"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};

// node_modules/@actions/core/lib/utils.js
var require_utils = __commonJS({
  "node_modules/@actions/core/lib/utils.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.toCommandProperties = exports.toCommandValue = void 0;
    function toCommandValue(input) {
      if (input === null || input === void 0) {
        return "";
      } else if (typeof input === "string" || input instanceof String) {
        return input;
      }
      return JSON.stringify(input);
    }
    exports.toCommandValue = toCommandValue;
    function toCommandProperties(annotationProperties) {
      if (!Object.keys(annotationProperties).length) {
        return {};
      }
      return {
        title: annotationProperties.title,
        file: annotationProperties.file,
        line: annotationProperties.startLine,
        endLine: annotationProperties.endLine,
        col: annotationProperties.startColumn,
        endColumn: annotationProperties.endColumn
      };
    }
    exports.toCommandProperties = toCommandProperties;
  }
});

// node_modules/@actions/core/lib/command.js
var require_command = __commonJS({
  "node_modules/@actions/core/lib/command.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.issue = exports.issueCommand = void 0;
    var os = __importStar(require("os"));
    var utils_1 = require_utils();
    function issueCommand(command, properties, message) {
      const cmd = new Command(command, properties, message);
      process.stdout.write(cmd.toString() + os.EOL);
    }
    exports.issueCommand = issueCommand;
    function issue(name, message = "") {
      issueCommand(name, {}, message);
    }
    exports.issue = issue;
    var CMD_STRING = "::";
    var Command = class {
      constructor(command, properties, message) {
        if (!command) {
          command = "missing.command";
        }
        this.command = command;
        this.properties = properties;
        this.message = message;
      }
      toString() {
        let cmdStr = CMD_STRING + this.command;
        if (this.properties && Object.keys(this.properties).length > 0) {
          cmdStr += " ";
          let first = true;
          for (const key in this.properties) {
            if (this.properties.hasOwnProperty(key)) {
              const val = this.properties[key];
              if (val) {
                if (first) {
                  first = false;
                } else {
                  cmdStr += ",";
                }
                cmdStr += `${key}=${escapeProperty(val)}`;
              }
            }
          }
        }
        cmdStr += `${CMD_STRING}${escapeData(this.message)}`;
        return cmdStr;
      }
    };
    function escapeData(s2) {
      return utils_1.toCommandValue(s2).replace(/%/g, "%25").replace(/\r/g, "%0D").replace(/\n/g, "%0A");
    }
    function escapeProperty(s2) {
      return utils_1.toCommandValue(s2).replace(/%/g, "%25").replace(/\r/g, "%0D").replace(/\n/g, "%0A").replace(/:/g, "%3A").replace(/,/g, "%2C");
    }
  }
});

// node_modules/@actions/core/lib/file-command.js
var require_file_command = __commonJS({
  "node_modules/@actions/core/lib/file-command.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.issueCommand = void 0;
    var fs4 = __importStar(require("fs"));
    var os = __importStar(require("os"));
    var utils_1 = require_utils();
    function issueCommand(command, message) {
      const filePath = process.env[`GITHUB_${command}`];
      if (!filePath) {
        throw new Error(`Unable to find environment variable for file command ${command}`);
      }
      if (!fs4.existsSync(filePath)) {
        throw new Error(`Missing file at path: ${filePath}`);
      }
      fs4.appendFileSync(filePath, `${utils_1.toCommandValue(message)}${os.EOL}`, {
        encoding: "utf8"
      });
    }
    exports.issueCommand = issueCommand;
  }
});

// node_modules/@actions/http-client/lib/proxy.js
var require_proxy = __commonJS({
  "node_modules/@actions/http-client/lib/proxy.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.checkBypass = exports.getProxyUrl = void 0;
    function getProxyUrl(reqUrl) {
      const usingSsl = reqUrl.protocol === "https:";
      if (checkBypass(reqUrl)) {
        return void 0;
      }
      const proxyVar = (() => {
        if (usingSsl) {
          return process.env["https_proxy"] || process.env["HTTPS_PROXY"];
        } else {
          return process.env["http_proxy"] || process.env["HTTP_PROXY"];
        }
      })();
      if (proxyVar) {
        return new URL(proxyVar);
      } else {
        return void 0;
      }
    }
    exports.getProxyUrl = getProxyUrl;
    function checkBypass(reqUrl) {
      if (!reqUrl.hostname) {
        return false;
      }
      const noProxy = process.env["no_proxy"] || process.env["NO_PROXY"] || "";
      if (!noProxy) {
        return false;
      }
      let reqPort;
      if (reqUrl.port) {
        reqPort = Number(reqUrl.port);
      } else if (reqUrl.protocol === "http:") {
        reqPort = 80;
      } else if (reqUrl.protocol === "https:") {
        reqPort = 443;
      }
      const upperReqHosts = [reqUrl.hostname.toUpperCase()];
      if (typeof reqPort === "number") {
        upperReqHosts.push(`${upperReqHosts[0]}:${reqPort}`);
      }
      for (const upperNoProxyItem of noProxy.split(",").map((x2) => x2.trim().toUpperCase()).filter((x2) => x2)) {
        if (upperReqHosts.some((x2) => x2 === upperNoProxyItem)) {
          return true;
        }
      }
      return false;
    }
    exports.checkBypass = checkBypass;
  }
});

// node_modules/tunnel/lib/tunnel.js
var require_tunnel = __commonJS({
  "node_modules/tunnel/lib/tunnel.js"(exports) {
    "use strict";
    var net = require("net");
    var tls = require("tls");
    var http4 = require("http");
    var https3 = require("https");
    var events = require("events");
    var assert = require("assert");
    var util2 = require("util");
    exports.httpOverHttp = httpOverHttp;
    exports.httpsOverHttp = httpsOverHttp;
    exports.httpOverHttps = httpOverHttps;
    exports.httpsOverHttps = httpsOverHttps;
    function httpOverHttp(options) {
      var agent = new TunnelingAgent(options);
      agent.request = http4.request;
      return agent;
    }
    function httpsOverHttp(options) {
      var agent = new TunnelingAgent(options);
      agent.request = http4.request;
      agent.createSocket = createSecureSocket;
      agent.defaultPort = 443;
      return agent;
    }
    function httpOverHttps(options) {
      var agent = new TunnelingAgent(options);
      agent.request = https3.request;
      return agent;
    }
    function httpsOverHttps(options) {
      var agent = new TunnelingAgent(options);
      agent.request = https3.request;
      agent.createSocket = createSecureSocket;
      agent.defaultPort = 443;
      return agent;
    }
    function TunnelingAgent(options) {
      var self2 = this;
      self2.options = options || {};
      self2.proxyOptions = self2.options.proxy || {};
      self2.maxSockets = self2.options.maxSockets || http4.Agent.defaultMaxSockets;
      self2.requests = [];
      self2.sockets = [];
      self2.on("free", function onFree(socket, host, port, localAddress) {
        var options2 = toOptions(host, port, localAddress);
        for (var i2 = 0, len = self2.requests.length; i2 < len; ++i2) {
          var pending = self2.requests[i2];
          if (pending.host === options2.host && pending.port === options2.port) {
            self2.requests.splice(i2, 1);
            pending.request.onSocket(socket);
            return;
          }
        }
        socket.destroy();
        self2.removeSocket(socket);
      });
    }
    util2.inherits(TunnelingAgent, events.EventEmitter);
    TunnelingAgent.prototype.addRequest = function addRequest(req, host, port, localAddress) {
      var self2 = this;
      var options = mergeOptions({ request: req }, self2.options, toOptions(host, port, localAddress));
      if (self2.sockets.length >= this.maxSockets) {
        self2.requests.push(options);
        return;
      }
      self2.createSocket(options, function(socket) {
        socket.on("free", onFree);
        socket.on("close", onCloseOrRemove);
        socket.on("agentRemove", onCloseOrRemove);
        req.onSocket(socket);
        function onFree() {
          self2.emit("free", socket, options);
        }
        function onCloseOrRemove(err) {
          self2.removeSocket(socket);
          socket.removeListener("free", onFree);
          socket.removeListener("close", onCloseOrRemove);
          socket.removeListener("agentRemove", onCloseOrRemove);
        }
      });
    };
    TunnelingAgent.prototype.createSocket = function createSocket(options, cb) {
      var self2 = this;
      var placeholder = {};
      self2.sockets.push(placeholder);
      var connectOptions = mergeOptions({}, self2.proxyOptions, {
        method: "CONNECT",
        path: options.host + ":" + options.port,
        agent: false,
        headers: {
          host: options.host + ":" + options.port
        }
      });
      if (options.localAddress) {
        connectOptions.localAddress = options.localAddress;
      }
      if (connectOptions.proxyAuth) {
        connectOptions.headers = connectOptions.headers || {};
        connectOptions.headers["Proxy-Authorization"] = "Basic " + new Buffer(connectOptions.proxyAuth).toString("base64");
      }
      debug("making CONNECT request");
      var connectReq = self2.request(connectOptions);
      connectReq.useChunkedEncodingByDefault = false;
      connectReq.once("response", onResponse);
      connectReq.once("upgrade", onUpgrade);
      connectReq.once("connect", onConnect);
      connectReq.once("error", onError);
      connectReq.end();
      function onResponse(res) {
        res.upgrade = true;
      }
      function onUpgrade(res, socket, head) {
        process.nextTick(function() {
          onConnect(res, socket, head);
        });
      }
      function onConnect(res, socket, head) {
        connectReq.removeAllListeners();
        socket.removeAllListeners();
        if (res.statusCode !== 200) {
          debug(
            "tunneling socket could not be established, statusCode=%d",
            res.statusCode
          );
          socket.destroy();
          var error = new Error("tunneling socket could not be established, statusCode=" + res.statusCode);
          error.code = "ECONNRESET";
          options.request.emit("error", error);
          self2.removeSocket(placeholder);
          return;
        }
        if (head.length > 0) {
          debug("got illegal response body from proxy");
          socket.destroy();
          var error = new Error("got illegal response body from proxy");
          error.code = "ECONNRESET";
          options.request.emit("error", error);
          self2.removeSocket(placeholder);
          return;
        }
        debug("tunneling connection has established");
        self2.sockets[self2.sockets.indexOf(placeholder)] = socket;
        return cb(socket);
      }
      function onError(cause) {
        connectReq.removeAllListeners();
        debug(
          "tunneling socket could not be established, cause=%s\n",
          cause.message,
          cause.stack
        );
        var error = new Error("tunneling socket could not be established, cause=" + cause.message);
        error.code = "ECONNRESET";
        options.request.emit("error", error);
        self2.removeSocket(placeholder);
      }
    };
    TunnelingAgent.prototype.removeSocket = function removeSocket(socket) {
      var pos = this.sockets.indexOf(socket);
      if (pos === -1) {
        return;
      }
      this.sockets.splice(pos, 1);
      var pending = this.requests.shift();
      if (pending) {
        this.createSocket(pending, function(socket2) {
          pending.request.onSocket(socket2);
        });
      }
    };
    function createSecureSocket(options, cb) {
      var self2 = this;
      TunnelingAgent.prototype.createSocket.call(self2, options, function(socket) {
        var hostHeader = options.request.getHeader("host");
        var tlsOptions = mergeOptions({}, self2.options, {
          socket,
          servername: hostHeader ? hostHeader.replace(/:.*$/, "") : options.host
        });
        var secureSocket = tls.connect(0, tlsOptions);
        self2.sockets[self2.sockets.indexOf(socket)] = secureSocket;
        cb(secureSocket);
      });
    }
    function toOptions(host, port, localAddress) {
      if (typeof host === "string") {
        return {
          host,
          port,
          localAddress
        };
      }
      return host;
    }
    function mergeOptions(target) {
      for (var i2 = 1, len = arguments.length; i2 < len; ++i2) {
        var overrides = arguments[i2];
        if (typeof overrides === "object") {
          var keys = Object.keys(overrides);
          for (var j = 0, keyLen = keys.length; j < keyLen; ++j) {
            var k = keys[j];
            if (overrides[k] !== void 0) {
              target[k] = overrides[k];
            }
          }
        }
      }
      return target;
    }
    var debug;
    if (process.env.NODE_DEBUG && /\btunnel\b/.test(process.env.NODE_DEBUG)) {
      debug = function() {
        var args = Array.prototype.slice.call(arguments);
        if (typeof args[0] === "string") {
          args[0] = "TUNNEL: " + args[0];
        } else {
          args.unshift("TUNNEL:");
        }
        console.error.apply(console, args);
      };
    } else {
      debug = function() {
      };
    }
    exports.debug = debug;
  }
});

// node_modules/tunnel/index.js
var require_tunnel2 = __commonJS({
  "node_modules/tunnel/index.js"(exports, module2) {
    module2.exports = require_tunnel();
  }
});

// node_modules/@actions/http-client/lib/index.js
var require_lib = __commonJS({
  "node_modules/@actions/http-client/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.HttpClient = exports.isHttps = exports.HttpClientResponse = exports.HttpClientError = exports.getProxyUrl = exports.MediaTypes = exports.Headers = exports.HttpCodes = void 0;
    var http4 = __importStar(require("http"));
    var https3 = __importStar(require("https"));
    var pm = __importStar(require_proxy());
    var tunnel = __importStar(require_tunnel2());
    var HttpCodes;
    (function(HttpCodes2) {
      HttpCodes2[HttpCodes2["OK"] = 200] = "OK";
      HttpCodes2[HttpCodes2["MultipleChoices"] = 300] = "MultipleChoices";
      HttpCodes2[HttpCodes2["MovedPermanently"] = 301] = "MovedPermanently";
      HttpCodes2[HttpCodes2["ResourceMoved"] = 302] = "ResourceMoved";
      HttpCodes2[HttpCodes2["SeeOther"] = 303] = "SeeOther";
      HttpCodes2[HttpCodes2["NotModified"] = 304] = "NotModified";
      HttpCodes2[HttpCodes2["UseProxy"] = 305] = "UseProxy";
      HttpCodes2[HttpCodes2["SwitchProxy"] = 306] = "SwitchProxy";
      HttpCodes2[HttpCodes2["TemporaryRedirect"] = 307] = "TemporaryRedirect";
      HttpCodes2[HttpCodes2["PermanentRedirect"] = 308] = "PermanentRedirect";
      HttpCodes2[HttpCodes2["BadRequest"] = 400] = "BadRequest";
      HttpCodes2[HttpCodes2["Unauthorized"] = 401] = "Unauthorized";
      HttpCodes2[HttpCodes2["PaymentRequired"] = 402] = "PaymentRequired";
      HttpCodes2[HttpCodes2["Forbidden"] = 403] = "Forbidden";
      HttpCodes2[HttpCodes2["NotFound"] = 404] = "NotFound";
      HttpCodes2[HttpCodes2["MethodNotAllowed"] = 405] = "MethodNotAllowed";
      HttpCodes2[HttpCodes2["NotAcceptable"] = 406] = "NotAcceptable";
      HttpCodes2[HttpCodes2["ProxyAuthenticationRequired"] = 407] = "ProxyAuthenticationRequired";
      HttpCodes2[HttpCodes2["RequestTimeout"] = 408] = "RequestTimeout";
      HttpCodes2[HttpCodes2["Conflict"] = 409] = "Conflict";
      HttpCodes2[HttpCodes2["Gone"] = 410] = "Gone";
      HttpCodes2[HttpCodes2["TooManyRequests"] = 429] = "TooManyRequests";
      HttpCodes2[HttpCodes2["InternalServerError"] = 500] = "InternalServerError";
      HttpCodes2[HttpCodes2["NotImplemented"] = 501] = "NotImplemented";
      HttpCodes2[HttpCodes2["BadGateway"] = 502] = "BadGateway";
      HttpCodes2[HttpCodes2["ServiceUnavailable"] = 503] = "ServiceUnavailable";
      HttpCodes2[HttpCodes2["GatewayTimeout"] = 504] = "GatewayTimeout";
    })(HttpCodes = exports.HttpCodes || (exports.HttpCodes = {}));
    var Headers3;
    (function(Headers4) {
      Headers4["Accept"] = "accept";
      Headers4["ContentType"] = "content-type";
    })(Headers3 = exports.Headers || (exports.Headers = {}));
    var MediaTypes;
    (function(MediaTypes2) {
      MediaTypes2["ApplicationJson"] = "application/json";
    })(MediaTypes = exports.MediaTypes || (exports.MediaTypes = {}));
    function getProxyUrl(serverUrl) {
      const proxyUrl = pm.getProxyUrl(new URL(serverUrl));
      return proxyUrl ? proxyUrl.href : "";
    }
    exports.getProxyUrl = getProxyUrl;
    var HttpRedirectCodes = [
      HttpCodes.MovedPermanently,
      HttpCodes.ResourceMoved,
      HttpCodes.SeeOther,
      HttpCodes.TemporaryRedirect,
      HttpCodes.PermanentRedirect
    ];
    var HttpResponseRetryCodes = [
      HttpCodes.BadGateway,
      HttpCodes.ServiceUnavailable,
      HttpCodes.GatewayTimeout
    ];
    var RetryableHttpVerbs = ["OPTIONS", "GET", "DELETE", "HEAD"];
    var ExponentialBackoffCeiling = 10;
    var ExponentialBackoffTimeSlice = 5;
    var HttpClientError = class extends Error {
      constructor(message, statusCode) {
        super(message);
        this.name = "HttpClientError";
        this.statusCode = statusCode;
        Object.setPrototypeOf(this, HttpClientError.prototype);
      }
    };
    exports.HttpClientError = HttpClientError;
    var HttpClientResponse = class {
      constructor(message) {
        this.message = message;
      }
      readBody() {
        return __awaiter(this, void 0, void 0, function* () {
          return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            let output = Buffer.alloc(0);
            this.message.on("data", (chunk) => {
              output = Buffer.concat([output, chunk]);
            });
            this.message.on("end", () => {
              resolve(output.toString());
            });
          }));
        });
      }
    };
    exports.HttpClientResponse = HttpClientResponse;
    function isHttps(requestUrl) {
      const parsedUrl = new URL(requestUrl);
      return parsedUrl.protocol === "https:";
    }
    exports.isHttps = isHttps;
    var HttpClient = class {
      constructor(userAgent2, handlers, requestOptions) {
        this._ignoreSslError = false;
        this._allowRedirects = true;
        this._allowRedirectDowngrade = false;
        this._maxRedirects = 50;
        this._allowRetries = false;
        this._maxRetries = 1;
        this._keepAlive = false;
        this._disposed = false;
        this.userAgent = userAgent2;
        this.handlers = handlers || [];
        this.requestOptions = requestOptions;
        if (requestOptions) {
          if (requestOptions.ignoreSslError != null) {
            this._ignoreSslError = requestOptions.ignoreSslError;
          }
          this._socketTimeout = requestOptions.socketTimeout;
          if (requestOptions.allowRedirects != null) {
            this._allowRedirects = requestOptions.allowRedirects;
          }
          if (requestOptions.allowRedirectDowngrade != null) {
            this._allowRedirectDowngrade = requestOptions.allowRedirectDowngrade;
          }
          if (requestOptions.maxRedirects != null) {
            this._maxRedirects = Math.max(requestOptions.maxRedirects, 0);
          }
          if (requestOptions.keepAlive != null) {
            this._keepAlive = requestOptions.keepAlive;
          }
          if (requestOptions.allowRetries != null) {
            this._allowRetries = requestOptions.allowRetries;
          }
          if (requestOptions.maxRetries != null) {
            this._maxRetries = requestOptions.maxRetries;
          }
        }
      }
      options(requestUrl, additionalHeaders) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.request("OPTIONS", requestUrl, null, additionalHeaders || {});
        });
      }
      get(requestUrl, additionalHeaders) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.request("GET", requestUrl, null, additionalHeaders || {});
        });
      }
      del(requestUrl, additionalHeaders) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.request("DELETE", requestUrl, null, additionalHeaders || {});
        });
      }
      post(requestUrl, data, additionalHeaders) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.request("POST", requestUrl, data, additionalHeaders || {});
        });
      }
      patch(requestUrl, data, additionalHeaders) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.request("PATCH", requestUrl, data, additionalHeaders || {});
        });
      }
      put(requestUrl, data, additionalHeaders) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.request("PUT", requestUrl, data, additionalHeaders || {});
        });
      }
      head(requestUrl, additionalHeaders) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.request("HEAD", requestUrl, null, additionalHeaders || {});
        });
      }
      sendStream(verb, requestUrl, stream, additionalHeaders) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.request(verb, requestUrl, stream, additionalHeaders);
        });
      }
      getJson(requestUrl, additionalHeaders = {}) {
        return __awaiter(this, void 0, void 0, function* () {
          additionalHeaders[Headers3.Accept] = this._getExistingOrDefaultHeader(additionalHeaders, Headers3.Accept, MediaTypes.ApplicationJson);
          const res = yield this.get(requestUrl, additionalHeaders);
          return this._processResponse(res, this.requestOptions);
        });
      }
      postJson(requestUrl, obj, additionalHeaders = {}) {
        return __awaiter(this, void 0, void 0, function* () {
          const data = JSON.stringify(obj, null, 2);
          additionalHeaders[Headers3.Accept] = this._getExistingOrDefaultHeader(additionalHeaders, Headers3.Accept, MediaTypes.ApplicationJson);
          additionalHeaders[Headers3.ContentType] = this._getExistingOrDefaultHeader(additionalHeaders, Headers3.ContentType, MediaTypes.ApplicationJson);
          const res = yield this.post(requestUrl, data, additionalHeaders);
          return this._processResponse(res, this.requestOptions);
        });
      }
      putJson(requestUrl, obj, additionalHeaders = {}) {
        return __awaiter(this, void 0, void 0, function* () {
          const data = JSON.stringify(obj, null, 2);
          additionalHeaders[Headers3.Accept] = this._getExistingOrDefaultHeader(additionalHeaders, Headers3.Accept, MediaTypes.ApplicationJson);
          additionalHeaders[Headers3.ContentType] = this._getExistingOrDefaultHeader(additionalHeaders, Headers3.ContentType, MediaTypes.ApplicationJson);
          const res = yield this.put(requestUrl, data, additionalHeaders);
          return this._processResponse(res, this.requestOptions);
        });
      }
      patchJson(requestUrl, obj, additionalHeaders = {}) {
        return __awaiter(this, void 0, void 0, function* () {
          const data = JSON.stringify(obj, null, 2);
          additionalHeaders[Headers3.Accept] = this._getExistingOrDefaultHeader(additionalHeaders, Headers3.Accept, MediaTypes.ApplicationJson);
          additionalHeaders[Headers3.ContentType] = this._getExistingOrDefaultHeader(additionalHeaders, Headers3.ContentType, MediaTypes.ApplicationJson);
          const res = yield this.patch(requestUrl, data, additionalHeaders);
          return this._processResponse(res, this.requestOptions);
        });
      }
      request(verb, requestUrl, data, headers) {
        return __awaiter(this, void 0, void 0, function* () {
          if (this._disposed) {
            throw new Error("Client has already been disposed.");
          }
          const parsedUrl = new URL(requestUrl);
          let info = this._prepareRequest(verb, parsedUrl, headers);
          const maxTries = this._allowRetries && RetryableHttpVerbs.includes(verb) ? this._maxRetries + 1 : 1;
          let numTries = 0;
          let response;
          do {
            response = yield this.requestRaw(info, data);
            if (response && response.message && response.message.statusCode === HttpCodes.Unauthorized) {
              let authenticationHandler;
              for (const handler of this.handlers) {
                if (handler.canHandleAuthentication(response)) {
                  authenticationHandler = handler;
                  break;
                }
              }
              if (authenticationHandler) {
                return authenticationHandler.handleAuthentication(this, info, data);
              } else {
                return response;
              }
            }
            let redirectsRemaining = this._maxRedirects;
            while (response.message.statusCode && HttpRedirectCodes.includes(response.message.statusCode) && this._allowRedirects && redirectsRemaining > 0) {
              const redirectUrl = response.message.headers["location"];
              if (!redirectUrl) {
                break;
              }
              const parsedRedirectUrl = new URL(redirectUrl);
              if (parsedUrl.protocol === "https:" && parsedUrl.protocol !== parsedRedirectUrl.protocol && !this._allowRedirectDowngrade) {
                throw new Error("Redirect from HTTPS to HTTP protocol. This downgrade is not allowed for security reasons. If you want to allow this behavior, set the allowRedirectDowngrade option to true.");
              }
              yield response.readBody();
              if (parsedRedirectUrl.hostname !== parsedUrl.hostname) {
                for (const header in headers) {
                  if (header.toLowerCase() === "authorization") {
                    delete headers[header];
                  }
                }
              }
              info = this._prepareRequest(verb, parsedRedirectUrl, headers);
              response = yield this.requestRaw(info, data);
              redirectsRemaining--;
            }
            if (!response.message.statusCode || !HttpResponseRetryCodes.includes(response.message.statusCode)) {
              return response;
            }
            numTries += 1;
            if (numTries < maxTries) {
              yield response.readBody();
              yield this._performExponentialBackoff(numTries);
            }
          } while (numTries < maxTries);
          return response;
        });
      }
      dispose() {
        if (this._agent) {
          this._agent.destroy();
        }
        this._disposed = true;
      }
      requestRaw(info, data) {
        return __awaiter(this, void 0, void 0, function* () {
          return new Promise((resolve, reject) => {
            function callbackForResult(err, res) {
              if (err) {
                reject(err);
              } else if (!res) {
                reject(new Error("Unknown error"));
              } else {
                resolve(res);
              }
            }
            this.requestRawWithCallback(info, data, callbackForResult);
          });
        });
      }
      requestRawWithCallback(info, data, onResult) {
        if (typeof data === "string") {
          if (!info.options.headers) {
            info.options.headers = {};
          }
          info.options.headers["Content-Length"] = Buffer.byteLength(data, "utf8");
        }
        let callbackCalled = false;
        function handleResult(err, res) {
          if (!callbackCalled) {
            callbackCalled = true;
            onResult(err, res);
          }
        }
        const req = info.httpModule.request(info.options, (msg) => {
          const res = new HttpClientResponse(msg);
          handleResult(void 0, res);
        });
        let socket;
        req.on("socket", (sock) => {
          socket = sock;
        });
        req.setTimeout(this._socketTimeout || 3 * 6e4, () => {
          if (socket) {
            socket.end();
          }
          handleResult(new Error(`Request timeout: ${info.options.path}`));
        });
        req.on("error", function(err) {
          handleResult(err);
        });
        if (data && typeof data === "string") {
          req.write(data, "utf8");
        }
        if (data && typeof data !== "string") {
          data.on("close", function() {
            req.end();
          });
          data.pipe(req);
        } else {
          req.end();
        }
      }
      getAgent(serverUrl) {
        const parsedUrl = new URL(serverUrl);
        return this._getAgent(parsedUrl);
      }
      _prepareRequest(method, requestUrl, headers) {
        const info = {};
        info.parsedUrl = requestUrl;
        const usingSsl = info.parsedUrl.protocol === "https:";
        info.httpModule = usingSsl ? https3 : http4;
        const defaultPort = usingSsl ? 443 : 80;
        info.options = {};
        info.options.host = info.parsedUrl.hostname;
        info.options.port = info.parsedUrl.port ? parseInt(info.parsedUrl.port) : defaultPort;
        info.options.path = (info.parsedUrl.pathname || "") + (info.parsedUrl.search || "");
        info.options.method = method;
        info.options.headers = this._mergeHeaders(headers);
        if (this.userAgent != null) {
          info.options.headers["user-agent"] = this.userAgent;
        }
        info.options.agent = this._getAgent(info.parsedUrl);
        if (this.handlers) {
          for (const handler of this.handlers) {
            handler.prepareRequest(info.options);
          }
        }
        return info;
      }
      _mergeHeaders(headers) {
        if (this.requestOptions && this.requestOptions.headers) {
          return Object.assign({}, lowercaseKeys2(this.requestOptions.headers), lowercaseKeys2(headers || {}));
        }
        return lowercaseKeys2(headers || {});
      }
      _getExistingOrDefaultHeader(additionalHeaders, header, _default) {
        let clientHeader;
        if (this.requestOptions && this.requestOptions.headers) {
          clientHeader = lowercaseKeys2(this.requestOptions.headers)[header];
        }
        return additionalHeaders[header] || clientHeader || _default;
      }
      _getAgent(parsedUrl) {
        let agent;
        const proxyUrl = pm.getProxyUrl(parsedUrl);
        const useProxy = proxyUrl && proxyUrl.hostname;
        if (this._keepAlive && useProxy) {
          agent = this._proxyAgent;
        }
        if (this._keepAlive && !useProxy) {
          agent = this._agent;
        }
        if (agent) {
          return agent;
        }
        const usingSsl = parsedUrl.protocol === "https:";
        let maxSockets = 100;
        if (this.requestOptions) {
          maxSockets = this.requestOptions.maxSockets || http4.globalAgent.maxSockets;
        }
        if (proxyUrl && proxyUrl.hostname) {
          const agentOptions = {
            maxSockets,
            keepAlive: this._keepAlive,
            proxy: Object.assign(Object.assign({}, (proxyUrl.username || proxyUrl.password) && {
              proxyAuth: `${proxyUrl.username}:${proxyUrl.password}`
            }), { host: proxyUrl.hostname, port: proxyUrl.port })
          };
          let tunnelAgent;
          const overHttps = proxyUrl.protocol === "https:";
          if (usingSsl) {
            tunnelAgent = overHttps ? tunnel.httpsOverHttps : tunnel.httpsOverHttp;
          } else {
            tunnelAgent = overHttps ? tunnel.httpOverHttps : tunnel.httpOverHttp;
          }
          agent = tunnelAgent(agentOptions);
          this._proxyAgent = agent;
        }
        if (this._keepAlive && !agent) {
          const options = { keepAlive: this._keepAlive, maxSockets };
          agent = usingSsl ? new https3.Agent(options) : new http4.Agent(options);
          this._agent = agent;
        }
        if (!agent) {
          agent = usingSsl ? https3.globalAgent : http4.globalAgent;
        }
        if (usingSsl && this._ignoreSslError) {
          agent.options = Object.assign(agent.options || {}, {
            rejectUnauthorized: false
          });
        }
        return agent;
      }
      _performExponentialBackoff(retryNumber) {
        return __awaiter(this, void 0, void 0, function* () {
          retryNumber = Math.min(ExponentialBackoffCeiling, retryNumber);
          const ms = ExponentialBackoffTimeSlice * Math.pow(2, retryNumber);
          return new Promise((resolve) => setTimeout(() => resolve(), ms));
        });
      }
      _processResponse(res, options) {
        return __awaiter(this, void 0, void 0, function* () {
          return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            const statusCode = res.message.statusCode || 0;
            const response = {
              statusCode,
              result: null,
              headers: {}
            };
            if (statusCode === HttpCodes.NotFound) {
              resolve(response);
            }
            function dateTimeDeserializer(key, value) {
              if (typeof value === "string") {
                const a = new Date(value);
                if (!isNaN(a.valueOf())) {
                  return a;
                }
              }
              return value;
            }
            let obj;
            let contents;
            try {
              contents = yield res.readBody();
              if (contents && contents.length > 0) {
                if (options && options.deserializeDates) {
                  obj = JSON.parse(contents, dateTimeDeserializer);
                } else {
                  obj = JSON.parse(contents);
                }
                response.result = obj;
              }
              response.headers = res.message.headers;
            } catch (err) {
            }
            if (statusCode > 299) {
              let msg;
              if (obj && obj.message) {
                msg = obj.message;
              } else if (contents && contents.length > 0) {
                msg = contents;
              } else {
                msg = `Failed request: (${statusCode})`;
              }
              const err = new HttpClientError(msg, statusCode);
              err.result = response.result;
              reject(err);
            } else {
              resolve(response);
            }
          }));
        });
      }
    };
    exports.HttpClient = HttpClient;
    var lowercaseKeys2 = (obj) => Object.keys(obj).reduce((c, k) => (c[k.toLowerCase()] = obj[k], c), {});
  }
});

// node_modules/@actions/http-client/lib/auth.js
var require_auth = __commonJS({
  "node_modules/@actions/http-client/lib/auth.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PersonalAccessTokenCredentialHandler = exports.BearerCredentialHandler = exports.BasicCredentialHandler = void 0;
    var BasicCredentialHandler = class {
      constructor(username, password) {
        this.username = username;
        this.password = password;
      }
      prepareRequest(options) {
        if (!options.headers) {
          throw Error("The request has no headers");
        }
        options.headers["Authorization"] = `Basic ${Buffer.from(`${this.username}:${this.password}`).toString("base64")}`;
      }
      canHandleAuthentication() {
        return false;
      }
      handleAuthentication() {
        return __awaiter(this, void 0, void 0, function* () {
          throw new Error("not implemented");
        });
      }
    };
    exports.BasicCredentialHandler = BasicCredentialHandler;
    var BearerCredentialHandler = class {
      constructor(token) {
        this.token = token;
      }
      prepareRequest(options) {
        if (!options.headers) {
          throw Error("The request has no headers");
        }
        options.headers["Authorization"] = `Bearer ${this.token}`;
      }
      canHandleAuthentication() {
        return false;
      }
      handleAuthentication() {
        return __awaiter(this, void 0, void 0, function* () {
          throw new Error("not implemented");
        });
      }
    };
    exports.BearerCredentialHandler = BearerCredentialHandler;
    var PersonalAccessTokenCredentialHandler = class {
      constructor(token) {
        this.token = token;
      }
      prepareRequest(options) {
        if (!options.headers) {
          throw Error("The request has no headers");
        }
        options.headers["Authorization"] = `Basic ${Buffer.from(`PAT:${this.token}`).toString("base64")}`;
      }
      canHandleAuthentication() {
        return false;
      }
      handleAuthentication() {
        return __awaiter(this, void 0, void 0, function* () {
          throw new Error("not implemented");
        });
      }
    };
    exports.PersonalAccessTokenCredentialHandler = PersonalAccessTokenCredentialHandler;
  }
});

// node_modules/@actions/core/lib/oidc-utils.js
var require_oidc_utils = __commonJS({
  "node_modules/@actions/core/lib/oidc-utils.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.OidcClient = void 0;
    var http_client_1 = require_lib();
    var auth_1 = require_auth();
    var core_1 = require_core();
    var OidcClient = class {
      static createHttpClient(allowRetry = true, maxRetry = 10) {
        const requestOptions = {
          allowRetries: allowRetry,
          maxRetries: maxRetry
        };
        return new http_client_1.HttpClient("actions/oidc-client", [new auth_1.BearerCredentialHandler(OidcClient.getRequestToken())], requestOptions);
      }
      static getRequestToken() {
        const token = process.env["ACTIONS_ID_TOKEN_REQUEST_TOKEN"];
        if (!token) {
          throw new Error("Unable to get ACTIONS_ID_TOKEN_REQUEST_TOKEN env variable");
        }
        return token;
      }
      static getIDTokenUrl() {
        const runtimeUrl = process.env["ACTIONS_ID_TOKEN_REQUEST_URL"];
        if (!runtimeUrl) {
          throw new Error("Unable to get ACTIONS_ID_TOKEN_REQUEST_URL env variable");
        }
        return runtimeUrl;
      }
      static getCall(id_token_url) {
        var _a4;
        return __awaiter(this, void 0, void 0, function* () {
          const httpclient = OidcClient.createHttpClient();
          const res = yield httpclient.getJson(id_token_url).catch((error) => {
            throw new Error(`Failed to get ID Token. 
 
        Error Code : ${error.statusCode}
 
        Error Message: ${error.result.message}`);
          });
          const id_token = (_a4 = res.result) === null || _a4 === void 0 ? void 0 : _a4.value;
          if (!id_token) {
            throw new Error("Response json body do not have ID Token field");
          }
          return id_token;
        });
      }
      static getIDToken(audience) {
        return __awaiter(this, void 0, void 0, function* () {
          try {
            let id_token_url = OidcClient.getIDTokenUrl();
            if (audience) {
              const encodedAudience = encodeURIComponent(audience);
              id_token_url = `${id_token_url}&audience=${encodedAudience}`;
            }
            core_1.debug(`ID token url is ${id_token_url}`);
            const id_token = yield OidcClient.getCall(id_token_url);
            core_1.setSecret(id_token);
            return id_token;
          } catch (error) {
            throw new Error(`Error message: ${error.message}`);
          }
        });
      }
    };
    exports.OidcClient = OidcClient;
  }
});

// node_modules/@actions/core/lib/summary.js
var require_summary = __commonJS({
  "node_modules/@actions/core/lib/summary.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.summary = exports.markdownSummary = exports.SUMMARY_DOCS_URL = exports.SUMMARY_ENV_VAR = void 0;
    var os_1 = require("os");
    var fs_1 = require("fs");
    var { access, appendFile, writeFile: writeFile2 } = fs_1.promises;
    exports.SUMMARY_ENV_VAR = "GITHUB_STEP_SUMMARY";
    exports.SUMMARY_DOCS_URL = "https://docs.github.com/actions/using-workflows/workflow-commands-for-github-actions#adding-a-job-summary";
    var Summary = class {
      constructor() {
        this._buffer = "";
      }
      filePath() {
        return __awaiter(this, void 0, void 0, function* () {
          if (this._filePath) {
            return this._filePath;
          }
          const pathFromEnv = process.env[exports.SUMMARY_ENV_VAR];
          if (!pathFromEnv) {
            throw new Error(`Unable to find environment variable for $${exports.SUMMARY_ENV_VAR}. Check if your runtime environment supports job summaries.`);
          }
          try {
            yield access(pathFromEnv, fs_1.constants.R_OK | fs_1.constants.W_OK);
          } catch (_a4) {
            throw new Error(`Unable to access summary file: '${pathFromEnv}'. Check if the file has correct read/write permissions.`);
          }
          this._filePath = pathFromEnv;
          return this._filePath;
        });
      }
      wrap(tag, content, attrs = {}) {
        const htmlAttrs = Object.entries(attrs).map(([key, value]) => ` ${key}="${value}"`).join("");
        if (!content) {
          return `<${tag}${htmlAttrs}>`;
        }
        return `<${tag}${htmlAttrs}>${content}</${tag}>`;
      }
      write(options) {
        return __awaiter(this, void 0, void 0, function* () {
          const overwrite = !!(options === null || options === void 0 ? void 0 : options.overwrite);
          const filePath = yield this.filePath();
          const writeFunc = overwrite ? writeFile2 : appendFile;
          yield writeFunc(filePath, this._buffer, { encoding: "utf8" });
          return this.emptyBuffer();
        });
      }
      clear() {
        return __awaiter(this, void 0, void 0, function* () {
          return this.emptyBuffer().write({ overwrite: true });
        });
      }
      stringify() {
        return this._buffer;
      }
      isEmptyBuffer() {
        return this._buffer.length === 0;
      }
      emptyBuffer() {
        this._buffer = "";
        return this;
      }
      addRaw(text, addEOL = false) {
        this._buffer += text;
        return addEOL ? this.addEOL() : this;
      }
      addEOL() {
        return this.addRaw(os_1.EOL);
      }
      addCodeBlock(code, lang) {
        const attrs = Object.assign({}, lang && { lang });
        const element = this.wrap("pre", this.wrap("code", code), attrs);
        return this.addRaw(element).addEOL();
      }
      addList(items, ordered = false) {
        const tag = ordered ? "ol" : "ul";
        const listItems = items.map((item) => this.wrap("li", item)).join("");
        const element = this.wrap(tag, listItems);
        return this.addRaw(element).addEOL();
      }
      addTable(rows) {
        const tableBody = rows.map((row) => {
          const cells = row.map((cell) => {
            if (typeof cell === "string") {
              return this.wrap("td", cell);
            }
            const { header, data, colspan, rowspan } = cell;
            const tag = header ? "th" : "td";
            const attrs = Object.assign(Object.assign({}, colspan && { colspan }), rowspan && { rowspan });
            return this.wrap(tag, data, attrs);
          }).join("");
          return this.wrap("tr", cells);
        }).join("");
        const element = this.wrap("table", tableBody);
        return this.addRaw(element).addEOL();
      }
      addDetails(label, content) {
        const element = this.wrap("details", this.wrap("summary", label) + content);
        return this.addRaw(element).addEOL();
      }
      addImage(src, alt, options) {
        const { width, height } = options || {};
        const attrs = Object.assign(Object.assign({}, width && { width }), height && { height });
        const element = this.wrap("img", null, Object.assign({ src, alt }, attrs));
        return this.addRaw(element).addEOL();
      }
      addHeading(text, level) {
        const tag = `h${level}`;
        const allowedTag = ["h1", "h2", "h3", "h4", "h5", "h6"].includes(tag) ? tag : "h1";
        const element = this.wrap(allowedTag, text);
        return this.addRaw(element).addEOL();
      }
      addSeparator() {
        const element = this.wrap("hr", null);
        return this.addRaw(element).addEOL();
      }
      addBreak() {
        const element = this.wrap("br", null);
        return this.addRaw(element).addEOL();
      }
      addQuote(text, cite) {
        const attrs = Object.assign({}, cite && { cite });
        const element = this.wrap("blockquote", text, attrs);
        return this.addRaw(element).addEOL();
      }
      addLink(text, href) {
        const element = this.wrap("a", text, { href });
        return this.addRaw(element).addEOL();
      }
    };
    var _summary = new Summary();
    exports.markdownSummary = _summary;
    exports.summary = _summary;
  }
});

// node_modules/@actions/core/lib/path-utils.js
var require_path_utils = __commonJS({
  "node_modules/@actions/core/lib/path-utils.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.toPlatformPath = exports.toWin32Path = exports.toPosixPath = void 0;
    var path4 = __importStar(require("path"));
    function toPosixPath(pth) {
      return pth.replace(/[\\]/g, "/");
    }
    exports.toPosixPath = toPosixPath;
    function toWin32Path(pth) {
      return pth.replace(/[/]/g, "\\");
    }
    exports.toWin32Path = toWin32Path;
    function toPlatformPath(pth) {
      return pth.replace(/[/\\]/g, path4.sep);
    }
    exports.toPlatformPath = toPlatformPath;
  }
});

// node_modules/@actions/core/lib/core.js
var require_core = __commonJS({
  "node_modules/@actions/core/lib/core.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getIDToken = exports.getState = exports.saveState = exports.group = exports.endGroup = exports.startGroup = exports.info = exports.notice = exports.warning = exports.error = exports.debug = exports.isDebug = exports.setFailed = exports.setCommandEcho = exports.setOutput = exports.getBooleanInput = exports.getMultilineInput = exports.getInput = exports.addPath = exports.setSecret = exports.exportVariable = exports.ExitCode = void 0;
    var command_1 = require_command();
    var file_command_1 = require_file_command();
    var utils_1 = require_utils();
    var os = __importStar(require("os"));
    var path4 = __importStar(require("path"));
    var oidc_utils_1 = require_oidc_utils();
    var ExitCode;
    (function(ExitCode2) {
      ExitCode2[ExitCode2["Success"] = 0] = "Success";
      ExitCode2[ExitCode2["Failure"] = 1] = "Failure";
    })(ExitCode = exports.ExitCode || (exports.ExitCode = {}));
    function exportVariable(name, val) {
      const convertedVal = utils_1.toCommandValue(val);
      process.env[name] = convertedVal;
      const filePath = process.env["GITHUB_ENV"] || "";
      if (filePath) {
        const delimiter = "_GitHubActionsFileCommandDelimeter_";
        const commandValue = `${name}<<${delimiter}${os.EOL}${convertedVal}${os.EOL}${delimiter}`;
        file_command_1.issueCommand("ENV", commandValue);
      } else {
        command_1.issueCommand("set-env", { name }, convertedVal);
      }
    }
    exports.exportVariable = exportVariable;
    function setSecret(secret) {
      command_1.issueCommand("add-mask", {}, secret);
    }
    exports.setSecret = setSecret;
    function addPath(inputPath) {
      const filePath = process.env["GITHUB_PATH"] || "";
      if (filePath) {
        file_command_1.issueCommand("PATH", inputPath);
      } else {
        command_1.issueCommand("add-path", {}, inputPath);
      }
      process.env["PATH"] = `${inputPath}${path4.delimiter}${process.env["PATH"]}`;
    }
    exports.addPath = addPath;
    function getInput(name, options) {
      const val = process.env[`INPUT_${name.replace(/ /g, "_").toUpperCase()}`] || "";
      if (options && options.required && !val) {
        throw new Error(`Input required and not supplied: ${name}`);
      }
      if (options && options.trimWhitespace === false) {
        return val;
      }
      return val.trim();
    }
    exports.getInput = getInput;
    function getMultilineInput(name, options) {
      const inputs = getInput(name, options).split("\n").filter((x2) => x2 !== "");
      return inputs;
    }
    exports.getMultilineInput = getMultilineInput;
    function getBooleanInput(name, options) {
      const trueValue = ["true", "True", "TRUE"];
      const falseValue = ["false", "False", "FALSE"];
      const val = getInput(name, options);
      if (trueValue.includes(val))
        return true;
      if (falseValue.includes(val))
        return false;
      throw new TypeError(`Input does not meet YAML 1.2 "Core Schema" specification: ${name}
Support boolean input list: \`true | True | TRUE | false | False | FALSE\``);
    }
    exports.getBooleanInput = getBooleanInput;
    function setOutput(name, value) {
      process.stdout.write(os.EOL);
      command_1.issueCommand("set-output", { name }, value);
    }
    exports.setOutput = setOutput;
    function setCommandEcho(enabled) {
      command_1.issue("echo", enabled ? "on" : "off");
    }
    exports.setCommandEcho = setCommandEcho;
    function setFailed2(message) {
      process.exitCode = ExitCode.Failure;
      error(message);
    }
    exports.setFailed = setFailed2;
    function isDebug() {
      return process.env["RUNNER_DEBUG"] === "1";
    }
    exports.isDebug = isDebug;
    function debug(message) {
      command_1.issueCommand("debug", {}, message);
    }
    exports.debug = debug;
    function error(message, properties = {}) {
      command_1.issueCommand("error", utils_1.toCommandProperties(properties), message instanceof Error ? message.toString() : message);
    }
    exports.error = error;
    function warning2(message, properties = {}) {
      command_1.issueCommand("warning", utils_1.toCommandProperties(properties), message instanceof Error ? message.toString() : message);
    }
    exports.warning = warning2;
    function notice(message, properties = {}) {
      command_1.issueCommand("notice", utils_1.toCommandProperties(properties), message instanceof Error ? message.toString() : message);
    }
    exports.notice = notice;
    function info(message) {
      process.stdout.write(message + os.EOL);
    }
    exports.info = info;
    function startGroup(name) {
      command_1.issue("group", name);
    }
    exports.startGroup = startGroup;
    function endGroup() {
      command_1.issue("endgroup");
    }
    exports.endGroup = endGroup;
    function group(name, fn) {
      return __awaiter(this, void 0, void 0, function* () {
        startGroup(name);
        let result;
        try {
          result = yield fn();
        } finally {
          endGroup();
        }
        return result;
      });
    }
    exports.group = group;
    function saveState(name, value) {
      command_1.issueCommand("save-state", { name }, value);
    }
    exports.saveState = saveState;
    function getState(name) {
      return process.env[`STATE_${name}`] || "";
    }
    exports.getState = getState;
    function getIDToken(aud) {
      return __awaiter(this, void 0, void 0, function* () {
        return yield oidc_utils_1.OidcClient.getIDToken(aud);
      });
    }
    exports.getIDToken = getIDToken;
    var summary_1 = require_summary();
    Object.defineProperty(exports, "summary", { enumerable: true, get: function() {
      return summary_1.summary;
    } });
    var summary_2 = require_summary();
    Object.defineProperty(exports, "markdownSummary", { enumerable: true, get: function() {
      return summary_2.markdownSummary;
    } });
    var path_utils_1 = require_path_utils();
    Object.defineProperty(exports, "toPosixPath", { enumerable: true, get: function() {
      return path_utils_1.toPosixPath;
    } });
    Object.defineProperty(exports, "toWin32Path", { enumerable: true, get: function() {
      return path_utils_1.toWin32Path;
    } });
    Object.defineProperty(exports, "toPlatformPath", { enumerable: true, get: function() {
      return path_utils_1.toPlatformPath;
    } });
  }
});

// node_modules/@actions/github/lib/context.js
var require_context = __commonJS({
  "node_modules/@actions/github/lib/context.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Context = void 0;
    var fs_1 = require("fs");
    var os_1 = require("os");
    var Context = class {
      constructor() {
        var _a4, _b, _c;
        this.payload = {};
        if (process.env.GITHUB_EVENT_PATH) {
          if (fs_1.existsSync(process.env.GITHUB_EVENT_PATH)) {
            this.payload = JSON.parse(fs_1.readFileSync(process.env.GITHUB_EVENT_PATH, { encoding: "utf8" }));
          } else {
            const path4 = process.env.GITHUB_EVENT_PATH;
            process.stdout.write(`GITHUB_EVENT_PATH ${path4} does not exist${os_1.EOL}`);
          }
        }
        this.eventName = process.env.GITHUB_EVENT_NAME;
        this.sha = process.env.GITHUB_SHA;
        this.ref = process.env.GITHUB_REF;
        this.workflow = process.env.GITHUB_WORKFLOW;
        this.action = process.env.GITHUB_ACTION;
        this.actor = process.env.GITHUB_ACTOR;
        this.job = process.env.GITHUB_JOB;
        this.runNumber = parseInt(process.env.GITHUB_RUN_NUMBER, 10);
        this.runId = parseInt(process.env.GITHUB_RUN_ID, 10);
        this.apiUrl = (_a4 = process.env.GITHUB_API_URL) !== null && _a4 !== void 0 ? _a4 : `https://api.github.com`;
        this.serverUrl = (_b = process.env.GITHUB_SERVER_URL) !== null && _b !== void 0 ? _b : `https://github.com`;
        this.graphqlUrl = (_c = process.env.GITHUB_GRAPHQL_URL) !== null && _c !== void 0 ? _c : `https://api.github.com/graphql`;
      }
      get issue() {
        const payload = this.payload;
        return Object.assign(Object.assign({}, this.repo), { number: (payload.issue || payload.pull_request || payload).number });
      }
      get repo() {
        if (process.env.GITHUB_REPOSITORY) {
          const [owner, repo] = process.env.GITHUB_REPOSITORY.split("/");
          return { owner, repo };
        }
        if (this.payload.repository) {
          return {
            owner: this.payload.repository.owner.login,
            repo: this.payload.repository.name
          };
        }
        throw new Error("context.repo requires a GITHUB_REPOSITORY environment variable like 'owner/repo'");
      }
    };
    exports.Context = Context;
  }
});

// node_modules/@actions/github/lib/internal/utils.js
var require_utils2 = __commonJS({
  "node_modules/@actions/github/lib/internal/utils.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getApiBaseUrl = exports.getProxyAgent = exports.getAuthString = void 0;
    var httpClient = __importStar(require_lib());
    function getAuthString(token, options) {
      if (!token && !options.auth) {
        throw new Error("Parameter token or opts.auth is required");
      } else if (token && options.auth) {
        throw new Error("Parameters token and opts.auth may not both be specified");
      }
      return typeof options.auth === "string" ? options.auth : `token ${token}`;
    }
    exports.getAuthString = getAuthString;
    function getProxyAgent(destinationUrl) {
      const hc = new httpClient.HttpClient();
      return hc.getAgent(destinationUrl);
    }
    exports.getProxyAgent = getProxyAgent;
    function getApiBaseUrl() {
      return process.env["GITHUB_API_URL"] || "https://api.github.com";
    }
    exports.getApiBaseUrl = getApiBaseUrl;
  }
});

// node_modules/universal-user-agent/dist-web/index.js
function getUserAgent() {
  if (typeof navigator === "object" && "userAgent" in navigator) {
    return navigator.userAgent;
  }
  if (typeof process === "object" && "version" in process) {
    return `Node.js/${process.version.substr(1)} (${process.platform}; ${process.arch})`;
  }
  return "<environment undetectable>";
}
var init_dist_web = __esm({
  "node_modules/universal-user-agent/dist-web/index.js"() {
  }
});

// node_modules/before-after-hook/lib/register.js
var require_register = __commonJS({
  "node_modules/before-after-hook/lib/register.js"(exports, module2) {
    module2.exports = register;
    function register(state, name, method, options) {
      if (typeof method !== "function") {
        throw new Error("method for before hook must be a function");
      }
      if (!options) {
        options = {};
      }
      if (Array.isArray(name)) {
        return name.reverse().reduce(function(callback, name2) {
          return register.bind(null, state, name2, callback, options);
        }, method)();
      }
      return Promise.resolve().then(function() {
        if (!state.registry[name]) {
          return method(options);
        }
        return state.registry[name].reduce(function(method2, registered) {
          return registered.hook.bind(null, method2, options);
        }, method)();
      });
    }
  }
});

// node_modules/before-after-hook/lib/add.js
var require_add = __commonJS({
  "node_modules/before-after-hook/lib/add.js"(exports, module2) {
    module2.exports = addHook;
    function addHook(state, kind, name, hook2) {
      var orig = hook2;
      if (!state.registry[name]) {
        state.registry[name] = [];
      }
      if (kind === "before") {
        hook2 = function(method, options) {
          return Promise.resolve().then(orig.bind(null, options)).then(method.bind(null, options));
        };
      }
      if (kind === "after") {
        hook2 = function(method, options) {
          var result;
          return Promise.resolve().then(method.bind(null, options)).then(function(result_) {
            result = result_;
            return orig(result, options);
          }).then(function() {
            return result;
          });
        };
      }
      if (kind === "error") {
        hook2 = function(method, options) {
          return Promise.resolve().then(method.bind(null, options)).catch(function(error) {
            return orig(error, options);
          });
        };
      }
      state.registry[name].push({
        hook: hook2,
        orig
      });
    }
  }
});

// node_modules/before-after-hook/lib/remove.js
var require_remove = __commonJS({
  "node_modules/before-after-hook/lib/remove.js"(exports, module2) {
    module2.exports = removeHook;
    function removeHook(state, name, method) {
      if (!state.registry[name]) {
        return;
      }
      var index = state.registry[name].map(function(registered) {
        return registered.orig;
      }).indexOf(method);
      if (index === -1) {
        return;
      }
      state.registry[name].splice(index, 1);
    }
  }
});

// node_modules/before-after-hook/index.js
var require_before_after_hook = __commonJS({
  "node_modules/before-after-hook/index.js"(exports, module2) {
    var register = require_register();
    var addHook = require_add();
    var removeHook = require_remove();
    var bind = Function.bind;
    var bindable = bind.bind(bind);
    function bindApi(hook2, state, name) {
      var removeHookRef = bindable(removeHook, null).apply(null, name ? [state, name] : [state]);
      hook2.api = { remove: removeHookRef };
      hook2.remove = removeHookRef;
      ["before", "error", "after", "wrap"].forEach(function(kind) {
        var args = name ? [state, kind, name] : [state, kind];
        hook2[kind] = hook2.api[kind] = bindable(addHook, null).apply(null, args);
      });
    }
    function HookSingular() {
      var singularHookName = "h";
      var singularHookState = {
        registry: {}
      };
      var singularHook = register.bind(null, singularHookState, singularHookName);
      bindApi(singularHook, singularHookState, singularHookName);
      return singularHook;
    }
    function HookCollection() {
      var state = {
        registry: {}
      };
      var hook2 = register.bind(null, state);
      bindApi(hook2, state);
      return hook2;
    }
    var collectionHookDeprecationMessageDisplayed = false;
    function Hook() {
      if (!collectionHookDeprecationMessageDisplayed) {
        console.warn('[before-after-hook]: "Hook()" repurposing warning, use "Hook.Collection()". Read more: https://git.io/upgrade-before-after-hook-to-1.4');
        collectionHookDeprecationMessageDisplayed = true;
      }
      return HookCollection();
    }
    Hook.Singular = HookSingular.bind();
    Hook.Collection = HookCollection.bind();
    module2.exports = Hook;
    module2.exports.Hook = Hook;
    module2.exports.Singular = Hook.Singular;
    module2.exports.Collection = Hook.Collection;
  }
});

// node_modules/isobject/index.js
function isObject(val) {
  return val != null && typeof val === "object" && Array.isArray(val) === false;
}
var init_isobject = __esm({
  "node_modules/isobject/index.js"() {
  }
});

// node_modules/@octokit/endpoint/node_modules/is-plain-object/index.js
function isObjectObject(o) {
  return isObject(o) === true && Object.prototype.toString.call(o) === "[object Object]";
}
function isPlainObject(o) {
  var ctor, prot;
  if (isObjectObject(o) === false)
    return false;
  ctor = o.constructor;
  if (typeof ctor !== "function")
    return false;
  prot = ctor.prototype;
  if (isObjectObject(prot) === false)
    return false;
  if (prot.hasOwnProperty("isPrototypeOf") === false) {
    return false;
  }
  return true;
}
var init_is_plain_object = __esm({
  "node_modules/@octokit/endpoint/node_modules/is-plain-object/index.js"() {
    init_isobject();
  }
});

// node_modules/@octokit/endpoint/node_modules/universal-user-agent/dist-web/index.js
function getUserAgent2() {
  try {
    return navigator.userAgent;
  } catch (e2) {
    return "<environment undetectable>";
  }
}
var init_dist_web2 = __esm({
  "node_modules/@octokit/endpoint/node_modules/universal-user-agent/dist-web/index.js"() {
  }
});

// node_modules/@octokit/endpoint/dist-web/index.js
function lowercaseKeys(object) {
  if (!object) {
    return {};
  }
  return Object.keys(object).reduce((newObj, key) => {
    newObj[key.toLowerCase()] = object[key];
    return newObj;
  }, {});
}
function mergeDeep(defaults, options) {
  const result = Object.assign({}, defaults);
  Object.keys(options).forEach((key) => {
    if (isPlainObject(options[key])) {
      if (!(key in defaults))
        Object.assign(result, { [key]: options[key] });
      else
        result[key] = mergeDeep(defaults[key], options[key]);
    } else {
      Object.assign(result, { [key]: options[key] });
    }
  });
  return result;
}
function merge(defaults, route, options) {
  if (typeof route === "string") {
    let [method, url] = route.split(" ");
    options = Object.assign(url ? { method, url } : { url: method }, options);
  } else {
    options = Object.assign({}, route);
  }
  options.headers = lowercaseKeys(options.headers);
  const mergedOptions = mergeDeep(defaults || {}, options);
  if (defaults && defaults.mediaType.previews.length) {
    mergedOptions.mediaType.previews = defaults.mediaType.previews.filter((preview) => !mergedOptions.mediaType.previews.includes(preview)).concat(mergedOptions.mediaType.previews);
  }
  mergedOptions.mediaType.previews = mergedOptions.mediaType.previews.map((preview) => preview.replace(/-preview/, ""));
  return mergedOptions;
}
function addQueryParameters(url, parameters) {
  const separator = /\?/.test(url) ? "&" : "?";
  const names = Object.keys(parameters);
  if (names.length === 0) {
    return url;
  }
  return url + separator + names.map((name) => {
    if (name === "q") {
      return "q=" + parameters.q.split("+").map(encodeURIComponent).join("+");
    }
    return `${name}=${encodeURIComponent(parameters[name])}`;
  }).join("&");
}
function removeNonChars(variableName) {
  return variableName.replace(/^\W+|\W+$/g, "").split(/,/);
}
function extractUrlVariableNames(url) {
  const matches = url.match(urlVariableRegex);
  if (!matches) {
    return [];
  }
  return matches.map(removeNonChars).reduce((a, b) => a.concat(b), []);
}
function omit(object, keysToOmit) {
  return Object.keys(object).filter((option) => !keysToOmit.includes(option)).reduce((obj, key) => {
    obj[key] = object[key];
    return obj;
  }, {});
}
function encodeReserved(str) {
  return str.split(/(%[0-9A-Fa-f]{2})/g).map(function(part) {
    if (!/%[0-9A-Fa-f]/.test(part)) {
      part = encodeURI(part).replace(/%5B/g, "[").replace(/%5D/g, "]");
    }
    return part;
  }).join("");
}
function encodeUnreserved(str) {
  return encodeURIComponent(str).replace(/[!'()*]/g, function(c) {
    return "%" + c.charCodeAt(0).toString(16).toUpperCase();
  });
}
function encodeValue(operator, value, key) {
  value = operator === "+" || operator === "#" ? encodeReserved(value) : encodeUnreserved(value);
  if (key) {
    return encodeUnreserved(key) + "=" + value;
  } else {
    return value;
  }
}
function isDefined(value) {
  return value !== void 0 && value !== null;
}
function isKeyOperator(operator) {
  return operator === ";" || operator === "&" || operator === "?";
}
function getValues(context2, operator, key, modifier) {
  var value = context2[key], result = [];
  if (isDefined(value) && value !== "") {
    if (typeof value === "string" || typeof value === "number" || typeof value === "boolean") {
      value = value.toString();
      if (modifier && modifier !== "*") {
        value = value.substring(0, parseInt(modifier, 10));
      }
      result.push(encodeValue(operator, value, isKeyOperator(operator) ? key : ""));
    } else {
      if (modifier === "*") {
        if (Array.isArray(value)) {
          value.filter(isDefined).forEach(function(value2) {
            result.push(encodeValue(operator, value2, isKeyOperator(operator) ? key : ""));
          });
        } else {
          Object.keys(value).forEach(function(k) {
            if (isDefined(value[k])) {
              result.push(encodeValue(operator, value[k], k));
            }
          });
        }
      } else {
        const tmp = [];
        if (Array.isArray(value)) {
          value.filter(isDefined).forEach(function(value2) {
            tmp.push(encodeValue(operator, value2));
          });
        } else {
          Object.keys(value).forEach(function(k) {
            if (isDefined(value[k])) {
              tmp.push(encodeUnreserved(k));
              tmp.push(encodeValue(operator, value[k].toString()));
            }
          });
        }
        if (isKeyOperator(operator)) {
          result.push(encodeUnreserved(key) + "=" + tmp.join(","));
        } else if (tmp.length !== 0) {
          result.push(tmp.join(","));
        }
      }
    }
  } else {
    if (operator === ";") {
      if (isDefined(value)) {
        result.push(encodeUnreserved(key));
      }
    } else if (value === "" && (operator === "&" || operator === "?")) {
      result.push(encodeUnreserved(key) + "=");
    } else if (value === "") {
      result.push("");
    }
  }
  return result;
}
function parseUrl(template) {
  return {
    expand: expand.bind(null, template)
  };
}
function expand(template, context2) {
  var operators = ["+", "#", ".", "/", ";", "?", "&"];
  return template.replace(/\{([^\{\}]+)\}|([^\{\}]+)/g, function(_, expression, literal) {
    if (expression) {
      let operator = "";
      const values = [];
      if (operators.indexOf(expression.charAt(0)) !== -1) {
        operator = expression.charAt(0);
        expression = expression.substr(1);
      }
      expression.split(/,/g).forEach(function(variable) {
        var tmp = /([^:\*]*)(?::(\d+)|(\*))?/.exec(variable);
        values.push(getValues(context2, operator, tmp[1], tmp[2] || tmp[3]));
      });
      if (operator && operator !== "+") {
        var separator = ",";
        if (operator === "?") {
          separator = "&";
        } else if (operator !== "#") {
          separator = operator;
        }
        return (values.length !== 0 ? operator : "") + values.join(separator);
      } else {
        return values.join(",");
      }
    } else {
      return encodeReserved(literal);
    }
  });
}
function parse(options) {
  let method = options.method.toUpperCase();
  let url = (options.url || "/").replace(/:([a-z]\w+)/g, "{+$1}");
  let headers = Object.assign({}, options.headers);
  let body;
  let parameters = omit(options, [
    "method",
    "baseUrl",
    "url",
    "headers",
    "request",
    "mediaType"
  ]);
  const urlVariableNames = extractUrlVariableNames(url);
  url = parseUrl(url).expand(parameters);
  if (!/^http/.test(url)) {
    url = options.baseUrl + url;
  }
  const omittedParameters = Object.keys(options).filter((option) => urlVariableNames.includes(option)).concat("baseUrl");
  const remainingParameters = omit(parameters, omittedParameters);
  const isBinaryRequset = /application\/octet-stream/i.test(headers.accept);
  if (!isBinaryRequset) {
    if (options.mediaType.format) {
      headers.accept = headers.accept.split(/,/).map((preview) => preview.replace(/application\/vnd(\.\w+)(\.v3)?(\.\w+)?(\+json)?$/, `application/vnd$1$2.${options.mediaType.format}`)).join(",");
    }
    if (options.mediaType.previews.length) {
      const previewsFromAcceptHeader = headers.accept.match(/[\w-]+(?=-preview)/g) || [];
      headers.accept = previewsFromAcceptHeader.concat(options.mediaType.previews).map((preview) => {
        const format2 = options.mediaType.format ? `.${options.mediaType.format}` : "+json";
        return `application/vnd.github.${preview}-preview${format2}`;
      }).join(",");
    }
  }
  if (["GET", "HEAD"].includes(method)) {
    url = addQueryParameters(url, remainingParameters);
  } else {
    if ("data" in remainingParameters) {
      body = remainingParameters.data;
    } else {
      if (Object.keys(remainingParameters).length) {
        body = remainingParameters;
      } else {
        headers["content-length"] = 0;
      }
    }
  }
  if (!headers["content-type"] && typeof body !== "undefined") {
    headers["content-type"] = "application/json; charset=utf-8";
  }
  if (["PATCH", "PUT"].includes(method) && typeof body === "undefined") {
    body = "";
  }
  return Object.assign({ method, url, headers }, typeof body !== "undefined" ? { body } : null, options.request ? { request: options.request } : null);
}
function endpointWithDefaults(defaults, route, options) {
  return parse(merge(defaults, route, options));
}
function withDefaults(oldDefaults, newDefaults) {
  const DEFAULTS2 = merge(oldDefaults, newDefaults);
  const endpoint2 = endpointWithDefaults.bind(null, DEFAULTS2);
  return Object.assign(endpoint2, {
    DEFAULTS: DEFAULTS2,
    defaults: withDefaults.bind(null, DEFAULTS2),
    merge: merge.bind(null, DEFAULTS2),
    parse
  });
}
var urlVariableRegex, VERSION, userAgent, DEFAULTS, endpoint;
var init_dist_web3 = __esm({
  "node_modules/@octokit/endpoint/dist-web/index.js"() {
    init_is_plain_object();
    init_dist_web2();
    urlVariableRegex = /\{[^}]+\}/g;
    VERSION = "6.0.3";
    userAgent = `octokit-endpoint.js/${VERSION} ${getUserAgent2()}`;
    DEFAULTS = {
      method: "GET",
      baseUrl: "https://api.github.com",
      headers: {
        accept: "application/vnd.github.v3+json",
        "user-agent": userAgent
      },
      mediaType: {
        format: "",
        previews: []
      }
    };
    endpoint = withDefaults(null, DEFAULTS);
  }
});

// node_modules/is-plain-object/dist/is-plain-object.mjs
function isObject2(o) {
  return Object.prototype.toString.call(o) === "[object Object]";
}
function isPlainObject2(o) {
  var ctor, prot;
  if (isObject2(o) === false)
    return false;
  ctor = o.constructor;
  if (ctor === void 0)
    return true;
  prot = ctor.prototype;
  if (isObject2(prot) === false)
    return false;
  if (prot.hasOwnProperty("isPrototypeOf") === false) {
    return false;
  }
  return true;
}
var init_is_plain_object2 = __esm({
  "node_modules/is-plain-object/dist/is-plain-object.mjs"() {
  }
});

// node_modules/@octokit/request/node_modules/webidl-conversions/lib/index.js
var require_lib2 = __commonJS({
  "node_modules/@octokit/request/node_modules/webidl-conversions/lib/index.js"(exports, module2) {
    "use strict";
    var conversions = {};
    module2.exports = conversions;
    function sign(x2) {
      return x2 < 0 ? -1 : 1;
    }
    function evenRound(x2) {
      if (x2 % 1 === 0.5 && (x2 & 1) === 0) {
        return Math.floor(x2);
      } else {
        return Math.round(x2);
      }
    }
    function createNumberConversion(bitLength, typeOpts) {
      if (!typeOpts.unsigned) {
        --bitLength;
      }
      const lowerBound = typeOpts.unsigned ? 0 : -Math.pow(2, bitLength);
      const upperBound = Math.pow(2, bitLength) - 1;
      const moduloVal = typeOpts.moduloBitLength ? Math.pow(2, typeOpts.moduloBitLength) : Math.pow(2, bitLength);
      const moduloBound = typeOpts.moduloBitLength ? Math.pow(2, typeOpts.moduloBitLength - 1) : Math.pow(2, bitLength - 1);
      return function(V, opts) {
        if (!opts)
          opts = {};
        let x2 = +V;
        if (opts.enforceRange) {
          if (!Number.isFinite(x2)) {
            throw new TypeError("Argument is not a finite number");
          }
          x2 = sign(x2) * Math.floor(Math.abs(x2));
          if (x2 < lowerBound || x2 > upperBound) {
            throw new TypeError("Argument is not in byte range");
          }
          return x2;
        }
        if (!isNaN(x2) && opts.clamp) {
          x2 = evenRound(x2);
          if (x2 < lowerBound)
            x2 = lowerBound;
          if (x2 > upperBound)
            x2 = upperBound;
          return x2;
        }
        if (!Number.isFinite(x2) || x2 === 0) {
          return 0;
        }
        x2 = sign(x2) * Math.floor(Math.abs(x2));
        x2 = x2 % moduloVal;
        if (!typeOpts.unsigned && x2 >= moduloBound) {
          return x2 - moduloVal;
        } else if (typeOpts.unsigned) {
          if (x2 < 0) {
            x2 += moduloVal;
          } else if (x2 === -0) {
            return 0;
          }
        }
        return x2;
      };
    }
    conversions["void"] = function() {
      return void 0;
    };
    conversions["boolean"] = function(val) {
      return !!val;
    };
    conversions["byte"] = createNumberConversion(8, { unsigned: false });
    conversions["octet"] = createNumberConversion(8, { unsigned: true });
    conversions["short"] = createNumberConversion(16, { unsigned: false });
    conversions["unsigned short"] = createNumberConversion(16, { unsigned: true });
    conversions["long"] = createNumberConversion(32, { unsigned: false });
    conversions["unsigned long"] = createNumberConversion(32, { unsigned: true });
    conversions["long long"] = createNumberConversion(32, { unsigned: false, moduloBitLength: 64 });
    conversions["unsigned long long"] = createNumberConversion(32, { unsigned: true, moduloBitLength: 64 });
    conversions["double"] = function(V) {
      const x2 = +V;
      if (!Number.isFinite(x2)) {
        throw new TypeError("Argument is not a finite floating-point value");
      }
      return x2;
    };
    conversions["unrestricted double"] = function(V) {
      const x2 = +V;
      if (isNaN(x2)) {
        throw new TypeError("Argument is NaN");
      }
      return x2;
    };
    conversions["float"] = conversions["double"];
    conversions["unrestricted float"] = conversions["unrestricted double"];
    conversions["DOMString"] = function(V, opts) {
      if (!opts)
        opts = {};
      if (opts.treatNullAsEmptyString && V === null) {
        return "";
      }
      return String(V);
    };
    conversions["ByteString"] = function(V, opts) {
      const x2 = String(V);
      let c = void 0;
      for (let i2 = 0; (c = x2.codePointAt(i2)) !== void 0; ++i2) {
        if (c > 255) {
          throw new TypeError("Argument is not a valid bytestring");
        }
      }
      return x2;
    };
    conversions["USVString"] = function(V) {
      const S2 = String(V);
      const n = S2.length;
      const U = [];
      for (let i2 = 0; i2 < n; ++i2) {
        const c = S2.charCodeAt(i2);
        if (c < 55296 || c > 57343) {
          U.push(String.fromCodePoint(c));
        } else if (56320 <= c && c <= 57343) {
          U.push(String.fromCodePoint(65533));
        } else {
          if (i2 === n - 1) {
            U.push(String.fromCodePoint(65533));
          } else {
            const d = S2.charCodeAt(i2 + 1);
            if (56320 <= d && d <= 57343) {
              const a = c & 1023;
              const b = d & 1023;
              U.push(String.fromCodePoint((2 << 15) + (2 << 9) * a + b));
              ++i2;
            } else {
              U.push(String.fromCodePoint(65533));
            }
          }
        }
      }
      return U.join("");
    };
    conversions["Date"] = function(V, opts) {
      if (!(V instanceof Date)) {
        throw new TypeError("Argument is not a Date object");
      }
      if (isNaN(V)) {
        return void 0;
      }
      return V;
    };
    conversions["RegExp"] = function(V, opts) {
      if (!(V instanceof RegExp)) {
        V = new RegExp(V);
      }
      return V;
    };
  }
});

// node_modules/@octokit/request/node_modules/whatwg-url/lib/utils.js
var require_utils3 = __commonJS({
  "node_modules/@octokit/request/node_modules/whatwg-url/lib/utils.js"(exports, module2) {
    "use strict";
    module2.exports.mixin = function mixin(target, source) {
      const keys = Object.getOwnPropertyNames(source);
      for (let i2 = 0; i2 < keys.length; ++i2) {
        Object.defineProperty(target, keys[i2], Object.getOwnPropertyDescriptor(source, keys[i2]));
      }
    };
    module2.exports.wrapperSymbol = Symbol("wrapper");
    module2.exports.implSymbol = Symbol("impl");
    module2.exports.wrapperForImpl = function(impl) {
      return impl[module2.exports.wrapperSymbol];
    };
    module2.exports.implForWrapper = function(wrapper) {
      return wrapper[module2.exports.implSymbol];
    };
  }
});

// node_modules/@octokit/request/node_modules/tr46/lib/mappingTable.json
var require_mappingTable = __commonJS({
  "node_modules/@octokit/request/node_modules/tr46/lib/mappingTable.json"(exports, module2) {
    module2.exports = [[[0, 44], "disallowed_STD3_valid"], [[45, 46], "valid"], [[47, 47], "disallowed_STD3_valid"], [[48, 57], "valid"], [[58, 64], "disallowed_STD3_valid"], [[65, 65], "mapped", [97]], [[66, 66], "mapped", [98]], [[67, 67], "mapped", [99]], [[68, 68], "mapped", [100]], [[69, 69], "mapped", [101]], [[70, 70], "mapped", [102]], [[71, 71], "mapped", [103]], [[72, 72], "mapped", [104]], [[73, 73], "mapped", [105]], [[74, 74], "mapped", [106]], [[75, 75], "mapped", [107]], [[76, 76], "mapped", [108]], [[77, 77], "mapped", [109]], [[78, 78], "mapped", [110]], [[79, 79], "mapped", [111]], [[80, 80], "mapped", [112]], [[81, 81], "mapped", [113]], [[82, 82], "mapped", [114]], [[83, 83], "mapped", [115]], [[84, 84], "mapped", [116]], [[85, 85], "mapped", [117]], [[86, 86], "mapped", [118]], [[87, 87], "mapped", [119]], [[88, 88], "mapped", [120]], [[89, 89], "mapped", [121]], [[90, 90], "mapped", [122]], [[91, 96], "disallowed_STD3_valid"], [[97, 122], "valid"], [[123, 127], "disallowed_STD3_valid"], [[128, 159], "disallowed"], [[160, 160], "disallowed_STD3_mapped", [32]], [[161, 167], "valid", [], "NV8"], [[168, 168], "disallowed_STD3_mapped", [32, 776]], [[169, 169], "valid", [], "NV8"], [[170, 170], "mapped", [97]], [[171, 172], "valid", [], "NV8"], [[173, 173], "ignored"], [[174, 174], "valid", [], "NV8"], [[175, 175], "disallowed_STD3_mapped", [32, 772]], [[176, 177], "valid", [], "NV8"], [[178, 178], "mapped", [50]], [[179, 179], "mapped", [51]], [[180, 180], "disallowed_STD3_mapped", [32, 769]], [[181, 181], "mapped", [956]], [[182, 182], "valid", [], "NV8"], [[183, 183], "valid"], [[184, 184], "disallowed_STD3_mapped", [32, 807]], [[185, 185], "mapped", [49]], [[186, 186], "mapped", [111]], [[187, 187], "valid", [], "NV8"], [[188, 188], "mapped", [49, 8260, 52]], [[189, 189], "mapped", [49, 8260, 50]], [[190, 190], "mapped", [51, 8260, 52]], [[191, 191], "valid", [], "NV8"], [[192, 192], "mapped", [224]], [[193, 193], "mapped", [225]], [[194, 194], "mapped", [226]], [[195, 195], "mapped", [227]], [[196, 196], "mapped", [228]], [[197, 197], "mapped", [229]], [[198, 198], "mapped", [230]], [[199, 199], "mapped", [231]], [[200, 200], "mapped", [232]], [[201, 201], "mapped", [233]], [[202, 202], "mapped", [234]], [[203, 203], "mapped", [235]], [[204, 204], "mapped", [236]], [[205, 205], "mapped", [237]], [[206, 206], "mapped", [238]], [[207, 207], "mapped", [239]], [[208, 208], "mapped", [240]], [[209, 209], "mapped", [241]], [[210, 210], "mapped", [242]], [[211, 211], "mapped", [243]], [[212, 212], "mapped", [244]], [[213, 213], "mapped", [245]], [[214, 214], "mapped", [246]], [[215, 215], "valid", [], "NV8"], [[216, 216], "mapped", [248]], [[217, 217], "mapped", [249]], [[218, 218], "mapped", [250]], [[219, 219], "mapped", [251]], [[220, 220], "mapped", [252]], [[221, 221], "mapped", [253]], [[222, 222], "mapped", [254]], [[223, 223], "deviation", [115, 115]], [[224, 246], "valid"], [[247, 247], "valid", [], "NV8"], [[248, 255], "valid"], [[256, 256], "mapped", [257]], [[257, 257], "valid"], [[258, 258], "mapped", [259]], [[259, 259], "valid"], [[260, 260], "mapped", [261]], [[261, 261], "valid"], [[262, 262], "mapped", [263]], [[263, 263], "valid"], [[264, 264], "mapped", [265]], [[265, 265], "valid"], [[266, 266], "mapped", [267]], [[267, 267], "valid"], [[268, 268], "mapped", [269]], [[269, 269], "valid"], [[270, 270], "mapped", [271]], [[271, 271], "valid"], [[272, 272], "mapped", [273]], [[273, 273], "valid"], [[274, 274], "mapped", [275]], [[275, 275], "valid"], [[276, 276], "mapped", [277]], [[277, 277], "valid"], [[278, 278], "mapped", [279]], [[279, 279], "valid"], [[280, 280], "mapped", [281]], [[281, 281], "valid"], [[282, 282], "mapped", [283]], [[283, 283], "valid"], [[284, 284], "mapped", [285]], [[285, 285], "valid"], [[286, 286], "mapped", [287]], [[287, 287], "valid"], [[288, 288], "mapped", [289]], [[289, 289], "valid"], [[290, 290], "mapped", [291]], [[291, 291], "valid"], [[292, 292], "mapped", [293]], [[293, 293], "valid"], [[294, 294], "mapped", [295]], [[295, 295], "valid"], [[296, 296], "mapped", [297]], [[297, 297], "valid"], [[298, 298], "mapped", [299]], [[299, 299], "valid"], [[300, 300], "mapped", [301]], [[301, 301], "valid"], [[302, 302], "mapped", [303]], [[303, 303], "valid"], [[304, 304], "mapped", [105, 775]], [[305, 305], "valid"], [[306, 307], "mapped", [105, 106]], [[308, 308], "mapped", [309]], [[309, 309], "valid"], [[310, 310], "mapped", [311]], [[311, 312], "valid"], [[313, 313], "mapped", [314]], [[314, 314], "valid"], [[315, 315], "mapped", [316]], [[316, 316], "valid"], [[317, 317], "mapped", [318]], [[318, 318], "valid"], [[319, 320], "mapped", [108, 183]], [[321, 321], "mapped", [322]], [[322, 322], "valid"], [[323, 323], "mapped", [324]], [[324, 324], "valid"], [[325, 325], "mapped", [326]], [[326, 326], "valid"], [[327, 327], "mapped", [328]], [[328, 328], "valid"], [[329, 329], "mapped", [700, 110]], [[330, 330], "mapped", [331]], [[331, 331], "valid"], [[332, 332], "mapped", [333]], [[333, 333], "valid"], [[334, 334], "mapped", [335]], [[335, 335], "valid"], [[336, 336], "mapped", [337]], [[337, 337], "valid"], [[338, 338], "mapped", [339]], [[339, 339], "valid"], [[340, 340], "mapped", [341]], [[341, 341], "valid"], [[342, 342], "mapped", [343]], [[343, 343], "valid"], [[344, 344], "mapped", [345]], [[345, 345], "valid"], [[346, 346], "mapped", [347]], [[347, 347], "valid"], [[348, 348], "mapped", [349]], [[349, 349], "valid"], [[350, 350], "mapped", [351]], [[351, 351], "valid"], [[352, 352], "mapped", [353]], [[353, 353], "valid"], [[354, 354], "mapped", [355]], [[355, 355], "valid"], [[356, 356], "mapped", [357]], [[357, 357], "valid"], [[358, 358], "mapped", [359]], [[359, 359], "valid"], [[360, 360], "mapped", [361]], [[361, 361], "valid"], [[362, 362], "mapped", [363]], [[363, 363], "valid"], [[364, 364], "mapped", [365]], [[365, 365], "valid"], [[366, 366], "mapped", [367]], [[367, 367], "valid"], [[368, 368], "mapped", [369]], [[369, 369], "valid"], [[370, 370], "mapped", [371]], [[371, 371], "valid"], [[372, 372], "mapped", [373]], [[373, 373], "valid"], [[374, 374], "mapped", [375]], [[375, 375], "valid"], [[376, 376], "mapped", [255]], [[377, 377], "mapped", [378]], [[378, 378], "valid"], [[379, 379], "mapped", [380]], [[380, 380], "valid"], [[381, 381], "mapped", [382]], [[382, 382], "valid"], [[383, 383], "mapped", [115]], [[384, 384], "valid"], [[385, 385], "mapped", [595]], [[386, 386], "mapped", [387]], [[387, 387], "valid"], [[388, 388], "mapped", [389]], [[389, 389], "valid"], [[390, 390], "mapped", [596]], [[391, 391], "mapped", [392]], [[392, 392], "valid"], [[393, 393], "mapped", [598]], [[394, 394], "mapped", [599]], [[395, 395], "mapped", [396]], [[396, 397], "valid"], [[398, 398], "mapped", [477]], [[399, 399], "mapped", [601]], [[400, 400], "mapped", [603]], [[401, 401], "mapped", [402]], [[402, 402], "valid"], [[403, 403], "mapped", [608]], [[404, 404], "mapped", [611]], [[405, 405], "valid"], [[406, 406], "mapped", [617]], [[407, 407], "mapped", [616]], [[408, 408], "mapped", [409]], [[409, 411], "valid"], [[412, 412], "mapped", [623]], [[413, 413], "mapped", [626]], [[414, 414], "valid"], [[415, 415], "mapped", [629]], [[416, 416], "mapped", [417]], [[417, 417], "valid"], [[418, 418], "mapped", [419]], [[419, 419], "valid"], [[420, 420], "mapped", [421]], [[421, 421], "valid"], [[422, 422], "mapped", [640]], [[423, 423], "mapped", [424]], [[424, 424], "valid"], [[425, 425], "mapped", [643]], [[426, 427], "valid"], [[428, 428], "mapped", [429]], [[429, 429], "valid"], [[430, 430], "mapped", [648]], [[431, 431], "mapped", [432]], [[432, 432], "valid"], [[433, 433], "mapped", [650]], [[434, 434], "mapped", [651]], [[435, 435], "mapped", [436]], [[436, 436], "valid"], [[437, 437], "mapped", [438]], [[438, 438], "valid"], [[439, 439], "mapped", [658]], [[440, 440], "mapped", [441]], [[441, 443], "valid"], [[444, 444], "mapped", [445]], [[445, 451], "valid"], [[452, 454], "mapped", [100, 382]], [[455, 457], "mapped", [108, 106]], [[458, 460], "mapped", [110, 106]], [[461, 461], "mapped", [462]], [[462, 462], "valid"], [[463, 463], "mapped", [464]], [[464, 464], "valid"], [[465, 465], "mapped", [466]], [[466, 466], "valid"], [[467, 467], "mapped", [468]], [[468, 468], "valid"], [[469, 469], "mapped", [470]], [[470, 470], "valid"], [[471, 471], "mapped", [472]], [[472, 472], "valid"], [[473, 473], "mapped", [474]], [[474, 474], "valid"], [[475, 475], "mapped", [476]], [[476, 477], "valid"], [[478, 478], "mapped", [479]], [[479, 479], "valid"], [[480, 480], "mapped", [481]], [[481, 481], "valid"], [[482, 482], "mapped", [483]], [[483, 483], "valid"], [[484, 484], "mapped", [485]], [[485, 485], "valid"], [[486, 486], "mapped", [487]], [[487, 487], "valid"], [[488, 488], "mapped", [489]], [[489, 489], "valid"], [[490, 490], "mapped", [491]], [[491, 491], "valid"], [[492, 492], "mapped", [493]], [[493, 493], "valid"], [[494, 494], "mapped", [495]], [[495, 496], "valid"], [[497, 499], "mapped", [100, 122]], [[500, 500], "mapped", [501]], [[501, 501], "valid"], [[502, 502], "mapped", [405]], [[503, 503], "mapped", [447]], [[504, 504], "mapped", [505]], [[505, 505], "valid"], [[506, 506], "mapped", [507]], [[507, 507], "valid"], [[508, 508], "mapped", [509]], [[509, 509], "valid"], [[510, 510], "mapped", [511]], [[511, 511], "valid"], [[512, 512], "mapped", [513]], [[513, 513], "valid"], [[514, 514], "mapped", [515]], [[515, 515], "valid"], [[516, 516], "mapped", [517]], [[517, 517], "valid"], [[518, 518], "mapped", [519]], [[519, 519], "valid"], [[520, 520], "mapped", [521]], [[521, 521], "valid"], [[522, 522], "mapped", [523]], [[523, 523], "valid"], [[524, 524], "mapped", [525]], [[525, 525], "valid"], [[526, 526], "mapped", [527]], [[527, 527], "valid"], [[528, 528], "mapped", [529]], [[529, 529], "valid"], [[530, 530], "mapped", [531]], [[531, 531], "valid"], [[532, 532], "mapped", [533]], [[533, 533], "valid"], [[534, 534], "mapped", [535]], [[535, 535], "valid"], [[536, 536], "mapped", [537]], [[537, 537], "valid"], [[538, 538], "mapped", [539]], [[539, 539], "valid"], [[540, 540], "mapped", [541]], [[541, 541], "valid"], [[542, 542], "mapped", [543]], [[543, 543], "valid"], [[544, 544], "mapped", [414]], [[545, 545], "valid"], [[546, 546], "mapped", [547]], [[547, 547], "valid"], [[548, 548], "mapped", [549]], [[549, 549], "valid"], [[550, 550], "mapped", [551]], [[551, 551], "valid"], [[552, 552], "mapped", [553]], [[553, 553], "valid"], [[554, 554], "mapped", [555]], [[555, 555], "valid"], [[556, 556], "mapped", [557]], [[557, 557], "valid"], [[558, 558], "mapped", [559]], [[559, 559], "valid"], [[560, 560], "mapped", [561]], [[561, 561], "valid"], [[562, 562], "mapped", [563]], [[563, 563], "valid"], [[564, 566], "valid"], [[567, 569], "valid"], [[570, 570], "mapped", [11365]], [[571, 571], "mapped", [572]], [[572, 572], "valid"], [[573, 573], "mapped", [410]], [[574, 574], "mapped", [11366]], [[575, 576], "valid"], [[577, 577], "mapped", [578]], [[578, 578], "valid"], [[579, 579], "mapped", [384]], [[580, 580], "mapped", [649]], [[581, 581], "mapped", [652]], [[582, 582], "mapped", [583]], [[583, 583], "valid"], [[584, 584], "mapped", [585]], [[585, 585], "valid"], [[586, 586], "mapped", [587]], [[587, 587], "valid"], [[588, 588], "mapped", [589]], [[589, 589], "valid"], [[590, 590], "mapped", [591]], [[591, 591], "valid"], [[592, 680], "valid"], [[681, 685], "valid"], [[686, 687], "valid"], [[688, 688], "mapped", [104]], [[689, 689], "mapped", [614]], [[690, 690], "mapped", [106]], [[691, 691], "mapped", [114]], [[692, 692], "mapped", [633]], [[693, 693], "mapped", [635]], [[694, 694], "mapped", [641]], [[695, 695], "mapped", [119]], [[696, 696], "mapped", [121]], [[697, 705], "valid"], [[706, 709], "valid", [], "NV8"], [[710, 721], "valid"], [[722, 727], "valid", [], "NV8"], [[728, 728], "disallowed_STD3_mapped", [32, 774]], [[729, 729], "disallowed_STD3_mapped", [32, 775]], [[730, 730], "disallowed_STD3_mapped", [32, 778]], [[731, 731], "disallowed_STD3_mapped", [32, 808]], [[732, 732], "disallowed_STD3_mapped", [32, 771]], [[733, 733], "disallowed_STD3_mapped", [32, 779]], [[734, 734], "valid", [], "NV8"], [[735, 735], "valid", [], "NV8"], [[736, 736], "mapped", [611]], [[737, 737], "mapped", [108]], [[738, 738], "mapped", [115]], [[739, 739], "mapped", [120]], [[740, 740], "mapped", [661]], [[741, 745], "valid", [], "NV8"], [[746, 747], "valid", [], "NV8"], [[748, 748], "valid"], [[749, 749], "valid", [], "NV8"], [[750, 750], "valid"], [[751, 767], "valid", [], "NV8"], [[768, 831], "valid"], [[832, 832], "mapped", [768]], [[833, 833], "mapped", [769]], [[834, 834], "valid"], [[835, 835], "mapped", [787]], [[836, 836], "mapped", [776, 769]], [[837, 837], "mapped", [953]], [[838, 846], "valid"], [[847, 847], "ignored"], [[848, 855], "valid"], [[856, 860], "valid"], [[861, 863], "valid"], [[864, 865], "valid"], [[866, 866], "valid"], [[867, 879], "valid"], [[880, 880], "mapped", [881]], [[881, 881], "valid"], [[882, 882], "mapped", [883]], [[883, 883], "valid"], [[884, 884], "mapped", [697]], [[885, 885], "valid"], [[886, 886], "mapped", [887]], [[887, 887], "valid"], [[888, 889], "disallowed"], [[890, 890], "disallowed_STD3_mapped", [32, 953]], [[891, 893], "valid"], [[894, 894], "disallowed_STD3_mapped", [59]], [[895, 895], "mapped", [1011]], [[896, 899], "disallowed"], [[900, 900], "disallowed_STD3_mapped", [32, 769]], [[901, 901], "disallowed_STD3_mapped", [32, 776, 769]], [[902, 902], "mapped", [940]], [[903, 903], "mapped", [183]], [[904, 904], "mapped", [941]], [[905, 905], "mapped", [942]], [[906, 906], "mapped", [943]], [[907, 907], "disallowed"], [[908, 908], "mapped", [972]], [[909, 909], "disallowed"], [[910, 910], "mapped", [973]], [[911, 911], "mapped", [974]], [[912, 912], "valid"], [[913, 913], "mapped", [945]], [[914, 914], "mapped", [946]], [[915, 915], "mapped", [947]], [[916, 916], "mapped", [948]], [[917, 917], "mapped", [949]], [[918, 918], "mapped", [950]], [[919, 919], "mapped", [951]], [[920, 920], "mapped", [952]], [[921, 921], "mapped", [953]], [[922, 922], "mapped", [954]], [[923, 923], "mapped", [955]], [[924, 924], "mapped", [956]], [[925, 925], "mapped", [957]], [[926, 926], "mapped", [958]], [[927, 927], "mapped", [959]], [[928, 928], "mapped", [960]], [[929, 929], "mapped", [961]], [[930, 930], "disallowed"], [[931, 931], "mapped", [963]], [[932, 932], "mapped", [964]], [[933, 933], "mapped", [965]], [[934, 934], "mapped", [966]], [[935, 935], "mapped", [967]], [[936, 936], "mapped", [968]], [[937, 937], "mapped", [969]], [[938, 938], "mapped", [970]], [[939, 939], "mapped", [971]], [[940, 961], "valid"], [[962, 962], "deviation", [963]], [[963, 974], "valid"], [[975, 975], "mapped", [983]], [[976, 976], "mapped", [946]], [[977, 977], "mapped", [952]], [[978, 978], "mapped", [965]], [[979, 979], "mapped", [973]], [[980, 980], "mapped", [971]], [[981, 981], "mapped", [966]], [[982, 982], "mapped", [960]], [[983, 983], "valid"], [[984, 984], "mapped", [985]], [[985, 985], "valid"], [[986, 986], "mapped", [987]], [[987, 987], "valid"], [[988, 988], "mapped", [989]], [[989, 989], "valid"], [[990, 990], "mapped", [991]], [[991, 991], "valid"], [[992, 992], "mapped", [993]], [[993, 993], "valid"], [[994, 994], "mapped", [995]], [[995, 995], "valid"], [[996, 996], "mapped", [997]], [[997, 997], "valid"], [[998, 998], "mapped", [999]], [[999, 999], "valid"], [[1e3, 1e3], "mapped", [1001]], [[1001, 1001], "valid"], [[1002, 1002], "mapped", [1003]], [[1003, 1003], "valid"], [[1004, 1004], "mapped", [1005]], [[1005, 1005], "valid"], [[1006, 1006], "mapped", [1007]], [[1007, 1007], "valid"], [[1008, 1008], "mapped", [954]], [[1009, 1009], "mapped", [961]], [[1010, 1010], "mapped", [963]], [[1011, 1011], "valid"], [[1012, 1012], "mapped", [952]], [[1013, 1013], "mapped", [949]], [[1014, 1014], "valid", [], "NV8"], [[1015, 1015], "mapped", [1016]], [[1016, 1016], "valid"], [[1017, 1017], "mapped", [963]], [[1018, 1018], "mapped", [1019]], [[1019, 1019], "valid"], [[1020, 1020], "valid"], [[1021, 1021], "mapped", [891]], [[1022, 1022], "mapped", [892]], [[1023, 1023], "mapped", [893]], [[1024, 1024], "mapped", [1104]], [[1025, 1025], "mapped", [1105]], [[1026, 1026], "mapped", [1106]], [[1027, 1027], "mapped", [1107]], [[1028, 1028], "mapped", [1108]], [[1029, 1029], "mapped", [1109]], [[1030, 1030], "mapped", [1110]], [[1031, 1031], "mapped", [1111]], [[1032, 1032], "mapped", [1112]], [[1033, 1033], "mapped", [1113]], [[1034, 1034], "mapped", [1114]], [[1035, 1035], "mapped", [1115]], [[1036, 1036], "mapped", [1116]], [[1037, 1037], "mapped", [1117]], [[1038, 1038], "mapped", [1118]], [[1039, 1039], "mapped", [1119]], [[1040, 1040], "mapped", [1072]], [[1041, 1041], "mapped", [1073]], [[1042, 1042], "mapped", [1074]], [[1043, 1043], "mapped", [1075]], [[1044, 1044], "mapped", [1076]], [[1045, 1045], "mapped", [1077]], [[1046, 1046], "mapped", [1078]], [[1047, 1047], "mapped", [1079]], [[1048, 1048], "mapped", [1080]], [[1049, 1049], "mapped", [1081]], [[1050, 1050], "mapped", [1082]], [[1051, 1051], "mapped", [1083]], [[1052, 1052], "mapped", [1084]], [[1053, 1053], "mapped", [1085]], [[1054, 1054], "mapped", [1086]], [[1055, 1055], "mapped", [1087]], [[1056, 1056], "mapped", [1088]], [[1057, 1057], "mapped", [1089]], [[1058, 1058], "mapped", [1090]], [[1059, 1059], "mapped", [1091]], [[1060, 1060], "mapped", [1092]], [[1061, 1061], "mapped", [1093]], [[1062, 1062], "mapped", [1094]], [[1063, 1063], "mapped", [1095]], [[1064, 1064], "mapped", [1096]], [[1065, 1065], "mapped", [1097]], [[1066, 1066], "mapped", [1098]], [[1067, 1067], "mapped", [1099]], [[1068, 1068], "mapped", [1100]], [[1069, 1069], "mapped", [1101]], [[1070, 1070], "mapped", [1102]], [[1071, 1071], "mapped", [1103]], [[1072, 1103], "valid"], [[1104, 1104], "valid"], [[1105, 1116], "valid"], [[1117, 1117], "valid"], [[1118, 1119], "valid"], [[1120, 1120], "mapped", [1121]], [[1121, 1121], "valid"], [[1122, 1122], "mapped", [1123]], [[1123, 1123], "valid"], [[1124, 1124], "mapped", [1125]], [[1125, 1125], "valid"], [[1126, 1126], "mapped", [1127]], [[1127, 1127], "valid"], [[1128, 1128], "mapped", [1129]], [[1129, 1129], "valid"], [[1130, 1130], "mapped", [1131]], [[1131, 1131], "valid"], [[1132, 1132], "mapped", [1133]], [[1133, 1133], "valid"], [[1134, 1134], "mapped", [1135]], [[1135, 1135], "valid"], [[1136, 1136], "mapped", [1137]], [[1137, 1137], "valid"], [[1138, 1138], "mapped", [1139]], [[1139, 1139], "valid"], [[1140, 1140], "mapped", [1141]], [[1141, 1141], "valid"], [[1142, 1142], "mapped", [1143]], [[1143, 1143], "valid"], [[1144, 1144], "mapped", [1145]], [[1145, 1145], "valid"], [[1146, 1146], "mapped", [1147]], [[1147, 1147], "valid"], [[1148, 1148], "mapped", [1149]], [[1149, 1149], "valid"], [[1150, 1150], "mapped", [1151]], [[1151, 1151], "valid"], [[1152, 1152], "mapped", [1153]], [[1153, 1153], "valid"], [[1154, 1154], "valid", [], "NV8"], [[1155, 1158], "valid"], [[1159, 1159], "valid"], [[1160, 1161], "valid", [], "NV8"], [[1162, 1162], "mapped", [1163]], [[1163, 1163], "valid"], [[1164, 1164], "mapped", [1165]], [[1165, 1165], "valid"], [[1166, 1166], "mapped", [1167]], [[1167, 1167], "valid"], [[1168, 1168], "mapped", [1169]], [[1169, 1169], "valid"], [[1170, 1170], "mapped", [1171]], [[1171, 1171], "valid"], [[1172, 1172], "mapped", [1173]], [[1173, 1173], "valid"], [[1174, 1174], "mapped", [1175]], [[1175, 1175], "valid"], [[1176, 1176], "mapped", [1177]], [[1177, 1177], "valid"], [[1178, 1178], "mapped", [1179]], [[1179, 1179], "valid"], [[1180, 1180], "mapped", [1181]], [[1181, 1181], "valid"], [[1182, 1182], "mapped", [1183]], [[1183, 1183], "valid"], [[1184, 1184], "mapped", [1185]], [[1185, 1185], "valid"], [[1186, 1186], "mapped", [1187]], [[1187, 1187], "valid"], [[1188, 1188], "mapped", [1189]], [[1189, 1189], "valid"], [[1190, 1190], "mapped", [1191]], [[1191, 1191], "valid"], [[1192, 1192], "mapped", [1193]], [[1193, 1193], "valid"], [[1194, 1194], "mapped", [1195]], [[1195, 1195], "valid"], [[1196, 1196], "mapped", [1197]], [[1197, 1197], "valid"], [[1198, 1198], "mapped", [1199]], [[1199, 1199], "valid"], [[1200, 1200], "mapped", [1201]], [[1201, 1201], "valid"], [[1202, 1202], "mapped", [1203]], [[1203, 1203], "valid"], [[1204, 1204], "mapped", [1205]], [[1205, 1205], "valid"], [[1206, 1206], "mapped", [1207]], [[1207, 1207], "valid"], [[1208, 1208], "mapped", [1209]], [[1209, 1209], "valid"], [[1210, 1210], "mapped", [1211]], [[1211, 1211], "valid"], [[1212, 1212], "mapped", [1213]], [[1213, 1213], "valid"], [[1214, 1214], "mapped", [1215]], [[1215, 1215], "valid"], [[1216, 1216], "disallowed"], [[1217, 1217], "mapped", [1218]], [[1218, 1218], "valid"], [[1219, 1219], "mapped", [1220]], [[1220, 1220], "valid"], [[1221, 1221], "mapped", [1222]], [[1222, 1222], "valid"], [[1223, 1223], "mapped", [1224]], [[1224, 1224], "valid"], [[1225, 1225], "mapped", [1226]], [[1226, 1226], "valid"], [[1227, 1227], "mapped", [1228]], [[1228, 1228], "valid"], [[1229, 1229], "mapped", [1230]], [[1230, 1230], "valid"], [[1231, 1231], "valid"], [[1232, 1232], "mapped", [1233]], [[1233, 1233], "valid"], [[1234, 1234], "mapped", [1235]], [[1235, 1235], "valid"], [[1236, 1236], "mapped", [1237]], [[1237, 1237], "valid"], [[1238, 1238], "mapped", [1239]], [[1239, 1239], "valid"], [[1240, 1240], "mapped", [1241]], [[1241, 1241], "valid"], [[1242, 1242], "mapped", [1243]], [[1243, 1243], "valid"], [[1244, 1244], "mapped", [1245]], [[1245, 1245], "valid"], [[1246, 1246], "mapped", [1247]], [[1247, 1247], "valid"], [[1248, 1248], "mapped", [1249]], [[1249, 1249], "valid"], [[1250, 1250], "mapped", [1251]], [[1251, 1251], "valid"], [[1252, 1252], "mapped", [1253]], [[1253, 1253], "valid"], [[1254, 1254], "mapped", [1255]], [[1255, 1255], "valid"], [[1256, 1256], "mapped", [1257]], [[1257, 1257], "valid"], [[1258, 1258], "mapped", [1259]], [[1259, 1259], "valid"], [[1260, 1260], "mapped", [1261]], [[1261, 1261], "valid"], [[1262, 1262], "mapped", [1263]], [[1263, 1263], "valid"], [[1264, 1264], "mapped", [1265]], [[1265, 1265], "valid"], [[1266, 1266], "mapped", [1267]], [[1267, 1267], "valid"], [[1268, 1268], "mapped", [1269]], [[1269, 1269], "valid"], [[1270, 1270], "mapped", [1271]], [[1271, 1271], "valid"], [[1272, 1272], "mapped", [1273]], [[1273, 1273], "valid"], [[1274, 1274], "mapped", [1275]], [[1275, 1275], "valid"], [[1276, 1276], "mapped", [1277]], [[1277, 1277], "valid"], [[1278, 1278], "mapped", [1279]], [[1279, 1279], "valid"], [[1280, 1280], "mapped", [1281]], [[1281, 1281], "valid"], [[1282, 1282], "mapped", [1283]], [[1283, 1283], "valid"], [[1284, 1284], "mapped", [1285]], [[1285, 1285], "valid"], [[1286, 1286], "mapped", [1287]], [[1287, 1287], "valid"], [[1288, 1288], "mapped", [1289]], [[1289, 1289], "valid"], [[1290, 1290], "mapped", [1291]], [[1291, 1291], "valid"], [[1292, 1292], "mapped", [1293]], [[1293, 1293], "valid"], [[1294, 1294], "mapped", [1295]], [[1295, 1295], "valid"], [[1296, 1296], "mapped", [1297]], [[1297, 1297], "valid"], [[1298, 1298], "mapped", [1299]], [[1299, 1299], "valid"], [[1300, 1300], "mapped", [1301]], [[1301, 1301], "valid"], [[1302, 1302], "mapped", [1303]], [[1303, 1303], "valid"], [[1304, 1304], "mapped", [1305]], [[1305, 1305], "valid"], [[1306, 1306], "mapped", [1307]], [[1307, 1307], "valid"], [[1308, 1308], "mapped", [1309]], [[1309, 1309], "valid"], [[1310, 1310], "mapped", [1311]], [[1311, 1311], "valid"], [[1312, 1312], "mapped", [1313]], [[1313, 1313], "valid"], [[1314, 1314], "mapped", [1315]], [[1315, 1315], "valid"], [[1316, 1316], "mapped", [1317]], [[1317, 1317], "valid"], [[1318, 1318], "mapped", [1319]], [[1319, 1319], "valid"], [[1320, 1320], "mapped", [1321]], [[1321, 1321], "valid"], [[1322, 1322], "mapped", [1323]], [[1323, 1323], "valid"], [[1324, 1324], "mapped", [1325]], [[1325, 1325], "valid"], [[1326, 1326], "mapped", [1327]], [[1327, 1327], "valid"], [[1328, 1328], "disallowed"], [[1329, 1329], "mapped", [1377]], [[1330, 1330], "mapped", [1378]], [[1331, 1331], "mapped", [1379]], [[1332, 1332], "mapped", [1380]], [[1333, 1333], "mapped", [1381]], [[1334, 1334], "mapped", [1382]], [[1335, 1335], "mapped", [1383]], [[1336, 1336], "mapped", [1384]], [[1337, 1337], "mapped", [1385]], [[1338, 1338], "mapped", [1386]], [[1339, 1339], "mapped", [1387]], [[1340, 1340], "mapped", [1388]], [[1341, 1341], "mapped", [1389]], [[1342, 1342], "mapped", [1390]], [[1343, 1343], "mapped", [1391]], [[1344, 1344], "mapped", [1392]], [[1345, 1345], "mapped", [1393]], [[1346, 1346], "mapped", [1394]], [[1347, 1347], "mapped", [1395]], [[1348, 1348], "mapped", [1396]], [[1349, 1349], "mapped", [1397]], [[1350, 1350], "mapped", [1398]], [[1351, 1351], "mapped", [1399]], [[1352, 1352], "mapped", [1400]], [[1353, 1353], "mapped", [1401]], [[1354, 1354], "mapped", [1402]], [[1355, 1355], "mapped", [1403]], [[1356, 1356], "mapped", [1404]], [[1357, 1357], "mapped", [1405]], [[1358, 1358], "mapped", [1406]], [[1359, 1359], "mapped", [1407]], [[1360, 1360], "mapped", [1408]], [[1361, 1361], "mapped", [1409]], [[1362, 1362], "mapped", [1410]], [[1363, 1363], "mapped", [1411]], [[1364, 1364], "mapped", [1412]], [[1365, 1365], "mapped", [1413]], [[1366, 1366], "mapped", [1414]], [[1367, 1368], "disallowed"], [[1369, 1369], "valid"], [[1370, 1375], "valid", [], "NV8"], [[1376, 1376], "disallowed"], [[1377, 1414], "valid"], [[1415, 1415], "mapped", [1381, 1410]], [[1416, 1416], "disallowed"], [[1417, 1417], "valid", [], "NV8"], [[1418, 1418], "valid", [], "NV8"], [[1419, 1420], "disallowed"], [[1421, 1422], "valid", [], "NV8"], [[1423, 1423], "valid", [], "NV8"], [[1424, 1424], "disallowed"], [[1425, 1441], "valid"], [[1442, 1442], "valid"], [[1443, 1455], "valid"], [[1456, 1465], "valid"], [[1466, 1466], "valid"], [[1467, 1469], "valid"], [[1470, 1470], "valid", [], "NV8"], [[1471, 1471], "valid"], [[1472, 1472], "valid", [], "NV8"], [[1473, 1474], "valid"], [[1475, 1475], "valid", [], "NV8"], [[1476, 1476], "valid"], [[1477, 1477], "valid"], [[1478, 1478], "valid", [], "NV8"], [[1479, 1479], "valid"], [[1480, 1487], "disallowed"], [[1488, 1514], "valid"], [[1515, 1519], "disallowed"], [[1520, 1524], "valid"], [[1525, 1535], "disallowed"], [[1536, 1539], "disallowed"], [[1540, 1540], "disallowed"], [[1541, 1541], "disallowed"], [[1542, 1546], "valid", [], "NV8"], [[1547, 1547], "valid", [], "NV8"], [[1548, 1548], "valid", [], "NV8"], [[1549, 1551], "valid", [], "NV8"], [[1552, 1557], "valid"], [[1558, 1562], "valid"], [[1563, 1563], "valid", [], "NV8"], [[1564, 1564], "disallowed"], [[1565, 1565], "disallowed"], [[1566, 1566], "valid", [], "NV8"], [[1567, 1567], "valid", [], "NV8"], [[1568, 1568], "valid"], [[1569, 1594], "valid"], [[1595, 1599], "valid"], [[1600, 1600], "valid", [], "NV8"], [[1601, 1618], "valid"], [[1619, 1621], "valid"], [[1622, 1624], "valid"], [[1625, 1630], "valid"], [[1631, 1631], "valid"], [[1632, 1641], "valid"], [[1642, 1645], "valid", [], "NV8"], [[1646, 1647], "valid"], [[1648, 1652], "valid"], [[1653, 1653], "mapped", [1575, 1652]], [[1654, 1654], "mapped", [1608, 1652]], [[1655, 1655], "mapped", [1735, 1652]], [[1656, 1656], "mapped", [1610, 1652]], [[1657, 1719], "valid"], [[1720, 1721], "valid"], [[1722, 1726], "valid"], [[1727, 1727], "valid"], [[1728, 1742], "valid"], [[1743, 1743], "valid"], [[1744, 1747], "valid"], [[1748, 1748], "valid", [], "NV8"], [[1749, 1756], "valid"], [[1757, 1757], "disallowed"], [[1758, 1758], "valid", [], "NV8"], [[1759, 1768], "valid"], [[1769, 1769], "valid", [], "NV8"], [[1770, 1773], "valid"], [[1774, 1775], "valid"], [[1776, 1785], "valid"], [[1786, 1790], "valid"], [[1791, 1791], "valid"], [[1792, 1805], "valid", [], "NV8"], [[1806, 1806], "disallowed"], [[1807, 1807], "disallowed"], [[1808, 1836], "valid"], [[1837, 1839], "valid"], [[1840, 1866], "valid"], [[1867, 1868], "disallowed"], [[1869, 1871], "valid"], [[1872, 1901], "valid"], [[1902, 1919], "valid"], [[1920, 1968], "valid"], [[1969, 1969], "valid"], [[1970, 1983], "disallowed"], [[1984, 2037], "valid"], [[2038, 2042], "valid", [], "NV8"], [[2043, 2047], "disallowed"], [[2048, 2093], "valid"], [[2094, 2095], "disallowed"], [[2096, 2110], "valid", [], "NV8"], [[2111, 2111], "disallowed"], [[2112, 2139], "valid"], [[2140, 2141], "disallowed"], [[2142, 2142], "valid", [], "NV8"], [[2143, 2207], "disallowed"], [[2208, 2208], "valid"], [[2209, 2209], "valid"], [[2210, 2220], "valid"], [[2221, 2226], "valid"], [[2227, 2228], "valid"], [[2229, 2274], "disallowed"], [[2275, 2275], "valid"], [[2276, 2302], "valid"], [[2303, 2303], "valid"], [[2304, 2304], "valid"], [[2305, 2307], "valid"], [[2308, 2308], "valid"], [[2309, 2361], "valid"], [[2362, 2363], "valid"], [[2364, 2381], "valid"], [[2382, 2382], "valid"], [[2383, 2383], "valid"], [[2384, 2388], "valid"], [[2389, 2389], "valid"], [[2390, 2391], "valid"], [[2392, 2392], "mapped", [2325, 2364]], [[2393, 2393], "mapped", [2326, 2364]], [[2394, 2394], "mapped", [2327, 2364]], [[2395, 2395], "mapped", [2332, 2364]], [[2396, 2396], "mapped", [2337, 2364]], [[2397, 2397], "mapped", [2338, 2364]], [[2398, 2398], "mapped", [2347, 2364]], [[2399, 2399], "mapped", [2351, 2364]], [[2400, 2403], "valid"], [[2404, 2405], "valid", [], "NV8"], [[2406, 2415], "valid"], [[2416, 2416], "valid", [], "NV8"], [[2417, 2418], "valid"], [[2419, 2423], "valid"], [[2424, 2424], "valid"], [[2425, 2426], "valid"], [[2427, 2428], "valid"], [[2429, 2429], "valid"], [[2430, 2431], "valid"], [[2432, 2432], "valid"], [[2433, 2435], "valid"], [[2436, 2436], "disallowed"], [[2437, 2444], "valid"], [[2445, 2446], "disallowed"], [[2447, 2448], "valid"], [[2449, 2450], "disallowed"], [[2451, 2472], "valid"], [[2473, 2473], "disallowed"], [[2474, 2480], "valid"], [[2481, 2481], "disallowed"], [[2482, 2482], "valid"], [[2483, 2485], "disallowed"], [[2486, 2489], "valid"], [[2490, 2491], "disallowed"], [[2492, 2492], "valid"], [[2493, 2493], "valid"], [[2494, 2500], "valid"], [[2501, 2502], "disallowed"], [[2503, 2504], "valid"], [[2505, 2506], "disallowed"], [[2507, 2509], "valid"], [[2510, 2510], "valid"], [[2511, 2518], "disallowed"], [[2519, 2519], "valid"], [[2520, 2523], "disallowed"], [[2524, 2524], "mapped", [2465, 2492]], [[2525, 2525], "mapped", [2466, 2492]], [[2526, 2526], "disallowed"], [[2527, 2527], "mapped", [2479, 2492]], [[2528, 2531], "valid"], [[2532, 2533], "disallowed"], [[2534, 2545], "valid"], [[2546, 2554], "valid", [], "NV8"], [[2555, 2555], "valid", [], "NV8"], [[2556, 2560], "disallowed"], [[2561, 2561], "valid"], [[2562, 2562], "valid"], [[2563, 2563], "valid"], [[2564, 2564], "disallowed"], [[2565, 2570], "valid"], [[2571, 2574], "disallowed"], [[2575, 2576], "valid"], [[2577, 2578], "disallowed"], [[2579, 2600], "valid"], [[2601, 2601], "disallowed"], [[2602, 2608], "valid"], [[2609, 2609], "disallowed"], [[2610, 2610], "valid"], [[2611, 2611], "mapped", [2610, 2620]], [[2612, 2612], "disallowed"], [[2613, 2613], "valid"], [[2614, 2614], "mapped", [2616, 2620]], [[2615, 2615], "disallowed"], [[2616, 2617], "valid"], [[2618, 2619], "disallowed"], [[2620, 2620], "valid"], [[2621, 2621], "disallowed"], [[2622, 2626], "valid"], [[2627, 2630], "disallowed"], [[2631, 2632], "valid"], [[2633, 2634], "disallowed"], [[2635, 2637], "valid"], [[2638, 2640], "disallowed"], [[2641, 2641], "valid"], [[2642, 2648], "disallowed"], [[2649, 2649], "mapped", [2582, 2620]], [[2650, 2650], "mapped", [2583, 2620]], [[2651, 2651], "mapped", [2588, 2620]], [[2652, 2652], "valid"], [[2653, 2653], "disallowed"], [[2654, 2654], "mapped", [2603, 2620]], [[2655, 2661], "disallowed"], [[2662, 2676], "valid"], [[2677, 2677], "valid"], [[2678, 2688], "disallowed"], [[2689, 2691], "valid"], [[2692, 2692], "disallowed"], [[2693, 2699], "valid"], [[2700, 2700], "valid"], [[2701, 2701], "valid"], [[2702, 2702], "disallowed"], [[2703, 2705], "valid"], [[2706, 2706], "disallowed"], [[2707, 2728], "valid"], [[2729, 2729], "disallowed"], [[2730, 2736], "valid"], [[2737, 2737], "disallowed"], [[2738, 2739], "valid"], [[2740, 2740], "disallowed"], [[2741, 2745], "valid"], [[2746, 2747], "disallowed"], [[2748, 2757], "valid"], [[2758, 2758], "disallowed"], [[2759, 2761], "valid"], [[2762, 2762], "disallowed"], [[2763, 2765], "valid"], [[2766, 2767], "disallowed"], [[2768, 2768], "valid"], [[2769, 2783], "disallowed"], [[2784, 2784], "valid"], [[2785, 2787], "valid"], [[2788, 2789], "disallowed"], [[2790, 2799], "valid"], [[2800, 2800], "valid", [], "NV8"], [[2801, 2801], "valid", [], "NV8"], [[2802, 2808], "disallowed"], [[2809, 2809], "valid"], [[2810, 2816], "disallowed"], [[2817, 2819], "valid"], [[2820, 2820], "disallowed"], [[2821, 2828], "valid"], [[2829, 2830], "disallowed"], [[2831, 2832], "valid"], [[2833, 2834], "disallowed"], [[2835, 2856], "valid"], [[2857, 2857], "disallowed"], [[2858, 2864], "valid"], [[2865, 2865], "disallowed"], [[2866, 2867], "valid"], [[2868, 2868], "disallowed"], [[2869, 2869], "valid"], [[2870, 2873], "valid"], [[2874, 2875], "disallowed"], [[2876, 2883], "valid"], [[2884, 2884], "valid"], [[2885, 2886], "disallowed"], [[2887, 2888], "valid"], [[2889, 2890], "disallowed"], [[2891, 2893], "valid"], [[2894, 2901], "disallowed"], [[2902, 2903], "valid"], [[2904, 2907], "disallowed"], [[2908, 2908], "mapped", [2849, 2876]], [[2909, 2909], "mapped", [2850, 2876]], [[2910, 2910], "disallowed"], [[2911, 2913], "valid"], [[2914, 2915], "valid"], [[2916, 2917], "disallowed"], [[2918, 2927], "valid"], [[2928, 2928], "valid", [], "NV8"], [[2929, 2929], "valid"], [[2930, 2935], "valid", [], "NV8"], [[2936, 2945], "disallowed"], [[2946, 2947], "valid"], [[2948, 2948], "disallowed"], [[2949, 2954], "valid"], [[2955, 2957], "disallowed"], [[2958, 2960], "valid"], [[2961, 2961], "disallowed"], [[2962, 2965], "valid"], [[2966, 2968], "disallowed"], [[2969, 2970], "valid"], [[2971, 2971], "disallowed"], [[2972, 2972], "valid"], [[2973, 2973], "disallowed"], [[2974, 2975], "valid"], [[2976, 2978], "disallowed"], [[2979, 2980], "valid"], [[2981, 2983], "disallowed"], [[2984, 2986], "valid"], [[2987, 2989], "disallowed"], [[2990, 2997], "valid"], [[2998, 2998], "valid"], [[2999, 3001], "valid"], [[3002, 3005], "disallowed"], [[3006, 3010], "valid"], [[3011, 3013], "disallowed"], [[3014, 3016], "valid"], [[3017, 3017], "disallowed"], [[3018, 3021], "valid"], [[3022, 3023], "disallowed"], [[3024, 3024], "valid"], [[3025, 3030], "disallowed"], [[3031, 3031], "valid"], [[3032, 3045], "disallowed"], [[3046, 3046], "valid"], [[3047, 3055], "valid"], [[3056, 3058], "valid", [], "NV8"], [[3059, 3066], "valid", [], "NV8"], [[3067, 3071], "disallowed"], [[3072, 3072], "valid"], [[3073, 3075], "valid"], [[3076, 3076], "disallowed"], [[3077, 3084], "valid"], [[3085, 3085], "disallowed"], [[3086, 3088], "valid"], [[3089, 3089], "disallowed"], [[3090, 3112], "valid"], [[3113, 3113], "disallowed"], [[3114, 3123], "valid"], [[3124, 3124], "valid"], [[3125, 3129], "valid"], [[3130, 3132], "disallowed"], [[3133, 3133], "valid"], [[3134, 3140], "valid"], [[3141, 3141], "disallowed"], [[3142, 3144], "valid"], [[3145, 3145], "disallowed"], [[3146, 3149], "valid"], [[3150, 3156], "disallowed"], [[3157, 3158], "valid"], [[3159, 3159], "disallowed"], [[3160, 3161], "valid"], [[3162, 3162], "valid"], [[3163, 3167], "disallowed"], [[3168, 3169], "valid"], [[3170, 3171], "valid"], [[3172, 3173], "disallowed"], [[3174, 3183], "valid"], [[3184, 3191], "disallowed"], [[3192, 3199], "valid", [], "NV8"], [[3200, 3200], "disallowed"], [[3201, 3201], "valid"], [[3202, 3203], "valid"], [[3204, 3204], "disallowed"], [[3205, 3212], "valid"], [[3213, 3213], "disallowed"], [[3214, 3216], "valid"], [[3217, 3217], "disallowed"], [[3218, 3240], "valid"], [[3241, 3241], "disallowed"], [[3242, 3251], "valid"], [[3252, 3252], "disallowed"], [[3253, 3257], "valid"], [[3258, 3259], "disallowed"], [[3260, 3261], "valid"], [[3262, 3268], "valid"], [[3269, 3269], "disallowed"], [[3270, 3272], "valid"], [[3273, 3273], "disallowed"], [[3274, 3277], "valid"], [[3278, 3284], "disallowed"], [[3285, 3286], "valid"], [[3287, 3293], "disallowed"], [[3294, 3294], "valid"], [[3295, 3295], "disallowed"], [[3296, 3297], "valid"], [[3298, 3299], "valid"], [[3300, 3301], "disallowed"], [[3302, 3311], "valid"], [[3312, 3312], "disallowed"], [[3313, 3314], "valid"], [[3315, 3328], "disallowed"], [[3329, 3329], "valid"], [[3330, 3331], "valid"], [[3332, 3332], "disallowed"], [[3333, 3340], "valid"], [[3341, 3341], "disallowed"], [[3342, 3344], "valid"], [[3345, 3345], "disallowed"], [[3346, 3368], "valid"], [[3369, 3369], "valid"], [[3370, 3385], "valid"], [[3386, 3386], "valid"], [[3387, 3388], "disallowed"], [[3389, 3389], "valid"], [[3390, 3395], "valid"], [[3396, 3396], "valid"], [[3397, 3397], "disallowed"], [[3398, 3400], "valid"], [[3401, 3401], "disallowed"], [[3402, 3405], "valid"], [[3406, 3406], "valid"], [[3407, 3414], "disallowed"], [[3415, 3415], "valid"], [[3416, 3422], "disallowed"], [[3423, 3423], "valid"], [[3424, 3425], "valid"], [[3426, 3427], "valid"], [[3428, 3429], "disallowed"], [[3430, 3439], "valid"], [[3440, 3445], "valid", [], "NV8"], [[3446, 3448], "disallowed"], [[3449, 3449], "valid", [], "NV8"], [[3450, 3455], "valid"], [[3456, 3457], "disallowed"], [[3458, 3459], "valid"], [[3460, 3460], "disallowed"], [[3461, 3478], "valid"], [[3479, 3481], "disallowed"], [[3482, 3505], "valid"], [[3506, 3506], "disallowed"], [[3507, 3515], "valid"], [[3516, 3516], "disallowed"], [[3517, 3517], "valid"], [[3518, 3519], "disallowed"], [[3520, 3526], "valid"], [[3527, 3529], "disallowed"], [[3530, 3530], "valid"], [[3531, 3534], "disallowed"], [[3535, 3540], "valid"], [[3541, 3541], "disallowed"], [[3542, 3542], "valid"], [[3543, 3543], "disallowed"], [[3544, 3551], "valid"], [[3552, 3557], "disallowed"], [[3558, 3567], "valid"], [[3568, 3569], "disallowed"], [[3570, 3571], "valid"], [[3572, 3572], "valid", [], "NV8"], [[3573, 3584], "disallowed"], [[3585, 3634], "valid"], [[3635, 3635], "mapped", [3661, 3634]], [[3636, 3642], "valid"], [[3643, 3646], "disallowed"], [[3647, 3647], "valid", [], "NV8"], [[3648, 3662], "valid"], [[3663, 3663], "valid", [], "NV8"], [[3664, 3673], "valid"], [[3674, 3675], "valid", [], "NV8"], [[3676, 3712], "disallowed"], [[3713, 3714], "valid"], [[3715, 3715], "disallowed"], [[3716, 3716], "valid"], [[3717, 3718], "disallowed"], [[3719, 3720], "valid"], [[3721, 3721], "disallowed"], [[3722, 3722], "valid"], [[3723, 3724], "disallowed"], [[3725, 3725], "valid"], [[3726, 3731], "disallowed"], [[3732, 3735], "valid"], [[3736, 3736], "disallowed"], [[3737, 3743], "valid"], [[3744, 3744], "disallowed"], [[3745, 3747], "valid"], [[3748, 3748], "disallowed"], [[3749, 3749], "valid"], [[3750, 3750], "disallowed"], [[3751, 3751], "valid"], [[3752, 3753], "disallowed"], [[3754, 3755], "valid"], [[3756, 3756], "disallowed"], [[3757, 3762], "valid"], [[3763, 3763], "mapped", [3789, 3762]], [[3764, 3769], "valid"], [[3770, 3770], "disallowed"], [[3771, 3773], "valid"], [[3774, 3775], "disallowed"], [[3776, 3780], "valid"], [[3781, 3781], "disallowed"], [[3782, 3782], "valid"], [[3783, 3783], "disallowed"], [[3784, 3789], "valid"], [[3790, 3791], "disallowed"], [[3792, 3801], "valid"], [[3802, 3803], "disallowed"], [[3804, 3804], "mapped", [3755, 3737]], [[3805, 3805], "mapped", [3755, 3745]], [[3806, 3807], "valid"], [[3808, 3839], "disallowed"], [[3840, 3840], "valid"], [[3841, 3850], "valid", [], "NV8"], [[3851, 3851], "valid"], [[3852, 3852], "mapped", [3851]], [[3853, 3863], "valid", [], "NV8"], [[3864, 3865], "valid"], [[3866, 3871], "valid", [], "NV8"], [[3872, 3881], "valid"], [[3882, 3892], "valid", [], "NV8"], [[3893, 3893], "valid"], [[3894, 3894], "valid", [], "NV8"], [[3895, 3895], "valid"], [[3896, 3896], "valid", [], "NV8"], [[3897, 3897], "valid"], [[3898, 3901], "valid", [], "NV8"], [[3902, 3906], "valid"], [[3907, 3907], "mapped", [3906, 4023]], [[3908, 3911], "valid"], [[3912, 3912], "disallowed"], [[3913, 3916], "valid"], [[3917, 3917], "mapped", [3916, 4023]], [[3918, 3921], "valid"], [[3922, 3922], "mapped", [3921, 4023]], [[3923, 3926], "valid"], [[3927, 3927], "mapped", [3926, 4023]], [[3928, 3931], "valid"], [[3932, 3932], "mapped", [3931, 4023]], [[3933, 3944], "valid"], [[3945, 3945], "mapped", [3904, 4021]], [[3946, 3946], "valid"], [[3947, 3948], "valid"], [[3949, 3952], "disallowed"], [[3953, 3954], "valid"], [[3955, 3955], "mapped", [3953, 3954]], [[3956, 3956], "valid"], [[3957, 3957], "mapped", [3953, 3956]], [[3958, 3958], "mapped", [4018, 3968]], [[3959, 3959], "mapped", [4018, 3953, 3968]], [[3960, 3960], "mapped", [4019, 3968]], [[3961, 3961], "mapped", [4019, 3953, 3968]], [[3962, 3968], "valid"], [[3969, 3969], "mapped", [3953, 3968]], [[3970, 3972], "valid"], [[3973, 3973], "valid", [], "NV8"], [[3974, 3979], "valid"], [[3980, 3983], "valid"], [[3984, 3986], "valid"], [[3987, 3987], "mapped", [3986, 4023]], [[3988, 3989], "valid"], [[3990, 3990], "valid"], [[3991, 3991], "valid"], [[3992, 3992], "disallowed"], [[3993, 3996], "valid"], [[3997, 3997], "mapped", [3996, 4023]], [[3998, 4001], "valid"], [[4002, 4002], "mapped", [4001, 4023]], [[4003, 4006], "valid"], [[4007, 4007], "mapped", [4006, 4023]], [[4008, 4011], "valid"], [[4012, 4012], "mapped", [4011, 4023]], [[4013, 4013], "valid"], [[4014, 4016], "valid"], [[4017, 4023], "valid"], [[4024, 4024], "valid"], [[4025, 4025], "mapped", [3984, 4021]], [[4026, 4028], "valid"], [[4029, 4029], "disallowed"], [[4030, 4037], "valid", [], "NV8"], [[4038, 4038], "valid"], [[4039, 4044], "valid", [], "NV8"], [[4045, 4045], "disallowed"], [[4046, 4046], "valid", [], "NV8"], [[4047, 4047], "valid", [], "NV8"], [[4048, 4049], "valid", [], "NV8"], [[4050, 4052], "valid", [], "NV8"], [[4053, 4056], "valid", [], "NV8"], [[4057, 4058], "valid", [], "NV8"], [[4059, 4095], "disallowed"], [[4096, 4129], "valid"], [[4130, 4130], "valid"], [[4131, 4135], "valid"], [[4136, 4136], "valid"], [[4137, 4138], "valid"], [[4139, 4139], "valid"], [[4140, 4146], "valid"], [[4147, 4149], "valid"], [[4150, 4153], "valid"], [[4154, 4159], "valid"], [[4160, 4169], "valid"], [[4170, 4175], "valid", [], "NV8"], [[4176, 4185], "valid"], [[4186, 4249], "valid"], [[4250, 4253], "valid"], [[4254, 4255], "valid", [], "NV8"], [[4256, 4293], "disallowed"], [[4294, 4294], "disallowed"], [[4295, 4295], "mapped", [11559]], [[4296, 4300], "disallowed"], [[4301, 4301], "mapped", [11565]], [[4302, 4303], "disallowed"], [[4304, 4342], "valid"], [[4343, 4344], "valid"], [[4345, 4346], "valid"], [[4347, 4347], "valid", [], "NV8"], [[4348, 4348], "mapped", [4316]], [[4349, 4351], "valid"], [[4352, 4441], "valid", [], "NV8"], [[4442, 4446], "valid", [], "NV8"], [[4447, 4448], "disallowed"], [[4449, 4514], "valid", [], "NV8"], [[4515, 4519], "valid", [], "NV8"], [[4520, 4601], "valid", [], "NV8"], [[4602, 4607], "valid", [], "NV8"], [[4608, 4614], "valid"], [[4615, 4615], "valid"], [[4616, 4678], "valid"], [[4679, 4679], "valid"], [[4680, 4680], "valid"], [[4681, 4681], "disallowed"], [[4682, 4685], "valid"], [[4686, 4687], "disallowed"], [[4688, 4694], "valid"], [[4695, 4695], "disallowed"], [[4696, 4696], "valid"], [[4697, 4697], "disallowed"], [[4698, 4701], "valid"], [[4702, 4703], "disallowed"], [[4704, 4742], "valid"], [[4743, 4743], "valid"], [[4744, 4744], "valid"], [[4745, 4745], "disallowed"], [[4746, 4749], "valid"], [[4750, 4751], "disallowed"], [[4752, 4782], "valid"], [[4783, 4783], "valid"], [[4784, 4784], "valid"], [[4785, 4785], "disallowed"], [[4786, 4789], "valid"], [[4790, 4791], "disallowed"], [[4792, 4798], "valid"], [[4799, 4799], "disallowed"], [[4800, 4800], "valid"], [[4801, 4801], "disallowed"], [[4802, 4805], "valid"], [[4806, 4807], "disallowed"], [[4808, 4814], "valid"], [[4815, 4815], "valid"], [[4816, 4822], "valid"], [[4823, 4823], "disallowed"], [[4824, 4846], "valid"], [[4847, 4847], "valid"], [[4848, 4878], "valid"], [[4879, 4879], "valid"], [[4880, 4880], "valid"], [[4881, 4881], "disallowed"], [[4882, 4885], "valid"], [[4886, 4887], "disallowed"], [[4888, 4894], "valid"], [[4895, 4895], "valid"], [[4896, 4934], "valid"], [[4935, 4935], "valid"], [[4936, 4954], "valid"], [[4955, 4956], "disallowed"], [[4957, 4958], "valid"], [[4959, 4959], "valid"], [[4960, 4960], "valid", [], "NV8"], [[4961, 4988], "valid", [], "NV8"], [[4989, 4991], "disallowed"], [[4992, 5007], "valid"], [[5008, 5017], "valid", [], "NV8"], [[5018, 5023], "disallowed"], [[5024, 5108], "valid"], [[5109, 5109], "valid"], [[5110, 5111], "disallowed"], [[5112, 5112], "mapped", [5104]], [[5113, 5113], "mapped", [5105]], [[5114, 5114], "mapped", [5106]], [[5115, 5115], "mapped", [5107]], [[5116, 5116], "mapped", [5108]], [[5117, 5117], "mapped", [5109]], [[5118, 5119], "disallowed"], [[5120, 5120], "valid", [], "NV8"], [[5121, 5740], "valid"], [[5741, 5742], "valid", [], "NV8"], [[5743, 5750], "valid"], [[5751, 5759], "valid"], [[5760, 5760], "disallowed"], [[5761, 5786], "valid"], [[5787, 5788], "valid", [], "NV8"], [[5789, 5791], "disallowed"], [[5792, 5866], "valid"], [[5867, 5872], "valid", [], "NV8"], [[5873, 5880], "valid"], [[5881, 5887], "disallowed"], [[5888, 5900], "valid"], [[5901, 5901], "disallowed"], [[5902, 5908], "valid"], [[5909, 5919], "disallowed"], [[5920, 5940], "valid"], [[5941, 5942], "valid", [], "NV8"], [[5943, 5951], "disallowed"], [[5952, 5971], "valid"], [[5972, 5983], "disallowed"], [[5984, 5996], "valid"], [[5997, 5997], "disallowed"], [[5998, 6e3], "valid"], [[6001, 6001], "disallowed"], [[6002, 6003], "valid"], [[6004, 6015], "disallowed"], [[6016, 6067], "valid"], [[6068, 6069], "disallowed"], [[6070, 6099], "valid"], [[6100, 6102], "valid", [], "NV8"], [[6103, 6103], "valid"], [[6104, 6107], "valid", [], "NV8"], [[6108, 6108], "valid"], [[6109, 6109], "valid"], [[6110, 6111], "disallowed"], [[6112, 6121], "valid"], [[6122, 6127], "disallowed"], [[6128, 6137], "valid", [], "NV8"], [[6138, 6143], "disallowed"], [[6144, 6149], "valid", [], "NV8"], [[6150, 6150], "disallowed"], [[6151, 6154], "valid", [], "NV8"], [[6155, 6157], "ignored"], [[6158, 6158], "disallowed"], [[6159, 6159], "disallowed"], [[6160, 6169], "valid"], [[6170, 6175], "disallowed"], [[6176, 6263], "valid"], [[6264, 6271], "disallowed"], [[6272, 6313], "valid"], [[6314, 6314], "valid"], [[6315, 6319], "disallowed"], [[6320, 6389], "valid"], [[6390, 6399], "disallowed"], [[6400, 6428], "valid"], [[6429, 6430], "valid"], [[6431, 6431], "disallowed"], [[6432, 6443], "valid"], [[6444, 6447], "disallowed"], [[6448, 6459], "valid"], [[6460, 6463], "disallowed"], [[6464, 6464], "valid", [], "NV8"], [[6465, 6467], "disallowed"], [[6468, 6469], "valid", [], "NV8"], [[6470, 6509], "valid"], [[6510, 6511], "disallowed"], [[6512, 6516], "valid"], [[6517, 6527], "disallowed"], [[6528, 6569], "valid"], [[6570, 6571], "valid"], [[6572, 6575], "disallowed"], [[6576, 6601], "valid"], [[6602, 6607], "disallowed"], [[6608, 6617], "valid"], [[6618, 6618], "valid", [], "XV8"], [[6619, 6621], "disallowed"], [[6622, 6623], "valid", [], "NV8"], [[6624, 6655], "valid", [], "NV8"], [[6656, 6683], "valid"], [[6684, 6685], "disallowed"], [[6686, 6687], "valid", [], "NV8"], [[6688, 6750], "valid"], [[6751, 6751], "disallowed"], [[6752, 6780], "valid"], [[6781, 6782], "disallowed"], [[6783, 6793], "valid"], [[6794, 6799], "disallowed"], [[6800, 6809], "valid"], [[6810, 6815], "disallowed"], [[6816, 6822], "valid", [], "NV8"], [[6823, 6823], "valid"], [[6824, 6829], "valid", [], "NV8"], [[6830, 6831], "disallowed"], [[6832, 6845], "valid"], [[6846, 6846], "valid", [], "NV8"], [[6847, 6911], "disallowed"], [[6912, 6987], "valid"], [[6988, 6991], "disallowed"], [[6992, 7001], "valid"], [[7002, 7018], "valid", [], "NV8"], [[7019, 7027], "valid"], [[7028, 7036], "valid", [], "NV8"], [[7037, 7039], "disallowed"], [[7040, 7082], "valid"], [[7083, 7085], "valid"], [[7086, 7097], "valid"], [[7098, 7103], "valid"], [[7104, 7155], "valid"], [[7156, 7163], "disallowed"], [[7164, 7167], "valid", [], "NV8"], [[7168, 7223], "valid"], [[7224, 7226], "disallowed"], [[7227, 7231], "valid", [], "NV8"], [[7232, 7241], "valid"], [[7242, 7244], "disallowed"], [[7245, 7293], "valid"], [[7294, 7295], "valid", [], "NV8"], [[7296, 7359], "disallowed"], [[7360, 7367], "valid", [], "NV8"], [[7368, 7375], "disallowed"], [[7376, 7378], "valid"], [[7379, 7379], "valid", [], "NV8"], [[7380, 7410], "valid"], [[7411, 7414], "valid"], [[7415, 7415], "disallowed"], [[7416, 7417], "valid"], [[7418, 7423], "disallowed"], [[7424, 7467], "valid"], [[7468, 7468], "mapped", [97]], [[7469, 7469], "mapped", [230]], [[7470, 7470], "mapped", [98]], [[7471, 7471], "valid"], [[7472, 7472], "mapped", [100]], [[7473, 7473], "mapped", [101]], [[7474, 7474], "mapped", [477]], [[7475, 7475], "mapped", [103]], [[7476, 7476], "mapped", [104]], [[7477, 7477], "mapped", [105]], [[7478, 7478], "mapped", [106]], [[7479, 7479], "mapped", [107]], [[7480, 7480], "mapped", [108]], [[7481, 7481], "mapped", [109]], [[7482, 7482], "mapped", [110]], [[7483, 7483], "valid"], [[7484, 7484], "mapped", [111]], [[7485, 7485], "mapped", [547]], [[7486, 7486], "mapped", [112]], [[7487, 7487], "mapped", [114]], [[7488, 7488], "mapped", [116]], [[7489, 7489], "mapped", [117]], [[7490, 7490], "mapped", [119]], [[7491, 7491], "mapped", [97]], [[7492, 7492], "mapped", [592]], [[7493, 7493], "mapped", [593]], [[7494, 7494], "mapped", [7426]], [[7495, 7495], "mapped", [98]], [[7496, 7496], "mapped", [100]], [[7497, 7497], "mapped", [101]], [[7498, 7498], "mapped", [601]], [[7499, 7499], "mapped", [603]], [[7500, 7500], "mapped", [604]], [[7501, 7501], "mapped", [103]], [[7502, 7502], "valid"], [[7503, 7503], "mapped", [107]], [[7504, 7504], "mapped", [109]], [[7505, 7505], "mapped", [331]], [[7506, 7506], "mapped", [111]], [[7507, 7507], "mapped", [596]], [[7508, 7508], "mapped", [7446]], [[7509, 7509], "mapped", [7447]], [[7510, 7510], "mapped", [112]], [[7511, 7511], "mapped", [116]], [[7512, 7512], "mapped", [117]], [[7513, 7513], "mapped", [7453]], [[7514, 7514], "mapped", [623]], [[7515, 7515], "mapped", [118]], [[7516, 7516], "mapped", [7461]], [[7517, 7517], "mapped", [946]], [[7518, 7518], "mapped", [947]], [[7519, 7519], "mapped", [948]], [[7520, 7520], "mapped", [966]], [[7521, 7521], "mapped", [967]], [[7522, 7522], "mapped", [105]], [[7523, 7523], "mapped", [114]], [[7524, 7524], "mapped", [117]], [[7525, 7525], "mapped", [118]], [[7526, 7526], "mapped", [946]], [[7527, 7527], "mapped", [947]], [[7528, 7528], "mapped", [961]], [[7529, 7529], "mapped", [966]], [[7530, 7530], "mapped", [967]], [[7531, 7531], "valid"], [[7532, 7543], "valid"], [[7544, 7544], "mapped", [1085]], [[7545, 7578], "valid"], [[7579, 7579], "mapped", [594]], [[7580, 7580], "mapped", [99]], [[7581, 7581], "mapped", [597]], [[7582, 7582], "mapped", [240]], [[7583, 7583], "mapped", [604]], [[7584, 7584], "mapped", [102]], [[7585, 7585], "mapped", [607]], [[7586, 7586], "mapped", [609]], [[7587, 7587], "mapped", [613]], [[7588, 7588], "mapped", [616]], [[7589, 7589], "mapped", [617]], [[7590, 7590], "mapped", [618]], [[7591, 7591], "mapped", [7547]], [[7592, 7592], "mapped", [669]], [[7593, 7593], "mapped", [621]], [[7594, 7594], "mapped", [7557]], [[7595, 7595], "mapped", [671]], [[7596, 7596], "mapped", [625]], [[7597, 7597], "mapped", [624]], [[7598, 7598], "mapped", [626]], [[7599, 7599], "mapped", [627]], [[7600, 7600], "mapped", [628]], [[7601, 7601], "mapped", [629]], [[7602, 7602], "mapped", [632]], [[7603, 7603], "mapped", [642]], [[7604, 7604], "mapped", [643]], [[7605, 7605], "mapped", [427]], [[7606, 7606], "mapped", [649]], [[7607, 7607], "mapped", [650]], [[7608, 7608], "mapped", [7452]], [[7609, 7609], "mapped", [651]], [[7610, 7610], "mapped", [652]], [[7611, 7611], "mapped", [122]], [[7612, 7612], "mapped", [656]], [[7613, 7613], "mapped", [657]], [[7614, 7614], "mapped", [658]], [[7615, 7615], "mapped", [952]], [[7616, 7619], "valid"], [[7620, 7626], "valid"], [[7627, 7654], "valid"], [[7655, 7669], "valid"], [[7670, 7675], "disallowed"], [[7676, 7676], "valid"], [[7677, 7677], "valid"], [[7678, 7679], "valid"], [[7680, 7680], "mapped", [7681]], [[7681, 7681], "valid"], [[7682, 7682], "mapped", [7683]], [[7683, 7683], "valid"], [[7684, 7684], "mapped", [7685]], [[7685, 7685], "valid"], [[7686, 7686], "mapped", [7687]], [[7687, 7687], "valid"], [[7688, 7688], "mapped", [7689]], [[7689, 7689], "valid"], [[7690, 7690], "mapped", [7691]], [[7691, 7691], "valid"], [[7692, 7692], "mapped", [7693]], [[7693, 7693], "valid"], [[7694, 7694], "mapped", [7695]], [[7695, 7695], "valid"], [[7696, 7696], "mapped", [7697]], [[7697, 7697], "valid"], [[7698, 7698], "mapped", [7699]], [[7699, 7699], "valid"], [[7700, 7700], "mapped", [7701]], [[7701, 7701], "valid"], [[7702, 7702], "mapped", [7703]], [[7703, 7703], "valid"], [[7704, 7704], "mapped", [7705]], [[7705, 7705], "valid"], [[7706, 7706], "mapped", [7707]], [[7707, 7707], "valid"], [[7708, 7708], "mapped", [7709]], [[7709, 7709], "valid"], [[7710, 7710], "mapped", [7711]], [[7711, 7711], "valid"], [[7712, 7712], "mapped", [7713]], [[7713, 7713], "valid"], [[7714, 7714], "mapped", [7715]], [[7715, 7715], "valid"], [[7716, 7716], "mapped", [7717]], [[7717, 7717], "valid"], [[7718, 7718], "mapped", [7719]], [[7719, 7719], "valid"], [[7720, 7720], "mapped", [7721]], [[7721, 7721], "valid"], [[7722, 7722], "mapped", [7723]], [[7723, 7723], "valid"], [[7724, 7724], "mapped", [7725]], [[7725, 7725], "valid"], [[7726, 7726], "mapped", [7727]], [[7727, 7727], "valid"], [[7728, 7728], "mapped", [7729]], [[7729, 7729], "valid"], [[7730, 7730], "mapped", [7731]], [[7731, 7731], "valid"], [[7732, 7732], "mapped", [7733]], [[7733, 7733], "valid"], [[7734, 7734], "mapped", [7735]], [[7735, 7735], "valid"], [[7736, 7736], "mapped", [7737]], [[7737, 7737], "valid"], [[7738, 7738], "mapped", [7739]], [[7739, 7739], "valid"], [[7740, 7740], "mapped", [7741]], [[7741, 7741], "valid"], [[7742, 7742], "mapped", [7743]], [[7743, 7743], "valid"], [[7744, 7744], "mapped", [7745]], [[7745, 7745], "valid"], [[7746, 7746], "mapped", [7747]], [[7747, 7747], "valid"], [[7748, 7748], "mapped", [7749]], [[7749, 7749], "valid"], [[7750, 7750], "mapped", [7751]], [[7751, 7751], "valid"], [[7752, 7752], "mapped", [7753]], [[7753, 7753], "valid"], [[7754, 7754], "mapped", [7755]], [[7755, 7755], "valid"], [[7756, 7756], "mapped", [7757]], [[7757, 7757], "valid"], [[7758, 7758], "mapped", [7759]], [[7759, 7759], "valid"], [[7760, 7760], "mapped", [7761]], [[7761, 7761], "valid"], [[7762, 7762], "mapped", [7763]], [[7763, 7763], "valid"], [[7764, 7764], "mapped", [7765]], [[7765, 7765], "valid"], [[7766, 7766], "mapped", [7767]], [[7767, 7767], "valid"], [[7768, 7768], "mapped", [7769]], [[7769, 7769], "valid"], [[7770, 7770], "mapped", [7771]], [[7771, 7771], "valid"], [[7772, 7772], "mapped", [7773]], [[7773, 7773], "valid"], [[7774, 7774], "mapped", [7775]], [[7775, 7775], "valid"], [[7776, 7776], "mapped", [7777]], [[7777, 7777], "valid"], [[7778, 7778], "mapped", [7779]], [[7779, 7779], "valid"], [[7780, 7780], "mapped", [7781]], [[7781, 7781], "valid"], [[7782, 7782], "mapped", [7783]], [[7783, 7783], "valid"], [[7784, 7784], "mapped", [7785]], [[7785, 7785], "valid"], [[7786, 7786], "mapped", [7787]], [[7787, 7787], "valid"], [[7788, 7788], "mapped", [7789]], [[7789, 7789], "valid"], [[7790, 7790], "mapped", [7791]], [[7791, 7791], "valid"], [[7792, 7792], "mapped", [7793]], [[7793, 7793], "valid"], [[7794, 7794], "mapped", [7795]], [[7795, 7795], "valid"], [[7796, 7796], "mapped", [7797]], [[7797, 7797], "valid"], [[7798, 7798], "mapped", [7799]], [[7799, 7799], "valid"], [[7800, 7800], "mapped", [7801]], [[7801, 7801], "valid"], [[7802, 7802], "mapped", [7803]], [[7803, 7803], "valid"], [[7804, 7804], "mapped", [7805]], [[7805, 7805], "valid"], [[7806, 7806], "mapped", [7807]], [[7807, 7807], "valid"], [[7808, 7808], "mapped", [7809]], [[7809, 7809], "valid"], [[7810, 7810], "mapped", [7811]], [[7811, 7811], "valid"], [[7812, 7812], "mapped", [7813]], [[7813, 7813], "valid"], [[7814, 7814], "mapped", [7815]], [[7815, 7815], "valid"], [[7816, 7816], "mapped", [7817]], [[7817, 7817], "valid"], [[7818, 7818], "mapped", [7819]], [[7819, 7819], "valid"], [[7820, 7820], "mapped", [7821]], [[7821, 7821], "valid"], [[7822, 7822], "mapped", [7823]], [[7823, 7823], "valid"], [[7824, 7824], "mapped", [7825]], [[7825, 7825], "valid"], [[7826, 7826], "mapped", [7827]], [[7827, 7827], "valid"], [[7828, 7828], "mapped", [7829]], [[7829, 7833], "valid"], [[7834, 7834], "mapped", [97, 702]], [[7835, 7835], "mapped", [7777]], [[7836, 7837], "valid"], [[7838, 7838], "mapped", [115, 115]], [[7839, 7839], "valid"], [[7840, 7840], "mapped", [7841]], [[7841, 7841], "valid"], [[7842, 7842], "mapped", [7843]], [[7843, 7843], "valid"], [[7844, 7844], "mapped", [7845]], [[7845, 7845], "valid"], [[7846, 7846], "mapped", [7847]], [[7847, 7847], "valid"], [[7848, 7848], "mapped", [7849]], [[7849, 7849], "valid"], [[7850, 7850], "mapped", [7851]], [[7851, 7851], "valid"], [[7852, 7852], "mapped", [7853]], [[7853, 7853], "valid"], [[7854, 7854], "mapped", [7855]], [[7855, 7855], "valid"], [[7856, 7856], "mapped", [7857]], [[7857, 7857], "valid"], [[7858, 7858], "mapped", [7859]], [[7859, 7859], "valid"], [[7860, 7860], "mapped", [7861]], [[7861, 7861], "valid"], [[7862, 7862], "mapped", [7863]], [[7863, 7863], "valid"], [[7864, 7864], "mapped", [7865]], [[7865, 7865], "valid"], [[7866, 7866], "mapped", [7867]], [[7867, 7867], "valid"], [[7868, 7868], "mapped", [7869]], [[7869, 7869], "valid"], [[7870, 7870], "mapped", [7871]], [[7871, 7871], "valid"], [[7872, 7872], "mapped", [7873]], [[7873, 7873], "valid"], [[7874, 7874], "mapped", [7875]], [[7875, 7875], "valid"], [[7876, 7876], "mapped", [7877]], [[7877, 7877], "valid"], [[7878, 7878], "mapped", [7879]], [[7879, 7879], "valid"], [[7880, 7880], "mapped", [7881]], [[7881, 7881], "valid"], [[7882, 7882], "mapped", [7883]], [[7883, 7883], "valid"], [[7884, 7884], "mapped", [7885]], [[7885, 7885], "valid"], [[7886, 7886], "mapped", [7887]], [[7887, 7887], "valid"], [[7888, 7888], "mapped", [7889]], [[7889, 7889], "valid"], [[7890, 7890], "mapped", [7891]], [[7891, 7891], "valid"], [[7892, 7892], "mapped", [7893]], [[7893, 7893], "valid"], [[7894, 7894], "mapped", [7895]], [[7895, 7895], "valid"], [[7896, 7896], "mapped", [7897]], [[7897, 7897], "valid"], [[7898, 7898], "mapped", [7899]], [[7899, 7899], "valid"], [[7900, 7900], "mapped", [7901]], [[7901, 7901], "valid"], [[7902, 7902], "mapped", [7903]], [[7903, 7903], "valid"], [[7904, 7904], "mapped", [7905]], [[7905, 7905], "valid"], [[7906, 7906], "mapped", [7907]], [[7907, 7907], "valid"], [[7908, 7908], "mapped", [7909]], [[7909, 7909], "valid"], [[7910, 7910], "mapped", [7911]], [[7911, 7911], "valid"], [[7912, 7912], "mapped", [7913]], [[7913, 7913], "valid"], [[7914, 7914], "mapped", [7915]], [[7915, 7915], "valid"], [[7916, 7916], "mapped", [7917]], [[7917, 7917], "valid"], [[7918, 7918], "mapped", [7919]], [[7919, 7919], "valid"], [[7920, 7920], "mapped", [7921]], [[7921, 7921], "valid"], [[7922, 7922], "mapped", [7923]], [[7923, 7923], "valid"], [[7924, 7924], "mapped", [7925]], [[7925, 7925], "valid"], [[7926, 7926], "mapped", [7927]], [[7927, 7927], "valid"], [[7928, 7928], "mapped", [7929]], [[7929, 7929], "valid"], [[7930, 7930], "mapped", [7931]], [[7931, 7931], "valid"], [[7932, 7932], "mapped", [7933]], [[7933, 7933], "valid"], [[7934, 7934], "mapped", [7935]], [[7935, 7935], "valid"], [[7936, 7943], "valid"], [[7944, 7944], "mapped", [7936]], [[7945, 7945], "mapped", [7937]], [[7946, 7946], "mapped", [7938]], [[7947, 7947], "mapped", [7939]], [[7948, 7948], "mapped", [7940]], [[7949, 7949], "mapped", [7941]], [[7950, 7950], "mapped", [7942]], [[7951, 7951], "mapped", [7943]], [[7952, 7957], "valid"], [[7958, 7959], "disallowed"], [[7960, 7960], "mapped", [7952]], [[7961, 7961], "mapped", [7953]], [[7962, 7962], "mapped", [7954]], [[7963, 7963], "mapped", [7955]], [[7964, 7964], "mapped", [7956]], [[7965, 7965], "mapped", [7957]], [[7966, 7967], "disallowed"], [[7968, 7975], "valid"], [[7976, 7976], "mapped", [7968]], [[7977, 7977], "mapped", [7969]], [[7978, 7978], "mapped", [7970]], [[7979, 7979], "mapped", [7971]], [[7980, 7980], "mapped", [7972]], [[7981, 7981], "mapped", [7973]], [[7982, 7982], "mapped", [7974]], [[7983, 7983], "mapped", [7975]], [[7984, 7991], "valid"], [[7992, 7992], "mapped", [7984]], [[7993, 7993], "mapped", [7985]], [[7994, 7994], "mapped", [7986]], [[7995, 7995], "mapped", [7987]], [[7996, 7996], "mapped", [7988]], [[7997, 7997], "mapped", [7989]], [[7998, 7998], "mapped", [7990]], [[7999, 7999], "mapped", [7991]], [[8e3, 8005], "valid"], [[8006, 8007], "disallowed"], [[8008, 8008], "mapped", [8e3]], [[8009, 8009], "mapped", [8001]], [[8010, 8010], "mapped", [8002]], [[8011, 8011], "mapped", [8003]], [[8012, 8012], "mapped", [8004]], [[8013, 8013], "mapped", [8005]], [[8014, 8015], "disallowed"], [[8016, 8023], "valid"], [[8024, 8024], "disallowed"], [[8025, 8025], "mapped", [8017]], [[8026, 8026], "disallowed"], [[8027, 8027], "mapped", [8019]], [[8028, 8028], "disallowed"], [[8029, 8029], "mapped", [8021]], [[8030, 8030], "disallowed"], [[8031, 8031], "mapped", [8023]], [[8032, 8039], "valid"], [[8040, 8040], "mapped", [8032]], [[8041, 8041], "mapped", [8033]], [[8042, 8042], "mapped", [8034]], [[8043, 8043], "mapped", [8035]], [[8044, 8044], "mapped", [8036]], [[8045, 8045], "mapped", [8037]], [[8046, 8046], "mapped", [8038]], [[8047, 8047], "mapped", [8039]], [[8048, 8048], "valid"], [[8049, 8049], "mapped", [940]], [[8050, 8050], "valid"], [[8051, 8051], "mapped", [941]], [[8052, 8052], "valid"], [[8053, 8053], "mapped", [942]], [[8054, 8054], "valid"], [[8055, 8055], "mapped", [943]], [[8056, 8056], "valid"], [[8057, 8057], "mapped", [972]], [[8058, 8058], "valid"], [[8059, 8059], "mapped", [973]], [[8060, 8060], "valid"], [[8061, 8061], "mapped", [974]], [[8062, 8063], "disallowed"], [[8064, 8064], "mapped", [7936, 953]], [[8065, 8065], "mapped", [7937, 953]], [[8066, 8066], "mapped", [7938, 953]], [[8067, 8067], "mapped", [7939, 953]], [[8068, 8068], "mapped", [7940, 953]], [[8069, 8069], "mapped", [7941, 953]], [[8070, 8070], "mapped", [7942, 953]], [[8071, 8071], "mapped", [7943, 953]], [[8072, 8072], "mapped", [7936, 953]], [[8073, 8073], "mapped", [7937, 953]], [[8074, 8074], "mapped", [7938, 953]], [[8075, 8075], "mapped", [7939, 953]], [[8076, 8076], "mapped", [7940, 953]], [[8077, 8077], "mapped", [7941, 953]], [[8078, 8078], "mapped", [7942, 953]], [[8079, 8079], "mapped", [7943, 953]], [[8080, 8080], "mapped", [7968, 953]], [[8081, 8081], "mapped", [7969, 953]], [[8082, 8082], "mapped", [7970, 953]], [[8083, 8083], "mapped", [7971, 953]], [[8084, 8084], "mapped", [7972, 953]], [[8085, 8085], "mapped", [7973, 953]], [[8086, 8086], "mapped", [7974, 953]], [[8087, 8087], "mapped", [7975, 953]], [[8088, 8088], "mapped", [7968, 953]], [[8089, 8089], "mapped", [7969, 953]], [[8090, 8090], "mapped", [7970, 953]], [[8091, 8091], "mapped", [7971, 953]], [[8092, 8092], "mapped", [7972, 953]], [[8093, 8093], "mapped", [7973, 953]], [[8094, 8094], "mapped", [7974, 953]], [[8095, 8095], "mapped", [7975, 953]], [[8096, 8096], "mapped", [8032, 953]], [[8097, 8097], "mapped", [8033, 953]], [[8098, 8098], "mapped", [8034, 953]], [[8099, 8099], "mapped", [8035, 953]], [[8100, 8100], "mapped", [8036, 953]], [[8101, 8101], "mapped", [8037, 953]], [[8102, 8102], "mapped", [8038, 953]], [[8103, 8103], "mapped", [8039, 953]], [[8104, 8104], "mapped", [8032, 953]], [[8105, 8105], "mapped", [8033, 953]], [[8106, 8106], "mapped", [8034, 953]], [[8107, 8107], "mapped", [8035, 953]], [[8108, 8108], "mapped", [8036, 953]], [[8109, 8109], "mapped", [8037, 953]], [[8110, 8110], "mapped", [8038, 953]], [[8111, 8111], "mapped", [8039, 953]], [[8112, 8113], "valid"], [[8114, 8114], "mapped", [8048, 953]], [[8115, 8115], "mapped", [945, 953]], [[8116, 8116], "mapped", [940, 953]], [[8117, 8117], "disallowed"], [[8118, 8118], "valid"], [[8119, 8119], "mapped", [8118, 953]], [[8120, 8120], "mapped", [8112]], [[8121, 8121], "mapped", [8113]], [[8122, 8122], "mapped", [8048]], [[8123, 8123], "mapped", [940]], [[8124, 8124], "mapped", [945, 953]], [[8125, 8125], "disallowed_STD3_mapped", [32, 787]], [[8126, 8126], "mapped", [953]], [[8127, 8127], "disallowed_STD3_mapped", [32, 787]], [[8128, 8128], "disallowed_STD3_mapped", [32, 834]], [[8129, 8129], "disallowed_STD3_mapped", [32, 776, 834]], [[8130, 8130], "mapped", [8052, 953]], [[8131, 8131], "mapped", [951, 953]], [[8132, 8132], "mapped", [942, 953]], [[8133, 8133], "disallowed"], [[8134, 8134], "valid"], [[8135, 8135], "mapped", [8134, 953]], [[8136, 8136], "mapped", [8050]], [[8137, 8137], "mapped", [941]], [[8138, 8138], "mapped", [8052]], [[8139, 8139], "mapped", [942]], [[8140, 8140], "mapped", [951, 953]], [[8141, 8141], "disallowed_STD3_mapped", [32, 787, 768]], [[8142, 8142], "disallowed_STD3_mapped", [32, 787, 769]], [[8143, 8143], "disallowed_STD3_mapped", [32, 787, 834]], [[8144, 8146], "valid"], [[8147, 8147], "mapped", [912]], [[8148, 8149], "disallowed"], [[8150, 8151], "valid"], [[8152, 8152], "mapped", [8144]], [[8153, 8153], "mapped", [8145]], [[8154, 8154], "mapped", [8054]], [[8155, 8155], "mapped", [943]], [[8156, 8156], "disallowed"], [[8157, 8157], "disallowed_STD3_mapped", [32, 788, 768]], [[8158, 8158], "disallowed_STD3_mapped", [32, 788, 769]], [[8159, 8159], "disallowed_STD3_mapped", [32, 788, 834]], [[8160, 8162], "valid"], [[8163, 8163], "mapped", [944]], [[8164, 8167], "valid"], [[8168, 8168], "mapped", [8160]], [[8169, 8169], "mapped", [8161]], [[8170, 8170], "mapped", [8058]], [[8171, 8171], "mapped", [973]], [[8172, 8172], "mapped", [8165]], [[8173, 8173], "disallowed_STD3_mapped", [32, 776, 768]], [[8174, 8174], "disallowed_STD3_mapped", [32, 776, 769]], [[8175, 8175], "disallowed_STD3_mapped", [96]], [[8176, 8177], "disallowed"], [[8178, 8178], "mapped", [8060, 953]], [[8179, 8179], "mapped", [969, 953]], [[8180, 8180], "mapped", [974, 953]], [[8181, 8181], "disallowed"], [[8182, 8182], "valid"], [[8183, 8183], "mapped", [8182, 953]], [[8184, 8184], "mapped", [8056]], [[8185, 8185], "mapped", [972]], [[8186, 8186], "mapped", [8060]], [[8187, 8187], "mapped", [974]], [[8188, 8188], "mapped", [969, 953]], [[8189, 8189], "disallowed_STD3_mapped", [32, 769]], [[8190, 8190], "disallowed_STD3_mapped", [32, 788]], [[8191, 8191], "disallowed"], [[8192, 8202], "disallowed_STD3_mapped", [32]], [[8203, 8203], "ignored"], [[8204, 8205], "deviation", []], [[8206, 8207], "disallowed"], [[8208, 8208], "valid", [], "NV8"], [[8209, 8209], "mapped", [8208]], [[8210, 8214], "valid", [], "NV8"], [[8215, 8215], "disallowed_STD3_mapped", [32, 819]], [[8216, 8227], "valid", [], "NV8"], [[8228, 8230], "disallowed"], [[8231, 8231], "valid", [], "NV8"], [[8232, 8238], "disallowed"], [[8239, 8239], "disallowed_STD3_mapped", [32]], [[8240, 8242], "valid", [], "NV8"], [[8243, 8243], "mapped", [8242, 8242]], [[8244, 8244], "mapped", [8242, 8242, 8242]], [[8245, 8245], "valid", [], "NV8"], [[8246, 8246], "mapped", [8245, 8245]], [[8247, 8247], "mapped", [8245, 8245, 8245]], [[8248, 8251], "valid", [], "NV8"], [[8252, 8252], "disallowed_STD3_mapped", [33, 33]], [[8253, 8253], "valid", [], "NV8"], [[8254, 8254], "disallowed_STD3_mapped", [32, 773]], [[8255, 8262], "valid", [], "NV8"], [[8263, 8263], "disallowed_STD3_mapped", [63, 63]], [[8264, 8264], "disallowed_STD3_mapped", [63, 33]], [[8265, 8265], "disallowed_STD3_mapped", [33, 63]], [[8266, 8269], "valid", [], "NV8"], [[8270, 8274], "valid", [], "NV8"], [[8275, 8276], "valid", [], "NV8"], [[8277, 8278], "valid", [], "NV8"], [[8279, 8279], "mapped", [8242, 8242, 8242, 8242]], [[8280, 8286], "valid", [], "NV8"], [[8287, 8287], "disallowed_STD3_mapped", [32]], [[8288, 8288], "ignored"], [[8289, 8291], "disallowed"], [[8292, 8292], "ignored"], [[8293, 8293], "disallowed"], [[8294, 8297], "disallowed"], [[8298, 8303], "disallowed"], [[8304, 8304], "mapped", [48]], [[8305, 8305], "mapped", [105]], [[8306, 8307], "disallowed"], [[8308, 8308], "mapped", [52]], [[8309, 8309], "mapped", [53]], [[8310, 8310], "mapped", [54]], [[8311, 8311], "mapped", [55]], [[8312, 8312], "mapped", [56]], [[8313, 8313], "mapped", [57]], [[8314, 8314], "disallowed_STD3_mapped", [43]], [[8315, 8315], "mapped", [8722]], [[8316, 8316], "disallowed_STD3_mapped", [61]], [[8317, 8317], "disallowed_STD3_mapped", [40]], [[8318, 8318], "disallowed_STD3_mapped", [41]], [[8319, 8319], "mapped", [110]], [[8320, 8320], "mapped", [48]], [[8321, 8321], "mapped", [49]], [[8322, 8322], "mapped", [50]], [[8323, 8323], "mapped", [51]], [[8324, 8324], "mapped", [52]], [[8325, 8325], "mapped", [53]], [[8326, 8326], "mapped", [54]], [[8327, 8327], "mapped", [55]], [[8328, 8328], "mapped", [56]], [[8329, 8329], "mapped", [57]], [[8330, 8330], "disallowed_STD3_mapped", [43]], [[8331, 8331], "mapped", [8722]], [[8332, 8332], "disallowed_STD3_mapped", [61]], [[8333, 8333], "disallowed_STD3_mapped", [40]], [[8334, 8334], "disallowed_STD3_mapped", [41]], [[8335, 8335], "disallowed"], [[8336, 8336], "mapped", [97]], [[8337, 8337], "mapped", [101]], [[8338, 8338], "mapped", [111]], [[8339, 8339], "mapped", [120]], [[8340, 8340], "mapped", [601]], [[8341, 8341], "mapped", [104]], [[8342, 8342], "mapped", [107]], [[8343, 8343], "mapped", [108]], [[8344, 8344], "mapped", [109]], [[8345, 8345], "mapped", [110]], [[8346, 8346], "mapped", [112]], [[8347, 8347], "mapped", [115]], [[8348, 8348], "mapped", [116]], [[8349, 8351], "disallowed"], [[8352, 8359], "valid", [], "NV8"], [[8360, 8360], "mapped", [114, 115]], [[8361, 8362], "valid", [], "NV8"], [[8363, 8363], "valid", [], "NV8"], [[8364, 8364], "valid", [], "NV8"], [[8365, 8367], "valid", [], "NV8"], [[8368, 8369], "valid", [], "NV8"], [[8370, 8373], "valid", [], "NV8"], [[8374, 8376], "valid", [], "NV8"], [[8377, 8377], "valid", [], "NV8"], [[8378, 8378], "valid", [], "NV8"], [[8379, 8381], "valid", [], "NV8"], [[8382, 8382], "valid", [], "NV8"], [[8383, 8399], "disallowed"], [[8400, 8417], "valid", [], "NV8"], [[8418, 8419], "valid", [], "NV8"], [[8420, 8426], "valid", [], "NV8"], [[8427, 8427], "valid", [], "NV8"], [[8428, 8431], "valid", [], "NV8"], [[8432, 8432], "valid", [], "NV8"], [[8433, 8447], "disallowed"], [[8448, 8448], "disallowed_STD3_mapped", [97, 47, 99]], [[8449, 8449], "disallowed_STD3_mapped", [97, 47, 115]], [[8450, 8450], "mapped", [99]], [[8451, 8451], "mapped", [176, 99]], [[8452, 8452], "valid", [], "NV8"], [[8453, 8453], "disallowed_STD3_mapped", [99, 47, 111]], [[8454, 8454], "disallowed_STD3_mapped", [99, 47, 117]], [[8455, 8455], "mapped", [603]], [[8456, 8456], "valid", [], "NV8"], [[8457, 8457], "mapped", [176, 102]], [[8458, 8458], "mapped", [103]], [[8459, 8462], "mapped", [104]], [[8463, 8463], "mapped", [295]], [[8464, 8465], "mapped", [105]], [[8466, 8467], "mapped", [108]], [[8468, 8468], "valid", [], "NV8"], [[8469, 8469], "mapped", [110]], [[8470, 8470], "mapped", [110, 111]], [[8471, 8472], "valid", [], "NV8"], [[8473, 8473], "mapped", [112]], [[8474, 8474], "mapped", [113]], [[8475, 8477], "mapped", [114]], [[8478, 8479], "valid", [], "NV8"], [[8480, 8480], "mapped", [115, 109]], [[8481, 8481], "mapped", [116, 101, 108]], [[8482, 8482], "mapped", [116, 109]], [[8483, 8483], "valid", [], "NV8"], [[8484, 8484], "mapped", [122]], [[8485, 8485], "valid", [], "NV8"], [[8486, 8486], "mapped", [969]], [[8487, 8487], "valid", [], "NV8"], [[8488, 8488], "mapped", [122]], [[8489, 8489], "valid", [], "NV8"], [[8490, 8490], "mapped", [107]], [[8491, 8491], "mapped", [229]], [[8492, 8492], "mapped", [98]], [[8493, 8493], "mapped", [99]], [[8494, 8494], "valid", [], "NV8"], [[8495, 8496], "mapped", [101]], [[8497, 8497], "mapped", [102]], [[8498, 8498], "disallowed"], [[8499, 8499], "mapped", [109]], [[8500, 8500], "mapped", [111]], [[8501, 8501], "mapped", [1488]], [[8502, 8502], "mapped", [1489]], [[8503, 8503], "mapped", [1490]], [[8504, 8504], "mapped", [1491]], [[8505, 8505], "mapped", [105]], [[8506, 8506], "valid", [], "NV8"], [[8507, 8507], "mapped", [102, 97, 120]], [[8508, 8508], "mapped", [960]], [[8509, 8510], "mapped", [947]], [[8511, 8511], "mapped", [960]], [[8512, 8512], "mapped", [8721]], [[8513, 8516], "valid", [], "NV8"], [[8517, 8518], "mapped", [100]], [[8519, 8519], "mapped", [101]], [[8520, 8520], "mapped", [105]], [[8521, 8521], "mapped", [106]], [[8522, 8523], "valid", [], "NV8"], [[8524, 8524], "valid", [], "NV8"], [[8525, 8525], "valid", [], "NV8"], [[8526, 8526], "valid"], [[8527, 8527], "valid", [], "NV8"], [[8528, 8528], "mapped", [49, 8260, 55]], [[8529, 8529], "mapped", [49, 8260, 57]], [[8530, 8530], "mapped", [49, 8260, 49, 48]], [[8531, 8531], "mapped", [49, 8260, 51]], [[8532, 8532], "mapped", [50, 8260, 51]], [[8533, 8533], "mapped", [49, 8260, 53]], [[8534, 8534], "mapped", [50, 8260, 53]], [[8535, 8535], "mapped", [51, 8260, 53]], [[8536, 8536], "mapped", [52, 8260, 53]], [[8537, 8537], "mapped", [49, 8260, 54]], [[8538, 8538], "mapped", [53, 8260, 54]], [[8539, 8539], "mapped", [49, 8260, 56]], [[8540, 8540], "mapped", [51, 8260, 56]], [[8541, 8541], "mapped", [53, 8260, 56]], [[8542, 8542], "mapped", [55, 8260, 56]], [[8543, 8543], "mapped", [49, 8260]], [[8544, 8544], "mapped", [105]], [[8545, 8545], "mapped", [105, 105]], [[8546, 8546], "mapped", [105, 105, 105]], [[8547, 8547], "mapped", [105, 118]], [[8548, 8548], "mapped", [118]], [[8549, 8549], "mapped", [118, 105]], [[8550, 8550], "mapped", [118, 105, 105]], [[8551, 8551], "mapped", [118, 105, 105, 105]], [[8552, 8552], "mapped", [105, 120]], [[8553, 8553], "mapped", [120]], [[8554, 8554], "mapped", [120, 105]], [[8555, 8555], "mapped", [120, 105, 105]], [[8556, 8556], "mapped", [108]], [[8557, 8557], "mapped", [99]], [[8558, 8558], "mapped", [100]], [[8559, 8559], "mapped", [109]], [[8560, 8560], "mapped", [105]], [[8561, 8561], "mapped", [105, 105]], [[8562, 8562], "mapped", [105, 105, 105]], [[8563, 8563], "mapped", [105, 118]], [[8564, 8564], "mapped", [118]], [[8565, 8565], "mapped", [118, 105]], [[8566, 8566], "mapped", [118, 105, 105]], [[8567, 8567], "mapped", [118, 105, 105, 105]], [[8568, 8568], "mapped", [105, 120]], [[8569, 8569], "mapped", [120]], [[8570, 8570], "mapped", [120, 105]], [[8571, 8571], "mapped", [120, 105, 105]], [[8572, 8572], "mapped", [108]], [[8573, 8573], "mapped", [99]], [[8574, 8574], "mapped", [100]], [[8575, 8575], "mapped", [109]], [[8576, 8578], "valid", [], "NV8"], [[8579, 8579], "disallowed"], [[8580, 8580], "valid"], [[8581, 8584], "valid", [], "NV8"], [[8585, 8585], "mapped", [48, 8260, 51]], [[8586, 8587], "valid", [], "NV8"], [[8588, 8591], "disallowed"], [[8592, 8682], "valid", [], "NV8"], [[8683, 8691], "valid", [], "NV8"], [[8692, 8703], "valid", [], "NV8"], [[8704, 8747], "valid", [], "NV8"], [[8748, 8748], "mapped", [8747, 8747]], [[8749, 8749], "mapped", [8747, 8747, 8747]], [[8750, 8750], "valid", [], "NV8"], [[8751, 8751], "mapped", [8750, 8750]], [[8752, 8752], "mapped", [8750, 8750, 8750]], [[8753, 8799], "valid", [], "NV8"], [[8800, 8800], "disallowed_STD3_valid"], [[8801, 8813], "valid", [], "NV8"], [[8814, 8815], "disallowed_STD3_valid"], [[8816, 8945], "valid", [], "NV8"], [[8946, 8959], "valid", [], "NV8"], [[8960, 8960], "valid", [], "NV8"], [[8961, 8961], "valid", [], "NV8"], [[8962, 9e3], "valid", [], "NV8"], [[9001, 9001], "mapped", [12296]], [[9002, 9002], "mapped", [12297]], [[9003, 9082], "valid", [], "NV8"], [[9083, 9083], "valid", [], "NV8"], [[9084, 9084], "valid", [], "NV8"], [[9085, 9114], "valid", [], "NV8"], [[9115, 9166], "valid", [], "NV8"], [[9167, 9168], "valid", [], "NV8"], [[9169, 9179], "valid", [], "NV8"], [[9180, 9191], "valid", [], "NV8"], [[9192, 9192], "valid", [], "NV8"], [[9193, 9203], "valid", [], "NV8"], [[9204, 9210], "valid", [], "NV8"], [[9211, 9215], "disallowed"], [[9216, 9252], "valid", [], "NV8"], [[9253, 9254], "valid", [], "NV8"], [[9255, 9279], "disallowed"], [[9280, 9290], "valid", [], "NV8"], [[9291, 9311], "disallowed"], [[9312, 9312], "mapped", [49]], [[9313, 9313], "mapped", [50]], [[9314, 9314], "mapped", [51]], [[9315, 9315], "mapped", [52]], [[9316, 9316], "mapped", [53]], [[9317, 9317], "mapped", [54]], [[9318, 9318], "mapped", [55]], [[9319, 9319], "mapped", [56]], [[9320, 9320], "mapped", [57]], [[9321, 9321], "mapped", [49, 48]], [[9322, 9322], "mapped", [49, 49]], [[9323, 9323], "mapped", [49, 50]], [[9324, 9324], "mapped", [49, 51]], [[9325, 9325], "mapped", [49, 52]], [[9326, 9326], "mapped", [49, 53]], [[9327, 9327], "mapped", [49, 54]], [[9328, 9328], "mapped", [49, 55]], [[9329, 9329], "mapped", [49, 56]], [[9330, 9330], "mapped", [49, 57]], [[9331, 9331], "mapped", [50, 48]], [[9332, 9332], "disallowed_STD3_mapped", [40, 49, 41]], [[9333, 9333], "disallowed_STD3_mapped", [40, 50, 41]], [[9334, 9334], "disallowed_STD3_mapped", [40, 51, 41]], [[9335, 9335], "disallowed_STD3_mapped", [40, 52, 41]], [[9336, 9336], "disallowed_STD3_mapped", [40, 53, 41]], [[9337, 9337], "disallowed_STD3_mapped", [40, 54, 41]], [[9338, 9338], "disallowed_STD3_mapped", [40, 55, 41]], [[9339, 9339], "disallowed_STD3_mapped", [40, 56, 41]], [[9340, 9340], "disallowed_STD3_mapped", [40, 57, 41]], [[9341, 9341], "disallowed_STD3_mapped", [40, 49, 48, 41]], [[9342, 9342], "disallowed_STD3_mapped", [40, 49, 49, 41]], [[9343, 9343], "disallowed_STD3_mapped", [40, 49, 50, 41]], [[9344, 9344], "disallowed_STD3_mapped", [40, 49, 51, 41]], [[9345, 9345], "disallowed_STD3_mapped", [40, 49, 52, 41]], [[9346, 9346], "disallowed_STD3_mapped", [40, 49, 53, 41]], [[9347, 9347], "disallowed_STD3_mapped", [40, 49, 54, 41]], [[9348, 9348], "disallowed_STD3_mapped", [40, 49, 55, 41]], [[9349, 9349], "disallowed_STD3_mapped", [40, 49, 56, 41]], [[9350, 9350], "disallowed_STD3_mapped", [40, 49, 57, 41]], [[9351, 9351], "disallowed_STD3_mapped", [40, 50, 48, 41]], [[9352, 9371], "disallowed"], [[9372, 9372], "disallowed_STD3_mapped", [40, 97, 41]], [[9373, 9373], "disallowed_STD3_mapped", [40, 98, 41]], [[9374, 9374], "disallowed_STD3_mapped", [40, 99, 41]], [[9375, 9375], "disallowed_STD3_mapped", [40, 100, 41]], [[9376, 9376], "disallowed_STD3_mapped", [40, 101, 41]], [[9377, 9377], "disallowed_STD3_mapped", [40, 102, 41]], [[9378, 9378], "disallowed_STD3_mapped", [40, 103, 41]], [[9379, 9379], "disallowed_STD3_mapped", [40, 104, 41]], [[9380, 9380], "disallowed_STD3_mapped", [40, 105, 41]], [[9381, 9381], "disallowed_STD3_mapped", [40, 106, 41]], [[9382, 9382], "disallowed_STD3_mapped", [40, 107, 41]], [[9383, 9383], "disallowed_STD3_mapped", [40, 108, 41]], [[9384, 9384], "disallowed_STD3_mapped", [40, 109, 41]], [[9385, 9385], "disallowed_STD3_mapped", [40, 110, 41]], [[9386, 9386], "disallowed_STD3_mapped", [40, 111, 41]], [[9387, 9387], "disallowed_STD3_mapped", [40, 112, 41]], [[9388, 9388], "disallowed_STD3_mapped", [40, 113, 41]], [[9389, 9389], "disallowed_STD3_mapped", [40, 114, 41]], [[9390, 9390], "disallowed_STD3_mapped", [40, 115, 41]], [[9391, 9391], "disallowed_STD3_mapped", [40, 116, 41]], [[9392, 9392], "disallowed_STD3_mapped", [40, 117, 41]], [[9393, 9393], "disallowed_STD3_mapped", [40, 118, 41]], [[9394, 9394], "disallowed_STD3_mapped", [40, 119, 41]], [[9395, 9395], "disallowed_STD3_mapped", [40, 120, 41]], [[9396, 9396], "disallowed_STD3_mapped", [40, 121, 41]], [[9397, 9397], "disallowed_STD3_mapped", [40, 122, 41]], [[9398, 9398], "mapped", [97]], [[9399, 9399], "mapped", [98]], [[9400, 9400], "mapped", [99]], [[9401, 9401], "mapped", [100]], [[9402, 9402], "mapped", [101]], [[9403, 9403], "mapped", [102]], [[9404, 9404], "mapped", [103]], [[9405, 9405], "mapped", [104]], [[9406, 9406], "mapped", [105]], [[9407, 9407], "mapped", [106]], [[9408, 9408], "mapped", [107]], [[9409, 9409], "mapped", [108]], [[9410, 9410], "mapped", [109]], [[9411, 9411], "mapped", [110]], [[9412, 9412], "mapped", [111]], [[9413, 9413], "mapped", [112]], [[9414, 9414], "mapped", [113]], [[9415, 9415], "mapped", [114]], [[9416, 9416], "mapped", [115]], [[9417, 9417], "mapped", [116]], [[9418, 9418], "mapped", [117]], [[9419, 9419], "mapped", [118]], [[9420, 9420], "mapped", [119]], [[9421, 9421], "mapped", [120]], [[9422, 9422], "mapped", [121]], [[9423, 9423], "mapped", [122]], [[9424, 9424], "mapped", [97]], [[9425, 9425], "mapped", [98]], [[9426, 9426], "mapped", [99]], [[9427, 9427], "mapped", [100]], [[9428, 9428], "mapped", [101]], [[9429, 9429], "mapped", [102]], [[9430, 9430], "mapped", [103]], [[9431, 9431], "mapped", [104]], [[9432, 9432], "mapped", [105]], [[9433, 9433], "mapped", [106]], [[9434, 9434], "mapped", [107]], [[9435, 9435], "mapped", [108]], [[9436, 9436], "mapped", [109]], [[9437, 9437], "mapped", [110]], [[9438, 9438], "mapped", [111]], [[9439, 9439], "mapped", [112]], [[9440, 9440], "mapped", [113]], [[9441, 9441], "mapped", [114]], [[9442, 9442], "mapped", [115]], [[9443, 9443], "mapped", [116]], [[9444, 9444], "mapped", [117]], [[9445, 9445], "mapped", [118]], [[9446, 9446], "mapped", [119]], [[9447, 9447], "mapped", [120]], [[9448, 9448], "mapped", [121]], [[9449, 9449], "mapped", [122]], [[9450, 9450], "mapped", [48]], [[9451, 9470], "valid", [], "NV8"], [[9471, 9471], "valid", [], "NV8"], [[9472, 9621], "valid", [], "NV8"], [[9622, 9631], "valid", [], "NV8"], [[9632, 9711], "valid", [], "NV8"], [[9712, 9719], "valid", [], "NV8"], [[9720, 9727], "valid", [], "NV8"], [[9728, 9747], "valid", [], "NV8"], [[9748, 9749], "valid", [], "NV8"], [[9750, 9751], "valid", [], "NV8"], [[9752, 9752], "valid", [], "NV8"], [[9753, 9753], "valid", [], "NV8"], [[9754, 9839], "valid", [], "NV8"], [[9840, 9841], "valid", [], "NV8"], [[9842, 9853], "valid", [], "NV8"], [[9854, 9855], "valid", [], "NV8"], [[9856, 9865], "valid", [], "NV8"], [[9866, 9873], "valid", [], "NV8"], [[9874, 9884], "valid", [], "NV8"], [[9885, 9885], "valid", [], "NV8"], [[9886, 9887], "valid", [], "NV8"], [[9888, 9889], "valid", [], "NV8"], [[9890, 9905], "valid", [], "NV8"], [[9906, 9906], "valid", [], "NV8"], [[9907, 9916], "valid", [], "NV8"], [[9917, 9919], "valid", [], "NV8"], [[9920, 9923], "valid", [], "NV8"], [[9924, 9933], "valid", [], "NV8"], [[9934, 9934], "valid", [], "NV8"], [[9935, 9953], "valid", [], "NV8"], [[9954, 9954], "valid", [], "NV8"], [[9955, 9955], "valid", [], "NV8"], [[9956, 9959], "valid", [], "NV8"], [[9960, 9983], "valid", [], "NV8"], [[9984, 9984], "valid", [], "NV8"], [[9985, 9988], "valid", [], "NV8"], [[9989, 9989], "valid", [], "NV8"], [[9990, 9993], "valid", [], "NV8"], [[9994, 9995], "valid", [], "NV8"], [[9996, 10023], "valid", [], "NV8"], [[10024, 10024], "valid", [], "NV8"], [[10025, 10059], "valid", [], "NV8"], [[10060, 10060], "valid", [], "NV8"], [[10061, 10061], "valid", [], "NV8"], [[10062, 10062], "valid", [], "NV8"], [[10063, 10066], "valid", [], "NV8"], [[10067, 10069], "valid", [], "NV8"], [[10070, 10070], "valid", [], "NV8"], [[10071, 10071], "valid", [], "NV8"], [[10072, 10078], "valid", [], "NV8"], [[10079, 10080], "valid", [], "NV8"], [[10081, 10087], "valid", [], "NV8"], [[10088, 10101], "valid", [], "NV8"], [[10102, 10132], "valid", [], "NV8"], [[10133, 10135], "valid", [], "NV8"], [[10136, 10159], "valid", [], "NV8"], [[10160, 10160], "valid", [], "NV8"], [[10161, 10174], "valid", [], "NV8"], [[10175, 10175], "valid", [], "NV8"], [[10176, 10182], "valid", [], "NV8"], [[10183, 10186], "valid", [], "NV8"], [[10187, 10187], "valid", [], "NV8"], [[10188, 10188], "valid", [], "NV8"], [[10189, 10189], "valid", [], "NV8"], [[10190, 10191], "valid", [], "NV8"], [[10192, 10219], "valid", [], "NV8"], [[10220, 10223], "valid", [], "NV8"], [[10224, 10239], "valid", [], "NV8"], [[10240, 10495], "valid", [], "NV8"], [[10496, 10763], "valid", [], "NV8"], [[10764, 10764], "mapped", [8747, 8747, 8747, 8747]], [[10765, 10867], "valid", [], "NV8"], [[10868, 10868], "disallowed_STD3_mapped", [58, 58, 61]], [[10869, 10869], "disallowed_STD3_mapped", [61, 61]], [[10870, 10870], "disallowed_STD3_mapped", [61, 61, 61]], [[10871, 10971], "valid", [], "NV8"], [[10972, 10972], "mapped", [10973, 824]], [[10973, 11007], "valid", [], "NV8"], [[11008, 11021], "valid", [], "NV8"], [[11022, 11027], "valid", [], "NV8"], [[11028, 11034], "valid", [], "NV8"], [[11035, 11039], "valid", [], "NV8"], [[11040, 11043], "valid", [], "NV8"], [[11044, 11084], "valid", [], "NV8"], [[11085, 11087], "valid", [], "NV8"], [[11088, 11092], "valid", [], "NV8"], [[11093, 11097], "valid", [], "NV8"], [[11098, 11123], "valid", [], "NV8"], [[11124, 11125], "disallowed"], [[11126, 11157], "valid", [], "NV8"], [[11158, 11159], "disallowed"], [[11160, 11193], "valid", [], "NV8"], [[11194, 11196], "disallowed"], [[11197, 11208], "valid", [], "NV8"], [[11209, 11209], "disallowed"], [[11210, 11217], "valid", [], "NV8"], [[11218, 11243], "disallowed"], [[11244, 11247], "valid", [], "NV8"], [[11248, 11263], "disallowed"], [[11264, 11264], "mapped", [11312]], [[11265, 11265], "mapped", [11313]], [[11266, 11266], "mapped", [11314]], [[11267, 11267], "mapped", [11315]], [[11268, 11268], "mapped", [11316]], [[11269, 11269], "mapped", [11317]], [[11270, 11270], "mapped", [11318]], [[11271, 11271], "mapped", [11319]], [[11272, 11272], "mapped", [11320]], [[11273, 11273], "mapped", [11321]], [[11274, 11274], "mapped", [11322]], [[11275, 11275], "mapped", [11323]], [[11276, 11276], "mapped", [11324]], [[11277, 11277], "mapped", [11325]], [[11278, 11278], "mapped", [11326]], [[11279, 11279], "mapped", [11327]], [[11280, 11280], "mapped", [11328]], [[11281, 11281], "mapped", [11329]], [[11282, 11282], "mapped", [11330]], [[11283, 11283], "mapped", [11331]], [[11284, 11284], "mapped", [11332]], [[11285, 11285], "mapped", [11333]], [[11286, 11286], "mapped", [11334]], [[11287, 11287], "mapped", [11335]], [[11288, 11288], "mapped", [11336]], [[11289, 11289], "mapped", [11337]], [[11290, 11290], "mapped", [11338]], [[11291, 11291], "mapped", [11339]], [[11292, 11292], "mapped", [11340]], [[11293, 11293], "mapped", [11341]], [[11294, 11294], "mapped", [11342]], [[11295, 11295], "mapped", [11343]], [[11296, 11296], "mapped", [11344]], [[11297, 11297], "mapped", [11345]], [[11298, 11298], "mapped", [11346]], [[11299, 11299], "mapped", [11347]], [[11300, 11300], "mapped", [11348]], [[11301, 11301], "mapped", [11349]], [[11302, 11302], "mapped", [11350]], [[11303, 11303], "mapped", [11351]], [[11304, 11304], "mapped", [11352]], [[11305, 11305], "mapped", [11353]], [[11306, 11306], "mapped", [11354]], [[11307, 11307], "mapped", [11355]], [[11308, 11308], "mapped", [11356]], [[11309, 11309], "mapped", [11357]], [[11310, 11310], "mapped", [11358]], [[11311, 11311], "disallowed"], [[11312, 11358], "valid"], [[11359, 11359], "disallowed"], [[11360, 11360], "mapped", [11361]], [[11361, 11361], "valid"], [[11362, 11362], "mapped", [619]], [[11363, 11363], "mapped", [7549]], [[11364, 11364], "mapped", [637]], [[11365, 11366], "valid"], [[11367, 11367], "mapped", [11368]], [[11368, 11368], "valid"], [[11369, 11369], "mapped", [11370]], [[11370, 11370], "valid"], [[11371, 11371], "mapped", [11372]], [[11372, 11372], "valid"], [[11373, 11373], "mapped", [593]], [[11374, 11374], "mapped", [625]], [[11375, 11375], "mapped", [592]], [[11376, 11376], "mapped", [594]], [[11377, 11377], "valid"], [[11378, 11378], "mapped", [11379]], [[11379, 11379], "valid"], [[11380, 11380], "valid"], [[11381, 11381], "mapped", [11382]], [[11382, 11383], "valid"], [[11384, 11387], "valid"], [[11388, 11388], "mapped", [106]], [[11389, 11389], "mapped", [118]], [[11390, 11390], "mapped", [575]], [[11391, 11391], "mapped", [576]], [[11392, 11392], "mapped", [11393]], [[11393, 11393], "valid"], [[11394, 11394], "mapped", [11395]], [[11395, 11395], "valid"], [[11396, 11396], "mapped", [11397]], [[11397, 11397], "valid"], [[11398, 11398], "mapped", [11399]], [[11399, 11399], "valid"], [[11400, 11400], "mapped", [11401]], [[11401, 11401], "valid"], [[11402, 11402], "mapped", [11403]], [[11403, 11403], "valid"], [[11404, 11404], "mapped", [11405]], [[11405, 11405], "valid"], [[11406, 11406], "mapped", [11407]], [[11407, 11407], "valid"], [[11408, 11408], "mapped", [11409]], [[11409, 11409], "valid"], [[11410, 11410], "mapped", [11411]], [[11411, 11411], "valid"], [[11412, 11412], "mapped", [11413]], [[11413, 11413], "valid"], [[11414, 11414], "mapped", [11415]], [[11415, 11415], "valid"], [[11416, 11416], "mapped", [11417]], [[11417, 11417], "valid"], [[11418, 11418], "mapped", [11419]], [[11419, 11419], "valid"], [[11420, 11420], "mapped", [11421]], [[11421, 11421], "valid"], [[11422, 11422], "mapped", [11423]], [[11423, 11423], "valid"], [[11424, 11424], "mapped", [11425]], [[11425, 11425], "valid"], [[11426, 11426], "mapped", [11427]], [[11427, 11427], "valid"], [[11428, 11428], "mapped", [11429]], [[11429, 11429], "valid"], [[11430, 11430], "mapped", [11431]], [[11431, 11431], "valid"], [[11432, 11432], "mapped", [11433]], [[11433, 11433], "valid"], [[11434, 11434], "mapped", [11435]], [[11435, 11435], "valid"], [[11436, 11436], "mapped", [11437]], [[11437, 11437], "valid"], [[11438, 11438], "mapped", [11439]], [[11439, 11439], "valid"], [[11440, 11440], "mapped", [11441]], [[11441, 11441], "valid"], [[11442, 11442], "mapped", [11443]], [[11443, 11443], "valid"], [[11444, 11444], "mapped", [11445]], [[11445, 11445], "valid"], [[11446, 11446], "mapped", [11447]], [[11447, 11447], "valid"], [[11448, 11448], "mapped", [11449]], [[11449, 11449], "valid"], [[11450, 11450], "mapped", [11451]], [[11451, 11451], "valid"], [[11452, 11452], "mapped", [11453]], [[11453, 11453], "valid"], [[11454, 11454], "mapped", [11455]], [[11455, 11455], "valid"], [[11456, 11456], "mapped", [11457]], [[11457, 11457], "valid"], [[11458, 11458], "mapped", [11459]], [[11459, 11459], "valid"], [[11460, 11460], "mapped", [11461]], [[11461, 11461], "valid"], [[11462, 11462], "mapped", [11463]], [[11463, 11463], "valid"], [[11464, 11464], "mapped", [11465]], [[11465, 11465], "valid"], [[11466, 11466], "mapped", [11467]], [[11467, 11467], "valid"], [[11468, 11468], "mapped", [11469]], [[11469, 11469], "valid"], [[11470, 11470], "mapped", [11471]], [[11471, 11471], "valid"], [[11472, 11472], "mapped", [11473]], [[11473, 11473], "valid"], [[11474, 11474], "mapped", [11475]], [[11475, 11475], "valid"], [[11476, 11476], "mapped", [11477]], [[11477, 11477], "valid"], [[11478, 11478], "mapped", [11479]], [[11479, 11479], "valid"], [[11480, 11480], "mapped", [11481]], [[11481, 11481], "valid"], [[11482, 11482], "mapped", [11483]], [[11483, 11483], "valid"], [[11484, 11484], "mapped", [11485]], [[11485, 11485], "valid"], [[11486, 11486], "mapped", [11487]], [[11487, 11487], "valid"], [[11488, 11488], "mapped", [11489]], [[11489, 11489], "valid"], [[11490, 11490], "mapped", [11491]], [[11491, 11492], "valid"], [[11493, 11498], "valid", [], "NV8"], [[11499, 11499], "mapped", [11500]], [[11500, 11500], "valid"], [[11501, 11501], "mapped", [11502]], [[11502, 11505], "valid"], [[11506, 11506], "mapped", [11507]], [[11507, 11507], "valid"], [[11508, 11512], "disallowed"], [[11513, 11519], "valid", [], "NV8"], [[11520, 11557], "valid"], [[11558, 11558], "disallowed"], [[11559, 11559], "valid"], [[11560, 11564], "disallowed"], [[11565, 11565], "valid"], [[11566, 11567], "disallowed"], [[11568, 11621], "valid"], [[11622, 11623], "valid"], [[11624, 11630], "disallowed"], [[11631, 11631], "mapped", [11617]], [[11632, 11632], "valid", [], "NV8"], [[11633, 11646], "disallowed"], [[11647, 11647], "valid"], [[11648, 11670], "valid"], [[11671, 11679], "disallowed"], [[11680, 11686], "valid"], [[11687, 11687], "disallowed"], [[11688, 11694], "valid"], [[11695, 11695], "disallowed"], [[11696, 11702], "valid"], [[11703, 11703], "disallowed"], [[11704, 11710], "valid"], [[11711, 11711], "disallowed"], [[11712, 11718], "valid"], [[11719, 11719], "disallowed"], [[11720, 11726], "valid"], [[11727, 11727], "disallowed"], [[11728, 11734], "valid"], [[11735, 11735], "disallowed"], [[11736, 11742], "valid"], [[11743, 11743], "disallowed"], [[11744, 11775], "valid"], [[11776, 11799], "valid", [], "NV8"], [[11800, 11803], "valid", [], "NV8"], [[11804, 11805], "valid", [], "NV8"], [[11806, 11822], "valid", [], "NV8"], [[11823, 11823], "valid"], [[11824, 11824], "valid", [], "NV8"], [[11825, 11825], "valid", [], "NV8"], [[11826, 11835], "valid", [], "NV8"], [[11836, 11842], "valid", [], "NV8"], [[11843, 11903], "disallowed"], [[11904, 11929], "valid", [], "NV8"], [[11930, 11930], "disallowed"], [[11931, 11934], "valid", [], "NV8"], [[11935, 11935], "mapped", [27597]], [[11936, 12018], "valid", [], "NV8"], [[12019, 12019], "mapped", [40863]], [[12020, 12031], "disallowed"], [[12032, 12032], "mapped", [19968]], [[12033, 12033], "mapped", [20008]], [[12034, 12034], "mapped", [20022]], [[12035, 12035], "mapped", [20031]], [[12036, 12036], "mapped", [20057]], [[12037, 12037], "mapped", [20101]], [[12038, 12038], "mapped", [20108]], [[12039, 12039], "mapped", [20128]], [[12040, 12040], "mapped", [20154]], [[12041, 12041], "mapped", [20799]], [[12042, 12042], "mapped", [20837]], [[12043, 12043], "mapped", [20843]], [[12044, 12044], "mapped", [20866]], [[12045, 12045], "mapped", [20886]], [[12046, 12046], "mapped", [20907]], [[12047, 12047], "mapped", [20960]], [[12048, 12048], "mapped", [20981]], [[12049, 12049], "mapped", [20992]], [[12050, 12050], "mapped", [21147]], [[12051, 12051], "mapped", [21241]], [[12052, 12052], "mapped", [21269]], [[12053, 12053], "mapped", [21274]], [[12054, 12054], "mapped", [21304]], [[12055, 12055], "mapped", [21313]], [[12056, 12056], "mapped", [21340]], [[12057, 12057], "mapped", [21353]], [[12058, 12058], "mapped", [21378]], [[12059, 12059], "mapped", [21430]], [[12060, 12060], "mapped", [21448]], [[12061, 12061], "mapped", [21475]], [[12062, 12062], "mapped", [22231]], [[12063, 12063], "mapped", [22303]], [[12064, 12064], "mapped", [22763]], [[12065, 12065], "mapped", [22786]], [[12066, 12066], "mapped", [22794]], [[12067, 12067], "mapped", [22805]], [[12068, 12068], "mapped", [22823]], [[12069, 12069], "mapped", [22899]], [[12070, 12070], "mapped", [23376]], [[12071, 12071], "mapped", [23424]], [[12072, 12072], "mapped", [23544]], [[12073, 12073], "mapped", [23567]], [[12074, 12074], "mapped", [23586]], [[12075, 12075], "mapped", [23608]], [[12076, 12076], "mapped", [23662]], [[12077, 12077], "mapped", [23665]], [[12078, 12078], "mapped", [24027]], [[12079, 12079], "mapped", [24037]], [[12080, 12080], "mapped", [24049]], [[12081, 12081], "mapped", [24062]], [[12082, 12082], "mapped", [24178]], [[12083, 12083], "mapped", [24186]], [[12084, 12084], "mapped", [24191]], [[12085, 12085], "mapped", [24308]], [[12086, 12086], "mapped", [24318]], [[12087, 12087], "mapped", [24331]], [[12088, 12088], "mapped", [24339]], [[12089, 12089], "mapped", [24400]], [[12090, 12090], "mapped", [24417]], [[12091, 12091], "mapped", [24435]], [[12092, 12092], "mapped", [24515]], [[12093, 12093], "mapped", [25096]], [[12094, 12094], "mapped", [25142]], [[12095, 12095], "mapped", [25163]], [[12096, 12096], "mapped", [25903]], [[12097, 12097], "mapped", [25908]], [[12098, 12098], "mapped", [25991]], [[12099, 12099], "mapped", [26007]], [[12100, 12100], "mapped", [26020]], [[12101, 12101], "mapped", [26041]], [[12102, 12102], "mapped", [26080]], [[12103, 12103], "mapped", [26085]], [[12104, 12104], "mapped", [26352]], [[12105, 12105], "mapped", [26376]], [[12106, 12106], "mapped", [26408]], [[12107, 12107], "mapped", [27424]], [[12108, 12108], "mapped", [27490]], [[12109, 12109], "mapped", [27513]], [[12110, 12110], "mapped", [27571]], [[12111, 12111], "mapped", [27595]], [[12112, 12112], "mapped", [27604]], [[12113, 12113], "mapped", [27611]], [[12114, 12114], "mapped", [27663]], [[12115, 12115], "mapped", [27668]], [[12116, 12116], "mapped", [27700]], [[12117, 12117], "mapped", [28779]], [[12118, 12118], "mapped", [29226]], [[12119, 12119], "mapped", [29238]], [[12120, 12120], "mapped", [29243]], [[12121, 12121], "mapped", [29247]], [[12122, 12122], "mapped", [29255]], [[12123, 12123], "mapped", [29273]], [[12124, 12124], "mapped", [29275]], [[12125, 12125], "mapped", [29356]], [[12126, 12126], "mapped", [29572]], [[12127, 12127], "mapped", [29577]], [[12128, 12128], "mapped", [29916]], [[12129, 12129], "mapped", [29926]], [[12130, 12130], "mapped", [29976]], [[12131, 12131], "mapped", [29983]], [[12132, 12132], "mapped", [29992]], [[12133, 12133], "mapped", [3e4]], [[12134, 12134], "mapped", [30091]], [[12135, 12135], "mapped", [30098]], [[12136, 12136], "mapped", [30326]], [[12137, 12137], "mapped", [30333]], [[12138, 12138], "mapped", [30382]], [[12139, 12139], "mapped", [30399]], [[12140, 12140], "mapped", [30446]], [[12141, 12141], "mapped", [30683]], [[12142, 12142], "mapped", [30690]], [[12143, 12143], "mapped", [30707]], [[12144, 12144], "mapped", [31034]], [[12145, 12145], "mapped", [31160]], [[12146, 12146], "mapped", [31166]], [[12147, 12147], "mapped", [31348]], [[12148, 12148], "mapped", [31435]], [[12149, 12149], "mapped", [31481]], [[12150, 12150], "mapped", [31859]], [[12151, 12151], "mapped", [31992]], [[12152, 12152], "mapped", [32566]], [[12153, 12153], "mapped", [32593]], [[12154, 12154], "mapped", [32650]], [[12155, 12155], "mapped", [32701]], [[12156, 12156], "mapped", [32769]], [[12157, 12157], "mapped", [32780]], [[12158, 12158], "mapped", [32786]], [[12159, 12159], "mapped", [32819]], [[12160, 12160], "mapped", [32895]], [[12161, 12161], "mapped", [32905]], [[12162, 12162], "mapped", [33251]], [[12163, 12163], "mapped", [33258]], [[12164, 12164], "mapped", [33267]], [[12165, 12165], "mapped", [33276]], [[12166, 12166], "mapped", [33292]], [[12167, 12167], "mapped", [33307]], [[12168, 12168], "mapped", [33311]], [[12169, 12169], "mapped", [33390]], [[12170, 12170], "mapped", [33394]], [[12171, 12171], "mapped", [33400]], [[12172, 12172], "mapped", [34381]], [[12173, 12173], "mapped", [34411]], [[12174, 12174], "mapped", [34880]], [[12175, 12175], "mapped", [34892]], [[12176, 12176], "mapped", [34915]], [[12177, 12177], "mapped", [35198]], [[12178, 12178], "mapped", [35211]], [[12179, 12179], "mapped", [35282]], [[12180, 12180], "mapped", [35328]], [[12181, 12181], "mapped", [35895]], [[12182, 12182], "mapped", [35910]], [[12183, 12183], "mapped", [35925]], [[12184, 12184], "mapped", [35960]], [[12185, 12185], "mapped", [35997]], [[12186, 12186], "mapped", [36196]], [[12187, 12187], "mapped", [36208]], [[12188, 12188], "mapped", [36275]], [[12189, 12189], "mapped", [36523]], [[12190, 12190], "mapped", [36554]], [[12191, 12191], "mapped", [36763]], [[12192, 12192], "mapped", [36784]], [[12193, 12193], "mapped", [36789]], [[12194, 12194], "mapped", [37009]], [[12195, 12195], "mapped", [37193]], [[12196, 12196], "mapped", [37318]], [[12197, 12197], "mapped", [37324]], [[12198, 12198], "mapped", [37329]], [[12199, 12199], "mapped", [38263]], [[12200, 12200], "mapped", [38272]], [[12201, 12201], "mapped", [38428]], [[12202, 12202], "mapped", [38582]], [[12203, 12203], "mapped", [38585]], [[12204, 12204], "mapped", [38632]], [[12205, 12205], "mapped", [38737]], [[12206, 12206], "mapped", [38750]], [[12207, 12207], "mapped", [38754]], [[12208, 12208], "mapped", [38761]], [[12209, 12209], "mapped", [38859]], [[12210, 12210], "mapped", [38893]], [[12211, 12211], "mapped", [38899]], [[12212, 12212], "mapped", [38913]], [[12213, 12213], "mapped", [39080]], [[12214, 12214], "mapped", [39131]], [[12215, 12215], "mapped", [39135]], [[12216, 12216], "mapped", [39318]], [[12217, 12217], "mapped", [39321]], [[12218, 12218], "mapped", [39340]], [[12219, 12219], "mapped", [39592]], [[12220, 12220], "mapped", [39640]], [[12221, 12221], "mapped", [39647]], [[12222, 12222], "mapped", [39717]], [[12223, 12223], "mapped", [39727]], [[12224, 12224], "mapped", [39730]], [[12225, 12225], "mapped", [39740]], [[12226, 12226], "mapped", [39770]], [[12227, 12227], "mapped", [40165]], [[12228, 12228], "mapped", [40565]], [[12229, 12229], "mapped", [40575]], [[12230, 12230], "mapped", [40613]], [[12231, 12231], "mapped", [40635]], [[12232, 12232], "mapped", [40643]], [[12233, 12233], "mapped", [40653]], [[12234, 12234], "mapped", [40657]], [[12235, 12235], "mapped", [40697]], [[12236, 12236], "mapped", [40701]], [[12237, 12237], "mapped", [40718]], [[12238, 12238], "mapped", [40723]], [[12239, 12239], "mapped", [40736]], [[12240, 12240], "mapped", [40763]], [[12241, 12241], "mapped", [40778]], [[12242, 12242], "mapped", [40786]], [[12243, 12243], "mapped", [40845]], [[12244, 12244], "mapped", [40860]], [[12245, 12245], "mapped", [40864]], [[12246, 12271], "disallowed"], [[12272, 12283], "disallowed"], [[12284, 12287], "disallowed"], [[12288, 12288], "disallowed_STD3_mapped", [32]], [[12289, 12289], "valid", [], "NV8"], [[12290, 12290], "mapped", [46]], [[12291, 12292], "valid", [], "NV8"], [[12293, 12295], "valid"], [[12296, 12329], "valid", [], "NV8"], [[12330, 12333], "valid"], [[12334, 12341], "valid", [], "NV8"], [[12342, 12342], "mapped", [12306]], [[12343, 12343], "valid", [], "NV8"], [[12344, 12344], "mapped", [21313]], [[12345, 12345], "mapped", [21316]], [[12346, 12346], "mapped", [21317]], [[12347, 12347], "valid", [], "NV8"], [[12348, 12348], "valid"], [[12349, 12349], "valid", [], "NV8"], [[12350, 12350], "valid", [], "NV8"], [[12351, 12351], "valid", [], "NV8"], [[12352, 12352], "disallowed"], [[12353, 12436], "valid"], [[12437, 12438], "valid"], [[12439, 12440], "disallowed"], [[12441, 12442], "valid"], [[12443, 12443], "disallowed_STD3_mapped", [32, 12441]], [[12444, 12444], "disallowed_STD3_mapped", [32, 12442]], [[12445, 12446], "valid"], [[12447, 12447], "mapped", [12424, 12426]], [[12448, 12448], "valid", [], "NV8"], [[12449, 12542], "valid"], [[12543, 12543], "mapped", [12467, 12488]], [[12544, 12548], "disallowed"], [[12549, 12588], "valid"], [[12589, 12589], "valid"], [[12590, 12592], "disallowed"], [[12593, 12593], "mapped", [4352]], [[12594, 12594], "mapped", [4353]], [[12595, 12595], "mapped", [4522]], [[12596, 12596], "mapped", [4354]], [[12597, 12597], "mapped", [4524]], [[12598, 12598], "mapped", [4525]], [[12599, 12599], "mapped", [4355]], [[12600, 12600], "mapped", [4356]], [[12601, 12601], "mapped", [4357]], [[12602, 12602], "mapped", [4528]], [[12603, 12603], "mapped", [4529]], [[12604, 12604], "mapped", [4530]], [[12605, 12605], "mapped", [4531]], [[12606, 12606], "mapped", [4532]], [[12607, 12607], "mapped", [4533]], [[12608, 12608], "mapped", [4378]], [[12609, 12609], "mapped", [4358]], [[12610, 12610], "mapped", [4359]], [[12611, 12611], "mapped", [4360]], [[12612, 12612], "mapped", [4385]], [[12613, 12613], "mapped", [4361]], [[12614, 12614], "mapped", [4362]], [[12615, 12615], "mapped", [4363]], [[12616, 12616], "mapped", [4364]], [[12617, 12617], "mapped", [4365]], [[12618, 12618], "mapped", [4366]], [[12619, 12619], "mapped", [4367]], [[12620, 12620], "mapped", [4368]], [[12621, 12621], "mapped", [4369]], [[12622, 12622], "mapped", [4370]], [[12623, 12623], "mapped", [4449]], [[12624, 12624], "mapped", [4450]], [[12625, 12625], "mapped", [4451]], [[12626, 12626], "mapped", [4452]], [[12627, 12627], "mapped", [4453]], [[12628, 12628], "mapped", [4454]], [[12629, 12629], "mapped", [4455]], [[12630, 12630], "mapped", [4456]], [[12631, 12631], "mapped", [4457]], [[12632, 12632], "mapped", [4458]], [[12633, 12633], "mapped", [4459]], [[12634, 12634], "mapped", [4460]], [[12635, 12635], "mapped", [4461]], [[12636, 12636], "mapped", [4462]], [[12637, 12637], "mapped", [4463]], [[12638, 12638], "mapped", [4464]], [[12639, 12639], "mapped", [4465]], [[12640, 12640], "mapped", [4466]], [[12641, 12641], "mapped", [4467]], [[12642, 12642], "mapped", [4468]], [[12643, 12643], "mapped", [4469]], [[12644, 12644], "disallowed"], [[12645, 12645], "mapped", [4372]], [[12646, 12646], "mapped", [4373]], [[12647, 12647], "mapped", [4551]], [[12648, 12648], "mapped", [4552]], [[12649, 12649], "mapped", [4556]], [[12650, 12650], "mapped", [4558]], [[12651, 12651], "mapped", [4563]], [[12652, 12652], "mapped", [4567]], [[12653, 12653], "mapped", [4569]], [[12654, 12654], "mapped", [4380]], [[12655, 12655], "mapped", [4573]], [[12656, 12656], "mapped", [4575]], [[12657, 12657], "mapped", [4381]], [[12658, 12658], "mapped", [4382]], [[12659, 12659], "mapped", [4384]], [[12660, 12660], "mapped", [4386]], [[12661, 12661], "mapped", [4387]], [[12662, 12662], "mapped", [4391]], [[12663, 12663], "mapped", [4393]], [[12664, 12664], "mapped", [4395]], [[12665, 12665], "mapped", [4396]], [[12666, 12666], "mapped", [4397]], [[12667, 12667], "mapped", [4398]], [[12668, 12668], "mapped", [4399]], [[12669, 12669], "mapped", [4402]], [[12670, 12670], "mapped", [4406]], [[12671, 12671], "mapped", [4416]], [[12672, 12672], "mapped", [4423]], [[12673, 12673], "mapped", [4428]], [[12674, 12674], "mapped", [4593]], [[12675, 12675], "mapped", [4594]], [[12676, 12676], "mapped", [4439]], [[12677, 12677], "mapped", [4440]], [[12678, 12678], "mapped", [4441]], [[12679, 12679], "mapped", [4484]], [[12680, 12680], "mapped", [4485]], [[12681, 12681], "mapped", [4488]], [[12682, 12682], "mapped", [4497]], [[12683, 12683], "mapped", [4498]], [[12684, 12684], "mapped", [4500]], [[12685, 12685], "mapped", [4510]], [[12686, 12686], "mapped", [4513]], [[12687, 12687], "disallowed"], [[12688, 12689], "valid", [], "NV8"], [[12690, 12690], "mapped", [19968]], [[12691, 12691], "mapped", [20108]], [[12692, 12692], "mapped", [19977]], [[12693, 12693], "mapped", [22235]], [[12694, 12694], "mapped", [19978]], [[12695, 12695], "mapped", [20013]], [[12696, 12696], "mapped", [19979]], [[12697, 12697], "mapped", [30002]], [[12698, 12698], "mapped", [20057]], [[12699, 12699], "mapped", [19993]], [[12700, 12700], "mapped", [19969]], [[12701, 12701], "mapped", [22825]], [[12702, 12702], "mapped", [22320]], [[12703, 12703], "mapped", [20154]], [[12704, 12727], "valid"], [[12728, 12730], "valid"], [[12731, 12735], "disallowed"], [[12736, 12751], "valid", [], "NV8"], [[12752, 12771], "valid", [], "NV8"], [[12772, 12783], "disallowed"], [[12784, 12799], "valid"], [[12800, 12800], "disallowed_STD3_mapped", [40, 4352, 41]], [[12801, 12801], "disallowed_STD3_mapped", [40, 4354, 41]], [[12802, 12802], "disallowed_STD3_mapped", [40, 4355, 41]], [[12803, 12803], "disallowed_STD3_mapped", [40, 4357, 41]], [[12804, 12804], "disallowed_STD3_mapped", [40, 4358, 41]], [[12805, 12805], "disallowed_STD3_mapped", [40, 4359, 41]], [[12806, 12806], "disallowed_STD3_mapped", [40, 4361, 41]], [[12807, 12807], "disallowed_STD3_mapped", [40, 4363, 41]], [[12808, 12808], "disallowed_STD3_mapped", [40, 4364, 41]], [[12809, 12809], "disallowed_STD3_mapped", [40, 4366, 41]], [[12810, 12810], "disallowed_STD3_mapped", [40, 4367, 41]], [[12811, 12811], "disallowed_STD3_mapped", [40, 4368, 41]], [[12812, 12812], "disallowed_STD3_mapped", [40, 4369, 41]], [[12813, 12813], "disallowed_STD3_mapped", [40, 4370, 41]], [[12814, 12814], "disallowed_STD3_mapped", [40, 44032, 41]], [[12815, 12815], "disallowed_STD3_mapped", [40, 45208, 41]], [[12816, 12816], "disallowed_STD3_mapped", [40, 45796, 41]], [[12817, 12817], "disallowed_STD3_mapped", [40, 46972, 41]], [[12818, 12818], "disallowed_STD3_mapped", [40, 47560, 41]], [[12819, 12819], "disallowed_STD3_mapped", [40, 48148, 41]], [[12820, 12820], "disallowed_STD3_mapped", [40, 49324, 41]], [[12821, 12821], "disallowed_STD3_mapped", [40, 50500, 41]], [[12822, 12822], "disallowed_STD3_mapped", [40, 51088, 41]], [[12823, 12823], "disallowed_STD3_mapped", [40, 52264, 41]], [[12824, 12824], "disallowed_STD3_mapped", [40, 52852, 41]], [[12825, 12825], "disallowed_STD3_mapped", [40, 53440, 41]], [[12826, 12826], "disallowed_STD3_mapped", [40, 54028, 41]], [[12827, 12827], "disallowed_STD3_mapped", [40, 54616, 41]], [[12828, 12828], "disallowed_STD3_mapped", [40, 51452, 41]], [[12829, 12829], "disallowed_STD3_mapped", [40, 50724, 51204, 41]], [[12830, 12830], "disallowed_STD3_mapped", [40, 50724, 54980, 41]], [[12831, 12831], "disallowed"], [[12832, 12832], "disallowed_STD3_mapped", [40, 19968, 41]], [[12833, 12833], "disallowed_STD3_mapped", [40, 20108, 41]], [[12834, 12834], "disallowed_STD3_mapped", [40, 19977, 41]], [[12835, 12835], "disallowed_STD3_mapped", [40, 22235, 41]], [[12836, 12836], "disallowed_STD3_mapped", [40, 20116, 41]], [[12837, 12837], "disallowed_STD3_mapped", [40, 20845, 41]], [[12838, 12838], "disallowed_STD3_mapped", [40, 19971, 41]], [[12839, 12839], "disallowed_STD3_mapped", [40, 20843, 41]], [[12840, 12840], "disallowed_STD3_mapped", [40, 20061, 41]], [[12841, 12841], "disallowed_STD3_mapped", [40, 21313, 41]], [[12842, 12842], "disallowed_STD3_mapped", [40, 26376, 41]], [[12843, 12843], "disallowed_STD3_mapped", [40, 28779, 41]], [[12844, 12844], "disallowed_STD3_mapped", [40, 27700, 41]], [[12845, 12845], "disallowed_STD3_mapped", [40, 26408, 41]], [[12846, 12846], "disallowed_STD3_mapped", [40, 37329, 41]], [[12847, 12847], "disallowed_STD3_mapped", [40, 22303, 41]], [[12848, 12848], "disallowed_STD3_mapped", [40, 26085, 41]], [[12849, 12849], "disallowed_STD3_mapped", [40, 26666, 41]], [[12850, 12850], "disallowed_STD3_mapped", [40, 26377, 41]], [[12851, 12851], "disallowed_STD3_mapped", [40, 31038, 41]], [[12852, 12852], "disallowed_STD3_mapped", [40, 21517, 41]], [[12853, 12853], "disallowed_STD3_mapped", [40, 29305, 41]], [[12854, 12854], "disallowed_STD3_mapped", [40, 36001, 41]], [[12855, 12855], "disallowed_STD3_mapped", [40, 31069, 41]], [[12856, 12856], "disallowed_STD3_mapped", [40, 21172, 41]], [[12857, 12857], "disallowed_STD3_mapped", [40, 20195, 41]], [[12858, 12858], "disallowed_STD3_mapped", [40, 21628, 41]], [[12859, 12859], "disallowed_STD3_mapped", [40, 23398, 41]], [[12860, 12860], "disallowed_STD3_mapped", [40, 30435, 41]], [[12861, 12861], "disallowed_STD3_mapped", [40, 20225, 41]], [[12862, 12862], "disallowed_STD3_mapped", [40, 36039, 41]], [[12863, 12863], "disallowed_STD3_mapped", [40, 21332, 41]], [[12864, 12864], "disallowed_STD3_mapped", [40, 31085, 41]], [[12865, 12865], "disallowed_STD3_mapped", [40, 20241, 41]], [[12866, 12866], "disallowed_STD3_mapped", [40, 33258, 41]], [[12867, 12867], "disallowed_STD3_mapped", [40, 33267, 41]], [[12868, 12868], "mapped", [21839]], [[12869, 12869], "mapped", [24188]], [[12870, 12870], "mapped", [25991]], [[12871, 12871], "mapped", [31631]], [[12872, 12879], "valid", [], "NV8"], [[12880, 12880], "mapped", [112, 116, 101]], [[12881, 12881], "mapped", [50, 49]], [[12882, 12882], "mapped", [50, 50]], [[12883, 12883], "mapped", [50, 51]], [[12884, 12884], "mapped", [50, 52]], [[12885, 12885], "mapped", [50, 53]], [[12886, 12886], "mapped", [50, 54]], [[12887, 12887], "mapped", [50, 55]], [[12888, 12888], "mapped", [50, 56]], [[12889, 12889], "mapped", [50, 57]], [[12890, 12890], "mapped", [51, 48]], [[12891, 12891], "mapped", [51, 49]], [[12892, 12892], "mapped", [51, 50]], [[12893, 12893], "mapped", [51, 51]], [[12894, 12894], "mapped", [51, 52]], [[12895, 12895], "mapped", [51, 53]], [[12896, 12896], "mapped", [4352]], [[12897, 12897], "mapped", [4354]], [[12898, 12898], "mapped", [4355]], [[12899, 12899], "mapped", [4357]], [[12900, 12900], "mapped", [4358]], [[12901, 12901], "mapped", [4359]], [[12902, 12902], "mapped", [4361]], [[12903, 12903], "mapped", [4363]], [[12904, 12904], "mapped", [4364]], [[12905, 12905], "mapped", [4366]], [[12906, 12906], "mapped", [4367]], [[12907, 12907], "mapped", [4368]], [[12908, 12908], "mapped", [4369]], [[12909, 12909], "mapped", [4370]], [[12910, 12910], "mapped", [44032]], [[12911, 12911], "mapped", [45208]], [[12912, 12912], "mapped", [45796]], [[12913, 12913], "mapped", [46972]], [[12914, 12914], "mapped", [47560]], [[12915, 12915], "mapped", [48148]], [[12916, 12916], "mapped", [49324]], [[12917, 12917], "mapped", [50500]], [[12918, 12918], "mapped", [51088]], [[12919, 12919], "mapped", [52264]], [[12920, 12920], "mapped", [52852]], [[12921, 12921], "mapped", [53440]], [[12922, 12922], "mapped", [54028]], [[12923, 12923], "mapped", [54616]], [[12924, 12924], "mapped", [52280, 44256]], [[12925, 12925], "mapped", [51452, 51032]], [[12926, 12926], "mapped", [50864]], [[12927, 12927], "valid", [], "NV8"], [[12928, 12928], "mapped", [19968]], [[12929, 12929], "mapped", [20108]], [[12930, 12930], "mapped", [19977]], [[12931, 12931], "mapped", [22235]], [[12932, 12932], "mapped", [20116]], [[12933, 12933], "mapped", [20845]], [[12934, 12934], "mapped", [19971]], [[12935, 12935], "mapped", [20843]], [[12936, 12936], "mapped", [20061]], [[12937, 12937], "mapped", [21313]], [[12938, 12938], "mapped", [26376]], [[12939, 12939], "mapped", [28779]], [[12940, 12940], "mapped", [27700]], [[12941, 12941], "mapped", [26408]], [[12942, 12942], "mapped", [37329]], [[12943, 12943], "mapped", [22303]], [[12944, 12944], "mapped", [26085]], [[12945, 12945], "mapped", [26666]], [[12946, 12946], "mapped", [26377]], [[12947, 12947], "mapped", [31038]], [[12948, 12948], "mapped", [21517]], [[12949, 12949], "mapped", [29305]], [[12950, 12950], "mapped", [36001]], [[12951, 12951], "mapped", [31069]], [[12952, 12952], "mapped", [21172]], [[12953, 12953], "mapped", [31192]], [[12954, 12954], "mapped", [30007]], [[12955, 12955], "mapped", [22899]], [[12956, 12956], "mapped", [36969]], [[12957, 12957], "mapped", [20778]], [[12958, 12958], "mapped", [21360]], [[12959, 12959], "mapped", [27880]], [[12960, 12960], "mapped", [38917]], [[12961, 12961], "mapped", [20241]], [[12962, 12962], "mapped", [20889]], [[12963, 12963], "mapped", [27491]], [[12964, 12964], "mapped", [19978]], [[12965, 12965], "mapped", [20013]], [[12966, 12966], "mapped", [19979]], [[12967, 12967], "mapped", [24038]], [[12968, 12968], "mapped", [21491]], [[12969, 12969], "mapped", [21307]], [[12970, 12970], "mapped", [23447]], [[12971, 12971], "mapped", [23398]], [[12972, 12972], "mapped", [30435]], [[12973, 12973], "mapped", [20225]], [[12974, 12974], "mapped", [36039]], [[12975, 12975], "mapped", [21332]], [[12976, 12976], "mapped", [22812]], [[12977, 12977], "mapped", [51, 54]], [[12978, 12978], "mapped", [51, 55]], [[12979, 12979], "mapped", [51, 56]], [[12980, 12980], "mapped", [51, 57]], [[12981, 12981], "mapped", [52, 48]], [[12982, 12982], "mapped", [52, 49]], [[12983, 12983], "mapped", [52, 50]], [[12984, 12984], "mapped", [52, 51]], [[12985, 12985], "mapped", [52, 52]], [[12986, 12986], "mapped", [52, 53]], [[12987, 12987], "mapped", [52, 54]], [[12988, 12988], "mapped", [52, 55]], [[12989, 12989], "mapped", [52, 56]], [[12990, 12990], "mapped", [52, 57]], [[12991, 12991], "mapped", [53, 48]], [[12992, 12992], "mapped", [49, 26376]], [[12993, 12993], "mapped", [50, 26376]], [[12994, 12994], "mapped", [51, 26376]], [[12995, 12995], "mapped", [52, 26376]], [[12996, 12996], "mapped", [53, 26376]], [[12997, 12997], "mapped", [54, 26376]], [[12998, 12998], "mapped", [55, 26376]], [[12999, 12999], "mapped", [56, 26376]], [[13e3, 13e3], "mapped", [57, 26376]], [[13001, 13001], "mapped", [49, 48, 26376]], [[13002, 13002], "mapped", [49, 49, 26376]], [[13003, 13003], "mapped", [49, 50, 26376]], [[13004, 13004], "mapped", [104, 103]], [[13005, 13005], "mapped", [101, 114, 103]], [[13006, 13006], "mapped", [101, 118]], [[13007, 13007], "mapped", [108, 116, 100]], [[13008, 13008], "mapped", [12450]], [[13009, 13009], "mapped", [12452]], [[13010, 13010], "mapped", [12454]], [[13011, 13011], "mapped", [12456]], [[13012, 13012], "mapped", [12458]], [[13013, 13013], "mapped", [12459]], [[13014, 13014], "mapped", [12461]], [[13015, 13015], "mapped", [12463]], [[13016, 13016], "mapped", [12465]], [[13017, 13017], "mapped", [12467]], [[13018, 13018], "mapped", [12469]], [[13019, 13019], "mapped", [12471]], [[13020, 13020], "mapped", [12473]], [[13021, 13021], "mapped", [12475]], [[13022, 13022], "mapped", [12477]], [[13023, 13023], "mapped", [12479]], [[13024, 13024], "mapped", [12481]], [[13025, 13025], "mapped", [12484]], [[13026, 13026], "mapped", [12486]], [[13027, 13027], "mapped", [12488]], [[13028, 13028], "mapped", [12490]], [[13029, 13029], "mapped", [12491]], [[13030, 13030], "mapped", [12492]], [[13031, 13031], "mapped", [12493]], [[13032, 13032], "mapped", [12494]], [[13033, 13033], "mapped", [12495]], [[13034, 13034], "mapped", [12498]], [[13035, 13035], "mapped", [12501]], [[13036, 13036], "mapped", [12504]], [[13037, 13037], "mapped", [12507]], [[13038, 13038], "mapped", [12510]], [[13039, 13039], "mapped", [12511]], [[13040, 13040], "mapped", [12512]], [[13041, 13041], "mapped", [12513]], [[13042, 13042], "mapped", [12514]], [[13043, 13043], "mapped", [12516]], [[13044, 13044], "mapped", [12518]], [[13045, 13045], "mapped", [12520]], [[13046, 13046], "mapped", [12521]], [[13047, 13047], "mapped", [12522]], [[13048, 13048], "mapped", [12523]], [[13049, 13049], "mapped", [12524]], [[13050, 13050], "mapped", [12525]], [[13051, 13051], "mapped", [12527]], [[13052, 13052], "mapped", [12528]], [[13053, 13053], "mapped", [12529]], [[13054, 13054], "mapped", [12530]], [[13055, 13055], "disallowed"], [[13056, 13056], "mapped", [12450, 12497, 12540, 12488]], [[13057, 13057], "mapped", [12450, 12523, 12501, 12449]], [[13058, 13058], "mapped", [12450, 12531, 12506, 12450]], [[13059, 13059], "mapped", [12450, 12540, 12523]], [[13060, 13060], "mapped", [12452, 12491, 12531, 12464]], [[13061, 13061], "mapped", [12452, 12531, 12481]], [[13062, 13062], "mapped", [12454, 12457, 12531]], [[13063, 13063], "mapped", [12456, 12473, 12463, 12540, 12489]], [[13064, 13064], "mapped", [12456, 12540, 12459, 12540]], [[13065, 13065], "mapped", [12458, 12531, 12473]], [[13066, 13066], "mapped", [12458, 12540, 12512]], [[13067, 13067], "mapped", [12459, 12452, 12522]], [[13068, 13068], "mapped", [12459, 12521, 12483, 12488]], [[13069, 13069], "mapped", [12459, 12525, 12522, 12540]], [[13070, 13070], "mapped", [12460, 12525, 12531]], [[13071, 13071], "mapped", [12460, 12531, 12510]], [[13072, 13072], "mapped", [12462, 12460]], [[13073, 13073], "mapped", [12462, 12491, 12540]], [[13074, 13074], "mapped", [12461, 12517, 12522, 12540]], [[13075, 13075], "mapped", [12462, 12523, 12480, 12540]], [[13076, 13076], "mapped", [12461, 12525]], [[13077, 13077], "mapped", [12461, 12525, 12464, 12521, 12512]], [[13078, 13078], "mapped", [12461, 12525, 12513, 12540, 12488, 12523]], [[13079, 13079], "mapped", [12461, 12525, 12527, 12483, 12488]], [[13080, 13080], "mapped", [12464, 12521, 12512]], [[13081, 13081], "mapped", [12464, 12521, 12512, 12488, 12531]], [[13082, 13082], "mapped", [12463, 12523, 12476, 12452, 12525]], [[13083, 13083], "mapped", [12463, 12525, 12540, 12493]], [[13084, 13084], "mapped", [12465, 12540, 12473]], [[13085, 13085], "mapped", [12467, 12523, 12490]], [[13086, 13086], "mapped", [12467, 12540, 12509]], [[13087, 13087], "mapped", [12469, 12452, 12463, 12523]], [[13088, 13088], "mapped", [12469, 12531, 12481, 12540, 12512]], [[13089, 13089], "mapped", [12471, 12522, 12531, 12464]], [[13090, 13090], "mapped", [12475, 12531, 12481]], [[13091, 13091], "mapped", [12475, 12531, 12488]], [[13092, 13092], "mapped", [12480, 12540, 12473]], [[13093, 13093], "mapped", [12487, 12471]], [[13094, 13094], "mapped", [12489, 12523]], [[13095, 13095], "mapped", [12488, 12531]], [[13096, 13096], "mapped", [12490, 12494]], [[13097, 13097], "mapped", [12494, 12483, 12488]], [[13098, 13098], "mapped", [12495, 12452, 12484]], [[13099, 13099], "mapped", [12497, 12540, 12475, 12531, 12488]], [[13100, 13100], "mapped", [12497, 12540, 12484]], [[13101, 13101], "mapped", [12496, 12540, 12524, 12523]], [[13102, 13102], "mapped", [12500, 12450, 12473, 12488, 12523]], [[13103, 13103], "mapped", [12500, 12463, 12523]], [[13104, 13104], "mapped", [12500, 12467]], [[13105, 13105], "mapped", [12499, 12523]], [[13106, 13106], "mapped", [12501, 12449, 12521, 12483, 12489]], [[13107, 13107], "mapped", [12501, 12451, 12540, 12488]], [[13108, 13108], "mapped", [12502, 12483, 12471, 12455, 12523]], [[13109, 13109], "mapped", [12501, 12521, 12531]], [[13110, 13110], "mapped", [12504, 12463, 12479, 12540, 12523]], [[13111, 13111], "mapped", [12506, 12477]], [[13112, 13112], "mapped", [12506, 12491, 12498]], [[13113, 13113], "mapped", [12504, 12523, 12484]], [[13114, 13114], "mapped", [12506, 12531, 12473]], [[13115, 13115], "mapped", [12506, 12540, 12472]], [[13116, 13116], "mapped", [12505, 12540, 12479]], [[13117, 13117], "mapped", [12509, 12452, 12531, 12488]], [[13118, 13118], "mapped", [12508, 12523, 12488]], [[13119, 13119], "mapped", [12507, 12531]], [[13120, 13120], "mapped", [12509, 12531, 12489]], [[13121, 13121], "mapped", [12507, 12540, 12523]], [[13122, 13122], "mapped", [12507, 12540, 12531]], [[13123, 13123], "mapped", [12510, 12452, 12463, 12525]], [[13124, 13124], "mapped", [12510, 12452, 12523]], [[13125, 13125], "mapped", [12510, 12483, 12495]], [[13126, 13126], "mapped", [12510, 12523, 12463]], [[13127, 13127], "mapped", [12510, 12531, 12471, 12519, 12531]], [[13128, 13128], "mapped", [12511, 12463, 12525, 12531]], [[13129, 13129], "mapped", [12511, 12522]], [[13130, 13130], "mapped", [12511, 12522, 12496, 12540, 12523]], [[13131, 13131], "mapped", [12513, 12460]], [[13132, 13132], "mapped", [12513, 12460, 12488, 12531]], [[13133, 13133], "mapped", [12513, 12540, 12488, 12523]], [[13134, 13134], "mapped", [12516, 12540, 12489]], [[13135, 13135], "mapped", [12516, 12540, 12523]], [[13136, 13136], "mapped", [12518, 12450, 12531]], [[13137, 13137], "mapped", [12522, 12483, 12488, 12523]], [[13138, 13138], "mapped", [12522, 12521]], [[13139, 13139], "mapped", [12523, 12500, 12540]], [[13140, 13140], "mapped", [12523, 12540, 12502, 12523]], [[13141, 13141], "mapped", [12524, 12512]], [[13142, 13142], "mapped", [12524, 12531, 12488, 12466, 12531]], [[13143, 13143], "mapped", [12527, 12483, 12488]], [[13144, 13144], "mapped", [48, 28857]], [[13145, 13145], "mapped", [49, 28857]], [[13146, 13146], "mapped", [50, 28857]], [[13147, 13147], "mapped", [51, 28857]], [[13148, 13148], "mapped", [52, 28857]], [[13149, 13149], "mapped", [53, 28857]], [[13150, 13150], "mapped", [54, 28857]], [[13151, 13151], "mapped", [55, 28857]], [[13152, 13152], "mapped", [56, 28857]], [[13153, 13153], "mapped", [57, 28857]], [[13154, 13154], "mapped", [49, 48, 28857]], [[13155, 13155], "mapped", [49, 49, 28857]], [[13156, 13156], "mapped", [49, 50, 28857]], [[13157, 13157], "mapped", [49, 51, 28857]], [[13158, 13158], "mapped", [49, 52, 28857]], [[13159, 13159], "mapped", [49, 53, 28857]], [[13160, 13160], "mapped", [49, 54, 28857]], [[13161, 13161], "mapped", [49, 55, 28857]], [[13162, 13162], "mapped", [49, 56, 28857]], [[13163, 13163], "mapped", [49, 57, 28857]], [[13164, 13164], "mapped", [50, 48, 28857]], [[13165, 13165], "mapped", [50, 49, 28857]], [[13166, 13166], "mapped", [50, 50, 28857]], [[13167, 13167], "mapped", [50, 51, 28857]], [[13168, 13168], "mapped", [50, 52, 28857]], [[13169, 13169], "mapped", [104, 112, 97]], [[13170, 13170], "mapped", [100, 97]], [[13171, 13171], "mapped", [97, 117]], [[13172, 13172], "mapped", [98, 97, 114]], [[13173, 13173], "mapped", [111, 118]], [[13174, 13174], "mapped", [112, 99]], [[13175, 13175], "mapped", [100, 109]], [[13176, 13176], "mapped", [100, 109, 50]], [[13177, 13177], "mapped", [100, 109, 51]], [[13178, 13178], "mapped", [105, 117]], [[13179, 13179], "mapped", [24179, 25104]], [[13180, 13180], "mapped", [26157, 21644]], [[13181, 13181], "mapped", [22823, 27491]], [[13182, 13182], "mapped", [26126, 27835]], [[13183, 13183], "mapped", [26666, 24335, 20250, 31038]], [[13184, 13184], "mapped", [112, 97]], [[13185, 13185], "mapped", [110, 97]], [[13186, 13186], "mapped", [956, 97]], [[13187, 13187], "mapped", [109, 97]], [[13188, 13188], "mapped", [107, 97]], [[13189, 13189], "mapped", [107, 98]], [[13190, 13190], "mapped", [109, 98]], [[13191, 13191], "mapped", [103, 98]], [[13192, 13192], "mapped", [99, 97, 108]], [[13193, 13193], "mapped", [107, 99, 97, 108]], [[13194, 13194], "mapped", [112, 102]], [[13195, 13195], "mapped", [110, 102]], [[13196, 13196], "mapped", [956, 102]], [[13197, 13197], "mapped", [956, 103]], [[13198, 13198], "mapped", [109, 103]], [[13199, 13199], "mapped", [107, 103]], [[13200, 13200], "mapped", [104, 122]], [[13201, 13201], "mapped", [107, 104, 122]], [[13202, 13202], "mapped", [109, 104, 122]], [[13203, 13203], "mapped", [103, 104, 122]], [[13204, 13204], "mapped", [116, 104, 122]], [[13205, 13205], "mapped", [956, 108]], [[13206, 13206], "mapped", [109, 108]], [[13207, 13207], "mapped", [100, 108]], [[13208, 13208], "mapped", [107, 108]], [[13209, 13209], "mapped", [102, 109]], [[13210, 13210], "mapped", [110, 109]], [[13211, 13211], "mapped", [956, 109]], [[13212, 13212], "mapped", [109, 109]], [[13213, 13213], "mapped", [99, 109]], [[13214, 13214], "mapped", [107, 109]], [[13215, 13215], "mapped", [109, 109, 50]], [[13216, 13216], "mapped", [99, 109, 50]], [[13217, 13217], "mapped", [109, 50]], [[13218, 13218], "mapped", [107, 109, 50]], [[13219, 13219], "mapped", [109, 109, 51]], [[13220, 13220], "mapped", [99, 109, 51]], [[13221, 13221], "mapped", [109, 51]], [[13222, 13222], "mapped", [107, 109, 51]], [[13223, 13223], "mapped", [109, 8725, 115]], [[13224, 13224], "mapped", [109, 8725, 115, 50]], [[13225, 13225], "mapped", [112, 97]], [[13226, 13226], "mapped", [107, 112, 97]], [[13227, 13227], "mapped", [109, 112, 97]], [[13228, 13228], "mapped", [103, 112, 97]], [[13229, 13229], "mapped", [114, 97, 100]], [[13230, 13230], "mapped", [114, 97, 100, 8725, 115]], [[13231, 13231], "mapped", [114, 97, 100, 8725, 115, 50]], [[13232, 13232], "mapped", [112, 115]], [[13233, 13233], "mapped", [110, 115]], [[13234, 13234], "mapped", [956, 115]], [[13235, 13235], "mapped", [109, 115]], [[13236, 13236], "mapped", [112, 118]], [[13237, 13237], "mapped", [110, 118]], [[13238, 13238], "mapped", [956, 118]], [[13239, 13239], "mapped", [109, 118]], [[13240, 13240], "mapped", [107, 118]], [[13241, 13241], "mapped", [109, 118]], [[13242, 13242], "mapped", [112, 119]], [[13243, 13243], "mapped", [110, 119]], [[13244, 13244], "mapped", [956, 119]], [[13245, 13245], "mapped", [109, 119]], [[13246, 13246], "mapped", [107, 119]], [[13247, 13247], "mapped", [109, 119]], [[13248, 13248], "mapped", [107, 969]], [[13249, 13249], "mapped", [109, 969]], [[13250, 13250], "disallowed"], [[13251, 13251], "mapped", [98, 113]], [[13252, 13252], "mapped", [99, 99]], [[13253, 13253], "mapped", [99, 100]], [[13254, 13254], "mapped", [99, 8725, 107, 103]], [[13255, 13255], "disallowed"], [[13256, 13256], "mapped", [100, 98]], [[13257, 13257], "mapped", [103, 121]], [[13258, 13258], "mapped", [104, 97]], [[13259, 13259], "mapped", [104, 112]], [[13260, 13260], "mapped", [105, 110]], [[13261, 13261], "mapped", [107, 107]], [[13262, 13262], "mapped", [107, 109]], [[13263, 13263], "mapped", [107, 116]], [[13264, 13264], "mapped", [108, 109]], [[13265, 13265], "mapped", [108, 110]], [[13266, 13266], "mapped", [108, 111, 103]], [[13267, 13267], "mapped", [108, 120]], [[13268, 13268], "mapped", [109, 98]], [[13269, 13269], "mapped", [109, 105, 108]], [[13270, 13270], "mapped", [109, 111, 108]], [[13271, 13271], "mapped", [112, 104]], [[13272, 13272], "disallowed"], [[13273, 13273], "mapped", [112, 112, 109]], [[13274, 13274], "mapped", [112, 114]], [[13275, 13275], "mapped", [115, 114]], [[13276, 13276], "mapped", [115, 118]], [[13277, 13277], "mapped", [119, 98]], [[13278, 13278], "mapped", [118, 8725, 109]], [[13279, 13279], "mapped", [97, 8725, 109]], [[13280, 13280], "mapped", [49, 26085]], [[13281, 13281], "mapped", [50, 26085]], [[13282, 13282], "mapped", [51, 26085]], [[13283, 13283], "mapped", [52, 26085]], [[13284, 13284], "mapped", [53, 26085]], [[13285, 13285], "mapped", [54, 26085]], [[13286, 13286], "mapped", [55, 26085]], [[13287, 13287], "mapped", [56, 26085]], [[13288, 13288], "mapped", [57, 26085]], [[13289, 13289], "mapped", [49, 48, 26085]], [[13290, 13290], "mapped", [49, 49, 26085]], [[13291, 13291], "mapped", [49, 50, 26085]], [[13292, 13292], "mapped", [49, 51, 26085]], [[13293, 13293], "mapped", [49, 52, 26085]], [[13294, 13294], "mapped", [49, 53, 26085]], [[13295, 13295], "mapped", [49, 54, 26085]], [[13296, 13296], "mapped", [49, 55, 26085]], [[13297, 13297], "mapped", [49, 56, 26085]], [[13298, 13298], "mapped", [49, 57, 26085]], [[13299, 13299], "mapped", [50, 48, 26085]], [[13300, 13300], "mapped", [50, 49, 26085]], [[13301, 13301], "mapped", [50, 50, 26085]], [[13302, 13302], "mapped", [50, 51, 26085]], [[13303, 13303], "mapped", [50, 52, 26085]], [[13304, 13304], "mapped", [50, 53, 26085]], [[13305, 13305], "mapped", [50, 54, 26085]], [[13306, 13306], "mapped", [50, 55, 26085]], [[13307, 13307], "mapped", [50, 56, 26085]], [[13308, 13308], "mapped", [50, 57, 26085]], [[13309, 13309], "mapped", [51, 48, 26085]], [[13310, 13310], "mapped", [51, 49, 26085]], [[13311, 13311], "mapped", [103, 97, 108]], [[13312, 19893], "valid"], [[19894, 19903], "disallowed"], [[19904, 19967], "valid", [], "NV8"], [[19968, 40869], "valid"], [[40870, 40891], "valid"], [[40892, 40899], "valid"], [[40900, 40907], "valid"], [[40908, 40908], "valid"], [[40909, 40917], "valid"], [[40918, 40959], "disallowed"], [[40960, 42124], "valid"], [[42125, 42127], "disallowed"], [[42128, 42145], "valid", [], "NV8"], [[42146, 42147], "valid", [], "NV8"], [[42148, 42163], "valid", [], "NV8"], [[42164, 42164], "valid", [], "NV8"], [[42165, 42176], "valid", [], "NV8"], [[42177, 42177], "valid", [], "NV8"], [[42178, 42180], "valid", [], "NV8"], [[42181, 42181], "valid", [], "NV8"], [[42182, 42182], "valid", [], "NV8"], [[42183, 42191], "disallowed"], [[42192, 42237], "valid"], [[42238, 42239], "valid", [], "NV8"], [[42240, 42508], "valid"], [[42509, 42511], "valid", [], "NV8"], [[42512, 42539], "valid"], [[42540, 42559], "disallowed"], [[42560, 42560], "mapped", [42561]], [[42561, 42561], "valid"], [[42562, 42562], "mapped", [42563]], [[42563, 42563], "valid"], [[42564, 42564], "mapped", [42565]], [[42565, 42565], "valid"], [[42566, 42566], "mapped", [42567]], [[42567, 42567], "valid"], [[42568, 42568], "mapped", [42569]], [[42569, 42569], "valid"], [[42570, 42570], "mapped", [42571]], [[42571, 42571], "valid"], [[42572, 42572], "mapped", [42573]], [[42573, 42573], "valid"], [[42574, 42574], "mapped", [42575]], [[42575, 42575], "valid"], [[42576, 42576], "mapped", [42577]], [[42577, 42577], "valid"], [[42578, 42578], "mapped", [42579]], [[42579, 42579], "valid"], [[42580, 42580], "mapped", [42581]], [[42581, 42581], "valid"], [[42582, 42582], "mapped", [42583]], [[42583, 42583], "valid"], [[42584, 42584], "mapped", [42585]], [[42585, 42585], "valid"], [[42586, 42586], "mapped", [42587]], [[42587, 42587], "valid"], [[42588, 42588], "mapped", [42589]], [[42589, 42589], "valid"], [[42590, 42590], "mapped", [42591]], [[42591, 42591], "valid"], [[42592, 42592], "mapped", [42593]], [[42593, 42593], "valid"], [[42594, 42594], "mapped", [42595]], [[42595, 42595], "valid"], [[42596, 42596], "mapped", [42597]], [[42597, 42597], "valid"], [[42598, 42598], "mapped", [42599]], [[42599, 42599], "valid"], [[42600, 42600], "mapped", [42601]], [[42601, 42601], "valid"], [[42602, 42602], "mapped", [42603]], [[42603, 42603], "valid"], [[42604, 42604], "mapped", [42605]], [[42605, 42607], "valid"], [[42608, 42611], "valid", [], "NV8"], [[42612, 42619], "valid"], [[42620, 42621], "valid"], [[42622, 42622], "valid", [], "NV8"], [[42623, 42623], "valid"], [[42624, 42624], "mapped", [42625]], [[42625, 42625], "valid"], [[42626, 42626], "mapped", [42627]], [[42627, 42627], "valid"], [[42628, 42628], "mapped", [42629]], [[42629, 42629], "valid"], [[42630, 42630], "mapped", [42631]], [[42631, 42631], "valid"], [[42632, 42632], "mapped", [42633]], [[42633, 42633], "valid"], [[42634, 42634], "mapped", [42635]], [[42635, 42635], "valid"], [[42636, 42636], "mapped", [42637]], [[42637, 42637], "valid"], [[42638, 42638], "mapped", [42639]], [[42639, 42639], "valid"], [[42640, 42640], "mapped", [42641]], [[42641, 42641], "valid"], [[42642, 42642], "mapped", [42643]], [[42643, 42643], "valid"], [[42644, 42644], "mapped", [42645]], [[42645, 42645], "valid"], [[42646, 42646], "mapped", [42647]], [[42647, 42647], "valid"], [[42648, 42648], "mapped", [42649]], [[42649, 42649], "valid"], [[42650, 42650], "mapped", [42651]], [[42651, 42651], "valid"], [[42652, 42652], "mapped", [1098]], [[42653, 42653], "mapped", [1100]], [[42654, 42654], "valid"], [[42655, 42655], "valid"], [[42656, 42725], "valid"], [[42726, 42735], "valid", [], "NV8"], [[42736, 42737], "valid"], [[42738, 42743], "valid", [], "NV8"], [[42744, 42751], "disallowed"], [[42752, 42774], "valid", [], "NV8"], [[42775, 42778], "valid"], [[42779, 42783], "valid"], [[42784, 42785], "valid", [], "NV8"], [[42786, 42786], "mapped", [42787]], [[42787, 42787], "valid"], [[42788, 42788], "mapped", [42789]], [[42789, 42789], "valid"], [[42790, 42790], "mapped", [42791]], [[42791, 42791], "valid"], [[42792, 42792], "mapped", [42793]], [[42793, 42793], "valid"], [[42794, 42794], "mapped", [42795]], [[42795, 42795], "valid"], [[42796, 42796], "mapped", [42797]], [[42797, 42797], "valid"], [[42798, 42798], "mapped", [42799]], [[42799, 42801], "valid"], [[42802, 42802], "mapped", [42803]], [[42803, 42803], "valid"], [[42804, 42804], "mapped", [42805]], [[42805, 42805], "valid"], [[42806, 42806], "mapped", [42807]], [[42807, 42807], "valid"], [[42808, 42808], "mapped", [42809]], [[42809, 42809], "valid"], [[42810, 42810], "mapped", [42811]], [[42811, 42811], "valid"], [[42812, 42812], "mapped", [42813]], [[42813, 42813], "valid"], [[42814, 42814], "mapped", [42815]], [[42815, 42815], "valid"], [[42816, 42816], "mapped", [42817]], [[42817, 42817], "valid"], [[42818, 42818], "mapped", [42819]], [[42819, 42819], "valid"], [[42820, 42820], "mapped", [42821]], [[42821, 42821], "valid"], [[42822, 42822], "mapped", [42823]], [[42823, 42823], "valid"], [[42824, 42824], "mapped", [42825]], [[42825, 42825], "valid"], [[42826, 42826], "mapped", [42827]], [[42827, 42827], "valid"], [[42828, 42828], "mapped", [42829]], [[42829, 42829], "valid"], [[42830, 42830], "mapped", [42831]], [[42831, 42831], "valid"], [[42832, 42832], "mapped", [42833]], [[42833, 42833], "valid"], [[42834, 42834], "mapped", [42835]], [[42835, 42835], "valid"], [[42836, 42836], "mapped", [42837]], [[42837, 42837], "valid"], [[42838, 42838], "mapped", [42839]], [[42839, 42839], "valid"], [[42840, 42840], "mapped", [42841]], [[42841, 42841], "valid"], [[42842, 42842], "mapped", [42843]], [[42843, 42843], "valid"], [[42844, 42844], "mapped", [42845]], [[42845, 42845], "valid"], [[42846, 42846], "mapped", [42847]], [[42847, 42847], "valid"], [[42848, 42848], "mapped", [42849]], [[42849, 42849], "valid"], [[42850, 42850], "mapped", [42851]], [[42851, 42851], "valid"], [[42852, 42852], "mapped", [42853]], [[42853, 42853], "valid"], [[42854, 42854], "mapped", [42855]], [[42855, 42855], "valid"], [[42856, 42856], "mapped", [42857]], [[42857, 42857], "valid"], [[42858, 42858], "mapped", [42859]], [[42859, 42859], "valid"], [[42860, 42860], "mapped", [42861]], [[42861, 42861], "valid"], [[42862, 42862], "mapped", [42863]], [[42863, 42863], "valid"], [[42864, 42864], "mapped", [42863]], [[42865, 42872], "valid"], [[42873, 42873], "mapped", [42874]], [[42874, 42874], "valid"], [[42875, 42875], "mapped", [42876]], [[42876, 42876], "valid"], [[42877, 42877], "mapped", [7545]], [[42878, 42878], "mapped", [42879]], [[42879, 42879], "valid"], [[42880, 42880], "mapped", [42881]], [[42881, 42881], "valid"], [[42882, 42882], "mapped", [42883]], [[42883, 42883], "valid"], [[42884, 42884], "mapped", [42885]], [[42885, 42885], "valid"], [[42886, 42886], "mapped", [42887]], [[42887, 42888], "valid"], [[42889, 42890], "valid", [], "NV8"], [[42891, 42891], "mapped", [42892]], [[42892, 42892], "valid"], [[42893, 42893], "mapped", [613]], [[42894, 42894], "valid"], [[42895, 42895], "valid"], [[42896, 42896], "mapped", [42897]], [[42897, 42897], "valid"], [[42898, 42898], "mapped", [42899]], [[42899, 42899], "valid"], [[42900, 42901], "valid"], [[42902, 42902], "mapped", [42903]], [[42903, 42903], "valid"], [[42904, 42904], "mapped", [42905]], [[42905, 42905], "valid"], [[42906, 42906], "mapped", [42907]], [[42907, 42907], "valid"], [[42908, 42908], "mapped", [42909]], [[42909, 42909], "valid"], [[42910, 42910], "mapped", [42911]], [[42911, 42911], "valid"], [[42912, 42912], "mapped", [42913]], [[42913, 42913], "valid"], [[42914, 42914], "mapped", [42915]], [[42915, 42915], "valid"], [[42916, 42916], "mapped", [42917]], [[42917, 42917], "valid"], [[42918, 42918], "mapped", [42919]], [[42919, 42919], "valid"], [[42920, 42920], "mapped", [42921]], [[42921, 42921], "valid"], [[42922, 42922], "mapped", [614]], [[42923, 42923], "mapped", [604]], [[42924, 42924], "mapped", [609]], [[42925, 42925], "mapped", [620]], [[42926, 42927], "disallowed"], [[42928, 42928], "mapped", [670]], [[42929, 42929], "mapped", [647]], [[42930, 42930], "mapped", [669]], [[42931, 42931], "mapped", [43859]], [[42932, 42932], "mapped", [42933]], [[42933, 42933], "valid"], [[42934, 42934], "mapped", [42935]], [[42935, 42935], "valid"], [[42936, 42998], "disallowed"], [[42999, 42999], "valid"], [[43e3, 43e3], "mapped", [295]], [[43001, 43001], "mapped", [339]], [[43002, 43002], "valid"], [[43003, 43007], "valid"], [[43008, 43047], "valid"], [[43048, 43051], "valid", [], "NV8"], [[43052, 43055], "disallowed"], [[43056, 43065], "valid", [], "NV8"], [[43066, 43071], "disallowed"], [[43072, 43123], "valid"], [[43124, 43127], "valid", [], "NV8"], [[43128, 43135], "disallowed"], [[43136, 43204], "valid"], [[43205, 43213], "disallowed"], [[43214, 43215], "valid", [], "NV8"], [[43216, 43225], "valid"], [[43226, 43231], "disallowed"], [[43232, 43255], "valid"], [[43256, 43258], "valid", [], "NV8"], [[43259, 43259], "valid"], [[43260, 43260], "valid", [], "NV8"], [[43261, 43261], "valid"], [[43262, 43263], "disallowed"], [[43264, 43309], "valid"], [[43310, 43311], "valid", [], "NV8"], [[43312, 43347], "valid"], [[43348, 43358], "disallowed"], [[43359, 43359], "valid", [], "NV8"], [[43360, 43388], "valid", [], "NV8"], [[43389, 43391], "disallowed"], [[43392, 43456], "valid"], [[43457, 43469], "valid", [], "NV8"], [[43470, 43470], "disallowed"], [[43471, 43481], "valid"], [[43482, 43485], "disallowed"], [[43486, 43487], "valid", [], "NV8"], [[43488, 43518], "valid"], [[43519, 43519], "disallowed"], [[43520, 43574], "valid"], [[43575, 43583], "disallowed"], [[43584, 43597], "valid"], [[43598, 43599], "disallowed"], [[43600, 43609], "valid"], [[43610, 43611], "disallowed"], [[43612, 43615], "valid", [], "NV8"], [[43616, 43638], "valid"], [[43639, 43641], "valid", [], "NV8"], [[43642, 43643], "valid"], [[43644, 43647], "valid"], [[43648, 43714], "valid"], [[43715, 43738], "disallowed"], [[43739, 43741], "valid"], [[43742, 43743], "valid", [], "NV8"], [[43744, 43759], "valid"], [[43760, 43761], "valid", [], "NV8"], [[43762, 43766], "valid"], [[43767, 43776], "disallowed"], [[43777, 43782], "valid"], [[43783, 43784], "disallowed"], [[43785, 43790], "valid"], [[43791, 43792], "disallowed"], [[43793, 43798], "valid"], [[43799, 43807], "disallowed"], [[43808, 43814], "valid"], [[43815, 43815], "disallowed"], [[43816, 43822], "valid"], [[43823, 43823], "disallowed"], [[43824, 43866], "valid"], [[43867, 43867], "valid", [], "NV8"], [[43868, 43868], "mapped", [42791]], [[43869, 43869], "mapped", [43831]], [[43870, 43870], "mapped", [619]], [[43871, 43871], "mapped", [43858]], [[43872, 43875], "valid"], [[43876, 43877], "valid"], [[43878, 43887], "disallowed"], [[43888, 43888], "mapped", [5024]], [[43889, 43889], "mapped", [5025]], [[43890, 43890], "mapped", [5026]], [[43891, 43891], "mapped", [5027]], [[43892, 43892], "mapped", [5028]], [[43893, 43893], "mapped", [5029]], [[43894, 43894], "mapped", [5030]], [[43895, 43895], "mapped", [5031]], [[43896, 43896], "mapped", [5032]], [[43897, 43897], "mapped", [5033]], [[43898, 43898], "mapped", [5034]], [[43899, 43899], "mapped", [5035]], [[43900, 43900], "mapped", [5036]], [[43901, 43901], "mapped", [5037]], [[43902, 43902], "mapped", [5038]], [[43903, 43903], "mapped", [5039]], [[43904, 43904], "mapped", [5040]], [[43905, 43905], "mapped", [5041]], [[43906, 43906], "mapped", [5042]], [[43907, 43907], "mapped", [5043]], [[43908, 43908], "mapped", [5044]], [[43909, 43909], "mapped", [5045]], [[43910, 43910], "mapped", [5046]], [[43911, 43911], "mapped", [5047]], [[43912, 43912], "mapped", [5048]], [[43913, 43913], "mapped", [5049]], [[43914, 43914], "mapped", [5050]], [[43915, 43915], "mapped", [5051]], [[43916, 43916], "mapped", [5052]], [[43917, 43917], "mapped", [5053]], [[43918, 43918], "mapped", [5054]], [[43919, 43919], "mapped", [5055]], [[43920, 43920], "mapped", [5056]], [[43921, 43921], "mapped", [5057]], [[43922, 43922], "mapped", [5058]], [[43923, 43923], "mapped", [5059]], [[43924, 43924], "mapped", [5060]], [[43925, 43925], "mapped", [5061]], [[43926, 43926], "mapped", [5062]], [[43927, 43927], "mapped", [5063]], [[43928, 43928], "mapped", [5064]], [[43929, 43929], "mapped", [5065]], [[43930, 43930], "mapped", [5066]], [[43931, 43931], "mapped", [5067]], [[43932, 43932], "mapped", [5068]], [[43933, 43933], "mapped", [5069]], [[43934, 43934], "mapped", [5070]], [[43935, 43935], "mapped", [5071]], [[43936, 43936], "mapped", [5072]], [[43937, 43937], "mapped", [5073]], [[43938, 43938], "mapped", [5074]], [[43939, 43939], "mapped", [5075]], [[43940, 43940], "mapped", [5076]], [[43941, 43941], "mapped", [5077]], [[43942, 43942], "mapped", [5078]], [[43943, 43943], "mapped", [5079]], [[43944, 43944], "mapped", [5080]], [[43945, 43945], "mapped", [5081]], [[43946, 43946], "mapped", [5082]], [[43947, 43947], "mapped", [5083]], [[43948, 43948], "mapped", [5084]], [[43949, 43949], "mapped", [5085]], [[43950, 43950], "mapped", [5086]], [[43951, 43951], "mapped", [5087]], [[43952, 43952], "mapped", [5088]], [[43953, 43953], "mapped", [5089]], [[43954, 43954], "mapped", [5090]], [[43955, 43955], "mapped", [5091]], [[43956, 43956], "mapped", [5092]], [[43957, 43957], "mapped", [5093]], [[43958, 43958], "mapped", [5094]], [[43959, 43959], "mapped", [5095]], [[43960, 43960], "mapped", [5096]], [[43961, 43961], "mapped", [5097]], [[43962, 43962], "mapped", [5098]], [[43963, 43963], "mapped", [5099]], [[43964, 43964], "mapped", [5100]], [[43965, 43965], "mapped", [5101]], [[43966, 43966], "mapped", [5102]], [[43967, 43967], "mapped", [5103]], [[43968, 44010], "valid"], [[44011, 44011], "valid", [], "NV8"], [[44012, 44013], "valid"], [[44014, 44015], "disallowed"], [[44016, 44025], "valid"], [[44026, 44031], "disallowed"], [[44032, 55203], "valid"], [[55204, 55215], "disallowed"], [[55216, 55238], "valid", [], "NV8"], [[55239, 55242], "disallowed"], [[55243, 55291], "valid", [], "NV8"], [[55292, 55295], "disallowed"], [[55296, 57343], "disallowed"], [[57344, 63743], "disallowed"], [[63744, 63744], "mapped", [35912]], [[63745, 63745], "mapped", [26356]], [[63746, 63746], "mapped", [36554]], [[63747, 63747], "mapped", [36040]], [[63748, 63748], "mapped", [28369]], [[63749, 63749], "mapped", [20018]], [[63750, 63750], "mapped", [21477]], [[63751, 63752], "mapped", [40860]], [[63753, 63753], "mapped", [22865]], [[63754, 63754], "mapped", [37329]], [[63755, 63755], "mapped", [21895]], [[63756, 63756], "mapped", [22856]], [[63757, 63757], "mapped", [25078]], [[63758, 63758], "mapped", [30313]], [[63759, 63759], "mapped", [32645]], [[63760, 63760], "mapped", [34367]], [[63761, 63761], "mapped", [34746]], [[63762, 63762], "mapped", [35064]], [[63763, 63763], "mapped", [37007]], [[63764, 63764], "mapped", [27138]], [[63765, 63765], "mapped", [27931]], [[63766, 63766], "mapped", [28889]], [[63767, 63767], "mapped", [29662]], [[63768, 63768], "mapped", [33853]], [[63769, 63769], "mapped", [37226]], [[63770, 63770], "mapped", [39409]], [[63771, 63771], "mapped", [20098]], [[63772, 63772], "mapped", [21365]], [[63773, 63773], "mapped", [27396]], [[63774, 63774], "mapped", [29211]], [[63775, 63775], "mapped", [34349]], [[63776, 63776], "mapped", [40478]], [[63777, 63777], "mapped", [23888]], [[63778, 63778], "mapped", [28651]], [[63779, 63779], "mapped", [34253]], [[63780, 63780], "mapped", [35172]], [[63781, 63781], "mapped", [25289]], [[63782, 63782], "mapped", [33240]], [[63783, 63783], "mapped", [34847]], [[63784, 63784], "mapped", [24266]], [[63785, 63785], "mapped", [26391]], [[63786, 63786], "mapped", [28010]], [[63787, 63787], "mapped", [29436]], [[63788, 63788], "mapped", [37070]], [[63789, 63789], "mapped", [20358]], [[63790, 63790], "mapped", [20919]], [[63791, 63791], "mapped", [21214]], [[63792, 63792], "mapped", [25796]], [[63793, 63793], "mapped", [27347]], [[63794, 63794], "mapped", [29200]], [[63795, 63795], "mapped", [30439]], [[63796, 63796], "mapped", [32769]], [[63797, 63797], "mapped", [34310]], [[63798, 63798], "mapped", [34396]], [[63799, 63799], "mapped", [36335]], [[63800, 63800], "mapped", [38706]], [[63801, 63801], "mapped", [39791]], [[63802, 63802], "mapped", [40442]], [[63803, 63803], "mapped", [30860]], [[63804, 63804], "mapped", [31103]], [[63805, 63805], "mapped", [32160]], [[63806, 63806], "mapped", [33737]], [[63807, 63807], "mapped", [37636]], [[63808, 63808], "mapped", [40575]], [[63809, 63809], "mapped", [35542]], [[63810, 63810], "mapped", [22751]], [[63811, 63811], "mapped", [24324]], [[63812, 63812], "mapped", [31840]], [[63813, 63813], "mapped", [32894]], [[63814, 63814], "mapped", [29282]], [[63815, 63815], "mapped", [30922]], [[63816, 63816], "mapped", [36034]], [[63817, 63817], "mapped", [38647]], [[63818, 63818], "mapped", [22744]], [[63819, 63819], "mapped", [23650]], [[63820, 63820], "mapped", [27155]], [[63821, 63821], "mapped", [28122]], [[63822, 63822], "mapped", [28431]], [[63823, 63823], "mapped", [32047]], [[63824, 63824], "mapped", [32311]], [[63825, 63825], "mapped", [38475]], [[63826, 63826], "mapped", [21202]], [[63827, 63827], "mapped", [32907]], [[63828, 63828], "mapped", [20956]], [[63829, 63829], "mapped", [20940]], [[63830, 63830], "mapped", [31260]], [[63831, 63831], "mapped", [32190]], [[63832, 63832], "mapped", [33777]], [[63833, 63833], "mapped", [38517]], [[63834, 63834], "mapped", [35712]], [[63835, 63835], "mapped", [25295]], [[63836, 63836], "mapped", [27138]], [[63837, 63837], "mapped", [35582]], [[63838, 63838], "mapped", [20025]], [[63839, 63839], "mapped", [23527]], [[63840, 63840], "mapped", [24594]], [[63841, 63841], "mapped", [29575]], [[63842, 63842], "mapped", [30064]], [[63843, 63843], "mapped", [21271]], [[63844, 63844], "mapped", [30971]], [[63845, 63845], "mapped", [20415]], [[63846, 63846], "mapped", [24489]], [[63847, 63847], "mapped", [19981]], [[63848, 63848], "mapped", [27852]], [[63849, 63849], "mapped", [25976]], [[63850, 63850], "mapped", [32034]], [[63851, 63851], "mapped", [21443]], [[63852, 63852], "mapped", [22622]], [[63853, 63853], "mapped", [30465]], [[63854, 63854], "mapped", [33865]], [[63855, 63855], "mapped", [35498]], [[63856, 63856], "mapped", [27578]], [[63857, 63857], "mapped", [36784]], [[63858, 63858], "mapped", [27784]], [[63859, 63859], "mapped", [25342]], [[63860, 63860], "mapped", [33509]], [[63861, 63861], "mapped", [25504]], [[63862, 63862], "mapped", [30053]], [[63863, 63863], "mapped", [20142]], [[63864, 63864], "mapped", [20841]], [[63865, 63865], "mapped", [20937]], [[63866, 63866], "mapped", [26753]], [[63867, 63867], "mapped", [31975]], [[63868, 63868], "mapped", [33391]], [[63869, 63869], "mapped", [35538]], [[63870, 63870], "mapped", [37327]], [[63871, 63871], "mapped", [21237]], [[63872, 63872], "mapped", [21570]], [[63873, 63873], "mapped", [22899]], [[63874, 63874], "mapped", [24300]], [[63875, 63875], "mapped", [26053]], [[63876, 63876], "mapped", [28670]], [[63877, 63877], "mapped", [31018]], [[63878, 63878], "mapped", [38317]], [[63879, 63879], "mapped", [39530]], [[63880, 63880], "mapped", [40599]], [[63881, 63881], "mapped", [40654]], [[63882, 63882], "mapped", [21147]], [[63883, 63883], "mapped", [26310]], [[63884, 63884], "mapped", [27511]], [[63885, 63885], "mapped", [36706]], [[63886, 63886], "mapped", [24180]], [[63887, 63887], "mapped", [24976]], [[63888, 63888], "mapped", [25088]], [[63889, 63889], "mapped", [25754]], [[63890, 63890], "mapped", [28451]], [[63891, 63891], "mapped", [29001]], [[63892, 63892], "mapped", [29833]], [[63893, 63893], "mapped", [31178]], [[63894, 63894], "mapped", [32244]], [[63895, 63895], "mapped", [32879]], [[63896, 63896], "mapped", [36646]], [[63897, 63897], "mapped", [34030]], [[63898, 63898], "mapped", [36899]], [[63899, 63899], "mapped", [37706]], [[63900, 63900], "mapped", [21015]], [[63901, 63901], "mapped", [21155]], [[63902, 63902], "mapped", [21693]], [[63903, 63903], "mapped", [28872]], [[63904, 63904], "mapped", [35010]], [[63905, 63905], "mapped", [35498]], [[63906, 63906], "mapped", [24265]], [[63907, 63907], "mapped", [24565]], [[63908, 63908], "mapped", [25467]], [[63909, 63909], "mapped", [27566]], [[63910, 63910], "mapped", [31806]], [[63911, 63911], "mapped", [29557]], [[63912, 63912], "mapped", [20196]], [[63913, 63913], "mapped", [22265]], [[63914, 63914], "mapped", [23527]], [[63915, 63915], "mapped", [23994]], [[63916, 63916], "mapped", [24604]], [[63917, 63917], "mapped", [29618]], [[63918, 63918], "mapped", [29801]], [[63919, 63919], "mapped", [32666]], [[63920, 63920], "mapped", [32838]], [[63921, 63921], "mapped", [37428]], [[63922, 63922], "mapped", [38646]], [[63923, 63923], "mapped", [38728]], [[63924, 63924], "mapped", [38936]], [[63925, 63925], "mapped", [20363]], [[63926, 63926], "mapped", [31150]], [[63927, 63927], "mapped", [37300]], [[63928, 63928], "mapped", [38584]], [[63929, 63929], "mapped", [24801]], [[63930, 63930], "mapped", [20102]], [[63931, 63931], "mapped", [20698]], [[63932, 63932], "mapped", [23534]], [[63933, 63933], "mapped", [23615]], [[63934, 63934], "mapped", [26009]], [[63935, 63935], "mapped", [27138]], [[63936, 63936], "mapped", [29134]], [[63937, 63937], "mapped", [30274]], [[63938, 63938], "mapped", [34044]], [[63939, 63939], "mapped", [36988]], [[63940, 63940], "mapped", [40845]], [[63941, 63941], "mapped", [26248]], [[63942, 63942], "mapped", [38446]], [[63943, 63943], "mapped", [21129]], [[63944, 63944], "mapped", [26491]], [[63945, 63945], "mapped", [26611]], [[63946, 63946], "mapped", [27969]], [[63947, 63947], "mapped", [28316]], [[63948, 63948], "mapped", [29705]], [[63949, 63949], "mapped", [30041]], [[63950, 63950], "mapped", [30827]], [[63951, 63951], "mapped", [32016]], [[63952, 63952], "mapped", [39006]], [[63953, 63953], "mapped", [20845]], [[63954, 63954], "mapped", [25134]], [[63955, 63955], "mapped", [38520]], [[63956, 63956], "mapped", [20523]], [[63957, 63957], "mapped", [23833]], [[63958, 63958], "mapped", [28138]], [[63959, 63959], "mapped", [36650]], [[63960, 63960], "mapped", [24459]], [[63961, 63961], "mapped", [24900]], [[63962, 63962], "mapped", [26647]], [[63963, 63963], "mapped", [29575]], [[63964, 63964], "mapped", [38534]], [[63965, 63965], "mapped", [21033]], [[63966, 63966], "mapped", [21519]], [[63967, 63967], "mapped", [23653]], [[63968, 63968], "mapped", [26131]], [[63969, 63969], "mapped", [26446]], [[63970, 63970], "mapped", [26792]], [[63971, 63971], "mapped", [27877]], [[63972, 63972], "mapped", [29702]], [[63973, 63973], "mapped", [30178]], [[63974, 63974], "mapped", [32633]], [[63975, 63975], "mapped", [35023]], [[63976, 63976], "mapped", [35041]], [[63977, 63977], "mapped", [37324]], [[63978, 63978], "mapped", [38626]], [[63979, 63979], "mapped", [21311]], [[63980, 63980], "mapped", [28346]], [[63981, 63981], "mapped", [21533]], [[63982, 63982], "mapped", [29136]], [[63983, 63983], "mapped", [29848]], [[63984, 63984], "mapped", [34298]], [[63985, 63985], "mapped", [38563]], [[63986, 63986], "mapped", [40023]], [[63987, 63987], "mapped", [40607]], [[63988, 63988], "mapped", [26519]], [[63989, 63989], "mapped", [28107]], [[63990, 63990], "mapped", [33256]], [[63991, 63991], "mapped", [31435]], [[63992, 63992], "mapped", [31520]], [[63993, 63993], "mapped", [31890]], [[63994, 63994], "mapped", [29376]], [[63995, 63995], "mapped", [28825]], [[63996, 63996], "mapped", [35672]], [[63997, 63997], "mapped", [20160]], [[63998, 63998], "mapped", [33590]], [[63999, 63999], "mapped", [21050]], [[64e3, 64e3], "mapped", [20999]], [[64001, 64001], "mapped", [24230]], [[64002, 64002], "mapped", [25299]], [[64003, 64003], "mapped", [31958]], [[64004, 64004], "mapped", [23429]], [[64005, 64005], "mapped", [27934]], [[64006, 64006], "mapped", [26292]], [[64007, 64007], "mapped", [36667]], [[64008, 64008], "mapped", [34892]], [[64009, 64009], "mapped", [38477]], [[64010, 64010], "mapped", [35211]], [[64011, 64011], "mapped", [24275]], [[64012, 64012], "mapped", [20800]], [[64013, 64013], "mapped", [21952]], [[64014, 64015], "valid"], [[64016, 64016], "mapped", [22618]], [[64017, 64017], "valid"], [[64018, 64018], "mapped", [26228]], [[64019, 64020], "valid"], [[64021, 64021], "mapped", [20958]], [[64022, 64022], "mapped", [29482]], [[64023, 64023], "mapped", [30410]], [[64024, 64024], "mapped", [31036]], [[64025, 64025], "mapped", [31070]], [[64026, 64026], "mapped", [31077]], [[64027, 64027], "mapped", [31119]], [[64028, 64028], "mapped", [38742]], [[64029, 64029], "mapped", [31934]], [[64030, 64030], "mapped", [32701]], [[64031, 64031], "valid"], [[64032, 64032], "mapped", [34322]], [[64033, 64033], "valid"], [[64034, 64034], "mapped", [35576]], [[64035, 64036], "valid"], [[64037, 64037], "mapped", [36920]], [[64038, 64038], "mapped", [37117]], [[64039, 64041], "valid"], [[64042, 64042], "mapped", [39151]], [[64043, 64043], "mapped", [39164]], [[64044, 64044], "mapped", [39208]], [[64045, 64045], "mapped", [40372]], [[64046, 64046], "mapped", [37086]], [[64047, 64047], "mapped", [38583]], [[64048, 64048], "mapped", [20398]], [[64049, 64049], "mapped", [20711]], [[64050, 64050], "mapped", [20813]], [[64051, 64051], "mapped", [21193]], [[64052, 64052], "mapped", [21220]], [[64053, 64053], "mapped", [21329]], [[64054, 64054], "mapped", [21917]], [[64055, 64055], "mapped", [22022]], [[64056, 64056], "mapped", [22120]], [[64057, 64057], "mapped", [22592]], [[64058, 64058], "mapped", [22696]], [[64059, 64059], "mapped", [23652]], [[64060, 64060], "mapped", [23662]], [[64061, 64061], "mapped", [24724]], [[64062, 64062], "mapped", [24936]], [[64063, 64063], "mapped", [24974]], [[64064, 64064], "mapped", [25074]], [[64065, 64065], "mapped", [25935]], [[64066, 64066], "mapped", [26082]], [[64067, 64067], "mapped", [26257]], [[64068, 64068], "mapped", [26757]], [[64069, 64069], "mapped", [28023]], [[64070, 64070], "mapped", [28186]], [[64071, 64071], "mapped", [28450]], [[64072, 64072], "mapped", [29038]], [[64073, 64073], "mapped", [29227]], [[64074, 64074], "mapped", [29730]], [[64075, 64075], "mapped", [30865]], [[64076, 64076], "mapped", [31038]], [[64077, 64077], "mapped", [31049]], [[64078, 64078], "mapped", [31048]], [[64079, 64079], "mapped", [31056]], [[64080, 64080], "mapped", [31062]], [[64081, 64081], "mapped", [31069]], [[64082, 64082], "mapped", [31117]], [[64083, 64083], "mapped", [31118]], [[64084, 64084], "mapped", [31296]], [[64085, 64085], "mapped", [31361]], [[64086, 64086], "mapped", [31680]], [[64087, 64087], "mapped", [32244]], [[64088, 64088], "mapped", [32265]], [[64089, 64089], "mapped", [32321]], [[64090, 64090], "mapped", [32626]], [[64091, 64091], "mapped", [32773]], [[64092, 64092], "mapped", [33261]], [[64093, 64094], "mapped", [33401]], [[64095, 64095], "mapped", [33879]], [[64096, 64096], "mapped", [35088]], [[64097, 64097], "mapped", [35222]], [[64098, 64098], "mapped", [35585]], [[64099, 64099], "mapped", [35641]], [[64100, 64100], "mapped", [36051]], [[64101, 64101], "mapped", [36104]], [[64102, 64102], "mapped", [36790]], [[64103, 64103], "mapped", [36920]], [[64104, 64104], "mapped", [38627]], [[64105, 64105], "mapped", [38911]], [[64106, 64106], "mapped", [38971]], [[64107, 64107], "mapped", [24693]], [[64108, 64108], "mapped", [148206]], [[64109, 64109], "mapped", [33304]], [[64110, 64111], "disallowed"], [[64112, 64112], "mapped", [20006]], [[64113, 64113], "mapped", [20917]], [[64114, 64114], "mapped", [20840]], [[64115, 64115], "mapped", [20352]], [[64116, 64116], "mapped", [20805]], [[64117, 64117], "mapped", [20864]], [[64118, 64118], "mapped", [21191]], [[64119, 64119], "mapped", [21242]], [[64120, 64120], "mapped", [21917]], [[64121, 64121], "mapped", [21845]], [[64122, 64122], "mapped", [21913]], [[64123, 64123], "mapped", [21986]], [[64124, 64124], "mapped", [22618]], [[64125, 64125], "mapped", [22707]], [[64126, 64126], "mapped", [22852]], [[64127, 64127], "mapped", [22868]], [[64128, 64128], "mapped", [23138]], [[64129, 64129], "mapped", [23336]], [[64130, 64130], "mapped", [24274]], [[64131, 64131], "mapped", [24281]], [[64132, 64132], "mapped", [24425]], [[64133, 64133], "mapped", [24493]], [[64134, 64134], "mapped", [24792]], [[64135, 64135], "mapped", [24910]], [[64136, 64136], "mapped", [24840]], [[64137, 64137], "mapped", [24974]], [[64138, 64138], "mapped", [24928]], [[64139, 64139], "mapped", [25074]], [[64140, 64140], "mapped", [25140]], [[64141, 64141], "mapped", [25540]], [[64142, 64142], "mapped", [25628]], [[64143, 64143], "mapped", [25682]], [[64144, 64144], "mapped", [25942]], [[64145, 64145], "mapped", [26228]], [[64146, 64146], "mapped", [26391]], [[64147, 64147], "mapped", [26395]], [[64148, 64148], "mapped", [26454]], [[64149, 64149], "mapped", [27513]], [[64150, 64150], "mapped", [27578]], [[64151, 64151], "mapped", [27969]], [[64152, 64152], "mapped", [28379]], [[64153, 64153], "mapped", [28363]], [[64154, 64154], "mapped", [28450]], [[64155, 64155], "mapped", [28702]], [[64156, 64156], "mapped", [29038]], [[64157, 64157], "mapped", [30631]], [[64158, 64158], "mapped", [29237]], [[64159, 64159], "mapped", [29359]], [[64160, 64160], "mapped", [29482]], [[64161, 64161], "mapped", [29809]], [[64162, 64162], "mapped", [29958]], [[64163, 64163], "mapped", [30011]], [[64164, 64164], "mapped", [30237]], [[64165, 64165], "mapped", [30239]], [[64166, 64166], "mapped", [30410]], [[64167, 64167], "mapped", [30427]], [[64168, 64168], "mapped", [30452]], [[64169, 64169], "mapped", [30538]], [[64170, 64170], "mapped", [30528]], [[64171, 64171], "mapped", [30924]], [[64172, 64172], "mapped", [31409]], [[64173, 64173], "mapped", [31680]], [[64174, 64174], "mapped", [31867]], [[64175, 64175], "mapped", [32091]], [[64176, 64176], "mapped", [32244]], [[64177, 64177], "mapped", [32574]], [[64178, 64178], "mapped", [32773]], [[64179, 64179], "mapped", [33618]], [[64180, 64180], "mapped", [33775]], [[64181, 64181], "mapped", [34681]], [[64182, 64182], "mapped", [35137]], [[64183, 64183], "mapped", [35206]], [[64184, 64184], "mapped", [35222]], [[64185, 64185], "mapped", [35519]], [[64186, 64186], "mapped", [35576]], [[64187, 64187], "mapped", [35531]], [[64188, 64188], "mapped", [35585]], [[64189, 64189], "mapped", [35582]], [[64190, 64190], "mapped", [35565]], [[64191, 64191], "mapped", [35641]], [[64192, 64192], "mapped", [35722]], [[64193, 64193], "mapped", [36104]], [[64194, 64194], "mapped", [36664]], [[64195, 64195], "mapped", [36978]], [[64196, 64196], "mapped", [37273]], [[64197, 64197], "mapped", [37494]], [[64198, 64198], "mapped", [38524]], [[64199, 64199], "mapped", [38627]], [[64200, 64200], "mapped", [38742]], [[64201, 64201], "mapped", [38875]], [[64202, 64202], "mapped", [38911]], [[64203, 64203], "mapped", [38923]], [[64204, 64204], "mapped", [38971]], [[64205, 64205], "mapped", [39698]], [[64206, 64206], "mapped", [40860]], [[64207, 64207], "mapped", [141386]], [[64208, 64208], "mapped", [141380]], [[64209, 64209], "mapped", [144341]], [[64210, 64210], "mapped", [15261]], [[64211, 64211], "mapped", [16408]], [[64212, 64212], "mapped", [16441]], [[64213, 64213], "mapped", [152137]], [[64214, 64214], "mapped", [154832]], [[64215, 64215], "mapped", [163539]], [[64216, 64216], "mapped", [40771]], [[64217, 64217], "mapped", [40846]], [[64218, 64255], "disallowed"], [[64256, 64256], "mapped", [102, 102]], [[64257, 64257], "mapped", [102, 105]], [[64258, 64258], "mapped", [102, 108]], [[64259, 64259], "mapped", [102, 102, 105]], [[64260, 64260], "mapped", [102, 102, 108]], [[64261, 64262], "mapped", [115, 116]], [[64263, 64274], "disallowed"], [[64275, 64275], "mapped", [1396, 1398]], [[64276, 64276], "mapped", [1396, 1381]], [[64277, 64277], "mapped", [1396, 1387]], [[64278, 64278], "mapped", [1406, 1398]], [[64279, 64279], "mapped", [1396, 1389]], [[64280, 64284], "disallowed"], [[64285, 64285], "mapped", [1497, 1460]], [[64286, 64286], "valid"], [[64287, 64287], "mapped", [1522, 1463]], [[64288, 64288], "mapped", [1506]], [[64289, 64289], "mapped", [1488]], [[64290, 64290], "mapped", [1491]], [[64291, 64291], "mapped", [1492]], [[64292, 64292], "mapped", [1499]], [[64293, 64293], "mapped", [1500]], [[64294, 64294], "mapped", [1501]], [[64295, 64295], "mapped", [1512]], [[64296, 64296], "mapped", [1514]], [[64297, 64297], "disallowed_STD3_mapped", [43]], [[64298, 64298], "mapped", [1513, 1473]], [[64299, 64299], "mapped", [1513, 1474]], [[64300, 64300], "mapped", [1513, 1468, 1473]], [[64301, 64301], "mapped", [1513, 1468, 1474]], [[64302, 64302], "mapped", [1488, 1463]], [[64303, 64303], "mapped", [1488, 1464]], [[64304, 64304], "mapped", [1488, 1468]], [[64305, 64305], "mapped", [1489, 1468]], [[64306, 64306], "mapped", [1490, 1468]], [[64307, 64307], "mapped", [1491, 1468]], [[64308, 64308], "mapped", [1492, 1468]], [[64309, 64309], "mapped", [1493, 1468]], [[64310, 64310], "mapped", [1494, 1468]], [[64311, 64311], "disallowed"], [[64312, 64312], "mapped", [1496, 1468]], [[64313, 64313], "mapped", [1497, 1468]], [[64314, 64314], "mapped", [1498, 1468]], [[64315, 64315], "mapped", [1499, 1468]], [[64316, 64316], "mapped", [1500, 1468]], [[64317, 64317], "disallowed"], [[64318, 64318], "mapped", [1502, 1468]], [[64319, 64319], "disallowed"], [[64320, 64320], "mapped", [1504, 1468]], [[64321, 64321], "mapped", [1505, 1468]], [[64322, 64322], "disallowed"], [[64323, 64323], "mapped", [1507, 1468]], [[64324, 64324], "mapped", [1508, 1468]], [[64325, 64325], "disallowed"], [[64326, 64326], "mapped", [1510, 1468]], [[64327, 64327], "mapped", [1511, 1468]], [[64328, 64328], "mapped", [1512, 1468]], [[64329, 64329], "mapped", [1513, 1468]], [[64330, 64330], "mapped", [1514, 1468]], [[64331, 64331], "mapped", [1493, 1465]], [[64332, 64332], "mapped", [1489, 1471]], [[64333, 64333], "mapped", [1499, 1471]], [[64334, 64334], "mapped", [1508, 1471]], [[64335, 64335], "mapped", [1488, 1500]], [[64336, 64337], "mapped", [1649]], [[64338, 64341], "mapped", [1659]], [[64342, 64345], "mapped", [1662]], [[64346, 64349], "mapped", [1664]], [[64350, 64353], "mapped", [1658]], [[64354, 64357], "mapped", [1663]], [[64358, 64361], "mapped", [1657]], [[64362, 64365], "mapped", [1700]], [[64366, 64369], "mapped", [1702]], [[64370, 64373], "mapped", [1668]], [[64374, 64377], "mapped", [1667]], [[64378, 64381], "mapped", [1670]], [[64382, 64385], "mapped", [1671]], [[64386, 64387], "mapped", [1677]], [[64388, 64389], "mapped", [1676]], [[64390, 64391], "mapped", [1678]], [[64392, 64393], "mapped", [1672]], [[64394, 64395], "mapped", [1688]], [[64396, 64397], "mapped", [1681]], [[64398, 64401], "mapped", [1705]], [[64402, 64405], "mapped", [1711]], [[64406, 64409], "mapped", [1715]], [[64410, 64413], "mapped", [1713]], [[64414, 64415], "mapped", [1722]], [[64416, 64419], "mapped", [1723]], [[64420, 64421], "mapped", [1728]], [[64422, 64425], "mapped", [1729]], [[64426, 64429], "mapped", [1726]], [[64430, 64431], "mapped", [1746]], [[64432, 64433], "mapped", [1747]], [[64434, 64449], "valid", [], "NV8"], [[64450, 64466], "disallowed"], [[64467, 64470], "mapped", [1709]], [[64471, 64472], "mapped", [1735]], [[64473, 64474], "mapped", [1734]], [[64475, 64476], "mapped", [1736]], [[64477, 64477], "mapped", [1735, 1652]], [[64478, 64479], "mapped", [1739]], [[64480, 64481], "mapped", [1733]], [[64482, 64483], "mapped", [1737]], [[64484, 64487], "mapped", [1744]], [[64488, 64489], "mapped", [1609]], [[64490, 64491], "mapped", [1574, 1575]], [[64492, 64493], "mapped", [1574, 1749]], [[64494, 64495], "mapped", [1574, 1608]], [[64496, 64497], "mapped", [1574, 1735]], [[64498, 64499], "mapped", [1574, 1734]], [[64500, 64501], "mapped", [1574, 1736]], [[64502, 64504], "mapped", [1574, 1744]], [[64505, 64507], "mapped", [1574, 1609]], [[64508, 64511], "mapped", [1740]], [[64512, 64512], "mapped", [1574, 1580]], [[64513, 64513], "mapped", [1574, 1581]], [[64514, 64514], "mapped", [1574, 1605]], [[64515, 64515], "mapped", [1574, 1609]], [[64516, 64516], "mapped", [1574, 1610]], [[64517, 64517], "mapped", [1576, 1580]], [[64518, 64518], "mapped", [1576, 1581]], [[64519, 64519], "mapped", [1576, 1582]], [[64520, 64520], "mapped", [1576, 1605]], [[64521, 64521], "mapped", [1576, 1609]], [[64522, 64522], "mapped", [1576, 1610]], [[64523, 64523], "mapped", [1578, 1580]], [[64524, 64524], "mapped", [1578, 1581]], [[64525, 64525], "mapped", [1578, 1582]], [[64526, 64526], "mapped", [1578, 1605]], [[64527, 64527], "mapped", [1578, 1609]], [[64528, 64528], "mapped", [1578, 1610]], [[64529, 64529], "mapped", [1579, 1580]], [[64530, 64530], "mapped", [1579, 1605]], [[64531, 64531], "mapped", [1579, 1609]], [[64532, 64532], "mapped", [1579, 1610]], [[64533, 64533], "mapped", [1580, 1581]], [[64534, 64534], "mapped", [1580, 1605]], [[64535, 64535], "mapped", [1581, 1580]], [[64536, 64536], "mapped", [1581, 1605]], [[64537, 64537], "mapped", [1582, 1580]], [[64538, 64538], "mapped", [1582, 1581]], [[64539, 64539], "mapped", [1582, 1605]], [[64540, 64540], "mapped", [1587, 1580]], [[64541, 64541], "mapped", [1587, 1581]], [[64542, 64542], "mapped", [1587, 1582]], [[64543, 64543], "mapped", [1587, 1605]], [[64544, 64544], "mapped", [1589, 1581]], [[64545, 64545], "mapped", [1589, 1605]], [[64546, 64546], "mapped", [1590, 1580]], [[64547, 64547], "mapped", [1590, 1581]], [[64548, 64548], "mapped", [1590, 1582]], [[64549, 64549], "mapped", [1590, 1605]], [[64550, 64550], "mapped", [1591, 1581]], [[64551, 64551], "mapped", [1591, 1605]], [[64552, 64552], "mapped", [1592, 1605]], [[64553, 64553], "mapped", [1593, 1580]], [[64554, 64554], "mapped", [1593, 1605]], [[64555, 64555], "mapped", [1594, 1580]], [[64556, 64556], "mapped", [1594, 1605]], [[64557, 64557], "mapped", [1601, 1580]], [[64558, 64558], "mapped", [1601, 1581]], [[64559, 64559], "mapped", [1601, 1582]], [[64560, 64560], "mapped", [1601, 1605]], [[64561, 64561], "mapped", [1601, 1609]], [[64562, 64562], "mapped", [1601, 1610]], [[64563, 64563], "mapped", [1602, 1581]], [[64564, 64564], "mapped", [1602, 1605]], [[64565, 64565], "mapped", [1602, 1609]], [[64566, 64566], "mapped", [1602, 1610]], [[64567, 64567], "mapped", [1603, 1575]], [[64568, 64568], "mapped", [1603, 1580]], [[64569, 64569], "mapped", [1603, 1581]], [[64570, 64570], "mapped", [1603, 1582]], [[64571, 64571], "mapped", [1603, 1604]], [[64572, 64572], "mapped", [1603, 1605]], [[64573, 64573], "mapped", [1603, 1609]], [[64574, 64574], "mapped", [1603, 1610]], [[64575, 64575], "mapped", [1604, 1580]], [[64576, 64576], "mapped", [1604, 1581]], [[64577, 64577], "mapped", [1604, 1582]], [[64578, 64578], "mapped", [1604, 1605]], [[64579, 64579], "mapped", [1604, 1609]], [[64580, 64580], "mapped", [1604, 1610]], [[64581, 64581], "mapped", [1605, 1580]], [[64582, 64582], "mapped", [1605, 1581]], [[64583, 64583], "mapped", [1605, 1582]], [[64584, 64584], "mapped", [1605, 1605]], [[64585, 64585], "mapped", [1605, 1609]], [[64586, 64586], "mapped", [1605, 1610]], [[64587, 64587], "mapped", [1606, 1580]], [[64588, 64588], "mapped", [1606, 1581]], [[64589, 64589], "mapped", [1606, 1582]], [[64590, 64590], "mapped", [1606, 1605]], [[64591, 64591], "mapped", [1606, 1609]], [[64592, 64592], "mapped", [1606, 1610]], [[64593, 64593], "mapped", [1607, 1580]], [[64594, 64594], "mapped", [1607, 1605]], [[64595, 64595], "mapped", [1607, 1609]], [[64596, 64596], "mapped", [1607, 1610]], [[64597, 64597], "mapped", [1610, 1580]], [[64598, 64598], "mapped", [1610, 1581]], [[64599, 64599], "mapped", [1610, 1582]], [[64600, 64600], "mapped", [1610, 1605]], [[64601, 64601], "mapped", [1610, 1609]], [[64602, 64602], "mapped", [1610, 1610]], [[64603, 64603], "mapped", [1584, 1648]], [[64604, 64604], "mapped", [1585, 1648]], [[64605, 64605], "mapped", [1609, 1648]], [[64606, 64606], "disallowed_STD3_mapped", [32, 1612, 1617]], [[64607, 64607], "disallowed_STD3_mapped", [32, 1613, 1617]], [[64608, 64608], "disallowed_STD3_mapped", [32, 1614, 1617]], [[64609, 64609], "disallowed_STD3_mapped", [32, 1615, 1617]], [[64610, 64610], "disallowed_STD3_mapped", [32, 1616, 1617]], [[64611, 64611], "disallowed_STD3_mapped", [32, 1617, 1648]], [[64612, 64612], "mapped", [1574, 1585]], [[64613, 64613], "mapped", [1574, 1586]], [[64614, 64614], "mapped", [1574, 1605]], [[64615, 64615], "mapped", [1574, 1606]], [[64616, 64616], "mapped", [1574, 1609]], [[64617, 64617], "mapped", [1574, 1610]], [[64618, 64618], "mapped", [1576, 1585]], [[64619, 64619], "mapped", [1576, 1586]], [[64620, 64620], "mapped", [1576, 1605]], [[64621, 64621], "mapped", [1576, 1606]], [[64622, 64622], "mapped", [1576, 1609]], [[64623, 64623], "mapped", [1576, 1610]], [[64624, 64624], "mapped", [1578, 1585]], [[64625, 64625], "mapped", [1578, 1586]], [[64626, 64626], "mapped", [1578, 1605]], [[64627, 64627], "mapped", [1578, 1606]], [[64628, 64628], "mapped", [1578, 1609]], [[64629, 64629], "mapped", [1578, 1610]], [[64630, 64630], "mapped", [1579, 1585]], [[64631, 64631], "mapped", [1579, 1586]], [[64632, 64632], "mapped", [1579, 1605]], [[64633, 64633], "mapped", [1579, 1606]], [[64634, 64634], "mapped", [1579, 1609]], [[64635, 64635], "mapped", [1579, 1610]], [[64636, 64636], "mapped", [1601, 1609]], [[64637, 64637], "mapped", [1601, 1610]], [[64638, 64638], "mapped", [1602, 1609]], [[64639, 64639], "mapped", [1602, 1610]], [[64640, 64640], "mapped", [1603, 1575]], [[64641, 64641], "mapped", [1603, 1604]], [[64642, 64642], "mapped", [1603, 1605]], [[64643, 64643], "mapped", [1603, 1609]], [[64644, 64644], "mapped", [1603, 1610]], [[64645, 64645], "mapped", [1604, 1605]], [[64646, 64646], "mapped", [1604, 1609]], [[64647, 64647], "mapped", [1604, 1610]], [[64648, 64648], "mapped", [1605, 1575]], [[64649, 64649], "mapped", [1605, 1605]], [[64650, 64650], "mapped", [1606, 1585]], [[64651, 64651], "mapped", [1606, 1586]], [[64652, 64652], "mapped", [1606, 1605]], [[64653, 64653], "mapped", [1606, 1606]], [[64654, 64654], "mapped", [1606, 1609]], [[64655, 64655], "mapped", [1606, 1610]], [[64656, 64656], "mapped", [1609, 1648]], [[64657, 64657], "mapped", [1610, 1585]], [[64658, 64658], "mapped", [1610, 1586]], [[64659, 64659], "mapped", [1610, 1605]], [[64660, 64660], "mapped", [1610, 1606]], [[64661, 64661], "mapped", [1610, 1609]], [[64662, 64662], "mapped", [1610, 1610]], [[64663, 64663], "mapped", [1574, 1580]], [[64664, 64664], "mapped", [1574, 1581]], [[64665, 64665], "mapped", [1574, 1582]], [[64666, 64666], "mapped", [1574, 1605]], [[64667, 64667], "mapped", [1574, 1607]], [[64668, 64668], "mapped", [1576, 1580]], [[64669, 64669], "mapped", [1576, 1581]], [[64670, 64670], "mapped", [1576, 1582]], [[64671, 64671], "mapped", [1576, 1605]], [[64672, 64672], "mapped", [1576, 1607]], [[64673, 64673], "mapped", [1578, 1580]], [[64674, 64674], "mapped", [1578, 1581]], [[64675, 64675], "mapped", [1578, 1582]], [[64676, 64676], "mapped", [1578, 1605]], [[64677, 64677], "mapped", [1578, 1607]], [[64678, 64678], "mapped", [1579, 1605]], [[64679, 64679], "mapped", [1580, 1581]], [[64680, 64680], "mapped", [1580, 1605]], [[64681, 64681], "mapped", [1581, 1580]], [[64682, 64682], "mapped", [1581, 1605]], [[64683, 64683], "mapped", [1582, 1580]], [[64684, 64684], "mapped", [1582, 1605]], [[64685, 64685], "mapped", [1587, 1580]], [[64686, 64686], "mapped", [1587, 1581]], [[64687, 64687], "mapped", [1587, 1582]], [[64688, 64688], "mapped", [1587, 1605]], [[64689, 64689], "mapped", [1589, 1581]], [[64690, 64690], "mapped", [1589, 1582]], [[64691, 64691], "mapped", [1589, 1605]], [[64692, 64692], "mapped", [1590, 1580]], [[64693, 64693], "mapped", [1590, 1581]], [[64694, 64694], "mapped", [1590, 1582]], [[64695, 64695], "mapped", [1590, 1605]], [[64696, 64696], "mapped", [1591, 1581]], [[64697, 64697], "mapped", [1592, 1605]], [[64698, 64698], "mapped", [1593, 1580]], [[64699, 64699], "mapped", [1593, 1605]], [[64700, 64700], "mapped", [1594, 1580]], [[64701, 64701], "mapped", [1594, 1605]], [[64702, 64702], "mapped", [1601, 1580]], [[64703, 64703], "mapped", [1601, 1581]], [[64704, 64704], "mapped", [1601, 1582]], [[64705, 64705], "mapped", [1601, 1605]], [[64706, 64706], "mapped", [1602, 1581]], [[64707, 64707], "mapped", [1602, 1605]], [[64708, 64708], "mapped", [1603, 1580]], [[64709, 64709], "mapped", [1603, 1581]], [[64710, 64710], "mapped", [1603, 1582]], [[64711, 64711], "mapped", [1603, 1604]], [[64712, 64712], "mapped", [1603, 1605]], [[64713, 64713], "mapped", [1604, 1580]], [[64714, 64714], "mapped", [1604, 1581]], [[64715, 64715], "mapped", [1604, 1582]], [[64716, 64716], "mapped", [1604, 1605]], [[64717, 64717], "mapped", [1604, 1607]], [[64718, 64718], "mapped", [1605, 1580]], [[64719, 64719], "mapped", [1605, 1581]], [[64720, 64720], "mapped", [1605, 1582]], [[64721, 64721], "mapped", [1605, 1605]], [[64722, 64722], "mapped", [1606, 1580]], [[64723, 64723], "mapped", [1606, 1581]], [[64724, 64724], "mapped", [1606, 1582]], [[64725, 64725], "mapped", [1606, 1605]], [[64726, 64726], "mapped", [1606, 1607]], [[64727, 64727], "mapped", [1607, 1580]], [[64728, 64728], "mapped", [1607, 1605]], [[64729, 64729], "mapped", [1607, 1648]], [[64730, 64730], "mapped", [1610, 1580]], [[64731, 64731], "mapped", [1610, 1581]], [[64732, 64732], "mapped", [1610, 1582]], [[64733, 64733], "mapped", [1610, 1605]], [[64734, 64734], "mapped", [1610, 1607]], [[64735, 64735], "mapped", [1574, 1605]], [[64736, 64736], "mapped", [1574, 1607]], [[64737, 64737], "mapped", [1576, 1605]], [[64738, 64738], "mapped", [1576, 1607]], [[64739, 64739], "mapped", [1578, 1605]], [[64740, 64740], "mapped", [1578, 1607]], [[64741, 64741], "mapped", [1579, 1605]], [[64742, 64742], "mapped", [1579, 1607]], [[64743, 64743], "mapped", [1587, 1605]], [[64744, 64744], "mapped", [1587, 1607]], [[64745, 64745], "mapped", [1588, 1605]], [[64746, 64746], "mapped", [1588, 1607]], [[64747, 64747], "mapped", [1603, 1604]], [[64748, 64748], "mapped", [1603, 1605]], [[64749, 64749], "mapped", [1604, 1605]], [[64750, 64750], "mapped", [1606, 1605]], [[64751, 64751], "mapped", [1606, 1607]], [[64752, 64752], "mapped", [1610, 1605]], [[64753, 64753], "mapped", [1610, 1607]], [[64754, 64754], "mapped", [1600, 1614, 1617]], [[64755, 64755], "mapped", [1600, 1615, 1617]], [[64756, 64756], "mapped", [1600, 1616, 1617]], [[64757, 64757], "mapped", [1591, 1609]], [[64758, 64758], "mapped", [1591, 1610]], [[64759, 64759], "mapped", [1593, 1609]], [[64760, 64760], "mapped", [1593, 1610]], [[64761, 64761], "mapped", [1594, 1609]], [[64762, 64762], "mapped", [1594, 1610]], [[64763, 64763], "mapped", [1587, 1609]], [[64764, 64764], "mapped", [1587, 1610]], [[64765, 64765], "mapped", [1588, 1609]], [[64766, 64766], "mapped", [1588, 1610]], [[64767, 64767], "mapped", [1581, 1609]], [[64768, 64768], "mapped", [1581, 1610]], [[64769, 64769], "mapped", [1580, 1609]], [[64770, 64770], "mapped", [1580, 1610]], [[64771, 64771], "mapped", [1582, 1609]], [[64772, 64772], "mapped", [1582, 1610]], [[64773, 64773], "mapped", [1589, 1609]], [[64774, 64774], "mapped", [1589, 1610]], [[64775, 64775], "mapped", [1590, 1609]], [[64776, 64776], "mapped", [1590, 1610]], [[64777, 64777], "mapped", [1588, 1580]], [[64778, 64778], "mapped", [1588, 1581]], [[64779, 64779], "mapped", [1588, 1582]], [[64780, 64780], "mapped", [1588, 1605]], [[64781, 64781], "mapped", [1588, 1585]], [[64782, 64782], "mapped", [1587, 1585]], [[64783, 64783], "mapped", [1589, 1585]], [[64784, 64784], "mapped", [1590, 1585]], [[64785, 64785], "mapped", [1591, 1609]], [[64786, 64786], "mapped", [1591, 1610]], [[64787, 64787], "mapped", [1593, 1609]], [[64788, 64788], "mapped", [1593, 1610]], [[64789, 64789], "mapped", [1594, 1609]], [[64790, 64790], "mapped", [1594, 1610]], [[64791, 64791], "mapped", [1587, 1609]], [[64792, 64792], "mapped", [1587, 1610]], [[64793, 64793], "mapped", [1588, 1609]], [[64794, 64794], "mapped", [1588, 1610]], [[64795, 64795], "mapped", [1581, 1609]], [[64796, 64796], "mapped", [1581, 1610]], [[64797, 64797], "mapped", [1580, 1609]], [[64798, 64798], "mapped", [1580, 1610]], [[64799, 64799], "mapped", [1582, 1609]], [[64800, 64800], "mapped", [1582, 1610]], [[64801, 64801], "mapped", [1589, 1609]], [[64802, 64802], "mapped", [1589, 1610]], [[64803, 64803], "mapped", [1590, 1609]], [[64804, 64804], "mapped", [1590, 1610]], [[64805, 64805], "mapped", [1588, 1580]], [[64806, 64806], "mapped", [1588, 1581]], [[64807, 64807], "mapped", [1588, 1582]], [[64808, 64808], "mapped", [1588, 1605]], [[64809, 64809], "mapped", [1588, 1585]], [[64810, 64810], "mapped", [1587, 1585]], [[64811, 64811], "mapped", [1589, 1585]], [[64812, 64812], "mapped", [1590, 1585]], [[64813, 64813], "mapped", [1588, 1580]], [[64814, 64814], "mapped", [1588, 1581]], [[64815, 64815], "mapped", [1588, 1582]], [[64816, 64816], "mapped", [1588, 1605]], [[64817, 64817], "mapped", [1587, 1607]], [[64818, 64818], "mapped", [1588, 1607]], [[64819, 64819], "mapped", [1591, 1605]], [[64820, 64820], "mapped", [1587, 1580]], [[64821, 64821], "mapped", [1587, 1581]], [[64822, 64822], "mapped", [1587, 1582]], [[64823, 64823], "mapped", [1588, 1580]], [[64824, 64824], "mapped", [1588, 1581]], [[64825, 64825], "mapped", [1588, 1582]], [[64826, 64826], "mapped", [1591, 1605]], [[64827, 64827], "mapped", [1592, 1605]], [[64828, 64829], "mapped", [1575, 1611]], [[64830, 64831], "valid", [], "NV8"], [[64832, 64847], "disallowed"], [[64848, 64848], "mapped", [1578, 1580, 1605]], [[64849, 64850], "mapped", [1578, 1581, 1580]], [[64851, 64851], "mapped", [1578, 1581, 1605]], [[64852, 64852], "mapped", [1578, 1582, 1605]], [[64853, 64853], "mapped", [1578, 1605, 1580]], [[64854, 64854], "mapped", [1578, 1605, 1581]], [[64855, 64855], "mapped", [1578, 1605, 1582]], [[64856, 64857], "mapped", [1580, 1605, 1581]], [[64858, 64858], "mapped", [1581, 1605, 1610]], [[64859, 64859], "mapped", [1581, 1605, 1609]], [[64860, 64860], "mapped", [1587, 1581, 1580]], [[64861, 64861], "mapped", [1587, 1580, 1581]], [[64862, 64862], "mapped", [1587, 1580, 1609]], [[64863, 64864], "mapped", [1587, 1605, 1581]], [[64865, 64865], "mapped", [1587, 1605, 1580]], [[64866, 64867], "mapped", [1587, 1605, 1605]], [[64868, 64869], "mapped", [1589, 1581, 1581]], [[64870, 64870], "mapped", [1589, 1605, 1605]], [[64871, 64872], "mapped", [1588, 1581, 1605]], [[64873, 64873], "mapped", [1588, 1580, 1610]], [[64874, 64875], "mapped", [1588, 1605, 1582]], [[64876, 64877], "mapped", [1588, 1605, 1605]], [[64878, 64878], "mapped", [1590, 1581, 1609]], [[64879, 64880], "mapped", [1590, 1582, 1605]], [[64881, 64882], "mapped", [1591, 1605, 1581]], [[64883, 64883], "mapped", [1591, 1605, 1605]], [[64884, 64884], "mapped", [1591, 1605, 1610]], [[64885, 64885], "mapped", [1593, 1580, 1605]], [[64886, 64887], "mapped", [1593, 1605, 1605]], [[64888, 64888], "mapped", [1593, 1605, 1609]], [[64889, 64889], "mapped", [1594, 1605, 1605]], [[64890, 64890], "mapped", [1594, 1605, 1610]], [[64891, 64891], "mapped", [1594, 1605, 1609]], [[64892, 64893], "mapped", [1601, 1582, 1605]], [[64894, 64894], "mapped", [1602, 1605, 1581]], [[64895, 64895], "mapped", [1602, 1605, 1605]], [[64896, 64896], "mapped", [1604, 1581, 1605]], [[64897, 64897], "mapped", [1604, 1581, 1610]], [[64898, 64898], "mapped", [1604, 1581, 1609]], [[64899, 64900], "mapped", [1604, 1580, 1580]], [[64901, 64902], "mapped", [1604, 1582, 1605]], [[64903, 64904], "mapped", [1604, 1605, 1581]], [[64905, 64905], "mapped", [1605, 1581, 1580]], [[64906, 64906], "mapped", [1605, 1581, 1605]], [[64907, 64907], "mapped", [1605, 1581, 1610]], [[64908, 64908], "mapped", [1605, 1580, 1581]], [[64909, 64909], "mapped", [1605, 1580, 1605]], [[64910, 64910], "mapped", [1605, 1582, 1580]], [[64911, 64911], "mapped", [1605, 1582, 1605]], [[64912, 64913], "disallowed"], [[64914, 64914], "mapped", [1605, 1580, 1582]], [[64915, 64915], "mapped", [1607, 1605, 1580]], [[64916, 64916], "mapped", [1607, 1605, 1605]], [[64917, 64917], "mapped", [1606, 1581, 1605]], [[64918, 64918], "mapped", [1606, 1581, 1609]], [[64919, 64920], "mapped", [1606, 1580, 1605]], [[64921, 64921], "mapped", [1606, 1580, 1609]], [[64922, 64922], "mapped", [1606, 1605, 1610]], [[64923, 64923], "mapped", [1606, 1605, 1609]], [[64924, 64925], "mapped", [1610, 1605, 1605]], [[64926, 64926], "mapped", [1576, 1582, 1610]], [[64927, 64927], "mapped", [1578, 1580, 1610]], [[64928, 64928], "mapped", [1578, 1580, 1609]], [[64929, 64929], "mapped", [1578, 1582, 1610]], [[64930, 64930], "mapped", [1578, 1582, 1609]], [[64931, 64931], "mapped", [1578, 1605, 1610]], [[64932, 64932], "mapped", [1578, 1605, 1609]], [[64933, 64933], "mapped", [1580, 1605, 1610]], [[64934, 64934], "mapped", [1580, 1581, 1609]], [[64935, 64935], "mapped", [1580, 1605, 1609]], [[64936, 64936], "mapped", [1587, 1582, 1609]], [[64937, 64937], "mapped", [1589, 1581, 1610]], [[64938, 64938], "mapped", [1588, 1581, 1610]], [[64939, 64939], "mapped", [1590, 1581, 1610]], [[64940, 64940], "mapped", [1604, 1580, 1610]], [[64941, 64941], "mapped", [1604, 1605, 1610]], [[64942, 64942], "mapped", [1610, 1581, 1610]], [[64943, 64943], "mapped", [1610, 1580, 1610]], [[64944, 64944], "mapped", [1610, 1605, 1610]], [[64945, 64945], "mapped", [1605, 1605, 1610]], [[64946, 64946], "mapped", [1602, 1605, 1610]], [[64947, 64947], "mapped", [1606, 1581, 1610]], [[64948, 64948], "mapped", [1602, 1605, 1581]], [[64949, 64949], "mapped", [1604, 1581, 1605]], [[64950, 64950], "mapped", [1593, 1605, 1610]], [[64951, 64951], "mapped", [1603, 1605, 1610]], [[64952, 64952], "mapped", [1606, 1580, 1581]], [[64953, 64953], "mapped", [1605, 1582, 1610]], [[64954, 64954], "mapped", [1604, 1580, 1605]], [[64955, 64955], "mapped", [1603, 1605, 1605]], [[64956, 64956], "mapped", [1604, 1580, 1605]], [[64957, 64957], "mapped", [1606, 1580, 1581]], [[64958, 64958], "mapped", [1580, 1581, 1610]], [[64959, 64959], "mapped", [1581, 1580, 1610]], [[64960, 64960], "mapped", [1605, 1580, 1610]], [[64961, 64961], "mapped", [1601, 1605, 1610]], [[64962, 64962], "mapped", [1576, 1581, 1610]], [[64963, 64963], "mapped", [1603, 1605, 1605]], [[64964, 64964], "mapped", [1593, 1580, 1605]], [[64965, 64965], "mapped", [1589, 1605, 1605]], [[64966, 64966], "mapped", [1587, 1582, 1610]], [[64967, 64967], "mapped", [1606, 1580, 1610]], [[64968, 64975], "disallowed"], [[64976, 65007], "disallowed"], [[65008, 65008], "mapped", [1589, 1604, 1746]], [[65009, 65009], "mapped", [1602, 1604, 1746]], [[65010, 65010], "mapped", [1575, 1604, 1604, 1607]], [[65011, 65011], "mapped", [1575, 1603, 1576, 1585]], [[65012, 65012], "mapped", [1605, 1581, 1605, 1583]], [[65013, 65013], "mapped", [1589, 1604, 1593, 1605]], [[65014, 65014], "mapped", [1585, 1587, 1608, 1604]], [[65015, 65015], "mapped", [1593, 1604, 1610, 1607]], [[65016, 65016], "mapped", [1608, 1587, 1604, 1605]], [[65017, 65017], "mapped", [1589, 1604, 1609]], [[65018, 65018], "disallowed_STD3_mapped", [1589, 1604, 1609, 32, 1575, 1604, 1604, 1607, 32, 1593, 1604, 1610, 1607, 32, 1608, 1587, 1604, 1605]], [[65019, 65019], "disallowed_STD3_mapped", [1580, 1604, 32, 1580, 1604, 1575, 1604, 1607]], [[65020, 65020], "mapped", [1585, 1740, 1575, 1604]], [[65021, 65021], "valid", [], "NV8"], [[65022, 65023], "disallowed"], [[65024, 65039], "ignored"], [[65040, 65040], "disallowed_STD3_mapped", [44]], [[65041, 65041], "mapped", [12289]], [[65042, 65042], "disallowed"], [[65043, 65043], "disallowed_STD3_mapped", [58]], [[65044, 65044], "disallowed_STD3_mapped", [59]], [[65045, 65045], "disallowed_STD3_mapped", [33]], [[65046, 65046], "disallowed_STD3_mapped", [63]], [[65047, 65047], "mapped", [12310]], [[65048, 65048], "mapped", [12311]], [[65049, 65049], "disallowed"], [[65050, 65055], "disallowed"], [[65056, 65059], "valid"], [[65060, 65062], "valid"], [[65063, 65069], "valid"], [[65070, 65071], "valid"], [[65072, 65072], "disallowed"], [[65073, 65073], "mapped", [8212]], [[65074, 65074], "mapped", [8211]], [[65075, 65076], "disallowed_STD3_mapped", [95]], [[65077, 65077], "disallowed_STD3_mapped", [40]], [[65078, 65078], "disallowed_STD3_mapped", [41]], [[65079, 65079], "disallowed_STD3_mapped", [123]], [[65080, 65080], "disallowed_STD3_mapped", [125]], [[65081, 65081], "mapped", [12308]], [[65082, 65082], "mapped", [12309]], [[65083, 65083], "mapped", [12304]], [[65084, 65084], "mapped", [12305]], [[65085, 65085], "mapped", [12298]], [[65086, 65086], "mapped", [12299]], [[65087, 65087], "mapped", [12296]], [[65088, 65088], "mapped", [12297]], [[65089, 65089], "mapped", [12300]], [[65090, 65090], "mapped", [12301]], [[65091, 65091], "mapped", [12302]], [[65092, 65092], "mapped", [12303]], [[65093, 65094], "valid", [], "NV8"], [[65095, 65095], "disallowed_STD3_mapped", [91]], [[65096, 65096], "disallowed_STD3_mapped", [93]], [[65097, 65100], "disallowed_STD3_mapped", [32, 773]], [[65101, 65103], "disallowed_STD3_mapped", [95]], [[65104, 65104], "disallowed_STD3_mapped", [44]], [[65105, 65105], "mapped", [12289]], [[65106, 65106], "disallowed"], [[65107, 65107], "disallowed"], [[65108, 65108], "disallowed_STD3_mapped", [59]], [[65109, 65109], "disallowed_STD3_mapped", [58]], [[65110, 65110], "disallowed_STD3_mapped", [63]], [[65111, 65111], "disallowed_STD3_mapped", [33]], [[65112, 65112], "mapped", [8212]], [[65113, 65113], "disallowed_STD3_mapped", [40]], [[65114, 65114], "disallowed_STD3_mapped", [41]], [[65115, 65115], "disallowed_STD3_mapped", [123]], [[65116, 65116], "disallowed_STD3_mapped", [125]], [[65117, 65117], "mapped", [12308]], [[65118, 65118], "mapped", [12309]], [[65119, 65119], "disallowed_STD3_mapped", [35]], [[65120, 65120], "disallowed_STD3_mapped", [38]], [[65121, 65121], "disallowed_STD3_mapped", [42]], [[65122, 65122], "disallowed_STD3_mapped", [43]], [[65123, 65123], "mapped", [45]], [[65124, 65124], "disallowed_STD3_mapped", [60]], [[65125, 65125], "disallowed_STD3_mapped", [62]], [[65126, 65126], "disallowed_STD3_mapped", [61]], [[65127, 65127], "disallowed"], [[65128, 65128], "disallowed_STD3_mapped", [92]], [[65129, 65129], "disallowed_STD3_mapped", [36]], [[65130, 65130], "disallowed_STD3_mapped", [37]], [[65131, 65131], "disallowed_STD3_mapped", [64]], [[65132, 65135], "disallowed"], [[65136, 65136], "disallowed_STD3_mapped", [32, 1611]], [[65137, 65137], "mapped", [1600, 1611]], [[65138, 65138], "disallowed_STD3_mapped", [32, 1612]], [[65139, 65139], "valid"], [[65140, 65140], "disallowed_STD3_mapped", [32, 1613]], [[65141, 65141], "disallowed"], [[65142, 65142], "disallowed_STD3_mapped", [32, 1614]], [[65143, 65143], "mapped", [1600, 1614]], [[65144, 65144], "disallowed_STD3_mapped", [32, 1615]], [[65145, 65145], "mapped", [1600, 1615]], [[65146, 65146], "disallowed_STD3_mapped", [32, 1616]], [[65147, 65147], "mapped", [1600, 1616]], [[65148, 65148], "disallowed_STD3_mapped", [32, 1617]], [[65149, 65149], "mapped", [1600, 1617]], [[65150, 65150], "disallowed_STD3_mapped", [32, 1618]], [[65151, 65151], "mapped", [1600, 1618]], [[65152, 65152], "mapped", [1569]], [[65153, 65154], "mapped", [1570]], [[65155, 65156], "mapped", [1571]], [[65157, 65158], "mapped", [1572]], [[65159, 65160], "mapped", [1573]], [[65161, 65164], "mapped", [1574]], [[65165, 65166], "mapped", [1575]], [[65167, 65170], "mapped", [1576]], [[65171, 65172], "mapped", [1577]], [[65173, 65176], "mapped", [1578]], [[65177, 65180], "mapped", [1579]], [[65181, 65184], "mapped", [1580]], [[65185, 65188], "mapped", [1581]], [[65189, 65192], "mapped", [1582]], [[65193, 65194], "mapped", [1583]], [[65195, 65196], "mapped", [1584]], [[65197, 65198], "mapped", [1585]], [[65199, 65200], "mapped", [1586]], [[65201, 65204], "mapped", [1587]], [[65205, 65208], "mapped", [1588]], [[65209, 65212], "mapped", [1589]], [[65213, 65216], "mapped", [1590]], [[65217, 65220], "mapped", [1591]], [[65221, 65224], "mapped", [1592]], [[65225, 65228], "mapped", [1593]], [[65229, 65232], "mapped", [1594]], [[65233, 65236], "mapped", [1601]], [[65237, 65240], "mapped", [1602]], [[65241, 65244], "mapped", [1603]], [[65245, 65248], "mapped", [1604]], [[65249, 65252], "mapped", [1605]], [[65253, 65256], "mapped", [1606]], [[65257, 65260], "mapped", [1607]], [[65261, 65262], "mapped", [1608]], [[65263, 65264], "mapped", [1609]], [[65265, 65268], "mapped", [1610]], [[65269, 65270], "mapped", [1604, 1570]], [[65271, 65272], "mapped", [1604, 1571]], [[65273, 65274], "mapped", [1604, 1573]], [[65275, 65276], "mapped", [1604, 1575]], [[65277, 65278], "disallowed"], [[65279, 65279], "ignored"], [[65280, 65280], "disallowed"], [[65281, 65281], "disallowed_STD3_mapped", [33]], [[65282, 65282], "disallowed_STD3_mapped", [34]], [[65283, 65283], "disallowed_STD3_mapped", [35]], [[65284, 65284], "disallowed_STD3_mapped", [36]], [[65285, 65285], "disallowed_STD3_mapped", [37]], [[65286, 65286], "disallowed_STD3_mapped", [38]], [[65287, 65287], "disallowed_STD3_mapped", [39]], [[65288, 65288], "disallowed_STD3_mapped", [40]], [[65289, 65289], "disallowed_STD3_mapped", [41]], [[65290, 65290], "disallowed_STD3_mapped", [42]], [[65291, 65291], "disallowed_STD3_mapped", [43]], [[65292, 65292], "disallowed_STD3_mapped", [44]], [[65293, 65293], "mapped", [45]], [[65294, 65294], "mapped", [46]], [[65295, 65295], "disallowed_STD3_mapped", [47]], [[65296, 65296], "mapped", [48]], [[65297, 65297], "mapped", [49]], [[65298, 65298], "mapped", [50]], [[65299, 65299], "mapped", [51]], [[65300, 65300], "mapped", [52]], [[65301, 65301], "mapped", [53]], [[65302, 65302], "mapped", [54]], [[65303, 65303], "mapped", [55]], [[65304, 65304], "mapped", [56]], [[65305, 65305], "mapped", [57]], [[65306, 65306], "disallowed_STD3_mapped", [58]], [[65307, 65307], "disallowed_STD3_mapped", [59]], [[65308, 65308], "disallowed_STD3_mapped", [60]], [[65309, 65309], "disallowed_STD3_mapped", [61]], [[65310, 65310], "disallowed_STD3_mapped", [62]], [[65311, 65311], "disallowed_STD3_mapped", [63]], [[65312, 65312], "disallowed_STD3_mapped", [64]], [[65313, 65313], "mapped", [97]], [[65314, 65314], "mapped", [98]], [[65315, 65315], "mapped", [99]], [[65316, 65316], "mapped", [100]], [[65317, 65317], "mapped", [101]], [[65318, 65318], "mapped", [102]], [[65319, 65319], "mapped", [103]], [[65320, 65320], "mapped", [104]], [[65321, 65321], "mapped", [105]], [[65322, 65322], "mapped", [106]], [[65323, 65323], "mapped", [107]], [[65324, 65324], "mapped", [108]], [[65325, 65325], "mapped", [109]], [[65326, 65326], "mapped", [110]], [[65327, 65327], "mapped", [111]], [[65328, 65328], "mapped", [112]], [[65329, 65329], "mapped", [113]], [[65330, 65330], "mapped", [114]], [[65331, 65331], "mapped", [115]], [[65332, 65332], "mapped", [116]], [[65333, 65333], "mapped", [117]], [[65334, 65334], "mapped", [118]], [[65335, 65335], "mapped", [119]], [[65336, 65336], "mapped", [120]], [[65337, 65337], "mapped", [121]], [[65338, 65338], "mapped", [122]], [[65339, 65339], "disallowed_STD3_mapped", [91]], [[65340, 65340], "disallowed_STD3_mapped", [92]], [[65341, 65341], "disallowed_STD3_mapped", [93]], [[65342, 65342], "disallowed_STD3_mapped", [94]], [[65343, 65343], "disallowed_STD3_mapped", [95]], [[65344, 65344], "disallowed_STD3_mapped", [96]], [[65345, 65345], "mapped", [97]], [[65346, 65346], "mapped", [98]], [[65347, 65347], "mapped", [99]], [[65348, 65348], "mapped", [100]], [[65349, 65349], "mapped", [101]], [[65350, 65350], "mapped", [102]], [[65351, 65351], "mapped", [103]], [[65352, 65352], "mapped", [104]], [[65353, 65353], "mapped", [105]], [[65354, 65354], "mapped", [106]], [[65355, 65355], "mapped", [107]], [[65356, 65356], "mapped", [108]], [[65357, 65357], "mapped", [109]], [[65358, 65358], "mapped", [110]], [[65359, 65359], "mapped", [111]], [[65360, 65360], "mapped", [112]], [[65361, 65361], "mapped", [113]], [[65362, 65362], "mapped", [114]], [[65363, 65363], "mapped", [115]], [[65364, 65364], "mapped", [116]], [[65365, 65365], "mapped", [117]], [[65366, 65366], "mapped", [118]], [[65367, 65367], "mapped", [119]], [[65368, 65368], "mapped", [120]], [[65369, 65369], "mapped", [121]], [[65370, 65370], "mapped", [122]], [[65371, 65371], "disallowed_STD3_mapped", [123]], [[65372, 65372], "disallowed_STD3_mapped", [124]], [[65373, 65373], "disallowed_STD3_mapped", [125]], [[65374, 65374], "disallowed_STD3_mapped", [126]], [[65375, 65375], "mapped", [10629]], [[65376, 65376], "mapped", [10630]], [[65377, 65377], "mapped", [46]], [[65378, 65378], "mapped", [12300]], [[65379, 65379], "mapped", [12301]], [[65380, 65380], "mapped", [12289]], [[65381, 65381], "mapped", [12539]], [[65382, 65382], "mapped", [12530]], [[65383, 65383], "mapped", [12449]], [[65384, 65384], "mapped", [12451]], [[65385, 65385], "mapped", [12453]], [[65386, 65386], "mapped", [12455]], [[65387, 65387], "mapped", [12457]], [[65388, 65388], "mapped", [12515]], [[65389, 65389], "mapped", [12517]], [[65390, 65390], "mapped", [12519]], [[65391, 65391], "mapped", [12483]], [[65392, 65392], "mapped", [12540]], [[65393, 65393], "mapped", [12450]], [[65394, 65394], "mapped", [12452]], [[65395, 65395], "mapped", [12454]], [[65396, 65396], "mapped", [12456]], [[65397, 65397], "mapped", [12458]], [[65398, 65398], "mapped", [12459]], [[65399, 65399], "mapped", [12461]], [[65400, 65400], "mapped", [12463]], [[65401, 65401], "mapped", [12465]], [[65402, 65402], "mapped", [12467]], [[65403, 65403], "mapped", [12469]], [[65404, 65404], "mapped", [12471]], [[65405, 65405], "mapped", [12473]], [[65406, 65406], "mapped", [12475]], [[65407, 65407], "mapped", [12477]], [[65408, 65408], "mapped", [12479]], [[65409, 65409], "mapped", [12481]], [[65410, 65410], "mapped", [12484]], [[65411, 65411], "mapped", [12486]], [[65412, 65412], "mapped", [12488]], [[65413, 65413], "mapped", [12490]], [[65414, 65414], "mapped", [12491]], [[65415, 65415], "mapped", [12492]], [[65416, 65416], "mapped", [12493]], [[65417, 65417], "mapped", [12494]], [[65418, 65418], "mapped", [12495]], [[65419, 65419], "mapped", [12498]], [[65420, 65420], "mapped", [12501]], [[65421, 65421], "mapped", [12504]], [[65422, 65422], "mapped", [12507]], [[65423, 65423], "mapped", [12510]], [[65424, 65424], "mapped", [12511]], [[65425, 65425], "mapped", [12512]], [[65426, 65426], "mapped", [12513]], [[65427, 65427], "mapped", [12514]], [[65428, 65428], "mapped", [12516]], [[65429, 65429], "mapped", [12518]], [[65430, 65430], "mapped", [12520]], [[65431, 65431], "mapped", [12521]], [[65432, 65432], "mapped", [12522]], [[65433, 65433], "mapped", [12523]], [[65434, 65434], "mapped", [12524]], [[65435, 65435], "mapped", [12525]], [[65436, 65436], "mapped", [12527]], [[65437, 65437], "mapped", [12531]], [[65438, 65438], "mapped", [12441]], [[65439, 65439], "mapped", [12442]], [[65440, 65440], "disallowed"], [[65441, 65441], "mapped", [4352]], [[65442, 65442], "mapped", [4353]], [[65443, 65443], "mapped", [4522]], [[65444, 65444], "mapped", [4354]], [[65445, 65445], "mapped", [4524]], [[65446, 65446], "mapped", [4525]], [[65447, 65447], "mapped", [4355]], [[65448, 65448], "mapped", [4356]], [[65449, 65449], "mapped", [4357]], [[65450, 65450], "mapped", [4528]], [[65451, 65451], "mapped", [4529]], [[65452, 65452], "mapped", [4530]], [[65453, 65453], "mapped", [4531]], [[65454, 65454], "mapped", [4532]], [[65455, 65455], "mapped", [4533]], [[65456, 65456], "mapped", [4378]], [[65457, 65457], "mapped", [4358]], [[65458, 65458], "mapped", [4359]], [[65459, 65459], "mapped", [4360]], [[65460, 65460], "mapped", [4385]], [[65461, 65461], "mapped", [4361]], [[65462, 65462], "mapped", [4362]], [[65463, 65463], "mapped", [4363]], [[65464, 65464], "mapped", [4364]], [[65465, 65465], "mapped", [4365]], [[65466, 65466], "mapped", [4366]], [[65467, 65467], "mapped", [4367]], [[65468, 65468], "mapped", [4368]], [[65469, 65469], "mapped", [4369]], [[65470, 65470], "mapped", [4370]], [[65471, 65473], "disallowed"], [[65474, 65474], "mapped", [4449]], [[65475, 65475], "mapped", [4450]], [[65476, 65476], "mapped", [4451]], [[65477, 65477], "mapped", [4452]], [[65478, 65478], "mapped", [4453]], [[65479, 65479], "mapped", [4454]], [[65480, 65481], "disallowed"], [[65482, 65482], "mapped", [4455]], [[65483, 65483], "mapped", [4456]], [[65484, 65484], "mapped", [4457]], [[65485, 65485], "mapped", [4458]], [[65486, 65486], "mapped", [4459]], [[65487, 65487], "mapped", [4460]], [[65488, 65489], "disallowed"], [[65490, 65490], "mapped", [4461]], [[65491, 65491], "mapped", [4462]], [[65492, 65492], "mapped", [4463]], [[65493, 65493], "mapped", [4464]], [[65494, 65494], "mapped", [4465]], [[65495, 65495], "mapped", [4466]], [[65496, 65497], "disallowed"], [[65498, 65498], "mapped", [4467]], [[65499, 65499], "mapped", [4468]], [[65500, 65500], "mapped", [4469]], [[65501, 65503], "disallowed"], [[65504, 65504], "mapped", [162]], [[65505, 65505], "mapped", [163]], [[65506, 65506], "mapped", [172]], [[65507, 65507], "disallowed_STD3_mapped", [32, 772]], [[65508, 65508], "mapped", [166]], [[65509, 65509], "mapped", [165]], [[65510, 65510], "mapped", [8361]], [[65511, 65511], "disallowed"], [[65512, 65512], "mapped", [9474]], [[65513, 65513], "mapped", [8592]], [[65514, 65514], "mapped", [8593]], [[65515, 65515], "mapped", [8594]], [[65516, 65516], "mapped", [8595]], [[65517, 65517], "mapped", [9632]], [[65518, 65518], "mapped", [9675]], [[65519, 65528], "disallowed"], [[65529, 65531], "disallowed"], [[65532, 65532], "disallowed"], [[65533, 65533], "disallowed"], [[65534, 65535], "disallowed"], [[65536, 65547], "valid"], [[65548, 65548], "disallowed"], [[65549, 65574], "valid"], [[65575, 65575], "disallowed"], [[65576, 65594], "valid"], [[65595, 65595], "disallowed"], [[65596, 65597], "valid"], [[65598, 65598], "disallowed"], [[65599, 65613], "valid"], [[65614, 65615], "disallowed"], [[65616, 65629], "valid"], [[65630, 65663], "disallowed"], [[65664, 65786], "valid"], [[65787, 65791], "disallowed"], [[65792, 65794], "valid", [], "NV8"], [[65795, 65798], "disallowed"], [[65799, 65843], "valid", [], "NV8"], [[65844, 65846], "disallowed"], [[65847, 65855], "valid", [], "NV8"], [[65856, 65930], "valid", [], "NV8"], [[65931, 65932], "valid", [], "NV8"], [[65933, 65935], "disallowed"], [[65936, 65947], "valid", [], "NV8"], [[65948, 65951], "disallowed"], [[65952, 65952], "valid", [], "NV8"], [[65953, 65999], "disallowed"], [[66e3, 66044], "valid", [], "NV8"], [[66045, 66045], "valid"], [[66046, 66175], "disallowed"], [[66176, 66204], "valid"], [[66205, 66207], "disallowed"], [[66208, 66256], "valid"], [[66257, 66271], "disallowed"], [[66272, 66272], "valid"], [[66273, 66299], "valid", [], "NV8"], [[66300, 66303], "disallowed"], [[66304, 66334], "valid"], [[66335, 66335], "valid"], [[66336, 66339], "valid", [], "NV8"], [[66340, 66351], "disallowed"], [[66352, 66368], "valid"], [[66369, 66369], "valid", [], "NV8"], [[66370, 66377], "valid"], [[66378, 66378], "valid", [], "NV8"], [[66379, 66383], "disallowed"], [[66384, 66426], "valid"], [[66427, 66431], "disallowed"], [[66432, 66461], "valid"], [[66462, 66462], "disallowed"], [[66463, 66463], "valid", [], "NV8"], [[66464, 66499], "valid"], [[66500, 66503], "disallowed"], [[66504, 66511], "valid"], [[66512, 66517], "valid", [], "NV8"], [[66518, 66559], "disallowed"], [[66560, 66560], "mapped", [66600]], [[66561, 66561], "mapped", [66601]], [[66562, 66562], "mapped", [66602]], [[66563, 66563], "mapped", [66603]], [[66564, 66564], "mapped", [66604]], [[66565, 66565], "mapped", [66605]], [[66566, 66566], "mapped", [66606]], [[66567, 66567], "mapped", [66607]], [[66568, 66568], "mapped", [66608]], [[66569, 66569], "mapped", [66609]], [[66570, 66570], "mapped", [66610]], [[66571, 66571], "mapped", [66611]], [[66572, 66572], "mapped", [66612]], [[66573, 66573], "mapped", [66613]], [[66574, 66574], "mapped", [66614]], [[66575, 66575], "mapped", [66615]], [[66576, 66576], "mapped", [66616]], [[66577, 66577], "mapped", [66617]], [[66578, 66578], "mapped", [66618]], [[66579, 66579], "mapped", [66619]], [[66580, 66580], "mapped", [66620]], [[66581, 66581], "mapped", [66621]], [[66582, 66582], "mapped", [66622]], [[66583, 66583], "mapped", [66623]], [[66584, 66584], "mapped", [66624]], [[66585, 66585], "mapped", [66625]], [[66586, 66586], "mapped", [66626]], [[66587, 66587], "mapped", [66627]], [[66588, 66588], "mapped", [66628]], [[66589, 66589], "mapped", [66629]], [[66590, 66590], "mapped", [66630]], [[66591, 66591], "mapped", [66631]], [[66592, 66592], "mapped", [66632]], [[66593, 66593], "mapped", [66633]], [[66594, 66594], "mapped", [66634]], [[66595, 66595], "mapped", [66635]], [[66596, 66596], "mapped", [66636]], [[66597, 66597], "mapped", [66637]], [[66598, 66598], "mapped", [66638]], [[66599, 66599], "mapped", [66639]], [[66600, 66637], "valid"], [[66638, 66717], "valid"], [[66718, 66719], "disallowed"], [[66720, 66729], "valid"], [[66730, 66815], "disallowed"], [[66816, 66855], "valid"], [[66856, 66863], "disallowed"], [[66864, 66915], "valid"], [[66916, 66926], "disallowed"], [[66927, 66927], "valid", [], "NV8"], [[66928, 67071], "disallowed"], [[67072, 67382], "valid"], [[67383, 67391], "disallowed"], [[67392, 67413], "valid"], [[67414, 67423], "disallowed"], [[67424, 67431], "valid"], [[67432, 67583], "disallowed"], [[67584, 67589], "valid"], [[67590, 67591], "disallowed"], [[67592, 67592], "valid"], [[67593, 67593], "disallowed"], [[67594, 67637], "valid"], [[67638, 67638], "disallowed"], [[67639, 67640], "valid"], [[67641, 67643], "disallowed"], [[67644, 67644], "valid"], [[67645, 67646], "disallowed"], [[67647, 67647], "valid"], [[67648, 67669], "valid"], [[67670, 67670], "disallowed"], [[67671, 67679], "valid", [], "NV8"], [[67680, 67702], "valid"], [[67703, 67711], "valid", [], "NV8"], [[67712, 67742], "valid"], [[67743, 67750], "disallowed"], [[67751, 67759], "valid", [], "NV8"], [[67760, 67807], "disallowed"], [[67808, 67826], "valid"], [[67827, 67827], "disallowed"], [[67828, 67829], "valid"], [[67830, 67834], "disallowed"], [[67835, 67839], "valid", [], "NV8"], [[67840, 67861], "valid"], [[67862, 67865], "valid", [], "NV8"], [[67866, 67867], "valid", [], "NV8"], [[67868, 67870], "disallowed"], [[67871, 67871], "valid", [], "NV8"], [[67872, 67897], "valid"], [[67898, 67902], "disallowed"], [[67903, 67903], "valid", [], "NV8"], [[67904, 67967], "disallowed"], [[67968, 68023], "valid"], [[68024, 68027], "disallowed"], [[68028, 68029], "valid", [], "NV8"], [[68030, 68031], "valid"], [[68032, 68047], "valid", [], "NV8"], [[68048, 68049], "disallowed"], [[68050, 68095], "valid", [], "NV8"], [[68096, 68099], "valid"], [[68100, 68100], "disallowed"], [[68101, 68102], "valid"], [[68103, 68107], "disallowed"], [[68108, 68115], "valid"], [[68116, 68116], "disallowed"], [[68117, 68119], "valid"], [[68120, 68120], "disallowed"], [[68121, 68147], "valid"], [[68148, 68151], "disallowed"], [[68152, 68154], "valid"], [[68155, 68158], "disallowed"], [[68159, 68159], "valid"], [[68160, 68167], "valid", [], "NV8"], [[68168, 68175], "disallowed"], [[68176, 68184], "valid", [], "NV8"], [[68185, 68191], "disallowed"], [[68192, 68220], "valid"], [[68221, 68223], "valid", [], "NV8"], [[68224, 68252], "valid"], [[68253, 68255], "valid", [], "NV8"], [[68256, 68287], "disallowed"], [[68288, 68295], "valid"], [[68296, 68296], "valid", [], "NV8"], [[68297, 68326], "valid"], [[68327, 68330], "disallowed"], [[68331, 68342], "valid", [], "NV8"], [[68343, 68351], "disallowed"], [[68352, 68405], "valid"], [[68406, 68408], "disallowed"], [[68409, 68415], "valid", [], "NV8"], [[68416, 68437], "valid"], [[68438, 68439], "disallowed"], [[68440, 68447], "valid", [], "NV8"], [[68448, 68466], "valid"], [[68467, 68471], "disallowed"], [[68472, 68479], "valid", [], "NV8"], [[68480, 68497], "valid"], [[68498, 68504], "disallowed"], [[68505, 68508], "valid", [], "NV8"], [[68509, 68520], "disallowed"], [[68521, 68527], "valid", [], "NV8"], [[68528, 68607], "disallowed"], [[68608, 68680], "valid"], [[68681, 68735], "disallowed"], [[68736, 68736], "mapped", [68800]], [[68737, 68737], "mapped", [68801]], [[68738, 68738], "mapped", [68802]], [[68739, 68739], "mapped", [68803]], [[68740, 68740], "mapped", [68804]], [[68741, 68741], "mapped", [68805]], [[68742, 68742], "mapped", [68806]], [[68743, 68743], "mapped", [68807]], [[68744, 68744], "mapped", [68808]], [[68745, 68745], "mapped", [68809]], [[68746, 68746], "mapped", [68810]], [[68747, 68747], "mapped", [68811]], [[68748, 68748], "mapped", [68812]], [[68749, 68749], "mapped", [68813]], [[68750, 68750], "mapped", [68814]], [[68751, 68751], "mapped", [68815]], [[68752, 68752], "mapped", [68816]], [[68753, 68753], "mapped", [68817]], [[68754, 68754], "mapped", [68818]], [[68755, 68755], "mapped", [68819]], [[68756, 68756], "mapped", [68820]], [[68757, 68757], "mapped", [68821]], [[68758, 68758], "mapped", [68822]], [[68759, 68759], "mapped", [68823]], [[68760, 68760], "mapped", [68824]], [[68761, 68761], "mapped", [68825]], [[68762, 68762], "mapped", [68826]], [[68763, 68763], "mapped", [68827]], [[68764, 68764], "mapped", [68828]], [[68765, 68765], "mapped", [68829]], [[68766, 68766], "mapped", [68830]], [[68767, 68767], "mapped", [68831]], [[68768, 68768], "mapped", [68832]], [[68769, 68769], "mapped", [68833]], [[68770, 68770], "mapped", [68834]], [[68771, 68771], "mapped", [68835]], [[68772, 68772], "mapped", [68836]], [[68773, 68773], "mapped", [68837]], [[68774, 68774], "mapped", [68838]], [[68775, 68775], "mapped", [68839]], [[68776, 68776], "mapped", [68840]], [[68777, 68777], "mapped", [68841]], [[68778, 68778], "mapped", [68842]], [[68779, 68779], "mapped", [68843]], [[68780, 68780], "mapped", [68844]], [[68781, 68781], "mapped", [68845]], [[68782, 68782], "mapped", [68846]], [[68783, 68783], "mapped", [68847]], [[68784, 68784], "mapped", [68848]], [[68785, 68785], "mapped", [68849]], [[68786, 68786], "mapped", [68850]], [[68787, 68799], "disallowed"], [[68800, 68850], "valid"], [[68851, 68857], "disallowed"], [[68858, 68863], "valid", [], "NV8"], [[68864, 69215], "disallowed"], [[69216, 69246], "valid", [], "NV8"], [[69247, 69631], "disallowed"], [[69632, 69702], "valid"], [[69703, 69709], "valid", [], "NV8"], [[69710, 69713], "disallowed"], [[69714, 69733], "valid", [], "NV8"], [[69734, 69743], "valid"], [[69744, 69758], "disallowed"], [[69759, 69759], "valid"], [[69760, 69818], "valid"], [[69819, 69820], "valid", [], "NV8"], [[69821, 69821], "disallowed"], [[69822, 69825], "valid", [], "NV8"], [[69826, 69839], "disallowed"], [[69840, 69864], "valid"], [[69865, 69871], "disallowed"], [[69872, 69881], "valid"], [[69882, 69887], "disallowed"], [[69888, 69940], "valid"], [[69941, 69941], "disallowed"], [[69942, 69951], "valid"], [[69952, 69955], "valid", [], "NV8"], [[69956, 69967], "disallowed"], [[69968, 70003], "valid"], [[70004, 70005], "valid", [], "NV8"], [[70006, 70006], "valid"], [[70007, 70015], "disallowed"], [[70016, 70084], "valid"], [[70085, 70088], "valid", [], "NV8"], [[70089, 70089], "valid", [], "NV8"], [[70090, 70092], "valid"], [[70093, 70093], "valid", [], "NV8"], [[70094, 70095], "disallowed"], [[70096, 70105], "valid"], [[70106, 70106], "valid"], [[70107, 70107], "valid", [], "NV8"], [[70108, 70108], "valid"], [[70109, 70111], "valid", [], "NV8"], [[70112, 70112], "disallowed"], [[70113, 70132], "valid", [], "NV8"], [[70133, 70143], "disallowed"], [[70144, 70161], "valid"], [[70162, 70162], "disallowed"], [[70163, 70199], "valid"], [[70200, 70205], "valid", [], "NV8"], [[70206, 70271], "disallowed"], [[70272, 70278], "valid"], [[70279, 70279], "disallowed"], [[70280, 70280], "valid"], [[70281, 70281], "disallowed"], [[70282, 70285], "valid"], [[70286, 70286], "disallowed"], [[70287, 70301], "valid"], [[70302, 70302], "disallowed"], [[70303, 70312], "valid"], [[70313, 70313], "valid", [], "NV8"], [[70314, 70319], "disallowed"], [[70320, 70378], "valid"], [[70379, 70383], "disallowed"], [[70384, 70393], "valid"], [[70394, 70399], "disallowed"], [[70400, 70400], "valid"], [[70401, 70403], "valid"], [[70404, 70404], "disallowed"], [[70405, 70412], "valid"], [[70413, 70414], "disallowed"], [[70415, 70416], "valid"], [[70417, 70418], "disallowed"], [[70419, 70440], "valid"], [[70441, 70441], "disallowed"], [[70442, 70448], "valid"], [[70449, 70449], "disallowed"], [[70450, 70451], "valid"], [[70452, 70452], "disallowed"], [[70453, 70457], "valid"], [[70458, 70459], "disallowed"], [[70460, 70468], "valid"], [[70469, 70470], "disallowed"], [[70471, 70472], "valid"], [[70473, 70474], "disallowed"], [[70475, 70477], "valid"], [[70478, 70479], "disallowed"], [[70480, 70480], "valid"], [[70481, 70486], "disallowed"], [[70487, 70487], "valid"], [[70488, 70492], "disallowed"], [[70493, 70499], "valid"], [[70500, 70501], "disallowed"], [[70502, 70508], "valid"], [[70509, 70511], "disallowed"], [[70512, 70516], "valid"], [[70517, 70783], "disallowed"], [[70784, 70853], "valid"], [[70854, 70854], "valid", [], "NV8"], [[70855, 70855], "valid"], [[70856, 70863], "disallowed"], [[70864, 70873], "valid"], [[70874, 71039], "disallowed"], [[71040, 71093], "valid"], [[71094, 71095], "disallowed"], [[71096, 71104], "valid"], [[71105, 71113], "valid", [], "NV8"], [[71114, 71127], "valid", [], "NV8"], [[71128, 71133], "valid"], [[71134, 71167], "disallowed"], [[71168, 71232], "valid"], [[71233, 71235], "valid", [], "NV8"], [[71236, 71236], "valid"], [[71237, 71247], "disallowed"], [[71248, 71257], "valid"], [[71258, 71295], "disallowed"], [[71296, 71351], "valid"], [[71352, 71359], "disallowed"], [[71360, 71369], "valid"], [[71370, 71423], "disallowed"], [[71424, 71449], "valid"], [[71450, 71452], "disallowed"], [[71453, 71467], "valid"], [[71468, 71471], "disallowed"], [[71472, 71481], "valid"], [[71482, 71487], "valid", [], "NV8"], [[71488, 71839], "disallowed"], [[71840, 71840], "mapped", [71872]], [[71841, 71841], "mapped", [71873]], [[71842, 71842], "mapped", [71874]], [[71843, 71843], "mapped", [71875]], [[71844, 71844], "mapped", [71876]], [[71845, 71845], "mapped", [71877]], [[71846, 71846], "mapped", [71878]], [[71847, 71847], "mapped", [71879]], [[71848, 71848], "mapped", [71880]], [[71849, 71849], "mapped", [71881]], [[71850, 71850], "mapped", [71882]], [[71851, 71851], "mapped", [71883]], [[71852, 71852], "mapped", [71884]], [[71853, 71853], "mapped", [71885]], [[71854, 71854], "mapped", [71886]], [[71855, 71855], "mapped", [71887]], [[71856, 71856], "mapped", [71888]], [[71857, 71857], "mapped", [71889]], [[71858, 71858], "mapped", [71890]], [[71859, 71859], "mapped", [71891]], [[71860, 71860], "mapped", [71892]], [[71861, 71861], "mapped", [71893]], [[71862, 71862], "mapped", [71894]], [[71863, 71863], "mapped", [71895]], [[71864, 71864], "mapped", [71896]], [[71865, 71865], "mapped", [71897]], [[71866, 71866], "mapped", [71898]], [[71867, 71867], "mapped", [71899]], [[71868, 71868], "mapped", [71900]], [[71869, 71869], "mapped", [71901]], [[71870, 71870], "mapped", [71902]], [[71871, 71871], "mapped", [71903]], [[71872, 71913], "valid"], [[71914, 71922], "valid", [], "NV8"], [[71923, 71934], "disallowed"], [[71935, 71935], "valid"], [[71936, 72383], "disallowed"], [[72384, 72440], "valid"], [[72441, 73727], "disallowed"], [[73728, 74606], "valid"], [[74607, 74648], "valid"], [[74649, 74649], "valid"], [[74650, 74751], "disallowed"], [[74752, 74850], "valid", [], "NV8"], [[74851, 74862], "valid", [], "NV8"], [[74863, 74863], "disallowed"], [[74864, 74867], "valid", [], "NV8"], [[74868, 74868], "valid", [], "NV8"], [[74869, 74879], "disallowed"], [[74880, 75075], "valid"], [[75076, 77823], "disallowed"], [[77824, 78894], "valid"], [[78895, 82943], "disallowed"], [[82944, 83526], "valid"], [[83527, 92159], "disallowed"], [[92160, 92728], "valid"], [[92729, 92735], "disallowed"], [[92736, 92766], "valid"], [[92767, 92767], "disallowed"], [[92768, 92777], "valid"], [[92778, 92781], "disallowed"], [[92782, 92783], "valid", [], "NV8"], [[92784, 92879], "disallowed"], [[92880, 92909], "valid"], [[92910, 92911], "disallowed"], [[92912, 92916], "valid"], [[92917, 92917], "valid", [], "NV8"], [[92918, 92927], "disallowed"], [[92928, 92982], "valid"], [[92983, 92991], "valid", [], "NV8"], [[92992, 92995], "valid"], [[92996, 92997], "valid", [], "NV8"], [[92998, 93007], "disallowed"], [[93008, 93017], "valid"], [[93018, 93018], "disallowed"], [[93019, 93025], "valid", [], "NV8"], [[93026, 93026], "disallowed"], [[93027, 93047], "valid"], [[93048, 93052], "disallowed"], [[93053, 93071], "valid"], [[93072, 93951], "disallowed"], [[93952, 94020], "valid"], [[94021, 94031], "disallowed"], [[94032, 94078], "valid"], [[94079, 94094], "disallowed"], [[94095, 94111], "valid"], [[94112, 110591], "disallowed"], [[110592, 110593], "valid"], [[110594, 113663], "disallowed"], [[113664, 113770], "valid"], [[113771, 113775], "disallowed"], [[113776, 113788], "valid"], [[113789, 113791], "disallowed"], [[113792, 113800], "valid"], [[113801, 113807], "disallowed"], [[113808, 113817], "valid"], [[113818, 113819], "disallowed"], [[113820, 113820], "valid", [], "NV8"], [[113821, 113822], "valid"], [[113823, 113823], "valid", [], "NV8"], [[113824, 113827], "ignored"], [[113828, 118783], "disallowed"], [[118784, 119029], "valid", [], "NV8"], [[119030, 119039], "disallowed"], [[119040, 119078], "valid", [], "NV8"], [[119079, 119080], "disallowed"], [[119081, 119081], "valid", [], "NV8"], [[119082, 119133], "valid", [], "NV8"], [[119134, 119134], "mapped", [119127, 119141]], [[119135, 119135], "mapped", [119128, 119141]], [[119136, 119136], "mapped", [119128, 119141, 119150]], [[119137, 119137], "mapped", [119128, 119141, 119151]], [[119138, 119138], "mapped", [119128, 119141, 119152]], [[119139, 119139], "mapped", [119128, 119141, 119153]], [[119140, 119140], "mapped", [119128, 119141, 119154]], [[119141, 119154], "valid", [], "NV8"], [[119155, 119162], "disallowed"], [[119163, 119226], "valid", [], "NV8"], [[119227, 119227], "mapped", [119225, 119141]], [[119228, 119228], "mapped", [119226, 119141]], [[119229, 119229], "mapped", [119225, 119141, 119150]], [[119230, 119230], "mapped", [119226, 119141, 119150]], [[119231, 119231], "mapped", [119225, 119141, 119151]], [[119232, 119232], "mapped", [119226, 119141, 119151]], [[119233, 119261], "valid", [], "NV8"], [[119262, 119272], "valid", [], "NV8"], [[119273, 119295], "disallowed"], [[119296, 119365], "valid", [], "NV8"], [[119366, 119551], "disallowed"], [[119552, 119638], "valid", [], "NV8"], [[119639, 119647], "disallowed"], [[119648, 119665], "valid", [], "NV8"], [[119666, 119807], "disallowed"], [[119808, 119808], "mapped", [97]], [[119809, 119809], "mapped", [98]], [[119810, 119810], "mapped", [99]], [[119811, 119811], "mapped", [100]], [[119812, 119812], "mapped", [101]], [[119813, 119813], "mapped", [102]], [[119814, 119814], "mapped", [103]], [[119815, 119815], "mapped", [104]], [[119816, 119816], "mapped", [105]], [[119817, 119817], "mapped", [106]], [[119818, 119818], "mapped", [107]], [[119819, 119819], "mapped", [108]], [[119820, 119820], "mapped", [109]], [[119821, 119821], "mapped", [110]], [[119822, 119822], "mapped", [111]], [[119823, 119823], "mapped", [112]], [[119824, 119824], "mapped", [113]], [[119825, 119825], "mapped", [114]], [[119826, 119826], "mapped", [115]], [[119827, 119827], "mapped", [116]], [[119828, 119828], "mapped", [117]], [[119829, 119829], "mapped", [118]], [[119830, 119830], "mapped", [119]], [[119831, 119831], "mapped", [120]], [[119832, 119832], "mapped", [121]], [[119833, 119833], "mapped", [122]], [[119834, 119834], "mapped", [97]], [[119835, 119835], "mapped", [98]], [[119836, 119836], "mapped", [99]], [[119837, 119837], "mapped", [100]], [[119838, 119838], "mapped", [101]], [[119839, 119839], "mapped", [102]], [[119840, 119840], "mapped", [103]], [[119841, 119841], "mapped", [104]], [[119842, 119842], "mapped", [105]], [[119843, 119843], "mapped", [106]], [[119844, 119844], "mapped", [107]], [[119845, 119845], "mapped", [108]], [[119846, 119846], "mapped", [109]], [[119847, 119847], "mapped", [110]], [[119848, 119848], "mapped", [111]], [[119849, 119849], "mapped", [112]], [[119850, 119850], "mapped", [113]], [[119851, 119851], "mapped", [114]], [[119852, 119852], "mapped", [115]], [[119853, 119853], "mapped", [116]], [[119854, 119854], "mapped", [117]], [[119855, 119855], "mapped", [118]], [[119856, 119856], "mapped", [119]], [[119857, 119857], "mapped", [120]], [[119858, 119858], "mapped", [121]], [[119859, 119859], "mapped", [122]], [[119860, 119860], "mapped", [97]], [[119861, 119861], "mapped", [98]], [[119862, 119862], "mapped", [99]], [[119863, 119863], "mapped", [100]], [[119864, 119864], "mapped", [101]], [[119865, 119865], "mapped", [102]], [[119866, 119866], "mapped", [103]], [[119867, 119867], "mapped", [104]], [[119868, 119868], "mapped", [105]], [[119869, 119869], "mapped", [106]], [[119870, 119870], "mapped", [107]], [[119871, 119871], "mapped", [108]], [[119872, 119872], "mapped", [109]], [[119873, 119873], "mapped", [110]], [[119874, 119874], "mapped", [111]], [[119875, 119875], "mapped", [112]], [[119876, 119876], "mapped", [113]], [[119877, 119877], "mapped", [114]], [[119878, 119878], "mapped", [115]], [[119879, 119879], "mapped", [116]], [[119880, 119880], "mapped", [117]], [[119881, 119881], "mapped", [118]], [[119882, 119882], "mapped", [119]], [[119883, 119883], "mapped", [120]], [[119884, 119884], "mapped", [121]], [[119885, 119885], "mapped", [122]], [[119886, 119886], "mapped", [97]], [[119887, 119887], "mapped", [98]], [[119888, 119888], "mapped", [99]], [[119889, 119889], "mapped", [100]], [[119890, 119890], "mapped", [101]], [[119891, 119891], "mapped", [102]], [[119892, 119892], "mapped", [103]], [[119893, 119893], "disallowed"], [[119894, 119894], "mapped", [105]], [[119895, 119895], "mapped", [106]], [[119896, 119896], "mapped", [107]], [[119897, 119897], "mapped", [108]], [[119898, 119898], "mapped", [109]], [[119899, 119899], "mapped", [110]], [[119900, 119900], "mapped", [111]], [[119901, 119901], "mapped", [112]], [[119902, 119902], "mapped", [113]], [[119903, 119903], "mapped", [114]], [[119904, 119904], "mapped", [115]], [[119905, 119905], "mapped", [116]], [[119906, 119906], "mapped", [117]], [[119907, 119907], "mapped", [118]], [[119908, 119908], "mapped", [119]], [[119909, 119909], "mapped", [120]], [[119910, 119910], "mapped", [121]], [[119911, 119911], "mapped", [122]], [[119912, 119912], "mapped", [97]], [[119913, 119913], "mapped", [98]], [[119914, 119914], "mapped", [99]], [[119915, 119915], "mapped", [100]], [[119916, 119916], "mapped", [101]], [[119917, 119917], "mapped", [102]], [[119918, 119918], "mapped", [103]], [[119919, 119919], "mapped", [104]], [[119920, 119920], "mapped", [105]], [[119921, 119921], "mapped", [106]], [[119922, 119922], "mapped", [107]], [[119923, 119923], "mapped", [108]], [[119924, 119924], "mapped", [109]], [[119925, 119925], "mapped", [110]], [[119926, 119926], "mapped", [111]], [[119927, 119927], "mapped", [112]], [[119928, 119928], "mapped", [113]], [[119929, 119929], "mapped", [114]], [[119930, 119930], "mapped", [115]], [[119931, 119931], "mapped", [116]], [[119932, 119932], "mapped", [117]], [[119933, 119933], "mapped", [118]], [[119934, 119934], "mapped", [119]], [[119935, 119935], "mapped", [120]], [[119936, 119936], "mapped", [121]], [[119937, 119937], "mapped", [122]], [[119938, 119938], "mapped", [97]], [[119939, 119939], "mapped", [98]], [[119940, 119940], "mapped", [99]], [[119941, 119941], "mapped", [100]], [[119942, 119942], "mapped", [101]], [[119943, 119943], "mapped", [102]], [[119944, 119944], "mapped", [103]], [[119945, 119945], "mapped", [104]], [[119946, 119946], "mapped", [105]], [[119947, 119947], "mapped", [106]], [[119948, 119948], "mapped", [107]], [[119949, 119949], "mapped", [108]], [[119950, 119950], "mapped", [109]], [[119951, 119951], "mapped", [110]], [[119952, 119952], "mapped", [111]], [[119953, 119953], "mapped", [112]], [[119954, 119954], "mapped", [113]], [[119955, 119955], "mapped", [114]], [[119956, 119956], "mapped", [115]], [[119957, 119957], "mapped", [116]], [[119958, 119958], "mapped", [117]], [[119959, 119959], "mapped", [118]], [[119960, 119960], "mapped", [119]], [[119961, 119961], "mapped", [120]], [[119962, 119962], "mapped", [121]], [[119963, 119963], "mapped", [122]], [[119964, 119964], "mapped", [97]], [[119965, 119965], "disallowed"], [[119966, 119966], "mapped", [99]], [[119967, 119967], "mapped", [100]], [[119968, 119969], "disallowed"], [[119970, 119970], "mapped", [103]], [[119971, 119972], "disallowed"], [[119973, 119973], "mapped", [106]], [[119974, 119974], "mapped", [107]], [[119975, 119976], "disallowed"], [[119977, 119977], "mapped", [110]], [[119978, 119978], "mapped", [111]], [[119979, 119979], "mapped", [112]], [[119980, 119980], "mapped", [113]], [[119981, 119981], "disallowed"], [[119982, 119982], "mapped", [115]], [[119983, 119983], "mapped", [116]], [[119984, 119984], "mapped", [117]], [[119985, 119985], "mapped", [118]], [[119986, 119986], "mapped", [119]], [[119987, 119987], "mapped", [120]], [[119988, 119988], "mapped", [121]], [[119989, 119989], "mapped", [122]], [[119990, 119990], "mapped", [97]], [[119991, 119991], "mapped", [98]], [[119992, 119992], "mapped", [99]], [[119993, 119993], "mapped", [100]], [[119994, 119994], "disallowed"], [[119995, 119995], "mapped", [102]], [[119996, 119996], "disallowed"], [[119997, 119997], "mapped", [104]], [[119998, 119998], "mapped", [105]], [[119999, 119999], "mapped", [106]], [[12e4, 12e4], "mapped", [107]], [[120001, 120001], "mapped", [108]], [[120002, 120002], "mapped", [109]], [[120003, 120003], "mapped", [110]], [[120004, 120004], "disallowed"], [[120005, 120005], "mapped", [112]], [[120006, 120006], "mapped", [113]], [[120007, 120007], "mapped", [114]], [[120008, 120008], "mapped", [115]], [[120009, 120009], "mapped", [116]], [[120010, 120010], "mapped", [117]], [[120011, 120011], "mapped", [118]], [[120012, 120012], "mapped", [119]], [[120013, 120013], "mapped", [120]], [[120014, 120014], "mapped", [121]], [[120015, 120015], "mapped", [122]], [[120016, 120016], "mapped", [97]], [[120017, 120017], "mapped", [98]], [[120018, 120018], "mapped", [99]], [[120019, 120019], "mapped", [100]], [[120020, 120020], "mapped", [101]], [[120021, 120021], "mapped", [102]], [[120022, 120022], "mapped", [103]], [[120023, 120023], "mapped", [104]], [[120024, 120024], "mapped", [105]], [[120025, 120025], "mapped", [106]], [[120026, 120026], "mapped", [107]], [[120027, 120027], "mapped", [108]], [[120028, 120028], "mapped", [109]], [[120029, 120029], "mapped", [110]], [[120030, 120030], "mapped", [111]], [[120031, 120031], "mapped", [112]], [[120032, 120032], "mapped", [113]], [[120033, 120033], "mapped", [114]], [[120034, 120034], "mapped", [115]], [[120035, 120035], "mapped", [116]], [[120036, 120036], "mapped", [117]], [[120037, 120037], "mapped", [118]], [[120038, 120038], "mapped", [119]], [[120039, 120039], "mapped", [120]], [[120040, 120040], "mapped", [121]], [[120041, 120041], "mapped", [122]], [[120042, 120042], "mapped", [97]], [[120043, 120043], "mapped", [98]], [[120044, 120044], "mapped", [99]], [[120045, 120045], "mapped", [100]], [[120046, 120046], "mapped", [101]], [[120047, 120047], "mapped", [102]], [[120048, 120048], "mapped", [103]], [[120049, 120049], "mapped", [104]], [[120050, 120050], "mapped", [105]], [[120051, 120051], "mapped", [106]], [[120052, 120052], "mapped", [107]], [[120053, 120053], "mapped", [108]], [[120054, 120054], "mapped", [109]], [[120055, 120055], "mapped", [110]], [[120056, 120056], "mapped", [111]], [[120057, 120057], "mapped", [112]], [[120058, 120058], "mapped", [113]], [[120059, 120059], "mapped", [114]], [[120060, 120060], "mapped", [115]], [[120061, 120061], "mapped", [116]], [[120062, 120062], "mapped", [117]], [[120063, 120063], "mapped", [118]], [[120064, 120064], "mapped", [119]], [[120065, 120065], "mapped", [120]], [[120066, 120066], "mapped", [121]], [[120067, 120067], "mapped", [122]], [[120068, 120068], "mapped", [97]], [[120069, 120069], "mapped", [98]], [[120070, 120070], "disallowed"], [[120071, 120071], "mapped", [100]], [[120072, 120072], "mapped", [101]], [[120073, 120073], "mapped", [102]], [[120074, 120074], "mapped", [103]], [[120075, 120076], "disallowed"], [[120077, 120077], "mapped", [106]], [[120078, 120078], "mapped", [107]], [[120079, 120079], "mapped", [108]], [[120080, 120080], "mapped", [109]], [[120081, 120081], "mapped", [110]], [[120082, 120082], "mapped", [111]], [[120083, 120083], "mapped", [112]], [[120084, 120084], "mapped", [113]], [[120085, 120085], "disallowed"], [[120086, 120086], "mapped", [115]], [[120087, 120087], "mapped", [116]], [[120088, 120088], "mapped", [117]], [[120089, 120089], "mapped", [118]], [[120090, 120090], "mapped", [119]], [[120091, 120091], "mapped", [120]], [[120092, 120092], "mapped", [121]], [[120093, 120093], "disallowed"], [[120094, 120094], "mapped", [97]], [[120095, 120095], "mapped", [98]], [[120096, 120096], "mapped", [99]], [[120097, 120097], "mapped", [100]], [[120098, 120098], "mapped", [101]], [[120099, 120099], "mapped", [102]], [[120100, 120100], "mapped", [103]], [[120101, 120101], "mapped", [104]], [[120102, 120102], "mapped", [105]], [[120103, 120103], "mapped", [106]], [[120104, 120104], "mapped", [107]], [[120105, 120105], "mapped", [108]], [[120106, 120106], "mapped", [109]], [[120107, 120107], "mapped", [110]], [[120108, 120108], "mapped", [111]], [[120109, 120109], "mapped", [112]], [[120110, 120110], "mapped", [113]], [[120111, 120111], "mapped", [114]], [[120112, 120112], "mapped", [115]], [[120113, 120113], "mapped", [116]], [[120114, 120114], "mapped", [117]], [[120115, 120115], "mapped", [118]], [[120116, 120116], "mapped", [119]], [[120117, 120117], "mapped", [120]], [[120118, 120118], "mapped", [121]], [[120119, 120119], "mapped", [122]], [[120120, 120120], "mapped", [97]], [[120121, 120121], "mapped", [98]], [[120122, 120122], "disallowed"], [[120123, 120123], "mapped", [100]], [[120124, 120124], "mapped", [101]], [[120125, 120125], "mapped", [102]], [[120126, 120126], "mapped", [103]], [[120127, 120127], "disallowed"], [[120128, 120128], "mapped", [105]], [[120129, 120129], "mapped", [106]], [[120130, 120130], "mapped", [107]], [[120131, 120131], "mapped", [108]], [[120132, 120132], "mapped", [109]], [[120133, 120133], "disallowed"], [[120134, 120134], "mapped", [111]], [[120135, 120137], "disallowed"], [[120138, 120138], "mapped", [115]], [[120139, 120139], "mapped", [116]], [[120140, 120140], "mapped", [117]], [[120141, 120141], "mapped", [118]], [[120142, 120142], "mapped", [119]], [[120143, 120143], "mapped", [120]], [[120144, 120144], "mapped", [121]], [[120145, 120145], "disallowed"], [[120146, 120146], "mapped", [97]], [[120147, 120147], "mapped", [98]], [[120148, 120148], "mapped", [99]], [[120149, 120149], "mapped", [100]], [[120150, 120150], "mapped", [101]], [[120151, 120151], "mapped", [102]], [[120152, 120152], "mapped", [103]], [[120153, 120153], "mapped", [104]], [[120154, 120154], "mapped", [105]], [[120155, 120155], "mapped", [106]], [[120156, 120156], "mapped", [107]], [[120157, 120157], "mapped", [108]], [[120158, 120158], "mapped", [109]], [[120159, 120159], "mapped", [110]], [[120160, 120160], "mapped", [111]], [[120161, 120161], "mapped", [112]], [[120162, 120162], "mapped", [113]], [[120163, 120163], "mapped", [114]], [[120164, 120164], "mapped", [115]], [[120165, 120165], "mapped", [116]], [[120166, 120166], "mapped", [117]], [[120167, 120167], "mapped", [118]], [[120168, 120168], "mapped", [119]], [[120169, 120169], "mapped", [120]], [[120170, 120170], "mapped", [121]], [[120171, 120171], "mapped", [122]], [[120172, 120172], "mapped", [97]], [[120173, 120173], "mapped", [98]], [[120174, 120174], "mapped", [99]], [[120175, 120175], "mapped", [100]], [[120176, 120176], "mapped", [101]], [[120177, 120177], "mapped", [102]], [[120178, 120178], "mapped", [103]], [[120179, 120179], "mapped", [104]], [[120180, 120180], "mapped", [105]], [[120181, 120181], "mapped", [106]], [[120182, 120182], "mapped", [107]], [[120183, 120183], "mapped", [108]], [[120184, 120184], "mapped", [109]], [[120185, 120185], "mapped", [110]], [[120186, 120186], "mapped", [111]], [[120187, 120187], "mapped", [112]], [[120188, 120188], "mapped", [113]], [[120189, 120189], "mapped", [114]], [[120190, 120190], "mapped", [115]], [[120191, 120191], "mapped", [116]], [[120192, 120192], "mapped", [117]], [[120193, 120193], "mapped", [118]], [[120194, 120194], "mapped", [119]], [[120195, 120195], "mapped", [120]], [[120196, 120196], "mapped", [121]], [[120197, 120197], "mapped", [122]], [[120198, 120198], "mapped", [97]], [[120199, 120199], "mapped", [98]], [[120200, 120200], "mapped", [99]], [[120201, 120201], "mapped", [100]], [[120202, 120202], "mapped", [101]], [[120203, 120203], "mapped", [102]], [[120204, 120204], "mapped", [103]], [[120205, 120205], "mapped", [104]], [[120206, 120206], "mapped", [105]], [[120207, 120207], "mapped", [106]], [[120208, 120208], "mapped", [107]], [[120209, 120209], "mapped", [108]], [[120210, 120210], "mapped", [109]], [[120211, 120211], "mapped", [110]], [[120212, 120212], "mapped", [111]], [[120213, 120213], "mapped", [112]], [[120214, 120214], "mapped", [113]], [[120215, 120215], "mapped", [114]], [[120216, 120216], "mapped", [115]], [[120217, 120217], "mapped", [116]], [[120218, 120218], "mapped", [117]], [[120219, 120219], "mapped", [118]], [[120220, 120220], "mapped", [119]], [[120221, 120221], "mapped", [120]], [[120222, 120222], "mapped", [121]], [[120223, 120223], "mapped", [122]], [[120224, 120224], "mapped", [97]], [[120225, 120225], "mapped", [98]], [[120226, 120226], "mapped", [99]], [[120227, 120227], "mapped", [100]], [[120228, 120228], "mapped", [101]], [[120229, 120229], "mapped", [102]], [[120230, 120230], "mapped", [103]], [[120231, 120231], "mapped", [104]], [[120232, 120232], "mapped", [105]], [[120233, 120233], "mapped", [106]], [[120234, 120234], "mapped", [107]], [[120235, 120235], "mapped", [108]], [[120236, 120236], "mapped", [109]], [[120237, 120237], "mapped", [110]], [[120238, 120238], "mapped", [111]], [[120239, 120239], "mapped", [112]], [[120240, 120240], "mapped", [113]], [[120241, 120241], "mapped", [114]], [[120242, 120242], "mapped", [115]], [[120243, 120243], "mapped", [116]], [[120244, 120244], "mapped", [117]], [[120245, 120245], "mapped", [118]], [[120246, 120246], "mapped", [119]], [[120247, 120247], "mapped", [120]], [[120248, 120248], "mapped", [121]], [[120249, 120249], "mapped", [122]], [[120250, 120250], "mapped", [97]], [[120251, 120251], "mapped", [98]], [[120252, 120252], "mapped", [99]], [[120253, 120253], "mapped", [100]], [[120254, 120254], "mapped", [101]], [[120255, 120255], "mapped", [102]], [[120256, 120256], "mapped", [103]], [[120257, 120257], "mapped", [104]], [[120258, 120258], "mapped", [105]], [[120259, 120259], "mapped", [106]], [[120260, 120260], "mapped", [107]], [[120261, 120261], "mapped", [108]], [[120262, 120262], "mapped", [109]], [[120263, 120263], "mapped", [110]], [[120264, 120264], "mapped", [111]], [[120265, 120265], "mapped", [112]], [[120266, 120266], "mapped", [113]], [[120267, 120267], "mapped", [114]], [[120268, 120268], "mapped", [115]], [[120269, 120269], "mapped", [116]], [[120270, 120270], "mapped", [117]], [[120271, 120271], "mapped", [118]], [[120272, 120272], "mapped", [119]], [[120273, 120273], "mapped", [120]], [[120274, 120274], "mapped", [121]], [[120275, 120275], "mapped", [122]], [[120276, 120276], "mapped", [97]], [[120277, 120277], "mapped", [98]], [[120278, 120278], "mapped", [99]], [[120279, 120279], "mapped", [100]], [[120280, 120280], "mapped", [101]], [[120281, 120281], "mapped", [102]], [[120282, 120282], "mapped", [103]], [[120283, 120283], "mapped", [104]], [[120284, 120284], "mapped", [105]], [[120285, 120285], "mapped", [106]], [[120286, 120286], "mapped", [107]], [[120287, 120287], "mapped", [108]], [[120288, 120288], "mapped", [109]], [[120289, 120289], "mapped", [110]], [[120290, 120290], "mapped", [111]], [[120291, 120291], "mapped", [112]], [[120292, 120292], "mapped", [113]], [[120293, 120293], "mapped", [114]], [[120294, 120294], "mapped", [115]], [[120295, 120295], "mapped", [116]], [[120296, 120296], "mapped", [117]], [[120297, 120297], "mapped", [118]], [[120298, 120298], "mapped", [119]], [[120299, 120299], "mapped", [120]], [[120300, 120300], "mapped", [121]], [[120301, 120301], "mapped", [122]], [[120302, 120302], "mapped", [97]], [[120303, 120303], "mapped", [98]], [[120304, 120304], "mapped", [99]], [[120305, 120305], "mapped", [100]], [[120306, 120306], "mapped", [101]], [[120307, 120307], "mapped", [102]], [[120308, 120308], "mapped", [103]], [[120309, 120309], "mapped", [104]], [[120310, 120310], "mapped", [105]], [[120311, 120311], "mapped", [106]], [[120312, 120312], "mapped", [107]], [[120313, 120313], "mapped", [108]], [[120314, 120314], "mapped", [109]], [[120315, 120315], "mapped", [110]], [[120316, 120316], "mapped", [111]], [[120317, 120317], "mapped", [112]], [[120318, 120318], "mapped", [113]], [[120319, 120319], "mapped", [114]], [[120320, 120320], "mapped", [115]], [[120321, 120321], "mapped", [116]], [[120322, 120322], "mapped", [117]], [[120323, 120323], "mapped", [118]], [[120324, 120324], "mapped", [119]], [[120325, 120325], "mapped", [120]], [[120326, 120326], "mapped", [121]], [[120327, 120327], "mapped", [122]], [[120328, 120328], "mapped", [97]], [[120329, 120329], "mapped", [98]], [[120330, 120330], "mapped", [99]], [[120331, 120331], "mapped", [100]], [[120332, 120332], "mapped", [101]], [[120333, 120333], "mapped", [102]], [[120334, 120334], "mapped", [103]], [[120335, 120335], "mapped", [104]], [[120336, 120336], "mapped", [105]], [[120337, 120337], "mapped", [106]], [[120338, 120338], "mapped", [107]], [[120339, 120339], "mapped", [108]], [[120340, 120340], "mapped", [109]], [[120341, 120341], "mapped", [110]], [[120342, 120342], "mapped", [111]], [[120343, 120343], "mapped", [112]], [[120344, 120344], "mapped", [113]], [[120345, 120345], "mapped", [114]], [[120346, 120346], "mapped", [115]], [[120347, 120347], "mapped", [116]], [[120348, 120348], "mapped", [117]], [[120349, 120349], "mapped", [118]], [[120350, 120350], "mapped", [119]], [[120351, 120351], "mapped", [120]], [[120352, 120352], "mapped", [121]], [[120353, 120353], "mapped", [122]], [[120354, 120354], "mapped", [97]], [[120355, 120355], "mapped", [98]], [[120356, 120356], "mapped", [99]], [[120357, 120357], "mapped", [100]], [[120358, 120358], "mapped", [101]], [[120359, 120359], "mapped", [102]], [[120360, 120360], "mapped", [103]], [[120361, 120361], "mapped", [104]], [[120362, 120362], "mapped", [105]], [[120363, 120363], "mapped", [106]], [[120364, 120364], "mapped", [107]], [[120365, 120365], "mapped", [108]], [[120366, 120366], "mapped", [109]], [[120367, 120367], "mapped", [110]], [[120368, 120368], "mapped", [111]], [[120369, 120369], "mapped", [112]], [[120370, 120370], "mapped", [113]], [[120371, 120371], "mapped", [114]], [[120372, 120372], "mapped", [115]], [[120373, 120373], "mapped", [116]], [[120374, 120374], "mapped", [117]], [[120375, 120375], "mapped", [118]], [[120376, 120376], "mapped", [119]], [[120377, 120377], "mapped", [120]], [[120378, 120378], "mapped", [121]], [[120379, 120379], "mapped", [122]], [[120380, 120380], "mapped", [97]], [[120381, 120381], "mapped", [98]], [[120382, 120382], "mapped", [99]], [[120383, 120383], "mapped", [100]], [[120384, 120384], "mapped", [101]], [[120385, 120385], "mapped", [102]], [[120386, 120386], "mapped", [103]], [[120387, 120387], "mapped", [104]], [[120388, 120388], "mapped", [105]], [[120389, 120389], "mapped", [106]], [[120390, 120390], "mapped", [107]], [[120391, 120391], "mapped", [108]], [[120392, 120392], "mapped", [109]], [[120393, 120393], "mapped", [110]], [[120394, 120394], "mapped", [111]], [[120395, 120395], "mapped", [112]], [[120396, 120396], "mapped", [113]], [[120397, 120397], "mapped", [114]], [[120398, 120398], "mapped", [115]], [[120399, 120399], "mapped", [116]], [[120400, 120400], "mapped", [117]], [[120401, 120401], "mapped", [118]], [[120402, 120402], "mapped", [119]], [[120403, 120403], "mapped", [120]], [[120404, 120404], "mapped", [121]], [[120405, 120405], "mapped", [122]], [[120406, 120406], "mapped", [97]], [[120407, 120407], "mapped", [98]], [[120408, 120408], "mapped", [99]], [[120409, 120409], "mapped", [100]], [[120410, 120410], "mapped", [101]], [[120411, 120411], "mapped", [102]], [[120412, 120412], "mapped", [103]], [[120413, 120413], "mapped", [104]], [[120414, 120414], "mapped", [105]], [[120415, 120415], "mapped", [106]], [[120416, 120416], "mapped", [107]], [[120417, 120417], "mapped", [108]], [[120418, 120418], "mapped", [109]], [[120419, 120419], "mapped", [110]], [[120420, 120420], "mapped", [111]], [[120421, 120421], "mapped", [112]], [[120422, 120422], "mapped", [113]], [[120423, 120423], "mapped", [114]], [[120424, 120424], "mapped", [115]], [[120425, 120425], "mapped", [116]], [[120426, 120426], "mapped", [117]], [[120427, 120427], "mapped", [118]], [[120428, 120428], "mapped", [119]], [[120429, 120429], "mapped", [120]], [[120430, 120430], "mapped", [121]], [[120431, 120431], "mapped", [122]], [[120432, 120432], "mapped", [97]], [[120433, 120433], "mapped", [98]], [[120434, 120434], "mapped", [99]], [[120435, 120435], "mapped", [100]], [[120436, 120436], "mapped", [101]], [[120437, 120437], "mapped", [102]], [[120438, 120438], "mapped", [103]], [[120439, 120439], "mapped", [104]], [[120440, 120440], "mapped", [105]], [[120441, 120441], "mapped", [106]], [[120442, 120442], "mapped", [107]], [[120443, 120443], "mapped", [108]], [[120444, 120444], "mapped", [109]], [[120445, 120445], "mapped", [110]], [[120446, 120446], "mapped", [111]], [[120447, 120447], "mapped", [112]], [[120448, 120448], "mapped", [113]], [[120449, 120449], "mapped", [114]], [[120450, 120450], "mapped", [115]], [[120451, 120451], "mapped", [116]], [[120452, 120452], "mapped", [117]], [[120453, 120453], "mapped", [118]], [[120454, 120454], "mapped", [119]], [[120455, 120455], "mapped", [120]], [[120456, 120456], "mapped", [121]], [[120457, 120457], "mapped", [122]], [[120458, 120458], "mapped", [97]], [[120459, 120459], "mapped", [98]], [[120460, 120460], "mapped", [99]], [[120461, 120461], "mapped", [100]], [[120462, 120462], "mapped", [101]], [[120463, 120463], "mapped", [102]], [[120464, 120464], "mapped", [103]], [[120465, 120465], "mapped", [104]], [[120466, 120466], "mapped", [105]], [[120467, 120467], "mapped", [106]], [[120468, 120468], "mapped", [107]], [[120469, 120469], "mapped", [108]], [[120470, 120470], "mapped", [109]], [[120471, 120471], "mapped", [110]], [[120472, 120472], "mapped", [111]], [[120473, 120473], "mapped", [112]], [[120474, 120474], "mapped", [113]], [[120475, 120475], "mapped", [114]], [[120476, 120476], "mapped", [115]], [[120477, 120477], "mapped", [116]], [[120478, 120478], "mapped", [117]], [[120479, 120479], "mapped", [118]], [[120480, 120480], "mapped", [119]], [[120481, 120481], "mapped", [120]], [[120482, 120482], "mapped", [121]], [[120483, 120483], "mapped", [122]], [[120484, 120484], "mapped", [305]], [[120485, 120485], "mapped", [567]], [[120486, 120487], "disallowed"], [[120488, 120488], "mapped", [945]], [[120489, 120489], "mapped", [946]], [[120490, 120490], "mapped", [947]], [[120491, 120491], "mapped", [948]], [[120492, 120492], "mapped", [949]], [[120493, 120493], "mapped", [950]], [[120494, 120494], "mapped", [951]], [[120495, 120495], "mapped", [952]], [[120496, 120496], "mapped", [953]], [[120497, 120497], "mapped", [954]], [[120498, 120498], "mapped", [955]], [[120499, 120499], "mapped", [956]], [[120500, 120500], "mapped", [957]], [[120501, 120501], "mapped", [958]], [[120502, 120502], "mapped", [959]], [[120503, 120503], "mapped", [960]], [[120504, 120504], "mapped", [961]], [[120505, 120505], "mapped", [952]], [[120506, 120506], "mapped", [963]], [[120507, 120507], "mapped", [964]], [[120508, 120508], "mapped", [965]], [[120509, 120509], "mapped", [966]], [[120510, 120510], "mapped", [967]], [[120511, 120511], "mapped", [968]], [[120512, 120512], "mapped", [969]], [[120513, 120513], "mapped", [8711]], [[120514, 120514], "mapped", [945]], [[120515, 120515], "mapped", [946]], [[120516, 120516], "mapped", [947]], [[120517, 120517], "mapped", [948]], [[120518, 120518], "mapped", [949]], [[120519, 120519], "mapped", [950]], [[120520, 120520], "mapped", [951]], [[120521, 120521], "mapped", [952]], [[120522, 120522], "mapped", [953]], [[120523, 120523], "mapped", [954]], [[120524, 120524], "mapped", [955]], [[120525, 120525], "mapped", [956]], [[120526, 120526], "mapped", [957]], [[120527, 120527], "mapped", [958]], [[120528, 120528], "mapped", [959]], [[120529, 120529], "mapped", [960]], [[120530, 120530], "mapped", [961]], [[120531, 120532], "mapped", [963]], [[120533, 120533], "mapped", [964]], [[120534, 120534], "mapped", [965]], [[120535, 120535], "mapped", [966]], [[120536, 120536], "mapped", [967]], [[120537, 120537], "mapped", [968]], [[120538, 120538], "mapped", [969]], [[120539, 120539], "mapped", [8706]], [[120540, 120540], "mapped", [949]], [[120541, 120541], "mapped", [952]], [[120542, 120542], "mapped", [954]], [[120543, 120543], "mapped", [966]], [[120544, 120544], "mapped", [961]], [[120545, 120545], "mapped", [960]], [[120546, 120546], "mapped", [945]], [[120547, 120547], "mapped", [946]], [[120548, 120548], "mapped", [947]], [[120549, 120549], "mapped", [948]], [[120550, 120550], "mapped", [949]], [[120551, 120551], "mapped", [950]], [[120552, 120552], "mapped", [951]], [[120553, 120553], "mapped", [952]], [[120554, 120554], "mapped", [953]], [[120555, 120555], "mapped", [954]], [[120556, 120556], "mapped", [955]], [[120557, 120557], "mapped", [956]], [[120558, 120558], "mapped", [957]], [[120559, 120559], "mapped", [958]], [[120560, 120560], "mapped", [959]], [[120561, 120561], "mapped", [960]], [[120562, 120562], "mapped", [961]], [[120563, 120563], "mapped", [952]], [[120564, 120564], "mapped", [963]], [[120565, 120565], "mapped", [964]], [[120566, 120566], "mapped", [965]], [[120567, 120567], "mapped", [966]], [[120568, 120568], "mapped", [967]], [[120569, 120569], "mapped", [968]], [[120570, 120570], "mapped", [969]], [[120571, 120571], "mapped", [8711]], [[120572, 120572], "mapped", [945]], [[120573, 120573], "mapped", [946]], [[120574, 120574], "mapped", [947]], [[120575, 120575], "mapped", [948]], [[120576, 120576], "mapped", [949]], [[120577, 120577], "mapped", [950]], [[120578, 120578], "mapped", [951]], [[120579, 120579], "mapped", [952]], [[120580, 120580], "mapped", [953]], [[120581, 120581], "mapped", [954]], [[120582, 120582], "mapped", [955]], [[120583, 120583], "mapped", [956]], [[120584, 120584], "mapped", [957]], [[120585, 120585], "mapped", [958]], [[120586, 120586], "mapped", [959]], [[120587, 120587], "mapped", [960]], [[120588, 120588], "mapped", [961]], [[120589, 120590], "mapped", [963]], [[120591, 120591], "mapped", [964]], [[120592, 120592], "mapped", [965]], [[120593, 120593], "mapped", [966]], [[120594, 120594], "mapped", [967]], [[120595, 120595], "mapped", [968]], [[120596, 120596], "mapped", [969]], [[120597, 120597], "mapped", [8706]], [[120598, 120598], "mapped", [949]], [[120599, 120599], "mapped", [952]], [[120600, 120600], "mapped", [954]], [[120601, 120601], "mapped", [966]], [[120602, 120602], "mapped", [961]], [[120603, 120603], "mapped", [960]], [[120604, 120604], "mapped", [945]], [[120605, 120605], "mapped", [946]], [[120606, 120606], "mapped", [947]], [[120607, 120607], "mapped", [948]], [[120608, 120608], "mapped", [949]], [[120609, 120609], "mapped", [950]], [[120610, 120610], "mapped", [951]], [[120611, 120611], "mapped", [952]], [[120612, 120612], "mapped", [953]], [[120613, 120613], "mapped", [954]], [[120614, 120614], "mapped", [955]], [[120615, 120615], "mapped", [956]], [[120616, 120616], "mapped", [957]], [[120617, 120617], "mapped", [958]], [[120618, 120618], "mapped", [959]], [[120619, 120619], "mapped", [960]], [[120620, 120620], "mapped", [961]], [[120621, 120621], "mapped", [952]], [[120622, 120622], "mapped", [963]], [[120623, 120623], "mapped", [964]], [[120624, 120624], "mapped", [965]], [[120625, 120625], "mapped", [966]], [[120626, 120626], "mapped", [967]], [[120627, 120627], "mapped", [968]], [[120628, 120628], "mapped", [969]], [[120629, 120629], "mapped", [8711]], [[120630, 120630], "mapped", [945]], [[120631, 120631], "mapped", [946]], [[120632, 120632], "mapped", [947]], [[120633, 120633], "mapped", [948]], [[120634, 120634], "mapped", [949]], [[120635, 120635], "mapped", [950]], [[120636, 120636], "mapped", [951]], [[120637, 120637], "mapped", [952]], [[120638, 120638], "mapped", [953]], [[120639, 120639], "mapped", [954]], [[120640, 120640], "mapped", [955]], [[120641, 120641], "mapped", [956]], [[120642, 120642], "mapped", [957]], [[120643, 120643], "mapped", [958]], [[120644, 120644], "mapped", [959]], [[120645, 120645], "mapped", [960]], [[120646, 120646], "mapped", [961]], [[120647, 120648], "mapped", [963]], [[120649, 120649], "mapped", [964]], [[120650, 120650], "mapped", [965]], [[120651, 120651], "mapped", [966]], [[120652, 120652], "mapped", [967]], [[120653, 120653], "mapped", [968]], [[120654, 120654], "mapped", [969]], [[120655, 120655], "mapped", [8706]], [[120656, 120656], "mapped", [949]], [[120657, 120657], "mapped", [952]], [[120658, 120658], "mapped", [954]], [[120659, 120659], "mapped", [966]], [[120660, 120660], "mapped", [961]], [[120661, 120661], "mapped", [960]], [[120662, 120662], "mapped", [945]], [[120663, 120663], "mapped", [946]], [[120664, 120664], "mapped", [947]], [[120665, 120665], "mapped", [948]], [[120666, 120666], "mapped", [949]], [[120667, 120667], "mapped", [950]], [[120668, 120668], "mapped", [951]], [[120669, 120669], "mapped", [952]], [[120670, 120670], "mapped", [953]], [[120671, 120671], "mapped", [954]], [[120672, 120672], "mapped", [955]], [[120673, 120673], "mapped", [956]], [[120674, 120674], "mapped", [957]], [[120675, 120675], "mapped", [958]], [[120676, 120676], "mapped", [959]], [[120677, 120677], "mapped", [960]], [[120678, 120678], "mapped", [961]], [[120679, 120679], "mapped", [952]], [[120680, 120680], "mapped", [963]], [[120681, 120681], "mapped", [964]], [[120682, 120682], "mapped", [965]], [[120683, 120683], "mapped", [966]], [[120684, 120684], "mapped", [967]], [[120685, 120685], "mapped", [968]], [[120686, 120686], "mapped", [969]], [[120687, 120687], "mapped", [8711]], [[120688, 120688], "mapped", [945]], [[120689, 120689], "mapped", [946]], [[120690, 120690], "mapped", [947]], [[120691, 120691], "mapped", [948]], [[120692, 120692], "mapped", [949]], [[120693, 120693], "mapped", [950]], [[120694, 120694], "mapped", [951]], [[120695, 120695], "mapped", [952]], [[120696, 120696], "mapped", [953]], [[120697, 120697], "mapped", [954]], [[120698, 120698], "mapped", [955]], [[120699, 120699], "mapped", [956]], [[120700, 120700], "mapped", [957]], [[120701, 120701], "mapped", [958]], [[120702, 120702], "mapped", [959]], [[120703, 120703], "mapped", [960]], [[120704, 120704], "mapped", [961]], [[120705, 120706], "mapped", [963]], [[120707, 120707], "mapped", [964]], [[120708, 120708], "mapped", [965]], [[120709, 120709], "mapped", [966]], [[120710, 120710], "mapped", [967]], [[120711, 120711], "mapped", [968]], [[120712, 120712], "mapped", [969]], [[120713, 120713], "mapped", [8706]], [[120714, 120714], "mapped", [949]], [[120715, 120715], "mapped", [952]], [[120716, 120716], "mapped", [954]], [[120717, 120717], "mapped", [966]], [[120718, 120718], "mapped", [961]], [[120719, 120719], "mapped", [960]], [[120720, 120720], "mapped", [945]], [[120721, 120721], "mapped", [946]], [[120722, 120722], "mapped", [947]], [[120723, 120723], "mapped", [948]], [[120724, 120724], "mapped", [949]], [[120725, 120725], "mapped", [950]], [[120726, 120726], "mapped", [951]], [[120727, 120727], "mapped", [952]], [[120728, 120728], "mapped", [953]], [[120729, 120729], "mapped", [954]], [[120730, 120730], "mapped", [955]], [[120731, 120731], "mapped", [956]], [[120732, 120732], "mapped", [957]], [[120733, 120733], "mapped", [958]], [[120734, 120734], "mapped", [959]], [[120735, 120735], "mapped", [960]], [[120736, 120736], "mapped", [961]], [[120737, 120737], "mapped", [952]], [[120738, 120738], "mapped", [963]], [[120739, 120739], "mapped", [964]], [[120740, 120740], "mapped", [965]], [[120741, 120741], "mapped", [966]], [[120742, 120742], "mapped", [967]], [[120743, 120743], "mapped", [968]], [[120744, 120744], "mapped", [969]], [[120745, 120745], "mapped", [8711]], [[120746, 120746], "mapped", [945]], [[120747, 120747], "mapped", [946]], [[120748, 120748], "mapped", [947]], [[120749, 120749], "mapped", [948]], [[120750, 120750], "mapped", [949]], [[120751, 120751], "mapped", [950]], [[120752, 120752], "mapped", [951]], [[120753, 120753], "mapped", [952]], [[120754, 120754], "mapped", [953]], [[120755, 120755], "mapped", [954]], [[120756, 120756], "mapped", [955]], [[120757, 120757], "mapped", [956]], [[120758, 120758], "mapped", [957]], [[120759, 120759], "mapped", [958]], [[120760, 120760], "mapped", [959]], [[120761, 120761], "mapped", [960]], [[120762, 120762], "mapped", [961]], [[120763, 120764], "mapped", [963]], [[120765, 120765], "mapped", [964]], [[120766, 120766], "mapped", [965]], [[120767, 120767], "mapped", [966]], [[120768, 120768], "mapped", [967]], [[120769, 120769], "mapped", [968]], [[120770, 120770], "mapped", [969]], [[120771, 120771], "mapped", [8706]], [[120772, 120772], "mapped", [949]], [[120773, 120773], "mapped", [952]], [[120774, 120774], "mapped", [954]], [[120775, 120775], "mapped", [966]], [[120776, 120776], "mapped", [961]], [[120777, 120777], "mapped", [960]], [[120778, 120779], "mapped", [989]], [[120780, 120781], "disallowed"], [[120782, 120782], "mapped", [48]], [[120783, 120783], "mapped", [49]], [[120784, 120784], "mapped", [50]], [[120785, 120785], "mapped", [51]], [[120786, 120786], "mapped", [52]], [[120787, 120787], "mapped", [53]], [[120788, 120788], "mapped", [54]], [[120789, 120789], "mapped", [55]], [[120790, 120790], "mapped", [56]], [[120791, 120791], "mapped", [57]], [[120792, 120792], "mapped", [48]], [[120793, 120793], "mapped", [49]], [[120794, 120794], "mapped", [50]], [[120795, 120795], "mapped", [51]], [[120796, 120796], "mapped", [52]], [[120797, 120797], "mapped", [53]], [[120798, 120798], "mapped", [54]], [[120799, 120799], "mapped", [55]], [[120800, 120800], "mapped", [56]], [[120801, 120801], "mapped", [57]], [[120802, 120802], "mapped", [48]], [[120803, 120803], "mapped", [49]], [[120804, 120804], "mapped", [50]], [[120805, 120805], "mapped", [51]], [[120806, 120806], "mapped", [52]], [[120807, 120807], "mapped", [53]], [[120808, 120808], "mapped", [54]], [[120809, 120809], "mapped", [55]], [[120810, 120810], "mapped", [56]], [[120811, 120811], "mapped", [57]], [[120812, 120812], "mapped", [48]], [[120813, 120813], "mapped", [49]], [[120814, 120814], "mapped", [50]], [[120815, 120815], "mapped", [51]], [[120816, 120816], "mapped", [52]], [[120817, 120817], "mapped", [53]], [[120818, 120818], "mapped", [54]], [[120819, 120819], "mapped", [55]], [[120820, 120820], "mapped", [56]], [[120821, 120821], "mapped", [57]], [[120822, 120822], "mapped", [48]], [[120823, 120823], "mapped", [49]], [[120824, 120824], "mapped", [50]], [[120825, 120825], "mapped", [51]], [[120826, 120826], "mapped", [52]], [[120827, 120827], "mapped", [53]], [[120828, 120828], "mapped", [54]], [[120829, 120829], "mapped", [55]], [[120830, 120830], "mapped", [56]], [[120831, 120831], "mapped", [57]], [[120832, 121343], "valid", [], "NV8"], [[121344, 121398], "valid"], [[121399, 121402], "valid", [], "NV8"], [[121403, 121452], "valid"], [[121453, 121460], "valid", [], "NV8"], [[121461, 121461], "valid"], [[121462, 121475], "valid", [], "NV8"], [[121476, 121476], "valid"], [[121477, 121483], "valid", [], "NV8"], [[121484, 121498], "disallowed"], [[121499, 121503], "valid"], [[121504, 121504], "disallowed"], [[121505, 121519], "valid"], [[121520, 124927], "disallowed"], [[124928, 125124], "valid"], [[125125, 125126], "disallowed"], [[125127, 125135], "valid", [], "NV8"], [[125136, 125142], "valid"], [[125143, 126463], "disallowed"], [[126464, 126464], "mapped", [1575]], [[126465, 126465], "mapped", [1576]], [[126466, 126466], "mapped", [1580]], [[126467, 126467], "mapped", [1583]], [[126468, 126468], "disallowed"], [[126469, 126469], "mapped", [1608]], [[126470, 126470], "mapped", [1586]], [[126471, 126471], "mapped", [1581]], [[126472, 126472], "mapped", [1591]], [[126473, 126473], "mapped", [1610]], [[126474, 126474], "mapped", [1603]], [[126475, 126475], "mapped", [1604]], [[126476, 126476], "mapped", [1605]], [[126477, 126477], "mapped", [1606]], [[126478, 126478], "mapped", [1587]], [[126479, 126479], "mapped", [1593]], [[126480, 126480], "mapped", [1601]], [[126481, 126481], "mapped", [1589]], [[126482, 126482], "mapped", [1602]], [[126483, 126483], "mapped", [1585]], [[126484, 126484], "mapped", [1588]], [[126485, 126485], "mapped", [1578]], [[126486, 126486], "mapped", [1579]], [[126487, 126487], "mapped", [1582]], [[126488, 126488], "mapped", [1584]], [[126489, 126489], "mapped", [1590]], [[126490, 126490], "mapped", [1592]], [[126491, 126491], "mapped", [1594]], [[126492, 126492], "mapped", [1646]], [[126493, 126493], "mapped", [1722]], [[126494, 126494], "mapped", [1697]], [[126495, 126495], "mapped", [1647]], [[126496, 126496], "disallowed"], [[126497, 126497], "mapped", [1576]], [[126498, 126498], "mapped", [1580]], [[126499, 126499], "disallowed"], [[126500, 126500], "mapped", [1607]], [[126501, 126502], "disallowed"], [[126503, 126503], "mapped", [1581]], [[126504, 126504], "disallowed"], [[126505, 126505], "mapped", [1610]], [[126506, 126506], "mapped", [1603]], [[126507, 126507], "mapped", [1604]], [[126508, 126508], "mapped", [1605]], [[126509, 126509], "mapped", [1606]], [[126510, 126510], "mapped", [1587]], [[126511, 126511], "mapped", [1593]], [[126512, 126512], "mapped", [1601]], [[126513, 126513], "mapped", [1589]], [[126514, 126514], "mapped", [1602]], [[126515, 126515], "disallowed"], [[126516, 126516], "mapped", [1588]], [[126517, 126517], "mapped", [1578]], [[126518, 126518], "mapped", [1579]], [[126519, 126519], "mapped", [1582]], [[126520, 126520], "disallowed"], [[126521, 126521], "mapped", [1590]], [[126522, 126522], "disallowed"], [[126523, 126523], "mapped", [1594]], [[126524, 126529], "disallowed"], [[126530, 126530], "mapped", [1580]], [[126531, 126534], "disallowed"], [[126535, 126535], "mapped", [1581]], [[126536, 126536], "disallowed"], [[126537, 126537], "mapped", [1610]], [[126538, 126538], "disallowed"], [[126539, 126539], "mapped", [1604]], [[126540, 126540], "disallowed"], [[126541, 126541], "mapped", [1606]], [[126542, 126542], "mapped", [1587]], [[126543, 126543], "mapped", [1593]], [[126544, 126544], "disallowed"], [[126545, 126545], "mapped", [1589]], [[126546, 126546], "mapped", [1602]], [[126547, 126547], "disallowed"], [[126548, 126548], "mapped", [1588]], [[126549, 126550], "disallowed"], [[126551, 126551], "mapped", [1582]], [[126552, 126552], "disallowed"], [[126553, 126553], "mapped", [1590]], [[126554, 126554], "disallowed"], [[126555, 126555], "mapped", [1594]], [[126556, 126556], "disallowed"], [[126557, 126557], "mapped", [1722]], [[126558, 126558], "disallowed"], [[126559, 126559], "mapped", [1647]], [[126560, 126560], "disallowed"], [[126561, 126561], "mapped", [1576]], [[126562, 126562], "mapped", [1580]], [[126563, 126563], "disallowed"], [[126564, 126564], "mapped", [1607]], [[126565, 126566], "disallowed"], [[126567, 126567], "mapped", [1581]], [[126568, 126568], "mapped", [1591]], [[126569, 126569], "mapped", [1610]], [[126570, 126570], "mapped", [1603]], [[126571, 126571], "disallowed"], [[126572, 126572], "mapped", [1605]], [[126573, 126573], "mapped", [1606]], [[126574, 126574], "mapped", [1587]], [[126575, 126575], "mapped", [1593]], [[126576, 126576], "mapped", [1601]], [[126577, 126577], "mapped", [1589]], [[126578, 126578], "mapped", [1602]], [[126579, 126579], "disallowed"], [[126580, 126580], "mapped", [1588]], [[126581, 126581], "mapped", [1578]], [[126582, 126582], "mapped", [1579]], [[126583, 126583], "mapped", [1582]], [[126584, 126584], "disallowed"], [[126585, 126585], "mapped", [1590]], [[126586, 126586], "mapped", [1592]], [[126587, 126587], "mapped", [1594]], [[126588, 126588], "mapped", [1646]], [[126589, 126589], "disallowed"], [[126590, 126590], "mapped", [1697]], [[126591, 126591], "disallowed"], [[126592, 126592], "mapped", [1575]], [[126593, 126593], "mapped", [1576]], [[126594, 126594], "mapped", [1580]], [[126595, 126595], "mapped", [1583]], [[126596, 126596], "mapped", [1607]], [[126597, 126597], "mapped", [1608]], [[126598, 126598], "mapped", [1586]], [[126599, 126599], "mapped", [1581]], [[126600, 126600], "mapped", [1591]], [[126601, 126601], "mapped", [1610]], [[126602, 126602], "disallowed"], [[126603, 126603], "mapped", [1604]], [[126604, 126604], "mapped", [1605]], [[126605, 126605], "mapped", [1606]], [[126606, 126606], "mapped", [1587]], [[126607, 126607], "mapped", [1593]], [[126608, 126608], "mapped", [1601]], [[126609, 126609], "mapped", [1589]], [[126610, 126610], "mapped", [1602]], [[126611, 126611], "mapped", [1585]], [[126612, 126612], "mapped", [1588]], [[126613, 126613], "mapped", [1578]], [[126614, 126614], "mapped", [1579]], [[126615, 126615], "mapped", [1582]], [[126616, 126616], "mapped", [1584]], [[126617, 126617], "mapped", [1590]], [[126618, 126618], "mapped", [1592]], [[126619, 126619], "mapped", [1594]], [[126620, 126624], "disallowed"], [[126625, 126625], "mapped", [1576]], [[126626, 126626], "mapped", [1580]], [[126627, 126627], "mapped", [1583]], [[126628, 126628], "disallowed"], [[126629, 126629], "mapped", [1608]], [[126630, 126630], "mapped", [1586]], [[126631, 126631], "mapped", [1581]], [[126632, 126632], "mapped", [1591]], [[126633, 126633], "mapped", [1610]], [[126634, 126634], "disallowed"], [[126635, 126635], "mapped", [1604]], [[126636, 126636], "mapped", [1605]], [[126637, 126637], "mapped", [1606]], [[126638, 126638], "mapped", [1587]], [[126639, 126639], "mapped", [1593]], [[126640, 126640], "mapped", [1601]], [[126641, 126641], "mapped", [1589]], [[126642, 126642], "mapped", [1602]], [[126643, 126643], "mapped", [1585]], [[126644, 126644], "mapped", [1588]], [[126645, 126645], "mapped", [1578]], [[126646, 126646], "mapped", [1579]], [[126647, 126647], "mapped", [1582]], [[126648, 126648], "mapped", [1584]], [[126649, 126649], "mapped", [1590]], [[126650, 126650], "mapped", [1592]], [[126651, 126651], "mapped", [1594]], [[126652, 126703], "disallowed"], [[126704, 126705], "valid", [], "NV8"], [[126706, 126975], "disallowed"], [[126976, 127019], "valid", [], "NV8"], [[127020, 127023], "disallowed"], [[127024, 127123], "valid", [], "NV8"], [[127124, 127135], "disallowed"], [[127136, 127150], "valid", [], "NV8"], [[127151, 127152], "disallowed"], [[127153, 127166], "valid", [], "NV8"], [[127167, 127167], "valid", [], "NV8"], [[127168, 127168], "disallowed"], [[127169, 127183], "valid", [], "NV8"], [[127184, 127184], "disallowed"], [[127185, 127199], "valid", [], "NV8"], [[127200, 127221], "valid", [], "NV8"], [[127222, 127231], "disallowed"], [[127232, 127232], "disallowed"], [[127233, 127233], "disallowed_STD3_mapped", [48, 44]], [[127234, 127234], "disallowed_STD3_mapped", [49, 44]], [[127235, 127235], "disallowed_STD3_mapped", [50, 44]], [[127236, 127236], "disallowed_STD3_mapped", [51, 44]], [[127237, 127237], "disallowed_STD3_mapped", [52, 44]], [[127238, 127238], "disallowed_STD3_mapped", [53, 44]], [[127239, 127239], "disallowed_STD3_mapped", [54, 44]], [[127240, 127240], "disallowed_STD3_mapped", [55, 44]], [[127241, 127241], "disallowed_STD3_mapped", [56, 44]], [[127242, 127242], "disallowed_STD3_mapped", [57, 44]], [[127243, 127244], "valid", [], "NV8"], [[127245, 127247], "disallowed"], [[127248, 127248], "disallowed_STD3_mapped", [40, 97, 41]], [[127249, 127249], "disallowed_STD3_mapped", [40, 98, 41]], [[127250, 127250], "disallowed_STD3_mapped", [40, 99, 41]], [[127251, 127251], "disallowed_STD3_mapped", [40, 100, 41]], [[127252, 127252], "disallowed_STD3_mapped", [40, 101, 41]], [[127253, 127253], "disallowed_STD3_mapped", [40, 102, 41]], [[127254, 127254], "disallowed_STD3_mapped", [40, 103, 41]], [[127255, 127255], "disallowed_STD3_mapped", [40, 104, 41]], [[127256, 127256], "disallowed_STD3_mapped", [40, 105, 41]], [[127257, 127257], "disallowed_STD3_mapped", [40, 106, 41]], [[127258, 127258], "disallowed_STD3_mapped", [40, 107, 41]], [[127259, 127259], "disallowed_STD3_mapped", [40, 108, 41]], [[127260, 127260], "disallowed_STD3_mapped", [40, 109, 41]], [[127261, 127261], "disallowed_STD3_mapped", [40, 110, 41]], [[127262, 127262], "disallowed_STD3_mapped", [40, 111, 41]], [[127263, 127263], "disallowed_STD3_mapped", [40, 112, 41]], [[127264, 127264], "disallowed_STD3_mapped", [40, 113, 41]], [[127265, 127265], "disallowed_STD3_mapped", [40, 114, 41]], [[127266, 127266], "disallowed_STD3_mapped", [40, 115, 41]], [[127267, 127267], "disallowed_STD3_mapped", [40, 116, 41]], [[127268, 127268], "disallowed_STD3_mapped", [40, 117, 41]], [[127269, 127269], "disallowed_STD3_mapped", [40, 118, 41]], [[127270, 127270], "disallowed_STD3_mapped", [40, 119, 41]], [[127271, 127271], "disallowed_STD3_mapped", [40, 120, 41]], [[127272, 127272], "disallowed_STD3_mapped", [40, 121, 41]], [[127273, 127273], "disallowed_STD3_mapped", [40, 122, 41]], [[127274, 127274], "mapped", [12308, 115, 12309]], [[127275, 127275], "mapped", [99]], [[127276, 127276], "mapped", [114]], [[127277, 127277], "mapped", [99, 100]], [[127278, 127278], "mapped", [119, 122]], [[127279, 127279], "disallowed"], [[127280, 127280], "mapped", [97]], [[127281, 127281], "mapped", [98]], [[127282, 127282], "mapped", [99]], [[127283, 127283], "mapped", [100]], [[127284, 127284], "mapped", [101]], [[127285, 127285], "mapped", [102]], [[127286, 127286], "mapped", [103]], [[127287, 127287], "mapped", [104]], [[127288, 127288], "mapped", [105]], [[127289, 127289], "mapped", [106]], [[127290, 127290], "mapped", [107]], [[127291, 127291], "mapped", [108]], [[127292, 127292], "mapped", [109]], [[127293, 127293], "mapped", [110]], [[127294, 127294], "mapped", [111]], [[127295, 127295], "mapped", [112]], [[127296, 127296], "mapped", [113]], [[127297, 127297], "mapped", [114]], [[127298, 127298], "mapped", [115]], [[127299, 127299], "mapped", [116]], [[127300, 127300], "mapped", [117]], [[127301, 127301], "mapped", [118]], [[127302, 127302], "mapped", [119]], [[127303, 127303], "mapped", [120]], [[127304, 127304], "mapped", [121]], [[127305, 127305], "mapped", [122]], [[127306, 127306], "mapped", [104, 118]], [[127307, 127307], "mapped", [109, 118]], [[127308, 127308], "mapped", [115, 100]], [[127309, 127309], "mapped", [115, 115]], [[127310, 127310], "mapped", [112, 112, 118]], [[127311, 127311], "mapped", [119, 99]], [[127312, 127318], "valid", [], "NV8"], [[127319, 127319], "valid", [], "NV8"], [[127320, 127326], "valid", [], "NV8"], [[127327, 127327], "valid", [], "NV8"], [[127328, 127337], "valid", [], "NV8"], [[127338, 127338], "mapped", [109, 99]], [[127339, 127339], "mapped", [109, 100]], [[127340, 127343], "disallowed"], [[127344, 127352], "valid", [], "NV8"], [[127353, 127353], "valid", [], "NV8"], [[127354, 127354], "valid", [], "NV8"], [[127355, 127356], "valid", [], "NV8"], [[127357, 127358], "valid", [], "NV8"], [[127359, 127359], "valid", [], "NV8"], [[127360, 127369], "valid", [], "NV8"], [[127370, 127373], "valid", [], "NV8"], [[127374, 127375], "valid", [], "NV8"], [[127376, 127376], "mapped", [100, 106]], [[127377, 127386], "valid", [], "NV8"], [[127387, 127461], "disallowed"], [[127462, 127487], "valid", [], "NV8"], [[127488, 127488], "mapped", [12411, 12363]], [[127489, 127489], "mapped", [12467, 12467]], [[127490, 127490], "mapped", [12469]], [[127491, 127503], "disallowed"], [[127504, 127504], "mapped", [25163]], [[127505, 127505], "mapped", [23383]], [[127506, 127506], "mapped", [21452]], [[127507, 127507], "mapped", [12487]], [[127508, 127508], "mapped", [20108]], [[127509, 127509], "mapped", [22810]], [[127510, 127510], "mapped", [35299]], [[127511, 127511], "mapped", [22825]], [[127512, 127512], "mapped", [20132]], [[127513, 127513], "mapped", [26144]], [[127514, 127514], "mapped", [28961]], [[127515, 127515], "mapped", [26009]], [[127516, 127516], "mapped", [21069]], [[127517, 127517], "mapped", [24460]], [[127518, 127518], "mapped", [20877]], [[127519, 127519], "mapped", [26032]], [[127520, 127520], "mapped", [21021]], [[127521, 127521], "mapped", [32066]], [[127522, 127522], "mapped", [29983]], [[127523, 127523], "mapped", [36009]], [[127524, 127524], "mapped", [22768]], [[127525, 127525], "mapped", [21561]], [[127526, 127526], "mapped", [28436]], [[127527, 127527], "mapped", [25237]], [[127528, 127528], "mapped", [25429]], [[127529, 127529], "mapped", [19968]], [[127530, 127530], "mapped", [19977]], [[127531, 127531], "mapped", [36938]], [[127532, 127532], "mapped", [24038]], [[127533, 127533], "mapped", [20013]], [[127534, 127534], "mapped", [21491]], [[127535, 127535], "mapped", [25351]], [[127536, 127536], "mapped", [36208]], [[127537, 127537], "mapped", [25171]], [[127538, 127538], "mapped", [31105]], [[127539, 127539], "mapped", [31354]], [[127540, 127540], "mapped", [21512]], [[127541, 127541], "mapped", [28288]], [[127542, 127542], "mapped", [26377]], [[127543, 127543], "mapped", [26376]], [[127544, 127544], "mapped", [30003]], [[127545, 127545], "mapped", [21106]], [[127546, 127546], "mapped", [21942]], [[127547, 127551], "disallowed"], [[127552, 127552], "mapped", [12308, 26412, 12309]], [[127553, 127553], "mapped", [12308, 19977, 12309]], [[127554, 127554], "mapped", [12308, 20108, 12309]], [[127555, 127555], "mapped", [12308, 23433, 12309]], [[127556, 127556], "mapped", [12308, 28857, 12309]], [[127557, 127557], "mapped", [12308, 25171, 12309]], [[127558, 127558], "mapped", [12308, 30423, 12309]], [[127559, 127559], "mapped", [12308, 21213, 12309]], [[127560, 127560], "mapped", [12308, 25943, 12309]], [[127561, 127567], "disallowed"], [[127568, 127568], "mapped", [24471]], [[127569, 127569], "mapped", [21487]], [[127570, 127743], "disallowed"], [[127744, 127776], "valid", [], "NV8"], [[127777, 127788], "valid", [], "NV8"], [[127789, 127791], "valid", [], "NV8"], [[127792, 127797], "valid", [], "NV8"], [[127798, 127798], "valid", [], "NV8"], [[127799, 127868], "valid", [], "NV8"], [[127869, 127869], "valid", [], "NV8"], [[127870, 127871], "valid", [], "NV8"], [[127872, 127891], "valid", [], "NV8"], [[127892, 127903], "valid", [], "NV8"], [[127904, 127940], "valid", [], "NV8"], [[127941, 127941], "valid", [], "NV8"], [[127942, 127946], "valid", [], "NV8"], [[127947, 127950], "valid", [], "NV8"], [[127951, 127955], "valid", [], "NV8"], [[127956, 127967], "valid", [], "NV8"], [[127968, 127984], "valid", [], "NV8"], [[127985, 127991], "valid", [], "NV8"], [[127992, 127999], "valid", [], "NV8"], [[128e3, 128062], "valid", [], "NV8"], [[128063, 128063], "valid", [], "NV8"], [[128064, 128064], "valid", [], "NV8"], [[128065, 128065], "valid", [], "NV8"], [[128066, 128247], "valid", [], "NV8"], [[128248, 128248], "valid", [], "NV8"], [[128249, 128252], "valid", [], "NV8"], [[128253, 128254], "valid", [], "NV8"], [[128255, 128255], "valid", [], "NV8"], [[128256, 128317], "valid", [], "NV8"], [[128318, 128319], "valid", [], "NV8"], [[128320, 128323], "valid", [], "NV8"], [[128324, 128330], "valid", [], "NV8"], [[128331, 128335], "valid", [], "NV8"], [[128336, 128359], "valid", [], "NV8"], [[128360, 128377], "valid", [], "NV8"], [[128378, 128378], "disallowed"], [[128379, 128419], "valid", [], "NV8"], [[128420, 128420], "disallowed"], [[128421, 128506], "valid", [], "NV8"], [[128507, 128511], "valid", [], "NV8"], [[128512, 128512], "valid", [], "NV8"], [[128513, 128528], "valid", [], "NV8"], [[128529, 128529], "valid", [], "NV8"], [[128530, 128532], "valid", [], "NV8"], [[128533, 128533], "valid", [], "NV8"], [[128534, 128534], "valid", [], "NV8"], [[128535, 128535], "valid", [], "NV8"], [[128536, 128536], "valid", [], "NV8"], [[128537, 128537], "valid", [], "NV8"], [[128538, 128538], "valid", [], "NV8"], [[128539, 128539], "valid", [], "NV8"], [[128540, 128542], "valid", [], "NV8"], [[128543, 128543], "valid", [], "NV8"], [[128544, 128549], "valid", [], "NV8"], [[128550, 128551], "valid", [], "NV8"], [[128552, 128555], "valid", [], "NV8"], [[128556, 128556], "valid", [], "NV8"], [[128557, 128557], "valid", [], "NV8"], [[128558, 128559], "valid", [], "NV8"], [[128560, 128563], "valid", [], "NV8"], [[128564, 128564], "valid", [], "NV8"], [[128565, 128576], "valid", [], "NV8"], [[128577, 128578], "valid", [], "NV8"], [[128579, 128580], "valid", [], "NV8"], [[128581, 128591], "valid", [], "NV8"], [[128592, 128639], "valid", [], "NV8"], [[128640, 128709], "valid", [], "NV8"], [[128710, 128719], "valid", [], "NV8"], [[128720, 128720], "valid", [], "NV8"], [[128721, 128735], "disallowed"], [[128736, 128748], "valid", [], "NV8"], [[128749, 128751], "disallowed"], [[128752, 128755], "valid", [], "NV8"], [[128756, 128767], "disallowed"], [[128768, 128883], "valid", [], "NV8"], [[128884, 128895], "disallowed"], [[128896, 128980], "valid", [], "NV8"], [[128981, 129023], "disallowed"], [[129024, 129035], "valid", [], "NV8"], [[129036, 129039], "disallowed"], [[129040, 129095], "valid", [], "NV8"], [[129096, 129103], "disallowed"], [[129104, 129113], "valid", [], "NV8"], [[129114, 129119], "disallowed"], [[129120, 129159], "valid", [], "NV8"], [[129160, 129167], "disallowed"], [[129168, 129197], "valid", [], "NV8"], [[129198, 129295], "disallowed"], [[129296, 129304], "valid", [], "NV8"], [[129305, 129407], "disallowed"], [[129408, 129412], "valid", [], "NV8"], [[129413, 129471], "disallowed"], [[129472, 129472], "valid", [], "NV8"], [[129473, 131069], "disallowed"], [[131070, 131071], "disallowed"], [[131072, 173782], "valid"], [[173783, 173823], "disallowed"], [[173824, 177972], "valid"], [[177973, 177983], "disallowed"], [[177984, 178205], "valid"], [[178206, 178207], "disallowed"], [[178208, 183969], "valid"], [[183970, 194559], "disallowed"], [[194560, 194560], "mapped", [20029]], [[194561, 194561], "mapped", [20024]], [[194562, 194562], "mapped", [20033]], [[194563, 194563], "mapped", [131362]], [[194564, 194564], "mapped", [20320]], [[194565, 194565], "mapped", [20398]], [[194566, 194566], "mapped", [20411]], [[194567, 194567], "mapped", [20482]], [[194568, 194568], "mapped", [20602]], [[194569, 194569], "mapped", [20633]], [[194570, 194570], "mapped", [20711]], [[194571, 194571], "mapped", [20687]], [[194572, 194572], "mapped", [13470]], [[194573, 194573], "mapped", [132666]], [[194574, 194574], "mapped", [20813]], [[194575, 194575], "mapped", [20820]], [[194576, 194576], "mapped", [20836]], [[194577, 194577], "mapped", [20855]], [[194578, 194578], "mapped", [132380]], [[194579, 194579], "mapped", [13497]], [[194580, 194580], "mapped", [20839]], [[194581, 194581], "mapped", [20877]], [[194582, 194582], "mapped", [132427]], [[194583, 194583], "mapped", [20887]], [[194584, 194584], "mapped", [20900]], [[194585, 194585], "mapped", [20172]], [[194586, 194586], "mapped", [20908]], [[194587, 194587], "mapped", [20917]], [[194588, 194588], "mapped", [168415]], [[194589, 194589], "mapped", [20981]], [[194590, 194590], "mapped", [20995]], [[194591, 194591], "mapped", [13535]], [[194592, 194592], "mapped", [21051]], [[194593, 194593], "mapped", [21062]], [[194594, 194594], "mapped", [21106]], [[194595, 194595], "mapped", [21111]], [[194596, 194596], "mapped", [13589]], [[194597, 194597], "mapped", [21191]], [[194598, 194598], "mapped", [21193]], [[194599, 194599], "mapped", [21220]], [[194600, 194600], "mapped", [21242]], [[194601, 194601], "mapped", [21253]], [[194602, 194602], "mapped", [21254]], [[194603, 194603], "mapped", [21271]], [[194604, 194604], "mapped", [21321]], [[194605, 194605], "mapped", [21329]], [[194606, 194606], "mapped", [21338]], [[194607, 194607], "mapped", [21363]], [[194608, 194608], "mapped", [21373]], [[194609, 194611], "mapped", [21375]], [[194612, 194612], "mapped", [133676]], [[194613, 194613], "mapped", [28784]], [[194614, 194614], "mapped", [21450]], [[194615, 194615], "mapped", [21471]], [[194616, 194616], "mapped", [133987]], [[194617, 194617], "mapped", [21483]], [[194618, 194618], "mapped", [21489]], [[194619, 194619], "mapped", [21510]], [[194620, 194620], "mapped", [21662]], [[194621, 194621], "mapped", [21560]], [[194622, 194622], "mapped", [21576]], [[194623, 194623], "mapped", [21608]], [[194624, 194624], "mapped", [21666]], [[194625, 194625], "mapped", [21750]], [[194626, 194626], "mapped", [21776]], [[194627, 194627], "mapped", [21843]], [[194628, 194628], "mapped", [21859]], [[194629, 194630], "mapped", [21892]], [[194631, 194631], "mapped", [21913]], [[194632, 194632], "mapped", [21931]], [[194633, 194633], "mapped", [21939]], [[194634, 194634], "mapped", [21954]], [[194635, 194635], "mapped", [22294]], [[194636, 194636], "mapped", [22022]], [[194637, 194637], "mapped", [22295]], [[194638, 194638], "mapped", [22097]], [[194639, 194639], "mapped", [22132]], [[194640, 194640], "mapped", [20999]], [[194641, 194641], "mapped", [22766]], [[194642, 194642], "mapped", [22478]], [[194643, 194643], "mapped", [22516]], [[194644, 194644], "mapped", [22541]], [[194645, 194645], "mapped", [22411]], [[194646, 194646], "mapped", [22578]], [[194647, 194647], "mapped", [22577]], [[194648, 194648], "mapped", [22700]], [[194649, 194649], "mapped", [136420]], [[194650, 194650], "mapped", [22770]], [[194651, 194651], "mapped", [22775]], [[194652, 194652], "mapped", [22790]], [[194653, 194653], "mapped", [22810]], [[194654, 194654], "mapped", [22818]], [[194655, 194655], "mapped", [22882]], [[194656, 194656], "mapped", [136872]], [[194657, 194657], "mapped", [136938]], [[194658, 194658], "mapped", [23020]], [[194659, 194659], "mapped", [23067]], [[194660, 194660], "mapped", [23079]], [[194661, 194661], "mapped", [23e3]], [[194662, 194662], "mapped", [23142]], [[194663, 194663], "mapped", [14062]], [[194664, 194664], "disallowed"], [[194665, 194665], "mapped", [23304]], [[194666, 194667], "mapped", [23358]], [[194668, 194668], "mapped", [137672]], [[194669, 194669], "mapped", [23491]], [[194670, 194670], "mapped", [23512]], [[194671, 194671], "mapped", [23527]], [[194672, 194672], "mapped", [23539]], [[194673, 194673], "mapped", [138008]], [[194674, 194674], "mapped", [23551]], [[194675, 194675], "mapped", [23558]], [[194676, 194676], "disallowed"], [[194677, 194677], "mapped", [23586]], [[194678, 194678], "mapped", [14209]], [[194679, 194679], "mapped", [23648]], [[194680, 194680], "mapped", [23662]], [[194681, 194681], "mapped", [23744]], [[194682, 194682], "mapped", [23693]], [[194683, 194683], "mapped", [138724]], [[194684, 194684], "mapped", [23875]], [[194685, 194685], "mapped", [138726]], [[194686, 194686], "mapped", [23918]], [[194687, 194687], "mapped", [23915]], [[194688, 194688], "mapped", [23932]], [[194689, 194689], "mapped", [24033]], [[194690, 194690], "mapped", [24034]], [[194691, 194691], "mapped", [14383]], [[194692, 194692], "mapped", [24061]], [[194693, 194693], "mapped", [24104]], [[194694, 194694], "mapped", [24125]], [[194695, 194695], "mapped", [24169]], [[194696, 194696], "mapped", [14434]], [[194697, 194697], "mapped", [139651]], [[194698, 194698], "mapped", [14460]], [[194699, 194699], "mapped", [24240]], [[194700, 194700], "mapped", [24243]], [[194701, 194701], "mapped", [24246]], [[194702, 194702], "mapped", [24266]], [[194703, 194703], "mapped", [172946]], [[194704, 194704], "mapped", [24318]], [[194705, 194706], "mapped", [140081]], [[194707, 194707], "mapped", [33281]], [[194708, 194709], "mapped", [24354]], [[194710, 194710], "mapped", [14535]], [[194711, 194711], "mapped", [144056]], [[194712, 194712], "mapped", [156122]], [[194713, 194713], "mapped", [24418]], [[194714, 194714], "mapped", [24427]], [[194715, 194715], "mapped", [14563]], [[194716, 194716], "mapped", [24474]], [[194717, 194717], "mapped", [24525]], [[194718, 194718], "mapped", [24535]], [[194719, 194719], "mapped", [24569]], [[194720, 194720], "mapped", [24705]], [[194721, 194721], "mapped", [14650]], [[194722, 194722], "mapped", [14620]], [[194723, 194723], "mapped", [24724]], [[194724, 194724], "mapped", [141012]], [[194725, 194725], "mapped", [24775]], [[194726, 194726], "mapped", [24904]], [[194727, 194727], "mapped", [24908]], [[194728, 194728], "mapped", [24910]], [[194729, 194729], "mapped", [24908]], [[194730, 194730], "mapped", [24954]], [[194731, 194731], "mapped", [24974]], [[194732, 194732], "mapped", [25010]], [[194733, 194733], "mapped", [24996]], [[194734, 194734], "mapped", [25007]], [[194735, 194735], "mapped", [25054]], [[194736, 194736], "mapped", [25074]], [[194737, 194737], "mapped", [25078]], [[194738, 194738], "mapped", [25104]], [[194739, 194739], "mapped", [25115]], [[194740, 194740], "mapped", [25181]], [[194741, 194741], "mapped", [25265]], [[194742, 194742], "mapped", [25300]], [[194743, 194743], "mapped", [25424]], [[194744, 194744], "mapped", [142092]], [[194745, 194745], "mapped", [25405]], [[194746, 194746], "mapped", [25340]], [[194747, 194747], "mapped", [25448]], [[194748, 194748], "mapped", [25475]], [[194749, 194749], "mapped", [25572]], [[194750, 194750], "mapped", [142321]], [[194751, 194751], "mapped", [25634]], [[194752, 194752], "mapped", [25541]], [[194753, 194753], "mapped", [25513]], [[194754, 194754], "mapped", [14894]], [[194755, 194755], "mapped", [25705]], [[194756, 194756], "mapped", [25726]], [[194757, 194757], "mapped", [25757]], [[194758, 194758], "mapped", [25719]], [[194759, 194759], "mapped", [14956]], [[194760, 194760], "mapped", [25935]], [[194761, 194761], "mapped", [25964]], [[194762, 194762], "mapped", [143370]], [[194763, 194763], "mapped", [26083]], [[194764, 194764], "mapped", [26360]], [[194765, 194765], "mapped", [26185]], [[194766, 194766], "mapped", [15129]], [[194767, 194767], "mapped", [26257]], [[194768, 194768], "mapped", [15112]], [[194769, 194769], "mapped", [15076]], [[194770, 194770], "mapped", [20882]], [[194771, 194771], "mapped", [20885]], [[194772, 194772], "mapped", [26368]], [[194773, 194773], "mapped", [26268]], [[194774, 194774], "mapped", [32941]], [[194775, 194775], "mapped", [17369]], [[194776, 194776], "mapped", [26391]], [[194777, 194777], "mapped", [26395]], [[194778, 194778], "mapped", [26401]], [[194779, 194779], "mapped", [26462]], [[194780, 194780], "mapped", [26451]], [[194781, 194781], "mapped", [144323]], [[194782, 194782], "mapped", [15177]], [[194783, 194783], "mapped", [26618]], [[194784, 194784], "mapped", [26501]], [[194785, 194785], "mapped", [26706]], [[194786, 194786], "mapped", [26757]], [[194787, 194787], "mapped", [144493]], [[194788, 194788], "mapped", [26766]], [[194789, 194789], "mapped", [26655]], [[194790, 194790], "mapped", [26900]], [[194791, 194791], "mapped", [15261]], [[194792, 194792], "mapped", [26946]], [[194793, 194793], "mapped", [27043]], [[194794, 194794], "mapped", [27114]], [[194795, 194795], "mapped", [27304]], [[194796, 194796], "mapped", [145059]], [[194797, 194797], "mapped", [27355]], [[194798, 194798], "mapped", [15384]], [[194799, 194799], "mapped", [27425]], [[194800, 194800], "mapped", [145575]], [[194801, 194801], "mapped", [27476]], [[194802, 194802], "mapped", [15438]], [[194803, 194803], "mapped", [27506]], [[194804, 194804], "mapped", [27551]], [[194805, 194805], "mapped", [27578]], [[194806, 194806], "mapped", [27579]], [[194807, 194807], "mapped", [146061]], [[194808, 194808], "mapped", [138507]], [[194809, 194809], "mapped", [146170]], [[194810, 194810], "mapped", [27726]], [[194811, 194811], "mapped", [146620]], [[194812, 194812], "mapped", [27839]], [[194813, 194813], "mapped", [27853]], [[194814, 194814], "mapped", [27751]], [[194815, 194815], "mapped", [27926]], [[194816, 194816], "mapped", [27966]], [[194817, 194817], "mapped", [28023]], [[194818, 194818], "mapped", [27969]], [[194819, 194819], "mapped", [28009]], [[194820, 194820], "mapped", [28024]], [[194821, 194821], "mapped", [28037]], [[194822, 194822], "mapped", [146718]], [[194823, 194823], "mapped", [27956]], [[194824, 194824], "mapped", [28207]], [[194825, 194825], "mapped", [28270]], [[194826, 194826], "mapped", [15667]], [[194827, 194827], "mapped", [28363]], [[194828, 194828], "mapped", [28359]], [[194829, 194829], "mapped", [147153]], [[194830, 194830], "mapped", [28153]], [[194831, 194831], "mapped", [28526]], [[194832, 194832], "mapped", [147294]], [[194833, 194833], "mapped", [147342]], [[194834, 194834], "mapped", [28614]], [[194835, 194835], "mapped", [28729]], [[194836, 194836], "mapped", [28702]], [[194837, 194837], "mapped", [28699]], [[194838, 194838], "mapped", [15766]], [[194839, 194839], "mapped", [28746]], [[194840, 194840], "mapped", [28797]], [[194841, 194841], "mapped", [28791]], [[194842, 194842], "mapped", [28845]], [[194843, 194843], "mapped", [132389]], [[194844, 194844], "mapped", [28997]], [[194845, 194845], "mapped", [148067]], [[194846, 194846], "mapped", [29084]], [[194847, 194847], "disallowed"], [[194848, 194848], "mapped", [29224]], [[194849, 194849], "mapped", [29237]], [[194850, 194850], "mapped", [29264]], [[194851, 194851], "mapped", [149e3]], [[194852, 194852], "mapped", [29312]], [[194853, 194853], "mapped", [29333]], [[194854, 194854], "mapped", [149301]], [[194855, 194855], "mapped", [149524]], [[194856, 194856], "mapped", [29562]], [[194857, 194857], "mapped", [29579]], [[194858, 194858], "mapped", [16044]], [[194859, 194859], "mapped", [29605]], [[194860, 194861], "mapped", [16056]], [[194862, 194862], "mapped", [29767]], [[194863, 194863], "mapped", [29788]], [[194864, 194864], "mapped", [29809]], [[194865, 194865], "mapped", [29829]], [[194866, 194866], "mapped", [29898]], [[194867, 194867], "mapped", [16155]], [[194868, 194868], "mapped", [29988]], [[194869, 194869], "mapped", [150582]], [[194870, 194870], "mapped", [30014]], [[194871, 194871], "mapped", [150674]], [[194872, 194872], "mapped", [30064]], [[194873, 194873], "mapped", [139679]], [[194874, 194874], "mapped", [30224]], [[194875, 194875], "mapped", [151457]], [[194876, 194876], "mapped", [151480]], [[194877, 194877], "mapped", [151620]], [[194878, 194878], "mapped", [16380]], [[194879, 194879], "mapped", [16392]], [[194880, 194880], "mapped", [30452]], [[194881, 194881], "mapped", [151795]], [[194882, 194882], "mapped", [151794]], [[194883, 194883], "mapped", [151833]], [[194884, 194884], "mapped", [151859]], [[194885, 194885], "mapped", [30494]], [[194886, 194887], "mapped", [30495]], [[194888, 194888], "mapped", [30538]], [[194889, 194889], "mapped", [16441]], [[194890, 194890], "mapped", [30603]], [[194891, 194891], "mapped", [16454]], [[194892, 194892], "mapped", [16534]], [[194893, 194893], "mapped", [152605]], [[194894, 194894], "mapped", [30798]], [[194895, 194895], "mapped", [30860]], [[194896, 194896], "mapped", [30924]], [[194897, 194897], "mapped", [16611]], [[194898, 194898], "mapped", [153126]], [[194899, 194899], "mapped", [31062]], [[194900, 194900], "mapped", [153242]], [[194901, 194901], "mapped", [153285]], [[194902, 194902], "mapped", [31119]], [[194903, 194903], "mapped", [31211]], [[194904, 194904], "mapped", [16687]], [[194905, 194905], "mapped", [31296]], [[194906, 194906], "mapped", [31306]], [[194907, 194907], "mapped", [31311]], [[194908, 194908], "mapped", [153980]], [[194909, 194910], "mapped", [154279]], [[194911, 194911], "disallowed"], [[194912, 194912], "mapped", [16898]], [[194913, 194913], "mapped", [154539]], [[194914, 194914], "mapped", [31686]], [[194915, 194915], "mapped", [31689]], [[194916, 194916], "mapped", [16935]], [[194917, 194917], "mapped", [154752]], [[194918, 194918], "mapped", [31954]], [[194919, 194919], "mapped", [17056]], [[194920, 194920], "mapped", [31976]], [[194921, 194921], "mapped", [31971]], [[194922, 194922], "mapped", [32e3]], [[194923, 194923], "mapped", [155526]], [[194924, 194924], "mapped", [32099]], [[194925, 194925], "mapped", [17153]], [[194926, 194926], "mapped", [32199]], [[194927, 194927], "mapped", [32258]], [[194928, 194928], "mapped", [32325]], [[194929, 194929], "mapped", [17204]], [[194930, 194930], "mapped", [156200]], [[194931, 194931], "mapped", [156231]], [[194932, 194932], "mapped", [17241]], [[194933, 194933], "mapped", [156377]], [[194934, 194934], "mapped", [32634]], [[194935, 194935], "mapped", [156478]], [[194936, 194936], "mapped", [32661]], [[194937, 194937], "mapped", [32762]], [[194938, 194938], "mapped", [32773]], [[194939, 194939], "mapped", [156890]], [[194940, 194940], "mapped", [156963]], [[194941, 194941], "mapped", [32864]], [[194942, 194942], "mapped", [157096]], [[194943, 194943], "mapped", [32880]], [[194944, 194944], "mapped", [144223]], [[194945, 194945], "mapped", [17365]], [[194946, 194946], "mapped", [32946]], [[194947, 194947], "mapped", [33027]], [[194948, 194948], "mapped", [17419]], [[194949, 194949], "mapped", [33086]], [[194950, 194950], "mapped", [23221]], [[194951, 194951], "mapped", [157607]], [[194952, 194952], "mapped", [157621]], [[194953, 194953], "mapped", [144275]], [[194954, 194954], "mapped", [144284]], [[194955, 194955], "mapped", [33281]], [[194956, 194956], "mapped", [33284]], [[194957, 194957], "mapped", [36766]], [[194958, 194958], "mapped", [17515]], [[194959, 194959], "mapped", [33425]], [[194960, 194960], "mapped", [33419]], [[194961, 194961], "mapped", [33437]], [[194962, 194962], "mapped", [21171]], [[194963, 194963], "mapped", [33457]], [[194964, 194964], "mapped", [33459]], [[194965, 194965], "mapped", [33469]], [[194966, 194966], "mapped", [33510]], [[194967, 194967], "mapped", [158524]], [[194968, 194968], "mapped", [33509]], [[194969, 194969], "mapped", [33565]], [[194970, 194970], "mapped", [33635]], [[194971, 194971], "mapped", [33709]], [[194972, 194972], "mapped", [33571]], [[194973, 194973], "mapped", [33725]], [[194974, 194974], "mapped", [33767]], [[194975, 194975], "mapped", [33879]], [[194976, 194976], "mapped", [33619]], [[194977, 194977], "mapped", [33738]], [[194978, 194978], "mapped", [33740]], [[194979, 194979], "mapped", [33756]], [[194980, 194980], "mapped", [158774]], [[194981, 194981], "mapped", [159083]], [[194982, 194982], "mapped", [158933]], [[194983, 194983], "mapped", [17707]], [[194984, 194984], "mapped", [34033]], [[194985, 194985], "mapped", [34035]], [[194986, 194986], "mapped", [34070]], [[194987, 194987], "mapped", [160714]], [[194988, 194988], "mapped", [34148]], [[194989, 194989], "mapped", [159532]], [[194990, 194990], "mapped", [17757]], [[194991, 194991], "mapped", [17761]], [[194992, 194992], "mapped", [159665]], [[194993, 194993], "mapped", [159954]], [[194994, 194994], "mapped", [17771]], [[194995, 194995], "mapped", [34384]], [[194996, 194996], "mapped", [34396]], [[194997, 194997], "mapped", [34407]], [[194998, 194998], "mapped", [34409]], [[194999, 194999], "mapped", [34473]], [[195e3, 195e3], "mapped", [34440]], [[195001, 195001], "mapped", [34574]], [[195002, 195002], "mapped", [34530]], [[195003, 195003], "mapped", [34681]], [[195004, 195004], "mapped", [34600]], [[195005, 195005], "mapped", [34667]], [[195006, 195006], "mapped", [34694]], [[195007, 195007], "disallowed"], [[195008, 195008], "mapped", [34785]], [[195009, 195009], "mapped", [34817]], [[195010, 195010], "mapped", [17913]], [[195011, 195011], "mapped", [34912]], [[195012, 195012], "mapped", [34915]], [[195013, 195013], "mapped", [161383]], [[195014, 195014], "mapped", [35031]], [[195015, 195015], "mapped", [35038]], [[195016, 195016], "mapped", [17973]], [[195017, 195017], "mapped", [35066]], [[195018, 195018], "mapped", [13499]], [[195019, 195019], "mapped", [161966]], [[195020, 195020], "mapped", [162150]], [[195021, 195021], "mapped", [18110]], [[195022, 195022], "mapped", [18119]], [[195023, 195023], "mapped", [35488]], [[195024, 195024], "mapped", [35565]], [[195025, 195025], "mapped", [35722]], [[195026, 195026], "mapped", [35925]], [[195027, 195027], "mapped", [162984]], [[195028, 195028], "mapped", [36011]], [[195029, 195029], "mapped", [36033]], [[195030, 195030], "mapped", [36123]], [[195031, 195031], "mapped", [36215]], [[195032, 195032], "mapped", [163631]], [[195033, 195033], "mapped", [133124]], [[195034, 195034], "mapped", [36299]], [[195035, 195035], "mapped", [36284]], [[195036, 195036], "mapped", [36336]], [[195037, 195037], "mapped", [133342]], [[195038, 195038], "mapped", [36564]], [[195039, 195039], "mapped", [36664]], [[195040, 195040], "mapped", [165330]], [[195041, 195041], "mapped", [165357]], [[195042, 195042], "mapped", [37012]], [[195043, 195043], "mapped", [37105]], [[195044, 195044], "mapped", [37137]], [[195045, 195045], "mapped", [165678]], [[195046, 195046], "mapped", [37147]], [[195047, 195047], "mapped", [37432]], [[195048, 195048], "mapped", [37591]], [[195049, 195049], "mapped", [37592]], [[195050, 195050], "mapped", [37500]], [[195051, 195051], "mapped", [37881]], [[195052, 195052], "mapped", [37909]], [[195053, 195053], "mapped", [166906]], [[195054, 195054], "mapped", [38283]], [[195055, 195055], "mapped", [18837]], [[195056, 195056], "mapped", [38327]], [[195057, 195057], "mapped", [167287]], [[195058, 195058], "mapped", [18918]], [[195059, 195059], "mapped", [38595]], [[195060, 195060], "mapped", [23986]], [[195061, 195061], "mapped", [38691]], [[195062, 195062], "mapped", [168261]], [[195063, 195063], "mapped", [168474]], [[195064, 195064], "mapped", [19054]], [[195065, 195065], "mapped", [19062]], [[195066, 195066], "mapped", [38880]], [[195067, 195067], "mapped", [168970]], [[195068, 195068], "mapped", [19122]], [[195069, 195069], "mapped", [169110]], [[195070, 195071], "mapped", [38923]], [[195072, 195072], "mapped", [38953]], [[195073, 195073], "mapped", [169398]], [[195074, 195074], "mapped", [39138]], [[195075, 195075], "mapped", [19251]], [[195076, 195076], "mapped", [39209]], [[195077, 195077], "mapped", [39335]], [[195078, 195078], "mapped", [39362]], [[195079, 195079], "mapped", [39422]], [[195080, 195080], "mapped", [19406]], [[195081, 195081], "mapped", [170800]], [[195082, 195082], "mapped", [39698]], [[195083, 195083], "mapped", [4e4]], [[195084, 195084], "mapped", [40189]], [[195085, 195085], "mapped", [19662]], [[195086, 195086], "mapped", [19693]], [[195087, 195087], "mapped", [40295]], [[195088, 195088], "mapped", [172238]], [[195089, 195089], "mapped", [19704]], [[195090, 195090], "mapped", [172293]], [[195091, 195091], "mapped", [172558]], [[195092, 195092], "mapped", [172689]], [[195093, 195093], "mapped", [40635]], [[195094, 195094], "mapped", [19798]], [[195095, 195095], "mapped", [40697]], [[195096, 195096], "mapped", [40702]], [[195097, 195097], "mapped", [40709]], [[195098, 195098], "mapped", [40719]], [[195099, 195099], "mapped", [40726]], [[195100, 195100], "mapped", [40763]], [[195101, 195101], "mapped", [173568]], [[195102, 196605], "disallowed"], [[196606, 196607], "disallowed"], [[196608, 262141], "disallowed"], [[262142, 262143], "disallowed"], [[262144, 327677], "disallowed"], [[327678, 327679], "disallowed"], [[327680, 393213], "disallowed"], [[393214, 393215], "disallowed"], [[393216, 458749], "disallowed"], [[458750, 458751], "disallowed"], [[458752, 524285], "disallowed"], [[524286, 524287], "disallowed"], [[524288, 589821], "disallowed"], [[589822, 589823], "disallowed"], [[589824, 655357], "disallowed"], [[655358, 655359], "disallowed"], [[655360, 720893], "disallowed"], [[720894, 720895], "disallowed"], [[720896, 786429], "disallowed"], [[786430, 786431], "disallowed"], [[786432, 851965], "disallowed"], [[851966, 851967], "disallowed"], [[851968, 917501], "disallowed"], [[917502, 917503], "disallowed"], [[917504, 917504], "disallowed"], [[917505, 917505], "disallowed"], [[917506, 917535], "disallowed"], [[917536, 917631], "disallowed"], [[917632, 917759], "disallowed"], [[917760, 917999], "ignored"], [[918e3, 983037], "disallowed"], [[983038, 983039], "disallowed"], [[983040, 1048573], "disallowed"], [[1048574, 1048575], "disallowed"], [[1048576, 1114109], "disallowed"], [[1114110, 1114111], "disallowed"]];
  }
});

// node_modules/@octokit/request/node_modules/tr46/index.js
var require_tr46 = __commonJS({
  "node_modules/@octokit/request/node_modules/tr46/index.js"(exports, module2) {
    "use strict";
    var punycode = require("punycode");
    var mappingTable = require_mappingTable();
    var PROCESSING_OPTIONS = {
      TRANSITIONAL: 0,
      NONTRANSITIONAL: 1
    };
    function normalize(str) {
      return str.split("\0").map(function(s2) {
        return s2.normalize("NFC");
      }).join("\0");
    }
    function findStatus(val) {
      var start = 0;
      var end = mappingTable.length - 1;
      while (start <= end) {
        var mid = Math.floor((start + end) / 2);
        var target = mappingTable[mid];
        if (target[0][0] <= val && target[0][1] >= val) {
          return target;
        } else if (target[0][0] > val) {
          end = mid - 1;
        } else {
          start = mid + 1;
        }
      }
      return null;
    }
    var regexAstralSymbols = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
    function countSymbols(string) {
      return string.replace(regexAstralSymbols, "_").length;
    }
    function mapChars(domain_name, useSTD3, processing_option) {
      var hasError = false;
      var processed = "";
      var len = countSymbols(domain_name);
      for (var i2 = 0; i2 < len; ++i2) {
        var codePoint = domain_name.codePointAt(i2);
        var status = findStatus(codePoint);
        switch (status[1]) {
          case "disallowed":
            hasError = true;
            processed += String.fromCodePoint(codePoint);
            break;
          case "ignored":
            break;
          case "mapped":
            processed += String.fromCodePoint.apply(String, status[2]);
            break;
          case "deviation":
            if (processing_option === PROCESSING_OPTIONS.TRANSITIONAL) {
              processed += String.fromCodePoint.apply(String, status[2]);
            } else {
              processed += String.fromCodePoint(codePoint);
            }
            break;
          case "valid":
            processed += String.fromCodePoint(codePoint);
            break;
          case "disallowed_STD3_mapped":
            if (useSTD3) {
              hasError = true;
              processed += String.fromCodePoint(codePoint);
            } else {
              processed += String.fromCodePoint.apply(String, status[2]);
            }
            break;
          case "disallowed_STD3_valid":
            if (useSTD3) {
              hasError = true;
            }
            processed += String.fromCodePoint(codePoint);
            break;
        }
      }
      return {
        string: processed,
        error: hasError
      };
    }
    var combiningMarksRegex = /[\u0300-\u036F\u0483-\u0489\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u065F\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u0711\u0730-\u074A\u07A6-\u07B0\u07EB-\u07F3\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u08E4-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A70\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B62\u0B63\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0C00-\u0C03\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0D01-\u0D03\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D82\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0F18\u0F19\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F\u109A-\u109D\u135D-\u135F\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u180B-\u180D\u18A9\u1920-\u192B\u1930-\u193B\u19B0-\u19C0\u19C8\u19C9\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F\u1AB0-\u1ABE\u1B00-\u1B04\u1B34-\u1B44\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BE6-\u1BF3\u1C24-\u1C37\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF2-\u1CF4\u1CF8\u1CF9\u1DC0-\u1DF5\u1DFC-\u1DFF\u20D0-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA66F-\uA672\uA674-\uA67D\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA880\uA881\uA8B4-\uA8C4\uA8E0-\uA8F1\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9E5\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uFB1E\uFE00-\uFE0F\uFE20-\uFE2D]|\uD800[\uDDFD\uDEE0\uDF76-\uDF7A]|\uD802[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F\uDEE5\uDEE6]|\uD804[\uDC00-\uDC02\uDC38-\uDC46\uDC7F-\uDC82\uDCB0-\uDCBA\uDD00-\uDD02\uDD27-\uDD34\uDD73\uDD80-\uDD82\uDDB3-\uDDC0\uDE2C-\uDE37\uDEDF-\uDEEA\uDF01-\uDF03\uDF3C\uDF3E-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF57\uDF62\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDCB0-\uDCC3\uDDAF-\uDDB5\uDDB8-\uDDC0\uDE30-\uDE40\uDEAB-\uDEB7]|\uD81A[\uDEF0-\uDEF4\uDF30-\uDF36]|\uD81B[\uDF51-\uDF7E\uDF8F-\uDF92]|\uD82F[\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD83A[\uDCD0-\uDCD6]|\uDB40[\uDD00-\uDDEF]/;
    function validateLabel(label, processing_option) {
      if (label.substr(0, 4) === "xn--") {
        label = punycode.toUnicode(label);
        processing_option = PROCESSING_OPTIONS.NONTRANSITIONAL;
      }
      var error = false;
      if (normalize(label) !== label || label[3] === "-" && label[4] === "-" || label[0] === "-" || label[label.length - 1] === "-" || label.indexOf(".") !== -1 || label.search(combiningMarksRegex) === 0) {
        error = true;
      }
      var len = countSymbols(label);
      for (var i2 = 0; i2 < len; ++i2) {
        var status = findStatus(label.codePointAt(i2));
        if (processing === PROCESSING_OPTIONS.TRANSITIONAL && status[1] !== "valid" || processing === PROCESSING_OPTIONS.NONTRANSITIONAL && status[1] !== "valid" && status[1] !== "deviation") {
          error = true;
          break;
        }
      }
      return {
        label,
        error
      };
    }
    function processing(domain_name, useSTD3, processing_option) {
      var result = mapChars(domain_name, useSTD3, processing_option);
      result.string = normalize(result.string);
      var labels = result.string.split(".");
      for (var i2 = 0; i2 < labels.length; ++i2) {
        try {
          var validation = validateLabel(labels[i2]);
          labels[i2] = validation.label;
          result.error = result.error || validation.error;
        } catch (e2) {
          result.error = true;
        }
      }
      return {
        string: labels.join("."),
        error: result.error
      };
    }
    module2.exports.toASCII = function(domain_name, useSTD3, processing_option, verifyDnsLength) {
      var result = processing(domain_name, useSTD3, processing_option);
      var labels = result.string.split(".");
      labels = labels.map(function(l) {
        try {
          return punycode.toASCII(l);
        } catch (e2) {
          result.error = true;
          return l;
        }
      });
      if (verifyDnsLength) {
        var total = labels.slice(0, labels.length - 1).join(".").length;
        if (total.length > 253 || total.length === 0) {
          result.error = true;
        }
        for (var i2 = 0; i2 < labels.length; ++i2) {
          if (labels.length > 63 || labels.length === 0) {
            result.error = true;
            break;
          }
        }
      }
      if (result.error)
        return null;
      return labels.join(".");
    };
    module2.exports.toUnicode = function(domain_name, useSTD3) {
      var result = processing(domain_name, useSTD3, PROCESSING_OPTIONS.NONTRANSITIONAL);
      return {
        domain: result.string,
        error: result.error
      };
    };
    module2.exports.PROCESSING_OPTIONS = PROCESSING_OPTIONS;
  }
});

// node_modules/@octokit/request/node_modules/whatwg-url/lib/url-state-machine.js
var require_url_state_machine = __commonJS({
  "node_modules/@octokit/request/node_modules/whatwg-url/lib/url-state-machine.js"(exports, module2) {
    "use strict";
    var punycode = require("punycode");
    var tr46 = require_tr46();
    var specialSchemes = {
      ftp: 21,
      file: null,
      gopher: 70,
      http: 80,
      https: 443,
      ws: 80,
      wss: 443
    };
    var failure = Symbol("failure");
    function countSymbols(str) {
      return punycode.ucs2.decode(str).length;
    }
    function at(input, idx) {
      const c = input[idx];
      return isNaN(c) ? void 0 : String.fromCodePoint(c);
    }
    function isASCIIDigit(c) {
      return c >= 48 && c <= 57;
    }
    function isASCIIAlpha(c) {
      return c >= 65 && c <= 90 || c >= 97 && c <= 122;
    }
    function isASCIIAlphanumeric(c) {
      return isASCIIAlpha(c) || isASCIIDigit(c);
    }
    function isASCIIHex(c) {
      return isASCIIDigit(c) || c >= 65 && c <= 70 || c >= 97 && c <= 102;
    }
    function isSingleDot(buffer) {
      return buffer === "." || buffer.toLowerCase() === "%2e";
    }
    function isDoubleDot(buffer) {
      buffer = buffer.toLowerCase();
      return buffer === ".." || buffer === "%2e." || buffer === ".%2e" || buffer === "%2e%2e";
    }
    function isWindowsDriveLetterCodePoints(cp1, cp2) {
      return isASCIIAlpha(cp1) && (cp2 === 58 || cp2 === 124);
    }
    function isWindowsDriveLetterString(string) {
      return string.length === 2 && isASCIIAlpha(string.codePointAt(0)) && (string[1] === ":" || string[1] === "|");
    }
    function isNormalizedWindowsDriveLetterString(string) {
      return string.length === 2 && isASCIIAlpha(string.codePointAt(0)) && string[1] === ":";
    }
    function containsForbiddenHostCodePoint(string) {
      return string.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|%|\/|:|\?|@|\[|\\|\]/) !== -1;
    }
    function containsForbiddenHostCodePointExcludingPercent(string) {
      return string.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|\/|:|\?|@|\[|\\|\]/) !== -1;
    }
    function isSpecialScheme(scheme) {
      return specialSchemes[scheme] !== void 0;
    }
    function isSpecial(url) {
      return isSpecialScheme(url.scheme);
    }
    function defaultPort(scheme) {
      return specialSchemes[scheme];
    }
    function percentEncode(c) {
      let hex = c.toString(16).toUpperCase();
      if (hex.length === 1) {
        hex = "0" + hex;
      }
      return "%" + hex;
    }
    function utf8PercentEncode(c) {
      const buf = new Buffer(c);
      let str = "";
      for (let i2 = 0; i2 < buf.length; ++i2) {
        str += percentEncode(buf[i2]);
      }
      return str;
    }
    function utf8PercentDecode(str) {
      const input = new Buffer(str);
      const output = [];
      for (let i2 = 0; i2 < input.length; ++i2) {
        if (input[i2] !== 37) {
          output.push(input[i2]);
        } else if (input[i2] === 37 && isASCIIHex(input[i2 + 1]) && isASCIIHex(input[i2 + 2])) {
          output.push(parseInt(input.slice(i2 + 1, i2 + 3).toString(), 16));
          i2 += 2;
        } else {
          output.push(input[i2]);
        }
      }
      return new Buffer(output).toString();
    }
    function isC0ControlPercentEncode(c) {
      return c <= 31 || c > 126;
    }
    var extraPathPercentEncodeSet = /* @__PURE__ */ new Set([32, 34, 35, 60, 62, 63, 96, 123, 125]);
    function isPathPercentEncode(c) {
      return isC0ControlPercentEncode(c) || extraPathPercentEncodeSet.has(c);
    }
    var extraUserinfoPercentEncodeSet = /* @__PURE__ */ new Set([47, 58, 59, 61, 64, 91, 92, 93, 94, 124]);
    function isUserinfoPercentEncode(c) {
      return isPathPercentEncode(c) || extraUserinfoPercentEncodeSet.has(c);
    }
    function percentEncodeChar(c, encodeSetPredicate) {
      const cStr = String.fromCodePoint(c);
      if (encodeSetPredicate(c)) {
        return utf8PercentEncode(cStr);
      }
      return cStr;
    }
    function parseIPv4Number(input) {
      let R = 10;
      if (input.length >= 2 && input.charAt(0) === "0" && input.charAt(1).toLowerCase() === "x") {
        input = input.substring(2);
        R = 16;
      } else if (input.length >= 2 && input.charAt(0) === "0") {
        input = input.substring(1);
        R = 8;
      }
      if (input === "") {
        return 0;
      }
      const regex = R === 10 ? /[^0-9]/ : R === 16 ? /[^0-9A-Fa-f]/ : /[^0-7]/;
      if (regex.test(input)) {
        return failure;
      }
      return parseInt(input, R);
    }
    function parseIPv4(input) {
      const parts = input.split(".");
      if (parts[parts.length - 1] === "") {
        if (parts.length > 1) {
          parts.pop();
        }
      }
      if (parts.length > 4) {
        return input;
      }
      const numbers = [];
      for (const part of parts) {
        if (part === "") {
          return input;
        }
        const n = parseIPv4Number(part);
        if (n === failure) {
          return input;
        }
        numbers.push(n);
      }
      for (let i2 = 0; i2 < numbers.length - 1; ++i2) {
        if (numbers[i2] > 255) {
          return failure;
        }
      }
      if (numbers[numbers.length - 1] >= Math.pow(256, 5 - numbers.length)) {
        return failure;
      }
      let ipv4 = numbers.pop();
      let counter = 0;
      for (const n of numbers) {
        ipv4 += n * Math.pow(256, 3 - counter);
        ++counter;
      }
      return ipv4;
    }
    function serializeIPv4(address) {
      let output = "";
      let n = address;
      for (let i2 = 1; i2 <= 4; ++i2) {
        output = String(n % 256) + output;
        if (i2 !== 4) {
          output = "." + output;
        }
        n = Math.floor(n / 256);
      }
      return output;
    }
    function parseIPv6(input) {
      const address = [0, 0, 0, 0, 0, 0, 0, 0];
      let pieceIndex = 0;
      let compress = null;
      let pointer = 0;
      input = punycode.ucs2.decode(input);
      if (input[pointer] === 58) {
        if (input[pointer + 1] !== 58) {
          return failure;
        }
        pointer += 2;
        ++pieceIndex;
        compress = pieceIndex;
      }
      while (pointer < input.length) {
        if (pieceIndex === 8) {
          return failure;
        }
        if (input[pointer] === 58) {
          if (compress !== null) {
            return failure;
          }
          ++pointer;
          ++pieceIndex;
          compress = pieceIndex;
          continue;
        }
        let value = 0;
        let length = 0;
        while (length < 4 && isASCIIHex(input[pointer])) {
          value = value * 16 + parseInt(at(input, pointer), 16);
          ++pointer;
          ++length;
        }
        if (input[pointer] === 46) {
          if (length === 0) {
            return failure;
          }
          pointer -= length;
          if (pieceIndex > 6) {
            return failure;
          }
          let numbersSeen = 0;
          while (input[pointer] !== void 0) {
            let ipv4Piece = null;
            if (numbersSeen > 0) {
              if (input[pointer] === 46 && numbersSeen < 4) {
                ++pointer;
              } else {
                return failure;
              }
            }
            if (!isASCIIDigit(input[pointer])) {
              return failure;
            }
            while (isASCIIDigit(input[pointer])) {
              const number = parseInt(at(input, pointer));
              if (ipv4Piece === null) {
                ipv4Piece = number;
              } else if (ipv4Piece === 0) {
                return failure;
              } else {
                ipv4Piece = ipv4Piece * 10 + number;
              }
              if (ipv4Piece > 255) {
                return failure;
              }
              ++pointer;
            }
            address[pieceIndex] = address[pieceIndex] * 256 + ipv4Piece;
            ++numbersSeen;
            if (numbersSeen === 2 || numbersSeen === 4) {
              ++pieceIndex;
            }
          }
          if (numbersSeen !== 4) {
            return failure;
          }
          break;
        } else if (input[pointer] === 58) {
          ++pointer;
          if (input[pointer] === void 0) {
            return failure;
          }
        } else if (input[pointer] !== void 0) {
          return failure;
        }
        address[pieceIndex] = value;
        ++pieceIndex;
      }
      if (compress !== null) {
        let swaps = pieceIndex - compress;
        pieceIndex = 7;
        while (pieceIndex !== 0 && swaps > 0) {
          const temp = address[compress + swaps - 1];
          address[compress + swaps - 1] = address[pieceIndex];
          address[pieceIndex] = temp;
          --pieceIndex;
          --swaps;
        }
      } else if (compress === null && pieceIndex !== 8) {
        return failure;
      }
      return address;
    }
    function serializeIPv6(address) {
      let output = "";
      const seqResult = findLongestZeroSequence(address);
      const compress = seqResult.idx;
      let ignore0 = false;
      for (let pieceIndex = 0; pieceIndex <= 7; ++pieceIndex) {
        if (ignore0 && address[pieceIndex] === 0) {
          continue;
        } else if (ignore0) {
          ignore0 = false;
        }
        if (compress === pieceIndex) {
          const separator = pieceIndex === 0 ? "::" : ":";
          output += separator;
          ignore0 = true;
          continue;
        }
        output += address[pieceIndex].toString(16);
        if (pieceIndex !== 7) {
          output += ":";
        }
      }
      return output;
    }
    function parseHost(input, isSpecialArg) {
      if (input[0] === "[") {
        if (input[input.length - 1] !== "]") {
          return failure;
        }
        return parseIPv6(input.substring(1, input.length - 1));
      }
      if (!isSpecialArg) {
        return parseOpaqueHost(input);
      }
      const domain = utf8PercentDecode(input);
      const asciiDomain = tr46.toASCII(domain, false, tr46.PROCESSING_OPTIONS.NONTRANSITIONAL, false);
      if (asciiDomain === null) {
        return failure;
      }
      if (containsForbiddenHostCodePoint(asciiDomain)) {
        return failure;
      }
      const ipv4Host = parseIPv4(asciiDomain);
      if (typeof ipv4Host === "number" || ipv4Host === failure) {
        return ipv4Host;
      }
      return asciiDomain;
    }
    function parseOpaqueHost(input) {
      if (containsForbiddenHostCodePointExcludingPercent(input)) {
        return failure;
      }
      let output = "";
      const decoded = punycode.ucs2.decode(input);
      for (let i2 = 0; i2 < decoded.length; ++i2) {
        output += percentEncodeChar(decoded[i2], isC0ControlPercentEncode);
      }
      return output;
    }
    function findLongestZeroSequence(arr) {
      let maxIdx = null;
      let maxLen = 1;
      let currStart = null;
      let currLen = 0;
      for (let i2 = 0; i2 < arr.length; ++i2) {
        if (arr[i2] !== 0) {
          if (currLen > maxLen) {
            maxIdx = currStart;
            maxLen = currLen;
          }
          currStart = null;
          currLen = 0;
        } else {
          if (currStart === null) {
            currStart = i2;
          }
          ++currLen;
        }
      }
      if (currLen > maxLen) {
        maxIdx = currStart;
        maxLen = currLen;
      }
      return {
        idx: maxIdx,
        len: maxLen
      };
    }
    function serializeHost(host) {
      if (typeof host === "number") {
        return serializeIPv4(host);
      }
      if (host instanceof Array) {
        return "[" + serializeIPv6(host) + "]";
      }
      return host;
    }
    function trimControlChars(url) {
      return url.replace(/^[\u0000-\u001F\u0020]+|[\u0000-\u001F\u0020]+$/g, "");
    }
    function trimTabAndNewline(url) {
      return url.replace(/\u0009|\u000A|\u000D/g, "");
    }
    function shortenPath(url) {
      const path4 = url.path;
      if (path4.length === 0) {
        return;
      }
      if (url.scheme === "file" && path4.length === 1 && isNormalizedWindowsDriveLetter(path4[0])) {
        return;
      }
      path4.pop();
    }
    function includesCredentials(url) {
      return url.username !== "" || url.password !== "";
    }
    function cannotHaveAUsernamePasswordPort(url) {
      return url.host === null || url.host === "" || url.cannotBeABaseURL || url.scheme === "file";
    }
    function isNormalizedWindowsDriveLetter(string) {
      return /^[A-Za-z]:$/.test(string);
    }
    function URLStateMachine(input, base, encodingOverride, url, stateOverride) {
      this.pointer = 0;
      this.input = input;
      this.base = base || null;
      this.encodingOverride = encodingOverride || "utf-8";
      this.stateOverride = stateOverride;
      this.url = url;
      this.failure = false;
      this.parseError = false;
      if (!this.url) {
        this.url = {
          scheme: "",
          username: "",
          password: "",
          host: null,
          port: null,
          path: [],
          query: null,
          fragment: null,
          cannotBeABaseURL: false
        };
        const res2 = trimControlChars(this.input);
        if (res2 !== this.input) {
          this.parseError = true;
        }
        this.input = res2;
      }
      const res = trimTabAndNewline(this.input);
      if (res !== this.input) {
        this.parseError = true;
      }
      this.input = res;
      this.state = stateOverride || "scheme start";
      this.buffer = "";
      this.atFlag = false;
      this.arrFlag = false;
      this.passwordTokenSeenFlag = false;
      this.input = punycode.ucs2.decode(this.input);
      for (; this.pointer <= this.input.length; ++this.pointer) {
        const c = this.input[this.pointer];
        const cStr = isNaN(c) ? void 0 : String.fromCodePoint(c);
        const ret = this["parse " + this.state](c, cStr);
        if (!ret) {
          break;
        } else if (ret === failure) {
          this.failure = true;
          break;
        }
      }
    }
    URLStateMachine.prototype["parse scheme start"] = function parseSchemeStart(c, cStr) {
      if (isASCIIAlpha(c)) {
        this.buffer += cStr.toLowerCase();
        this.state = "scheme";
      } else if (!this.stateOverride) {
        this.state = "no scheme";
        --this.pointer;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    URLStateMachine.prototype["parse scheme"] = function parseScheme(c, cStr) {
      if (isASCIIAlphanumeric(c) || c === 43 || c === 45 || c === 46) {
        this.buffer += cStr.toLowerCase();
      } else if (c === 58) {
        if (this.stateOverride) {
          if (isSpecial(this.url) && !isSpecialScheme(this.buffer)) {
            return false;
          }
          if (!isSpecial(this.url) && isSpecialScheme(this.buffer)) {
            return false;
          }
          if ((includesCredentials(this.url) || this.url.port !== null) && this.buffer === "file") {
            return false;
          }
          if (this.url.scheme === "file" && (this.url.host === "" || this.url.host === null)) {
            return false;
          }
        }
        this.url.scheme = this.buffer;
        this.buffer = "";
        if (this.stateOverride) {
          return false;
        }
        if (this.url.scheme === "file") {
          if (this.input[this.pointer + 1] !== 47 || this.input[this.pointer + 2] !== 47) {
            this.parseError = true;
          }
          this.state = "file";
        } else if (isSpecial(this.url) && this.base !== null && this.base.scheme === this.url.scheme) {
          this.state = "special relative or authority";
        } else if (isSpecial(this.url)) {
          this.state = "special authority slashes";
        } else if (this.input[this.pointer + 1] === 47) {
          this.state = "path or authority";
          ++this.pointer;
        } else {
          this.url.cannotBeABaseURL = true;
          this.url.path.push("");
          this.state = "cannot-be-a-base-URL path";
        }
      } else if (!this.stateOverride) {
        this.buffer = "";
        this.state = "no scheme";
        this.pointer = -1;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    URLStateMachine.prototype["parse no scheme"] = function parseNoScheme(c) {
      if (this.base === null || this.base.cannotBeABaseURL && c !== 35) {
        return failure;
      } else if (this.base.cannotBeABaseURL && c === 35) {
        this.url.scheme = this.base.scheme;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
        this.url.fragment = "";
        this.url.cannotBeABaseURL = true;
        this.state = "fragment";
      } else if (this.base.scheme === "file") {
        this.state = "file";
        --this.pointer;
      } else {
        this.state = "relative";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special relative or authority"] = function parseSpecialRelativeOrAuthority(c) {
      if (c === 47 && this.input[this.pointer + 1] === 47) {
        this.state = "special authority ignore slashes";
        ++this.pointer;
      } else {
        this.parseError = true;
        this.state = "relative";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse path or authority"] = function parsePathOrAuthority(c) {
      if (c === 47) {
        this.state = "authority";
      } else {
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse relative"] = function parseRelative(c) {
      this.url.scheme = this.base.scheme;
      if (isNaN(c)) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
      } else if (c === 47) {
        this.state = "relative slash";
      } else if (c === 63) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = "";
        this.state = "query";
      } else if (c === 35) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
        this.url.fragment = "";
        this.state = "fragment";
      } else if (isSpecial(this.url) && c === 92) {
        this.parseError = true;
        this.state = "relative slash";
      } else {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice(0, this.base.path.length - 1);
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse relative slash"] = function parseRelativeSlash(c) {
      if (isSpecial(this.url) && (c === 47 || c === 92)) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "special authority ignore slashes";
      } else if (c === 47) {
        this.state = "authority";
      } else {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special authority slashes"] = function parseSpecialAuthoritySlashes(c) {
      if (c === 47 && this.input[this.pointer + 1] === 47) {
        this.state = "special authority ignore slashes";
        ++this.pointer;
      } else {
        this.parseError = true;
        this.state = "special authority ignore slashes";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special authority ignore slashes"] = function parseSpecialAuthorityIgnoreSlashes(c) {
      if (c !== 47 && c !== 92) {
        this.state = "authority";
        --this.pointer;
      } else {
        this.parseError = true;
      }
      return true;
    };
    URLStateMachine.prototype["parse authority"] = function parseAuthority(c, cStr) {
      if (c === 64) {
        this.parseError = true;
        if (this.atFlag) {
          this.buffer = "%40" + this.buffer;
        }
        this.atFlag = true;
        const len = countSymbols(this.buffer);
        for (let pointer = 0; pointer < len; ++pointer) {
          const codePoint = this.buffer.codePointAt(pointer);
          if (codePoint === 58 && !this.passwordTokenSeenFlag) {
            this.passwordTokenSeenFlag = true;
            continue;
          }
          const encodedCodePoints = percentEncodeChar(codePoint, isUserinfoPercentEncode);
          if (this.passwordTokenSeenFlag) {
            this.url.password += encodedCodePoints;
          } else {
            this.url.username += encodedCodePoints;
          }
        }
        this.buffer = "";
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92) {
        if (this.atFlag && this.buffer === "") {
          this.parseError = true;
          return failure;
        }
        this.pointer -= countSymbols(this.buffer) + 1;
        this.buffer = "";
        this.state = "host";
      } else {
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse hostname"] = URLStateMachine.prototype["parse host"] = function parseHostName(c, cStr) {
      if (this.stateOverride && this.url.scheme === "file") {
        --this.pointer;
        this.state = "file host";
      } else if (c === 58 && !this.arrFlag) {
        if (this.buffer === "") {
          this.parseError = true;
          return failure;
        }
        const host = parseHost(this.buffer, isSpecial(this.url));
        if (host === failure) {
          return failure;
        }
        this.url.host = host;
        this.buffer = "";
        this.state = "port";
        if (this.stateOverride === "hostname") {
          return false;
        }
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92) {
        --this.pointer;
        if (isSpecial(this.url) && this.buffer === "") {
          this.parseError = true;
          return failure;
        } else if (this.stateOverride && this.buffer === "" && (includesCredentials(this.url) || this.url.port !== null)) {
          this.parseError = true;
          return false;
        }
        const host = parseHost(this.buffer, isSpecial(this.url));
        if (host === failure) {
          return failure;
        }
        this.url.host = host;
        this.buffer = "";
        this.state = "path start";
        if (this.stateOverride) {
          return false;
        }
      } else {
        if (c === 91) {
          this.arrFlag = true;
        } else if (c === 93) {
          this.arrFlag = false;
        }
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse port"] = function parsePort(c, cStr) {
      if (isASCIIDigit(c)) {
        this.buffer += cStr;
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92 || this.stateOverride) {
        if (this.buffer !== "") {
          const port = parseInt(this.buffer);
          if (port > Math.pow(2, 16) - 1) {
            this.parseError = true;
            return failure;
          }
          this.url.port = port === defaultPort(this.url.scheme) ? null : port;
          this.buffer = "";
        }
        if (this.stateOverride) {
          return false;
        }
        this.state = "path start";
        --this.pointer;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    var fileOtherwiseCodePoints = /* @__PURE__ */ new Set([47, 92, 63, 35]);
    URLStateMachine.prototype["parse file"] = function parseFile(c) {
      this.url.scheme = "file";
      if (c === 47 || c === 92) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "file slash";
      } else if (this.base !== null && this.base.scheme === "file") {
        if (isNaN(c)) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = this.base.query;
        } else if (c === 63) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = "";
          this.state = "query";
        } else if (c === 35) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = this.base.query;
          this.url.fragment = "";
          this.state = "fragment";
        } else {
          if (this.input.length - this.pointer - 1 === 0 || !isWindowsDriveLetterCodePoints(c, this.input[this.pointer + 1]) || this.input.length - this.pointer - 1 >= 2 && !fileOtherwiseCodePoints.has(this.input[this.pointer + 2])) {
            this.url.host = this.base.host;
            this.url.path = this.base.path.slice();
            shortenPath(this.url);
          } else {
            this.parseError = true;
          }
          this.state = "path";
          --this.pointer;
        }
      } else {
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse file slash"] = function parseFileSlash(c) {
      if (c === 47 || c === 92) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "file host";
      } else {
        if (this.base !== null && this.base.scheme === "file") {
          if (isNormalizedWindowsDriveLetterString(this.base.path[0])) {
            this.url.path.push(this.base.path[0]);
          } else {
            this.url.host = this.base.host;
          }
        }
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse file host"] = function parseFileHost(c, cStr) {
      if (isNaN(c) || c === 47 || c === 92 || c === 63 || c === 35) {
        --this.pointer;
        if (!this.stateOverride && isWindowsDriveLetterString(this.buffer)) {
          this.parseError = true;
          this.state = "path";
        } else if (this.buffer === "") {
          this.url.host = "";
          if (this.stateOverride) {
            return false;
          }
          this.state = "path start";
        } else {
          let host = parseHost(this.buffer, isSpecial(this.url));
          if (host === failure) {
            return failure;
          }
          if (host === "localhost") {
            host = "";
          }
          this.url.host = host;
          if (this.stateOverride) {
            return false;
          }
          this.buffer = "";
          this.state = "path start";
        }
      } else {
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse path start"] = function parsePathStart(c) {
      if (isSpecial(this.url)) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "path";
        if (c !== 47 && c !== 92) {
          --this.pointer;
        }
      } else if (!this.stateOverride && c === 63) {
        this.url.query = "";
        this.state = "query";
      } else if (!this.stateOverride && c === 35) {
        this.url.fragment = "";
        this.state = "fragment";
      } else if (c !== void 0) {
        this.state = "path";
        if (c !== 47) {
          --this.pointer;
        }
      }
      return true;
    };
    URLStateMachine.prototype["parse path"] = function parsePath(c) {
      if (isNaN(c) || c === 47 || isSpecial(this.url) && c === 92 || !this.stateOverride && (c === 63 || c === 35)) {
        if (isSpecial(this.url) && c === 92) {
          this.parseError = true;
        }
        if (isDoubleDot(this.buffer)) {
          shortenPath(this.url);
          if (c !== 47 && !(isSpecial(this.url) && c === 92)) {
            this.url.path.push("");
          }
        } else if (isSingleDot(this.buffer) && c !== 47 && !(isSpecial(this.url) && c === 92)) {
          this.url.path.push("");
        } else if (!isSingleDot(this.buffer)) {
          if (this.url.scheme === "file" && this.url.path.length === 0 && isWindowsDriveLetterString(this.buffer)) {
            if (this.url.host !== "" && this.url.host !== null) {
              this.parseError = true;
              this.url.host = "";
            }
            this.buffer = this.buffer[0] + ":";
          }
          this.url.path.push(this.buffer);
        }
        this.buffer = "";
        if (this.url.scheme === "file" && (c === void 0 || c === 63 || c === 35)) {
          while (this.url.path.length > 1 && this.url.path[0] === "") {
            this.parseError = true;
            this.url.path.shift();
          }
        }
        if (c === 63) {
          this.url.query = "";
          this.state = "query";
        }
        if (c === 35) {
          this.url.fragment = "";
          this.state = "fragment";
        }
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.buffer += percentEncodeChar(c, isPathPercentEncode);
      }
      return true;
    };
    URLStateMachine.prototype["parse cannot-be-a-base-URL path"] = function parseCannotBeABaseURLPath(c) {
      if (c === 63) {
        this.url.query = "";
        this.state = "query";
      } else if (c === 35) {
        this.url.fragment = "";
        this.state = "fragment";
      } else {
        if (!isNaN(c) && c !== 37) {
          this.parseError = true;
        }
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        if (!isNaN(c)) {
          this.url.path[0] = this.url.path[0] + percentEncodeChar(c, isC0ControlPercentEncode);
        }
      }
      return true;
    };
    URLStateMachine.prototype["parse query"] = function parseQuery(c, cStr) {
      if (isNaN(c) || !this.stateOverride && c === 35) {
        if (!isSpecial(this.url) || this.url.scheme === "ws" || this.url.scheme === "wss") {
          this.encodingOverride = "utf-8";
        }
        const buffer = new Buffer(this.buffer);
        for (let i2 = 0; i2 < buffer.length; ++i2) {
          if (buffer[i2] < 33 || buffer[i2] > 126 || buffer[i2] === 34 || buffer[i2] === 35 || buffer[i2] === 60 || buffer[i2] === 62) {
            this.url.query += percentEncode(buffer[i2]);
          } else {
            this.url.query += String.fromCodePoint(buffer[i2]);
          }
        }
        this.buffer = "";
        if (c === 35) {
          this.url.fragment = "";
          this.state = "fragment";
        }
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse fragment"] = function parseFragment(c) {
      if (isNaN(c)) {
      } else if (c === 0) {
        this.parseError = true;
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.url.fragment += percentEncodeChar(c, isC0ControlPercentEncode);
      }
      return true;
    };
    function serializeURL(url, excludeFragment) {
      let output = url.scheme + ":";
      if (url.host !== null) {
        output += "//";
        if (url.username !== "" || url.password !== "") {
          output += url.username;
          if (url.password !== "") {
            output += ":" + url.password;
          }
          output += "@";
        }
        output += serializeHost(url.host);
        if (url.port !== null) {
          output += ":" + url.port;
        }
      } else if (url.host === null && url.scheme === "file") {
        output += "//";
      }
      if (url.cannotBeABaseURL) {
        output += url.path[0];
      } else {
        for (const string of url.path) {
          output += "/" + string;
        }
      }
      if (url.query !== null) {
        output += "?" + url.query;
      }
      if (!excludeFragment && url.fragment !== null) {
        output += "#" + url.fragment;
      }
      return output;
    }
    function serializeOrigin(tuple) {
      let result = tuple.scheme + "://";
      result += serializeHost(tuple.host);
      if (tuple.port !== null) {
        result += ":" + tuple.port;
      }
      return result;
    }
    module2.exports.serializeURL = serializeURL;
    module2.exports.serializeURLOrigin = function(url) {
      switch (url.scheme) {
        case "blob":
          try {
            return module2.exports.serializeURLOrigin(module2.exports.parseURL(url.path[0]));
          } catch (e2) {
            return "null";
          }
        case "ftp":
        case "gopher":
        case "http":
        case "https":
        case "ws":
        case "wss":
          return serializeOrigin({
            scheme: url.scheme,
            host: url.host,
            port: url.port
          });
        case "file":
          return "file://";
        default:
          return "null";
      }
    };
    module2.exports.basicURLParse = function(input, options) {
      if (options === void 0) {
        options = {};
      }
      const usm = new URLStateMachine(input, options.baseURL, options.encodingOverride, options.url, options.stateOverride);
      if (usm.failure) {
        return "failure";
      }
      return usm.url;
    };
    module2.exports.setTheUsername = function(url, username) {
      url.username = "";
      const decoded = punycode.ucs2.decode(username);
      for (let i2 = 0; i2 < decoded.length; ++i2) {
        url.username += percentEncodeChar(decoded[i2], isUserinfoPercentEncode);
      }
    };
    module2.exports.setThePassword = function(url, password) {
      url.password = "";
      const decoded = punycode.ucs2.decode(password);
      for (let i2 = 0; i2 < decoded.length; ++i2) {
        url.password += percentEncodeChar(decoded[i2], isUserinfoPercentEncode);
      }
    };
    module2.exports.serializeHost = serializeHost;
    module2.exports.cannotHaveAUsernamePasswordPort = cannotHaveAUsernamePasswordPort;
    module2.exports.serializeInteger = function(integer) {
      return String(integer);
    };
    module2.exports.parseURL = function(input, options) {
      if (options === void 0) {
        options = {};
      }
      return module2.exports.basicURLParse(input, { baseURL: options.baseURL, encodingOverride: options.encodingOverride });
    };
  }
});

// node_modules/@octokit/request/node_modules/whatwg-url/lib/URL-impl.js
var require_URL_impl = __commonJS({
  "node_modules/@octokit/request/node_modules/whatwg-url/lib/URL-impl.js"(exports) {
    "use strict";
    var usm = require_url_state_machine();
    exports.implementation = class URLImpl {
      constructor(constructorArgs) {
        const url = constructorArgs[0];
        const base = constructorArgs[1];
        let parsedBase = null;
        if (base !== void 0) {
          parsedBase = usm.basicURLParse(base);
          if (parsedBase === "failure") {
            throw new TypeError("Invalid base URL");
          }
        }
        const parsedURL = usm.basicURLParse(url, { baseURL: parsedBase });
        if (parsedURL === "failure") {
          throw new TypeError("Invalid URL");
        }
        this._url = parsedURL;
      }
      get href() {
        return usm.serializeURL(this._url);
      }
      set href(v) {
        const parsedURL = usm.basicURLParse(v);
        if (parsedURL === "failure") {
          throw new TypeError("Invalid URL");
        }
        this._url = parsedURL;
      }
      get origin() {
        return usm.serializeURLOrigin(this._url);
      }
      get protocol() {
        return this._url.scheme + ":";
      }
      set protocol(v) {
        usm.basicURLParse(v + ":", { url: this._url, stateOverride: "scheme start" });
      }
      get username() {
        return this._url.username;
      }
      set username(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        usm.setTheUsername(this._url, v);
      }
      get password() {
        return this._url.password;
      }
      set password(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        usm.setThePassword(this._url, v);
      }
      get host() {
        const url = this._url;
        if (url.host === null) {
          return "";
        }
        if (url.port === null) {
          return usm.serializeHost(url.host);
        }
        return usm.serializeHost(url.host) + ":" + usm.serializeInteger(url.port);
      }
      set host(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        usm.basicURLParse(v, { url: this._url, stateOverride: "host" });
      }
      get hostname() {
        if (this._url.host === null) {
          return "";
        }
        return usm.serializeHost(this._url.host);
      }
      set hostname(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        usm.basicURLParse(v, { url: this._url, stateOverride: "hostname" });
      }
      get port() {
        if (this._url.port === null) {
          return "";
        }
        return usm.serializeInteger(this._url.port);
      }
      set port(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        if (v === "") {
          this._url.port = null;
        } else {
          usm.basicURLParse(v, { url: this._url, stateOverride: "port" });
        }
      }
      get pathname() {
        if (this._url.cannotBeABaseURL) {
          return this._url.path[0];
        }
        if (this._url.path.length === 0) {
          return "";
        }
        return "/" + this._url.path.join("/");
      }
      set pathname(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        this._url.path = [];
        usm.basicURLParse(v, { url: this._url, stateOverride: "path start" });
      }
      get search() {
        if (this._url.query === null || this._url.query === "") {
          return "";
        }
        return "?" + this._url.query;
      }
      set search(v) {
        const url = this._url;
        if (v === "") {
          url.query = null;
          return;
        }
        const input = v[0] === "?" ? v.substring(1) : v;
        url.query = "";
        usm.basicURLParse(input, { url, stateOverride: "query" });
      }
      get hash() {
        if (this._url.fragment === null || this._url.fragment === "") {
          return "";
        }
        return "#" + this._url.fragment;
      }
      set hash(v) {
        if (v === "") {
          this._url.fragment = null;
          return;
        }
        const input = v[0] === "#" ? v.substring(1) : v;
        this._url.fragment = "";
        usm.basicURLParse(input, { url: this._url, stateOverride: "fragment" });
      }
      toJSON() {
        return this.href;
      }
    };
  }
});

// node_modules/@octokit/request/node_modules/whatwg-url/lib/URL.js
var require_URL = __commonJS({
  "node_modules/@octokit/request/node_modules/whatwg-url/lib/URL.js"(exports, module2) {
    "use strict";
    var conversions = require_lib2();
    var utils = require_utils3();
    var Impl = require_URL_impl();
    var impl = utils.implSymbol;
    function URL3(url) {
      if (!this || this[impl] || !(this instanceof URL3)) {
        throw new TypeError("Failed to construct 'URL': Please use the 'new' operator, this DOM object constructor cannot be called as a function.");
      }
      if (arguments.length < 1) {
        throw new TypeError("Failed to construct 'URL': 1 argument required, but only " + arguments.length + " present.");
      }
      const args = [];
      for (let i2 = 0; i2 < arguments.length && i2 < 2; ++i2) {
        args[i2] = arguments[i2];
      }
      args[0] = conversions["USVString"](args[0]);
      if (args[1] !== void 0) {
        args[1] = conversions["USVString"](args[1]);
      }
      module2.exports.setup(this, args);
    }
    URL3.prototype.toJSON = function toJSON() {
      if (!this || !module2.exports.is(this)) {
        throw new TypeError("Illegal invocation");
      }
      const args = [];
      for (let i2 = 0; i2 < arguments.length && i2 < 0; ++i2) {
        args[i2] = arguments[i2];
      }
      return this[impl].toJSON.apply(this[impl], args);
    };
    Object.defineProperty(URL3.prototype, "href", {
      get() {
        return this[impl].href;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].href = V;
      },
      enumerable: true,
      configurable: true
    });
    URL3.prototype.toString = function() {
      if (!this || !module2.exports.is(this)) {
        throw new TypeError("Illegal invocation");
      }
      return this.href;
    };
    Object.defineProperty(URL3.prototype, "origin", {
      get() {
        return this[impl].origin;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "protocol", {
      get() {
        return this[impl].protocol;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].protocol = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "username", {
      get() {
        return this[impl].username;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].username = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "password", {
      get() {
        return this[impl].password;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].password = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "host", {
      get() {
        return this[impl].host;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].host = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "hostname", {
      get() {
        return this[impl].hostname;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].hostname = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "port", {
      get() {
        return this[impl].port;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].port = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "pathname", {
      get() {
        return this[impl].pathname;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].pathname = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "search", {
      get() {
        return this[impl].search;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].search = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "hash", {
      get() {
        return this[impl].hash;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].hash = V;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = {
      is(obj) {
        return !!obj && obj[impl] instanceof Impl.implementation;
      },
      create(constructorArgs, privateData) {
        let obj = Object.create(URL3.prototype);
        this.setup(obj, constructorArgs, privateData);
        return obj;
      },
      setup(obj, constructorArgs, privateData) {
        if (!privateData)
          privateData = {};
        privateData.wrapper = obj;
        obj[impl] = new Impl.implementation(constructorArgs, privateData);
        obj[impl][utils.wrapperSymbol] = obj;
      },
      interface: URL3,
      expose: {
        Window: { URL: URL3 },
        Worker: { URL: URL3 }
      }
    };
  }
});

// node_modules/@octokit/request/node_modules/whatwg-url/lib/public-api.js
var require_public_api = __commonJS({
  "node_modules/@octokit/request/node_modules/whatwg-url/lib/public-api.js"(exports) {
    "use strict";
    exports.URL = require_URL().interface;
    exports.serializeURL = require_url_state_machine().serializeURL;
    exports.serializeURLOrigin = require_url_state_machine().serializeURLOrigin;
    exports.basicURLParse = require_url_state_machine().basicURLParse;
    exports.setTheUsername = require_url_state_machine().setTheUsername;
    exports.setThePassword = require_url_state_machine().setThePassword;
    exports.serializeHost = require_url_state_machine().serializeHost;
    exports.serializeInteger = require_url_state_machine().serializeInteger;
    exports.parseURL = require_url_state_machine().parseURL;
  }
});

// node_modules/@octokit/request/node_modules/node-fetch/lib/index.mjs
function FetchError(message, type, systemError) {
  Error.call(this, message);
  this.message = message;
  this.type = type;
  if (systemError) {
    this.code = this.errno = systemError.code;
  }
  Error.captureStackTrace(this, this.constructor);
}
function Body(body) {
  var _this = this;
  var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ref$size = _ref.size;
  let size = _ref$size === void 0 ? 0 : _ref$size;
  var _ref$timeout = _ref.timeout;
  let timeout = _ref$timeout === void 0 ? 0 : _ref$timeout;
  if (body == null) {
    body = null;
  } else if (isURLSearchParams(body)) {
    body = Buffer.from(body.toString());
  } else if (isBlob(body))
    ;
  else if (Buffer.isBuffer(body))
    ;
  else if (Object.prototype.toString.call(body) === "[object ArrayBuffer]") {
    body = Buffer.from(body);
  } else if (ArrayBuffer.isView(body)) {
    body = Buffer.from(body.buffer, body.byteOffset, body.byteLength);
  } else if (body instanceof import_stream.default)
    ;
  else {
    body = Buffer.from(String(body));
  }
  this[INTERNALS] = {
    body,
    disturbed: false,
    error: null
  };
  this.size = size;
  this.timeout = timeout;
  if (body instanceof import_stream.default) {
    body.on("error", function(err) {
      const error = err.name === "AbortError" ? err : new FetchError(`Invalid response body while trying to fetch ${_this.url}: ${err.message}`, "system", err);
      _this[INTERNALS].error = error;
    });
  }
}
function consumeBody() {
  var _this4 = this;
  if (this[INTERNALS].disturbed) {
    return Body.Promise.reject(new TypeError(`body used already for: ${this.url}`));
  }
  this[INTERNALS].disturbed = true;
  if (this[INTERNALS].error) {
    return Body.Promise.reject(this[INTERNALS].error);
  }
  let body = this.body;
  if (body === null) {
    return Body.Promise.resolve(Buffer.alloc(0));
  }
  if (isBlob(body)) {
    body = body.stream();
  }
  if (Buffer.isBuffer(body)) {
    return Body.Promise.resolve(body);
  }
  if (!(body instanceof import_stream.default)) {
    return Body.Promise.resolve(Buffer.alloc(0));
  }
  let accum = [];
  let accumBytes = 0;
  let abort = false;
  return new Body.Promise(function(resolve, reject) {
    let resTimeout;
    if (_this4.timeout) {
      resTimeout = setTimeout(function() {
        abort = true;
        reject(new FetchError(`Response timeout while trying to fetch ${_this4.url} (over ${_this4.timeout}ms)`, "body-timeout"));
      }, _this4.timeout);
    }
    body.on("error", function(err) {
      if (err.name === "AbortError") {
        abort = true;
        reject(err);
      } else {
        reject(new FetchError(`Invalid response body while trying to fetch ${_this4.url}: ${err.message}`, "system", err));
      }
    });
    body.on("data", function(chunk) {
      if (abort || chunk === null) {
        return;
      }
      if (_this4.size && accumBytes + chunk.length > _this4.size) {
        abort = true;
        reject(new FetchError(`content size at ${_this4.url} over limit: ${_this4.size}`, "max-size"));
        return;
      }
      accumBytes += chunk.length;
      accum.push(chunk);
    });
    body.on("end", function() {
      if (abort) {
        return;
      }
      clearTimeout(resTimeout);
      try {
        resolve(Buffer.concat(accum, accumBytes));
      } catch (err) {
        reject(new FetchError(`Could not create Buffer from response body for ${_this4.url}: ${err.message}`, "system", err));
      }
    });
  });
}
function convertBody(buffer, headers) {
  if (typeof convert !== "function") {
    throw new Error("The package `encoding` must be installed to use the textConverted() function");
  }
  const ct = headers.get("content-type");
  let charset = "utf-8";
  let res, str;
  if (ct) {
    res = /charset=([^;]*)/i.exec(ct);
  }
  str = buffer.slice(0, 1024).toString();
  if (!res && str) {
    res = /<meta.+?charset=(['"])(.+?)\1/i.exec(str);
  }
  if (!res && str) {
    res = /<meta[\s]+?http-equiv=(['"])content-type\1[\s]+?content=(['"])(.+?)\2/i.exec(str);
    if (!res) {
      res = /<meta[\s]+?content=(['"])(.+?)\1[\s]+?http-equiv=(['"])content-type\3/i.exec(str);
      if (res) {
        res.pop();
      }
    }
    if (res) {
      res = /charset=(.*)/i.exec(res.pop());
    }
  }
  if (!res && str) {
    res = /<\?xml.+?encoding=(['"])(.+?)\1/i.exec(str);
  }
  if (res) {
    charset = res.pop();
    if (charset === "gb2312" || charset === "gbk") {
      charset = "gb18030";
    }
  }
  return convert(buffer, "UTF-8", charset).toString();
}
function isURLSearchParams(obj) {
  if (typeof obj !== "object" || typeof obj.append !== "function" || typeof obj.delete !== "function" || typeof obj.get !== "function" || typeof obj.getAll !== "function" || typeof obj.has !== "function" || typeof obj.set !== "function") {
    return false;
  }
  return obj.constructor.name === "URLSearchParams" || Object.prototype.toString.call(obj) === "[object URLSearchParams]" || typeof obj.sort === "function";
}
function isBlob(obj) {
  return typeof obj === "object" && typeof obj.arrayBuffer === "function" && typeof obj.type === "string" && typeof obj.stream === "function" && typeof obj.constructor === "function" && typeof obj.constructor.name === "string" && /^(Blob|File)$/.test(obj.constructor.name) && /^(Blob|File)$/.test(obj[Symbol.toStringTag]);
}
function clone(instance) {
  let p1, p2;
  let body = instance.body;
  if (instance.bodyUsed) {
    throw new Error("cannot clone body after it is used");
  }
  if (body instanceof import_stream.default && typeof body.getBoundary !== "function") {
    p1 = new PassThrough();
    p2 = new PassThrough();
    body.pipe(p1);
    body.pipe(p2);
    instance[INTERNALS].body = p1;
    body = p2;
  }
  return body;
}
function extractContentType(body) {
  if (body === null) {
    return null;
  } else if (typeof body === "string") {
    return "text/plain;charset=UTF-8";
  } else if (isURLSearchParams(body)) {
    return "application/x-www-form-urlencoded;charset=UTF-8";
  } else if (isBlob(body)) {
    return body.type || null;
  } else if (Buffer.isBuffer(body)) {
    return null;
  } else if (Object.prototype.toString.call(body) === "[object ArrayBuffer]") {
    return null;
  } else if (ArrayBuffer.isView(body)) {
    return null;
  } else if (typeof body.getBoundary === "function") {
    return `multipart/form-data;boundary=${body.getBoundary()}`;
  } else if (body instanceof import_stream.default) {
    return null;
  } else {
    return "text/plain;charset=UTF-8";
  }
}
function getTotalBytes(instance) {
  const body = instance.body;
  if (body === null) {
    return 0;
  } else if (isBlob(body)) {
    return body.size;
  } else if (Buffer.isBuffer(body)) {
    return body.length;
  } else if (body && typeof body.getLengthSync === "function") {
    if (body._lengthRetrievers && body._lengthRetrievers.length == 0 || body.hasKnownLength && body.hasKnownLength()) {
      return body.getLengthSync();
    }
    return null;
  } else {
    return null;
  }
}
function writeToStream(dest, instance) {
  const body = instance.body;
  if (body === null) {
    dest.end();
  } else if (isBlob(body)) {
    body.stream().pipe(dest);
  } else if (Buffer.isBuffer(body)) {
    dest.write(body);
    dest.end();
  } else {
    body.pipe(dest);
  }
}
function validateName(name) {
  name = `${name}`;
  if (invalidTokenRegex.test(name) || name === "") {
    throw new TypeError(`${name} is not a legal HTTP header name`);
  }
}
function validateValue(value) {
  value = `${value}`;
  if (invalidHeaderCharRegex.test(value)) {
    throw new TypeError(`${value} is not a legal HTTP header value`);
  }
}
function find(map, name) {
  name = name.toLowerCase();
  for (const key in map) {
    if (key.toLowerCase() === name) {
      return key;
    }
  }
  return void 0;
}
function getHeaders(headers) {
  let kind = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "key+value";
  const keys = Object.keys(headers[MAP]).sort();
  return keys.map(kind === "key" ? function(k) {
    return k.toLowerCase();
  } : kind === "value" ? function(k) {
    return headers[MAP][k].join(", ");
  } : function(k) {
    return [k.toLowerCase(), headers[MAP][k].join(", ")];
  });
}
function createHeadersIterator(target, kind) {
  const iterator2 = Object.create(HeadersIteratorPrototype);
  iterator2[INTERNAL] = {
    target,
    kind,
    index: 0
  };
  return iterator2;
}
function exportNodeCompatibleHeaders(headers) {
  const obj = Object.assign({ __proto__: null }, headers[MAP]);
  const hostHeaderKey = find(headers[MAP], "Host");
  if (hostHeaderKey !== void 0) {
    obj[hostHeaderKey] = obj[hostHeaderKey][0];
  }
  return obj;
}
function createHeadersLenient(obj) {
  const headers = new Headers();
  for (const name of Object.keys(obj)) {
    if (invalidTokenRegex.test(name)) {
      continue;
    }
    if (Array.isArray(obj[name])) {
      for (const val of obj[name]) {
        if (invalidHeaderCharRegex.test(val)) {
          continue;
        }
        if (headers[MAP][name] === void 0) {
          headers[MAP][name] = [val];
        } else {
          headers[MAP][name].push(val);
        }
      }
    } else if (!invalidHeaderCharRegex.test(obj[name])) {
      headers[MAP][name] = [obj[name]];
    }
  }
  return headers;
}
function parseURL(urlStr) {
  if (/^[a-zA-Z][a-zA-Z\d+\-.]*:/.exec(urlStr)) {
    urlStr = new URL2(urlStr).toString();
  }
  return parse_url(urlStr);
}
function isRequest(input) {
  return typeof input === "object" && typeof input[INTERNALS$2] === "object";
}
function isAbortSignal(signal) {
  const proto = signal && typeof signal === "object" && Object.getPrototypeOf(signal);
  return !!(proto && proto.constructor.name === "AbortSignal");
}
function getNodeRequestOptions(request2) {
  const parsedURL = request2[INTERNALS$2].parsedURL;
  const headers = new Headers(request2[INTERNALS$2].headers);
  if (!headers.has("Accept")) {
    headers.set("Accept", "*/*");
  }
  if (!parsedURL.protocol || !parsedURL.hostname) {
    throw new TypeError("Only absolute URLs are supported");
  }
  if (!/^https?:$/.test(parsedURL.protocol)) {
    throw new TypeError("Only HTTP(S) protocols are supported");
  }
  if (request2.signal && request2.body instanceof import_stream.default.Readable && !streamDestructionSupported) {
    throw new Error("Cancellation of streamed requests with AbortSignal is not supported in node < 8");
  }
  let contentLengthValue = null;
  if (request2.body == null && /^(POST|PUT)$/i.test(request2.method)) {
    contentLengthValue = "0";
  }
  if (request2.body != null) {
    const totalBytes = getTotalBytes(request2);
    if (typeof totalBytes === "number") {
      contentLengthValue = String(totalBytes);
    }
  }
  if (contentLengthValue) {
    headers.set("Content-Length", contentLengthValue);
  }
  if (!headers.has("User-Agent")) {
    headers.set("User-Agent", "node-fetch/1.0 (+https://github.com/bitinn/node-fetch)");
  }
  if (request2.compress && !headers.has("Accept-Encoding")) {
    headers.set("Accept-Encoding", "gzip,deflate");
  }
  let agent = request2.agent;
  if (typeof agent === "function") {
    agent = agent(parsedURL);
  }
  if (!headers.has("Connection") && !agent) {
    headers.set("Connection", "close");
  }
  return Object.assign({}, parsedURL, {
    method: request2.method,
    headers: exportNodeCompatibleHeaders(headers),
    agent
  });
}
function AbortError(message) {
  Error.call(this, message);
  this.type = "aborted";
  this.message = message;
  Error.captureStackTrace(this, this.constructor);
}
function fetch(url, opts) {
  if (!fetch.Promise) {
    throw new Error("native promise missing, set fetch.Promise to your favorite alternative");
  }
  Body.Promise = fetch.Promise;
  return new fetch.Promise(function(resolve, reject) {
    const request2 = new Request(url, opts);
    const options = getNodeRequestOptions(request2);
    const send = (options.protocol === "https:" ? import_https.default : import_http.default).request;
    const signal = request2.signal;
    let response = null;
    const abort = function abort2() {
      let error = new AbortError("The user aborted a request.");
      reject(error);
      if (request2.body && request2.body instanceof import_stream.default.Readable) {
        request2.body.destroy(error);
      }
      if (!response || !response.body)
        return;
      response.body.emit("error", error);
    };
    if (signal && signal.aborted) {
      abort();
      return;
    }
    const abortAndFinalize = function abortAndFinalize2() {
      abort();
      finalize();
    };
    const req = send(options);
    let reqTimeout;
    if (signal) {
      signal.addEventListener("abort", abortAndFinalize);
    }
    function finalize() {
      req.abort();
      if (signal)
        signal.removeEventListener("abort", abortAndFinalize);
      clearTimeout(reqTimeout);
    }
    if (request2.timeout) {
      req.once("socket", function(socket) {
        reqTimeout = setTimeout(function() {
          reject(new FetchError(`network timeout at: ${request2.url}`, "request-timeout"));
          finalize();
        }, request2.timeout);
      });
    }
    req.on("error", function(err) {
      reject(new FetchError(`request to ${request2.url} failed, reason: ${err.message}`, "system", err));
      finalize();
    });
    req.on("response", function(res) {
      clearTimeout(reqTimeout);
      const headers = createHeadersLenient(res.headers);
      if (fetch.isRedirect(res.statusCode)) {
        const location = headers.get("Location");
        let locationURL = null;
        try {
          locationURL = location === null ? null : new URL$1(location, request2.url).toString();
        } catch (err) {
          if (request2.redirect !== "manual") {
            reject(new FetchError(`uri requested responds with an invalid redirect URL: ${location}`, "invalid-redirect"));
            finalize();
            return;
          }
        }
        switch (request2.redirect) {
          case "error":
            reject(new FetchError(`uri requested responds with a redirect, redirect mode is set to error: ${request2.url}`, "no-redirect"));
            finalize();
            return;
          case "manual":
            if (locationURL !== null) {
              try {
                headers.set("Location", locationURL);
              } catch (err) {
                reject(err);
              }
            }
            break;
          case "follow":
            if (locationURL === null) {
              break;
            }
            if (request2.counter >= request2.follow) {
              reject(new FetchError(`maximum redirect reached at: ${request2.url}`, "max-redirect"));
              finalize();
              return;
            }
            const requestOpts = {
              headers: new Headers(request2.headers),
              follow: request2.follow,
              counter: request2.counter + 1,
              agent: request2.agent,
              compress: request2.compress,
              method: request2.method,
              body: request2.body,
              signal: request2.signal,
              timeout: request2.timeout,
              size: request2.size
            };
            if (!isDomainOrSubdomain(request2.url, locationURL)) {
              for (const name of ["authorization", "www-authenticate", "cookie", "cookie2"]) {
                requestOpts.headers.delete(name);
              }
            }
            if (res.statusCode !== 303 && request2.body && getTotalBytes(request2) === null) {
              reject(new FetchError("Cannot follow redirect with body being a readable stream", "unsupported-redirect"));
              finalize();
              return;
            }
            if (res.statusCode === 303 || (res.statusCode === 301 || res.statusCode === 302) && request2.method === "POST") {
              requestOpts.method = "GET";
              requestOpts.body = void 0;
              requestOpts.headers.delete("content-length");
            }
            resolve(fetch(new Request(locationURL, requestOpts)));
            finalize();
            return;
        }
      }
      res.once("end", function() {
        if (signal)
          signal.removeEventListener("abort", abortAndFinalize);
      });
      let body = res.pipe(new PassThrough$1());
      const response_options = {
        url: request2.url,
        status: res.statusCode,
        statusText: res.statusMessage,
        headers,
        size: request2.size,
        timeout: request2.timeout,
        counter: request2.counter
      };
      const codings = headers.get("Content-Encoding");
      if (!request2.compress || request2.method === "HEAD" || codings === null || res.statusCode === 204 || res.statusCode === 304) {
        response = new Response(body, response_options);
        resolve(response);
        return;
      }
      const zlibOptions = {
        flush: import_zlib.default.Z_SYNC_FLUSH,
        finishFlush: import_zlib.default.Z_SYNC_FLUSH
      };
      if (codings == "gzip" || codings == "x-gzip") {
        body = body.pipe(import_zlib.default.createGunzip(zlibOptions));
        response = new Response(body, response_options);
        resolve(response);
        return;
      }
      if (codings == "deflate" || codings == "x-deflate") {
        const raw = res.pipe(new PassThrough$1());
        raw.once("data", function(chunk) {
          if ((chunk[0] & 15) === 8) {
            body = body.pipe(import_zlib.default.createInflate());
          } else {
            body = body.pipe(import_zlib.default.createInflateRaw());
          }
          response = new Response(body, response_options);
          resolve(response);
        });
        return;
      }
      if (codings == "br" && typeof import_zlib.default.createBrotliDecompress === "function") {
        body = body.pipe(import_zlib.default.createBrotliDecompress());
        response = new Response(body, response_options);
        resolve(response);
        return;
      }
      response = new Response(body, response_options);
      resolve(response);
    });
    writeToStream(req, request2);
  });
}
var import_stream, import_http, import_url, import_whatwg_url, import_https, import_zlib, Readable, BUFFER, TYPE, Blob, convert, INTERNALS, PassThrough, invalidTokenRegex, invalidHeaderCharRegex, MAP, Headers, INTERNAL, HeadersIteratorPrototype, INTERNALS$1, STATUS_CODES, Response, INTERNALS$2, URL2, parse_url, format_url, streamDestructionSupported, Request, URL$1, PassThrough$1, isDomainOrSubdomain, lib_default;
var init_lib = __esm({
  "node_modules/@octokit/request/node_modules/node-fetch/lib/index.mjs"() {
    import_stream = __toESM(require("stream"), 1);
    import_http = __toESM(require("http"), 1);
    import_url = __toESM(require("url"), 1);
    import_whatwg_url = __toESM(require_public_api(), 1);
    import_https = __toESM(require("https"), 1);
    import_zlib = __toESM(require("zlib"), 1);
    Readable = import_stream.default.Readable;
    BUFFER = Symbol("buffer");
    TYPE = Symbol("type");
    Blob = class {
      constructor() {
        this[TYPE] = "";
        const blobParts = arguments[0];
        const options = arguments[1];
        const buffers = [];
        let size = 0;
        if (blobParts) {
          const a = blobParts;
          const length = Number(a.length);
          for (let i2 = 0; i2 < length; i2++) {
            const element = a[i2];
            let buffer;
            if (element instanceof Buffer) {
              buffer = element;
            } else if (ArrayBuffer.isView(element)) {
              buffer = Buffer.from(element.buffer, element.byteOffset, element.byteLength);
            } else if (element instanceof ArrayBuffer) {
              buffer = Buffer.from(element);
            } else if (element instanceof Blob) {
              buffer = element[BUFFER];
            } else {
              buffer = Buffer.from(typeof element === "string" ? element : String(element));
            }
            size += buffer.length;
            buffers.push(buffer);
          }
        }
        this[BUFFER] = Buffer.concat(buffers);
        let type = options && options.type !== void 0 && String(options.type).toLowerCase();
        if (type && !/[^\u0020-\u007E]/.test(type)) {
          this[TYPE] = type;
        }
      }
      get size() {
        return this[BUFFER].length;
      }
      get type() {
        return this[TYPE];
      }
      text() {
        return Promise.resolve(this[BUFFER].toString());
      }
      arrayBuffer() {
        const buf = this[BUFFER];
        const ab = buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
        return Promise.resolve(ab);
      }
      stream() {
        const readable = new Readable();
        readable._read = function() {
        };
        readable.push(this[BUFFER]);
        readable.push(null);
        return readable;
      }
      toString() {
        return "[object Blob]";
      }
      slice() {
        const size = this.size;
        const start = arguments[0];
        const end = arguments[1];
        let relativeStart, relativeEnd;
        if (start === void 0) {
          relativeStart = 0;
        } else if (start < 0) {
          relativeStart = Math.max(size + start, 0);
        } else {
          relativeStart = Math.min(start, size);
        }
        if (end === void 0) {
          relativeEnd = size;
        } else if (end < 0) {
          relativeEnd = Math.max(size + end, 0);
        } else {
          relativeEnd = Math.min(end, size);
        }
        const span = Math.max(relativeEnd - relativeStart, 0);
        const buffer = this[BUFFER];
        const slicedBuffer = buffer.slice(relativeStart, relativeStart + span);
        const blob = new Blob([], { type: arguments[2] });
        blob[BUFFER] = slicedBuffer;
        return blob;
      }
    };
    Object.defineProperties(Blob.prototype, {
      size: { enumerable: true },
      type: { enumerable: true },
      slice: { enumerable: true }
    });
    Object.defineProperty(Blob.prototype, Symbol.toStringTag, {
      value: "Blob",
      writable: false,
      enumerable: false,
      configurable: true
    });
    FetchError.prototype = Object.create(Error.prototype);
    FetchError.prototype.constructor = FetchError;
    FetchError.prototype.name = "FetchError";
    try {
      convert = require("encoding").convert;
    } catch (e2) {
    }
    INTERNALS = Symbol("Body internals");
    PassThrough = import_stream.default.PassThrough;
    Body.prototype = {
      get body() {
        return this[INTERNALS].body;
      },
      get bodyUsed() {
        return this[INTERNALS].disturbed;
      },
      arrayBuffer() {
        return consumeBody.call(this).then(function(buf) {
          return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
        });
      },
      blob() {
        let ct = this.headers && this.headers.get("content-type") || "";
        return consumeBody.call(this).then(function(buf) {
          return Object.assign(
            new Blob([], {
              type: ct.toLowerCase()
            }),
            {
              [BUFFER]: buf
            }
          );
        });
      },
      json() {
        var _this2 = this;
        return consumeBody.call(this).then(function(buffer) {
          try {
            return JSON.parse(buffer.toString());
          } catch (err) {
            return Body.Promise.reject(new FetchError(`invalid json response body at ${_this2.url} reason: ${err.message}`, "invalid-json"));
          }
        });
      },
      text() {
        return consumeBody.call(this).then(function(buffer) {
          return buffer.toString();
        });
      },
      buffer() {
        return consumeBody.call(this);
      },
      textConverted() {
        var _this3 = this;
        return consumeBody.call(this).then(function(buffer) {
          return convertBody(buffer, _this3.headers);
        });
      }
    };
    Object.defineProperties(Body.prototype, {
      body: { enumerable: true },
      bodyUsed: { enumerable: true },
      arrayBuffer: { enumerable: true },
      blob: { enumerable: true },
      json: { enumerable: true },
      text: { enumerable: true }
    });
    Body.mixIn = function(proto) {
      for (const name of Object.getOwnPropertyNames(Body.prototype)) {
        if (!(name in proto)) {
          const desc = Object.getOwnPropertyDescriptor(Body.prototype, name);
          Object.defineProperty(proto, name, desc);
        }
      }
    };
    Body.Promise = global.Promise;
    invalidTokenRegex = /[^\^_`a-zA-Z\-0-9!#$%&'*+.|~]/;
    invalidHeaderCharRegex = /[^\t\x20-\x7e\x80-\xff]/;
    MAP = Symbol("map");
    Headers = class {
      constructor() {
        let init = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : void 0;
        this[MAP] = /* @__PURE__ */ Object.create(null);
        if (init instanceof Headers) {
          const rawHeaders = init.raw();
          const headerNames = Object.keys(rawHeaders);
          for (const headerName of headerNames) {
            for (const value of rawHeaders[headerName]) {
              this.append(headerName, value);
            }
          }
          return;
        }
        if (init == null)
          ;
        else if (typeof init === "object") {
          const method = init[Symbol.iterator];
          if (method != null) {
            if (typeof method !== "function") {
              throw new TypeError("Header pairs must be iterable");
            }
            const pairs = [];
            for (const pair of init) {
              if (typeof pair !== "object" || typeof pair[Symbol.iterator] !== "function") {
                throw new TypeError("Each header pair must be iterable");
              }
              pairs.push(Array.from(pair));
            }
            for (const pair of pairs) {
              if (pair.length !== 2) {
                throw new TypeError("Each header pair must be a name/value tuple");
              }
              this.append(pair[0], pair[1]);
            }
          } else {
            for (const key of Object.keys(init)) {
              const value = init[key];
              this.append(key, value);
            }
          }
        } else {
          throw new TypeError("Provided initializer must be an object");
        }
      }
      get(name) {
        name = `${name}`;
        validateName(name);
        const key = find(this[MAP], name);
        if (key === void 0) {
          return null;
        }
        return this[MAP][key].join(", ");
      }
      forEach(callback) {
        let thisArg = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : void 0;
        let pairs = getHeaders(this);
        let i2 = 0;
        while (i2 < pairs.length) {
          var _pairs$i = pairs[i2];
          const name = _pairs$i[0], value = _pairs$i[1];
          callback.call(thisArg, value, name, this);
          pairs = getHeaders(this);
          i2++;
        }
      }
      set(name, value) {
        name = `${name}`;
        value = `${value}`;
        validateName(name);
        validateValue(value);
        const key = find(this[MAP], name);
        this[MAP][key !== void 0 ? key : name] = [value];
      }
      append(name, value) {
        name = `${name}`;
        value = `${value}`;
        validateName(name);
        validateValue(value);
        const key = find(this[MAP], name);
        if (key !== void 0) {
          this[MAP][key].push(value);
        } else {
          this[MAP][name] = [value];
        }
      }
      has(name) {
        name = `${name}`;
        validateName(name);
        return find(this[MAP], name) !== void 0;
      }
      delete(name) {
        name = `${name}`;
        validateName(name);
        const key = find(this[MAP], name);
        if (key !== void 0) {
          delete this[MAP][key];
        }
      }
      raw() {
        return this[MAP];
      }
      keys() {
        return createHeadersIterator(this, "key");
      }
      values() {
        return createHeadersIterator(this, "value");
      }
      [Symbol.iterator]() {
        return createHeadersIterator(this, "key+value");
      }
    };
    Headers.prototype.entries = Headers.prototype[Symbol.iterator];
    Object.defineProperty(Headers.prototype, Symbol.toStringTag, {
      value: "Headers",
      writable: false,
      enumerable: false,
      configurable: true
    });
    Object.defineProperties(Headers.prototype, {
      get: { enumerable: true },
      forEach: { enumerable: true },
      set: { enumerable: true },
      append: { enumerable: true },
      has: { enumerable: true },
      delete: { enumerable: true },
      keys: { enumerable: true },
      values: { enumerable: true },
      entries: { enumerable: true }
    });
    INTERNAL = Symbol("internal");
    HeadersIteratorPrototype = Object.setPrototypeOf({
      next() {
        if (!this || Object.getPrototypeOf(this) !== HeadersIteratorPrototype) {
          throw new TypeError("Value of `this` is not a HeadersIterator");
        }
        var _INTERNAL = this[INTERNAL];
        const target = _INTERNAL.target, kind = _INTERNAL.kind, index = _INTERNAL.index;
        const values = getHeaders(target, kind);
        const len = values.length;
        if (index >= len) {
          return {
            value: void 0,
            done: true
          };
        }
        this[INTERNAL].index = index + 1;
        return {
          value: values[index],
          done: false
        };
      }
    }, Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]())));
    Object.defineProperty(HeadersIteratorPrototype, Symbol.toStringTag, {
      value: "HeadersIterator",
      writable: false,
      enumerable: false,
      configurable: true
    });
    INTERNALS$1 = Symbol("Response internals");
    STATUS_CODES = import_http.default.STATUS_CODES;
    Response = class {
      constructor() {
        let body = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
        let opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        Body.call(this, body, opts);
        const status = opts.status || 200;
        const headers = new Headers(opts.headers);
        if (body != null && !headers.has("Content-Type")) {
          const contentType = extractContentType(body);
          if (contentType) {
            headers.append("Content-Type", contentType);
          }
        }
        this[INTERNALS$1] = {
          url: opts.url,
          status,
          statusText: opts.statusText || STATUS_CODES[status],
          headers,
          counter: opts.counter
        };
      }
      get url() {
        return this[INTERNALS$1].url || "";
      }
      get status() {
        return this[INTERNALS$1].status;
      }
      get ok() {
        return this[INTERNALS$1].status >= 200 && this[INTERNALS$1].status < 300;
      }
      get redirected() {
        return this[INTERNALS$1].counter > 0;
      }
      get statusText() {
        return this[INTERNALS$1].statusText;
      }
      get headers() {
        return this[INTERNALS$1].headers;
      }
      clone() {
        return new Response(clone(this), {
          url: this.url,
          status: this.status,
          statusText: this.statusText,
          headers: this.headers,
          ok: this.ok,
          redirected: this.redirected
        });
      }
    };
    Body.mixIn(Response.prototype);
    Object.defineProperties(Response.prototype, {
      url: { enumerable: true },
      status: { enumerable: true },
      ok: { enumerable: true },
      redirected: { enumerable: true },
      statusText: { enumerable: true },
      headers: { enumerable: true },
      clone: { enumerable: true }
    });
    Object.defineProperty(Response.prototype, Symbol.toStringTag, {
      value: "Response",
      writable: false,
      enumerable: false,
      configurable: true
    });
    INTERNALS$2 = Symbol("Request internals");
    URL2 = import_url.default.URL || import_whatwg_url.default.URL;
    parse_url = import_url.default.parse;
    format_url = import_url.default.format;
    streamDestructionSupported = "destroy" in import_stream.default.Readable.prototype;
    Request = class {
      constructor(input) {
        let init = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        let parsedURL;
        if (!isRequest(input)) {
          if (input && input.href) {
            parsedURL = parseURL(input.href);
          } else {
            parsedURL = parseURL(`${input}`);
          }
          input = {};
        } else {
          parsedURL = parseURL(input.url);
        }
        let method = init.method || input.method || "GET";
        method = method.toUpperCase();
        if ((init.body != null || isRequest(input) && input.body !== null) && (method === "GET" || method === "HEAD")) {
          throw new TypeError("Request with GET/HEAD method cannot have body");
        }
        let inputBody = init.body != null ? init.body : isRequest(input) && input.body !== null ? clone(input) : null;
        Body.call(this, inputBody, {
          timeout: init.timeout || input.timeout || 0,
          size: init.size || input.size || 0
        });
        const headers = new Headers(init.headers || input.headers || {});
        if (inputBody != null && !headers.has("Content-Type")) {
          const contentType = extractContentType(inputBody);
          if (contentType) {
            headers.append("Content-Type", contentType);
          }
        }
        let signal = isRequest(input) ? input.signal : null;
        if ("signal" in init)
          signal = init.signal;
        if (signal != null && !isAbortSignal(signal)) {
          throw new TypeError("Expected signal to be an instanceof AbortSignal");
        }
        this[INTERNALS$2] = {
          method,
          redirect: init.redirect || input.redirect || "follow",
          headers,
          parsedURL,
          signal
        };
        this.follow = init.follow !== void 0 ? init.follow : input.follow !== void 0 ? input.follow : 20;
        this.compress = init.compress !== void 0 ? init.compress : input.compress !== void 0 ? input.compress : true;
        this.counter = init.counter || input.counter || 0;
        this.agent = init.agent || input.agent;
      }
      get method() {
        return this[INTERNALS$2].method;
      }
      get url() {
        return format_url(this[INTERNALS$2].parsedURL);
      }
      get headers() {
        return this[INTERNALS$2].headers;
      }
      get redirect() {
        return this[INTERNALS$2].redirect;
      }
      get signal() {
        return this[INTERNALS$2].signal;
      }
      clone() {
        return new Request(this);
      }
    };
    Body.mixIn(Request.prototype);
    Object.defineProperty(Request.prototype, Symbol.toStringTag, {
      value: "Request",
      writable: false,
      enumerable: false,
      configurable: true
    });
    Object.defineProperties(Request.prototype, {
      method: { enumerable: true },
      url: { enumerable: true },
      headers: { enumerable: true },
      redirect: { enumerable: true },
      clone: { enumerable: true },
      signal: { enumerable: true }
    });
    AbortError.prototype = Object.create(Error.prototype);
    AbortError.prototype.constructor = AbortError;
    AbortError.prototype.name = "AbortError";
    URL$1 = import_url.default.URL || import_whatwg_url.default.URL;
    PassThrough$1 = import_stream.default.PassThrough;
    isDomainOrSubdomain = function isDomainOrSubdomain2(destination, original) {
      const orig = new URL$1(original).hostname;
      const dest = new URL$1(destination).hostname;
      return orig === dest || orig[orig.length - dest.length - 1] === "." && orig.endsWith(dest);
    };
    fetch.isRedirect = function(code) {
      return code === 301 || code === 302 || code === 303 || code === 307 || code === 308;
    };
    fetch.Promise = global.Promise;
    lib_default = fetch;
  }
});

// node_modules/deprecation/dist-web/index.js
var Deprecation;
var init_dist_web4 = __esm({
  "node_modules/deprecation/dist-web/index.js"() {
    Deprecation = class extends Error {
      constructor(message) {
        super(message);
        if (Error.captureStackTrace) {
          Error.captureStackTrace(this, this.constructor);
        }
        this.name = "Deprecation";
      }
    };
  }
});

// node_modules/wrappy/wrappy.js
var require_wrappy = __commonJS({
  "node_modules/wrappy/wrappy.js"(exports, module2) {
    module2.exports = wrappy;
    function wrappy(fn, cb) {
      if (fn && cb)
        return wrappy(fn)(cb);
      if (typeof fn !== "function")
        throw new TypeError("need wrapper function");
      Object.keys(fn).forEach(function(k) {
        wrapper[k] = fn[k];
      });
      return wrapper;
      function wrapper() {
        var args = new Array(arguments.length);
        for (var i2 = 0; i2 < args.length; i2++) {
          args[i2] = arguments[i2];
        }
        var ret = fn.apply(this, args);
        var cb2 = args[args.length - 1];
        if (typeof ret === "function" && ret !== cb2) {
          Object.keys(cb2).forEach(function(k) {
            ret[k] = cb2[k];
          });
        }
        return ret;
      }
    }
  }
});

// node_modules/once/once.js
var require_once = __commonJS({
  "node_modules/once/once.js"(exports, module2) {
    var wrappy = require_wrappy();
    module2.exports = wrappy(once2);
    module2.exports.strict = wrappy(onceStrict);
    once2.proto = once2(function() {
      Object.defineProperty(Function.prototype, "once", {
        value: function() {
          return once2(this);
        },
        configurable: true
      });
      Object.defineProperty(Function.prototype, "onceStrict", {
        value: function() {
          return onceStrict(this);
        },
        configurable: true
      });
    });
    function once2(fn) {
      var f3 = function() {
        if (f3.called)
          return f3.value;
        f3.called = true;
        return f3.value = fn.apply(this, arguments);
      };
      f3.called = false;
      return f3;
    }
    function onceStrict(fn) {
      var f3 = function() {
        if (f3.called)
          throw new Error(f3.onceError);
        f3.called = true;
        return f3.value = fn.apply(this, arguments);
      };
      var name = fn.name || "Function wrapped with `once`";
      f3.onceError = name + " shouldn't be called more than once";
      f3.called = false;
      return f3;
    }
  }
});

// node_modules/@octokit/request-error/dist-web/index.js
var import_once, logOnceCode, logOnceHeaders, RequestError;
var init_dist_web5 = __esm({
  "node_modules/@octokit/request-error/dist-web/index.js"() {
    init_dist_web4();
    import_once = __toESM(require_once());
    logOnceCode = (0, import_once.default)((deprecation) => console.warn(deprecation));
    logOnceHeaders = (0, import_once.default)((deprecation) => console.warn(deprecation));
    RequestError = class extends Error {
      constructor(message, statusCode, options) {
        super(message);
        if (Error.captureStackTrace) {
          Error.captureStackTrace(this, this.constructor);
        }
        this.name = "HttpError";
        this.status = statusCode;
        let headers;
        if ("headers" in options && typeof options.headers !== "undefined") {
          headers = options.headers;
        }
        if ("response" in options) {
          this.response = options.response;
          headers = options.response.headers;
        }
        const requestCopy = Object.assign({}, options.request);
        if (options.request.headers.authorization) {
          requestCopy.headers = Object.assign({}, options.request.headers, {
            authorization: options.request.headers.authorization.replace(/ .*$/, " [REDACTED]")
          });
        }
        requestCopy.url = requestCopy.url.replace(/\bclient_secret=\w+/g, "client_secret=[REDACTED]").replace(/\baccess_token=\w+/g, "access_token=[REDACTED]");
        this.request = requestCopy;
        Object.defineProperty(this, "code", {
          get() {
            logOnceCode(new Deprecation("[@octokit/request-error] `error.code` is deprecated, use `error.status`."));
            return statusCode;
          }
        });
        Object.defineProperty(this, "headers", {
          get() {
            logOnceHeaders(new Deprecation("[@octokit/request-error] `error.headers` is deprecated, use `error.response.headers`."));
            return headers || {};
          }
        });
      }
    };
  }
});

// node_modules/@octokit/request/dist-web/index.js
function getBufferResponse(response) {
  return response.arrayBuffer();
}
function fetchWrapper(requestOptions) {
  const log = requestOptions.request && requestOptions.request.log ? requestOptions.request.log : console;
  if (isPlainObject2(requestOptions.body) || Array.isArray(requestOptions.body)) {
    requestOptions.body = JSON.stringify(requestOptions.body);
  }
  let headers = {};
  let status;
  let url;
  const fetch4 = requestOptions.request && requestOptions.request.fetch || lib_default;
  return fetch4(requestOptions.url, Object.assign(
    {
      method: requestOptions.method,
      body: requestOptions.body,
      headers: requestOptions.headers,
      redirect: requestOptions.redirect
    },
    requestOptions.request
  )).then(async (response) => {
    url = response.url;
    status = response.status;
    for (const keyAndValue of response.headers) {
      headers[keyAndValue[0]] = keyAndValue[1];
    }
    if ("deprecation" in headers) {
      const matches = headers.link && headers.link.match(/<([^>]+)>; rel="deprecation"/);
      const deprecationLink = matches && matches.pop();
      log.warn(`[@octokit/request] "${requestOptions.method} ${requestOptions.url}" is deprecated. It is scheduled to be removed on ${headers.sunset}${deprecationLink ? `. See ${deprecationLink}` : ""}`);
    }
    if (status === 204 || status === 205) {
      return;
    }
    if (requestOptions.method === "HEAD") {
      if (status < 400) {
        return;
      }
      throw new RequestError(response.statusText, status, {
        response: {
          url,
          status,
          headers,
          data: void 0
        },
        request: requestOptions
      });
    }
    if (status === 304) {
      throw new RequestError("Not modified", status, {
        response: {
          url,
          status,
          headers,
          data: await getResponseData(response)
        },
        request: requestOptions
      });
    }
    if (status >= 400) {
      const data = await getResponseData(response);
      const error = new RequestError(toErrorMessage(data), status, {
        response: {
          url,
          status,
          headers,
          data
        },
        request: requestOptions
      });
      throw error;
    }
    return getResponseData(response);
  }).then((data) => {
    return {
      status,
      url,
      headers,
      data
    };
  }).catch((error) => {
    if (error instanceof RequestError)
      throw error;
    throw new RequestError(error.message, 500, {
      request: requestOptions
    });
  });
}
async function getResponseData(response) {
  const contentType = response.headers.get("content-type");
  if (/application\/json/.test(contentType)) {
    return response.json();
  }
  if (!contentType || /^text\/|charset=utf-8$/.test(contentType)) {
    return response.text();
  }
  return getBufferResponse(response);
}
function toErrorMessage(data) {
  if (typeof data === "string")
    return data;
  if ("message" in data) {
    if (Array.isArray(data.errors)) {
      return `${data.message}: ${data.errors.map(JSON.stringify).join(", ")}`;
    }
    return data.message;
  }
  return `Unknown error: ${JSON.stringify(data)}`;
}
function withDefaults2(oldEndpoint, newDefaults) {
  const endpoint2 = oldEndpoint.defaults(newDefaults);
  const newApi = function(route, parameters) {
    const endpointOptions = endpoint2.merge(route, parameters);
    if (!endpointOptions.request || !endpointOptions.request.hook) {
      return fetchWrapper(endpoint2.parse(endpointOptions));
    }
    const request2 = (route2, parameters2) => {
      return fetchWrapper(endpoint2.parse(endpoint2.merge(route2, parameters2)));
    };
    Object.assign(request2, {
      endpoint: endpoint2,
      defaults: withDefaults2.bind(null, endpoint2)
    });
    return endpointOptions.request.hook(request2, endpointOptions);
  };
  return Object.assign(newApi, {
    endpoint: endpoint2,
    defaults: withDefaults2.bind(null, endpoint2)
  });
}
var VERSION2, request;
var init_dist_web6 = __esm({
  "node_modules/@octokit/request/dist-web/index.js"() {
    init_dist_web3();
    init_dist_web();
    init_is_plain_object2();
    init_lib();
    init_dist_web5();
    VERSION2 = "5.6.3";
    request = withDefaults2(endpoint, {
      headers: {
        "user-agent": `octokit-request.js/${VERSION2} ${getUserAgent()}`
      }
    });
  }
});

// node_modules/@octokit/graphql/dist-web/index.js
function _buildMessageForResponseErrors(data) {
  return `Request failed due to following response errors:
` + data.errors.map((e2) => ` - ${e2.message}`).join("\n");
}
function graphql(request2, query, options) {
  if (options) {
    if (typeof query === "string" && "query" in options) {
      return Promise.reject(new Error(`[@octokit/graphql] "query" cannot be used as variable name`));
    }
    for (const key in options) {
      if (!FORBIDDEN_VARIABLE_OPTIONS.includes(key))
        continue;
      return Promise.reject(new Error(`[@octokit/graphql] "${key}" cannot be used as variable name`));
    }
  }
  const parsedOptions = typeof query === "string" ? Object.assign({ query }, options) : query;
  const requestOptions = Object.keys(parsedOptions).reduce((result, key) => {
    if (NON_VARIABLE_OPTIONS.includes(key)) {
      result[key] = parsedOptions[key];
      return result;
    }
    if (!result.variables) {
      result.variables = {};
    }
    result.variables[key] = parsedOptions[key];
    return result;
  }, {});
  const baseUrl = parsedOptions.baseUrl || request2.endpoint.DEFAULTS.baseUrl;
  if (GHES_V3_SUFFIX_REGEX.test(baseUrl)) {
    requestOptions.url = baseUrl.replace(GHES_V3_SUFFIX_REGEX, "/api/graphql");
  }
  return request2(requestOptions).then((response) => {
    if (response.data.errors) {
      const headers = {};
      for (const key of Object.keys(response.headers)) {
        headers[key] = response.headers[key];
      }
      throw new GraphqlResponseError(requestOptions, headers, response.data);
    }
    return response.data.data;
  });
}
function withDefaults3(request$1, newDefaults) {
  const newRequest = request$1.defaults(newDefaults);
  const newApi = (query, options) => {
    return graphql(newRequest, query, options);
  };
  return Object.assign(newApi, {
    defaults: withDefaults3.bind(null, newRequest),
    endpoint: request.endpoint
  });
}
function withCustomRequest(customRequest) {
  return withDefaults3(customRequest, {
    method: "POST",
    url: "/graphql"
  });
}
var VERSION3, GraphqlResponseError, NON_VARIABLE_OPTIONS, FORBIDDEN_VARIABLE_OPTIONS, GHES_V3_SUFFIX_REGEX, graphql$1;
var init_dist_web7 = __esm({
  "node_modules/@octokit/graphql/dist-web/index.js"() {
    init_dist_web6();
    init_dist_web();
    VERSION3 = "4.8.0";
    GraphqlResponseError = class extends Error {
      constructor(request2, headers, response) {
        super(_buildMessageForResponseErrors(response));
        this.request = request2;
        this.headers = headers;
        this.response = response;
        this.name = "GraphqlResponseError";
        this.errors = response.errors;
        this.data = response.data;
        if (Error.captureStackTrace) {
          Error.captureStackTrace(this, this.constructor);
        }
      }
    };
    NON_VARIABLE_OPTIONS = [
      "method",
      "baseUrl",
      "url",
      "headers",
      "request",
      "query",
      "mediaType"
    ];
    FORBIDDEN_VARIABLE_OPTIONS = ["query", "method", "url"];
    GHES_V3_SUFFIX_REGEX = /\/api\/v3\/?$/;
    graphql$1 = withDefaults3(request, {
      headers: {
        "user-agent": `octokit-graphql.js/${VERSION3} ${getUserAgent()}`
      },
      method: "POST",
      url: "/graphql"
    });
  }
});

// node_modules/@octokit/auth-token/dist-web/index.js
async function auth(token) {
  const isApp = token.split(/\./).length === 3;
  const isInstallation = REGEX_IS_INSTALLATION_LEGACY.test(token) || REGEX_IS_INSTALLATION.test(token);
  const isUserToServer = REGEX_IS_USER_TO_SERVER.test(token);
  const tokenType = isApp ? "app" : isInstallation ? "installation" : isUserToServer ? "user-to-server" : "oauth";
  return {
    type: "token",
    token,
    tokenType
  };
}
function withAuthorizationPrefix(token) {
  if (token.split(/\./).length === 3) {
    return `bearer ${token}`;
  }
  return `token ${token}`;
}
async function hook(token, request2, route, parameters) {
  const endpoint2 = request2.endpoint.merge(route, parameters);
  endpoint2.headers.authorization = withAuthorizationPrefix(token);
  return request2(endpoint2);
}
var REGEX_IS_INSTALLATION_LEGACY, REGEX_IS_INSTALLATION, REGEX_IS_USER_TO_SERVER, createTokenAuth;
var init_dist_web8 = __esm({
  "node_modules/@octokit/auth-token/dist-web/index.js"() {
    REGEX_IS_INSTALLATION_LEGACY = /^v1\./;
    REGEX_IS_INSTALLATION = /^ghs_/;
    REGEX_IS_USER_TO_SERVER = /^ghu_/;
    createTokenAuth = function createTokenAuth2(token) {
      if (!token) {
        throw new Error("[@octokit/auth-token] No token passed to createTokenAuth");
      }
      if (typeof token !== "string") {
        throw new Error("[@octokit/auth-token] Token passed to createTokenAuth is not a string");
      }
      token = token.replace(/^(token|bearer) +/i, "");
      return Object.assign(auth.bind(null, token), {
        hook: hook.bind(null, token)
      });
    };
  }
});

// node_modules/@octokit/core/dist-web/index.js
var dist_web_exports = {};
__export(dist_web_exports, {
  Octokit: () => Octokit
});
var import_before_after_hook, VERSION4, Octokit;
var init_dist_web9 = __esm({
  "node_modules/@octokit/core/dist-web/index.js"() {
    init_dist_web();
    import_before_after_hook = __toESM(require_before_after_hook());
    init_dist_web6();
    init_dist_web7();
    init_dist_web8();
    VERSION4 = "3.6.0";
    Octokit = class {
      constructor(options = {}) {
        const hook2 = new import_before_after_hook.Collection();
        const requestDefaults = {
          baseUrl: request.endpoint.DEFAULTS.baseUrl,
          headers: {},
          request: Object.assign({}, options.request, {
            hook: hook2.bind(null, "request")
          }),
          mediaType: {
            previews: [],
            format: ""
          }
        };
        requestDefaults.headers["user-agent"] = [
          options.userAgent,
          `octokit-core.js/${VERSION4} ${getUserAgent()}`
        ].filter(Boolean).join(" ");
        if (options.baseUrl) {
          requestDefaults.baseUrl = options.baseUrl;
        }
        if (options.previews) {
          requestDefaults.mediaType.previews = options.previews;
        }
        if (options.timeZone) {
          requestDefaults.headers["time-zone"] = options.timeZone;
        }
        this.request = request.defaults(requestDefaults);
        this.graphql = withCustomRequest(this.request).defaults(requestDefaults);
        this.log = Object.assign({
          debug: () => {
          },
          info: () => {
          },
          warn: console.warn.bind(console),
          error: console.error.bind(console)
        }, options.log);
        this.hook = hook2;
        if (!options.authStrategy) {
          if (!options.auth) {
            this.auth = async () => ({
              type: "unauthenticated"
            });
          } else {
            const auth2 = createTokenAuth(options.auth);
            hook2.wrap("request", auth2.hook);
            this.auth = auth2;
          }
        } else {
          const { authStrategy, ...otherOptions } = options;
          const auth2 = authStrategy(Object.assign({
            request: this.request,
            log: this.log,
            octokit: this,
            octokitOptions: otherOptions
          }, options.auth));
          hook2.wrap("request", auth2.hook);
          this.auth = auth2;
        }
        const classConstructor = this.constructor;
        classConstructor.plugins.forEach((plugin) => {
          Object.assign(this, plugin(this, options));
        });
      }
      static defaults(defaults) {
        const OctokitWithDefaults = class extends this {
          constructor(...args) {
            const options = args[0] || {};
            if (typeof defaults === "function") {
              super(defaults(options));
              return;
            }
            super(Object.assign({}, defaults, options, options.userAgent && defaults.userAgent ? {
              userAgent: `${options.userAgent} ${defaults.userAgent}`
            } : null));
          }
        };
        return OctokitWithDefaults;
      }
      static plugin(...newPlugins) {
        var _a4;
        const currentPlugins = this.plugins;
        const NewOctokit = (_a4 = class extends this {
        }, _a4.plugins = currentPlugins.concat(newPlugins.filter((plugin) => !currentPlugins.includes(plugin))), _a4);
        return NewOctokit;
      }
    };
    Octokit.VERSION = VERSION4;
    Octokit.plugins = [];
  }
});

// node_modules/@octokit/plugin-rest-endpoint-methods/dist-web/index.js
var dist_web_exports2 = {};
__export(dist_web_exports2, {
  legacyRestEndpointMethods: () => legacyRestEndpointMethods,
  restEndpointMethods: () => restEndpointMethods
});
function endpointsToMethods(octokit, endpointsMap) {
  const newMethods = {};
  for (const [scope, endpoints] of Object.entries(endpointsMap)) {
    for (const [methodName, endpoint2] of Object.entries(endpoints)) {
      const [route, defaults, decorations] = endpoint2;
      const [method, url] = route.split(/ /);
      const endpointDefaults = Object.assign({ method, url }, defaults);
      if (!newMethods[scope]) {
        newMethods[scope] = {};
      }
      const scopeMethods = newMethods[scope];
      if (decorations) {
        scopeMethods[methodName] = decorate(octokit, scope, methodName, endpointDefaults, decorations);
        continue;
      }
      scopeMethods[methodName] = octokit.request.defaults(endpointDefaults);
    }
  }
  return newMethods;
}
function decorate(octokit, scope, methodName, defaults, decorations) {
  const requestWithDefaults = octokit.request.defaults(defaults);
  function withDecorations(...args) {
    let options = requestWithDefaults.endpoint.merge(...args);
    if (decorations.mapToData) {
      options = Object.assign({}, options, {
        data: options[decorations.mapToData],
        [decorations.mapToData]: void 0
      });
      return requestWithDefaults(options);
    }
    if (decorations.renamed) {
      const [newScope, newMethodName] = decorations.renamed;
      octokit.log.warn(`octokit.${scope}.${methodName}() has been renamed to octokit.${newScope}.${newMethodName}()`);
    }
    if (decorations.deprecated) {
      octokit.log.warn(decorations.deprecated);
    }
    if (decorations.renamedParameters) {
      const options2 = requestWithDefaults.endpoint.merge(...args);
      for (const [name, alias] of Object.entries(decorations.renamedParameters)) {
        if (name in options2) {
          octokit.log.warn(`"${name}" parameter is deprecated for "octokit.${scope}.${methodName}()". Use "${alias}" instead`);
          if (!(alias in options2)) {
            options2[alias] = options2[name];
          }
          delete options2[name];
        }
      }
      return requestWithDefaults(options2);
    }
    return requestWithDefaults(...args);
  }
  return Object.assign(withDecorations, requestWithDefaults);
}
function restEndpointMethods(octokit) {
  const api = endpointsToMethods(octokit, Endpoints);
  return {
    rest: api
  };
}
function legacyRestEndpointMethods(octokit) {
  const api = endpointsToMethods(octokit, Endpoints);
  return {
    ...api,
    rest: api
  };
}
var Endpoints, VERSION5;
var init_dist_web10 = __esm({
  "node_modules/@octokit/plugin-rest-endpoint-methods/dist-web/index.js"() {
    Endpoints = {
      actions: {
        addCustomLabelsToSelfHostedRunnerForOrg: [
          "POST /orgs/{org}/actions/runners/{runner_id}/labels"
        ],
        addCustomLabelsToSelfHostedRunnerForRepo: [
          "POST /repos/{owner}/{repo}/actions/runners/{runner_id}/labels"
        ],
        addSelectedRepoToOrgSecret: [
          "PUT /orgs/{org}/actions/secrets/{secret_name}/repositories/{repository_id}"
        ],
        approveWorkflowRun: [
          "POST /repos/{owner}/{repo}/actions/runs/{run_id}/approve"
        ],
        cancelWorkflowRun: [
          "POST /repos/{owner}/{repo}/actions/runs/{run_id}/cancel"
        ],
        createOrUpdateEnvironmentSecret: [
          "PUT /repositories/{repository_id}/environments/{environment_name}/secrets/{secret_name}"
        ],
        createOrUpdateOrgSecret: ["PUT /orgs/{org}/actions/secrets/{secret_name}"],
        createOrUpdateRepoSecret: [
          "PUT /repos/{owner}/{repo}/actions/secrets/{secret_name}"
        ],
        createRegistrationTokenForOrg: [
          "POST /orgs/{org}/actions/runners/registration-token"
        ],
        createRegistrationTokenForRepo: [
          "POST /repos/{owner}/{repo}/actions/runners/registration-token"
        ],
        createRemoveTokenForOrg: ["POST /orgs/{org}/actions/runners/remove-token"],
        createRemoveTokenForRepo: [
          "POST /repos/{owner}/{repo}/actions/runners/remove-token"
        ],
        createWorkflowDispatch: [
          "POST /repos/{owner}/{repo}/actions/workflows/{workflow_id}/dispatches"
        ],
        deleteActionsCacheById: [
          "DELETE /repos/{owner}/{repo}/actions/caches/{cache_id}"
        ],
        deleteActionsCacheByKey: [
          "DELETE /repos/{owner}/{repo}/actions/caches{?key,ref}"
        ],
        deleteArtifact: [
          "DELETE /repos/{owner}/{repo}/actions/artifacts/{artifact_id}"
        ],
        deleteEnvironmentSecret: [
          "DELETE /repositories/{repository_id}/environments/{environment_name}/secrets/{secret_name}"
        ],
        deleteOrgSecret: ["DELETE /orgs/{org}/actions/secrets/{secret_name}"],
        deleteRepoSecret: [
          "DELETE /repos/{owner}/{repo}/actions/secrets/{secret_name}"
        ],
        deleteSelfHostedRunnerFromOrg: [
          "DELETE /orgs/{org}/actions/runners/{runner_id}"
        ],
        deleteSelfHostedRunnerFromRepo: [
          "DELETE /repos/{owner}/{repo}/actions/runners/{runner_id}"
        ],
        deleteWorkflowRun: ["DELETE /repos/{owner}/{repo}/actions/runs/{run_id}"],
        deleteWorkflowRunLogs: [
          "DELETE /repos/{owner}/{repo}/actions/runs/{run_id}/logs"
        ],
        disableSelectedRepositoryGithubActionsOrganization: [
          "DELETE /orgs/{org}/actions/permissions/repositories/{repository_id}"
        ],
        disableWorkflow: [
          "PUT /repos/{owner}/{repo}/actions/workflows/{workflow_id}/disable"
        ],
        downloadArtifact: [
          "GET /repos/{owner}/{repo}/actions/artifacts/{artifact_id}/{archive_format}"
        ],
        downloadJobLogsForWorkflowRun: [
          "GET /repos/{owner}/{repo}/actions/jobs/{job_id}/logs"
        ],
        downloadWorkflowRunAttemptLogs: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}/logs"
        ],
        downloadWorkflowRunLogs: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/logs"
        ],
        enableSelectedRepositoryGithubActionsOrganization: [
          "PUT /orgs/{org}/actions/permissions/repositories/{repository_id}"
        ],
        enableWorkflow: [
          "PUT /repos/{owner}/{repo}/actions/workflows/{workflow_id}/enable"
        ],
        getActionsCacheList: ["GET /repos/{owner}/{repo}/actions/caches"],
        getActionsCacheUsage: ["GET /repos/{owner}/{repo}/actions/cache/usage"],
        getActionsCacheUsageByRepoForOrg: [
          "GET /orgs/{org}/actions/cache/usage-by-repository"
        ],
        getActionsCacheUsageForEnterprise: [
          "GET /enterprises/{enterprise}/actions/cache/usage"
        ],
        getActionsCacheUsageForOrg: ["GET /orgs/{org}/actions/cache/usage"],
        getAllowedActionsOrganization: [
          "GET /orgs/{org}/actions/permissions/selected-actions"
        ],
        getAllowedActionsRepository: [
          "GET /repos/{owner}/{repo}/actions/permissions/selected-actions"
        ],
        getArtifact: ["GET /repos/{owner}/{repo}/actions/artifacts/{artifact_id}"],
        getEnvironmentPublicKey: [
          "GET /repositories/{repository_id}/environments/{environment_name}/secrets/public-key"
        ],
        getEnvironmentSecret: [
          "GET /repositories/{repository_id}/environments/{environment_name}/secrets/{secret_name}"
        ],
        getGithubActionsDefaultWorkflowPermissionsEnterprise: [
          "GET /enterprises/{enterprise}/actions/permissions/workflow"
        ],
        getGithubActionsDefaultWorkflowPermissionsOrganization: [
          "GET /orgs/{org}/actions/permissions/workflow"
        ],
        getGithubActionsDefaultWorkflowPermissionsRepository: [
          "GET /repos/{owner}/{repo}/actions/permissions/workflow"
        ],
        getGithubActionsPermissionsOrganization: [
          "GET /orgs/{org}/actions/permissions"
        ],
        getGithubActionsPermissionsRepository: [
          "GET /repos/{owner}/{repo}/actions/permissions"
        ],
        getJobForWorkflowRun: ["GET /repos/{owner}/{repo}/actions/jobs/{job_id}"],
        getOrgPublicKey: ["GET /orgs/{org}/actions/secrets/public-key"],
        getOrgSecret: ["GET /orgs/{org}/actions/secrets/{secret_name}"],
        getPendingDeploymentsForRun: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments"
        ],
        getRepoPermissions: [
          "GET /repos/{owner}/{repo}/actions/permissions",
          {},
          { renamed: ["actions", "getGithubActionsPermissionsRepository"] }
        ],
        getRepoPublicKey: ["GET /repos/{owner}/{repo}/actions/secrets/public-key"],
        getRepoSecret: ["GET /repos/{owner}/{repo}/actions/secrets/{secret_name}"],
        getReviewsForRun: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/approvals"
        ],
        getSelfHostedRunnerForOrg: ["GET /orgs/{org}/actions/runners/{runner_id}"],
        getSelfHostedRunnerForRepo: [
          "GET /repos/{owner}/{repo}/actions/runners/{runner_id}"
        ],
        getWorkflow: ["GET /repos/{owner}/{repo}/actions/workflows/{workflow_id}"],
        getWorkflowAccessToRepository: [
          "GET /repos/{owner}/{repo}/actions/permissions/access"
        ],
        getWorkflowRun: ["GET /repos/{owner}/{repo}/actions/runs/{run_id}"],
        getWorkflowRunAttempt: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}"
        ],
        getWorkflowRunUsage: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/timing"
        ],
        getWorkflowUsage: [
          "GET /repos/{owner}/{repo}/actions/workflows/{workflow_id}/timing"
        ],
        listArtifactsForRepo: ["GET /repos/{owner}/{repo}/actions/artifacts"],
        listEnvironmentSecrets: [
          "GET /repositories/{repository_id}/environments/{environment_name}/secrets"
        ],
        listJobsForWorkflowRun: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/jobs"
        ],
        listJobsForWorkflowRunAttempt: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}/jobs"
        ],
        listLabelsForSelfHostedRunnerForOrg: [
          "GET /orgs/{org}/actions/runners/{runner_id}/labels"
        ],
        listLabelsForSelfHostedRunnerForRepo: [
          "GET /repos/{owner}/{repo}/actions/runners/{runner_id}/labels"
        ],
        listOrgSecrets: ["GET /orgs/{org}/actions/secrets"],
        listRepoSecrets: ["GET /repos/{owner}/{repo}/actions/secrets"],
        listRepoWorkflows: ["GET /repos/{owner}/{repo}/actions/workflows"],
        listRunnerApplicationsForOrg: ["GET /orgs/{org}/actions/runners/downloads"],
        listRunnerApplicationsForRepo: [
          "GET /repos/{owner}/{repo}/actions/runners/downloads"
        ],
        listSelectedReposForOrgSecret: [
          "GET /orgs/{org}/actions/secrets/{secret_name}/repositories"
        ],
        listSelectedRepositoriesEnabledGithubActionsOrganization: [
          "GET /orgs/{org}/actions/permissions/repositories"
        ],
        listSelfHostedRunnersForOrg: ["GET /orgs/{org}/actions/runners"],
        listSelfHostedRunnersForRepo: ["GET /repos/{owner}/{repo}/actions/runners"],
        listWorkflowRunArtifacts: [
          "GET /repos/{owner}/{repo}/actions/runs/{run_id}/artifacts"
        ],
        listWorkflowRuns: [
          "GET /repos/{owner}/{repo}/actions/workflows/{workflow_id}/runs"
        ],
        listWorkflowRunsForRepo: ["GET /repos/{owner}/{repo}/actions/runs"],
        reRunJobForWorkflowRun: [
          "POST /repos/{owner}/{repo}/actions/jobs/{job_id}/rerun"
        ],
        reRunWorkflow: ["POST /repos/{owner}/{repo}/actions/runs/{run_id}/rerun"],
        reRunWorkflowFailedJobs: [
          "POST /repos/{owner}/{repo}/actions/runs/{run_id}/rerun-failed-jobs"
        ],
        removeAllCustomLabelsFromSelfHostedRunnerForOrg: [
          "DELETE /orgs/{org}/actions/runners/{runner_id}/labels"
        ],
        removeAllCustomLabelsFromSelfHostedRunnerForRepo: [
          "DELETE /repos/{owner}/{repo}/actions/runners/{runner_id}/labels"
        ],
        removeCustomLabelFromSelfHostedRunnerForOrg: [
          "DELETE /orgs/{org}/actions/runners/{runner_id}/labels/{name}"
        ],
        removeCustomLabelFromSelfHostedRunnerForRepo: [
          "DELETE /repos/{owner}/{repo}/actions/runners/{runner_id}/labels/{name}"
        ],
        removeSelectedRepoFromOrgSecret: [
          "DELETE /orgs/{org}/actions/secrets/{secret_name}/repositories/{repository_id}"
        ],
        reviewPendingDeploymentsForRun: [
          "POST /repos/{owner}/{repo}/actions/runs/{run_id}/pending_deployments"
        ],
        setAllowedActionsOrganization: [
          "PUT /orgs/{org}/actions/permissions/selected-actions"
        ],
        setAllowedActionsRepository: [
          "PUT /repos/{owner}/{repo}/actions/permissions/selected-actions"
        ],
        setCustomLabelsForSelfHostedRunnerForOrg: [
          "PUT /orgs/{org}/actions/runners/{runner_id}/labels"
        ],
        setCustomLabelsForSelfHostedRunnerForRepo: [
          "PUT /repos/{owner}/{repo}/actions/runners/{runner_id}/labels"
        ],
        setGithubActionsDefaultWorkflowPermissionsEnterprise: [
          "PUT /enterprises/{enterprise}/actions/permissions/workflow"
        ],
        setGithubActionsDefaultWorkflowPermissionsOrganization: [
          "PUT /orgs/{org}/actions/permissions/workflow"
        ],
        setGithubActionsDefaultWorkflowPermissionsRepository: [
          "PUT /repos/{owner}/{repo}/actions/permissions/workflow"
        ],
        setGithubActionsPermissionsOrganization: [
          "PUT /orgs/{org}/actions/permissions"
        ],
        setGithubActionsPermissionsRepository: [
          "PUT /repos/{owner}/{repo}/actions/permissions"
        ],
        setSelectedReposForOrgSecret: [
          "PUT /orgs/{org}/actions/secrets/{secret_name}/repositories"
        ],
        setSelectedRepositoriesEnabledGithubActionsOrganization: [
          "PUT /orgs/{org}/actions/permissions/repositories"
        ],
        setWorkflowAccessToRepository: [
          "PUT /repos/{owner}/{repo}/actions/permissions/access"
        ]
      },
      activity: {
        checkRepoIsStarredByAuthenticatedUser: ["GET /user/starred/{owner}/{repo}"],
        deleteRepoSubscription: ["DELETE /repos/{owner}/{repo}/subscription"],
        deleteThreadSubscription: [
          "DELETE /notifications/threads/{thread_id}/subscription"
        ],
        getFeeds: ["GET /feeds"],
        getRepoSubscription: ["GET /repos/{owner}/{repo}/subscription"],
        getThread: ["GET /notifications/threads/{thread_id}"],
        getThreadSubscriptionForAuthenticatedUser: [
          "GET /notifications/threads/{thread_id}/subscription"
        ],
        listEventsForAuthenticatedUser: ["GET /users/{username}/events"],
        listNotificationsForAuthenticatedUser: ["GET /notifications"],
        listOrgEventsForAuthenticatedUser: [
          "GET /users/{username}/events/orgs/{org}"
        ],
        listPublicEvents: ["GET /events"],
        listPublicEventsForRepoNetwork: ["GET /networks/{owner}/{repo}/events"],
        listPublicEventsForUser: ["GET /users/{username}/events/public"],
        listPublicOrgEvents: ["GET /orgs/{org}/events"],
        listReceivedEventsForUser: ["GET /users/{username}/received_events"],
        listReceivedPublicEventsForUser: [
          "GET /users/{username}/received_events/public"
        ],
        listRepoEvents: ["GET /repos/{owner}/{repo}/events"],
        listRepoNotificationsForAuthenticatedUser: [
          "GET /repos/{owner}/{repo}/notifications"
        ],
        listReposStarredByAuthenticatedUser: ["GET /user/starred"],
        listReposStarredByUser: ["GET /users/{username}/starred"],
        listReposWatchedByUser: ["GET /users/{username}/subscriptions"],
        listStargazersForRepo: ["GET /repos/{owner}/{repo}/stargazers"],
        listWatchedReposForAuthenticatedUser: ["GET /user/subscriptions"],
        listWatchersForRepo: ["GET /repos/{owner}/{repo}/subscribers"],
        markNotificationsAsRead: ["PUT /notifications"],
        markRepoNotificationsAsRead: ["PUT /repos/{owner}/{repo}/notifications"],
        markThreadAsRead: ["PATCH /notifications/threads/{thread_id}"],
        setRepoSubscription: ["PUT /repos/{owner}/{repo}/subscription"],
        setThreadSubscription: [
          "PUT /notifications/threads/{thread_id}/subscription"
        ],
        starRepoForAuthenticatedUser: ["PUT /user/starred/{owner}/{repo}"],
        unstarRepoForAuthenticatedUser: ["DELETE /user/starred/{owner}/{repo}"]
      },
      apps: {
        addRepoToInstallation: [
          "PUT /user/installations/{installation_id}/repositories/{repository_id}",
          {},
          { renamed: ["apps", "addRepoToInstallationForAuthenticatedUser"] }
        ],
        addRepoToInstallationForAuthenticatedUser: [
          "PUT /user/installations/{installation_id}/repositories/{repository_id}"
        ],
        checkToken: ["POST /applications/{client_id}/token"],
        createFromManifest: ["POST /app-manifests/{code}/conversions"],
        createInstallationAccessToken: [
          "POST /app/installations/{installation_id}/access_tokens"
        ],
        deleteAuthorization: ["DELETE /applications/{client_id}/grant"],
        deleteInstallation: ["DELETE /app/installations/{installation_id}"],
        deleteToken: ["DELETE /applications/{client_id}/token"],
        getAuthenticated: ["GET /app"],
        getBySlug: ["GET /apps/{app_slug}"],
        getInstallation: ["GET /app/installations/{installation_id}"],
        getOrgInstallation: ["GET /orgs/{org}/installation"],
        getRepoInstallation: ["GET /repos/{owner}/{repo}/installation"],
        getSubscriptionPlanForAccount: [
          "GET /marketplace_listing/accounts/{account_id}"
        ],
        getSubscriptionPlanForAccountStubbed: [
          "GET /marketplace_listing/stubbed/accounts/{account_id}"
        ],
        getUserInstallation: ["GET /users/{username}/installation"],
        getWebhookConfigForApp: ["GET /app/hook/config"],
        getWebhookDelivery: ["GET /app/hook/deliveries/{delivery_id}"],
        listAccountsForPlan: ["GET /marketplace_listing/plans/{plan_id}/accounts"],
        listAccountsForPlanStubbed: [
          "GET /marketplace_listing/stubbed/plans/{plan_id}/accounts"
        ],
        listInstallationReposForAuthenticatedUser: [
          "GET /user/installations/{installation_id}/repositories"
        ],
        listInstallations: ["GET /app/installations"],
        listInstallationsForAuthenticatedUser: ["GET /user/installations"],
        listPlans: ["GET /marketplace_listing/plans"],
        listPlansStubbed: ["GET /marketplace_listing/stubbed/plans"],
        listReposAccessibleToInstallation: ["GET /installation/repositories"],
        listSubscriptionsForAuthenticatedUser: ["GET /user/marketplace_purchases"],
        listSubscriptionsForAuthenticatedUserStubbed: [
          "GET /user/marketplace_purchases/stubbed"
        ],
        listWebhookDeliveries: ["GET /app/hook/deliveries"],
        redeliverWebhookDelivery: [
          "POST /app/hook/deliveries/{delivery_id}/attempts"
        ],
        removeRepoFromInstallation: [
          "DELETE /user/installations/{installation_id}/repositories/{repository_id}",
          {},
          { renamed: ["apps", "removeRepoFromInstallationForAuthenticatedUser"] }
        ],
        removeRepoFromInstallationForAuthenticatedUser: [
          "DELETE /user/installations/{installation_id}/repositories/{repository_id}"
        ],
        resetToken: ["PATCH /applications/{client_id}/token"],
        revokeInstallationAccessToken: ["DELETE /installation/token"],
        scopeToken: ["POST /applications/{client_id}/token/scoped"],
        suspendInstallation: ["PUT /app/installations/{installation_id}/suspended"],
        unsuspendInstallation: [
          "DELETE /app/installations/{installation_id}/suspended"
        ],
        updateWebhookConfigForApp: ["PATCH /app/hook/config"]
      },
      billing: {
        getGithubActionsBillingOrg: ["GET /orgs/{org}/settings/billing/actions"],
        getGithubActionsBillingUser: [
          "GET /users/{username}/settings/billing/actions"
        ],
        getGithubAdvancedSecurityBillingGhe: [
          "GET /enterprises/{enterprise}/settings/billing/advanced-security"
        ],
        getGithubAdvancedSecurityBillingOrg: [
          "GET /orgs/{org}/settings/billing/advanced-security"
        ],
        getGithubPackagesBillingOrg: ["GET /orgs/{org}/settings/billing/packages"],
        getGithubPackagesBillingUser: [
          "GET /users/{username}/settings/billing/packages"
        ],
        getSharedStorageBillingOrg: [
          "GET /orgs/{org}/settings/billing/shared-storage"
        ],
        getSharedStorageBillingUser: [
          "GET /users/{username}/settings/billing/shared-storage"
        ]
      },
      checks: {
        create: ["POST /repos/{owner}/{repo}/check-runs"],
        createSuite: ["POST /repos/{owner}/{repo}/check-suites"],
        get: ["GET /repos/{owner}/{repo}/check-runs/{check_run_id}"],
        getSuite: ["GET /repos/{owner}/{repo}/check-suites/{check_suite_id}"],
        listAnnotations: [
          "GET /repos/{owner}/{repo}/check-runs/{check_run_id}/annotations"
        ],
        listForRef: ["GET /repos/{owner}/{repo}/commits/{ref}/check-runs"],
        listForSuite: [
          "GET /repos/{owner}/{repo}/check-suites/{check_suite_id}/check-runs"
        ],
        listSuitesForRef: ["GET /repos/{owner}/{repo}/commits/{ref}/check-suites"],
        rerequestRun: [
          "POST /repos/{owner}/{repo}/check-runs/{check_run_id}/rerequest"
        ],
        rerequestSuite: [
          "POST /repos/{owner}/{repo}/check-suites/{check_suite_id}/rerequest"
        ],
        setSuitesPreferences: [
          "PATCH /repos/{owner}/{repo}/check-suites/preferences"
        ],
        update: ["PATCH /repos/{owner}/{repo}/check-runs/{check_run_id}"]
      },
      codeScanning: {
        deleteAnalysis: [
          "DELETE /repos/{owner}/{repo}/code-scanning/analyses/{analysis_id}{?confirm_delete}"
        ],
        getAlert: [
          "GET /repos/{owner}/{repo}/code-scanning/alerts/{alert_number}",
          {},
          { renamedParameters: { alert_id: "alert_number" } }
        ],
        getAnalysis: [
          "GET /repos/{owner}/{repo}/code-scanning/analyses/{analysis_id}"
        ],
        getSarif: ["GET /repos/{owner}/{repo}/code-scanning/sarifs/{sarif_id}"],
        listAlertInstances: [
          "GET /repos/{owner}/{repo}/code-scanning/alerts/{alert_number}/instances"
        ],
        listAlertsForOrg: ["GET /orgs/{org}/code-scanning/alerts"],
        listAlertsForRepo: ["GET /repos/{owner}/{repo}/code-scanning/alerts"],
        listAlertsInstances: [
          "GET /repos/{owner}/{repo}/code-scanning/alerts/{alert_number}/instances",
          {},
          { renamed: ["codeScanning", "listAlertInstances"] }
        ],
        listRecentAnalyses: ["GET /repos/{owner}/{repo}/code-scanning/analyses"],
        updateAlert: [
          "PATCH /repos/{owner}/{repo}/code-scanning/alerts/{alert_number}"
        ],
        uploadSarif: ["POST /repos/{owner}/{repo}/code-scanning/sarifs"]
      },
      codesOfConduct: {
        getAllCodesOfConduct: ["GET /codes_of_conduct"],
        getConductCode: ["GET /codes_of_conduct/{key}"]
      },
      codespaces: {
        addRepositoryForSecretForAuthenticatedUser: [
          "PUT /user/codespaces/secrets/{secret_name}/repositories/{repository_id}"
        ],
        codespaceMachinesForAuthenticatedUser: [
          "GET /user/codespaces/{codespace_name}/machines"
        ],
        createForAuthenticatedUser: ["POST /user/codespaces"],
        createOrUpdateRepoSecret: [
          "PUT /repos/{owner}/{repo}/codespaces/secrets/{secret_name}"
        ],
        createOrUpdateSecretForAuthenticatedUser: [
          "PUT /user/codespaces/secrets/{secret_name}"
        ],
        createWithPrForAuthenticatedUser: [
          "POST /repos/{owner}/{repo}/pulls/{pull_number}/codespaces"
        ],
        createWithRepoForAuthenticatedUser: [
          "POST /repos/{owner}/{repo}/codespaces"
        ],
        deleteForAuthenticatedUser: ["DELETE /user/codespaces/{codespace_name}"],
        deleteFromOrganization: [
          "DELETE /orgs/{org}/members/{username}/codespaces/{codespace_name}"
        ],
        deleteRepoSecret: [
          "DELETE /repos/{owner}/{repo}/codespaces/secrets/{secret_name}"
        ],
        deleteSecretForAuthenticatedUser: [
          "DELETE /user/codespaces/secrets/{secret_name}"
        ],
        exportForAuthenticatedUser: [
          "POST /user/codespaces/{codespace_name}/exports"
        ],
        getExportDetailsForAuthenticatedUser: [
          "GET /user/codespaces/{codespace_name}/exports/{export_id}"
        ],
        getForAuthenticatedUser: ["GET /user/codespaces/{codespace_name}"],
        getPublicKeyForAuthenticatedUser: [
          "GET /user/codespaces/secrets/public-key"
        ],
        getRepoPublicKey: [
          "GET /repos/{owner}/{repo}/codespaces/secrets/public-key"
        ],
        getRepoSecret: [
          "GET /repos/{owner}/{repo}/codespaces/secrets/{secret_name}"
        ],
        getSecretForAuthenticatedUser: [
          "GET /user/codespaces/secrets/{secret_name}"
        ],
        listDevcontainersInRepositoryForAuthenticatedUser: [
          "GET /repos/{owner}/{repo}/codespaces/devcontainers"
        ],
        listForAuthenticatedUser: ["GET /user/codespaces"],
        listInOrganization: [
          "GET /orgs/{org}/codespaces",
          {},
          { renamedParameters: { org_id: "org" } }
        ],
        listInRepositoryForAuthenticatedUser: [
          "GET /repos/{owner}/{repo}/codespaces"
        ],
        listRepoSecrets: ["GET /repos/{owner}/{repo}/codespaces/secrets"],
        listRepositoriesForSecretForAuthenticatedUser: [
          "GET /user/codespaces/secrets/{secret_name}/repositories"
        ],
        listSecretsForAuthenticatedUser: ["GET /user/codespaces/secrets"],
        removeRepositoryForSecretForAuthenticatedUser: [
          "DELETE /user/codespaces/secrets/{secret_name}/repositories/{repository_id}"
        ],
        repoMachinesForAuthenticatedUser: [
          "GET /repos/{owner}/{repo}/codespaces/machines"
        ],
        setRepositoriesForSecretForAuthenticatedUser: [
          "PUT /user/codespaces/secrets/{secret_name}/repositories"
        ],
        startForAuthenticatedUser: ["POST /user/codespaces/{codespace_name}/start"],
        stopForAuthenticatedUser: ["POST /user/codespaces/{codespace_name}/stop"],
        stopInOrganization: [
          "POST /orgs/{org}/members/{username}/codespaces/{codespace_name}/stop"
        ],
        updateForAuthenticatedUser: ["PATCH /user/codespaces/{codespace_name}"]
      },
      dependabot: {
        addSelectedRepoToOrgSecret: [
          "PUT /orgs/{org}/dependabot/secrets/{secret_name}/repositories/{repository_id}"
        ],
        createOrUpdateOrgSecret: [
          "PUT /orgs/{org}/dependabot/secrets/{secret_name}"
        ],
        createOrUpdateRepoSecret: [
          "PUT /repos/{owner}/{repo}/dependabot/secrets/{secret_name}"
        ],
        deleteOrgSecret: ["DELETE /orgs/{org}/dependabot/secrets/{secret_name}"],
        deleteRepoSecret: [
          "DELETE /repos/{owner}/{repo}/dependabot/secrets/{secret_name}"
        ],
        getOrgPublicKey: ["GET /orgs/{org}/dependabot/secrets/public-key"],
        getOrgSecret: ["GET /orgs/{org}/dependabot/secrets/{secret_name}"],
        getRepoPublicKey: [
          "GET /repos/{owner}/{repo}/dependabot/secrets/public-key"
        ],
        getRepoSecret: [
          "GET /repos/{owner}/{repo}/dependabot/secrets/{secret_name}"
        ],
        listOrgSecrets: ["GET /orgs/{org}/dependabot/secrets"],
        listRepoSecrets: ["GET /repos/{owner}/{repo}/dependabot/secrets"],
        listSelectedReposForOrgSecret: [
          "GET /orgs/{org}/dependabot/secrets/{secret_name}/repositories"
        ],
        removeSelectedRepoFromOrgSecret: [
          "DELETE /orgs/{org}/dependabot/secrets/{secret_name}/repositories/{repository_id}"
        ],
        setSelectedReposForOrgSecret: [
          "PUT /orgs/{org}/dependabot/secrets/{secret_name}/repositories"
        ]
      },
      dependencyGraph: {
        createRepositorySnapshot: [
          "POST /repos/{owner}/{repo}/dependency-graph/snapshots"
        ],
        diffRange: [
          "GET /repos/{owner}/{repo}/dependency-graph/compare/{basehead}"
        ]
      },
      emojis: { get: ["GET /emojis"] },
      enterpriseAdmin: {
        addCustomLabelsToSelfHostedRunnerForEnterprise: [
          "POST /enterprises/{enterprise}/actions/runners/{runner_id}/labels"
        ],
        disableSelectedOrganizationGithubActionsEnterprise: [
          "DELETE /enterprises/{enterprise}/actions/permissions/organizations/{org_id}"
        ],
        enableSelectedOrganizationGithubActionsEnterprise: [
          "PUT /enterprises/{enterprise}/actions/permissions/organizations/{org_id}"
        ],
        getAllowedActionsEnterprise: [
          "GET /enterprises/{enterprise}/actions/permissions/selected-actions"
        ],
        getGithubActionsPermissionsEnterprise: [
          "GET /enterprises/{enterprise}/actions/permissions"
        ],
        getServerStatistics: [
          "GET /enterprise-installation/{enterprise_or_org}/server-statistics"
        ],
        listLabelsForSelfHostedRunnerForEnterprise: [
          "GET /enterprises/{enterprise}/actions/runners/{runner_id}/labels"
        ],
        listSelectedOrganizationsEnabledGithubActionsEnterprise: [
          "GET /enterprises/{enterprise}/actions/permissions/organizations"
        ],
        removeAllCustomLabelsFromSelfHostedRunnerForEnterprise: [
          "DELETE /enterprises/{enterprise}/actions/runners/{runner_id}/labels"
        ],
        removeCustomLabelFromSelfHostedRunnerForEnterprise: [
          "DELETE /enterprises/{enterprise}/actions/runners/{runner_id}/labels/{name}"
        ],
        setAllowedActionsEnterprise: [
          "PUT /enterprises/{enterprise}/actions/permissions/selected-actions"
        ],
        setCustomLabelsForSelfHostedRunnerForEnterprise: [
          "PUT /enterprises/{enterprise}/actions/runners/{runner_id}/labels"
        ],
        setGithubActionsPermissionsEnterprise: [
          "PUT /enterprises/{enterprise}/actions/permissions"
        ],
        setSelectedOrganizationsEnabledGithubActionsEnterprise: [
          "PUT /enterprises/{enterprise}/actions/permissions/organizations"
        ]
      },
      gists: {
        checkIsStarred: ["GET /gists/{gist_id}/star"],
        create: ["POST /gists"],
        createComment: ["POST /gists/{gist_id}/comments"],
        delete: ["DELETE /gists/{gist_id}"],
        deleteComment: ["DELETE /gists/{gist_id}/comments/{comment_id}"],
        fork: ["POST /gists/{gist_id}/forks"],
        get: ["GET /gists/{gist_id}"],
        getComment: ["GET /gists/{gist_id}/comments/{comment_id}"],
        getRevision: ["GET /gists/{gist_id}/{sha}"],
        list: ["GET /gists"],
        listComments: ["GET /gists/{gist_id}/comments"],
        listCommits: ["GET /gists/{gist_id}/commits"],
        listForUser: ["GET /users/{username}/gists"],
        listForks: ["GET /gists/{gist_id}/forks"],
        listPublic: ["GET /gists/public"],
        listStarred: ["GET /gists/starred"],
        star: ["PUT /gists/{gist_id}/star"],
        unstar: ["DELETE /gists/{gist_id}/star"],
        update: ["PATCH /gists/{gist_id}"],
        updateComment: ["PATCH /gists/{gist_id}/comments/{comment_id}"]
      },
      git: {
        createBlob: ["POST /repos/{owner}/{repo}/git/blobs"],
        createCommit: ["POST /repos/{owner}/{repo}/git/commits"],
        createRef: ["POST /repos/{owner}/{repo}/git/refs"],
        createTag: ["POST /repos/{owner}/{repo}/git/tags"],
        createTree: ["POST /repos/{owner}/{repo}/git/trees"],
        deleteRef: ["DELETE /repos/{owner}/{repo}/git/refs/{ref}"],
        getBlob: ["GET /repos/{owner}/{repo}/git/blobs/{file_sha}"],
        getCommit: ["GET /repos/{owner}/{repo}/git/commits/{commit_sha}"],
        getRef: ["GET /repos/{owner}/{repo}/git/ref/{ref}"],
        getTag: ["GET /repos/{owner}/{repo}/git/tags/{tag_sha}"],
        getTree: ["GET /repos/{owner}/{repo}/git/trees/{tree_sha}"],
        listMatchingRefs: ["GET /repos/{owner}/{repo}/git/matching-refs/{ref}"],
        updateRef: ["PATCH /repos/{owner}/{repo}/git/refs/{ref}"]
      },
      gitignore: {
        getAllTemplates: ["GET /gitignore/templates"],
        getTemplate: ["GET /gitignore/templates/{name}"]
      },
      interactions: {
        getRestrictionsForAuthenticatedUser: ["GET /user/interaction-limits"],
        getRestrictionsForOrg: ["GET /orgs/{org}/interaction-limits"],
        getRestrictionsForRepo: ["GET /repos/{owner}/{repo}/interaction-limits"],
        getRestrictionsForYourPublicRepos: [
          "GET /user/interaction-limits",
          {},
          { renamed: ["interactions", "getRestrictionsForAuthenticatedUser"] }
        ],
        removeRestrictionsForAuthenticatedUser: ["DELETE /user/interaction-limits"],
        removeRestrictionsForOrg: ["DELETE /orgs/{org}/interaction-limits"],
        removeRestrictionsForRepo: [
          "DELETE /repos/{owner}/{repo}/interaction-limits"
        ],
        removeRestrictionsForYourPublicRepos: [
          "DELETE /user/interaction-limits",
          {},
          { renamed: ["interactions", "removeRestrictionsForAuthenticatedUser"] }
        ],
        setRestrictionsForAuthenticatedUser: ["PUT /user/interaction-limits"],
        setRestrictionsForOrg: ["PUT /orgs/{org}/interaction-limits"],
        setRestrictionsForRepo: ["PUT /repos/{owner}/{repo}/interaction-limits"],
        setRestrictionsForYourPublicRepos: [
          "PUT /user/interaction-limits",
          {},
          { renamed: ["interactions", "setRestrictionsForAuthenticatedUser"] }
        ]
      },
      issues: {
        addAssignees: [
          "POST /repos/{owner}/{repo}/issues/{issue_number}/assignees"
        ],
        addLabels: ["POST /repos/{owner}/{repo}/issues/{issue_number}/labels"],
        checkUserCanBeAssigned: ["GET /repos/{owner}/{repo}/assignees/{assignee}"],
        create: ["POST /repos/{owner}/{repo}/issues"],
        createComment: [
          "POST /repos/{owner}/{repo}/issues/{issue_number}/comments"
        ],
        createLabel: ["POST /repos/{owner}/{repo}/labels"],
        createMilestone: ["POST /repos/{owner}/{repo}/milestones"],
        deleteComment: [
          "DELETE /repos/{owner}/{repo}/issues/comments/{comment_id}"
        ],
        deleteLabel: ["DELETE /repos/{owner}/{repo}/labels/{name}"],
        deleteMilestone: [
          "DELETE /repos/{owner}/{repo}/milestones/{milestone_number}"
        ],
        get: ["GET /repos/{owner}/{repo}/issues/{issue_number}"],
        getComment: ["GET /repos/{owner}/{repo}/issues/comments/{comment_id}"],
        getEvent: ["GET /repos/{owner}/{repo}/issues/events/{event_id}"],
        getLabel: ["GET /repos/{owner}/{repo}/labels/{name}"],
        getMilestone: ["GET /repos/{owner}/{repo}/milestones/{milestone_number}"],
        list: ["GET /issues"],
        listAssignees: ["GET /repos/{owner}/{repo}/assignees"],
        listComments: ["GET /repos/{owner}/{repo}/issues/{issue_number}/comments"],
        listCommentsForRepo: ["GET /repos/{owner}/{repo}/issues/comments"],
        listEvents: ["GET /repos/{owner}/{repo}/issues/{issue_number}/events"],
        listEventsForRepo: ["GET /repos/{owner}/{repo}/issues/events"],
        listEventsForTimeline: [
          "GET /repos/{owner}/{repo}/issues/{issue_number}/timeline"
        ],
        listForAuthenticatedUser: ["GET /user/issues"],
        listForOrg: ["GET /orgs/{org}/issues"],
        listForRepo: ["GET /repos/{owner}/{repo}/issues"],
        listLabelsForMilestone: [
          "GET /repos/{owner}/{repo}/milestones/{milestone_number}/labels"
        ],
        listLabelsForRepo: ["GET /repos/{owner}/{repo}/labels"],
        listLabelsOnIssue: [
          "GET /repos/{owner}/{repo}/issues/{issue_number}/labels"
        ],
        listMilestones: ["GET /repos/{owner}/{repo}/milestones"],
        lock: ["PUT /repos/{owner}/{repo}/issues/{issue_number}/lock"],
        removeAllLabels: [
          "DELETE /repos/{owner}/{repo}/issues/{issue_number}/labels"
        ],
        removeAssignees: [
          "DELETE /repos/{owner}/{repo}/issues/{issue_number}/assignees"
        ],
        removeLabel: [
          "DELETE /repos/{owner}/{repo}/issues/{issue_number}/labels/{name}"
        ],
        setLabels: ["PUT /repos/{owner}/{repo}/issues/{issue_number}/labels"],
        unlock: ["DELETE /repos/{owner}/{repo}/issues/{issue_number}/lock"],
        update: ["PATCH /repos/{owner}/{repo}/issues/{issue_number}"],
        updateComment: ["PATCH /repos/{owner}/{repo}/issues/comments/{comment_id}"],
        updateLabel: ["PATCH /repos/{owner}/{repo}/labels/{name}"],
        updateMilestone: [
          "PATCH /repos/{owner}/{repo}/milestones/{milestone_number}"
        ]
      },
      licenses: {
        get: ["GET /licenses/{license}"],
        getAllCommonlyUsed: ["GET /licenses"],
        getForRepo: ["GET /repos/{owner}/{repo}/license"]
      },
      markdown: {
        render: ["POST /markdown"],
        renderRaw: [
          "POST /markdown/raw",
          { headers: { "content-type": "text/plain; charset=utf-8" } }
        ]
      },
      meta: {
        get: ["GET /meta"],
        getOctocat: ["GET /octocat"],
        getZen: ["GET /zen"],
        root: ["GET /"]
      },
      migrations: {
        cancelImport: ["DELETE /repos/{owner}/{repo}/import"],
        deleteArchiveForAuthenticatedUser: [
          "DELETE /user/migrations/{migration_id}/archive"
        ],
        deleteArchiveForOrg: [
          "DELETE /orgs/{org}/migrations/{migration_id}/archive"
        ],
        downloadArchiveForOrg: [
          "GET /orgs/{org}/migrations/{migration_id}/archive"
        ],
        getArchiveForAuthenticatedUser: [
          "GET /user/migrations/{migration_id}/archive"
        ],
        getCommitAuthors: ["GET /repos/{owner}/{repo}/import/authors"],
        getImportStatus: ["GET /repos/{owner}/{repo}/import"],
        getLargeFiles: ["GET /repos/{owner}/{repo}/import/large_files"],
        getStatusForAuthenticatedUser: ["GET /user/migrations/{migration_id}"],
        getStatusForOrg: ["GET /orgs/{org}/migrations/{migration_id}"],
        listForAuthenticatedUser: ["GET /user/migrations"],
        listForOrg: ["GET /orgs/{org}/migrations"],
        listReposForAuthenticatedUser: [
          "GET /user/migrations/{migration_id}/repositories"
        ],
        listReposForOrg: ["GET /orgs/{org}/migrations/{migration_id}/repositories"],
        listReposForUser: [
          "GET /user/migrations/{migration_id}/repositories",
          {},
          { renamed: ["migrations", "listReposForAuthenticatedUser"] }
        ],
        mapCommitAuthor: ["PATCH /repos/{owner}/{repo}/import/authors/{author_id}"],
        setLfsPreference: ["PATCH /repos/{owner}/{repo}/import/lfs"],
        startForAuthenticatedUser: ["POST /user/migrations"],
        startForOrg: ["POST /orgs/{org}/migrations"],
        startImport: ["PUT /repos/{owner}/{repo}/import"],
        unlockRepoForAuthenticatedUser: [
          "DELETE /user/migrations/{migration_id}/repos/{repo_name}/lock"
        ],
        unlockRepoForOrg: [
          "DELETE /orgs/{org}/migrations/{migration_id}/repos/{repo_name}/lock"
        ],
        updateImport: ["PATCH /repos/{owner}/{repo}/import"]
      },
      orgs: {
        blockUser: ["PUT /orgs/{org}/blocks/{username}"],
        cancelInvitation: ["DELETE /orgs/{org}/invitations/{invitation_id}"],
        checkBlockedUser: ["GET /orgs/{org}/blocks/{username}"],
        checkMembershipForUser: ["GET /orgs/{org}/members/{username}"],
        checkPublicMembershipForUser: ["GET /orgs/{org}/public_members/{username}"],
        convertMemberToOutsideCollaborator: [
          "PUT /orgs/{org}/outside_collaborators/{username}"
        ],
        createInvitation: ["POST /orgs/{org}/invitations"],
        createWebhook: ["POST /orgs/{org}/hooks"],
        deleteWebhook: ["DELETE /orgs/{org}/hooks/{hook_id}"],
        get: ["GET /orgs/{org}"],
        getMembershipForAuthenticatedUser: ["GET /user/memberships/orgs/{org}"],
        getMembershipForUser: ["GET /orgs/{org}/memberships/{username}"],
        getWebhook: ["GET /orgs/{org}/hooks/{hook_id}"],
        getWebhookConfigForOrg: ["GET /orgs/{org}/hooks/{hook_id}/config"],
        getWebhookDelivery: [
          "GET /orgs/{org}/hooks/{hook_id}/deliveries/{delivery_id}"
        ],
        list: ["GET /organizations"],
        listAppInstallations: ["GET /orgs/{org}/installations"],
        listBlockedUsers: ["GET /orgs/{org}/blocks"],
        listCustomRoles: ["GET /organizations/{organization_id}/custom_roles"],
        listFailedInvitations: ["GET /orgs/{org}/failed_invitations"],
        listForAuthenticatedUser: ["GET /user/orgs"],
        listForUser: ["GET /users/{username}/orgs"],
        listInvitationTeams: ["GET /orgs/{org}/invitations/{invitation_id}/teams"],
        listMembers: ["GET /orgs/{org}/members"],
        listMembershipsForAuthenticatedUser: ["GET /user/memberships/orgs"],
        listOutsideCollaborators: ["GET /orgs/{org}/outside_collaborators"],
        listPendingInvitations: ["GET /orgs/{org}/invitations"],
        listPublicMembers: ["GET /orgs/{org}/public_members"],
        listWebhookDeliveries: ["GET /orgs/{org}/hooks/{hook_id}/deliveries"],
        listWebhooks: ["GET /orgs/{org}/hooks"],
        pingWebhook: ["POST /orgs/{org}/hooks/{hook_id}/pings"],
        redeliverWebhookDelivery: [
          "POST /orgs/{org}/hooks/{hook_id}/deliveries/{delivery_id}/attempts"
        ],
        removeMember: ["DELETE /orgs/{org}/members/{username}"],
        removeMembershipForUser: ["DELETE /orgs/{org}/memberships/{username}"],
        removeOutsideCollaborator: [
          "DELETE /orgs/{org}/outside_collaborators/{username}"
        ],
        removePublicMembershipForAuthenticatedUser: [
          "DELETE /orgs/{org}/public_members/{username}"
        ],
        setMembershipForUser: ["PUT /orgs/{org}/memberships/{username}"],
        setPublicMembershipForAuthenticatedUser: [
          "PUT /orgs/{org}/public_members/{username}"
        ],
        unblockUser: ["DELETE /orgs/{org}/blocks/{username}"],
        update: ["PATCH /orgs/{org}"],
        updateMembershipForAuthenticatedUser: [
          "PATCH /user/memberships/orgs/{org}"
        ],
        updateWebhook: ["PATCH /orgs/{org}/hooks/{hook_id}"],
        updateWebhookConfigForOrg: ["PATCH /orgs/{org}/hooks/{hook_id}/config"]
      },
      packages: {
        deletePackageForAuthenticatedUser: [
          "DELETE /user/packages/{package_type}/{package_name}"
        ],
        deletePackageForOrg: [
          "DELETE /orgs/{org}/packages/{package_type}/{package_name}"
        ],
        deletePackageForUser: [
          "DELETE /users/{username}/packages/{package_type}/{package_name}"
        ],
        deletePackageVersionForAuthenticatedUser: [
          "DELETE /user/packages/{package_type}/{package_name}/versions/{package_version_id}"
        ],
        deletePackageVersionForOrg: [
          "DELETE /orgs/{org}/packages/{package_type}/{package_name}/versions/{package_version_id}"
        ],
        deletePackageVersionForUser: [
          "DELETE /users/{username}/packages/{package_type}/{package_name}/versions/{package_version_id}"
        ],
        getAllPackageVersionsForAPackageOwnedByAnOrg: [
          "GET /orgs/{org}/packages/{package_type}/{package_name}/versions",
          {},
          { renamed: ["packages", "getAllPackageVersionsForPackageOwnedByOrg"] }
        ],
        getAllPackageVersionsForAPackageOwnedByTheAuthenticatedUser: [
          "GET /user/packages/{package_type}/{package_name}/versions",
          {},
          {
            renamed: [
              "packages",
              "getAllPackageVersionsForPackageOwnedByAuthenticatedUser"
            ]
          }
        ],
        getAllPackageVersionsForPackageOwnedByAuthenticatedUser: [
          "GET /user/packages/{package_type}/{package_name}/versions"
        ],
        getAllPackageVersionsForPackageOwnedByOrg: [
          "GET /orgs/{org}/packages/{package_type}/{package_name}/versions"
        ],
        getAllPackageVersionsForPackageOwnedByUser: [
          "GET /users/{username}/packages/{package_type}/{package_name}/versions"
        ],
        getPackageForAuthenticatedUser: [
          "GET /user/packages/{package_type}/{package_name}"
        ],
        getPackageForOrganization: [
          "GET /orgs/{org}/packages/{package_type}/{package_name}"
        ],
        getPackageForUser: [
          "GET /users/{username}/packages/{package_type}/{package_name}"
        ],
        getPackageVersionForAuthenticatedUser: [
          "GET /user/packages/{package_type}/{package_name}/versions/{package_version_id}"
        ],
        getPackageVersionForOrganization: [
          "GET /orgs/{org}/packages/{package_type}/{package_name}/versions/{package_version_id}"
        ],
        getPackageVersionForUser: [
          "GET /users/{username}/packages/{package_type}/{package_name}/versions/{package_version_id}"
        ],
        listPackagesForAuthenticatedUser: ["GET /user/packages"],
        listPackagesForOrganization: ["GET /orgs/{org}/packages"],
        listPackagesForUser: ["GET /users/{username}/packages"],
        restorePackageForAuthenticatedUser: [
          "POST /user/packages/{package_type}/{package_name}/restore{?token}"
        ],
        restorePackageForOrg: [
          "POST /orgs/{org}/packages/{package_type}/{package_name}/restore{?token}"
        ],
        restorePackageForUser: [
          "POST /users/{username}/packages/{package_type}/{package_name}/restore{?token}"
        ],
        restorePackageVersionForAuthenticatedUser: [
          "POST /user/packages/{package_type}/{package_name}/versions/{package_version_id}/restore"
        ],
        restorePackageVersionForOrg: [
          "POST /orgs/{org}/packages/{package_type}/{package_name}/versions/{package_version_id}/restore"
        ],
        restorePackageVersionForUser: [
          "POST /users/{username}/packages/{package_type}/{package_name}/versions/{package_version_id}/restore"
        ]
      },
      projects: {
        addCollaborator: ["PUT /projects/{project_id}/collaborators/{username}"],
        createCard: ["POST /projects/columns/{column_id}/cards"],
        createColumn: ["POST /projects/{project_id}/columns"],
        createForAuthenticatedUser: ["POST /user/projects"],
        createForOrg: ["POST /orgs/{org}/projects"],
        createForRepo: ["POST /repos/{owner}/{repo}/projects"],
        delete: ["DELETE /projects/{project_id}"],
        deleteCard: ["DELETE /projects/columns/cards/{card_id}"],
        deleteColumn: ["DELETE /projects/columns/{column_id}"],
        get: ["GET /projects/{project_id}"],
        getCard: ["GET /projects/columns/cards/{card_id}"],
        getColumn: ["GET /projects/columns/{column_id}"],
        getPermissionForUser: [
          "GET /projects/{project_id}/collaborators/{username}/permission"
        ],
        listCards: ["GET /projects/columns/{column_id}/cards"],
        listCollaborators: ["GET /projects/{project_id}/collaborators"],
        listColumns: ["GET /projects/{project_id}/columns"],
        listForOrg: ["GET /orgs/{org}/projects"],
        listForRepo: ["GET /repos/{owner}/{repo}/projects"],
        listForUser: ["GET /users/{username}/projects"],
        moveCard: ["POST /projects/columns/cards/{card_id}/moves"],
        moveColumn: ["POST /projects/columns/{column_id}/moves"],
        removeCollaborator: [
          "DELETE /projects/{project_id}/collaborators/{username}"
        ],
        update: ["PATCH /projects/{project_id}"],
        updateCard: ["PATCH /projects/columns/cards/{card_id}"],
        updateColumn: ["PATCH /projects/columns/{column_id}"]
      },
      pulls: {
        checkIfMerged: ["GET /repos/{owner}/{repo}/pulls/{pull_number}/merge"],
        create: ["POST /repos/{owner}/{repo}/pulls"],
        createReplyForReviewComment: [
          "POST /repos/{owner}/{repo}/pulls/{pull_number}/comments/{comment_id}/replies"
        ],
        createReview: ["POST /repos/{owner}/{repo}/pulls/{pull_number}/reviews"],
        createReviewComment: [
          "POST /repos/{owner}/{repo}/pulls/{pull_number}/comments"
        ],
        deletePendingReview: [
          "DELETE /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}"
        ],
        deleteReviewComment: [
          "DELETE /repos/{owner}/{repo}/pulls/comments/{comment_id}"
        ],
        dismissReview: [
          "PUT /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/dismissals"
        ],
        get: ["GET /repos/{owner}/{repo}/pulls/{pull_number}"],
        getReview: [
          "GET /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}"
        ],
        getReviewComment: ["GET /repos/{owner}/{repo}/pulls/comments/{comment_id}"],
        list: ["GET /repos/{owner}/{repo}/pulls"],
        listCommentsForReview: [
          "GET /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/comments"
        ],
        listCommits: ["GET /repos/{owner}/{repo}/pulls/{pull_number}/commits"],
        listFiles: ["GET /repos/{owner}/{repo}/pulls/{pull_number}/files"],
        listRequestedReviewers: [
          "GET /repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers"
        ],
        listReviewComments: [
          "GET /repos/{owner}/{repo}/pulls/{pull_number}/comments"
        ],
        listReviewCommentsForRepo: ["GET /repos/{owner}/{repo}/pulls/comments"],
        listReviews: ["GET /repos/{owner}/{repo}/pulls/{pull_number}/reviews"],
        merge: ["PUT /repos/{owner}/{repo}/pulls/{pull_number}/merge"],
        removeRequestedReviewers: [
          "DELETE /repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers"
        ],
        requestReviewers: [
          "POST /repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers"
        ],
        submitReview: [
          "POST /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/events"
        ],
        update: ["PATCH /repos/{owner}/{repo}/pulls/{pull_number}"],
        updateBranch: [
          "PUT /repos/{owner}/{repo}/pulls/{pull_number}/update-branch"
        ],
        updateReview: [
          "PUT /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}"
        ],
        updateReviewComment: [
          "PATCH /repos/{owner}/{repo}/pulls/comments/{comment_id}"
        ]
      },
      rateLimit: { get: ["GET /rate_limit"] },
      reactions: {
        createForCommitComment: [
          "POST /repos/{owner}/{repo}/comments/{comment_id}/reactions"
        ],
        createForIssue: [
          "POST /repos/{owner}/{repo}/issues/{issue_number}/reactions"
        ],
        createForIssueComment: [
          "POST /repos/{owner}/{repo}/issues/comments/{comment_id}/reactions"
        ],
        createForPullRequestReviewComment: [
          "POST /repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions"
        ],
        createForRelease: [
          "POST /repos/{owner}/{repo}/releases/{release_id}/reactions"
        ],
        createForTeamDiscussionCommentInOrg: [
          "POST /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions"
        ],
        createForTeamDiscussionInOrg: [
          "POST /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions"
        ],
        deleteForCommitComment: [
          "DELETE /repos/{owner}/{repo}/comments/{comment_id}/reactions/{reaction_id}"
        ],
        deleteForIssue: [
          "DELETE /repos/{owner}/{repo}/issues/{issue_number}/reactions/{reaction_id}"
        ],
        deleteForIssueComment: [
          "DELETE /repos/{owner}/{repo}/issues/comments/{comment_id}/reactions/{reaction_id}"
        ],
        deleteForPullRequestComment: [
          "DELETE /repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions/{reaction_id}"
        ],
        deleteForRelease: [
          "DELETE /repos/{owner}/{repo}/releases/{release_id}/reactions/{reaction_id}"
        ],
        deleteForTeamDiscussion: [
          "DELETE /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions/{reaction_id}"
        ],
        deleteForTeamDiscussionComment: [
          "DELETE /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions/{reaction_id}"
        ],
        listForCommitComment: [
          "GET /repos/{owner}/{repo}/comments/{comment_id}/reactions"
        ],
        listForIssue: ["GET /repos/{owner}/{repo}/issues/{issue_number}/reactions"],
        listForIssueComment: [
          "GET /repos/{owner}/{repo}/issues/comments/{comment_id}/reactions"
        ],
        listForPullRequestReviewComment: [
          "GET /repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions"
        ],
        listForRelease: [
          "GET /repos/{owner}/{repo}/releases/{release_id}/reactions"
        ],
        listForTeamDiscussionCommentInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions"
        ],
        listForTeamDiscussionInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions"
        ]
      },
      repos: {
        acceptInvitation: [
          "PATCH /user/repository_invitations/{invitation_id}",
          {},
          { renamed: ["repos", "acceptInvitationForAuthenticatedUser"] }
        ],
        acceptInvitationForAuthenticatedUser: [
          "PATCH /user/repository_invitations/{invitation_id}"
        ],
        addAppAccessRestrictions: [
          "POST /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps",
          {},
          { mapToData: "apps" }
        ],
        addCollaborator: ["PUT /repos/{owner}/{repo}/collaborators/{username}"],
        addStatusCheckContexts: [
          "POST /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts",
          {},
          { mapToData: "contexts" }
        ],
        addTeamAccessRestrictions: [
          "POST /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams",
          {},
          { mapToData: "teams" }
        ],
        addUserAccessRestrictions: [
          "POST /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users",
          {},
          { mapToData: "users" }
        ],
        checkCollaborator: ["GET /repos/{owner}/{repo}/collaborators/{username}"],
        checkVulnerabilityAlerts: [
          "GET /repos/{owner}/{repo}/vulnerability-alerts"
        ],
        codeownersErrors: ["GET /repos/{owner}/{repo}/codeowners/errors"],
        compareCommits: ["GET /repos/{owner}/{repo}/compare/{base}...{head}"],
        compareCommitsWithBasehead: [
          "GET /repos/{owner}/{repo}/compare/{basehead}"
        ],
        createAutolink: ["POST /repos/{owner}/{repo}/autolinks"],
        createCommitComment: [
          "POST /repos/{owner}/{repo}/commits/{commit_sha}/comments"
        ],
        createCommitSignatureProtection: [
          "POST /repos/{owner}/{repo}/branches/{branch}/protection/required_signatures"
        ],
        createCommitStatus: ["POST /repos/{owner}/{repo}/statuses/{sha}"],
        createDeployKey: ["POST /repos/{owner}/{repo}/keys"],
        createDeployment: ["POST /repos/{owner}/{repo}/deployments"],
        createDeploymentStatus: [
          "POST /repos/{owner}/{repo}/deployments/{deployment_id}/statuses"
        ],
        createDispatchEvent: ["POST /repos/{owner}/{repo}/dispatches"],
        createForAuthenticatedUser: ["POST /user/repos"],
        createFork: ["POST /repos/{owner}/{repo}/forks"],
        createInOrg: ["POST /orgs/{org}/repos"],
        createOrUpdateEnvironment: [
          "PUT /repos/{owner}/{repo}/environments/{environment_name}"
        ],
        createOrUpdateFileContents: ["PUT /repos/{owner}/{repo}/contents/{path}"],
        createPagesSite: ["POST /repos/{owner}/{repo}/pages"],
        createRelease: ["POST /repos/{owner}/{repo}/releases"],
        createTagProtection: ["POST /repos/{owner}/{repo}/tags/protection"],
        createUsingTemplate: [
          "POST /repos/{template_owner}/{template_repo}/generate"
        ],
        createWebhook: ["POST /repos/{owner}/{repo}/hooks"],
        declineInvitation: [
          "DELETE /user/repository_invitations/{invitation_id}",
          {},
          { renamed: ["repos", "declineInvitationForAuthenticatedUser"] }
        ],
        declineInvitationForAuthenticatedUser: [
          "DELETE /user/repository_invitations/{invitation_id}"
        ],
        delete: ["DELETE /repos/{owner}/{repo}"],
        deleteAccessRestrictions: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/restrictions"
        ],
        deleteAdminBranchProtection: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins"
        ],
        deleteAnEnvironment: [
          "DELETE /repos/{owner}/{repo}/environments/{environment_name}"
        ],
        deleteAutolink: ["DELETE /repos/{owner}/{repo}/autolinks/{autolink_id}"],
        deleteBranchProtection: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection"
        ],
        deleteCommitComment: ["DELETE /repos/{owner}/{repo}/comments/{comment_id}"],
        deleteCommitSignatureProtection: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/required_signatures"
        ],
        deleteDeployKey: ["DELETE /repos/{owner}/{repo}/keys/{key_id}"],
        deleteDeployment: [
          "DELETE /repos/{owner}/{repo}/deployments/{deployment_id}"
        ],
        deleteFile: ["DELETE /repos/{owner}/{repo}/contents/{path}"],
        deleteInvitation: [
          "DELETE /repos/{owner}/{repo}/invitations/{invitation_id}"
        ],
        deletePagesSite: ["DELETE /repos/{owner}/{repo}/pages"],
        deletePullRequestReviewProtection: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews"
        ],
        deleteRelease: ["DELETE /repos/{owner}/{repo}/releases/{release_id}"],
        deleteReleaseAsset: [
          "DELETE /repos/{owner}/{repo}/releases/assets/{asset_id}"
        ],
        deleteTagProtection: [
          "DELETE /repos/{owner}/{repo}/tags/protection/{tag_protection_id}"
        ],
        deleteWebhook: ["DELETE /repos/{owner}/{repo}/hooks/{hook_id}"],
        disableAutomatedSecurityFixes: [
          "DELETE /repos/{owner}/{repo}/automated-security-fixes"
        ],
        disableLfsForRepo: ["DELETE /repos/{owner}/{repo}/lfs"],
        disableVulnerabilityAlerts: [
          "DELETE /repos/{owner}/{repo}/vulnerability-alerts"
        ],
        downloadArchive: [
          "GET /repos/{owner}/{repo}/zipball/{ref}",
          {},
          { renamed: ["repos", "downloadZipballArchive"] }
        ],
        downloadTarballArchive: ["GET /repos/{owner}/{repo}/tarball/{ref}"],
        downloadZipballArchive: ["GET /repos/{owner}/{repo}/zipball/{ref}"],
        enableAutomatedSecurityFixes: [
          "PUT /repos/{owner}/{repo}/automated-security-fixes"
        ],
        enableLfsForRepo: ["PUT /repos/{owner}/{repo}/lfs"],
        enableVulnerabilityAlerts: [
          "PUT /repos/{owner}/{repo}/vulnerability-alerts"
        ],
        generateReleaseNotes: [
          "POST /repos/{owner}/{repo}/releases/generate-notes"
        ],
        get: ["GET /repos/{owner}/{repo}"],
        getAccessRestrictions: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/restrictions"
        ],
        getAdminBranchProtection: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins"
        ],
        getAllEnvironments: ["GET /repos/{owner}/{repo}/environments"],
        getAllStatusCheckContexts: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts"
        ],
        getAllTopics: ["GET /repos/{owner}/{repo}/topics"],
        getAppsWithAccessToProtectedBranch: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps"
        ],
        getAutolink: ["GET /repos/{owner}/{repo}/autolinks/{autolink_id}"],
        getBranch: ["GET /repos/{owner}/{repo}/branches/{branch}"],
        getBranchProtection: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection"
        ],
        getClones: ["GET /repos/{owner}/{repo}/traffic/clones"],
        getCodeFrequencyStats: ["GET /repos/{owner}/{repo}/stats/code_frequency"],
        getCollaboratorPermissionLevel: [
          "GET /repos/{owner}/{repo}/collaborators/{username}/permission"
        ],
        getCombinedStatusForRef: ["GET /repos/{owner}/{repo}/commits/{ref}/status"],
        getCommit: ["GET /repos/{owner}/{repo}/commits/{ref}"],
        getCommitActivityStats: ["GET /repos/{owner}/{repo}/stats/commit_activity"],
        getCommitComment: ["GET /repos/{owner}/{repo}/comments/{comment_id}"],
        getCommitSignatureProtection: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/required_signatures"
        ],
        getCommunityProfileMetrics: ["GET /repos/{owner}/{repo}/community/profile"],
        getContent: ["GET /repos/{owner}/{repo}/contents/{path}"],
        getContributorsStats: ["GET /repos/{owner}/{repo}/stats/contributors"],
        getDeployKey: ["GET /repos/{owner}/{repo}/keys/{key_id}"],
        getDeployment: ["GET /repos/{owner}/{repo}/deployments/{deployment_id}"],
        getDeploymentStatus: [
          "GET /repos/{owner}/{repo}/deployments/{deployment_id}/statuses/{status_id}"
        ],
        getEnvironment: [
          "GET /repos/{owner}/{repo}/environments/{environment_name}"
        ],
        getLatestPagesBuild: ["GET /repos/{owner}/{repo}/pages/builds/latest"],
        getLatestRelease: ["GET /repos/{owner}/{repo}/releases/latest"],
        getPages: ["GET /repos/{owner}/{repo}/pages"],
        getPagesBuild: ["GET /repos/{owner}/{repo}/pages/builds/{build_id}"],
        getPagesHealthCheck: ["GET /repos/{owner}/{repo}/pages/health"],
        getParticipationStats: ["GET /repos/{owner}/{repo}/stats/participation"],
        getPullRequestReviewProtection: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews"
        ],
        getPunchCardStats: ["GET /repos/{owner}/{repo}/stats/punch_card"],
        getReadme: ["GET /repos/{owner}/{repo}/readme"],
        getReadmeInDirectory: ["GET /repos/{owner}/{repo}/readme/{dir}"],
        getRelease: ["GET /repos/{owner}/{repo}/releases/{release_id}"],
        getReleaseAsset: ["GET /repos/{owner}/{repo}/releases/assets/{asset_id}"],
        getReleaseByTag: ["GET /repos/{owner}/{repo}/releases/tags/{tag}"],
        getStatusChecksProtection: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks"
        ],
        getTeamsWithAccessToProtectedBranch: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams"
        ],
        getTopPaths: ["GET /repos/{owner}/{repo}/traffic/popular/paths"],
        getTopReferrers: ["GET /repos/{owner}/{repo}/traffic/popular/referrers"],
        getUsersWithAccessToProtectedBranch: [
          "GET /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users"
        ],
        getViews: ["GET /repos/{owner}/{repo}/traffic/views"],
        getWebhook: ["GET /repos/{owner}/{repo}/hooks/{hook_id}"],
        getWebhookConfigForRepo: [
          "GET /repos/{owner}/{repo}/hooks/{hook_id}/config"
        ],
        getWebhookDelivery: [
          "GET /repos/{owner}/{repo}/hooks/{hook_id}/deliveries/{delivery_id}"
        ],
        listAutolinks: ["GET /repos/{owner}/{repo}/autolinks"],
        listBranches: ["GET /repos/{owner}/{repo}/branches"],
        listBranchesForHeadCommit: [
          "GET /repos/{owner}/{repo}/commits/{commit_sha}/branches-where-head"
        ],
        listCollaborators: ["GET /repos/{owner}/{repo}/collaborators"],
        listCommentsForCommit: [
          "GET /repos/{owner}/{repo}/commits/{commit_sha}/comments"
        ],
        listCommitCommentsForRepo: ["GET /repos/{owner}/{repo}/comments"],
        listCommitStatusesForRef: [
          "GET /repos/{owner}/{repo}/commits/{ref}/statuses"
        ],
        listCommits: ["GET /repos/{owner}/{repo}/commits"],
        listContributors: ["GET /repos/{owner}/{repo}/contributors"],
        listDeployKeys: ["GET /repos/{owner}/{repo}/keys"],
        listDeploymentStatuses: [
          "GET /repos/{owner}/{repo}/deployments/{deployment_id}/statuses"
        ],
        listDeployments: ["GET /repos/{owner}/{repo}/deployments"],
        listForAuthenticatedUser: ["GET /user/repos"],
        listForOrg: ["GET /orgs/{org}/repos"],
        listForUser: ["GET /users/{username}/repos"],
        listForks: ["GET /repos/{owner}/{repo}/forks"],
        listInvitations: ["GET /repos/{owner}/{repo}/invitations"],
        listInvitationsForAuthenticatedUser: ["GET /user/repository_invitations"],
        listLanguages: ["GET /repos/{owner}/{repo}/languages"],
        listPagesBuilds: ["GET /repos/{owner}/{repo}/pages/builds"],
        listPublic: ["GET /repositories"],
        listPullRequestsAssociatedWithCommit: [
          "GET /repos/{owner}/{repo}/commits/{commit_sha}/pulls"
        ],
        listReleaseAssets: [
          "GET /repos/{owner}/{repo}/releases/{release_id}/assets"
        ],
        listReleases: ["GET /repos/{owner}/{repo}/releases"],
        listTagProtection: ["GET /repos/{owner}/{repo}/tags/protection"],
        listTags: ["GET /repos/{owner}/{repo}/tags"],
        listTeams: ["GET /repos/{owner}/{repo}/teams"],
        listWebhookDeliveries: [
          "GET /repos/{owner}/{repo}/hooks/{hook_id}/deliveries"
        ],
        listWebhooks: ["GET /repos/{owner}/{repo}/hooks"],
        merge: ["POST /repos/{owner}/{repo}/merges"],
        mergeUpstream: ["POST /repos/{owner}/{repo}/merge-upstream"],
        pingWebhook: ["POST /repos/{owner}/{repo}/hooks/{hook_id}/pings"],
        redeliverWebhookDelivery: [
          "POST /repos/{owner}/{repo}/hooks/{hook_id}/deliveries/{delivery_id}/attempts"
        ],
        removeAppAccessRestrictions: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps",
          {},
          { mapToData: "apps" }
        ],
        removeCollaborator: [
          "DELETE /repos/{owner}/{repo}/collaborators/{username}"
        ],
        removeStatusCheckContexts: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts",
          {},
          { mapToData: "contexts" }
        ],
        removeStatusCheckProtection: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks"
        ],
        removeTeamAccessRestrictions: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams",
          {},
          { mapToData: "teams" }
        ],
        removeUserAccessRestrictions: [
          "DELETE /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users",
          {},
          { mapToData: "users" }
        ],
        renameBranch: ["POST /repos/{owner}/{repo}/branches/{branch}/rename"],
        replaceAllTopics: ["PUT /repos/{owner}/{repo}/topics"],
        requestPagesBuild: ["POST /repos/{owner}/{repo}/pages/builds"],
        setAdminBranchProtection: [
          "POST /repos/{owner}/{repo}/branches/{branch}/protection/enforce_admins"
        ],
        setAppAccessRestrictions: [
          "PUT /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/apps",
          {},
          { mapToData: "apps" }
        ],
        setStatusCheckContexts: [
          "PUT /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks/contexts",
          {},
          { mapToData: "contexts" }
        ],
        setTeamAccessRestrictions: [
          "PUT /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/teams",
          {},
          { mapToData: "teams" }
        ],
        setUserAccessRestrictions: [
          "PUT /repos/{owner}/{repo}/branches/{branch}/protection/restrictions/users",
          {},
          { mapToData: "users" }
        ],
        testPushWebhook: ["POST /repos/{owner}/{repo}/hooks/{hook_id}/tests"],
        transfer: ["POST /repos/{owner}/{repo}/transfer"],
        update: ["PATCH /repos/{owner}/{repo}"],
        updateBranchProtection: [
          "PUT /repos/{owner}/{repo}/branches/{branch}/protection"
        ],
        updateCommitComment: ["PATCH /repos/{owner}/{repo}/comments/{comment_id}"],
        updateInformationAboutPagesSite: ["PUT /repos/{owner}/{repo}/pages"],
        updateInvitation: [
          "PATCH /repos/{owner}/{repo}/invitations/{invitation_id}"
        ],
        updatePullRequestReviewProtection: [
          "PATCH /repos/{owner}/{repo}/branches/{branch}/protection/required_pull_request_reviews"
        ],
        updateRelease: ["PATCH /repos/{owner}/{repo}/releases/{release_id}"],
        updateReleaseAsset: [
          "PATCH /repos/{owner}/{repo}/releases/assets/{asset_id}"
        ],
        updateStatusCheckPotection: [
          "PATCH /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks",
          {},
          { renamed: ["repos", "updateStatusCheckProtection"] }
        ],
        updateStatusCheckProtection: [
          "PATCH /repos/{owner}/{repo}/branches/{branch}/protection/required_status_checks"
        ],
        updateWebhook: ["PATCH /repos/{owner}/{repo}/hooks/{hook_id}"],
        updateWebhookConfigForRepo: [
          "PATCH /repos/{owner}/{repo}/hooks/{hook_id}/config"
        ],
        uploadReleaseAsset: [
          "POST /repos/{owner}/{repo}/releases/{release_id}/assets{?name,label}",
          { baseUrl: "https://uploads.github.com" }
        ]
      },
      search: {
        code: ["GET /search/code"],
        commits: ["GET /search/commits"],
        issuesAndPullRequests: ["GET /search/issues"],
        labels: ["GET /search/labels"],
        repos: ["GET /search/repositories"],
        topics: ["GET /search/topics"],
        users: ["GET /search/users"]
      },
      secretScanning: {
        getAlert: [
          "GET /repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}"
        ],
        listAlertsForEnterprise: [
          "GET /enterprises/{enterprise}/secret-scanning/alerts"
        ],
        listAlertsForOrg: ["GET /orgs/{org}/secret-scanning/alerts"],
        listAlertsForRepo: ["GET /repos/{owner}/{repo}/secret-scanning/alerts"],
        listLocationsForAlert: [
          "GET /repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}/locations"
        ],
        updateAlert: [
          "PATCH /repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}"
        ]
      },
      teams: {
        addOrUpdateMembershipForUserInOrg: [
          "PUT /orgs/{org}/teams/{team_slug}/memberships/{username}"
        ],
        addOrUpdateProjectPermissionsInOrg: [
          "PUT /orgs/{org}/teams/{team_slug}/projects/{project_id}"
        ],
        addOrUpdateRepoPermissionsInOrg: [
          "PUT /orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}"
        ],
        checkPermissionsForProjectInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/projects/{project_id}"
        ],
        checkPermissionsForRepoInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}"
        ],
        create: ["POST /orgs/{org}/teams"],
        createDiscussionCommentInOrg: [
          "POST /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments"
        ],
        createDiscussionInOrg: ["POST /orgs/{org}/teams/{team_slug}/discussions"],
        deleteDiscussionCommentInOrg: [
          "DELETE /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}"
        ],
        deleteDiscussionInOrg: [
          "DELETE /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}"
        ],
        deleteInOrg: ["DELETE /orgs/{org}/teams/{team_slug}"],
        getByName: ["GET /orgs/{org}/teams/{team_slug}"],
        getDiscussionCommentInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}"
        ],
        getDiscussionInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}"
        ],
        getMembershipForUserInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/memberships/{username}"
        ],
        list: ["GET /orgs/{org}/teams"],
        listChildInOrg: ["GET /orgs/{org}/teams/{team_slug}/teams"],
        listDiscussionCommentsInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments"
        ],
        listDiscussionsInOrg: ["GET /orgs/{org}/teams/{team_slug}/discussions"],
        listForAuthenticatedUser: ["GET /user/teams"],
        listMembersInOrg: ["GET /orgs/{org}/teams/{team_slug}/members"],
        listPendingInvitationsInOrg: [
          "GET /orgs/{org}/teams/{team_slug}/invitations"
        ],
        listProjectsInOrg: ["GET /orgs/{org}/teams/{team_slug}/projects"],
        listReposInOrg: ["GET /orgs/{org}/teams/{team_slug}/repos"],
        removeMembershipForUserInOrg: [
          "DELETE /orgs/{org}/teams/{team_slug}/memberships/{username}"
        ],
        removeProjectInOrg: [
          "DELETE /orgs/{org}/teams/{team_slug}/projects/{project_id}"
        ],
        removeRepoInOrg: [
          "DELETE /orgs/{org}/teams/{team_slug}/repos/{owner}/{repo}"
        ],
        updateDiscussionCommentInOrg: [
          "PATCH /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}"
        ],
        updateDiscussionInOrg: [
          "PATCH /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}"
        ],
        updateInOrg: ["PATCH /orgs/{org}/teams/{team_slug}"]
      },
      users: {
        addEmailForAuthenticated: [
          "POST /user/emails",
          {},
          { renamed: ["users", "addEmailForAuthenticatedUser"] }
        ],
        addEmailForAuthenticatedUser: ["POST /user/emails"],
        block: ["PUT /user/blocks/{username}"],
        checkBlocked: ["GET /user/blocks/{username}"],
        checkFollowingForUser: ["GET /users/{username}/following/{target_user}"],
        checkPersonIsFollowedByAuthenticated: ["GET /user/following/{username}"],
        createGpgKeyForAuthenticated: [
          "POST /user/gpg_keys",
          {},
          { renamed: ["users", "createGpgKeyForAuthenticatedUser"] }
        ],
        createGpgKeyForAuthenticatedUser: ["POST /user/gpg_keys"],
        createPublicSshKeyForAuthenticated: [
          "POST /user/keys",
          {},
          { renamed: ["users", "createPublicSshKeyForAuthenticatedUser"] }
        ],
        createPublicSshKeyForAuthenticatedUser: ["POST /user/keys"],
        deleteEmailForAuthenticated: [
          "DELETE /user/emails",
          {},
          { renamed: ["users", "deleteEmailForAuthenticatedUser"] }
        ],
        deleteEmailForAuthenticatedUser: ["DELETE /user/emails"],
        deleteGpgKeyForAuthenticated: [
          "DELETE /user/gpg_keys/{gpg_key_id}",
          {},
          { renamed: ["users", "deleteGpgKeyForAuthenticatedUser"] }
        ],
        deleteGpgKeyForAuthenticatedUser: ["DELETE /user/gpg_keys/{gpg_key_id}"],
        deletePublicSshKeyForAuthenticated: [
          "DELETE /user/keys/{key_id}",
          {},
          { renamed: ["users", "deletePublicSshKeyForAuthenticatedUser"] }
        ],
        deletePublicSshKeyForAuthenticatedUser: ["DELETE /user/keys/{key_id}"],
        follow: ["PUT /user/following/{username}"],
        getAuthenticated: ["GET /user"],
        getByUsername: ["GET /users/{username}"],
        getContextForUser: ["GET /users/{username}/hovercard"],
        getGpgKeyForAuthenticated: [
          "GET /user/gpg_keys/{gpg_key_id}",
          {},
          { renamed: ["users", "getGpgKeyForAuthenticatedUser"] }
        ],
        getGpgKeyForAuthenticatedUser: ["GET /user/gpg_keys/{gpg_key_id}"],
        getPublicSshKeyForAuthenticated: [
          "GET /user/keys/{key_id}",
          {},
          { renamed: ["users", "getPublicSshKeyForAuthenticatedUser"] }
        ],
        getPublicSshKeyForAuthenticatedUser: ["GET /user/keys/{key_id}"],
        list: ["GET /users"],
        listBlockedByAuthenticated: [
          "GET /user/blocks",
          {},
          { renamed: ["users", "listBlockedByAuthenticatedUser"] }
        ],
        listBlockedByAuthenticatedUser: ["GET /user/blocks"],
        listEmailsForAuthenticated: [
          "GET /user/emails",
          {},
          { renamed: ["users", "listEmailsForAuthenticatedUser"] }
        ],
        listEmailsForAuthenticatedUser: ["GET /user/emails"],
        listFollowedByAuthenticated: [
          "GET /user/following",
          {},
          { renamed: ["users", "listFollowedByAuthenticatedUser"] }
        ],
        listFollowedByAuthenticatedUser: ["GET /user/following"],
        listFollowersForAuthenticatedUser: ["GET /user/followers"],
        listFollowersForUser: ["GET /users/{username}/followers"],
        listFollowingForUser: ["GET /users/{username}/following"],
        listGpgKeysForAuthenticated: [
          "GET /user/gpg_keys",
          {},
          { renamed: ["users", "listGpgKeysForAuthenticatedUser"] }
        ],
        listGpgKeysForAuthenticatedUser: ["GET /user/gpg_keys"],
        listGpgKeysForUser: ["GET /users/{username}/gpg_keys"],
        listPublicEmailsForAuthenticated: [
          "GET /user/public_emails",
          {},
          { renamed: ["users", "listPublicEmailsForAuthenticatedUser"] }
        ],
        listPublicEmailsForAuthenticatedUser: ["GET /user/public_emails"],
        listPublicKeysForUser: ["GET /users/{username}/keys"],
        listPublicSshKeysForAuthenticated: [
          "GET /user/keys",
          {},
          { renamed: ["users", "listPublicSshKeysForAuthenticatedUser"] }
        ],
        listPublicSshKeysForAuthenticatedUser: ["GET /user/keys"],
        setPrimaryEmailVisibilityForAuthenticated: [
          "PATCH /user/email/visibility",
          {},
          { renamed: ["users", "setPrimaryEmailVisibilityForAuthenticatedUser"] }
        ],
        setPrimaryEmailVisibilityForAuthenticatedUser: [
          "PATCH /user/email/visibility"
        ],
        unblock: ["DELETE /user/blocks/{username}"],
        unfollow: ["DELETE /user/following/{username}"],
        updateAuthenticated: ["PATCH /user"]
      }
    };
    VERSION5 = "5.16.2";
    restEndpointMethods.VERSION = VERSION5;
    legacyRestEndpointMethods.VERSION = VERSION5;
  }
});

// node_modules/@octokit/plugin-paginate-rest/dist-web/index.js
var dist_web_exports3 = {};
__export(dist_web_exports3, {
  composePaginateRest: () => composePaginateRest,
  isPaginatingEndpoint: () => isPaginatingEndpoint,
  paginateRest: () => paginateRest,
  paginatingEndpoints: () => paginatingEndpoints
});
function normalizePaginatedListResponse(response) {
  if (!response.data) {
    return {
      ...response,
      data: []
    };
  }
  const responseNeedsNormalization = "total_count" in response.data && !("url" in response.data);
  if (!responseNeedsNormalization)
    return response;
  const incompleteResults = response.data.incomplete_results;
  const repositorySelection = response.data.repository_selection;
  const totalCount = response.data.total_count;
  delete response.data.incomplete_results;
  delete response.data.repository_selection;
  delete response.data.total_count;
  const namespaceKey = Object.keys(response.data)[0];
  const data = response.data[namespaceKey];
  response.data = data;
  if (typeof incompleteResults !== "undefined") {
    response.data.incomplete_results = incompleteResults;
  }
  if (typeof repositorySelection !== "undefined") {
    response.data.repository_selection = repositorySelection;
  }
  response.data.total_count = totalCount;
  return response;
}
function iterator(octokit, route, parameters) {
  const options = typeof route === "function" ? route.endpoint(parameters) : octokit.request.endpoint(route, parameters);
  const requestMethod = typeof route === "function" ? route : octokit.request;
  const method = options.method;
  const headers = options.headers;
  let url = options.url;
  return {
    [Symbol.asyncIterator]: () => ({
      async next() {
        if (!url)
          return { done: true };
        try {
          const response = await requestMethod({ method, url, headers });
          const normalizedResponse = normalizePaginatedListResponse(response);
          url = ((normalizedResponse.headers.link || "").match(/<([^>]+)>;\s*rel="next"/) || [])[1];
          return { value: normalizedResponse };
        } catch (error) {
          if (error.status !== 409)
            throw error;
          url = "";
          return {
            value: {
              status: 200,
              headers: {},
              data: []
            }
          };
        }
      }
    })
  };
}
function paginate(octokit, route, parameters, mapFn) {
  if (typeof parameters === "function") {
    mapFn = parameters;
    parameters = void 0;
  }
  return gather(octokit, [], iterator(octokit, route, parameters)[Symbol.asyncIterator](), mapFn);
}
function gather(octokit, results, iterator2, mapFn) {
  return iterator2.next().then((result) => {
    if (result.done) {
      return results;
    }
    let earlyExit = false;
    function done() {
      earlyExit = true;
    }
    results = results.concat(mapFn ? mapFn(result.value, done) : result.value.data);
    if (earlyExit) {
      return results;
    }
    return gather(octokit, results, iterator2, mapFn);
  });
}
function isPaginatingEndpoint(arg) {
  if (typeof arg === "string") {
    return paginatingEndpoints.includes(arg);
  } else {
    return false;
  }
}
function paginateRest(octokit) {
  return {
    paginate: Object.assign(paginate.bind(null, octokit), {
      iterator: iterator.bind(null, octokit)
    })
  };
}
var VERSION6, composePaginateRest, paginatingEndpoints;
var init_dist_web11 = __esm({
  "node_modules/@octokit/plugin-paginate-rest/dist-web/index.js"() {
    VERSION6 = "2.21.3";
    composePaginateRest = Object.assign(paginate, {
      iterator
    });
    paginatingEndpoints = [
      "GET /app/hook/deliveries",
      "GET /app/installations",
      "GET /applications/grants",
      "GET /authorizations",
      "GET /enterprises/{enterprise}/actions/permissions/organizations",
      "GET /enterprises/{enterprise}/actions/runner-groups",
      "GET /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/organizations",
      "GET /enterprises/{enterprise}/actions/runner-groups/{runner_group_id}/runners",
      "GET /enterprises/{enterprise}/actions/runners",
      "GET /enterprises/{enterprise}/audit-log",
      "GET /enterprises/{enterprise}/secret-scanning/alerts",
      "GET /enterprises/{enterprise}/settings/billing/advanced-security",
      "GET /events",
      "GET /gists",
      "GET /gists/public",
      "GET /gists/starred",
      "GET /gists/{gist_id}/comments",
      "GET /gists/{gist_id}/commits",
      "GET /gists/{gist_id}/forks",
      "GET /installation/repositories",
      "GET /issues",
      "GET /licenses",
      "GET /marketplace_listing/plans",
      "GET /marketplace_listing/plans/{plan_id}/accounts",
      "GET /marketplace_listing/stubbed/plans",
      "GET /marketplace_listing/stubbed/plans/{plan_id}/accounts",
      "GET /networks/{owner}/{repo}/events",
      "GET /notifications",
      "GET /organizations",
      "GET /orgs/{org}/actions/cache/usage-by-repository",
      "GET /orgs/{org}/actions/permissions/repositories",
      "GET /orgs/{org}/actions/runner-groups",
      "GET /orgs/{org}/actions/runner-groups/{runner_group_id}/repositories",
      "GET /orgs/{org}/actions/runner-groups/{runner_group_id}/runners",
      "GET /orgs/{org}/actions/runners",
      "GET /orgs/{org}/actions/secrets",
      "GET /orgs/{org}/actions/secrets/{secret_name}/repositories",
      "GET /orgs/{org}/audit-log",
      "GET /orgs/{org}/blocks",
      "GET /orgs/{org}/code-scanning/alerts",
      "GET /orgs/{org}/codespaces",
      "GET /orgs/{org}/credential-authorizations",
      "GET /orgs/{org}/dependabot/secrets",
      "GET /orgs/{org}/dependabot/secrets/{secret_name}/repositories",
      "GET /orgs/{org}/events",
      "GET /orgs/{org}/external-groups",
      "GET /orgs/{org}/failed_invitations",
      "GET /orgs/{org}/hooks",
      "GET /orgs/{org}/hooks/{hook_id}/deliveries",
      "GET /orgs/{org}/installations",
      "GET /orgs/{org}/invitations",
      "GET /orgs/{org}/invitations/{invitation_id}/teams",
      "GET /orgs/{org}/issues",
      "GET /orgs/{org}/members",
      "GET /orgs/{org}/migrations",
      "GET /orgs/{org}/migrations/{migration_id}/repositories",
      "GET /orgs/{org}/outside_collaborators",
      "GET /orgs/{org}/packages",
      "GET /orgs/{org}/packages/{package_type}/{package_name}/versions",
      "GET /orgs/{org}/projects",
      "GET /orgs/{org}/public_members",
      "GET /orgs/{org}/repos",
      "GET /orgs/{org}/secret-scanning/alerts",
      "GET /orgs/{org}/settings/billing/advanced-security",
      "GET /orgs/{org}/team-sync/groups",
      "GET /orgs/{org}/teams",
      "GET /orgs/{org}/teams/{team_slug}/discussions",
      "GET /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments",
      "GET /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/comments/{comment_number}/reactions",
      "GET /orgs/{org}/teams/{team_slug}/discussions/{discussion_number}/reactions",
      "GET /orgs/{org}/teams/{team_slug}/invitations",
      "GET /orgs/{org}/teams/{team_slug}/members",
      "GET /orgs/{org}/teams/{team_slug}/projects",
      "GET /orgs/{org}/teams/{team_slug}/repos",
      "GET /orgs/{org}/teams/{team_slug}/teams",
      "GET /projects/columns/{column_id}/cards",
      "GET /projects/{project_id}/collaborators",
      "GET /projects/{project_id}/columns",
      "GET /repos/{owner}/{repo}/actions/artifacts",
      "GET /repos/{owner}/{repo}/actions/caches",
      "GET /repos/{owner}/{repo}/actions/runners",
      "GET /repos/{owner}/{repo}/actions/runs",
      "GET /repos/{owner}/{repo}/actions/runs/{run_id}/artifacts",
      "GET /repos/{owner}/{repo}/actions/runs/{run_id}/attempts/{attempt_number}/jobs",
      "GET /repos/{owner}/{repo}/actions/runs/{run_id}/jobs",
      "GET /repos/{owner}/{repo}/actions/secrets",
      "GET /repos/{owner}/{repo}/actions/workflows",
      "GET /repos/{owner}/{repo}/actions/workflows/{workflow_id}/runs",
      "GET /repos/{owner}/{repo}/assignees",
      "GET /repos/{owner}/{repo}/branches",
      "GET /repos/{owner}/{repo}/check-runs/{check_run_id}/annotations",
      "GET /repos/{owner}/{repo}/check-suites/{check_suite_id}/check-runs",
      "GET /repos/{owner}/{repo}/code-scanning/alerts",
      "GET /repos/{owner}/{repo}/code-scanning/alerts/{alert_number}/instances",
      "GET /repos/{owner}/{repo}/code-scanning/analyses",
      "GET /repos/{owner}/{repo}/codespaces",
      "GET /repos/{owner}/{repo}/codespaces/devcontainers",
      "GET /repos/{owner}/{repo}/codespaces/secrets",
      "GET /repos/{owner}/{repo}/collaborators",
      "GET /repos/{owner}/{repo}/comments",
      "GET /repos/{owner}/{repo}/comments/{comment_id}/reactions",
      "GET /repos/{owner}/{repo}/commits",
      "GET /repos/{owner}/{repo}/commits/{commit_sha}/comments",
      "GET /repos/{owner}/{repo}/commits/{commit_sha}/pulls",
      "GET /repos/{owner}/{repo}/commits/{ref}/check-runs",
      "GET /repos/{owner}/{repo}/commits/{ref}/check-suites",
      "GET /repos/{owner}/{repo}/commits/{ref}/status",
      "GET /repos/{owner}/{repo}/commits/{ref}/statuses",
      "GET /repos/{owner}/{repo}/contributors",
      "GET /repos/{owner}/{repo}/dependabot/secrets",
      "GET /repos/{owner}/{repo}/deployments",
      "GET /repos/{owner}/{repo}/deployments/{deployment_id}/statuses",
      "GET /repos/{owner}/{repo}/environments",
      "GET /repos/{owner}/{repo}/events",
      "GET /repos/{owner}/{repo}/forks",
      "GET /repos/{owner}/{repo}/git/matching-refs/{ref}",
      "GET /repos/{owner}/{repo}/hooks",
      "GET /repos/{owner}/{repo}/hooks/{hook_id}/deliveries",
      "GET /repos/{owner}/{repo}/invitations",
      "GET /repos/{owner}/{repo}/issues",
      "GET /repos/{owner}/{repo}/issues/comments",
      "GET /repos/{owner}/{repo}/issues/comments/{comment_id}/reactions",
      "GET /repos/{owner}/{repo}/issues/events",
      "GET /repos/{owner}/{repo}/issues/{issue_number}/comments",
      "GET /repos/{owner}/{repo}/issues/{issue_number}/events",
      "GET /repos/{owner}/{repo}/issues/{issue_number}/labels",
      "GET /repos/{owner}/{repo}/issues/{issue_number}/reactions",
      "GET /repos/{owner}/{repo}/issues/{issue_number}/timeline",
      "GET /repos/{owner}/{repo}/keys",
      "GET /repos/{owner}/{repo}/labels",
      "GET /repos/{owner}/{repo}/milestones",
      "GET /repos/{owner}/{repo}/milestones/{milestone_number}/labels",
      "GET /repos/{owner}/{repo}/notifications",
      "GET /repos/{owner}/{repo}/pages/builds",
      "GET /repos/{owner}/{repo}/projects",
      "GET /repos/{owner}/{repo}/pulls",
      "GET /repos/{owner}/{repo}/pulls/comments",
      "GET /repos/{owner}/{repo}/pulls/comments/{comment_id}/reactions",
      "GET /repos/{owner}/{repo}/pulls/{pull_number}/comments",
      "GET /repos/{owner}/{repo}/pulls/{pull_number}/commits",
      "GET /repos/{owner}/{repo}/pulls/{pull_number}/files",
      "GET /repos/{owner}/{repo}/pulls/{pull_number}/requested_reviewers",
      "GET /repos/{owner}/{repo}/pulls/{pull_number}/reviews",
      "GET /repos/{owner}/{repo}/pulls/{pull_number}/reviews/{review_id}/comments",
      "GET /repos/{owner}/{repo}/releases",
      "GET /repos/{owner}/{repo}/releases/{release_id}/assets",
      "GET /repos/{owner}/{repo}/releases/{release_id}/reactions",
      "GET /repos/{owner}/{repo}/secret-scanning/alerts",
      "GET /repos/{owner}/{repo}/secret-scanning/alerts/{alert_number}/locations",
      "GET /repos/{owner}/{repo}/stargazers",
      "GET /repos/{owner}/{repo}/subscribers",
      "GET /repos/{owner}/{repo}/tags",
      "GET /repos/{owner}/{repo}/teams",
      "GET /repos/{owner}/{repo}/topics",
      "GET /repositories",
      "GET /repositories/{repository_id}/environments/{environment_name}/secrets",
      "GET /search/code",
      "GET /search/commits",
      "GET /search/issues",
      "GET /search/labels",
      "GET /search/repositories",
      "GET /search/topics",
      "GET /search/users",
      "GET /teams/{team_id}/discussions",
      "GET /teams/{team_id}/discussions/{discussion_number}/comments",
      "GET /teams/{team_id}/discussions/{discussion_number}/comments/{comment_number}/reactions",
      "GET /teams/{team_id}/discussions/{discussion_number}/reactions",
      "GET /teams/{team_id}/invitations",
      "GET /teams/{team_id}/members",
      "GET /teams/{team_id}/projects",
      "GET /teams/{team_id}/repos",
      "GET /teams/{team_id}/teams",
      "GET /user/blocks",
      "GET /user/codespaces",
      "GET /user/codespaces/secrets",
      "GET /user/emails",
      "GET /user/followers",
      "GET /user/following",
      "GET /user/gpg_keys",
      "GET /user/installations",
      "GET /user/installations/{installation_id}/repositories",
      "GET /user/issues",
      "GET /user/keys",
      "GET /user/marketplace_purchases",
      "GET /user/marketplace_purchases/stubbed",
      "GET /user/memberships/orgs",
      "GET /user/migrations",
      "GET /user/migrations/{migration_id}/repositories",
      "GET /user/orgs",
      "GET /user/packages",
      "GET /user/packages/{package_type}/{package_name}/versions",
      "GET /user/public_emails",
      "GET /user/repos",
      "GET /user/repository_invitations",
      "GET /user/starred",
      "GET /user/subscriptions",
      "GET /user/teams",
      "GET /users",
      "GET /users/{username}/events",
      "GET /users/{username}/events/orgs/{org}",
      "GET /users/{username}/events/public",
      "GET /users/{username}/followers",
      "GET /users/{username}/following",
      "GET /users/{username}/gists",
      "GET /users/{username}/gpg_keys",
      "GET /users/{username}/keys",
      "GET /users/{username}/orgs",
      "GET /users/{username}/packages",
      "GET /users/{username}/projects",
      "GET /users/{username}/received_events",
      "GET /users/{username}/received_events/public",
      "GET /users/{username}/repos",
      "GET /users/{username}/starred",
      "GET /users/{username}/subscriptions"
    ];
    paginateRest.VERSION = VERSION6;
  }
});

// node_modules/@actions/github/lib/utils.js
var require_utils4 = __commonJS({
  "node_modules/@actions/github/lib/utils.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getOctokitOptions = exports.GitHub = exports.context = void 0;
    var Context = __importStar(require_context());
    var Utils = __importStar(require_utils2());
    var core_1 = (init_dist_web9(), __toCommonJS(dist_web_exports));
    var plugin_rest_endpoint_methods_1 = (init_dist_web10(), __toCommonJS(dist_web_exports2));
    var plugin_paginate_rest_1 = (init_dist_web11(), __toCommonJS(dist_web_exports3));
    exports.context = new Context.Context();
    var baseUrl = Utils.getApiBaseUrl();
    var defaults = {
      baseUrl,
      request: {
        agent: Utils.getProxyAgent(baseUrl)
      }
    };
    exports.GitHub = core_1.Octokit.plugin(plugin_rest_endpoint_methods_1.restEndpointMethods, plugin_paginate_rest_1.paginateRest).defaults(defaults);
    function getOctokitOptions(token, options) {
      const opts = Object.assign({}, options || {});
      const auth2 = Utils.getAuthString(token, opts);
      if (auth2) {
        opts.auth = auth2;
      }
      return opts;
    }
    exports.getOctokitOptions = getOctokitOptions;
  }
});

// node_modules/@actions/github/lib/github.js
var require_github = __commonJS({
  "node_modules/@actions/github/lib/github.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getOctokit = exports.context = void 0;
    var Context = __importStar(require_context());
    var utils_1 = require_utils4();
    exports.context = new Context.Context();
    function getOctokit(token, options) {
      return new utils_1.GitHub(utils_1.getOctokitOptions(token, options));
    }
    exports.getOctokit = getOctokit;
  }
});

// node_modules/@actions/io/lib/io-util.js
var require_io_util = __commonJS({
  "node_modules/@actions/io/lib/io-util.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    var _a4;
    Object.defineProperty(exports, "__esModule", { value: true });
    var assert_1 = require("assert");
    var fs4 = require("fs");
    var path4 = require("path");
    _a4 = fs4.promises, exports.chmod = _a4.chmod, exports.copyFile = _a4.copyFile, exports.lstat = _a4.lstat, exports.mkdir = _a4.mkdir, exports.readdir = _a4.readdir, exports.readlink = _a4.readlink, exports.rename = _a4.rename, exports.rmdir = _a4.rmdir, exports.stat = _a4.stat, exports.symlink = _a4.symlink, exports.unlink = _a4.unlink;
    exports.IS_WINDOWS = process.platform === "win32";
    function exists(fsPath) {
      return __awaiter(this, void 0, void 0, function* () {
        try {
          yield exports.stat(fsPath);
        } catch (err) {
          if (err.code === "ENOENT") {
            return false;
          }
          throw err;
        }
        return true;
      });
    }
    exports.exists = exists;
    function isDirectory(fsPath, useStat = false) {
      return __awaiter(this, void 0, void 0, function* () {
        const stats = useStat ? yield exports.stat(fsPath) : yield exports.lstat(fsPath);
        return stats.isDirectory();
      });
    }
    exports.isDirectory = isDirectory;
    function isRooted(p) {
      p = normalizeSeparators(p);
      if (!p) {
        throw new Error('isRooted() parameter "p" cannot be empty');
      }
      if (exports.IS_WINDOWS) {
        return p.startsWith("\\") || /^[A-Z]:/i.test(p);
      }
      return p.startsWith("/");
    }
    exports.isRooted = isRooted;
    function mkdirP(fsPath, maxDepth = 1e3, depth = 1) {
      return __awaiter(this, void 0, void 0, function* () {
        assert_1.ok(fsPath, "a path argument must be provided");
        fsPath = path4.resolve(fsPath);
        if (depth >= maxDepth)
          return exports.mkdir(fsPath);
        try {
          yield exports.mkdir(fsPath);
          return;
        } catch (err) {
          switch (err.code) {
            case "ENOENT": {
              yield mkdirP(path4.dirname(fsPath), maxDepth, depth + 1);
              yield exports.mkdir(fsPath);
              return;
            }
            default: {
              let stats;
              try {
                stats = yield exports.stat(fsPath);
              } catch (err2) {
                throw err;
              }
              if (!stats.isDirectory())
                throw err;
            }
          }
        }
      });
    }
    exports.mkdirP = mkdirP;
    function tryGetExecutablePath(filePath, extensions) {
      return __awaiter(this, void 0, void 0, function* () {
        let stats = void 0;
        try {
          stats = yield exports.stat(filePath);
        } catch (err) {
          if (err.code !== "ENOENT") {
            console.log(`Unexpected error attempting to determine if executable file exists '${filePath}': ${err}`);
          }
        }
        if (stats && stats.isFile()) {
          if (exports.IS_WINDOWS) {
            const upperExt = path4.extname(filePath).toUpperCase();
            if (extensions.some((validExt) => validExt.toUpperCase() === upperExt)) {
              return filePath;
            }
          } else {
            if (isUnixExecutable(stats)) {
              return filePath;
            }
          }
        }
        const originalFilePath = filePath;
        for (const extension of extensions) {
          filePath = originalFilePath + extension;
          stats = void 0;
          try {
            stats = yield exports.stat(filePath);
          } catch (err) {
            if (err.code !== "ENOENT") {
              console.log(`Unexpected error attempting to determine if executable file exists '${filePath}': ${err}`);
            }
          }
          if (stats && stats.isFile()) {
            if (exports.IS_WINDOWS) {
              try {
                const directory = path4.dirname(filePath);
                const upperName = path4.basename(filePath).toUpperCase();
                for (const actualName of yield exports.readdir(directory)) {
                  if (upperName === actualName.toUpperCase()) {
                    filePath = path4.join(directory, actualName);
                    break;
                  }
                }
              } catch (err) {
                console.log(`Unexpected error attempting to determine the actual case of the file '${filePath}': ${err}`);
              }
              return filePath;
            } else {
              if (isUnixExecutable(stats)) {
                return filePath;
              }
            }
          }
        }
        return "";
      });
    }
    exports.tryGetExecutablePath = tryGetExecutablePath;
    function normalizeSeparators(p) {
      p = p || "";
      if (exports.IS_WINDOWS) {
        p = p.replace(/\//g, "\\");
        return p.replace(/\\\\+/g, "\\");
      }
      return p.replace(/\/\/+/g, "/");
    }
    function isUnixExecutable(stats) {
      return (stats.mode & 1) > 0 || (stats.mode & 8) > 0 && stats.gid === process.getgid() || (stats.mode & 64) > 0 && stats.uid === process.getuid();
    }
  }
});

// node_modules/@actions/io/lib/io.js
var require_io = __commonJS({
  "node_modules/@actions/io/lib/io.js"(exports) {
    "use strict";
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    var childProcess = require("child_process");
    var path4 = require("path");
    var util_1 = require("util");
    var ioUtil = require_io_util();
    var exec3 = util_1.promisify(childProcess.exec);
    function cp(source, dest, options = {}) {
      return __awaiter(this, void 0, void 0, function* () {
        const { force, recursive } = readCopyOptions(options);
        const destStat = (yield ioUtil.exists(dest)) ? yield ioUtil.stat(dest) : null;
        if (destStat && destStat.isFile() && !force) {
          return;
        }
        const newDest = destStat && destStat.isDirectory() ? path4.join(dest, path4.basename(source)) : dest;
        if (!(yield ioUtil.exists(source))) {
          throw new Error(`no such file or directory: ${source}`);
        }
        const sourceStat = yield ioUtil.stat(source);
        if (sourceStat.isDirectory()) {
          if (!recursive) {
            throw new Error(`Failed to copy. ${source} is a directory, but tried to copy without recursive flag.`);
          } else {
            yield cpDirRecursive(source, newDest, 0, force);
          }
        } else {
          if (path4.relative(source, newDest) === "") {
            throw new Error(`'${newDest}' and '${source}' are the same file`);
          }
          yield copyFile(source, newDest, force);
        }
      });
    }
    exports.cp = cp;
    function mv(source, dest, options = {}) {
      return __awaiter(this, void 0, void 0, function* () {
        if (yield ioUtil.exists(dest)) {
          let destExists = true;
          if (yield ioUtil.isDirectory(dest)) {
            dest = path4.join(dest, path4.basename(source));
            destExists = yield ioUtil.exists(dest);
          }
          if (destExists) {
            if (options.force == null || options.force) {
              yield rmRF(dest);
            } else {
              throw new Error("Destination already exists");
            }
          }
        }
        yield mkdirP(path4.dirname(dest));
        yield ioUtil.rename(source, dest);
      });
    }
    exports.mv = mv;
    function rmRF(inputPath) {
      return __awaiter(this, void 0, void 0, function* () {
        if (ioUtil.IS_WINDOWS) {
          try {
            if (yield ioUtil.isDirectory(inputPath, true)) {
              yield exec3(`rd /s /q "${inputPath}"`);
            } else {
              yield exec3(`del /f /a "${inputPath}"`);
            }
          } catch (err) {
            if (err.code !== "ENOENT")
              throw err;
          }
          try {
            yield ioUtil.unlink(inputPath);
          } catch (err) {
            if (err.code !== "ENOENT")
              throw err;
          }
        } else {
          let isDir = false;
          try {
            isDir = yield ioUtil.isDirectory(inputPath);
          } catch (err) {
            if (err.code !== "ENOENT")
              throw err;
            return;
          }
          if (isDir) {
            yield exec3(`rm -rf "${inputPath}"`);
          } else {
            yield ioUtil.unlink(inputPath);
          }
        }
      });
    }
    exports.rmRF = rmRF;
    function mkdirP(fsPath) {
      return __awaiter(this, void 0, void 0, function* () {
        yield ioUtil.mkdirP(fsPath);
      });
    }
    exports.mkdirP = mkdirP;
    function which(tool, check) {
      return __awaiter(this, void 0, void 0, function* () {
        if (!tool) {
          throw new Error("parameter 'tool' is required");
        }
        if (check) {
          const result = yield which(tool, false);
          if (!result) {
            if (ioUtil.IS_WINDOWS) {
              throw new Error(`Unable to locate executable file: ${tool}. Please verify either the file path exists or the file can be found within a directory specified by the PATH environment variable. Also verify the file has a valid extension for an executable file.`);
            } else {
              throw new Error(`Unable to locate executable file: ${tool}. Please verify either the file path exists or the file can be found within a directory specified by the PATH environment variable. Also check the file mode to verify the file is executable.`);
            }
          }
        }
        try {
          const extensions = [];
          if (ioUtil.IS_WINDOWS && process.env.PATHEXT) {
            for (const extension of process.env.PATHEXT.split(path4.delimiter)) {
              if (extension) {
                extensions.push(extension);
              }
            }
          }
          if (ioUtil.isRooted(tool)) {
            const filePath = yield ioUtil.tryGetExecutablePath(tool, extensions);
            if (filePath) {
              return filePath;
            }
            return "";
          }
          if (tool.includes("/") || ioUtil.IS_WINDOWS && tool.includes("\\")) {
            return "";
          }
          const directories = [];
          if (process.env.PATH) {
            for (const p of process.env.PATH.split(path4.delimiter)) {
              if (p) {
                directories.push(p);
              }
            }
          }
          for (const directory of directories) {
            const filePath = yield ioUtil.tryGetExecutablePath(directory + path4.sep + tool, extensions);
            if (filePath) {
              return filePath;
            }
          }
          return "";
        } catch (err) {
          throw new Error(`which failed with message ${err.message}`);
        }
      });
    }
    exports.which = which;
    function readCopyOptions(options) {
      const force = options.force == null ? true : options.force;
      const recursive = Boolean(options.recursive);
      return { force, recursive };
    }
    function cpDirRecursive(sourceDir, destDir, currentDepth, force) {
      return __awaiter(this, void 0, void 0, function* () {
        if (currentDepth >= 255)
          return;
        currentDepth++;
        yield mkdirP(destDir);
        const files = yield ioUtil.readdir(sourceDir);
        for (const fileName of files) {
          const srcFile = `${sourceDir}/${fileName}`;
          const destFile = `${destDir}/${fileName}`;
          const srcFileStat = yield ioUtil.lstat(srcFile);
          if (srcFileStat.isDirectory()) {
            yield cpDirRecursive(srcFile, destFile, currentDepth, force);
          } else {
            yield copyFile(srcFile, destFile, force);
          }
        }
        yield ioUtil.chmod(destDir, (yield ioUtil.stat(sourceDir)).mode);
      });
    }
    function copyFile(srcFile, destFile, force) {
      return __awaiter(this, void 0, void 0, function* () {
        if ((yield ioUtil.lstat(srcFile)).isSymbolicLink()) {
          try {
            yield ioUtil.lstat(destFile);
            yield ioUtil.unlink(destFile);
          } catch (e2) {
            if (e2.code === "EPERM") {
              yield ioUtil.chmod(destFile, "0666");
              yield ioUtil.unlink(destFile);
            }
          }
          const symlinkFull = yield ioUtil.readlink(srcFile);
          yield ioUtil.symlink(symlinkFull, destFile, ioUtil.IS_WINDOWS ? "junction" : null);
        } else if (!(yield ioUtil.exists(destFile)) || force) {
          yield ioUtil.copyFile(srcFile, destFile);
        }
      });
    }
  }
});

// node_modules/@actions/exec/lib/toolrunner.js
var require_toolrunner = __commonJS({
  "node_modules/@actions/exec/lib/toolrunner.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.argStringToArray = exports.ToolRunner = void 0;
    var os = __importStar(require("os"));
    var events = __importStar(require("events"));
    var child = __importStar(require("child_process"));
    var path4 = __importStar(require("path"));
    var io = __importStar(require_io());
    var ioUtil = __importStar(require_io_util());
    var timers_1 = require("timers");
    var IS_WINDOWS = process.platform === "win32";
    var ToolRunner = class extends events.EventEmitter {
      constructor(toolPath, args, options) {
        super();
        if (!toolPath) {
          throw new Error("Parameter 'toolPath' cannot be null or empty.");
        }
        this.toolPath = toolPath;
        this.args = args || [];
        this.options = options || {};
      }
      _debug(message) {
        if (this.options.listeners && this.options.listeners.debug) {
          this.options.listeners.debug(message);
        }
      }
      _getCommandString(options, noPrefix) {
        const toolPath = this._getSpawnFileName();
        const args = this._getSpawnArgs(options);
        let cmd = noPrefix ? "" : "[command]";
        if (IS_WINDOWS) {
          if (this._isCmdFile()) {
            cmd += toolPath;
            for (const a of args) {
              cmd += ` ${a}`;
            }
          } else if (options.windowsVerbatimArguments) {
            cmd += `"${toolPath}"`;
            for (const a of args) {
              cmd += ` ${a}`;
            }
          } else {
            cmd += this._windowsQuoteCmdArg(toolPath);
            for (const a of args) {
              cmd += ` ${this._windowsQuoteCmdArg(a)}`;
            }
          }
        } else {
          cmd += toolPath;
          for (const a of args) {
            cmd += ` ${a}`;
          }
        }
        return cmd;
      }
      _processLineBuffer(data, strBuffer, onLine) {
        try {
          let s2 = strBuffer + data.toString();
          let n = s2.indexOf(os.EOL);
          while (n > -1) {
            const line = s2.substring(0, n);
            onLine(line);
            s2 = s2.substring(n + os.EOL.length);
            n = s2.indexOf(os.EOL);
          }
          return s2;
        } catch (err) {
          this._debug(`error processing line. Failed with error ${err}`);
          return "";
        }
      }
      _getSpawnFileName() {
        if (IS_WINDOWS) {
          if (this._isCmdFile()) {
            return process.env["COMSPEC"] || "cmd.exe";
          }
        }
        return this.toolPath;
      }
      _getSpawnArgs(options) {
        if (IS_WINDOWS) {
          if (this._isCmdFile()) {
            let argline = `/D /S /C "${this._windowsQuoteCmdArg(this.toolPath)}`;
            for (const a of this.args) {
              argline += " ";
              argline += options.windowsVerbatimArguments ? a : this._windowsQuoteCmdArg(a);
            }
            argline += '"';
            return [argline];
          }
        }
        return this.args;
      }
      _endsWith(str, end) {
        return str.endsWith(end);
      }
      _isCmdFile() {
        const upperToolPath = this.toolPath.toUpperCase();
        return this._endsWith(upperToolPath, ".CMD") || this._endsWith(upperToolPath, ".BAT");
      }
      _windowsQuoteCmdArg(arg) {
        if (!this._isCmdFile()) {
          return this._uvQuoteCmdArg(arg);
        }
        if (!arg) {
          return '""';
        }
        const cmdSpecialChars = [
          " ",
          "	",
          "&",
          "(",
          ")",
          "[",
          "]",
          "{",
          "}",
          "^",
          "=",
          ";",
          "!",
          "'",
          "+",
          ",",
          "`",
          "~",
          "|",
          "<",
          ">",
          '"'
        ];
        let needsQuotes = false;
        for (const char of arg) {
          if (cmdSpecialChars.some((x2) => x2 === char)) {
            needsQuotes = true;
            break;
          }
        }
        if (!needsQuotes) {
          return arg;
        }
        let reverse = '"';
        let quoteHit = true;
        for (let i2 = arg.length; i2 > 0; i2--) {
          reverse += arg[i2 - 1];
          if (quoteHit && arg[i2 - 1] === "\\") {
            reverse += "\\";
          } else if (arg[i2 - 1] === '"') {
            quoteHit = true;
            reverse += '"';
          } else {
            quoteHit = false;
          }
        }
        reverse += '"';
        return reverse.split("").reverse().join("");
      }
      _uvQuoteCmdArg(arg) {
        if (!arg) {
          return '""';
        }
        if (!arg.includes(" ") && !arg.includes("	") && !arg.includes('"')) {
          return arg;
        }
        if (!arg.includes('"') && !arg.includes("\\")) {
          return `"${arg}"`;
        }
        let reverse = '"';
        let quoteHit = true;
        for (let i2 = arg.length; i2 > 0; i2--) {
          reverse += arg[i2 - 1];
          if (quoteHit && arg[i2 - 1] === "\\") {
            reverse += "\\";
          } else if (arg[i2 - 1] === '"') {
            quoteHit = true;
            reverse += "\\";
          } else {
            quoteHit = false;
          }
        }
        reverse += '"';
        return reverse.split("").reverse().join("");
      }
      _cloneExecOptions(options) {
        options = options || {};
        const result = {
          cwd: options.cwd || process.cwd(),
          env: options.env || process.env,
          silent: options.silent || false,
          windowsVerbatimArguments: options.windowsVerbatimArguments || false,
          failOnStdErr: options.failOnStdErr || false,
          ignoreReturnCode: options.ignoreReturnCode || false,
          delay: options.delay || 1e4
        };
        result.outStream = options.outStream || process.stdout;
        result.errStream = options.errStream || process.stderr;
        return result;
      }
      _getSpawnOptions(options, toolPath) {
        options = options || {};
        const result = {};
        result.cwd = options.cwd;
        result.env = options.env;
        result["windowsVerbatimArguments"] = options.windowsVerbatimArguments || this._isCmdFile();
        if (options.windowsVerbatimArguments) {
          result.argv0 = `"${toolPath}"`;
        }
        return result;
      }
      exec() {
        return __awaiter(this, void 0, void 0, function* () {
          if (!ioUtil.isRooted(this.toolPath) && (this.toolPath.includes("/") || IS_WINDOWS && this.toolPath.includes("\\"))) {
            this.toolPath = path4.resolve(process.cwd(), this.options.cwd || process.cwd(), this.toolPath);
          }
          this.toolPath = yield io.which(this.toolPath, true);
          return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            this._debug(`exec tool: ${this.toolPath}`);
            this._debug("arguments:");
            for (const arg of this.args) {
              this._debug(`   ${arg}`);
            }
            const optionsNonNull = this._cloneExecOptions(this.options);
            if (!optionsNonNull.silent && optionsNonNull.outStream) {
              optionsNonNull.outStream.write(this._getCommandString(optionsNonNull) + os.EOL);
            }
            const state = new ExecState(optionsNonNull, this.toolPath);
            state.on("debug", (message) => {
              this._debug(message);
            });
            if (this.options.cwd && !(yield ioUtil.exists(this.options.cwd))) {
              return reject(new Error(`The cwd: ${this.options.cwd} does not exist!`));
            }
            const fileName = this._getSpawnFileName();
            const cp = child.spawn(fileName, this._getSpawnArgs(optionsNonNull), this._getSpawnOptions(this.options, fileName));
            let stdbuffer = "";
            if (cp.stdout) {
              cp.stdout.on("data", (data) => {
                if (this.options.listeners && this.options.listeners.stdout) {
                  this.options.listeners.stdout(data);
                }
                if (!optionsNonNull.silent && optionsNonNull.outStream) {
                  optionsNonNull.outStream.write(data);
                }
                stdbuffer = this._processLineBuffer(data, stdbuffer, (line) => {
                  if (this.options.listeners && this.options.listeners.stdline) {
                    this.options.listeners.stdline(line);
                  }
                });
              });
            }
            let errbuffer = "";
            if (cp.stderr) {
              cp.stderr.on("data", (data) => {
                state.processStderr = true;
                if (this.options.listeners && this.options.listeners.stderr) {
                  this.options.listeners.stderr(data);
                }
                if (!optionsNonNull.silent && optionsNonNull.errStream && optionsNonNull.outStream) {
                  const s2 = optionsNonNull.failOnStdErr ? optionsNonNull.errStream : optionsNonNull.outStream;
                  s2.write(data);
                }
                errbuffer = this._processLineBuffer(data, errbuffer, (line) => {
                  if (this.options.listeners && this.options.listeners.errline) {
                    this.options.listeners.errline(line);
                  }
                });
              });
            }
            cp.on("error", (err) => {
              state.processError = err.message;
              state.processExited = true;
              state.processClosed = true;
              state.CheckComplete();
            });
            cp.on("exit", (code) => {
              state.processExitCode = code;
              state.processExited = true;
              this._debug(`Exit code ${code} received from tool '${this.toolPath}'`);
              state.CheckComplete();
            });
            cp.on("close", (code) => {
              state.processExitCode = code;
              state.processExited = true;
              state.processClosed = true;
              this._debug(`STDIO streams have closed for tool '${this.toolPath}'`);
              state.CheckComplete();
            });
            state.on("done", (error, exitCode) => {
              if (stdbuffer.length > 0) {
                this.emit("stdline", stdbuffer);
              }
              if (errbuffer.length > 0) {
                this.emit("errline", errbuffer);
              }
              cp.removeAllListeners();
              if (error) {
                reject(error);
              } else {
                resolve(exitCode);
              }
            });
            if (this.options.input) {
              if (!cp.stdin) {
                throw new Error("child process missing stdin");
              }
              cp.stdin.end(this.options.input);
            }
          }));
        });
      }
    };
    exports.ToolRunner = ToolRunner;
    function argStringToArray(argString) {
      const args = [];
      let inQuotes = false;
      let escaped = false;
      let arg = "";
      function append(c) {
        if (escaped && c !== '"') {
          arg += "\\";
        }
        arg += c;
        escaped = false;
      }
      for (let i2 = 0; i2 < argString.length; i2++) {
        const c = argString.charAt(i2);
        if (c === '"') {
          if (!escaped) {
            inQuotes = !inQuotes;
          } else {
            append(c);
          }
          continue;
        }
        if (c === "\\" && escaped) {
          append(c);
          continue;
        }
        if (c === "\\" && inQuotes) {
          escaped = true;
          continue;
        }
        if (c === " " && !inQuotes) {
          if (arg.length > 0) {
            args.push(arg);
            arg = "";
          }
          continue;
        }
        append(c);
      }
      if (arg.length > 0) {
        args.push(arg.trim());
      }
      return args;
    }
    exports.argStringToArray = argStringToArray;
    var ExecState = class extends events.EventEmitter {
      constructor(options, toolPath) {
        super();
        this.processClosed = false;
        this.processError = "";
        this.processExitCode = 0;
        this.processExited = false;
        this.processStderr = false;
        this.delay = 1e4;
        this.done = false;
        this.timeout = null;
        if (!toolPath) {
          throw new Error("toolPath must not be empty");
        }
        this.options = options;
        this.toolPath = toolPath;
        if (options.delay) {
          this.delay = options.delay;
        }
      }
      CheckComplete() {
        if (this.done) {
          return;
        }
        if (this.processClosed) {
          this._setResult();
        } else if (this.processExited) {
          this.timeout = timers_1.setTimeout(ExecState.HandleTimeout, this.delay, this);
        }
      }
      _debug(message) {
        this.emit("debug", message);
      }
      _setResult() {
        let error;
        if (this.processExited) {
          if (this.processError) {
            error = new Error(`There was an error when attempting to execute the process '${this.toolPath}'. This may indicate the process failed to start. Error: ${this.processError}`);
          } else if (this.processExitCode !== 0 && !this.options.ignoreReturnCode) {
            error = new Error(`The process '${this.toolPath}' failed with exit code ${this.processExitCode}`);
          } else if (this.processStderr && this.options.failOnStdErr) {
            error = new Error(`The process '${this.toolPath}' failed because one or more lines were written to the STDERR stream`);
          }
        }
        if (this.timeout) {
          clearTimeout(this.timeout);
          this.timeout = null;
        }
        this.done = true;
        this.emit("done", error, this.processExitCode);
      }
      static HandleTimeout(state) {
        if (state.done) {
          return;
        }
        if (!state.processClosed && state.processExited) {
          const message = `The STDIO streams did not close within ${state.delay / 1e3} seconds of the exit event from process '${state.toolPath}'. This may indicate a child process inherited the STDIO streams and has not yet exited.`;
          state._debug(message);
        }
        state._setResult();
      }
    };
  }
});

// node_modules/@actions/exec/lib/exec.js
var require_exec = __commonJS({
  "node_modules/@actions/exec/lib/exec.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __setModuleDefault = exports && exports.__setModuleDefault || (Object.create ? function(o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
    } : function(o, v) {
      o["default"] = v;
    });
    var __importStar = exports && exports.__importStar || function(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (k !== "default" && Object.hasOwnProperty.call(mod, k))
            __createBinding(result, mod, k);
      }
      __setModuleDefault(result, mod);
      return result;
    };
    var __awaiter = exports && exports.__awaiter || function(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getExecOutput = exports.exec = void 0;
    var string_decoder_1 = require("string_decoder");
    var tr = __importStar(require_toolrunner());
    function exec3(commandLine, args, options) {
      return __awaiter(this, void 0, void 0, function* () {
        const commandArgs = tr.argStringToArray(commandLine);
        if (commandArgs.length === 0) {
          throw new Error(`Parameter 'commandLine' cannot be null or empty.`);
        }
        const toolPath = commandArgs[0];
        args = commandArgs.slice(1).concat(args || []);
        const runner = new tr.ToolRunner(toolPath, args, options);
        return runner.exec();
      });
    }
    exports.exec = exec3;
    function getExecOutput(commandLine, args, options) {
      var _a4, _b;
      return __awaiter(this, void 0, void 0, function* () {
        let stdout = "";
        let stderr = "";
        const stdoutDecoder = new string_decoder_1.StringDecoder("utf8");
        const stderrDecoder = new string_decoder_1.StringDecoder("utf8");
        const originalStdoutListener = (_a4 = options === null || options === void 0 ? void 0 : options.listeners) === null || _a4 === void 0 ? void 0 : _a4.stdout;
        const originalStdErrListener = (_b = options === null || options === void 0 ? void 0 : options.listeners) === null || _b === void 0 ? void 0 : _b.stderr;
        const stdErrListener = (data) => {
          stderr += stderrDecoder.write(data);
          if (originalStdErrListener) {
            originalStdErrListener(data);
          }
        };
        const stdOutListener = (data) => {
          stdout += stdoutDecoder.write(data);
          if (originalStdoutListener) {
            originalStdoutListener(data);
          }
        };
        const listeners = Object.assign(Object.assign({}, options === null || options === void 0 ? void 0 : options.listeners), { stdout: stdOutListener, stderr: stdErrListener });
        const exitCode = yield exec3(commandLine, args, Object.assign(Object.assign({}, options), { listeners }));
        stdout += stdoutDecoder.end();
        stderr += stderrDecoder.end();
        return {
          exitCode,
          stdout,
          stderr
        };
      });
    }
    exports.getExecOutput = getExecOutput;
  }
});

// node_modules/fs-extra/node_modules/universalify/index.js
var require_universalify = __commonJS({
  "node_modules/fs-extra/node_modules/universalify/index.js"(exports) {
    "use strict";
    exports.fromCallback = function(fn) {
      return Object.defineProperty(function(...args) {
        if (typeof args[args.length - 1] === "function")
          fn.apply(this, args);
        else {
          return new Promise((resolve, reject) => {
            fn.call(
              this,
              ...args,
              (err, res) => err != null ? reject(err) : resolve(res)
            );
          });
        }
      }, "name", { value: fn.name });
    };
    exports.fromPromise = function(fn) {
      return Object.defineProperty(function(...args) {
        const cb = args[args.length - 1];
        if (typeof cb !== "function")
          return fn.apply(this, args);
        else
          fn.apply(this, args.slice(0, -1)).then((r2) => cb(null, r2), cb);
      }, "name", { value: fn.name });
    };
  }
});

// node_modules/graceful-fs/polyfills.js
var require_polyfills = __commonJS({
  "node_modules/graceful-fs/polyfills.js"(exports, module2) {
    var constants = require("constants");
    var origCwd = process.cwd;
    var cwd = null;
    var platform = process.env.GRACEFUL_FS_PLATFORM || process.platform;
    process.cwd = function() {
      if (!cwd)
        cwd = origCwd.call(process);
      return cwd;
    };
    try {
      process.cwd();
    } catch (er) {
    }
    var chdir = process.chdir;
    process.chdir = function(d) {
      cwd = null;
      chdir.call(process, d);
    };
    module2.exports = patch;
    function patch(fs4) {
      if (constants.hasOwnProperty("O_SYMLINK") && process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
        patchLchmod(fs4);
      }
      if (!fs4.lutimes) {
        patchLutimes(fs4);
      }
      fs4.chown = chownFix(fs4.chown);
      fs4.fchown = chownFix(fs4.fchown);
      fs4.lchown = chownFix(fs4.lchown);
      fs4.chmod = chmodFix(fs4.chmod);
      fs4.fchmod = chmodFix(fs4.fchmod);
      fs4.lchmod = chmodFix(fs4.lchmod);
      fs4.chownSync = chownFixSync(fs4.chownSync);
      fs4.fchownSync = chownFixSync(fs4.fchownSync);
      fs4.lchownSync = chownFixSync(fs4.lchownSync);
      fs4.chmodSync = chmodFixSync(fs4.chmodSync);
      fs4.fchmodSync = chmodFixSync(fs4.fchmodSync);
      fs4.lchmodSync = chmodFixSync(fs4.lchmodSync);
      fs4.stat = statFix(fs4.stat);
      fs4.fstat = statFix(fs4.fstat);
      fs4.lstat = statFix(fs4.lstat);
      fs4.statSync = statFixSync(fs4.statSync);
      fs4.fstatSync = statFixSync(fs4.fstatSync);
      fs4.lstatSync = statFixSync(fs4.lstatSync);
      if (!fs4.lchmod) {
        fs4.lchmod = function(path4, mode, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs4.lchmodSync = function() {
        };
      }
      if (!fs4.lchown) {
        fs4.lchown = function(path4, uid, gid, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs4.lchownSync = function() {
        };
      }
      if (platform === "win32") {
        fs4.rename = function(fs$rename) {
          return function(from, to, cb) {
            var start = Date.now();
            var backoff = 0;
            fs$rename(from, to, function CB(er) {
              if (er && (er.code === "EACCES" || er.code === "EPERM") && Date.now() - start < 6e4) {
                setTimeout(function() {
                  fs4.stat(to, function(stater, st) {
                    if (stater && stater.code === "ENOENT")
                      fs$rename(from, to, CB);
                    else
                      cb(er);
                  });
                }, backoff);
                if (backoff < 100)
                  backoff += 10;
                return;
              }
              if (cb)
                cb(er);
            });
          };
        }(fs4.rename);
      }
      fs4.read = function(fs$read) {
        function read2(fd, buffer, offset, length, position, callback_) {
          var callback;
          if (callback_ && typeof callback_ === "function") {
            var eagCounter = 0;
            callback = function(er, _, __) {
              if (er && er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                return fs$read.call(fs4, fd, buffer, offset, length, position, callback);
              }
              callback_.apply(this, arguments);
            };
          }
          return fs$read.call(fs4, fd, buffer, offset, length, position, callback);
        }
        read2.__proto__ = fs$read;
        return read2;
      }(fs4.read);
      fs4.readSync = function(fs$readSync) {
        return function(fd, buffer, offset, length, position) {
          var eagCounter = 0;
          while (true) {
            try {
              return fs$readSync.call(fs4, fd, buffer, offset, length, position);
            } catch (er) {
              if (er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                continue;
              }
              throw er;
            }
          }
        };
      }(fs4.readSync);
      function patchLchmod(fs5) {
        fs5.lchmod = function(path4, mode, callback) {
          fs5.open(
            path4,
            constants.O_WRONLY | constants.O_SYMLINK,
            mode,
            function(err, fd) {
              if (err) {
                if (callback)
                  callback(err);
                return;
              }
              fs5.fchmod(fd, mode, function(err2) {
                fs5.close(fd, function(err22) {
                  if (callback)
                    callback(err2 || err22);
                });
              });
            }
          );
        };
        fs5.lchmodSync = function(path4, mode) {
          var fd = fs5.openSync(path4, constants.O_WRONLY | constants.O_SYMLINK, mode);
          var threw = true;
          var ret;
          try {
            ret = fs5.fchmodSync(fd, mode);
            threw = false;
          } finally {
            if (threw) {
              try {
                fs5.closeSync(fd);
              } catch (er) {
              }
            } else {
              fs5.closeSync(fd);
            }
          }
          return ret;
        };
      }
      function patchLutimes(fs5) {
        if (constants.hasOwnProperty("O_SYMLINK")) {
          fs5.lutimes = function(path4, at, mt, cb) {
            fs5.open(path4, constants.O_SYMLINK, function(er, fd) {
              if (er) {
                if (cb)
                  cb(er);
                return;
              }
              fs5.futimes(fd, at, mt, function(er2) {
                fs5.close(fd, function(er22) {
                  if (cb)
                    cb(er2 || er22);
                });
              });
            });
          };
          fs5.lutimesSync = function(path4, at, mt) {
            var fd = fs5.openSync(path4, constants.O_SYMLINK);
            var ret;
            var threw = true;
            try {
              ret = fs5.futimesSync(fd, at, mt);
              threw = false;
            } finally {
              if (threw) {
                try {
                  fs5.closeSync(fd);
                } catch (er) {
                }
              } else {
                fs5.closeSync(fd);
              }
            }
            return ret;
          };
        } else {
          fs5.lutimes = function(_a4, _b, _c, cb) {
            if (cb)
              process.nextTick(cb);
          };
          fs5.lutimesSync = function() {
          };
        }
      }
      function chmodFix(orig) {
        if (!orig)
          return orig;
        return function(target, mode, cb) {
          return orig.call(fs4, target, mode, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chmodFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, mode) {
          try {
            return orig.call(fs4, target, mode);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function chownFix(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid, cb) {
          return orig.call(fs4, target, uid, gid, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chownFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid) {
          try {
            return orig.call(fs4, target, uid, gid);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function statFix(orig) {
        if (!orig)
          return orig;
        return function(target, options, cb) {
          if (typeof options === "function") {
            cb = options;
            options = null;
          }
          function callback(er, stats) {
            if (stats) {
              if (stats.uid < 0)
                stats.uid += 4294967296;
              if (stats.gid < 0)
                stats.gid += 4294967296;
            }
            if (cb)
              cb.apply(this, arguments);
          }
          return options ? orig.call(fs4, target, options, callback) : orig.call(fs4, target, callback);
        };
      }
      function statFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, options) {
          var stats = options ? orig.call(fs4, target, options) : orig.call(fs4, target);
          if (stats.uid < 0)
            stats.uid += 4294967296;
          if (stats.gid < 0)
            stats.gid += 4294967296;
          return stats;
        };
      }
      function chownErOk(er) {
        if (!er)
          return true;
        if (er.code === "ENOSYS")
          return true;
        var nonroot = !process.getuid || process.getuid() !== 0;
        if (nonroot) {
          if (er.code === "EINVAL" || er.code === "EPERM")
            return true;
        }
        return false;
      }
    }
  }
});

// node_modules/graceful-fs/legacy-streams.js
var require_legacy_streams = __commonJS({
  "node_modules/graceful-fs/legacy-streams.js"(exports, module2) {
    var Stream4 = require("stream").Stream;
    module2.exports = legacy;
    function legacy(fs4) {
      return {
        ReadStream,
        WriteStream
      };
      function ReadStream(path4, options) {
        if (!(this instanceof ReadStream))
          return new ReadStream(path4, options);
        Stream4.call(this);
        var self2 = this;
        this.path = path4;
        this.fd = null;
        this.readable = true;
        this.paused = false;
        this.flags = "r";
        this.mode = 438;
        this.bufferSize = 64 * 1024;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.encoding)
          this.setEncoding(this.encoding);
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.end === void 0) {
            this.end = Infinity;
          } else if ("number" !== typeof this.end) {
            throw TypeError("end must be a Number");
          }
          if (this.start > this.end) {
            throw new Error("start must be <= end");
          }
          this.pos = this.start;
        }
        if (this.fd !== null) {
          process.nextTick(function() {
            self2._read();
          });
          return;
        }
        fs4.open(this.path, this.flags, this.mode, function(err, fd) {
          if (err) {
            self2.emit("error", err);
            self2.readable = false;
            return;
          }
          self2.fd = fd;
          self2.emit("open", fd);
          self2._read();
        });
      }
      function WriteStream(path4, options) {
        if (!(this instanceof WriteStream))
          return new WriteStream(path4, options);
        Stream4.call(this);
        this.path = path4;
        this.fd = null;
        this.writable = true;
        this.flags = "w";
        this.encoding = "binary";
        this.mode = 438;
        this.bytesWritten = 0;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.start < 0) {
            throw new Error("start must be >= zero");
          }
          this.pos = this.start;
        }
        this.busy = false;
        this._queue = [];
        if (this.fd === null) {
          this._open = fs4.open;
          this._queue.push([this._open, this.path, this.flags, this.mode, void 0]);
          this.flush();
        }
      }
    }
  }
});

// node_modules/graceful-fs/clone.js
var require_clone = __commonJS({
  "node_modules/graceful-fs/clone.js"(exports, module2) {
    "use strict";
    module2.exports = clone3;
    function clone3(obj) {
      if (obj === null || typeof obj !== "object")
        return obj;
      if (obj instanceof Object)
        var copy = { __proto__: obj.__proto__ };
      else
        var copy = /* @__PURE__ */ Object.create(null);
      Object.getOwnPropertyNames(obj).forEach(function(key) {
        Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key));
      });
      return copy;
    }
  }
});

// node_modules/graceful-fs/graceful-fs.js
var require_graceful_fs = __commonJS({
  "node_modules/graceful-fs/graceful-fs.js"(exports, module2) {
    var fs4 = require("fs");
    var polyfills = require_polyfills();
    var legacy = require_legacy_streams();
    var clone3 = require_clone();
    var util2 = require("util");
    var gracefulQueue;
    var previousSymbol;
    if (typeof Symbol === "function" && typeof Symbol.for === "function") {
      gracefulQueue = Symbol.for("graceful-fs.queue");
      previousSymbol = Symbol.for("graceful-fs.previous");
    } else {
      gracefulQueue = "___graceful-fs.queue";
      previousSymbol = "___graceful-fs.previous";
    }
    function noop2() {
    }
    var debug = noop2;
    if (util2.debuglog)
      debug = util2.debuglog("gfs4");
    else if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || ""))
      debug = function() {
        var m2 = util2.format.apply(util2, arguments);
        m2 = "GFS4: " + m2.split(/\n/).join("\nGFS4: ");
        console.error(m2);
      };
    if (!global[gracefulQueue]) {
      queue = [];
      Object.defineProperty(global, gracefulQueue, {
        get: function() {
          return queue;
        }
      });
      fs4.close = function(fs$close) {
        function close(fd, cb) {
          return fs$close.call(fs4, fd, function(err) {
            if (!err) {
              retry();
            }
            if (typeof cb === "function")
              cb.apply(this, arguments);
          });
        }
        Object.defineProperty(close, previousSymbol, {
          value: fs$close
        });
        return close;
      }(fs4.close);
      fs4.closeSync = function(fs$closeSync) {
        function closeSync(fd) {
          fs$closeSync.apply(fs4, arguments);
          retry();
        }
        Object.defineProperty(closeSync, previousSymbol, {
          value: fs$closeSync
        });
        return closeSync;
      }(fs4.closeSync);
      if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || "")) {
        process.on("exit", function() {
          debug(global[gracefulQueue]);
          require("assert").equal(global[gracefulQueue].length, 0);
        });
      }
    }
    var queue;
    module2.exports = patch(clone3(fs4));
    if (process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs4.__patched) {
      module2.exports = patch(fs4);
      fs4.__patched = true;
    }
    function patch(fs5) {
      polyfills(fs5);
      fs5.gracefulify = patch;
      fs5.createReadStream = createReadStream2;
      fs5.createWriteStream = createWriteStream;
      var fs$readFile = fs5.readFile;
      fs5.readFile = readFile;
      function readFile(path4, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$readFile(path4, options, cb);
        function go$readFile(path5, options2, cb2) {
          return fs$readFile(path5, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$readFile, [path5, options2, cb2]]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
              retry();
            }
          });
        }
      }
      var fs$writeFile = fs5.writeFile;
      fs5.writeFile = writeFile2;
      function writeFile2(path4, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$writeFile(path4, data, options, cb);
        function go$writeFile(path5, data2, options2, cb2) {
          return fs$writeFile(path5, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$writeFile, [path5, data2, options2, cb2]]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
              retry();
            }
          });
        }
      }
      var fs$appendFile = fs5.appendFile;
      if (fs$appendFile)
        fs5.appendFile = appendFile;
      function appendFile(path4, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$appendFile(path4, data, options, cb);
        function go$appendFile(path5, data2, options2, cb2) {
          return fs$appendFile(path5, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$appendFile, [path5, data2, options2, cb2]]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
              retry();
            }
          });
        }
      }
      var fs$readdir = fs5.readdir;
      fs5.readdir = readdir;
      function readdir(path4, options, cb) {
        var args = [path4];
        if (typeof options !== "function") {
          args.push(options);
        } else {
          cb = options;
        }
        args.push(go$readdir$cb);
        return go$readdir(args);
        function go$readdir$cb(err, files) {
          if (files && files.sort)
            files.sort();
          if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
            enqueue([go$readdir, [args]]);
          else {
            if (typeof cb === "function")
              cb.apply(this, arguments);
            retry();
          }
        }
      }
      function go$readdir(args) {
        return fs$readdir.apply(fs5, args);
      }
      if (process.version.substr(0, 4) === "v0.8") {
        var legStreams = legacy(fs5);
        ReadStream = legStreams.ReadStream;
        WriteStream = legStreams.WriteStream;
      }
      var fs$ReadStream = fs5.ReadStream;
      if (fs$ReadStream) {
        ReadStream.prototype = Object.create(fs$ReadStream.prototype);
        ReadStream.prototype.open = ReadStream$open;
      }
      var fs$WriteStream = fs5.WriteStream;
      if (fs$WriteStream) {
        WriteStream.prototype = Object.create(fs$WriteStream.prototype);
        WriteStream.prototype.open = WriteStream$open;
      }
      Object.defineProperty(fs5, "ReadStream", {
        get: function() {
          return ReadStream;
        },
        set: function(val) {
          ReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      Object.defineProperty(fs5, "WriteStream", {
        get: function() {
          return WriteStream;
        },
        set: function(val) {
          WriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      Object.defineProperty(fs5, "FileReadStream", {
        get: function() {
          return ReadStream;
        },
        set: function(val) {
          ReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      Object.defineProperty(fs5, "FileWriteStream", {
        get: function() {
          return WriteStream;
        },
        set: function(val) {
          WriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      function ReadStream(path4, options) {
        if (this instanceof ReadStream)
          return fs$ReadStream.apply(this, arguments), this;
        else
          return ReadStream.apply(Object.create(ReadStream.prototype), arguments);
      }
      function ReadStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            if (that.autoClose)
              that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
            that.read();
          }
        });
      }
      function WriteStream(path4, options) {
        if (this instanceof WriteStream)
          return fs$WriteStream.apply(this, arguments), this;
        else
          return WriteStream.apply(Object.create(WriteStream.prototype), arguments);
      }
      function WriteStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
          }
        });
      }
      function createReadStream2(path4, options) {
        return new fs5.ReadStream(path4, options);
      }
      function createWriteStream(path4, options) {
        return new fs5.WriteStream(path4, options);
      }
      var fs$open = fs5.open;
      fs5.open = open;
      function open(path4, flags, mode, cb) {
        if (typeof mode === "function")
          cb = mode, mode = null;
        return go$open(path4, flags, mode, cb);
        function go$open(path5, flags2, mode2, cb2) {
          return fs$open(path5, flags2, mode2, function(err, fd) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$open, [path5, flags2, mode2, cb2]]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
              retry();
            }
          });
        }
      }
      return fs5;
    }
    function enqueue(elem) {
      debug("ENQUEUE", elem[0].name, elem[1]);
      global[gracefulQueue].push(elem);
    }
    function retry() {
      var elem = global[gracefulQueue].shift();
      if (elem) {
        debug("RETRY", elem[0].name, elem[1]);
        elem[0].apply(null, elem[1]);
      }
    }
  }
});

// node_modules/fs-extra/lib/fs/index.js
var require_fs = __commonJS({
  "node_modules/fs-extra/lib/fs/index.js"(exports) {
    "use strict";
    var u = require_universalify().fromCallback;
    var fs4 = require_graceful_fs();
    var api = [
      "access",
      "appendFile",
      "chmod",
      "chown",
      "close",
      "copyFile",
      "fchmod",
      "fchown",
      "fdatasync",
      "fstat",
      "fsync",
      "ftruncate",
      "futimes",
      "lchmod",
      "lchown",
      "link",
      "lstat",
      "mkdir",
      "mkdtemp",
      "open",
      "opendir",
      "readdir",
      "readFile",
      "readlink",
      "realpath",
      "rename",
      "rm",
      "rmdir",
      "stat",
      "symlink",
      "truncate",
      "unlink",
      "utimes",
      "writeFile"
    ].filter((key) => {
      return typeof fs4[key] === "function";
    });
    Object.assign(exports, fs4);
    api.forEach((method) => {
      exports[method] = u(fs4[method]);
    });
    exports.exists = function(filename, callback) {
      if (typeof callback === "function") {
        return fs4.exists(filename, callback);
      }
      return new Promise((resolve) => {
        return fs4.exists(filename, resolve);
      });
    };
    exports.read = function(fd, buffer, offset, length, position, callback) {
      if (typeof callback === "function") {
        return fs4.read(fd, buffer, offset, length, position, callback);
      }
      return new Promise((resolve, reject) => {
        fs4.read(fd, buffer, offset, length, position, (err, bytesRead, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesRead, buffer: buffer2 });
        });
      });
    };
    exports.write = function(fd, buffer, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs4.write(fd, buffer, ...args);
      }
      return new Promise((resolve, reject) => {
        fs4.write(fd, buffer, ...args, (err, bytesWritten, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesWritten, buffer: buffer2 });
        });
      });
    };
    if (typeof fs4.writev === "function") {
      exports.writev = function(fd, buffers, ...args) {
        if (typeof args[args.length - 1] === "function") {
          return fs4.writev(fd, buffers, ...args);
        }
        return new Promise((resolve, reject) => {
          fs4.writev(fd, buffers, ...args, (err, bytesWritten, buffers2) => {
            if (err)
              return reject(err);
            resolve({ bytesWritten, buffers: buffers2 });
          });
        });
      };
    }
    if (typeof fs4.realpath.native === "function") {
      exports.realpath.native = u(fs4.realpath.native);
    } else {
      process.emitWarning(
        "fs.realpath.native is not a function. Is fs being monkey-patched?",
        "Warning",
        "fs-extra-WARN0003"
      );
    }
  }
});

// node_modules/fs-extra/lib/mkdirs/utils.js
var require_utils5 = __commonJS({
  "node_modules/fs-extra/lib/mkdirs/utils.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    module2.exports.checkPath = function checkPath(pth) {
      if (process.platform === "win32") {
        const pathHasInvalidWinCharacters = /[<>:"|?*]/.test(pth.replace(path4.parse(pth).root, ""));
        if (pathHasInvalidWinCharacters) {
          const error = new Error(`Path contains invalid characters: ${pth}`);
          error.code = "EINVAL";
          throw error;
        }
      }
    };
  }
});

// node_modules/fs-extra/lib/mkdirs/make-dir.js
var require_make_dir = __commonJS({
  "node_modules/fs-extra/lib/mkdirs/make-dir.js"(exports, module2) {
    "use strict";
    var fs4 = require_fs();
    var { checkPath } = require_utils5();
    var getMode = (options) => {
      const defaults = { mode: 511 };
      if (typeof options === "number")
        return options;
      return { ...defaults, ...options }.mode;
    };
    module2.exports.makeDir = async (dir, options) => {
      checkPath(dir);
      return fs4.mkdir(dir, {
        mode: getMode(options),
        recursive: true
      });
    };
    module2.exports.makeDirSync = (dir, options) => {
      checkPath(dir);
      return fs4.mkdirSync(dir, {
        mode: getMode(options),
        recursive: true
      });
    };
  }
});

// node_modules/fs-extra/lib/mkdirs/index.js
var require_mkdirs = __commonJS({
  "node_modules/fs-extra/lib/mkdirs/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var { makeDir: _makeDir, makeDirSync } = require_make_dir();
    var makeDir = u(_makeDir);
    module2.exports = {
      mkdirs: makeDir,
      mkdirsSync: makeDirSync,
      mkdirp: makeDir,
      mkdirpSync: makeDirSync,
      ensureDir: makeDir,
      ensureDirSync: makeDirSync
    };
  }
});

// node_modules/fs-extra/lib/path-exists/index.js
var require_path_exists = __commonJS({
  "node_modules/fs-extra/lib/path-exists/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var fs4 = require_fs();
    function pathExists(path4) {
      return fs4.access(path4).then(() => true).catch(() => false);
    }
    module2.exports = {
      pathExists: u(pathExists),
      pathExistsSync: fs4.existsSync
    };
  }
});

// node_modules/fs-extra/lib/util/utimes.js
var require_utimes = __commonJS({
  "node_modules/fs-extra/lib/util/utimes.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    function utimesMillis(path4, atime, mtime, callback) {
      fs4.open(path4, "r+", (err, fd) => {
        if (err)
          return callback(err);
        fs4.futimes(fd, atime, mtime, (futimesErr) => {
          fs4.close(fd, (closeErr) => {
            if (callback)
              callback(futimesErr || closeErr);
          });
        });
      });
    }
    function utimesMillisSync(path4, atime, mtime) {
      const fd = fs4.openSync(path4, "r+");
      fs4.futimesSync(fd, atime, mtime);
      return fs4.closeSync(fd);
    }
    module2.exports = {
      utimesMillis,
      utimesMillisSync
    };
  }
});

// node_modules/fs-extra/lib/util/stat.js
var require_stat = __commonJS({
  "node_modules/fs-extra/lib/util/stat.js"(exports, module2) {
    "use strict";
    var fs4 = require_fs();
    var path4 = require("path");
    var util2 = require("util");
    function getStats(src, dest, opts) {
      const statFunc = opts.dereference ? (file) => fs4.stat(file, { bigint: true }) : (file) => fs4.lstat(file, { bigint: true });
      return Promise.all([
        statFunc(src),
        statFunc(dest).catch((err) => {
          if (err.code === "ENOENT")
            return null;
          throw err;
        })
      ]).then(([srcStat, destStat]) => ({ srcStat, destStat }));
    }
    function getStatsSync(src, dest, opts) {
      let destStat;
      const statFunc = opts.dereference ? (file) => fs4.statSync(file, { bigint: true }) : (file) => fs4.lstatSync(file, { bigint: true });
      const srcStat = statFunc(src);
      try {
        destStat = statFunc(dest);
      } catch (err) {
        if (err.code === "ENOENT")
          return { srcStat, destStat: null };
        throw err;
      }
      return { srcStat, destStat };
    }
    function checkPaths(src, dest, funcName, opts, cb) {
      util2.callbackify(getStats)(src, dest, opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        if (destStat) {
          if (areIdentical(srcStat, destStat)) {
            const srcBaseName = path4.basename(src);
            const destBaseName = path4.basename(dest);
            if (funcName === "move" && srcBaseName !== destBaseName && srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
              return cb(null, { srcStat, destStat, isChangingCase: true });
            }
            return cb(new Error("Source and destination must not be the same."));
          }
          if (srcStat.isDirectory() && !destStat.isDirectory()) {
            return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`));
          }
          if (!srcStat.isDirectory() && destStat.isDirectory()) {
            return cb(new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`));
          }
        }
        if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return cb(null, { srcStat, destStat });
      });
    }
    function checkPathsSync(src, dest, funcName, opts) {
      const { srcStat, destStat } = getStatsSync(src, dest, opts);
      if (destStat) {
        if (areIdentical(srcStat, destStat)) {
          const srcBaseName = path4.basename(src);
          const destBaseName = path4.basename(dest);
          if (funcName === "move" && srcBaseName !== destBaseName && srcBaseName.toLowerCase() === destBaseName.toLowerCase()) {
            return { srcStat, destStat, isChangingCase: true };
          }
          throw new Error("Source and destination must not be the same.");
        }
        if (srcStat.isDirectory() && !destStat.isDirectory()) {
          throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`);
        }
        if (!srcStat.isDirectory() && destStat.isDirectory()) {
          throw new Error(`Cannot overwrite directory '${dest}' with non-directory '${src}'.`);
        }
      }
      if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return { srcStat, destStat };
    }
    function checkParentPaths(src, srcStat, dest, funcName, cb) {
      const srcParent = path4.resolve(path4.dirname(src));
      const destParent = path4.resolve(path4.dirname(dest));
      if (destParent === srcParent || destParent === path4.parse(destParent).root)
        return cb();
      fs4.stat(destParent, { bigint: true }, (err, destStat) => {
        if (err) {
          if (err.code === "ENOENT")
            return cb();
          return cb(err);
        }
        if (areIdentical(srcStat, destStat)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return checkParentPaths(src, srcStat, destParent, funcName, cb);
      });
    }
    function checkParentPathsSync(src, srcStat, dest, funcName) {
      const srcParent = path4.resolve(path4.dirname(src));
      const destParent = path4.resolve(path4.dirname(dest));
      if (destParent === srcParent || destParent === path4.parse(destParent).root)
        return;
      let destStat;
      try {
        destStat = fs4.statSync(destParent, { bigint: true });
      } catch (err) {
        if (err.code === "ENOENT")
          return;
        throw err;
      }
      if (areIdentical(srcStat, destStat)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return checkParentPathsSync(src, srcStat, destParent, funcName);
    }
    function areIdentical(srcStat, destStat) {
      return destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev;
    }
    function isSrcSubdir(src, dest) {
      const srcArr = path4.resolve(src).split(path4.sep).filter((i2) => i2);
      const destArr = path4.resolve(dest).split(path4.sep).filter((i2) => i2);
      return srcArr.reduce((acc, cur, i2) => acc && destArr[i2] === cur, true);
    }
    function errMsg(src, dest, funcName) {
      return `Cannot ${funcName} '${src}' to a subdirectory of itself, '${dest}'.`;
    }
    module2.exports = {
      checkPaths,
      checkPathsSync,
      checkParentPaths,
      checkParentPathsSync,
      isSrcSubdir,
      areIdentical
    };
  }
});

// node_modules/fs-extra/lib/copy/copy.js
var require_copy = __commonJS({
  "node_modules/fs-extra/lib/copy/copy.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdirs = require_mkdirs().mkdirs;
    var pathExists = require_path_exists().pathExists;
    var utimesMillis = require_utimes().utimesMillis;
    var stat3 = require_stat();
    function copy(src, dest, opts, cb) {
      if (typeof opts === "function" && !cb) {
        cb = opts;
        opts = {};
      } else if (typeof opts === "function") {
        opts = { filter: opts };
      }
      cb = cb || function() {
      };
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        process.emitWarning(
          "Using the preserveTimestamps option in 32-bit node is not recommended;\n\n	see https://github.com/jprichardson/node-fs-extra/issues/269",
          "Warning",
          "fs-extra-WARN0001"
        );
      }
      stat3.checkPaths(src, dest, "copy", opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        stat3.checkParentPaths(src, srcStat, dest, "copy", (err2) => {
          if (err2)
            return cb(err2);
          if (opts.filter)
            return handleFilter(checkParentDir, destStat, src, dest, opts, cb);
          return checkParentDir(destStat, src, dest, opts, cb);
        });
      });
    }
    function checkParentDir(destStat, src, dest, opts, cb) {
      const destParent = path4.dirname(dest);
      pathExists(destParent, (err, dirExists) => {
        if (err)
          return cb(err);
        if (dirExists)
          return getStats(destStat, src, dest, opts, cb);
        mkdirs(destParent, (err2) => {
          if (err2)
            return cb(err2);
          return getStats(destStat, src, dest, opts, cb);
        });
      });
    }
    function handleFilter(onInclude, destStat, src, dest, opts, cb) {
      Promise.resolve(opts.filter(src, dest)).then((include) => {
        if (include)
          return onInclude(destStat, src, dest, opts, cb);
        return cb();
      }, (error) => cb(error));
    }
    function startCopy(destStat, src, dest, opts, cb) {
      if (opts.filter)
        return handleFilter(getStats, destStat, src, dest, opts, cb);
      return getStats(destStat, src, dest, opts, cb);
    }
    function getStats(destStat, src, dest, opts, cb) {
      const stat4 = opts.dereference ? fs4.stat : fs4.lstat;
      stat4(src, (err, srcStat) => {
        if (err)
          return cb(err);
        if (srcStat.isDirectory())
          return onDir(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
          return onFile(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isSymbolicLink())
          return onLink(destStat, src, dest, opts, cb);
        else if (srcStat.isSocket())
          return cb(new Error(`Cannot copy a socket file: ${src}`));
        else if (srcStat.isFIFO())
          return cb(new Error(`Cannot copy a FIFO pipe: ${src}`));
        return cb(new Error(`Unknown file: ${src}`));
      });
    }
    function onFile(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts, cb);
      return mayCopyFile(srcStat, src, dest, opts, cb);
    }
    function mayCopyFile(srcStat, src, dest, opts, cb) {
      if (opts.overwrite) {
        fs4.unlink(dest, (err) => {
          if (err)
            return cb(err);
          return copyFile(srcStat, src, dest, opts, cb);
        });
      } else if (opts.errorOnExist) {
        return cb(new Error(`'${dest}' already exists`));
      } else
        return cb();
    }
    function copyFile(srcStat, src, dest, opts, cb) {
      fs4.copyFile(src, dest, (err) => {
        if (err)
          return cb(err);
        if (opts.preserveTimestamps)
          return handleTimestampsAndMode(srcStat.mode, src, dest, cb);
        return setDestMode(dest, srcStat.mode, cb);
      });
    }
    function handleTimestampsAndMode(srcMode, src, dest, cb) {
      if (fileIsNotWritable(srcMode)) {
        return makeFileWritable(dest, srcMode, (err) => {
          if (err)
            return cb(err);
          return setDestTimestampsAndMode(srcMode, src, dest, cb);
        });
      }
      return setDestTimestampsAndMode(srcMode, src, dest, cb);
    }
    function fileIsNotWritable(srcMode) {
      return (srcMode & 128) === 0;
    }
    function makeFileWritable(dest, srcMode, cb) {
      return setDestMode(dest, srcMode | 128, cb);
    }
    function setDestTimestampsAndMode(srcMode, src, dest, cb) {
      setDestTimestamps(src, dest, (err) => {
        if (err)
          return cb(err);
        return setDestMode(dest, srcMode, cb);
      });
    }
    function setDestMode(dest, srcMode, cb) {
      return fs4.chmod(dest, srcMode, cb);
    }
    function setDestTimestamps(src, dest, cb) {
      fs4.stat(src, (err, updatedSrcStat) => {
        if (err)
          return cb(err);
        return utimesMillis(dest, updatedSrcStat.atime, updatedSrcStat.mtime, cb);
      });
    }
    function onDir(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return mkDirAndCopy(srcStat.mode, src, dest, opts, cb);
      return copyDir(src, dest, opts, cb);
    }
    function mkDirAndCopy(srcMode, src, dest, opts, cb) {
      fs4.mkdir(dest, (err) => {
        if (err)
          return cb(err);
        copyDir(src, dest, opts, (err2) => {
          if (err2)
            return cb(err2);
          return setDestMode(dest, srcMode, cb);
        });
      });
    }
    function copyDir(src, dest, opts, cb) {
      fs4.readdir(src, (err, items) => {
        if (err)
          return cb(err);
        return copyDirItems(items, src, dest, opts, cb);
      });
    }
    function copyDirItems(items, src, dest, opts, cb) {
      const item = items.pop();
      if (!item)
        return cb();
      return copyDirItem(items, item, src, dest, opts, cb);
    }
    function copyDirItem(items, item, src, dest, opts, cb) {
      const srcItem = path4.join(src, item);
      const destItem = path4.join(dest, item);
      stat3.checkPaths(srcItem, destItem, "copy", opts, (err, stats) => {
        if (err)
          return cb(err);
        const { destStat } = stats;
        startCopy(destStat, srcItem, destItem, opts, (err2) => {
          if (err2)
            return cb(err2);
          return copyDirItems(items, src, dest, opts, cb);
        });
      });
    }
    function onLink(destStat, src, dest, opts, cb) {
      fs4.readlink(src, (err, resolvedSrc) => {
        if (err)
          return cb(err);
        if (opts.dereference) {
          resolvedSrc = path4.resolve(process.cwd(), resolvedSrc);
        }
        if (!destStat) {
          return fs4.symlink(resolvedSrc, dest, cb);
        } else {
          fs4.readlink(dest, (err2, resolvedDest) => {
            if (err2) {
              if (err2.code === "EINVAL" || err2.code === "UNKNOWN")
                return fs4.symlink(resolvedSrc, dest, cb);
              return cb(err2);
            }
            if (opts.dereference) {
              resolvedDest = path4.resolve(process.cwd(), resolvedDest);
            }
            if (stat3.isSrcSubdir(resolvedSrc, resolvedDest)) {
              return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`));
            }
            if (destStat.isDirectory() && stat3.isSrcSubdir(resolvedDest, resolvedSrc)) {
              return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`));
            }
            return copyLink(resolvedSrc, dest, cb);
          });
        }
      });
    }
    function copyLink(resolvedSrc, dest, cb) {
      fs4.unlink(dest, (err) => {
        if (err)
          return cb(err);
        return fs4.symlink(resolvedSrc, dest, cb);
      });
    }
    module2.exports = copy;
  }
});

// node_modules/fs-extra/lib/copy/copy-sync.js
var require_copy_sync = __commonJS({
  "node_modules/fs-extra/lib/copy/copy-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdirsSync = require_mkdirs().mkdirsSync;
    var utimesMillisSync = require_utimes().utimesMillisSync;
    var stat3 = require_stat();
    function copySync(src, dest, opts) {
      if (typeof opts === "function") {
        opts = { filter: opts };
      }
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        process.emitWarning(
          "Using the preserveTimestamps option in 32-bit node is not recommended;\n\n	see https://github.com/jprichardson/node-fs-extra/issues/269",
          "Warning",
          "fs-extra-WARN0002"
        );
      }
      const { srcStat, destStat } = stat3.checkPathsSync(src, dest, "copy", opts);
      stat3.checkParentPathsSync(src, srcStat, dest, "copy");
      return handleFilterAndCopy(destStat, src, dest, opts);
    }
    function handleFilterAndCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      const destParent = path4.dirname(dest);
      if (!fs4.existsSync(destParent))
        mkdirsSync(destParent);
      return getStats(destStat, src, dest, opts);
    }
    function startCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      return getStats(destStat, src, dest, opts);
    }
    function getStats(destStat, src, dest, opts) {
      const statSync2 = opts.dereference ? fs4.statSync : fs4.lstatSync;
      const srcStat = statSync2(src);
      if (srcStat.isDirectory())
        return onDir(srcStat, destStat, src, dest, opts);
      else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
        return onFile(srcStat, destStat, src, dest, opts);
      else if (srcStat.isSymbolicLink())
        return onLink(destStat, src, dest, opts);
      else if (srcStat.isSocket())
        throw new Error(`Cannot copy a socket file: ${src}`);
      else if (srcStat.isFIFO())
        throw new Error(`Cannot copy a FIFO pipe: ${src}`);
      throw new Error(`Unknown file: ${src}`);
    }
    function onFile(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts);
      return mayCopyFile(srcStat, src, dest, opts);
    }
    function mayCopyFile(srcStat, src, dest, opts) {
      if (opts.overwrite) {
        fs4.unlinkSync(dest);
        return copyFile(srcStat, src, dest, opts);
      } else if (opts.errorOnExist) {
        throw new Error(`'${dest}' already exists`);
      }
    }
    function copyFile(srcStat, src, dest, opts) {
      fs4.copyFileSync(src, dest);
      if (opts.preserveTimestamps)
        handleTimestamps(srcStat.mode, src, dest);
      return setDestMode(dest, srcStat.mode);
    }
    function handleTimestamps(srcMode, src, dest) {
      if (fileIsNotWritable(srcMode))
        makeFileWritable(dest, srcMode);
      return setDestTimestamps(src, dest);
    }
    function fileIsNotWritable(srcMode) {
      return (srcMode & 128) === 0;
    }
    function makeFileWritable(dest, srcMode) {
      return setDestMode(dest, srcMode | 128);
    }
    function setDestMode(dest, srcMode) {
      return fs4.chmodSync(dest, srcMode);
    }
    function setDestTimestamps(src, dest) {
      const updatedSrcStat = fs4.statSync(src);
      return utimesMillisSync(dest, updatedSrcStat.atime, updatedSrcStat.mtime);
    }
    function onDir(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return mkDirAndCopy(srcStat.mode, src, dest, opts);
      return copyDir(src, dest, opts);
    }
    function mkDirAndCopy(srcMode, src, dest, opts) {
      fs4.mkdirSync(dest);
      copyDir(src, dest, opts);
      return setDestMode(dest, srcMode);
    }
    function copyDir(src, dest, opts) {
      fs4.readdirSync(src).forEach((item) => copyDirItem(item, src, dest, opts));
    }
    function copyDirItem(item, src, dest, opts) {
      const srcItem = path4.join(src, item);
      const destItem = path4.join(dest, item);
      const { destStat } = stat3.checkPathsSync(srcItem, destItem, "copy", opts);
      return startCopy(destStat, srcItem, destItem, opts);
    }
    function onLink(destStat, src, dest, opts) {
      let resolvedSrc = fs4.readlinkSync(src);
      if (opts.dereference) {
        resolvedSrc = path4.resolve(process.cwd(), resolvedSrc);
      }
      if (!destStat) {
        return fs4.symlinkSync(resolvedSrc, dest);
      } else {
        let resolvedDest;
        try {
          resolvedDest = fs4.readlinkSync(dest);
        } catch (err) {
          if (err.code === "EINVAL" || err.code === "UNKNOWN")
            return fs4.symlinkSync(resolvedSrc, dest);
          throw err;
        }
        if (opts.dereference) {
          resolvedDest = path4.resolve(process.cwd(), resolvedDest);
        }
        if (stat3.isSrcSubdir(resolvedSrc, resolvedDest)) {
          throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
        }
        if (fs4.statSync(dest).isDirectory() && stat3.isSrcSubdir(resolvedDest, resolvedSrc)) {
          throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
        }
        return copyLink(resolvedSrc, dest);
      }
    }
    function copyLink(resolvedSrc, dest) {
      fs4.unlinkSync(dest);
      return fs4.symlinkSync(resolvedSrc, dest);
    }
    module2.exports = copySync;
  }
});

// node_modules/fs-extra/lib/copy/index.js
var require_copy2 = __commonJS({
  "node_modules/fs-extra/lib/copy/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    module2.exports = {
      copy: u(require_copy()),
      copySync: require_copy_sync()
    };
  }
});

// node_modules/fs-extra/lib/remove/rimraf.js
var require_rimraf = __commonJS({
  "node_modules/fs-extra/lib/remove/rimraf.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var assert = require("assert");
    var isWindows = process.platform === "win32";
    function defaults(options) {
      const methods = [
        "unlink",
        "chmod",
        "stat",
        "lstat",
        "rmdir",
        "readdir"
      ];
      methods.forEach((m2) => {
        options[m2] = options[m2] || fs4[m2];
        m2 = m2 + "Sync";
        options[m2] = options[m2] || fs4[m2];
      });
      options.maxBusyTries = options.maxBusyTries || 3;
    }
    function rimraf(p, options, cb) {
      let busyTries = 0;
      if (typeof options === "function") {
        cb = options;
        options = {};
      }
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert.strictEqual(typeof cb, "function", "rimraf: callback function required");
      assert(options, "rimraf: invalid options argument provided");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      defaults(options);
      rimraf_(p, options, function CB(er) {
        if (er) {
          if ((er.code === "EBUSY" || er.code === "ENOTEMPTY" || er.code === "EPERM") && busyTries < options.maxBusyTries) {
            busyTries++;
            const time = busyTries * 100;
            return setTimeout(() => rimraf_(p, options, CB), time);
          }
          if (er.code === "ENOENT")
            er = null;
        }
        cb(er);
      });
    }
    function rimraf_(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.lstat(p, (er, st) => {
        if (er && er.code === "ENOENT") {
          return cb(null);
        }
        if (er && er.code === "EPERM" && isWindows) {
          return fixWinEPERM(p, options, er, cb);
        }
        if (st && st.isDirectory()) {
          return rmdir(p, options, er, cb);
        }
        options.unlink(p, (er2) => {
          if (er2) {
            if (er2.code === "ENOENT") {
              return cb(null);
            }
            if (er2.code === "EPERM") {
              return isWindows ? fixWinEPERM(p, options, er2, cb) : rmdir(p, options, er2, cb);
            }
            if (er2.code === "EISDIR") {
              return rmdir(p, options, er2, cb);
            }
          }
          return cb(er2);
        });
      });
    }
    function fixWinEPERM(p, options, er, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.chmod(p, 438, (er2) => {
        if (er2) {
          cb(er2.code === "ENOENT" ? null : er);
        } else {
          options.stat(p, (er3, stats) => {
            if (er3) {
              cb(er3.code === "ENOENT" ? null : er);
            } else if (stats.isDirectory()) {
              rmdir(p, options, er, cb);
            } else {
              options.unlink(p, cb);
            }
          });
        }
      });
    }
    function fixWinEPERMSync(p, options, er) {
      let stats;
      assert(p);
      assert(options);
      try {
        options.chmodSync(p, 438);
      } catch (er2) {
        if (er2.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      try {
        stats = options.statSync(p);
      } catch (er3) {
        if (er3.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      if (stats.isDirectory()) {
        rmdirSync(p, options, er);
      } else {
        options.unlinkSync(p);
      }
    }
    function rmdir(p, options, originalEr, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.rmdir(p, (er) => {
        if (er && (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM")) {
          rmkids(p, options, cb);
        } else if (er && er.code === "ENOTDIR") {
          cb(originalEr);
        } else {
          cb(er);
        }
      });
    }
    function rmkids(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.readdir(p, (er, files) => {
        if (er)
          return cb(er);
        let n = files.length;
        let errState;
        if (n === 0)
          return options.rmdir(p, cb);
        files.forEach((f3) => {
          rimraf(path4.join(p, f3), options, (er2) => {
            if (errState) {
              return;
            }
            if (er2)
              return cb(errState = er2);
            if (--n === 0) {
              options.rmdir(p, cb);
            }
          });
        });
      });
    }
    function rimrafSync(p, options) {
      let st;
      options = options || {};
      defaults(options);
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert(options, "rimraf: missing options");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      try {
        st = options.lstatSync(p);
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        }
        if (er.code === "EPERM" && isWindows) {
          fixWinEPERMSync(p, options, er);
        }
      }
      try {
        if (st && st.isDirectory()) {
          rmdirSync(p, options, null);
        } else {
          options.unlinkSync(p);
        }
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        } else if (er.code === "EPERM") {
          return isWindows ? fixWinEPERMSync(p, options, er) : rmdirSync(p, options, er);
        } else if (er.code !== "EISDIR") {
          throw er;
        }
        rmdirSync(p, options, er);
      }
    }
    function rmdirSync(p, options, originalEr) {
      assert(p);
      assert(options);
      try {
        options.rmdirSync(p);
      } catch (er) {
        if (er.code === "ENOTDIR") {
          throw originalEr;
        } else if (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM") {
          rmkidsSync(p, options);
        } else if (er.code !== "ENOENT") {
          throw er;
        }
      }
    }
    function rmkidsSync(p, options) {
      assert(p);
      assert(options);
      options.readdirSync(p).forEach((f3) => rimrafSync(path4.join(p, f3), options));
      if (isWindows) {
        const startTime = Date.now();
        do {
          try {
            const ret = options.rmdirSync(p, options);
            return ret;
          } catch {
          }
        } while (Date.now() - startTime < 500);
      } else {
        const ret = options.rmdirSync(p, options);
        return ret;
      }
    }
    module2.exports = rimraf;
    rimraf.sync = rimrafSync;
  }
});

// node_modules/fs-extra/lib/remove/index.js
var require_remove2 = __commonJS({
  "node_modules/fs-extra/lib/remove/index.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var u = require_universalify().fromCallback;
    var rimraf = require_rimraf();
    function remove(path4, callback) {
      if (fs4.rm)
        return fs4.rm(path4, { recursive: true, force: true }, callback);
      rimraf(path4, callback);
    }
    function removeSync(path4) {
      if (fs4.rmSync)
        return fs4.rmSync(path4, { recursive: true, force: true });
      rimraf.sync(path4);
    }
    module2.exports = {
      remove: u(remove),
      removeSync
    };
  }
});

// node_modules/fs-extra/lib/empty/index.js
var require_empty = __commonJS({
  "node_modules/fs-extra/lib/empty/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var fs4 = require_fs();
    var path4 = require("path");
    var mkdir = require_mkdirs();
    var remove = require_remove2();
    var emptyDir = u(async function emptyDir2(dir) {
      let items;
      try {
        items = await fs4.readdir(dir);
      } catch {
        return mkdir.mkdirs(dir);
      }
      return Promise.all(items.map((item) => remove.remove(path4.join(dir, item))));
    });
    function emptyDirSync(dir) {
      let items;
      try {
        items = fs4.readdirSync(dir);
      } catch {
        return mkdir.mkdirsSync(dir);
      }
      items.forEach((item) => {
        item = path4.join(dir, item);
        remove.removeSync(item);
      });
    }
    module2.exports = {
      emptyDirSync,
      emptydirSync: emptyDirSync,
      emptyDir,
      emptydir: emptyDir
    };
  }
});

// node_modules/fs-extra/lib/ensure/file.js
var require_file = __commonJS({
  "node_modules/fs-extra/lib/ensure/file.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var mkdir = require_mkdirs();
    function createFile(file, callback) {
      function makeFile() {
        fs4.writeFile(file, "", (err) => {
          if (err)
            return callback(err);
          callback();
        });
      }
      fs4.stat(file, (err, stats) => {
        if (!err && stats.isFile())
          return callback();
        const dir = path4.dirname(file);
        fs4.stat(dir, (err2, stats2) => {
          if (err2) {
            if (err2.code === "ENOENT") {
              return mkdir.mkdirs(dir, (err3) => {
                if (err3)
                  return callback(err3);
                makeFile();
              });
            }
            return callback(err2);
          }
          if (stats2.isDirectory())
            makeFile();
          else {
            fs4.readdir(dir, (err3) => {
              if (err3)
                return callback(err3);
            });
          }
        });
      });
    }
    function createFileSync(file) {
      let stats;
      try {
        stats = fs4.statSync(file);
      } catch {
      }
      if (stats && stats.isFile())
        return;
      const dir = path4.dirname(file);
      try {
        if (!fs4.statSync(dir).isDirectory()) {
          fs4.readdirSync(dir);
        }
      } catch (err) {
        if (err && err.code === "ENOENT")
          mkdir.mkdirsSync(dir);
        else
          throw err;
      }
      fs4.writeFileSync(file, "");
    }
    module2.exports = {
      createFile: u(createFile),
      createFileSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/link.js
var require_link = __commonJS({
  "node_modules/fs-extra/lib/ensure/link.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var mkdir = require_mkdirs();
    var pathExists = require_path_exists().pathExists;
    var { areIdentical } = require_stat();
    function createLink(srcpath, dstpath, callback) {
      function makeLink(srcpath2, dstpath2) {
        fs4.link(srcpath2, dstpath2, (err) => {
          if (err)
            return callback(err);
          callback(null);
        });
      }
      fs4.lstat(dstpath, (_, dstStat) => {
        fs4.lstat(srcpath, (err, srcStat) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureLink");
            return callback(err);
          }
          if (dstStat && areIdentical(srcStat, dstStat))
            return callback(null);
          const dir = path4.dirname(dstpath);
          pathExists(dir, (err2, dirExists) => {
            if (err2)
              return callback(err2);
            if (dirExists)
              return makeLink(srcpath, dstpath);
            mkdir.mkdirs(dir, (err3) => {
              if (err3)
                return callback(err3);
              makeLink(srcpath, dstpath);
            });
          });
        });
      });
    }
    function createLinkSync(srcpath, dstpath) {
      let dstStat;
      try {
        dstStat = fs4.lstatSync(dstpath);
      } catch {
      }
      try {
        const srcStat = fs4.lstatSync(srcpath);
        if (dstStat && areIdentical(srcStat, dstStat))
          return;
      } catch (err) {
        err.message = err.message.replace("lstat", "ensureLink");
        throw err;
      }
      const dir = path4.dirname(dstpath);
      const dirExists = fs4.existsSync(dir);
      if (dirExists)
        return fs4.linkSync(srcpath, dstpath);
      mkdir.mkdirsSync(dir);
      return fs4.linkSync(srcpath, dstpath);
    }
    module2.exports = {
      createLink: u(createLink),
      createLinkSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/symlink-paths.js
var require_symlink_paths = __commonJS({
  "node_modules/fs-extra/lib/ensure/symlink-paths.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var pathExists = require_path_exists().pathExists;
    function symlinkPaths(srcpath, dstpath, callback) {
      if (path4.isAbsolute(srcpath)) {
        return fs4.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureSymlink");
            return callback(err);
          }
          return callback(null, {
            toCwd: srcpath,
            toDst: srcpath
          });
        });
      } else {
        const dstdir = path4.dirname(dstpath);
        const relativeToDst = path4.join(dstdir, srcpath);
        return pathExists(relativeToDst, (err, exists) => {
          if (err)
            return callback(err);
          if (exists) {
            return callback(null, {
              toCwd: relativeToDst,
              toDst: srcpath
            });
          } else {
            return fs4.lstat(srcpath, (err2) => {
              if (err2) {
                err2.message = err2.message.replace("lstat", "ensureSymlink");
                return callback(err2);
              }
              return callback(null, {
                toCwd: srcpath,
                toDst: path4.relative(dstdir, srcpath)
              });
            });
          }
        });
      }
    }
    function symlinkPathsSync(srcpath, dstpath) {
      let exists;
      if (path4.isAbsolute(srcpath)) {
        exists = fs4.existsSync(srcpath);
        if (!exists)
          throw new Error("absolute srcpath does not exist");
        return {
          toCwd: srcpath,
          toDst: srcpath
        };
      } else {
        const dstdir = path4.dirname(dstpath);
        const relativeToDst = path4.join(dstdir, srcpath);
        exists = fs4.existsSync(relativeToDst);
        if (exists) {
          return {
            toCwd: relativeToDst,
            toDst: srcpath
          };
        } else {
          exists = fs4.existsSync(srcpath);
          if (!exists)
            throw new Error("relative srcpath does not exist");
          return {
            toCwd: srcpath,
            toDst: path4.relative(dstdir, srcpath)
          };
        }
      }
    }
    module2.exports = {
      symlinkPaths,
      symlinkPathsSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/symlink-type.js
var require_symlink_type = __commonJS({
  "node_modules/fs-extra/lib/ensure/symlink-type.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    function symlinkType(srcpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      if (type)
        return callback(null, type);
      fs4.lstat(srcpath, (err, stats) => {
        if (err)
          return callback(null, "file");
        type = stats && stats.isDirectory() ? "dir" : "file";
        callback(null, type);
      });
    }
    function symlinkTypeSync(srcpath, type) {
      let stats;
      if (type)
        return type;
      try {
        stats = fs4.lstatSync(srcpath);
      } catch {
        return "file";
      }
      return stats && stats.isDirectory() ? "dir" : "file";
    }
    module2.exports = {
      symlinkType,
      symlinkTypeSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/symlink.js
var require_symlink = __commonJS({
  "node_modules/fs-extra/lib/ensure/symlink.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var path4 = require("path");
    var fs4 = require_fs();
    var _mkdirs = require_mkdirs();
    var mkdirs = _mkdirs.mkdirs;
    var mkdirsSync = _mkdirs.mkdirsSync;
    var _symlinkPaths = require_symlink_paths();
    var symlinkPaths = _symlinkPaths.symlinkPaths;
    var symlinkPathsSync = _symlinkPaths.symlinkPathsSync;
    var _symlinkType = require_symlink_type();
    var symlinkType = _symlinkType.symlinkType;
    var symlinkTypeSync = _symlinkType.symlinkTypeSync;
    var pathExists = require_path_exists().pathExists;
    var { areIdentical } = require_stat();
    function createSymlink(srcpath, dstpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      fs4.lstat(dstpath, (err, stats) => {
        if (!err && stats.isSymbolicLink()) {
          Promise.all([
            fs4.stat(srcpath),
            fs4.stat(dstpath)
          ]).then(([srcStat, dstStat]) => {
            if (areIdentical(srcStat, dstStat))
              return callback(null);
            _createSymlink(srcpath, dstpath, type, callback);
          });
        } else
          _createSymlink(srcpath, dstpath, type, callback);
      });
    }
    function _createSymlink(srcpath, dstpath, type, callback) {
      symlinkPaths(srcpath, dstpath, (err, relative) => {
        if (err)
          return callback(err);
        srcpath = relative.toDst;
        symlinkType(relative.toCwd, type, (err2, type2) => {
          if (err2)
            return callback(err2);
          const dir = path4.dirname(dstpath);
          pathExists(dir, (err3, dirExists) => {
            if (err3)
              return callback(err3);
            if (dirExists)
              return fs4.symlink(srcpath, dstpath, type2, callback);
            mkdirs(dir, (err4) => {
              if (err4)
                return callback(err4);
              fs4.symlink(srcpath, dstpath, type2, callback);
            });
          });
        });
      });
    }
    function createSymlinkSync(srcpath, dstpath, type) {
      let stats;
      try {
        stats = fs4.lstatSync(dstpath);
      } catch {
      }
      if (stats && stats.isSymbolicLink()) {
        const srcStat = fs4.statSync(srcpath);
        const dstStat = fs4.statSync(dstpath);
        if (areIdentical(srcStat, dstStat))
          return;
      }
      const relative = symlinkPathsSync(srcpath, dstpath);
      srcpath = relative.toDst;
      type = symlinkTypeSync(relative.toCwd, type);
      const dir = path4.dirname(dstpath);
      const exists = fs4.existsSync(dir);
      if (exists)
        return fs4.symlinkSync(srcpath, dstpath, type);
      mkdirsSync(dir);
      return fs4.symlinkSync(srcpath, dstpath, type);
    }
    module2.exports = {
      createSymlink: u(createSymlink),
      createSymlinkSync
    };
  }
});

// node_modules/fs-extra/lib/ensure/index.js
var require_ensure = __commonJS({
  "node_modules/fs-extra/lib/ensure/index.js"(exports, module2) {
    "use strict";
    var { createFile, createFileSync } = require_file();
    var { createLink, createLinkSync } = require_link();
    var { createSymlink, createSymlinkSync } = require_symlink();
    module2.exports = {
      createFile,
      createFileSync,
      ensureFile: createFile,
      ensureFileSync: createFileSync,
      createLink,
      createLinkSync,
      ensureLink: createLink,
      ensureLinkSync: createLinkSync,
      createSymlink,
      createSymlinkSync,
      ensureSymlink: createSymlink,
      ensureSymlinkSync: createSymlinkSync
    };
  }
});

// node_modules/fs-extra/node_modules/jsonfile/utils.js
var require_utils6 = __commonJS({
  "node_modules/fs-extra/node_modules/jsonfile/utils.js"(exports, module2) {
    function stringify(obj, { EOL = "\n", finalEOL = true, replacer = null, spaces } = {}) {
      const EOF = finalEOL ? EOL : "";
      const str = JSON.stringify(obj, replacer, spaces);
      return str.replace(/\n/g, EOL) + EOF;
    }
    function stripBom(content) {
      if (Buffer.isBuffer(content))
        content = content.toString("utf8");
      return content.replace(/^\uFEFF/, "");
    }
    module2.exports = { stringify, stripBom };
  }
});

// node_modules/fs-extra/node_modules/jsonfile/index.js
var require_jsonfile = __commonJS({
  "node_modules/fs-extra/node_modules/jsonfile/index.js"(exports, module2) {
    var _fs;
    try {
      _fs = require_graceful_fs();
    } catch (_) {
      _fs = require("fs");
    }
    var universalify = require_universalify();
    var { stringify, stripBom } = require_utils6();
    async function _readFile(file, options = {}) {
      if (typeof options === "string") {
        options = { encoding: options };
      }
      const fs4 = options.fs || _fs;
      const shouldThrow = "throws" in options ? options.throws : true;
      let data = await universalify.fromCallback(fs4.readFile)(file, options);
      data = stripBom(data);
      let obj;
      try {
        obj = JSON.parse(data, options ? options.reviver : null);
      } catch (err) {
        if (shouldThrow) {
          err.message = `${file}: ${err.message}`;
          throw err;
        } else {
          return null;
        }
      }
      return obj;
    }
    var readFile = universalify.fromPromise(_readFile);
    function readFileSync(file, options = {}) {
      if (typeof options === "string") {
        options = { encoding: options };
      }
      const fs4 = options.fs || _fs;
      const shouldThrow = "throws" in options ? options.throws : true;
      try {
        let content = fs4.readFileSync(file, options);
        content = stripBom(content);
        return JSON.parse(content, options.reviver);
      } catch (err) {
        if (shouldThrow) {
          err.message = `${file}: ${err.message}`;
          throw err;
        } else {
          return null;
        }
      }
    }
    async function _writeFile(file, obj, options = {}) {
      const fs4 = options.fs || _fs;
      const str = stringify(obj, options);
      await universalify.fromCallback(fs4.writeFile)(file, str, options);
    }
    var writeFile2 = universalify.fromPromise(_writeFile);
    function writeFileSync(file, obj, options = {}) {
      const fs4 = options.fs || _fs;
      const str = stringify(obj, options);
      return fs4.writeFileSync(file, str, options);
    }
    var jsonfile = {
      readFile,
      readFileSync,
      writeFile: writeFile2,
      writeFileSync
    };
    module2.exports = jsonfile;
  }
});

// node_modules/fs-extra/lib/json/jsonfile.js
var require_jsonfile2 = __commonJS({
  "node_modules/fs-extra/lib/json/jsonfile.js"(exports, module2) {
    "use strict";
    var jsonFile = require_jsonfile();
    module2.exports = {
      readJson: jsonFile.readFile,
      readJsonSync: jsonFile.readFileSync,
      writeJson: jsonFile.writeFile,
      writeJsonSync: jsonFile.writeFileSync
    };
  }
});

// node_modules/fs-extra/lib/output-file/index.js
var require_output_file = __commonJS({
  "node_modules/fs-extra/lib/output-file/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdir = require_mkdirs();
    var pathExists = require_path_exists().pathExists;
    function outputFile(file, data, encoding, callback) {
      if (typeof encoding === "function") {
        callback = encoding;
        encoding = "utf8";
      }
      const dir = path4.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return fs4.writeFile(file, data, encoding, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          fs4.writeFile(file, data, encoding, callback);
        });
      });
    }
    function outputFileSync(file, ...args) {
      const dir = path4.dirname(file);
      if (fs4.existsSync(dir)) {
        return fs4.writeFileSync(file, ...args);
      }
      mkdir.mkdirsSync(dir);
      fs4.writeFileSync(file, ...args);
    }
    module2.exports = {
      outputFile: u(outputFile),
      outputFileSync
    };
  }
});

// node_modules/fs-extra/lib/json/output-json.js
var require_output_json = __commonJS({
  "node_modules/fs-extra/lib/json/output-json.js"(exports, module2) {
    "use strict";
    var { stringify } = require_utils6();
    var { outputFile } = require_output_file();
    async function outputJson(file, data, options = {}) {
      const str = stringify(data, options);
      await outputFile(file, str, options);
    }
    module2.exports = outputJson;
  }
});

// node_modules/fs-extra/lib/json/output-json-sync.js
var require_output_json_sync = __commonJS({
  "node_modules/fs-extra/lib/json/output-json-sync.js"(exports, module2) {
    "use strict";
    var { stringify } = require_utils6();
    var { outputFileSync } = require_output_file();
    function outputJsonSync(file, data, options) {
      const str = stringify(data, options);
      outputFileSync(file, str, options);
    }
    module2.exports = outputJsonSync;
  }
});

// node_modules/fs-extra/lib/json/index.js
var require_json = __commonJS({
  "node_modules/fs-extra/lib/json/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromPromise;
    var jsonFile = require_jsonfile2();
    jsonFile.outputJson = u(require_output_json());
    jsonFile.outputJsonSync = require_output_json_sync();
    jsonFile.outputJSON = jsonFile.outputJson;
    jsonFile.outputJSONSync = jsonFile.outputJsonSync;
    jsonFile.writeJSON = jsonFile.writeJson;
    jsonFile.writeJSONSync = jsonFile.writeJsonSync;
    jsonFile.readJSON = jsonFile.readJson;
    jsonFile.readJSONSync = jsonFile.readJsonSync;
    module2.exports = jsonFile;
  }
});

// node_modules/fs-extra/lib/move/move.js
var require_move = __commonJS({
  "node_modules/fs-extra/lib/move/move.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var copy = require_copy2().copy;
    var remove = require_remove2().remove;
    var mkdirp2 = require_mkdirs().mkdirp;
    var pathExists = require_path_exists().pathExists;
    var stat3 = require_stat();
    function move(src, dest, opts, cb) {
      if (typeof opts === "function") {
        cb = opts;
        opts = {};
      }
      opts = opts || {};
      const overwrite = opts.overwrite || opts.clobber || false;
      stat3.checkPaths(src, dest, "move", opts, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, isChangingCase = false } = stats;
        stat3.checkParentPaths(src, srcStat, dest, "move", (err2) => {
          if (err2)
            return cb(err2);
          if (isParentRoot(dest))
            return doRename(src, dest, overwrite, isChangingCase, cb);
          mkdirp2(path4.dirname(dest), (err3) => {
            if (err3)
              return cb(err3);
            return doRename(src, dest, overwrite, isChangingCase, cb);
          });
        });
      });
    }
    function isParentRoot(dest) {
      const parent = path4.dirname(dest);
      const parsedPath = path4.parse(parent);
      return parsedPath.root === parent;
    }
    function doRename(src, dest, overwrite, isChangingCase, cb) {
      if (isChangingCase)
        return rename(src, dest, overwrite, cb);
      if (overwrite) {
        return remove(dest, (err) => {
          if (err)
            return cb(err);
          return rename(src, dest, overwrite, cb);
        });
      }
      pathExists(dest, (err, destExists) => {
        if (err)
          return cb(err);
        if (destExists)
          return cb(new Error("dest already exists."));
        return rename(src, dest, overwrite, cb);
      });
    }
    function rename(src, dest, overwrite, cb) {
      fs4.rename(src, dest, (err) => {
        if (!err)
          return cb();
        if (err.code !== "EXDEV")
          return cb(err);
        return moveAcrossDevice(src, dest, overwrite, cb);
      });
    }
    function moveAcrossDevice(src, dest, overwrite, cb) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copy(src, dest, opts, (err) => {
        if (err)
          return cb(err);
        return remove(src, cb);
      });
    }
    module2.exports = move;
  }
});

// node_modules/fs-extra/lib/move/move-sync.js
var require_move_sync = __commonJS({
  "node_modules/fs-extra/lib/move/move-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var copySync = require_copy2().copySync;
    var removeSync = require_remove2().removeSync;
    var mkdirpSync = require_mkdirs().mkdirpSync;
    var stat3 = require_stat();
    function moveSync(src, dest, opts) {
      opts = opts || {};
      const overwrite = opts.overwrite || opts.clobber || false;
      const { srcStat, isChangingCase = false } = stat3.checkPathsSync(src, dest, "move", opts);
      stat3.checkParentPathsSync(src, srcStat, dest, "move");
      if (!isParentRoot(dest))
        mkdirpSync(path4.dirname(dest));
      return doRename(src, dest, overwrite, isChangingCase);
    }
    function isParentRoot(dest) {
      const parent = path4.dirname(dest);
      const parsedPath = path4.parse(parent);
      return parsedPath.root === parent;
    }
    function doRename(src, dest, overwrite, isChangingCase) {
      if (isChangingCase)
        return rename(src, dest, overwrite);
      if (overwrite) {
        removeSync(dest);
        return rename(src, dest, overwrite);
      }
      if (fs4.existsSync(dest))
        throw new Error("dest already exists.");
      return rename(src, dest, overwrite);
    }
    function rename(src, dest, overwrite) {
      try {
        fs4.renameSync(src, dest);
      } catch (err) {
        if (err.code !== "EXDEV")
          throw err;
        return moveAcrossDevice(src, dest, overwrite);
      }
    }
    function moveAcrossDevice(src, dest, overwrite) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copySync(src, dest, opts);
      return removeSync(src);
    }
    module2.exports = moveSync;
  }
});

// node_modules/fs-extra/lib/move/index.js
var require_move2 = __commonJS({
  "node_modules/fs-extra/lib/move/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify().fromCallback;
    module2.exports = {
      move: u(require_move()),
      moveSync: require_move_sync()
    };
  }
});

// node_modules/fs-extra/lib/index.js
var require_lib3 = __commonJS({
  "node_modules/fs-extra/lib/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      ...require_fs(),
      ...require_copy2(),
      ...require_empty(),
      ...require_ensure(),
      ...require_json(),
      ...require_mkdirs(),
      ...require_move2(),
      ...require_output_file(),
      ...require_path_exists(),
      ...require_remove2()
    };
  }
});

// node_modules/web-streams-polyfill/dist/ponyfill.es2018.js
var require_ponyfill_es2018 = __commonJS({
  "node_modules/web-streams-polyfill/dist/ponyfill.es2018.js"(exports, module2) {
    (function(global2, factory) {
      typeof exports === "object" && typeof module2 !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global2 = typeof globalThis !== "undefined" ? globalThis : global2 || self, factory(global2.WebStreamsPolyfill = {}));
    })(exports, function(exports2) {
      "use strict";
      const SymbolPolyfill = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? Symbol : (description) => `Symbol(${description})`;
      function noop2() {
        return void 0;
      }
      function getGlobals() {
        if (typeof self !== "undefined") {
          return self;
        } else if (typeof window !== "undefined") {
          return window;
        } else if (typeof global !== "undefined") {
          return global;
        }
        return void 0;
      }
      const globals = getGlobals();
      function typeIsObject(x2) {
        return typeof x2 === "object" && x2 !== null || typeof x2 === "function";
      }
      const rethrowAssertionErrorRejection = noop2;
      const originalPromise = Promise;
      const originalPromiseThen = Promise.prototype.then;
      const originalPromiseResolve = Promise.resolve.bind(originalPromise);
      const originalPromiseReject = Promise.reject.bind(originalPromise);
      function newPromise(executor) {
        return new originalPromise(executor);
      }
      function promiseResolvedWith(value) {
        return originalPromiseResolve(value);
      }
      function promiseRejectedWith(reason) {
        return originalPromiseReject(reason);
      }
      function PerformPromiseThen(promise, onFulfilled, onRejected) {
        return originalPromiseThen.call(promise, onFulfilled, onRejected);
      }
      function uponPromise(promise, onFulfilled, onRejected) {
        PerformPromiseThen(PerformPromiseThen(promise, onFulfilled, onRejected), void 0, rethrowAssertionErrorRejection);
      }
      function uponFulfillment(promise, onFulfilled) {
        uponPromise(promise, onFulfilled);
      }
      function uponRejection(promise, onRejected) {
        uponPromise(promise, void 0, onRejected);
      }
      function transformPromiseWith(promise, fulfillmentHandler, rejectionHandler) {
        return PerformPromiseThen(promise, fulfillmentHandler, rejectionHandler);
      }
      function setPromiseIsHandledToTrue(promise) {
        PerformPromiseThen(promise, void 0, rethrowAssertionErrorRejection);
      }
      const queueMicrotask2 = (() => {
        const globalQueueMicrotask = globals && globals.queueMicrotask;
        if (typeof globalQueueMicrotask === "function") {
          return globalQueueMicrotask;
        }
        const resolvedPromise = promiseResolvedWith(void 0);
        return (fn) => PerformPromiseThen(resolvedPromise, fn);
      })();
      function reflectCall(F2, V, args) {
        if (typeof F2 !== "function") {
          throw new TypeError("Argument is not a function");
        }
        return Function.prototype.apply.call(F2, V, args);
      }
      function promiseCall(F2, V, args) {
        try {
          return promiseResolvedWith(reflectCall(F2, V, args));
        } catch (value) {
          return promiseRejectedWith(value);
        }
      }
      const QUEUE_MAX_ARRAY_SIZE = 16384;
      class SimpleQueue {
        constructor() {
          this._cursor = 0;
          this._size = 0;
          this._front = {
            _elements: [],
            _next: void 0
          };
          this._back = this._front;
          this._cursor = 0;
          this._size = 0;
        }
        get length() {
          return this._size;
        }
        push(element) {
          const oldBack = this._back;
          let newBack = oldBack;
          if (oldBack._elements.length === QUEUE_MAX_ARRAY_SIZE - 1) {
            newBack = {
              _elements: [],
              _next: void 0
            };
          }
          oldBack._elements.push(element);
          if (newBack !== oldBack) {
            this._back = newBack;
            oldBack._next = newBack;
          }
          ++this._size;
        }
        shift() {
          const oldFront = this._front;
          let newFront = oldFront;
          const oldCursor = this._cursor;
          let newCursor = oldCursor + 1;
          const elements = oldFront._elements;
          const element = elements[oldCursor];
          if (newCursor === QUEUE_MAX_ARRAY_SIZE) {
            newFront = oldFront._next;
            newCursor = 0;
          }
          --this._size;
          this._cursor = newCursor;
          if (oldFront !== newFront) {
            this._front = newFront;
          }
          elements[oldCursor] = void 0;
          return element;
        }
        forEach(callback) {
          let i2 = this._cursor;
          let node = this._front;
          let elements = node._elements;
          while (i2 !== elements.length || node._next !== void 0) {
            if (i2 === elements.length) {
              node = node._next;
              elements = node._elements;
              i2 = 0;
              if (elements.length === 0) {
                break;
              }
            }
            callback(elements[i2]);
            ++i2;
          }
        }
        peek() {
          const front = this._front;
          const cursor = this._cursor;
          return front._elements[cursor];
        }
      }
      function ReadableStreamReaderGenericInitialize(reader, stream) {
        reader._ownerReadableStream = stream;
        stream._reader = reader;
        if (stream._state === "readable") {
          defaultReaderClosedPromiseInitialize(reader);
        } else if (stream._state === "closed") {
          defaultReaderClosedPromiseInitializeAsResolved(reader);
        } else {
          defaultReaderClosedPromiseInitializeAsRejected(reader, stream._storedError);
        }
      }
      function ReadableStreamReaderGenericCancel(reader, reason) {
        const stream = reader._ownerReadableStream;
        return ReadableStreamCancel(stream, reason);
      }
      function ReadableStreamReaderGenericRelease(reader) {
        if (reader._ownerReadableStream._state === "readable") {
          defaultReaderClosedPromiseReject(reader, new TypeError(`Reader was released and can no longer be used to monitor the stream's closedness`));
        } else {
          defaultReaderClosedPromiseResetToRejected(reader, new TypeError(`Reader was released and can no longer be used to monitor the stream's closedness`));
        }
        reader._ownerReadableStream._reader = void 0;
        reader._ownerReadableStream = void 0;
      }
      function readerLockException(name) {
        return new TypeError("Cannot " + name + " a stream using a released reader");
      }
      function defaultReaderClosedPromiseInitialize(reader) {
        reader._closedPromise = newPromise((resolve, reject) => {
          reader._closedPromise_resolve = resolve;
          reader._closedPromise_reject = reject;
        });
      }
      function defaultReaderClosedPromiseInitializeAsRejected(reader, reason) {
        defaultReaderClosedPromiseInitialize(reader);
        defaultReaderClosedPromiseReject(reader, reason);
      }
      function defaultReaderClosedPromiseInitializeAsResolved(reader) {
        defaultReaderClosedPromiseInitialize(reader);
        defaultReaderClosedPromiseResolve(reader);
      }
      function defaultReaderClosedPromiseReject(reader, reason) {
        if (reader._closedPromise_reject === void 0) {
          return;
        }
        setPromiseIsHandledToTrue(reader._closedPromise);
        reader._closedPromise_reject(reason);
        reader._closedPromise_resolve = void 0;
        reader._closedPromise_reject = void 0;
      }
      function defaultReaderClosedPromiseResetToRejected(reader, reason) {
        defaultReaderClosedPromiseInitializeAsRejected(reader, reason);
      }
      function defaultReaderClosedPromiseResolve(reader) {
        if (reader._closedPromise_resolve === void 0) {
          return;
        }
        reader._closedPromise_resolve(void 0);
        reader._closedPromise_resolve = void 0;
        reader._closedPromise_reject = void 0;
      }
      const AbortSteps = SymbolPolyfill("[[AbortSteps]]");
      const ErrorSteps = SymbolPolyfill("[[ErrorSteps]]");
      const CancelSteps = SymbolPolyfill("[[CancelSteps]]");
      const PullSteps = SymbolPolyfill("[[PullSteps]]");
      const NumberIsFinite = Number.isFinite || function(x2) {
        return typeof x2 === "number" && isFinite(x2);
      };
      const MathTrunc = Math.trunc || function(v) {
        return v < 0 ? Math.ceil(v) : Math.floor(v);
      };
      function isDictionary(x2) {
        return typeof x2 === "object" || typeof x2 === "function";
      }
      function assertDictionary(obj, context2) {
        if (obj !== void 0 && !isDictionary(obj)) {
          throw new TypeError(`${context2} is not an object.`);
        }
      }
      function assertFunction(x2, context2) {
        if (typeof x2 !== "function") {
          throw new TypeError(`${context2} is not a function.`);
        }
      }
      function isObject3(x2) {
        return typeof x2 === "object" && x2 !== null || typeof x2 === "function";
      }
      function assertObject(x2, context2) {
        if (!isObject3(x2)) {
          throw new TypeError(`${context2} is not an object.`);
        }
      }
      function assertRequiredArgument(x2, position, context2) {
        if (x2 === void 0) {
          throw new TypeError(`Parameter ${position} is required in '${context2}'.`);
        }
      }
      function assertRequiredField(x2, field, context2) {
        if (x2 === void 0) {
          throw new TypeError(`${field} is required in '${context2}'.`);
        }
      }
      function convertUnrestrictedDouble(value) {
        return Number(value);
      }
      function censorNegativeZero(x2) {
        return x2 === 0 ? 0 : x2;
      }
      function integerPart(x2) {
        return censorNegativeZero(MathTrunc(x2));
      }
      function convertUnsignedLongLongWithEnforceRange(value, context2) {
        const lowerBound = 0;
        const upperBound = Number.MAX_SAFE_INTEGER;
        let x2 = Number(value);
        x2 = censorNegativeZero(x2);
        if (!NumberIsFinite(x2)) {
          throw new TypeError(`${context2} is not a finite number`);
        }
        x2 = integerPart(x2);
        if (x2 < lowerBound || x2 > upperBound) {
          throw new TypeError(`${context2} is outside the accepted range of ${lowerBound} to ${upperBound}, inclusive`);
        }
        if (!NumberIsFinite(x2) || x2 === 0) {
          return 0;
        }
        return x2;
      }
      function assertReadableStream(x2, context2) {
        if (!IsReadableStream(x2)) {
          throw new TypeError(`${context2} is not a ReadableStream.`);
        }
      }
      function AcquireReadableStreamDefaultReader(stream) {
        return new ReadableStreamDefaultReader(stream);
      }
      function ReadableStreamAddReadRequest(stream, readRequest) {
        stream._reader._readRequests.push(readRequest);
      }
      function ReadableStreamFulfillReadRequest(stream, chunk, done) {
        const reader = stream._reader;
        const readRequest = reader._readRequests.shift();
        if (done) {
          readRequest._closeSteps();
        } else {
          readRequest._chunkSteps(chunk);
        }
      }
      function ReadableStreamGetNumReadRequests(stream) {
        return stream._reader._readRequests.length;
      }
      function ReadableStreamHasDefaultReader(stream) {
        const reader = stream._reader;
        if (reader === void 0) {
          return false;
        }
        if (!IsReadableStreamDefaultReader(reader)) {
          return false;
        }
        return true;
      }
      class ReadableStreamDefaultReader {
        constructor(stream) {
          assertRequiredArgument(stream, 1, "ReadableStreamDefaultReader");
          assertReadableStream(stream, "First parameter");
          if (IsReadableStreamLocked(stream)) {
            throw new TypeError("This stream has already been locked for exclusive reading by another reader");
          }
          ReadableStreamReaderGenericInitialize(this, stream);
          this._readRequests = new SimpleQueue();
        }
        get closed() {
          if (!IsReadableStreamDefaultReader(this)) {
            return promiseRejectedWith(defaultReaderBrandCheckException("closed"));
          }
          return this._closedPromise;
        }
        cancel(reason = void 0) {
          if (!IsReadableStreamDefaultReader(this)) {
            return promiseRejectedWith(defaultReaderBrandCheckException("cancel"));
          }
          if (this._ownerReadableStream === void 0) {
            return promiseRejectedWith(readerLockException("cancel"));
          }
          return ReadableStreamReaderGenericCancel(this, reason);
        }
        read() {
          if (!IsReadableStreamDefaultReader(this)) {
            return promiseRejectedWith(defaultReaderBrandCheckException("read"));
          }
          if (this._ownerReadableStream === void 0) {
            return promiseRejectedWith(readerLockException("read from"));
          }
          let resolvePromise;
          let rejectPromise;
          const promise = newPromise((resolve, reject) => {
            resolvePromise = resolve;
            rejectPromise = reject;
          });
          const readRequest = {
            _chunkSteps: (chunk) => resolvePromise({ value: chunk, done: false }),
            _closeSteps: () => resolvePromise({ value: void 0, done: true }),
            _errorSteps: (e2) => rejectPromise(e2)
          };
          ReadableStreamDefaultReaderRead(this, readRequest);
          return promise;
        }
        releaseLock() {
          if (!IsReadableStreamDefaultReader(this)) {
            throw defaultReaderBrandCheckException("releaseLock");
          }
          if (this._ownerReadableStream === void 0) {
            return;
          }
          if (this._readRequests.length > 0) {
            throw new TypeError("Tried to release a reader lock when that reader has pending read() calls un-settled");
          }
          ReadableStreamReaderGenericRelease(this);
        }
      }
      Object.defineProperties(ReadableStreamDefaultReader.prototype, {
        cancel: { enumerable: true },
        read: { enumerable: true },
        releaseLock: { enumerable: true },
        closed: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(ReadableStreamDefaultReader.prototype, SymbolPolyfill.toStringTag, {
          value: "ReadableStreamDefaultReader",
          configurable: true
        });
      }
      function IsReadableStreamDefaultReader(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_readRequests")) {
          return false;
        }
        return x2 instanceof ReadableStreamDefaultReader;
      }
      function ReadableStreamDefaultReaderRead(reader, readRequest) {
        const stream = reader._ownerReadableStream;
        stream._disturbed = true;
        if (stream._state === "closed") {
          readRequest._closeSteps();
        } else if (stream._state === "errored") {
          readRequest._errorSteps(stream._storedError);
        } else {
          stream._readableStreamController[PullSteps](readRequest);
        }
      }
      function defaultReaderBrandCheckException(name) {
        return new TypeError(`ReadableStreamDefaultReader.prototype.${name} can only be used on a ReadableStreamDefaultReader`);
      }
      const AsyncIteratorPrototype = Object.getPrototypeOf(Object.getPrototypeOf(async function* () {
      }).prototype);
      class ReadableStreamAsyncIteratorImpl {
        constructor(reader, preventCancel) {
          this._ongoingPromise = void 0;
          this._isFinished = false;
          this._reader = reader;
          this._preventCancel = preventCancel;
        }
        next() {
          const nextSteps = () => this._nextSteps();
          this._ongoingPromise = this._ongoingPromise ? transformPromiseWith(this._ongoingPromise, nextSteps, nextSteps) : nextSteps();
          return this._ongoingPromise;
        }
        return(value) {
          const returnSteps = () => this._returnSteps(value);
          return this._ongoingPromise ? transformPromiseWith(this._ongoingPromise, returnSteps, returnSteps) : returnSteps();
        }
        _nextSteps() {
          if (this._isFinished) {
            return Promise.resolve({ value: void 0, done: true });
          }
          const reader = this._reader;
          if (reader._ownerReadableStream === void 0) {
            return promiseRejectedWith(readerLockException("iterate"));
          }
          let resolvePromise;
          let rejectPromise;
          const promise = newPromise((resolve, reject) => {
            resolvePromise = resolve;
            rejectPromise = reject;
          });
          const readRequest = {
            _chunkSteps: (chunk) => {
              this._ongoingPromise = void 0;
              queueMicrotask2(() => resolvePromise({ value: chunk, done: false }));
            },
            _closeSteps: () => {
              this._ongoingPromise = void 0;
              this._isFinished = true;
              ReadableStreamReaderGenericRelease(reader);
              resolvePromise({ value: void 0, done: true });
            },
            _errorSteps: (reason) => {
              this._ongoingPromise = void 0;
              this._isFinished = true;
              ReadableStreamReaderGenericRelease(reader);
              rejectPromise(reason);
            }
          };
          ReadableStreamDefaultReaderRead(reader, readRequest);
          return promise;
        }
        _returnSteps(value) {
          if (this._isFinished) {
            return Promise.resolve({ value, done: true });
          }
          this._isFinished = true;
          const reader = this._reader;
          if (reader._ownerReadableStream === void 0) {
            return promiseRejectedWith(readerLockException("finish iterating"));
          }
          if (!this._preventCancel) {
            const result = ReadableStreamReaderGenericCancel(reader, value);
            ReadableStreamReaderGenericRelease(reader);
            return transformPromiseWith(result, () => ({ value, done: true }));
          }
          ReadableStreamReaderGenericRelease(reader);
          return promiseResolvedWith({ value, done: true });
        }
      }
      const ReadableStreamAsyncIteratorPrototype = {
        next() {
          if (!IsReadableStreamAsyncIterator(this)) {
            return promiseRejectedWith(streamAsyncIteratorBrandCheckException("next"));
          }
          return this._asyncIteratorImpl.next();
        },
        return(value) {
          if (!IsReadableStreamAsyncIterator(this)) {
            return promiseRejectedWith(streamAsyncIteratorBrandCheckException("return"));
          }
          return this._asyncIteratorImpl.return(value);
        }
      };
      if (AsyncIteratorPrototype !== void 0) {
        Object.setPrototypeOf(ReadableStreamAsyncIteratorPrototype, AsyncIteratorPrototype);
      }
      function AcquireReadableStreamAsyncIterator(stream, preventCancel) {
        const reader = AcquireReadableStreamDefaultReader(stream);
        const impl = new ReadableStreamAsyncIteratorImpl(reader, preventCancel);
        const iterator2 = Object.create(ReadableStreamAsyncIteratorPrototype);
        iterator2._asyncIteratorImpl = impl;
        return iterator2;
      }
      function IsReadableStreamAsyncIterator(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_asyncIteratorImpl")) {
          return false;
        }
        try {
          return x2._asyncIteratorImpl instanceof ReadableStreamAsyncIteratorImpl;
        } catch (_a4) {
          return false;
        }
      }
      function streamAsyncIteratorBrandCheckException(name) {
        return new TypeError(`ReadableStreamAsyncIterator.${name} can only be used on a ReadableSteamAsyncIterator`);
      }
      const NumberIsNaN = Number.isNaN || function(x2) {
        return x2 !== x2;
      };
      function CreateArrayFromList(elements) {
        return elements.slice();
      }
      function CopyDataBlockBytes(dest, destOffset, src, srcOffset, n) {
        new Uint8Array(dest).set(new Uint8Array(src, srcOffset, n), destOffset);
      }
      function TransferArrayBuffer(O) {
        return O;
      }
      function IsDetachedBuffer(O) {
        return false;
      }
      function ArrayBufferSlice(buffer, begin, end) {
        if (buffer.slice) {
          return buffer.slice(begin, end);
        }
        const length = end - begin;
        const slice = new ArrayBuffer(length);
        CopyDataBlockBytes(slice, 0, buffer, begin, length);
        return slice;
      }
      function IsNonNegativeNumber(v) {
        if (typeof v !== "number") {
          return false;
        }
        if (NumberIsNaN(v)) {
          return false;
        }
        if (v < 0) {
          return false;
        }
        return true;
      }
      function CloneAsUint8Array(O) {
        const buffer = ArrayBufferSlice(O.buffer, O.byteOffset, O.byteOffset + O.byteLength);
        return new Uint8Array(buffer);
      }
      function DequeueValue(container) {
        const pair = container._queue.shift();
        container._queueTotalSize -= pair.size;
        if (container._queueTotalSize < 0) {
          container._queueTotalSize = 0;
        }
        return pair.value;
      }
      function EnqueueValueWithSize(container, value, size) {
        if (!IsNonNegativeNumber(size) || size === Infinity) {
          throw new RangeError("Size must be a finite, non-NaN, non-negative number.");
        }
        container._queue.push({ value, size });
        container._queueTotalSize += size;
      }
      function PeekQueueValue(container) {
        const pair = container._queue.peek();
        return pair.value;
      }
      function ResetQueue(container) {
        container._queue = new SimpleQueue();
        container._queueTotalSize = 0;
      }
      class ReadableStreamBYOBRequest {
        constructor() {
          throw new TypeError("Illegal constructor");
        }
        get view() {
          if (!IsReadableStreamBYOBRequest(this)) {
            throw byobRequestBrandCheckException("view");
          }
          return this._view;
        }
        respond(bytesWritten) {
          if (!IsReadableStreamBYOBRequest(this)) {
            throw byobRequestBrandCheckException("respond");
          }
          assertRequiredArgument(bytesWritten, 1, "respond");
          bytesWritten = convertUnsignedLongLongWithEnforceRange(bytesWritten, "First parameter");
          if (this._associatedReadableByteStreamController === void 0) {
            throw new TypeError("This BYOB request has been invalidated");
          }
          if (IsDetachedBuffer(this._view.buffer))
            ;
          ReadableByteStreamControllerRespond(this._associatedReadableByteStreamController, bytesWritten);
        }
        respondWithNewView(view) {
          if (!IsReadableStreamBYOBRequest(this)) {
            throw byobRequestBrandCheckException("respondWithNewView");
          }
          assertRequiredArgument(view, 1, "respondWithNewView");
          if (!ArrayBuffer.isView(view)) {
            throw new TypeError("You can only respond with array buffer views");
          }
          if (this._associatedReadableByteStreamController === void 0) {
            throw new TypeError("This BYOB request has been invalidated");
          }
          if (IsDetachedBuffer(view.buffer))
            ;
          ReadableByteStreamControllerRespondWithNewView(this._associatedReadableByteStreamController, view);
        }
      }
      Object.defineProperties(ReadableStreamBYOBRequest.prototype, {
        respond: { enumerable: true },
        respondWithNewView: { enumerable: true },
        view: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(ReadableStreamBYOBRequest.prototype, SymbolPolyfill.toStringTag, {
          value: "ReadableStreamBYOBRequest",
          configurable: true
        });
      }
      class ReadableByteStreamController {
        constructor() {
          throw new TypeError("Illegal constructor");
        }
        get byobRequest() {
          if (!IsReadableByteStreamController(this)) {
            throw byteStreamControllerBrandCheckException("byobRequest");
          }
          return ReadableByteStreamControllerGetBYOBRequest(this);
        }
        get desiredSize() {
          if (!IsReadableByteStreamController(this)) {
            throw byteStreamControllerBrandCheckException("desiredSize");
          }
          return ReadableByteStreamControllerGetDesiredSize(this);
        }
        close() {
          if (!IsReadableByteStreamController(this)) {
            throw byteStreamControllerBrandCheckException("close");
          }
          if (this._closeRequested) {
            throw new TypeError("The stream has already been closed; do not close it again!");
          }
          const state = this._controlledReadableByteStream._state;
          if (state !== "readable") {
            throw new TypeError(`The stream (in ${state} state) is not in the readable state and cannot be closed`);
          }
          ReadableByteStreamControllerClose(this);
        }
        enqueue(chunk) {
          if (!IsReadableByteStreamController(this)) {
            throw byteStreamControllerBrandCheckException("enqueue");
          }
          assertRequiredArgument(chunk, 1, "enqueue");
          if (!ArrayBuffer.isView(chunk)) {
            throw new TypeError("chunk must be an array buffer view");
          }
          if (chunk.byteLength === 0) {
            throw new TypeError("chunk must have non-zero byteLength");
          }
          if (chunk.buffer.byteLength === 0) {
            throw new TypeError(`chunk's buffer must have non-zero byteLength`);
          }
          if (this._closeRequested) {
            throw new TypeError("stream is closed or draining");
          }
          const state = this._controlledReadableByteStream._state;
          if (state !== "readable") {
            throw new TypeError(`The stream (in ${state} state) is not in the readable state and cannot be enqueued to`);
          }
          ReadableByteStreamControllerEnqueue(this, chunk);
        }
        error(e2 = void 0) {
          if (!IsReadableByteStreamController(this)) {
            throw byteStreamControllerBrandCheckException("error");
          }
          ReadableByteStreamControllerError(this, e2);
        }
        [CancelSteps](reason) {
          ReadableByteStreamControllerClearPendingPullIntos(this);
          ResetQueue(this);
          const result = this._cancelAlgorithm(reason);
          ReadableByteStreamControllerClearAlgorithms(this);
          return result;
        }
        [PullSteps](readRequest) {
          const stream = this._controlledReadableByteStream;
          if (this._queueTotalSize > 0) {
            const entry = this._queue.shift();
            this._queueTotalSize -= entry.byteLength;
            ReadableByteStreamControllerHandleQueueDrain(this);
            const view = new Uint8Array(entry.buffer, entry.byteOffset, entry.byteLength);
            readRequest._chunkSteps(view);
            return;
          }
          const autoAllocateChunkSize = this._autoAllocateChunkSize;
          if (autoAllocateChunkSize !== void 0) {
            let buffer;
            try {
              buffer = new ArrayBuffer(autoAllocateChunkSize);
            } catch (bufferE) {
              readRequest._errorSteps(bufferE);
              return;
            }
            const pullIntoDescriptor = {
              buffer,
              bufferByteLength: autoAllocateChunkSize,
              byteOffset: 0,
              byteLength: autoAllocateChunkSize,
              bytesFilled: 0,
              elementSize: 1,
              viewConstructor: Uint8Array,
              readerType: "default"
            };
            this._pendingPullIntos.push(pullIntoDescriptor);
          }
          ReadableStreamAddReadRequest(stream, readRequest);
          ReadableByteStreamControllerCallPullIfNeeded(this);
        }
      }
      Object.defineProperties(ReadableByteStreamController.prototype, {
        close: { enumerable: true },
        enqueue: { enumerable: true },
        error: { enumerable: true },
        byobRequest: { enumerable: true },
        desiredSize: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(ReadableByteStreamController.prototype, SymbolPolyfill.toStringTag, {
          value: "ReadableByteStreamController",
          configurable: true
        });
      }
      function IsReadableByteStreamController(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_controlledReadableByteStream")) {
          return false;
        }
        return x2 instanceof ReadableByteStreamController;
      }
      function IsReadableStreamBYOBRequest(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_associatedReadableByteStreamController")) {
          return false;
        }
        return x2 instanceof ReadableStreamBYOBRequest;
      }
      function ReadableByteStreamControllerCallPullIfNeeded(controller) {
        const shouldPull = ReadableByteStreamControllerShouldCallPull(controller);
        if (!shouldPull) {
          return;
        }
        if (controller._pulling) {
          controller._pullAgain = true;
          return;
        }
        controller._pulling = true;
        const pullPromise = controller._pullAlgorithm();
        uponPromise(pullPromise, () => {
          controller._pulling = false;
          if (controller._pullAgain) {
            controller._pullAgain = false;
            ReadableByteStreamControllerCallPullIfNeeded(controller);
          }
        }, (e2) => {
          ReadableByteStreamControllerError(controller, e2);
        });
      }
      function ReadableByteStreamControllerClearPendingPullIntos(controller) {
        ReadableByteStreamControllerInvalidateBYOBRequest(controller);
        controller._pendingPullIntos = new SimpleQueue();
      }
      function ReadableByteStreamControllerCommitPullIntoDescriptor(stream, pullIntoDescriptor) {
        let done = false;
        if (stream._state === "closed") {
          done = true;
        }
        const filledView = ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor);
        if (pullIntoDescriptor.readerType === "default") {
          ReadableStreamFulfillReadRequest(stream, filledView, done);
        } else {
          ReadableStreamFulfillReadIntoRequest(stream, filledView, done);
        }
      }
      function ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor) {
        const bytesFilled = pullIntoDescriptor.bytesFilled;
        const elementSize = pullIntoDescriptor.elementSize;
        return new pullIntoDescriptor.viewConstructor(pullIntoDescriptor.buffer, pullIntoDescriptor.byteOffset, bytesFilled / elementSize);
      }
      function ReadableByteStreamControllerEnqueueChunkToQueue(controller, buffer, byteOffset, byteLength) {
        controller._queue.push({ buffer, byteOffset, byteLength });
        controller._queueTotalSize += byteLength;
      }
      function ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor) {
        const elementSize = pullIntoDescriptor.elementSize;
        const currentAlignedBytes = pullIntoDescriptor.bytesFilled - pullIntoDescriptor.bytesFilled % elementSize;
        const maxBytesToCopy = Math.min(controller._queueTotalSize, pullIntoDescriptor.byteLength - pullIntoDescriptor.bytesFilled);
        const maxBytesFilled = pullIntoDescriptor.bytesFilled + maxBytesToCopy;
        const maxAlignedBytes = maxBytesFilled - maxBytesFilled % elementSize;
        let totalBytesToCopyRemaining = maxBytesToCopy;
        let ready = false;
        if (maxAlignedBytes > currentAlignedBytes) {
          totalBytesToCopyRemaining = maxAlignedBytes - pullIntoDescriptor.bytesFilled;
          ready = true;
        }
        const queue = controller._queue;
        while (totalBytesToCopyRemaining > 0) {
          const headOfQueue = queue.peek();
          const bytesToCopy = Math.min(totalBytesToCopyRemaining, headOfQueue.byteLength);
          const destStart = pullIntoDescriptor.byteOffset + pullIntoDescriptor.bytesFilled;
          CopyDataBlockBytes(pullIntoDescriptor.buffer, destStart, headOfQueue.buffer, headOfQueue.byteOffset, bytesToCopy);
          if (headOfQueue.byteLength === bytesToCopy) {
            queue.shift();
          } else {
            headOfQueue.byteOffset += bytesToCopy;
            headOfQueue.byteLength -= bytesToCopy;
          }
          controller._queueTotalSize -= bytesToCopy;
          ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, bytesToCopy, pullIntoDescriptor);
          totalBytesToCopyRemaining -= bytesToCopy;
        }
        return ready;
      }
      function ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, size, pullIntoDescriptor) {
        pullIntoDescriptor.bytesFilled += size;
      }
      function ReadableByteStreamControllerHandleQueueDrain(controller) {
        if (controller._queueTotalSize === 0 && controller._closeRequested) {
          ReadableByteStreamControllerClearAlgorithms(controller);
          ReadableStreamClose(controller._controlledReadableByteStream);
        } else {
          ReadableByteStreamControllerCallPullIfNeeded(controller);
        }
      }
      function ReadableByteStreamControllerInvalidateBYOBRequest(controller) {
        if (controller._byobRequest === null) {
          return;
        }
        controller._byobRequest._associatedReadableByteStreamController = void 0;
        controller._byobRequest._view = null;
        controller._byobRequest = null;
      }
      function ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller) {
        while (controller._pendingPullIntos.length > 0) {
          if (controller._queueTotalSize === 0) {
            return;
          }
          const pullIntoDescriptor = controller._pendingPullIntos.peek();
          if (ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor)) {
            ReadableByteStreamControllerShiftPendingPullInto(controller);
            ReadableByteStreamControllerCommitPullIntoDescriptor(controller._controlledReadableByteStream, pullIntoDescriptor);
          }
        }
      }
      function ReadableByteStreamControllerPullInto(controller, view, readIntoRequest) {
        const stream = controller._controlledReadableByteStream;
        let elementSize = 1;
        if (view.constructor !== DataView) {
          elementSize = view.constructor.BYTES_PER_ELEMENT;
        }
        const ctor = view.constructor;
        const buffer = TransferArrayBuffer(view.buffer);
        const pullIntoDescriptor = {
          buffer,
          bufferByteLength: buffer.byteLength,
          byteOffset: view.byteOffset,
          byteLength: view.byteLength,
          bytesFilled: 0,
          elementSize,
          viewConstructor: ctor,
          readerType: "byob"
        };
        if (controller._pendingPullIntos.length > 0) {
          controller._pendingPullIntos.push(pullIntoDescriptor);
          ReadableStreamAddReadIntoRequest(stream, readIntoRequest);
          return;
        }
        if (stream._state === "closed") {
          const emptyView = new ctor(pullIntoDescriptor.buffer, pullIntoDescriptor.byteOffset, 0);
          readIntoRequest._closeSteps(emptyView);
          return;
        }
        if (controller._queueTotalSize > 0) {
          if (ReadableByteStreamControllerFillPullIntoDescriptorFromQueue(controller, pullIntoDescriptor)) {
            const filledView = ReadableByteStreamControllerConvertPullIntoDescriptor(pullIntoDescriptor);
            ReadableByteStreamControllerHandleQueueDrain(controller);
            readIntoRequest._chunkSteps(filledView);
            return;
          }
          if (controller._closeRequested) {
            const e2 = new TypeError("Insufficient bytes to fill elements in the given buffer");
            ReadableByteStreamControllerError(controller, e2);
            readIntoRequest._errorSteps(e2);
            return;
          }
        }
        controller._pendingPullIntos.push(pullIntoDescriptor);
        ReadableStreamAddReadIntoRequest(stream, readIntoRequest);
        ReadableByteStreamControllerCallPullIfNeeded(controller);
      }
      function ReadableByteStreamControllerRespondInClosedState(controller, firstDescriptor) {
        const stream = controller._controlledReadableByteStream;
        if (ReadableStreamHasBYOBReader(stream)) {
          while (ReadableStreamGetNumReadIntoRequests(stream) > 0) {
            const pullIntoDescriptor = ReadableByteStreamControllerShiftPendingPullInto(controller);
            ReadableByteStreamControllerCommitPullIntoDescriptor(stream, pullIntoDescriptor);
          }
        }
      }
      function ReadableByteStreamControllerRespondInReadableState(controller, bytesWritten, pullIntoDescriptor) {
        ReadableByteStreamControllerFillHeadPullIntoDescriptor(controller, bytesWritten, pullIntoDescriptor);
        if (pullIntoDescriptor.bytesFilled < pullIntoDescriptor.elementSize) {
          return;
        }
        ReadableByteStreamControllerShiftPendingPullInto(controller);
        const remainderSize = pullIntoDescriptor.bytesFilled % pullIntoDescriptor.elementSize;
        if (remainderSize > 0) {
          const end = pullIntoDescriptor.byteOffset + pullIntoDescriptor.bytesFilled;
          const remainder = ArrayBufferSlice(pullIntoDescriptor.buffer, end - remainderSize, end);
          ReadableByteStreamControllerEnqueueChunkToQueue(controller, remainder, 0, remainder.byteLength);
        }
        pullIntoDescriptor.bytesFilled -= remainderSize;
        ReadableByteStreamControllerCommitPullIntoDescriptor(controller._controlledReadableByteStream, pullIntoDescriptor);
        ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller);
      }
      function ReadableByteStreamControllerRespondInternal(controller, bytesWritten) {
        const firstDescriptor = controller._pendingPullIntos.peek();
        ReadableByteStreamControllerInvalidateBYOBRequest(controller);
        const state = controller._controlledReadableByteStream._state;
        if (state === "closed") {
          ReadableByteStreamControllerRespondInClosedState(controller);
        } else {
          ReadableByteStreamControllerRespondInReadableState(controller, bytesWritten, firstDescriptor);
        }
        ReadableByteStreamControllerCallPullIfNeeded(controller);
      }
      function ReadableByteStreamControllerShiftPendingPullInto(controller) {
        const descriptor = controller._pendingPullIntos.shift();
        return descriptor;
      }
      function ReadableByteStreamControllerShouldCallPull(controller) {
        const stream = controller._controlledReadableByteStream;
        if (stream._state !== "readable") {
          return false;
        }
        if (controller._closeRequested) {
          return false;
        }
        if (!controller._started) {
          return false;
        }
        if (ReadableStreamHasDefaultReader(stream) && ReadableStreamGetNumReadRequests(stream) > 0) {
          return true;
        }
        if (ReadableStreamHasBYOBReader(stream) && ReadableStreamGetNumReadIntoRequests(stream) > 0) {
          return true;
        }
        const desiredSize = ReadableByteStreamControllerGetDesiredSize(controller);
        if (desiredSize > 0) {
          return true;
        }
        return false;
      }
      function ReadableByteStreamControllerClearAlgorithms(controller) {
        controller._pullAlgorithm = void 0;
        controller._cancelAlgorithm = void 0;
      }
      function ReadableByteStreamControllerClose(controller) {
        const stream = controller._controlledReadableByteStream;
        if (controller._closeRequested || stream._state !== "readable") {
          return;
        }
        if (controller._queueTotalSize > 0) {
          controller._closeRequested = true;
          return;
        }
        if (controller._pendingPullIntos.length > 0) {
          const firstPendingPullInto = controller._pendingPullIntos.peek();
          if (firstPendingPullInto.bytesFilled > 0) {
            const e2 = new TypeError("Insufficient bytes to fill elements in the given buffer");
            ReadableByteStreamControllerError(controller, e2);
            throw e2;
          }
        }
        ReadableByteStreamControllerClearAlgorithms(controller);
        ReadableStreamClose(stream);
      }
      function ReadableByteStreamControllerEnqueue(controller, chunk) {
        const stream = controller._controlledReadableByteStream;
        if (controller._closeRequested || stream._state !== "readable") {
          return;
        }
        const buffer = chunk.buffer;
        const byteOffset = chunk.byteOffset;
        const byteLength = chunk.byteLength;
        const transferredBuffer = TransferArrayBuffer(buffer);
        if (controller._pendingPullIntos.length > 0) {
          const firstPendingPullInto = controller._pendingPullIntos.peek();
          if (IsDetachedBuffer(firstPendingPullInto.buffer))
            ;
          firstPendingPullInto.buffer = TransferArrayBuffer(firstPendingPullInto.buffer);
        }
        ReadableByteStreamControllerInvalidateBYOBRequest(controller);
        if (ReadableStreamHasDefaultReader(stream)) {
          if (ReadableStreamGetNumReadRequests(stream) === 0) {
            ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
          } else {
            if (controller._pendingPullIntos.length > 0) {
              ReadableByteStreamControllerShiftPendingPullInto(controller);
            }
            const transferredView = new Uint8Array(transferredBuffer, byteOffset, byteLength);
            ReadableStreamFulfillReadRequest(stream, transferredView, false);
          }
        } else if (ReadableStreamHasBYOBReader(stream)) {
          ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
          ReadableByteStreamControllerProcessPullIntoDescriptorsUsingQueue(controller);
        } else {
          ReadableByteStreamControllerEnqueueChunkToQueue(controller, transferredBuffer, byteOffset, byteLength);
        }
        ReadableByteStreamControllerCallPullIfNeeded(controller);
      }
      function ReadableByteStreamControllerError(controller, e2) {
        const stream = controller._controlledReadableByteStream;
        if (stream._state !== "readable") {
          return;
        }
        ReadableByteStreamControllerClearPendingPullIntos(controller);
        ResetQueue(controller);
        ReadableByteStreamControllerClearAlgorithms(controller);
        ReadableStreamError(stream, e2);
      }
      function ReadableByteStreamControllerGetBYOBRequest(controller) {
        if (controller._byobRequest === null && controller._pendingPullIntos.length > 0) {
          const firstDescriptor = controller._pendingPullIntos.peek();
          const view = new Uint8Array(firstDescriptor.buffer, firstDescriptor.byteOffset + firstDescriptor.bytesFilled, firstDescriptor.byteLength - firstDescriptor.bytesFilled);
          const byobRequest = Object.create(ReadableStreamBYOBRequest.prototype);
          SetUpReadableStreamBYOBRequest(byobRequest, controller, view);
          controller._byobRequest = byobRequest;
        }
        return controller._byobRequest;
      }
      function ReadableByteStreamControllerGetDesiredSize(controller) {
        const state = controller._controlledReadableByteStream._state;
        if (state === "errored") {
          return null;
        }
        if (state === "closed") {
          return 0;
        }
        return controller._strategyHWM - controller._queueTotalSize;
      }
      function ReadableByteStreamControllerRespond(controller, bytesWritten) {
        const firstDescriptor = controller._pendingPullIntos.peek();
        const state = controller._controlledReadableByteStream._state;
        if (state === "closed") {
          if (bytesWritten !== 0) {
            throw new TypeError("bytesWritten must be 0 when calling respond() on a closed stream");
          }
        } else {
          if (bytesWritten === 0) {
            throw new TypeError("bytesWritten must be greater than 0 when calling respond() on a readable stream");
          }
          if (firstDescriptor.bytesFilled + bytesWritten > firstDescriptor.byteLength) {
            throw new RangeError("bytesWritten out of range");
          }
        }
        firstDescriptor.buffer = TransferArrayBuffer(firstDescriptor.buffer);
        ReadableByteStreamControllerRespondInternal(controller, bytesWritten);
      }
      function ReadableByteStreamControllerRespondWithNewView(controller, view) {
        const firstDescriptor = controller._pendingPullIntos.peek();
        const state = controller._controlledReadableByteStream._state;
        if (state === "closed") {
          if (view.byteLength !== 0) {
            throw new TypeError("The view's length must be 0 when calling respondWithNewView() on a closed stream");
          }
        } else {
          if (view.byteLength === 0) {
            throw new TypeError("The view's length must be greater than 0 when calling respondWithNewView() on a readable stream");
          }
        }
        if (firstDescriptor.byteOffset + firstDescriptor.bytesFilled !== view.byteOffset) {
          throw new RangeError("The region specified by view does not match byobRequest");
        }
        if (firstDescriptor.bufferByteLength !== view.buffer.byteLength) {
          throw new RangeError("The buffer of view has different capacity than byobRequest");
        }
        if (firstDescriptor.bytesFilled + view.byteLength > firstDescriptor.byteLength) {
          throw new RangeError("The region specified by view is larger than byobRequest");
        }
        const viewByteLength = view.byteLength;
        firstDescriptor.buffer = TransferArrayBuffer(view.buffer);
        ReadableByteStreamControllerRespondInternal(controller, viewByteLength);
      }
      function SetUpReadableByteStreamController(stream, controller, startAlgorithm, pullAlgorithm, cancelAlgorithm, highWaterMark, autoAllocateChunkSize) {
        controller._controlledReadableByteStream = stream;
        controller._pullAgain = false;
        controller._pulling = false;
        controller._byobRequest = null;
        controller._queue = controller._queueTotalSize = void 0;
        ResetQueue(controller);
        controller._closeRequested = false;
        controller._started = false;
        controller._strategyHWM = highWaterMark;
        controller._pullAlgorithm = pullAlgorithm;
        controller._cancelAlgorithm = cancelAlgorithm;
        controller._autoAllocateChunkSize = autoAllocateChunkSize;
        controller._pendingPullIntos = new SimpleQueue();
        stream._readableStreamController = controller;
        const startResult = startAlgorithm();
        uponPromise(promiseResolvedWith(startResult), () => {
          controller._started = true;
          ReadableByteStreamControllerCallPullIfNeeded(controller);
        }, (r2) => {
          ReadableByteStreamControllerError(controller, r2);
        });
      }
      function SetUpReadableByteStreamControllerFromUnderlyingSource(stream, underlyingByteSource, highWaterMark) {
        const controller = Object.create(ReadableByteStreamController.prototype);
        let startAlgorithm = () => void 0;
        let pullAlgorithm = () => promiseResolvedWith(void 0);
        let cancelAlgorithm = () => promiseResolvedWith(void 0);
        if (underlyingByteSource.start !== void 0) {
          startAlgorithm = () => underlyingByteSource.start(controller);
        }
        if (underlyingByteSource.pull !== void 0) {
          pullAlgorithm = () => underlyingByteSource.pull(controller);
        }
        if (underlyingByteSource.cancel !== void 0) {
          cancelAlgorithm = (reason) => underlyingByteSource.cancel(reason);
        }
        const autoAllocateChunkSize = underlyingByteSource.autoAllocateChunkSize;
        if (autoAllocateChunkSize === 0) {
          throw new TypeError("autoAllocateChunkSize must be greater than 0");
        }
        SetUpReadableByteStreamController(stream, controller, startAlgorithm, pullAlgorithm, cancelAlgorithm, highWaterMark, autoAllocateChunkSize);
      }
      function SetUpReadableStreamBYOBRequest(request2, controller, view) {
        request2._associatedReadableByteStreamController = controller;
        request2._view = view;
      }
      function byobRequestBrandCheckException(name) {
        return new TypeError(`ReadableStreamBYOBRequest.prototype.${name} can only be used on a ReadableStreamBYOBRequest`);
      }
      function byteStreamControllerBrandCheckException(name) {
        return new TypeError(`ReadableByteStreamController.prototype.${name} can only be used on a ReadableByteStreamController`);
      }
      function AcquireReadableStreamBYOBReader(stream) {
        return new ReadableStreamBYOBReader(stream);
      }
      function ReadableStreamAddReadIntoRequest(stream, readIntoRequest) {
        stream._reader._readIntoRequests.push(readIntoRequest);
      }
      function ReadableStreamFulfillReadIntoRequest(stream, chunk, done) {
        const reader = stream._reader;
        const readIntoRequest = reader._readIntoRequests.shift();
        if (done) {
          readIntoRequest._closeSteps(chunk);
        } else {
          readIntoRequest._chunkSteps(chunk);
        }
      }
      function ReadableStreamGetNumReadIntoRequests(stream) {
        return stream._reader._readIntoRequests.length;
      }
      function ReadableStreamHasBYOBReader(stream) {
        const reader = stream._reader;
        if (reader === void 0) {
          return false;
        }
        if (!IsReadableStreamBYOBReader(reader)) {
          return false;
        }
        return true;
      }
      class ReadableStreamBYOBReader {
        constructor(stream) {
          assertRequiredArgument(stream, 1, "ReadableStreamBYOBReader");
          assertReadableStream(stream, "First parameter");
          if (IsReadableStreamLocked(stream)) {
            throw new TypeError("This stream has already been locked for exclusive reading by another reader");
          }
          if (!IsReadableByteStreamController(stream._readableStreamController)) {
            throw new TypeError("Cannot construct a ReadableStreamBYOBReader for a stream not constructed with a byte source");
          }
          ReadableStreamReaderGenericInitialize(this, stream);
          this._readIntoRequests = new SimpleQueue();
        }
        get closed() {
          if (!IsReadableStreamBYOBReader(this)) {
            return promiseRejectedWith(byobReaderBrandCheckException("closed"));
          }
          return this._closedPromise;
        }
        cancel(reason = void 0) {
          if (!IsReadableStreamBYOBReader(this)) {
            return promiseRejectedWith(byobReaderBrandCheckException("cancel"));
          }
          if (this._ownerReadableStream === void 0) {
            return promiseRejectedWith(readerLockException("cancel"));
          }
          return ReadableStreamReaderGenericCancel(this, reason);
        }
        read(view) {
          if (!IsReadableStreamBYOBReader(this)) {
            return promiseRejectedWith(byobReaderBrandCheckException("read"));
          }
          if (!ArrayBuffer.isView(view)) {
            return promiseRejectedWith(new TypeError("view must be an array buffer view"));
          }
          if (view.byteLength === 0) {
            return promiseRejectedWith(new TypeError("view must have non-zero byteLength"));
          }
          if (view.buffer.byteLength === 0) {
            return promiseRejectedWith(new TypeError(`view's buffer must have non-zero byteLength`));
          }
          if (IsDetachedBuffer(view.buffer))
            ;
          if (this._ownerReadableStream === void 0) {
            return promiseRejectedWith(readerLockException("read from"));
          }
          let resolvePromise;
          let rejectPromise;
          const promise = newPromise((resolve, reject) => {
            resolvePromise = resolve;
            rejectPromise = reject;
          });
          const readIntoRequest = {
            _chunkSteps: (chunk) => resolvePromise({ value: chunk, done: false }),
            _closeSteps: (chunk) => resolvePromise({ value: chunk, done: true }),
            _errorSteps: (e2) => rejectPromise(e2)
          };
          ReadableStreamBYOBReaderRead(this, view, readIntoRequest);
          return promise;
        }
        releaseLock() {
          if (!IsReadableStreamBYOBReader(this)) {
            throw byobReaderBrandCheckException("releaseLock");
          }
          if (this._ownerReadableStream === void 0) {
            return;
          }
          if (this._readIntoRequests.length > 0) {
            throw new TypeError("Tried to release a reader lock when that reader has pending read() calls un-settled");
          }
          ReadableStreamReaderGenericRelease(this);
        }
      }
      Object.defineProperties(ReadableStreamBYOBReader.prototype, {
        cancel: { enumerable: true },
        read: { enumerable: true },
        releaseLock: { enumerable: true },
        closed: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(ReadableStreamBYOBReader.prototype, SymbolPolyfill.toStringTag, {
          value: "ReadableStreamBYOBReader",
          configurable: true
        });
      }
      function IsReadableStreamBYOBReader(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_readIntoRequests")) {
          return false;
        }
        return x2 instanceof ReadableStreamBYOBReader;
      }
      function ReadableStreamBYOBReaderRead(reader, view, readIntoRequest) {
        const stream = reader._ownerReadableStream;
        stream._disturbed = true;
        if (stream._state === "errored") {
          readIntoRequest._errorSteps(stream._storedError);
        } else {
          ReadableByteStreamControllerPullInto(stream._readableStreamController, view, readIntoRequest);
        }
      }
      function byobReaderBrandCheckException(name) {
        return new TypeError(`ReadableStreamBYOBReader.prototype.${name} can only be used on a ReadableStreamBYOBReader`);
      }
      function ExtractHighWaterMark(strategy, defaultHWM) {
        const { highWaterMark } = strategy;
        if (highWaterMark === void 0) {
          return defaultHWM;
        }
        if (NumberIsNaN(highWaterMark) || highWaterMark < 0) {
          throw new RangeError("Invalid highWaterMark");
        }
        return highWaterMark;
      }
      function ExtractSizeAlgorithm(strategy) {
        const { size } = strategy;
        if (!size) {
          return () => 1;
        }
        return size;
      }
      function convertQueuingStrategy(init, context2) {
        assertDictionary(init, context2);
        const highWaterMark = init === null || init === void 0 ? void 0 : init.highWaterMark;
        const size = init === null || init === void 0 ? void 0 : init.size;
        return {
          highWaterMark: highWaterMark === void 0 ? void 0 : convertUnrestrictedDouble(highWaterMark),
          size: size === void 0 ? void 0 : convertQueuingStrategySize(size, `${context2} has member 'size' that`)
        };
      }
      function convertQueuingStrategySize(fn, context2) {
        assertFunction(fn, context2);
        return (chunk) => convertUnrestrictedDouble(fn(chunk));
      }
      function convertUnderlyingSink(original, context2) {
        assertDictionary(original, context2);
        const abort = original === null || original === void 0 ? void 0 : original.abort;
        const close = original === null || original === void 0 ? void 0 : original.close;
        const start = original === null || original === void 0 ? void 0 : original.start;
        const type = original === null || original === void 0 ? void 0 : original.type;
        const write = original === null || original === void 0 ? void 0 : original.write;
        return {
          abort: abort === void 0 ? void 0 : convertUnderlyingSinkAbortCallback(abort, original, `${context2} has member 'abort' that`),
          close: close === void 0 ? void 0 : convertUnderlyingSinkCloseCallback(close, original, `${context2} has member 'close' that`),
          start: start === void 0 ? void 0 : convertUnderlyingSinkStartCallback(start, original, `${context2} has member 'start' that`),
          write: write === void 0 ? void 0 : convertUnderlyingSinkWriteCallback(write, original, `${context2} has member 'write' that`),
          type
        };
      }
      function convertUnderlyingSinkAbortCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (reason) => promiseCall(fn, original, [reason]);
      }
      function convertUnderlyingSinkCloseCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return () => promiseCall(fn, original, []);
      }
      function convertUnderlyingSinkStartCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (controller) => reflectCall(fn, original, [controller]);
      }
      function convertUnderlyingSinkWriteCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (chunk, controller) => promiseCall(fn, original, [chunk, controller]);
      }
      function assertWritableStream(x2, context2) {
        if (!IsWritableStream(x2)) {
          throw new TypeError(`${context2} is not a WritableStream.`);
        }
      }
      function isAbortSignal3(value) {
        if (typeof value !== "object" || value === null) {
          return false;
        }
        try {
          return typeof value.aborted === "boolean";
        } catch (_a4) {
          return false;
        }
      }
      const supportsAbortController = typeof AbortController === "function";
      function createAbortController() {
        if (supportsAbortController) {
          return new AbortController();
        }
        return void 0;
      }
      class WritableStream {
        constructor(rawUnderlyingSink = {}, rawStrategy = {}) {
          if (rawUnderlyingSink === void 0) {
            rawUnderlyingSink = null;
          } else {
            assertObject(rawUnderlyingSink, "First parameter");
          }
          const strategy = convertQueuingStrategy(rawStrategy, "Second parameter");
          const underlyingSink = convertUnderlyingSink(rawUnderlyingSink, "First parameter");
          InitializeWritableStream(this);
          const type = underlyingSink.type;
          if (type !== void 0) {
            throw new RangeError("Invalid type is specified");
          }
          const sizeAlgorithm = ExtractSizeAlgorithm(strategy);
          const highWaterMark = ExtractHighWaterMark(strategy, 1);
          SetUpWritableStreamDefaultControllerFromUnderlyingSink(this, underlyingSink, highWaterMark, sizeAlgorithm);
        }
        get locked() {
          if (!IsWritableStream(this)) {
            throw streamBrandCheckException$2("locked");
          }
          return IsWritableStreamLocked(this);
        }
        abort(reason = void 0) {
          if (!IsWritableStream(this)) {
            return promiseRejectedWith(streamBrandCheckException$2("abort"));
          }
          if (IsWritableStreamLocked(this)) {
            return promiseRejectedWith(new TypeError("Cannot abort a stream that already has a writer"));
          }
          return WritableStreamAbort(this, reason);
        }
        close() {
          if (!IsWritableStream(this)) {
            return promiseRejectedWith(streamBrandCheckException$2("close"));
          }
          if (IsWritableStreamLocked(this)) {
            return promiseRejectedWith(new TypeError("Cannot close a stream that already has a writer"));
          }
          if (WritableStreamCloseQueuedOrInFlight(this)) {
            return promiseRejectedWith(new TypeError("Cannot close an already-closing stream"));
          }
          return WritableStreamClose(this);
        }
        getWriter() {
          if (!IsWritableStream(this)) {
            throw streamBrandCheckException$2("getWriter");
          }
          return AcquireWritableStreamDefaultWriter(this);
        }
      }
      Object.defineProperties(WritableStream.prototype, {
        abort: { enumerable: true },
        close: { enumerable: true },
        getWriter: { enumerable: true },
        locked: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(WritableStream.prototype, SymbolPolyfill.toStringTag, {
          value: "WritableStream",
          configurable: true
        });
      }
      function AcquireWritableStreamDefaultWriter(stream) {
        return new WritableStreamDefaultWriter(stream);
      }
      function CreateWritableStream(startAlgorithm, writeAlgorithm, closeAlgorithm, abortAlgorithm, highWaterMark = 1, sizeAlgorithm = () => 1) {
        const stream = Object.create(WritableStream.prototype);
        InitializeWritableStream(stream);
        const controller = Object.create(WritableStreamDefaultController.prototype);
        SetUpWritableStreamDefaultController(stream, controller, startAlgorithm, writeAlgorithm, closeAlgorithm, abortAlgorithm, highWaterMark, sizeAlgorithm);
        return stream;
      }
      function InitializeWritableStream(stream) {
        stream._state = "writable";
        stream._storedError = void 0;
        stream._writer = void 0;
        stream._writableStreamController = void 0;
        stream._writeRequests = new SimpleQueue();
        stream._inFlightWriteRequest = void 0;
        stream._closeRequest = void 0;
        stream._inFlightCloseRequest = void 0;
        stream._pendingAbortRequest = void 0;
        stream._backpressure = false;
      }
      function IsWritableStream(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_writableStreamController")) {
          return false;
        }
        return x2 instanceof WritableStream;
      }
      function IsWritableStreamLocked(stream) {
        if (stream._writer === void 0) {
          return false;
        }
        return true;
      }
      function WritableStreamAbort(stream, reason) {
        var _a4;
        if (stream._state === "closed" || stream._state === "errored") {
          return promiseResolvedWith(void 0);
        }
        stream._writableStreamController._abortReason = reason;
        (_a4 = stream._writableStreamController._abortController) === null || _a4 === void 0 ? void 0 : _a4.abort();
        const state = stream._state;
        if (state === "closed" || state === "errored") {
          return promiseResolvedWith(void 0);
        }
        if (stream._pendingAbortRequest !== void 0) {
          return stream._pendingAbortRequest._promise;
        }
        let wasAlreadyErroring = false;
        if (state === "erroring") {
          wasAlreadyErroring = true;
          reason = void 0;
        }
        const promise = newPromise((resolve, reject) => {
          stream._pendingAbortRequest = {
            _promise: void 0,
            _resolve: resolve,
            _reject: reject,
            _reason: reason,
            _wasAlreadyErroring: wasAlreadyErroring
          };
        });
        stream._pendingAbortRequest._promise = promise;
        if (!wasAlreadyErroring) {
          WritableStreamStartErroring(stream, reason);
        }
        return promise;
      }
      function WritableStreamClose(stream) {
        const state = stream._state;
        if (state === "closed" || state === "errored") {
          return promiseRejectedWith(new TypeError(`The stream (in ${state} state) is not in the writable state and cannot be closed`));
        }
        const promise = newPromise((resolve, reject) => {
          const closeRequest = {
            _resolve: resolve,
            _reject: reject
          };
          stream._closeRequest = closeRequest;
        });
        const writer = stream._writer;
        if (writer !== void 0 && stream._backpressure && state === "writable") {
          defaultWriterReadyPromiseResolve(writer);
        }
        WritableStreamDefaultControllerClose(stream._writableStreamController);
        return promise;
      }
      function WritableStreamAddWriteRequest(stream) {
        const promise = newPromise((resolve, reject) => {
          const writeRequest = {
            _resolve: resolve,
            _reject: reject
          };
          stream._writeRequests.push(writeRequest);
        });
        return promise;
      }
      function WritableStreamDealWithRejection(stream, error) {
        const state = stream._state;
        if (state === "writable") {
          WritableStreamStartErroring(stream, error);
          return;
        }
        WritableStreamFinishErroring(stream);
      }
      function WritableStreamStartErroring(stream, reason) {
        const controller = stream._writableStreamController;
        stream._state = "erroring";
        stream._storedError = reason;
        const writer = stream._writer;
        if (writer !== void 0) {
          WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, reason);
        }
        if (!WritableStreamHasOperationMarkedInFlight(stream) && controller._started) {
          WritableStreamFinishErroring(stream);
        }
      }
      function WritableStreamFinishErroring(stream) {
        stream._state = "errored";
        stream._writableStreamController[ErrorSteps]();
        const storedError = stream._storedError;
        stream._writeRequests.forEach((writeRequest) => {
          writeRequest._reject(storedError);
        });
        stream._writeRequests = new SimpleQueue();
        if (stream._pendingAbortRequest === void 0) {
          WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
          return;
        }
        const abortRequest = stream._pendingAbortRequest;
        stream._pendingAbortRequest = void 0;
        if (abortRequest._wasAlreadyErroring) {
          abortRequest._reject(storedError);
          WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
          return;
        }
        const promise = stream._writableStreamController[AbortSteps](abortRequest._reason);
        uponPromise(promise, () => {
          abortRequest._resolve();
          WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
        }, (reason) => {
          abortRequest._reject(reason);
          WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream);
        });
      }
      function WritableStreamFinishInFlightWrite(stream) {
        stream._inFlightWriteRequest._resolve(void 0);
        stream._inFlightWriteRequest = void 0;
      }
      function WritableStreamFinishInFlightWriteWithError(stream, error) {
        stream._inFlightWriteRequest._reject(error);
        stream._inFlightWriteRequest = void 0;
        WritableStreamDealWithRejection(stream, error);
      }
      function WritableStreamFinishInFlightClose(stream) {
        stream._inFlightCloseRequest._resolve(void 0);
        stream._inFlightCloseRequest = void 0;
        const state = stream._state;
        if (state === "erroring") {
          stream._storedError = void 0;
          if (stream._pendingAbortRequest !== void 0) {
            stream._pendingAbortRequest._resolve();
            stream._pendingAbortRequest = void 0;
          }
        }
        stream._state = "closed";
        const writer = stream._writer;
        if (writer !== void 0) {
          defaultWriterClosedPromiseResolve(writer);
        }
      }
      function WritableStreamFinishInFlightCloseWithError(stream, error) {
        stream._inFlightCloseRequest._reject(error);
        stream._inFlightCloseRequest = void 0;
        if (stream._pendingAbortRequest !== void 0) {
          stream._pendingAbortRequest._reject(error);
          stream._pendingAbortRequest = void 0;
        }
        WritableStreamDealWithRejection(stream, error);
      }
      function WritableStreamCloseQueuedOrInFlight(stream) {
        if (stream._closeRequest === void 0 && stream._inFlightCloseRequest === void 0) {
          return false;
        }
        return true;
      }
      function WritableStreamHasOperationMarkedInFlight(stream) {
        if (stream._inFlightWriteRequest === void 0 && stream._inFlightCloseRequest === void 0) {
          return false;
        }
        return true;
      }
      function WritableStreamMarkCloseRequestInFlight(stream) {
        stream._inFlightCloseRequest = stream._closeRequest;
        stream._closeRequest = void 0;
      }
      function WritableStreamMarkFirstWriteRequestInFlight(stream) {
        stream._inFlightWriteRequest = stream._writeRequests.shift();
      }
      function WritableStreamRejectCloseAndClosedPromiseIfNeeded(stream) {
        if (stream._closeRequest !== void 0) {
          stream._closeRequest._reject(stream._storedError);
          stream._closeRequest = void 0;
        }
        const writer = stream._writer;
        if (writer !== void 0) {
          defaultWriterClosedPromiseReject(writer, stream._storedError);
        }
      }
      function WritableStreamUpdateBackpressure(stream, backpressure) {
        const writer = stream._writer;
        if (writer !== void 0 && backpressure !== stream._backpressure) {
          if (backpressure) {
            defaultWriterReadyPromiseReset(writer);
          } else {
            defaultWriterReadyPromiseResolve(writer);
          }
        }
        stream._backpressure = backpressure;
      }
      class WritableStreamDefaultWriter {
        constructor(stream) {
          assertRequiredArgument(stream, 1, "WritableStreamDefaultWriter");
          assertWritableStream(stream, "First parameter");
          if (IsWritableStreamLocked(stream)) {
            throw new TypeError("This stream has already been locked for exclusive writing by another writer");
          }
          this._ownerWritableStream = stream;
          stream._writer = this;
          const state = stream._state;
          if (state === "writable") {
            if (!WritableStreamCloseQueuedOrInFlight(stream) && stream._backpressure) {
              defaultWriterReadyPromiseInitialize(this);
            } else {
              defaultWriterReadyPromiseInitializeAsResolved(this);
            }
            defaultWriterClosedPromiseInitialize(this);
          } else if (state === "erroring") {
            defaultWriterReadyPromiseInitializeAsRejected(this, stream._storedError);
            defaultWriterClosedPromiseInitialize(this);
          } else if (state === "closed") {
            defaultWriterReadyPromiseInitializeAsResolved(this);
            defaultWriterClosedPromiseInitializeAsResolved(this);
          } else {
            const storedError = stream._storedError;
            defaultWriterReadyPromiseInitializeAsRejected(this, storedError);
            defaultWriterClosedPromiseInitializeAsRejected(this, storedError);
          }
        }
        get closed() {
          if (!IsWritableStreamDefaultWriter(this)) {
            return promiseRejectedWith(defaultWriterBrandCheckException("closed"));
          }
          return this._closedPromise;
        }
        get desiredSize() {
          if (!IsWritableStreamDefaultWriter(this)) {
            throw defaultWriterBrandCheckException("desiredSize");
          }
          if (this._ownerWritableStream === void 0) {
            throw defaultWriterLockException("desiredSize");
          }
          return WritableStreamDefaultWriterGetDesiredSize(this);
        }
        get ready() {
          if (!IsWritableStreamDefaultWriter(this)) {
            return promiseRejectedWith(defaultWriterBrandCheckException("ready"));
          }
          return this._readyPromise;
        }
        abort(reason = void 0) {
          if (!IsWritableStreamDefaultWriter(this)) {
            return promiseRejectedWith(defaultWriterBrandCheckException("abort"));
          }
          if (this._ownerWritableStream === void 0) {
            return promiseRejectedWith(defaultWriterLockException("abort"));
          }
          return WritableStreamDefaultWriterAbort(this, reason);
        }
        close() {
          if (!IsWritableStreamDefaultWriter(this)) {
            return promiseRejectedWith(defaultWriterBrandCheckException("close"));
          }
          const stream = this._ownerWritableStream;
          if (stream === void 0) {
            return promiseRejectedWith(defaultWriterLockException("close"));
          }
          if (WritableStreamCloseQueuedOrInFlight(stream)) {
            return promiseRejectedWith(new TypeError("Cannot close an already-closing stream"));
          }
          return WritableStreamDefaultWriterClose(this);
        }
        releaseLock() {
          if (!IsWritableStreamDefaultWriter(this)) {
            throw defaultWriterBrandCheckException("releaseLock");
          }
          const stream = this._ownerWritableStream;
          if (stream === void 0) {
            return;
          }
          WritableStreamDefaultWriterRelease(this);
        }
        write(chunk = void 0) {
          if (!IsWritableStreamDefaultWriter(this)) {
            return promiseRejectedWith(defaultWriterBrandCheckException("write"));
          }
          if (this._ownerWritableStream === void 0) {
            return promiseRejectedWith(defaultWriterLockException("write to"));
          }
          return WritableStreamDefaultWriterWrite(this, chunk);
        }
      }
      Object.defineProperties(WritableStreamDefaultWriter.prototype, {
        abort: { enumerable: true },
        close: { enumerable: true },
        releaseLock: { enumerable: true },
        write: { enumerable: true },
        closed: { enumerable: true },
        desiredSize: { enumerable: true },
        ready: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(WritableStreamDefaultWriter.prototype, SymbolPolyfill.toStringTag, {
          value: "WritableStreamDefaultWriter",
          configurable: true
        });
      }
      function IsWritableStreamDefaultWriter(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_ownerWritableStream")) {
          return false;
        }
        return x2 instanceof WritableStreamDefaultWriter;
      }
      function WritableStreamDefaultWriterAbort(writer, reason) {
        const stream = writer._ownerWritableStream;
        return WritableStreamAbort(stream, reason);
      }
      function WritableStreamDefaultWriterClose(writer) {
        const stream = writer._ownerWritableStream;
        return WritableStreamClose(stream);
      }
      function WritableStreamDefaultWriterCloseWithErrorPropagation(writer) {
        const stream = writer._ownerWritableStream;
        const state = stream._state;
        if (WritableStreamCloseQueuedOrInFlight(stream) || state === "closed") {
          return promiseResolvedWith(void 0);
        }
        if (state === "errored") {
          return promiseRejectedWith(stream._storedError);
        }
        return WritableStreamDefaultWriterClose(writer);
      }
      function WritableStreamDefaultWriterEnsureClosedPromiseRejected(writer, error) {
        if (writer._closedPromiseState === "pending") {
          defaultWriterClosedPromiseReject(writer, error);
        } else {
          defaultWriterClosedPromiseResetToRejected(writer, error);
        }
      }
      function WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, error) {
        if (writer._readyPromiseState === "pending") {
          defaultWriterReadyPromiseReject(writer, error);
        } else {
          defaultWriterReadyPromiseResetToRejected(writer, error);
        }
      }
      function WritableStreamDefaultWriterGetDesiredSize(writer) {
        const stream = writer._ownerWritableStream;
        const state = stream._state;
        if (state === "errored" || state === "erroring") {
          return null;
        }
        if (state === "closed") {
          return 0;
        }
        return WritableStreamDefaultControllerGetDesiredSize(stream._writableStreamController);
      }
      function WritableStreamDefaultWriterRelease(writer) {
        const stream = writer._ownerWritableStream;
        const releasedError = new TypeError(`Writer was released and can no longer be used to monitor the stream's closedness`);
        WritableStreamDefaultWriterEnsureReadyPromiseRejected(writer, releasedError);
        WritableStreamDefaultWriterEnsureClosedPromiseRejected(writer, releasedError);
        stream._writer = void 0;
        writer._ownerWritableStream = void 0;
      }
      function WritableStreamDefaultWriterWrite(writer, chunk) {
        const stream = writer._ownerWritableStream;
        const controller = stream._writableStreamController;
        const chunkSize = WritableStreamDefaultControllerGetChunkSize(controller, chunk);
        if (stream !== writer._ownerWritableStream) {
          return promiseRejectedWith(defaultWriterLockException("write to"));
        }
        const state = stream._state;
        if (state === "errored") {
          return promiseRejectedWith(stream._storedError);
        }
        if (WritableStreamCloseQueuedOrInFlight(stream) || state === "closed") {
          return promiseRejectedWith(new TypeError("The stream is closing or closed and cannot be written to"));
        }
        if (state === "erroring") {
          return promiseRejectedWith(stream._storedError);
        }
        const promise = WritableStreamAddWriteRequest(stream);
        WritableStreamDefaultControllerWrite(controller, chunk, chunkSize);
        return promise;
      }
      const closeSentinel = {};
      class WritableStreamDefaultController {
        constructor() {
          throw new TypeError("Illegal constructor");
        }
        get abortReason() {
          if (!IsWritableStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException$2("abortReason");
          }
          return this._abortReason;
        }
        get signal() {
          if (!IsWritableStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException$2("signal");
          }
          if (this._abortController === void 0) {
            throw new TypeError("WritableStreamDefaultController.prototype.signal is not supported");
          }
          return this._abortController.signal;
        }
        error(e2 = void 0) {
          if (!IsWritableStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException$2("error");
          }
          const state = this._controlledWritableStream._state;
          if (state !== "writable") {
            return;
          }
          WritableStreamDefaultControllerError(this, e2);
        }
        [AbortSteps](reason) {
          const result = this._abortAlgorithm(reason);
          WritableStreamDefaultControllerClearAlgorithms(this);
          return result;
        }
        [ErrorSteps]() {
          ResetQueue(this);
        }
      }
      Object.defineProperties(WritableStreamDefaultController.prototype, {
        abortReason: { enumerable: true },
        signal: { enumerable: true },
        error: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(WritableStreamDefaultController.prototype, SymbolPolyfill.toStringTag, {
          value: "WritableStreamDefaultController",
          configurable: true
        });
      }
      function IsWritableStreamDefaultController(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_controlledWritableStream")) {
          return false;
        }
        return x2 instanceof WritableStreamDefaultController;
      }
      function SetUpWritableStreamDefaultController(stream, controller, startAlgorithm, writeAlgorithm, closeAlgorithm, abortAlgorithm, highWaterMark, sizeAlgorithm) {
        controller._controlledWritableStream = stream;
        stream._writableStreamController = controller;
        controller._queue = void 0;
        controller._queueTotalSize = void 0;
        ResetQueue(controller);
        controller._abortReason = void 0;
        controller._abortController = createAbortController();
        controller._started = false;
        controller._strategySizeAlgorithm = sizeAlgorithm;
        controller._strategyHWM = highWaterMark;
        controller._writeAlgorithm = writeAlgorithm;
        controller._closeAlgorithm = closeAlgorithm;
        controller._abortAlgorithm = abortAlgorithm;
        const backpressure = WritableStreamDefaultControllerGetBackpressure(controller);
        WritableStreamUpdateBackpressure(stream, backpressure);
        const startResult = startAlgorithm();
        const startPromise = promiseResolvedWith(startResult);
        uponPromise(startPromise, () => {
          controller._started = true;
          WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
        }, (r2) => {
          controller._started = true;
          WritableStreamDealWithRejection(stream, r2);
        });
      }
      function SetUpWritableStreamDefaultControllerFromUnderlyingSink(stream, underlyingSink, highWaterMark, sizeAlgorithm) {
        const controller = Object.create(WritableStreamDefaultController.prototype);
        let startAlgorithm = () => void 0;
        let writeAlgorithm = () => promiseResolvedWith(void 0);
        let closeAlgorithm = () => promiseResolvedWith(void 0);
        let abortAlgorithm = () => promiseResolvedWith(void 0);
        if (underlyingSink.start !== void 0) {
          startAlgorithm = () => underlyingSink.start(controller);
        }
        if (underlyingSink.write !== void 0) {
          writeAlgorithm = (chunk) => underlyingSink.write(chunk, controller);
        }
        if (underlyingSink.close !== void 0) {
          closeAlgorithm = () => underlyingSink.close();
        }
        if (underlyingSink.abort !== void 0) {
          abortAlgorithm = (reason) => underlyingSink.abort(reason);
        }
        SetUpWritableStreamDefaultController(stream, controller, startAlgorithm, writeAlgorithm, closeAlgorithm, abortAlgorithm, highWaterMark, sizeAlgorithm);
      }
      function WritableStreamDefaultControllerClearAlgorithms(controller) {
        controller._writeAlgorithm = void 0;
        controller._closeAlgorithm = void 0;
        controller._abortAlgorithm = void 0;
        controller._strategySizeAlgorithm = void 0;
      }
      function WritableStreamDefaultControllerClose(controller) {
        EnqueueValueWithSize(controller, closeSentinel, 0);
        WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
      }
      function WritableStreamDefaultControllerGetChunkSize(controller, chunk) {
        try {
          return controller._strategySizeAlgorithm(chunk);
        } catch (chunkSizeE) {
          WritableStreamDefaultControllerErrorIfNeeded(controller, chunkSizeE);
          return 1;
        }
      }
      function WritableStreamDefaultControllerGetDesiredSize(controller) {
        return controller._strategyHWM - controller._queueTotalSize;
      }
      function WritableStreamDefaultControllerWrite(controller, chunk, chunkSize) {
        try {
          EnqueueValueWithSize(controller, chunk, chunkSize);
        } catch (enqueueE) {
          WritableStreamDefaultControllerErrorIfNeeded(controller, enqueueE);
          return;
        }
        const stream = controller._controlledWritableStream;
        if (!WritableStreamCloseQueuedOrInFlight(stream) && stream._state === "writable") {
          const backpressure = WritableStreamDefaultControllerGetBackpressure(controller);
          WritableStreamUpdateBackpressure(stream, backpressure);
        }
        WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
      }
      function WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller) {
        const stream = controller._controlledWritableStream;
        if (!controller._started) {
          return;
        }
        if (stream._inFlightWriteRequest !== void 0) {
          return;
        }
        const state = stream._state;
        if (state === "erroring") {
          WritableStreamFinishErroring(stream);
          return;
        }
        if (controller._queue.length === 0) {
          return;
        }
        const value = PeekQueueValue(controller);
        if (value === closeSentinel) {
          WritableStreamDefaultControllerProcessClose(controller);
        } else {
          WritableStreamDefaultControllerProcessWrite(controller, value);
        }
      }
      function WritableStreamDefaultControllerErrorIfNeeded(controller, error) {
        if (controller._controlledWritableStream._state === "writable") {
          WritableStreamDefaultControllerError(controller, error);
        }
      }
      function WritableStreamDefaultControllerProcessClose(controller) {
        const stream = controller._controlledWritableStream;
        WritableStreamMarkCloseRequestInFlight(stream);
        DequeueValue(controller);
        const sinkClosePromise = controller._closeAlgorithm();
        WritableStreamDefaultControllerClearAlgorithms(controller);
        uponPromise(sinkClosePromise, () => {
          WritableStreamFinishInFlightClose(stream);
        }, (reason) => {
          WritableStreamFinishInFlightCloseWithError(stream, reason);
        });
      }
      function WritableStreamDefaultControllerProcessWrite(controller, chunk) {
        const stream = controller._controlledWritableStream;
        WritableStreamMarkFirstWriteRequestInFlight(stream);
        const sinkWritePromise = controller._writeAlgorithm(chunk);
        uponPromise(sinkWritePromise, () => {
          WritableStreamFinishInFlightWrite(stream);
          const state = stream._state;
          DequeueValue(controller);
          if (!WritableStreamCloseQueuedOrInFlight(stream) && state === "writable") {
            const backpressure = WritableStreamDefaultControllerGetBackpressure(controller);
            WritableStreamUpdateBackpressure(stream, backpressure);
          }
          WritableStreamDefaultControllerAdvanceQueueIfNeeded(controller);
        }, (reason) => {
          if (stream._state === "writable") {
            WritableStreamDefaultControllerClearAlgorithms(controller);
          }
          WritableStreamFinishInFlightWriteWithError(stream, reason);
        });
      }
      function WritableStreamDefaultControllerGetBackpressure(controller) {
        const desiredSize = WritableStreamDefaultControllerGetDesiredSize(controller);
        return desiredSize <= 0;
      }
      function WritableStreamDefaultControllerError(controller, error) {
        const stream = controller._controlledWritableStream;
        WritableStreamDefaultControllerClearAlgorithms(controller);
        WritableStreamStartErroring(stream, error);
      }
      function streamBrandCheckException$2(name) {
        return new TypeError(`WritableStream.prototype.${name} can only be used on a WritableStream`);
      }
      function defaultControllerBrandCheckException$2(name) {
        return new TypeError(`WritableStreamDefaultController.prototype.${name} can only be used on a WritableStreamDefaultController`);
      }
      function defaultWriterBrandCheckException(name) {
        return new TypeError(`WritableStreamDefaultWriter.prototype.${name} can only be used on a WritableStreamDefaultWriter`);
      }
      function defaultWriterLockException(name) {
        return new TypeError("Cannot " + name + " a stream using a released writer");
      }
      function defaultWriterClosedPromiseInitialize(writer) {
        writer._closedPromise = newPromise((resolve, reject) => {
          writer._closedPromise_resolve = resolve;
          writer._closedPromise_reject = reject;
          writer._closedPromiseState = "pending";
        });
      }
      function defaultWriterClosedPromiseInitializeAsRejected(writer, reason) {
        defaultWriterClosedPromiseInitialize(writer);
        defaultWriterClosedPromiseReject(writer, reason);
      }
      function defaultWriterClosedPromiseInitializeAsResolved(writer) {
        defaultWriterClosedPromiseInitialize(writer);
        defaultWriterClosedPromiseResolve(writer);
      }
      function defaultWriterClosedPromiseReject(writer, reason) {
        if (writer._closedPromise_reject === void 0) {
          return;
        }
        setPromiseIsHandledToTrue(writer._closedPromise);
        writer._closedPromise_reject(reason);
        writer._closedPromise_resolve = void 0;
        writer._closedPromise_reject = void 0;
        writer._closedPromiseState = "rejected";
      }
      function defaultWriterClosedPromiseResetToRejected(writer, reason) {
        defaultWriterClosedPromiseInitializeAsRejected(writer, reason);
      }
      function defaultWriterClosedPromiseResolve(writer) {
        if (writer._closedPromise_resolve === void 0) {
          return;
        }
        writer._closedPromise_resolve(void 0);
        writer._closedPromise_resolve = void 0;
        writer._closedPromise_reject = void 0;
        writer._closedPromiseState = "resolved";
      }
      function defaultWriterReadyPromiseInitialize(writer) {
        writer._readyPromise = newPromise((resolve, reject) => {
          writer._readyPromise_resolve = resolve;
          writer._readyPromise_reject = reject;
        });
        writer._readyPromiseState = "pending";
      }
      function defaultWriterReadyPromiseInitializeAsRejected(writer, reason) {
        defaultWriterReadyPromiseInitialize(writer);
        defaultWriterReadyPromiseReject(writer, reason);
      }
      function defaultWriterReadyPromiseInitializeAsResolved(writer) {
        defaultWriterReadyPromiseInitialize(writer);
        defaultWriterReadyPromiseResolve(writer);
      }
      function defaultWriterReadyPromiseReject(writer, reason) {
        if (writer._readyPromise_reject === void 0) {
          return;
        }
        setPromiseIsHandledToTrue(writer._readyPromise);
        writer._readyPromise_reject(reason);
        writer._readyPromise_resolve = void 0;
        writer._readyPromise_reject = void 0;
        writer._readyPromiseState = "rejected";
      }
      function defaultWriterReadyPromiseReset(writer) {
        defaultWriterReadyPromiseInitialize(writer);
      }
      function defaultWriterReadyPromiseResetToRejected(writer, reason) {
        defaultWriterReadyPromiseInitializeAsRejected(writer, reason);
      }
      function defaultWriterReadyPromiseResolve(writer) {
        if (writer._readyPromise_resolve === void 0) {
          return;
        }
        writer._readyPromise_resolve(void 0);
        writer._readyPromise_resolve = void 0;
        writer._readyPromise_reject = void 0;
        writer._readyPromiseState = "fulfilled";
      }
      const NativeDOMException = typeof DOMException !== "undefined" ? DOMException : void 0;
      function isDOMExceptionConstructor(ctor) {
        if (!(typeof ctor === "function" || typeof ctor === "object")) {
          return false;
        }
        try {
          new ctor();
          return true;
        } catch (_a4) {
          return false;
        }
      }
      function createDOMExceptionPolyfill() {
        const ctor = function DOMException3(message, name) {
          this.message = message || "";
          this.name = name || "Error";
          if (Error.captureStackTrace) {
            Error.captureStackTrace(this, this.constructor);
          }
        };
        ctor.prototype = Object.create(Error.prototype);
        Object.defineProperty(ctor.prototype, "constructor", { value: ctor, writable: true, configurable: true });
        return ctor;
      }
      const DOMException$1 = isDOMExceptionConstructor(NativeDOMException) ? NativeDOMException : createDOMExceptionPolyfill();
      function ReadableStreamPipeTo(source, dest, preventClose, preventAbort, preventCancel, signal) {
        const reader = AcquireReadableStreamDefaultReader(source);
        const writer = AcquireWritableStreamDefaultWriter(dest);
        source._disturbed = true;
        let shuttingDown = false;
        let currentWrite = promiseResolvedWith(void 0);
        return newPromise((resolve, reject) => {
          let abortAlgorithm;
          if (signal !== void 0) {
            abortAlgorithm = () => {
              const error = new DOMException$1("Aborted", "AbortError");
              const actions = [];
              if (!preventAbort) {
                actions.push(() => {
                  if (dest._state === "writable") {
                    return WritableStreamAbort(dest, error);
                  }
                  return promiseResolvedWith(void 0);
                });
              }
              if (!preventCancel) {
                actions.push(() => {
                  if (source._state === "readable") {
                    return ReadableStreamCancel(source, error);
                  }
                  return promiseResolvedWith(void 0);
                });
              }
              shutdownWithAction(() => Promise.all(actions.map((action) => action())), true, error);
            };
            if (signal.aborted) {
              abortAlgorithm();
              return;
            }
            signal.addEventListener("abort", abortAlgorithm);
          }
          function pipeLoop() {
            return newPromise((resolveLoop, rejectLoop) => {
              function next(done) {
                if (done) {
                  resolveLoop();
                } else {
                  PerformPromiseThen(pipeStep(), next, rejectLoop);
                }
              }
              next(false);
            });
          }
          function pipeStep() {
            if (shuttingDown) {
              return promiseResolvedWith(true);
            }
            return PerformPromiseThen(writer._readyPromise, () => {
              return newPromise((resolveRead, rejectRead) => {
                ReadableStreamDefaultReaderRead(reader, {
                  _chunkSteps: (chunk) => {
                    currentWrite = PerformPromiseThen(WritableStreamDefaultWriterWrite(writer, chunk), void 0, noop2);
                    resolveRead(false);
                  },
                  _closeSteps: () => resolveRead(true),
                  _errorSteps: rejectRead
                });
              });
            });
          }
          isOrBecomesErrored(source, reader._closedPromise, (storedError) => {
            if (!preventAbort) {
              shutdownWithAction(() => WritableStreamAbort(dest, storedError), true, storedError);
            } else {
              shutdown(true, storedError);
            }
          });
          isOrBecomesErrored(dest, writer._closedPromise, (storedError) => {
            if (!preventCancel) {
              shutdownWithAction(() => ReadableStreamCancel(source, storedError), true, storedError);
            } else {
              shutdown(true, storedError);
            }
          });
          isOrBecomesClosed(source, reader._closedPromise, () => {
            if (!preventClose) {
              shutdownWithAction(() => WritableStreamDefaultWriterCloseWithErrorPropagation(writer));
            } else {
              shutdown();
            }
          });
          if (WritableStreamCloseQueuedOrInFlight(dest) || dest._state === "closed") {
            const destClosed = new TypeError("the destination writable stream closed before all data could be piped to it");
            if (!preventCancel) {
              shutdownWithAction(() => ReadableStreamCancel(source, destClosed), true, destClosed);
            } else {
              shutdown(true, destClosed);
            }
          }
          setPromiseIsHandledToTrue(pipeLoop());
          function waitForWritesToFinish() {
            const oldCurrentWrite = currentWrite;
            return PerformPromiseThen(currentWrite, () => oldCurrentWrite !== currentWrite ? waitForWritesToFinish() : void 0);
          }
          function isOrBecomesErrored(stream, promise, action) {
            if (stream._state === "errored") {
              action(stream._storedError);
            } else {
              uponRejection(promise, action);
            }
          }
          function isOrBecomesClosed(stream, promise, action) {
            if (stream._state === "closed") {
              action();
            } else {
              uponFulfillment(promise, action);
            }
          }
          function shutdownWithAction(action, originalIsError, originalError) {
            if (shuttingDown) {
              return;
            }
            shuttingDown = true;
            if (dest._state === "writable" && !WritableStreamCloseQueuedOrInFlight(dest)) {
              uponFulfillment(waitForWritesToFinish(), doTheRest);
            } else {
              doTheRest();
            }
            function doTheRest() {
              uponPromise(action(), () => finalize(originalIsError, originalError), (newError) => finalize(true, newError));
            }
          }
          function shutdown(isError, error) {
            if (shuttingDown) {
              return;
            }
            shuttingDown = true;
            if (dest._state === "writable" && !WritableStreamCloseQueuedOrInFlight(dest)) {
              uponFulfillment(waitForWritesToFinish(), () => finalize(isError, error));
            } else {
              finalize(isError, error);
            }
          }
          function finalize(isError, error) {
            WritableStreamDefaultWriterRelease(writer);
            ReadableStreamReaderGenericRelease(reader);
            if (signal !== void 0) {
              signal.removeEventListener("abort", abortAlgorithm);
            }
            if (isError) {
              reject(error);
            } else {
              resolve(void 0);
            }
          }
        });
      }
      class ReadableStreamDefaultController {
        constructor() {
          throw new TypeError("Illegal constructor");
        }
        get desiredSize() {
          if (!IsReadableStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException$1("desiredSize");
          }
          return ReadableStreamDefaultControllerGetDesiredSize(this);
        }
        close() {
          if (!IsReadableStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException$1("close");
          }
          if (!ReadableStreamDefaultControllerCanCloseOrEnqueue(this)) {
            throw new TypeError("The stream is not in a state that permits close");
          }
          ReadableStreamDefaultControllerClose(this);
        }
        enqueue(chunk = void 0) {
          if (!IsReadableStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException$1("enqueue");
          }
          if (!ReadableStreamDefaultControllerCanCloseOrEnqueue(this)) {
            throw new TypeError("The stream is not in a state that permits enqueue");
          }
          return ReadableStreamDefaultControllerEnqueue(this, chunk);
        }
        error(e2 = void 0) {
          if (!IsReadableStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException$1("error");
          }
          ReadableStreamDefaultControllerError(this, e2);
        }
        [CancelSteps](reason) {
          ResetQueue(this);
          const result = this._cancelAlgorithm(reason);
          ReadableStreamDefaultControllerClearAlgorithms(this);
          return result;
        }
        [PullSteps](readRequest) {
          const stream = this._controlledReadableStream;
          if (this._queue.length > 0) {
            const chunk = DequeueValue(this);
            if (this._closeRequested && this._queue.length === 0) {
              ReadableStreamDefaultControllerClearAlgorithms(this);
              ReadableStreamClose(stream);
            } else {
              ReadableStreamDefaultControllerCallPullIfNeeded(this);
            }
            readRequest._chunkSteps(chunk);
          } else {
            ReadableStreamAddReadRequest(stream, readRequest);
            ReadableStreamDefaultControllerCallPullIfNeeded(this);
          }
        }
      }
      Object.defineProperties(ReadableStreamDefaultController.prototype, {
        close: { enumerable: true },
        enqueue: { enumerable: true },
        error: { enumerable: true },
        desiredSize: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(ReadableStreamDefaultController.prototype, SymbolPolyfill.toStringTag, {
          value: "ReadableStreamDefaultController",
          configurable: true
        });
      }
      function IsReadableStreamDefaultController(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_controlledReadableStream")) {
          return false;
        }
        return x2 instanceof ReadableStreamDefaultController;
      }
      function ReadableStreamDefaultControllerCallPullIfNeeded(controller) {
        const shouldPull = ReadableStreamDefaultControllerShouldCallPull(controller);
        if (!shouldPull) {
          return;
        }
        if (controller._pulling) {
          controller._pullAgain = true;
          return;
        }
        controller._pulling = true;
        const pullPromise = controller._pullAlgorithm();
        uponPromise(pullPromise, () => {
          controller._pulling = false;
          if (controller._pullAgain) {
            controller._pullAgain = false;
            ReadableStreamDefaultControllerCallPullIfNeeded(controller);
          }
        }, (e2) => {
          ReadableStreamDefaultControllerError(controller, e2);
        });
      }
      function ReadableStreamDefaultControllerShouldCallPull(controller) {
        const stream = controller._controlledReadableStream;
        if (!ReadableStreamDefaultControllerCanCloseOrEnqueue(controller)) {
          return false;
        }
        if (!controller._started) {
          return false;
        }
        if (IsReadableStreamLocked(stream) && ReadableStreamGetNumReadRequests(stream) > 0) {
          return true;
        }
        const desiredSize = ReadableStreamDefaultControllerGetDesiredSize(controller);
        if (desiredSize > 0) {
          return true;
        }
        return false;
      }
      function ReadableStreamDefaultControllerClearAlgorithms(controller) {
        controller._pullAlgorithm = void 0;
        controller._cancelAlgorithm = void 0;
        controller._strategySizeAlgorithm = void 0;
      }
      function ReadableStreamDefaultControllerClose(controller) {
        if (!ReadableStreamDefaultControllerCanCloseOrEnqueue(controller)) {
          return;
        }
        const stream = controller._controlledReadableStream;
        controller._closeRequested = true;
        if (controller._queue.length === 0) {
          ReadableStreamDefaultControllerClearAlgorithms(controller);
          ReadableStreamClose(stream);
        }
      }
      function ReadableStreamDefaultControllerEnqueue(controller, chunk) {
        if (!ReadableStreamDefaultControllerCanCloseOrEnqueue(controller)) {
          return;
        }
        const stream = controller._controlledReadableStream;
        if (IsReadableStreamLocked(stream) && ReadableStreamGetNumReadRequests(stream) > 0) {
          ReadableStreamFulfillReadRequest(stream, chunk, false);
        } else {
          let chunkSize;
          try {
            chunkSize = controller._strategySizeAlgorithm(chunk);
          } catch (chunkSizeE) {
            ReadableStreamDefaultControllerError(controller, chunkSizeE);
            throw chunkSizeE;
          }
          try {
            EnqueueValueWithSize(controller, chunk, chunkSize);
          } catch (enqueueE) {
            ReadableStreamDefaultControllerError(controller, enqueueE);
            throw enqueueE;
          }
        }
        ReadableStreamDefaultControllerCallPullIfNeeded(controller);
      }
      function ReadableStreamDefaultControllerError(controller, e2) {
        const stream = controller._controlledReadableStream;
        if (stream._state !== "readable") {
          return;
        }
        ResetQueue(controller);
        ReadableStreamDefaultControllerClearAlgorithms(controller);
        ReadableStreamError(stream, e2);
      }
      function ReadableStreamDefaultControllerGetDesiredSize(controller) {
        const state = controller._controlledReadableStream._state;
        if (state === "errored") {
          return null;
        }
        if (state === "closed") {
          return 0;
        }
        return controller._strategyHWM - controller._queueTotalSize;
      }
      function ReadableStreamDefaultControllerHasBackpressure(controller) {
        if (ReadableStreamDefaultControllerShouldCallPull(controller)) {
          return false;
        }
        return true;
      }
      function ReadableStreamDefaultControllerCanCloseOrEnqueue(controller) {
        const state = controller._controlledReadableStream._state;
        if (!controller._closeRequested && state === "readable") {
          return true;
        }
        return false;
      }
      function SetUpReadableStreamDefaultController(stream, controller, startAlgorithm, pullAlgorithm, cancelAlgorithm, highWaterMark, sizeAlgorithm) {
        controller._controlledReadableStream = stream;
        controller._queue = void 0;
        controller._queueTotalSize = void 0;
        ResetQueue(controller);
        controller._started = false;
        controller._closeRequested = false;
        controller._pullAgain = false;
        controller._pulling = false;
        controller._strategySizeAlgorithm = sizeAlgorithm;
        controller._strategyHWM = highWaterMark;
        controller._pullAlgorithm = pullAlgorithm;
        controller._cancelAlgorithm = cancelAlgorithm;
        stream._readableStreamController = controller;
        const startResult = startAlgorithm();
        uponPromise(promiseResolvedWith(startResult), () => {
          controller._started = true;
          ReadableStreamDefaultControllerCallPullIfNeeded(controller);
        }, (r2) => {
          ReadableStreamDefaultControllerError(controller, r2);
        });
      }
      function SetUpReadableStreamDefaultControllerFromUnderlyingSource(stream, underlyingSource, highWaterMark, sizeAlgorithm) {
        const controller = Object.create(ReadableStreamDefaultController.prototype);
        let startAlgorithm = () => void 0;
        let pullAlgorithm = () => promiseResolvedWith(void 0);
        let cancelAlgorithm = () => promiseResolvedWith(void 0);
        if (underlyingSource.start !== void 0) {
          startAlgorithm = () => underlyingSource.start(controller);
        }
        if (underlyingSource.pull !== void 0) {
          pullAlgorithm = () => underlyingSource.pull(controller);
        }
        if (underlyingSource.cancel !== void 0) {
          cancelAlgorithm = (reason) => underlyingSource.cancel(reason);
        }
        SetUpReadableStreamDefaultController(stream, controller, startAlgorithm, pullAlgorithm, cancelAlgorithm, highWaterMark, sizeAlgorithm);
      }
      function defaultControllerBrandCheckException$1(name) {
        return new TypeError(`ReadableStreamDefaultController.prototype.${name} can only be used on a ReadableStreamDefaultController`);
      }
      function ReadableStreamTee(stream, cloneForBranch2) {
        if (IsReadableByteStreamController(stream._readableStreamController)) {
          return ReadableByteStreamTee(stream);
        }
        return ReadableStreamDefaultTee(stream);
      }
      function ReadableStreamDefaultTee(stream, cloneForBranch2) {
        const reader = AcquireReadableStreamDefaultReader(stream);
        let reading = false;
        let readAgain = false;
        let canceled1 = false;
        let canceled2 = false;
        let reason1;
        let reason2;
        let branch1;
        let branch2;
        let resolveCancelPromise;
        const cancelPromise = newPromise((resolve) => {
          resolveCancelPromise = resolve;
        });
        function pullAlgorithm() {
          if (reading) {
            readAgain = true;
            return promiseResolvedWith(void 0);
          }
          reading = true;
          const readRequest = {
            _chunkSteps: (chunk) => {
              queueMicrotask2(() => {
                readAgain = false;
                const chunk1 = chunk;
                const chunk2 = chunk;
                if (!canceled1) {
                  ReadableStreamDefaultControllerEnqueue(branch1._readableStreamController, chunk1);
                }
                if (!canceled2) {
                  ReadableStreamDefaultControllerEnqueue(branch2._readableStreamController, chunk2);
                }
                reading = false;
                if (readAgain) {
                  pullAlgorithm();
                }
              });
            },
            _closeSteps: () => {
              reading = false;
              if (!canceled1) {
                ReadableStreamDefaultControllerClose(branch1._readableStreamController);
              }
              if (!canceled2) {
                ReadableStreamDefaultControllerClose(branch2._readableStreamController);
              }
              if (!canceled1 || !canceled2) {
                resolveCancelPromise(void 0);
              }
            },
            _errorSteps: () => {
              reading = false;
            }
          };
          ReadableStreamDefaultReaderRead(reader, readRequest);
          return promiseResolvedWith(void 0);
        }
        function cancel1Algorithm(reason) {
          canceled1 = true;
          reason1 = reason;
          if (canceled2) {
            const compositeReason = CreateArrayFromList([reason1, reason2]);
            const cancelResult = ReadableStreamCancel(stream, compositeReason);
            resolveCancelPromise(cancelResult);
          }
          return cancelPromise;
        }
        function cancel2Algorithm(reason) {
          canceled2 = true;
          reason2 = reason;
          if (canceled1) {
            const compositeReason = CreateArrayFromList([reason1, reason2]);
            const cancelResult = ReadableStreamCancel(stream, compositeReason);
            resolveCancelPromise(cancelResult);
          }
          return cancelPromise;
        }
        function startAlgorithm() {
        }
        branch1 = CreateReadableStream(startAlgorithm, pullAlgorithm, cancel1Algorithm);
        branch2 = CreateReadableStream(startAlgorithm, pullAlgorithm, cancel2Algorithm);
        uponRejection(reader._closedPromise, (r2) => {
          ReadableStreamDefaultControllerError(branch1._readableStreamController, r2);
          ReadableStreamDefaultControllerError(branch2._readableStreamController, r2);
          if (!canceled1 || !canceled2) {
            resolveCancelPromise(void 0);
          }
        });
        return [branch1, branch2];
      }
      function ReadableByteStreamTee(stream) {
        let reader = AcquireReadableStreamDefaultReader(stream);
        let reading = false;
        let readAgainForBranch1 = false;
        let readAgainForBranch2 = false;
        let canceled1 = false;
        let canceled2 = false;
        let reason1;
        let reason2;
        let branch1;
        let branch2;
        let resolveCancelPromise;
        const cancelPromise = newPromise((resolve) => {
          resolveCancelPromise = resolve;
        });
        function forwardReaderError(thisReader) {
          uponRejection(thisReader._closedPromise, (r2) => {
            if (thisReader !== reader) {
              return;
            }
            ReadableByteStreamControllerError(branch1._readableStreamController, r2);
            ReadableByteStreamControllerError(branch2._readableStreamController, r2);
            if (!canceled1 || !canceled2) {
              resolveCancelPromise(void 0);
            }
          });
        }
        function pullWithDefaultReader() {
          if (IsReadableStreamBYOBReader(reader)) {
            ReadableStreamReaderGenericRelease(reader);
            reader = AcquireReadableStreamDefaultReader(stream);
            forwardReaderError(reader);
          }
          const readRequest = {
            _chunkSteps: (chunk) => {
              queueMicrotask2(() => {
                readAgainForBranch1 = false;
                readAgainForBranch2 = false;
                const chunk1 = chunk;
                let chunk2 = chunk;
                if (!canceled1 && !canceled2) {
                  try {
                    chunk2 = CloneAsUint8Array(chunk);
                  } catch (cloneE) {
                    ReadableByteStreamControllerError(branch1._readableStreamController, cloneE);
                    ReadableByteStreamControllerError(branch2._readableStreamController, cloneE);
                    resolveCancelPromise(ReadableStreamCancel(stream, cloneE));
                    return;
                  }
                }
                if (!canceled1) {
                  ReadableByteStreamControllerEnqueue(branch1._readableStreamController, chunk1);
                }
                if (!canceled2) {
                  ReadableByteStreamControllerEnqueue(branch2._readableStreamController, chunk2);
                }
                reading = false;
                if (readAgainForBranch1) {
                  pull1Algorithm();
                } else if (readAgainForBranch2) {
                  pull2Algorithm();
                }
              });
            },
            _closeSteps: () => {
              reading = false;
              if (!canceled1) {
                ReadableByteStreamControllerClose(branch1._readableStreamController);
              }
              if (!canceled2) {
                ReadableByteStreamControllerClose(branch2._readableStreamController);
              }
              if (branch1._readableStreamController._pendingPullIntos.length > 0) {
                ReadableByteStreamControllerRespond(branch1._readableStreamController, 0);
              }
              if (branch2._readableStreamController._pendingPullIntos.length > 0) {
                ReadableByteStreamControllerRespond(branch2._readableStreamController, 0);
              }
              if (!canceled1 || !canceled2) {
                resolveCancelPromise(void 0);
              }
            },
            _errorSteps: () => {
              reading = false;
            }
          };
          ReadableStreamDefaultReaderRead(reader, readRequest);
        }
        function pullWithBYOBReader(view, forBranch2) {
          if (IsReadableStreamDefaultReader(reader)) {
            ReadableStreamReaderGenericRelease(reader);
            reader = AcquireReadableStreamBYOBReader(stream);
            forwardReaderError(reader);
          }
          const byobBranch = forBranch2 ? branch2 : branch1;
          const otherBranch = forBranch2 ? branch1 : branch2;
          const readIntoRequest = {
            _chunkSteps: (chunk) => {
              queueMicrotask2(() => {
                readAgainForBranch1 = false;
                readAgainForBranch2 = false;
                const byobCanceled = forBranch2 ? canceled2 : canceled1;
                const otherCanceled = forBranch2 ? canceled1 : canceled2;
                if (!otherCanceled) {
                  let clonedChunk;
                  try {
                    clonedChunk = CloneAsUint8Array(chunk);
                  } catch (cloneE) {
                    ReadableByteStreamControllerError(byobBranch._readableStreamController, cloneE);
                    ReadableByteStreamControllerError(otherBranch._readableStreamController, cloneE);
                    resolveCancelPromise(ReadableStreamCancel(stream, cloneE));
                    return;
                  }
                  if (!byobCanceled) {
                    ReadableByteStreamControllerRespondWithNewView(byobBranch._readableStreamController, chunk);
                  }
                  ReadableByteStreamControllerEnqueue(otherBranch._readableStreamController, clonedChunk);
                } else if (!byobCanceled) {
                  ReadableByteStreamControllerRespondWithNewView(byobBranch._readableStreamController, chunk);
                }
                reading = false;
                if (readAgainForBranch1) {
                  pull1Algorithm();
                } else if (readAgainForBranch2) {
                  pull2Algorithm();
                }
              });
            },
            _closeSteps: (chunk) => {
              reading = false;
              const byobCanceled = forBranch2 ? canceled2 : canceled1;
              const otherCanceled = forBranch2 ? canceled1 : canceled2;
              if (!byobCanceled) {
                ReadableByteStreamControllerClose(byobBranch._readableStreamController);
              }
              if (!otherCanceled) {
                ReadableByteStreamControllerClose(otherBranch._readableStreamController);
              }
              if (chunk !== void 0) {
                if (!byobCanceled) {
                  ReadableByteStreamControllerRespondWithNewView(byobBranch._readableStreamController, chunk);
                }
                if (!otherCanceled && otherBranch._readableStreamController._pendingPullIntos.length > 0) {
                  ReadableByteStreamControllerRespond(otherBranch._readableStreamController, 0);
                }
              }
              if (!byobCanceled || !otherCanceled) {
                resolveCancelPromise(void 0);
              }
            },
            _errorSteps: () => {
              reading = false;
            }
          };
          ReadableStreamBYOBReaderRead(reader, view, readIntoRequest);
        }
        function pull1Algorithm() {
          if (reading) {
            readAgainForBranch1 = true;
            return promiseResolvedWith(void 0);
          }
          reading = true;
          const byobRequest = ReadableByteStreamControllerGetBYOBRequest(branch1._readableStreamController);
          if (byobRequest === null) {
            pullWithDefaultReader();
          } else {
            pullWithBYOBReader(byobRequest._view, false);
          }
          return promiseResolvedWith(void 0);
        }
        function pull2Algorithm() {
          if (reading) {
            readAgainForBranch2 = true;
            return promiseResolvedWith(void 0);
          }
          reading = true;
          const byobRequest = ReadableByteStreamControllerGetBYOBRequest(branch2._readableStreamController);
          if (byobRequest === null) {
            pullWithDefaultReader();
          } else {
            pullWithBYOBReader(byobRequest._view, true);
          }
          return promiseResolvedWith(void 0);
        }
        function cancel1Algorithm(reason) {
          canceled1 = true;
          reason1 = reason;
          if (canceled2) {
            const compositeReason = CreateArrayFromList([reason1, reason2]);
            const cancelResult = ReadableStreamCancel(stream, compositeReason);
            resolveCancelPromise(cancelResult);
          }
          return cancelPromise;
        }
        function cancel2Algorithm(reason) {
          canceled2 = true;
          reason2 = reason;
          if (canceled1) {
            const compositeReason = CreateArrayFromList([reason1, reason2]);
            const cancelResult = ReadableStreamCancel(stream, compositeReason);
            resolveCancelPromise(cancelResult);
          }
          return cancelPromise;
        }
        function startAlgorithm() {
          return;
        }
        branch1 = CreateReadableByteStream(startAlgorithm, pull1Algorithm, cancel1Algorithm);
        branch2 = CreateReadableByteStream(startAlgorithm, pull2Algorithm, cancel2Algorithm);
        forwardReaderError(reader);
        return [branch1, branch2];
      }
      function convertUnderlyingDefaultOrByteSource(source, context2) {
        assertDictionary(source, context2);
        const original = source;
        const autoAllocateChunkSize = original === null || original === void 0 ? void 0 : original.autoAllocateChunkSize;
        const cancel = original === null || original === void 0 ? void 0 : original.cancel;
        const pull = original === null || original === void 0 ? void 0 : original.pull;
        const start = original === null || original === void 0 ? void 0 : original.start;
        const type = original === null || original === void 0 ? void 0 : original.type;
        return {
          autoAllocateChunkSize: autoAllocateChunkSize === void 0 ? void 0 : convertUnsignedLongLongWithEnforceRange(autoAllocateChunkSize, `${context2} has member 'autoAllocateChunkSize' that`),
          cancel: cancel === void 0 ? void 0 : convertUnderlyingSourceCancelCallback(cancel, original, `${context2} has member 'cancel' that`),
          pull: pull === void 0 ? void 0 : convertUnderlyingSourcePullCallback(pull, original, `${context2} has member 'pull' that`),
          start: start === void 0 ? void 0 : convertUnderlyingSourceStartCallback(start, original, `${context2} has member 'start' that`),
          type: type === void 0 ? void 0 : convertReadableStreamType(type, `${context2} has member 'type' that`)
        };
      }
      function convertUnderlyingSourceCancelCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (reason) => promiseCall(fn, original, [reason]);
      }
      function convertUnderlyingSourcePullCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (controller) => promiseCall(fn, original, [controller]);
      }
      function convertUnderlyingSourceStartCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (controller) => reflectCall(fn, original, [controller]);
      }
      function convertReadableStreamType(type, context2) {
        type = `${type}`;
        if (type !== "bytes") {
          throw new TypeError(`${context2} '${type}' is not a valid enumeration value for ReadableStreamType`);
        }
        return type;
      }
      function convertReaderOptions(options, context2) {
        assertDictionary(options, context2);
        const mode = options === null || options === void 0 ? void 0 : options.mode;
        return {
          mode: mode === void 0 ? void 0 : convertReadableStreamReaderMode(mode, `${context2} has member 'mode' that`)
        };
      }
      function convertReadableStreamReaderMode(mode, context2) {
        mode = `${mode}`;
        if (mode !== "byob") {
          throw new TypeError(`${context2} '${mode}' is not a valid enumeration value for ReadableStreamReaderMode`);
        }
        return mode;
      }
      function convertIteratorOptions(options, context2) {
        assertDictionary(options, context2);
        const preventCancel = options === null || options === void 0 ? void 0 : options.preventCancel;
        return { preventCancel: Boolean(preventCancel) };
      }
      function convertPipeOptions(options, context2) {
        assertDictionary(options, context2);
        const preventAbort = options === null || options === void 0 ? void 0 : options.preventAbort;
        const preventCancel = options === null || options === void 0 ? void 0 : options.preventCancel;
        const preventClose = options === null || options === void 0 ? void 0 : options.preventClose;
        const signal = options === null || options === void 0 ? void 0 : options.signal;
        if (signal !== void 0) {
          assertAbortSignal(signal, `${context2} has member 'signal' that`);
        }
        return {
          preventAbort: Boolean(preventAbort),
          preventCancel: Boolean(preventCancel),
          preventClose: Boolean(preventClose),
          signal
        };
      }
      function assertAbortSignal(signal, context2) {
        if (!isAbortSignal3(signal)) {
          throw new TypeError(`${context2} is not an AbortSignal.`);
        }
      }
      function convertReadableWritablePair(pair, context2) {
        assertDictionary(pair, context2);
        const readable = pair === null || pair === void 0 ? void 0 : pair.readable;
        assertRequiredField(readable, "readable", "ReadableWritablePair");
        assertReadableStream(readable, `${context2} has member 'readable' that`);
        const writable = pair === null || pair === void 0 ? void 0 : pair.writable;
        assertRequiredField(writable, "writable", "ReadableWritablePair");
        assertWritableStream(writable, `${context2} has member 'writable' that`);
        return { readable, writable };
      }
      class ReadableStream2 {
        constructor(rawUnderlyingSource = {}, rawStrategy = {}) {
          if (rawUnderlyingSource === void 0) {
            rawUnderlyingSource = null;
          } else {
            assertObject(rawUnderlyingSource, "First parameter");
          }
          const strategy = convertQueuingStrategy(rawStrategy, "Second parameter");
          const underlyingSource = convertUnderlyingDefaultOrByteSource(rawUnderlyingSource, "First parameter");
          InitializeReadableStream(this);
          if (underlyingSource.type === "bytes") {
            if (strategy.size !== void 0) {
              throw new RangeError("The strategy for a byte stream cannot have a size function");
            }
            const highWaterMark = ExtractHighWaterMark(strategy, 0);
            SetUpReadableByteStreamControllerFromUnderlyingSource(this, underlyingSource, highWaterMark);
          } else {
            const sizeAlgorithm = ExtractSizeAlgorithm(strategy);
            const highWaterMark = ExtractHighWaterMark(strategy, 1);
            SetUpReadableStreamDefaultControllerFromUnderlyingSource(this, underlyingSource, highWaterMark, sizeAlgorithm);
          }
        }
        get locked() {
          if (!IsReadableStream(this)) {
            throw streamBrandCheckException$1("locked");
          }
          return IsReadableStreamLocked(this);
        }
        cancel(reason = void 0) {
          if (!IsReadableStream(this)) {
            return promiseRejectedWith(streamBrandCheckException$1("cancel"));
          }
          if (IsReadableStreamLocked(this)) {
            return promiseRejectedWith(new TypeError("Cannot cancel a stream that already has a reader"));
          }
          return ReadableStreamCancel(this, reason);
        }
        getReader(rawOptions = void 0) {
          if (!IsReadableStream(this)) {
            throw streamBrandCheckException$1("getReader");
          }
          const options = convertReaderOptions(rawOptions, "First parameter");
          if (options.mode === void 0) {
            return AcquireReadableStreamDefaultReader(this);
          }
          return AcquireReadableStreamBYOBReader(this);
        }
        pipeThrough(rawTransform, rawOptions = {}) {
          if (!IsReadableStream(this)) {
            throw streamBrandCheckException$1("pipeThrough");
          }
          assertRequiredArgument(rawTransform, 1, "pipeThrough");
          const transform = convertReadableWritablePair(rawTransform, "First parameter");
          const options = convertPipeOptions(rawOptions, "Second parameter");
          if (IsReadableStreamLocked(this)) {
            throw new TypeError("ReadableStream.prototype.pipeThrough cannot be used on a locked ReadableStream");
          }
          if (IsWritableStreamLocked(transform.writable)) {
            throw new TypeError("ReadableStream.prototype.pipeThrough cannot be used on a locked WritableStream");
          }
          const promise = ReadableStreamPipeTo(this, transform.writable, options.preventClose, options.preventAbort, options.preventCancel, options.signal);
          setPromiseIsHandledToTrue(promise);
          return transform.readable;
        }
        pipeTo(destination, rawOptions = {}) {
          if (!IsReadableStream(this)) {
            return promiseRejectedWith(streamBrandCheckException$1("pipeTo"));
          }
          if (destination === void 0) {
            return promiseRejectedWith(`Parameter 1 is required in 'pipeTo'.`);
          }
          if (!IsWritableStream(destination)) {
            return promiseRejectedWith(new TypeError(`ReadableStream.prototype.pipeTo's first argument must be a WritableStream`));
          }
          let options;
          try {
            options = convertPipeOptions(rawOptions, "Second parameter");
          } catch (e2) {
            return promiseRejectedWith(e2);
          }
          if (IsReadableStreamLocked(this)) {
            return promiseRejectedWith(new TypeError("ReadableStream.prototype.pipeTo cannot be used on a locked ReadableStream"));
          }
          if (IsWritableStreamLocked(destination)) {
            return promiseRejectedWith(new TypeError("ReadableStream.prototype.pipeTo cannot be used on a locked WritableStream"));
          }
          return ReadableStreamPipeTo(this, destination, options.preventClose, options.preventAbort, options.preventCancel, options.signal);
        }
        tee() {
          if (!IsReadableStream(this)) {
            throw streamBrandCheckException$1("tee");
          }
          const branches = ReadableStreamTee(this);
          return CreateArrayFromList(branches);
        }
        values(rawOptions = void 0) {
          if (!IsReadableStream(this)) {
            throw streamBrandCheckException$1("values");
          }
          const options = convertIteratorOptions(rawOptions, "First parameter");
          return AcquireReadableStreamAsyncIterator(this, options.preventCancel);
        }
      }
      Object.defineProperties(ReadableStream2.prototype, {
        cancel: { enumerable: true },
        getReader: { enumerable: true },
        pipeThrough: { enumerable: true },
        pipeTo: { enumerable: true },
        tee: { enumerable: true },
        values: { enumerable: true },
        locked: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(ReadableStream2.prototype, SymbolPolyfill.toStringTag, {
          value: "ReadableStream",
          configurable: true
        });
      }
      if (typeof SymbolPolyfill.asyncIterator === "symbol") {
        Object.defineProperty(ReadableStream2.prototype, SymbolPolyfill.asyncIterator, {
          value: ReadableStream2.prototype.values,
          writable: true,
          configurable: true
        });
      }
      function CreateReadableStream(startAlgorithm, pullAlgorithm, cancelAlgorithm, highWaterMark = 1, sizeAlgorithm = () => 1) {
        const stream = Object.create(ReadableStream2.prototype);
        InitializeReadableStream(stream);
        const controller = Object.create(ReadableStreamDefaultController.prototype);
        SetUpReadableStreamDefaultController(stream, controller, startAlgorithm, pullAlgorithm, cancelAlgorithm, highWaterMark, sizeAlgorithm);
        return stream;
      }
      function CreateReadableByteStream(startAlgorithm, pullAlgorithm, cancelAlgorithm) {
        const stream = Object.create(ReadableStream2.prototype);
        InitializeReadableStream(stream);
        const controller = Object.create(ReadableByteStreamController.prototype);
        SetUpReadableByteStreamController(stream, controller, startAlgorithm, pullAlgorithm, cancelAlgorithm, 0, void 0);
        return stream;
      }
      function InitializeReadableStream(stream) {
        stream._state = "readable";
        stream._reader = void 0;
        stream._storedError = void 0;
        stream._disturbed = false;
      }
      function IsReadableStream(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_readableStreamController")) {
          return false;
        }
        return x2 instanceof ReadableStream2;
      }
      function IsReadableStreamLocked(stream) {
        if (stream._reader === void 0) {
          return false;
        }
        return true;
      }
      function ReadableStreamCancel(stream, reason) {
        stream._disturbed = true;
        if (stream._state === "closed") {
          return promiseResolvedWith(void 0);
        }
        if (stream._state === "errored") {
          return promiseRejectedWith(stream._storedError);
        }
        ReadableStreamClose(stream);
        const reader = stream._reader;
        if (reader !== void 0 && IsReadableStreamBYOBReader(reader)) {
          reader._readIntoRequests.forEach((readIntoRequest) => {
            readIntoRequest._closeSteps(void 0);
          });
          reader._readIntoRequests = new SimpleQueue();
        }
        const sourceCancelPromise = stream._readableStreamController[CancelSteps](reason);
        return transformPromiseWith(sourceCancelPromise, noop2);
      }
      function ReadableStreamClose(stream) {
        stream._state = "closed";
        const reader = stream._reader;
        if (reader === void 0) {
          return;
        }
        defaultReaderClosedPromiseResolve(reader);
        if (IsReadableStreamDefaultReader(reader)) {
          reader._readRequests.forEach((readRequest) => {
            readRequest._closeSteps();
          });
          reader._readRequests = new SimpleQueue();
        }
      }
      function ReadableStreamError(stream, e2) {
        stream._state = "errored";
        stream._storedError = e2;
        const reader = stream._reader;
        if (reader === void 0) {
          return;
        }
        defaultReaderClosedPromiseReject(reader, e2);
        if (IsReadableStreamDefaultReader(reader)) {
          reader._readRequests.forEach((readRequest) => {
            readRequest._errorSteps(e2);
          });
          reader._readRequests = new SimpleQueue();
        } else {
          reader._readIntoRequests.forEach((readIntoRequest) => {
            readIntoRequest._errorSteps(e2);
          });
          reader._readIntoRequests = new SimpleQueue();
        }
      }
      function streamBrandCheckException$1(name) {
        return new TypeError(`ReadableStream.prototype.${name} can only be used on a ReadableStream`);
      }
      function convertQueuingStrategyInit(init, context2) {
        assertDictionary(init, context2);
        const highWaterMark = init === null || init === void 0 ? void 0 : init.highWaterMark;
        assertRequiredField(highWaterMark, "highWaterMark", "QueuingStrategyInit");
        return {
          highWaterMark: convertUnrestrictedDouble(highWaterMark)
        };
      }
      const byteLengthSizeFunction = (chunk) => {
        return chunk.byteLength;
      };
      try {
        Object.defineProperty(byteLengthSizeFunction, "name", {
          value: "size",
          configurable: true
        });
      } catch (_a4) {
      }
      class ByteLengthQueuingStrategy {
        constructor(options) {
          assertRequiredArgument(options, 1, "ByteLengthQueuingStrategy");
          options = convertQueuingStrategyInit(options, "First parameter");
          this._byteLengthQueuingStrategyHighWaterMark = options.highWaterMark;
        }
        get highWaterMark() {
          if (!IsByteLengthQueuingStrategy(this)) {
            throw byteLengthBrandCheckException("highWaterMark");
          }
          return this._byteLengthQueuingStrategyHighWaterMark;
        }
        get size() {
          if (!IsByteLengthQueuingStrategy(this)) {
            throw byteLengthBrandCheckException("size");
          }
          return byteLengthSizeFunction;
        }
      }
      Object.defineProperties(ByteLengthQueuingStrategy.prototype, {
        highWaterMark: { enumerable: true },
        size: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(ByteLengthQueuingStrategy.prototype, SymbolPolyfill.toStringTag, {
          value: "ByteLengthQueuingStrategy",
          configurable: true
        });
      }
      function byteLengthBrandCheckException(name) {
        return new TypeError(`ByteLengthQueuingStrategy.prototype.${name} can only be used on a ByteLengthQueuingStrategy`);
      }
      function IsByteLengthQueuingStrategy(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_byteLengthQueuingStrategyHighWaterMark")) {
          return false;
        }
        return x2 instanceof ByteLengthQueuingStrategy;
      }
      const countSizeFunction = () => {
        return 1;
      };
      try {
        Object.defineProperty(countSizeFunction, "name", {
          value: "size",
          configurable: true
        });
      } catch (_a4) {
      }
      class CountQueuingStrategy {
        constructor(options) {
          assertRequiredArgument(options, 1, "CountQueuingStrategy");
          options = convertQueuingStrategyInit(options, "First parameter");
          this._countQueuingStrategyHighWaterMark = options.highWaterMark;
        }
        get highWaterMark() {
          if (!IsCountQueuingStrategy(this)) {
            throw countBrandCheckException("highWaterMark");
          }
          return this._countQueuingStrategyHighWaterMark;
        }
        get size() {
          if (!IsCountQueuingStrategy(this)) {
            throw countBrandCheckException("size");
          }
          return countSizeFunction;
        }
      }
      Object.defineProperties(CountQueuingStrategy.prototype, {
        highWaterMark: { enumerable: true },
        size: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(CountQueuingStrategy.prototype, SymbolPolyfill.toStringTag, {
          value: "CountQueuingStrategy",
          configurable: true
        });
      }
      function countBrandCheckException(name) {
        return new TypeError(`CountQueuingStrategy.prototype.${name} can only be used on a CountQueuingStrategy`);
      }
      function IsCountQueuingStrategy(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_countQueuingStrategyHighWaterMark")) {
          return false;
        }
        return x2 instanceof CountQueuingStrategy;
      }
      function convertTransformer(original, context2) {
        assertDictionary(original, context2);
        const flush = original === null || original === void 0 ? void 0 : original.flush;
        const readableType = original === null || original === void 0 ? void 0 : original.readableType;
        const start = original === null || original === void 0 ? void 0 : original.start;
        const transform = original === null || original === void 0 ? void 0 : original.transform;
        const writableType = original === null || original === void 0 ? void 0 : original.writableType;
        return {
          flush: flush === void 0 ? void 0 : convertTransformerFlushCallback(flush, original, `${context2} has member 'flush' that`),
          readableType,
          start: start === void 0 ? void 0 : convertTransformerStartCallback(start, original, `${context2} has member 'start' that`),
          transform: transform === void 0 ? void 0 : convertTransformerTransformCallback(transform, original, `${context2} has member 'transform' that`),
          writableType
        };
      }
      function convertTransformerFlushCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (controller) => promiseCall(fn, original, [controller]);
      }
      function convertTransformerStartCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (controller) => reflectCall(fn, original, [controller]);
      }
      function convertTransformerTransformCallback(fn, original, context2) {
        assertFunction(fn, context2);
        return (chunk, controller) => promiseCall(fn, original, [chunk, controller]);
      }
      class TransformStream {
        constructor(rawTransformer = {}, rawWritableStrategy = {}, rawReadableStrategy = {}) {
          if (rawTransformer === void 0) {
            rawTransformer = null;
          }
          const writableStrategy = convertQueuingStrategy(rawWritableStrategy, "Second parameter");
          const readableStrategy = convertQueuingStrategy(rawReadableStrategy, "Third parameter");
          const transformer = convertTransformer(rawTransformer, "First parameter");
          if (transformer.readableType !== void 0) {
            throw new RangeError("Invalid readableType specified");
          }
          if (transformer.writableType !== void 0) {
            throw new RangeError("Invalid writableType specified");
          }
          const readableHighWaterMark = ExtractHighWaterMark(readableStrategy, 0);
          const readableSizeAlgorithm = ExtractSizeAlgorithm(readableStrategy);
          const writableHighWaterMark = ExtractHighWaterMark(writableStrategy, 1);
          const writableSizeAlgorithm = ExtractSizeAlgorithm(writableStrategy);
          let startPromise_resolve;
          const startPromise = newPromise((resolve) => {
            startPromise_resolve = resolve;
          });
          InitializeTransformStream(this, startPromise, writableHighWaterMark, writableSizeAlgorithm, readableHighWaterMark, readableSizeAlgorithm);
          SetUpTransformStreamDefaultControllerFromTransformer(this, transformer);
          if (transformer.start !== void 0) {
            startPromise_resolve(transformer.start(this._transformStreamController));
          } else {
            startPromise_resolve(void 0);
          }
        }
        get readable() {
          if (!IsTransformStream(this)) {
            throw streamBrandCheckException("readable");
          }
          return this._readable;
        }
        get writable() {
          if (!IsTransformStream(this)) {
            throw streamBrandCheckException("writable");
          }
          return this._writable;
        }
      }
      Object.defineProperties(TransformStream.prototype, {
        readable: { enumerable: true },
        writable: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(TransformStream.prototype, SymbolPolyfill.toStringTag, {
          value: "TransformStream",
          configurable: true
        });
      }
      function InitializeTransformStream(stream, startPromise, writableHighWaterMark, writableSizeAlgorithm, readableHighWaterMark, readableSizeAlgorithm) {
        function startAlgorithm() {
          return startPromise;
        }
        function writeAlgorithm(chunk) {
          return TransformStreamDefaultSinkWriteAlgorithm(stream, chunk);
        }
        function abortAlgorithm(reason) {
          return TransformStreamDefaultSinkAbortAlgorithm(stream, reason);
        }
        function closeAlgorithm() {
          return TransformStreamDefaultSinkCloseAlgorithm(stream);
        }
        stream._writable = CreateWritableStream(startAlgorithm, writeAlgorithm, closeAlgorithm, abortAlgorithm, writableHighWaterMark, writableSizeAlgorithm);
        function pullAlgorithm() {
          return TransformStreamDefaultSourcePullAlgorithm(stream);
        }
        function cancelAlgorithm(reason) {
          TransformStreamErrorWritableAndUnblockWrite(stream, reason);
          return promiseResolvedWith(void 0);
        }
        stream._readable = CreateReadableStream(startAlgorithm, pullAlgorithm, cancelAlgorithm, readableHighWaterMark, readableSizeAlgorithm);
        stream._backpressure = void 0;
        stream._backpressureChangePromise = void 0;
        stream._backpressureChangePromise_resolve = void 0;
        TransformStreamSetBackpressure(stream, true);
        stream._transformStreamController = void 0;
      }
      function IsTransformStream(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_transformStreamController")) {
          return false;
        }
        return x2 instanceof TransformStream;
      }
      function TransformStreamError(stream, e2) {
        ReadableStreamDefaultControllerError(stream._readable._readableStreamController, e2);
        TransformStreamErrorWritableAndUnblockWrite(stream, e2);
      }
      function TransformStreamErrorWritableAndUnblockWrite(stream, e2) {
        TransformStreamDefaultControllerClearAlgorithms(stream._transformStreamController);
        WritableStreamDefaultControllerErrorIfNeeded(stream._writable._writableStreamController, e2);
        if (stream._backpressure) {
          TransformStreamSetBackpressure(stream, false);
        }
      }
      function TransformStreamSetBackpressure(stream, backpressure) {
        if (stream._backpressureChangePromise !== void 0) {
          stream._backpressureChangePromise_resolve();
        }
        stream._backpressureChangePromise = newPromise((resolve) => {
          stream._backpressureChangePromise_resolve = resolve;
        });
        stream._backpressure = backpressure;
      }
      class TransformStreamDefaultController {
        constructor() {
          throw new TypeError("Illegal constructor");
        }
        get desiredSize() {
          if (!IsTransformStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException("desiredSize");
          }
          const readableController = this._controlledTransformStream._readable._readableStreamController;
          return ReadableStreamDefaultControllerGetDesiredSize(readableController);
        }
        enqueue(chunk = void 0) {
          if (!IsTransformStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException("enqueue");
          }
          TransformStreamDefaultControllerEnqueue(this, chunk);
        }
        error(reason = void 0) {
          if (!IsTransformStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException("error");
          }
          TransformStreamDefaultControllerError(this, reason);
        }
        terminate() {
          if (!IsTransformStreamDefaultController(this)) {
            throw defaultControllerBrandCheckException("terminate");
          }
          TransformStreamDefaultControllerTerminate(this);
        }
      }
      Object.defineProperties(TransformStreamDefaultController.prototype, {
        enqueue: { enumerable: true },
        error: { enumerable: true },
        terminate: { enumerable: true },
        desiredSize: { enumerable: true }
      });
      if (typeof SymbolPolyfill.toStringTag === "symbol") {
        Object.defineProperty(TransformStreamDefaultController.prototype, SymbolPolyfill.toStringTag, {
          value: "TransformStreamDefaultController",
          configurable: true
        });
      }
      function IsTransformStreamDefaultController(x2) {
        if (!typeIsObject(x2)) {
          return false;
        }
        if (!Object.prototype.hasOwnProperty.call(x2, "_controlledTransformStream")) {
          return false;
        }
        return x2 instanceof TransformStreamDefaultController;
      }
      function SetUpTransformStreamDefaultController(stream, controller, transformAlgorithm, flushAlgorithm) {
        controller._controlledTransformStream = stream;
        stream._transformStreamController = controller;
        controller._transformAlgorithm = transformAlgorithm;
        controller._flushAlgorithm = flushAlgorithm;
      }
      function SetUpTransformStreamDefaultControllerFromTransformer(stream, transformer) {
        const controller = Object.create(TransformStreamDefaultController.prototype);
        let transformAlgorithm = (chunk) => {
          try {
            TransformStreamDefaultControllerEnqueue(controller, chunk);
            return promiseResolvedWith(void 0);
          } catch (transformResultE) {
            return promiseRejectedWith(transformResultE);
          }
        };
        let flushAlgorithm = () => promiseResolvedWith(void 0);
        if (transformer.transform !== void 0) {
          transformAlgorithm = (chunk) => transformer.transform(chunk, controller);
        }
        if (transformer.flush !== void 0) {
          flushAlgorithm = () => transformer.flush(controller);
        }
        SetUpTransformStreamDefaultController(stream, controller, transformAlgorithm, flushAlgorithm);
      }
      function TransformStreamDefaultControllerClearAlgorithms(controller) {
        controller._transformAlgorithm = void 0;
        controller._flushAlgorithm = void 0;
      }
      function TransformStreamDefaultControllerEnqueue(controller, chunk) {
        const stream = controller._controlledTransformStream;
        const readableController = stream._readable._readableStreamController;
        if (!ReadableStreamDefaultControllerCanCloseOrEnqueue(readableController)) {
          throw new TypeError("Readable side is not in a state that permits enqueue");
        }
        try {
          ReadableStreamDefaultControllerEnqueue(readableController, chunk);
        } catch (e2) {
          TransformStreamErrorWritableAndUnblockWrite(stream, e2);
          throw stream._readable._storedError;
        }
        const backpressure = ReadableStreamDefaultControllerHasBackpressure(readableController);
        if (backpressure !== stream._backpressure) {
          TransformStreamSetBackpressure(stream, true);
        }
      }
      function TransformStreamDefaultControllerError(controller, e2) {
        TransformStreamError(controller._controlledTransformStream, e2);
      }
      function TransformStreamDefaultControllerPerformTransform(controller, chunk) {
        const transformPromise = controller._transformAlgorithm(chunk);
        return transformPromiseWith(transformPromise, void 0, (r2) => {
          TransformStreamError(controller._controlledTransformStream, r2);
          throw r2;
        });
      }
      function TransformStreamDefaultControllerTerminate(controller) {
        const stream = controller._controlledTransformStream;
        const readableController = stream._readable._readableStreamController;
        ReadableStreamDefaultControllerClose(readableController);
        const error = new TypeError("TransformStream terminated");
        TransformStreamErrorWritableAndUnblockWrite(stream, error);
      }
      function TransformStreamDefaultSinkWriteAlgorithm(stream, chunk) {
        const controller = stream._transformStreamController;
        if (stream._backpressure) {
          const backpressureChangePromise = stream._backpressureChangePromise;
          return transformPromiseWith(backpressureChangePromise, () => {
            const writable = stream._writable;
            const state = writable._state;
            if (state === "erroring") {
              throw writable._storedError;
            }
            return TransformStreamDefaultControllerPerformTransform(controller, chunk);
          });
        }
        return TransformStreamDefaultControllerPerformTransform(controller, chunk);
      }
      function TransformStreamDefaultSinkAbortAlgorithm(stream, reason) {
        TransformStreamError(stream, reason);
        return promiseResolvedWith(void 0);
      }
      function TransformStreamDefaultSinkCloseAlgorithm(stream) {
        const readable = stream._readable;
        const controller = stream._transformStreamController;
        const flushPromise = controller._flushAlgorithm();
        TransformStreamDefaultControllerClearAlgorithms(controller);
        return transformPromiseWith(flushPromise, () => {
          if (readable._state === "errored") {
            throw readable._storedError;
          }
          ReadableStreamDefaultControllerClose(readable._readableStreamController);
        }, (r2) => {
          TransformStreamError(stream, r2);
          throw readable._storedError;
        });
      }
      function TransformStreamDefaultSourcePullAlgorithm(stream) {
        TransformStreamSetBackpressure(stream, false);
        return stream._backpressureChangePromise;
      }
      function defaultControllerBrandCheckException(name) {
        return new TypeError(`TransformStreamDefaultController.prototype.${name} can only be used on a TransformStreamDefaultController`);
      }
      function streamBrandCheckException(name) {
        return new TypeError(`TransformStream.prototype.${name} can only be used on a TransformStream`);
      }
      exports2.ByteLengthQueuingStrategy = ByteLengthQueuingStrategy;
      exports2.CountQueuingStrategy = CountQueuingStrategy;
      exports2.ReadableByteStreamController = ReadableByteStreamController;
      exports2.ReadableStream = ReadableStream2;
      exports2.ReadableStreamBYOBReader = ReadableStreamBYOBReader;
      exports2.ReadableStreamBYOBRequest = ReadableStreamBYOBRequest;
      exports2.ReadableStreamDefaultController = ReadableStreamDefaultController;
      exports2.ReadableStreamDefaultReader = ReadableStreamDefaultReader;
      exports2.TransformStream = TransformStream;
      exports2.TransformStreamDefaultController = TransformStreamDefaultController;
      exports2.WritableStream = WritableStream;
      exports2.WritableStreamDefaultController = WritableStreamDefaultController;
      exports2.WritableStreamDefaultWriter = WritableStreamDefaultWriter;
      Object.defineProperty(exports2, "__esModule", { value: true });
    });
  }
});

// node_modules/fetch-blob/streams.cjs
var require_streams = __commonJS({
  "node_modules/fetch-blob/streams.cjs"() {
    var POOL_SIZE2 = 65536;
    if (!globalThis.ReadableStream) {
      try {
        const process2 = require("process");
        const { emitWarning } = process2;
        try {
          process2.emitWarning = () => {
          };
          Object.assign(globalThis, require("stream/web"));
          process2.emitWarning = emitWarning;
        } catch (error) {
          process2.emitWarning = emitWarning;
          throw error;
        }
      } catch (error) {
        Object.assign(globalThis, require_ponyfill_es2018());
      }
    }
    try {
      const { Blob: Blob3 } = require("buffer");
      if (Blob3 && !Blob3.prototype.stream) {
        Blob3.prototype.stream = function name(params) {
          let position = 0;
          const blob = this;
          return new ReadableStream({
            type: "bytes",
            async pull(ctrl) {
              const chunk = blob.slice(position, Math.min(blob.size, position + POOL_SIZE2));
              const buffer = await chunk.arrayBuffer();
              position += buffer.byteLength;
              ctrl.enqueue(new Uint8Array(buffer));
              if (position === blob.size) {
                ctrl.close();
              }
            }
          });
        };
      }
    } catch (error) {
    }
  }
});

// node_modules/fetch-blob/index.js
async function* toIterator(parts, clone3 = true) {
  for (const part of parts) {
    if ("stream" in part) {
      yield* part.stream();
    } else if (ArrayBuffer.isView(part)) {
      if (clone3) {
        let position = part.byteOffset;
        const end = part.byteOffset + part.byteLength;
        while (position !== end) {
          const size = Math.min(end - position, POOL_SIZE);
          const chunk = part.buffer.slice(position, position + size);
          position += chunk.byteLength;
          yield new Uint8Array(chunk);
        }
      } else {
        yield part;
      }
    } else {
      let position = 0, b = part;
      while (position !== b.size) {
        const chunk = b.slice(position, Math.min(b.size, position + POOL_SIZE));
        const buffer = await chunk.arrayBuffer();
        position += buffer.byteLength;
        yield new Uint8Array(buffer);
      }
    }
  }
}
var import_streams, POOL_SIZE, _parts, _type, _size, _endings, _a, _Blob, Blob2, fetch_blob_default;
var init_fetch_blob = __esm({
  "node_modules/fetch-blob/index.js"() {
    import_streams = __toESM(require_streams(), 1);
    POOL_SIZE = 65536;
    _Blob = (_a = class {
      constructor(blobParts = [], options = {}) {
        __privateAdd(this, _parts, []);
        __privateAdd(this, _type, "");
        __privateAdd(this, _size, 0);
        __privateAdd(this, _endings, "transparent");
        if (typeof blobParts !== "object" || blobParts === null) {
          throw new TypeError("Failed to construct 'Blob': The provided value cannot be converted to a sequence.");
        }
        if (typeof blobParts[Symbol.iterator] !== "function") {
          throw new TypeError("Failed to construct 'Blob': The object must have a callable @@iterator property.");
        }
        if (typeof options !== "object" && typeof options !== "function") {
          throw new TypeError("Failed to construct 'Blob': parameter 2 cannot convert to dictionary.");
        }
        if (options === null)
          options = {};
        const encoder = new TextEncoder();
        for (const element of blobParts) {
          let part;
          if (ArrayBuffer.isView(element)) {
            part = new Uint8Array(element.buffer.slice(element.byteOffset, element.byteOffset + element.byteLength));
          } else if (element instanceof ArrayBuffer) {
            part = new Uint8Array(element.slice(0));
          } else if (element instanceof _a) {
            part = element;
          } else {
            part = encoder.encode(`${element}`);
          }
          __privateSet(this, _size, __privateGet(this, _size) + (ArrayBuffer.isView(part) ? part.byteLength : part.size));
          __privateGet(this, _parts).push(part);
        }
        __privateSet(this, _endings, `${options.endings === void 0 ? "transparent" : options.endings}`);
        const type = options.type === void 0 ? "" : String(options.type);
        __privateSet(this, _type, /^[\x20-\x7E]*$/.test(type) ? type : "");
      }
      get size() {
        return __privateGet(this, _size);
      }
      get type() {
        return __privateGet(this, _type);
      }
      async text() {
        const decoder = new TextDecoder();
        let str = "";
        for await (const part of toIterator(__privateGet(this, _parts), false)) {
          str += decoder.decode(part, { stream: true });
        }
        str += decoder.decode();
        return str;
      }
      async arrayBuffer() {
        const data = new Uint8Array(this.size);
        let offset = 0;
        for await (const chunk of toIterator(__privateGet(this, _parts), false)) {
          data.set(chunk, offset);
          offset += chunk.length;
        }
        return data.buffer;
      }
      stream() {
        const it = toIterator(__privateGet(this, _parts), true);
        return new globalThis.ReadableStream({
          type: "bytes",
          async pull(ctrl) {
            const chunk = await it.next();
            chunk.done ? ctrl.close() : ctrl.enqueue(chunk.value);
          },
          async cancel() {
            await it.return();
          }
        });
      }
      slice(start = 0, end = this.size, type = "") {
        const { size } = this;
        let relativeStart = start < 0 ? Math.max(size + start, 0) : Math.min(start, size);
        let relativeEnd = end < 0 ? Math.max(size + end, 0) : Math.min(end, size);
        const span = Math.max(relativeEnd - relativeStart, 0);
        const parts = __privateGet(this, _parts);
        const blobParts = [];
        let added = 0;
        for (const part of parts) {
          if (added >= span) {
            break;
          }
          const size2 = ArrayBuffer.isView(part) ? part.byteLength : part.size;
          if (relativeStart && size2 <= relativeStart) {
            relativeStart -= size2;
            relativeEnd -= size2;
          } else {
            let chunk;
            if (ArrayBuffer.isView(part)) {
              chunk = part.subarray(relativeStart, Math.min(size2, relativeEnd));
              added += chunk.byteLength;
            } else {
              chunk = part.slice(relativeStart, Math.min(size2, relativeEnd));
              added += chunk.size;
            }
            relativeEnd -= size2;
            blobParts.push(chunk);
            relativeStart = 0;
          }
        }
        const blob = new _a([], { type: String(type).toLowerCase() });
        __privateSet(blob, _size, span);
        __privateSet(blob, _parts, blobParts);
        return blob;
      }
      get [Symbol.toStringTag]() {
        return "Blob";
      }
      static [Symbol.hasInstance](object) {
        return object && typeof object === "object" && typeof object.constructor === "function" && (typeof object.stream === "function" || typeof object.arrayBuffer === "function") && /^(Blob|File)$/.test(object[Symbol.toStringTag]);
      }
    }, _parts = new WeakMap(), _type = new WeakMap(), _size = new WeakMap(), _endings = new WeakMap(), _a);
    Object.defineProperties(_Blob.prototype, {
      size: { enumerable: true },
      type: { enumerable: true },
      slice: { enumerable: true }
    });
    Blob2 = _Blob;
    fetch_blob_default = Blob2;
  }
});

// node_modules/fetch-blob/file.js
var _lastModified, _name, _a2, _File, File, file_default;
var init_file = __esm({
  "node_modules/fetch-blob/file.js"() {
    init_fetch_blob();
    _File = (_a2 = class extends fetch_blob_default {
      constructor(fileBits, fileName, options = {}) {
        if (arguments.length < 2) {
          throw new TypeError(`Failed to construct 'File': 2 arguments required, but only ${arguments.length} present.`);
        }
        super(fileBits, options);
        __privateAdd(this, _lastModified, 0);
        __privateAdd(this, _name, "");
        if (options === null)
          options = {};
        const lastModified = options.lastModified === void 0 ? Date.now() : Number(options.lastModified);
        if (!Number.isNaN(lastModified)) {
          __privateSet(this, _lastModified, lastModified);
        }
        __privateSet(this, _name, String(fileName));
      }
      get name() {
        return __privateGet(this, _name);
      }
      get lastModified() {
        return __privateGet(this, _lastModified);
      }
      get [Symbol.toStringTag]() {
        return "File";
      }
      static [Symbol.hasInstance](object) {
        return !!object && object instanceof fetch_blob_default && /^(File)$/.test(object[Symbol.toStringTag]);
      }
    }, _lastModified = new WeakMap(), _name = new WeakMap(), _a2);
    File = _File;
    file_default = File;
  }
});

// node_modules/formdata-polyfill/esm.min.js
function formDataToBlob(F2, B = fetch_blob_default) {
  var b = `${r()}${r()}`.replace(/\./g, "").slice(-28).padStart(32, "-"), c = [], p = `--${b}\r
Content-Disposition: form-data; name="`;
  F2.forEach((v, n) => typeof v == "string" ? c.push(p + e(n) + `"\r
\r
${v.replace(/\r(?!\n)|(?<!\r)\n/g, "\r\n")}\r
`) : c.push(p + e(n) + `"; filename="${e(v.name, 1)}"\r
Content-Type: ${v.type || "application/octet-stream"}\r
\r
`, v, "\r\n"));
  c.push(`--${b}--`);
  return new B(c, { type: "multipart/form-data; boundary=" + b });
}
var t, i, h, r, m, f, e, x, _d, _a3, FormData;
var init_esm_min = __esm({
  "node_modules/formdata-polyfill/esm.min.js"() {
    init_fetch_blob();
    init_file();
    ({ toStringTag: t, iterator: i, hasInstance: h } = Symbol);
    r = Math.random;
    m = "append,set,get,getAll,delete,keys,values,entries,forEach,constructor".split(",");
    f = (a, b, c) => (a += "", /^(Blob|File)$/.test(b && b[t]) ? [(c = c !== void 0 ? c + "" : b[t] == "File" ? b.name : "blob", a), b.name !== c || b[t] == "blob" ? new file_default([b], c, b) : b] : [a, b + ""]);
    e = (c, f3) => (f3 ? c : c.replace(/\r?\n|\r/g, "\r\n")).replace(/\n/g, "%0A").replace(/\r/g, "%0D").replace(/"/g, "%22");
    x = (n, a, e2) => {
      if (a.length < e2) {
        throw new TypeError(`Failed to execute '${n}' on 'FormData': ${e2} arguments required, but only ${a.length} present.`);
      }
    };
    FormData = (_a3 = class {
      constructor(...a) {
        __privateAdd(this, _d, []);
        if (a.length)
          throw new TypeError(`Failed to construct 'FormData': parameter 1 is not of type 'HTMLFormElement'.`);
      }
      get [t]() {
        return "FormData";
      }
      [i]() {
        return this.entries();
      }
      static [h](o) {
        return o && typeof o === "object" && o[t] === "FormData" && !m.some((m2) => typeof o[m2] != "function");
      }
      append(...a) {
        x("append", arguments, 2);
        __privateGet(this, _d).push(f(...a));
      }
      delete(a) {
        x("delete", arguments, 1);
        a += "";
        __privateSet(this, _d, __privateGet(this, _d).filter(([b]) => b !== a));
      }
      get(a) {
        x("get", arguments, 1);
        a += "";
        for (var b = __privateGet(this, _d), l = b.length, c = 0; c < l; c++)
          if (b[c][0] === a)
            return b[c][1];
        return null;
      }
      getAll(a, b) {
        x("getAll", arguments, 1);
        b = [];
        a += "";
        __privateGet(this, _d).forEach((c) => c[0] === a && b.push(c[1]));
        return b;
      }
      has(a) {
        x("has", arguments, 1);
        a += "";
        return __privateGet(this, _d).some((b) => b[0] === a);
      }
      forEach(a, b) {
        x("forEach", arguments, 1);
        for (var [c, d] of this)
          a.call(b, d, c, this);
      }
      set(...a) {
        x("set", arguments, 2);
        var b = [], c = true;
        a = f(...a);
        __privateGet(this, _d).forEach((d) => {
          d[0] === a[0] ? c && (c = !b.push(a)) : b.push(d);
        });
        c && b.push(a);
        __privateSet(this, _d, b);
      }
      *entries() {
        yield* __privateGet(this, _d);
      }
      *keys() {
        for (var [a] of this)
          yield a;
      }
      *values() {
        for (var [, a] of this)
          yield a;
      }
    }, _d = new WeakMap(), _a3);
  }
});

// node_modules/node-domexception/index.js
var require_node_domexception = __commonJS({
  "node_modules/node-domexception/index.js"(exports, module2) {
    if (!globalThis.DOMException) {
      try {
        const { MessageChannel } = require("worker_threads"), port = new MessageChannel().port1, ab = new ArrayBuffer();
        port.postMessage(ab, [ab, ab]);
      } catch (err) {
        err.constructor.name === "DOMException" && (globalThis.DOMException = err.constructor);
      }
    }
    module2.exports = globalThis.DOMException;
  }
});

// node_modules/fetch-blob/from.js
var import_node_fs, import_node_path, import_node_domexception, stat, _path, _start, _BlobDataItem, BlobDataItem;
var init_from = __esm({
  "node_modules/fetch-blob/from.js"() {
    import_node_fs = require("fs");
    import_node_path = require("path");
    import_node_domexception = __toESM(require_node_domexception(), 1);
    init_file();
    init_fetch_blob();
    ({ stat } = import_node_fs.promises);
    _BlobDataItem = class {
      constructor(options) {
        __privateAdd(this, _path, void 0);
        __privateAdd(this, _start, void 0);
        __privateSet(this, _path, options.path);
        __privateSet(this, _start, options.start);
        this.size = options.size;
        this.lastModified = options.lastModified;
      }
      slice(start, end) {
        return new _BlobDataItem({
          path: __privateGet(this, _path),
          lastModified: this.lastModified,
          size: end - start,
          start: __privateGet(this, _start) + start
        });
      }
      async *stream() {
        const { mtimeMs } = await stat(__privateGet(this, _path));
        if (mtimeMs > this.lastModified) {
          throw new import_node_domexception.default("The requested file could not be read, typically due to permission problems that have occurred after a reference to a file was acquired.", "NotReadableError");
        }
        yield* (0, import_node_fs.createReadStream)(__privateGet(this, _path), {
          start: __privateGet(this, _start),
          end: __privateGet(this, _start) + this.size - 1
        });
      }
      get [Symbol.toStringTag]() {
        return "Blob";
      }
    };
    BlobDataItem = _BlobDataItem;
    _path = new WeakMap();
    _start = new WeakMap();
  }
});

// node_modules/node-fetch/src/utils/multipart-parser.js
var multipart_parser_exports = {};
__export(multipart_parser_exports, {
  toFormData: () => toFormData
});
function _fileName(headerValue) {
  const m2 = headerValue.match(/\bfilename=("(.*?)"|([^()<>@,;:\\"/[\]?={}\s\t]+))($|;\s)/i);
  if (!m2) {
    return;
  }
  const match = m2[2] || m2[3] || "";
  let filename = match.slice(match.lastIndexOf("\\") + 1);
  filename = filename.replace(/%22/g, '"');
  filename = filename.replace(/&#(\d{4});/g, (m3, code) => {
    return String.fromCharCode(code);
  });
  return filename;
}
async function toFormData(Body3, ct) {
  if (!/multipart/i.test(ct)) {
    throw new TypeError("Failed to fetch");
  }
  const m2 = ct.match(/boundary=(?:"([^"]+)"|([^;]+))/i);
  if (!m2) {
    throw new TypeError("no or bad content-type header, no multipart boundary");
  }
  const parser = new MultipartParser(m2[1] || m2[2]);
  let headerField;
  let headerValue;
  let entryValue;
  let entryName;
  let contentType;
  let filename;
  const entryChunks = [];
  const formData = new FormData();
  const onPartData = (ui8a) => {
    entryValue += decoder.decode(ui8a, { stream: true });
  };
  const appendToFile = (ui8a) => {
    entryChunks.push(ui8a);
  };
  const appendFileToFormData = () => {
    const file = new file_default(entryChunks, filename, { type: contentType });
    formData.append(entryName, file);
  };
  const appendEntryToFormData = () => {
    formData.append(entryName, entryValue);
  };
  const decoder = new TextDecoder("utf-8");
  decoder.decode();
  parser.onPartBegin = function() {
    parser.onPartData = onPartData;
    parser.onPartEnd = appendEntryToFormData;
    headerField = "";
    headerValue = "";
    entryValue = "";
    entryName = "";
    contentType = "";
    filename = null;
    entryChunks.length = 0;
  };
  parser.onHeaderField = function(ui8a) {
    headerField += decoder.decode(ui8a, { stream: true });
  };
  parser.onHeaderValue = function(ui8a) {
    headerValue += decoder.decode(ui8a, { stream: true });
  };
  parser.onHeaderEnd = function() {
    headerValue += decoder.decode();
    headerField = headerField.toLowerCase();
    if (headerField === "content-disposition") {
      const m3 = headerValue.match(/\bname=("([^"]*)"|([^()<>@,;:\\"/[\]?={}\s\t]+))/i);
      if (m3) {
        entryName = m3[2] || m3[3] || "";
      }
      filename = _fileName(headerValue);
      if (filename) {
        parser.onPartData = appendToFile;
        parser.onPartEnd = appendFileToFormData;
      }
    } else if (headerField === "content-type") {
      contentType = headerValue;
    }
    headerValue = "";
    headerField = "";
  };
  for await (const chunk of Body3) {
    parser.write(chunk);
  }
  parser.end();
  return formData;
}
var s, S, f2, F, LF, CR, SPACE, HYPHEN, COLON, A, Z, lower, noop, MultipartParser;
var init_multipart_parser = __esm({
  "node_modules/node-fetch/src/utils/multipart-parser.js"() {
    init_from();
    init_esm_min();
    s = 0;
    S = {
      START_BOUNDARY: s++,
      HEADER_FIELD_START: s++,
      HEADER_FIELD: s++,
      HEADER_VALUE_START: s++,
      HEADER_VALUE: s++,
      HEADER_VALUE_ALMOST_DONE: s++,
      HEADERS_ALMOST_DONE: s++,
      PART_DATA_START: s++,
      PART_DATA: s++,
      END: s++
    };
    f2 = 1;
    F = {
      PART_BOUNDARY: f2,
      LAST_BOUNDARY: f2 *= 2
    };
    LF = 10;
    CR = 13;
    SPACE = 32;
    HYPHEN = 45;
    COLON = 58;
    A = 97;
    Z = 122;
    lower = (c) => c | 32;
    noop = () => {
    };
    MultipartParser = class {
      constructor(boundary) {
        this.index = 0;
        this.flags = 0;
        this.onHeaderEnd = noop;
        this.onHeaderField = noop;
        this.onHeadersEnd = noop;
        this.onHeaderValue = noop;
        this.onPartBegin = noop;
        this.onPartData = noop;
        this.onPartEnd = noop;
        this.boundaryChars = {};
        boundary = "\r\n--" + boundary;
        const ui8a = new Uint8Array(boundary.length);
        for (let i2 = 0; i2 < boundary.length; i2++) {
          ui8a[i2] = boundary.charCodeAt(i2);
          this.boundaryChars[ui8a[i2]] = true;
        }
        this.boundary = ui8a;
        this.lookbehind = new Uint8Array(this.boundary.length + 8);
        this.state = S.START_BOUNDARY;
      }
      write(data) {
        let i2 = 0;
        const length_ = data.length;
        let previousIndex = this.index;
        let { lookbehind, boundary, boundaryChars, index, state, flags } = this;
        const boundaryLength = this.boundary.length;
        const boundaryEnd = boundaryLength - 1;
        const bufferLength = data.length;
        let c;
        let cl;
        const mark = (name) => {
          this[name + "Mark"] = i2;
        };
        const clear = (name) => {
          delete this[name + "Mark"];
        };
        const callback = (callbackSymbol, start, end, ui8a) => {
          if (start === void 0 || start !== end) {
            this[callbackSymbol](ui8a && ui8a.subarray(start, end));
          }
        };
        const dataCallback = (name, clear2) => {
          const markSymbol = name + "Mark";
          if (!(markSymbol in this)) {
            return;
          }
          if (clear2) {
            callback(name, this[markSymbol], i2, data);
            delete this[markSymbol];
          } else {
            callback(name, this[markSymbol], data.length, data);
            this[markSymbol] = 0;
          }
        };
        for (i2 = 0; i2 < length_; i2++) {
          c = data[i2];
          switch (state) {
            case S.START_BOUNDARY:
              if (index === boundary.length - 2) {
                if (c === HYPHEN) {
                  flags |= F.LAST_BOUNDARY;
                } else if (c !== CR) {
                  return;
                }
                index++;
                break;
              } else if (index - 1 === boundary.length - 2) {
                if (flags & F.LAST_BOUNDARY && c === HYPHEN) {
                  state = S.END;
                  flags = 0;
                } else if (!(flags & F.LAST_BOUNDARY) && c === LF) {
                  index = 0;
                  callback("onPartBegin");
                  state = S.HEADER_FIELD_START;
                } else {
                  return;
                }
                break;
              }
              if (c !== boundary[index + 2]) {
                index = -2;
              }
              if (c === boundary[index + 2]) {
                index++;
              }
              break;
            case S.HEADER_FIELD_START:
              state = S.HEADER_FIELD;
              mark("onHeaderField");
              index = 0;
            case S.HEADER_FIELD:
              if (c === CR) {
                clear("onHeaderField");
                state = S.HEADERS_ALMOST_DONE;
                break;
              }
              index++;
              if (c === HYPHEN) {
                break;
              }
              if (c === COLON) {
                if (index === 1) {
                  return;
                }
                dataCallback("onHeaderField", true);
                state = S.HEADER_VALUE_START;
                break;
              }
              cl = lower(c);
              if (cl < A || cl > Z) {
                return;
              }
              break;
            case S.HEADER_VALUE_START:
              if (c === SPACE) {
                break;
              }
              mark("onHeaderValue");
              state = S.HEADER_VALUE;
            case S.HEADER_VALUE:
              if (c === CR) {
                dataCallback("onHeaderValue", true);
                callback("onHeaderEnd");
                state = S.HEADER_VALUE_ALMOST_DONE;
              }
              break;
            case S.HEADER_VALUE_ALMOST_DONE:
              if (c !== LF) {
                return;
              }
              state = S.HEADER_FIELD_START;
              break;
            case S.HEADERS_ALMOST_DONE:
              if (c !== LF) {
                return;
              }
              callback("onHeadersEnd");
              state = S.PART_DATA_START;
              break;
            case S.PART_DATA_START:
              state = S.PART_DATA;
              mark("onPartData");
            case S.PART_DATA:
              previousIndex = index;
              if (index === 0) {
                i2 += boundaryEnd;
                while (i2 < bufferLength && !(data[i2] in boundaryChars)) {
                  i2 += boundaryLength;
                }
                i2 -= boundaryEnd;
                c = data[i2];
              }
              if (index < boundary.length) {
                if (boundary[index] === c) {
                  if (index === 0) {
                    dataCallback("onPartData", true);
                  }
                  index++;
                } else {
                  index = 0;
                }
              } else if (index === boundary.length) {
                index++;
                if (c === CR) {
                  flags |= F.PART_BOUNDARY;
                } else if (c === HYPHEN) {
                  flags |= F.LAST_BOUNDARY;
                } else {
                  index = 0;
                }
              } else if (index - 1 === boundary.length) {
                if (flags & F.PART_BOUNDARY) {
                  index = 0;
                  if (c === LF) {
                    flags &= ~F.PART_BOUNDARY;
                    callback("onPartEnd");
                    callback("onPartBegin");
                    state = S.HEADER_FIELD_START;
                    break;
                  }
                } else if (flags & F.LAST_BOUNDARY) {
                  if (c === HYPHEN) {
                    callback("onPartEnd");
                    state = S.END;
                    flags = 0;
                  } else {
                    index = 0;
                  }
                } else {
                  index = 0;
                }
              }
              if (index > 0) {
                lookbehind[index - 1] = c;
              } else if (previousIndex > 0) {
                const _lookbehind = new Uint8Array(lookbehind.buffer, lookbehind.byteOffset, lookbehind.byteLength);
                callback("onPartData", 0, previousIndex, _lookbehind);
                previousIndex = 0;
                mark("onPartData");
                i2--;
              }
              break;
            case S.END:
              break;
            default:
              throw new Error(`Unexpected state entered: ${state}`);
          }
        }
        dataCallback("onHeaderField");
        dataCallback("onHeaderValue");
        dataCallback("onPartData");
        this.index = index;
        this.state = state;
        this.flags = flags;
      }
      end() {
        if (this.state === S.HEADER_FIELD_START && this.index === 0 || this.state === S.PART_DATA && this.index === this.boundary.length) {
          this.onPartEnd();
        } else if (this.state !== S.END) {
          throw new Error("MultipartParser.end(): stream ended unexpectedly");
        }
      }
    };
  }
});

// node_modules/@babel/runtime/helpers/typeof.js
var require_typeof = __commonJS({
  "node_modules/@babel/runtime/helpers/typeof.js"(exports, module2) {
    function _typeof2(obj) {
      "@babel/helpers - typeof";
      return module2.exports = _typeof2 = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
        return typeof obj2;
      } : function(obj2) {
        return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
      }, module2.exports.__esModule = true, module2.exports["default"] = module2.exports, _typeof2(obj);
    }
    module2.exports = _typeof2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/regeneratorRuntime.js
var require_regeneratorRuntime = __commonJS({
  "node_modules/@babel/runtime/helpers/regeneratorRuntime.js"(exports, module2) {
    var _typeof2 = require_typeof()["default"];
    function _regeneratorRuntime2() {
      "use strict";
      module2.exports = _regeneratorRuntime2 = function _regeneratorRuntime3() {
        return exports2;
      }, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
      var exports2 = {}, Op = Object.prototype, hasOwn = Op.hasOwnProperty, $Symbol = "function" == typeof Symbol ? Symbol : {}, iteratorSymbol = $Symbol.iterator || "@@iterator", asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator", toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
      function define2(obj, key, value) {
        return Object.defineProperty(obj, key, {
          value,
          enumerable: true,
          configurable: true,
          writable: true
        }), obj[key];
      }
      try {
        define2({}, "");
      } catch (err) {
        define2 = function define3(obj, key, value) {
          return obj[key] = value;
        };
      }
      function wrap(innerFn, outerFn, self2, tryLocsList) {
        var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator, generator = Object.create(protoGenerator.prototype), context2 = new Context(tryLocsList || []);
        return generator._invoke = function(innerFn2, self3, context3) {
          var state = "suspendedStart";
          return function(method, arg) {
            if ("executing" === state)
              throw new Error("Generator is already running");
            if ("completed" === state) {
              if ("throw" === method)
                throw arg;
              return doneResult();
            }
            for (context3.method = method, context3.arg = arg; ; ) {
              var delegate = context3.delegate;
              if (delegate) {
                var delegateResult = maybeInvokeDelegate(delegate, context3);
                if (delegateResult) {
                  if (delegateResult === ContinueSentinel)
                    continue;
                  return delegateResult;
                }
              }
              if ("next" === context3.method)
                context3.sent = context3._sent = context3.arg;
              else if ("throw" === context3.method) {
                if ("suspendedStart" === state)
                  throw state = "completed", context3.arg;
                context3.dispatchException(context3.arg);
              } else
                "return" === context3.method && context3.abrupt("return", context3.arg);
              state = "executing";
              var record = tryCatch(innerFn2, self3, context3);
              if ("normal" === record.type) {
                if (state = context3.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel)
                  continue;
                return {
                  value: record.arg,
                  done: context3.done
                };
              }
              "throw" === record.type && (state = "completed", context3.method = "throw", context3.arg = record.arg);
            }
          };
        }(innerFn, self2, context2), generator;
      }
      function tryCatch(fn, obj, arg) {
        try {
          return {
            type: "normal",
            arg: fn.call(obj, arg)
          };
        } catch (err) {
          return {
            type: "throw",
            arg: err
          };
        }
      }
      exports2.wrap = wrap;
      var ContinueSentinel = {};
      function Generator() {
      }
      function GeneratorFunction() {
      }
      function GeneratorFunctionPrototype() {
      }
      var IteratorPrototype = {};
      define2(IteratorPrototype, iteratorSymbol, function() {
        return this;
      });
      var getProto = Object.getPrototypeOf, NativeIteratorPrototype = getProto && getProto(getProto(values([])));
      NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
      var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
      function defineIteratorMethods(prototype) {
        ["next", "throw", "return"].forEach(function(method) {
          define2(prototype, method, function(arg) {
            return this._invoke(method, arg);
          });
        });
      }
      function AsyncIterator(generator, PromiseImpl) {
        function invoke(method, arg, resolve, reject) {
          var record = tryCatch(generator[method], generator, arg);
          if ("throw" !== record.type) {
            var result = record.arg, value = result.value;
            return value && "object" == _typeof2(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function(value2) {
              invoke("next", value2, resolve, reject);
            }, function(err) {
              invoke("throw", err, resolve, reject);
            }) : PromiseImpl.resolve(value).then(function(unwrapped) {
              result.value = unwrapped, resolve(result);
            }, function(error) {
              return invoke("throw", error, resolve, reject);
            });
          }
          reject(record.arg);
        }
        var previousPromise;
        this._invoke = function(method, arg) {
          function callInvokeWithMethodAndArg() {
            return new PromiseImpl(function(resolve, reject) {
              invoke(method, arg, resolve, reject);
            });
          }
          return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
        };
      }
      function maybeInvokeDelegate(delegate, context2) {
        var method = delegate.iterator[context2.method];
        if (void 0 === method) {
          if (context2.delegate = null, "throw" === context2.method) {
            if (delegate.iterator["return"] && (context2.method = "return", context2.arg = void 0, maybeInvokeDelegate(delegate, context2), "throw" === context2.method))
              return ContinueSentinel;
            context2.method = "throw", context2.arg = new TypeError("The iterator does not provide a 'throw' method");
          }
          return ContinueSentinel;
        }
        var record = tryCatch(method, delegate.iterator, context2.arg);
        if ("throw" === record.type)
          return context2.method = "throw", context2.arg = record.arg, context2.delegate = null, ContinueSentinel;
        var info = record.arg;
        return info ? info.done ? (context2[delegate.resultName] = info.value, context2.next = delegate.nextLoc, "return" !== context2.method && (context2.method = "next", context2.arg = void 0), context2.delegate = null, ContinueSentinel) : info : (context2.method = "throw", context2.arg = new TypeError("iterator result is not an object"), context2.delegate = null, ContinueSentinel);
      }
      function pushTryEntry(locs) {
        var entry = {
          tryLoc: locs[0]
        };
        1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
      }
      function resetTryEntry(entry) {
        var record = entry.completion || {};
        record.type = "normal", delete record.arg, entry.completion = record;
      }
      function Context(tryLocsList) {
        this.tryEntries = [{
          tryLoc: "root"
        }], tryLocsList.forEach(pushTryEntry, this), this.reset(true);
      }
      function values(iterable) {
        if (iterable) {
          var iteratorMethod = iterable[iteratorSymbol];
          if (iteratorMethod)
            return iteratorMethod.call(iterable);
          if ("function" == typeof iterable.next)
            return iterable;
          if (!isNaN(iterable.length)) {
            var i2 = -1, next = function next2() {
              for (; ++i2 < iterable.length; ) {
                if (hasOwn.call(iterable, i2))
                  return next2.value = iterable[i2], next2.done = false, next2;
              }
              return next2.value = void 0, next2.done = true, next2;
            };
            return next.next = next;
          }
        }
        return {
          next: doneResult
        };
      }
      function doneResult() {
        return {
          value: void 0,
          done: true
        };
      }
      return GeneratorFunction.prototype = GeneratorFunctionPrototype, define2(Gp, "constructor", GeneratorFunctionPrototype), define2(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define2(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports2.isGeneratorFunction = function(genFun) {
        var ctor = "function" == typeof genFun && genFun.constructor;
        return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
      }, exports2.mark = function(genFun) {
        return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define2(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
      }, exports2.awrap = function(arg) {
        return {
          __await: arg
        };
      }, defineIteratorMethods(AsyncIterator.prototype), define2(AsyncIterator.prototype, asyncIteratorSymbol, function() {
        return this;
      }), exports2.AsyncIterator = AsyncIterator, exports2.async = function(innerFn, outerFn, self2, tryLocsList, PromiseImpl) {
        void 0 === PromiseImpl && (PromiseImpl = Promise);
        var iter = new AsyncIterator(wrap(innerFn, outerFn, self2, tryLocsList), PromiseImpl);
        return exports2.isGeneratorFunction(outerFn) ? iter : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
      }, defineIteratorMethods(Gp), define2(Gp, toStringTagSymbol, "Generator"), define2(Gp, iteratorSymbol, function() {
        return this;
      }), define2(Gp, "toString", function() {
        return "[object Generator]";
      }), exports2.keys = function(object) {
        var keys = [];
        for (var key in object) {
          keys.push(key);
        }
        return keys.reverse(), function next() {
          for (; keys.length; ) {
            var key2 = keys.pop();
            if (key2 in object)
              return next.value = key2, next.done = false, next;
          }
          return next.done = true, next;
        };
      }, exports2.values = values, Context.prototype = {
        constructor: Context,
        reset: function reset(skipTempReset) {
          if (this.prev = 0, this.next = 0, this.sent = this._sent = void 0, this.done = false, this.delegate = null, this.method = "next", this.arg = void 0, this.tryEntries.forEach(resetTryEntry), !skipTempReset)
            for (var name in this) {
              "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = void 0);
            }
        },
        stop: function stop() {
          this.done = true;
          var rootRecord = this.tryEntries[0].completion;
          if ("throw" === rootRecord.type)
            throw rootRecord.arg;
          return this.rval;
        },
        dispatchException: function dispatchException(exception) {
          if (this.done)
            throw exception;
          var context2 = this;
          function handle(loc, caught) {
            return record.type = "throw", record.arg = exception, context2.next = loc, caught && (context2.method = "next", context2.arg = void 0), !!caught;
          }
          for (var i2 = this.tryEntries.length - 1; i2 >= 0; --i2) {
            var entry = this.tryEntries[i2], record = entry.completion;
            if ("root" === entry.tryLoc)
              return handle("end");
            if (entry.tryLoc <= this.prev) {
              var hasCatch = hasOwn.call(entry, "catchLoc"), hasFinally = hasOwn.call(entry, "finallyLoc");
              if (hasCatch && hasFinally) {
                if (this.prev < entry.catchLoc)
                  return handle(entry.catchLoc, true);
                if (this.prev < entry.finallyLoc)
                  return handle(entry.finallyLoc);
              } else if (hasCatch) {
                if (this.prev < entry.catchLoc)
                  return handle(entry.catchLoc, true);
              } else {
                if (!hasFinally)
                  throw new Error("try statement without catch or finally");
                if (this.prev < entry.finallyLoc)
                  return handle(entry.finallyLoc);
              }
            }
          }
        },
        abrupt: function abrupt(type, arg) {
          for (var i2 = this.tryEntries.length - 1; i2 >= 0; --i2) {
            var entry = this.tryEntries[i2];
            if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
              var finallyEntry = entry;
              break;
            }
          }
          finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
          var record = finallyEntry ? finallyEntry.completion : {};
          return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
        },
        complete: function complete(record, afterLoc) {
          if ("throw" === record.type)
            throw record.arg;
          return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
        },
        finish: function finish(finallyLoc) {
          for (var i2 = this.tryEntries.length - 1; i2 >= 0; --i2) {
            var entry = this.tryEntries[i2];
            if (entry.finallyLoc === finallyLoc)
              return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
          }
        },
        "catch": function _catch(tryLoc) {
          for (var i2 = this.tryEntries.length - 1; i2 >= 0; --i2) {
            var entry = this.tryEntries[i2];
            if (entry.tryLoc === tryLoc) {
              var record = entry.completion;
              if ("throw" === record.type) {
                var thrown = record.arg;
                resetTryEntry(entry);
              }
              return thrown;
            }
          }
          throw new Error("illegal catch attempt");
        },
        delegateYield: function delegateYield(iterable, resultName, nextLoc) {
          return this.delegate = {
            iterator: values(iterable),
            resultName,
            nextLoc
          }, "next" === this.method && (this.arg = void 0), ContinueSentinel;
        }
      }, exports2;
    }
    module2.exports = _regeneratorRuntime2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/regenerator/index.js
var require_regenerator = __commonJS({
  "node_modules/@babel/runtime/regenerator/index.js"(exports, module2) {
    var runtime = require_regeneratorRuntime()();
    module2.exports = runtime;
    try {
      regeneratorRuntime = runtime;
    } catch (accidentalStrictMode) {
      if (typeof globalThis === "object") {
        globalThis.regeneratorRuntime = runtime;
      } else {
        Function("r", "regeneratorRuntime = r")(runtime);
      }
    }
  }
});

// node_modules/@babel/runtime/helpers/asyncToGenerator.js
var require_asyncToGenerator = __commonJS({
  "node_modules/@babel/runtime/helpers/asyncToGenerator.js"(exports, module2) {
    function asyncGeneratorStep2(gen, resolve, reject, _next, _throw, key, arg) {
      try {
        var info = gen[key](arg);
        var value = info.value;
      } catch (error) {
        reject(error);
        return;
      }
      if (info.done) {
        resolve(value);
      } else {
        Promise.resolve(value).then(_next, _throw);
      }
    }
    function _asyncToGenerator2(fn) {
      return function() {
        var self2 = this, args = arguments;
        return new Promise(function(resolve, reject) {
          var gen = fn.apply(self2, args);
          function _next(value) {
            asyncGeneratorStep2(gen, resolve, reject, _next, _throw, "next", value);
          }
          function _throw(err) {
            asyncGeneratorStep2(gen, resolve, reject, _next, _throw, "throw", err);
          }
          _next(void 0);
        });
      };
    }
    module2.exports = _asyncToGenerator2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/classCallCheck.js
var require_classCallCheck = __commonJS({
  "node_modules/@babel/runtime/helpers/classCallCheck.js"(exports, module2) {
    function _classCallCheck2(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    module2.exports = _classCallCheck2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/assertThisInitialized.js
var require_assertThisInitialized = __commonJS({
  "node_modules/@babel/runtime/helpers/assertThisInitialized.js"(exports, module2) {
    function _assertThisInitialized2(self2) {
      if (self2 === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }
      return self2;
    }
    module2.exports = _assertThisInitialized2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/possibleConstructorReturn.js
var require_possibleConstructorReturn = __commonJS({
  "node_modules/@babel/runtime/helpers/possibleConstructorReturn.js"(exports, module2) {
    var _typeof2 = require_typeof()["default"];
    var assertThisInitialized = require_assertThisInitialized();
    function _possibleConstructorReturn2(self2, call) {
      if (call && (_typeof2(call) === "object" || typeof call === "function")) {
        return call;
      } else if (call !== void 0) {
        throw new TypeError("Derived constructors may only return object or undefined");
      }
      return assertThisInitialized(self2);
    }
    module2.exports = _possibleConstructorReturn2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/getPrototypeOf.js
var require_getPrototypeOf = __commonJS({
  "node_modules/@babel/runtime/helpers/getPrototypeOf.js"(exports, module2) {
    function _getPrototypeOf2(o) {
      module2.exports = _getPrototypeOf2 = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf3(o2) {
        return o2.__proto__ || Object.getPrototypeOf(o2);
      }, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
      return _getPrototypeOf2(o);
    }
    module2.exports = _getPrototypeOf2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/setPrototypeOf.js
var require_setPrototypeOf = __commonJS({
  "node_modules/@babel/runtime/helpers/setPrototypeOf.js"(exports, module2) {
    function _setPrototypeOf2(o, p) {
      module2.exports = _setPrototypeOf2 = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf3(o2, p2) {
        o2.__proto__ = p2;
        return o2;
      }, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
      return _setPrototypeOf2(o, p);
    }
    module2.exports = _setPrototypeOf2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/inherits.js
var require_inherits = __commonJS({
  "node_modules/@babel/runtime/helpers/inherits.js"(exports, module2) {
    var setPrototypeOf = require_setPrototypeOf();
    function _inherits2(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }
      subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
          value: subClass,
          writable: true,
          configurable: true
        }
      });
      Object.defineProperty(subClass, "prototype", {
        writable: false
      });
      if (superClass)
        setPrototypeOf(subClass, superClass);
    }
    module2.exports = _inherits2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/isNativeFunction.js
var require_isNativeFunction = __commonJS({
  "node_modules/@babel/runtime/helpers/isNativeFunction.js"(exports, module2) {
    function _isNativeFunction2(fn) {
      return Function.toString.call(fn).indexOf("[native code]") !== -1;
    }
    module2.exports = _isNativeFunction2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/isNativeReflectConstruct.js
var require_isNativeReflectConstruct = __commonJS({
  "node_modules/@babel/runtime/helpers/isNativeReflectConstruct.js"(exports, module2) {
    function _isNativeReflectConstruct2() {
      if (typeof Reflect === "undefined" || !Reflect.construct)
        return false;
      if (Reflect.construct.sham)
        return false;
      if (typeof Proxy === "function")
        return true;
      try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
        }));
        return true;
      } catch (e2) {
        return false;
      }
    }
    module2.exports = _isNativeReflectConstruct2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/construct.js
var require_construct = __commonJS({
  "node_modules/@babel/runtime/helpers/construct.js"(exports, module2) {
    var setPrototypeOf = require_setPrototypeOf();
    var isNativeReflectConstruct = require_isNativeReflectConstruct();
    function _construct2(Parent, args, Class) {
      if (isNativeReflectConstruct()) {
        module2.exports = _construct2 = Reflect.construct.bind(), module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
      } else {
        module2.exports = _construct2 = function _construct3(Parent2, args2, Class2) {
          var a = [null];
          a.push.apply(a, args2);
          var Constructor = Function.bind.apply(Parent2, a);
          var instance = new Constructor();
          if (Class2)
            setPrototypeOf(instance, Class2.prototype);
          return instance;
        }, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
      }
      return _construct2.apply(null, arguments);
    }
    module2.exports = _construct2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/@babel/runtime/helpers/wrapNativeSuper.js
var require_wrapNativeSuper = __commonJS({
  "node_modules/@babel/runtime/helpers/wrapNativeSuper.js"(exports, module2) {
    var getPrototypeOf = require_getPrototypeOf();
    var setPrototypeOf = require_setPrototypeOf();
    var isNativeFunction = require_isNativeFunction();
    var construct = require_construct();
    function _wrapNativeSuper2(Class) {
      var _cache = typeof Map === "function" ? /* @__PURE__ */ new Map() : void 0;
      module2.exports = _wrapNativeSuper2 = function _wrapNativeSuper3(Class2) {
        if (Class2 === null || !isNativeFunction(Class2))
          return Class2;
        if (typeof Class2 !== "function") {
          throw new TypeError("Super expression must either be null or a function");
        }
        if (typeof _cache !== "undefined") {
          if (_cache.has(Class2))
            return _cache.get(Class2);
          _cache.set(Class2, Wrapper);
        }
        function Wrapper() {
          return construct(Class2, arguments, getPrototypeOf(this).constructor);
        }
        Wrapper.prototype = Object.create(Class2.prototype, {
          constructor: {
            value: Wrapper,
            enumerable: false,
            writable: true,
            configurable: true
          }
        });
        return setPrototypeOf(Wrapper, Class2);
      }, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
      return _wrapNativeSuper2(Class);
    }
    module2.exports = _wrapNativeSuper2, module2.exports.__esModule = true, module2.exports["default"] = module2.exports;
  }
});

// node_modules/universalify/index.js
var require_universalify2 = __commonJS({
  "node_modules/universalify/index.js"(exports) {
    "use strict";
    exports.fromCallback = function(fn) {
      return Object.defineProperty(function() {
        if (typeof arguments[arguments.length - 1] === "function")
          fn.apply(this, arguments);
        else {
          return new Promise((resolve, reject) => {
            arguments[arguments.length] = (err, res) => {
              if (err)
                return reject(err);
              resolve(res);
            };
            arguments.length++;
            fn.apply(this, arguments);
          });
        }
      }, "name", { value: fn.name });
    };
    exports.fromPromise = function(fn) {
      return Object.defineProperty(function() {
        const cb = arguments[arguments.length - 1];
        if (typeof cb !== "function")
          return fn.apply(this, arguments);
        else
          fn.apply(this, arguments).then((r2) => cb(null, r2), cb);
      }, "name", { value: fn.name });
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/fs/index.js
var require_fs2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/fs/index.js"(exports) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs();
    var api = [
      "access",
      "appendFile",
      "chmod",
      "chown",
      "close",
      "copyFile",
      "fchmod",
      "fchown",
      "fdatasync",
      "fstat",
      "fsync",
      "ftruncate",
      "futimes",
      "lchown",
      "lchmod",
      "link",
      "lstat",
      "mkdir",
      "mkdtemp",
      "open",
      "readFile",
      "readdir",
      "readlink",
      "realpath",
      "rename",
      "rmdir",
      "stat",
      "symlink",
      "truncate",
      "unlink",
      "utimes",
      "writeFile"
    ].filter((key) => {
      return typeof fs4[key] === "function";
    });
    Object.keys(fs4).forEach((key) => {
      if (key === "promises") {
        return;
      }
      exports[key] = fs4[key];
    });
    api.forEach((method) => {
      exports[method] = u(fs4[method]);
    });
    exports.exists = function(filename, callback) {
      if (typeof callback === "function") {
        return fs4.exists(filename, callback);
      }
      return new Promise((resolve) => {
        return fs4.exists(filename, resolve);
      });
    };
    exports.read = function(fd, buffer, offset, length, position, callback) {
      if (typeof callback === "function") {
        return fs4.read(fd, buffer, offset, length, position, callback);
      }
      return new Promise((resolve, reject) => {
        fs4.read(fd, buffer, offset, length, position, (err, bytesRead, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesRead, buffer: buffer2 });
        });
      });
    };
    exports.write = function(fd, buffer, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs4.write(fd, buffer, ...args);
      }
      return new Promise((resolve, reject) => {
        fs4.write(fd, buffer, ...args, (err, bytesWritten, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesWritten, buffer: buffer2 });
        });
      });
    };
    if (typeof fs4.realpath.native === "function") {
      exports.realpath.native = u(fs4.realpath.native);
    }
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/mkdirs/win32.js
var require_win32 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/mkdirs/win32.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    function getRootPath(p) {
      p = path4.normalize(path4.resolve(p)).split(path4.sep);
      if (p.length > 0)
        return p[0];
      return null;
    }
    var INVALID_PATH_CHARS = /[<>:"|?*]/;
    function invalidWin32Path(p) {
      const rp = getRootPath(p);
      p = p.replace(rp, "");
      return INVALID_PATH_CHARS.test(p);
    }
    module2.exports = {
      getRootPath,
      invalidWin32Path
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/mkdirs/mkdirs.js
var require_mkdirs2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/mkdirs/mkdirs.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var invalidWin32Path = require_win32().invalidWin32Path;
    var o777 = parseInt("0777", 8);
    function mkdirs(p, opts, callback, made) {
      if (typeof opts === "function") {
        callback = opts;
        opts = {};
      } else if (!opts || typeof opts !== "object") {
        opts = { mode: opts };
      }
      if (process.platform === "win32" && invalidWin32Path(p)) {
        const errInval = new Error(p + " contains invalid WIN32 path characters.");
        errInval.code = "EINVAL";
        return callback(errInval);
      }
      let mode = opts.mode;
      const xfs = opts.fs || fs4;
      if (mode === void 0) {
        mode = o777 & ~process.umask();
      }
      if (!made)
        made = null;
      callback = callback || function() {
      };
      p = path4.resolve(p);
      xfs.mkdir(p, mode, (er) => {
        if (!er) {
          made = made || p;
          return callback(null, made);
        }
        switch (er.code) {
          case "ENOENT":
            if (path4.dirname(p) === p)
              return callback(er);
            mkdirs(path4.dirname(p), opts, (er2, made2) => {
              if (er2)
                callback(er2, made2);
              else
                mkdirs(p, opts, callback, made2);
            });
            break;
          default:
            xfs.stat(p, (er2, stat3) => {
              if (er2 || !stat3.isDirectory())
                callback(er, made);
              else
                callback(null, made);
            });
            break;
        }
      });
    }
    module2.exports = mkdirs;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/mkdirs/mkdirs-sync.js
var require_mkdirs_sync = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/mkdirs/mkdirs-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var invalidWin32Path = require_win32().invalidWin32Path;
    var o777 = parseInt("0777", 8);
    function mkdirsSync(p, opts, made) {
      if (!opts || typeof opts !== "object") {
        opts = { mode: opts };
      }
      let mode = opts.mode;
      const xfs = opts.fs || fs4;
      if (process.platform === "win32" && invalidWin32Path(p)) {
        const errInval = new Error(p + " contains invalid WIN32 path characters.");
        errInval.code = "EINVAL";
        throw errInval;
      }
      if (mode === void 0) {
        mode = o777 & ~process.umask();
      }
      if (!made)
        made = null;
      p = path4.resolve(p);
      try {
        xfs.mkdirSync(p, mode);
        made = made || p;
      } catch (err0) {
        if (err0.code === "ENOENT") {
          if (path4.dirname(p) === p)
            throw err0;
          made = mkdirsSync(path4.dirname(p), opts, made);
          mkdirsSync(p, opts, made);
        } else {
          let stat3;
          try {
            stat3 = xfs.statSync(p);
          } catch (err1) {
            throw err0;
          }
          if (!stat3.isDirectory())
            throw err0;
        }
      }
      return made;
    }
    module2.exports = mkdirsSync;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/mkdirs/index.js
var require_mkdirs3 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/mkdirs/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var mkdirs = u(require_mkdirs2());
    var mkdirsSync = require_mkdirs_sync();
    module2.exports = {
      mkdirs,
      mkdirsSync,
      mkdirp: mkdirs,
      mkdirpSync: mkdirsSync,
      ensureDir: mkdirs,
      ensureDirSync: mkdirsSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/util/utimes.js
var require_utimes2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/util/utimes.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var os = require("os");
    var path4 = require("path");
    function hasMillisResSync() {
      let tmpfile = path4.join("millis-test-sync" + Date.now().toString() + Math.random().toString().slice(2));
      tmpfile = path4.join(os.tmpdir(), tmpfile);
      const d = new Date(1435410243862);
      fs4.writeFileSync(tmpfile, "https://github.com/jprichardson/node-fs-extra/pull/141");
      const fd = fs4.openSync(tmpfile, "r+");
      fs4.futimesSync(fd, d, d);
      fs4.closeSync(fd);
      return fs4.statSync(tmpfile).mtime > 1435410243e3;
    }
    function hasMillisRes(callback) {
      let tmpfile = path4.join("millis-test" + Date.now().toString() + Math.random().toString().slice(2));
      tmpfile = path4.join(os.tmpdir(), tmpfile);
      const d = new Date(1435410243862);
      fs4.writeFile(tmpfile, "https://github.com/jprichardson/node-fs-extra/pull/141", (err) => {
        if (err)
          return callback(err);
        fs4.open(tmpfile, "r+", (err2, fd) => {
          if (err2)
            return callback(err2);
          fs4.futimes(fd, d, d, (err3) => {
            if (err3)
              return callback(err3);
            fs4.close(fd, (err4) => {
              if (err4)
                return callback(err4);
              fs4.stat(tmpfile, (err5, stats) => {
                if (err5)
                  return callback(err5);
                callback(null, stats.mtime > 1435410243e3);
              });
            });
          });
        });
      });
    }
    function timeRemoveMillis(timestamp) {
      if (typeof timestamp === "number") {
        return Math.floor(timestamp / 1e3) * 1e3;
      } else if (timestamp instanceof Date) {
        return new Date(Math.floor(timestamp.getTime() / 1e3) * 1e3);
      } else {
        throw new Error("fs-extra: timeRemoveMillis() unknown parameter type");
      }
    }
    function utimesMillis(path5, atime, mtime, callback) {
      fs4.open(path5, "r+", (err, fd) => {
        if (err)
          return callback(err);
        fs4.futimes(fd, atime, mtime, (futimesErr) => {
          fs4.close(fd, (closeErr) => {
            if (callback)
              callback(futimesErr || closeErr);
          });
        });
      });
    }
    function utimesMillisSync(path5, atime, mtime) {
      const fd = fs4.openSync(path5, "r+");
      fs4.futimesSync(fd, atime, mtime);
      return fs4.closeSync(fd);
    }
    module2.exports = {
      hasMillisRes,
      hasMillisResSync,
      timeRemoveMillis,
      utimesMillis,
      utimesMillisSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/util/stat.js
var require_stat2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/util/stat.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var NODE_VERSION_MAJOR_WITH_BIGINT = 10;
    var NODE_VERSION_MINOR_WITH_BIGINT = 5;
    var NODE_VERSION_PATCH_WITH_BIGINT = 0;
    var nodeVersion = process.versions.node.split(".");
    var nodeVersionMajor = Number.parseInt(nodeVersion[0], 10);
    var nodeVersionMinor = Number.parseInt(nodeVersion[1], 10);
    var nodeVersionPatch = Number.parseInt(nodeVersion[2], 10);
    function nodeSupportsBigInt() {
      if (nodeVersionMajor > NODE_VERSION_MAJOR_WITH_BIGINT) {
        return true;
      } else if (nodeVersionMajor === NODE_VERSION_MAJOR_WITH_BIGINT) {
        if (nodeVersionMinor > NODE_VERSION_MINOR_WITH_BIGINT) {
          return true;
        } else if (nodeVersionMinor === NODE_VERSION_MINOR_WITH_BIGINT) {
          if (nodeVersionPatch >= NODE_VERSION_PATCH_WITH_BIGINT) {
            return true;
          }
        }
      }
      return false;
    }
    function getStats(src, dest, cb) {
      if (nodeSupportsBigInt()) {
        fs4.stat(src, { bigint: true }, (err, srcStat) => {
          if (err)
            return cb(err);
          fs4.stat(dest, { bigint: true }, (err2, destStat) => {
            if (err2) {
              if (err2.code === "ENOENT")
                return cb(null, { srcStat, destStat: null });
              return cb(err2);
            }
            return cb(null, { srcStat, destStat });
          });
        });
      } else {
        fs4.stat(src, (err, srcStat) => {
          if (err)
            return cb(err);
          fs4.stat(dest, (err2, destStat) => {
            if (err2) {
              if (err2.code === "ENOENT")
                return cb(null, { srcStat, destStat: null });
              return cb(err2);
            }
            return cb(null, { srcStat, destStat });
          });
        });
      }
    }
    function getStatsSync(src, dest) {
      let srcStat, destStat;
      if (nodeSupportsBigInt()) {
        srcStat = fs4.statSync(src, { bigint: true });
      } else {
        srcStat = fs4.statSync(src);
      }
      try {
        if (nodeSupportsBigInt()) {
          destStat = fs4.statSync(dest, { bigint: true });
        } else {
          destStat = fs4.statSync(dest);
        }
      } catch (err) {
        if (err.code === "ENOENT")
          return { srcStat, destStat: null };
        throw err;
      }
      return { srcStat, destStat };
    }
    function checkPaths(src, dest, funcName, cb) {
      getStats(src, dest, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        if (destStat && destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
          return cb(new Error("Source and destination must not be the same."));
        }
        if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return cb(null, { srcStat, destStat });
      });
    }
    function checkPathsSync(src, dest, funcName) {
      const { srcStat, destStat } = getStatsSync(src, dest);
      if (destStat && destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
        throw new Error("Source and destination must not be the same.");
      }
      if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return { srcStat, destStat };
    }
    function checkParentPaths(src, srcStat, dest, funcName, cb) {
      const srcParent = path4.resolve(path4.dirname(src));
      const destParent = path4.resolve(path4.dirname(dest));
      if (destParent === srcParent || destParent === path4.parse(destParent).root)
        return cb();
      if (nodeSupportsBigInt()) {
        fs4.stat(destParent, { bigint: true }, (err, destStat) => {
          if (err) {
            if (err.code === "ENOENT")
              return cb();
            return cb(err);
          }
          if (destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
            return cb(new Error(errMsg(src, dest, funcName)));
          }
          return checkParentPaths(src, srcStat, destParent, funcName, cb);
        });
      } else {
        fs4.stat(destParent, (err, destStat) => {
          if (err) {
            if (err.code === "ENOENT")
              return cb();
            return cb(err);
          }
          if (destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
            return cb(new Error(errMsg(src, dest, funcName)));
          }
          return checkParentPaths(src, srcStat, destParent, funcName, cb);
        });
      }
    }
    function checkParentPathsSync(src, srcStat, dest, funcName) {
      const srcParent = path4.resolve(path4.dirname(src));
      const destParent = path4.resolve(path4.dirname(dest));
      if (destParent === srcParent || destParent === path4.parse(destParent).root)
        return;
      let destStat;
      try {
        if (nodeSupportsBigInt()) {
          destStat = fs4.statSync(destParent, { bigint: true });
        } else {
          destStat = fs4.statSync(destParent);
        }
      } catch (err) {
        if (err.code === "ENOENT")
          return;
        throw err;
      }
      if (destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return checkParentPathsSync(src, srcStat, destParent, funcName);
    }
    function isSrcSubdir(src, dest) {
      const srcArr = path4.resolve(src).split(path4.sep).filter((i2) => i2);
      const destArr = path4.resolve(dest).split(path4.sep).filter((i2) => i2);
      return srcArr.reduce((acc, cur, i2) => acc && destArr[i2] === cur, true);
    }
    function errMsg(src, dest, funcName) {
      return `Cannot ${funcName} '${src}' to a subdirectory of itself, '${dest}'.`;
    }
    module2.exports = {
      checkPaths,
      checkPathsSync,
      checkParentPaths,
      checkParentPathsSync,
      isSrcSubdir
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/util/buffer.js
var require_buffer = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/util/buffer.js"(exports, module2) {
    "use strict";
    module2.exports = function(size) {
      if (typeof Buffer.allocUnsafe === "function") {
        try {
          return Buffer.allocUnsafe(size);
        } catch (e2) {
          return new Buffer(size);
        }
      }
      return new Buffer(size);
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/copy-sync/copy-sync.js
var require_copy_sync2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/copy-sync/copy-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdirpSync = require_mkdirs3().mkdirsSync;
    var utimesSync = require_utimes2().utimesMillisSync;
    var stat3 = require_stat2();
    function copySync(src, dest, opts) {
      if (typeof opts === "function") {
        opts = { filter: opts };
      }
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      const { srcStat, destStat } = stat3.checkPathsSync(src, dest, "copy");
      stat3.checkParentPathsSync(src, srcStat, dest, "copy");
      return handleFilterAndCopy(destStat, src, dest, opts);
    }
    function handleFilterAndCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      const destParent = path4.dirname(dest);
      if (!fs4.existsSync(destParent))
        mkdirpSync(destParent);
      return startCopy(destStat, src, dest, opts);
    }
    function startCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      return getStats(destStat, src, dest, opts);
    }
    function getStats(destStat, src, dest, opts) {
      const statSync2 = opts.dereference ? fs4.statSync : fs4.lstatSync;
      const srcStat = statSync2(src);
      if (srcStat.isDirectory())
        return onDir(srcStat, destStat, src, dest, opts);
      else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
        return onFile(srcStat, destStat, src, dest, opts);
      else if (srcStat.isSymbolicLink())
        return onLink(destStat, src, dest, opts);
    }
    function onFile(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts);
      return mayCopyFile(srcStat, src, dest, opts);
    }
    function mayCopyFile(srcStat, src, dest, opts) {
      if (opts.overwrite) {
        fs4.unlinkSync(dest);
        return copyFile(srcStat, src, dest, opts);
      } else if (opts.errorOnExist) {
        throw new Error(`'${dest}' already exists`);
      }
    }
    function copyFile(srcStat, src, dest, opts) {
      if (typeof fs4.copyFileSync === "function") {
        fs4.copyFileSync(src, dest);
        fs4.chmodSync(dest, srcStat.mode);
        if (opts.preserveTimestamps) {
          return utimesSync(dest, srcStat.atime, srcStat.mtime);
        }
        return;
      }
      return copyFileFallback(srcStat, src, dest, opts);
    }
    function copyFileFallback(srcStat, src, dest, opts) {
      const BUF_LENGTH = 64 * 1024;
      const _buff = require_buffer()(BUF_LENGTH);
      const fdr = fs4.openSync(src, "r");
      const fdw = fs4.openSync(dest, "w", srcStat.mode);
      let pos = 0;
      while (pos < srcStat.size) {
        const bytesRead = fs4.readSync(fdr, _buff, 0, BUF_LENGTH, pos);
        fs4.writeSync(fdw, _buff, 0, bytesRead);
        pos += bytesRead;
      }
      if (opts.preserveTimestamps)
        fs4.futimesSync(fdw, srcStat.atime, srcStat.mtime);
      fs4.closeSync(fdr);
      fs4.closeSync(fdw);
    }
    function onDir(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return mkDirAndCopy(srcStat, src, dest, opts);
      if (destStat && !destStat.isDirectory()) {
        throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`);
      }
      return copyDir(src, dest, opts);
    }
    function mkDirAndCopy(srcStat, src, dest, opts) {
      fs4.mkdirSync(dest);
      copyDir(src, dest, opts);
      return fs4.chmodSync(dest, srcStat.mode);
    }
    function copyDir(src, dest, opts) {
      fs4.readdirSync(src).forEach((item) => copyDirItem(item, src, dest, opts));
    }
    function copyDirItem(item, src, dest, opts) {
      const srcItem = path4.join(src, item);
      const destItem = path4.join(dest, item);
      const { destStat } = stat3.checkPathsSync(srcItem, destItem, "copy");
      return startCopy(destStat, srcItem, destItem, opts);
    }
    function onLink(destStat, src, dest, opts) {
      let resolvedSrc = fs4.readlinkSync(src);
      if (opts.dereference) {
        resolvedSrc = path4.resolve(process.cwd(), resolvedSrc);
      }
      if (!destStat) {
        return fs4.symlinkSync(resolvedSrc, dest);
      } else {
        let resolvedDest;
        try {
          resolvedDest = fs4.readlinkSync(dest);
        } catch (err) {
          if (err.code === "EINVAL" || err.code === "UNKNOWN")
            return fs4.symlinkSync(resolvedSrc, dest);
          throw err;
        }
        if (opts.dereference) {
          resolvedDest = path4.resolve(process.cwd(), resolvedDest);
        }
        if (stat3.isSrcSubdir(resolvedSrc, resolvedDest)) {
          throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
        }
        if (fs4.statSync(dest).isDirectory() && stat3.isSrcSubdir(resolvedDest, resolvedSrc)) {
          throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
        }
        return copyLink(resolvedSrc, dest);
      }
    }
    function copyLink(resolvedSrc, dest) {
      fs4.unlinkSync(dest);
      return fs4.symlinkSync(resolvedSrc, dest);
    }
    module2.exports = copySync;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/copy-sync/index.js
var require_copy_sync3 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/copy-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      copySync: require_copy_sync2()
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/path-exists/index.js
var require_path_exists2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/path-exists/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromPromise;
    var fs4 = require_fs2();
    function pathExists(path4) {
      return fs4.access(path4).then(() => true).catch(() => false);
    }
    module2.exports = {
      pathExists: u(pathExists),
      pathExistsSync: fs4.existsSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/copy/copy.js
var require_copy3 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/copy/copy.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdirp2 = require_mkdirs3().mkdirs;
    var pathExists = require_path_exists2().pathExists;
    var utimes = require_utimes2().utimesMillis;
    var stat3 = require_stat2();
    function copy(src, dest, opts, cb) {
      if (typeof opts === "function" && !cb) {
        cb = opts;
        opts = {};
      } else if (typeof opts === "function") {
        opts = { filter: opts };
      }
      cb = cb || function() {
      };
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      stat3.checkPaths(src, dest, "copy", (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        stat3.checkParentPaths(src, srcStat, dest, "copy", (err2) => {
          if (err2)
            return cb(err2);
          if (opts.filter)
            return handleFilter(checkParentDir, destStat, src, dest, opts, cb);
          return checkParentDir(destStat, src, dest, opts, cb);
        });
      });
    }
    function checkParentDir(destStat, src, dest, opts, cb) {
      const destParent = path4.dirname(dest);
      pathExists(destParent, (err, dirExists) => {
        if (err)
          return cb(err);
        if (dirExists)
          return startCopy(destStat, src, dest, opts, cb);
        mkdirp2(destParent, (err2) => {
          if (err2)
            return cb(err2);
          return startCopy(destStat, src, dest, opts, cb);
        });
      });
    }
    function handleFilter(onInclude, destStat, src, dest, opts, cb) {
      Promise.resolve(opts.filter(src, dest)).then((include) => {
        if (include)
          return onInclude(destStat, src, dest, opts, cb);
        return cb();
      }, (error) => cb(error));
    }
    function startCopy(destStat, src, dest, opts, cb) {
      if (opts.filter)
        return handleFilter(getStats, destStat, src, dest, opts, cb);
      return getStats(destStat, src, dest, opts, cb);
    }
    function getStats(destStat, src, dest, opts, cb) {
      const stat4 = opts.dereference ? fs4.stat : fs4.lstat;
      stat4(src, (err, srcStat) => {
        if (err)
          return cb(err);
        if (srcStat.isDirectory())
          return onDir(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
          return onFile(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isSymbolicLink())
          return onLink(destStat, src, dest, opts, cb);
      });
    }
    function onFile(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts, cb);
      return mayCopyFile(srcStat, src, dest, opts, cb);
    }
    function mayCopyFile(srcStat, src, dest, opts, cb) {
      if (opts.overwrite) {
        fs4.unlink(dest, (err) => {
          if (err)
            return cb(err);
          return copyFile(srcStat, src, dest, opts, cb);
        });
      } else if (opts.errorOnExist) {
        return cb(new Error(`'${dest}' already exists`));
      } else
        return cb();
    }
    function copyFile(srcStat, src, dest, opts, cb) {
      if (typeof fs4.copyFile === "function") {
        return fs4.copyFile(src, dest, (err) => {
          if (err)
            return cb(err);
          return setDestModeAndTimestamps(srcStat, dest, opts, cb);
        });
      }
      return copyFileFallback(srcStat, src, dest, opts, cb);
    }
    function copyFileFallback(srcStat, src, dest, opts, cb) {
      const rs = fs4.createReadStream(src);
      rs.on("error", (err) => cb(err)).once("open", () => {
        const ws = fs4.createWriteStream(dest, { mode: srcStat.mode });
        ws.on("error", (err) => cb(err)).on("open", () => rs.pipe(ws)).once("close", () => setDestModeAndTimestamps(srcStat, dest, opts, cb));
      });
    }
    function setDestModeAndTimestamps(srcStat, dest, opts, cb) {
      fs4.chmod(dest, srcStat.mode, (err) => {
        if (err)
          return cb(err);
        if (opts.preserveTimestamps) {
          return utimes(dest, srcStat.atime, srcStat.mtime, cb);
        }
        return cb();
      });
    }
    function onDir(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return mkDirAndCopy(srcStat, src, dest, opts, cb);
      if (destStat && !destStat.isDirectory()) {
        return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`));
      }
      return copyDir(src, dest, opts, cb);
    }
    function mkDirAndCopy(srcStat, src, dest, opts, cb) {
      fs4.mkdir(dest, (err) => {
        if (err)
          return cb(err);
        copyDir(src, dest, opts, (err2) => {
          if (err2)
            return cb(err2);
          return fs4.chmod(dest, srcStat.mode, cb);
        });
      });
    }
    function copyDir(src, dest, opts, cb) {
      fs4.readdir(src, (err, items) => {
        if (err)
          return cb(err);
        return copyDirItems(items, src, dest, opts, cb);
      });
    }
    function copyDirItems(items, src, dest, opts, cb) {
      const item = items.pop();
      if (!item)
        return cb();
      return copyDirItem(items, item, src, dest, opts, cb);
    }
    function copyDirItem(items, item, src, dest, opts, cb) {
      const srcItem = path4.join(src, item);
      const destItem = path4.join(dest, item);
      stat3.checkPaths(srcItem, destItem, "copy", (err, stats) => {
        if (err)
          return cb(err);
        const { destStat } = stats;
        startCopy(destStat, srcItem, destItem, opts, (err2) => {
          if (err2)
            return cb(err2);
          return copyDirItems(items, src, dest, opts, cb);
        });
      });
    }
    function onLink(destStat, src, dest, opts, cb) {
      fs4.readlink(src, (err, resolvedSrc) => {
        if (err)
          return cb(err);
        if (opts.dereference) {
          resolvedSrc = path4.resolve(process.cwd(), resolvedSrc);
        }
        if (!destStat) {
          return fs4.symlink(resolvedSrc, dest, cb);
        } else {
          fs4.readlink(dest, (err2, resolvedDest) => {
            if (err2) {
              if (err2.code === "EINVAL" || err2.code === "UNKNOWN")
                return fs4.symlink(resolvedSrc, dest, cb);
              return cb(err2);
            }
            if (opts.dereference) {
              resolvedDest = path4.resolve(process.cwd(), resolvedDest);
            }
            if (stat3.isSrcSubdir(resolvedSrc, resolvedDest)) {
              return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`));
            }
            if (destStat.isDirectory() && stat3.isSrcSubdir(resolvedDest, resolvedSrc)) {
              return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`));
            }
            return copyLink(resolvedSrc, dest, cb);
          });
        }
      });
    }
    function copyLink(resolvedSrc, dest, cb) {
      fs4.unlink(dest, (err) => {
        if (err)
          return cb(err);
        return fs4.symlink(resolvedSrc, dest, cb);
      });
    }
    module2.exports = copy;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/copy/index.js
var require_copy4 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/copy/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    module2.exports = {
      copy: u(require_copy3())
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/remove/rimraf.js
var require_rimraf2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/remove/rimraf.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var assert = require("assert");
    var isWindows = process.platform === "win32";
    function defaults(options) {
      const methods = [
        "unlink",
        "chmod",
        "stat",
        "lstat",
        "rmdir",
        "readdir"
      ];
      methods.forEach((m2) => {
        options[m2] = options[m2] || fs4[m2];
        m2 = m2 + "Sync";
        options[m2] = options[m2] || fs4[m2];
      });
      options.maxBusyTries = options.maxBusyTries || 3;
    }
    function rimraf(p, options, cb) {
      let busyTries = 0;
      if (typeof options === "function") {
        cb = options;
        options = {};
      }
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert.strictEqual(typeof cb, "function", "rimraf: callback function required");
      assert(options, "rimraf: invalid options argument provided");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      defaults(options);
      rimraf_(p, options, function CB(er) {
        if (er) {
          if ((er.code === "EBUSY" || er.code === "ENOTEMPTY" || er.code === "EPERM") && busyTries < options.maxBusyTries) {
            busyTries++;
            const time = busyTries * 100;
            return setTimeout(() => rimraf_(p, options, CB), time);
          }
          if (er.code === "ENOENT")
            er = null;
        }
        cb(er);
      });
    }
    function rimraf_(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.lstat(p, (er, st) => {
        if (er && er.code === "ENOENT") {
          return cb(null);
        }
        if (er && er.code === "EPERM" && isWindows) {
          return fixWinEPERM(p, options, er, cb);
        }
        if (st && st.isDirectory()) {
          return rmdir(p, options, er, cb);
        }
        options.unlink(p, (er2) => {
          if (er2) {
            if (er2.code === "ENOENT") {
              return cb(null);
            }
            if (er2.code === "EPERM") {
              return isWindows ? fixWinEPERM(p, options, er2, cb) : rmdir(p, options, er2, cb);
            }
            if (er2.code === "EISDIR") {
              return rmdir(p, options, er2, cb);
            }
          }
          return cb(er2);
        });
      });
    }
    function fixWinEPERM(p, options, er, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      if (er) {
        assert(er instanceof Error);
      }
      options.chmod(p, 438, (er2) => {
        if (er2) {
          cb(er2.code === "ENOENT" ? null : er);
        } else {
          options.stat(p, (er3, stats) => {
            if (er3) {
              cb(er3.code === "ENOENT" ? null : er);
            } else if (stats.isDirectory()) {
              rmdir(p, options, er, cb);
            } else {
              options.unlink(p, cb);
            }
          });
        }
      });
    }
    function fixWinEPERMSync(p, options, er) {
      let stats;
      assert(p);
      assert(options);
      if (er) {
        assert(er instanceof Error);
      }
      try {
        options.chmodSync(p, 438);
      } catch (er2) {
        if (er2.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      try {
        stats = options.statSync(p);
      } catch (er3) {
        if (er3.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      if (stats.isDirectory()) {
        rmdirSync(p, options, er);
      } else {
        options.unlinkSync(p);
      }
    }
    function rmdir(p, options, originalEr, cb) {
      assert(p);
      assert(options);
      if (originalEr) {
        assert(originalEr instanceof Error);
      }
      assert(typeof cb === "function");
      options.rmdir(p, (er) => {
        if (er && (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM")) {
          rmkids(p, options, cb);
        } else if (er && er.code === "ENOTDIR") {
          cb(originalEr);
        } else {
          cb(er);
        }
      });
    }
    function rmkids(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.readdir(p, (er, files) => {
        if (er)
          return cb(er);
        let n = files.length;
        let errState;
        if (n === 0)
          return options.rmdir(p, cb);
        files.forEach((f3) => {
          rimraf(path4.join(p, f3), options, (er2) => {
            if (errState) {
              return;
            }
            if (er2)
              return cb(errState = er2);
            if (--n === 0) {
              options.rmdir(p, cb);
            }
          });
        });
      });
    }
    function rimrafSync(p, options) {
      let st;
      options = options || {};
      defaults(options);
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert(options, "rimraf: missing options");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      try {
        st = options.lstatSync(p);
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        }
        if (er.code === "EPERM" && isWindows) {
          fixWinEPERMSync(p, options, er);
        }
      }
      try {
        if (st && st.isDirectory()) {
          rmdirSync(p, options, null);
        } else {
          options.unlinkSync(p);
        }
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        } else if (er.code === "EPERM") {
          return isWindows ? fixWinEPERMSync(p, options, er) : rmdirSync(p, options, er);
        } else if (er.code !== "EISDIR") {
          throw er;
        }
        rmdirSync(p, options, er);
      }
    }
    function rmdirSync(p, options, originalEr) {
      assert(p);
      assert(options);
      if (originalEr) {
        assert(originalEr instanceof Error);
      }
      try {
        options.rmdirSync(p);
      } catch (er) {
        if (er.code === "ENOTDIR") {
          throw originalEr;
        } else if (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM") {
          rmkidsSync(p, options);
        } else if (er.code !== "ENOENT") {
          throw er;
        }
      }
    }
    function rmkidsSync(p, options) {
      assert(p);
      assert(options);
      options.readdirSync(p).forEach((f3) => rimrafSync(path4.join(p, f3), options));
      if (isWindows) {
        const startTime = Date.now();
        do {
          try {
            const ret = options.rmdirSync(p, options);
            return ret;
          } catch (er) {
          }
        } while (Date.now() - startTime < 500);
      } else {
        const ret = options.rmdirSync(p, options);
        return ret;
      }
    }
    module2.exports = rimraf;
    rimraf.sync = rimrafSync;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/remove/index.js
var require_remove3 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/remove/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var rimraf = require_rimraf2();
    module2.exports = {
      remove: u(rimraf),
      removeSync: rimraf.sync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/empty/index.js
var require_empty2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/empty/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdir = require_mkdirs3();
    var remove = require_remove3();
    var emptyDir = u(function emptyDir2(dir, callback) {
      callback = callback || function() {
      };
      fs4.readdir(dir, (err, items) => {
        if (err)
          return mkdir.mkdirs(dir, callback);
        items = items.map((item) => path4.join(dir, item));
        deleteItem();
        function deleteItem() {
          const item = items.pop();
          if (!item)
            return callback();
          remove.remove(item, (err2) => {
            if (err2)
              return callback(err2);
            deleteItem();
          });
        }
      });
    });
    function emptyDirSync(dir) {
      let items;
      try {
        items = fs4.readdirSync(dir);
      } catch (err) {
        return mkdir.mkdirsSync(dir);
      }
      items.forEach((item) => {
        item = path4.join(dir, item);
        remove.removeSync(item);
      });
    }
    module2.exports = {
      emptyDirSync,
      emptydirSync: emptyDirSync,
      emptyDir,
      emptydir: emptyDir
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/file.js
var require_file2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/file.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var mkdir = require_mkdirs3();
    var pathExists = require_path_exists2().pathExists;
    function createFile(file, callback) {
      function makeFile() {
        fs4.writeFile(file, "", (err) => {
          if (err)
            return callback(err);
          callback();
        });
      }
      fs4.stat(file, (err, stats) => {
        if (!err && stats.isFile())
          return callback();
        const dir = path4.dirname(file);
        pathExists(dir, (err2, dirExists) => {
          if (err2)
            return callback(err2);
          if (dirExists)
            return makeFile();
          mkdir.mkdirs(dir, (err3) => {
            if (err3)
              return callback(err3);
            makeFile();
          });
        });
      });
    }
    function createFileSync(file) {
      let stats;
      try {
        stats = fs4.statSync(file);
      } catch (e2) {
      }
      if (stats && stats.isFile())
        return;
      const dir = path4.dirname(file);
      if (!fs4.existsSync(dir)) {
        mkdir.mkdirsSync(dir);
      }
      fs4.writeFileSync(file, "");
    }
    module2.exports = {
      createFile: u(createFile),
      createFileSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/link.js
var require_link2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/link.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var mkdir = require_mkdirs3();
    var pathExists = require_path_exists2().pathExists;
    function createLink(srcpath, dstpath, callback) {
      function makeLink(srcpath2, dstpath2) {
        fs4.link(srcpath2, dstpath2, (err) => {
          if (err)
            return callback(err);
          callback(null);
        });
      }
      pathExists(dstpath, (err, destinationExists) => {
        if (err)
          return callback(err);
        if (destinationExists)
          return callback(null);
        fs4.lstat(srcpath, (err2) => {
          if (err2) {
            err2.message = err2.message.replace("lstat", "ensureLink");
            return callback(err2);
          }
          const dir = path4.dirname(dstpath);
          pathExists(dir, (err3, dirExists) => {
            if (err3)
              return callback(err3);
            if (dirExists)
              return makeLink(srcpath, dstpath);
            mkdir.mkdirs(dir, (err4) => {
              if (err4)
                return callback(err4);
              makeLink(srcpath, dstpath);
            });
          });
        });
      });
    }
    function createLinkSync(srcpath, dstpath) {
      const destinationExists = fs4.existsSync(dstpath);
      if (destinationExists)
        return void 0;
      try {
        fs4.lstatSync(srcpath);
      } catch (err) {
        err.message = err.message.replace("lstat", "ensureLink");
        throw err;
      }
      const dir = path4.dirname(dstpath);
      const dirExists = fs4.existsSync(dir);
      if (dirExists)
        return fs4.linkSync(srcpath, dstpath);
      mkdir.mkdirsSync(dir);
      return fs4.linkSync(srcpath, dstpath);
    }
    module2.exports = {
      createLink: u(createLink),
      createLinkSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/symlink-paths.js
var require_symlink_paths2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/symlink-paths.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var pathExists = require_path_exists2().pathExists;
    function symlinkPaths(srcpath, dstpath, callback) {
      if (path4.isAbsolute(srcpath)) {
        return fs4.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureSymlink");
            return callback(err);
          }
          return callback(null, {
            "toCwd": srcpath,
            "toDst": srcpath
          });
        });
      } else {
        const dstdir = path4.dirname(dstpath);
        const relativeToDst = path4.join(dstdir, srcpath);
        return pathExists(relativeToDst, (err, exists) => {
          if (err)
            return callback(err);
          if (exists) {
            return callback(null, {
              "toCwd": relativeToDst,
              "toDst": srcpath
            });
          } else {
            return fs4.lstat(srcpath, (err2) => {
              if (err2) {
                err2.message = err2.message.replace("lstat", "ensureSymlink");
                return callback(err2);
              }
              return callback(null, {
                "toCwd": srcpath,
                "toDst": path4.relative(dstdir, srcpath)
              });
            });
          }
        });
      }
    }
    function symlinkPathsSync(srcpath, dstpath) {
      let exists;
      if (path4.isAbsolute(srcpath)) {
        exists = fs4.existsSync(srcpath);
        if (!exists)
          throw new Error("absolute srcpath does not exist");
        return {
          "toCwd": srcpath,
          "toDst": srcpath
        };
      } else {
        const dstdir = path4.dirname(dstpath);
        const relativeToDst = path4.join(dstdir, srcpath);
        exists = fs4.existsSync(relativeToDst);
        if (exists) {
          return {
            "toCwd": relativeToDst,
            "toDst": srcpath
          };
        } else {
          exists = fs4.existsSync(srcpath);
          if (!exists)
            throw new Error("relative srcpath does not exist");
          return {
            "toCwd": srcpath,
            "toDst": path4.relative(dstdir, srcpath)
          };
        }
      }
    }
    module2.exports = {
      symlinkPaths,
      symlinkPathsSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/symlink-type.js
var require_symlink_type2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/symlink-type.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    function symlinkType(srcpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      if (type)
        return callback(null, type);
      fs4.lstat(srcpath, (err, stats) => {
        if (err)
          return callback(null, "file");
        type = stats && stats.isDirectory() ? "dir" : "file";
        callback(null, type);
      });
    }
    function symlinkTypeSync(srcpath, type) {
      let stats;
      if (type)
        return type;
      try {
        stats = fs4.lstatSync(srcpath);
      } catch (e2) {
        return "file";
      }
      return stats && stats.isDirectory() ? "dir" : "file";
    }
    module2.exports = {
      symlinkType,
      symlinkTypeSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/symlink.js
var require_symlink2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/symlink.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var _mkdirs = require_mkdirs3();
    var mkdirs = _mkdirs.mkdirs;
    var mkdirsSync = _mkdirs.mkdirsSync;
    var _symlinkPaths = require_symlink_paths2();
    var symlinkPaths = _symlinkPaths.symlinkPaths;
    var symlinkPathsSync = _symlinkPaths.symlinkPathsSync;
    var _symlinkType = require_symlink_type2();
    var symlinkType = _symlinkType.symlinkType;
    var symlinkTypeSync = _symlinkType.symlinkTypeSync;
    var pathExists = require_path_exists2().pathExists;
    function createSymlink(srcpath, dstpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      pathExists(dstpath, (err, destinationExists) => {
        if (err)
          return callback(err);
        if (destinationExists)
          return callback(null);
        symlinkPaths(srcpath, dstpath, (err2, relative) => {
          if (err2)
            return callback(err2);
          srcpath = relative.toDst;
          symlinkType(relative.toCwd, type, (err3, type2) => {
            if (err3)
              return callback(err3);
            const dir = path4.dirname(dstpath);
            pathExists(dir, (err4, dirExists) => {
              if (err4)
                return callback(err4);
              if (dirExists)
                return fs4.symlink(srcpath, dstpath, type2, callback);
              mkdirs(dir, (err5) => {
                if (err5)
                  return callback(err5);
                fs4.symlink(srcpath, dstpath, type2, callback);
              });
            });
          });
        });
      });
    }
    function createSymlinkSync(srcpath, dstpath, type) {
      const destinationExists = fs4.existsSync(dstpath);
      if (destinationExists)
        return void 0;
      const relative = symlinkPathsSync(srcpath, dstpath);
      srcpath = relative.toDst;
      type = symlinkTypeSync(relative.toCwd, type);
      const dir = path4.dirname(dstpath);
      const exists = fs4.existsSync(dir);
      if (exists)
        return fs4.symlinkSync(srcpath, dstpath, type);
      mkdirsSync(dir);
      return fs4.symlinkSync(srcpath, dstpath, type);
    }
    module2.exports = {
      createSymlink: u(createSymlink),
      createSymlinkSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/index.js
var require_ensure2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/ensure/index.js"(exports, module2) {
    "use strict";
    var file = require_file2();
    var link = require_link2();
    var symlink = require_symlink2();
    module2.exports = {
      createFile: file.createFile,
      createFileSync: file.createFileSync,
      ensureFile: file.createFile,
      ensureFileSync: file.createFileSync,
      createLink: link.createLink,
      createLinkSync: link.createLinkSync,
      ensureLink: link.createLink,
      ensureLinkSync: link.createLinkSync,
      createSymlink: symlink.createSymlink,
      createSymlinkSync: symlink.createSymlinkSync,
      ensureSymlink: symlink.createSymlink,
      ensureSymlinkSync: symlink.createSymlinkSync
    };
  }
});

// node_modules/jsonfile/index.js
var require_jsonfile3 = __commonJS({
  "node_modules/jsonfile/index.js"(exports, module2) {
    var _fs;
    try {
      _fs = require_graceful_fs();
    } catch (_) {
      _fs = require("fs");
    }
    function readFile(file, options, callback) {
      if (callback == null) {
        callback = options;
        options = {};
      }
      if (typeof options === "string") {
        options = { encoding: options };
      }
      options = options || {};
      var fs4 = options.fs || _fs;
      var shouldThrow = true;
      if ("throws" in options) {
        shouldThrow = options.throws;
      }
      fs4.readFile(file, options, function(err, data) {
        if (err)
          return callback(err);
        data = stripBom(data);
        var obj;
        try {
          obj = JSON.parse(data, options ? options.reviver : null);
        } catch (err2) {
          if (shouldThrow) {
            err2.message = file + ": " + err2.message;
            return callback(err2);
          } else {
            return callback(null, null);
          }
        }
        callback(null, obj);
      });
    }
    function readFileSync(file, options) {
      options = options || {};
      if (typeof options === "string") {
        options = { encoding: options };
      }
      var fs4 = options.fs || _fs;
      var shouldThrow = true;
      if ("throws" in options) {
        shouldThrow = options.throws;
      }
      try {
        var content = fs4.readFileSync(file, options);
        content = stripBom(content);
        return JSON.parse(content, options.reviver);
      } catch (err) {
        if (shouldThrow) {
          err.message = file + ": " + err.message;
          throw err;
        } else {
          return null;
        }
      }
    }
    function stringify(obj, options) {
      var spaces;
      var EOL = "\n";
      if (typeof options === "object" && options !== null) {
        if (options.spaces) {
          spaces = options.spaces;
        }
        if (options.EOL) {
          EOL = options.EOL;
        }
      }
      var str = JSON.stringify(obj, options ? options.replacer : null, spaces);
      return str.replace(/\n/g, EOL) + EOL;
    }
    function writeFile2(file, obj, options, callback) {
      if (callback == null) {
        callback = options;
        options = {};
      }
      options = options || {};
      var fs4 = options.fs || _fs;
      var str = "";
      try {
        str = stringify(obj, options);
      } catch (err) {
        if (callback)
          callback(err, null);
        return;
      }
      fs4.writeFile(file, str, options, callback);
    }
    function writeFileSync(file, obj, options) {
      options = options || {};
      var fs4 = options.fs || _fs;
      var str = stringify(obj, options);
      return fs4.writeFileSync(file, str, options);
    }
    function stripBom(content) {
      if (Buffer.isBuffer(content))
        content = content.toString("utf8");
      content = content.replace(/^\uFEFF/, "");
      return content;
    }
    var jsonfile = {
      readFile,
      readFileSync,
      writeFile: writeFile2,
      writeFileSync
    };
    module2.exports = jsonfile;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/json/jsonfile.js
var require_jsonfile4 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/json/jsonfile.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var jsonFile = require_jsonfile3();
    module2.exports = {
      readJson: u(jsonFile.readFile),
      readJsonSync: jsonFile.readFileSync,
      writeJson: u(jsonFile.writeFile),
      writeJsonSync: jsonFile.writeFileSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/json/output-json.js
var require_output_json2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/json/output-json.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var mkdir = require_mkdirs3();
    var pathExists = require_path_exists2().pathExists;
    var jsonFile = require_jsonfile4();
    function outputJson(file, data, options, callback) {
      if (typeof options === "function") {
        callback = options;
        options = {};
      }
      const dir = path4.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return jsonFile.writeJson(file, data, options, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          jsonFile.writeJson(file, data, options, callback);
        });
      });
    }
    module2.exports = outputJson;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/json/output-json-sync.js
var require_output_json_sync2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/json/output-json-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdir = require_mkdirs3();
    var jsonFile = require_jsonfile4();
    function outputJsonSync(file, data, options) {
      const dir = path4.dirname(file);
      if (!fs4.existsSync(dir)) {
        mkdir.mkdirsSync(dir);
      }
      jsonFile.writeJsonSync(file, data, options);
    }
    module2.exports = outputJsonSync;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/json/index.js
var require_json2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/json/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var jsonFile = require_jsonfile4();
    jsonFile.outputJson = u(require_output_json2());
    jsonFile.outputJsonSync = require_output_json_sync2();
    jsonFile.outputJSON = jsonFile.outputJson;
    jsonFile.outputJSONSync = jsonFile.outputJsonSync;
    jsonFile.writeJSON = jsonFile.writeJson;
    jsonFile.writeJSONSync = jsonFile.writeJsonSync;
    jsonFile.readJSON = jsonFile.readJson;
    jsonFile.readJSONSync = jsonFile.readJsonSync;
    module2.exports = jsonFile;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/move-sync/move-sync.js
var require_move_sync2 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/move-sync/move-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var copySync = require_copy_sync3().copySync;
    var removeSync = require_remove3().removeSync;
    var mkdirpSync = require_mkdirs3().mkdirpSync;
    var stat3 = require_stat2();
    function moveSync(src, dest, opts) {
      opts = opts || {};
      const overwrite = opts.overwrite || opts.clobber || false;
      const { srcStat } = stat3.checkPathsSync(src, dest, "move");
      stat3.checkParentPathsSync(src, srcStat, dest, "move");
      mkdirpSync(path4.dirname(dest));
      return doRename(src, dest, overwrite);
    }
    function doRename(src, dest, overwrite) {
      if (overwrite) {
        removeSync(dest);
        return rename(src, dest, overwrite);
      }
      if (fs4.existsSync(dest))
        throw new Error("dest already exists.");
      return rename(src, dest, overwrite);
    }
    function rename(src, dest, overwrite) {
      try {
        fs4.renameSync(src, dest);
      } catch (err) {
        if (err.code !== "EXDEV")
          throw err;
        return moveAcrossDevice(src, dest, overwrite);
      }
    }
    function moveAcrossDevice(src, dest, overwrite) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copySync(src, dest, opts);
      return removeSync(src);
    }
    module2.exports = moveSync;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/move-sync/index.js
var require_move_sync3 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/move-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      moveSync: require_move_sync2()
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/move/move.js
var require_move3 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/move/move.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var copy = require_copy4().copy;
    var remove = require_remove3().remove;
    var mkdirp2 = require_mkdirs3().mkdirp;
    var pathExists = require_path_exists2().pathExists;
    var stat3 = require_stat2();
    function move(src, dest, opts, cb) {
      if (typeof opts === "function") {
        cb = opts;
        opts = {};
      }
      const overwrite = opts.overwrite || opts.clobber || false;
      stat3.checkPaths(src, dest, "move", (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat } = stats;
        stat3.checkParentPaths(src, srcStat, dest, "move", (err2) => {
          if (err2)
            return cb(err2);
          mkdirp2(path4.dirname(dest), (err3) => {
            if (err3)
              return cb(err3);
            return doRename(src, dest, overwrite, cb);
          });
        });
      });
    }
    function doRename(src, dest, overwrite, cb) {
      if (overwrite) {
        return remove(dest, (err) => {
          if (err)
            return cb(err);
          return rename(src, dest, overwrite, cb);
        });
      }
      pathExists(dest, (err, destExists) => {
        if (err)
          return cb(err);
        if (destExists)
          return cb(new Error("dest already exists."));
        return rename(src, dest, overwrite, cb);
      });
    }
    function rename(src, dest, overwrite, cb) {
      fs4.rename(src, dest, (err) => {
        if (!err)
          return cb();
        if (err.code !== "EXDEV")
          return cb(err);
        return moveAcrossDevice(src, dest, overwrite, cb);
      });
    }
    function moveAcrossDevice(src, dest, overwrite, cb) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copy(src, dest, opts, (err) => {
        if (err)
          return cb(err);
        return remove(src, cb);
      });
    }
    module2.exports = move;
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/move/index.js
var require_move4 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/move/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    module2.exports = {
      move: u(require_move3())
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/output/index.js
var require_output = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/output/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdir = require_mkdirs3();
    var pathExists = require_path_exists2().pathExists;
    function outputFile(file, data, encoding, callback) {
      if (typeof encoding === "function") {
        callback = encoding;
        encoding = "utf8";
      }
      const dir = path4.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return fs4.writeFile(file, data, encoding, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          fs4.writeFile(file, data, encoding, callback);
        });
      });
    }
    function outputFileSync(file, ...args) {
      const dir = path4.dirname(file);
      if (fs4.existsSync(dir)) {
        return fs4.writeFileSync(file, ...args);
      }
      mkdir.mkdirsSync(dir);
      fs4.writeFileSync(file, ...args);
    }
    module2.exports = {
      outputFile: u(outputFile),
      outputFileSync
    };
  }
});

// node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/index.js
var require_lib4 = __commonJS({
  "node_modules/@manypkg/get-packages/node_modules/fs-extra/lib/index.js"(exports, module2) {
    "use strict";
    module2.exports = Object.assign(
      {},
      require_fs2(),
      require_copy_sync3(),
      require_copy4(),
      require_empty2(),
      require_ensure2(),
      require_json2(),
      require_mkdirs3(),
      require_move_sync3(),
      require_move4(),
      require_output(),
      require_path_exists2(),
      require_remove3()
    );
    var fs4 = require("fs");
    if (Object.getOwnPropertyDescriptor(fs4, "promises")) {
      Object.defineProperty(module2.exports, "promises", {
        get() {
          return fs4.promises;
        }
      });
    }
  }
});

// node_modules/array-union/index.js
var require_array_union = __commonJS({
  "node_modules/array-union/index.js"(exports, module2) {
    "use strict";
    module2.exports = (...arguments_) => {
      return [...new Set([].concat(...arguments_))];
    };
  }
});

// node_modules/merge2/index.js
var require_merge2 = __commonJS({
  "node_modules/merge2/index.js"(exports, module2) {
    "use strict";
    var Stream4 = require("stream");
    var PassThrough4 = Stream4.PassThrough;
    var slice = Array.prototype.slice;
    module2.exports = merge2;
    function merge2() {
      const streamsQueue = [];
      const args = slice.call(arguments);
      let merging = false;
      let options = args[args.length - 1];
      if (options && !Array.isArray(options) && options.pipe == null) {
        args.pop();
      } else {
        options = {};
      }
      const doEnd = options.end !== false;
      const doPipeError = options.pipeError === true;
      if (options.objectMode == null) {
        options.objectMode = true;
      }
      if (options.highWaterMark == null) {
        options.highWaterMark = 64 * 1024;
      }
      const mergedStream = PassThrough4(options);
      function addStream() {
        for (let i2 = 0, len = arguments.length; i2 < len; i2++) {
          streamsQueue.push(pauseStreams(arguments[i2], options));
        }
        mergeStream();
        return this;
      }
      function mergeStream() {
        if (merging) {
          return;
        }
        merging = true;
        let streams = streamsQueue.shift();
        if (!streams) {
          process.nextTick(endStream);
          return;
        }
        if (!Array.isArray(streams)) {
          streams = [streams];
        }
        let pipesCount = streams.length + 1;
        function next() {
          if (--pipesCount > 0) {
            return;
          }
          merging = false;
          mergeStream();
        }
        function pipe(stream) {
          function onend() {
            stream.removeListener("merge2UnpipeEnd", onend);
            stream.removeListener("end", onend);
            if (doPipeError) {
              stream.removeListener("error", onerror);
            }
            next();
          }
          function onerror(err) {
            mergedStream.emit("error", err);
          }
          if (stream._readableState.endEmitted) {
            return next();
          }
          stream.on("merge2UnpipeEnd", onend);
          stream.on("end", onend);
          if (doPipeError) {
            stream.on("error", onerror);
          }
          stream.pipe(mergedStream, { end: false });
          stream.resume();
        }
        for (let i2 = 0; i2 < streams.length; i2++) {
          pipe(streams[i2]);
        }
        next();
      }
      function endStream() {
        merging = false;
        mergedStream.emit("queueDrain");
        if (doEnd) {
          mergedStream.end();
        }
      }
      mergedStream.setMaxListeners(0);
      mergedStream.add = addStream;
      mergedStream.on("unpipe", function(stream) {
        stream.emit("merge2UnpipeEnd");
      });
      if (args.length) {
        addStream.apply(null, args);
      }
      return mergedStream;
    }
    function pauseStreams(streams, options) {
      if (!Array.isArray(streams)) {
        if (!streams._readableState && streams.pipe) {
          streams = streams.pipe(PassThrough4(options));
        }
        if (!streams._readableState || !streams.pause || !streams.pipe) {
          throw new Error("Only readable stream can be merged.");
        }
        streams.pause();
      } else {
        for (let i2 = 0, len = streams.length; i2 < len; i2++) {
          streams[i2] = pauseStreams(streams[i2], options);
        }
      }
      return streams;
    }
  }
});

// node_modules/fast-glob/out/utils/array.js
var require_array = __commonJS({
  "node_modules/fast-glob/out/utils/array.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.splitWhen = exports.flatten = void 0;
    function flatten2(items) {
      return items.reduce((collection, item) => [].concat(collection, item), []);
    }
    exports.flatten = flatten2;
    function splitWhen(items, predicate) {
      const result = [[]];
      let groupIndex = 0;
      for (const item of items) {
        if (predicate(item)) {
          groupIndex++;
          result[groupIndex] = [];
        } else {
          result[groupIndex].push(item);
        }
      }
      return result;
    }
    exports.splitWhen = splitWhen;
  }
});

// node_modules/fast-glob/out/utils/errno.js
var require_errno = __commonJS({
  "node_modules/fast-glob/out/utils/errno.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isEnoentCodeError = void 0;
    function isEnoentCodeError(error) {
      return error.code === "ENOENT";
    }
    exports.isEnoentCodeError = isEnoentCodeError;
  }
});

// node_modules/fast-glob/out/utils/fs.js
var require_fs3 = __commonJS({
  "node_modules/fast-glob/out/utils/fs.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.createDirentFromStats = void 0;
    var DirentFromStats = class {
      constructor(name, stats) {
        this.name = name;
        this.isBlockDevice = stats.isBlockDevice.bind(stats);
        this.isCharacterDevice = stats.isCharacterDevice.bind(stats);
        this.isDirectory = stats.isDirectory.bind(stats);
        this.isFIFO = stats.isFIFO.bind(stats);
        this.isFile = stats.isFile.bind(stats);
        this.isSocket = stats.isSocket.bind(stats);
        this.isSymbolicLink = stats.isSymbolicLink.bind(stats);
      }
    };
    function createDirentFromStats(name, stats) {
      return new DirentFromStats(name, stats);
    }
    exports.createDirentFromStats = createDirentFromStats;
  }
});

// node_modules/fast-glob/out/utils/path.js
var require_path = __commonJS({
  "node_modules/fast-glob/out/utils/path.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.removeLeadingDotSegment = exports.escape = exports.makeAbsolute = exports.unixify = void 0;
    var path4 = require("path");
    var LEADING_DOT_SEGMENT_CHARACTERS_COUNT = 2;
    var UNESCAPED_GLOB_SYMBOLS_RE = /(\\?)([()*?[\]{|}]|^!|[!+@](?=\())/g;
    function unixify(filepath) {
      return filepath.replace(/\\/g, "/");
    }
    exports.unixify = unixify;
    function makeAbsolute(cwd, filepath) {
      return path4.resolve(cwd, filepath);
    }
    exports.makeAbsolute = makeAbsolute;
    function escape(pattern) {
      return pattern.replace(UNESCAPED_GLOB_SYMBOLS_RE, "\\$2");
    }
    exports.escape = escape;
    function removeLeadingDotSegment(entry) {
      if (entry.charAt(0) === ".") {
        const secondCharactery = entry.charAt(1);
        if (secondCharactery === "/" || secondCharactery === "\\") {
          return entry.slice(LEADING_DOT_SEGMENT_CHARACTERS_COUNT);
        }
      }
      return entry;
    }
    exports.removeLeadingDotSegment = removeLeadingDotSegment;
  }
});

// node_modules/is-extglob/index.js
var require_is_extglob = __commonJS({
  "node_modules/is-extglob/index.js"(exports, module2) {
    module2.exports = function isExtglob(str) {
      if (typeof str !== "string" || str === "") {
        return false;
      }
      var match;
      while (match = /(\\).|([@?!+*]\(.*\))/g.exec(str)) {
        if (match[2])
          return true;
        str = str.slice(match.index + match[0].length);
      }
      return false;
    };
  }
});

// node_modules/glob-parent/node_modules/is-glob/index.js
var require_is_glob = __commonJS({
  "node_modules/glob-parent/node_modules/is-glob/index.js"(exports, module2) {
    var isExtglob = require_is_extglob();
    var chars = { "{": "}", "(": ")", "[": "]" };
    var strictRegex = /\\(.)|(^!|\*|[\].+)]\?|\[[^\\\]]+\]|\{[^\\}]+\}|\(\?[:!=][^\\)]+\)|\([^|]+\|[^\\)]+\))/;
    var relaxedRegex = /\\(.)|(^!|[*?{}()[\]]|\(\?)/;
    module2.exports = function isGlob(str, options) {
      if (typeof str !== "string" || str === "") {
        return false;
      }
      if (isExtglob(str)) {
        return true;
      }
      var regex = strictRegex;
      var match;
      if (options && options.strict === false) {
        regex = relaxedRegex;
      }
      while (match = regex.exec(str)) {
        if (match[2])
          return true;
        var idx = match.index + match[0].length;
        var open = match[1];
        var close = open ? chars[open] : null;
        if (open && close) {
          var n = str.indexOf(close, idx);
          if (n !== -1) {
            idx = n + 1;
          }
        }
        str = str.slice(idx);
      }
      return false;
    };
  }
});

// node_modules/glob-parent/index.js
var require_glob_parent = __commonJS({
  "node_modules/glob-parent/index.js"(exports, module2) {
    "use strict";
    var isGlob = require_is_glob();
    var pathPosixDirname = require("path").posix.dirname;
    var isWin32 = require("os").platform() === "win32";
    var slash = "/";
    var backslash = /\\/g;
    var enclosure = /[\{\[].*[\}\]]$/;
    var globby = /(^|[^\\])([\{\[]|\([^\)]+$)/;
    var escaped = /\\([\!\*\?\|\[\]\(\)\{\}])/g;
    module2.exports = function globParent(str, opts) {
      var options = Object.assign({ flipBackslashes: true }, opts);
      if (options.flipBackslashes && isWin32 && str.indexOf(slash) < 0) {
        str = str.replace(backslash, slash);
      }
      if (enclosure.test(str)) {
        str += slash;
      }
      str += "a";
      do {
        str = pathPosixDirname(str);
      } while (isGlob(str) || globby.test(str));
      return str.replace(escaped, "$1");
    };
  }
});

// node_modules/braces/lib/utils.js
var require_utils7 = __commonJS({
  "node_modules/braces/lib/utils.js"(exports) {
    "use strict";
    exports.isInteger = (num) => {
      if (typeof num === "number") {
        return Number.isInteger(num);
      }
      if (typeof num === "string" && num.trim() !== "") {
        return Number.isInteger(Number(num));
      }
      return false;
    };
    exports.find = (node, type) => node.nodes.find((node2) => node2.type === type);
    exports.exceedsLimit = (min, max, step = 1, limit) => {
      if (limit === false)
        return false;
      if (!exports.isInteger(min) || !exports.isInteger(max))
        return false;
      return (Number(max) - Number(min)) / Number(step) >= limit;
    };
    exports.escapeNode = (block, n = 0, type) => {
      let node = block.nodes[n];
      if (!node)
        return;
      if (type && node.type === type || node.type === "open" || node.type === "close") {
        if (node.escaped !== true) {
          node.value = "\\" + node.value;
          node.escaped = true;
        }
      }
    };
    exports.encloseBrace = (node) => {
      if (node.type !== "brace")
        return false;
      if (node.commas >> 0 + node.ranges >> 0 === 0) {
        node.invalid = true;
        return true;
      }
      return false;
    };
    exports.isInvalidBrace = (block) => {
      if (block.type !== "brace")
        return false;
      if (block.invalid === true || block.dollar)
        return true;
      if (block.commas >> 0 + block.ranges >> 0 === 0) {
        block.invalid = true;
        return true;
      }
      if (block.open !== true || block.close !== true) {
        block.invalid = true;
        return true;
      }
      return false;
    };
    exports.isOpenOrClose = (node) => {
      if (node.type === "open" || node.type === "close") {
        return true;
      }
      return node.open === true || node.close === true;
    };
    exports.reduce = (nodes) => nodes.reduce((acc, node) => {
      if (node.type === "text")
        acc.push(node.value);
      if (node.type === "range")
        node.type = "text";
      return acc;
    }, []);
    exports.flatten = (...args) => {
      const result = [];
      const flat = (arr) => {
        for (let i2 = 0; i2 < arr.length; i2++) {
          let ele = arr[i2];
          Array.isArray(ele) ? flat(ele, result) : ele !== void 0 && result.push(ele);
        }
        return result;
      };
      flat(args);
      return result;
    };
  }
});

// node_modules/braces/lib/stringify.js
var require_stringify = __commonJS({
  "node_modules/braces/lib/stringify.js"(exports, module2) {
    "use strict";
    var utils = require_utils7();
    module2.exports = (ast, options = {}) => {
      let stringify = (node, parent = {}) => {
        let invalidBlock = options.escapeInvalid && utils.isInvalidBrace(parent);
        let invalidNode = node.invalid === true && options.escapeInvalid === true;
        let output = "";
        if (node.value) {
          if ((invalidBlock || invalidNode) && utils.isOpenOrClose(node)) {
            return "\\" + node.value;
          }
          return node.value;
        }
        if (node.value) {
          return node.value;
        }
        if (node.nodes) {
          for (let child of node.nodes) {
            output += stringify(child);
          }
        }
        return output;
      };
      return stringify(ast);
    };
  }
});

// node_modules/is-number/index.js
var require_is_number = __commonJS({
  "node_modules/is-number/index.js"(exports, module2) {
    "use strict";
    module2.exports = function(num) {
      if (typeof num === "number") {
        return num - num === 0;
      }
      if (typeof num === "string" && num.trim() !== "") {
        return Number.isFinite ? Number.isFinite(+num) : isFinite(+num);
      }
      return false;
    };
  }
});

// node_modules/to-regex-range/index.js
var require_to_regex_range = __commonJS({
  "node_modules/to-regex-range/index.js"(exports, module2) {
    "use strict";
    var isNumber = require_is_number();
    var toRegexRange = (min, max, options) => {
      if (isNumber(min) === false) {
        throw new TypeError("toRegexRange: expected the first argument to be a number");
      }
      if (max === void 0 || min === max) {
        return String(min);
      }
      if (isNumber(max) === false) {
        throw new TypeError("toRegexRange: expected the second argument to be a number.");
      }
      let opts = { relaxZeros: true, ...options };
      if (typeof opts.strictZeros === "boolean") {
        opts.relaxZeros = opts.strictZeros === false;
      }
      let relax = String(opts.relaxZeros);
      let shorthand = String(opts.shorthand);
      let capture = String(opts.capture);
      let wrap = String(opts.wrap);
      let cacheKey = min + ":" + max + "=" + relax + shorthand + capture + wrap;
      if (toRegexRange.cache.hasOwnProperty(cacheKey)) {
        return toRegexRange.cache[cacheKey].result;
      }
      let a = Math.min(min, max);
      let b = Math.max(min, max);
      if (Math.abs(a - b) === 1) {
        let result = min + "|" + max;
        if (opts.capture) {
          return `(${result})`;
        }
        if (opts.wrap === false) {
          return result;
        }
        return `(?:${result})`;
      }
      let isPadded = hasPadding(min) || hasPadding(max);
      let state = { min, max, a, b };
      let positives = [];
      let negatives = [];
      if (isPadded) {
        state.isPadded = isPadded;
        state.maxLen = String(state.max).length;
      }
      if (a < 0) {
        let newMin = b < 0 ? Math.abs(b) : 1;
        negatives = splitToPatterns(newMin, Math.abs(a), state, opts);
        a = state.a = 0;
      }
      if (b >= 0) {
        positives = splitToPatterns(a, b, state, opts);
      }
      state.negatives = negatives;
      state.positives = positives;
      state.result = collatePatterns(negatives, positives, opts);
      if (opts.capture === true) {
        state.result = `(${state.result})`;
      } else if (opts.wrap !== false && positives.length + negatives.length > 1) {
        state.result = `(?:${state.result})`;
      }
      toRegexRange.cache[cacheKey] = state;
      return state.result;
    };
    function collatePatterns(neg, pos, options) {
      let onlyNegative = filterPatterns(neg, pos, "-", false, options) || [];
      let onlyPositive = filterPatterns(pos, neg, "", false, options) || [];
      let intersected = filterPatterns(neg, pos, "-?", true, options) || [];
      let subpatterns = onlyNegative.concat(intersected).concat(onlyPositive);
      return subpatterns.join("|");
    }
    function splitToRanges(min, max) {
      let nines = 1;
      let zeros = 1;
      let stop = countNines(min, nines);
      let stops = /* @__PURE__ */ new Set([max]);
      while (min <= stop && stop <= max) {
        stops.add(stop);
        nines += 1;
        stop = countNines(min, nines);
      }
      stop = countZeros(max + 1, zeros) - 1;
      while (min < stop && stop <= max) {
        stops.add(stop);
        zeros += 1;
        stop = countZeros(max + 1, zeros) - 1;
      }
      stops = [...stops];
      stops.sort(compare);
      return stops;
    }
    function rangeToPattern(start, stop, options) {
      if (start === stop) {
        return { pattern: start, count: [], digits: 0 };
      }
      let zipped = zip(start, stop);
      let digits = zipped.length;
      let pattern = "";
      let count = 0;
      for (let i2 = 0; i2 < digits; i2++) {
        let [startDigit, stopDigit] = zipped[i2];
        if (startDigit === stopDigit) {
          pattern += startDigit;
        } else if (startDigit !== "0" || stopDigit !== "9") {
          pattern += toCharacterClass(startDigit, stopDigit, options);
        } else {
          count++;
        }
      }
      if (count) {
        pattern += options.shorthand === true ? "\\d" : "[0-9]";
      }
      return { pattern, count: [count], digits };
    }
    function splitToPatterns(min, max, tok, options) {
      let ranges = splitToRanges(min, max);
      let tokens = [];
      let start = min;
      let prev;
      for (let i2 = 0; i2 < ranges.length; i2++) {
        let max2 = ranges[i2];
        let obj = rangeToPattern(String(start), String(max2), options);
        let zeros = "";
        if (!tok.isPadded && prev && prev.pattern === obj.pattern) {
          if (prev.count.length > 1) {
            prev.count.pop();
          }
          prev.count.push(obj.count[0]);
          prev.string = prev.pattern + toQuantifier(prev.count);
          start = max2 + 1;
          continue;
        }
        if (tok.isPadded) {
          zeros = padZeros(max2, tok, options);
        }
        obj.string = zeros + obj.pattern + toQuantifier(obj.count);
        tokens.push(obj);
        start = max2 + 1;
        prev = obj;
      }
      return tokens;
    }
    function filterPatterns(arr, comparison, prefix2, intersection, options) {
      let result = [];
      for (let ele of arr) {
        let { string } = ele;
        if (!intersection && !contains(comparison, "string", string)) {
          result.push(prefix2 + string);
        }
        if (intersection && contains(comparison, "string", string)) {
          result.push(prefix2 + string);
        }
      }
      return result;
    }
    function zip(a, b) {
      let arr = [];
      for (let i2 = 0; i2 < a.length; i2++)
        arr.push([a[i2], b[i2]]);
      return arr;
    }
    function compare(a, b) {
      return a > b ? 1 : b > a ? -1 : 0;
    }
    function contains(arr, key, val) {
      return arr.some((ele) => ele[key] === val);
    }
    function countNines(min, len) {
      return Number(String(min).slice(0, -len) + "9".repeat(len));
    }
    function countZeros(integer, zeros) {
      return integer - integer % Math.pow(10, zeros);
    }
    function toQuantifier(digits) {
      let [start = 0, stop = ""] = digits;
      if (stop || start > 1) {
        return `{${start + (stop ? "," + stop : "")}}`;
      }
      return "";
    }
    function toCharacterClass(a, b, options) {
      return `[${a}${b - a === 1 ? "" : "-"}${b}]`;
    }
    function hasPadding(str) {
      return /^-?(0+)\d/.test(str);
    }
    function padZeros(value, tok, options) {
      if (!tok.isPadded) {
        return value;
      }
      let diff2 = Math.abs(tok.maxLen - String(value).length);
      let relax = options.relaxZeros !== false;
      switch (diff2) {
        case 0:
          return "";
        case 1:
          return relax ? "0?" : "0";
        case 2:
          return relax ? "0{0,2}" : "00";
        default: {
          return relax ? `0{0,${diff2}}` : `0{${diff2}}`;
        }
      }
    }
    toRegexRange.cache = {};
    toRegexRange.clearCache = () => toRegexRange.cache = {};
    module2.exports = toRegexRange;
  }
});

// node_modules/fill-range/index.js
var require_fill_range = __commonJS({
  "node_modules/fill-range/index.js"(exports, module2) {
    "use strict";
    var util2 = require("util");
    var toRegexRange = require_to_regex_range();
    var isObject3 = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
    var transform = (toNumber) => {
      return (value) => toNumber === true ? Number(value) : String(value);
    };
    var isValidValue = (value) => {
      return typeof value === "number" || typeof value === "string" && value !== "";
    };
    var isNumber = (num) => Number.isInteger(+num);
    var zeros = (input) => {
      let value = `${input}`;
      let index = -1;
      if (value[0] === "-")
        value = value.slice(1);
      if (value === "0")
        return false;
      while (value[++index] === "0")
        ;
      return index > 0;
    };
    var stringify = (start, end, options) => {
      if (typeof start === "string" || typeof end === "string") {
        return true;
      }
      return options.stringify === true;
    };
    var pad = (input, maxLength, toNumber) => {
      if (maxLength > 0) {
        let dash = input[0] === "-" ? "-" : "";
        if (dash)
          input = input.slice(1);
        input = dash + input.padStart(dash ? maxLength - 1 : maxLength, "0");
      }
      if (toNumber === false) {
        return String(input);
      }
      return input;
    };
    var toMaxLen = (input, maxLength) => {
      let negative = input[0] === "-" ? "-" : "";
      if (negative) {
        input = input.slice(1);
        maxLength--;
      }
      while (input.length < maxLength)
        input = "0" + input;
      return negative ? "-" + input : input;
    };
    var toSequence = (parts, options) => {
      parts.negatives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
      parts.positives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
      let prefix2 = options.capture ? "" : "?:";
      let positives = "";
      let negatives = "";
      let result;
      if (parts.positives.length) {
        positives = parts.positives.join("|");
      }
      if (parts.negatives.length) {
        negatives = `-(${prefix2}${parts.negatives.join("|")})`;
      }
      if (positives && negatives) {
        result = `${positives}|${negatives}`;
      } else {
        result = positives || negatives;
      }
      if (options.wrap) {
        return `(${prefix2}${result})`;
      }
      return result;
    };
    var toRange = (a, b, isNumbers, options) => {
      if (isNumbers) {
        return toRegexRange(a, b, { wrap: false, ...options });
      }
      let start = String.fromCharCode(a);
      if (a === b)
        return start;
      let stop = String.fromCharCode(b);
      return `[${start}-${stop}]`;
    };
    var toRegex = (start, end, options) => {
      if (Array.isArray(start)) {
        let wrap = options.wrap === true;
        let prefix2 = options.capture ? "" : "?:";
        return wrap ? `(${prefix2}${start.join("|")})` : start.join("|");
      }
      return toRegexRange(start, end, options);
    };
    var rangeError = (...args) => {
      return new RangeError("Invalid range arguments: " + util2.inspect(...args));
    };
    var invalidRange = (start, end, options) => {
      if (options.strictRanges === true)
        throw rangeError([start, end]);
      return [];
    };
    var invalidStep = (step, options) => {
      if (options.strictRanges === true) {
        throw new TypeError(`Expected step "${step}" to be a number`);
      }
      return [];
    };
    var fillNumbers = (start, end, step = 1, options = {}) => {
      let a = Number(start);
      let b = Number(end);
      if (!Number.isInteger(a) || !Number.isInteger(b)) {
        if (options.strictRanges === true)
          throw rangeError([start, end]);
        return [];
      }
      if (a === 0)
        a = 0;
      if (b === 0)
        b = 0;
      let descending = a > b;
      let startString = String(start);
      let endString = String(end);
      let stepString = String(step);
      step = Math.max(Math.abs(step), 1);
      let padded = zeros(startString) || zeros(endString) || zeros(stepString);
      let maxLen = padded ? Math.max(startString.length, endString.length, stepString.length) : 0;
      let toNumber = padded === false && stringify(start, end, options) === false;
      let format2 = options.transform || transform(toNumber);
      if (options.toRegex && step === 1) {
        return toRange(toMaxLen(start, maxLen), toMaxLen(end, maxLen), true, options);
      }
      let parts = { negatives: [], positives: [] };
      let push2 = (num) => parts[num < 0 ? "negatives" : "positives"].push(Math.abs(num));
      let range = [];
      let index = 0;
      while (descending ? a >= b : a <= b) {
        if (options.toRegex === true && step > 1) {
          push2(a);
        } else {
          range.push(pad(format2(a, index), maxLen, toNumber));
        }
        a = descending ? a - step : a + step;
        index++;
      }
      if (options.toRegex === true) {
        return step > 1 ? toSequence(parts, options) : toRegex(range, null, { wrap: false, ...options });
      }
      return range;
    };
    var fillLetters = (start, end, step = 1, options = {}) => {
      if (!isNumber(start) && start.length > 1 || !isNumber(end) && end.length > 1) {
        return invalidRange(start, end, options);
      }
      let format2 = options.transform || ((val) => String.fromCharCode(val));
      let a = `${start}`.charCodeAt(0);
      let b = `${end}`.charCodeAt(0);
      let descending = a > b;
      let min = Math.min(a, b);
      let max = Math.max(a, b);
      if (options.toRegex && step === 1) {
        return toRange(min, max, false, options);
      }
      let range = [];
      let index = 0;
      while (descending ? a >= b : a <= b) {
        range.push(format2(a, index));
        a = descending ? a - step : a + step;
        index++;
      }
      if (options.toRegex === true) {
        return toRegex(range, null, { wrap: false, options });
      }
      return range;
    };
    var fill = (start, end, step, options = {}) => {
      if (end == null && isValidValue(start)) {
        return [start];
      }
      if (!isValidValue(start) || !isValidValue(end)) {
        return invalidRange(start, end, options);
      }
      if (typeof step === "function") {
        return fill(start, end, 1, { transform: step });
      }
      if (isObject3(step)) {
        return fill(start, end, 0, step);
      }
      let opts = { ...options };
      if (opts.capture === true)
        opts.wrap = true;
      step = step || opts.step || 1;
      if (!isNumber(step)) {
        if (step != null && !isObject3(step))
          return invalidStep(step, opts);
        return fill(start, end, 1, step);
      }
      if (isNumber(start) && isNumber(end)) {
        return fillNumbers(start, end, step, opts);
      }
      return fillLetters(start, end, Math.max(Math.abs(step), 1), opts);
    };
    module2.exports = fill;
  }
});

// node_modules/braces/lib/compile.js
var require_compile = __commonJS({
  "node_modules/braces/lib/compile.js"(exports, module2) {
    "use strict";
    var fill = require_fill_range();
    var utils = require_utils7();
    var compile = (ast, options = {}) => {
      let walk = (node, parent = {}) => {
        let invalidBlock = utils.isInvalidBrace(parent);
        let invalidNode = node.invalid === true && options.escapeInvalid === true;
        let invalid = invalidBlock === true || invalidNode === true;
        let prefix2 = options.escapeInvalid === true ? "\\" : "";
        let output = "";
        if (node.isOpen === true) {
          return prefix2 + node.value;
        }
        if (node.isClose === true) {
          return prefix2 + node.value;
        }
        if (node.type === "open") {
          return invalid ? prefix2 + node.value : "(";
        }
        if (node.type === "close") {
          return invalid ? prefix2 + node.value : ")";
        }
        if (node.type === "comma") {
          return node.prev.type === "comma" ? "" : invalid ? node.value : "|";
        }
        if (node.value) {
          return node.value;
        }
        if (node.nodes && node.ranges > 0) {
          let args = utils.reduce(node.nodes);
          let range = fill(...args, { ...options, wrap: false, toRegex: true });
          if (range.length !== 0) {
            return args.length > 1 && range.length > 1 ? `(${range})` : range;
          }
        }
        if (node.nodes) {
          for (let child of node.nodes) {
            output += walk(child, node);
          }
        }
        return output;
      };
      return walk(ast);
    };
    module2.exports = compile;
  }
});

// node_modules/braces/lib/expand.js
var require_expand = __commonJS({
  "node_modules/braces/lib/expand.js"(exports, module2) {
    "use strict";
    var fill = require_fill_range();
    var stringify = require_stringify();
    var utils = require_utils7();
    var append = (queue = "", stash = "", enclose = false) => {
      let result = [];
      queue = [].concat(queue);
      stash = [].concat(stash);
      if (!stash.length)
        return queue;
      if (!queue.length) {
        return enclose ? utils.flatten(stash).map((ele) => `{${ele}}`) : stash;
      }
      for (let item of queue) {
        if (Array.isArray(item)) {
          for (let value of item) {
            result.push(append(value, stash, enclose));
          }
        } else {
          for (let ele of stash) {
            if (enclose === true && typeof ele === "string")
              ele = `{${ele}}`;
            result.push(Array.isArray(ele) ? append(item, ele, enclose) : item + ele);
          }
        }
      }
      return utils.flatten(result);
    };
    var expand2 = (ast, options = {}) => {
      let rangeLimit = options.rangeLimit === void 0 ? 1e3 : options.rangeLimit;
      let walk = (node, parent = {}) => {
        node.queue = [];
        let p = parent;
        let q = parent.queue;
        while (p.type !== "brace" && p.type !== "root" && p.parent) {
          p = p.parent;
          q = p.queue;
        }
        if (node.invalid || node.dollar) {
          q.push(append(q.pop(), stringify(node, options)));
          return;
        }
        if (node.type === "brace" && node.invalid !== true && node.nodes.length === 2) {
          q.push(append(q.pop(), ["{}"]));
          return;
        }
        if (node.nodes && node.ranges > 0) {
          let args = utils.reduce(node.nodes);
          if (utils.exceedsLimit(...args, options.step, rangeLimit)) {
            throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.");
          }
          let range = fill(...args, options);
          if (range.length === 0) {
            range = stringify(node, options);
          }
          q.push(append(q.pop(), range));
          node.nodes = [];
          return;
        }
        let enclose = utils.encloseBrace(node);
        let queue = node.queue;
        let block = node;
        while (block.type !== "brace" && block.type !== "root" && block.parent) {
          block = block.parent;
          queue = block.queue;
        }
        for (let i2 = 0; i2 < node.nodes.length; i2++) {
          let child = node.nodes[i2];
          if (child.type === "comma" && node.type === "brace") {
            if (i2 === 1)
              queue.push("");
            queue.push("");
            continue;
          }
          if (child.type === "close") {
            q.push(append(q.pop(), queue, enclose));
            continue;
          }
          if (child.value && child.type !== "open") {
            queue.push(append(queue.pop(), child.value));
            continue;
          }
          if (child.nodes) {
            walk(child, node);
          }
        }
        return queue;
      };
      return utils.flatten(walk(ast));
    };
    module2.exports = expand2;
  }
});

// node_modules/braces/lib/constants.js
var require_constants = __commonJS({
  "node_modules/braces/lib/constants.js"(exports, module2) {
    "use strict";
    module2.exports = {
      MAX_LENGTH: 1024 * 64,
      CHAR_0: "0",
      CHAR_9: "9",
      CHAR_UPPERCASE_A: "A",
      CHAR_LOWERCASE_A: "a",
      CHAR_UPPERCASE_Z: "Z",
      CHAR_LOWERCASE_Z: "z",
      CHAR_LEFT_PARENTHESES: "(",
      CHAR_RIGHT_PARENTHESES: ")",
      CHAR_ASTERISK: "*",
      CHAR_AMPERSAND: "&",
      CHAR_AT: "@",
      CHAR_BACKSLASH: "\\",
      CHAR_BACKTICK: "`",
      CHAR_CARRIAGE_RETURN: "\r",
      CHAR_CIRCUMFLEX_ACCENT: "^",
      CHAR_COLON: ":",
      CHAR_COMMA: ",",
      CHAR_DOLLAR: "$",
      CHAR_DOT: ".",
      CHAR_DOUBLE_QUOTE: '"',
      CHAR_EQUAL: "=",
      CHAR_EXCLAMATION_MARK: "!",
      CHAR_FORM_FEED: "\f",
      CHAR_FORWARD_SLASH: "/",
      CHAR_HASH: "#",
      CHAR_HYPHEN_MINUS: "-",
      CHAR_LEFT_ANGLE_BRACKET: "<",
      CHAR_LEFT_CURLY_BRACE: "{",
      CHAR_LEFT_SQUARE_BRACKET: "[",
      CHAR_LINE_FEED: "\n",
      CHAR_NO_BREAK_SPACE: "\xA0",
      CHAR_PERCENT: "%",
      CHAR_PLUS: "+",
      CHAR_QUESTION_MARK: "?",
      CHAR_RIGHT_ANGLE_BRACKET: ">",
      CHAR_RIGHT_CURLY_BRACE: "}",
      CHAR_RIGHT_SQUARE_BRACKET: "]",
      CHAR_SEMICOLON: ";",
      CHAR_SINGLE_QUOTE: "'",
      CHAR_SPACE: " ",
      CHAR_TAB: "	",
      CHAR_UNDERSCORE: "_",
      CHAR_VERTICAL_LINE: "|",
      CHAR_ZERO_WIDTH_NOBREAK_SPACE: "\uFEFF"
    };
  }
});

// node_modules/braces/lib/parse.js
var require_parse = __commonJS({
  "node_modules/braces/lib/parse.js"(exports, module2) {
    "use strict";
    var stringify = require_stringify();
    var {
      MAX_LENGTH,
      CHAR_BACKSLASH,
      CHAR_BACKTICK,
      CHAR_COMMA,
      CHAR_DOT,
      CHAR_LEFT_PARENTHESES,
      CHAR_RIGHT_PARENTHESES,
      CHAR_LEFT_CURLY_BRACE,
      CHAR_RIGHT_CURLY_BRACE,
      CHAR_LEFT_SQUARE_BRACKET,
      CHAR_RIGHT_SQUARE_BRACKET,
      CHAR_DOUBLE_QUOTE,
      CHAR_SINGLE_QUOTE,
      CHAR_NO_BREAK_SPACE,
      CHAR_ZERO_WIDTH_NOBREAK_SPACE
    } = require_constants();
    var parse3 = (input, options = {}) => {
      if (typeof input !== "string") {
        throw new TypeError("Expected a string");
      }
      let opts = options || {};
      let max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
      if (input.length > max) {
        throw new SyntaxError(`Input length (${input.length}), exceeds max characters (${max})`);
      }
      let ast = { type: "root", input, nodes: [] };
      let stack = [ast];
      let block = ast;
      let prev = ast;
      let brackets = 0;
      let length = input.length;
      let index = 0;
      let depth = 0;
      let value;
      let memo = {};
      const advance = () => input[index++];
      const push2 = (node) => {
        if (node.type === "text" && prev.type === "dot") {
          prev.type = "text";
        }
        if (prev && prev.type === "text" && node.type === "text") {
          prev.value += node.value;
          return;
        }
        block.nodes.push(node);
        node.parent = block;
        node.prev = prev;
        prev = node;
        return node;
      };
      push2({ type: "bos" });
      while (index < length) {
        block = stack[stack.length - 1];
        value = advance();
        if (value === CHAR_ZERO_WIDTH_NOBREAK_SPACE || value === CHAR_NO_BREAK_SPACE) {
          continue;
        }
        if (value === CHAR_BACKSLASH) {
          push2({ type: "text", value: (options.keepEscaping ? value : "") + advance() });
          continue;
        }
        if (value === CHAR_RIGHT_SQUARE_BRACKET) {
          push2({ type: "text", value: "\\" + value });
          continue;
        }
        if (value === CHAR_LEFT_SQUARE_BRACKET) {
          brackets++;
          let closed = true;
          let next;
          while (index < length && (next = advance())) {
            value += next;
            if (next === CHAR_LEFT_SQUARE_BRACKET) {
              brackets++;
              continue;
            }
            if (next === CHAR_BACKSLASH) {
              value += advance();
              continue;
            }
            if (next === CHAR_RIGHT_SQUARE_BRACKET) {
              brackets--;
              if (brackets === 0) {
                break;
              }
            }
          }
          push2({ type: "text", value });
          continue;
        }
        if (value === CHAR_LEFT_PARENTHESES) {
          block = push2({ type: "paren", nodes: [] });
          stack.push(block);
          push2({ type: "text", value });
          continue;
        }
        if (value === CHAR_RIGHT_PARENTHESES) {
          if (block.type !== "paren") {
            push2({ type: "text", value });
            continue;
          }
          block = stack.pop();
          push2({ type: "text", value });
          block = stack[stack.length - 1];
          continue;
        }
        if (value === CHAR_DOUBLE_QUOTE || value === CHAR_SINGLE_QUOTE || value === CHAR_BACKTICK) {
          let open = value;
          let next;
          if (options.keepQuotes !== true) {
            value = "";
          }
          while (index < length && (next = advance())) {
            if (next === CHAR_BACKSLASH) {
              value += next + advance();
              continue;
            }
            if (next === open) {
              if (options.keepQuotes === true)
                value += next;
              break;
            }
            value += next;
          }
          push2({ type: "text", value });
          continue;
        }
        if (value === CHAR_LEFT_CURLY_BRACE) {
          depth++;
          let dollar = prev.value && prev.value.slice(-1) === "$" || block.dollar === true;
          let brace = {
            type: "brace",
            open: true,
            close: false,
            dollar,
            depth,
            commas: 0,
            ranges: 0,
            nodes: []
          };
          block = push2(brace);
          stack.push(block);
          push2({ type: "open", value });
          continue;
        }
        if (value === CHAR_RIGHT_CURLY_BRACE) {
          if (block.type !== "brace") {
            push2({ type: "text", value });
            continue;
          }
          let type = "close";
          block = stack.pop();
          block.close = true;
          push2({ type, value });
          depth--;
          block = stack[stack.length - 1];
          continue;
        }
        if (value === CHAR_COMMA && depth > 0) {
          if (block.ranges > 0) {
            block.ranges = 0;
            let open = block.nodes.shift();
            block.nodes = [open, { type: "text", value: stringify(block) }];
          }
          push2({ type: "comma", value });
          block.commas++;
          continue;
        }
        if (value === CHAR_DOT && depth > 0 && block.commas === 0) {
          let siblings = block.nodes;
          if (depth === 0 || siblings.length === 0) {
            push2({ type: "text", value });
            continue;
          }
          if (prev.type === "dot") {
            block.range = [];
            prev.value += value;
            prev.type = "range";
            if (block.nodes.length !== 3 && block.nodes.length !== 5) {
              block.invalid = true;
              block.ranges = 0;
              prev.type = "text";
              continue;
            }
            block.ranges++;
            block.args = [];
            continue;
          }
          if (prev.type === "range") {
            siblings.pop();
            let before = siblings[siblings.length - 1];
            before.value += prev.value + value;
            prev = before;
            block.ranges--;
            continue;
          }
          push2({ type: "dot", value });
          continue;
        }
        push2({ type: "text", value });
      }
      do {
        block = stack.pop();
        if (block.type !== "root") {
          block.nodes.forEach((node) => {
            if (!node.nodes) {
              if (node.type === "open")
                node.isOpen = true;
              if (node.type === "close")
                node.isClose = true;
              if (!node.nodes)
                node.type = "text";
              node.invalid = true;
            }
          });
          let parent = stack[stack.length - 1];
          let index2 = parent.nodes.indexOf(block);
          parent.nodes.splice(index2, 1, ...block.nodes);
        }
      } while (stack.length > 0);
      push2({ type: "eos" });
      return ast;
    };
    module2.exports = parse3;
  }
});

// node_modules/braces/index.js
var require_braces = __commonJS({
  "node_modules/braces/index.js"(exports, module2) {
    "use strict";
    var stringify = require_stringify();
    var compile = require_compile();
    var expand2 = require_expand();
    var parse3 = require_parse();
    var braces = (input, options = {}) => {
      let output = [];
      if (Array.isArray(input)) {
        for (let pattern of input) {
          let result = braces.create(pattern, options);
          if (Array.isArray(result)) {
            output.push(...result);
          } else {
            output.push(result);
          }
        }
      } else {
        output = [].concat(braces.create(input, options));
      }
      if (options && options.expand === true && options.nodupes === true) {
        output = [...new Set(output)];
      }
      return output;
    };
    braces.parse = (input, options = {}) => parse3(input, options);
    braces.stringify = (input, options = {}) => {
      if (typeof input === "string") {
        return stringify(braces.parse(input, options), options);
      }
      return stringify(input, options);
    };
    braces.compile = (input, options = {}) => {
      if (typeof input === "string") {
        input = braces.parse(input, options);
      }
      return compile(input, options);
    };
    braces.expand = (input, options = {}) => {
      if (typeof input === "string") {
        input = braces.parse(input, options);
      }
      let result = expand2(input, options);
      if (options.noempty === true) {
        result = result.filter(Boolean);
      }
      if (options.nodupes === true) {
        result = [...new Set(result)];
      }
      return result;
    };
    braces.create = (input, options = {}) => {
      if (input === "" || input.length < 3) {
        return [input];
      }
      return options.expand !== true ? braces.compile(input, options) : braces.expand(input, options);
    };
    module2.exports = braces;
  }
});

// node_modules/picomatch/lib/constants.js
var require_constants2 = __commonJS({
  "node_modules/picomatch/lib/constants.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var WIN_SLASH = "\\\\/";
    var WIN_NO_SLASH = `[^${WIN_SLASH}]`;
    var DOT_LITERAL = "\\.";
    var PLUS_LITERAL = "\\+";
    var QMARK_LITERAL = "\\?";
    var SLASH_LITERAL = "\\/";
    var ONE_CHAR = "(?=.)";
    var QMARK = "[^/]";
    var END_ANCHOR = `(?:${SLASH_LITERAL}|$)`;
    var START_ANCHOR = `(?:^|${SLASH_LITERAL})`;
    var DOTS_SLASH = `${DOT_LITERAL}{1,2}${END_ANCHOR}`;
    var NO_DOT = `(?!${DOT_LITERAL})`;
    var NO_DOTS = `(?!${START_ANCHOR}${DOTS_SLASH})`;
    var NO_DOT_SLASH = `(?!${DOT_LITERAL}{0,1}${END_ANCHOR})`;
    var NO_DOTS_SLASH = `(?!${DOTS_SLASH})`;
    var QMARK_NO_DOT = `[^.${SLASH_LITERAL}]`;
    var STAR = `${QMARK}*?`;
    var POSIX_CHARS = {
      DOT_LITERAL,
      PLUS_LITERAL,
      QMARK_LITERAL,
      SLASH_LITERAL,
      ONE_CHAR,
      QMARK,
      END_ANCHOR,
      DOTS_SLASH,
      NO_DOT,
      NO_DOTS,
      NO_DOT_SLASH,
      NO_DOTS_SLASH,
      QMARK_NO_DOT,
      STAR,
      START_ANCHOR
    };
    var WINDOWS_CHARS = {
      ...POSIX_CHARS,
      SLASH_LITERAL: `[${WIN_SLASH}]`,
      QMARK: WIN_NO_SLASH,
      STAR: `${WIN_NO_SLASH}*?`,
      DOTS_SLASH: `${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$)`,
      NO_DOT: `(?!${DOT_LITERAL})`,
      NO_DOTS: `(?!(?:^|[${WIN_SLASH}])${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
      NO_DOT_SLASH: `(?!${DOT_LITERAL}{0,1}(?:[${WIN_SLASH}]|$))`,
      NO_DOTS_SLASH: `(?!${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
      QMARK_NO_DOT: `[^.${WIN_SLASH}]`,
      START_ANCHOR: `(?:^|[${WIN_SLASH}])`,
      END_ANCHOR: `(?:[${WIN_SLASH}]|$)`
    };
    var POSIX_REGEX_SOURCE = {
      alnum: "a-zA-Z0-9",
      alpha: "a-zA-Z",
      ascii: "\\x00-\\x7F",
      blank: " \\t",
      cntrl: "\\x00-\\x1F\\x7F",
      digit: "0-9",
      graph: "\\x21-\\x7E",
      lower: "a-z",
      print: "\\x20-\\x7E ",
      punct: "\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",
      space: " \\t\\r\\n\\v\\f",
      upper: "A-Z",
      word: "A-Za-z0-9_",
      xdigit: "A-Fa-f0-9"
    };
    module2.exports = {
      MAX_LENGTH: 1024 * 64,
      POSIX_REGEX_SOURCE,
      REGEX_BACKSLASH: /\\(?![*+?^${}(|)[\]])/g,
      REGEX_NON_SPECIAL_CHARS: /^[^@![\].,$*+?^{}()|\\/]+/,
      REGEX_SPECIAL_CHARS: /[-*+?.^${}(|)[\]]/,
      REGEX_SPECIAL_CHARS_BACKREF: /(\\?)((\W)(\3*))/g,
      REGEX_SPECIAL_CHARS_GLOBAL: /([-*+?.^${}(|)[\]])/g,
      REGEX_REMOVE_BACKSLASH: /(?:\[.*?[^\\]\]|\\(?=.))/g,
      REPLACEMENTS: {
        "***": "*",
        "**/**": "**",
        "**/**/**": "**"
      },
      CHAR_0: 48,
      CHAR_9: 57,
      CHAR_UPPERCASE_A: 65,
      CHAR_LOWERCASE_A: 97,
      CHAR_UPPERCASE_Z: 90,
      CHAR_LOWERCASE_Z: 122,
      CHAR_LEFT_PARENTHESES: 40,
      CHAR_RIGHT_PARENTHESES: 41,
      CHAR_ASTERISK: 42,
      CHAR_AMPERSAND: 38,
      CHAR_AT: 64,
      CHAR_BACKWARD_SLASH: 92,
      CHAR_CARRIAGE_RETURN: 13,
      CHAR_CIRCUMFLEX_ACCENT: 94,
      CHAR_COLON: 58,
      CHAR_COMMA: 44,
      CHAR_DOT: 46,
      CHAR_DOUBLE_QUOTE: 34,
      CHAR_EQUAL: 61,
      CHAR_EXCLAMATION_MARK: 33,
      CHAR_FORM_FEED: 12,
      CHAR_FORWARD_SLASH: 47,
      CHAR_GRAVE_ACCENT: 96,
      CHAR_HASH: 35,
      CHAR_HYPHEN_MINUS: 45,
      CHAR_LEFT_ANGLE_BRACKET: 60,
      CHAR_LEFT_CURLY_BRACE: 123,
      CHAR_LEFT_SQUARE_BRACKET: 91,
      CHAR_LINE_FEED: 10,
      CHAR_NO_BREAK_SPACE: 160,
      CHAR_PERCENT: 37,
      CHAR_PLUS: 43,
      CHAR_QUESTION_MARK: 63,
      CHAR_RIGHT_ANGLE_BRACKET: 62,
      CHAR_RIGHT_CURLY_BRACE: 125,
      CHAR_RIGHT_SQUARE_BRACKET: 93,
      CHAR_SEMICOLON: 59,
      CHAR_SINGLE_QUOTE: 39,
      CHAR_SPACE: 32,
      CHAR_TAB: 9,
      CHAR_UNDERSCORE: 95,
      CHAR_VERTICAL_LINE: 124,
      CHAR_ZERO_WIDTH_NOBREAK_SPACE: 65279,
      SEP: path4.sep,
      extglobChars(chars) {
        return {
          "!": { type: "negate", open: "(?:(?!(?:", close: `))${chars.STAR})` },
          "?": { type: "qmark", open: "(?:", close: ")?" },
          "+": { type: "plus", open: "(?:", close: ")+" },
          "*": { type: "star", open: "(?:", close: ")*" },
          "@": { type: "at", open: "(?:", close: ")" }
        };
      },
      globChars(win32) {
        return win32 === true ? WINDOWS_CHARS : POSIX_CHARS;
      }
    };
  }
});

// node_modules/picomatch/lib/utils.js
var require_utils8 = __commonJS({
  "node_modules/picomatch/lib/utils.js"(exports) {
    "use strict";
    var path4 = require("path");
    var win32 = process.platform === "win32";
    var {
      REGEX_BACKSLASH,
      REGEX_REMOVE_BACKSLASH,
      REGEX_SPECIAL_CHARS,
      REGEX_SPECIAL_CHARS_GLOBAL
    } = require_constants2();
    exports.isObject = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
    exports.hasRegexChars = (str) => REGEX_SPECIAL_CHARS.test(str);
    exports.isRegexChar = (str) => str.length === 1 && exports.hasRegexChars(str);
    exports.escapeRegex = (str) => str.replace(REGEX_SPECIAL_CHARS_GLOBAL, "\\$1");
    exports.toPosixSlashes = (str) => str.replace(REGEX_BACKSLASH, "/");
    exports.removeBackslashes = (str) => {
      return str.replace(REGEX_REMOVE_BACKSLASH, (match) => {
        return match === "\\" ? "" : match;
      });
    };
    exports.supportsLookbehinds = () => {
      const segs = process.version.slice(1).split(".").map(Number);
      if (segs.length === 3 && segs[0] >= 9 || segs[0] === 8 && segs[1] >= 10) {
        return true;
      }
      return false;
    };
    exports.isWindows = (options) => {
      if (options && typeof options.windows === "boolean") {
        return options.windows;
      }
      return win32 === true || path4.sep === "\\";
    };
    exports.escapeLast = (input, char, lastIdx) => {
      const idx = input.lastIndexOf(char, lastIdx);
      if (idx === -1)
        return input;
      if (input[idx - 1] === "\\")
        return exports.escapeLast(input, char, idx - 1);
      return `${input.slice(0, idx)}\\${input.slice(idx)}`;
    };
    exports.removePrefix = (input, state = {}) => {
      let output = input;
      if (output.startsWith("./")) {
        output = output.slice(2);
        state.prefix = "./";
      }
      return output;
    };
    exports.wrapOutput = (input, state = {}, options = {}) => {
      const prepend = options.contains ? "" : "^";
      const append = options.contains ? "" : "$";
      let output = `${prepend}(?:${input})${append}`;
      if (state.negated === true) {
        output = `(?:^(?!${output}).*$)`;
      }
      return output;
    };
  }
});

// node_modules/picomatch/lib/scan.js
var require_scan = __commonJS({
  "node_modules/picomatch/lib/scan.js"(exports, module2) {
    "use strict";
    var utils = require_utils8();
    var {
      CHAR_ASTERISK,
      CHAR_AT,
      CHAR_BACKWARD_SLASH,
      CHAR_COMMA,
      CHAR_DOT,
      CHAR_EXCLAMATION_MARK,
      CHAR_FORWARD_SLASH,
      CHAR_LEFT_CURLY_BRACE,
      CHAR_LEFT_PARENTHESES,
      CHAR_LEFT_SQUARE_BRACKET,
      CHAR_PLUS,
      CHAR_QUESTION_MARK,
      CHAR_RIGHT_CURLY_BRACE,
      CHAR_RIGHT_PARENTHESES,
      CHAR_RIGHT_SQUARE_BRACKET
    } = require_constants2();
    var isPathSeparator = (code) => {
      return code === CHAR_FORWARD_SLASH || code === CHAR_BACKWARD_SLASH;
    };
    var depth = (token) => {
      if (token.isPrefix !== true) {
        token.depth = token.isGlobstar ? Infinity : 1;
      }
    };
    var scan = (input, options) => {
      const opts = options || {};
      const length = input.length - 1;
      const scanToEnd = opts.parts === true || opts.scanToEnd === true;
      const slashes = [];
      const tokens = [];
      const parts = [];
      let str = input;
      let index = -1;
      let start = 0;
      let lastIndex = 0;
      let isBrace = false;
      let isBracket = false;
      let isGlob = false;
      let isExtglob = false;
      let isGlobstar = false;
      let braceEscaped = false;
      let backslashes = false;
      let negated = false;
      let negatedExtglob = false;
      let finished = false;
      let braces = 0;
      let prev;
      let code;
      let token = { value: "", depth: 0, isGlob: false };
      const eos = () => index >= length;
      const peek = () => str.charCodeAt(index + 1);
      const advance = () => {
        prev = code;
        return str.charCodeAt(++index);
      };
      while (index < length) {
        code = advance();
        let next;
        if (code === CHAR_BACKWARD_SLASH) {
          backslashes = token.backslashes = true;
          code = advance();
          if (code === CHAR_LEFT_CURLY_BRACE) {
            braceEscaped = true;
          }
          continue;
        }
        if (braceEscaped === true || code === CHAR_LEFT_CURLY_BRACE) {
          braces++;
          while (eos() !== true && (code = advance())) {
            if (code === CHAR_BACKWARD_SLASH) {
              backslashes = token.backslashes = true;
              advance();
              continue;
            }
            if (code === CHAR_LEFT_CURLY_BRACE) {
              braces++;
              continue;
            }
            if (braceEscaped !== true && code === CHAR_DOT && (code = advance()) === CHAR_DOT) {
              isBrace = token.isBrace = true;
              isGlob = token.isGlob = true;
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (braceEscaped !== true && code === CHAR_COMMA) {
              isBrace = token.isBrace = true;
              isGlob = token.isGlob = true;
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (code === CHAR_RIGHT_CURLY_BRACE) {
              braces--;
              if (braces === 0) {
                braceEscaped = false;
                isBrace = token.isBrace = true;
                finished = true;
                break;
              }
            }
          }
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (code === CHAR_FORWARD_SLASH) {
          slashes.push(index);
          tokens.push(token);
          token = { value: "", depth: 0, isGlob: false };
          if (finished === true)
            continue;
          if (prev === CHAR_DOT && index === start + 1) {
            start += 2;
            continue;
          }
          lastIndex = index + 1;
          continue;
        }
        if (opts.noext !== true) {
          const isExtglobChar = code === CHAR_PLUS || code === CHAR_AT || code === CHAR_ASTERISK || code === CHAR_QUESTION_MARK || code === CHAR_EXCLAMATION_MARK;
          if (isExtglobChar === true && peek() === CHAR_LEFT_PARENTHESES) {
            isGlob = token.isGlob = true;
            isExtglob = token.isExtglob = true;
            finished = true;
            if (code === CHAR_EXCLAMATION_MARK && index === start) {
              negatedExtglob = true;
            }
            if (scanToEnd === true) {
              while (eos() !== true && (code = advance())) {
                if (code === CHAR_BACKWARD_SLASH) {
                  backslashes = token.backslashes = true;
                  code = advance();
                  continue;
                }
                if (code === CHAR_RIGHT_PARENTHESES) {
                  isGlob = token.isGlob = true;
                  finished = true;
                  break;
                }
              }
              continue;
            }
            break;
          }
        }
        if (code === CHAR_ASTERISK) {
          if (prev === CHAR_ASTERISK)
            isGlobstar = token.isGlobstar = true;
          isGlob = token.isGlob = true;
          finished = true;
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (code === CHAR_QUESTION_MARK) {
          isGlob = token.isGlob = true;
          finished = true;
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (code === CHAR_LEFT_SQUARE_BRACKET) {
          while (eos() !== true && (next = advance())) {
            if (next === CHAR_BACKWARD_SLASH) {
              backslashes = token.backslashes = true;
              advance();
              continue;
            }
            if (next === CHAR_RIGHT_SQUARE_BRACKET) {
              isBracket = token.isBracket = true;
              isGlob = token.isGlob = true;
              finished = true;
              break;
            }
          }
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
        if (opts.nonegate !== true && code === CHAR_EXCLAMATION_MARK && index === start) {
          negated = token.negated = true;
          start++;
          continue;
        }
        if (opts.noparen !== true && code === CHAR_LEFT_PARENTHESES) {
          isGlob = token.isGlob = true;
          if (scanToEnd === true) {
            while (eos() !== true && (code = advance())) {
              if (code === CHAR_LEFT_PARENTHESES) {
                backslashes = token.backslashes = true;
                code = advance();
                continue;
              }
              if (code === CHAR_RIGHT_PARENTHESES) {
                finished = true;
                break;
              }
            }
            continue;
          }
          break;
        }
        if (isGlob === true) {
          finished = true;
          if (scanToEnd === true) {
            continue;
          }
          break;
        }
      }
      if (opts.noext === true) {
        isExtglob = false;
        isGlob = false;
      }
      let base = str;
      let prefix2 = "";
      let glob = "";
      if (start > 0) {
        prefix2 = str.slice(0, start);
        str = str.slice(start);
        lastIndex -= start;
      }
      if (base && isGlob === true && lastIndex > 0) {
        base = str.slice(0, lastIndex);
        glob = str.slice(lastIndex);
      } else if (isGlob === true) {
        base = "";
        glob = str;
      } else {
        base = str;
      }
      if (base && base !== "" && base !== "/" && base !== str) {
        if (isPathSeparator(base.charCodeAt(base.length - 1))) {
          base = base.slice(0, -1);
        }
      }
      if (opts.unescape === true) {
        if (glob)
          glob = utils.removeBackslashes(glob);
        if (base && backslashes === true) {
          base = utils.removeBackslashes(base);
        }
      }
      const state = {
        prefix: prefix2,
        input,
        start,
        base,
        glob,
        isBrace,
        isBracket,
        isGlob,
        isExtglob,
        isGlobstar,
        negated,
        negatedExtglob
      };
      if (opts.tokens === true) {
        state.maxDepth = 0;
        if (!isPathSeparator(code)) {
          tokens.push(token);
        }
        state.tokens = tokens;
      }
      if (opts.parts === true || opts.tokens === true) {
        let prevIndex;
        for (let idx = 0; idx < slashes.length; idx++) {
          const n = prevIndex ? prevIndex + 1 : start;
          const i2 = slashes[idx];
          const value = input.slice(n, i2);
          if (opts.tokens) {
            if (idx === 0 && start !== 0) {
              tokens[idx].isPrefix = true;
              tokens[idx].value = prefix2;
            } else {
              tokens[idx].value = value;
            }
            depth(tokens[idx]);
            state.maxDepth += tokens[idx].depth;
          }
          if (idx !== 0 || value !== "") {
            parts.push(value);
          }
          prevIndex = i2;
        }
        if (prevIndex && prevIndex + 1 < input.length) {
          const value = input.slice(prevIndex + 1);
          parts.push(value);
          if (opts.tokens) {
            tokens[tokens.length - 1].value = value;
            depth(tokens[tokens.length - 1]);
            state.maxDepth += tokens[tokens.length - 1].depth;
          }
        }
        state.slashes = slashes;
        state.parts = parts;
      }
      return state;
    };
    module2.exports = scan;
  }
});

// node_modules/picomatch/lib/parse.js
var require_parse2 = __commonJS({
  "node_modules/picomatch/lib/parse.js"(exports, module2) {
    "use strict";
    var constants = require_constants2();
    var utils = require_utils8();
    var {
      MAX_LENGTH,
      POSIX_REGEX_SOURCE,
      REGEX_NON_SPECIAL_CHARS,
      REGEX_SPECIAL_CHARS_BACKREF,
      REPLACEMENTS
    } = constants;
    var expandRange = (args, options) => {
      if (typeof options.expandRange === "function") {
        return options.expandRange(...args, options);
      }
      args.sort();
      const value = `[${args.join("-")}]`;
      try {
        new RegExp(value);
      } catch (ex) {
        return args.map((v) => utils.escapeRegex(v)).join("..");
      }
      return value;
    };
    var syntaxError = (type, char) => {
      return `Missing ${type}: "${char}" - use "\\\\${char}" to match literal characters`;
    };
    var parse3 = (input, options) => {
      if (typeof input !== "string") {
        throw new TypeError("Expected a string");
      }
      input = REPLACEMENTS[input] || input;
      const opts = { ...options };
      const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
      let len = input.length;
      if (len > max) {
        throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
      }
      const bos = { type: "bos", value: "", output: opts.prepend || "" };
      const tokens = [bos];
      const capture = opts.capture ? "" : "?:";
      const win32 = utils.isWindows(options);
      const PLATFORM_CHARS = constants.globChars(win32);
      const EXTGLOB_CHARS = constants.extglobChars(PLATFORM_CHARS);
      const {
        DOT_LITERAL,
        PLUS_LITERAL,
        SLASH_LITERAL,
        ONE_CHAR,
        DOTS_SLASH,
        NO_DOT,
        NO_DOT_SLASH,
        NO_DOTS_SLASH,
        QMARK,
        QMARK_NO_DOT,
        STAR,
        START_ANCHOR
      } = PLATFORM_CHARS;
      const globstar = (opts2) => {
        return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
      };
      const nodot = opts.dot ? "" : NO_DOT;
      const qmarkNoDot = opts.dot ? QMARK : QMARK_NO_DOT;
      let star = opts.bash === true ? globstar(opts) : STAR;
      if (opts.capture) {
        star = `(${star})`;
      }
      if (typeof opts.noext === "boolean") {
        opts.noextglob = opts.noext;
      }
      const state = {
        input,
        index: -1,
        start: 0,
        dot: opts.dot === true,
        consumed: "",
        output: "",
        prefix: "",
        backtrack: false,
        negated: false,
        brackets: 0,
        braces: 0,
        parens: 0,
        quotes: 0,
        globstar: false,
        tokens
      };
      input = utils.removePrefix(input, state);
      len = input.length;
      const extglobs = [];
      const braces = [];
      const stack = [];
      let prev = bos;
      let value;
      const eos = () => state.index === len - 1;
      const peek = state.peek = (n = 1) => input[state.index + n];
      const advance = state.advance = () => input[++state.index] || "";
      const remaining = () => input.slice(state.index + 1);
      const consume = (value2 = "", num = 0) => {
        state.consumed += value2;
        state.index += num;
      };
      const append = (token) => {
        state.output += token.output != null ? token.output : token.value;
        consume(token.value);
      };
      const negate = () => {
        let count = 1;
        while (peek() === "!" && (peek(2) !== "(" || peek(3) === "?")) {
          advance();
          state.start++;
          count++;
        }
        if (count % 2 === 0) {
          return false;
        }
        state.negated = true;
        state.start++;
        return true;
      };
      const increment = (type) => {
        state[type]++;
        stack.push(type);
      };
      const decrement = (type) => {
        state[type]--;
        stack.pop();
      };
      const push2 = (tok) => {
        if (prev.type === "globstar") {
          const isBrace = state.braces > 0 && (tok.type === "comma" || tok.type === "brace");
          const isExtglob = tok.extglob === true || extglobs.length && (tok.type === "pipe" || tok.type === "paren");
          if (tok.type !== "slash" && tok.type !== "paren" && !isBrace && !isExtglob) {
            state.output = state.output.slice(0, -prev.output.length);
            prev.type = "star";
            prev.value = "*";
            prev.output = star;
            state.output += prev.output;
          }
        }
        if (extglobs.length && tok.type !== "paren") {
          extglobs[extglobs.length - 1].inner += tok.value;
        }
        if (tok.value || tok.output)
          append(tok);
        if (prev && prev.type === "text" && tok.type === "text") {
          prev.value += tok.value;
          prev.output = (prev.output || "") + tok.value;
          return;
        }
        tok.prev = prev;
        tokens.push(tok);
        prev = tok;
      };
      const extglobOpen = (type, value2) => {
        const token = { ...EXTGLOB_CHARS[value2], conditions: 1, inner: "" };
        token.prev = prev;
        token.parens = state.parens;
        token.output = state.output;
        const output = (opts.capture ? "(" : "") + token.open;
        increment("parens");
        push2({ type, value: value2, output: state.output ? "" : ONE_CHAR });
        push2({ type: "paren", extglob: true, value: advance(), output });
        extglobs.push(token);
      };
      const extglobClose = (token) => {
        let output = token.close + (opts.capture ? ")" : "");
        let rest;
        if (token.type === "negate") {
          let extglobStar = star;
          if (token.inner && token.inner.length > 1 && token.inner.includes("/")) {
            extglobStar = globstar(opts);
          }
          if (extglobStar !== star || eos() || /^\)+$/.test(remaining())) {
            output = token.close = `)$))${extglobStar}`;
          }
          if (token.inner.includes("*") && (rest = remaining()) && /^\.[^\\/.]+$/.test(rest)) {
            const expression = parse3(rest, { ...options, fastpaths: false }).output;
            output = token.close = `)${expression})${extglobStar})`;
          }
          if (token.prev.type === "bos") {
            state.negatedExtglob = true;
          }
        }
        push2({ type: "paren", extglob: true, value, output });
        decrement("parens");
      };
      if (opts.fastpaths !== false && !/(^[*!]|[/()[\]{}"])/.test(input)) {
        let backslashes = false;
        let output = input.replace(REGEX_SPECIAL_CHARS_BACKREF, (m2, esc, chars, first, rest, index) => {
          if (first === "\\") {
            backslashes = true;
            return m2;
          }
          if (first === "?") {
            if (esc) {
              return esc + first + (rest ? QMARK.repeat(rest.length) : "");
            }
            if (index === 0) {
              return qmarkNoDot + (rest ? QMARK.repeat(rest.length) : "");
            }
            return QMARK.repeat(chars.length);
          }
          if (first === ".") {
            return DOT_LITERAL.repeat(chars.length);
          }
          if (first === "*") {
            if (esc) {
              return esc + first + (rest ? star : "");
            }
            return star;
          }
          return esc ? m2 : `\\${m2}`;
        });
        if (backslashes === true) {
          if (opts.unescape === true) {
            output = output.replace(/\\/g, "");
          } else {
            output = output.replace(/\\+/g, (m2) => {
              return m2.length % 2 === 0 ? "\\\\" : m2 ? "\\" : "";
            });
          }
        }
        if (output === input && opts.contains === true) {
          state.output = input;
          return state;
        }
        state.output = utils.wrapOutput(output, state, options);
        return state;
      }
      while (!eos()) {
        value = advance();
        if (value === "\0") {
          continue;
        }
        if (value === "\\") {
          const next = peek();
          if (next === "/" && opts.bash !== true) {
            continue;
          }
          if (next === "." || next === ";") {
            continue;
          }
          if (!next) {
            value += "\\";
            push2({ type: "text", value });
            continue;
          }
          const match = /^\\+/.exec(remaining());
          let slashes = 0;
          if (match && match[0].length > 2) {
            slashes = match[0].length;
            state.index += slashes;
            if (slashes % 2 !== 0) {
              value += "\\";
            }
          }
          if (opts.unescape === true) {
            value = advance();
          } else {
            value += advance();
          }
          if (state.brackets === 0) {
            push2({ type: "text", value });
            continue;
          }
        }
        if (state.brackets > 0 && (value !== "]" || prev.value === "[" || prev.value === "[^")) {
          if (opts.posix !== false && value === ":") {
            const inner = prev.value.slice(1);
            if (inner.includes("[")) {
              prev.posix = true;
              if (inner.includes(":")) {
                const idx = prev.value.lastIndexOf("[");
                const pre = prev.value.slice(0, idx);
                const rest2 = prev.value.slice(idx + 2);
                const posix = POSIX_REGEX_SOURCE[rest2];
                if (posix) {
                  prev.value = pre + posix;
                  state.backtrack = true;
                  advance();
                  if (!bos.output && tokens.indexOf(prev) === 1) {
                    bos.output = ONE_CHAR;
                  }
                  continue;
                }
              }
            }
          }
          if (value === "[" && peek() !== ":" || value === "-" && peek() === "]") {
            value = `\\${value}`;
          }
          if (value === "]" && (prev.value === "[" || prev.value === "[^")) {
            value = `\\${value}`;
          }
          if (opts.posix === true && value === "!" && prev.value === "[") {
            value = "^";
          }
          prev.value += value;
          append({ value });
          continue;
        }
        if (state.quotes === 1 && value !== '"') {
          value = utils.escapeRegex(value);
          prev.value += value;
          append({ value });
          continue;
        }
        if (value === '"') {
          state.quotes = state.quotes === 1 ? 0 : 1;
          if (opts.keepQuotes === true) {
            push2({ type: "text", value });
          }
          continue;
        }
        if (value === "(") {
          increment("parens");
          push2({ type: "paren", value });
          continue;
        }
        if (value === ")") {
          if (state.parens === 0 && opts.strictBrackets === true) {
            throw new SyntaxError(syntaxError("opening", "("));
          }
          const extglob = extglobs[extglobs.length - 1];
          if (extglob && state.parens === extglob.parens + 1) {
            extglobClose(extglobs.pop());
            continue;
          }
          push2({ type: "paren", value, output: state.parens ? ")" : "\\)" });
          decrement("parens");
          continue;
        }
        if (value === "[") {
          if (opts.nobracket === true || !remaining().includes("]")) {
            if (opts.nobracket !== true && opts.strictBrackets === true) {
              throw new SyntaxError(syntaxError("closing", "]"));
            }
            value = `\\${value}`;
          } else {
            increment("brackets");
          }
          push2({ type: "bracket", value });
          continue;
        }
        if (value === "]") {
          if (opts.nobracket === true || prev && prev.type === "bracket" && prev.value.length === 1) {
            push2({ type: "text", value, output: `\\${value}` });
            continue;
          }
          if (state.brackets === 0) {
            if (opts.strictBrackets === true) {
              throw new SyntaxError(syntaxError("opening", "["));
            }
            push2({ type: "text", value, output: `\\${value}` });
            continue;
          }
          decrement("brackets");
          const prevValue = prev.value.slice(1);
          if (prev.posix !== true && prevValue[0] === "^" && !prevValue.includes("/")) {
            value = `/${value}`;
          }
          prev.value += value;
          append({ value });
          if (opts.literalBrackets === false || utils.hasRegexChars(prevValue)) {
            continue;
          }
          const escaped = utils.escapeRegex(prev.value);
          state.output = state.output.slice(0, -prev.value.length);
          if (opts.literalBrackets === true) {
            state.output += escaped;
            prev.value = escaped;
            continue;
          }
          prev.value = `(${capture}${escaped}|${prev.value})`;
          state.output += prev.value;
          continue;
        }
        if (value === "{" && opts.nobrace !== true) {
          increment("braces");
          const open = {
            type: "brace",
            value,
            output: "(",
            outputIndex: state.output.length,
            tokensIndex: state.tokens.length
          };
          braces.push(open);
          push2(open);
          continue;
        }
        if (value === "}") {
          const brace = braces[braces.length - 1];
          if (opts.nobrace === true || !brace) {
            push2({ type: "text", value, output: value });
            continue;
          }
          let output = ")";
          if (brace.dots === true) {
            const arr = tokens.slice();
            const range = [];
            for (let i2 = arr.length - 1; i2 >= 0; i2--) {
              tokens.pop();
              if (arr[i2].type === "brace") {
                break;
              }
              if (arr[i2].type !== "dots") {
                range.unshift(arr[i2].value);
              }
            }
            output = expandRange(range, opts);
            state.backtrack = true;
          }
          if (brace.comma !== true && brace.dots !== true) {
            const out = state.output.slice(0, brace.outputIndex);
            const toks = state.tokens.slice(brace.tokensIndex);
            brace.value = brace.output = "\\{";
            value = output = "\\}";
            state.output = out;
            for (const t2 of toks) {
              state.output += t2.output || t2.value;
            }
          }
          push2({ type: "brace", value, output });
          decrement("braces");
          braces.pop();
          continue;
        }
        if (value === "|") {
          if (extglobs.length > 0) {
            extglobs[extglobs.length - 1].conditions++;
          }
          push2({ type: "text", value });
          continue;
        }
        if (value === ",") {
          let output = value;
          const brace = braces[braces.length - 1];
          if (brace && stack[stack.length - 1] === "braces") {
            brace.comma = true;
            output = "|";
          }
          push2({ type: "comma", value, output });
          continue;
        }
        if (value === "/") {
          if (prev.type === "dot" && state.index === state.start + 1) {
            state.start = state.index + 1;
            state.consumed = "";
            state.output = "";
            tokens.pop();
            prev = bos;
            continue;
          }
          push2({ type: "slash", value, output: SLASH_LITERAL });
          continue;
        }
        if (value === ".") {
          if (state.braces > 0 && prev.type === "dot") {
            if (prev.value === ".")
              prev.output = DOT_LITERAL;
            const brace = braces[braces.length - 1];
            prev.type = "dots";
            prev.output += value;
            prev.value += value;
            brace.dots = true;
            continue;
          }
          if (state.braces + state.parens === 0 && prev.type !== "bos" && prev.type !== "slash") {
            push2({ type: "text", value, output: DOT_LITERAL });
            continue;
          }
          push2({ type: "dot", value, output: DOT_LITERAL });
          continue;
        }
        if (value === "?") {
          const isGroup = prev && prev.value === "(";
          if (!isGroup && opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
            extglobOpen("qmark", value);
            continue;
          }
          if (prev && prev.type === "paren") {
            const next = peek();
            let output = value;
            if (next === "<" && !utils.supportsLookbehinds()) {
              throw new Error("Node.js v10 or higher is required for regex lookbehinds");
            }
            if (prev.value === "(" && !/[!=<:]/.test(next) || next === "<" && !/<([!=]|\w+>)/.test(remaining())) {
              output = `\\${value}`;
            }
            push2({ type: "text", value, output });
            continue;
          }
          if (opts.dot !== true && (prev.type === "slash" || prev.type === "bos")) {
            push2({ type: "qmark", value, output: QMARK_NO_DOT });
            continue;
          }
          push2({ type: "qmark", value, output: QMARK });
          continue;
        }
        if (value === "!") {
          if (opts.noextglob !== true && peek() === "(") {
            if (peek(2) !== "?" || !/[!=<:]/.test(peek(3))) {
              extglobOpen("negate", value);
              continue;
            }
          }
          if (opts.nonegate !== true && state.index === 0) {
            negate();
            continue;
          }
        }
        if (value === "+") {
          if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
            extglobOpen("plus", value);
            continue;
          }
          if (prev && prev.value === "(" || opts.regex === false) {
            push2({ type: "plus", value, output: PLUS_LITERAL });
            continue;
          }
          if (prev && (prev.type === "bracket" || prev.type === "paren" || prev.type === "brace") || state.parens > 0) {
            push2({ type: "plus", value });
            continue;
          }
          push2({ type: "plus", value: PLUS_LITERAL });
          continue;
        }
        if (value === "@") {
          if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
            push2({ type: "at", extglob: true, value, output: "" });
            continue;
          }
          push2({ type: "text", value });
          continue;
        }
        if (value !== "*") {
          if (value === "$" || value === "^") {
            value = `\\${value}`;
          }
          const match = REGEX_NON_SPECIAL_CHARS.exec(remaining());
          if (match) {
            value += match[0];
            state.index += match[0].length;
          }
          push2({ type: "text", value });
          continue;
        }
        if (prev && (prev.type === "globstar" || prev.star === true)) {
          prev.type = "star";
          prev.star = true;
          prev.value += value;
          prev.output = star;
          state.backtrack = true;
          state.globstar = true;
          consume(value);
          continue;
        }
        let rest = remaining();
        if (opts.noextglob !== true && /^\([^?]/.test(rest)) {
          extglobOpen("star", value);
          continue;
        }
        if (prev.type === "star") {
          if (opts.noglobstar === true) {
            consume(value);
            continue;
          }
          const prior = prev.prev;
          const before = prior.prev;
          const isStart = prior.type === "slash" || prior.type === "bos";
          const afterStar = before && (before.type === "star" || before.type === "globstar");
          if (opts.bash === true && (!isStart || rest[0] && rest[0] !== "/")) {
            push2({ type: "star", value, output: "" });
            continue;
          }
          const isBrace = state.braces > 0 && (prior.type === "comma" || prior.type === "brace");
          const isExtglob = extglobs.length && (prior.type === "pipe" || prior.type === "paren");
          if (!isStart && prior.type !== "paren" && !isBrace && !isExtglob) {
            push2({ type: "star", value, output: "" });
            continue;
          }
          while (rest.slice(0, 3) === "/**") {
            const after = input[state.index + 4];
            if (after && after !== "/") {
              break;
            }
            rest = rest.slice(3);
            consume("/**", 3);
          }
          if (prior.type === "bos" && eos()) {
            prev.type = "globstar";
            prev.value += value;
            prev.output = globstar(opts);
            state.output = prev.output;
            state.globstar = true;
            consume(value);
            continue;
          }
          if (prior.type === "slash" && prior.prev.type !== "bos" && !afterStar && eos()) {
            state.output = state.output.slice(0, -(prior.output + prev.output).length);
            prior.output = `(?:${prior.output}`;
            prev.type = "globstar";
            prev.output = globstar(opts) + (opts.strictSlashes ? ")" : "|$)");
            prev.value += value;
            state.globstar = true;
            state.output += prior.output + prev.output;
            consume(value);
            continue;
          }
          if (prior.type === "slash" && prior.prev.type !== "bos" && rest[0] === "/") {
            const end = rest[1] !== void 0 ? "|$" : "";
            state.output = state.output.slice(0, -(prior.output + prev.output).length);
            prior.output = `(?:${prior.output}`;
            prev.type = "globstar";
            prev.output = `${globstar(opts)}${SLASH_LITERAL}|${SLASH_LITERAL}${end})`;
            prev.value += value;
            state.output += prior.output + prev.output;
            state.globstar = true;
            consume(value + advance());
            push2({ type: "slash", value: "/", output: "" });
            continue;
          }
          if (prior.type === "bos" && rest[0] === "/") {
            prev.type = "globstar";
            prev.value += value;
            prev.output = `(?:^|${SLASH_LITERAL}|${globstar(opts)}${SLASH_LITERAL})`;
            state.output = prev.output;
            state.globstar = true;
            consume(value + advance());
            push2({ type: "slash", value: "/", output: "" });
            continue;
          }
          state.output = state.output.slice(0, -prev.output.length);
          prev.type = "globstar";
          prev.output = globstar(opts);
          prev.value += value;
          state.output += prev.output;
          state.globstar = true;
          consume(value);
          continue;
        }
        const token = { type: "star", value, output: star };
        if (opts.bash === true) {
          token.output = ".*?";
          if (prev.type === "bos" || prev.type === "slash") {
            token.output = nodot + token.output;
          }
          push2(token);
          continue;
        }
        if (prev && (prev.type === "bracket" || prev.type === "paren") && opts.regex === true) {
          token.output = value;
          push2(token);
          continue;
        }
        if (state.index === state.start || prev.type === "slash" || prev.type === "dot") {
          if (prev.type === "dot") {
            state.output += NO_DOT_SLASH;
            prev.output += NO_DOT_SLASH;
          } else if (opts.dot === true) {
            state.output += NO_DOTS_SLASH;
            prev.output += NO_DOTS_SLASH;
          } else {
            state.output += nodot;
            prev.output += nodot;
          }
          if (peek() !== "*") {
            state.output += ONE_CHAR;
            prev.output += ONE_CHAR;
          }
        }
        push2(token);
      }
      while (state.brackets > 0) {
        if (opts.strictBrackets === true)
          throw new SyntaxError(syntaxError("closing", "]"));
        state.output = utils.escapeLast(state.output, "[");
        decrement("brackets");
      }
      while (state.parens > 0) {
        if (opts.strictBrackets === true)
          throw new SyntaxError(syntaxError("closing", ")"));
        state.output = utils.escapeLast(state.output, "(");
        decrement("parens");
      }
      while (state.braces > 0) {
        if (opts.strictBrackets === true)
          throw new SyntaxError(syntaxError("closing", "}"));
        state.output = utils.escapeLast(state.output, "{");
        decrement("braces");
      }
      if (opts.strictSlashes !== true && (prev.type === "star" || prev.type === "bracket")) {
        push2({ type: "maybe_slash", value: "", output: `${SLASH_LITERAL}?` });
      }
      if (state.backtrack === true) {
        state.output = "";
        for (const token of state.tokens) {
          state.output += token.output != null ? token.output : token.value;
          if (token.suffix) {
            state.output += token.suffix;
          }
        }
      }
      return state;
    };
    parse3.fastpaths = (input, options) => {
      const opts = { ...options };
      const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
      const len = input.length;
      if (len > max) {
        throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
      }
      input = REPLACEMENTS[input] || input;
      const win32 = utils.isWindows(options);
      const {
        DOT_LITERAL,
        SLASH_LITERAL,
        ONE_CHAR,
        DOTS_SLASH,
        NO_DOT,
        NO_DOTS,
        NO_DOTS_SLASH,
        STAR,
        START_ANCHOR
      } = constants.globChars(win32);
      const nodot = opts.dot ? NO_DOTS : NO_DOT;
      const slashDot = opts.dot ? NO_DOTS_SLASH : NO_DOT;
      const capture = opts.capture ? "" : "?:";
      const state = { negated: false, prefix: "" };
      let star = opts.bash === true ? ".*?" : STAR;
      if (opts.capture) {
        star = `(${star})`;
      }
      const globstar = (opts2) => {
        if (opts2.noglobstar === true)
          return star;
        return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
      };
      const create = (str) => {
        switch (str) {
          case "*":
            return `${nodot}${ONE_CHAR}${star}`;
          case ".*":
            return `${DOT_LITERAL}${ONE_CHAR}${star}`;
          case "*.*":
            return `${nodot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
          case "*/*":
            return `${nodot}${star}${SLASH_LITERAL}${ONE_CHAR}${slashDot}${star}`;
          case "**":
            return nodot + globstar(opts);
          case "**/*":
            return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${ONE_CHAR}${star}`;
          case "**/*.*":
            return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
          case "**/.*":
            return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${DOT_LITERAL}${ONE_CHAR}${star}`;
          default: {
            const match = /^(.*?)\.(\w+)$/.exec(str);
            if (!match)
              return;
            const source2 = create(match[1]);
            if (!source2)
              return;
            return source2 + DOT_LITERAL + match[2];
          }
        }
      };
      const output = utils.removePrefix(input, state);
      let source = create(output);
      if (source && opts.strictSlashes !== true) {
        source += `${SLASH_LITERAL}?`;
      }
      return source;
    };
    module2.exports = parse3;
  }
});

// node_modules/picomatch/lib/picomatch.js
var require_picomatch = __commonJS({
  "node_modules/picomatch/lib/picomatch.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var scan = require_scan();
    var parse3 = require_parse2();
    var utils = require_utils8();
    var constants = require_constants2();
    var isObject3 = (val) => val && typeof val === "object" && !Array.isArray(val);
    var picomatch = (glob, options, returnState = false) => {
      if (Array.isArray(glob)) {
        const fns = glob.map((input) => picomatch(input, options, returnState));
        const arrayMatcher = (str) => {
          for (const isMatch of fns) {
            const state2 = isMatch(str);
            if (state2)
              return state2;
          }
          return false;
        };
        return arrayMatcher;
      }
      const isState = isObject3(glob) && glob.tokens && glob.input;
      if (glob === "" || typeof glob !== "string" && !isState) {
        throw new TypeError("Expected pattern to be a non-empty string");
      }
      const opts = options || {};
      const posix = utils.isWindows(options);
      const regex = isState ? picomatch.compileRe(glob, options) : picomatch.makeRe(glob, options, false, true);
      const state = regex.state;
      delete regex.state;
      let isIgnored = () => false;
      if (opts.ignore) {
        const ignoreOpts = { ...options, ignore: null, onMatch: null, onResult: null };
        isIgnored = picomatch(opts.ignore, ignoreOpts, returnState);
      }
      const matcher = (input, returnObject = false) => {
        const { isMatch, match, output } = picomatch.test(input, regex, options, { glob, posix });
        const result = { glob, state, regex, posix, input, output, match, isMatch };
        if (typeof opts.onResult === "function") {
          opts.onResult(result);
        }
        if (isMatch === false) {
          result.isMatch = false;
          return returnObject ? result : false;
        }
        if (isIgnored(input)) {
          if (typeof opts.onIgnore === "function") {
            opts.onIgnore(result);
          }
          result.isMatch = false;
          return returnObject ? result : false;
        }
        if (typeof opts.onMatch === "function") {
          opts.onMatch(result);
        }
        return returnObject ? result : true;
      };
      if (returnState) {
        matcher.state = state;
      }
      return matcher;
    };
    picomatch.test = (input, regex, options, { glob, posix } = {}) => {
      if (typeof input !== "string") {
        throw new TypeError("Expected input to be a string");
      }
      if (input === "") {
        return { isMatch: false, output: "" };
      }
      const opts = options || {};
      const format2 = opts.format || (posix ? utils.toPosixSlashes : null);
      let match = input === glob;
      let output = match && format2 ? format2(input) : input;
      if (match === false) {
        output = format2 ? format2(input) : input;
        match = output === glob;
      }
      if (match === false || opts.capture === true) {
        if (opts.matchBase === true || opts.basename === true) {
          match = picomatch.matchBase(input, regex, options, posix);
        } else {
          match = regex.exec(output);
        }
      }
      return { isMatch: Boolean(match), match, output };
    };
    picomatch.matchBase = (input, glob, options, posix = utils.isWindows(options)) => {
      const regex = glob instanceof RegExp ? glob : picomatch.makeRe(glob, options);
      return regex.test(path4.basename(input));
    };
    picomatch.isMatch = (str, patterns, options) => picomatch(patterns, options)(str);
    picomatch.parse = (pattern, options) => {
      if (Array.isArray(pattern))
        return pattern.map((p) => picomatch.parse(p, options));
      return parse3(pattern, { ...options, fastpaths: false });
    };
    picomatch.scan = (input, options) => scan(input, options);
    picomatch.compileRe = (state, options, returnOutput = false, returnState = false) => {
      if (returnOutput === true) {
        return state.output;
      }
      const opts = options || {};
      const prepend = opts.contains ? "" : "^";
      const append = opts.contains ? "" : "$";
      let source = `${prepend}(?:${state.output})${append}`;
      if (state && state.negated === true) {
        source = `^(?!${source}).*$`;
      }
      const regex = picomatch.toRegex(source, options);
      if (returnState === true) {
        regex.state = state;
      }
      return regex;
    };
    picomatch.makeRe = (input, options = {}, returnOutput = false, returnState = false) => {
      if (!input || typeof input !== "string") {
        throw new TypeError("Expected a non-empty string");
      }
      let parsed = { negated: false, fastpaths: true };
      if (options.fastpaths !== false && (input[0] === "." || input[0] === "*")) {
        parsed.output = parse3.fastpaths(input, options);
      }
      if (!parsed.output) {
        parsed = parse3(input, options);
      }
      return picomatch.compileRe(parsed, options, returnOutput, returnState);
    };
    picomatch.toRegex = (source, options) => {
      try {
        const opts = options || {};
        return new RegExp(source, opts.flags || (opts.nocase ? "i" : ""));
      } catch (err) {
        if (options && options.debug === true)
          throw err;
        return /$^/;
      }
    };
    picomatch.constants = constants;
    module2.exports = picomatch;
  }
});

// node_modules/picomatch/index.js
var require_picomatch2 = __commonJS({
  "node_modules/picomatch/index.js"(exports, module2) {
    "use strict";
    module2.exports = require_picomatch();
  }
});

// node_modules/micromatch/index.js
var require_micromatch = __commonJS({
  "node_modules/micromatch/index.js"(exports, module2) {
    "use strict";
    var util2 = require("util");
    var braces = require_braces();
    var picomatch = require_picomatch2();
    var utils = require_utils8();
    var isEmptyString = (val) => val === "" || val === "./";
    var micromatch2 = (list, patterns, options) => {
      patterns = [].concat(patterns);
      list = [].concat(list);
      let omit2 = /* @__PURE__ */ new Set();
      let keep = /* @__PURE__ */ new Set();
      let items = /* @__PURE__ */ new Set();
      let negatives = 0;
      let onResult = (state) => {
        items.add(state.output);
        if (options && options.onResult) {
          options.onResult(state);
        }
      };
      for (let i2 = 0; i2 < patterns.length; i2++) {
        let isMatch = picomatch(String(patterns[i2]), { ...options, onResult }, true);
        let negated = isMatch.state.negated || isMatch.state.negatedExtglob;
        if (negated)
          negatives++;
        for (let item of list) {
          let matched = isMatch(item, true);
          let match = negated ? !matched.isMatch : matched.isMatch;
          if (!match)
            continue;
          if (negated) {
            omit2.add(matched.output);
          } else {
            omit2.delete(matched.output);
            keep.add(matched.output);
          }
        }
      }
      let result = negatives === patterns.length ? [...items] : [...keep];
      let matches = result.filter((item) => !omit2.has(item));
      if (options && matches.length === 0) {
        if (options.failglob === true) {
          throw new Error(`No matches found for "${patterns.join(", ")}"`);
        }
        if (options.nonull === true || options.nullglob === true) {
          return options.unescape ? patterns.map((p) => p.replace(/\\/g, "")) : patterns;
        }
      }
      return matches;
    };
    micromatch2.match = micromatch2;
    micromatch2.matcher = (pattern, options) => picomatch(pattern, options);
    micromatch2.isMatch = (str, patterns, options) => picomatch(patterns, options)(str);
    micromatch2.any = micromatch2.isMatch;
    micromatch2.not = (list, patterns, options = {}) => {
      patterns = [].concat(patterns).map(String);
      let result = /* @__PURE__ */ new Set();
      let items = [];
      let onResult = (state) => {
        if (options.onResult)
          options.onResult(state);
        items.push(state.output);
      };
      let matches = new Set(micromatch2(list, patterns, { ...options, onResult }));
      for (let item of items) {
        if (!matches.has(item)) {
          result.add(item);
        }
      }
      return [...result];
    };
    micromatch2.contains = (str, pattern, options) => {
      if (typeof str !== "string") {
        throw new TypeError(`Expected a string: "${util2.inspect(str)}"`);
      }
      if (Array.isArray(pattern)) {
        return pattern.some((p) => micromatch2.contains(str, p, options));
      }
      if (typeof pattern === "string") {
        if (isEmptyString(str) || isEmptyString(pattern)) {
          return false;
        }
        if (str.includes(pattern) || str.startsWith("./") && str.slice(2).includes(pattern)) {
          return true;
        }
      }
      return micromatch2.isMatch(str, pattern, { ...options, contains: true });
    };
    micromatch2.matchKeys = (obj, patterns, options) => {
      if (!utils.isObject(obj)) {
        throw new TypeError("Expected the first argument to be an object");
      }
      let keys = micromatch2(Object.keys(obj), patterns, options);
      let res = {};
      for (let key of keys)
        res[key] = obj[key];
      return res;
    };
    micromatch2.some = (list, patterns, options) => {
      let items = [].concat(list);
      for (let pattern of [].concat(patterns)) {
        let isMatch = picomatch(String(pattern), options);
        if (items.some((item) => isMatch(item))) {
          return true;
        }
      }
      return false;
    };
    micromatch2.every = (list, patterns, options) => {
      let items = [].concat(list);
      for (let pattern of [].concat(patterns)) {
        let isMatch = picomatch(String(pattern), options);
        if (!items.every((item) => isMatch(item))) {
          return false;
        }
      }
      return true;
    };
    micromatch2.all = (str, patterns, options) => {
      if (typeof str !== "string") {
        throw new TypeError(`Expected a string: "${util2.inspect(str)}"`);
      }
      return [].concat(patterns).every((p) => picomatch(p, options)(str));
    };
    micromatch2.capture = (glob, input, options) => {
      let posix = utils.isWindows(options);
      let regex = picomatch.makeRe(String(glob), { ...options, capture: true });
      let match = regex.exec(posix ? utils.toPosixSlashes(input) : input);
      if (match) {
        return match.slice(1).map((v) => v === void 0 ? "" : v);
      }
    };
    micromatch2.makeRe = (...args) => picomatch.makeRe(...args);
    micromatch2.scan = (...args) => picomatch.scan(...args);
    micromatch2.parse = (patterns, options) => {
      let res = [];
      for (let pattern of [].concat(patterns || [])) {
        for (let str of braces(String(pattern), options)) {
          res.push(picomatch.parse(str, options));
        }
      }
      return res;
    };
    micromatch2.braces = (pattern, options) => {
      if (typeof pattern !== "string")
        throw new TypeError("Expected a string");
      if (options && options.nobrace === true || !/\{.*\}/.test(pattern)) {
        return [pattern];
      }
      return braces(pattern, options);
    };
    micromatch2.braceExpand = (pattern, options) => {
      if (typeof pattern !== "string")
        throw new TypeError("Expected a string");
      return micromatch2.braces(pattern, { ...options, expand: true });
    };
    module2.exports = micromatch2;
  }
});

// node_modules/fast-glob/out/utils/pattern.js
var require_pattern = __commonJS({
  "node_modules/fast-glob/out/utils/pattern.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.matchAny = exports.convertPatternsToRe = exports.makeRe = exports.getPatternParts = exports.expandBraceExpansion = exports.expandPatternsWithBraceExpansion = exports.isAffectDepthOfReadingPattern = exports.endsWithSlashGlobStar = exports.hasGlobStar = exports.getBaseDirectory = exports.isPatternRelatedToParentDirectory = exports.getPatternsOutsideCurrentDirectory = exports.getPatternsInsideCurrentDirectory = exports.getPositivePatterns = exports.getNegativePatterns = exports.isPositivePattern = exports.isNegativePattern = exports.convertToNegativePattern = exports.convertToPositivePattern = exports.isDynamicPattern = exports.isStaticPattern = void 0;
    var path4 = require("path");
    var globParent = require_glob_parent();
    var micromatch2 = require_micromatch();
    var GLOBSTAR = "**";
    var ESCAPE_SYMBOL = "\\";
    var COMMON_GLOB_SYMBOLS_RE = /[*?]|^!/;
    var REGEX_CHARACTER_CLASS_SYMBOLS_RE = /\[[^[]*]/;
    var REGEX_GROUP_SYMBOLS_RE = /(?:^|[^!*+?@])\([^(]*\|[^|]*\)/;
    var GLOB_EXTENSION_SYMBOLS_RE = /[!*+?@]\([^(]*\)/;
    var BRACE_EXPANSION_SEPARATORS_RE = /,|\.\./;
    function isStaticPattern(pattern, options = {}) {
      return !isDynamicPattern(pattern, options);
    }
    exports.isStaticPattern = isStaticPattern;
    function isDynamicPattern(pattern, options = {}) {
      if (pattern === "") {
        return false;
      }
      if (options.caseSensitiveMatch === false || pattern.includes(ESCAPE_SYMBOL)) {
        return true;
      }
      if (COMMON_GLOB_SYMBOLS_RE.test(pattern) || REGEX_CHARACTER_CLASS_SYMBOLS_RE.test(pattern) || REGEX_GROUP_SYMBOLS_RE.test(pattern)) {
        return true;
      }
      if (options.extglob !== false && GLOB_EXTENSION_SYMBOLS_RE.test(pattern)) {
        return true;
      }
      if (options.braceExpansion !== false && hasBraceExpansion(pattern)) {
        return true;
      }
      return false;
    }
    exports.isDynamicPattern = isDynamicPattern;
    function hasBraceExpansion(pattern) {
      const openingBraceIndex = pattern.indexOf("{");
      if (openingBraceIndex === -1) {
        return false;
      }
      const closingBraceIndex = pattern.indexOf("}", openingBraceIndex + 1);
      if (closingBraceIndex === -1) {
        return false;
      }
      const braceContent = pattern.slice(openingBraceIndex, closingBraceIndex);
      return BRACE_EXPANSION_SEPARATORS_RE.test(braceContent);
    }
    function convertToPositivePattern(pattern) {
      return isNegativePattern(pattern) ? pattern.slice(1) : pattern;
    }
    exports.convertToPositivePattern = convertToPositivePattern;
    function convertToNegativePattern(pattern) {
      return "!" + pattern;
    }
    exports.convertToNegativePattern = convertToNegativePattern;
    function isNegativePattern(pattern) {
      return pattern.startsWith("!") && pattern[1] !== "(";
    }
    exports.isNegativePattern = isNegativePattern;
    function isPositivePattern(pattern) {
      return !isNegativePattern(pattern);
    }
    exports.isPositivePattern = isPositivePattern;
    function getNegativePatterns(patterns) {
      return patterns.filter(isNegativePattern);
    }
    exports.getNegativePatterns = getNegativePatterns;
    function getPositivePatterns(patterns) {
      return patterns.filter(isPositivePattern);
    }
    exports.getPositivePatterns = getPositivePatterns;
    function getPatternsInsideCurrentDirectory(patterns) {
      return patterns.filter((pattern) => !isPatternRelatedToParentDirectory(pattern));
    }
    exports.getPatternsInsideCurrentDirectory = getPatternsInsideCurrentDirectory;
    function getPatternsOutsideCurrentDirectory(patterns) {
      return patterns.filter(isPatternRelatedToParentDirectory);
    }
    exports.getPatternsOutsideCurrentDirectory = getPatternsOutsideCurrentDirectory;
    function isPatternRelatedToParentDirectory(pattern) {
      return pattern.startsWith("..") || pattern.startsWith("./..");
    }
    exports.isPatternRelatedToParentDirectory = isPatternRelatedToParentDirectory;
    function getBaseDirectory(pattern) {
      return globParent(pattern, { flipBackslashes: false });
    }
    exports.getBaseDirectory = getBaseDirectory;
    function hasGlobStar(pattern) {
      return pattern.includes(GLOBSTAR);
    }
    exports.hasGlobStar = hasGlobStar;
    function endsWithSlashGlobStar(pattern) {
      return pattern.endsWith("/" + GLOBSTAR);
    }
    exports.endsWithSlashGlobStar = endsWithSlashGlobStar;
    function isAffectDepthOfReadingPattern(pattern) {
      const basename2 = path4.basename(pattern);
      return endsWithSlashGlobStar(pattern) || isStaticPattern(basename2);
    }
    exports.isAffectDepthOfReadingPattern = isAffectDepthOfReadingPattern;
    function expandPatternsWithBraceExpansion(patterns) {
      return patterns.reduce((collection, pattern) => {
        return collection.concat(expandBraceExpansion(pattern));
      }, []);
    }
    exports.expandPatternsWithBraceExpansion = expandPatternsWithBraceExpansion;
    function expandBraceExpansion(pattern) {
      return micromatch2.braces(pattern, {
        expand: true,
        nodupes: true
      });
    }
    exports.expandBraceExpansion = expandBraceExpansion;
    function getPatternParts(pattern, options) {
      let { parts } = micromatch2.scan(pattern, Object.assign(Object.assign({}, options), { parts: true }));
      if (parts.length === 0) {
        parts = [pattern];
      }
      if (parts[0].startsWith("/")) {
        parts[0] = parts[0].slice(1);
        parts.unshift("");
      }
      return parts;
    }
    exports.getPatternParts = getPatternParts;
    function makeRe(pattern, options) {
      return micromatch2.makeRe(pattern, options);
    }
    exports.makeRe = makeRe;
    function convertPatternsToRe(patterns, options) {
      return patterns.map((pattern) => makeRe(pattern, options));
    }
    exports.convertPatternsToRe = convertPatternsToRe;
    function matchAny(entry, patternsRe) {
      return patternsRe.some((patternRe) => patternRe.test(entry));
    }
    exports.matchAny = matchAny;
  }
});

// node_modules/fast-glob/out/utils/stream.js
var require_stream = __commonJS({
  "node_modules/fast-glob/out/utils/stream.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.merge = void 0;
    var merge2 = require_merge2();
    function merge3(streams) {
      const mergedStream = merge2(streams);
      streams.forEach((stream) => {
        stream.once("error", (error) => mergedStream.emit("error", error));
      });
      mergedStream.once("close", () => propagateCloseEventToSources(streams));
      mergedStream.once("end", () => propagateCloseEventToSources(streams));
      return mergedStream;
    }
    exports.merge = merge3;
    function propagateCloseEventToSources(streams) {
      streams.forEach((stream) => stream.emit("close"));
    }
  }
});

// node_modules/fast-glob/out/utils/string.js
var require_string = __commonJS({
  "node_modules/fast-glob/out/utils/string.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.isEmpty = exports.isString = void 0;
    function isString(input) {
      return typeof input === "string";
    }
    exports.isString = isString;
    function isEmpty(input) {
      return input === "";
    }
    exports.isEmpty = isEmpty;
  }
});

// node_modules/fast-glob/out/utils/index.js
var require_utils9 = __commonJS({
  "node_modules/fast-glob/out/utils/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.string = exports.stream = exports.pattern = exports.path = exports.fs = exports.errno = exports.array = void 0;
    var array = require_array();
    exports.array = array;
    var errno = require_errno();
    exports.errno = errno;
    var fs4 = require_fs3();
    exports.fs = fs4;
    var path4 = require_path();
    exports.path = path4;
    var pattern = require_pattern();
    exports.pattern = pattern;
    var stream = require_stream();
    exports.stream = stream;
    var string = require_string();
    exports.string = string;
  }
});

// node_modules/fast-glob/out/managers/tasks.js
var require_tasks = __commonJS({
  "node_modules/fast-glob/out/managers/tasks.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.convertPatternGroupToTask = exports.convertPatternGroupsToTasks = exports.groupPatternsByBaseDirectory = exports.getNegativePatternsAsPositive = exports.getPositivePatterns = exports.convertPatternsToTasks = exports.generate = void 0;
    var utils = require_utils9();
    function generate(patterns, settings) {
      const positivePatterns = getPositivePatterns(patterns);
      const negativePatterns = getNegativePatternsAsPositive(patterns, settings.ignore);
      const staticPatterns = positivePatterns.filter((pattern) => utils.pattern.isStaticPattern(pattern, settings));
      const dynamicPatterns = positivePatterns.filter((pattern) => utils.pattern.isDynamicPattern(pattern, settings));
      const staticTasks = convertPatternsToTasks(staticPatterns, negativePatterns, false);
      const dynamicTasks = convertPatternsToTasks(dynamicPatterns, negativePatterns, true);
      return staticTasks.concat(dynamicTasks);
    }
    exports.generate = generate;
    function convertPatternsToTasks(positive, negative, dynamic) {
      const tasks = [];
      const patternsOutsideCurrentDirectory = utils.pattern.getPatternsOutsideCurrentDirectory(positive);
      const patternsInsideCurrentDirectory = utils.pattern.getPatternsInsideCurrentDirectory(positive);
      const outsideCurrentDirectoryGroup = groupPatternsByBaseDirectory(patternsOutsideCurrentDirectory);
      const insideCurrentDirectoryGroup = groupPatternsByBaseDirectory(patternsInsideCurrentDirectory);
      tasks.push(...convertPatternGroupsToTasks(outsideCurrentDirectoryGroup, negative, dynamic));
      if ("." in insideCurrentDirectoryGroup) {
        tasks.push(convertPatternGroupToTask(".", patternsInsideCurrentDirectory, negative, dynamic));
      } else {
        tasks.push(...convertPatternGroupsToTasks(insideCurrentDirectoryGroup, negative, dynamic));
      }
      return tasks;
    }
    exports.convertPatternsToTasks = convertPatternsToTasks;
    function getPositivePatterns(patterns) {
      return utils.pattern.getPositivePatterns(patterns);
    }
    exports.getPositivePatterns = getPositivePatterns;
    function getNegativePatternsAsPositive(patterns, ignore) {
      const negative = utils.pattern.getNegativePatterns(patterns).concat(ignore);
      const positive = negative.map(utils.pattern.convertToPositivePattern);
      return positive;
    }
    exports.getNegativePatternsAsPositive = getNegativePatternsAsPositive;
    function groupPatternsByBaseDirectory(patterns) {
      const group = {};
      return patterns.reduce((collection, pattern) => {
        const base = utils.pattern.getBaseDirectory(pattern);
        if (base in collection) {
          collection[base].push(pattern);
        } else {
          collection[base] = [pattern];
        }
        return collection;
      }, group);
    }
    exports.groupPatternsByBaseDirectory = groupPatternsByBaseDirectory;
    function convertPatternGroupsToTasks(positive, negative, dynamic) {
      return Object.keys(positive).map((base) => {
        return convertPatternGroupToTask(base, positive[base], negative, dynamic);
      });
    }
    exports.convertPatternGroupsToTasks = convertPatternGroupsToTasks;
    function convertPatternGroupToTask(base, positive, negative, dynamic) {
      return {
        dynamic,
        positive,
        negative,
        base,
        patterns: [].concat(positive, negative.map(utils.pattern.convertToNegativePattern))
      };
    }
    exports.convertPatternGroupToTask = convertPatternGroupToTask;
  }
});

// node_modules/fast-glob/out/managers/patterns.js
var require_patterns = __commonJS({
  "node_modules/fast-glob/out/managers/patterns.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.removeDuplicateSlashes = exports.transform = void 0;
    var DOUBLE_SLASH_RE = /(?!^)\/{2,}/g;
    function transform(patterns) {
      return patterns.map((pattern) => removeDuplicateSlashes(pattern));
    }
    exports.transform = transform;
    function removeDuplicateSlashes(pattern) {
      return pattern.replace(DOUBLE_SLASH_RE, "/");
    }
    exports.removeDuplicateSlashes = removeDuplicateSlashes;
  }
});

// node_modules/@nodelib/fs.stat/out/providers/async.js
var require_async = __commonJS({
  "node_modules/@nodelib/fs.stat/out/providers/async.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function read2(path4, settings, callback) {
      settings.fs.lstat(path4, (lstatError, lstat) => {
        if (lstatError !== null) {
          return callFailureCallback(callback, lstatError);
        }
        if (!lstat.isSymbolicLink() || !settings.followSymbolicLink) {
          return callSuccessCallback(callback, lstat);
        }
        settings.fs.stat(path4, (statError, stat3) => {
          if (statError !== null) {
            if (settings.throwErrorOnBrokenSymbolicLink) {
              return callFailureCallback(callback, statError);
            }
            return callSuccessCallback(callback, lstat);
          }
          if (settings.markSymbolicLink) {
            stat3.isSymbolicLink = () => true;
          }
          callSuccessCallback(callback, stat3);
        });
      });
    }
    exports.read = read2;
    function callFailureCallback(callback, error) {
      callback(error);
    }
    function callSuccessCallback(callback, result) {
      callback(null, result);
    }
  }
});

// node_modules/@nodelib/fs.stat/out/providers/sync.js
var require_sync = __commonJS({
  "node_modules/@nodelib/fs.stat/out/providers/sync.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function read2(path4, settings) {
      const lstat = settings.fs.lstatSync(path4);
      if (!lstat.isSymbolicLink() || !settings.followSymbolicLink) {
        return lstat;
      }
      try {
        const stat3 = settings.fs.statSync(path4);
        if (settings.markSymbolicLink) {
          stat3.isSymbolicLink = () => true;
        }
        return stat3;
      } catch (error) {
        if (!settings.throwErrorOnBrokenSymbolicLink) {
          return lstat;
        }
        throw error;
      }
    }
    exports.read = read2;
  }
});

// node_modules/@nodelib/fs.stat/out/adapters/fs.js
var require_fs4 = __commonJS({
  "node_modules/@nodelib/fs.stat/out/adapters/fs.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fs4 = require("fs");
    exports.FILE_SYSTEM_ADAPTER = {
      lstat: fs4.lstat,
      stat: fs4.stat,
      lstatSync: fs4.lstatSync,
      statSync: fs4.statSync
    };
    function createFileSystemAdapter(fsMethods) {
      if (fsMethods === void 0) {
        return exports.FILE_SYSTEM_ADAPTER;
      }
      return Object.assign(Object.assign({}, exports.FILE_SYSTEM_ADAPTER), fsMethods);
    }
    exports.createFileSystemAdapter = createFileSystemAdapter;
  }
});

// node_modules/@nodelib/fs.stat/out/settings.js
var require_settings = __commonJS({
  "node_modules/@nodelib/fs.stat/out/settings.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fs4 = require_fs4();
    var Settings = class {
      constructor(_options = {}) {
        this._options = _options;
        this.followSymbolicLink = this._getValue(this._options.followSymbolicLink, true);
        this.fs = fs4.createFileSystemAdapter(this._options.fs);
        this.markSymbolicLink = this._getValue(this._options.markSymbolicLink, false);
        this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, true);
      }
      _getValue(option, value) {
        return option === void 0 ? value : option;
      }
    };
    exports.default = Settings;
  }
});

// node_modules/@nodelib/fs.stat/out/index.js
var require_out = __commonJS({
  "node_modules/@nodelib/fs.stat/out/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var async = require_async();
    var sync2 = require_sync();
    var settings_1 = require_settings();
    exports.Settings = settings_1.default;
    function stat3(path4, optionsOrSettingsOrCallback, callback) {
      if (typeof optionsOrSettingsOrCallback === "function") {
        return async.read(path4, getSettings(), optionsOrSettingsOrCallback);
      }
      async.read(path4, getSettings(optionsOrSettingsOrCallback), callback);
    }
    exports.stat = stat3;
    function statSync2(path4, optionsOrSettings) {
      const settings = getSettings(optionsOrSettings);
      return sync2.read(path4, settings);
    }
    exports.statSync = statSync2;
    function getSettings(settingsOrOptions = {}) {
      if (settingsOrOptions instanceof settings_1.default) {
        return settingsOrOptions;
      }
      return new settings_1.default(settingsOrOptions);
    }
  }
});

// node_modules/run-parallel/index.js
var require_run_parallel = __commonJS({
  "node_modules/run-parallel/index.js"(exports, module2) {
    module2.exports = runParallel;
    function runParallel(tasks, cb) {
      var results, pending, keys;
      var isSync = true;
      if (Array.isArray(tasks)) {
        results = [];
        pending = tasks.length;
      } else {
        keys = Object.keys(tasks);
        results = {};
        pending = keys.length;
      }
      function done(err) {
        function end() {
          if (cb)
            cb(err, results);
          cb = null;
        }
        if (isSync)
          process.nextTick(end);
        else
          end();
      }
      function each(i2, err, result) {
        results[i2] = result;
        if (--pending === 0 || err) {
          done(err);
        }
      }
      if (!pending) {
        done(null);
      } else if (keys) {
        keys.forEach(function(key) {
          tasks[key](function(err, result) {
            each(key, err, result);
          });
        });
      } else {
        tasks.forEach(function(task, i2) {
          task(function(err, result) {
            each(i2, err, result);
          });
        });
      }
      isSync = false;
    }
  }
});

// node_modules/@nodelib/fs.scandir/out/constants.js
var require_constants3 = __commonJS({
  "node_modules/@nodelib/fs.scandir/out/constants.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var NODE_PROCESS_VERSION_PARTS = process.versions.node.split(".");
    var MAJOR_VERSION = parseInt(NODE_PROCESS_VERSION_PARTS[0], 10);
    var MINOR_VERSION = parseInt(NODE_PROCESS_VERSION_PARTS[1], 10);
    var SUPPORTED_MAJOR_VERSION = 10;
    var SUPPORTED_MINOR_VERSION = 10;
    var IS_MATCHED_BY_MAJOR = MAJOR_VERSION > SUPPORTED_MAJOR_VERSION;
    var IS_MATCHED_BY_MAJOR_AND_MINOR = MAJOR_VERSION === SUPPORTED_MAJOR_VERSION && MINOR_VERSION >= SUPPORTED_MINOR_VERSION;
    exports.IS_SUPPORT_READDIR_WITH_FILE_TYPES = IS_MATCHED_BY_MAJOR || IS_MATCHED_BY_MAJOR_AND_MINOR;
  }
});

// node_modules/@nodelib/fs.scandir/out/utils/fs.js
var require_fs5 = __commonJS({
  "node_modules/@nodelib/fs.scandir/out/utils/fs.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var DirentFromStats = class {
      constructor(name, stats) {
        this.name = name;
        this.isBlockDevice = stats.isBlockDevice.bind(stats);
        this.isCharacterDevice = stats.isCharacterDevice.bind(stats);
        this.isDirectory = stats.isDirectory.bind(stats);
        this.isFIFO = stats.isFIFO.bind(stats);
        this.isFile = stats.isFile.bind(stats);
        this.isSocket = stats.isSocket.bind(stats);
        this.isSymbolicLink = stats.isSymbolicLink.bind(stats);
      }
    };
    function createDirentFromStats(name, stats) {
      return new DirentFromStats(name, stats);
    }
    exports.createDirentFromStats = createDirentFromStats;
  }
});

// node_modules/@nodelib/fs.scandir/out/utils/index.js
var require_utils10 = __commonJS({
  "node_modules/@nodelib/fs.scandir/out/utils/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fs4 = require_fs5();
    exports.fs = fs4;
  }
});

// node_modules/@nodelib/fs.scandir/out/providers/async.js
var require_async2 = __commonJS({
  "node_modules/@nodelib/fs.scandir/out/providers/async.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fsStat = require_out();
    var rpl = require_run_parallel();
    var constants_1 = require_constants3();
    var utils = require_utils10();
    function read2(directory, settings, callback) {
      if (!settings.stats && constants_1.IS_SUPPORT_READDIR_WITH_FILE_TYPES) {
        return readdirWithFileTypes(directory, settings, callback);
      }
      return readdir(directory, settings, callback);
    }
    exports.read = read2;
    function readdirWithFileTypes(directory, settings, callback) {
      settings.fs.readdir(directory, { withFileTypes: true }, (readdirError, dirents) => {
        if (readdirError !== null) {
          return callFailureCallback(callback, readdirError);
        }
        const entries = dirents.map((dirent) => ({
          dirent,
          name: dirent.name,
          path: `${directory}${settings.pathSegmentSeparator}${dirent.name}`
        }));
        if (!settings.followSymbolicLinks) {
          return callSuccessCallback(callback, entries);
        }
        const tasks = entries.map((entry) => makeRplTaskEntry(entry, settings));
        rpl(tasks, (rplError, rplEntries) => {
          if (rplError !== null) {
            return callFailureCallback(callback, rplError);
          }
          callSuccessCallback(callback, rplEntries);
        });
      });
    }
    exports.readdirWithFileTypes = readdirWithFileTypes;
    function makeRplTaskEntry(entry, settings) {
      return (done) => {
        if (!entry.dirent.isSymbolicLink()) {
          return done(null, entry);
        }
        settings.fs.stat(entry.path, (statError, stats) => {
          if (statError !== null) {
            if (settings.throwErrorOnBrokenSymbolicLink) {
              return done(statError);
            }
            return done(null, entry);
          }
          entry.dirent = utils.fs.createDirentFromStats(entry.name, stats);
          return done(null, entry);
        });
      };
    }
    function readdir(directory, settings, callback) {
      settings.fs.readdir(directory, (readdirError, names) => {
        if (readdirError !== null) {
          return callFailureCallback(callback, readdirError);
        }
        const filepaths = names.map((name) => `${directory}${settings.pathSegmentSeparator}${name}`);
        const tasks = filepaths.map((filepath) => {
          return (done) => fsStat.stat(filepath, settings.fsStatSettings, done);
        });
        rpl(tasks, (rplError, results) => {
          if (rplError !== null) {
            return callFailureCallback(callback, rplError);
          }
          const entries = [];
          names.forEach((name, index) => {
            const stats = results[index];
            const entry = {
              name,
              path: filepaths[index],
              dirent: utils.fs.createDirentFromStats(name, stats)
            };
            if (settings.stats) {
              entry.stats = stats;
            }
            entries.push(entry);
          });
          callSuccessCallback(callback, entries);
        });
      });
    }
    exports.readdir = readdir;
    function callFailureCallback(callback, error) {
      callback(error);
    }
    function callSuccessCallback(callback, result) {
      callback(null, result);
    }
  }
});

// node_modules/@nodelib/fs.scandir/out/providers/sync.js
var require_sync2 = __commonJS({
  "node_modules/@nodelib/fs.scandir/out/providers/sync.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fsStat = require_out();
    var constants_1 = require_constants3();
    var utils = require_utils10();
    function read2(directory, settings) {
      if (!settings.stats && constants_1.IS_SUPPORT_READDIR_WITH_FILE_TYPES) {
        return readdirWithFileTypes(directory, settings);
      }
      return readdir(directory, settings);
    }
    exports.read = read2;
    function readdirWithFileTypes(directory, settings) {
      const dirents = settings.fs.readdirSync(directory, { withFileTypes: true });
      return dirents.map((dirent) => {
        const entry = {
          dirent,
          name: dirent.name,
          path: `${directory}${settings.pathSegmentSeparator}${dirent.name}`
        };
        if (entry.dirent.isSymbolicLink() && settings.followSymbolicLinks) {
          try {
            const stats = settings.fs.statSync(entry.path);
            entry.dirent = utils.fs.createDirentFromStats(entry.name, stats);
          } catch (error) {
            if (settings.throwErrorOnBrokenSymbolicLink) {
              throw error;
            }
          }
        }
        return entry;
      });
    }
    exports.readdirWithFileTypes = readdirWithFileTypes;
    function readdir(directory, settings) {
      const names = settings.fs.readdirSync(directory);
      return names.map((name) => {
        const entryPath = `${directory}${settings.pathSegmentSeparator}${name}`;
        const stats = fsStat.statSync(entryPath, settings.fsStatSettings);
        const entry = {
          name,
          path: entryPath,
          dirent: utils.fs.createDirentFromStats(name, stats)
        };
        if (settings.stats) {
          entry.stats = stats;
        }
        return entry;
      });
    }
    exports.readdir = readdir;
  }
});

// node_modules/@nodelib/fs.scandir/out/adapters/fs.js
var require_fs6 = __commonJS({
  "node_modules/@nodelib/fs.scandir/out/adapters/fs.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fs4 = require("fs");
    exports.FILE_SYSTEM_ADAPTER = {
      lstat: fs4.lstat,
      stat: fs4.stat,
      lstatSync: fs4.lstatSync,
      statSync: fs4.statSync,
      readdir: fs4.readdir,
      readdirSync: fs4.readdirSync
    };
    function createFileSystemAdapter(fsMethods) {
      if (fsMethods === void 0) {
        return exports.FILE_SYSTEM_ADAPTER;
      }
      return Object.assign(Object.assign({}, exports.FILE_SYSTEM_ADAPTER), fsMethods);
    }
    exports.createFileSystemAdapter = createFileSystemAdapter;
  }
});

// node_modules/@nodelib/fs.scandir/out/settings.js
var require_settings2 = __commonJS({
  "node_modules/@nodelib/fs.scandir/out/settings.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var path4 = require("path");
    var fsStat = require_out();
    var fs4 = require_fs6();
    var Settings = class {
      constructor(_options = {}) {
        this._options = _options;
        this.followSymbolicLinks = this._getValue(this._options.followSymbolicLinks, false);
        this.fs = fs4.createFileSystemAdapter(this._options.fs);
        this.pathSegmentSeparator = this._getValue(this._options.pathSegmentSeparator, path4.sep);
        this.stats = this._getValue(this._options.stats, false);
        this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, true);
        this.fsStatSettings = new fsStat.Settings({
          followSymbolicLink: this.followSymbolicLinks,
          fs: this.fs,
          throwErrorOnBrokenSymbolicLink: this.throwErrorOnBrokenSymbolicLink
        });
      }
      _getValue(option, value) {
        return option === void 0 ? value : option;
      }
    };
    exports.default = Settings;
  }
});

// node_modules/@nodelib/fs.scandir/out/index.js
var require_out2 = __commonJS({
  "node_modules/@nodelib/fs.scandir/out/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var async = require_async2();
    var sync2 = require_sync2();
    var settings_1 = require_settings2();
    exports.Settings = settings_1.default;
    function scandir(path4, optionsOrSettingsOrCallback, callback) {
      if (typeof optionsOrSettingsOrCallback === "function") {
        return async.read(path4, getSettings(), optionsOrSettingsOrCallback);
      }
      async.read(path4, getSettings(optionsOrSettingsOrCallback), callback);
    }
    exports.scandir = scandir;
    function scandirSync(path4, optionsOrSettings) {
      const settings = getSettings(optionsOrSettings);
      return sync2.read(path4, settings);
    }
    exports.scandirSync = scandirSync;
    function getSettings(settingsOrOptions = {}) {
      if (settingsOrOptions instanceof settings_1.default) {
        return settingsOrOptions;
      }
      return new settings_1.default(settingsOrOptions);
    }
  }
});

// node_modules/reusify/reusify.js
var require_reusify = __commonJS({
  "node_modules/reusify/reusify.js"(exports, module2) {
    "use strict";
    function reusify(Constructor) {
      var head = new Constructor();
      var tail = head;
      function get() {
        var current = head;
        if (current.next) {
          head = current.next;
        } else {
          head = new Constructor();
          tail = head;
        }
        current.next = null;
        return current;
      }
      function release(obj) {
        tail.next = obj;
        tail = obj;
      }
      return {
        get,
        release
      };
    }
    module2.exports = reusify;
  }
});

// node_modules/fastq/queue.js
var require_queue = __commonJS({
  "node_modules/fastq/queue.js"(exports, module2) {
    "use strict";
    var reusify = require_reusify();
    function fastqueue(context2, worker, concurrency) {
      if (typeof context2 === "function") {
        concurrency = worker;
        worker = context2;
        context2 = null;
      }
      var cache = reusify(Task);
      var queueHead = null;
      var queueTail = null;
      var _running = 0;
      var self2 = {
        push: push2,
        drain: noop2,
        saturated: noop2,
        pause,
        paused: false,
        concurrency,
        running,
        resume,
        idle,
        length,
        getQueue,
        unshift,
        empty: noop2,
        kill,
        killAndDrain
      };
      return self2;
      function running() {
        return _running;
      }
      function pause() {
        self2.paused = true;
      }
      function length() {
        var current = queueHead;
        var counter = 0;
        while (current) {
          current = current.next;
          counter++;
        }
        return counter;
      }
      function getQueue() {
        var current = queueHead;
        var tasks = [];
        while (current) {
          tasks.push(current.value);
          current = current.next;
        }
        return tasks;
      }
      function resume() {
        if (!self2.paused)
          return;
        self2.paused = false;
        for (var i2 = 0; i2 < self2.concurrency; i2++) {
          _running++;
          release();
        }
      }
      function idle() {
        return _running === 0 && self2.length() === 0;
      }
      function push2(value, done) {
        var current = cache.get();
        current.context = context2;
        current.release = release;
        current.value = value;
        current.callback = done || noop2;
        if (_running === self2.concurrency || self2.paused) {
          if (queueTail) {
            queueTail.next = current;
            queueTail = current;
          } else {
            queueHead = current;
            queueTail = current;
            self2.saturated();
          }
        } else {
          _running++;
          worker.call(context2, current.value, current.worked);
        }
      }
      function unshift(value, done) {
        var current = cache.get();
        current.context = context2;
        current.release = release;
        current.value = value;
        current.callback = done || noop2;
        if (_running === self2.concurrency || self2.paused) {
          if (queueHead) {
            current.next = queueHead;
            queueHead = current;
          } else {
            queueHead = current;
            queueTail = current;
            self2.saturated();
          }
        } else {
          _running++;
          worker.call(context2, current.value, current.worked);
        }
      }
      function release(holder) {
        if (holder) {
          cache.release(holder);
        }
        var next = queueHead;
        if (next) {
          if (!self2.paused) {
            if (queueTail === queueHead) {
              queueTail = null;
            }
            queueHead = next.next;
            next.next = null;
            worker.call(context2, next.value, next.worked);
            if (queueTail === null) {
              self2.empty();
            }
          } else {
            _running--;
          }
        } else if (--_running === 0) {
          self2.drain();
        }
      }
      function kill() {
        queueHead = null;
        queueTail = null;
        self2.drain = noop2;
      }
      function killAndDrain() {
        queueHead = null;
        queueTail = null;
        self2.drain();
        self2.drain = noop2;
      }
    }
    function noop2() {
    }
    function Task() {
      this.value = null;
      this.callback = noop2;
      this.next = null;
      this.release = noop2;
      this.context = null;
      var self2 = this;
      this.worked = function worked(err, result) {
        var callback = self2.callback;
        self2.value = null;
        self2.callback = noop2;
        callback.call(self2.context, err, result);
        self2.release(self2);
      };
    }
    module2.exports = fastqueue;
  }
});

// node_modules/@nodelib/fs.walk/out/readers/common.js
var require_common = __commonJS({
  "node_modules/@nodelib/fs.walk/out/readers/common.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function isFatalError(settings, error) {
      if (settings.errorFilter === null) {
        return true;
      }
      return !settings.errorFilter(error);
    }
    exports.isFatalError = isFatalError;
    function isAppliedFilter(filter, value) {
      return filter === null || filter(value);
    }
    exports.isAppliedFilter = isAppliedFilter;
    function replacePathSegmentSeparator(filepath, separator) {
      return filepath.split(/[\\/]/).join(separator);
    }
    exports.replacePathSegmentSeparator = replacePathSegmentSeparator;
    function joinPathSegments(a, b, separator) {
      if (a === "") {
        return b;
      }
      return a + separator + b;
    }
    exports.joinPathSegments = joinPathSegments;
  }
});

// node_modules/@nodelib/fs.walk/out/readers/reader.js
var require_reader = __commonJS({
  "node_modules/@nodelib/fs.walk/out/readers/reader.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var common = require_common();
    var Reader = class {
      constructor(_root, _settings) {
        this._root = _root;
        this._settings = _settings;
        this._root = common.replacePathSegmentSeparator(_root, _settings.pathSegmentSeparator);
      }
    };
    exports.default = Reader;
  }
});

// node_modules/@nodelib/fs.walk/out/readers/async.js
var require_async3 = __commonJS({
  "node_modules/@nodelib/fs.walk/out/readers/async.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var events_1 = require("events");
    var fsScandir = require_out2();
    var fastq = require_queue();
    var common = require_common();
    var reader_1 = require_reader();
    var AsyncReader = class extends reader_1.default {
      constructor(_root, _settings) {
        super(_root, _settings);
        this._settings = _settings;
        this._scandir = fsScandir.scandir;
        this._emitter = new events_1.EventEmitter();
        this._queue = fastq(this._worker.bind(this), this._settings.concurrency);
        this._isFatalError = false;
        this._isDestroyed = false;
        this._queue.drain = () => {
          if (!this._isFatalError) {
            this._emitter.emit("end");
          }
        };
      }
      read() {
        this._isFatalError = false;
        this._isDestroyed = false;
        setImmediate(() => {
          this._pushToQueue(this._root, this._settings.basePath);
        });
        return this._emitter;
      }
      destroy() {
        if (this._isDestroyed) {
          throw new Error("The reader is already destroyed");
        }
        this._isDestroyed = true;
        this._queue.killAndDrain();
      }
      onEntry(callback) {
        this._emitter.on("entry", callback);
      }
      onError(callback) {
        this._emitter.once("error", callback);
      }
      onEnd(callback) {
        this._emitter.once("end", callback);
      }
      _pushToQueue(directory, base) {
        const queueItem = { directory, base };
        this._queue.push(queueItem, (error) => {
          if (error !== null) {
            this._handleError(error);
          }
        });
      }
      _worker(item, done) {
        this._scandir(item.directory, this._settings.fsScandirSettings, (error, entries) => {
          if (error !== null) {
            return done(error, void 0);
          }
          for (const entry of entries) {
            this._handleEntry(entry, item.base);
          }
          done(null, void 0);
        });
      }
      _handleError(error) {
        if (!common.isFatalError(this._settings, error)) {
          return;
        }
        this._isFatalError = true;
        this._isDestroyed = true;
        this._emitter.emit("error", error);
      }
      _handleEntry(entry, base) {
        if (this._isDestroyed || this._isFatalError) {
          return;
        }
        const fullpath = entry.path;
        if (base !== void 0) {
          entry.path = common.joinPathSegments(base, entry.name, this._settings.pathSegmentSeparator);
        }
        if (common.isAppliedFilter(this._settings.entryFilter, entry)) {
          this._emitEntry(entry);
        }
        if (entry.dirent.isDirectory() && common.isAppliedFilter(this._settings.deepFilter, entry)) {
          this._pushToQueue(fullpath, entry.path);
        }
      }
      _emitEntry(entry) {
        this._emitter.emit("entry", entry);
      }
    };
    exports.default = AsyncReader;
  }
});

// node_modules/@nodelib/fs.walk/out/providers/async.js
var require_async4 = __commonJS({
  "node_modules/@nodelib/fs.walk/out/providers/async.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var async_1 = require_async3();
    var AsyncProvider = class {
      constructor(_root, _settings) {
        this._root = _root;
        this._settings = _settings;
        this._reader = new async_1.default(this._root, this._settings);
        this._storage = /* @__PURE__ */ new Set();
      }
      read(callback) {
        this._reader.onError((error) => {
          callFailureCallback(callback, error);
        });
        this._reader.onEntry((entry) => {
          this._storage.add(entry);
        });
        this._reader.onEnd(() => {
          callSuccessCallback(callback, [...this._storage]);
        });
        this._reader.read();
      }
    };
    exports.default = AsyncProvider;
    function callFailureCallback(callback, error) {
      callback(error);
    }
    function callSuccessCallback(callback, entries) {
      callback(null, entries);
    }
  }
});

// node_modules/@nodelib/fs.walk/out/providers/stream.js
var require_stream2 = __commonJS({
  "node_modules/@nodelib/fs.walk/out/providers/stream.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var stream_1 = require("stream");
    var async_1 = require_async3();
    var StreamProvider = class {
      constructor(_root, _settings) {
        this._root = _root;
        this._settings = _settings;
        this._reader = new async_1.default(this._root, this._settings);
        this._stream = new stream_1.Readable({
          objectMode: true,
          read: () => {
          },
          destroy: this._reader.destroy.bind(this._reader)
        });
      }
      read() {
        this._reader.onError((error) => {
          this._stream.emit("error", error);
        });
        this._reader.onEntry((entry) => {
          this._stream.push(entry);
        });
        this._reader.onEnd(() => {
          this._stream.push(null);
        });
        this._reader.read();
        return this._stream;
      }
    };
    exports.default = StreamProvider;
  }
});

// node_modules/@nodelib/fs.walk/out/readers/sync.js
var require_sync3 = __commonJS({
  "node_modules/@nodelib/fs.walk/out/readers/sync.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fsScandir = require_out2();
    var common = require_common();
    var reader_1 = require_reader();
    var SyncReader = class extends reader_1.default {
      constructor() {
        super(...arguments);
        this._scandir = fsScandir.scandirSync;
        this._storage = /* @__PURE__ */ new Set();
        this._queue = /* @__PURE__ */ new Set();
      }
      read() {
        this._pushToQueue(this._root, this._settings.basePath);
        this._handleQueue();
        return [...this._storage];
      }
      _pushToQueue(directory, base) {
        this._queue.add({ directory, base });
      }
      _handleQueue() {
        for (const item of this._queue.values()) {
          this._handleDirectory(item.directory, item.base);
        }
      }
      _handleDirectory(directory, base) {
        try {
          const entries = this._scandir(directory, this._settings.fsScandirSettings);
          for (const entry of entries) {
            this._handleEntry(entry, base);
          }
        } catch (error) {
          this._handleError(error);
        }
      }
      _handleError(error) {
        if (!common.isFatalError(this._settings, error)) {
          return;
        }
        throw error;
      }
      _handleEntry(entry, base) {
        const fullpath = entry.path;
        if (base !== void 0) {
          entry.path = common.joinPathSegments(base, entry.name, this._settings.pathSegmentSeparator);
        }
        if (common.isAppliedFilter(this._settings.entryFilter, entry)) {
          this._pushToStorage(entry);
        }
        if (entry.dirent.isDirectory() && common.isAppliedFilter(this._settings.deepFilter, entry)) {
          this._pushToQueue(fullpath, entry.path);
        }
      }
      _pushToStorage(entry) {
        this._storage.add(entry);
      }
    };
    exports.default = SyncReader;
  }
});

// node_modules/@nodelib/fs.walk/out/providers/sync.js
var require_sync4 = __commonJS({
  "node_modules/@nodelib/fs.walk/out/providers/sync.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var sync_1 = require_sync3();
    var SyncProvider = class {
      constructor(_root, _settings) {
        this._root = _root;
        this._settings = _settings;
        this._reader = new sync_1.default(this._root, this._settings);
      }
      read() {
        return this._reader.read();
      }
    };
    exports.default = SyncProvider;
  }
});

// node_modules/@nodelib/fs.walk/out/settings.js
var require_settings3 = __commonJS({
  "node_modules/@nodelib/fs.walk/out/settings.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var path4 = require("path");
    var fsScandir = require_out2();
    var Settings = class {
      constructor(_options = {}) {
        this._options = _options;
        this.basePath = this._getValue(this._options.basePath, void 0);
        this.concurrency = this._getValue(this._options.concurrency, Infinity);
        this.deepFilter = this._getValue(this._options.deepFilter, null);
        this.entryFilter = this._getValue(this._options.entryFilter, null);
        this.errorFilter = this._getValue(this._options.errorFilter, null);
        this.pathSegmentSeparator = this._getValue(this._options.pathSegmentSeparator, path4.sep);
        this.fsScandirSettings = new fsScandir.Settings({
          followSymbolicLinks: this._options.followSymbolicLinks,
          fs: this._options.fs,
          pathSegmentSeparator: this._options.pathSegmentSeparator,
          stats: this._options.stats,
          throwErrorOnBrokenSymbolicLink: this._options.throwErrorOnBrokenSymbolicLink
        });
      }
      _getValue(option, value) {
        return option === void 0 ? value : option;
      }
    };
    exports.default = Settings;
  }
});

// node_modules/@nodelib/fs.walk/out/index.js
var require_out3 = __commonJS({
  "node_modules/@nodelib/fs.walk/out/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var async_1 = require_async4();
    var stream_1 = require_stream2();
    var sync_1 = require_sync4();
    var settings_1 = require_settings3();
    exports.Settings = settings_1.default;
    function walk(directory, optionsOrSettingsOrCallback, callback) {
      if (typeof optionsOrSettingsOrCallback === "function") {
        return new async_1.default(directory, getSettings()).read(optionsOrSettingsOrCallback);
      }
      new async_1.default(directory, getSettings(optionsOrSettingsOrCallback)).read(callback);
    }
    exports.walk = walk;
    function walkSync(directory, optionsOrSettings) {
      const settings = getSettings(optionsOrSettings);
      const provider = new sync_1.default(directory, settings);
      return provider.read();
    }
    exports.walkSync = walkSync;
    function walkStream(directory, optionsOrSettings) {
      const settings = getSettings(optionsOrSettings);
      const provider = new stream_1.default(directory, settings);
      return provider.read();
    }
    exports.walkStream = walkStream;
    function getSettings(settingsOrOptions = {}) {
      if (settingsOrOptions instanceof settings_1.default) {
        return settingsOrOptions;
      }
      return new settings_1.default(settingsOrOptions);
    }
  }
});

// node_modules/fast-glob/out/readers/reader.js
var require_reader2 = __commonJS({
  "node_modules/fast-glob/out/readers/reader.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var path4 = require("path");
    var fsStat = require_out();
    var utils = require_utils9();
    var Reader = class {
      constructor(_settings) {
        this._settings = _settings;
        this._fsStatSettings = new fsStat.Settings({
          followSymbolicLink: this._settings.followSymbolicLinks,
          fs: this._settings.fs,
          throwErrorOnBrokenSymbolicLink: this._settings.followSymbolicLinks
        });
      }
      _getFullEntryPath(filepath) {
        return path4.resolve(this._settings.cwd, filepath);
      }
      _makeEntry(stats, pattern) {
        const entry = {
          name: pattern,
          path: pattern,
          dirent: utils.fs.createDirentFromStats(pattern, stats)
        };
        if (this._settings.stats) {
          entry.stats = stats;
        }
        return entry;
      }
      _isFatalError(error) {
        return !utils.errno.isEnoentCodeError(error) && !this._settings.suppressErrors;
      }
    };
    exports.default = Reader;
  }
});

// node_modules/fast-glob/out/readers/stream.js
var require_stream3 = __commonJS({
  "node_modules/fast-glob/out/readers/stream.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var stream_1 = require("stream");
    var fsStat = require_out();
    var fsWalk = require_out3();
    var reader_1 = require_reader2();
    var ReaderStream = class extends reader_1.default {
      constructor() {
        super(...arguments);
        this._walkStream = fsWalk.walkStream;
        this._stat = fsStat.stat;
      }
      dynamic(root, options) {
        return this._walkStream(root, options);
      }
      static(patterns, options) {
        const filepaths = patterns.map(this._getFullEntryPath, this);
        const stream = new stream_1.PassThrough({ objectMode: true });
        stream._write = (index, _enc, done) => {
          return this._getEntry(filepaths[index], patterns[index], options).then((entry) => {
            if (entry !== null && options.entryFilter(entry)) {
              stream.push(entry);
            }
            if (index === filepaths.length - 1) {
              stream.end();
            }
            done();
          }).catch(done);
        };
        for (let i2 = 0; i2 < filepaths.length; i2++) {
          stream.write(i2);
        }
        return stream;
      }
      _getEntry(filepath, pattern, options) {
        return this._getStat(filepath).then((stats) => this._makeEntry(stats, pattern)).catch((error) => {
          if (options.errorFilter(error)) {
            return null;
          }
          throw error;
        });
      }
      _getStat(filepath) {
        return new Promise((resolve, reject) => {
          this._stat(filepath, this._fsStatSettings, (error, stats) => {
            return error === null ? resolve(stats) : reject(error);
          });
        });
      }
    };
    exports.default = ReaderStream;
  }
});

// node_modules/fast-glob/out/providers/matchers/matcher.js
var require_matcher = __commonJS({
  "node_modules/fast-glob/out/providers/matchers/matcher.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils = require_utils9();
    var Matcher = class {
      constructor(_patterns, _settings, _micromatchOptions) {
        this._patterns = _patterns;
        this._settings = _settings;
        this._micromatchOptions = _micromatchOptions;
        this._storage = [];
        this._fillStorage();
      }
      _fillStorage() {
        const patterns = utils.pattern.expandPatternsWithBraceExpansion(this._patterns);
        for (const pattern of patterns) {
          const segments = this._getPatternSegments(pattern);
          const sections = this._splitSegmentsIntoSections(segments);
          this._storage.push({
            complete: sections.length <= 1,
            pattern,
            segments,
            sections
          });
        }
      }
      _getPatternSegments(pattern) {
        const parts = utils.pattern.getPatternParts(pattern, this._micromatchOptions);
        return parts.map((part) => {
          const dynamic = utils.pattern.isDynamicPattern(part, this._settings);
          if (!dynamic) {
            return {
              dynamic: false,
              pattern: part
            };
          }
          return {
            dynamic: true,
            pattern: part,
            patternRe: utils.pattern.makeRe(part, this._micromatchOptions)
          };
        });
      }
      _splitSegmentsIntoSections(segments) {
        return utils.array.splitWhen(segments, (segment) => segment.dynamic && utils.pattern.hasGlobStar(segment.pattern));
      }
    };
    exports.default = Matcher;
  }
});

// node_modules/fast-glob/out/providers/matchers/partial.js
var require_partial = __commonJS({
  "node_modules/fast-glob/out/providers/matchers/partial.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var matcher_1 = require_matcher();
    var PartialMatcher = class extends matcher_1.default {
      match(filepath) {
        const parts = filepath.split("/");
        const levels = parts.length;
        const patterns = this._storage.filter((info) => !info.complete || info.segments.length > levels);
        for (const pattern of patterns) {
          const section = pattern.sections[0];
          if (!pattern.complete && levels > section.length) {
            return true;
          }
          const match = parts.every((part, index) => {
            const segment = pattern.segments[index];
            if (segment.dynamic && segment.patternRe.test(part)) {
              return true;
            }
            if (!segment.dynamic && segment.pattern === part) {
              return true;
            }
            return false;
          });
          if (match) {
            return true;
          }
        }
        return false;
      }
    };
    exports.default = PartialMatcher;
  }
});

// node_modules/fast-glob/out/providers/filters/deep.js
var require_deep = __commonJS({
  "node_modules/fast-glob/out/providers/filters/deep.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils = require_utils9();
    var partial_1 = require_partial();
    var DeepFilter = class {
      constructor(_settings, _micromatchOptions) {
        this._settings = _settings;
        this._micromatchOptions = _micromatchOptions;
      }
      getFilter(basePath, positive, negative) {
        const matcher = this._getMatcher(positive);
        const negativeRe = this._getNegativePatternsRe(negative);
        return (entry) => this._filter(basePath, entry, matcher, negativeRe);
      }
      _getMatcher(patterns) {
        return new partial_1.default(patterns, this._settings, this._micromatchOptions);
      }
      _getNegativePatternsRe(patterns) {
        const affectDepthOfReadingPatterns = patterns.filter(utils.pattern.isAffectDepthOfReadingPattern);
        return utils.pattern.convertPatternsToRe(affectDepthOfReadingPatterns, this._micromatchOptions);
      }
      _filter(basePath, entry, matcher, negativeRe) {
        if (this._isSkippedByDeep(basePath, entry.path)) {
          return false;
        }
        if (this._isSkippedSymbolicLink(entry)) {
          return false;
        }
        const filepath = utils.path.removeLeadingDotSegment(entry.path);
        if (this._isSkippedByPositivePatterns(filepath, matcher)) {
          return false;
        }
        return this._isSkippedByNegativePatterns(filepath, negativeRe);
      }
      _isSkippedByDeep(basePath, entryPath) {
        if (this._settings.deep === Infinity) {
          return false;
        }
        return this._getEntryLevel(basePath, entryPath) >= this._settings.deep;
      }
      _getEntryLevel(basePath, entryPath) {
        const entryPathDepth = entryPath.split("/").length;
        if (basePath === "") {
          return entryPathDepth;
        }
        const basePathDepth = basePath.split("/").length;
        return entryPathDepth - basePathDepth;
      }
      _isSkippedSymbolicLink(entry) {
        return !this._settings.followSymbolicLinks && entry.dirent.isSymbolicLink();
      }
      _isSkippedByPositivePatterns(entryPath, matcher) {
        return !this._settings.baseNameMatch && !matcher.match(entryPath);
      }
      _isSkippedByNegativePatterns(entryPath, patternsRe) {
        return !utils.pattern.matchAny(entryPath, patternsRe);
      }
    };
    exports.default = DeepFilter;
  }
});

// node_modules/fast-glob/out/providers/filters/entry.js
var require_entry = __commonJS({
  "node_modules/fast-glob/out/providers/filters/entry.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils = require_utils9();
    var EntryFilter = class {
      constructor(_settings, _micromatchOptions) {
        this._settings = _settings;
        this._micromatchOptions = _micromatchOptions;
        this.index = /* @__PURE__ */ new Map();
      }
      getFilter(positive, negative) {
        const positiveRe = utils.pattern.convertPatternsToRe(positive, this._micromatchOptions);
        const negativeRe = utils.pattern.convertPatternsToRe(negative, this._micromatchOptions);
        return (entry) => this._filter(entry, positiveRe, negativeRe);
      }
      _filter(entry, positiveRe, negativeRe) {
        if (this._settings.unique && this._isDuplicateEntry(entry)) {
          return false;
        }
        if (this._onlyFileFilter(entry) || this._onlyDirectoryFilter(entry)) {
          return false;
        }
        if (this._isSkippedByAbsoluteNegativePatterns(entry.path, negativeRe)) {
          return false;
        }
        const filepath = this._settings.baseNameMatch ? entry.name : entry.path;
        const isMatched = this._isMatchToPatterns(filepath, positiveRe) && !this._isMatchToPatterns(entry.path, negativeRe);
        if (this._settings.unique && isMatched) {
          this._createIndexRecord(entry);
        }
        return isMatched;
      }
      _isDuplicateEntry(entry) {
        return this.index.has(entry.path);
      }
      _createIndexRecord(entry) {
        this.index.set(entry.path, void 0);
      }
      _onlyFileFilter(entry) {
        return this._settings.onlyFiles && !entry.dirent.isFile();
      }
      _onlyDirectoryFilter(entry) {
        return this._settings.onlyDirectories && !entry.dirent.isDirectory();
      }
      _isSkippedByAbsoluteNegativePatterns(entryPath, patternsRe) {
        if (!this._settings.absolute) {
          return false;
        }
        const fullpath = utils.path.makeAbsolute(this._settings.cwd, entryPath);
        return utils.pattern.matchAny(fullpath, patternsRe);
      }
      _isMatchToPatterns(entryPath, patternsRe) {
        const filepath = utils.path.removeLeadingDotSegment(entryPath);
        return utils.pattern.matchAny(filepath, patternsRe) || utils.pattern.matchAny(filepath + "/", patternsRe);
      }
    };
    exports.default = EntryFilter;
  }
});

// node_modules/fast-glob/out/providers/filters/error.js
var require_error = __commonJS({
  "node_modules/fast-glob/out/providers/filters/error.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils = require_utils9();
    var ErrorFilter = class {
      constructor(_settings) {
        this._settings = _settings;
      }
      getFilter() {
        return (error) => this._isNonFatalError(error);
      }
      _isNonFatalError(error) {
        return utils.errno.isEnoentCodeError(error) || this._settings.suppressErrors;
      }
    };
    exports.default = ErrorFilter;
  }
});

// node_modules/fast-glob/out/providers/transformers/entry.js
var require_entry2 = __commonJS({
  "node_modules/fast-glob/out/providers/transformers/entry.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var utils = require_utils9();
    var EntryTransformer = class {
      constructor(_settings) {
        this._settings = _settings;
      }
      getTransformer() {
        return (entry) => this._transform(entry);
      }
      _transform(entry) {
        let filepath = entry.path;
        if (this._settings.absolute) {
          filepath = utils.path.makeAbsolute(this._settings.cwd, filepath);
          filepath = utils.path.unixify(filepath);
        }
        if (this._settings.markDirectories && entry.dirent.isDirectory()) {
          filepath += "/";
        }
        if (!this._settings.objectMode) {
          return filepath;
        }
        return Object.assign(Object.assign({}, entry), { path: filepath });
      }
    };
    exports.default = EntryTransformer;
  }
});

// node_modules/fast-glob/out/providers/provider.js
var require_provider = __commonJS({
  "node_modules/fast-glob/out/providers/provider.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var path4 = require("path");
    var deep_1 = require_deep();
    var entry_1 = require_entry();
    var error_1 = require_error();
    var entry_2 = require_entry2();
    var Provider = class {
      constructor(_settings) {
        this._settings = _settings;
        this.errorFilter = new error_1.default(this._settings);
        this.entryFilter = new entry_1.default(this._settings, this._getMicromatchOptions());
        this.deepFilter = new deep_1.default(this._settings, this._getMicromatchOptions());
        this.entryTransformer = new entry_2.default(this._settings);
      }
      _getRootDirectory(task) {
        return path4.resolve(this._settings.cwd, task.base);
      }
      _getReaderOptions(task) {
        const basePath = task.base === "." ? "" : task.base;
        return {
          basePath,
          pathSegmentSeparator: "/",
          concurrency: this._settings.concurrency,
          deepFilter: this.deepFilter.getFilter(basePath, task.positive, task.negative),
          entryFilter: this.entryFilter.getFilter(task.positive, task.negative),
          errorFilter: this.errorFilter.getFilter(),
          followSymbolicLinks: this._settings.followSymbolicLinks,
          fs: this._settings.fs,
          stats: this._settings.stats,
          throwErrorOnBrokenSymbolicLink: this._settings.throwErrorOnBrokenSymbolicLink,
          transform: this.entryTransformer.getTransformer()
        };
      }
      _getMicromatchOptions() {
        return {
          dot: this._settings.dot,
          matchBase: this._settings.baseNameMatch,
          nobrace: !this._settings.braceExpansion,
          nocase: !this._settings.caseSensitiveMatch,
          noext: !this._settings.extglob,
          noglobstar: !this._settings.globstar,
          posix: true,
          strictSlashes: false
        };
      }
    };
    exports.default = Provider;
  }
});

// node_modules/fast-glob/out/providers/async.js
var require_async5 = __commonJS({
  "node_modules/fast-glob/out/providers/async.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var stream_1 = require_stream3();
    var provider_1 = require_provider();
    var ProviderAsync = class extends provider_1.default {
      constructor() {
        super(...arguments);
        this._reader = new stream_1.default(this._settings);
      }
      read(task) {
        const root = this._getRootDirectory(task);
        const options = this._getReaderOptions(task);
        const entries = [];
        return new Promise((resolve, reject) => {
          const stream = this.api(root, task, options);
          stream.once("error", reject);
          stream.on("data", (entry) => entries.push(options.transform(entry)));
          stream.once("end", () => resolve(entries));
        });
      }
      api(root, task, options) {
        if (task.dynamic) {
          return this._reader.dynamic(root, options);
        }
        return this._reader.static(task.patterns, options);
      }
    };
    exports.default = ProviderAsync;
  }
});

// node_modules/fast-glob/out/providers/stream.js
var require_stream4 = __commonJS({
  "node_modules/fast-glob/out/providers/stream.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var stream_1 = require("stream");
    var stream_2 = require_stream3();
    var provider_1 = require_provider();
    var ProviderStream = class extends provider_1.default {
      constructor() {
        super(...arguments);
        this._reader = new stream_2.default(this._settings);
      }
      read(task) {
        const root = this._getRootDirectory(task);
        const options = this._getReaderOptions(task);
        const source = this.api(root, task, options);
        const destination = new stream_1.Readable({ objectMode: true, read: () => {
        } });
        source.once("error", (error) => destination.emit("error", error)).on("data", (entry) => destination.emit("data", options.transform(entry))).once("end", () => destination.emit("end"));
        destination.once("close", () => source.destroy());
        return destination;
      }
      api(root, task, options) {
        if (task.dynamic) {
          return this._reader.dynamic(root, options);
        }
        return this._reader.static(task.patterns, options);
      }
    };
    exports.default = ProviderStream;
  }
});

// node_modules/fast-glob/out/readers/sync.js
var require_sync5 = __commonJS({
  "node_modules/fast-glob/out/readers/sync.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var fsStat = require_out();
    var fsWalk = require_out3();
    var reader_1 = require_reader2();
    var ReaderSync = class extends reader_1.default {
      constructor() {
        super(...arguments);
        this._walkSync = fsWalk.walkSync;
        this._statSync = fsStat.statSync;
      }
      dynamic(root, options) {
        return this._walkSync(root, options);
      }
      static(patterns, options) {
        const entries = [];
        for (const pattern of patterns) {
          const filepath = this._getFullEntryPath(pattern);
          const entry = this._getEntry(filepath, pattern, options);
          if (entry === null || !options.entryFilter(entry)) {
            continue;
          }
          entries.push(entry);
        }
        return entries;
      }
      _getEntry(filepath, pattern, options) {
        try {
          const stats = this._getStat(filepath);
          return this._makeEntry(stats, pattern);
        } catch (error) {
          if (options.errorFilter(error)) {
            return null;
          }
          throw error;
        }
      }
      _getStat(filepath) {
        return this._statSync(filepath, this._fsStatSettings);
      }
    };
    exports.default = ReaderSync;
  }
});

// node_modules/fast-glob/out/providers/sync.js
var require_sync6 = __commonJS({
  "node_modules/fast-glob/out/providers/sync.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var sync_1 = require_sync5();
    var provider_1 = require_provider();
    var ProviderSync = class extends provider_1.default {
      constructor() {
        super(...arguments);
        this._reader = new sync_1.default(this._settings);
      }
      read(task) {
        const root = this._getRootDirectory(task);
        const options = this._getReaderOptions(task);
        const entries = this.api(root, task, options);
        return entries.map(options.transform);
      }
      api(root, task, options) {
        if (task.dynamic) {
          return this._reader.dynamic(root, options);
        }
        return this._reader.static(task.patterns, options);
      }
    };
    exports.default = ProviderSync;
  }
});

// node_modules/fast-glob/out/settings.js
var require_settings4 = __commonJS({
  "node_modules/fast-glob/out/settings.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DEFAULT_FILE_SYSTEM_ADAPTER = void 0;
    var fs4 = require("fs");
    var os = require("os");
    var CPU_COUNT = Math.max(os.cpus().length, 1);
    exports.DEFAULT_FILE_SYSTEM_ADAPTER = {
      lstat: fs4.lstat,
      lstatSync: fs4.lstatSync,
      stat: fs4.stat,
      statSync: fs4.statSync,
      readdir: fs4.readdir,
      readdirSync: fs4.readdirSync
    };
    var Settings = class {
      constructor(_options = {}) {
        this._options = _options;
        this.absolute = this._getValue(this._options.absolute, false);
        this.baseNameMatch = this._getValue(this._options.baseNameMatch, false);
        this.braceExpansion = this._getValue(this._options.braceExpansion, true);
        this.caseSensitiveMatch = this._getValue(this._options.caseSensitiveMatch, true);
        this.concurrency = this._getValue(this._options.concurrency, CPU_COUNT);
        this.cwd = this._getValue(this._options.cwd, process.cwd());
        this.deep = this._getValue(this._options.deep, Infinity);
        this.dot = this._getValue(this._options.dot, false);
        this.extglob = this._getValue(this._options.extglob, true);
        this.followSymbolicLinks = this._getValue(this._options.followSymbolicLinks, true);
        this.fs = this._getFileSystemMethods(this._options.fs);
        this.globstar = this._getValue(this._options.globstar, true);
        this.ignore = this._getValue(this._options.ignore, []);
        this.markDirectories = this._getValue(this._options.markDirectories, false);
        this.objectMode = this._getValue(this._options.objectMode, false);
        this.onlyDirectories = this._getValue(this._options.onlyDirectories, false);
        this.onlyFiles = this._getValue(this._options.onlyFiles, true);
        this.stats = this._getValue(this._options.stats, false);
        this.suppressErrors = this._getValue(this._options.suppressErrors, false);
        this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, false);
        this.unique = this._getValue(this._options.unique, true);
        if (this.onlyDirectories) {
          this.onlyFiles = false;
        }
        if (this.stats) {
          this.objectMode = true;
        }
      }
      _getValue(option, value) {
        return option === void 0 ? value : option;
      }
      _getFileSystemMethods(methods = {}) {
        return Object.assign(Object.assign({}, exports.DEFAULT_FILE_SYSTEM_ADAPTER), methods);
      }
    };
    exports.default = Settings;
  }
});

// node_modules/fast-glob/out/index.js
var require_out4 = __commonJS({
  "node_modules/fast-glob/out/index.js"(exports, module2) {
    "use strict";
    var taskManager = require_tasks();
    var patternManager = require_patterns();
    var async_1 = require_async5();
    var stream_1 = require_stream4();
    var sync_1 = require_sync6();
    var settings_1 = require_settings4();
    var utils = require_utils9();
    async function FastGlob(source, options) {
      assertPatternsInput(source);
      const works = getWorks(source, async_1.default, options);
      const result = await Promise.all(works);
      return utils.array.flatten(result);
    }
    (function(FastGlob2) {
      function sync2(source, options) {
        assertPatternsInput(source);
        const works = getWorks(source, sync_1.default, options);
        return utils.array.flatten(works);
      }
      FastGlob2.sync = sync2;
      function stream(source, options) {
        assertPatternsInput(source);
        const works = getWorks(source, stream_1.default, options);
        return utils.stream.merge(works);
      }
      FastGlob2.stream = stream;
      function generateTasks(source, options) {
        assertPatternsInput(source);
        const patterns = patternManager.transform([].concat(source));
        const settings = new settings_1.default(options);
        return taskManager.generate(patterns, settings);
      }
      FastGlob2.generateTasks = generateTasks;
      function isDynamicPattern(source, options) {
        assertPatternsInput(source);
        const settings = new settings_1.default(options);
        return utils.pattern.isDynamicPattern(source, settings);
      }
      FastGlob2.isDynamicPattern = isDynamicPattern;
      function escapePath(source) {
        assertPatternsInput(source);
        return utils.path.escape(source);
      }
      FastGlob2.escapePath = escapePath;
    })(FastGlob || (FastGlob = {}));
    function getWorks(source, _Provider, options) {
      const patterns = patternManager.transform([].concat(source));
      const settings = new settings_1.default(options);
      const tasks = taskManager.generate(patterns, settings);
      const provider = new _Provider(settings);
      return tasks.map(provider.read, provider);
    }
    function assertPatternsInput(input) {
      const source = [].concat(input);
      const isValidSource = source.every((item) => utils.string.isString(item) && !utils.string.isEmpty(item));
      if (!isValidSource) {
        throw new TypeError("Patterns must be a string (non empty) or an array of strings");
      }
    }
    module2.exports = FastGlob;
  }
});

// node_modules/path-type/index.js
var require_path_type = __commonJS({
  "node_modules/path-type/index.js"(exports) {
    "use strict";
    var { promisify: promisify2 } = require("util");
    var fs4 = require("fs");
    async function isType(fsStatType, statsMethodName, filePath) {
      if (typeof filePath !== "string") {
        throw new TypeError(`Expected a string, got ${typeof filePath}`);
      }
      try {
        const stats = await promisify2(fs4[fsStatType])(filePath);
        return stats[statsMethodName]();
      } catch (error) {
        if (error.code === "ENOENT") {
          return false;
        }
        throw error;
      }
    }
    function isTypeSync(fsStatType, statsMethodName, filePath) {
      if (typeof filePath !== "string") {
        throw new TypeError(`Expected a string, got ${typeof filePath}`);
      }
      try {
        return fs4[fsStatType](filePath)[statsMethodName]();
      } catch (error) {
        if (error.code === "ENOENT") {
          return false;
        }
        throw error;
      }
    }
    exports.isFile = isType.bind(null, "stat", "isFile");
    exports.isDirectory = isType.bind(null, "stat", "isDirectory");
    exports.isSymlink = isType.bind(null, "lstat", "isSymbolicLink");
    exports.isFileSync = isTypeSync.bind(null, "statSync", "isFile");
    exports.isDirectorySync = isTypeSync.bind(null, "statSync", "isDirectory");
    exports.isSymlinkSync = isTypeSync.bind(null, "lstatSync", "isSymbolicLink");
  }
});

// node_modules/dir-glob/index.js
var require_dir_glob = __commonJS({
  "node_modules/dir-glob/index.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var pathType = require_path_type();
    var getExtensions = (extensions) => extensions.length > 1 ? `{${extensions.join(",")}}` : extensions[0];
    var getPath = (filepath, cwd) => {
      const pth = filepath[0] === "!" ? filepath.slice(1) : filepath;
      return path4.isAbsolute(pth) ? pth : path4.join(cwd, pth);
    };
    var addExtensions = (file, extensions) => {
      if (path4.extname(file)) {
        return `**/${file}`;
      }
      return `**/${file}.${getExtensions(extensions)}`;
    };
    var getGlob = (directory, options) => {
      if (options.files && !Array.isArray(options.files)) {
        throw new TypeError(`Expected \`files\` to be of type \`Array\` but received type \`${typeof options.files}\``);
      }
      if (options.extensions && !Array.isArray(options.extensions)) {
        throw new TypeError(`Expected \`extensions\` to be of type \`Array\` but received type \`${typeof options.extensions}\``);
      }
      if (options.files && options.extensions) {
        return options.files.map((x2) => path4.posix.join(directory, addExtensions(x2, options.extensions)));
      }
      if (options.files) {
        return options.files.map((x2) => path4.posix.join(directory, `**/${x2}`));
      }
      if (options.extensions) {
        return [path4.posix.join(directory, `**/*.${getExtensions(options.extensions)}`)];
      }
      return [path4.posix.join(directory, "**")];
    };
    module2.exports = async (input, options) => {
      options = {
        cwd: process.cwd(),
        ...options
      };
      if (typeof options.cwd !== "string") {
        throw new TypeError(`Expected \`cwd\` to be of type \`string\` but received type \`${typeof options.cwd}\``);
      }
      const globs = await Promise.all([].concat(input).map(async (x2) => {
        const isDirectory = await pathType.isDirectory(getPath(x2, options.cwd));
        return isDirectory ? getGlob(x2, options) : x2;
      }));
      return [].concat.apply([], globs);
    };
    module2.exports.sync = (input, options) => {
      options = {
        cwd: process.cwd(),
        ...options
      };
      if (typeof options.cwd !== "string") {
        throw new TypeError(`Expected \`cwd\` to be of type \`string\` but received type \`${typeof options.cwd}\``);
      }
      const globs = [].concat(input).map((x2) => pathType.isDirectorySync(getPath(x2, options.cwd)) ? getGlob(x2, options) : x2);
      return [].concat.apply([], globs);
    };
  }
});

// node_modules/ignore/index.js
var require_ignore = __commonJS({
  "node_modules/ignore/index.js"(exports, module2) {
    function makeArray(subject) {
      return Array.isArray(subject) ? subject : [subject];
    }
    var EMPTY = "";
    var SPACE2 = " ";
    var ESCAPE = "\\";
    var REGEX_TEST_BLANK_LINE = /^\s+$/;
    var REGEX_REPLACE_LEADING_EXCAPED_EXCLAMATION = /^\\!/;
    var REGEX_REPLACE_LEADING_EXCAPED_HASH = /^\\#/;
    var REGEX_SPLITALL_CRLF = /\r?\n/g;
    var REGEX_TEST_INVALID_PATH = /^\.*\/|^\.+$/;
    var SLASH = "/";
    var KEY_IGNORE = typeof Symbol !== "undefined" ? Symbol.for("node-ignore") : "node-ignore";
    var define2 = (object, key, value) => Object.defineProperty(object, key, { value });
    var REGEX_REGEXP_RANGE = /([0-z])-([0-z])/g;
    var RETURN_FALSE = () => false;
    var sanitizeRange = (range) => range.replace(
      REGEX_REGEXP_RANGE,
      (match, from, to) => from.charCodeAt(0) <= to.charCodeAt(0) ? match : EMPTY
    );
    var cleanRangeBackSlash = (slashes) => {
      const { length } = slashes;
      return slashes.slice(0, length - length % 2);
    };
    var REPLACERS = [
      [
        /\\?\s+$/,
        (match) => match.indexOf("\\") === 0 ? SPACE2 : EMPTY
      ],
      [
        /\\\s/g,
        () => SPACE2
      ],
      [
        /[\\$.|*+(){^]/g,
        (match) => `\\${match}`
      ],
      [
        /(?!\\)\?/g,
        () => "[^/]"
      ],
      [
        /^\//,
        () => "^"
      ],
      [
        /\//g,
        () => "\\/"
      ],
      [
        /^\^*\\\*\\\*\\\//,
        () => "^(?:.*\\/)?"
      ],
      [
        /^(?=[^^])/,
        function startingReplacer() {
          return !/\/(?!$)/.test(this) ? "(?:^|\\/)" : "^";
        }
      ],
      [
        /\\\/\\\*\\\*(?=\\\/|$)/g,
        (_, index, str) => index + 6 < str.length ? "(?:\\/[^\\/]+)*" : "\\/.+"
      ],
      [
        /(^|[^\\]+)\\\*(?=.+)/g,
        (_, p1) => `${p1}[^\\/]*`
      ],
      [
        /\\\\\\(?=[$.|*+(){^])/g,
        () => ESCAPE
      ],
      [
        /\\\\/g,
        () => ESCAPE
      ],
      [
        /(\\)?\[([^\]/]*?)(\\*)($|\])/g,
        (match, leadEscape, range, endEscape, close) => leadEscape === ESCAPE ? `\\[${range}${cleanRangeBackSlash(endEscape)}${close}` : close === "]" ? endEscape.length % 2 === 0 ? `[${sanitizeRange(range)}${endEscape}]` : "[]" : "[]"
      ],
      [
        /(?:[^*])$/,
        (match) => /\/$/.test(match) ? `${match}$` : `${match}(?=$|\\/$)`
      ],
      [
        /(\^|\\\/)?\\\*$/,
        (_, p1) => {
          const prefix2 = p1 ? `${p1}[^/]+` : "[^/]*";
          return `${prefix2}(?=$|\\/$)`;
        }
      ]
    ];
    var regexCache = /* @__PURE__ */ Object.create(null);
    var makeRegex = (pattern, ignoreCase) => {
      let source = regexCache[pattern];
      if (!source) {
        source = REPLACERS.reduce(
          (prev, current) => prev.replace(current[0], current[1].bind(pattern)),
          pattern
        );
        regexCache[pattern] = source;
      }
      return ignoreCase ? new RegExp(source, "i") : new RegExp(source);
    };
    var isString = (subject) => typeof subject === "string";
    var checkPattern = (pattern) => pattern && isString(pattern) && !REGEX_TEST_BLANK_LINE.test(pattern) && pattern.indexOf("#") !== 0;
    var splitPattern = (pattern) => pattern.split(REGEX_SPLITALL_CRLF);
    var IgnoreRule = class {
      constructor(origin, pattern, negative, regex) {
        this.origin = origin;
        this.pattern = pattern;
        this.negative = negative;
        this.regex = regex;
      }
    };
    var createRule = (pattern, ignoreCase) => {
      const origin = pattern;
      let negative = false;
      if (pattern.indexOf("!") === 0) {
        negative = true;
        pattern = pattern.substr(1);
      }
      pattern = pattern.replace(REGEX_REPLACE_LEADING_EXCAPED_EXCLAMATION, "!").replace(REGEX_REPLACE_LEADING_EXCAPED_HASH, "#");
      const regex = makeRegex(pattern, ignoreCase);
      return new IgnoreRule(
        origin,
        pattern,
        negative,
        regex
      );
    };
    var throwError = (message, Ctor) => {
      throw new Ctor(message);
    };
    var checkPath = (path4, originalPath, doThrow) => {
      if (!isString(path4)) {
        return doThrow(
          `path must be a string, but got \`${originalPath}\``,
          TypeError
        );
      }
      if (!path4) {
        return doThrow(`path must not be empty`, TypeError);
      }
      if (checkPath.isNotRelative(path4)) {
        const r2 = "`path.relative()`d";
        return doThrow(
          `path should be a ${r2} string, but got "${originalPath}"`,
          RangeError
        );
      }
      return true;
    };
    var isNotRelative = (path4) => REGEX_TEST_INVALID_PATH.test(path4);
    checkPath.isNotRelative = isNotRelative;
    checkPath.convert = (p) => p;
    var Ignore = class {
      constructor({
        ignorecase = true,
        ignoreCase = ignorecase,
        allowRelativePaths = false
      } = {}) {
        define2(this, KEY_IGNORE, true);
        this._rules = [];
        this._ignoreCase = ignoreCase;
        this._allowRelativePaths = allowRelativePaths;
        this._initCache();
      }
      _initCache() {
        this._ignoreCache = /* @__PURE__ */ Object.create(null);
        this._testCache = /* @__PURE__ */ Object.create(null);
      }
      _addPattern(pattern) {
        if (pattern && pattern[KEY_IGNORE]) {
          this._rules = this._rules.concat(pattern._rules);
          this._added = true;
          return;
        }
        if (checkPattern(pattern)) {
          const rule = createRule(pattern, this._ignoreCase);
          this._added = true;
          this._rules.push(rule);
        }
      }
      add(pattern) {
        this._added = false;
        makeArray(
          isString(pattern) ? splitPattern(pattern) : pattern
        ).forEach(this._addPattern, this);
        if (this._added) {
          this._initCache();
        }
        return this;
      }
      addPattern(pattern) {
        return this.add(pattern);
      }
      _testOne(path4, checkUnignored) {
        let ignored = false;
        let unignored = false;
        this._rules.forEach((rule) => {
          const { negative } = rule;
          if (unignored === negative && ignored !== unignored || negative && !ignored && !unignored && !checkUnignored) {
            return;
          }
          const matched = rule.regex.test(path4);
          if (matched) {
            ignored = !negative;
            unignored = negative;
          }
        });
        return {
          ignored,
          unignored
        };
      }
      _test(originalPath, cache, checkUnignored, slices) {
        const path4 = originalPath && checkPath.convert(originalPath);
        checkPath(
          path4,
          originalPath,
          this._allowRelativePaths ? RETURN_FALSE : throwError
        );
        return this._t(path4, cache, checkUnignored, slices);
      }
      _t(path4, cache, checkUnignored, slices) {
        if (path4 in cache) {
          return cache[path4];
        }
        if (!slices) {
          slices = path4.split(SLASH);
        }
        slices.pop();
        if (!slices.length) {
          return cache[path4] = this._testOne(path4, checkUnignored);
        }
        const parent = this._t(
          slices.join(SLASH) + SLASH,
          cache,
          checkUnignored,
          slices
        );
        return cache[path4] = parent.ignored ? parent : this._testOne(path4, checkUnignored);
      }
      ignores(path4) {
        return this._test(path4, this._ignoreCache, false).ignored;
      }
      createFilter() {
        return (path4) => !this.ignores(path4);
      }
      filter(paths) {
        return makeArray(paths).filter(this.createFilter());
      }
      test(path4) {
        return this._test(path4, this._testCache, true);
      }
    };
    var factory = (options) => new Ignore(options);
    var isPathValid = (path4) => checkPath(path4 && checkPath.convert(path4), path4, RETURN_FALSE);
    factory.isPathValid = isPathValid;
    factory.default = factory;
    module2.exports = factory;
    if (typeof process !== "undefined" && (process.env && process.env.IGNORE_TEST_WIN32 || process.platform === "win32")) {
      const makePosix = (str) => /^\\\\\?\\/.test(str) || /["<>|\u0000-\u001F]+/u.test(str) ? str : str.replace(/\\/g, "/");
      checkPath.convert = makePosix;
      const REGIX_IS_WINDOWS_PATH_ABSOLUTE = /^[a-z]:\//i;
      checkPath.isNotRelative = (path4) => REGIX_IS_WINDOWS_PATH_ABSOLUTE.test(path4) || isNotRelative(path4);
    }
  }
});

// node_modules/slash/index.js
var require_slash = __commonJS({
  "node_modules/slash/index.js"(exports, module2) {
    "use strict";
    module2.exports = (path4) => {
      const isExtendedLengthPath = /^\\\\\?\\/.test(path4);
      const hasNonAscii = /[^\u0000-\u0080]+/.test(path4);
      if (isExtendedLengthPath || hasNonAscii) {
        return path4;
      }
      return path4.replace(/\\/g, "/");
    };
  }
});

// node_modules/globby/gitignore.js
var require_gitignore = __commonJS({
  "node_modules/globby/gitignore.js"(exports, module2) {
    "use strict";
    var { promisify: promisify2 } = require("util");
    var fs4 = require("fs");
    var path4 = require("path");
    var fastGlob = require_out4();
    var gitIgnore = require_ignore();
    var slash = require_slash();
    var DEFAULT_IGNORE = [
      "**/node_modules/**",
      "**/flow-typed/**",
      "**/coverage/**",
      "**/.git"
    ];
    var readFileP = promisify2(fs4.readFile);
    var mapGitIgnorePatternTo = (base) => (ignore) => {
      if (ignore.startsWith("!")) {
        return "!" + path4.posix.join(base, ignore.slice(1));
      }
      return path4.posix.join(base, ignore);
    };
    var parseGitIgnore = (content, options) => {
      const base = slash(path4.relative(options.cwd, path4.dirname(options.fileName)));
      return content.split(/\r?\n/).filter(Boolean).filter((line) => !line.startsWith("#")).map(mapGitIgnorePatternTo(base));
    };
    var reduceIgnore = (files) => {
      const ignores = gitIgnore();
      for (const file of files) {
        ignores.add(parseGitIgnore(file.content, {
          cwd: file.cwd,
          fileName: file.filePath
        }));
      }
      return ignores;
    };
    var ensureAbsolutePathForCwd = (cwd, p) => {
      cwd = slash(cwd);
      if (path4.isAbsolute(p)) {
        if (slash(p).startsWith(cwd)) {
          return p;
        }
        throw new Error(`Path ${p} is not in cwd ${cwd}`);
      }
      return path4.join(cwd, p);
    };
    var getIsIgnoredPredecate = (ignores, cwd) => {
      return (p) => ignores.ignores(slash(path4.relative(cwd, ensureAbsolutePathForCwd(cwd, p.path || p))));
    };
    var getFile = async (file, cwd) => {
      const filePath = path4.join(cwd, file);
      const content = await readFileP(filePath, "utf8");
      return {
        cwd,
        filePath,
        content
      };
    };
    var getFileSync = (file, cwd) => {
      const filePath = path4.join(cwd, file);
      const content = fs4.readFileSync(filePath, "utf8");
      return {
        cwd,
        filePath,
        content
      };
    };
    var normalizeOptions = ({
      ignore = [],
      cwd = slash(process.cwd())
    } = {}) => {
      return { ignore, cwd };
    };
    module2.exports = async (options) => {
      options = normalizeOptions(options);
      const paths = await fastGlob("**/.gitignore", {
        ignore: DEFAULT_IGNORE.concat(options.ignore),
        cwd: options.cwd
      });
      const files = await Promise.all(paths.map((file) => getFile(file, options.cwd)));
      const ignores = reduceIgnore(files);
      return getIsIgnoredPredecate(ignores, options.cwd);
    };
    module2.exports.sync = (options) => {
      options = normalizeOptions(options);
      const paths = fastGlob.sync("**/.gitignore", {
        ignore: DEFAULT_IGNORE.concat(options.ignore),
        cwd: options.cwd
      });
      const files = paths.map((file) => getFileSync(file, options.cwd));
      const ignores = reduceIgnore(files);
      return getIsIgnoredPredecate(ignores, options.cwd);
    };
  }
});

// node_modules/globby/stream-utils.js
var require_stream_utils = __commonJS({
  "node_modules/globby/stream-utils.js"(exports, module2) {
    "use strict";
    var { Transform } = require("stream");
    var ObjectTransform = class extends Transform {
      constructor() {
        super({
          objectMode: true
        });
      }
    };
    var FilterStream = class extends ObjectTransform {
      constructor(filter) {
        super();
        this._filter = filter;
      }
      _transform(data, encoding, callback) {
        if (this._filter(data)) {
          this.push(data);
        }
        callback();
      }
    };
    var UniqueStream = class extends ObjectTransform {
      constructor() {
        super();
        this._pushed = /* @__PURE__ */ new Set();
      }
      _transform(data, encoding, callback) {
        if (!this._pushed.has(data)) {
          this.push(data);
          this._pushed.add(data);
        }
        callback();
      }
    };
    module2.exports = {
      FilterStream,
      UniqueStream
    };
  }
});

// node_modules/globby/index.js
var require_globby = __commonJS({
  "node_modules/globby/index.js"(exports, module2) {
    "use strict";
    var fs4 = require("fs");
    var arrayUnion = require_array_union();
    var merge2 = require_merge2();
    var fastGlob = require_out4();
    var dirGlob = require_dir_glob();
    var gitignore = require_gitignore();
    var { FilterStream, UniqueStream } = require_stream_utils();
    var DEFAULT_FILTER = () => false;
    var isNegative = (pattern) => pattern[0] === "!";
    var assertPatternsInput = (patterns) => {
      if (!patterns.every((pattern) => typeof pattern === "string")) {
        throw new TypeError("Patterns must be a string or an array of strings");
      }
    };
    var checkCwdOption = (options = {}) => {
      if (!options.cwd) {
        return;
      }
      let stat3;
      try {
        stat3 = fs4.statSync(options.cwd);
      } catch {
        return;
      }
      if (!stat3.isDirectory()) {
        throw new Error("The `cwd` option must be a path to a directory");
      }
    };
    var getPathString = (p) => p.stats instanceof fs4.Stats ? p.path : p;
    var generateGlobTasks = (patterns, taskOptions) => {
      patterns = arrayUnion([].concat(patterns));
      assertPatternsInput(patterns);
      checkCwdOption(taskOptions);
      const globTasks = [];
      taskOptions = {
        ignore: [],
        expandDirectories: true,
        ...taskOptions
      };
      for (const [index, pattern] of patterns.entries()) {
        if (isNegative(pattern)) {
          continue;
        }
        const ignore = patterns.slice(index).filter((pattern2) => isNegative(pattern2)).map((pattern2) => pattern2.slice(1));
        const options = {
          ...taskOptions,
          ignore: taskOptions.ignore.concat(ignore)
        };
        globTasks.push({ pattern, options });
      }
      return globTasks;
    };
    var globDirs = (task, fn) => {
      let options = {};
      if (task.options.cwd) {
        options.cwd = task.options.cwd;
      }
      if (Array.isArray(task.options.expandDirectories)) {
        options = {
          ...options,
          files: task.options.expandDirectories
        };
      } else if (typeof task.options.expandDirectories === "object") {
        options = {
          ...options,
          ...task.options.expandDirectories
        };
      }
      return fn(task.pattern, options);
    };
    var getPattern = (task, fn) => task.options.expandDirectories ? globDirs(task, fn) : [task.pattern];
    var getFilterSync = (options) => {
      return options && options.gitignore ? gitignore.sync({ cwd: options.cwd, ignore: options.ignore }) : DEFAULT_FILTER;
    };
    var globToTask = (task) => (glob) => {
      const { options } = task;
      if (options.ignore && Array.isArray(options.ignore) && options.expandDirectories) {
        options.ignore = dirGlob.sync(options.ignore);
      }
      return {
        pattern: glob,
        options
      };
    };
    module2.exports = async (patterns, options) => {
      const globTasks = generateGlobTasks(patterns, options);
      const getFilter = async () => {
        return options && options.gitignore ? gitignore({ cwd: options.cwd, ignore: options.ignore }) : DEFAULT_FILTER;
      };
      const getTasks = async () => {
        const tasks2 = await Promise.all(globTasks.map(async (task) => {
          const globs = await getPattern(task, dirGlob);
          return Promise.all(globs.map(globToTask(task)));
        }));
        return arrayUnion(...tasks2);
      };
      const [filter, tasks] = await Promise.all([getFilter(), getTasks()]);
      const paths = await Promise.all(tasks.map((task) => fastGlob(task.pattern, task.options)));
      return arrayUnion(...paths).filter((path_) => !filter(getPathString(path_)));
    };
    module2.exports.sync = (patterns, options) => {
      const globTasks = generateGlobTasks(patterns, options);
      const tasks = [];
      for (const task of globTasks) {
        const newTask = getPattern(task, dirGlob.sync).map(globToTask(task));
        tasks.push(...newTask);
      }
      const filter = getFilterSync(options);
      let matches = [];
      for (const task of tasks) {
        matches = arrayUnion(matches, fastGlob.sync(task.pattern, task.options));
      }
      return matches.filter((path_) => !filter(path_));
    };
    module2.exports.stream = (patterns, options) => {
      const globTasks = generateGlobTasks(patterns, options);
      const tasks = [];
      for (const task of globTasks) {
        const newTask = getPattern(task, dirGlob.sync).map(globToTask(task));
        tasks.push(...newTask);
      }
      const filter = getFilterSync(options);
      const filterStream = new FilterStream((p) => !filter(p));
      const uniqueStream = new UniqueStream();
      return merge2(tasks.map((task) => fastGlob.stream(task.pattern, task.options))).pipe(filterStream).pipe(uniqueStream);
    };
    module2.exports.generateGlobTasks = generateGlobTasks;
    module2.exports.hasMagic = (patterns, options) => [].concat(patterns).some((pattern) => fastGlob.isDynamicPattern(pattern, options));
    module2.exports.gitignore = gitignore;
  }
});

// node_modules/read-yaml-file/node_modules/graceful-fs/polyfills.js
var require_polyfills2 = __commonJS({
  "node_modules/read-yaml-file/node_modules/graceful-fs/polyfills.js"(exports, module2) {
    var constants = require("constants");
    var origCwd = process.cwd;
    var cwd = null;
    var platform = process.env.GRACEFUL_FS_PLATFORM || process.platform;
    process.cwd = function() {
      if (!cwd)
        cwd = origCwd.call(process);
      return cwd;
    };
    try {
      process.cwd();
    } catch (er) {
    }
    if (typeof process.chdir === "function") {
      chdir = process.chdir;
      process.chdir = function(d) {
        cwd = null;
        chdir.call(process, d);
      };
      if (Object.setPrototypeOf)
        Object.setPrototypeOf(process.chdir, chdir);
    }
    var chdir;
    module2.exports = patch;
    function patch(fs4) {
      if (constants.hasOwnProperty("O_SYMLINK") && process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
        patchLchmod(fs4);
      }
      if (!fs4.lutimes) {
        patchLutimes(fs4);
      }
      fs4.chown = chownFix(fs4.chown);
      fs4.fchown = chownFix(fs4.fchown);
      fs4.lchown = chownFix(fs4.lchown);
      fs4.chmod = chmodFix(fs4.chmod);
      fs4.fchmod = chmodFix(fs4.fchmod);
      fs4.lchmod = chmodFix(fs4.lchmod);
      fs4.chownSync = chownFixSync(fs4.chownSync);
      fs4.fchownSync = chownFixSync(fs4.fchownSync);
      fs4.lchownSync = chownFixSync(fs4.lchownSync);
      fs4.chmodSync = chmodFixSync(fs4.chmodSync);
      fs4.fchmodSync = chmodFixSync(fs4.fchmodSync);
      fs4.lchmodSync = chmodFixSync(fs4.lchmodSync);
      fs4.stat = statFix(fs4.stat);
      fs4.fstat = statFix(fs4.fstat);
      fs4.lstat = statFix(fs4.lstat);
      fs4.statSync = statFixSync(fs4.statSync);
      fs4.fstatSync = statFixSync(fs4.fstatSync);
      fs4.lstatSync = statFixSync(fs4.lstatSync);
      if (fs4.chmod && !fs4.lchmod) {
        fs4.lchmod = function(path4, mode, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs4.lchmodSync = function() {
        };
      }
      if (fs4.chown && !fs4.lchown) {
        fs4.lchown = function(path4, uid, gid, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs4.lchownSync = function() {
        };
      }
      if (platform === "win32") {
        fs4.rename = typeof fs4.rename !== "function" ? fs4.rename : function(fs$rename) {
          function rename(from, to, cb) {
            var start = Date.now();
            var backoff = 0;
            fs$rename(from, to, function CB(er) {
              if (er && (er.code === "EACCES" || er.code === "EPERM") && Date.now() - start < 6e4) {
                setTimeout(function() {
                  fs4.stat(to, function(stater, st) {
                    if (stater && stater.code === "ENOENT")
                      fs$rename(from, to, CB);
                    else
                      cb(er);
                  });
                }, backoff);
                if (backoff < 100)
                  backoff += 10;
                return;
              }
              if (cb)
                cb(er);
            });
          }
          if (Object.setPrototypeOf)
            Object.setPrototypeOf(rename, fs$rename);
          return rename;
        }(fs4.rename);
      }
      fs4.read = typeof fs4.read !== "function" ? fs4.read : function(fs$read) {
        function read2(fd, buffer, offset, length, position, callback_) {
          var callback;
          if (callback_ && typeof callback_ === "function") {
            var eagCounter = 0;
            callback = function(er, _, __) {
              if (er && er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                return fs$read.call(fs4, fd, buffer, offset, length, position, callback);
              }
              callback_.apply(this, arguments);
            };
          }
          return fs$read.call(fs4, fd, buffer, offset, length, position, callback);
        }
        if (Object.setPrototypeOf)
          Object.setPrototypeOf(read2, fs$read);
        return read2;
      }(fs4.read);
      fs4.readSync = typeof fs4.readSync !== "function" ? fs4.readSync : function(fs$readSync) {
        return function(fd, buffer, offset, length, position) {
          var eagCounter = 0;
          while (true) {
            try {
              return fs$readSync.call(fs4, fd, buffer, offset, length, position);
            } catch (er) {
              if (er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                continue;
              }
              throw er;
            }
          }
        };
      }(fs4.readSync);
      function patchLchmod(fs5) {
        fs5.lchmod = function(path4, mode, callback) {
          fs5.open(
            path4,
            constants.O_WRONLY | constants.O_SYMLINK,
            mode,
            function(err, fd) {
              if (err) {
                if (callback)
                  callback(err);
                return;
              }
              fs5.fchmod(fd, mode, function(err2) {
                fs5.close(fd, function(err22) {
                  if (callback)
                    callback(err2 || err22);
                });
              });
            }
          );
        };
        fs5.lchmodSync = function(path4, mode) {
          var fd = fs5.openSync(path4, constants.O_WRONLY | constants.O_SYMLINK, mode);
          var threw = true;
          var ret;
          try {
            ret = fs5.fchmodSync(fd, mode);
            threw = false;
          } finally {
            if (threw) {
              try {
                fs5.closeSync(fd);
              } catch (er) {
              }
            } else {
              fs5.closeSync(fd);
            }
          }
          return ret;
        };
      }
      function patchLutimes(fs5) {
        if (constants.hasOwnProperty("O_SYMLINK") && fs5.futimes) {
          fs5.lutimes = function(path4, at, mt, cb) {
            fs5.open(path4, constants.O_SYMLINK, function(er, fd) {
              if (er) {
                if (cb)
                  cb(er);
                return;
              }
              fs5.futimes(fd, at, mt, function(er2) {
                fs5.close(fd, function(er22) {
                  if (cb)
                    cb(er2 || er22);
                });
              });
            });
          };
          fs5.lutimesSync = function(path4, at, mt) {
            var fd = fs5.openSync(path4, constants.O_SYMLINK);
            var ret;
            var threw = true;
            try {
              ret = fs5.futimesSync(fd, at, mt);
              threw = false;
            } finally {
              if (threw) {
                try {
                  fs5.closeSync(fd);
                } catch (er) {
                }
              } else {
                fs5.closeSync(fd);
              }
            }
            return ret;
          };
        } else if (fs5.futimes) {
          fs5.lutimes = function(_a4, _b, _c, cb) {
            if (cb)
              process.nextTick(cb);
          };
          fs5.lutimesSync = function() {
          };
        }
      }
      function chmodFix(orig) {
        if (!orig)
          return orig;
        return function(target, mode, cb) {
          return orig.call(fs4, target, mode, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chmodFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, mode) {
          try {
            return orig.call(fs4, target, mode);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function chownFix(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid, cb) {
          return orig.call(fs4, target, uid, gid, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chownFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid) {
          try {
            return orig.call(fs4, target, uid, gid);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function statFix(orig) {
        if (!orig)
          return orig;
        return function(target, options, cb) {
          if (typeof options === "function") {
            cb = options;
            options = null;
          }
          function callback(er, stats) {
            if (stats) {
              if (stats.uid < 0)
                stats.uid += 4294967296;
              if (stats.gid < 0)
                stats.gid += 4294967296;
            }
            if (cb)
              cb.apply(this, arguments);
          }
          return options ? orig.call(fs4, target, options, callback) : orig.call(fs4, target, callback);
        };
      }
      function statFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, options) {
          var stats = options ? orig.call(fs4, target, options) : orig.call(fs4, target);
          if (stats) {
            if (stats.uid < 0)
              stats.uid += 4294967296;
            if (stats.gid < 0)
              stats.gid += 4294967296;
          }
          return stats;
        };
      }
      function chownErOk(er) {
        if (!er)
          return true;
        if (er.code === "ENOSYS")
          return true;
        var nonroot = !process.getuid || process.getuid() !== 0;
        if (nonroot) {
          if (er.code === "EINVAL" || er.code === "EPERM")
            return true;
        }
        return false;
      }
    }
  }
});

// node_modules/read-yaml-file/node_modules/graceful-fs/legacy-streams.js
var require_legacy_streams2 = __commonJS({
  "node_modules/read-yaml-file/node_modules/graceful-fs/legacy-streams.js"(exports, module2) {
    var Stream4 = require("stream").Stream;
    module2.exports = legacy;
    function legacy(fs4) {
      return {
        ReadStream,
        WriteStream
      };
      function ReadStream(path4, options) {
        if (!(this instanceof ReadStream))
          return new ReadStream(path4, options);
        Stream4.call(this);
        var self2 = this;
        this.path = path4;
        this.fd = null;
        this.readable = true;
        this.paused = false;
        this.flags = "r";
        this.mode = 438;
        this.bufferSize = 64 * 1024;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.encoding)
          this.setEncoding(this.encoding);
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.end === void 0) {
            this.end = Infinity;
          } else if ("number" !== typeof this.end) {
            throw TypeError("end must be a Number");
          }
          if (this.start > this.end) {
            throw new Error("start must be <= end");
          }
          this.pos = this.start;
        }
        if (this.fd !== null) {
          process.nextTick(function() {
            self2._read();
          });
          return;
        }
        fs4.open(this.path, this.flags, this.mode, function(err, fd) {
          if (err) {
            self2.emit("error", err);
            self2.readable = false;
            return;
          }
          self2.fd = fd;
          self2.emit("open", fd);
          self2._read();
        });
      }
      function WriteStream(path4, options) {
        if (!(this instanceof WriteStream))
          return new WriteStream(path4, options);
        Stream4.call(this);
        this.path = path4;
        this.fd = null;
        this.writable = true;
        this.flags = "w";
        this.encoding = "binary";
        this.mode = 438;
        this.bytesWritten = 0;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.start < 0) {
            throw new Error("start must be >= zero");
          }
          this.pos = this.start;
        }
        this.busy = false;
        this._queue = [];
        if (this.fd === null) {
          this._open = fs4.open;
          this._queue.push([this._open, this.path, this.flags, this.mode, void 0]);
          this.flush();
        }
      }
    }
  }
});

// node_modules/read-yaml-file/node_modules/graceful-fs/clone.js
var require_clone2 = __commonJS({
  "node_modules/read-yaml-file/node_modules/graceful-fs/clone.js"(exports, module2) {
    "use strict";
    module2.exports = clone3;
    var getPrototypeOf = Object.getPrototypeOf || function(obj) {
      return obj.__proto__;
    };
    function clone3(obj) {
      if (obj === null || typeof obj !== "object")
        return obj;
      if (obj instanceof Object)
        var copy = { __proto__: getPrototypeOf(obj) };
      else
        var copy = /* @__PURE__ */ Object.create(null);
      Object.getOwnPropertyNames(obj).forEach(function(key) {
        Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key));
      });
      return copy;
    }
  }
});

// node_modules/read-yaml-file/node_modules/graceful-fs/graceful-fs.js
var require_graceful_fs2 = __commonJS({
  "node_modules/read-yaml-file/node_modules/graceful-fs/graceful-fs.js"(exports, module2) {
    var fs4 = require("fs");
    var polyfills = require_polyfills2();
    var legacy = require_legacy_streams2();
    var clone3 = require_clone2();
    var util2 = require("util");
    var gracefulQueue;
    var previousSymbol;
    if (typeof Symbol === "function" && typeof Symbol.for === "function") {
      gracefulQueue = Symbol.for("graceful-fs.queue");
      previousSymbol = Symbol.for("graceful-fs.previous");
    } else {
      gracefulQueue = "___graceful-fs.queue";
      previousSymbol = "___graceful-fs.previous";
    }
    function noop2() {
    }
    function publishQueue(context2, queue2) {
      Object.defineProperty(context2, gracefulQueue, {
        get: function() {
          return queue2;
        }
      });
    }
    var debug = noop2;
    if (util2.debuglog)
      debug = util2.debuglog("gfs4");
    else if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || ""))
      debug = function() {
        var m2 = util2.format.apply(util2, arguments);
        m2 = "GFS4: " + m2.split(/\n/).join("\nGFS4: ");
        console.error(m2);
      };
    if (!fs4[gracefulQueue]) {
      queue = global[gracefulQueue] || [];
      publishQueue(fs4, queue);
      fs4.close = function(fs$close) {
        function close(fd, cb) {
          return fs$close.call(fs4, fd, function(err) {
            if (!err) {
              resetQueue();
            }
            if (typeof cb === "function")
              cb.apply(this, arguments);
          });
        }
        Object.defineProperty(close, previousSymbol, {
          value: fs$close
        });
        return close;
      }(fs4.close);
      fs4.closeSync = function(fs$closeSync) {
        function closeSync(fd) {
          fs$closeSync.apply(fs4, arguments);
          resetQueue();
        }
        Object.defineProperty(closeSync, previousSymbol, {
          value: fs$closeSync
        });
        return closeSync;
      }(fs4.closeSync);
      if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || "")) {
        process.on("exit", function() {
          debug(fs4[gracefulQueue]);
          require("assert").equal(fs4[gracefulQueue].length, 0);
        });
      }
    }
    var queue;
    if (!global[gracefulQueue]) {
      publishQueue(global, fs4[gracefulQueue]);
    }
    module2.exports = patch(clone3(fs4));
    if (process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs4.__patched) {
      module2.exports = patch(fs4);
      fs4.__patched = true;
    }
    function patch(fs5) {
      polyfills(fs5);
      fs5.gracefulify = patch;
      fs5.createReadStream = createReadStream2;
      fs5.createWriteStream = createWriteStream;
      var fs$readFile = fs5.readFile;
      fs5.readFile = readFile;
      function readFile(path4, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$readFile(path4, options, cb);
        function go$readFile(path5, options2, cb2, startTime) {
          return fs$readFile(path5, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$readFile, [path5, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$writeFile = fs5.writeFile;
      fs5.writeFile = writeFile2;
      function writeFile2(path4, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$writeFile(path4, data, options, cb);
        function go$writeFile(path5, data2, options2, cb2, startTime) {
          return fs$writeFile(path5, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$writeFile, [path5, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$appendFile = fs5.appendFile;
      if (fs$appendFile)
        fs5.appendFile = appendFile;
      function appendFile(path4, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$appendFile(path4, data, options, cb);
        function go$appendFile(path5, data2, options2, cb2, startTime) {
          return fs$appendFile(path5, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$appendFile, [path5, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$copyFile = fs5.copyFile;
      if (fs$copyFile)
        fs5.copyFile = copyFile;
      function copyFile(src, dest, flags, cb) {
        if (typeof flags === "function") {
          cb = flags;
          flags = 0;
        }
        return go$copyFile(src, dest, flags, cb);
        function go$copyFile(src2, dest2, flags2, cb2, startTime) {
          return fs$copyFile(src2, dest2, flags2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$copyFile, [src2, dest2, flags2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$readdir = fs5.readdir;
      fs5.readdir = readdir;
      var noReaddirOptionVersions = /^v[0-5]\./;
      function readdir(path4, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        var go$readdir = noReaddirOptionVersions.test(process.version) ? function go$readdir2(path5, options2, cb2, startTime) {
          return fs$readdir(path5, fs$readdirCallback(
            path5,
            options2,
            cb2,
            startTime
          ));
        } : function go$readdir2(path5, options2, cb2, startTime) {
          return fs$readdir(path5, options2, fs$readdirCallback(
            path5,
            options2,
            cb2,
            startTime
          ));
        };
        return go$readdir(path4, options, cb);
        function fs$readdirCallback(path5, options2, cb2, startTime) {
          return function(err, files) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([
                go$readdir,
                [path5, options2, cb2],
                err,
                startTime || Date.now(),
                Date.now()
              ]);
            else {
              if (files && files.sort)
                files.sort();
              if (typeof cb2 === "function")
                cb2.call(this, err, files);
            }
          };
        }
      }
      if (process.version.substr(0, 4) === "v0.8") {
        var legStreams = legacy(fs5);
        ReadStream = legStreams.ReadStream;
        WriteStream = legStreams.WriteStream;
      }
      var fs$ReadStream = fs5.ReadStream;
      if (fs$ReadStream) {
        ReadStream.prototype = Object.create(fs$ReadStream.prototype);
        ReadStream.prototype.open = ReadStream$open;
      }
      var fs$WriteStream = fs5.WriteStream;
      if (fs$WriteStream) {
        WriteStream.prototype = Object.create(fs$WriteStream.prototype);
        WriteStream.prototype.open = WriteStream$open;
      }
      Object.defineProperty(fs5, "ReadStream", {
        get: function() {
          return ReadStream;
        },
        set: function(val) {
          ReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      Object.defineProperty(fs5, "WriteStream", {
        get: function() {
          return WriteStream;
        },
        set: function(val) {
          WriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileReadStream = ReadStream;
      Object.defineProperty(fs5, "FileReadStream", {
        get: function() {
          return FileReadStream;
        },
        set: function(val) {
          FileReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileWriteStream = WriteStream;
      Object.defineProperty(fs5, "FileWriteStream", {
        get: function() {
          return FileWriteStream;
        },
        set: function(val) {
          FileWriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      function ReadStream(path4, options) {
        if (this instanceof ReadStream)
          return fs$ReadStream.apply(this, arguments), this;
        else
          return ReadStream.apply(Object.create(ReadStream.prototype), arguments);
      }
      function ReadStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            if (that.autoClose)
              that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
            that.read();
          }
        });
      }
      function WriteStream(path4, options) {
        if (this instanceof WriteStream)
          return fs$WriteStream.apply(this, arguments), this;
        else
          return WriteStream.apply(Object.create(WriteStream.prototype), arguments);
      }
      function WriteStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
          }
        });
      }
      function createReadStream2(path4, options) {
        return new fs5.ReadStream(path4, options);
      }
      function createWriteStream(path4, options) {
        return new fs5.WriteStream(path4, options);
      }
      var fs$open = fs5.open;
      fs5.open = open;
      function open(path4, flags, mode, cb) {
        if (typeof mode === "function")
          cb = mode, mode = null;
        return go$open(path4, flags, mode, cb);
        function go$open(path5, flags2, mode2, cb2, startTime) {
          return fs$open(path5, flags2, mode2, function(err, fd) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$open, [path5, flags2, mode2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      return fs5;
    }
    function enqueue(elem) {
      debug("ENQUEUE", elem[0].name, elem[1]);
      fs4[gracefulQueue].push(elem);
      retry();
    }
    var retryTimer;
    function resetQueue() {
      var now = Date.now();
      for (var i2 = 0; i2 < fs4[gracefulQueue].length; ++i2) {
        if (fs4[gracefulQueue][i2].length > 2) {
          fs4[gracefulQueue][i2][3] = now;
          fs4[gracefulQueue][i2][4] = now;
        }
      }
      retry();
    }
    function retry() {
      clearTimeout(retryTimer);
      retryTimer = void 0;
      if (fs4[gracefulQueue].length === 0)
        return;
      var elem = fs4[gracefulQueue].shift();
      var fn = elem[0];
      var args = elem[1];
      var err = elem[2];
      var startTime = elem[3];
      var lastTime = elem[4];
      if (startTime === void 0) {
        debug("RETRY", fn.name, args);
        fn.apply(null, args);
      } else if (Date.now() - startTime >= 6e4) {
        debug("TIMEOUT", fn.name, args);
        var cb = args.pop();
        if (typeof cb === "function")
          cb.call(null, err);
      } else {
        var sinceAttempt = Date.now() - lastTime;
        var sinceStart = Math.max(lastTime - startTime, 1);
        var desiredDelay = Math.min(sinceStart * 1.2, 100);
        if (sinceAttempt >= desiredDelay) {
          debug("RETRY", fn.name, args);
          fn.apply(null, args.concat([startTime]));
        } else {
          fs4[gracefulQueue].push(elem);
        }
      }
      if (retryTimer === void 0) {
        retryTimer = setTimeout(retry, 0);
      }
    }
  }
});

// node_modules/pify/index.js
var require_pify = __commonJS({
  "node_modules/pify/index.js"(exports, module2) {
    "use strict";
    var processFn = (fn, options) => function(...args) {
      const P = options.promiseModule;
      return new P((resolve, reject) => {
        if (options.multiArgs) {
          args.push((...result) => {
            if (options.errorFirst) {
              if (result[0]) {
                reject(result);
              } else {
                result.shift();
                resolve(result);
              }
            } else {
              resolve(result);
            }
          });
        } else if (options.errorFirst) {
          args.push((error, result) => {
            if (error) {
              reject(error);
            } else {
              resolve(result);
            }
          });
        } else {
          args.push(resolve);
        }
        fn.apply(this, args);
      });
    };
    module2.exports = (input, options) => {
      options = Object.assign({
        exclude: [/.+(Sync|Stream)$/],
        errorFirst: true,
        promiseModule: Promise
      }, options);
      const objType = typeof input;
      if (!(input !== null && (objType === "object" || objType === "function"))) {
        throw new TypeError(`Expected \`input\` to be a \`Function\` or \`Object\`, got \`${input === null ? "null" : objType}\``);
      }
      const filter = (key) => {
        const match = (pattern) => typeof pattern === "string" ? key === pattern : pattern.test(key);
        return options.include ? options.include.some(match) : !options.exclude.some(match);
      };
      let ret;
      if (objType === "function") {
        ret = function(...args) {
          return options.excludeMain ? input(...args) : processFn(input, options).apply(this, args);
        };
      } else {
        ret = Object.create(Object.getPrototypeOf(input));
      }
      for (const key in input) {
        const property = input[key];
        ret[key] = typeof property === "function" && filter(key) ? processFn(property, options) : property;
      }
      return ret;
    };
  }
});

// node_modules/strip-bom/index.js
var require_strip_bom = __commonJS({
  "node_modules/strip-bom/index.js"(exports, module2) {
    "use strict";
    module2.exports = (x2) => {
      if (typeof x2 !== "string") {
        throw new TypeError("Expected a string, got " + typeof x2);
      }
      if (x2.charCodeAt(0) === 65279) {
        return x2.slice(1);
      }
      return x2;
    };
  }
});

// node_modules/js-yaml/lib/js-yaml/common.js
var require_common2 = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/common.js"(exports, module2) {
    "use strict";
    function isNothing(subject) {
      return typeof subject === "undefined" || subject === null;
    }
    function isObject3(subject) {
      return typeof subject === "object" && subject !== null;
    }
    function toArray(sequence) {
      if (Array.isArray(sequence))
        return sequence;
      else if (isNothing(sequence))
        return [];
      return [sequence];
    }
    function extend(target, source) {
      var index, length, key, sourceKeys;
      if (source) {
        sourceKeys = Object.keys(source);
        for (index = 0, length = sourceKeys.length; index < length; index += 1) {
          key = sourceKeys[index];
          target[key] = source[key];
        }
      }
      return target;
    }
    function repeat(string, count) {
      var result = "", cycle;
      for (cycle = 0; cycle < count; cycle += 1) {
        result += string;
      }
      return result;
    }
    function isNegativeZero(number) {
      return number === 0 && Number.NEGATIVE_INFINITY === 1 / number;
    }
    module2.exports.isNothing = isNothing;
    module2.exports.isObject = isObject3;
    module2.exports.toArray = toArray;
    module2.exports.repeat = repeat;
    module2.exports.isNegativeZero = isNegativeZero;
    module2.exports.extend = extend;
  }
});

// node_modules/js-yaml/lib/js-yaml/exception.js
var require_exception = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/exception.js"(exports, module2) {
    "use strict";
    function YAMLException(reason, mark) {
      Error.call(this);
      this.name = "YAMLException";
      this.reason = reason;
      this.mark = mark;
      this.message = (this.reason || "(unknown reason)") + (this.mark ? " " + this.mark.toString() : "");
      if (Error.captureStackTrace) {
        Error.captureStackTrace(this, this.constructor);
      } else {
        this.stack = new Error().stack || "";
      }
    }
    YAMLException.prototype = Object.create(Error.prototype);
    YAMLException.prototype.constructor = YAMLException;
    YAMLException.prototype.toString = function toString(compact) {
      var result = this.name + ": ";
      result += this.reason || "(unknown reason)";
      if (!compact && this.mark) {
        result += " " + this.mark.toString();
      }
      return result;
    };
    module2.exports = YAMLException;
  }
});

// node_modules/js-yaml/lib/js-yaml/mark.js
var require_mark = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/mark.js"(exports, module2) {
    "use strict";
    var common = require_common2();
    function Mark(name, buffer, position, line, column) {
      this.name = name;
      this.buffer = buffer;
      this.position = position;
      this.line = line;
      this.column = column;
    }
    Mark.prototype.getSnippet = function getSnippet(indent, maxLength) {
      var head, start, tail, end, snippet;
      if (!this.buffer)
        return null;
      indent = indent || 4;
      maxLength = maxLength || 75;
      head = "";
      start = this.position;
      while (start > 0 && "\0\r\n\x85\u2028\u2029".indexOf(this.buffer.charAt(start - 1)) === -1) {
        start -= 1;
        if (this.position - start > maxLength / 2 - 1) {
          head = " ... ";
          start += 5;
          break;
        }
      }
      tail = "";
      end = this.position;
      while (end < this.buffer.length && "\0\r\n\x85\u2028\u2029".indexOf(this.buffer.charAt(end)) === -1) {
        end += 1;
        if (end - this.position > maxLength / 2 - 1) {
          tail = " ... ";
          end -= 5;
          break;
        }
      }
      snippet = this.buffer.slice(start, end);
      return common.repeat(" ", indent) + head + snippet + tail + "\n" + common.repeat(" ", indent + this.position - start + head.length) + "^";
    };
    Mark.prototype.toString = function toString(compact) {
      var snippet, where = "";
      if (this.name) {
        where += 'in "' + this.name + '" ';
      }
      where += "at line " + (this.line + 1) + ", column " + (this.column + 1);
      if (!compact) {
        snippet = this.getSnippet();
        if (snippet) {
          where += ":\n" + snippet;
        }
      }
      return where;
    };
    module2.exports = Mark;
  }
});

// node_modules/js-yaml/lib/js-yaml/type.js
var require_type = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type.js"(exports, module2) {
    "use strict";
    var YAMLException = require_exception();
    var TYPE_CONSTRUCTOR_OPTIONS = [
      "kind",
      "resolve",
      "construct",
      "instanceOf",
      "predicate",
      "represent",
      "defaultStyle",
      "styleAliases"
    ];
    var YAML_NODE_KINDS = [
      "scalar",
      "sequence",
      "mapping"
    ];
    function compileStyleAliases(map) {
      var result = {};
      if (map !== null) {
        Object.keys(map).forEach(function(style) {
          map[style].forEach(function(alias) {
            result[String(alias)] = style;
          });
        });
      }
      return result;
    }
    function Type(tag, options) {
      options = options || {};
      Object.keys(options).forEach(function(name) {
        if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1) {
          throw new YAMLException('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
        }
      });
      this.tag = tag;
      this.kind = options["kind"] || null;
      this.resolve = options["resolve"] || function() {
        return true;
      };
      this.construct = options["construct"] || function(data) {
        return data;
      };
      this.instanceOf = options["instanceOf"] || null;
      this.predicate = options["predicate"] || null;
      this.represent = options["represent"] || null;
      this.defaultStyle = options["defaultStyle"] || null;
      this.styleAliases = compileStyleAliases(options["styleAliases"] || null);
      if (YAML_NODE_KINDS.indexOf(this.kind) === -1) {
        throw new YAMLException('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
      }
    }
    module2.exports = Type;
  }
});

// node_modules/js-yaml/lib/js-yaml/schema.js
var require_schema = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/schema.js"(exports, module2) {
    "use strict";
    var common = require_common2();
    var YAMLException = require_exception();
    var Type = require_type();
    function compileList(schema, name, result) {
      var exclude = [];
      schema.include.forEach(function(includedSchema) {
        result = compileList(includedSchema, name, result);
      });
      schema[name].forEach(function(currentType) {
        result.forEach(function(previousType, previousIndex) {
          if (previousType.tag === currentType.tag && previousType.kind === currentType.kind) {
            exclude.push(previousIndex);
          }
        });
        result.push(currentType);
      });
      return result.filter(function(type, index) {
        return exclude.indexOf(index) === -1;
      });
    }
    function compileMap() {
      var result = {
        scalar: {},
        sequence: {},
        mapping: {},
        fallback: {}
      }, index, length;
      function collectType(type) {
        result[type.kind][type.tag] = result["fallback"][type.tag] = type;
      }
      for (index = 0, length = arguments.length; index < length; index += 1) {
        arguments[index].forEach(collectType);
      }
      return result;
    }
    function Schema(definition) {
      this.include = definition.include || [];
      this.implicit = definition.implicit || [];
      this.explicit = definition.explicit || [];
      this.implicit.forEach(function(type) {
        if (type.loadKind && type.loadKind !== "scalar") {
          throw new YAMLException("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
        }
      });
      this.compiledImplicit = compileList(this, "implicit", []);
      this.compiledExplicit = compileList(this, "explicit", []);
      this.compiledTypeMap = compileMap(this.compiledImplicit, this.compiledExplicit);
    }
    Schema.DEFAULT = null;
    Schema.create = function createSchema() {
      var schemas, types3;
      switch (arguments.length) {
        case 1:
          schemas = Schema.DEFAULT;
          types3 = arguments[0];
          break;
        case 2:
          schemas = arguments[0];
          types3 = arguments[1];
          break;
        default:
          throw new YAMLException("Wrong number of arguments for Schema.create function");
      }
      schemas = common.toArray(schemas);
      types3 = common.toArray(types3);
      if (!schemas.every(function(schema) {
        return schema instanceof Schema;
      })) {
        throw new YAMLException("Specified list of super schemas (or a single Schema object) contains a non-Schema object.");
      }
      if (!types3.every(function(type) {
        return type instanceof Type;
      })) {
        throw new YAMLException("Specified list of YAML types (or a single Type object) contains a non-Type object.");
      }
      return new Schema({
        include: schemas,
        explicit: types3
      });
    };
    module2.exports = Schema;
  }
});

// node_modules/js-yaml/lib/js-yaml/type/str.js
var require_str = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/str.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    module2.exports = new Type("tag:yaml.org,2002:str", {
      kind: "scalar",
      construct: function(data) {
        return data !== null ? data : "";
      }
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/seq.js
var require_seq = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/seq.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    module2.exports = new Type("tag:yaml.org,2002:seq", {
      kind: "sequence",
      construct: function(data) {
        return data !== null ? data : [];
      }
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/map.js
var require_map = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/map.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    module2.exports = new Type("tag:yaml.org,2002:map", {
      kind: "mapping",
      construct: function(data) {
        return data !== null ? data : {};
      }
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/schema/failsafe.js
var require_failsafe = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/schema/failsafe.js"(exports, module2) {
    "use strict";
    var Schema = require_schema();
    module2.exports = new Schema({
      explicit: [
        require_str(),
        require_seq(),
        require_map()
      ]
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/null.js
var require_null = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/null.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    function resolveYamlNull(data) {
      if (data === null)
        return true;
      var max = data.length;
      return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
    }
    function constructYamlNull() {
      return null;
    }
    function isNull(object) {
      return object === null;
    }
    module2.exports = new Type("tag:yaml.org,2002:null", {
      kind: "scalar",
      resolve: resolveYamlNull,
      construct: constructYamlNull,
      predicate: isNull,
      represent: {
        canonical: function() {
          return "~";
        },
        lowercase: function() {
          return "null";
        },
        uppercase: function() {
          return "NULL";
        },
        camelcase: function() {
          return "Null";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/bool.js
var require_bool = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/bool.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    function resolveYamlBoolean(data) {
      if (data === null)
        return false;
      var max = data.length;
      return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
    }
    function constructYamlBoolean(data) {
      return data === "true" || data === "True" || data === "TRUE";
    }
    function isBoolean(object) {
      return Object.prototype.toString.call(object) === "[object Boolean]";
    }
    module2.exports = new Type("tag:yaml.org,2002:bool", {
      kind: "scalar",
      resolve: resolveYamlBoolean,
      construct: constructYamlBoolean,
      predicate: isBoolean,
      represent: {
        lowercase: function(object) {
          return object ? "true" : "false";
        },
        uppercase: function(object) {
          return object ? "TRUE" : "FALSE";
        },
        camelcase: function(object) {
          return object ? "True" : "False";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/int.js
var require_int = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/int.js"(exports, module2) {
    "use strict";
    var common = require_common2();
    var Type = require_type();
    function isHexCode(c) {
      return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
    }
    function isOctCode(c) {
      return 48 <= c && c <= 55;
    }
    function isDecCode(c) {
      return 48 <= c && c <= 57;
    }
    function resolveYamlInteger(data) {
      if (data === null)
        return false;
      var max = data.length, index = 0, hasDigits = false, ch;
      if (!max)
        return false;
      ch = data[index];
      if (ch === "-" || ch === "+") {
        ch = data[++index];
      }
      if (ch === "0") {
        if (index + 1 === max)
          return true;
        ch = data[++index];
        if (ch === "b") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_")
              continue;
            if (ch !== "0" && ch !== "1")
              return false;
            hasDigits = true;
          }
          return hasDigits && ch !== "_";
        }
        if (ch === "x") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_")
              continue;
            if (!isHexCode(data.charCodeAt(index)))
              return false;
            hasDigits = true;
          }
          return hasDigits && ch !== "_";
        }
        for (; index < max; index++) {
          ch = data[index];
          if (ch === "_")
            continue;
          if (!isOctCode(data.charCodeAt(index)))
            return false;
          hasDigits = true;
        }
        return hasDigits && ch !== "_";
      }
      if (ch === "_")
        return false;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_")
          continue;
        if (ch === ":")
          break;
        if (!isDecCode(data.charCodeAt(index))) {
          return false;
        }
        hasDigits = true;
      }
      if (!hasDigits || ch === "_")
        return false;
      if (ch !== ":")
        return true;
      return /^(:[0-5]?[0-9])+$/.test(data.slice(index));
    }
    function constructYamlInteger(data) {
      var value = data, sign = 1, ch, base, digits = [];
      if (value.indexOf("_") !== -1) {
        value = value.replace(/_/g, "");
      }
      ch = value[0];
      if (ch === "-" || ch === "+") {
        if (ch === "-")
          sign = -1;
        value = value.slice(1);
        ch = value[0];
      }
      if (value === "0")
        return 0;
      if (ch === "0") {
        if (value[1] === "b")
          return sign * parseInt(value.slice(2), 2);
        if (value[1] === "x")
          return sign * parseInt(value, 16);
        return sign * parseInt(value, 8);
      }
      if (value.indexOf(":") !== -1) {
        value.split(":").forEach(function(v) {
          digits.unshift(parseInt(v, 10));
        });
        value = 0;
        base = 1;
        digits.forEach(function(d) {
          value += d * base;
          base *= 60;
        });
        return sign * value;
      }
      return sign * parseInt(value, 10);
    }
    function isInteger(object) {
      return Object.prototype.toString.call(object) === "[object Number]" && (object % 1 === 0 && !common.isNegativeZero(object));
    }
    module2.exports = new Type("tag:yaml.org,2002:int", {
      kind: "scalar",
      resolve: resolveYamlInteger,
      construct: constructYamlInteger,
      predicate: isInteger,
      represent: {
        binary: function(obj) {
          return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
        },
        octal: function(obj) {
          return obj >= 0 ? "0" + obj.toString(8) : "-0" + obj.toString(8).slice(1);
        },
        decimal: function(obj) {
          return obj.toString(10);
        },
        hexadecimal: function(obj) {
          return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
        }
      },
      defaultStyle: "decimal",
      styleAliases: {
        binary: [2, "bin"],
        octal: [8, "oct"],
        decimal: [10, "dec"],
        hexadecimal: [16, "hex"]
      }
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/float.js
var require_float = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/float.js"(exports, module2) {
    "use strict";
    var common = require_common2();
    var Type = require_type();
    var YAML_FLOAT_PATTERN = new RegExp(
      "^(?:[-+]?(?:0|[1-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\\.[0-9_]*|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$"
    );
    function resolveYamlFloat(data) {
      if (data === null)
        return false;
      if (!YAML_FLOAT_PATTERN.test(data) || data[data.length - 1] === "_") {
        return false;
      }
      return true;
    }
    function constructYamlFloat(data) {
      var value, sign, base, digits;
      value = data.replace(/_/g, "").toLowerCase();
      sign = value[0] === "-" ? -1 : 1;
      digits = [];
      if ("+-".indexOf(value[0]) >= 0) {
        value = value.slice(1);
      }
      if (value === ".inf") {
        return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
      } else if (value === ".nan") {
        return NaN;
      } else if (value.indexOf(":") >= 0) {
        value.split(":").forEach(function(v) {
          digits.unshift(parseFloat(v, 10));
        });
        value = 0;
        base = 1;
        digits.forEach(function(d) {
          value += d * base;
          base *= 60;
        });
        return sign * value;
      }
      return sign * parseFloat(value, 10);
    }
    var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
    function representYamlFloat(object, style) {
      var res;
      if (isNaN(object)) {
        switch (style) {
          case "lowercase":
            return ".nan";
          case "uppercase":
            return ".NAN";
          case "camelcase":
            return ".NaN";
        }
      } else if (Number.POSITIVE_INFINITY === object) {
        switch (style) {
          case "lowercase":
            return ".inf";
          case "uppercase":
            return ".INF";
          case "camelcase":
            return ".Inf";
        }
      } else if (Number.NEGATIVE_INFINITY === object) {
        switch (style) {
          case "lowercase":
            return "-.inf";
          case "uppercase":
            return "-.INF";
          case "camelcase":
            return "-.Inf";
        }
      } else if (common.isNegativeZero(object)) {
        return "-0.0";
      }
      res = object.toString(10);
      return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
    }
    function isFloat(object) {
      return Object.prototype.toString.call(object) === "[object Number]" && (object % 1 !== 0 || common.isNegativeZero(object));
    }
    module2.exports = new Type("tag:yaml.org,2002:float", {
      kind: "scalar",
      resolve: resolveYamlFloat,
      construct: constructYamlFloat,
      predicate: isFloat,
      represent: representYamlFloat,
      defaultStyle: "lowercase"
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/schema/json.js
var require_json3 = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/schema/json.js"(exports, module2) {
    "use strict";
    var Schema = require_schema();
    module2.exports = new Schema({
      include: [
        require_failsafe()
      ],
      implicit: [
        require_null(),
        require_bool(),
        require_int(),
        require_float()
      ]
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/schema/core.js
var require_core2 = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/schema/core.js"(exports, module2) {
    "use strict";
    var Schema = require_schema();
    module2.exports = new Schema({
      include: [
        require_json3()
      ]
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/timestamp.js
var require_timestamp = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/timestamp.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    var YAML_DATE_REGEXP = new RegExp(
      "^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"
    );
    var YAML_TIMESTAMP_REGEXP = new RegExp(
      "^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$"
    );
    function resolveYamlTimestamp(data) {
      if (data === null)
        return false;
      if (YAML_DATE_REGEXP.exec(data) !== null)
        return true;
      if (YAML_TIMESTAMP_REGEXP.exec(data) !== null)
        return true;
      return false;
    }
    function constructYamlTimestamp(data) {
      var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date;
      match = YAML_DATE_REGEXP.exec(data);
      if (match === null)
        match = YAML_TIMESTAMP_REGEXP.exec(data);
      if (match === null)
        throw new Error("Date resolve error");
      year = +match[1];
      month = +match[2] - 1;
      day = +match[3];
      if (!match[4]) {
        return new Date(Date.UTC(year, month, day));
      }
      hour = +match[4];
      minute = +match[5];
      second = +match[6];
      if (match[7]) {
        fraction = match[7].slice(0, 3);
        while (fraction.length < 3) {
          fraction += "0";
        }
        fraction = +fraction;
      }
      if (match[9]) {
        tz_hour = +match[10];
        tz_minute = +(match[11] || 0);
        delta = (tz_hour * 60 + tz_minute) * 6e4;
        if (match[9] === "-")
          delta = -delta;
      }
      date = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
      if (delta)
        date.setTime(date.getTime() - delta);
      return date;
    }
    function representYamlTimestamp(object) {
      return object.toISOString();
    }
    module2.exports = new Type("tag:yaml.org,2002:timestamp", {
      kind: "scalar",
      resolve: resolveYamlTimestamp,
      construct: constructYamlTimestamp,
      instanceOf: Date,
      represent: representYamlTimestamp
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/merge.js
var require_merge = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/merge.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    function resolveYamlMerge(data) {
      return data === "<<" || data === null;
    }
    module2.exports = new Type("tag:yaml.org,2002:merge", {
      kind: "scalar",
      resolve: resolveYamlMerge
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/binary.js
var require_binary = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/binary.js"(exports, module2) {
    "use strict";
    var NodeBuffer;
    try {
      _require = require;
      NodeBuffer = _require("buffer").Buffer;
    } catch (__) {
    }
    var _require;
    var Type = require_type();
    var BASE64_MAP = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
    function resolveYamlBinary(data) {
      if (data === null)
        return false;
      var code, idx, bitlen = 0, max = data.length, map = BASE64_MAP;
      for (idx = 0; idx < max; idx++) {
        code = map.indexOf(data.charAt(idx));
        if (code > 64)
          continue;
        if (code < 0)
          return false;
        bitlen += 6;
      }
      return bitlen % 8 === 0;
    }
    function constructYamlBinary(data) {
      var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map = BASE64_MAP, bits = 0, result = [];
      for (idx = 0; idx < max; idx++) {
        if (idx % 4 === 0 && idx) {
          result.push(bits >> 16 & 255);
          result.push(bits >> 8 & 255);
          result.push(bits & 255);
        }
        bits = bits << 6 | map.indexOf(input.charAt(idx));
      }
      tailbits = max % 4 * 6;
      if (tailbits === 0) {
        result.push(bits >> 16 & 255);
        result.push(bits >> 8 & 255);
        result.push(bits & 255);
      } else if (tailbits === 18) {
        result.push(bits >> 10 & 255);
        result.push(bits >> 2 & 255);
      } else if (tailbits === 12) {
        result.push(bits >> 4 & 255);
      }
      if (NodeBuffer) {
        return NodeBuffer.from ? NodeBuffer.from(result) : new NodeBuffer(result);
      }
      return result;
    }
    function representYamlBinary(object) {
      var result = "", bits = 0, idx, tail, max = object.length, map = BASE64_MAP;
      for (idx = 0; idx < max; idx++) {
        if (idx % 3 === 0 && idx) {
          result += map[bits >> 18 & 63];
          result += map[bits >> 12 & 63];
          result += map[bits >> 6 & 63];
          result += map[bits & 63];
        }
        bits = (bits << 8) + object[idx];
      }
      tail = max % 3;
      if (tail === 0) {
        result += map[bits >> 18 & 63];
        result += map[bits >> 12 & 63];
        result += map[bits >> 6 & 63];
        result += map[bits & 63];
      } else if (tail === 2) {
        result += map[bits >> 10 & 63];
        result += map[bits >> 4 & 63];
        result += map[bits << 2 & 63];
        result += map[64];
      } else if (tail === 1) {
        result += map[bits >> 2 & 63];
        result += map[bits << 4 & 63];
        result += map[64];
        result += map[64];
      }
      return result;
    }
    function isBinary(object) {
      return NodeBuffer && NodeBuffer.isBuffer(object);
    }
    module2.exports = new Type("tag:yaml.org,2002:binary", {
      kind: "scalar",
      resolve: resolveYamlBinary,
      construct: constructYamlBinary,
      predicate: isBinary,
      represent: representYamlBinary
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/omap.js
var require_omap = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/omap.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    var _hasOwnProperty = Object.prototype.hasOwnProperty;
    var _toString = Object.prototype.toString;
    function resolveYamlOmap(data) {
      if (data === null)
        return true;
      var objectKeys = [], index, length, pair, pairKey, pairHasKey, object = data;
      for (index = 0, length = object.length; index < length; index += 1) {
        pair = object[index];
        pairHasKey = false;
        if (_toString.call(pair) !== "[object Object]")
          return false;
        for (pairKey in pair) {
          if (_hasOwnProperty.call(pair, pairKey)) {
            if (!pairHasKey)
              pairHasKey = true;
            else
              return false;
          }
        }
        if (!pairHasKey)
          return false;
        if (objectKeys.indexOf(pairKey) === -1)
          objectKeys.push(pairKey);
        else
          return false;
      }
      return true;
    }
    function constructYamlOmap(data) {
      return data !== null ? data : [];
    }
    module2.exports = new Type("tag:yaml.org,2002:omap", {
      kind: "sequence",
      resolve: resolveYamlOmap,
      construct: constructYamlOmap
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/pairs.js
var require_pairs = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/pairs.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    var _toString = Object.prototype.toString;
    function resolveYamlPairs(data) {
      if (data === null)
        return true;
      var index, length, pair, keys, result, object = data;
      result = new Array(object.length);
      for (index = 0, length = object.length; index < length; index += 1) {
        pair = object[index];
        if (_toString.call(pair) !== "[object Object]")
          return false;
        keys = Object.keys(pair);
        if (keys.length !== 1)
          return false;
        result[index] = [keys[0], pair[keys[0]]];
      }
      return true;
    }
    function constructYamlPairs(data) {
      if (data === null)
        return [];
      var index, length, pair, keys, result, object = data;
      result = new Array(object.length);
      for (index = 0, length = object.length; index < length; index += 1) {
        pair = object[index];
        keys = Object.keys(pair);
        result[index] = [keys[0], pair[keys[0]]];
      }
      return result;
    }
    module2.exports = new Type("tag:yaml.org,2002:pairs", {
      kind: "sequence",
      resolve: resolveYamlPairs,
      construct: constructYamlPairs
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/set.js
var require_set = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/set.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    var _hasOwnProperty = Object.prototype.hasOwnProperty;
    function resolveYamlSet(data) {
      if (data === null)
        return true;
      var key, object = data;
      for (key in object) {
        if (_hasOwnProperty.call(object, key)) {
          if (object[key] !== null)
            return false;
        }
      }
      return true;
    }
    function constructYamlSet(data) {
      return data !== null ? data : {};
    }
    module2.exports = new Type("tag:yaml.org,2002:set", {
      kind: "mapping",
      resolve: resolveYamlSet,
      construct: constructYamlSet
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/schema/default_safe.js
var require_default_safe = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/schema/default_safe.js"(exports, module2) {
    "use strict";
    var Schema = require_schema();
    module2.exports = new Schema({
      include: [
        require_core2()
      ],
      implicit: [
        require_timestamp(),
        require_merge()
      ],
      explicit: [
        require_binary(),
        require_omap(),
        require_pairs(),
        require_set()
      ]
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/js/undefined.js
var require_undefined = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/js/undefined.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    function resolveJavascriptUndefined() {
      return true;
    }
    function constructJavascriptUndefined() {
      return void 0;
    }
    function representJavascriptUndefined() {
      return "";
    }
    function isUndefined(object) {
      return typeof object === "undefined";
    }
    module2.exports = new Type("tag:yaml.org,2002:js/undefined", {
      kind: "scalar",
      resolve: resolveJavascriptUndefined,
      construct: constructJavascriptUndefined,
      predicate: isUndefined,
      represent: representJavascriptUndefined
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/js/regexp.js
var require_regexp = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/js/regexp.js"(exports, module2) {
    "use strict";
    var Type = require_type();
    function resolveJavascriptRegExp(data) {
      if (data === null)
        return false;
      if (data.length === 0)
        return false;
      var regexp = data, tail = /\/([gim]*)$/.exec(data), modifiers = "";
      if (regexp[0] === "/") {
        if (tail)
          modifiers = tail[1];
        if (modifiers.length > 3)
          return false;
        if (regexp[regexp.length - modifiers.length - 1] !== "/")
          return false;
      }
      return true;
    }
    function constructJavascriptRegExp(data) {
      var regexp = data, tail = /\/([gim]*)$/.exec(data), modifiers = "";
      if (regexp[0] === "/") {
        if (tail)
          modifiers = tail[1];
        regexp = regexp.slice(1, regexp.length - modifiers.length - 1);
      }
      return new RegExp(regexp, modifiers);
    }
    function representJavascriptRegExp(object) {
      var result = "/" + object.source + "/";
      if (object.global)
        result += "g";
      if (object.multiline)
        result += "m";
      if (object.ignoreCase)
        result += "i";
      return result;
    }
    function isRegExp(object) {
      return Object.prototype.toString.call(object) === "[object RegExp]";
    }
    module2.exports = new Type("tag:yaml.org,2002:js/regexp", {
      kind: "scalar",
      resolve: resolveJavascriptRegExp,
      construct: constructJavascriptRegExp,
      predicate: isRegExp,
      represent: representJavascriptRegExp
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/type/js/function.js
var require_function = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/type/js/function.js"(exports, module2) {
    "use strict";
    var esprima;
    try {
      _require = require;
      esprima = _require("esprima");
    } catch (_) {
      if (typeof window !== "undefined")
        esprima = window.esprima;
    }
    var _require;
    var Type = require_type();
    function resolveJavascriptFunction(data) {
      if (data === null)
        return false;
      try {
        var source = "(" + data + ")", ast = esprima.parse(source, { range: true });
        if (ast.type !== "Program" || ast.body.length !== 1 || ast.body[0].type !== "ExpressionStatement" || ast.body[0].expression.type !== "ArrowFunctionExpression" && ast.body[0].expression.type !== "FunctionExpression") {
          return false;
        }
        return true;
      } catch (err) {
        return false;
      }
    }
    function constructJavascriptFunction(data) {
      var source = "(" + data + ")", ast = esprima.parse(source, { range: true }), params = [], body;
      if (ast.type !== "Program" || ast.body.length !== 1 || ast.body[0].type !== "ExpressionStatement" || ast.body[0].expression.type !== "ArrowFunctionExpression" && ast.body[0].expression.type !== "FunctionExpression") {
        throw new Error("Failed to resolve function");
      }
      ast.body[0].expression.params.forEach(function(param) {
        params.push(param.name);
      });
      body = ast.body[0].expression.body.range;
      if (ast.body[0].expression.body.type === "BlockStatement") {
        return new Function(params, source.slice(body[0] + 1, body[1] - 1));
      }
      return new Function(params, "return " + source.slice(body[0], body[1]));
    }
    function representJavascriptFunction(object) {
      return object.toString();
    }
    function isFunction(object) {
      return Object.prototype.toString.call(object) === "[object Function]";
    }
    module2.exports = new Type("tag:yaml.org,2002:js/function", {
      kind: "scalar",
      resolve: resolveJavascriptFunction,
      construct: constructJavascriptFunction,
      predicate: isFunction,
      represent: representJavascriptFunction
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/schema/default_full.js
var require_default_full = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/schema/default_full.js"(exports, module2) {
    "use strict";
    var Schema = require_schema();
    module2.exports = Schema.DEFAULT = new Schema({
      include: [
        require_default_safe()
      ],
      explicit: [
        require_undefined(),
        require_regexp(),
        require_function()
      ]
    });
  }
});

// node_modules/js-yaml/lib/js-yaml/loader.js
var require_loader = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/loader.js"(exports, module2) {
    "use strict";
    var common = require_common2();
    var YAMLException = require_exception();
    var Mark = require_mark();
    var DEFAULT_SAFE_SCHEMA = require_default_safe();
    var DEFAULT_FULL_SCHEMA = require_default_full();
    var _hasOwnProperty = Object.prototype.hasOwnProperty;
    var CONTEXT_FLOW_IN = 1;
    var CONTEXT_FLOW_OUT = 2;
    var CONTEXT_BLOCK_IN = 3;
    var CONTEXT_BLOCK_OUT = 4;
    var CHOMPING_CLIP = 1;
    var CHOMPING_STRIP = 2;
    var CHOMPING_KEEP = 3;
    var PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
    var PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
    var PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/;
    var PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i;
    var PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
    function _class(obj) {
      return Object.prototype.toString.call(obj);
    }
    function is_EOL(c) {
      return c === 10 || c === 13;
    }
    function is_WHITE_SPACE(c) {
      return c === 9 || c === 32;
    }
    function is_WS_OR_EOL(c) {
      return c === 9 || c === 32 || c === 10 || c === 13;
    }
    function is_FLOW_INDICATOR(c) {
      return c === 44 || c === 91 || c === 93 || c === 123 || c === 125;
    }
    function fromHexCode(c) {
      var lc;
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      lc = c | 32;
      if (97 <= lc && lc <= 102) {
        return lc - 97 + 10;
      }
      return -1;
    }
    function escapedHexLen(c) {
      if (c === 120) {
        return 2;
      }
      if (c === 117) {
        return 4;
      }
      if (c === 85) {
        return 8;
      }
      return 0;
    }
    function fromDecimalCode(c) {
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      return -1;
    }
    function simpleEscapeSequence(c) {
      return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
    }
    function charFromCodepoint(c) {
      if (c <= 65535) {
        return String.fromCharCode(c);
      }
      return String.fromCharCode(
        (c - 65536 >> 10) + 55296,
        (c - 65536 & 1023) + 56320
      );
    }
    var simpleEscapeCheck = new Array(256);
    var simpleEscapeMap = new Array(256);
    for (i2 = 0; i2 < 256; i2++) {
      simpleEscapeCheck[i2] = simpleEscapeSequence(i2) ? 1 : 0;
      simpleEscapeMap[i2] = simpleEscapeSequence(i2);
    }
    var i2;
    function State(input, options) {
      this.input = input;
      this.filename = options["filename"] || null;
      this.schema = options["schema"] || DEFAULT_FULL_SCHEMA;
      this.onWarning = options["onWarning"] || null;
      this.legacy = options["legacy"] || false;
      this.json = options["json"] || false;
      this.listener = options["listener"] || null;
      this.implicitTypes = this.schema.compiledImplicit;
      this.typeMap = this.schema.compiledTypeMap;
      this.length = input.length;
      this.position = 0;
      this.line = 0;
      this.lineStart = 0;
      this.lineIndent = 0;
      this.documents = [];
    }
    function generateError(state, message) {
      return new YAMLException(
        message,
        new Mark(state.filename, state.input, state.position, state.line, state.position - state.lineStart)
      );
    }
    function throwError(state, message) {
      throw generateError(state, message);
    }
    function throwWarning(state, message) {
      if (state.onWarning) {
        state.onWarning.call(null, generateError(state, message));
      }
    }
    var directiveHandlers = {
      YAML: function handleYamlDirective(state, name, args) {
        var match, major, minor;
        if (state.version !== null) {
          throwError(state, "duplication of %YAML directive");
        }
        if (args.length !== 1) {
          throwError(state, "YAML directive accepts exactly one argument");
        }
        match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
        if (match === null) {
          throwError(state, "ill-formed argument of the YAML directive");
        }
        major = parseInt(match[1], 10);
        minor = parseInt(match[2], 10);
        if (major !== 1) {
          throwError(state, "unacceptable YAML version of the document");
        }
        state.version = args[0];
        state.checkLineBreaks = minor < 2;
        if (minor !== 1 && minor !== 2) {
          throwWarning(state, "unsupported YAML version of the document");
        }
      },
      TAG: function handleTagDirective(state, name, args) {
        var handle, prefix2;
        if (args.length !== 2) {
          throwError(state, "TAG directive accepts exactly two arguments");
        }
        handle = args[0];
        prefix2 = args[1];
        if (!PATTERN_TAG_HANDLE.test(handle)) {
          throwError(state, "ill-formed tag handle (first argument) of the TAG directive");
        }
        if (_hasOwnProperty.call(state.tagMap, handle)) {
          throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
        }
        if (!PATTERN_TAG_URI.test(prefix2)) {
          throwError(state, "ill-formed tag prefix (second argument) of the TAG directive");
        }
        state.tagMap[handle] = prefix2;
      }
    };
    function captureSegment(state, start, end, checkJson) {
      var _position, _length, _character, _result;
      if (start < end) {
        _result = state.input.slice(start, end);
        if (checkJson) {
          for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
            _character = _result.charCodeAt(_position);
            if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
              throwError(state, "expected valid JSON character");
            }
          }
        } else if (PATTERN_NON_PRINTABLE.test(_result)) {
          throwError(state, "the stream contains non-printable characters");
        }
        state.result += _result;
      }
    }
    function mergeMappings(state, destination, source, overridableKeys) {
      var sourceKeys, key, index, quantity;
      if (!common.isObject(source)) {
        throwError(state, "cannot merge mappings; the provided source object is unacceptable");
      }
      sourceKeys = Object.keys(source);
      for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
        key = sourceKeys[index];
        if (!_hasOwnProperty.call(destination, key)) {
          destination[key] = source[key];
          overridableKeys[key] = true;
        }
      }
    }
    function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startPos) {
      var index, quantity;
      if (Array.isArray(keyNode)) {
        keyNode = Array.prototype.slice.call(keyNode);
        for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
          if (Array.isArray(keyNode[index])) {
            throwError(state, "nested arrays are not supported inside keys");
          }
          if (typeof keyNode === "object" && _class(keyNode[index]) === "[object Object]") {
            keyNode[index] = "[object Object]";
          }
        }
      }
      if (typeof keyNode === "object" && _class(keyNode) === "[object Object]") {
        keyNode = "[object Object]";
      }
      keyNode = String(keyNode);
      if (_result === null) {
        _result = {};
      }
      if (keyTag === "tag:yaml.org,2002:merge") {
        if (Array.isArray(valueNode)) {
          for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
            mergeMappings(state, _result, valueNode[index], overridableKeys);
          }
        } else {
          mergeMappings(state, _result, valueNode, overridableKeys);
        }
      } else {
        if (!state.json && !_hasOwnProperty.call(overridableKeys, keyNode) && _hasOwnProperty.call(_result, keyNode)) {
          state.line = startLine || state.line;
          state.position = startPos || state.position;
          throwError(state, "duplicated mapping key");
        }
        _result[keyNode] = valueNode;
        delete overridableKeys[keyNode];
      }
      return _result;
    }
    function readLineBreak(state) {
      var ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 10) {
        state.position++;
      } else if (ch === 13) {
        state.position++;
        if (state.input.charCodeAt(state.position) === 10) {
          state.position++;
        }
      } else {
        throwError(state, "a line break is expected");
      }
      state.line += 1;
      state.lineStart = state.position;
    }
    function skipSeparationSpace(state, allowComments, checkIndent) {
      var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        while (is_WHITE_SPACE(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        if (allowComments && ch === 35) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (ch !== 10 && ch !== 13 && ch !== 0);
        }
        if (is_EOL(ch)) {
          readLineBreak(state);
          ch = state.input.charCodeAt(state.position);
          lineBreaks++;
          state.lineIndent = 0;
          while (ch === 32) {
            state.lineIndent++;
            ch = state.input.charCodeAt(++state.position);
          }
        } else {
          break;
        }
      }
      if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
        throwWarning(state, "deficient indentation");
      }
      return lineBreaks;
    }
    function testDocumentSeparator(state) {
      var _position = state.position, ch;
      ch = state.input.charCodeAt(_position);
      if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
        _position += 3;
        ch = state.input.charCodeAt(_position);
        if (ch === 0 || is_WS_OR_EOL(ch)) {
          return true;
        }
      }
      return false;
    }
    function writeFoldedLines(state, count) {
      if (count === 1) {
        state.result += " ";
      } else if (count > 1) {
        state.result += common.repeat("\n", count - 1);
      }
    }
    function readPlainScalar(state, nodeIndent, withinFlowCollection) {
      var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
      ch = state.input.charCodeAt(state.position);
      if (is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
        return false;
      }
      if (ch === 63 || ch === 45) {
        following = state.input.charCodeAt(state.position + 1);
        if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
          return false;
        }
      }
      state.kind = "scalar";
      state.result = "";
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
      while (ch !== 0) {
        if (ch === 58) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
            break;
          }
        } else if (ch === 35) {
          preceding = state.input.charCodeAt(state.position - 1);
          if (is_WS_OR_EOL(preceding)) {
            break;
          }
        } else if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch)) {
          break;
        } else if (is_EOL(ch)) {
          _line = state.line;
          _lineStart = state.lineStart;
          _lineIndent = state.lineIndent;
          skipSeparationSpace(state, false, -1);
          if (state.lineIndent >= nodeIndent) {
            hasPendingContent = true;
            ch = state.input.charCodeAt(state.position);
            continue;
          } else {
            state.position = captureEnd;
            state.line = _line;
            state.lineStart = _lineStart;
            state.lineIndent = _lineIndent;
            break;
          }
        }
        if (hasPendingContent) {
          captureSegment(state, captureStart, captureEnd, false);
          writeFoldedLines(state, state.line - _line);
          captureStart = captureEnd = state.position;
          hasPendingContent = false;
        }
        if (!is_WHITE_SPACE(ch)) {
          captureEnd = state.position + 1;
        }
        ch = state.input.charCodeAt(++state.position);
      }
      captureSegment(state, captureStart, captureEnd, false);
      if (state.result) {
        return true;
      }
      state.kind = _kind;
      state.result = _result;
      return false;
    }
    function readSingleQuotedScalar(state, nodeIndent) {
      var ch, captureStart, captureEnd;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 39) {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      state.position++;
      captureStart = captureEnd = state.position;
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        if (ch === 39) {
          captureSegment(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          if (ch === 39) {
            captureStart = state.position;
            state.position++;
            captureEnd = state.position;
          } else {
            return true;
          }
        } else if (is_EOL(ch)) {
          captureSegment(state, captureStart, captureEnd, true);
          writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
          throwError(state, "unexpected end of the document within a single quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
        }
      }
      throwError(state, "unexpected end of the stream within a single quoted scalar");
    }
    function readDoubleQuotedScalar(state, nodeIndent) {
      var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 34) {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      state.position++;
      captureStart = captureEnd = state.position;
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        if (ch === 34) {
          captureSegment(state, captureStart, state.position, true);
          state.position++;
          return true;
        } else if (ch === 92) {
          captureSegment(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          if (is_EOL(ch)) {
            skipSeparationSpace(state, false, nodeIndent);
          } else if (ch < 256 && simpleEscapeCheck[ch]) {
            state.result += simpleEscapeMap[ch];
            state.position++;
          } else if ((tmp = escapedHexLen(ch)) > 0) {
            hexLength = tmp;
            hexResult = 0;
            for (; hexLength > 0; hexLength--) {
              ch = state.input.charCodeAt(++state.position);
              if ((tmp = fromHexCode(ch)) >= 0) {
                hexResult = (hexResult << 4) + tmp;
              } else {
                throwError(state, "expected hexadecimal character");
              }
            }
            state.result += charFromCodepoint(hexResult);
            state.position++;
          } else {
            throwError(state, "unknown escape sequence");
          }
          captureStart = captureEnd = state.position;
        } else if (is_EOL(ch)) {
          captureSegment(state, captureStart, captureEnd, true);
          writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
          throwError(state, "unexpected end of the document within a double quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
        }
      }
      throwError(state, "unexpected end of the stream within a double quoted scalar");
    }
    function readFlowCollection(state, nodeIndent) {
      var readNext = true, _line, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = {}, keyNode, keyTag, valueNode, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 91) {
        terminator = 93;
        isMapping = false;
        _result = [];
      } else if (ch === 123) {
        terminator = 125;
        isMapping = true;
        _result = {};
      } else {
        return false;
      }
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(++state.position);
      while (ch !== 0) {
        skipSeparationSpace(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (ch === terminator) {
          state.position++;
          state.tag = _tag;
          state.anchor = _anchor;
          state.kind = isMapping ? "mapping" : "sequence";
          state.result = _result;
          return true;
        } else if (!readNext) {
          throwError(state, "missed comma between flow collection entries");
        }
        keyTag = keyNode = valueNode = null;
        isPair = isExplicitPair = false;
        if (ch === 63) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL(following)) {
            isPair = isExplicitPair = true;
            state.position++;
            skipSeparationSpace(state, true, nodeIndent);
          }
        }
        _line = state.line;
        composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
        keyTag = state.tag;
        keyNode = state.result;
        skipSeparationSpace(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if ((isExplicitPair || state.line === _line) && ch === 58) {
          isPair = true;
          ch = state.input.charCodeAt(++state.position);
          skipSeparationSpace(state, true, nodeIndent);
          composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
          valueNode = state.result;
        }
        if (isMapping) {
          storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode);
        } else if (isPair) {
          _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode));
        } else {
          _result.push(keyNode);
        }
        skipSeparationSpace(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (ch === 44) {
          readNext = true;
          ch = state.input.charCodeAt(++state.position);
        } else {
          readNext = false;
        }
      }
      throwError(state, "unexpected end of the stream within a flow collection");
    }
    function readBlockScalar(state, nodeIndent) {
      var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 124) {
        folding = false;
      } else if (ch === 62) {
        folding = true;
      } else {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      while (ch !== 0) {
        ch = state.input.charCodeAt(++state.position);
        if (ch === 43 || ch === 45) {
          if (CHOMPING_CLIP === chomping) {
            chomping = ch === 43 ? CHOMPING_KEEP : CHOMPING_STRIP;
          } else {
            throwError(state, "repeat of a chomping mode identifier");
          }
        } else if ((tmp = fromDecimalCode(ch)) >= 0) {
          if (tmp === 0) {
            throwError(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
          } else if (!detectedIndent) {
            textIndent = nodeIndent + tmp - 1;
            detectedIndent = true;
          } else {
            throwError(state, "repeat of an indentation width identifier");
          }
        } else {
          break;
        }
      }
      if (is_WHITE_SPACE(ch)) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (is_WHITE_SPACE(ch));
        if (ch === 35) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (!is_EOL(ch) && ch !== 0);
        }
      }
      while (ch !== 0) {
        readLineBreak(state);
        state.lineIndent = 0;
        ch = state.input.charCodeAt(state.position);
        while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
          state.lineIndent++;
          ch = state.input.charCodeAt(++state.position);
        }
        if (!detectedIndent && state.lineIndent > textIndent) {
          textIndent = state.lineIndent;
        }
        if (is_EOL(ch)) {
          emptyLines++;
          continue;
        }
        if (state.lineIndent < textIndent) {
          if (chomping === CHOMPING_KEEP) {
            state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
          } else if (chomping === CHOMPING_CLIP) {
            if (didReadContent) {
              state.result += "\n";
            }
          }
          break;
        }
        if (folding) {
          if (is_WHITE_SPACE(ch)) {
            atMoreIndented = true;
            state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
          } else if (atMoreIndented) {
            atMoreIndented = false;
            state.result += common.repeat("\n", emptyLines + 1);
          } else if (emptyLines === 0) {
            if (didReadContent) {
              state.result += " ";
            }
          } else {
            state.result += common.repeat("\n", emptyLines);
          }
        } else {
          state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
        }
        didReadContent = true;
        detectedIndent = true;
        emptyLines = 0;
        captureStart = state.position;
        while (!is_EOL(ch) && ch !== 0) {
          ch = state.input.charCodeAt(++state.position);
        }
        captureSegment(state, captureStart, state.position, false);
      }
      return true;
    }
    function readBlockSequence(state, nodeIndent) {
      var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        if (ch !== 45) {
          break;
        }
        following = state.input.charCodeAt(state.position + 1);
        if (!is_WS_OR_EOL(following)) {
          break;
        }
        detected = true;
        state.position++;
        if (skipSeparationSpace(state, true, -1)) {
          if (state.lineIndent <= nodeIndent) {
            _result.push(null);
            ch = state.input.charCodeAt(state.position);
            continue;
          }
        }
        _line = state.line;
        composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
        _result.push(state.result);
        skipSeparationSpace(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
          throwError(state, "bad indentation of a sequence entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "sequence";
        state.result = _result;
        return true;
      }
      return false;
    }
    function readBlockMapping(state, nodeIndent, flowIndent) {
      var following, allowCompact, _line, _pos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = {}, keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        following = state.input.charCodeAt(state.position + 1);
        _line = state.line;
        _pos = state.position;
        if ((ch === 63 || ch === 58) && is_WS_OR_EOL(following)) {
          if (ch === 63) {
            if (atExplicitKey) {
              storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null);
              keyTag = keyNode = valueNode = null;
            }
            detected = true;
            atExplicitKey = true;
            allowCompact = true;
          } else if (atExplicitKey) {
            atExplicitKey = false;
            allowCompact = true;
          } else {
            throwError(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
          }
          state.position += 1;
          ch = following;
        } else if (composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) {
          if (state.line === _line) {
            ch = state.input.charCodeAt(state.position);
            while (is_WHITE_SPACE(ch)) {
              ch = state.input.charCodeAt(++state.position);
            }
            if (ch === 58) {
              ch = state.input.charCodeAt(++state.position);
              if (!is_WS_OR_EOL(ch)) {
                throwError(state, "a whitespace character is expected after the key-value separator within a block mapping");
              }
              if (atExplicitKey) {
                storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null);
                keyTag = keyNode = valueNode = null;
              }
              detected = true;
              atExplicitKey = false;
              allowCompact = false;
              keyTag = state.tag;
              keyNode = state.result;
            } else if (detected) {
              throwError(state, "can not read an implicit mapping pair; a colon is missed");
            } else {
              state.tag = _tag;
              state.anchor = _anchor;
              return true;
            }
          } else if (detected) {
            throwError(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
          } else {
            state.tag = _tag;
            state.anchor = _anchor;
            return true;
          }
        } else {
          break;
        }
        if (state.line === _line || state.lineIndent > nodeIndent) {
          if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
            if (atExplicitKey) {
              keyNode = state.result;
            } else {
              valueNode = state.result;
            }
          }
          if (!atExplicitKey) {
            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _pos);
            keyTag = keyNode = valueNode = null;
          }
          skipSeparationSpace(state, true, -1);
          ch = state.input.charCodeAt(state.position);
        }
        if (state.lineIndent > nodeIndent && ch !== 0) {
          throwError(state, "bad indentation of a mapping entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      if (atExplicitKey) {
        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null);
      }
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "mapping";
        state.result = _result;
      }
      return detected;
    }
    function readTagProperty(state) {
      var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 33)
        return false;
      if (state.tag !== null) {
        throwError(state, "duplication of a tag property");
      }
      ch = state.input.charCodeAt(++state.position);
      if (ch === 60) {
        isVerbatim = true;
        ch = state.input.charCodeAt(++state.position);
      } else if (ch === 33) {
        isNamed = true;
        tagHandle = "!!";
        ch = state.input.charCodeAt(++state.position);
      } else {
        tagHandle = "!";
      }
      _position = state.position;
      if (isVerbatim) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && ch !== 62);
        if (state.position < state.length) {
          tagName = state.input.slice(_position, state.position);
          ch = state.input.charCodeAt(++state.position);
        } else {
          throwError(state, "unexpected end of the stream within a verbatim tag");
        }
      } else {
        while (ch !== 0 && !is_WS_OR_EOL(ch)) {
          if (ch === 33) {
            if (!isNamed) {
              tagHandle = state.input.slice(_position - 1, state.position + 1);
              if (!PATTERN_TAG_HANDLE.test(tagHandle)) {
                throwError(state, "named tag handle cannot contain such characters");
              }
              isNamed = true;
              _position = state.position + 1;
            } else {
              throwError(state, "tag suffix cannot contain exclamation marks");
            }
          }
          ch = state.input.charCodeAt(++state.position);
        }
        tagName = state.input.slice(_position, state.position);
        if (PATTERN_FLOW_INDICATORS.test(tagName)) {
          throwError(state, "tag suffix cannot contain flow indicator characters");
        }
      }
      if (tagName && !PATTERN_TAG_URI.test(tagName)) {
        throwError(state, "tag name cannot contain such characters: " + tagName);
      }
      if (isVerbatim) {
        state.tag = tagName;
      } else if (_hasOwnProperty.call(state.tagMap, tagHandle)) {
        state.tag = state.tagMap[tagHandle] + tagName;
      } else if (tagHandle === "!") {
        state.tag = "!" + tagName;
      } else if (tagHandle === "!!") {
        state.tag = "tag:yaml.org,2002:" + tagName;
      } else {
        throwError(state, 'undeclared tag handle "' + tagHandle + '"');
      }
      return true;
    }
    function readAnchorProperty(state) {
      var _position, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 38)
        return false;
      if (state.anchor !== null) {
        throwError(state, "duplication of an anchor property");
      }
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position === _position) {
        throwError(state, "name of an anchor node must contain at least one character");
      }
      state.anchor = state.input.slice(_position, state.position);
      return true;
    }
    function readAlias(state) {
      var _position, alias, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 42)
        return false;
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position === _position) {
        throwError(state, "name of an alias node must contain at least one character");
      }
      alias = state.input.slice(_position, state.position);
      if (!_hasOwnProperty.call(state.anchorMap, alias)) {
        throwError(state, 'unidentified alias "' + alias + '"');
      }
      state.result = state.anchorMap[alias];
      skipSeparationSpace(state, true, -1);
      return true;
    }
    function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
      var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, type, flowIndent, blockIndent;
      if (state.listener !== null) {
        state.listener("open", state);
      }
      state.tag = null;
      state.anchor = null;
      state.kind = null;
      state.result = null;
      allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext;
      if (allowToSeek) {
        if (skipSeparationSpace(state, true, -1)) {
          atNewLine = true;
          if (state.lineIndent > parentIndent) {
            indentStatus = 1;
          } else if (state.lineIndent === parentIndent) {
            indentStatus = 0;
          } else if (state.lineIndent < parentIndent) {
            indentStatus = -1;
          }
        }
      }
      if (indentStatus === 1) {
        while (readTagProperty(state) || readAnchorProperty(state)) {
          if (skipSeparationSpace(state, true, -1)) {
            atNewLine = true;
            allowBlockCollections = allowBlockStyles;
            if (state.lineIndent > parentIndent) {
              indentStatus = 1;
            } else if (state.lineIndent === parentIndent) {
              indentStatus = 0;
            } else if (state.lineIndent < parentIndent) {
              indentStatus = -1;
            }
          } else {
            allowBlockCollections = false;
          }
        }
      }
      if (allowBlockCollections) {
        allowBlockCollections = atNewLine || allowCompact;
      }
      if (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) {
        if (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext) {
          flowIndent = parentIndent;
        } else {
          flowIndent = parentIndent + 1;
        }
        blockIndent = state.position - state.lineStart;
        if (indentStatus === 1) {
          if (allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent)) {
            hasContent = true;
          } else {
            if (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent)) {
              hasContent = true;
            } else if (readAlias(state)) {
              hasContent = true;
              if (state.tag !== null || state.anchor !== null) {
                throwError(state, "alias node should not have any properties");
              }
            } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
              hasContent = true;
              if (state.tag === null) {
                state.tag = "?";
              }
            }
            if (state.anchor !== null) {
              state.anchorMap[state.anchor] = state.result;
            }
          }
        } else if (indentStatus === 0) {
          hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
        }
      }
      if (state.tag !== null && state.tag !== "!") {
        if (state.tag === "?") {
          if (state.result !== null && state.kind !== "scalar") {
            throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
          }
          for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
            type = state.implicitTypes[typeIndex];
            if (type.resolve(state.result)) {
              state.result = type.construct(state.result);
              state.tag = type.tag;
              if (state.anchor !== null) {
                state.anchorMap[state.anchor] = state.result;
              }
              break;
            }
          }
        } else if (_hasOwnProperty.call(state.typeMap[state.kind || "fallback"], state.tag)) {
          type = state.typeMap[state.kind || "fallback"][state.tag];
          if (state.result !== null && type.kind !== state.kind) {
            throwError(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type.kind + '", not "' + state.kind + '"');
          }
          if (!type.resolve(state.result)) {
            throwError(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
          } else {
            state.result = type.construct(state.result);
            if (state.anchor !== null) {
              state.anchorMap[state.anchor] = state.result;
            }
          }
        } else {
          throwError(state, "unknown tag !<" + state.tag + ">");
        }
      }
      if (state.listener !== null) {
        state.listener("close", state);
      }
      return state.tag !== null || state.anchor !== null || hasContent;
    }
    function readDocument(state) {
      var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
      state.version = null;
      state.checkLineBreaks = state.legacy;
      state.tagMap = {};
      state.anchorMap = {};
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        skipSeparationSpace(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if (state.lineIndent > 0 || ch !== 37) {
          break;
        }
        hasDirectives = true;
        ch = state.input.charCodeAt(++state.position);
        _position = state.position;
        while (ch !== 0 && !is_WS_OR_EOL(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        directiveName = state.input.slice(_position, state.position);
        directiveArgs = [];
        if (directiveName.length < 1) {
          throwError(state, "directive name must not be less than one character in length");
        }
        while (ch !== 0) {
          while (is_WHITE_SPACE(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          if (ch === 35) {
            do {
              ch = state.input.charCodeAt(++state.position);
            } while (ch !== 0 && !is_EOL(ch));
            break;
          }
          if (is_EOL(ch))
            break;
          _position = state.position;
          while (ch !== 0 && !is_WS_OR_EOL(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          directiveArgs.push(state.input.slice(_position, state.position));
        }
        if (ch !== 0)
          readLineBreak(state);
        if (_hasOwnProperty.call(directiveHandlers, directiveName)) {
          directiveHandlers[directiveName](state, directiveName, directiveArgs);
        } else {
          throwWarning(state, 'unknown document directive "' + directiveName + '"');
        }
      }
      skipSeparationSpace(state, true, -1);
      if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
        state.position += 3;
        skipSeparationSpace(state, true, -1);
      } else if (hasDirectives) {
        throwError(state, "directives end mark is expected");
      }
      composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
      skipSeparationSpace(state, true, -1);
      if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) {
        throwWarning(state, "non-ASCII line breaks are interpreted as content");
      }
      state.documents.push(state.result);
      if (state.position === state.lineStart && testDocumentSeparator(state)) {
        if (state.input.charCodeAt(state.position) === 46) {
          state.position += 3;
          skipSeparationSpace(state, true, -1);
        }
        return;
      }
      if (state.position < state.length - 1) {
        throwError(state, "end of the stream or a document separator is expected");
      } else {
        return;
      }
    }
    function loadDocuments(input, options) {
      input = String(input);
      options = options || {};
      if (input.length !== 0) {
        if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
          input += "\n";
        }
        if (input.charCodeAt(0) === 65279) {
          input = input.slice(1);
        }
      }
      var state = new State(input, options);
      var nullpos = input.indexOf("\0");
      if (nullpos !== -1) {
        state.position = nullpos;
        throwError(state, "null byte is not allowed in input");
      }
      state.input += "\0";
      while (state.input.charCodeAt(state.position) === 32) {
        state.lineIndent += 1;
        state.position += 1;
      }
      while (state.position < state.length - 1) {
        readDocument(state);
      }
      return state.documents;
    }
    function loadAll(input, iterator2, options) {
      if (iterator2 !== null && typeof iterator2 === "object" && typeof options === "undefined") {
        options = iterator2;
        iterator2 = null;
      }
      var documents = loadDocuments(input, options);
      if (typeof iterator2 !== "function") {
        return documents;
      }
      for (var index = 0, length = documents.length; index < length; index += 1) {
        iterator2(documents[index]);
      }
    }
    function load(input, options) {
      var documents = loadDocuments(input, options);
      if (documents.length === 0) {
        return void 0;
      } else if (documents.length === 1) {
        return documents[0];
      }
      throw new YAMLException("expected a single document in the stream, but found more");
    }
    function safeLoadAll(input, iterator2, options) {
      if (typeof iterator2 === "object" && iterator2 !== null && typeof options === "undefined") {
        options = iterator2;
        iterator2 = null;
      }
      return loadAll(input, iterator2, common.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    function safeLoad(input, options) {
      return load(input, common.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    module2.exports.loadAll = loadAll;
    module2.exports.load = load;
    module2.exports.safeLoadAll = safeLoadAll;
    module2.exports.safeLoad = safeLoad;
  }
});

// node_modules/js-yaml/lib/js-yaml/dumper.js
var require_dumper = __commonJS({
  "node_modules/js-yaml/lib/js-yaml/dumper.js"(exports, module2) {
    "use strict";
    var common = require_common2();
    var YAMLException = require_exception();
    var DEFAULT_FULL_SCHEMA = require_default_full();
    var DEFAULT_SAFE_SCHEMA = require_default_safe();
    var _toString = Object.prototype.toString;
    var _hasOwnProperty = Object.prototype.hasOwnProperty;
    var CHAR_TAB = 9;
    var CHAR_LINE_FEED = 10;
    var CHAR_CARRIAGE_RETURN = 13;
    var CHAR_SPACE = 32;
    var CHAR_EXCLAMATION = 33;
    var CHAR_DOUBLE_QUOTE = 34;
    var CHAR_SHARP = 35;
    var CHAR_PERCENT = 37;
    var CHAR_AMPERSAND = 38;
    var CHAR_SINGLE_QUOTE = 39;
    var CHAR_ASTERISK = 42;
    var CHAR_COMMA = 44;
    var CHAR_MINUS = 45;
    var CHAR_COLON = 58;
    var CHAR_EQUALS = 61;
    var CHAR_GREATER_THAN = 62;
    var CHAR_QUESTION = 63;
    var CHAR_COMMERCIAL_AT = 64;
    var CHAR_LEFT_SQUARE_BRACKET = 91;
    var CHAR_RIGHT_SQUARE_BRACKET = 93;
    var CHAR_GRAVE_ACCENT = 96;
    var CHAR_LEFT_CURLY_BRACKET = 123;
    var CHAR_VERTICAL_LINE = 124;
    var CHAR_RIGHT_CURLY_BRACKET = 125;
    var ESCAPE_SEQUENCES = {};
    ESCAPE_SEQUENCES[0] = "\\0";
    ESCAPE_SEQUENCES[7] = "\\a";
    ESCAPE_SEQUENCES[8] = "\\b";
    ESCAPE_SEQUENCES[9] = "\\t";
    ESCAPE_SEQUENCES[10] = "\\n";
    ESCAPE_SEQUENCES[11] = "\\v";
    ESCAPE_SEQUENCES[12] = "\\f";
    ESCAPE_SEQUENCES[13] = "\\r";
    ESCAPE_SEQUENCES[27] = "\\e";
    ESCAPE_SEQUENCES[34] = '\\"';
    ESCAPE_SEQUENCES[92] = "\\\\";
    ESCAPE_SEQUENCES[133] = "\\N";
    ESCAPE_SEQUENCES[160] = "\\_";
    ESCAPE_SEQUENCES[8232] = "\\L";
    ESCAPE_SEQUENCES[8233] = "\\P";
    var DEPRECATED_BOOLEANS_SYNTAX = [
      "y",
      "Y",
      "yes",
      "Yes",
      "YES",
      "on",
      "On",
      "ON",
      "n",
      "N",
      "no",
      "No",
      "NO",
      "off",
      "Off",
      "OFF"
    ];
    function compileStyleMap(schema, map) {
      var result, keys, index, length, tag, style, type;
      if (map === null)
        return {};
      result = {};
      keys = Object.keys(map);
      for (index = 0, length = keys.length; index < length; index += 1) {
        tag = keys[index];
        style = String(map[tag]);
        if (tag.slice(0, 2) === "!!") {
          tag = "tag:yaml.org,2002:" + tag.slice(2);
        }
        type = schema.compiledTypeMap["fallback"][tag];
        if (type && _hasOwnProperty.call(type.styleAliases, style)) {
          style = type.styleAliases[style];
        }
        result[tag] = style;
      }
      return result;
    }
    function encodeHex(character) {
      var string, handle, length;
      string = character.toString(16).toUpperCase();
      if (character <= 255) {
        handle = "x";
        length = 2;
      } else if (character <= 65535) {
        handle = "u";
        length = 4;
      } else if (character <= 4294967295) {
        handle = "U";
        length = 8;
      } else {
        throw new YAMLException("code point within a string may not be greater than 0xFFFFFFFF");
      }
      return "\\" + handle + common.repeat("0", length - string.length) + string;
    }
    function State(options) {
      this.schema = options["schema"] || DEFAULT_FULL_SCHEMA;
      this.indent = Math.max(1, options["indent"] || 2);
      this.noArrayIndent = options["noArrayIndent"] || false;
      this.skipInvalid = options["skipInvalid"] || false;
      this.flowLevel = common.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
      this.styleMap = compileStyleMap(this.schema, options["styles"] || null);
      this.sortKeys = options["sortKeys"] || false;
      this.lineWidth = options["lineWidth"] || 80;
      this.noRefs = options["noRefs"] || false;
      this.noCompatMode = options["noCompatMode"] || false;
      this.condenseFlow = options["condenseFlow"] || false;
      this.implicitTypes = this.schema.compiledImplicit;
      this.explicitTypes = this.schema.compiledExplicit;
      this.tag = null;
      this.result = "";
      this.duplicates = [];
      this.usedDuplicates = null;
    }
    function indentString(string, spaces) {
      var ind = common.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string.length;
      while (position < length) {
        next = string.indexOf("\n", position);
        if (next === -1) {
          line = string.slice(position);
          position = length;
        } else {
          line = string.slice(position, next + 1);
          position = next + 1;
        }
        if (line.length && line !== "\n")
          result += ind;
        result += line;
      }
      return result;
    }
    function generateNextLine(state, level) {
      return "\n" + common.repeat(" ", state.indent * level);
    }
    function testImplicitResolving(state, str) {
      var index, length, type;
      for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
        type = state.implicitTypes[index];
        if (type.resolve(str)) {
          return true;
        }
      }
      return false;
    }
    function isWhitespace(c) {
      return c === CHAR_SPACE || c === CHAR_TAB;
    }
    function isPrintable(c) {
      return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && c !== 8232 && c !== 8233 || 57344 <= c && c <= 65533 && c !== 65279 || 65536 <= c && c <= 1114111;
    }
    function isNsChar(c) {
      return isPrintable(c) && !isWhitespace(c) && c !== 65279 && c !== CHAR_CARRIAGE_RETURN && c !== CHAR_LINE_FEED;
    }
    function isPlainSafe(c, prev) {
      return isPrintable(c) && c !== 65279 && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET && c !== CHAR_COLON && (c !== CHAR_SHARP || prev && isNsChar(prev));
    }
    function isPlainSafeFirst(c) {
      return isPrintable(c) && c !== 65279 && !isWhitespace(c) && c !== CHAR_MINUS && c !== CHAR_QUESTION && c !== CHAR_COLON && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET && c !== CHAR_SHARP && c !== CHAR_AMPERSAND && c !== CHAR_ASTERISK && c !== CHAR_EXCLAMATION && c !== CHAR_VERTICAL_LINE && c !== CHAR_EQUALS && c !== CHAR_GREATER_THAN && c !== CHAR_SINGLE_QUOTE && c !== CHAR_DOUBLE_QUOTE && c !== CHAR_PERCENT && c !== CHAR_COMMERCIAL_AT && c !== CHAR_GRAVE_ACCENT;
    }
    function needIndentIndicator(string) {
      var leadingSpaceRe = /^\n* /;
      return leadingSpaceRe.test(string);
    }
    var STYLE_PLAIN = 1;
    var STYLE_SINGLE = 2;
    var STYLE_LITERAL = 3;
    var STYLE_FOLDED = 4;
    var STYLE_DOUBLE = 5;
    function chooseScalarStyle(string, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType) {
      var i2;
      var char, prev_char;
      var hasLineBreak = false;
      var hasFoldableLine = false;
      var shouldTrackWidth = lineWidth !== -1;
      var previousLineBreak = -1;
      var plain = isPlainSafeFirst(string.charCodeAt(0)) && !isWhitespace(string.charCodeAt(string.length - 1));
      if (singleLineOnly) {
        for (i2 = 0; i2 < string.length; i2++) {
          char = string.charCodeAt(i2);
          if (!isPrintable(char)) {
            return STYLE_DOUBLE;
          }
          prev_char = i2 > 0 ? string.charCodeAt(i2 - 1) : null;
          plain = plain && isPlainSafe(char, prev_char);
        }
      } else {
        for (i2 = 0; i2 < string.length; i2++) {
          char = string.charCodeAt(i2);
          if (char === CHAR_LINE_FEED) {
            hasLineBreak = true;
            if (shouldTrackWidth) {
              hasFoldableLine = hasFoldableLine || i2 - previousLineBreak - 1 > lineWidth && string[previousLineBreak + 1] !== " ";
              previousLineBreak = i2;
            }
          } else if (!isPrintable(char)) {
            return STYLE_DOUBLE;
          }
          prev_char = i2 > 0 ? string.charCodeAt(i2 - 1) : null;
          plain = plain && isPlainSafe(char, prev_char);
        }
        hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i2 - previousLineBreak - 1 > lineWidth && string[previousLineBreak + 1] !== " ");
      }
      if (!hasLineBreak && !hasFoldableLine) {
        return plain && !testAmbiguousType(string) ? STYLE_PLAIN : STYLE_SINGLE;
      }
      if (indentPerLevel > 9 && needIndentIndicator(string)) {
        return STYLE_DOUBLE;
      }
      return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
    }
    function writeScalar(state, string, level, iskey) {
      state.dump = function() {
        if (string.length === 0) {
          return "''";
        }
        if (!state.noCompatMode && DEPRECATED_BOOLEANS_SYNTAX.indexOf(string) !== -1) {
          return "'" + string + "'";
        }
        var indent = state.indent * Math.max(1, level);
        var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
        var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
        function testAmbiguity(string2) {
          return testImplicitResolving(state, string2);
        }
        switch (chooseScalarStyle(string, singleLineOnly, state.indent, lineWidth, testAmbiguity)) {
          case STYLE_PLAIN:
            return string;
          case STYLE_SINGLE:
            return "'" + string.replace(/'/g, "''") + "'";
          case STYLE_LITERAL:
            return "|" + blockHeader(string, state.indent) + dropEndingNewline(indentString(string, indent));
          case STYLE_FOLDED:
            return ">" + blockHeader(string, state.indent) + dropEndingNewline(indentString(foldString(string, lineWidth), indent));
          case STYLE_DOUBLE:
            return '"' + escapeString(string, lineWidth) + '"';
          default:
            throw new YAMLException("impossible error: invalid scalar style");
        }
      }();
    }
    function blockHeader(string, indentPerLevel) {
      var indentIndicator = needIndentIndicator(string) ? String(indentPerLevel) : "";
      var clip = string[string.length - 1] === "\n";
      var keep = clip && (string[string.length - 2] === "\n" || string === "\n");
      var chomp = keep ? "+" : clip ? "" : "-";
      return indentIndicator + chomp + "\n";
    }
    function dropEndingNewline(string) {
      return string[string.length - 1] === "\n" ? string.slice(0, -1) : string;
    }
    function foldString(string, width) {
      var lineRe = /(\n+)([^\n]*)/g;
      var result = function() {
        var nextLF = string.indexOf("\n");
        nextLF = nextLF !== -1 ? nextLF : string.length;
        lineRe.lastIndex = nextLF;
        return foldLine(string.slice(0, nextLF), width);
      }();
      var prevMoreIndented = string[0] === "\n" || string[0] === " ";
      var moreIndented;
      var match;
      while (match = lineRe.exec(string)) {
        var prefix2 = match[1], line = match[2];
        moreIndented = line[0] === " ";
        result += prefix2 + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine(line, width);
        prevMoreIndented = moreIndented;
      }
      return result;
    }
    function foldLine(line, width) {
      if (line === "" || line[0] === " ")
        return line;
      var breakRe = / [^ ]/g;
      var match;
      var start = 0, end, curr = 0, next = 0;
      var result = "";
      while (match = breakRe.exec(line)) {
        next = match.index;
        if (next - start > width) {
          end = curr > start ? curr : next;
          result += "\n" + line.slice(start, end);
          start = end + 1;
        }
        curr = next;
      }
      result += "\n";
      if (line.length - start > width && curr > start) {
        result += line.slice(start, curr) + "\n" + line.slice(curr + 1);
      } else {
        result += line.slice(start);
      }
      return result.slice(1);
    }
    function escapeString(string) {
      var result = "";
      var char, nextChar;
      var escapeSeq;
      for (var i2 = 0; i2 < string.length; i2++) {
        char = string.charCodeAt(i2);
        if (char >= 55296 && char <= 56319) {
          nextChar = string.charCodeAt(i2 + 1);
          if (nextChar >= 56320 && nextChar <= 57343) {
            result += encodeHex((char - 55296) * 1024 + nextChar - 56320 + 65536);
            i2++;
            continue;
          }
        }
        escapeSeq = ESCAPE_SEQUENCES[char];
        result += !escapeSeq && isPrintable(char) ? string[i2] : escapeSeq || encodeHex(char);
      }
      return result;
    }
    function writeFlowSequence(state, level, object) {
      var _result = "", _tag = state.tag, index, length;
      for (index = 0, length = object.length; index < length; index += 1) {
        if (writeNode(state, level, object[index], false, false)) {
          if (index !== 0)
            _result += "," + (!state.condenseFlow ? " " : "");
          _result += state.dump;
        }
      }
      state.tag = _tag;
      state.dump = "[" + _result + "]";
    }
    function writeBlockSequence(state, level, object, compact) {
      var _result = "", _tag = state.tag, index, length;
      for (index = 0, length = object.length; index < length; index += 1) {
        if (writeNode(state, level + 1, object[index], true, true)) {
          if (!compact || index !== 0) {
            _result += generateNextLine(state, level);
          }
          if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
            _result += "-";
          } else {
            _result += "- ";
          }
          _result += state.dump;
        }
      }
      state.tag = _tag;
      state.dump = _result || "[]";
    }
    function writeFlowMapping(state, level, object) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, pairBuffer;
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (index !== 0)
          pairBuffer += ", ";
        if (state.condenseFlow)
          pairBuffer += '"';
        objectKey = objectKeyList[index];
        objectValue = object[objectKey];
        if (!writeNode(state, level, objectKey, false, false)) {
          continue;
        }
        if (state.dump.length > 1024)
          pairBuffer += "? ";
        pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
        if (!writeNode(state, level, objectValue, false, false)) {
          continue;
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = "{" + _result + "}";
    }
    function writeBlockMapping(state, level, object, compact) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object), index, length, objectKey, objectValue, explicitPair, pairBuffer;
      if (state.sortKeys === true) {
        objectKeyList.sort();
      } else if (typeof state.sortKeys === "function") {
        objectKeyList.sort(state.sortKeys);
      } else if (state.sortKeys) {
        throw new YAMLException("sortKeys must be a boolean or a function");
      }
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (!compact || index !== 0) {
          pairBuffer += generateNextLine(state, level);
        }
        objectKey = objectKeyList[index];
        objectValue = object[objectKey];
        if (!writeNode(state, level + 1, objectKey, true, true, true)) {
          continue;
        }
        explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
        if (explicitPair) {
          if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
            pairBuffer += "?";
          } else {
            pairBuffer += "? ";
          }
        }
        pairBuffer += state.dump;
        if (explicitPair) {
          pairBuffer += generateNextLine(state, level);
        }
        if (!writeNode(state, level + 1, objectValue, true, explicitPair)) {
          continue;
        }
        if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
          pairBuffer += ":";
        } else {
          pairBuffer += ": ";
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = _result || "{}";
    }
    function detectType(state, object, explicit) {
      var _result, typeList, index, length, type, style;
      typeList = explicit ? state.explicitTypes : state.implicitTypes;
      for (index = 0, length = typeList.length; index < length; index += 1) {
        type = typeList[index];
        if ((type.instanceOf || type.predicate) && (!type.instanceOf || typeof object === "object" && object instanceof type.instanceOf) && (!type.predicate || type.predicate(object))) {
          state.tag = explicit ? type.tag : "?";
          if (type.represent) {
            style = state.styleMap[type.tag] || type.defaultStyle;
            if (_toString.call(type.represent) === "[object Function]") {
              _result = type.represent(object, style);
            } else if (_hasOwnProperty.call(type.represent, style)) {
              _result = type.represent[style](object, style);
            } else {
              throw new YAMLException("!<" + type.tag + '> tag resolver accepts not "' + style + '" style');
            }
            state.dump = _result;
          }
          return true;
        }
      }
      return false;
    }
    function writeNode(state, level, object, block, compact, iskey) {
      state.tag = null;
      state.dump = object;
      if (!detectType(state, object, false)) {
        detectType(state, object, true);
      }
      var type = _toString.call(state.dump);
      if (block) {
        block = state.flowLevel < 0 || state.flowLevel > level;
      }
      var objectOrArray = type === "[object Object]" || type === "[object Array]", duplicateIndex, duplicate;
      if (objectOrArray) {
        duplicateIndex = state.duplicates.indexOf(object);
        duplicate = duplicateIndex !== -1;
      }
      if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
        compact = false;
      }
      if (duplicate && state.usedDuplicates[duplicateIndex]) {
        state.dump = "*ref_" + duplicateIndex;
      } else {
        if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
          state.usedDuplicates[duplicateIndex] = true;
        }
        if (type === "[object Object]") {
          if (block && Object.keys(state.dump).length !== 0) {
            writeBlockMapping(state, level, state.dump, compact);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + state.dump;
            }
          } else {
            writeFlowMapping(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if (type === "[object Array]") {
          var arrayLevel = state.noArrayIndent && level > 0 ? level - 1 : level;
          if (block && state.dump.length !== 0) {
            writeBlockSequence(state, arrayLevel, state.dump, compact);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + state.dump;
            }
          } else {
            writeFlowSequence(state, arrayLevel, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if (type === "[object String]") {
          if (state.tag !== "?") {
            writeScalar(state, state.dump, level, iskey);
          }
        } else {
          if (state.skipInvalid)
            return false;
          throw new YAMLException("unacceptable kind of an object to dump " + type);
        }
        if (state.tag !== null && state.tag !== "?") {
          state.dump = "!<" + state.tag + "> " + state.dump;
        }
      }
      return true;
    }
    function getDuplicateReferences(object, state) {
      var objects = [], duplicatesIndexes = [], index, length;
      inspectNode(object, objects, duplicatesIndexes);
      for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
        state.duplicates.push(objects[duplicatesIndexes[index]]);
      }
      state.usedDuplicates = new Array(length);
    }
    function inspectNode(object, objects, duplicatesIndexes) {
      var objectKeyList, index, length;
      if (object !== null && typeof object === "object") {
        index = objects.indexOf(object);
        if (index !== -1) {
          if (duplicatesIndexes.indexOf(index) === -1) {
            duplicatesIndexes.push(index);
          }
        } else {
          objects.push(object);
          if (Array.isArray(object)) {
            for (index = 0, length = object.length; index < length; index += 1) {
              inspectNode(object[index], objects, duplicatesIndexes);
            }
          } else {
            objectKeyList = Object.keys(object);
            for (index = 0, length = objectKeyList.length; index < length; index += 1) {
              inspectNode(object[objectKeyList[index]], objects, duplicatesIndexes);
            }
          }
        }
      }
    }
    function dump(input, options) {
      options = options || {};
      var state = new State(options);
      if (!state.noRefs)
        getDuplicateReferences(input, state);
      if (writeNode(state, 0, input, true, true))
        return state.dump + "\n";
      return "";
    }
    function safeDump(input, options) {
      return dump(input, common.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    module2.exports.dump = dump;
    module2.exports.safeDump = safeDump;
  }
});

// node_modules/js-yaml/lib/js-yaml.js
var require_js_yaml = __commonJS({
  "node_modules/js-yaml/lib/js-yaml.js"(exports, module2) {
    "use strict";
    var loader = require_loader();
    var dumper = require_dumper();
    function deprecated(name) {
      return function() {
        throw new Error("Function " + name + " is deprecated and cannot be used.");
      };
    }
    module2.exports.Type = require_type();
    module2.exports.Schema = require_schema();
    module2.exports.FAILSAFE_SCHEMA = require_failsafe();
    module2.exports.JSON_SCHEMA = require_json3();
    module2.exports.CORE_SCHEMA = require_core2();
    module2.exports.DEFAULT_SAFE_SCHEMA = require_default_safe();
    module2.exports.DEFAULT_FULL_SCHEMA = require_default_full();
    module2.exports.load = loader.load;
    module2.exports.loadAll = loader.loadAll;
    module2.exports.safeLoad = loader.safeLoad;
    module2.exports.safeLoadAll = loader.safeLoadAll;
    module2.exports.dump = dumper.dump;
    module2.exports.safeDump = dumper.safeDump;
    module2.exports.YAMLException = require_exception();
    module2.exports.MINIMAL_SCHEMA = require_failsafe();
    module2.exports.SAFE_SCHEMA = require_default_safe();
    module2.exports.DEFAULT_SCHEMA = require_default_full();
    module2.exports.scan = deprecated("scan");
    module2.exports.parse = deprecated("parse");
    module2.exports.compose = deprecated("compose");
    module2.exports.addConstructor = deprecated("addConstructor");
  }
});

// node_modules/js-yaml/index.js
var require_js_yaml2 = __commonJS({
  "node_modules/js-yaml/index.js"(exports, module2) {
    "use strict";
    var yaml = require_js_yaml();
    module2.exports = yaml;
  }
});

// node_modules/read-yaml-file/index.js
var require_read_yaml_file = __commonJS({
  "node_modules/read-yaml-file/index.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs2();
    var pify = require_pify();
    var stripBom = require_strip_bom();
    var yaml = require_js_yaml2();
    var parse3 = (data) => yaml.safeLoad(stripBom(data));
    var readYamlFile = (fp) => pify(fs4.readFile)(fp, "utf8").then((data) => parse3(data));
    module2.exports = readYamlFile;
    module2.exports.default = readYamlFile;
    module2.exports.sync = (fp) => parse3(fs4.readFileSync(fp, "utf8"));
  }
});

// node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function() {
    var self2 = this, args = arguments;
    return new Promise(function(resolve, reject) {
      var gen = fn.apply(self2, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(void 0);
    });
  };
}
var init_asyncToGenerator = __esm({
  "node_modules/@babel/runtime/helpers/esm/asyncToGenerator.js"() {
  }
});

// node_modules/@babel/runtime/helpers/esm/classCallCheck.js
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
var init_classCallCheck = __esm({
  "node_modules/@babel/runtime/helpers/esm/classCallCheck.js"() {
  }
});

// node_modules/@babel/runtime/helpers/esm/typeof.js
function _typeof(obj) {
  "@babel/helpers - typeof";
  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function(obj2) {
    return typeof obj2;
  } : function(obj2) {
    return obj2 && "function" == typeof Symbol && obj2.constructor === Symbol && obj2 !== Symbol.prototype ? "symbol" : typeof obj2;
  }, _typeof(obj);
}
var init_typeof = __esm({
  "node_modules/@babel/runtime/helpers/esm/typeof.js"() {
  }
});

// node_modules/@babel/runtime/helpers/esm/assertThisInitialized.js
function _assertThisInitialized(self2) {
  if (self2 === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self2;
}
var init_assertThisInitialized = __esm({
  "node_modules/@babel/runtime/helpers/esm/assertThisInitialized.js"() {
  }
});

// node_modules/@babel/runtime/helpers/esm/possibleConstructorReturn.js
function _possibleConstructorReturn(self2, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self2);
}
var init_possibleConstructorReturn = __esm({
  "node_modules/@babel/runtime/helpers/esm/possibleConstructorReturn.js"() {
    init_typeof();
    init_assertThisInitialized();
  }
});

// node_modules/@babel/runtime/helpers/esm/getPrototypeOf.js
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf2(o2) {
    return o2.__proto__ || Object.getPrototypeOf(o2);
  };
  return _getPrototypeOf(o);
}
var init_getPrototypeOf = __esm({
  "node_modules/@babel/runtime/helpers/esm/getPrototypeOf.js"() {
  }
});

// node_modules/@babel/runtime/helpers/esm/setPrototypeOf.js
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf2(o2, p2) {
    o2.__proto__ = p2;
    return o2;
  };
  return _setPrototypeOf(o, p);
}
var init_setPrototypeOf = __esm({
  "node_modules/@babel/runtime/helpers/esm/setPrototypeOf.js"() {
  }
});

// node_modules/@babel/runtime/helpers/esm/inherits.js
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass)
    _setPrototypeOf(subClass, superClass);
}
var init_inherits = __esm({
  "node_modules/@babel/runtime/helpers/esm/inherits.js"() {
    init_setPrototypeOf();
  }
});

// node_modules/@babel/runtime/helpers/esm/isNativeFunction.js
function _isNativeFunction(fn) {
  return Function.toString.call(fn).indexOf("[native code]") !== -1;
}
var init_isNativeFunction = __esm({
  "node_modules/@babel/runtime/helpers/esm/isNativeFunction.js"() {
  }
});

// node_modules/@babel/runtime/helpers/esm/isNativeReflectConstruct.js
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct)
    return false;
  if (Reflect.construct.sham)
    return false;
  if (typeof Proxy === "function")
    return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {
    }));
    return true;
  } catch (e2) {
    return false;
  }
}
var init_isNativeReflectConstruct = __esm({
  "node_modules/@babel/runtime/helpers/esm/isNativeReflectConstruct.js"() {
  }
});

// node_modules/@babel/runtime/helpers/esm/construct.js
function _construct(Parent, args, Class) {
  if (_isNativeReflectConstruct()) {
    _construct = Reflect.construct.bind();
  } else {
    _construct = function _construct2(Parent2, args2, Class2) {
      var a = [null];
      a.push.apply(a, args2);
      var Constructor = Function.bind.apply(Parent2, a);
      var instance = new Constructor();
      if (Class2)
        _setPrototypeOf(instance, Class2.prototype);
      return instance;
    };
  }
  return _construct.apply(null, arguments);
}
var init_construct = __esm({
  "node_modules/@babel/runtime/helpers/esm/construct.js"() {
    init_setPrototypeOf();
    init_isNativeReflectConstruct();
  }
});

// node_modules/@babel/runtime/helpers/esm/wrapNativeSuper.js
function _wrapNativeSuper(Class) {
  var _cache = typeof Map === "function" ? /* @__PURE__ */ new Map() : void 0;
  _wrapNativeSuper = function _wrapNativeSuper2(Class2) {
    if (Class2 === null || !_isNativeFunction(Class2))
      return Class2;
    if (typeof Class2 !== "function") {
      throw new TypeError("Super expression must either be null or a function");
    }
    if (typeof _cache !== "undefined") {
      if (_cache.has(Class2))
        return _cache.get(Class2);
      _cache.set(Class2, Wrapper);
    }
    function Wrapper() {
      return _construct(Class2, arguments, _getPrototypeOf(this).constructor);
    }
    Wrapper.prototype = Object.create(Class2.prototype, {
      constructor: {
        value: Wrapper,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    return _setPrototypeOf(Wrapper, Class2);
  };
  return _wrapNativeSuper(Class);
}
var init_wrapNativeSuper = __esm({
  "node_modules/@babel/runtime/helpers/esm/wrapNativeSuper.js"() {
    init_getPrototypeOf();
    init_setPrototypeOf();
    init_isNativeFunction();
    init_construct();
  }
});

// node_modules/p-try/index.js
var require_p_try = __commonJS({
  "node_modules/p-try/index.js"(exports, module2) {
    "use strict";
    var pTry = (fn, ...arguments_) => new Promise((resolve) => {
      resolve(fn(...arguments_));
    });
    module2.exports = pTry;
    module2.exports.default = pTry;
  }
});

// node_modules/p-limit/index.js
var require_p_limit = __commonJS({
  "node_modules/p-limit/index.js"(exports, module2) {
    "use strict";
    var pTry = require_p_try();
    var pLimit = (concurrency) => {
      if (!((Number.isInteger(concurrency) || concurrency === Infinity) && concurrency > 0)) {
        return Promise.reject(new TypeError("Expected `concurrency` to be a number from 1 and up"));
      }
      const queue = [];
      let activeCount = 0;
      const next = () => {
        activeCount--;
        if (queue.length > 0) {
          queue.shift()();
        }
      };
      const run = (fn, resolve, ...args) => {
        activeCount++;
        const result = pTry(fn, ...args);
        resolve(result);
        result.then(next, next);
      };
      const enqueue = (fn, resolve, ...args) => {
        if (activeCount < concurrency) {
          run(fn, resolve, ...args);
        } else {
          queue.push(run.bind(null, fn, resolve, ...args));
        }
      };
      const generator = (fn, ...args) => new Promise((resolve) => enqueue(fn, resolve, ...args));
      Object.defineProperties(generator, {
        activeCount: {
          get: () => activeCount
        },
        pendingCount: {
          get: () => queue.length
        },
        clearQueue: {
          value: () => {
            queue.length = 0;
          }
        }
      });
      return generator;
    };
    module2.exports = pLimit;
    module2.exports.default = pLimit;
  }
});

// node_modules/p-locate/index.js
var require_p_locate = __commonJS({
  "node_modules/p-locate/index.js"(exports, module2) {
    "use strict";
    var pLimit = require_p_limit();
    var EndError = class extends Error {
      constructor(value) {
        super();
        this.value = value;
      }
    };
    var testElement = async (element, tester) => tester(await element);
    var finder = async (element) => {
      const values = await Promise.all(element);
      if (values[1] === true) {
        throw new EndError(values[0]);
      }
      return false;
    };
    var pLocate = async (iterable, tester, options) => {
      options = {
        concurrency: Infinity,
        preserveOrder: true,
        ...options
      };
      const limit = pLimit(options.concurrency);
      const items = [...iterable].map((element) => [element, limit(testElement, element, tester)]);
      const checkLimit = pLimit(options.preserveOrder ? 1 : Infinity);
      try {
        await Promise.all(items.map((element) => checkLimit(finder, element)));
      } catch (error) {
        if (error instanceof EndError) {
          return error.value;
        }
        throw error;
      }
    };
    module2.exports = pLocate;
    module2.exports.default = pLocate;
  }
});

// node_modules/locate-path/index.js
var require_locate_path = __commonJS({
  "node_modules/locate-path/index.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var fs4 = require("fs");
    var { promisify: promisify2 } = require("util");
    var pLocate = require_p_locate();
    var fsStat = promisify2(fs4.stat);
    var fsLStat = promisify2(fs4.lstat);
    var typeMappings = {
      directory: "isDirectory",
      file: "isFile"
    };
    function checkType({ type }) {
      if (type in typeMappings) {
        return;
      }
      throw new Error(`Invalid type specified: ${type}`);
    }
    var matchType = (type, stat3) => type === void 0 || stat3[typeMappings[type]]();
    module2.exports = async (paths, options) => {
      options = {
        cwd: process.cwd(),
        type: "file",
        allowSymlinks: true,
        ...options
      };
      checkType(options);
      const statFn = options.allowSymlinks ? fsStat : fsLStat;
      return pLocate(paths, async (path_) => {
        try {
          const stat3 = await statFn(path4.resolve(options.cwd, path_));
          return matchType(options.type, stat3);
        } catch (_) {
          return false;
        }
      }, options);
    };
    module2.exports.sync = (paths, options) => {
      options = {
        cwd: process.cwd(),
        allowSymlinks: true,
        type: "file",
        ...options
      };
      checkType(options);
      const statFn = options.allowSymlinks ? fs4.statSync : fs4.lstatSync;
      for (const path_ of paths) {
        try {
          const stat3 = statFn(path4.resolve(options.cwd, path_));
          if (matchType(options.type, stat3)) {
            return path_;
          }
        } catch (_) {
        }
      }
    };
  }
});

// node_modules/path-exists/index.js
var require_path_exists3 = __commonJS({
  "node_modules/path-exists/index.js"(exports, module2) {
    "use strict";
    var fs4 = require("fs");
    var { promisify: promisify2 } = require("util");
    var pAccess = promisify2(fs4.access);
    module2.exports = async (path4) => {
      try {
        await pAccess(path4);
        return true;
      } catch (_) {
        return false;
      }
    };
    module2.exports.sync = (path4) => {
      try {
        fs4.accessSync(path4);
        return true;
      } catch (_) {
        return false;
      }
    };
  }
});

// node_modules/find-up/index.js
var require_find_up = __commonJS({
  "node_modules/find-up/index.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var locatePath = require_locate_path();
    var pathExists = require_path_exists3();
    var stop = Symbol("findUp.stop");
    module2.exports = async (name, options = {}) => {
      let directory = path4.resolve(options.cwd || "");
      const { root } = path4.parse(directory);
      const paths = [].concat(name);
      const runMatcher = async (locateOptions) => {
        if (typeof name !== "function") {
          return locatePath(paths, locateOptions);
        }
        const foundPath = await name(locateOptions.cwd);
        if (typeof foundPath === "string") {
          return locatePath([foundPath], locateOptions);
        }
        return foundPath;
      };
      while (true) {
        const foundPath = await runMatcher({ ...options, cwd: directory });
        if (foundPath === stop) {
          return;
        }
        if (foundPath) {
          return path4.resolve(directory, foundPath);
        }
        if (directory === root) {
          return;
        }
        directory = path4.dirname(directory);
      }
    };
    module2.exports.sync = (name, options = {}) => {
      let directory = path4.resolve(options.cwd || "");
      const { root } = path4.parse(directory);
      const paths = [].concat(name);
      const runMatcher = (locateOptions) => {
        if (typeof name !== "function") {
          return locatePath.sync(paths, locateOptions);
        }
        const foundPath = name(locateOptions.cwd);
        if (typeof foundPath === "string") {
          return locatePath.sync([foundPath], locateOptions);
        }
        return foundPath;
      };
      while (true) {
        const foundPath = runMatcher({ ...options, cwd: directory });
        if (foundPath === stop) {
          return;
        }
        if (foundPath) {
          return path4.resolve(directory, foundPath);
        }
        if (directory === root) {
          return;
        }
        directory = path4.dirname(directory);
      }
    };
    module2.exports.exists = pathExists;
    module2.exports.sync.exists = pathExists.sync;
    module2.exports.stop = stop;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/fs/index.js
var require_fs7 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/fs/index.js"(exports) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs();
    var api = [
      "access",
      "appendFile",
      "chmod",
      "chown",
      "close",
      "copyFile",
      "fchmod",
      "fchown",
      "fdatasync",
      "fstat",
      "fsync",
      "ftruncate",
      "futimes",
      "lchown",
      "lchmod",
      "link",
      "lstat",
      "mkdir",
      "mkdtemp",
      "open",
      "readFile",
      "readdir",
      "readlink",
      "realpath",
      "rename",
      "rmdir",
      "stat",
      "symlink",
      "truncate",
      "unlink",
      "utimes",
      "writeFile"
    ].filter((key) => {
      return typeof fs4[key] === "function";
    });
    Object.keys(fs4).forEach((key) => {
      if (key === "promises") {
        return;
      }
      exports[key] = fs4[key];
    });
    api.forEach((method) => {
      exports[method] = u(fs4[method]);
    });
    exports.exists = function(filename, callback) {
      if (typeof callback === "function") {
        return fs4.exists(filename, callback);
      }
      return new Promise((resolve) => {
        return fs4.exists(filename, resolve);
      });
    };
    exports.read = function(fd, buffer, offset, length, position, callback) {
      if (typeof callback === "function") {
        return fs4.read(fd, buffer, offset, length, position, callback);
      }
      return new Promise((resolve, reject) => {
        fs4.read(fd, buffer, offset, length, position, (err, bytesRead, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesRead, buffer: buffer2 });
        });
      });
    };
    exports.write = function(fd, buffer, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs4.write(fd, buffer, ...args);
      }
      return new Promise((resolve, reject) => {
        fs4.write(fd, buffer, ...args, (err, bytesWritten, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesWritten, buffer: buffer2 });
        });
      });
    };
    if (typeof fs4.realpath.native === "function") {
      exports.realpath.native = u(fs4.realpath.native);
    }
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/mkdirs/win32.js
var require_win322 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/mkdirs/win32.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    function getRootPath(p) {
      p = path4.normalize(path4.resolve(p)).split(path4.sep);
      if (p.length > 0)
        return p[0];
      return null;
    }
    var INVALID_PATH_CHARS = /[<>:"|?*]/;
    function invalidWin32Path(p) {
      const rp = getRootPath(p);
      p = p.replace(rp, "");
      return INVALID_PATH_CHARS.test(p);
    }
    module2.exports = {
      getRootPath,
      invalidWin32Path
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/mkdirs/mkdirs.js
var require_mkdirs4 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/mkdirs/mkdirs.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var invalidWin32Path = require_win322().invalidWin32Path;
    var o777 = parseInt("0777", 8);
    function mkdirs(p, opts, callback, made) {
      if (typeof opts === "function") {
        callback = opts;
        opts = {};
      } else if (!opts || typeof opts !== "object") {
        opts = { mode: opts };
      }
      if (process.platform === "win32" && invalidWin32Path(p)) {
        const errInval = new Error(p + " contains invalid WIN32 path characters.");
        errInval.code = "EINVAL";
        return callback(errInval);
      }
      let mode = opts.mode;
      const xfs = opts.fs || fs4;
      if (mode === void 0) {
        mode = o777 & ~process.umask();
      }
      if (!made)
        made = null;
      callback = callback || function() {
      };
      p = path4.resolve(p);
      xfs.mkdir(p, mode, (er) => {
        if (!er) {
          made = made || p;
          return callback(null, made);
        }
        switch (er.code) {
          case "ENOENT":
            if (path4.dirname(p) === p)
              return callback(er);
            mkdirs(path4.dirname(p), opts, (er2, made2) => {
              if (er2)
                callback(er2, made2);
              else
                mkdirs(p, opts, callback, made2);
            });
            break;
          default:
            xfs.stat(p, (er2, stat3) => {
              if (er2 || !stat3.isDirectory())
                callback(er, made);
              else
                callback(null, made);
            });
            break;
        }
      });
    }
    module2.exports = mkdirs;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/mkdirs/mkdirs-sync.js
var require_mkdirs_sync2 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/mkdirs/mkdirs-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var invalidWin32Path = require_win322().invalidWin32Path;
    var o777 = parseInt("0777", 8);
    function mkdirsSync(p, opts, made) {
      if (!opts || typeof opts !== "object") {
        opts = { mode: opts };
      }
      let mode = opts.mode;
      const xfs = opts.fs || fs4;
      if (process.platform === "win32" && invalidWin32Path(p)) {
        const errInval = new Error(p + " contains invalid WIN32 path characters.");
        errInval.code = "EINVAL";
        throw errInval;
      }
      if (mode === void 0) {
        mode = o777 & ~process.umask();
      }
      if (!made)
        made = null;
      p = path4.resolve(p);
      try {
        xfs.mkdirSync(p, mode);
        made = made || p;
      } catch (err0) {
        if (err0.code === "ENOENT") {
          if (path4.dirname(p) === p)
            throw err0;
          made = mkdirsSync(path4.dirname(p), opts, made);
          mkdirsSync(p, opts, made);
        } else {
          let stat3;
          try {
            stat3 = xfs.statSync(p);
          } catch (err1) {
            throw err0;
          }
          if (!stat3.isDirectory())
            throw err0;
        }
      }
      return made;
    }
    module2.exports = mkdirsSync;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/mkdirs/index.js
var require_mkdirs5 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/mkdirs/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var mkdirs = u(require_mkdirs4());
    var mkdirsSync = require_mkdirs_sync2();
    module2.exports = {
      mkdirs,
      mkdirsSync,
      mkdirp: mkdirs,
      mkdirpSync: mkdirsSync,
      ensureDir: mkdirs,
      ensureDirSync: mkdirsSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/util/utimes.js
var require_utimes3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/util/utimes.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var os = require("os");
    var path4 = require("path");
    function hasMillisResSync() {
      let tmpfile = path4.join("millis-test-sync" + Date.now().toString() + Math.random().toString().slice(2));
      tmpfile = path4.join(os.tmpdir(), tmpfile);
      const d = new Date(1435410243862);
      fs4.writeFileSync(tmpfile, "https://github.com/jprichardson/node-fs-extra/pull/141");
      const fd = fs4.openSync(tmpfile, "r+");
      fs4.futimesSync(fd, d, d);
      fs4.closeSync(fd);
      return fs4.statSync(tmpfile).mtime > 1435410243e3;
    }
    function hasMillisRes(callback) {
      let tmpfile = path4.join("millis-test" + Date.now().toString() + Math.random().toString().slice(2));
      tmpfile = path4.join(os.tmpdir(), tmpfile);
      const d = new Date(1435410243862);
      fs4.writeFile(tmpfile, "https://github.com/jprichardson/node-fs-extra/pull/141", (err) => {
        if (err)
          return callback(err);
        fs4.open(tmpfile, "r+", (err2, fd) => {
          if (err2)
            return callback(err2);
          fs4.futimes(fd, d, d, (err3) => {
            if (err3)
              return callback(err3);
            fs4.close(fd, (err4) => {
              if (err4)
                return callback(err4);
              fs4.stat(tmpfile, (err5, stats) => {
                if (err5)
                  return callback(err5);
                callback(null, stats.mtime > 1435410243e3);
              });
            });
          });
        });
      });
    }
    function timeRemoveMillis(timestamp) {
      if (typeof timestamp === "number") {
        return Math.floor(timestamp / 1e3) * 1e3;
      } else if (timestamp instanceof Date) {
        return new Date(Math.floor(timestamp.getTime() / 1e3) * 1e3);
      } else {
        throw new Error("fs-extra: timeRemoveMillis() unknown parameter type");
      }
    }
    function utimesMillis(path5, atime, mtime, callback) {
      fs4.open(path5, "r+", (err, fd) => {
        if (err)
          return callback(err);
        fs4.futimes(fd, atime, mtime, (futimesErr) => {
          fs4.close(fd, (closeErr) => {
            if (callback)
              callback(futimesErr || closeErr);
          });
        });
      });
    }
    function utimesMillisSync(path5, atime, mtime) {
      const fd = fs4.openSync(path5, "r+");
      fs4.futimesSync(fd, atime, mtime);
      return fs4.closeSync(fd);
    }
    module2.exports = {
      hasMillisRes,
      hasMillisResSync,
      timeRemoveMillis,
      utimesMillis,
      utimesMillisSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/util/stat.js
var require_stat3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/util/stat.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var NODE_VERSION_MAJOR_WITH_BIGINT = 10;
    var NODE_VERSION_MINOR_WITH_BIGINT = 5;
    var NODE_VERSION_PATCH_WITH_BIGINT = 0;
    var nodeVersion = process.versions.node.split(".");
    var nodeVersionMajor = Number.parseInt(nodeVersion[0], 10);
    var nodeVersionMinor = Number.parseInt(nodeVersion[1], 10);
    var nodeVersionPatch = Number.parseInt(nodeVersion[2], 10);
    function nodeSupportsBigInt() {
      if (nodeVersionMajor > NODE_VERSION_MAJOR_WITH_BIGINT) {
        return true;
      } else if (nodeVersionMajor === NODE_VERSION_MAJOR_WITH_BIGINT) {
        if (nodeVersionMinor > NODE_VERSION_MINOR_WITH_BIGINT) {
          return true;
        } else if (nodeVersionMinor === NODE_VERSION_MINOR_WITH_BIGINT) {
          if (nodeVersionPatch >= NODE_VERSION_PATCH_WITH_BIGINT) {
            return true;
          }
        }
      }
      return false;
    }
    function getStats(src, dest, cb) {
      if (nodeSupportsBigInt()) {
        fs4.stat(src, { bigint: true }, (err, srcStat) => {
          if (err)
            return cb(err);
          fs4.stat(dest, { bigint: true }, (err2, destStat) => {
            if (err2) {
              if (err2.code === "ENOENT")
                return cb(null, { srcStat, destStat: null });
              return cb(err2);
            }
            return cb(null, { srcStat, destStat });
          });
        });
      } else {
        fs4.stat(src, (err, srcStat) => {
          if (err)
            return cb(err);
          fs4.stat(dest, (err2, destStat) => {
            if (err2) {
              if (err2.code === "ENOENT")
                return cb(null, { srcStat, destStat: null });
              return cb(err2);
            }
            return cb(null, { srcStat, destStat });
          });
        });
      }
    }
    function getStatsSync(src, dest) {
      let srcStat, destStat;
      if (nodeSupportsBigInt()) {
        srcStat = fs4.statSync(src, { bigint: true });
      } else {
        srcStat = fs4.statSync(src);
      }
      try {
        if (nodeSupportsBigInt()) {
          destStat = fs4.statSync(dest, { bigint: true });
        } else {
          destStat = fs4.statSync(dest);
        }
      } catch (err) {
        if (err.code === "ENOENT")
          return { srcStat, destStat: null };
        throw err;
      }
      return { srcStat, destStat };
    }
    function checkPaths(src, dest, funcName, cb) {
      getStats(src, dest, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        if (destStat && destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
          return cb(new Error("Source and destination must not be the same."));
        }
        if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
          return cb(new Error(errMsg(src, dest, funcName)));
        }
        return cb(null, { srcStat, destStat });
      });
    }
    function checkPathsSync(src, dest, funcName) {
      const { srcStat, destStat } = getStatsSync(src, dest);
      if (destStat && destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
        throw new Error("Source and destination must not be the same.");
      }
      if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return { srcStat, destStat };
    }
    function checkParentPaths(src, srcStat, dest, funcName, cb) {
      const srcParent = path4.resolve(path4.dirname(src));
      const destParent = path4.resolve(path4.dirname(dest));
      if (destParent === srcParent || destParent === path4.parse(destParent).root)
        return cb();
      if (nodeSupportsBigInt()) {
        fs4.stat(destParent, { bigint: true }, (err, destStat) => {
          if (err) {
            if (err.code === "ENOENT")
              return cb();
            return cb(err);
          }
          if (destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
            return cb(new Error(errMsg(src, dest, funcName)));
          }
          return checkParentPaths(src, srcStat, destParent, funcName, cb);
        });
      } else {
        fs4.stat(destParent, (err, destStat) => {
          if (err) {
            if (err.code === "ENOENT")
              return cb();
            return cb(err);
          }
          if (destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
            return cb(new Error(errMsg(src, dest, funcName)));
          }
          return checkParentPaths(src, srcStat, destParent, funcName, cb);
        });
      }
    }
    function checkParentPathsSync(src, srcStat, dest, funcName) {
      const srcParent = path4.resolve(path4.dirname(src));
      const destParent = path4.resolve(path4.dirname(dest));
      if (destParent === srcParent || destParent === path4.parse(destParent).root)
        return;
      let destStat;
      try {
        if (nodeSupportsBigInt()) {
          destStat = fs4.statSync(destParent, { bigint: true });
        } else {
          destStat = fs4.statSync(destParent);
        }
      } catch (err) {
        if (err.code === "ENOENT")
          return;
        throw err;
      }
      if (destStat.ino && destStat.dev && destStat.ino === srcStat.ino && destStat.dev === srcStat.dev) {
        throw new Error(errMsg(src, dest, funcName));
      }
      return checkParentPathsSync(src, srcStat, destParent, funcName);
    }
    function isSrcSubdir(src, dest) {
      const srcArr = path4.resolve(src).split(path4.sep).filter((i2) => i2);
      const destArr = path4.resolve(dest).split(path4.sep).filter((i2) => i2);
      return srcArr.reduce((acc, cur, i2) => acc && destArr[i2] === cur, true);
    }
    function errMsg(src, dest, funcName) {
      return `Cannot ${funcName} '${src}' to a subdirectory of itself, '${dest}'.`;
    }
    module2.exports = {
      checkPaths,
      checkPathsSync,
      checkParentPaths,
      checkParentPathsSync,
      isSrcSubdir
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/util/buffer.js
var require_buffer2 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/util/buffer.js"(exports, module2) {
    "use strict";
    module2.exports = function(size) {
      if (typeof Buffer.allocUnsafe === "function") {
        try {
          return Buffer.allocUnsafe(size);
        } catch (e2) {
          return new Buffer(size);
        }
      }
      return new Buffer(size);
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/copy-sync/copy-sync.js
var require_copy_sync4 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/copy-sync/copy-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdirpSync = require_mkdirs5().mkdirsSync;
    var utimesSync = require_utimes3().utimesMillisSync;
    var stat3 = require_stat3();
    function copySync(src, dest, opts) {
      if (typeof opts === "function") {
        opts = { filter: opts };
      }
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      const { srcStat, destStat } = stat3.checkPathsSync(src, dest, "copy");
      stat3.checkParentPathsSync(src, srcStat, dest, "copy");
      return handleFilterAndCopy(destStat, src, dest, opts);
    }
    function handleFilterAndCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      const destParent = path4.dirname(dest);
      if (!fs4.existsSync(destParent))
        mkdirpSync(destParent);
      return startCopy(destStat, src, dest, opts);
    }
    function startCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      return getStats(destStat, src, dest, opts);
    }
    function getStats(destStat, src, dest, opts) {
      const statSync2 = opts.dereference ? fs4.statSync : fs4.lstatSync;
      const srcStat = statSync2(src);
      if (srcStat.isDirectory())
        return onDir(srcStat, destStat, src, dest, opts);
      else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
        return onFile(srcStat, destStat, src, dest, opts);
      else if (srcStat.isSymbolicLink())
        return onLink(destStat, src, dest, opts);
    }
    function onFile(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts);
      return mayCopyFile(srcStat, src, dest, opts);
    }
    function mayCopyFile(srcStat, src, dest, opts) {
      if (opts.overwrite) {
        fs4.unlinkSync(dest);
        return copyFile(srcStat, src, dest, opts);
      } else if (opts.errorOnExist) {
        throw new Error(`'${dest}' already exists`);
      }
    }
    function copyFile(srcStat, src, dest, opts) {
      if (typeof fs4.copyFileSync === "function") {
        fs4.copyFileSync(src, dest);
        fs4.chmodSync(dest, srcStat.mode);
        if (opts.preserveTimestamps) {
          return utimesSync(dest, srcStat.atime, srcStat.mtime);
        }
        return;
      }
      return copyFileFallback(srcStat, src, dest, opts);
    }
    function copyFileFallback(srcStat, src, dest, opts) {
      const BUF_LENGTH = 64 * 1024;
      const _buff = require_buffer2()(BUF_LENGTH);
      const fdr = fs4.openSync(src, "r");
      const fdw = fs4.openSync(dest, "w", srcStat.mode);
      let pos = 0;
      while (pos < srcStat.size) {
        const bytesRead = fs4.readSync(fdr, _buff, 0, BUF_LENGTH, pos);
        fs4.writeSync(fdw, _buff, 0, bytesRead);
        pos += bytesRead;
      }
      if (opts.preserveTimestamps)
        fs4.futimesSync(fdw, srcStat.atime, srcStat.mtime);
      fs4.closeSync(fdr);
      fs4.closeSync(fdw);
    }
    function onDir(srcStat, destStat, src, dest, opts) {
      if (!destStat)
        return mkDirAndCopy(srcStat, src, dest, opts);
      if (destStat && !destStat.isDirectory()) {
        throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`);
      }
      return copyDir(src, dest, opts);
    }
    function mkDirAndCopy(srcStat, src, dest, opts) {
      fs4.mkdirSync(dest);
      copyDir(src, dest, opts);
      return fs4.chmodSync(dest, srcStat.mode);
    }
    function copyDir(src, dest, opts) {
      fs4.readdirSync(src).forEach((item) => copyDirItem(item, src, dest, opts));
    }
    function copyDirItem(item, src, dest, opts) {
      const srcItem = path4.join(src, item);
      const destItem = path4.join(dest, item);
      const { destStat } = stat3.checkPathsSync(srcItem, destItem, "copy");
      return startCopy(destStat, srcItem, destItem, opts);
    }
    function onLink(destStat, src, dest, opts) {
      let resolvedSrc = fs4.readlinkSync(src);
      if (opts.dereference) {
        resolvedSrc = path4.resolve(process.cwd(), resolvedSrc);
      }
      if (!destStat) {
        return fs4.symlinkSync(resolvedSrc, dest);
      } else {
        let resolvedDest;
        try {
          resolvedDest = fs4.readlinkSync(dest);
        } catch (err) {
          if (err.code === "EINVAL" || err.code === "UNKNOWN")
            return fs4.symlinkSync(resolvedSrc, dest);
          throw err;
        }
        if (opts.dereference) {
          resolvedDest = path4.resolve(process.cwd(), resolvedDest);
        }
        if (stat3.isSrcSubdir(resolvedSrc, resolvedDest)) {
          throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
        }
        if (fs4.statSync(dest).isDirectory() && stat3.isSrcSubdir(resolvedDest, resolvedSrc)) {
          throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
        }
        return copyLink(resolvedSrc, dest);
      }
    }
    function copyLink(resolvedSrc, dest) {
      fs4.unlinkSync(dest);
      return fs4.symlinkSync(resolvedSrc, dest);
    }
    module2.exports = copySync;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/copy-sync/index.js
var require_copy_sync5 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/copy-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      copySync: require_copy_sync4()
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/path-exists/index.js
var require_path_exists4 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/path-exists/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromPromise;
    var fs4 = require_fs7();
    function pathExists(path4) {
      return fs4.access(path4).then(() => true).catch(() => false);
    }
    module2.exports = {
      pathExists: u(pathExists),
      pathExistsSync: fs4.existsSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/copy/copy.js
var require_copy5 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/copy/copy.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdirp2 = require_mkdirs5().mkdirs;
    var pathExists = require_path_exists4().pathExists;
    var utimes = require_utimes3().utimesMillis;
    var stat3 = require_stat3();
    function copy(src, dest, opts, cb) {
      if (typeof opts === "function" && !cb) {
        cb = opts;
        opts = {};
      } else if (typeof opts === "function") {
        opts = { filter: opts };
      }
      cb = cb || function() {
      };
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      stat3.checkPaths(src, dest, "copy", (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        stat3.checkParentPaths(src, srcStat, dest, "copy", (err2) => {
          if (err2)
            return cb(err2);
          if (opts.filter)
            return handleFilter(checkParentDir, destStat, src, dest, opts, cb);
          return checkParentDir(destStat, src, dest, opts, cb);
        });
      });
    }
    function checkParentDir(destStat, src, dest, opts, cb) {
      const destParent = path4.dirname(dest);
      pathExists(destParent, (err, dirExists) => {
        if (err)
          return cb(err);
        if (dirExists)
          return startCopy(destStat, src, dest, opts, cb);
        mkdirp2(destParent, (err2) => {
          if (err2)
            return cb(err2);
          return startCopy(destStat, src, dest, opts, cb);
        });
      });
    }
    function handleFilter(onInclude, destStat, src, dest, opts, cb) {
      Promise.resolve(opts.filter(src, dest)).then((include) => {
        if (include)
          return onInclude(destStat, src, dest, opts, cb);
        return cb();
      }, (error) => cb(error));
    }
    function startCopy(destStat, src, dest, opts, cb) {
      if (opts.filter)
        return handleFilter(getStats, destStat, src, dest, opts, cb);
      return getStats(destStat, src, dest, opts, cb);
    }
    function getStats(destStat, src, dest, opts, cb) {
      const stat4 = opts.dereference ? fs4.stat : fs4.lstat;
      stat4(src, (err, srcStat) => {
        if (err)
          return cb(err);
        if (srcStat.isDirectory())
          return onDir(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
          return onFile(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isSymbolicLink())
          return onLink(destStat, src, dest, opts, cb);
      });
    }
    function onFile(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return copyFile(srcStat, src, dest, opts, cb);
      return mayCopyFile(srcStat, src, dest, opts, cb);
    }
    function mayCopyFile(srcStat, src, dest, opts, cb) {
      if (opts.overwrite) {
        fs4.unlink(dest, (err) => {
          if (err)
            return cb(err);
          return copyFile(srcStat, src, dest, opts, cb);
        });
      } else if (opts.errorOnExist) {
        return cb(new Error(`'${dest}' already exists`));
      } else
        return cb();
    }
    function copyFile(srcStat, src, dest, opts, cb) {
      if (typeof fs4.copyFile === "function") {
        return fs4.copyFile(src, dest, (err) => {
          if (err)
            return cb(err);
          return setDestModeAndTimestamps(srcStat, dest, opts, cb);
        });
      }
      return copyFileFallback(srcStat, src, dest, opts, cb);
    }
    function copyFileFallback(srcStat, src, dest, opts, cb) {
      const rs = fs4.createReadStream(src);
      rs.on("error", (err) => cb(err)).once("open", () => {
        const ws = fs4.createWriteStream(dest, { mode: srcStat.mode });
        ws.on("error", (err) => cb(err)).on("open", () => rs.pipe(ws)).once("close", () => setDestModeAndTimestamps(srcStat, dest, opts, cb));
      });
    }
    function setDestModeAndTimestamps(srcStat, dest, opts, cb) {
      fs4.chmod(dest, srcStat.mode, (err) => {
        if (err)
          return cb(err);
        if (opts.preserveTimestamps) {
          return utimes(dest, srcStat.atime, srcStat.mtime, cb);
        }
        return cb();
      });
    }
    function onDir(srcStat, destStat, src, dest, opts, cb) {
      if (!destStat)
        return mkDirAndCopy(srcStat, src, dest, opts, cb);
      if (destStat && !destStat.isDirectory()) {
        return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`));
      }
      return copyDir(src, dest, opts, cb);
    }
    function mkDirAndCopy(srcStat, src, dest, opts, cb) {
      fs4.mkdir(dest, (err) => {
        if (err)
          return cb(err);
        copyDir(src, dest, opts, (err2) => {
          if (err2)
            return cb(err2);
          return fs4.chmod(dest, srcStat.mode, cb);
        });
      });
    }
    function copyDir(src, dest, opts, cb) {
      fs4.readdir(src, (err, items) => {
        if (err)
          return cb(err);
        return copyDirItems(items, src, dest, opts, cb);
      });
    }
    function copyDirItems(items, src, dest, opts, cb) {
      const item = items.pop();
      if (!item)
        return cb();
      return copyDirItem(items, item, src, dest, opts, cb);
    }
    function copyDirItem(items, item, src, dest, opts, cb) {
      const srcItem = path4.join(src, item);
      const destItem = path4.join(dest, item);
      stat3.checkPaths(srcItem, destItem, "copy", (err, stats) => {
        if (err)
          return cb(err);
        const { destStat } = stats;
        startCopy(destStat, srcItem, destItem, opts, (err2) => {
          if (err2)
            return cb(err2);
          return copyDirItems(items, src, dest, opts, cb);
        });
      });
    }
    function onLink(destStat, src, dest, opts, cb) {
      fs4.readlink(src, (err, resolvedSrc) => {
        if (err)
          return cb(err);
        if (opts.dereference) {
          resolvedSrc = path4.resolve(process.cwd(), resolvedSrc);
        }
        if (!destStat) {
          return fs4.symlink(resolvedSrc, dest, cb);
        } else {
          fs4.readlink(dest, (err2, resolvedDest) => {
            if (err2) {
              if (err2.code === "EINVAL" || err2.code === "UNKNOWN")
                return fs4.symlink(resolvedSrc, dest, cb);
              return cb(err2);
            }
            if (opts.dereference) {
              resolvedDest = path4.resolve(process.cwd(), resolvedDest);
            }
            if (stat3.isSrcSubdir(resolvedSrc, resolvedDest)) {
              return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`));
            }
            if (destStat.isDirectory() && stat3.isSrcSubdir(resolvedDest, resolvedSrc)) {
              return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`));
            }
            return copyLink(resolvedSrc, dest, cb);
          });
        }
      });
    }
    function copyLink(resolvedSrc, dest, cb) {
      fs4.unlink(dest, (err) => {
        if (err)
          return cb(err);
        return fs4.symlink(resolvedSrc, dest, cb);
      });
    }
    module2.exports = copy;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/copy/index.js
var require_copy6 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/copy/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    module2.exports = {
      copy: u(require_copy5())
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/remove/rimraf.js
var require_rimraf3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/remove/rimraf.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var assert = require("assert");
    var isWindows = process.platform === "win32";
    function defaults(options) {
      const methods = [
        "unlink",
        "chmod",
        "stat",
        "lstat",
        "rmdir",
        "readdir"
      ];
      methods.forEach((m2) => {
        options[m2] = options[m2] || fs4[m2];
        m2 = m2 + "Sync";
        options[m2] = options[m2] || fs4[m2];
      });
      options.maxBusyTries = options.maxBusyTries || 3;
    }
    function rimraf(p, options, cb) {
      let busyTries = 0;
      if (typeof options === "function") {
        cb = options;
        options = {};
      }
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert.strictEqual(typeof cb, "function", "rimraf: callback function required");
      assert(options, "rimraf: invalid options argument provided");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      defaults(options);
      rimraf_(p, options, function CB(er) {
        if (er) {
          if ((er.code === "EBUSY" || er.code === "ENOTEMPTY" || er.code === "EPERM") && busyTries < options.maxBusyTries) {
            busyTries++;
            const time = busyTries * 100;
            return setTimeout(() => rimraf_(p, options, CB), time);
          }
          if (er.code === "ENOENT")
            er = null;
        }
        cb(er);
      });
    }
    function rimraf_(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.lstat(p, (er, st) => {
        if (er && er.code === "ENOENT") {
          return cb(null);
        }
        if (er && er.code === "EPERM" && isWindows) {
          return fixWinEPERM(p, options, er, cb);
        }
        if (st && st.isDirectory()) {
          return rmdir(p, options, er, cb);
        }
        options.unlink(p, (er2) => {
          if (er2) {
            if (er2.code === "ENOENT") {
              return cb(null);
            }
            if (er2.code === "EPERM") {
              return isWindows ? fixWinEPERM(p, options, er2, cb) : rmdir(p, options, er2, cb);
            }
            if (er2.code === "EISDIR") {
              return rmdir(p, options, er2, cb);
            }
          }
          return cb(er2);
        });
      });
    }
    function fixWinEPERM(p, options, er, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      if (er) {
        assert(er instanceof Error);
      }
      options.chmod(p, 438, (er2) => {
        if (er2) {
          cb(er2.code === "ENOENT" ? null : er);
        } else {
          options.stat(p, (er3, stats) => {
            if (er3) {
              cb(er3.code === "ENOENT" ? null : er);
            } else if (stats.isDirectory()) {
              rmdir(p, options, er, cb);
            } else {
              options.unlink(p, cb);
            }
          });
        }
      });
    }
    function fixWinEPERMSync(p, options, er) {
      let stats;
      assert(p);
      assert(options);
      if (er) {
        assert(er instanceof Error);
      }
      try {
        options.chmodSync(p, 438);
      } catch (er2) {
        if (er2.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      try {
        stats = options.statSync(p);
      } catch (er3) {
        if (er3.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      if (stats.isDirectory()) {
        rmdirSync(p, options, er);
      } else {
        options.unlinkSync(p);
      }
    }
    function rmdir(p, options, originalEr, cb) {
      assert(p);
      assert(options);
      if (originalEr) {
        assert(originalEr instanceof Error);
      }
      assert(typeof cb === "function");
      options.rmdir(p, (er) => {
        if (er && (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM")) {
          rmkids(p, options, cb);
        } else if (er && er.code === "ENOTDIR") {
          cb(originalEr);
        } else {
          cb(er);
        }
      });
    }
    function rmkids(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.readdir(p, (er, files) => {
        if (er)
          return cb(er);
        let n = files.length;
        let errState;
        if (n === 0)
          return options.rmdir(p, cb);
        files.forEach((f3) => {
          rimraf(path4.join(p, f3), options, (er2) => {
            if (errState) {
              return;
            }
            if (er2)
              return cb(errState = er2);
            if (--n === 0) {
              options.rmdir(p, cb);
            }
          });
        });
      });
    }
    function rimrafSync(p, options) {
      let st;
      options = options || {};
      defaults(options);
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert(options, "rimraf: missing options");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      try {
        st = options.lstatSync(p);
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        }
        if (er.code === "EPERM" && isWindows) {
          fixWinEPERMSync(p, options, er);
        }
      }
      try {
        if (st && st.isDirectory()) {
          rmdirSync(p, options, null);
        } else {
          options.unlinkSync(p);
        }
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        } else if (er.code === "EPERM") {
          return isWindows ? fixWinEPERMSync(p, options, er) : rmdirSync(p, options, er);
        } else if (er.code !== "EISDIR") {
          throw er;
        }
        rmdirSync(p, options, er);
      }
    }
    function rmdirSync(p, options, originalEr) {
      assert(p);
      assert(options);
      if (originalEr) {
        assert(originalEr instanceof Error);
      }
      try {
        options.rmdirSync(p);
      } catch (er) {
        if (er.code === "ENOTDIR") {
          throw originalEr;
        } else if (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM") {
          rmkidsSync(p, options);
        } else if (er.code !== "ENOENT") {
          throw er;
        }
      }
    }
    function rmkidsSync(p, options) {
      assert(p);
      assert(options);
      options.readdirSync(p).forEach((f3) => rimrafSync(path4.join(p, f3), options));
      if (isWindows) {
        const startTime = Date.now();
        do {
          try {
            const ret = options.rmdirSync(p, options);
            return ret;
          } catch (er) {
          }
        } while (Date.now() - startTime < 500);
      } else {
        const ret = options.rmdirSync(p, options);
        return ret;
      }
    }
    module2.exports = rimraf;
    rimraf.sync = rimrafSync;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/remove/index.js
var require_remove4 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/remove/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var rimraf = require_rimraf3();
    module2.exports = {
      remove: u(rimraf),
      removeSync: rimraf.sync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/empty/index.js
var require_empty3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/empty/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdir = require_mkdirs5();
    var remove = require_remove4();
    var emptyDir = u(function emptyDir2(dir, callback) {
      callback = callback || function() {
      };
      fs4.readdir(dir, (err, items) => {
        if (err)
          return mkdir.mkdirs(dir, callback);
        items = items.map((item) => path4.join(dir, item));
        deleteItem();
        function deleteItem() {
          const item = items.pop();
          if (!item)
            return callback();
          remove.remove(item, (err2) => {
            if (err2)
              return callback(err2);
            deleteItem();
          });
        }
      });
    });
    function emptyDirSync(dir) {
      let items;
      try {
        items = fs4.readdirSync(dir);
      } catch (err) {
        return mkdir.mkdirsSync(dir);
      }
      items.forEach((item) => {
        item = path4.join(dir, item);
        remove.removeSync(item);
      });
    }
    module2.exports = {
      emptyDirSync,
      emptydirSync: emptyDirSync,
      emptyDir,
      emptydir: emptyDir
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/file.js
var require_file3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/file.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var mkdir = require_mkdirs5();
    var pathExists = require_path_exists4().pathExists;
    function createFile(file, callback) {
      function makeFile() {
        fs4.writeFile(file, "", (err) => {
          if (err)
            return callback(err);
          callback();
        });
      }
      fs4.stat(file, (err, stats) => {
        if (!err && stats.isFile())
          return callback();
        const dir = path4.dirname(file);
        pathExists(dir, (err2, dirExists) => {
          if (err2)
            return callback(err2);
          if (dirExists)
            return makeFile();
          mkdir.mkdirs(dir, (err3) => {
            if (err3)
              return callback(err3);
            makeFile();
          });
        });
      });
    }
    function createFileSync(file) {
      let stats;
      try {
        stats = fs4.statSync(file);
      } catch (e2) {
      }
      if (stats && stats.isFile())
        return;
      const dir = path4.dirname(file);
      if (!fs4.existsSync(dir)) {
        mkdir.mkdirsSync(dir);
      }
      fs4.writeFileSync(file, "");
    }
    module2.exports = {
      createFile: u(createFile),
      createFileSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/link.js
var require_link3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/link.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var mkdir = require_mkdirs5();
    var pathExists = require_path_exists4().pathExists;
    function createLink(srcpath, dstpath, callback) {
      function makeLink(srcpath2, dstpath2) {
        fs4.link(srcpath2, dstpath2, (err) => {
          if (err)
            return callback(err);
          callback(null);
        });
      }
      pathExists(dstpath, (err, destinationExists) => {
        if (err)
          return callback(err);
        if (destinationExists)
          return callback(null);
        fs4.lstat(srcpath, (err2) => {
          if (err2) {
            err2.message = err2.message.replace("lstat", "ensureLink");
            return callback(err2);
          }
          const dir = path4.dirname(dstpath);
          pathExists(dir, (err3, dirExists) => {
            if (err3)
              return callback(err3);
            if (dirExists)
              return makeLink(srcpath, dstpath);
            mkdir.mkdirs(dir, (err4) => {
              if (err4)
                return callback(err4);
              makeLink(srcpath, dstpath);
            });
          });
        });
      });
    }
    function createLinkSync(srcpath, dstpath) {
      const destinationExists = fs4.existsSync(dstpath);
      if (destinationExists)
        return void 0;
      try {
        fs4.lstatSync(srcpath);
      } catch (err) {
        err.message = err.message.replace("lstat", "ensureLink");
        throw err;
      }
      const dir = path4.dirname(dstpath);
      const dirExists = fs4.existsSync(dir);
      if (dirExists)
        return fs4.linkSync(srcpath, dstpath);
      mkdir.mkdirsSync(dir);
      return fs4.linkSync(srcpath, dstpath);
    }
    module2.exports = {
      createLink: u(createLink),
      createLinkSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/symlink-paths.js
var require_symlink_paths3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/symlink-paths.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var pathExists = require_path_exists4().pathExists;
    function symlinkPaths(srcpath, dstpath, callback) {
      if (path4.isAbsolute(srcpath)) {
        return fs4.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureSymlink");
            return callback(err);
          }
          return callback(null, {
            "toCwd": srcpath,
            "toDst": srcpath
          });
        });
      } else {
        const dstdir = path4.dirname(dstpath);
        const relativeToDst = path4.join(dstdir, srcpath);
        return pathExists(relativeToDst, (err, exists) => {
          if (err)
            return callback(err);
          if (exists) {
            return callback(null, {
              "toCwd": relativeToDst,
              "toDst": srcpath
            });
          } else {
            return fs4.lstat(srcpath, (err2) => {
              if (err2) {
                err2.message = err2.message.replace("lstat", "ensureSymlink");
                return callback(err2);
              }
              return callback(null, {
                "toCwd": srcpath,
                "toDst": path4.relative(dstdir, srcpath)
              });
            });
          }
        });
      }
    }
    function symlinkPathsSync(srcpath, dstpath) {
      let exists;
      if (path4.isAbsolute(srcpath)) {
        exists = fs4.existsSync(srcpath);
        if (!exists)
          throw new Error("absolute srcpath does not exist");
        return {
          "toCwd": srcpath,
          "toDst": srcpath
        };
      } else {
        const dstdir = path4.dirname(dstpath);
        const relativeToDst = path4.join(dstdir, srcpath);
        exists = fs4.existsSync(relativeToDst);
        if (exists) {
          return {
            "toCwd": relativeToDst,
            "toDst": srcpath
          };
        } else {
          exists = fs4.existsSync(srcpath);
          if (!exists)
            throw new Error("relative srcpath does not exist");
          return {
            "toCwd": srcpath,
            "toDst": path4.relative(dstdir, srcpath)
          };
        }
      }
    }
    module2.exports = {
      symlinkPaths,
      symlinkPathsSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/symlink-type.js
var require_symlink_type3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/symlink-type.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    function symlinkType(srcpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      if (type)
        return callback(null, type);
      fs4.lstat(srcpath, (err, stats) => {
        if (err)
          return callback(null, "file");
        type = stats && stats.isDirectory() ? "dir" : "file";
        callback(null, type);
      });
    }
    function symlinkTypeSync(srcpath, type) {
      let stats;
      if (type)
        return type;
      try {
        stats = fs4.lstatSync(srcpath);
      } catch (e2) {
        return "file";
      }
      return stats && stats.isDirectory() ? "dir" : "file";
    }
    module2.exports = {
      symlinkType,
      symlinkTypeSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/symlink.js
var require_symlink3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/symlink.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs();
    var _mkdirs = require_mkdirs5();
    var mkdirs = _mkdirs.mkdirs;
    var mkdirsSync = _mkdirs.mkdirsSync;
    var _symlinkPaths = require_symlink_paths3();
    var symlinkPaths = _symlinkPaths.symlinkPaths;
    var symlinkPathsSync = _symlinkPaths.symlinkPathsSync;
    var _symlinkType = require_symlink_type3();
    var symlinkType = _symlinkType.symlinkType;
    var symlinkTypeSync = _symlinkType.symlinkTypeSync;
    var pathExists = require_path_exists4().pathExists;
    function createSymlink(srcpath, dstpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      pathExists(dstpath, (err, destinationExists) => {
        if (err)
          return callback(err);
        if (destinationExists)
          return callback(null);
        symlinkPaths(srcpath, dstpath, (err2, relative) => {
          if (err2)
            return callback(err2);
          srcpath = relative.toDst;
          symlinkType(relative.toCwd, type, (err3, type2) => {
            if (err3)
              return callback(err3);
            const dir = path4.dirname(dstpath);
            pathExists(dir, (err4, dirExists) => {
              if (err4)
                return callback(err4);
              if (dirExists)
                return fs4.symlink(srcpath, dstpath, type2, callback);
              mkdirs(dir, (err5) => {
                if (err5)
                  return callback(err5);
                fs4.symlink(srcpath, dstpath, type2, callback);
              });
            });
          });
        });
      });
    }
    function createSymlinkSync(srcpath, dstpath, type) {
      const destinationExists = fs4.existsSync(dstpath);
      if (destinationExists)
        return void 0;
      const relative = symlinkPathsSync(srcpath, dstpath);
      srcpath = relative.toDst;
      type = symlinkTypeSync(relative.toCwd, type);
      const dir = path4.dirname(dstpath);
      const exists = fs4.existsSync(dir);
      if (exists)
        return fs4.symlinkSync(srcpath, dstpath, type);
      mkdirsSync(dir);
      return fs4.symlinkSync(srcpath, dstpath, type);
    }
    module2.exports = {
      createSymlink: u(createSymlink),
      createSymlinkSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/index.js
var require_ensure3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/ensure/index.js"(exports, module2) {
    "use strict";
    var file = require_file3();
    var link = require_link3();
    var symlink = require_symlink3();
    module2.exports = {
      createFile: file.createFile,
      createFileSync: file.createFileSync,
      ensureFile: file.createFile,
      ensureFileSync: file.createFileSync,
      createLink: link.createLink,
      createLinkSync: link.createLinkSync,
      ensureLink: link.createLink,
      ensureLinkSync: link.createLinkSync,
      createSymlink: symlink.createSymlink,
      createSymlinkSync: symlink.createSymlinkSync,
      ensureSymlink: symlink.createSymlink,
      ensureSymlinkSync: symlink.createSymlinkSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/json/jsonfile.js
var require_jsonfile5 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/json/jsonfile.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var jsonFile = require_jsonfile3();
    module2.exports = {
      readJson: u(jsonFile.readFile),
      readJsonSync: jsonFile.readFileSync,
      writeJson: u(jsonFile.writeFile),
      writeJsonSync: jsonFile.writeFileSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/json/output-json.js
var require_output_json3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/json/output-json.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var mkdir = require_mkdirs5();
    var pathExists = require_path_exists4().pathExists;
    var jsonFile = require_jsonfile5();
    function outputJson(file, data, options, callback) {
      if (typeof options === "function") {
        callback = options;
        options = {};
      }
      const dir = path4.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return jsonFile.writeJson(file, data, options, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          jsonFile.writeJson(file, data, options, callback);
        });
      });
    }
    module2.exports = outputJson;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/json/output-json-sync.js
var require_output_json_sync3 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/json/output-json-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdir = require_mkdirs5();
    var jsonFile = require_jsonfile5();
    function outputJsonSync(file, data, options) {
      const dir = path4.dirname(file);
      if (!fs4.existsSync(dir)) {
        mkdir.mkdirsSync(dir);
      }
      jsonFile.writeJsonSync(file, data, options);
    }
    module2.exports = outputJsonSync;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/json/index.js
var require_json4 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/json/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var jsonFile = require_jsonfile5();
    jsonFile.outputJson = u(require_output_json3());
    jsonFile.outputJsonSync = require_output_json_sync3();
    jsonFile.outputJSON = jsonFile.outputJson;
    jsonFile.outputJSONSync = jsonFile.outputJsonSync;
    jsonFile.writeJSON = jsonFile.writeJson;
    jsonFile.writeJSONSync = jsonFile.writeJsonSync;
    jsonFile.readJSON = jsonFile.readJson;
    jsonFile.readJSONSync = jsonFile.readJsonSync;
    module2.exports = jsonFile;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/move-sync/move-sync.js
var require_move_sync4 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/move-sync/move-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var copySync = require_copy_sync5().copySync;
    var removeSync = require_remove4().removeSync;
    var mkdirpSync = require_mkdirs5().mkdirpSync;
    var stat3 = require_stat3();
    function moveSync(src, dest, opts) {
      opts = opts || {};
      const overwrite = opts.overwrite || opts.clobber || false;
      const { srcStat } = stat3.checkPathsSync(src, dest, "move");
      stat3.checkParentPathsSync(src, srcStat, dest, "move");
      mkdirpSync(path4.dirname(dest));
      return doRename(src, dest, overwrite);
    }
    function doRename(src, dest, overwrite) {
      if (overwrite) {
        removeSync(dest);
        return rename(src, dest, overwrite);
      }
      if (fs4.existsSync(dest))
        throw new Error("dest already exists.");
      return rename(src, dest, overwrite);
    }
    function rename(src, dest, overwrite) {
      try {
        fs4.renameSync(src, dest);
      } catch (err) {
        if (err.code !== "EXDEV")
          throw err;
        return moveAcrossDevice(src, dest, overwrite);
      }
    }
    function moveAcrossDevice(src, dest, overwrite) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copySync(src, dest, opts);
      return removeSync(src);
    }
    module2.exports = moveSync;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/move-sync/index.js
var require_move_sync5 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/move-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      moveSync: require_move_sync4()
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/move/move.js
var require_move5 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/move/move.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var copy = require_copy6().copy;
    var remove = require_remove4().remove;
    var mkdirp2 = require_mkdirs5().mkdirp;
    var pathExists = require_path_exists4().pathExists;
    var stat3 = require_stat3();
    function move(src, dest, opts, cb) {
      if (typeof opts === "function") {
        cb = opts;
        opts = {};
      }
      const overwrite = opts.overwrite || opts.clobber || false;
      stat3.checkPaths(src, dest, "move", (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat } = stats;
        stat3.checkParentPaths(src, srcStat, dest, "move", (err2) => {
          if (err2)
            return cb(err2);
          mkdirp2(path4.dirname(dest), (err3) => {
            if (err3)
              return cb(err3);
            return doRename(src, dest, overwrite, cb);
          });
        });
      });
    }
    function doRename(src, dest, overwrite, cb) {
      if (overwrite) {
        return remove(dest, (err) => {
          if (err)
            return cb(err);
          return rename(src, dest, overwrite, cb);
        });
      }
      pathExists(dest, (err, destExists) => {
        if (err)
          return cb(err);
        if (destExists)
          return cb(new Error("dest already exists."));
        return rename(src, dest, overwrite, cb);
      });
    }
    function rename(src, dest, overwrite, cb) {
      fs4.rename(src, dest, (err) => {
        if (!err)
          return cb();
        if (err.code !== "EXDEV")
          return cb(err);
        return moveAcrossDevice(src, dest, overwrite, cb);
      });
    }
    function moveAcrossDevice(src, dest, overwrite, cb) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copy(src, dest, opts, (err) => {
        if (err)
          return cb(err);
        return remove(src, cb);
      });
    }
    module2.exports = move;
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/move/index.js
var require_move6 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/move/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    module2.exports = {
      move: u(require_move5())
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/output/index.js
var require_output2 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/output/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs();
    var path4 = require("path");
    var mkdir = require_mkdirs5();
    var pathExists = require_path_exists4().pathExists;
    function outputFile(file, data, encoding, callback) {
      if (typeof encoding === "function") {
        callback = encoding;
        encoding = "utf8";
      }
      const dir = path4.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return fs4.writeFile(file, data, encoding, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          fs4.writeFile(file, data, encoding, callback);
        });
      });
    }
    function outputFileSync(file, ...args) {
      const dir = path4.dirname(file);
      if (fs4.existsSync(dir)) {
        return fs4.writeFileSync(file, ...args);
      }
      mkdir.mkdirsSync(dir);
      fs4.writeFileSync(file, ...args);
    }
    module2.exports = {
      outputFile: u(outputFile),
      outputFileSync
    };
  }
});

// node_modules/@manypkg/find-root/node_modules/fs-extra/lib/index.js
var require_lib5 = __commonJS({
  "node_modules/@manypkg/find-root/node_modules/fs-extra/lib/index.js"(exports, module2) {
    "use strict";
    module2.exports = Object.assign(
      {},
      require_fs7(),
      require_copy_sync5(),
      require_copy6(),
      require_empty3(),
      require_ensure3(),
      require_json4(),
      require_mkdirs5(),
      require_move_sync5(),
      require_move6(),
      require_output2(),
      require_path_exists4(),
      require_remove4()
    );
    var fs4 = require("fs");
    if (Object.getOwnPropertyDescriptor(fs4, "promises")) {
      Object.defineProperty(module2.exports, "promises", {
        get() {
          return fs4.promises;
        }
      });
    }
  }
});

// node_modules/@manypkg/find-root/dist/find-root.esm.js
var find_root_esm_exports = {};
__export(find_root_esm_exports, {
  NoPkgJsonFound: () => NoPkgJsonFound,
  findRoot: () => findRoot,
  findRootSync: () => findRootSync
});
function hasWorkspacesConfiguredViaPkgJson(_x, _x2) {
  return _hasWorkspacesConfiguredViaPkgJson.apply(this, arguments);
}
function _hasWorkspacesConfiguredViaPkgJson() {
  _hasWorkspacesConfiguredViaPkgJson = _asyncToGenerator(
    /* @__PURE__ */ import_regenerator.default.mark(function _callee(directory, firstPkgJsonDirRef) {
      var pkgJson;
      return import_regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return import_fs_extra2.default.readJson(import_path.default.join(directory, "package.json"));
            case 3:
              pkgJson = _context.sent;
              if (firstPkgJsonDirRef.current === void 0) {
                firstPkgJsonDirRef.current = directory;
              }
              if (!(pkgJson.workspaces || pkgJson.bolt)) {
                _context.next = 7;
                break;
              }
              return _context.abrupt("return", directory);
            case 7:
              _context.next = 13;
              break;
            case 9:
              _context.prev = 9;
              _context.t0 = _context["catch"](0);
              if (!(_context.t0.code !== "ENOENT")) {
                _context.next = 13;
                break;
              }
              throw _context.t0;
            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 9]]);
    })
  );
  return _hasWorkspacesConfiguredViaPkgJson.apply(this, arguments);
}
function hasWorkspacesConfiguredViaLerna(_x3) {
  return _hasWorkspacesConfiguredViaLerna.apply(this, arguments);
}
function _hasWorkspacesConfiguredViaLerna() {
  _hasWorkspacesConfiguredViaLerna = _asyncToGenerator(
    /* @__PURE__ */ import_regenerator.default.mark(function _callee2(directory) {
      var lernaJson;
      return import_regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.prev = 0;
              _context2.next = 3;
              return import_fs_extra2.default.readJson(import_path.default.join(directory, "lerna.json"));
            case 3:
              lernaJson = _context2.sent;
              if (!(lernaJson.useWorkspaces !== true)) {
                _context2.next = 6;
                break;
              }
              return _context2.abrupt("return", directory);
            case 6:
              _context2.next = 12;
              break;
            case 8:
              _context2.prev = 8;
              _context2.t0 = _context2["catch"](0);
              if (!(_context2.t0.code !== "ENOENT")) {
                _context2.next = 12;
                break;
              }
              throw _context2.t0;
            case 12:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[0, 8]]);
    })
  );
  return _hasWorkspacesConfiguredViaLerna.apply(this, arguments);
}
function hasWorkspacesConfiguredViaPnpm(_x4) {
  return _hasWorkspacesConfiguredViaPnpm.apply(this, arguments);
}
function _hasWorkspacesConfiguredViaPnpm() {
  _hasWorkspacesConfiguredViaPnpm = _asyncToGenerator(
    /* @__PURE__ */ import_regenerator.default.mark(function _callee3(directory) {
      var pnpmWorkspacesFileExists;
      return import_regenerator.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return import_fs_extra2.default.exists(import_path.default.join(directory, "pnpm-workspace.yaml"));
            case 2:
              pnpmWorkspacesFileExists = _context3.sent;
              if (!pnpmWorkspacesFileExists) {
                _context3.next = 5;
                break;
              }
              return _context3.abrupt("return", directory);
            case 5:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    })
  );
  return _hasWorkspacesConfiguredViaPnpm.apply(this, arguments);
}
function findRoot(_x5) {
  return _findRoot.apply(this, arguments);
}
function _findRoot() {
  _findRoot = _asyncToGenerator(
    /* @__PURE__ */ import_regenerator.default.mark(function _callee4(cwd) {
      var firstPkgJsonDirRef, dir;
      return import_regenerator.default.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              firstPkgJsonDirRef = {
                current: void 0
              };
              _context4.next = 3;
              return (0, import_find_up.default)(function(directory) {
                return Promise.all([hasWorkspacesConfiguredViaLerna(directory), hasWorkspacesConfiguredViaPkgJson(directory, firstPkgJsonDirRef), hasWorkspacesConfiguredViaPnpm(directory)]).then(function(x2) {
                  return x2.find(function(dir2) {
                    return dir2;
                  });
                });
              }, {
                cwd,
                type: "directory"
              });
            case 3:
              dir = _context4.sent;
              if (!(firstPkgJsonDirRef.current === void 0)) {
                _context4.next = 6;
                break;
              }
              throw new NoPkgJsonFound(cwd);
            case 6:
              if (!(dir === void 0)) {
                _context4.next = 8;
                break;
              }
              return _context4.abrupt("return", firstPkgJsonDirRef.current);
            case 8:
              return _context4.abrupt("return", dir);
            case 9:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    })
  );
  return _findRoot.apply(this, arguments);
}
function hasWorkspacesConfiguredViaPkgJsonSync(directory, firstPkgJsonDirRef) {
  try {
    var pkgJson = import_fs_extra2.default.readJsonSync(import_path.default.join(directory, "package.json"));
    if (firstPkgJsonDirRef.current === void 0) {
      firstPkgJsonDirRef.current = directory;
    }
    if (pkgJson.workspaces || pkgJson.bolt) {
      return directory;
    }
  } catch (err) {
    if (err.code !== "ENOENT") {
      throw err;
    }
  }
}
function hasWorkspacesConfiguredViaLernaSync(directory) {
  try {
    var lernaJson = import_fs_extra2.default.readJsonSync(import_path.default.join(directory, "lerna.json"));
    if (lernaJson.useWorkspaces !== true) {
      return directory;
    }
  } catch (err) {
    if (err.code !== "ENOENT") {
      throw err;
    }
  }
}
function hasWorkspacesConfiguredViaPnpmSync(directory) {
  var pnpmWorkspacesFileExists = import_fs_extra2.default.existsSync(import_path.default.join(directory, "pnpm-workspace.yaml"));
  if (pnpmWorkspacesFileExists) {
    return directory;
  }
}
function findRootSync(cwd) {
  var firstPkgJsonDirRef = {
    current: void 0
  };
  var dir = (0, import_find_up.sync)(function(directory) {
    return [hasWorkspacesConfiguredViaLernaSync(directory), hasWorkspacesConfiguredViaPkgJsonSync(directory, firstPkgJsonDirRef), hasWorkspacesConfiguredViaPnpmSync(directory)].find(function(dir2) {
      return dir2;
    });
  }, {
    cwd,
    type: "directory"
  });
  if (firstPkgJsonDirRef.current === void 0) {
    throw new NoPkgJsonFound(cwd);
  }
  if (dir === void 0) {
    return firstPkgJsonDirRef.current;
  }
  return dir;
}
var import_regenerator, import_find_up, import_path, import_fs_extra2, NoPkgJsonFound;
var init_find_root_esm = __esm({
  "node_modules/@manypkg/find-root/dist/find-root.esm.js"() {
    import_regenerator = __toESM(require_regenerator());
    init_asyncToGenerator();
    init_classCallCheck();
    init_possibleConstructorReturn();
    init_getPrototypeOf();
    init_inherits();
    init_wrapNativeSuper();
    import_find_up = __toESM(require_find_up());
    import_path = __toESM(require("path"));
    import_fs_extra2 = __toESM(require_lib5());
    NoPkgJsonFound = /* @__PURE__ */ function(_Error) {
      _inherits(NoPkgJsonFound2, _Error);
      function NoPkgJsonFound2(directory) {
        var _this;
        _classCallCheck(this, NoPkgJsonFound2);
        _this = _possibleConstructorReturn(this, _getPrototypeOf(NoPkgJsonFound2).call(this, "No package.json could be found upwards from the directory ".concat(directory)));
        _this.directory = directory;
        return _this;
      }
      return NoPkgJsonFound2;
    }(_wrapNativeSuper(Error));
  }
});

// node_modules/@manypkg/get-packages/dist/get-packages.cjs.prod.js
var require_get_packages_cjs_prod = __commonJS({
  "node_modules/@manypkg/get-packages/dist/get-packages.cjs.prod.js"(exports) {
    "use strict";
    function _interopDefault(ex) {
      return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
    }
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    var _regeneratorRuntime2 = _interopDefault(require_regenerator());
    var _asyncToGenerator2 = _interopDefault(require_asyncToGenerator());
    var _classCallCheck2 = _interopDefault(require_classCallCheck());
    var _possibleConstructorReturn2 = _interopDefault(require_possibleConstructorReturn());
    var _getPrototypeOf2 = _interopDefault(require_getPrototypeOf());
    var _inherits2 = _interopDefault(require_inherits());
    var _wrapNativeSuper2 = _interopDefault(require_wrapNativeSuper());
    var fs4 = _interopDefault(require_lib4());
    var path4 = _interopDefault(require("path"));
    var globby = require_globby();
    var globby__default = _interopDefault(globby);
    var readYamlFile = require_read_yaml_file();
    var readYamlFile__default = _interopDefault(readYamlFile);
    var findRoot2 = (init_find_root_esm(), __toCommonJS(find_root_esm_exports));
    var PackageJsonMissingNameError = function(_Error) {
      function PackageJsonMissingNameError2(directories) {
        var _this;
        return _classCallCheck2(this, PackageJsonMissingNameError2), (_this = _possibleConstructorReturn2(this, _getPrototypeOf2(PackageJsonMissingNameError2).call(this, 'The following package.jsons are missing the "name" field:\n'.concat(directories.join("\n"))))).directories = directories, _this;
      }
      return _inherits2(PackageJsonMissingNameError2, _Error), PackageJsonMissingNameError2;
    }(_wrapNativeSuper2(Error));
    function getPackages2(_x) {
      return _getPackages.apply(this, arguments);
    }
    function _getPackages() {
      return (_getPackages = _asyncToGenerator2(_regeneratorRuntime2.mark(function _callee(dir) {
        var cwd, pkg, tool, manifest, lernaJson, root, relativeDirectories, directories, pkgJsonsMissingNameField, results;
        return _regeneratorRuntime2.wrap(function(_context) {
          for (; ; )
            switch (_context.prev = _context.next) {
              case 0:
                return _context.next = 2, findRoot2.findRoot(dir);
              case 2:
                return cwd = _context.sent, _context.next = 5, fs4.readJson(path4.join(cwd, "package.json"));
              case 5:
                if (!(pkg = _context.sent).workspaces) {
                  _context.next = 10;
                  break;
                }
                Array.isArray(pkg.workspaces) ? tool = {
                  type: "yarn",
                  packageGlobs: pkg.workspaces
                } : pkg.workspaces.packages && (tool = {
                  type: "yarn",
                  packageGlobs: pkg.workspaces.packages
                }), _context.next = 37;
                break;
              case 10:
                if (!pkg.bolt || !pkg.bolt.workspaces) {
                  _context.next = 14;
                  break;
                }
                tool = {
                  type: "bolt",
                  packageGlobs: pkg.bolt.workspaces
                }, _context.next = 37;
                break;
              case 14:
                return _context.prev = 14, _context.next = 17, readYamlFile__default(path4.join(cwd, "pnpm-workspace.yaml"));
              case 17:
                (manifest = _context.sent) && manifest.packages && (tool = {
                  type: "pnpm",
                  packageGlobs: manifest.packages
                }), _context.next = 25;
                break;
              case 21:
                if (_context.prev = 21, _context.t0 = _context.catch(14), "ENOENT" === _context.t0.code) {
                  _context.next = 25;
                  break;
                }
                throw _context.t0;
              case 25:
                if (tool) {
                  _context.next = 37;
                  break;
                }
                return _context.prev = 26, _context.next = 29, fs4.readJson(path4.join(cwd, "lerna.json"));
              case 29:
                (lernaJson = _context.sent) && (tool = {
                  type: "lerna",
                  packageGlobs: lernaJson.packages || ["packages/*"]
                }), _context.next = 37;
                break;
              case 33:
                if (_context.prev = 33, _context.t1 = _context.catch(26), "ENOENT" === _context.t1.code) {
                  _context.next = 37;
                  break;
                }
                throw _context.t1;
              case 37:
                if (tool) {
                  _context.next = 42;
                  break;
                }
                if (root = {
                  dir: cwd,
                  packageJson: pkg
                }, pkg.name) {
                  _context.next = 41;
                  break;
                }
                throw new PackageJsonMissingNameError(["package.json"]);
              case 41:
                return _context.abrupt("return", {
                  tool: "root",
                  root,
                  packages: [root]
                });
              case 42:
                return _context.next = 44, globby__default(tool.packageGlobs, {
                  cwd,
                  onlyDirectories: true,
                  expandDirectories: false,
                  ignore: ["**/node_modules"]
                });
              case 44:
                return relativeDirectories = _context.sent, directories = relativeDirectories.map(function(p) {
                  return path4.resolve(cwd, p);
                }), pkgJsonsMissingNameField = [], _context.next = 49, Promise.all(directories.sort().map(function(dir2) {
                  return fs4.readJson(path4.join(dir2, "package.json")).then(function(packageJson2) {
                    return packageJson2.name || pkgJsonsMissingNameField.push(path4.relative(cwd, path4.join(dir2, "package.json"))), {
                      packageJson: packageJson2,
                      dir: dir2
                    };
                  }).catch(function(err) {
                    if ("ENOENT" === err.code)
                      return null;
                    throw err;
                  });
                }));
              case 49:
                if (_context.t2 = function(x2) {
                  return x2;
                }, results = _context.sent.filter(_context.t2), 0 === pkgJsonsMissingNameField.length) {
                  _context.next = 54;
                  break;
                }
                throw pkgJsonsMissingNameField.sort(), new PackageJsonMissingNameError(pkgJsonsMissingNameField);
              case 54:
                return _context.abrupt("return", {
                  tool: tool.type,
                  root: {
                    dir: cwd,
                    packageJson: pkg
                  },
                  packages: results
                });
              case 55:
              case "end":
                return _context.stop();
            }
        }, _callee, null, [[14, 21], [26, 33]]);
      }))).apply(this, arguments);
    }
    function getPackagesSync(dir) {
      var tool, cwd = findRoot2.findRootSync(dir), pkg = fs4.readJsonSync(path4.join(cwd, "package.json"));
      if (pkg.workspaces)
        Array.isArray(pkg.workspaces) ? tool = {
          type: "yarn",
          packageGlobs: pkg.workspaces
        } : pkg.workspaces.packages && (tool = {
          type: "yarn",
          packageGlobs: pkg.workspaces.packages
        });
      else if (pkg.bolt && pkg.bolt.workspaces)
        tool = {
          type: "bolt",
          packageGlobs: pkg.bolt.workspaces
        };
      else {
        try {
          var manifest = readYamlFile.sync(path4.join(cwd, "pnpm-workspace.yaml"));
          manifest && manifest.packages && (tool = {
            type: "pnpm",
            packageGlobs: manifest.packages
          });
        } catch (err) {
          if ("ENOENT" !== err.code)
            throw err;
        }
        if (!tool)
          try {
            var lernaJson = fs4.readJsonSync(path4.join(cwd, "lerna.json"));
            lernaJson && (tool = {
              type: "lerna",
              packageGlobs: lernaJson.packages || ["packages/*"]
            });
          } catch (err) {
            if ("ENOENT" !== err.code)
              throw err;
          }
      }
      if (!tool) {
        var root = {
          dir: cwd,
          packageJson: pkg
        };
        if (!pkg.name)
          throw new PackageJsonMissingNameError(["package.json"]);
        return {
          tool: "root",
          root,
          packages: [root]
        };
      }
      var directories = globby.sync(tool.packageGlobs, {
        cwd,
        onlyDirectories: true,
        expandDirectories: false,
        ignore: ["**/node_modules"]
      }).map(function(p) {
        return path4.resolve(cwd, p);
      }), pkgJsonsMissingNameField = [], results = directories.sort().map(function(dir2) {
        try {
          var packageJson2 = fs4.readJsonSync(path4.join(dir2, "package.json"));
          return packageJson2.name || pkgJsonsMissingNameField.push(path4.relative(cwd, path4.join(dir2, "package.json"))), {
            packageJson: packageJson2,
            dir: dir2
          };
        } catch (err) {
          if ("ENOENT" === err.code)
            return null;
          throw err;
        }
      }).filter(function(x2) {
        return x2;
      });
      if (0 !== pkgJsonsMissingNameField.length)
        throw pkgJsonsMissingNameField.sort(), new PackageJsonMissingNameError(pkgJsonsMissingNameField);
      return {
        tool: tool.type,
        root: {
          dir: cwd,
          packageJson: pkg
        },
        packages: results
      };
    }
    exports.PackageJsonMissingNameError = PackageJsonMissingNameError, exports.getPackages = getPackages2, exports.getPackagesSync = getPackagesSync;
  }
});

// node_modules/@manypkg/get-packages/dist/get-packages.cjs.dev.js
var require_get_packages_cjs_dev = __commonJS({
  "node_modules/@manypkg/get-packages/dist/get-packages.cjs.dev.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function _interopDefault(ex) {
      return ex && typeof ex === "object" && "default" in ex ? ex["default"] : ex;
    }
    var _regeneratorRuntime2 = _interopDefault(require_regenerator());
    var _asyncToGenerator2 = _interopDefault(require_asyncToGenerator());
    var _classCallCheck2 = _interopDefault(require_classCallCheck());
    var _possibleConstructorReturn2 = _interopDefault(require_possibleConstructorReturn());
    var _getPrototypeOf2 = _interopDefault(require_getPrototypeOf());
    var _inherits2 = _interopDefault(require_inherits());
    var _wrapNativeSuper2 = _interopDefault(require_wrapNativeSuper());
    var fs4 = _interopDefault(require_lib4());
    var path4 = _interopDefault(require("path"));
    var globby = require_globby();
    var globby__default = _interopDefault(globby);
    var readYamlFile = require_read_yaml_file();
    var readYamlFile__default = _interopDefault(readYamlFile);
    var findRoot2 = (init_find_root_esm(), __toCommonJS(find_root_esm_exports));
    var PackageJsonMissingNameError = /* @__PURE__ */ function(_Error) {
      _inherits2(PackageJsonMissingNameError2, _Error);
      function PackageJsonMissingNameError2(directories) {
        var _this;
        _classCallCheck2(this, PackageJsonMissingNameError2);
        _this = _possibleConstructorReturn2(this, _getPrototypeOf2(PackageJsonMissingNameError2).call(this, 'The following package.jsons are missing the "name" field:\n'.concat(directories.join("\n"))));
        _this.directories = directories;
        return _this;
      }
      return PackageJsonMissingNameError2;
    }(_wrapNativeSuper2(Error));
    function getPackages2(_x) {
      return _getPackages.apply(this, arguments);
    }
    function _getPackages() {
      _getPackages = _asyncToGenerator2(
        /* @__PURE__ */ _regeneratorRuntime2.mark(function _callee(dir) {
          var cwd, pkg, tool, manifest, lernaJson, root, relativeDirectories, directories, pkgJsonsMissingNameField, results;
          return _regeneratorRuntime2.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return findRoot2.findRoot(dir);
                case 2:
                  cwd = _context.sent;
                  _context.next = 5;
                  return fs4.readJson(path4.join(cwd, "package.json"));
                case 5:
                  pkg = _context.sent;
                  if (!pkg.workspaces) {
                    _context.next = 10;
                    break;
                  }
                  if (Array.isArray(pkg.workspaces)) {
                    tool = {
                      type: "yarn",
                      packageGlobs: pkg.workspaces
                    };
                  } else if (pkg.workspaces.packages) {
                    tool = {
                      type: "yarn",
                      packageGlobs: pkg.workspaces.packages
                    };
                  }
                  _context.next = 37;
                  break;
                case 10:
                  if (!(pkg.bolt && pkg.bolt.workspaces)) {
                    _context.next = 14;
                    break;
                  }
                  tool = {
                    type: "bolt",
                    packageGlobs: pkg.bolt.workspaces
                  };
                  _context.next = 37;
                  break;
                case 14:
                  _context.prev = 14;
                  _context.next = 17;
                  return readYamlFile__default(path4.join(cwd, "pnpm-workspace.yaml"));
                case 17:
                  manifest = _context.sent;
                  if (manifest && manifest.packages) {
                    tool = {
                      type: "pnpm",
                      packageGlobs: manifest.packages
                    };
                  }
                  _context.next = 25;
                  break;
                case 21:
                  _context.prev = 21;
                  _context.t0 = _context["catch"](14);
                  if (!(_context.t0.code !== "ENOENT")) {
                    _context.next = 25;
                    break;
                  }
                  throw _context.t0;
                case 25:
                  if (tool) {
                    _context.next = 37;
                    break;
                  }
                  _context.prev = 26;
                  _context.next = 29;
                  return fs4.readJson(path4.join(cwd, "lerna.json"));
                case 29:
                  lernaJson = _context.sent;
                  if (lernaJson) {
                    tool = {
                      type: "lerna",
                      packageGlobs: lernaJson.packages || ["packages/*"]
                    };
                  }
                  _context.next = 37;
                  break;
                case 33:
                  _context.prev = 33;
                  _context.t1 = _context["catch"](26);
                  if (!(_context.t1.code !== "ENOENT")) {
                    _context.next = 37;
                    break;
                  }
                  throw _context.t1;
                case 37:
                  if (tool) {
                    _context.next = 42;
                    break;
                  }
                  root = {
                    dir: cwd,
                    packageJson: pkg
                  };
                  if (pkg.name) {
                    _context.next = 41;
                    break;
                  }
                  throw new PackageJsonMissingNameError(["package.json"]);
                case 41:
                  return _context.abrupt("return", {
                    tool: "root",
                    root,
                    packages: [root]
                  });
                case 42:
                  _context.next = 44;
                  return globby__default(tool.packageGlobs, {
                    cwd,
                    onlyDirectories: true,
                    expandDirectories: false,
                    ignore: ["**/node_modules"]
                  });
                case 44:
                  relativeDirectories = _context.sent;
                  directories = relativeDirectories.map(function(p) {
                    return path4.resolve(cwd, p);
                  });
                  pkgJsonsMissingNameField = [];
                  _context.next = 49;
                  return Promise.all(directories.sort().map(function(dir2) {
                    return fs4.readJson(path4.join(dir2, "package.json")).then(function(packageJson2) {
                      if (!packageJson2.name) {
                        pkgJsonsMissingNameField.push(path4.relative(cwd, path4.join(dir2, "package.json")));
                      }
                      return {
                        packageJson: packageJson2,
                        dir: dir2
                      };
                    })["catch"](function(err) {
                      if (err.code === "ENOENT") {
                        return null;
                      }
                      throw err;
                    });
                  }));
                case 49:
                  _context.t2 = function(x2) {
                    return x2;
                  };
                  results = _context.sent.filter(_context.t2);
                  if (!(pkgJsonsMissingNameField.length !== 0)) {
                    _context.next = 54;
                    break;
                  }
                  pkgJsonsMissingNameField.sort();
                  throw new PackageJsonMissingNameError(pkgJsonsMissingNameField);
                case 54:
                  return _context.abrupt("return", {
                    tool: tool.type,
                    root: {
                      dir: cwd,
                      packageJson: pkg
                    },
                    packages: results
                  });
                case 55:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, null, [[14, 21], [26, 33]]);
        })
      );
      return _getPackages.apply(this, arguments);
    }
    function getPackagesSync(dir) {
      var cwd = findRoot2.findRootSync(dir);
      var pkg = fs4.readJsonSync(path4.join(cwd, "package.json"));
      var tool;
      if (pkg.workspaces) {
        if (Array.isArray(pkg.workspaces)) {
          tool = {
            type: "yarn",
            packageGlobs: pkg.workspaces
          };
        } else if (pkg.workspaces.packages) {
          tool = {
            type: "yarn",
            packageGlobs: pkg.workspaces.packages
          };
        }
      } else if (pkg.bolt && pkg.bolt.workspaces) {
        tool = {
          type: "bolt",
          packageGlobs: pkg.bolt.workspaces
        };
      } else {
        try {
          var manifest = readYamlFile.sync(path4.join(cwd, "pnpm-workspace.yaml"));
          if (manifest && manifest.packages) {
            tool = {
              type: "pnpm",
              packageGlobs: manifest.packages
            };
          }
        } catch (err) {
          if (err.code !== "ENOENT") {
            throw err;
          }
        }
        if (!tool) {
          try {
            var lernaJson = fs4.readJsonSync(path4.join(cwd, "lerna.json"));
            if (lernaJson) {
              tool = {
                type: "lerna",
                packageGlobs: lernaJson.packages || ["packages/*"]
              };
            }
          } catch (err) {
            if (err.code !== "ENOENT") {
              throw err;
            }
          }
        }
      }
      if (!tool) {
        var root = {
          dir: cwd,
          packageJson: pkg
        };
        if (!pkg.name) {
          throw new PackageJsonMissingNameError(["package.json"]);
        }
        return {
          tool: "root",
          root,
          packages: [root]
        };
      }
      var relativeDirectories = globby.sync(tool.packageGlobs, {
        cwd,
        onlyDirectories: true,
        expandDirectories: false,
        ignore: ["**/node_modules"]
      });
      var directories = relativeDirectories.map(function(p) {
        return path4.resolve(cwd, p);
      });
      var pkgJsonsMissingNameField = [];
      var results = directories.sort().map(function(dir2) {
        try {
          var packageJson2 = fs4.readJsonSync(path4.join(dir2, "package.json"));
          if (!packageJson2.name) {
            pkgJsonsMissingNameField.push(path4.relative(cwd, path4.join(dir2, "package.json")));
          }
          return {
            packageJson: packageJson2,
            dir: dir2
          };
        } catch (err) {
          if (err.code === "ENOENT")
            return null;
          throw err;
        }
      }).filter(function(x2) {
        return x2;
      });
      if (pkgJsonsMissingNameField.length !== 0) {
        pkgJsonsMissingNameField.sort();
        throw new PackageJsonMissingNameError(pkgJsonsMissingNameField);
      }
      return {
        tool: tool.type,
        root: {
          dir: cwd,
          packageJson: pkg
        },
        packages: results
      };
    }
    exports.PackageJsonMissingNameError = PackageJsonMissingNameError;
    exports.getPackages = getPackages2;
    exports.getPackagesSync = getPackagesSync;
  }
});

// node_modules/@manypkg/get-packages/dist/get-packages.cjs.js
var require_get_packages_cjs = __commonJS({
  "node_modules/@manypkg/get-packages/dist/get-packages.cjs.js"(exports, module2) {
    "use strict";
    if (process.env.NODE_ENV === "production") {
      module2.exports = require_get_packages_cjs_prod();
    } else {
      module2.exports = require_get_packages_cjs_dev();
    }
  }
});

// node_modules/lodash/lodash.js
var require_lodash = __commonJS({
  "node_modules/lodash/lodash.js"(exports, module2) {
    (function() {
      var undefined2;
      var VERSION7 = "4.17.21";
      var LARGE_ARRAY_SIZE = 200;
      var CORE_ERROR_TEXT = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", FUNC_ERROR_TEXT = "Expected a function", INVALID_TEMPL_VAR_ERROR_TEXT = "Invalid `variable` option passed into `_.template`";
      var HASH_UNDEFINED = "__lodash_hash_undefined__";
      var MAX_MEMOIZE_SIZE = 500;
      var PLACEHOLDER = "__lodash_placeholder__";
      var CLONE_DEEP_FLAG = 1, CLONE_FLAT_FLAG = 2, CLONE_SYMBOLS_FLAG = 4;
      var COMPARE_PARTIAL_FLAG = 1, COMPARE_UNORDERED_FLAG = 2;
      var WRAP_BIND_FLAG = 1, WRAP_BIND_KEY_FLAG = 2, WRAP_CURRY_BOUND_FLAG = 4, WRAP_CURRY_FLAG = 8, WRAP_CURRY_RIGHT_FLAG = 16, WRAP_PARTIAL_FLAG = 32, WRAP_PARTIAL_RIGHT_FLAG = 64, WRAP_ARY_FLAG = 128, WRAP_REARG_FLAG = 256, WRAP_FLIP_FLAG = 512;
      var DEFAULT_TRUNC_LENGTH = 30, DEFAULT_TRUNC_OMISSION = "...";
      var HOT_COUNT = 800, HOT_SPAN = 16;
      var LAZY_FILTER_FLAG = 1, LAZY_MAP_FLAG = 2, LAZY_WHILE_FLAG = 3;
      var INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, MAX_INTEGER = 17976931348623157e292, NAN = 0 / 0;
      var MAX_ARRAY_LENGTH = 4294967295, MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1, HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;
      var wrapFlags = [
        ["ary", WRAP_ARY_FLAG],
        ["bind", WRAP_BIND_FLAG],
        ["bindKey", WRAP_BIND_KEY_FLAG],
        ["curry", WRAP_CURRY_FLAG],
        ["curryRight", WRAP_CURRY_RIGHT_FLAG],
        ["flip", WRAP_FLIP_FLAG],
        ["partial", WRAP_PARTIAL_FLAG],
        ["partialRight", WRAP_PARTIAL_RIGHT_FLAG],
        ["rearg", WRAP_REARG_FLAG]
      ];
      var argsTag = "[object Arguments]", arrayTag = "[object Array]", asyncTag = "[object AsyncFunction]", boolTag = "[object Boolean]", dateTag = "[object Date]", domExcTag = "[object DOMException]", errorTag = "[object Error]", funcTag = "[object Function]", genTag = "[object GeneratorFunction]", mapTag = "[object Map]", numberTag = "[object Number]", nullTag = "[object Null]", objectTag = "[object Object]", promiseTag = "[object Promise]", proxyTag = "[object Proxy]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]", undefinedTag = "[object Undefined]", weakMapTag = "[object WeakMap]", weakSetTag = "[object WeakSet]";
      var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
      var reEmptyStringLeading = /\b__p \+= '';/g, reEmptyStringMiddle = /\b(__p \+=) '' \+/g, reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;
      var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g, reUnescapedHtml = /[&<>"']/g, reHasEscapedHtml = RegExp(reEscapedHtml.source), reHasUnescapedHtml = RegExp(reUnescapedHtml.source);
      var reEscape = /<%-([\s\S]+?)%>/g, reEvaluate = /<%([\s\S]+?)%>/g, reInterpolate = /<%=([\s\S]+?)%>/g;
      var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
      var reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reHasRegExpChar = RegExp(reRegExpChar.source);
      var reTrimStart = /^\s+/;
      var reWhitespace = /\s/;
      var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/, reSplitDetails = /,? & /;
      var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
      var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;
      var reEscapeChar = /\\(\\)?/g;
      var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;
      var reFlags = /\w*$/;
      var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;
      var reIsBinary = /^0b[01]+$/i;
      var reIsHostCtor = /^\[object .+?Constructor\]$/;
      var reIsOctal = /^0o[0-7]+$/i;
      var reIsUint = /^(?:0|[1-9]\d*)$/;
      var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
      var reNoMatch = /($^)/;
      var reUnescapedString = /['\n\r\u2028\u2029\\]/g;
      var rsAstralRange = "\\ud800-\\udfff", rsComboMarksRange = "\\u0300-\\u036f", reComboHalfMarksRange = "\\ufe20-\\ufe2f", rsComboSymbolsRange = "\\u20d0-\\u20ff", rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange, rsDingbatRange = "\\u2700-\\u27bf", rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff", rsMathOpRange = "\\xac\\xb1\\xd7\\xf7", rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", rsPunctuationRange = "\\u2000-\\u206f", rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde", rsVarRange = "\\ufe0e\\ufe0f", rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
      var rsApos = "['\u2019]", rsAstral = "[" + rsAstralRange + "]", rsBreak = "[" + rsBreakRange + "]", rsCombo = "[" + rsComboRange + "]", rsDigits = "\\d+", rsDingbat = "[" + rsDingbatRange + "]", rsLower = "[" + rsLowerRange + "]", rsMisc = "[^" + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]", rsFitz = "\\ud83c[\\udffb-\\udfff]", rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")", rsNonAstral = "[^" + rsAstralRange + "]", rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}", rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]", rsUpper = "[" + rsUpperRange + "]", rsZWJ = "\\u200d";
      var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")", rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")", rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?", rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?", reOptMod = rsModifier + "?", rsOptVar = "[" + rsVarRange + "]?", rsOptJoin = "(?:" + rsZWJ + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*", rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", rsSeq = rsOptVar + reOptMod + rsOptJoin, rsEmoji = "(?:" + [rsDingbat, rsRegional, rsSurrPair].join("|") + ")" + rsSeq, rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
      var reApos = RegExp(rsApos, "g");
      var reComboMark = RegExp(rsCombo, "g");
      var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
      var reUnicodeWord = RegExp([
        rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
        rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
        rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
        rsUpper + "+" + rsOptContrUpper,
        rsOrdUpper,
        rsOrdLower,
        rsDigits,
        rsEmoji
      ].join("|"), "g");
      var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
      var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
      var contextProps = [
        "Array",
        "Buffer",
        "DataView",
        "Date",
        "Error",
        "Float32Array",
        "Float64Array",
        "Function",
        "Int8Array",
        "Int16Array",
        "Int32Array",
        "Map",
        "Math",
        "Object",
        "Promise",
        "RegExp",
        "Set",
        "String",
        "Symbol",
        "TypeError",
        "Uint8Array",
        "Uint8ClampedArray",
        "Uint16Array",
        "Uint32Array",
        "WeakMap",
        "_",
        "clearTimeout",
        "isFinite",
        "parseInt",
        "setTimeout"
      ];
      var templateCounter = -1;
      var typedArrayTags = {};
      typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
      typedArrayTags[argsTag] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
      var cloneableTags = {};
      cloneableTags[argsTag] = cloneableTags[arrayTag] = cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] = cloneableTags[boolTag] = cloneableTags[dateTag] = cloneableTags[float32Tag] = cloneableTags[float64Tag] = cloneableTags[int8Tag] = cloneableTags[int16Tag] = cloneableTags[int32Tag] = cloneableTags[mapTag] = cloneableTags[numberTag] = cloneableTags[objectTag] = cloneableTags[regexpTag] = cloneableTags[setTag] = cloneableTags[stringTag] = cloneableTags[symbolTag] = cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] = cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
      cloneableTags[errorTag] = cloneableTags[funcTag] = cloneableTags[weakMapTag] = false;
      var deburredLetters = {
        "\xC0": "A",
        "\xC1": "A",
        "\xC2": "A",
        "\xC3": "A",
        "\xC4": "A",
        "\xC5": "A",
        "\xE0": "a",
        "\xE1": "a",
        "\xE2": "a",
        "\xE3": "a",
        "\xE4": "a",
        "\xE5": "a",
        "\xC7": "C",
        "\xE7": "c",
        "\xD0": "D",
        "\xF0": "d",
        "\xC8": "E",
        "\xC9": "E",
        "\xCA": "E",
        "\xCB": "E",
        "\xE8": "e",
        "\xE9": "e",
        "\xEA": "e",
        "\xEB": "e",
        "\xCC": "I",
        "\xCD": "I",
        "\xCE": "I",
        "\xCF": "I",
        "\xEC": "i",
        "\xED": "i",
        "\xEE": "i",
        "\xEF": "i",
        "\xD1": "N",
        "\xF1": "n",
        "\xD2": "O",
        "\xD3": "O",
        "\xD4": "O",
        "\xD5": "O",
        "\xD6": "O",
        "\xD8": "O",
        "\xF2": "o",
        "\xF3": "o",
        "\xF4": "o",
        "\xF5": "o",
        "\xF6": "o",
        "\xF8": "o",
        "\xD9": "U",
        "\xDA": "U",
        "\xDB": "U",
        "\xDC": "U",
        "\xF9": "u",
        "\xFA": "u",
        "\xFB": "u",
        "\xFC": "u",
        "\xDD": "Y",
        "\xFD": "y",
        "\xFF": "y",
        "\xC6": "Ae",
        "\xE6": "ae",
        "\xDE": "Th",
        "\xFE": "th",
        "\xDF": "ss",
        "\u0100": "A",
        "\u0102": "A",
        "\u0104": "A",
        "\u0101": "a",
        "\u0103": "a",
        "\u0105": "a",
        "\u0106": "C",
        "\u0108": "C",
        "\u010A": "C",
        "\u010C": "C",
        "\u0107": "c",
        "\u0109": "c",
        "\u010B": "c",
        "\u010D": "c",
        "\u010E": "D",
        "\u0110": "D",
        "\u010F": "d",
        "\u0111": "d",
        "\u0112": "E",
        "\u0114": "E",
        "\u0116": "E",
        "\u0118": "E",
        "\u011A": "E",
        "\u0113": "e",
        "\u0115": "e",
        "\u0117": "e",
        "\u0119": "e",
        "\u011B": "e",
        "\u011C": "G",
        "\u011E": "G",
        "\u0120": "G",
        "\u0122": "G",
        "\u011D": "g",
        "\u011F": "g",
        "\u0121": "g",
        "\u0123": "g",
        "\u0124": "H",
        "\u0126": "H",
        "\u0125": "h",
        "\u0127": "h",
        "\u0128": "I",
        "\u012A": "I",
        "\u012C": "I",
        "\u012E": "I",
        "\u0130": "I",
        "\u0129": "i",
        "\u012B": "i",
        "\u012D": "i",
        "\u012F": "i",
        "\u0131": "i",
        "\u0134": "J",
        "\u0135": "j",
        "\u0136": "K",
        "\u0137": "k",
        "\u0138": "k",
        "\u0139": "L",
        "\u013B": "L",
        "\u013D": "L",
        "\u013F": "L",
        "\u0141": "L",
        "\u013A": "l",
        "\u013C": "l",
        "\u013E": "l",
        "\u0140": "l",
        "\u0142": "l",
        "\u0143": "N",
        "\u0145": "N",
        "\u0147": "N",
        "\u014A": "N",
        "\u0144": "n",
        "\u0146": "n",
        "\u0148": "n",
        "\u014B": "n",
        "\u014C": "O",
        "\u014E": "O",
        "\u0150": "O",
        "\u014D": "o",
        "\u014F": "o",
        "\u0151": "o",
        "\u0154": "R",
        "\u0156": "R",
        "\u0158": "R",
        "\u0155": "r",
        "\u0157": "r",
        "\u0159": "r",
        "\u015A": "S",
        "\u015C": "S",
        "\u015E": "S",
        "\u0160": "S",
        "\u015B": "s",
        "\u015D": "s",
        "\u015F": "s",
        "\u0161": "s",
        "\u0162": "T",
        "\u0164": "T",
        "\u0166": "T",
        "\u0163": "t",
        "\u0165": "t",
        "\u0167": "t",
        "\u0168": "U",
        "\u016A": "U",
        "\u016C": "U",
        "\u016E": "U",
        "\u0170": "U",
        "\u0172": "U",
        "\u0169": "u",
        "\u016B": "u",
        "\u016D": "u",
        "\u016F": "u",
        "\u0171": "u",
        "\u0173": "u",
        "\u0174": "W",
        "\u0175": "w",
        "\u0176": "Y",
        "\u0177": "y",
        "\u0178": "Y",
        "\u0179": "Z",
        "\u017B": "Z",
        "\u017D": "Z",
        "\u017A": "z",
        "\u017C": "z",
        "\u017E": "z",
        "\u0132": "IJ",
        "\u0133": "ij",
        "\u0152": "Oe",
        "\u0153": "oe",
        "\u0149": "'n",
        "\u017F": "s"
      };
      var htmlEscapes = {
        "&": "&amp;",
        "<": "&lt;",
        ">": "&gt;",
        '"': "&quot;",
        "'": "&#39;"
      };
      var htmlUnescapes = {
        "&amp;": "&",
        "&lt;": "<",
        "&gt;": ">",
        "&quot;": '"',
        "&#39;": "'"
      };
      var stringEscapes = {
        "\\": "\\",
        "'": "'",
        "\n": "n",
        "\r": "r",
        "\u2028": "u2028",
        "\u2029": "u2029"
      };
      var freeParseFloat = parseFloat, freeParseInt = parseInt;
      var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
      var freeSelf = typeof self == "object" && self && self.Object === Object && self;
      var root = freeGlobal || freeSelf || Function("return this")();
      var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
      var freeModule = freeExports && typeof module2 == "object" && module2 && !module2.nodeType && module2;
      var moduleExports = freeModule && freeModule.exports === freeExports;
      var freeProcess = moduleExports && freeGlobal.process;
      var nodeUtil = function() {
        try {
          var types3 = freeModule && freeModule.require && freeModule.require("util").types;
          if (types3) {
            return types3;
          }
          return freeProcess && freeProcess.binding && freeProcess.binding("util");
        } catch (e2) {
        }
      }();
      var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer, nodeIsDate = nodeUtil && nodeUtil.isDate, nodeIsMap = nodeUtil && nodeUtil.isMap, nodeIsRegExp = nodeUtil && nodeUtil.isRegExp, nodeIsSet = nodeUtil && nodeUtil.isSet, nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;
      function apply(func, thisArg, args) {
        switch (args.length) {
          case 0:
            return func.call(thisArg);
          case 1:
            return func.call(thisArg, args[0]);
          case 2:
            return func.call(thisArg, args[0], args[1]);
          case 3:
            return func.call(thisArg, args[0], args[1], args[2]);
        }
        return func.apply(thisArg, args);
      }
      function arrayAggregator(array, setter, iteratee, accumulator) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          var value = array[index];
          setter(accumulator, value, iteratee(value), array);
        }
        return accumulator;
      }
      function arrayEach(array, iteratee) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (iteratee(array[index], index, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayEachRight(array, iteratee) {
        var length = array == null ? 0 : array.length;
        while (length--) {
          if (iteratee(array[length], length, array) === false) {
            break;
          }
        }
        return array;
      }
      function arrayEvery(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (!predicate(array[index], index, array)) {
            return false;
          }
        }
        return true;
      }
      function arrayFilter(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
        while (++index < length) {
          var value = array[index];
          if (predicate(value, index, array)) {
            result[resIndex++] = value;
          }
        }
        return result;
      }
      function arrayIncludes(array, value) {
        var length = array == null ? 0 : array.length;
        return !!length && baseIndexOf(array, value, 0) > -1;
      }
      function arrayIncludesWith(array, value, comparator) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (comparator(value, array[index])) {
            return true;
          }
        }
        return false;
      }
      function arrayMap(array, iteratee) {
        var index = -1, length = array == null ? 0 : array.length, result = Array(length);
        while (++index < length) {
          result[index] = iteratee(array[index], index, array);
        }
        return result;
      }
      function arrayPush(array, values) {
        var index = -1, length = values.length, offset = array.length;
        while (++index < length) {
          array[offset + index] = values[index];
        }
        return array;
      }
      function arrayReduce(array, iteratee, accumulator, initAccum) {
        var index = -1, length = array == null ? 0 : array.length;
        if (initAccum && length) {
          accumulator = array[++index];
        }
        while (++index < length) {
          accumulator = iteratee(accumulator, array[index], index, array);
        }
        return accumulator;
      }
      function arrayReduceRight(array, iteratee, accumulator, initAccum) {
        var length = array == null ? 0 : array.length;
        if (initAccum && length) {
          accumulator = array[--length];
        }
        while (length--) {
          accumulator = iteratee(accumulator, array[length], length, array);
        }
        return accumulator;
      }
      function arraySome(array, predicate) {
        var index = -1, length = array == null ? 0 : array.length;
        while (++index < length) {
          if (predicate(array[index], index, array)) {
            return true;
          }
        }
        return false;
      }
      var asciiSize = baseProperty("length");
      function asciiToArray(string) {
        return string.split("");
      }
      function asciiWords(string) {
        return string.match(reAsciiWord) || [];
      }
      function baseFindKey(collection, predicate, eachFunc) {
        var result;
        eachFunc(collection, function(value, key, collection2) {
          if (predicate(value, key, collection2)) {
            result = key;
            return false;
          }
        });
        return result;
      }
      function baseFindIndex(array, predicate, fromIndex, fromRight) {
        var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
        while (fromRight ? index-- : ++index < length) {
          if (predicate(array[index], index, array)) {
            return index;
          }
        }
        return -1;
      }
      function baseIndexOf(array, value, fromIndex) {
        return value === value ? strictIndexOf(array, value, fromIndex) : baseFindIndex(array, baseIsNaN, fromIndex);
      }
      function baseIndexOfWith(array, value, fromIndex, comparator) {
        var index = fromIndex - 1, length = array.length;
        while (++index < length) {
          if (comparator(array[index], value)) {
            return index;
          }
        }
        return -1;
      }
      function baseIsNaN(value) {
        return value !== value;
      }
      function baseMean(array, iteratee) {
        var length = array == null ? 0 : array.length;
        return length ? baseSum(array, iteratee) / length : NAN;
      }
      function baseProperty(key) {
        return function(object) {
          return object == null ? undefined2 : object[key];
        };
      }
      function basePropertyOf(object) {
        return function(key) {
          return object == null ? undefined2 : object[key];
        };
      }
      function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
        eachFunc(collection, function(value, index, collection2) {
          accumulator = initAccum ? (initAccum = false, value) : iteratee(accumulator, value, index, collection2);
        });
        return accumulator;
      }
      function baseSortBy(array, comparer) {
        var length = array.length;
        array.sort(comparer);
        while (length--) {
          array[length] = array[length].value;
        }
        return array;
      }
      function baseSum(array, iteratee) {
        var result, index = -1, length = array.length;
        while (++index < length) {
          var current = iteratee(array[index]);
          if (current !== undefined2) {
            result = result === undefined2 ? current : result + current;
          }
        }
        return result;
      }
      function baseTimes(n, iteratee) {
        var index = -1, result = Array(n);
        while (++index < n) {
          result[index] = iteratee(index);
        }
        return result;
      }
      function baseToPairs(object, props) {
        return arrayMap(props, function(key) {
          return [key, object[key]];
        });
      }
      function baseTrim(string) {
        return string ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, "") : string;
      }
      function baseUnary(func) {
        return function(value) {
          return func(value);
        };
      }
      function baseValues(object, props) {
        return arrayMap(props, function(key) {
          return object[key];
        });
      }
      function cacheHas(cache, key) {
        return cache.has(key);
      }
      function charsStartIndex(strSymbols, chrSymbols) {
        var index = -1, length = strSymbols.length;
        while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {
        }
        return index;
      }
      function charsEndIndex(strSymbols, chrSymbols) {
        var index = strSymbols.length;
        while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {
        }
        return index;
      }
      function countHolders(array, placeholder) {
        var length = array.length, result = 0;
        while (length--) {
          if (array[length] === placeholder) {
            ++result;
          }
        }
        return result;
      }
      var deburrLetter = basePropertyOf(deburredLetters);
      var escapeHtmlChar = basePropertyOf(htmlEscapes);
      function escapeStringChar(chr) {
        return "\\" + stringEscapes[chr];
      }
      function getValue(object, key) {
        return object == null ? undefined2 : object[key];
      }
      function hasUnicode(string) {
        return reHasUnicode.test(string);
      }
      function hasUnicodeWord(string) {
        return reHasUnicodeWord.test(string);
      }
      function iteratorToArray(iterator2) {
        var data, result = [];
        while (!(data = iterator2.next()).done) {
          result.push(data.value);
        }
        return result;
      }
      function mapToArray(map) {
        var index = -1, result = Array(map.size);
        map.forEach(function(value, key) {
          result[++index] = [key, value];
        });
        return result;
      }
      function overArg(func, transform) {
        return function(arg) {
          return func(transform(arg));
        };
      }
      function replaceHolders(array, placeholder) {
        var index = -1, length = array.length, resIndex = 0, result = [];
        while (++index < length) {
          var value = array[index];
          if (value === placeholder || value === PLACEHOLDER) {
            array[index] = PLACEHOLDER;
            result[resIndex++] = index;
          }
        }
        return result;
      }
      function setToArray(set) {
        var index = -1, result = Array(set.size);
        set.forEach(function(value) {
          result[++index] = value;
        });
        return result;
      }
      function setToPairs(set) {
        var index = -1, result = Array(set.size);
        set.forEach(function(value) {
          result[++index] = [value, value];
        });
        return result;
      }
      function strictIndexOf(array, value, fromIndex) {
        var index = fromIndex - 1, length = array.length;
        while (++index < length) {
          if (array[index] === value) {
            return index;
          }
        }
        return -1;
      }
      function strictLastIndexOf(array, value, fromIndex) {
        var index = fromIndex + 1;
        while (index--) {
          if (array[index] === value) {
            return index;
          }
        }
        return index;
      }
      function stringSize(string) {
        return hasUnicode(string) ? unicodeSize(string) : asciiSize(string);
      }
      function stringToArray(string) {
        return hasUnicode(string) ? unicodeToArray(string) : asciiToArray(string);
      }
      function trimmedEndIndex(string) {
        var index = string.length;
        while (index-- && reWhitespace.test(string.charAt(index))) {
        }
        return index;
      }
      var unescapeHtmlChar = basePropertyOf(htmlUnescapes);
      function unicodeSize(string) {
        var result = reUnicode.lastIndex = 0;
        while (reUnicode.test(string)) {
          ++result;
        }
        return result;
      }
      function unicodeToArray(string) {
        return string.match(reUnicode) || [];
      }
      function unicodeWords(string) {
        return string.match(reUnicodeWord) || [];
      }
      var runInContext = function runInContext2(context2) {
        context2 = context2 == null ? root : _.defaults(root.Object(), context2, _.pick(root, contextProps));
        var Array2 = context2.Array, Date2 = context2.Date, Error2 = context2.Error, Function2 = context2.Function, Math2 = context2.Math, Object2 = context2.Object, RegExp2 = context2.RegExp, String2 = context2.String, TypeError2 = context2.TypeError;
        var arrayProto = Array2.prototype, funcProto = Function2.prototype, objectProto = Object2.prototype;
        var coreJsData = context2["__core-js_shared__"];
        var funcToString = funcProto.toString;
        var hasOwnProperty = objectProto.hasOwnProperty;
        var idCounter = 0;
        var maskSrcKey = function() {
          var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
          return uid ? "Symbol(src)_1." + uid : "";
        }();
        var nativeObjectToString = objectProto.toString;
        var objectCtorString = funcToString.call(Object2);
        var oldDash = root._;
        var reIsNative = RegExp2(
          "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
        );
        var Buffer4 = moduleExports ? context2.Buffer : undefined2, Symbol2 = context2.Symbol, Uint8Array2 = context2.Uint8Array, allocUnsafe = Buffer4 ? Buffer4.allocUnsafe : undefined2, getPrototype = overArg(Object2.getPrototypeOf, Object2), objectCreate = Object2.create, propertyIsEnumerable = objectProto.propertyIsEnumerable, splice = arrayProto.splice, spreadableSymbol = Symbol2 ? Symbol2.isConcatSpreadable : undefined2, symIterator = Symbol2 ? Symbol2.iterator : undefined2, symToStringTag = Symbol2 ? Symbol2.toStringTag : undefined2;
        var defineProperty = function() {
          try {
            var func = getNative(Object2, "defineProperty");
            func({}, "", {});
            return func;
          } catch (e2) {
          }
        }();
        var ctxClearTimeout = context2.clearTimeout !== root.clearTimeout && context2.clearTimeout, ctxNow = Date2 && Date2.now !== root.Date.now && Date2.now, ctxSetTimeout = context2.setTimeout !== root.setTimeout && context2.setTimeout;
        var nativeCeil = Math2.ceil, nativeFloor = Math2.floor, nativeGetSymbols = Object2.getOwnPropertySymbols, nativeIsBuffer = Buffer4 ? Buffer4.isBuffer : undefined2, nativeIsFinite = context2.isFinite, nativeJoin = arrayProto.join, nativeKeys = overArg(Object2.keys, Object2), nativeMax = Math2.max, nativeMin = Math2.min, nativeNow = Date2.now, nativeParseInt = context2.parseInt, nativeRandom = Math2.random, nativeReverse = arrayProto.reverse;
        var DataView2 = getNative(context2, "DataView"), Map2 = getNative(context2, "Map"), Promise2 = getNative(context2, "Promise"), Set2 = getNative(context2, "Set"), WeakMap2 = getNative(context2, "WeakMap"), nativeCreate = getNative(Object2, "create");
        var metaMap = WeakMap2 && new WeakMap2();
        var realNames = {};
        var dataViewCtorString = toSource(DataView2), mapCtorString = toSource(Map2), promiseCtorString = toSource(Promise2), setCtorString = toSource(Set2), weakMapCtorString = toSource(WeakMap2);
        var symbolProto = Symbol2 ? Symbol2.prototype : undefined2, symbolValueOf = symbolProto ? symbolProto.valueOf : undefined2, symbolToString = symbolProto ? symbolProto.toString : undefined2;
        function lodash(value) {
          if (isObjectLike(value) && !isArray2(value) && !(value instanceof LazyWrapper)) {
            if (value instanceof LodashWrapper) {
              return value;
            }
            if (hasOwnProperty.call(value, "__wrapped__")) {
              return wrapperClone(value);
            }
          }
          return new LodashWrapper(value);
        }
        var baseCreate = function() {
          function object() {
          }
          return function(proto) {
            if (!isObject3(proto)) {
              return {};
            }
            if (objectCreate) {
              return objectCreate(proto);
            }
            object.prototype = proto;
            var result2 = new object();
            object.prototype = undefined2;
            return result2;
          };
        }();
        function baseLodash() {
        }
        function LodashWrapper(value, chainAll) {
          this.__wrapped__ = value;
          this.__actions__ = [];
          this.__chain__ = !!chainAll;
          this.__index__ = 0;
          this.__values__ = undefined2;
        }
        lodash.templateSettings = {
          "escape": reEscape,
          "evaluate": reEvaluate,
          "interpolate": reInterpolate,
          "variable": "",
          "imports": {
            "_": lodash
          }
        };
        lodash.prototype = baseLodash.prototype;
        lodash.prototype.constructor = lodash;
        LodashWrapper.prototype = baseCreate(baseLodash.prototype);
        LodashWrapper.prototype.constructor = LodashWrapper;
        function LazyWrapper(value) {
          this.__wrapped__ = value;
          this.__actions__ = [];
          this.__dir__ = 1;
          this.__filtered__ = false;
          this.__iteratees__ = [];
          this.__takeCount__ = MAX_ARRAY_LENGTH;
          this.__views__ = [];
        }
        function lazyClone() {
          var result2 = new LazyWrapper(this.__wrapped__);
          result2.__actions__ = copyArray(this.__actions__);
          result2.__dir__ = this.__dir__;
          result2.__filtered__ = this.__filtered__;
          result2.__iteratees__ = copyArray(this.__iteratees__);
          result2.__takeCount__ = this.__takeCount__;
          result2.__views__ = copyArray(this.__views__);
          return result2;
        }
        function lazyReverse() {
          if (this.__filtered__) {
            var result2 = new LazyWrapper(this);
            result2.__dir__ = -1;
            result2.__filtered__ = true;
          } else {
            result2 = this.clone();
            result2.__dir__ *= -1;
          }
          return result2;
        }
        function lazyValue() {
          var array = this.__wrapped__.value(), dir = this.__dir__, isArr = isArray2(array), isRight = dir < 0, arrLength = isArr ? array.length : 0, view = getView(0, arrLength, this.__views__), start = view.start, end = view.end, length = end - start, index = isRight ? end : start - 1, iteratees = this.__iteratees__, iterLength = iteratees.length, resIndex = 0, takeCount = nativeMin(length, this.__takeCount__);
          if (!isArr || !isRight && arrLength == length && takeCount == length) {
            return baseWrapperValue(array, this.__actions__);
          }
          var result2 = [];
          outer:
            while (length-- && resIndex < takeCount) {
              index += dir;
              var iterIndex = -1, value = array[index];
              while (++iterIndex < iterLength) {
                var data = iteratees[iterIndex], iteratee2 = data.iteratee, type = data.type, computed = iteratee2(value);
                if (type == LAZY_MAP_FLAG) {
                  value = computed;
                } else if (!computed) {
                  if (type == LAZY_FILTER_FLAG) {
                    continue outer;
                  } else {
                    break outer;
                  }
                }
              }
              result2[resIndex++] = value;
            }
          return result2;
        }
        LazyWrapper.prototype = baseCreate(baseLodash.prototype);
        LazyWrapper.prototype.constructor = LazyWrapper;
        function Hash(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function hashClear() {
          this.__data__ = nativeCreate ? nativeCreate(null) : {};
          this.size = 0;
        }
        function hashDelete(key) {
          var result2 = this.has(key) && delete this.__data__[key];
          this.size -= result2 ? 1 : 0;
          return result2;
        }
        function hashGet(key) {
          var data = this.__data__;
          if (nativeCreate) {
            var result2 = data[key];
            return result2 === HASH_UNDEFINED ? undefined2 : result2;
          }
          return hasOwnProperty.call(data, key) ? data[key] : undefined2;
        }
        function hashHas(key) {
          var data = this.__data__;
          return nativeCreate ? data[key] !== undefined2 : hasOwnProperty.call(data, key);
        }
        function hashSet(key, value) {
          var data = this.__data__;
          this.size += this.has(key) ? 0 : 1;
          data[key] = nativeCreate && value === undefined2 ? HASH_UNDEFINED : value;
          return this;
        }
        Hash.prototype.clear = hashClear;
        Hash.prototype["delete"] = hashDelete;
        Hash.prototype.get = hashGet;
        Hash.prototype.has = hashHas;
        Hash.prototype.set = hashSet;
        function ListCache(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function listCacheClear() {
          this.__data__ = [];
          this.size = 0;
        }
        function listCacheDelete(key) {
          var data = this.__data__, index = assocIndexOf(data, key);
          if (index < 0) {
            return false;
          }
          var lastIndex = data.length - 1;
          if (index == lastIndex) {
            data.pop();
          } else {
            splice.call(data, index, 1);
          }
          --this.size;
          return true;
        }
        function listCacheGet(key) {
          var data = this.__data__, index = assocIndexOf(data, key);
          return index < 0 ? undefined2 : data[index][1];
        }
        function listCacheHas(key) {
          return assocIndexOf(this.__data__, key) > -1;
        }
        function listCacheSet(key, value) {
          var data = this.__data__, index = assocIndexOf(data, key);
          if (index < 0) {
            ++this.size;
            data.push([key, value]);
          } else {
            data[index][1] = value;
          }
          return this;
        }
        ListCache.prototype.clear = listCacheClear;
        ListCache.prototype["delete"] = listCacheDelete;
        ListCache.prototype.get = listCacheGet;
        ListCache.prototype.has = listCacheHas;
        ListCache.prototype.set = listCacheSet;
        function MapCache(entries) {
          var index = -1, length = entries == null ? 0 : entries.length;
          this.clear();
          while (++index < length) {
            var entry = entries[index];
            this.set(entry[0], entry[1]);
          }
        }
        function mapCacheClear() {
          this.size = 0;
          this.__data__ = {
            "hash": new Hash(),
            "map": new (Map2 || ListCache)(),
            "string": new Hash()
          };
        }
        function mapCacheDelete(key) {
          var result2 = getMapData(this, key)["delete"](key);
          this.size -= result2 ? 1 : 0;
          return result2;
        }
        function mapCacheGet(key) {
          return getMapData(this, key).get(key);
        }
        function mapCacheHas(key) {
          return getMapData(this, key).has(key);
        }
        function mapCacheSet(key, value) {
          var data = getMapData(this, key), size2 = data.size;
          data.set(key, value);
          this.size += data.size == size2 ? 0 : 1;
          return this;
        }
        MapCache.prototype.clear = mapCacheClear;
        MapCache.prototype["delete"] = mapCacheDelete;
        MapCache.prototype.get = mapCacheGet;
        MapCache.prototype.has = mapCacheHas;
        MapCache.prototype.set = mapCacheSet;
        function SetCache(values2) {
          var index = -1, length = values2 == null ? 0 : values2.length;
          this.__data__ = new MapCache();
          while (++index < length) {
            this.add(values2[index]);
          }
        }
        function setCacheAdd(value) {
          this.__data__.set(value, HASH_UNDEFINED);
          return this;
        }
        function setCacheHas(value) {
          return this.__data__.has(value);
        }
        SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
        SetCache.prototype.has = setCacheHas;
        function Stack(entries) {
          var data = this.__data__ = new ListCache(entries);
          this.size = data.size;
        }
        function stackClear() {
          this.__data__ = new ListCache();
          this.size = 0;
        }
        function stackDelete(key) {
          var data = this.__data__, result2 = data["delete"](key);
          this.size = data.size;
          return result2;
        }
        function stackGet(key) {
          return this.__data__.get(key);
        }
        function stackHas(key) {
          return this.__data__.has(key);
        }
        function stackSet(key, value) {
          var data = this.__data__;
          if (data instanceof ListCache) {
            var pairs = data.__data__;
            if (!Map2 || pairs.length < LARGE_ARRAY_SIZE - 1) {
              pairs.push([key, value]);
              this.size = ++data.size;
              return this;
            }
            data = this.__data__ = new MapCache(pairs);
          }
          data.set(key, value);
          this.size = data.size;
          return this;
        }
        Stack.prototype.clear = stackClear;
        Stack.prototype["delete"] = stackDelete;
        Stack.prototype.get = stackGet;
        Stack.prototype.has = stackHas;
        Stack.prototype.set = stackSet;
        function arrayLikeKeys(value, inherited) {
          var isArr = isArray2(value), isArg = !isArr && isArguments(value), isBuff = !isArr && !isArg && isBuffer(value), isType = !isArr && !isArg && !isBuff && isTypedArray(value), skipIndexes = isArr || isArg || isBuff || isType, result2 = skipIndexes ? baseTimes(value.length, String2) : [], length = result2.length;
          for (var key in value) {
            if ((inherited || hasOwnProperty.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
              result2.push(key);
            }
          }
          return result2;
        }
        function arraySample(array) {
          var length = array.length;
          return length ? array[baseRandom(0, length - 1)] : undefined2;
        }
        function arraySampleSize(array, n) {
          return shuffleSelf(copyArray(array), baseClamp(n, 0, array.length));
        }
        function arrayShuffle(array) {
          return shuffleSelf(copyArray(array));
        }
        function assignMergeValue(object, key, value) {
          if (value !== undefined2 && !eq(object[key], value) || value === undefined2 && !(key in object)) {
            baseAssignValue(object, key, value);
          }
        }
        function assignValue(object, key, value) {
          var objValue = object[key];
          if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) || value === undefined2 && !(key in object)) {
            baseAssignValue(object, key, value);
          }
        }
        function assocIndexOf(array, key) {
          var length = array.length;
          while (length--) {
            if (eq(array[length][0], key)) {
              return length;
            }
          }
          return -1;
        }
        function baseAggregator(collection, setter, iteratee2, accumulator) {
          baseEach(collection, function(value, key, collection2) {
            setter(accumulator, value, iteratee2(value), collection2);
          });
          return accumulator;
        }
        function baseAssign(object, source) {
          return object && copyObject(source, keys(source), object);
        }
        function baseAssignIn(object, source) {
          return object && copyObject(source, keysIn(source), object);
        }
        function baseAssignValue(object, key, value) {
          if (key == "__proto__" && defineProperty) {
            defineProperty(object, key, {
              "configurable": true,
              "enumerable": true,
              "value": value,
              "writable": true
            });
          } else {
            object[key] = value;
          }
        }
        function baseAt(object, paths) {
          var index = -1, length = paths.length, result2 = Array2(length), skip = object == null;
          while (++index < length) {
            result2[index] = skip ? undefined2 : get(object, paths[index]);
          }
          return result2;
        }
        function baseClamp(number, lower2, upper) {
          if (number === number) {
            if (upper !== undefined2) {
              number = number <= upper ? number : upper;
            }
            if (lower2 !== undefined2) {
              number = number >= lower2 ? number : lower2;
            }
          }
          return number;
        }
        function baseClone(value, bitmask, customizer, key, object, stack) {
          var result2, isDeep = bitmask & CLONE_DEEP_FLAG, isFlat = bitmask & CLONE_FLAT_FLAG, isFull = bitmask & CLONE_SYMBOLS_FLAG;
          if (customizer) {
            result2 = object ? customizer(value, key, object, stack) : customizer(value);
          }
          if (result2 !== undefined2) {
            return result2;
          }
          if (!isObject3(value)) {
            return value;
          }
          var isArr = isArray2(value);
          if (isArr) {
            result2 = initCloneArray(value);
            if (!isDeep) {
              return copyArray(value, result2);
            }
          } else {
            var tag = getTag(value), isFunc = tag == funcTag || tag == genTag;
            if (isBuffer(value)) {
              return cloneBuffer(value, isDeep);
            }
            if (tag == objectTag || tag == argsTag || isFunc && !object) {
              result2 = isFlat || isFunc ? {} : initCloneObject(value);
              if (!isDeep) {
                return isFlat ? copySymbolsIn(value, baseAssignIn(result2, value)) : copySymbols(value, baseAssign(result2, value));
              }
            } else {
              if (!cloneableTags[tag]) {
                return object ? value : {};
              }
              result2 = initCloneByTag(value, tag, isDeep);
            }
          }
          stack || (stack = new Stack());
          var stacked = stack.get(value);
          if (stacked) {
            return stacked;
          }
          stack.set(value, result2);
          if (isSet(value)) {
            value.forEach(function(subValue) {
              result2.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
            });
          } else if (isMap(value)) {
            value.forEach(function(subValue, key2) {
              result2.set(key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
            });
          }
          var keysFunc = isFull ? isFlat ? getAllKeysIn : getAllKeys : isFlat ? keysIn : keys;
          var props = isArr ? undefined2 : keysFunc(value);
          arrayEach(props || value, function(subValue, key2) {
            if (props) {
              key2 = subValue;
              subValue = value[key2];
            }
            assignValue(result2, key2, baseClone(subValue, bitmask, customizer, key2, value, stack));
          });
          return result2;
        }
        function baseConforms(source) {
          var props = keys(source);
          return function(object) {
            return baseConformsTo(object, source, props);
          };
        }
        function baseConformsTo(object, source, props) {
          var length = props.length;
          if (object == null) {
            return !length;
          }
          object = Object2(object);
          while (length--) {
            var key = props[length], predicate = source[key], value = object[key];
            if (value === undefined2 && !(key in object) || !predicate(value)) {
              return false;
            }
          }
          return true;
        }
        function baseDelay(func, wait, args) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return setTimeout2(function() {
            func.apply(undefined2, args);
          }, wait);
        }
        function baseDifference(array, values2, iteratee2, comparator) {
          var index = -1, includes2 = arrayIncludes, isCommon = true, length = array.length, result2 = [], valuesLength = values2.length;
          if (!length) {
            return result2;
          }
          if (iteratee2) {
            values2 = arrayMap(values2, baseUnary(iteratee2));
          }
          if (comparator) {
            includes2 = arrayIncludesWith;
            isCommon = false;
          } else if (values2.length >= LARGE_ARRAY_SIZE) {
            includes2 = cacheHas;
            isCommon = false;
            values2 = new SetCache(values2);
          }
          outer:
            while (++index < length) {
              var value = array[index], computed = iteratee2 == null ? value : iteratee2(value);
              value = comparator || value !== 0 ? value : 0;
              if (isCommon && computed === computed) {
                var valuesIndex = valuesLength;
                while (valuesIndex--) {
                  if (values2[valuesIndex] === computed) {
                    continue outer;
                  }
                }
                result2.push(value);
              } else if (!includes2(values2, computed, comparator)) {
                result2.push(value);
              }
            }
          return result2;
        }
        var baseEach = createBaseEach(baseForOwn);
        var baseEachRight = createBaseEach(baseForOwnRight, true);
        function baseEvery(collection, predicate) {
          var result2 = true;
          baseEach(collection, function(value, index, collection2) {
            result2 = !!predicate(value, index, collection2);
            return result2;
          });
          return result2;
        }
        function baseExtremum(array, iteratee2, comparator) {
          var index = -1, length = array.length;
          while (++index < length) {
            var value = array[index], current = iteratee2(value);
            if (current != null && (computed === undefined2 ? current === current && !isSymbol(current) : comparator(current, computed))) {
              var computed = current, result2 = value;
            }
          }
          return result2;
        }
        function baseFill(array, value, start, end) {
          var length = array.length;
          start = toInteger(start);
          if (start < 0) {
            start = -start > length ? 0 : length + start;
          }
          end = end === undefined2 || end > length ? length : toInteger(end);
          if (end < 0) {
            end += length;
          }
          end = start > end ? 0 : toLength(end);
          while (start < end) {
            array[start++] = value;
          }
          return array;
        }
        function baseFilter(collection, predicate) {
          var result2 = [];
          baseEach(collection, function(value, index, collection2) {
            if (predicate(value, index, collection2)) {
              result2.push(value);
            }
          });
          return result2;
        }
        function baseFlatten(array, depth, predicate, isStrict, result2) {
          var index = -1, length = array.length;
          predicate || (predicate = isFlattenable);
          result2 || (result2 = []);
          while (++index < length) {
            var value = array[index];
            if (depth > 0 && predicate(value)) {
              if (depth > 1) {
                baseFlatten(value, depth - 1, predicate, isStrict, result2);
              } else {
                arrayPush(result2, value);
              }
            } else if (!isStrict) {
              result2[result2.length] = value;
            }
          }
          return result2;
        }
        var baseFor = createBaseFor();
        var baseForRight = createBaseFor(true);
        function baseForOwn(object, iteratee2) {
          return object && baseFor(object, iteratee2, keys);
        }
        function baseForOwnRight(object, iteratee2) {
          return object && baseForRight(object, iteratee2, keys);
        }
        function baseFunctions(object, props) {
          return arrayFilter(props, function(key) {
            return isFunction(object[key]);
          });
        }
        function baseGet(object, path4) {
          path4 = castPath(path4, object);
          var index = 0, length = path4.length;
          while (object != null && index < length) {
            object = object[toKey(path4[index++])];
          }
          return index && index == length ? object : undefined2;
        }
        function baseGetAllKeys(object, keysFunc, symbolsFunc) {
          var result2 = keysFunc(object);
          return isArray2(object) ? result2 : arrayPush(result2, symbolsFunc(object));
        }
        function baseGetTag(value) {
          if (value == null) {
            return value === undefined2 ? undefinedTag : nullTag;
          }
          return symToStringTag && symToStringTag in Object2(value) ? getRawTag(value) : objectToString(value);
        }
        function baseGt(value, other) {
          return value > other;
        }
        function baseHas(object, key) {
          return object != null && hasOwnProperty.call(object, key);
        }
        function baseHasIn(object, key) {
          return object != null && key in Object2(object);
        }
        function baseInRange(number, start, end) {
          return number >= nativeMin(start, end) && number < nativeMax(start, end);
        }
        function baseIntersection(arrays, iteratee2, comparator) {
          var includes2 = comparator ? arrayIncludesWith : arrayIncludes, length = arrays[0].length, othLength = arrays.length, othIndex = othLength, caches = Array2(othLength), maxLength = Infinity, result2 = [];
          while (othIndex--) {
            var array = arrays[othIndex];
            if (othIndex && iteratee2) {
              array = arrayMap(array, baseUnary(iteratee2));
            }
            maxLength = nativeMin(array.length, maxLength);
            caches[othIndex] = !comparator && (iteratee2 || length >= 120 && array.length >= 120) ? new SetCache(othIndex && array) : undefined2;
          }
          array = arrays[0];
          var index = -1, seen = caches[0];
          outer:
            while (++index < length && result2.length < maxLength) {
              var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
              value = comparator || value !== 0 ? value : 0;
              if (!(seen ? cacheHas(seen, computed) : includes2(result2, computed, comparator))) {
                othIndex = othLength;
                while (--othIndex) {
                  var cache = caches[othIndex];
                  if (!(cache ? cacheHas(cache, computed) : includes2(arrays[othIndex], computed, comparator))) {
                    continue outer;
                  }
                }
                if (seen) {
                  seen.push(computed);
                }
                result2.push(value);
              }
            }
          return result2;
        }
        function baseInverter(object, setter, iteratee2, accumulator) {
          baseForOwn(object, function(value, key, object2) {
            setter(accumulator, iteratee2(value), key, object2);
          });
          return accumulator;
        }
        function baseInvoke(object, path4, args) {
          path4 = castPath(path4, object);
          object = parent(object, path4);
          var func = object == null ? object : object[toKey(last(path4))];
          return func == null ? undefined2 : apply(func, object, args);
        }
        function baseIsArguments(value) {
          return isObjectLike(value) && baseGetTag(value) == argsTag;
        }
        function baseIsArrayBuffer(value) {
          return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;
        }
        function baseIsDate(value) {
          return isObjectLike(value) && baseGetTag(value) == dateTag;
        }
        function baseIsEqual(value, other, bitmask, customizer, stack) {
          if (value === other) {
            return true;
          }
          if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
            return value !== value && other !== other;
          }
          return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
        }
        function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
          var objIsArr = isArray2(object), othIsArr = isArray2(other), objTag = objIsArr ? arrayTag : getTag(object), othTag = othIsArr ? arrayTag : getTag(other);
          objTag = objTag == argsTag ? objectTag : objTag;
          othTag = othTag == argsTag ? objectTag : othTag;
          var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
          if (isSameTag && isBuffer(object)) {
            if (!isBuffer(other)) {
              return false;
            }
            objIsArr = true;
            objIsObj = false;
          }
          if (isSameTag && !objIsObj) {
            stack || (stack = new Stack());
            return objIsArr || isTypedArray(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
          }
          if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
            var objIsWrapped = objIsObj && hasOwnProperty.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty.call(other, "__wrapped__");
            if (objIsWrapped || othIsWrapped) {
              var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
              stack || (stack = new Stack());
              return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
            }
          }
          if (!isSameTag) {
            return false;
          }
          stack || (stack = new Stack());
          return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
        }
        function baseIsMap(value) {
          return isObjectLike(value) && getTag(value) == mapTag;
        }
        function baseIsMatch(object, source, matchData, customizer) {
          var index = matchData.length, length = index, noCustomizer = !customizer;
          if (object == null) {
            return !length;
          }
          object = Object2(object);
          while (index--) {
            var data = matchData[index];
            if (noCustomizer && data[2] ? data[1] !== object[data[0]] : !(data[0] in object)) {
              return false;
            }
          }
          while (++index < length) {
            data = matchData[index];
            var key = data[0], objValue = object[key], srcValue = data[1];
            if (noCustomizer && data[2]) {
              if (objValue === undefined2 && !(key in object)) {
                return false;
              }
            } else {
              var stack = new Stack();
              if (customizer) {
                var result2 = customizer(objValue, srcValue, key, object, source, stack);
              }
              if (!(result2 === undefined2 ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack) : result2)) {
                return false;
              }
            }
          }
          return true;
        }
        function baseIsNative(value) {
          if (!isObject3(value) || isMasked(value)) {
            return false;
          }
          var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
          return pattern.test(toSource(value));
        }
        function baseIsRegExp(value) {
          return isObjectLike(value) && baseGetTag(value) == regexpTag;
        }
        function baseIsSet(value) {
          return isObjectLike(value) && getTag(value) == setTag;
        }
        function baseIsTypedArray(value) {
          return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
        }
        function baseIteratee(value) {
          if (typeof value == "function") {
            return value;
          }
          if (value == null) {
            return identity;
          }
          if (typeof value == "object") {
            return isArray2(value) ? baseMatchesProperty(value[0], value[1]) : baseMatches(value);
          }
          return property(value);
        }
        function baseKeys(object) {
          if (!isPrototype(object)) {
            return nativeKeys(object);
          }
          var result2 = [];
          for (var key in Object2(object)) {
            if (hasOwnProperty.call(object, key) && key != "constructor") {
              result2.push(key);
            }
          }
          return result2;
        }
        function baseKeysIn(object) {
          if (!isObject3(object)) {
            return nativeKeysIn(object);
          }
          var isProto = isPrototype(object), result2 = [];
          for (var key in object) {
            if (!(key == "constructor" && (isProto || !hasOwnProperty.call(object, key)))) {
              result2.push(key);
            }
          }
          return result2;
        }
        function baseLt(value, other) {
          return value < other;
        }
        function baseMap(collection, iteratee2) {
          var index = -1, result2 = isArrayLike(collection) ? Array2(collection.length) : [];
          baseEach(collection, function(value, key, collection2) {
            result2[++index] = iteratee2(value, key, collection2);
          });
          return result2;
        }
        function baseMatches(source) {
          var matchData = getMatchData(source);
          if (matchData.length == 1 && matchData[0][2]) {
            return matchesStrictComparable(matchData[0][0], matchData[0][1]);
          }
          return function(object) {
            return object === source || baseIsMatch(object, source, matchData);
          };
        }
        function baseMatchesProperty(path4, srcValue) {
          if (isKey(path4) && isStrictComparable(srcValue)) {
            return matchesStrictComparable(toKey(path4), srcValue);
          }
          return function(object) {
            var objValue = get(object, path4);
            return objValue === undefined2 && objValue === srcValue ? hasIn(object, path4) : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
          };
        }
        function baseMerge(object, source, srcIndex, customizer, stack) {
          if (object === source) {
            return;
          }
          baseFor(source, function(srcValue, key) {
            stack || (stack = new Stack());
            if (isObject3(srcValue)) {
              baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
            } else {
              var newValue = customizer ? customizer(safeGet(object, key), srcValue, key + "", object, source, stack) : undefined2;
              if (newValue === undefined2) {
                newValue = srcValue;
              }
              assignMergeValue(object, key, newValue);
            }
          }, keysIn);
        }
        function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
          var objValue = safeGet(object, key), srcValue = safeGet(source, key), stacked = stack.get(srcValue);
          if (stacked) {
            assignMergeValue(object, key, stacked);
            return;
          }
          var newValue = customizer ? customizer(objValue, srcValue, key + "", object, source, stack) : undefined2;
          var isCommon = newValue === undefined2;
          if (isCommon) {
            var isArr = isArray2(srcValue), isBuff = !isArr && isBuffer(srcValue), isTyped = !isArr && !isBuff && isTypedArray(srcValue);
            newValue = srcValue;
            if (isArr || isBuff || isTyped) {
              if (isArray2(objValue)) {
                newValue = objValue;
              } else if (isArrayLikeObject(objValue)) {
                newValue = copyArray(objValue);
              } else if (isBuff) {
                isCommon = false;
                newValue = cloneBuffer(srcValue, true);
              } else if (isTyped) {
                isCommon = false;
                newValue = cloneTypedArray(srcValue, true);
              } else {
                newValue = [];
              }
            } else if (isPlainObject3(srcValue) || isArguments(srcValue)) {
              newValue = objValue;
              if (isArguments(objValue)) {
                newValue = toPlainObject(objValue);
              } else if (!isObject3(objValue) || isFunction(objValue)) {
                newValue = initCloneObject(srcValue);
              }
            } else {
              isCommon = false;
            }
          }
          if (isCommon) {
            stack.set(srcValue, newValue);
            mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
            stack["delete"](srcValue);
          }
          assignMergeValue(object, key, newValue);
        }
        function baseNth(array, n) {
          var length = array.length;
          if (!length) {
            return;
          }
          n += n < 0 ? length : 0;
          return isIndex(n, length) ? array[n] : undefined2;
        }
        function baseOrderBy(collection, iteratees, orders) {
          if (iteratees.length) {
            iteratees = arrayMap(iteratees, function(iteratee2) {
              if (isArray2(iteratee2)) {
                return function(value) {
                  return baseGet(value, iteratee2.length === 1 ? iteratee2[0] : iteratee2);
                };
              }
              return iteratee2;
            });
          } else {
            iteratees = [identity];
          }
          var index = -1;
          iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
          var result2 = baseMap(collection, function(value, key, collection2) {
            var criteria = arrayMap(iteratees, function(iteratee2) {
              return iteratee2(value);
            });
            return { "criteria": criteria, "index": ++index, "value": value };
          });
          return baseSortBy(result2, function(object, other) {
            return compareMultiple(object, other, orders);
          });
        }
        function basePick(object, paths) {
          return basePickBy(object, paths, function(value, path4) {
            return hasIn(object, path4);
          });
        }
        function basePickBy(object, paths, predicate) {
          var index = -1, length = paths.length, result2 = {};
          while (++index < length) {
            var path4 = paths[index], value = baseGet(object, path4);
            if (predicate(value, path4)) {
              baseSet(result2, castPath(path4, object), value);
            }
          }
          return result2;
        }
        function basePropertyDeep(path4) {
          return function(object) {
            return baseGet(object, path4);
          };
        }
        function basePullAll(array, values2, iteratee2, comparator) {
          var indexOf2 = comparator ? baseIndexOfWith : baseIndexOf, index = -1, length = values2.length, seen = array;
          if (array === values2) {
            values2 = copyArray(values2);
          }
          if (iteratee2) {
            seen = arrayMap(array, baseUnary(iteratee2));
          }
          while (++index < length) {
            var fromIndex = 0, value = values2[index], computed = iteratee2 ? iteratee2(value) : value;
            while ((fromIndex = indexOf2(seen, computed, fromIndex, comparator)) > -1) {
              if (seen !== array) {
                splice.call(seen, fromIndex, 1);
              }
              splice.call(array, fromIndex, 1);
            }
          }
          return array;
        }
        function basePullAt(array, indexes) {
          var length = array ? indexes.length : 0, lastIndex = length - 1;
          while (length--) {
            var index = indexes[length];
            if (length == lastIndex || index !== previous) {
              var previous = index;
              if (isIndex(index)) {
                splice.call(array, index, 1);
              } else {
                baseUnset(array, index);
              }
            }
          }
          return array;
        }
        function baseRandom(lower2, upper) {
          return lower2 + nativeFloor(nativeRandom() * (upper - lower2 + 1));
        }
        function baseRange(start, end, step, fromRight) {
          var index = -1, length = nativeMax(nativeCeil((end - start) / (step || 1)), 0), result2 = Array2(length);
          while (length--) {
            result2[fromRight ? length : ++index] = start;
            start += step;
          }
          return result2;
        }
        function baseRepeat(string, n) {
          var result2 = "";
          if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
            return result2;
          }
          do {
            if (n % 2) {
              result2 += string;
            }
            n = nativeFloor(n / 2);
            if (n) {
              string += string;
            }
          } while (n);
          return result2;
        }
        function baseRest(func, start) {
          return setToString(overRest(func, start, identity), func + "");
        }
        function baseSample(collection) {
          return arraySample(values(collection));
        }
        function baseSampleSize(collection, n) {
          var array = values(collection);
          return shuffleSelf(array, baseClamp(n, 0, array.length));
        }
        function baseSet(object, path4, value, customizer) {
          if (!isObject3(object)) {
            return object;
          }
          path4 = castPath(path4, object);
          var index = -1, length = path4.length, lastIndex = length - 1, nested = object;
          while (nested != null && ++index < length) {
            var key = toKey(path4[index]), newValue = value;
            if (key === "__proto__" || key === "constructor" || key === "prototype") {
              return object;
            }
            if (index != lastIndex) {
              var objValue = nested[key];
              newValue = customizer ? customizer(objValue, key, nested) : undefined2;
              if (newValue === undefined2) {
                newValue = isObject3(objValue) ? objValue : isIndex(path4[index + 1]) ? [] : {};
              }
            }
            assignValue(nested, key, newValue);
            nested = nested[key];
          }
          return object;
        }
        var baseSetData = !metaMap ? identity : function(func, data) {
          metaMap.set(func, data);
          return func;
        };
        var baseSetToString = !defineProperty ? identity : function(func, string) {
          return defineProperty(func, "toString", {
            "configurable": true,
            "enumerable": false,
            "value": constant(string),
            "writable": true
          });
        };
        function baseShuffle(collection) {
          return shuffleSelf(values(collection));
        }
        function baseSlice(array, start, end) {
          var index = -1, length = array.length;
          if (start < 0) {
            start = -start > length ? 0 : length + start;
          }
          end = end > length ? length : end;
          if (end < 0) {
            end += length;
          }
          length = start > end ? 0 : end - start >>> 0;
          start >>>= 0;
          var result2 = Array2(length);
          while (++index < length) {
            result2[index] = array[index + start];
          }
          return result2;
        }
        function baseSome(collection, predicate) {
          var result2;
          baseEach(collection, function(value, index, collection2) {
            result2 = predicate(value, index, collection2);
            return !result2;
          });
          return !!result2;
        }
        function baseSortedIndex(array, value, retHighest) {
          var low = 0, high = array == null ? low : array.length;
          if (typeof value == "number" && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
            while (low < high) {
              var mid = low + high >>> 1, computed = array[mid];
              if (computed !== null && !isSymbol(computed) && (retHighest ? computed <= value : computed < value)) {
                low = mid + 1;
              } else {
                high = mid;
              }
            }
            return high;
          }
          return baseSortedIndexBy(array, value, identity, retHighest);
        }
        function baseSortedIndexBy(array, value, iteratee2, retHighest) {
          var low = 0, high = array == null ? 0 : array.length;
          if (high === 0) {
            return 0;
          }
          value = iteratee2(value);
          var valIsNaN = value !== value, valIsNull = value === null, valIsSymbol = isSymbol(value), valIsUndefined = value === undefined2;
          while (low < high) {
            var mid = nativeFloor((low + high) / 2), computed = iteratee2(array[mid]), othIsDefined = computed !== undefined2, othIsNull = computed === null, othIsReflexive = computed === computed, othIsSymbol = isSymbol(computed);
            if (valIsNaN) {
              var setLow = retHighest || othIsReflexive;
            } else if (valIsUndefined) {
              setLow = othIsReflexive && (retHighest || othIsDefined);
            } else if (valIsNull) {
              setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
            } else if (valIsSymbol) {
              setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
            } else if (othIsNull || othIsSymbol) {
              setLow = false;
            } else {
              setLow = retHighest ? computed <= value : computed < value;
            }
            if (setLow) {
              low = mid + 1;
            } else {
              high = mid;
            }
          }
          return nativeMin(high, MAX_ARRAY_INDEX);
        }
        function baseSortedUniq(array, iteratee2) {
          var index = -1, length = array.length, resIndex = 0, result2 = [];
          while (++index < length) {
            var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
            if (!index || !eq(computed, seen)) {
              var seen = computed;
              result2[resIndex++] = value === 0 ? 0 : value;
            }
          }
          return result2;
        }
        function baseToNumber(value) {
          if (typeof value == "number") {
            return value;
          }
          if (isSymbol(value)) {
            return NAN;
          }
          return +value;
        }
        function baseToString(value) {
          if (typeof value == "string") {
            return value;
          }
          if (isArray2(value)) {
            return arrayMap(value, baseToString) + "";
          }
          if (isSymbol(value)) {
            return symbolToString ? symbolToString.call(value) : "";
          }
          var result2 = value + "";
          return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
        }
        function baseUniq(array, iteratee2, comparator) {
          var index = -1, includes2 = arrayIncludes, length = array.length, isCommon = true, result2 = [], seen = result2;
          if (comparator) {
            isCommon = false;
            includes2 = arrayIncludesWith;
          } else if (length >= LARGE_ARRAY_SIZE) {
            var set2 = iteratee2 ? null : createSet(array);
            if (set2) {
              return setToArray(set2);
            }
            isCommon = false;
            includes2 = cacheHas;
            seen = new SetCache();
          } else {
            seen = iteratee2 ? [] : result2;
          }
          outer:
            while (++index < length) {
              var value = array[index], computed = iteratee2 ? iteratee2(value) : value;
              value = comparator || value !== 0 ? value : 0;
              if (isCommon && computed === computed) {
                var seenIndex = seen.length;
                while (seenIndex--) {
                  if (seen[seenIndex] === computed) {
                    continue outer;
                  }
                }
                if (iteratee2) {
                  seen.push(computed);
                }
                result2.push(value);
              } else if (!includes2(seen, computed, comparator)) {
                if (seen !== result2) {
                  seen.push(computed);
                }
                result2.push(value);
              }
            }
          return result2;
        }
        function baseUnset(object, path4) {
          path4 = castPath(path4, object);
          object = parent(object, path4);
          return object == null || delete object[toKey(last(path4))];
        }
        function baseUpdate(object, path4, updater, customizer) {
          return baseSet(object, path4, updater(baseGet(object, path4)), customizer);
        }
        function baseWhile(array, predicate, isDrop, fromRight) {
          var length = array.length, index = fromRight ? length : -1;
          while ((fromRight ? index-- : ++index < length) && predicate(array[index], index, array)) {
          }
          return isDrop ? baseSlice(array, fromRight ? 0 : index, fromRight ? index + 1 : length) : baseSlice(array, fromRight ? index + 1 : 0, fromRight ? length : index);
        }
        function baseWrapperValue(value, actions) {
          var result2 = value;
          if (result2 instanceof LazyWrapper) {
            result2 = result2.value();
          }
          return arrayReduce(actions, function(result3, action) {
            return action.func.apply(action.thisArg, arrayPush([result3], action.args));
          }, result2);
        }
        function baseXor(arrays, iteratee2, comparator) {
          var length = arrays.length;
          if (length < 2) {
            return length ? baseUniq(arrays[0]) : [];
          }
          var index = -1, result2 = Array2(length);
          while (++index < length) {
            var array = arrays[index], othIndex = -1;
            while (++othIndex < length) {
              if (othIndex != index) {
                result2[index] = baseDifference(result2[index] || array, arrays[othIndex], iteratee2, comparator);
              }
            }
          }
          return baseUniq(baseFlatten(result2, 1), iteratee2, comparator);
        }
        function baseZipObject(props, values2, assignFunc) {
          var index = -1, length = props.length, valsLength = values2.length, result2 = {};
          while (++index < length) {
            var value = index < valsLength ? values2[index] : undefined2;
            assignFunc(result2, props[index], value);
          }
          return result2;
        }
        function castArrayLikeObject(value) {
          return isArrayLikeObject(value) ? value : [];
        }
        function castFunction(value) {
          return typeof value == "function" ? value : identity;
        }
        function castPath(value, object) {
          if (isArray2(value)) {
            return value;
          }
          return isKey(value, object) ? [value] : stringToPath(toString(value));
        }
        var castRest = baseRest;
        function castSlice(array, start, end) {
          var length = array.length;
          end = end === undefined2 ? length : end;
          return !start && end >= length ? array : baseSlice(array, start, end);
        }
        var clearTimeout2 = ctxClearTimeout || function(id) {
          return root.clearTimeout(id);
        };
        function cloneBuffer(buffer, isDeep) {
          if (isDeep) {
            return buffer.slice();
          }
          var length = buffer.length, result2 = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
          buffer.copy(result2);
          return result2;
        }
        function cloneArrayBuffer(arrayBuffer) {
          var result2 = new arrayBuffer.constructor(arrayBuffer.byteLength);
          new Uint8Array2(result2).set(new Uint8Array2(arrayBuffer));
          return result2;
        }
        function cloneDataView(dataView, isDeep) {
          var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
          return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
        }
        function cloneRegExp(regexp) {
          var result2 = new regexp.constructor(regexp.source, reFlags.exec(regexp));
          result2.lastIndex = regexp.lastIndex;
          return result2;
        }
        function cloneSymbol(symbol) {
          return symbolValueOf ? Object2(symbolValueOf.call(symbol)) : {};
        }
        function cloneTypedArray(typedArray, isDeep) {
          var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
          return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
        }
        function compareAscending(value, other) {
          if (value !== other) {
            var valIsDefined = value !== undefined2, valIsNull = value === null, valIsReflexive = value === value, valIsSymbol = isSymbol(value);
            var othIsDefined = other !== undefined2, othIsNull = other === null, othIsReflexive = other === other, othIsSymbol = isSymbol(other);
            if (!othIsNull && !othIsSymbol && !valIsSymbol && value > other || valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol || valIsNull && othIsDefined && othIsReflexive || !valIsDefined && othIsReflexive || !valIsReflexive) {
              return 1;
            }
            if (!valIsNull && !valIsSymbol && !othIsSymbol && value < other || othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol || othIsNull && valIsDefined && valIsReflexive || !othIsDefined && valIsReflexive || !othIsReflexive) {
              return -1;
            }
          }
          return 0;
        }
        function compareMultiple(object, other, orders) {
          var index = -1, objCriteria = object.criteria, othCriteria = other.criteria, length = objCriteria.length, ordersLength = orders.length;
          while (++index < length) {
            var result2 = compareAscending(objCriteria[index], othCriteria[index]);
            if (result2) {
              if (index >= ordersLength) {
                return result2;
              }
              var order = orders[index];
              return result2 * (order == "desc" ? -1 : 1);
            }
          }
          return object.index - other.index;
        }
        function composeArgs(args, partials, holders, isCurried) {
          var argsIndex = -1, argsLength = args.length, holdersLength = holders.length, leftIndex = -1, leftLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result2 = Array2(leftLength + rangeLength), isUncurried = !isCurried;
          while (++leftIndex < leftLength) {
            result2[leftIndex] = partials[leftIndex];
          }
          while (++argsIndex < holdersLength) {
            if (isUncurried || argsIndex < argsLength) {
              result2[holders[argsIndex]] = args[argsIndex];
            }
          }
          while (rangeLength--) {
            result2[leftIndex++] = args[argsIndex++];
          }
          return result2;
        }
        function composeArgsRight(args, partials, holders, isCurried) {
          var argsIndex = -1, argsLength = args.length, holdersIndex = -1, holdersLength = holders.length, rightIndex = -1, rightLength = partials.length, rangeLength = nativeMax(argsLength - holdersLength, 0), result2 = Array2(rangeLength + rightLength), isUncurried = !isCurried;
          while (++argsIndex < rangeLength) {
            result2[argsIndex] = args[argsIndex];
          }
          var offset = argsIndex;
          while (++rightIndex < rightLength) {
            result2[offset + rightIndex] = partials[rightIndex];
          }
          while (++holdersIndex < holdersLength) {
            if (isUncurried || argsIndex < argsLength) {
              result2[offset + holders[holdersIndex]] = args[argsIndex++];
            }
          }
          return result2;
        }
        function copyArray(source, array) {
          var index = -1, length = source.length;
          array || (array = Array2(length));
          while (++index < length) {
            array[index] = source[index];
          }
          return array;
        }
        function copyObject(source, props, object, customizer) {
          var isNew = !object;
          object || (object = {});
          var index = -1, length = props.length;
          while (++index < length) {
            var key = props[index];
            var newValue = customizer ? customizer(object[key], source[key], key, object, source) : undefined2;
            if (newValue === undefined2) {
              newValue = source[key];
            }
            if (isNew) {
              baseAssignValue(object, key, newValue);
            } else {
              assignValue(object, key, newValue);
            }
          }
          return object;
        }
        function copySymbols(source, object) {
          return copyObject(source, getSymbols(source), object);
        }
        function copySymbolsIn(source, object) {
          return copyObject(source, getSymbolsIn(source), object);
        }
        function createAggregator(setter, initializer) {
          return function(collection, iteratee2) {
            var func = isArray2(collection) ? arrayAggregator : baseAggregator, accumulator = initializer ? initializer() : {};
            return func(collection, setter, getIteratee(iteratee2, 2), accumulator);
          };
        }
        function createAssigner(assigner) {
          return baseRest(function(object, sources) {
            var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : undefined2, guard = length > 2 ? sources[2] : undefined2;
            customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : undefined2;
            if (guard && isIterateeCall(sources[0], sources[1], guard)) {
              customizer = length < 3 ? undefined2 : customizer;
              length = 1;
            }
            object = Object2(object);
            while (++index < length) {
              var source = sources[index];
              if (source) {
                assigner(object, source, index, customizer);
              }
            }
            return object;
          });
        }
        function createBaseEach(eachFunc, fromRight) {
          return function(collection, iteratee2) {
            if (collection == null) {
              return collection;
            }
            if (!isArrayLike(collection)) {
              return eachFunc(collection, iteratee2);
            }
            var length = collection.length, index = fromRight ? length : -1, iterable = Object2(collection);
            while (fromRight ? index-- : ++index < length) {
              if (iteratee2(iterable[index], index, iterable) === false) {
                break;
              }
            }
            return collection;
          };
        }
        function createBaseFor(fromRight) {
          return function(object, iteratee2, keysFunc) {
            var index = -1, iterable = Object2(object), props = keysFunc(object), length = props.length;
            while (length--) {
              var key = props[fromRight ? length : ++index];
              if (iteratee2(iterable[key], key, iterable) === false) {
                break;
              }
            }
            return object;
          };
        }
        function createBind(func, bitmask, thisArg) {
          var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
          function wrapper() {
            var fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            return fn.apply(isBind ? thisArg : this, arguments);
          }
          return wrapper;
        }
        function createCaseFirst(methodName) {
          return function(string) {
            string = toString(string);
            var strSymbols = hasUnicode(string) ? stringToArray(string) : undefined2;
            var chr = strSymbols ? strSymbols[0] : string.charAt(0);
            var trailing = strSymbols ? castSlice(strSymbols, 1).join("") : string.slice(1);
            return chr[methodName]() + trailing;
          };
        }
        function createCompounder(callback) {
          return function(string) {
            return arrayReduce(words(deburr(string).replace(reApos, "")), callback, "");
          };
        }
        function createCtor(Ctor) {
          return function() {
            var args = arguments;
            switch (args.length) {
              case 0:
                return new Ctor();
              case 1:
                return new Ctor(args[0]);
              case 2:
                return new Ctor(args[0], args[1]);
              case 3:
                return new Ctor(args[0], args[1], args[2]);
              case 4:
                return new Ctor(args[0], args[1], args[2], args[3]);
              case 5:
                return new Ctor(args[0], args[1], args[2], args[3], args[4]);
              case 6:
                return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
              case 7:
                return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
            }
            var thisBinding = baseCreate(Ctor.prototype), result2 = Ctor.apply(thisBinding, args);
            return isObject3(result2) ? result2 : thisBinding;
          };
        }
        function createCurry(func, bitmask, arity) {
          var Ctor = createCtor(func);
          function wrapper() {
            var length = arguments.length, args = Array2(length), index = length, placeholder = getHolder(wrapper);
            while (index--) {
              args[index] = arguments[index];
            }
            var holders = length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder ? [] : replaceHolders(args, placeholder);
            length -= holders.length;
            if (length < arity) {
              return createRecurry(
                func,
                bitmask,
                createHybrid,
                wrapper.placeholder,
                undefined2,
                args,
                holders,
                undefined2,
                undefined2,
                arity - length
              );
            }
            var fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            return apply(fn, this, args);
          }
          return wrapper;
        }
        function createFind(findIndexFunc) {
          return function(collection, predicate, fromIndex) {
            var iterable = Object2(collection);
            if (!isArrayLike(collection)) {
              var iteratee2 = getIteratee(predicate, 3);
              collection = keys(collection);
              predicate = function(key) {
                return iteratee2(iterable[key], key, iterable);
              };
            }
            var index = findIndexFunc(collection, predicate, fromIndex);
            return index > -1 ? iterable[iteratee2 ? collection[index] : index] : undefined2;
          };
        }
        function createFlow(fromRight) {
          return flatRest(function(funcs) {
            var length = funcs.length, index = length, prereq = LodashWrapper.prototype.thru;
            if (fromRight) {
              funcs.reverse();
            }
            while (index--) {
              var func = funcs[index];
              if (typeof func != "function") {
                throw new TypeError2(FUNC_ERROR_TEXT);
              }
              if (prereq && !wrapper && getFuncName(func) == "wrapper") {
                var wrapper = new LodashWrapper([], true);
              }
            }
            index = wrapper ? index : length;
            while (++index < length) {
              func = funcs[index];
              var funcName = getFuncName(func), data = funcName == "wrapper" ? getData(func) : undefined2;
              if (data && isLaziable(data[0]) && data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) && !data[4].length && data[9] == 1) {
                wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
              } else {
                wrapper = func.length == 1 && isLaziable(func) ? wrapper[funcName]() : wrapper.thru(func);
              }
            }
            return function() {
              var args = arguments, value = args[0];
              if (wrapper && args.length == 1 && isArray2(value)) {
                return wrapper.plant(value).value();
              }
              var index2 = 0, result2 = length ? funcs[index2].apply(this, args) : value;
              while (++index2 < length) {
                result2 = funcs[index2].call(this, result2);
              }
              return result2;
            };
          });
        }
        function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary2, arity) {
          var isAry = bitmask & WRAP_ARY_FLAG, isBind = bitmask & WRAP_BIND_FLAG, isBindKey = bitmask & WRAP_BIND_KEY_FLAG, isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG), isFlip = bitmask & WRAP_FLIP_FLAG, Ctor = isBindKey ? undefined2 : createCtor(func);
          function wrapper() {
            var length = arguments.length, args = Array2(length), index = length;
            while (index--) {
              args[index] = arguments[index];
            }
            if (isCurried) {
              var placeholder = getHolder(wrapper), holdersCount = countHolders(args, placeholder);
            }
            if (partials) {
              args = composeArgs(args, partials, holders, isCurried);
            }
            if (partialsRight) {
              args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
            }
            length -= holdersCount;
            if (isCurried && length < arity) {
              var newHolders = replaceHolders(args, placeholder);
              return createRecurry(
                func,
                bitmask,
                createHybrid,
                wrapper.placeholder,
                thisArg,
                args,
                newHolders,
                argPos,
                ary2,
                arity - length
              );
            }
            var thisBinding = isBind ? thisArg : this, fn = isBindKey ? thisBinding[func] : func;
            length = args.length;
            if (argPos) {
              args = reorder(args, argPos);
            } else if (isFlip && length > 1) {
              args.reverse();
            }
            if (isAry && ary2 < length) {
              args.length = ary2;
            }
            if (this && this !== root && this instanceof wrapper) {
              fn = Ctor || createCtor(fn);
            }
            return fn.apply(thisBinding, args);
          }
          return wrapper;
        }
        function createInverter(setter, toIteratee) {
          return function(object, iteratee2) {
            return baseInverter(object, setter, toIteratee(iteratee2), {});
          };
        }
        function createMathOperation(operator, defaultValue) {
          return function(value, other) {
            var result2;
            if (value === undefined2 && other === undefined2) {
              return defaultValue;
            }
            if (value !== undefined2) {
              result2 = value;
            }
            if (other !== undefined2) {
              if (result2 === undefined2) {
                return other;
              }
              if (typeof value == "string" || typeof other == "string") {
                value = baseToString(value);
                other = baseToString(other);
              } else {
                value = baseToNumber(value);
                other = baseToNumber(other);
              }
              result2 = operator(value, other);
            }
            return result2;
          };
        }
        function createOver(arrayFunc) {
          return flatRest(function(iteratees) {
            iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
            return baseRest(function(args) {
              var thisArg = this;
              return arrayFunc(iteratees, function(iteratee2) {
                return apply(iteratee2, thisArg, args);
              });
            });
          });
        }
        function createPadding(length, chars) {
          chars = chars === undefined2 ? " " : baseToString(chars);
          var charsLength = chars.length;
          if (charsLength < 2) {
            return charsLength ? baseRepeat(chars, length) : chars;
          }
          var result2 = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
          return hasUnicode(chars) ? castSlice(stringToArray(result2), 0, length).join("") : result2.slice(0, length);
        }
        function createPartial(func, bitmask, thisArg, partials) {
          var isBind = bitmask & WRAP_BIND_FLAG, Ctor = createCtor(func);
          function wrapper() {
            var argsIndex = -1, argsLength = arguments.length, leftIndex = -1, leftLength = partials.length, args = Array2(leftLength + argsLength), fn = this && this !== root && this instanceof wrapper ? Ctor : func;
            while (++leftIndex < leftLength) {
              args[leftIndex] = partials[leftIndex];
            }
            while (argsLength--) {
              args[leftIndex++] = arguments[++argsIndex];
            }
            return apply(fn, isBind ? thisArg : this, args);
          }
          return wrapper;
        }
        function createRange(fromRight) {
          return function(start, end, step) {
            if (step && typeof step != "number" && isIterateeCall(start, end, step)) {
              end = step = undefined2;
            }
            start = toFinite(start);
            if (end === undefined2) {
              end = start;
              start = 0;
            } else {
              end = toFinite(end);
            }
            step = step === undefined2 ? start < end ? 1 : -1 : toFinite(step);
            return baseRange(start, end, step, fromRight);
          };
        }
        function createRelationalOperation(operator) {
          return function(value, other) {
            if (!(typeof value == "string" && typeof other == "string")) {
              value = toNumber(value);
              other = toNumber(other);
            }
            return operator(value, other);
          };
        }
        function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary2, arity) {
          var isCurry = bitmask & WRAP_CURRY_FLAG, newHolders = isCurry ? holders : undefined2, newHoldersRight = isCurry ? undefined2 : holders, newPartials = isCurry ? partials : undefined2, newPartialsRight = isCurry ? undefined2 : partials;
          bitmask |= isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG;
          bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);
          if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
            bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
          }
          var newData = [
            func,
            bitmask,
            thisArg,
            newPartials,
            newHolders,
            newPartialsRight,
            newHoldersRight,
            argPos,
            ary2,
            arity
          ];
          var result2 = wrapFunc.apply(undefined2, newData);
          if (isLaziable(func)) {
            setData(result2, newData);
          }
          result2.placeholder = placeholder;
          return setWrapToString(result2, func, bitmask);
        }
        function createRound(methodName) {
          var func = Math2[methodName];
          return function(number, precision) {
            number = toNumber(number);
            precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
            if (precision && nativeIsFinite(number)) {
              var pair = (toString(number) + "e").split("e"), value = func(pair[0] + "e" + (+pair[1] + precision));
              pair = (toString(value) + "e").split("e");
              return +(pair[0] + "e" + (+pair[1] - precision));
            }
            return func(number);
          };
        }
        var createSet = !(Set2 && 1 / setToArray(new Set2([, -0]))[1] == INFINITY) ? noop2 : function(values2) {
          return new Set2(values2);
        };
        function createToPairs(keysFunc) {
          return function(object) {
            var tag = getTag(object);
            if (tag == mapTag) {
              return mapToArray(object);
            }
            if (tag == setTag) {
              return setToPairs(object);
            }
            return baseToPairs(object, keysFunc(object));
          };
        }
        function createWrap(func, bitmask, thisArg, partials, holders, argPos, ary2, arity) {
          var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
          if (!isBindKey && typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          var length = partials ? partials.length : 0;
          if (!length) {
            bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
            partials = holders = undefined2;
          }
          ary2 = ary2 === undefined2 ? ary2 : nativeMax(toInteger(ary2), 0);
          arity = arity === undefined2 ? arity : toInteger(arity);
          length -= holders ? holders.length : 0;
          if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
            var partialsRight = partials, holdersRight = holders;
            partials = holders = undefined2;
          }
          var data = isBindKey ? undefined2 : getData(func);
          var newData = [
            func,
            bitmask,
            thisArg,
            partials,
            holders,
            partialsRight,
            holdersRight,
            argPos,
            ary2,
            arity
          ];
          if (data) {
            mergeData(newData, data);
          }
          func = newData[0];
          bitmask = newData[1];
          thisArg = newData[2];
          partials = newData[3];
          holders = newData[4];
          arity = newData[9] = newData[9] === undefined2 ? isBindKey ? 0 : func.length : nativeMax(newData[9] - length, 0);
          if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
            bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
          }
          if (!bitmask || bitmask == WRAP_BIND_FLAG) {
            var result2 = createBind(func, bitmask, thisArg);
          } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
            result2 = createCurry(func, bitmask, arity);
          } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
            result2 = createPartial(func, bitmask, thisArg, partials);
          } else {
            result2 = createHybrid.apply(undefined2, newData);
          }
          var setter = data ? baseSetData : setData;
          return setWrapToString(setter(result2, newData), func, bitmask);
        }
        function customDefaultsAssignIn(objValue, srcValue, key, object) {
          if (objValue === undefined2 || eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key)) {
            return srcValue;
          }
          return objValue;
        }
        function customDefaultsMerge(objValue, srcValue, key, object, source, stack) {
          if (isObject3(objValue) && isObject3(srcValue)) {
            stack.set(srcValue, objValue);
            baseMerge(objValue, srcValue, undefined2, customDefaultsMerge, stack);
            stack["delete"](srcValue);
          }
          return objValue;
        }
        function customOmitClone(value) {
          return isPlainObject3(value) ? undefined2 : value;
        }
        function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
          if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
            return false;
          }
          var arrStacked = stack.get(array);
          var othStacked = stack.get(other);
          if (arrStacked && othStacked) {
            return arrStacked == other && othStacked == array;
          }
          var index = -1, result2 = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache() : undefined2;
          stack.set(array, other);
          stack.set(other, array);
          while (++index < arrLength) {
            var arrValue = array[index], othValue = other[index];
            if (customizer) {
              var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
            }
            if (compared !== undefined2) {
              if (compared) {
                continue;
              }
              result2 = false;
              break;
            }
            if (seen) {
              if (!arraySome(other, function(othValue2, othIndex) {
                if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
                  return seen.push(othIndex);
                }
              })) {
                result2 = false;
                break;
              }
            } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              result2 = false;
              break;
            }
          }
          stack["delete"](array);
          stack["delete"](other);
          return result2;
        }
        function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
          switch (tag) {
            case dataViewTag:
              if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
                return false;
              }
              object = object.buffer;
              other = other.buffer;
            case arrayBufferTag:
              if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array2(object), new Uint8Array2(other))) {
                return false;
              }
              return true;
            case boolTag:
            case dateTag:
            case numberTag:
              return eq(+object, +other);
            case errorTag:
              return object.name == other.name && object.message == other.message;
            case regexpTag:
            case stringTag:
              return object == other + "";
            case mapTag:
              var convert2 = mapToArray;
            case setTag:
              var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
              convert2 || (convert2 = setToArray);
              if (object.size != other.size && !isPartial) {
                return false;
              }
              var stacked = stack.get(object);
              if (stacked) {
                return stacked == other;
              }
              bitmask |= COMPARE_UNORDERED_FLAG;
              stack.set(object, other);
              var result2 = equalArrays(convert2(object), convert2(other), bitmask, customizer, equalFunc, stack);
              stack["delete"](object);
              return result2;
            case symbolTag:
              if (symbolValueOf) {
                return symbolValueOf.call(object) == symbolValueOf.call(other);
              }
          }
          return false;
        }
        function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG, objProps = getAllKeys(object), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
          if (objLength != othLength && !isPartial) {
            return false;
          }
          var index = objLength;
          while (index--) {
            var key = objProps[index];
            if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
              return false;
            }
          }
          var objStacked = stack.get(object);
          var othStacked = stack.get(other);
          if (objStacked && othStacked) {
            return objStacked == other && othStacked == object;
          }
          var result2 = true;
          stack.set(object, other);
          stack.set(other, object);
          var skipCtor = isPartial;
          while (++index < objLength) {
            key = objProps[index];
            var objValue = object[key], othValue = other[key];
            if (customizer) {
              var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
            }
            if (!(compared === undefined2 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
              result2 = false;
              break;
            }
            skipCtor || (skipCtor = key == "constructor");
          }
          if (result2 && !skipCtor) {
            var objCtor = object.constructor, othCtor = other.constructor;
            if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
              result2 = false;
            }
          }
          stack["delete"](object);
          stack["delete"](other);
          return result2;
        }
        function flatRest(func) {
          return setToString(overRest(func, undefined2, flatten2), func + "");
        }
        function getAllKeys(object) {
          return baseGetAllKeys(object, keys, getSymbols);
        }
        function getAllKeysIn(object) {
          return baseGetAllKeys(object, keysIn, getSymbolsIn);
        }
        var getData = !metaMap ? noop2 : function(func) {
          return metaMap.get(func);
        };
        function getFuncName(func) {
          var result2 = func.name + "", array = realNames[result2], length = hasOwnProperty.call(realNames, result2) ? array.length : 0;
          while (length--) {
            var data = array[length], otherFunc = data.func;
            if (otherFunc == null || otherFunc == func) {
              return data.name;
            }
          }
          return result2;
        }
        function getHolder(func) {
          var object = hasOwnProperty.call(lodash, "placeholder") ? lodash : func;
          return object.placeholder;
        }
        function getIteratee() {
          var result2 = lodash.iteratee || iteratee;
          result2 = result2 === iteratee ? baseIteratee : result2;
          return arguments.length ? result2(arguments[0], arguments[1]) : result2;
        }
        function getMapData(map2, key) {
          var data = map2.__data__;
          return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
        }
        function getMatchData(object) {
          var result2 = keys(object), length = result2.length;
          while (length--) {
            var key = result2[length], value = object[key];
            result2[length] = [key, value, isStrictComparable(value)];
          }
          return result2;
        }
        function getNative(object, key) {
          var value = getValue(object, key);
          return baseIsNative(value) ? value : undefined2;
        }
        function getRawTag(value) {
          var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
          try {
            value[symToStringTag] = undefined2;
            var unmasked = true;
          } catch (e2) {
          }
          var result2 = nativeObjectToString.call(value);
          if (unmasked) {
            if (isOwn) {
              value[symToStringTag] = tag;
            } else {
              delete value[symToStringTag];
            }
          }
          return result2;
        }
        var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
          if (object == null) {
            return [];
          }
          object = Object2(object);
          return arrayFilter(nativeGetSymbols(object), function(symbol) {
            return propertyIsEnumerable.call(object, symbol);
          });
        };
        var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
          var result2 = [];
          while (object) {
            arrayPush(result2, getSymbols(object));
            object = getPrototype(object);
          }
          return result2;
        };
        var getTag = baseGetTag;
        if (DataView2 && getTag(new DataView2(new ArrayBuffer(1))) != dataViewTag || Map2 && getTag(new Map2()) != mapTag || Promise2 && getTag(Promise2.resolve()) != promiseTag || Set2 && getTag(new Set2()) != setTag || WeakMap2 && getTag(new WeakMap2()) != weakMapTag) {
          getTag = function(value) {
            var result2 = baseGetTag(value), Ctor = result2 == objectTag ? value.constructor : undefined2, ctorString = Ctor ? toSource(Ctor) : "";
            if (ctorString) {
              switch (ctorString) {
                case dataViewCtorString:
                  return dataViewTag;
                case mapCtorString:
                  return mapTag;
                case promiseCtorString:
                  return promiseTag;
                case setCtorString:
                  return setTag;
                case weakMapCtorString:
                  return weakMapTag;
              }
            }
            return result2;
          };
        }
        function getView(start, end, transforms) {
          var index = -1, length = transforms.length;
          while (++index < length) {
            var data = transforms[index], size2 = data.size;
            switch (data.type) {
              case "drop":
                start += size2;
                break;
              case "dropRight":
                end -= size2;
                break;
              case "take":
                end = nativeMin(end, start + size2);
                break;
              case "takeRight":
                start = nativeMax(start, end - size2);
                break;
            }
          }
          return { "start": start, "end": end };
        }
        function getWrapDetails(source) {
          var match = source.match(reWrapDetails);
          return match ? match[1].split(reSplitDetails) : [];
        }
        function hasPath(object, path4, hasFunc) {
          path4 = castPath(path4, object);
          var index = -1, length = path4.length, result2 = false;
          while (++index < length) {
            var key = toKey(path4[index]);
            if (!(result2 = object != null && hasFunc(object, key))) {
              break;
            }
            object = object[key];
          }
          if (result2 || ++index != length) {
            return result2;
          }
          length = object == null ? 0 : object.length;
          return !!length && isLength(length) && isIndex(key, length) && (isArray2(object) || isArguments(object));
        }
        function initCloneArray(array) {
          var length = array.length, result2 = new array.constructor(length);
          if (length && typeof array[0] == "string" && hasOwnProperty.call(array, "index")) {
            result2.index = array.index;
            result2.input = array.input;
          }
          return result2;
        }
        function initCloneObject(object) {
          return typeof object.constructor == "function" && !isPrototype(object) ? baseCreate(getPrototype(object)) : {};
        }
        function initCloneByTag(object, tag, isDeep) {
          var Ctor = object.constructor;
          switch (tag) {
            case arrayBufferTag:
              return cloneArrayBuffer(object);
            case boolTag:
            case dateTag:
              return new Ctor(+object);
            case dataViewTag:
              return cloneDataView(object, isDeep);
            case float32Tag:
            case float64Tag:
            case int8Tag:
            case int16Tag:
            case int32Tag:
            case uint8Tag:
            case uint8ClampedTag:
            case uint16Tag:
            case uint32Tag:
              return cloneTypedArray(object, isDeep);
            case mapTag:
              return new Ctor();
            case numberTag:
            case stringTag:
              return new Ctor(object);
            case regexpTag:
              return cloneRegExp(object);
            case setTag:
              return new Ctor();
            case symbolTag:
              return cloneSymbol(object);
          }
        }
        function insertWrapDetails(source, details) {
          var length = details.length;
          if (!length) {
            return source;
          }
          var lastIndex = length - 1;
          details[lastIndex] = (length > 1 ? "& " : "") + details[lastIndex];
          details = details.join(length > 2 ? ", " : " ");
          return source.replace(reWrapComment, "{\n/* [wrapped with " + details + "] */\n");
        }
        function isFlattenable(value) {
          return isArray2(value) || isArguments(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
        }
        function isIndex(value, length) {
          var type = typeof value;
          length = length == null ? MAX_SAFE_INTEGER : length;
          return !!length && (type == "number" || type != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
        }
        function isIterateeCall(value, index, object) {
          if (!isObject3(object)) {
            return false;
          }
          var type = typeof index;
          if (type == "number" ? isArrayLike(object) && isIndex(index, object.length) : type == "string" && index in object) {
            return eq(object[index], value);
          }
          return false;
        }
        function isKey(value, object) {
          if (isArray2(value)) {
            return false;
          }
          var type = typeof value;
          if (type == "number" || type == "symbol" || type == "boolean" || value == null || isSymbol(value)) {
            return true;
          }
          return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object2(object);
        }
        function isKeyable(value) {
          var type = typeof value;
          return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
        }
        function isLaziable(func) {
          var funcName = getFuncName(func), other = lodash[funcName];
          if (typeof other != "function" || !(funcName in LazyWrapper.prototype)) {
            return false;
          }
          if (func === other) {
            return true;
          }
          var data = getData(other);
          return !!data && func === data[0];
        }
        function isMasked(func) {
          return !!maskSrcKey && maskSrcKey in func;
        }
        var isMaskable = coreJsData ? isFunction : stubFalse;
        function isPrototype(value) {
          var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto;
          return value === proto;
        }
        function isStrictComparable(value) {
          return value === value && !isObject3(value);
        }
        function matchesStrictComparable(key, srcValue) {
          return function(object) {
            if (object == null) {
              return false;
            }
            return object[key] === srcValue && (srcValue !== undefined2 || key in Object2(object));
          };
        }
        function memoizeCapped(func) {
          var result2 = memoize(func, function(key) {
            if (cache.size === MAX_MEMOIZE_SIZE) {
              cache.clear();
            }
            return key;
          });
          var cache = result2.cache;
          return result2;
        }
        function mergeData(data, source) {
          var bitmask = data[1], srcBitmask = source[1], newBitmask = bitmask | srcBitmask, isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);
          var isCombo = srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_CURRY_FLAG || srcBitmask == WRAP_ARY_FLAG && bitmask == WRAP_REARG_FLAG && data[7].length <= source[8] || srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG) && source[7].length <= source[8] && bitmask == WRAP_CURRY_FLAG;
          if (!(isCommon || isCombo)) {
            return data;
          }
          if (srcBitmask & WRAP_BIND_FLAG) {
            data[2] = source[2];
            newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
          }
          var value = source[3];
          if (value) {
            var partials = data[3];
            data[3] = partials ? composeArgs(partials, value, source[4]) : value;
            data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
          }
          value = source[5];
          if (value) {
            partials = data[5];
            data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
            data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
          }
          value = source[7];
          if (value) {
            data[7] = value;
          }
          if (srcBitmask & WRAP_ARY_FLAG) {
            data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
          }
          if (data[9] == null) {
            data[9] = source[9];
          }
          data[0] = source[0];
          data[1] = newBitmask;
          return data;
        }
        function nativeKeysIn(object) {
          var result2 = [];
          if (object != null) {
            for (var key in Object2(object)) {
              result2.push(key);
            }
          }
          return result2;
        }
        function objectToString(value) {
          return nativeObjectToString.call(value);
        }
        function overRest(func, start, transform2) {
          start = nativeMax(start === undefined2 ? func.length - 1 : start, 0);
          return function() {
            var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array2(length);
            while (++index < length) {
              array[index] = args[start + index];
            }
            index = -1;
            var otherArgs = Array2(start + 1);
            while (++index < start) {
              otherArgs[index] = args[index];
            }
            otherArgs[start] = transform2(array);
            return apply(func, this, otherArgs);
          };
        }
        function parent(object, path4) {
          return path4.length < 2 ? object : baseGet(object, baseSlice(path4, 0, -1));
        }
        function reorder(array, indexes) {
          var arrLength = array.length, length = nativeMin(indexes.length, arrLength), oldArray = copyArray(array);
          while (length--) {
            var index = indexes[length];
            array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined2;
          }
          return array;
        }
        function safeGet(object, key) {
          if (key === "constructor" && typeof object[key] === "function") {
            return;
          }
          if (key == "__proto__") {
            return;
          }
          return object[key];
        }
        var setData = shortOut(baseSetData);
        var setTimeout2 = ctxSetTimeout || function(func, wait) {
          return root.setTimeout(func, wait);
        };
        var setToString = shortOut(baseSetToString);
        function setWrapToString(wrapper, reference, bitmask) {
          var source = reference + "";
          return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
        }
        function shortOut(func) {
          var count = 0, lastCalled = 0;
          return function() {
            var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
            lastCalled = stamp;
            if (remaining > 0) {
              if (++count >= HOT_COUNT) {
                return arguments[0];
              }
            } else {
              count = 0;
            }
            return func.apply(undefined2, arguments);
          };
        }
        function shuffleSelf(array, size2) {
          var index = -1, length = array.length, lastIndex = length - 1;
          size2 = size2 === undefined2 ? length : size2;
          while (++index < size2) {
            var rand = baseRandom(index, lastIndex), value = array[rand];
            array[rand] = array[index];
            array[index] = value;
          }
          array.length = size2;
          return array;
        }
        var stringToPath = memoizeCapped(function(string) {
          var result2 = [];
          if (string.charCodeAt(0) === 46) {
            result2.push("");
          }
          string.replace(rePropName, function(match, number, quote, subString) {
            result2.push(quote ? subString.replace(reEscapeChar, "$1") : number || match);
          });
          return result2;
        });
        function toKey(value) {
          if (typeof value == "string" || isSymbol(value)) {
            return value;
          }
          var result2 = value + "";
          return result2 == "0" && 1 / value == -INFINITY ? "-0" : result2;
        }
        function toSource(func) {
          if (func != null) {
            try {
              return funcToString.call(func);
            } catch (e2) {
            }
            try {
              return func + "";
            } catch (e2) {
            }
          }
          return "";
        }
        function updateWrapDetails(details, bitmask) {
          arrayEach(wrapFlags, function(pair) {
            var value = "_." + pair[0];
            if (bitmask & pair[1] && !arrayIncludes(details, value)) {
              details.push(value);
            }
          });
          return details.sort();
        }
        function wrapperClone(wrapper) {
          if (wrapper instanceof LazyWrapper) {
            return wrapper.clone();
          }
          var result2 = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
          result2.__actions__ = copyArray(wrapper.__actions__);
          result2.__index__ = wrapper.__index__;
          result2.__values__ = wrapper.__values__;
          return result2;
        }
        function chunk(array, size2, guard) {
          if (guard ? isIterateeCall(array, size2, guard) : size2 === undefined2) {
            size2 = 1;
          } else {
            size2 = nativeMax(toInteger(size2), 0);
          }
          var length = array == null ? 0 : array.length;
          if (!length || size2 < 1) {
            return [];
          }
          var index = 0, resIndex = 0, result2 = Array2(nativeCeil(length / size2));
          while (index < length) {
            result2[resIndex++] = baseSlice(array, index, index += size2);
          }
          return result2;
        }
        function compact(array) {
          var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result2 = [];
          while (++index < length) {
            var value = array[index];
            if (value) {
              result2[resIndex++] = value;
            }
          }
          return result2;
        }
        function concat() {
          var length = arguments.length;
          if (!length) {
            return [];
          }
          var args = Array2(length - 1), array = arguments[0], index = length;
          while (index--) {
            args[index - 1] = arguments[index];
          }
          return arrayPush(isArray2(array) ? copyArray(array) : [array], baseFlatten(args, 1));
        }
        var difference = baseRest(function(array, values2) {
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true)) : [];
        });
        var differenceBy = baseRest(function(array, values2) {
          var iteratee2 = last(values2);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2)) : [];
        });
        var differenceWith = baseRest(function(array, values2) {
          var comparator = last(values2);
          if (isArrayLikeObject(comparator)) {
            comparator = undefined2;
          }
          return isArrayLikeObject(array) ? baseDifference(array, baseFlatten(values2, 1, isArrayLikeObject, true), undefined2, comparator) : [];
        });
        function drop(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          return baseSlice(array, n < 0 ? 0 : n, length);
        }
        function dropRight(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          n = length - n;
          return baseSlice(array, 0, n < 0 ? 0 : n);
        }
        function dropRightWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true, true) : [];
        }
        function dropWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), true) : [];
        }
        function fill(array, value, start, end) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          if (start && typeof start != "number" && isIterateeCall(array, value, start)) {
            start = 0;
            end = length;
          }
          return baseFill(array, value, start, end);
        }
        function findIndex(array, predicate, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = fromIndex == null ? 0 : toInteger(fromIndex);
          if (index < 0) {
            index = nativeMax(length + index, 0);
          }
          return baseFindIndex(array, getIteratee(predicate, 3), index);
        }
        function findLastIndex(array, predicate, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = length - 1;
          if (fromIndex !== undefined2) {
            index = toInteger(fromIndex);
            index = fromIndex < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
          }
          return baseFindIndex(array, getIteratee(predicate, 3), index, true);
        }
        function flatten2(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseFlatten(array, 1) : [];
        }
        function flattenDeep(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseFlatten(array, INFINITY) : [];
        }
        function flattenDepth(array, depth) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          depth = depth === undefined2 ? 1 : toInteger(depth);
          return baseFlatten(array, depth);
        }
        function fromPairs(pairs) {
          var index = -1, length = pairs == null ? 0 : pairs.length, result2 = {};
          while (++index < length) {
            var pair = pairs[index];
            result2[pair[0]] = pair[1];
          }
          return result2;
        }
        function head(array) {
          return array && array.length ? array[0] : undefined2;
        }
        function indexOf(array, value, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = fromIndex == null ? 0 : toInteger(fromIndex);
          if (index < 0) {
            index = nativeMax(length + index, 0);
          }
          return baseIndexOf(array, value, index);
        }
        function initial(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseSlice(array, 0, -1) : [];
        }
        var intersection = baseRest(function(arrays) {
          var mapped = arrayMap(arrays, castArrayLikeObject);
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped) : [];
        });
        var intersectionBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
          if (iteratee2 === last(mapped)) {
            iteratee2 = undefined2;
          } else {
            mapped.pop();
          }
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, getIteratee(iteratee2, 2)) : [];
        });
        var intersectionWith = baseRest(function(arrays) {
          var comparator = last(arrays), mapped = arrayMap(arrays, castArrayLikeObject);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          if (comparator) {
            mapped.pop();
          }
          return mapped.length && mapped[0] === arrays[0] ? baseIntersection(mapped, undefined2, comparator) : [];
        });
        function join(array, separator) {
          return array == null ? "" : nativeJoin.call(array, separator);
        }
        function last(array) {
          var length = array == null ? 0 : array.length;
          return length ? array[length - 1] : undefined2;
        }
        function lastIndexOf(array, value, fromIndex) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return -1;
          }
          var index = length;
          if (fromIndex !== undefined2) {
            index = toInteger(fromIndex);
            index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
          }
          return value === value ? strictLastIndexOf(array, value, index) : baseFindIndex(array, baseIsNaN, index, true);
        }
        function nth(array, n) {
          return array && array.length ? baseNth(array, toInteger(n)) : undefined2;
        }
        var pull = baseRest(pullAll);
        function pullAll(array, values2) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2) : array;
        }
        function pullAllBy(array, values2, iteratee2) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2, getIteratee(iteratee2, 2)) : array;
        }
        function pullAllWith(array, values2, comparator) {
          return array && array.length && values2 && values2.length ? basePullAll(array, values2, undefined2, comparator) : array;
        }
        var pullAt = flatRest(function(array, indexes) {
          var length = array == null ? 0 : array.length, result2 = baseAt(array, indexes);
          basePullAt(array, arrayMap(indexes, function(index) {
            return isIndex(index, length) ? +index : index;
          }).sort(compareAscending));
          return result2;
        });
        function remove(array, predicate) {
          var result2 = [];
          if (!(array && array.length)) {
            return result2;
          }
          var index = -1, indexes = [], length = array.length;
          predicate = getIteratee(predicate, 3);
          while (++index < length) {
            var value = array[index];
            if (predicate(value, index, array)) {
              result2.push(value);
              indexes.push(index);
            }
          }
          basePullAt(array, indexes);
          return result2;
        }
        function reverse(array) {
          return array == null ? array : nativeReverse.call(array);
        }
        function slice(array, start, end) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          if (end && typeof end != "number" && isIterateeCall(array, start, end)) {
            start = 0;
            end = length;
          } else {
            start = start == null ? 0 : toInteger(start);
            end = end === undefined2 ? length : toInteger(end);
          }
          return baseSlice(array, start, end);
        }
        function sortedIndex(array, value) {
          return baseSortedIndex(array, value);
        }
        function sortedIndexBy(array, value, iteratee2) {
          return baseSortedIndexBy(array, value, getIteratee(iteratee2, 2));
        }
        function sortedIndexOf(array, value) {
          var length = array == null ? 0 : array.length;
          if (length) {
            var index = baseSortedIndex(array, value);
            if (index < length && eq(array[index], value)) {
              return index;
            }
          }
          return -1;
        }
        function sortedLastIndex(array, value) {
          return baseSortedIndex(array, value, true);
        }
        function sortedLastIndexBy(array, value, iteratee2) {
          return baseSortedIndexBy(array, value, getIteratee(iteratee2, 2), true);
        }
        function sortedLastIndexOf(array, value) {
          var length = array == null ? 0 : array.length;
          if (length) {
            var index = baseSortedIndex(array, value, true) - 1;
            if (eq(array[index], value)) {
              return index;
            }
          }
          return -1;
        }
        function sortedUniq(array) {
          return array && array.length ? baseSortedUniq(array) : [];
        }
        function sortedUniqBy(array, iteratee2) {
          return array && array.length ? baseSortedUniq(array, getIteratee(iteratee2, 2)) : [];
        }
        function tail(array) {
          var length = array == null ? 0 : array.length;
          return length ? baseSlice(array, 1, length) : [];
        }
        function take(array, n, guard) {
          if (!(array && array.length)) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          return baseSlice(array, 0, n < 0 ? 0 : n);
        }
        function takeRight(array, n, guard) {
          var length = array == null ? 0 : array.length;
          if (!length) {
            return [];
          }
          n = guard || n === undefined2 ? 1 : toInteger(n);
          n = length - n;
          return baseSlice(array, n < 0 ? 0 : n, length);
        }
        function takeRightWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3), false, true) : [];
        }
        function takeWhile(array, predicate) {
          return array && array.length ? baseWhile(array, getIteratee(predicate, 3)) : [];
        }
        var union = baseRest(function(arrays) {
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
        });
        var unionBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee2, 2));
        });
        var unionWith = baseRest(function(arrays) {
          var comparator = last(arrays);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined2, comparator);
        });
        function uniq(array) {
          return array && array.length ? baseUniq(array) : [];
        }
        function uniqBy(array, iteratee2) {
          return array && array.length ? baseUniq(array, getIteratee(iteratee2, 2)) : [];
        }
        function uniqWith(array, comparator) {
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return array && array.length ? baseUniq(array, undefined2, comparator) : [];
        }
        function unzip(array) {
          if (!(array && array.length)) {
            return [];
          }
          var length = 0;
          array = arrayFilter(array, function(group) {
            if (isArrayLikeObject(group)) {
              length = nativeMax(group.length, length);
              return true;
            }
          });
          return baseTimes(length, function(index) {
            return arrayMap(array, baseProperty(index));
          });
        }
        function unzipWith(array, iteratee2) {
          if (!(array && array.length)) {
            return [];
          }
          var result2 = unzip(array);
          if (iteratee2 == null) {
            return result2;
          }
          return arrayMap(result2, function(group) {
            return apply(iteratee2, undefined2, group);
          });
        }
        var without = baseRest(function(array, values2) {
          return isArrayLikeObject(array) ? baseDifference(array, values2) : [];
        });
        var xor = baseRest(function(arrays) {
          return baseXor(arrayFilter(arrays, isArrayLikeObject));
        });
        var xorBy = baseRest(function(arrays) {
          var iteratee2 = last(arrays);
          if (isArrayLikeObject(iteratee2)) {
            iteratee2 = undefined2;
          }
          return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee2, 2));
        });
        var xorWith = baseRest(function(arrays) {
          var comparator = last(arrays);
          comparator = typeof comparator == "function" ? comparator : undefined2;
          return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined2, comparator);
        });
        var zip = baseRest(unzip);
        function zipObject(props, values2) {
          return baseZipObject(props || [], values2 || [], assignValue);
        }
        function zipObjectDeep(props, values2) {
          return baseZipObject(props || [], values2 || [], baseSet);
        }
        var zipWith = baseRest(function(arrays) {
          var length = arrays.length, iteratee2 = length > 1 ? arrays[length - 1] : undefined2;
          iteratee2 = typeof iteratee2 == "function" ? (arrays.pop(), iteratee2) : undefined2;
          return unzipWith(arrays, iteratee2);
        });
        function chain(value) {
          var result2 = lodash(value);
          result2.__chain__ = true;
          return result2;
        }
        function tap(value, interceptor) {
          interceptor(value);
          return value;
        }
        function thru(value, interceptor) {
          return interceptor(value);
        }
        var wrapperAt = flatRest(function(paths) {
          var length = paths.length, start = length ? paths[0] : 0, value = this.__wrapped__, interceptor = function(object) {
            return baseAt(object, paths);
          };
          if (length > 1 || this.__actions__.length || !(value instanceof LazyWrapper) || !isIndex(start)) {
            return this.thru(interceptor);
          }
          value = value.slice(start, +start + (length ? 1 : 0));
          value.__actions__.push({
            "func": thru,
            "args": [interceptor],
            "thisArg": undefined2
          });
          return new LodashWrapper(value, this.__chain__).thru(function(array) {
            if (length && !array.length) {
              array.push(undefined2);
            }
            return array;
          });
        });
        function wrapperChain() {
          return chain(this);
        }
        function wrapperCommit() {
          return new LodashWrapper(this.value(), this.__chain__);
        }
        function wrapperNext() {
          if (this.__values__ === undefined2) {
            this.__values__ = toArray(this.value());
          }
          var done = this.__index__ >= this.__values__.length, value = done ? undefined2 : this.__values__[this.__index__++];
          return { "done": done, "value": value };
        }
        function wrapperToIterator() {
          return this;
        }
        function wrapperPlant(value) {
          var result2, parent2 = this;
          while (parent2 instanceof baseLodash) {
            var clone4 = wrapperClone(parent2);
            clone4.__index__ = 0;
            clone4.__values__ = undefined2;
            if (result2) {
              previous.__wrapped__ = clone4;
            } else {
              result2 = clone4;
            }
            var previous = clone4;
            parent2 = parent2.__wrapped__;
          }
          previous.__wrapped__ = value;
          return result2;
        }
        function wrapperReverse() {
          var value = this.__wrapped__;
          if (value instanceof LazyWrapper) {
            var wrapped = value;
            if (this.__actions__.length) {
              wrapped = new LazyWrapper(this);
            }
            wrapped = wrapped.reverse();
            wrapped.__actions__.push({
              "func": thru,
              "args": [reverse],
              "thisArg": undefined2
            });
            return new LodashWrapper(wrapped, this.__chain__);
          }
          return this.thru(reverse);
        }
        function wrapperValue() {
          return baseWrapperValue(this.__wrapped__, this.__actions__);
        }
        var countBy = createAggregator(function(result2, value, key) {
          if (hasOwnProperty.call(result2, key)) {
            ++result2[key];
          } else {
            baseAssignValue(result2, key, 1);
          }
        });
        function every(collection, predicate, guard) {
          var func = isArray2(collection) ? arrayEvery : baseEvery;
          if (guard && isIterateeCall(collection, predicate, guard)) {
            predicate = undefined2;
          }
          return func(collection, getIteratee(predicate, 3));
        }
        function filter(collection, predicate) {
          var func = isArray2(collection) ? arrayFilter : baseFilter;
          return func(collection, getIteratee(predicate, 3));
        }
        var find2 = createFind(findIndex);
        var findLast = createFind(findLastIndex);
        function flatMap(collection, iteratee2) {
          return baseFlatten(map(collection, iteratee2), 1);
        }
        function flatMapDeep(collection, iteratee2) {
          return baseFlatten(map(collection, iteratee2), INFINITY);
        }
        function flatMapDepth(collection, iteratee2, depth) {
          depth = depth === undefined2 ? 1 : toInteger(depth);
          return baseFlatten(map(collection, iteratee2), depth);
        }
        function forEach(collection, iteratee2) {
          var func = isArray2(collection) ? arrayEach : baseEach;
          return func(collection, getIteratee(iteratee2, 3));
        }
        function forEachRight(collection, iteratee2) {
          var func = isArray2(collection) ? arrayEachRight : baseEachRight;
          return func(collection, getIteratee(iteratee2, 3));
        }
        var groupBy = createAggregator(function(result2, value, key) {
          if (hasOwnProperty.call(result2, key)) {
            result2[key].push(value);
          } else {
            baseAssignValue(result2, key, [value]);
          }
        });
        function includes(collection, value, fromIndex, guard) {
          collection = isArrayLike(collection) ? collection : values(collection);
          fromIndex = fromIndex && !guard ? toInteger(fromIndex) : 0;
          var length = collection.length;
          if (fromIndex < 0) {
            fromIndex = nativeMax(length + fromIndex, 0);
          }
          return isString(collection) ? fromIndex <= length && collection.indexOf(value, fromIndex) > -1 : !!length && baseIndexOf(collection, value, fromIndex) > -1;
        }
        var invokeMap = baseRest(function(collection, path4, args) {
          var index = -1, isFunc = typeof path4 == "function", result2 = isArrayLike(collection) ? Array2(collection.length) : [];
          baseEach(collection, function(value) {
            result2[++index] = isFunc ? apply(path4, value, args) : baseInvoke(value, path4, args);
          });
          return result2;
        });
        var keyBy = createAggregator(function(result2, value, key) {
          baseAssignValue(result2, key, value);
        });
        function map(collection, iteratee2) {
          var func = isArray2(collection) ? arrayMap : baseMap;
          return func(collection, getIteratee(iteratee2, 3));
        }
        function orderBy(collection, iteratees, orders, guard) {
          if (collection == null) {
            return [];
          }
          if (!isArray2(iteratees)) {
            iteratees = iteratees == null ? [] : [iteratees];
          }
          orders = guard ? undefined2 : orders;
          if (!isArray2(orders)) {
            orders = orders == null ? [] : [orders];
          }
          return baseOrderBy(collection, iteratees, orders);
        }
        var partition = createAggregator(function(result2, value, key) {
          result2[key ? 0 : 1].push(value);
        }, function() {
          return [[], []];
        });
        function reduce(collection, iteratee2, accumulator) {
          var func = isArray2(collection) ? arrayReduce : baseReduce, initAccum = arguments.length < 3;
          return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEach);
        }
        function reduceRight(collection, iteratee2, accumulator) {
          var func = isArray2(collection) ? arrayReduceRight : baseReduce, initAccum = arguments.length < 3;
          return func(collection, getIteratee(iteratee2, 4), accumulator, initAccum, baseEachRight);
        }
        function reject(collection, predicate) {
          var func = isArray2(collection) ? arrayFilter : baseFilter;
          return func(collection, negate(getIteratee(predicate, 3)));
        }
        function sample(collection) {
          var func = isArray2(collection) ? arraySample : baseSample;
          return func(collection);
        }
        function sampleSize(collection, n, guard) {
          if (guard ? isIterateeCall(collection, n, guard) : n === undefined2) {
            n = 1;
          } else {
            n = toInteger(n);
          }
          var func = isArray2(collection) ? arraySampleSize : baseSampleSize;
          return func(collection, n);
        }
        function shuffle(collection) {
          var func = isArray2(collection) ? arrayShuffle : baseShuffle;
          return func(collection);
        }
        function size(collection) {
          if (collection == null) {
            return 0;
          }
          if (isArrayLike(collection)) {
            return isString(collection) ? stringSize(collection) : collection.length;
          }
          var tag = getTag(collection);
          if (tag == mapTag || tag == setTag) {
            return collection.size;
          }
          return baseKeys(collection).length;
        }
        function some(collection, predicate, guard) {
          var func = isArray2(collection) ? arraySome : baseSome;
          if (guard && isIterateeCall(collection, predicate, guard)) {
            predicate = undefined2;
          }
          return func(collection, getIteratee(predicate, 3));
        }
        var sortBy = baseRest(function(collection, iteratees) {
          if (collection == null) {
            return [];
          }
          var length = iteratees.length;
          if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
            iteratees = [];
          } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
            iteratees = [iteratees[0]];
          }
          return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
        });
        var now = ctxNow || function() {
          return root.Date.now();
        };
        function after(n, func) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          n = toInteger(n);
          return function() {
            if (--n < 1) {
              return func.apply(this, arguments);
            }
          };
        }
        function ary(func, n, guard) {
          n = guard ? undefined2 : n;
          n = func && n == null ? func.length : n;
          return createWrap(func, WRAP_ARY_FLAG, undefined2, undefined2, undefined2, undefined2, n);
        }
        function before(n, func) {
          var result2;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          n = toInteger(n);
          return function() {
            if (--n > 0) {
              result2 = func.apply(this, arguments);
            }
            if (n <= 1) {
              func = undefined2;
            }
            return result2;
          };
        }
        var bind = baseRest(function(func, thisArg, partials) {
          var bitmask = WRAP_BIND_FLAG;
          if (partials.length) {
            var holders = replaceHolders(partials, getHolder(bind));
            bitmask |= WRAP_PARTIAL_FLAG;
          }
          return createWrap(func, bitmask, thisArg, partials, holders);
        });
        var bindKey = baseRest(function(object, key, partials) {
          var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
          if (partials.length) {
            var holders = replaceHolders(partials, getHolder(bindKey));
            bitmask |= WRAP_PARTIAL_FLAG;
          }
          return createWrap(key, bitmask, object, partials, holders);
        });
        function curry(func, arity, guard) {
          arity = guard ? undefined2 : arity;
          var result2 = createWrap(func, WRAP_CURRY_FLAG, undefined2, undefined2, undefined2, undefined2, undefined2, arity);
          result2.placeholder = curry.placeholder;
          return result2;
        }
        function curryRight(func, arity, guard) {
          arity = guard ? undefined2 : arity;
          var result2 = createWrap(func, WRAP_CURRY_RIGHT_FLAG, undefined2, undefined2, undefined2, undefined2, undefined2, arity);
          result2.placeholder = curryRight.placeholder;
          return result2;
        }
        function debounce(func, wait, options) {
          var lastArgs, lastThis, maxWait, result2, timerId, lastCallTime, lastInvokeTime = 0, leading = false, maxing = false, trailing = true;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          wait = toNumber(wait) || 0;
          if (isObject3(options)) {
            leading = !!options.leading;
            maxing = "maxWait" in options;
            maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
            trailing = "trailing" in options ? !!options.trailing : trailing;
          }
          function invokeFunc(time) {
            var args = lastArgs, thisArg = lastThis;
            lastArgs = lastThis = undefined2;
            lastInvokeTime = time;
            result2 = func.apply(thisArg, args);
            return result2;
          }
          function leadingEdge(time) {
            lastInvokeTime = time;
            timerId = setTimeout2(timerExpired, wait);
            return leading ? invokeFunc(time) : result2;
          }
          function remainingWait(time) {
            var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime, timeWaiting = wait - timeSinceLastCall;
            return maxing ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke) : timeWaiting;
          }
          function shouldInvoke(time) {
            var timeSinceLastCall = time - lastCallTime, timeSinceLastInvoke = time - lastInvokeTime;
            return lastCallTime === undefined2 || timeSinceLastCall >= wait || timeSinceLastCall < 0 || maxing && timeSinceLastInvoke >= maxWait;
          }
          function timerExpired() {
            var time = now();
            if (shouldInvoke(time)) {
              return trailingEdge(time);
            }
            timerId = setTimeout2(timerExpired, remainingWait(time));
          }
          function trailingEdge(time) {
            timerId = undefined2;
            if (trailing && lastArgs) {
              return invokeFunc(time);
            }
            lastArgs = lastThis = undefined2;
            return result2;
          }
          function cancel() {
            if (timerId !== undefined2) {
              clearTimeout2(timerId);
            }
            lastInvokeTime = 0;
            lastArgs = lastCallTime = lastThis = timerId = undefined2;
          }
          function flush() {
            return timerId === undefined2 ? result2 : trailingEdge(now());
          }
          function debounced() {
            var time = now(), isInvoking = shouldInvoke(time);
            lastArgs = arguments;
            lastThis = this;
            lastCallTime = time;
            if (isInvoking) {
              if (timerId === undefined2) {
                return leadingEdge(lastCallTime);
              }
              if (maxing) {
                clearTimeout2(timerId);
                timerId = setTimeout2(timerExpired, wait);
                return invokeFunc(lastCallTime);
              }
            }
            if (timerId === undefined2) {
              timerId = setTimeout2(timerExpired, wait);
            }
            return result2;
          }
          debounced.cancel = cancel;
          debounced.flush = flush;
          return debounced;
        }
        var defer = baseRest(function(func, args) {
          return baseDelay(func, 1, args);
        });
        var delay = baseRest(function(func, wait, args) {
          return baseDelay(func, toNumber(wait) || 0, args);
        });
        function flip(func) {
          return createWrap(func, WRAP_FLIP_FLAG);
        }
        function memoize(func, resolver) {
          if (typeof func != "function" || resolver != null && typeof resolver != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          var memoized = function() {
            var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
            if (cache.has(key)) {
              return cache.get(key);
            }
            var result2 = func.apply(this, args);
            memoized.cache = cache.set(key, result2) || cache;
            return result2;
          };
          memoized.cache = new (memoize.Cache || MapCache)();
          return memoized;
        }
        memoize.Cache = MapCache;
        function negate(predicate) {
          if (typeof predicate != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          return function() {
            var args = arguments;
            switch (args.length) {
              case 0:
                return !predicate.call(this);
              case 1:
                return !predicate.call(this, args[0]);
              case 2:
                return !predicate.call(this, args[0], args[1]);
              case 3:
                return !predicate.call(this, args[0], args[1], args[2]);
            }
            return !predicate.apply(this, args);
          };
        }
        function once2(func) {
          return before(2, func);
        }
        var overArgs = castRest(function(func, transforms) {
          transforms = transforms.length == 1 && isArray2(transforms[0]) ? arrayMap(transforms[0], baseUnary(getIteratee())) : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));
          var funcsLength = transforms.length;
          return baseRest(function(args) {
            var index = -1, length = nativeMin(args.length, funcsLength);
            while (++index < length) {
              args[index] = transforms[index].call(this, args[index]);
            }
            return apply(func, this, args);
          });
        });
        var partial = baseRest(function(func, partials) {
          var holders = replaceHolders(partials, getHolder(partial));
          return createWrap(func, WRAP_PARTIAL_FLAG, undefined2, partials, holders);
        });
        var partialRight = baseRest(function(func, partials) {
          var holders = replaceHolders(partials, getHolder(partialRight));
          return createWrap(func, WRAP_PARTIAL_RIGHT_FLAG, undefined2, partials, holders);
        });
        var rearg = flatRest(function(func, indexes) {
          return createWrap(func, WRAP_REARG_FLAG, undefined2, undefined2, undefined2, indexes);
        });
        function rest(func, start) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          start = start === undefined2 ? start : toInteger(start);
          return baseRest(func, start);
        }
        function spread(func, start) {
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          start = start == null ? 0 : nativeMax(toInteger(start), 0);
          return baseRest(function(args) {
            var array = args[start], otherArgs = castSlice(args, 0, start);
            if (array) {
              arrayPush(otherArgs, array);
            }
            return apply(func, this, otherArgs);
          });
        }
        function throttle(func, wait, options) {
          var leading = true, trailing = true;
          if (typeof func != "function") {
            throw new TypeError2(FUNC_ERROR_TEXT);
          }
          if (isObject3(options)) {
            leading = "leading" in options ? !!options.leading : leading;
            trailing = "trailing" in options ? !!options.trailing : trailing;
          }
          return debounce(func, wait, {
            "leading": leading,
            "maxWait": wait,
            "trailing": trailing
          });
        }
        function unary(func) {
          return ary(func, 1);
        }
        function wrap(value, wrapper) {
          return partial(castFunction(wrapper), value);
        }
        function castArray() {
          if (!arguments.length) {
            return [];
          }
          var value = arguments[0];
          return isArray2(value) ? value : [value];
        }
        function clone3(value) {
          return baseClone(value, CLONE_SYMBOLS_FLAG);
        }
        function cloneWith(value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
        }
        function cloneDeep(value) {
          return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
        }
        function cloneDeepWith(value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
        }
        function conformsTo(object, source) {
          return source == null || baseConformsTo(object, source, keys(source));
        }
        function eq(value, other) {
          return value === other || value !== value && other !== other;
        }
        var gt = createRelationalOperation(baseGt);
        var gte = createRelationalOperation(function(value, other) {
          return value >= other;
        });
        var isArguments = baseIsArguments(function() {
          return arguments;
        }()) ? baseIsArguments : function(value) {
          return isObjectLike(value) && hasOwnProperty.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
        };
        var isArray2 = Array2.isArray;
        var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;
        function isArrayLike(value) {
          return value != null && isLength(value.length) && !isFunction(value);
        }
        function isArrayLikeObject(value) {
          return isObjectLike(value) && isArrayLike(value);
        }
        function isBoolean(value) {
          return value === true || value === false || isObjectLike(value) && baseGetTag(value) == boolTag;
        }
        var isBuffer = nativeIsBuffer || stubFalse;
        var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;
        function isElement(value) {
          return isObjectLike(value) && value.nodeType === 1 && !isPlainObject3(value);
        }
        function isEmpty(value) {
          if (value == null) {
            return true;
          }
          if (isArrayLike(value) && (isArray2(value) || typeof value == "string" || typeof value.splice == "function" || isBuffer(value) || isTypedArray(value) || isArguments(value))) {
            return !value.length;
          }
          var tag = getTag(value);
          if (tag == mapTag || tag == setTag) {
            return !value.size;
          }
          if (isPrototype(value)) {
            return !baseKeys(value).length;
          }
          for (var key in value) {
            if (hasOwnProperty.call(value, key)) {
              return false;
            }
          }
          return true;
        }
        function isEqual(value, other) {
          return baseIsEqual(value, other);
        }
        function isEqualWith(value, other, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          var result2 = customizer ? customizer(value, other) : undefined2;
          return result2 === undefined2 ? baseIsEqual(value, other, undefined2, customizer) : !!result2;
        }
        function isError(value) {
          if (!isObjectLike(value)) {
            return false;
          }
          var tag = baseGetTag(value);
          return tag == errorTag || tag == domExcTag || typeof value.message == "string" && typeof value.name == "string" && !isPlainObject3(value);
        }
        function isFinite2(value) {
          return typeof value == "number" && nativeIsFinite(value);
        }
        function isFunction(value) {
          if (!isObject3(value)) {
            return false;
          }
          var tag = baseGetTag(value);
          return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
        }
        function isInteger(value) {
          return typeof value == "number" && value == toInteger(value);
        }
        function isLength(value) {
          return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
        }
        function isObject3(value) {
          var type = typeof value;
          return value != null && (type == "object" || type == "function");
        }
        function isObjectLike(value) {
          return value != null && typeof value == "object";
        }
        var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;
        function isMatch(object, source) {
          return object === source || baseIsMatch(object, source, getMatchData(source));
        }
        function isMatchWith(object, source, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return baseIsMatch(object, source, getMatchData(source), customizer);
        }
        function isNaN2(value) {
          return isNumber(value) && value != +value;
        }
        function isNative(value) {
          if (isMaskable(value)) {
            throw new Error2(CORE_ERROR_TEXT);
          }
          return baseIsNative(value);
        }
        function isNull(value) {
          return value === null;
        }
        function isNil(value) {
          return value == null;
        }
        function isNumber(value) {
          return typeof value == "number" || isObjectLike(value) && baseGetTag(value) == numberTag;
        }
        function isPlainObject3(value) {
          if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
            return false;
          }
          var proto = getPrototype(value);
          if (proto === null) {
            return true;
          }
          var Ctor = hasOwnProperty.call(proto, "constructor") && proto.constructor;
          return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString.call(Ctor) == objectCtorString;
        }
        var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;
        function isSafeInteger(value) {
          return isInteger(value) && value >= -MAX_SAFE_INTEGER && value <= MAX_SAFE_INTEGER;
        }
        var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;
        function isString(value) {
          return typeof value == "string" || !isArray2(value) && isObjectLike(value) && baseGetTag(value) == stringTag;
        }
        function isSymbol(value) {
          return typeof value == "symbol" || isObjectLike(value) && baseGetTag(value) == symbolTag;
        }
        var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
        function isUndefined(value) {
          return value === undefined2;
        }
        function isWeakMap(value) {
          return isObjectLike(value) && getTag(value) == weakMapTag;
        }
        function isWeakSet(value) {
          return isObjectLike(value) && baseGetTag(value) == weakSetTag;
        }
        var lt = createRelationalOperation(baseLt);
        var lte = createRelationalOperation(function(value, other) {
          return value <= other;
        });
        function toArray(value) {
          if (!value) {
            return [];
          }
          if (isArrayLike(value)) {
            return isString(value) ? stringToArray(value) : copyArray(value);
          }
          if (symIterator && value[symIterator]) {
            return iteratorToArray(value[symIterator]());
          }
          var tag = getTag(value), func = tag == mapTag ? mapToArray : tag == setTag ? setToArray : values;
          return func(value);
        }
        function toFinite(value) {
          if (!value) {
            return value === 0 ? value : 0;
          }
          value = toNumber(value);
          if (value === INFINITY || value === -INFINITY) {
            var sign = value < 0 ? -1 : 1;
            return sign * MAX_INTEGER;
          }
          return value === value ? value : 0;
        }
        function toInteger(value) {
          var result2 = toFinite(value), remainder = result2 % 1;
          return result2 === result2 ? remainder ? result2 - remainder : result2 : 0;
        }
        function toLength(value) {
          return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
        }
        function toNumber(value) {
          if (typeof value == "number") {
            return value;
          }
          if (isSymbol(value)) {
            return NAN;
          }
          if (isObject3(value)) {
            var other = typeof value.valueOf == "function" ? value.valueOf() : value;
            value = isObject3(other) ? other + "" : other;
          }
          if (typeof value != "string") {
            return value === 0 ? value : +value;
          }
          value = baseTrim(value);
          var isBinary = reIsBinary.test(value);
          return isBinary || reIsOctal.test(value) ? freeParseInt(value.slice(2), isBinary ? 2 : 8) : reIsBadHex.test(value) ? NAN : +value;
        }
        function toPlainObject(value) {
          return copyObject(value, keysIn(value));
        }
        function toSafeInteger(value) {
          return value ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER) : value === 0 ? value : 0;
        }
        function toString(value) {
          return value == null ? "" : baseToString(value);
        }
        var assign = createAssigner(function(object, source) {
          if (isPrototype(source) || isArrayLike(source)) {
            copyObject(source, keys(source), object);
            return;
          }
          for (var key in source) {
            if (hasOwnProperty.call(source, key)) {
              assignValue(object, key, source[key]);
            }
          }
        });
        var assignIn = createAssigner(function(object, source) {
          copyObject(source, keysIn(source), object);
        });
        var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
          copyObject(source, keysIn(source), object, customizer);
        });
        var assignWith = createAssigner(function(object, source, srcIndex, customizer) {
          copyObject(source, keys(source), object, customizer);
        });
        var at = flatRest(baseAt);
        function create(prototype, properties) {
          var result2 = baseCreate(prototype);
          return properties == null ? result2 : baseAssign(result2, properties);
        }
        var defaults = baseRest(function(object, sources) {
          object = Object2(object);
          var index = -1;
          var length = sources.length;
          var guard = length > 2 ? sources[2] : undefined2;
          if (guard && isIterateeCall(sources[0], sources[1], guard)) {
            length = 1;
          }
          while (++index < length) {
            var source = sources[index];
            var props = keysIn(source);
            var propsIndex = -1;
            var propsLength = props.length;
            while (++propsIndex < propsLength) {
              var key = props[propsIndex];
              var value = object[key];
              if (value === undefined2 || eq(value, objectProto[key]) && !hasOwnProperty.call(object, key)) {
                object[key] = source[key];
              }
            }
          }
          return object;
        });
        var defaultsDeep = baseRest(function(args) {
          args.push(undefined2, customDefaultsMerge);
          return apply(mergeWith, undefined2, args);
        });
        function findKey(object, predicate) {
          return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);
        }
        function findLastKey(object, predicate) {
          return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);
        }
        function forIn(object, iteratee2) {
          return object == null ? object : baseFor(object, getIteratee(iteratee2, 3), keysIn);
        }
        function forInRight(object, iteratee2) {
          return object == null ? object : baseForRight(object, getIteratee(iteratee2, 3), keysIn);
        }
        function forOwn(object, iteratee2) {
          return object && baseForOwn(object, getIteratee(iteratee2, 3));
        }
        function forOwnRight(object, iteratee2) {
          return object && baseForOwnRight(object, getIteratee(iteratee2, 3));
        }
        function functions(object) {
          return object == null ? [] : baseFunctions(object, keys(object));
        }
        function functionsIn(object) {
          return object == null ? [] : baseFunctions(object, keysIn(object));
        }
        function get(object, path4, defaultValue) {
          var result2 = object == null ? undefined2 : baseGet(object, path4);
          return result2 === undefined2 ? defaultValue : result2;
        }
        function has(object, path4) {
          return object != null && hasPath(object, path4, baseHas);
        }
        function hasIn(object, path4) {
          return object != null && hasPath(object, path4, baseHasIn);
        }
        var invert = createInverter(function(result2, value, key) {
          if (value != null && typeof value.toString != "function") {
            value = nativeObjectToString.call(value);
          }
          result2[value] = key;
        }, constant(identity));
        var invertBy = createInverter(function(result2, value, key) {
          if (value != null && typeof value.toString != "function") {
            value = nativeObjectToString.call(value);
          }
          if (hasOwnProperty.call(result2, value)) {
            result2[value].push(key);
          } else {
            result2[value] = [key];
          }
        }, getIteratee);
        var invoke = baseRest(baseInvoke);
        function keys(object) {
          return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
        }
        function keysIn(object) {
          return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
        }
        function mapKeys(object, iteratee2) {
          var result2 = {};
          iteratee2 = getIteratee(iteratee2, 3);
          baseForOwn(object, function(value, key, object2) {
            baseAssignValue(result2, iteratee2(value, key, object2), value);
          });
          return result2;
        }
        function mapValues(object, iteratee2) {
          var result2 = {};
          iteratee2 = getIteratee(iteratee2, 3);
          baseForOwn(object, function(value, key, object2) {
            baseAssignValue(result2, key, iteratee2(value, key, object2));
          });
          return result2;
        }
        var merge2 = createAssigner(function(object, source, srcIndex) {
          baseMerge(object, source, srcIndex);
        });
        var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {
          baseMerge(object, source, srcIndex, customizer);
        });
        var omit2 = flatRest(function(object, paths) {
          var result2 = {};
          if (object == null) {
            return result2;
          }
          var isDeep = false;
          paths = arrayMap(paths, function(path4) {
            path4 = castPath(path4, object);
            isDeep || (isDeep = path4.length > 1);
            return path4;
          });
          copyObject(object, getAllKeysIn(object), result2);
          if (isDeep) {
            result2 = baseClone(result2, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
          }
          var length = paths.length;
          while (length--) {
            baseUnset(result2, paths[length]);
          }
          return result2;
        });
        function omitBy(object, predicate) {
          return pickBy(object, negate(getIteratee(predicate)));
        }
        var pick = flatRest(function(object, paths) {
          return object == null ? {} : basePick(object, paths);
        });
        function pickBy(object, predicate) {
          if (object == null) {
            return {};
          }
          var props = arrayMap(getAllKeysIn(object), function(prop) {
            return [prop];
          });
          predicate = getIteratee(predicate);
          return basePickBy(object, props, function(value, path4) {
            return predicate(value, path4[0]);
          });
        }
        function result(object, path4, defaultValue) {
          path4 = castPath(path4, object);
          var index = -1, length = path4.length;
          if (!length) {
            length = 1;
            object = undefined2;
          }
          while (++index < length) {
            var value = object == null ? undefined2 : object[toKey(path4[index])];
            if (value === undefined2) {
              index = length;
              value = defaultValue;
            }
            object = isFunction(value) ? value.call(object) : value;
          }
          return object;
        }
        function set(object, path4, value) {
          return object == null ? object : baseSet(object, path4, value);
        }
        function setWith(object, path4, value, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return object == null ? object : baseSet(object, path4, value, customizer);
        }
        var toPairs = createToPairs(keys);
        var toPairsIn = createToPairs(keysIn);
        function transform(object, iteratee2, accumulator) {
          var isArr = isArray2(object), isArrLike = isArr || isBuffer(object) || isTypedArray(object);
          iteratee2 = getIteratee(iteratee2, 4);
          if (accumulator == null) {
            var Ctor = object && object.constructor;
            if (isArrLike) {
              accumulator = isArr ? new Ctor() : [];
            } else if (isObject3(object)) {
              accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};
            } else {
              accumulator = {};
            }
          }
          (isArrLike ? arrayEach : baseForOwn)(object, function(value, index, object2) {
            return iteratee2(accumulator, value, index, object2);
          });
          return accumulator;
        }
        function unset(object, path4) {
          return object == null ? true : baseUnset(object, path4);
        }
        function update(object, path4, updater) {
          return object == null ? object : baseUpdate(object, path4, castFunction(updater));
        }
        function updateWith(object, path4, updater, customizer) {
          customizer = typeof customizer == "function" ? customizer : undefined2;
          return object == null ? object : baseUpdate(object, path4, castFunction(updater), customizer);
        }
        function values(object) {
          return object == null ? [] : baseValues(object, keys(object));
        }
        function valuesIn(object) {
          return object == null ? [] : baseValues(object, keysIn(object));
        }
        function clamp(number, lower2, upper) {
          if (upper === undefined2) {
            upper = lower2;
            lower2 = undefined2;
          }
          if (upper !== undefined2) {
            upper = toNumber(upper);
            upper = upper === upper ? upper : 0;
          }
          if (lower2 !== undefined2) {
            lower2 = toNumber(lower2);
            lower2 = lower2 === lower2 ? lower2 : 0;
          }
          return baseClamp(toNumber(number), lower2, upper);
        }
        function inRange(number, start, end) {
          start = toFinite(start);
          if (end === undefined2) {
            end = start;
            start = 0;
          } else {
            end = toFinite(end);
          }
          number = toNumber(number);
          return baseInRange(number, start, end);
        }
        function random(lower2, upper, floating) {
          if (floating && typeof floating != "boolean" && isIterateeCall(lower2, upper, floating)) {
            upper = floating = undefined2;
          }
          if (floating === undefined2) {
            if (typeof upper == "boolean") {
              floating = upper;
              upper = undefined2;
            } else if (typeof lower2 == "boolean") {
              floating = lower2;
              lower2 = undefined2;
            }
          }
          if (lower2 === undefined2 && upper === undefined2) {
            lower2 = 0;
            upper = 1;
          } else {
            lower2 = toFinite(lower2);
            if (upper === undefined2) {
              upper = lower2;
              lower2 = 0;
            } else {
              upper = toFinite(upper);
            }
          }
          if (lower2 > upper) {
            var temp = lower2;
            lower2 = upper;
            upper = temp;
          }
          if (floating || lower2 % 1 || upper % 1) {
            var rand = nativeRandom();
            return nativeMin(lower2 + rand * (upper - lower2 + freeParseFloat("1e-" + ((rand + "").length - 1))), upper);
          }
          return baseRandom(lower2, upper);
        }
        var camelCase = createCompounder(function(result2, word, index) {
          word = word.toLowerCase();
          return result2 + (index ? capitalize(word) : word);
        });
        function capitalize(string) {
          return upperFirst(toString(string).toLowerCase());
        }
        function deburr(string) {
          string = toString(string);
          return string && string.replace(reLatin, deburrLetter).replace(reComboMark, "");
        }
        function endsWith(string, target, position) {
          string = toString(string);
          target = baseToString(target);
          var length = string.length;
          position = position === undefined2 ? length : baseClamp(toInteger(position), 0, length);
          var end = position;
          position -= target.length;
          return position >= 0 && string.slice(position, end) == target;
        }
        function escape(string) {
          string = toString(string);
          return string && reHasUnescapedHtml.test(string) ? string.replace(reUnescapedHtml, escapeHtmlChar) : string;
        }
        function escapeRegExp(string) {
          string = toString(string);
          return string && reHasRegExpChar.test(string) ? string.replace(reRegExpChar, "\\$&") : string;
        }
        var kebabCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? "-" : "") + word.toLowerCase();
        });
        var lowerCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? " " : "") + word.toLowerCase();
        });
        var lowerFirst = createCaseFirst("toLowerCase");
        function pad(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          if (!length || strLength >= length) {
            return string;
          }
          var mid = (length - strLength) / 2;
          return createPadding(nativeFloor(mid), chars) + string + createPadding(nativeCeil(mid), chars);
        }
        function padEnd(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          return length && strLength < length ? string + createPadding(length - strLength, chars) : string;
        }
        function padStart(string, length, chars) {
          string = toString(string);
          length = toInteger(length);
          var strLength = length ? stringSize(string) : 0;
          return length && strLength < length ? createPadding(length - strLength, chars) + string : string;
        }
        function parseInt2(string, radix, guard) {
          if (guard || radix == null) {
            radix = 0;
          } else if (radix) {
            radix = +radix;
          }
          return nativeParseInt(toString(string).replace(reTrimStart, ""), radix || 0);
        }
        function repeat(string, n, guard) {
          if (guard ? isIterateeCall(string, n, guard) : n === undefined2) {
            n = 1;
          } else {
            n = toInteger(n);
          }
          return baseRepeat(toString(string), n);
        }
        function replace() {
          var args = arguments, string = toString(args[0]);
          return args.length < 3 ? string : string.replace(args[1], args[2]);
        }
        var snakeCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? "_" : "") + word.toLowerCase();
        });
        function split(string, separator, limit) {
          if (limit && typeof limit != "number" && isIterateeCall(string, separator, limit)) {
            separator = limit = undefined2;
          }
          limit = limit === undefined2 ? MAX_ARRAY_LENGTH : limit >>> 0;
          if (!limit) {
            return [];
          }
          string = toString(string);
          if (string && (typeof separator == "string" || separator != null && !isRegExp(separator))) {
            separator = baseToString(separator);
            if (!separator && hasUnicode(string)) {
              return castSlice(stringToArray(string), 0, limit);
            }
          }
          return string.split(separator, limit);
        }
        var startCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? " " : "") + upperFirst(word);
        });
        function startsWith(string, target, position) {
          string = toString(string);
          position = position == null ? 0 : baseClamp(toInteger(position), 0, string.length);
          target = baseToString(target);
          return string.slice(position, position + target.length) == target;
        }
        function template(string, options, guard) {
          var settings = lodash.templateSettings;
          if (guard && isIterateeCall(string, options, guard)) {
            options = undefined2;
          }
          string = toString(string);
          options = assignInWith({}, options, settings, customDefaultsAssignIn);
          var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn), importsKeys = keys(imports), importsValues = baseValues(imports, importsKeys);
          var isEscaping, isEvaluating, index = 0, interpolate = options.interpolate || reNoMatch, source = "__p += '";
          var reDelimiters = RegExp2(
            (options.escape || reNoMatch).source + "|" + interpolate.source + "|" + (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + "|" + (options.evaluate || reNoMatch).source + "|$",
            "g"
          );
          var sourceURL = "//# sourceURL=" + (hasOwnProperty.call(options, "sourceURL") ? (options.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++templateCounter + "]") + "\n";
          string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
            interpolateValue || (interpolateValue = esTemplateValue);
            source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);
            if (escapeValue) {
              isEscaping = true;
              source += "' +\n__e(" + escapeValue + ") +\n'";
            }
            if (evaluateValue) {
              isEvaluating = true;
              source += "';\n" + evaluateValue + ";\n__p += '";
            }
            if (interpolateValue) {
              source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
            }
            index = offset + match.length;
            return match;
          });
          source += "';\n";
          var variable = hasOwnProperty.call(options, "variable") && options.variable;
          if (!variable) {
            source = "with (obj) {\n" + source + "\n}\n";
          } else if (reForbiddenIdentifierChars.test(variable)) {
            throw new Error2(INVALID_TEMPL_VAR_ERROR_TEXT);
          }
          source = (isEvaluating ? source.replace(reEmptyStringLeading, "") : source).replace(reEmptyStringMiddle, "$1").replace(reEmptyStringTrailing, "$1;");
          source = "function(" + (variable || "obj") + ") {\n" + (variable ? "" : "obj || (obj = {});\n") + "var __t, __p = ''" + (isEscaping ? ", __e = _.escape" : "") + (isEvaluating ? ", __j = Array.prototype.join;\nfunction print() { __p += __j.call(arguments, '') }\n" : ";\n") + source + "return __p\n}";
          var result2 = attempt(function() {
            return Function2(importsKeys, sourceURL + "return " + source).apply(undefined2, importsValues);
          });
          result2.source = source;
          if (isError(result2)) {
            throw result2;
          }
          return result2;
        }
        function toLower(value) {
          return toString(value).toLowerCase();
        }
        function toUpper(value) {
          return toString(value).toUpperCase();
        }
        function trim(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return baseTrim(string);
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), chrSymbols = stringToArray(chars), start = charsStartIndex(strSymbols, chrSymbols), end = charsEndIndex(strSymbols, chrSymbols) + 1;
          return castSlice(strSymbols, start, end).join("");
        }
        function trimEnd(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return string.slice(0, trimmedEndIndex(string) + 1);
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;
          return castSlice(strSymbols, 0, end).join("");
        }
        function trimStart(string, chars, guard) {
          string = toString(string);
          if (string && (guard || chars === undefined2)) {
            return string.replace(reTrimStart, "");
          }
          if (!string || !(chars = baseToString(chars))) {
            return string;
          }
          var strSymbols = stringToArray(string), start = charsStartIndex(strSymbols, stringToArray(chars));
          return castSlice(strSymbols, start).join("");
        }
        function truncate(string, options) {
          var length = DEFAULT_TRUNC_LENGTH, omission = DEFAULT_TRUNC_OMISSION;
          if (isObject3(options)) {
            var separator = "separator" in options ? options.separator : separator;
            length = "length" in options ? toInteger(options.length) : length;
            omission = "omission" in options ? baseToString(options.omission) : omission;
          }
          string = toString(string);
          var strLength = string.length;
          if (hasUnicode(string)) {
            var strSymbols = stringToArray(string);
            strLength = strSymbols.length;
          }
          if (length >= strLength) {
            return string;
          }
          var end = length - stringSize(omission);
          if (end < 1) {
            return omission;
          }
          var result2 = strSymbols ? castSlice(strSymbols, 0, end).join("") : string.slice(0, end);
          if (separator === undefined2) {
            return result2 + omission;
          }
          if (strSymbols) {
            end += result2.length - end;
          }
          if (isRegExp(separator)) {
            if (string.slice(end).search(separator)) {
              var match, substring = result2;
              if (!separator.global) {
                separator = RegExp2(separator.source, toString(reFlags.exec(separator)) + "g");
              }
              separator.lastIndex = 0;
              while (match = separator.exec(substring)) {
                var newEnd = match.index;
              }
              result2 = result2.slice(0, newEnd === undefined2 ? end : newEnd);
            }
          } else if (string.indexOf(baseToString(separator), end) != end) {
            var index = result2.lastIndexOf(separator);
            if (index > -1) {
              result2 = result2.slice(0, index);
            }
          }
          return result2 + omission;
        }
        function unescape2(string) {
          string = toString(string);
          return string && reHasEscapedHtml.test(string) ? string.replace(reEscapedHtml, unescapeHtmlChar) : string;
        }
        var upperCase = createCompounder(function(result2, word, index) {
          return result2 + (index ? " " : "") + word.toUpperCase();
        });
        var upperFirst = createCaseFirst("toUpperCase");
        function words(string, pattern, guard) {
          string = toString(string);
          pattern = guard ? undefined2 : pattern;
          if (pattern === undefined2) {
            return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
          }
          return string.match(pattern) || [];
        }
        var attempt = baseRest(function(func, args) {
          try {
            return apply(func, undefined2, args);
          } catch (e2) {
            return isError(e2) ? e2 : new Error2(e2);
          }
        });
        var bindAll = flatRest(function(object, methodNames) {
          arrayEach(methodNames, function(key) {
            key = toKey(key);
            baseAssignValue(object, key, bind(object[key], object));
          });
          return object;
        });
        function cond(pairs) {
          var length = pairs == null ? 0 : pairs.length, toIteratee = getIteratee();
          pairs = !length ? [] : arrayMap(pairs, function(pair) {
            if (typeof pair[1] != "function") {
              throw new TypeError2(FUNC_ERROR_TEXT);
            }
            return [toIteratee(pair[0]), pair[1]];
          });
          return baseRest(function(args) {
            var index = -1;
            while (++index < length) {
              var pair = pairs[index];
              if (apply(pair[0], this, args)) {
                return apply(pair[1], this, args);
              }
            }
          });
        }
        function conforms(source) {
          return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
        }
        function constant(value) {
          return function() {
            return value;
          };
        }
        function defaultTo(value, defaultValue) {
          return value == null || value !== value ? defaultValue : value;
        }
        var flow = createFlow();
        var flowRight = createFlow(true);
        function identity(value) {
          return value;
        }
        function iteratee(func) {
          return baseIteratee(typeof func == "function" ? func : baseClone(func, CLONE_DEEP_FLAG));
        }
        function matches(source) {
          return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
        }
        function matchesProperty(path4, srcValue) {
          return baseMatchesProperty(path4, baseClone(srcValue, CLONE_DEEP_FLAG));
        }
        var method = baseRest(function(path4, args) {
          return function(object) {
            return baseInvoke(object, path4, args);
          };
        });
        var methodOf = baseRest(function(object, args) {
          return function(path4) {
            return baseInvoke(object, path4, args);
          };
        });
        function mixin(object, source, options) {
          var props = keys(source), methodNames = baseFunctions(source, props);
          if (options == null && !(isObject3(source) && (methodNames.length || !props.length))) {
            options = source;
            source = object;
            object = this;
            methodNames = baseFunctions(source, keys(source));
          }
          var chain2 = !(isObject3(options) && "chain" in options) || !!options.chain, isFunc = isFunction(object);
          arrayEach(methodNames, function(methodName) {
            var func = source[methodName];
            object[methodName] = func;
            if (isFunc) {
              object.prototype[methodName] = function() {
                var chainAll = this.__chain__;
                if (chain2 || chainAll) {
                  var result2 = object(this.__wrapped__), actions = result2.__actions__ = copyArray(this.__actions__);
                  actions.push({ "func": func, "args": arguments, "thisArg": object });
                  result2.__chain__ = chainAll;
                  return result2;
                }
                return func.apply(object, arrayPush([this.value()], arguments));
              };
            }
          });
          return object;
        }
        function noConflict() {
          if (root._ === this) {
            root._ = oldDash;
          }
          return this;
        }
        function noop2() {
        }
        function nthArg(n) {
          n = toInteger(n);
          return baseRest(function(args) {
            return baseNth(args, n);
          });
        }
        var over = createOver(arrayMap);
        var overEvery = createOver(arrayEvery);
        var overSome = createOver(arraySome);
        function property(path4) {
          return isKey(path4) ? baseProperty(toKey(path4)) : basePropertyDeep(path4);
        }
        function propertyOf(object) {
          return function(path4) {
            return object == null ? undefined2 : baseGet(object, path4);
          };
        }
        var range = createRange();
        var rangeRight = createRange(true);
        function stubArray() {
          return [];
        }
        function stubFalse() {
          return false;
        }
        function stubObject() {
          return {};
        }
        function stubString() {
          return "";
        }
        function stubTrue() {
          return true;
        }
        function times(n, iteratee2) {
          n = toInteger(n);
          if (n < 1 || n > MAX_SAFE_INTEGER) {
            return [];
          }
          var index = MAX_ARRAY_LENGTH, length = nativeMin(n, MAX_ARRAY_LENGTH);
          iteratee2 = getIteratee(iteratee2);
          n -= MAX_ARRAY_LENGTH;
          var result2 = baseTimes(length, iteratee2);
          while (++index < n) {
            iteratee2(index);
          }
          return result2;
        }
        function toPath(value) {
          if (isArray2(value)) {
            return arrayMap(value, toKey);
          }
          return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));
        }
        function uniqueId(prefix2) {
          var id = ++idCounter;
          return toString(prefix2) + id;
        }
        var add = createMathOperation(function(augend, addend) {
          return augend + addend;
        }, 0);
        var ceil = createRound("ceil");
        var divide = createMathOperation(function(dividend, divisor) {
          return dividend / divisor;
        }, 1);
        var floor = createRound("floor");
        function max(array) {
          return array && array.length ? baseExtremum(array, identity, baseGt) : undefined2;
        }
        function maxBy(array, iteratee2) {
          return array && array.length ? baseExtremum(array, getIteratee(iteratee2, 2), baseGt) : undefined2;
        }
        function mean(array) {
          return baseMean(array, identity);
        }
        function meanBy(array, iteratee2) {
          return baseMean(array, getIteratee(iteratee2, 2));
        }
        function min(array) {
          return array && array.length ? baseExtremum(array, identity, baseLt) : undefined2;
        }
        function minBy(array, iteratee2) {
          return array && array.length ? baseExtremum(array, getIteratee(iteratee2, 2), baseLt) : undefined2;
        }
        var multiply = createMathOperation(function(multiplier, multiplicand) {
          return multiplier * multiplicand;
        }, 1);
        var round = createRound("round");
        var subtract = createMathOperation(function(minuend, subtrahend) {
          return minuend - subtrahend;
        }, 0);
        function sum(array) {
          return array && array.length ? baseSum(array, identity) : 0;
        }
        function sumBy(array, iteratee2) {
          return array && array.length ? baseSum(array, getIteratee(iteratee2, 2)) : 0;
        }
        lodash.after = after;
        lodash.ary = ary;
        lodash.assign = assign;
        lodash.assignIn = assignIn;
        lodash.assignInWith = assignInWith;
        lodash.assignWith = assignWith;
        lodash.at = at;
        lodash.before = before;
        lodash.bind = bind;
        lodash.bindAll = bindAll;
        lodash.bindKey = bindKey;
        lodash.castArray = castArray;
        lodash.chain = chain;
        lodash.chunk = chunk;
        lodash.compact = compact;
        lodash.concat = concat;
        lodash.cond = cond;
        lodash.conforms = conforms;
        lodash.constant = constant;
        lodash.countBy = countBy;
        lodash.create = create;
        lodash.curry = curry;
        lodash.curryRight = curryRight;
        lodash.debounce = debounce;
        lodash.defaults = defaults;
        lodash.defaultsDeep = defaultsDeep;
        lodash.defer = defer;
        lodash.delay = delay;
        lodash.difference = difference;
        lodash.differenceBy = differenceBy;
        lodash.differenceWith = differenceWith;
        lodash.drop = drop;
        lodash.dropRight = dropRight;
        lodash.dropRightWhile = dropRightWhile;
        lodash.dropWhile = dropWhile;
        lodash.fill = fill;
        lodash.filter = filter;
        lodash.flatMap = flatMap;
        lodash.flatMapDeep = flatMapDeep;
        lodash.flatMapDepth = flatMapDepth;
        lodash.flatten = flatten2;
        lodash.flattenDeep = flattenDeep;
        lodash.flattenDepth = flattenDepth;
        lodash.flip = flip;
        lodash.flow = flow;
        lodash.flowRight = flowRight;
        lodash.fromPairs = fromPairs;
        lodash.functions = functions;
        lodash.functionsIn = functionsIn;
        lodash.groupBy = groupBy;
        lodash.initial = initial;
        lodash.intersection = intersection;
        lodash.intersectionBy = intersectionBy;
        lodash.intersectionWith = intersectionWith;
        lodash.invert = invert;
        lodash.invertBy = invertBy;
        lodash.invokeMap = invokeMap;
        lodash.iteratee = iteratee;
        lodash.keyBy = keyBy;
        lodash.keys = keys;
        lodash.keysIn = keysIn;
        lodash.map = map;
        lodash.mapKeys = mapKeys;
        lodash.mapValues = mapValues;
        lodash.matches = matches;
        lodash.matchesProperty = matchesProperty;
        lodash.memoize = memoize;
        lodash.merge = merge2;
        lodash.mergeWith = mergeWith;
        lodash.method = method;
        lodash.methodOf = methodOf;
        lodash.mixin = mixin;
        lodash.negate = negate;
        lodash.nthArg = nthArg;
        lodash.omit = omit2;
        lodash.omitBy = omitBy;
        lodash.once = once2;
        lodash.orderBy = orderBy;
        lodash.over = over;
        lodash.overArgs = overArgs;
        lodash.overEvery = overEvery;
        lodash.overSome = overSome;
        lodash.partial = partial;
        lodash.partialRight = partialRight;
        lodash.partition = partition;
        lodash.pick = pick;
        lodash.pickBy = pickBy;
        lodash.property = property;
        lodash.propertyOf = propertyOf;
        lodash.pull = pull;
        lodash.pullAll = pullAll;
        lodash.pullAllBy = pullAllBy;
        lodash.pullAllWith = pullAllWith;
        lodash.pullAt = pullAt;
        lodash.range = range;
        lodash.rangeRight = rangeRight;
        lodash.rearg = rearg;
        lodash.reject = reject;
        lodash.remove = remove;
        lodash.rest = rest;
        lodash.reverse = reverse;
        lodash.sampleSize = sampleSize;
        lodash.set = set;
        lodash.setWith = setWith;
        lodash.shuffle = shuffle;
        lodash.slice = slice;
        lodash.sortBy = sortBy;
        lodash.sortedUniq = sortedUniq;
        lodash.sortedUniqBy = sortedUniqBy;
        lodash.split = split;
        lodash.spread = spread;
        lodash.tail = tail;
        lodash.take = take;
        lodash.takeRight = takeRight;
        lodash.takeRightWhile = takeRightWhile;
        lodash.takeWhile = takeWhile;
        lodash.tap = tap;
        lodash.throttle = throttle;
        lodash.thru = thru;
        lodash.toArray = toArray;
        lodash.toPairs = toPairs;
        lodash.toPairsIn = toPairsIn;
        lodash.toPath = toPath;
        lodash.toPlainObject = toPlainObject;
        lodash.transform = transform;
        lodash.unary = unary;
        lodash.union = union;
        lodash.unionBy = unionBy;
        lodash.unionWith = unionWith;
        lodash.uniq = uniq;
        lodash.uniqBy = uniqBy;
        lodash.uniqWith = uniqWith;
        lodash.unset = unset;
        lodash.unzip = unzip;
        lodash.unzipWith = unzipWith;
        lodash.update = update;
        lodash.updateWith = updateWith;
        lodash.values = values;
        lodash.valuesIn = valuesIn;
        lodash.without = without;
        lodash.words = words;
        lodash.wrap = wrap;
        lodash.xor = xor;
        lodash.xorBy = xorBy;
        lodash.xorWith = xorWith;
        lodash.zip = zip;
        lodash.zipObject = zipObject;
        lodash.zipObjectDeep = zipObjectDeep;
        lodash.zipWith = zipWith;
        lodash.entries = toPairs;
        lodash.entriesIn = toPairsIn;
        lodash.extend = assignIn;
        lodash.extendWith = assignInWith;
        mixin(lodash, lodash);
        lodash.add = add;
        lodash.attempt = attempt;
        lodash.camelCase = camelCase;
        lodash.capitalize = capitalize;
        lodash.ceil = ceil;
        lodash.clamp = clamp;
        lodash.clone = clone3;
        lodash.cloneDeep = cloneDeep;
        lodash.cloneDeepWith = cloneDeepWith;
        lodash.cloneWith = cloneWith;
        lodash.conformsTo = conformsTo;
        lodash.deburr = deburr;
        lodash.defaultTo = defaultTo;
        lodash.divide = divide;
        lodash.endsWith = endsWith;
        lodash.eq = eq;
        lodash.escape = escape;
        lodash.escapeRegExp = escapeRegExp;
        lodash.every = every;
        lodash.find = find2;
        lodash.findIndex = findIndex;
        lodash.findKey = findKey;
        lodash.findLast = findLast;
        lodash.findLastIndex = findLastIndex;
        lodash.findLastKey = findLastKey;
        lodash.floor = floor;
        lodash.forEach = forEach;
        lodash.forEachRight = forEachRight;
        lodash.forIn = forIn;
        lodash.forInRight = forInRight;
        lodash.forOwn = forOwn;
        lodash.forOwnRight = forOwnRight;
        lodash.get = get;
        lodash.gt = gt;
        lodash.gte = gte;
        lodash.has = has;
        lodash.hasIn = hasIn;
        lodash.head = head;
        lodash.identity = identity;
        lodash.includes = includes;
        lodash.indexOf = indexOf;
        lodash.inRange = inRange;
        lodash.invoke = invoke;
        lodash.isArguments = isArguments;
        lodash.isArray = isArray2;
        lodash.isArrayBuffer = isArrayBuffer;
        lodash.isArrayLike = isArrayLike;
        lodash.isArrayLikeObject = isArrayLikeObject;
        lodash.isBoolean = isBoolean;
        lodash.isBuffer = isBuffer;
        lodash.isDate = isDate;
        lodash.isElement = isElement;
        lodash.isEmpty = isEmpty;
        lodash.isEqual = isEqual;
        lodash.isEqualWith = isEqualWith;
        lodash.isError = isError;
        lodash.isFinite = isFinite2;
        lodash.isFunction = isFunction;
        lodash.isInteger = isInteger;
        lodash.isLength = isLength;
        lodash.isMap = isMap;
        lodash.isMatch = isMatch;
        lodash.isMatchWith = isMatchWith;
        lodash.isNaN = isNaN2;
        lodash.isNative = isNative;
        lodash.isNil = isNil;
        lodash.isNull = isNull;
        lodash.isNumber = isNumber;
        lodash.isObject = isObject3;
        lodash.isObjectLike = isObjectLike;
        lodash.isPlainObject = isPlainObject3;
        lodash.isRegExp = isRegExp;
        lodash.isSafeInteger = isSafeInteger;
        lodash.isSet = isSet;
        lodash.isString = isString;
        lodash.isSymbol = isSymbol;
        lodash.isTypedArray = isTypedArray;
        lodash.isUndefined = isUndefined;
        lodash.isWeakMap = isWeakMap;
        lodash.isWeakSet = isWeakSet;
        lodash.join = join;
        lodash.kebabCase = kebabCase;
        lodash.last = last;
        lodash.lastIndexOf = lastIndexOf;
        lodash.lowerCase = lowerCase;
        lodash.lowerFirst = lowerFirst;
        lodash.lt = lt;
        lodash.lte = lte;
        lodash.max = max;
        lodash.maxBy = maxBy;
        lodash.mean = mean;
        lodash.meanBy = meanBy;
        lodash.min = min;
        lodash.minBy = minBy;
        lodash.stubArray = stubArray;
        lodash.stubFalse = stubFalse;
        lodash.stubObject = stubObject;
        lodash.stubString = stubString;
        lodash.stubTrue = stubTrue;
        lodash.multiply = multiply;
        lodash.nth = nth;
        lodash.noConflict = noConflict;
        lodash.noop = noop2;
        lodash.now = now;
        lodash.pad = pad;
        lodash.padEnd = padEnd;
        lodash.padStart = padStart;
        lodash.parseInt = parseInt2;
        lodash.random = random;
        lodash.reduce = reduce;
        lodash.reduceRight = reduceRight;
        lodash.repeat = repeat;
        lodash.replace = replace;
        lodash.result = result;
        lodash.round = round;
        lodash.runInContext = runInContext2;
        lodash.sample = sample;
        lodash.size = size;
        lodash.snakeCase = snakeCase;
        lodash.some = some;
        lodash.sortedIndex = sortedIndex;
        lodash.sortedIndexBy = sortedIndexBy;
        lodash.sortedIndexOf = sortedIndexOf;
        lodash.sortedLastIndex = sortedLastIndex;
        lodash.sortedLastIndexBy = sortedLastIndexBy;
        lodash.sortedLastIndexOf = sortedLastIndexOf;
        lodash.startCase = startCase;
        lodash.startsWith = startsWith;
        lodash.subtract = subtract;
        lodash.sum = sum;
        lodash.sumBy = sumBy;
        lodash.template = template;
        lodash.times = times;
        lodash.toFinite = toFinite;
        lodash.toInteger = toInteger;
        lodash.toLength = toLength;
        lodash.toLower = toLower;
        lodash.toNumber = toNumber;
        lodash.toSafeInteger = toSafeInteger;
        lodash.toString = toString;
        lodash.toUpper = toUpper;
        lodash.trim = trim;
        lodash.trimEnd = trimEnd;
        lodash.trimStart = trimStart;
        lodash.truncate = truncate;
        lodash.unescape = unescape2;
        lodash.uniqueId = uniqueId;
        lodash.upperCase = upperCase;
        lodash.upperFirst = upperFirst;
        lodash.each = forEach;
        lodash.eachRight = forEachRight;
        lodash.first = head;
        mixin(lodash, function() {
          var source = {};
          baseForOwn(lodash, function(func, methodName) {
            if (!hasOwnProperty.call(lodash.prototype, methodName)) {
              source[methodName] = func;
            }
          });
          return source;
        }(), { "chain": false });
        lodash.VERSION = VERSION7;
        arrayEach(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(methodName) {
          lodash[methodName].placeholder = lodash;
        });
        arrayEach(["drop", "take"], function(methodName, index) {
          LazyWrapper.prototype[methodName] = function(n) {
            n = n === undefined2 ? 1 : nativeMax(toInteger(n), 0);
            var result2 = this.__filtered__ && !index ? new LazyWrapper(this) : this.clone();
            if (result2.__filtered__) {
              result2.__takeCount__ = nativeMin(n, result2.__takeCount__);
            } else {
              result2.__views__.push({
                "size": nativeMin(n, MAX_ARRAY_LENGTH),
                "type": methodName + (result2.__dir__ < 0 ? "Right" : "")
              });
            }
            return result2;
          };
          LazyWrapper.prototype[methodName + "Right"] = function(n) {
            return this.reverse()[methodName](n).reverse();
          };
        });
        arrayEach(["filter", "map", "takeWhile"], function(methodName, index) {
          var type = index + 1, isFilter = type == LAZY_FILTER_FLAG || type == LAZY_WHILE_FLAG;
          LazyWrapper.prototype[methodName] = function(iteratee2) {
            var result2 = this.clone();
            result2.__iteratees__.push({
              "iteratee": getIteratee(iteratee2, 3),
              "type": type
            });
            result2.__filtered__ = result2.__filtered__ || isFilter;
            return result2;
          };
        });
        arrayEach(["head", "last"], function(methodName, index) {
          var takeName = "take" + (index ? "Right" : "");
          LazyWrapper.prototype[methodName] = function() {
            return this[takeName](1).value()[0];
          };
        });
        arrayEach(["initial", "tail"], function(methodName, index) {
          var dropName = "drop" + (index ? "" : "Right");
          LazyWrapper.prototype[methodName] = function() {
            return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
          };
        });
        LazyWrapper.prototype.compact = function() {
          return this.filter(identity);
        };
        LazyWrapper.prototype.find = function(predicate) {
          return this.filter(predicate).head();
        };
        LazyWrapper.prototype.findLast = function(predicate) {
          return this.reverse().find(predicate);
        };
        LazyWrapper.prototype.invokeMap = baseRest(function(path4, args) {
          if (typeof path4 == "function") {
            return new LazyWrapper(this);
          }
          return this.map(function(value) {
            return baseInvoke(value, path4, args);
          });
        });
        LazyWrapper.prototype.reject = function(predicate) {
          return this.filter(negate(getIteratee(predicate)));
        };
        LazyWrapper.prototype.slice = function(start, end) {
          start = toInteger(start);
          var result2 = this;
          if (result2.__filtered__ && (start > 0 || end < 0)) {
            return new LazyWrapper(result2);
          }
          if (start < 0) {
            result2 = result2.takeRight(-start);
          } else if (start) {
            result2 = result2.drop(start);
          }
          if (end !== undefined2) {
            end = toInteger(end);
            result2 = end < 0 ? result2.dropRight(-end) : result2.take(end - start);
          }
          return result2;
        };
        LazyWrapper.prototype.takeRightWhile = function(predicate) {
          return this.reverse().takeWhile(predicate).reverse();
        };
        LazyWrapper.prototype.toArray = function() {
          return this.take(MAX_ARRAY_LENGTH);
        };
        baseForOwn(LazyWrapper.prototype, function(func, methodName) {
          var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName), isTaker = /^(?:head|last)$/.test(methodName), lodashFunc = lodash[isTaker ? "take" + (methodName == "last" ? "Right" : "") : methodName], retUnwrapped = isTaker || /^find/.test(methodName);
          if (!lodashFunc) {
            return;
          }
          lodash.prototype[methodName] = function() {
            var value = this.__wrapped__, args = isTaker ? [1] : arguments, isLazy = value instanceof LazyWrapper, iteratee2 = args[0], useLazy = isLazy || isArray2(value);
            var interceptor = function(value2) {
              var result3 = lodashFunc.apply(lodash, arrayPush([value2], args));
              return isTaker && chainAll ? result3[0] : result3;
            };
            if (useLazy && checkIteratee && typeof iteratee2 == "function" && iteratee2.length != 1) {
              isLazy = useLazy = false;
            }
            var chainAll = this.__chain__, isHybrid = !!this.__actions__.length, isUnwrapped = retUnwrapped && !chainAll, onlyLazy = isLazy && !isHybrid;
            if (!retUnwrapped && useLazy) {
              value = onlyLazy ? value : new LazyWrapper(this);
              var result2 = func.apply(value, args);
              result2.__actions__.push({ "func": thru, "args": [interceptor], "thisArg": undefined2 });
              return new LodashWrapper(result2, chainAll);
            }
            if (isUnwrapped && onlyLazy) {
              return func.apply(this, args);
            }
            result2 = this.thru(interceptor);
            return isUnwrapped ? isTaker ? result2.value()[0] : result2.value() : result2;
          };
        });
        arrayEach(["pop", "push", "shift", "sort", "splice", "unshift"], function(methodName) {
          var func = arrayProto[methodName], chainName = /^(?:push|sort|unshift)$/.test(methodName) ? "tap" : "thru", retUnwrapped = /^(?:pop|shift)$/.test(methodName);
          lodash.prototype[methodName] = function() {
            var args = arguments;
            if (retUnwrapped && !this.__chain__) {
              var value = this.value();
              return func.apply(isArray2(value) ? value : [], args);
            }
            return this[chainName](function(value2) {
              return func.apply(isArray2(value2) ? value2 : [], args);
            });
          };
        });
        baseForOwn(LazyWrapper.prototype, function(func, methodName) {
          var lodashFunc = lodash[methodName];
          if (lodashFunc) {
            var key = lodashFunc.name + "";
            if (!hasOwnProperty.call(realNames, key)) {
              realNames[key] = [];
            }
            realNames[key].push({ "name": methodName, "func": lodashFunc });
          }
        });
        realNames[createHybrid(undefined2, WRAP_BIND_KEY_FLAG).name] = [{
          "name": "wrapper",
          "func": undefined2
        }];
        LazyWrapper.prototype.clone = lazyClone;
        LazyWrapper.prototype.reverse = lazyReverse;
        LazyWrapper.prototype.value = lazyValue;
        lodash.prototype.at = wrapperAt;
        lodash.prototype.chain = wrapperChain;
        lodash.prototype.commit = wrapperCommit;
        lodash.prototype.next = wrapperNext;
        lodash.prototype.plant = wrapperPlant;
        lodash.prototype.reverse = wrapperReverse;
        lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;
        lodash.prototype.first = lodash.prototype.head;
        if (symIterator) {
          lodash.prototype[symIterator] = wrapperToIterator;
        }
        return lodash;
      };
      var _ = runInContext();
      if (typeof define == "function" && typeof define.amd == "object" && define.amd) {
        root._ = _;
        define(function() {
          return _;
        });
      } else if (freeModule) {
        (freeModule.exports = _)._ = _;
        freeExports._ = _;
      } else {
        root._ = _;
      }
    }).call(exports);
  }
});

// node_modules/json-diff-ts/lib/jsonDiff.js
var require_jsonDiff = __commonJS({
  "node_modules/json-diff-ts/lib/jsonDiff.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.unflattenChanges = exports.flattenChangeset = exports.Operation = exports.revertChangeset = exports.applyChangeset = exports.diff = exports.getTypeOfObj = void 0;
    var lodash_1 = require_lodash();
    var getTypeOfObj = (obj) => {
      if (typeof obj === "undefined") {
        return "undefined";
      }
      if (obj === null) {
        return null;
      }
      return Object.prototype.toString.call(obj).match(/^\[object\s(.*)\]$/)[1];
    };
    exports.getTypeOfObj = getTypeOfObj;
    var getKey = (path4) => {
      const left = path4[path4.length - 1];
      return left != null ? left : "$root";
    };
    var compare = (oldObj, newObj, path4, embeddedObjKeys, keyPath) => {
      let changes = [];
      const typeOfOldObj = (0, exports.getTypeOfObj)(oldObj);
      const typeOfNewObj = (0, exports.getTypeOfObj)(newObj);
      if (typeOfOldObj !== typeOfNewObj) {
        changes.push({ type: Operation2.REMOVE, key: getKey(path4), value: oldObj });
        changes.push({ type: Operation2.ADD, key: getKey(path4), value: newObj });
        return changes;
      }
      switch (typeOfOldObj) {
        case "Date":
          changes = changes.concat(comparePrimitives(oldObj.getTime(), newObj.getTime(), path4).map((x2) => Object.assign(Object.assign({}, x2), { value: new Date(x2.value), oldValue: new Date(x2.oldValue) })));
          break;
        case "Object":
          const diffs = compareObject(oldObj, newObj, path4, embeddedObjKeys, keyPath);
          if (diffs.length) {
            if (path4.length) {
              changes.push({
                type: Operation2.UPDATE,
                key: getKey(path4),
                changes: diffs
              });
            } else {
              changes = changes.concat(diffs);
            }
          }
          break;
        case "Array":
          changes = changes.concat(compareArray(oldObj, newObj, path4, embeddedObjKeys, keyPath));
          break;
        case "Function":
          break;
        default:
          changes = changes.concat(comparePrimitives(oldObj, newObj, path4));
      }
      return changes;
    };
    var compareObject = (oldObj, newObj, path4, embeddedObjKeys, keyPath, skipPath = false) => {
      let k;
      let newKeyPath;
      let newPath;
      if (skipPath == null) {
        skipPath = false;
      }
      let changes = [];
      const oldObjKeys = Object.keys(oldObj);
      const newObjKeys = Object.keys(newObj);
      const intersectionKeys = (0, lodash_1.intersection)(oldObjKeys, newObjKeys);
      for (k of intersectionKeys) {
        newPath = path4.concat([k]);
        newKeyPath = skipPath ? keyPath : keyPath.concat([k]);
        const diffs = compare(oldObj[k], newObj[k], newPath, embeddedObjKeys, newKeyPath);
        if (diffs.length) {
          changes = changes.concat(diffs);
        }
      }
      const addedKeys = (0, lodash_1.difference)(newObjKeys, oldObjKeys);
      for (k of addedKeys) {
        newPath = path4.concat([k]);
        newKeyPath = skipPath ? keyPath : keyPath.concat([k]);
        changes.push({
          type: Operation2.ADD,
          key: getKey(newPath),
          value: newObj[k]
        });
      }
      const deletedKeys = (0, lodash_1.difference)(oldObjKeys, newObjKeys);
      for (k of deletedKeys) {
        newPath = path4.concat([k]);
        newKeyPath = skipPath ? keyPath : keyPath.concat([k]);
        changes.push({
          type: Operation2.REMOVE,
          key: getKey(newPath),
          value: oldObj[k]
        });
      }
      return changes;
    };
    var compareArray = (oldObj, newObj, path4, embeddedObjKeys, keyPath) => {
      const left = getObjectKey(embeddedObjKeys, keyPath);
      const uniqKey = left != null ? left : "$index";
      const indexedOldObj = convertArrayToObj(oldObj, uniqKey);
      const indexedNewObj = convertArrayToObj(newObj, uniqKey);
      const diffs = compareObject(indexedOldObj, indexedNewObj, path4, embeddedObjKeys, keyPath, true);
      if (diffs.length) {
        return [
          {
            type: Operation2.UPDATE,
            key: getKey(path4),
            embeddedKey: uniqKey,
            changes: diffs
          }
        ];
      } else {
        return [];
      }
    };
    var getObjectKey = (embeddedObjKeys, keyPath) => {
      if (embeddedObjKeys != null) {
        const path4 = keyPath.join(".");
        const key = embeddedObjKeys[path4];
        if (key != null) {
          return key;
        }
        for (const regex in embeddedObjKeys) {
          if (path4.match(new RegExp(regex))) {
            return embeddedObjKeys[regex];
          }
        }
      }
      return void 0;
    };
    var convertArrayToObj = (arr, uniqKey) => {
      let obj = {};
      if (uniqKey !== "$index") {
        obj = (0, lodash_1.keyBy)(arr, uniqKey);
      } else {
        for (let i2 = 0; i2 < arr.length; i2++) {
          const value = arr[i2];
          obj[i2] = value;
        }
      }
      return obj;
    };
    var comparePrimitives = (oldObj, newObj, path4) => {
      const changes = [];
      if (oldObj !== newObj) {
        changes.push({
          type: Operation2.UPDATE,
          key: getKey(path4),
          value: newObj,
          oldValue: oldObj
        });
      }
      return changes;
    };
    var removeKey = (obj, key, embeddedKey) => {
      if (Array.isArray(obj)) {
        if (embeddedKey === "$index") {
          obj.splice(key);
          return;
        }
        const index = indexOfItemInArray(obj, embeddedKey, key);
        if (index === -1) {
          console.warn(`Element with the key '${embeddedKey}' and value '${key}' could not be found in the array'`);
          return;
        }
        return obj.splice(index != null ? index : key, 1);
      } else {
        obj[key] = void 0;
        delete obj[key];
        return;
      }
    };
    var indexOfItemInArray = (arr, key, value) => {
      for (let i2 = 0; i2 < arr.length; i2++) {
        const item = arr[i2];
        if (item && item[key] ? item[key].toString() === value.toString() : void 0) {
          return i2;
        }
      }
      return -1;
    };
    var modifyKeyValue = (obj, key, value) => obj[key] = value;
    var addKeyValue = (obj, key, value) => {
      if (Array.isArray(obj)) {
        return obj.push(value);
      } else {
        return obj ? obj[key] = value : null;
      }
    };
    var applyLeafChange = (obj, change, embeddedKey) => {
      const { type, key, value } = change;
      switch (type) {
        case Operation2.ADD:
          return addKeyValue(obj, key, value);
        case Operation2.UPDATE:
          return modifyKeyValue(obj, key, value);
        case Operation2.REMOVE:
          return removeKey(obj, key, embeddedKey);
      }
    };
    var applyArrayChange = (arr, change) => (() => {
      const result = [];
      for (const subchange of change.changes) {
        if (subchange.value != null || subchange.type === Operation2.REMOVE) {
          result.push(applyLeafChange(arr, subchange, change.embeddedKey));
        } else {
          let element;
          if (change.embeddedKey === "$index") {
            element = arr[subchange.key];
          } else {
            element = (0, lodash_1.find)(arr, (el) => el[change.embeddedKey].toString() === subchange.key.toString());
          }
          result.push((0, exports.applyChangeset)(element, subchange.changes));
        }
      }
      return result;
    })();
    var applyBranchChange = (obj, change) => {
      if (Array.isArray(obj)) {
        return applyArrayChange(obj, change);
      } else {
        return (0, exports.applyChangeset)(obj, change.changes);
      }
    };
    var revertLeafChange = (obj, change, embeddedKey = "$index") => {
      const { type, key, value, oldValue } = change;
      switch (type) {
        case Operation2.ADD:
          return removeKey(obj, key, embeddedKey);
        case Operation2.UPDATE:
          return modifyKeyValue(obj, key, oldValue);
        case Operation2.REMOVE:
          return addKeyValue(obj, key, value);
      }
    };
    var revertArrayChange = (arr, change) => (() => {
      const result = [];
      for (const subchange of change.changes) {
        if (subchange.value != null || subchange.type === Operation2.REMOVE) {
          result.push(revertLeafChange(arr, subchange, change.embeddedKey));
        } else {
          let element;
          if (change.embeddedKey === "$index") {
            element = arr[+subchange.key];
          } else {
            element = (0, lodash_1.find)(arr, (el) => el[change.embeddedKey].toString() === subchange.key);
          }
          result.push((0, exports.revertChangeset)(element, subchange.changes));
        }
      }
      return result;
    })();
    var revertBranchChange = (obj, change) => {
      if (Array.isArray(obj)) {
        return revertArrayChange(obj, change);
      } else {
        return (0, exports.revertChangeset)(obj, change.changes);
      }
    };
    var diff2 = (oldObj, newObj, embeddedObjKeys) => compare(oldObj, newObj, [], embeddedObjKeys, []);
    exports.diff = diff2;
    var applyChangeset = (obj, changeset) => {
      if (changeset) {
        changeset.forEach((change) => change.value !== null && change.value !== void 0 || change.type === Operation2.REMOVE ? applyLeafChange(obj, change, change.embeddedKey) : applyBranchChange(obj[change.key], change));
      }
      return obj;
    };
    exports.applyChangeset = applyChangeset;
    var revertChangeset = (obj, changeset) => {
      if (changeset) {
        changeset.reverse().forEach((change) => !change.changes ? revertLeafChange(obj, change) : revertBranchChange(obj[change.key], change));
      }
      return obj;
    };
    exports.revertChangeset = revertChangeset;
    var Operation2;
    (function(Operation3) {
      Operation3["REMOVE"] = "REMOVE";
      Operation3["ADD"] = "ADD";
      Operation3["UPDATE"] = "UPDATE";
    })(Operation2 = exports.Operation || (exports.Operation = {}));
    var flattenChangeset = (obj, path4 = "$", embeddedKey) => {
      if (Array.isArray(obj)) {
        return obj.reduce((memo, change) => [...memo, ...(0, exports.flattenChangeset)(change, path4, embeddedKey)], []);
      } else {
        if (obj.changes || embeddedKey) {
          path4 = embeddedKey ? embeddedKey === "$index" ? `${path4}[${obj.key}]` : obj.type === Operation2.ADD ? path4 : `${path4}[?(@.${embeddedKey}='${obj.key}')]` : path4 = `${path4}.${obj.key}`;
          return (0, exports.flattenChangeset)(obj.changes || obj, path4, obj.embeddedKey);
        } else {
          const valueType = (0, exports.getTypeOfObj)(obj.value);
          return [
            Object.assign(Object.assign({}, obj), { path: valueType === "Object" || path4.endsWith(`[${obj.key}]`) ? path4 : `${path4}.${obj.key}`, valueType })
          ];
        }
      }
    };
    exports.flattenChangeset = flattenChangeset;
    var unflattenChanges = (changes) => {
      if (!Array.isArray(changes)) {
        changes = [changes];
      }
      const changesArr = [];
      changes.forEach((change) => {
        const obj = {};
        let ptr = obj;
        const segments = change.path.split(/([^@])\./).reduce((acc, curr, i2) => {
          const x2 = Math.floor(i2 / 2);
          if (!acc[x2]) {
            acc[x2] = "";
          }
          acc[x2] += curr;
          return acc;
        }, []);
        if (segments.length === 1) {
          ptr.key = change.key;
          ptr.type = change.type;
          ptr.value = change.value;
          ptr.oldValue = change.oldValue;
          changesArr.push(ptr);
        } else {
          for (let i2 = 1; i2 < segments.length; i2++) {
            const segment = segments[i2];
            const result = /^(.+)\[\?\(@\.(.+)='(.+)'\)]$|^(.+)\[(\d+)\]/.exec(segment);
            if (result) {
              let key;
              let embeddedKey;
              let arrKey;
              if (result[1]) {
                key = result[1];
                embeddedKey = result[2];
                arrKey = result[3];
              } else {
                key = result[4];
                embeddedKey = "$index";
                arrKey = Number(result[5]);
              }
              if (i2 === segments.length - 1) {
                ptr.key = key;
                ptr.embeddedKey = embeddedKey;
                ptr.type = Operation2.UPDATE;
                ptr.changes = [
                  {
                    type: change.type,
                    key: arrKey,
                    value: change.value,
                    oldValue: change.oldValue
                  }
                ];
              } else {
                ptr.key = key;
                ptr.embeddedKey = embeddedKey;
                ptr.type = Operation2.UPDATE;
                const newPtr = {};
                ptr.changes = [
                  {
                    type: Operation2.UPDATE,
                    key: arrKey,
                    changes: [newPtr]
                  }
                ];
                ptr = newPtr;
              }
            } else {
              if (i2 === segments.length - 1) {
                if (change.value !== null && change.valueType === "Object") {
                  ptr.key = segment;
                  ptr.type = Operation2.UPDATE;
                  ptr.changes = [
                    {
                      key: change.key,
                      type: change.type,
                      value: change.value
                    }
                  ];
                } else {
                  ptr.key = change.key;
                  ptr.type = change.type;
                  ptr.value = change.value;
                  ptr.oldValue = change.oldValue;
                }
              } else {
                ptr.key = segment;
                ptr.type = Operation2.UPDATE;
                const newPtr = {};
                ptr.changes = [newPtr];
                ptr = newPtr;
              }
            }
          }
          changesArr.push(obj);
        }
      });
      return changesArr;
    };
    exports.unflattenChanges = unflattenChanges;
  }
});

// node_modules/json-diff-ts/lib/jsonCompare.js
var require_jsonCompare = __commonJS({
  "node_modules/json-diff-ts/lib/jsonCompare.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.compare = exports.applyChangelist = exports.enrich = exports.createContainer = exports.createValue = exports.CompareOperation = void 0;
    var lodash_1 = require_lodash();
    var jsonDiff_1 = require_jsonDiff();
    var CompareOperation;
    (function(CompareOperation2) {
      CompareOperation2["CONTAINER"] = "CONTAINER";
      CompareOperation2["UNCHANGED"] = "UNCHANGED";
    })(CompareOperation = exports.CompareOperation || (exports.CompareOperation = {}));
    var createValue = (value) => ({ type: CompareOperation.UNCHANGED, value });
    exports.createValue = createValue;
    var createContainer = (value) => ({
      type: CompareOperation.CONTAINER,
      value
    });
    exports.createContainer = createContainer;
    var enrich = (object) => {
      const objectType = (0, jsonDiff_1.getTypeOfObj)(object);
      switch (objectType) {
        case "Object":
          return (0, lodash_1.keys)(object).map((key) => ({ key, value: (0, exports.enrich)(object[key]) })).reduce((accumulator, entry) => {
            accumulator.value[entry.key] = entry.value;
            return accumulator;
          }, (0, exports.createContainer)({}));
        case "Array":
          return (0, lodash_1.chain)(object).map((value) => (0, exports.enrich)(value)).reduce((accumulator, value) => {
            accumulator.value.push(value);
            return accumulator;
          }, (0, exports.createContainer)([])).value();
        case "Function":
          return void 0;
        case "Date":
        default:
          return (0, exports.createValue)(object);
      }
    };
    exports.enrich = enrich;
    var applyChangelist = (object, changelist) => {
      (0, lodash_1.chain)(changelist).map((entry) => Object.assign(Object.assign({}, entry), { path: (0, lodash_1.replace)(entry.path, "$.", ".") })).map((entry) => Object.assign(Object.assign({}, entry), { path: (0, lodash_1.replace)(entry.path, /(\[(?<array>\d)\]\.)/g, "ARRVAL_START$<array>ARRVAL_END") })).map((entry) => Object.assign(Object.assign({}, entry), { path: (0, lodash_1.replace)(entry.path, /(?<dot>\.)/g, ".value$<dot>") })).map((entry) => Object.assign(Object.assign({}, entry), { path: (0, lodash_1.replace)(entry.path, /\./, "") })).map((entry) => Object.assign(Object.assign({}, entry), { path: (0, lodash_1.replace)(entry.path, /ARRVAL_START/g, ".value[") })).map((entry) => Object.assign(Object.assign({}, entry), { path: (0, lodash_1.replace)(entry.path, /ARRVAL_END/g, "].value.") })).value().forEach((entry) => {
        switch (entry.type) {
          case jsonDiff_1.Operation.ADD:
          case jsonDiff_1.Operation.UPDATE:
            (0, lodash_1.set)(object, entry.path, { type: entry.type, value: entry.value, oldValue: entry.oldValue });
            break;
          case jsonDiff_1.Operation.REMOVE:
            (0, lodash_1.set)(object, entry.path, { type: entry.type, value: void 0, oldValue: entry.value });
            break;
          default:
            throw new Error();
        }
      });
      return object;
    };
    exports.applyChangelist = applyChangelist;
    var compare = (oldObject, newObject) => {
      return (0, exports.applyChangelist)((0, exports.enrich)(oldObject), (0, jsonDiff_1.flattenChangeset)((0, jsonDiff_1.diff)(oldObject, newObject)));
    };
    exports.compare = compare;
  }
});

// node_modules/json-diff-ts/lib/index.js
var require_lib6 = __commonJS({
  "node_modules/json-diff-ts/lib/index.js"(exports) {
    "use strict";
    var __createBinding = exports && exports.__createBinding || (Object.create ? function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m2[k];
      } });
    } : function(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    });
    var __exportStar = exports && exports.__exportStar || function(m2, exports2) {
      for (var p in m2)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports2, p))
          __createBinding(exports2, m2, p);
    };
    Object.defineProperty(exports, "__esModule", { value: true });
    __exportStar(require_jsonDiff(), exports);
    __exportStar(require_jsonCompare(), exports);
  }
});

// node_modules/@changesets/config/node_modules/graceful-fs/polyfills.js
var require_polyfills3 = __commonJS({
  "node_modules/@changesets/config/node_modules/graceful-fs/polyfills.js"(exports, module2) {
    var constants = require("constants");
    var origCwd = process.cwd;
    var cwd = null;
    var platform = process.env.GRACEFUL_FS_PLATFORM || process.platform;
    process.cwd = function() {
      if (!cwd)
        cwd = origCwd.call(process);
      return cwd;
    };
    try {
      process.cwd();
    } catch (er) {
    }
    if (typeof process.chdir === "function") {
      chdir = process.chdir;
      process.chdir = function(d) {
        cwd = null;
        chdir.call(process, d);
      };
      if (Object.setPrototypeOf)
        Object.setPrototypeOf(process.chdir, chdir);
    }
    var chdir;
    module2.exports = patch;
    function patch(fs4) {
      if (constants.hasOwnProperty("O_SYMLINK") && process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)) {
        patchLchmod(fs4);
      }
      if (!fs4.lutimes) {
        patchLutimes(fs4);
      }
      fs4.chown = chownFix(fs4.chown);
      fs4.fchown = chownFix(fs4.fchown);
      fs4.lchown = chownFix(fs4.lchown);
      fs4.chmod = chmodFix(fs4.chmod);
      fs4.fchmod = chmodFix(fs4.fchmod);
      fs4.lchmod = chmodFix(fs4.lchmod);
      fs4.chownSync = chownFixSync(fs4.chownSync);
      fs4.fchownSync = chownFixSync(fs4.fchownSync);
      fs4.lchownSync = chownFixSync(fs4.lchownSync);
      fs4.chmodSync = chmodFixSync(fs4.chmodSync);
      fs4.fchmodSync = chmodFixSync(fs4.fchmodSync);
      fs4.lchmodSync = chmodFixSync(fs4.lchmodSync);
      fs4.stat = statFix(fs4.stat);
      fs4.fstat = statFix(fs4.fstat);
      fs4.lstat = statFix(fs4.lstat);
      fs4.statSync = statFixSync(fs4.statSync);
      fs4.fstatSync = statFixSync(fs4.fstatSync);
      fs4.lstatSync = statFixSync(fs4.lstatSync);
      if (fs4.chmod && !fs4.lchmod) {
        fs4.lchmod = function(path4, mode, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs4.lchmodSync = function() {
        };
      }
      if (fs4.chown && !fs4.lchown) {
        fs4.lchown = function(path4, uid, gid, cb) {
          if (cb)
            process.nextTick(cb);
        };
        fs4.lchownSync = function() {
        };
      }
      if (platform === "win32") {
        fs4.rename = typeof fs4.rename !== "function" ? fs4.rename : function(fs$rename) {
          function rename(from, to, cb) {
            var start = Date.now();
            var backoff = 0;
            fs$rename(from, to, function CB(er) {
              if (er && (er.code === "EACCES" || er.code === "EPERM") && Date.now() - start < 6e4) {
                setTimeout(function() {
                  fs4.stat(to, function(stater, st) {
                    if (stater && stater.code === "ENOENT")
                      fs$rename(from, to, CB);
                    else
                      cb(er);
                  });
                }, backoff);
                if (backoff < 100)
                  backoff += 10;
                return;
              }
              if (cb)
                cb(er);
            });
          }
          if (Object.setPrototypeOf)
            Object.setPrototypeOf(rename, fs$rename);
          return rename;
        }(fs4.rename);
      }
      fs4.read = typeof fs4.read !== "function" ? fs4.read : function(fs$read) {
        function read2(fd, buffer, offset, length, position, callback_) {
          var callback;
          if (callback_ && typeof callback_ === "function") {
            var eagCounter = 0;
            callback = function(er, _, __) {
              if (er && er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                return fs$read.call(fs4, fd, buffer, offset, length, position, callback);
              }
              callback_.apply(this, arguments);
            };
          }
          return fs$read.call(fs4, fd, buffer, offset, length, position, callback);
        }
        if (Object.setPrototypeOf)
          Object.setPrototypeOf(read2, fs$read);
        return read2;
      }(fs4.read);
      fs4.readSync = typeof fs4.readSync !== "function" ? fs4.readSync : function(fs$readSync) {
        return function(fd, buffer, offset, length, position) {
          var eagCounter = 0;
          while (true) {
            try {
              return fs$readSync.call(fs4, fd, buffer, offset, length, position);
            } catch (er) {
              if (er.code === "EAGAIN" && eagCounter < 10) {
                eagCounter++;
                continue;
              }
              throw er;
            }
          }
        };
      }(fs4.readSync);
      function patchLchmod(fs5) {
        fs5.lchmod = function(path4, mode, callback) {
          fs5.open(
            path4,
            constants.O_WRONLY | constants.O_SYMLINK,
            mode,
            function(err, fd) {
              if (err) {
                if (callback)
                  callback(err);
                return;
              }
              fs5.fchmod(fd, mode, function(err2) {
                fs5.close(fd, function(err22) {
                  if (callback)
                    callback(err2 || err22);
                });
              });
            }
          );
        };
        fs5.lchmodSync = function(path4, mode) {
          var fd = fs5.openSync(path4, constants.O_WRONLY | constants.O_SYMLINK, mode);
          var threw = true;
          var ret;
          try {
            ret = fs5.fchmodSync(fd, mode);
            threw = false;
          } finally {
            if (threw) {
              try {
                fs5.closeSync(fd);
              } catch (er) {
              }
            } else {
              fs5.closeSync(fd);
            }
          }
          return ret;
        };
      }
      function patchLutimes(fs5) {
        if (constants.hasOwnProperty("O_SYMLINK") && fs5.futimes) {
          fs5.lutimes = function(path4, at, mt, cb) {
            fs5.open(path4, constants.O_SYMLINK, function(er, fd) {
              if (er) {
                if (cb)
                  cb(er);
                return;
              }
              fs5.futimes(fd, at, mt, function(er2) {
                fs5.close(fd, function(er22) {
                  if (cb)
                    cb(er2 || er22);
                });
              });
            });
          };
          fs5.lutimesSync = function(path4, at, mt) {
            var fd = fs5.openSync(path4, constants.O_SYMLINK);
            var ret;
            var threw = true;
            try {
              ret = fs5.futimesSync(fd, at, mt);
              threw = false;
            } finally {
              if (threw) {
                try {
                  fs5.closeSync(fd);
                } catch (er) {
                }
              } else {
                fs5.closeSync(fd);
              }
            }
            return ret;
          };
        } else if (fs5.futimes) {
          fs5.lutimes = function(_a4, _b, _c, cb) {
            if (cb)
              process.nextTick(cb);
          };
          fs5.lutimesSync = function() {
          };
        }
      }
      function chmodFix(orig) {
        if (!orig)
          return orig;
        return function(target, mode, cb) {
          return orig.call(fs4, target, mode, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chmodFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, mode) {
          try {
            return orig.call(fs4, target, mode);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function chownFix(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid, cb) {
          return orig.call(fs4, target, uid, gid, function(er) {
            if (chownErOk(er))
              er = null;
            if (cb)
              cb.apply(this, arguments);
          });
        };
      }
      function chownFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, uid, gid) {
          try {
            return orig.call(fs4, target, uid, gid);
          } catch (er) {
            if (!chownErOk(er))
              throw er;
          }
        };
      }
      function statFix(orig) {
        if (!orig)
          return orig;
        return function(target, options, cb) {
          if (typeof options === "function") {
            cb = options;
            options = null;
          }
          function callback(er, stats) {
            if (stats) {
              if (stats.uid < 0)
                stats.uid += 4294967296;
              if (stats.gid < 0)
                stats.gid += 4294967296;
            }
            if (cb)
              cb.apply(this, arguments);
          }
          return options ? orig.call(fs4, target, options, callback) : orig.call(fs4, target, callback);
        };
      }
      function statFixSync(orig) {
        if (!orig)
          return orig;
        return function(target, options) {
          var stats = options ? orig.call(fs4, target, options) : orig.call(fs4, target);
          if (stats) {
            if (stats.uid < 0)
              stats.uid += 4294967296;
            if (stats.gid < 0)
              stats.gid += 4294967296;
          }
          return stats;
        };
      }
      function chownErOk(er) {
        if (!er)
          return true;
        if (er.code === "ENOSYS")
          return true;
        var nonroot = !process.getuid || process.getuid() !== 0;
        if (nonroot) {
          if (er.code === "EINVAL" || er.code === "EPERM")
            return true;
        }
        return false;
      }
    }
  }
});

// node_modules/@changesets/config/node_modules/graceful-fs/legacy-streams.js
var require_legacy_streams3 = __commonJS({
  "node_modules/@changesets/config/node_modules/graceful-fs/legacy-streams.js"(exports, module2) {
    var Stream4 = require("stream").Stream;
    module2.exports = legacy;
    function legacy(fs4) {
      return {
        ReadStream,
        WriteStream
      };
      function ReadStream(path4, options) {
        if (!(this instanceof ReadStream))
          return new ReadStream(path4, options);
        Stream4.call(this);
        var self2 = this;
        this.path = path4;
        this.fd = null;
        this.readable = true;
        this.paused = false;
        this.flags = "r";
        this.mode = 438;
        this.bufferSize = 64 * 1024;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.encoding)
          this.setEncoding(this.encoding);
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.end === void 0) {
            this.end = Infinity;
          } else if ("number" !== typeof this.end) {
            throw TypeError("end must be a Number");
          }
          if (this.start > this.end) {
            throw new Error("start must be <= end");
          }
          this.pos = this.start;
        }
        if (this.fd !== null) {
          process.nextTick(function() {
            self2._read();
          });
          return;
        }
        fs4.open(this.path, this.flags, this.mode, function(err, fd) {
          if (err) {
            self2.emit("error", err);
            self2.readable = false;
            return;
          }
          self2.fd = fd;
          self2.emit("open", fd);
          self2._read();
        });
      }
      function WriteStream(path4, options) {
        if (!(this instanceof WriteStream))
          return new WriteStream(path4, options);
        Stream4.call(this);
        this.path = path4;
        this.fd = null;
        this.writable = true;
        this.flags = "w";
        this.encoding = "binary";
        this.mode = 438;
        this.bytesWritten = 0;
        options = options || {};
        var keys = Object.keys(options);
        for (var index = 0, length = keys.length; index < length; index++) {
          var key = keys[index];
          this[key] = options[key];
        }
        if (this.start !== void 0) {
          if ("number" !== typeof this.start) {
            throw TypeError("start must be a Number");
          }
          if (this.start < 0) {
            throw new Error("start must be >= zero");
          }
          this.pos = this.start;
        }
        this.busy = false;
        this._queue = [];
        if (this.fd === null) {
          this._open = fs4.open;
          this._queue.push([this._open, this.path, this.flags, this.mode, void 0]);
          this.flush();
        }
      }
    }
  }
});

// node_modules/@changesets/config/node_modules/graceful-fs/clone.js
var require_clone3 = __commonJS({
  "node_modules/@changesets/config/node_modules/graceful-fs/clone.js"(exports, module2) {
    "use strict";
    module2.exports = clone3;
    var getPrototypeOf = Object.getPrototypeOf || function(obj) {
      return obj.__proto__;
    };
    function clone3(obj) {
      if (obj === null || typeof obj !== "object")
        return obj;
      if (obj instanceof Object)
        var copy = { __proto__: getPrototypeOf(obj) };
      else
        var copy = /* @__PURE__ */ Object.create(null);
      Object.getOwnPropertyNames(obj).forEach(function(key) {
        Object.defineProperty(copy, key, Object.getOwnPropertyDescriptor(obj, key));
      });
      return copy;
    }
  }
});

// node_modules/@changesets/config/node_modules/graceful-fs/graceful-fs.js
var require_graceful_fs3 = __commonJS({
  "node_modules/@changesets/config/node_modules/graceful-fs/graceful-fs.js"(exports, module2) {
    var fs4 = require("fs");
    var polyfills = require_polyfills3();
    var legacy = require_legacy_streams3();
    var clone3 = require_clone3();
    var util2 = require("util");
    var gracefulQueue;
    var previousSymbol;
    if (typeof Symbol === "function" && typeof Symbol.for === "function") {
      gracefulQueue = Symbol.for("graceful-fs.queue");
      previousSymbol = Symbol.for("graceful-fs.previous");
    } else {
      gracefulQueue = "___graceful-fs.queue";
      previousSymbol = "___graceful-fs.previous";
    }
    function noop2() {
    }
    function publishQueue(context2, queue2) {
      Object.defineProperty(context2, gracefulQueue, {
        get: function() {
          return queue2;
        }
      });
    }
    var debug = noop2;
    if (util2.debuglog)
      debug = util2.debuglog("gfs4");
    else if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || ""))
      debug = function() {
        var m2 = util2.format.apply(util2, arguments);
        m2 = "GFS4: " + m2.split(/\n/).join("\nGFS4: ");
        console.error(m2);
      };
    if (!fs4[gracefulQueue]) {
      queue = global[gracefulQueue] || [];
      publishQueue(fs4, queue);
      fs4.close = function(fs$close) {
        function close(fd, cb) {
          return fs$close.call(fs4, fd, function(err) {
            if (!err) {
              resetQueue();
            }
            if (typeof cb === "function")
              cb.apply(this, arguments);
          });
        }
        Object.defineProperty(close, previousSymbol, {
          value: fs$close
        });
        return close;
      }(fs4.close);
      fs4.closeSync = function(fs$closeSync) {
        function closeSync(fd) {
          fs$closeSync.apply(fs4, arguments);
          resetQueue();
        }
        Object.defineProperty(closeSync, previousSymbol, {
          value: fs$closeSync
        });
        return closeSync;
      }(fs4.closeSync);
      if (/\bgfs4\b/i.test(process.env.NODE_DEBUG || "")) {
        process.on("exit", function() {
          debug(fs4[gracefulQueue]);
          require("assert").equal(fs4[gracefulQueue].length, 0);
        });
      }
    }
    var queue;
    if (!global[gracefulQueue]) {
      publishQueue(global, fs4[gracefulQueue]);
    }
    module2.exports = patch(clone3(fs4));
    if (process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH && !fs4.__patched) {
      module2.exports = patch(fs4);
      fs4.__patched = true;
    }
    function patch(fs5) {
      polyfills(fs5);
      fs5.gracefulify = patch;
      fs5.createReadStream = createReadStream2;
      fs5.createWriteStream = createWriteStream;
      var fs$readFile = fs5.readFile;
      fs5.readFile = readFile;
      function readFile(path4, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$readFile(path4, options, cb);
        function go$readFile(path5, options2, cb2, startTime) {
          return fs$readFile(path5, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$readFile, [path5, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$writeFile = fs5.writeFile;
      fs5.writeFile = writeFile2;
      function writeFile2(path4, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$writeFile(path4, data, options, cb);
        function go$writeFile(path5, data2, options2, cb2, startTime) {
          return fs$writeFile(path5, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$writeFile, [path5, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$appendFile = fs5.appendFile;
      if (fs$appendFile)
        fs5.appendFile = appendFile;
      function appendFile(path4, data, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        return go$appendFile(path4, data, options, cb);
        function go$appendFile(path5, data2, options2, cb2, startTime) {
          return fs$appendFile(path5, data2, options2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$appendFile, [path5, data2, options2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$copyFile = fs5.copyFile;
      if (fs$copyFile)
        fs5.copyFile = copyFile;
      function copyFile(src, dest, flags, cb) {
        if (typeof flags === "function") {
          cb = flags;
          flags = 0;
        }
        return go$copyFile(src, dest, flags, cb);
        function go$copyFile(src2, dest2, flags2, cb2, startTime) {
          return fs$copyFile(src2, dest2, flags2, function(err) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$copyFile, [src2, dest2, flags2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      var fs$readdir = fs5.readdir;
      fs5.readdir = readdir;
      var noReaddirOptionVersions = /^v[0-5]\./;
      function readdir(path4, options, cb) {
        if (typeof options === "function")
          cb = options, options = null;
        var go$readdir = noReaddirOptionVersions.test(process.version) ? function go$readdir2(path5, options2, cb2, startTime) {
          return fs$readdir(path5, fs$readdirCallback(
            path5,
            options2,
            cb2,
            startTime
          ));
        } : function go$readdir2(path5, options2, cb2, startTime) {
          return fs$readdir(path5, options2, fs$readdirCallback(
            path5,
            options2,
            cb2,
            startTime
          ));
        };
        return go$readdir(path4, options, cb);
        function fs$readdirCallback(path5, options2, cb2, startTime) {
          return function(err, files) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([
                go$readdir,
                [path5, options2, cb2],
                err,
                startTime || Date.now(),
                Date.now()
              ]);
            else {
              if (files && files.sort)
                files.sort();
              if (typeof cb2 === "function")
                cb2.call(this, err, files);
            }
          };
        }
      }
      if (process.version.substr(0, 4) === "v0.8") {
        var legStreams = legacy(fs5);
        ReadStream = legStreams.ReadStream;
        WriteStream = legStreams.WriteStream;
      }
      var fs$ReadStream = fs5.ReadStream;
      if (fs$ReadStream) {
        ReadStream.prototype = Object.create(fs$ReadStream.prototype);
        ReadStream.prototype.open = ReadStream$open;
      }
      var fs$WriteStream = fs5.WriteStream;
      if (fs$WriteStream) {
        WriteStream.prototype = Object.create(fs$WriteStream.prototype);
        WriteStream.prototype.open = WriteStream$open;
      }
      Object.defineProperty(fs5, "ReadStream", {
        get: function() {
          return ReadStream;
        },
        set: function(val) {
          ReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      Object.defineProperty(fs5, "WriteStream", {
        get: function() {
          return WriteStream;
        },
        set: function(val) {
          WriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileReadStream = ReadStream;
      Object.defineProperty(fs5, "FileReadStream", {
        get: function() {
          return FileReadStream;
        },
        set: function(val) {
          FileReadStream = val;
        },
        enumerable: true,
        configurable: true
      });
      var FileWriteStream = WriteStream;
      Object.defineProperty(fs5, "FileWriteStream", {
        get: function() {
          return FileWriteStream;
        },
        set: function(val) {
          FileWriteStream = val;
        },
        enumerable: true,
        configurable: true
      });
      function ReadStream(path4, options) {
        if (this instanceof ReadStream)
          return fs$ReadStream.apply(this, arguments), this;
        else
          return ReadStream.apply(Object.create(ReadStream.prototype), arguments);
      }
      function ReadStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            if (that.autoClose)
              that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
            that.read();
          }
        });
      }
      function WriteStream(path4, options) {
        if (this instanceof WriteStream)
          return fs$WriteStream.apply(this, arguments), this;
        else
          return WriteStream.apply(Object.create(WriteStream.prototype), arguments);
      }
      function WriteStream$open() {
        var that = this;
        open(that.path, that.flags, that.mode, function(err, fd) {
          if (err) {
            that.destroy();
            that.emit("error", err);
          } else {
            that.fd = fd;
            that.emit("open", fd);
          }
        });
      }
      function createReadStream2(path4, options) {
        return new fs5.ReadStream(path4, options);
      }
      function createWriteStream(path4, options) {
        return new fs5.WriteStream(path4, options);
      }
      var fs$open = fs5.open;
      fs5.open = open;
      function open(path4, flags, mode, cb) {
        if (typeof mode === "function")
          cb = mode, mode = null;
        return go$open(path4, flags, mode, cb);
        function go$open(path5, flags2, mode2, cb2, startTime) {
          return fs$open(path5, flags2, mode2, function(err, fd) {
            if (err && (err.code === "EMFILE" || err.code === "ENFILE"))
              enqueue([go$open, [path5, flags2, mode2, cb2], err, startTime || Date.now(), Date.now()]);
            else {
              if (typeof cb2 === "function")
                cb2.apply(this, arguments);
            }
          });
        }
      }
      return fs5;
    }
    function enqueue(elem) {
      debug("ENQUEUE", elem[0].name, elem[1]);
      fs4[gracefulQueue].push(elem);
      retry();
    }
    var retryTimer;
    function resetQueue() {
      var now = Date.now();
      for (var i2 = 0; i2 < fs4[gracefulQueue].length; ++i2) {
        if (fs4[gracefulQueue][i2].length > 2) {
          fs4[gracefulQueue][i2][3] = now;
          fs4[gracefulQueue][i2][4] = now;
        }
      }
      retry();
    }
    function retry() {
      clearTimeout(retryTimer);
      retryTimer = void 0;
      if (fs4[gracefulQueue].length === 0)
        return;
      var elem = fs4[gracefulQueue].shift();
      var fn = elem[0];
      var args = elem[1];
      var err = elem[2];
      var startTime = elem[3];
      var lastTime = elem[4];
      if (startTime === void 0) {
        debug("RETRY", fn.name, args);
        fn.apply(null, args);
      } else if (Date.now() - startTime >= 6e4) {
        debug("TIMEOUT", fn.name, args);
        var cb = args.pop();
        if (typeof cb === "function")
          cb.call(null, err);
      } else {
        var sinceAttempt = Date.now() - lastTime;
        var sinceStart = Math.max(lastTime - startTime, 1);
        var desiredDelay = Math.min(sinceStart * 1.2, 100);
        if (sinceAttempt >= desiredDelay) {
          debug("RETRY", fn.name, args);
          fn.apply(null, args.concat([startTime]));
        } else {
          fs4[gracefulQueue].push(elem);
        }
      }
      if (retryTimer === void 0) {
        retryTimer = setTimeout(retry, 0);
      }
    }
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/fs/index.js
var require_fs8 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/fs/index.js"(exports) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs3();
    var api = [
      "access",
      "appendFile",
      "chmod",
      "chown",
      "close",
      "copyFile",
      "fchmod",
      "fchown",
      "fdatasync",
      "fstat",
      "fsync",
      "ftruncate",
      "futimes",
      "lchown",
      "lchmod",
      "link",
      "lstat",
      "mkdir",
      "mkdtemp",
      "open",
      "readFile",
      "readdir",
      "readlink",
      "realpath",
      "rename",
      "rmdir",
      "stat",
      "symlink",
      "truncate",
      "unlink",
      "utimes",
      "writeFile"
    ].filter((key) => {
      return typeof fs4[key] === "function";
    });
    Object.keys(fs4).forEach((key) => {
      if (key === "promises") {
        return;
      }
      exports[key] = fs4[key];
    });
    api.forEach((method) => {
      exports[method] = u(fs4[method]);
    });
    exports.exists = function(filename, callback) {
      if (typeof callback === "function") {
        return fs4.exists(filename, callback);
      }
      return new Promise((resolve) => {
        return fs4.exists(filename, resolve);
      });
    };
    exports.read = function(fd, buffer, offset, length, position, callback) {
      if (typeof callback === "function") {
        return fs4.read(fd, buffer, offset, length, position, callback);
      }
      return new Promise((resolve, reject) => {
        fs4.read(fd, buffer, offset, length, position, (err, bytesRead, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesRead, buffer: buffer2 });
        });
      });
    };
    exports.write = function(fd, buffer, ...args) {
      if (typeof args[args.length - 1] === "function") {
        return fs4.write(fd, buffer, ...args);
      }
      return new Promise((resolve, reject) => {
        fs4.write(fd, buffer, ...args, (err, bytesWritten, buffer2) => {
          if (err)
            return reject(err);
          resolve({ bytesWritten, buffer: buffer2 });
        });
      });
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/mkdirs/win32.js
var require_win323 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/mkdirs/win32.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    function getRootPath(p) {
      p = path4.normalize(path4.resolve(p)).split(path4.sep);
      if (p.length > 0)
        return p[0];
      return null;
    }
    var INVALID_PATH_CHARS = /[<>:"|?*]/;
    function invalidWin32Path(p) {
      const rp = getRootPath(p);
      p = p.replace(rp, "");
      return INVALID_PATH_CHARS.test(p);
    }
    module2.exports = {
      getRootPath,
      invalidWin32Path
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/mkdirs/mkdirs.js
var require_mkdirs6 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/mkdirs/mkdirs.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var invalidWin32Path = require_win323().invalidWin32Path;
    var o777 = parseInt("0777", 8);
    function mkdirs(p, opts, callback, made) {
      if (typeof opts === "function") {
        callback = opts;
        opts = {};
      } else if (!opts || typeof opts !== "object") {
        opts = { mode: opts };
      }
      if (process.platform === "win32" && invalidWin32Path(p)) {
        const errInval = new Error(p + " contains invalid WIN32 path characters.");
        errInval.code = "EINVAL";
        return callback(errInval);
      }
      let mode = opts.mode;
      const xfs = opts.fs || fs4;
      if (mode === void 0) {
        mode = o777 & ~process.umask();
      }
      if (!made)
        made = null;
      callback = callback || function() {
      };
      p = path4.resolve(p);
      xfs.mkdir(p, mode, (er) => {
        if (!er) {
          made = made || p;
          return callback(null, made);
        }
        switch (er.code) {
          case "ENOENT":
            if (path4.dirname(p) === p)
              return callback(er);
            mkdirs(path4.dirname(p), opts, (er2, made2) => {
              if (er2)
                callback(er2, made2);
              else
                mkdirs(p, opts, callback, made2);
            });
            break;
          default:
            xfs.stat(p, (er2, stat3) => {
              if (er2 || !stat3.isDirectory())
                callback(er, made);
              else
                callback(null, made);
            });
            break;
        }
      });
    }
    module2.exports = mkdirs;
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/mkdirs/mkdirs-sync.js
var require_mkdirs_sync3 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/mkdirs/mkdirs-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var invalidWin32Path = require_win323().invalidWin32Path;
    var o777 = parseInt("0777", 8);
    function mkdirsSync(p, opts, made) {
      if (!opts || typeof opts !== "object") {
        opts = { mode: opts };
      }
      let mode = opts.mode;
      const xfs = opts.fs || fs4;
      if (process.platform === "win32" && invalidWin32Path(p)) {
        const errInval = new Error(p + " contains invalid WIN32 path characters.");
        errInval.code = "EINVAL";
        throw errInval;
      }
      if (mode === void 0) {
        mode = o777 & ~process.umask();
      }
      if (!made)
        made = null;
      p = path4.resolve(p);
      try {
        xfs.mkdirSync(p, mode);
        made = made || p;
      } catch (err0) {
        if (err0.code === "ENOENT") {
          if (path4.dirname(p) === p)
            throw err0;
          made = mkdirsSync(path4.dirname(p), opts, made);
          mkdirsSync(p, opts, made);
        } else {
          let stat3;
          try {
            stat3 = xfs.statSync(p);
          } catch (err1) {
            throw err0;
          }
          if (!stat3.isDirectory())
            throw err0;
        }
      }
      return made;
    }
    module2.exports = mkdirsSync;
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/mkdirs/index.js
var require_mkdirs7 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/mkdirs/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var mkdirs = u(require_mkdirs6());
    var mkdirsSync = require_mkdirs_sync3();
    module2.exports = {
      mkdirs,
      mkdirsSync,
      mkdirp: mkdirs,
      mkdirpSync: mkdirsSync,
      ensureDir: mkdirs,
      ensureDirSync: mkdirsSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/util/utimes.js
var require_utimes4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/util/utimes.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    var os = require("os");
    var path4 = require("path");
    function hasMillisResSync() {
      let tmpfile = path4.join("millis-test-sync" + Date.now().toString() + Math.random().toString().slice(2));
      tmpfile = path4.join(os.tmpdir(), tmpfile);
      const d = new Date(1435410243862);
      fs4.writeFileSync(tmpfile, "https://github.com/jprichardson/node-fs-extra/pull/141");
      const fd = fs4.openSync(tmpfile, "r+");
      fs4.futimesSync(fd, d, d);
      fs4.closeSync(fd);
      return fs4.statSync(tmpfile).mtime > 1435410243e3;
    }
    function hasMillisRes(callback) {
      let tmpfile = path4.join("millis-test" + Date.now().toString() + Math.random().toString().slice(2));
      tmpfile = path4.join(os.tmpdir(), tmpfile);
      const d = new Date(1435410243862);
      fs4.writeFile(tmpfile, "https://github.com/jprichardson/node-fs-extra/pull/141", (err) => {
        if (err)
          return callback(err);
        fs4.open(tmpfile, "r+", (err2, fd) => {
          if (err2)
            return callback(err2);
          fs4.futimes(fd, d, d, (err3) => {
            if (err3)
              return callback(err3);
            fs4.close(fd, (err4) => {
              if (err4)
                return callback(err4);
              fs4.stat(tmpfile, (err5, stats) => {
                if (err5)
                  return callback(err5);
                callback(null, stats.mtime > 1435410243e3);
              });
            });
          });
        });
      });
    }
    function timeRemoveMillis(timestamp) {
      if (typeof timestamp === "number") {
        return Math.floor(timestamp / 1e3) * 1e3;
      } else if (timestamp instanceof Date) {
        return new Date(Math.floor(timestamp.getTime() / 1e3) * 1e3);
      } else {
        throw new Error("fs-extra: timeRemoveMillis() unknown parameter type");
      }
    }
    function utimesMillis(path5, atime, mtime, callback) {
      fs4.open(path5, "r+", (err, fd) => {
        if (err)
          return callback(err);
        fs4.futimes(fd, atime, mtime, (futimesErr) => {
          fs4.close(fd, (closeErr) => {
            if (callback)
              callback(futimesErr || closeErr);
          });
        });
      });
    }
    function utimesMillisSync(path5, atime, mtime) {
      const fd = fs4.openSync(path5, "r+");
      fs4.futimesSync(fd, atime, mtime);
      return fs4.closeSync(fd);
    }
    module2.exports = {
      hasMillisRes,
      hasMillisResSync,
      timeRemoveMillis,
      utimesMillis,
      utimesMillisSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/util/buffer.js
var require_buffer3 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/util/buffer.js"(exports, module2) {
    "use strict";
    module2.exports = function(size) {
      if (typeof Buffer.allocUnsafe === "function") {
        try {
          return Buffer.allocUnsafe(size);
        } catch (e2) {
          return new Buffer(size);
        }
      }
      return new Buffer(size);
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/copy-sync/copy-sync.js
var require_copy_sync6 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/copy-sync/copy-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var mkdirpSync = require_mkdirs7().mkdirsSync;
    var utimesSync = require_utimes4().utimesMillisSync;
    var notExist = Symbol("notExist");
    function copySync(src, dest, opts) {
      if (typeof opts === "function") {
        opts = { filter: opts };
      }
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      const destStat = checkPaths(src, dest);
      if (opts.filter && !opts.filter(src, dest))
        return;
      const destParent = path4.dirname(dest);
      if (!fs4.existsSync(destParent))
        mkdirpSync(destParent);
      return startCopy(destStat, src, dest, opts);
    }
    function startCopy(destStat, src, dest, opts) {
      if (opts.filter && !opts.filter(src, dest))
        return;
      return getStats(destStat, src, dest, opts);
    }
    function getStats(destStat, src, dest, opts) {
      const statSync2 = opts.dereference ? fs4.statSync : fs4.lstatSync;
      const srcStat = statSync2(src);
      if (srcStat.isDirectory())
        return onDir(srcStat, destStat, src, dest, opts);
      else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
        return onFile(srcStat, destStat, src, dest, opts);
      else if (srcStat.isSymbolicLink())
        return onLink(destStat, src, dest, opts);
    }
    function onFile(srcStat, destStat, src, dest, opts) {
      if (destStat === notExist)
        return copyFile(srcStat, src, dest, opts);
      return mayCopyFile(srcStat, src, dest, opts);
    }
    function mayCopyFile(srcStat, src, dest, opts) {
      if (opts.overwrite) {
        fs4.unlinkSync(dest);
        return copyFile(srcStat, src, dest, opts);
      } else if (opts.errorOnExist) {
        throw new Error(`'${dest}' already exists`);
      }
    }
    function copyFile(srcStat, src, dest, opts) {
      if (typeof fs4.copyFileSync === "function") {
        fs4.copyFileSync(src, dest);
        fs4.chmodSync(dest, srcStat.mode);
        if (opts.preserveTimestamps) {
          return utimesSync(dest, srcStat.atime, srcStat.mtime);
        }
        return;
      }
      return copyFileFallback(srcStat, src, dest, opts);
    }
    function copyFileFallback(srcStat, src, dest, opts) {
      const BUF_LENGTH = 64 * 1024;
      const _buff = require_buffer3()(BUF_LENGTH);
      const fdr = fs4.openSync(src, "r");
      const fdw = fs4.openSync(dest, "w", srcStat.mode);
      let pos = 0;
      while (pos < srcStat.size) {
        const bytesRead = fs4.readSync(fdr, _buff, 0, BUF_LENGTH, pos);
        fs4.writeSync(fdw, _buff, 0, bytesRead);
        pos += bytesRead;
      }
      if (opts.preserveTimestamps)
        fs4.futimesSync(fdw, srcStat.atime, srcStat.mtime);
      fs4.closeSync(fdr);
      fs4.closeSync(fdw);
    }
    function onDir(srcStat, destStat, src, dest, opts) {
      if (destStat === notExist)
        return mkDirAndCopy(srcStat, src, dest, opts);
      if (destStat && !destStat.isDirectory()) {
        throw new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`);
      }
      return copyDir(src, dest, opts);
    }
    function mkDirAndCopy(srcStat, src, dest, opts) {
      fs4.mkdirSync(dest);
      copyDir(src, dest, opts);
      return fs4.chmodSync(dest, srcStat.mode);
    }
    function copyDir(src, dest, opts) {
      fs4.readdirSync(src).forEach((item) => copyDirItem(item, src, dest, opts));
    }
    function copyDirItem(item, src, dest, opts) {
      const srcItem = path4.join(src, item);
      const destItem = path4.join(dest, item);
      const destStat = checkPaths(srcItem, destItem);
      return startCopy(destStat, srcItem, destItem, opts);
    }
    function onLink(destStat, src, dest, opts) {
      let resolvedSrc = fs4.readlinkSync(src);
      if (opts.dereference) {
        resolvedSrc = path4.resolve(process.cwd(), resolvedSrc);
      }
      if (destStat === notExist) {
        return fs4.symlinkSync(resolvedSrc, dest);
      } else {
        let resolvedDest;
        try {
          resolvedDest = fs4.readlinkSync(dest);
        } catch (err) {
          if (err.code === "EINVAL" || err.code === "UNKNOWN")
            return fs4.symlinkSync(resolvedSrc, dest);
          throw err;
        }
        if (opts.dereference) {
          resolvedDest = path4.resolve(process.cwd(), resolvedDest);
        }
        if (isSrcSubdir(resolvedSrc, resolvedDest)) {
          throw new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`);
        }
        if (fs4.statSync(dest).isDirectory() && isSrcSubdir(resolvedDest, resolvedSrc)) {
          throw new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`);
        }
        return copyLink(resolvedSrc, dest);
      }
    }
    function copyLink(resolvedSrc, dest) {
      fs4.unlinkSync(dest);
      return fs4.symlinkSync(resolvedSrc, dest);
    }
    function isSrcSubdir(src, dest) {
      const srcArray = path4.resolve(src).split(path4.sep);
      const destArray = path4.resolve(dest).split(path4.sep);
      return srcArray.reduce((acc, current, i2) => acc && destArray[i2] === current, true);
    }
    function checkStats(src, dest) {
      const srcStat = fs4.statSync(src);
      let destStat;
      try {
        destStat = fs4.statSync(dest);
      } catch (err) {
        if (err.code === "ENOENT")
          return { srcStat, destStat: notExist };
        throw err;
      }
      return { srcStat, destStat };
    }
    function checkPaths(src, dest) {
      const { srcStat, destStat } = checkStats(src, dest);
      if (destStat.ino && destStat.ino === srcStat.ino) {
        throw new Error("Source and destination must not be the same.");
      }
      if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
        throw new Error(`Cannot copy '${src}' to a subdirectory of itself, '${dest}'.`);
      }
      return destStat;
    }
    module2.exports = copySync;
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/copy-sync/index.js
var require_copy_sync7 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/copy-sync/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      copySync: require_copy_sync6()
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/path-exists/index.js
var require_path_exists5 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/path-exists/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromPromise;
    var fs4 = require_fs8();
    function pathExists(path4) {
      return fs4.access(path4).then(() => true).catch(() => false);
    }
    module2.exports = {
      pathExists: u(pathExists),
      pathExistsSync: fs4.existsSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/copy/copy.js
var require_copy7 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/copy/copy.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var mkdirp2 = require_mkdirs7().mkdirs;
    var pathExists = require_path_exists5().pathExists;
    var utimes = require_utimes4().utimesMillis;
    var notExist = Symbol("notExist");
    function copy(src, dest, opts, cb) {
      if (typeof opts === "function" && !cb) {
        cb = opts;
        opts = {};
      } else if (typeof opts === "function") {
        opts = { filter: opts };
      }
      cb = cb || function() {
      };
      opts = opts || {};
      opts.clobber = "clobber" in opts ? !!opts.clobber : true;
      opts.overwrite = "overwrite" in opts ? !!opts.overwrite : opts.clobber;
      if (opts.preserveTimestamps && process.arch === "ia32") {
        console.warn(`fs-extra: Using the preserveTimestamps option in 32-bit node is not recommended;

    see https://github.com/jprichardson/node-fs-extra/issues/269`);
      }
      checkPaths(src, dest, (err, destStat) => {
        if (err)
          return cb(err);
        if (opts.filter)
          return handleFilter(checkParentDir, destStat, src, dest, opts, cb);
        return checkParentDir(destStat, src, dest, opts, cb);
      });
    }
    function checkParentDir(destStat, src, dest, opts, cb) {
      const destParent = path4.dirname(dest);
      pathExists(destParent, (err, dirExists) => {
        if (err)
          return cb(err);
        if (dirExists)
          return startCopy(destStat, src, dest, opts, cb);
        mkdirp2(destParent, (err2) => {
          if (err2)
            return cb(err2);
          return startCopy(destStat, src, dest, opts, cb);
        });
      });
    }
    function handleFilter(onInclude, destStat, src, dest, opts, cb) {
      Promise.resolve(opts.filter(src, dest)).then((include) => {
        if (include) {
          if (destStat)
            return onInclude(destStat, src, dest, opts, cb);
          return onInclude(src, dest, opts, cb);
        }
        return cb();
      }, (error) => cb(error));
    }
    function startCopy(destStat, src, dest, opts, cb) {
      if (opts.filter)
        return handleFilter(getStats, destStat, src, dest, opts, cb);
      return getStats(destStat, src, dest, opts, cb);
    }
    function getStats(destStat, src, dest, opts, cb) {
      const stat3 = opts.dereference ? fs4.stat : fs4.lstat;
      stat3(src, (err, srcStat) => {
        if (err)
          return cb(err);
        if (srcStat.isDirectory())
          return onDir(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isFile() || srcStat.isCharacterDevice() || srcStat.isBlockDevice())
          return onFile(srcStat, destStat, src, dest, opts, cb);
        else if (srcStat.isSymbolicLink())
          return onLink(destStat, src, dest, opts, cb);
      });
    }
    function onFile(srcStat, destStat, src, dest, opts, cb) {
      if (destStat === notExist)
        return copyFile(srcStat, src, dest, opts, cb);
      return mayCopyFile(srcStat, src, dest, opts, cb);
    }
    function mayCopyFile(srcStat, src, dest, opts, cb) {
      if (opts.overwrite) {
        fs4.unlink(dest, (err) => {
          if (err)
            return cb(err);
          return copyFile(srcStat, src, dest, opts, cb);
        });
      } else if (opts.errorOnExist) {
        return cb(new Error(`'${dest}' already exists`));
      } else
        return cb();
    }
    function copyFile(srcStat, src, dest, opts, cb) {
      if (typeof fs4.copyFile === "function") {
        return fs4.copyFile(src, dest, (err) => {
          if (err)
            return cb(err);
          return setDestModeAndTimestamps(srcStat, dest, opts, cb);
        });
      }
      return copyFileFallback(srcStat, src, dest, opts, cb);
    }
    function copyFileFallback(srcStat, src, dest, opts, cb) {
      const rs = fs4.createReadStream(src);
      rs.on("error", (err) => cb(err)).once("open", () => {
        const ws = fs4.createWriteStream(dest, { mode: srcStat.mode });
        ws.on("error", (err) => cb(err)).on("open", () => rs.pipe(ws)).once("close", () => setDestModeAndTimestamps(srcStat, dest, opts, cb));
      });
    }
    function setDestModeAndTimestamps(srcStat, dest, opts, cb) {
      fs4.chmod(dest, srcStat.mode, (err) => {
        if (err)
          return cb(err);
        if (opts.preserveTimestamps) {
          return utimes(dest, srcStat.atime, srcStat.mtime, cb);
        }
        return cb();
      });
    }
    function onDir(srcStat, destStat, src, dest, opts, cb) {
      if (destStat === notExist)
        return mkDirAndCopy(srcStat, src, dest, opts, cb);
      if (destStat && !destStat.isDirectory()) {
        return cb(new Error(`Cannot overwrite non-directory '${dest}' with directory '${src}'.`));
      }
      return copyDir(src, dest, opts, cb);
    }
    function mkDirAndCopy(srcStat, src, dest, opts, cb) {
      fs4.mkdir(dest, (err) => {
        if (err)
          return cb(err);
        copyDir(src, dest, opts, (err2) => {
          if (err2)
            return cb(err2);
          return fs4.chmod(dest, srcStat.mode, cb);
        });
      });
    }
    function copyDir(src, dest, opts, cb) {
      fs4.readdir(src, (err, items) => {
        if (err)
          return cb(err);
        return copyDirItems(items, src, dest, opts, cb);
      });
    }
    function copyDirItems(items, src, dest, opts, cb) {
      const item = items.pop();
      if (!item)
        return cb();
      return copyDirItem(items, item, src, dest, opts, cb);
    }
    function copyDirItem(items, item, src, dest, opts, cb) {
      const srcItem = path4.join(src, item);
      const destItem = path4.join(dest, item);
      checkPaths(srcItem, destItem, (err, destStat) => {
        if (err)
          return cb(err);
        startCopy(destStat, srcItem, destItem, opts, (err2) => {
          if (err2)
            return cb(err2);
          return copyDirItems(items, src, dest, opts, cb);
        });
      });
    }
    function onLink(destStat, src, dest, opts, cb) {
      fs4.readlink(src, (err, resolvedSrc) => {
        if (err)
          return cb(err);
        if (opts.dereference) {
          resolvedSrc = path4.resolve(process.cwd(), resolvedSrc);
        }
        if (destStat === notExist) {
          return fs4.symlink(resolvedSrc, dest, cb);
        } else {
          fs4.readlink(dest, (err2, resolvedDest) => {
            if (err2) {
              if (err2.code === "EINVAL" || err2.code === "UNKNOWN")
                return fs4.symlink(resolvedSrc, dest, cb);
              return cb(err2);
            }
            if (opts.dereference) {
              resolvedDest = path4.resolve(process.cwd(), resolvedDest);
            }
            if (isSrcSubdir(resolvedSrc, resolvedDest)) {
              return cb(new Error(`Cannot copy '${resolvedSrc}' to a subdirectory of itself, '${resolvedDest}'.`));
            }
            if (destStat.isDirectory() && isSrcSubdir(resolvedDest, resolvedSrc)) {
              return cb(new Error(`Cannot overwrite '${resolvedDest}' with '${resolvedSrc}'.`));
            }
            return copyLink(resolvedSrc, dest, cb);
          });
        }
      });
    }
    function copyLink(resolvedSrc, dest, cb) {
      fs4.unlink(dest, (err) => {
        if (err)
          return cb(err);
        return fs4.symlink(resolvedSrc, dest, cb);
      });
    }
    function isSrcSubdir(src, dest) {
      const srcArray = path4.resolve(src).split(path4.sep);
      const destArray = path4.resolve(dest).split(path4.sep);
      return srcArray.reduce((acc, current, i2) => acc && destArray[i2] === current, true);
    }
    function checkStats(src, dest, cb) {
      fs4.stat(src, (err, srcStat) => {
        if (err)
          return cb(err);
        fs4.stat(dest, (err2, destStat) => {
          if (err2) {
            if (err2.code === "ENOENT")
              return cb(null, { srcStat, destStat: notExist });
            return cb(err2);
          }
          return cb(null, { srcStat, destStat });
        });
      });
    }
    function checkPaths(src, dest, cb) {
      checkStats(src, dest, (err, stats) => {
        if (err)
          return cb(err);
        const { srcStat, destStat } = stats;
        if (destStat.ino && destStat.ino === srcStat.ino) {
          return cb(new Error("Source and destination must not be the same."));
        }
        if (srcStat.isDirectory() && isSrcSubdir(src, dest)) {
          return cb(new Error(`Cannot copy '${src}' to a subdirectory of itself, '${dest}'.`));
        }
        return cb(null, destStat);
      });
    }
    module2.exports = copy;
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/copy/index.js
var require_copy8 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/copy/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    module2.exports = {
      copy: u(require_copy7())
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/remove/rimraf.js
var require_rimraf4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/remove/rimraf.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var assert = require("assert");
    var isWindows = process.platform === "win32";
    function defaults(options) {
      const methods = [
        "unlink",
        "chmod",
        "stat",
        "lstat",
        "rmdir",
        "readdir"
      ];
      methods.forEach((m2) => {
        options[m2] = options[m2] || fs4[m2];
        m2 = m2 + "Sync";
        options[m2] = options[m2] || fs4[m2];
      });
      options.maxBusyTries = options.maxBusyTries || 3;
    }
    function rimraf(p, options, cb) {
      let busyTries = 0;
      if (typeof options === "function") {
        cb = options;
        options = {};
      }
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert.strictEqual(typeof cb, "function", "rimraf: callback function required");
      assert(options, "rimraf: invalid options argument provided");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      defaults(options);
      rimraf_(p, options, function CB(er) {
        if (er) {
          if ((er.code === "EBUSY" || er.code === "ENOTEMPTY" || er.code === "EPERM") && busyTries < options.maxBusyTries) {
            busyTries++;
            const time = busyTries * 100;
            return setTimeout(() => rimraf_(p, options, CB), time);
          }
          if (er.code === "ENOENT")
            er = null;
        }
        cb(er);
      });
    }
    function rimraf_(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.lstat(p, (er, st) => {
        if (er && er.code === "ENOENT") {
          return cb(null);
        }
        if (er && er.code === "EPERM" && isWindows) {
          return fixWinEPERM(p, options, er, cb);
        }
        if (st && st.isDirectory()) {
          return rmdir(p, options, er, cb);
        }
        options.unlink(p, (er2) => {
          if (er2) {
            if (er2.code === "ENOENT") {
              return cb(null);
            }
            if (er2.code === "EPERM") {
              return isWindows ? fixWinEPERM(p, options, er2, cb) : rmdir(p, options, er2, cb);
            }
            if (er2.code === "EISDIR") {
              return rmdir(p, options, er2, cb);
            }
          }
          return cb(er2);
        });
      });
    }
    function fixWinEPERM(p, options, er, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      if (er) {
        assert(er instanceof Error);
      }
      options.chmod(p, 438, (er2) => {
        if (er2) {
          cb(er2.code === "ENOENT" ? null : er);
        } else {
          options.stat(p, (er3, stats) => {
            if (er3) {
              cb(er3.code === "ENOENT" ? null : er);
            } else if (stats.isDirectory()) {
              rmdir(p, options, er, cb);
            } else {
              options.unlink(p, cb);
            }
          });
        }
      });
    }
    function fixWinEPERMSync(p, options, er) {
      let stats;
      assert(p);
      assert(options);
      if (er) {
        assert(er instanceof Error);
      }
      try {
        options.chmodSync(p, 438);
      } catch (er2) {
        if (er2.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      try {
        stats = options.statSync(p);
      } catch (er3) {
        if (er3.code === "ENOENT") {
          return;
        } else {
          throw er;
        }
      }
      if (stats.isDirectory()) {
        rmdirSync(p, options, er);
      } else {
        options.unlinkSync(p);
      }
    }
    function rmdir(p, options, originalEr, cb) {
      assert(p);
      assert(options);
      if (originalEr) {
        assert(originalEr instanceof Error);
      }
      assert(typeof cb === "function");
      options.rmdir(p, (er) => {
        if (er && (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM")) {
          rmkids(p, options, cb);
        } else if (er && er.code === "ENOTDIR") {
          cb(originalEr);
        } else {
          cb(er);
        }
      });
    }
    function rmkids(p, options, cb) {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.readdir(p, (er, files) => {
        if (er)
          return cb(er);
        let n = files.length;
        let errState;
        if (n === 0)
          return options.rmdir(p, cb);
        files.forEach((f3) => {
          rimraf(path4.join(p, f3), options, (er2) => {
            if (errState) {
              return;
            }
            if (er2)
              return cb(errState = er2);
            if (--n === 0) {
              options.rmdir(p, cb);
            }
          });
        });
      });
    }
    function rimrafSync(p, options) {
      let st;
      options = options || {};
      defaults(options);
      assert(p, "rimraf: missing path");
      assert.strictEqual(typeof p, "string", "rimraf: path should be a string");
      assert(options, "rimraf: missing options");
      assert.strictEqual(typeof options, "object", "rimraf: options should be object");
      try {
        st = options.lstatSync(p);
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        }
        if (er.code === "EPERM" && isWindows) {
          fixWinEPERMSync(p, options, er);
        }
      }
      try {
        if (st && st.isDirectory()) {
          rmdirSync(p, options, null);
        } else {
          options.unlinkSync(p);
        }
      } catch (er) {
        if (er.code === "ENOENT") {
          return;
        } else if (er.code === "EPERM") {
          return isWindows ? fixWinEPERMSync(p, options, er) : rmdirSync(p, options, er);
        } else if (er.code !== "EISDIR") {
          throw er;
        }
        rmdirSync(p, options, er);
      }
    }
    function rmdirSync(p, options, originalEr) {
      assert(p);
      assert(options);
      if (originalEr) {
        assert(originalEr instanceof Error);
      }
      try {
        options.rmdirSync(p);
      } catch (er) {
        if (er.code === "ENOTDIR") {
          throw originalEr;
        } else if (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM") {
          rmkidsSync(p, options);
        } else if (er.code !== "ENOENT") {
          throw er;
        }
      }
    }
    function rmkidsSync(p, options) {
      assert(p);
      assert(options);
      options.readdirSync(p).forEach((f3) => rimrafSync(path4.join(p, f3), options));
      if (isWindows) {
        const startTime = Date.now();
        do {
          try {
            const ret = options.rmdirSync(p, options);
            return ret;
          } catch (er) {
          }
        } while (Date.now() - startTime < 500);
      } else {
        const ret = options.rmdirSync(p, options);
        return ret;
      }
    }
    module2.exports = rimraf;
    rimraf.sync = rimrafSync;
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/remove/index.js
var require_remove5 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/remove/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var rimraf = require_rimraf4();
    module2.exports = {
      remove: u(rimraf),
      removeSync: rimraf.sync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/empty/index.js
var require_empty4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/empty/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require("fs");
    var path4 = require("path");
    var mkdir = require_mkdirs7();
    var remove = require_remove5();
    var emptyDir = u(function emptyDir2(dir, callback) {
      callback = callback || function() {
      };
      fs4.readdir(dir, (err, items) => {
        if (err)
          return mkdir.mkdirs(dir, callback);
        items = items.map((item) => path4.join(dir, item));
        deleteItem();
        function deleteItem() {
          const item = items.pop();
          if (!item)
            return callback();
          remove.remove(item, (err2) => {
            if (err2)
              return callback(err2);
            deleteItem();
          });
        }
      });
    });
    function emptyDirSync(dir) {
      let items;
      try {
        items = fs4.readdirSync(dir);
      } catch (err) {
        return mkdir.mkdirsSync(dir);
      }
      items.forEach((item) => {
        item = path4.join(dir, item);
        remove.removeSync(item);
      });
    }
    module2.exports = {
      emptyDirSync,
      emptydirSync: emptyDirSync,
      emptyDir,
      emptydir: emptyDir
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/file.js
var require_file4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/file.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs3();
    var mkdir = require_mkdirs7();
    var pathExists = require_path_exists5().pathExists;
    function createFile(file, callback) {
      function makeFile() {
        fs4.writeFile(file, "", (err) => {
          if (err)
            return callback(err);
          callback();
        });
      }
      fs4.stat(file, (err, stats) => {
        if (!err && stats.isFile())
          return callback();
        const dir = path4.dirname(file);
        pathExists(dir, (err2, dirExists) => {
          if (err2)
            return callback(err2);
          if (dirExists)
            return makeFile();
          mkdir.mkdirs(dir, (err3) => {
            if (err3)
              return callback(err3);
            makeFile();
          });
        });
      });
    }
    function createFileSync(file) {
      let stats;
      try {
        stats = fs4.statSync(file);
      } catch (e2) {
      }
      if (stats && stats.isFile())
        return;
      const dir = path4.dirname(file);
      if (!fs4.existsSync(dir)) {
        mkdir.mkdirsSync(dir);
      }
      fs4.writeFileSync(file, "");
    }
    module2.exports = {
      createFile: u(createFile),
      createFileSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/link.js
var require_link4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/link.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs3();
    var mkdir = require_mkdirs7();
    var pathExists = require_path_exists5().pathExists;
    function createLink(srcpath, dstpath, callback) {
      function makeLink(srcpath2, dstpath2) {
        fs4.link(srcpath2, dstpath2, (err) => {
          if (err)
            return callback(err);
          callback(null);
        });
      }
      pathExists(dstpath, (err, destinationExists) => {
        if (err)
          return callback(err);
        if (destinationExists)
          return callback(null);
        fs4.lstat(srcpath, (err2) => {
          if (err2) {
            err2.message = err2.message.replace("lstat", "ensureLink");
            return callback(err2);
          }
          const dir = path4.dirname(dstpath);
          pathExists(dir, (err3, dirExists) => {
            if (err3)
              return callback(err3);
            if (dirExists)
              return makeLink(srcpath, dstpath);
            mkdir.mkdirs(dir, (err4) => {
              if (err4)
                return callback(err4);
              makeLink(srcpath, dstpath);
            });
          });
        });
      });
    }
    function createLinkSync(srcpath, dstpath) {
      const destinationExists = fs4.existsSync(dstpath);
      if (destinationExists)
        return void 0;
      try {
        fs4.lstatSync(srcpath);
      } catch (err) {
        err.message = err.message.replace("lstat", "ensureLink");
        throw err;
      }
      const dir = path4.dirname(dstpath);
      const dirExists = fs4.existsSync(dir);
      if (dirExists)
        return fs4.linkSync(srcpath, dstpath);
      mkdir.mkdirsSync(dir);
      return fs4.linkSync(srcpath, dstpath);
    }
    module2.exports = {
      createLink: u(createLink),
      createLinkSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/symlink-paths.js
var require_symlink_paths4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/symlink-paths.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var fs4 = require_graceful_fs3();
    var pathExists = require_path_exists5().pathExists;
    function symlinkPaths(srcpath, dstpath, callback) {
      if (path4.isAbsolute(srcpath)) {
        return fs4.lstat(srcpath, (err) => {
          if (err) {
            err.message = err.message.replace("lstat", "ensureSymlink");
            return callback(err);
          }
          return callback(null, {
            "toCwd": srcpath,
            "toDst": srcpath
          });
        });
      } else {
        const dstdir = path4.dirname(dstpath);
        const relativeToDst = path4.join(dstdir, srcpath);
        return pathExists(relativeToDst, (err, exists) => {
          if (err)
            return callback(err);
          if (exists) {
            return callback(null, {
              "toCwd": relativeToDst,
              "toDst": srcpath
            });
          } else {
            return fs4.lstat(srcpath, (err2) => {
              if (err2) {
                err2.message = err2.message.replace("lstat", "ensureSymlink");
                return callback(err2);
              }
              return callback(null, {
                "toCwd": srcpath,
                "toDst": path4.relative(dstdir, srcpath)
              });
            });
          }
        });
      }
    }
    function symlinkPathsSync(srcpath, dstpath) {
      let exists;
      if (path4.isAbsolute(srcpath)) {
        exists = fs4.existsSync(srcpath);
        if (!exists)
          throw new Error("absolute srcpath does not exist");
        return {
          "toCwd": srcpath,
          "toDst": srcpath
        };
      } else {
        const dstdir = path4.dirname(dstpath);
        const relativeToDst = path4.join(dstdir, srcpath);
        exists = fs4.existsSync(relativeToDst);
        if (exists) {
          return {
            "toCwd": relativeToDst,
            "toDst": srcpath
          };
        } else {
          exists = fs4.existsSync(srcpath);
          if (!exists)
            throw new Error("relative srcpath does not exist");
          return {
            "toCwd": srcpath,
            "toDst": path4.relative(dstdir, srcpath)
          };
        }
      }
    }
    module2.exports = {
      symlinkPaths,
      symlinkPathsSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/symlink-type.js
var require_symlink_type4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/symlink-type.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    function symlinkType(srcpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      if (type)
        return callback(null, type);
      fs4.lstat(srcpath, (err, stats) => {
        if (err)
          return callback(null, "file");
        type = stats && stats.isDirectory() ? "dir" : "file";
        callback(null, type);
      });
    }
    function symlinkTypeSync(srcpath, type) {
      let stats;
      if (type)
        return type;
      try {
        stats = fs4.lstatSync(srcpath);
      } catch (e2) {
        return "file";
      }
      return stats && stats.isDirectory() ? "dir" : "file";
    }
    module2.exports = {
      symlinkType,
      symlinkTypeSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/symlink.js
var require_symlink4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/symlink.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var path4 = require("path");
    var fs4 = require_graceful_fs3();
    var _mkdirs = require_mkdirs7();
    var mkdirs = _mkdirs.mkdirs;
    var mkdirsSync = _mkdirs.mkdirsSync;
    var _symlinkPaths = require_symlink_paths4();
    var symlinkPaths = _symlinkPaths.symlinkPaths;
    var symlinkPathsSync = _symlinkPaths.symlinkPathsSync;
    var _symlinkType = require_symlink_type4();
    var symlinkType = _symlinkType.symlinkType;
    var symlinkTypeSync = _symlinkType.symlinkTypeSync;
    var pathExists = require_path_exists5().pathExists;
    function createSymlink(srcpath, dstpath, type, callback) {
      callback = typeof type === "function" ? type : callback;
      type = typeof type === "function" ? false : type;
      pathExists(dstpath, (err, destinationExists) => {
        if (err)
          return callback(err);
        if (destinationExists)
          return callback(null);
        symlinkPaths(srcpath, dstpath, (err2, relative) => {
          if (err2)
            return callback(err2);
          srcpath = relative.toDst;
          symlinkType(relative.toCwd, type, (err3, type2) => {
            if (err3)
              return callback(err3);
            const dir = path4.dirname(dstpath);
            pathExists(dir, (err4, dirExists) => {
              if (err4)
                return callback(err4);
              if (dirExists)
                return fs4.symlink(srcpath, dstpath, type2, callback);
              mkdirs(dir, (err5) => {
                if (err5)
                  return callback(err5);
                fs4.symlink(srcpath, dstpath, type2, callback);
              });
            });
          });
        });
      });
    }
    function createSymlinkSync(srcpath, dstpath, type) {
      const destinationExists = fs4.existsSync(dstpath);
      if (destinationExists)
        return void 0;
      const relative = symlinkPathsSync(srcpath, dstpath);
      srcpath = relative.toDst;
      type = symlinkTypeSync(relative.toCwd, type);
      const dir = path4.dirname(dstpath);
      const exists = fs4.existsSync(dir);
      if (exists)
        return fs4.symlinkSync(srcpath, dstpath, type);
      mkdirsSync(dir);
      return fs4.symlinkSync(srcpath, dstpath, type);
    }
    module2.exports = {
      createSymlink: u(createSymlink),
      createSymlinkSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/index.js
var require_ensure4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/ensure/index.js"(exports, module2) {
    "use strict";
    var file = require_file4();
    var link = require_link4();
    var symlink = require_symlink4();
    module2.exports = {
      createFile: file.createFile,
      createFileSync: file.createFileSync,
      ensureFile: file.createFile,
      ensureFileSync: file.createFileSync,
      createLink: link.createLink,
      createLinkSync: link.createLinkSync,
      ensureLink: link.createLink,
      ensureLinkSync: link.createLinkSync,
      createSymlink: symlink.createSymlink,
      createSymlinkSync: symlink.createSymlinkSync,
      ensureSymlink: symlink.createSymlink,
      ensureSymlinkSync: symlink.createSymlinkSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/json/jsonfile.js
var require_jsonfile6 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/json/jsonfile.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var jsonFile = require_jsonfile3();
    module2.exports = {
      readJson: u(jsonFile.readFile),
      readJsonSync: jsonFile.readFileSync,
      writeJson: u(jsonFile.writeFile),
      writeJsonSync: jsonFile.writeFileSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/json/output-json.js
var require_output_json4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/json/output-json.js"(exports, module2) {
    "use strict";
    var path4 = require("path");
    var mkdir = require_mkdirs7();
    var pathExists = require_path_exists5().pathExists;
    var jsonFile = require_jsonfile6();
    function outputJson(file, data, options, callback) {
      if (typeof options === "function") {
        callback = options;
        options = {};
      }
      const dir = path4.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return jsonFile.writeJson(file, data, options, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          jsonFile.writeJson(file, data, options, callback);
        });
      });
    }
    module2.exports = outputJson;
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/json/output-json-sync.js
var require_output_json_sync4 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/json/output-json-sync.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var mkdir = require_mkdirs7();
    var jsonFile = require_jsonfile6();
    function outputJsonSync(file, data, options) {
      const dir = path4.dirname(file);
      if (!fs4.existsSync(dir)) {
        mkdir.mkdirsSync(dir);
      }
      jsonFile.writeJsonSync(file, data, options);
    }
    module2.exports = outputJsonSync;
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/json/index.js
var require_json5 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/json/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var jsonFile = require_jsonfile6();
    jsonFile.outputJson = u(require_output_json4());
    jsonFile.outputJsonSync = require_output_json_sync4();
    jsonFile.outputJSON = jsonFile.outputJson;
    jsonFile.outputJSONSync = jsonFile.outputJsonSync;
    jsonFile.writeJSON = jsonFile.writeJson;
    jsonFile.writeJSONSync = jsonFile.writeJsonSync;
    jsonFile.readJSON = jsonFile.readJson;
    jsonFile.readJSONSync = jsonFile.readJsonSync;
    module2.exports = jsonFile;
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/move-sync/index.js
var require_move_sync6 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/move-sync/index.js"(exports, module2) {
    "use strict";
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var copySync = require_copy_sync7().copySync;
    var removeSync = require_remove5().removeSync;
    var mkdirpSync = require_mkdirs7().mkdirsSync;
    var buffer = require_buffer3();
    function moveSync(src, dest, options) {
      options = options || {};
      const overwrite = options.overwrite || options.clobber || false;
      src = path4.resolve(src);
      dest = path4.resolve(dest);
      if (src === dest)
        return fs4.accessSync(src);
      if (isSrcSubdir(src, dest))
        throw new Error(`Cannot move '${src}' into itself '${dest}'.`);
      mkdirpSync(path4.dirname(dest));
      tryRenameSync();
      function tryRenameSync() {
        if (overwrite) {
          try {
            return fs4.renameSync(src, dest);
          } catch (err) {
            if (err.code === "ENOTEMPTY" || err.code === "EEXIST" || err.code === "EPERM") {
              removeSync(dest);
              options.overwrite = false;
              return moveSync(src, dest, options);
            }
            if (err.code !== "EXDEV")
              throw err;
            return moveSyncAcrossDevice(src, dest, overwrite);
          }
        } else {
          try {
            fs4.linkSync(src, dest);
            return fs4.unlinkSync(src);
          } catch (err) {
            if (err.code === "EXDEV" || err.code === "EISDIR" || err.code === "EPERM" || err.code === "ENOTSUP") {
              return moveSyncAcrossDevice(src, dest, overwrite);
            }
            throw err;
          }
        }
      }
    }
    function moveSyncAcrossDevice(src, dest, overwrite) {
      const stat3 = fs4.statSync(src);
      if (stat3.isDirectory()) {
        return moveDirSyncAcrossDevice(src, dest, overwrite);
      } else {
        return moveFileSyncAcrossDevice(src, dest, overwrite);
      }
    }
    function moveFileSyncAcrossDevice(src, dest, overwrite) {
      const BUF_LENGTH = 64 * 1024;
      const _buff = buffer(BUF_LENGTH);
      const flags = overwrite ? "w" : "wx";
      const fdr = fs4.openSync(src, "r");
      const stat3 = fs4.fstatSync(fdr);
      const fdw = fs4.openSync(dest, flags, stat3.mode);
      let pos = 0;
      while (pos < stat3.size) {
        const bytesRead = fs4.readSync(fdr, _buff, 0, BUF_LENGTH, pos);
        fs4.writeSync(fdw, _buff, 0, bytesRead);
        pos += bytesRead;
      }
      fs4.closeSync(fdr);
      fs4.closeSync(fdw);
      return fs4.unlinkSync(src);
    }
    function moveDirSyncAcrossDevice(src, dest, overwrite) {
      const options = {
        overwrite: false
      };
      if (overwrite) {
        removeSync(dest);
        tryCopySync();
      } else {
        tryCopySync();
      }
      function tryCopySync() {
        copySync(src, dest, options);
        return removeSync(src);
      }
    }
    function isSrcSubdir(src, dest) {
      try {
        return fs4.statSync(src).isDirectory() && src !== dest && dest.indexOf(src) > -1 && dest.split(path4.dirname(src) + path4.sep)[1].split(path4.sep)[0] === path4.basename(src);
      } catch (e2) {
        return false;
      }
    }
    module2.exports = {
      moveSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/move/index.js
var require_move7 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/move/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var copy = require_copy8().copy;
    var remove = require_remove5().remove;
    var mkdirp2 = require_mkdirs7().mkdirp;
    var pathExists = require_path_exists5().pathExists;
    function move(src, dest, opts, cb) {
      if (typeof opts === "function") {
        cb = opts;
        opts = {};
      }
      const overwrite = opts.overwrite || opts.clobber || false;
      src = path4.resolve(src);
      dest = path4.resolve(dest);
      if (src === dest)
        return fs4.access(src, cb);
      fs4.stat(src, (err, st) => {
        if (err)
          return cb(err);
        if (st.isDirectory() && isSrcSubdir(src, dest)) {
          return cb(new Error(`Cannot move '${src}' to a subdirectory of itself, '${dest}'.`));
        }
        mkdirp2(path4.dirname(dest), (err2) => {
          if (err2)
            return cb(err2);
          return doRename(src, dest, overwrite, cb);
        });
      });
    }
    function doRename(src, dest, overwrite, cb) {
      if (overwrite) {
        return remove(dest, (err) => {
          if (err)
            return cb(err);
          return rename(src, dest, overwrite, cb);
        });
      }
      pathExists(dest, (err, destExists) => {
        if (err)
          return cb(err);
        if (destExists)
          return cb(new Error("dest already exists."));
        return rename(src, dest, overwrite, cb);
      });
    }
    function rename(src, dest, overwrite, cb) {
      fs4.rename(src, dest, (err) => {
        if (!err)
          return cb();
        if (err.code !== "EXDEV")
          return cb(err);
        return moveAcrossDevice(src, dest, overwrite, cb);
      });
    }
    function moveAcrossDevice(src, dest, overwrite, cb) {
      const opts = {
        overwrite,
        errorOnExist: true
      };
      copy(src, dest, opts, (err) => {
        if (err)
          return cb(err);
        return remove(src, cb);
      });
    }
    function isSrcSubdir(src, dest) {
      const srcArray = src.split(path4.sep);
      const destArray = dest.split(path4.sep);
      return srcArray.reduce((acc, current, i2) => {
        return acc && destArray[i2] === current;
      }, true);
    }
    module2.exports = {
      move: u(move)
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/output/index.js
var require_output3 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/output/index.js"(exports, module2) {
    "use strict";
    var u = require_universalify2().fromCallback;
    var fs4 = require_graceful_fs3();
    var path4 = require("path");
    var mkdir = require_mkdirs7();
    var pathExists = require_path_exists5().pathExists;
    function outputFile(file, data, encoding, callback) {
      if (typeof encoding === "function") {
        callback = encoding;
        encoding = "utf8";
      }
      const dir = path4.dirname(file);
      pathExists(dir, (err, itDoes) => {
        if (err)
          return callback(err);
        if (itDoes)
          return fs4.writeFile(file, data, encoding, callback);
        mkdir.mkdirs(dir, (err2) => {
          if (err2)
            return callback(err2);
          fs4.writeFile(file, data, encoding, callback);
        });
      });
    }
    function outputFileSync(file, ...args) {
      const dir = path4.dirname(file);
      if (fs4.existsSync(dir)) {
        return fs4.writeFileSync(file, ...args);
      }
      mkdir.mkdirsSync(dir);
      fs4.writeFileSync(file, ...args);
    }
    module2.exports = {
      outputFile: u(outputFile),
      outputFileSync
    };
  }
});

// node_modules/@changesets/config/node_modules/fs-extra/lib/index.js
var require_lib7 = __commonJS({
  "node_modules/@changesets/config/node_modules/fs-extra/lib/index.js"(exports, module2) {
    "use strict";
    module2.exports = Object.assign(
      {},
      require_fs8(),
      require_copy_sync7(),
      require_copy8(),
      require_empty4(),
      require_ensure4(),
      require_json5(),
      require_mkdirs7(),
      require_move_sync6(),
      require_move7(),
      require_output3(),
      require_path_exists5(),
      require_remove5()
    );
    var fs4 = require("fs");
    if (Object.getOwnPropertyDescriptor(fs4, "promises")) {
      Object.defineProperty(module2.exports, "promises", {
        get() {
          return fs4.promises;
        }
      });
    }
  }
});

// node_modules/extendable-error/bld/index.js
var require_bld = __commonJS({
  "node_modules/extendable-error/bld/index.js"(exports) {
    "use strict";
    var __extends = exports && exports.__extends || function() {
      var extendStatics = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(d, b) {
        d.__proto__ = b;
      } || function(d, b) {
        for (var p in b)
          if (b.hasOwnProperty(p))
            d[p] = b[p];
      };
      return function(d, b) {
        extendStatics(d, b);
        function __() {
          this.constructor = d;
        }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
      };
    }();
    Object.defineProperty(exports, "__esModule", { value: true });
    var ExtendableError2 = function(_super) {
      __extends(ExtendableError3, _super);
      function ExtendableError3(message) {
        var _newTarget = this.constructor;
        if (message === void 0) {
          message = "";
        }
        var _this = _super.call(this, message) || this;
        _this.message = message;
        Object.setPrototypeOf(_this, _newTarget.prototype);
        delete _this.stack;
        _this.name = _newTarget.name;
        _this._error = new Error();
        return _this;
      }
      Object.defineProperty(ExtendableError3.prototype, "stack", {
        get: function() {
          if (this._stack) {
            return this._stack;
          }
          var prototype = Object.getPrototypeOf(this);
          var depth = 1;
          loop:
            while (prototype) {
              switch (prototype) {
                case ExtendableError3.prototype:
                  break loop;
                case Object.prototype:
                  depth = 1;
                  break loop;
                default:
                  depth++;
                  break;
              }
              prototype = Object.getPrototypeOf(prototype);
            }
          var stackLines = (this._error.stack || "").match(/.+/g) || [];
          var nameLine = this.name;
          if (this.message) {
            nameLine += ": " + this.message;
          }
          stackLines.splice(0, depth + 1, nameLine);
          return this._stack = stackLines.join("\n");
        },
        enumerable: true,
        configurable: true
      });
      return ExtendableError3;
    }(Error);
    exports.ExtendableError = ExtendableError2;
    exports.default = ExtendableError2;
  }
});

// node_modules/escape-string-regexp/index.js
var require_escape_string_regexp = __commonJS({
  "node_modules/escape-string-regexp/index.js"(exports, module2) {
    "use strict";
    var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
    module2.exports = function(str) {
      if (typeof str !== "string") {
        throw new TypeError("Expected a string");
      }
      return str.replace(matchOperatorsRe, "\\$&");
    };
  }
});

// node_modules/color-name/index.js
var require_color_name = __commonJS({
  "node_modules/color-name/index.js"(exports, module2) {
    "use strict";
    module2.exports = {
      "aliceblue": [240, 248, 255],
      "antiquewhite": [250, 235, 215],
      "aqua": [0, 255, 255],
      "aquamarine": [127, 255, 212],
      "azure": [240, 255, 255],
      "beige": [245, 245, 220],
      "bisque": [255, 228, 196],
      "black": [0, 0, 0],
      "blanchedalmond": [255, 235, 205],
      "blue": [0, 0, 255],
      "blueviolet": [138, 43, 226],
      "brown": [165, 42, 42],
      "burlywood": [222, 184, 135],
      "cadetblue": [95, 158, 160],
      "chartreuse": [127, 255, 0],
      "chocolate": [210, 105, 30],
      "coral": [255, 127, 80],
      "cornflowerblue": [100, 149, 237],
      "cornsilk": [255, 248, 220],
      "crimson": [220, 20, 60],
      "cyan": [0, 255, 255],
      "darkblue": [0, 0, 139],
      "darkcyan": [0, 139, 139],
      "darkgoldenrod": [184, 134, 11],
      "darkgray": [169, 169, 169],
      "darkgreen": [0, 100, 0],
      "darkgrey": [169, 169, 169],
      "darkkhaki": [189, 183, 107],
      "darkmagenta": [139, 0, 139],
      "darkolivegreen": [85, 107, 47],
      "darkorange": [255, 140, 0],
      "darkorchid": [153, 50, 204],
      "darkred": [139, 0, 0],
      "darksalmon": [233, 150, 122],
      "darkseagreen": [143, 188, 143],
      "darkslateblue": [72, 61, 139],
      "darkslategray": [47, 79, 79],
      "darkslategrey": [47, 79, 79],
      "darkturquoise": [0, 206, 209],
      "darkviolet": [148, 0, 211],
      "deeppink": [255, 20, 147],
      "deepskyblue": [0, 191, 255],
      "dimgray": [105, 105, 105],
      "dimgrey": [105, 105, 105],
      "dodgerblue": [30, 144, 255],
      "firebrick": [178, 34, 34],
      "floralwhite": [255, 250, 240],
      "forestgreen": [34, 139, 34],
      "fuchsia": [255, 0, 255],
      "gainsboro": [220, 220, 220],
      "ghostwhite": [248, 248, 255],
      "gold": [255, 215, 0],
      "goldenrod": [218, 165, 32],
      "gray": [128, 128, 128],
      "green": [0, 128, 0],
      "greenyellow": [173, 255, 47],
      "grey": [128, 128, 128],
      "honeydew": [240, 255, 240],
      "hotpink": [255, 105, 180],
      "indianred": [205, 92, 92],
      "indigo": [75, 0, 130],
      "ivory": [255, 255, 240],
      "khaki": [240, 230, 140],
      "lavender": [230, 230, 250],
      "lavenderblush": [255, 240, 245],
      "lawngreen": [124, 252, 0],
      "lemonchiffon": [255, 250, 205],
      "lightblue": [173, 216, 230],
      "lightcoral": [240, 128, 128],
      "lightcyan": [224, 255, 255],
      "lightgoldenrodyellow": [250, 250, 210],
      "lightgray": [211, 211, 211],
      "lightgreen": [144, 238, 144],
      "lightgrey": [211, 211, 211],
      "lightpink": [255, 182, 193],
      "lightsalmon": [255, 160, 122],
      "lightseagreen": [32, 178, 170],
      "lightskyblue": [135, 206, 250],
      "lightslategray": [119, 136, 153],
      "lightslategrey": [119, 136, 153],
      "lightsteelblue": [176, 196, 222],
      "lightyellow": [255, 255, 224],
      "lime": [0, 255, 0],
      "limegreen": [50, 205, 50],
      "linen": [250, 240, 230],
      "magenta": [255, 0, 255],
      "maroon": [128, 0, 0],
      "mediumaquamarine": [102, 205, 170],
      "mediumblue": [0, 0, 205],
      "mediumorchid": [186, 85, 211],
      "mediumpurple": [147, 112, 219],
      "mediumseagreen": [60, 179, 113],
      "mediumslateblue": [123, 104, 238],
      "mediumspringgreen": [0, 250, 154],
      "mediumturquoise": [72, 209, 204],
      "mediumvioletred": [199, 21, 133],
      "midnightblue": [25, 25, 112],
      "mintcream": [245, 255, 250],
      "mistyrose": [255, 228, 225],
      "moccasin": [255, 228, 181],
      "navajowhite": [255, 222, 173],
      "navy": [0, 0, 128],
      "oldlace": [253, 245, 230],
      "olive": [128, 128, 0],
      "olivedrab": [107, 142, 35],
      "orange": [255, 165, 0],
      "orangered": [255, 69, 0],
      "orchid": [218, 112, 214],
      "palegoldenrod": [238, 232, 170],
      "palegreen": [152, 251, 152],
      "paleturquoise": [175, 238, 238],
      "palevioletred": [219, 112, 147],
      "papayawhip": [255, 239, 213],
      "peachpuff": [255, 218, 185],
      "peru": [205, 133, 63],
      "pink": [255, 192, 203],
      "plum": [221, 160, 221],
      "powderblue": [176, 224, 230],
      "purple": [128, 0, 128],
      "rebeccapurple": [102, 51, 153],
      "red": [255, 0, 0],
      "rosybrown": [188, 143, 143],
      "royalblue": [65, 105, 225],
      "saddlebrown": [139, 69, 19],
      "salmon": [250, 128, 114],
      "sandybrown": [244, 164, 96],
      "seagreen": [46, 139, 87],
      "seashell": [255, 245, 238],
      "sienna": [160, 82, 45],
      "silver": [192, 192, 192],
      "skyblue": [135, 206, 235],
      "slateblue": [106, 90, 205],
      "slategray": [112, 128, 144],
      "slategrey": [112, 128, 144],
      "snow": [255, 250, 250],
      "springgreen": [0, 255, 127],
      "steelblue": [70, 130, 180],
      "tan": [210, 180, 140],
      "teal": [0, 128, 128],
      "thistle": [216, 191, 216],
      "tomato": [255, 99, 71],
      "turquoise": [64, 224, 208],
      "violet": [238, 130, 238],
      "wheat": [245, 222, 179],
      "white": [255, 255, 255],
      "whitesmoke": [245, 245, 245],
      "yellow": [255, 255, 0],
      "yellowgreen": [154, 205, 50]
    };
  }
});

// node_modules/color-convert/conversions.js
var require_conversions = __commonJS({
  "node_modules/color-convert/conversions.js"(exports, module2) {
    var cssKeywords = require_color_name();
    var reverseKeywords = {};
    for (key in cssKeywords) {
      if (cssKeywords.hasOwnProperty(key)) {
        reverseKeywords[cssKeywords[key]] = key;
      }
    }
    var key;
    var convert2 = module2.exports = {
      rgb: { channels: 3, labels: "rgb" },
      hsl: { channels: 3, labels: "hsl" },
      hsv: { channels: 3, labels: "hsv" },
      hwb: { channels: 3, labels: "hwb" },
      cmyk: { channels: 4, labels: "cmyk" },
      xyz: { channels: 3, labels: "xyz" },
      lab: { channels: 3, labels: "lab" },
      lch: { channels: 3, labels: "lch" },
      hex: { channels: 1, labels: ["hex"] },
      keyword: { channels: 1, labels: ["keyword"] },
      ansi16: { channels: 1, labels: ["ansi16"] },
      ansi256: { channels: 1, labels: ["ansi256"] },
      hcg: { channels: 3, labels: ["h", "c", "g"] },
      apple: { channels: 3, labels: ["r16", "g16", "b16"] },
      gray: { channels: 1, labels: ["gray"] }
    };
    for (model in convert2) {
      if (convert2.hasOwnProperty(model)) {
        if (!("channels" in convert2[model])) {
          throw new Error("missing channels property: " + model);
        }
        if (!("labels" in convert2[model])) {
          throw new Error("missing channel labels property: " + model);
        }
        if (convert2[model].labels.length !== convert2[model].channels) {
          throw new Error("channel and label counts mismatch: " + model);
        }
        channels = convert2[model].channels;
        labels = convert2[model].labels;
        delete convert2[model].channels;
        delete convert2[model].labels;
        Object.defineProperty(convert2[model], "channels", { value: channels });
        Object.defineProperty(convert2[model], "labels", { value: labels });
      }
    }
    var channels;
    var labels;
    var model;
    convert2.rgb.hsl = function(rgb) {
      var r2 = rgb[0] / 255;
      var g = rgb[1] / 255;
      var b = rgb[2] / 255;
      var min = Math.min(r2, g, b);
      var max = Math.max(r2, g, b);
      var delta = max - min;
      var h2;
      var s2;
      var l;
      if (max === min) {
        h2 = 0;
      } else if (r2 === max) {
        h2 = (g - b) / delta;
      } else if (g === max) {
        h2 = 2 + (b - r2) / delta;
      } else if (b === max) {
        h2 = 4 + (r2 - g) / delta;
      }
      h2 = Math.min(h2 * 60, 360);
      if (h2 < 0) {
        h2 += 360;
      }
      l = (min + max) / 2;
      if (max === min) {
        s2 = 0;
      } else if (l <= 0.5) {
        s2 = delta / (max + min);
      } else {
        s2 = delta / (2 - max - min);
      }
      return [h2, s2 * 100, l * 100];
    };
    convert2.rgb.hsv = function(rgb) {
      var rdif;
      var gdif;
      var bdif;
      var h2;
      var s2;
      var r2 = rgb[0] / 255;
      var g = rgb[1] / 255;
      var b = rgb[2] / 255;
      var v = Math.max(r2, g, b);
      var diff2 = v - Math.min(r2, g, b);
      var diffc = function(c) {
        return (v - c) / 6 / diff2 + 1 / 2;
      };
      if (diff2 === 0) {
        h2 = s2 = 0;
      } else {
        s2 = diff2 / v;
        rdif = diffc(r2);
        gdif = diffc(g);
        bdif = diffc(b);
        if (r2 === v) {
          h2 = bdif - gdif;
        } else if (g === v) {
          h2 = 1 / 3 + rdif - bdif;
        } else if (b === v) {
          h2 = 2 / 3 + gdif - rdif;
        }
        if (h2 < 0) {
          h2 += 1;
        } else if (h2 > 1) {
          h2 -= 1;
        }
      }
      return [
        h2 * 360,
        s2 * 100,
        v * 100
      ];
    };
    convert2.rgb.hwb = function(rgb) {
      var r2 = rgb[0];
      var g = rgb[1];
      var b = rgb[2];
      var h2 = convert2.rgb.hsl(rgb)[0];
      var w = 1 / 255 * Math.min(r2, Math.min(g, b));
      b = 1 - 1 / 255 * Math.max(r2, Math.max(g, b));
      return [h2, w * 100, b * 100];
    };
    convert2.rgb.cmyk = function(rgb) {
      var r2 = rgb[0] / 255;
      var g = rgb[1] / 255;
      var b = rgb[2] / 255;
      var c;
      var m2;
      var y;
      var k;
      k = Math.min(1 - r2, 1 - g, 1 - b);
      c = (1 - r2 - k) / (1 - k) || 0;
      m2 = (1 - g - k) / (1 - k) || 0;
      y = (1 - b - k) / (1 - k) || 0;
      return [c * 100, m2 * 100, y * 100, k * 100];
    };
    function comparativeDistance(x2, y) {
      return Math.pow(x2[0] - y[0], 2) + Math.pow(x2[1] - y[1], 2) + Math.pow(x2[2] - y[2], 2);
    }
    convert2.rgb.keyword = function(rgb) {
      var reversed = reverseKeywords[rgb];
      if (reversed) {
        return reversed;
      }
      var currentClosestDistance = Infinity;
      var currentClosestKeyword;
      for (var keyword in cssKeywords) {
        if (cssKeywords.hasOwnProperty(keyword)) {
          var value = cssKeywords[keyword];
          var distance = comparativeDistance(rgb, value);
          if (distance < currentClosestDistance) {
            currentClosestDistance = distance;
            currentClosestKeyword = keyword;
          }
        }
      }
      return currentClosestKeyword;
    };
    convert2.keyword.rgb = function(keyword) {
      return cssKeywords[keyword];
    };
    convert2.rgb.xyz = function(rgb) {
      var r2 = rgb[0] / 255;
      var g = rgb[1] / 255;
      var b = rgb[2] / 255;
      r2 = r2 > 0.04045 ? Math.pow((r2 + 0.055) / 1.055, 2.4) : r2 / 12.92;
      g = g > 0.04045 ? Math.pow((g + 0.055) / 1.055, 2.4) : g / 12.92;
      b = b > 0.04045 ? Math.pow((b + 0.055) / 1.055, 2.4) : b / 12.92;
      var x2 = r2 * 0.4124 + g * 0.3576 + b * 0.1805;
      var y = r2 * 0.2126 + g * 0.7152 + b * 0.0722;
      var z = r2 * 0.0193 + g * 0.1192 + b * 0.9505;
      return [x2 * 100, y * 100, z * 100];
    };
    convert2.rgb.lab = function(rgb) {
      var xyz = convert2.rgb.xyz(rgb);
      var x2 = xyz[0];
      var y = xyz[1];
      var z = xyz[2];
      var l;
      var a;
      var b;
      x2 /= 95.047;
      y /= 100;
      z /= 108.883;
      x2 = x2 > 8856e-6 ? Math.pow(x2, 1 / 3) : 7.787 * x2 + 16 / 116;
      y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
      l = 116 * y - 16;
      a = 500 * (x2 - y);
      b = 200 * (y - z);
      return [l, a, b];
    };
    convert2.hsl.rgb = function(hsl) {
      var h2 = hsl[0] / 360;
      var s2 = hsl[1] / 100;
      var l = hsl[2] / 100;
      var t1;
      var t2;
      var t3;
      var rgb;
      var val;
      if (s2 === 0) {
        val = l * 255;
        return [val, val, val];
      }
      if (l < 0.5) {
        t2 = l * (1 + s2);
      } else {
        t2 = l + s2 - l * s2;
      }
      t1 = 2 * l - t2;
      rgb = [0, 0, 0];
      for (var i2 = 0; i2 < 3; i2++) {
        t3 = h2 + 1 / 3 * -(i2 - 1);
        if (t3 < 0) {
          t3++;
        }
        if (t3 > 1) {
          t3--;
        }
        if (6 * t3 < 1) {
          val = t1 + (t2 - t1) * 6 * t3;
        } else if (2 * t3 < 1) {
          val = t2;
        } else if (3 * t3 < 2) {
          val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
        } else {
          val = t1;
        }
        rgb[i2] = val * 255;
      }
      return rgb;
    };
    convert2.hsl.hsv = function(hsl) {
      var h2 = hsl[0];
      var s2 = hsl[1] / 100;
      var l = hsl[2] / 100;
      var smin = s2;
      var lmin = Math.max(l, 0.01);
      var sv;
      var v;
      l *= 2;
      s2 *= l <= 1 ? l : 2 - l;
      smin *= lmin <= 1 ? lmin : 2 - lmin;
      v = (l + s2) / 2;
      sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s2 / (l + s2);
      return [h2, sv * 100, v * 100];
    };
    convert2.hsv.rgb = function(hsv) {
      var h2 = hsv[0] / 60;
      var s2 = hsv[1] / 100;
      var v = hsv[2] / 100;
      var hi = Math.floor(h2) % 6;
      var f3 = h2 - Math.floor(h2);
      var p = 255 * v * (1 - s2);
      var q = 255 * v * (1 - s2 * f3);
      var t2 = 255 * v * (1 - s2 * (1 - f3));
      v *= 255;
      switch (hi) {
        case 0:
          return [v, t2, p];
        case 1:
          return [q, v, p];
        case 2:
          return [p, v, t2];
        case 3:
          return [p, q, v];
        case 4:
          return [t2, p, v];
        case 5:
          return [v, p, q];
      }
    };
    convert2.hsv.hsl = function(hsv) {
      var h2 = hsv[0];
      var s2 = hsv[1] / 100;
      var v = hsv[2] / 100;
      var vmin = Math.max(v, 0.01);
      var lmin;
      var sl;
      var l;
      l = (2 - s2) * v;
      lmin = (2 - s2) * vmin;
      sl = s2 * vmin;
      sl /= lmin <= 1 ? lmin : 2 - lmin;
      sl = sl || 0;
      l /= 2;
      return [h2, sl * 100, l * 100];
    };
    convert2.hwb.rgb = function(hwb) {
      var h2 = hwb[0] / 360;
      var wh = hwb[1] / 100;
      var bl = hwb[2] / 100;
      var ratio = wh + bl;
      var i2;
      var v;
      var f3;
      var n;
      if (ratio > 1) {
        wh /= ratio;
        bl /= ratio;
      }
      i2 = Math.floor(6 * h2);
      v = 1 - bl;
      f3 = 6 * h2 - i2;
      if ((i2 & 1) !== 0) {
        f3 = 1 - f3;
      }
      n = wh + f3 * (v - wh);
      var r2;
      var g;
      var b;
      switch (i2) {
        default:
        case 6:
        case 0:
          r2 = v;
          g = n;
          b = wh;
          break;
        case 1:
          r2 = n;
          g = v;
          b = wh;
          break;
        case 2:
          r2 = wh;
          g = v;
          b = n;
          break;
        case 3:
          r2 = wh;
          g = n;
          b = v;
          break;
        case 4:
          r2 = n;
          g = wh;
          b = v;
          break;
        case 5:
          r2 = v;
          g = wh;
          b = n;
          break;
      }
      return [r2 * 255, g * 255, b * 255];
    };
    convert2.cmyk.rgb = function(cmyk) {
      var c = cmyk[0] / 100;
      var m2 = cmyk[1] / 100;
      var y = cmyk[2] / 100;
      var k = cmyk[3] / 100;
      var r2;
      var g;
      var b;
      r2 = 1 - Math.min(1, c * (1 - k) + k);
      g = 1 - Math.min(1, m2 * (1 - k) + k);
      b = 1 - Math.min(1, y * (1 - k) + k);
      return [r2 * 255, g * 255, b * 255];
    };
    convert2.xyz.rgb = function(xyz) {
      var x2 = xyz[0] / 100;
      var y = xyz[1] / 100;
      var z = xyz[2] / 100;
      var r2;
      var g;
      var b;
      r2 = x2 * 3.2406 + y * -1.5372 + z * -0.4986;
      g = x2 * -0.9689 + y * 1.8758 + z * 0.0415;
      b = x2 * 0.0557 + y * -0.204 + z * 1.057;
      r2 = r2 > 31308e-7 ? 1.055 * Math.pow(r2, 1 / 2.4) - 0.055 : r2 * 12.92;
      g = g > 31308e-7 ? 1.055 * Math.pow(g, 1 / 2.4) - 0.055 : g * 12.92;
      b = b > 31308e-7 ? 1.055 * Math.pow(b, 1 / 2.4) - 0.055 : b * 12.92;
      r2 = Math.min(Math.max(0, r2), 1);
      g = Math.min(Math.max(0, g), 1);
      b = Math.min(Math.max(0, b), 1);
      return [r2 * 255, g * 255, b * 255];
    };
    convert2.xyz.lab = function(xyz) {
      var x2 = xyz[0];
      var y = xyz[1];
      var z = xyz[2];
      var l;
      var a;
      var b;
      x2 /= 95.047;
      y /= 100;
      z /= 108.883;
      x2 = x2 > 8856e-6 ? Math.pow(x2, 1 / 3) : 7.787 * x2 + 16 / 116;
      y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
      l = 116 * y - 16;
      a = 500 * (x2 - y);
      b = 200 * (y - z);
      return [l, a, b];
    };
    convert2.lab.xyz = function(lab) {
      var l = lab[0];
      var a = lab[1];
      var b = lab[2];
      var x2;
      var y;
      var z;
      y = (l + 16) / 116;
      x2 = a / 500 + y;
      z = y - b / 200;
      var y2 = Math.pow(y, 3);
      var x22 = Math.pow(x2, 3);
      var z2 = Math.pow(z, 3);
      y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
      x2 = x22 > 8856e-6 ? x22 : (x2 - 16 / 116) / 7.787;
      z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
      x2 *= 95.047;
      y *= 100;
      z *= 108.883;
      return [x2, y, z];
    };
    convert2.lab.lch = function(lab) {
      var l = lab[0];
      var a = lab[1];
      var b = lab[2];
      var hr;
      var h2;
      var c;
      hr = Math.atan2(b, a);
      h2 = hr * 360 / 2 / Math.PI;
      if (h2 < 0) {
        h2 += 360;
      }
      c = Math.sqrt(a * a + b * b);
      return [l, c, h2];
    };
    convert2.lch.lab = function(lch) {
      var l = lch[0];
      var c = lch[1];
      var h2 = lch[2];
      var a;
      var b;
      var hr;
      hr = h2 / 360 * 2 * Math.PI;
      a = c * Math.cos(hr);
      b = c * Math.sin(hr);
      return [l, a, b];
    };
    convert2.rgb.ansi16 = function(args) {
      var r2 = args[0];
      var g = args[1];
      var b = args[2];
      var value = 1 in arguments ? arguments[1] : convert2.rgb.hsv(args)[2];
      value = Math.round(value / 50);
      if (value === 0) {
        return 30;
      }
      var ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r2 / 255));
      if (value === 2) {
        ansi += 60;
      }
      return ansi;
    };
    convert2.hsv.ansi16 = function(args) {
      return convert2.rgb.ansi16(convert2.hsv.rgb(args), args[2]);
    };
    convert2.rgb.ansi256 = function(args) {
      var r2 = args[0];
      var g = args[1];
      var b = args[2];
      if (r2 === g && g === b) {
        if (r2 < 8) {
          return 16;
        }
        if (r2 > 248) {
          return 231;
        }
        return Math.round((r2 - 8) / 247 * 24) + 232;
      }
      var ansi = 16 + 36 * Math.round(r2 / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
      return ansi;
    };
    convert2.ansi16.rgb = function(args) {
      var color = args % 10;
      if (color === 0 || color === 7) {
        if (args > 50) {
          color += 3.5;
        }
        color = color / 10.5 * 255;
        return [color, color, color];
      }
      var mult = (~~(args > 50) + 1) * 0.5;
      var r2 = (color & 1) * mult * 255;
      var g = (color >> 1 & 1) * mult * 255;
      var b = (color >> 2 & 1) * mult * 255;
      return [r2, g, b];
    };
    convert2.ansi256.rgb = function(args) {
      if (args >= 232) {
        var c = (args - 232) * 10 + 8;
        return [c, c, c];
      }
      args -= 16;
      var rem;
      var r2 = Math.floor(args / 36) / 5 * 255;
      var g = Math.floor((rem = args % 36) / 6) / 5 * 255;
      var b = rem % 6 / 5 * 255;
      return [r2, g, b];
    };
    convert2.rgb.hex = function(args) {
      var integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
      var string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert2.hex.rgb = function(args) {
      var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
      if (!match) {
        return [0, 0, 0];
      }
      var colorString = match[0];
      if (match[0].length === 3) {
        colorString = colorString.split("").map(function(char) {
          return char + char;
        }).join("");
      }
      var integer = parseInt(colorString, 16);
      var r2 = integer >> 16 & 255;
      var g = integer >> 8 & 255;
      var b = integer & 255;
      return [r2, g, b];
    };
    convert2.rgb.hcg = function(rgb) {
      var r2 = rgb[0] / 255;
      var g = rgb[1] / 255;
      var b = rgb[2] / 255;
      var max = Math.max(Math.max(r2, g), b);
      var min = Math.min(Math.min(r2, g), b);
      var chroma = max - min;
      var grayscale;
      var hue;
      if (chroma < 1) {
        grayscale = min / (1 - chroma);
      } else {
        grayscale = 0;
      }
      if (chroma <= 0) {
        hue = 0;
      } else if (max === r2) {
        hue = (g - b) / chroma % 6;
      } else if (max === g) {
        hue = 2 + (b - r2) / chroma;
      } else {
        hue = 4 + (r2 - g) / chroma + 4;
      }
      hue /= 6;
      hue %= 1;
      return [hue * 360, chroma * 100, grayscale * 100];
    };
    convert2.hsl.hcg = function(hsl) {
      var s2 = hsl[1] / 100;
      var l = hsl[2] / 100;
      var c = 1;
      var f3 = 0;
      if (l < 0.5) {
        c = 2 * s2 * l;
      } else {
        c = 2 * s2 * (1 - l);
      }
      if (c < 1) {
        f3 = (l - 0.5 * c) / (1 - c);
      }
      return [hsl[0], c * 100, f3 * 100];
    };
    convert2.hsv.hcg = function(hsv) {
      var s2 = hsv[1] / 100;
      var v = hsv[2] / 100;
      var c = s2 * v;
      var f3 = 0;
      if (c < 1) {
        f3 = (v - c) / (1 - c);
      }
      return [hsv[0], c * 100, f3 * 100];
    };
    convert2.hcg.rgb = function(hcg) {
      var h2 = hcg[0] / 360;
      var c = hcg[1] / 100;
      var g = hcg[2] / 100;
      if (c === 0) {
        return [g * 255, g * 255, g * 255];
      }
      var pure = [0, 0, 0];
      var hi = h2 % 1 * 6;
      var v = hi % 1;
      var w = 1 - v;
      var mg = 0;
      switch (Math.floor(hi)) {
        case 0:
          pure[0] = 1;
          pure[1] = v;
          pure[2] = 0;
          break;
        case 1:
          pure[0] = w;
          pure[1] = 1;
          pure[2] = 0;
          break;
        case 2:
          pure[0] = 0;
          pure[1] = 1;
          pure[2] = v;
          break;
        case 3:
          pure[0] = 0;
          pure[1] = w;
          pure[2] = 1;
          break;
        case 4:
          pure[0] = v;
          pure[1] = 0;
          pure[2] = 1;
          break;
        default:
          pure[0] = 1;
          pure[1] = 0;
          pure[2] = w;
      }
      mg = (1 - c) * g;
      return [
        (c * pure[0] + mg) * 255,
        (c * pure[1] + mg) * 255,
        (c * pure[2] + mg) * 255
      ];
    };
    convert2.hcg.hsv = function(hcg) {
      var c = hcg[1] / 100;
      var g = hcg[2] / 100;
      var v = c + g * (1 - c);
      var f3 = 0;
      if (v > 0) {
        f3 = c / v;
      }
      return [hcg[0], f3 * 100, v * 100];
    };
    convert2.hcg.hsl = function(hcg) {
      var c = hcg[1] / 100;
      var g = hcg[2] / 100;
      var l = g * (1 - c) + 0.5 * c;
      var s2 = 0;
      if (l > 0 && l < 0.5) {
        s2 = c / (2 * l);
      } else if (l >= 0.5 && l < 1) {
        s2 = c / (2 * (1 - l));
      }
      return [hcg[0], s2 * 100, l * 100];
    };
    convert2.hcg.hwb = function(hcg) {
      var c = hcg[1] / 100;
      var g = hcg[2] / 100;
      var v = c + g * (1 - c);
      return [hcg[0], (v - c) * 100, (1 - v) * 100];
    };
    convert2.hwb.hcg = function(hwb) {
      var w = hwb[1] / 100;
      var b = hwb[2] / 100;
      var v = 1 - b;
      var c = v - w;
      var g = 0;
      if (c < 1) {
        g = (v - c) / (1 - c);
      }
      return [hwb[0], c * 100, g * 100];
    };
    convert2.apple.rgb = function(apple) {
      return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
    };
    convert2.rgb.apple = function(rgb) {
      return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
    };
    convert2.gray.rgb = function(args) {
      return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
    };
    convert2.gray.hsl = convert2.gray.hsv = function(args) {
      return [0, 0, args[0]];
    };
    convert2.gray.hwb = function(gray) {
      return [0, 100, gray[0]];
    };
    convert2.gray.cmyk = function(gray) {
      return [0, 0, 0, gray[0]];
    };
    convert2.gray.lab = function(gray) {
      return [gray[0], 0, 0];
    };
    convert2.gray.hex = function(gray) {
      var val = Math.round(gray[0] / 100 * 255) & 255;
      var integer = (val << 16) + (val << 8) + val;
      var string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert2.rgb.gray = function(rgb) {
      var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
      return [val / 255 * 100];
    };
  }
});

// node_modules/color-convert/route.js
var require_route = __commonJS({
  "node_modules/color-convert/route.js"(exports, module2) {
    var conversions = require_conversions();
    function buildGraph() {
      var graph = {};
      var models = Object.keys(conversions);
      for (var len = models.length, i2 = 0; i2 < len; i2++) {
        graph[models[i2]] = {
          distance: -1,
          parent: null
        };
      }
      return graph;
    }
    function deriveBFS(fromModel) {
      var graph = buildGraph();
      var queue = [fromModel];
      graph[fromModel].distance = 0;
      while (queue.length) {
        var current = queue.pop();
        var adjacents = Object.keys(conversions[current]);
        for (var len = adjacents.length, i2 = 0; i2 < len; i2++) {
          var adjacent = adjacents[i2];
          var node = graph[adjacent];
          if (node.distance === -1) {
            node.distance = graph[current].distance + 1;
            node.parent = current;
            queue.unshift(adjacent);
          }
        }
      }
      return graph;
    }
    function link(from, to) {
      return function(args) {
        return to(from(args));
      };
    }
    function wrapConversion(toModel, graph) {
      var path4 = [graph[toModel].parent, toModel];
      var fn = conversions[graph[toModel].parent][toModel];
      var cur = graph[toModel].parent;
      while (graph[cur].parent) {
        path4.unshift(graph[cur].parent);
        fn = link(conversions[graph[cur].parent][cur], fn);
        cur = graph[cur].parent;
      }
      fn.conversion = path4;
      return fn;
    }
    module2.exports = function(fromModel) {
      var graph = deriveBFS(fromModel);
      var conversion = {};
      var models = Object.keys(graph);
      for (var len = models.length, i2 = 0; i2 < len; i2++) {
        var toModel = models[i2];
        var node = graph[toModel];
        if (node.parent === null) {
          continue;
        }
        conversion[toModel] = wrapConversion(toModel, graph);
      }
      return conversion;
    };
  }
});

// node_modules/color-convert/index.js
var require_color_convert = __commonJS({
  "node_modules/color-convert/index.js"(exports, module2) {
    var conversions = require_conversions();
    var route = require_route();
    var convert2 = {};
    var models = Object.keys(conversions);
    function wrapRaw(fn) {
      var wrappedFn = function(args) {
        if (args === void 0 || args === null) {
          return args;
        }
        if (arguments.length > 1) {
          args = Array.prototype.slice.call(arguments);
        }
        return fn(args);
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    function wrapRounded(fn) {
      var wrappedFn = function(args) {
        if (args === void 0 || args === null) {
          return args;
        }
        if (arguments.length > 1) {
          args = Array.prototype.slice.call(arguments);
        }
        var result = fn(args);
        if (typeof result === "object") {
          for (var len = result.length, i2 = 0; i2 < len; i2++) {
            result[i2] = Math.round(result[i2]);
          }
        }
        return result;
      };
      if ("conversion" in fn) {
        wrappedFn.conversion = fn.conversion;
      }
      return wrappedFn;
    }
    models.forEach(function(fromModel) {
      convert2[fromModel] = {};
      Object.defineProperty(convert2[fromModel], "channels", { value: conversions[fromModel].channels });
      Object.defineProperty(convert2[fromModel], "labels", { value: conversions[fromModel].labels });
      var routes = route(fromModel);
      var routeModels = Object.keys(routes);
      routeModels.forEach(function(toModel) {
        var fn = routes[toModel];
        convert2[fromModel][toModel] = wrapRounded(fn);
        convert2[fromModel][toModel].raw = wrapRaw(fn);
      });
    });
    module2.exports = convert2;
  }
});

// node_modules/ansi-styles/index.js
var require_ansi_styles = __commonJS({
  "node_modules/ansi-styles/index.js"(exports, module2) {
    "use strict";
    var colorConvert = require_color_convert();
    var wrapAnsi16 = (fn, offset) => function() {
      const code = fn.apply(colorConvert, arguments);
      return `\x1B[${code + offset}m`;
    };
    var wrapAnsi256 = (fn, offset) => function() {
      const code = fn.apply(colorConvert, arguments);
      return `\x1B[${38 + offset};5;${code}m`;
    };
    var wrapAnsi16m = (fn, offset) => function() {
      const rgb = fn.apply(colorConvert, arguments);
      return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
    };
    function assembleStyles() {
      const codes = /* @__PURE__ */ new Map();
      const styles = {
        modifier: {
          reset: [0, 0],
          bold: [1, 22],
          dim: [2, 22],
          italic: [3, 23],
          underline: [4, 24],
          inverse: [7, 27],
          hidden: [8, 28],
          strikethrough: [9, 29]
        },
        color: {
          black: [30, 39],
          red: [31, 39],
          green: [32, 39],
          yellow: [33, 39],
          blue: [34, 39],
          magenta: [35, 39],
          cyan: [36, 39],
          white: [37, 39],
          gray: [90, 39],
          redBright: [91, 39],
          greenBright: [92, 39],
          yellowBright: [93, 39],
          blueBright: [94, 39],
          magentaBright: [95, 39],
          cyanBright: [96, 39],
          whiteBright: [97, 39]
        },
        bgColor: {
          bgBlack: [40, 49],
          bgRed: [41, 49],
          bgGreen: [42, 49],
          bgYellow: [43, 49],
          bgBlue: [44, 49],
          bgMagenta: [45, 49],
          bgCyan: [46, 49],
          bgWhite: [47, 49],
          bgBlackBright: [100, 49],
          bgRedBright: [101, 49],
          bgGreenBright: [102, 49],
          bgYellowBright: [103, 49],
          bgBlueBright: [104, 49],
          bgMagentaBright: [105, 49],
          bgCyanBright: [106, 49],
          bgWhiteBright: [107, 49]
        }
      };
      styles.color.grey = styles.color.gray;
      for (const groupName of Object.keys(styles)) {
        const group = styles[groupName];
        for (const styleName of Object.keys(group)) {
          const style = group[styleName];
          styles[styleName] = {
            open: `\x1B[${style[0]}m`,
            close: `\x1B[${style[1]}m`
          };
          group[styleName] = styles[styleName];
          codes.set(style[0], style[1]);
        }
        Object.defineProperty(styles, groupName, {
          value: group,
          enumerable: false
        });
        Object.defineProperty(styles, "codes", {
          value: codes,
          enumerable: false
        });
      }
      const ansi2ansi = (n) => n;
      const rgb2rgb = (r2, g, b) => [r2, g, b];
      styles.color.close = "\x1B[39m";
      styles.bgColor.close = "\x1B[49m";
      styles.color.ansi = {
        ansi: wrapAnsi16(ansi2ansi, 0)
      };
      styles.color.ansi256 = {
        ansi256: wrapAnsi256(ansi2ansi, 0)
      };
      styles.color.ansi16m = {
        rgb: wrapAnsi16m(rgb2rgb, 0)
      };
      styles.bgColor.ansi = {
        ansi: wrapAnsi16(ansi2ansi, 10)
      };
      styles.bgColor.ansi256 = {
        ansi256: wrapAnsi256(ansi2ansi, 10)
      };
      styles.bgColor.ansi16m = {
        rgb: wrapAnsi16m(rgb2rgb, 10)
      };
      for (let key of Object.keys(colorConvert)) {
        if (typeof colorConvert[key] !== "object") {
          continue;
        }
        const suite = colorConvert[key];
        if (key === "ansi16") {
          key = "ansi";
        }
        if ("ansi16" in suite) {
          styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
          styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
        }
        if ("ansi256" in suite) {
          styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
          styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
        }
        if ("rgb" in suite) {
          styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
          styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
        }
      }
      return styles;
    }
    Object.defineProperty(module2, "exports", {
      enumerable: true,
      get: assembleStyles
    });
  }
});

// node_modules/has-flag/index.js
var require_has_flag = __commonJS({
  "node_modules/has-flag/index.js"(exports, module2) {
    "use strict";
    module2.exports = (flag, argv) => {
      argv = argv || process.argv;
      const prefix2 = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
      const pos = argv.indexOf(prefix2 + flag);
      const terminatorPos = argv.indexOf("--");
      return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
    };
  }
});

// node_modules/supports-color/index.js
var require_supports_color = __commonJS({
  "node_modules/supports-color/index.js"(exports, module2) {
    "use strict";
    var os = require("os");
    var hasFlag = require_has_flag();
    var env = process.env;
    var forceColor;
    if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
      forceColor = false;
    } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
      forceColor = true;
    }
    if ("FORCE_COLOR" in env) {
      forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
    }
    function translateLevel(level) {
      if (level === 0) {
        return false;
      }
      return {
        level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
      };
    }
    function supportsColor(stream) {
      if (forceColor === false) {
        return 0;
      }
      if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
        return 3;
      }
      if (hasFlag("color=256")) {
        return 2;
      }
      if (stream && !stream.isTTY && forceColor !== true) {
        return 0;
      }
      const min = forceColor ? 1 : 0;
      if (process.platform === "win32") {
        const osRelease = os.release().split(".");
        if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
          return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
      }
      if ("CI" in env) {
        if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
          return 1;
        }
        return min;
      }
      if ("TEAMCITY_VERSION" in env) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
      }
      if (env.COLORTERM === "truecolor") {
        return 3;
      }
      if ("TERM_PROGRAM" in env) {
        const version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch (env.TERM_PROGRAM) {
          case "iTerm.app":
            return version >= 3 ? 3 : 2;
          case "Apple_Terminal":
            return 2;
        }
      }
      if (/-256(color)?$/i.test(env.TERM)) {
        return 2;
      }
      if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
        return 1;
      }
      if ("COLORTERM" in env) {
        return 1;
      }
      if (env.TERM === "dumb") {
        return min;
      }
      return min;
    }
    function getSupportLevel(stream) {
      const level = supportsColor(stream);
      return translateLevel(level);
    }
    module2.exports = {
      supportsColor: getSupportLevel,
      stdout: getSupportLevel(process.stdout),
      stderr: getSupportLevel(process.stderr)
    };
  }
});

// node_modules/chalk/templates.js
var require_templates = __commonJS({
  "node_modules/chalk/templates.js"(exports, module2) {
    "use strict";
    var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
    var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
    var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
    var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
    var ESCAPES = /* @__PURE__ */ new Map([
      ["n", "\n"],
      ["r", "\r"],
      ["t", "	"],
      ["b", "\b"],
      ["f", "\f"],
      ["v", "\v"],
      ["0", "\0"],
      ["\\", "\\"],
      ["e", "\x1B"],
      ["a", "\x07"]
    ]);
    function unescape2(c) {
      if (c[0] === "u" && c.length === 5 || c[0] === "x" && c.length === 3) {
        return String.fromCharCode(parseInt(c.slice(1), 16));
      }
      return ESCAPES.get(c) || c;
    }
    function parseArguments(name, args) {
      const results = [];
      const chunks = args.trim().split(/\s*,\s*/g);
      let matches;
      for (const chunk of chunks) {
        if (!isNaN(chunk)) {
          results.push(Number(chunk));
        } else if (matches = chunk.match(STRING_REGEX)) {
          results.push(matches[2].replace(ESCAPE_REGEX, (m2, escape, chr) => escape ? unescape2(escape) : chr));
        } else {
          throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
        }
      }
      return results;
    }
    function parseStyle(style) {
      STYLE_REGEX.lastIndex = 0;
      const results = [];
      let matches;
      while ((matches = STYLE_REGEX.exec(style)) !== null) {
        const name = matches[1];
        if (matches[2]) {
          const args = parseArguments(name, matches[2]);
          results.push([name].concat(args));
        } else {
          results.push([name]);
        }
      }
      return results;
    }
    function buildStyle(chalk3, styles) {
      const enabled = {};
      for (const layer of styles) {
        for (const style of layer.styles) {
          enabled[style[0]] = layer.inverse ? null : style.slice(1);
        }
      }
      let current = chalk3;
      for (const styleName of Object.keys(enabled)) {
        if (Array.isArray(enabled[styleName])) {
          if (!(styleName in current)) {
            throw new Error(`Unknown Chalk style: ${styleName}`);
          }
          if (enabled[styleName].length > 0) {
            current = current[styleName].apply(current, enabled[styleName]);
          } else {
            current = current[styleName];
          }
        }
      }
      return current;
    }
    module2.exports = (chalk3, tmp) => {
      const styles = [];
      const chunks = [];
      let chunk = [];
      tmp.replace(TEMPLATE_REGEX, (m2, escapeChar, inverse, style, close, chr) => {
        if (escapeChar) {
          chunk.push(unescape2(escapeChar));
        } else if (style) {
          const str = chunk.join("");
          chunk = [];
          chunks.push(styles.length === 0 ? str : buildStyle(chalk3, styles)(str));
          styles.push({ inverse, styles: parseStyle(style) });
        } else if (close) {
          if (styles.length === 0) {
            throw new Error("Found extraneous } in Chalk template literal");
          }
          chunks.push(buildStyle(chalk3, styles)(chunk.join("")));
          chunk = [];
          styles.pop();
        } else {
          chunk.push(chr);
        }
      });
      chunks.push(chunk.join(""));
      if (styles.length > 0) {
        const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
        throw new Error(errMsg);
      }
      return chunks.join("");
    };
  }
});

// node_modules/chalk/index.js
var require_chalk = __commonJS({
  "node_modules/chalk/index.js"(exports, module2) {
    "use strict";
    var escapeStringRegexp = require_escape_string_regexp();
    var ansiStyles = require_ansi_styles();
    var stdoutColor = require_supports_color().stdout;
    var template = require_templates();
    var isSimpleWindowsTerm = process.platform === "win32" && !(process.env.TERM || "").toLowerCase().startsWith("xterm");
    var levelMapping = ["ansi", "ansi", "ansi256", "ansi16m"];
    var skipModels = /* @__PURE__ */ new Set(["gray"]);
    var styles = /* @__PURE__ */ Object.create(null);
    function applyOptions(obj, options) {
      options = options || {};
      const scLevel = stdoutColor ? stdoutColor.level : 0;
      obj.level = options.level === void 0 ? scLevel : options.level;
      obj.enabled = "enabled" in options ? options.enabled : obj.level > 0;
    }
    function Chalk(options) {
      if (!this || !(this instanceof Chalk) || this.template) {
        const chalk3 = {};
        applyOptions(chalk3, options);
        chalk3.template = function() {
          const args = [].slice.call(arguments);
          return chalkTag.apply(null, [chalk3.template].concat(args));
        };
        Object.setPrototypeOf(chalk3, Chalk.prototype);
        Object.setPrototypeOf(chalk3.template, chalk3);
        chalk3.template.constructor = Chalk;
        return chalk3.template;
      }
      applyOptions(this, options);
    }
    if (isSimpleWindowsTerm) {
      ansiStyles.blue.open = "\x1B[94m";
    }
    for (const key of Object.keys(ansiStyles)) {
      ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), "g");
      styles[key] = {
        get() {
          const codes = ansiStyles[key];
          return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
        }
      };
    }
    styles.visible = {
      get() {
        return build.call(this, this._styles || [], true, "visible");
      }
    };
    ansiStyles.color.closeRe = new RegExp(escapeStringRegexp(ansiStyles.color.close), "g");
    for (const model of Object.keys(ansiStyles.color.ansi)) {
      if (skipModels.has(model)) {
        continue;
      }
      styles[model] = {
        get() {
          const level = this.level;
          return function() {
            const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
            const codes = {
              open,
              close: ansiStyles.color.close,
              closeRe: ansiStyles.color.closeRe
            };
            return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
          };
        }
      };
    }
    ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp(ansiStyles.bgColor.close), "g");
    for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
      if (skipModels.has(model)) {
        continue;
      }
      const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
      styles[bgModel] = {
        get() {
          const level = this.level;
          return function() {
            const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
            const codes = {
              open,
              close: ansiStyles.bgColor.close,
              closeRe: ansiStyles.bgColor.closeRe
            };
            return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
          };
        }
      };
    }
    var proto = Object.defineProperties(() => {
    }, styles);
    function build(_styles, _empty, key) {
      const builder = function() {
        return applyStyle.apply(builder, arguments);
      };
      builder._styles = _styles;
      builder._empty = _empty;
      const self2 = this;
      Object.defineProperty(builder, "level", {
        enumerable: true,
        get() {
          return self2.level;
        },
        set(level) {
          self2.level = level;
        }
      });
      Object.defineProperty(builder, "enabled", {
        enumerable: true,
        get() {
          return self2.enabled;
        },
        set(enabled) {
          self2.enabled = enabled;
        }
      });
      builder.hasGrey = this.hasGrey || key === "gray" || key === "grey";
      builder.__proto__ = proto;
      return builder;
    }
    function applyStyle() {
      const args = arguments;
      const argsLen = args.length;
      let str = String(arguments[0]);
      if (argsLen === 0) {
        return "";
      }
      if (argsLen > 1) {
        for (let a = 1; a < argsLen; a++) {
          str += " " + args[a];
        }
      }
      if (!this.enabled || this.level <= 0 || !str) {
        return this._empty ? "" : str;
      }
      const originalDim = ansiStyles.dim.open;
      if (isSimpleWindowsTerm && this.hasGrey) {
        ansiStyles.dim.open = "";
      }
      for (const code of this._styles.slice().reverse()) {
        str = code.open + str.replace(code.closeRe, code.open) + code.close;
        str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
      }
      ansiStyles.dim.open = originalDim;
      return str;
    }
    function chalkTag(chalk3, strings) {
      if (!Array.isArray(strings)) {
        return [].slice.call(arguments, 1).join(" ");
      }
      const args = [].slice.call(arguments, 2);
      const parts = [strings.raw[0]];
      for (let i2 = 1; i2 < strings.length; i2++) {
        parts.push(String(args[i2 - 1]).replace(/[{}\\]/g, "\\$&"));
        parts.push(String(strings.raw[i2]));
      }
      return template(chalk3, parts.join(""));
    }
    Object.defineProperties(Chalk.prototype, styles);
    module2.exports = Chalk();
    module2.exports.supportsColor = stdoutColor;
    module2.exports.default = module2.exports;
  }
});

// node_modules/@changesets/get-dependents-graph/node_modules/semver/semver.js
var require_semver = __commonJS({
  "node_modules/@changesets/get-dependents-graph/node_modules/semver/semver.js"(exports, module2) {
    exports = module2.exports = SemVer;
    var debug;
    if (typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG)) {
      debug = function() {
        var args = Array.prototype.slice.call(arguments, 0);
        args.unshift("SEMVER");
        console.log.apply(console, args);
      };
    } else {
      debug = function() {
      };
    }
    exports.SEMVER_SPEC_VERSION = "2.0.0";
    var MAX_LENGTH = 256;
    var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    var re = exports.re = [];
    var src = exports.src = [];
    var R = 0;
    var NUMERICIDENTIFIER = R++;
    src[NUMERICIDENTIFIER] = "0|[1-9]\\d*";
    var NUMERICIDENTIFIERLOOSE = R++;
    src[NUMERICIDENTIFIERLOOSE] = "[0-9]+";
    var NONNUMERICIDENTIFIER = R++;
    src[NONNUMERICIDENTIFIER] = "\\d*[a-zA-Z-][a-zA-Z0-9-]*";
    var MAINVERSION = R++;
    src[MAINVERSION] = "(" + src[NUMERICIDENTIFIER] + ")\\.(" + src[NUMERICIDENTIFIER] + ")\\.(" + src[NUMERICIDENTIFIER] + ")";
    var MAINVERSIONLOOSE = R++;
    src[MAINVERSIONLOOSE] = "(" + src[NUMERICIDENTIFIERLOOSE] + ")\\.(" + src[NUMERICIDENTIFIERLOOSE] + ")\\.(" + src[NUMERICIDENTIFIERLOOSE] + ")";
    var PRERELEASEIDENTIFIER = R++;
    src[PRERELEASEIDENTIFIER] = "(?:" + src[NUMERICIDENTIFIER] + "|" + src[NONNUMERICIDENTIFIER] + ")";
    var PRERELEASEIDENTIFIERLOOSE = R++;
    src[PRERELEASEIDENTIFIERLOOSE] = "(?:" + src[NUMERICIDENTIFIERLOOSE] + "|" + src[NONNUMERICIDENTIFIER] + ")";
    var PRERELEASE = R++;
    src[PRERELEASE] = "(?:-(" + src[PRERELEASEIDENTIFIER] + "(?:\\." + src[PRERELEASEIDENTIFIER] + ")*))";
    var PRERELEASELOOSE = R++;
    src[PRERELEASELOOSE] = "(?:-?(" + src[PRERELEASEIDENTIFIERLOOSE] + "(?:\\." + src[PRERELEASEIDENTIFIERLOOSE] + ")*))";
    var BUILDIDENTIFIER = R++;
    src[BUILDIDENTIFIER] = "[0-9A-Za-z-]+";
    var BUILD = R++;
    src[BUILD] = "(?:\\+(" + src[BUILDIDENTIFIER] + "(?:\\." + src[BUILDIDENTIFIER] + ")*))";
    var FULL = R++;
    var FULLPLAIN = "v?" + src[MAINVERSION] + src[PRERELEASE] + "?" + src[BUILD] + "?";
    src[FULL] = "^" + FULLPLAIN + "$";
    var LOOSEPLAIN = "[v=\\s]*" + src[MAINVERSIONLOOSE] + src[PRERELEASELOOSE] + "?" + src[BUILD] + "?";
    var LOOSE = R++;
    src[LOOSE] = "^" + LOOSEPLAIN + "$";
    var GTLT = R++;
    src[GTLT] = "((?:<|>)?=?)";
    var XRANGEIDENTIFIERLOOSE = R++;
    src[XRANGEIDENTIFIERLOOSE] = src[NUMERICIDENTIFIERLOOSE] + "|x|X|\\*";
    var XRANGEIDENTIFIER = R++;
    src[XRANGEIDENTIFIER] = src[NUMERICIDENTIFIER] + "|x|X|\\*";
    var XRANGEPLAIN = R++;
    src[XRANGEPLAIN] = "[v=\\s]*(" + src[XRANGEIDENTIFIER] + ")(?:\\.(" + src[XRANGEIDENTIFIER] + ")(?:\\.(" + src[XRANGEIDENTIFIER] + ")(?:" + src[PRERELEASE] + ")?" + src[BUILD] + "?)?)?";
    var XRANGEPLAINLOOSE = R++;
    src[XRANGEPLAINLOOSE] = "[v=\\s]*(" + src[XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src[XRANGEIDENTIFIERLOOSE] + ")(?:\\.(" + src[XRANGEIDENTIFIERLOOSE] + ")(?:" + src[PRERELEASELOOSE] + ")?" + src[BUILD] + "?)?)?";
    var XRANGE = R++;
    src[XRANGE] = "^" + src[GTLT] + "\\s*" + src[XRANGEPLAIN] + "$";
    var XRANGELOOSE = R++;
    src[XRANGELOOSE] = "^" + src[GTLT] + "\\s*" + src[XRANGEPLAINLOOSE] + "$";
    var COERCE = R++;
    src[COERCE] = "(?:^|[^\\d])(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "})(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "}))?(?:\\.(\\d{1," + MAX_SAFE_COMPONENT_LENGTH + "}))?(?:$|[^\\d])";
    var LONETILDE = R++;
    src[LONETILDE] = "(?:~>?)";
    var TILDETRIM = R++;
    src[TILDETRIM] = "(\\s*)" + src[LONETILDE] + "\\s+";
    re[TILDETRIM] = new RegExp(src[TILDETRIM], "g");
    var tildeTrimReplace = "$1~";
    var TILDE = R++;
    src[TILDE] = "^" + src[LONETILDE] + src[XRANGEPLAIN] + "$";
    var TILDELOOSE = R++;
    src[TILDELOOSE] = "^" + src[LONETILDE] + src[XRANGEPLAINLOOSE] + "$";
    var LONECARET = R++;
    src[LONECARET] = "(?:\\^)";
    var CARETTRIM = R++;
    src[CARETTRIM] = "(\\s*)" + src[LONECARET] + "\\s+";
    re[CARETTRIM] = new RegExp(src[CARETTRIM], "g");
    var caretTrimReplace = "$1^";
    var CARET = R++;
    src[CARET] = "^" + src[LONECARET] + src[XRANGEPLAIN] + "$";
    var CARETLOOSE = R++;
    src[CARETLOOSE] = "^" + src[LONECARET] + src[XRANGEPLAINLOOSE] + "$";
    var COMPARATORLOOSE = R++;
    src[COMPARATORLOOSE] = "^" + src[GTLT] + "\\s*(" + LOOSEPLAIN + ")$|^$";
    var COMPARATOR = R++;
    src[COMPARATOR] = "^" + src[GTLT] + "\\s*(" + FULLPLAIN + ")$|^$";
    var COMPARATORTRIM = R++;
    src[COMPARATORTRIM] = "(\\s*)" + src[GTLT] + "\\s*(" + LOOSEPLAIN + "|" + src[XRANGEPLAIN] + ")";
    re[COMPARATORTRIM] = new RegExp(src[COMPARATORTRIM], "g");
    var comparatorTrimReplace = "$1$2$3";
    var HYPHENRANGE = R++;
    src[HYPHENRANGE] = "^\\s*(" + src[XRANGEPLAIN] + ")\\s+-\\s+(" + src[XRANGEPLAIN] + ")\\s*$";
    var HYPHENRANGELOOSE = R++;
    src[HYPHENRANGELOOSE] = "^\\s*(" + src[XRANGEPLAINLOOSE] + ")\\s+-\\s+(" + src[XRANGEPLAINLOOSE] + ")\\s*$";
    var STAR = R++;
    src[STAR] = "(<|>)?=?\\s*\\*";
    for (i2 = 0; i2 < R; i2++) {
      debug(i2, src[i2]);
      if (!re[i2]) {
        re[i2] = new RegExp(src[i2]);
      }
    }
    var i2;
    exports.parse = parse3;
    function parse3(version, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== "string") {
        return null;
      }
      if (version.length > MAX_LENGTH) {
        return null;
      }
      var r2 = options.loose ? re[LOOSE] : re[FULL];
      if (!r2.test(version)) {
        return null;
      }
      try {
        return new SemVer(version, options);
      } catch (er) {
        return null;
      }
    }
    exports.valid = valid;
    function valid(version, options) {
      var v = parse3(version, options);
      return v ? v.version : null;
    }
    exports.clean = clean;
    function clean(version, options) {
      var s2 = parse3(version.trim().replace(/^[=v]+/, ""), options);
      return s2 ? s2.version : null;
    }
    exports.SemVer = SemVer;
    function SemVer(version, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (version instanceof SemVer) {
        if (version.loose === options.loose) {
          return version;
        } else {
          version = version.version;
        }
      } else if (typeof version !== "string") {
        throw new TypeError("Invalid Version: " + version);
      }
      if (version.length > MAX_LENGTH) {
        throw new TypeError("version is longer than " + MAX_LENGTH + " characters");
      }
      if (!(this instanceof SemVer)) {
        return new SemVer(version, options);
      }
      debug("SemVer", version, options);
      this.options = options;
      this.loose = !!options.loose;
      var m2 = version.trim().match(options.loose ? re[LOOSE] : re[FULL]);
      if (!m2) {
        throw new TypeError("Invalid Version: " + version);
      }
      this.raw = version;
      this.major = +m2[1];
      this.minor = +m2[2];
      this.patch = +m2[3];
      if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
        throw new TypeError("Invalid major version");
      }
      if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
        throw new TypeError("Invalid minor version");
      }
      if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
        throw new TypeError("Invalid patch version");
      }
      if (!m2[4]) {
        this.prerelease = [];
      } else {
        this.prerelease = m2[4].split(".").map(function(id) {
          if (/^[0-9]+$/.test(id)) {
            var num = +id;
            if (num >= 0 && num < MAX_SAFE_INTEGER) {
              return num;
            }
          }
          return id;
        });
      }
      this.build = m2[5] ? m2[5].split(".") : [];
      this.format();
    }
    SemVer.prototype.format = function() {
      this.version = this.major + "." + this.minor + "." + this.patch;
      if (this.prerelease.length) {
        this.version += "-" + this.prerelease.join(".");
      }
      return this.version;
    };
    SemVer.prototype.toString = function() {
      return this.version;
    };
    SemVer.prototype.compare = function(other) {
      debug("SemVer.compare", this.version, this.options, other);
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      return this.compareMain(other) || this.comparePre(other);
    };
    SemVer.prototype.compareMain = function(other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
    };
    SemVer.prototype.comparePre = function(other) {
      if (!(other instanceof SemVer)) {
        other = new SemVer(other, this.options);
      }
      if (this.prerelease.length && !other.prerelease.length) {
        return -1;
      } else if (!this.prerelease.length && other.prerelease.length) {
        return 1;
      } else if (!this.prerelease.length && !other.prerelease.length) {
        return 0;
      }
      var i3 = 0;
      do {
        var a = this.prerelease[i3];
        var b = other.prerelease[i3];
        debug("prerelease compare", i3, a, b);
        if (a === void 0 && b === void 0) {
          return 0;
        } else if (b === void 0) {
          return 1;
        } else if (a === void 0) {
          return -1;
        } else if (a === b) {
          continue;
        } else {
          return compareIdentifiers(a, b);
        }
      } while (++i3);
    };
    SemVer.prototype.inc = function(release, identifier) {
      switch (release) {
        case "premajor":
          this.prerelease.length = 0;
          this.patch = 0;
          this.minor = 0;
          this.major++;
          this.inc("pre", identifier);
          break;
        case "preminor":
          this.prerelease.length = 0;
          this.patch = 0;
          this.minor++;
          this.inc("pre", identifier);
          break;
        case "prepatch":
          this.prerelease.length = 0;
          this.inc("patch", identifier);
          this.inc("pre", identifier);
          break;
        case "prerelease":
          if (this.prerelease.length === 0) {
            this.inc("patch", identifier);
          }
          this.inc("pre", identifier);
          break;
        case "major":
          if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
            this.major++;
          }
          this.minor = 0;
          this.patch = 0;
          this.prerelease = [];
          break;
        case "minor":
          if (this.patch !== 0 || this.prerelease.length === 0) {
            this.minor++;
          }
          this.patch = 0;
          this.prerelease = [];
          break;
        case "patch":
          if (this.prerelease.length === 0) {
            this.patch++;
          }
          this.prerelease = [];
          break;
        case "pre":
          if (this.prerelease.length === 0) {
            this.prerelease = [0];
          } else {
            var i3 = this.prerelease.length;
            while (--i3 >= 0) {
              if (typeof this.prerelease[i3] === "number") {
                this.prerelease[i3]++;
                i3 = -2;
              }
            }
            if (i3 === -1) {
              this.prerelease.push(0);
            }
          }
          if (identifier) {
            if (this.prerelease[0] === identifier) {
              if (isNaN(this.prerelease[1])) {
                this.prerelease = [identifier, 0];
              }
            } else {
              this.prerelease = [identifier, 0];
            }
          }
          break;
        default:
          throw new Error("invalid increment argument: " + release);
      }
      this.format();
      this.raw = this.version;
      return this;
    };
    exports.inc = inc;
    function inc(version, release, loose, identifier) {
      if (typeof loose === "string") {
        identifier = loose;
        loose = void 0;
      }
      try {
        return new SemVer(version, loose).inc(release, identifier).version;
      } catch (er) {
        return null;
      }
    }
    exports.diff = diff2;
    function diff2(version1, version2) {
      if (eq(version1, version2)) {
        return null;
      } else {
        var v1 = parse3(version1);
        var v2 = parse3(version2);
        var prefix2 = "";
        if (v1.prerelease.length || v2.prerelease.length) {
          prefix2 = "pre";
          var defaultResult = "prerelease";
        }
        for (var key in v1) {
          if (key === "major" || key === "minor" || key === "patch") {
            if (v1[key] !== v2[key]) {
              return prefix2 + key;
            }
          }
        }
        return defaultResult;
      }
    }
    exports.compareIdentifiers = compareIdentifiers;
    var numeric = /^[0-9]+$/;
    function compareIdentifiers(a, b) {
      var anum = numeric.test(a);
      var bnum = numeric.test(b);
      if (anum && bnum) {
        a = +a;
        b = +b;
      }
      return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
    }
    exports.rcompareIdentifiers = rcompareIdentifiers;
    function rcompareIdentifiers(a, b) {
      return compareIdentifiers(b, a);
    }
    exports.major = major;
    function major(a, loose) {
      return new SemVer(a, loose).major;
    }
    exports.minor = minor;
    function minor(a, loose) {
      return new SemVer(a, loose).minor;
    }
    exports.patch = patch;
    function patch(a, loose) {
      return new SemVer(a, loose).patch;
    }
    exports.compare = compare;
    function compare(a, b, loose) {
      return new SemVer(a, loose).compare(new SemVer(b, loose));
    }
    exports.compareLoose = compareLoose;
    function compareLoose(a, b) {
      return compare(a, b, true);
    }
    exports.rcompare = rcompare;
    function rcompare(a, b, loose) {
      return compare(b, a, loose);
    }
    exports.sort = sort;
    function sort(list, loose) {
      return list.sort(function(a, b) {
        return exports.compare(a, b, loose);
      });
    }
    exports.rsort = rsort;
    function rsort(list, loose) {
      return list.sort(function(a, b) {
        return exports.rcompare(a, b, loose);
      });
    }
    exports.gt = gt;
    function gt(a, b, loose) {
      return compare(a, b, loose) > 0;
    }
    exports.lt = lt;
    function lt(a, b, loose) {
      return compare(a, b, loose) < 0;
    }
    exports.eq = eq;
    function eq(a, b, loose) {
      return compare(a, b, loose) === 0;
    }
    exports.neq = neq;
    function neq(a, b, loose) {
      return compare(a, b, loose) !== 0;
    }
    exports.gte = gte;
    function gte(a, b, loose) {
      return compare(a, b, loose) >= 0;
    }
    exports.lte = lte;
    function lte(a, b, loose) {
      return compare(a, b, loose) <= 0;
    }
    exports.cmp = cmp;
    function cmp(a, op, b, loose) {
      switch (op) {
        case "===":
          if (typeof a === "object")
            a = a.version;
          if (typeof b === "object")
            b = b.version;
          return a === b;
        case "!==":
          if (typeof a === "object")
            a = a.version;
          if (typeof b === "object")
            b = b.version;
          return a !== b;
        case "":
        case "=":
        case "==":
          return eq(a, b, loose);
        case "!=":
          return neq(a, b, loose);
        case ">":
          return gt(a, b, loose);
        case ">=":
          return gte(a, b, loose);
        case "<":
          return lt(a, b, loose);
        case "<=":
          return lte(a, b, loose);
        default:
          throw new TypeError("Invalid operator: " + op);
      }
    }
    exports.Comparator = Comparator;
    function Comparator(comp, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (comp instanceof Comparator) {
        if (comp.loose === !!options.loose) {
          return comp;
        } else {
          comp = comp.value;
        }
      }
      if (!(this instanceof Comparator)) {
        return new Comparator(comp, options);
      }
      debug("comparator", comp, options);
      this.options = options;
      this.loose = !!options.loose;
      this.parse(comp);
      if (this.semver === ANY) {
        this.value = "";
      } else {
        this.value = this.operator + this.semver.version;
      }
      debug("comp", this);
    }
    var ANY = {};
    Comparator.prototype.parse = function(comp) {
      var r2 = this.options.loose ? re[COMPARATORLOOSE] : re[COMPARATOR];
      var m2 = comp.match(r2);
      if (!m2) {
        throw new TypeError("Invalid comparator: " + comp);
      }
      this.operator = m2[1];
      if (this.operator === "=") {
        this.operator = "";
      }
      if (!m2[2]) {
        this.semver = ANY;
      } else {
        this.semver = new SemVer(m2[2], this.options.loose);
      }
    };
    Comparator.prototype.toString = function() {
      return this.value;
    };
    Comparator.prototype.test = function(version) {
      debug("Comparator.test", version, this.options.loose);
      if (this.semver === ANY) {
        return true;
      }
      if (typeof version === "string") {
        version = new SemVer(version, this.options);
      }
      return cmp(version, this.operator, this.semver, this.options);
    };
    Comparator.prototype.intersects = function(comp, options) {
      if (!(comp instanceof Comparator)) {
        throw new TypeError("a Comparator is required");
      }
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      var rangeTmp;
      if (this.operator === "") {
        rangeTmp = new Range(comp.value, options);
        return satisfies(this.value, rangeTmp, options);
      } else if (comp.operator === "") {
        rangeTmp = new Range(this.value, options);
        return satisfies(comp.semver, rangeTmp, options);
      }
      var sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
      var sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
      var sameSemVer = this.semver.version === comp.semver.version;
      var differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
      var oppositeDirectionsLessThan = cmp(this.semver, "<", comp.semver, options) && ((this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<"));
      var oppositeDirectionsGreaterThan = cmp(this.semver, ">", comp.semver, options) && ((this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">"));
      return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
    };
    exports.Range = Range;
    function Range(range, options) {
      if (!options || typeof options !== "object") {
        options = {
          loose: !!options,
          includePrerelease: false
        };
      }
      if (range instanceof Range) {
        if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
          return range;
        } else {
          return new Range(range.raw, options);
        }
      }
      if (range instanceof Comparator) {
        return new Range(range.value, options);
      }
      if (!(this instanceof Range)) {
        return new Range(range, options);
      }
      this.options = options;
      this.loose = !!options.loose;
      this.includePrerelease = !!options.includePrerelease;
      this.raw = range;
      this.set = range.split(/\s*\|\|\s*/).map(function(range2) {
        return this.parseRange(range2.trim());
      }, this).filter(function(c) {
        return c.length;
      });
      if (!this.set.length) {
        throw new TypeError("Invalid SemVer Range: " + range);
      }
      this.format();
    }
    Range.prototype.format = function() {
      this.range = this.set.map(function(comps) {
        return comps.join(" ").trim();
      }).join("||").trim();
      return this.range;
    };
    Range.prototype.toString = function() {
      return this.range;
    };
    Range.prototype.parseRange = function(range) {
      var loose = this.options.loose;
      range = range.trim();
      var hr = loose ? re[HYPHENRANGELOOSE] : re[HYPHENRANGE];
      range = range.replace(hr, hyphenReplace);
      debug("hyphen replace", range);
      range = range.replace(re[COMPARATORTRIM], comparatorTrimReplace);
      debug("comparator trim", range, re[COMPARATORTRIM]);
      range = range.replace(re[TILDETRIM], tildeTrimReplace);
      range = range.replace(re[CARETTRIM], caretTrimReplace);
      range = range.split(/\s+/).join(" ");
      var compRe = loose ? re[COMPARATORLOOSE] : re[COMPARATOR];
      var set = range.split(" ").map(function(comp) {
        return parseComparator(comp, this.options);
      }, this).join(" ").split(/\s+/);
      if (this.options.loose) {
        set = set.filter(function(comp) {
          return !!comp.match(compRe);
        });
      }
      set = set.map(function(comp) {
        return new Comparator(comp, this.options);
      }, this);
      return set;
    };
    Range.prototype.intersects = function(range, options) {
      if (!(range instanceof Range)) {
        throw new TypeError("a Range is required");
      }
      return this.set.some(function(thisComparators) {
        return thisComparators.every(function(thisComparator) {
          return range.set.some(function(rangeComparators) {
            return rangeComparators.every(function(rangeComparator) {
              return thisComparator.intersects(rangeComparator, options);
            });
          });
        });
      });
    };
    exports.toComparators = toComparators;
    function toComparators(range, options) {
      return new Range(range, options).set.map(function(comp) {
        return comp.map(function(c) {
          return c.value;
        }).join(" ").trim().split(" ");
      });
    }
    function parseComparator(comp, options) {
      debug("comp", comp, options);
      comp = replaceCarets(comp, options);
      debug("caret", comp);
      comp = replaceTildes(comp, options);
      debug("tildes", comp);
      comp = replaceXRanges(comp, options);
      debug("xrange", comp);
      comp = replaceStars(comp, options);
      debug("stars", comp);
      return comp;
    }
    function isX(id) {
      return !id || id.toLowerCase() === "x" || id === "*";
    }
    function replaceTildes(comp, options) {
      return comp.trim().split(/\s+/).map(function(comp2) {
        return replaceTilde(comp2, options);
      }).join(" ");
    }
    function replaceTilde(comp, options) {
      var r2 = options.loose ? re[TILDELOOSE] : re[TILDE];
      return comp.replace(r2, function(_, M, m2, p, pr) {
        debug("tilde", comp, _, M, m2, p, pr);
        var ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m2)) {
          ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
        } else if (isX(p)) {
          ret = ">=" + M + "." + m2 + ".0 <" + M + "." + (+m2 + 1) + ".0";
        } else if (pr) {
          debug("replaceTilde pr", pr);
          ret = ">=" + M + "." + m2 + "." + p + "-" + pr + " <" + M + "." + (+m2 + 1) + ".0";
        } else {
          ret = ">=" + M + "." + m2 + "." + p + " <" + M + "." + (+m2 + 1) + ".0";
        }
        debug("tilde return", ret);
        return ret;
      });
    }
    function replaceCarets(comp, options) {
      return comp.trim().split(/\s+/).map(function(comp2) {
        return replaceCaret(comp2, options);
      }).join(" ");
    }
    function replaceCaret(comp, options) {
      debug("caret", comp, options);
      var r2 = options.loose ? re[CARETLOOSE] : re[CARET];
      return comp.replace(r2, function(_, M, m2, p, pr) {
        debug("caret", comp, _, M, m2, p, pr);
        var ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m2)) {
          ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
        } else if (isX(p)) {
          if (M === "0") {
            ret = ">=" + M + "." + m2 + ".0 <" + M + "." + (+m2 + 1) + ".0";
          } else {
            ret = ">=" + M + "." + m2 + ".0 <" + (+M + 1) + ".0.0";
          }
        } else if (pr) {
          debug("replaceCaret pr", pr);
          if (M === "0") {
            if (m2 === "0") {
              ret = ">=" + M + "." + m2 + "." + p + "-" + pr + " <" + M + "." + m2 + "." + (+p + 1);
            } else {
              ret = ">=" + M + "." + m2 + "." + p + "-" + pr + " <" + M + "." + (+m2 + 1) + ".0";
            }
          } else {
            ret = ">=" + M + "." + m2 + "." + p + "-" + pr + " <" + (+M + 1) + ".0.0";
          }
        } else {
          debug("no pr");
          if (M === "0") {
            if (m2 === "0") {
              ret = ">=" + M + "." + m2 + "." + p + " <" + M + "." + m2 + "." + (+p + 1);
            } else {
              ret = ">=" + M + "." + m2 + "." + p + " <" + M + "." + (+m2 + 1) + ".0";
            }
          } else {
            ret = ">=" + M + "." + m2 + "." + p + " <" + (+M + 1) + ".0.0";
          }
        }
        debug("caret return", ret);
        return ret;
      });
    }
    function replaceXRanges(comp, options) {
      debug("replaceXRanges", comp, options);
      return comp.split(/\s+/).map(function(comp2) {
        return replaceXRange(comp2, options);
      }).join(" ");
    }
    function replaceXRange(comp, options) {
      comp = comp.trim();
      var r2 = options.loose ? re[XRANGELOOSE] : re[XRANGE];
      return comp.replace(r2, function(ret, gtlt, M, m2, p, pr) {
        debug("xRange", comp, ret, gtlt, M, m2, p, pr);
        var xM = isX(M);
        var xm = xM || isX(m2);
        var xp = xm || isX(p);
        var anyX = xp;
        if (gtlt === "=" && anyX) {
          gtlt = "";
        }
        if (xM) {
          if (gtlt === ">" || gtlt === "<") {
            ret = "<0.0.0";
          } else {
            ret = "*";
          }
        } else if (gtlt && anyX) {
          if (xm) {
            m2 = 0;
          }
          p = 0;
          if (gtlt === ">") {
            gtlt = ">=";
            if (xm) {
              M = +M + 1;
              m2 = 0;
              p = 0;
            } else {
              m2 = +m2 + 1;
              p = 0;
            }
          } else if (gtlt === "<=") {
            gtlt = "<";
            if (xm) {
              M = +M + 1;
            } else {
              m2 = +m2 + 1;
            }
          }
          ret = gtlt + M + "." + m2 + "." + p;
        } else if (xm) {
          ret = ">=" + M + ".0.0 <" + (+M + 1) + ".0.0";
        } else if (xp) {
          ret = ">=" + M + "." + m2 + ".0 <" + M + "." + (+m2 + 1) + ".0";
        }
        debug("xRange return", ret);
        return ret;
      });
    }
    function replaceStars(comp, options) {
      debug("replaceStars", comp, options);
      return comp.trim().replace(re[STAR], "");
    }
    function hyphenReplace($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) {
      if (isX(fM)) {
        from = "";
      } else if (isX(fm)) {
        from = ">=" + fM + ".0.0";
      } else if (isX(fp)) {
        from = ">=" + fM + "." + fm + ".0";
      } else {
        from = ">=" + from;
      }
      if (isX(tM)) {
        to = "";
      } else if (isX(tm)) {
        to = "<" + (+tM + 1) + ".0.0";
      } else if (isX(tp)) {
        to = "<" + tM + "." + (+tm + 1) + ".0";
      } else if (tpr) {
        to = "<=" + tM + "." + tm + "." + tp + "-" + tpr;
      } else {
        to = "<=" + to;
      }
      return (from + " " + to).trim();
    }
    Range.prototype.test = function(version) {
      if (!version) {
        return false;
      }
      if (typeof version === "string") {
        version = new SemVer(version, this.options);
      }
      for (var i3 = 0; i3 < this.set.length; i3++) {
        if (testSet(this.set[i3], version, this.options)) {
          return true;
        }
      }
      return false;
    };
    function testSet(set, version, options) {
      for (var i3 = 0; i3 < set.length; i3++) {
        if (!set[i3].test(version)) {
          return false;
        }
      }
      if (version.prerelease.length && !options.includePrerelease) {
        for (i3 = 0; i3 < set.length; i3++) {
          debug(set[i3].semver);
          if (set[i3].semver === ANY) {
            continue;
          }
          if (set[i3].semver.prerelease.length > 0) {
            var allowed = set[i3].semver;
            if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
              return true;
            }
          }
        }
        return false;
      }
      return true;
    }
    exports.satisfies = satisfies;
    function satisfies(version, range, options) {
      try {
        range = new Range(range, options);
      } catch (er) {
        return false;
      }
      return range.test(version);
    }
    exports.maxSatisfying = maxSatisfying;
    function maxSatisfying(versions, range, options) {
      var max = null;
      var maxSV = null;
      try {
        var rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach(function(v) {
        if (rangeObj.test(v)) {
          if (!max || maxSV.compare(v) === -1) {
            max = v;
            maxSV = new SemVer(max, options);
          }
        }
      });
      return max;
    }
    exports.minSatisfying = minSatisfying;
    function minSatisfying(versions, range, options) {
      var min = null;
      var minSV = null;
      try {
        var rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach(function(v) {
        if (rangeObj.test(v)) {
          if (!min || minSV.compare(v) === 1) {
            min = v;
            minSV = new SemVer(min, options);
          }
        }
      });
      return min;
    }
    exports.minVersion = minVersion;
    function minVersion(range, loose) {
      range = new Range(range, loose);
      var minver = new SemVer("0.0.0");
      if (range.test(minver)) {
        return minver;
      }
      minver = new SemVer("0.0.0-0");
      if (range.test(minver)) {
        return minver;
      }
      minver = null;
      for (var i3 = 0; i3 < range.set.length; ++i3) {
        var comparators = range.set[i3];
        comparators.forEach(function(comparator) {
          var compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case ">":
              if (compver.prerelease.length === 0) {
                compver.patch++;
              } else {
                compver.prerelease.push(0);
              }
              compver.raw = compver.format();
            case "":
            case ">=":
              if (!minver || gt(minver, compver)) {
                minver = compver;
              }
              break;
            case "<":
            case "<=":
              break;
            default:
              throw new Error("Unexpected operation: " + comparator.operator);
          }
        });
      }
      if (minver && range.test(minver)) {
        return minver;
      }
      return null;
    }
    exports.validRange = validRange;
    function validRange(range, options) {
      try {
        return new Range(range, options).range || "*";
      } catch (er) {
        return null;
      }
    }
    exports.ltr = ltr;
    function ltr(version, range, options) {
      return outside(version, range, "<", options);
    }
    exports.gtr = gtr;
    function gtr(version, range, options) {
      return outside(version, range, ">", options);
    }
    exports.outside = outside;
    function outside(version, range, hilo, options) {
      version = new SemVer(version, options);
      range = new Range(range, options);
      var gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case ">":
          gtfn = gt;
          ltefn = lte;
          ltfn = lt;
          comp = ">";
          ecomp = ">=";
          break;
        case "<":
          gtfn = lt;
          ltefn = gte;
          ltfn = gt;
          comp = "<";
          ecomp = "<=";
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version, range, options)) {
        return false;
      }
      for (var i3 = 0; i3 < range.set.length; ++i3) {
        var comparators = range.set[i3];
        var high = null;
        var low = null;
        comparators.forEach(function(comparator) {
          if (comparator.semver === ANY) {
            comparator = new Comparator(">=0.0.0");
          }
          high = high || comparator;
          low = low || comparator;
          if (gtfn(comparator.semver, high.semver, options)) {
            high = comparator;
          } else if (ltfn(comparator.semver, low.semver, options)) {
            low = comparator;
          }
        });
        if (high.operator === comp || high.operator === ecomp) {
          return false;
        }
        if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
          return false;
        } else if (low.operator === ecomp && ltfn(version, low.semver)) {
          return false;
        }
      }
      return true;
    }
    exports.prerelease = prerelease;
    function prerelease(version, options) {
      var parsed = parse3(version, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    }
    exports.intersects = intersects;
    function intersects(r1, r2, options) {
      r1 = new Range(r1, options);
      r2 = new Range(r2, options);
      return r1.intersects(r2);
    }
    exports.coerce = coerce;
    function coerce(version) {
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== "string") {
        return null;
      }
      var match = version.match(re[COERCE]);
      if (match == null) {
        return null;
      }
      return parse3(match[1] + "." + (match[2] || "0") + "." + (match[3] || "0"));
    }
  }
});

// node_modules/truncate-utf8-bytes/lib/truncate.js
var require_truncate = __commonJS({
  "node_modules/truncate-utf8-bytes/lib/truncate.js"(exports, module2) {
    "use strict";
    function isHighSurrogate(codePoint) {
      return codePoint >= 55296 && codePoint <= 56319;
    }
    function isLowSurrogate(codePoint) {
      return codePoint >= 56320 && codePoint <= 57343;
    }
    module2.exports = function truncate(getLength, string, byteLength) {
      if (typeof string !== "string") {
        throw new Error("Input must be string");
      }
      var charLength = string.length;
      var curByteLength = 0;
      var codePoint;
      var segment;
      for (var i2 = 0; i2 < charLength; i2 += 1) {
        codePoint = string.charCodeAt(i2);
        segment = string[i2];
        if (isHighSurrogate(codePoint) && isLowSurrogate(string.charCodeAt(i2 + 1))) {
          i2 += 1;
          segment += string[i2];
        }
        curByteLength += getLength(segment);
        if (curByteLength === byteLength) {
          return string.slice(0, i2 + 1);
        } else if (curByteLength > byteLength) {
          return string.slice(0, i2 - segment.length + 1);
        }
      }
      return string;
    };
  }
});

// node_modules/truncate-utf8-bytes/index.js
var require_truncate_utf8_bytes = __commonJS({
  "node_modules/truncate-utf8-bytes/index.js"(exports, module2) {
    "use strict";
    var truncate = require_truncate();
    var getLength = Buffer.byteLength.bind(Buffer);
    module2.exports = truncate.bind(null, getLength);
  }
});

// node_modules/sanitize-filename/index.js
var require_sanitize_filename = __commonJS({
  "node_modules/sanitize-filename/index.js"(exports, module2) {
    "use strict";
    var truncate = require_truncate_utf8_bytes();
    var illegalRe = /[\/\?<>\\:\*\|"]/g;
    var controlRe = /[\x00-\x1f\x80-\x9f]/g;
    var reservedRe = /^\.+$/;
    var windowsReservedRe = /^(con|prn|aux|nul|com[0-9]|lpt[0-9])(\..*)?$/i;
    var windowsTrailingRe = /[\. ]+$/;
    function sanitize2(input, replacement) {
      if (typeof input !== "string") {
        throw new Error("Input must be string");
      }
      var sanitized = input.replace(illegalRe, replacement).replace(controlRe, replacement).replace(reservedRe, replacement).replace(windowsReservedRe, replacement).replace(windowsTrailingRe, replacement);
      return truncate(sanitized, 255);
    }
    module2.exports = function(input, options) {
      var replacement = options && options.replacement || "";
      var output = sanitize2(input, replacement);
      if (replacement === "") {
        return output;
      }
      return sanitize2(output, "");
    };
  }
});

// node_modules/semver/internal/constants.js
var require_constants4 = __commonJS({
  "node_modules/semver/internal/constants.js"(exports, module2) {
    var SEMVER_SPEC_VERSION = "2.0.0";
    var MAX_LENGTH = 256;
    var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    module2.exports = {
      SEMVER_SPEC_VERSION,
      MAX_LENGTH,
      MAX_SAFE_INTEGER,
      MAX_SAFE_COMPONENT_LENGTH
    };
  }
});

// node_modules/semver/internal/debug.js
var require_debug = __commonJS({
  "node_modules/semver/internal/debug.js"(exports, module2) {
    var debug = typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG) ? (...args) => console.error("SEMVER", ...args) : () => {
    };
    module2.exports = debug;
  }
});

// node_modules/semver/internal/re.js
var require_re = __commonJS({
  "node_modules/semver/internal/re.js"(exports, module2) {
    var { MAX_SAFE_COMPONENT_LENGTH } = require_constants4();
    var debug = require_debug();
    exports = module2.exports = {};
    var re = exports.re = [];
    var src = exports.src = [];
    var t2 = exports.t = {};
    var R = 0;
    var createToken = (name, value, isGlobal) => {
      const index = R++;
      debug(name, index, value);
      t2[name] = index;
      src[index] = value;
      re[index] = new RegExp(value, isGlobal ? "g" : void 0);
    };
    createToken("NUMERICIDENTIFIER", "0|[1-9]\\d*");
    createToken("NUMERICIDENTIFIERLOOSE", "[0-9]+");
    createToken("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*");
    createToken("MAINVERSION", `(${src[t2.NUMERICIDENTIFIER]})\\.(${src[t2.NUMERICIDENTIFIER]})\\.(${src[t2.NUMERICIDENTIFIER]})`);
    createToken("MAINVERSIONLOOSE", `(${src[t2.NUMERICIDENTIFIERLOOSE]})\\.(${src[t2.NUMERICIDENTIFIERLOOSE]})\\.(${src[t2.NUMERICIDENTIFIERLOOSE]})`);
    createToken("PRERELEASEIDENTIFIER", `(?:${src[t2.NUMERICIDENTIFIER]}|${src[t2.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASEIDENTIFIERLOOSE", `(?:${src[t2.NUMERICIDENTIFIERLOOSE]}|${src[t2.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASE", `(?:-(${src[t2.PRERELEASEIDENTIFIER]}(?:\\.${src[t2.PRERELEASEIDENTIFIER]})*))`);
    createToken("PRERELEASELOOSE", `(?:-?(${src[t2.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${src[t2.PRERELEASEIDENTIFIERLOOSE]})*))`);
    createToken("BUILDIDENTIFIER", "[0-9A-Za-z-]+");
    createToken("BUILD", `(?:\\+(${src[t2.BUILDIDENTIFIER]}(?:\\.${src[t2.BUILDIDENTIFIER]})*))`);
    createToken("FULLPLAIN", `v?${src[t2.MAINVERSION]}${src[t2.PRERELEASE]}?${src[t2.BUILD]}?`);
    createToken("FULL", `^${src[t2.FULLPLAIN]}$`);
    createToken("LOOSEPLAIN", `[v=\\s]*${src[t2.MAINVERSIONLOOSE]}${src[t2.PRERELEASELOOSE]}?${src[t2.BUILD]}?`);
    createToken("LOOSE", `^${src[t2.LOOSEPLAIN]}$`);
    createToken("GTLT", "((?:<|>)?=?)");
    createToken("XRANGEIDENTIFIERLOOSE", `${src[t2.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);
    createToken("XRANGEIDENTIFIER", `${src[t2.NUMERICIDENTIFIER]}|x|X|\\*`);
    createToken("XRANGEPLAIN", `[v=\\s]*(${src[t2.XRANGEIDENTIFIER]})(?:\\.(${src[t2.XRANGEIDENTIFIER]})(?:\\.(${src[t2.XRANGEIDENTIFIER]})(?:${src[t2.PRERELEASE]})?${src[t2.BUILD]}?)?)?`);
    createToken("XRANGEPLAINLOOSE", `[v=\\s]*(${src[t2.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t2.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t2.XRANGEIDENTIFIERLOOSE]})(?:${src[t2.PRERELEASELOOSE]})?${src[t2.BUILD]}?)?)?`);
    createToken("XRANGE", `^${src[t2.GTLT]}\\s*${src[t2.XRANGEPLAIN]}$`);
    createToken("XRANGELOOSE", `^${src[t2.GTLT]}\\s*${src[t2.XRANGEPLAINLOOSE]}$`);
    createToken("COERCE", `${"(^|[^\\d])(\\d{1,"}${MAX_SAFE_COMPONENT_LENGTH}})(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:$|[^\\d])`);
    createToken("COERCERTL", src[t2.COERCE], true);
    createToken("LONETILDE", "(?:~>?)");
    createToken("TILDETRIM", `(\\s*)${src[t2.LONETILDE]}\\s+`, true);
    exports.tildeTrimReplace = "$1~";
    createToken("TILDE", `^${src[t2.LONETILDE]}${src[t2.XRANGEPLAIN]}$`);
    createToken("TILDELOOSE", `^${src[t2.LONETILDE]}${src[t2.XRANGEPLAINLOOSE]}$`);
    createToken("LONECARET", "(?:\\^)");
    createToken("CARETTRIM", `(\\s*)${src[t2.LONECARET]}\\s+`, true);
    exports.caretTrimReplace = "$1^";
    createToken("CARET", `^${src[t2.LONECARET]}${src[t2.XRANGEPLAIN]}$`);
    createToken("CARETLOOSE", `^${src[t2.LONECARET]}${src[t2.XRANGEPLAINLOOSE]}$`);
    createToken("COMPARATORLOOSE", `^${src[t2.GTLT]}\\s*(${src[t2.LOOSEPLAIN]})$|^$`);
    createToken("COMPARATOR", `^${src[t2.GTLT]}\\s*(${src[t2.FULLPLAIN]})$|^$`);
    createToken("COMPARATORTRIM", `(\\s*)${src[t2.GTLT]}\\s*(${src[t2.LOOSEPLAIN]}|${src[t2.XRANGEPLAIN]})`, true);
    exports.comparatorTrimReplace = "$1$2$3";
    createToken("HYPHENRANGE", `^\\s*(${src[t2.XRANGEPLAIN]})\\s+-\\s+(${src[t2.XRANGEPLAIN]})\\s*$`);
    createToken("HYPHENRANGELOOSE", `^\\s*(${src[t2.XRANGEPLAINLOOSE]})\\s+-\\s+(${src[t2.XRANGEPLAINLOOSE]})\\s*$`);
    createToken("STAR", "(<|>)?=?\\s*\\*");
    createToken("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$");
    createToken("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
  }
});

// node_modules/semver/internal/parse-options.js
var require_parse_options = __commonJS({
  "node_modules/semver/internal/parse-options.js"(exports, module2) {
    var opts = ["includePrerelease", "loose", "rtl"];
    var parseOptions = (options) => !options ? {} : typeof options !== "object" ? { loose: true } : opts.filter((k) => options[k]).reduce((o, k) => {
      o[k] = true;
      return o;
    }, {});
    module2.exports = parseOptions;
  }
});

// node_modules/semver/internal/identifiers.js
var require_identifiers = __commonJS({
  "node_modules/semver/internal/identifiers.js"(exports, module2) {
    var numeric = /^[0-9]+$/;
    var compareIdentifiers = (a, b) => {
      const anum = numeric.test(a);
      const bnum = numeric.test(b);
      if (anum && bnum) {
        a = +a;
        b = +b;
      }
      return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
    };
    var rcompareIdentifiers = (a, b) => compareIdentifiers(b, a);
    module2.exports = {
      compareIdentifiers,
      rcompareIdentifiers
    };
  }
});

// node_modules/semver/classes/semver.js
var require_semver2 = __commonJS({
  "node_modules/semver/classes/semver.js"(exports, module2) {
    var debug = require_debug();
    var { MAX_LENGTH, MAX_SAFE_INTEGER } = require_constants4();
    var { re, t: t2 } = require_re();
    var parseOptions = require_parse_options();
    var { compareIdentifiers } = require_identifiers();
    var SemVer = class {
      constructor(version, options) {
        options = parseOptions(options);
        if (version instanceof SemVer) {
          if (version.loose === !!options.loose && version.includePrerelease === !!options.includePrerelease) {
            return version;
          } else {
            version = version.version;
          }
        } else if (typeof version !== "string") {
          throw new TypeError(`Invalid Version: ${version}`);
        }
        if (version.length > MAX_LENGTH) {
          throw new TypeError(
            `version is longer than ${MAX_LENGTH} characters`
          );
        }
        debug("SemVer", version, options);
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        const m2 = version.trim().match(options.loose ? re[t2.LOOSE] : re[t2.FULL]);
        if (!m2) {
          throw new TypeError(`Invalid Version: ${version}`);
        }
        this.raw = version;
        this.major = +m2[1];
        this.minor = +m2[2];
        this.patch = +m2[3];
        if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
          throw new TypeError("Invalid major version");
        }
        if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
          throw new TypeError("Invalid minor version");
        }
        if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
          throw new TypeError("Invalid patch version");
        }
        if (!m2[4]) {
          this.prerelease = [];
        } else {
          this.prerelease = m2[4].split(".").map((id) => {
            if (/^[0-9]+$/.test(id)) {
              const num = +id;
              if (num >= 0 && num < MAX_SAFE_INTEGER) {
                return num;
              }
            }
            return id;
          });
        }
        this.build = m2[5] ? m2[5].split(".") : [];
        this.format();
      }
      format() {
        this.version = `${this.major}.${this.minor}.${this.patch}`;
        if (this.prerelease.length) {
          this.version += `-${this.prerelease.join(".")}`;
        }
        return this.version;
      }
      toString() {
        return this.version;
      }
      compare(other) {
        debug("SemVer.compare", this.version, this.options, other);
        if (!(other instanceof SemVer)) {
          if (typeof other === "string" && other === this.version) {
            return 0;
          }
          other = new SemVer(other, this.options);
        }
        if (other.version === this.version) {
          return 0;
        }
        return this.compareMain(other) || this.comparePre(other);
      }
      compareMain(other) {
        if (!(other instanceof SemVer)) {
          other = new SemVer(other, this.options);
        }
        return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
      }
      comparePre(other) {
        if (!(other instanceof SemVer)) {
          other = new SemVer(other, this.options);
        }
        if (this.prerelease.length && !other.prerelease.length) {
          return -1;
        } else if (!this.prerelease.length && other.prerelease.length) {
          return 1;
        } else if (!this.prerelease.length && !other.prerelease.length) {
          return 0;
        }
        let i2 = 0;
        do {
          const a = this.prerelease[i2];
          const b = other.prerelease[i2];
          debug("prerelease compare", i2, a, b);
          if (a === void 0 && b === void 0) {
            return 0;
          } else if (b === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b) {
            continue;
          } else {
            return compareIdentifiers(a, b);
          }
        } while (++i2);
      }
      compareBuild(other) {
        if (!(other instanceof SemVer)) {
          other = new SemVer(other, this.options);
        }
        let i2 = 0;
        do {
          const a = this.build[i2];
          const b = other.build[i2];
          debug("prerelease compare", i2, a, b);
          if (a === void 0 && b === void 0) {
            return 0;
          } else if (b === void 0) {
            return 1;
          } else if (a === void 0) {
            return -1;
          } else if (a === b) {
            continue;
          } else {
            return compareIdentifiers(a, b);
          }
        } while (++i2);
      }
      inc(release, identifier) {
        switch (release) {
          case "premajor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor = 0;
            this.major++;
            this.inc("pre", identifier);
            break;
          case "preminor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor++;
            this.inc("pre", identifier);
            break;
          case "prepatch":
            this.prerelease.length = 0;
            this.inc("patch", identifier);
            this.inc("pre", identifier);
            break;
          case "prerelease":
            if (this.prerelease.length === 0) {
              this.inc("patch", identifier);
            }
            this.inc("pre", identifier);
            break;
          case "major":
            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
              this.major++;
            }
            this.minor = 0;
            this.patch = 0;
            this.prerelease = [];
            break;
          case "minor":
            if (this.patch !== 0 || this.prerelease.length === 0) {
              this.minor++;
            }
            this.patch = 0;
            this.prerelease = [];
            break;
          case "patch":
            if (this.prerelease.length === 0) {
              this.patch++;
            }
            this.prerelease = [];
            break;
          case "pre":
            if (this.prerelease.length === 0) {
              this.prerelease = [0];
            } else {
              let i2 = this.prerelease.length;
              while (--i2 >= 0) {
                if (typeof this.prerelease[i2] === "number") {
                  this.prerelease[i2]++;
                  i2 = -2;
                }
              }
              if (i2 === -1) {
                this.prerelease.push(0);
              }
            }
            if (identifier) {
              if (compareIdentifiers(this.prerelease[0], identifier) === 0) {
                if (isNaN(this.prerelease[1])) {
                  this.prerelease = [identifier, 0];
                }
              } else {
                this.prerelease = [identifier, 0];
              }
            }
            break;
          default:
            throw new Error(`invalid increment argument: ${release}`);
        }
        this.format();
        this.raw = this.version;
        return this;
      }
    };
    module2.exports = SemVer;
  }
});

// node_modules/semver/functions/parse.js
var require_parse3 = __commonJS({
  "node_modules/semver/functions/parse.js"(exports, module2) {
    var { MAX_LENGTH } = require_constants4();
    var { re, t: t2 } = require_re();
    var SemVer = require_semver2();
    var parseOptions = require_parse_options();
    var parse3 = (version, options) => {
      options = parseOptions(options);
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== "string") {
        return null;
      }
      if (version.length > MAX_LENGTH) {
        return null;
      }
      const r2 = options.loose ? re[t2.LOOSE] : re[t2.FULL];
      if (!r2.test(version)) {
        return null;
      }
      try {
        return new SemVer(version, options);
      } catch (er) {
        return null;
      }
    };
    module2.exports = parse3;
  }
});

// node_modules/semver/functions/valid.js
var require_valid = __commonJS({
  "node_modules/semver/functions/valid.js"(exports, module2) {
    var parse3 = require_parse3();
    var valid = (version, options) => {
      const v = parse3(version, options);
      return v ? v.version : null;
    };
    module2.exports = valid;
  }
});

// node_modules/semver/functions/clean.js
var require_clean = __commonJS({
  "node_modules/semver/functions/clean.js"(exports, module2) {
    var parse3 = require_parse3();
    var clean = (version, options) => {
      const s2 = parse3(version.trim().replace(/^[=v]+/, ""), options);
      return s2 ? s2.version : null;
    };
    module2.exports = clean;
  }
});

// node_modules/semver/functions/inc.js
var require_inc = __commonJS({
  "node_modules/semver/functions/inc.js"(exports, module2) {
    var SemVer = require_semver2();
    var inc = (version, release, options, identifier) => {
      if (typeof options === "string") {
        identifier = options;
        options = void 0;
      }
      try {
        return new SemVer(
          version instanceof SemVer ? version.version : version,
          options
        ).inc(release, identifier).version;
      } catch (er) {
        return null;
      }
    };
    module2.exports = inc;
  }
});

// node_modules/semver/functions/compare.js
var require_compare = __commonJS({
  "node_modules/semver/functions/compare.js"(exports, module2) {
    var SemVer = require_semver2();
    var compare = (a, b, loose) => new SemVer(a, loose).compare(new SemVer(b, loose));
    module2.exports = compare;
  }
});

// node_modules/semver/functions/eq.js
var require_eq = __commonJS({
  "node_modules/semver/functions/eq.js"(exports, module2) {
    var compare = require_compare();
    var eq = (a, b, loose) => compare(a, b, loose) === 0;
    module2.exports = eq;
  }
});

// node_modules/semver/functions/diff.js
var require_diff = __commonJS({
  "node_modules/semver/functions/diff.js"(exports, module2) {
    var parse3 = require_parse3();
    var eq = require_eq();
    var diff2 = (version1, version2) => {
      if (eq(version1, version2)) {
        return null;
      } else {
        const v1 = parse3(version1);
        const v2 = parse3(version2);
        const hasPre = v1.prerelease.length || v2.prerelease.length;
        const prefix2 = hasPre ? "pre" : "";
        const defaultResult = hasPre ? "prerelease" : "";
        for (const key in v1) {
          if (key === "major" || key === "minor" || key === "patch") {
            if (v1[key] !== v2[key]) {
              return prefix2 + key;
            }
          }
        }
        return defaultResult;
      }
    };
    module2.exports = diff2;
  }
});

// node_modules/semver/functions/major.js
var require_major = __commonJS({
  "node_modules/semver/functions/major.js"(exports, module2) {
    var SemVer = require_semver2();
    var major = (a, loose) => new SemVer(a, loose).major;
    module2.exports = major;
  }
});

// node_modules/semver/functions/minor.js
var require_minor = __commonJS({
  "node_modules/semver/functions/minor.js"(exports, module2) {
    var SemVer = require_semver2();
    var minor = (a, loose) => new SemVer(a, loose).minor;
    module2.exports = minor;
  }
});

// node_modules/semver/functions/patch.js
var require_patch = __commonJS({
  "node_modules/semver/functions/patch.js"(exports, module2) {
    var SemVer = require_semver2();
    var patch = (a, loose) => new SemVer(a, loose).patch;
    module2.exports = patch;
  }
});

// node_modules/semver/functions/prerelease.js
var require_prerelease = __commonJS({
  "node_modules/semver/functions/prerelease.js"(exports, module2) {
    var parse3 = require_parse3();
    var prerelease = (version, options) => {
      const parsed = parse3(version, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    };
    module2.exports = prerelease;
  }
});

// node_modules/semver/functions/rcompare.js
var require_rcompare = __commonJS({
  "node_modules/semver/functions/rcompare.js"(exports, module2) {
    var compare = require_compare();
    var rcompare = (a, b, loose) => compare(b, a, loose);
    module2.exports = rcompare;
  }
});

// node_modules/semver/functions/compare-loose.js
var require_compare_loose = __commonJS({
  "node_modules/semver/functions/compare-loose.js"(exports, module2) {
    var compare = require_compare();
    var compareLoose = (a, b) => compare(a, b, true);
    module2.exports = compareLoose;
  }
});

// node_modules/semver/functions/compare-build.js
var require_compare_build = __commonJS({
  "node_modules/semver/functions/compare-build.js"(exports, module2) {
    var SemVer = require_semver2();
    var compareBuild = (a, b, loose) => {
      const versionA = new SemVer(a, loose);
      const versionB = new SemVer(b, loose);
      return versionA.compare(versionB) || versionA.compareBuild(versionB);
    };
    module2.exports = compareBuild;
  }
});

// node_modules/semver/functions/sort.js
var require_sort = __commonJS({
  "node_modules/semver/functions/sort.js"(exports, module2) {
    var compareBuild = require_compare_build();
    var sort = (list, loose) => list.sort((a, b) => compareBuild(a, b, loose));
    module2.exports = sort;
  }
});

// node_modules/semver/functions/rsort.js
var require_rsort = __commonJS({
  "node_modules/semver/functions/rsort.js"(exports, module2) {
    var compareBuild = require_compare_build();
    var rsort = (list, loose) => list.sort((a, b) => compareBuild(b, a, loose));
    module2.exports = rsort;
  }
});

// node_modules/semver/functions/gt.js
var require_gt = __commonJS({
  "node_modules/semver/functions/gt.js"(exports, module2) {
    var compare = require_compare();
    var gt = (a, b, loose) => compare(a, b, loose) > 0;
    module2.exports = gt;
  }
});

// node_modules/semver/functions/lt.js
var require_lt = __commonJS({
  "node_modules/semver/functions/lt.js"(exports, module2) {
    var compare = require_compare();
    var lt = (a, b, loose) => compare(a, b, loose) < 0;
    module2.exports = lt;
  }
});

// node_modules/semver/functions/neq.js
var require_neq = __commonJS({
  "node_modules/semver/functions/neq.js"(exports, module2) {
    var compare = require_compare();
    var neq = (a, b, loose) => compare(a, b, loose) !== 0;
    module2.exports = neq;
  }
});

// node_modules/semver/functions/gte.js
var require_gte = __commonJS({
  "node_modules/semver/functions/gte.js"(exports, module2) {
    var compare = require_compare();
    var gte = (a, b, loose) => compare(a, b, loose) >= 0;
    module2.exports = gte;
  }
});

// node_modules/semver/functions/lte.js
var require_lte = __commonJS({
  "node_modules/semver/functions/lte.js"(exports, module2) {
    var compare = require_compare();
    var lte = (a, b, loose) => compare(a, b, loose) <= 0;
    module2.exports = lte;
  }
});

// node_modules/semver/functions/cmp.js
var require_cmp = __commonJS({
  "node_modules/semver/functions/cmp.js"(exports, module2) {
    var eq = require_eq();
    var neq = require_neq();
    var gt = require_gt();
    var gte = require_gte();
    var lt = require_lt();
    var lte = require_lte();
    var cmp = (a, op, b, loose) => {
      switch (op) {
        case "===":
          if (typeof a === "object") {
            a = a.version;
          }
          if (typeof b === "object") {
            b = b.version;
          }
          return a === b;
        case "!==":
          if (typeof a === "object") {
            a = a.version;
          }
          if (typeof b === "object") {
            b = b.version;
          }
          return a !== b;
        case "":
        case "=":
        case "==":
          return eq(a, b, loose);
        case "!=":
          return neq(a, b, loose);
        case ">":
          return gt(a, b, loose);
        case ">=":
          return gte(a, b, loose);
        case "<":
          return lt(a, b, loose);
        case "<=":
          return lte(a, b, loose);
        default:
          throw new TypeError(`Invalid operator: ${op}`);
      }
    };
    module2.exports = cmp;
  }
});

// node_modules/semver/functions/coerce.js
var require_coerce = __commonJS({
  "node_modules/semver/functions/coerce.js"(exports, module2) {
    var SemVer = require_semver2();
    var parse3 = require_parse3();
    var { re, t: t2 } = require_re();
    var coerce = (version, options) => {
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version === "number") {
        version = String(version);
      }
      if (typeof version !== "string") {
        return null;
      }
      options = options || {};
      let match = null;
      if (!options.rtl) {
        match = version.match(re[t2.COERCE]);
      } else {
        let next;
        while ((next = re[t2.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
          if (!match || next.index + next[0].length !== match.index + match[0].length) {
            match = next;
          }
          re[t2.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
        }
        re[t2.COERCERTL].lastIndex = -1;
      }
      if (match === null) {
        return null;
      }
      return parse3(`${match[2]}.${match[3] || "0"}.${match[4] || "0"}`, options);
    };
    module2.exports = coerce;
  }
});

// node_modules/yallist/iterator.js
var require_iterator = __commonJS({
  "node_modules/yallist/iterator.js"(exports, module2) {
    "use strict";
    module2.exports = function(Yallist) {
      Yallist.prototype[Symbol.iterator] = function* () {
        for (let walker = this.head; walker; walker = walker.next) {
          yield walker.value;
        }
      };
    };
  }
});

// node_modules/yallist/yallist.js
var require_yallist = __commonJS({
  "node_modules/yallist/yallist.js"(exports, module2) {
    "use strict";
    module2.exports = Yallist;
    Yallist.Node = Node;
    Yallist.create = Yallist;
    function Yallist(list) {
      var self2 = this;
      if (!(self2 instanceof Yallist)) {
        self2 = new Yallist();
      }
      self2.tail = null;
      self2.head = null;
      self2.length = 0;
      if (list && typeof list.forEach === "function") {
        list.forEach(function(item) {
          self2.push(item);
        });
      } else if (arguments.length > 0) {
        for (var i2 = 0, l = arguments.length; i2 < l; i2++) {
          self2.push(arguments[i2]);
        }
      }
      return self2;
    }
    Yallist.prototype.removeNode = function(node) {
      if (node.list !== this) {
        throw new Error("removing node which does not belong to this list");
      }
      var next = node.next;
      var prev = node.prev;
      if (next) {
        next.prev = prev;
      }
      if (prev) {
        prev.next = next;
      }
      if (node === this.head) {
        this.head = next;
      }
      if (node === this.tail) {
        this.tail = prev;
      }
      node.list.length--;
      node.next = null;
      node.prev = null;
      node.list = null;
      return next;
    };
    Yallist.prototype.unshiftNode = function(node) {
      if (node === this.head) {
        return;
      }
      if (node.list) {
        node.list.removeNode(node);
      }
      var head = this.head;
      node.list = this;
      node.next = head;
      if (head) {
        head.prev = node;
      }
      this.head = node;
      if (!this.tail) {
        this.tail = node;
      }
      this.length++;
    };
    Yallist.prototype.pushNode = function(node) {
      if (node === this.tail) {
        return;
      }
      if (node.list) {
        node.list.removeNode(node);
      }
      var tail = this.tail;
      node.list = this;
      node.prev = tail;
      if (tail) {
        tail.next = node;
      }
      this.tail = node;
      if (!this.head) {
        this.head = node;
      }
      this.length++;
    };
    Yallist.prototype.push = function() {
      for (var i2 = 0, l = arguments.length; i2 < l; i2++) {
        push2(this, arguments[i2]);
      }
      return this.length;
    };
    Yallist.prototype.unshift = function() {
      for (var i2 = 0, l = arguments.length; i2 < l; i2++) {
        unshift(this, arguments[i2]);
      }
      return this.length;
    };
    Yallist.prototype.pop = function() {
      if (!this.tail) {
        return void 0;
      }
      var res = this.tail.value;
      this.tail = this.tail.prev;
      if (this.tail) {
        this.tail.next = null;
      } else {
        this.head = null;
      }
      this.length--;
      return res;
    };
    Yallist.prototype.shift = function() {
      if (!this.head) {
        return void 0;
      }
      var res = this.head.value;
      this.head = this.head.next;
      if (this.head) {
        this.head.prev = null;
      } else {
        this.tail = null;
      }
      this.length--;
      return res;
    };
    Yallist.prototype.forEach = function(fn, thisp) {
      thisp = thisp || this;
      for (var walker = this.head, i2 = 0; walker !== null; i2++) {
        fn.call(thisp, walker.value, i2, this);
        walker = walker.next;
      }
    };
    Yallist.prototype.forEachReverse = function(fn, thisp) {
      thisp = thisp || this;
      for (var walker = this.tail, i2 = this.length - 1; walker !== null; i2--) {
        fn.call(thisp, walker.value, i2, this);
        walker = walker.prev;
      }
    };
    Yallist.prototype.get = function(n) {
      for (var i2 = 0, walker = this.head; walker !== null && i2 < n; i2++) {
        walker = walker.next;
      }
      if (i2 === n && walker !== null) {
        return walker.value;
      }
    };
    Yallist.prototype.getReverse = function(n) {
      for (var i2 = 0, walker = this.tail; walker !== null && i2 < n; i2++) {
        walker = walker.prev;
      }
      if (i2 === n && walker !== null) {
        return walker.value;
      }
    };
    Yallist.prototype.map = function(fn, thisp) {
      thisp = thisp || this;
      var res = new Yallist();
      for (var walker = this.head; walker !== null; ) {
        res.push(fn.call(thisp, walker.value, this));
        walker = walker.next;
      }
      return res;
    };
    Yallist.prototype.mapReverse = function(fn, thisp) {
      thisp = thisp || this;
      var res = new Yallist();
      for (var walker = this.tail; walker !== null; ) {
        res.push(fn.call(thisp, walker.value, this));
        walker = walker.prev;
      }
      return res;
    };
    Yallist.prototype.reduce = function(fn, initial) {
      var acc;
      var walker = this.head;
      if (arguments.length > 1) {
        acc = initial;
      } else if (this.head) {
        walker = this.head.next;
        acc = this.head.value;
      } else {
        throw new TypeError("Reduce of empty list with no initial value");
      }
      for (var i2 = 0; walker !== null; i2++) {
        acc = fn(acc, walker.value, i2);
        walker = walker.next;
      }
      return acc;
    };
    Yallist.prototype.reduceReverse = function(fn, initial) {
      var acc;
      var walker = this.tail;
      if (arguments.length > 1) {
        acc = initial;
      } else if (this.tail) {
        walker = this.tail.prev;
        acc = this.tail.value;
      } else {
        throw new TypeError("Reduce of empty list with no initial value");
      }
      for (var i2 = this.length - 1; walker !== null; i2--) {
        acc = fn(acc, walker.value, i2);
        walker = walker.prev;
      }
      return acc;
    };
    Yallist.prototype.toArray = function() {
      var arr = new Array(this.length);
      for (var i2 = 0, walker = this.head; walker !== null; i2++) {
        arr[i2] = walker.value;
        walker = walker.next;
      }
      return arr;
    };
    Yallist.prototype.toArrayReverse = function() {
      var arr = new Array(this.length);
      for (var i2 = 0, walker = this.tail; walker !== null; i2++) {
        arr[i2] = walker.value;
        walker = walker.prev;
      }
      return arr;
    };
    Yallist.prototype.slice = function(from, to) {
      to = to || this.length;
      if (to < 0) {
        to += this.length;
      }
      from = from || 0;
      if (from < 0) {
        from += this.length;
      }
      var ret = new Yallist();
      if (to < from || to < 0) {
        return ret;
      }
      if (from < 0) {
        from = 0;
      }
      if (to > this.length) {
        to = this.length;
      }
      for (var i2 = 0, walker = this.head; walker !== null && i2 < from; i2++) {
        walker = walker.next;
      }
      for (; walker !== null && i2 < to; i2++, walker = walker.next) {
        ret.push(walker.value);
      }
      return ret;
    };
    Yallist.prototype.sliceReverse = function(from, to) {
      to = to || this.length;
      if (to < 0) {
        to += this.length;
      }
      from = from || 0;
      if (from < 0) {
        from += this.length;
      }
      var ret = new Yallist();
      if (to < from || to < 0) {
        return ret;
      }
      if (from < 0) {
        from = 0;
      }
      if (to > this.length) {
        to = this.length;
      }
      for (var i2 = this.length, walker = this.tail; walker !== null && i2 > to; i2--) {
        walker = walker.prev;
      }
      for (; walker !== null && i2 > from; i2--, walker = walker.prev) {
        ret.push(walker.value);
      }
      return ret;
    };
    Yallist.prototype.splice = function(start, deleteCount, ...nodes) {
      if (start > this.length) {
        start = this.length - 1;
      }
      if (start < 0) {
        start = this.length + start;
      }
      for (var i2 = 0, walker = this.head; walker !== null && i2 < start; i2++) {
        walker = walker.next;
      }
      var ret = [];
      for (var i2 = 0; walker && i2 < deleteCount; i2++) {
        ret.push(walker.value);
        walker = this.removeNode(walker);
      }
      if (walker === null) {
        walker = this.tail;
      }
      if (walker !== this.head && walker !== this.tail) {
        walker = walker.prev;
      }
      for (var i2 = 0; i2 < nodes.length; i2++) {
        walker = insert(this, walker, nodes[i2]);
      }
      return ret;
    };
    Yallist.prototype.reverse = function() {
      var head = this.head;
      var tail = this.tail;
      for (var walker = head; walker !== null; walker = walker.prev) {
        var p = walker.prev;
        walker.prev = walker.next;
        walker.next = p;
      }
      this.head = tail;
      this.tail = head;
      return this;
    };
    function insert(self2, node, value) {
      var inserted = node === self2.head ? new Node(value, null, node, self2) : new Node(value, node, node.next, self2);
      if (inserted.next === null) {
        self2.tail = inserted;
      }
      if (inserted.prev === null) {
        self2.head = inserted;
      }
      self2.length++;
      return inserted;
    }
    function push2(self2, item) {
      self2.tail = new Node(item, self2.tail, null, self2);
      if (!self2.head) {
        self2.head = self2.tail;
      }
      self2.length++;
    }
    function unshift(self2, item) {
      self2.head = new Node(item, null, self2.head, self2);
      if (!self2.tail) {
        self2.tail = self2.head;
      }
      self2.length++;
    }
    function Node(value, prev, next, list) {
      if (!(this instanceof Node)) {
        return new Node(value, prev, next, list);
      }
      this.list = list;
      this.value = value;
      if (prev) {
        prev.next = this;
        this.prev = prev;
      } else {
        this.prev = null;
      }
      if (next) {
        next.prev = this;
        this.next = next;
      } else {
        this.next = null;
      }
    }
    try {
      require_iterator()(Yallist);
    } catch (er) {
    }
  }
});

// node_modules/lru-cache/index.js
var require_lru_cache = __commonJS({
  "node_modules/lru-cache/index.js"(exports, module2) {
    "use strict";
    var Yallist = require_yallist();
    var MAX = Symbol("max");
    var LENGTH = Symbol("length");
    var LENGTH_CALCULATOR = Symbol("lengthCalculator");
    var ALLOW_STALE = Symbol("allowStale");
    var MAX_AGE = Symbol("maxAge");
    var DISPOSE = Symbol("dispose");
    var NO_DISPOSE_ON_SET = Symbol("noDisposeOnSet");
    var LRU_LIST = Symbol("lruList");
    var CACHE = Symbol("cache");
    var UPDATE_AGE_ON_GET = Symbol("updateAgeOnGet");
    var naiveLength = () => 1;
    var LRUCache = class {
      constructor(options) {
        if (typeof options === "number")
          options = { max: options };
        if (!options)
          options = {};
        if (options.max && (typeof options.max !== "number" || options.max < 0))
          throw new TypeError("max must be a non-negative number");
        const max = this[MAX] = options.max || Infinity;
        const lc = options.length || naiveLength;
        this[LENGTH_CALCULATOR] = typeof lc !== "function" ? naiveLength : lc;
        this[ALLOW_STALE] = options.stale || false;
        if (options.maxAge && typeof options.maxAge !== "number")
          throw new TypeError("maxAge must be a number");
        this[MAX_AGE] = options.maxAge || 0;
        this[DISPOSE] = options.dispose;
        this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
        this[UPDATE_AGE_ON_GET] = options.updateAgeOnGet || false;
        this.reset();
      }
      set max(mL) {
        if (typeof mL !== "number" || mL < 0)
          throw new TypeError("max must be a non-negative number");
        this[MAX] = mL || Infinity;
        trim(this);
      }
      get max() {
        return this[MAX];
      }
      set allowStale(allowStale) {
        this[ALLOW_STALE] = !!allowStale;
      }
      get allowStale() {
        return this[ALLOW_STALE];
      }
      set maxAge(mA) {
        if (typeof mA !== "number")
          throw new TypeError("maxAge must be a non-negative number");
        this[MAX_AGE] = mA;
        trim(this);
      }
      get maxAge() {
        return this[MAX_AGE];
      }
      set lengthCalculator(lC) {
        if (typeof lC !== "function")
          lC = naiveLength;
        if (lC !== this[LENGTH_CALCULATOR]) {
          this[LENGTH_CALCULATOR] = lC;
          this[LENGTH] = 0;
          this[LRU_LIST].forEach((hit) => {
            hit.length = this[LENGTH_CALCULATOR](hit.value, hit.key);
            this[LENGTH] += hit.length;
          });
        }
        trim(this);
      }
      get lengthCalculator() {
        return this[LENGTH_CALCULATOR];
      }
      get length() {
        return this[LENGTH];
      }
      get itemCount() {
        return this[LRU_LIST].length;
      }
      rforEach(fn, thisp) {
        thisp = thisp || this;
        for (let walker = this[LRU_LIST].tail; walker !== null; ) {
          const prev = walker.prev;
          forEachStep(this, fn, walker, thisp);
          walker = prev;
        }
      }
      forEach(fn, thisp) {
        thisp = thisp || this;
        for (let walker = this[LRU_LIST].head; walker !== null; ) {
          const next = walker.next;
          forEachStep(this, fn, walker, thisp);
          walker = next;
        }
      }
      keys() {
        return this[LRU_LIST].toArray().map((k) => k.key);
      }
      values() {
        return this[LRU_LIST].toArray().map((k) => k.value);
      }
      reset() {
        if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
          this[LRU_LIST].forEach((hit) => this[DISPOSE](hit.key, hit.value));
        }
        this[CACHE] = /* @__PURE__ */ new Map();
        this[LRU_LIST] = new Yallist();
        this[LENGTH] = 0;
      }
      dump() {
        return this[LRU_LIST].map((hit) => isStale(this, hit) ? false : {
          k: hit.key,
          v: hit.value,
          e: hit.now + (hit.maxAge || 0)
        }).toArray().filter((h2) => h2);
      }
      dumpLru() {
        return this[LRU_LIST];
      }
      set(key, value, maxAge) {
        maxAge = maxAge || this[MAX_AGE];
        if (maxAge && typeof maxAge !== "number")
          throw new TypeError("maxAge must be a number");
        const now = maxAge ? Date.now() : 0;
        const len = this[LENGTH_CALCULATOR](value, key);
        if (this[CACHE].has(key)) {
          if (len > this[MAX]) {
            del(this, this[CACHE].get(key));
            return false;
          }
          const node = this[CACHE].get(key);
          const item = node.value;
          if (this[DISPOSE]) {
            if (!this[NO_DISPOSE_ON_SET])
              this[DISPOSE](key, item.value);
          }
          item.now = now;
          item.maxAge = maxAge;
          item.value = value;
          this[LENGTH] += len - item.length;
          item.length = len;
          this.get(key);
          trim(this);
          return true;
        }
        const hit = new Entry(key, value, len, now, maxAge);
        if (hit.length > this[MAX]) {
          if (this[DISPOSE])
            this[DISPOSE](key, value);
          return false;
        }
        this[LENGTH] += hit.length;
        this[LRU_LIST].unshift(hit);
        this[CACHE].set(key, this[LRU_LIST].head);
        trim(this);
        return true;
      }
      has(key) {
        if (!this[CACHE].has(key))
          return false;
        const hit = this[CACHE].get(key).value;
        return !isStale(this, hit);
      }
      get(key) {
        return get(this, key, true);
      }
      peek(key) {
        return get(this, key, false);
      }
      pop() {
        const node = this[LRU_LIST].tail;
        if (!node)
          return null;
        del(this, node);
        return node.value;
      }
      del(key) {
        del(this, this[CACHE].get(key));
      }
      load(arr) {
        this.reset();
        const now = Date.now();
        for (let l = arr.length - 1; l >= 0; l--) {
          const hit = arr[l];
          const expiresAt = hit.e || 0;
          if (expiresAt === 0)
            this.set(hit.k, hit.v);
          else {
            const maxAge = expiresAt - now;
            if (maxAge > 0) {
              this.set(hit.k, hit.v, maxAge);
            }
          }
        }
      }
      prune() {
        this[CACHE].forEach((value, key) => get(this, key, false));
      }
    };
    var get = (self2, key, doUse) => {
      const node = self2[CACHE].get(key);
      if (node) {
        const hit = node.value;
        if (isStale(self2, hit)) {
          del(self2, node);
          if (!self2[ALLOW_STALE])
            return void 0;
        } else {
          if (doUse) {
            if (self2[UPDATE_AGE_ON_GET])
              node.value.now = Date.now();
            self2[LRU_LIST].unshiftNode(node);
          }
        }
        return hit.value;
      }
    };
    var isStale = (self2, hit) => {
      if (!hit || !hit.maxAge && !self2[MAX_AGE])
        return false;
      const diff2 = Date.now() - hit.now;
      return hit.maxAge ? diff2 > hit.maxAge : self2[MAX_AGE] && diff2 > self2[MAX_AGE];
    };
    var trim = (self2) => {
      if (self2[LENGTH] > self2[MAX]) {
        for (let walker = self2[LRU_LIST].tail; self2[LENGTH] > self2[MAX] && walker !== null; ) {
          const prev = walker.prev;
          del(self2, walker);
          walker = prev;
        }
      }
    };
    var del = (self2, node) => {
      if (node) {
        const hit = node.value;
        if (self2[DISPOSE])
          self2[DISPOSE](hit.key, hit.value);
        self2[LENGTH] -= hit.length;
        self2[CACHE].delete(hit.key);
        self2[LRU_LIST].removeNode(node);
      }
    };
    var Entry = class {
      constructor(key, value, length, now, maxAge) {
        this.key = key;
        this.value = value;
        this.length = length;
        this.now = now;
        this.maxAge = maxAge || 0;
      }
    };
    var forEachStep = (self2, fn, node, thisp) => {
      let hit = node.value;
      if (isStale(self2, hit)) {
        del(self2, node);
        if (!self2[ALLOW_STALE])
          hit = void 0;
      }
      if (hit)
        fn.call(thisp, hit.value, hit.key, self2);
    };
    module2.exports = LRUCache;
  }
});

// node_modules/semver/classes/range.js
var require_range = __commonJS({
  "node_modules/semver/classes/range.js"(exports, module2) {
    var Range = class {
      constructor(range, options) {
        options = parseOptions(options);
        if (range instanceof Range) {
          if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
            return range;
          } else {
            return new Range(range.raw, options);
          }
        }
        if (range instanceof Comparator) {
          this.raw = range.value;
          this.set = [[range]];
          this.format();
          return this;
        }
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        this.raw = range;
        this.set = range.split("||").map((r2) => this.parseRange(r2.trim())).filter((c) => c.length);
        if (!this.set.length) {
          throw new TypeError(`Invalid SemVer Range: ${range}`);
        }
        if (this.set.length > 1) {
          const first = this.set[0];
          this.set = this.set.filter((c) => !isNullSet(c[0]));
          if (this.set.length === 0) {
            this.set = [first];
          } else if (this.set.length > 1) {
            for (const c of this.set) {
              if (c.length === 1 && isAny(c[0])) {
                this.set = [c];
                break;
              }
            }
          }
        }
        this.format();
      }
      format() {
        this.range = this.set.map((comps) => {
          return comps.join(" ").trim();
        }).join("||").trim();
        return this.range;
      }
      toString() {
        return this.range;
      }
      parseRange(range) {
        range = range.trim();
        const memoOpts = Object.keys(this.options).join(",");
        const memoKey = `parseRange:${memoOpts}:${range}`;
        const cached = cache.get(memoKey);
        if (cached) {
          return cached;
        }
        const loose = this.options.loose;
        const hr = loose ? re[t2.HYPHENRANGELOOSE] : re[t2.HYPHENRANGE];
        range = range.replace(hr, hyphenReplace(this.options.includePrerelease));
        debug("hyphen replace", range);
        range = range.replace(re[t2.COMPARATORTRIM], comparatorTrimReplace);
        debug("comparator trim", range);
        range = range.replace(re[t2.TILDETRIM], tildeTrimReplace);
        range = range.replace(re[t2.CARETTRIM], caretTrimReplace);
        range = range.split(/\s+/).join(" ");
        let rangeList = range.split(" ").map((comp) => parseComparator(comp, this.options)).join(" ").split(/\s+/).map((comp) => replaceGTE0(comp, this.options));
        if (loose) {
          rangeList = rangeList.filter((comp) => {
            debug("loose invalid filter", comp, this.options);
            return !!comp.match(re[t2.COMPARATORLOOSE]);
          });
        }
        debug("range list", rangeList);
        const rangeMap = /* @__PURE__ */ new Map();
        const comparators = rangeList.map((comp) => new Comparator(comp, this.options));
        for (const comp of comparators) {
          if (isNullSet(comp)) {
            return [comp];
          }
          rangeMap.set(comp.value, comp);
        }
        if (rangeMap.size > 1 && rangeMap.has("")) {
          rangeMap.delete("");
        }
        const result = [...rangeMap.values()];
        cache.set(memoKey, result);
        return result;
      }
      intersects(range, options) {
        if (!(range instanceof Range)) {
          throw new TypeError("a Range is required");
        }
        return this.set.some((thisComparators) => {
          return isSatisfiable(thisComparators, options) && range.set.some((rangeComparators) => {
            return isSatisfiable(rangeComparators, options) && thisComparators.every((thisComparator) => {
              return rangeComparators.every((rangeComparator) => {
                return thisComparator.intersects(rangeComparator, options);
              });
            });
          });
        });
      }
      test(version) {
        if (!version) {
          return false;
        }
        if (typeof version === "string") {
          try {
            version = new SemVer(version, this.options);
          } catch (er) {
            return false;
          }
        }
        for (let i2 = 0; i2 < this.set.length; i2++) {
          if (testSet(this.set[i2], version, this.options)) {
            return true;
          }
        }
        return false;
      }
    };
    module2.exports = Range;
    var LRU = require_lru_cache();
    var cache = new LRU({ max: 1e3 });
    var parseOptions = require_parse_options();
    var Comparator = require_comparator();
    var debug = require_debug();
    var SemVer = require_semver2();
    var {
      re,
      t: t2,
      comparatorTrimReplace,
      tildeTrimReplace,
      caretTrimReplace
    } = require_re();
    var isNullSet = (c) => c.value === "<0.0.0-0";
    var isAny = (c) => c.value === "";
    var isSatisfiable = (comparators, options) => {
      let result = true;
      const remainingComparators = comparators.slice();
      let testComparator = remainingComparators.pop();
      while (result && remainingComparators.length) {
        result = remainingComparators.every((otherComparator) => {
          return testComparator.intersects(otherComparator, options);
        });
        testComparator = remainingComparators.pop();
      }
      return result;
    };
    var parseComparator = (comp, options) => {
      debug("comp", comp, options);
      comp = replaceCarets(comp, options);
      debug("caret", comp);
      comp = replaceTildes(comp, options);
      debug("tildes", comp);
      comp = replaceXRanges(comp, options);
      debug("xrange", comp);
      comp = replaceStars(comp, options);
      debug("stars", comp);
      return comp;
    };
    var isX = (id) => !id || id.toLowerCase() === "x" || id === "*";
    var replaceTildes = (comp, options) => comp.trim().split(/\s+/).map((c) => {
      return replaceTilde(c, options);
    }).join(" ");
    var replaceTilde = (comp, options) => {
      const r2 = options.loose ? re[t2.TILDELOOSE] : re[t2.TILDE];
      return comp.replace(r2, (_, M, m2, p, pr) => {
        debug("tilde", comp, _, M, m2, p, pr);
        let ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m2)) {
          ret = `>=${M}.0.0 <${+M + 1}.0.0-0`;
        } else if (isX(p)) {
          ret = `>=${M}.${m2}.0 <${M}.${+m2 + 1}.0-0`;
        } else if (pr) {
          debug("replaceTilde pr", pr);
          ret = `>=${M}.${m2}.${p}-${pr} <${M}.${+m2 + 1}.0-0`;
        } else {
          ret = `>=${M}.${m2}.${p} <${M}.${+m2 + 1}.0-0`;
        }
        debug("tilde return", ret);
        return ret;
      });
    };
    var replaceCarets = (comp, options) => comp.trim().split(/\s+/).map((c) => {
      return replaceCaret(c, options);
    }).join(" ");
    var replaceCaret = (comp, options) => {
      debug("caret", comp, options);
      const r2 = options.loose ? re[t2.CARETLOOSE] : re[t2.CARET];
      const z = options.includePrerelease ? "-0" : "";
      return comp.replace(r2, (_, M, m2, p, pr) => {
        debug("caret", comp, _, M, m2, p, pr);
        let ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m2)) {
          ret = `>=${M}.0.0${z} <${+M + 1}.0.0-0`;
        } else if (isX(p)) {
          if (M === "0") {
            ret = `>=${M}.${m2}.0${z} <${M}.${+m2 + 1}.0-0`;
          } else {
            ret = `>=${M}.${m2}.0${z} <${+M + 1}.0.0-0`;
          }
        } else if (pr) {
          debug("replaceCaret pr", pr);
          if (M === "0") {
            if (m2 === "0") {
              ret = `>=${M}.${m2}.${p}-${pr} <${M}.${m2}.${+p + 1}-0`;
            } else {
              ret = `>=${M}.${m2}.${p}-${pr} <${M}.${+m2 + 1}.0-0`;
            }
          } else {
            ret = `>=${M}.${m2}.${p}-${pr} <${+M + 1}.0.0-0`;
          }
        } else {
          debug("no pr");
          if (M === "0") {
            if (m2 === "0") {
              ret = `>=${M}.${m2}.${p}${z} <${M}.${m2}.${+p + 1}-0`;
            } else {
              ret = `>=${M}.${m2}.${p}${z} <${M}.${+m2 + 1}.0-0`;
            }
          } else {
            ret = `>=${M}.${m2}.${p} <${+M + 1}.0.0-0`;
          }
        }
        debug("caret return", ret);
        return ret;
      });
    };
    var replaceXRanges = (comp, options) => {
      debug("replaceXRanges", comp, options);
      return comp.split(/\s+/).map((c) => {
        return replaceXRange(c, options);
      }).join(" ");
    };
    var replaceXRange = (comp, options) => {
      comp = comp.trim();
      const r2 = options.loose ? re[t2.XRANGELOOSE] : re[t2.XRANGE];
      return comp.replace(r2, (ret, gtlt, M, m2, p, pr) => {
        debug("xRange", comp, ret, gtlt, M, m2, p, pr);
        const xM = isX(M);
        const xm = xM || isX(m2);
        const xp = xm || isX(p);
        const anyX = xp;
        if (gtlt === "=" && anyX) {
          gtlt = "";
        }
        pr = options.includePrerelease ? "-0" : "";
        if (xM) {
          if (gtlt === ">" || gtlt === "<") {
            ret = "<0.0.0-0";
          } else {
            ret = "*";
          }
        } else if (gtlt && anyX) {
          if (xm) {
            m2 = 0;
          }
          p = 0;
          if (gtlt === ">") {
            gtlt = ">=";
            if (xm) {
              M = +M + 1;
              m2 = 0;
              p = 0;
            } else {
              m2 = +m2 + 1;
              p = 0;
            }
          } else if (gtlt === "<=") {
            gtlt = "<";
            if (xm) {
              M = +M + 1;
            } else {
              m2 = +m2 + 1;
            }
          }
          if (gtlt === "<") {
            pr = "-0";
          }
          ret = `${gtlt + M}.${m2}.${p}${pr}`;
        } else if (xm) {
          ret = `>=${M}.0.0${pr} <${+M + 1}.0.0-0`;
        } else if (xp) {
          ret = `>=${M}.${m2}.0${pr} <${M}.${+m2 + 1}.0-0`;
        }
        debug("xRange return", ret);
        return ret;
      });
    };
    var replaceStars = (comp, options) => {
      debug("replaceStars", comp, options);
      return comp.trim().replace(re[t2.STAR], "");
    };
    var replaceGTE0 = (comp, options) => {
      debug("replaceGTE0", comp, options);
      return comp.trim().replace(re[options.includePrerelease ? t2.GTE0PRE : t2.GTE0], "");
    };
    var hyphenReplace = (incPr) => ($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) => {
      if (isX(fM)) {
        from = "";
      } else if (isX(fm)) {
        from = `>=${fM}.0.0${incPr ? "-0" : ""}`;
      } else if (isX(fp)) {
        from = `>=${fM}.${fm}.0${incPr ? "-0" : ""}`;
      } else if (fpr) {
        from = `>=${from}`;
      } else {
        from = `>=${from}${incPr ? "-0" : ""}`;
      }
      if (isX(tM)) {
        to = "";
      } else if (isX(tm)) {
        to = `<${+tM + 1}.0.0-0`;
      } else if (isX(tp)) {
        to = `<${tM}.${+tm + 1}.0-0`;
      } else if (tpr) {
        to = `<=${tM}.${tm}.${tp}-${tpr}`;
      } else if (incPr) {
        to = `<${tM}.${tm}.${+tp + 1}-0`;
      } else {
        to = `<=${to}`;
      }
      return `${from} ${to}`.trim();
    };
    var testSet = (set, version, options) => {
      for (let i2 = 0; i2 < set.length; i2++) {
        if (!set[i2].test(version)) {
          return false;
        }
      }
      if (version.prerelease.length && !options.includePrerelease) {
        for (let i2 = 0; i2 < set.length; i2++) {
          debug(set[i2].semver);
          if (set[i2].semver === Comparator.ANY) {
            continue;
          }
          if (set[i2].semver.prerelease.length > 0) {
            const allowed = set[i2].semver;
            if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
              return true;
            }
          }
        }
        return false;
      }
      return true;
    };
  }
});

// node_modules/semver/classes/comparator.js
var require_comparator = __commonJS({
  "node_modules/semver/classes/comparator.js"(exports, module2) {
    var ANY = Symbol("SemVer ANY");
    var Comparator = class {
      static get ANY() {
        return ANY;
      }
      constructor(comp, options) {
        options = parseOptions(options);
        if (comp instanceof Comparator) {
          if (comp.loose === !!options.loose) {
            return comp;
          } else {
            comp = comp.value;
          }
        }
        debug("comparator", comp, options);
        this.options = options;
        this.loose = !!options.loose;
        this.parse(comp);
        if (this.semver === ANY) {
          this.value = "";
        } else {
          this.value = this.operator + this.semver.version;
        }
        debug("comp", this);
      }
      parse(comp) {
        const r2 = this.options.loose ? re[t2.COMPARATORLOOSE] : re[t2.COMPARATOR];
        const m2 = comp.match(r2);
        if (!m2) {
          throw new TypeError(`Invalid comparator: ${comp}`);
        }
        this.operator = m2[1] !== void 0 ? m2[1] : "";
        if (this.operator === "=") {
          this.operator = "";
        }
        if (!m2[2]) {
          this.semver = ANY;
        } else {
          this.semver = new SemVer(m2[2], this.options.loose);
        }
      }
      toString() {
        return this.value;
      }
      test(version) {
        debug("Comparator.test", version, this.options.loose);
        if (this.semver === ANY || version === ANY) {
          return true;
        }
        if (typeof version === "string") {
          try {
            version = new SemVer(version, this.options);
          } catch (er) {
            return false;
          }
        }
        return cmp(version, this.operator, this.semver, this.options);
      }
      intersects(comp, options) {
        if (!(comp instanceof Comparator)) {
          throw new TypeError("a Comparator is required");
        }
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (this.operator === "") {
          if (this.value === "") {
            return true;
          }
          return new Range(comp.value, options).test(this.value);
        } else if (comp.operator === "") {
          if (comp.value === "") {
            return true;
          }
          return new Range(this.value, options).test(comp.semver);
        }
        const sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
        const sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
        const sameSemVer = this.semver.version === comp.semver.version;
        const differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
        const oppositeDirectionsLessThan = cmp(this.semver, "<", comp.semver, options) && (this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<");
        const oppositeDirectionsGreaterThan = cmp(this.semver, ">", comp.semver, options) && (this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">");
        return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
      }
    };
    module2.exports = Comparator;
    var parseOptions = require_parse_options();
    var { re, t: t2 } = require_re();
    var cmp = require_cmp();
    var debug = require_debug();
    var SemVer = require_semver2();
    var Range = require_range();
  }
});

// node_modules/semver/functions/satisfies.js
var require_satisfies = __commonJS({
  "node_modules/semver/functions/satisfies.js"(exports, module2) {
    var Range = require_range();
    var satisfies = (version, range, options) => {
      try {
        range = new Range(range, options);
      } catch (er) {
        return false;
      }
      return range.test(version);
    };
    module2.exports = satisfies;
  }
});

// node_modules/semver/ranges/to-comparators.js
var require_to_comparators = __commonJS({
  "node_modules/semver/ranges/to-comparators.js"(exports, module2) {
    var Range = require_range();
    var toComparators = (range, options) => new Range(range, options).set.map((comp) => comp.map((c) => c.value).join(" ").trim().split(" "));
    module2.exports = toComparators;
  }
});

// node_modules/semver/ranges/max-satisfying.js
var require_max_satisfying = __commonJS({
  "node_modules/semver/ranges/max-satisfying.js"(exports, module2) {
    var SemVer = require_semver2();
    var Range = require_range();
    var maxSatisfying = (versions, range, options) => {
      let max = null;
      let maxSV = null;
      let rangeObj = null;
      try {
        rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach((v) => {
        if (rangeObj.test(v)) {
          if (!max || maxSV.compare(v) === -1) {
            max = v;
            maxSV = new SemVer(max, options);
          }
        }
      });
      return max;
    };
    module2.exports = maxSatisfying;
  }
});

// node_modules/semver/ranges/min-satisfying.js
var require_min_satisfying = __commonJS({
  "node_modules/semver/ranges/min-satisfying.js"(exports, module2) {
    var SemVer = require_semver2();
    var Range = require_range();
    var minSatisfying = (versions, range, options) => {
      let min = null;
      let minSV = null;
      let rangeObj = null;
      try {
        rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach((v) => {
        if (rangeObj.test(v)) {
          if (!min || minSV.compare(v) === 1) {
            min = v;
            minSV = new SemVer(min, options);
          }
        }
      });
      return min;
    };
    module2.exports = minSatisfying;
  }
});

// node_modules/semver/ranges/min-version.js
var require_min_version = __commonJS({
  "node_modules/semver/ranges/min-version.js"(exports, module2) {
    var SemVer = require_semver2();
    var Range = require_range();
    var gt = require_gt();
    var minVersion = (range, loose) => {
      range = new Range(range, loose);
      let minver = new SemVer("0.0.0");
      if (range.test(minver)) {
        return minver;
      }
      minver = new SemVer("0.0.0-0");
      if (range.test(minver)) {
        return minver;
      }
      minver = null;
      for (let i2 = 0; i2 < range.set.length; ++i2) {
        const comparators = range.set[i2];
        let setMin = null;
        comparators.forEach((comparator) => {
          const compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case ">":
              if (compver.prerelease.length === 0) {
                compver.patch++;
              } else {
                compver.prerelease.push(0);
              }
              compver.raw = compver.format();
            case "":
            case ">=":
              if (!setMin || gt(compver, setMin)) {
                setMin = compver;
              }
              break;
            case "<":
            case "<=":
              break;
            default:
              throw new Error(`Unexpected operation: ${comparator.operator}`);
          }
        });
        if (setMin && (!minver || gt(minver, setMin))) {
          minver = setMin;
        }
      }
      if (minver && range.test(minver)) {
        return minver;
      }
      return null;
    };
    module2.exports = minVersion;
  }
});

// node_modules/semver/ranges/valid.js
var require_valid2 = __commonJS({
  "node_modules/semver/ranges/valid.js"(exports, module2) {
    var Range = require_range();
    var validRange = (range, options) => {
      try {
        return new Range(range, options).range || "*";
      } catch (er) {
        return null;
      }
    };
    module2.exports = validRange;
  }
});

// node_modules/semver/ranges/outside.js
var require_outside = __commonJS({
  "node_modules/semver/ranges/outside.js"(exports, module2) {
    var SemVer = require_semver2();
    var Comparator = require_comparator();
    var { ANY } = Comparator;
    var Range = require_range();
    var satisfies = require_satisfies();
    var gt = require_gt();
    var lt = require_lt();
    var lte = require_lte();
    var gte = require_gte();
    var outside = (version, range, hilo, options) => {
      version = new SemVer(version, options);
      range = new Range(range, options);
      let gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case ">":
          gtfn = gt;
          ltefn = lte;
          ltfn = lt;
          comp = ">";
          ecomp = ">=";
          break;
        case "<":
          gtfn = lt;
          ltefn = gte;
          ltfn = gt;
          comp = "<";
          ecomp = "<=";
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version, range, options)) {
        return false;
      }
      for (let i2 = 0; i2 < range.set.length; ++i2) {
        const comparators = range.set[i2];
        let high = null;
        let low = null;
        comparators.forEach((comparator) => {
          if (comparator.semver === ANY) {
            comparator = new Comparator(">=0.0.0");
          }
          high = high || comparator;
          low = low || comparator;
          if (gtfn(comparator.semver, high.semver, options)) {
            high = comparator;
          } else if (ltfn(comparator.semver, low.semver, options)) {
            low = comparator;
          }
        });
        if (high.operator === comp || high.operator === ecomp) {
          return false;
        }
        if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
          return false;
        } else if (low.operator === ecomp && ltfn(version, low.semver)) {
          return false;
        }
      }
      return true;
    };
    module2.exports = outside;
  }
});

// node_modules/semver/ranges/gtr.js
var require_gtr = __commonJS({
  "node_modules/semver/ranges/gtr.js"(exports, module2) {
    var outside = require_outside();
    var gtr = (version, range, options) => outside(version, range, ">", options);
    module2.exports = gtr;
  }
});

// node_modules/semver/ranges/ltr.js
var require_ltr = __commonJS({
  "node_modules/semver/ranges/ltr.js"(exports, module2) {
    var outside = require_outside();
    var ltr = (version, range, options) => outside(version, range, "<", options);
    module2.exports = ltr;
  }
});

// node_modules/semver/ranges/intersects.js
var require_intersects = __commonJS({
  "node_modules/semver/ranges/intersects.js"(exports, module2) {
    var Range = require_range();
    var intersects = (r1, r2, options) => {
      r1 = new Range(r1, options);
      r2 = new Range(r2, options);
      return r1.intersects(r2);
    };
    module2.exports = intersects;
  }
});

// node_modules/semver/ranges/simplify.js
var require_simplify = __commonJS({
  "node_modules/semver/ranges/simplify.js"(exports, module2) {
    var satisfies = require_satisfies();
    var compare = require_compare();
    module2.exports = (versions, range, options) => {
      const set = [];
      let first = null;
      let prev = null;
      const v = versions.sort((a, b) => compare(a, b, options));
      for (const version of v) {
        const included = satisfies(version, range, options);
        if (included) {
          prev = version;
          if (!first) {
            first = version;
          }
        } else {
          if (prev) {
            set.push([first, prev]);
          }
          prev = null;
          first = null;
        }
      }
      if (first) {
        set.push([first, null]);
      }
      const ranges = [];
      for (const [min, max] of set) {
        if (min === max) {
          ranges.push(min);
        } else if (!max && min === v[0]) {
          ranges.push("*");
        } else if (!max) {
          ranges.push(`>=${min}`);
        } else if (min === v[0]) {
          ranges.push(`<=${max}`);
        } else {
          ranges.push(`${min} - ${max}`);
        }
      }
      const simplified = ranges.join(" || ");
      const original = typeof range.raw === "string" ? range.raw : String(range);
      return simplified.length < original.length ? simplified : range;
    };
  }
});

// node_modules/semver/ranges/subset.js
var require_subset = __commonJS({
  "node_modules/semver/ranges/subset.js"(exports, module2) {
    var Range = require_range();
    var Comparator = require_comparator();
    var { ANY } = Comparator;
    var satisfies = require_satisfies();
    var compare = require_compare();
    var subset = (sub, dom, options = {}) => {
      if (sub === dom) {
        return true;
      }
      sub = new Range(sub, options);
      dom = new Range(dom, options);
      let sawNonNull = false;
      OUTER:
        for (const simpleSub of sub.set) {
          for (const simpleDom of dom.set) {
            const isSub = simpleSubset(simpleSub, simpleDom, options);
            sawNonNull = sawNonNull || isSub !== null;
            if (isSub) {
              continue OUTER;
            }
          }
          if (sawNonNull) {
            return false;
          }
        }
      return true;
    };
    var simpleSubset = (sub, dom, options) => {
      if (sub === dom) {
        return true;
      }
      if (sub.length === 1 && sub[0].semver === ANY) {
        if (dom.length === 1 && dom[0].semver === ANY) {
          return true;
        } else if (options.includePrerelease) {
          sub = [new Comparator(">=0.0.0-0")];
        } else {
          sub = [new Comparator(">=0.0.0")];
        }
      }
      if (dom.length === 1 && dom[0].semver === ANY) {
        if (options.includePrerelease) {
          return true;
        } else {
          dom = [new Comparator(">=0.0.0")];
        }
      }
      const eqSet = /* @__PURE__ */ new Set();
      let gt, lt;
      for (const c of sub) {
        if (c.operator === ">" || c.operator === ">=") {
          gt = higherGT(gt, c, options);
        } else if (c.operator === "<" || c.operator === "<=") {
          lt = lowerLT(lt, c, options);
        } else {
          eqSet.add(c.semver);
        }
      }
      if (eqSet.size > 1) {
        return null;
      }
      let gtltComp;
      if (gt && lt) {
        gtltComp = compare(gt.semver, lt.semver, options);
        if (gtltComp > 0) {
          return null;
        } else if (gtltComp === 0 && (gt.operator !== ">=" || lt.operator !== "<=")) {
          return null;
        }
      }
      for (const eq of eqSet) {
        if (gt && !satisfies(eq, String(gt), options)) {
          return null;
        }
        if (lt && !satisfies(eq, String(lt), options)) {
          return null;
        }
        for (const c of dom) {
          if (!satisfies(eq, String(c), options)) {
            return false;
          }
        }
        return true;
      }
      let higher, lower2;
      let hasDomLT, hasDomGT;
      let needDomLTPre = lt && !options.includePrerelease && lt.semver.prerelease.length ? lt.semver : false;
      let needDomGTPre = gt && !options.includePrerelease && gt.semver.prerelease.length ? gt.semver : false;
      if (needDomLTPre && needDomLTPre.prerelease.length === 1 && lt.operator === "<" && needDomLTPre.prerelease[0] === 0) {
        needDomLTPre = false;
      }
      for (const c of dom) {
        hasDomGT = hasDomGT || c.operator === ">" || c.operator === ">=";
        hasDomLT = hasDomLT || c.operator === "<" || c.operator === "<=";
        if (gt) {
          if (needDomGTPre) {
            if (c.semver.prerelease && c.semver.prerelease.length && c.semver.major === needDomGTPre.major && c.semver.minor === needDomGTPre.minor && c.semver.patch === needDomGTPre.patch) {
              needDomGTPre = false;
            }
          }
          if (c.operator === ">" || c.operator === ">=") {
            higher = higherGT(gt, c, options);
            if (higher === c && higher !== gt) {
              return false;
            }
          } else if (gt.operator === ">=" && !satisfies(gt.semver, String(c), options)) {
            return false;
          }
        }
        if (lt) {
          if (needDomLTPre) {
            if (c.semver.prerelease && c.semver.prerelease.length && c.semver.major === needDomLTPre.major && c.semver.minor === needDomLTPre.minor && c.semver.patch === needDomLTPre.patch) {
              needDomLTPre = false;
            }
          }
          if (c.operator === "<" || c.operator === "<=") {
            lower2 = lowerLT(lt, c, options);
            if (lower2 === c && lower2 !== lt) {
              return false;
            }
          } else if (lt.operator === "<=" && !satisfies(lt.semver, String(c), options)) {
            return false;
          }
        }
        if (!c.operator && (lt || gt) && gtltComp !== 0) {
          return false;
        }
      }
      if (gt && hasDomLT && !lt && gtltComp !== 0) {
        return false;
      }
      if (lt && hasDomGT && !gt && gtltComp !== 0) {
        return false;
      }
      if (needDomGTPre || needDomLTPre) {
        return false;
      }
      return true;
    };
    var higherGT = (a, b, options) => {
      if (!a) {
        return b;
      }
      const comp = compare(a.semver, b.semver, options);
      return comp > 0 ? a : comp < 0 ? b : b.operator === ">" && a.operator === ">=" ? b : a;
    };
    var lowerLT = (a, b, options) => {
      if (!a) {
        return b;
      }
      const comp = compare(a.semver, b.semver, options);
      return comp < 0 ? a : comp > 0 ? b : b.operator === "<" && a.operator === "<=" ? b : a;
    };
    module2.exports = subset;
  }
});

// node_modules/semver/index.js
var require_semver3 = __commonJS({
  "node_modules/semver/index.js"(exports, module2) {
    var internalRe = require_re();
    module2.exports = {
      re: internalRe.re,
      src: internalRe.src,
      tokens: internalRe.t,
      SEMVER_SPEC_VERSION: require_constants4().SEMVER_SPEC_VERSION,
      SemVer: require_semver2(),
      compareIdentifiers: require_identifiers().compareIdentifiers,
      rcompareIdentifiers: require_identifiers().rcompareIdentifiers,
      parse: require_parse3(),
      valid: require_valid(),
      clean: require_clean(),
      inc: require_inc(),
      diff: require_diff(),
      major: require_major(),
      minor: require_minor(),
      patch: require_patch(),
      prerelease: require_prerelease(),
      compare: require_compare(),
      rcompare: require_rcompare(),
      compareLoose: require_compare_loose(),
      compareBuild: require_compare_build(),
      sort: require_sort(),
      rsort: require_rsort(),
      gt: require_gt(),
      lt: require_lt(),
      eq: require_eq(),
      neq: require_neq(),
      gte: require_gte(),
      lte: require_lte(),
      cmp: require_cmp(),
      coerce: require_coerce(),
      Comparator: require_comparator(),
      Range: require_range(),
      satisfies: require_satisfies(),
      toComparators: require_to_comparators(),
      maxSatisfying: require_max_satisfying(),
      minSatisfying: require_min_satisfying(),
      minVersion: require_min_version(),
      validRange: require_valid2(),
      outside: require_outside(),
      gtr: require_gtr(),
      ltr: require_ltr(),
      intersects: require_intersects(),
      simplifyRange: require_simplify(),
      subset: require_subset()
    };
  }
});

// node_modules/prettier/package.json
var require_package = __commonJS({
  "node_modules/prettier/package.json"(exports, module2) {
    module2.exports = {
      name: "prettier",
      version: "2.7.1",
      description: "Prettier is an opinionated code formatter",
      bin: "./bin-prettier.js",
      repository: "prettier/prettier",
      funding: "https://github.com/prettier/prettier?sponsor=1",
      homepage: "https://prettier.io",
      author: "James Long",
      license: "MIT",
      main: "./index.js",
      browser: "./standalone.js",
      unpkg: "./standalone.js",
      engines: {
        node: ">=10.13.0"
      },
      files: [
        "*.js",
        "esm/*.mjs"
      ]
    };
  }
});

// node_modules/prettier/doc.js
var require_doc = __commonJS({
  "node_modules/prettier/doc.js"(exports, module2) {
    (function(factory) {
      if (typeof exports === "object" && typeof module2 === "object") {
        module2.exports = factory();
      } else if (typeof define === "function" && define.amd) {
        define(factory);
      } else {
        var root = typeof globalThis !== "undefined" ? globalThis : typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : this || {};
        root.doc = factory();
      }
    })(function() {
      "use strict";
      var __getOwnPropNames2 = Object.getOwnPropertyNames;
      var __commonJS2 = (cb, mod) => function __require() {
        return mod || (0, cb[__getOwnPropNames2(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
      };
      var require_doc_js_umd = __commonJS2({
        "dist/_doc.js.umd.js"(exports2, module3) {
          var __create2 = Object.create;
          var __defProp2 = Object.defineProperty;
          var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
          var __getOwnPropNames22 = Object.getOwnPropertyNames;
          var __getProtoOf2 = Object.getPrototypeOf;
          var __hasOwnProp2 = Object.prototype.hasOwnProperty;
          var __esm2 = (fn, res) => function __init() {
            return fn && (res = (0, fn[__getOwnPropNames22(fn)[0]])(fn = 0)), res;
          };
          var __commonJS22 = (cb, mod) => function __require() {
            return mod || (0, cb[__getOwnPropNames22(cb)[0]])((mod = {
              exports: {}
            }).exports, mod), mod.exports;
          };
          var __export2 = (target, all) => {
            for (var name in all)
              __defProp2(target, name, {
                get: all[name],
                enumerable: true
              });
          };
          var __copyProps2 = (to, from, except, desc) => {
            if (from && typeof from === "object" || typeof from === "function") {
              for (let key of __getOwnPropNames22(from))
                if (!__hasOwnProp2.call(to, key) && key !== except)
                  __defProp2(to, key, {
                    get: () => from[key],
                    enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable
                  });
            }
            return to;
          };
          var __toESM2 = (mod, isNodeMode, target) => (target = mod != null ? __create2(__getProtoOf2(mod)) : {}, __copyProps2(isNodeMode || !mod || !mod.__esModule ? __defProp2(target, "default", {
            value: mod,
            enumerable: true
          }) : target, mod));
          var __toCommonJS2 = (mod) => __copyProps2(__defProp2({}, "__esModule", {
            value: true
          }), mod);
          var init_define_process = __esm2({
            "<define:process>"() {
            }
          });
          var require_doc_builders = __commonJS22({
            "src/document/doc-builders.js"(exports22, module22) {
              "use strict";
              init_define_process();
              function concat(parts) {
                if (false) {
                  for (const part of parts) {
                    assertDoc(part);
                  }
                }
                return {
                  type: "concat",
                  parts
                };
              }
              function indent(contents) {
                if (false) {
                  assertDoc(contents);
                }
                return {
                  type: "indent",
                  contents
                };
              }
              function align(widthOrString, contents) {
                if (false) {
                  assertDoc(contents);
                }
                return {
                  type: "align",
                  contents,
                  n: widthOrString
                };
              }
              function group(contents) {
                let opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
                if (false) {
                  assertDoc(contents);
                }
                return {
                  type: "group",
                  id: opts.id,
                  contents,
                  break: Boolean(opts.shouldBreak),
                  expandedStates: opts.expandedStates
                };
              }
              function dedentToRoot(contents) {
                return align(Number.NEGATIVE_INFINITY, contents);
              }
              function markAsRoot(contents) {
                return align({
                  type: "root"
                }, contents);
              }
              function dedent(contents) {
                return align(-1, contents);
              }
              function conditionalGroup(states, opts) {
                return group(states[0], Object.assign(Object.assign({}, opts), {}, {
                  expandedStates: states
                }));
              }
              function fill(parts) {
                if (false) {
                  for (const part of parts) {
                    assertDoc(part);
                  }
                }
                return {
                  type: "fill",
                  parts
                };
              }
              function ifBreak(breakContents, flatContents) {
                let opts = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
                if (false) {
                  if (breakContents) {
                    assertDoc(breakContents);
                  }
                  if (flatContents) {
                    assertDoc(flatContents);
                  }
                }
                return {
                  type: "if-break",
                  breakContents,
                  flatContents,
                  groupId: opts.groupId
                };
              }
              function indentIfBreak(contents, opts) {
                return {
                  type: "indent-if-break",
                  contents,
                  groupId: opts.groupId,
                  negate: opts.negate
                };
              }
              function lineSuffix(contents) {
                if (false) {
                  assertDoc(contents);
                }
                return {
                  type: "line-suffix",
                  contents
                };
              }
              var lineSuffixBoundary = {
                type: "line-suffix-boundary"
              };
              var breakParent = {
                type: "break-parent"
              };
              var trim = {
                type: "trim"
              };
              var hardlineWithoutBreakParent = {
                type: "line",
                hard: true
              };
              var literallineWithoutBreakParent = {
                type: "line",
                hard: true,
                literal: true
              };
              var line = {
                type: "line"
              };
              var softline = {
                type: "line",
                soft: true
              };
              var hardline = concat([hardlineWithoutBreakParent, breakParent]);
              var literalline = concat([literallineWithoutBreakParent, breakParent]);
              var cursor = {
                type: "cursor",
                placeholder: Symbol("cursor")
              };
              function join(sep, arr) {
                const res = [];
                for (let i2 = 0; i2 < arr.length; i2++) {
                  if (i2 !== 0) {
                    res.push(sep);
                  }
                  res.push(arr[i2]);
                }
                return concat(res);
              }
              function addAlignmentToDoc(doc, size, tabWidth) {
                let aligned = doc;
                if (size > 0) {
                  for (let i2 = 0; i2 < Math.floor(size / tabWidth); ++i2) {
                    aligned = indent(aligned);
                  }
                  aligned = align(size % tabWidth, aligned);
                  aligned = align(Number.NEGATIVE_INFINITY, aligned);
                }
                return aligned;
              }
              function label(label2, contents) {
                return {
                  type: "label",
                  label: label2,
                  contents
                };
              }
              module22.exports = {
                concat,
                join,
                line,
                softline,
                hardline,
                literalline,
                group,
                conditionalGroup,
                fill,
                lineSuffix,
                lineSuffixBoundary,
                cursor,
                breakParent,
                ifBreak,
                trim,
                indent,
                indentIfBreak,
                align,
                addAlignmentToDoc,
                markAsRoot,
                dedentToRoot,
                dedent,
                hardlineWithoutBreakParent,
                literallineWithoutBreakParent,
                label
              };
            }
          });
          var require_end_of_line = __commonJS22({
            "src/common/end-of-line.js"(exports22, module22) {
              "use strict";
              init_define_process();
              function guessEndOfLine(text) {
                const index = text.indexOf("\r");
                if (index >= 0) {
                  return text.charAt(index + 1) === "\n" ? "crlf" : "cr";
                }
                return "lf";
              }
              function convertEndOfLineToChars(value) {
                switch (value) {
                  case "cr":
                    return "\r";
                  case "crlf":
                    return "\r\n";
                  default:
                    return "\n";
                }
              }
              function countEndOfLineChars(text, eol) {
                let regex;
                switch (eol) {
                  case "\n":
                    regex = /\n/g;
                    break;
                  case "\r":
                    regex = /\r/g;
                    break;
                  case "\r\n":
                    regex = /\r\n/g;
                    break;
                  default:
                    throw new Error('Unexpected "eol" '.concat(JSON.stringify(eol), "."));
                }
                const endOfLines = text.match(regex);
                return endOfLines ? endOfLines.length : 0;
              }
              function normalizeEndOfLine(text) {
                return text.replace(/\r\n?/g, "\n");
              }
              module22.exports = {
                guessEndOfLine,
                convertEndOfLineToChars,
                countEndOfLineChars,
                normalizeEndOfLine
              };
            }
          });
          var require_get_last = __commonJS22({
            "src/utils/get-last.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var getLast = (arr) => arr[arr.length - 1];
              module22.exports = getLast;
            }
          });
          function ansiRegex() {
            let {
              onlyFirst = false
            } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
            const pattern = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
            return new RegExp(pattern, onlyFirst ? void 0 : "g");
          }
          var init_ansi_regex = __esm2({
            "node_modules/strip-ansi/node_modules/ansi-regex/index.js"() {
              init_define_process();
            }
          });
          function stripAnsi(string) {
            if (typeof string !== "string") {
              throw new TypeError("Expected a `string`, got `".concat(typeof string, "`"));
            }
            return string.replace(ansiRegex(), "");
          }
          var init_strip_ansi = __esm2({
            "node_modules/strip-ansi/index.js"() {
              init_define_process();
              init_ansi_regex();
            }
          });
          function isFullwidthCodePoint(codePoint) {
            if (!Number.isInteger(codePoint)) {
              return false;
            }
            return codePoint >= 4352 && (codePoint <= 4447 || codePoint === 9001 || codePoint === 9002 || 11904 <= codePoint && codePoint <= 12871 && codePoint !== 12351 || 12880 <= codePoint && codePoint <= 19903 || 19968 <= codePoint && codePoint <= 42182 || 43360 <= codePoint && codePoint <= 43388 || 44032 <= codePoint && codePoint <= 55203 || 63744 <= codePoint && codePoint <= 64255 || 65040 <= codePoint && codePoint <= 65049 || 65072 <= codePoint && codePoint <= 65131 || 65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510 || 110592 <= codePoint && codePoint <= 110593 || 127488 <= codePoint && codePoint <= 127569 || 131072 <= codePoint && codePoint <= 262141);
          }
          var init_is_fullwidth_code_point = __esm2({
            "node_modules/is-fullwidth-code-point/index.js"() {
              init_define_process();
            }
          });
          var require_emoji_regex = __commonJS22({
            "node_modules/emoji-regex/index.js"(exports22, module22) {
              "use strict";
              init_define_process();
              module22.exports = function() {
                return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
              };
            }
          });
          var string_width_exports = {};
          __export2(string_width_exports, {
            default: () => stringWidth
          });
          function stringWidth(string) {
            if (typeof string !== "string" || string.length === 0) {
              return 0;
            }
            string = stripAnsi(string);
            if (string.length === 0) {
              return 0;
            }
            string = string.replace((0, import_emoji_regex.default)(), "  ");
            let width = 0;
            for (let index = 0; index < string.length; index++) {
              const codePoint = string.codePointAt(index);
              if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
                continue;
              }
              if (codePoint >= 768 && codePoint <= 879) {
                continue;
              }
              if (codePoint > 65535) {
                index++;
              }
              width += isFullwidthCodePoint(codePoint) ? 2 : 1;
            }
            return width;
          }
          var import_emoji_regex;
          var init_string_width = __esm2({
            "node_modules/string-width/index.js"() {
              init_define_process();
              init_strip_ansi();
              init_is_fullwidth_code_point();
              import_emoji_regex = __toESM2(require_emoji_regex());
            }
          });
          var require_get_string_width = __commonJS22({
            "src/utils/get-string-width.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var stringWidth2 = (init_string_width(), __toCommonJS2(string_width_exports)).default;
              var notAsciiRegex = /[^\x20-\x7F]/;
              function getStringWidth(text) {
                if (!text) {
                  return 0;
                }
                if (!notAsciiRegex.test(text)) {
                  return text.length;
                }
                return stringWidth2(text);
              }
              module22.exports = getStringWidth;
            }
          });
          var require_doc_utils = __commonJS22({
            "src/document/doc-utils.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var getLast = require_get_last();
              var {
                literalline,
                join
              } = require_doc_builders();
              var isConcat = (doc) => Array.isArray(doc) || doc && doc.type === "concat";
              var getDocParts = (doc) => {
                if (Array.isArray(doc)) {
                  return doc;
                }
                if (doc.type !== "concat" && doc.type !== "fill") {
                  throw new Error("Expect doc type to be `concat` or `fill`.");
                }
                return doc.parts;
              };
              var traverseDocOnExitStackMarker = {};
              function traverseDoc(doc, onEnter, onExit, shouldTraverseConditionalGroups) {
                const docsStack = [doc];
                while (docsStack.length > 0) {
                  const doc2 = docsStack.pop();
                  if (doc2 === traverseDocOnExitStackMarker) {
                    onExit(docsStack.pop());
                    continue;
                  }
                  if (onExit) {
                    docsStack.push(doc2, traverseDocOnExitStackMarker);
                  }
                  if (!onEnter || onEnter(doc2) !== false) {
                    if (isConcat(doc2) || doc2.type === "fill") {
                      const parts = getDocParts(doc2);
                      for (let ic = parts.length, i2 = ic - 1; i2 >= 0; --i2) {
                        docsStack.push(parts[i2]);
                      }
                    } else if (doc2.type === "if-break") {
                      if (doc2.flatContents) {
                        docsStack.push(doc2.flatContents);
                      }
                      if (doc2.breakContents) {
                        docsStack.push(doc2.breakContents);
                      }
                    } else if (doc2.type === "group" && doc2.expandedStates) {
                      if (shouldTraverseConditionalGroups) {
                        for (let ic = doc2.expandedStates.length, i2 = ic - 1; i2 >= 0; --i2) {
                          docsStack.push(doc2.expandedStates[i2]);
                        }
                      } else {
                        docsStack.push(doc2.contents);
                      }
                    } else if (doc2.contents) {
                      docsStack.push(doc2.contents);
                    }
                  }
                }
              }
              function mapDoc(doc, cb) {
                const mapped = /* @__PURE__ */ new Map();
                return rec(doc);
                function rec(doc2) {
                  if (mapped.has(doc2)) {
                    return mapped.get(doc2);
                  }
                  const result = process2(doc2);
                  mapped.set(doc2, result);
                  return result;
                }
                function process2(doc2) {
                  if (Array.isArray(doc2)) {
                    return cb(doc2.map(rec));
                  }
                  if (doc2.type === "concat" || doc2.type === "fill") {
                    const parts = doc2.parts.map(rec);
                    return cb(Object.assign(Object.assign({}, doc2), {}, {
                      parts
                    }));
                  }
                  if (doc2.type === "if-break") {
                    const breakContents = doc2.breakContents && rec(doc2.breakContents);
                    const flatContents = doc2.flatContents && rec(doc2.flatContents);
                    return cb(Object.assign(Object.assign({}, doc2), {}, {
                      breakContents,
                      flatContents
                    }));
                  }
                  if (doc2.type === "group" && doc2.expandedStates) {
                    const expandedStates = doc2.expandedStates.map(rec);
                    const contents = expandedStates[0];
                    return cb(Object.assign(Object.assign({}, doc2), {}, {
                      contents,
                      expandedStates
                    }));
                  }
                  if (doc2.contents) {
                    const contents = rec(doc2.contents);
                    return cb(Object.assign(Object.assign({}, doc2), {}, {
                      contents
                    }));
                  }
                  return cb(doc2);
                }
              }
              function findInDoc(doc, fn, defaultValue) {
                let result = defaultValue;
                let hasStopped = false;
                function findInDocOnEnterFn(doc2) {
                  const maybeResult = fn(doc2);
                  if (maybeResult !== void 0) {
                    hasStopped = true;
                    result = maybeResult;
                  }
                  if (hasStopped) {
                    return false;
                  }
                }
                traverseDoc(doc, findInDocOnEnterFn);
                return result;
              }
              function willBreakFn(doc) {
                if (doc.type === "group" && doc.break) {
                  return true;
                }
                if (doc.type === "line" && doc.hard) {
                  return true;
                }
                if (doc.type === "break-parent") {
                  return true;
                }
              }
              function willBreak(doc) {
                return findInDoc(doc, willBreakFn, false);
              }
              function breakParentGroup(groupStack) {
                if (groupStack.length > 0) {
                  const parentGroup = getLast(groupStack);
                  if (!parentGroup.expandedStates && !parentGroup.break) {
                    parentGroup.break = "propagated";
                  }
                }
                return null;
              }
              function propagateBreaks(doc) {
                const alreadyVisitedSet = /* @__PURE__ */ new Set();
                const groupStack = [];
                function propagateBreaksOnEnterFn(doc2) {
                  if (doc2.type === "break-parent") {
                    breakParentGroup(groupStack);
                  }
                  if (doc2.type === "group") {
                    groupStack.push(doc2);
                    if (alreadyVisitedSet.has(doc2)) {
                      return false;
                    }
                    alreadyVisitedSet.add(doc2);
                  }
                }
                function propagateBreaksOnExitFn(doc2) {
                  if (doc2.type === "group") {
                    const group = groupStack.pop();
                    if (group.break) {
                      breakParentGroup(groupStack);
                    }
                  }
                }
                traverseDoc(doc, propagateBreaksOnEnterFn, propagateBreaksOnExitFn, true);
              }
              function removeLinesFn(doc) {
                if (doc.type === "line" && !doc.hard) {
                  return doc.soft ? "" : " ";
                }
                if (doc.type === "if-break") {
                  return doc.flatContents || "";
                }
                return doc;
              }
              function removeLines(doc) {
                return mapDoc(doc, removeLinesFn);
              }
              var isHardline = (doc, nextDoc) => doc && doc.type === "line" && doc.hard && nextDoc && nextDoc.type === "break-parent";
              function stripDocTrailingHardlineFromDoc(doc) {
                if (!doc) {
                  return doc;
                }
                if (isConcat(doc) || doc.type === "fill") {
                  const parts = getDocParts(doc);
                  while (parts.length > 1 && isHardline(...parts.slice(-2))) {
                    parts.length -= 2;
                  }
                  if (parts.length > 0) {
                    const lastPart = stripDocTrailingHardlineFromDoc(getLast(parts));
                    parts[parts.length - 1] = lastPart;
                  }
                  return Array.isArray(doc) ? parts : Object.assign(Object.assign({}, doc), {}, {
                    parts
                  });
                }
                switch (doc.type) {
                  case "align":
                  case "indent":
                  case "indent-if-break":
                  case "group":
                  case "line-suffix":
                  case "label": {
                    const contents = stripDocTrailingHardlineFromDoc(doc.contents);
                    return Object.assign(Object.assign({}, doc), {}, {
                      contents
                    });
                  }
                  case "if-break": {
                    const breakContents = stripDocTrailingHardlineFromDoc(doc.breakContents);
                    const flatContents = stripDocTrailingHardlineFromDoc(doc.flatContents);
                    return Object.assign(Object.assign({}, doc), {}, {
                      breakContents,
                      flatContents
                    });
                  }
                }
                return doc;
              }
              function stripTrailingHardline(doc) {
                return stripDocTrailingHardlineFromDoc(cleanDoc(doc));
              }
              function cleanDocFn(doc) {
                switch (doc.type) {
                  case "fill":
                    if (doc.parts.every((part) => part === "")) {
                      return "";
                    }
                    break;
                  case "group":
                    if (!doc.contents && !doc.id && !doc.break && !doc.expandedStates) {
                      return "";
                    }
                    if (doc.contents.type === "group" && doc.contents.id === doc.id && doc.contents.break === doc.break && doc.contents.expandedStates === doc.expandedStates) {
                      return doc.contents;
                    }
                    break;
                  case "align":
                  case "indent":
                  case "indent-if-break":
                  case "line-suffix":
                    if (!doc.contents) {
                      return "";
                    }
                    break;
                  case "if-break":
                    if (!doc.flatContents && !doc.breakContents) {
                      return "";
                    }
                    break;
                }
                if (!isConcat(doc)) {
                  return doc;
                }
                const parts = [];
                for (const part of getDocParts(doc)) {
                  if (!part) {
                    continue;
                  }
                  const [currentPart, ...restParts] = isConcat(part) ? getDocParts(part) : [part];
                  if (typeof currentPart === "string" && typeof getLast(parts) === "string") {
                    parts[parts.length - 1] += currentPart;
                  } else {
                    parts.push(currentPart);
                  }
                  parts.push(...restParts);
                }
                if (parts.length === 0) {
                  return "";
                }
                if (parts.length === 1) {
                  return parts[0];
                }
                return Array.isArray(doc) ? parts : Object.assign(Object.assign({}, doc), {}, {
                  parts
                });
              }
              function cleanDoc(doc) {
                return mapDoc(doc, (currentDoc) => cleanDocFn(currentDoc));
              }
              function normalizeParts(parts) {
                const newParts = [];
                const restParts = parts.filter(Boolean);
                while (restParts.length > 0) {
                  const part = restParts.shift();
                  if (!part) {
                    continue;
                  }
                  if (isConcat(part)) {
                    restParts.unshift(...getDocParts(part));
                    continue;
                  }
                  if (newParts.length > 0 && typeof getLast(newParts) === "string" && typeof part === "string") {
                    newParts[newParts.length - 1] += part;
                    continue;
                  }
                  newParts.push(part);
                }
                return newParts;
              }
              function normalizeDoc(doc) {
                return mapDoc(doc, (currentDoc) => {
                  if (Array.isArray(currentDoc)) {
                    return normalizeParts(currentDoc);
                  }
                  if (!currentDoc.parts) {
                    return currentDoc;
                  }
                  return Object.assign(Object.assign({}, currentDoc), {}, {
                    parts: normalizeParts(currentDoc.parts)
                  });
                });
              }
              function replaceEndOfLine(doc) {
                return mapDoc(doc, (currentDoc) => typeof currentDoc === "string" && currentDoc.includes("\n") ? replaceTextEndOfLine(currentDoc) : currentDoc);
              }
              function replaceTextEndOfLine(text) {
                let replacement = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : literalline;
                return join(replacement, text.split("\n")).parts;
              }
              function canBreakFn(doc) {
                if (doc.type === "line") {
                  return true;
                }
              }
              function canBreak(doc) {
                return findInDoc(doc, canBreakFn, false);
              }
              module22.exports = {
                isConcat,
                getDocParts,
                willBreak,
                traverseDoc,
                findInDoc,
                mapDoc,
                propagateBreaks,
                removeLines,
                stripTrailingHardline,
                normalizeParts,
                normalizeDoc,
                cleanDoc,
                replaceTextEndOfLine,
                replaceEndOfLine,
                canBreak
              };
            }
          });
          var require_doc_printer = __commonJS22({
            "src/document/doc-printer.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var {
                convertEndOfLineToChars
              } = require_end_of_line();
              var getLast = require_get_last();
              var getStringWidth = require_get_string_width();
              var {
                fill,
                cursor,
                indent
              } = require_doc_builders();
              var {
                isConcat,
                getDocParts
              } = require_doc_utils();
              var groupModeMap;
              var MODE_BREAK = 1;
              var MODE_FLAT = 2;
              function rootIndent() {
                return {
                  value: "",
                  length: 0,
                  queue: []
                };
              }
              function makeIndent(ind, options) {
                return generateInd(ind, {
                  type: "indent"
                }, options);
              }
              function makeAlign(indent2, widthOrDoc, options) {
                if (widthOrDoc === Number.NEGATIVE_INFINITY) {
                  return indent2.root || rootIndent();
                }
                if (widthOrDoc < 0) {
                  return generateInd(indent2, {
                    type: "dedent"
                  }, options);
                }
                if (!widthOrDoc) {
                  return indent2;
                }
                if (widthOrDoc.type === "root") {
                  return Object.assign(Object.assign({}, indent2), {}, {
                    root: indent2
                  });
                }
                const alignType = typeof widthOrDoc === "string" ? "stringAlign" : "numberAlign";
                return generateInd(indent2, {
                  type: alignType,
                  n: widthOrDoc
                }, options);
              }
              function generateInd(ind, newPart, options) {
                const queue = newPart.type === "dedent" ? ind.queue.slice(0, -1) : [...ind.queue, newPart];
                let value = "";
                let length = 0;
                let lastTabs = 0;
                let lastSpaces = 0;
                for (const part of queue) {
                  switch (part.type) {
                    case "indent":
                      flush();
                      if (options.useTabs) {
                        addTabs(1);
                      } else {
                        addSpaces(options.tabWidth);
                      }
                      break;
                    case "stringAlign":
                      flush();
                      value += part.n;
                      length += part.n.length;
                      break;
                    case "numberAlign":
                      lastTabs += 1;
                      lastSpaces += part.n;
                      break;
                    default:
                      throw new Error("Unexpected type '".concat(part.type, "'"));
                  }
                }
                flushSpaces();
                return Object.assign(Object.assign({}, ind), {}, {
                  value,
                  length,
                  queue
                });
                function addTabs(count) {
                  value += "	".repeat(count);
                  length += options.tabWidth * count;
                }
                function addSpaces(count) {
                  value += " ".repeat(count);
                  length += count;
                }
                function flush() {
                  if (options.useTabs) {
                    flushTabs();
                  } else {
                    flushSpaces();
                  }
                }
                function flushTabs() {
                  if (lastTabs > 0) {
                    addTabs(lastTabs);
                  }
                  resetLast();
                }
                function flushSpaces() {
                  if (lastSpaces > 0) {
                    addSpaces(lastSpaces);
                  }
                  resetLast();
                }
                function resetLast() {
                  lastTabs = 0;
                  lastSpaces = 0;
                }
              }
              function trim(out) {
                if (out.length === 0) {
                  return 0;
                }
                let trimCount = 0;
                while (out.length > 0 && typeof getLast(out) === "string" && /^[\t ]*$/.test(getLast(out))) {
                  trimCount += out.pop().length;
                }
                if (out.length > 0 && typeof getLast(out) === "string") {
                  const trimmed = getLast(out).replace(/[\t ]*$/, "");
                  trimCount += getLast(out).length - trimmed.length;
                  out[out.length - 1] = trimmed;
                }
                return trimCount;
              }
              function fits(next, restCommands, width, options, hasLineSuffix, mustBeFlat) {
                let restIdx = restCommands.length;
                const cmds = [next];
                const out = [];
                while (width >= 0) {
                  if (cmds.length === 0) {
                    if (restIdx === 0) {
                      return true;
                    }
                    cmds.push(restCommands[restIdx - 1]);
                    restIdx--;
                    continue;
                  }
                  const [ind, mode, doc] = cmds.pop();
                  if (typeof doc === "string") {
                    out.push(doc);
                    width -= getStringWidth(doc);
                  } else if (isConcat(doc)) {
                    const parts = getDocParts(doc);
                    for (let i2 = parts.length - 1; i2 >= 0; i2--) {
                      cmds.push([ind, mode, parts[i2]]);
                    }
                  } else {
                    switch (doc.type) {
                      case "indent":
                        cmds.push([makeIndent(ind, options), mode, doc.contents]);
                        break;
                      case "align":
                        cmds.push([makeAlign(ind, doc.n, options), mode, doc.contents]);
                        break;
                      case "trim":
                        width += trim(out);
                        break;
                      case "group": {
                        if (mustBeFlat && doc.break) {
                          return false;
                        }
                        const groupMode = doc.break ? MODE_BREAK : mode;
                        cmds.push([ind, groupMode, doc.expandedStates && groupMode === MODE_BREAK ? getLast(doc.expandedStates) : doc.contents]);
                        if (doc.id) {
                          groupModeMap[doc.id] = groupMode;
                        }
                        break;
                      }
                      case "fill":
                        for (let i2 = doc.parts.length - 1; i2 >= 0; i2--) {
                          cmds.push([ind, mode, doc.parts[i2]]);
                        }
                        break;
                      case "if-break":
                      case "indent-if-break": {
                        const groupMode = doc.groupId ? groupModeMap[doc.groupId] : mode;
                        if (groupMode === MODE_BREAK) {
                          const breakContents = doc.type === "if-break" ? doc.breakContents : doc.negate ? doc.contents : indent(doc.contents);
                          if (breakContents) {
                            cmds.push([ind, mode, breakContents]);
                          }
                        }
                        if (groupMode === MODE_FLAT) {
                          const flatContents = doc.type === "if-break" ? doc.flatContents : doc.negate ? indent(doc.contents) : doc.contents;
                          if (flatContents) {
                            cmds.push([ind, mode, flatContents]);
                          }
                        }
                        break;
                      }
                      case "line":
                        switch (mode) {
                          case MODE_FLAT:
                            if (!doc.hard) {
                              if (!doc.soft) {
                                out.push(" ");
                                width -= 1;
                              }
                              break;
                            }
                            return true;
                          case MODE_BREAK:
                            return true;
                        }
                        break;
                      case "line-suffix":
                        hasLineSuffix = true;
                        break;
                      case "line-suffix-boundary":
                        if (hasLineSuffix) {
                          return false;
                        }
                        break;
                      case "label":
                        cmds.push([ind, mode, doc.contents]);
                        break;
                    }
                  }
                }
                return false;
              }
              function printDocToString(doc, options) {
                groupModeMap = {};
                const width = options.printWidth;
                const newLine = convertEndOfLineToChars(options.endOfLine);
                let pos = 0;
                const cmds = [[rootIndent(), MODE_BREAK, doc]];
                const out = [];
                let shouldRemeasure = false;
                let lineSuffix = [];
                while (cmds.length > 0) {
                  const [ind, mode, doc2] = cmds.pop();
                  if (typeof doc2 === "string") {
                    const formatted = newLine !== "\n" ? doc2.replace(/\n/g, newLine) : doc2;
                    out.push(formatted);
                    pos += getStringWidth(formatted);
                  } else if (isConcat(doc2)) {
                    const parts = getDocParts(doc2);
                    for (let i2 = parts.length - 1; i2 >= 0; i2--) {
                      cmds.push([ind, mode, parts[i2]]);
                    }
                  } else {
                    switch (doc2.type) {
                      case "cursor":
                        out.push(cursor.placeholder);
                        break;
                      case "indent":
                        cmds.push([makeIndent(ind, options), mode, doc2.contents]);
                        break;
                      case "align":
                        cmds.push([makeAlign(ind, doc2.n, options), mode, doc2.contents]);
                        break;
                      case "trim":
                        pos -= trim(out);
                        break;
                      case "group":
                        switch (mode) {
                          case MODE_FLAT:
                            if (!shouldRemeasure) {
                              cmds.push([ind, doc2.break ? MODE_BREAK : MODE_FLAT, doc2.contents]);
                              break;
                            }
                          case MODE_BREAK: {
                            shouldRemeasure = false;
                            const next = [ind, MODE_FLAT, doc2.contents];
                            const rem = width - pos;
                            const hasLineSuffix = lineSuffix.length > 0;
                            if (!doc2.break && fits(next, cmds, rem, options, hasLineSuffix)) {
                              cmds.push(next);
                            } else {
                              if (doc2.expandedStates) {
                                const mostExpanded = getLast(doc2.expandedStates);
                                if (doc2.break) {
                                  cmds.push([ind, MODE_BREAK, mostExpanded]);
                                  break;
                                } else {
                                  for (let i2 = 1; i2 < doc2.expandedStates.length + 1; i2++) {
                                    if (i2 >= doc2.expandedStates.length) {
                                      cmds.push([ind, MODE_BREAK, mostExpanded]);
                                      break;
                                    } else {
                                      const state = doc2.expandedStates[i2];
                                      const cmd = [ind, MODE_FLAT, state];
                                      if (fits(cmd, cmds, rem, options, hasLineSuffix)) {
                                        cmds.push(cmd);
                                        break;
                                      }
                                    }
                                  }
                                }
                              } else {
                                cmds.push([ind, MODE_BREAK, doc2.contents]);
                              }
                            }
                            break;
                          }
                        }
                        if (doc2.id) {
                          groupModeMap[doc2.id] = getLast(cmds)[1];
                        }
                        break;
                      case "fill": {
                        const rem = width - pos;
                        const {
                          parts
                        } = doc2;
                        if (parts.length === 0) {
                          break;
                        }
                        const [content, whitespace] = parts;
                        const contentFlatCmd = [ind, MODE_FLAT, content];
                        const contentBreakCmd = [ind, MODE_BREAK, content];
                        const contentFits = fits(contentFlatCmd, [], rem, options, lineSuffix.length > 0, true);
                        if (parts.length === 1) {
                          if (contentFits) {
                            cmds.push(contentFlatCmd);
                          } else {
                            cmds.push(contentBreakCmd);
                          }
                          break;
                        }
                        const whitespaceFlatCmd = [ind, MODE_FLAT, whitespace];
                        const whitespaceBreakCmd = [ind, MODE_BREAK, whitespace];
                        if (parts.length === 2) {
                          if (contentFits) {
                            cmds.push(whitespaceFlatCmd, contentFlatCmd);
                          } else {
                            cmds.push(whitespaceBreakCmd, contentBreakCmd);
                          }
                          break;
                        }
                        parts.splice(0, 2);
                        const remainingCmd = [ind, mode, fill(parts)];
                        const secondContent = parts[0];
                        const firstAndSecondContentFlatCmd = [ind, MODE_FLAT, [content, whitespace, secondContent]];
                        const firstAndSecondContentFits = fits(firstAndSecondContentFlatCmd, [], rem, options, lineSuffix.length > 0, true);
                        if (firstAndSecondContentFits) {
                          cmds.push(remainingCmd, whitespaceFlatCmd, contentFlatCmd);
                        } else if (contentFits) {
                          cmds.push(remainingCmd, whitespaceBreakCmd, contentFlatCmd);
                        } else {
                          cmds.push(remainingCmd, whitespaceBreakCmd, contentBreakCmd);
                        }
                        break;
                      }
                      case "if-break":
                      case "indent-if-break": {
                        const groupMode = doc2.groupId ? groupModeMap[doc2.groupId] : mode;
                        if (groupMode === MODE_BREAK) {
                          const breakContents = doc2.type === "if-break" ? doc2.breakContents : doc2.negate ? doc2.contents : indent(doc2.contents);
                          if (breakContents) {
                            cmds.push([ind, mode, breakContents]);
                          }
                        }
                        if (groupMode === MODE_FLAT) {
                          const flatContents = doc2.type === "if-break" ? doc2.flatContents : doc2.negate ? indent(doc2.contents) : doc2.contents;
                          if (flatContents) {
                            cmds.push([ind, mode, flatContents]);
                          }
                        }
                        break;
                      }
                      case "line-suffix":
                        lineSuffix.push([ind, mode, doc2.contents]);
                        break;
                      case "line-suffix-boundary":
                        if (lineSuffix.length > 0) {
                          cmds.push([ind, mode, {
                            type: "line",
                            hard: true
                          }]);
                        }
                        break;
                      case "line":
                        switch (mode) {
                          case MODE_FLAT:
                            if (!doc2.hard) {
                              if (!doc2.soft) {
                                out.push(" ");
                                pos += 1;
                              }
                              break;
                            } else {
                              shouldRemeasure = true;
                            }
                          case MODE_BREAK:
                            if (lineSuffix.length > 0) {
                              cmds.push([ind, mode, doc2], ...lineSuffix.reverse());
                              lineSuffix = [];
                              break;
                            }
                            if (doc2.literal) {
                              if (ind.root) {
                                out.push(newLine, ind.root.value);
                                pos = ind.root.length;
                              } else {
                                out.push(newLine);
                                pos = 0;
                              }
                            } else {
                              pos -= trim(out);
                              out.push(newLine + ind.value);
                              pos = ind.length;
                            }
                            break;
                        }
                        break;
                      case "label":
                        cmds.push([ind, mode, doc2.contents]);
                        break;
                      default:
                    }
                  }
                  if (cmds.length === 0 && lineSuffix.length > 0) {
                    cmds.push(...lineSuffix.reverse());
                    lineSuffix = [];
                  }
                }
                const cursorPlaceholderIndex = out.indexOf(cursor.placeholder);
                if (cursorPlaceholderIndex !== -1) {
                  const otherCursorPlaceholderIndex = out.indexOf(cursor.placeholder, cursorPlaceholderIndex + 1);
                  const beforeCursor = out.slice(0, cursorPlaceholderIndex).join("");
                  const aroundCursor = out.slice(cursorPlaceholderIndex + 1, otherCursorPlaceholderIndex).join("");
                  const afterCursor = out.slice(otherCursorPlaceholderIndex + 1).join("");
                  return {
                    formatted: beforeCursor + aroundCursor + afterCursor,
                    cursorNodeStart: beforeCursor.length,
                    cursorNodeText: aroundCursor
                  };
                }
                return {
                  formatted: out.join("")
                };
              }
              module22.exports = {
                printDocToString
              };
            }
          });
          var require_doc_debug = __commonJS22({
            "src/document/doc-debug.js"(exports22, module22) {
              "use strict";
              init_define_process();
              var {
                isConcat,
                getDocParts
              } = require_doc_utils();
              function flattenDoc(doc) {
                if (!doc) {
                  return "";
                }
                if (isConcat(doc)) {
                  const res = [];
                  for (const part of getDocParts(doc)) {
                    if (isConcat(part)) {
                      res.push(...flattenDoc(part).parts);
                    } else {
                      const flattened = flattenDoc(part);
                      if (flattened !== "") {
                        res.push(flattened);
                      }
                    }
                  }
                  return {
                    type: "concat",
                    parts: res
                  };
                }
                if (doc.type === "if-break") {
                  return Object.assign(Object.assign({}, doc), {}, {
                    breakContents: flattenDoc(doc.breakContents),
                    flatContents: flattenDoc(doc.flatContents)
                  });
                }
                if (doc.type === "group") {
                  return Object.assign(Object.assign({}, doc), {}, {
                    contents: flattenDoc(doc.contents),
                    expandedStates: doc.expandedStates && doc.expandedStates.map(flattenDoc)
                  });
                }
                if (doc.type === "fill") {
                  return {
                    type: "fill",
                    parts: doc.parts.map(flattenDoc)
                  };
                }
                if (doc.contents) {
                  return Object.assign(Object.assign({}, doc), {}, {
                    contents: flattenDoc(doc.contents)
                  });
                }
                return doc;
              }
              function printDocToDebug(doc) {
                const printedSymbols = /* @__PURE__ */ Object.create(null);
                const usedKeysForSymbols = /* @__PURE__ */ new Set();
                return printDoc(flattenDoc(doc));
                function printDoc(doc2, index, parentParts) {
                  if (typeof doc2 === "string") {
                    return JSON.stringify(doc2);
                  }
                  if (isConcat(doc2)) {
                    const printed = getDocParts(doc2).map(printDoc).filter(Boolean);
                    return printed.length === 1 ? printed[0] : "[".concat(printed.join(", "), "]");
                  }
                  if (doc2.type === "line") {
                    const withBreakParent = Array.isArray(parentParts) && parentParts[index + 1] && parentParts[index + 1].type === "break-parent";
                    if (doc2.literal) {
                      return withBreakParent ? "literalline" : "literallineWithoutBreakParent";
                    }
                    if (doc2.hard) {
                      return withBreakParent ? "hardline" : "hardlineWithoutBreakParent";
                    }
                    if (doc2.soft) {
                      return "softline";
                    }
                    return "line";
                  }
                  if (doc2.type === "break-parent") {
                    const afterHardline = Array.isArray(parentParts) && parentParts[index - 1] && parentParts[index - 1].type === "line" && parentParts[index - 1].hard;
                    return afterHardline ? void 0 : "breakParent";
                  }
                  if (doc2.type === "trim") {
                    return "trim";
                  }
                  if (doc2.type === "indent") {
                    return "indent(" + printDoc(doc2.contents) + ")";
                  }
                  if (doc2.type === "align") {
                    return doc2.n === Number.NEGATIVE_INFINITY ? "dedentToRoot(" + printDoc(doc2.contents) + ")" : doc2.n < 0 ? "dedent(" + printDoc(doc2.contents) + ")" : doc2.n.type === "root" ? "markAsRoot(" + printDoc(doc2.contents) + ")" : "align(" + JSON.stringify(doc2.n) + ", " + printDoc(doc2.contents) + ")";
                  }
                  if (doc2.type === "if-break") {
                    return "ifBreak(" + printDoc(doc2.breakContents) + (doc2.flatContents ? ", " + printDoc(doc2.flatContents) : "") + (doc2.groupId ? (!doc2.flatContents ? ', ""' : "") + ", { groupId: ".concat(printGroupId(doc2.groupId), " }") : "") + ")";
                  }
                  if (doc2.type === "indent-if-break") {
                    const optionsParts = [];
                    if (doc2.negate) {
                      optionsParts.push("negate: true");
                    }
                    if (doc2.groupId) {
                      optionsParts.push("groupId: ".concat(printGroupId(doc2.groupId)));
                    }
                    const options = optionsParts.length > 0 ? ", { ".concat(optionsParts.join(", "), " }") : "";
                    return "indentIfBreak(".concat(printDoc(doc2.contents)).concat(options, ")");
                  }
                  if (doc2.type === "group") {
                    const optionsParts = [];
                    if (doc2.break && doc2.break !== "propagated") {
                      optionsParts.push("shouldBreak: true");
                    }
                    if (doc2.id) {
                      optionsParts.push("id: ".concat(printGroupId(doc2.id)));
                    }
                    const options = optionsParts.length > 0 ? ", { ".concat(optionsParts.join(", "), " }") : "";
                    if (doc2.expandedStates) {
                      return "conditionalGroup([".concat(doc2.expandedStates.map((part) => printDoc(part)).join(","), "]").concat(options, ")");
                    }
                    return "group(".concat(printDoc(doc2.contents)).concat(options, ")");
                  }
                  if (doc2.type === "fill") {
                    return "fill([".concat(doc2.parts.map((part) => printDoc(part)).join(", "), "])");
                  }
                  if (doc2.type === "line-suffix") {
                    return "lineSuffix(" + printDoc(doc2.contents) + ")";
                  }
                  if (doc2.type === "line-suffix-boundary") {
                    return "lineSuffixBoundary";
                  }
                  if (doc2.type === "label") {
                    return "label(".concat(JSON.stringify(doc2.label), ", ").concat(printDoc(doc2.contents), ")");
                  }
                  throw new Error("Unknown doc type " + doc2.type);
                }
                function printGroupId(id) {
                  if (typeof id !== "symbol") {
                    return JSON.stringify(String(id));
                  }
                  if (id in printedSymbols) {
                    return printedSymbols[id];
                  }
                  const prefix2 = String(id).slice(7, -1) || "symbol";
                  for (let counter = 0; ; counter++) {
                    const key = prefix2 + (counter > 0 ? " #".concat(counter) : "");
                    if (!usedKeysForSymbols.has(key)) {
                      usedKeysForSymbols.add(key);
                      return printedSymbols[id] = "Symbol.for(".concat(JSON.stringify(key), ")");
                    }
                  }
                }
              }
              module22.exports = {
                printDocToDebug
              };
            }
          });
          init_define_process();
          module3.exports = {
            builders: require_doc_builders(),
            printer: require_doc_printer(),
            utils: require_doc_utils(),
            debug: require_doc_debug()
          };
        }
      });
      return require_doc_js_umd();
    });
  }
});

// node_modules/prettier/third-party.js
var require_third_party = __commonJS({
  "node_modules/prettier/third-party.js"(exports, module2) {
    "use strict";
    var __getOwnPropNames2 = Object.getOwnPropertyNames;
    var __commonJS2 = (cb, mod) => function __require() {
      return mod || (0, cb[__getOwnPropNames2(cb)[0]])((mod = {
        exports: {}
      }).exports, mod), mod.exports;
    };
    var require_resolve_from = __commonJS2({
      "node_modules/import-fresh/node_modules/resolve-from/index.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var Module = require("module");
        var fs4 = require("fs");
        var resolveFrom = (fromDir, moduleId, silent) => {
          if (typeof fromDir !== "string") {
            throw new TypeError(`Expected \`fromDir\` to be of type \`string\`, got \`${typeof fromDir}\``);
          }
          if (typeof moduleId !== "string") {
            throw new TypeError(`Expected \`moduleId\` to be of type \`string\`, got \`${typeof moduleId}\``);
          }
          try {
            fromDir = fs4.realpathSync(fromDir);
          } catch (err) {
            if (err.code === "ENOENT") {
              fromDir = path4.resolve(fromDir);
            } else if (silent) {
              return null;
            } else {
              throw err;
            }
          }
          const fromFile = path4.join(fromDir, "noop.js");
          const resolveFileName = () => Module._resolveFilename(moduleId, {
            id: fromFile,
            filename: fromFile,
            paths: Module._nodeModulePaths(fromDir)
          });
          if (silent) {
            try {
              return resolveFileName();
            } catch (err) {
              return null;
            }
          }
          return resolveFileName();
        };
        module22.exports = (fromDir, moduleId) => resolveFrom(fromDir, moduleId);
        module22.exports.silent = (fromDir, moduleId) => resolveFrom(fromDir, moduleId, true);
      }
    });
    var require_parent_module = __commonJS2({
      "scripts/build/shims/parent-module.cjs"(exports2, module22) {
        "use strict";
        module22.exports = (file) => file;
      }
    });
    var require_import_fresh = __commonJS2({
      "node_modules/import-fresh/index.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var resolveFrom = require_resolve_from();
        var parentModule = require_parent_module();
        module22.exports = (moduleId) => {
          if (typeof moduleId !== "string") {
            throw new TypeError("Expected a string");
          }
          const parentPath = parentModule(__filename);
          const cwd = parentPath ? path4.dirname(parentPath) : __dirname;
          const filePath = resolveFrom(cwd, moduleId);
          const oldModule = require.cache[filePath];
          if (oldModule && oldModule.parent) {
            let i2 = oldModule.parent.children.length;
            while (i2--) {
              if (oldModule.parent.children[i2].id === filePath) {
                oldModule.parent.children.splice(i2, 1);
              }
            }
          }
          delete require.cache[filePath];
          const parent = require.cache[parentPath];
          return parent === void 0 ? require(filePath) : parent.require(filePath);
        };
      }
    });
    var require_is_arrayish = __commonJS2({
      "node_modules/is-arrayish/index.js"(exports2, module22) {
        "use strict";
        module22.exports = function isArrayish(obj) {
          if (!obj) {
            return false;
          }
          return obj instanceof Array || Array.isArray(obj) || obj.length >= 0 && obj.splice instanceof Function;
        };
      }
    });
    var require_error_ex = __commonJS2({
      "node_modules/error-ex/index.js"(exports2, module22) {
        "use strict";
        var util2 = require("util");
        var isArrayish = require_is_arrayish();
        var errorEx = function errorEx2(name, properties) {
          if (!name || name.constructor !== String) {
            properties = name || {};
            name = Error.name;
          }
          var errorExError = function ErrorEXError(message) {
            if (!this) {
              return new ErrorEXError(message);
            }
            message = message instanceof Error ? message.message : message || this.message;
            Error.call(this, message);
            Error.captureStackTrace(this, errorExError);
            this.name = name;
            Object.defineProperty(this, "message", {
              configurable: true,
              enumerable: false,
              get: function() {
                var newMessage = message.split(/\r?\n/g);
                for (var key in properties) {
                  if (!properties.hasOwnProperty(key)) {
                    continue;
                  }
                  var modifier = properties[key];
                  if ("message" in modifier) {
                    newMessage = modifier.message(this[key], newMessage) || newMessage;
                    if (!isArrayish(newMessage)) {
                      newMessage = [newMessage];
                    }
                  }
                }
                return newMessage.join("\n");
              },
              set: function(v) {
                message = v;
              }
            });
            var overwrittenStack = null;
            var stackDescriptor = Object.getOwnPropertyDescriptor(this, "stack");
            var stackGetter = stackDescriptor.get;
            var stackValue = stackDescriptor.value;
            delete stackDescriptor.value;
            delete stackDescriptor.writable;
            stackDescriptor.set = function(newstack) {
              overwrittenStack = newstack;
            };
            stackDescriptor.get = function() {
              var stack = (overwrittenStack || (stackGetter ? stackGetter.call(this) : stackValue)).split(/\r?\n+/g);
              if (!overwrittenStack) {
                stack[0] = this.name + ": " + this.message;
              }
              var lineCount = 1;
              for (var key in properties) {
                if (!properties.hasOwnProperty(key)) {
                  continue;
                }
                var modifier = properties[key];
                if ("line" in modifier) {
                  var line = modifier.line(this[key]);
                  if (line) {
                    stack.splice(lineCount++, 0, "    " + line);
                  }
                }
                if ("stack" in modifier) {
                  modifier.stack(this[key], stack);
                }
              }
              return stack.join("\n");
            };
            Object.defineProperty(this, "stack", stackDescriptor);
          };
          if (Object.setPrototypeOf) {
            Object.setPrototypeOf(errorExError.prototype, Error.prototype);
            Object.setPrototypeOf(errorExError, Error);
          } else {
            util2.inherits(errorExError, Error);
          }
          return errorExError;
        };
        errorEx.append = function(str, def) {
          return {
            message: function(v, message) {
              v = v || def;
              if (v) {
                message[0] += " " + str.replace("%s", v.toString());
              }
              return message;
            }
          };
        };
        errorEx.line = function(str, def) {
          return {
            line: function(v) {
              v = v || def;
              if (v) {
                return str.replace("%s", v.toString());
              }
              return null;
            }
          };
        };
        module22.exports = errorEx;
      }
    });
    var require_json_parse_even_better_errors = __commonJS2({
      "node_modules/json-parse-even-better-errors/index.js"(exports2, module22) {
        "use strict";
        var hexify = (char) => {
          const h2 = char.charCodeAt(0).toString(16).toUpperCase();
          return "0x" + (h2.length % 2 ? "0" : "") + h2;
        };
        var parseError = (e2, txt, context2) => {
          if (!txt) {
            return {
              message: e2.message + " while parsing empty string",
              position: 0
            };
          }
          const badToken = e2.message.match(/^Unexpected token (.) .*position\s+(\d+)/i);
          const errIdx = badToken ? +badToken[2] : e2.message.match(/^Unexpected end of JSON.*/i) ? txt.length - 1 : null;
          const msg = badToken ? e2.message.replace(/^Unexpected token ./, `Unexpected token ${JSON.stringify(badToken[1])} (${hexify(badToken[1])})`) : e2.message;
          if (errIdx !== null && errIdx !== void 0) {
            const start = errIdx <= context2 ? 0 : errIdx - context2;
            const end = errIdx + context2 >= txt.length ? txt.length : errIdx + context2;
            const slice = (start === 0 ? "" : "...") + txt.slice(start, end) + (end === txt.length ? "" : "...");
            const near = txt === slice ? "" : "near ";
            return {
              message: msg + ` while parsing ${near}${JSON.stringify(slice)}`,
              position: errIdx
            };
          } else {
            return {
              message: msg + ` while parsing '${txt.slice(0, context2 * 2)}'`,
              position: 0
            };
          }
        };
        var JSONParseError = class extends SyntaxError {
          constructor(er, txt, context2, caller) {
            context2 = context2 || 20;
            const metadata = parseError(er, txt, context2);
            super(metadata.message);
            Object.assign(this, metadata);
            this.code = "EJSONPARSE";
            this.systemError = er;
            Error.captureStackTrace(this, caller || this.constructor);
          }
          get name() {
            return this.constructor.name;
          }
          set name(n) {
          }
          get [Symbol.toStringTag]() {
            return this.constructor.name;
          }
        };
        var kIndent = Symbol.for("indent");
        var kNewline = Symbol.for("newline");
        var formatRE = /^\s*[{\[]((?:\r?\n)+)([\s\t]*)/;
        var emptyRE = /^(?:\{\}|\[\])((?:\r?\n)+)?$/;
        var parseJson = (txt, reviver, context2) => {
          const parseText = stripBOM(txt);
          context2 = context2 || 20;
          try {
            const [, newline = "\n", indent = "  "] = parseText.match(emptyRE) || parseText.match(formatRE) || [, "", ""];
            const result = JSON.parse(parseText, reviver);
            if (result && typeof result === "object") {
              result[kNewline] = newline;
              result[kIndent] = indent;
            }
            return result;
          } catch (e2) {
            if (typeof txt !== "string" && !Buffer.isBuffer(txt)) {
              const isEmptyArray = Array.isArray(txt) && txt.length === 0;
              throw Object.assign(new TypeError(`Cannot parse ${isEmptyArray ? "an empty array" : String(txt)}`), {
                code: "EJSONPARSE",
                systemError: e2
              });
            }
            throw new JSONParseError(e2, parseText, context2, parseJson);
          }
        };
        var stripBOM = (txt) => String(txt).replace(/^\uFEFF/, "");
        module22.exports = parseJson;
        parseJson.JSONParseError = JSONParseError;
        parseJson.noExceptions = (txt, reviver) => {
          try {
            return JSON.parse(stripBOM(txt), reviver);
          } catch (e2) {
          }
        };
      }
    });
    var require_build = __commonJS2({
      "node_modules/parse-json/node_modules/lines-and-columns/build/index.js"(exports2) {
        "use strict";
        exports2.__esModule = true;
        exports2.LinesAndColumns = void 0;
        var LF2 = "\n";
        var CR2 = "\r";
        var LinesAndColumns = function() {
          function LinesAndColumns2(string) {
            this.string = string;
            var offsets = [0];
            for (var offset = 0; offset < string.length; ) {
              switch (string[offset]) {
                case LF2:
                  offset += LF2.length;
                  offsets.push(offset);
                  break;
                case CR2:
                  offset += CR2.length;
                  if (string[offset] === LF2) {
                    offset += LF2.length;
                  }
                  offsets.push(offset);
                  break;
                default:
                  offset++;
                  break;
              }
            }
            this.offsets = offsets;
          }
          LinesAndColumns2.prototype.locationForIndex = function(index) {
            if (index < 0 || index > this.string.length) {
              return null;
            }
            var line = 0;
            var offsets = this.offsets;
            while (offsets[line + 1] <= index) {
              line++;
            }
            var column = index - offsets[line];
            return {
              line,
              column
            };
          };
          LinesAndColumns2.prototype.indexForLocation = function(location) {
            var line = location.line, column = location.column;
            if (line < 0 || line >= this.offsets.length) {
              return null;
            }
            if (column < 0 || column > this.lengthOfLine(line)) {
              return null;
            }
            return this.offsets[line] + column;
          };
          LinesAndColumns2.prototype.lengthOfLine = function(line) {
            var offset = this.offsets[line];
            var nextOffset = line === this.offsets.length - 1 ? this.string.length : this.offsets[line + 1];
            return nextOffset - offset;
          };
          return LinesAndColumns2;
        }();
        exports2.LinesAndColumns = LinesAndColumns;
        exports2["default"] = LinesAndColumns;
      }
    });
    var require_js_tokens = __commonJS2({
      "node_modules/js-tokens/index.js"(exports2) {
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.default = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;
        exports2.matchToToken = function(match) {
          var token = {
            type: "invalid",
            value: match[0],
            closed: void 0
          };
          if (match[1])
            token.type = "string", token.closed = !!(match[3] || match[4]);
          else if (match[5])
            token.type = "comment";
          else if (match[6])
            token.type = "comment", token.closed = !!match[7];
          else if (match[8])
            token.type = "regex";
          else if (match[9])
            token.type = "number";
          else if (match[10])
            token.type = "name";
          else if (match[11])
            token.type = "punctuator";
          else if (match[12])
            token.type = "whitespace";
          return token;
        };
      }
    });
    var require_identifier = __commonJS2({
      "node_modules/@babel/helper-validator-identifier/lib/identifier.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.isIdentifierChar = isIdentifierChar;
        exports2.isIdentifierName = isIdentifierName;
        exports2.isIdentifierStart = isIdentifierStart;
        var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
        var nonASCIIidentifierChars = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F";
        var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
        var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
        nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
        var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938];
        var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
        function isInAstralSet(code, set) {
          let pos = 65536;
          for (let i2 = 0, length = set.length; i2 < length; i2 += 2) {
            pos += set[i2];
            if (pos > code)
              return false;
            pos += set[i2 + 1];
            if (pos >= code)
              return true;
          }
          return false;
        }
        function isIdentifierStart(code) {
          if (code < 65)
            return code === 36;
          if (code <= 90)
            return true;
          if (code < 97)
            return code === 95;
          if (code <= 122)
            return true;
          if (code <= 65535) {
            return code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code));
          }
          return isInAstralSet(code, astralIdentifierStartCodes);
        }
        function isIdentifierChar(code) {
          if (code < 48)
            return code === 36;
          if (code < 58)
            return true;
          if (code < 65)
            return false;
          if (code <= 90)
            return true;
          if (code < 97)
            return code === 95;
          if (code <= 122)
            return true;
          if (code <= 65535) {
            return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
          }
          return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
        }
        function isIdentifierName(name) {
          let isFirst = true;
          for (let i2 = 0; i2 < name.length; i2++) {
            let cp = name.charCodeAt(i2);
            if ((cp & 64512) === 55296 && i2 + 1 < name.length) {
              const trail = name.charCodeAt(++i2);
              if ((trail & 64512) === 56320) {
                cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
              }
            }
            if (isFirst) {
              isFirst = false;
              if (!isIdentifierStart(cp)) {
                return false;
              }
            } else if (!isIdentifierChar(cp)) {
              return false;
            }
          }
          return !isFirst;
        }
      }
    });
    var require_keyword = __commonJS2({
      "node_modules/@babel/helper-validator-identifier/lib/keyword.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.isKeyword = isKeyword;
        exports2.isReservedWord = isReservedWord;
        exports2.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
        exports2.isStrictBindReservedWord = isStrictBindReservedWord;
        exports2.isStrictReservedWord = isStrictReservedWord;
        var reservedWords = {
          keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
          strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
          strictBind: ["eval", "arguments"]
        };
        var keywords = new Set(reservedWords.keyword);
        var reservedWordsStrictSet = new Set(reservedWords.strict);
        var reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
        function isReservedWord(word, inModule) {
          return inModule && word === "await" || word === "enum";
        }
        function isStrictReservedWord(word, inModule) {
          return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
        }
        function isStrictBindOnlyReservedWord(word) {
          return reservedWordsStrictBindSet.has(word);
        }
        function isStrictBindReservedWord(word, inModule) {
          return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
        }
        function isKeyword(word) {
          return keywords.has(word);
        }
      }
    });
    var require_lib8 = __commonJS2({
      "node_modules/@babel/helper-validator-identifier/lib/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        Object.defineProperty(exports2, "isIdentifierChar", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierChar;
          }
        });
        Object.defineProperty(exports2, "isIdentifierName", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierName;
          }
        });
        Object.defineProperty(exports2, "isIdentifierStart", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierStart;
          }
        });
        Object.defineProperty(exports2, "isKeyword", {
          enumerable: true,
          get: function() {
            return _keyword.isKeyword;
          }
        });
        Object.defineProperty(exports2, "isReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isReservedWord;
          }
        });
        Object.defineProperty(exports2, "isStrictBindOnlyReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictBindOnlyReservedWord;
          }
        });
        Object.defineProperty(exports2, "isStrictBindReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictBindReservedWord;
          }
        });
        Object.defineProperty(exports2, "isStrictReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictReservedWord;
          }
        });
        var _identifier = require_identifier();
        var _keyword = require_keyword();
      }
    });
    var require_escape_string_regexp2 = __commonJS2({
      "node_modules/@babel/highlight/node_modules/escape-string-regexp/index.js"(exports2, module22) {
        "use strict";
        var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
        module22.exports = function(str) {
          if (typeof str !== "string") {
            throw new TypeError("Expected a string");
          }
          return str.replace(matchOperatorsRe, "\\$&");
        };
      }
    });
    var require_color_name2 = __commonJS2({
      "node_modules/color-name/index.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          "aliceblue": [240, 248, 255],
          "antiquewhite": [250, 235, 215],
          "aqua": [0, 255, 255],
          "aquamarine": [127, 255, 212],
          "azure": [240, 255, 255],
          "beige": [245, 245, 220],
          "bisque": [255, 228, 196],
          "black": [0, 0, 0],
          "blanchedalmond": [255, 235, 205],
          "blue": [0, 0, 255],
          "blueviolet": [138, 43, 226],
          "brown": [165, 42, 42],
          "burlywood": [222, 184, 135],
          "cadetblue": [95, 158, 160],
          "chartreuse": [127, 255, 0],
          "chocolate": [210, 105, 30],
          "coral": [255, 127, 80],
          "cornflowerblue": [100, 149, 237],
          "cornsilk": [255, 248, 220],
          "crimson": [220, 20, 60],
          "cyan": [0, 255, 255],
          "darkblue": [0, 0, 139],
          "darkcyan": [0, 139, 139],
          "darkgoldenrod": [184, 134, 11],
          "darkgray": [169, 169, 169],
          "darkgreen": [0, 100, 0],
          "darkgrey": [169, 169, 169],
          "darkkhaki": [189, 183, 107],
          "darkmagenta": [139, 0, 139],
          "darkolivegreen": [85, 107, 47],
          "darkorange": [255, 140, 0],
          "darkorchid": [153, 50, 204],
          "darkred": [139, 0, 0],
          "darksalmon": [233, 150, 122],
          "darkseagreen": [143, 188, 143],
          "darkslateblue": [72, 61, 139],
          "darkslategray": [47, 79, 79],
          "darkslategrey": [47, 79, 79],
          "darkturquoise": [0, 206, 209],
          "darkviolet": [148, 0, 211],
          "deeppink": [255, 20, 147],
          "deepskyblue": [0, 191, 255],
          "dimgray": [105, 105, 105],
          "dimgrey": [105, 105, 105],
          "dodgerblue": [30, 144, 255],
          "firebrick": [178, 34, 34],
          "floralwhite": [255, 250, 240],
          "forestgreen": [34, 139, 34],
          "fuchsia": [255, 0, 255],
          "gainsboro": [220, 220, 220],
          "ghostwhite": [248, 248, 255],
          "gold": [255, 215, 0],
          "goldenrod": [218, 165, 32],
          "gray": [128, 128, 128],
          "green": [0, 128, 0],
          "greenyellow": [173, 255, 47],
          "grey": [128, 128, 128],
          "honeydew": [240, 255, 240],
          "hotpink": [255, 105, 180],
          "indianred": [205, 92, 92],
          "indigo": [75, 0, 130],
          "ivory": [255, 255, 240],
          "khaki": [240, 230, 140],
          "lavender": [230, 230, 250],
          "lavenderblush": [255, 240, 245],
          "lawngreen": [124, 252, 0],
          "lemonchiffon": [255, 250, 205],
          "lightblue": [173, 216, 230],
          "lightcoral": [240, 128, 128],
          "lightcyan": [224, 255, 255],
          "lightgoldenrodyellow": [250, 250, 210],
          "lightgray": [211, 211, 211],
          "lightgreen": [144, 238, 144],
          "lightgrey": [211, 211, 211],
          "lightpink": [255, 182, 193],
          "lightsalmon": [255, 160, 122],
          "lightseagreen": [32, 178, 170],
          "lightskyblue": [135, 206, 250],
          "lightslategray": [119, 136, 153],
          "lightslategrey": [119, 136, 153],
          "lightsteelblue": [176, 196, 222],
          "lightyellow": [255, 255, 224],
          "lime": [0, 255, 0],
          "limegreen": [50, 205, 50],
          "linen": [250, 240, 230],
          "magenta": [255, 0, 255],
          "maroon": [128, 0, 0],
          "mediumaquamarine": [102, 205, 170],
          "mediumblue": [0, 0, 205],
          "mediumorchid": [186, 85, 211],
          "mediumpurple": [147, 112, 219],
          "mediumseagreen": [60, 179, 113],
          "mediumslateblue": [123, 104, 238],
          "mediumspringgreen": [0, 250, 154],
          "mediumturquoise": [72, 209, 204],
          "mediumvioletred": [199, 21, 133],
          "midnightblue": [25, 25, 112],
          "mintcream": [245, 255, 250],
          "mistyrose": [255, 228, 225],
          "moccasin": [255, 228, 181],
          "navajowhite": [255, 222, 173],
          "navy": [0, 0, 128],
          "oldlace": [253, 245, 230],
          "olive": [128, 128, 0],
          "olivedrab": [107, 142, 35],
          "orange": [255, 165, 0],
          "orangered": [255, 69, 0],
          "orchid": [218, 112, 214],
          "palegoldenrod": [238, 232, 170],
          "palegreen": [152, 251, 152],
          "paleturquoise": [175, 238, 238],
          "palevioletred": [219, 112, 147],
          "papayawhip": [255, 239, 213],
          "peachpuff": [255, 218, 185],
          "peru": [205, 133, 63],
          "pink": [255, 192, 203],
          "plum": [221, 160, 221],
          "powderblue": [176, 224, 230],
          "purple": [128, 0, 128],
          "rebeccapurple": [102, 51, 153],
          "red": [255, 0, 0],
          "rosybrown": [188, 143, 143],
          "royalblue": [65, 105, 225],
          "saddlebrown": [139, 69, 19],
          "salmon": [250, 128, 114],
          "sandybrown": [244, 164, 96],
          "seagreen": [46, 139, 87],
          "seashell": [255, 245, 238],
          "sienna": [160, 82, 45],
          "silver": [192, 192, 192],
          "skyblue": [135, 206, 235],
          "slateblue": [106, 90, 205],
          "slategray": [112, 128, 144],
          "slategrey": [112, 128, 144],
          "snow": [255, 250, 250],
          "springgreen": [0, 255, 127],
          "steelblue": [70, 130, 180],
          "tan": [210, 180, 140],
          "teal": [0, 128, 128],
          "thistle": [216, 191, 216],
          "tomato": [255, 99, 71],
          "turquoise": [64, 224, 208],
          "violet": [238, 130, 238],
          "wheat": [245, 222, 179],
          "white": [255, 255, 255],
          "whitesmoke": [245, 245, 245],
          "yellow": [255, 255, 0],
          "yellowgreen": [154, 205, 50]
        };
      }
    });
    var require_conversions2 = __commonJS2({
      "node_modules/color-convert/conversions.js"(exports2, module22) {
        var cssKeywords = require_color_name2();
        var reverseKeywords = {};
        for (key in cssKeywords) {
          if (cssKeywords.hasOwnProperty(key)) {
            reverseKeywords[cssKeywords[key]] = key;
          }
        }
        var key;
        var convert2 = module22.exports = {
          rgb: {
            channels: 3,
            labels: "rgb"
          },
          hsl: {
            channels: 3,
            labels: "hsl"
          },
          hsv: {
            channels: 3,
            labels: "hsv"
          },
          hwb: {
            channels: 3,
            labels: "hwb"
          },
          cmyk: {
            channels: 4,
            labels: "cmyk"
          },
          xyz: {
            channels: 3,
            labels: "xyz"
          },
          lab: {
            channels: 3,
            labels: "lab"
          },
          lch: {
            channels: 3,
            labels: "lch"
          },
          hex: {
            channels: 1,
            labels: ["hex"]
          },
          keyword: {
            channels: 1,
            labels: ["keyword"]
          },
          ansi16: {
            channels: 1,
            labels: ["ansi16"]
          },
          ansi256: {
            channels: 1,
            labels: ["ansi256"]
          },
          hcg: {
            channels: 3,
            labels: ["h", "c", "g"]
          },
          apple: {
            channels: 3,
            labels: ["r16", "g16", "b16"]
          },
          gray: {
            channels: 1,
            labels: ["gray"]
          }
        };
        for (model in convert2) {
          if (convert2.hasOwnProperty(model)) {
            if (!("channels" in convert2[model])) {
              throw new Error("missing channels property: " + model);
            }
            if (!("labels" in convert2[model])) {
              throw new Error("missing channel labels property: " + model);
            }
            if (convert2[model].labels.length !== convert2[model].channels) {
              throw new Error("channel and label counts mismatch: " + model);
            }
            channels = convert2[model].channels;
            labels = convert2[model].labels;
            delete convert2[model].channels;
            delete convert2[model].labels;
            Object.defineProperty(convert2[model], "channels", {
              value: channels
            });
            Object.defineProperty(convert2[model], "labels", {
              value: labels
            });
          }
        }
        var channels;
        var labels;
        var model;
        convert2.rgb.hsl = function(rgb) {
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var min = Math.min(r2, g, b);
          var max = Math.max(r2, g, b);
          var delta = max - min;
          var h2;
          var s2;
          var l;
          if (max === min) {
            h2 = 0;
          } else if (r2 === max) {
            h2 = (g - b) / delta;
          } else if (g === max) {
            h2 = 2 + (b - r2) / delta;
          } else if (b === max) {
            h2 = 4 + (r2 - g) / delta;
          }
          h2 = Math.min(h2 * 60, 360);
          if (h2 < 0) {
            h2 += 360;
          }
          l = (min + max) / 2;
          if (max === min) {
            s2 = 0;
          } else if (l <= 0.5) {
            s2 = delta / (max + min);
          } else {
            s2 = delta / (2 - max - min);
          }
          return [h2, s2 * 100, l * 100];
        };
        convert2.rgb.hsv = function(rgb) {
          var rdif;
          var gdif;
          var bdif;
          var h2;
          var s2;
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var v = Math.max(r2, g, b);
          var diff2 = v - Math.min(r2, g, b);
          var diffc = function(c) {
            return (v - c) / 6 / diff2 + 1 / 2;
          };
          if (diff2 === 0) {
            h2 = s2 = 0;
          } else {
            s2 = diff2 / v;
            rdif = diffc(r2);
            gdif = diffc(g);
            bdif = diffc(b);
            if (r2 === v) {
              h2 = bdif - gdif;
            } else if (g === v) {
              h2 = 1 / 3 + rdif - bdif;
            } else if (b === v) {
              h2 = 2 / 3 + gdif - rdif;
            }
            if (h2 < 0) {
              h2 += 1;
            } else if (h2 > 1) {
              h2 -= 1;
            }
          }
          return [h2 * 360, s2 * 100, v * 100];
        };
        convert2.rgb.hwb = function(rgb) {
          var r2 = rgb[0];
          var g = rgb[1];
          var b = rgb[2];
          var h2 = convert2.rgb.hsl(rgb)[0];
          var w = 1 / 255 * Math.min(r2, Math.min(g, b));
          b = 1 - 1 / 255 * Math.max(r2, Math.max(g, b));
          return [h2, w * 100, b * 100];
        };
        convert2.rgb.cmyk = function(rgb) {
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var c;
          var m2;
          var y;
          var k;
          k = Math.min(1 - r2, 1 - g, 1 - b);
          c = (1 - r2 - k) / (1 - k) || 0;
          m2 = (1 - g - k) / (1 - k) || 0;
          y = (1 - b - k) / (1 - k) || 0;
          return [c * 100, m2 * 100, y * 100, k * 100];
        };
        function comparativeDistance(x2, y) {
          return Math.pow(x2[0] - y[0], 2) + Math.pow(x2[1] - y[1], 2) + Math.pow(x2[2] - y[2], 2);
        }
        convert2.rgb.keyword = function(rgb) {
          var reversed = reverseKeywords[rgb];
          if (reversed) {
            return reversed;
          }
          var currentClosestDistance = Infinity;
          var currentClosestKeyword;
          for (var keyword in cssKeywords) {
            if (cssKeywords.hasOwnProperty(keyword)) {
              var value = cssKeywords[keyword];
              var distance = comparativeDistance(rgb, value);
              if (distance < currentClosestDistance) {
                currentClosestDistance = distance;
                currentClosestKeyword = keyword;
              }
            }
          }
          return currentClosestKeyword;
        };
        convert2.keyword.rgb = function(keyword) {
          return cssKeywords[keyword];
        };
        convert2.rgb.xyz = function(rgb) {
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          r2 = r2 > 0.04045 ? Math.pow((r2 + 0.055) / 1.055, 2.4) : r2 / 12.92;
          g = g > 0.04045 ? Math.pow((g + 0.055) / 1.055, 2.4) : g / 12.92;
          b = b > 0.04045 ? Math.pow((b + 0.055) / 1.055, 2.4) : b / 12.92;
          var x2 = r2 * 0.4124 + g * 0.3576 + b * 0.1805;
          var y = r2 * 0.2126 + g * 0.7152 + b * 0.0722;
          var z = r2 * 0.0193 + g * 0.1192 + b * 0.9505;
          return [x2 * 100, y * 100, z * 100];
        };
        convert2.rgb.lab = function(rgb) {
          var xyz = convert2.rgb.xyz(rgb);
          var x2 = xyz[0];
          var y = xyz[1];
          var z = xyz[2];
          var l;
          var a;
          var b;
          x2 /= 95.047;
          y /= 100;
          z /= 108.883;
          x2 = x2 > 8856e-6 ? Math.pow(x2, 1 / 3) : 7.787 * x2 + 16 / 116;
          y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
          z = z > 8856e-6 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
          l = 116 * y - 16;
          a = 500 * (x2 - y);
          b = 200 * (y - z);
          return [l, a, b];
        };
        convert2.hsl.rgb = function(hsl) {
          var h2 = hsl[0] / 360;
          var s2 = hsl[1] / 100;
          var l = hsl[2] / 100;
          var t1;
          var t2;
          var t3;
          var rgb;
          var val;
          if (s2 === 0) {
            val = l * 255;
            return [val, val, val];
          }
          if (l < 0.5) {
            t2 = l * (1 + s2);
          } else {
            t2 = l + s2 - l * s2;
          }
          t1 = 2 * l - t2;
          rgb = [0, 0, 0];
          for (var i2 = 0; i2 < 3; i2++) {
            t3 = h2 + 1 / 3 * -(i2 - 1);
            if (t3 < 0) {
              t3++;
            }
            if (t3 > 1) {
              t3--;
            }
            if (6 * t3 < 1) {
              val = t1 + (t2 - t1) * 6 * t3;
            } else if (2 * t3 < 1) {
              val = t2;
            } else if (3 * t3 < 2) {
              val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
            } else {
              val = t1;
            }
            rgb[i2] = val * 255;
          }
          return rgb;
        };
        convert2.hsl.hsv = function(hsl) {
          var h2 = hsl[0];
          var s2 = hsl[1] / 100;
          var l = hsl[2] / 100;
          var smin = s2;
          var lmin = Math.max(l, 0.01);
          var sv;
          var v;
          l *= 2;
          s2 *= l <= 1 ? l : 2 - l;
          smin *= lmin <= 1 ? lmin : 2 - lmin;
          v = (l + s2) / 2;
          sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s2 / (l + s2);
          return [h2, sv * 100, v * 100];
        };
        convert2.hsv.rgb = function(hsv) {
          var h2 = hsv[0] / 60;
          var s2 = hsv[1] / 100;
          var v = hsv[2] / 100;
          var hi = Math.floor(h2) % 6;
          var f3 = h2 - Math.floor(h2);
          var p = 255 * v * (1 - s2);
          var q = 255 * v * (1 - s2 * f3);
          var t2 = 255 * v * (1 - s2 * (1 - f3));
          v *= 255;
          switch (hi) {
            case 0:
              return [v, t2, p];
            case 1:
              return [q, v, p];
            case 2:
              return [p, v, t2];
            case 3:
              return [p, q, v];
            case 4:
              return [t2, p, v];
            case 5:
              return [v, p, q];
          }
        };
        convert2.hsv.hsl = function(hsv) {
          var h2 = hsv[0];
          var s2 = hsv[1] / 100;
          var v = hsv[2] / 100;
          var vmin = Math.max(v, 0.01);
          var lmin;
          var sl;
          var l;
          l = (2 - s2) * v;
          lmin = (2 - s2) * vmin;
          sl = s2 * vmin;
          sl /= lmin <= 1 ? lmin : 2 - lmin;
          sl = sl || 0;
          l /= 2;
          return [h2, sl * 100, l * 100];
        };
        convert2.hwb.rgb = function(hwb) {
          var h2 = hwb[0] / 360;
          var wh = hwb[1] / 100;
          var bl = hwb[2] / 100;
          var ratio = wh + bl;
          var i2;
          var v;
          var f3;
          var n;
          if (ratio > 1) {
            wh /= ratio;
            bl /= ratio;
          }
          i2 = Math.floor(6 * h2);
          v = 1 - bl;
          f3 = 6 * h2 - i2;
          if ((i2 & 1) !== 0) {
            f3 = 1 - f3;
          }
          n = wh + f3 * (v - wh);
          var r2;
          var g;
          var b;
          switch (i2) {
            default:
            case 6:
            case 0:
              r2 = v;
              g = n;
              b = wh;
              break;
            case 1:
              r2 = n;
              g = v;
              b = wh;
              break;
            case 2:
              r2 = wh;
              g = v;
              b = n;
              break;
            case 3:
              r2 = wh;
              g = n;
              b = v;
              break;
            case 4:
              r2 = n;
              g = wh;
              b = v;
              break;
            case 5:
              r2 = v;
              g = wh;
              b = n;
              break;
          }
          return [r2 * 255, g * 255, b * 255];
        };
        convert2.cmyk.rgb = function(cmyk) {
          var c = cmyk[0] / 100;
          var m2 = cmyk[1] / 100;
          var y = cmyk[2] / 100;
          var k = cmyk[3] / 100;
          var r2;
          var g;
          var b;
          r2 = 1 - Math.min(1, c * (1 - k) + k);
          g = 1 - Math.min(1, m2 * (1 - k) + k);
          b = 1 - Math.min(1, y * (1 - k) + k);
          return [r2 * 255, g * 255, b * 255];
        };
        convert2.xyz.rgb = function(xyz) {
          var x2 = xyz[0] / 100;
          var y = xyz[1] / 100;
          var z = xyz[2] / 100;
          var r2;
          var g;
          var b;
          r2 = x2 * 3.2406 + y * -1.5372 + z * -0.4986;
          g = x2 * -0.9689 + y * 1.8758 + z * 0.0415;
          b = x2 * 0.0557 + y * -0.204 + z * 1.057;
          r2 = r2 > 31308e-7 ? 1.055 * Math.pow(r2, 1 / 2.4) - 0.055 : r2 * 12.92;
          g = g > 31308e-7 ? 1.055 * Math.pow(g, 1 / 2.4) - 0.055 : g * 12.92;
          b = b > 31308e-7 ? 1.055 * Math.pow(b, 1 / 2.4) - 0.055 : b * 12.92;
          r2 = Math.min(Math.max(0, r2), 1);
          g = Math.min(Math.max(0, g), 1);
          b = Math.min(Math.max(0, b), 1);
          return [r2 * 255, g * 255, b * 255];
        };
        convert2.xyz.lab = function(xyz) {
          var x2 = xyz[0];
          var y = xyz[1];
          var z = xyz[2];
          var l;
          var a;
          var b;
          x2 /= 95.047;
          y /= 100;
          z /= 108.883;
          x2 = x2 > 8856e-6 ? Math.pow(x2, 1 / 3) : 7.787 * x2 + 16 / 116;
          y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
          z = z > 8856e-6 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
          l = 116 * y - 16;
          a = 500 * (x2 - y);
          b = 200 * (y - z);
          return [l, a, b];
        };
        convert2.lab.xyz = function(lab) {
          var l = lab[0];
          var a = lab[1];
          var b = lab[2];
          var x2;
          var y;
          var z;
          y = (l + 16) / 116;
          x2 = a / 500 + y;
          z = y - b / 200;
          var y2 = Math.pow(y, 3);
          var x22 = Math.pow(x2, 3);
          var z2 = Math.pow(z, 3);
          y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
          x2 = x22 > 8856e-6 ? x22 : (x2 - 16 / 116) / 7.787;
          z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
          x2 *= 95.047;
          y *= 100;
          z *= 108.883;
          return [x2, y, z];
        };
        convert2.lab.lch = function(lab) {
          var l = lab[0];
          var a = lab[1];
          var b = lab[2];
          var hr;
          var h2;
          var c;
          hr = Math.atan2(b, a);
          h2 = hr * 360 / 2 / Math.PI;
          if (h2 < 0) {
            h2 += 360;
          }
          c = Math.sqrt(a * a + b * b);
          return [l, c, h2];
        };
        convert2.lch.lab = function(lch) {
          var l = lch[0];
          var c = lch[1];
          var h2 = lch[2];
          var a;
          var b;
          var hr;
          hr = h2 / 360 * 2 * Math.PI;
          a = c * Math.cos(hr);
          b = c * Math.sin(hr);
          return [l, a, b];
        };
        convert2.rgb.ansi16 = function(args) {
          var r2 = args[0];
          var g = args[1];
          var b = args[2];
          var value = 1 in arguments ? arguments[1] : convert2.rgb.hsv(args)[2];
          value = Math.round(value / 50);
          if (value === 0) {
            return 30;
          }
          var ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r2 / 255));
          if (value === 2) {
            ansi += 60;
          }
          return ansi;
        };
        convert2.hsv.ansi16 = function(args) {
          return convert2.rgb.ansi16(convert2.hsv.rgb(args), args[2]);
        };
        convert2.rgb.ansi256 = function(args) {
          var r2 = args[0];
          var g = args[1];
          var b = args[2];
          if (r2 === g && g === b) {
            if (r2 < 8) {
              return 16;
            }
            if (r2 > 248) {
              return 231;
            }
            return Math.round((r2 - 8) / 247 * 24) + 232;
          }
          var ansi = 16 + 36 * Math.round(r2 / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
          return ansi;
        };
        convert2.ansi16.rgb = function(args) {
          var color = args % 10;
          if (color === 0 || color === 7) {
            if (args > 50) {
              color += 3.5;
            }
            color = color / 10.5 * 255;
            return [color, color, color];
          }
          var mult = (~~(args > 50) + 1) * 0.5;
          var r2 = (color & 1) * mult * 255;
          var g = (color >> 1 & 1) * mult * 255;
          var b = (color >> 2 & 1) * mult * 255;
          return [r2, g, b];
        };
        convert2.ansi256.rgb = function(args) {
          if (args >= 232) {
            var c = (args - 232) * 10 + 8;
            return [c, c, c];
          }
          args -= 16;
          var rem;
          var r2 = Math.floor(args / 36) / 5 * 255;
          var g = Math.floor((rem = args % 36) / 6) / 5 * 255;
          var b = rem % 6 / 5 * 255;
          return [r2, g, b];
        };
        convert2.rgb.hex = function(args) {
          var integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
          var string = integer.toString(16).toUpperCase();
          return "000000".substring(string.length) + string;
        };
        convert2.hex.rgb = function(args) {
          var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
          if (!match) {
            return [0, 0, 0];
          }
          var colorString = match[0];
          if (match[0].length === 3) {
            colorString = colorString.split("").map(function(char) {
              return char + char;
            }).join("");
          }
          var integer = parseInt(colorString, 16);
          var r2 = integer >> 16 & 255;
          var g = integer >> 8 & 255;
          var b = integer & 255;
          return [r2, g, b];
        };
        convert2.rgb.hcg = function(rgb) {
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var max = Math.max(Math.max(r2, g), b);
          var min = Math.min(Math.min(r2, g), b);
          var chroma = max - min;
          var grayscale;
          var hue;
          if (chroma < 1) {
            grayscale = min / (1 - chroma);
          } else {
            grayscale = 0;
          }
          if (chroma <= 0) {
            hue = 0;
          } else if (max === r2) {
            hue = (g - b) / chroma % 6;
          } else if (max === g) {
            hue = 2 + (b - r2) / chroma;
          } else {
            hue = 4 + (r2 - g) / chroma + 4;
          }
          hue /= 6;
          hue %= 1;
          return [hue * 360, chroma * 100, grayscale * 100];
        };
        convert2.hsl.hcg = function(hsl) {
          var s2 = hsl[1] / 100;
          var l = hsl[2] / 100;
          var c = 1;
          var f3 = 0;
          if (l < 0.5) {
            c = 2 * s2 * l;
          } else {
            c = 2 * s2 * (1 - l);
          }
          if (c < 1) {
            f3 = (l - 0.5 * c) / (1 - c);
          }
          return [hsl[0], c * 100, f3 * 100];
        };
        convert2.hsv.hcg = function(hsv) {
          var s2 = hsv[1] / 100;
          var v = hsv[2] / 100;
          var c = s2 * v;
          var f3 = 0;
          if (c < 1) {
            f3 = (v - c) / (1 - c);
          }
          return [hsv[0], c * 100, f3 * 100];
        };
        convert2.hcg.rgb = function(hcg) {
          var h2 = hcg[0] / 360;
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          if (c === 0) {
            return [g * 255, g * 255, g * 255];
          }
          var pure = [0, 0, 0];
          var hi = h2 % 1 * 6;
          var v = hi % 1;
          var w = 1 - v;
          var mg = 0;
          switch (Math.floor(hi)) {
            case 0:
              pure[0] = 1;
              pure[1] = v;
              pure[2] = 0;
              break;
            case 1:
              pure[0] = w;
              pure[1] = 1;
              pure[2] = 0;
              break;
            case 2:
              pure[0] = 0;
              pure[1] = 1;
              pure[2] = v;
              break;
            case 3:
              pure[0] = 0;
              pure[1] = w;
              pure[2] = 1;
              break;
            case 4:
              pure[0] = v;
              pure[1] = 0;
              pure[2] = 1;
              break;
            default:
              pure[0] = 1;
              pure[1] = 0;
              pure[2] = w;
          }
          mg = (1 - c) * g;
          return [(c * pure[0] + mg) * 255, (c * pure[1] + mg) * 255, (c * pure[2] + mg) * 255];
        };
        convert2.hcg.hsv = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var v = c + g * (1 - c);
          var f3 = 0;
          if (v > 0) {
            f3 = c / v;
          }
          return [hcg[0], f3 * 100, v * 100];
        };
        convert2.hcg.hsl = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var l = g * (1 - c) + 0.5 * c;
          var s2 = 0;
          if (l > 0 && l < 0.5) {
            s2 = c / (2 * l);
          } else if (l >= 0.5 && l < 1) {
            s2 = c / (2 * (1 - l));
          }
          return [hcg[0], s2 * 100, l * 100];
        };
        convert2.hcg.hwb = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var v = c + g * (1 - c);
          return [hcg[0], (v - c) * 100, (1 - v) * 100];
        };
        convert2.hwb.hcg = function(hwb) {
          var w = hwb[1] / 100;
          var b = hwb[2] / 100;
          var v = 1 - b;
          var c = v - w;
          var g = 0;
          if (c < 1) {
            g = (v - c) / (1 - c);
          }
          return [hwb[0], c * 100, g * 100];
        };
        convert2.apple.rgb = function(apple) {
          return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
        };
        convert2.rgb.apple = function(rgb) {
          return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
        };
        convert2.gray.rgb = function(args) {
          return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
        };
        convert2.gray.hsl = convert2.gray.hsv = function(args) {
          return [0, 0, args[0]];
        };
        convert2.gray.hwb = function(gray) {
          return [0, 100, gray[0]];
        };
        convert2.gray.cmyk = function(gray) {
          return [0, 0, 0, gray[0]];
        };
        convert2.gray.lab = function(gray) {
          return [gray[0], 0, 0];
        };
        convert2.gray.hex = function(gray) {
          var val = Math.round(gray[0] / 100 * 255) & 255;
          var integer = (val << 16) + (val << 8) + val;
          var string = integer.toString(16).toUpperCase();
          return "000000".substring(string.length) + string;
        };
        convert2.rgb.gray = function(rgb) {
          var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
          return [val / 255 * 100];
        };
      }
    });
    var require_route2 = __commonJS2({
      "node_modules/color-convert/route.js"(exports2, module22) {
        var conversions = require_conversions2();
        function buildGraph() {
          var graph = {};
          var models = Object.keys(conversions);
          for (var len = models.length, i2 = 0; i2 < len; i2++) {
            graph[models[i2]] = {
              distance: -1,
              parent: null
            };
          }
          return graph;
        }
        function deriveBFS(fromModel) {
          var graph = buildGraph();
          var queue = [fromModel];
          graph[fromModel].distance = 0;
          while (queue.length) {
            var current = queue.pop();
            var adjacents = Object.keys(conversions[current]);
            for (var len = adjacents.length, i2 = 0; i2 < len; i2++) {
              var adjacent = adjacents[i2];
              var node = graph[adjacent];
              if (node.distance === -1) {
                node.distance = graph[current].distance + 1;
                node.parent = current;
                queue.unshift(adjacent);
              }
            }
          }
          return graph;
        }
        function link(from, to) {
          return function(args) {
            return to(from(args));
          };
        }
        function wrapConversion(toModel, graph) {
          var path4 = [graph[toModel].parent, toModel];
          var fn = conversions[graph[toModel].parent][toModel];
          var cur = graph[toModel].parent;
          while (graph[cur].parent) {
            path4.unshift(graph[cur].parent);
            fn = link(conversions[graph[cur].parent][cur], fn);
            cur = graph[cur].parent;
          }
          fn.conversion = path4;
          return fn;
        }
        module22.exports = function(fromModel) {
          var graph = deriveBFS(fromModel);
          var conversion = {};
          var models = Object.keys(graph);
          for (var len = models.length, i2 = 0; i2 < len; i2++) {
            var toModel = models[i2];
            var node = graph[toModel];
            if (node.parent === null) {
              continue;
            }
            conversion[toModel] = wrapConversion(toModel, graph);
          }
          return conversion;
        };
      }
    });
    var require_color_convert2 = __commonJS2({
      "node_modules/color-convert/index.js"(exports2, module22) {
        var conversions = require_conversions2();
        var route = require_route2();
        var convert2 = {};
        var models = Object.keys(conversions);
        function wrapRaw(fn) {
          var wrappedFn = function(args) {
            if (args === void 0 || args === null) {
              return args;
            }
            if (arguments.length > 1) {
              args = Array.prototype.slice.call(arguments);
            }
            return fn(args);
          };
          if ("conversion" in fn) {
            wrappedFn.conversion = fn.conversion;
          }
          return wrappedFn;
        }
        function wrapRounded(fn) {
          var wrappedFn = function(args) {
            if (args === void 0 || args === null) {
              return args;
            }
            if (arguments.length > 1) {
              args = Array.prototype.slice.call(arguments);
            }
            var result = fn(args);
            if (typeof result === "object") {
              for (var len = result.length, i2 = 0; i2 < len; i2++) {
                result[i2] = Math.round(result[i2]);
              }
            }
            return result;
          };
          if ("conversion" in fn) {
            wrappedFn.conversion = fn.conversion;
          }
          return wrappedFn;
        }
        models.forEach(function(fromModel) {
          convert2[fromModel] = {};
          Object.defineProperty(convert2[fromModel], "channels", {
            value: conversions[fromModel].channels
          });
          Object.defineProperty(convert2[fromModel], "labels", {
            value: conversions[fromModel].labels
          });
          var routes = route(fromModel);
          var routeModels = Object.keys(routes);
          routeModels.forEach(function(toModel) {
            var fn = routes[toModel];
            convert2[fromModel][toModel] = wrapRounded(fn);
            convert2[fromModel][toModel].raw = wrapRaw(fn);
          });
        });
        module22.exports = convert2;
      }
    });
    var require_ansi_styles2 = __commonJS2({
      "node_modules/ansi-styles/index.js"(exports2, module22) {
        "use strict";
        var colorConvert = require_color_convert2();
        var wrapAnsi16 = (fn, offset) => function() {
          const code = fn.apply(colorConvert, arguments);
          return `\x1B[${code + offset}m`;
        };
        var wrapAnsi256 = (fn, offset) => function() {
          const code = fn.apply(colorConvert, arguments);
          return `\x1B[${38 + offset};5;${code}m`;
        };
        var wrapAnsi16m = (fn, offset) => function() {
          const rgb = fn.apply(colorConvert, arguments);
          return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
        };
        function assembleStyles() {
          const codes = /* @__PURE__ */ new Map();
          const styles = {
            modifier: {
              reset: [0, 0],
              bold: [1, 22],
              dim: [2, 22],
              italic: [3, 23],
              underline: [4, 24],
              inverse: [7, 27],
              hidden: [8, 28],
              strikethrough: [9, 29]
            },
            color: {
              black: [30, 39],
              red: [31, 39],
              green: [32, 39],
              yellow: [33, 39],
              blue: [34, 39],
              magenta: [35, 39],
              cyan: [36, 39],
              white: [37, 39],
              gray: [90, 39],
              redBright: [91, 39],
              greenBright: [92, 39],
              yellowBright: [93, 39],
              blueBright: [94, 39],
              magentaBright: [95, 39],
              cyanBright: [96, 39],
              whiteBright: [97, 39]
            },
            bgColor: {
              bgBlack: [40, 49],
              bgRed: [41, 49],
              bgGreen: [42, 49],
              bgYellow: [43, 49],
              bgBlue: [44, 49],
              bgMagenta: [45, 49],
              bgCyan: [46, 49],
              bgWhite: [47, 49],
              bgBlackBright: [100, 49],
              bgRedBright: [101, 49],
              bgGreenBright: [102, 49],
              bgYellowBright: [103, 49],
              bgBlueBright: [104, 49],
              bgMagentaBright: [105, 49],
              bgCyanBright: [106, 49],
              bgWhiteBright: [107, 49]
            }
          };
          styles.color.grey = styles.color.gray;
          for (const groupName of Object.keys(styles)) {
            const group = styles[groupName];
            for (const styleName of Object.keys(group)) {
              const style = group[styleName];
              styles[styleName] = {
                open: `\x1B[${style[0]}m`,
                close: `\x1B[${style[1]}m`
              };
              group[styleName] = styles[styleName];
              codes.set(style[0], style[1]);
            }
            Object.defineProperty(styles, groupName, {
              value: group,
              enumerable: false
            });
            Object.defineProperty(styles, "codes", {
              value: codes,
              enumerable: false
            });
          }
          const ansi2ansi = (n) => n;
          const rgb2rgb = (r2, g, b) => [r2, g, b];
          styles.color.close = "\x1B[39m";
          styles.bgColor.close = "\x1B[49m";
          styles.color.ansi = {
            ansi: wrapAnsi16(ansi2ansi, 0)
          };
          styles.color.ansi256 = {
            ansi256: wrapAnsi256(ansi2ansi, 0)
          };
          styles.color.ansi16m = {
            rgb: wrapAnsi16m(rgb2rgb, 0)
          };
          styles.bgColor.ansi = {
            ansi: wrapAnsi16(ansi2ansi, 10)
          };
          styles.bgColor.ansi256 = {
            ansi256: wrapAnsi256(ansi2ansi, 10)
          };
          styles.bgColor.ansi16m = {
            rgb: wrapAnsi16m(rgb2rgb, 10)
          };
          for (let key of Object.keys(colorConvert)) {
            if (typeof colorConvert[key] !== "object") {
              continue;
            }
            const suite = colorConvert[key];
            if (key === "ansi16") {
              key = "ansi";
            }
            if ("ansi16" in suite) {
              styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
              styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
            }
            if ("ansi256" in suite) {
              styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
              styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
            }
            if ("rgb" in suite) {
              styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
              styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
            }
          }
          return styles;
        }
        Object.defineProperty(module22, "exports", {
          enumerable: true,
          get: assembleStyles
        });
      }
    });
    var require_has_flag2 = __commonJS2({
      "node_modules/@babel/highlight/node_modules/has-flag/index.js"(exports2, module22) {
        "use strict";
        module22.exports = (flag, argv) => {
          argv = argv || process.argv;
          const prefix2 = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
          const pos = argv.indexOf(prefix2 + flag);
          const terminatorPos = argv.indexOf("--");
          return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
        };
      }
    });
    var require_supports_color2 = __commonJS2({
      "node_modules/@babel/highlight/node_modules/supports-color/index.js"(exports2, module22) {
        "use strict";
        var os = require("os");
        var hasFlag = require_has_flag2();
        var env = process.env;
        var forceColor;
        if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
          forceColor = false;
        } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
          forceColor = true;
        }
        if ("FORCE_COLOR" in env) {
          forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
        }
        function translateLevel(level) {
          if (level === 0) {
            return false;
          }
          return {
            level,
            hasBasic: true,
            has256: level >= 2,
            has16m: level >= 3
          };
        }
        function supportsColor(stream) {
          if (forceColor === false) {
            return 0;
          }
          if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
            return 3;
          }
          if (hasFlag("color=256")) {
            return 2;
          }
          if (stream && !stream.isTTY && forceColor !== true) {
            return 0;
          }
          const min = forceColor ? 1 : 0;
          if (process.platform === "win32") {
            const osRelease = os.release().split(".");
            if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
              return Number(osRelease[2]) >= 14931 ? 3 : 2;
            }
            return 1;
          }
          if ("CI" in env) {
            if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
              return 1;
            }
            return min;
          }
          if ("TEAMCITY_VERSION" in env) {
            return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
          }
          if (env.COLORTERM === "truecolor") {
            return 3;
          }
          if ("TERM_PROGRAM" in env) {
            const version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
            switch (env.TERM_PROGRAM) {
              case "iTerm.app":
                return version >= 3 ? 3 : 2;
              case "Apple_Terminal":
                return 2;
            }
          }
          if (/-256(color)?$/i.test(env.TERM)) {
            return 2;
          }
          if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
            return 1;
          }
          if ("COLORTERM" in env) {
            return 1;
          }
          if (env.TERM === "dumb") {
            return min;
          }
          return min;
        }
        function getSupportLevel(stream) {
          const level = supportsColor(stream);
          return translateLevel(level);
        }
        module22.exports = {
          supportsColor: getSupportLevel,
          stdout: getSupportLevel(process.stdout),
          stderr: getSupportLevel(process.stderr)
        };
      }
    });
    var require_templates2 = __commonJS2({
      "node_modules/@babel/highlight/node_modules/chalk/templates.js"(exports2, module22) {
        "use strict";
        var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
        var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
        var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
        var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
        var ESCAPES = /* @__PURE__ */ new Map([["n", "\n"], ["r", "\r"], ["t", "	"], ["b", "\b"], ["f", "\f"], ["v", "\v"], ["0", "\0"], ["\\", "\\"], ["e", "\x1B"], ["a", "\x07"]]);
        function unescape2(c) {
          if (c[0] === "u" && c.length === 5 || c[0] === "x" && c.length === 3) {
            return String.fromCharCode(parseInt(c.slice(1), 16));
          }
          return ESCAPES.get(c) || c;
        }
        function parseArguments(name, args) {
          const results = [];
          const chunks = args.trim().split(/\s*,\s*/g);
          let matches;
          for (const chunk of chunks) {
            if (!isNaN(chunk)) {
              results.push(Number(chunk));
            } else if (matches = chunk.match(STRING_REGEX)) {
              results.push(matches[2].replace(ESCAPE_REGEX, (m2, escape, chr) => escape ? unescape2(escape) : chr));
            } else {
              throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
            }
          }
          return results;
        }
        function parseStyle(style) {
          STYLE_REGEX.lastIndex = 0;
          const results = [];
          let matches;
          while ((matches = STYLE_REGEX.exec(style)) !== null) {
            const name = matches[1];
            if (matches[2]) {
              const args = parseArguments(name, matches[2]);
              results.push([name].concat(args));
            } else {
              results.push([name]);
            }
          }
          return results;
        }
        function buildStyle(chalk3, styles) {
          const enabled = {};
          for (const layer of styles) {
            for (const style of layer.styles) {
              enabled[style[0]] = layer.inverse ? null : style.slice(1);
            }
          }
          let current = chalk3;
          for (const styleName of Object.keys(enabled)) {
            if (Array.isArray(enabled[styleName])) {
              if (!(styleName in current)) {
                throw new Error(`Unknown Chalk style: ${styleName}`);
              }
              if (enabled[styleName].length > 0) {
                current = current[styleName].apply(current, enabled[styleName]);
              } else {
                current = current[styleName];
              }
            }
          }
          return current;
        }
        module22.exports = (chalk3, tmp) => {
          const styles = [];
          const chunks = [];
          let chunk = [];
          tmp.replace(TEMPLATE_REGEX, (m2, escapeChar, inverse, style, close, chr) => {
            if (escapeChar) {
              chunk.push(unescape2(escapeChar));
            } else if (style) {
              const str = chunk.join("");
              chunk = [];
              chunks.push(styles.length === 0 ? str : buildStyle(chalk3, styles)(str));
              styles.push({
                inverse,
                styles: parseStyle(style)
              });
            } else if (close) {
              if (styles.length === 0) {
                throw new Error("Found extraneous } in Chalk template literal");
              }
              chunks.push(buildStyle(chalk3, styles)(chunk.join("")));
              chunk = [];
              styles.pop();
            } else {
              chunk.push(chr);
            }
          });
          chunks.push(chunk.join(""));
          if (styles.length > 0) {
            const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
            throw new Error(errMsg);
          }
          return chunks.join("");
        };
      }
    });
    var require_chalk2 = __commonJS2({
      "node_modules/@babel/highlight/node_modules/chalk/index.js"(exports2, module22) {
        "use strict";
        var escapeStringRegexp = require_escape_string_regexp2();
        var ansiStyles = require_ansi_styles2();
        var stdoutColor = require_supports_color2().stdout;
        var template = require_templates2();
        var isSimpleWindowsTerm = process.platform === "win32" && !(process.env.TERM || "").toLowerCase().startsWith("xterm");
        var levelMapping = ["ansi", "ansi", "ansi256", "ansi16m"];
        var skipModels = /* @__PURE__ */ new Set(["gray"]);
        var styles = /* @__PURE__ */ Object.create(null);
        function applyOptions(obj, options) {
          options = options || {};
          const scLevel = stdoutColor ? stdoutColor.level : 0;
          obj.level = options.level === void 0 ? scLevel : options.level;
          obj.enabled = "enabled" in options ? options.enabled : obj.level > 0;
        }
        function Chalk(options) {
          if (!this || !(this instanceof Chalk) || this.template) {
            const chalk3 = {};
            applyOptions(chalk3, options);
            chalk3.template = function() {
              const args = [].slice.call(arguments);
              return chalkTag.apply(null, [chalk3.template].concat(args));
            };
            Object.setPrototypeOf(chalk3, Chalk.prototype);
            Object.setPrototypeOf(chalk3.template, chalk3);
            chalk3.template.constructor = Chalk;
            return chalk3.template;
          }
          applyOptions(this, options);
        }
        if (isSimpleWindowsTerm) {
          ansiStyles.blue.open = "\x1B[94m";
        }
        for (const key of Object.keys(ansiStyles)) {
          ansiStyles[key].closeRe = new RegExp(escapeStringRegexp(ansiStyles[key].close), "g");
          styles[key] = {
            get() {
              const codes = ansiStyles[key];
              return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
            }
          };
        }
        styles.visible = {
          get() {
            return build.call(this, this._styles || [], true, "visible");
          }
        };
        ansiStyles.color.closeRe = new RegExp(escapeStringRegexp(ansiStyles.color.close), "g");
        for (const model of Object.keys(ansiStyles.color.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          styles[model] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.color.close,
                  closeRe: ansiStyles.color.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp(ansiStyles.bgColor.close), "g");
        for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
          styles[bgModel] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.bgColor.close,
                  closeRe: ansiStyles.bgColor.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        var proto = Object.defineProperties(() => {
        }, styles);
        function build(_styles, _empty, key) {
          const builder = function() {
            return applyStyle.apply(builder, arguments);
          };
          builder._styles = _styles;
          builder._empty = _empty;
          const self2 = this;
          Object.defineProperty(builder, "level", {
            enumerable: true,
            get() {
              return self2.level;
            },
            set(level) {
              self2.level = level;
            }
          });
          Object.defineProperty(builder, "enabled", {
            enumerable: true,
            get() {
              return self2.enabled;
            },
            set(enabled) {
              self2.enabled = enabled;
            }
          });
          builder.hasGrey = this.hasGrey || key === "gray" || key === "grey";
          builder.__proto__ = proto;
          return builder;
        }
        function applyStyle() {
          const args = arguments;
          const argsLen = args.length;
          let str = String(arguments[0]);
          if (argsLen === 0) {
            return "";
          }
          if (argsLen > 1) {
            for (let a = 1; a < argsLen; a++) {
              str += " " + args[a];
            }
          }
          if (!this.enabled || this.level <= 0 || !str) {
            return this._empty ? "" : str;
          }
          const originalDim = ansiStyles.dim.open;
          if (isSimpleWindowsTerm && this.hasGrey) {
            ansiStyles.dim.open = "";
          }
          for (const code of this._styles.slice().reverse()) {
            str = code.open + str.replace(code.closeRe, code.open) + code.close;
            str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
          }
          ansiStyles.dim.open = originalDim;
          return str;
        }
        function chalkTag(chalk3, strings) {
          if (!Array.isArray(strings)) {
            return [].slice.call(arguments, 1).join(" ");
          }
          const args = [].slice.call(arguments, 2);
          const parts = [strings.raw[0]];
          for (let i2 = 1; i2 < strings.length; i2++) {
            parts.push(String(args[i2 - 1]).replace(/[{}\\]/g, "\\$&"));
            parts.push(String(strings.raw[i2]));
          }
          return template(chalk3, parts.join(""));
        }
        Object.defineProperties(Chalk.prototype, styles);
        module22.exports = Chalk();
        module22.exports.supportsColor = stdoutColor;
        module22.exports.default = module22.exports;
      }
    });
    var require_lib22 = __commonJS2({
      "node_modules/@babel/highlight/lib/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.default = highlight;
        exports2.getChalk = getChalk;
        exports2.shouldHighlight = shouldHighlight;
        var _jsTokens = require_js_tokens();
        var _helperValidatorIdentifier = require_lib8();
        var _chalk = require_chalk2();
        var sometimesKeywords = /* @__PURE__ */ new Set(["as", "async", "from", "get", "of", "set"]);
        function getDefs(chalk3) {
          return {
            keyword: chalk3.cyan,
            capitalized: chalk3.yellow,
            jsxIdentifier: chalk3.yellow,
            punctuator: chalk3.yellow,
            number: chalk3.magenta,
            string: chalk3.green,
            regex: chalk3.magenta,
            comment: chalk3.grey,
            invalid: chalk3.white.bgRed.bold
          };
        }
        var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
        var BRACKET = /^[()[\]{}]$/;
        var tokenize;
        {
          const JSX_TAG = /^[a-z][\w-]*$/i;
          const getTokenType = function(token, offset, text) {
            if (token.type === "name") {
              if ((0, _helperValidatorIdentifier.isKeyword)(token.value) || (0, _helperValidatorIdentifier.isStrictReservedWord)(token.value, true) || sometimesKeywords.has(token.value)) {
                return "keyword";
              }
              if (JSX_TAG.test(token.value) && (text[offset - 1] === "<" || text.substr(offset - 2, 2) == "</")) {
                return "jsxIdentifier";
              }
              if (token.value[0] !== token.value[0].toLowerCase()) {
                return "capitalized";
              }
            }
            if (token.type === "punctuator" && BRACKET.test(token.value)) {
              return "bracket";
            }
            if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
              return "punctuator";
            }
            return token.type;
          };
          tokenize = function* (text) {
            let match;
            while (match = _jsTokens.default.exec(text)) {
              const token = _jsTokens.matchToToken(match);
              yield {
                type: getTokenType(token, match.index, text),
                value: token.value
              };
            }
          };
        }
        function highlightTokens(defs, text) {
          let highlighted = "";
          for (const {
            type,
            value
          } of tokenize(text)) {
            const colorize = defs[type];
            if (colorize) {
              highlighted += value.split(NEWLINE).map((str) => colorize(str)).join("\n");
            } else {
              highlighted += value;
            }
          }
          return highlighted;
        }
        function shouldHighlight(options) {
          return !!_chalk.supportsColor || options.forceColor;
        }
        function getChalk(options) {
          return options.forceColor ? new _chalk.constructor({
            enabled: true,
            level: 1
          }) : _chalk;
        }
        function highlight(code, options = {}) {
          if (code !== "" && shouldHighlight(options)) {
            const chalk3 = getChalk(options);
            const defs = getDefs(chalk3);
            return highlightTokens(defs, code);
          } else {
            return code;
          }
        }
      }
    });
    var require_lib32 = __commonJS2({
      "node_modules/@babel/code-frame/lib/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.codeFrameColumns = codeFrameColumns;
        exports2.default = _default;
        var _highlight = require_lib22();
        var deprecationWarningShown = false;
        function getDefs(chalk3) {
          return {
            gutter: chalk3.grey,
            marker: chalk3.red.bold,
            message: chalk3.red.bold
          };
        }
        var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
        function getMarkerLines(loc, source, opts) {
          const startLoc = Object.assign({
            column: 0,
            line: -1
          }, loc.start);
          const endLoc = Object.assign({}, startLoc, loc.end);
          const {
            linesAbove = 2,
            linesBelow = 3
          } = opts || {};
          const startLine = startLoc.line;
          const startColumn = startLoc.column;
          const endLine = endLoc.line;
          const endColumn = endLoc.column;
          let start = Math.max(startLine - (linesAbove + 1), 0);
          let end = Math.min(source.length, endLine + linesBelow);
          if (startLine === -1) {
            start = 0;
          }
          if (endLine === -1) {
            end = source.length;
          }
          const lineDiff = endLine - startLine;
          const markerLines = {};
          if (lineDiff) {
            for (let i2 = 0; i2 <= lineDiff; i2++) {
              const lineNumber = i2 + startLine;
              if (!startColumn) {
                markerLines[lineNumber] = true;
              } else if (i2 === 0) {
                const sourceLength = source[lineNumber - 1].length;
                markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
              } else if (i2 === lineDiff) {
                markerLines[lineNumber] = [0, endColumn];
              } else {
                const sourceLength = source[lineNumber - i2].length;
                markerLines[lineNumber] = [0, sourceLength];
              }
            }
          } else {
            if (startColumn === endColumn) {
              if (startColumn) {
                markerLines[startLine] = [startColumn, 0];
              } else {
                markerLines[startLine] = true;
              }
            } else {
              markerLines[startLine] = [startColumn, endColumn - startColumn];
            }
          }
          return {
            start,
            end,
            markerLines
          };
        }
        function codeFrameColumns(rawLines, loc, opts = {}) {
          const highlighted = (opts.highlightCode || opts.forceColor) && (0, _highlight.shouldHighlight)(opts);
          const chalk3 = (0, _highlight.getChalk)(opts);
          const defs = getDefs(chalk3);
          const maybeHighlight = (chalkFn, string) => {
            return highlighted ? chalkFn(string) : string;
          };
          const lines = rawLines.split(NEWLINE);
          const {
            start,
            end,
            markerLines
          } = getMarkerLines(loc, lines, opts);
          const hasColumns = loc.start && typeof loc.start.column === "number";
          const numberMaxWidth = String(end).length;
          const highlightedLines = highlighted ? (0, _highlight.default)(rawLines, opts) : rawLines;
          let frame = highlightedLines.split(NEWLINE, end).slice(start, end).map((line, index) => {
            const number = start + 1 + index;
            const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
            const gutter = ` ${paddedNumber} |`;
            const hasMarker = markerLines[number];
            const lastMarkerLine = !markerLines[number + 1];
            if (hasMarker) {
              let markerLine = "";
              if (Array.isArray(hasMarker)) {
                const markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
                const numberOfMarkers = hasMarker[1] || 1;
                markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");
                if (lastMarkerLine && opts.message) {
                  markerLine += " " + maybeHighlight(defs.message, opts.message);
                }
              }
              return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? ` ${line}` : "", markerLine].join("");
            } else {
              return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ""}`;
            }
          }).join("\n");
          if (opts.message && !hasColumns) {
            frame = `${" ".repeat(numberMaxWidth + 1)}${opts.message}
${frame}`;
          }
          if (highlighted) {
            return chalk3.reset(frame);
          } else {
            return frame;
          }
        }
        function _default(rawLines, lineNumber, colNumber, opts = {}) {
          if (!deprecationWarningShown) {
            deprecationWarningShown = true;
            const message = "Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.";
            if (process.emitWarning) {
              process.emitWarning(message, "DeprecationWarning");
            } else {
              const deprecationError = new Error(message);
              deprecationError.name = "DeprecationWarning";
              console.warn(new Error(message));
            }
          }
          colNumber = Math.max(colNumber, 0);
          const location = {
            start: {
              column: colNumber,
              line: lineNumber
            }
          };
          return codeFrameColumns(rawLines, location, opts);
        }
      }
    });
    var require_parse_json = __commonJS2({
      "node_modules/parse-json/index.js"(exports2, module22) {
        "use strict";
        var errorEx = require_error_ex();
        var fallback = require_json_parse_even_better_errors();
        var {
          default: LinesAndColumns
        } = require_build();
        var {
          codeFrameColumns
        } = require_lib32();
        var JSONError = errorEx("JSONError", {
          fileName: errorEx.append("in %s"),
          codeFrame: errorEx.append("\n\n%s\n")
        });
        var parseJson = (string, reviver, filename) => {
          if (typeof reviver === "string") {
            filename = reviver;
            reviver = null;
          }
          try {
            try {
              return JSON.parse(string, reviver);
            } catch (error) {
              fallback(string, reviver);
              throw error;
            }
          } catch (error) {
            error.message = error.message.replace(/\n/g, "");
            const indexMatch = error.message.match(/in JSON at position (\d+) while parsing/);
            const jsonError = new JSONError(error);
            if (filename) {
              jsonError.fileName = filename;
            }
            if (indexMatch && indexMatch.length > 0) {
              const lines = new LinesAndColumns(string);
              const index = Number(indexMatch[1]);
              const location = lines.locationForIndex(index);
              const codeFrame = codeFrameColumns(string, {
                start: {
                  line: location.line + 1,
                  column: location.column + 1
                }
              }, {
                highlightCode: true
              });
              jsonError.codeFrame = codeFrame;
            }
            throw jsonError;
          }
        };
        parseJson.JSONError = JSONError;
        module22.exports = parseJson;
      }
    });
    var require_PlainValue_ec8e588e = __commonJS2({
      "node_modules/yaml/dist/PlainValue-ec8e588e.js"(exports2) {
        "use strict";
        var Char = {
          ANCHOR: "&",
          COMMENT: "#",
          TAG: "!",
          DIRECTIVES_END: "-",
          DOCUMENT_END: "."
        };
        var Type = {
          ALIAS: "ALIAS",
          BLANK_LINE: "BLANK_LINE",
          BLOCK_FOLDED: "BLOCK_FOLDED",
          BLOCK_LITERAL: "BLOCK_LITERAL",
          COMMENT: "COMMENT",
          DIRECTIVE: "DIRECTIVE",
          DOCUMENT: "DOCUMENT",
          FLOW_MAP: "FLOW_MAP",
          FLOW_SEQ: "FLOW_SEQ",
          MAP: "MAP",
          MAP_KEY: "MAP_KEY",
          MAP_VALUE: "MAP_VALUE",
          PLAIN: "PLAIN",
          QUOTE_DOUBLE: "QUOTE_DOUBLE",
          QUOTE_SINGLE: "QUOTE_SINGLE",
          SEQ: "SEQ",
          SEQ_ITEM: "SEQ_ITEM"
        };
        var defaultTagPrefix = "tag:yaml.org,2002:";
        var defaultTags = {
          MAP: "tag:yaml.org,2002:map",
          SEQ: "tag:yaml.org,2002:seq",
          STR: "tag:yaml.org,2002:str"
        };
        function findLineStarts(src) {
          const ls = [0];
          let offset = src.indexOf("\n");
          while (offset !== -1) {
            offset += 1;
            ls.push(offset);
            offset = src.indexOf("\n", offset);
          }
          return ls;
        }
        function getSrcInfo(cst) {
          let lineStarts, src;
          if (typeof cst === "string") {
            lineStarts = findLineStarts(cst);
            src = cst;
          } else {
            if (Array.isArray(cst))
              cst = cst[0];
            if (cst && cst.context) {
              if (!cst.lineStarts)
                cst.lineStarts = findLineStarts(cst.context.src);
              lineStarts = cst.lineStarts;
              src = cst.context.src;
            }
          }
          return {
            lineStarts,
            src
          };
        }
        function getLinePos(offset, cst) {
          if (typeof offset !== "number" || offset < 0)
            return null;
          const {
            lineStarts,
            src
          } = getSrcInfo(cst);
          if (!lineStarts || !src || offset > src.length)
            return null;
          for (let i2 = 0; i2 < lineStarts.length; ++i2) {
            const start = lineStarts[i2];
            if (offset < start) {
              return {
                line: i2,
                col: offset - lineStarts[i2 - 1] + 1
              };
            }
            if (offset === start)
              return {
                line: i2 + 1,
                col: 1
              };
          }
          const line = lineStarts.length;
          return {
            line,
            col: offset - lineStarts[line - 1] + 1
          };
        }
        function getLine(line, cst) {
          const {
            lineStarts,
            src
          } = getSrcInfo(cst);
          if (!lineStarts || !(line >= 1) || line > lineStarts.length)
            return null;
          const start = lineStarts[line - 1];
          let end = lineStarts[line];
          while (end && end > start && src[end - 1] === "\n")
            --end;
          return src.slice(start, end);
        }
        function getPrettyContext({
          start,
          end
        }, cst, maxWidth = 80) {
          let src = getLine(start.line, cst);
          if (!src)
            return null;
          let {
            col
          } = start;
          if (src.length > maxWidth) {
            if (col <= maxWidth - 10) {
              src = src.substr(0, maxWidth - 1) + "\u2026";
            } else {
              const halfWidth = Math.round(maxWidth / 2);
              if (src.length > col + halfWidth)
                src = src.substr(0, col + halfWidth - 1) + "\u2026";
              col -= src.length - maxWidth;
              src = "\u2026" + src.substr(1 - maxWidth);
            }
          }
          let errLen = 1;
          let errEnd = "";
          if (end) {
            if (end.line === start.line && col + (end.col - start.col) <= maxWidth + 1) {
              errLen = end.col - start.col;
            } else {
              errLen = Math.min(src.length + 1, maxWidth) - col;
              errEnd = "\u2026";
            }
          }
          const offset = col > 1 ? " ".repeat(col - 1) : "";
          const err = "^".repeat(errLen);
          return `${src}
${offset}${err}${errEnd}`;
        }
        var Range = class {
          static copy(orig) {
            return new Range(orig.start, orig.end);
          }
          constructor(start, end) {
            this.start = start;
            this.end = end || start;
          }
          isEmpty() {
            return typeof this.start !== "number" || !this.end || this.end <= this.start;
          }
          setOrigRange(cr, offset) {
            const {
              start,
              end
            } = this;
            if (cr.length === 0 || end <= cr[0]) {
              this.origStart = start;
              this.origEnd = end;
              return offset;
            }
            let i2 = offset;
            while (i2 < cr.length) {
              if (cr[i2] > start)
                break;
              else
                ++i2;
            }
            this.origStart = start + i2;
            const nextOffset = i2;
            while (i2 < cr.length) {
              if (cr[i2] >= end)
                break;
              else
                ++i2;
            }
            this.origEnd = end + i2;
            return nextOffset;
          }
        };
        var Node = class {
          static addStringTerminator(src, offset, str) {
            if (str[str.length - 1] === "\n")
              return str;
            const next = Node.endOfWhiteSpace(src, offset);
            return next >= src.length || src[next] === "\n" ? str + "\n" : str;
          }
          static atDocumentBoundary(src, offset, sep) {
            const ch0 = src[offset];
            if (!ch0)
              return true;
            const prev = src[offset - 1];
            if (prev && prev !== "\n")
              return false;
            if (sep) {
              if (ch0 !== sep)
                return false;
            } else {
              if (ch0 !== Char.DIRECTIVES_END && ch0 !== Char.DOCUMENT_END)
                return false;
            }
            const ch1 = src[offset + 1];
            const ch2 = src[offset + 2];
            if (ch1 !== ch0 || ch2 !== ch0)
              return false;
            const ch3 = src[offset + 3];
            return !ch3 || ch3 === "\n" || ch3 === "	" || ch3 === " ";
          }
          static endOfIdentifier(src, offset) {
            let ch = src[offset];
            const isVerbatim = ch === "<";
            const notOk = isVerbatim ? ["\n", "	", " ", ">"] : ["\n", "	", " ", "[", "]", "{", "}", ","];
            while (ch && notOk.indexOf(ch) === -1)
              ch = src[offset += 1];
            if (isVerbatim && ch === ">")
              offset += 1;
            return offset;
          }
          static endOfIndent(src, offset) {
            let ch = src[offset];
            while (ch === " ")
              ch = src[offset += 1];
            return offset;
          }
          static endOfLine(src, offset) {
            let ch = src[offset];
            while (ch && ch !== "\n")
              ch = src[offset += 1];
            return offset;
          }
          static endOfWhiteSpace(src, offset) {
            let ch = src[offset];
            while (ch === "	" || ch === " ")
              ch = src[offset += 1];
            return offset;
          }
          static startOfLine(src, offset) {
            let ch = src[offset - 1];
            if (ch === "\n")
              return offset;
            while (ch && ch !== "\n")
              ch = src[offset -= 1];
            return offset + 1;
          }
          static endOfBlockIndent(src, indent, lineStart) {
            const inEnd = Node.endOfIndent(src, lineStart);
            if (inEnd > lineStart + indent) {
              return inEnd;
            } else {
              const wsEnd = Node.endOfWhiteSpace(src, inEnd);
              const ch = src[wsEnd];
              if (!ch || ch === "\n")
                return wsEnd;
            }
            return null;
          }
          static atBlank(src, offset, endAsBlank) {
            const ch = src[offset];
            return ch === "\n" || ch === "	" || ch === " " || endAsBlank && !ch;
          }
          static nextNodeIsIndented(ch, indentDiff, indicatorAsIndent) {
            if (!ch || indentDiff < 0)
              return false;
            if (indentDiff > 0)
              return true;
            return indicatorAsIndent && ch === "-";
          }
          static normalizeOffset(src, offset) {
            const ch = src[offset];
            return !ch ? offset : ch !== "\n" && src[offset - 1] === "\n" ? offset - 1 : Node.endOfWhiteSpace(src, offset);
          }
          static foldNewline(src, offset, indent) {
            let inCount = 0;
            let error = false;
            let fold = "";
            let ch = src[offset + 1];
            while (ch === " " || ch === "	" || ch === "\n") {
              switch (ch) {
                case "\n":
                  inCount = 0;
                  offset += 1;
                  fold += "\n";
                  break;
                case "	":
                  if (inCount <= indent)
                    error = true;
                  offset = Node.endOfWhiteSpace(src, offset + 2) - 1;
                  break;
                case " ":
                  inCount += 1;
                  offset += 1;
                  break;
              }
              ch = src[offset + 1];
            }
            if (!fold)
              fold = " ";
            if (ch && inCount <= indent)
              error = true;
            return {
              fold,
              offset,
              error
            };
          }
          constructor(type, props, context2) {
            Object.defineProperty(this, "context", {
              value: context2 || null,
              writable: true
            });
            this.error = null;
            this.range = null;
            this.valueRange = null;
            this.props = props || [];
            this.type = type;
            this.value = null;
          }
          getPropValue(idx, key, skipKey) {
            if (!this.context)
              return null;
            const {
              src
            } = this.context;
            const prop = this.props[idx];
            return prop && src[prop.start] === key ? src.slice(prop.start + (skipKey ? 1 : 0), prop.end) : null;
          }
          get anchor() {
            for (let i2 = 0; i2 < this.props.length; ++i2) {
              const anchor = this.getPropValue(i2, Char.ANCHOR, true);
              if (anchor != null)
                return anchor;
            }
            return null;
          }
          get comment() {
            const comments = [];
            for (let i2 = 0; i2 < this.props.length; ++i2) {
              const comment = this.getPropValue(i2, Char.COMMENT, true);
              if (comment != null)
                comments.push(comment);
            }
            return comments.length > 0 ? comments.join("\n") : null;
          }
          commentHasRequiredWhitespace(start) {
            const {
              src
            } = this.context;
            if (this.header && start === this.header.end)
              return false;
            if (!this.valueRange)
              return false;
            const {
              end
            } = this.valueRange;
            return start !== end || Node.atBlank(src, end - 1);
          }
          get hasComment() {
            if (this.context) {
              const {
                src
              } = this.context;
              for (let i2 = 0; i2 < this.props.length; ++i2) {
                if (src[this.props[i2].start] === Char.COMMENT)
                  return true;
              }
            }
            return false;
          }
          get hasProps() {
            if (this.context) {
              const {
                src
              } = this.context;
              for (let i2 = 0; i2 < this.props.length; ++i2) {
                if (src[this.props[i2].start] !== Char.COMMENT)
                  return true;
              }
            }
            return false;
          }
          get includesTrailingLines() {
            return false;
          }
          get jsonLike() {
            const jsonLikeTypes = [Type.FLOW_MAP, Type.FLOW_SEQ, Type.QUOTE_DOUBLE, Type.QUOTE_SINGLE];
            return jsonLikeTypes.indexOf(this.type) !== -1;
          }
          get rangeAsLinePos() {
            if (!this.range || !this.context)
              return void 0;
            const start = getLinePos(this.range.start, this.context.root);
            if (!start)
              return void 0;
            const end = getLinePos(this.range.end, this.context.root);
            return {
              start,
              end
            };
          }
          get rawValue() {
            if (!this.valueRange || !this.context)
              return null;
            const {
              start,
              end
            } = this.valueRange;
            return this.context.src.slice(start, end);
          }
          get tag() {
            for (let i2 = 0; i2 < this.props.length; ++i2) {
              const tag = this.getPropValue(i2, Char.TAG, false);
              if (tag != null) {
                if (tag[1] === "<") {
                  return {
                    verbatim: tag.slice(2, -1)
                  };
                } else {
                  const [_, handle, suffix] = tag.match(/^(.*!)([^!]*)$/);
                  return {
                    handle,
                    suffix
                  };
                }
              }
            }
            return null;
          }
          get valueRangeContainsNewline() {
            if (!this.valueRange || !this.context)
              return false;
            const {
              start,
              end
            } = this.valueRange;
            const {
              src
            } = this.context;
            for (let i2 = start; i2 < end; ++i2) {
              if (src[i2] === "\n")
                return true;
            }
            return false;
          }
          parseComment(start) {
            const {
              src
            } = this.context;
            if (src[start] === Char.COMMENT) {
              const end = Node.endOfLine(src, start + 1);
              const commentRange = new Range(start, end);
              this.props.push(commentRange);
              return end;
            }
            return start;
          }
          setOrigRanges(cr, offset) {
            if (this.range)
              offset = this.range.setOrigRange(cr, offset);
            if (this.valueRange)
              this.valueRange.setOrigRange(cr, offset);
            this.props.forEach((prop) => prop.setOrigRange(cr, offset));
            return offset;
          }
          toString() {
            const {
              context: {
                src
              },
              range,
              value
            } = this;
            if (value != null)
              return value;
            const str = src.slice(range.start, range.end);
            return Node.addStringTerminator(src, range.end, str);
          }
        };
        var YAMLError = class extends Error {
          constructor(name, source, message) {
            if (!message || !(source instanceof Node))
              throw new Error(`Invalid arguments for new ${name}`);
            super();
            this.name = name;
            this.message = message;
            this.source = source;
          }
          makePretty() {
            if (!this.source)
              return;
            this.nodeType = this.source.type;
            const cst = this.source.context && this.source.context.root;
            if (typeof this.offset === "number") {
              this.range = new Range(this.offset, this.offset + 1);
              const start = cst && getLinePos(this.offset, cst);
              if (start) {
                const end = {
                  line: start.line,
                  col: start.col + 1
                };
                this.linePos = {
                  start,
                  end
                };
              }
              delete this.offset;
            } else {
              this.range = this.source.range;
              this.linePos = this.source.rangeAsLinePos;
            }
            if (this.linePos) {
              const {
                line,
                col
              } = this.linePos.start;
              this.message += ` at line ${line}, column ${col}`;
              const ctx = cst && getPrettyContext(this.linePos, cst);
              if (ctx)
                this.message += `:

${ctx}
`;
            }
            delete this.source;
          }
        };
        var YAMLReferenceError = class extends YAMLError {
          constructor(source, message) {
            super("YAMLReferenceError", source, message);
          }
        };
        var YAMLSemanticError = class extends YAMLError {
          constructor(source, message) {
            super("YAMLSemanticError", source, message);
          }
        };
        var YAMLSyntaxError = class extends YAMLError {
          constructor(source, message) {
            super("YAMLSyntaxError", source, message);
          }
        };
        var YAMLWarning = class extends YAMLError {
          constructor(source, message) {
            super("YAMLWarning", source, message);
          }
        };
        function _defineProperty(obj, key, value) {
          if (key in obj) {
            Object.defineProperty(obj, key, {
              value,
              enumerable: true,
              configurable: true,
              writable: true
            });
          } else {
            obj[key] = value;
          }
          return obj;
        }
        var PlainValue = class extends Node {
          static endOfLine(src, start, inFlow) {
            let ch = src[start];
            let offset = start;
            while (ch && ch !== "\n") {
              if (inFlow && (ch === "[" || ch === "]" || ch === "{" || ch === "}" || ch === ","))
                break;
              const next = src[offset + 1];
              if (ch === ":" && (!next || next === "\n" || next === "	" || next === " " || inFlow && next === ","))
                break;
              if ((ch === " " || ch === "	") && next === "#")
                break;
              offset += 1;
              ch = next;
            }
            return offset;
          }
          get strValue() {
            if (!this.valueRange || !this.context)
              return null;
            let {
              start,
              end
            } = this.valueRange;
            const {
              src
            } = this.context;
            let ch = src[end - 1];
            while (start < end && (ch === "\n" || ch === "	" || ch === " "))
              ch = src[--end - 1];
            let str = "";
            for (let i2 = start; i2 < end; ++i2) {
              const ch2 = src[i2];
              if (ch2 === "\n") {
                const {
                  fold,
                  offset
                } = Node.foldNewline(src, i2, -1);
                str += fold;
                i2 = offset;
              } else if (ch2 === " " || ch2 === "	") {
                const wsStart = i2;
                let next = src[i2 + 1];
                while (i2 < end && (next === " " || next === "	")) {
                  i2 += 1;
                  next = src[i2 + 1];
                }
                if (next !== "\n")
                  str += i2 > wsStart ? src.slice(wsStart, i2 + 1) : ch2;
              } else {
                str += ch2;
              }
            }
            const ch0 = src[start];
            switch (ch0) {
              case "	": {
                const msg = "Plain value cannot start with a tab character";
                const errors = [new YAMLSemanticError(this, msg)];
                return {
                  errors,
                  str
                };
              }
              case "@":
              case "`": {
                const msg = `Plain value cannot start with reserved character ${ch0}`;
                const errors = [new YAMLSemanticError(this, msg)];
                return {
                  errors,
                  str
                };
              }
              default:
                return str;
            }
          }
          parseBlockValue(start) {
            const {
              indent,
              inFlow,
              src
            } = this.context;
            let offset = start;
            let valueEnd = start;
            for (let ch = src[offset]; ch === "\n"; ch = src[offset]) {
              if (Node.atDocumentBoundary(src, offset + 1))
                break;
              const end = Node.endOfBlockIndent(src, indent, offset + 1);
              if (end === null || src[end] === "#")
                break;
              if (src[end] === "\n") {
                offset = end;
              } else {
                valueEnd = PlainValue.endOfLine(src, end, inFlow);
                offset = valueEnd;
              }
            }
            if (this.valueRange.isEmpty())
              this.valueRange.start = start;
            this.valueRange.end = valueEnd;
            return valueEnd;
          }
          parse(context2, start) {
            this.context = context2;
            const {
              inFlow,
              src
            } = context2;
            let offset = start;
            const ch = src[offset];
            if (ch && ch !== "#" && ch !== "\n") {
              offset = PlainValue.endOfLine(src, start, inFlow);
            }
            this.valueRange = new Range(start, offset);
            offset = Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            if (!this.hasComment || this.valueRange.isEmpty()) {
              offset = this.parseBlockValue(offset);
            }
            return offset;
          }
        };
        exports2.Char = Char;
        exports2.Node = Node;
        exports2.PlainValue = PlainValue;
        exports2.Range = Range;
        exports2.Type = Type;
        exports2.YAMLError = YAMLError;
        exports2.YAMLReferenceError = YAMLReferenceError;
        exports2.YAMLSemanticError = YAMLSemanticError;
        exports2.YAMLSyntaxError = YAMLSyntaxError;
        exports2.YAMLWarning = YAMLWarning;
        exports2._defineProperty = _defineProperty;
        exports2.defaultTagPrefix = defaultTagPrefix;
        exports2.defaultTags = defaultTags;
      }
    });
    var require_parse_cst = __commonJS2({
      "node_modules/yaml/dist/parse-cst.js"(exports2) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        var BlankLine = class extends PlainValue.Node {
          constructor() {
            super(PlainValue.Type.BLANK_LINE);
          }
          get includesTrailingLines() {
            return true;
          }
          parse(context2, start) {
            this.context = context2;
            this.range = new PlainValue.Range(start, start + 1);
            return start + 1;
          }
        };
        var CollectionItem = class extends PlainValue.Node {
          constructor(type, props) {
            super(type, props);
            this.node = null;
          }
          get includesTrailingLines() {
            return !!this.node && this.node.includesTrailingLines;
          }
          parse(context2, start) {
            this.context = context2;
            const {
              parseNode,
              src
            } = context2;
            let {
              atLineStart,
              lineStart
            } = context2;
            if (!atLineStart && this.type === PlainValue.Type.SEQ_ITEM)
              this.error = new PlainValue.YAMLSemanticError(this, "Sequence items must not have preceding content on the same line");
            const indent = atLineStart ? start - lineStart : context2.indent;
            let offset = PlainValue.Node.endOfWhiteSpace(src, start + 1);
            let ch = src[offset];
            const inlineComment = ch === "#";
            const comments = [];
            let blankLine = null;
            while (ch === "\n" || ch === "#") {
              if (ch === "#") {
                const end2 = PlainValue.Node.endOfLine(src, offset + 1);
                comments.push(new PlainValue.Range(offset, end2));
                offset = end2;
              } else {
                atLineStart = true;
                lineStart = offset + 1;
                const wsEnd = PlainValue.Node.endOfWhiteSpace(src, lineStart);
                if (src[wsEnd] === "\n" && comments.length === 0) {
                  blankLine = new BlankLine();
                  lineStart = blankLine.parse({
                    src
                  }, lineStart);
                }
                offset = PlainValue.Node.endOfIndent(src, lineStart);
              }
              ch = src[offset];
            }
            if (PlainValue.Node.nextNodeIsIndented(ch, offset - (lineStart + indent), this.type !== PlainValue.Type.SEQ_ITEM)) {
              this.node = parseNode({
                atLineStart,
                inCollection: false,
                indent,
                lineStart,
                parent: this
              }, offset);
            } else if (ch && lineStart > start + 1) {
              offset = lineStart - 1;
            }
            if (this.node) {
              if (blankLine) {
                const items = context2.parent.items || context2.parent.contents;
                if (items)
                  items.push(blankLine);
              }
              if (comments.length)
                Array.prototype.push.apply(this.props, comments);
              offset = this.node.range.end;
            } else {
              if (inlineComment) {
                const c = comments[0];
                this.props.push(c);
                offset = c.end;
              } else {
                offset = PlainValue.Node.endOfLine(src, start + 1);
              }
            }
            const end = this.node ? this.node.valueRange.end : offset;
            this.valueRange = new PlainValue.Range(start, end);
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            return this.node ? this.node.setOrigRanges(cr, offset) : offset;
          }
          toString() {
            const {
              context: {
                src
              },
              node,
              range,
              value
            } = this;
            if (value != null)
              return value;
            const str = node ? src.slice(range.start, node.range.start) + String(node) : src.slice(range.start, range.end);
            return PlainValue.Node.addStringTerminator(src, range.end, str);
          }
        };
        var Comment = class extends PlainValue.Node {
          constructor() {
            super(PlainValue.Type.COMMENT);
          }
          parse(context2, start) {
            this.context = context2;
            const offset = this.parseComment(start);
            this.range = new PlainValue.Range(start, offset);
            return offset;
          }
        };
        function grabCollectionEndComments(node) {
          let cnode = node;
          while (cnode instanceof CollectionItem)
            cnode = cnode.node;
          if (!(cnode instanceof Collection2))
            return null;
          const len = cnode.items.length;
          let ci = -1;
          for (let i2 = len - 1; i2 >= 0; --i2) {
            const n = cnode.items[i2];
            if (n.type === PlainValue.Type.COMMENT) {
              const {
                indent,
                lineStart
              } = n.context;
              if (indent > 0 && n.range.start >= lineStart + indent)
                break;
              ci = i2;
            } else if (n.type === PlainValue.Type.BLANK_LINE)
              ci = i2;
            else
              break;
          }
          if (ci === -1)
            return null;
          const ca = cnode.items.splice(ci, len - ci);
          const prevEnd = ca[0].range.start;
          while (true) {
            cnode.range.end = prevEnd;
            if (cnode.valueRange && cnode.valueRange.end > prevEnd)
              cnode.valueRange.end = prevEnd;
            if (cnode === node)
              break;
            cnode = cnode.context.parent;
          }
          return ca;
        }
        var Collection2 = class extends PlainValue.Node {
          static nextContentHasIndent(src, offset, indent) {
            const lineStart = PlainValue.Node.endOfLine(src, offset) + 1;
            offset = PlainValue.Node.endOfWhiteSpace(src, lineStart);
            const ch = src[offset];
            if (!ch)
              return false;
            if (offset >= lineStart + indent)
              return true;
            if (ch !== "#" && ch !== "\n")
              return false;
            return Collection2.nextContentHasIndent(src, offset, indent);
          }
          constructor(firstItem) {
            super(firstItem.type === PlainValue.Type.SEQ_ITEM ? PlainValue.Type.SEQ : PlainValue.Type.MAP);
            for (let i2 = firstItem.props.length - 1; i2 >= 0; --i2) {
              if (firstItem.props[i2].start < firstItem.context.lineStart) {
                this.props = firstItem.props.slice(0, i2 + 1);
                firstItem.props = firstItem.props.slice(i2 + 1);
                const itemRange = firstItem.props[0] || firstItem.valueRange;
                firstItem.range.start = itemRange.start;
                break;
              }
            }
            this.items = [firstItem];
            const ec = grabCollectionEndComments(firstItem);
            if (ec)
              Array.prototype.push.apply(this.items, ec);
          }
          get includesTrailingLines() {
            return this.items.length > 0;
          }
          parse(context2, start) {
            this.context = context2;
            const {
              parseNode,
              src
            } = context2;
            let lineStart = PlainValue.Node.startOfLine(src, start);
            const firstItem = this.items[0];
            firstItem.context.parent = this;
            this.valueRange = PlainValue.Range.copy(firstItem.valueRange);
            const indent = firstItem.range.start - firstItem.context.lineStart;
            let offset = start;
            offset = PlainValue.Node.normalizeOffset(src, offset);
            let ch = src[offset];
            let atLineStart = PlainValue.Node.endOfWhiteSpace(src, lineStart) === offset;
            let prevIncludesTrailingLines = false;
            while (ch) {
              while (ch === "\n" || ch === "#") {
                if (atLineStart && ch === "\n" && !prevIncludesTrailingLines) {
                  const blankLine = new BlankLine();
                  offset = blankLine.parse({
                    src
                  }, offset);
                  this.valueRange.end = offset;
                  if (offset >= src.length) {
                    ch = null;
                    break;
                  }
                  this.items.push(blankLine);
                  offset -= 1;
                } else if (ch === "#") {
                  if (offset < lineStart + indent && !Collection2.nextContentHasIndent(src, offset, indent)) {
                    return offset;
                  }
                  const comment = new Comment();
                  offset = comment.parse({
                    indent,
                    lineStart,
                    src
                  }, offset);
                  this.items.push(comment);
                  this.valueRange.end = offset;
                  if (offset >= src.length) {
                    ch = null;
                    break;
                  }
                }
                lineStart = offset + 1;
                offset = PlainValue.Node.endOfIndent(src, lineStart);
                if (PlainValue.Node.atBlank(src, offset)) {
                  const wsEnd = PlainValue.Node.endOfWhiteSpace(src, offset);
                  const next = src[wsEnd];
                  if (!next || next === "\n" || next === "#") {
                    offset = wsEnd;
                  }
                }
                ch = src[offset];
                atLineStart = true;
              }
              if (!ch) {
                break;
              }
              if (offset !== lineStart + indent && (atLineStart || ch !== ":")) {
                if (offset < lineStart + indent) {
                  if (lineStart > start)
                    offset = lineStart;
                  break;
                } else if (!this.error) {
                  const msg = "All collection items must start at the same column";
                  this.error = new PlainValue.YAMLSyntaxError(this, msg);
                }
              }
              if (firstItem.type === PlainValue.Type.SEQ_ITEM) {
                if (ch !== "-") {
                  if (lineStart > start)
                    offset = lineStart;
                  break;
                }
              } else if (ch === "-" && !this.error) {
                const next = src[offset + 1];
                if (!next || next === "\n" || next === "	" || next === " ") {
                  const msg = "A collection cannot be both a mapping and a sequence";
                  this.error = new PlainValue.YAMLSyntaxError(this, msg);
                }
              }
              const node = parseNode({
                atLineStart,
                inCollection: true,
                indent,
                lineStart,
                parent: this
              }, offset);
              if (!node)
                return offset;
              this.items.push(node);
              this.valueRange.end = node.valueRange.end;
              offset = PlainValue.Node.normalizeOffset(src, node.range.end);
              ch = src[offset];
              atLineStart = false;
              prevIncludesTrailingLines = node.includesTrailingLines;
              if (ch) {
                let ls = offset - 1;
                let prev = src[ls];
                while (prev === " " || prev === "	")
                  prev = src[--ls];
                if (prev === "\n") {
                  lineStart = ls + 1;
                  atLineStart = true;
                }
              }
              const ec = grabCollectionEndComments(node);
              if (ec)
                Array.prototype.push.apply(this.items, ec);
            }
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            this.items.forEach((node) => {
              offset = node.setOrigRanges(cr, offset);
            });
            return offset;
          }
          toString() {
            const {
              context: {
                src
              },
              items,
              range,
              value
            } = this;
            if (value != null)
              return value;
            let str = src.slice(range.start, items[0].range.start) + String(items[0]);
            for (let i2 = 1; i2 < items.length; ++i2) {
              const item = items[i2];
              const {
                atLineStart,
                indent
              } = item.context;
              if (atLineStart)
                for (let i22 = 0; i22 < indent; ++i22)
                  str += " ";
              str += String(item);
            }
            return PlainValue.Node.addStringTerminator(src, range.end, str);
          }
        };
        var Directive = class extends PlainValue.Node {
          constructor() {
            super(PlainValue.Type.DIRECTIVE);
            this.name = null;
          }
          get parameters() {
            const raw = this.rawValue;
            return raw ? raw.trim().split(/[ \t]+/) : [];
          }
          parseName(start) {
            const {
              src
            } = this.context;
            let offset = start;
            let ch = src[offset];
            while (ch && ch !== "\n" && ch !== "	" && ch !== " ")
              ch = src[offset += 1];
            this.name = src.slice(start, offset);
            return offset;
          }
          parseParameters(start) {
            const {
              src
            } = this.context;
            let offset = start;
            let ch = src[offset];
            while (ch && ch !== "\n" && ch !== "#")
              ch = src[offset += 1];
            this.valueRange = new PlainValue.Range(start, offset);
            return offset;
          }
          parse(context2, start) {
            this.context = context2;
            let offset = this.parseName(start + 1);
            offset = this.parseParameters(offset);
            offset = this.parseComment(offset);
            this.range = new PlainValue.Range(start, offset);
            return offset;
          }
        };
        var Document = class extends PlainValue.Node {
          static startCommentOrEndBlankLine(src, start) {
            const offset = PlainValue.Node.endOfWhiteSpace(src, start);
            const ch = src[offset];
            return ch === "#" || ch === "\n" ? offset : start;
          }
          constructor() {
            super(PlainValue.Type.DOCUMENT);
            this.directives = null;
            this.contents = null;
            this.directivesEndMarker = null;
            this.documentEndMarker = null;
          }
          parseDirectives(start) {
            const {
              src
            } = this.context;
            this.directives = [];
            let atLineStart = true;
            let hasDirectives = false;
            let offset = start;
            while (!PlainValue.Node.atDocumentBoundary(src, offset, PlainValue.Char.DIRECTIVES_END)) {
              offset = Document.startCommentOrEndBlankLine(src, offset);
              switch (src[offset]) {
                case "\n":
                  if (atLineStart) {
                    const blankLine = new BlankLine();
                    offset = blankLine.parse({
                      src
                    }, offset);
                    if (offset < src.length) {
                      this.directives.push(blankLine);
                    }
                  } else {
                    offset += 1;
                    atLineStart = true;
                  }
                  break;
                case "#":
                  {
                    const comment = new Comment();
                    offset = comment.parse({
                      src
                    }, offset);
                    this.directives.push(comment);
                    atLineStart = false;
                  }
                  break;
                case "%":
                  {
                    const directive = new Directive();
                    offset = directive.parse({
                      parent: this,
                      src
                    }, offset);
                    this.directives.push(directive);
                    hasDirectives = true;
                    atLineStart = false;
                  }
                  break;
                default:
                  if (hasDirectives) {
                    this.error = new PlainValue.YAMLSemanticError(this, "Missing directives-end indicator line");
                  } else if (this.directives.length > 0) {
                    this.contents = this.directives;
                    this.directives = [];
                  }
                  return offset;
              }
            }
            if (src[offset]) {
              this.directivesEndMarker = new PlainValue.Range(offset, offset + 3);
              return offset + 3;
            }
            if (hasDirectives) {
              this.error = new PlainValue.YAMLSemanticError(this, "Missing directives-end indicator line");
            } else if (this.directives.length > 0) {
              this.contents = this.directives;
              this.directives = [];
            }
            return offset;
          }
          parseContents(start) {
            const {
              parseNode,
              src
            } = this.context;
            if (!this.contents)
              this.contents = [];
            let lineStart = start;
            while (src[lineStart - 1] === "-")
              lineStart -= 1;
            let offset = PlainValue.Node.endOfWhiteSpace(src, start);
            let atLineStart = lineStart === start;
            this.valueRange = new PlainValue.Range(offset);
            while (!PlainValue.Node.atDocumentBoundary(src, offset, PlainValue.Char.DOCUMENT_END)) {
              switch (src[offset]) {
                case "\n":
                  if (atLineStart) {
                    const blankLine = new BlankLine();
                    offset = blankLine.parse({
                      src
                    }, offset);
                    if (offset < src.length) {
                      this.contents.push(blankLine);
                    }
                  } else {
                    offset += 1;
                    atLineStart = true;
                  }
                  lineStart = offset;
                  break;
                case "#":
                  {
                    const comment = new Comment();
                    offset = comment.parse({
                      src
                    }, offset);
                    this.contents.push(comment);
                    atLineStart = false;
                  }
                  break;
                default: {
                  const iEnd = PlainValue.Node.endOfIndent(src, offset);
                  const context2 = {
                    atLineStart,
                    indent: -1,
                    inFlow: false,
                    inCollection: false,
                    lineStart,
                    parent: this
                  };
                  const node = parseNode(context2, iEnd);
                  if (!node)
                    return this.valueRange.end = iEnd;
                  this.contents.push(node);
                  offset = node.range.end;
                  atLineStart = false;
                  const ec = grabCollectionEndComments(node);
                  if (ec)
                    Array.prototype.push.apply(this.contents, ec);
                }
              }
              offset = Document.startCommentOrEndBlankLine(src, offset);
            }
            this.valueRange.end = offset;
            if (src[offset]) {
              this.documentEndMarker = new PlainValue.Range(offset, offset + 3);
              offset += 3;
              if (src[offset]) {
                offset = PlainValue.Node.endOfWhiteSpace(src, offset);
                if (src[offset] === "#") {
                  const comment = new Comment();
                  offset = comment.parse({
                    src
                  }, offset);
                  this.contents.push(comment);
                }
                switch (src[offset]) {
                  case "\n":
                    offset += 1;
                    break;
                  case void 0:
                    break;
                  default:
                    this.error = new PlainValue.YAMLSyntaxError(this, "Document end marker line cannot have a non-comment suffix");
                }
              }
            }
            return offset;
          }
          parse(context2, start) {
            context2.root = this;
            this.context = context2;
            const {
              src
            } = context2;
            let offset = src.charCodeAt(start) === 65279 ? start + 1 : start;
            offset = this.parseDirectives(offset);
            offset = this.parseContents(offset);
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            this.directives.forEach((node) => {
              offset = node.setOrigRanges(cr, offset);
            });
            if (this.directivesEndMarker)
              offset = this.directivesEndMarker.setOrigRange(cr, offset);
            this.contents.forEach((node) => {
              offset = node.setOrigRanges(cr, offset);
            });
            if (this.documentEndMarker)
              offset = this.documentEndMarker.setOrigRange(cr, offset);
            return offset;
          }
          toString() {
            const {
              contents,
              directives,
              value
            } = this;
            if (value != null)
              return value;
            let str = directives.join("");
            if (contents.length > 0) {
              if (directives.length > 0 || contents[0].type === PlainValue.Type.COMMENT)
                str += "---\n";
              str += contents.join("");
            }
            if (str[str.length - 1] !== "\n")
              str += "\n";
            return str;
          }
        };
        var Alias = class extends PlainValue.Node {
          parse(context2, start) {
            this.context = context2;
            const {
              src
            } = context2;
            let offset = PlainValue.Node.endOfIdentifier(src, start + 1);
            this.valueRange = new PlainValue.Range(start + 1, offset);
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            return offset;
          }
        };
        var Chomp = {
          CLIP: "CLIP",
          KEEP: "KEEP",
          STRIP: "STRIP"
        };
        var BlockValue = class extends PlainValue.Node {
          constructor(type, props) {
            super(type, props);
            this.blockIndent = null;
            this.chomping = Chomp.CLIP;
            this.header = null;
          }
          get includesTrailingLines() {
            return this.chomping === Chomp.KEEP;
          }
          get strValue() {
            if (!this.valueRange || !this.context)
              return null;
            let {
              start,
              end
            } = this.valueRange;
            const {
              indent,
              src
            } = this.context;
            if (this.valueRange.isEmpty())
              return "";
            let lastNewLine = null;
            let ch = src[end - 1];
            while (ch === "\n" || ch === "	" || ch === " ") {
              end -= 1;
              if (end <= start) {
                if (this.chomping === Chomp.KEEP)
                  break;
                else
                  return "";
              }
              if (ch === "\n")
                lastNewLine = end;
              ch = src[end - 1];
            }
            let keepStart = end + 1;
            if (lastNewLine) {
              if (this.chomping === Chomp.KEEP) {
                keepStart = lastNewLine;
                end = this.valueRange.end;
              } else {
                end = lastNewLine;
              }
            }
            const bi = indent + this.blockIndent;
            const folded = this.type === PlainValue.Type.BLOCK_FOLDED;
            let atStart = true;
            let str = "";
            let sep = "";
            let prevMoreIndented = false;
            for (let i2 = start; i2 < end; ++i2) {
              for (let j = 0; j < bi; ++j) {
                if (src[i2] !== " ")
                  break;
                i2 += 1;
              }
              const ch2 = src[i2];
              if (ch2 === "\n") {
                if (sep === "\n")
                  str += "\n";
                else
                  sep = "\n";
              } else {
                const lineEnd = PlainValue.Node.endOfLine(src, i2);
                const line = src.slice(i2, lineEnd);
                i2 = lineEnd;
                if (folded && (ch2 === " " || ch2 === "	") && i2 < keepStart) {
                  if (sep === " ")
                    sep = "\n";
                  else if (!prevMoreIndented && !atStart && sep === "\n")
                    sep = "\n\n";
                  str += sep + line;
                  sep = lineEnd < end && src[lineEnd] || "";
                  prevMoreIndented = true;
                } else {
                  str += sep + line;
                  sep = folded && i2 < keepStart ? " " : "\n";
                  prevMoreIndented = false;
                }
                if (atStart && line !== "")
                  atStart = false;
              }
            }
            return this.chomping === Chomp.STRIP ? str : str + "\n";
          }
          parseBlockHeader(start) {
            const {
              src
            } = this.context;
            let offset = start + 1;
            let bi = "";
            while (true) {
              const ch = src[offset];
              switch (ch) {
                case "-":
                  this.chomping = Chomp.STRIP;
                  break;
                case "+":
                  this.chomping = Chomp.KEEP;
                  break;
                case "0":
                case "1":
                case "2":
                case "3":
                case "4":
                case "5":
                case "6":
                case "7":
                case "8":
                case "9":
                  bi += ch;
                  break;
                default:
                  this.blockIndent = Number(bi) || null;
                  this.header = new PlainValue.Range(start, offset);
                  return offset;
              }
              offset += 1;
            }
          }
          parseBlockValue(start) {
            const {
              indent,
              src
            } = this.context;
            const explicit = !!this.blockIndent;
            let offset = start;
            let valueEnd = start;
            let minBlockIndent = 1;
            for (let ch = src[offset]; ch === "\n"; ch = src[offset]) {
              offset += 1;
              if (PlainValue.Node.atDocumentBoundary(src, offset))
                break;
              const end = PlainValue.Node.endOfBlockIndent(src, indent, offset);
              if (end === null)
                break;
              const ch2 = src[end];
              const lineIndent = end - (offset + indent);
              if (!this.blockIndent) {
                if (src[end] !== "\n") {
                  if (lineIndent < minBlockIndent) {
                    const msg = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
                    this.error = new PlainValue.YAMLSemanticError(this, msg);
                  }
                  this.blockIndent = lineIndent;
                } else if (lineIndent > minBlockIndent) {
                  minBlockIndent = lineIndent;
                }
              } else if (ch2 && ch2 !== "\n" && lineIndent < this.blockIndent) {
                if (src[end] === "#")
                  break;
                if (!this.error) {
                  const src2 = explicit ? "explicit indentation indicator" : "first line";
                  const msg = `Block scalars must not be less indented than their ${src2}`;
                  this.error = new PlainValue.YAMLSemanticError(this, msg);
                }
              }
              if (src[end] === "\n") {
                offset = end;
              } else {
                offset = valueEnd = PlainValue.Node.endOfLine(src, end);
              }
            }
            if (this.chomping !== Chomp.KEEP) {
              offset = src[valueEnd] ? valueEnd + 1 : valueEnd;
            }
            this.valueRange = new PlainValue.Range(start + 1, offset);
            return offset;
          }
          parse(context2, start) {
            this.context = context2;
            const {
              src
            } = context2;
            let offset = this.parseBlockHeader(start);
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            offset = this.parseBlockValue(offset);
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            return this.header ? this.header.setOrigRange(cr, offset) : offset;
          }
        };
        var FlowCollection = class extends PlainValue.Node {
          constructor(type, props) {
            super(type, props);
            this.items = null;
          }
          prevNodeIsJsonLike(idx = this.items.length) {
            const node = this.items[idx - 1];
            return !!node && (node.jsonLike || node.type === PlainValue.Type.COMMENT && this.prevNodeIsJsonLike(idx - 1));
          }
          parse(context2, start) {
            this.context = context2;
            const {
              parseNode,
              src
            } = context2;
            let {
              indent,
              lineStart
            } = context2;
            let char = src[start];
            this.items = [{
              char,
              offset: start
            }];
            let offset = PlainValue.Node.endOfWhiteSpace(src, start + 1);
            char = src[offset];
            while (char && char !== "]" && char !== "}") {
              switch (char) {
                case "\n":
                  {
                    lineStart = offset + 1;
                    const wsEnd = PlainValue.Node.endOfWhiteSpace(src, lineStart);
                    if (src[wsEnd] === "\n") {
                      const blankLine = new BlankLine();
                      lineStart = blankLine.parse({
                        src
                      }, lineStart);
                      this.items.push(blankLine);
                    }
                    offset = PlainValue.Node.endOfIndent(src, lineStart);
                    if (offset <= lineStart + indent) {
                      char = src[offset];
                      if (offset < lineStart + indent || char !== "]" && char !== "}") {
                        const msg = "Insufficient indentation in flow collection";
                        this.error = new PlainValue.YAMLSemanticError(this, msg);
                      }
                    }
                  }
                  break;
                case ",":
                  {
                    this.items.push({
                      char,
                      offset
                    });
                    offset += 1;
                  }
                  break;
                case "#":
                  {
                    const comment = new Comment();
                    offset = comment.parse({
                      src
                    }, offset);
                    this.items.push(comment);
                  }
                  break;
                case "?":
                case ":": {
                  const next = src[offset + 1];
                  if (next === "\n" || next === "	" || next === " " || next === "," || char === ":" && this.prevNodeIsJsonLike()) {
                    this.items.push({
                      char,
                      offset
                    });
                    offset += 1;
                    break;
                  }
                }
                default: {
                  const node = parseNode({
                    atLineStart: false,
                    inCollection: false,
                    inFlow: true,
                    indent: -1,
                    lineStart,
                    parent: this
                  }, offset);
                  if (!node) {
                    this.valueRange = new PlainValue.Range(start, offset);
                    return offset;
                  }
                  this.items.push(node);
                  offset = PlainValue.Node.normalizeOffset(src, node.range.end);
                }
              }
              offset = PlainValue.Node.endOfWhiteSpace(src, offset);
              char = src[offset];
            }
            this.valueRange = new PlainValue.Range(start, offset + 1);
            if (char) {
              this.items.push({
                char,
                offset
              });
              offset = PlainValue.Node.endOfWhiteSpace(src, offset + 1);
              offset = this.parseComment(offset);
            }
            return offset;
          }
          setOrigRanges(cr, offset) {
            offset = super.setOrigRanges(cr, offset);
            this.items.forEach((node) => {
              if (node instanceof PlainValue.Node) {
                offset = node.setOrigRanges(cr, offset);
              } else if (cr.length === 0) {
                node.origOffset = node.offset;
              } else {
                let i2 = offset;
                while (i2 < cr.length) {
                  if (cr[i2] > node.offset)
                    break;
                  else
                    ++i2;
                }
                node.origOffset = node.offset + i2;
                offset = i2;
              }
            });
            return offset;
          }
          toString() {
            const {
              context: {
                src
              },
              items,
              range,
              value
            } = this;
            if (value != null)
              return value;
            const nodes = items.filter((item) => item instanceof PlainValue.Node);
            let str = "";
            let prevEnd = range.start;
            nodes.forEach((node) => {
              const prefix2 = src.slice(prevEnd, node.range.start);
              prevEnd = node.range.end;
              str += prefix2 + String(node);
              if (str[str.length - 1] === "\n" && src[prevEnd - 1] !== "\n" && src[prevEnd] === "\n") {
                prevEnd += 1;
              }
            });
            str += src.slice(prevEnd, range.end);
            return PlainValue.Node.addStringTerminator(src, range.end, str);
          }
        };
        var QuoteDouble = class extends PlainValue.Node {
          static endOfQuote(src, offset) {
            let ch = src[offset];
            while (ch && ch !== '"') {
              offset += ch === "\\" ? 2 : 1;
              ch = src[offset];
            }
            return offset + 1;
          }
          get strValue() {
            if (!this.valueRange || !this.context)
              return null;
            const errors = [];
            const {
              start,
              end
            } = this.valueRange;
            const {
              indent,
              src
            } = this.context;
            if (src[end - 1] !== '"')
              errors.push(new PlainValue.YAMLSyntaxError(this, 'Missing closing "quote'));
            let str = "";
            for (let i2 = start + 1; i2 < end - 1; ++i2) {
              const ch = src[i2];
              if (ch === "\n") {
                if (PlainValue.Node.atDocumentBoundary(src, i2 + 1))
                  errors.push(new PlainValue.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
                const {
                  fold,
                  offset,
                  error
                } = PlainValue.Node.foldNewline(src, i2, indent);
                str += fold;
                i2 = offset;
                if (error)
                  errors.push(new PlainValue.YAMLSemanticError(this, "Multi-line double-quoted string needs to be sufficiently indented"));
              } else if (ch === "\\") {
                i2 += 1;
                switch (src[i2]) {
                  case "0":
                    str += "\0";
                    break;
                  case "a":
                    str += "\x07";
                    break;
                  case "b":
                    str += "\b";
                    break;
                  case "e":
                    str += "\x1B";
                    break;
                  case "f":
                    str += "\f";
                    break;
                  case "n":
                    str += "\n";
                    break;
                  case "r":
                    str += "\r";
                    break;
                  case "t":
                    str += "	";
                    break;
                  case "v":
                    str += "\v";
                    break;
                  case "N":
                    str += "\x85";
                    break;
                  case "_":
                    str += "\xA0";
                    break;
                  case "L":
                    str += "\u2028";
                    break;
                  case "P":
                    str += "\u2029";
                    break;
                  case " ":
                    str += " ";
                    break;
                  case '"':
                    str += '"';
                    break;
                  case "/":
                    str += "/";
                    break;
                  case "\\":
                    str += "\\";
                    break;
                  case "	":
                    str += "	";
                    break;
                  case "x":
                    str += this.parseCharCode(i2 + 1, 2, errors);
                    i2 += 2;
                    break;
                  case "u":
                    str += this.parseCharCode(i2 + 1, 4, errors);
                    i2 += 4;
                    break;
                  case "U":
                    str += this.parseCharCode(i2 + 1, 8, errors);
                    i2 += 8;
                    break;
                  case "\n":
                    while (src[i2 + 1] === " " || src[i2 + 1] === "	")
                      i2 += 1;
                    break;
                  default:
                    errors.push(new PlainValue.YAMLSyntaxError(this, `Invalid escape sequence ${src.substr(i2 - 1, 2)}`));
                    str += "\\" + src[i2];
                }
              } else if (ch === " " || ch === "	") {
                const wsStart = i2;
                let next = src[i2 + 1];
                while (next === " " || next === "	") {
                  i2 += 1;
                  next = src[i2 + 1];
                }
                if (next !== "\n")
                  str += i2 > wsStart ? src.slice(wsStart, i2 + 1) : ch;
              } else {
                str += ch;
              }
            }
            return errors.length > 0 ? {
              errors,
              str
            } : str;
          }
          parseCharCode(offset, length, errors) {
            const {
              src
            } = this.context;
            const cc = src.substr(offset, length);
            const ok = cc.length === length && /^[0-9a-fA-F]+$/.test(cc);
            const code = ok ? parseInt(cc, 16) : NaN;
            if (isNaN(code)) {
              errors.push(new PlainValue.YAMLSyntaxError(this, `Invalid escape sequence ${src.substr(offset - 2, length + 2)}`));
              return src.substr(offset - 2, length + 2);
            }
            return String.fromCodePoint(code);
          }
          parse(context2, start) {
            this.context = context2;
            const {
              src
            } = context2;
            let offset = QuoteDouble.endOfQuote(src, start + 1);
            this.valueRange = new PlainValue.Range(start, offset);
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            return offset;
          }
        };
        var QuoteSingle = class extends PlainValue.Node {
          static endOfQuote(src, offset) {
            let ch = src[offset];
            while (ch) {
              if (ch === "'") {
                if (src[offset + 1] !== "'")
                  break;
                ch = src[offset += 2];
              } else {
                ch = src[offset += 1];
              }
            }
            return offset + 1;
          }
          get strValue() {
            if (!this.valueRange || !this.context)
              return null;
            const errors = [];
            const {
              start,
              end
            } = this.valueRange;
            const {
              indent,
              src
            } = this.context;
            if (src[end - 1] !== "'")
              errors.push(new PlainValue.YAMLSyntaxError(this, "Missing closing 'quote"));
            let str = "";
            for (let i2 = start + 1; i2 < end - 1; ++i2) {
              const ch = src[i2];
              if (ch === "\n") {
                if (PlainValue.Node.atDocumentBoundary(src, i2 + 1))
                  errors.push(new PlainValue.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
                const {
                  fold,
                  offset,
                  error
                } = PlainValue.Node.foldNewline(src, i2, indent);
                str += fold;
                i2 = offset;
                if (error)
                  errors.push(new PlainValue.YAMLSemanticError(this, "Multi-line single-quoted string needs to be sufficiently indented"));
              } else if (ch === "'") {
                str += ch;
                i2 += 1;
                if (src[i2] !== "'")
                  errors.push(new PlainValue.YAMLSyntaxError(this, "Unescaped single quote? This should not happen."));
              } else if (ch === " " || ch === "	") {
                const wsStart = i2;
                let next = src[i2 + 1];
                while (next === " " || next === "	") {
                  i2 += 1;
                  next = src[i2 + 1];
                }
                if (next !== "\n")
                  str += i2 > wsStart ? src.slice(wsStart, i2 + 1) : ch;
              } else {
                str += ch;
              }
            }
            return errors.length > 0 ? {
              errors,
              str
            } : str;
          }
          parse(context2, start) {
            this.context = context2;
            const {
              src
            } = context2;
            let offset = QuoteSingle.endOfQuote(src, start + 1);
            this.valueRange = new PlainValue.Range(start, offset);
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            offset = this.parseComment(offset);
            return offset;
          }
        };
        function createNewNode(type, props) {
          switch (type) {
            case PlainValue.Type.ALIAS:
              return new Alias(type, props);
            case PlainValue.Type.BLOCK_FOLDED:
            case PlainValue.Type.BLOCK_LITERAL:
              return new BlockValue(type, props);
            case PlainValue.Type.FLOW_MAP:
            case PlainValue.Type.FLOW_SEQ:
              return new FlowCollection(type, props);
            case PlainValue.Type.MAP_KEY:
            case PlainValue.Type.MAP_VALUE:
            case PlainValue.Type.SEQ_ITEM:
              return new CollectionItem(type, props);
            case PlainValue.Type.COMMENT:
            case PlainValue.Type.PLAIN:
              return new PlainValue.PlainValue(type, props);
            case PlainValue.Type.QUOTE_DOUBLE:
              return new QuoteDouble(type, props);
            case PlainValue.Type.QUOTE_SINGLE:
              return new QuoteSingle(type, props);
            default:
              return null;
          }
        }
        var ParseContext = class {
          static parseType(src, offset, inFlow) {
            switch (src[offset]) {
              case "*":
                return PlainValue.Type.ALIAS;
              case ">":
                return PlainValue.Type.BLOCK_FOLDED;
              case "|":
                return PlainValue.Type.BLOCK_LITERAL;
              case "{":
                return PlainValue.Type.FLOW_MAP;
              case "[":
                return PlainValue.Type.FLOW_SEQ;
              case "?":
                return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.MAP_KEY : PlainValue.Type.PLAIN;
              case ":":
                return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.MAP_VALUE : PlainValue.Type.PLAIN;
              case "-":
                return !inFlow && PlainValue.Node.atBlank(src, offset + 1, true) ? PlainValue.Type.SEQ_ITEM : PlainValue.Type.PLAIN;
              case '"':
                return PlainValue.Type.QUOTE_DOUBLE;
              case "'":
                return PlainValue.Type.QUOTE_SINGLE;
              default:
                return PlainValue.Type.PLAIN;
            }
          }
          constructor(orig = {}, {
            atLineStart,
            inCollection,
            inFlow,
            indent,
            lineStart,
            parent
          } = {}) {
            PlainValue._defineProperty(this, "parseNode", (overlay, start) => {
              if (PlainValue.Node.atDocumentBoundary(this.src, start))
                return null;
              const context2 = new ParseContext(this, overlay);
              const {
                props,
                type,
                valueStart
              } = context2.parseProps(start);
              const node = createNewNode(type, props);
              let offset = node.parse(context2, valueStart);
              node.range = new PlainValue.Range(start, offset);
              if (offset <= start) {
                node.error = new Error(`Node#parse consumed no characters`);
                node.error.parseEnd = offset;
                node.error.source = node;
                node.range.end = start + 1;
              }
              if (context2.nodeStartsCollection(node)) {
                if (!node.error && !context2.atLineStart && context2.parent.type === PlainValue.Type.DOCUMENT) {
                  node.error = new PlainValue.YAMLSyntaxError(node, "Block collection must not have preceding content here (e.g. directives-end indicator)");
                }
                const collection = new Collection2(node);
                offset = collection.parse(new ParseContext(context2), offset);
                collection.range = new PlainValue.Range(start, offset);
                return collection;
              }
              return node;
            });
            this.atLineStart = atLineStart != null ? atLineStart : orig.atLineStart || false;
            this.inCollection = inCollection != null ? inCollection : orig.inCollection || false;
            this.inFlow = inFlow != null ? inFlow : orig.inFlow || false;
            this.indent = indent != null ? indent : orig.indent;
            this.lineStart = lineStart != null ? lineStart : orig.lineStart;
            this.parent = parent != null ? parent : orig.parent || {};
            this.root = orig.root;
            this.src = orig.src;
          }
          nodeStartsCollection(node) {
            const {
              inCollection,
              inFlow,
              src
            } = this;
            if (inCollection || inFlow)
              return false;
            if (node instanceof CollectionItem)
              return true;
            let offset = node.range.end;
            if (src[offset] === "\n" || src[offset - 1] === "\n")
              return false;
            offset = PlainValue.Node.endOfWhiteSpace(src, offset);
            return src[offset] === ":";
          }
          parseProps(offset) {
            const {
              inFlow,
              parent,
              src
            } = this;
            const props = [];
            let lineHasProps = false;
            offset = this.atLineStart ? PlainValue.Node.endOfIndent(src, offset) : PlainValue.Node.endOfWhiteSpace(src, offset);
            let ch = src[offset];
            while (ch === PlainValue.Char.ANCHOR || ch === PlainValue.Char.COMMENT || ch === PlainValue.Char.TAG || ch === "\n") {
              if (ch === "\n") {
                let inEnd = offset;
                let lineStart;
                do {
                  lineStart = inEnd + 1;
                  inEnd = PlainValue.Node.endOfIndent(src, lineStart);
                } while (src[inEnd] === "\n");
                const indentDiff = inEnd - (lineStart + this.indent);
                const noIndicatorAsIndent = parent.type === PlainValue.Type.SEQ_ITEM && parent.context.atLineStart;
                if (src[inEnd] !== "#" && !PlainValue.Node.nextNodeIsIndented(src[inEnd], indentDiff, !noIndicatorAsIndent))
                  break;
                this.atLineStart = true;
                this.lineStart = lineStart;
                lineHasProps = false;
                offset = inEnd;
              } else if (ch === PlainValue.Char.COMMENT) {
                const end = PlainValue.Node.endOfLine(src, offset + 1);
                props.push(new PlainValue.Range(offset, end));
                offset = end;
              } else {
                let end = PlainValue.Node.endOfIdentifier(src, offset + 1);
                if (ch === PlainValue.Char.TAG && src[end] === "," && /^[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+,\d\d\d\d(-\d\d){0,2}\/\S/.test(src.slice(offset + 1, end + 13))) {
                  end = PlainValue.Node.endOfIdentifier(src, end + 5);
                }
                props.push(new PlainValue.Range(offset, end));
                lineHasProps = true;
                offset = PlainValue.Node.endOfWhiteSpace(src, end);
              }
              ch = src[offset];
            }
            if (lineHasProps && ch === ":" && PlainValue.Node.atBlank(src, offset + 1, true))
              offset -= 1;
            const type = ParseContext.parseType(src, offset, inFlow);
            return {
              props,
              type,
              valueStart: offset
            };
          }
        };
        function parse3(src) {
          const cr = [];
          if (src.indexOf("\r") !== -1) {
            src = src.replace(/\r\n?/g, (match, offset2) => {
              if (match.length > 1)
                cr.push(offset2);
              return "\n";
            });
          }
          const documents = [];
          let offset = 0;
          do {
            const doc = new Document();
            const context2 = new ParseContext({
              src
            });
            offset = doc.parse(context2, offset);
            documents.push(doc);
          } while (offset < src.length);
          documents.setOrigRanges = () => {
            if (cr.length === 0)
              return false;
            for (let i2 = 1; i2 < cr.length; ++i2)
              cr[i2] -= i2;
            let crOffset = 0;
            for (let i2 = 0; i2 < documents.length; ++i2) {
              crOffset = documents[i2].setOrigRanges(cr, crOffset);
            }
            cr.splice(0, cr.length);
            return true;
          };
          documents.toString = () => documents.join("...\n");
          return documents;
        }
        exports2.parse = parse3;
      }
    });
    var require_resolveSeq_d03cb037 = __commonJS2({
      "node_modules/yaml/dist/resolveSeq-d03cb037.js"(exports2) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        function addCommentBefore(str, indent, comment) {
          if (!comment)
            return str;
          const cc = comment.replace(/[\s\S]^/gm, `$&${indent}#`);
          return `#${cc}
${indent}${str}`;
        }
        function addComment(str, indent, comment) {
          return !comment ? str : comment.indexOf("\n") === -1 ? `${str} #${comment}` : `${str}
` + comment.replace(/^/gm, `${indent || ""}#`);
        }
        var Node = class {
        };
        function toJSON(value, arg, ctx) {
          if (Array.isArray(value))
            return value.map((v, i2) => toJSON(v, String(i2), ctx));
          if (value && typeof value.toJSON === "function") {
            const anchor = ctx && ctx.anchors && ctx.anchors.get(value);
            if (anchor)
              ctx.onCreate = (res2) => {
                anchor.res = res2;
                delete ctx.onCreate;
              };
            const res = value.toJSON(arg, ctx);
            if (anchor && ctx.onCreate)
              ctx.onCreate(res);
            return res;
          }
          if ((!ctx || !ctx.keep) && typeof value === "bigint")
            return Number(value);
          return value;
        }
        var Scalar = class extends Node {
          constructor(value) {
            super();
            this.value = value;
          }
          toJSON(arg, ctx) {
            return ctx && ctx.keep ? this.value : toJSON(this.value, arg, ctx);
          }
          toString() {
            return String(this.value);
          }
        };
        function collectionFromPath(schema, path4, value) {
          let v = value;
          for (let i2 = path4.length - 1; i2 >= 0; --i2) {
            const k = path4[i2];
            if (Number.isInteger(k) && k >= 0) {
              const a = [];
              a[k] = v;
              v = a;
            } else {
              const o = {};
              Object.defineProperty(o, k, {
                value: v,
                writable: true,
                enumerable: true,
                configurable: true
              });
              v = o;
            }
          }
          return schema.createNode(v, false);
        }
        var isEmptyPath = (path4) => path4 == null || typeof path4 === "object" && path4[Symbol.iterator]().next().done;
        var Collection2 = class extends Node {
          constructor(schema) {
            super();
            PlainValue._defineProperty(this, "items", []);
            this.schema = schema;
          }
          addIn(path4, value) {
            if (isEmptyPath(path4))
              this.add(value);
            else {
              const [key, ...rest] = path4;
              const node = this.get(key, true);
              if (node instanceof Collection2)
                node.addIn(rest, value);
              else if (node === void 0 && this.schema)
                this.set(key, collectionFromPath(this.schema, rest, value));
              else
                throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
            }
          }
          deleteIn([key, ...rest]) {
            if (rest.length === 0)
              return this.delete(key);
            const node = this.get(key, true);
            if (node instanceof Collection2)
              return node.deleteIn(rest);
            else
              throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
          }
          getIn([key, ...rest], keepScalar) {
            const node = this.get(key, true);
            if (rest.length === 0)
              return !keepScalar && node instanceof Scalar ? node.value : node;
            else
              return node instanceof Collection2 ? node.getIn(rest, keepScalar) : void 0;
          }
          hasAllNullValues() {
            return this.items.every((node) => {
              if (!node || node.type !== "PAIR")
                return false;
              const n = node.value;
              return n == null || n instanceof Scalar && n.value == null && !n.commentBefore && !n.comment && !n.tag;
            });
          }
          hasIn([key, ...rest]) {
            if (rest.length === 0)
              return this.has(key);
            const node = this.get(key, true);
            return node instanceof Collection2 ? node.hasIn(rest) : false;
          }
          setIn([key, ...rest], value) {
            if (rest.length === 0) {
              this.set(key, value);
            } else {
              const node = this.get(key, true);
              if (node instanceof Collection2)
                node.setIn(rest, value);
              else if (node === void 0 && this.schema)
                this.set(key, collectionFromPath(this.schema, rest, value));
              else
                throw new Error(`Expected YAML collection at ${key}. Remaining path: ${rest}`);
            }
          }
          toJSON() {
            return null;
          }
          toString(ctx, {
            blockItem,
            flowChars,
            isMap,
            itemIndent
          }, onComment, onChompKeep) {
            const {
              indent,
              indentStep,
              stringify
            } = ctx;
            const inFlow = this.type === PlainValue.Type.FLOW_MAP || this.type === PlainValue.Type.FLOW_SEQ || ctx.inFlow;
            if (inFlow)
              itemIndent += indentStep;
            const allNullValues = isMap && this.hasAllNullValues();
            ctx = Object.assign({}, ctx, {
              allNullValues,
              indent: itemIndent,
              inFlow,
              type: null
            });
            let chompKeep = false;
            let hasItemWithNewLine = false;
            const nodes = this.items.reduce((nodes2, item, i2) => {
              let comment;
              if (item) {
                if (!chompKeep && item.spaceBefore)
                  nodes2.push({
                    type: "comment",
                    str: ""
                  });
                if (item.commentBefore)
                  item.commentBefore.match(/^.*$/gm).forEach((line) => {
                    nodes2.push({
                      type: "comment",
                      str: `#${line}`
                    });
                  });
                if (item.comment)
                  comment = item.comment;
                if (inFlow && (!chompKeep && item.spaceBefore || item.commentBefore || item.comment || item.key && (item.key.commentBefore || item.key.comment) || item.value && (item.value.commentBefore || item.value.comment)))
                  hasItemWithNewLine = true;
              }
              chompKeep = false;
              let str2 = stringify(item, ctx, () => comment = null, () => chompKeep = true);
              if (inFlow && !hasItemWithNewLine && str2.includes("\n"))
                hasItemWithNewLine = true;
              if (inFlow && i2 < this.items.length - 1)
                str2 += ",";
              str2 = addComment(str2, itemIndent, comment);
              if (chompKeep && (comment || inFlow))
                chompKeep = false;
              nodes2.push({
                type: "item",
                str: str2
              });
              return nodes2;
            }, []);
            let str;
            if (nodes.length === 0) {
              str = flowChars.start + flowChars.end;
            } else if (inFlow) {
              const {
                start,
                end
              } = flowChars;
              const strings = nodes.map((n) => n.str);
              if (hasItemWithNewLine || strings.reduce((sum, str2) => sum + str2.length + 2, 2) > Collection2.maxFlowStringSingleLineLength) {
                str = start;
                for (const s2 of strings) {
                  str += s2 ? `
${indentStep}${indent}${s2}` : "\n";
                }
                str += `
${indent}${end}`;
              } else {
                str = `${start} ${strings.join(" ")} ${end}`;
              }
            } else {
              const strings = nodes.map(blockItem);
              str = strings.shift();
              for (const s2 of strings)
                str += s2 ? `
${indent}${s2}` : "\n";
            }
            if (this.comment) {
              str += "\n" + this.comment.replace(/^/gm, `${indent}#`);
              if (onComment)
                onComment();
            } else if (chompKeep && onChompKeep)
              onChompKeep();
            return str;
          }
        };
        PlainValue._defineProperty(Collection2, "maxFlowStringSingleLineLength", 60);
        function asItemIndex(key) {
          let idx = key instanceof Scalar ? key.value : key;
          if (idx && typeof idx === "string")
            idx = Number(idx);
          return Number.isInteger(idx) && idx >= 0 ? idx : null;
        }
        var YAMLSeq = class extends Collection2 {
          add(value) {
            this.items.push(value);
          }
          delete(key) {
            const idx = asItemIndex(key);
            if (typeof idx !== "number")
              return false;
            const del = this.items.splice(idx, 1);
            return del.length > 0;
          }
          get(key, keepScalar) {
            const idx = asItemIndex(key);
            if (typeof idx !== "number")
              return void 0;
            const it = this.items[idx];
            return !keepScalar && it instanceof Scalar ? it.value : it;
          }
          has(key) {
            const idx = asItemIndex(key);
            return typeof idx === "number" && idx < this.items.length;
          }
          set(key, value) {
            const idx = asItemIndex(key);
            if (typeof idx !== "number")
              throw new Error(`Expected a valid index, not ${key}.`);
            this.items[idx] = value;
          }
          toJSON(_, ctx) {
            const seq = [];
            if (ctx && ctx.onCreate)
              ctx.onCreate(seq);
            let i2 = 0;
            for (const item of this.items)
              seq.push(toJSON(item, String(i2++), ctx));
            return seq;
          }
          toString(ctx, onComment, onChompKeep) {
            if (!ctx)
              return JSON.stringify(this);
            return super.toString(ctx, {
              blockItem: (n) => n.type === "comment" ? n.str : `- ${n.str}`,
              flowChars: {
                start: "[",
                end: "]"
              },
              isMap: false,
              itemIndent: (ctx.indent || "") + "  "
            }, onComment, onChompKeep);
          }
        };
        var stringifyKey = (key, jsKey, ctx) => {
          if (jsKey === null)
            return "";
          if (typeof jsKey !== "object")
            return String(jsKey);
          if (key instanceof Node && ctx && ctx.doc)
            return key.toString({
              anchors: /* @__PURE__ */ Object.create(null),
              doc: ctx.doc,
              indent: "",
              indentStep: ctx.indentStep,
              inFlow: true,
              inStringifyKey: true,
              stringify: ctx.stringify
            });
          return JSON.stringify(jsKey);
        };
        var Pair = class extends Node {
          constructor(key, value = null) {
            super();
            this.key = key;
            this.value = value;
            this.type = Pair.Type.PAIR;
          }
          get commentBefore() {
            return this.key instanceof Node ? this.key.commentBefore : void 0;
          }
          set commentBefore(cb) {
            if (this.key == null)
              this.key = new Scalar(null);
            if (this.key instanceof Node)
              this.key.commentBefore = cb;
            else {
              const msg = "Pair.commentBefore is an alias for Pair.key.commentBefore. To set it, the key must be a Node.";
              throw new Error(msg);
            }
          }
          addToJSMap(ctx, map) {
            const key = toJSON(this.key, "", ctx);
            if (map instanceof Map) {
              const value = toJSON(this.value, key, ctx);
              map.set(key, value);
            } else if (map instanceof Set) {
              map.add(key);
            } else {
              const stringKey = stringifyKey(this.key, key, ctx);
              const value = toJSON(this.value, stringKey, ctx);
              if (stringKey in map)
                Object.defineProperty(map, stringKey, {
                  value,
                  writable: true,
                  enumerable: true,
                  configurable: true
                });
              else
                map[stringKey] = value;
            }
            return map;
          }
          toJSON(_, ctx) {
            const pair = ctx && ctx.mapAsMap ? /* @__PURE__ */ new Map() : {};
            return this.addToJSMap(ctx, pair);
          }
          toString(ctx, onComment, onChompKeep) {
            if (!ctx || !ctx.doc)
              return JSON.stringify(this);
            const {
              indent: indentSize,
              indentSeq,
              simpleKeys
            } = ctx.doc.options;
            let {
              key,
              value
            } = this;
            let keyComment = key instanceof Node && key.comment;
            if (simpleKeys) {
              if (keyComment) {
                throw new Error("With simple keys, key nodes cannot have comments");
              }
              if (key instanceof Collection2) {
                const msg = "With simple keys, collection cannot be used as a key value";
                throw new Error(msg);
              }
            }
            let explicitKey = !simpleKeys && (!key || keyComment || (key instanceof Node ? key instanceof Collection2 || key.type === PlainValue.Type.BLOCK_FOLDED || key.type === PlainValue.Type.BLOCK_LITERAL : typeof key === "object"));
            const {
              doc,
              indent,
              indentStep,
              stringify
            } = ctx;
            ctx = Object.assign({}, ctx, {
              implicitKey: !explicitKey,
              indent: indent + indentStep
            });
            let chompKeep = false;
            let str = stringify(key, ctx, () => keyComment = null, () => chompKeep = true);
            str = addComment(str, ctx.indent, keyComment);
            if (!explicitKey && str.length > 1024) {
              if (simpleKeys)
                throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
              explicitKey = true;
            }
            if (ctx.allNullValues && !simpleKeys) {
              if (this.comment) {
                str = addComment(str, ctx.indent, this.comment);
                if (onComment)
                  onComment();
              } else if (chompKeep && !keyComment && onChompKeep)
                onChompKeep();
              return ctx.inFlow && !explicitKey ? str : `? ${str}`;
            }
            str = explicitKey ? `? ${str}
${indent}:` : `${str}:`;
            if (this.comment) {
              str = addComment(str, ctx.indent, this.comment);
              if (onComment)
                onComment();
            }
            let vcb = "";
            let valueComment = null;
            if (value instanceof Node) {
              if (value.spaceBefore)
                vcb = "\n";
              if (value.commentBefore) {
                const cs = value.commentBefore.replace(/^/gm, `${ctx.indent}#`);
                vcb += `
${cs}`;
              }
              valueComment = value.comment;
            } else if (value && typeof value === "object") {
              value = doc.schema.createNode(value, true);
            }
            ctx.implicitKey = false;
            if (!explicitKey && !this.comment && value instanceof Scalar)
              ctx.indentAtStart = str.length + 1;
            chompKeep = false;
            if (!indentSeq && indentSize >= 2 && !ctx.inFlow && !explicitKey && value instanceof YAMLSeq && value.type !== PlainValue.Type.FLOW_SEQ && !value.tag && !doc.anchors.getName(value)) {
              ctx.indent = ctx.indent.substr(2);
            }
            const valueStr = stringify(value, ctx, () => valueComment = null, () => chompKeep = true);
            let ws = " ";
            if (vcb || this.comment) {
              ws = `${vcb}
${ctx.indent}`;
            } else if (!explicitKey && value instanceof Collection2) {
              const flow = valueStr[0] === "[" || valueStr[0] === "{";
              if (!flow || valueStr.includes("\n"))
                ws = `
${ctx.indent}`;
            } else if (valueStr[0] === "\n")
              ws = "";
            if (chompKeep && !valueComment && onChompKeep)
              onChompKeep();
            return addComment(str + ws + valueStr, ctx.indent, valueComment);
          }
        };
        PlainValue._defineProperty(Pair, "Type", {
          PAIR: "PAIR",
          MERGE_PAIR: "MERGE_PAIR"
        });
        var getAliasCount = (node, anchors) => {
          if (node instanceof Alias) {
            const anchor = anchors.get(node.source);
            return anchor.count * anchor.aliasCount;
          } else if (node instanceof Collection2) {
            let count = 0;
            for (const item of node.items) {
              const c = getAliasCount(item, anchors);
              if (c > count)
                count = c;
            }
            return count;
          } else if (node instanceof Pair) {
            const kc = getAliasCount(node.key, anchors);
            const vc = getAliasCount(node.value, anchors);
            return Math.max(kc, vc);
          }
          return 1;
        };
        var Alias = class extends Node {
          static stringify({
            range,
            source
          }, {
            anchors,
            doc,
            implicitKey,
            inStringifyKey
          }) {
            let anchor = Object.keys(anchors).find((a) => anchors[a] === source);
            if (!anchor && inStringifyKey)
              anchor = doc.anchors.getName(source) || doc.anchors.newName();
            if (anchor)
              return `*${anchor}${implicitKey ? " " : ""}`;
            const msg = doc.anchors.getName(source) ? "Alias node must be after source node" : "Source node not found for alias node";
            throw new Error(`${msg} [${range}]`);
          }
          constructor(source) {
            super();
            this.source = source;
            this.type = PlainValue.Type.ALIAS;
          }
          set tag(t2) {
            throw new Error("Alias nodes cannot have tags");
          }
          toJSON(arg, ctx) {
            if (!ctx)
              return toJSON(this.source, arg, ctx);
            const {
              anchors,
              maxAliasCount
            } = ctx;
            const anchor = anchors.get(this.source);
            if (!anchor || anchor.res === void 0) {
              const msg = "This should not happen: Alias anchor was not resolved?";
              if (this.cstNode)
                throw new PlainValue.YAMLReferenceError(this.cstNode, msg);
              else
                throw new ReferenceError(msg);
            }
            if (maxAliasCount >= 0) {
              anchor.count += 1;
              if (anchor.aliasCount === 0)
                anchor.aliasCount = getAliasCount(this.source, anchors);
              if (anchor.count * anchor.aliasCount > maxAliasCount) {
                const msg = "Excessive alias count indicates a resource exhaustion attack";
                if (this.cstNode)
                  throw new PlainValue.YAMLReferenceError(this.cstNode, msg);
                else
                  throw new ReferenceError(msg);
              }
            }
            return anchor.res;
          }
          toString(ctx) {
            return Alias.stringify(this, ctx);
          }
        };
        PlainValue._defineProperty(Alias, "default", true);
        function findPair(items, key) {
          const k = key instanceof Scalar ? key.value : key;
          for (const it of items) {
            if (it instanceof Pair) {
              if (it.key === key || it.key === k)
                return it;
              if (it.key && it.key.value === k)
                return it;
            }
          }
          return void 0;
        }
        var YAMLMap = class extends Collection2 {
          add(pair, overwrite) {
            if (!pair)
              pair = new Pair(pair);
            else if (!(pair instanceof Pair))
              pair = new Pair(pair.key || pair, pair.value);
            const prev = findPair(this.items, pair.key);
            const sortEntries = this.schema && this.schema.sortMapEntries;
            if (prev) {
              if (overwrite)
                prev.value = pair.value;
              else
                throw new Error(`Key ${pair.key} already set`);
            } else if (sortEntries) {
              const i2 = this.items.findIndex((item) => sortEntries(pair, item) < 0);
              if (i2 === -1)
                this.items.push(pair);
              else
                this.items.splice(i2, 0, pair);
            } else {
              this.items.push(pair);
            }
          }
          delete(key) {
            const it = findPair(this.items, key);
            if (!it)
              return false;
            const del = this.items.splice(this.items.indexOf(it), 1);
            return del.length > 0;
          }
          get(key, keepScalar) {
            const it = findPair(this.items, key);
            const node = it && it.value;
            return !keepScalar && node instanceof Scalar ? node.value : node;
          }
          has(key) {
            return !!findPair(this.items, key);
          }
          set(key, value) {
            this.add(new Pair(key, value), true);
          }
          toJSON(_, ctx, Type) {
            const map = Type ? new Type() : ctx && ctx.mapAsMap ? /* @__PURE__ */ new Map() : {};
            if (ctx && ctx.onCreate)
              ctx.onCreate(map);
            for (const item of this.items)
              item.addToJSMap(ctx, map);
            return map;
          }
          toString(ctx, onComment, onChompKeep) {
            if (!ctx)
              return JSON.stringify(this);
            for (const item of this.items) {
              if (!(item instanceof Pair))
                throw new Error(`Map items must all be pairs; found ${JSON.stringify(item)} instead`);
            }
            return super.toString(ctx, {
              blockItem: (n) => n.str,
              flowChars: {
                start: "{",
                end: "}"
              },
              isMap: true,
              itemIndent: ctx.indent || ""
            }, onComment, onChompKeep);
          }
        };
        var MERGE_KEY = "<<";
        var Merge = class extends Pair {
          constructor(pair) {
            if (pair instanceof Pair) {
              let seq = pair.value;
              if (!(seq instanceof YAMLSeq)) {
                seq = new YAMLSeq();
                seq.items.push(pair.value);
                seq.range = pair.value.range;
              }
              super(pair.key, seq);
              this.range = pair.range;
            } else {
              super(new Scalar(MERGE_KEY), new YAMLSeq());
            }
            this.type = Pair.Type.MERGE_PAIR;
          }
          addToJSMap(ctx, map) {
            for (const {
              source
            } of this.value.items) {
              if (!(source instanceof YAMLMap))
                throw new Error("Merge sources must be maps");
              const srcMap = source.toJSON(null, ctx, Map);
              for (const [key, value] of srcMap) {
                if (map instanceof Map) {
                  if (!map.has(key))
                    map.set(key, value);
                } else if (map instanceof Set) {
                  map.add(key);
                } else if (!Object.prototype.hasOwnProperty.call(map, key)) {
                  Object.defineProperty(map, key, {
                    value,
                    writable: true,
                    enumerable: true,
                    configurable: true
                  });
                }
              }
            }
            return map;
          }
          toString(ctx, onComment) {
            const seq = this.value;
            if (seq.items.length > 1)
              return super.toString(ctx, onComment);
            this.value = seq.items[0];
            const str = super.toString(ctx, onComment);
            this.value = seq;
            return str;
          }
        };
        var binaryOptions = {
          defaultType: PlainValue.Type.BLOCK_LITERAL,
          lineWidth: 76
        };
        var boolOptions = {
          trueStr: "true",
          falseStr: "false"
        };
        var intOptions = {
          asBigInt: false
        };
        var nullOptions = {
          nullStr: "null"
        };
        var strOptions = {
          defaultType: PlainValue.Type.PLAIN,
          doubleQuoted: {
            jsonEncoding: false,
            minMultiLineLength: 40
          },
          fold: {
            lineWidth: 80,
            minContentWidth: 20
          }
        };
        function resolveScalar(str, tags, scalarFallback) {
          for (const {
            format: format2,
            test,
            resolve
          } of tags) {
            if (test) {
              const match = str.match(test);
              if (match) {
                let res = resolve.apply(null, match);
                if (!(res instanceof Scalar))
                  res = new Scalar(res);
                if (format2)
                  res.format = format2;
                return res;
              }
            }
          }
          if (scalarFallback)
            str = scalarFallback(str);
          return new Scalar(str);
        }
        var FOLD_FLOW = "flow";
        var FOLD_BLOCK = "block";
        var FOLD_QUOTED = "quoted";
        var consumeMoreIndentedLines = (text, i2) => {
          let ch = text[i2 + 1];
          while (ch === " " || ch === "	") {
            do {
              ch = text[i2 += 1];
            } while (ch && ch !== "\n");
            ch = text[i2 + 1];
          }
          return i2;
        };
        function foldFlowLines(text, indent, mode, {
          indentAtStart,
          lineWidth = 80,
          minContentWidth = 20,
          onFold,
          onOverflow
        }) {
          if (!lineWidth || lineWidth < 0)
            return text;
          const endStep = Math.max(1 + minContentWidth, 1 + lineWidth - indent.length);
          if (text.length <= endStep)
            return text;
          const folds = [];
          const escapedFolds = {};
          let end = lineWidth - indent.length;
          if (typeof indentAtStart === "number") {
            if (indentAtStart > lineWidth - Math.max(2, minContentWidth))
              folds.push(0);
            else
              end = lineWidth - indentAtStart;
          }
          let split = void 0;
          let prev = void 0;
          let overflow = false;
          let i2 = -1;
          let escStart = -1;
          let escEnd = -1;
          if (mode === FOLD_BLOCK) {
            i2 = consumeMoreIndentedLines(text, i2);
            if (i2 !== -1)
              end = i2 + endStep;
          }
          for (let ch; ch = text[i2 += 1]; ) {
            if (mode === FOLD_QUOTED && ch === "\\") {
              escStart = i2;
              switch (text[i2 + 1]) {
                case "x":
                  i2 += 3;
                  break;
                case "u":
                  i2 += 5;
                  break;
                case "U":
                  i2 += 9;
                  break;
                default:
                  i2 += 1;
              }
              escEnd = i2;
            }
            if (ch === "\n") {
              if (mode === FOLD_BLOCK)
                i2 = consumeMoreIndentedLines(text, i2);
              end = i2 + endStep;
              split = void 0;
            } else {
              if (ch === " " && prev && prev !== " " && prev !== "\n" && prev !== "	") {
                const next = text[i2 + 1];
                if (next && next !== " " && next !== "\n" && next !== "	")
                  split = i2;
              }
              if (i2 >= end) {
                if (split) {
                  folds.push(split);
                  end = split + endStep;
                  split = void 0;
                } else if (mode === FOLD_QUOTED) {
                  while (prev === " " || prev === "	") {
                    prev = ch;
                    ch = text[i2 += 1];
                    overflow = true;
                  }
                  const j = i2 > escEnd + 1 ? i2 - 2 : escStart - 1;
                  if (escapedFolds[j])
                    return text;
                  folds.push(j);
                  escapedFolds[j] = true;
                  end = j + endStep;
                  split = void 0;
                } else {
                  overflow = true;
                }
              }
            }
            prev = ch;
          }
          if (overflow && onOverflow)
            onOverflow();
          if (folds.length === 0)
            return text;
          if (onFold)
            onFold();
          let res = text.slice(0, folds[0]);
          for (let i22 = 0; i22 < folds.length; ++i22) {
            const fold = folds[i22];
            const end2 = folds[i22 + 1] || text.length;
            if (fold === 0)
              res = `
${indent}${text.slice(0, end2)}`;
            else {
              if (mode === FOLD_QUOTED && escapedFolds[fold])
                res += `${text[fold]}\\`;
              res += `
${indent}${text.slice(fold + 1, end2)}`;
            }
          }
          return res;
        }
        var getFoldOptions = ({
          indentAtStart
        }) => indentAtStart ? Object.assign({
          indentAtStart
        }, strOptions.fold) : strOptions.fold;
        var containsDocumentMarker = (str) => /^(%|---|\.\.\.)/m.test(str);
        function lineLengthOverLimit(str, lineWidth, indentLength) {
          if (!lineWidth || lineWidth < 0)
            return false;
          const limit = lineWidth - indentLength;
          const strLen = str.length;
          if (strLen <= limit)
            return false;
          for (let i2 = 0, start = 0; i2 < strLen; ++i2) {
            if (str[i2] === "\n") {
              if (i2 - start > limit)
                return true;
              start = i2 + 1;
              if (strLen - start <= limit)
                return false;
            }
          }
          return true;
        }
        function doubleQuotedString(value, ctx) {
          const {
            implicitKey
          } = ctx;
          const {
            jsonEncoding,
            minMultiLineLength
          } = strOptions.doubleQuoted;
          const json = JSON.stringify(value);
          if (jsonEncoding)
            return json;
          const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
          let str = "";
          let start = 0;
          for (let i2 = 0, ch = json[i2]; ch; ch = json[++i2]) {
            if (ch === " " && json[i2 + 1] === "\\" && json[i2 + 2] === "n") {
              str += json.slice(start, i2) + "\\ ";
              i2 += 1;
              start = i2;
              ch = "\\";
            }
            if (ch === "\\")
              switch (json[i2 + 1]) {
                case "u":
                  {
                    str += json.slice(start, i2);
                    const code = json.substr(i2 + 2, 4);
                    switch (code) {
                      case "0000":
                        str += "\\0";
                        break;
                      case "0007":
                        str += "\\a";
                        break;
                      case "000b":
                        str += "\\v";
                        break;
                      case "001b":
                        str += "\\e";
                        break;
                      case "0085":
                        str += "\\N";
                        break;
                      case "00a0":
                        str += "\\_";
                        break;
                      case "2028":
                        str += "\\L";
                        break;
                      case "2029":
                        str += "\\P";
                        break;
                      default:
                        if (code.substr(0, 2) === "00")
                          str += "\\x" + code.substr(2);
                        else
                          str += json.substr(i2, 6);
                    }
                    i2 += 5;
                    start = i2 + 1;
                  }
                  break;
                case "n":
                  if (implicitKey || json[i2 + 2] === '"' || json.length < minMultiLineLength) {
                    i2 += 1;
                  } else {
                    str += json.slice(start, i2) + "\n\n";
                    while (json[i2 + 2] === "\\" && json[i2 + 3] === "n" && json[i2 + 4] !== '"') {
                      str += "\n";
                      i2 += 2;
                    }
                    str += indent;
                    if (json[i2 + 2] === " ")
                      str += "\\";
                    i2 += 1;
                    start = i2 + 1;
                  }
                  break;
                default:
                  i2 += 1;
              }
          }
          str = start ? str + json.slice(start) : json;
          return implicitKey ? str : foldFlowLines(str, indent, FOLD_QUOTED, getFoldOptions(ctx));
        }
        function singleQuotedString(value, ctx) {
          if (ctx.implicitKey) {
            if (/\n/.test(value))
              return doubleQuotedString(value, ctx);
          } else {
            if (/[ \t]\n|\n[ \t]/.test(value))
              return doubleQuotedString(value, ctx);
          }
          const indent = ctx.indent || (containsDocumentMarker(value) ? "  " : "");
          const res = "'" + value.replace(/'/g, "''").replace(/\n+/g, `$&
${indent}`) + "'";
          return ctx.implicitKey ? res : foldFlowLines(res, indent, FOLD_FLOW, getFoldOptions(ctx));
        }
        function blockString({
          comment,
          type,
          value
        }, ctx, onComment, onChompKeep) {
          if (/\n[\t ]+$/.test(value) || /^\s*$/.test(value)) {
            return doubleQuotedString(value, ctx);
          }
          const indent = ctx.indent || (ctx.forceBlockIndent || containsDocumentMarker(value) ? "  " : "");
          const indentSize = indent ? "2" : "1";
          const literal = type === PlainValue.Type.BLOCK_FOLDED ? false : type === PlainValue.Type.BLOCK_LITERAL ? true : !lineLengthOverLimit(value, strOptions.fold.lineWidth, indent.length);
          let header = literal ? "|" : ">";
          if (!value)
            return header + "\n";
          let wsStart = "";
          let wsEnd = "";
          value = value.replace(/[\n\t ]*$/, (ws) => {
            const n = ws.indexOf("\n");
            if (n === -1) {
              header += "-";
            } else if (value === ws || n !== ws.length - 1) {
              header += "+";
              if (onChompKeep)
                onChompKeep();
            }
            wsEnd = ws.replace(/\n$/, "");
            return "";
          }).replace(/^[\n ]*/, (ws) => {
            if (ws.indexOf(" ") !== -1)
              header += indentSize;
            const m2 = ws.match(/ +$/);
            if (m2) {
              wsStart = ws.slice(0, -m2[0].length);
              return m2[0];
            } else {
              wsStart = ws;
              return "";
            }
          });
          if (wsEnd)
            wsEnd = wsEnd.replace(/\n+(?!\n|$)/g, `$&${indent}`);
          if (wsStart)
            wsStart = wsStart.replace(/\n+/g, `$&${indent}`);
          if (comment) {
            header += " #" + comment.replace(/ ?[\r\n]+/g, " ");
            if (onComment)
              onComment();
          }
          if (!value)
            return `${header}${indentSize}
${indent}${wsEnd}`;
          if (literal) {
            value = value.replace(/\n+/g, `$&${indent}`);
            return `${header}
${indent}${wsStart}${value}${wsEnd}`;
          }
          value = value.replace(/\n+/g, "\n$&").replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, `$&${indent}`);
          const body = foldFlowLines(`${wsStart}${value}${wsEnd}`, indent, FOLD_BLOCK, strOptions.fold);
          return `${header}
${indent}${body}`;
        }
        function plainString(item, ctx, onComment, onChompKeep) {
          const {
            comment,
            type,
            value
          } = item;
          const {
            actualString,
            implicitKey,
            indent,
            inFlow
          } = ctx;
          if (implicitKey && /[\n[\]{},]/.test(value) || inFlow && /[[\]{},]/.test(value)) {
            return doubleQuotedString(value, ctx);
          }
          if (!value || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(value)) {
            return implicitKey || inFlow || value.indexOf("\n") === -1 ? value.indexOf('"') !== -1 && value.indexOf("'") === -1 ? singleQuotedString(value, ctx) : doubleQuotedString(value, ctx) : blockString(item, ctx, onComment, onChompKeep);
          }
          if (!implicitKey && !inFlow && type !== PlainValue.Type.PLAIN && value.indexOf("\n") !== -1) {
            return blockString(item, ctx, onComment, onChompKeep);
          }
          if (indent === "" && containsDocumentMarker(value)) {
            ctx.forceBlockIndent = true;
            return blockString(item, ctx, onComment, onChompKeep);
          }
          const str = value.replace(/\n+/g, `$&
${indent}`);
          if (actualString) {
            const {
              tags
            } = ctx.doc.schema;
            const resolved = resolveScalar(str, tags, tags.scalarFallback).value;
            if (typeof resolved !== "string")
              return doubleQuotedString(value, ctx);
          }
          const body = implicitKey ? str : foldFlowLines(str, indent, FOLD_FLOW, getFoldOptions(ctx));
          if (comment && !inFlow && (body.indexOf("\n") !== -1 || comment.indexOf("\n") !== -1)) {
            if (onComment)
              onComment();
            return addCommentBefore(body, indent, comment);
          }
          return body;
        }
        function stringifyString(item, ctx, onComment, onChompKeep) {
          const {
            defaultType
          } = strOptions;
          const {
            implicitKey,
            inFlow
          } = ctx;
          let {
            type,
            value
          } = item;
          if (typeof value !== "string") {
            value = String(value);
            item = Object.assign({}, item, {
              value
            });
          }
          const _stringify = (_type2) => {
            switch (_type2) {
              case PlainValue.Type.BLOCK_FOLDED:
              case PlainValue.Type.BLOCK_LITERAL:
                return blockString(item, ctx, onComment, onChompKeep);
              case PlainValue.Type.QUOTE_DOUBLE:
                return doubleQuotedString(value, ctx);
              case PlainValue.Type.QUOTE_SINGLE:
                return singleQuotedString(value, ctx);
              case PlainValue.Type.PLAIN:
                return plainString(item, ctx, onComment, onChompKeep);
              default:
                return null;
            }
          };
          if (type !== PlainValue.Type.QUOTE_DOUBLE && /[\x00-\x08\x0b-\x1f\x7f-\x9f]/.test(value)) {
            type = PlainValue.Type.QUOTE_DOUBLE;
          } else if ((implicitKey || inFlow) && (type === PlainValue.Type.BLOCK_FOLDED || type === PlainValue.Type.BLOCK_LITERAL)) {
            type = PlainValue.Type.QUOTE_DOUBLE;
          }
          let res = _stringify(type);
          if (res === null) {
            res = _stringify(defaultType);
            if (res === null)
              throw new Error(`Unsupported default string type ${defaultType}`);
          }
          return res;
        }
        function stringifyNumber({
          format: format2,
          minFractionDigits,
          tag,
          value
        }) {
          if (typeof value === "bigint")
            return String(value);
          if (!isFinite(value))
            return isNaN(value) ? ".nan" : value < 0 ? "-.inf" : ".inf";
          let n = JSON.stringify(value);
          if (!format2 && minFractionDigits && (!tag || tag === "tag:yaml.org,2002:float") && /^\d/.test(n)) {
            let i2 = n.indexOf(".");
            if (i2 < 0) {
              i2 = n.length;
              n += ".";
            }
            let d = minFractionDigits - (n.length - i2 - 1);
            while (d-- > 0)
              n += "0";
          }
          return n;
        }
        function checkFlowCollectionEnd(errors, cst) {
          let char, name;
          switch (cst.type) {
            case PlainValue.Type.FLOW_MAP:
              char = "}";
              name = "flow map";
              break;
            case PlainValue.Type.FLOW_SEQ:
              char = "]";
              name = "flow sequence";
              break;
            default:
              errors.push(new PlainValue.YAMLSemanticError(cst, "Not a flow collection!?"));
              return;
          }
          let lastItem;
          for (let i2 = cst.items.length - 1; i2 >= 0; --i2) {
            const item = cst.items[i2];
            if (!item || item.type !== PlainValue.Type.COMMENT) {
              lastItem = item;
              break;
            }
          }
          if (lastItem && lastItem.char !== char) {
            const msg = `Expected ${name} to end with ${char}`;
            let err;
            if (typeof lastItem.offset === "number") {
              err = new PlainValue.YAMLSemanticError(cst, msg);
              err.offset = lastItem.offset + 1;
            } else {
              err = new PlainValue.YAMLSemanticError(lastItem, msg);
              if (lastItem.range && lastItem.range.end)
                err.offset = lastItem.range.end - lastItem.range.start;
            }
            errors.push(err);
          }
        }
        function checkFlowCommentSpace(errors, comment) {
          const prev = comment.context.src[comment.range.start - 1];
          if (prev !== "\n" && prev !== "	" && prev !== " ") {
            const msg = "Comments must be separated from other tokens by white space characters";
            errors.push(new PlainValue.YAMLSemanticError(comment, msg));
          }
        }
        function getLongKeyError(source, key) {
          const sk = String(key);
          const k = sk.substr(0, 8) + "..." + sk.substr(-8);
          return new PlainValue.YAMLSemanticError(source, `The "${k}" key is too long`);
        }
        function resolveComments(collection, comments) {
          for (const {
            afterKey,
            before,
            comment
          } of comments) {
            let item = collection.items[before];
            if (!item) {
              if (comment !== void 0) {
                if (collection.comment)
                  collection.comment += "\n" + comment;
                else
                  collection.comment = comment;
              }
            } else {
              if (afterKey && item.value)
                item = item.value;
              if (comment === void 0) {
                if (afterKey || !item.commentBefore)
                  item.spaceBefore = true;
              } else {
                if (item.commentBefore)
                  item.commentBefore += "\n" + comment;
                else
                  item.commentBefore = comment;
              }
            }
          }
        }
        function resolveString(doc, node) {
          const res = node.strValue;
          if (!res)
            return "";
          if (typeof res === "string")
            return res;
          res.errors.forEach((error) => {
            if (!error.source)
              error.source = node;
            doc.errors.push(error);
          });
          return res.str;
        }
        function resolveTagHandle(doc, node) {
          const {
            handle,
            suffix
          } = node.tag;
          let prefix2 = doc.tagPrefixes.find((p) => p.handle === handle);
          if (!prefix2) {
            const dtp = doc.getDefaults().tagPrefixes;
            if (dtp)
              prefix2 = dtp.find((p) => p.handle === handle);
            if (!prefix2)
              throw new PlainValue.YAMLSemanticError(node, `The ${handle} tag handle is non-default and was not declared.`);
          }
          if (!suffix)
            throw new PlainValue.YAMLSemanticError(node, `The ${handle} tag has no suffix.`);
          if (handle === "!" && (doc.version || doc.options.version) === "1.0") {
            if (suffix[0] === "^") {
              doc.warnings.push(new PlainValue.YAMLWarning(node, "YAML 1.0 ^ tag expansion is not supported"));
              return suffix;
            }
            if (/[:/]/.test(suffix)) {
              const vocab = suffix.match(/^([a-z0-9-]+)\/(.*)/i);
              return vocab ? `tag:${vocab[1]}.yaml.org,2002:${vocab[2]}` : `tag:${suffix}`;
            }
          }
          return prefix2.prefix + decodeURIComponent(suffix);
        }
        function resolveTagName(doc, node) {
          const {
            tag,
            type
          } = node;
          let nonSpecific = false;
          if (tag) {
            const {
              handle,
              suffix,
              verbatim
            } = tag;
            if (verbatim) {
              if (verbatim !== "!" && verbatim !== "!!")
                return verbatim;
              const msg = `Verbatim tags aren't resolved, so ${verbatim} is invalid.`;
              doc.errors.push(new PlainValue.YAMLSemanticError(node, msg));
            } else if (handle === "!" && !suffix) {
              nonSpecific = true;
            } else {
              try {
                return resolveTagHandle(doc, node);
              } catch (error) {
                doc.errors.push(error);
              }
            }
          }
          switch (type) {
            case PlainValue.Type.BLOCK_FOLDED:
            case PlainValue.Type.BLOCK_LITERAL:
            case PlainValue.Type.QUOTE_DOUBLE:
            case PlainValue.Type.QUOTE_SINGLE:
              return PlainValue.defaultTags.STR;
            case PlainValue.Type.FLOW_MAP:
            case PlainValue.Type.MAP:
              return PlainValue.defaultTags.MAP;
            case PlainValue.Type.FLOW_SEQ:
            case PlainValue.Type.SEQ:
              return PlainValue.defaultTags.SEQ;
            case PlainValue.Type.PLAIN:
              return nonSpecific ? PlainValue.defaultTags.STR : null;
            default:
              return null;
          }
        }
        function resolveByTagName(doc, node, tagName) {
          const {
            tags
          } = doc.schema;
          const matchWithTest = [];
          for (const tag of tags) {
            if (tag.tag === tagName) {
              if (tag.test)
                matchWithTest.push(tag);
              else {
                const res = tag.resolve(doc, node);
                return res instanceof Collection2 ? res : new Scalar(res);
              }
            }
          }
          const str = resolveString(doc, node);
          if (typeof str === "string" && matchWithTest.length > 0)
            return resolveScalar(str, matchWithTest, tags.scalarFallback);
          return null;
        }
        function getFallbackTagName({
          type
        }) {
          switch (type) {
            case PlainValue.Type.FLOW_MAP:
            case PlainValue.Type.MAP:
              return PlainValue.defaultTags.MAP;
            case PlainValue.Type.FLOW_SEQ:
            case PlainValue.Type.SEQ:
              return PlainValue.defaultTags.SEQ;
            default:
              return PlainValue.defaultTags.STR;
          }
        }
        function resolveTag(doc, node, tagName) {
          try {
            const res = resolveByTagName(doc, node, tagName);
            if (res) {
              if (tagName && node.tag)
                res.tag = tagName;
              return res;
            }
          } catch (error) {
            if (!error.source)
              error.source = node;
            doc.errors.push(error);
            return null;
          }
          try {
            const fallback = getFallbackTagName(node);
            if (!fallback)
              throw new Error(`The tag ${tagName} is unavailable`);
            const msg = `The tag ${tagName} is unavailable, falling back to ${fallback}`;
            doc.warnings.push(new PlainValue.YAMLWarning(node, msg));
            const res = resolveByTagName(doc, node, fallback);
            res.tag = tagName;
            return res;
          } catch (error) {
            const refError = new PlainValue.YAMLReferenceError(node, error.message);
            refError.stack = error.stack;
            doc.errors.push(refError);
            return null;
          }
        }
        var isCollectionItem = (node) => {
          if (!node)
            return false;
          const {
            type
          } = node;
          return type === PlainValue.Type.MAP_KEY || type === PlainValue.Type.MAP_VALUE || type === PlainValue.Type.SEQ_ITEM;
        };
        function resolveNodeProps(errors, node) {
          const comments = {
            before: [],
            after: []
          };
          let hasAnchor = false;
          let hasTag = false;
          const props = isCollectionItem(node.context.parent) ? node.context.parent.props.concat(node.props) : node.props;
          for (const {
            start,
            end
          } of props) {
            switch (node.context.src[start]) {
              case PlainValue.Char.COMMENT: {
                if (!node.commentHasRequiredWhitespace(start)) {
                  const msg = "Comments must be separated from other tokens by white space characters";
                  errors.push(new PlainValue.YAMLSemanticError(node, msg));
                }
                const {
                  header,
                  valueRange
                } = node;
                const cc = valueRange && (start > valueRange.start || header && start > header.start) ? comments.after : comments.before;
                cc.push(node.context.src.slice(start + 1, end));
                break;
              }
              case PlainValue.Char.ANCHOR:
                if (hasAnchor) {
                  const msg = "A node can have at most one anchor";
                  errors.push(new PlainValue.YAMLSemanticError(node, msg));
                }
                hasAnchor = true;
                break;
              case PlainValue.Char.TAG:
                if (hasTag) {
                  const msg = "A node can have at most one tag";
                  errors.push(new PlainValue.YAMLSemanticError(node, msg));
                }
                hasTag = true;
                break;
            }
          }
          return {
            comments,
            hasAnchor,
            hasTag
          };
        }
        function resolveNodeValue(doc, node) {
          const {
            anchors,
            errors,
            schema
          } = doc;
          if (node.type === PlainValue.Type.ALIAS) {
            const name = node.rawValue;
            const src = anchors.getNode(name);
            if (!src) {
              const msg = `Aliased anchor not found: ${name}`;
              errors.push(new PlainValue.YAMLReferenceError(node, msg));
              return null;
            }
            const res = new Alias(src);
            anchors._cstAliases.push(res);
            return res;
          }
          const tagName = resolveTagName(doc, node);
          if (tagName)
            return resolveTag(doc, node, tagName);
          if (node.type !== PlainValue.Type.PLAIN) {
            const msg = `Failed to resolve ${node.type} node here`;
            errors.push(new PlainValue.YAMLSyntaxError(node, msg));
            return null;
          }
          try {
            const str = resolveString(doc, node);
            return resolveScalar(str, schema.tags, schema.tags.scalarFallback);
          } catch (error) {
            if (!error.source)
              error.source = node;
            errors.push(error);
            return null;
          }
        }
        function resolveNode(doc, node) {
          if (!node)
            return null;
          if (node.error)
            doc.errors.push(node.error);
          const {
            comments,
            hasAnchor,
            hasTag
          } = resolveNodeProps(doc.errors, node);
          if (hasAnchor) {
            const {
              anchors
            } = doc;
            const name = node.anchor;
            const prev = anchors.getNode(name);
            if (prev)
              anchors.map[anchors.newName(name)] = prev;
            anchors.map[name] = node;
          }
          if (node.type === PlainValue.Type.ALIAS && (hasAnchor || hasTag)) {
            const msg = "An alias node must not specify any properties";
            doc.errors.push(new PlainValue.YAMLSemanticError(node, msg));
          }
          const res = resolveNodeValue(doc, node);
          if (res) {
            res.range = [node.range.start, node.range.end];
            if (doc.options.keepCstNodes)
              res.cstNode = node;
            if (doc.options.keepNodeTypes)
              res.type = node.type;
            const cb = comments.before.join("\n");
            if (cb) {
              res.commentBefore = res.commentBefore ? `${res.commentBefore}
${cb}` : cb;
            }
            const ca = comments.after.join("\n");
            if (ca)
              res.comment = res.comment ? `${res.comment}
${ca}` : ca;
          }
          return node.resolved = res;
        }
        function resolveMap(doc, cst) {
          if (cst.type !== PlainValue.Type.MAP && cst.type !== PlainValue.Type.FLOW_MAP) {
            const msg = `A ${cst.type} node cannot be resolved as a mapping`;
            doc.errors.push(new PlainValue.YAMLSyntaxError(cst, msg));
            return null;
          }
          const {
            comments,
            items
          } = cst.type === PlainValue.Type.FLOW_MAP ? resolveFlowMapItems(doc, cst) : resolveBlockMapItems(doc, cst);
          const map = new YAMLMap();
          map.items = items;
          resolveComments(map, comments);
          let hasCollectionKey = false;
          for (let i2 = 0; i2 < items.length; ++i2) {
            const {
              key: iKey
            } = items[i2];
            if (iKey instanceof Collection2)
              hasCollectionKey = true;
            if (doc.schema.merge && iKey && iKey.value === MERGE_KEY) {
              items[i2] = new Merge(items[i2]);
              const sources = items[i2].value.items;
              let error = null;
              sources.some((node) => {
                if (node instanceof Alias) {
                  const {
                    type
                  } = node.source;
                  if (type === PlainValue.Type.MAP || type === PlainValue.Type.FLOW_MAP)
                    return false;
                  return error = "Merge nodes aliases can only point to maps";
                }
                return error = "Merge nodes can only have Alias nodes as values";
              });
              if (error)
                doc.errors.push(new PlainValue.YAMLSemanticError(cst, error));
            } else {
              for (let j = i2 + 1; j < items.length; ++j) {
                const {
                  key: jKey
                } = items[j];
                if (iKey === jKey || iKey && jKey && Object.prototype.hasOwnProperty.call(iKey, "value") && iKey.value === jKey.value) {
                  const msg = `Map keys must be unique; "${iKey}" is repeated`;
                  doc.errors.push(new PlainValue.YAMLSemanticError(cst, msg));
                  break;
                }
              }
            }
          }
          if (hasCollectionKey && !doc.options.mapAsMap) {
            const warn2 = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
            doc.warnings.push(new PlainValue.YAMLWarning(cst, warn2));
          }
          cst.resolved = map;
          return map;
        }
        var valueHasPairComment = ({
          context: {
            lineStart,
            node,
            src
          },
          props
        }) => {
          if (props.length === 0)
            return false;
          const {
            start
          } = props[0];
          if (node && start > node.valueRange.start)
            return false;
          if (src[start] !== PlainValue.Char.COMMENT)
            return false;
          for (let i2 = lineStart; i2 < start; ++i2)
            if (src[i2] === "\n")
              return false;
          return true;
        };
        function resolvePairComment(item, pair) {
          if (!valueHasPairComment(item))
            return;
          const comment = item.getPropValue(0, PlainValue.Char.COMMENT, true);
          let found = false;
          const cb = pair.value.commentBefore;
          if (cb && cb.startsWith(comment)) {
            pair.value.commentBefore = cb.substr(comment.length + 1);
            found = true;
          } else {
            const cc = pair.value.comment;
            if (!item.node && cc && cc.startsWith(comment)) {
              pair.value.comment = cc.substr(comment.length + 1);
              found = true;
            }
          }
          if (found)
            pair.comment = comment;
        }
        function resolveBlockMapItems(doc, cst) {
          const comments = [];
          const items = [];
          let key = void 0;
          let keyStart = null;
          for (let i2 = 0; i2 < cst.items.length; ++i2) {
            const item = cst.items[i2];
            switch (item.type) {
              case PlainValue.Type.BLANK_LINE:
                comments.push({
                  afterKey: !!key,
                  before: items.length
                });
                break;
              case PlainValue.Type.COMMENT:
                comments.push({
                  afterKey: !!key,
                  before: items.length,
                  comment: item.comment
                });
                break;
              case PlainValue.Type.MAP_KEY:
                if (key !== void 0)
                  items.push(new Pair(key));
                if (item.error)
                  doc.errors.push(item.error);
                key = resolveNode(doc, item.node);
                keyStart = null;
                break;
              case PlainValue.Type.MAP_VALUE:
                {
                  if (key === void 0)
                    key = null;
                  if (item.error)
                    doc.errors.push(item.error);
                  if (!item.context.atLineStart && item.node && item.node.type === PlainValue.Type.MAP && !item.node.context.atLineStart) {
                    const msg = "Nested mappings are not allowed in compact mappings";
                    doc.errors.push(new PlainValue.YAMLSemanticError(item.node, msg));
                  }
                  let valueNode = item.node;
                  if (!valueNode && item.props.length > 0) {
                    valueNode = new PlainValue.PlainValue(PlainValue.Type.PLAIN, []);
                    valueNode.context = {
                      parent: item,
                      src: item.context.src
                    };
                    const pos = item.range.start + 1;
                    valueNode.range = {
                      start: pos,
                      end: pos
                    };
                    valueNode.valueRange = {
                      start: pos,
                      end: pos
                    };
                    if (typeof item.range.origStart === "number") {
                      const origPos = item.range.origStart + 1;
                      valueNode.range.origStart = valueNode.range.origEnd = origPos;
                      valueNode.valueRange.origStart = valueNode.valueRange.origEnd = origPos;
                    }
                  }
                  const pair = new Pair(key, resolveNode(doc, valueNode));
                  resolvePairComment(item, pair);
                  items.push(pair);
                  if (key && typeof keyStart === "number") {
                    if (item.range.start > keyStart + 1024)
                      doc.errors.push(getLongKeyError(cst, key));
                  }
                  key = void 0;
                  keyStart = null;
                }
                break;
              default:
                if (key !== void 0)
                  items.push(new Pair(key));
                key = resolveNode(doc, item);
                keyStart = item.range.start;
                if (item.error)
                  doc.errors.push(item.error);
                next:
                  for (let j = i2 + 1; ; ++j) {
                    const nextItem = cst.items[j];
                    switch (nextItem && nextItem.type) {
                      case PlainValue.Type.BLANK_LINE:
                      case PlainValue.Type.COMMENT:
                        continue next;
                      case PlainValue.Type.MAP_VALUE:
                        break next;
                      default: {
                        const msg = "Implicit map keys need to be followed by map values";
                        doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
                        break next;
                      }
                    }
                  }
                if (item.valueRangeContainsNewline) {
                  const msg = "Implicit map keys need to be on a single line";
                  doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
                }
            }
          }
          if (key !== void 0)
            items.push(new Pair(key));
          return {
            comments,
            items
          };
        }
        function resolveFlowMapItems(doc, cst) {
          const comments = [];
          const items = [];
          let key = void 0;
          let explicitKey = false;
          let next = "{";
          for (let i2 = 0; i2 < cst.items.length; ++i2) {
            const item = cst.items[i2];
            if (typeof item.char === "string") {
              const {
                char,
                offset
              } = item;
              if (char === "?" && key === void 0 && !explicitKey) {
                explicitKey = true;
                next = ":";
                continue;
              }
              if (char === ":") {
                if (key === void 0)
                  key = null;
                if (next === ":") {
                  next = ",";
                  continue;
                }
              } else {
                if (explicitKey) {
                  if (key === void 0 && char !== ",")
                    key = null;
                  explicitKey = false;
                }
                if (key !== void 0) {
                  items.push(new Pair(key));
                  key = void 0;
                  if (char === ",") {
                    next = ":";
                    continue;
                  }
                }
              }
              if (char === "}") {
                if (i2 === cst.items.length - 1)
                  continue;
              } else if (char === next) {
                next = ":";
                continue;
              }
              const msg = `Flow map contains an unexpected ${char}`;
              const err = new PlainValue.YAMLSyntaxError(cst, msg);
              err.offset = offset;
              doc.errors.push(err);
            } else if (item.type === PlainValue.Type.BLANK_LINE) {
              comments.push({
                afterKey: !!key,
                before: items.length
              });
            } else if (item.type === PlainValue.Type.COMMENT) {
              checkFlowCommentSpace(doc.errors, item);
              comments.push({
                afterKey: !!key,
                before: items.length,
                comment: item.comment
              });
            } else if (key === void 0) {
              if (next === ",")
                doc.errors.push(new PlainValue.YAMLSemanticError(item, "Separator , missing in flow map"));
              key = resolveNode(doc, item);
            } else {
              if (next !== ",")
                doc.errors.push(new PlainValue.YAMLSemanticError(item, "Indicator : missing in flow map entry"));
              items.push(new Pair(key, resolveNode(doc, item)));
              key = void 0;
              explicitKey = false;
            }
          }
          checkFlowCollectionEnd(doc.errors, cst);
          if (key !== void 0)
            items.push(new Pair(key));
          return {
            comments,
            items
          };
        }
        function resolveSeq(doc, cst) {
          if (cst.type !== PlainValue.Type.SEQ && cst.type !== PlainValue.Type.FLOW_SEQ) {
            const msg = `A ${cst.type} node cannot be resolved as a sequence`;
            doc.errors.push(new PlainValue.YAMLSyntaxError(cst, msg));
            return null;
          }
          const {
            comments,
            items
          } = cst.type === PlainValue.Type.FLOW_SEQ ? resolveFlowSeqItems(doc, cst) : resolveBlockSeqItems(doc, cst);
          const seq = new YAMLSeq();
          seq.items = items;
          resolveComments(seq, comments);
          if (!doc.options.mapAsMap && items.some((it) => it instanceof Pair && it.key instanceof Collection2)) {
            const warn2 = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
            doc.warnings.push(new PlainValue.YAMLWarning(cst, warn2));
          }
          cst.resolved = seq;
          return seq;
        }
        function resolveBlockSeqItems(doc, cst) {
          const comments = [];
          const items = [];
          for (let i2 = 0; i2 < cst.items.length; ++i2) {
            const item = cst.items[i2];
            switch (item.type) {
              case PlainValue.Type.BLANK_LINE:
                comments.push({
                  before: items.length
                });
                break;
              case PlainValue.Type.COMMENT:
                comments.push({
                  comment: item.comment,
                  before: items.length
                });
                break;
              case PlainValue.Type.SEQ_ITEM:
                if (item.error)
                  doc.errors.push(item.error);
                items.push(resolveNode(doc, item.node));
                if (item.hasProps) {
                  const msg = "Sequence items cannot have tags or anchors before the - indicator";
                  doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
                }
                break;
              default:
                if (item.error)
                  doc.errors.push(item.error);
                doc.errors.push(new PlainValue.YAMLSyntaxError(item, `Unexpected ${item.type} node in sequence`));
            }
          }
          return {
            comments,
            items
          };
        }
        function resolveFlowSeqItems(doc, cst) {
          const comments = [];
          const items = [];
          let explicitKey = false;
          let key = void 0;
          let keyStart = null;
          let next = "[";
          let prevItem = null;
          for (let i2 = 0; i2 < cst.items.length; ++i2) {
            const item = cst.items[i2];
            if (typeof item.char === "string") {
              const {
                char,
                offset
              } = item;
              if (char !== ":" && (explicitKey || key !== void 0)) {
                if (explicitKey && key === void 0)
                  key = next ? items.pop() : null;
                items.push(new Pair(key));
                explicitKey = false;
                key = void 0;
                keyStart = null;
              }
              if (char === next) {
                next = null;
              } else if (!next && char === "?") {
                explicitKey = true;
              } else if (next !== "[" && char === ":" && key === void 0) {
                if (next === ",") {
                  key = items.pop();
                  if (key instanceof Pair) {
                    const msg = "Chaining flow sequence pairs is invalid";
                    const err = new PlainValue.YAMLSemanticError(cst, msg);
                    err.offset = offset;
                    doc.errors.push(err);
                  }
                  if (!explicitKey && typeof keyStart === "number") {
                    const keyEnd = item.range ? item.range.start : item.offset;
                    if (keyEnd > keyStart + 1024)
                      doc.errors.push(getLongKeyError(cst, key));
                    const {
                      src
                    } = prevItem.context;
                    for (let i22 = keyStart; i22 < keyEnd; ++i22)
                      if (src[i22] === "\n") {
                        const msg = "Implicit keys of flow sequence pairs need to be on a single line";
                        doc.errors.push(new PlainValue.YAMLSemanticError(prevItem, msg));
                        break;
                      }
                  }
                } else {
                  key = null;
                }
                keyStart = null;
                explicitKey = false;
                next = null;
              } else if (next === "[" || char !== "]" || i2 < cst.items.length - 1) {
                const msg = `Flow sequence contains an unexpected ${char}`;
                const err = new PlainValue.YAMLSyntaxError(cst, msg);
                err.offset = offset;
                doc.errors.push(err);
              }
            } else if (item.type === PlainValue.Type.BLANK_LINE) {
              comments.push({
                before: items.length
              });
            } else if (item.type === PlainValue.Type.COMMENT) {
              checkFlowCommentSpace(doc.errors, item);
              comments.push({
                comment: item.comment,
                before: items.length
              });
            } else {
              if (next) {
                const msg = `Expected a ${next} in flow sequence`;
                doc.errors.push(new PlainValue.YAMLSemanticError(item, msg));
              }
              const value = resolveNode(doc, item);
              if (key === void 0) {
                items.push(value);
                prevItem = item;
              } else {
                items.push(new Pair(key, value));
                key = void 0;
              }
              keyStart = item.range.start;
              next = ",";
            }
          }
          checkFlowCollectionEnd(doc.errors, cst);
          if (key !== void 0)
            items.push(new Pair(key));
          return {
            comments,
            items
          };
        }
        exports2.Alias = Alias;
        exports2.Collection = Collection2;
        exports2.Merge = Merge;
        exports2.Node = Node;
        exports2.Pair = Pair;
        exports2.Scalar = Scalar;
        exports2.YAMLMap = YAMLMap;
        exports2.YAMLSeq = YAMLSeq;
        exports2.addComment = addComment;
        exports2.binaryOptions = binaryOptions;
        exports2.boolOptions = boolOptions;
        exports2.findPair = findPair;
        exports2.intOptions = intOptions;
        exports2.isEmptyPath = isEmptyPath;
        exports2.nullOptions = nullOptions;
        exports2.resolveMap = resolveMap;
        exports2.resolveNode = resolveNode;
        exports2.resolveSeq = resolveSeq;
        exports2.resolveString = resolveString;
        exports2.strOptions = strOptions;
        exports2.stringifyNumber = stringifyNumber;
        exports2.stringifyString = stringifyString;
        exports2.toJSON = toJSON;
      }
    });
    var require_warnings_1000a372 = __commonJS2({
      "node_modules/yaml/dist/warnings-1000a372.js"(exports2) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        var resolveSeq = require_resolveSeq_d03cb037();
        var binary = {
          identify: (value) => value instanceof Uint8Array,
          default: false,
          tag: "tag:yaml.org,2002:binary",
          resolve: (doc, node) => {
            const src = resolveSeq.resolveString(doc, node);
            if (typeof Buffer === "function") {
              return Buffer.from(src, "base64");
            } else if (typeof atob === "function") {
              const str = atob(src.replace(/[\n\r]/g, ""));
              const buffer = new Uint8Array(str.length);
              for (let i2 = 0; i2 < str.length; ++i2)
                buffer[i2] = str.charCodeAt(i2);
              return buffer;
            } else {
              const msg = "This environment does not support reading binary tags; either Buffer or atob is required";
              doc.errors.push(new PlainValue.YAMLReferenceError(node, msg));
              return null;
            }
          },
          options: resolveSeq.binaryOptions,
          stringify: ({
            comment,
            type,
            value
          }, ctx, onComment, onChompKeep) => {
            let src;
            if (typeof Buffer === "function") {
              src = value instanceof Buffer ? value.toString("base64") : Buffer.from(value.buffer).toString("base64");
            } else if (typeof btoa === "function") {
              let s2 = "";
              for (let i2 = 0; i2 < value.length; ++i2)
                s2 += String.fromCharCode(value[i2]);
              src = btoa(s2);
            } else {
              throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
            }
            if (!type)
              type = resolveSeq.binaryOptions.defaultType;
            if (type === PlainValue.Type.QUOTE_DOUBLE) {
              value = src;
            } else {
              const {
                lineWidth
              } = resolveSeq.binaryOptions;
              const n = Math.ceil(src.length / lineWidth);
              const lines = new Array(n);
              for (let i2 = 0, o = 0; i2 < n; ++i2, o += lineWidth) {
                lines[i2] = src.substr(o, lineWidth);
              }
              value = lines.join(type === PlainValue.Type.BLOCK_LITERAL ? "\n" : " ");
            }
            return resolveSeq.stringifyString({
              comment,
              type,
              value
            }, ctx, onComment, onChompKeep);
          }
        };
        function parsePairs(doc, cst) {
          const seq = resolveSeq.resolveSeq(doc, cst);
          for (let i2 = 0; i2 < seq.items.length; ++i2) {
            let item = seq.items[i2];
            if (item instanceof resolveSeq.Pair)
              continue;
            else if (item instanceof resolveSeq.YAMLMap) {
              if (item.items.length > 1) {
                const msg = "Each pair must have its own sequence indicator";
                throw new PlainValue.YAMLSemanticError(cst, msg);
              }
              const pair = item.items[0] || new resolveSeq.Pair();
              if (item.commentBefore)
                pair.commentBefore = pair.commentBefore ? `${item.commentBefore}
${pair.commentBefore}` : item.commentBefore;
              if (item.comment)
                pair.comment = pair.comment ? `${item.comment}
${pair.comment}` : item.comment;
              item = pair;
            }
            seq.items[i2] = item instanceof resolveSeq.Pair ? item : new resolveSeq.Pair(item);
          }
          return seq;
        }
        function createPairs(schema, iterable, ctx) {
          const pairs2 = new resolveSeq.YAMLSeq(schema);
          pairs2.tag = "tag:yaml.org,2002:pairs";
          for (const it of iterable) {
            let key, value;
            if (Array.isArray(it)) {
              if (it.length === 2) {
                key = it[0];
                value = it[1];
              } else
                throw new TypeError(`Expected [key, value] tuple: ${it}`);
            } else if (it && it instanceof Object) {
              const keys = Object.keys(it);
              if (keys.length === 1) {
                key = keys[0];
                value = it[key];
              } else
                throw new TypeError(`Expected { key: value } tuple: ${it}`);
            } else {
              key = it;
            }
            const pair = schema.createPair(key, value, ctx);
            pairs2.items.push(pair);
          }
          return pairs2;
        }
        var pairs = {
          default: false,
          tag: "tag:yaml.org,2002:pairs",
          resolve: parsePairs,
          createNode: createPairs
        };
        var YAMLOMap = class extends resolveSeq.YAMLSeq {
          constructor() {
            super();
            PlainValue._defineProperty(this, "add", resolveSeq.YAMLMap.prototype.add.bind(this));
            PlainValue._defineProperty(this, "delete", resolveSeq.YAMLMap.prototype.delete.bind(this));
            PlainValue._defineProperty(this, "get", resolveSeq.YAMLMap.prototype.get.bind(this));
            PlainValue._defineProperty(this, "has", resolveSeq.YAMLMap.prototype.has.bind(this));
            PlainValue._defineProperty(this, "set", resolveSeq.YAMLMap.prototype.set.bind(this));
            this.tag = YAMLOMap.tag;
          }
          toJSON(_, ctx) {
            const map = /* @__PURE__ */ new Map();
            if (ctx && ctx.onCreate)
              ctx.onCreate(map);
            for (const pair of this.items) {
              let key, value;
              if (pair instanceof resolveSeq.Pair) {
                key = resolveSeq.toJSON(pair.key, "", ctx);
                value = resolveSeq.toJSON(pair.value, key, ctx);
              } else {
                key = resolveSeq.toJSON(pair, "", ctx);
              }
              if (map.has(key))
                throw new Error("Ordered maps must not include duplicate keys");
              map.set(key, value);
            }
            return map;
          }
        };
        PlainValue._defineProperty(YAMLOMap, "tag", "tag:yaml.org,2002:omap");
        function parseOMap(doc, cst) {
          const pairs2 = parsePairs(doc, cst);
          const seenKeys = [];
          for (const {
            key
          } of pairs2.items) {
            if (key instanceof resolveSeq.Scalar) {
              if (seenKeys.includes(key.value)) {
                const msg = "Ordered maps must not include duplicate keys";
                throw new PlainValue.YAMLSemanticError(cst, msg);
              } else {
                seenKeys.push(key.value);
              }
            }
          }
          return Object.assign(new YAMLOMap(), pairs2);
        }
        function createOMap(schema, iterable, ctx) {
          const pairs2 = createPairs(schema, iterable, ctx);
          const omap2 = new YAMLOMap();
          omap2.items = pairs2.items;
          return omap2;
        }
        var omap = {
          identify: (value) => value instanceof Map,
          nodeClass: YAMLOMap,
          default: false,
          tag: "tag:yaml.org,2002:omap",
          resolve: parseOMap,
          createNode: createOMap
        };
        var YAMLSet = class extends resolveSeq.YAMLMap {
          constructor() {
            super();
            this.tag = YAMLSet.tag;
          }
          add(key) {
            const pair = key instanceof resolveSeq.Pair ? key : new resolveSeq.Pair(key);
            const prev = resolveSeq.findPair(this.items, pair.key);
            if (!prev)
              this.items.push(pair);
          }
          get(key, keepPair) {
            const pair = resolveSeq.findPair(this.items, key);
            return !keepPair && pair instanceof resolveSeq.Pair ? pair.key instanceof resolveSeq.Scalar ? pair.key.value : pair.key : pair;
          }
          set(key, value) {
            if (typeof value !== "boolean")
              throw new Error(`Expected boolean value for set(key, value) in a YAML set, not ${typeof value}`);
            const prev = resolveSeq.findPair(this.items, key);
            if (prev && !value) {
              this.items.splice(this.items.indexOf(prev), 1);
            } else if (!prev && value) {
              this.items.push(new resolveSeq.Pair(key));
            }
          }
          toJSON(_, ctx) {
            return super.toJSON(_, ctx, Set);
          }
          toString(ctx, onComment, onChompKeep) {
            if (!ctx)
              return JSON.stringify(this);
            if (this.hasAllNullValues())
              return super.toString(ctx, onComment, onChompKeep);
            else
              throw new Error("Set items must all have null values");
          }
        };
        PlainValue._defineProperty(YAMLSet, "tag", "tag:yaml.org,2002:set");
        function parseSet(doc, cst) {
          const map = resolveSeq.resolveMap(doc, cst);
          if (!map.hasAllNullValues())
            throw new PlainValue.YAMLSemanticError(cst, "Set items must all have null values");
          return Object.assign(new YAMLSet(), map);
        }
        function createSet(schema, iterable, ctx) {
          const set2 = new YAMLSet();
          for (const value of iterable)
            set2.items.push(schema.createPair(value, null, ctx));
          return set2;
        }
        var set = {
          identify: (value) => value instanceof Set,
          nodeClass: YAMLSet,
          default: false,
          tag: "tag:yaml.org,2002:set",
          resolve: parseSet,
          createNode: createSet
        };
        var parseSexagesimal = (sign, parts) => {
          const n = parts.split(":").reduce((n2, p) => n2 * 60 + Number(p), 0);
          return sign === "-" ? -n : n;
        };
        var stringifySexagesimal = ({
          value
        }) => {
          if (isNaN(value) || !isFinite(value))
            return resolveSeq.stringifyNumber(value);
          let sign = "";
          if (value < 0) {
            sign = "-";
            value = Math.abs(value);
          }
          const parts = [value % 60];
          if (value < 60) {
            parts.unshift(0);
          } else {
            value = Math.round((value - parts[0]) / 60);
            parts.unshift(value % 60);
            if (value >= 60) {
              value = Math.round((value - parts[0]) / 60);
              parts.unshift(value);
            }
          }
          return sign + parts.map((n) => n < 10 ? "0" + String(n) : String(n)).join(":").replace(/000000\d*$/, "");
        };
        var intTime = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "TIME",
          test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+)$/,
          resolve: (str, sign, parts) => parseSexagesimal(sign, parts.replace(/_/g, "")),
          stringify: stringifySexagesimal
        };
        var floatTime = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          format: "TIME",
          test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*)$/,
          resolve: (str, sign, parts) => parseSexagesimal(sign, parts.replace(/_/g, "")),
          stringify: stringifySexagesimal
        };
        var timestamp = {
          identify: (value) => value instanceof Date,
          default: true,
          tag: "tag:yaml.org,2002:timestamp",
          test: RegExp("^(?:([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?)$"),
          resolve: (str, year, month, day, hour, minute, second, millisec, tz) => {
            if (millisec)
              millisec = (millisec + "00").substr(1, 3);
            let date = Date.UTC(year, month - 1, day, hour || 0, minute || 0, second || 0, millisec || 0);
            if (tz && tz !== "Z") {
              let d = parseSexagesimal(tz[0], tz.slice(1));
              if (Math.abs(d) < 30)
                d *= 60;
              date -= 6e4 * d;
            }
            return new Date(date);
          },
          stringify: ({
            value
          }) => value.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "")
        };
        function shouldWarn(deprecation) {
          const env = typeof process !== "undefined" && process.env || {};
          if (deprecation) {
            if (typeof YAML_SILENCE_DEPRECATION_WARNINGS !== "undefined")
              return !YAML_SILENCE_DEPRECATION_WARNINGS;
            return !env.YAML_SILENCE_DEPRECATION_WARNINGS;
          }
          if (typeof YAML_SILENCE_WARNINGS !== "undefined")
            return !YAML_SILENCE_WARNINGS;
          return !env.YAML_SILENCE_WARNINGS;
        }
        function warn2(warning2, type) {
          if (shouldWarn(false)) {
            const emit = typeof process !== "undefined" && process.emitWarning;
            if (emit)
              emit(warning2, type);
            else {
              console.warn(type ? `${type}: ${warning2}` : warning2);
            }
          }
        }
        function warnFileDeprecation(filename) {
          if (shouldWarn(true)) {
            const path4 = filename.replace(/.*yaml[/\\]/i, "").replace(/\.js$/, "").replace(/\\/g, "/");
            warn2(`The endpoint 'yaml/${path4}' will be removed in a future release.`, "DeprecationWarning");
          }
        }
        var warned = {};
        function warnOptionDeprecation(name, alternative) {
          if (!warned[name] && shouldWarn(true)) {
            warned[name] = true;
            let msg = `The option '${name}' will be removed in a future release`;
            msg += alternative ? `, use '${alternative}' instead.` : ".";
            warn2(msg, "DeprecationWarning");
          }
        }
        exports2.binary = binary;
        exports2.floatTime = floatTime;
        exports2.intTime = intTime;
        exports2.omap = omap;
        exports2.pairs = pairs;
        exports2.set = set;
        exports2.timestamp = timestamp;
        exports2.warn = warn2;
        exports2.warnFileDeprecation = warnFileDeprecation;
        exports2.warnOptionDeprecation = warnOptionDeprecation;
      }
    });
    var require_Schema_88e323a7 = __commonJS2({
      "node_modules/yaml/dist/Schema-88e323a7.js"(exports2) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        var resolveSeq = require_resolveSeq_d03cb037();
        var warnings = require_warnings_1000a372();
        function createMap(schema, obj, ctx) {
          const map2 = new resolveSeq.YAMLMap(schema);
          if (obj instanceof Map) {
            for (const [key, value] of obj)
              map2.items.push(schema.createPair(key, value, ctx));
          } else if (obj && typeof obj === "object") {
            for (const key of Object.keys(obj))
              map2.items.push(schema.createPair(key, obj[key], ctx));
          }
          if (typeof schema.sortMapEntries === "function") {
            map2.items.sort(schema.sortMapEntries);
          }
          return map2;
        }
        var map = {
          createNode: createMap,
          default: true,
          nodeClass: resolveSeq.YAMLMap,
          tag: "tag:yaml.org,2002:map",
          resolve: resolveSeq.resolveMap
        };
        function createSeq(schema, obj, ctx) {
          const seq2 = new resolveSeq.YAMLSeq(schema);
          if (obj && obj[Symbol.iterator]) {
            for (const it of obj) {
              const v = schema.createNode(it, ctx.wrapScalars, null, ctx);
              seq2.items.push(v);
            }
          }
          return seq2;
        }
        var seq = {
          createNode: createSeq,
          default: true,
          nodeClass: resolveSeq.YAMLSeq,
          tag: "tag:yaml.org,2002:seq",
          resolve: resolveSeq.resolveSeq
        };
        var string = {
          identify: (value) => typeof value === "string",
          default: true,
          tag: "tag:yaml.org,2002:str",
          resolve: resolveSeq.resolveString,
          stringify(item, ctx, onComment, onChompKeep) {
            ctx = Object.assign({
              actualString: true
            }, ctx);
            return resolveSeq.stringifyString(item, ctx, onComment, onChompKeep);
          },
          options: resolveSeq.strOptions
        };
        var failsafe = [map, seq, string];
        var intIdentify$2 = (value) => typeof value === "bigint" || Number.isInteger(value);
        var intResolve$1 = (src, part, radix) => resolveSeq.intOptions.asBigInt ? BigInt(src) : parseInt(part, radix);
        function intStringify$1(node, radix, prefix2) {
          const {
            value
          } = node;
          if (intIdentify$2(value) && value >= 0)
            return prefix2 + value.toString(radix);
          return resolveSeq.stringifyNumber(node);
        }
        var nullObj = {
          identify: (value) => value == null,
          createNode: (schema, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
          default: true,
          tag: "tag:yaml.org,2002:null",
          test: /^(?:~|[Nn]ull|NULL)?$/,
          resolve: () => null,
          options: resolveSeq.nullOptions,
          stringify: () => resolveSeq.nullOptions.nullStr
        };
        var boolObj = {
          identify: (value) => typeof value === "boolean",
          default: true,
          tag: "tag:yaml.org,2002:bool",
          test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/,
          resolve: (str) => str[0] === "t" || str[0] === "T",
          options: resolveSeq.boolOptions,
          stringify: ({
            value
          }) => value ? resolveSeq.boolOptions.trueStr : resolveSeq.boolOptions.falseStr
        };
        var octObj = {
          identify: (value) => intIdentify$2(value) && value >= 0,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "OCT",
          test: /^0o([0-7]+)$/,
          resolve: (str, oct) => intResolve$1(str, oct, 8),
          options: resolveSeq.intOptions,
          stringify: (node) => intStringify$1(node, 8, "0o")
        };
        var intObj = {
          identify: intIdentify$2,
          default: true,
          tag: "tag:yaml.org,2002:int",
          test: /^[-+]?[0-9]+$/,
          resolve: (str) => intResolve$1(str, str, 10),
          options: resolveSeq.intOptions,
          stringify: resolveSeq.stringifyNumber
        };
        var hexObj = {
          identify: (value) => intIdentify$2(value) && value >= 0,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "HEX",
          test: /^0x([0-9a-fA-F]+)$/,
          resolve: (str, hex) => intResolve$1(str, hex, 16),
          options: resolveSeq.intOptions,
          stringify: (node) => intStringify$1(node, 16, "0x")
        };
        var nanObj = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^(?:[-+]?\.inf|(\.nan))$/i,
          resolve: (str, nan) => nan ? NaN : str[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
          stringify: resolveSeq.stringifyNumber
        };
        var expObj = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          format: "EXP",
          test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/,
          resolve: (str) => parseFloat(str),
          stringify: ({
            value
          }) => Number(value).toExponential()
        };
        var floatObj = {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^[-+]?(?:\.([0-9]+)|[0-9]+\.([0-9]*))$/,
          resolve(str, frac1, frac2) {
            const frac = frac1 || frac2;
            const node = new resolveSeq.Scalar(parseFloat(str));
            if (frac && frac[frac.length - 1] === "0")
              node.minFractionDigits = frac.length;
            return node;
          },
          stringify: resolveSeq.stringifyNumber
        };
        var core2 = failsafe.concat([nullObj, boolObj, octObj, intObj, hexObj, nanObj, expObj, floatObj]);
        var intIdentify$1 = (value) => typeof value === "bigint" || Number.isInteger(value);
        var stringifyJSON = ({
          value
        }) => JSON.stringify(value);
        var json = [map, seq, {
          identify: (value) => typeof value === "string",
          default: true,
          tag: "tag:yaml.org,2002:str",
          resolve: resolveSeq.resolveString,
          stringify: stringifyJSON
        }, {
          identify: (value) => value == null,
          createNode: (schema, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
          default: true,
          tag: "tag:yaml.org,2002:null",
          test: /^null$/,
          resolve: () => null,
          stringify: stringifyJSON
        }, {
          identify: (value) => typeof value === "boolean",
          default: true,
          tag: "tag:yaml.org,2002:bool",
          test: /^true|false$/,
          resolve: (str) => str === "true",
          stringify: stringifyJSON
        }, {
          identify: intIdentify$1,
          default: true,
          tag: "tag:yaml.org,2002:int",
          test: /^-?(?:0|[1-9][0-9]*)$/,
          resolve: (str) => resolveSeq.intOptions.asBigInt ? BigInt(str) : parseInt(str, 10),
          stringify: ({
            value
          }) => intIdentify$1(value) ? value.toString() : JSON.stringify(value)
        }, {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/,
          resolve: (str) => parseFloat(str),
          stringify: stringifyJSON
        }];
        json.scalarFallback = (str) => {
          throw new SyntaxError(`Unresolved plain scalar ${JSON.stringify(str)}`);
        };
        var boolStringify = ({
          value
        }) => value ? resolveSeq.boolOptions.trueStr : resolveSeq.boolOptions.falseStr;
        var intIdentify = (value) => typeof value === "bigint" || Number.isInteger(value);
        function intResolve(sign, src, radix) {
          let str = src.replace(/_/g, "");
          if (resolveSeq.intOptions.asBigInt) {
            switch (radix) {
              case 2:
                str = `0b${str}`;
                break;
              case 8:
                str = `0o${str}`;
                break;
              case 16:
                str = `0x${str}`;
                break;
            }
            const n2 = BigInt(str);
            return sign === "-" ? BigInt(-1) * n2 : n2;
          }
          const n = parseInt(str, radix);
          return sign === "-" ? -1 * n : n;
        }
        function intStringify(node, radix, prefix2) {
          const {
            value
          } = node;
          if (intIdentify(value)) {
            const str = value.toString(radix);
            return value < 0 ? "-" + prefix2 + str.substr(1) : prefix2 + str;
          }
          return resolveSeq.stringifyNumber(node);
        }
        var yaml11 = failsafe.concat([{
          identify: (value) => value == null,
          createNode: (schema, value, ctx) => ctx.wrapScalars ? new resolveSeq.Scalar(null) : null,
          default: true,
          tag: "tag:yaml.org,2002:null",
          test: /^(?:~|[Nn]ull|NULL)?$/,
          resolve: () => null,
          options: resolveSeq.nullOptions,
          stringify: () => resolveSeq.nullOptions.nullStr
        }, {
          identify: (value) => typeof value === "boolean",
          default: true,
          tag: "tag:yaml.org,2002:bool",
          test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/,
          resolve: () => true,
          options: resolveSeq.boolOptions,
          stringify: boolStringify
        }, {
          identify: (value) => typeof value === "boolean",
          default: true,
          tag: "tag:yaml.org,2002:bool",
          test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/i,
          resolve: () => false,
          options: resolveSeq.boolOptions,
          stringify: boolStringify
        }, {
          identify: intIdentify,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "BIN",
          test: /^([-+]?)0b([0-1_]+)$/,
          resolve: (str, sign, bin) => intResolve(sign, bin, 2),
          stringify: (node) => intStringify(node, 2, "0b")
        }, {
          identify: intIdentify,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "OCT",
          test: /^([-+]?)0([0-7_]+)$/,
          resolve: (str, sign, oct) => intResolve(sign, oct, 8),
          stringify: (node) => intStringify(node, 8, "0")
        }, {
          identify: intIdentify,
          default: true,
          tag: "tag:yaml.org,2002:int",
          test: /^([-+]?)([0-9][0-9_]*)$/,
          resolve: (str, sign, abs) => intResolve(sign, abs, 10),
          stringify: resolveSeq.stringifyNumber
        }, {
          identify: intIdentify,
          default: true,
          tag: "tag:yaml.org,2002:int",
          format: "HEX",
          test: /^([-+]?)0x([0-9a-fA-F_]+)$/,
          resolve: (str, sign, hex) => intResolve(sign, hex, 16),
          stringify: (node) => intStringify(node, 16, "0x")
        }, {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^(?:[-+]?\.inf|(\.nan))$/i,
          resolve: (str, nan) => nan ? NaN : str[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY,
          stringify: resolveSeq.stringifyNumber
        }, {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          format: "EXP",
          test: /^[-+]?([0-9][0-9_]*)?(\.[0-9_]*)?[eE][-+]?[0-9]+$/,
          resolve: (str) => parseFloat(str.replace(/_/g, "")),
          stringify: ({
            value
          }) => Number(value).toExponential()
        }, {
          identify: (value) => typeof value === "number",
          default: true,
          tag: "tag:yaml.org,2002:float",
          test: /^[-+]?(?:[0-9][0-9_]*)?\.([0-9_]*)$/,
          resolve(str, frac) {
            const node = new resolveSeq.Scalar(parseFloat(str.replace(/_/g, "")));
            if (frac) {
              const f3 = frac.replace(/_/g, "");
              if (f3[f3.length - 1] === "0")
                node.minFractionDigits = f3.length;
            }
            return node;
          },
          stringify: resolveSeq.stringifyNumber
        }], warnings.binary, warnings.omap, warnings.pairs, warnings.set, warnings.intTime, warnings.floatTime, warnings.timestamp);
        var schemas = {
          core: core2,
          failsafe,
          json,
          yaml11
        };
        var tags = {
          binary: warnings.binary,
          bool: boolObj,
          float: floatObj,
          floatExp: expObj,
          floatNaN: nanObj,
          floatTime: warnings.floatTime,
          int: intObj,
          intHex: hexObj,
          intOct: octObj,
          intTime: warnings.intTime,
          map,
          null: nullObj,
          omap: warnings.omap,
          pairs: warnings.pairs,
          seq,
          set: warnings.set,
          timestamp: warnings.timestamp
        };
        function findTagObject(value, tagName, tags2) {
          if (tagName) {
            const match = tags2.filter((t2) => t2.tag === tagName);
            const tagObj = match.find((t2) => !t2.format) || match[0];
            if (!tagObj)
              throw new Error(`Tag ${tagName} not found`);
            return tagObj;
          }
          return tags2.find((t2) => (t2.identify && t2.identify(value) || t2.class && value instanceof t2.class) && !t2.format);
        }
        function createNode(value, tagName, ctx) {
          if (value instanceof resolveSeq.Node)
            return value;
          const {
            defaultPrefix,
            onTagObj,
            prevObjects,
            schema,
            wrapScalars
          } = ctx;
          if (tagName && tagName.startsWith("!!"))
            tagName = defaultPrefix + tagName.slice(2);
          let tagObj = findTagObject(value, tagName, schema.tags);
          if (!tagObj) {
            if (typeof value.toJSON === "function")
              value = value.toJSON();
            if (!value || typeof value !== "object")
              return wrapScalars ? new resolveSeq.Scalar(value) : value;
            tagObj = value instanceof Map ? map : value[Symbol.iterator] ? seq : map;
          }
          if (onTagObj) {
            onTagObj(tagObj);
            delete ctx.onTagObj;
          }
          const obj = {
            value: void 0,
            node: void 0
          };
          if (value && typeof value === "object" && prevObjects) {
            const prev = prevObjects.get(value);
            if (prev) {
              const alias = new resolveSeq.Alias(prev);
              ctx.aliasNodes.push(alias);
              return alias;
            }
            obj.value = value;
            prevObjects.set(value, obj);
          }
          obj.node = tagObj.createNode ? tagObj.createNode(ctx.schema, value, ctx) : wrapScalars ? new resolveSeq.Scalar(value) : value;
          if (tagName && obj.node instanceof resolveSeq.Node)
            obj.node.tag = tagName;
          return obj.node;
        }
        function getSchemaTags(schemas2, knownTags, customTags, schemaId) {
          let tags2 = schemas2[schemaId.replace(/\W/g, "")];
          if (!tags2) {
            const keys = Object.keys(schemas2).map((key) => JSON.stringify(key)).join(", ");
            throw new Error(`Unknown schema "${schemaId}"; use one of ${keys}`);
          }
          if (Array.isArray(customTags)) {
            for (const tag of customTags)
              tags2 = tags2.concat(tag);
          } else if (typeof customTags === "function") {
            tags2 = customTags(tags2.slice());
          }
          for (let i2 = 0; i2 < tags2.length; ++i2) {
            const tag = tags2[i2];
            if (typeof tag === "string") {
              const tagObj = knownTags[tag];
              if (!tagObj) {
                const keys = Object.keys(knownTags).map((key) => JSON.stringify(key)).join(", ");
                throw new Error(`Unknown custom tag "${tag}"; use one of ${keys}`);
              }
              tags2[i2] = tagObj;
            }
          }
          return tags2;
        }
        var sortMapEntriesByKey = (a, b) => a.key < b.key ? -1 : a.key > b.key ? 1 : 0;
        var Schema = class {
          constructor({
            customTags,
            merge: merge2,
            schema,
            sortMapEntries,
            tags: deprecatedCustomTags
          }) {
            this.merge = !!merge2;
            this.name = schema;
            this.sortMapEntries = sortMapEntries === true ? sortMapEntriesByKey : sortMapEntries || null;
            if (!customTags && deprecatedCustomTags)
              warnings.warnOptionDeprecation("tags", "customTags");
            this.tags = getSchemaTags(schemas, tags, customTags || deprecatedCustomTags, schema);
          }
          createNode(value, wrapScalars, tagName, ctx) {
            const baseCtx = {
              defaultPrefix: Schema.defaultPrefix,
              schema: this,
              wrapScalars
            };
            const createCtx = ctx ? Object.assign(ctx, baseCtx) : baseCtx;
            return createNode(value, tagName, createCtx);
          }
          createPair(key, value, ctx) {
            if (!ctx)
              ctx = {
                wrapScalars: true
              };
            const k = this.createNode(key, ctx.wrapScalars, null, ctx);
            const v = this.createNode(value, ctx.wrapScalars, null, ctx);
            return new resolveSeq.Pair(k, v);
          }
        };
        PlainValue._defineProperty(Schema, "defaultPrefix", PlainValue.defaultTagPrefix);
        PlainValue._defineProperty(Schema, "defaultTags", PlainValue.defaultTags);
        exports2.Schema = Schema;
      }
    });
    var require_Document_9b4560a1 = __commonJS2({
      "node_modules/yaml/dist/Document-9b4560a1.js"(exports2) {
        "use strict";
        var PlainValue = require_PlainValue_ec8e588e();
        var resolveSeq = require_resolveSeq_d03cb037();
        var Schema = require_Schema_88e323a7();
        var defaultOptions = {
          anchorPrefix: "a",
          customTags: null,
          indent: 2,
          indentSeq: true,
          keepCstNodes: false,
          keepNodeTypes: true,
          keepBlobsInJSON: true,
          mapAsMap: false,
          maxAliasCount: 100,
          prettyErrors: false,
          simpleKeys: false,
          version: "1.2"
        };
        var scalarOptions = {
          get binary() {
            return resolveSeq.binaryOptions;
          },
          set binary(opt) {
            Object.assign(resolveSeq.binaryOptions, opt);
          },
          get bool() {
            return resolveSeq.boolOptions;
          },
          set bool(opt) {
            Object.assign(resolveSeq.boolOptions, opt);
          },
          get int() {
            return resolveSeq.intOptions;
          },
          set int(opt) {
            Object.assign(resolveSeq.intOptions, opt);
          },
          get null() {
            return resolveSeq.nullOptions;
          },
          set null(opt) {
            Object.assign(resolveSeq.nullOptions, opt);
          },
          get str() {
            return resolveSeq.strOptions;
          },
          set str(opt) {
            Object.assign(resolveSeq.strOptions, opt);
          }
        };
        var documentOptions = {
          "1.0": {
            schema: "yaml-1.1",
            merge: true,
            tagPrefixes: [{
              handle: "!",
              prefix: PlainValue.defaultTagPrefix
            }, {
              handle: "!!",
              prefix: "tag:private.yaml.org,2002:"
            }]
          },
          1.1: {
            schema: "yaml-1.1",
            merge: true,
            tagPrefixes: [{
              handle: "!",
              prefix: "!"
            }, {
              handle: "!!",
              prefix: PlainValue.defaultTagPrefix
            }]
          },
          1.2: {
            schema: "core",
            merge: false,
            tagPrefixes: [{
              handle: "!",
              prefix: "!"
            }, {
              handle: "!!",
              prefix: PlainValue.defaultTagPrefix
            }]
          }
        };
        function stringifyTag(doc, tag) {
          if ((doc.version || doc.options.version) === "1.0") {
            const priv = tag.match(/^tag:private\.yaml\.org,2002:([^:/]+)$/);
            if (priv)
              return "!" + priv[1];
            const vocab = tag.match(/^tag:([a-zA-Z0-9-]+)\.yaml\.org,2002:(.*)/);
            return vocab ? `!${vocab[1]}/${vocab[2]}` : `!${tag.replace(/^tag:/, "")}`;
          }
          let p = doc.tagPrefixes.find((p2) => tag.indexOf(p2.prefix) === 0);
          if (!p) {
            const dtp = doc.getDefaults().tagPrefixes;
            p = dtp && dtp.find((p2) => tag.indexOf(p2.prefix) === 0);
          }
          if (!p)
            return tag[0] === "!" ? tag : `!<${tag}>`;
          const suffix = tag.substr(p.prefix.length).replace(/[!,[\]{}]/g, (ch) => ({
            "!": "%21",
            ",": "%2C",
            "[": "%5B",
            "]": "%5D",
            "{": "%7B",
            "}": "%7D"
          })[ch]);
          return p.handle + suffix;
        }
        function getTagObject(tags, item) {
          if (item instanceof resolveSeq.Alias)
            return resolveSeq.Alias;
          if (item.tag) {
            const match = tags.filter((t2) => t2.tag === item.tag);
            if (match.length > 0)
              return match.find((t2) => t2.format === item.format) || match[0];
          }
          let tagObj, obj;
          if (item instanceof resolveSeq.Scalar) {
            obj = item.value;
            const match = tags.filter((t2) => t2.identify && t2.identify(obj) || t2.class && obj instanceof t2.class);
            tagObj = match.find((t2) => t2.format === item.format) || match.find((t2) => !t2.format);
          } else {
            obj = item;
            tagObj = tags.find((t2) => t2.nodeClass && obj instanceof t2.nodeClass);
          }
          if (!tagObj) {
            const name = obj && obj.constructor ? obj.constructor.name : typeof obj;
            throw new Error(`Tag not resolved for ${name} value`);
          }
          return tagObj;
        }
        function stringifyProps(node, tagObj, {
          anchors,
          doc
        }) {
          const props = [];
          const anchor = doc.anchors.getName(node);
          if (anchor) {
            anchors[anchor] = node;
            props.push(`&${anchor}`);
          }
          if (node.tag) {
            props.push(stringifyTag(doc, node.tag));
          } else if (!tagObj.default) {
            props.push(stringifyTag(doc, tagObj.tag));
          }
          return props.join(" ");
        }
        function stringify(item, ctx, onComment, onChompKeep) {
          const {
            anchors,
            schema
          } = ctx.doc;
          let tagObj;
          if (!(item instanceof resolveSeq.Node)) {
            const createCtx = {
              aliasNodes: [],
              onTagObj: (o) => tagObj = o,
              prevObjects: /* @__PURE__ */ new Map()
            };
            item = schema.createNode(item, true, null, createCtx);
            for (const alias of createCtx.aliasNodes) {
              alias.source = alias.source.node;
              let name = anchors.getName(alias.source);
              if (!name) {
                name = anchors.newName();
                anchors.map[name] = alias.source;
              }
            }
          }
          if (item instanceof resolveSeq.Pair)
            return item.toString(ctx, onComment, onChompKeep);
          if (!tagObj)
            tagObj = getTagObject(schema.tags, item);
          const props = stringifyProps(item, tagObj, ctx);
          if (props.length > 0)
            ctx.indentAtStart = (ctx.indentAtStart || 0) + props.length + 1;
          const str = typeof tagObj.stringify === "function" ? tagObj.stringify(item, ctx, onComment, onChompKeep) : item instanceof resolveSeq.Scalar ? resolveSeq.stringifyString(item, ctx, onComment, onChompKeep) : item.toString(ctx, onComment, onChompKeep);
          if (!props)
            return str;
          return item instanceof resolveSeq.Scalar || str[0] === "{" || str[0] === "[" ? `${props} ${str}` : `${props}
${ctx.indent}${str}`;
        }
        var Anchors = class {
          static validAnchorNode(node) {
            return node instanceof resolveSeq.Scalar || node instanceof resolveSeq.YAMLSeq || node instanceof resolveSeq.YAMLMap;
          }
          constructor(prefix2) {
            PlainValue._defineProperty(this, "map", /* @__PURE__ */ Object.create(null));
            this.prefix = prefix2;
          }
          createAlias(node, name) {
            this.setAnchor(node, name);
            return new resolveSeq.Alias(node);
          }
          createMergePair(...sources) {
            const merge2 = new resolveSeq.Merge();
            merge2.value.items = sources.map((s2) => {
              if (s2 instanceof resolveSeq.Alias) {
                if (s2.source instanceof resolveSeq.YAMLMap)
                  return s2;
              } else if (s2 instanceof resolveSeq.YAMLMap) {
                return this.createAlias(s2);
              }
              throw new Error("Merge sources must be Map nodes or their Aliases");
            });
            return merge2;
          }
          getName(node) {
            const {
              map
            } = this;
            return Object.keys(map).find((a) => map[a] === node);
          }
          getNames() {
            return Object.keys(this.map);
          }
          getNode(name) {
            return this.map[name];
          }
          newName(prefix2) {
            if (!prefix2)
              prefix2 = this.prefix;
            const names = Object.keys(this.map);
            for (let i2 = 1; true; ++i2) {
              const name = `${prefix2}${i2}`;
              if (!names.includes(name))
                return name;
            }
          }
          resolveNodes() {
            const {
              map,
              _cstAliases
            } = this;
            Object.keys(map).forEach((a) => {
              map[a] = map[a].resolved;
            });
            _cstAliases.forEach((a) => {
              a.source = a.source.resolved;
            });
            delete this._cstAliases;
          }
          setAnchor(node, name) {
            if (node != null && !Anchors.validAnchorNode(node)) {
              throw new Error("Anchors may only be set for Scalar, Seq and Map nodes");
            }
            if (name && /[\x00-\x19\s,[\]{}]/.test(name)) {
              throw new Error("Anchor names must not contain whitespace or control characters");
            }
            const {
              map
            } = this;
            const prev = node && Object.keys(map).find((a) => map[a] === node);
            if (prev) {
              if (!name) {
                return prev;
              } else if (prev !== name) {
                delete map[prev];
                map[name] = node;
              }
            } else {
              if (!name) {
                if (!node)
                  return null;
                name = this.newName();
              }
              map[name] = node;
            }
            return name;
          }
        };
        var visit = (node, tags) => {
          if (node && typeof node === "object") {
            const {
              tag
            } = node;
            if (node instanceof resolveSeq.Collection) {
              if (tag)
                tags[tag] = true;
              node.items.forEach((n) => visit(n, tags));
            } else if (node instanceof resolveSeq.Pair) {
              visit(node.key, tags);
              visit(node.value, tags);
            } else if (node instanceof resolveSeq.Scalar) {
              if (tag)
                tags[tag] = true;
            }
          }
          return tags;
        };
        var listTagNames = (node) => Object.keys(visit(node, {}));
        function parseContents(doc, contents) {
          const comments = {
            before: [],
            after: []
          };
          let body = void 0;
          let spaceBefore = false;
          for (const node of contents) {
            if (node.valueRange) {
              if (body !== void 0) {
                const msg = "Document contains trailing content not separated by a ... or --- line";
                doc.errors.push(new PlainValue.YAMLSyntaxError(node, msg));
                break;
              }
              const res = resolveSeq.resolveNode(doc, node);
              if (spaceBefore) {
                res.spaceBefore = true;
                spaceBefore = false;
              }
              body = res;
            } else if (node.comment !== null) {
              const cc = body === void 0 ? comments.before : comments.after;
              cc.push(node.comment);
            } else if (node.type === PlainValue.Type.BLANK_LINE) {
              spaceBefore = true;
              if (body === void 0 && comments.before.length > 0 && !doc.commentBefore) {
                doc.commentBefore = comments.before.join("\n");
                comments.before = [];
              }
            }
          }
          doc.contents = body || null;
          if (!body) {
            doc.comment = comments.before.concat(comments.after).join("\n") || null;
          } else {
            const cb = comments.before.join("\n");
            if (cb) {
              const cbNode = body instanceof resolveSeq.Collection && body.items[0] ? body.items[0] : body;
              cbNode.commentBefore = cbNode.commentBefore ? `${cb}
${cbNode.commentBefore}` : cb;
            }
            doc.comment = comments.after.join("\n") || null;
          }
        }
        function resolveTagDirective({
          tagPrefixes
        }, directive) {
          const [handle, prefix2] = directive.parameters;
          if (!handle || !prefix2) {
            const msg = "Insufficient parameters given for %TAG directive";
            throw new PlainValue.YAMLSemanticError(directive, msg);
          }
          if (tagPrefixes.some((p) => p.handle === handle)) {
            const msg = "The %TAG directive must only be given at most once per handle in the same document.";
            throw new PlainValue.YAMLSemanticError(directive, msg);
          }
          return {
            handle,
            prefix: prefix2
          };
        }
        function resolveYamlDirective(doc, directive) {
          let [version] = directive.parameters;
          if (directive.name === "YAML:1.0")
            version = "1.0";
          if (!version) {
            const msg = "Insufficient parameters given for %YAML directive";
            throw new PlainValue.YAMLSemanticError(directive, msg);
          }
          if (!documentOptions[version]) {
            const v0 = doc.version || doc.options.version;
            const msg = `Document will be parsed as YAML ${v0} rather than YAML ${version}`;
            doc.warnings.push(new PlainValue.YAMLWarning(directive, msg));
          }
          return version;
        }
        function parseDirectives(doc, directives, prevDoc) {
          const directiveComments = [];
          let hasDirectives = false;
          for (const directive of directives) {
            const {
              comment,
              name
            } = directive;
            switch (name) {
              case "TAG":
                try {
                  doc.tagPrefixes.push(resolveTagDirective(doc, directive));
                } catch (error) {
                  doc.errors.push(error);
                }
                hasDirectives = true;
                break;
              case "YAML":
              case "YAML:1.0":
                if (doc.version) {
                  const msg = "The %YAML directive must only be given at most once per document.";
                  doc.errors.push(new PlainValue.YAMLSemanticError(directive, msg));
                }
                try {
                  doc.version = resolveYamlDirective(doc, directive);
                } catch (error) {
                  doc.errors.push(error);
                }
                hasDirectives = true;
                break;
              default:
                if (name) {
                  const msg = `YAML only supports %TAG and %YAML directives, and not %${name}`;
                  doc.warnings.push(new PlainValue.YAMLWarning(directive, msg));
                }
            }
            if (comment)
              directiveComments.push(comment);
          }
          if (prevDoc && !hasDirectives && (doc.version || prevDoc.version || doc.options.version) === "1.1") {
            const copyTagPrefix = ({
              handle,
              prefix: prefix2
            }) => ({
              handle,
              prefix: prefix2
            });
            doc.tagPrefixes = prevDoc.tagPrefixes.map(copyTagPrefix);
            doc.version = prevDoc.version;
          }
          doc.commentBefore = directiveComments.join("\n") || null;
        }
        function assertCollection(contents) {
          if (contents instanceof resolveSeq.Collection)
            return true;
          throw new Error("Expected a YAML collection as document contents");
        }
        var Document = class {
          constructor(options) {
            this.anchors = new Anchors(options.anchorPrefix);
            this.commentBefore = null;
            this.comment = null;
            this.contents = null;
            this.directivesEndMarker = null;
            this.errors = [];
            this.options = options;
            this.schema = null;
            this.tagPrefixes = [];
            this.version = null;
            this.warnings = [];
          }
          add(value) {
            assertCollection(this.contents);
            return this.contents.add(value);
          }
          addIn(path4, value) {
            assertCollection(this.contents);
            this.contents.addIn(path4, value);
          }
          delete(key) {
            assertCollection(this.contents);
            return this.contents.delete(key);
          }
          deleteIn(path4) {
            if (resolveSeq.isEmptyPath(path4)) {
              if (this.contents == null)
                return false;
              this.contents = null;
              return true;
            }
            assertCollection(this.contents);
            return this.contents.deleteIn(path4);
          }
          getDefaults() {
            return Document.defaults[this.version] || Document.defaults[this.options.version] || {};
          }
          get(key, keepScalar) {
            return this.contents instanceof resolveSeq.Collection ? this.contents.get(key, keepScalar) : void 0;
          }
          getIn(path4, keepScalar) {
            if (resolveSeq.isEmptyPath(path4))
              return !keepScalar && this.contents instanceof resolveSeq.Scalar ? this.contents.value : this.contents;
            return this.contents instanceof resolveSeq.Collection ? this.contents.getIn(path4, keepScalar) : void 0;
          }
          has(key) {
            return this.contents instanceof resolveSeq.Collection ? this.contents.has(key) : false;
          }
          hasIn(path4) {
            if (resolveSeq.isEmptyPath(path4))
              return this.contents !== void 0;
            return this.contents instanceof resolveSeq.Collection ? this.contents.hasIn(path4) : false;
          }
          set(key, value) {
            assertCollection(this.contents);
            this.contents.set(key, value);
          }
          setIn(path4, value) {
            if (resolveSeq.isEmptyPath(path4))
              this.contents = value;
            else {
              assertCollection(this.contents);
              this.contents.setIn(path4, value);
            }
          }
          setSchema(id, customTags) {
            if (!id && !customTags && this.schema)
              return;
            if (typeof id === "number")
              id = id.toFixed(1);
            if (id === "1.0" || id === "1.1" || id === "1.2") {
              if (this.version)
                this.version = id;
              else
                this.options.version = id;
              delete this.options.schema;
            } else if (id && typeof id === "string") {
              this.options.schema = id;
            }
            if (Array.isArray(customTags))
              this.options.customTags = customTags;
            const opt = Object.assign({}, this.getDefaults(), this.options);
            this.schema = new Schema.Schema(opt);
          }
          parse(node, prevDoc) {
            if (this.options.keepCstNodes)
              this.cstNode = node;
            if (this.options.keepNodeTypes)
              this.type = "DOCUMENT";
            const {
              directives = [],
              contents = [],
              directivesEndMarker,
              error,
              valueRange
            } = node;
            if (error) {
              if (!error.source)
                error.source = this;
              this.errors.push(error);
            }
            parseDirectives(this, directives, prevDoc);
            if (directivesEndMarker)
              this.directivesEndMarker = true;
            this.range = valueRange ? [valueRange.start, valueRange.end] : null;
            this.setSchema();
            this.anchors._cstAliases = [];
            parseContents(this, contents);
            this.anchors.resolveNodes();
            if (this.options.prettyErrors) {
              for (const error2 of this.errors)
                if (error2 instanceof PlainValue.YAMLError)
                  error2.makePretty();
              for (const warn2 of this.warnings)
                if (warn2 instanceof PlainValue.YAMLError)
                  warn2.makePretty();
            }
            return this;
          }
          listNonDefaultTags() {
            return listTagNames(this.contents).filter((t2) => t2.indexOf(Schema.Schema.defaultPrefix) !== 0);
          }
          setTagPrefix(handle, prefix2) {
            if (handle[0] !== "!" || handle[handle.length - 1] !== "!")
              throw new Error("Handle must start and end with !");
            if (prefix2) {
              const prev = this.tagPrefixes.find((p) => p.handle === handle);
              if (prev)
                prev.prefix = prefix2;
              else
                this.tagPrefixes.push({
                  handle,
                  prefix: prefix2
                });
            } else {
              this.tagPrefixes = this.tagPrefixes.filter((p) => p.handle !== handle);
            }
          }
          toJSON(arg, onAnchor) {
            const {
              keepBlobsInJSON,
              mapAsMap,
              maxAliasCount
            } = this.options;
            const keep = keepBlobsInJSON && (typeof arg !== "string" || !(this.contents instanceof resolveSeq.Scalar));
            const ctx = {
              doc: this,
              indentStep: "  ",
              keep,
              mapAsMap: keep && !!mapAsMap,
              maxAliasCount,
              stringify
            };
            const anchorNames = Object.keys(this.anchors.map);
            if (anchorNames.length > 0)
              ctx.anchors = new Map(anchorNames.map((name) => [this.anchors.map[name], {
                alias: [],
                aliasCount: 0,
                count: 1
              }]));
            const res = resolveSeq.toJSON(this.contents, arg, ctx);
            if (typeof onAnchor === "function" && ctx.anchors)
              for (const {
                count,
                res: res2
              } of ctx.anchors.values())
                onAnchor(res2, count);
            return res;
          }
          toString() {
            if (this.errors.length > 0)
              throw new Error("Document with errors cannot be stringified");
            const indentSize = this.options.indent;
            if (!Number.isInteger(indentSize) || indentSize <= 0) {
              const s2 = JSON.stringify(indentSize);
              throw new Error(`"indent" option must be a positive integer, not ${s2}`);
            }
            this.setSchema();
            const lines = [];
            let hasDirectives = false;
            if (this.version) {
              let vd = "%YAML 1.2";
              if (this.schema.name === "yaml-1.1") {
                if (this.version === "1.0")
                  vd = "%YAML:1.0";
                else if (this.version === "1.1")
                  vd = "%YAML 1.1";
              }
              lines.push(vd);
              hasDirectives = true;
            }
            const tagNames = this.listNonDefaultTags();
            this.tagPrefixes.forEach(({
              handle,
              prefix: prefix2
            }) => {
              if (tagNames.some((t2) => t2.indexOf(prefix2) === 0)) {
                lines.push(`%TAG ${handle} ${prefix2}`);
                hasDirectives = true;
              }
            });
            if (hasDirectives || this.directivesEndMarker)
              lines.push("---");
            if (this.commentBefore) {
              if (hasDirectives || !this.directivesEndMarker)
                lines.unshift("");
              lines.unshift(this.commentBefore.replace(/^/gm, "#"));
            }
            const ctx = {
              anchors: /* @__PURE__ */ Object.create(null),
              doc: this,
              indent: "",
              indentStep: " ".repeat(indentSize),
              stringify
            };
            let chompKeep = false;
            let contentComment = null;
            if (this.contents) {
              if (this.contents instanceof resolveSeq.Node) {
                if (this.contents.spaceBefore && (hasDirectives || this.directivesEndMarker))
                  lines.push("");
                if (this.contents.commentBefore)
                  lines.push(this.contents.commentBefore.replace(/^/gm, "#"));
                ctx.forceBlockIndent = !!this.comment;
                contentComment = this.contents.comment;
              }
              const onChompKeep = contentComment ? null : () => chompKeep = true;
              const body = stringify(this.contents, ctx, () => contentComment = null, onChompKeep);
              lines.push(resolveSeq.addComment(body, "", contentComment));
            } else if (this.contents !== void 0) {
              lines.push(stringify(this.contents, ctx));
            }
            if (this.comment) {
              if ((!chompKeep || contentComment) && lines[lines.length - 1] !== "")
                lines.push("");
              lines.push(this.comment.replace(/^/gm, "#"));
            }
            return lines.join("\n") + "\n";
          }
        };
        PlainValue._defineProperty(Document, "defaults", documentOptions);
        exports2.Document = Document;
        exports2.defaultOptions = defaultOptions;
        exports2.scalarOptions = scalarOptions;
      }
    });
    var require_dist = __commonJS2({
      "node_modules/yaml/dist/index.js"(exports2) {
        "use strict";
        var parseCst = require_parse_cst();
        var Document$1 = require_Document_9b4560a1();
        var Schema = require_Schema_88e323a7();
        var PlainValue = require_PlainValue_ec8e588e();
        var warnings = require_warnings_1000a372();
        require_resolveSeq_d03cb037();
        function createNode(value, wrapScalars = true, tag) {
          if (tag === void 0 && typeof wrapScalars === "string") {
            tag = wrapScalars;
            wrapScalars = true;
          }
          const options = Object.assign({}, Document$1.Document.defaults[Document$1.defaultOptions.version], Document$1.defaultOptions);
          const schema = new Schema.Schema(options);
          return schema.createNode(value, wrapScalars, tag);
        }
        var Document = class extends Document$1.Document {
          constructor(options) {
            super(Object.assign({}, Document$1.defaultOptions, options));
          }
        };
        function parseAllDocuments(src, options) {
          const stream = [];
          let prev;
          for (const cstDoc of parseCst.parse(src)) {
            const doc = new Document(options);
            doc.parse(cstDoc, prev);
            stream.push(doc);
            prev = doc;
          }
          return stream;
        }
        function parseDocument(src, options) {
          const cst = parseCst.parse(src);
          const doc = new Document(options).parse(cst[0]);
          if (cst.length > 1) {
            const errMsg = "Source contains multiple documents; please use YAML.parseAllDocuments()";
            doc.errors.unshift(new PlainValue.YAMLSemanticError(cst[1], errMsg));
          }
          return doc;
        }
        function parse3(src, options) {
          const doc = parseDocument(src, options);
          doc.warnings.forEach((warning2) => warnings.warn(warning2));
          if (doc.errors.length > 0)
            throw doc.errors[0];
          return doc.toJSON();
        }
        function stringify(value, options) {
          const doc = new Document(options);
          doc.contents = value;
          return String(doc);
        }
        var YAML = {
          createNode,
          defaultOptions: Document$1.defaultOptions,
          Document,
          parse: parse3,
          parseAllDocuments,
          parseCST: parseCst.parse,
          parseDocument,
          scalarOptions: Document$1.scalarOptions,
          stringify
        };
        exports2.YAML = YAML;
      }
    });
    var require_yaml = __commonJS2({
      "node_modules/yaml/index.js"(exports2, module22) {
        module22.exports = require_dist().YAML;
      }
    });
    var require_loaders = __commonJS2({
      "node_modules/cosmiconfig/dist/loaders.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.loaders = void 0;
        var importFresh;
        var loadJs = function loadJs2(filepath) {
          if (importFresh === void 0) {
            importFresh = require_import_fresh();
          }
          const result = importFresh(filepath);
          return result;
        };
        var parseJson;
        var loadJson = function loadJson2(filepath, content) {
          if (parseJson === void 0) {
            parseJson = require_parse_json();
          }
          try {
            const result = parseJson(content);
            return result;
          } catch (error) {
            error.message = `JSON Error in ${filepath}:
${error.message}`;
            throw error;
          }
        };
        var yaml;
        var loadYaml = function loadYaml2(filepath, content) {
          if (yaml === void 0) {
            yaml = require_yaml();
          }
          try {
            const result = yaml.parse(content, {
              prettyErrors: true
            });
            return result;
          } catch (error) {
            error.message = `YAML Error in ${filepath}:
${error.message}`;
            throw error;
          }
        };
        var loaders = {
          loadJs,
          loadJson,
          loadYaml
        };
        exports2.loaders = loaders;
      }
    });
    var require_getPropertyByPath = __commonJS2({
      "node_modules/cosmiconfig/dist/getPropertyByPath.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.getPropertyByPath = getPropertyByPath;
        function getPropertyByPath(source, path4) {
          if (typeof path4 === "string" && Object.prototype.hasOwnProperty.call(source, path4)) {
            return source[path4];
          }
          const parsedPath = typeof path4 === "string" ? path4.split(".") : path4;
          return parsedPath.reduce((previous, key) => {
            if (previous === void 0) {
              return previous;
            }
            return previous[key];
          }, source);
        }
      }
    });
    var require_ExplorerBase = __commonJS2({
      "node_modules/cosmiconfig/dist/ExplorerBase.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.getExtensionDescription = getExtensionDescription;
        exports2.ExplorerBase = void 0;
        var _path2 = _interopRequireDefault(require("path"));
        var _loaders = require_loaders();
        var _getPropertyByPath = require_getPropertyByPath();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        var ExplorerBase = class {
          constructor(options) {
            if (options.cache === true) {
              this.loadCache = /* @__PURE__ */ new Map();
              this.searchCache = /* @__PURE__ */ new Map();
            }
            this.config = options;
            this.validateConfig();
          }
          clearLoadCache() {
            if (this.loadCache) {
              this.loadCache.clear();
            }
          }
          clearSearchCache() {
            if (this.searchCache) {
              this.searchCache.clear();
            }
          }
          clearCaches() {
            this.clearLoadCache();
            this.clearSearchCache();
          }
          validateConfig() {
            const config = this.config;
            config.searchPlaces.forEach((place) => {
              const loaderKey = _path2.default.extname(place) || "noExt";
              const loader = config.loaders[loaderKey];
              if (!loader) {
                throw new Error(`No loader specified for ${getExtensionDescription(place)}, so searchPlaces item "${place}" is invalid`);
              }
              if (typeof loader !== "function") {
                throw new Error(`loader for ${getExtensionDescription(place)} is not a function (type provided: "${typeof loader}"), so searchPlaces item "${place}" is invalid`);
              }
            });
          }
          shouldSearchStopWithResult(result) {
            if (result === null)
              return false;
            if (result.isEmpty && this.config.ignoreEmptySearchPlaces)
              return false;
            return true;
          }
          nextDirectoryToSearch(currentDir, currentResult) {
            if (this.shouldSearchStopWithResult(currentResult)) {
              return null;
            }
            const nextDir = nextDirUp(currentDir);
            if (nextDir === currentDir || currentDir === this.config.stopDir) {
              return null;
            }
            return nextDir;
          }
          loadPackageProp(filepath, content) {
            const parsedContent = _loaders.loaders.loadJson(filepath, content);
            const packagePropValue = (0, _getPropertyByPath.getPropertyByPath)(parsedContent, this.config.packageProp);
            return packagePropValue || null;
          }
          getLoaderEntryForFile(filepath) {
            if (_path2.default.basename(filepath) === "package.json") {
              const loader2 = this.loadPackageProp.bind(this);
              return loader2;
            }
            const loaderKey = _path2.default.extname(filepath) || "noExt";
            const loader = this.config.loaders[loaderKey];
            if (!loader) {
              throw new Error(`No loader specified for ${getExtensionDescription(filepath)}`);
            }
            return loader;
          }
          loadedContentToCosmiconfigResult(filepath, loadedContent) {
            if (loadedContent === null) {
              return null;
            }
            if (loadedContent === void 0) {
              return {
                filepath,
                config: void 0,
                isEmpty: true
              };
            }
            return {
              config: loadedContent,
              filepath
            };
          }
          validateFilePath(filepath) {
            if (!filepath) {
              throw new Error("load must pass a non-empty string");
            }
          }
        };
        exports2.ExplorerBase = ExplorerBase;
        function nextDirUp(dir) {
          return _path2.default.dirname(dir);
        }
        function getExtensionDescription(filepath) {
          const ext = _path2.default.extname(filepath);
          return ext ? `extension "${ext}"` : "files without extensions";
        }
      }
    });
    var require_readFile = __commonJS2({
      "node_modules/cosmiconfig/dist/readFile.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.readFile = readFile;
        exports2.readFileSync = readFileSync;
        var _fs = _interopRequireDefault(require("fs"));
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        async function fsReadFileAsync(pathname, encoding) {
          return new Promise((resolve, reject) => {
            _fs.default.readFile(pathname, encoding, (error, contents) => {
              if (error) {
                reject(error);
                return;
              }
              resolve(contents);
            });
          });
        }
        async function readFile(filepath, options = {}) {
          const throwNotFound = options.throwNotFound === true;
          try {
            const content = await fsReadFileAsync(filepath, "utf8");
            return content;
          } catch (error) {
            if (throwNotFound === false && (error.code === "ENOENT" || error.code === "EISDIR")) {
              return null;
            }
            throw error;
          }
        }
        function readFileSync(filepath, options = {}) {
          const throwNotFound = options.throwNotFound === true;
          try {
            const content = _fs.default.readFileSync(filepath, "utf8");
            return content;
          } catch (error) {
            if (throwNotFound === false && (error.code === "ENOENT" || error.code === "EISDIR")) {
              return null;
            }
            throw error;
          }
        }
      }
    });
    var require_cacheWrapper = __commonJS2({
      "node_modules/cosmiconfig/dist/cacheWrapper.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.cacheWrapper = cacheWrapper;
        exports2.cacheWrapperSync = cacheWrapperSync;
        async function cacheWrapper(cache, key, fn) {
          const cached = cache.get(key);
          if (cached !== void 0) {
            return cached;
          }
          const result = await fn();
          cache.set(key, result);
          return result;
        }
        function cacheWrapperSync(cache, key, fn) {
          const cached = cache.get(key);
          if (cached !== void 0) {
            return cached;
          }
          const result = fn();
          cache.set(key, result);
          return result;
        }
      }
    });
    var require_path_type2 = __commonJS2({
      "node_modules/path-type/index.js"(exports2) {
        "use strict";
        var {
          promisify: promisify2
        } = require("util");
        var fs4 = require("fs");
        async function isType(fsStatType, statsMethodName, filePath) {
          if (typeof filePath !== "string") {
            throw new TypeError(`Expected a string, got ${typeof filePath}`);
          }
          try {
            const stats = await promisify2(fs4[fsStatType])(filePath);
            return stats[statsMethodName]();
          } catch (error) {
            if (error.code === "ENOENT") {
              return false;
            }
            throw error;
          }
        }
        function isTypeSync(fsStatType, statsMethodName, filePath) {
          if (typeof filePath !== "string") {
            throw new TypeError(`Expected a string, got ${typeof filePath}`);
          }
          try {
            return fs4[fsStatType](filePath)[statsMethodName]();
          } catch (error) {
            if (error.code === "ENOENT") {
              return false;
            }
            throw error;
          }
        }
        exports2.isFile = isType.bind(null, "stat", "isFile");
        exports2.isDirectory = isType.bind(null, "stat", "isDirectory");
        exports2.isSymlink = isType.bind(null, "lstat", "isSymbolicLink");
        exports2.isFileSync = isTypeSync.bind(null, "statSync", "isFile");
        exports2.isDirectorySync = isTypeSync.bind(null, "statSync", "isDirectory");
        exports2.isSymlinkSync = isTypeSync.bind(null, "lstatSync", "isSymbolicLink");
      }
    });
    var require_getDirectory = __commonJS2({
      "node_modules/cosmiconfig/dist/getDirectory.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.getDirectory = getDirectory;
        exports2.getDirectorySync = getDirectorySync;
        var _path2 = _interopRequireDefault(require("path"));
        var _pathType = require_path_type2();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        async function getDirectory(filepath) {
          const filePathIsDirectory = await (0, _pathType.isDirectory)(filepath);
          if (filePathIsDirectory === true) {
            return filepath;
          }
          const directory = _path2.default.dirname(filepath);
          return directory;
        }
        function getDirectorySync(filepath) {
          const filePathIsDirectory = (0, _pathType.isDirectorySync)(filepath);
          if (filePathIsDirectory === true) {
            return filepath;
          }
          const directory = _path2.default.dirname(filepath);
          return directory;
        }
      }
    });
    var require_Explorer = __commonJS2({
      "node_modules/cosmiconfig/dist/Explorer.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.Explorer = void 0;
        var _path2 = _interopRequireDefault(require("path"));
        var _ExplorerBase = require_ExplorerBase();
        var _readFile = require_readFile();
        var _cacheWrapper = require_cacheWrapper();
        var _getDirectory = require_getDirectory();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        var Explorer = class extends _ExplorerBase.ExplorerBase {
          constructor(options) {
            super(options);
          }
          async search(searchFrom = process.cwd()) {
            const startDirectory = await (0, _getDirectory.getDirectory)(searchFrom);
            const result = await this.searchFromDirectory(startDirectory);
            return result;
          }
          async searchFromDirectory(dir) {
            const absoluteDir = _path2.default.resolve(process.cwd(), dir);
            const run = async () => {
              const result = await this.searchDirectory(absoluteDir);
              const nextDir = this.nextDirectoryToSearch(absoluteDir, result);
              if (nextDir) {
                return this.searchFromDirectory(nextDir);
              }
              const transformResult = await this.config.transform(result);
              return transformResult;
            };
            if (this.searchCache) {
              return (0, _cacheWrapper.cacheWrapper)(this.searchCache, absoluteDir, run);
            }
            return run();
          }
          async searchDirectory(dir) {
            for await (const place of this.config.searchPlaces) {
              const placeResult = await this.loadSearchPlace(dir, place);
              if (this.shouldSearchStopWithResult(placeResult) === true) {
                return placeResult;
              }
            }
            return null;
          }
          async loadSearchPlace(dir, place) {
            const filepath = _path2.default.join(dir, place);
            const fileContents = await (0, _readFile.readFile)(filepath);
            const result = await this.createCosmiconfigResult(filepath, fileContents);
            return result;
          }
          async loadFileContent(filepath, content) {
            if (content === null) {
              return null;
            }
            if (content.trim() === "") {
              return void 0;
            }
            const loader = this.getLoaderEntryForFile(filepath);
            const loaderResult = await loader(filepath, content);
            return loaderResult;
          }
          async createCosmiconfigResult(filepath, content) {
            const fileContent = await this.loadFileContent(filepath, content);
            const result = this.loadedContentToCosmiconfigResult(filepath, fileContent);
            return result;
          }
          async load(filepath) {
            this.validateFilePath(filepath);
            const absoluteFilePath = _path2.default.resolve(process.cwd(), filepath);
            const runLoad = async () => {
              const fileContents = await (0, _readFile.readFile)(absoluteFilePath, {
                throwNotFound: true
              });
              const result = await this.createCosmiconfigResult(absoluteFilePath, fileContents);
              const transformResult = await this.config.transform(result);
              return transformResult;
            };
            if (this.loadCache) {
              return (0, _cacheWrapper.cacheWrapper)(this.loadCache, absoluteFilePath, runLoad);
            }
            return runLoad();
          }
        };
        exports2.Explorer = Explorer;
      }
    });
    var require_ExplorerSync = __commonJS2({
      "node_modules/cosmiconfig/dist/ExplorerSync.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.ExplorerSync = void 0;
        var _path2 = _interopRequireDefault(require("path"));
        var _ExplorerBase = require_ExplorerBase();
        var _readFile = require_readFile();
        var _cacheWrapper = require_cacheWrapper();
        var _getDirectory = require_getDirectory();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        var ExplorerSync = class extends _ExplorerBase.ExplorerBase {
          constructor(options) {
            super(options);
          }
          searchSync(searchFrom = process.cwd()) {
            const startDirectory = (0, _getDirectory.getDirectorySync)(searchFrom);
            const result = this.searchFromDirectorySync(startDirectory);
            return result;
          }
          searchFromDirectorySync(dir) {
            const absoluteDir = _path2.default.resolve(process.cwd(), dir);
            const run = () => {
              const result = this.searchDirectorySync(absoluteDir);
              const nextDir = this.nextDirectoryToSearch(absoluteDir, result);
              if (nextDir) {
                return this.searchFromDirectorySync(nextDir);
              }
              const transformResult = this.config.transform(result);
              return transformResult;
            };
            if (this.searchCache) {
              return (0, _cacheWrapper.cacheWrapperSync)(this.searchCache, absoluteDir, run);
            }
            return run();
          }
          searchDirectorySync(dir) {
            for (const place of this.config.searchPlaces) {
              const placeResult = this.loadSearchPlaceSync(dir, place);
              if (this.shouldSearchStopWithResult(placeResult) === true) {
                return placeResult;
              }
            }
            return null;
          }
          loadSearchPlaceSync(dir, place) {
            const filepath = _path2.default.join(dir, place);
            const content = (0, _readFile.readFileSync)(filepath);
            const result = this.createCosmiconfigResultSync(filepath, content);
            return result;
          }
          loadFileContentSync(filepath, content) {
            if (content === null) {
              return null;
            }
            if (content.trim() === "") {
              return void 0;
            }
            const loader = this.getLoaderEntryForFile(filepath);
            const loaderResult = loader(filepath, content);
            return loaderResult;
          }
          createCosmiconfigResultSync(filepath, content) {
            const fileContent = this.loadFileContentSync(filepath, content);
            const result = this.loadedContentToCosmiconfigResult(filepath, fileContent);
            return result;
          }
          loadSync(filepath) {
            this.validateFilePath(filepath);
            const absoluteFilePath = _path2.default.resolve(process.cwd(), filepath);
            const runLoadSync = () => {
              const content = (0, _readFile.readFileSync)(absoluteFilePath, {
                throwNotFound: true
              });
              const cosmiconfigResult = this.createCosmiconfigResultSync(absoluteFilePath, content);
              const transformResult = this.config.transform(cosmiconfigResult);
              return transformResult;
            };
            if (this.loadCache) {
              return (0, _cacheWrapper.cacheWrapperSync)(this.loadCache, absoluteFilePath, runLoadSync);
            }
            return runLoadSync();
          }
        };
        exports2.ExplorerSync = ExplorerSync;
      }
    });
    var require_types = __commonJS2({
      "node_modules/cosmiconfig/dist/types.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
      }
    });
    var require_dist2 = __commonJS2({
      "node_modules/cosmiconfig/dist/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.cosmiconfig = cosmiconfig;
        exports2.cosmiconfigSync = cosmiconfigSync;
        exports2.defaultLoaders = void 0;
        var _os = _interopRequireDefault(require("os"));
        var _Explorer = require_Explorer();
        var _ExplorerSync = require_ExplorerSync();
        var _loaders = require_loaders();
        var _types = require_types();
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        function cosmiconfig(moduleName, options = {}) {
          const normalizedOptions = normalizeOptions(moduleName, options);
          const explorer = new _Explorer.Explorer(normalizedOptions);
          return {
            search: explorer.search.bind(explorer),
            load: explorer.load.bind(explorer),
            clearLoadCache: explorer.clearLoadCache.bind(explorer),
            clearSearchCache: explorer.clearSearchCache.bind(explorer),
            clearCaches: explorer.clearCaches.bind(explorer)
          };
        }
        function cosmiconfigSync(moduleName, options = {}) {
          const normalizedOptions = normalizeOptions(moduleName, options);
          const explorerSync = new _ExplorerSync.ExplorerSync(normalizedOptions);
          return {
            search: explorerSync.searchSync.bind(explorerSync),
            load: explorerSync.loadSync.bind(explorerSync),
            clearLoadCache: explorerSync.clearLoadCache.bind(explorerSync),
            clearSearchCache: explorerSync.clearSearchCache.bind(explorerSync),
            clearCaches: explorerSync.clearCaches.bind(explorerSync)
          };
        }
        var defaultLoaders = Object.freeze({
          ".cjs": _loaders.loaders.loadJs,
          ".js": _loaders.loaders.loadJs,
          ".json": _loaders.loaders.loadJson,
          ".yaml": _loaders.loaders.loadYaml,
          ".yml": _loaders.loaders.loadYaml,
          noExt: _loaders.loaders.loadYaml
        });
        exports2.defaultLoaders = defaultLoaders;
        var identity = function identity2(x2) {
          return x2;
        };
        function normalizeOptions(moduleName, options) {
          const defaults = {
            packageProp: moduleName,
            searchPlaces: ["package.json", `.${moduleName}rc`, `.${moduleName}rc.json`, `.${moduleName}rc.yaml`, `.${moduleName}rc.yml`, `.${moduleName}rc.js`, `.${moduleName}rc.cjs`, `${moduleName}.config.js`, `${moduleName}.config.cjs`],
            ignoreEmptySearchPlaces: true,
            stopDir: _os.default.homedir(),
            cache: true,
            transform: identity,
            loaders: defaultLoaders
          };
          const normalizedOptions = Object.assign(Object.assign(Object.assign({}, defaults), options), {}, {
            loaders: Object.assign(Object.assign({}, defaults.loaders), options.loaders)
          });
          return normalizedOptions;
        }
      }
    });
    var require_find_parent_dir = __commonJS2({
      "node_modules/find-parent-dir/index.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var fs4 = require("fs");
        var exists = fs4.exists || path4.exists;
        var existsSync = fs4.existsSync || path4.existsSync;
        function splitPath(path22) {
          var parts = path22.split(/(\/|\\)/);
          if (!parts.length)
            return parts;
          return !parts[0].length ? parts.slice(1) : parts;
        }
        exports2 = module22.exports = function(currentFullPath, clue, cb) {
          function testDir(parts) {
            if (parts.length === 0)
              return cb(null, null);
            var p = parts.join("");
            exists(path4.join(p, clue), function(itdoes) {
              if (itdoes)
                return cb(null, p);
              testDir(parts.slice(0, -1));
            });
          }
          testDir(splitPath(currentFullPath));
        };
        exports2.sync = function(currentFullPath, clue) {
          function testDir(parts) {
            if (parts.length === 0)
              return null;
            var p = parts.join("");
            var itdoes = existsSync(path4.join(p, clue));
            return itdoes ? p : testDir(parts.slice(0, -1));
          }
          return testDir(splitPath(currentFullPath));
        };
      }
    });
    var require_get_stdin = __commonJS2({
      "node_modules/get-stdin/index.js"(exports2, module22) {
        "use strict";
        var {
          stdin
        } = process;
        module22.exports = async () => {
          let result = "";
          if (stdin.isTTY) {
            return result;
          }
          stdin.setEncoding("utf8");
          for await (const chunk of stdin) {
            result += chunk;
          }
          return result;
        };
        module22.exports.buffer = async () => {
          const result = [];
          let length = 0;
          if (stdin.isTTY) {
            return Buffer.concat([]);
          }
          for await (const chunk of stdin) {
            result.push(chunk);
            length += chunk.length;
          }
          return Buffer.concat(result, length);
        };
      }
    });
    var require_vendors = __commonJS2({
      "node_modules/ci-info/vendors.json"(exports2, module22) {
        module22.exports = [{
          name: "AppVeyor",
          constant: "APPVEYOR",
          env: "APPVEYOR",
          pr: "APPVEYOR_PULL_REQUEST_NUMBER"
        }, {
          name: "Azure Pipelines",
          constant: "AZURE_PIPELINES",
          env: "SYSTEM_TEAMFOUNDATIONCOLLECTIONURI",
          pr: "SYSTEM_PULLREQUEST_PULLREQUESTID"
        }, {
          name: "Appcircle",
          constant: "APPCIRCLE",
          env: "AC_APPCIRCLE"
        }, {
          name: "Bamboo",
          constant: "BAMBOO",
          env: "bamboo_planKey"
        }, {
          name: "Bitbucket Pipelines",
          constant: "BITBUCKET",
          env: "BITBUCKET_COMMIT",
          pr: "BITBUCKET_PR_ID"
        }, {
          name: "Bitrise",
          constant: "BITRISE",
          env: "BITRISE_IO",
          pr: "BITRISE_PULL_REQUEST"
        }, {
          name: "Buddy",
          constant: "BUDDY",
          env: "BUDDY_WORKSPACE_ID",
          pr: "BUDDY_EXECUTION_PULL_REQUEST_ID"
        }, {
          name: "Buildkite",
          constant: "BUILDKITE",
          env: "BUILDKITE",
          pr: {
            env: "BUILDKITE_PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "CircleCI",
          constant: "CIRCLE",
          env: "CIRCLECI",
          pr: "CIRCLE_PULL_REQUEST"
        }, {
          name: "Cirrus CI",
          constant: "CIRRUS",
          env: "CIRRUS_CI",
          pr: "CIRRUS_PR"
        }, {
          name: "AWS CodeBuild",
          constant: "CODEBUILD",
          env: "CODEBUILD_BUILD_ARN"
        }, {
          name: "Codefresh",
          constant: "CODEFRESH",
          env: "CF_BUILD_ID",
          pr: {
            any: ["CF_PULL_REQUEST_NUMBER", "CF_PULL_REQUEST_ID"]
          }
        }, {
          name: "Codeship",
          constant: "CODESHIP",
          env: {
            CI_NAME: "codeship"
          }
        }, {
          name: "Drone",
          constant: "DRONE",
          env: "DRONE",
          pr: {
            DRONE_BUILD_EVENT: "pull_request"
          }
        }, {
          name: "dsari",
          constant: "DSARI",
          env: "DSARI"
        }, {
          name: "Expo Application Services",
          constant: "EAS",
          env: "EAS_BUILD"
        }, {
          name: "GitHub Actions",
          constant: "GITHUB_ACTIONS",
          env: "GITHUB_ACTIONS",
          pr: {
            GITHUB_EVENT_NAME: "pull_request"
          }
        }, {
          name: "GitLab CI",
          constant: "GITLAB",
          env: "GITLAB_CI",
          pr: "CI_MERGE_REQUEST_ID"
        }, {
          name: "GoCD",
          constant: "GOCD",
          env: "GO_PIPELINE_LABEL"
        }, {
          name: "LayerCI",
          constant: "LAYERCI",
          env: "LAYERCI",
          pr: "LAYERCI_PULL_REQUEST"
        }, {
          name: "Hudson",
          constant: "HUDSON",
          env: "HUDSON_URL"
        }, {
          name: "Jenkins",
          constant: "JENKINS",
          env: ["JENKINS_URL", "BUILD_ID"],
          pr: {
            any: ["ghprbPullId", "CHANGE_ID"]
          }
        }, {
          name: "Magnum CI",
          constant: "MAGNUM",
          env: "MAGNUM"
        }, {
          name: "Netlify CI",
          constant: "NETLIFY",
          env: "NETLIFY",
          pr: {
            env: "PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "Nevercode",
          constant: "NEVERCODE",
          env: "NEVERCODE",
          pr: {
            env: "NEVERCODE_PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "Render",
          constant: "RENDER",
          env: "RENDER",
          pr: {
            IS_PULL_REQUEST: "true"
          }
        }, {
          name: "Sail CI",
          constant: "SAIL",
          env: "SAILCI",
          pr: "SAIL_PULL_REQUEST_NUMBER"
        }, {
          name: "Semaphore",
          constant: "SEMAPHORE",
          env: "SEMAPHORE",
          pr: "PULL_REQUEST_NUMBER"
        }, {
          name: "Screwdriver",
          constant: "SCREWDRIVER",
          env: "SCREWDRIVER",
          pr: {
            env: "SD_PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "Shippable",
          constant: "SHIPPABLE",
          env: "SHIPPABLE",
          pr: {
            IS_PULL_REQUEST: "true"
          }
        }, {
          name: "Solano CI",
          constant: "SOLANO",
          env: "TDDIUM",
          pr: "TDDIUM_PR_ID"
        }, {
          name: "Strider CD",
          constant: "STRIDER",
          env: "STRIDER"
        }, {
          name: "TaskCluster",
          constant: "TASKCLUSTER",
          env: ["TASK_ID", "RUN_ID"]
        }, {
          name: "TeamCity",
          constant: "TEAMCITY",
          env: "TEAMCITY_VERSION"
        }, {
          name: "Travis CI",
          constant: "TRAVIS",
          env: "TRAVIS",
          pr: {
            env: "TRAVIS_PULL_REQUEST",
            ne: "false"
          }
        }, {
          name: "Vercel",
          constant: "VERCEL",
          env: "NOW_BUILDER"
        }, {
          name: "Visual Studio App Center",
          constant: "APPCENTER",
          env: "APPCENTER_BUILD_ID"
        }];
      }
    });
    var require_ci_info = __commonJS2({
      "node_modules/ci-info/index.js"(exports2) {
        "use strict";
        var vendors = require_vendors();
        var env = process.env;
        Object.defineProperty(exports2, "_vendors", {
          value: vendors.map(function(v) {
            return v.constant;
          })
        });
        exports2.name = null;
        exports2.isPR = null;
        vendors.forEach(function(vendor) {
          const envs = Array.isArray(vendor.env) ? vendor.env : [vendor.env];
          const isCI = envs.every(function(obj) {
            return checkEnv(obj);
          });
          exports2[vendor.constant] = isCI;
          if (isCI) {
            exports2.name = vendor.name;
            switch (typeof vendor.pr) {
              case "string":
                exports2.isPR = !!env[vendor.pr];
                break;
              case "object":
                if ("env" in vendor.pr) {
                  exports2.isPR = vendor.pr.env in env && env[vendor.pr.env] !== vendor.pr.ne;
                } else if ("any" in vendor.pr) {
                  exports2.isPR = vendor.pr.any.some(function(key) {
                    return !!env[key];
                  });
                } else {
                  exports2.isPR = checkEnv(vendor.pr);
                }
                break;
              default:
                exports2.isPR = null;
            }
          }
        });
        exports2.isCI = !!(env.CI || env.CONTINUOUS_INTEGRATION || env.BUILD_NUMBER || env.RUN_ID || exports2.name || false);
        function checkEnv(obj) {
          if (typeof obj === "string")
            return !!env[obj];
          return Object.keys(obj).every(function(k) {
            return env[k] === obj[k];
          });
        }
      }
    });
    module2.exports = {
      cosmiconfig: require_dist2().cosmiconfig,
      cosmiconfigSync: require_dist2().cosmiconfigSync,
      findParentDir: require_find_parent_dir().sync,
      getStdin: require_get_stdin(),
      isCI: () => require_ci_info().isCI
    };
  }
});

// node_modules/prettier/parser-babel.js
var require_parser_babel = __commonJS({
  "node_modules/prettier/parser-babel.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.babel = e2();
      }
    })(function() {
      "use strict";
      var b = (h2, l) => () => (l || h2((l = { exports: {} }).exports, l), l.exports);
      var G = b((zf, Jr) => {
        var Tt = function(h2) {
          return h2 && h2.Math == Math && h2;
        };
        Jr.exports = Tt(typeof globalThis == "object" && globalThis) || Tt(typeof window == "object" && window) || Tt(typeof self == "object" && self) || Tt(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      });
      var Ae = b((Kf, Yr) => {
        Yr.exports = function(h2) {
          try {
            return !!h2();
          } catch {
            return true;
          }
        };
      });
      var ke = b((Vf, $r) => {
        var hl = Ae();
        $r.exports = !hl(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Et = b((Hf, Qr) => {
        var ll = Ae();
        Qr.exports = !ll(function() {
          var h2 = function() {
          }.bind();
          return typeof h2 != "function" || h2.hasOwnProperty("prototype");
        });
      });
      var bt = b((Wf, Zr) => {
        var ul = Et(), Ct = Function.prototype.call;
        Zr.exports = ul ? Ct.bind(Ct) : function() {
          return Ct.apply(Ct, arguments);
        };
      });
      var ri = b((si) => {
        "use strict";
        var ei = {}.propertyIsEnumerable, ti = Object.getOwnPropertyDescriptor, cl = ti && !ei.call({ 1: 2 }, 1);
        si.f = cl ? function(l) {
          var p = ti(this, l);
          return !!p && p.enumerable;
        } : ei;
      });
      var ms = b((Xf, ii) => {
        ii.exports = function(h2, l) {
          return { enumerable: !(h2 & 1), configurable: !(h2 & 2), writable: !(h2 & 4), value: l };
        };
      });
      var ie = b((Jf, oi) => {
        var ai = Et(), ni = Function.prototype, pl = ni.bind, ys = ni.call, fl = ai && pl.bind(ys, ys);
        oi.exports = ai ? function(h2) {
          return h2 && fl(h2);
        } : function(h2) {
          return h2 && function() {
            return ys.apply(h2, arguments);
          };
        };
      });
      var vt = b((Yf, li) => {
        var hi = ie(), dl = hi({}.toString), ml = hi("".slice);
        li.exports = function(h2) {
          return ml(dl(h2), 8, -1);
        };
      });
      var ci = b(($f, ui) => {
        var yl = G(), xl = ie(), gl = Ae(), Al = vt(), xs = yl.Object, Pl = xl("".split);
        ui.exports = gl(function() {
          return !xs("z").propertyIsEnumerable(0);
        }) ? function(h2) {
          return Al(h2) == "String" ? Pl(h2, "") : xs(h2);
        } : xs;
      });
      var gs = b((Qf, pi) => {
        var Tl = G(), El = Tl.TypeError;
        pi.exports = function(h2) {
          if (h2 == null)
            throw El("Can't call method on " + h2);
          return h2;
        };
      });
      var St = b((Zf, fi) => {
        var Cl = ci(), bl = gs();
        fi.exports = function(h2) {
          return Cl(bl(h2));
        };
      });
      var ae = b((ed, di) => {
        di.exports = function(h2) {
          return typeof h2 == "function";
        };
      });
      var De = b((td, mi) => {
        var vl = ae();
        mi.exports = function(h2) {
          return typeof h2 == "object" ? h2 !== null : vl(h2);
        };
      });
      var Qe = b((sd, yi) => {
        var As = G(), Sl = ae(), wl = function(h2) {
          return Sl(h2) ? h2 : void 0;
        };
        yi.exports = function(h2, l) {
          return arguments.length < 2 ? wl(As[h2]) : As[h2] && As[h2][l];
        };
      });
      var gi = b((rd, xi) => {
        var Nl = ie();
        xi.exports = Nl({}.isPrototypeOf);
      });
      var Pi = b((id, Ai) => {
        var Il = Qe();
        Ai.exports = Il("navigator", "userAgent") || "";
      });
      var wi = b((ad, Si) => {
        var vi = G(), Ps = Pi(), Ti = vi.process, Ei = vi.Deno, Ci = Ti && Ti.versions || Ei && Ei.version, bi = Ci && Ci.v8, oe, wt;
        bi && (oe = bi.split("."), wt = oe[0] > 0 && oe[0] < 4 ? 1 : +(oe[0] + oe[1]));
        !wt && Ps && (oe = Ps.match(/Edge\/(\d+)/), (!oe || oe[1] >= 74) && (oe = Ps.match(/Chrome\/(\d+)/), oe && (wt = +oe[1])));
        Si.exports = wt;
      });
      var Ts = b((nd, Ii) => {
        var Ni = wi(), kl = Ae();
        Ii.exports = !!Object.getOwnPropertySymbols && !kl(function() {
          var h2 = Symbol();
          return !String(h2) || !(Object(h2) instanceof Symbol) || !Symbol.sham && Ni && Ni < 41;
        });
      });
      var Es = b((od, ki) => {
        var Dl = Ts();
        ki.exports = Dl && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var Cs = b((hd, Di) => {
        var Fl = G(), Ll = Qe(), Ol = ae(), Bl = gi(), Ml = Es(), Rl = Fl.Object;
        Di.exports = Ml ? function(h2) {
          return typeof h2 == "symbol";
        } : function(h2) {
          var l = Ll("Symbol");
          return Ol(l) && Bl(l.prototype, Rl(h2));
        };
      });
      var Li = b((ld, Fi) => {
        var jl = G(), ql = jl.String;
        Fi.exports = function(h2) {
          try {
            return ql(h2);
          } catch {
            return "Object";
          }
        };
      });
      var Nt = b((ud, Oi) => {
        var Ul = G(), _l = ae(), zl = Li(), Kl = Ul.TypeError;
        Oi.exports = function(h2) {
          if (_l(h2))
            return h2;
          throw Kl(zl(h2) + " is not a function");
        };
      });
      var Mi = b((cd, Bi) => {
        var Vl = Nt();
        Bi.exports = function(h2, l) {
          var p = h2[l];
          return p == null ? void 0 : Vl(p);
        };
      });
      var ji = b((pd, Ri) => {
        var Hl = G(), bs = bt(), vs = ae(), Ss = De(), Wl = Hl.TypeError;
        Ri.exports = function(h2, l) {
          var p, d;
          if (l === "string" && vs(p = h2.toString) && !Ss(d = bs(p, h2)) || vs(p = h2.valueOf) && !Ss(d = bs(p, h2)) || l !== "string" && vs(p = h2.toString) && !Ss(d = bs(p, h2)))
            return d;
          throw Wl("Can't convert object to primitive value");
        };
      });
      var Ui = b((fd, qi) => {
        qi.exports = false;
      });
      var It = b((dd, zi) => {
        var _i = G(), Gl = Object.defineProperty;
        zi.exports = function(h2, l) {
          try {
            Gl(_i, h2, { value: l, configurable: true, writable: true });
          } catch {
            _i[h2] = l;
          }
          return l;
        };
      });
      var kt = b((md, Vi) => {
        var Xl = G(), Jl = It(), Ki = "__core-js_shared__", Yl = Xl[Ki] || Jl(Ki, {});
        Vi.exports = Yl;
      });
      var ws = b((yd, Wi) => {
        var $l = Ui(), Hi = kt();
        (Wi.exports = function(h2, l) {
          return Hi[h2] || (Hi[h2] = l !== void 0 ? l : {});
        })("versions", []).push({ version: "3.22.2", mode: $l ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var Ns = b((xd, Gi) => {
        var Ql = G(), Zl = gs(), eu = Ql.Object;
        Gi.exports = function(h2) {
          return eu(Zl(h2));
        };
      });
      var be = b((gd, Xi) => {
        var tu = ie(), su = Ns(), ru = tu({}.hasOwnProperty);
        Xi.exports = Object.hasOwn || function(l, p) {
          return ru(su(l), p);
        };
      });
      var Is = b((Ad, Ji) => {
        var iu = ie(), au = 0, nu = Math.random(), ou = iu(1 .toString);
        Ji.exports = function(h2) {
          return "Symbol(" + (h2 === void 0 ? "" : h2) + ")_" + ou(++au + nu, 36);
        };
      });
      var Ze = b((Pd, ea) => {
        var hu = G(), lu = ws(), Yi = be(), uu = Is(), $i = Ts(), Zi = Es(), _e = lu("wks"), Fe = hu.Symbol, Qi = Fe && Fe.for, cu = Zi ? Fe : Fe && Fe.withoutSetter || uu;
        ea.exports = function(h2) {
          if (!Yi(_e, h2) || !($i || typeof _e[h2] == "string")) {
            var l = "Symbol." + h2;
            $i && Yi(Fe, h2) ? _e[h2] = Fe[h2] : Zi && Qi ? _e[h2] = Qi(l) : _e[h2] = cu(l);
          }
          return _e[h2];
        };
      });
      var ia = b((Td, ra) => {
        var pu = G(), fu = bt(), ta = De(), sa = Cs(), du = Mi(), mu = ji(), yu = Ze(), xu = pu.TypeError, gu = yu("toPrimitive");
        ra.exports = function(h2, l) {
          if (!ta(h2) || sa(h2))
            return h2;
          var p = du(h2, gu), d;
          if (p) {
            if (l === void 0 && (l = "default"), d = fu(p, h2, l), !ta(d) || sa(d))
              return d;
            throw xu("Can't convert object to primitive value");
          }
          return l === void 0 && (l = "number"), mu(h2, l);
        };
      });
      var ks = b((Ed, aa) => {
        var Au = ia(), Pu = Cs();
        aa.exports = function(h2) {
          var l = Au(h2, "string");
          return Pu(l) ? l : l + "";
        };
      });
      var ha = b((Cd, oa) => {
        var Tu = G(), na = De(), Ds = Tu.document, Eu = na(Ds) && na(Ds.createElement);
        oa.exports = function(h2) {
          return Eu ? Ds.createElement(h2) : {};
        };
      });
      var Fs = b((bd, la) => {
        var Cu = ke(), bu = Ae(), vu = ha();
        la.exports = !Cu && !bu(function() {
          return Object.defineProperty(vu("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var Ls = b((ca) => {
        var Su = ke(), wu = bt(), Nu = ri(), Iu = ms(), ku = St(), Du = ks(), Fu = be(), Lu = Fs(), ua = Object.getOwnPropertyDescriptor;
        ca.f = Su ? ua : function(l, p) {
          if (l = ku(l), p = Du(p), Lu)
            try {
              return ua(l, p);
            } catch {
            }
          if (Fu(l, p))
            return Iu(!wu(Nu.f, l, p), l[p]);
        };
      });
      var fa = b((Sd, pa) => {
        var Ou = ke(), Bu = Ae();
        pa.exports = Ou && Bu(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var Os = b((wd, ma) => {
        var da = G(), Mu = De(), Ru = da.String, ju = da.TypeError;
        ma.exports = function(h2) {
          if (Mu(h2))
            return h2;
          throw ju(Ru(h2) + " is not an object");
        };
      });
      var qs = b((xa) => {
        var qu = G(), Uu = ke(), _u = Fs(), zu = fa(), Dt = Os(), ya = ks(), Ku = qu.TypeError, Bs = Object.defineProperty, Vu = Object.getOwnPropertyDescriptor, Ms = "enumerable", Rs = "configurable", js = "writable";
        xa.f = Uu ? zu ? function(l, p, d) {
          if (Dt(l), p = ya(p), Dt(d), typeof l == "function" && p === "prototype" && "value" in d && js in d && !d[js]) {
            var m2 = Vu(l, p);
            m2 && m2[js] && (l[p] = d.value, d = { configurable: Rs in d ? d[Rs] : m2[Rs], enumerable: Ms in d ? d[Ms] : m2[Ms], writable: false });
          }
          return Bs(l, p, d);
        } : Bs : function(l, p, d) {
          if (Dt(l), p = ya(p), Dt(d), _u)
            try {
              return Bs(l, p, d);
            } catch {
            }
          if ("get" in d || "set" in d)
            throw Ku("Accessors not supported");
          return "value" in d && (l[p] = d.value), l;
        };
      });
      var Ft = b((Id, ga) => {
        var Hu = ke(), Wu = qs(), Gu = ms();
        ga.exports = Hu ? function(h2, l, p) {
          return Wu.f(h2, l, Gu(1, p));
        } : function(h2, l, p) {
          return h2[l] = p, h2;
        };
      });
      var Lt = b((kd, Aa) => {
        var Xu = ie(), Ju = ae(), Us = kt(), Yu = Xu(Function.toString);
        Ju(Us.inspectSource) || (Us.inspectSource = function(h2) {
          return Yu(h2);
        });
        Aa.exports = Us.inspectSource;
      });
      var Ea = b((Dd, Ta) => {
        var $u = G(), Qu = ae(), Zu = Lt(), Pa = $u.WeakMap;
        Ta.exports = Qu(Pa) && /native code/.test(Zu(Pa));
      });
      var va = b((Fd, ba) => {
        var ec = ws(), tc = Is(), Ca = ec("keys");
        ba.exports = function(h2) {
          return Ca[h2] || (Ca[h2] = tc(h2));
        };
      });
      var _s = b((Ld, Sa) => {
        Sa.exports = {};
      });
      var Fa = b((Od, Da) => {
        var sc = Ea(), ka = G(), zs = ie(), rc = De(), ic = Ft(), Ks = be(), Vs = kt(), ac = va(), nc = _s(), wa = "Object already initialized", Ws = ka.TypeError, oc = ka.WeakMap, Ot, et, Bt, hc = function(h2) {
          return Bt(h2) ? et(h2) : Ot(h2, {});
        }, lc = function(h2) {
          return function(l) {
            var p;
            if (!rc(l) || (p = et(l)).type !== h2)
              throw Ws("Incompatible receiver, " + h2 + " required");
            return p;
          };
        };
        sc || Vs.state ? (ve = Vs.state || (Vs.state = new oc()), Na = zs(ve.get), Hs = zs(ve.has), Ia = zs(ve.set), Ot = function(h2, l) {
          if (Hs(ve, h2))
            throw new Ws(wa);
          return l.facade = h2, Ia(ve, h2, l), l;
        }, et = function(h2) {
          return Na(ve, h2) || {};
        }, Bt = function(h2) {
          return Hs(ve, h2);
        }) : (Le = ac("state"), nc[Le] = true, Ot = function(h2, l) {
          if (Ks(h2, Le))
            throw new Ws(wa);
          return l.facade = h2, ic(h2, Le, l), l;
        }, et = function(h2) {
          return Ks(h2, Le) ? h2[Le] : {};
        }, Bt = function(h2) {
          return Ks(h2, Le);
        });
        var ve, Na, Hs, Ia, Le;
        Da.exports = { set: Ot, get: et, has: Bt, enforce: hc, getterFor: lc };
      });
      var Ba = b((Bd, Oa) => {
        var Gs = ke(), uc = be(), La = Function.prototype, cc = Gs && Object.getOwnPropertyDescriptor, Xs = uc(La, "name"), pc = Xs && function() {
        }.name === "something", fc = Xs && (!Gs || Gs && cc(La, "name").configurable);
        Oa.exports = { EXISTS: Xs, PROPER: pc, CONFIGURABLE: fc };
      });
      var Ua = b((Md, qa) => {
        var dc = G(), Ma = ae(), mc = be(), Ra = Ft(), yc = It(), xc = Lt(), ja = Fa(), gc = Ba().CONFIGURABLE, Ac = ja.get, Pc = ja.enforce, Tc = String(String).split("String");
        (qa.exports = function(h2, l, p, d) {
          var m2 = d ? !!d.unsafe : false, A2 = d ? !!d.enumerable : false, g = d ? !!d.noTargetGet : false, x2 = d && d.name !== void 0 ? d.name : l, T;
          if (Ma(p) && (String(x2).slice(0, 7) === "Symbol(" && (x2 = "[" + String(x2).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!mc(p, "name") || gc && p.name !== x2) && Ra(p, "name", x2), T = Pc(p), T.source || (T.source = Tc.join(typeof x2 == "string" ? x2 : ""))), h2 === dc) {
            A2 ? h2[l] = p : yc(l, p);
            return;
          } else
            m2 ? !g && h2[l] && (A2 = true) : delete h2[l];
          A2 ? h2[l] = p : Ra(h2, l, p);
        })(Function.prototype, "toString", function() {
          return Ma(this) && Ac(this).source || xc(this);
        });
      });
      var Js = b((Rd, _a4) => {
        var Ec = Math.ceil, Cc = Math.floor;
        _a4.exports = function(h2) {
          var l = +h2;
          return l !== l || l === 0 ? 0 : (l > 0 ? Cc : Ec)(l);
        };
      });
      var Ka = b((jd, za) => {
        var bc = Js(), vc = Math.max, Sc = Math.min;
        za.exports = function(h2, l) {
          var p = bc(h2);
          return p < 0 ? vc(p + l, 0) : Sc(p, l);
        };
      });
      var Ha = b((qd, Va) => {
        var wc = Js(), Nc = Math.min;
        Va.exports = function(h2) {
          return h2 > 0 ? Nc(wc(h2), 9007199254740991) : 0;
        };
      });
      var Mt = b((Ud, Wa) => {
        var Ic = Ha();
        Wa.exports = function(h2) {
          return Ic(h2.length);
        };
      });
      var Ja = b((_d2, Xa) => {
        var kc = St(), Dc = Ka(), Fc = Mt(), Ga = function(h2) {
          return function(l, p, d) {
            var m2 = kc(l), A2 = Fc(m2), g = Dc(d, A2), x2;
            if (h2 && p != p) {
              for (; A2 > g; )
                if (x2 = m2[g++], x2 != x2)
                  return true;
            } else
              for (; A2 > g; g++)
                if ((h2 || g in m2) && m2[g] === p)
                  return h2 || g || 0;
            return !h2 && -1;
          };
        };
        Xa.exports = { includes: Ga(true), indexOf: Ga(false) };
      });
      var Qa = b((zd, $a) => {
        var Lc = ie(), Ys = be(), Oc = St(), Bc = Ja().indexOf, Mc = _s(), Ya = Lc([].push);
        $a.exports = function(h2, l) {
          var p = Oc(h2), d = 0, m2 = [], A2;
          for (A2 in p)
            !Ys(Mc, A2) && Ys(p, A2) && Ya(m2, A2);
          for (; l.length > d; )
            Ys(p, A2 = l[d++]) && (~Bc(m2, A2) || Ya(m2, A2));
          return m2;
        };
      });
      var en = b((Kd, Za) => {
        Za.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var sn = b((tn) => {
        var Rc = Qa(), jc = en(), qc = jc.concat("length", "prototype");
        tn.f = Object.getOwnPropertyNames || function(l) {
          return Rc(l, qc);
        };
      });
      var an = b((rn) => {
        rn.f = Object.getOwnPropertySymbols;
      });
      var on = b((Wd, nn) => {
        var Uc = Qe(), _c = ie(), zc = sn(), Kc = an(), Vc = Os(), Hc = _c([].concat);
        nn.exports = Uc("Reflect", "ownKeys") || function(l) {
          var p = zc.f(Vc(l)), d = Kc.f;
          return d ? Hc(p, d(l)) : p;
        };
      });
      var un = b((Gd, ln) => {
        var hn = be(), Wc = on(), Gc = Ls(), Xc = qs();
        ln.exports = function(h2, l, p) {
          for (var d = Wc(l), m2 = Xc.f, A2 = Gc.f, g = 0; g < d.length; g++) {
            var x2 = d[g];
            !hn(h2, x2) && !(p && hn(p, x2)) && m2(h2, x2, A2(l, x2));
          }
        };
      });
      var pn = b((Xd, cn) => {
        var Jc = Ae(), Yc = ae(), $c = /#|\.prototype\./, tt = function(h2, l) {
          var p = Zc[Qc(h2)];
          return p == tp ? true : p == ep ? false : Yc(l) ? Jc(l) : !!l;
        }, Qc = tt.normalize = function(h2) {
          return String(h2).replace($c, ".").toLowerCase();
        }, Zc = tt.data = {}, ep = tt.NATIVE = "N", tp = tt.POLYFILL = "P";
        cn.exports = tt;
      });
      var Qs = b((Jd, fn) => {
        var $s = G(), sp = Ls().f, rp = Ft(), ip = Ua(), ap = It(), np = un(), op = pn();
        fn.exports = function(h2, l) {
          var p = h2.target, d = h2.global, m2 = h2.stat, A2, g, x2, T, k, D;
          if (d ? g = $s : m2 ? g = $s[p] || ap(p, {}) : g = ($s[p] || {}).prototype, g)
            for (x2 in l) {
              if (k = l[x2], h2.noTargetGet ? (D = sp(g, x2), T = D && D.value) : T = g[x2], A2 = op(d ? x2 : p + (m2 ? "." : "#") + x2, h2.forced), !A2 && T !== void 0) {
                if (typeof k == typeof T)
                  continue;
                np(k, T);
              }
              (h2.sham || T && T.sham) && rp(k, "sham", true), ip(g, x2, k, h2);
            }
        };
      });
      var dn = b(() => {
        var hp = Qs(), lp = G();
        hp({ global: true }, { globalThis: lp });
      });
      var mn = b(() => {
        dn();
      });
      var Zs = b((em, yn) => {
        var up = vt();
        yn.exports = Array.isArray || function(l) {
          return up(l) == "Array";
        };
      });
      var An = b((tm, gn) => {
        var xn = ie(), cp = Nt(), pp = Et(), fp = xn(xn.bind);
        gn.exports = function(h2, l) {
          return cp(h2), l === void 0 ? h2 : pp ? fp(h2, l) : function() {
            return h2.apply(l, arguments);
          };
        };
      });
      var En = b((sm, Tn) => {
        "use strict";
        var dp = G(), mp = Zs(), yp = Mt(), xp = An(), gp = dp.TypeError, Pn = function(h2, l, p, d, m2, A2, g, x2) {
          for (var T = m2, k = 0, D = g ? xp(g, x2) : false, E, L; k < d; ) {
            if (k in p) {
              if (E = D ? D(p[k], k, l) : p[k], A2 > 0 && mp(E))
                L = yp(E), T = Pn(h2, l, E, L, T, A2 - 1) - 1;
              else {
                if (T >= 9007199254740991)
                  throw gp("Exceed the acceptable array length");
                h2[T] = E;
              }
              T++;
            }
            k++;
          }
          return T;
        };
        Tn.exports = Pn;
      });
      var vn = b((rm, bn) => {
        var Ap = Ze(), Pp = Ap("toStringTag"), Cn = {};
        Cn[Pp] = "z";
        bn.exports = String(Cn) === "[object z]";
      });
      var wn = b((im, Sn) => {
        var Tp = G(), Ep = vn(), Cp = ae(), Rt = vt(), bp = Ze(), vp = bp("toStringTag"), Sp = Tp.Object, wp = Rt(function() {
          return arguments;
        }()) == "Arguments", Np = function(h2, l) {
          try {
            return h2[l];
          } catch {
          }
        };
        Sn.exports = Ep ? Rt : function(h2) {
          var l, p, d;
          return h2 === void 0 ? "Undefined" : h2 === null ? "Null" : typeof (p = Np(l = Sp(h2), vp)) == "string" ? p : wp ? Rt(l) : (d = Rt(l)) == "Object" && Cp(l.callee) ? "Arguments" : d;
        };
      });
      var Ln = b((am, Fn) => {
        var Ip = ie(), kp = Ae(), Nn = ae(), Dp = wn(), Fp = Qe(), Lp = Lt(), In = function() {
        }, Op = [], kn = Fp("Reflect", "construct"), er = /^\s*(?:class|function)\b/, Bp = Ip(er.exec), Mp = !er.exec(In), st = function(l) {
          if (!Nn(l))
            return false;
          try {
            return kn(In, Op, l), true;
          } catch {
            return false;
          }
        }, Dn = function(l) {
          if (!Nn(l))
            return false;
          switch (Dp(l)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return Mp || !!Bp(er, Lp(l));
          } catch {
            return true;
          }
        };
        Dn.sham = true;
        Fn.exports = !kn || kp(function() {
          var h2;
          return st(st.call) || !st(Object) || !st(function() {
            h2 = true;
          }) || h2;
        }) ? Dn : st;
      });
      var Rn = b((nm, Mn) => {
        var Rp = G(), On = Zs(), jp = Ln(), qp = De(), Up = Ze(), _p = Up("species"), Bn = Rp.Array;
        Mn.exports = function(h2) {
          var l;
          return On(h2) && (l = h2.constructor, jp(l) && (l === Bn || On(l.prototype)) ? l = void 0 : qp(l) && (l = l[_p], l === null && (l = void 0))), l === void 0 ? Bn : l;
        };
      });
      var qn = b((om, jn) => {
        var zp = Rn();
        jn.exports = function(h2, l) {
          return new (zp(h2))(l === 0 ? 0 : l);
        };
      });
      var Un = b(() => {
        "use strict";
        var Kp = Qs(), Vp = En(), Hp = Nt(), Wp = Ns(), Gp = Mt(), Xp = qn();
        Kp({ target: "Array", proto: true }, { flatMap: function(l) {
          var p = Wp(this), d = Gp(p), m2;
          return Hp(l), m2 = Xp(p, 0), m2.length = Vp(m2, p, p, d, 0, 1, l, arguments.length > 1 ? arguments[1] : void 0), m2;
        } });
      });
      var qf = b((um, Eo) => {
        var _n, zn, Kn, Vn, Hn;
        function rt(h2, l) {
          return l || (l = h2.slice(0)), Object.freeze(Object.defineProperties(h2, { raw: { value: Object.freeze(l) } }));
        }
        mn();
        Un();
        var ir = Object.defineProperty, Jp = Object.getOwnPropertyDescriptor, ar = Object.getOwnPropertyNames, Yp = Object.prototype.hasOwnProperty, $n = (h2, l) => function() {
          return h2 && (l = (0, h2[ar(h2)[0]])(h2 = 0)), l;
        }, H = (h2, l) => function() {
          return l || (0, h2[ar(h2)[0]])((l = { exports: {} }).exports, l), l.exports;
        }, $p = (h2, l) => {
          for (var p in l)
            ir(h2, p, { get: l[p], enumerable: true });
        }, Qp = (h2, l, p, d) => {
          if (l && typeof l == "object" || typeof l == "function")
            for (let m2 of ar(l))
              !Yp.call(h2, m2) && m2 !== p && ir(h2, m2, { get: () => l[m2], enumerable: !(d = Jp(l, m2)) || d.enumerable });
          return h2;
        }, Zp = (h2) => Qp(ir({}, "__esModule", { value: true }), h2), V = $n({ "<define:process>"() {
        } }), ef = H({ "src/utils/try-combinations.js"(h2, l) {
          "use strict";
          V();
          function p() {
            let d;
            for (var m2 = arguments.length, A2 = new Array(m2), g = 0; g < m2; g++)
              A2[g] = arguments[g];
            for (let [x2, T] of A2.entries())
              try {
                return { result: T() };
              } catch (k) {
                x2 === 0 && (d = k);
              }
            return { error: d };
          }
          l.exports = p;
        } }), Qn = H({ "src/language-js/utils/get-shebang.js"(h2, l) {
          "use strict";
          V();
          function p(d) {
            if (!d.startsWith("#!"))
              return "";
            let m2 = d.indexOf(`
`);
            return m2 === -1 ? d : d.slice(0, m2);
          }
          l.exports = p;
        } }), tf = H({ "src/utils/text/skip-inline-comment.js"(h2, l) {
          "use strict";
          V();
          function p(d, m2) {
            if (m2 === false)
              return false;
            if (d.charAt(m2) === "/" && d.charAt(m2 + 1) === "*") {
              for (let A2 = m2 + 2; A2 < d.length; ++A2)
                if (d.charAt(A2) === "*" && d.charAt(A2 + 1) === "/")
                  return A2 + 2;
            }
            return m2;
          }
          l.exports = p;
        } }), sf = H({ "src/utils/text/skip-newline.js"(h2, l) {
          "use strict";
          V();
          function p(d, m2, A2) {
            let g = A2 && A2.backwards;
            if (m2 === false)
              return false;
            let x2 = d.charAt(m2);
            if (g) {
              if (d.charAt(m2 - 1) === "\r" && x2 === `
`)
                return m2 - 2;
              if (x2 === `
` || x2 === "\r" || x2 === "\u2028" || x2 === "\u2029")
                return m2 - 1;
            } else {
              if (x2 === "\r" && d.charAt(m2 + 1) === `
`)
                return m2 + 2;
              if (x2 === `
` || x2 === "\r" || x2 === "\u2028" || x2 === "\u2029")
                return m2 + 1;
            }
            return m2;
          }
          l.exports = p;
        } }), Zn = H({ "src/utils/text/skip.js"(h2, l) {
          "use strict";
          V();
          function p(x2) {
            return (T, k, D) => {
              let E = D && D.backwards;
              if (k === false)
                return false;
              let { length: L } = T, R = k;
              for (; R >= 0 && R < L; ) {
                let F2 = T.charAt(R);
                if (x2 instanceof RegExp) {
                  if (!x2.test(F2))
                    return R;
                } else if (!x2.includes(F2))
                  return R;
                E ? R-- : R++;
              }
              return R === -1 || R === L ? R : false;
            };
          }
          var d = p(/\s/), m2 = p(" 	"), A2 = p(",; 	"), g = p(/[^\n\r]/);
          l.exports = { skipWhitespace: d, skipSpaces: m2, skipToLineEnd: A2, skipEverythingButNewLine: g };
        } }), rf = H({ "src/utils/text/skip-trailing-comment.js"(h2, l) {
          "use strict";
          V();
          var { skipEverythingButNewLine: p } = Zn();
          function d(m2, A2) {
            return A2 === false ? false : m2.charAt(A2) === "/" && m2.charAt(A2 + 1) === "/" ? p(m2, A2) : A2;
          }
          l.exports = d;
        } }), af = H({ "src/utils/text/get-next-non-space-non-comment-character-index-with-start-index.js"(h2, l) {
          "use strict";
          V();
          var p = tf(), d = sf(), m2 = rf(), { skipSpaces: A2 } = Zn();
          function g(x2, T) {
            let k = null, D = T;
            for (; D !== k; )
              k = D, D = A2(x2, D), D = p(x2, D), D = m2(x2, D), D = d(x2, D);
            return D;
          }
          l.exports = g;
        } }), eo = {};
        $p(eo, { EOL: () => rr, arch: () => nf, cpus: () => oo, default: () => po, endianness: () => to, freemem: () => ao, getNetworkInterfaces: () => co, hostname: () => so, loadavg: () => ro, networkInterfaces: () => uo, platform: () => of, release: () => lo, tmpDir: () => tr, tmpdir: () => sr, totalmem: () => no, type: () => ho, uptime: () => io });
        function to() {
          if (typeof jt > "u") {
            var h2 = new ArrayBuffer(2), l = new Uint8Array(h2), p = new Uint16Array(h2);
            if (l[0] = 1, l[1] = 2, p[0] === 258)
              jt = "BE";
            else if (p[0] === 513)
              jt = "LE";
            else
              throw new Error("unable to figure out endianess");
          }
          return jt;
        }
        function so() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function ro() {
          return [];
        }
        function io() {
          return 0;
        }
        function ao() {
          return Number.MAX_VALUE;
        }
        function no() {
          return Number.MAX_VALUE;
        }
        function oo() {
          return [];
        }
        function ho() {
          return "Browser";
        }
        function lo() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function uo() {
        }
        function co() {
        }
        function nf() {
          return "javascript";
        }
        function of() {
          return "browser";
        }
        function tr() {
          return "/tmp";
        }
        var jt, sr, rr, po, hf = $n({ "node-modules-polyfills:os"() {
          V(), sr = tr, rr = `
`, po = { EOL: rr, tmpdir: sr, tmpDir: tr, networkInterfaces: uo, getNetworkInterfaces: co, release: lo, type: ho, cpus: oo, totalmem: no, freemem: ao, uptime: io, loadavg: ro, hostname: so, endianness: to };
        } }), lf = H({ "node-modules-polyfills-commonjs:os"(h2, l) {
          V();
          var p = (hf(), Zp(eo));
          if (p && p.default) {
            l.exports = p.default;
            for (let d in p)
              l.exports[d] = p[d];
          } else
            p && (l.exports = p);
        } }), uf = H({ "node_modules/detect-newline/index.js"(h2, l) {
          "use strict";
          V();
          var p = (d) => {
            if (typeof d != "string")
              throw new TypeError("Expected a string");
            let m2 = d.match(/(?:\r?\n)/g) || [];
            if (m2.length === 0)
              return;
            let A2 = m2.filter((x2) => x2 === `\r
`).length, g = m2.length - A2;
            return A2 > g ? `\r
` : `
`;
          };
          l.exports = p, l.exports.graceful = (d) => typeof d == "string" && p(d) || `
`;
        } }), cf = H({ "node_modules/jest-docblock/build/index.js"(h2) {
          "use strict";
          V(), Object.defineProperty(h2, "__esModule", { value: true }), h2.extract = R, h2.parse = W, h2.parseWithComments = Y, h2.print = M, h2.strip = F2;
          function l() {
            let u = lf();
            return l = function() {
              return u;
            }, u;
          }
          function p() {
            let u = d(uf());
            return p = function() {
              return u;
            }, u;
          }
          function d(u) {
            return u && u.__esModule ? u : { default: u };
          }
          var m2 = /\*\/$/, A2 = /^\/\*\*/, g = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, x2 = /(^|\s+)\/\/([^\r\n]*)/g, T = /^(\r?\n)+/, k = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, D = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, E = /(\r?\n|^) *\* ?/g, L = [];
          function R(u) {
            let X = u.match(g);
            return X ? X[0].trimLeft() : "";
          }
          function F2(u) {
            let X = u.match(g);
            return X && X[0] ? u.substring(X[0].length) : u;
          }
          function W(u) {
            return Y(u).pragmas;
          }
          function Y(u) {
            let X = (0, p().default)(u) || l().EOL;
            u = u.replace(A2, "").replace(m2, "").replace(E, "$1");
            let se = "";
            for (; se !== u; )
              se = u, u = u.replace(k, "".concat(X, "$1 $2").concat(X));
            u = u.replace(T, "").trimRight();
            let J = /* @__PURE__ */ Object.create(null), Oe = u.replace(D, "").replace(T, "").trimRight(), $;
            for (; $ = D.exec(u); ) {
              let z = $[2].replace(x2, "");
              typeof J[$[1]] == "string" || Array.isArray(J[$[1]]) ? J[$[1]] = L.concat(J[$[1]], z) : J[$[1]] = z;
            }
            return { comments: Oe, pragmas: J };
          }
          function M(u) {
            let { comments: X = "", pragmas: se = {} } = u, J = (0, p().default)(X) || l().EOL, Oe = "/**", $ = " *", z = " */", O = Object.keys(se), C = O.map((Z2) => j(Z2, se[Z2])).reduce((Z2, he) => Z2.concat(he), []).map((Z2) => $ + " " + Z2 + J).join("");
            if (!X) {
              if (O.length === 0)
                return "";
              if (O.length === 1 && !Array.isArray(se[O[0]])) {
                let Z2 = se[O[0]];
                return "".concat(Oe, " ").concat(j(O[0], Z2)[0]).concat(z);
              }
            }
            let Ve = X.split(J).map((Z2) => "".concat($, " ").concat(Z2)).join(J) + J;
            return Oe + J + (X ? Ve : "") + (X && O.length ? $ + J : "") + C + z;
          }
          function j(u, X) {
            return L.concat(X).map((se) => "@".concat(u, " ").concat(se).trim());
          }
        } }), pf = H({ "src/common/end-of-line.js"(h2, l) {
          "use strict";
          V();
          function p(g) {
            let x2 = g.indexOf("\r");
            return x2 >= 0 ? g.charAt(x2 + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function d(g) {
            switch (g) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function m2(g, x2) {
            let T;
            switch (x2) {
              case `
`:
                T = /\n/g;
                break;
              case "\r":
                T = /\r/g;
                break;
              case `\r
`:
                T = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(x2), "."));
            }
            let k = g.match(T);
            return k ? k.length : 0;
          }
          function A2(g) {
            return g.replace(/\r\n?/g, `
`);
          }
          l.exports = { guessEndOfLine: p, convertEndOfLineToChars: d, countEndOfLineChars: m2, normalizeEndOfLine: A2 };
        } }), ff = H({ "src/language-js/pragma.js"(h2, l) {
          "use strict";
          V();
          var { parseWithComments: p, strip: d, extract: m2, print: A2 } = cf(), { normalizeEndOfLine: g } = pf(), x2 = Qn();
          function T(E) {
            let L = x2(E);
            L && (E = E.slice(L.length + 1));
            let R = m2(E), { pragmas: F2, comments: W } = p(R);
            return { shebang: L, text: E, pragmas: F2, comments: W };
          }
          function k(E) {
            let L = Object.keys(T(E).pragmas);
            return L.includes("prettier") || L.includes("format");
          }
          function D(E) {
            let { shebang: L, text: R, pragmas: F2, comments: W } = T(E), Y = d(R), M = A2({ pragmas: Object.assign({ format: "" }, F2), comments: W.trimStart() });
            return (L ? "".concat(L, `
`) : "") + g(M) + (Y.startsWith(`
`) ? `
` : `

`) + Y;
          }
          l.exports = { hasPragma: k, insertPragma: D };
        } }), fo = H({ "src/utils/is-non-empty-array.js"(h2, l) {
          "use strict";
          V();
          function p(d) {
            return Array.isArray(d) && d.length > 0;
          }
          l.exports = p;
        } }), mo = H({ "src/language-js/loc.js"(h2, l) {
          "use strict";
          V();
          var p = fo();
          function d(T, k) {
            let { ignoreDecorators: D } = k || {};
            if (!D) {
              let E = T.declaration && T.declaration.decorators || T.decorators;
              if (p(E))
                return d(E[0]);
            }
            return T.range ? T.range[0] : T.start;
          }
          function m2(T) {
            return T.range ? T.range[1] : T.end;
          }
          function A2(T, k) {
            let D = d(T);
            return Number.isInteger(D) && D === d(k);
          }
          function g(T, k) {
            let D = m2(T);
            return Number.isInteger(D) && D === m2(k);
          }
          function x2(T, k) {
            return A2(T, k) && g(T, k);
          }
          l.exports = { locStart: d, locEnd: m2, hasSameLocStart: A2, hasSameLoc: x2 };
        } }), yo = H({ "src/language-js/parse/utils/create-parser.js"(h2, l) {
          "use strict";
          V();
          var { hasPragma: p } = ff(), { locStart: d, locEnd: m2 } = mo();
          function A2(g) {
            return g = typeof g == "function" ? { parse: g } : g, Object.assign({ astFormat: "estree", hasPragma: p, locStart: d, locEnd: m2 }, g);
          }
          l.exports = A2;
        } }), nr = H({ "src/common/parser-create-error.js"(h2, l) {
          "use strict";
          V();
          function p(d, m2) {
            let A2 = new SyntaxError(d + " (" + m2.start.line + ":" + m2.start.column + ")");
            return A2.loc = m2, A2;
          }
          l.exports = p;
        } }), xo = H({ "src/language-js/parse/utils/create-babel-parse-error.js"(h2, l) {
          "use strict";
          V();
          var p = nr();
          function d(m2) {
            let { message: A2, loc: g } = m2;
            return p(A2.replace(/ \(.*\)/, ""), { start: { line: g ? g.line : 0, column: g ? g.column + 1 : 0 } });
          }
          l.exports = d;
        } }), df = H({ "src/language-js/utils/is-ts-keyword-type.js"(h2, l) {
          "use strict";
          V();
          function p(d) {
            let { type: m2 } = d;
            return m2.startsWith("TS") && m2.endsWith("Keyword");
          }
          l.exports = p;
        } }), mf = H({ "src/language-js/utils/is-block-comment.js"(h2, l) {
          "use strict";
          V();
          var p = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), d = (m2) => p.has(m2 == null ? void 0 : m2.type);
          l.exports = d;
        } }), yf = H({ "src/language-js/utils/is-type-cast-comment.js"(h2, l) {
          "use strict";
          V();
          var p = mf();
          function d(m2) {
            return p(m2) && m2.value[0] === "*" && /@type\b/.test(m2.value);
          }
          l.exports = d;
        } }), xf = H({ "src/utils/get-last.js"(h2, l) {
          "use strict";
          V();
          var p = (d) => d[d.length - 1];
          l.exports = p;
        } }), go = H({ "src/language-js/parse/postprocess/visit-node.js"(h2, l) {
          "use strict";
          V();
          function p(d, m2) {
            if (Array.isArray(d)) {
              for (let A2 = 0; A2 < d.length; A2++)
                d[A2] = p(d[A2], m2);
              return d;
            }
            if (d && typeof d == "object" && typeof d.type == "string") {
              let A2 = Object.keys(d);
              for (let g = 0; g < A2.length; g++)
                d[A2[g]] = p(d[A2[g]], m2);
              return m2(d) || d;
            }
            return d;
          }
          l.exports = p;
        } }), Ao = H({ "src/language-js/parse/postprocess/throw-syntax-error.js"(h2, l) {
          "use strict";
          V();
          var p = nr();
          function d(m2, A2) {
            let { start: g, end: x2 } = m2.loc;
            throw p(A2, { start: { line: g.line, column: g.column + 1 }, end: { line: x2.line, column: x2.column + 1 } });
          }
          l.exports = d;
        } }), gf = H({ "src/language-js/parse/postprocess/typescript.js"(h2, l) {
          "use strict";
          V();
          var p = go(), d = Ao();
          function m2(x2, T, k) {
            let D = x2.decorators;
            if (!Array.isArray(D))
              return;
            let E = T.decorators;
            (!Array.isArray(E) || E.length !== D.length || D.some((L) => {
              let R = k.get(L);
              return !R || !E.includes(R);
            })) && d(T, "Leading decorators must be attached to a class declaration");
          }
          function A2(x2, T) {
            x2.kind !== 167 || x2.modifiers && !x2.modifiers.some((E) => E.kind === 126) || x2.initializer && T.value === null && d(T, "Abstract property cannot have an initializer");
          }
          function g(x2, T) {
            let { esTreeNodeToTSNodeMap: k, tsNodeToESTreeNodeMap: D } = T.tsParseResult;
            p(x2, (E) => {
              let L = k.get(E);
              if (!L)
                return;
              let R = D.get(L);
              R === E && (m2(L, R, D), A2(L, R));
            });
          }
          l.exports = { throwErrorForInvalidNodes: g };
        } }), Af = H({ "src/language-js/parse/postprocess/index.js"(h2, l) {
          "use strict";
          V();
          var { locStart: p, locEnd: d } = mo(), m2 = df(), A2 = yf(), g = xf(), x2 = go(), { throwErrorForInvalidNodes: T } = gf(), k = Ao();
          function D(F2, W) {
            if (W.parser === "typescript" && /@|abstract/.test(W.originalText) && T(F2, W), W.parser !== "typescript" && W.parser !== "flow" && W.parser !== "acorn" && W.parser !== "espree" && W.parser !== "meriyah") {
              let M = /* @__PURE__ */ new Set();
              F2 = x2(F2, (j) => {
                j.leadingComments && j.leadingComments.some(A2) && M.add(p(j));
              }), F2 = x2(F2, (j) => {
                if (j.type === "ParenthesizedExpression") {
                  let { expression: u } = j;
                  if (u.type === "TypeCastExpression")
                    return u.range = j.range, u;
                  let X = p(j);
                  if (!M.has(X))
                    return u.extra = Object.assign(Object.assign({}, u.extra), {}, { parenthesized: true }), u;
                }
              });
            }
            return F2 = x2(F2, (M) => {
              switch (M.type) {
                case "ChainExpression":
                  return E(M.expression);
                case "LogicalExpression": {
                  if (L(M))
                    return R(M);
                  break;
                }
                case "VariableDeclaration": {
                  let j = g(M.declarations);
                  j && j.init && Y(M, j);
                  break;
                }
                case "TSParenthesizedType":
                  return m2(M.typeAnnotation) || M.typeAnnotation.type === "TSThisType" || (M.typeAnnotation.range = [p(M), d(M)]), M.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof M.name == "string") {
                    let j = p(M);
                    M.name = { type: "Identifier", name: M.name, range: [j, j + M.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (W.parser === "typescript") {
                    let j = M.properties.find((u) => u.type === "Property" && u.value.type === "TSEmptyBodyFunctionExpression");
                    j && k(j.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let j = g(M.expressions);
                  M.range = [p(M), Math.min(d(j), d(M))];
                  break;
                }
                case "TopicReference":
                  W.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: j } = M;
                  if (W.parser === "meriyah" && j && j.type === "Identifier") {
                    let u = W.originalText.slice(p(j), d(j));
                    (u.startsWith('"') || u.startsWith("'")) && (M.exported = Object.assign(Object.assign({}, M.exported), {}, { type: "Literal", value: M.exported.name, raw: u }));
                  }
                  break;
                }
              }
            }), F2;
            function Y(M, j) {
              W.originalText[d(j)] !== ";" && (M.range = [p(M), d(j)]);
            }
          }
          function E(F2) {
            switch (F2.type) {
              case "CallExpression":
                F2.type = "OptionalCallExpression", F2.callee = E(F2.callee);
                break;
              case "MemberExpression":
                F2.type = "OptionalMemberExpression", F2.object = E(F2.object);
                break;
              case "TSNonNullExpression":
                F2.expression = E(F2.expression);
                break;
            }
            return F2;
          }
          function L(F2) {
            return F2.type === "LogicalExpression" && F2.right.type === "LogicalExpression" && F2.operator === F2.right.operator;
          }
          function R(F2) {
            return L(F2) ? R({ type: "LogicalExpression", operator: F2.operator, left: R({ type: "LogicalExpression", operator: F2.operator, left: F2.left, right: F2.right.left, range: [p(F2.left), d(F2.right.left)] }), right: F2.right.right, range: [p(F2), d(F2)] }) : F2;
          }
          l.exports = D;
        } }), Po = H({ "node_modules/@babel/parser/lib/index.js"(h2) {
          "use strict";
          V(), Object.defineProperty(h2, "__esModule", { value: true });
          function l(t2, e2) {
            if (t2 == null)
              return {};
            var s2 = {}, r2 = Object.keys(t2), i2, a;
            for (a = 0; a < r2.length; a++)
              i2 = r2[a], !(e2.indexOf(i2) >= 0) && (s2[i2] = t2[i2]);
            return s2;
          }
          var p = class {
            constructor(t2, e2, s2) {
              this.line = void 0, this.column = void 0, this.index = void 0, this.line = t2, this.column = e2, this.index = s2;
            }
          }, d = class {
            constructor(t2, e2) {
              this.start = void 0, this.end = void 0, this.filename = void 0, this.identifierName = void 0, this.start = t2, this.end = e2;
            }
          };
          function m2(t2, e2) {
            let { line: s2, column: r2, index: i2 } = t2;
            return new p(s2, r2 + e2, i2 + e2);
          }
          var A2 = Object.freeze({ SyntaxError: "BABEL_PARSER_SYNTAX_ERROR", SourceTypeModuleError: "BABEL_PARSER_SOURCETYPE_MODULE_REQUIRED" }), g = function(t2) {
            let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : t2.length - 1;
            return { get() {
              return t2.reduce((s2, r2) => s2[r2], this);
            }, set(s2) {
              t2.reduce((r2, i2, a) => a === e2 ? r2[i2] = s2 : r2[i2], this);
            } };
          }, x2 = (t2, e2, s2) => Object.keys(s2).map((r2) => [r2, s2[r2]]).filter((r2) => {
            let [, i2] = r2;
            return !!i2;
          }).map((r2) => {
            let [i2, a] = r2;
            return [i2, typeof a == "function" ? { value: a, enumerable: false } : typeof a.reflect == "string" ? Object.assign({}, a, g(a.reflect.split("."))) : a];
          }).reduce((r2, i2) => {
            let [a, n] = i2;
            return Object.defineProperty(r2, a, Object.assign({ configurable: true }, n));
          }, Object.assign(new t2(), e2)), T = (t2) => ({ ImportMetaOutsideModule: t2(`import.meta may appear only with 'sourceType: "module"'`, { code: A2.SourceTypeModuleError }), ImportOutsideModule: t2(`'import' and 'export' may appear only with 'sourceType: "module"'`, { code: A2.SourceTypeModuleError }) }), k = { ArrayPattern: "array destructuring pattern", AssignmentExpression: "assignment expression", AssignmentPattern: "assignment expression", ArrowFunctionExpression: "arrow function expression", ConditionalExpression: "conditional expression", ForOfStatement: "for-of statement", ForInStatement: "for-in statement", ForStatement: "for-loop", FormalParameters: "function parameter list", Identifier: "identifier", ObjectPattern: "object destructuring pattern", ParenthesizedExpression: "parenthesized expression", RestElement: "rest element", UpdateExpression: { true: "prefix operation", false: "postfix operation" }, VariableDeclarator: "variable declaration", YieldExpression: "yield expression" }, D = (t2) => {
            let { type: e2, prefix: s2 } = t2;
            return e2 === "UpdateExpression" ? k.UpdateExpression[String(s2)] : k[e2];
          }, E = (t2) => ({ AccessorIsGenerator: t2((e2) => {
            let { kind: s2 } = e2;
            return "A ".concat(s2, "ter cannot be a generator.");
          }), ArgumentsInClass: t2("'arguments' is only allowed in functions and class methods."), AsyncFunctionInSingleStatementContext: t2("Async functions can only be declared at the top level or inside a block."), AwaitBindingIdentifier: t2("Can not use 'await' as identifier inside an async function."), AwaitBindingIdentifierInStaticBlock: t2("Can not use 'await' as identifier inside a static block."), AwaitExpressionFormalParameter: t2("'await' is not allowed in async function parameters."), AwaitNotInAsyncContext: t2("'await' is only allowed within async functions and at the top levels of modules."), AwaitNotInAsyncFunction: t2("'await' is only allowed within async functions."), BadGetterArity: t2("A 'get' accesor must not have any formal parameters."), BadSetterArity: t2("A 'set' accesor must have exactly one formal parameter."), BadSetterRestParameter: t2("A 'set' accesor function argument must not be a rest parameter."), ConstructorClassField: t2("Classes may not have a field named 'constructor'."), ConstructorClassPrivateField: t2("Classes may not have a private field named '#constructor'."), ConstructorIsAccessor: t2("Class constructor may not be an accessor."), ConstructorIsAsync: t2("Constructor can't be an async function."), ConstructorIsGenerator: t2("Constructor can't be a generator."), DeclarationMissingInitializer: t2((e2) => {
            let { kind: s2 } = e2;
            return "Missing initializer in ".concat(s2, " declaration.");
          }), DecoratorBeforeExport: t2("Decorators must be placed *before* the 'export' keyword. You can set the 'decoratorsBeforeExport' option to false to use the 'export @decorator class {}' syntax."), DecoratorConstructor: t2("Decorators can't be used with a constructor. Did you mean '@dec class { ... }'?"), DecoratorExportClass: t2("Using the export keyword between a decorator and a class is not allowed. Please use `export @dec class` instead."), DecoratorSemicolon: t2("Decorators must not be followed by a semicolon."), DecoratorStaticBlock: t2("Decorators can't be used with a static block."), DeletePrivateField: t2("Deleting a private field is not allowed."), DestructureNamedImport: t2("ES2015 named imports do not destructure. Use another statement for destructuring after the import."), DuplicateConstructor: t2("Duplicate constructor in the same class."), DuplicateDefaultExport: t2("Only one default export allowed per module."), DuplicateExport: t2((e2) => {
            let { exportName: s2 } = e2;
            return "`".concat(s2, "` has already been exported. Exported identifiers must be unique.");
          }), DuplicateProto: t2("Redefinition of __proto__ property."), DuplicateRegExpFlags: t2("Duplicate regular expression flag."), ElementAfterRest: t2("Rest element must be last element."), EscapedCharNotAnIdentifier: t2("Invalid Unicode escape."), ExportBindingIsString: t2((e2) => {
            let { localName: s2, exportName: r2 } = e2;
            return "A string literal cannot be used as an exported binding without `from`.\n- Did you mean `export { '".concat(s2, "' as '").concat(r2, "' } from 'some-module'`?");
          }), ExportDefaultFromAsIdentifier: t2("'from' is not allowed as an identifier after 'export default'."), ForInOfLoopInitializer: t2((e2) => {
            let { type: s2 } = e2;
            return "'".concat(s2 === "ForInStatement" ? "for-in" : "for-of", "' loop variable declaration may not have an initializer.");
          }), ForOfAsync: t2("The left-hand side of a for-of loop may not be 'async'."), ForOfLet: t2("The left-hand side of a for-of loop may not start with 'let'."), GeneratorInSingleStatementContext: t2("Generators can only be declared at the top level or inside a block."), IllegalBreakContinue: t2((e2) => {
            let { type: s2 } = e2;
            return "Unsyntactic ".concat(s2 === "BreakStatement" ? "break" : "continue", ".");
          }), IllegalLanguageModeDirective: t2("Illegal 'use strict' directive in function with non-simple parameter list."), IllegalReturn: t2("'return' outside of function."), ImportBindingIsString: t2((e2) => {
            let { importName: s2 } = e2;
            return 'A string literal cannot be used as an imported binding.\n- Did you mean `import { "'.concat(s2, '" as foo }`?');
          }), ImportCallArgumentTrailingComma: t2("Trailing comma is disallowed inside import(...) arguments."), ImportCallArity: t2((e2) => {
            let { maxArgumentCount: s2 } = e2;
            return "`import()` requires exactly ".concat(s2 === 1 ? "one argument" : "one or two arguments", ".");
          }), ImportCallNotNewExpression: t2("Cannot use new with import(...)."), ImportCallSpreadArgument: t2("`...` is not allowed in `import()`."), IncompatibleRegExpUVFlags: t2("The 'u' and 'v' regular expression flags cannot be enabled at the same time."), InvalidBigIntLiteral: t2("Invalid BigIntLiteral."), InvalidCodePoint: t2("Code point out of bounds."), InvalidCoverInitializedName: t2("Invalid shorthand property initializer."), InvalidDecimal: t2("Invalid decimal."), InvalidDigit: t2((e2) => {
            let { radix: s2 } = e2;
            return "Expected number in radix ".concat(s2, ".");
          }), InvalidEscapeSequence: t2("Bad character escape sequence."), InvalidEscapeSequenceTemplate: t2("Invalid escape sequence in template."), InvalidEscapedReservedWord: t2((e2) => {
            let { reservedWord: s2 } = e2;
            return "Escape sequence in keyword ".concat(s2, ".");
          }), InvalidIdentifier: t2((e2) => {
            let { identifierName: s2 } = e2;
            return "Invalid identifier ".concat(s2, ".");
          }), InvalidLhs: t2((e2) => {
            let { ancestor: s2 } = e2;
            return "Invalid left-hand side in ".concat(D(s2), ".");
          }), InvalidLhsBinding: t2((e2) => {
            let { ancestor: s2 } = e2;
            return "Binding invalid left-hand side in ".concat(D(s2), ".");
          }), InvalidNumber: t2("Invalid number."), InvalidOrMissingExponent: t2("Floating-point numbers require a valid exponent after the 'e'."), InvalidOrUnexpectedToken: t2((e2) => {
            let { unexpected: s2 } = e2;
            return "Unexpected character '".concat(s2, "'.");
          }), InvalidParenthesizedAssignment: t2("Invalid parenthesized assignment pattern."), InvalidPrivateFieldResolution: t2((e2) => {
            let { identifierName: s2 } = e2;
            return "Private name #".concat(s2, " is not defined.");
          }), InvalidPropertyBindingPattern: t2("Binding member expression."), InvalidRecordProperty: t2("Only properties and spread elements are allowed in record definitions."), InvalidRestAssignmentPattern: t2("Invalid rest operator's argument."), LabelRedeclaration: t2((e2) => {
            let { labelName: s2 } = e2;
            return "Label '".concat(s2, "' is already declared.");
          }), LetInLexicalBinding: t2("'let' is not allowed to be used as a name in 'let' or 'const' declarations."), LineTerminatorBeforeArrow: t2("No line break is allowed before '=>'."), MalformedRegExpFlags: t2("Invalid regular expression flag."), MissingClassName: t2("A class name is required."), MissingEqInAssignment: t2("Only '=' operator can be used for specifying default value."), MissingSemicolon: t2("Missing semicolon."), MissingPlugin: t2((e2) => {
            let { missingPlugin: s2 } = e2;
            return "This experimental syntax requires enabling the parser plugin: ".concat(s2.map((r2) => JSON.stringify(r2)).join(", "), ".");
          }), MissingOneOfPlugins: t2((e2) => {
            let { missingPlugin: s2 } = e2;
            return "This experimental syntax requires enabling one of the following parser plugin(s): ".concat(s2.map((r2) => JSON.stringify(r2)).join(", "), ".");
          }), MissingUnicodeEscape: t2("Expecting Unicode escape sequence \\uXXXX."), MixingCoalesceWithLogical: t2("Nullish coalescing operator(??) requires parens when mixing with logical operators."), ModuleAttributeDifferentFromType: t2("The only accepted module attribute is `type`."), ModuleAttributeInvalidValue: t2("Only string literals are allowed as module attribute values."), ModuleAttributesWithDuplicateKeys: t2((e2) => {
            let { key: s2 } = e2;
            return 'Duplicate key "'.concat(s2, '" is not allowed in module attributes.');
          }), ModuleExportNameHasLoneSurrogate: t2((e2) => {
            let { surrogateCharCode: s2 } = e2;
            return "An export name cannot include a lone surrogate, found '\\u".concat(s2.toString(16), "'.");
          }), ModuleExportUndefined: t2((e2) => {
            let { localName: s2 } = e2;
            return "Export '".concat(s2, "' is not defined.");
          }), MultipleDefaultsInSwitch: t2("Multiple default clauses."), NewlineAfterThrow: t2("Illegal newline after throw."), NoCatchOrFinally: t2("Missing catch or finally clause."), NumberIdentifier: t2("Identifier directly after number."), NumericSeparatorInEscapeSequence: t2("Numeric separators are not allowed inside unicode escape sequences or hex escape sequences."), ObsoleteAwaitStar: t2("'await*' has been removed from the async functions proposal. Use Promise.all() instead."), OptionalChainingNoNew: t2("Constructors in/after an Optional Chain are not allowed."), OptionalChainingNoTemplate: t2("Tagged Template Literals are not allowed in optionalChain."), OverrideOnConstructor: t2("'override' modifier cannot appear on a constructor declaration."), ParamDupe: t2("Argument name clash."), PatternHasAccessor: t2("Object pattern can't contain getter or setter."), PatternHasMethod: t2("Object pattern can't contain methods."), PrivateInExpectedIn: t2((e2) => {
            let { identifierName: s2 } = e2;
            return "Private names are only allowed in property accesses (`obj.#".concat(s2, "`) or in `in` expressions (`#").concat(s2, " in obj`).");
          }), PrivateNameRedeclaration: t2((e2) => {
            let { identifierName: s2 } = e2;
            return "Duplicate private name #".concat(s2, ".");
          }), RecordExpressionBarIncorrectEndSyntaxType: t2("Record expressions ending with '|}' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."), RecordExpressionBarIncorrectStartSyntaxType: t2("Record expressions starting with '{|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."), RecordExpressionHashIncorrectStartSyntaxType: t2("Record expressions starting with '#{' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'."), RecordNoProto: t2("'__proto__' is not allowed in Record expressions."), RestTrailingComma: t2("Unexpected trailing comma after rest element."), SloppyFunction: t2("In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement."), StaticPrototype: t2("Classes may not have static property named prototype."), SuperNotAllowed: t2("`super()` is only valid inside a class constructor of a subclass. Maybe a typo in the method name ('constructor') or not extending another class?"), SuperPrivateField: t2("Private fields can't be accessed on super."), TrailingDecorator: t2("Decorators must be attached to a class element."), TupleExpressionBarIncorrectEndSyntaxType: t2("Tuple expressions ending with '|]' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."), TupleExpressionBarIncorrectStartSyntaxType: t2("Tuple expressions starting with '[|' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'bar'."), TupleExpressionHashIncorrectStartSyntaxType: t2("Tuple expressions starting with '#[' are only allowed when the 'syntaxType' option of the 'recordAndTuple' plugin is set to 'hash'."), UnexpectedArgumentPlaceholder: t2("Unexpected argument placeholder."), UnexpectedAwaitAfterPipelineBody: t2('Unexpected "await" after pipeline body; await must have parentheses in minimal proposal.'), UnexpectedDigitAfterHash: t2("Unexpected digit after hash token."), UnexpectedImportExport: t2("'import' and 'export' may only appear at the top level."), UnexpectedKeyword: t2((e2) => {
            let { keyword: s2 } = e2;
            return "Unexpected keyword '".concat(s2, "'.");
          }), UnexpectedLeadingDecorator: t2("Leading decorators must be attached to a class declaration."), UnexpectedLexicalDeclaration: t2("Lexical declaration cannot appear in a single-statement context."), UnexpectedNewTarget: t2("`new.target` can only be used in functions or class properties."), UnexpectedNumericSeparator: t2("A numeric separator is only allowed between two digits."), UnexpectedPrivateField: t2("Unexpected private name."), UnexpectedReservedWord: t2((e2) => {
            let { reservedWord: s2 } = e2;
            return "Unexpected reserved word '".concat(s2, "'.");
          }), UnexpectedSuper: t2("'super' is only allowed in object methods and classes."), UnexpectedToken: t2((e2) => {
            let { expected: s2, unexpected: r2 } = e2;
            return "Unexpected token".concat(r2 ? " '".concat(r2, "'.") : "").concat(s2 ? ', expected "'.concat(s2, '"') : "");
          }), UnexpectedTokenUnaryExponentiation: t2("Illegal expression. Wrap left hand side or entire exponentiation in parentheses."), UnsupportedBind: t2("Binding should be performed on object property."), UnsupportedDecoratorExport: t2("A decorated export must export a class declaration."), UnsupportedDefaultExport: t2("Only expressions, functions or classes are allowed as the `default` export."), UnsupportedImport: t2("`import` can only be used in `import()` or `import.meta`."), UnsupportedMetaProperty: t2((e2) => {
            let { target: s2, onlyValidPropertyName: r2 } = e2;
            return "The only valid meta property for ".concat(s2, " is ").concat(s2, ".").concat(r2, ".");
          }), UnsupportedParameterDecorator: t2("Decorators cannot be used to decorate parameters."), UnsupportedPropertyDecorator: t2("Decorators cannot be used to decorate object literal properties."), UnsupportedSuper: t2("'super' can only be used with function calls (i.e. super()) or in property accesses (i.e. super.prop or super[prop])."), UnterminatedComment: t2("Unterminated comment."), UnterminatedRegExp: t2("Unterminated regular expression."), UnterminatedString: t2("Unterminated string constant."), UnterminatedTemplate: t2("Unterminated template."), VarRedeclaration: t2((e2) => {
            let { identifierName: s2 } = e2;
            return "Identifier '".concat(s2, "' has already been declared.");
          }), YieldBindingIdentifier: t2("Can not use 'yield' as identifier inside a generator."), YieldInParameter: t2("Yield expression is not allowed in formal parameters."), ZeroDigitNumericSeparator: t2("Numeric separator can not be used after leading 0.") }), L = (t2) => ({ StrictDelete: t2("Deleting local variable in strict mode."), StrictEvalArguments: t2((e2) => {
            let { referenceName: s2 } = e2;
            return "Assigning to '".concat(s2, "' in strict mode.");
          }), StrictEvalArgumentsBinding: t2((e2) => {
            let { bindingName: s2 } = e2;
            return "Binding '".concat(s2, "' in strict mode.");
          }), StrictFunction: t2("In strict mode code, functions can only be declared at top level or inside a block."), StrictNumericEscape: t2("The only valid numeric escape in strict mode is '\\0'."), StrictOctalLiteral: t2("Legacy octal literals are not allowed in strict mode."), StrictWith: t2("'with' in strict mode.") }), R = /* @__PURE__ */ new Set(["ArrowFunctionExpression", "AssignmentExpression", "ConditionalExpression", "YieldExpression"]), F2 = (t2) => ({ PipeBodyIsTighter: t2("Unexpected yield after pipeline body; any yield expression acting as Hack-style pipe body must be parenthesized due to its loose operator precedence."), PipeTopicRequiresHackPipes: t2('Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.'), PipeTopicUnbound: t2("Topic reference is unbound; it must be inside a pipe body."), PipeTopicUnconfiguredToken: t2((e2) => {
            let { token: s2 } = e2;
            return "Invalid topic token ".concat(s2, ". In order to use ").concat(s2, ' as a topic reference, the pipelineOperator plugin must be configured with { "proposal": "hack", "topicToken": "').concat(s2, '" }.');
          }), PipeTopicUnused: t2("Hack-style pipe body does not contain a topic reference; Hack-style pipes must use topic at least once."), PipeUnparenthesizedBody: t2((e2) => {
            let { type: s2 } = e2;
            return "Hack-style pipe body cannot be an unparenthesized ".concat(D({ type: s2 }), "; please wrap it in parentheses.");
          }), PipelineBodyNoArrow: t2('Unexpected arrow "=>" after pipeline body; arrow function in pipeline body must be parenthesized.'), PipelineBodySequenceExpression: t2("Pipeline body may not be a comma-separated sequence expression."), PipelineHeadSequenceExpression: t2("Pipeline head should not be a comma-separated sequence expression."), PipelineTopicUnused: t2("Pipeline is in topic style but does not use topic reference."), PrimaryTopicNotAllowed: t2("Topic reference was used in a lexical context without topic binding."), PrimaryTopicRequiresSmartPipeline: t2('Topic reference is used, but the pipelineOperator plugin was not passed a "proposal": "hack" or "smart" option.') }), W = ["toMessage"];
          function Y(t2) {
            let { toMessage: e2 } = t2, s2 = l(t2, W);
            return function r2(i2) {
              let { loc: a, details: n } = i2;
              return x2(SyntaxError, Object.assign({}, s2, { loc: a }), { clone() {
                let o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, c = o.loc || {};
                return r2({ loc: new p("line" in c ? c.line : this.loc.line, "column" in c ? c.column : this.loc.column, "index" in c ? c.index : this.loc.index), details: Object.assign({}, this.details, o.details) });
              }, details: { value: n, enumerable: false }, message: { get() {
                return "".concat(e2(this.details), " (").concat(this.loc.line, ":").concat(this.loc.column, ")");
              }, set(o) {
                Object.defineProperty(this, "message", { value: o });
              } }, pos: { reflect: "loc.index", enumerable: true }, missingPlugin: "missingPlugin" in n && { reflect: "details.missingPlugin", enumerable: true } });
            };
          }
          function M(t2, e2) {
            return Object.assign({ toMessage: typeof t2 == "string" ? () => t2 : t2 }, e2);
          }
          function j(t2, e2) {
            if (Array.isArray(t2))
              return (i2) => j(i2, t2[0]);
            let s2 = t2(M), r2 = {};
            for (let i2 of Object.keys(s2))
              r2[i2] = Y(Object.assign({ code: A2.SyntaxError, reasonCode: i2 }, e2 ? { syntaxPlugin: e2 } : {}, s2[i2]));
            return r2;
          }
          var u = Object.assign({}, j(T), j(E), j(L), j(_n || (_n = rt(["pipelineOperator"])))(F2)), { defineProperty: X } = Object, se = (t2, e2) => X(t2, e2, { enumerable: false, value: t2[e2] });
          function J(t2) {
            return se(t2.loc.start, "index"), se(t2.loc.end, "index"), t2;
          }
          var Oe = (t2) => class extends t2 {
            parse() {
              let e2 = J(super.parse());
              return this.options.tokens && (e2.tokens = e2.tokens.map(J)), e2;
            }
            parseRegExpLiteral(e2) {
              let { pattern: s2, flags: r2 } = e2, i2 = null;
              try {
                i2 = new RegExp(s2, r2);
              } catch {
              }
              let a = this.estreeParseLiteral(i2);
              return a.regex = { pattern: s2, flags: r2 }, a;
            }
            parseBigIntLiteral(e2) {
              let s2;
              try {
                s2 = BigInt(e2);
              } catch {
                s2 = null;
              }
              let r2 = this.estreeParseLiteral(s2);
              return r2.bigint = String(r2.value || e2), r2;
            }
            parseDecimalLiteral(e2) {
              let r2 = this.estreeParseLiteral(null);
              return r2.decimal = String(r2.value || e2), r2;
            }
            estreeParseLiteral(e2) {
              return this.parseLiteral(e2, "Literal");
            }
            parseStringLiteral(e2) {
              return this.estreeParseLiteral(e2);
            }
            parseNumericLiteral(e2) {
              return this.estreeParseLiteral(e2);
            }
            parseNullLiteral() {
              return this.estreeParseLiteral(null);
            }
            parseBooleanLiteral(e2) {
              return this.estreeParseLiteral(e2);
            }
            directiveToStmt(e2) {
              let s2 = e2.value, r2 = this.startNodeAt(e2.start, e2.loc.start), i2 = this.startNodeAt(s2.start, s2.loc.start);
              return i2.value = s2.extra.expressionValue, i2.raw = s2.extra.raw, r2.expression = this.finishNodeAt(i2, "Literal", s2.loc.end), r2.directive = s2.extra.raw.slice(1, -1), this.finishNodeAt(r2, "ExpressionStatement", e2.loc.end);
            }
            initFunction(e2, s2) {
              super.initFunction(e2, s2), e2.expression = false;
            }
            checkDeclaration(e2) {
              e2 != null && this.isObjectProperty(e2) ? this.checkDeclaration(e2.value) : super.checkDeclaration(e2);
            }
            getObjectOrClassMethodParams(e2) {
              return e2.value.params;
            }
            isValidDirective(e2) {
              var s2;
              return e2.type === "ExpressionStatement" && e2.expression.type === "Literal" && typeof e2.expression.value == "string" && !((s2 = e2.expression.extra) != null && s2.parenthesized);
            }
            parseBlockBody(e2) {
              for (var s2 = arguments.length, r2 = new Array(s2 > 1 ? s2 - 1 : 0), i2 = 1; i2 < s2; i2++)
                r2[i2 - 1] = arguments[i2];
              super.parseBlockBody(e2, ...r2);
              let a = e2.directives.map((n) => this.directiveToStmt(n));
              e2.body = a.concat(e2.body), delete e2.directives;
            }
            pushClassMethod(e2, s2, r2, i2, a, n) {
              this.parseMethod(s2, r2, i2, a, n, "ClassMethod", true), s2.typeParameters && (s2.value.typeParameters = s2.typeParameters, delete s2.typeParameters), e2.body.push(s2);
            }
            parsePrivateName() {
              let e2 = super.parsePrivateName();
              return this.getPluginOption("estree", "classFeatures") ? this.convertPrivateNameToPrivateIdentifier(e2) : e2;
            }
            convertPrivateNameToPrivateIdentifier(e2) {
              let s2 = super.getPrivateNameSV(e2);
              return e2 = e2, delete e2.id, e2.name = s2, e2.type = "PrivateIdentifier", e2;
            }
            isPrivateName(e2) {
              return this.getPluginOption("estree", "classFeatures") ? e2.type === "PrivateIdentifier" : super.isPrivateName(e2);
            }
            getPrivateNameSV(e2) {
              return this.getPluginOption("estree", "classFeatures") ? e2.name : super.getPrivateNameSV(e2);
            }
            parseLiteral(e2, s2) {
              let r2 = super.parseLiteral(e2, s2);
              return r2.raw = r2.extra.raw, delete r2.extra, r2;
            }
            parseFunctionBody(e2, s2) {
              let r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              super.parseFunctionBody(e2, s2, r2), e2.expression = e2.body.type !== "BlockStatement";
            }
            parseMethod(e2, s2, r2, i2, a, n) {
              let o = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : false, c = this.startNode();
              return c.kind = e2.kind, c = super.parseMethod(c, s2, r2, i2, a, n, o), c.type = "FunctionExpression", delete c.kind, e2.value = c, n === "ClassPrivateMethod" && (e2.computed = false), n = "MethodDefinition", this.finishNode(e2, n);
            }
            parseClassProperty() {
              let e2 = super.parseClassProperty(...arguments);
              return this.getPluginOption("estree", "classFeatures") && (e2.type = "PropertyDefinition"), e2;
            }
            parseClassPrivateProperty() {
              let e2 = super.parseClassPrivateProperty(...arguments);
              return this.getPluginOption("estree", "classFeatures") && (e2.type = "PropertyDefinition", e2.computed = false), e2;
            }
            parseObjectMethod(e2, s2, r2, i2, a) {
              let n = super.parseObjectMethod(e2, s2, r2, i2, a);
              return n && (n.type = "Property", n.kind === "method" && (n.kind = "init"), n.shorthand = false), n;
            }
            parseObjectProperty(e2, s2, r2, i2, a) {
              let n = super.parseObjectProperty(e2, s2, r2, i2, a);
              return n && (n.kind = "init", n.type = "Property"), n;
            }
            isValidLVal(e2) {
              for (var s2 = arguments.length, r2 = new Array(s2 > 1 ? s2 - 1 : 0), i2 = 1; i2 < s2; i2++)
                r2[i2 - 1] = arguments[i2];
              return e2 === "Property" ? "value" : super.isValidLVal(e2, ...r2);
            }
            isAssignable(e2, s2) {
              return e2 != null && this.isObjectProperty(e2) ? this.isAssignable(e2.value, s2) : super.isAssignable(e2, s2);
            }
            toAssignable(e2) {
              let s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              if (e2 != null && this.isObjectProperty(e2)) {
                let { key: r2, value: i2 } = e2;
                this.isPrivateName(r2) && this.classScope.usePrivateName(this.getPrivateNameSV(r2), r2.loc.start), this.toAssignable(i2, s2);
              } else
                super.toAssignable(e2, s2);
            }
            toAssignableObjectExpressionProp(e2) {
              e2.kind === "get" || e2.kind === "set" ? this.raise(u.PatternHasAccessor, { at: e2.key }) : e2.method ? this.raise(u.PatternHasMethod, { at: e2.key }) : super.toAssignableObjectExpressionProp(...arguments);
            }
            finishCallExpression(e2, s2) {
              if (super.finishCallExpression(e2, s2), e2.callee.type === "Import") {
                if (e2.type = "ImportExpression", e2.source = e2.arguments[0], this.hasPlugin("importAssertions")) {
                  var r2;
                  e2.attributes = (r2 = e2.arguments[1]) != null ? r2 : null;
                }
                delete e2.arguments, delete e2.callee;
              }
              return e2;
            }
            toReferencedArguments(e2) {
              e2.type !== "ImportExpression" && super.toReferencedArguments(e2);
            }
            parseExport(e2) {
              switch (super.parseExport(e2), e2.type) {
                case "ExportAllDeclaration":
                  e2.exported = null;
                  break;
                case "ExportNamedDeclaration":
                  e2.specifiers.length === 1 && e2.specifiers[0].type === "ExportNamespaceSpecifier" && (e2.type = "ExportAllDeclaration", e2.exported = e2.specifiers[0].exported, delete e2.specifiers);
                  break;
              }
              return e2;
            }
            parseSubscript(e2, s2, r2, i2, a) {
              let n = super.parseSubscript(e2, s2, r2, i2, a);
              if (a.optionalChainMember) {
                if ((n.type === "OptionalMemberExpression" || n.type === "OptionalCallExpression") && (n.type = n.type.substring(8)), a.stop) {
                  let o = this.startNodeAtNode(n);
                  return o.expression = n, this.finishNode(o, "ChainExpression");
                }
              } else
                (n.type === "MemberExpression" || n.type === "CallExpression") && (n.optional = false);
              return n;
            }
            hasPropertyAsPrivateName(e2) {
              return e2.type === "ChainExpression" && (e2 = e2.expression), super.hasPropertyAsPrivateName(e2);
            }
            isOptionalChain(e2) {
              return e2.type === "ChainExpression";
            }
            isObjectProperty(e2) {
              return e2.type === "Property" && e2.kind === "init" && !e2.method;
            }
            isObjectMethod(e2) {
              return e2.method || e2.kind === "get" || e2.kind === "set";
            }
            finishNodeAt(e2, s2, r2) {
              return J(super.finishNodeAt(e2, s2, r2));
            }
            resetEndLocation(e2) {
              let s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.lastTokEndLoc;
              super.resetEndLocation(e2, s2), J(e2);
            }
          }, $ = class {
            constructor(t2, e2) {
              this.token = void 0, this.preserveSpace = void 0, this.token = t2, this.preserveSpace = !!e2;
            }
          }, z = { brace: new $("{"), j_oTag: new $("<tag"), j_cTag: new $("</tag"), j_expr: new $("<tag>...</tag>", true) };
          z.template = new $("`", true);
          var O = true, C = true, Ve = true, Z2 = true, he = true, Co = true, or = class {
            constructor(t2) {
              let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              this.label = void 0, this.keyword = void 0, this.beforeExpr = void 0, this.startsExpr = void 0, this.rightAssociative = void 0, this.isLoop = void 0, this.isAssign = void 0, this.prefix = void 0, this.postfix = void 0, this.binop = void 0, this.label = t2, this.keyword = e2.keyword, this.beforeExpr = !!e2.beforeExpr, this.startsExpr = !!e2.startsExpr, this.rightAssociative = !!e2.rightAssociative, this.isLoop = !!e2.isLoop, this.isAssign = !!e2.isAssign, this.prefix = !!e2.prefix, this.postfix = !!e2.postfix, this.binop = e2.binop != null ? e2.binop : null, this.updateContext = null;
            }
          }, qt = /* @__PURE__ */ new Map();
          function q(t2) {
            let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            e2.keyword = t2;
            let s2 = w(t2, e2);
            return qt.set(t2, s2), s2;
          }
          function te(t2, e2) {
            return w(t2, { beforeExpr: O, binop: e2 });
          }
          var He = -1, ce = [], Ut = [], it = [], _t = [], zt = [], Kt = [];
          function w(t2) {
            let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            var s2, r2, i2, a;
            return ++He, Ut.push(t2), it.push((s2 = e2.binop) != null ? s2 : -1), _t.push((r2 = e2.beforeExpr) != null ? r2 : false), zt.push((i2 = e2.startsExpr) != null ? i2 : false), Kt.push((a = e2.prefix) != null ? a : false), ce.push(new or(t2, e2)), He;
          }
          function U(t2) {
            let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            var s2, r2, i2, a;
            return ++He, qt.set(t2, He), Ut.push(t2), it.push((s2 = e2.binop) != null ? s2 : -1), _t.push((r2 = e2.beforeExpr) != null ? r2 : false), zt.push((i2 = e2.startsExpr) != null ? i2 : false), Kt.push((a = e2.prefix) != null ? a : false), ce.push(new or("name", e2)), He;
          }
          var bo = { bracketL: w("[", { beforeExpr: O, startsExpr: C }), bracketHashL: w("#[", { beforeExpr: O, startsExpr: C }), bracketBarL: w("[|", { beforeExpr: O, startsExpr: C }), bracketR: w("]"), bracketBarR: w("|]"), braceL: w("{", { beforeExpr: O, startsExpr: C }), braceBarL: w("{|", { beforeExpr: O, startsExpr: C }), braceHashL: w("#{", { beforeExpr: O, startsExpr: C }), braceR: w("}"), braceBarR: w("|}"), parenL: w("(", { beforeExpr: O, startsExpr: C }), parenR: w(")"), comma: w(",", { beforeExpr: O }), semi: w(";", { beforeExpr: O }), colon: w(":", { beforeExpr: O }), doubleColon: w("::", { beforeExpr: O }), dot: w("."), question: w("?", { beforeExpr: O }), questionDot: w("?."), arrow: w("=>", { beforeExpr: O }), template: w("template"), ellipsis: w("...", { beforeExpr: O }), backQuote: w("`", { startsExpr: C }), dollarBraceL: w("${", { beforeExpr: O, startsExpr: C }), templateTail: w("...`", { startsExpr: C }), templateNonTail: w("...${", { beforeExpr: O, startsExpr: C }), at: w("@"), hash: w("#", { startsExpr: C }), interpreterDirective: w("#!..."), eq: w("=", { beforeExpr: O, isAssign: Z2 }), assign: w("_=", { beforeExpr: O, isAssign: Z2 }), slashAssign: w("_=", { beforeExpr: O, isAssign: Z2 }), xorAssign: w("_=", { beforeExpr: O, isAssign: Z2 }), moduloAssign: w("_=", { beforeExpr: O, isAssign: Z2 }), incDec: w("++/--", { prefix: he, postfix: Co, startsExpr: C }), bang: w("!", { beforeExpr: O, prefix: he, startsExpr: C }), tilde: w("~", { beforeExpr: O, prefix: he, startsExpr: C }), doubleCaret: w("^^", { startsExpr: C }), doubleAt: w("@@", { startsExpr: C }), pipeline: te("|>", 0), nullishCoalescing: te("??", 1), logicalOR: te("||", 1), logicalAND: te("&&", 2), bitwiseOR: te("|", 3), bitwiseXOR: te("^", 4), bitwiseAND: te("&", 5), equality: te("==/!=/===/!==", 6), lt: te("</>/<=/>=", 7), gt: te("</>/<=/>=", 7), relational: te("</>/<=/>=", 7), bitShift: te("<</>>/>>>", 8), bitShiftL: te("<</>>/>>>", 8), bitShiftR: te("<</>>/>>>", 8), plusMin: w("+/-", { beforeExpr: O, binop: 9, prefix: he, startsExpr: C }), modulo: w("%", { binop: 10, startsExpr: C }), star: w("*", { binop: 10 }), slash: te("/", 10), exponent: w("**", { beforeExpr: O, binop: 11, rightAssociative: true }), _in: q("in", { beforeExpr: O, binop: 7 }), _instanceof: q("instanceof", { beforeExpr: O, binop: 7 }), _break: q("break"), _case: q("case", { beforeExpr: O }), _catch: q("catch"), _continue: q("continue"), _debugger: q("debugger"), _default: q("default", { beforeExpr: O }), _else: q("else", { beforeExpr: O }), _finally: q("finally"), _function: q("function", { startsExpr: C }), _if: q("if"), _return: q("return", { beforeExpr: O }), _switch: q("switch"), _throw: q("throw", { beforeExpr: O, prefix: he, startsExpr: C }), _try: q("try"), _var: q("var"), _const: q("const"), _with: q("with"), _new: q("new", { beforeExpr: O, startsExpr: C }), _this: q("this", { startsExpr: C }), _super: q("super", { startsExpr: C }), _class: q("class", { startsExpr: C }), _extends: q("extends", { beforeExpr: O }), _export: q("export"), _import: q("import", { startsExpr: C }), _null: q("null", { startsExpr: C }), _true: q("true", { startsExpr: C }), _false: q("false", { startsExpr: C }), _typeof: q("typeof", { beforeExpr: O, prefix: he, startsExpr: C }), _void: q("void", { beforeExpr: O, prefix: he, startsExpr: C }), _delete: q("delete", { beforeExpr: O, prefix: he, startsExpr: C }), _do: q("do", { isLoop: Ve, beforeExpr: O }), _for: q("for", { isLoop: Ve }), _while: q("while", { isLoop: Ve }), _as: U("as", { startsExpr: C }), _assert: U("assert", { startsExpr: C }), _async: U("async", { startsExpr: C }), _await: U("await", { startsExpr: C }), _from: U("from", { startsExpr: C }), _get: U("get", { startsExpr: C }), _let: U("let", { startsExpr: C }), _meta: U("meta", { startsExpr: C }), _of: U("of", { startsExpr: C }), _sent: U("sent", { startsExpr: C }), _set: U("set", { startsExpr: C }), _static: U("static", { startsExpr: C }), _yield: U("yield", { startsExpr: C }), _asserts: U("asserts", { startsExpr: C }), _checks: U("checks", { startsExpr: C }), _exports: U("exports", { startsExpr: C }), _global: U("global", { startsExpr: C }), _implements: U("implements", { startsExpr: C }), _intrinsic: U("intrinsic", { startsExpr: C }), _infer: U("infer", { startsExpr: C }), _is: U("is", { startsExpr: C }), _mixins: U("mixins", { startsExpr: C }), _proto: U("proto", { startsExpr: C }), _require: U("require", { startsExpr: C }), _keyof: U("keyof", { startsExpr: C }), _readonly: U("readonly", { startsExpr: C }), _unique: U("unique", { startsExpr: C }), _abstract: U("abstract", { startsExpr: C }), _declare: U("declare", { startsExpr: C }), _enum: U("enum", { startsExpr: C }), _module: U("module", { startsExpr: C }), _namespace: U("namespace", { startsExpr: C }), _interface: U("interface", { startsExpr: C }), _type: U("type", { startsExpr: C }), _opaque: U("opaque", { startsExpr: C }), name: w("name", { startsExpr: C }), string: w("string", { startsExpr: C }), num: w("num", { startsExpr: C }), bigint: w("bigint", { startsExpr: C }), decimal: w("decimal", { startsExpr: C }), regexp: w("regexp", { startsExpr: C }), privateName: w("#name", { startsExpr: C }), eof: w("eof"), jsxName: w("jsxName"), jsxText: w("jsxText", { beforeExpr: true }), jsxTagStart: w("jsxTagStart", { startsExpr: true }), jsxTagEnd: w("jsxTagEnd"), placeholder: w("%%", { startsExpr: true }) };
          function K(t2) {
            return t2 >= 93 && t2 <= 128;
          }
          function vo(t2) {
            return t2 <= 92;
          }
          function pe(t2) {
            return t2 >= 58 && t2 <= 128;
          }
          function hr(t2) {
            return t2 >= 58 && t2 <= 132;
          }
          function So(t2) {
            return _t[t2];
          }
          function Vt(t2) {
            return zt[t2];
          }
          function wo(t2) {
            return t2 >= 29 && t2 <= 33;
          }
          function lr(t2) {
            return t2 >= 125 && t2 <= 127;
          }
          function No(t2) {
            return t2 >= 90 && t2 <= 92;
          }
          function Ht(t2) {
            return t2 >= 58 && t2 <= 92;
          }
          function Io(t2) {
            return t2 >= 39 && t2 <= 59;
          }
          function ko(t2) {
            return t2 === 34;
          }
          function Do(t2) {
            return Kt[t2];
          }
          function Fo(t2) {
            return t2 >= 117 && t2 <= 119;
          }
          function Lo(t2) {
            return t2 >= 120 && t2 <= 126;
          }
          function Pe(t2) {
            return Ut[t2];
          }
          function at(t2) {
            return it[t2];
          }
          function Oo(t2) {
            return it[t2] !== -1;
          }
          function Bo(t2) {
            return t2 === 57;
          }
          function nt(t2) {
            return t2 >= 24 && t2 <= 25;
          }
          function fe(t2) {
            return ce[t2];
          }
          ce[8].updateContext = (t2) => {
            t2.pop();
          }, ce[5].updateContext = ce[7].updateContext = ce[23].updateContext = (t2) => {
            t2.push(z.brace);
          }, ce[22].updateContext = (t2) => {
            t2[t2.length - 1] === z.template ? t2.pop() : t2.push(z.template);
          }, ce[138].updateContext = (t2) => {
            t2.push(z.j_expr, z.j_oTag);
          };
          var Wt = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC", ur = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F", Mo = new RegExp("[" + Wt + "]"), Ro = new RegExp("[" + Wt + ur + "]");
          Wt = ur = null;
          var cr = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938], jo = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
          function Gt(t2, e2) {
            let s2 = 65536;
            for (let r2 = 0, i2 = e2.length; r2 < i2; r2 += 2) {
              if (s2 += e2[r2], s2 > t2)
                return false;
              if (s2 += e2[r2 + 1], s2 >= t2)
                return true;
            }
            return false;
          }
          function de(t2) {
            return t2 < 65 ? t2 === 36 : t2 <= 90 ? true : t2 < 97 ? t2 === 95 : t2 <= 122 ? true : t2 <= 65535 ? t2 >= 170 && Mo.test(String.fromCharCode(t2)) : Gt(t2, cr);
          }
          function Be(t2) {
            return t2 < 48 ? t2 === 36 : t2 < 58 ? true : t2 < 65 ? false : t2 <= 90 ? true : t2 < 97 ? t2 === 95 : t2 <= 122 ? true : t2 <= 65535 ? t2 >= 170 && Ro.test(String.fromCharCode(t2)) : Gt(t2, cr) || Gt(t2, jo);
          }
          var Xt = { keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"], strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"], strictBind: ["eval", "arguments"] }, qo = new Set(Xt.keyword), Uo = new Set(Xt.strict), _o = new Set(Xt.strictBind);
          function pr(t2, e2) {
            return e2 && t2 === "await" || t2 === "enum";
          }
          function fr(t2, e2) {
            return pr(t2, e2) || Uo.has(t2);
          }
          function dr(t2) {
            return _o.has(t2);
          }
          function mr(t2, e2) {
            return fr(t2, e2) || dr(t2);
          }
          function zo(t2) {
            return qo.has(t2);
          }
          function Ko(t2, e2, s2) {
            return t2 === 64 && e2 === 64 && de(s2);
          }
          var Vo = /* @__PURE__ */ new Set(["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete", "implements", "interface", "let", "package", "private", "protected", "public", "static", "yield", "eval", "arguments", "enum", "await"]);
          function Ho(t2) {
            return Vo.has(t2);
          }
          var Me = 0, We = 1, me = 2, Jt = 4, yr = 8, ot = 16, xr = 32, Se = 64, Yt = 128, ht = 256, lt = We | me | ht, ye = 1, Re = 2, gr = 4, Te = 8, ut = 16, Ar = 64, ct = 128, $t = 256, Qt = 512, Zt = 1024, es = 2048, Pr = ye | Re | Te | ct, xe = ye | 0 | Te | 0, pt = ye | 0 | gr | 0, Tr = ye | 0 | ut | 0, Wo = 0 | Re | 0 | ct, Go = 0 | Re | 0 | 0, Er = ye | Re | Te | $t, Cr = 0 | Zt, we = 0 | Ar, Xo = ye | 0 | 0 | Ar, Jo = Er | Qt, Yo = 0 | Zt, $o = es, ft = 4, ts = 2, ss = 1, rs = ts | ss, Qo = ts | ft, Zo = ss | ft, eh = ts, th = ss, is = 0, sh = class {
            constructor() {
              this.sawUnambiguousESM = false, this.ambiguousScriptDifferentAst = false;
            }
            hasPlugin(t2) {
              if (typeof t2 == "string")
                return this.plugins.has(t2);
              {
                let [e2, s2] = t2;
                if (!this.hasPlugin(e2))
                  return false;
                let r2 = this.plugins.get(e2);
                for (let i2 of Object.keys(s2))
                  if ((r2 == null ? void 0 : r2[i2]) !== s2[i2])
                    return false;
                return true;
              }
            }
            getPluginOption(t2, e2) {
              var s2;
              return (s2 = this.plugins.get(t2)) == null ? void 0 : s2[e2];
            }
          };
          function br(t2, e2) {
            t2.trailingComments === void 0 ? t2.trailingComments = e2 : t2.trailingComments.unshift(...e2);
          }
          function rh(t2, e2) {
            t2.leadingComments === void 0 ? t2.leadingComments = e2 : t2.leadingComments.unshift(...e2);
          }
          function Ge(t2, e2) {
            t2.innerComments === void 0 ? t2.innerComments = e2 : t2.innerComments.unshift(...e2);
          }
          function Xe(t2, e2, s2) {
            let r2 = null, i2 = e2.length;
            for (; r2 === null && i2 > 0; )
              r2 = e2[--i2];
            r2 === null || r2.start > s2.start ? Ge(t2, s2.comments) : br(r2, s2.comments);
          }
          var ih = class extends sh {
            addComment(t2) {
              this.filename && (t2.loc.filename = this.filename), this.state.comments.push(t2);
            }
            processComment(t2) {
              let { commentStack: e2 } = this.state, s2 = e2.length;
              if (s2 === 0)
                return;
              let r2 = s2 - 1, i2 = e2[r2];
              i2.start === t2.end && (i2.leadingNode = t2, r2--);
              let { start: a } = t2;
              for (; r2 >= 0; r2--) {
                let n = e2[r2], o = n.end;
                if (o > a)
                  n.containingNode = t2, this.finalizeComment(n), e2.splice(r2, 1);
                else {
                  o === a && (n.trailingNode = t2);
                  break;
                }
              }
            }
            finalizeComment(t2) {
              let { comments: e2 } = t2;
              if (t2.leadingNode !== null || t2.trailingNode !== null)
                t2.leadingNode !== null && br(t2.leadingNode, e2), t2.trailingNode !== null && rh(t2.trailingNode, e2);
              else {
                let { containingNode: s2, start: r2 } = t2;
                if (this.input.charCodeAt(r2 - 1) === 44)
                  switch (s2.type) {
                    case "ObjectExpression":
                    case "ObjectPattern":
                    case "RecordExpression":
                      Xe(s2, s2.properties, t2);
                      break;
                    case "CallExpression":
                    case "OptionalCallExpression":
                      Xe(s2, s2.arguments, t2);
                      break;
                    case "FunctionDeclaration":
                    case "FunctionExpression":
                    case "ArrowFunctionExpression":
                    case "ObjectMethod":
                    case "ClassMethod":
                    case "ClassPrivateMethod":
                      Xe(s2, s2.params, t2);
                      break;
                    case "ArrayExpression":
                    case "ArrayPattern":
                    case "TupleExpression":
                      Xe(s2, s2.elements, t2);
                      break;
                    case "ExportNamedDeclaration":
                    case "ImportDeclaration":
                      Xe(s2, s2.specifiers, t2);
                      break;
                    default:
                      Ge(s2, e2);
                  }
                else
                  Ge(s2, e2);
              }
            }
            finalizeRemainingComments() {
              let { commentStack: t2 } = this.state;
              for (let e2 = t2.length - 1; e2 >= 0; e2--)
                this.finalizeComment(t2[e2]);
              this.state.commentStack = [];
            }
            resetPreviousNodeTrailingComments(t2) {
              let { commentStack: e2 } = this.state, { length: s2 } = e2;
              if (s2 === 0)
                return;
              let r2 = e2[s2 - 1];
              r2.leadingNode === t2 && (r2.leadingNode = null);
            }
            takeSurroundingComments(t2, e2, s2) {
              let { commentStack: r2 } = this.state, i2 = r2.length;
              if (i2 === 0)
                return;
              let a = i2 - 1;
              for (; a >= 0; a--) {
                let n = r2[a], o = n.end;
                if (n.start === s2)
                  n.leadingNode = t2;
                else if (o === e2)
                  n.trailingNode = t2;
                else if (o < e2)
                  break;
              }
            }
          }, as = /\r\n?|[\n\u2028\u2029]/, dt = new RegExp(as.source, "g");
          function Ne(t2) {
            switch (t2) {
              case 10:
              case 13:
              case 8232:
              case 8233:
                return true;
              default:
                return false;
            }
          }
          var ns = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g, ah = /(?:[^\S\n\r\u2028\u2029]|\/\/.*|\/\*.*?\*\/)*/y, vr = new RegExp("(?=(" + ah.source + "))\\1" + /(?=[\n\r\u2028\u2029]|\/\*(?!.*?\*\/)|$)/.source, "y");
          function nh(t2) {
            switch (t2) {
              case 9:
              case 11:
              case 12:
              case 32:
              case 160:
              case 5760:
              case 8192:
              case 8193:
              case 8194:
              case 8195:
              case 8196:
              case 8197:
              case 8198:
              case 8199:
              case 8200:
              case 8201:
              case 8202:
              case 8239:
              case 8287:
              case 12288:
              case 65279:
                return true;
              default:
                return false;
            }
          }
          var Sr = class {
            constructor() {
              this.strict = void 0, this.curLine = void 0, this.lineStart = void 0, this.startLoc = void 0, this.endLoc = void 0, this.errors = [], this.potentialArrowAt = -1, this.noArrowAt = [], this.noArrowParamsConversionAt = [], this.maybeInArrowParameters = false, this.inType = false, this.noAnonFunctionType = false, this.hasFlowComment = false, this.isAmbientContext = false, this.inAbstractClass = false, this.inDisallowConditionalTypesContext = false, this.topicContext = { maxNumOfResolvableTopics: 0, maxTopicIndex: null }, this.soloAwait = false, this.inFSharpPipelineDirectBody = false, this.labels = [], this.decoratorStack = [[]], this.comments = [], this.commentStack = [], this.pos = 0, this.type = 135, this.value = null, this.start = 0, this.end = 0, this.lastTokEndLoc = null, this.lastTokStartLoc = null, this.lastTokStart = 0, this.context = [z.brace], this.canStartJSXElement = true, this.containsEsc = false, this.strictErrors = /* @__PURE__ */ new Map(), this.tokensLength = 0;
            }
            init(t2) {
              let { strictMode: e2, sourceType: s2, startLine: r2, startColumn: i2 } = t2;
              this.strict = e2 === false ? false : e2 === true ? true : s2 === "module", this.curLine = r2, this.lineStart = -i2, this.startLoc = this.endLoc = new p(r2, i2, 0);
            }
            curPosition() {
              return new p(this.curLine, this.pos - this.lineStart, this.pos);
            }
            clone(t2) {
              let e2 = new Sr(), s2 = Object.keys(this);
              for (let r2 = 0, i2 = s2.length; r2 < i2; r2++) {
                let a = s2[r2], n = this[a];
                !t2 && Array.isArray(n) && (n = n.slice()), e2[a] = n;
              }
              return e2;
            }
          }, oh = ["at"], hh = ["at"], lh = function(e2) {
            return e2 >= 48 && e2 <= 57;
          }, uh = /* @__PURE__ */ new Set([103, 109, 115, 105, 121, 117, 100, 118]), wr = { decBinOct: /* @__PURE__ */ new Set([46, 66, 69, 79, 95, 98, 101, 111]), hex: /* @__PURE__ */ new Set([46, 88, 95, 120]) }, mt = { bin: (t2) => t2 === 48 || t2 === 49, oct: (t2) => t2 >= 48 && t2 <= 55, dec: (t2) => t2 >= 48 && t2 <= 57, hex: (t2) => t2 >= 48 && t2 <= 57 || t2 >= 65 && t2 <= 70 || t2 >= 97 && t2 <= 102 }, Ee = class {
            constructor(t2) {
              this.type = t2.type, this.value = t2.value, this.start = t2.start, this.end = t2.end, this.loc = new d(t2.startLoc, t2.endLoc);
            }
          }, ch = class extends ih {
            constructor(t2, e2) {
              super(), this.isLookahead = void 0, this.tokens = [], this.state = new Sr(), this.state.init(t2), this.input = e2, this.length = e2.length, this.isLookahead = false;
            }
            pushToken(t2) {
              this.tokens.length = this.state.tokensLength, this.tokens.push(t2), ++this.state.tokensLength;
            }
            next() {
              this.checkKeywordEscapes(), this.options.tokens && this.pushToken(new Ee(this.state)), this.state.lastTokStart = this.state.start, this.state.lastTokEndLoc = this.state.endLoc, this.state.lastTokStartLoc = this.state.startLoc, this.nextToken();
            }
            eat(t2) {
              return this.match(t2) ? (this.next(), true) : false;
            }
            match(t2) {
              return this.state.type === t2;
            }
            createLookaheadState(t2) {
              return { pos: t2.pos, value: null, type: t2.type, start: t2.start, end: t2.end, context: [this.curContext()], inType: t2.inType, startLoc: t2.startLoc, lastTokEndLoc: t2.lastTokEndLoc, curLine: t2.curLine, lineStart: t2.lineStart, curPosition: t2.curPosition };
            }
            lookahead() {
              let t2 = this.state;
              this.state = this.createLookaheadState(t2), this.isLookahead = true, this.nextToken(), this.isLookahead = false;
              let e2 = this.state;
              return this.state = t2, e2;
            }
            nextTokenStart() {
              return this.nextTokenStartSince(this.state.pos);
            }
            nextTokenStartSince(t2) {
              return ns.lastIndex = t2, ns.test(this.input) ? ns.lastIndex : t2;
            }
            lookaheadCharCode() {
              return this.input.charCodeAt(this.nextTokenStart());
            }
            codePointAtPos(t2) {
              let e2 = this.input.charCodeAt(t2);
              if ((e2 & 64512) === 55296 && ++t2 < this.input.length) {
                let s2 = this.input.charCodeAt(t2);
                (s2 & 64512) === 56320 && (e2 = 65536 + ((e2 & 1023) << 10) + (s2 & 1023));
              }
              return e2;
            }
            setStrict(t2) {
              this.state.strict = t2, t2 && (this.state.strictErrors.forEach((e2) => {
                let [s2, r2] = e2;
                return this.raise(s2, { at: r2 });
              }), this.state.strictErrors.clear());
            }
            curContext() {
              return this.state.context[this.state.context.length - 1];
            }
            nextToken() {
              if (this.skipSpace(), this.state.start = this.state.pos, this.isLookahead || (this.state.startLoc = this.state.curPosition()), this.state.pos >= this.length) {
                this.finishToken(135);
                return;
              }
              this.getTokenFromCode(this.codePointAtPos(this.state.pos));
            }
            skipBlockComment() {
              let t2;
              this.isLookahead || (t2 = this.state.curPosition());
              let e2 = this.state.pos, s2 = this.input.indexOf("*/", e2 + 2);
              if (s2 === -1)
                throw this.raise(u.UnterminatedComment, { at: this.state.curPosition() });
              for (this.state.pos = s2 + 2, dt.lastIndex = e2 + 2; dt.test(this.input) && dt.lastIndex <= s2; )
                ++this.state.curLine, this.state.lineStart = dt.lastIndex;
              if (this.isLookahead)
                return;
              let r2 = { type: "CommentBlock", value: this.input.slice(e2 + 2, s2), start: e2, end: s2 + 2, loc: new d(t2, this.state.curPosition()) };
              return this.options.tokens && this.pushToken(r2), r2;
            }
            skipLineComment(t2) {
              let e2 = this.state.pos, s2;
              this.isLookahead || (s2 = this.state.curPosition());
              let r2 = this.input.charCodeAt(this.state.pos += t2);
              if (this.state.pos < this.length)
                for (; !Ne(r2) && ++this.state.pos < this.length; )
                  r2 = this.input.charCodeAt(this.state.pos);
              if (this.isLookahead)
                return;
              let i2 = this.state.pos, a = this.input.slice(e2 + t2, i2), n = { type: "CommentLine", value: a, start: e2, end: i2, loc: new d(s2, this.state.curPosition()) };
              return this.options.tokens && this.pushToken(n), n;
            }
            skipSpace() {
              let t2 = this.state.pos, e2 = [];
              e:
                for (; this.state.pos < this.length; ) {
                  let s2 = this.input.charCodeAt(this.state.pos);
                  switch (s2) {
                    case 32:
                    case 160:
                    case 9:
                      ++this.state.pos;
                      break;
                    case 13:
                      this.input.charCodeAt(this.state.pos + 1) === 10 && ++this.state.pos;
                    case 10:
                    case 8232:
                    case 8233:
                      ++this.state.pos, ++this.state.curLine, this.state.lineStart = this.state.pos;
                      break;
                    case 47:
                      switch (this.input.charCodeAt(this.state.pos + 1)) {
                        case 42: {
                          let r2 = this.skipBlockComment();
                          r2 !== void 0 && (this.addComment(r2), this.options.attachComment && e2.push(r2));
                          break;
                        }
                        case 47: {
                          let r2 = this.skipLineComment(2);
                          r2 !== void 0 && (this.addComment(r2), this.options.attachComment && e2.push(r2));
                          break;
                        }
                        default:
                          break e;
                      }
                      break;
                    default:
                      if (nh(s2))
                        ++this.state.pos;
                      else if (s2 === 45 && !this.inModule) {
                        let r2 = this.state.pos;
                        if (this.input.charCodeAt(r2 + 1) === 45 && this.input.charCodeAt(r2 + 2) === 62 && (t2 === 0 || this.state.lineStart > t2)) {
                          let i2 = this.skipLineComment(3);
                          i2 !== void 0 && (this.addComment(i2), this.options.attachComment && e2.push(i2));
                        } else
                          break e;
                      } else if (s2 === 60 && !this.inModule) {
                        let r2 = this.state.pos;
                        if (this.input.charCodeAt(r2 + 1) === 33 && this.input.charCodeAt(r2 + 2) === 45 && this.input.charCodeAt(r2 + 3) === 45) {
                          let i2 = this.skipLineComment(4);
                          i2 !== void 0 && (this.addComment(i2), this.options.attachComment && e2.push(i2));
                        } else
                          break e;
                      } else
                        break e;
                  }
                }
              if (e2.length > 0) {
                let s2 = this.state.pos, r2 = { start: t2, end: s2, comments: e2, leadingNode: null, trailingNode: null, containingNode: null };
                this.state.commentStack.push(r2);
              }
            }
            finishToken(t2, e2) {
              this.state.end = this.state.pos, this.state.endLoc = this.state.curPosition();
              let s2 = this.state.type;
              this.state.type = t2, this.state.value = e2, this.isLookahead || this.updateContext(s2);
            }
            replaceToken(t2) {
              this.state.type = t2, this.updateContext();
            }
            readToken_numberSign() {
              if (this.state.pos === 0 && this.readToken_interpreter())
                return;
              let t2 = this.state.pos + 1, e2 = this.codePointAtPos(t2);
              if (e2 >= 48 && e2 <= 57)
                throw this.raise(u.UnexpectedDigitAfterHash, { at: this.state.curPosition() });
              if (e2 === 123 || e2 === 91 && this.hasPlugin("recordAndTuple")) {
                if (this.expectPlugin("recordAndTuple"), this.getPluginOption("recordAndTuple", "syntaxType") !== "hash")
                  throw this.raise(e2 === 123 ? u.RecordExpressionHashIncorrectStartSyntaxType : u.TupleExpressionHashIncorrectStartSyntaxType, { at: this.state.curPosition() });
                this.state.pos += 2, e2 === 123 ? this.finishToken(7) : this.finishToken(1);
              } else
                de(e2) ? (++this.state.pos, this.finishToken(134, this.readWord1(e2))) : e2 === 92 ? (++this.state.pos, this.finishToken(134, this.readWord1())) : this.finishOp(27, 1);
            }
            readToken_dot() {
              let t2 = this.input.charCodeAt(this.state.pos + 1);
              if (t2 >= 48 && t2 <= 57) {
                this.readNumber(true);
                return;
              }
              t2 === 46 && this.input.charCodeAt(this.state.pos + 2) === 46 ? (this.state.pos += 3, this.finishToken(21)) : (++this.state.pos, this.finishToken(16));
            }
            readToken_slash() {
              this.input.charCodeAt(this.state.pos + 1) === 61 ? this.finishOp(31, 2) : this.finishOp(56, 1);
            }
            readToken_interpreter() {
              if (this.state.pos !== 0 || this.length < 2)
                return false;
              let t2 = this.input.charCodeAt(this.state.pos + 1);
              if (t2 !== 33)
                return false;
              let e2 = this.state.pos;
              for (this.state.pos += 1; !Ne(t2) && ++this.state.pos < this.length; )
                t2 = this.input.charCodeAt(this.state.pos);
              let s2 = this.input.slice(e2 + 2, this.state.pos);
              return this.finishToken(28, s2), true;
            }
            readToken_mult_modulo(t2) {
              let e2 = t2 === 42 ? 55 : 54, s2 = 1, r2 = this.input.charCodeAt(this.state.pos + 1);
              t2 === 42 && r2 === 42 && (s2++, r2 = this.input.charCodeAt(this.state.pos + 2), e2 = 57), r2 === 61 && !this.state.inType && (s2++, e2 = t2 === 37 ? 33 : 30), this.finishOp(e2, s2);
            }
            readToken_pipe_amp(t2) {
              let e2 = this.input.charCodeAt(this.state.pos + 1);
              if (e2 === t2) {
                this.input.charCodeAt(this.state.pos + 2) === 61 ? this.finishOp(30, 3) : this.finishOp(t2 === 124 ? 41 : 42, 2);
                return;
              }
              if (t2 === 124) {
                if (e2 === 62) {
                  this.finishOp(39, 2);
                  return;
                }
                if (this.hasPlugin("recordAndTuple") && e2 === 125) {
                  if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar")
                    throw this.raise(u.RecordExpressionBarIncorrectEndSyntaxType, { at: this.state.curPosition() });
                  this.state.pos += 2, this.finishToken(9);
                  return;
                }
                if (this.hasPlugin("recordAndTuple") && e2 === 93) {
                  if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar")
                    throw this.raise(u.TupleExpressionBarIncorrectEndSyntaxType, { at: this.state.curPosition() });
                  this.state.pos += 2, this.finishToken(4);
                  return;
                }
              }
              if (e2 === 61) {
                this.finishOp(30, 2);
                return;
              }
              this.finishOp(t2 === 124 ? 43 : 45, 1);
            }
            readToken_caret() {
              let t2 = this.input.charCodeAt(this.state.pos + 1);
              if (t2 === 61 && !this.state.inType)
                this.finishOp(32, 2);
              else if (t2 === 94 && this.hasPlugin(["pipelineOperator", { proposal: "hack", topicToken: "^^" }])) {
                if (this.finishOp(37, 2), this.input.codePointAt(this.state.pos) === 94)
                  throw this.unexpected();
              } else
                this.finishOp(44, 1);
            }
            readToken_atSign() {
              this.input.charCodeAt(this.state.pos + 1) === 64 && this.hasPlugin(["pipelineOperator", { proposal: "hack", topicToken: "@@" }]) ? this.finishOp(38, 2) : this.finishOp(26, 1);
            }
            readToken_plus_min(t2) {
              let e2 = this.input.charCodeAt(this.state.pos + 1);
              if (e2 === t2) {
                this.finishOp(34, 2);
                return;
              }
              e2 === 61 ? this.finishOp(30, 2) : this.finishOp(53, 1);
            }
            readToken_lt() {
              let { pos: t2 } = this.state, e2 = this.input.charCodeAt(t2 + 1);
              if (e2 === 60) {
                if (this.input.charCodeAt(t2 + 2) === 61) {
                  this.finishOp(30, 3);
                  return;
                }
                this.finishOp(51, 2);
                return;
              }
              if (e2 === 61) {
                this.finishOp(49, 2);
                return;
              }
              this.finishOp(47, 1);
            }
            readToken_gt() {
              let { pos: t2 } = this.state, e2 = this.input.charCodeAt(t2 + 1);
              if (e2 === 62) {
                let s2 = this.input.charCodeAt(t2 + 2) === 62 ? 3 : 2;
                if (this.input.charCodeAt(t2 + s2) === 61) {
                  this.finishOp(30, s2 + 1);
                  return;
                }
                this.finishOp(52, s2);
                return;
              }
              if (e2 === 61) {
                this.finishOp(49, 2);
                return;
              }
              this.finishOp(48, 1);
            }
            readToken_eq_excl(t2) {
              let e2 = this.input.charCodeAt(this.state.pos + 1);
              if (e2 === 61) {
                this.finishOp(46, this.input.charCodeAt(this.state.pos + 2) === 61 ? 3 : 2);
                return;
              }
              if (t2 === 61 && e2 === 62) {
                this.state.pos += 2, this.finishToken(19);
                return;
              }
              this.finishOp(t2 === 61 ? 29 : 35, 1);
            }
            readToken_question() {
              let t2 = this.input.charCodeAt(this.state.pos + 1), e2 = this.input.charCodeAt(this.state.pos + 2);
              t2 === 63 ? e2 === 61 ? this.finishOp(30, 3) : this.finishOp(40, 2) : t2 === 46 && !(e2 >= 48 && e2 <= 57) ? (this.state.pos += 2, this.finishToken(18)) : (++this.state.pos, this.finishToken(17));
            }
            getTokenFromCode(t2) {
              switch (t2) {
                case 46:
                  this.readToken_dot();
                  return;
                case 40:
                  ++this.state.pos, this.finishToken(10);
                  return;
                case 41:
                  ++this.state.pos, this.finishToken(11);
                  return;
                case 59:
                  ++this.state.pos, this.finishToken(13);
                  return;
                case 44:
                  ++this.state.pos, this.finishToken(12);
                  return;
                case 91:
                  if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
                    if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar")
                      throw this.raise(u.TupleExpressionBarIncorrectStartSyntaxType, { at: this.state.curPosition() });
                    this.state.pos += 2, this.finishToken(2);
                  } else
                    ++this.state.pos, this.finishToken(0);
                  return;
                case 93:
                  ++this.state.pos, this.finishToken(3);
                  return;
                case 123:
                  if (this.hasPlugin("recordAndTuple") && this.input.charCodeAt(this.state.pos + 1) === 124) {
                    if (this.getPluginOption("recordAndTuple", "syntaxType") !== "bar")
                      throw this.raise(u.RecordExpressionBarIncorrectStartSyntaxType, { at: this.state.curPosition() });
                    this.state.pos += 2, this.finishToken(6);
                  } else
                    ++this.state.pos, this.finishToken(5);
                  return;
                case 125:
                  ++this.state.pos, this.finishToken(8);
                  return;
                case 58:
                  this.hasPlugin("functionBind") && this.input.charCodeAt(this.state.pos + 1) === 58 ? this.finishOp(15, 2) : (++this.state.pos, this.finishToken(14));
                  return;
                case 63:
                  this.readToken_question();
                  return;
                case 96:
                  this.readTemplateToken();
                  return;
                case 48: {
                  let e2 = this.input.charCodeAt(this.state.pos + 1);
                  if (e2 === 120 || e2 === 88) {
                    this.readRadixNumber(16);
                    return;
                  }
                  if (e2 === 111 || e2 === 79) {
                    this.readRadixNumber(8);
                    return;
                  }
                  if (e2 === 98 || e2 === 66) {
                    this.readRadixNumber(2);
                    return;
                  }
                }
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                  this.readNumber(false);
                  return;
                case 34:
                case 39:
                  this.readString(t2);
                  return;
                case 47:
                  this.readToken_slash();
                  return;
                case 37:
                case 42:
                  this.readToken_mult_modulo(t2);
                  return;
                case 124:
                case 38:
                  this.readToken_pipe_amp(t2);
                  return;
                case 94:
                  this.readToken_caret();
                  return;
                case 43:
                case 45:
                  this.readToken_plus_min(t2);
                  return;
                case 60:
                  this.readToken_lt();
                  return;
                case 62:
                  this.readToken_gt();
                  return;
                case 61:
                case 33:
                  this.readToken_eq_excl(t2);
                  return;
                case 126:
                  this.finishOp(36, 1);
                  return;
                case 64:
                  this.readToken_atSign();
                  return;
                case 35:
                  this.readToken_numberSign();
                  return;
                case 92:
                  this.readWord();
                  return;
                default:
                  if (de(t2)) {
                    this.readWord(t2);
                    return;
                  }
              }
              throw this.raise(u.InvalidOrUnexpectedToken, { at: this.state.curPosition(), unexpected: String.fromCodePoint(t2) });
            }
            finishOp(t2, e2) {
              let s2 = this.input.slice(this.state.pos, this.state.pos + e2);
              this.state.pos += e2, this.finishToken(t2, s2);
            }
            readRegexp() {
              let t2 = this.state.startLoc, e2 = this.state.start + 1, s2, r2, { pos: i2 } = this.state;
              for (; ; ++i2) {
                if (i2 >= this.length)
                  throw this.raise(u.UnterminatedRegExp, { at: m2(t2, 1) });
                let c = this.input.charCodeAt(i2);
                if (Ne(c))
                  throw this.raise(u.UnterminatedRegExp, { at: m2(t2, 1) });
                if (s2)
                  s2 = false;
                else {
                  if (c === 91)
                    r2 = true;
                  else if (c === 93 && r2)
                    r2 = false;
                  else if (c === 47 && !r2)
                    break;
                  s2 = c === 92;
                }
              }
              let a = this.input.slice(e2, i2);
              ++i2;
              let n = "", o = () => m2(t2, i2 + 2 - e2);
              for (; i2 < this.length; ) {
                let c = this.codePointAtPos(i2), f3 = String.fromCharCode(c);
                if (uh.has(c))
                  c === 118 ? (this.expectPlugin("regexpUnicodeSets", o()), n.includes("u") && this.raise(u.IncompatibleRegExpUVFlags, { at: o() })) : c === 117 && n.includes("v") && this.raise(u.IncompatibleRegExpUVFlags, { at: o() }), n.includes(f3) && this.raise(u.DuplicateRegExpFlags, { at: o() });
                else if (Be(c) || c === 92)
                  this.raise(u.MalformedRegExpFlags, { at: o() });
                else
                  break;
                ++i2, n += f3;
              }
              this.state.pos = i2, this.finishToken(133, { pattern: a, flags: n });
            }
            readInt(t2, e2, s2) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true, i2 = this.state.pos, a = t2 === 16 ? wr.hex : wr.decBinOct, n = t2 === 16 ? mt.hex : t2 === 10 ? mt.dec : t2 === 8 ? mt.oct : mt.bin, o = false, c = 0;
              for (let f3 = 0, y = e2 == null ? 1 / 0 : e2; f3 < y; ++f3) {
                let P = this.input.charCodeAt(this.state.pos), v;
                if (P === 95 && r2 !== "bail") {
                  let N = this.input.charCodeAt(this.state.pos - 1), B = this.input.charCodeAt(this.state.pos + 1);
                  r2 ? (Number.isNaN(B) || !n(B) || a.has(N) || a.has(B)) && this.raise(u.UnexpectedNumericSeparator, { at: this.state.curPosition() }) : this.raise(u.NumericSeparatorInEscapeSequence, { at: this.state.curPosition() }), ++this.state.pos;
                  continue;
                }
                if (P >= 97 ? v = P - 97 + 10 : P >= 65 ? v = P - 65 + 10 : lh(P) ? v = P - 48 : v = 1 / 0, v >= t2)
                  if (this.options.errorRecovery && v <= 9)
                    v = 0, this.raise(u.InvalidDigit, { at: this.state.curPosition(), radix: t2 });
                  else if (s2)
                    v = 0, o = true;
                  else
                    break;
                ++this.state.pos, c = c * t2 + v;
              }
              return this.state.pos === i2 || e2 != null && this.state.pos - i2 !== e2 || o ? null : c;
            }
            readRadixNumber(t2) {
              let e2 = this.state.curPosition(), s2 = false;
              this.state.pos += 2;
              let r2 = this.readInt(t2);
              r2 == null && this.raise(u.InvalidDigit, { at: m2(e2, 2), radix: t2 });
              let i2 = this.input.charCodeAt(this.state.pos);
              if (i2 === 110)
                ++this.state.pos, s2 = true;
              else if (i2 === 109)
                throw this.raise(u.InvalidDecimal, { at: e2 });
              if (de(this.codePointAtPos(this.state.pos)))
                throw this.raise(u.NumberIdentifier, { at: this.state.curPosition() });
              if (s2) {
                let a = this.input.slice(e2.index, this.state.pos).replace(/[_n]/g, "");
                this.finishToken(131, a);
                return;
              }
              this.finishToken(130, r2);
            }
            readNumber(t2) {
              let e2 = this.state.pos, s2 = this.state.curPosition(), r2 = false, i2 = false, a = false, n = false, o = false;
              !t2 && this.readInt(10) === null && this.raise(u.InvalidNumber, { at: this.state.curPosition() });
              let c = this.state.pos - e2 >= 2 && this.input.charCodeAt(e2) === 48;
              if (c) {
                let v = this.input.slice(e2, this.state.pos);
                if (this.recordStrictModeErrors(u.StrictOctalLiteral, { at: s2 }), !this.state.strict) {
                  let N = v.indexOf("_");
                  N > 0 && this.raise(u.ZeroDigitNumericSeparator, { at: m2(s2, N) });
                }
                o = c && !/[89]/.test(v);
              }
              let f3 = this.input.charCodeAt(this.state.pos);
              if (f3 === 46 && !o && (++this.state.pos, this.readInt(10), r2 = true, f3 = this.input.charCodeAt(this.state.pos)), (f3 === 69 || f3 === 101) && !o && (f3 = this.input.charCodeAt(++this.state.pos), (f3 === 43 || f3 === 45) && ++this.state.pos, this.readInt(10) === null && this.raise(u.InvalidOrMissingExponent, { at: s2 }), r2 = true, n = true, f3 = this.input.charCodeAt(this.state.pos)), f3 === 110 && ((r2 || c) && this.raise(u.InvalidBigIntLiteral, { at: s2 }), ++this.state.pos, i2 = true), f3 === 109 && (this.expectPlugin("decimal", this.state.curPosition()), (n || c) && this.raise(u.InvalidDecimal, { at: s2 }), ++this.state.pos, a = true), de(this.codePointAtPos(this.state.pos)))
                throw this.raise(u.NumberIdentifier, { at: this.state.curPosition() });
              let y = this.input.slice(e2, this.state.pos).replace(/[_mn]/g, "");
              if (i2) {
                this.finishToken(131, y);
                return;
              }
              if (a) {
                this.finishToken(132, y);
                return;
              }
              let P = o ? parseInt(y, 8) : parseFloat(y);
              this.finishToken(130, P);
            }
            readCodePoint(t2) {
              let e2 = this.input.charCodeAt(this.state.pos), s2;
              if (e2 === 123) {
                if (++this.state.pos, s2 = this.readHexChar(this.input.indexOf("}", this.state.pos) - this.state.pos, true, t2), ++this.state.pos, s2 !== null && s2 > 1114111)
                  if (t2)
                    this.raise(u.InvalidCodePoint, { at: this.state.curPosition() });
                  else
                    return null;
              } else
                s2 = this.readHexChar(4, false, t2);
              return s2;
            }
            readString(t2) {
              let e2 = "", s2 = ++this.state.pos;
              for (; ; ) {
                if (this.state.pos >= this.length)
                  throw this.raise(u.UnterminatedString, { at: this.state.startLoc });
                let r2 = this.input.charCodeAt(this.state.pos);
                if (r2 === t2)
                  break;
                if (r2 === 92)
                  e2 += this.input.slice(s2, this.state.pos), e2 += this.readEscapedChar(false), s2 = this.state.pos;
                else if (r2 === 8232 || r2 === 8233)
                  ++this.state.pos, ++this.state.curLine, this.state.lineStart = this.state.pos;
                else {
                  if (Ne(r2))
                    throw this.raise(u.UnterminatedString, { at: this.state.startLoc });
                  ++this.state.pos;
                }
              }
              e2 += this.input.slice(s2, this.state.pos++), this.finishToken(129, e2);
            }
            readTemplateContinuation() {
              this.match(8) || this.unexpected(null, 8), this.state.pos--, this.readTemplateToken();
            }
            readTemplateToken() {
              let t2 = "", e2 = this.state.pos, s2 = false;
              for (++this.state.pos; ; ) {
                if (this.state.pos >= this.length)
                  throw this.raise(u.UnterminatedTemplate, { at: m2(this.state.startLoc, 1) });
                let r2 = this.input.charCodeAt(this.state.pos);
                if (r2 === 96) {
                  ++this.state.pos, t2 += this.input.slice(e2, this.state.pos), this.finishToken(24, s2 ? null : t2);
                  return;
                }
                if (r2 === 36 && this.input.charCodeAt(this.state.pos + 1) === 123) {
                  this.state.pos += 2, t2 += this.input.slice(e2, this.state.pos), this.finishToken(25, s2 ? null : t2);
                  return;
                }
                if (r2 === 92) {
                  t2 += this.input.slice(e2, this.state.pos);
                  let i2 = this.readEscapedChar(true);
                  i2 === null ? s2 = true : t2 += i2, e2 = this.state.pos;
                } else if (Ne(r2)) {
                  switch (t2 += this.input.slice(e2, this.state.pos), ++this.state.pos, r2) {
                    case 13:
                      this.input.charCodeAt(this.state.pos) === 10 && ++this.state.pos;
                    case 10:
                      t2 += `
`;
                      break;
                    default:
                      t2 += String.fromCharCode(r2);
                      break;
                  }
                  ++this.state.curLine, this.state.lineStart = this.state.pos, e2 = this.state.pos;
                } else
                  ++this.state.pos;
              }
            }
            recordStrictModeErrors(t2, e2) {
              let { at: s2 } = e2, r2 = s2.index;
              this.state.strict && !this.state.strictErrors.has(r2) ? this.raise(t2, { at: s2 }) : this.state.strictErrors.set(r2, [t2, s2]);
            }
            readEscapedChar(t2) {
              let e2 = !t2, s2 = this.input.charCodeAt(++this.state.pos);
              switch (++this.state.pos, s2) {
                case 110:
                  return `
`;
                case 114:
                  return "\r";
                case 120: {
                  let r2 = this.readHexChar(2, false, e2);
                  return r2 === null ? null : String.fromCharCode(r2);
                }
                case 117: {
                  let r2 = this.readCodePoint(e2);
                  return r2 === null ? null : String.fromCodePoint(r2);
                }
                case 116:
                  return "	";
                case 98:
                  return "\b";
                case 118:
                  return "\v";
                case 102:
                  return "\f";
                case 13:
                  this.input.charCodeAt(this.state.pos) === 10 && ++this.state.pos;
                case 10:
                  this.state.lineStart = this.state.pos, ++this.state.curLine;
                case 8232:
                case 8233:
                  return "";
                case 56:
                case 57:
                  if (t2)
                    return null;
                  this.recordStrictModeErrors(u.StrictNumericEscape, { at: m2(this.state.curPosition(), -1) });
                default:
                  if (s2 >= 48 && s2 <= 55) {
                    let r2 = m2(this.state.curPosition(), -1), a = this.input.slice(this.state.pos - 1, this.state.pos + 2).match(/^[0-7]+/)[0], n = parseInt(a, 8);
                    n > 255 && (a = a.slice(0, -1), n = parseInt(a, 8)), this.state.pos += a.length - 1;
                    let o = this.input.charCodeAt(this.state.pos);
                    if (a !== "0" || o === 56 || o === 57) {
                      if (t2)
                        return null;
                      this.recordStrictModeErrors(u.StrictNumericEscape, { at: r2 });
                    }
                    return String.fromCharCode(n);
                  }
                  return String.fromCharCode(s2);
              }
            }
            readHexChar(t2, e2, s2) {
              let r2 = this.state.curPosition(), i2 = this.readInt(16, t2, e2, false);
              return i2 === null && (s2 ? this.raise(u.InvalidEscapeSequence, { at: r2 }) : this.state.pos = r2.index - 1), i2;
            }
            readWord1(t2) {
              this.state.containsEsc = false;
              let e2 = "", s2 = this.state.pos, r2 = this.state.pos;
              for (t2 !== void 0 && (this.state.pos += t2 <= 65535 ? 1 : 2); this.state.pos < this.length; ) {
                let i2 = this.codePointAtPos(this.state.pos);
                if (Be(i2))
                  this.state.pos += i2 <= 65535 ? 1 : 2;
                else if (i2 === 92) {
                  this.state.containsEsc = true, e2 += this.input.slice(r2, this.state.pos);
                  let a = this.state.curPosition(), n = this.state.pos === s2 ? de : Be;
                  if (this.input.charCodeAt(++this.state.pos) !== 117) {
                    this.raise(u.MissingUnicodeEscape, { at: this.state.curPosition() }), r2 = this.state.pos - 1;
                    continue;
                  }
                  ++this.state.pos;
                  let o = this.readCodePoint(true);
                  o !== null && (n(o) || this.raise(u.EscapedCharNotAnIdentifier, { at: a }), e2 += String.fromCodePoint(o)), r2 = this.state.pos;
                } else
                  break;
              }
              return e2 + this.input.slice(r2, this.state.pos);
            }
            readWord(t2) {
              let e2 = this.readWord1(t2), s2 = qt.get(e2);
              s2 !== void 0 ? this.finishToken(s2, Pe(s2)) : this.finishToken(128, e2);
            }
            checkKeywordEscapes() {
              let { type: t2 } = this.state;
              Ht(t2) && this.state.containsEsc && this.raise(u.InvalidEscapedReservedWord, { at: this.state.startLoc, reservedWord: Pe(t2) });
            }
            raise(t2, e2) {
              let { at: s2 } = e2, r2 = l(e2, oh), i2 = s2 instanceof p ? s2 : s2.loc.start, a = t2({ loc: i2, details: r2 });
              if (!this.options.errorRecovery)
                throw a;
              return this.isLookahead || this.state.errors.push(a), a;
            }
            raiseOverwrite(t2, e2) {
              let { at: s2 } = e2, r2 = l(e2, hh), i2 = s2 instanceof p ? s2 : s2.loc.start, a = i2.index, n = this.state.errors;
              for (let o = n.length - 1; o >= 0; o--) {
                let c = n[o];
                if (c.loc.index === a)
                  return n[o] = t2({ loc: i2, details: r2 });
                if (c.loc.index < a)
                  break;
              }
              return this.raise(t2, e2);
            }
            updateContext(t2) {
            }
            unexpected(t2, e2) {
              throw this.raise(u.UnexpectedToken, { expected: e2 ? Pe(e2) : null, at: t2 != null ? t2 : this.state.startLoc });
            }
            expectPlugin(t2, e2) {
              if (this.hasPlugin(t2))
                return true;
              throw this.raise(u.MissingPlugin, { at: e2 != null ? e2 : this.state.startLoc, missingPlugin: [t2] });
            }
            expectOnePlugin(t2) {
              if (!t2.some((e2) => this.hasPlugin(e2)))
                throw this.raise(u.MissingOneOfPlugins, { at: this.state.startLoc, missingPlugin: t2 });
            }
          }, os = class {
            constructor(t2) {
              this.var = /* @__PURE__ */ new Set(), this.lexical = /* @__PURE__ */ new Set(), this.functions = /* @__PURE__ */ new Set(), this.flags = t2;
            }
          }, hs = class {
            constructor(t2, e2) {
              this.parser = void 0, this.scopeStack = [], this.inModule = void 0, this.undefinedExports = /* @__PURE__ */ new Map(), this.parser = t2, this.inModule = e2;
            }
            get inFunction() {
              return (this.currentVarScopeFlags() & me) > 0;
            }
            get allowSuper() {
              return (this.currentThisScopeFlags() & ot) > 0;
            }
            get allowDirectSuper() {
              return (this.currentThisScopeFlags() & xr) > 0;
            }
            get inClass() {
              return (this.currentThisScopeFlags() & Se) > 0;
            }
            get inClassAndNotInNonArrowFunction() {
              let t2 = this.currentThisScopeFlags();
              return (t2 & Se) > 0 && (t2 & me) === 0;
            }
            get inStaticBlock() {
              for (let t2 = this.scopeStack.length - 1; ; t2--) {
                let { flags: e2 } = this.scopeStack[t2];
                if (e2 & Yt)
                  return true;
                if (e2 & (lt | Se))
                  return false;
              }
            }
            get inNonArrowFunction() {
              return (this.currentThisScopeFlags() & me) > 0;
            }
            get treatFunctionsAsVar() {
              return this.treatFunctionsAsVarInScope(this.currentScope());
            }
            createScope(t2) {
              return new os(t2);
            }
            enter(t2) {
              this.scopeStack.push(this.createScope(t2));
            }
            exit() {
              this.scopeStack.pop();
            }
            treatFunctionsAsVarInScope(t2) {
              return !!(t2.flags & (me | Yt) || !this.parser.inModule && t2.flags & We);
            }
            declareName(t2, e2, s2) {
              let r2 = this.currentScope();
              if (e2 & Te || e2 & ut)
                this.checkRedeclarationInScope(r2, t2, e2, s2), e2 & ut ? r2.functions.add(t2) : r2.lexical.add(t2), e2 & Te && this.maybeExportDefined(r2, t2);
              else if (e2 & gr)
                for (let i2 = this.scopeStack.length - 1; i2 >= 0 && (r2 = this.scopeStack[i2], this.checkRedeclarationInScope(r2, t2, e2, s2), r2.var.add(t2), this.maybeExportDefined(r2, t2), !(r2.flags & lt)); --i2)
                  ;
              this.parser.inModule && r2.flags & We && this.undefinedExports.delete(t2);
            }
            maybeExportDefined(t2, e2) {
              this.parser.inModule && t2.flags & We && this.undefinedExports.delete(e2);
            }
            checkRedeclarationInScope(t2, e2, s2, r2) {
              this.isRedeclaredInScope(t2, e2, s2) && this.parser.raise(u.VarRedeclaration, { at: r2, identifierName: e2 });
            }
            isRedeclaredInScope(t2, e2, s2) {
              return s2 & ye ? s2 & Te ? t2.lexical.has(e2) || t2.functions.has(e2) || t2.var.has(e2) : s2 & ut ? t2.lexical.has(e2) || !this.treatFunctionsAsVarInScope(t2) && t2.var.has(e2) : t2.lexical.has(e2) && !(t2.flags & yr && t2.lexical.values().next().value === e2) || !this.treatFunctionsAsVarInScope(t2) && t2.functions.has(e2) : false;
            }
            checkLocalExport(t2) {
              let { name: e2 } = t2, s2 = this.scopeStack[0];
              !s2.lexical.has(e2) && !s2.var.has(e2) && !s2.functions.has(e2) && this.undefinedExports.set(e2, t2.loc.start);
            }
            currentScope() {
              return this.scopeStack[this.scopeStack.length - 1];
            }
            currentVarScopeFlags() {
              for (let t2 = this.scopeStack.length - 1; ; t2--) {
                let { flags: e2 } = this.scopeStack[t2];
                if (e2 & lt)
                  return e2;
              }
            }
            currentThisScopeFlags() {
              for (let t2 = this.scopeStack.length - 1; ; t2--) {
                let { flags: e2 } = this.scopeStack[t2];
                if (e2 & (lt | Se) && !(e2 & Jt))
                  return e2;
              }
            }
          }, ph = class extends os {
            constructor() {
              super(...arguments), this.declareFunctions = /* @__PURE__ */ new Set();
            }
          }, fh = class extends hs {
            createScope(t2) {
              return new ph(t2);
            }
            declareName(t2, e2, s2) {
              let r2 = this.currentScope();
              if (e2 & es) {
                this.checkRedeclarationInScope(r2, t2, e2, s2), this.maybeExportDefined(r2, t2), r2.declareFunctions.add(t2);
                return;
              }
              super.declareName(...arguments);
            }
            isRedeclaredInScope(t2, e2, s2) {
              return super.isRedeclaredInScope(...arguments) ? true : s2 & es ? !t2.declareFunctions.has(e2) && (t2.lexical.has(e2) || t2.functions.has(e2)) : false;
            }
            checkLocalExport(t2) {
              this.scopeStack[0].declareFunctions.has(t2.name) || super.checkLocalExport(t2);
            }
          }, dh = class {
            constructor() {
              this.privateNames = /* @__PURE__ */ new Set(), this.loneAccessors = /* @__PURE__ */ new Map(), this.undefinedPrivateNames = /* @__PURE__ */ new Map();
            }
          }, mh = class {
            constructor(t2) {
              this.parser = void 0, this.stack = [], this.undefinedPrivateNames = /* @__PURE__ */ new Map(), this.parser = t2;
            }
            current() {
              return this.stack[this.stack.length - 1];
            }
            enter() {
              this.stack.push(new dh());
            }
            exit() {
              let t2 = this.stack.pop(), e2 = this.current();
              for (let [s2, r2] of Array.from(t2.undefinedPrivateNames))
                e2 ? e2.undefinedPrivateNames.has(s2) || e2.undefinedPrivateNames.set(s2, r2) : this.parser.raise(u.InvalidPrivateFieldResolution, { at: r2, identifierName: s2 });
            }
            declarePrivateName(t2, e2, s2) {
              let { privateNames: r2, loneAccessors: i2, undefinedPrivateNames: a } = this.current(), n = r2.has(t2);
              if (e2 & rs) {
                let o = n && i2.get(t2);
                if (o) {
                  let c = o & ft, f3 = e2 & ft, y = o & rs, P = e2 & rs;
                  n = y === P || c !== f3, n || i2.delete(t2);
                } else
                  n || i2.set(t2, e2);
              }
              n && this.parser.raise(u.PrivateNameRedeclaration, { at: s2, identifierName: t2 }), r2.add(t2), a.delete(t2);
            }
            usePrivateName(t2, e2) {
              let s2;
              for (s2 of this.stack)
                if (s2.privateNames.has(t2))
                  return;
              s2 ? s2.undefinedPrivateNames.set(t2, e2) : this.parser.raise(u.InvalidPrivateFieldResolution, { at: e2, identifierName: t2 });
            }
          }, yh = 0, Nr = 1, ls = 2, Ir = 3, yt = class {
            constructor() {
              let t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : yh;
              this.type = void 0, this.type = t2;
            }
            canBeArrowParameterDeclaration() {
              return this.type === ls || this.type === Nr;
            }
            isCertainlyParameterDeclaration() {
              return this.type === Ir;
            }
          }, kr = class extends yt {
            constructor(t2) {
              super(t2), this.declarationErrors = /* @__PURE__ */ new Map();
            }
            recordDeclarationError(t2, e2) {
              let { at: s2 } = e2, r2 = s2.index;
              this.declarationErrors.set(r2, [t2, s2]);
            }
            clearDeclarationError(t2) {
              this.declarationErrors.delete(t2);
            }
            iterateErrors(t2) {
              this.declarationErrors.forEach(t2);
            }
          }, xh = class {
            constructor(t2) {
              this.parser = void 0, this.stack = [new yt()], this.parser = t2;
            }
            enter(t2) {
              this.stack.push(t2);
            }
            exit() {
              this.stack.pop();
            }
            recordParameterInitializerError(t2, e2) {
              let { at: s2 } = e2, r2 = { at: s2.loc.start }, { stack: i2 } = this, a = i2.length - 1, n = i2[a];
              for (; !n.isCertainlyParameterDeclaration(); ) {
                if (n.canBeArrowParameterDeclaration())
                  n.recordDeclarationError(t2, r2);
                else
                  return;
                n = i2[--a];
              }
              this.parser.raise(t2, r2);
            }
            recordArrowParemeterBindingError(t2, e2) {
              let { at: s2 } = e2, { stack: r2 } = this, i2 = r2[r2.length - 1], a = { at: s2.loc.start };
              if (i2.isCertainlyParameterDeclaration())
                this.parser.raise(t2, a);
              else if (i2.canBeArrowParameterDeclaration())
                i2.recordDeclarationError(t2, a);
              else
                return;
            }
            recordAsyncArrowParametersError(t2) {
              let { at: e2 } = t2, { stack: s2 } = this, r2 = s2.length - 1, i2 = s2[r2];
              for (; i2.canBeArrowParameterDeclaration(); )
                i2.type === ls && i2.recordDeclarationError(u.AwaitBindingIdentifier, { at: e2 }), i2 = s2[--r2];
            }
            validateAsPattern() {
              let { stack: t2 } = this, e2 = t2[t2.length - 1];
              !e2.canBeArrowParameterDeclaration() || e2.iterateErrors((s2) => {
                let [r2, i2] = s2;
                this.parser.raise(r2, { at: i2 });
                let a = t2.length - 2, n = t2[a];
                for (; n.canBeArrowParameterDeclaration(); )
                  n.clearDeclarationError(i2.index), n = t2[--a];
              });
            }
          };
          function gh() {
            return new yt(Ir);
          }
          function Ah() {
            return new kr(Nr);
          }
          function Ph() {
            return new kr(ls);
          }
          function Dr() {
            return new yt();
          }
          var je = 0, Fr = 1, xt = 2, Lr = 4, qe = 8, Th = class {
            constructor() {
              this.stacks = [];
            }
            enter(t2) {
              this.stacks.push(t2);
            }
            exit() {
              this.stacks.pop();
            }
            currentFlags() {
              return this.stacks[this.stacks.length - 1];
            }
            get hasAwait() {
              return (this.currentFlags() & xt) > 0;
            }
            get hasYield() {
              return (this.currentFlags() & Fr) > 0;
            }
            get hasReturn() {
              return (this.currentFlags() & Lr) > 0;
            }
            get hasIn() {
              return (this.currentFlags() & qe) > 0;
            }
          };
          function gt(t2, e2) {
            return (t2 ? xt : 0) | (e2 ? Fr : 0);
          }
          var Eh = class extends ch {
            addExtra(t2, e2, s2) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
              if (!t2)
                return;
              let i2 = t2.extra = t2.extra || {};
              r2 ? i2[e2] = s2 : Object.defineProperty(i2, e2, { enumerable: r2, value: s2 });
            }
            isContextual(t2) {
              return this.state.type === t2 && !this.state.containsEsc;
            }
            isUnparsedContextual(t2, e2) {
              let s2 = t2 + e2.length;
              if (this.input.slice(t2, s2) === e2) {
                let r2 = this.input.charCodeAt(s2);
                return !(Be(r2) || (r2 & 64512) === 55296);
              }
              return false;
            }
            isLookaheadContextual(t2) {
              let e2 = this.nextTokenStart();
              return this.isUnparsedContextual(e2, t2);
            }
            eatContextual(t2) {
              return this.isContextual(t2) ? (this.next(), true) : false;
            }
            expectContextual(t2, e2) {
              if (!this.eatContextual(t2))
                throw e2 != null ? this.raise(e2, { at: this.state.startLoc }) : this.unexpected(null, t2);
            }
            canInsertSemicolon() {
              return this.match(135) || this.match(8) || this.hasPrecedingLineBreak();
            }
            hasPrecedingLineBreak() {
              return as.test(this.input.slice(this.state.lastTokEndLoc.index, this.state.start));
            }
            hasFollowingLineBreak() {
              return vr.lastIndex = this.state.end, vr.test(this.input);
            }
            isLineTerminator() {
              return this.eat(13) || this.canInsertSemicolon();
            }
            semicolon() {
              ((arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true) ? this.isLineTerminator() : this.eat(13)) || this.raise(u.MissingSemicolon, { at: this.state.lastTokEndLoc });
            }
            expect(t2, e2) {
              this.eat(t2) || this.unexpected(e2, t2);
            }
            tryParse(t2) {
              let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.clone(), s2 = { node: null };
              try {
                let r2 = t2(function() {
                  let i2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
                  throw s2.node = i2, s2;
                });
                if (this.state.errors.length > e2.errors.length) {
                  let i2 = this.state;
                  return this.state = e2, this.state.tokensLength = i2.tokensLength, { node: r2, error: i2.errors[e2.errors.length], thrown: false, aborted: false, failState: i2 };
                }
                return { node: r2, error: null, thrown: false, aborted: false, failState: null };
              } catch (r2) {
                let i2 = this.state;
                if (this.state = e2, r2 instanceof SyntaxError)
                  return { node: null, error: r2, thrown: true, aborted: false, failState: i2 };
                if (r2 === s2)
                  return { node: s2.node, error: null, thrown: false, aborted: true, failState: i2 };
                throw r2;
              }
            }
            checkExpressionErrors(t2, e2) {
              if (!t2)
                return false;
              let { shorthandAssignLoc: s2, doubleProtoLoc: r2, privateKeyLoc: i2, optionalParametersLoc: a } = t2, n = !!s2 || !!r2 || !!a || !!i2;
              if (!e2)
                return n;
              s2 != null && this.raise(u.InvalidCoverInitializedName, { at: s2 }), r2 != null && this.raise(u.DuplicateProto, { at: r2 }), i2 != null && this.raise(u.UnexpectedPrivateField, { at: i2 }), a != null && this.unexpected(a);
            }
            isLiteralPropertyName() {
              return hr(this.state.type);
            }
            isPrivateName(t2) {
              return t2.type === "PrivateName";
            }
            getPrivateNameSV(t2) {
              return t2.id.name;
            }
            hasPropertyAsPrivateName(t2) {
              return (t2.type === "MemberExpression" || t2.type === "OptionalMemberExpression") && this.isPrivateName(t2.property);
            }
            isOptionalChain(t2) {
              return t2.type === "OptionalMemberExpression" || t2.type === "OptionalCallExpression";
            }
            isObjectProperty(t2) {
              return t2.type === "ObjectProperty";
            }
            isObjectMethod(t2) {
              return t2.type === "ObjectMethod";
            }
            initializeScopes() {
              let t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.options.sourceType === "module", e2 = this.state.labels;
              this.state.labels = [];
              let s2 = this.exportedIdentifiers;
              this.exportedIdentifiers = /* @__PURE__ */ new Set();
              let r2 = this.inModule;
              this.inModule = t2;
              let i2 = this.scope, a = this.getScopeHandler();
              this.scope = new a(this, t2);
              let n = this.prodParam;
              this.prodParam = new Th();
              let o = this.classScope;
              this.classScope = new mh(this);
              let c = this.expressionScope;
              return this.expressionScope = new xh(this), () => {
                this.state.labels = e2, this.exportedIdentifiers = s2, this.inModule = r2, this.scope = i2, this.prodParam = n, this.classScope = o, this.expressionScope = c;
              };
            }
            enterInitialScopes() {
              let t2 = je;
              this.inModule && (t2 |= xt), this.scope.enter(We), this.prodParam.enter(t2);
            }
            checkDestructuringPrivate(t2) {
              let { privateKeyLoc: e2 } = t2;
              e2 !== null && this.expectPlugin("destructuringPrivate", e2);
            }
          }, At = class {
            constructor() {
              this.shorthandAssignLoc = null, this.doubleProtoLoc = null, this.privateKeyLoc = null, this.optionalParametersLoc = null;
            }
          }, Pt = class {
            constructor(t2, e2, s2) {
              this.type = "", this.start = e2, this.end = 0, this.loc = new d(s2), t2 != null && t2.options.ranges && (this.range = [e2, 0]), t2 != null && t2.filename && (this.loc.filename = t2.filename);
            }
          }, us = Pt.prototype;
          us.__clone = function() {
            let t2 = new Pt(), e2 = Object.keys(this);
            for (let s2 = 0, r2 = e2.length; s2 < r2; s2++) {
              let i2 = e2[s2];
              i2 !== "leadingComments" && i2 !== "trailingComments" && i2 !== "innerComments" && (t2[i2] = this[i2]);
            }
            return t2;
          };
          function Ch(t2) {
            return ge(t2);
          }
          function ge(t2) {
            let { type: e2, start: s2, end: r2, loc: i2, range: a, extra: n, name: o } = t2, c = Object.create(us);
            return c.type = e2, c.start = s2, c.end = r2, c.loc = i2, c.range = a, c.extra = n, c.name = o, e2 === "Placeholder" && (c.expectedNode = t2.expectedNode), c;
          }
          function bh(t2) {
            let { type: e2, start: s2, end: r2, loc: i2, range: a, extra: n } = t2;
            if (e2 === "Placeholder")
              return Ch(t2);
            let o = Object.create(us);
            return o.type = e2, o.start = s2, o.end = r2, o.loc = i2, o.range = a, t2.raw !== void 0 ? o.raw = t2.raw : o.extra = n, o.value = t2.value, o;
          }
          var vh = class extends Eh {
            startNode() {
              return new Pt(this, this.state.start, this.state.startLoc);
            }
            startNodeAt(t2, e2) {
              return new Pt(this, t2, e2);
            }
            startNodeAtNode(t2) {
              return this.startNodeAt(t2.start, t2.loc.start);
            }
            finishNode(t2, e2) {
              return this.finishNodeAt(t2, e2, this.state.lastTokEndLoc);
            }
            finishNodeAt(t2, e2, s2) {
              return t2.type = e2, t2.end = s2.index, t2.loc.end = s2, this.options.ranges && (t2.range[1] = s2.index), this.options.attachComment && this.processComment(t2), t2;
            }
            resetStartLocation(t2, e2, s2) {
              t2.start = e2, t2.loc.start = s2, this.options.ranges && (t2.range[0] = e2);
            }
            resetEndLocation(t2) {
              let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.state.lastTokEndLoc;
              t2.end = e2.index, t2.loc.end = e2, this.options.ranges && (t2.range[1] = e2.index);
            }
            resetStartLocationFromNode(t2, e2) {
              this.resetStartLocation(t2, e2.start, e2.loc.start);
            }
          }, Sh = /* @__PURE__ */ new Set(["_", "any", "bool", "boolean", "empty", "extends", "false", "interface", "mixed", "null", "number", "static", "string", "true", "typeof", "void"]), I = j(zn || (zn = rt(["flow"])))((t2) => ({ AmbiguousConditionalArrow: t2("Ambiguous expression: wrap the arrow functions in parentheses to disambiguate."), AmbiguousDeclareModuleKind: t2("Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module or they are a CommonJS module."), AssignReservedType: t2((e2) => {
            let { reservedType: s2 } = e2;
            return "Cannot overwrite reserved type ".concat(s2, ".");
          }), DeclareClassElement: t2("The `declare` modifier can only appear on class fields."), DeclareClassFieldInitializer: t2("Initializers are not allowed in fields with the `declare` modifier."), DuplicateDeclareModuleExports: t2("Duplicate `declare module.exports` statement."), EnumBooleanMemberNotInitialized: t2((e2) => {
            let { memberName: s2, enumName: r2 } = e2;
            return "Boolean enum members need to be initialized. Use either `".concat(s2, " = true,` or `").concat(s2, " = false,` in enum `").concat(r2, "`.");
          }), EnumDuplicateMemberName: t2((e2) => {
            let { memberName: s2, enumName: r2 } = e2;
            return "Enum member names need to be unique, but the name `".concat(s2, "` has already been used before in enum `").concat(r2, "`.");
          }), EnumInconsistentMemberValues: t2((e2) => {
            let { enumName: s2 } = e2;
            return "Enum `".concat(s2, "` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.");
          }), EnumInvalidExplicitType: t2((e2) => {
            let { invalidEnumType: s2, enumName: r2 } = e2;
            return "Enum type `".concat(s2, "` is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `").concat(r2, "`.");
          }), EnumInvalidExplicitTypeUnknownSupplied: t2((e2) => {
            let { enumName: s2 } = e2;
            return "Supplied enum type is not valid. Use one of `boolean`, `number`, `string`, or `symbol` in enum `".concat(s2, "`.");
          }), EnumInvalidMemberInitializerPrimaryType: t2((e2) => {
            let { enumName: s2, memberName: r2, explicitType: i2 } = e2;
            return "Enum `".concat(s2, "` has type `").concat(i2, "`, so the initializer of `").concat(r2, "` needs to be a ").concat(i2, " literal.");
          }), EnumInvalidMemberInitializerSymbolType: t2((e2) => {
            let { enumName: s2, memberName: r2 } = e2;
            return "Symbol enum members cannot be initialized. Use `".concat(r2, ",` in enum `").concat(s2, "`.");
          }), EnumInvalidMemberInitializerUnknownType: t2((e2) => {
            let { enumName: s2, memberName: r2 } = e2;
            return "The enum member initializer for `".concat(r2, "` needs to be a literal (either a boolean, number, or string) in enum `").concat(s2, "`.");
          }), EnumInvalidMemberName: t2((e2) => {
            let { enumName: s2, memberName: r2, suggestion: i2 } = e2;
            return "Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `".concat(r2, "`, consider using `").concat(i2, "`, in enum `").concat(s2, "`.");
          }), EnumNumberMemberNotInitialized: t2((e2) => {
            let { enumName: s2, memberName: r2 } = e2;
            return "Number enum members need to be initialized, e.g. `".concat(r2, " = 1` in enum `").concat(s2, "`.");
          }), EnumStringMemberInconsistentlyInitailized: t2((e2) => {
            let { enumName: s2 } = e2;
            return "String enum members need to consistently either all use initializers, or use no initializers, in enum `".concat(s2, "`.");
          }), GetterMayNotHaveThisParam: t2("A getter cannot have a `this` parameter."), ImportTypeShorthandOnlyInPureImport: t2("The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements."), InexactInsideExact: t2("Explicit inexact syntax cannot appear inside an explicit exact object type."), InexactInsideNonObject: t2("Explicit inexact syntax cannot appear in class or interface definitions."), InexactVariance: t2("Explicit inexact syntax cannot have variance."), InvalidNonTypeImportInDeclareModule: t2("Imports within a `declare module` body must always be `import type` or `import typeof`."), MissingTypeParamDefault: t2("Type parameter declaration needs a default, since a preceding type parameter declaration has a default."), NestedDeclareModule: t2("`declare module` cannot be used inside another `declare module`."), NestedFlowComment: t2("Cannot have a flow comment inside another flow comment."), PatternIsOptional: t2("A binding pattern parameter cannot be optional in an implementation signature.", { reasonCode: "OptionalBindingPattern" }), SetterMayNotHaveThisParam: t2("A setter cannot have a `this` parameter."), SpreadVariance: t2("Spread properties cannot have variance."), ThisParamAnnotationRequired: t2("A type annotation is required for the `this` parameter."), ThisParamBannedInConstructor: t2("Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions."), ThisParamMayNotBeOptional: t2("The `this` parameter cannot be optional."), ThisParamMustBeFirst: t2("The `this` parameter must be the first function parameter."), ThisParamNoDefault: t2("The `this` parameter may not have a default value."), TypeBeforeInitializer: t2("Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`."), TypeCastInPattern: t2("The type cast expression is expected to be wrapped with parenthesis."), UnexpectedExplicitInexactInObject: t2("Explicit inexact syntax must appear at the end of an inexact object."), UnexpectedReservedType: t2((e2) => {
            let { reservedType: s2 } = e2;
            return "Unexpected reserved type ".concat(s2, ".");
          }), UnexpectedReservedUnderscore: t2("`_` is only allowed as a type argument to call or new."), UnexpectedSpaceBetweenModuloChecks: t2("Spaces between `%` and `checks` are not allowed here."), UnexpectedSpreadType: t2("Spread operator cannot appear in class or interface definitions."), UnexpectedSubtractionOperand: t2('Unexpected token, expected "number" or "bigint".'), UnexpectedTokenAfterTypeParameter: t2("Expected an arrow function after this type parameter declaration."), UnexpectedTypeParameterBeforeAsyncArrowFunction: t2("Type parameters must come after the async keyword, e.g. instead of `<T> async () => {}`, use `async <T>() => {}`."), UnsupportedDeclareExportKind: t2((e2) => {
            let { unsupportedExportKind: s2, suggestion: r2 } = e2;
            return "`declare export ".concat(s2, "` is not supported. Use `").concat(r2, "` instead.");
          }), UnsupportedStatementInDeclareModule: t2("Only declares and type imports are allowed inside declare module."), UnterminatedFlowComment: t2("Unterminated flow-comment.") }));
          function wh(t2) {
            return t2.type === "DeclareExportAllDeclaration" || t2.type === "DeclareExportDeclaration" && (!t2.declaration || t2.declaration.type !== "TypeAlias" && t2.declaration.type !== "InterfaceDeclaration");
          }
          function cs(t2) {
            return t2.importKind === "type" || t2.importKind === "typeof";
          }
          function Or(t2) {
            return pe(t2) && t2 !== 97;
          }
          var Nh = { const: "declare export var", let: "declare export var", type: "export type", interface: "export interface" };
          function Ih(t2, e2) {
            let s2 = [], r2 = [];
            for (let i2 = 0; i2 < t2.length; i2++)
              (e2(t2[i2], i2, t2) ? s2 : r2).push(t2[i2]);
            return [s2, r2];
          }
          var kh = /\*?\s*@((?:no)?flow)\b/, Dh = (t2) => class extends t2 {
            constructor() {
              super(...arguments), this.flowPragma = void 0;
            }
            getScopeHandler() {
              return fh;
            }
            shouldParseTypes() {
              return this.getPluginOption("flow", "all") || this.flowPragma === "flow";
            }
            shouldParseEnums() {
              return !!this.getPluginOption("flow", "enums");
            }
            finishToken(e2, s2) {
              return e2 !== 129 && e2 !== 13 && e2 !== 28 && this.flowPragma === void 0 && (this.flowPragma = null), super.finishToken(e2, s2);
            }
            addComment(e2) {
              if (this.flowPragma === void 0) {
                let s2 = kh.exec(e2.value);
                if (s2)
                  if (s2[1] === "flow")
                    this.flowPragma = "flow";
                  else if (s2[1] === "noflow")
                    this.flowPragma = "noflow";
                  else
                    throw new Error("Unexpected flow pragma");
              }
              return super.addComment(e2);
            }
            flowParseTypeInitialiser(e2) {
              let s2 = this.state.inType;
              this.state.inType = true, this.expect(e2 || 14);
              let r2 = this.flowParseType();
              return this.state.inType = s2, r2;
            }
            flowParsePredicate() {
              let e2 = this.startNode(), s2 = this.state.startLoc;
              return this.next(), this.expectContextual(107), this.state.lastTokStart > s2.index + 1 && this.raise(I.UnexpectedSpaceBetweenModuloChecks, { at: s2 }), this.eat(10) ? (e2.value = this.parseExpression(), this.expect(11), this.finishNode(e2, "DeclaredPredicate")) : this.finishNode(e2, "InferredPredicate");
            }
            flowParseTypeAndPredicateInitialiser() {
              let e2 = this.state.inType;
              this.state.inType = true, this.expect(14);
              let s2 = null, r2 = null;
              return this.match(54) ? (this.state.inType = e2, r2 = this.flowParsePredicate()) : (s2 = this.flowParseType(), this.state.inType = e2, this.match(54) && (r2 = this.flowParsePredicate())), [s2, r2];
            }
            flowParseDeclareClass(e2) {
              return this.next(), this.flowParseInterfaceish(e2, true), this.finishNode(e2, "DeclareClass");
            }
            flowParseDeclareFunction(e2) {
              this.next();
              let s2 = e2.id = this.parseIdentifier(), r2 = this.startNode(), i2 = this.startNode();
              this.match(47) ? r2.typeParameters = this.flowParseTypeParameterDeclaration() : r2.typeParameters = null, this.expect(10);
              let a = this.flowParseFunctionTypeParams();
              return r2.params = a.params, r2.rest = a.rest, r2.this = a._this, this.expect(11), [r2.returnType, e2.predicate] = this.flowParseTypeAndPredicateInitialiser(), i2.typeAnnotation = this.finishNode(r2, "FunctionTypeAnnotation"), s2.typeAnnotation = this.finishNode(i2, "TypeAnnotation"), this.resetEndLocation(s2), this.semicolon(), this.scope.declareName(e2.id.name, $o, e2.id.loc.start), this.finishNode(e2, "DeclareFunction");
            }
            flowParseDeclare(e2, s2) {
              if (this.match(80))
                return this.flowParseDeclareClass(e2);
              if (this.match(68))
                return this.flowParseDeclareFunction(e2);
              if (this.match(74))
                return this.flowParseDeclareVariable(e2);
              if (this.eatContextual(123))
                return this.match(16) ? this.flowParseDeclareModuleExports(e2) : (s2 && this.raise(I.NestedDeclareModule, { at: this.state.lastTokStartLoc }), this.flowParseDeclareModule(e2));
              if (this.isContextual(126))
                return this.flowParseDeclareTypeAlias(e2);
              if (this.isContextual(127))
                return this.flowParseDeclareOpaqueType(e2);
              if (this.isContextual(125))
                return this.flowParseDeclareInterface(e2);
              if (this.match(82))
                return this.flowParseDeclareExportDeclaration(e2, s2);
              throw this.unexpected();
            }
            flowParseDeclareVariable(e2) {
              return this.next(), e2.id = this.flowParseTypeAnnotatableIdentifier(true), this.scope.declareName(e2.id.name, pt, e2.id.loc.start), this.semicolon(), this.finishNode(e2, "DeclareVariable");
            }
            flowParseDeclareModule(e2) {
              this.scope.enter(Me), this.match(129) ? e2.id = this.parseExprAtom() : e2.id = this.parseIdentifier();
              let s2 = e2.body = this.startNode(), r2 = s2.body = [];
              for (this.expect(5); !this.match(8); ) {
                let n = this.startNode();
                this.match(83) ? (this.next(), !this.isContextual(126) && !this.match(87) && this.raise(I.InvalidNonTypeImportInDeclareModule, { at: this.state.lastTokStartLoc }), this.parseImport(n)) : (this.expectContextual(121, I.UnsupportedStatementInDeclareModule), n = this.flowParseDeclare(n, true)), r2.push(n);
              }
              this.scope.exit(), this.expect(8), this.finishNode(s2, "BlockStatement");
              let i2 = null, a = false;
              return r2.forEach((n) => {
                wh(n) ? (i2 === "CommonJS" && this.raise(I.AmbiguousDeclareModuleKind, { at: n }), i2 = "ES") : n.type === "DeclareModuleExports" && (a && this.raise(I.DuplicateDeclareModuleExports, { at: n }), i2 === "ES" && this.raise(I.AmbiguousDeclareModuleKind, { at: n }), i2 = "CommonJS", a = true);
              }), e2.kind = i2 || "CommonJS", this.finishNode(e2, "DeclareModule");
            }
            flowParseDeclareExportDeclaration(e2, s2) {
              if (this.expect(82), this.eat(65))
                return this.match(68) || this.match(80) ? e2.declaration = this.flowParseDeclare(this.startNode()) : (e2.declaration = this.flowParseType(), this.semicolon()), e2.default = true, this.finishNode(e2, "DeclareExportDeclaration");
              if (this.match(75) || this.isLet() || (this.isContextual(126) || this.isContextual(125)) && !s2) {
                let r2 = this.state.value;
                throw this.raise(I.UnsupportedDeclareExportKind, { at: this.state.startLoc, unsupportedExportKind: r2, suggestion: Nh[r2] });
              }
              if (this.match(74) || this.match(68) || this.match(80) || this.isContextual(127))
                return e2.declaration = this.flowParseDeclare(this.startNode()), e2.default = false, this.finishNode(e2, "DeclareExportDeclaration");
              if (this.match(55) || this.match(5) || this.isContextual(125) || this.isContextual(126) || this.isContextual(127))
                return e2 = this.parseExport(e2), e2.type === "ExportNamedDeclaration" && (e2.type = "ExportDeclaration", e2.default = false, delete e2.exportKind), e2.type = "Declare" + e2.type, e2;
              throw this.unexpected();
            }
            flowParseDeclareModuleExports(e2) {
              return this.next(), this.expectContextual(108), e2.typeAnnotation = this.flowParseTypeAnnotation(), this.semicolon(), this.finishNode(e2, "DeclareModuleExports");
            }
            flowParseDeclareTypeAlias(e2) {
              return this.next(), this.flowParseTypeAlias(e2), e2.type = "DeclareTypeAlias", e2;
            }
            flowParseDeclareOpaqueType(e2) {
              return this.next(), this.flowParseOpaqueType(e2, true), e2.type = "DeclareOpaqueType", e2;
            }
            flowParseDeclareInterface(e2) {
              return this.next(), this.flowParseInterfaceish(e2), this.finishNode(e2, "DeclareInterface");
            }
            flowParseInterfaceish(e2) {
              let s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              if (e2.id = this.flowParseRestrictedIdentifier(!s2, true), this.scope.declareName(e2.id.name, s2 ? Tr : xe, e2.id.loc.start), this.match(47) ? e2.typeParameters = this.flowParseTypeParameterDeclaration() : e2.typeParameters = null, e2.extends = [], e2.implements = [], e2.mixins = [], this.eat(81))
                do
                  e2.extends.push(this.flowParseInterfaceExtends());
                while (!s2 && this.eat(12));
              if (this.isContextual(114)) {
                this.next();
                do
                  e2.mixins.push(this.flowParseInterfaceExtends());
                while (this.eat(12));
              }
              if (this.isContextual(110)) {
                this.next();
                do
                  e2.implements.push(this.flowParseInterfaceExtends());
                while (this.eat(12));
              }
              e2.body = this.flowParseObjectType({ allowStatic: s2, allowExact: false, allowSpread: false, allowProto: s2, allowInexact: false });
            }
            flowParseInterfaceExtends() {
              let e2 = this.startNode();
              return e2.id = this.flowParseQualifiedTypeIdentifier(), this.match(47) ? e2.typeParameters = this.flowParseTypeParameterInstantiation() : e2.typeParameters = null, this.finishNode(e2, "InterfaceExtends");
            }
            flowParseInterface(e2) {
              return this.flowParseInterfaceish(e2), this.finishNode(e2, "InterfaceDeclaration");
            }
            checkNotUnderscore(e2) {
              e2 === "_" && this.raise(I.UnexpectedReservedUnderscore, { at: this.state.startLoc });
            }
            checkReservedType(e2, s2, r2) {
              !Sh.has(e2) || this.raise(r2 ? I.AssignReservedType : I.UnexpectedReservedType, { at: s2, reservedType: e2 });
            }
            flowParseRestrictedIdentifier(e2, s2) {
              return this.checkReservedType(this.state.value, this.state.startLoc, s2), this.parseIdentifier(e2);
            }
            flowParseTypeAlias(e2) {
              return e2.id = this.flowParseRestrictedIdentifier(false, true), this.scope.declareName(e2.id.name, xe, e2.id.loc.start), this.match(47) ? e2.typeParameters = this.flowParseTypeParameterDeclaration() : e2.typeParameters = null, e2.right = this.flowParseTypeInitialiser(29), this.semicolon(), this.finishNode(e2, "TypeAlias");
            }
            flowParseOpaqueType(e2, s2) {
              return this.expectContextual(126), e2.id = this.flowParseRestrictedIdentifier(true, true), this.scope.declareName(e2.id.name, xe, e2.id.loc.start), this.match(47) ? e2.typeParameters = this.flowParseTypeParameterDeclaration() : e2.typeParameters = null, e2.supertype = null, this.match(14) && (e2.supertype = this.flowParseTypeInitialiser(14)), e2.impltype = null, s2 || (e2.impltype = this.flowParseTypeInitialiser(29)), this.semicolon(), this.finishNode(e2, "OpaqueType");
            }
            flowParseTypeParameter() {
              let e2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, s2 = this.state.startLoc, r2 = this.startNode(), i2 = this.flowParseVariance(), a = this.flowParseTypeAnnotatableIdentifier();
              return r2.name = a.name, r2.variance = i2, r2.bound = a.typeAnnotation, this.match(29) ? (this.eat(29), r2.default = this.flowParseType()) : e2 && this.raise(I.MissingTypeParamDefault, { at: s2 }), this.finishNode(r2, "TypeParameter");
            }
            flowParseTypeParameterDeclaration() {
              let e2 = this.state.inType, s2 = this.startNode();
              s2.params = [], this.state.inType = true, this.match(47) || this.match(138) ? this.next() : this.unexpected();
              let r2 = false;
              do {
                let i2 = this.flowParseTypeParameter(r2);
                s2.params.push(i2), i2.default && (r2 = true), this.match(48) || this.expect(12);
              } while (!this.match(48));
              return this.expect(48), this.state.inType = e2, this.finishNode(s2, "TypeParameterDeclaration");
            }
            flowParseTypeParameterInstantiation() {
              let e2 = this.startNode(), s2 = this.state.inType;
              e2.params = [], this.state.inType = true, this.expect(47);
              let r2 = this.state.noAnonFunctionType;
              for (this.state.noAnonFunctionType = false; !this.match(48); )
                e2.params.push(this.flowParseType()), this.match(48) || this.expect(12);
              return this.state.noAnonFunctionType = r2, this.expect(48), this.state.inType = s2, this.finishNode(e2, "TypeParameterInstantiation");
            }
            flowParseTypeParameterInstantiationCallOrNew() {
              let e2 = this.startNode(), s2 = this.state.inType;
              for (e2.params = [], this.state.inType = true, this.expect(47); !this.match(48); )
                e2.params.push(this.flowParseTypeOrImplicitInstantiation()), this.match(48) || this.expect(12);
              return this.expect(48), this.state.inType = s2, this.finishNode(e2, "TypeParameterInstantiation");
            }
            flowParseInterfaceType() {
              let e2 = this.startNode();
              if (this.expectContextual(125), e2.extends = [], this.eat(81))
                do
                  e2.extends.push(this.flowParseInterfaceExtends());
                while (this.eat(12));
              return e2.body = this.flowParseObjectType({ allowStatic: false, allowExact: false, allowSpread: false, allowProto: false, allowInexact: false }), this.finishNode(e2, "InterfaceTypeAnnotation");
            }
            flowParseObjectPropertyKey() {
              return this.match(130) || this.match(129) ? this.parseExprAtom() : this.parseIdentifier(true);
            }
            flowParseObjectTypeIndexer(e2, s2, r2) {
              return e2.static = s2, this.lookahead().type === 14 ? (e2.id = this.flowParseObjectPropertyKey(), e2.key = this.flowParseTypeInitialiser()) : (e2.id = null, e2.key = this.flowParseType()), this.expect(3), e2.value = this.flowParseTypeInitialiser(), e2.variance = r2, this.finishNode(e2, "ObjectTypeIndexer");
            }
            flowParseObjectTypeInternalSlot(e2, s2) {
              return e2.static = s2, e2.id = this.flowParseObjectPropertyKey(), this.expect(3), this.expect(3), this.match(47) || this.match(10) ? (e2.method = true, e2.optional = false, e2.value = this.flowParseObjectTypeMethodish(this.startNodeAt(e2.start, e2.loc.start))) : (e2.method = false, this.eat(17) && (e2.optional = true), e2.value = this.flowParseTypeInitialiser()), this.finishNode(e2, "ObjectTypeInternalSlot");
            }
            flowParseObjectTypeMethodish(e2) {
              for (e2.params = [], e2.rest = null, e2.typeParameters = null, e2.this = null, this.match(47) && (e2.typeParameters = this.flowParseTypeParameterDeclaration()), this.expect(10), this.match(78) && (e2.this = this.flowParseFunctionTypeParam(true), e2.this.name = null, this.match(11) || this.expect(12)); !this.match(11) && !this.match(21); )
                e2.params.push(this.flowParseFunctionTypeParam(false)), this.match(11) || this.expect(12);
              return this.eat(21) && (e2.rest = this.flowParseFunctionTypeParam(false)), this.expect(11), e2.returnType = this.flowParseTypeInitialiser(), this.finishNode(e2, "FunctionTypeAnnotation");
            }
            flowParseObjectTypeCallProperty(e2, s2) {
              let r2 = this.startNode();
              return e2.static = s2, e2.value = this.flowParseObjectTypeMethodish(r2), this.finishNode(e2, "ObjectTypeCallProperty");
            }
            flowParseObjectType(e2) {
              let { allowStatic: s2, allowExact: r2, allowSpread: i2, allowProto: a, allowInexact: n } = e2, o = this.state.inType;
              this.state.inType = true;
              let c = this.startNode();
              c.callProperties = [], c.properties = [], c.indexers = [], c.internalSlots = [];
              let f3, y, P = false;
              for (r2 && this.match(6) ? (this.expect(6), f3 = 9, y = true) : (this.expect(5), f3 = 8, y = false), c.exact = y; !this.match(f3); ) {
                let N = false, B = null, _ = null, Q = this.startNode();
                if (a && this.isContextual(115)) {
                  let ne = this.lookahead();
                  ne.type !== 14 && ne.type !== 17 && (this.next(), B = this.state.startLoc, s2 = false);
                }
                if (s2 && this.isContextual(104)) {
                  let ne = this.lookahead();
                  ne.type !== 14 && ne.type !== 17 && (this.next(), N = true);
                }
                let re = this.flowParseVariance();
                if (this.eat(0))
                  B != null && this.unexpected(B), this.eat(0) ? (re && this.unexpected(re.loc.start), c.internalSlots.push(this.flowParseObjectTypeInternalSlot(Q, N))) : c.indexers.push(this.flowParseObjectTypeIndexer(Q, N, re));
                else if (this.match(10) || this.match(47))
                  B != null && this.unexpected(B), re && this.unexpected(re.loc.start), c.callProperties.push(this.flowParseObjectTypeCallProperty(Q, N));
                else {
                  let ne = "init";
                  if (this.isContextual(98) || this.isContextual(103)) {
                    let le = this.lookahead();
                    hr(le.type) && (ne = this.state.value, this.next());
                  }
                  let $e = this.flowParseObjectTypeProperty(Q, N, B, re, ne, i2, n != null ? n : !y);
                  $e === null ? (P = true, _ = this.state.lastTokStartLoc) : c.properties.push($e);
                }
                this.flowObjectTypeSemicolon(), _ && !this.match(8) && !this.match(9) && this.raise(I.UnexpectedExplicitInexactInObject, { at: _ });
              }
              this.expect(f3), i2 && (c.inexact = P);
              let v = this.finishNode(c, "ObjectTypeAnnotation");
              return this.state.inType = o, v;
            }
            flowParseObjectTypeProperty(e2, s2, r2, i2, a, n, o) {
              if (this.eat(21))
                return this.match(12) || this.match(13) || this.match(8) || this.match(9) ? (n ? o || this.raise(I.InexactInsideExact, { at: this.state.lastTokStartLoc }) : this.raise(I.InexactInsideNonObject, { at: this.state.lastTokStartLoc }), i2 && this.raise(I.InexactVariance, { at: i2 }), null) : (n || this.raise(I.UnexpectedSpreadType, { at: this.state.lastTokStartLoc }), r2 != null && this.unexpected(r2), i2 && this.raise(I.SpreadVariance, { at: i2 }), e2.argument = this.flowParseType(), this.finishNode(e2, "ObjectTypeSpreadProperty"));
              {
                e2.key = this.flowParseObjectPropertyKey(), e2.static = s2, e2.proto = r2 != null, e2.kind = a;
                let c = false;
                return this.match(47) || this.match(10) ? (e2.method = true, r2 != null && this.unexpected(r2), i2 && this.unexpected(i2.loc.start), e2.value = this.flowParseObjectTypeMethodish(this.startNodeAt(e2.start, e2.loc.start)), (a === "get" || a === "set") && this.flowCheckGetterSetterParams(e2), !n && e2.key.name === "constructor" && e2.value.this && this.raise(I.ThisParamBannedInConstructor, { at: e2.value.this })) : (a !== "init" && this.unexpected(), e2.method = false, this.eat(17) && (c = true), e2.value = this.flowParseTypeInitialiser(), e2.variance = i2), e2.optional = c, this.finishNode(e2, "ObjectTypeProperty");
              }
            }
            flowCheckGetterSetterParams(e2) {
              let s2 = e2.kind === "get" ? 0 : 1, r2 = e2.value.params.length + (e2.value.rest ? 1 : 0);
              e2.value.this && this.raise(e2.kind === "get" ? I.GetterMayNotHaveThisParam : I.SetterMayNotHaveThisParam, { at: e2.value.this }), r2 !== s2 && this.raise(e2.kind === "get" ? u.BadGetterArity : u.BadSetterArity, { at: e2 }), e2.kind === "set" && e2.value.rest && this.raise(u.BadSetterRestParameter, { at: e2 });
            }
            flowObjectTypeSemicolon() {
              !this.eat(13) && !this.eat(12) && !this.match(8) && !this.match(9) && this.unexpected();
            }
            flowParseQualifiedTypeIdentifier(e2, s2, r2) {
              e2 = e2 || this.state.start, s2 = s2 || this.state.startLoc;
              let i2 = r2 || this.flowParseRestrictedIdentifier(true);
              for (; this.eat(16); ) {
                let a = this.startNodeAt(e2, s2);
                a.qualification = i2, a.id = this.flowParseRestrictedIdentifier(true), i2 = this.finishNode(a, "QualifiedTypeIdentifier");
              }
              return i2;
            }
            flowParseGenericType(e2, s2, r2) {
              let i2 = this.startNodeAt(e2, s2);
              return i2.typeParameters = null, i2.id = this.flowParseQualifiedTypeIdentifier(e2, s2, r2), this.match(47) && (i2.typeParameters = this.flowParseTypeParameterInstantiation()), this.finishNode(i2, "GenericTypeAnnotation");
            }
            flowParseTypeofType() {
              let e2 = this.startNode();
              return this.expect(87), e2.argument = this.flowParsePrimaryType(), this.finishNode(e2, "TypeofTypeAnnotation");
            }
            flowParseTupleType() {
              let e2 = this.startNode();
              for (e2.types = [], this.expect(0); this.state.pos < this.length && !this.match(3) && (e2.types.push(this.flowParseType()), !this.match(3)); )
                this.expect(12);
              return this.expect(3), this.finishNode(e2, "TupleTypeAnnotation");
            }
            flowParseFunctionTypeParam(e2) {
              let s2 = null, r2 = false, i2 = null, a = this.startNode(), n = this.lookahead(), o = this.state.type === 78;
              return n.type === 14 || n.type === 17 ? (o && !e2 && this.raise(I.ThisParamMustBeFirst, { at: a }), s2 = this.parseIdentifier(o), this.eat(17) && (r2 = true, o && this.raise(I.ThisParamMayNotBeOptional, { at: a })), i2 = this.flowParseTypeInitialiser()) : i2 = this.flowParseType(), a.name = s2, a.optional = r2, a.typeAnnotation = i2, this.finishNode(a, "FunctionTypeParam");
            }
            reinterpretTypeAsFunctionTypeParam(e2) {
              let s2 = this.startNodeAt(e2.start, e2.loc.start);
              return s2.name = null, s2.optional = false, s2.typeAnnotation = e2, this.finishNode(s2, "FunctionTypeParam");
            }
            flowParseFunctionTypeParams() {
              let e2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [], s2 = null, r2 = null;
              for (this.match(78) && (r2 = this.flowParseFunctionTypeParam(true), r2.name = null, this.match(11) || this.expect(12)); !this.match(11) && !this.match(21); )
                e2.push(this.flowParseFunctionTypeParam(false)), this.match(11) || this.expect(12);
              return this.eat(21) && (s2 = this.flowParseFunctionTypeParam(false)), { params: e2, rest: s2, _this: r2 };
            }
            flowIdentToTypeAnnotation(e2, s2, r2, i2) {
              switch (i2.name) {
                case "any":
                  return this.finishNode(r2, "AnyTypeAnnotation");
                case "bool":
                case "boolean":
                  return this.finishNode(r2, "BooleanTypeAnnotation");
                case "mixed":
                  return this.finishNode(r2, "MixedTypeAnnotation");
                case "empty":
                  return this.finishNode(r2, "EmptyTypeAnnotation");
                case "number":
                  return this.finishNode(r2, "NumberTypeAnnotation");
                case "string":
                  return this.finishNode(r2, "StringTypeAnnotation");
                case "symbol":
                  return this.finishNode(r2, "SymbolTypeAnnotation");
                default:
                  return this.checkNotUnderscore(i2.name), this.flowParseGenericType(e2, s2, i2);
              }
            }
            flowParsePrimaryType() {
              let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.startNode(), i2, a, n = false, o = this.state.noAnonFunctionType;
              switch (this.state.type) {
                case 5:
                  return this.flowParseObjectType({ allowStatic: false, allowExact: false, allowSpread: true, allowProto: false, allowInexact: true });
                case 6:
                  return this.flowParseObjectType({ allowStatic: false, allowExact: true, allowSpread: true, allowProto: false, allowInexact: false });
                case 0:
                  return this.state.noAnonFunctionType = false, a = this.flowParseTupleType(), this.state.noAnonFunctionType = o, a;
                case 47:
                  return r2.typeParameters = this.flowParseTypeParameterDeclaration(), this.expect(10), i2 = this.flowParseFunctionTypeParams(), r2.params = i2.params, r2.rest = i2.rest, r2.this = i2._this, this.expect(11), this.expect(19), r2.returnType = this.flowParseType(), this.finishNode(r2, "FunctionTypeAnnotation");
                case 10:
                  if (this.next(), !this.match(11) && !this.match(21))
                    if (K(this.state.type) || this.match(78)) {
                      let c = this.lookahead().type;
                      n = c !== 17 && c !== 14;
                    } else
                      n = true;
                  if (n) {
                    if (this.state.noAnonFunctionType = false, a = this.flowParseType(), this.state.noAnonFunctionType = o, this.state.noAnonFunctionType || !(this.match(12) || this.match(11) && this.lookahead().type === 19))
                      return this.expect(11), a;
                    this.eat(12);
                  }
                  return a ? i2 = this.flowParseFunctionTypeParams([this.reinterpretTypeAsFunctionTypeParam(a)]) : i2 = this.flowParseFunctionTypeParams(), r2.params = i2.params, r2.rest = i2.rest, r2.this = i2._this, this.expect(11), this.expect(19), r2.returnType = this.flowParseType(), r2.typeParameters = null, this.finishNode(r2, "FunctionTypeAnnotation");
                case 129:
                  return this.parseLiteral(this.state.value, "StringLiteralTypeAnnotation");
                case 85:
                case 86:
                  return r2.value = this.match(85), this.next(), this.finishNode(r2, "BooleanLiteralTypeAnnotation");
                case 53:
                  if (this.state.value === "-") {
                    if (this.next(), this.match(130))
                      return this.parseLiteralAtNode(-this.state.value, "NumberLiteralTypeAnnotation", r2);
                    if (this.match(131))
                      return this.parseLiteralAtNode(-this.state.value, "BigIntLiteralTypeAnnotation", r2);
                    throw this.raise(I.UnexpectedSubtractionOperand, { at: this.state.startLoc });
                  }
                  throw this.unexpected();
                case 130:
                  return this.parseLiteral(this.state.value, "NumberLiteralTypeAnnotation");
                case 131:
                  return this.parseLiteral(this.state.value, "BigIntLiteralTypeAnnotation");
                case 88:
                  return this.next(), this.finishNode(r2, "VoidTypeAnnotation");
                case 84:
                  return this.next(), this.finishNode(r2, "NullLiteralTypeAnnotation");
                case 78:
                  return this.next(), this.finishNode(r2, "ThisTypeAnnotation");
                case 55:
                  return this.next(), this.finishNode(r2, "ExistsTypeAnnotation");
                case 87:
                  return this.flowParseTypeofType();
                default:
                  if (Ht(this.state.type)) {
                    let c = Pe(this.state.type);
                    return this.next(), super.createIdentifier(r2, c);
                  } else if (K(this.state.type))
                    return this.isContextual(125) ? this.flowParseInterfaceType() : this.flowIdentToTypeAnnotation(e2, s2, r2, this.parseIdentifier());
              }
              throw this.unexpected();
            }
            flowParsePostfixType() {
              let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.flowParsePrimaryType(), i2 = false;
              for (; (this.match(0) || this.match(18)) && !this.canInsertSemicolon(); ) {
                let a = this.startNodeAt(e2, s2), n = this.eat(18);
                i2 = i2 || n, this.expect(0), !n && this.match(3) ? (a.elementType = r2, this.next(), r2 = this.finishNode(a, "ArrayTypeAnnotation")) : (a.objectType = r2, a.indexType = this.flowParseType(), this.expect(3), i2 ? (a.optional = n, r2 = this.finishNode(a, "OptionalIndexedAccessType")) : r2 = this.finishNode(a, "IndexedAccessType"));
              }
              return r2;
            }
            flowParsePrefixType() {
              let e2 = this.startNode();
              return this.eat(17) ? (e2.typeAnnotation = this.flowParsePrefixType(), this.finishNode(e2, "NullableTypeAnnotation")) : this.flowParsePostfixType();
            }
            flowParseAnonFunctionWithoutParens() {
              let e2 = this.flowParsePrefixType();
              if (!this.state.noAnonFunctionType && this.eat(19)) {
                let s2 = this.startNodeAt(e2.start, e2.loc.start);
                return s2.params = [this.reinterpretTypeAsFunctionTypeParam(e2)], s2.rest = null, s2.this = null, s2.returnType = this.flowParseType(), s2.typeParameters = null, this.finishNode(s2, "FunctionTypeAnnotation");
              }
              return e2;
            }
            flowParseIntersectionType() {
              let e2 = this.startNode();
              this.eat(45);
              let s2 = this.flowParseAnonFunctionWithoutParens();
              for (e2.types = [s2]; this.eat(45); )
                e2.types.push(this.flowParseAnonFunctionWithoutParens());
              return e2.types.length === 1 ? s2 : this.finishNode(e2, "IntersectionTypeAnnotation");
            }
            flowParseUnionType() {
              let e2 = this.startNode();
              this.eat(43);
              let s2 = this.flowParseIntersectionType();
              for (e2.types = [s2]; this.eat(43); )
                e2.types.push(this.flowParseIntersectionType());
              return e2.types.length === 1 ? s2 : this.finishNode(e2, "UnionTypeAnnotation");
            }
            flowParseType() {
              let e2 = this.state.inType;
              this.state.inType = true;
              let s2 = this.flowParseUnionType();
              return this.state.inType = e2, s2;
            }
            flowParseTypeOrImplicitInstantiation() {
              if (this.state.type === 128 && this.state.value === "_") {
                let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.parseIdentifier();
                return this.flowParseGenericType(e2, s2, r2);
              } else
                return this.flowParseType();
            }
            flowParseTypeAnnotation() {
              let e2 = this.startNode();
              return e2.typeAnnotation = this.flowParseTypeInitialiser(), this.finishNode(e2, "TypeAnnotation");
            }
            flowParseTypeAnnotatableIdentifier(e2) {
              let s2 = e2 ? this.parseIdentifier() : this.flowParseRestrictedIdentifier();
              return this.match(14) && (s2.typeAnnotation = this.flowParseTypeAnnotation(), this.resetEndLocation(s2)), s2;
            }
            typeCastToParameter(e2) {
              return e2.expression.typeAnnotation = e2.typeAnnotation, this.resetEndLocation(e2.expression, e2.typeAnnotation.loc.end), e2.expression;
            }
            flowParseVariance() {
              let e2 = null;
              return this.match(53) && (e2 = this.startNode(), this.state.value === "+" ? e2.kind = "plus" : e2.kind = "minus", this.next(), this.finishNode(e2, "Variance")), e2;
            }
            parseFunctionBody(e2, s2) {
              let r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              return s2 ? this.forwardNoArrowParamsConversionAt(e2, () => super.parseFunctionBody(e2, true, r2)) : super.parseFunctionBody(e2, false, r2);
            }
            parseFunctionBodyAndFinish(e2, s2) {
              let r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              if (this.match(14)) {
                let i2 = this.startNode();
                [i2.typeAnnotation, e2.predicate] = this.flowParseTypeAndPredicateInitialiser(), e2.returnType = i2.typeAnnotation ? this.finishNode(i2, "TypeAnnotation") : null;
              }
              super.parseFunctionBodyAndFinish(e2, s2, r2);
            }
            parseStatement(e2, s2) {
              if (this.state.strict && this.isContextual(125)) {
                let i2 = this.lookahead();
                if (pe(i2.type)) {
                  let a = this.startNode();
                  return this.next(), this.flowParseInterface(a);
                }
              } else if (this.shouldParseEnums() && this.isContextual(122)) {
                let i2 = this.startNode();
                return this.next(), this.flowParseEnumDeclaration(i2);
              }
              let r2 = super.parseStatement(e2, s2);
              return this.flowPragma === void 0 && !this.isValidDirective(r2) && (this.flowPragma = null), r2;
            }
            parseExpressionStatement(e2, s2) {
              if (s2.type === "Identifier") {
                if (s2.name === "declare") {
                  if (this.match(80) || K(this.state.type) || this.match(68) || this.match(74) || this.match(82))
                    return this.flowParseDeclare(e2);
                } else if (K(this.state.type)) {
                  if (s2.name === "interface")
                    return this.flowParseInterface(e2);
                  if (s2.name === "type")
                    return this.flowParseTypeAlias(e2);
                  if (s2.name === "opaque")
                    return this.flowParseOpaqueType(e2, false);
                }
              }
              return super.parseExpressionStatement(e2, s2);
            }
            shouldParseExportDeclaration() {
              let { type: e2 } = this.state;
              return lr(e2) || this.shouldParseEnums() && e2 === 122 ? !this.state.containsEsc : super.shouldParseExportDeclaration();
            }
            isExportDefaultSpecifier() {
              let { type: e2 } = this.state;
              return lr(e2) || this.shouldParseEnums() && e2 === 122 ? this.state.containsEsc : super.isExportDefaultSpecifier();
            }
            parseExportDefaultExpression() {
              if (this.shouldParseEnums() && this.isContextual(122)) {
                let e2 = this.startNode();
                return this.next(), this.flowParseEnumDeclaration(e2);
              }
              return super.parseExportDefaultExpression();
            }
            parseConditional(e2, s2, r2, i2) {
              if (!this.match(17))
                return e2;
              if (this.state.maybeInArrowParameters) {
                let v = this.lookaheadCharCode();
                if (v === 44 || v === 61 || v === 58 || v === 41)
                  return this.setOptionalParametersError(i2), e2;
              }
              this.expect(17);
              let a = this.state.clone(), n = this.state.noArrowAt, o = this.startNodeAt(s2, r2), { consequent: c, failed: f3 } = this.tryParseConditionalConsequent(), [y, P] = this.getArrowLikeExpressions(c);
              if (f3 || P.length > 0) {
                let v = [...n];
                if (P.length > 0) {
                  this.state = a, this.state.noArrowAt = v;
                  for (let N = 0; N < P.length; N++)
                    v.push(P[N].start);
                  ({ consequent: c, failed: f3 } = this.tryParseConditionalConsequent()), [y, P] = this.getArrowLikeExpressions(c);
                }
                f3 && y.length > 1 && this.raise(I.AmbiguousConditionalArrow, { at: a.startLoc }), f3 && y.length === 1 && (this.state = a, v.push(y[0].start), this.state.noArrowAt = v, { consequent: c, failed: f3 } = this.tryParseConditionalConsequent());
              }
              return this.getArrowLikeExpressions(c, true), this.state.noArrowAt = n, this.expect(14), o.test = e2, o.consequent = c, o.alternate = this.forwardNoArrowParamsConversionAt(o, () => this.parseMaybeAssign(void 0, void 0)), this.finishNode(o, "ConditionalExpression");
            }
            tryParseConditionalConsequent() {
              this.state.noArrowParamsConversionAt.push(this.state.start);
              let e2 = this.parseMaybeAssignAllowIn(), s2 = !this.match(14);
              return this.state.noArrowParamsConversionAt.pop(), { consequent: e2, failed: s2 };
            }
            getArrowLikeExpressions(e2, s2) {
              let r2 = [e2], i2 = [];
              for (; r2.length !== 0; ) {
                let a = r2.pop();
                a.type === "ArrowFunctionExpression" ? (a.typeParameters || !a.returnType ? this.finishArrowValidation(a) : i2.push(a), r2.push(a.body)) : a.type === "ConditionalExpression" && (r2.push(a.consequent), r2.push(a.alternate));
              }
              return s2 ? (i2.forEach((a) => this.finishArrowValidation(a)), [i2, []]) : Ih(i2, (a) => a.params.every((n) => this.isAssignable(n, true)));
            }
            finishArrowValidation(e2) {
              var s2;
              this.toAssignableList(e2.params, (s2 = e2.extra) == null ? void 0 : s2.trailingCommaLoc, false), this.scope.enter(me | Jt), super.checkParams(e2, false, true), this.scope.exit();
            }
            forwardNoArrowParamsConversionAt(e2, s2) {
              let r2;
              return this.state.noArrowParamsConversionAt.indexOf(e2.start) !== -1 ? (this.state.noArrowParamsConversionAt.push(this.state.start), r2 = s2(), this.state.noArrowParamsConversionAt.pop()) : r2 = s2(), r2;
            }
            parseParenItem(e2, s2, r2) {
              if (e2 = super.parseParenItem(e2, s2, r2), this.eat(17) && (e2.optional = true, this.resetEndLocation(e2)), this.match(14)) {
                let i2 = this.startNodeAt(s2, r2);
                return i2.expression = e2, i2.typeAnnotation = this.flowParseTypeAnnotation(), this.finishNode(i2, "TypeCastExpression");
              }
              return e2;
            }
            assertModuleNodeAllowed(e2) {
              e2.type === "ImportDeclaration" && (e2.importKind === "type" || e2.importKind === "typeof") || e2.type === "ExportNamedDeclaration" && e2.exportKind === "type" || e2.type === "ExportAllDeclaration" && e2.exportKind === "type" || super.assertModuleNodeAllowed(e2);
            }
            parseExport(e2) {
              let s2 = super.parseExport(e2);
              return (s2.type === "ExportNamedDeclaration" || s2.type === "ExportAllDeclaration") && (s2.exportKind = s2.exportKind || "value"), s2;
            }
            parseExportDeclaration(e2) {
              if (this.isContextual(126)) {
                e2.exportKind = "type";
                let s2 = this.startNode();
                return this.next(), this.match(5) ? (e2.specifiers = this.parseExportSpecifiers(true), this.parseExportFrom(e2), null) : this.flowParseTypeAlias(s2);
              } else if (this.isContextual(127)) {
                e2.exportKind = "type";
                let s2 = this.startNode();
                return this.next(), this.flowParseOpaqueType(s2, false);
              } else if (this.isContextual(125)) {
                e2.exportKind = "type";
                let s2 = this.startNode();
                return this.next(), this.flowParseInterface(s2);
              } else if (this.shouldParseEnums() && this.isContextual(122)) {
                e2.exportKind = "value";
                let s2 = this.startNode();
                return this.next(), this.flowParseEnumDeclaration(s2);
              } else
                return super.parseExportDeclaration(e2);
            }
            eatExportStar(e2) {
              return super.eatExportStar(...arguments) ? true : this.isContextual(126) && this.lookahead().type === 55 ? (e2.exportKind = "type", this.next(), this.next(), true) : false;
            }
            maybeParseExportNamespaceSpecifier(e2) {
              let { startLoc: s2 } = this.state, r2 = super.maybeParseExportNamespaceSpecifier(e2);
              return r2 && e2.exportKind === "type" && this.unexpected(s2), r2;
            }
            parseClassId(e2, s2, r2) {
              super.parseClassId(e2, s2, r2), this.match(47) && (e2.typeParameters = this.flowParseTypeParameterDeclaration());
            }
            parseClassMember(e2, s2, r2) {
              let { startLoc: i2 } = this.state;
              if (this.isContextual(121)) {
                if (this.parseClassMemberFromModifier(e2, s2))
                  return;
                s2.declare = true;
              }
              super.parseClassMember(e2, s2, r2), s2.declare && (s2.type !== "ClassProperty" && s2.type !== "ClassPrivateProperty" && s2.type !== "PropertyDefinition" ? this.raise(I.DeclareClassElement, { at: i2 }) : s2.value && this.raise(I.DeclareClassFieldInitializer, { at: s2.value }));
            }
            isIterator(e2) {
              return e2 === "iterator" || e2 === "asyncIterator";
            }
            readIterator() {
              let e2 = super.readWord1(), s2 = "@@" + e2;
              (!this.isIterator(e2) || !this.state.inType) && this.raise(u.InvalidIdentifier, { at: this.state.curPosition(), identifierName: s2 }), this.finishToken(128, s2);
            }
            getTokenFromCode(e2) {
              let s2 = this.input.charCodeAt(this.state.pos + 1);
              return e2 === 123 && s2 === 124 ? this.finishOp(6, 2) : this.state.inType && (e2 === 62 || e2 === 60) ? this.finishOp(e2 === 62 ? 48 : 47, 1) : this.state.inType && e2 === 63 ? s2 === 46 ? this.finishOp(18, 2) : this.finishOp(17, 1) : Ko(e2, s2, this.input.charCodeAt(this.state.pos + 2)) ? (this.state.pos += 2, this.readIterator()) : super.getTokenFromCode(e2);
            }
            isAssignable(e2, s2) {
              return e2.type === "TypeCastExpression" ? this.isAssignable(e2.expression, s2) : super.isAssignable(e2, s2);
            }
            toAssignable(e2) {
              !(arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false) && e2.type === "AssignmentExpression" && e2.left.type === "TypeCastExpression" && (e2.left = this.typeCastToParameter(e2.left)), super.toAssignable(...arguments);
            }
            toAssignableList(e2, s2, r2) {
              for (let i2 = 0; i2 < e2.length; i2++) {
                let a = e2[i2];
                (a == null ? void 0 : a.type) === "TypeCastExpression" && (e2[i2] = this.typeCastToParameter(a));
              }
              super.toAssignableList(e2, s2, r2);
            }
            toReferencedList(e2, s2) {
              for (let i2 = 0; i2 < e2.length; i2++) {
                var r2;
                let a = e2[i2];
                a && a.type === "TypeCastExpression" && !((r2 = a.extra) != null && r2.parenthesized) && (e2.length > 1 || !s2) && this.raise(I.TypeCastInPattern, { at: a.typeAnnotation });
              }
              return e2;
            }
            parseArrayLike(e2, s2, r2, i2) {
              let a = super.parseArrayLike(e2, s2, r2, i2);
              return s2 && !this.state.maybeInArrowParameters && this.toReferencedList(a.elements), a;
            }
            isValidLVal(e2) {
              for (var s2 = arguments.length, r2 = new Array(s2 > 1 ? s2 - 1 : 0), i2 = 1; i2 < s2; i2++)
                r2[i2 - 1] = arguments[i2];
              return e2 === "TypeCastExpression" || super.isValidLVal(e2, ...r2);
            }
            parseClassProperty(e2) {
              return this.match(14) && (e2.typeAnnotation = this.flowParseTypeAnnotation()), super.parseClassProperty(e2);
            }
            parseClassPrivateProperty(e2) {
              return this.match(14) && (e2.typeAnnotation = this.flowParseTypeAnnotation()), super.parseClassPrivateProperty(e2);
            }
            isClassMethod() {
              return this.match(47) || super.isClassMethod();
            }
            isClassProperty() {
              return this.match(14) || super.isClassProperty();
            }
            isNonstaticConstructor(e2) {
              return !this.match(14) && super.isNonstaticConstructor(e2);
            }
            pushClassMethod(e2, s2, r2, i2, a, n) {
              if (s2.variance && this.unexpected(s2.variance.loc.start), delete s2.variance, this.match(47) && (s2.typeParameters = this.flowParseTypeParameterDeclaration()), super.pushClassMethod(e2, s2, r2, i2, a, n), s2.params && a) {
                let o = s2.params;
                o.length > 0 && this.isThisParam(o[0]) && this.raise(I.ThisParamBannedInConstructor, { at: s2 });
              } else if (s2.type === "MethodDefinition" && a && s2.value.params) {
                let o = s2.value.params;
                o.length > 0 && this.isThisParam(o[0]) && this.raise(I.ThisParamBannedInConstructor, { at: s2 });
              }
            }
            pushClassPrivateMethod(e2, s2, r2, i2) {
              s2.variance && this.unexpected(s2.variance.loc.start), delete s2.variance, this.match(47) && (s2.typeParameters = this.flowParseTypeParameterDeclaration()), super.pushClassPrivateMethod(e2, s2, r2, i2);
            }
            parseClassSuper(e2) {
              if (super.parseClassSuper(e2), e2.superClass && this.match(47) && (e2.superTypeParameters = this.flowParseTypeParameterInstantiation()), this.isContextual(110)) {
                this.next();
                let s2 = e2.implements = [];
                do {
                  let r2 = this.startNode();
                  r2.id = this.flowParseRestrictedIdentifier(true), this.match(47) ? r2.typeParameters = this.flowParseTypeParameterInstantiation() : r2.typeParameters = null, s2.push(this.finishNode(r2, "ClassImplements"));
                } while (this.eat(12));
              }
            }
            checkGetterSetterParams(e2) {
              super.checkGetterSetterParams(e2);
              let s2 = this.getObjectOrClassMethodParams(e2);
              if (s2.length > 0) {
                let r2 = s2[0];
                this.isThisParam(r2) && e2.kind === "get" ? this.raise(I.GetterMayNotHaveThisParam, { at: r2 }) : this.isThisParam(r2) && this.raise(I.SetterMayNotHaveThisParam, { at: r2 });
              }
            }
            parsePropertyNamePrefixOperator(e2) {
              e2.variance = this.flowParseVariance();
            }
            parseObjPropValue(e2, s2, r2, i2, a, n, o, c) {
              e2.variance && this.unexpected(e2.variance.loc.start), delete e2.variance;
              let f3;
              this.match(47) && !o && (f3 = this.flowParseTypeParameterDeclaration(), this.match(10) || this.unexpected()), super.parseObjPropValue(e2, s2, r2, i2, a, n, o, c), f3 && ((e2.value || e2).typeParameters = f3);
            }
            parseAssignableListItemTypes(e2) {
              return this.eat(17) && (e2.type !== "Identifier" && this.raise(I.PatternIsOptional, { at: e2 }), this.isThisParam(e2) && this.raise(I.ThisParamMayNotBeOptional, { at: e2 }), e2.optional = true), this.match(14) ? e2.typeAnnotation = this.flowParseTypeAnnotation() : this.isThisParam(e2) && this.raise(I.ThisParamAnnotationRequired, { at: e2 }), this.match(29) && this.isThisParam(e2) && this.raise(I.ThisParamNoDefault, { at: e2 }), this.resetEndLocation(e2), e2;
            }
            parseMaybeDefault(e2, s2, r2) {
              let i2 = super.parseMaybeDefault(e2, s2, r2);
              return i2.type === "AssignmentPattern" && i2.typeAnnotation && i2.right.start < i2.typeAnnotation.start && this.raise(I.TypeBeforeInitializer, { at: i2.typeAnnotation }), i2;
            }
            shouldParseDefaultImport(e2) {
              return cs(e2) ? Or(this.state.type) : super.shouldParseDefaultImport(e2);
            }
            parseImportSpecifierLocal(e2, s2, r2) {
              s2.local = cs(e2) ? this.flowParseRestrictedIdentifier(true, true) : this.parseIdentifier(), e2.specifiers.push(this.finishImportSpecifier(s2, r2));
            }
            maybeParseDefaultImportSpecifier(e2) {
              e2.importKind = "value";
              let s2 = null;
              if (this.match(87) ? s2 = "typeof" : this.isContextual(126) && (s2 = "type"), s2) {
                let r2 = this.lookahead(), { type: i2 } = r2;
                s2 === "type" && i2 === 55 && this.unexpected(null, r2.type), (Or(i2) || i2 === 5 || i2 === 55) && (this.next(), e2.importKind = s2);
              }
              return super.maybeParseDefaultImportSpecifier(e2);
            }
            parseImportSpecifier(e2, s2, r2, i2) {
              let a = e2.imported, n = null;
              a.type === "Identifier" && (a.name === "type" ? n = "type" : a.name === "typeof" && (n = "typeof"));
              let o = false;
              if (this.isContextual(93) && !this.isLookaheadContextual("as")) {
                let f3 = this.parseIdentifier(true);
                n !== null && !pe(this.state.type) ? (e2.imported = f3, e2.importKind = n, e2.local = ge(f3)) : (e2.imported = a, e2.importKind = null, e2.local = this.parseIdentifier());
              } else {
                if (n !== null && pe(this.state.type))
                  e2.imported = this.parseIdentifier(true), e2.importKind = n;
                else {
                  if (s2)
                    throw this.raise(u.ImportBindingIsString, { at: e2, importName: a.value });
                  e2.imported = a, e2.importKind = null;
                }
                this.eatContextual(93) ? e2.local = this.parseIdentifier() : (o = true, e2.local = ge(e2.imported));
              }
              let c = cs(e2);
              return r2 && c && this.raise(I.ImportTypeShorthandOnlyInPureImport, { at: e2 }), (r2 || c) && this.checkReservedType(e2.local.name, e2.local.loc.start, true), o && !r2 && !c && this.checkReservedWord(e2.local.name, e2.loc.start, true, true), this.finishImportSpecifier(e2, "ImportSpecifier");
            }
            parseBindingAtom() {
              switch (this.state.type) {
                case 78:
                  return this.parseIdentifier(true);
                default:
                  return super.parseBindingAtom();
              }
            }
            parseFunctionParams(e2, s2) {
              let r2 = e2.kind;
              r2 !== "get" && r2 !== "set" && this.match(47) && (e2.typeParameters = this.flowParseTypeParameterDeclaration()), super.parseFunctionParams(e2, s2);
            }
            parseVarId(e2, s2) {
              super.parseVarId(e2, s2), this.match(14) && (e2.id.typeAnnotation = this.flowParseTypeAnnotation(), this.resetEndLocation(e2.id));
            }
            parseAsyncArrowFromCallExpression(e2, s2) {
              if (this.match(14)) {
                let r2 = this.state.noAnonFunctionType;
                this.state.noAnonFunctionType = true, e2.returnType = this.flowParseTypeAnnotation(), this.state.noAnonFunctionType = r2;
              }
              return super.parseAsyncArrowFromCallExpression(e2, s2);
            }
            shouldParseAsyncArrow() {
              return this.match(14) || super.shouldParseAsyncArrow();
            }
            parseMaybeAssign(e2, s2) {
              var r2;
              let i2 = null, a;
              if (this.hasPlugin("jsx") && (this.match(138) || this.match(47))) {
                if (i2 = this.state.clone(), a = this.tryParse(() => super.parseMaybeAssign(e2, s2), i2), !a.error)
                  return a.node;
                let { context: c } = this.state, f3 = c[c.length - 1];
                (f3 === z.j_oTag || f3 === z.j_expr) && c.pop();
              }
              if ((r2 = a) != null && r2.error || this.match(47)) {
                var n, o;
                i2 = i2 || this.state.clone();
                let c, f3 = this.tryParse((P) => {
                  var v;
                  c = this.flowParseTypeParameterDeclaration();
                  let N = this.forwardNoArrowParamsConversionAt(c, () => {
                    let _ = super.parseMaybeAssign(e2, s2);
                    return this.resetStartLocationFromNode(_, c), _;
                  });
                  (v = N.extra) != null && v.parenthesized && P();
                  let B = this.maybeUnwrapTypeCastExpression(N);
                  return B.type !== "ArrowFunctionExpression" && P(), B.typeParameters = c, this.resetStartLocationFromNode(B, c), N;
                }, i2), y = null;
                if (f3.node && this.maybeUnwrapTypeCastExpression(f3.node).type === "ArrowFunctionExpression") {
                  if (!f3.error && !f3.aborted)
                    return f3.node.async && this.raise(I.UnexpectedTypeParameterBeforeAsyncArrowFunction, { at: c }), f3.node;
                  y = f3.node;
                }
                if ((n = a) != null && n.node)
                  return this.state = a.failState, a.node;
                if (y)
                  return this.state = f3.failState, y;
                throw (o = a) != null && o.thrown ? a.error : f3.thrown ? f3.error : this.raise(I.UnexpectedTokenAfterTypeParameter, { at: c });
              }
              return super.parseMaybeAssign(e2, s2);
            }
            parseArrow(e2) {
              if (this.match(14)) {
                let s2 = this.tryParse(() => {
                  let r2 = this.state.noAnonFunctionType;
                  this.state.noAnonFunctionType = true;
                  let i2 = this.startNode();
                  return [i2.typeAnnotation, e2.predicate] = this.flowParseTypeAndPredicateInitialiser(), this.state.noAnonFunctionType = r2, this.canInsertSemicolon() && this.unexpected(), this.match(19) || this.unexpected(), i2;
                });
                if (s2.thrown)
                  return null;
                s2.error && (this.state = s2.failState), e2.returnType = s2.node.typeAnnotation ? this.finishNode(s2.node, "TypeAnnotation") : null;
              }
              return super.parseArrow(e2);
            }
            shouldParseArrow(e2) {
              return this.match(14) || super.shouldParseArrow(e2);
            }
            setArrowFunctionParameters(e2, s2) {
              this.state.noArrowParamsConversionAt.indexOf(e2.start) !== -1 ? e2.params = s2 : super.setArrowFunctionParameters(e2, s2);
            }
            checkParams(e2, s2, r2) {
              if (!(r2 && this.state.noArrowParamsConversionAt.indexOf(e2.start) !== -1)) {
                for (let i2 = 0; i2 < e2.params.length; i2++)
                  this.isThisParam(e2.params[i2]) && i2 > 0 && this.raise(I.ThisParamMustBeFirst, { at: e2.params[i2] });
                return super.checkParams(...arguments);
              }
            }
            parseParenAndDistinguishExpression(e2) {
              return super.parseParenAndDistinguishExpression(e2 && this.state.noArrowAt.indexOf(this.state.start) === -1);
            }
            parseSubscripts(e2, s2, r2, i2) {
              if (e2.type === "Identifier" && e2.name === "async" && this.state.noArrowAt.indexOf(s2) !== -1) {
                this.next();
                let a = this.startNodeAt(s2, r2);
                a.callee = e2, a.arguments = this.parseCallExpressionArguments(11, false), e2 = this.finishNode(a, "CallExpression");
              } else if (e2.type === "Identifier" && e2.name === "async" && this.match(47)) {
                let a = this.state.clone(), n = this.tryParse((c) => this.parseAsyncArrowWithTypeParameters(s2, r2) || c(), a);
                if (!n.error && !n.aborted)
                  return n.node;
                let o = this.tryParse(() => super.parseSubscripts(e2, s2, r2, i2), a);
                if (o.node && !o.error)
                  return o.node;
                if (n.node)
                  return this.state = n.failState, n.node;
                if (o.node)
                  return this.state = o.failState, o.node;
                throw n.error || o.error;
              }
              return super.parseSubscripts(e2, s2, r2, i2);
            }
            parseSubscript(e2, s2, r2, i2, a) {
              if (this.match(18) && this.isLookaheadToken_lt()) {
                if (a.optionalChainMember = true, i2)
                  return a.stop = true, e2;
                this.next();
                let n = this.startNodeAt(s2, r2);
                return n.callee = e2, n.typeArguments = this.flowParseTypeParameterInstantiation(), this.expect(10), n.arguments = this.parseCallExpressionArguments(11, false), n.optional = true, this.finishCallExpression(n, true);
              } else if (!i2 && this.shouldParseTypes() && this.match(47)) {
                let n = this.startNodeAt(s2, r2);
                n.callee = e2;
                let o = this.tryParse(() => (n.typeArguments = this.flowParseTypeParameterInstantiationCallOrNew(), this.expect(10), n.arguments = this.parseCallExpressionArguments(11, false), a.optionalChainMember && (n.optional = false), this.finishCallExpression(n, a.optionalChainMember)));
                if (o.node)
                  return o.error && (this.state = o.failState), o.node;
              }
              return super.parseSubscript(e2, s2, r2, i2, a);
            }
            parseNewCallee(e2) {
              super.parseNewCallee(e2);
              let s2 = null;
              this.shouldParseTypes() && this.match(47) && (s2 = this.tryParse(() => this.flowParseTypeParameterInstantiationCallOrNew()).node), e2.typeArguments = s2;
            }
            parseAsyncArrowWithTypeParameters(e2, s2) {
              let r2 = this.startNodeAt(e2, s2);
              if (this.parseFunctionParams(r2), !!this.parseArrow(r2))
                return this.parseArrowExpression(r2, void 0, true);
            }
            readToken_mult_modulo(e2) {
              let s2 = this.input.charCodeAt(this.state.pos + 1);
              if (e2 === 42 && s2 === 47 && this.state.hasFlowComment) {
                this.state.hasFlowComment = false, this.state.pos += 2, this.nextToken();
                return;
              }
              super.readToken_mult_modulo(e2);
            }
            readToken_pipe_amp(e2) {
              let s2 = this.input.charCodeAt(this.state.pos + 1);
              if (e2 === 124 && s2 === 125) {
                this.finishOp(9, 2);
                return;
              }
              super.readToken_pipe_amp(e2);
            }
            parseTopLevel(e2, s2) {
              let r2 = super.parseTopLevel(e2, s2);
              return this.state.hasFlowComment && this.raise(I.UnterminatedFlowComment, { at: this.state.curPosition() }), r2;
            }
            skipBlockComment() {
              if (this.hasPlugin("flowComments") && this.skipFlowComment()) {
                if (this.state.hasFlowComment)
                  throw this.raise(I.NestedFlowComment, { at: this.state.startLoc });
                this.hasFlowCommentCompletion(), this.state.pos += this.skipFlowComment(), this.state.hasFlowComment = true;
                return;
              }
              if (this.state.hasFlowComment) {
                let e2 = this.input.indexOf("*-/", this.state.pos + 2);
                if (e2 === -1)
                  throw this.raise(u.UnterminatedComment, { at: this.state.curPosition() });
                this.state.pos = e2 + 2 + 3;
                return;
              }
              return super.skipBlockComment();
            }
            skipFlowComment() {
              let { pos: e2 } = this.state, s2 = 2;
              for (; [32, 9].includes(this.input.charCodeAt(e2 + s2)); )
                s2++;
              let r2 = this.input.charCodeAt(s2 + e2), i2 = this.input.charCodeAt(s2 + e2 + 1);
              return r2 === 58 && i2 === 58 ? s2 + 2 : this.input.slice(s2 + e2, s2 + e2 + 12) === "flow-include" ? s2 + 12 : r2 === 58 && i2 !== 58 ? s2 : false;
            }
            hasFlowCommentCompletion() {
              if (this.input.indexOf("*/", this.state.pos) === -1)
                throw this.raise(u.UnterminatedComment, { at: this.state.curPosition() });
            }
            flowEnumErrorBooleanMemberNotInitialized(e2, s2) {
              let { enumName: r2, memberName: i2 } = s2;
              this.raise(I.EnumBooleanMemberNotInitialized, { at: e2, memberName: i2, enumName: r2 });
            }
            flowEnumErrorInvalidMemberInitializer(e2, s2) {
              return this.raise(s2.explicitType ? s2.explicitType === "symbol" ? I.EnumInvalidMemberInitializerSymbolType : I.EnumInvalidMemberInitializerPrimaryType : I.EnumInvalidMemberInitializerUnknownType, Object.assign({ at: e2 }, s2));
            }
            flowEnumErrorNumberMemberNotInitialized(e2, s2) {
              let { enumName: r2, memberName: i2 } = s2;
              this.raise(I.EnumNumberMemberNotInitialized, { at: e2, enumName: r2, memberName: i2 });
            }
            flowEnumErrorStringMemberInconsistentlyInitailized(e2, s2) {
              let { enumName: r2 } = s2;
              this.raise(I.EnumStringMemberInconsistentlyInitailized, { at: e2, enumName: r2 });
            }
            flowEnumMemberInit() {
              let e2 = this.state.startLoc, s2 = () => this.match(12) || this.match(8);
              switch (this.state.type) {
                case 130: {
                  let r2 = this.parseNumericLiteral(this.state.value);
                  return s2() ? { type: "number", loc: r2.loc.start, value: r2 } : { type: "invalid", loc: e2 };
                }
                case 129: {
                  let r2 = this.parseStringLiteral(this.state.value);
                  return s2() ? { type: "string", loc: r2.loc.start, value: r2 } : { type: "invalid", loc: e2 };
                }
                case 85:
                case 86: {
                  let r2 = this.parseBooleanLiteral(this.match(85));
                  return s2() ? { type: "boolean", loc: r2.loc.start, value: r2 } : { type: "invalid", loc: e2 };
                }
                default:
                  return { type: "invalid", loc: e2 };
              }
            }
            flowEnumMemberRaw() {
              let e2 = this.state.startLoc, s2 = this.parseIdentifier(true), r2 = this.eat(29) ? this.flowEnumMemberInit() : { type: "none", loc: e2 };
              return { id: s2, init: r2 };
            }
            flowEnumCheckExplicitTypeMismatch(e2, s2, r2) {
              let { explicitType: i2 } = s2;
              i2 !== null && i2 !== r2 && this.flowEnumErrorInvalidMemberInitializer(e2, s2);
            }
            flowEnumMembers(e2) {
              let { enumName: s2, explicitType: r2 } = e2, i2 = /* @__PURE__ */ new Set(), a = { booleanMembers: [], numberMembers: [], stringMembers: [], defaultedMembers: [] }, n = false;
              for (; !this.match(8); ) {
                if (this.eat(21)) {
                  n = true;
                  break;
                }
                let o = this.startNode(), { id: c, init: f3 } = this.flowEnumMemberRaw(), y = c.name;
                if (y === "")
                  continue;
                /^[a-z]/.test(y) && this.raise(I.EnumInvalidMemberName, { at: c, memberName: y, suggestion: y[0].toUpperCase() + y.slice(1), enumName: s2 }), i2.has(y) && this.raise(I.EnumDuplicateMemberName, { at: c, memberName: y, enumName: s2 }), i2.add(y);
                let P = { enumName: s2, explicitType: r2, memberName: y };
                switch (o.id = c, f3.type) {
                  case "boolean": {
                    this.flowEnumCheckExplicitTypeMismatch(f3.loc, P, "boolean"), o.init = f3.value, a.booleanMembers.push(this.finishNode(o, "EnumBooleanMember"));
                    break;
                  }
                  case "number": {
                    this.flowEnumCheckExplicitTypeMismatch(f3.loc, P, "number"), o.init = f3.value, a.numberMembers.push(this.finishNode(o, "EnumNumberMember"));
                    break;
                  }
                  case "string": {
                    this.flowEnumCheckExplicitTypeMismatch(f3.loc, P, "string"), o.init = f3.value, a.stringMembers.push(this.finishNode(o, "EnumStringMember"));
                    break;
                  }
                  case "invalid":
                    throw this.flowEnumErrorInvalidMemberInitializer(f3.loc, P);
                  case "none":
                    switch (r2) {
                      case "boolean":
                        this.flowEnumErrorBooleanMemberNotInitialized(f3.loc, P);
                        break;
                      case "number":
                        this.flowEnumErrorNumberMemberNotInitialized(f3.loc, P);
                        break;
                      default:
                        a.defaultedMembers.push(this.finishNode(o, "EnumDefaultedMember"));
                    }
                }
                this.match(8) || this.expect(12);
              }
              return { members: a, hasUnknownMembers: n };
            }
            flowEnumStringMembers(e2, s2, r2) {
              let { enumName: i2 } = r2;
              if (e2.length === 0)
                return s2;
              if (s2.length === 0)
                return e2;
              if (s2.length > e2.length) {
                for (let a of e2)
                  this.flowEnumErrorStringMemberInconsistentlyInitailized(a, { enumName: i2 });
                return s2;
              } else {
                for (let a of s2)
                  this.flowEnumErrorStringMemberInconsistentlyInitailized(a, { enumName: i2 });
                return e2;
              }
            }
            flowEnumParseExplicitType(e2) {
              let { enumName: s2 } = e2;
              if (!this.eatContextual(101))
                return null;
              if (!K(this.state.type))
                throw this.raise(I.EnumInvalidExplicitTypeUnknownSupplied, { at: this.state.startLoc, enumName: s2 });
              let { value: r2 } = this.state;
              return this.next(), r2 !== "boolean" && r2 !== "number" && r2 !== "string" && r2 !== "symbol" && this.raise(I.EnumInvalidExplicitType, { at: this.state.startLoc, enumName: s2, invalidEnumType: r2 }), r2;
            }
            flowEnumBody(e2, s2) {
              let r2 = s2.name, i2 = s2.loc.start, a = this.flowEnumParseExplicitType({ enumName: r2 });
              this.expect(5);
              let { members: n, hasUnknownMembers: o } = this.flowEnumMembers({ enumName: r2, explicitType: a });
              switch (e2.hasUnknownMembers = o, a) {
                case "boolean":
                  return e2.explicitType = true, e2.members = n.booleanMembers, this.expect(8), this.finishNode(e2, "EnumBooleanBody");
                case "number":
                  return e2.explicitType = true, e2.members = n.numberMembers, this.expect(8), this.finishNode(e2, "EnumNumberBody");
                case "string":
                  return e2.explicitType = true, e2.members = this.flowEnumStringMembers(n.stringMembers, n.defaultedMembers, { enumName: r2 }), this.expect(8), this.finishNode(e2, "EnumStringBody");
                case "symbol":
                  return e2.members = n.defaultedMembers, this.expect(8), this.finishNode(e2, "EnumSymbolBody");
                default: {
                  let c = () => (e2.members = [], this.expect(8), this.finishNode(e2, "EnumStringBody"));
                  e2.explicitType = false;
                  let f3 = n.booleanMembers.length, y = n.numberMembers.length, P = n.stringMembers.length, v = n.defaultedMembers.length;
                  if (!f3 && !y && !P && !v)
                    return c();
                  if (!f3 && !y)
                    return e2.members = this.flowEnumStringMembers(n.stringMembers, n.defaultedMembers, { enumName: r2 }), this.expect(8), this.finishNode(e2, "EnumStringBody");
                  if (!y && !P && f3 >= v) {
                    for (let N of n.defaultedMembers)
                      this.flowEnumErrorBooleanMemberNotInitialized(N.loc.start, { enumName: r2, memberName: N.id.name });
                    return e2.members = n.booleanMembers, this.expect(8), this.finishNode(e2, "EnumBooleanBody");
                  } else if (!f3 && !P && y >= v) {
                    for (let N of n.defaultedMembers)
                      this.flowEnumErrorNumberMemberNotInitialized(N.loc.start, { enumName: r2, memberName: N.id.name });
                    return e2.members = n.numberMembers, this.expect(8), this.finishNode(e2, "EnumNumberBody");
                  } else
                    return this.raise(I.EnumInconsistentMemberValues, { at: i2, enumName: r2 }), c();
                }
              }
            }
            flowParseEnumDeclaration(e2) {
              let s2 = this.parseIdentifier();
              return e2.id = s2, e2.body = this.flowEnumBody(this.startNode(), s2), this.finishNode(e2, "EnumDeclaration");
            }
            isLookaheadToken_lt() {
              let e2 = this.nextTokenStart();
              if (this.input.charCodeAt(e2) === 60) {
                let s2 = this.input.charCodeAt(e2 + 1);
                return s2 !== 60 && s2 !== 61;
              }
              return false;
            }
            maybeUnwrapTypeCastExpression(e2) {
              return e2.type === "TypeCastExpression" ? e2.expression : e2;
            }
          }, Fh = { __proto__: null, quot: '"', amp: "&", apos: "'", lt: "<", gt: ">", nbsp: "\xA0", iexcl: "\xA1", cent: "\xA2", pound: "\xA3", curren: "\xA4", yen: "\xA5", brvbar: "\xA6", sect: "\xA7", uml: "\xA8", copy: "\xA9", ordf: "\xAA", laquo: "\xAB", not: "\xAC", shy: "\xAD", reg: "\xAE", macr: "\xAF", deg: "\xB0", plusmn: "\xB1", sup2: "\xB2", sup3: "\xB3", acute: "\xB4", micro: "\xB5", para: "\xB6", middot: "\xB7", cedil: "\xB8", sup1: "\xB9", ordm: "\xBA", raquo: "\xBB", frac14: "\xBC", frac12: "\xBD", frac34: "\xBE", iquest: "\xBF", Agrave: "\xC0", Aacute: "\xC1", Acirc: "\xC2", Atilde: "\xC3", Auml: "\xC4", Aring: "\xC5", AElig: "\xC6", Ccedil: "\xC7", Egrave: "\xC8", Eacute: "\xC9", Ecirc: "\xCA", Euml: "\xCB", Igrave: "\xCC", Iacute: "\xCD", Icirc: "\xCE", Iuml: "\xCF", ETH: "\xD0", Ntilde: "\xD1", Ograve: "\xD2", Oacute: "\xD3", Ocirc: "\xD4", Otilde: "\xD5", Ouml: "\xD6", times: "\xD7", Oslash: "\xD8", Ugrave: "\xD9", Uacute: "\xDA", Ucirc: "\xDB", Uuml: "\xDC", Yacute: "\xDD", THORN: "\xDE", szlig: "\xDF", agrave: "\xE0", aacute: "\xE1", acirc: "\xE2", atilde: "\xE3", auml: "\xE4", aring: "\xE5", aelig: "\xE6", ccedil: "\xE7", egrave: "\xE8", eacute: "\xE9", ecirc: "\xEA", euml: "\xEB", igrave: "\xEC", iacute: "\xED", icirc: "\xEE", iuml: "\xEF", eth: "\xF0", ntilde: "\xF1", ograve: "\xF2", oacute: "\xF3", ocirc: "\xF4", otilde: "\xF5", ouml: "\xF6", divide: "\xF7", oslash: "\xF8", ugrave: "\xF9", uacute: "\xFA", ucirc: "\xFB", uuml: "\xFC", yacute: "\xFD", thorn: "\xFE", yuml: "\xFF", OElig: "\u0152", oelig: "\u0153", Scaron: "\u0160", scaron: "\u0161", Yuml: "\u0178", fnof: "\u0192", circ: "\u02C6", tilde: "\u02DC", Alpha: "\u0391", Beta: "\u0392", Gamma: "\u0393", Delta: "\u0394", Epsilon: "\u0395", Zeta: "\u0396", Eta: "\u0397", Theta: "\u0398", Iota: "\u0399", Kappa: "\u039A", Lambda: "\u039B", Mu: "\u039C", Nu: "\u039D", Xi: "\u039E", Omicron: "\u039F", Pi: "\u03A0", Rho: "\u03A1", Sigma: "\u03A3", Tau: "\u03A4", Upsilon: "\u03A5", Phi: "\u03A6", Chi: "\u03A7", Psi: "\u03A8", Omega: "\u03A9", alpha: "\u03B1", beta: "\u03B2", gamma: "\u03B3", delta: "\u03B4", epsilon: "\u03B5", zeta: "\u03B6", eta: "\u03B7", theta: "\u03B8", iota: "\u03B9", kappa: "\u03BA", lambda: "\u03BB", mu: "\u03BC", nu: "\u03BD", xi: "\u03BE", omicron: "\u03BF", pi: "\u03C0", rho: "\u03C1", sigmaf: "\u03C2", sigma: "\u03C3", tau: "\u03C4", upsilon: "\u03C5", phi: "\u03C6", chi: "\u03C7", psi: "\u03C8", omega: "\u03C9", thetasym: "\u03D1", upsih: "\u03D2", piv: "\u03D6", ensp: "\u2002", emsp: "\u2003", thinsp: "\u2009", zwnj: "\u200C", zwj: "\u200D", lrm: "\u200E", rlm: "\u200F", ndash: "\u2013", mdash: "\u2014", lsquo: "\u2018", rsquo: "\u2019", sbquo: "\u201A", ldquo: "\u201C", rdquo: "\u201D", bdquo: "\u201E", dagger: "\u2020", Dagger: "\u2021", bull: "\u2022", hellip: "\u2026", permil: "\u2030", prime: "\u2032", Prime: "\u2033", lsaquo: "\u2039", rsaquo: "\u203A", oline: "\u203E", frasl: "\u2044", euro: "\u20AC", image: "\u2111", weierp: "\u2118", real: "\u211C", trade: "\u2122", alefsym: "\u2135", larr: "\u2190", uarr: "\u2191", rarr: "\u2192", darr: "\u2193", harr: "\u2194", crarr: "\u21B5", lArr: "\u21D0", uArr: "\u21D1", rArr: "\u21D2", dArr: "\u21D3", hArr: "\u21D4", forall: "\u2200", part: "\u2202", exist: "\u2203", empty: "\u2205", nabla: "\u2207", isin: "\u2208", notin: "\u2209", ni: "\u220B", prod: "\u220F", sum: "\u2211", minus: "\u2212", lowast: "\u2217", radic: "\u221A", prop: "\u221D", infin: "\u221E", ang: "\u2220", and: "\u2227", or: "\u2228", cap: "\u2229", cup: "\u222A", int: "\u222B", there4: "\u2234", sim: "\u223C", cong: "\u2245", asymp: "\u2248", ne: "\u2260", equiv: "\u2261", le: "\u2264", ge: "\u2265", sub: "\u2282", sup: "\u2283", nsub: "\u2284", sube: "\u2286", supe: "\u2287", oplus: "\u2295", otimes: "\u2297", perp: "\u22A5", sdot: "\u22C5", lceil: "\u2308", rceil: "\u2309", lfloor: "\u230A", rfloor: "\u230B", lang: "\u2329", rang: "\u232A", loz: "\u25CA", spades: "\u2660", clubs: "\u2663", hearts: "\u2665", diams: "\u2666" }, Ie = j(Kn || (Kn = rt(["jsx"])))((t2) => ({ AttributeIsEmpty: t2("JSX attributes must only be assigned a non-empty expression."), MissingClosingTagElement: t2((e2) => {
            let { openingTagName: s2 } = e2;
            return "Expected corresponding JSX closing tag for <".concat(s2, ">.");
          }), MissingClosingTagFragment: t2("Expected corresponding JSX closing tag for <>."), UnexpectedSequenceExpression: t2("Sequence expressions cannot be directly nested inside JSX. Did you mean to wrap it in parentheses (...)?"), UnexpectedToken: t2((e2) => {
            let { unexpected: s2, HTMLEntity: r2 } = e2;
            return "Unexpected token `".concat(s2, "`. Did you mean `").concat(r2, "` or `{'").concat(s2, "'}`?");
          }), UnsupportedJsxValue: t2("JSX value should be either an expression or a quoted JSX text."), UnterminatedJsxContent: t2("Unterminated JSX contents."), UnwrappedAdjacentJSXElements: t2("Adjacent JSX elements must be wrapped in an enclosing tag. Did you want a JSX fragment <>...</>?") }));
          function Ce(t2) {
            return t2 ? t2.type === "JSXOpeningFragment" || t2.type === "JSXClosingFragment" : false;
          }
          function Ue(t2) {
            if (t2.type === "JSXIdentifier")
              return t2.name;
            if (t2.type === "JSXNamespacedName")
              return t2.namespace.name + ":" + t2.name.name;
            if (t2.type === "JSXMemberExpression")
              return Ue(t2.object) + "." + Ue(t2.property);
            throw new Error("Node had unexpected type: " + t2.type);
          }
          var Lh = (t2) => class extends t2 {
            jsxReadToken() {
              let e2 = "", s2 = this.state.pos;
              for (; ; ) {
                if (this.state.pos >= this.length)
                  throw this.raise(Ie.UnterminatedJsxContent, { at: this.state.startLoc });
                let r2 = this.input.charCodeAt(this.state.pos);
                switch (r2) {
                  case 60:
                  case 123:
                    return this.state.pos === this.state.start ? r2 === 60 && this.state.canStartJSXElement ? (++this.state.pos, this.finishToken(138)) : super.getTokenFromCode(r2) : (e2 += this.input.slice(s2, this.state.pos), this.finishToken(137, e2));
                  case 38:
                    e2 += this.input.slice(s2, this.state.pos), e2 += this.jsxReadEntity(), s2 = this.state.pos;
                    break;
                  case 62:
                  case 125:
                  default:
                    Ne(r2) ? (e2 += this.input.slice(s2, this.state.pos), e2 += this.jsxReadNewLine(true), s2 = this.state.pos) : ++this.state.pos;
                }
              }
            }
            jsxReadNewLine(e2) {
              let s2 = this.input.charCodeAt(this.state.pos), r2;
              return ++this.state.pos, s2 === 13 && this.input.charCodeAt(this.state.pos) === 10 ? (++this.state.pos, r2 = e2 ? `
` : `\r
`) : r2 = String.fromCharCode(s2), ++this.state.curLine, this.state.lineStart = this.state.pos, r2;
            }
            jsxReadString(e2) {
              let s2 = "", r2 = ++this.state.pos;
              for (; ; ) {
                if (this.state.pos >= this.length)
                  throw this.raise(u.UnterminatedString, { at: this.state.startLoc });
                let i2 = this.input.charCodeAt(this.state.pos);
                if (i2 === e2)
                  break;
                i2 === 38 ? (s2 += this.input.slice(r2, this.state.pos), s2 += this.jsxReadEntity(), r2 = this.state.pos) : Ne(i2) ? (s2 += this.input.slice(r2, this.state.pos), s2 += this.jsxReadNewLine(false), r2 = this.state.pos) : ++this.state.pos;
              }
              return s2 += this.input.slice(r2, this.state.pos++), this.finishToken(129, s2);
            }
            jsxReadEntity() {
              let e2 = ++this.state.pos;
              if (this.codePointAtPos(this.state.pos) === 35) {
                ++this.state.pos;
                let s2 = 10;
                this.codePointAtPos(this.state.pos) === 120 && (s2 = 16, ++this.state.pos);
                let r2 = this.readInt(s2, void 0, false, "bail");
                if (r2 !== null && this.codePointAtPos(this.state.pos) === 59)
                  return ++this.state.pos, String.fromCodePoint(r2);
              } else {
                let s2 = 0, r2 = false;
                for (; s2++ < 10 && this.state.pos < this.length && !(r2 = this.codePointAtPos(this.state.pos) == 59); )
                  ++this.state.pos;
                if (r2) {
                  let i2 = this.input.slice(e2, this.state.pos), a = Fh[i2];
                  if (++this.state.pos, a)
                    return a;
                }
              }
              return this.state.pos = e2, "&";
            }
            jsxReadWord() {
              let e2, s2 = this.state.pos;
              do
                e2 = this.input.charCodeAt(++this.state.pos);
              while (Be(e2) || e2 === 45);
              return this.finishToken(136, this.input.slice(s2, this.state.pos));
            }
            jsxParseIdentifier() {
              let e2 = this.startNode();
              return this.match(136) ? e2.name = this.state.value : Ht(this.state.type) ? e2.name = Pe(this.state.type) : this.unexpected(), this.next(), this.finishNode(e2, "JSXIdentifier");
            }
            jsxParseNamespacedName() {
              let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.jsxParseIdentifier();
              if (!this.eat(14))
                return r2;
              let i2 = this.startNodeAt(e2, s2);
              return i2.namespace = r2, i2.name = this.jsxParseIdentifier(), this.finishNode(i2, "JSXNamespacedName");
            }
            jsxParseElementName() {
              let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.jsxParseNamespacedName();
              if (r2.type === "JSXNamespacedName")
                return r2;
              for (; this.eat(16); ) {
                let i2 = this.startNodeAt(e2, s2);
                i2.object = r2, i2.property = this.jsxParseIdentifier(), r2 = this.finishNode(i2, "JSXMemberExpression");
              }
              return r2;
            }
            jsxParseAttributeValue() {
              let e2;
              switch (this.state.type) {
                case 5:
                  return e2 = this.startNode(), this.setContext(z.brace), this.next(), e2 = this.jsxParseExpressionContainer(e2, z.j_oTag), e2.expression.type === "JSXEmptyExpression" && this.raise(Ie.AttributeIsEmpty, { at: e2 }), e2;
                case 138:
                case 129:
                  return this.parseExprAtom();
                default:
                  throw this.raise(Ie.UnsupportedJsxValue, { at: this.state.startLoc });
              }
            }
            jsxParseEmptyExpression() {
              let e2 = this.startNodeAt(this.state.lastTokEndLoc.index, this.state.lastTokEndLoc);
              return this.finishNodeAt(e2, "JSXEmptyExpression", this.state.startLoc);
            }
            jsxParseSpreadChild(e2) {
              return this.next(), e2.expression = this.parseExpression(), this.setContext(z.j_oTag), this.state.canStartJSXElement = true, this.expect(8), this.finishNode(e2, "JSXSpreadChild");
            }
            jsxParseExpressionContainer(e2, s2) {
              if (this.match(8))
                e2.expression = this.jsxParseEmptyExpression();
              else {
                let r2 = this.parseExpression();
                e2.expression = r2;
              }
              return this.setContext(s2), this.state.canStartJSXElement = true, this.expect(8), this.finishNode(e2, "JSXExpressionContainer");
            }
            jsxParseAttribute() {
              let e2 = this.startNode();
              return this.match(5) ? (this.setContext(z.brace), this.next(), this.expect(21), e2.argument = this.parseMaybeAssignAllowIn(), this.setContext(z.j_oTag), this.state.canStartJSXElement = true, this.expect(8), this.finishNode(e2, "JSXSpreadAttribute")) : (e2.name = this.jsxParseNamespacedName(), e2.value = this.eat(29) ? this.jsxParseAttributeValue() : null, this.finishNode(e2, "JSXAttribute"));
            }
            jsxParseOpeningElementAt(e2, s2) {
              let r2 = this.startNodeAt(e2, s2);
              return this.eat(139) ? this.finishNode(r2, "JSXOpeningFragment") : (r2.name = this.jsxParseElementName(), this.jsxParseOpeningElementAfterName(r2));
            }
            jsxParseOpeningElementAfterName(e2) {
              let s2 = [];
              for (; !this.match(56) && !this.match(139); )
                s2.push(this.jsxParseAttribute());
              return e2.attributes = s2, e2.selfClosing = this.eat(56), this.expect(139), this.finishNode(e2, "JSXOpeningElement");
            }
            jsxParseClosingElementAt(e2, s2) {
              let r2 = this.startNodeAt(e2, s2);
              return this.eat(139) ? this.finishNode(r2, "JSXClosingFragment") : (r2.name = this.jsxParseElementName(), this.expect(139), this.finishNode(r2, "JSXClosingElement"));
            }
            jsxParseElementAt(e2, s2) {
              let r2 = this.startNodeAt(e2, s2), i2 = [], a = this.jsxParseOpeningElementAt(e2, s2), n = null;
              if (!a.selfClosing) {
                e:
                  for (; ; )
                    switch (this.state.type) {
                      case 138:
                        if (e2 = this.state.start, s2 = this.state.startLoc, this.next(), this.eat(56)) {
                          n = this.jsxParseClosingElementAt(e2, s2);
                          break e;
                        }
                        i2.push(this.jsxParseElementAt(e2, s2));
                        break;
                      case 137:
                        i2.push(this.parseExprAtom());
                        break;
                      case 5: {
                        let o = this.startNode();
                        this.setContext(z.brace), this.next(), this.match(21) ? i2.push(this.jsxParseSpreadChild(o)) : i2.push(this.jsxParseExpressionContainer(o, z.j_expr));
                        break;
                      }
                      default:
                        throw this.unexpected();
                    }
                Ce(a) && !Ce(n) && n !== null ? this.raise(Ie.MissingClosingTagFragment, { at: n }) : !Ce(a) && Ce(n) ? this.raise(Ie.MissingClosingTagElement, { at: n, openingTagName: Ue(a.name) }) : !Ce(a) && !Ce(n) && Ue(n.name) !== Ue(a.name) && this.raise(Ie.MissingClosingTagElement, { at: n, openingTagName: Ue(a.name) });
              }
              if (Ce(a) ? (r2.openingFragment = a, r2.closingFragment = n) : (r2.openingElement = a, r2.closingElement = n), r2.children = i2, this.match(47))
                throw this.raise(Ie.UnwrappedAdjacentJSXElements, { at: this.state.startLoc });
              return Ce(a) ? this.finishNode(r2, "JSXFragment") : this.finishNode(r2, "JSXElement");
            }
            jsxParseElement() {
              let e2 = this.state.start, s2 = this.state.startLoc;
              return this.next(), this.jsxParseElementAt(e2, s2);
            }
            setContext(e2) {
              let { context: s2 } = this.state;
              s2[s2.length - 1] = e2;
            }
            parseExprAtom(e2) {
              return this.match(137) ? this.parseLiteral(this.state.value, "JSXText") : this.match(138) ? this.jsxParseElement() : this.match(47) && this.input.charCodeAt(this.state.pos) !== 33 ? (this.replaceToken(138), this.jsxParseElement()) : super.parseExprAtom(e2);
            }
            skipSpace() {
              this.curContext().preserveSpace || super.skipSpace();
            }
            getTokenFromCode(e2) {
              let s2 = this.curContext();
              if (s2 === z.j_expr)
                return this.jsxReadToken();
              if (s2 === z.j_oTag || s2 === z.j_cTag) {
                if (de(e2))
                  return this.jsxReadWord();
                if (e2 === 62)
                  return ++this.state.pos, this.finishToken(139);
                if ((e2 === 34 || e2 === 39) && s2 === z.j_oTag)
                  return this.jsxReadString(e2);
              }
              return e2 === 60 && this.state.canStartJSXElement && this.input.charCodeAt(this.state.pos + 1) !== 33 ? (++this.state.pos, this.finishToken(138)) : super.getTokenFromCode(e2);
            }
            updateContext(e2) {
              let { context: s2, type: r2 } = this.state;
              if (r2 === 56 && e2 === 138)
                s2.splice(-2, 2, z.j_cTag), this.state.canStartJSXElement = false;
              else if (r2 === 138)
                s2.push(z.j_oTag);
              else if (r2 === 139) {
                let i2 = s2[s2.length - 1];
                i2 === z.j_oTag && e2 === 56 || i2 === z.j_cTag ? (s2.pop(), this.state.canStartJSXElement = s2[s2.length - 1] === z.j_expr) : (this.setContext(z.j_expr), this.state.canStartJSXElement = true);
              } else
                this.state.canStartJSXElement = So(r2);
            }
          }, Oh = class extends os {
            constructor() {
              super(...arguments), this.types = /* @__PURE__ */ new Set(), this.enums = /* @__PURE__ */ new Set(), this.constEnums = /* @__PURE__ */ new Set(), this.classes = /* @__PURE__ */ new Set(), this.exportOnlyBindings = /* @__PURE__ */ new Set();
            }
          }, Bh = class extends hs {
            createScope(t2) {
              return new Oh(t2);
            }
            declareName(t2, e2, s2) {
              let r2 = this.currentScope();
              if (e2 & Zt) {
                this.maybeExportDefined(r2, t2), r2.exportOnlyBindings.add(t2);
                return;
              }
              super.declareName(...arguments), e2 & Re && (e2 & ye || (this.checkRedeclarationInScope(r2, t2, e2, s2), this.maybeExportDefined(r2, t2)), r2.types.add(t2)), e2 & $t && r2.enums.add(t2), e2 & Qt && r2.constEnums.add(t2), e2 & ct && r2.classes.add(t2);
            }
            isRedeclaredInScope(t2, e2, s2) {
              if (t2.enums.has(e2)) {
                if (s2 & $t) {
                  let r2 = !!(s2 & Qt), i2 = t2.constEnums.has(e2);
                  return r2 !== i2;
                }
                return true;
              }
              return s2 & ct && t2.classes.has(e2) ? t2.lexical.has(e2) ? !!(s2 & ye) : false : s2 & Re && t2.types.has(e2) ? true : super.isRedeclaredInScope(...arguments);
            }
            checkLocalExport(t2) {
              let e2 = this.scopeStack[0], { name: s2 } = t2;
              !e2.types.has(s2) && !e2.exportOnlyBindings.has(s2) && super.checkLocalExport(t2);
            }
          }, Mh = (t2, e2) => Object.hasOwnProperty.call(t2, e2) && t2[e2];
          function Rh(t2) {
            if (t2 == null)
              throw new Error("Unexpected ".concat(t2, " value."));
            return t2;
          }
          function Br(t2) {
            if (!t2)
              throw new Error("Assert fail");
          }
          function jh(t2) {
            return Vt(t2) || Oo(t2);
          }
          var S2 = j(Vn || (Vn = rt(["typescript"])))((t2) => ({ AbstractMethodHasImplementation: t2((e2) => {
            let { methodName: s2 } = e2;
            return "Method '".concat(s2, "' cannot have an implementation because it is marked abstract.");
          }), AbstractPropertyHasInitializer: t2((e2) => {
            let { propertyName: s2 } = e2;
            return "Property '".concat(s2, "' cannot have an initializer because it is marked abstract.");
          }), AccesorCannotDeclareThisParameter: t2("'get' and 'set' accessors cannot declare 'this' parameters."), AccesorCannotHaveTypeParameters: t2("An accessor cannot have type parameters."), CannotFindName: t2((e2) => {
            let { name: s2 } = e2;
            return "Cannot find name '".concat(s2, "'.");
          }), ClassMethodHasDeclare: t2("Class methods cannot have the 'declare' modifier."), ClassMethodHasReadonly: t2("Class methods cannot have the 'readonly' modifier."), ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference: t2("A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."), ConstructorHasTypeParameters: t2("Type parameters cannot appear on a constructor declaration."), DeclareAccessor: t2((e2) => {
            let { kind: s2 } = e2;
            return "'declare' is not allowed in ".concat(s2, "ters.");
          }), DeclareClassFieldHasInitializer: t2("Initializers are not allowed in ambient contexts."), DeclareFunctionHasImplementation: t2("An implementation cannot be declared in ambient contexts."), DuplicateAccessibilityModifier: t2((e2) => {
            let { modifier: s2 } = e2;
            return "Accessibility modifier already seen.";
          }), DuplicateModifier: t2((e2) => {
            let { modifier: s2 } = e2;
            return "Duplicate modifier: '".concat(s2, "'.");
          }), EmptyHeritageClauseType: t2((e2) => {
            let { token: s2 } = e2;
            return "'".concat(s2, "' list cannot be empty.");
          }), EmptyTypeArguments: t2("Type argument list cannot be empty."), EmptyTypeParameters: t2("Type parameter list cannot be empty."), ExpectedAmbientAfterExportDeclare: t2("'export declare' must be followed by an ambient declaration."), ImportAliasHasImportType: t2("An import alias can not use 'import type'."), IncompatibleModifiers: t2((e2) => {
            let { modifiers: s2 } = e2;
            return "'".concat(s2[0], "' modifier cannot be used with '").concat(s2[1], "' modifier.");
          }), IndexSignatureHasAbstract: t2("Index signatures cannot have the 'abstract' modifier."), IndexSignatureHasAccessibility: t2((e2) => {
            let { modifier: s2 } = e2;
            return "Index signatures cannot have an accessibility modifier ('".concat(s2, "').");
          }), IndexSignatureHasDeclare: t2("Index signatures cannot have the 'declare' modifier."), IndexSignatureHasOverride: t2("'override' modifier cannot appear on an index signature."), IndexSignatureHasStatic: t2("Index signatures cannot have the 'static' modifier."), InitializerNotAllowedInAmbientContext: t2("Initializers are not allowed in ambient contexts."), InvalidModifierOnTypeMember: t2((e2) => {
            let { modifier: s2 } = e2;
            return "'".concat(s2, "' modifier cannot appear on a type member.");
          }), InvalidModifierOnTypeParameter: t2((e2) => {
            let { modifier: s2 } = e2;
            return "'".concat(s2, "' modifier cannot appear on a type parameter.");
          }), InvalidModifierOnTypeParameterPositions: t2((e2) => {
            let { modifier: s2 } = e2;
            return "'".concat(s2, "' modifier can only appear on a type parameter of a class, interface or type alias.");
          }), InvalidModifiersOrder: t2((e2) => {
            let { orderedModifiers: s2 } = e2;
            return "'".concat(s2[0], "' modifier must precede '").concat(s2[1], "' modifier.");
          }), InvalidTupleMemberLabel: t2("Tuple members must be labeled with a simple identifier."), MissingInterfaceName: t2("'interface' declarations must be followed by an identifier."), MixedLabeledAndUnlabeledElements: t2("Tuple members must all have names or all not have names."), NonAbstractClassHasAbstractMethod: t2("Abstract methods can only appear within an abstract class."), NonClassMethodPropertyHasAbstractModifer: t2("'abstract' modifier can only appear on a class, method, or property declaration."), OptionalTypeBeforeRequired: t2("A required element cannot follow an optional element."), OverrideNotInSubClass: t2("This member cannot have an 'override' modifier because its containing class does not extend another class."), PatternIsOptional: t2("A binding pattern parameter cannot be optional in an implementation signature."), PrivateElementHasAbstract: t2("Private elements cannot have the 'abstract' modifier."), PrivateElementHasAccessibility: t2((e2) => {
            let { modifier: s2 } = e2;
            return "Private elements cannot have an accessibility modifier ('".concat(s2, "').");
          }), ReadonlyForMethodSignature: t2("'readonly' modifier can only appear on a property declaration or index signature."), ReservedArrowTypeParam: t2("This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma, as in `<T,>() => ...`."), ReservedTypeAssertion: t2("This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."), SetAccesorCannotHaveOptionalParameter: t2("A 'set' accessor cannot have an optional parameter."), SetAccesorCannotHaveRestParameter: t2("A 'set' accessor cannot have rest parameter."), SetAccesorCannotHaveReturnType: t2("A 'set' accessor cannot have a return type annotation."), SingleTypeParameterWithoutTrailingComma: t2((e2) => {
            let { typeParameterName: s2 } = e2;
            return "Single type parameter ".concat(s2, " should have a trailing comma. Example usage: <").concat(s2, ",>.");
          }), StaticBlockCannotHaveModifier: t2("Static class blocks cannot have any modifier."), TypeAnnotationAfterAssign: t2("Type annotations must come before default assignments, e.g. instead of `age = 25: number` use `age: number = 25`."), TypeImportCannotSpecifyDefaultAndNamed: t2("A type-only import can specify a default import or named bindings, but not both."), TypeModifierIsUsedInTypeExports: t2("The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."), TypeModifierIsUsedInTypeImports: t2("The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."), UnexpectedParameterModifier: t2("A parameter property is only allowed in a constructor implementation."), UnexpectedReadonly: t2("'readonly' type modifier is only permitted on array and tuple literal types."), UnexpectedTypeAnnotation: t2("Did not expect a type annotation here."), UnexpectedTypeCastInParameter: t2("Unexpected type cast in parameter position."), UnsupportedImportTypeArgument: t2("Argument in a type import must be a string literal."), UnsupportedParameterPropertyKind: t2("A parameter property may not be declared using a binding pattern."), UnsupportedSignatureParameterKind: t2((e2) => {
            let { type: s2 } = e2;
            return "Name in a signature must be an Identifier, ObjectPattern or ArrayPattern, instead got ".concat(s2, ".");
          }) }));
          function qh(t2) {
            switch (t2) {
              case "any":
                return "TSAnyKeyword";
              case "boolean":
                return "TSBooleanKeyword";
              case "bigint":
                return "TSBigIntKeyword";
              case "never":
                return "TSNeverKeyword";
              case "number":
                return "TSNumberKeyword";
              case "object":
                return "TSObjectKeyword";
              case "string":
                return "TSStringKeyword";
              case "symbol":
                return "TSSymbolKeyword";
              case "undefined":
                return "TSUndefinedKeyword";
              case "unknown":
                return "TSUnknownKeyword";
              default:
                return;
            }
          }
          function Mr(t2) {
            return t2 === "private" || t2 === "public" || t2 === "protected";
          }
          function Uh(t2) {
            return t2 === "in" || t2 === "out";
          }
          var _h = (t2) => class extends t2 {
            getScopeHandler() {
              return Bh;
            }
            tsIsIdentifier() {
              return K(this.state.type);
            }
            tsTokenCanFollowModifier() {
              return (this.match(0) || this.match(5) || this.match(55) || this.match(21) || this.match(134) || this.isLiteralPropertyName()) && !this.hasPrecedingLineBreak();
            }
            tsNextTokenCanFollowModifier() {
              return this.next(), this.tsTokenCanFollowModifier();
            }
            tsParseModifier(e2, s2) {
              if (!K(this.state.type) && this.state.type !== 58)
                return;
              let r2 = this.state.value;
              if (e2.indexOf(r2) !== -1) {
                if (s2 && this.tsIsStartOfStaticBlocks())
                  return;
                if (this.tsTryParse(this.tsNextTokenCanFollowModifier.bind(this)))
                  return r2;
              }
            }
            tsParseModifiers(e2) {
              let { modified: s2, allowedModifiers: r2, disallowedModifiers: i2, stopOnStartOfClassStaticBlock: a, errorTemplate: n = S2.InvalidModifierOnTypeMember } = e2, o = (f3, y, P, v) => {
                y === P && s2[v] && this.raise(S2.InvalidModifiersOrder, { at: f3, orderedModifiers: [P, v] });
              }, c = (f3, y, P, v) => {
                (s2[P] && y === v || s2[v] && y === P) && this.raise(S2.IncompatibleModifiers, { at: f3, modifiers: [P, v] });
              };
              for (; ; ) {
                let { startLoc: f3 } = this.state, y = this.tsParseModifier(r2.concat(i2 != null ? i2 : []), a);
                if (!y)
                  break;
                Mr(y) ? s2.accessibility ? this.raise(S2.DuplicateAccessibilityModifier, { at: f3, modifier: y }) : (o(f3, y, y, "override"), o(f3, y, y, "static"), o(f3, y, y, "readonly"), s2.accessibility = y) : Uh(y) ? (s2[y] && this.raise(S2.DuplicateModifier, { at: f3, modifier: y }), s2[y] = true, o(f3, y, "in", "out")) : (Object.hasOwnProperty.call(s2, y) ? this.raise(S2.DuplicateModifier, { at: f3, modifier: y }) : (o(f3, y, "static", "readonly"), o(f3, y, "static", "override"), o(f3, y, "override", "readonly"), o(f3, y, "abstract", "override"), c(f3, y, "declare", "override"), c(f3, y, "static", "abstract")), s2[y] = true), i2 != null && i2.includes(y) && this.raise(n, { at: f3, modifier: y });
              }
            }
            tsIsListTerminator(e2) {
              switch (e2) {
                case "EnumMembers":
                case "TypeMembers":
                  return this.match(8);
                case "HeritageClauseElement":
                  return this.match(5);
                case "TupleElementTypes":
                  return this.match(3);
                case "TypeParametersOrArguments":
                  return this.match(48);
              }
              throw new Error("Unreachable");
            }
            tsParseList(e2, s2) {
              let r2 = [];
              for (; !this.tsIsListTerminator(e2); )
                r2.push(s2());
              return r2;
            }
            tsParseDelimitedList(e2, s2, r2) {
              return Rh(this.tsParseDelimitedListWorker(e2, s2, true, r2));
            }
            tsParseDelimitedListWorker(e2, s2, r2, i2) {
              let a = [], n = -1;
              for (; !this.tsIsListTerminator(e2); ) {
                n = -1;
                let o = s2();
                if (o == null)
                  return;
                if (a.push(o), this.eat(12)) {
                  n = this.state.lastTokStart;
                  continue;
                }
                if (this.tsIsListTerminator(e2))
                  break;
                r2 && this.expect(12);
                return;
              }
              return i2 && (i2.value = n), a;
            }
            tsParseBracketedList(e2, s2, r2, i2, a) {
              i2 || (r2 ? this.expect(0) : this.expect(47));
              let n = this.tsParseDelimitedList(e2, s2, a);
              return r2 ? this.expect(3) : this.expect(48), n;
            }
            tsParseImportType() {
              let e2 = this.startNode();
              return this.expect(83), this.expect(10), this.match(129) || this.raise(S2.UnsupportedImportTypeArgument, { at: this.state.startLoc }), e2.argument = this.parseExprAtom(), this.expect(11), this.eat(16) && (e2.qualifier = this.tsParseEntityName()), this.match(47) && (e2.typeParameters = this.tsParseTypeArguments()), this.finishNode(e2, "TSImportType");
            }
            tsParseEntityName() {
              let e2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true, s2 = this.parseIdentifier(e2);
              for (; this.eat(16); ) {
                let r2 = this.startNodeAtNode(s2);
                r2.left = s2, r2.right = this.parseIdentifier(e2), s2 = this.finishNode(r2, "TSQualifiedName");
              }
              return s2;
            }
            tsParseTypeReference() {
              let e2 = this.startNode();
              return e2.typeName = this.tsParseEntityName(), !this.hasPrecedingLineBreak() && this.match(47) && (e2.typeParameters = this.tsParseTypeArguments()), this.finishNode(e2, "TSTypeReference");
            }
            tsParseThisTypePredicate(e2) {
              this.next();
              let s2 = this.startNodeAtNode(e2);
              return s2.parameterName = e2, s2.typeAnnotation = this.tsParseTypeAnnotation(false), s2.asserts = false, this.finishNode(s2, "TSTypePredicate");
            }
            tsParseThisTypeNode() {
              let e2 = this.startNode();
              return this.next(), this.finishNode(e2, "TSThisType");
            }
            tsParseTypeQuery() {
              let e2 = this.startNode();
              return this.expect(87), this.match(83) ? e2.exprName = this.tsParseImportType() : e2.exprName = this.tsParseEntityName(), !this.hasPrecedingLineBreak() && this.match(47) && (e2.typeParameters = this.tsParseTypeArguments()), this.finishNode(e2, "TSTypeQuery");
            }
            tsParseInOutModifiers(e2) {
              this.tsParseModifiers({ modified: e2, allowedModifiers: ["in", "out"], disallowedModifiers: ["public", "private", "protected", "readonly", "declare", "abstract", "override"], errorTemplate: S2.InvalidModifierOnTypeParameter });
            }
            tsParseNoneModifiers(e2) {
              this.tsParseModifiers({ modified: e2, allowedModifiers: [], disallowedModifiers: ["in", "out"], errorTemplate: S2.InvalidModifierOnTypeParameterPositions });
            }
            tsParseTypeParameter() {
              let e2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.tsParseNoneModifiers.bind(this), s2 = this.startNode();
              return e2(s2), s2.name = this.tsParseTypeParameterName(), s2.constraint = this.tsEatThenParseType(81), s2.default = this.tsEatThenParseType(29), this.finishNode(s2, "TSTypeParameter");
            }
            tsTryParseTypeParameters(e2) {
              if (this.match(47))
                return this.tsParseTypeParameters(e2);
            }
            tsParseTypeParameters(e2) {
              let s2 = this.startNode();
              this.match(47) || this.match(138) ? this.next() : this.unexpected();
              let r2 = { value: -1 };
              return s2.params = this.tsParseBracketedList("TypeParametersOrArguments", this.tsParseTypeParameter.bind(this, e2), false, true, r2), s2.params.length === 0 && this.raise(S2.EmptyTypeParameters, { at: s2 }), r2.value !== -1 && this.addExtra(s2, "trailingComma", r2.value), this.finishNode(s2, "TSTypeParameterDeclaration");
            }
            tsTryNextParseConstantContext() {
              if (this.lookahead().type !== 75)
                return null;
              this.next();
              let e2 = this.tsParseTypeReference();
              return e2.typeParameters && this.raise(S2.CannotFindName, { at: e2.typeName, name: "const" }), e2;
            }
            tsFillSignature(e2, s2) {
              let r2 = e2 === 19, i2 = "parameters", a = "typeAnnotation";
              s2.typeParameters = this.tsTryParseTypeParameters(), this.expect(10), s2[i2] = this.tsParseBindingListForSignature(), r2 ? s2[a] = this.tsParseTypeOrTypePredicateAnnotation(e2) : this.match(e2) && (s2[a] = this.tsParseTypeOrTypePredicateAnnotation(e2));
            }
            tsParseBindingListForSignature() {
              return this.parseBindingList(11, 41).map((e2) => (e2.type !== "Identifier" && e2.type !== "RestElement" && e2.type !== "ObjectPattern" && e2.type !== "ArrayPattern" && this.raise(S2.UnsupportedSignatureParameterKind, { at: e2, type: e2.type }), e2));
            }
            tsParseTypeMemberSemicolon() {
              !this.eat(12) && !this.isLineTerminator() && this.expect(13);
            }
            tsParseSignatureMember(e2, s2) {
              return this.tsFillSignature(14, s2), this.tsParseTypeMemberSemicolon(), this.finishNode(s2, e2);
            }
            tsIsUnambiguouslyIndexSignature() {
              return this.next(), K(this.state.type) ? (this.next(), this.match(14)) : false;
            }
            tsTryParseIndexSignature(e2) {
              if (!(this.match(0) && this.tsLookAhead(this.tsIsUnambiguouslyIndexSignature.bind(this))))
                return;
              this.expect(0);
              let s2 = this.parseIdentifier();
              s2.typeAnnotation = this.tsParseTypeAnnotation(), this.resetEndLocation(s2), this.expect(3), e2.parameters = [s2];
              let r2 = this.tsTryParseTypeAnnotation();
              return r2 && (e2.typeAnnotation = r2), this.tsParseTypeMemberSemicolon(), this.finishNode(e2, "TSIndexSignature");
            }
            tsParsePropertyOrMethodSignature(e2, s2) {
              this.eat(17) && (e2.optional = true);
              let r2 = e2;
              if (this.match(10) || this.match(47)) {
                s2 && this.raise(S2.ReadonlyForMethodSignature, { at: e2 });
                let i2 = r2;
                i2.kind && this.match(47) && this.raise(S2.AccesorCannotHaveTypeParameters, { at: this.state.curPosition() }), this.tsFillSignature(14, i2), this.tsParseTypeMemberSemicolon();
                let a = "parameters", n = "typeAnnotation";
                if (i2.kind === "get")
                  i2[a].length > 0 && (this.raise(u.BadGetterArity, { at: this.state.curPosition() }), this.isThisParam(i2[a][0]) && this.raise(S2.AccesorCannotDeclareThisParameter, { at: this.state.curPosition() }));
                else if (i2.kind === "set") {
                  if (i2[a].length !== 1)
                    this.raise(u.BadSetterArity, { at: this.state.curPosition() });
                  else {
                    let o = i2[a][0];
                    this.isThisParam(o) && this.raise(S2.AccesorCannotDeclareThisParameter, { at: this.state.curPosition() }), o.type === "Identifier" && o.optional && this.raise(S2.SetAccesorCannotHaveOptionalParameter, { at: this.state.curPosition() }), o.type === "RestElement" && this.raise(S2.SetAccesorCannotHaveRestParameter, { at: this.state.curPosition() });
                  }
                  i2[n] && this.raise(S2.SetAccesorCannotHaveReturnType, { at: i2[n] });
                } else
                  i2.kind = "method";
                return this.finishNode(i2, "TSMethodSignature");
              } else {
                let i2 = r2;
                s2 && (i2.readonly = true);
                let a = this.tsTryParseTypeAnnotation();
                return a && (i2.typeAnnotation = a), this.tsParseTypeMemberSemicolon(), this.finishNode(i2, "TSPropertySignature");
              }
            }
            tsParseTypeMember() {
              let e2 = this.startNode();
              if (this.match(10) || this.match(47))
                return this.tsParseSignatureMember("TSCallSignatureDeclaration", e2);
              if (this.match(77)) {
                let r2 = this.startNode();
                return this.next(), this.match(10) || this.match(47) ? this.tsParseSignatureMember("TSConstructSignatureDeclaration", e2) : (e2.key = this.createIdentifier(r2, "new"), this.tsParsePropertyOrMethodSignature(e2, false));
              }
              this.tsParseModifiers({ modified: e2, allowedModifiers: ["readonly"], disallowedModifiers: ["declare", "abstract", "private", "protected", "public", "static", "override"] });
              let s2 = this.tsTryParseIndexSignature(e2);
              return s2 || (this.parsePropertyName(e2), !e2.computed && e2.key.type === "Identifier" && (e2.key.name === "get" || e2.key.name === "set") && this.tsTokenCanFollowModifier() && (e2.kind = e2.key.name, this.parsePropertyName(e2)), this.tsParsePropertyOrMethodSignature(e2, !!e2.readonly));
            }
            tsParseTypeLiteral() {
              let e2 = this.startNode();
              return e2.members = this.tsParseObjectTypeMembers(), this.finishNode(e2, "TSTypeLiteral");
            }
            tsParseObjectTypeMembers() {
              this.expect(5);
              let e2 = this.tsParseList("TypeMembers", this.tsParseTypeMember.bind(this));
              return this.expect(8), e2;
            }
            tsIsStartOfMappedType() {
              return this.next(), this.eat(53) ? this.isContextual(118) : (this.isContextual(118) && this.next(), !this.match(0) || (this.next(), !this.tsIsIdentifier()) ? false : (this.next(), this.match(58)));
            }
            tsParseMappedTypeParameter() {
              let e2 = this.startNode();
              return e2.name = this.tsParseTypeParameterName(), e2.constraint = this.tsExpectThenParseType(58), this.finishNode(e2, "TSTypeParameter");
            }
            tsParseMappedType() {
              let e2 = this.startNode();
              return this.expect(5), this.match(53) ? (e2.readonly = this.state.value, this.next(), this.expectContextual(118)) : this.eatContextual(118) && (e2.readonly = true), this.expect(0), e2.typeParameter = this.tsParseMappedTypeParameter(), e2.nameType = this.eatContextual(93) ? this.tsParseType() : null, this.expect(3), this.match(53) ? (e2.optional = this.state.value, this.next(), this.expect(17)) : this.eat(17) && (e2.optional = true), e2.typeAnnotation = this.tsTryParseType(), this.semicolon(), this.expect(8), this.finishNode(e2, "TSMappedType");
            }
            tsParseTupleType() {
              let e2 = this.startNode();
              e2.elementTypes = this.tsParseBracketedList("TupleElementTypes", this.tsParseTupleElementType.bind(this), true, false);
              let s2 = false, r2 = null;
              return e2.elementTypes.forEach((i2) => {
                var a;
                let { type: n } = i2;
                s2 && n !== "TSRestType" && n !== "TSOptionalType" && !(n === "TSNamedTupleMember" && i2.optional) && this.raise(S2.OptionalTypeBeforeRequired, { at: i2 }), s2 = s2 || n === "TSNamedTupleMember" && i2.optional || n === "TSOptionalType", n === "TSRestType" && (i2 = i2.typeAnnotation, n = i2.type);
                let o = n === "TSNamedTupleMember";
                r2 = (a = r2) != null ? a : o, r2 !== o && this.raise(S2.MixedLabeledAndUnlabeledElements, { at: i2 });
              }), this.finishNode(e2, "TSTupleType");
            }
            tsParseTupleElementType() {
              let { start: e2, startLoc: s2 } = this.state, r2 = this.eat(21), i2 = this.tsParseType(), a = this.eat(17);
              if (this.eat(14)) {
                let o = this.startNodeAtNode(i2);
                o.optional = a, i2.type === "TSTypeReference" && !i2.typeParameters && i2.typeName.type === "Identifier" ? o.label = i2.typeName : (this.raise(S2.InvalidTupleMemberLabel, { at: i2 }), o.label = i2), o.elementType = this.tsParseType(), i2 = this.finishNode(o, "TSNamedTupleMember");
              } else if (a) {
                let o = this.startNodeAtNode(i2);
                o.typeAnnotation = i2, i2 = this.finishNode(o, "TSOptionalType");
              }
              if (r2) {
                let o = this.startNodeAt(e2, s2);
                o.typeAnnotation = i2, i2 = this.finishNode(o, "TSRestType");
              }
              return i2;
            }
            tsParseParenthesizedType() {
              let e2 = this.startNode();
              return this.expect(10), e2.typeAnnotation = this.tsParseType(), this.expect(11), this.finishNode(e2, "TSParenthesizedType");
            }
            tsParseFunctionOrConstructorType(e2, s2) {
              let r2 = this.startNode();
              return e2 === "TSConstructorType" && (r2.abstract = !!s2, s2 && this.next(), this.next()), this.tsFillSignature(19, r2), this.finishNode(r2, e2);
            }
            tsParseLiteralTypeNode() {
              let e2 = this.startNode();
              return e2.literal = (() => {
                switch (this.state.type) {
                  case 130:
                  case 131:
                  case 129:
                  case 85:
                  case 86:
                    return this.parseExprAtom();
                  default:
                    throw this.unexpected();
                }
              })(), this.finishNode(e2, "TSLiteralType");
            }
            tsParseTemplateLiteralType() {
              let e2 = this.startNode();
              return e2.literal = this.parseTemplate(false), this.finishNode(e2, "TSLiteralType");
            }
            parseTemplateSubstitution() {
              return this.state.inType ? this.tsParseType() : super.parseTemplateSubstitution();
            }
            tsParseThisTypeOrThisTypePredicate() {
              let e2 = this.tsParseThisTypeNode();
              return this.isContextual(113) && !this.hasPrecedingLineBreak() ? this.tsParseThisTypePredicate(e2) : e2;
            }
            tsParseNonArrayType() {
              switch (this.state.type) {
                case 129:
                case 130:
                case 131:
                case 85:
                case 86:
                  return this.tsParseLiteralTypeNode();
                case 53:
                  if (this.state.value === "-") {
                    let e2 = this.startNode(), s2 = this.lookahead();
                    if (s2.type !== 130 && s2.type !== 131)
                      throw this.unexpected();
                    return e2.literal = this.parseMaybeUnary(), this.finishNode(e2, "TSLiteralType");
                  }
                  break;
                case 78:
                  return this.tsParseThisTypeOrThisTypePredicate();
                case 87:
                  return this.tsParseTypeQuery();
                case 83:
                  return this.tsParseImportType();
                case 5:
                  return this.tsLookAhead(this.tsIsStartOfMappedType.bind(this)) ? this.tsParseMappedType() : this.tsParseTypeLiteral();
                case 0:
                  return this.tsParseTupleType();
                case 10:
                  return this.tsParseParenthesizedType();
                case 25:
                case 24:
                  return this.tsParseTemplateLiteralType();
                default: {
                  let { type: e2 } = this.state;
                  if (K(e2) || e2 === 88 || e2 === 84) {
                    let s2 = e2 === 88 ? "TSVoidKeyword" : e2 === 84 ? "TSNullKeyword" : qh(this.state.value);
                    if (s2 !== void 0 && this.lookaheadCharCode() !== 46) {
                      let r2 = this.startNode();
                      return this.next(), this.finishNode(r2, s2);
                    }
                    return this.tsParseTypeReference();
                  }
                }
              }
              throw this.unexpected();
            }
            tsParseArrayTypeOrHigher() {
              let e2 = this.tsParseNonArrayType();
              for (; !this.hasPrecedingLineBreak() && this.eat(0); )
                if (this.match(3)) {
                  let s2 = this.startNodeAtNode(e2);
                  s2.elementType = e2, this.expect(3), e2 = this.finishNode(s2, "TSArrayType");
                } else {
                  let s2 = this.startNodeAtNode(e2);
                  s2.objectType = e2, s2.indexType = this.tsParseType(), this.expect(3), e2 = this.finishNode(s2, "TSIndexedAccessType");
                }
              return e2;
            }
            tsParseTypeOperator() {
              let e2 = this.startNode(), s2 = this.state.value;
              return this.next(), e2.operator = s2, e2.typeAnnotation = this.tsParseTypeOperatorOrHigher(), s2 === "readonly" && this.tsCheckTypeAnnotationForReadOnly(e2), this.finishNode(e2, "TSTypeOperator");
            }
            tsCheckTypeAnnotationForReadOnly(e2) {
              switch (e2.typeAnnotation.type) {
                case "TSTupleType":
                case "TSArrayType":
                  return;
                default:
                  this.raise(S2.UnexpectedReadonly, { at: e2 });
              }
            }
            tsParseInferType() {
              let e2 = this.startNode();
              this.expectContextual(112);
              let s2 = this.startNode();
              return s2.name = this.tsParseTypeParameterName(), s2.constraint = this.tsTryParse(() => this.tsParseConstraintForInferType()), e2.typeParameter = this.finishNode(s2, "TSTypeParameter"), this.finishNode(e2, "TSInferType");
            }
            tsParseConstraintForInferType() {
              if (this.eat(81)) {
                let e2 = this.tsInDisallowConditionalTypesContext(() => this.tsParseType());
                if (this.state.inDisallowConditionalTypesContext || !this.match(17))
                  return e2;
              }
            }
            tsParseTypeOperatorOrHigher() {
              return Fo(this.state.type) && !this.state.containsEsc ? this.tsParseTypeOperator() : this.isContextual(112) ? this.tsParseInferType() : this.tsInAllowConditionalTypesContext(() => this.tsParseArrayTypeOrHigher());
            }
            tsParseUnionOrIntersectionType(e2, s2, r2) {
              let i2 = this.startNode(), a = this.eat(r2), n = [];
              do
                n.push(s2());
              while (this.eat(r2));
              return n.length === 1 && !a ? n[0] : (i2.types = n, this.finishNode(i2, e2));
            }
            tsParseIntersectionTypeOrHigher() {
              return this.tsParseUnionOrIntersectionType("TSIntersectionType", this.tsParseTypeOperatorOrHigher.bind(this), 45);
            }
            tsParseUnionTypeOrHigher() {
              return this.tsParseUnionOrIntersectionType("TSUnionType", this.tsParseIntersectionTypeOrHigher.bind(this), 43);
            }
            tsIsStartOfFunctionType() {
              return this.match(47) ? true : this.match(10) && this.tsLookAhead(this.tsIsUnambiguouslyStartOfFunctionType.bind(this));
            }
            tsSkipParameterStart() {
              if (K(this.state.type) || this.match(78))
                return this.next(), true;
              if (this.match(5)) {
                let { errors: e2 } = this.state, s2 = e2.length;
                try {
                  return this.parseObjectLike(8, true), e2.length === s2;
                } catch {
                  return false;
                }
              }
              if (this.match(0)) {
                this.next();
                let { errors: e2 } = this.state, s2 = e2.length;
                try {
                  return this.parseBindingList(3, 93, true), e2.length === s2;
                } catch {
                  return false;
                }
              }
              return false;
            }
            tsIsUnambiguouslyStartOfFunctionType() {
              return this.next(), !!(this.match(11) || this.match(21) || this.tsSkipParameterStart() && (this.match(14) || this.match(12) || this.match(17) || this.match(29) || this.match(11) && (this.next(), this.match(19))));
            }
            tsParseTypeOrTypePredicateAnnotation(e2) {
              return this.tsInType(() => {
                let s2 = this.startNode();
                this.expect(e2);
                let r2 = this.startNode(), i2 = !!this.tsTryParse(this.tsParseTypePredicateAsserts.bind(this));
                if (i2 && this.match(78)) {
                  let o = this.tsParseThisTypeOrThisTypePredicate();
                  return o.type === "TSThisType" ? (r2.parameterName = o, r2.asserts = true, r2.typeAnnotation = null, o = this.finishNode(r2, "TSTypePredicate")) : (this.resetStartLocationFromNode(o, r2), o.asserts = true), s2.typeAnnotation = o, this.finishNode(s2, "TSTypeAnnotation");
                }
                let a = this.tsIsIdentifier() && this.tsTryParse(this.tsParseTypePredicatePrefix.bind(this));
                if (!a)
                  return i2 ? (r2.parameterName = this.parseIdentifier(), r2.asserts = i2, r2.typeAnnotation = null, s2.typeAnnotation = this.finishNode(r2, "TSTypePredicate"), this.finishNode(s2, "TSTypeAnnotation")) : this.tsParseTypeAnnotation(false, s2);
                let n = this.tsParseTypeAnnotation(false);
                return r2.parameterName = a, r2.typeAnnotation = n, r2.asserts = i2, s2.typeAnnotation = this.finishNode(r2, "TSTypePredicate"), this.finishNode(s2, "TSTypeAnnotation");
              });
            }
            tsTryParseTypeOrTypePredicateAnnotation() {
              return this.match(14) ? this.tsParseTypeOrTypePredicateAnnotation(14) : void 0;
            }
            tsTryParseTypeAnnotation() {
              return this.match(14) ? this.tsParseTypeAnnotation() : void 0;
            }
            tsTryParseType() {
              return this.tsEatThenParseType(14);
            }
            tsParseTypePredicatePrefix() {
              let e2 = this.parseIdentifier();
              if (this.isContextual(113) && !this.hasPrecedingLineBreak())
                return this.next(), e2;
            }
            tsParseTypePredicateAsserts() {
              if (this.state.type !== 106)
                return false;
              let e2 = this.state.containsEsc;
              return this.next(), !K(this.state.type) && !this.match(78) ? false : (e2 && this.raise(u.InvalidEscapedReservedWord, { at: this.state.lastTokStartLoc, reservedWord: "asserts" }), true);
            }
            tsParseTypeAnnotation() {
              let e2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : true, s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this.startNode();
              return this.tsInType(() => {
                e2 && this.expect(14), s2.typeAnnotation = this.tsParseType();
              }), this.finishNode(s2, "TSTypeAnnotation");
            }
            tsParseType() {
              Br(this.state.inType);
              let e2 = this.tsParseNonConditionalType();
              if (this.state.inDisallowConditionalTypesContext || this.hasPrecedingLineBreak() || !this.eat(81))
                return e2;
              let s2 = this.startNodeAtNode(e2);
              return s2.checkType = e2, s2.extendsType = this.tsInDisallowConditionalTypesContext(() => this.tsParseNonConditionalType()), this.expect(17), s2.trueType = this.tsInAllowConditionalTypesContext(() => this.tsParseType()), this.expect(14), s2.falseType = this.tsInAllowConditionalTypesContext(() => this.tsParseType()), this.finishNode(s2, "TSConditionalType");
            }
            isAbstractConstructorSignature() {
              return this.isContextual(120) && this.lookahead().type === 77;
            }
            tsParseNonConditionalType() {
              return this.tsIsStartOfFunctionType() ? this.tsParseFunctionOrConstructorType("TSFunctionType") : this.match(77) ? this.tsParseFunctionOrConstructorType("TSConstructorType") : this.isAbstractConstructorSignature() ? this.tsParseFunctionOrConstructorType("TSConstructorType", true) : this.tsParseUnionTypeOrHigher();
            }
            tsParseTypeAssertion() {
              this.getPluginOption("typescript", "disallowAmbiguousJSXLike") && this.raise(S2.ReservedTypeAssertion, { at: this.state.startLoc });
              let e2 = this.startNode(), s2 = this.tsTryNextParseConstantContext();
              return e2.typeAnnotation = s2 || this.tsNextThenParseType(), this.expect(48), e2.expression = this.parseMaybeUnary(), this.finishNode(e2, "TSTypeAssertion");
            }
            tsParseHeritageClause(e2) {
              let s2 = this.state.startLoc, r2 = this.tsParseDelimitedList("HeritageClauseElement", () => {
                let i2 = this.startNode();
                return i2.expression = this.tsParseEntityName(), this.match(47) && (i2.typeParameters = this.tsParseTypeArguments()), this.finishNode(i2, "TSExpressionWithTypeArguments");
              });
              return r2.length || this.raise(S2.EmptyHeritageClauseType, { at: s2, token: e2 }), r2;
            }
            tsParseInterfaceDeclaration(e2) {
              let s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              if (this.hasFollowingLineBreak())
                return null;
              this.expectContextual(125), s2.declare && (e2.declare = true), K(this.state.type) ? (e2.id = this.parseIdentifier(), this.checkIdentifier(e2.id, Wo)) : (e2.id = null, this.raise(S2.MissingInterfaceName, { at: this.state.startLoc })), e2.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutModifiers.bind(this)), this.eat(81) && (e2.extends = this.tsParseHeritageClause("extends"));
              let r2 = this.startNode();
              return r2.body = this.tsInType(this.tsParseObjectTypeMembers.bind(this)), e2.body = this.finishNode(r2, "TSInterfaceBody"), this.finishNode(e2, "TSInterfaceDeclaration");
            }
            tsParseTypeAliasDeclaration(e2) {
              return e2.id = this.parseIdentifier(), this.checkIdentifier(e2.id, Go), e2.typeAnnotation = this.tsInType(() => {
                if (e2.typeParameters = this.tsTryParseTypeParameters(this.tsParseInOutModifiers.bind(this)), this.expect(29), this.isContextual(111) && this.lookahead().type !== 16) {
                  let s2 = this.startNode();
                  return this.next(), this.finishNode(s2, "TSIntrinsicKeyword");
                }
                return this.tsParseType();
              }), this.semicolon(), this.finishNode(e2, "TSTypeAliasDeclaration");
            }
            tsInNoContext(e2) {
              let s2 = this.state.context;
              this.state.context = [s2[0]];
              try {
                return e2();
              } finally {
                this.state.context = s2;
              }
            }
            tsInType(e2) {
              let s2 = this.state.inType;
              this.state.inType = true;
              try {
                return e2();
              } finally {
                this.state.inType = s2;
              }
            }
            tsInDisallowConditionalTypesContext(e2) {
              let s2 = this.state.inDisallowConditionalTypesContext;
              this.state.inDisallowConditionalTypesContext = true;
              try {
                return e2();
              } finally {
                this.state.inDisallowConditionalTypesContext = s2;
              }
            }
            tsInAllowConditionalTypesContext(e2) {
              let s2 = this.state.inDisallowConditionalTypesContext;
              this.state.inDisallowConditionalTypesContext = false;
              try {
                return e2();
              } finally {
                this.state.inDisallowConditionalTypesContext = s2;
              }
            }
            tsEatThenParseType(e2) {
              return this.match(e2) ? this.tsNextThenParseType() : void 0;
            }
            tsExpectThenParseType(e2) {
              return this.tsDoThenParseType(() => this.expect(e2));
            }
            tsNextThenParseType() {
              return this.tsDoThenParseType(() => this.next());
            }
            tsDoThenParseType(e2) {
              return this.tsInType(() => (e2(), this.tsParseType()));
            }
            tsParseEnumMember() {
              let e2 = this.startNode();
              return e2.id = this.match(129) ? this.parseExprAtom() : this.parseIdentifier(true), this.eat(29) && (e2.initializer = this.parseMaybeAssignAllowIn()), this.finishNode(e2, "TSEnumMember");
            }
            tsParseEnumDeclaration(e2) {
              let s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              return s2.const && (e2.const = true), s2.declare && (e2.declare = true), this.expectContextual(122), e2.id = this.parseIdentifier(), this.checkIdentifier(e2.id, e2.const ? Jo : Er), this.expect(5), e2.members = this.tsParseDelimitedList("EnumMembers", this.tsParseEnumMember.bind(this)), this.expect(8), this.finishNode(e2, "TSEnumDeclaration");
            }
            tsParseModuleBlock() {
              let e2 = this.startNode();
              return this.scope.enter(Me), this.expect(5), this.parseBlockOrModuleBlockBody(e2.body = [], void 0, true, 8), this.scope.exit(), this.finishNode(e2, "TSModuleBlock");
            }
            tsParseModuleOrNamespaceDeclaration(e2) {
              let s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              if (e2.id = this.parseIdentifier(), s2 || this.checkIdentifier(e2.id, Yo), this.eat(16)) {
                let r2 = this.startNode();
                this.tsParseModuleOrNamespaceDeclaration(r2, true), e2.body = r2;
              } else
                this.scope.enter(ht), this.prodParam.enter(je), e2.body = this.tsParseModuleBlock(), this.prodParam.exit(), this.scope.exit();
              return this.finishNode(e2, "TSModuleDeclaration");
            }
            tsParseAmbientExternalModuleDeclaration(e2) {
              return this.isContextual(109) ? (e2.global = true, e2.id = this.parseIdentifier()) : this.match(129) ? e2.id = this.parseExprAtom() : this.unexpected(), this.match(5) ? (this.scope.enter(ht), this.prodParam.enter(je), e2.body = this.tsParseModuleBlock(), this.prodParam.exit(), this.scope.exit()) : this.semicolon(), this.finishNode(e2, "TSModuleDeclaration");
            }
            tsParseImportEqualsDeclaration(e2, s2) {
              e2.isExport = s2 || false, e2.id = this.parseIdentifier(), this.checkIdentifier(e2.id, xe), this.expect(29);
              let r2 = this.tsParseModuleReference();
              return e2.importKind === "type" && r2.type !== "TSExternalModuleReference" && this.raise(S2.ImportAliasHasImportType, { at: r2 }), e2.moduleReference = r2, this.semicolon(), this.finishNode(e2, "TSImportEqualsDeclaration");
            }
            tsIsExternalModuleReference() {
              return this.isContextual(116) && this.lookaheadCharCode() === 40;
            }
            tsParseModuleReference() {
              return this.tsIsExternalModuleReference() ? this.tsParseExternalModuleReference() : this.tsParseEntityName(false);
            }
            tsParseExternalModuleReference() {
              let e2 = this.startNode();
              if (this.expectContextual(116), this.expect(10), !this.match(129))
                throw this.unexpected();
              return e2.expression = this.parseExprAtom(), this.expect(11), this.finishNode(e2, "TSExternalModuleReference");
            }
            tsLookAhead(e2) {
              let s2 = this.state.clone(), r2 = e2();
              return this.state = s2, r2;
            }
            tsTryParseAndCatch(e2) {
              let s2 = this.tryParse((r2) => e2() || r2());
              if (!(s2.aborted || !s2.node))
                return s2.error && (this.state = s2.failState), s2.node;
            }
            tsTryParse(e2) {
              let s2 = this.state.clone(), r2 = e2();
              if (r2 !== void 0 && r2 !== false)
                return r2;
              this.state = s2;
            }
            tsTryParseDeclare(e2) {
              if (this.isLineTerminator())
                return;
              let s2 = this.state.type, r2;
              return this.isContextual(99) && (s2 = 74, r2 = "let"), this.tsInAmbientContext(() => {
                if (s2 === 68)
                  return e2.declare = true, this.parseFunctionStatement(e2, false, true);
                if (s2 === 80)
                  return e2.declare = true, this.parseClass(e2, true, false);
                if (s2 === 122)
                  return this.tsParseEnumDeclaration(e2, { declare: true });
                if (s2 === 109)
                  return this.tsParseAmbientExternalModuleDeclaration(e2);
                if (s2 === 75 || s2 === 74)
                  return !this.match(75) || !this.isLookaheadContextual("enum") ? (e2.declare = true, this.parseVarStatement(e2, r2 || this.state.value, true)) : (this.expect(75), this.tsParseEnumDeclaration(e2, { const: true, declare: true }));
                if (s2 === 125) {
                  let i2 = this.tsParseInterfaceDeclaration(e2, { declare: true });
                  if (i2)
                    return i2;
                }
                if (K(s2))
                  return this.tsParseDeclaration(e2, this.state.value, true);
              });
            }
            tsTryParseExportDeclaration() {
              return this.tsParseDeclaration(this.startNode(), this.state.value, true);
            }
            tsParseExpressionStatement(e2, s2) {
              switch (s2.name) {
                case "declare": {
                  let r2 = this.tsTryParseDeclare(e2);
                  if (r2)
                    return r2.declare = true, r2;
                  break;
                }
                case "global":
                  if (this.match(5)) {
                    this.scope.enter(ht), this.prodParam.enter(je);
                    let r2 = e2;
                    return r2.global = true, r2.id = s2, r2.body = this.tsParseModuleBlock(), this.scope.exit(), this.prodParam.exit(), this.finishNode(r2, "TSModuleDeclaration");
                  }
                  break;
                default:
                  return this.tsParseDeclaration(e2, s2.name, false);
              }
            }
            tsParseDeclaration(e2, s2, r2) {
              switch (s2) {
                case "abstract":
                  if (this.tsCheckLineTerminator(r2) && (this.match(80) || K(this.state.type)))
                    return this.tsParseAbstractDeclaration(e2);
                  break;
                case "module":
                  if (this.tsCheckLineTerminator(r2)) {
                    if (this.match(129))
                      return this.tsParseAmbientExternalModuleDeclaration(e2);
                    if (K(this.state.type))
                      return this.tsParseModuleOrNamespaceDeclaration(e2);
                  }
                  break;
                case "namespace":
                  if (this.tsCheckLineTerminator(r2) && K(this.state.type))
                    return this.tsParseModuleOrNamespaceDeclaration(e2);
                  break;
                case "type":
                  if (this.tsCheckLineTerminator(r2) && K(this.state.type))
                    return this.tsParseTypeAliasDeclaration(e2);
                  break;
              }
            }
            tsCheckLineTerminator(e2) {
              return e2 ? this.hasFollowingLineBreak() ? false : (this.next(), true) : !this.isLineTerminator();
            }
            tsTryParseGenericAsyncArrowFunction(e2, s2) {
              if (!this.match(47))
                return;
              let r2 = this.state.maybeInArrowParameters;
              this.state.maybeInArrowParameters = true;
              let i2 = this.tsTryParseAndCatch(() => {
                let a = this.startNodeAt(e2, s2);
                return a.typeParameters = this.tsParseTypeParameters(), super.parseFunctionParams(a), a.returnType = this.tsTryParseTypeOrTypePredicateAnnotation(), this.expect(19), a;
              });
              if (this.state.maybeInArrowParameters = r2, !!i2)
                return this.parseArrowExpression(i2, null, true);
            }
            tsParseTypeArgumentsInExpression() {
              if (this.reScan_lt() === 47)
                return this.tsParseTypeArguments();
            }
            tsParseTypeArguments() {
              let e2 = this.startNode();
              return e2.params = this.tsInType(() => this.tsInNoContext(() => (this.expect(47), this.tsParseDelimitedList("TypeParametersOrArguments", this.tsParseType.bind(this))))), e2.params.length === 0 && this.raise(S2.EmptyTypeArguments, { at: e2 }), this.expect(48), this.finishNode(e2, "TSTypeParameterInstantiation");
            }
            tsIsDeclarationStart() {
              return Lo(this.state.type);
            }
            isExportDefaultSpecifier() {
              return this.tsIsDeclarationStart() ? false : super.isExportDefaultSpecifier();
            }
            parseAssignableListItem(e2, s2) {
              let r2 = this.state.start, i2 = this.state.startLoc, a, n = false, o = false;
              if (e2 !== void 0) {
                let y = {};
                this.tsParseModifiers({ modified: y, allowedModifiers: ["public", "private", "protected", "override", "readonly"] }), a = y.accessibility, o = y.override, n = y.readonly, e2 === false && (a || n || o) && this.raise(S2.UnexpectedParameterModifier, { at: i2 });
              }
              let c = this.parseMaybeDefault();
              this.parseAssignableListItemTypes(c);
              let f3 = this.parseMaybeDefault(c.start, c.loc.start, c);
              if (a || n || o) {
                let y = this.startNodeAt(r2, i2);
                return s2.length && (y.decorators = s2), a && (y.accessibility = a), n && (y.readonly = n), o && (y.override = o), f3.type !== "Identifier" && f3.type !== "AssignmentPattern" && this.raise(S2.UnsupportedParameterPropertyKind, { at: y }), y.parameter = f3, this.finishNode(y, "TSParameterProperty");
              }
              return s2.length && (c.decorators = s2), f3;
            }
            isSimpleParameter(e2) {
              return e2.type === "TSParameterProperty" && super.isSimpleParameter(e2.parameter) || super.isSimpleParameter(e2);
            }
            parseFunctionBodyAndFinish(e2, s2) {
              let r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              this.match(14) && (e2.returnType = this.tsParseTypeOrTypePredicateAnnotation(14));
              let i2 = s2 === "FunctionDeclaration" ? "TSDeclareFunction" : s2 === "ClassMethod" || s2 === "ClassPrivateMethod" ? "TSDeclareMethod" : void 0;
              if (i2 && !this.match(5) && this.isLineTerminator()) {
                this.finishNode(e2, i2);
                return;
              }
              if (i2 === "TSDeclareFunction" && this.state.isAmbientContext && (this.raise(S2.DeclareFunctionHasImplementation, { at: e2 }), e2.declare)) {
                super.parseFunctionBodyAndFinish(e2, i2, r2);
                return;
              }
              super.parseFunctionBodyAndFinish(e2, s2, r2);
            }
            registerFunctionStatementId(e2) {
              !e2.body && e2.id ? this.checkIdentifier(e2.id, Cr) : super.registerFunctionStatementId(...arguments);
            }
            tsCheckForInvalidTypeCasts(e2) {
              e2.forEach((s2) => {
                (s2 == null ? void 0 : s2.type) === "TSTypeCastExpression" && this.raise(S2.UnexpectedTypeAnnotation, { at: s2.typeAnnotation });
              });
            }
            toReferencedList(e2, s2) {
              return this.tsCheckForInvalidTypeCasts(e2), e2;
            }
            parseArrayLike() {
              let e2 = super.parseArrayLike(...arguments);
              return e2.type === "ArrayExpression" && this.tsCheckForInvalidTypeCasts(e2.elements), e2;
            }
            parseSubscript(e2, s2, r2, i2, a) {
              if (!this.hasPrecedingLineBreak() && this.match(35)) {
                this.state.canStartJSXElement = false, this.next();
                let o = this.startNodeAt(s2, r2);
                return o.expression = e2, this.finishNode(o, "TSNonNullExpression");
              }
              let n = false;
              if (this.match(18) && this.lookaheadCharCode() === 60) {
                if (i2)
                  return a.stop = true, e2;
                a.optionalChainMember = n = true, this.next();
              }
              if (this.match(47) || this.match(51)) {
                let o, c = this.tsTryParseAndCatch(() => {
                  if (!i2 && this.atPossibleAsyncArrow(e2)) {
                    let P = this.tsTryParseGenericAsyncArrowFunction(s2, r2);
                    if (P)
                      return P;
                  }
                  let f3 = this.tsParseTypeArgumentsInExpression();
                  if (!f3)
                    throw this.unexpected();
                  if (n && !this.match(10))
                    throw o = this.state.curPosition(), this.unexpected();
                  if (nt(this.state.type)) {
                    let P = this.parseTaggedTemplateExpression(e2, s2, r2, a);
                    return P.typeParameters = f3, P;
                  }
                  if (!i2 && this.eat(10)) {
                    let P = this.startNodeAt(s2, r2);
                    return P.callee = e2, P.arguments = this.parseCallExpressionArguments(11, false), this.tsCheckForInvalidTypeCasts(P.arguments), P.typeParameters = f3, a.optionalChainMember && (P.optional = n), this.finishCallExpression(P, a.optionalChainMember);
                  }
                  if (jh(this.state.type) && this.state.type !== 10)
                    throw this.unexpected();
                  let y = this.startNodeAt(s2, r2);
                  return y.expression = e2, y.typeParameters = f3, this.finishNode(y, "TSInstantiationExpression");
                });
                if (o && this.unexpected(o, 10), c)
                  return c;
              }
              return super.parseSubscript(e2, s2, r2, i2, a);
            }
            parseNewCallee(e2) {
              var s2;
              super.parseNewCallee(e2);
              let { callee: r2 } = e2;
              r2.type === "TSInstantiationExpression" && !((s2 = r2.extra) != null && s2.parenthesized) && (e2.typeParameters = r2.typeParameters, e2.callee = r2.expression);
            }
            parseExprOp(e2, s2, r2, i2) {
              if (at(58) > i2 && !this.hasPrecedingLineBreak() && this.isContextual(93)) {
                let a = this.startNodeAt(s2, r2);
                a.expression = e2;
                let n = this.tsTryNextParseConstantContext();
                return n ? a.typeAnnotation = n : a.typeAnnotation = this.tsNextThenParseType(), this.finishNode(a, "TSAsExpression"), this.reScan_lt_gt(), this.parseExprOp(a, s2, r2, i2);
              }
              return super.parseExprOp(e2, s2, r2, i2);
            }
            checkReservedWord(e2, s2, r2, i2) {
              this.state.isAmbientContext || super.checkReservedWord(e2, s2, r2, i2);
            }
            checkDuplicateExports() {
            }
            parseImport(e2) {
              if (e2.importKind = "value", K(this.state.type) || this.match(55) || this.match(5)) {
                let r2 = this.lookahead();
                if (this.isContextual(126) && r2.type !== 12 && r2.type !== 97 && r2.type !== 29 && (e2.importKind = "type", this.next(), r2 = this.lookahead()), K(this.state.type) && r2.type === 29)
                  return this.tsParseImportEqualsDeclaration(e2);
              }
              let s2 = super.parseImport(e2);
              return s2.importKind === "type" && s2.specifiers.length > 1 && s2.specifiers[0].type === "ImportDefaultSpecifier" && this.raise(S2.TypeImportCannotSpecifyDefaultAndNamed, { at: s2 }), s2;
            }
            parseExport(e2) {
              if (this.match(83))
                return this.next(), this.isContextual(126) && this.lookaheadCharCode() !== 61 ? (e2.importKind = "type", this.next()) : e2.importKind = "value", this.tsParseImportEqualsDeclaration(e2, true);
              if (this.eat(29)) {
                let s2 = e2;
                return s2.expression = this.parseExpression(), this.semicolon(), this.finishNode(s2, "TSExportAssignment");
              } else if (this.eatContextual(93)) {
                let s2 = e2;
                return this.expectContextual(124), s2.id = this.parseIdentifier(), this.semicolon(), this.finishNode(s2, "TSNamespaceExportDeclaration");
              } else
                return this.isContextual(126) && this.lookahead().type === 5 ? (this.next(), e2.exportKind = "type") : e2.exportKind = "value", super.parseExport(e2);
            }
            isAbstractClass() {
              return this.isContextual(120) && this.lookahead().type === 80;
            }
            parseExportDefaultExpression() {
              if (this.isAbstractClass()) {
                let e2 = this.startNode();
                return this.next(), e2.abstract = true, this.parseClass(e2, true, true), e2;
              }
              if (this.match(125)) {
                let e2 = this.tsParseInterfaceDeclaration(this.startNode());
                if (e2)
                  return e2;
              }
              return super.parseExportDefaultExpression();
            }
            parseVarStatement(e2, s2) {
              let r2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, { isAmbientContext: i2 } = this.state, a = super.parseVarStatement(e2, s2, r2 || i2);
              if (!i2)
                return a;
              for (let { id: n, init: o } of a.declarations)
                !o || (s2 !== "const" || !!n.typeAnnotation ? this.raise(S2.InitializerNotAllowedInAmbientContext, { at: o }) : o.type !== "StringLiteral" && o.type !== "BooleanLiteral" && o.type !== "NumericLiteral" && o.type !== "BigIntLiteral" && (o.type !== "TemplateLiteral" || o.expressions.length > 0) && !zh(o) && this.raise(S2.ConstInitiailizerMustBeStringOrNumericLiteralOrLiteralEnumReference, { at: o }));
              return a;
            }
            parseStatementContent(e2, s2) {
              if (this.match(75) && this.isLookaheadContextual("enum")) {
                let r2 = this.startNode();
                return this.expect(75), this.tsParseEnumDeclaration(r2, { const: true });
              }
              if (this.isContextual(122))
                return this.tsParseEnumDeclaration(this.startNode());
              if (this.isContextual(125)) {
                let r2 = this.tsParseInterfaceDeclaration(this.startNode());
                if (r2)
                  return r2;
              }
              return super.parseStatementContent(e2, s2);
            }
            parseAccessModifier() {
              return this.tsParseModifier(["public", "protected", "private"]);
            }
            tsHasSomeModifiers(e2, s2) {
              return s2.some((r2) => Mr(r2) ? e2.accessibility === r2 : !!e2[r2]);
            }
            tsIsStartOfStaticBlocks() {
              return this.isContextual(104) && this.lookaheadCharCode() === 123;
            }
            parseClassMember(e2, s2, r2) {
              let i2 = ["declare", "private", "public", "protected", "override", "abstract", "readonly", "static"];
              this.tsParseModifiers({ modified: s2, allowedModifiers: i2, disallowedModifiers: ["in", "out"], stopOnStartOfClassStaticBlock: true, errorTemplate: S2.InvalidModifierOnTypeParameterPositions });
              let a = () => {
                this.tsIsStartOfStaticBlocks() ? (this.next(), this.next(), this.tsHasSomeModifiers(s2, i2) && this.raise(S2.StaticBlockCannotHaveModifier, { at: this.state.curPosition() }), this.parseClassStaticBlock(e2, s2)) : this.parseClassMemberWithIsStatic(e2, s2, r2, !!s2.static);
              };
              s2.declare ? this.tsInAmbientContext(a) : a();
            }
            parseClassMemberWithIsStatic(e2, s2, r2, i2) {
              let a = this.tsTryParseIndexSignature(s2);
              if (a) {
                e2.body.push(a), s2.abstract && this.raise(S2.IndexSignatureHasAbstract, { at: s2 }), s2.accessibility && this.raise(S2.IndexSignatureHasAccessibility, { at: s2, modifier: s2.accessibility }), s2.declare && this.raise(S2.IndexSignatureHasDeclare, { at: s2 }), s2.override && this.raise(S2.IndexSignatureHasOverride, { at: s2 });
                return;
              }
              !this.state.inAbstractClass && s2.abstract && this.raise(S2.NonAbstractClassHasAbstractMethod, { at: s2 }), s2.override && (r2.hadSuperClass || this.raise(S2.OverrideNotInSubClass, { at: s2 })), super.parseClassMemberWithIsStatic(e2, s2, r2, i2);
            }
            parsePostMemberNameModifiers(e2) {
              this.eat(17) && (e2.optional = true), e2.readonly && this.match(10) && this.raise(S2.ClassMethodHasReadonly, { at: e2 }), e2.declare && this.match(10) && this.raise(S2.ClassMethodHasDeclare, { at: e2 });
            }
            parseExpressionStatement(e2, s2) {
              return (s2.type === "Identifier" ? this.tsParseExpressionStatement(e2, s2) : void 0) || super.parseExpressionStatement(e2, s2);
            }
            shouldParseExportDeclaration() {
              return this.tsIsDeclarationStart() ? true : super.shouldParseExportDeclaration();
            }
            parseConditional(e2, s2, r2, i2) {
              if (!this.state.maybeInArrowParameters || !this.match(17))
                return super.parseConditional(e2, s2, r2, i2);
              let a = this.tryParse(() => super.parseConditional(e2, s2, r2));
              return a.node ? (a.error && (this.state = a.failState), a.node) : (a.error && super.setOptionalParametersError(i2, a.error), e2);
            }
            parseParenItem(e2, s2, r2) {
              if (e2 = super.parseParenItem(e2, s2, r2), this.eat(17) && (e2.optional = true, this.resetEndLocation(e2)), this.match(14)) {
                let i2 = this.startNodeAt(s2, r2);
                return i2.expression = e2, i2.typeAnnotation = this.tsParseTypeAnnotation(), this.finishNode(i2, "TSTypeCastExpression");
              }
              return e2;
            }
            parseExportDeclaration(e2) {
              if (!this.state.isAmbientContext && this.isContextual(121))
                return this.tsInAmbientContext(() => this.parseExportDeclaration(e2));
              let s2 = this.state.start, r2 = this.state.startLoc, i2 = this.eatContextual(121);
              if (i2 && (this.isContextual(121) || !this.shouldParseExportDeclaration()))
                throw this.raise(S2.ExpectedAmbientAfterExportDeclare, { at: this.state.startLoc });
              let n = K(this.state.type) && this.tsTryParseExportDeclaration() || super.parseExportDeclaration(e2);
              return n ? ((n.type === "TSInterfaceDeclaration" || n.type === "TSTypeAliasDeclaration" || i2) && (e2.exportKind = "type"), i2 && (this.resetStartLocation(n, s2, r2), n.declare = true), n) : null;
            }
            parseClassId(e2, s2, r2) {
              if ((!s2 || r2) && this.isContextual(110))
                return;
              super.parseClassId(e2, s2, r2, e2.declare ? Cr : Pr);
              let i2 = this.tsTryParseTypeParameters(this.tsParseInOutModifiers.bind(this));
              i2 && (e2.typeParameters = i2);
            }
            parseClassPropertyAnnotation(e2) {
              !e2.optional && this.eat(35) && (e2.definite = true);
              let s2 = this.tsTryParseTypeAnnotation();
              s2 && (e2.typeAnnotation = s2);
            }
            parseClassProperty(e2) {
              if (this.parseClassPropertyAnnotation(e2), this.state.isAmbientContext && this.match(29) && this.raise(S2.DeclareClassFieldHasInitializer, { at: this.state.startLoc }), e2.abstract && this.match(29)) {
                let { key: s2 } = e2;
                this.raise(S2.AbstractPropertyHasInitializer, { at: this.state.startLoc, propertyName: s2.type === "Identifier" && !e2.computed ? s2.name : "[".concat(this.input.slice(s2.start, s2.end), "]") });
              }
              return super.parseClassProperty(e2);
            }
            parseClassPrivateProperty(e2) {
              return e2.abstract && this.raise(S2.PrivateElementHasAbstract, { at: e2 }), e2.accessibility && this.raise(S2.PrivateElementHasAccessibility, { at: e2, modifier: e2.accessibility }), this.parseClassPropertyAnnotation(e2), super.parseClassPrivateProperty(e2);
            }
            pushClassMethod(e2, s2, r2, i2, a, n) {
              let o = this.tsTryParseTypeParameters();
              o && a && this.raise(S2.ConstructorHasTypeParameters, { at: o });
              let { declare: c = false, kind: f3 } = s2;
              c && (f3 === "get" || f3 === "set") && this.raise(S2.DeclareAccessor, { at: s2, kind: f3 }), o && (s2.typeParameters = o), super.pushClassMethod(e2, s2, r2, i2, a, n);
            }
            pushClassPrivateMethod(e2, s2, r2, i2) {
              let a = this.tsTryParseTypeParameters();
              a && (s2.typeParameters = a), super.pushClassPrivateMethod(e2, s2, r2, i2);
            }
            declareClassPrivateMethodInScope(e2, s2) {
              e2.type !== "TSDeclareMethod" && (e2.type === "MethodDefinition" && !e2.value.body || super.declareClassPrivateMethodInScope(e2, s2));
            }
            parseClassSuper(e2) {
              super.parseClassSuper(e2), e2.superClass && (this.match(47) || this.match(51)) && (e2.superTypeParameters = this.tsParseTypeArgumentsInExpression()), this.eatContextual(110) && (e2.implements = this.tsParseHeritageClause("implements"));
            }
            parseObjPropValue(e2) {
              let s2 = this.tsTryParseTypeParameters();
              s2 && (e2.typeParameters = s2);
              for (var r2 = arguments.length, i2 = new Array(r2 > 1 ? r2 - 1 : 0), a = 1; a < r2; a++)
                i2[a - 1] = arguments[a];
              super.parseObjPropValue(e2, ...i2);
            }
            parseFunctionParams(e2, s2) {
              let r2 = this.tsTryParseTypeParameters();
              r2 && (e2.typeParameters = r2), super.parseFunctionParams(e2, s2);
            }
            parseVarId(e2, s2) {
              super.parseVarId(e2, s2), e2.id.type === "Identifier" && !this.hasPrecedingLineBreak() && this.eat(35) && (e2.definite = true);
              let r2 = this.tsTryParseTypeAnnotation();
              r2 && (e2.id.typeAnnotation = r2, this.resetEndLocation(e2.id));
            }
            parseAsyncArrowFromCallExpression(e2, s2) {
              return this.match(14) && (e2.returnType = this.tsParseTypeAnnotation()), super.parseAsyncArrowFromCallExpression(e2, s2);
            }
            parseMaybeAssign() {
              for (var e2 = arguments.length, s2 = new Array(e2), r2 = 0; r2 < e2; r2++)
                s2[r2] = arguments[r2];
              var i2, a, n, o, c, f3, y;
              let P, v, N;
              if (this.hasPlugin("jsx") && (this.match(138) || this.match(47))) {
                if (P = this.state.clone(), v = this.tryParse(() => super.parseMaybeAssign(...s2), P), !v.error)
                  return v.node;
                let { context: Q } = this.state, re = Q[Q.length - 1];
                (re === z.j_oTag || re === z.j_expr) && Q.pop();
              }
              if (!((i2 = v) != null && i2.error) && !this.match(47))
                return super.parseMaybeAssign(...s2);
              let B;
              P = P || this.state.clone();
              let _ = this.tryParse((Q) => {
                var re, ne, $e;
                B = this.tsParseTypeParameters();
                let le = super.parseMaybeAssign(...s2);
                return (le.type !== "ArrowFunctionExpression" || (re = le.extra) != null && re.parenthesized) && Q(), ((ne = B) == null ? void 0 : ne.params.length) !== 0 && this.resetStartLocationFromNode(le, B), le.typeParameters = B, this.hasPlugin("jsx") && le.typeParameters.params.length === 1 && !(($e = le.typeParameters.extra) != null && $e.trailingComma) && le.typeParameters.params[0].constraint, le;
              }, P);
              if (!_.error && !_.aborted)
                return B && this.reportReservedArrowTypeParam(B), _.node;
              if (!v && (Br(!this.hasPlugin("jsx")), N = this.tryParse(() => super.parseMaybeAssign(...s2), P), !N.error))
                return N.node;
              if ((a = v) != null && a.node)
                return this.state = v.failState, v.node;
              if (_.node)
                return this.state = _.failState, B && this.reportReservedArrowTypeParam(B), _.node;
              if ((n = N) != null && n.node)
                return this.state = N.failState, N.node;
              throw (o = v) != null && o.thrown ? v.error : _.thrown ? _.error : (c = N) != null && c.thrown ? N.error : ((f3 = v) == null ? void 0 : f3.error) || _.error || ((y = N) == null ? void 0 : y.error);
            }
            reportReservedArrowTypeParam(e2) {
              var s2;
              e2.params.length === 1 && !((s2 = e2.extra) != null && s2.trailingComma) && this.getPluginOption("typescript", "disallowAmbiguousJSXLike") && this.raise(S2.ReservedArrowTypeParam, { at: e2 });
            }
            parseMaybeUnary(e2) {
              return !this.hasPlugin("jsx") && this.match(47) ? this.tsParseTypeAssertion() : super.parseMaybeUnary(e2);
            }
            parseArrow(e2) {
              if (this.match(14)) {
                let s2 = this.tryParse((r2) => {
                  let i2 = this.tsParseTypeOrTypePredicateAnnotation(14);
                  return (this.canInsertSemicolon() || !this.match(19)) && r2(), i2;
                });
                if (s2.aborted)
                  return;
                s2.thrown || (s2.error && (this.state = s2.failState), e2.returnType = s2.node);
              }
              return super.parseArrow(e2);
            }
            parseAssignableListItemTypes(e2) {
              this.eat(17) && (e2.type !== "Identifier" && !this.state.isAmbientContext && !this.state.inType && this.raise(S2.PatternIsOptional, { at: e2 }), e2.optional = true);
              let s2 = this.tsTryParseTypeAnnotation();
              return s2 && (e2.typeAnnotation = s2), this.resetEndLocation(e2), e2;
            }
            isAssignable(e2, s2) {
              switch (e2.type) {
                case "TSTypeCastExpression":
                  return this.isAssignable(e2.expression, s2);
                case "TSParameterProperty":
                  return true;
                default:
                  return super.isAssignable(e2, s2);
              }
            }
            toAssignable(e2) {
              let s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              switch (e2.type) {
                case "ParenthesizedExpression":
                  this.toAssignableParenthesizedExpression(e2, s2);
                  break;
                case "TSAsExpression":
                case "TSNonNullExpression":
                case "TSTypeAssertion":
                  s2 ? this.expressionScope.recordArrowParemeterBindingError(S2.UnexpectedTypeCastInParameter, { at: e2 }) : this.raise(S2.UnexpectedTypeCastInParameter, { at: e2 }), this.toAssignable(e2.expression, s2);
                  break;
                case "AssignmentExpression":
                  !s2 && e2.left.type === "TSTypeCastExpression" && (e2.left = this.typeCastToParameter(e2.left));
                default:
                  super.toAssignable(e2, s2);
              }
            }
            toAssignableParenthesizedExpression(e2, s2) {
              switch (e2.expression.type) {
                case "TSAsExpression":
                case "TSNonNullExpression":
                case "TSTypeAssertion":
                case "ParenthesizedExpression":
                  this.toAssignable(e2.expression, s2);
                  break;
                default:
                  super.toAssignable(e2, s2);
              }
            }
            checkToRestConversion(e2, s2) {
              switch (e2.type) {
                case "TSAsExpression":
                case "TSTypeAssertion":
                case "TSNonNullExpression":
                  this.checkToRestConversion(e2.expression, false);
                  break;
                default:
                  super.checkToRestConversion(e2, s2);
              }
            }
            isValidLVal(e2, s2, r2) {
              return Mh({ TSTypeCastExpression: true, TSParameterProperty: "parameter", TSNonNullExpression: "expression", TSAsExpression: (r2 !== we || !s2) && ["expression", true], TSTypeAssertion: (r2 !== we || !s2) && ["expression", true] }, e2) || super.isValidLVal(e2, s2, r2);
            }
            parseBindingAtom() {
              switch (this.state.type) {
                case 78:
                  return this.parseIdentifier(true);
                default:
                  return super.parseBindingAtom();
              }
            }
            parseMaybeDecoratorArguments(e2) {
              if (this.match(47) || this.match(51)) {
                let s2 = this.tsParseTypeArgumentsInExpression();
                if (this.match(10)) {
                  let r2 = super.parseMaybeDecoratorArguments(e2);
                  return r2.typeParameters = s2, r2;
                }
                this.unexpected(null, 10);
              }
              return super.parseMaybeDecoratorArguments(e2);
            }
            checkCommaAfterRest(e2) {
              return this.state.isAmbientContext && this.match(12) && this.lookaheadCharCode() === e2 ? (this.next(), false) : super.checkCommaAfterRest(e2);
            }
            isClassMethod() {
              return this.match(47) || super.isClassMethod();
            }
            isClassProperty() {
              return this.match(35) || this.match(14) || super.isClassProperty();
            }
            parseMaybeDefault() {
              let e2 = super.parseMaybeDefault(...arguments);
              return e2.type === "AssignmentPattern" && e2.typeAnnotation && e2.right.start < e2.typeAnnotation.start && this.raise(S2.TypeAnnotationAfterAssign, { at: e2.typeAnnotation }), e2;
            }
            getTokenFromCode(e2) {
              if (this.state.inType) {
                if (e2 === 62)
                  return this.finishOp(48, 1);
                if (e2 === 60)
                  return this.finishOp(47, 1);
              }
              return super.getTokenFromCode(e2);
            }
            reScan_lt_gt() {
              let { type: e2 } = this.state;
              e2 === 47 ? (this.state.pos -= 1, this.readToken_lt()) : e2 === 48 && (this.state.pos -= 1, this.readToken_gt());
            }
            reScan_lt() {
              let { type: e2 } = this.state;
              return e2 === 51 ? (this.state.pos -= 2, this.finishOp(47, 1), 47) : e2;
            }
            toAssignableList(e2) {
              for (let s2 = 0; s2 < e2.length; s2++) {
                let r2 = e2[s2];
                (r2 == null ? void 0 : r2.type) === "TSTypeCastExpression" && (e2[s2] = this.typeCastToParameter(r2));
              }
              super.toAssignableList(...arguments);
            }
            typeCastToParameter(e2) {
              return e2.expression.typeAnnotation = e2.typeAnnotation, this.resetEndLocation(e2.expression, e2.typeAnnotation.loc.end), e2.expression;
            }
            shouldParseArrow(e2) {
              return this.match(14) ? e2.every((s2) => this.isAssignable(s2, true)) : super.shouldParseArrow(e2);
            }
            shouldParseAsyncArrow() {
              return this.match(14) || super.shouldParseAsyncArrow();
            }
            canHaveLeadingDecorator() {
              return super.canHaveLeadingDecorator() || this.isAbstractClass();
            }
            jsxParseOpeningElementAfterName(e2) {
              if (this.match(47) || this.match(51)) {
                let s2 = this.tsTryParseAndCatch(() => this.tsParseTypeArgumentsInExpression());
                s2 && (e2.typeParameters = s2);
              }
              return super.jsxParseOpeningElementAfterName(e2);
            }
            getGetterSetterExpectedParamCount(e2) {
              let s2 = super.getGetterSetterExpectedParamCount(e2), i2 = this.getObjectOrClassMethodParams(e2)[0];
              return i2 && this.isThisParam(i2) ? s2 + 1 : s2;
            }
            parseCatchClauseParam() {
              let e2 = super.parseCatchClauseParam(), s2 = this.tsTryParseTypeAnnotation();
              return s2 && (e2.typeAnnotation = s2, this.resetEndLocation(e2)), e2;
            }
            tsInAmbientContext(e2) {
              let s2 = this.state.isAmbientContext;
              this.state.isAmbientContext = true;
              try {
                return e2();
              } finally {
                this.state.isAmbientContext = s2;
              }
            }
            parseClass(e2) {
              let s2 = this.state.inAbstractClass;
              this.state.inAbstractClass = !!e2.abstract;
              try {
                for (var r2 = arguments.length, i2 = new Array(r2 > 1 ? r2 - 1 : 0), a = 1; a < r2; a++)
                  i2[a - 1] = arguments[a];
                return super.parseClass(e2, ...i2);
              } finally {
                this.state.inAbstractClass = s2;
              }
            }
            tsParseAbstractDeclaration(e2) {
              if (this.match(80))
                return e2.abstract = true, this.parseClass(e2, true, false);
              if (this.isContextual(125)) {
                if (!this.hasFollowingLineBreak())
                  return e2.abstract = true, this.raise(S2.NonClassMethodPropertyHasAbstractModifer, { at: e2 }), this.tsParseInterfaceDeclaration(e2);
              } else
                this.unexpected(null, 80);
            }
            parseMethod() {
              let e2 = super.parseMethod(...arguments);
              if (e2.abstract && (this.hasPlugin("estree") ? !!e2.value.body : !!e2.body)) {
                let { key: r2 } = e2;
                this.raise(S2.AbstractMethodHasImplementation, { at: e2, methodName: r2.type === "Identifier" && !e2.computed ? r2.name : "[".concat(this.input.slice(r2.start, r2.end), "]") });
              }
              return e2;
            }
            tsParseTypeParameterName() {
              return this.parseIdentifier().name;
            }
            shouldParseAsAmbientContext() {
              return !!this.getPluginOption("typescript", "dts");
            }
            parse() {
              return this.shouldParseAsAmbientContext() && (this.state.isAmbientContext = true), super.parse();
            }
            getExpression() {
              return this.shouldParseAsAmbientContext() && (this.state.isAmbientContext = true), super.getExpression();
            }
            parseExportSpecifier(e2, s2, r2, i2) {
              return !s2 && i2 ? (this.parseTypeOnlyImportExportSpecifier(e2, false, r2), this.finishNode(e2, "ExportSpecifier")) : (e2.exportKind = "value", super.parseExportSpecifier(e2, s2, r2, i2));
            }
            parseImportSpecifier(e2, s2, r2, i2) {
              return !s2 && i2 ? (this.parseTypeOnlyImportExportSpecifier(e2, true, r2), this.finishNode(e2, "ImportSpecifier")) : (e2.importKind = "value", super.parseImportSpecifier(e2, s2, r2, i2));
            }
            parseTypeOnlyImportExportSpecifier(e2, s2, r2) {
              let i2 = s2 ? "imported" : "local", a = s2 ? "local" : "exported", n = e2[i2], o, c = false, f3 = true, y = n.loc.start;
              if (this.isContextual(93)) {
                let v = this.parseIdentifier();
                if (this.isContextual(93)) {
                  let N = this.parseIdentifier();
                  pe(this.state.type) ? (c = true, n = v, o = s2 ? this.parseIdentifier() : this.parseModuleExportName(), f3 = false) : (o = N, f3 = false);
                } else
                  pe(this.state.type) ? (f3 = false, o = s2 ? this.parseIdentifier() : this.parseModuleExportName()) : (c = true, n = v);
              } else
                pe(this.state.type) && (c = true, s2 ? (n = this.parseIdentifier(true), this.isContextual(93) || this.checkReservedWord(n.name, n.loc.start, true, true)) : n = this.parseModuleExportName());
              c && r2 && this.raise(s2 ? S2.TypeModifierIsUsedInTypeImports : S2.TypeModifierIsUsedInTypeExports, { at: y }), e2[i2] = n, e2[a] = o;
              let P = s2 ? "importKind" : "exportKind";
              e2[P] = c ? "type" : "value", f3 && this.eatContextual(93) && (e2[a] = s2 ? this.parseIdentifier() : this.parseModuleExportName()), e2[a] || (e2[a] = ge(e2[i2])), s2 && this.checkIdentifier(e2[a], xe);
            }
          };
          function zh(t2) {
            if (t2.type !== "MemberExpression")
              return false;
            let { computed: e2, property: s2 } = t2;
            return e2 && s2.type !== "StringLiteral" && (s2.type !== "TemplateLiteral" || s2.expressions.length > 0) ? false : Rr(t2.object);
          }
          function Rr(t2) {
            return t2.type === "Identifier" ? true : t2.type !== "MemberExpression" || t2.computed ? false : Rr(t2.object);
          }
          var jr = j(Hn || (Hn = rt(["placeholders"])))((t2) => ({ ClassNameIsRequired: t2("A class name is required."), UnexpectedSpace: t2("Unexpected space in placeholder.") })), Kh = (t2) => class extends t2 {
            parsePlaceholder(e2) {
              if (this.match(140)) {
                let s2 = this.startNode();
                return this.next(), this.assertNoSpace(), s2.name = super.parseIdentifier(true), this.assertNoSpace(), this.expect(140), this.finishPlaceholder(s2, e2);
              }
            }
            finishPlaceholder(e2, s2) {
              let r2 = !!(e2.expectedNode && e2.type === "Placeholder");
              return e2.expectedNode = s2, r2 ? e2 : this.finishNode(e2, "Placeholder");
            }
            getTokenFromCode(e2) {
              return e2 === 37 && this.input.charCodeAt(this.state.pos + 1) === 37 ? this.finishOp(140, 2) : super.getTokenFromCode(...arguments);
            }
            parseExprAtom() {
              return this.parsePlaceholder("Expression") || super.parseExprAtom(...arguments);
            }
            parseIdentifier() {
              return this.parsePlaceholder("Identifier") || super.parseIdentifier(...arguments);
            }
            checkReservedWord(e2) {
              e2 !== void 0 && super.checkReservedWord(...arguments);
            }
            parseBindingAtom() {
              return this.parsePlaceholder("Pattern") || super.parseBindingAtom(...arguments);
            }
            isValidLVal(e2) {
              for (var s2 = arguments.length, r2 = new Array(s2 > 1 ? s2 - 1 : 0), i2 = 1; i2 < s2; i2++)
                r2[i2 - 1] = arguments[i2];
              return e2 === "Placeholder" || super.isValidLVal(e2, ...r2);
            }
            toAssignable(e2) {
              e2 && e2.type === "Placeholder" && e2.expectedNode === "Expression" ? e2.expectedNode = "Pattern" : super.toAssignable(...arguments);
            }
            isLet(e2) {
              return super.isLet(e2) ? true : !this.isContextual(99) || e2 ? false : this.lookahead().type === 140;
            }
            verifyBreakContinue(e2) {
              e2.label && e2.label.type === "Placeholder" || super.verifyBreakContinue(...arguments);
            }
            parseExpressionStatement(e2, s2) {
              if (s2.type !== "Placeholder" || s2.extra && s2.extra.parenthesized)
                return super.parseExpressionStatement(...arguments);
              if (this.match(14)) {
                let r2 = e2;
                return r2.label = this.finishPlaceholder(s2, "Identifier"), this.next(), r2.body = this.parseStatement("label"), this.finishNode(r2, "LabeledStatement");
              }
              return this.semicolon(), e2.name = s2.name, this.finishPlaceholder(e2, "Statement");
            }
            parseBlock() {
              return this.parsePlaceholder("BlockStatement") || super.parseBlock(...arguments);
            }
            parseFunctionId() {
              return this.parsePlaceholder("Identifier") || super.parseFunctionId(...arguments);
            }
            parseClass(e2, s2, r2) {
              let i2 = s2 ? "ClassDeclaration" : "ClassExpression";
              this.next(), this.takeDecorators(e2);
              let a = this.state.strict, n = this.parsePlaceholder("Identifier");
              if (n)
                if (this.match(81) || this.match(140) || this.match(5))
                  e2.id = n;
                else {
                  if (r2 || !s2)
                    return e2.id = null, e2.body = this.finishPlaceholder(n, "ClassBody"), this.finishNode(e2, i2);
                  throw this.raise(jr.ClassNameIsRequired, { at: this.state.startLoc });
                }
              else
                this.parseClassId(e2, s2, r2);
              return this.parseClassSuper(e2), e2.body = this.parsePlaceholder("ClassBody") || this.parseClassBody(!!e2.superClass, a), this.finishNode(e2, i2);
            }
            parseExport(e2) {
              let s2 = this.parsePlaceholder("Identifier");
              if (!s2)
                return super.parseExport(...arguments);
              if (!this.isContextual(97) && !this.match(12))
                return e2.specifiers = [], e2.source = null, e2.declaration = this.finishPlaceholder(s2, "Declaration"), this.finishNode(e2, "ExportNamedDeclaration");
              this.expectPlugin("exportDefaultFrom");
              let r2 = this.startNode();
              return r2.exported = s2, e2.specifiers = [this.finishNode(r2, "ExportDefaultSpecifier")], super.parseExport(e2);
            }
            isExportDefaultSpecifier() {
              if (this.match(65)) {
                let e2 = this.nextTokenStart();
                if (this.isUnparsedContextual(e2, "from") && this.input.startsWith(Pe(140), this.nextTokenStartSince(e2 + 4)))
                  return true;
              }
              return super.isExportDefaultSpecifier();
            }
            maybeParseExportDefaultSpecifier(e2) {
              return e2.specifiers && e2.specifiers.length > 0 ? true : super.maybeParseExportDefaultSpecifier(...arguments);
            }
            checkExport(e2) {
              let { specifiers: s2 } = e2;
              s2 != null && s2.length && (e2.specifiers = s2.filter((r2) => r2.exported.type === "Placeholder")), super.checkExport(e2), e2.specifiers = s2;
            }
            parseImport(e2) {
              let s2 = this.parsePlaceholder("Identifier");
              if (!s2)
                return super.parseImport(...arguments);
              if (e2.specifiers = [], !this.isContextual(97) && !this.match(12))
                return e2.source = this.finishPlaceholder(s2, "StringLiteral"), this.semicolon(), this.finishNode(e2, "ImportDeclaration");
              let r2 = this.startNodeAtNode(s2);
              return r2.local = s2, this.finishNode(r2, "ImportDefaultSpecifier"), e2.specifiers.push(r2), this.eat(12) && (this.maybeParseStarImportSpecifier(e2) || this.parseNamedImportSpecifiers(e2)), this.expectContextual(97), e2.source = this.parseImportSource(), this.semicolon(), this.finishNode(e2, "ImportDeclaration");
            }
            parseImportSource() {
              return this.parsePlaceholder("StringLiteral") || super.parseImportSource(...arguments);
            }
            assertNoSpace() {
              this.state.start > this.state.lastTokEndLoc.index && this.raise(jr.UnexpectedSpace, { at: this.state.lastTokEndLoc });
            }
          }, Vh = (t2) => class extends t2 {
            parseV8Intrinsic() {
              if (this.match(54)) {
                let e2 = this.state.startLoc, s2 = this.startNode();
                if (this.next(), K(this.state.type)) {
                  let r2 = this.parseIdentifierName(this.state.start), i2 = this.createIdentifier(s2, r2);
                  if (i2.type = "V8IntrinsicIdentifier", this.match(10))
                    return i2;
                }
                this.unexpected(e2);
              }
            }
            parseExprAtom() {
              return this.parseV8Intrinsic() || super.parseExprAtom(...arguments);
            }
          };
          function ee(t2, e2) {
            let [s2, r2] = typeof e2 == "string" ? [e2, {}] : e2, i2 = Object.keys(r2), a = i2.length === 0;
            return t2.some((n) => {
              if (typeof n == "string")
                return a && n === s2;
              {
                let [o, c] = n;
                if (o !== s2)
                  return false;
                for (let f3 of i2)
                  if (c[f3] !== r2[f3])
                    return false;
                return true;
              }
            });
          }
          function Je(t2, e2, s2) {
            let r2 = t2.find((i2) => Array.isArray(i2) ? i2[0] === e2 : i2 === e2);
            return r2 && Array.isArray(r2) ? r2[1][s2] : null;
          }
          var qr = ["minimal", "fsharp", "hack", "smart"], Ur = ["^^", "@@", "^", "%", "#"], _r = ["hash", "bar"];
          function Hh(t2) {
            if (ee(t2, "decorators")) {
              if (ee(t2, "decorators-legacy"))
                throw new Error("Cannot use the decorators and decorators-legacy plugin together");
              let e2 = Je(t2, "decorators", "decoratorsBeforeExport");
              if (e2 == null)
                throw new Error("The 'decorators' plugin requires a 'decoratorsBeforeExport' option, whose value must be a boolean. If you are migrating from Babylon/Babel 6 or want to use the old decorators proposal, you should use the 'decorators-legacy' plugin instead of 'decorators'.");
              if (typeof e2 != "boolean")
                throw new Error("'decoratorsBeforeExport' must be a boolean.");
            }
            if (ee(t2, "flow") && ee(t2, "typescript"))
              throw new Error("Cannot combine flow and typescript plugins.");
            if (ee(t2, "placeholders") && ee(t2, "v8intrinsic"))
              throw new Error("Cannot combine placeholders and v8intrinsic plugins.");
            if (ee(t2, "pipelineOperator")) {
              let e2 = Je(t2, "pipelineOperator", "proposal");
              if (!qr.includes(e2)) {
                let r2 = qr.map((i2) => '"'.concat(i2, '"')).join(", ");
                throw new Error('"pipelineOperator" requires "proposal" option whose value must be one of: '.concat(r2, "."));
              }
              let s2 = ee(t2, ["recordAndTuple", { syntaxType: "hash" }]);
              if (e2 === "hack") {
                if (ee(t2, "placeholders"))
                  throw new Error("Cannot combine placeholders plugin and Hack-style pipes.");
                if (ee(t2, "v8intrinsic"))
                  throw new Error("Cannot combine v8intrinsic plugin and Hack-style pipes.");
                let r2 = Je(t2, "pipelineOperator", "topicToken");
                if (!Ur.includes(r2)) {
                  let i2 = Ur.map((a) => '"'.concat(a, '"')).join(", ");
                  throw new Error('"pipelineOperator" in "proposal": "hack" mode also requires a "topicToken" option whose value must be one of: '.concat(i2, "."));
                }
                if (r2 === "#" && s2)
                  throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "hack", topicToken: "#" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
              } else if (e2 === "smart" && s2)
                throw new Error('Plugin conflict between `["pipelineOperator", { proposal: "smart" }]` and `["recordAndtuple", { syntaxType: "hash"}]`.');
            }
            if (ee(t2, "moduleAttributes")) {
              if (ee(t2, "importAssertions"))
                throw new Error("Cannot combine importAssertions and moduleAttributes plugins.");
              if (Je(t2, "moduleAttributes", "version") !== "may-2020")
                throw new Error("The 'moduleAttributes' plugin requires a 'version' option, representing the last proposal update. Currently, the only supported value is 'may-2020'.");
            }
            if (ee(t2, "recordAndTuple") && !_r.includes(Je(t2, "recordAndTuple", "syntaxType")))
              throw new Error("'recordAndTuple' requires 'syntaxType' option whose value should be one of: " + _r.map((e2) => "'".concat(e2, "'")).join(", "));
            if (ee(t2, "asyncDoExpressions") && !ee(t2, "doExpressions")) {
              let e2 = new Error("'asyncDoExpressions' requires 'doExpressions', please add 'doExpressions' to parser plugins.");
              throw e2.missingPlugins = "doExpressions", e2;
            }
          }
          var zr = { estree: Oe, jsx: Lh, flow: Dh, typescript: _h, v8intrinsic: Vh, placeholders: Kh }, Wh = Object.keys(zr), Kr = { sourceType: "script", sourceFilename: void 0, startColumn: 0, startLine: 1, allowAwaitOutsideFunction: false, allowReturnOutsideFunction: false, allowImportExportEverywhere: false, allowSuperOutsideMethod: false, allowUndeclaredExports: false, plugins: [], strictMode: null, ranges: false, tokens: false, createParenthesizedExpressions: false, errorRecovery: false, attachComment: true };
          function Gh(t2) {
            let e2 = {};
            for (let s2 of Object.keys(Kr))
              e2[s2] = t2 && t2[s2] != null ? t2[s2] : Kr[s2];
            return e2;
          }
          var Xh = (t2, e2) => Object.hasOwnProperty.call(t2, e2) && t2[e2], Vr = (t2) => t2.type === "ParenthesizedExpression" ? Vr(t2.expression) : t2, Jh = class extends vh {
            toAssignable(t2) {
              let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              var s2, r2;
              let i2;
              switch ((t2.type === "ParenthesizedExpression" || (s2 = t2.extra) != null && s2.parenthesized) && (i2 = Vr(t2), e2 ? i2.type === "Identifier" ? this.expressionScope.recordArrowParemeterBindingError(u.InvalidParenthesizedAssignment, { at: t2 }) : i2.type !== "MemberExpression" && this.raise(u.InvalidParenthesizedAssignment, { at: t2 }) : this.raise(u.InvalidParenthesizedAssignment, { at: t2 })), t2.type) {
                case "Identifier":
                case "ObjectPattern":
                case "ArrayPattern":
                case "AssignmentPattern":
                case "RestElement":
                  break;
                case "ObjectExpression":
                  t2.type = "ObjectPattern";
                  for (let n = 0, o = t2.properties.length, c = o - 1; n < o; n++) {
                    var a;
                    let f3 = t2.properties[n], y = n === c;
                    this.toAssignableObjectExpressionProp(f3, y, e2), y && f3.type === "RestElement" && (a = t2.extra) != null && a.trailingCommaLoc && this.raise(u.RestTrailingComma, { at: t2.extra.trailingCommaLoc });
                  }
                  break;
                case "ObjectProperty": {
                  let { key: n, value: o } = t2;
                  this.isPrivateName(n) && this.classScope.usePrivateName(this.getPrivateNameSV(n), n.loc.start), this.toAssignable(o, e2);
                  break;
                }
                case "SpreadElement":
                  throw new Error("Internal @babel/parser error (this is a bug, please report it). SpreadElement should be converted by .toAssignable's caller.");
                case "ArrayExpression":
                  t2.type = "ArrayPattern", this.toAssignableList(t2.elements, (r2 = t2.extra) == null ? void 0 : r2.trailingCommaLoc, e2);
                  break;
                case "AssignmentExpression":
                  t2.operator !== "=" && this.raise(u.MissingEqInAssignment, { at: t2.left.loc.end }), t2.type = "AssignmentPattern", delete t2.operator, this.toAssignable(t2.left, e2);
                  break;
                case "ParenthesizedExpression":
                  this.toAssignable(i2, e2);
                  break;
              }
            }
            toAssignableObjectExpressionProp(t2, e2, s2) {
              if (t2.type === "ObjectMethod")
                this.raise(t2.kind === "get" || t2.kind === "set" ? u.PatternHasAccessor : u.PatternHasMethod, { at: t2.key });
              else if (t2.type === "SpreadElement") {
                t2.type = "RestElement";
                let r2 = t2.argument;
                this.checkToRestConversion(r2, false), this.toAssignable(r2, s2), e2 || this.raise(u.RestTrailingComma, { at: t2 });
              } else
                this.toAssignable(t2, s2);
            }
            toAssignableList(t2, e2, s2) {
              let r2 = t2.length - 1;
              for (let i2 = 0; i2 <= r2; i2++) {
                let a = t2[i2];
                if (!!a) {
                  if (a.type === "SpreadElement") {
                    a.type = "RestElement";
                    let n = a.argument;
                    this.checkToRestConversion(n, true), this.toAssignable(n, s2);
                  } else
                    this.toAssignable(a, s2);
                  a.type === "RestElement" && (i2 < r2 ? this.raise(u.RestTrailingComma, { at: a }) : e2 && this.raise(u.RestTrailingComma, { at: e2 }));
                }
              }
            }
            isAssignable(t2, e2) {
              switch (t2.type) {
                case "Identifier":
                case "ObjectPattern":
                case "ArrayPattern":
                case "AssignmentPattern":
                case "RestElement":
                  return true;
                case "ObjectExpression": {
                  let s2 = t2.properties.length - 1;
                  return t2.properties.every((r2, i2) => r2.type !== "ObjectMethod" && (i2 === s2 || r2.type !== "SpreadElement") && this.isAssignable(r2));
                }
                case "ObjectProperty":
                  return this.isAssignable(t2.value);
                case "SpreadElement":
                  return this.isAssignable(t2.argument);
                case "ArrayExpression":
                  return t2.elements.every((s2) => s2 === null || this.isAssignable(s2));
                case "AssignmentExpression":
                  return t2.operator === "=";
                case "ParenthesizedExpression":
                  return this.isAssignable(t2.expression);
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return !e2;
                default:
                  return false;
              }
            }
            toReferencedList(t2, e2) {
              return t2;
            }
            toReferencedListDeep(t2, e2) {
              this.toReferencedList(t2, e2);
              for (let s2 of t2)
                (s2 == null ? void 0 : s2.type) === "ArrayExpression" && this.toReferencedListDeep(s2.elements);
            }
            parseSpread(t2, e2) {
              let s2 = this.startNode();
              return this.next(), s2.argument = this.parseMaybeAssignAllowIn(t2, void 0, e2), this.finishNode(s2, "SpreadElement");
            }
            parseRestBinding() {
              let t2 = this.startNode();
              return this.next(), t2.argument = this.parseBindingAtom(), this.finishNode(t2, "RestElement");
            }
            parseBindingAtom() {
              switch (this.state.type) {
                case 0: {
                  let t2 = this.startNode();
                  return this.next(), t2.elements = this.parseBindingList(3, 93, true), this.finishNode(t2, "ArrayPattern");
                }
                case 5:
                  return this.parseObjectLike(8, true);
              }
              return this.parseIdentifier();
            }
            parseBindingList(t2, e2, s2, r2) {
              let i2 = [], a = true;
              for (; !this.eat(t2); )
                if (a ? a = false : this.expect(12), s2 && this.match(12))
                  i2.push(null);
                else {
                  if (this.eat(t2))
                    break;
                  if (this.match(21)) {
                    if (i2.push(this.parseAssignableListItemTypes(this.parseRestBinding())), !this.checkCommaAfterRest(e2)) {
                      this.expect(t2);
                      break;
                    }
                  } else {
                    let n = [];
                    for (this.match(26) && this.hasPlugin("decorators") && this.raise(u.UnsupportedParameterDecorator, { at: this.state.startLoc }); this.match(26); )
                      n.push(this.parseDecorator());
                    i2.push(this.parseAssignableListItem(r2, n));
                  }
                }
              return i2;
            }
            parseBindingRestProperty(t2) {
              return this.next(), t2.argument = this.parseIdentifier(), this.checkCommaAfterRest(125), this.finishNode(t2, "RestElement");
            }
            parseBindingProperty() {
              let t2 = this.startNode(), { type: e2, start: s2, startLoc: r2 } = this.state;
              return e2 === 21 ? this.parseBindingRestProperty(t2) : (e2 === 134 ? (this.expectPlugin("destructuringPrivate", r2), this.classScope.usePrivateName(this.state.value, r2), t2.key = this.parsePrivateName()) : this.parsePropertyName(t2), t2.method = false, this.parseObjPropValue(t2, s2, r2, false, false, true, false), t2);
            }
            parseAssignableListItem(t2, e2) {
              let s2 = this.parseMaybeDefault();
              this.parseAssignableListItemTypes(s2);
              let r2 = this.parseMaybeDefault(s2.start, s2.loc.start, s2);
              return e2.length && (s2.decorators = e2), r2;
            }
            parseAssignableListItemTypes(t2) {
              return t2;
            }
            parseMaybeDefault(t2, e2, s2) {
              var r2, i2, a;
              if (e2 = (r2 = e2) != null ? r2 : this.state.startLoc, t2 = (i2 = t2) != null ? i2 : this.state.start, s2 = (a = s2) != null ? a : this.parseBindingAtom(), !this.eat(29))
                return s2;
              let n = this.startNodeAt(t2, e2);
              return n.left = s2, n.right = this.parseMaybeAssignAllowIn(), this.finishNode(n, "AssignmentPattern");
            }
            isValidLVal(t2, e2, s2) {
              return Xh({ AssignmentPattern: "left", RestElement: "argument", ObjectProperty: "value", ParenthesizedExpression: "expression", ArrayPattern: "elements", ObjectPattern: "properties" }, t2);
            }
            checkLVal(t2, e2) {
              let { in: s2, binding: r2 = we, checkClashes: i2 = false, strictModeChanged: a = false, allowingSloppyLetBinding: n = !(r2 & Te), hasParenthesizedAncestor: o = false } = e2;
              var c;
              let f3 = t2.type;
              if (this.isObjectMethod(t2))
                return;
              if (f3 === "MemberExpression") {
                r2 !== we && this.raise(u.InvalidPropertyBindingPattern, { at: t2 });
                return;
              }
              if (t2.type === "Identifier") {
                this.checkIdentifier(t2, r2, a, n);
                let { name: B } = t2;
                i2 && (i2.has(B) ? this.raise(u.ParamDupe, { at: t2 }) : i2.add(B));
                return;
              }
              let y = this.isValidLVal(t2.type, !(o || (c = t2.extra) != null && c.parenthesized) && s2.type === "AssignmentExpression", r2);
              if (y === true)
                return;
              if (y === false) {
                let B = r2 === we ? u.InvalidLhs : u.InvalidLhsBinding;
                this.raise(B, { at: t2, ancestor: s2.type === "UpdateExpression" ? { type: "UpdateExpression", prefix: s2.prefix } : { type: s2.type } });
                return;
              }
              let [P, v] = Array.isArray(y) ? y : [y, f3 === "ParenthesizedExpression"], N = t2.type === "ArrayPattern" || t2.type === "ObjectPattern" || t2.type === "ParenthesizedExpression" ? t2 : s2;
              for (let B of [].concat(t2[P]))
                B && this.checkLVal(B, { in: N, binding: r2, checkClashes: i2, allowingSloppyLetBinding: n, strictModeChanged: a, hasParenthesizedAncestor: v });
            }
            checkIdentifier(t2, e2) {
              let s2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : !(e2 & Te);
              this.state.strict && (s2 ? mr(t2.name, this.inModule) : dr(t2.name)) && (e2 === we ? this.raise(u.StrictEvalArguments, { at: t2, referenceName: t2.name }) : this.raise(u.StrictEvalArgumentsBinding, { at: t2, bindingName: t2.name })), !r2 && t2.name === "let" && this.raise(u.LetInLexicalBinding, { at: t2 }), e2 & we || this.declareNameFromIdentifier(t2, e2);
            }
            declareNameFromIdentifier(t2, e2) {
              this.scope.declareName(t2.name, e2, t2.loc.start);
            }
            checkToRestConversion(t2, e2) {
              switch (t2.type) {
                case "ParenthesizedExpression":
                  this.checkToRestConversion(t2.expression, e2);
                  break;
                case "Identifier":
                case "MemberExpression":
                  break;
                case "ArrayExpression":
                case "ObjectExpression":
                  if (e2)
                    break;
                default:
                  this.raise(u.InvalidRestAssignmentPattern, { at: t2 });
              }
            }
            checkCommaAfterRest(t2) {
              return this.match(12) ? (this.raise(this.lookaheadCharCode() === t2 ? u.RestTrailingComma : u.ElementAfterRest, { at: this.state.startLoc }), true) : false;
            }
          }, Yh = class extends Jh {
            checkProto(t2, e2, s2, r2) {
              if (t2.type === "SpreadElement" || this.isObjectMethod(t2) || t2.computed || t2.shorthand)
                return;
              let i2 = t2.key;
              if ((i2.type === "Identifier" ? i2.name : i2.value) === "__proto__") {
                if (e2) {
                  this.raise(u.RecordNoProto, { at: i2 });
                  return;
                }
                s2.used && (r2 ? r2.doubleProtoLoc === null && (r2.doubleProtoLoc = i2.loc.start) : this.raise(u.DuplicateProto, { at: i2 })), s2.used = true;
              }
            }
            shouldExitDescending(t2, e2) {
              return t2.type === "ArrowFunctionExpression" && t2.start === e2;
            }
            getExpression() {
              this.enterInitialScopes(), this.nextToken();
              let t2 = this.parseExpression();
              return this.match(135) || this.unexpected(), this.finalizeRemainingComments(), t2.comments = this.state.comments, t2.errors = this.state.errors, this.options.tokens && (t2.tokens = this.tokens), t2;
            }
            parseExpression(t2, e2) {
              return t2 ? this.disallowInAnd(() => this.parseExpressionBase(e2)) : this.allowInAnd(() => this.parseExpressionBase(e2));
            }
            parseExpressionBase(t2) {
              let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.parseMaybeAssign(t2);
              if (this.match(12)) {
                let i2 = this.startNodeAt(e2, s2);
                for (i2.expressions = [r2]; this.eat(12); )
                  i2.expressions.push(this.parseMaybeAssign(t2));
                return this.toReferencedList(i2.expressions), this.finishNode(i2, "SequenceExpression");
              }
              return r2;
            }
            parseMaybeAssignDisallowIn(t2, e2) {
              return this.disallowInAnd(() => this.parseMaybeAssign(t2, e2));
            }
            parseMaybeAssignAllowIn(t2, e2) {
              return this.allowInAnd(() => this.parseMaybeAssign(t2, e2));
            }
            setOptionalParametersError(t2, e2) {
              var s2;
              t2.optionalParametersLoc = (s2 = e2 == null ? void 0 : e2.loc) != null ? s2 : this.state.startLoc;
            }
            parseMaybeAssign(t2, e2) {
              let s2 = this.state.start, r2 = this.state.startLoc;
              if (this.isContextual(105) && this.prodParam.hasYield) {
                let o = this.parseYield();
                return e2 && (o = e2.call(this, o, s2, r2)), o;
              }
              let i2;
              t2 ? i2 = false : (t2 = new At(), i2 = true);
              let { type: a } = this.state;
              (a === 10 || K(a)) && (this.state.potentialArrowAt = this.state.start);
              let n = this.parseMaybeConditional(t2);
              if (e2 && (n = e2.call(this, n, s2, r2)), wo(this.state.type)) {
                let o = this.startNodeAt(s2, r2), c = this.state.value;
                return o.operator = c, this.match(29) ? (this.toAssignable(n, true), o.left = n, t2.doubleProtoLoc != null && t2.doubleProtoLoc.index >= s2 && (t2.doubleProtoLoc = null), t2.shorthandAssignLoc != null && t2.shorthandAssignLoc.index >= s2 && (t2.shorthandAssignLoc = null), t2.privateKeyLoc != null && t2.privateKeyLoc.index >= s2 && (this.checkDestructuringPrivate(t2), t2.privateKeyLoc = null)) : o.left = n, this.next(), o.right = this.parseMaybeAssign(), this.checkLVal(n, { in: this.finishNode(o, "AssignmentExpression") }), o;
              } else
                i2 && this.checkExpressionErrors(t2, true);
              return n;
            }
            parseMaybeConditional(t2) {
              let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.state.potentialArrowAt, i2 = this.parseExprOps(t2);
              return this.shouldExitDescending(i2, r2) ? i2 : this.parseConditional(i2, e2, s2, t2);
            }
            parseConditional(t2, e2, s2, r2) {
              if (this.eat(17)) {
                let i2 = this.startNodeAt(e2, s2);
                return i2.test = t2, i2.consequent = this.parseMaybeAssignAllowIn(), this.expect(14), i2.alternate = this.parseMaybeAssign(), this.finishNode(i2, "ConditionalExpression");
              }
              return t2;
            }
            parseMaybeUnaryOrPrivate(t2) {
              return this.match(134) ? this.parsePrivateName() : this.parseMaybeUnary(t2);
            }
            parseExprOps(t2) {
              let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.state.potentialArrowAt, i2 = this.parseMaybeUnaryOrPrivate(t2);
              return this.shouldExitDescending(i2, r2) ? i2 : this.parseExprOp(i2, e2, s2, -1);
            }
            parseExprOp(t2, e2, s2, r2) {
              if (this.isPrivateName(t2)) {
                let a = this.getPrivateNameSV(t2);
                (r2 >= at(58) || !this.prodParam.hasIn || !this.match(58)) && this.raise(u.PrivateInExpectedIn, { at: t2, identifierName: a }), this.classScope.usePrivateName(a, t2.loc.start);
              }
              let i2 = this.state.type;
              if (Io(i2) && (this.prodParam.hasIn || !this.match(58))) {
                let a = at(i2);
                if (a > r2) {
                  if (i2 === 39) {
                    if (this.expectPlugin("pipelineOperator"), this.state.inFSharpPipelineDirectBody)
                      return t2;
                    this.checkPipelineAtInfixOperator(t2, s2);
                  }
                  let n = this.startNodeAt(e2, s2);
                  n.left = t2, n.operator = this.state.value;
                  let o = i2 === 41 || i2 === 42, c = i2 === 40;
                  if (c && (a = at(42)), this.next(), i2 === 39 && this.hasPlugin(["pipelineOperator", { proposal: "minimal" }]) && this.state.type === 96 && this.prodParam.hasAwait)
                    throw this.raise(u.UnexpectedAwaitAfterPipelineBody, { at: this.state.startLoc });
                  n.right = this.parseExprOpRightExpr(i2, a), this.finishNode(n, o || c ? "LogicalExpression" : "BinaryExpression");
                  let f3 = this.state.type;
                  if (c && (f3 === 41 || f3 === 42) || o && f3 === 40)
                    throw this.raise(u.MixingCoalesceWithLogical, { at: this.state.startLoc });
                  return this.parseExprOp(n, e2, s2, r2);
                }
              }
              return t2;
            }
            parseExprOpRightExpr(t2, e2) {
              let s2 = this.state.start, r2 = this.state.startLoc;
              switch (t2) {
                case 39:
                  switch (this.getPluginOption("pipelineOperator", "proposal")) {
                    case "hack":
                      return this.withTopicBindingContext(() => this.parseHackPipeBody());
                    case "smart":
                      return this.withTopicBindingContext(() => {
                        if (this.prodParam.hasYield && this.isContextual(105))
                          throw this.raise(u.PipeBodyIsTighter, { at: this.state.startLoc });
                        return this.parseSmartPipelineBodyInStyle(this.parseExprOpBaseRightExpr(t2, e2), s2, r2);
                      });
                    case "fsharp":
                      return this.withSoloAwaitPermittingContext(() => this.parseFSharpPipelineBody(e2));
                  }
                default:
                  return this.parseExprOpBaseRightExpr(t2, e2);
              }
            }
            parseExprOpBaseRightExpr(t2, e2) {
              let s2 = this.state.start, r2 = this.state.startLoc;
              return this.parseExprOp(this.parseMaybeUnaryOrPrivate(), s2, r2, Bo(t2) ? e2 - 1 : e2);
            }
            parseHackPipeBody() {
              var t2;
              let { startLoc: e2 } = this.state, s2 = this.parseMaybeAssign();
              return R.has(s2.type) && !((t2 = s2.extra) != null && t2.parenthesized) && this.raise(u.PipeUnparenthesizedBody, { at: e2, type: s2.type }), this.topicReferenceWasUsedInCurrentContext() || this.raise(u.PipeTopicUnused, { at: e2 }), s2;
            }
            checkExponentialAfterUnary(t2) {
              this.match(57) && this.raise(u.UnexpectedTokenUnaryExponentiation, { at: t2.argument });
            }
            parseMaybeUnary(t2, e2) {
              let s2 = this.state.start, r2 = this.state.startLoc, i2 = this.isContextual(96);
              if (i2 && this.isAwaitAllowed()) {
                this.next();
                let c = this.parseAwait(s2, r2);
                return e2 || this.checkExponentialAfterUnary(c), c;
              }
              let a = this.match(34), n = this.startNode();
              if (Do(this.state.type)) {
                n.operator = this.state.value, n.prefix = true, this.match(72) && this.expectPlugin("throwExpressions");
                let c = this.match(89);
                if (this.next(), n.argument = this.parseMaybeUnary(null, true), this.checkExpressionErrors(t2, true), this.state.strict && c) {
                  let f3 = n.argument;
                  f3.type === "Identifier" ? this.raise(u.StrictDelete, { at: n }) : this.hasPropertyAsPrivateName(f3) && this.raise(u.DeletePrivateField, { at: n });
                }
                if (!a)
                  return e2 || this.checkExponentialAfterUnary(n), this.finishNode(n, "UnaryExpression");
              }
              let o = this.parseUpdate(n, a, t2);
              if (i2) {
                let { type: c } = this.state;
                if ((this.hasPlugin("v8intrinsic") ? Vt(c) : Vt(c) && !this.match(54)) && !this.isAmbiguousAwait())
                  return this.raiseOverwrite(u.AwaitNotInAsyncContext, { at: r2 }), this.parseAwait(s2, r2);
              }
              return o;
            }
            parseUpdate(t2, e2, s2) {
              if (e2)
                return this.checkLVal(t2.argument, { in: this.finishNode(t2, "UpdateExpression") }), t2;
              let r2 = this.state.start, i2 = this.state.startLoc, a = this.parseExprSubscripts(s2);
              if (this.checkExpressionErrors(s2, false))
                return a;
              for (; ko(this.state.type) && !this.canInsertSemicolon(); ) {
                let n = this.startNodeAt(r2, i2);
                n.operator = this.state.value, n.prefix = false, n.argument = a, this.next(), this.checkLVal(a, { in: a = this.finishNode(n, "UpdateExpression") });
              }
              return a;
            }
            parseExprSubscripts(t2) {
              let e2 = this.state.start, s2 = this.state.startLoc, r2 = this.state.potentialArrowAt, i2 = this.parseExprAtom(t2);
              return this.shouldExitDescending(i2, r2) ? i2 : this.parseSubscripts(i2, e2, s2);
            }
            parseSubscripts(t2, e2, s2, r2) {
              let i2 = { optionalChainMember: false, maybeAsyncArrow: this.atPossibleAsyncArrow(t2), stop: false };
              do
                t2 = this.parseSubscript(t2, e2, s2, r2, i2), i2.maybeAsyncArrow = false;
              while (!i2.stop);
              return t2;
            }
            parseSubscript(t2, e2, s2, r2, i2) {
              let { type: a } = this.state;
              if (!r2 && a === 15)
                return this.parseBind(t2, e2, s2, r2, i2);
              if (nt(a))
                return this.parseTaggedTemplateExpression(t2, e2, s2, i2);
              let n = false;
              if (a === 18) {
                if (r2 && this.lookaheadCharCode() === 40)
                  return i2.stop = true, t2;
                i2.optionalChainMember = n = true, this.next();
              }
              if (!r2 && this.match(10))
                return this.parseCoverCallAndAsyncArrowHead(t2, e2, s2, i2, n);
              {
                let o = this.eat(0);
                return o || n || this.eat(16) ? this.parseMember(t2, e2, s2, i2, o, n) : (i2.stop = true, t2);
              }
            }
            parseMember(t2, e2, s2, r2, i2, a) {
              let n = this.startNodeAt(e2, s2);
              return n.object = t2, n.computed = i2, i2 ? (n.property = this.parseExpression(), this.expect(3)) : this.match(134) ? (t2.type === "Super" && this.raise(u.SuperPrivateField, { at: s2 }), this.classScope.usePrivateName(this.state.value, this.state.startLoc), n.property = this.parsePrivateName()) : n.property = this.parseIdentifier(true), r2.optionalChainMember ? (n.optional = a, this.finishNode(n, "OptionalMemberExpression")) : this.finishNode(n, "MemberExpression");
            }
            parseBind(t2, e2, s2, r2, i2) {
              let a = this.startNodeAt(e2, s2);
              return a.object = t2, this.next(), a.callee = this.parseNoCallExpr(), i2.stop = true, this.parseSubscripts(this.finishNode(a, "BindExpression"), e2, s2, r2);
            }
            parseCoverCallAndAsyncArrowHead(t2, e2, s2, r2, i2) {
              let a = this.state.maybeInArrowParameters, n = null;
              this.state.maybeInArrowParameters = true, this.next();
              let o = this.startNodeAt(e2, s2);
              o.callee = t2;
              let { maybeAsyncArrow: c, optionalChainMember: f3 } = r2;
              return c && (this.expressionScope.enter(Ph()), n = new At()), f3 && (o.optional = i2), i2 ? o.arguments = this.parseCallExpressionArguments(11) : o.arguments = this.parseCallExpressionArguments(11, t2.type === "Import", t2.type !== "Super", o, n), this.finishCallExpression(o, f3), c && this.shouldParseAsyncArrow() && !i2 ? (r2.stop = true, this.checkDestructuringPrivate(n), this.expressionScope.validateAsPattern(), this.expressionScope.exit(), o = this.parseAsyncArrowFromCallExpression(this.startNodeAt(e2, s2), o)) : (c && (this.checkExpressionErrors(n, true), this.expressionScope.exit()), this.toReferencedArguments(o)), this.state.maybeInArrowParameters = a, o;
            }
            toReferencedArguments(t2, e2) {
              this.toReferencedListDeep(t2.arguments, e2);
            }
            parseTaggedTemplateExpression(t2, e2, s2, r2) {
              let i2 = this.startNodeAt(e2, s2);
              return i2.tag = t2, i2.quasi = this.parseTemplate(true), r2.optionalChainMember && this.raise(u.OptionalChainingNoTemplate, { at: s2 }), this.finishNode(i2, "TaggedTemplateExpression");
            }
            atPossibleAsyncArrow(t2) {
              return t2.type === "Identifier" && t2.name === "async" && this.state.lastTokEndLoc.index === t2.end && !this.canInsertSemicolon() && t2.end - t2.start === 5 && t2.start === this.state.potentialArrowAt;
            }
            finishCallExpression(t2, e2) {
              if (t2.callee.type === "Import")
                if (t2.arguments.length === 2 && (this.hasPlugin("moduleAttributes") || this.expectPlugin("importAssertions")), t2.arguments.length === 0 || t2.arguments.length > 2)
                  this.raise(u.ImportCallArity, { at: t2, maxArgumentCount: this.hasPlugin("importAssertions") || this.hasPlugin("moduleAttributes") ? 2 : 1 });
                else
                  for (let s2 of t2.arguments)
                    s2.type === "SpreadElement" && this.raise(u.ImportCallSpreadArgument, { at: s2 });
              return this.finishNode(t2, e2 ? "OptionalCallExpression" : "CallExpression");
            }
            parseCallExpressionArguments(t2, e2, s2, r2, i2) {
              let a = [], n = true, o = this.state.inFSharpPipelineDirectBody;
              for (this.state.inFSharpPipelineDirectBody = false; !this.eat(t2); ) {
                if (n)
                  n = false;
                else if (this.expect(12), this.match(t2)) {
                  e2 && !this.hasPlugin("importAssertions") && !this.hasPlugin("moduleAttributes") && this.raise(u.ImportCallArgumentTrailingComma, { at: this.state.lastTokStartLoc }), r2 && this.addTrailingCommaExtraToNode(r2), this.next();
                  break;
                }
                a.push(this.parseExprListItem(false, i2, s2));
              }
              return this.state.inFSharpPipelineDirectBody = o, a;
            }
            shouldParseAsyncArrow() {
              return this.match(19) && !this.canInsertSemicolon();
            }
            parseAsyncArrowFromCallExpression(t2, e2) {
              var s2;
              return this.resetPreviousNodeTrailingComments(e2), this.expect(19), this.parseArrowExpression(t2, e2.arguments, true, (s2 = e2.extra) == null ? void 0 : s2.trailingCommaLoc), e2.innerComments && Ge(t2, e2.innerComments), e2.callee.trailingComments && Ge(t2, e2.callee.trailingComments), t2;
            }
            parseNoCallExpr() {
              let t2 = this.state.start, e2 = this.state.startLoc;
              return this.parseSubscripts(this.parseExprAtom(), t2, e2, true);
            }
            parseExprAtom(t2) {
              let e2, { type: s2 } = this.state;
              switch (s2) {
                case 79:
                  return this.parseSuper();
                case 83:
                  return e2 = this.startNode(), this.next(), this.match(16) ? this.parseImportMetaProperty(e2) : (this.match(10) || this.raise(u.UnsupportedImport, { at: this.state.lastTokStartLoc }), this.finishNode(e2, "Import"));
                case 78:
                  return e2 = this.startNode(), this.next(), this.finishNode(e2, "ThisExpression");
                case 90:
                  return this.parseDo(this.startNode(), false);
                case 56:
                case 31:
                  return this.readRegexp(), this.parseRegExpLiteral(this.state.value);
                case 130:
                  return this.parseNumericLiteral(this.state.value);
                case 131:
                  return this.parseBigIntLiteral(this.state.value);
                case 132:
                  return this.parseDecimalLiteral(this.state.value);
                case 129:
                  return this.parseStringLiteral(this.state.value);
                case 84:
                  return this.parseNullLiteral();
                case 85:
                  return this.parseBooleanLiteral(true);
                case 86:
                  return this.parseBooleanLiteral(false);
                case 10: {
                  let r2 = this.state.potentialArrowAt === this.state.start;
                  return this.parseParenAndDistinguishExpression(r2);
                }
                case 2:
                case 1:
                  return this.parseArrayLike(this.state.type === 2 ? 4 : 3, false, true);
                case 0:
                  return this.parseArrayLike(3, true, false, t2);
                case 6:
                case 7:
                  return this.parseObjectLike(this.state.type === 6 ? 9 : 8, false, true);
                case 5:
                  return this.parseObjectLike(8, false, false, t2);
                case 68:
                  return this.parseFunctionOrFunctionSent();
                case 26:
                  this.parseDecorators();
                case 80:
                  return e2 = this.startNode(), this.takeDecorators(e2), this.parseClass(e2, false);
                case 77:
                  return this.parseNewOrNewTarget();
                case 25:
                case 24:
                  return this.parseTemplate(false);
                case 15: {
                  e2 = this.startNode(), this.next(), e2.object = null;
                  let r2 = e2.callee = this.parseNoCallExpr();
                  if (r2.type === "MemberExpression")
                    return this.finishNode(e2, "BindExpression");
                  throw this.raise(u.UnsupportedBind, { at: r2 });
                }
                case 134:
                  return this.raise(u.PrivateInExpectedIn, { at: this.state.startLoc, identifierName: this.state.value }), this.parsePrivateName();
                case 33:
                  return this.parseTopicReferenceThenEqualsSign(54, "%");
                case 32:
                  return this.parseTopicReferenceThenEqualsSign(44, "^");
                case 37:
                case 38:
                  return this.parseTopicReference("hack");
                case 44:
                case 54:
                case 27: {
                  let r2 = this.getPluginOption("pipelineOperator", "proposal");
                  if (r2)
                    return this.parseTopicReference(r2);
                  throw this.unexpected();
                }
                case 47: {
                  let r2 = this.input.codePointAt(this.nextTokenStart());
                  if (de(r2) || r2 === 62) {
                    this.expectOnePlugin(["jsx", "flow", "typescript"]);
                    break;
                  } else
                    throw this.unexpected();
                }
                default:
                  if (K(s2)) {
                    if (this.isContextual(123) && this.lookaheadCharCode() === 123 && !this.hasFollowingLineBreak())
                      return this.parseModuleExpression();
                    let r2 = this.state.potentialArrowAt === this.state.start, i2 = this.state.containsEsc, a = this.parseIdentifier();
                    if (!i2 && a.name === "async" && !this.canInsertSemicolon()) {
                      let { type: n } = this.state;
                      if (n === 68)
                        return this.resetPreviousNodeTrailingComments(a), this.next(), this.parseFunction(this.startNodeAtNode(a), void 0, true);
                      if (K(n))
                        return this.lookaheadCharCode() === 61 ? this.parseAsyncArrowUnaryFunction(this.startNodeAtNode(a)) : a;
                      if (n === 90)
                        return this.resetPreviousNodeTrailingComments(a), this.parseDo(this.startNodeAtNode(a), true);
                    }
                    return r2 && this.match(19) && !this.canInsertSemicolon() ? (this.next(), this.parseArrowExpression(this.startNodeAtNode(a), [a], false)) : a;
                  } else
                    throw this.unexpected();
              }
            }
            parseTopicReferenceThenEqualsSign(t2, e2) {
              let s2 = this.getPluginOption("pipelineOperator", "proposal");
              if (s2)
                return this.state.type = t2, this.state.value = e2, this.state.pos--, this.state.end--, this.state.endLoc = m2(this.state.endLoc, -1), this.parseTopicReference(s2);
              throw this.unexpected();
            }
            parseTopicReference(t2) {
              let e2 = this.startNode(), s2 = this.state.startLoc, r2 = this.state.type;
              return this.next(), this.finishTopicReference(e2, s2, t2, r2);
            }
            finishTopicReference(t2, e2, s2, r2) {
              if (this.testTopicReferenceConfiguration(s2, e2, r2)) {
                let i2 = s2 === "smart" ? "PipelinePrimaryTopicReference" : "TopicReference";
                return this.topicReferenceIsAllowedInCurrentContext() || this.raise(s2 === "smart" ? u.PrimaryTopicNotAllowed : u.PipeTopicUnbound, { at: e2 }), this.registerTopicReference(), this.finishNode(t2, i2);
              } else
                throw this.raise(u.PipeTopicUnconfiguredToken, { at: e2, token: Pe(r2) });
            }
            testTopicReferenceConfiguration(t2, e2, s2) {
              switch (t2) {
                case "hack":
                  return this.hasPlugin(["pipelineOperator", { topicToken: Pe(s2) }]);
                case "smart":
                  return s2 === 27;
                default:
                  throw this.raise(u.PipeTopicRequiresHackPipes, { at: e2 });
              }
            }
            parseAsyncArrowUnaryFunction(t2) {
              this.prodParam.enter(gt(true, this.prodParam.hasYield));
              let e2 = [this.parseIdentifier()];
              return this.prodParam.exit(), this.hasPrecedingLineBreak() && this.raise(u.LineTerminatorBeforeArrow, { at: this.state.curPosition() }), this.expect(19), this.parseArrowExpression(t2, e2, true), t2;
            }
            parseDo(t2, e2) {
              this.expectPlugin("doExpressions"), e2 && this.expectPlugin("asyncDoExpressions"), t2.async = e2, this.next();
              let s2 = this.state.labels;
              return this.state.labels = [], e2 ? (this.prodParam.enter(xt), t2.body = this.parseBlock(), this.prodParam.exit()) : t2.body = this.parseBlock(), this.state.labels = s2, this.finishNode(t2, "DoExpression");
            }
            parseSuper() {
              let t2 = this.startNode();
              return this.next(), this.match(10) && !this.scope.allowDirectSuper && !this.options.allowSuperOutsideMethod ? this.raise(u.SuperNotAllowed, { at: t2 }) : !this.scope.allowSuper && !this.options.allowSuperOutsideMethod && this.raise(u.UnexpectedSuper, { at: t2 }), !this.match(10) && !this.match(0) && !this.match(16) && this.raise(u.UnsupportedSuper, { at: t2 }), this.finishNode(t2, "Super");
            }
            parsePrivateName() {
              let t2 = this.startNode(), e2 = this.startNodeAt(this.state.start + 1, new p(this.state.curLine, this.state.start + 1 - this.state.lineStart, this.state.start + 1)), s2 = this.state.value;
              return this.next(), t2.id = this.createIdentifier(e2, s2), this.finishNode(t2, "PrivateName");
            }
            parseFunctionOrFunctionSent() {
              let t2 = this.startNode();
              if (this.next(), this.prodParam.hasYield && this.match(16)) {
                let e2 = this.createIdentifier(this.startNodeAtNode(t2), "function");
                return this.next(), this.match(102) ? this.expectPlugin("functionSent") : this.hasPlugin("functionSent") || this.unexpected(), this.parseMetaProperty(t2, e2, "sent");
              }
              return this.parseFunction(t2);
            }
            parseMetaProperty(t2, e2, s2) {
              t2.meta = e2;
              let r2 = this.state.containsEsc;
              return t2.property = this.parseIdentifier(true), (t2.property.name !== s2 || r2) && this.raise(u.UnsupportedMetaProperty, { at: t2.property, target: e2.name, onlyValidPropertyName: s2 }), this.finishNode(t2, "MetaProperty");
            }
            parseImportMetaProperty(t2) {
              let e2 = this.createIdentifier(this.startNodeAtNode(t2), "import");
              return this.next(), this.isContextual(100) && (this.inModule || this.raise(u.ImportMetaOutsideModule, { at: e2 }), this.sawUnambiguousESM = true), this.parseMetaProperty(t2, e2, "meta");
            }
            parseLiteralAtNode(t2, e2, s2) {
              return this.addExtra(s2, "rawValue", t2), this.addExtra(s2, "raw", this.input.slice(s2.start, this.state.end)), s2.value = t2, this.next(), this.finishNode(s2, e2);
            }
            parseLiteral(t2, e2) {
              let s2 = this.startNode();
              return this.parseLiteralAtNode(t2, e2, s2);
            }
            parseStringLiteral(t2) {
              return this.parseLiteral(t2, "StringLiteral");
            }
            parseNumericLiteral(t2) {
              return this.parseLiteral(t2, "NumericLiteral");
            }
            parseBigIntLiteral(t2) {
              return this.parseLiteral(t2, "BigIntLiteral");
            }
            parseDecimalLiteral(t2) {
              return this.parseLiteral(t2, "DecimalLiteral");
            }
            parseRegExpLiteral(t2) {
              let e2 = this.parseLiteral(t2.value, "RegExpLiteral");
              return e2.pattern = t2.pattern, e2.flags = t2.flags, e2;
            }
            parseBooleanLiteral(t2) {
              let e2 = this.startNode();
              return e2.value = t2, this.next(), this.finishNode(e2, "BooleanLiteral");
            }
            parseNullLiteral() {
              let t2 = this.startNode();
              return this.next(), this.finishNode(t2, "NullLiteral");
            }
            parseParenAndDistinguishExpression(t2) {
              let e2 = this.state.start, s2 = this.state.startLoc, r2;
              this.next(), this.expressionScope.enter(Ah());
              let i2 = this.state.maybeInArrowParameters, a = this.state.inFSharpPipelineDirectBody;
              this.state.maybeInArrowParameters = true, this.state.inFSharpPipelineDirectBody = false;
              let n = this.state.start, o = this.state.startLoc, c = [], f3 = new At(), y = true, P, v;
              for (; !this.match(11); ) {
                if (y)
                  y = false;
                else if (this.expect(12, f3.optionalParametersLoc === null ? null : f3.optionalParametersLoc), this.match(11)) {
                  v = this.state.startLoc;
                  break;
                }
                if (this.match(21)) {
                  let _ = this.state.start, Q = this.state.startLoc;
                  if (P = this.state.startLoc, c.push(this.parseParenItem(this.parseRestBinding(), _, Q)), !this.checkCommaAfterRest(41))
                    break;
                } else
                  c.push(this.parseMaybeAssignAllowIn(f3, this.parseParenItem));
              }
              let N = this.state.lastTokEndLoc;
              this.expect(11), this.state.maybeInArrowParameters = i2, this.state.inFSharpPipelineDirectBody = a;
              let B = this.startNodeAt(e2, s2);
              return t2 && this.shouldParseArrow(c) && (B = this.parseArrow(B)) ? (this.checkDestructuringPrivate(f3), this.expressionScope.validateAsPattern(), this.expressionScope.exit(), this.parseArrowExpression(B, c, false), B) : (this.expressionScope.exit(), c.length || this.unexpected(this.state.lastTokStartLoc), v && this.unexpected(v), P && this.unexpected(P), this.checkExpressionErrors(f3, true), this.toReferencedListDeep(c, true), c.length > 1 ? (r2 = this.startNodeAt(n, o), r2.expressions = c, this.finishNode(r2, "SequenceExpression"), this.resetEndLocation(r2, N)) : r2 = c[0], this.wrapParenthesis(e2, s2, r2));
            }
            wrapParenthesis(t2, e2, s2) {
              if (!this.options.createParenthesizedExpressions)
                return this.addExtra(s2, "parenthesized", true), this.addExtra(s2, "parenStart", t2), this.takeSurroundingComments(s2, t2, this.state.lastTokEndLoc.index), s2;
              let r2 = this.startNodeAt(t2, e2);
              return r2.expression = s2, this.finishNode(r2, "ParenthesizedExpression"), r2;
            }
            shouldParseArrow(t2) {
              return !this.canInsertSemicolon();
            }
            parseArrow(t2) {
              if (this.eat(19))
                return t2;
            }
            parseParenItem(t2, e2, s2) {
              return t2;
            }
            parseNewOrNewTarget() {
              let t2 = this.startNode();
              if (this.next(), this.match(16)) {
                let e2 = this.createIdentifier(this.startNodeAtNode(t2), "new");
                this.next();
                let s2 = this.parseMetaProperty(t2, e2, "target");
                return !this.scope.inNonArrowFunction && !this.scope.inClass && this.raise(u.UnexpectedNewTarget, { at: s2 }), s2;
              }
              return this.parseNew(t2);
            }
            parseNew(t2) {
              if (this.parseNewCallee(t2), this.eat(10)) {
                let e2 = this.parseExprList(11);
                this.toReferencedList(e2), t2.arguments = e2;
              } else
                t2.arguments = [];
              return this.finishNode(t2, "NewExpression");
            }
            parseNewCallee(t2) {
              t2.callee = this.parseNoCallExpr(), t2.callee.type === "Import" ? this.raise(u.ImportCallNotNewExpression, { at: t2.callee }) : this.isOptionalChain(t2.callee) ? this.raise(u.OptionalChainingNoNew, { at: this.state.lastTokEndLoc }) : this.eat(18) && this.raise(u.OptionalChainingNoNew, { at: this.state.startLoc });
            }
            parseTemplateElement(t2) {
              let { start: e2, startLoc: s2, end: r2, value: i2 } = this.state, a = e2 + 1, n = this.startNodeAt(a, m2(s2, 1));
              i2 === null && (t2 || this.raise(u.InvalidEscapeSequenceTemplate, { at: m2(s2, 2) }));
              let o = this.match(24), c = o ? -1 : -2, f3 = r2 + c;
              return n.value = { raw: this.input.slice(a, f3).replace(/\r\n?/g, `
`), cooked: i2 === null ? null : i2.slice(1, c) }, n.tail = o, this.next(), this.finishNode(n, "TemplateElement"), this.resetEndLocation(n, m2(this.state.lastTokEndLoc, c)), n;
            }
            parseTemplate(t2) {
              let e2 = this.startNode();
              e2.expressions = [];
              let s2 = this.parseTemplateElement(t2);
              for (e2.quasis = [s2]; !s2.tail; )
                e2.expressions.push(this.parseTemplateSubstitution()), this.readTemplateContinuation(), e2.quasis.push(s2 = this.parseTemplateElement(t2));
              return this.finishNode(e2, "TemplateLiteral");
            }
            parseTemplateSubstitution() {
              return this.parseExpression();
            }
            parseObjectLike(t2, e2, s2, r2) {
              s2 && this.expectPlugin("recordAndTuple");
              let i2 = this.state.inFSharpPipelineDirectBody;
              this.state.inFSharpPipelineDirectBody = false;
              let a = /* @__PURE__ */ Object.create(null), n = true, o = this.startNode();
              for (o.properties = [], this.next(); !this.match(t2); ) {
                if (n)
                  n = false;
                else if (this.expect(12), this.match(t2)) {
                  this.addTrailingCommaExtraToNode(o);
                  break;
                }
                let f3;
                e2 ? f3 = this.parseBindingProperty() : (f3 = this.parsePropertyDefinition(r2), this.checkProto(f3, s2, a, r2)), s2 && !this.isObjectProperty(f3) && f3.type !== "SpreadElement" && this.raise(u.InvalidRecordProperty, { at: f3 }), f3.shorthand && this.addExtra(f3, "shorthand", true), o.properties.push(f3);
              }
              this.next(), this.state.inFSharpPipelineDirectBody = i2;
              let c = "ObjectExpression";
              return e2 ? c = "ObjectPattern" : s2 && (c = "RecordExpression"), this.finishNode(o, c);
            }
            addTrailingCommaExtraToNode(t2) {
              this.addExtra(t2, "trailingComma", this.state.lastTokStart), this.addExtra(t2, "trailingCommaLoc", this.state.lastTokStartLoc, false);
            }
            maybeAsyncOrAccessorProp(t2) {
              return !t2.computed && t2.key.type === "Identifier" && (this.isLiteralPropertyName() || this.match(0) || this.match(55));
            }
            parsePropertyDefinition(t2) {
              let e2 = [];
              if (this.match(26))
                for (this.hasPlugin("decorators") && this.raise(u.UnsupportedPropertyDecorator, { at: this.state.startLoc }); this.match(26); )
                  e2.push(this.parseDecorator());
              let s2 = this.startNode(), r2 = false, i2 = false, a, n;
              if (this.match(21))
                return e2.length && this.unexpected(), this.parseSpread();
              e2.length && (s2.decorators = e2, e2 = []), s2.method = false, t2 && (a = this.state.start, n = this.state.startLoc);
              let o = this.eat(55);
              this.parsePropertyNamePrefixOperator(s2);
              let c = this.state.containsEsc, f3 = this.parsePropertyName(s2, t2);
              if (!o && !c && this.maybeAsyncOrAccessorProp(s2)) {
                let y = f3.name;
                y === "async" && !this.hasPrecedingLineBreak() && (r2 = true, this.resetPreviousNodeTrailingComments(f3), o = this.eat(55), this.parsePropertyName(s2)), (y === "get" || y === "set") && (i2 = true, this.resetPreviousNodeTrailingComments(f3), s2.kind = y, this.match(55) && (o = true, this.raise(u.AccessorIsGenerator, { at: this.state.curPosition(), kind: y }), this.next()), this.parsePropertyName(s2));
              }
              return this.parseObjPropValue(s2, a, n, o, r2, false, i2, t2), s2;
            }
            getGetterSetterExpectedParamCount(t2) {
              return t2.kind === "get" ? 0 : 1;
            }
            getObjectOrClassMethodParams(t2) {
              return t2.params;
            }
            checkGetterSetterParams(t2) {
              var e2;
              let s2 = this.getGetterSetterExpectedParamCount(t2), r2 = this.getObjectOrClassMethodParams(t2);
              r2.length !== s2 && this.raise(t2.kind === "get" ? u.BadGetterArity : u.BadSetterArity, { at: t2 }), t2.kind === "set" && ((e2 = r2[r2.length - 1]) == null ? void 0 : e2.type) === "RestElement" && this.raise(u.BadSetterRestParameter, { at: t2 });
            }
            parseObjectMethod(t2, e2, s2, r2, i2) {
              if (i2)
                return this.parseMethod(t2, e2, false, false, false, "ObjectMethod"), this.checkGetterSetterParams(t2), t2;
              if (s2 || e2 || this.match(10))
                return r2 && this.unexpected(), t2.kind = "method", t2.method = true, this.parseMethod(t2, e2, s2, false, false, "ObjectMethod");
            }
            parseObjectProperty(t2, e2, s2, r2, i2) {
              if (t2.shorthand = false, this.eat(14))
                return t2.value = r2 ? this.parseMaybeDefault(this.state.start, this.state.startLoc) : this.parseMaybeAssignAllowIn(i2), this.finishNode(t2, "ObjectProperty");
              if (!t2.computed && t2.key.type === "Identifier") {
                if (this.checkReservedWord(t2.key.name, t2.key.loc.start, true, false), r2)
                  t2.value = this.parseMaybeDefault(e2, s2, ge(t2.key));
                else if (this.match(29)) {
                  let a = this.state.startLoc;
                  i2 != null ? i2.shorthandAssignLoc === null && (i2.shorthandAssignLoc = a) : this.raise(u.InvalidCoverInitializedName, { at: a }), t2.value = this.parseMaybeDefault(e2, s2, ge(t2.key));
                } else
                  t2.value = ge(t2.key);
                return t2.shorthand = true, this.finishNode(t2, "ObjectProperty");
              }
            }
            parseObjPropValue(t2, e2, s2, r2, i2, a, n, o) {
              let c = this.parseObjectMethod(t2, r2, i2, a, n) || this.parseObjectProperty(t2, e2, s2, a, o);
              return c || this.unexpected(), c;
            }
            parsePropertyName(t2, e2) {
              if (this.eat(0))
                t2.computed = true, t2.key = this.parseMaybeAssignAllowIn(), this.expect(3);
              else {
                let { type: s2, value: r2 } = this.state, i2;
                if (pe(s2))
                  i2 = this.parseIdentifier(true);
                else
                  switch (s2) {
                    case 130:
                      i2 = this.parseNumericLiteral(r2);
                      break;
                    case 129:
                      i2 = this.parseStringLiteral(r2);
                      break;
                    case 131:
                      i2 = this.parseBigIntLiteral(r2);
                      break;
                    case 132:
                      i2 = this.parseDecimalLiteral(r2);
                      break;
                    case 134: {
                      let a = this.state.startLoc;
                      e2 != null ? e2.privateKeyLoc === null && (e2.privateKeyLoc = a) : this.raise(u.UnexpectedPrivateField, { at: a }), i2 = this.parsePrivateName();
                      break;
                    }
                    default:
                      throw this.unexpected();
                  }
                t2.key = i2, s2 !== 134 && (t2.computed = false);
              }
              return t2.key;
            }
            initFunction(t2, e2) {
              t2.id = null, t2.generator = false, t2.async = !!e2;
            }
            parseMethod(t2, e2, s2, r2, i2, a) {
              let n = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : false;
              this.initFunction(t2, s2), t2.generator = !!e2;
              let o = r2;
              return this.scope.enter(me | ot | (n ? Se : 0) | (i2 ? xr : 0)), this.prodParam.enter(gt(s2, t2.generator)), this.parseFunctionParams(t2, o), this.parseFunctionBodyAndFinish(t2, a, true), this.prodParam.exit(), this.scope.exit(), t2;
            }
            parseArrayLike(t2, e2, s2, r2) {
              s2 && this.expectPlugin("recordAndTuple");
              let i2 = this.state.inFSharpPipelineDirectBody;
              this.state.inFSharpPipelineDirectBody = false;
              let a = this.startNode();
              return this.next(), a.elements = this.parseExprList(t2, !s2, r2, a), this.state.inFSharpPipelineDirectBody = i2, this.finishNode(a, s2 ? "TupleExpression" : "ArrayExpression");
            }
            parseArrowExpression(t2, e2, s2, r2) {
              this.scope.enter(me | Jt);
              let i2 = gt(s2, false);
              !this.match(5) && this.prodParam.hasIn && (i2 |= qe), this.prodParam.enter(i2), this.initFunction(t2, s2);
              let a = this.state.maybeInArrowParameters;
              return e2 && (this.state.maybeInArrowParameters = true, this.setArrowFunctionParameters(t2, e2, r2)), this.state.maybeInArrowParameters = false, this.parseFunctionBody(t2, true), this.prodParam.exit(), this.scope.exit(), this.state.maybeInArrowParameters = a, this.finishNode(t2, "ArrowFunctionExpression");
            }
            setArrowFunctionParameters(t2, e2, s2) {
              this.toAssignableList(e2, s2, false), t2.params = e2;
            }
            parseFunctionBodyAndFinish(t2, e2) {
              let s2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              this.parseFunctionBody(t2, false, s2), this.finishNode(t2, e2);
            }
            parseFunctionBody(t2, e2) {
              let s2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, r2 = e2 && !this.match(5);
              if (this.expressionScope.enter(Dr()), r2)
                t2.body = this.parseMaybeAssign(), this.checkParams(t2, false, e2, false);
              else {
                let i2 = this.state.strict, a = this.state.labels;
                this.state.labels = [], this.prodParam.enter(this.prodParam.currentFlags() | Lr), t2.body = this.parseBlock(true, false, (n) => {
                  let o = !this.isSimpleParamList(t2.params);
                  n && o && this.raise(u.IllegalLanguageModeDirective, { at: (t2.kind === "method" || t2.kind === "constructor") && !!t2.key ? t2.key.loc.end : t2 });
                  let c = !i2 && this.state.strict;
                  this.checkParams(t2, !this.state.strict && !e2 && !s2 && !o, e2, c), this.state.strict && t2.id && this.checkIdentifier(t2.id, Xo, c);
                }), this.prodParam.exit(), this.state.labels = a;
              }
              this.expressionScope.exit();
            }
            isSimpleParameter(t2) {
              return t2.type === "Identifier";
            }
            isSimpleParamList(t2) {
              for (let e2 = 0, s2 = t2.length; e2 < s2; e2++)
                if (!this.isSimpleParameter(t2[e2]))
                  return false;
              return true;
            }
            checkParams(t2, e2, s2) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true, i2 = !e2 && /* @__PURE__ */ new Set(), a = { type: "FormalParameters" };
              for (let n of t2.params)
                this.checkLVal(n, { in: a, binding: pt, checkClashes: i2, strictModeChanged: r2 });
            }
            parseExprList(t2, e2, s2, r2) {
              let i2 = [], a = true;
              for (; !this.eat(t2); ) {
                if (a)
                  a = false;
                else if (this.expect(12), this.match(t2)) {
                  r2 && this.addTrailingCommaExtraToNode(r2), this.next();
                  break;
                }
                i2.push(this.parseExprListItem(e2, s2));
              }
              return i2;
            }
            parseExprListItem(t2, e2, s2) {
              let r2;
              if (this.match(12))
                t2 || this.raise(u.UnexpectedToken, { at: this.state.curPosition(), unexpected: "," }), r2 = null;
              else if (this.match(21)) {
                let i2 = this.state.start, a = this.state.startLoc;
                r2 = this.parseParenItem(this.parseSpread(e2), i2, a);
              } else if (this.match(17)) {
                this.expectPlugin("partialApplication"), s2 || this.raise(u.UnexpectedArgumentPlaceholder, { at: this.state.startLoc });
                let i2 = this.startNode();
                this.next(), r2 = this.finishNode(i2, "ArgumentPlaceholder");
              } else
                r2 = this.parseMaybeAssignAllowIn(e2, this.parseParenItem);
              return r2;
            }
            parseIdentifier(t2) {
              let e2 = this.startNode(), s2 = this.parseIdentifierName(e2.start, t2);
              return this.createIdentifier(e2, s2);
            }
            createIdentifier(t2, e2) {
              return t2.name = e2, t2.loc.identifierName = e2, this.finishNode(t2, "Identifier");
            }
            parseIdentifierName(t2, e2) {
              let s2, { startLoc: r2, type: i2 } = this.state;
              if (pe(i2))
                s2 = this.state.value;
              else
                throw this.unexpected();
              let a = vo(i2);
              return e2 ? a && this.replaceToken(128) : this.checkReservedWord(s2, r2, a, false), this.next(), s2;
            }
            checkReservedWord(t2, e2, s2, r2) {
              if (t2.length > 10 || !Ho(t2))
                return;
              if (t2 === "yield") {
                if (this.prodParam.hasYield) {
                  this.raise(u.YieldBindingIdentifier, { at: e2 });
                  return;
                }
              } else if (t2 === "await") {
                if (this.prodParam.hasAwait) {
                  this.raise(u.AwaitBindingIdentifier, { at: e2 });
                  return;
                }
                if (this.scope.inStaticBlock) {
                  this.raise(u.AwaitBindingIdentifierInStaticBlock, { at: e2 });
                  return;
                }
                this.expressionScope.recordAsyncArrowParametersError({ at: e2 });
              } else if (t2 === "arguments" && this.scope.inClassAndNotInNonArrowFunction) {
                this.raise(u.ArgumentsInClass, { at: e2 });
                return;
              }
              if (s2 && zo(t2)) {
                this.raise(u.UnexpectedKeyword, { at: e2, keyword: t2 });
                return;
              }
              (this.state.strict ? r2 ? mr : fr : pr)(t2, this.inModule) && this.raise(u.UnexpectedReservedWord, { at: e2, reservedWord: t2 });
            }
            isAwaitAllowed() {
              return !!(this.prodParam.hasAwait || this.options.allowAwaitOutsideFunction && !this.scope.inFunction);
            }
            parseAwait(t2, e2) {
              let s2 = this.startNodeAt(t2, e2);
              return this.expressionScope.recordParameterInitializerError(u.AwaitExpressionFormalParameter, { at: s2 }), this.eat(55) && this.raise(u.ObsoleteAwaitStar, { at: s2 }), !this.scope.inFunction && !this.options.allowAwaitOutsideFunction && (this.isAmbiguousAwait() ? this.ambiguousScriptDifferentAst = true : this.sawUnambiguousESM = true), this.state.soloAwait || (s2.argument = this.parseMaybeUnary(null, true)), this.finishNode(s2, "AwaitExpression");
            }
            isAmbiguousAwait() {
              if (this.hasPrecedingLineBreak())
                return true;
              let { type: t2 } = this.state;
              return t2 === 53 || t2 === 10 || t2 === 0 || nt(t2) || t2 === 133 || t2 === 56 || this.hasPlugin("v8intrinsic") && t2 === 54;
            }
            parseYield() {
              let t2 = this.startNode();
              this.expressionScope.recordParameterInitializerError(u.YieldInParameter, { at: t2 }), this.next();
              let e2 = false, s2 = null;
              if (!this.hasPrecedingLineBreak())
                switch (e2 = this.eat(55), this.state.type) {
                  case 13:
                  case 135:
                  case 8:
                  case 11:
                  case 3:
                  case 9:
                  case 14:
                  case 12:
                    if (!e2)
                      break;
                  default:
                    s2 = this.parseMaybeAssign();
                }
              return t2.delegate = e2, t2.argument = s2, this.finishNode(t2, "YieldExpression");
            }
            checkPipelineAtInfixOperator(t2, e2) {
              this.hasPlugin(["pipelineOperator", { proposal: "smart" }]) && t2.type === "SequenceExpression" && this.raise(u.PipelineHeadSequenceExpression, { at: e2 });
            }
            parseSmartPipelineBodyInStyle(t2, e2, s2) {
              let r2 = this.startNodeAt(e2, s2);
              return this.isSimpleReference(t2) ? (r2.callee = t2, this.finishNode(r2, "PipelineBareFunction")) : (this.checkSmartPipeTopicBodyEarlyErrors(s2), r2.expression = t2, this.finishNode(r2, "PipelineTopicExpression"));
            }
            isSimpleReference(t2) {
              switch (t2.type) {
                case "MemberExpression":
                  return !t2.computed && this.isSimpleReference(t2.object);
                case "Identifier":
                  return true;
                default:
                  return false;
              }
            }
            checkSmartPipeTopicBodyEarlyErrors(t2) {
              if (this.match(19))
                throw this.raise(u.PipelineBodyNoArrow, { at: this.state.startLoc });
              this.topicReferenceWasUsedInCurrentContext() || this.raise(u.PipelineTopicUnused, { at: t2 });
            }
            withTopicBindingContext(t2) {
              let e2 = this.state.topicContext;
              this.state.topicContext = { maxNumOfResolvableTopics: 1, maxTopicIndex: null };
              try {
                return t2();
              } finally {
                this.state.topicContext = e2;
              }
            }
            withSmartMixTopicForbiddingContext(t2) {
              if (this.hasPlugin(["pipelineOperator", { proposal: "smart" }])) {
                let e2 = this.state.topicContext;
                this.state.topicContext = { maxNumOfResolvableTopics: 0, maxTopicIndex: null };
                try {
                  return t2();
                } finally {
                  this.state.topicContext = e2;
                }
              } else
                return t2();
            }
            withSoloAwaitPermittingContext(t2) {
              let e2 = this.state.soloAwait;
              this.state.soloAwait = true;
              try {
                return t2();
              } finally {
                this.state.soloAwait = e2;
              }
            }
            allowInAnd(t2) {
              let e2 = this.prodParam.currentFlags();
              if (qe & ~e2) {
                this.prodParam.enter(e2 | qe);
                try {
                  return t2();
                } finally {
                  this.prodParam.exit();
                }
              }
              return t2();
            }
            disallowInAnd(t2) {
              let e2 = this.prodParam.currentFlags();
              if (qe & e2) {
                this.prodParam.enter(e2 & ~qe);
                try {
                  return t2();
                } finally {
                  this.prodParam.exit();
                }
              }
              return t2();
            }
            registerTopicReference() {
              this.state.topicContext.maxTopicIndex = 0;
            }
            topicReferenceIsAllowedInCurrentContext() {
              return this.state.topicContext.maxNumOfResolvableTopics >= 1;
            }
            topicReferenceWasUsedInCurrentContext() {
              return this.state.topicContext.maxTopicIndex != null && this.state.topicContext.maxTopicIndex >= 0;
            }
            parseFSharpPipelineBody(t2) {
              let e2 = this.state.start, s2 = this.state.startLoc;
              this.state.potentialArrowAt = this.state.start;
              let r2 = this.state.inFSharpPipelineDirectBody;
              this.state.inFSharpPipelineDirectBody = true;
              let i2 = this.parseExprOp(this.parseMaybeUnaryOrPrivate(), e2, s2, t2);
              return this.state.inFSharpPipelineDirectBody = r2, i2;
            }
            parseModuleExpression() {
              this.expectPlugin("moduleBlocks");
              let t2 = this.startNode();
              this.next(), this.eat(5);
              let e2 = this.initializeScopes(true);
              this.enterInitialScopes();
              let s2 = this.startNode();
              try {
                t2.body = this.parseProgram(s2, 8, "module");
              } finally {
                e2();
              }
              return this.eat(8), this.finishNode(t2, "ModuleExpression");
            }
            parsePropertyNamePrefixOperator(t2) {
            }
          }, ps = { kind: "loop" }, $h = { kind: "switch" }, Qh = 0, fs4 = 1, Hr = 2, Wr = 4, Zh = /[\uD800-\uDFFF]/u, ds = /in(?:stanceof)?/y;
          function el(t2, e2) {
            for (let s2 = 0; s2 < t2.length; s2++) {
              let r2 = t2[s2], { type: i2 } = r2;
              if (typeof i2 == "number") {
                {
                  if (i2 === 134) {
                    let { loc: a, start: n, value: o, end: c } = r2, f3 = n + 1, y = m2(a.start, 1);
                    t2.splice(s2, 1, new Ee({ type: fe(27), value: "#", start: n, end: f3, startLoc: a.start, endLoc: y }), new Ee({ type: fe(128), value: o, start: f3, end: c, startLoc: y, endLoc: a.end })), s2++;
                    continue;
                  }
                  if (nt(i2)) {
                    let { loc: a, start: n, value: o, end: c } = r2, f3 = n + 1, y = m2(a.start, 1), P;
                    e2.charCodeAt(n) === 96 ? P = new Ee({ type: fe(22), value: "`", start: n, end: f3, startLoc: a.start, endLoc: y }) : P = new Ee({ type: fe(8), value: "}", start: n, end: f3, startLoc: a.start, endLoc: y });
                    let v, N, B, _;
                    i2 === 24 ? (N = c - 1, B = m2(a.end, -1), v = o === null ? null : o.slice(1, -1), _ = new Ee({ type: fe(22), value: "`", start: N, end: c, startLoc: B, endLoc: a.end })) : (N = c - 2, B = m2(a.end, -2), v = o === null ? null : o.slice(1, -2), _ = new Ee({ type: fe(23), value: "${", start: N, end: c, startLoc: B, endLoc: a.end })), t2.splice(s2, 1, P, new Ee({ type: fe(20), value: v, start: f3, end: N, startLoc: y, endLoc: B }), _), s2 += 2;
                    continue;
                  }
                }
                r2.type = fe(i2);
              }
            }
            return t2;
          }
          var tl = class extends Yh {
            parseTopLevel(t2, e2) {
              return t2.program = this.parseProgram(e2), t2.comments = this.state.comments, this.options.tokens && (t2.tokens = el(this.tokens, this.input)), this.finishNode(t2, "File");
            }
            parseProgram(t2) {
              let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 135, s2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : this.options.sourceType;
              if (t2.sourceType = s2, t2.interpreter = this.parseInterpreterDirective(), this.parseBlockBody(t2, true, true, e2), this.inModule && !this.options.allowUndeclaredExports && this.scope.undefinedExports.size > 0)
                for (let [r2, i2] of Array.from(this.scope.undefinedExports))
                  this.raise(u.ModuleExportUndefined, { at: i2, localName: r2 });
              return this.finishNode(t2, "Program");
            }
            stmtToDirective(t2) {
              let e2 = t2;
              e2.type = "Directive", e2.value = e2.expression, delete e2.expression;
              let s2 = e2.value, r2 = s2.value, i2 = this.input.slice(s2.start, s2.end), a = s2.value = i2.slice(1, -1);
              return this.addExtra(s2, "raw", i2), this.addExtra(s2, "rawValue", a), this.addExtra(s2, "expressionValue", r2), s2.type = "DirectiveLiteral", e2;
            }
            parseInterpreterDirective() {
              if (!this.match(28))
                return null;
              let t2 = this.startNode();
              return t2.value = this.state.value, this.next(), this.finishNode(t2, "InterpreterDirective");
            }
            isLet(t2) {
              return this.isContextual(99) ? this.isLetKeyword(t2) : false;
            }
            isLetKeyword(t2) {
              let e2 = this.nextTokenStart(), s2 = this.codePointAtPos(e2);
              if (s2 === 92 || s2 === 91)
                return true;
              if (t2)
                return false;
              if (s2 === 123)
                return true;
              if (de(s2)) {
                if (ds.lastIndex = e2, ds.test(this.input)) {
                  let r2 = this.codePointAtPos(ds.lastIndex);
                  if (!Be(r2) && r2 !== 92)
                    return false;
                }
                return true;
              }
              return false;
            }
            parseStatement(t2, e2) {
              return this.match(26) && this.parseDecorators(true), this.parseStatementContent(t2, e2);
            }
            parseStatementContent(t2, e2) {
              let s2 = this.state.type, r2 = this.startNode(), i2;
              switch (this.isLet(t2) && (s2 = 74, i2 = "let"), s2) {
                case 60:
                  return this.parseBreakContinueStatement(r2, true);
                case 63:
                  return this.parseBreakContinueStatement(r2, false);
                case 64:
                  return this.parseDebuggerStatement(r2);
                case 90:
                  return this.parseDoStatement(r2);
                case 91:
                  return this.parseForStatement(r2);
                case 68:
                  if (this.lookaheadCharCode() === 46)
                    break;
                  return t2 && (this.state.strict ? this.raise(u.StrictFunction, { at: this.state.startLoc }) : t2 !== "if" && t2 !== "label" && this.raise(u.SloppyFunction, { at: this.state.startLoc })), this.parseFunctionStatement(r2, false, !t2);
                case 80:
                  return t2 && this.unexpected(), this.parseClass(r2, true);
                case 69:
                  return this.parseIfStatement(r2);
                case 70:
                  return this.parseReturnStatement(r2);
                case 71:
                  return this.parseSwitchStatement(r2);
                case 72:
                  return this.parseThrowStatement(r2);
                case 73:
                  return this.parseTryStatement(r2);
                case 75:
                case 74:
                  return i2 = i2 || this.state.value, t2 && i2 !== "var" && this.raise(u.UnexpectedLexicalDeclaration, { at: this.state.startLoc }), this.parseVarStatement(r2, i2);
                case 92:
                  return this.parseWhileStatement(r2);
                case 76:
                  return this.parseWithStatement(r2);
                case 5:
                  return this.parseBlock();
                case 13:
                  return this.parseEmptyStatement(r2);
                case 83: {
                  let o = this.lookaheadCharCode();
                  if (o === 40 || o === 46)
                    break;
                }
                case 82: {
                  !this.options.allowImportExportEverywhere && !e2 && this.raise(u.UnexpectedImportExport, { at: this.state.startLoc }), this.next();
                  let o;
                  return s2 === 83 ? (o = this.parseImport(r2), o.type === "ImportDeclaration" && (!o.importKind || o.importKind === "value") && (this.sawUnambiguousESM = true)) : (o = this.parseExport(r2), (o.type === "ExportNamedDeclaration" && (!o.exportKind || o.exportKind === "value") || o.type === "ExportAllDeclaration" && (!o.exportKind || o.exportKind === "value") || o.type === "ExportDefaultDeclaration") && (this.sawUnambiguousESM = true)), this.assertModuleNodeAllowed(r2), o;
                }
                default:
                  if (this.isAsyncFunction())
                    return t2 && this.raise(u.AsyncFunctionInSingleStatementContext, { at: this.state.startLoc }), this.next(), this.parseFunctionStatement(r2, true, !t2);
              }
              let a = this.state.value, n = this.parseExpression();
              return K(s2) && n.type === "Identifier" && this.eat(14) ? this.parseLabeledStatement(r2, a, n, t2) : this.parseExpressionStatement(r2, n);
            }
            assertModuleNodeAllowed(t2) {
              !this.options.allowImportExportEverywhere && !this.inModule && this.raise(u.ImportOutsideModule, { at: t2 });
            }
            takeDecorators(t2) {
              let e2 = this.state.decoratorStack[this.state.decoratorStack.length - 1];
              e2.length && (t2.decorators = e2, this.resetStartLocationFromNode(t2, e2[0]), this.state.decoratorStack[this.state.decoratorStack.length - 1] = []);
            }
            canHaveLeadingDecorator() {
              return this.match(80);
            }
            parseDecorators(t2) {
              let e2 = this.state.decoratorStack[this.state.decoratorStack.length - 1];
              for (; this.match(26); ) {
                let s2 = this.parseDecorator();
                e2.push(s2);
              }
              if (this.match(82))
                t2 || this.unexpected(), this.hasPlugin("decorators") && !this.getPluginOption("decorators", "decoratorsBeforeExport") && this.raise(u.DecoratorExportClass, { at: this.state.startLoc });
              else if (!this.canHaveLeadingDecorator())
                throw this.raise(u.UnexpectedLeadingDecorator, { at: this.state.startLoc });
            }
            parseDecorator() {
              this.expectOnePlugin(["decorators-legacy", "decorators"]);
              let t2 = this.startNode();
              if (this.next(), this.hasPlugin("decorators")) {
                this.state.decoratorStack.push([]);
                let e2 = this.state.start, s2 = this.state.startLoc, r2;
                if (this.match(10)) {
                  let i2 = this.state.start, a = this.state.startLoc;
                  this.next(), r2 = this.parseExpression(), this.expect(11), r2 = this.wrapParenthesis(i2, a, r2);
                } else
                  for (r2 = this.parseIdentifier(false); this.eat(16); ) {
                    let i2 = this.startNodeAt(e2, s2);
                    i2.object = r2, i2.property = this.parseIdentifier(true), i2.computed = false, r2 = this.finishNode(i2, "MemberExpression");
                  }
                t2.expression = this.parseMaybeDecoratorArguments(r2), this.state.decoratorStack.pop();
              } else
                t2.expression = this.parseExprSubscripts();
              return this.finishNode(t2, "Decorator");
            }
            parseMaybeDecoratorArguments(t2) {
              if (this.eat(10)) {
                let e2 = this.startNodeAtNode(t2);
                return e2.callee = t2, e2.arguments = this.parseCallExpressionArguments(11, false), this.toReferencedList(e2.arguments), this.finishNode(e2, "CallExpression");
              }
              return t2;
            }
            parseBreakContinueStatement(t2, e2) {
              return this.next(), this.isLineTerminator() ? t2.label = null : (t2.label = this.parseIdentifier(), this.semicolon()), this.verifyBreakContinue(t2, e2), this.finishNode(t2, e2 ? "BreakStatement" : "ContinueStatement");
            }
            verifyBreakContinue(t2, e2) {
              let s2;
              for (s2 = 0; s2 < this.state.labels.length; ++s2) {
                let r2 = this.state.labels[s2];
                if ((t2.label == null || r2.name === t2.label.name) && (r2.kind != null && (e2 || r2.kind === "loop") || t2.label && e2))
                  break;
              }
              if (s2 === this.state.labels.length) {
                let r2 = e2 ? "BreakStatement" : "ContinueStatement";
                this.raise(u.IllegalBreakContinue, { at: t2, type: r2 });
              }
            }
            parseDebuggerStatement(t2) {
              return this.next(), this.semicolon(), this.finishNode(t2, "DebuggerStatement");
            }
            parseHeaderExpression() {
              this.expect(10);
              let t2 = this.parseExpression();
              return this.expect(11), t2;
            }
            parseDoStatement(t2) {
              return this.next(), this.state.labels.push(ps), t2.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("do")), this.state.labels.pop(), this.expect(92), t2.test = this.parseHeaderExpression(), this.eat(13), this.finishNode(t2, "DoWhileStatement");
            }
            parseForStatement(t2) {
              this.next(), this.state.labels.push(ps);
              let e2 = null;
              if (this.isAwaitAllowed() && this.eatContextual(96) && (e2 = this.state.lastTokStartLoc), this.scope.enter(Me), this.expect(10), this.match(13))
                return e2 !== null && this.unexpected(e2), this.parseFor(t2, null);
              let s2 = this.isContextual(99), r2 = s2 && this.isLetKeyword();
              if (this.match(74) || this.match(75) || r2) {
                let c = this.startNode(), f3 = r2 ? "let" : this.state.value;
                return this.next(), this.parseVar(c, true, f3), this.finishNode(c, "VariableDeclaration"), (this.match(58) || this.isContextual(101)) && c.declarations.length === 1 ? this.parseForIn(t2, c, e2) : (e2 !== null && this.unexpected(e2), this.parseFor(t2, c));
              }
              let i2 = this.isContextual(95), a = new At(), n = this.parseExpression(true, a), o = this.isContextual(101);
              if (o && (s2 && this.raise(u.ForOfLet, { at: n }), e2 === null && i2 && n.type === "Identifier" && this.raise(u.ForOfAsync, { at: n })), o || this.match(58)) {
                this.checkDestructuringPrivate(a), this.toAssignable(n, true);
                let c = o ? "ForOfStatement" : "ForInStatement";
                return this.checkLVal(n, { in: { type: c } }), this.parseForIn(t2, n, e2);
              } else
                this.checkExpressionErrors(a, true);
              return e2 !== null && this.unexpected(e2), this.parseFor(t2, n);
            }
            parseFunctionStatement(t2, e2, s2) {
              return this.next(), this.parseFunction(t2, fs4 | (s2 ? 0 : Hr), e2);
            }
            parseIfStatement(t2) {
              return this.next(), t2.test = this.parseHeaderExpression(), t2.consequent = this.parseStatement("if"), t2.alternate = this.eat(66) ? this.parseStatement("if") : null, this.finishNode(t2, "IfStatement");
            }
            parseReturnStatement(t2) {
              return !this.prodParam.hasReturn && !this.options.allowReturnOutsideFunction && this.raise(u.IllegalReturn, { at: this.state.startLoc }), this.next(), this.isLineTerminator() ? t2.argument = null : (t2.argument = this.parseExpression(), this.semicolon()), this.finishNode(t2, "ReturnStatement");
            }
            parseSwitchStatement(t2) {
              this.next(), t2.discriminant = this.parseHeaderExpression();
              let e2 = t2.cases = [];
              this.expect(5), this.state.labels.push($h), this.scope.enter(Me);
              let s2;
              for (let r2; !this.match(8); )
                if (this.match(61) || this.match(65)) {
                  let i2 = this.match(61);
                  s2 && this.finishNode(s2, "SwitchCase"), e2.push(s2 = this.startNode()), s2.consequent = [], this.next(), i2 ? s2.test = this.parseExpression() : (r2 && this.raise(u.MultipleDefaultsInSwitch, { at: this.state.lastTokStartLoc }), r2 = true, s2.test = null), this.expect(14);
                } else
                  s2 ? s2.consequent.push(this.parseStatement(null)) : this.unexpected();
              return this.scope.exit(), s2 && this.finishNode(s2, "SwitchCase"), this.next(), this.state.labels.pop(), this.finishNode(t2, "SwitchStatement");
            }
            parseThrowStatement(t2) {
              return this.next(), this.hasPrecedingLineBreak() && this.raise(u.NewlineAfterThrow, { at: this.state.lastTokEndLoc }), t2.argument = this.parseExpression(), this.semicolon(), this.finishNode(t2, "ThrowStatement");
            }
            parseCatchClauseParam() {
              let t2 = this.parseBindingAtom(), e2 = t2.type === "Identifier";
              return this.scope.enter(e2 ? yr : 0), this.checkLVal(t2, { in: { type: "CatchClause" }, binding: xe, allowingSloppyLetBinding: true }), t2;
            }
            parseTryStatement(t2) {
              if (this.next(), t2.block = this.parseBlock(), t2.handler = null, this.match(62)) {
                let e2 = this.startNode();
                this.next(), this.match(10) ? (this.expect(10), e2.param = this.parseCatchClauseParam(), this.expect(11)) : (e2.param = null, this.scope.enter(Me)), e2.body = this.withSmartMixTopicForbiddingContext(() => this.parseBlock(false, false)), this.scope.exit(), t2.handler = this.finishNode(e2, "CatchClause");
              }
              return t2.finalizer = this.eat(67) ? this.parseBlock() : null, !t2.handler && !t2.finalizer && this.raise(u.NoCatchOrFinally, { at: t2 }), this.finishNode(t2, "TryStatement");
            }
            parseVarStatement(t2, e2) {
              let s2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
              return this.next(), this.parseVar(t2, false, e2, s2), this.semicolon(), this.finishNode(t2, "VariableDeclaration");
            }
            parseWhileStatement(t2) {
              return this.next(), t2.test = this.parseHeaderExpression(), this.state.labels.push(ps), t2.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("while")), this.state.labels.pop(), this.finishNode(t2, "WhileStatement");
            }
            parseWithStatement(t2) {
              return this.state.strict && this.raise(u.StrictWith, { at: this.state.startLoc }), this.next(), t2.object = this.parseHeaderExpression(), t2.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("with")), this.finishNode(t2, "WithStatement");
            }
            parseEmptyStatement(t2) {
              return this.next(), this.finishNode(t2, "EmptyStatement");
            }
            parseLabeledStatement(t2, e2, s2, r2) {
              for (let a of this.state.labels)
                a.name === e2 && this.raise(u.LabelRedeclaration, { at: s2, labelName: e2 });
              let i2 = No(this.state.type) ? "loop" : this.match(71) ? "switch" : null;
              for (let a = this.state.labels.length - 1; a >= 0; a--) {
                let n = this.state.labels[a];
                if (n.statementStart === t2.start)
                  n.statementStart = this.state.start, n.kind = i2;
                else
                  break;
              }
              return this.state.labels.push({ name: e2, kind: i2, statementStart: this.state.start }), t2.body = this.parseStatement(r2 ? r2.indexOf("label") === -1 ? r2 + "label" : r2 : "label"), this.state.labels.pop(), t2.label = s2, this.finishNode(t2, "LabeledStatement");
            }
            parseExpressionStatement(t2, e2) {
              return t2.expression = e2, this.semicolon(), this.finishNode(t2, "ExpressionStatement");
            }
            parseBlock() {
              let t2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : false, e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true, s2 = arguments.length > 2 ? arguments[2] : void 0, r2 = this.startNode();
              return t2 && this.state.strictErrors.clear(), this.expect(5), e2 && this.scope.enter(Me), this.parseBlockBody(r2, t2, false, 8, s2), e2 && this.scope.exit(), this.finishNode(r2, "BlockStatement");
            }
            isValidDirective(t2) {
              return t2.type === "ExpressionStatement" && t2.expression.type === "StringLiteral" && !t2.expression.extra.parenthesized;
            }
            parseBlockBody(t2, e2, s2, r2, i2) {
              let a = t2.body = [], n = t2.directives = [];
              this.parseBlockOrModuleBlockBody(a, e2 ? n : void 0, s2, r2, i2);
            }
            parseBlockOrModuleBlockBody(t2, e2, s2, r2, i2) {
              let a = this.state.strict, n = false, o = false;
              for (; !this.match(r2); ) {
                let c = this.parseStatement(null, s2);
                if (e2 && !o) {
                  if (this.isValidDirective(c)) {
                    let f3 = this.stmtToDirective(c);
                    e2.push(f3), !n && f3.value.value === "use strict" && (n = true, this.setStrict(true));
                    continue;
                  }
                  o = true, this.state.strictErrors.clear();
                }
                t2.push(c);
              }
              i2 && i2.call(this, n), a || this.setStrict(false), this.next();
            }
            parseFor(t2, e2) {
              return t2.init = e2, this.semicolon(false), t2.test = this.match(13) ? null : this.parseExpression(), this.semicolon(false), t2.update = this.match(11) ? null : this.parseExpression(), this.expect(11), t2.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("for")), this.scope.exit(), this.state.labels.pop(), this.finishNode(t2, "ForStatement");
            }
            parseForIn(t2, e2, s2) {
              let r2 = this.match(58);
              return this.next(), r2 ? s2 !== null && this.unexpected(s2) : t2.await = s2 !== null, e2.type === "VariableDeclaration" && e2.declarations[0].init != null && (!r2 || this.state.strict || e2.kind !== "var" || e2.declarations[0].id.type !== "Identifier") && this.raise(u.ForInOfLoopInitializer, { at: e2, type: r2 ? "ForInStatement" : "ForOfStatement" }), e2.type === "AssignmentPattern" && this.raise(u.InvalidLhs, { at: e2, ancestor: { type: "ForStatement" } }), t2.left = e2, t2.right = r2 ? this.parseExpression() : this.parseMaybeAssignAllowIn(), this.expect(11), t2.body = this.withSmartMixTopicForbiddingContext(() => this.parseStatement("for")), this.scope.exit(), this.state.labels.pop(), this.finishNode(t2, r2 ? "ForInStatement" : "ForOfStatement");
            }
            parseVar(t2, e2, s2) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, i2 = t2.declarations = [];
              for (t2.kind = s2; ; ) {
                let a = this.startNode();
                if (this.parseVarId(a, s2), a.init = this.eat(29) ? e2 ? this.parseMaybeAssignDisallowIn() : this.parseMaybeAssignAllowIn() : null, a.init === null && !r2 && (a.id.type !== "Identifier" && !(e2 && (this.match(58) || this.isContextual(101))) ? this.raise(u.DeclarationMissingInitializer, { at: this.state.lastTokEndLoc, kind: "destructuring" }) : s2 === "const" && !(this.match(58) || this.isContextual(101)) && this.raise(u.DeclarationMissingInitializer, { at: this.state.lastTokEndLoc, kind: "const" })), i2.push(this.finishNode(a, "VariableDeclarator")), !this.eat(12))
                  break;
              }
              return t2;
            }
            parseVarId(t2, e2) {
              t2.id = this.parseBindingAtom(), this.checkLVal(t2.id, { in: { type: "VariableDeclarator" }, binding: e2 === "var" ? pt : xe });
            }
            parseFunction(t2) {
              let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : Qh, s2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, r2 = e2 & fs4, i2 = e2 & Hr, a = !!r2 && !(e2 & Wr);
              this.initFunction(t2, s2), this.match(55) && i2 && this.raise(u.GeneratorInSingleStatementContext, { at: this.state.startLoc }), t2.generator = this.eat(55), r2 && (t2.id = this.parseFunctionId(a));
              let n = this.state.maybeInArrowParameters;
              return this.state.maybeInArrowParameters = false, this.scope.enter(me), this.prodParam.enter(gt(s2, t2.generator)), r2 || (t2.id = this.parseFunctionId()), this.parseFunctionParams(t2, false), this.withSmartMixTopicForbiddingContext(() => {
                this.parseFunctionBodyAndFinish(t2, r2 ? "FunctionDeclaration" : "FunctionExpression");
              }), this.prodParam.exit(), this.scope.exit(), r2 && !i2 && this.registerFunctionStatementId(t2), this.state.maybeInArrowParameters = n, t2;
            }
            parseFunctionId(t2) {
              return t2 || K(this.state.type) ? this.parseIdentifier() : null;
            }
            parseFunctionParams(t2, e2) {
              this.expect(10), this.expressionScope.enter(gh()), t2.params = this.parseBindingList(11, 41, false, e2), this.expressionScope.exit();
            }
            registerFunctionStatementId(t2) {
              !t2.id || this.scope.declareName(t2.id.name, this.state.strict || t2.generator || t2.async ? this.scope.treatFunctionsAsVar ? pt : xe : Tr, t2.id.loc.start);
            }
            parseClass(t2, e2, s2) {
              this.next(), this.takeDecorators(t2);
              let r2 = this.state.strict;
              return this.state.strict = true, this.parseClassId(t2, e2, s2), this.parseClassSuper(t2), t2.body = this.parseClassBody(!!t2.superClass, r2), this.finishNode(t2, e2 ? "ClassDeclaration" : "ClassExpression");
            }
            isClassProperty() {
              return this.match(29) || this.match(13) || this.match(8);
            }
            isClassMethod() {
              return this.match(10);
            }
            isNonstaticConstructor(t2) {
              return !t2.computed && !t2.static && (t2.key.name === "constructor" || t2.key.value === "constructor");
            }
            parseClassBody(t2, e2) {
              this.classScope.enter();
              let s2 = { hadConstructor: false, hadSuperClass: t2 }, r2 = [], i2 = this.startNode();
              if (i2.body = [], this.expect(5), this.withSmartMixTopicForbiddingContext(() => {
                for (; !this.match(8); ) {
                  if (this.eat(13)) {
                    if (r2.length > 0)
                      throw this.raise(u.DecoratorSemicolon, { at: this.state.lastTokEndLoc });
                    continue;
                  }
                  if (this.match(26)) {
                    r2.push(this.parseDecorator());
                    continue;
                  }
                  let a = this.startNode();
                  r2.length && (a.decorators = r2, this.resetStartLocationFromNode(a, r2[0]), r2 = []), this.parseClassMember(i2, a, s2), a.kind === "constructor" && a.decorators && a.decorators.length > 0 && this.raise(u.DecoratorConstructor, { at: a });
                }
              }), this.state.strict = e2, this.next(), r2.length)
                throw this.raise(u.TrailingDecorator, { at: this.state.startLoc });
              return this.classScope.exit(), this.finishNode(i2, "ClassBody");
            }
            parseClassMemberFromModifier(t2, e2) {
              let s2 = this.parseIdentifier(true);
              if (this.isClassMethod()) {
                let r2 = e2;
                return r2.kind = "method", r2.computed = false, r2.key = s2, r2.static = false, this.pushClassMethod(t2, r2, false, false, false, false), true;
              } else if (this.isClassProperty()) {
                let r2 = e2;
                return r2.computed = false, r2.key = s2, r2.static = false, t2.body.push(this.parseClassProperty(r2)), true;
              }
              return this.resetPreviousNodeTrailingComments(s2), false;
            }
            parseClassMember(t2, e2, s2) {
              let r2 = this.isContextual(104);
              if (r2) {
                if (this.parseClassMemberFromModifier(t2, e2))
                  return;
                if (this.eat(5)) {
                  this.parseClassStaticBlock(t2, e2);
                  return;
                }
              }
              this.parseClassMemberWithIsStatic(t2, e2, s2, r2);
            }
            parseClassMemberWithIsStatic(t2, e2, s2, r2) {
              let i2 = e2, a = e2, n = e2, o = e2, c = e2, f3 = i2, y = i2;
              if (e2.static = r2, this.parsePropertyNamePrefixOperator(e2), this.eat(55)) {
                f3.kind = "method";
                let _ = this.match(134);
                if (this.parseClassElementName(f3), _) {
                  this.pushClassPrivateMethod(t2, a, true, false);
                  return;
                }
                this.isNonstaticConstructor(i2) && this.raise(u.ConstructorIsGenerator, { at: i2.key }), this.pushClassMethod(t2, i2, true, false, false, false);
                return;
              }
              let P = K(this.state.type) && !this.state.containsEsc, v = this.match(134), N = this.parseClassElementName(e2), B = this.state.startLoc;
              if (this.parsePostMemberNameModifiers(y), this.isClassMethod()) {
                if (f3.kind = "method", v) {
                  this.pushClassPrivateMethod(t2, a, false, false);
                  return;
                }
                let _ = this.isNonstaticConstructor(i2), Q = false;
                _ && (i2.kind = "constructor", s2.hadConstructor && !this.hasPlugin("typescript") && this.raise(u.DuplicateConstructor, { at: N }), _ && this.hasPlugin("typescript") && e2.override && this.raise(u.OverrideOnConstructor, { at: N }), s2.hadConstructor = true, Q = s2.hadSuperClass), this.pushClassMethod(t2, i2, false, false, _, Q);
              } else if (this.isClassProperty())
                v ? this.pushClassPrivateProperty(t2, o) : this.pushClassProperty(t2, n);
              else if (P && N.name === "async" && !this.isLineTerminator()) {
                this.resetPreviousNodeTrailingComments(N);
                let _ = this.eat(55);
                y.optional && this.unexpected(B), f3.kind = "method";
                let Q = this.match(134);
                this.parseClassElementName(f3), this.parsePostMemberNameModifiers(y), Q ? this.pushClassPrivateMethod(t2, a, _, true) : (this.isNonstaticConstructor(i2) && this.raise(u.ConstructorIsAsync, { at: i2.key }), this.pushClassMethod(t2, i2, _, true, false, false));
              } else if (P && (N.name === "get" || N.name === "set") && !(this.match(55) && this.isLineTerminator())) {
                this.resetPreviousNodeTrailingComments(N), f3.kind = N.name;
                let _ = this.match(134);
                this.parseClassElementName(i2), _ ? this.pushClassPrivateMethod(t2, a, false, false) : (this.isNonstaticConstructor(i2) && this.raise(u.ConstructorIsAccessor, { at: i2.key }), this.pushClassMethod(t2, i2, false, false, false, false)), this.checkGetterSetterParams(i2);
              } else if (P && N.name === "accessor" && !this.isLineTerminator()) {
                this.expectPlugin("decoratorAutoAccessors"), this.resetPreviousNodeTrailingComments(N);
                let _ = this.match(134);
                this.parseClassElementName(n), this.pushClassAccessorProperty(t2, c, _);
              } else
                this.isLineTerminator() ? v ? this.pushClassPrivateProperty(t2, o) : this.pushClassProperty(t2, n) : this.unexpected();
            }
            parseClassElementName(t2) {
              let { type: e2, value: s2 } = this.state;
              if ((e2 === 128 || e2 === 129) && t2.static && s2 === "prototype" && this.raise(u.StaticPrototype, { at: this.state.startLoc }), e2 === 134) {
                s2 === "constructor" && this.raise(u.ConstructorClassPrivateField, { at: this.state.startLoc });
                let r2 = this.parsePrivateName();
                return t2.key = r2, r2;
              }
              return this.parsePropertyName(t2);
            }
            parseClassStaticBlock(t2, e2) {
              var s2;
              this.scope.enter(Se | Yt | ot);
              let r2 = this.state.labels;
              this.state.labels = [], this.prodParam.enter(je);
              let i2 = e2.body = [];
              this.parseBlockOrModuleBlockBody(i2, void 0, false, 8), this.prodParam.exit(), this.scope.exit(), this.state.labels = r2, t2.body.push(this.finishNode(e2, "StaticBlock")), (s2 = e2.decorators) != null && s2.length && this.raise(u.DecoratorStaticBlock, { at: e2 });
            }
            pushClassProperty(t2, e2) {
              !e2.computed && (e2.key.name === "constructor" || e2.key.value === "constructor") && this.raise(u.ConstructorClassField, { at: e2.key }), t2.body.push(this.parseClassProperty(e2));
            }
            pushClassPrivateProperty(t2, e2) {
              let s2 = this.parseClassPrivateProperty(e2);
              t2.body.push(s2), this.classScope.declarePrivateName(this.getPrivateNameSV(s2.key), is, s2.key.loc.start);
            }
            pushClassAccessorProperty(t2, e2, s2) {
              if (!s2 && !e2.computed) {
                let i2 = e2.key;
                (i2.name === "constructor" || i2.value === "constructor") && this.raise(u.ConstructorClassField, { at: i2 });
              }
              let r2 = this.parseClassAccessorProperty(e2);
              t2.body.push(r2), s2 && this.classScope.declarePrivateName(this.getPrivateNameSV(r2.key), is, r2.key.loc.start);
            }
            pushClassMethod(t2, e2, s2, r2, i2, a) {
              t2.body.push(this.parseMethod(e2, s2, r2, i2, a, "ClassMethod", true));
            }
            pushClassPrivateMethod(t2, e2, s2, r2) {
              let i2 = this.parseMethod(e2, s2, r2, false, false, "ClassPrivateMethod", true);
              t2.body.push(i2);
              let a = i2.kind === "get" ? i2.static ? Qo : eh : i2.kind === "set" ? i2.static ? Zo : th : is;
              this.declareClassPrivateMethodInScope(i2, a);
            }
            declareClassPrivateMethodInScope(t2, e2) {
              this.classScope.declarePrivateName(this.getPrivateNameSV(t2.key), e2, t2.key.loc.start);
            }
            parsePostMemberNameModifiers(t2) {
            }
            parseClassPrivateProperty(t2) {
              return this.parseInitializer(t2), this.semicolon(), this.finishNode(t2, "ClassPrivateProperty");
            }
            parseClassProperty(t2) {
              return this.parseInitializer(t2), this.semicolon(), this.finishNode(t2, "ClassProperty");
            }
            parseClassAccessorProperty(t2) {
              return this.parseInitializer(t2), this.semicolon(), this.finishNode(t2, "ClassAccessorProperty");
            }
            parseInitializer(t2) {
              this.scope.enter(Se | ot), this.expressionScope.enter(Dr()), this.prodParam.enter(je), t2.value = this.eat(29) ? this.parseMaybeAssignAllowIn() : null, this.expressionScope.exit(), this.prodParam.exit(), this.scope.exit();
            }
            parseClassId(t2, e2, s2) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : Pr;
              if (K(this.state.type))
                t2.id = this.parseIdentifier(), e2 && this.declareNameFromIdentifier(t2.id, r2);
              else if (s2 || !e2)
                t2.id = null;
              else
                throw this.raise(u.MissingClassName, { at: this.state.startLoc });
            }
            parseClassSuper(t2) {
              t2.superClass = this.eat(81) ? this.parseExprSubscripts() : null;
            }
            parseExport(t2) {
              let e2 = this.maybeParseExportDefaultSpecifier(t2), s2 = !e2 || this.eat(12), r2 = s2 && this.eatExportStar(t2), i2 = r2 && this.maybeParseExportNamespaceSpecifier(t2), a = s2 && (!i2 || this.eat(12)), n = e2 || r2;
              if (r2 && !i2)
                return e2 && this.unexpected(), this.parseExportFrom(t2, true), this.finishNode(t2, "ExportAllDeclaration");
              let o = this.maybeParseExportNamedSpecifiers(t2);
              if (e2 && s2 && !r2 && !o || i2 && a && !o)
                throw this.unexpected(null, 5);
              let c;
              if (n || o ? (c = false, this.parseExportFrom(t2, n)) : c = this.maybeParseExportDeclaration(t2), n || o || c)
                return this.checkExport(t2, true, false, !!t2.source), this.finishNode(t2, "ExportNamedDeclaration");
              if (this.eat(65))
                return t2.declaration = this.parseExportDefaultExpression(), this.checkExport(t2, true, true), this.finishNode(t2, "ExportDefaultDeclaration");
              throw this.unexpected(null, 5);
            }
            eatExportStar(t2) {
              return this.eat(55);
            }
            maybeParseExportDefaultSpecifier(t2) {
              if (this.isExportDefaultSpecifier()) {
                this.expectPlugin("exportDefaultFrom");
                let e2 = this.startNode();
                return e2.exported = this.parseIdentifier(true), t2.specifiers = [this.finishNode(e2, "ExportDefaultSpecifier")], true;
              }
              return false;
            }
            maybeParseExportNamespaceSpecifier(t2) {
              if (this.isContextual(93)) {
                t2.specifiers || (t2.specifiers = []);
                let e2 = this.startNodeAt(this.state.lastTokStart, this.state.lastTokStartLoc);
                return this.next(), e2.exported = this.parseModuleExportName(), t2.specifiers.push(this.finishNode(e2, "ExportNamespaceSpecifier")), true;
              }
              return false;
            }
            maybeParseExportNamedSpecifiers(t2) {
              if (this.match(5)) {
                t2.specifiers || (t2.specifiers = []);
                let e2 = t2.exportKind === "type";
                return t2.specifiers.push(...this.parseExportSpecifiers(e2)), t2.source = null, t2.declaration = null, this.hasPlugin("importAssertions") && (t2.assertions = []), true;
              }
              return false;
            }
            maybeParseExportDeclaration(t2) {
              return this.shouldParseExportDeclaration() ? (t2.specifiers = [], t2.source = null, this.hasPlugin("importAssertions") && (t2.assertions = []), t2.declaration = this.parseExportDeclaration(t2), true) : false;
            }
            isAsyncFunction() {
              if (!this.isContextual(95))
                return false;
              let t2 = this.nextTokenStart();
              return !as.test(this.input.slice(this.state.pos, t2)) && this.isUnparsedContextual(t2, "function");
            }
            parseExportDefaultExpression() {
              let t2 = this.startNode(), e2 = this.isAsyncFunction();
              if (this.match(68) || e2)
                return this.next(), e2 && this.next(), this.parseFunction(t2, fs4 | Wr, e2);
              if (this.match(80))
                return this.parseClass(t2, true, true);
              if (this.match(26))
                return this.hasPlugin("decorators") && this.getPluginOption("decorators", "decoratorsBeforeExport") && this.raise(u.DecoratorBeforeExport, { at: this.state.startLoc }), this.parseDecorators(false), this.parseClass(t2, true, true);
              if (this.match(75) || this.match(74) || this.isLet())
                throw this.raise(u.UnsupportedDefaultExport, { at: this.state.startLoc });
              let s2 = this.parseMaybeAssignAllowIn();
              return this.semicolon(), s2;
            }
            parseExportDeclaration(t2) {
              return this.parseStatement(null);
            }
            isExportDefaultSpecifier() {
              let { type: t2 } = this.state;
              if (K(t2)) {
                if (t2 === 95 && !this.state.containsEsc || t2 === 99)
                  return false;
                if ((t2 === 126 || t2 === 125) && !this.state.containsEsc) {
                  let { type: r2 } = this.lookahead();
                  if (K(r2) && r2 !== 97 || r2 === 5)
                    return this.expectOnePlugin(["flow", "typescript"]), false;
                }
              } else if (!this.match(65))
                return false;
              let e2 = this.nextTokenStart(), s2 = this.isUnparsedContextual(e2, "from");
              if (this.input.charCodeAt(e2) === 44 || K(this.state.type) && s2)
                return true;
              if (this.match(65) && s2) {
                let r2 = this.input.charCodeAt(this.nextTokenStartSince(e2 + 4));
                return r2 === 34 || r2 === 39;
              }
              return false;
            }
            parseExportFrom(t2, e2) {
              if (this.eatContextual(97)) {
                t2.source = this.parseImportSource(), this.checkExport(t2);
                let s2 = this.maybeParseImportAssertions();
                s2 && (t2.assertions = s2);
              } else
                e2 && this.unexpected();
              this.semicolon();
            }
            shouldParseExportDeclaration() {
              let { type: t2 } = this.state;
              if (t2 === 26 && (this.expectOnePlugin(["decorators", "decorators-legacy"]), this.hasPlugin("decorators"))) {
                if (this.getPluginOption("decorators", "decoratorsBeforeExport"))
                  throw this.raise(u.DecoratorBeforeExport, { at: this.state.startLoc });
                return true;
              }
              return t2 === 74 || t2 === 75 || t2 === 68 || t2 === 80 || this.isLet() || this.isAsyncFunction();
            }
            checkExport(t2, e2, s2, r2) {
              if (e2) {
                if (s2) {
                  if (this.checkDuplicateExports(t2, "default"), this.hasPlugin("exportDefaultFrom")) {
                    var i2;
                    let n = t2.declaration;
                    n.type === "Identifier" && n.name === "from" && n.end - n.start === 4 && !((i2 = n.extra) != null && i2.parenthesized) && this.raise(u.ExportDefaultFromAsIdentifier, { at: n });
                  }
                } else if (t2.specifiers && t2.specifiers.length)
                  for (let n of t2.specifiers) {
                    let { exported: o } = n, c = o.type === "Identifier" ? o.name : o.value;
                    if (this.checkDuplicateExports(n, c), !r2 && n.local) {
                      let { local: f3 } = n;
                      f3.type !== "Identifier" ? this.raise(u.ExportBindingIsString, { at: n, localName: f3.value, exportName: c }) : (this.checkReservedWord(f3.name, f3.loc.start, true, false), this.scope.checkLocalExport(f3));
                    }
                  }
                else if (t2.declaration) {
                  if (t2.declaration.type === "FunctionDeclaration" || t2.declaration.type === "ClassDeclaration") {
                    let n = t2.declaration.id;
                    if (!n)
                      throw new Error("Assertion failure");
                    this.checkDuplicateExports(t2, n.name);
                  } else if (t2.declaration.type === "VariableDeclaration")
                    for (let n of t2.declaration.declarations)
                      this.checkDeclaration(n.id);
                }
              }
              if (this.state.decoratorStack[this.state.decoratorStack.length - 1].length)
                throw this.raise(u.UnsupportedDecoratorExport, { at: t2 });
            }
            checkDeclaration(t2) {
              if (t2.type === "Identifier")
                this.checkDuplicateExports(t2, t2.name);
              else if (t2.type === "ObjectPattern")
                for (let e2 of t2.properties)
                  this.checkDeclaration(e2);
              else if (t2.type === "ArrayPattern")
                for (let e2 of t2.elements)
                  e2 && this.checkDeclaration(e2);
              else
                t2.type === "ObjectProperty" ? this.checkDeclaration(t2.value) : t2.type === "RestElement" ? this.checkDeclaration(t2.argument) : t2.type === "AssignmentPattern" && this.checkDeclaration(t2.left);
            }
            checkDuplicateExports(t2, e2) {
              this.exportedIdentifiers.has(e2) && (e2 === "default" ? this.raise(u.DuplicateDefaultExport, { at: t2 }) : this.raise(u.DuplicateExport, { at: t2, exportName: e2 })), this.exportedIdentifiers.add(e2);
            }
            parseExportSpecifiers(t2) {
              let e2 = [], s2 = true;
              for (this.expect(5); !this.eat(8); ) {
                if (s2)
                  s2 = false;
                else if (this.expect(12), this.eat(8))
                  break;
                let r2 = this.isContextual(126), i2 = this.match(129), a = this.startNode();
                a.local = this.parseModuleExportName(), e2.push(this.parseExportSpecifier(a, i2, t2, r2));
              }
              return e2;
            }
            parseExportSpecifier(t2, e2, s2, r2) {
              return this.eatContextual(93) ? t2.exported = this.parseModuleExportName() : e2 ? t2.exported = bh(t2.local) : t2.exported || (t2.exported = ge(t2.local)), this.finishNode(t2, "ExportSpecifier");
            }
            parseModuleExportName() {
              if (this.match(129)) {
                let t2 = this.parseStringLiteral(this.state.value), e2 = t2.value.match(Zh);
                return e2 && this.raise(u.ModuleExportNameHasLoneSurrogate, { at: t2, surrogateCharCode: e2[0].charCodeAt(0) }), t2;
              }
              return this.parseIdentifier(true);
            }
            parseImport(t2) {
              if (t2.specifiers = [], !this.match(129)) {
                let r2 = !this.maybeParseDefaultImportSpecifier(t2) || this.eat(12), i2 = r2 && this.maybeParseStarImportSpecifier(t2);
                r2 && !i2 && this.parseNamedImportSpecifiers(t2), this.expectContextual(97);
              }
              t2.source = this.parseImportSource();
              let e2 = this.maybeParseImportAssertions();
              if (e2)
                t2.assertions = e2;
              else {
                let s2 = this.maybeParseModuleAttributes();
                s2 && (t2.attributes = s2);
              }
              return this.semicolon(), this.finishNode(t2, "ImportDeclaration");
            }
            parseImportSource() {
              return this.match(129) || this.unexpected(), this.parseExprAtom();
            }
            shouldParseDefaultImport(t2) {
              return K(this.state.type);
            }
            parseImportSpecifierLocal(t2, e2, s2) {
              e2.local = this.parseIdentifier(), t2.specifiers.push(this.finishImportSpecifier(e2, s2));
            }
            finishImportSpecifier(t2, e2) {
              return this.checkLVal(t2.local, { in: t2, binding: xe }), this.finishNode(t2, e2);
            }
            parseAssertEntries() {
              let t2 = [], e2 = /* @__PURE__ */ new Set();
              do {
                if (this.match(8))
                  break;
                let s2 = this.startNode(), r2 = this.state.value;
                if (e2.has(r2) && this.raise(u.ModuleAttributesWithDuplicateKeys, { at: this.state.startLoc, key: r2 }), e2.add(r2), this.match(129) ? s2.key = this.parseStringLiteral(r2) : s2.key = this.parseIdentifier(true), this.expect(14), !this.match(129))
                  throw this.raise(u.ModuleAttributeInvalidValue, { at: this.state.startLoc });
                s2.value = this.parseStringLiteral(this.state.value), this.finishNode(s2, "ImportAttribute"), t2.push(s2);
              } while (this.eat(12));
              return t2;
            }
            maybeParseModuleAttributes() {
              if (this.match(76) && !this.hasPrecedingLineBreak())
                this.expectPlugin("moduleAttributes"), this.next();
              else
                return this.hasPlugin("moduleAttributes") ? [] : null;
              let t2 = [], e2 = /* @__PURE__ */ new Set();
              do {
                let s2 = this.startNode();
                if (s2.key = this.parseIdentifier(true), s2.key.name !== "type" && this.raise(u.ModuleAttributeDifferentFromType, { at: s2.key }), e2.has(s2.key.name) && this.raise(u.ModuleAttributesWithDuplicateKeys, { at: s2.key, key: s2.key.name }), e2.add(s2.key.name), this.expect(14), !this.match(129))
                  throw this.raise(u.ModuleAttributeInvalidValue, { at: this.state.startLoc });
                s2.value = this.parseStringLiteral(this.state.value), this.finishNode(s2, "ImportAttribute"), t2.push(s2);
              } while (this.eat(12));
              return t2;
            }
            maybeParseImportAssertions() {
              if (this.isContextual(94) && !this.hasPrecedingLineBreak())
                this.expectPlugin("importAssertions"), this.next();
              else
                return this.hasPlugin("importAssertions") ? [] : null;
              this.eat(5);
              let t2 = this.parseAssertEntries();
              return this.eat(8), t2;
            }
            maybeParseDefaultImportSpecifier(t2) {
              return this.shouldParseDefaultImport(t2) ? (this.parseImportSpecifierLocal(t2, this.startNode(), "ImportDefaultSpecifier"), true) : false;
            }
            maybeParseStarImportSpecifier(t2) {
              if (this.match(55)) {
                let e2 = this.startNode();
                return this.next(), this.expectContextual(93), this.parseImportSpecifierLocal(t2, e2, "ImportNamespaceSpecifier"), true;
              }
              return false;
            }
            parseNamedImportSpecifiers(t2) {
              let e2 = true;
              for (this.expect(5); !this.eat(8); ) {
                if (e2)
                  e2 = false;
                else {
                  if (this.eat(14))
                    throw this.raise(u.DestructureNamedImport, { at: this.state.startLoc });
                  if (this.expect(12), this.eat(8))
                    break;
                }
                let s2 = this.startNode(), r2 = this.match(129), i2 = this.isContextual(126);
                s2.imported = this.parseModuleExportName();
                let a = this.parseImportSpecifier(s2, r2, t2.importKind === "type" || t2.importKind === "typeof", i2);
                t2.specifiers.push(a);
              }
            }
            parseImportSpecifier(t2, e2, s2, r2) {
              if (this.eatContextual(93))
                t2.local = this.parseIdentifier();
              else {
                let { imported: i2 } = t2;
                if (e2)
                  throw this.raise(u.ImportBindingIsString, { at: t2, importName: i2.value });
                this.checkReservedWord(i2.name, t2.loc.start, true, true), t2.local || (t2.local = ge(i2));
              }
              return this.finishImportSpecifier(t2, "ImportSpecifier");
            }
            isThisParam(t2) {
              return t2.type === "Identifier" && t2.name === "this";
            }
          }, Gr = class extends tl {
            constructor(t2, e2) {
              t2 = Gh(t2), super(t2, e2), this.options = t2, this.initializeScopes(), this.plugins = sl(this.options.plugins), this.filename = t2.sourceFilename;
            }
            getScopeHandler() {
              return hs;
            }
            parse() {
              this.enterInitialScopes();
              let t2 = this.startNode(), e2 = this.startNode();
              return this.nextToken(), t2.errors = null, this.parseTopLevel(t2, e2), t2.errors = this.state.errors, t2;
            }
          };
          function sl(t2) {
            let e2 = /* @__PURE__ */ new Map();
            for (let s2 of t2) {
              let [r2, i2] = Array.isArray(s2) ? s2 : [s2, {}];
              e2.has(r2) || e2.set(r2, i2 || {});
            }
            return e2;
          }
          function rl(t2, e2) {
            var s2;
            if (((s2 = e2) == null ? void 0 : s2.sourceType) === "unambiguous") {
              e2 = Object.assign({}, e2);
              try {
                e2.sourceType = "module";
                let r2 = Ye(e2, t2), i2 = r2.parse();
                if (r2.sawUnambiguousESM)
                  return i2;
                if (r2.ambiguousScriptDifferentAst)
                  try {
                    return e2.sourceType = "script", Ye(e2, t2).parse();
                  } catch {
                  }
                else
                  i2.program.sourceType = "script";
                return i2;
              } catch (r2) {
                try {
                  return e2.sourceType = "script", Ye(e2, t2).parse();
                } catch {
                }
                throw r2;
              }
            } else
              return Ye(e2, t2).parse();
          }
          function il(t2, e2) {
            let s2 = Ye(e2, t2);
            return s2.options.strictMode && (s2.state.strict = true), s2.getExpression();
          }
          function al(t2) {
            let e2 = {};
            for (let s2 of Object.keys(t2))
              e2[s2] = fe(t2[s2]);
            return e2;
          }
          var nl = al(bo);
          function Ye(t2, e2) {
            let s2 = Gr;
            return t2 != null && t2.plugins && (Hh(t2.plugins), s2 = ol(t2.plugins)), new s2(t2, e2);
          }
          var Xr = {};
          function ol(t2) {
            let e2 = Wh.filter((i2) => ee(t2, i2)), s2 = e2.join("/"), r2 = Xr[s2];
            if (!r2) {
              r2 = Gr;
              for (let i2 of e2)
                r2 = zr[i2](r2);
              Xr[s2] = r2;
            }
            return r2;
          }
          h2.parse = rl, h2.parseExpression = il, h2.tokTypes = nl;
        } }), Pf = H({ "src/language-js/parse/json.js"(h2, l) {
          "use strict";
          V();
          var p = fo(), d = nr(), m2 = yo(), A2 = xo();
          function g() {
            let E = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, { allowComments: L = true } = E;
            return function(F2) {
              let { parseExpression: W } = Po(), Y;
              try {
                Y = W(F2, { tokens: true, ranges: true });
              } catch (M) {
                throw A2(M);
              }
              if (!L && p(Y.comments))
                throw x2(Y.comments[0], "Comment");
              return T(Y), Y;
            };
          }
          function x2(E, L) {
            let [R, F2] = [E.loc.start, E.loc.end].map((W) => {
              let { line: Y, column: M } = W;
              return { line: Y, column: M + 1 };
            });
            return d("".concat(L, " is not allowed in JSON."), { start: R, end: F2 });
          }
          function T(E) {
            switch (E.type) {
              case "ArrayExpression":
                for (let L of E.elements)
                  L !== null && T(L);
                return;
              case "ObjectExpression":
                for (let L of E.properties)
                  T(L);
                return;
              case "ObjectProperty":
                if (E.computed)
                  throw x2(E.key, "Computed key");
                if (E.shorthand)
                  throw x2(E.key, "Shorthand property");
                E.key.type !== "Identifier" && T(E.key), T(E.value);
                return;
              case "UnaryExpression": {
                let { operator: L, argument: R } = E;
                if (L !== "+" && L !== "-")
                  throw x2(E, "Operator '".concat(E.operator, "'"));
                if (R.type === "NumericLiteral" || R.type === "Identifier" && (R.name === "Infinity" || R.name === "NaN"))
                  return;
                throw x2(R, "Operator '".concat(L, "' before '").concat(R.type, "'"));
              }
              case "Identifier":
                if (E.name !== "Infinity" && E.name !== "NaN" && E.name !== "undefined")
                  throw x2(E, "Identifier '".concat(E.name, "'"));
                return;
              case "TemplateLiteral":
                if (p(E.expressions))
                  throw x2(E.expressions[0], "'TemplateLiteral' with expression");
                for (let L of E.quasis)
                  T(L);
                return;
              case "NullLiteral":
              case "BooleanLiteral":
              case "NumericLiteral":
              case "StringLiteral":
              case "TemplateElement":
                return;
              default:
                throw x2(E, "'".concat(E.type, "'"));
            }
          }
          var k = g(), D = { json: m2({ parse: k, hasPragma() {
            return true;
          } }), json5: m2(k), "json-stringify": m2({ parse: g({ allowComments: false }), astFormat: "estree-json" }) };
          l.exports = D;
        } });
        V();
        var Tf = ef(), Ef = Qn(), Cf = af(), ze = yo(), bf = xo(), vf = Af(), Sf = Pf(), wf = { sourceType: "module", allowImportExportEverywhere: true, allowReturnOutsideFunction: true, allowSuperOutsideMethod: true, allowUndeclaredExports: true, errorRecovery: true, createParenthesizedExpressions: true, plugins: ["doExpressions", "exportDefaultFrom", "functionBind", "functionSent", "throwExpressions", "partialApplication", ["decorators", { decoratorsBeforeExport: false }], "importAssertions", "decimal", "moduleBlocks", "asyncDoExpressions", "regexpUnicodeSets", "destructuringPrivate", "decoratorAutoAccessors"], tokens: true, ranges: true }, Nf = ["recordAndTuple", { syntaxType: "hash" }], Wn = "v8intrinsic", Gn = [["pipelineOperator", { proposal: "hack", topicToken: "%" }], ["pipelineOperator", { proposal: "minimal" }], ["pipelineOperator", { proposal: "fsharp" }]], ue = function(h2) {
          let l = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : wf;
          return Object.assign(Object.assign({}, l), {}, { plugins: [...l.plugins, ...h2] });
        }, If = /@(?:no)?flow\b/;
        function kf(h2, l) {
          if (l.filepath && l.filepath.endsWith(".js.flow"))
            return true;
          let p = Ef(h2);
          p && (h2 = h2.slice(p.length));
          let d = Cf(h2, 0);
          return d !== false && (h2 = h2.slice(0, d)), If.test(h2);
        }
        function Df(h2, l, p) {
          let m2 = Po()[h2](l, p), A2 = m2.errors.find((g) => !Rf.has(g.reasonCode));
          if (A2)
            throw A2;
          return m2;
        }
        function Ke(h2) {
          for (var l = arguments.length, p = new Array(l > 1 ? l - 1 : 0), d = 1; d < l; d++)
            p[d - 1] = arguments[d];
          return function(m2, A2) {
            let g = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            if ((g.parser === "babel" || g.parser === "__babel_estree") && kf(m2, g))
              return g.parser = "babel-flow", To(m2, A2, g);
            let x2 = p;
            g.__babelSourceType === "script" && (x2 = x2.map((E) => Object.assign(Object.assign({}, E), {}, { sourceType: "script" }))), /#[[{]/.test(m2) && (x2 = x2.map((E) => ue([Nf], E)));
            let T = /%[A-Z]/.test(m2);
            m2.includes("|>") ? x2 = (T ? [...Gn, Wn] : Gn).flatMap((L) => x2.map((R) => ue([L], R))) : T && (x2 = x2.map((E) => ue([Wn], E)));
            let { result: k, error: D } = Tf(...x2.map((E) => () => Df(h2, m2, E)));
            if (!k)
              throw bf(D);
            return g.originalText = m2, vf(k, g);
          };
        }
        var Ff = Ke("parse", ue(["jsx", "flow"])), To = Ke("parse", ue(["jsx", ["flow", { all: true, enums: true }]])), Lf = Ke("parse", ue(["jsx", "typescript"]), ue(["typescript"])), Of = Ke("parse", ue(["jsx", "flow", "estree"])), Bf = Ke("parseExpression", ue(["jsx"])), Mf = Ke("parseExpression", ue(["typescript"])), Rf = /* @__PURE__ */ new Set(["StrictNumericEscape", "StrictWith", "StrictOctalLiteral", "StrictDelete", "StrictEvalArguments", "StrictEvalArgumentsBinding", "StrictFunction", "EmptyTypeArguments", "EmptyTypeParameters", "ConstructorHasTypeParameters", "UnsupportedParameterPropertyKind", "UnexpectedParameterModifier", "MixedLabeledAndUnlabeledElements", "InvalidTupleMemberLabel", "NonClassMethodPropertyHasAbstractModifer", "ReadonlyForMethodSignature", "ClassMethodHasDeclare", "ClassMethodHasReadonly", "InvalidModifierOnTypeMember", "DuplicateAccessibilityModifier", "IndexSignatureHasDeclare", "DecoratorExportClass", "ParamDupe", "InvalidDecimal", "RestTrailingComma", "UnsupportedParameterDecorator", "UnterminatedJsxContent", "UnexpectedReservedWord", "ModuleAttributesWithDuplicateKeys", "LineTerminatorBeforeArrow", "InvalidEscapeSequenceTemplate", "NonAbstractClassHasAbstractMethod", "UnsupportedPropertyDecorator", "OptionalTypeBeforeRequired", "PatternIsOptional", "OptionalBindingPattern", "DeclareClassFieldHasInitializer", "TypeImportCannotSpecifyDefaultAndNamed", "DeclareFunctionHasImplementation", "ConstructorClassField", "VarRedeclaration", "InvalidPrivateFieldResolution", "DuplicateExport"]), Xn = ze(Ff), Jn = ze(Lf), Yn = ze(Bf), jf = ze(Mf);
        Eo.exports = { parsers: Object.assign(Object.assign({ babel: Xn, "babel-flow": ze(To), "babel-ts": Jn }, Sf), {}, { __js_expression: Yn, __vue_expression: Yn, __vue_ts_expression: jf, __vue_event_binding: Xn, __vue_ts_event_binding: Jn, __babel_estree: ze(Of) }) };
      });
      return qf();
    });
  }
});

// node_modules/prettier/parser-flow.js
var require_parser_flow = __commonJS({
  "node_modules/prettier/parser-flow.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.flow = e2();
      }
    })(function() {
      "use strict";
      var Be = (H0, z0) => () => (z0 || H0((z0 = { exports: {} }).exports, z0), z0.exports);
      var ru = Be((_oe, rn0) => {
        var h_ = function(H0) {
          return H0 && H0.Math == Math && H0;
        };
        rn0.exports = h_(typeof globalThis == "object" && globalThis) || h_(typeof window == "object" && window) || h_(typeof self == "object" && self) || h_(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      });
      var Qs = Be((yoe, en0) => {
        en0.exports = function(H0) {
          try {
            return !!H0();
          } catch {
            return true;
          }
        };
      });
      var fv = Be((hoe, nn0) => {
        var N7e = Qs();
        nn0.exports = !N7e(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var jR = Be((doe, tn0) => {
        var C7e = Qs();
        tn0.exports = !C7e(function() {
          var H0 = function() {
          }.bind();
          return typeof H0 != "function" || H0.hasOwnProperty("prototype");
        });
      });
      var k_ = Be((koe, un0) => {
        var P7e = jR(), d_ = Function.prototype.call;
        un0.exports = P7e ? d_.bind(d_) : function() {
          return d_.apply(d_, arguments);
        };
      });
      var on0 = Be((xn0) => {
        "use strict";
        var in0 = {}.propertyIsEnumerable, fn0 = Object.getOwnPropertyDescriptor, D7e = fn0 && !in0.call({ 1: 2 }, 1);
        xn0.f = D7e ? function(z0) {
          var xr = fn0(this, z0);
          return !!xr && xr.enumerable;
        } : in0;
      });
      var GR = Be((Eoe, an0) => {
        an0.exports = function(H0, z0) {
          return { enumerable: !(H0 & 1), configurable: !(H0 & 2), writable: !(H0 & 4), value: z0 };
        };
      });
      var zc = Be((Soe, vn0) => {
        var cn0 = jR(), sn0 = Function.prototype, L7e = sn0.bind, MR = sn0.call, R7e = cn0 && L7e.bind(MR, MR);
        vn0.exports = cn0 ? function(H0) {
          return H0 && R7e(H0);
        } : function(H0) {
          return H0 && function() {
            return MR.apply(H0, arguments);
          };
        };
      });
      var pn0 = Be((goe, bn0) => {
        var ln0 = zc(), j7e = ln0({}.toString), G7e = ln0("".slice);
        bn0.exports = function(H0) {
          return G7e(j7e(H0), 8, -1);
        };
      });
      var _n0 = Be((Foe, mn0) => {
        var M7e = ru(), B7e = zc(), q7e = Qs(), U7e = pn0(), BR = M7e.Object, H7e = B7e("".split);
        mn0.exports = q7e(function() {
          return !BR("z").propertyIsEnumerable(0);
        }) ? function(H0) {
          return U7e(H0) == "String" ? H7e(H0, "") : BR(H0);
        } : BR;
      });
      var qR = Be((Toe, yn0) => {
        var X7e = ru(), Y7e = X7e.TypeError;
        yn0.exports = function(H0) {
          if (H0 == null)
            throw Y7e("Can't call method on " + H0);
          return H0;
        };
      });
      var w_ = Be((Ooe, hn0) => {
        var V7e = _n0(), z7e = qR();
        hn0.exports = function(H0) {
          return V7e(z7e(H0));
        };
      });
      var Kc = Be((Ioe, dn0) => {
        dn0.exports = function(H0) {
          return typeof H0 == "function";
        };
      });
      var S2 = Be((Aoe, kn0) => {
        var K7e = Kc();
        kn0.exports = function(H0) {
          return typeof H0 == "object" ? H0 !== null : K7e(H0);
        };
      });
      var E_ = Be((Noe, wn0) => {
        var UR = ru(), W7e = Kc(), J7e = function(H0) {
          return W7e(H0) ? H0 : void 0;
        };
        wn0.exports = function(H0, z0) {
          return arguments.length < 2 ? J7e(UR[H0]) : UR[H0] && UR[H0][z0];
        };
      });
      var Sn0 = Be((Coe, En0) => {
        var $7e = zc();
        En0.exports = $7e({}.isPrototypeOf);
      });
      var Fn0 = Be((Poe, gn0) => {
        var Z7e = E_();
        gn0.exports = Z7e("navigator", "userAgent") || "";
      });
      var Pn0 = Be((Doe, Cn0) => {
        var Nn0 = ru(), HR = Fn0(), Tn0 = Nn0.process, On0 = Nn0.Deno, In0 = Tn0 && Tn0.versions || On0 && On0.version, An0 = In0 && In0.v8, $i, S_;
        An0 && ($i = An0.split("."), S_ = $i[0] > 0 && $i[0] < 4 ? 1 : +($i[0] + $i[1]));
        !S_ && HR && ($i = HR.match(/Edge\/(\d+)/), (!$i || $i[1] >= 74) && ($i = HR.match(/Chrome\/(\d+)/), $i && (S_ = +$i[1])));
        Cn0.exports = S_;
      });
      var XR = Be((Loe, Ln0) => {
        var Dn0 = Pn0(), Q7e = Qs();
        Ln0.exports = !!Object.getOwnPropertySymbols && !Q7e(function() {
          var H0 = Symbol();
          return !String(H0) || !(Object(H0) instanceof Symbol) || !Symbol.sham && Dn0 && Dn0 < 41;
        });
      });
      var YR = Be((Roe, Rn0) => {
        var rie = XR();
        Rn0.exports = rie && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var VR = Be((joe, jn0) => {
        var eie = ru(), nie = E_(), tie = Kc(), uie = Sn0(), iie = YR(), fie = eie.Object;
        jn0.exports = iie ? function(H0) {
          return typeof H0 == "symbol";
        } : function(H0) {
          var z0 = nie("Symbol");
          return tie(z0) && uie(z0.prototype, fie(H0));
        };
      });
      var Mn0 = Be((Goe, Gn0) => {
        var xie = ru(), oie = xie.String;
        Gn0.exports = function(H0) {
          try {
            return oie(H0);
          } catch {
            return "Object";
          }
        };
      });
      var qn0 = Be((Moe, Bn0) => {
        var aie = ru(), cie = Kc(), sie = Mn0(), vie = aie.TypeError;
        Bn0.exports = function(H0) {
          if (cie(H0))
            return H0;
          throw vie(sie(H0) + " is not a function");
        };
      });
      var Hn0 = Be((Boe, Un0) => {
        var lie = qn0();
        Un0.exports = function(H0, z0) {
          var xr = H0[z0];
          return xr == null ? void 0 : lie(xr);
        };
      });
      var Yn0 = Be((qoe, Xn0) => {
        var bie = ru(), zR = k_(), KR = Kc(), WR = S2(), pie = bie.TypeError;
        Xn0.exports = function(H0, z0) {
          var xr, gr;
          if (z0 === "string" && KR(xr = H0.toString) && !WR(gr = zR(xr, H0)) || KR(xr = H0.valueOf) && !WR(gr = zR(xr, H0)) || z0 !== "string" && KR(xr = H0.toString) && !WR(gr = zR(xr, H0)))
            return gr;
          throw pie("Can't convert object to primitive value");
        };
      });
      var zn0 = Be((Uoe, Vn0) => {
        Vn0.exports = false;
      });
      var g_ = Be((Hoe, Wn0) => {
        var Kn0 = ru(), mie = Object.defineProperty;
        Wn0.exports = function(H0, z0) {
          try {
            mie(Kn0, H0, { value: z0, configurable: true, writable: true });
          } catch {
            Kn0[H0] = z0;
          }
          return z0;
        };
      });
      var F_ = Be((Xoe, $n0) => {
        var _ie = ru(), yie = g_(), Jn0 = "__core-js_shared__", hie = _ie[Jn0] || yie(Jn0, {});
        $n0.exports = hie;
      });
      var JR = Be((Yoe, Qn0) => {
        var die = zn0(), Zn0 = F_();
        (Qn0.exports = function(H0, z0) {
          return Zn0[H0] || (Zn0[H0] = z0 !== void 0 ? z0 : {});
        })("versions", []).push({ version: "3.22.2", mode: die ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var et0 = Be((Voe, rt0) => {
        var kie = ru(), wie = qR(), Eie = kie.Object;
        rt0.exports = function(H0) {
          return Eie(wie(H0));
        };
      });
      var r1 = Be((zoe, nt0) => {
        var Sie = zc(), gie = et0(), Fie = Sie({}.hasOwnProperty);
        nt0.exports = Object.hasOwn || function(z0, xr) {
          return Fie(gie(z0), xr);
        };
      });
      var $R = Be((Koe, tt0) => {
        var Tie = zc(), Oie = 0, Iie = Math.random(), Aie = Tie(1 .toString);
        tt0.exports = function(H0) {
          return "Symbol(" + (H0 === void 0 ? "" : H0) + ")_" + Aie(++Oie + Iie, 36);
        };
      });
      var at0 = Be((Woe, ot0) => {
        var Nie = ru(), Cie = JR(), ut0 = r1(), Pie = $R(), it0 = XR(), xt0 = YR(), g2 = Cie("wks"), xv = Nie.Symbol, ft0 = xv && xv.for, Die = xt0 ? xv : xv && xv.withoutSetter || Pie;
        ot0.exports = function(H0) {
          if (!ut0(g2, H0) || !(it0 || typeof g2[H0] == "string")) {
            var z0 = "Symbol." + H0;
            it0 && ut0(xv, H0) ? g2[H0] = xv[H0] : xt0 && ft0 ? g2[H0] = ft0(z0) : g2[H0] = Die(z0);
          }
          return g2[H0];
        };
      });
      var lt0 = Be((Joe, vt0) => {
        var Lie = ru(), Rie = k_(), ct0 = S2(), st0 = VR(), jie = Hn0(), Gie = Yn0(), Mie = at0(), Bie = Lie.TypeError, qie = Mie("toPrimitive");
        vt0.exports = function(H0, z0) {
          if (!ct0(H0) || st0(H0))
            return H0;
          var xr = jie(H0, qie), gr;
          if (xr) {
            if (z0 === void 0 && (z0 = "default"), gr = Rie(xr, H0, z0), !ct0(gr) || st0(gr))
              return gr;
            throw Bie("Can't convert object to primitive value");
          }
          return z0 === void 0 && (z0 = "number"), Gie(H0, z0);
        };
      });
      var ZR = Be(($oe, bt0) => {
        var Uie = lt0(), Hie = VR();
        bt0.exports = function(H0) {
          var z0 = Uie(H0, "string");
          return Hie(z0) ? z0 : z0 + "";
        };
      });
      var _t0 = Be((Zoe, mt0) => {
        var Xie = ru(), pt0 = S2(), QR = Xie.document, Yie = pt0(QR) && pt0(QR.createElement);
        mt0.exports = function(H0) {
          return Yie ? QR.createElement(H0) : {};
        };
      });
      var rj = Be((Qoe, yt0) => {
        var Vie = fv(), zie = Qs(), Kie = _t0();
        yt0.exports = !Vie && !zie(function() {
          return Object.defineProperty(Kie("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var ej = Be((dt0) => {
        var Wie = fv(), Jie = k_(), $ie = on0(), Zie = GR(), Qie = w_(), rfe = ZR(), efe = r1(), nfe = rj(), ht0 = Object.getOwnPropertyDescriptor;
        dt0.f = Wie ? ht0 : function(z0, xr) {
          if (z0 = Qie(z0), xr = rfe(xr), nfe)
            try {
              return ht0(z0, xr);
            } catch {
            }
          if (efe(z0, xr))
            return Zie(!Jie($ie.f, z0, xr), z0[xr]);
        };
      });
      var wt0 = Be((eae, kt0) => {
        var tfe = fv(), ufe = Qs();
        kt0.exports = tfe && ufe(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var nj = Be((nae, St0) => {
        var Et0 = ru(), ife = S2(), ffe = Et0.String, xfe = Et0.TypeError;
        St0.exports = function(H0) {
          if (ife(H0))
            return H0;
          throw xfe(ffe(H0) + " is not an object");
        };
      });
      var xj = Be((Ft0) => {
        var ofe = ru(), afe = fv(), cfe = rj(), sfe = wt0(), T_ = nj(), gt0 = ZR(), vfe = ofe.TypeError, tj = Object.defineProperty, lfe = Object.getOwnPropertyDescriptor, uj = "enumerable", ij = "configurable", fj = "writable";
        Ft0.f = afe ? sfe ? function(z0, xr, gr) {
          if (T_(z0), xr = gt0(xr), T_(gr), typeof z0 == "function" && xr === "prototype" && "value" in gr && fj in gr && !gr[fj]) {
            var de = lfe(z0, xr);
            de && de[fj] && (z0[xr] = gr.value, gr = { configurable: ij in gr ? gr[ij] : de[ij], enumerable: uj in gr ? gr[uj] : de[uj], writable: false });
          }
          return tj(z0, xr, gr);
        } : tj : function(z0, xr, gr) {
          if (T_(z0), xr = gt0(xr), T_(gr), cfe)
            try {
              return tj(z0, xr, gr);
            } catch {
            }
          if ("get" in gr || "set" in gr)
            throw vfe("Accessors not supported");
          return "value" in gr && (z0[xr] = gr.value), z0;
        };
      });
      var O_ = Be((uae, Tt0) => {
        var bfe = fv(), pfe = xj(), mfe = GR();
        Tt0.exports = bfe ? function(H0, z0, xr) {
          return pfe.f(H0, z0, mfe(1, xr));
        } : function(H0, z0, xr) {
          return H0[z0] = xr, H0;
        };
      });
      var aj = Be((iae, Ot0) => {
        var _fe = zc(), yfe = Kc(), oj = F_(), hfe = _fe(Function.toString);
        yfe(oj.inspectSource) || (oj.inspectSource = function(H0) {
          return hfe(H0);
        });
        Ot0.exports = oj.inspectSource;
      });
      var Nt0 = Be((fae, At0) => {
        var dfe = ru(), kfe = Kc(), wfe = aj(), It0 = dfe.WeakMap;
        At0.exports = kfe(It0) && /native code/.test(wfe(It0));
      });
      var Dt0 = Be((xae, Pt0) => {
        var Efe = JR(), Sfe = $R(), Ct0 = Efe("keys");
        Pt0.exports = function(H0) {
          return Ct0[H0] || (Ct0[H0] = Sfe(H0));
        };
      });
      var cj = Be((oae, Lt0) => {
        Lt0.exports = {};
      });
      var qt0 = Be((aae, Bt0) => {
        var gfe = Nt0(), Mt0 = ru(), sj = zc(), Ffe = S2(), Tfe = O_(), vj = r1(), lj = F_(), Ofe = Dt0(), Ife = cj(), Rt0 = "Object already initialized", pj = Mt0.TypeError, Afe = Mt0.WeakMap, I_, a4, A_, Nfe = function(H0) {
          return A_(H0) ? a4(H0) : I_(H0, {});
        }, Cfe = function(H0) {
          return function(z0) {
            var xr;
            if (!Ffe(z0) || (xr = a4(z0)).type !== H0)
              throw pj("Incompatible receiver, " + H0 + " required");
            return xr;
          };
        };
        gfe || lj.state ? (e1 = lj.state || (lj.state = new Afe()), jt0 = sj(e1.get), bj = sj(e1.has), Gt0 = sj(e1.set), I_ = function(H0, z0) {
          if (bj(e1, H0))
            throw new pj(Rt0);
          return z0.facade = H0, Gt0(e1, H0, z0), z0;
        }, a4 = function(H0) {
          return jt0(e1, H0) || {};
        }, A_ = function(H0) {
          return bj(e1, H0);
        }) : (ov = Ofe("state"), Ife[ov] = true, I_ = function(H0, z0) {
          if (vj(H0, ov))
            throw new pj(Rt0);
          return z0.facade = H0, Tfe(H0, ov, z0), z0;
        }, a4 = function(H0) {
          return vj(H0, ov) ? H0[ov] : {};
        }, A_ = function(H0) {
          return vj(H0, ov);
        });
        var e1, jt0, bj, Gt0, ov;
        Bt0.exports = { set: I_, get: a4, has: A_, enforce: Nfe, getterFor: Cfe };
      });
      var Xt0 = Be((cae, Ht0) => {
        var mj = fv(), Pfe = r1(), Ut0 = Function.prototype, Dfe = mj && Object.getOwnPropertyDescriptor, _j = Pfe(Ut0, "name"), Lfe = _j && function() {
        }.name === "something", Rfe = _j && (!mj || mj && Dfe(Ut0, "name").configurable);
        Ht0.exports = { EXISTS: _j, PROPER: Lfe, CONFIGURABLE: Rfe };
      });
      var Wt0 = Be((sae, Kt0) => {
        var jfe = ru(), Yt0 = Kc(), Gfe = r1(), Vt0 = O_(), Mfe = g_(), Bfe = aj(), zt0 = qt0(), qfe = Xt0().CONFIGURABLE, Ufe = zt0.get, Hfe = zt0.enforce, Xfe = String(String).split("String");
        (Kt0.exports = function(H0, z0, xr, gr) {
          var de = gr ? !!gr.unsafe : false, Ve = gr ? !!gr.enumerable : false, De = gr ? !!gr.noTargetGet : false, Ke = gr && gr.name !== void 0 ? gr.name : z0, tn;
          if (Yt0(xr) && (String(Ke).slice(0, 7) === "Symbol(" && (Ke = "[" + String(Ke).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!Gfe(xr, "name") || qfe && xr.name !== Ke) && Vt0(xr, "name", Ke), tn = Hfe(xr), tn.source || (tn.source = Xfe.join(typeof Ke == "string" ? Ke : ""))), H0 === jfe) {
            Ve ? H0[z0] = xr : Mfe(z0, xr);
            return;
          } else
            de ? !De && H0[z0] && (Ve = true) : delete H0[z0];
          Ve ? H0[z0] = xr : Vt0(H0, z0, xr);
        })(Function.prototype, "toString", function() {
          return Yt0(this) && Ufe(this).source || Bfe(this);
        });
      });
      var yj = Be((vae, Jt0) => {
        var Yfe = Math.ceil, Vfe = Math.floor;
        Jt0.exports = function(H0) {
          var z0 = +H0;
          return z0 !== z0 || z0 === 0 ? 0 : (z0 > 0 ? Vfe : Yfe)(z0);
        };
      });
      var Zt0 = Be((lae, $t0) => {
        var zfe = yj(), Kfe = Math.max, Wfe = Math.min;
        $t0.exports = function(H0, z0) {
          var xr = zfe(H0);
          return xr < 0 ? Kfe(xr + z0, 0) : Wfe(xr, z0);
        };
      });
      var ru0 = Be((bae, Qt0) => {
        var Jfe = yj(), $fe = Math.min;
        Qt0.exports = function(H0) {
          return H0 > 0 ? $fe(Jfe(H0), 9007199254740991) : 0;
        };
      });
      var nu0 = Be((pae, eu0) => {
        var Zfe = ru0();
        eu0.exports = function(H0) {
          return Zfe(H0.length);
        };
      });
      var iu0 = Be((mae, uu0) => {
        var Qfe = w_(), rxe = Zt0(), exe = nu0(), tu0 = function(H0) {
          return function(z0, xr, gr) {
            var de = Qfe(z0), Ve = exe(de), De = rxe(gr, Ve), Ke;
            if (H0 && xr != xr) {
              for (; Ve > De; )
                if (Ke = de[De++], Ke != Ke)
                  return true;
            } else
              for (; Ve > De; De++)
                if ((H0 || De in de) && de[De] === xr)
                  return H0 || De || 0;
            return !H0 && -1;
          };
        };
        uu0.exports = { includes: tu0(true), indexOf: tu0(false) };
      });
      var ou0 = Be((_ae, xu0) => {
        var nxe = zc(), hj = r1(), txe = w_(), uxe = iu0().indexOf, ixe = cj(), fu0 = nxe([].push);
        xu0.exports = function(H0, z0) {
          var xr = txe(H0), gr = 0, de = [], Ve;
          for (Ve in xr)
            !hj(ixe, Ve) && hj(xr, Ve) && fu0(de, Ve);
          for (; z0.length > gr; )
            hj(xr, Ve = z0[gr++]) && (~uxe(de, Ve) || fu0(de, Ve));
          return de;
        };
      });
      var cu0 = Be((yae, au0) => {
        au0.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var vu0 = Be((su0) => {
        var fxe = ou0(), xxe = cu0(), oxe = xxe.concat("length", "prototype");
        su0.f = Object.getOwnPropertyNames || function(z0) {
          return fxe(z0, oxe);
        };
      });
      var bu0 = Be((lu0) => {
        lu0.f = Object.getOwnPropertySymbols;
      });
      var mu0 = Be((kae, pu0) => {
        var axe = E_(), cxe = zc(), sxe = vu0(), vxe = bu0(), lxe = nj(), bxe = cxe([].concat);
        pu0.exports = axe("Reflect", "ownKeys") || function(z0) {
          var xr = sxe.f(lxe(z0)), gr = vxe.f;
          return gr ? bxe(xr, gr(z0)) : xr;
        };
      });
      var hu0 = Be((wae, yu0) => {
        var _u0 = r1(), pxe = mu0(), mxe = ej(), _xe = xj();
        yu0.exports = function(H0, z0, xr) {
          for (var gr = pxe(z0), de = _xe.f, Ve = mxe.f, De = 0; De < gr.length; De++) {
            var Ke = gr[De];
            !_u0(H0, Ke) && !(xr && _u0(xr, Ke)) && de(H0, Ke, Ve(z0, Ke));
          }
        };
      });
      var ku0 = Be((Eae, du0) => {
        var yxe = Qs(), hxe = Kc(), dxe = /#|\.prototype\./, c4 = function(H0, z0) {
          var xr = wxe[kxe(H0)];
          return xr == Sxe ? true : xr == Exe ? false : hxe(z0) ? yxe(z0) : !!z0;
        }, kxe = c4.normalize = function(H0) {
          return String(H0).replace(dxe, ".").toLowerCase();
        }, wxe = c4.data = {}, Exe = c4.NATIVE = "N", Sxe = c4.POLYFILL = "P";
        du0.exports = c4;
      });
      var Eu0 = Be((Sae, wu0) => {
        var dj = ru(), gxe = ej().f, Fxe = O_(), Txe = Wt0(), Oxe = g_(), Ixe = hu0(), Axe = ku0();
        wu0.exports = function(H0, z0) {
          var xr = H0.target, gr = H0.global, de = H0.stat, Ve, De, Ke, tn, Qn, rt;
          if (gr ? De = dj : de ? De = dj[xr] || Oxe(xr, {}) : De = (dj[xr] || {}).prototype, De)
            for (Ke in z0) {
              if (Qn = z0[Ke], H0.noTargetGet ? (rt = gxe(De, Ke), tn = rt && rt.value) : tn = De[Ke], Ve = Axe(gr ? Ke : xr + (de ? "." : "#") + Ke, H0.forced), !Ve && tn !== void 0) {
                if (typeof Qn == typeof tn)
                  continue;
                Ixe(Qn, tn);
              }
              (H0.sham || tn && tn.sham) && Fxe(Qn, "sham", true), Txe(De, Ke, Qn, H0);
            }
        };
      });
      var Su0 = Be(() => {
        var Nxe = Eu0(), Cxe = ru();
        Nxe({ global: true }, { globalThis: Cxe });
      });
      var gu0 = Be(() => {
        Su0();
      });
      var soe = Be((Iae, zu0) => {
        gu0();
        var Zq = Object.defineProperty, Pxe = Object.getOwnPropertyDescriptor, Qq = Object.getOwnPropertyNames, Dxe = Object.prototype.hasOwnProperty, C_ = (H0, z0) => function() {
          return H0 && (z0 = (0, H0[Qq(H0)[0]])(H0 = 0)), z0;
        }, eu = (H0, z0) => function() {
          return z0 || (0, H0[Qq(H0)[0]])((z0 = { exports: {} }).exports, z0), z0.exports;
        }, rU = (H0, z0) => {
          for (var xr in z0)
            Zq(H0, xr, { get: z0[xr], enumerable: true });
        }, Lxe = (H0, z0, xr, gr) => {
          if (z0 && typeof z0 == "object" || typeof z0 == "function")
            for (let de of Qq(z0))
              !Dxe.call(H0, de) && de !== xr && Zq(H0, de, { get: () => z0[de], enumerable: !(gr = Pxe(z0, de)) || gr.enumerable });
          return H0;
        }, eU = (H0) => Lxe(Zq({}, "__esModule", { value: true }), H0), Pt = C_({ "<define:process>"() {
        } }), Fu0 = eu({ "src/common/parser-create-error.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr, de) {
            let Ve = new SyntaxError(gr + " (" + de.start.line + ":" + de.start.column + ")");
            return Ve.loc = de, Ve;
          }
          z0.exports = xr;
        } }), Tu0 = {};
        rU(Tu0, { EOL: () => Sj, arch: () => Rxe, cpus: () => Du0, default: () => Mu0, endianness: () => Ou0, freemem: () => Cu0, getNetworkInterfaces: () => Gu0, hostname: () => Iu0, loadavg: () => Au0, networkInterfaces: () => ju0, platform: () => jxe, release: () => Ru0, tmpDir: () => wj, tmpdir: () => Ej, totalmem: () => Pu0, type: () => Lu0, uptime: () => Nu0 });
        function Ou0() {
          if (typeof N_ > "u") {
            var H0 = new ArrayBuffer(2), z0 = new Uint8Array(H0), xr = new Uint16Array(H0);
            if (z0[0] = 1, z0[1] = 2, xr[0] === 258)
              N_ = "BE";
            else if (xr[0] === 513)
              N_ = "LE";
            else
              throw new Error("unable to figure out endianess");
          }
          return N_;
        }
        function Iu0() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function Au0() {
          return [];
        }
        function Nu0() {
          return 0;
        }
        function Cu0() {
          return Number.MAX_VALUE;
        }
        function Pu0() {
          return Number.MAX_VALUE;
        }
        function Du0() {
          return [];
        }
        function Lu0() {
          return "Browser";
        }
        function Ru0() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function ju0() {
        }
        function Gu0() {
        }
        function Rxe() {
          return "javascript";
        }
        function jxe() {
          return "browser";
        }
        function wj() {
          return "/tmp";
        }
        var N_, Ej, Sj, Mu0, Gxe = C_({ "node-modules-polyfills:os"() {
          Pt(), Ej = wj, Sj = `
`, Mu0 = { EOL: Sj, tmpdir: Ej, tmpDir: wj, networkInterfaces: ju0, getNetworkInterfaces: Gu0, release: Ru0, type: Lu0, cpus: Du0, totalmem: Pu0, freemem: Cu0, uptime: Nu0, loadavg: Au0, hostname: Iu0, endianness: Ou0 };
        } }), Mxe = eu({ "node-modules-polyfills-commonjs:os"(H0, z0) {
          Pt();
          var xr = (Gxe(), eU(Tu0));
          if (xr && xr.default) {
            z0.exports = xr.default;
            for (let gr in xr)
              z0.exports[gr] = xr[gr];
          } else
            xr && (z0.exports = xr);
        } }), Bxe = eu({ "node_modules/detect-newline/index.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = (gr) => {
            if (typeof gr != "string")
              throw new TypeError("Expected a string");
            let de = gr.match(/(?:\r?\n)/g) || [];
            if (de.length === 0)
              return;
            let Ve = de.filter((Ke) => Ke === `\r
`).length, De = de.length - Ve;
            return Ve > De ? `\r
` : `
`;
          };
          z0.exports = xr, z0.exports.graceful = (gr) => typeof gr == "string" && xr(gr) || `
`;
        } }), qxe = eu({ "node_modules/jest-docblock/build/index.js"(H0) {
          "use strict";
          Pt(), Object.defineProperty(H0, "__esModule", { value: true }), H0.extract = au, H0.parse = Kt, H0.parseWithComments = Zi, H0.print = Ln, H0.strip = En;
          function z0() {
            let fn = Mxe();
            return z0 = function() {
              return fn;
            }, fn;
          }
          function xr() {
            let fn = gr(Bxe());
            return xr = function() {
              return fn;
            }, fn;
          }
          function gr(fn) {
            return fn && fn.__esModule ? fn : { default: fn };
          }
          var de = /\*\/$/, Ve = /^\/\*\*/, De = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, Ke = /(^|\s+)\/\/([^\r\n]*)/g, tn = /^(\r?\n)+/, Qn = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, rt = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, tt = /(\r?\n|^) *\* ?/g, Ot = [];
          function au(fn) {
            let Ht = fn.match(De);
            return Ht ? Ht[0].trimLeft() : "";
          }
          function En(fn) {
            let Ht = fn.match(De);
            return Ht && Ht[0] ? fn.substring(Ht[0].length) : fn;
          }
          function Kt(fn) {
            return Zi(fn).pragmas;
          }
          function Zi(fn) {
            let Ht = (0, xr().default)(fn) || z0().EOL;
            fn = fn.replace(Ve, "").replace(de, "").replace(tt, "$1");
            let S7 = "";
            for (; S7 !== fn; )
              S7 = fn, fn = fn.replace(Qn, "".concat(Ht, "$1 $2").concat(Ht));
            fn = fn.replace(tn, "").trimRight();
            let Dt = /* @__PURE__ */ Object.create(null), ks = fn.replace(rt, "").replace(tn, "").trimRight(), In;
            for (; In = rt.exec(fn); ) {
              let Wc = In[2].replace(Ke, "");
              typeof Dt[In[1]] == "string" || Array.isArray(Dt[In[1]]) ? Dt[In[1]] = Ot.concat(Dt[In[1]], Wc) : Dt[In[1]] = Wc;
            }
            return { comments: ks, pragmas: Dt };
          }
          function Ln(fn) {
            let { comments: Ht = "", pragmas: S7 = {} } = fn, Dt = (0, xr().default)(Ht) || z0().EOL, ks = "/**", In = " *", Wc = " */", Ai = Object.keys(S7), li = Ai.map((g7) => Tn(g7, S7[g7])).reduce((g7, av) => g7.concat(av), []).map((g7) => In + " " + g7 + Dt).join("");
            if (!Ht) {
              if (Ai.length === 0)
                return "";
              if (Ai.length === 1 && !Array.isArray(S7[Ai[0]])) {
                let g7 = S7[Ai[0]];
                return "".concat(ks, " ").concat(Tn(Ai[0], g7)[0]).concat(Wc);
              }
            }
            let jt = Ht.split(Dt).map((g7) => "".concat(In, " ").concat(g7)).join(Dt) + Dt;
            return ks + Dt + (Ht ? jt : "") + (Ht && Ai.length ? In + Dt : "") + li + Wc;
          }
          function Tn(fn, Ht) {
            return Ot.concat(Ht).map((S7) => "@".concat(fn, " ").concat(S7).trim());
          }
        } }), Uxe = eu({ "src/common/end-of-line.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(De) {
            let Ke = De.indexOf("\r");
            return Ke >= 0 ? De.charAt(Ke + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function gr(De) {
            switch (De) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function de(De, Ke) {
            let tn;
            switch (Ke) {
              case `
`:
                tn = /\n/g;
                break;
              case "\r":
                tn = /\r/g;
                break;
              case `\r
`:
                tn = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(Ke), "."));
            }
            let Qn = De.match(tn);
            return Qn ? Qn.length : 0;
          }
          function Ve(De) {
            return De.replace(/\r\n?/g, `
`);
          }
          z0.exports = { guessEndOfLine: xr, convertEndOfLineToChars: gr, countEndOfLineChars: de, normalizeEndOfLine: Ve };
        } }), Hxe = eu({ "src/language-js/utils/get-shebang.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr) {
            if (!gr.startsWith("#!"))
              return "";
            let de = gr.indexOf(`
`);
            return de === -1 ? gr : gr.slice(0, de);
          }
          z0.exports = xr;
        } }), Xxe = eu({ "src/language-js/pragma.js"(H0, z0) {
          "use strict";
          Pt();
          var { parseWithComments: xr, strip: gr, extract: de, print: Ve } = qxe(), { normalizeEndOfLine: De } = Uxe(), Ke = Hxe();
          function tn(tt) {
            let Ot = Ke(tt);
            Ot && (tt = tt.slice(Ot.length + 1));
            let au = de(tt), { pragmas: En, comments: Kt } = xr(au);
            return { shebang: Ot, text: tt, pragmas: En, comments: Kt };
          }
          function Qn(tt) {
            let Ot = Object.keys(tn(tt).pragmas);
            return Ot.includes("prettier") || Ot.includes("format");
          }
          function rt(tt) {
            let { shebang: Ot, text: au, pragmas: En, comments: Kt } = tn(tt), Zi = gr(au), Ln = Ve({ pragmas: Object.assign({ format: "" }, En), comments: Kt.trimStart() });
            return (Ot ? "".concat(Ot, `
`) : "") + De(Ln) + (Zi.startsWith(`
`) ? `
` : `

`) + Zi;
          }
          z0.exports = { hasPragma: Qn, insertPragma: rt };
        } }), Yxe = eu({ "src/utils/is-non-empty-array.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr) {
            return Array.isArray(gr) && gr.length > 0;
          }
          z0.exports = xr;
        } }), Bu0 = eu({ "src/language-js/loc.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = Yxe();
          function gr(tn, Qn) {
            let { ignoreDecorators: rt } = Qn || {};
            if (!rt) {
              let tt = tn.declaration && tn.declaration.decorators || tn.decorators;
              if (xr(tt))
                return gr(tt[0]);
            }
            return tn.range ? tn.range[0] : tn.start;
          }
          function de(tn) {
            return tn.range ? tn.range[1] : tn.end;
          }
          function Ve(tn, Qn) {
            let rt = gr(tn);
            return Number.isInteger(rt) && rt === gr(Qn);
          }
          function De(tn, Qn) {
            let rt = de(tn);
            return Number.isInteger(rt) && rt === de(Qn);
          }
          function Ke(tn, Qn) {
            return Ve(tn, Qn) && De(tn, Qn);
          }
          z0.exports = { locStart: gr, locEnd: de, hasSameLocStart: Ve, hasSameLoc: Ke };
        } }), Vxe = eu({ "src/language-js/parse/utils/create-parser.js"(H0, z0) {
          "use strict";
          Pt();
          var { hasPragma: xr } = Xxe(), { locStart: gr, locEnd: de } = Bu0();
          function Ve(De) {
            return De = typeof De == "function" ? { parse: De } : De, Object.assign({ astFormat: "estree", hasPragma: xr, locStart: gr, locEnd: de }, De);
          }
          z0.exports = Ve;
        } }), zxe = eu({ "src/language-js/parse/utils/replace-hashbang.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr) {
            return gr.charAt(0) === "#" && gr.charAt(1) === "!" ? "//" + gr.slice(2) : gr;
          }
          z0.exports = xr;
        } }), Kxe = eu({ "src/language-js/utils/is-ts-keyword-type.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr) {
            let { type: de } = gr;
            return de.startsWith("TS") && de.endsWith("Keyword");
          }
          z0.exports = xr;
        } }), Wxe = eu({ "src/language-js/utils/is-block-comment.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), gr = (de) => xr.has(de == null ? void 0 : de.type);
          z0.exports = gr;
        } }), Jxe = eu({ "src/language-js/utils/is-type-cast-comment.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = Wxe();
          function gr(de) {
            return xr(de) && de.value[0] === "*" && /@type\b/.test(de.value);
          }
          z0.exports = gr;
        } }), $xe = eu({ "src/utils/get-last.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = (gr) => gr[gr.length - 1];
          z0.exports = xr;
        } }), qu0 = eu({ "src/language-js/parse/postprocess/visit-node.js"(H0, z0) {
          "use strict";
          Pt();
          function xr(gr, de) {
            if (Array.isArray(gr)) {
              for (let Ve = 0; Ve < gr.length; Ve++)
                gr[Ve] = xr(gr[Ve], de);
              return gr;
            }
            if (gr && typeof gr == "object" && typeof gr.type == "string") {
              let Ve = Object.keys(gr);
              for (let De = 0; De < Ve.length; De++)
                gr[Ve[De]] = xr(gr[Ve[De]], de);
              return de(gr) || gr;
            }
            return gr;
          }
          z0.exports = xr;
        } }), Uu0 = eu({ "src/language-js/parse/postprocess/throw-syntax-error.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = Fu0();
          function gr(de, Ve) {
            let { start: De, end: Ke } = de.loc;
            throw xr(Ve, { start: { line: De.line, column: De.column + 1 }, end: { line: Ke.line, column: Ke.column + 1 } });
          }
          z0.exports = gr;
        } }), Zxe = eu({ "src/language-js/parse/postprocess/typescript.js"(H0, z0) {
          "use strict";
          Pt();
          var xr = qu0(), gr = Uu0();
          function de(Ke, tn, Qn) {
            let rt = Ke.decorators;
            if (!Array.isArray(rt))
              return;
            let tt = tn.decorators;
            (!Array.isArray(tt) || tt.length !== rt.length || rt.some((Ot) => {
              let au = Qn.get(Ot);
              return !au || !tt.includes(au);
            })) && gr(tn, "Leading decorators must be attached to a class declaration");
          }
          function Ve(Ke, tn) {
            Ke.kind !== 167 || Ke.modifiers && !Ke.modifiers.some((tt) => tt.kind === 126) || Ke.initializer && tn.value === null && gr(tn, "Abstract property cannot have an initializer");
          }
          function De(Ke, tn) {
            let { esTreeNodeToTSNodeMap: Qn, tsNodeToESTreeNodeMap: rt } = tn.tsParseResult;
            xr(Ke, (tt) => {
              let Ot = Qn.get(tt);
              if (!Ot)
                return;
              let au = rt.get(Ot);
              au === tt && (de(Ot, au, rt), Ve(Ot, au));
            });
          }
          z0.exports = { throwErrorForInvalidNodes: De };
        } }), Qxe = eu({ "src/language-js/parse/postprocess/index.js"(H0, z0) {
          "use strict";
          Pt();
          var { locStart: xr, locEnd: gr } = Bu0(), de = Kxe(), Ve = Jxe(), De = $xe(), Ke = qu0(), { throwErrorForInvalidNodes: tn } = Zxe(), Qn = Uu0();
          function rt(En, Kt) {
            if (Kt.parser === "typescript" && /@|abstract/.test(Kt.originalText) && tn(En, Kt), Kt.parser !== "typescript" && Kt.parser !== "flow" && Kt.parser !== "acorn" && Kt.parser !== "espree" && Kt.parser !== "meriyah") {
              let Ln = /* @__PURE__ */ new Set();
              En = Ke(En, (Tn) => {
                Tn.leadingComments && Tn.leadingComments.some(Ve) && Ln.add(xr(Tn));
              }), En = Ke(En, (Tn) => {
                if (Tn.type === "ParenthesizedExpression") {
                  let { expression: fn } = Tn;
                  if (fn.type === "TypeCastExpression")
                    return fn.range = Tn.range, fn;
                  let Ht = xr(Tn);
                  if (!Ln.has(Ht))
                    return fn.extra = Object.assign(Object.assign({}, fn.extra), {}, { parenthesized: true }), fn;
                }
              });
            }
            return En = Ke(En, (Ln) => {
              switch (Ln.type) {
                case "ChainExpression":
                  return tt(Ln.expression);
                case "LogicalExpression": {
                  if (Ot(Ln))
                    return au(Ln);
                  break;
                }
                case "VariableDeclaration": {
                  let Tn = De(Ln.declarations);
                  Tn && Tn.init && Zi(Ln, Tn);
                  break;
                }
                case "TSParenthesizedType":
                  return de(Ln.typeAnnotation) || Ln.typeAnnotation.type === "TSThisType" || (Ln.typeAnnotation.range = [xr(Ln), gr(Ln)]), Ln.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof Ln.name == "string") {
                    let Tn = xr(Ln);
                    Ln.name = { type: "Identifier", name: Ln.name, range: [Tn, Tn + Ln.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (Kt.parser === "typescript") {
                    let Tn = Ln.properties.find((fn) => fn.type === "Property" && fn.value.type === "TSEmptyBodyFunctionExpression");
                    Tn && Qn(Tn.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let Tn = De(Ln.expressions);
                  Ln.range = [xr(Ln), Math.min(gr(Tn), gr(Ln))];
                  break;
                }
                case "TopicReference":
                  Kt.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: Tn } = Ln;
                  if (Kt.parser === "meriyah" && Tn && Tn.type === "Identifier") {
                    let fn = Kt.originalText.slice(xr(Tn), gr(Tn));
                    (fn.startsWith('"') || fn.startsWith("'")) && (Ln.exported = Object.assign(Object.assign({}, Ln.exported), {}, { type: "Literal", value: Ln.exported.name, raw: fn }));
                  }
                  break;
                }
              }
            }), En;
            function Zi(Ln, Tn) {
              Kt.originalText[gr(Tn)] !== ";" && (Ln.range = [xr(Ln), gr(Tn)]);
            }
          }
          function tt(En) {
            switch (En.type) {
              case "CallExpression":
                En.type = "OptionalCallExpression", En.callee = tt(En.callee);
                break;
              case "MemberExpression":
                En.type = "OptionalMemberExpression", En.object = tt(En.object);
                break;
              case "TSNonNullExpression":
                En.expression = tt(En.expression);
                break;
            }
            return En;
          }
          function Ot(En) {
            return En.type === "LogicalExpression" && En.right.type === "LogicalExpression" && En.operator === En.right.operator;
          }
          function au(En) {
            return Ot(En) ? au({ type: "LogicalExpression", operator: En.operator, left: au({ type: "LogicalExpression", operator: En.operator, left: En.left, right: En.right.left, range: [xr(En.left), gr(En.right.left)] }), right: En.right.right, range: [xr(En), gr(En)] }) : En;
          }
          z0.exports = rt;
        } }), Hu0 = {};
        rU(Hu0, { default: () => Xu0 });
        var Xu0, roe = C_({ "node-modules-polyfills:fs"() {
          Pt(), Xu0 = {};
        } }), kj = eu({ "node-modules-polyfills-commonjs:fs"(H0, z0) {
          Pt();
          var xr = (roe(), eU(Hu0));
          if (xr && xr.default) {
            z0.exports = xr.default;
            for (let gr in xr)
              z0.exports[gr] = xr[gr];
          } else
            xr && (z0.exports = xr);
        } }), Yu0 = {};
        rU(Yu0, { ALPN_ENABLED: () => Pq, COPYFILE_EXCL: () => CB, COPYFILE_FICLONE: () => DB, COPYFILE_FICLONE_FORCE: () => RB, DH_CHECK_P_NOT_PRIME: () => Aq, DH_CHECK_P_NOT_SAFE_PRIME: () => Iq, DH_NOT_SUITABLE_GENERATOR: () => Cq, DH_UNABLE_TO_CHECK_GENERATOR: () => Nq, E2BIG: () => Ij, EACCES: () => Aj, EADDRINUSE: () => Nj, EADDRNOTAVAIL: () => Cj, EAFNOSUPPORT: () => Pj, EAGAIN: () => Dj, EALREADY: () => Lj, EBADF: () => Rj, EBADMSG: () => jj, EBUSY: () => Gj, ECANCELED: () => Mj, ECHILD: () => Bj, ECONNABORTED: () => qj, ECONNREFUSED: () => Uj, ECONNRESET: () => Hj, EDEADLK: () => Xj, EDESTADDRREQ: () => Yj, EDOM: () => Vj, EDQUOT: () => zj, EEXIST: () => Kj, EFAULT: () => Wj, EFBIG: () => Jj, EHOSTUNREACH: () => $j, EIDRM: () => Zj, EILSEQ: () => Qj, EINPROGRESS: () => rG, EINTR: () => eG, EINVAL: () => nG, EIO: () => tG, EISCONN: () => uG, EISDIR: () => iG, ELOOP: () => fG, EMFILE: () => xG, EMLINK: () => oG, EMSGSIZE: () => aG, EMULTIHOP: () => cG, ENAMETOOLONG: () => sG, ENETDOWN: () => vG, ENETRESET: () => lG, ENETUNREACH: () => bG, ENFILE: () => pG, ENGINE_METHOD_ALL: () => Tq, ENGINE_METHOD_CIPHERS: () => Eq, ENGINE_METHOD_DH: () => dq, ENGINE_METHOD_DIGESTS: () => Sq, ENGINE_METHOD_DSA: () => hq, ENGINE_METHOD_EC: () => wq, ENGINE_METHOD_NONE: () => Oq, ENGINE_METHOD_PKEY_ASN1_METHS: () => Fq, ENGINE_METHOD_PKEY_METHS: () => gq, ENGINE_METHOD_RAND: () => kq, ENGINE_METHOD_RSA: () => yq, ENOBUFS: () => mG, ENODATA: () => _G, ENODEV: () => yG, ENOENT: () => hG, ENOEXEC: () => dG, ENOLCK: () => kG, ENOLINK: () => wG, ENOMEM: () => EG, ENOMSG: () => SG, ENOPROTOOPT: () => gG, ENOSPC: () => FG, ENOSR: () => TG, ENOSTR: () => OG, ENOSYS: () => IG, ENOTCONN: () => AG, ENOTDIR: () => NG, ENOTEMPTY: () => CG, ENOTSOCK: () => PG, ENOTSUP: () => DG, ENOTTY: () => LG, ENXIO: () => RG, EOPNOTSUPP: () => jG, EOVERFLOW: () => GG, EPERM: () => MG, EPIPE: () => BG, EPROTO: () => qG, EPROTONOSUPPORT: () => UG, EPROTOTYPE: () => HG, ERANGE: () => XG, EROFS: () => YG, ESPIPE: () => VG, ESRCH: () => zG, ESTALE: () => KG, ETIME: () => WG, ETIMEDOUT: () => JG, ETXTBSY: () => $G, EWOULDBLOCK: () => ZG, EXDEV: () => QG, F_OK: () => TB, OPENSSL_VERSION_NUMBER: () => jB, O_APPEND: () => oB, O_CREAT: () => uB, O_DIRECTORY: () => aB, O_DSYNC: () => vB, O_EXCL: () => iB, O_NOCTTY: () => fB, O_NOFOLLOW: () => cB, O_NONBLOCK: () => bB, O_RDONLY: () => MM, O_RDWR: () => qM, O_SYMLINK: () => lB, O_SYNC: () => sB, O_TRUNC: () => xB, O_WRONLY: () => BM, POINT_CONVERSION_COMPRESSED: () => Kq, POINT_CONVERSION_HYBRID: () => Jq, POINT_CONVERSION_UNCOMPRESSED: () => Wq, PRIORITY_ABOVE_NORMAL: () => tM, PRIORITY_BELOW_NORMAL: () => eM, PRIORITY_HIGH: () => uM, PRIORITY_HIGHEST: () => iM, PRIORITY_LOW: () => rM, PRIORITY_NORMAL: () => nM, RSA_NO_PADDING: () => Rq, RSA_PKCS1_OAEP_PADDING: () => jq, RSA_PKCS1_PADDING: () => Dq, RSA_PKCS1_PSS_PADDING: () => Mq, RSA_PSS_SALTLEN_AUTO: () => Uq, RSA_PSS_SALTLEN_DIGEST: () => Bq, RSA_PSS_SALTLEN_MAX_SIGN: () => qq, RSA_SSLV23_PADDING: () => Lq, RSA_X931_PADDING: () => Gq, RTLD_GLOBAL: () => Tj, RTLD_LAZY: () => gj, RTLD_LOCAL: () => Oj, RTLD_NOW: () => Fj, R_OK: () => OB, SIGABRT: () => sM, SIGALRM: () => dM, SIGBUS: () => lM, SIGCHLD: () => wM, SIGCONT: () => EM, SIGFPE: () => bM, SIGHUP: () => fM, SIGILL: () => aM, SIGINFO: () => LM, SIGINT: () => xM, SIGIO: () => DM, SIGIOT: () => vM, SIGKILL: () => pM, SIGPIPE: () => hM, SIGPROF: () => CM, SIGQUIT: () => oM, SIGSEGV: () => _M, SIGSTOP: () => SM, SIGSYS: () => RM, SIGTERM: () => kM, SIGTRAP: () => cM, SIGTSTP: () => gM, SIGTTIN: () => FM, SIGTTOU: () => TM, SIGURG: () => OM, SIGUSR1: () => mM, SIGUSR2: () => yM, SIGVTALRM: () => NM, SIGWINCH: () => PM, SIGXCPU: () => IM, SIGXFSZ: () => AM, SSL_OP_ALL: () => GB, SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION: () => MB, SSL_OP_CIPHER_SERVER_PREFERENCE: () => BB, SSL_OP_CISCO_ANYCONNECT: () => qB, SSL_OP_COOKIE_EXCHANGE: () => UB, SSL_OP_CRYPTOPRO_TLSEXT_BUG: () => HB, SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS: () => XB, SSL_OP_EPHEMERAL_RSA: () => YB, SSL_OP_LEGACY_SERVER_CONNECT: () => VB, SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER: () => zB, SSL_OP_MICROSOFT_SESS_ID_BUG: () => KB, SSL_OP_MSIE_SSLV2_RSA_PADDING: () => WB, SSL_OP_NETSCAPE_CA_DN_BUG: () => JB, SSL_OP_NETSCAPE_CHALLENGE_BUG: () => $B, SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG: () => ZB, SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG: () => QB, SSL_OP_NO_COMPRESSION: () => rq, SSL_OP_NO_QUERY_MTU: () => eq, SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION: () => nq, SSL_OP_NO_SSLv2: () => tq, SSL_OP_NO_SSLv3: () => uq, SSL_OP_NO_TICKET: () => iq, SSL_OP_NO_TLSv1: () => fq, SSL_OP_NO_TLSv1_1: () => xq, SSL_OP_NO_TLSv1_2: () => oq, SSL_OP_PKCS1_CHECK_1: () => aq, SSL_OP_PKCS1_CHECK_2: () => cq, SSL_OP_SINGLE_DH_USE: () => sq, SSL_OP_SINGLE_ECDH_USE: () => vq, SSL_OP_SSLEAY_080_CLIENT_DH_BUG: () => lq, SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG: () => bq, SSL_OP_TLS_BLOCK_PADDING_BUG: () => pq, SSL_OP_TLS_D5_BUG: () => mq, SSL_OP_TLS_ROLLBACK_BUG: () => _q, S_IFBLK: () => rB, S_IFCHR: () => QM, S_IFDIR: () => ZM, S_IFIFO: () => eB, S_IFLNK: () => nB, S_IFMT: () => JM, S_IFREG: () => $M, S_IFSOCK: () => tB, S_IRGRP: () => dB, S_IROTH: () => SB, S_IRUSR: () => mB, S_IRWXG: () => hB, S_IRWXO: () => EB, S_IRWXU: () => pB, S_IWGRP: () => kB, S_IWOTH: () => gB, S_IWUSR: () => _B, S_IXGRP: () => wB, S_IXOTH: () => FB, S_IXUSR: () => yB, TLS1_1_VERSION: () => Yq, TLS1_2_VERSION: () => Vq, TLS1_3_VERSION: () => zq, TLS1_VERSION: () => Xq, UV_DIRENT_BLOCK: () => WM, UV_DIRENT_CHAR: () => KM, UV_DIRENT_DIR: () => XM, UV_DIRENT_FIFO: () => VM, UV_DIRENT_FILE: () => HM, UV_DIRENT_LINK: () => YM, UV_DIRENT_SOCKET: () => zM, UV_DIRENT_UNKNOWN: () => UM, UV_FS_COPYFILE_EXCL: () => NB, UV_FS_COPYFILE_FICLONE: () => PB, UV_FS_COPYFILE_FICLONE_FORCE: () => LB, UV_FS_SYMLINK_DIR: () => jM, UV_FS_SYMLINK_JUNCTION: () => GM, W_OK: () => IB, X_OK: () => AB, default: () => Vu0, defaultCipherList: () => $q, defaultCoreCipherList: () => Hq });
        var gj, Fj, Tj, Oj, Ij, Aj, Nj, Cj, Pj, Dj, Lj, Rj, jj, Gj, Mj, Bj, qj, Uj, Hj, Xj, Yj, Vj, zj, Kj, Wj, Jj, $j, Zj, Qj, rG, eG, nG, tG, uG, iG, fG, xG, oG, aG, cG, sG, vG, lG, bG, pG, mG, _G, yG, hG, dG, kG, wG, EG, SG, gG, FG, TG, OG, IG, AG, NG, CG, PG, DG, LG, RG, jG, GG, MG, BG, qG, UG, HG, XG, YG, VG, zG, KG, WG, JG, $G, ZG, QG, rM, eM, nM, tM, uM, iM, fM, xM, oM, aM, cM, sM, vM, lM, bM, pM, mM, _M, yM, hM, dM, kM, wM, EM, SM, gM, FM, TM, OM, IM, AM, NM, CM, PM, DM, LM, RM, jM, GM, MM, BM, qM, UM, HM, XM, YM, VM, zM, KM, WM, JM, $M, ZM, QM, rB, eB, nB, tB, uB, iB, fB, xB, oB, aB, cB, sB, vB, lB, bB, pB, mB, _B, yB, hB, dB, kB, wB, EB, SB, gB, FB, TB, OB, IB, AB, NB, CB, PB, DB, LB, RB, jB, GB, MB, BB, qB, UB, HB, XB, YB, VB, zB, KB, WB, JB, $B, ZB, QB, rq, eq, nq, tq, uq, iq, fq, xq, oq, aq, cq, sq, vq, lq, bq, pq, mq, _q, yq, hq, dq, kq, wq, Eq, Sq, gq, Fq, Tq, Oq, Iq, Aq, Nq, Cq, Pq, Dq, Lq, Rq, jq, Gq, Mq, Bq, qq, Uq, Hq, Xq, Yq, Vq, zq, Kq, Wq, Jq, $q, Vu0, eoe = C_({ "node-modules-polyfills:constants"() {
          Pt(), gj = 1, Fj = 2, Tj = 8, Oj = 4, Ij = 7, Aj = 13, Nj = 48, Cj = 49, Pj = 47, Dj = 35, Lj = 37, Rj = 9, jj = 94, Gj = 16, Mj = 89, Bj = 10, qj = 53, Uj = 61, Hj = 54, Xj = 11, Yj = 39, Vj = 33, zj = 69, Kj = 17, Wj = 14, Jj = 27, $j = 65, Zj = 90, Qj = 92, rG = 36, eG = 4, nG = 22, tG = 5, uG = 56, iG = 21, fG = 62, xG = 24, oG = 31, aG = 40, cG = 95, sG = 63, vG = 50, lG = 52, bG = 51, pG = 23, mG = 55, _G = 96, yG = 19, hG = 2, dG = 8, kG = 77, wG = 97, EG = 12, SG = 91, gG = 42, FG = 28, TG = 98, OG = 99, IG = 78, AG = 57, NG = 20, CG = 66, PG = 38, DG = 45, LG = 25, RG = 6, jG = 102, GG = 84, MG = 1, BG = 32, qG = 100, UG = 43, HG = 41, XG = 34, YG = 30, VG = 29, zG = 3, KG = 70, WG = 101, JG = 60, $G = 26, ZG = 35, QG = 18, rM = 19, eM = 10, nM = 0, tM = -7, uM = -14, iM = -20, fM = 1, xM = 2, oM = 3, aM = 4, cM = 5, sM = 6, vM = 6, lM = 10, bM = 8, pM = 9, mM = 30, _M = 11, yM = 31, hM = 13, dM = 14, kM = 15, wM = 20, EM = 19, SM = 17, gM = 18, FM = 21, TM = 22, OM = 16, IM = 24, AM = 25, NM = 26, CM = 27, PM = 28, DM = 23, LM = 29, RM = 12, jM = 1, GM = 2, MM = 0, BM = 1, qM = 2, UM = 0, HM = 1, XM = 2, YM = 3, VM = 4, zM = 5, KM = 6, WM = 7, JM = 61440, $M = 32768, ZM = 16384, QM = 8192, rB = 24576, eB = 4096, nB = 40960, tB = 49152, uB = 512, iB = 2048, fB = 131072, xB = 1024, oB = 8, aB = 1048576, cB = 256, sB = 128, vB = 4194304, lB = 2097152, bB = 4, pB = 448, mB = 256, _B = 128, yB = 64, hB = 56, dB = 32, kB = 16, wB = 8, EB = 7, SB = 4, gB = 2, FB = 1, TB = 0, OB = 4, IB = 2, AB = 1, NB = 1, CB = 1, PB = 2, DB = 2, LB = 4, RB = 4, jB = 269488175, GB = 2147485780, MB = 262144, BB = 4194304, qB = 32768, UB = 8192, HB = 2147483648, XB = 2048, YB = 0, VB = 4, zB = 0, KB = 0, WB = 0, JB = 0, $B = 0, ZB = 0, QB = 0, rq = 131072, eq = 4096, nq = 65536, tq = 0, uq = 33554432, iq = 16384, fq = 67108864, xq = 268435456, oq = 134217728, aq = 0, cq = 0, sq = 0, vq = 0, lq = 0, bq = 0, pq = 0, mq = 0, _q = 8388608, yq = 1, hq = 2, dq = 4, kq = 8, wq = 2048, Eq = 64, Sq = 128, gq = 512, Fq = 1024, Tq = 65535, Oq = 0, Iq = 2, Aq = 1, Nq = 4, Cq = 8, Pq = 1, Dq = 1, Lq = 2, Rq = 3, jq = 4, Gq = 5, Mq = 6, Bq = -1, qq = -2, Uq = -2, Hq = "TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA256:ECDHE-RSA-AES256-SHA384:DHE-RSA-AES256-SHA384:ECDHE-RSA-AES256-SHA256:DHE-RSA-AES256-SHA256:HIGH:!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!SRP:!CAMELLIA", Xq = 769, Yq = 770, Vq = 771, zq = 772, Kq = 2, Wq = 4, Jq = 6, $q = "TLS_AES_256_GCM_SHA384:TLS_CHACHA20_POLY1305_SHA256:TLS_AES_128_GCM_SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA256:ECDHE-RSA-AES256-SHA384:DHE-RSA-AES256-SHA384:ECDHE-RSA-AES256-SHA256:DHE-RSA-AES256-SHA256:HIGH:!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!SRP:!CAMELLIA", Vu0 = { RTLD_LAZY: gj, RTLD_NOW: Fj, RTLD_GLOBAL: Tj, RTLD_LOCAL: Oj, E2BIG: Ij, EACCES: Aj, EADDRINUSE: Nj, EADDRNOTAVAIL: Cj, EAFNOSUPPORT: Pj, EAGAIN: Dj, EALREADY: Lj, EBADF: Rj, EBADMSG: jj, EBUSY: Gj, ECANCELED: Mj, ECHILD: Bj, ECONNABORTED: qj, ECONNREFUSED: Uj, ECONNRESET: Hj, EDEADLK: Xj, EDESTADDRREQ: Yj, EDOM: Vj, EDQUOT: zj, EEXIST: Kj, EFAULT: Wj, EFBIG: Jj, EHOSTUNREACH: $j, EIDRM: Zj, EILSEQ: Qj, EINPROGRESS: rG, EINTR: eG, EINVAL: nG, EIO: tG, EISCONN: uG, EISDIR: iG, ELOOP: fG, EMFILE: xG, EMLINK: oG, EMSGSIZE: aG, EMULTIHOP: cG, ENAMETOOLONG: sG, ENETDOWN: vG, ENETRESET: lG, ENETUNREACH: bG, ENFILE: pG, ENOBUFS: mG, ENODATA: _G, ENODEV: yG, ENOENT: hG, ENOEXEC: dG, ENOLCK: kG, ENOLINK: wG, ENOMEM: EG, ENOMSG: SG, ENOPROTOOPT: gG, ENOSPC: FG, ENOSR: TG, ENOSTR: OG, ENOSYS: IG, ENOTCONN: AG, ENOTDIR: NG, ENOTEMPTY: CG, ENOTSOCK: PG, ENOTSUP: DG, ENOTTY: LG, ENXIO: RG, EOPNOTSUPP: jG, EOVERFLOW: GG, EPERM: MG, EPIPE: BG, EPROTO: qG, EPROTONOSUPPORT: UG, EPROTOTYPE: HG, ERANGE: XG, EROFS: YG, ESPIPE: VG, ESRCH: zG, ESTALE: KG, ETIME: WG, ETIMEDOUT: JG, ETXTBSY: $G, EWOULDBLOCK: ZG, EXDEV: QG, PRIORITY_LOW: rM, PRIORITY_BELOW_NORMAL: eM, PRIORITY_NORMAL: nM, PRIORITY_ABOVE_NORMAL: tM, PRIORITY_HIGH: uM, PRIORITY_HIGHEST: iM, SIGHUP: fM, SIGINT: xM, SIGQUIT: oM, SIGILL: aM, SIGTRAP: cM, SIGABRT: sM, SIGIOT: vM, SIGBUS: lM, SIGFPE: bM, SIGKILL: pM, SIGUSR1: mM, SIGSEGV: _M, SIGUSR2: yM, SIGPIPE: hM, SIGALRM: dM, SIGTERM: kM, SIGCHLD: wM, SIGCONT: EM, SIGSTOP: SM, SIGTSTP: gM, SIGTTIN: FM, SIGTTOU: TM, SIGURG: OM, SIGXCPU: IM, SIGXFSZ: AM, SIGVTALRM: NM, SIGPROF: CM, SIGWINCH: PM, SIGIO: DM, SIGINFO: LM, SIGSYS: RM, UV_FS_SYMLINK_DIR: jM, UV_FS_SYMLINK_JUNCTION: GM, O_RDONLY: MM, O_WRONLY: BM, O_RDWR: qM, UV_DIRENT_UNKNOWN: UM, UV_DIRENT_FILE: HM, UV_DIRENT_DIR: XM, UV_DIRENT_LINK: YM, UV_DIRENT_FIFO: VM, UV_DIRENT_SOCKET: zM, UV_DIRENT_CHAR: KM, UV_DIRENT_BLOCK: WM, S_IFMT: JM, S_IFREG: $M, S_IFDIR: ZM, S_IFCHR: QM, S_IFBLK: rB, S_IFIFO: eB, S_IFLNK: nB, S_IFSOCK: tB, O_CREAT: uB, O_EXCL: iB, O_NOCTTY: fB, O_TRUNC: xB, O_APPEND: oB, O_DIRECTORY: aB, O_NOFOLLOW: cB, O_SYNC: sB, O_DSYNC: vB, O_SYMLINK: lB, O_NONBLOCK: bB, S_IRWXU: pB, S_IRUSR: mB, S_IWUSR: _B, S_IXUSR: yB, S_IRWXG: hB, S_IRGRP: dB, S_IWGRP: kB, S_IXGRP: wB, S_IRWXO: EB, S_IROTH: SB, S_IWOTH: gB, S_IXOTH: FB, F_OK: TB, R_OK: OB, W_OK: IB, X_OK: AB, UV_FS_COPYFILE_EXCL: NB, COPYFILE_EXCL: CB, UV_FS_COPYFILE_FICLONE: PB, COPYFILE_FICLONE: DB, UV_FS_COPYFILE_FICLONE_FORCE: LB, COPYFILE_FICLONE_FORCE: RB, OPENSSL_VERSION_NUMBER: jB, SSL_OP_ALL: GB, SSL_OP_ALLOW_UNSAFE_LEGACY_RENEGOTIATION: MB, SSL_OP_CIPHER_SERVER_PREFERENCE: BB, SSL_OP_CISCO_ANYCONNECT: qB, SSL_OP_COOKIE_EXCHANGE: UB, SSL_OP_CRYPTOPRO_TLSEXT_BUG: HB, SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS: XB, SSL_OP_EPHEMERAL_RSA: YB, SSL_OP_LEGACY_SERVER_CONNECT: VB, SSL_OP_MICROSOFT_BIG_SSLV3_BUFFER: zB, SSL_OP_MICROSOFT_SESS_ID_BUG: KB, SSL_OP_MSIE_SSLV2_RSA_PADDING: WB, SSL_OP_NETSCAPE_CA_DN_BUG: JB, SSL_OP_NETSCAPE_CHALLENGE_BUG: $B, SSL_OP_NETSCAPE_DEMO_CIPHER_CHANGE_BUG: ZB, SSL_OP_NETSCAPE_REUSE_CIPHER_CHANGE_BUG: QB, SSL_OP_NO_COMPRESSION: rq, SSL_OP_NO_QUERY_MTU: eq, SSL_OP_NO_SESSION_RESUMPTION_ON_RENEGOTIATION: nq, SSL_OP_NO_SSLv2: tq, SSL_OP_NO_SSLv3: uq, SSL_OP_NO_TICKET: iq, SSL_OP_NO_TLSv1: fq, SSL_OP_NO_TLSv1_1: xq, SSL_OP_NO_TLSv1_2: oq, SSL_OP_PKCS1_CHECK_1: aq, SSL_OP_PKCS1_CHECK_2: cq, SSL_OP_SINGLE_DH_USE: sq, SSL_OP_SINGLE_ECDH_USE: vq, SSL_OP_SSLEAY_080_CLIENT_DH_BUG: lq, SSL_OP_SSLREF2_REUSE_CERT_TYPE_BUG: bq, SSL_OP_TLS_BLOCK_PADDING_BUG: pq, SSL_OP_TLS_D5_BUG: mq, SSL_OP_TLS_ROLLBACK_BUG: _q, ENGINE_METHOD_RSA: yq, ENGINE_METHOD_DSA: hq, ENGINE_METHOD_DH: dq, ENGINE_METHOD_RAND: kq, ENGINE_METHOD_EC: wq, ENGINE_METHOD_CIPHERS: Eq, ENGINE_METHOD_DIGESTS: Sq, ENGINE_METHOD_PKEY_METHS: gq, ENGINE_METHOD_PKEY_ASN1_METHS: Fq, ENGINE_METHOD_ALL: Tq, ENGINE_METHOD_NONE: Oq, DH_CHECK_P_NOT_SAFE_PRIME: Iq, DH_CHECK_P_NOT_PRIME: Aq, DH_UNABLE_TO_CHECK_GENERATOR: Nq, DH_NOT_SUITABLE_GENERATOR: Cq, ALPN_ENABLED: Pq, RSA_PKCS1_PADDING: Dq, RSA_SSLV23_PADDING: Lq, RSA_NO_PADDING: Rq, RSA_PKCS1_OAEP_PADDING: jq, RSA_X931_PADDING: Gq, RSA_PKCS1_PSS_PADDING: Mq, RSA_PSS_SALTLEN_DIGEST: Bq, RSA_PSS_SALTLEN_MAX_SIGN: qq, RSA_PSS_SALTLEN_AUTO: Uq, defaultCoreCipherList: Hq, TLS1_VERSION: Xq, TLS1_1_VERSION: Yq, TLS1_2_VERSION: Vq, TLS1_3_VERSION: zq, POINT_CONVERSION_COMPRESSED: Kq, POINT_CONVERSION_UNCOMPRESSED: Wq, POINT_CONVERSION_HYBRID: Jq, defaultCipherList: $q };
        } }), noe = eu({ "node-modules-polyfills-commonjs:constants"(H0, z0) {
          Pt();
          var xr = (eoe(), eU(Yu0));
          if (xr && xr.default) {
            z0.exports = xr.default;
            for (let gr in xr)
              z0.exports[gr] = xr[gr];
          } else
            xr && (z0.exports = xr);
        } }), toe = eu({ "node_modules/flow-parser/flow_parser.js"(H0) {
          Pt(), function(z0) {
            "use strict";
            var xr = "member_property_expression", gr = 8483, de = 12538, Ve = "children", De = "predicate_expression", Ke = "??", tn = "Identifier", Qn = 64311, rt = 192, tt = 11710, Ot = 122654, au = 110947, En = 67591, Kt = "!", Zi = "directive", Ln = 163, Tn = "block", fn = 126553, Ht = 12735, S7 = 68096, Dt = "params", ks = 93071, In = 122, Wc = 72767, Ai = 181, li = "for_statement", jt = 128, g7 = "start", av = 43867, nU = "_method", P_ = 70414, cv = ">", Qi = "catch_body", D_ = 120121, tU = "the end of an expression statement (`;`)", L_ = 124907, uU = 1027, s4 = 126558, rf = "jsx_fragment", R_ = 42527, j_ = "decorators", G_ = 82943, M_ = 71039, B_ = 110882, q_ = 67514, iU = 8472, fU = "update", U_ = 12783, H_ = 12438, X_ = 12352, Y_ = 8511, V_ = 42961, F2 = "method", v4 = 120713, ef = 8191, nf = "function_param", z_ = 67871, F7 = "throw", K_ = 11507, tf = "class_extends", W_ = 43470, uf = "object_key_literal", J_ = 71903, $_ = 65437, ff = "jsx_child", Z_ = 43311, l4 = 119995, Q_ = 67637, b4 = 68116, ry = 66204, ey = 65470, xU = "<<=", ny = "e", ty = 67391, p4 = 11631, m4 = 69956, sv = "tparams", uy = 66735, iy = 64217, fy = 43697, oU = "Invalid binary/octal ", xy = -43, oy = 43255, _4 = "do", ay = 43301, xf = "binding_pattern", cy = 120487, of = "jsx_attribute_value_literal", y4 = "package", af = "interface_declaration", sy = 72750, vy = 119892, aU = "tail", cU = -53, cf = 111, sU = 180, ly = 119807, by = 71959, vU = 8206, py = 65613, Jc = "type", my = 55215, _y = -42, sf = "export_default_declaration_decl", h4 = 72970, lU = "filtered_out", yy = 70416, bU = 229, vf = "function_this_param", pU = "module", d4 = "try", hy = 70143, dy = 125183, ky = 70412, d0 = "@])", lf = "binary", mU = "infinity", k4 = "private", wy = 65500, w4 = "has_unknown_members", bf = "pattern_array_rest_element", _U = "Property", ws = "implements", Ey = 12548, yU = 211, pf = "if_alternate_statement", Sy = 124903, gy = 43395, vv = "src/parser/type_parser.ml", Fy = 66915, E4 = 126552, Ty = 120712, S4 = 126555, Oy = 120596, c7 = "raw", T7 = 112, mf = "class_declaration", _f = "statement", Iy = 126624, Ay = 71235, yf = "meta_property", Ny = 44002, Cy = 8467, hf = "class_property_value", Py = 8318, df = "optional_call", Dy = 43761, $c = "kind", kf = "class_identifier", Ly = 69955, Ry = 66378, jy = 120512, Gy = 68220, Xt = 110, My = 123583, T2 = "declare", wf = "typeof_member_identifier", Ef = "catch_clause", By = 11742, qy = 70831, g4 = 8468, Sf = "for_in_assignment_pattern", hU = -32, gf = "object_", Uy = 43262, Hy = "mixins", Ff = "type_param", dU = "visit_trailing_comment", Xy = 71839, O2 = "boolean", Tf = "call", kU = "expected *", Yy = 43010, Vy = 241, Nu = "expression", I2 = "column", zy = 43595, Ky = 43258, Wy = 191456, Of = "member_type_identifier", A2 = 117, Jy = 43754, F4 = 126544, wU = "Assert_failure", $y = 66517, Zy = 42964, If = "enum_number_member", EU = "a string", Qy = 65855, rh = 119993, eh = "opaque", SU = 870530776, nh = 67711, th = 66994, Af = "enum_symbol_body", gU = 185, FU = 219, T4 = "filter", uh = 43615, O4 = 126560, ih = 19903, n1 = "get", fh = 64316, TU = `Fatal error: exception %s
`, I4 = "exported", OU = ">=", Ju = "return", A4 = "members", N4 = 256, xh = 66962, oh = 64279, ah = 67829, IU = "Enum `", AU = "&&=", Nf = "object_property", ch = 67589, Cf = "pattern_object_property", Pf = "template_literal_element", sh = 69551, Ni = 127343600, C4 = 70452, Df = "class_element", vh = "ENOENT", lh = 71131, NU = 200, bh = 120137, ph = 94098, P4 = 72349, CU = 1328, Lf = "function_identifier", mh = 126543, Rf = "jsx_attribute_name", _h = 43487, dr = "@[<2>{ ", PU = "ENOTEMPTY", yh = 65908, hh = 72191, D4 = 120513, dh = 92909, DU = "bound", kh = 162, LU = 172, L4 = 120070, jf = "enum_number_body", Gf = "update_expression", Mf = "spread_element", Bf = "for_in_left_declaration", R4 = 64319, N2 = "%d", wh = 12703, j4 = 11687, RU = "@,))@]", Eh = 42239, qf = "type_cast", Sh = 42508, Uf = "class_implements_interface", gh = 67640, Fh = 605857695, jU = "Cygwin", GU = "buffer.ml", Th = 124908, MU = "handler", Oh = 66207, Ih = 66963, G4 = 11558, BU = "-=", Pn = 113, Ah = 113775, qU = "collect_comments", M4 = 126540, lv = "set", Hf = "assignment_pattern", Cu = "right", Xf = "object_key_identifier", B4 = 120133, Nh = "Invalid number ", Ch = 42963, q4 = 12539, Ph = 68023, Dh = 43798, ti = 100, Yf = "pattern_literal", Vf = "generic_type", UU = "*", Lh = 42783, Rh = 42890, jh = 230, U4 = "else", Gh = 70851, Mh = 69289, HU = "the start of a statement", H4 = "properties", Bh = 43696, qh = 110959, zf = "declare_function", X4 = 120597, Kf = "object_indexer_property_type", Uh = 70492, Hh = 2048, C2 = "arguments", Xr = "comments", Xh = 43042, Zc = 107, Yh = 110575, XU = 161, Vh = 67431, Y4 = "line", P2 = "declaration", nu = "static", Wf = "pattern_identifier", zh = 69958, YU = "the", Kh = "Unix.Unix_error", Wh = 43814, Qc = "annot", Jh = 65786, $h = 66303, Zh = 64967, Qh = 64255, rd = 8584, V4 = 120655, VU = "Stack_overflow", ed = 43700, Jf = "syntax_opt", zU = "/static/", $f = "comprehension", nd = 253, KU = "Not_found", WU = "+=", JU = 235, td = 68680, ud = 66954, id = 64324, fd = 72966, $U = 174, ZU = -1053382366, xd = "rest", Zf = "pattern_array_element", Qf = "jsx_attribute_value_expression", z4 = 65595, rx = "pattern_array_e", QU = 243, od = 43711, ad = "rmdir", K4 = "symbol", cd = 69926, W4 = "*dummy method*", sd = 43741, O7 = "typeParameters", D2 = "const", rH = 1026, eH = 149, vd = 12341, ld = 72847, bd = 66993, nH = 202, Ci = "false", Yt = 106, pd = 120076, md = 186, Pi = 128, _d2 = 125124, yd = "Fatal error: exception ", J4 = 67593, hd = 69297, dd = 44031, tH = 234, kd = 92927, wd = 68095, $u = 8231, ex = "object_key_computed", nx = "labeled_statement", tx = "function_param_pattern", $4 = 126590, Ed = 65481, Sd = 43442, uH = "collect_comments_opt", ux = "variable_declarator", bv = "_", gd = "compare: functional value", Fd = 67967, pv = "computed", ix = "object_property_type", mt = "id", Td = 126562, t1 = 114, iH = "comment_bounds", Od = 70853, Id = 69247, fx = "class_private_field", Ad = 42237, Nd = 72329, fH = "Invalid_argument", Cd = 113770, Z4 = 94031, Pd = 120092, xx = "declare_class", Dd = 67839, Ld = 72250, xH = "%ni", Rd = 92879, oH = "prototype", Es = "`.", ox = 8287, Q4 = 65344, jd = "&", I7 = "debugger", ax = "type_identifier_reference", aH = "Internal Error: Found private field in object props", cx = "sequence", sx = "call_type_args", cH = 238, Gd = 12348, sH = "++", Md = 68863, Bd = 72001, qd = 70084, Ud = "label", mv = -45, vx = "jsx_opening_attribute", Hd = 43583, r8 = "%F", Xd = 43784, Yd = 113791, lx = "call_arguments", e8 = 126503, Vd = 43743, Zu = "0", zd = 119967, n8 = 126538, bx = "new_", _v = 449540197, Kd = 64109, Wd = 68466, Jd = 177983, wt = 248, px = "program", Xe = "@,]@]", $d = 68031, mx = "function_type", _x = "type_", t8 = 8484, Zd = 67382, Qd = 42537, rk = 226, ek = 66559, nk = 42993, tk = 64274, u8 = 71236, uk = 120069, ik = 72105, fk = 126570, xk = "object", ok = 42959, A7 = "break", yx = "for_of_statement", ak = 43695, i8 = 126551, ck = 66955, f8 = 126520, sk = 66499, L2 = 1024, vk = 67455, lk = 43018, vH = 198, x8 = 126522, hx = "function_declaration", bk = 73064, dx = "await", pk = 92728, mk = 70418, _k = 68119, kx = "function_rest_param", yk = 42653, o8 = 11703, bi = "left", a8 = 70449, hk = 184, wx = "declare_type_alias", Ex = 16777215, c8 = 70302, lH = "/=", bH = "|=", dk = 55242, kk = 126583, wk = 124927, Ek = 124895, Sk = 72959, gk = 65497, pH = "Invalid legacy octal ", rs = "typeof", Fk = "explicit_type", Sx = "statement_list", Tk = 65495, gx = "class_method", s8 = 8526, v8 = 244, Ok = 67861, l8 = 119994, b8 = "enum", mH = 2147483647, Ik = 69762, _H = 208, R2 = "in", Ak = 11702, p8 = 67638, yH = ", characters ", Nk = 70753, yv = "super", Ck = 92783, Pk = 8304, m8 = 126504, Fx = "import_specifier", Dk = 68324, Lk = 101589, Rk = 67646, Tx = "expression_or_spread", jk = 74879, Gk = 43792, _8 = 43260, Mk = 93052, hH = "{", Bk = 65574, qk = 125258, hv = 224, Ox = "jsx_element_name_member_expression", j2 = "instanceof", Uk = 69599, Hk = 43560, Ix = "function_expression", y8 = 223, Xk = 72242, Yk = 11498, Vk = 126467, zk = 73112, dH = 140, h8 = 70107, Kk = 13311, Ax = "jsx_children", d8 = 126548, Wk = 63743, k8 = 43471, Nx = "jsx_expression", Jk = 69864, $k = 71998, Zk = 72e3, w8 = 126591, E8 = 12592, Cx = "type_params", Qk = 126578, S8 = 126537, kr = "{ ", rw = 123627, Px = "jsx_spread_attribute", Ce = "@,", ew = 70161, nw = 187, g8 = 126500, Dx = "label_identifier", tw = 42606, Lx = "number_literal_type", F8 = 42999, uw = 64310, kH = -594953737, iw = 122623, T8 = "hasUnknownMembers", Rx = "array", wH = "^=", jx = "enum_string_member", fw = 65536, xw = 65615, es = "void", ow = 65135, Z0 = ")", EH = 138, aw = 70002, G2 = "let", cw = 70271, sw = "nan", W = "@[%s =@ ", vw = 194559, lw = 110579, Gx = "binding_type_identifier", bw = 42735, SH = 57343, Qu = "/", Mx = "for_in_statement_lhs", pw = 43503, mw = 8516, _w = 66938, yw = "ENOTDIR", gH = "TypeParameterInstantiation", hw = 69749, dw = 65381, kw = 83526, dv = "number", ww = 12447, FH = 154, O8 = 70286, Ew = 72160, Sw = 43493, TH = 206, Bx = "enum_member_identifier", I8 = 70280, M2 = "function", A8 = 70162, gw = 255, Fw = 67702, Tw = 66771, Ow = 70312, OH = "|", Iw = 93759, IH = "End_of_file", Aw = 43709, u1 = "new", AH = "Failure", B2 = "local", Nw = 101631, N8 = 8489, C8 = "with", qx = "enum_declaration", Cw = 218, Pw = 70457, P8 = 8488, Ux = "member", D8 = 64325, Dw = 247, Lw = 70448, Rw = 69967, L8 = 126535, jw = 71934, Hx = "import_named_specifier", Gw = 65312, Mw = 126619, Xx = "type_annotation", NH = 56320, Bw = 131071, qw = 120770, Uw = 67002, Yx = "with_", Vx = "statement_fork_point", CH = "finalizer", Hw = 12320, PH = "elements", zx = "literal", Xw = 68607, Yw = 8507, R8 = "each", DH = "Sys_error", Vw = 123535, zw = 130, Kx = "bigint_literal_type", Kw = 64829, j8 = 11727, Ww = 120538, Wx = "member_private_name", Jx = "type_alias", LH = "Printexc.handle_uncaught_exception", G8 = 126556, $x = "tagged_template", Zx = "pattern_object_property_literal_key", Jw = 43881, M8 = 72192, $w = 67826, Zw = 124910, Qw = 66511, ns = "int_of_string", rE = 43249, nr = "None", RH = "FunctionTypeParam", ui = "name", eE = 70285, s7 = 103, nE = 120744, Qx = 12288, ro = "intersection_type", tE = 11679, B8 = 11559, jH = "callee", uE = 71295, iE = 70018, fE = 11567, xE = 42954, GH = "*-/", r7 = "predicate", eo = "expression_statement", MH = "regexp", oE = 65479, BH = 132, aE = 11389, qu = "optional", qH = -602162310, z = "@]", cE = 120003, sE = 72249, UH = "Unexpected ", vE = 73008, q8 = "finally", no = "toplevel_statement_list", HH = "end", lE = 178207, XH = "&=", bE = 70301, YH = "%Li", pE = 72161, mE = 69746, _E = 70460, yE = 12799, U8 = 65535, hE = "loc", dE = 69375, kE = 43518, VH = 205, wE = 65487, to = "while_", EE = 183983, uo = "typeof_expression", SE = -673950933, gE = 42559, zH = "||", FE = 124926, TE = 55291, io = "jsx_element_name_identifier", fo = 8239, H8 = "mixed", KH = 136, OE = -253313196, IE = 11734, X8 = 67827, AE = 68287, NE = 119976, WH = "**", J = " =", Y8 = 888960333, CE = 124902, xo = "tuple_type", JH = 227, PE = 70726, DE = 73111, V8 = 126602, LE = 126529, oo = "object_property_value_type", N0 = "%a", $H = ", ", ZH = "<=", RE = 69423, QH = 199, z8 = 11695, jE = 12294, K8 = 11711, GE = 67583, rX = 710, W8 = 126584, ME = 68295, BE = 72703, qE = "prefix", eX = -80, J8 = 69415, UE = 11492, q2 = "class", $8 = 65575, N7 = "continue", HE = 65663, nX = 2047, Z8 = 68120, XE = 71086, YE = 19967, Di = 782176664, VE = 120779, Q8 = 8486, pi = " ", tX = "||=", uX = "Undefined_recursive_module", zE = 66863, iX = "RestElement", r3 = 126634, KE = 66377, WE = 74751, ao = "jsx_element_name_namespaced", JE = 43334, $E = 66815, C7 = "typeAnnotation", ZE = 120126, co = "array_element", e3 = 64285, fX = 189, xX = "**=", Yr = "()", QE = 8543, so = "declare_module", vo = "export_batch_specifier", oX = "%i", aX = ">>>=", rS = 68029, cX = "importKind", P7 = "extends", eS = 64296, n3 = 43259, nS = 71679, tS = 64913, uS = 119969, iS = 94175, fS = 72440, t3 = 65141, lo = "function_", xS = 43071, oS = 42888, aS = 69807, cu = "variance", ts = 123, bo = "import_default_specifier", sX = ">>>", cS = 43764, mi = "pattern", sS = 71947, vS = 70655, kv = "consequent", vX = 4096, lS = 183, bS = 68447, pS = 65473, us = 255, mS = 73648, po = "call_type_arg", mo = 8238, _S = 68899, yS = 93026, Ye = "@[<2>[", hS = 110588, _o = "comment", lX = 191, yo = "switch_case", bX = 175, dS = 71942, ho = "do_while", wv = "constructor", kS = 43587, wS = 43586, Eu = "yield", ES = 67462, pX = "fd ", SS = -61, gS = "target", u3 = 72272, U2 = "var", mX = "impltype", i3 = 70108, H2 = "0o", FS = 119972, TS = 92991, f3 = 70441, x3 = 8450, OS = 120074, IS = 66717, ko = "interface_type", o3 = 43880, An = "%B", AS = 111355, Ev = 5760, NS = 11630, a3 = 126499, CS = "of", _X = ">>", yX = "Popping lex mode from empty stack", c3 = 120629, is = 108, PS = 43002, hX = "%=", s3 = 126539, DS = 126502, wo = "template_literal", LS = "src/parser/statement_parser.ml", RS = ": Not a directory", dX = "b", jS = 67461, GS = 11519, kX = "src/parser/flow_lexer.ml", wX = "Out_of_memory", MS = 120570, Eo = 12287, BS = 126534, qS = "index out of bounds", US = 73029, v3 = "_bigarr02", l3 = 126571, EX = "))", So = "for_statement_init", SX = "supertype", go = "class_property", b3 = "}", i1 = "this", Fo = "declare_module_exports", gX = "@", To = "union_type", Li = 65535, Oo = "variance_opt", HS = 94032, FX = 222, XS = 42124, Io = "this_expression", Ao = "jsx_element", TX = "typeArguments", YS = 65019, VS = 125251, zS = 64111, KS = 8471, No = "typeof_qualified_identifier", WS = 70497, OX = "EnumDefaultedMember", Co = 8202, JS = 66927, D7 = "switch", $S = 69634, Po = "unary_expression", ZS = 71215, IX = 126, QS = 67679, rg = 65597, AX = 207, eg = 120686, p3 = 72163, ng = 67001, tg = 42962, ug = 64262, X2 = 124, Do = 65279, ig = 126495, NX = 169, fg = 71944, CX = -10, m3 = "alternate", xg = 92975, og = 65489, Y2 = 252, ag = 67807, cg = 43187, sg = 68850, _3 = "export", vg = 66383, PX = "===", Lo = ".", Ro = "type_args", DX = 147, lg = 92159, LX = 240, jo = "jsx_element_name", bg = 72283, pg = 171, f1 = 116, mg = 110587, y3 = 70279, _g = 75075, yg = 65338, Go = "function_params", hg = 126627, RX = 213, h3 = 73065, dg = 71352, d3 = 119970, kg = 70005, wg = 12295, k3 = 120771, Eg = 71494, Sg = 11557, gg = 42191, jX = "flags", Fg = 68437, Tg = 70730, Mo = "optional_indexed_access", Bo = "pattern_object_p", Og = 42785, qo = "nullable_type", Bn = "value", Ig = 12343, Ag = 68415, Ng = 11694, GX = 221, Cg = 11726, Uo = "syntax", Pg = 119964, MX = "&&", Dg = 68497, Lg = 73097, fs4 = "null", w3 = 126523, Rg = 120084, jg = 126601, Gg = 8454, Mg = "expressions", Bg = 72144, V2 = '"', Zr = "(@[", BX = 1022, qX = 231, qg = 170, E3 = 12448, Ug = 68786, S3 = "<", UX = 931, HX = "(", XX = 196, YX = 2048, g3 = "an identifier", F3 = 69959, Hg = 68799, VX = "leadingComments", Xg = 72969, Yg = 182, Vg = 100351, Ho = "enum_defaulted_member", zg = 69839, Kg = 94026, Wg = 209, zX = ">>=", Jg = 131, T3 = 12336, v7 = "empty", KX = 331416730, WX = 204, $g = 70479, Zg = 69487, Qg = 101640, rF = 43123, JX = "([^/]+)", O3 = 8319, $X = 165, Xo = "object_type_property_setter", ZX = 909, eF = 15, nF = 12591, br = 125, tF = 92735, QX = "cases", uF = 183969, x1 = "bigint", rY = "Division_by_zero", iF = 67071, fF = 12329, I3 = 120004, xF = 69414, A3 = "if", oF = 126519, aF = "immediately within another function.", cF = 55238, sF = 126498, eY = "qualification", vF = 66256, wr = "@ }@]", z2 = 118, N3 = 11565, C3 = 120122, Yo = "pattern_object_rest_property", lF = 74862, P3 = "'", bF = -26065557, pF = 124911, Sv = 119, L7 = 104, Vo = "assignment", mF = 8457, K2 = "from", _F = 64321, yF = 113817, hF = 65629, dF = 42655, Ri = 102, kF = 43137, wF = 11502, a0 = ";@ ", R7 = 101, zo = "pattern_array_element_pattern", Wn = "body", Ko = "jsx_member_expression", EF = 65547, Wo = "jsx_attribute_value", Jo = "jsx_namespaced_name", D3 = 72967, SF = 126550, gv = 254, gF = 43807, FF = 43738, L3 = 126589, R3 = 8455, j3 = 126628, TF = 11670, nY = "*=", G3 = 120134, $o = "conditional", tY = " : flags Open_text and Open_binary are not compatible", M3 = 119965, OF = 69890, IF = 72817, AF = 164, NF = 43822, B3 = 69744, uY = "\\\\", CF = 43638, PF = 93047, DF = "AssignmentPattern", q3 = 64322, LF2 = 123190, iY = 188, Zo = "object_spread_property_type", RF = 70783, jF = 113663, fY = 160, U3 = 42622, H3 = 43823, ji = "init", Fv = 109, GF = 66503, X3 = "proto", MF = 74649, Qo = "optional_member", BF = 40981, qF = 120654, v = "@ ", ra = "enum_boolean_body", ea = "export_named_specifier", na = "declare_interface", UF = 70451, ta = "pattern_object_property_computed_key", Y3 = -97, V3 = 120539, z3 = 64317, HF = 12543, ua = "export_named_declaration_specifier", XF = 43359, K3 = 126530, W3 = 72713, YF = 113800, xY = 195, VF = 72367, zF = 72103, KF = 70278, ia = "if_consequent_statement", W2 = -85, J3 = 126496, fa = "try_catch", xa = "computed_key", oa = "class_", WF = 173823, aa = "pattern_object_property_identifier_key", oY = "f", ca = "arrow_function", $3 = 8485, JF = 126546, sa = "enum_boolean_member", $F = 94177, J2 = "delete", ZF = 232, aY = "blocks", va = "pattern_array_rest_element_pattern", QF = 78894, Z3 = 66512, rT = 94111, Tv = "string", Ss = "test", eT = 69572, nT = 66463, tT = 66335, uT = 72348, iT = 73061, o1 = ":", la = "enum_body", fT = 110590, ba = "function_this_param_type", xT = 215, oT = 77823, cY = "minus", sY = 201, aT = 119980, pa = "private_name", ma = "object_key", _a4 = "function_param_type", vY = "<<", cT = 11718, a1 = "as", lY = "delegate", Gi = "true", sT = 67413, Q3 = 70854, vT = 73439, lT = 43776, bT = 71723, pT = 11505, mT = 214, _T = 120628, yT = 43513, ya = "jsx_attribute_name_namespaced", r6 = 120127, e6 = "Map.bal", n6 = "any", bY = "@[", pY = "camlinternalMod.ml", t6 = 126559, Uu = "import", u6 = 70404, ha = "jsx_spread_child", hT = 233, dT = 67897, kT = 119974, Hu = 8233, wT = 68405, i6 = 239, mY = "attributes", _Y = 173, da = "object_internal_slot_property_type", ET = 71351, ST = 242, gT = 67643, f6 = "shorthand", ka = "for_in_statement", FT = 126463, TT = 71338, OT = 69445, IT = 65370, AT = 73055, NT = 167, CT = 64911, wa = "pattern_object_property_pattern", yY = 212, hY = 197, x6 = 126579, PT = 64286, DT = "explicitType", LT = 67669, RT = 43866, dY = "Sys_blocked_io", o6 = "catch", jT = 123197, GT = 64466, MT = 65140, BT = 73030, qT = 69404, a6 = "protected", kY = 8204, UT = 67504, HT = 193, $2 = 246, XT = 43713, c6 = 120571, Ea = "array_type", wY = "%u", Sa = "export_default_declaration", ga = "class_expression", EY = "quasi", Vt = "%S", YT = 8525, s6 = 126515, VT = 120485, v6 = 43519, l6 = 120745, b6 = 94178, zT = 126588, zn = 127, KT = 66855, SY = "@{", gY = "visit_leading_comment", WT = 67742, FY = " : flags Open_rdonly and Open_wronly are not compatible", JT = 120144, p6 = "returnType", c1 = -744106340, s1 = 240, Fa = "-", m6 = 8469, gs = "async", _6 = 126521, $T = 72095, y6 = 216, TY = " : file already exists", ZT = 178205, QT = 8449, h6 = 94179, rO = 42774, d6 = "case", eO = 66965, nO = 66431, OY = 190, Ta = "declare_export_declaration", Z2 = "targs", Oa = "type_identifier", tO = 64284, uO = 43013, k6 = 43815, Ia = "function_body_any", iO = 66966, w6 = 120687, fO = 66939, xO = 66978, IY = 168, E6 = "public", oO = 68115, aO = 43712, S6 = 65598, g6 = 126547, cO = 110591, Aa = "indexed_access", AY = 12520, e7 = "interface", NY = `(Program not linked with -g, cannot print stack backtrace)
`, v1 = -46, Na = "string_literal_type", Ca = "import_namespace_specifier", sO = 120132, F6 = 11735, vO = 67505, T6 = 119893, O6 = "bool", Q2 = 1e3, _i = "default", lO = 236, C = "", bO = "exportKind", CY = "trailingComments", I6 = "^", pO = 71983, mO = 8348, _O = 66977, yO = 65594, Pa = "logical", Da = "jsx_member_expression_identifier", A6 = 210, PY = "cooked", La = "for_of_left_declaration", Ov = 63, hO = 72202, l7 = "argument", dO = 12442, kO = 43645, N6 = 120085, wO = 42539, C6 = 126468, DY = 166, LY = "Match_failure", EO = 68191, Su = "src/parser/flow_ast.ml", P6 = 11647, Ra = "declare_variable", xs = "+", SO = 71127, D6 = 120145, ja = "declare_export_declaration_decl", L6 = 64318, RY = 179, Ga = "class_implements", jY = "!=", GY = "inexact", MY = "%li", BY = 237, rl = "a", R6 = 73062, gO = 178, Ma = 65278, Ba = "function_rest_param_type", FO = 77711, TO = 70066, OO = 43714, qY = -696510241, j6 = 70480, IO = 69748, AO = 113788, NO = 94207, UY = `\r
`, qa = "class_body", CO = 126651, PO = 68735, DO = 43273, G6 = 119996, M6 = 67644, HY = 224, Ua = "catch_clause_pattern", Ha = "boolean_literal_type", B6 = 126554, q6 = 126557, LO = 113807, U6 = 126536, XY = "%", Iv = "property", RO = 71956, YY = "#", jO = 123213, el = "meta", Xa = "for_of_assignment_pattern", Ya = "if_statement", GO = 66421, MO = 8505, BO = 225, nl = 250, qO = 100343, H6 = "Literal", UO = 42887, Av = 115, VY = ";", HO = 1255, XO = "=", YO = 126566, VO = 93823, Va = "opaque_type", zY = "!==", za = "jsx_attribute", Ka = "type_annotation_hint", Mi = 32768, zO = 73727, KY = "range", WY = 245, KO = "jsError", X6 = 70006, WO = 43492, Y6 = "@]}", tr = "(Some ", JO = 8477, JY = 129, $O = 71487, V6 = 126564, $Y = `
`, ZO = 126514, QO = 70080, Wa = "generic_identifier_type", rI = 66811, Ja = "typeof_identifier", ZY = "~", eI = 65007, $a = "pattern_object_rest_property_pattern", nI = 194, QY = 1039100673, tI = 66461, uI = 70319, z6 = 11719, iI = 72271, Wt = -48, Za = "enum_string_body", fI = 70461, Qa = "export_named_declaration", xI = 110930, oI = 92862, rV = "??=", aI = 70440, K6 = "while", su = "camlinternalFormat.ml", cI = 43782, eV = 203, sI = 173791, vI = 11263, lI = 1114111, bI = 42969, W6 = 70750, rc = "jsx_identifier", pI = 70105, mI = 43014, _I = 11564, ec = "typeof_type", nV = "EEXIST", yI = 64847, hI = 71167, dI = 42511, kI = 72712, wI = 92995, EI = 43704, tl = 121, nc = "object_call_property_type", SI = 64433, ul = "operator", J6 = 68296, tc = "class_decorator", uc = 120, ic = "for_of_statement_lhs", gI = 11623, FI = 67004, TI = 71999, OI = 70708, II = 512, AI = 110927, NI = 71423, tV = 32752, CI = 93951, PI = 12292, fc = "object_type", $6 = "types", DI = 110580, uV = 177, LI = 126633, RI = 12686, xc = 8286, iV = 144, jI = 73647, fV = 228, Z6 = 70855, l1 = "0x", GI = 70366, MI = `
`, oc = "variable_declaration", BI = 65276, Q6 = 119981, qI = 71945, UI = 43887, j7 = 105, HI = 8335, XI = 123565, YI = 69505, VI = 70187, ac = "jsx_attribute_name_identifier", cc = "source", sc = "pattern_object_property_key", rp = 65548, zI = 66175, KI = 92766, vc = "pattern_assignment_pattern", lc = "object_type_property_getter", ep = 8305, G7 = "generator", np = "for", xV = "PropertyDefinition", oV = "--", vu = -36, WI = "mkdir", JI = 68223, bc = "generic_qualified_identifier_type", $I = 11686, pc = "jsx_closing_element", ZI = 43790, tp = ": No such file or directory", QI = 69687, rA = 66348, up = 72162, eA = 43388, nA = 72768, tA = 68351, h2 = "<2>", ip = 64297, uA = 125259, iA = 220, zr = ",@ ", aV = "win32", fp = 70281, mc = "member_property_identifier", fA = 68149, xA = 68111, oA = 71450, aA = 43009, _c = "member_property", cA = 73458, yi = "identifier", sA = 67423, vA = 66775, lA = 110951, cV = "Internal Error: Found object private prop", yc = "super_expression", hc = "jsx_opening_element", bA = 177976, dc = "variable_declarator_pattern", kc = "pattern_expression", wc = "jsx_member_expression_object", pA = 68252, mA = 77808, Nv = -835925911, Ec = "import_declaration", _A = 55203, sV = "Pervasives.do_at_exit", vV = "utf8", ii = "key", yA = 43702, Sc = "spread_property", xp = 126563, hA = 863850040, dA = 70106, op = 67592, gc = "function_expression_or_method", kA = 71958, Fc = "for_init_declaration", wA = 71955, ap = 123214, EA = 68479, lV = "==", SA = 43019, gA = 123180, cp = 217, Cv = "specifiers", Tc = "function_body", FA = 69622, sp = 8487, TA = 43641, bV = "Unexpected token `", pV = "v", OA = 123135, IA = 69295, vp = 120093, AA = 8521, lp = 43642, mV = 176;
            function Ku0(t4, n, e4, i4, x4) {
              if (i4 <= n)
                for (var c = 1; c <= x4; c++)
                  e4[i4 + c] = t4[n + c];
              else
                for (var c = x4; c >= 1; c--)
                  e4[i4 + c] = t4[n + c];
              return 0;
            }
            function Wu0(t4) {
              for (var n = [0]; t4 !== 0; ) {
                for (var e4 = t4[1], i4 = 1; i4 < e4.length; i4++)
                  n.push(e4[i4]);
                t4 = t4[2];
              }
              return n;
            }
            function Ju0(t4, n, e4) {
              var i4 = new Array(e4 + 1);
              i4[0] = 0;
              for (var x4 = 1, c = n + 1; x4 <= e4; x4++, c++)
                i4[x4] = t4[c];
              return i4;
            }
            function NA(t4, n, e4) {
              var i4 = String.fromCharCode;
              if (n == 0 && e4 <= vX && e4 == t4.length)
                return i4.apply(null, t4);
              for (var x4 = C; 0 < e4; n += L2, e4 -= L2)
                x4 += i4.apply(null, t4.slice(n, n + Math.min(e4, L2)));
              return x4;
            }
            function bp(t4) {
              if (z0.Uint8Array)
                var n = new z0.Uint8Array(t4.l);
              else
                var n = new Array(t4.l);
              for (var e4 = t4.c, i4 = e4.length, x4 = 0; x4 < i4; x4++)
                n[x4] = e4.charCodeAt(x4);
              for (i4 = t4.l; x4 < i4; x4++)
                n[x4] = 0;
              return t4.c = n, t4.t = 4, n;
            }
            function Fs(t4, n, e4, i4, x4) {
              if (x4 == 0)
                return 0;
              if (i4 == 0 && (x4 >= e4.l || e4.t == 2 && x4 >= e4.c.length))
                e4.c = t4.t == 4 ? NA(t4.c, n, x4) : n == 0 && t4.c.length == x4 ? t4.c : t4.c.substr(n, x4), e4.t = e4.c.length == e4.l ? 0 : 2;
              else if (e4.t == 2 && i4 == e4.c.length)
                e4.c += t4.t == 4 ? NA(t4.c, n, x4) : n == 0 && t4.c.length == x4 ? t4.c : t4.c.substr(n, x4), e4.t = e4.c.length == e4.l ? 0 : 2;
              else {
                e4.t != 4 && bp(e4);
                var c = t4.c, s2 = e4.c;
                if (t4.t == 4)
                  if (i4 <= n)
                    for (var p = 0; p < x4; p++)
                      s2[i4 + p] = c[n + p];
                  else
                    for (var p = x4 - 1; p >= 0; p--)
                      s2[i4 + p] = c[n + p];
                else {
                  for (var y = Math.min(x4, c.length - n), p = 0; p < y; p++)
                    s2[i4 + p] = c.charCodeAt(n + p);
                  for (; p < x4; p++)
                    s2[i4 + p] = 0;
                }
              }
              return 0;
            }
            function voe(t4) {
              return t4;
            }
            function Ts(t4, n, e4, i4, x4) {
              return Fs(t4, n, e4, i4, x4), 0;
            }
            function $u0(t4, n) {
              throw [0, t4, n];
            }
            function Pv(t4, n) {
              if (t4 == 0)
                return C;
              if (n.repeat)
                return n.repeat(t4);
              for (var e4 = C, i4 = 0; ; ) {
                if (t4 & 1 && (e4 += n), t4 >>= 1, t4 == 0)
                  return e4;
                n += n, i4++, i4 == 9 && n.slice(0, 1);
              }
            }
            function Dv(t4) {
              t4.t == 2 ? t4.c += Pv(t4.l - t4.c.length, "\0") : t4.c = NA(t4.c, 0, t4.c.length), t4.t = 0;
            }
            function _V(t4) {
              if (t4.length < 24) {
                for (var n = 0; n < t4.length; n++)
                  if (t4.charCodeAt(n) > zn)
                    return false;
                return true;
              } else
                return !/[^\x00-\x7f]/.test(t4);
            }
            function CA(t4) {
              for (var n = C, e4 = C, i4, x4, c, s2, p = 0, y = t4.length; p < y; p++) {
                if (x4 = t4.charCodeAt(p), x4 < Pi) {
                  for (var T = p + 1; T < y && (x4 = t4.charCodeAt(T)) < Pi; T++)
                    ;
                  if (T - p > II ? (e4.substr(0, 1), n += e4, e4 = C, n += t4.slice(p, T)) : e4 += t4.slice(p, T), T == y)
                    break;
                  p = T;
                }
                s2 = 1, ++p < y && ((c = t4.charCodeAt(p)) & -64) == jt && (i4 = c + (x4 << 6), x4 < HY ? (s2 = i4 - 12416, s2 < Pi && (s2 = 1)) : (s2 = 2, ++p < y && ((c = t4.charCodeAt(p)) & -64) == jt && (i4 = c + (i4 << 6), x4 < LX ? (s2 = i4 - 925824, (s2 < YX || s2 >= 55295 && s2 < 57344) && (s2 = 2)) : (s2 = 3, ++p < y && ((c = t4.charCodeAt(p)) & -64) == jt && x4 < 245 && (s2 = c - 63447168 + (i4 << 6), (s2 < 65536 || s2 > 1114111) && (s2 = 3)))))), s2 < 4 ? (p -= s2, e4 += "\uFFFD") : s2 > Li ? e4 += String.fromCharCode(55232 + (s2 >> 10), NH + (s2 & 1023)) : e4 += String.fromCharCode(s2), e4.length > L2 && (e4.substr(0, 1), n += e4, e4 = C);
              }
              return n + e4;
            }
            function Oc(t4, n, e4) {
              this.t = t4, this.c = n, this.l = e4;
            }
            Oc.prototype.toString = function() {
              switch (this.t) {
                case 9:
                  return this.c;
                default:
                  Dv(this);
                case 0:
                  if (_V(this.c))
                    return this.t = 9, this.c;
                  this.t = 8;
                case 8:
                  return this.c;
              }
            }, Oc.prototype.toUtf16 = function() {
              var t4 = this.toString();
              return this.t == 9 ? t4 : CA(t4);
            }, Oc.prototype.slice = function() {
              var t4 = this.t == 4 ? this.c.slice() : this.c;
              return new Oc(this.t, t4, this.l);
            };
            function yV(t4) {
              return new Oc(0, t4, t4.length);
            }
            function r2(t4) {
              return yV(t4);
            }
            function PA(t4, n) {
              $u0(t4, r2(n));
            }
            var zt = [0];
            function lu(t4) {
              PA(zt.Invalid_argument, t4);
            }
            function hV() {
              lu(qS);
            }
            function Jn(t4, n, e4) {
              if (e4 &= us, t4.t != 4) {
                if (n == t4.c.length)
                  return t4.c += String.fromCharCode(e4), n + 1 == t4.l && (t4.t = 0), 0;
                bp(t4);
              }
              return t4.c[n] = e4, 0;
            }
            function b1(t4, n, e4) {
              return n >>> 0 >= t4.l && hV(), Jn(t4, n, e4);
            }
            function Xu(t4, n) {
              switch (t4.t & 6) {
                default:
                  if (n >= t4.c.length)
                    return 0;
                case 0:
                  return t4.c.charCodeAt(n);
                case 4:
                  return t4.c[n];
              }
            }
            function os(t4, n) {
              if (t4.fun)
                return os(t4.fun, n);
              if (typeof t4 != "function")
                return t4;
              var e4 = t4.length | 0;
              if (e4 === 0)
                return t4.apply(null, n);
              var i4 = n.length | 0, x4 = e4 - i4 | 0;
              return x4 == 0 ? t4.apply(null, n) : x4 < 0 ? os(t4.apply(null, n.slice(0, e4)), n.slice(e4)) : function() {
                for (var c = arguments.length == 0 ? 1 : arguments.length, s2 = new Array(n.length + c), p = 0; p < n.length; p++)
                  s2[p] = n[p];
                for (var p = 0; p < arguments.length; p++)
                  s2[n.length + p] = arguments[p];
                return os(t4, s2);
              };
            }
            function il() {
              lu(qS);
            }
            function tu(t4, n) {
              return n >>> 0 >= t4.length - 1 && il(), t4;
            }
            function Zu0(t4) {
              return isFinite(t4) ? Math.abs(t4) >= 22250738585072014e-324 ? 0 : t4 != 0 ? 1 : 2 : isNaN(t4) ? 4 : 3;
            }
            function Ic(t4) {
              return (t4.t & 6) != 0 && Dv(t4), t4.c;
            }
            var Qu0 = Math.log2 && Math.log2(11235582092889474e291) == 1020;
            function r70(t4) {
              if (Qu0)
                return Math.floor(Math.log2(t4));
              var n = 0;
              if (t4 == 0)
                return -1 / 0;
              if (t4 >= 1)
                for (; t4 >= 2; )
                  t4 /= 2, n++;
              else
                for (; t4 < 1; )
                  t4 *= 2, n--;
              return n;
            }
            function DA(t4) {
              var n = new z0.Float32Array(1);
              n[0] = t4;
              var e4 = new z0.Int32Array(n.buffer);
              return e4[0] | 0;
            }
            var dV = Math.pow(2, -24);
            function kV(t4) {
              throw t4;
            }
            function wV() {
              kV(zt.Division_by_zero);
            }
            function sn(t4, n, e4) {
              this.lo = t4 & Ex, this.mi = n & Ex, this.hi = e4 & Li;
            }
            sn.prototype.caml_custom = "_j", sn.prototype.copy = function() {
              return new sn(this.lo, this.mi, this.hi);
            }, sn.prototype.ucompare = function(t4) {
              return this.hi > t4.hi ? 1 : this.hi < t4.hi ? -1 : this.mi > t4.mi ? 1 : this.mi < t4.mi ? -1 : this.lo > t4.lo ? 1 : this.lo < t4.lo ? -1 : 0;
            }, sn.prototype.compare = function(t4) {
              var n = this.hi << 16, e4 = t4.hi << 16;
              return n > e4 ? 1 : n < e4 ? -1 : this.mi > t4.mi ? 1 : this.mi < t4.mi ? -1 : this.lo > t4.lo ? 1 : this.lo < t4.lo ? -1 : 0;
            }, sn.prototype.neg = function() {
              var t4 = -this.lo, n = -this.mi + (t4 >> 24), e4 = -this.hi + (n >> 24);
              return new sn(t4, n, e4);
            }, sn.prototype.add = function(t4) {
              var n = this.lo + t4.lo, e4 = this.mi + t4.mi + (n >> 24), i4 = this.hi + t4.hi + (e4 >> 24);
              return new sn(n, e4, i4);
            }, sn.prototype.sub = function(t4) {
              var n = this.lo - t4.lo, e4 = this.mi - t4.mi + (n >> 24), i4 = this.hi - t4.hi + (e4 >> 24);
              return new sn(n, e4, i4);
            }, sn.prototype.mul = function(t4) {
              var n = this.lo * t4.lo, e4 = (n * dV | 0) + this.mi * t4.lo + this.lo * t4.mi, i4 = (e4 * dV | 0) + this.hi * t4.lo + this.mi * t4.mi + this.lo * t4.hi;
              return new sn(n, e4, i4);
            }, sn.prototype.isZero = function() {
              return (this.lo | this.mi | this.hi) == 0;
            }, sn.prototype.isNeg = function() {
              return this.hi << 16 < 0;
            }, sn.prototype.and = function(t4) {
              return new sn(this.lo & t4.lo, this.mi & t4.mi, this.hi & t4.hi);
            }, sn.prototype.or = function(t4) {
              return new sn(this.lo | t4.lo, this.mi | t4.mi, this.hi | t4.hi);
            }, sn.prototype.xor = function(t4) {
              return new sn(this.lo ^ t4.lo, this.mi ^ t4.mi, this.hi ^ t4.hi);
            }, sn.prototype.shift_left = function(t4) {
              return t4 = t4 & 63, t4 == 0 ? this : t4 < 24 ? new sn(this.lo << t4, this.mi << t4 | this.lo >> 24 - t4, this.hi << t4 | this.mi >> 24 - t4) : t4 < 48 ? new sn(0, this.lo << t4 - 24, this.mi << t4 - 24 | this.lo >> 48 - t4) : new sn(0, 0, this.lo << t4 - 48);
            }, sn.prototype.shift_right_unsigned = function(t4) {
              return t4 = t4 & 63, t4 == 0 ? this : t4 < 24 ? new sn(this.lo >> t4 | this.mi << 24 - t4, this.mi >> t4 | this.hi << 24 - t4, this.hi >> t4) : t4 < 48 ? new sn(this.mi >> t4 - 24 | this.hi << 48 - t4, this.hi >> t4 - 24, 0) : new sn(this.hi >> t4 - 48, 0, 0);
            }, sn.prototype.shift_right = function(t4) {
              if (t4 = t4 & 63, t4 == 0)
                return this;
              var n = this.hi << 16 >> 16;
              if (t4 < 24)
                return new sn(this.lo >> t4 | this.mi << 24 - t4, this.mi >> t4 | n << 24 - t4, this.hi << 16 >> t4 >>> 16);
              var e4 = this.hi << 16 >> 31;
              return t4 < 48 ? new sn(this.mi >> t4 - 24 | this.hi << 48 - t4, this.hi << 16 >> t4 - 24 >> 16, e4 & Li) : new sn(this.hi << 16 >> t4 - 32, e4, e4);
            }, sn.prototype.lsl1 = function() {
              this.hi = this.hi << 1 | this.mi >> 23, this.mi = (this.mi << 1 | this.lo >> 23) & Ex, this.lo = this.lo << 1 & Ex;
            }, sn.prototype.lsr1 = function() {
              this.lo = (this.lo >>> 1 | this.mi << 23) & Ex, this.mi = (this.mi >>> 1 | this.hi << 23) & Ex, this.hi = this.hi >>> 1;
            }, sn.prototype.udivmod = function(t4) {
              for (var n = 0, e4 = this.copy(), i4 = t4.copy(), x4 = new sn(0, 0, 0); e4.ucompare(i4) > 0; )
                n++, i4.lsl1();
              for (; n >= 0; )
                n--, x4.lsl1(), e4.ucompare(i4) >= 0 && (x4.lo++, e4 = e4.sub(i4)), i4.lsr1();
              return { quotient: x4, modulus: e4 };
            }, sn.prototype.div = function(t4) {
              var n = this;
              t4.isZero() && wV();
              var e4 = n.hi ^ t4.hi;
              n.hi & Mi && (n = n.neg()), t4.hi & Mi && (t4 = t4.neg());
              var i4 = n.udivmod(t4).quotient;
              return e4 & Mi && (i4 = i4.neg()), i4;
            }, sn.prototype.mod = function(t4) {
              var n = this;
              t4.isZero() && wV();
              var e4 = n.hi;
              n.hi & Mi && (n = n.neg()), t4.hi & Mi && (t4 = t4.neg());
              var i4 = n.udivmod(t4).modulus;
              return e4 & Mi && (i4 = i4.neg()), i4;
            }, sn.prototype.toInt = function() {
              return this.lo | this.mi << 24;
            }, sn.prototype.toFloat = function() {
              return (this.hi << 16) * Math.pow(2, 32) + this.mi * Math.pow(2, 24) + this.lo;
            }, sn.prototype.toArray = function() {
              return [this.hi >> 8, this.hi & us, this.mi >> 16, this.mi >> 8 & us, this.mi & us, this.lo >> 16, this.lo >> 8 & us, this.lo & us];
            }, sn.prototype.lo32 = function() {
              return this.lo | (this.mi & us) << 24;
            }, sn.prototype.hi32 = function() {
              return this.mi >>> 8 & Li | this.hi << 16;
            };
            function pp(t4, n, e4) {
              return new sn(t4, n, e4);
            }
            function mp(t4) {
              if (!isFinite(t4))
                return isNaN(t4) ? pp(1, 0, tV) : t4 > 0 ? pp(0, 0, tV) : pp(0, 0, 65520);
              var n = t4 == 0 && 1 / t4 == -1 / 0 ? Mi : t4 >= 0 ? 0 : Mi;
              n && (t4 = -t4);
              var e4 = r70(t4) + 1023;
              e4 <= 0 ? (e4 = 0, t4 /= Math.pow(2, -rH)) : (t4 /= Math.pow(2, e4 - uU), t4 < 16 && (t4 *= 2, e4 -= 1), e4 == 0 && (t4 /= 2));
              var i4 = Math.pow(2, 24), x4 = t4 | 0;
              t4 = (t4 - x4) * i4;
              var c = t4 | 0;
              t4 = (t4 - c) * i4;
              var s2 = t4 | 0;
              return x4 = x4 & eF | n | e4 << 4, pp(s2, c, x4);
            }
            function fl(t4) {
              return t4.toArray();
            }
            function EV(t4, n, e4) {
              if (t4.write(32, n.dims.length), t4.write(32, n.kind | n.layout << 8), n.caml_custom == v3)
                for (var i4 = 0; i4 < n.dims.length; i4++)
                  n.dims[i4] < Li ? t4.write(16, n.dims[i4]) : (t4.write(16, Li), t4.write(32, 0), t4.write(32, n.dims[i4]));
              else
                for (var i4 = 0; i4 < n.dims.length; i4++)
                  t4.write(32, n.dims[i4]);
              switch (n.kind) {
                case 2:
                case 3:
                case 12:
                  for (var i4 = 0; i4 < n.data.length; i4++)
                    t4.write(8, n.data[i4]);
                  break;
                case 4:
                case 5:
                  for (var i4 = 0; i4 < n.data.length; i4++)
                    t4.write(16, n.data[i4]);
                  break;
                case 6:
                  for (var i4 = 0; i4 < n.data.length; i4++)
                    t4.write(32, n.data[i4]);
                  break;
                case 8:
                case 9:
                  t4.write(8, 0);
                  for (var i4 = 0; i4 < n.data.length; i4++)
                    t4.write(32, n.data[i4]);
                  break;
                case 7:
                  for (var i4 = 0; i4 < n.data.length / 2; i4++)
                    for (var x4 = fl(n.get(i4)), c = 0; c < 8; c++)
                      t4.write(8, x4[c]);
                  break;
                case 1:
                  for (var i4 = 0; i4 < n.data.length; i4++)
                    for (var x4 = fl(mp(n.get(i4))), c = 0; c < 8; c++)
                      t4.write(8, x4[c]);
                  break;
                case 0:
                  for (var i4 = 0; i4 < n.data.length; i4++) {
                    var x4 = DA(n.get(i4));
                    t4.write(32, x4);
                  }
                  break;
                case 10:
                  for (var i4 = 0; i4 < n.data.length / 2; i4++) {
                    var c = n.get(i4);
                    t4.write(32, DA(c[1])), t4.write(32, DA(c[2]));
                  }
                  break;
                case 11:
                  for (var i4 = 0; i4 < n.data.length / 2; i4++) {
                    for (var s2 = n.get(i4), x4 = fl(mp(s2[1])), c = 0; c < 8; c++)
                      t4.write(8, x4[c]);
                    for (var x4 = fl(mp(s2[2])), c = 0; c < 8; c++)
                      t4.write(8, x4[c]);
                  }
                  break;
              }
              e4[0] = (4 + n.dims.length) * 4, e4[1] = (4 + n.dims.length) * 8;
            }
            function SV(t4) {
              switch (t4) {
                case 7:
                case 10:
                case 11:
                  return 2;
                default:
                  return 1;
              }
            }
            function e70(t4, n) {
              var e4 = z0, i4;
              switch (t4) {
                case 0:
                  i4 = e4.Float32Array;
                  break;
                case 1:
                  i4 = e4.Float64Array;
                  break;
                case 2:
                  i4 = e4.Int8Array;
                  break;
                case 3:
                  i4 = e4.Uint8Array;
                  break;
                case 4:
                  i4 = e4.Int16Array;
                  break;
                case 5:
                  i4 = e4.Uint16Array;
                  break;
                case 6:
                  i4 = e4.Int32Array;
                  break;
                case 7:
                  i4 = e4.Int32Array;
                  break;
                case 8:
                  i4 = e4.Int32Array;
                  break;
                case 9:
                  i4 = e4.Int32Array;
                  break;
                case 10:
                  i4 = e4.Float32Array;
                  break;
                case 11:
                  i4 = e4.Float64Array;
                  break;
                case 12:
                  i4 = e4.Uint8Array;
                  break;
              }
              i4 || lu("Bigarray.create: unsupported kind");
              var x4 = new i4(n * SV(t4));
              return x4;
            }
            function LA(t4) {
              var n = new z0.Int32Array(1);
              n[0] = t4;
              var e4 = new z0.Float32Array(n.buffer);
              return e4[0];
            }
            function xl(t4) {
              return new sn(t4[7] << 0 | t4[6] << 8 | t4[5] << 16, t4[4] << 0 | t4[3] << 8 | t4[2] << 16, t4[1] << 0 | t4[0] << 8);
            }
            function RA(t4) {
              var n = t4.lo, e4 = t4.mi, i4 = t4.hi, x4 = (i4 & 32767) >> 4;
              if (x4 == nX)
                return (n | e4 | i4 & eF) == 0 ? i4 & Mi ? -1 / 0 : 1 / 0 : NaN;
              var c = Math.pow(2, -24), s2 = (n * c + e4) * c + (i4 & eF);
              return x4 > 0 ? (s2 += 16, s2 *= Math.pow(2, x4 - uU)) : s2 *= Math.pow(2, -rH), i4 & Mi && (s2 = -s2), s2;
            }
            function jA(t4) {
              for (var n = t4.length, e4 = 1, i4 = 0; i4 < n; i4++)
                t4[i4] < 0 && lu("Bigarray.create: negative dimension"), e4 = e4 * t4[i4];
              return e4;
            }
            function n70(t4, n) {
              return new sn(t4 & Ex, t4 >>> 24 & us | (n & Li) << 8, n >>> 16 & Li);
            }
            function GA(t4) {
              return t4.hi32();
            }
            function MA(t4) {
              return t4.lo32();
            }
            var t70 = v3;
            function Os(t4, n, e4, i4) {
              this.kind = t4, this.layout = n, this.dims = e4, this.data = i4;
            }
            Os.prototype.caml_custom = t70, Os.prototype.offset = function(t4) {
              var n = 0;
              if (typeof t4 == "number" && (t4 = [t4]), t4 instanceof Array || lu("bigarray.js: invalid offset"), this.dims.length != t4.length && lu("Bigarray.get/set: bad number of dimensions"), this.layout == 0)
                for (var e4 = 0; e4 < this.dims.length; e4++)
                  (t4[e4] < 0 || t4[e4] >= this.dims[e4]) && il(), n = n * this.dims[e4] + t4[e4];
              else
                for (var e4 = this.dims.length - 1; e4 >= 0; e4--)
                  (t4[e4] < 1 || t4[e4] > this.dims[e4]) && il(), n = n * this.dims[e4] + (t4[e4] - 1);
              return n;
            }, Os.prototype.get = function(t4) {
              switch (this.kind) {
                case 7:
                  var n = this.data[t4 * 2 + 0], e4 = this.data[t4 * 2 + 1];
                  return n70(n, e4);
                case 10:
                case 11:
                  var i4 = this.data[t4 * 2 + 0], x4 = this.data[t4 * 2 + 1];
                  return [gv, i4, x4];
                default:
                  return this.data[t4];
              }
            }, Os.prototype.set = function(t4, n) {
              switch (this.kind) {
                case 7:
                  this.data[t4 * 2 + 0] = MA(n), this.data[t4 * 2 + 1] = GA(n);
                  break;
                case 10:
                case 11:
                  this.data[t4 * 2 + 0] = n[1], this.data[t4 * 2 + 1] = n[2];
                  break;
                default:
                  this.data[t4] = n;
                  break;
              }
              return 0;
            }, Os.prototype.fill = function(t4) {
              switch (this.kind) {
                case 7:
                  var n = MA(t4), e4 = GA(t4);
                  if (n == e4)
                    this.data.fill(n);
                  else
                    for (var i4 = 0; i4 < this.data.length; i4++)
                      this.data[i4] = i4 % 2 == 0 ? n : e4;
                  break;
                case 10:
                case 11:
                  var x4 = t4[1], c = t4[2];
                  if (x4 == c)
                    this.data.fill(x4);
                  else
                    for (var i4 = 0; i4 < this.data.length; i4++)
                      this.data[i4] = i4 % 2 == 0 ? x4 : c;
                  break;
                default:
                  this.data.fill(t4);
                  break;
              }
            }, Os.prototype.compare = function(t4, n) {
              if (this.layout != t4.layout || this.kind != t4.kind) {
                var e4 = this.kind | this.layout << 8, i4 = t4.kind | t4.layout << 8;
                return i4 - e4;
              }
              if (this.dims.length != t4.dims.length)
                return t4.dims.length - this.dims.length;
              for (var x4 = 0; x4 < this.dims.length; x4++)
                if (this.dims[x4] != t4.dims[x4])
                  return this.dims[x4] < t4.dims[x4] ? -1 : 1;
              switch (this.kind) {
                case 0:
                case 1:
                case 10:
                case 11:
                  for (var c, s2, x4 = 0; x4 < this.data.length; x4++) {
                    if (c = this.data[x4], s2 = t4.data[x4], c < s2)
                      return -1;
                    if (c > s2)
                      return 1;
                    if (c != s2) {
                      if (!n)
                        return NaN;
                      if (c == c)
                        return 1;
                      if (s2 == s2)
                        return -1;
                    }
                  }
                  break;
                case 7:
                  for (var x4 = 0; x4 < this.data.length; x4 += 2) {
                    if (this.data[x4 + 1] < t4.data[x4 + 1])
                      return -1;
                    if (this.data[x4 + 1] > t4.data[x4 + 1])
                      return 1;
                    if (this.data[x4] >>> 0 < t4.data[x4] >>> 0)
                      return -1;
                    if (this.data[x4] >>> 0 > t4.data[x4] >>> 0)
                      return 1;
                  }
                  break;
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 8:
                case 9:
                case 12:
                  for (var x4 = 0; x4 < this.data.length; x4++) {
                    if (this.data[x4] < t4.data[x4])
                      return -1;
                    if (this.data[x4] > t4.data[x4])
                      return 1;
                  }
                  break;
              }
              return 0;
            };
            function Lv(t4, n, e4, i4) {
              this.kind = t4, this.layout = n, this.dims = e4, this.data = i4;
            }
            Lv.prototype = new Os(), Lv.prototype.offset = function(t4) {
              return typeof t4 != "number" && (t4 instanceof Array && t4.length == 1 ? t4 = t4[0] : lu("Ml_Bigarray_c_1_1.offset")), (t4 < 0 || t4 >= this.dims[0]) && il(), t4;
            }, Lv.prototype.get = function(t4) {
              return this.data[t4];
            }, Lv.prototype.set = function(t4, n) {
              return this.data[t4] = n, 0;
            }, Lv.prototype.fill = function(t4) {
              return this.data.fill(t4), 0;
            };
            function gV(t4, n, e4, i4) {
              var x4 = SV(t4);
              return jA(e4) * x4 != i4.length && lu("length doesn't match dims"), n == 0 && e4.length == 1 && x4 == 1 ? new Lv(t4, n, e4, i4) : new Os(t4, n, e4, i4);
            }
            function n7(t4) {
              PA(zt.Failure, t4);
            }
            function FV(t4, n, e4) {
              var i4 = t4.read32s();
              (i4 < 0 || i4 > 16) && n7("input_value: wrong number of bigarray dimensions");
              var x4 = t4.read32s(), c = x4 & us, s2 = x4 >> 8 & 1, p = [];
              if (e4 == v3)
                for (var y = 0; y < i4; y++) {
                  var T = t4.read16u();
                  if (T == Li) {
                    var E = t4.read32u(), d = t4.read32u();
                    E != 0 && n7("input_value: bigarray dimension overflow in 32bit"), T = d;
                  }
                  p.push(T);
                }
              else
                for (var y = 0; y < i4; y++)
                  p.push(t4.read32u());
              var w = jA(p), G = e70(c, w), A11 = gV(c, s2, p, G);
              switch (c) {
                case 2:
                  for (var y = 0; y < w; y++)
                    G[y] = t4.read8s();
                  break;
                case 3:
                case 12:
                  for (var y = 0; y < w; y++)
                    G[y] = t4.read8u();
                  break;
                case 4:
                  for (var y = 0; y < w; y++)
                    G[y] = t4.read16s();
                  break;
                case 5:
                  for (var y = 0; y < w; y++)
                    G[y] = t4.read16u();
                  break;
                case 6:
                  for (var y = 0; y < w; y++)
                    G[y] = t4.read32s();
                  break;
                case 8:
                case 9:
                  var S11 = t4.read8u();
                  S11 && n7("input_value: cannot read bigarray with 64-bit OCaml ints");
                  for (var y = 0; y < w; y++)
                    G[y] = t4.read32s();
                  break;
                case 7:
                  for (var k0 = new Array(8), y = 0; y < w; y++) {
                    for (var M = 0; M < 8; M++)
                      k0[M] = t4.read8u();
                    var K = xl(k0);
                    A11.set(y, K);
                  }
                  break;
                case 1:
                  for (var k0 = new Array(8), y = 0; y < w; y++) {
                    for (var M = 0; M < 8; M++)
                      k0[M] = t4.read8u();
                    var V = RA(xl(k0));
                    A11.set(y, V);
                  }
                  break;
                case 0:
                  for (var y = 0; y < w; y++) {
                    var V = LA(t4.read32s());
                    A11.set(y, V);
                  }
                  break;
                case 10:
                  for (var y = 0; y < w; y++) {
                    var f0 = LA(t4.read32s()), m0 = LA(t4.read32s());
                    A11.set(y, [gv, f0, m0]);
                  }
                  break;
                case 11:
                  for (var k0 = new Array(8), y = 0; y < w; y++) {
                    for (var M = 0; M < 8; M++)
                      k0[M] = t4.read8u();
                    for (var f0 = RA(xl(k0)), M = 0; M < 8; M++)
                      k0[M] = t4.read8u();
                    var m0 = RA(xl(k0));
                    A11.set(y, [gv, f0, m0]);
                  }
                  break;
              }
              return n[0] = (4 + i4) * 4, gV(c, s2, p, G);
            }
            function TV(t4, n, e4) {
              return t4.compare(n, e4);
            }
            function OV(t4, n) {
              return Math.imul(t4, n);
            }
            function as(t4, n) {
              return n = OV(n, -862048943), n = n << 15 | n >>> 32 - 15, n = OV(n, 461845907), t4 ^= n, t4 = t4 << 13 | t4 >>> 32 - 13, (t4 + (t4 << 2) | 0) + -430675100 | 0;
            }
            function u70(t4, n) {
              return t4 = as(t4, MA(n)), t4 = as(t4, GA(n)), t4;
            }
            function IV(t4, n) {
              return u70(t4, mp(n));
            }
            function AV(t4) {
              var n = jA(t4.dims), e4 = 0;
              switch (t4.kind) {
                case 2:
                case 3:
                case 12:
                  n > N4 && (n = N4);
                  var i4 = 0, x4 = 0;
                  for (x4 = 0; x4 + 4 <= t4.data.length; x4 += 4)
                    i4 = t4.data[x4 + 0] | t4.data[x4 + 1] << 8 | t4.data[x4 + 2] << 16 | t4.data[x4 + 3] << 24, e4 = as(e4, i4);
                  switch (i4 = 0, n & 3) {
                    case 3:
                      i4 = t4.data[x4 + 2] << 16;
                    case 2:
                      i4 |= t4.data[x4 + 1] << 8;
                    case 1:
                      i4 |= t4.data[x4 + 0], e4 = as(e4, i4);
                  }
                  break;
                case 4:
                case 5:
                  n > jt && (n = jt);
                  var i4 = 0, x4 = 0;
                  for (x4 = 0; x4 + 2 <= t4.data.length; x4 += 2)
                    i4 = t4.data[x4 + 0] | t4.data[x4 + 1] << 16, e4 = as(e4, i4);
                  (n & 1) != 0 && (e4 = as(e4, t4.data[x4]));
                  break;
                case 6:
                  n > 64 && (n = 64);
                  for (var x4 = 0; x4 < n; x4++)
                    e4 = as(e4, t4.data[x4]);
                  break;
                case 8:
                case 9:
                  n > 64 && (n = 64);
                  for (var x4 = 0; x4 < n; x4++)
                    e4 = as(e4, t4.data[x4]);
                  break;
                case 7:
                  n > 32 && (n = 32), n *= 2;
                  for (var x4 = 0; x4 < n; x4++)
                    e4 = as(e4, t4.data[x4]);
                  break;
                case 10:
                  n *= 2;
                case 0:
                  n > 64 && (n = 64);
                  for (var x4 = 0; x4 < n; x4++)
                    e4 = IV(e4, t4.data[x4]);
                  break;
                case 11:
                  n *= 2;
                case 1:
                  n > 32 && (n = 32);
                  for (var x4 = 0; x4 < n; x4++)
                    e4 = IV(e4, t4.data[x4]);
                  break;
              }
              return e4;
            }
            function i70(t4, n) {
              return n[0] = 4, t4.read32s();
            }
            function f70(t4, n) {
              switch (t4.read8u()) {
                case 1:
                  return n[0] = 4, t4.read32s();
                case 2:
                  n7("input_value: native integer value too large");
                default:
                  n7("input_value: ill-formed native integer");
              }
            }
            function x70(t4, n) {
              for (var e4 = new Array(8), i4 = 0; i4 < 8; i4++)
                e4[i4] = t4.read8u();
              return n[0] = 8, xl(e4);
            }
            function o70(t4, n, e4) {
              for (var i4 = fl(n), x4 = 0; x4 < 8; x4++)
                t4.write(8, i4[x4]);
              e4[0] = 8, e4[1] = 8;
            }
            function a70(t4, n, e4) {
              return t4.compare(n);
            }
            function c70(t4) {
              return t4.lo32() ^ t4.hi32();
            }
            var NV = { _j: { deserialize: x70, serialize: o70, fixed_length: 8, compare: a70, hash: c70 }, _i: { deserialize: i70, fixed_length: 4 }, _n: { deserialize: f70, fixed_length: 4 }, _bigarray: { deserialize: function(t4, n) {
              return FV(t4, n, "_bigarray");
            }, serialize: EV, compare: TV, hash: AV }, _bigarr02: { deserialize: function(t4, n) {
              return FV(t4, n, v3);
            }, serialize: EV, compare: TV, hash: AV } };
            function BA(t4) {
              return NV[t4.caml_custom] && NV[t4.caml_custom].compare;
            }
            function CV(t4, n, e4, i4) {
              var x4 = BA(n);
              if (x4) {
                var c = e4 > 0 ? x4(n, t4, i4) : x4(t4, n, i4);
                if (i4 && c != c)
                  return e4;
                if (+c != +c)
                  return +c;
                if ((c | 0) != 0)
                  return c | 0;
              }
              return e4;
            }
            function _p(t4) {
              return t4 instanceof Oc;
            }
            function qA(t4) {
              return _p(t4);
            }
            function PV(t4) {
              if (typeof t4 == "number")
                return Q2;
              if (_p(t4))
                return Y2;
              if (qA(t4))
                return 1252;
              if (t4 instanceof Array && t4[0] === t4[0] >>> 0 && t4[0] <= gw) {
                var n = t4[0] | 0;
                return n == gv ? 0 : n;
              } else {
                if (t4 instanceof String)
                  return AY;
                if (typeof t4 == "string")
                  return AY;
                if (t4 instanceof Number)
                  return Q2;
                if (t4 && t4.caml_custom)
                  return HO;
                if (t4 && t4.compare)
                  return 1256;
                if (typeof t4 == "function")
                  return 1247;
                if (typeof t4 == "symbol")
                  return 1251;
              }
              return 1001;
            }
            function Ac(t4, n) {
              return t4 < n ? -1 : t4 == n ? 0 : 1;
            }
            function DV(t4, n) {
              return t4.t & 6 && Dv(t4), n.t & 6 && Dv(n), t4.c < n.c ? -1 : t4.c > n.c ? 1 : 0;
            }
            function Ee(t4, n) {
              return DV(t4, n);
            }
            function yp(t4, n, e4) {
              for (var i4 = []; ; ) {
                if (!(e4 && t4 === n)) {
                  var x4 = PV(t4);
                  if (x4 == nl) {
                    t4 = t4[1];
                    continue;
                  }
                  var c = PV(n);
                  if (c == nl) {
                    n = n[1];
                    continue;
                  }
                  if (x4 !== c)
                    return x4 == Q2 ? c == HO ? CV(t4, n, -1, e4) : -1 : c == Q2 ? x4 == HO ? CV(n, t4, 1, e4) : 1 : x4 < c ? -1 : 1;
                  switch (x4) {
                    case 247:
                      lu(gd);
                      break;
                    case 248:
                      var p = Ac(t4[2], n[2]);
                      if (p != 0)
                        return p | 0;
                      break;
                    case 249:
                      lu(gd);
                      break;
                    case 250:
                      lu("equal: got Forward_tag, should not happen");
                      break;
                    case 251:
                      lu("equal: abstract value");
                      break;
                    case 252:
                      if (t4 !== n) {
                        var p = DV(t4, n);
                        if (p != 0)
                          return p | 0;
                      }
                      break;
                    case 253:
                      lu("equal: got Double_tag, should not happen");
                      break;
                    case 254:
                      lu("equal: got Double_array_tag, should not happen");
                      break;
                    case 255:
                      lu("equal: got Custom_tag, should not happen");
                      break;
                    case 1247:
                      lu(gd);
                      break;
                    case 1255:
                      var s2 = BA(t4);
                      if (s2 != BA(n))
                        return t4.caml_custom < n.caml_custom ? -1 : 1;
                      s2 || lu("compare: abstract value");
                      var p = s2(t4, n, e4);
                      if (p != p)
                        return e4 ? -1 : p;
                      if (p !== (p | 0))
                        return -1;
                      if (p != 0)
                        return p | 0;
                      break;
                    case 1256:
                      var p = t4.compare(n, e4);
                      if (p != p)
                        return e4 ? -1 : p;
                      if (p !== (p | 0))
                        return -1;
                      if (p != 0)
                        return p | 0;
                      break;
                    case 1e3:
                      if (t4 = +t4, n = +n, t4 < n)
                        return -1;
                      if (t4 > n)
                        return 1;
                      if (t4 != n) {
                        if (!e4)
                          return NaN;
                        if (t4 == t4)
                          return 1;
                        if (n == n)
                          return -1;
                      }
                      break;
                    case 1001:
                      if (t4 < n)
                        return -1;
                      if (t4 > n)
                        return 1;
                      if (t4 != n) {
                        if (!e4)
                          return NaN;
                        if (t4 == t4)
                          return 1;
                        if (n == n)
                          return -1;
                      }
                      break;
                    case 1251:
                      if (t4 !== n)
                        return e4 ? 1 : NaN;
                      break;
                    case 1252:
                      var t4 = Ic(t4), n = Ic(n);
                      if (t4 !== n) {
                        if (t4 < n)
                          return -1;
                        if (t4 > n)
                          return 1;
                      }
                      break;
                    case 12520:
                      var t4 = t4.toString(), n = n.toString();
                      if (t4 !== n) {
                        if (t4 < n)
                          return -1;
                        if (t4 > n)
                          return 1;
                      }
                      break;
                    case 246:
                    case 254:
                    default:
                      if (t4.length != n.length)
                        return t4.length < n.length ? -1 : 1;
                      t4.length > 1 && i4.push(t4, n, 1);
                      break;
                  }
                }
                if (i4.length == 0)
                  return 0;
                var y = i4.pop();
                n = i4.pop(), t4 = i4.pop(), y + 1 < t4.length && i4.push(t4, n, y + 1), t4 = t4[y], n = n[y];
              }
            }
            function LV(t4, n) {
              return yp(t4, n, true);
            }
            function s70() {
              return [0];
            }
            function Lt(t4) {
              return t4 < 0 && lu("Bytes.create"), new Oc(t4 ? 2 : 9, C, t4);
            }
            function RV(t4, n) {
              return +(yp(t4, n, false) == 0);
            }
            function v70(t4, n, e4, i4) {
              if (e4 > 0)
                if (n == 0 && (e4 >= t4.l || t4.t == 2 && e4 >= t4.c.length))
                  i4 == 0 ? (t4.c = C, t4.t = 2) : (t4.c = Pv(e4, String.fromCharCode(i4)), t4.t = e4 == t4.l ? 0 : 2);
                else
                  for (t4.t != 4 && bp(t4), e4 += n; n < e4; n++)
                    t4.c[n] = i4;
              return 0;
            }
            function ol(t4) {
              var n;
              if (t4 = Ic(t4), n = +t4, t4.length > 0 && n === n || (t4 = t4.replace(/_/g, C), n = +t4, t4.length > 0 && n === n || /^[+-]?nan$/i.test(t4)))
                return n;
              var e4 = /^ *([+-]?)0x([0-9a-f]+)\.?([0-9a-f]*)p([+-]?[0-9]+)/i.exec(t4);
              if (e4) {
                var i4 = e4[3].replace(/0+$/, C), x4 = parseInt(e4[1] + e4[2] + i4, 16), c = (e4[4] | 0) - 4 * i4.length;
                return n = x4 * Math.pow(2, c), n;
              }
              if (/^\+?inf(inity)?$/i.test(t4))
                return 1 / 0;
              if (/^-inf(inity)?$/i.test(t4))
                return -1 / 0;
              n7("float_of_string");
            }
            function UA(t4) {
              t4 = Ic(t4);
              var n = t4.length;
              n > 31 && lu("format_int: format too long");
              for (var e4 = { justify: xs, signstyle: Fa, filler: pi, alternate: false, base: 0, signedconv: false, width: 0, uppercase: false, sign: 1, prec: -1, conv: oY }, i4 = 0; i4 < n; i4++) {
                var x4 = t4.charAt(i4);
                switch (x4) {
                  case "-":
                    e4.justify = Fa;
                    break;
                  case "+":
                  case " ":
                    e4.signstyle = x4;
                    break;
                  case "0":
                    e4.filler = Zu;
                    break;
                  case "#":
                    e4.alternate = true;
                    break;
                  case "1":
                  case "2":
                  case "3":
                  case "4":
                  case "5":
                  case "6":
                  case "7":
                  case "8":
                  case "9":
                    for (e4.width = 0; x4 = t4.charCodeAt(i4) - 48, x4 >= 0 && x4 <= 9; )
                      e4.width = e4.width * 10 + x4, i4++;
                    i4--;
                    break;
                  case ".":
                    for (e4.prec = 0, i4++; x4 = t4.charCodeAt(i4) - 48, x4 >= 0 && x4 <= 9; )
                      e4.prec = e4.prec * 10 + x4, i4++;
                    i4--;
                  case "d":
                  case "i":
                    e4.signedconv = true;
                  case "u":
                    e4.base = 10;
                    break;
                  case "x":
                    e4.base = 16;
                    break;
                  case "X":
                    e4.base = 16, e4.uppercase = true;
                    break;
                  case "o":
                    e4.base = 8;
                    break;
                  case "e":
                  case "f":
                  case "g":
                    e4.signedconv = true, e4.conv = x4;
                    break;
                  case "E":
                  case "F":
                  case "G":
                    e4.signedconv = true, e4.uppercase = true, e4.conv = x4.toLowerCase();
                    break;
                }
              }
              return e4;
            }
            function HA(t4, n) {
              t4.uppercase && (n = n.toUpperCase());
              var e4 = n.length;
              t4.signedconv && (t4.sign < 0 || t4.signstyle != Fa) && e4++, t4.alternate && (t4.base == 8 && (e4 += 1), t4.base == 16 && (e4 += 2));
              var i4 = C;
              if (t4.justify == xs && t4.filler == pi)
                for (var x4 = e4; x4 < t4.width; x4++)
                  i4 += pi;
              if (t4.signedconv && (t4.sign < 0 ? i4 += Fa : t4.signstyle != Fa && (i4 += t4.signstyle)), t4.alternate && t4.base == 8 && (i4 += Zu), t4.alternate && t4.base == 16 && (i4 += l1), t4.justify == xs && t4.filler == Zu)
                for (var x4 = e4; x4 < t4.width; x4++)
                  i4 += Zu;
              if (i4 += n, t4.justify == Fa)
                for (var x4 = e4; x4 < t4.width; x4++)
                  i4 += pi;
              return r2(i4);
            }
            function XA(t4, n) {
              function e4(E, d) {
                if (Math.abs(E) < 1)
                  return E.toFixed(d);
                var w = parseInt(E.toString().split(xs)[1]);
                return w > 20 ? (w -= 20, E /= Math.pow(10, w), E += new Array(w + 1).join(Zu), d > 0 && (E = E + Lo + new Array(d + 1).join(Zu)), E) : E.toFixed(d);
              }
              var i4, x4 = UA(t4), c = x4.prec < 0 ? 6 : x4.prec;
              if ((n < 0 || n == 0 && 1 / n == -1 / 0) && (x4.sign = -1, n = -n), isNaN(n))
                i4 = sw, x4.filler = pi;
              else if (!isFinite(n))
                i4 = "inf", x4.filler = pi;
              else
                switch (x4.conv) {
                  case "e":
                    var i4 = n.toExponential(c), s2 = i4.length;
                    i4.charAt(s2 - 3) == ny && (i4 = i4.slice(0, s2 - 1) + Zu + i4.slice(s2 - 1));
                    break;
                  case "f":
                    i4 = e4(n, c);
                    break;
                  case "g":
                    c = c || 1, i4 = n.toExponential(c - 1);
                    var p = i4.indexOf(ny), y = +i4.slice(p + 1);
                    if (y < -4 || n >= 1e21 || n.toFixed(0).length > c) {
                      for (var s2 = p - 1; i4.charAt(s2) == Zu; )
                        s2--;
                      i4.charAt(s2) == Lo && s2--, i4 = i4.slice(0, s2 + 1) + i4.slice(p), s2 = i4.length, i4.charAt(s2 - 3) == ny && (i4 = i4.slice(0, s2 - 1) + Zu + i4.slice(s2 - 1));
                      break;
                    } else {
                      var T = c;
                      if (y < 0)
                        T -= y + 1, i4 = n.toFixed(T);
                      else
                        for (; i4 = n.toFixed(T), i4.length > c + 1; )
                          T--;
                      if (T) {
                        for (var s2 = i4.length - 1; i4.charAt(s2) == Zu; )
                          s2--;
                        i4.charAt(s2) == Lo && s2--, i4 = i4.slice(0, s2 + 1);
                      }
                    }
                    break;
                }
              return HA(x4, i4);
            }
            function hp(t4, n) {
              if (Ic(t4) == N2)
                return r2(C + n);
              var e4 = UA(t4);
              n < 0 && (e4.signedconv ? (e4.sign = -1, n = -n) : n >>>= 0);
              var i4 = n.toString(e4.base);
              if (e4.prec >= 0) {
                e4.filler = pi;
                var x4 = e4.prec - i4.length;
                x4 > 0 && (i4 = Pv(x4, Zu) + i4);
              }
              return HA(e4, i4);
            }
            var jV = 0;
            function M7() {
              return jV++;
            }
            function l70() {
              return 0;
            }
            function GV() {
              return [0];
            }
            var dp = [];
            function Qe(t4, n, e4) {
              var i4 = t4[1], x4 = dp[e4];
              if (x4 === void 0)
                for (var c = dp.length; c < e4; c++)
                  dp[c] = 0;
              else if (i4[x4] === n)
                return i4[x4 - 1];
              for (var s2 = 3, p = i4[1] * 2 + 1, y; s2 < p; )
                y = s2 + p >> 1 | 1, n < i4[y + 1] ? p = y - 2 : s2 = y;
              return dp[e4] = s2 + 1, n == i4[s2 + 1] ? i4[s2] : 0;
            }
            function b70(t4) {
              for (var n = C, e4 = n, i4, x4, c = 0, s2 = t4.length; c < s2; c++) {
                if (i4 = t4.charCodeAt(c), i4 < Pi) {
                  for (var p = c + 1; p < s2 && (i4 = t4.charCodeAt(p)) < Pi; p++)
                    ;
                  if (p - c > II ? (e4.substr(0, 1), n += e4, e4 = C, n += t4.slice(c, p)) : e4 += t4.slice(c, p), p == s2)
                    break;
                  c = p;
                }
                i4 < YX ? (e4 += String.fromCharCode(192 | i4 >> 6), e4 += String.fromCharCode(Pi | i4 & Ov)) : i4 < 55296 || i4 >= SH ? e4 += String.fromCharCode(HY | i4 >> 12, Pi | i4 >> 6 & Ov, Pi | i4 & Ov) : i4 >= 56319 || c + 1 == s2 || (x4 = t4.charCodeAt(c + 1)) < NH || x4 > SH ? e4 += "\xEF\xBF\xBD" : (c++, i4 = (i4 << 10) + x4 - 56613888, e4 += String.fromCharCode(LX | i4 >> 18, Pi | i4 >> 12 & Ov, Pi | i4 >> 6 & Ov, Pi | i4 & Ov)), e4.length > L2 && (e4.substr(0, 1), n += e4, e4 = C);
              }
              return n + e4;
            }
            function p70(t4) {
              var n = 9;
              return _V(t4) || (n = 8, t4 = b70(t4)), new Oc(n, t4, t4.length);
            }
            function B7(t4) {
              return p70(t4);
            }
            function m70(t4, n, e4) {
              if (!isFinite(t4))
                return isNaN(t4) ? B7(sw) : B7(t4 > 0 ? mU : "-infinity");
              var i4 = t4 == 0 && 1 / t4 == -1 / 0 ? 1 : t4 >= 0 ? 0 : 1;
              i4 && (t4 = -t4);
              var x4 = 0;
              if (t4 != 0)
                if (t4 < 1)
                  for (; t4 < 1 && x4 > -BX; )
                    t4 *= 2, x4--;
                else
                  for (; t4 >= 2; )
                    t4 /= 2, x4++;
              var c = x4 < 0 ? C : xs, s2 = C;
              if (i4)
                s2 = Fa;
              else
                switch (e4) {
                  case 43:
                    s2 = xs;
                    break;
                  case 32:
                    s2 = pi;
                    break;
                  default:
                    break;
                }
              if (n >= 0 && n < 13) {
                var p = Math.pow(2, n * 4);
                t4 = Math.round(t4 * p) / p;
              }
              var y = t4.toString(16);
              if (n >= 0) {
                var T = y.indexOf(Lo);
                if (T < 0)
                  y += Lo + Pv(n, Zu);
                else {
                  var E = T + 1 + n;
                  y.length < E ? y += Pv(E - y.length, Zu) : y = y.substr(0, E);
                }
              }
              return B7(s2 + l1 + y + "p" + c + x4.toString(10));
            }
            function _70(t4) {
              return +t4.isZero();
            }
            function kp(t4) {
              return new sn(t4 & Ex, t4 >> 24 & Ex, t4 >> 31 & Li);
            }
            function y70(t4) {
              return t4.toInt();
            }
            function h70(t4) {
              return +t4.isNeg();
            }
            function MV(t4) {
              return t4.neg();
            }
            function d70(t4, n) {
              var e4 = UA(t4);
              e4.signedconv && h70(n) && (e4.sign = -1, n = MV(n));
              var i4 = C, x4 = kp(e4.base), c = "0123456789abcdef";
              do {
                var s2 = n.udivmod(x4);
                n = s2.quotient, i4 = c.charAt(y70(s2.modulus)) + i4;
              } while (!_70(n));
              if (e4.prec >= 0) {
                e4.filler = pi;
                var p = e4.prec - i4.length;
                p > 0 && (i4 = Pv(p, Zu) + i4);
              }
              return HA(e4, i4);
            }
            function b7(t4) {
              return t4.l;
            }
            function un(t4) {
              return b7(t4);
            }
            function Vr(t4, n) {
              return Xu(t4, n);
            }
            function k70(t4, n) {
              return t4.add(n);
            }
            function w70(t4, n) {
              return t4.mul(n);
            }
            function YA(t4, n) {
              return t4.ucompare(n) < 0;
            }
            function BV(t4) {
              var n = 0, e4 = un(t4), i4 = 10, x4 = 1;
              if (e4 > 0)
                switch (Vr(t4, n)) {
                  case 45:
                    n++, x4 = -1;
                    break;
                  case 43:
                    n++, x4 = 1;
                    break;
                }
              if (n + 1 < e4 && Vr(t4, n) == 48)
                switch (Vr(t4, n + 1)) {
                  case 120:
                  case 88:
                    i4 = 16, n += 2;
                    break;
                  case 111:
                  case 79:
                    i4 = 8, n += 2;
                    break;
                  case 98:
                  case 66:
                    i4 = 2, n += 2;
                    break;
                  case 117:
                  case 85:
                    n += 2;
                    break;
                }
              return [n, x4, i4];
            }
            function wp(t4) {
              return t4 >= 48 && t4 <= 57 ? t4 - 48 : t4 >= 65 && t4 <= 90 ? t4 - 55 : t4 >= 97 && t4 <= In ? t4 - 87 : -1;
            }
            function Rv(t4) {
              var n = BV(t4), e4 = n[0], i4 = n[1], x4 = n[2], c = kp(x4), s2 = new sn(Ex, 268435455, Li).udivmod(c).quotient, p = Vr(t4, e4), y = wp(p);
              (y < 0 || y >= x4) && n7(ns);
              for (var T = kp(y); ; )
                if (e4++, p = Vr(t4, e4), p != 95) {
                  if (y = wp(p), y < 0 || y >= x4)
                    break;
                  YA(s2, T) && n7(ns), y = kp(y), T = k70(w70(c, T), y), YA(T, y) && n7(ns);
                }
              return e4 != un(t4) && n7(ns), x4 == 10 && YA(new sn(0, 0, Mi), T) && n7(ns), i4 < 0 && (T = MV(T)), T;
            }
            function jv(t4) {
              return t4.toFloat();
            }
            function Bi(t4) {
              var n = BV(t4), e4 = n[0], i4 = n[1], x4 = n[2], c = un(t4), s2 = -1 >>> 0, p = e4 < c ? Vr(t4, e4) : 0, y = wp(p);
              (y < 0 || y >= x4) && n7(ns);
              var T = y;
              for (e4++; e4 < c; e4++)
                if (p = Vr(t4, e4), p != 95) {
                  if (y = wp(p), y < 0 || y >= x4)
                    break;
                  T = x4 * T + y, T > s2 && n7(ns);
                }
              return e4 != c && n7(ns), T = i4 * T, x4 == 10 && (T | 0) != T && n7(ns), T | 0;
            }
            function E70(t4) {
              return t4.slice(1);
            }
            function S70(t4) {
              return !!t4;
            }
            function bn(t4) {
              return t4.toUtf16();
            }
            function g70(t4) {
              for (var n = {}, e4 = 1; e4 < t4.length; e4++) {
                var i4 = t4[e4];
                n[bn(i4[1])] = i4[2];
              }
              return n;
            }
            function F70(t4, n) {
              return +(yp(t4, n, false) < 0);
            }
            function Gv(e4, n) {
              e4 < 0 && il();
              var e4 = e4 + 1 | 0, i4 = new Array(e4);
              i4[0] = 0;
              for (var x4 = 1; x4 < e4; x4++)
                i4[x4] = n;
              return i4;
            }
            function T70() {
              return 0;
            }
            function at(t4) {
              PA(zt.Sys_error, t4);
            }
            var Nc = new Array();
            function p1(t4) {
              var n = Nc[t4];
              if (n.opened || at("Cannot flush a closed channel"), !n.buffer || n.buffer == C)
                return 0;
              if (n.fd && zt.fds[n.fd] && zt.fds[n.fd].output) {
                var e4 = zt.fds[n.fd].output;
                switch (e4.length) {
                  case 2:
                    e4(t4, n.buffer);
                    break;
                  default:
                    e4(n.buffer);
                }
              }
              return n.buffer = C, 0;
            }
            function qV() {
              return typeof z0.process < "u" && typeof z0.process.versions < "u" && typeof z0.process.versions.node < "u" && z0.process.platform !== "browser";
            }
            function O70() {
              function t4(e4) {
                if (e4.charAt(0) === Qu)
                  return [C, e4.substring(1)];
              }
              function n(e4) {
                var i4 = /^([a-zA-Z]:|[\\/]{2}[^\\/]+[\\/]+[^\\/]+)?([\\/])?([\s\S]*?)$/, x4 = i4.exec(e4), c = x4[1] || C, s2 = Boolean(c && c.charAt(1) !== o1);
                if (Boolean(x4[2] || s2)) {
                  var p = x4[1] || C, y = x4[2] || C;
                  return [p, e4.substring(p.length + y.length)];
                }
              }
              return z0.process && z0.process.platform && z0.process.platform === aV ? n : t4;
            }
            var VA = O70();
            function UV(t4) {
              return t4.slice(-1) !== Qu ? t4 + Qu : t4;
            }
            if (z0.process && z0.process.cwd)
              var al = z0.process.cwd().replace(/\\/g, Qu);
            else
              var al = "/static";
            al = UV(al);
            function I70(t4) {
              t4 = bn(t4), VA(t4) || (t4 = al + t4);
              for (var n = VA(t4), e4 = n[1].split(Qu), i4 = [], x4 = 0; x4 < e4.length; x4++)
                switch (e4[x4]) {
                  case "..":
                    i4.length > 1 && i4.pop();
                    break;
                  case ".":
                    break;
                  default:
                    i4.push(e4[x4]);
                    break;
                }
              return i4.unshift(n[0]), i4.orig = t4, i4;
            }
            var A70 = ["E2BIG", "EACCES", "EAGAIN", "EBADF", "EBUSY", "ECHILD", "EDEADLK", "EDOM", nV, "EFAULT", "EFBIG", "EINTR", "EINVAL", "EIO", "EISDIR", "EMFILE", "EMLINK", "ENAMETOOLONG", "ENFILE", "ENODEV", vh, "ENOEXEC", "ENOLCK", "ENOMEM", "ENOSPC", "ENOSYS", yw, PU, "ENOTTY", "ENXIO", "EPERM", "EPIPE", "ERANGE", "EROFS", "ESPIPE", "ESRCH", "EXDEV", "EWOULDBLOCK", "EINPROGRESS", "EALREADY", "ENOTSOCK", "EDESTADDRREQ", "EMSGSIZE", "EPROTOTYPE", "ENOPROTOOPT", "EPROTONOSUPPORT", "ESOCKTNOSUPPORT", "EOPNOTSUPP", "EPFNOSUPPORT", "EAFNOSUPPORT", "EADDRINUSE", "EADDRNOTAVAIL", "ENETDOWN", "ENETUNREACH", "ENETRESET", "ECONNABORTED", "ECONNRESET", "ENOBUFS", "EISCONN", "ENOTCONN", "ESHUTDOWN", "ETOOMANYREFS", "ETIMEDOUT", "ECONNREFUSED", "EHOSTDOWN", "EHOSTUNREACH", "ELOOP", "EOVERFLOW"];
            function m1(t4, n, e4, i4) {
              var x4 = A70.indexOf(t4);
              x4 < 0 && (i4 == null && (i4 = -9999), x4 = [0, i4]);
              var c = [x4, B7(n || C), B7(e4 || C)];
              return c;
            }
            var HV = {};
            function _1(t4) {
              return HV[t4];
            }
            function y1(t4, n) {
              throw [0, t4].concat(n);
            }
            function N70(t4) {
              return new Oc(4, t4, t4.length);
            }
            function C70(t4) {
              t4 = Ic(t4), at(t4 + tp);
            }
            function P70(t4, n) {
              return n >>> 0 >= t4.l && hV(), Xu(t4, n);
            }
            function XV() {
            }
            function gu(t4) {
              this.data = t4;
            }
            gu.prototype = new XV(), gu.prototype.truncate = function(t4) {
              var n = this.data;
              this.data = Lt(t4 | 0), Fs(n, 0, this.data, 0, t4);
            }, gu.prototype.length = function() {
              return b7(this.data);
            }, gu.prototype.write = function(t4, n, e4, i4) {
              var x4 = this.length();
              if (t4 + i4 >= x4) {
                var c = Lt(t4 + i4), s2 = this.data;
                this.data = c, Fs(s2, 0, this.data, 0, x4);
              }
              return Ts(n, e4, this.data, t4, i4), 0;
            }, gu.prototype.read = function(t4, n, e4, i4) {
              var x4 = this.length();
              return Fs(this.data, t4, n, e4, i4), 0;
            }, gu.prototype.read_one = function(t4) {
              return P70(this.data, t4);
            }, gu.prototype.close = function() {
            }, gu.prototype.constructor = gu;
            function t7(t4, n) {
              this.content = {}, this.root = t4, this.lookupFun = n;
            }
            t7.prototype.nm = function(t4) {
              return this.root + t4;
            }, t7.prototype.create_dir_if_needed = function(t4) {
              for (var n = t4.split(Qu), e4 = C, i4 = 0; i4 < n.length - 1; i4++)
                e4 += n[i4] + Qu, !this.content[e4] && (this.content[e4] = Symbol("directory"));
            }, t7.prototype.slash = function(t4) {
              return /\/$/.test(t4) ? t4 : t4 + Qu;
            }, t7.prototype.lookup = function(t4) {
              if (!this.content[t4] && this.lookupFun) {
                var n = this.lookupFun(r2(this.root), r2(t4));
                n !== 0 && (this.create_dir_if_needed(t4), this.content[t4] = new gu(n[1]));
              }
            }, t7.prototype.exists = function(t4) {
              if (t4 == C)
                return 1;
              var n = this.slash(t4);
              return this.content[n] ? 1 : (this.lookup(t4), this.content[t4] ? 1 : 0);
            }, t7.prototype.mkdir = function(t4, n, e4) {
              var i4 = e4 && _1(Kh);
              this.exists(t4) && (i4 ? y1(i4, m1(nV, WI, this.nm(t4))) : at(t4 + ": File exists"));
              var x4 = /^(.*)\/[^/]+/.exec(t4);
              x4 = x4 && x4[1] || C, this.exists(x4) || (i4 ? y1(i4, m1(vh, WI, this.nm(x4))) : at(x4 + tp)), this.is_dir(x4) || (i4 ? y1(i4, m1(yw, WI, this.nm(x4))) : at(x4 + RS)), this.create_dir_if_needed(this.slash(t4));
            }, t7.prototype.rmdir = function(t4, n) {
              var e4 = n && _1(Kh), i4 = t4 == C ? C : this.slash(t4), x4 = new RegExp(I6 + i4 + JX);
              this.exists(t4) || (e4 ? y1(e4, m1(vh, ad, this.nm(t4))) : at(t4 + tp)), this.is_dir(t4) || (e4 ? y1(e4, m1(yw, ad, this.nm(t4))) : at(t4 + RS));
              for (var c in this.content)
                c.match(x4) && (e4 ? y1(e4, m1(PU, ad, this.nm(t4))) : at(this.nm(t4) + ": Directory not empty"));
              delete this.content[i4];
            }, t7.prototype.readdir = function(t4) {
              var n = t4 == C ? C : this.slash(t4);
              this.exists(t4) || at(t4 + tp), this.is_dir(t4) || at(t4 + RS);
              var e4 = new RegExp(I6 + n + JX), i4 = {}, x4 = [];
              for (var c in this.content) {
                var s2 = c.match(e4);
                s2 && !i4[s2[1]] && (i4[s2[1]] = true, x4.push(s2[1]));
              }
              return x4;
            }, t7.prototype.is_dir = function(t4) {
              if (t4 == C)
                return true;
              var n = this.slash(t4);
              return this.content[n] ? 1 : 0;
            }, t7.prototype.unlink = function(t4) {
              var n = !!this.content[t4];
              return delete this.content[t4], n;
            }, t7.prototype.open = function(t4, n) {
              if (n.rdonly && n.wronly && at(this.nm(t4) + FY), n.text && n.binary && at(this.nm(t4) + tY), this.lookup(t4), this.content[t4]) {
                this.is_dir(t4) && at(this.nm(t4) + " : is a directory"), n.create && n.excl && at(this.nm(t4) + TY);
                var e4 = this.content[t4];
                return n.truncate && e4.truncate(), e4;
              } else {
                if (n.create)
                  return this.create_dir_if_needed(t4), this.content[t4] = new gu(Lt(0)), this.content[t4];
                C70(this.nm(t4));
              }
            }, t7.prototype.register = function(t4, n) {
              var e4;
              if (this.content[t4] && at(this.nm(t4) + TY), _p(n) && (e4 = new gu(n)), qA(n))
                e4 = new gu(n);
              else if (n instanceof Array)
                e4 = new gu(N70(n));
              else if (typeof n == "string")
                e4 = new gu(yV(n));
              else if (n.toString) {
                var i4 = B7(n.toString());
                e4 = new gu(i4);
              }
              e4 ? (this.create_dir_if_needed(t4), this.content[t4] = e4) : at(this.nm(t4) + " : registering file with invalid content type");
            }, t7.prototype.constructor = t7;
            function D70(t4) {
              for (var n = un(t4), e4 = new Array(n), i4 = 0; i4 < n; i4++)
                e4[i4] = Vr(t4, i4);
              return e4;
            }
            function L70(t4) {
              return t4.t != 4 && bp(t4), t4.c;
            }
            function Cc(t4) {
              this.fs = kj(), this.fd = t4;
            }
            Cc.prototype = new XV(), Cc.prototype.truncate = function(t4) {
              try {
                this.fs.ftruncateSync(this.fd, t4 | 0);
              } catch (n) {
                at(n.toString());
              }
            }, Cc.prototype.length = function() {
              try {
                return this.fs.fstatSync(this.fd).size;
              } catch (t4) {
                at(t4.toString());
              }
            }, Cc.prototype.write = function(t4, n, e4, i4) {
              var x4 = D70(n);
              x4 instanceof z0.Uint8Array || (x4 = new z0.Uint8Array(x4));
              var c = z0.Buffer.from(x4);
              try {
                this.fs.writeSync(this.fd, c, e4, i4, t4);
              } catch (s2) {
                at(s2.toString());
              }
              return 0;
            }, Cc.prototype.read = function(t4, n, e4, i4) {
              var x4 = L70(n);
              x4 instanceof z0.Uint8Array || (x4 = new z0.Uint8Array(x4));
              var c = z0.Buffer.from(x4);
              try {
                this.fs.readSync(this.fd, c, e4, i4, t4);
              } catch (p) {
                at(p.toString());
              }
              for (var s2 = 0; s2 < i4; s2++)
                b1(n, e4 + s2, c[e4 + s2]);
              return 0;
            }, Cc.prototype.read_one = function(t4) {
              var n = new z0.Uint8Array(1), e4 = z0.Buffer.from(n);
              try {
                this.fs.readSync(this.fd, e4, 0, 1, t4);
              } catch (i4) {
                at(i4.toString());
              }
              return e4[0];
            }, Cc.prototype.close = function() {
              try {
                this.fs.closeSync(this.fd);
              } catch (t4) {
                at(t4.toString());
              }
            }, Cc.prototype.constructor = Cc;
            function Fu(t4) {
              this.fs = kj(), this.root = t4;
            }
            Fu.prototype.nm = function(t4) {
              return this.root + t4;
            }, Fu.prototype.exists = function(t4) {
              try {
                return this.fs.existsSync(this.nm(t4)) ? 1 : 0;
              } catch {
                return 0;
              }
            }, Fu.prototype.mkdir = function(t4, n, e4) {
              try {
                return this.fs.mkdirSync(this.nm(t4), { mode: n }), 0;
              } catch (i4) {
                this.raise_nodejs_error(i4, e4);
              }
            }, Fu.prototype.rmdir = function(t4, n) {
              try {
                return this.fs.rmdirSync(this.nm(t4)), 0;
              } catch (e4) {
                this.raise_nodejs_error(e4, n);
              }
            }, Fu.prototype.readdir = function(t4, n) {
              try {
                return this.fs.readdirSync(this.nm(t4));
              } catch (e4) {
                this.raise_nodejs_error(e4, n);
              }
            }, Fu.prototype.is_dir = function(t4) {
              try {
                return this.fs.statSync(this.nm(t4)).isDirectory() ? 1 : 0;
              } catch (n) {
                at(n.toString());
              }
            }, Fu.prototype.unlink = function(t4, n) {
              try {
                var e4 = this.fs.existsSync(this.nm(t4)) ? 1 : 0;
                return this.fs.unlinkSync(this.nm(t4)), e4;
              } catch (i4) {
                this.raise_nodejs_error(i4, n);
              }
            }, Fu.prototype.open = function(t4, n, e4) {
              var i4 = noe(), x4 = 0;
              for (var c in n)
                switch (c) {
                  case "rdonly":
                    x4 |= i4.O_RDONLY;
                    break;
                  case "wronly":
                    x4 |= i4.O_WRONLY;
                    break;
                  case "append":
                    x4 |= i4.O_WRONLY | i4.O_APPEND;
                    break;
                  case "create":
                    x4 |= i4.O_CREAT;
                    break;
                  case "truncate":
                    x4 |= i4.O_TRUNC;
                    break;
                  case "excl":
                    x4 |= i4.O_EXCL;
                    break;
                  case "binary":
                    x4 |= i4.O_BINARY;
                    break;
                  case "text":
                    x4 |= i4.O_TEXT;
                    break;
                  case "nonblock":
                    x4 |= i4.O_NONBLOCK;
                    break;
                }
              try {
                var s2 = this.fs.openSync(this.nm(t4), x4);
                return new Cc(s2);
              } catch (p) {
                this.raise_nodejs_error(p, e4);
              }
            }, Fu.prototype.rename = function(t4, n, e4) {
              try {
                this.fs.renameSync(this.nm(t4), this.nm(n));
              } catch (i4) {
                this.raise_nodejs_error(i4, e4);
              }
            }, Fu.prototype.stat = function(t4, n) {
              try {
                var e4 = this.fs.statSync(this.nm(t4));
                return this.stats_from_js(e4);
              } catch (i4) {
                this.raise_nodejs_error(i4, n);
              }
            }, Fu.prototype.lstat = function(t4, n) {
              try {
                var e4 = this.fs.lstatSync(this.nm(t4));
                return this.stats_from_js(e4);
              } catch (i4) {
                this.raise_nodejs_error(i4, n);
              }
            }, Fu.prototype.symlink = function(t4, n, e4, i4) {
              try {
                return this.fs.symlinkSync(this.nm(n), this.nm(e4), t4 ? "dir" : "file"), 0;
              } catch (x4) {
                this.raise_nodejs_error(x4, i4);
              }
            }, Fu.prototype.readlink = function(t4, n) {
              try {
                var e4 = this.fs.readlinkSync(this.nm(t4), vV);
                return B7(e4);
              } catch (i4) {
                this.raise_nodejs_error(i4, n);
              }
            }, Fu.prototype.raise_nodejs_error = function(t4, n) {
              var e4 = _1(Kh);
              if (n && e4) {
                var i4 = m1(t4.code, t4.syscall, t4.path, t4.errno);
                y1(e4, i4);
              } else
                at(t4.toString());
            }, Fu.prototype.stats_from_js = function(t4) {
              var n;
              return t4.isFile() ? n = 0 : t4.isDirectory() ? n = 1 : t4.isCharacterDevice() ? n = 2 : t4.isBlockDevice() ? n = 3 : t4.isSymbolicLink() ? n = 4 : t4.isFIFO() ? n = 5 : t4.isSocket() && (n = 6), [0, t4.dev, t4.ino, n, t4.mode, t4.nlink, t4.uid, t4.gid, t4.rdev, t4.size, t4.atimeMs, t4.mtimeMs, t4.ctimeMs];
            }, Fu.prototype.constructor = Fu;
            function YV(t4) {
              var n = VA(t4);
              if (!!n)
                return n[0] + Qu;
            }
            var Ep = YV(al) || n7("unable to compute caml_root"), Mv = [];
            qV() ? Mv.push({ path: Ep, device: new Fu(Ep) }) : Mv.push({ path: Ep, device: new t7(Ep) }), Mv.push({ path: zU, device: new t7(zU) });
            function R70(e4) {
              for (var n = I70(e4), e4 = n.join(Qu), i4 = UV(e4), x4, c = 0; c < Mv.length; c++) {
                var s2 = Mv[c];
                i4.search(s2.path) == 0 && (!x4 || x4.path.length < s2.path.length) && (x4 = { path: s2.path, device: s2.device, rest: e4.substring(s2.path.length, e4.length) });
              }
              if (!x4) {
                var p = YV(e4);
                if (p && p.match(/^[a-zA-Z]:\/$/)) {
                  var s2 = { path: p, device: new Fu(p) };
                  Mv.push(s2), x4 = { path: s2.path, device: s2.device, rest: e4.substring(s2.path.length, e4.length) };
                }
              }
              if (x4)
                return x4;
              at("no device found for " + i4);
            }
            function VV(t4, n) {
              var e4 = Nc[t4], i4 = r2(n), x4 = un(i4);
              return e4.file.write(e4.offset, i4, 0, x4), e4.offset += x4, 0;
            }
            function j70(n) {
              var n = CA(n), e4 = z0;
              if (e4.process && e4.process.stdout && e4.process.stdout.write)
                e4.process.stderr.write(n);
              else {
                n.charCodeAt(n.length - 1) == 10 && (n = n.substr(0, n.length - 1));
                var i4 = e4.console;
                i4 && i4.error && i4.error(n);
              }
            }
            function G70(n) {
              var n = CA(n), e4 = z0;
              if (e4.process && e4.process.stdout && e4.process.stdout.write)
                e4.process.stdout.write(n);
              else {
                n.charCodeAt(n.length - 1) == 10 && (n = n.substr(0, n.length - 1));
                var i4 = e4.console;
                i4 && i4.log && i4.log(n);
              }
            }
            function Sp(t4, n, e4, i4) {
              zt.fds === void 0 && (zt.fds = new Array()), i4 = i4 || {};
              var x4 = {};
              return x4.file = e4, x4.offset = i4.append ? e4.length() : 0, x4.flags = i4, x4.output = n, zt.fds[t4] = x4, (!zt.fd_last_idx || t4 > zt.fd_last_idx) && (zt.fd_last_idx = t4), t4;
            }
            function loe(t4, n, e4) {
              for (var i4 = {}; n; ) {
                switch (n[1]) {
                  case 0:
                    i4.rdonly = 1;
                    break;
                  case 1:
                    i4.wronly = 1;
                    break;
                  case 2:
                    i4.append = 1;
                    break;
                  case 3:
                    i4.create = 1;
                    break;
                  case 4:
                    i4.truncate = 1;
                    break;
                  case 5:
                    i4.excl = 1;
                    break;
                  case 6:
                    i4.binary = 1;
                    break;
                  case 7:
                    i4.text = 1;
                    break;
                  case 8:
                    i4.nonblock = 1;
                    break;
                }
                n = n[2];
              }
              i4.rdonly && i4.wronly && at(Ic(t4) + FY), i4.text && i4.binary && at(Ic(t4) + tY);
              var x4 = R70(t4), c = x4.device.open(x4.rest, i4), s2 = zt.fd_last_idx ? zt.fd_last_idx : 0;
              return Sp(s2 + 1, VV, c, i4);
            }
            Sp(0, VV, new gu(Lt(0))), Sp(1, G70, new gu(Lt(0))), Sp(2, j70, new gu(Lt(0)));
            function M70(t4) {
              var n = zt.fds[t4];
              n.flags.wronly && at(pX + t4 + " is writeonly");
              var e4 = null;
              if (t4 == 0 && qV()) {
                var i4 = kj();
                e4 = function() {
                  return B7(i4.readFileSync(0, vV));
                };
              }
              var x4 = { file: n.file, offset: n.offset, fd: t4, opened: true, out: false, refill: e4 };
              return Nc[x4.fd] = x4, x4.fd;
            }
            function zV(t4) {
              var n = zt.fds[t4];
              n.flags.rdonly && at(pX + t4 + " is readonly");
              var e4 = { file: n.file, offset: n.offset, fd: t4, opened: true, out: true, buffer: C };
              return Nc[e4.fd] = e4, e4.fd;
            }
            function B70() {
              for (var t4 = 0, n = 0; n < Nc.length; n++)
                Nc[n] && Nc[n].opened && Nc[n].out && (t4 = [0, Nc[n].fd, t4]);
              return t4;
            }
            function boe(t4) {
              return t4;
            }
            function q70(t4, n, e4, i4) {
              var x4 = Nc[t4];
              x4.opened || at("Cannot output to a closed channel");
              var c;
              e4 == 0 && b7(n) == i4 ? c = n : (c = Lt(i4), Fs(n, e4, c, 0, i4));
              var s2 = c, p = Ic(s2), y = p.lastIndexOf($Y);
              return y < 0 ? x4.buffer += p : (x4.buffer += p.substr(0, y + 1), p1(t4), x4.buffer += p.substr(y + 1)), 0;
            }
            function zA(t4, n, e4, i4) {
              return q70(t4, n, e4, i4);
            }
            function KV(t4, n) {
              var e4 = r2(String.fromCharCode(n));
              return zA(t4, e4, 0, 1), 0;
            }
            function cl(t4, n) {
              return +(yp(t4, n, false) != 0);
            }
            function KA(t4, n) {
              var e4 = new Array(n + 1);
              e4[0] = t4;
              for (var i4 = 1; i4 <= n; i4++)
                e4[i4] = 0;
              return e4;
            }
            function U70(t4, n) {
              return t4[0] = nl, t4[1] = n, 0;
            }
            function h1(t4) {
              return t4 instanceof Array && t4[0] == t4[0] >>> 0 ? t4[0] : _p(t4) || qA(t4) ? Y2 : t4 instanceof Function || typeof t4 == "function" ? Dw : t4 && t4.caml_custom ? gw : Q2;
            }
            function hi(t4, n, e4) {
              e4 && z0.toplevelReloc && (t4 = z0.toplevelReloc(e4)), zt[t4 + 1] = n, e4 && (zt[e4] = n);
            }
            function WA(t4, n) {
              return HV[Ic(t4)] = n, 0;
            }
            function H70(t4) {
              return t4[2] = jV++, t4;
            }
            function X70(t4, n) {
              return t4 === n ? 1 : (t4.t & 6 && Dv(t4), n.t & 6 && Dv(n), t4.c == n.c ? 1 : 0);
            }
            function qn(t4, n) {
              return X70(t4, n);
            }
            function Y70() {
              lu(qS);
            }
            function It(t4, n) {
              return n >>> 0 >= un(t4) && Y70(), Vr(t4, n);
            }
            function n0(t4, n) {
              return 1 - qn(t4, n);
            }
            function V70() {
              return [0, r2("js_of_ocaml")];
            }
            function z70() {
              return 2147483647 / 4 | 0;
            }
            function K70(t4) {
              return 0;
            }
            var W70 = z0.process && z0.process.platform && z0.process.platform == aV ? jU : "Unix";
            function J70() {
              return [0, r2(W70), 32, 0];
            }
            function $70() {
              kV(zt.Not_found);
            }
            function WV(t4) {
              var n = z0, e4 = bn(t4);
              if (n.process && n.process.env && n.process.env[e4] != null)
                return B7(n.process.env[e4]);
              if (z0.jsoo_static_env && z0.jsoo_static_env[e4])
                return B7(z0.jsoo_static_env[e4]);
              $70();
            }
            function JA(t4) {
              for (var n = 1; t4 && t4.joo_tramp; )
                t4 = t4.joo_tramp.apply(null, t4.joo_args), n++;
              return t4;
            }
            function Tu(t4, n) {
              return { joo_tramp: t4, joo_args: n };
            }
            function N(t4, n) {
              if (typeof n == "function")
                return t4.fun = n, 0;
              if (n.fun)
                return t4.fun = n.fun, 0;
              for (var e4 = n.length; e4--; )
                t4[e4] = n[e4];
              return 0;
            }
            function poe(t4) {
              return t4;
            }
            function Et(t4) {
              return t4 instanceof Array ? t4 : z0.RangeError && t4 instanceof z0.RangeError && t4.message && t4.message.match(/maximum call stack/i) || z0.InternalError && t4 instanceof z0.InternalError && t4.message && t4.message.match(/too much recursion/i) ? zt.Stack_overflow : t4 instanceof z0.Error && _1(KO) ? [0, _1(KO), t4] : [0, zt.Failure, B7(String(t4))];
            }
            function Z70(t4) {
              switch (t4[2]) {
                case -8:
                case -11:
                case -12:
                  return 1;
                default:
                  return 0;
              }
            }
            function Q70(t4) {
              var n = C;
              if (t4[0] == 0) {
                if (n += t4[1][1], t4.length == 3 && t4[2][0] == 0 && Z70(t4[1]))
                  var i4 = t4[2], e4 = 1;
                else
                  var e4 = 2, i4 = t4;
                n += HX;
                for (var x4 = e4; x4 < i4.length; x4++) {
                  x4 > e4 && (n += $H);
                  var c = i4[x4];
                  typeof c == "number" ? n += c.toString() : c instanceof Oc || typeof c == "string" ? n += V2 + c.toString() + V2 : n += bv;
                }
                n += Z0;
              } else
                t4[0] == wt && (n += t4[1]);
              return n;
            }
            function JV(t4) {
              if (t4 instanceof Array && (t4[0] == 0 || t4[0] == wt)) {
                var n = _1(LH);
                if (n)
                  n(t4, false);
                else {
                  var e4 = Q70(t4), i4 = _1(sV);
                  i4 && i4(0), z0.console.error(yd + e4 + $Y);
                }
              } else
                throw t4;
            }
            function ri0() {
              var t4 = z0;
              t4.process && t4.process.on ? t4.process.on("uncaughtException", function(n, e4) {
                JV(n), t4.process.exit(2);
              }) : t4.addEventListener && t4.addEventListener("error", function(n) {
                n.error && JV(n.error);
              });
            }
            ri0();
            function u(t4, n) {
              return t4.length == 1 ? t4(n) : os(t4, [n]);
            }
            function o(t4, n, e4) {
              return t4.length == 2 ? t4(n, e4) : os(t4, [n, e4]);
            }
            function ur(t4, n, e4, i4) {
              return t4.length == 3 ? t4(n, e4, i4) : os(t4, [n, e4, i4]);
            }
            function R(t4, n, e4, i4, x4) {
              return t4.length == 4 ? t4(n, e4, i4, x4) : os(t4, [n, e4, i4, x4]);
            }
            function p7(t4, n, e4, i4, x4, c) {
              return t4.length == 5 ? t4(n, e4, i4, x4, c) : os(t4, [n, e4, i4, x4, c]);
            }
            function ei0(t4, n, e4, i4, x4, c, s2, p) {
              return t4.length == 7 ? t4(n, e4, i4, x4, c, s2, p) : os(t4, [n, e4, i4, x4, c, s2, p]);
            }
            var $A = [wt, r2(wX), -1], $V = [wt, r2(DH), -2], q7 = [wt, r2(AH), -3], ZA = [wt, r2(fH), -4], Jt = [wt, r2(KU), -7], ZV = [wt, r2(LY), -8], QV = [wt, r2(VU), -9], Sn = [wt, r2(wU), -11], sl = [wt, r2(uX), -12], rz = [0, s7], ni0 = [4, 0, 0, 0, [12, 45, [4, 0, 0, 0, 0]]], QA = [0, [11, r2('File "'), [2, 0, [11, r2('", line '), [4, 0, 0, 0, [11, r2(yH), [4, 0, 0, 0, [12, 45, [4, 0, 0, 0, [11, r2(": "), [2, 0, 0]]]]]]]]]], r2('File "%s", line %d, characters %d-%d: %s')], ez = [0, 0, [0, 0, 0], [0, 0, 0]], rN = r2(""), eN = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), Bv = [0, 0, 0, 0, 1, 0], nz = [0, r2(Rx), r2(co), r2(Ea), r2(ca), r2(Vo), r2(Hf), r2(Kx), r2(lf), r2(xf), r2(Gx), r2(Tn), r2(Ha), r2(A7), r2(Tf), r2(lx), r2(po), r2(sx), r2(Qi), r2(Ef), r2(Ua), r2(oa), r2(qa), r2(mf), r2(tc), r2(Df), r2(ga), r2(tf), r2(kf), r2(Ga), r2(Uf), r2(gx), r2(fx), r2(go), r2(hf), r2(_o), r2($f), r2(xa), r2($o), r2(N7), r2(I7), r2(xx), r2(Ta), r2(ja), r2(zf), r2(na), r2(so), r2(Fo), r2(wx), r2(Ra), r2(ho), r2(v7), r2(la), r2(ra), r2(sa), r2(qx), r2(Ho), r2(Bx), r2(jf), r2(If), r2(Za), r2(jx), r2(Af), r2(vo), r2(Sa), r2(sf), r2(Qa), r2(ua), r2(ea), r2(Nu), r2(Tx), r2(eo), r2(Sf), r2(Bf), r2(ka), r2(Mx), r2(Fc), r2(Xa), r2(La), r2(yx), r2(ic), r2(li), r2(So), r2(lo), r2(Tc), r2(Ia), r2(hx), r2(Ix), r2(gc), r2(Lf), r2(nf), r2(tx), r2(_a4), r2(Go), r2(kx), r2(Ba), r2(vf), r2(ba), r2(mx), r2(G7), r2(Wa), r2(bc), r2(Vf), r2(yi), r2(pf), r2(ia), r2(Ya), r2(Uu), r2(Ec), r2(bo), r2(Hx), r2(Ca), r2(Fx), r2(Aa), r2(e7), r2(af), r2(ko), r2(ro), r2(za), r2(Rf), r2(ac), r2(ya), r2(Wo), r2(Qf), r2(of), r2(ff), r2(Ax), r2(pc), r2(Ao), r2(jo), r2(io), r2(Ox), r2(ao), r2(Nx), r2(rf), r2(rc), r2(Ko), r2(Da), r2(wc), r2(Jo), r2(vx), r2(hc), r2(Px), r2(ha), r2(Dx), r2(nx), r2(zx), r2(Pa), r2(Ux), r2(Wx), r2(_c), r2(xr), r2(mc), r2(Of), r2(yf), r2(bx), r2(qo), r2(Lx), r2(gf), r2(nc), r2(Kf), r2(da), r2(ma), r2(ex), r2(Xf), r2(uf), r2(Nf), r2(ix), r2(oo), r2(Zo), r2(fc), r2(lc), r2(Xo), r2(Va), r2(df), r2(Mo), r2(Qo), r2(mi), r2(rx), r2(Zf), r2(zo), r2(bf), r2(va), r2(vc), r2(kc), r2(Wf), r2(Yf), r2(Bo), r2(Cf), r2(ta), r2(aa), r2(sc), r2(Zx), r2(wa), r2(Yo), r2($a), r2(r7), r2(De), r2(pa), r2(px), r2(Ju), r2(cx), r2(Mf), r2(Sc), r2(_f), r2(Vx), r2(Sx), r2(Na), r2(yc), r2(D7), r2(yo), r2(Uo), r2(Jf), r2($x), r2(wo), r2(Pf), r2(Io), r2(F7), r2(no), r2(fa), r2(xo), r2(_x), r2(Jx), r2(Xx), r2(Ka), r2(Ro), r2(qf), r2(Oa), r2(ax), r2(Ff), r2(Cx), r2(uo), r2(Ja), r2(wf), r2(No), r2(ec), r2(Po), r2(To), r2(Gf), r2(oc), r2(ux), r2(dc), r2(cu), r2(Oo), r2(to), r2(Yx), r2(Eu)], tz = [0, r2("first_leading"), r2("last_trailing")], uz = [0, 0];
            hi(11, sl, uX), hi(10, Sn, wU), hi(9, [wt, r2(dY), CX], dY), hi(8, QV, VU), hi(7, ZV, LY), hi(6, Jt, KU), hi(5, [wt, r2(rY), -6], rY), hi(4, [wt, r2(IH), -5], IH), hi(3, ZA, fH), hi(2, q7, AH), hi(1, $V, DH), hi(0, $A, wX);
            var ti0 = r2("output_substring"), ui0 = r2("%.12g"), ii0 = r2(Lo), fi0 = r2(Gi), xi0 = r2(Ci), oi0 = r2(uY), ai0 = r2("\\'"), ci0 = r2("\\b"), si0 = r2("\\t"), vi0 = r2("\\n"), li0 = r2("\\r"), bi0 = r2("List.iter2"), pi0 = r2("tl"), mi0 = r2("hd"), _i0 = r2("String.blit / Bytes.blit_string"), yi0 = r2("Bytes.blit"), hi0 = r2("String.sub / Bytes.sub"), di0 = r2("Array.blit"), ki0 = r2("Array.sub"), wi0 = r2("Map.remove_min_elt"), Ei0 = [0, 0, 0, 0], Si0 = [0, r2("map.ml"), 400, 10], gi0 = [0, 0, 0], Fi0 = r2(e6), Ti0 = r2(e6), Oi0 = r2(e6), Ii0 = r2(e6), Ai0 = r2("Stdlib.Queue.Empty"), Ni0 = r2("CamlinternalLazy.Undefined"), Ci0 = r2("Buffer.add_substring/add_subbytes"), Pi0 = r2("Buffer.add: cannot grow buffer"), Di0 = [0, r2(GU), 93, 2], Li0 = [0, r2(GU), 94, 2], Ri0 = r2("Buffer.sub"), ji0 = r2("%c"), Gi0 = r2("%s"), Mi0 = r2(oX), Bi0 = r2(MY), qi0 = r2(xH), Ui0 = r2(YH), Hi0 = r2("%f"), Xi0 = r2(An), Yi0 = r2("%{"), Vi0 = r2("%}"), zi0 = r2("%("), Ki0 = r2("%)"), Wi0 = r2(N0), Ji0 = r2("%t"), $i0 = r2("%?"), Zi0 = r2("%r"), Qi0 = r2("%_r"), rf0 = [0, r2(su), 850, 23], ef0 = [0, r2(su), 814, 21], nf0 = [0, r2(su), 815, 21], tf0 = [0, r2(su), 818, 21], uf0 = [0, r2(su), 819, 21], if0 = [0, r2(su), 822, 19], ff0 = [0, r2(su), 823, 19], xf0 = [0, r2(su), 826, 22], of0 = [0, r2(su), 827, 22], af0 = [0, r2(su), 831, 30], cf0 = [0, r2(su), 832, 30], sf0 = [0, r2(su), 836, 26], vf0 = [0, r2(su), 837, 26], lf0 = [0, r2(su), 846, 28], bf0 = [0, r2(su), 847, 28], pf0 = [0, r2(su), 851, 23], mf0 = r2(wY), _f0 = [0, r2(su), 1558, 4], yf0 = r2("Printf: bad conversion %["), hf0 = [0, r2(su), 1626, 39], df0 = [0, r2(su), 1649, 31], kf0 = [0, r2(su), 1650, 31], wf0 = r2("Printf: bad conversion %_"), Ef0 = r2(SY), Sf0 = r2(bY), gf0 = r2(SY), Ff0 = r2(bY), Tf0 = [0, [11, r2("invalid box description "), [3, 0, 0]], r2("invalid box description %S")], Of0 = r2(C), If0 = [0, 0, 4], Af0 = r2(C), Nf0 = r2(dX), Cf0 = r2("h"), Pf0 = r2("hov"), Df0 = r2("hv"), Lf0 = r2(pV), Rf0 = r2(sw), jf0 = r2("neg_infinity"), Gf0 = r2(mU), Mf0 = r2(Lo), Bf0 = r2("%+nd"), qf0 = r2("% nd"), Uf0 = r2("%+ni"), Hf0 = r2("% ni"), Xf0 = r2("%nx"), Yf0 = r2("%#nx"), Vf0 = r2("%nX"), zf0 = r2("%#nX"), Kf0 = r2("%no"), Wf0 = r2("%#no"), Jf0 = r2("%nd"), $f0 = r2(xH), Zf0 = r2("%nu"), Qf0 = r2("%+ld"), rx0 = r2("% ld"), ex0 = r2("%+li"), nx0 = r2("% li"), tx0 = r2("%lx"), ux0 = r2("%#lx"), ix0 = r2("%lX"), fx0 = r2("%#lX"), xx0 = r2("%lo"), ox0 = r2("%#lo"), ax0 = r2("%ld"), cx0 = r2(MY), sx0 = r2("%lu"), vx0 = r2("%+Ld"), lx0 = r2("% Ld"), bx0 = r2("%+Li"), px0 = r2("% Li"), mx0 = r2("%Lx"), _x0 = r2("%#Lx"), yx0 = r2("%LX"), hx0 = r2("%#LX"), dx0 = r2("%Lo"), kx0 = r2("%#Lo"), wx0 = r2("%Ld"), Ex0 = r2(YH), Sx0 = r2("%Lu"), gx0 = r2("%+d"), Fx0 = r2("% d"), Tx0 = r2("%+i"), Ox0 = r2("% i"), Ix0 = r2("%x"), Ax0 = r2("%#x"), Nx0 = r2("%X"), Cx0 = r2("%#X"), Px0 = r2("%o"), Dx0 = r2("%#o"), Lx0 = r2(N2), Rx0 = r2(oX), jx0 = r2(wY), Gx0 = r2(z), Mx0 = r2("@}"), Bx0 = r2("@?"), qx0 = r2(`@
`), Ux0 = r2("@."), Hx0 = r2("@@"), Xx0 = r2("@%"), Yx0 = r2(gX), Vx0 = r2("CamlinternalFormat.Type_mismatch"), zx0 = r2(C), Kx0 = [0, [11, r2($H), [2, 0, [2, 0, 0]]], r2(", %s%s")], Wx0 = [0, [11, r2(yd), [2, 0, [12, 10, 0]]], r2(TU)], Jx0 = [0, [11, r2("Fatal error in uncaught exception handler: exception "), [2, 0, [12, 10, 0]]], r2(`Fatal error in uncaught exception handler: exception %s
`)], $x0 = r2("Fatal error: out of memory in uncaught exception handler"), Zx0 = [0, [11, r2(yd), [2, 0, [12, 10, 0]]], r2(TU)], Qx0 = [0, [2, 0, [12, 10, 0]], r2(`%s
`)], ro0 = [0, [11, r2(NY), 0], r2(NY)], eo0 = r2("Raised at"), no0 = r2("Re-raised at"), to0 = r2("Raised by primitive operation at"), uo0 = r2("Called from"), io0 = r2(" (inlined)"), fo0 = r2(C), xo0 = [0, [2, 0, [12, 32, [2, 0, [11, r2(' in file "'), [2, 0, [12, 34, [2, 0, [11, r2(", line "), [4, 0, 0, 0, [11, r2(yH), ni0]]]]]]]]]], r2('%s %s in file "%s"%s, line %d, characters %d-%d')], oo0 = [0, [2, 0, [11, r2(" unknown location"), 0]], r2("%s unknown location")], ao0 = r2("Out of memory"), co0 = r2("Stack overflow"), so0 = r2("Pattern matching failed"), vo0 = r2("Assertion failed"), lo0 = r2("Undefined recursive module"), bo0 = [0, [12, 40, [2, 0, [2, 0, [12, 41, 0]]]], r2("(%s%s)")], po0 = r2(C), mo0 = r2(C), _o0 = [0, [12, 40, [2, 0, [12, 41, 0]]], r2("(%s)")], yo0 = [0, [4, 0, 0, 0, 0], r2(N2)], ho0 = [0, [3, 0, 0], r2(Vt)], do0 = r2(bv), ko0 = [0, r2(C), r2(`(Cannot print locations:
 bytecode executable program file not found)`), r2(`(Cannot print locations:
 bytecode executable program file appears to be corrupt)`), r2(`(Cannot print locations:
 bytecode executable program file has wrong magic number)`), r2(`(Cannot print locations:
 bytecode executable program file cannot be opened;
 -- too many open files. Try running with OCAMLRUNPARAM=b=2)`)], wo0 = [3, 0, 3], Eo0 = r2(Lo), So0 = r2(cv), go0 = r2("</"), Fo0 = r2(C), To0 = r2(cv), Oo0 = r2(S3), Io0 = r2(C), Ao0 = r2(MI), No0 = r2(C), Co0 = r2(C), Po0 = r2(C), Do0 = r2(C), Lo0 = [0, r2(C)], Ro0 = r2(C), jo0 = r2(C), Go0 = r2(C), Mo0 = r2(C), Bo0 = [0, r2(C), 0, r2(C)], qo0 = r2(C), Uo0 = r2("Stdlib.Format.String_tag"), Ho0 = [0, r2("camlinternalOO.ml"), 281, 50], Xo0 = r2(C), Yo0 = [0, r2(pY), 72, 5], Vo0 = [0, r2(pY), 81, 2], zo0 = r2("CamlinternalMod.update_mod: not a module"), Ko0 = r2("CamlinternalMod.init_mod: not a module"), Wo0 = r2("TMPDIR"), Jo0 = r2("TEMP"), $o0 = r2(jU), Zo0 = r2("Win32"), Qo0 = [0, r2("src/wtf8.ml"), 65, 9], ra0 = r2("Js_of_ocaml__Js.Error"), ea0 = r2(KO), na0 = [0, [15, 0], r2(N0)], ta0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ua0 = r2(Yr), ia0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], fa0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], xa0 = r2("Flow_ast.Program.statements"), oa0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], aa0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], ca0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], sa0 = [0, [17, 0, 0], r2(z)], va0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], la0 = r2(Xr), ba0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], pa0 = r2(tr), ma0 = r2(Z0), _a0 = r2(nr), ya0 = [0, [17, 0, 0], r2(z)], ha0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], da0 = r2("all_comments"), ka0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], wa0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Ea0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Sa0 = [0, [17, 0, 0], r2(z)], ga0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Fa0 = [0, [15, 0], r2(N0)], Ta0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Oa0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Ia0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Aa0 = [0, [15, 0], r2(N0)], Na0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Function.BodyBlock"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Function.BodyBlock@ ")], Ca0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Pa0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Da0 = [0, [17, 0, [12, 41, 0]], r2(d0)], La0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Ra0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Function.BodyExpression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Function.BodyExpression@ ")], ja0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Ga0 = [0, [15, 0], r2(N0)], Ma0 = r2(Yr), Ba0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], qa0 = r2("Flow_ast.Function.id"), Ua0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ha0 = r2(tr), Xa0 = r2(Z0), Ya0 = r2(nr), Va0 = [0, [17, 0, 0], r2(z)], za0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ka0 = r2(Dt), Wa0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ja0 = [0, [17, 0, 0], r2(z)], $a0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Za0 = r2(Wn), Qa0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], rc0 = [0, [17, 0, 0], r2(z)], ec0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], nc0 = r2(gs), tc0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], uc0 = [0, [9, 0, 0], r2(An)], ic0 = [0, [17, 0, 0], r2(z)], fc0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], xc0 = r2(G7), oc0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ac0 = [0, [9, 0, 0], r2(An)], cc0 = [0, [17, 0, 0], r2(z)], sc0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], vc0 = r2(r7), lc0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], bc0 = r2(tr), pc0 = r2(Z0), mc0 = r2(nr), _c0 = [0, [17, 0, 0], r2(z)], yc0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], hc0 = r2(Ju), dc0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kc0 = [0, [17, 0, 0], r2(z)], wc0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ec0 = r2(sv), Sc0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], gc0 = r2(tr), Fc0 = r2(Z0), Tc0 = r2(nr), Oc0 = [0, [17, 0, 0], r2(z)], Ic0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ac0 = r2(Xr), Nc0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Cc0 = r2(tr), Pc0 = r2(Z0), Dc0 = r2(nr), Lc0 = [0, [17, 0, 0], r2(z)], Rc0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], jc0 = r2("sig_loc"), Gc0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Mc0 = [0, [17, 0, 0], r2(z)], Bc0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], qc0 = [0, [15, 0], r2(N0)], Uc0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Hc0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Xc0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Yc0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Vc0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], zc0 = r2("Flow_ast.Function.Params.this_"), Kc0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Wc0 = r2(tr), Jc0 = r2(Z0), $c0 = r2(nr), Zc0 = [0, [17, 0, 0], r2(z)], Qc0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], rs0 = r2(Dt), es0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ns0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], ts0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], us0 = [0, [17, 0, 0], r2(z)], is0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], fs0 = r2(xd), xs0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], os0 = r2(tr), as0 = r2(Z0), cs0 = r2(nr), ss0 = [0, [17, 0, 0], r2(z)], vs0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ls0 = r2(Xr), bs0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ps0 = r2(tr), ms0 = r2(Z0), _s0 = r2(nr), ys0 = [0, [17, 0, 0], r2(z)], hs0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], ds0 = [0, [15, 0], r2(N0)], ks0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], ws0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Es0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Ss0 = [0, [15, 0], r2(N0)], gs0 = r2(Yr), Fs0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Ts0 = r2("Flow_ast.Function.ThisParam.annot"), Os0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Is0 = [0, [17, 0, 0], r2(z)], As0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ns0 = r2(Xr), Cs0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ps0 = r2(tr), Ds0 = r2(Z0), Ls0 = r2(nr), Rs0 = [0, [17, 0, 0], r2(z)], js0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Gs0 = [0, [15, 0], r2(N0)], Ms0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Bs0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], qs0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Us0 = [0, [15, 0], r2(N0)], Hs0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Xs0 = r2("Flow_ast.Function.Param.argument"), Ys0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Vs0 = [0, [17, 0, 0], r2(z)], zs0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ks0 = r2(_i), Ws0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Js0 = r2(tr), $s0 = r2(Z0), Zs0 = r2(nr), Qs0 = [0, [17, 0, 0], r2(z)], r10 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], e10 = [0, [15, 0], r2(N0)], n10 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], t10 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], u10 = [0, [17, 0, [12, 41, 0]], r2(d0)], i10 = [0, [15, 0], r2(N0)], f10 = r2(Yr), x10 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], o10 = r2("Flow_ast.Function.RestParam.argument"), a10 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], c10 = [0, [17, 0, 0], r2(z)], s10 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], v10 = r2(Xr), l10 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], b10 = r2(tr), p10 = r2(Z0), m10 = r2(nr), _10 = [0, [17, 0, 0], r2(z)], y10 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], h10 = [0, [15, 0], r2(N0)], d10 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], k10 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], w10 = [0, [17, 0, [12, 41, 0]], r2(d0)], E10 = [0, [15, 0], r2(N0)], S10 = r2(Yr), g10 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], F10 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], T10 = r2("Flow_ast.Class.id"), O10 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], I10 = r2(tr), A10 = r2(Z0), N10 = r2(nr), C10 = [0, [17, 0, 0], r2(z)], P10 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], D10 = r2(Wn), L10 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], R10 = [0, [17, 0, 0], r2(z)], j10 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], G10 = r2(sv), M10 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], B10 = r2(tr), q10 = r2(Z0), U10 = r2(nr), H10 = [0, [17, 0, 0], r2(z)], X10 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Y10 = r2(P7), V10 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], z10 = r2(tr), K10 = r2(Z0), W10 = r2(nr), J10 = [0, [17, 0, 0], r2(z)], $10 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Z10 = r2(ws), Q10 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], rv0 = r2(tr), ev0 = r2(Z0), nv0 = r2(nr), tv0 = [0, [17, 0, 0], r2(z)], uv0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], iv0 = r2("class_decorators"), fv0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], xv0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], ov0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], av0 = [0, [17, 0, 0], r2(z)], cv0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], sv0 = r2(Xr), vv0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], lv0 = r2(tr), bv0 = r2(Z0), pv0 = r2(nr), mv0 = [0, [17, 0, 0], r2(z)], _v0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], yv0 = [0, [15, 0], r2(N0)], hv0 = r2(Yr), dv0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], kv0 = r2("Flow_ast.Class.Decorator.expression"), wv0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ev0 = [0, [17, 0, 0], r2(z)], Sv0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], gv0 = r2(Xr), Fv0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Tv0 = r2(tr), Ov0 = r2(Z0), Iv0 = r2(nr), Av0 = [0, [17, 0, 0], r2(z)], Nv0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Cv0 = [0, [15, 0], r2(N0)], Pv0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Dv0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Lv0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Rv0 = [0, [15, 0], r2(N0)], jv0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Class.Body.Method"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Class.Body.Method@ ")], Gv0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Mv0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Class.Body.Property"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Class.Body.Property@ ")], Bv0 = [0, [17, 0, [12, 41, 0]], r2(d0)], qv0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Class.Body.PrivateField"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Class.Body.PrivateField@ ")], Uv0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Hv0 = [0, [15, 0], r2(N0)], Xv0 = r2(Yr), Yv0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Vv0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], zv0 = r2("Flow_ast.Class.Body.body"), Kv0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Wv0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Jv0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], $v0 = [0, [17, 0, 0], r2(z)], Zv0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Qv0 = r2(Xr), r20 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], e20 = r2(tr), n20 = r2(Z0), t20 = r2(nr), u20 = [0, [17, 0, 0], r2(z)], i20 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], f20 = [0, [15, 0], r2(N0)], x20 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], o20 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], a20 = [0, [17, 0, [12, 41, 0]], r2(d0)], c20 = [0, [15, 0], r2(N0)], s20 = r2(Yr), v20 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], l20 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], b20 = r2("Flow_ast.Class.Implements.interfaces"), p20 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], m20 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], _20 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], y20 = [0, [17, 0, 0], r2(z)], h20 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], d20 = r2(Xr), k20 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], w20 = r2(tr), E20 = r2(Z0), S20 = r2(nr), g20 = [0, [17, 0, 0], r2(z)], F20 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], T20 = [0, [15, 0], r2(N0)], O20 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], I20 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], A20 = [0, [17, 0, [12, 41, 0]], r2(d0)], N20 = [0, [15, 0], r2(N0)], C20 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], P20 = r2("Flow_ast.Class.Implements.Interface.id"), D20 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], L20 = [0, [17, 0, 0], r2(z)], R20 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], j20 = r2(Z2), G20 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], M20 = r2(tr), B20 = r2(Z0), q20 = r2(nr), U20 = [0, [17, 0, 0], r2(z)], H20 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], X20 = [0, [15, 0], r2(N0)], Y20 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], V20 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], z20 = [0, [17, 0, [12, 41, 0]], r2(d0)], K20 = [0, [15, 0], r2(N0)], W20 = r2(Yr), J20 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], $20 = r2("Flow_ast.Class.Extends.expr"), Z20 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Q20 = [0, [17, 0, 0], r2(z)], rl0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], el0 = r2(Z2), nl0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], tl0 = r2(tr), ul0 = r2(Z0), il0 = r2(nr), fl0 = [0, [17, 0, 0], r2(z)], xl0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ol0 = r2(Xr), al0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], cl0 = r2(tr), sl0 = r2(Z0), vl0 = r2(nr), ll0 = [0, [17, 0, 0], r2(z)], bl0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], pl0 = [0, [15, 0], r2(N0)], ml0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], _l0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], yl0 = [0, [17, 0, [12, 41, 0]], r2(d0)], hl0 = [0, [15, 0], r2(N0)], dl0 = r2(Yr), kl0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], wl0 = r2("Flow_ast.Class.PrivateField.key"), El0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Sl0 = [0, [17, 0, 0], r2(z)], gl0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Fl0 = r2(Bn), Tl0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ol0 = [0, [17, 0, 0], r2(z)], Il0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Al0 = r2(Qc), Nl0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Cl0 = [0, [17, 0, 0], r2(z)], Pl0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Dl0 = r2(nu), Ll0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Rl0 = [0, [9, 0, 0], r2(An)], jl0 = [0, [17, 0, 0], r2(z)], Gl0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ml0 = r2(cu), Bl0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ql0 = r2(tr), Ul0 = r2(Z0), Hl0 = r2(nr), Xl0 = [0, [17, 0, 0], r2(z)], Yl0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Vl0 = r2(Xr), zl0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Kl0 = r2(tr), Wl0 = r2(Z0), Jl0 = r2(nr), $l0 = [0, [17, 0, 0], r2(z)], Zl0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Ql0 = [0, [15, 0], r2(N0)], rb0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], eb0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], nb0 = [0, [17, 0, [12, 41, 0]], r2(d0)], tb0 = [0, [15, 0], r2(N0)], ub0 = r2("Flow_ast.Class.Property.Uninitialized"), ib0 = r2("Flow_ast.Class.Property.Declared"), fb0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Class.Property.Initialized"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Class.Property.Initialized@ ")], xb0 = [0, [17, 0, [12, 41, 0]], r2(d0)], ob0 = [0, [15, 0], r2(N0)], ab0 = r2(Yr), cb0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], sb0 = r2("Flow_ast.Class.Property.key"), vb0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], lb0 = [0, [17, 0, 0], r2(z)], bb0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], pb0 = r2(Bn), mb0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], _b0 = [0, [17, 0, 0], r2(z)], yb0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], hb0 = r2(Qc), db0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kb0 = [0, [17, 0, 0], r2(z)], wb0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Eb0 = r2(nu), Sb0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], gb0 = [0, [9, 0, 0], r2(An)], Fb0 = [0, [17, 0, 0], r2(z)], Tb0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ob0 = r2(cu), Ib0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ab0 = r2(tr), Nb0 = r2(Z0), Cb0 = r2(nr), Pb0 = [0, [17, 0, 0], r2(z)], Db0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Lb0 = r2(Xr), Rb0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jb0 = r2(tr), Gb0 = r2(Z0), Mb0 = r2(nr), Bb0 = [0, [17, 0, 0], r2(z)], qb0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Ub0 = [0, [15, 0], r2(N0)], Hb0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Xb0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Yb0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Vb0 = [0, [15, 0], r2(N0)], zb0 = r2(Yr), Kb0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Wb0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Jb0 = r2("Flow_ast.Class.Method.kind"), $b0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Zb0 = [0, [17, 0, 0], r2(z)], Qb0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], r40 = r2(ii), e40 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], n40 = [0, [17, 0, 0], r2(z)], t40 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], u40 = r2(Bn), i40 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], f40 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], x40 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], o40 = [0, [17, 0, [12, 41, 0]], r2(d0)], a40 = [0, [17, 0, 0], r2(z)], c40 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], s40 = r2(nu), v40 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], l40 = [0, [9, 0, 0], r2(An)], b40 = [0, [17, 0, 0], r2(z)], p40 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], m40 = r2(j_), _40 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], y40 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], h40 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], d40 = [0, [17, 0, 0], r2(z)], k40 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], w40 = r2(Xr), E40 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], S40 = r2(tr), g40 = r2(Z0), F40 = r2(nr), T40 = [0, [17, 0, 0], r2(z)], O40 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], I40 = [0, [15, 0], r2(N0)], A40 = r2("Flow_ast.Class.Method.Constructor"), N40 = r2("Flow_ast.Class.Method.Method"), C40 = r2("Flow_ast.Class.Method.Get"), P40 = r2("Flow_ast.Class.Method.Set"), D40 = [0, [15, 0], r2(N0)], L40 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], R40 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], j40 = [0, [17, 0, [12, 41, 0]], r2(d0)], G40 = [0, [15, 0], r2(N0)], M40 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], B40 = r2("Flow_ast.Comment.kind"), q40 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], U40 = [0, [17, 0, 0], r2(z)], H40 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], X40 = r2("text"), Y40 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], V40 = [0, [3, 0, 0], r2(Vt)], z40 = [0, [17, 0, 0], r2(z)], K40 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], W40 = r2("on_newline"), J40 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $40 = [0, [9, 0, 0], r2(An)], Z40 = [0, [17, 0, 0], r2(z)], Q40 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], r80 = [0, [15, 0], r2(N0)], e80 = r2("Flow_ast.Comment.Line"), n80 = r2("Flow_ast.Comment.Block"), t80 = [0, [15, 0], r2(N0)], u80 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], i80 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], f80 = [0, [17, 0, [12, 41, 0]], r2(d0)], x80 = [0, [15, 0], r2(N0)], o80 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Object"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Object@ ")], a80 = [0, [17, 0, [12, 41, 0]], r2(d0)], c80 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Array"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Array@ ")], s80 = [0, [17, 0, [12, 41, 0]], r2(d0)], v80 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Identifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Identifier@ ")], l80 = [0, [17, 0, [12, 41, 0]], r2(d0)], b80 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Expression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Expression@ ")], p80 = [0, [17, 0, [12, 41, 0]], r2(d0)], m80 = [0, [15, 0], r2(N0)], _80 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], y80 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], h80 = [0, [17, 0, [12, 41, 0]], r2(d0)], d80 = [0, [15, 0], r2(N0)], k80 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], w80 = r2("Flow_ast.Pattern.Identifier.name"), E80 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], S80 = [0, [17, 0, 0], r2(z)], g80 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], F80 = r2(Qc), T80 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], O80 = [0, [17, 0, 0], r2(z)], I80 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], A80 = r2(qu), N80 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], C80 = [0, [9, 0, 0], r2(An)], P80 = [0, [17, 0, 0], r2(z)], D80 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], L80 = [0, [15, 0], r2(N0)], R80 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], j80 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], G80 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], M80 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], B80 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], q80 = r2("Flow_ast.Pattern.Array.elements"), U80 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], H80 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], X80 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Y80 = [0, [17, 0, 0], r2(z)], V80 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], z80 = r2(Qc), K80 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], W80 = [0, [17, 0, 0], r2(z)], J80 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], $80 = r2(Xr), Z80 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Q80 = r2(tr), r30 = r2(Z0), e30 = r2(nr), n30 = [0, [17, 0, 0], r2(z)], t30 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], u30 = [0, [15, 0], r2(N0)], i30 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Array.Element"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Array.Element@ ")], f30 = [0, [17, 0, [12, 41, 0]], r2(d0)], x30 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Array.RestElement"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Array.RestElement@ ")], o30 = [0, [17, 0, [12, 41, 0]], r2(d0)], a30 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Array.Hole"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Array.Hole@ ")], c30 = [0, [17, 0, [12, 41, 0]], r2(d0)], s30 = [0, [15, 0], r2(N0)], v30 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], l30 = r2("Flow_ast.Pattern.Array.Element.argument"), b30 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], p30 = [0, [17, 0, 0], r2(z)], m30 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], _30 = r2(_i), y30 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], h30 = r2(tr), d30 = r2(Z0), k30 = r2(nr), w30 = [0, [17, 0, 0], r2(z)], E30 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], S30 = [0, [15, 0], r2(N0)], g30 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], F30 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], T30 = [0, [17, 0, [12, 41, 0]], r2(d0)], O30 = [0, [15, 0], r2(N0)], I30 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], A30 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], N30 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], C30 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], P30 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], D30 = r2("Flow_ast.Pattern.Object.properties"), L30 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], R30 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], j30 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], G30 = [0, [17, 0, 0], r2(z)], M30 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], B30 = r2(Qc), q30 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], U30 = [0, [17, 0, 0], r2(z)], H30 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], X30 = r2(Xr), Y30 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], V30 = r2(tr), z30 = r2(Z0), K30 = r2(nr), W30 = [0, [17, 0, 0], r2(z)], J30 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], $30 = [0, [15, 0], r2(N0)], Z30 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Object.Property"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Object.Property@ ")], Q30 = [0, [17, 0, [12, 41, 0]], r2(d0)], r60 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Object.RestElement"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Object.RestElement@ ")], e60 = [0, [17, 0, [12, 41, 0]], r2(d0)], n60 = [0, [15, 0], r2(N0)], t60 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], u60 = r2("Flow_ast.Pattern.Object.Property.key"), i60 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], f60 = [0, [17, 0, 0], r2(z)], x60 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], o60 = r2(mi), a60 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], c60 = [0, [17, 0, 0], r2(z)], s60 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], v60 = r2(_i), l60 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], b60 = r2(tr), p60 = r2(Z0), m60 = r2(nr), _60 = [0, [17, 0, 0], r2(z)], y60 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], h60 = r2(f6), d60 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], k60 = [0, [9, 0, 0], r2(An)], w60 = [0, [17, 0, 0], r2(z)], E60 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], S60 = [0, [15, 0], r2(N0)], g60 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], F60 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], T60 = [0, [17, 0, [12, 41, 0]], r2(d0)], O60 = [0, [15, 0], r2(N0)], I60 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Object.Property.Literal"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Object.Property.Literal@ ")], A60 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], N60 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], C60 = [0, [17, 0, [12, 41, 0]], r2(d0)], P60 = [0, [17, 0, [12, 41, 0]], r2(d0)], D60 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Object.Property.Identifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Object.Property.Identifier@ ")], L60 = [0, [17, 0, [12, 41, 0]], r2(d0)], R60 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Pattern.Object.Property.Computed"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Pattern.Object.Property.Computed@ ")], j60 = [0, [17, 0, [12, 41, 0]], r2(d0)], G60 = [0, [15, 0], r2(N0)], M60 = r2(Yr), B60 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], q60 = r2("Flow_ast.Pattern.RestElement.argument"), U60 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], H60 = [0, [17, 0, 0], r2(z)], X60 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Y60 = r2(Xr), V60 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], z60 = r2(tr), K60 = r2(Z0), W60 = r2(nr), J60 = [0, [17, 0, 0], r2(z)], $60 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Z60 = [0, [15, 0], r2(N0)], Q60 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], rp0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], ep0 = [0, [17, 0, [12, 41, 0]], r2(d0)], np0 = [0, [15, 0], r2(N0)], tp0 = r2(Yr), up0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ip0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], fp0 = r2("Flow_ast.JSX.frag_opening_element"), xp0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], op0 = [0, [17, 0, 0], r2(z)], ap0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], cp0 = r2("frag_closing_element"), sp0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], vp0 = [0, [17, 0, 0], r2(z)], lp0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], bp0 = r2("frag_children"), pp0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], mp0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], _p0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], yp0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], hp0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], dp0 = [0, [17, 0, [12, 41, 0]], r2(d0)], kp0 = [0, [17, 0, 0], r2(z)], wp0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ep0 = r2("frag_comments"), Sp0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], gp0 = r2(tr), Fp0 = r2(Z0), Tp0 = r2(nr), Op0 = [0, [17, 0, 0], r2(z)], Ip0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Ap0 = [0, [15, 0], r2(N0)], Np0 = r2(Yr), Cp0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Pp0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Dp0 = r2("Flow_ast.JSX.opening_element"), Lp0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Rp0 = [0, [17, 0, 0], r2(z)], jp0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Gp0 = r2("closing_element"), Mp0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Bp0 = r2(tr), qp0 = r2(Z0), Up0 = r2(nr), Hp0 = [0, [17, 0, 0], r2(z)], Xp0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Yp0 = r2(Ve), Vp0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], zp0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Kp0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Wp0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Jp0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], $p0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Zp0 = [0, [17, 0, 0], r2(z)], Qp0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], r50 = r2(Xr), e50 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], n50 = r2(tr), t50 = r2(Z0), u50 = r2(nr), i50 = [0, [17, 0, 0], r2(z)], f50 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], x50 = [0, [15, 0], r2(N0)], o50 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Element"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Element@ ")], a50 = [0, [17, 0, [12, 41, 0]], r2(d0)], c50 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Fragment"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Fragment@ ")], s50 = [0, [17, 0, [12, 41, 0]], r2(d0)], v50 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.ExpressionContainer"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.ExpressionContainer@ ")], l50 = [0, [17, 0, [12, 41, 0]], r2(d0)], b50 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.SpreadChild"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.SpreadChild@ ")], p50 = [0, [17, 0, [12, 41, 0]], r2(d0)], m50 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Text"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Text@ ")], _50 = [0, [17, 0, [12, 41, 0]], r2(d0)], y50 = [0, [15, 0], r2(N0)], h50 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], d50 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], k50 = [0, [17, 0, [12, 41, 0]], r2(d0)], w50 = [0, [15, 0], r2(N0)], E50 = r2(Yr), S50 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], g50 = r2("Flow_ast.JSX.SpreadChild.expression"), F50 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], T50 = [0, [17, 0, 0], r2(z)], O50 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], I50 = r2(Xr), A50 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], N50 = r2(tr), C50 = r2(Z0), P50 = r2(nr), D50 = [0, [17, 0, 0], r2(z)], L50 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], R50 = [0, [15, 0], r2(N0)], j50 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], G50 = r2("Flow_ast.JSX.Closing.name"), M50 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], B50 = [0, [17, 0, 0], r2(z)], q50 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], U50 = [0, [15, 0], r2(N0)], H50 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], X50 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Y50 = [0, [17, 0, [12, 41, 0]], r2(d0)], V50 = [0, [15, 0], r2(N0)], z50 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], K50 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], W50 = r2("Flow_ast.JSX.Opening.name"), J50 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $50 = [0, [17, 0, 0], r2(z)], Z50 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Q50 = r2("self_closing"), rm0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], em0 = [0, [9, 0, 0], r2(An)], nm0 = [0, [17, 0, 0], r2(z)], tm0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], um0 = r2(mY), im0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], fm0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], xm0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], om0 = [0, [17, 0, 0], r2(z)], am0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], cm0 = [0, [15, 0], r2(N0)], sm0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Opening.Attribute"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Opening.Attribute@ ")], vm0 = [0, [17, 0, [12, 41, 0]], r2(d0)], lm0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Opening.SpreadAttribute"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Opening.SpreadAttribute@ ")], bm0 = [0, [17, 0, [12, 41, 0]], r2(d0)], pm0 = [0, [15, 0], r2(N0)], mm0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], _m0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], ym0 = [0, [17, 0, [12, 41, 0]], r2(d0)], hm0 = [0, [15, 0], r2(N0)], dm0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Identifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Identifier@ ")], km0 = [0, [17, 0, [12, 41, 0]], r2(d0)], wm0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.NamespacedName"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.NamespacedName@ ")], Em0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Sm0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.MemberExpression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.MemberExpression@ ")], gm0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Fm0 = [0, [15, 0], r2(N0)], Tm0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Om0 = r2("Flow_ast.JSX.MemberExpression._object"), Im0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Am0 = [0, [17, 0, 0], r2(z)], Nm0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Cm0 = r2(Iv), Pm0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Dm0 = [0, [17, 0, 0], r2(z)], Lm0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Rm0 = [0, [15, 0], r2(N0)], jm0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.MemberExpression.Identifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.MemberExpression.Identifier@ ")], Gm0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Mm0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.MemberExpression.MemberExpression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.MemberExpression.MemberExpression@ ")], Bm0 = [0, [17, 0, [12, 41, 0]], r2(d0)], qm0 = [0, [15, 0], r2(N0)], Um0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Hm0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Xm0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Ym0 = [0, [15, 0], r2(N0)], Vm0 = r2(Yr), zm0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Km0 = r2("Flow_ast.JSX.SpreadAttribute.argument"), Wm0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Jm0 = [0, [17, 0, 0], r2(z)], $m0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Zm0 = r2(Xr), Qm0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], r90 = r2(tr), e90 = r2(Z0), n90 = r2(nr), t90 = [0, [17, 0, 0], r2(z)], u90 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], i90 = [0, [15, 0], r2(N0)], f90 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], x90 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], o90 = [0, [17, 0, [12, 41, 0]], r2(d0)], a90 = [0, [15, 0], r2(N0)], c90 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], s90 = r2("Flow_ast.JSX.Attribute.name"), v90 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], l90 = [0, [17, 0, 0], r2(z)], b90 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], p90 = r2(Bn), m90 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], _90 = r2(tr), y90 = r2(Z0), h90 = r2(nr), d90 = [0, [17, 0, 0], r2(z)], k90 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], w90 = [0, [15, 0], r2(N0)], E90 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Attribute.Literal ("), [17, [0, r2(Ce), 0, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Attribute.Literal (@,")], S90 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], g90 = [0, [17, [0, r2(Ce), 0, 0], [11, r2(EX), [17, 0, 0]]], r2(RU)], F90 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Attribute.ExpressionContainer ("), [17, [0, r2(Ce), 0, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Attribute.ExpressionContainer (@,")], T90 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], O90 = [0, [17, [0, r2(Ce), 0, 0], [11, r2(EX), [17, 0, 0]]], r2(RU)], I90 = [0, [15, 0], r2(N0)], A90 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Attribute.Identifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Attribute.Identifier@ ")], N90 = [0, [17, 0, [12, 41, 0]], r2(d0)], C90 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.Attribute.NamespacedName"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.Attribute.NamespacedName@ ")], P90 = [0, [17, 0, [12, 41, 0]], r2(d0)], D90 = [0, [15, 0], r2(N0)], L90 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], R90 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], j90 = [0, [17, 0, [12, 41, 0]], r2(d0)], G90 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], M90 = r2("Flow_ast.JSX.Text.value"), B90 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], q90 = [0, [3, 0, 0], r2(Vt)], U90 = [0, [17, 0, 0], r2(z)], H90 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], X90 = r2(c7), Y90 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], V90 = [0, [3, 0, 0], r2(Vt)], z90 = [0, [17, 0, 0], r2(z)], K90 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], W90 = [0, [15, 0], r2(N0)], J90 = [0, [15, 0], r2(N0)], $90 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.JSX.ExpressionContainer.Expression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.JSX.ExpressionContainer.Expression@ ")], Z90 = [0, [17, 0, [12, 41, 0]], r2(d0)], Q90 = r2("Flow_ast.JSX.ExpressionContainer.EmptyExpression"), r_0 = [0, [15, 0], r2(N0)], e_0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], n_0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], t_0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], u_0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], i_0 = r2("Flow_ast.JSX.ExpressionContainer.expression"), f_0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], x_0 = [0, [17, 0, 0], r2(z)], o_0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], a_0 = r2(Xr), c_0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], s_0 = r2(tr), v_0 = r2(Z0), l_0 = r2(nr), b_0 = [0, [17, 0, 0], r2(z)], p_0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], m_0 = [0, [15, 0], r2(N0)], __0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], y_0 = r2("Flow_ast.JSX.NamespacedName.namespace"), h_0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], d_0 = [0, [17, 0, 0], r2(z)], k_0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], w_0 = r2(ui), E_0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], S_0 = [0, [17, 0, 0], r2(z)], g_0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], F_0 = [0, [15, 0], r2(N0)], T_0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], O_0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], I_0 = [0, [17, 0, [12, 41, 0]], r2(d0)], A_0 = [0, [15, 0], r2(N0)], N_0 = r2(Yr), C_0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], P_0 = r2("Flow_ast.JSX.Identifier.name"), D_0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], L_0 = [0, [3, 0, 0], r2(Vt)], R_0 = [0, [17, 0, 0], r2(z)], j_0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], G_0 = r2(Xr), M_0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], B_0 = r2(tr), q_0 = r2(Z0), U_0 = r2(nr), H_0 = [0, [17, 0, 0], r2(z)], X_0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Y_0 = [0, [15, 0], r2(N0)], V_0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], z_0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], K_0 = [0, [17, 0, [12, 41, 0]], r2(d0)], W_0 = [0, [15, 0], r2(N0)], J_0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Array"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Array@ ")], $_0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Z_0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.ArrowFunction"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.ArrowFunction@ ")], Q_0 = [0, [17, 0, [12, 41, 0]], r2(d0)], ry0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Assignment"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Assignment@ ")], ey0 = [0, [17, 0, [12, 41, 0]], r2(d0)], ny0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Binary"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Binary@ ")], ty0 = [0, [17, 0, [12, 41, 0]], r2(d0)], uy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Call"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Call@ ")], iy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], fy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Class"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Class@ ")], xy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], oy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Comprehension"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Comprehension@ ")], ay0 = [0, [17, 0, [12, 41, 0]], r2(d0)], cy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Conditional"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Conditional@ ")], sy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], vy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Function"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Function@ ")], ly0 = [0, [17, 0, [12, 41, 0]], r2(d0)], by0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Generator"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Generator@ ")], py0 = [0, [17, 0, [12, 41, 0]], r2(d0)], my0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Identifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Identifier@ ")], _y0 = [0, [17, 0, [12, 41, 0]], r2(d0)], yy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Import"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Import@ ")], hy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], dy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.JSXElement"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.JSXElement@ ")], ky0 = [0, [17, 0, [12, 41, 0]], r2(d0)], wy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.JSXFragment"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.JSXFragment@ ")], Ey0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Sy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Literal"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Literal@ ")], gy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Fy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Logical"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Logical@ ")], Ty0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Oy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Member"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Member@ ")], Iy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Ay0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.MetaProperty"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.MetaProperty@ ")], Ny0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Cy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.New"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.New@ ")], Py0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Dy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Object@ ")], Ly0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Ry0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.OptionalCall"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.OptionalCall@ ")], jy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Gy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.OptionalMember"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.OptionalMember@ ")], My0 = [0, [17, 0, [12, 41, 0]], r2(d0)], By0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Sequence"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Sequence@ ")], qy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Uy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Super"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Super@ ")], Hy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Xy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.TaggedTemplate"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.TaggedTemplate@ ")], Yy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Vy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.TemplateLiteral"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.TemplateLiteral@ ")], zy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Ky0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.This"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.This@ ")], Wy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Jy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.TypeCast"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.TypeCast@ ")], $y0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Zy0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Unary"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Unary@ ")], Qy0 = [0, [17, 0, [12, 41, 0]], r2(d0)], rh0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Update"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Update@ ")], eh0 = [0, [17, 0, [12, 41, 0]], r2(d0)], nh0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Yield"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Yield@ ")], th0 = [0, [17, 0, [12, 41, 0]], r2(d0)], uh0 = [0, [15, 0], r2(N0)], ih0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], fh0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], xh0 = [0, [17, 0, [12, 41, 0]], r2(d0)], oh0 = [0, [15, 0], r2(N0)], ah0 = r2(Yr), ch0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], sh0 = r2("Flow_ast.Expression.Import.argument"), vh0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], lh0 = [0, [17, 0, 0], r2(z)], bh0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ph0 = r2(Xr), mh0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], _h0 = r2(tr), yh0 = r2(Z0), hh0 = r2(nr), dh0 = [0, [17, 0, 0], r2(z)], kh0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], wh0 = [0, [15, 0], r2(N0)], Eh0 = r2(Yr), Sh0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], gh0 = r2("Flow_ast.Expression.Super.comments"), Fh0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Th0 = r2(tr), Oh0 = r2(Z0), Ih0 = r2(nr), Ah0 = [0, [17, 0, 0], r2(z)], Nh0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Ch0 = [0, [15, 0], r2(N0)], Ph0 = r2(Yr), Dh0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Lh0 = r2("Flow_ast.Expression.This.comments"), Rh0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jh0 = r2(tr), Gh0 = r2(Z0), Mh0 = r2(nr), Bh0 = [0, [17, 0, 0], r2(z)], qh0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Uh0 = [0, [15, 0], r2(N0)], Hh0 = r2(Yr), Xh0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Yh0 = r2("Flow_ast.Expression.MetaProperty.meta"), Vh0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], zh0 = [0, [17, 0, 0], r2(z)], Kh0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Wh0 = r2(Iv), Jh0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $h0 = [0, [17, 0, 0], r2(z)], Zh0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Qh0 = r2(Xr), rd0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ed0 = r2(tr), nd0 = r2(Z0), td0 = r2(nr), ud0 = [0, [17, 0, 0], r2(z)], id0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], fd0 = [0, [15, 0], r2(N0)], xd0 = r2(Yr), od0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], ad0 = r2("Flow_ast.Expression.TypeCast.expression"), cd0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], sd0 = [0, [17, 0, 0], r2(z)], vd0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ld0 = r2(Qc), bd0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], pd0 = [0, [17, 0, 0], r2(z)], md0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], _d0 = r2(Xr), yd0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], hd0 = r2(tr), dd0 = r2(Z0), kd0 = r2(nr), wd0 = [0, [17, 0, 0], r2(z)], Ed0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Sd0 = [0, [15, 0], r2(N0)], gd0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Fd0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Td0 = r2("Flow_ast.Expression.Generator.blocks"), Od0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Id0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Ad0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Nd0 = [0, [17, 0, 0], r2(z)], Cd0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Pd0 = r2(T4), Dd0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ld0 = r2(tr), Rd0 = r2(Z0), jd0 = r2(nr), Gd0 = [0, [17, 0, 0], r2(z)], Md0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Bd0 = [0, [15, 0], r2(N0)], qd0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ud0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Hd0 = r2("Flow_ast.Expression.Comprehension.blocks"), Xd0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Yd0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Vd0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], zd0 = [0, [17, 0, 0], r2(z)], Kd0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Wd0 = r2(T4), Jd0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $d0 = r2(tr), Zd0 = r2(Z0), Qd0 = r2(nr), rk0 = [0, [17, 0, 0], r2(z)], ek0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], nk0 = [0, [15, 0], r2(N0)], tk0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], uk0 = r2("Flow_ast.Expression.Comprehension.Block.left"), ik0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], fk0 = [0, [17, 0, 0], r2(z)], xk0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ok0 = r2(Cu), ak0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ck0 = [0, [17, 0, 0], r2(z)], sk0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], vk0 = r2(R8), lk0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], bk0 = [0, [9, 0, 0], r2(An)], pk0 = [0, [17, 0, 0], r2(z)], mk0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], _k0 = [0, [15, 0], r2(N0)], yk0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], hk0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], dk0 = [0, [17, 0, [12, 41, 0]], r2(d0)], kk0 = [0, [15, 0], r2(N0)], wk0 = r2(Yr), Ek0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Sk0 = r2("Flow_ast.Expression.Yield.argument"), gk0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Fk0 = r2(tr), Tk0 = r2(Z0), Ok0 = r2(nr), Ik0 = [0, [17, 0, 0], r2(z)], Ak0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Nk0 = r2(Xr), Ck0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Pk0 = r2(tr), Dk0 = r2(Z0), Lk0 = r2(nr), Rk0 = [0, [17, 0, 0], r2(z)], jk0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Gk0 = r2(lY), Mk0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Bk0 = [0, [9, 0, 0], r2(An)], qk0 = [0, [17, 0, 0], r2(z)], Uk0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Hk0 = r2("result_out"), Xk0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Yk0 = [0, [17, 0, 0], r2(z)], Vk0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], zk0 = [0, [15, 0], r2(N0)], Kk0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Wk0 = r2("Flow_ast.Expression.OptionalMember.member"), Jk0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $k0 = [0, [17, 0, 0], r2(z)], Zk0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Qk0 = r2(lU), rw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ew0 = [0, [17, 0, 0], r2(z)], nw0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], tw0 = r2(qu), uw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], iw0 = [0, [9, 0, 0], r2(An)], fw0 = [0, [17, 0, 0], r2(z)], xw0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], ow0 = [0, [15, 0], r2(N0)], aw0 = r2(Yr), cw0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], sw0 = r2("Flow_ast.Expression.Member._object"), vw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], lw0 = [0, [17, 0, 0], r2(z)], bw0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], pw0 = r2(Iv), mw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], _w0 = [0, [17, 0, 0], r2(z)], yw0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], hw0 = r2(Xr), dw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kw0 = r2(tr), ww0 = r2(Z0), Ew0 = r2(nr), Sw0 = [0, [17, 0, 0], r2(z)], gw0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Fw0 = [0, [15, 0], r2(N0)], Tw0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Member.PropertyIdentifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Member.PropertyIdentifier@ ")], Ow0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Iw0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Member.PropertyPrivateName"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Member.PropertyPrivateName@ ")], Aw0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Nw0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Member.PropertyExpression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Member.PropertyExpression@ ")], Cw0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Pw0 = [0, [15, 0], r2(N0)], Dw0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Lw0 = r2("Flow_ast.Expression.OptionalCall.call"), Rw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jw0 = [0, [17, 0, 0], r2(z)], Gw0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Mw0 = r2(lU), Bw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], qw0 = [0, [17, 0, 0], r2(z)], Uw0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Hw0 = r2(qu), Xw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Yw0 = [0, [9, 0, 0], r2(An)], Vw0 = [0, [17, 0, 0], r2(z)], zw0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Kw0 = [0, [15, 0], r2(N0)], Ww0 = r2(Yr), Jw0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], $w0 = r2("Flow_ast.Expression.Call.callee"), Zw0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Qw0 = [0, [17, 0, 0], r2(z)], rE0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], eE0 = r2(Z2), nE0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], tE0 = r2(tr), uE0 = r2(Z0), iE0 = r2(nr), fE0 = [0, [17, 0, 0], r2(z)], xE0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], oE0 = r2(C2), aE0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], cE0 = [0, [17, 0, 0], r2(z)], sE0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], vE0 = r2(Xr), lE0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], bE0 = r2(tr), pE0 = r2(Z0), mE0 = r2(nr), _E0 = [0, [17, 0, 0], r2(z)], yE0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], hE0 = [0, [15, 0], r2(N0)], dE0 = r2(Yr), kE0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], wE0 = r2("Flow_ast.Expression.New.callee"), EE0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], SE0 = [0, [17, 0, 0], r2(z)], gE0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], FE0 = r2(Z2), TE0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], OE0 = r2(tr), IE0 = r2(Z0), AE0 = r2(nr), NE0 = [0, [17, 0, 0], r2(z)], CE0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], PE0 = r2(C2), DE0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], LE0 = r2(tr), RE0 = r2(Z0), jE0 = r2(nr), GE0 = [0, [17, 0, 0], r2(z)], ME0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], BE0 = r2(Xr), qE0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], UE0 = r2(tr), HE0 = r2(Z0), XE0 = r2(nr), YE0 = [0, [17, 0, 0], r2(z)], VE0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], zE0 = [0, [15, 0], r2(N0)], KE0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], WE0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], JE0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], $E0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ZE0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], QE0 = r2("Flow_ast.Expression.ArgList.arguments"), rS0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], eS0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], nS0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], tS0 = [0, [17, 0, 0], r2(z)], uS0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], iS0 = r2(Xr), fS0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], xS0 = r2(tr), oS0 = r2(Z0), aS0 = r2(nr), cS0 = [0, [17, 0, 0], r2(z)], sS0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], vS0 = [0, [15, 0], r2(N0)], lS0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], bS0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], pS0 = [0, [17, 0, [12, 41, 0]], r2(d0)], mS0 = [0, [15, 0], r2(N0)], _S0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Expression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Expression@ ")], yS0 = [0, [17, 0, [12, 41, 0]], r2(d0)], hS0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Spread"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Spread@ ")], dS0 = [0, [17, 0, [12, 41, 0]], r2(d0)], kS0 = [0, [15, 0], r2(N0)], wS0 = r2(Yr), ES0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], SS0 = r2("Flow_ast.Expression.Conditional.test"), gS0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], FS0 = [0, [17, 0, 0], r2(z)], TS0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], OS0 = r2(kv), IS0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], AS0 = [0, [17, 0, 0], r2(z)], NS0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], CS0 = r2(m3), PS0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], DS0 = [0, [17, 0, 0], r2(z)], LS0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], RS0 = r2(Xr), jS0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], GS0 = r2(tr), MS0 = r2(Z0), BS0 = r2(nr), qS0 = [0, [17, 0, 0], r2(z)], US0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], HS0 = [0, [15, 0], r2(N0)], XS0 = r2(Yr), YS0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], VS0 = r2("Flow_ast.Expression.Logical.operator"), zS0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], KS0 = [0, [17, 0, 0], r2(z)], WS0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], JS0 = r2(bi), $S0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ZS0 = [0, [17, 0, 0], r2(z)], QS0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], rg0 = r2(Cu), eg0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ng0 = [0, [17, 0, 0], r2(z)], tg0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ug0 = r2(Xr), ig0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], fg0 = r2(tr), xg0 = r2(Z0), og0 = r2(nr), ag0 = [0, [17, 0, 0], r2(z)], cg0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], sg0 = [0, [15, 0], r2(N0)], vg0 = r2("Flow_ast.Expression.Logical.Or"), lg0 = r2("Flow_ast.Expression.Logical.And"), bg0 = r2("Flow_ast.Expression.Logical.NullishCoalesce"), pg0 = [0, [15, 0], r2(N0)], mg0 = r2(Yr), _g0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], yg0 = r2("Flow_ast.Expression.Update.operator"), hg0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], dg0 = [0, [17, 0, 0], r2(z)], kg0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], wg0 = r2(l7), Eg0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Sg0 = [0, [17, 0, 0], r2(z)], gg0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Fg0 = r2(qE), Tg0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Og0 = [0, [9, 0, 0], r2(An)], Ig0 = [0, [17, 0, 0], r2(z)], Ag0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ng0 = r2(Xr), Cg0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Pg0 = r2(tr), Dg0 = r2(Z0), Lg0 = r2(nr), Rg0 = [0, [17, 0, 0], r2(z)], jg0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Gg0 = [0, [15, 0], r2(N0)], Mg0 = r2("Flow_ast.Expression.Update.Decrement"), Bg0 = r2("Flow_ast.Expression.Update.Increment"), qg0 = [0, [15, 0], r2(N0)], Ug0 = r2(Yr), Hg0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Xg0 = r2("Flow_ast.Expression.Assignment.operator"), Yg0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Vg0 = r2(tr), zg0 = r2(Z0), Kg0 = r2(nr), Wg0 = [0, [17, 0, 0], r2(z)], Jg0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], $g0 = r2(bi), Zg0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Qg0 = [0, [17, 0, 0], r2(z)], rF0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], eF0 = r2(Cu), nF0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], tF0 = [0, [17, 0, 0], r2(z)], uF0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], iF0 = r2(Xr), fF0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], xF0 = r2(tr), oF0 = r2(Z0), aF0 = r2(nr), cF0 = [0, [17, 0, 0], r2(z)], sF0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], vF0 = [0, [15, 0], r2(N0)], lF0 = r2("Flow_ast.Expression.Assignment.PlusAssign"), bF0 = r2("Flow_ast.Expression.Assignment.MinusAssign"), pF0 = r2("Flow_ast.Expression.Assignment.MultAssign"), mF0 = r2("Flow_ast.Expression.Assignment.ExpAssign"), _F0 = r2("Flow_ast.Expression.Assignment.DivAssign"), yF0 = r2("Flow_ast.Expression.Assignment.ModAssign"), hF0 = r2("Flow_ast.Expression.Assignment.LShiftAssign"), dF0 = r2("Flow_ast.Expression.Assignment.RShiftAssign"), kF0 = r2("Flow_ast.Expression.Assignment.RShift3Assign"), wF0 = r2("Flow_ast.Expression.Assignment.BitOrAssign"), EF0 = r2("Flow_ast.Expression.Assignment.BitXorAssign"), SF0 = r2("Flow_ast.Expression.Assignment.BitAndAssign"), gF0 = r2("Flow_ast.Expression.Assignment.NullishAssign"), FF0 = r2("Flow_ast.Expression.Assignment.AndAssign"), TF0 = r2("Flow_ast.Expression.Assignment.OrAssign"), OF0 = [0, [15, 0], r2(N0)], IF0 = r2(Yr), AF0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], NF0 = r2("Flow_ast.Expression.Binary.operator"), CF0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], PF0 = [0, [17, 0, 0], r2(z)], DF0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], LF0 = r2(bi), RF0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jF0 = [0, [17, 0, 0], r2(z)], GF0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], MF0 = r2(Cu), BF0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], qF0 = [0, [17, 0, 0], r2(z)], UF0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], HF0 = r2(Xr), XF0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], YF0 = r2(tr), VF0 = r2(Z0), zF0 = r2(nr), KF0 = [0, [17, 0, 0], r2(z)], WF0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], JF0 = [0, [15, 0], r2(N0)], $F0 = r2("Flow_ast.Expression.Binary.Equal"), ZF0 = r2("Flow_ast.Expression.Binary.NotEqual"), QF0 = r2("Flow_ast.Expression.Binary.StrictEqual"), rT0 = r2("Flow_ast.Expression.Binary.StrictNotEqual"), eT0 = r2("Flow_ast.Expression.Binary.LessThan"), nT0 = r2("Flow_ast.Expression.Binary.LessThanEqual"), tT0 = r2("Flow_ast.Expression.Binary.GreaterThan"), uT0 = r2("Flow_ast.Expression.Binary.GreaterThanEqual"), iT0 = r2("Flow_ast.Expression.Binary.LShift"), fT0 = r2("Flow_ast.Expression.Binary.RShift"), xT0 = r2("Flow_ast.Expression.Binary.RShift3"), oT0 = r2("Flow_ast.Expression.Binary.Plus"), aT0 = r2("Flow_ast.Expression.Binary.Minus"), cT0 = r2("Flow_ast.Expression.Binary.Mult"), sT0 = r2("Flow_ast.Expression.Binary.Exp"), vT0 = r2("Flow_ast.Expression.Binary.Div"), lT0 = r2("Flow_ast.Expression.Binary.Mod"), bT0 = r2("Flow_ast.Expression.Binary.BitOr"), pT0 = r2("Flow_ast.Expression.Binary.Xor"), mT0 = r2("Flow_ast.Expression.Binary.BitAnd"), _T0 = r2("Flow_ast.Expression.Binary.In"), yT0 = r2("Flow_ast.Expression.Binary.Instanceof"), hT0 = [0, [15, 0], r2(N0)], dT0 = r2(Yr), kT0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], wT0 = r2("Flow_ast.Expression.Unary.operator"), ET0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ST0 = [0, [17, 0, 0], r2(z)], gT0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], FT0 = r2(l7), TT0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], OT0 = [0, [17, 0, 0], r2(z)], IT0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], AT0 = r2(Xr), NT0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], CT0 = r2(tr), PT0 = r2(Z0), DT0 = r2(nr), LT0 = [0, [17, 0, 0], r2(z)], RT0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], jT0 = [0, [15, 0], r2(N0)], GT0 = r2("Flow_ast.Expression.Unary.Minus"), MT0 = r2("Flow_ast.Expression.Unary.Plus"), BT0 = r2("Flow_ast.Expression.Unary.Not"), qT0 = r2("Flow_ast.Expression.Unary.BitNot"), UT0 = r2("Flow_ast.Expression.Unary.Typeof"), HT0 = r2("Flow_ast.Expression.Unary.Void"), XT0 = r2("Flow_ast.Expression.Unary.Delete"), YT0 = r2("Flow_ast.Expression.Unary.Await"), VT0 = [0, [15, 0], r2(N0)], zT0 = r2(Yr), KT0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], WT0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], JT0 = r2("Flow_ast.Expression.Sequence.expressions"), $T0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ZT0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], QT0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], rO0 = [0, [17, 0, 0], r2(z)], eO0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], nO0 = r2(Xr), tO0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], uO0 = r2(tr), iO0 = r2(Z0), fO0 = r2(nr), xO0 = [0, [17, 0, 0], r2(z)], oO0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], aO0 = [0, [15, 0], r2(N0)], cO0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], sO0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], vO0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], lO0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], bO0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], pO0 = r2("Flow_ast.Expression.Object.properties"), mO0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], _O0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], yO0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], hO0 = [0, [17, 0, 0], r2(z)], dO0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], kO0 = r2(Xr), wO0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], EO0 = r2(tr), SO0 = r2(Z0), gO0 = r2(nr), FO0 = [0, [17, 0, 0], r2(z)], TO0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], OO0 = [0, [15, 0], r2(N0)], IO0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Object.Property@ ")], AO0 = [0, [17, 0, [12, 41, 0]], r2(d0)], NO0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.SpreadProperty"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Object.SpreadProperty@ ")], CO0 = [0, [17, 0, [12, 41, 0]], r2(d0)], PO0 = [0, [15, 0], r2(N0)], DO0 = r2(Yr), LO0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], RO0 = r2("Flow_ast.Expression.Object.SpreadProperty.argument"), jO0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], GO0 = [0, [17, 0, 0], r2(z)], MO0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], BO0 = r2(Xr), qO0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], UO0 = r2(tr), HO0 = r2(Z0), XO0 = r2(nr), YO0 = [0, [17, 0, 0], r2(z)], VO0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], zO0 = [0, [15, 0], r2(N0)], KO0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], WO0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], JO0 = [0, [17, 0, [12, 41, 0]], r2(d0)], $O0 = [0, [15, 0], r2(N0)], ZO0 = r2(Yr), QO0 = r2(Yr), rI0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property.Init {"), [17, [0, r2(Ce), 0, 0], 0]]], r2("@[<2>Flow_ast.Expression.Object.Property.Init {@,")], eI0 = r2(ii), nI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], tI0 = [0, [17, 0, 0], r2(z)], uI0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], iI0 = r2(Bn), fI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], xI0 = [0, [17, 0, 0], r2(z)], oI0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], aI0 = r2(f6), cI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], sI0 = [0, [9, 0, 0], r2(An)], vI0 = [0, [17, 0, 0], r2(z)], lI0 = [0, [17, 0, [12, br, 0]], r2(Y6)], bI0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property.Method {"), [17, [0, r2(Ce), 0, 0], 0]]], r2("@[<2>Flow_ast.Expression.Object.Property.Method {@,")], pI0 = r2(ii), mI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], _I0 = [0, [17, 0, 0], r2(z)], yI0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], hI0 = r2(Bn), dI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kI0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], wI0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], EI0 = [0, [17, 0, [12, 41, 0]], r2(d0)], SI0 = [0, [17, 0, 0], r2(z)], gI0 = [0, [17, 0, [12, br, 0]], r2(Y6)], FI0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property.Get {"), [17, [0, r2(Ce), 0, 0], 0]]], r2("@[<2>Flow_ast.Expression.Object.Property.Get {@,")], TI0 = r2(ii), OI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], II0 = [0, [17, 0, 0], r2(z)], AI0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], NI0 = r2(Bn), CI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], PI0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], DI0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], LI0 = [0, [17, 0, [12, 41, 0]], r2(d0)], RI0 = [0, [17, 0, 0], r2(z)], jI0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], GI0 = r2(Xr), MI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], BI0 = r2(tr), qI0 = r2(Z0), UI0 = r2(nr), HI0 = [0, [17, 0, 0], r2(z)], XI0 = [0, [17, 0, [12, br, 0]], r2(Y6)], YI0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property.Set {"), [17, [0, r2(Ce), 0, 0], 0]]], r2("@[<2>Flow_ast.Expression.Object.Property.Set {@,")], VI0 = r2(ii), zI0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], KI0 = [0, [17, 0, 0], r2(z)], WI0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], JI0 = r2(Bn), $I0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ZI0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], QI0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], rA0 = [0, [17, 0, [12, 41, 0]], r2(d0)], eA0 = [0, [17, 0, 0], r2(z)], nA0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], tA0 = r2(Xr), uA0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], iA0 = r2(tr), fA0 = r2(Z0), xA0 = r2(nr), oA0 = [0, [17, 0, 0], r2(z)], aA0 = [0, [17, 0, [12, br, 0]], r2(Y6)], cA0 = [0, [15, 0], r2(N0)], sA0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], vA0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], lA0 = [0, [17, 0, [12, 41, 0]], r2(d0)], bA0 = [0, [15, 0], r2(N0)], pA0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property.Literal"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Object.Property.Literal@ ")], mA0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], _A0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], yA0 = [0, [17, 0, [12, 41, 0]], r2(d0)], hA0 = [0, [17, 0, [12, 41, 0]], r2(d0)], dA0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property.Identifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Object.Property.Identifier@ ")], kA0 = [0, [17, 0, [12, 41, 0]], r2(d0)], wA0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property.PrivateName"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Object.Property.PrivateName@ ")], EA0 = [0, [17, 0, [12, 41, 0]], r2(d0)], SA0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Object.Property.Computed"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Object.Property.Computed@ ")], gA0 = [0, [17, 0, [12, 41, 0]], r2(d0)], FA0 = [0, [15, 0], r2(N0)], TA0 = r2(Yr), OA0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], IA0 = r2("Flow_ast.Expression.TaggedTemplate.tag"), AA0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], NA0 = [0, [17, 0, 0], r2(z)], CA0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], PA0 = r2(EY), DA0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], LA0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], RA0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], jA0 = [0, [17, 0, [12, 41, 0]], r2(d0)], GA0 = [0, [17, 0, 0], r2(z)], MA0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], BA0 = r2(Xr), qA0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], UA0 = r2(tr), HA0 = r2(Z0), XA0 = r2(nr), YA0 = [0, [17, 0, 0], r2(z)], VA0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], zA0 = [0, [15, 0], r2(N0)], KA0 = r2(Yr), WA0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], JA0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], $A0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], ZA0 = r2("Flow_ast.Expression.TemplateLiteral.quasis"), QA0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], rN0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], eN0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], nN0 = [0, [17, 0, 0], r2(z)], tN0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], uN0 = r2(Mg), iN0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], fN0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], xN0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], oN0 = [0, [17, 0, 0], r2(z)], aN0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], cN0 = r2(Xr), sN0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], vN0 = r2(tr), lN0 = r2(Z0), bN0 = r2(nr), pN0 = [0, [17, 0, 0], r2(z)], mN0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], _N0 = [0, [15, 0], r2(N0)], yN0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], hN0 = r2("Flow_ast.Expression.TemplateLiteral.Element.value"), dN0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kN0 = [0, [17, 0, 0], r2(z)], wN0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], EN0 = r2(aU), SN0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], gN0 = [0, [9, 0, 0], r2(An)], FN0 = [0, [17, 0, 0], r2(z)], TN0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], ON0 = [0, [15, 0], r2(N0)], IN0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], AN0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], NN0 = [0, [17, 0, [12, 41, 0]], r2(d0)], CN0 = [0, [15, 0], r2(N0)], PN0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], DN0 = r2("Flow_ast.Expression.TemplateLiteral.Element.raw"), LN0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], RN0 = [0, [3, 0, 0], r2(Vt)], jN0 = [0, [17, 0, 0], r2(z)], GN0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], MN0 = r2(PY), BN0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], qN0 = [0, [3, 0, 0], r2(Vt)], UN0 = [0, [17, 0, 0], r2(z)], HN0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], XN0 = [0, [15, 0], r2(N0)], YN0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], VN0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], zN0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], KN0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], WN0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], JN0 = r2("Flow_ast.Expression.Array.elements"), $N0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ZN0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], QN0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], rC0 = [0, [17, 0, 0], r2(z)], eC0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], nC0 = r2(Xr), tC0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], uC0 = r2(tr), iC0 = r2(Z0), fC0 = r2(nr), xC0 = [0, [17, 0, 0], r2(z)], oC0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], aC0 = [0, [15, 0], r2(N0)], cC0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Array.Expression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Array.Expression@ ")], sC0 = [0, [17, 0, [12, 41, 0]], r2(d0)], vC0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Array.Spread"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Array.Spread@ ")], lC0 = [0, [17, 0, [12, 41, 0]], r2(d0)], bC0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.Array.Hole"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.Array.Hole@ ")], pC0 = [0, [17, 0, [12, 41, 0]], r2(d0)], mC0 = [0, [15, 0], r2(N0)], _C0 = r2(Yr), yC0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], hC0 = r2("Flow_ast.Expression.SpreadElement.argument"), dC0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kC0 = [0, [17, 0, 0], r2(z)], wC0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], EC0 = r2(Xr), SC0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], gC0 = r2(tr), FC0 = r2(Z0), TC0 = r2(nr), OC0 = [0, [17, 0, 0], r2(z)], IC0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], AC0 = [0, [15, 0], r2(N0)], NC0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], CC0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], PC0 = [0, [17, 0, [12, 41, 0]], r2(d0)], DC0 = [0, [15, 0], r2(N0)], LC0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], RC0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], jC0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], GC0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], MC0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], BC0 = r2("Flow_ast.Expression.CallTypeArgs.arguments"), qC0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], UC0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], HC0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], XC0 = [0, [17, 0, 0], r2(z)], YC0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], VC0 = r2(Xr), zC0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], KC0 = r2(tr), WC0 = r2(Z0), JC0 = r2(nr), $C0 = [0, [17, 0, 0], r2(z)], ZC0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], QC0 = [0, [15, 0], r2(N0)], rP0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], eP0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], nP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], tP0 = [0, [15, 0], r2(N0)], uP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.CallTypeArg.Explicit"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.CallTypeArg.Explicit@ ")], iP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], fP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Expression.CallTypeArg.Implicit"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Expression.CallTypeArg.Implicit@ ")], xP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], oP0 = [0, [15, 0], r2(N0)], aP0 = r2(Yr), cP0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], sP0 = r2("Flow_ast.Expression.CallTypeArg.Implicit.comments"), vP0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], lP0 = r2(tr), bP0 = r2(Z0), pP0 = r2(nr), mP0 = [0, [17, 0, 0], r2(z)], _P0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], yP0 = [0, [15, 0], r2(N0)], hP0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], dP0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], kP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], wP0 = [0, [15, 0], r2(N0)], EP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Block"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Block@ ")], SP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], gP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Break"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Break@ ")], FP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], TP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ClassDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ClassDeclaration@ ")], OP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], IP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Continue"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Continue@ ")], AP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], NP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Debugger"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Debugger@ ")], CP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], PP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareClass"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareClass@ ")], DP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], LP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareExportDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareExportDeclaration@ ")], RP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], jP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareFunction"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareFunction@ ")], GP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], MP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareInterface"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareInterface@ ")], BP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], qP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareModule"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareModule@ ")], UP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], HP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareModuleExports"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareModuleExports@ ")], XP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], YP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareTypeAlias"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareTypeAlias@ ")], VP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], zP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareOpaqueType"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareOpaqueType@ ")], KP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], WP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareVariable"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareVariable@ ")], JP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], $P0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DoWhile"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DoWhile@ ")], ZP0 = [0, [17, 0, [12, 41, 0]], r2(d0)], QP0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Empty"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Empty@ ")], rD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], eD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.EnumDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.EnumDeclaration@ ")], nD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], tD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ExportDefaultDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ExportDefaultDeclaration@ ")], uD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], iD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ExportNamedDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ExportNamedDeclaration@ ")], fD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], xD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Expression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Expression@ ")], oD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], aD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.For"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.For@ ")], cD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], sD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ForIn"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ForIn@ ")], vD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], lD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ForOf"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ForOf@ ")], bD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], pD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.FunctionDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.FunctionDeclaration@ ")], mD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], _D0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.If"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.If@ ")], yD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], hD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ImportDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ImportDeclaration@ ")], dD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], kD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.InterfaceDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.InterfaceDeclaration@ ")], wD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], ED0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Labeled"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Labeled@ ")], SD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], gD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Return"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Return@ ")], FD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], TD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Switch"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Switch@ ")], OD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], ID0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Throw"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Throw@ ")], AD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], ND0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.Try"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.Try@ ")], CD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], PD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.TypeAlias"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.TypeAlias@ ")], DD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], LD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.OpaqueType"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.OpaqueType@ ")], RD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], jD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.VariableDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.VariableDeclaration@ ")], GD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], MD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.While"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.While@ ")], BD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], qD0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.With"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.With@ ")], UD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], HD0 = [0, [15, 0], r2(N0)], XD0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], YD0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], VD0 = [0, [17, 0, [12, 41, 0]], r2(d0)], zD0 = [0, [15, 0], r2(N0)], KD0 = r2("Flow_ast.Statement.ExportValue"), WD0 = r2("Flow_ast.Statement.ExportType"), JD0 = [0, [15, 0], r2(N0)], $D0 = r2(Yr), ZD0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], QD0 = r2("Flow_ast.Statement.Empty.comments"), rL0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], eL0 = r2(tr), nL0 = r2(Z0), tL0 = r2(nr), uL0 = [0, [17, 0, 0], r2(z)], iL0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], fL0 = [0, [15, 0], r2(N0)], xL0 = r2(Yr), oL0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], aL0 = r2("Flow_ast.Statement.Expression.expression"), cL0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], sL0 = [0, [17, 0, 0], r2(z)], vL0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], lL0 = r2(Zi), bL0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], pL0 = r2(tr), mL0 = [0, [3, 0, 0], r2(Vt)], _L0 = r2(Z0), yL0 = r2(nr), hL0 = [0, [17, 0, 0], r2(z)], dL0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], kL0 = r2(Xr), wL0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], EL0 = r2(tr), SL0 = r2(Z0), gL0 = r2(nr), FL0 = [0, [17, 0, 0], r2(z)], TL0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], OL0 = [0, [15, 0], r2(N0)], IL0 = r2(Yr), AL0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], NL0 = r2("Flow_ast.Statement.ImportDeclaration.import_kind"), CL0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], PL0 = [0, [17, 0, 0], r2(z)], DL0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], LL0 = r2(cc), RL0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jL0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], GL0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], ML0 = [0, [17, 0, [12, 41, 0]], r2(d0)], BL0 = [0, [17, 0, 0], r2(z)], qL0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], UL0 = r2(_i), HL0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], XL0 = r2(tr), YL0 = r2(Z0), VL0 = r2(nr), zL0 = [0, [17, 0, 0], r2(z)], KL0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], WL0 = r2(Cv), JL0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $L0 = r2(tr), ZL0 = r2(Z0), QL0 = r2(nr), rR0 = [0, [17, 0, 0], r2(z)], eR0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], nR0 = r2(Xr), tR0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], uR0 = r2(tr), iR0 = r2(Z0), fR0 = r2(nr), xR0 = [0, [17, 0, 0], r2(z)], oR0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], aR0 = [0, [15, 0], r2(N0)], cR0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], sR0 = r2("Flow_ast.Statement.ImportDeclaration.kind"), vR0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], lR0 = r2(tr), bR0 = r2(Z0), pR0 = r2(nr), mR0 = [0, [17, 0, 0], r2(z)], _R0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], yR0 = r2(B2), hR0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], dR0 = r2(tr), kR0 = r2(Z0), wR0 = r2(nr), ER0 = [0, [17, 0, 0], r2(z)], SR0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], gR0 = r2("remote"), FR0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], TR0 = [0, [17, 0, 0], r2(z)], OR0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], IR0 = [0, [15, 0], r2(N0)], AR0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], NR0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ImportDeclaration.ImportNamedSpecifiers"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ImportDeclaration.ImportNamedSpecifiers@ ")], CR0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], PR0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], DR0 = [0, [17, 0, [12, 41, 0]], r2(d0)], LR0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ImportDeclaration.ImportNamespaceSpecifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ImportDeclaration.ImportNamespaceSpecifier@ ")], RR0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], jR0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], GR0 = [0, [17, 0, [12, 41, 0]], r2(d0)], MR0 = [0, [17, 0, [12, 41, 0]], r2(d0)], BR0 = [0, [15, 0], r2(N0)], qR0 = r2("Flow_ast.Statement.ImportDeclaration.ImportType"), UR0 = r2("Flow_ast.Statement.ImportDeclaration.ImportTypeof"), HR0 = r2("Flow_ast.Statement.ImportDeclaration.ImportValue"), XR0 = [0, [15, 0], r2(N0)], YR0 = r2(Yr), VR0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], zR0 = r2("Flow_ast.Statement.DeclareExportDeclaration.default"), KR0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], WR0 = r2(tr), JR0 = r2(Z0), $R0 = r2(nr), ZR0 = [0, [17, 0, 0], r2(z)], QR0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], rj0 = r2(P2), ej0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], nj0 = r2(tr), tj0 = r2(Z0), uj0 = r2(nr), ij0 = [0, [17, 0, 0], r2(z)], fj0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], xj0 = r2(Cv), oj0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], aj0 = r2(tr), cj0 = r2(Z0), sj0 = r2(nr), vj0 = [0, [17, 0, 0], r2(z)], lj0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], bj0 = r2(cc), pj0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], mj0 = r2(tr), _j0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], yj0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], hj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], dj0 = r2(Z0), kj0 = r2(nr), wj0 = [0, [17, 0, 0], r2(z)], Ej0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Sj0 = r2(Xr), gj0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Fj0 = r2(tr), Tj0 = r2(Z0), Oj0 = r2(nr), Ij0 = [0, [17, 0, 0], r2(z)], Aj0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Nj0 = [0, [15, 0], r2(N0)], Cj0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareExportDeclaration.Variable"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.Variable@ ")], Pj0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Dj0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Lj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Rj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], jj0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareExportDeclaration.Function"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.Function@ ")], Gj0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Mj0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Bj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], qj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Uj0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareExportDeclaration.Class"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.Class@ ")], Hj0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Xj0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Yj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Vj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], zj0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareExportDeclaration.DefaultType"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.DefaultType@ ")], Kj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Wj0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareExportDeclaration.NamedType"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.NamedType@ ")], Jj0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], $j0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Zj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Qj0 = [0, [17, 0, [12, 41, 0]], r2(d0)], rG0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareExportDeclaration.NamedOpaqueType"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.NamedOpaqueType@ ")], eG0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], nG0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], tG0 = [0, [17, 0, [12, 41, 0]], r2(d0)], uG0 = [0, [17, 0, [12, 41, 0]], r2(d0)], iG0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareExportDeclaration.Interface"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareExportDeclaration.Interface@ ")], fG0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], xG0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], oG0 = [0, [17, 0, [12, 41, 0]], r2(d0)], aG0 = [0, [17, 0, [12, 41, 0]], r2(d0)], cG0 = [0, [15, 0], r2(N0)], sG0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ExportDefaultDeclaration.Declaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ExportDefaultDeclaration.Declaration@ ")], vG0 = [0, [17, 0, [12, 41, 0]], r2(d0)], lG0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ExportDefaultDeclaration.Expression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ExportDefaultDeclaration.Expression@ ")], bG0 = [0, [17, 0, [12, 41, 0]], r2(d0)], pG0 = [0, [15, 0], r2(N0)], mG0 = r2(Yr), _G0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], yG0 = r2("Flow_ast.Statement.ExportDefaultDeclaration.default"), hG0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], dG0 = [0, [17, 0, 0], r2(z)], kG0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], wG0 = r2(P2), EG0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], SG0 = [0, [17, 0, 0], r2(z)], gG0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], FG0 = r2(Xr), TG0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], OG0 = r2(tr), IG0 = r2(Z0), AG0 = r2(nr), NG0 = [0, [17, 0, 0], r2(z)], CG0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], PG0 = [0, [15, 0], r2(N0)], DG0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], LG0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ExportNamedDeclaration.ExportSpecifiers"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ExportNamedDeclaration.ExportSpecifiers@ ")], RG0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], jG0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], GG0 = [0, [17, 0, [12, 41, 0]], r2(d0)], MG0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ExportNamedDeclaration.ExportBatchSpecifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ExportNamedDeclaration.ExportBatchSpecifier@ ")], BG0 = [0, [17, 0, [12, 41, 0]], r2(d0)], qG0 = [0, [15, 0], r2(N0)], UG0 = r2(Yr), HG0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], XG0 = r2("Flow_ast.Statement.ExportNamedDeclaration.declaration"), YG0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], VG0 = r2(tr), zG0 = r2(Z0), KG0 = r2(nr), WG0 = [0, [17, 0, 0], r2(z)], JG0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], $G0 = r2(Cv), ZG0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], QG0 = r2(tr), rM0 = r2(Z0), eM0 = r2(nr), nM0 = [0, [17, 0, 0], r2(z)], tM0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], uM0 = r2(cc), iM0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], fM0 = r2(tr), xM0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], oM0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], aM0 = [0, [17, 0, [12, 41, 0]], r2(d0)], cM0 = r2(Z0), sM0 = r2(nr), vM0 = [0, [17, 0, 0], r2(z)], lM0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], bM0 = r2("export_kind"), pM0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], mM0 = [0, [17, 0, 0], r2(z)], _M0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], yM0 = r2(Xr), hM0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], dM0 = r2(tr), kM0 = r2(Z0), wM0 = r2(nr), EM0 = [0, [17, 0, 0], r2(z)], SM0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], gM0 = [0, [15, 0], r2(N0)], FM0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], TM0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], OM0 = r2(tr), IM0 = r2(Z0), AM0 = r2(nr), NM0 = [0, [17, 0, [12, 41, 0]], r2(d0)], CM0 = [0, [15, 0], r2(N0)], PM0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], DM0 = r2("Flow_ast.Statement.ExportNamedDeclaration.ExportSpecifier.local"), LM0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], RM0 = [0, [17, 0, 0], r2(z)], jM0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], GM0 = r2(I4), MM0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], BM0 = r2(tr), qM0 = r2(Z0), UM0 = r2(nr), HM0 = [0, [17, 0, 0], r2(z)], XM0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], YM0 = [0, [15, 0], r2(N0)], VM0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], zM0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], KM0 = [0, [17, 0, [12, 41, 0]], r2(d0)], WM0 = [0, [15, 0], r2(N0)], JM0 = r2(Yr), $M0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], ZM0 = r2("Flow_ast.Statement.DeclareModuleExports.annot"), QM0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], rB0 = [0, [17, 0, 0], r2(z)], eB0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], nB0 = r2(Xr), tB0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], uB0 = r2(tr), iB0 = r2(Z0), fB0 = r2(nr), xB0 = [0, [17, 0, 0], r2(z)], oB0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], aB0 = [0, [15, 0], r2(N0)], cB0 = r2(Yr), sB0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], vB0 = r2("Flow_ast.Statement.DeclareModule.id"), lB0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], bB0 = [0, [17, 0, 0], r2(z)], pB0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], mB0 = r2(Wn), _B0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], yB0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], hB0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], dB0 = [0, [17, 0, [12, 41, 0]], r2(d0)], kB0 = [0, [17, 0, 0], r2(z)], wB0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], EB0 = r2($c), SB0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], gB0 = [0, [17, 0, 0], r2(z)], FB0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], TB0 = r2(Xr), OB0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], IB0 = r2(tr), AB0 = r2(Z0), NB0 = r2(nr), CB0 = [0, [17, 0, 0], r2(z)], PB0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], DB0 = [0, [15, 0], r2(N0)], LB0 = r2("Flow_ast.Statement.DeclareModule.ES"), RB0 = r2("Flow_ast.Statement.DeclareModule.CommonJS"), jB0 = [0, [15, 0], r2(N0)], GB0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareModule.Identifier"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareModule.Identifier@ ")], MB0 = [0, [17, 0, [12, 41, 0]], r2(d0)], BB0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.DeclareModule.Literal"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.DeclareModule.Literal@ ")], qB0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], UB0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], HB0 = [0, [17, 0, [12, 41, 0]], r2(d0)], XB0 = [0, [17, 0, [12, 41, 0]], r2(d0)], YB0 = [0, [15, 0], r2(N0)], VB0 = r2(Yr), zB0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], KB0 = r2("Flow_ast.Statement.DeclareFunction.id"), WB0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], JB0 = [0, [17, 0, 0], r2(z)], $B0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ZB0 = r2(Qc), QB0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], rq0 = [0, [17, 0, 0], r2(z)], eq0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], nq0 = r2(r7), tq0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], uq0 = r2(tr), iq0 = r2(Z0), fq0 = r2(nr), xq0 = [0, [17, 0, 0], r2(z)], oq0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], aq0 = r2(Xr), cq0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], sq0 = r2(tr), vq0 = r2(Z0), lq0 = r2(nr), bq0 = [0, [17, 0, 0], r2(z)], pq0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], mq0 = [0, [15, 0], r2(N0)], _q0 = r2(Yr), yq0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], hq0 = r2("Flow_ast.Statement.DeclareVariable.id"), dq0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kq0 = [0, [17, 0, 0], r2(z)], wq0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Eq0 = r2(Qc), Sq0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], gq0 = [0, [17, 0, 0], r2(z)], Fq0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Tq0 = r2(Xr), Oq0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Iq0 = r2(tr), Aq0 = r2(Z0), Nq0 = r2(nr), Cq0 = [0, [17, 0, 0], r2(z)], Pq0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Dq0 = [0, [15, 0], r2(N0)], Lq0 = r2(Yr), Rq0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], jq0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Gq0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Mq0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Bq0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], qq0 = r2("Flow_ast.Statement.DeclareClass.id"), Uq0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Hq0 = [0, [17, 0, 0], r2(z)], Xq0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Yq0 = r2(sv), Vq0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], zq0 = r2(tr), Kq0 = r2(Z0), Wq0 = r2(nr), Jq0 = [0, [17, 0, 0], r2(z)], $q0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Zq0 = r2(Wn), Qq0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], rU0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], eU0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], nU0 = [0, [17, 0, [12, 41, 0]], r2(d0)], tU0 = [0, [17, 0, 0], r2(z)], uU0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], iU0 = r2(P7), fU0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], xU0 = r2(tr), oU0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], aU0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], cU0 = [0, [17, 0, [12, 41, 0]], r2(d0)], sU0 = r2(Z0), vU0 = r2(nr), lU0 = [0, [17, 0, 0], r2(z)], bU0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], pU0 = r2(Hy), mU0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], _U0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], yU0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], hU0 = [0, [17, 0, 0], r2(z)], dU0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], kU0 = r2(ws), wU0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], EU0 = r2(tr), SU0 = r2(Z0), gU0 = r2(nr), FU0 = [0, [17, 0, 0], r2(z)], TU0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], OU0 = r2(Xr), IU0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], AU0 = r2(tr), NU0 = r2(Z0), CU0 = r2(nr), PU0 = [0, [17, 0, 0], r2(z)], DU0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], LU0 = [0, [15, 0], r2(N0)], RU0 = r2(Yr), jU0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], GU0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], MU0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], BU0 = [0, [17, 0, [12, 41, 0]], r2(d0)], qU0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], UU0 = r2("Flow_ast.Statement.Interface.id"), HU0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], XU0 = [0, [17, 0, 0], r2(z)], YU0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], VU0 = r2(sv), zU0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], KU0 = r2(tr), WU0 = r2(Z0), JU0 = r2(nr), $U0 = [0, [17, 0, 0], r2(z)], ZU0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], QU0 = r2(P7), rH0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], eH0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], nH0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], tH0 = [0, [17, 0, 0], r2(z)], uH0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], iH0 = r2(Wn), fH0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], xH0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], oH0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], aH0 = [0, [17, 0, [12, 41, 0]], r2(d0)], cH0 = [0, [17, 0, 0], r2(z)], sH0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], vH0 = r2(Xr), lH0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], bH0 = r2(tr), pH0 = r2(Z0), mH0 = r2(nr), _H0 = [0, [17, 0, 0], r2(z)], yH0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], hH0 = [0, [15, 0], r2(N0)], dH0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.EnumDeclaration.BooleanBody"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.EnumDeclaration.BooleanBody@ ")], kH0 = [0, [17, 0, [12, 41, 0]], r2(d0)], wH0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.EnumDeclaration.NumberBody"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.EnumDeclaration.NumberBody@ ")], EH0 = [0, [17, 0, [12, 41, 0]], r2(d0)], SH0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.EnumDeclaration.StringBody"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.EnumDeclaration.StringBody@ ")], gH0 = [0, [17, 0, [12, 41, 0]], r2(d0)], FH0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.EnumDeclaration.SymbolBody"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.EnumDeclaration.SymbolBody@ ")], TH0 = [0, [17, 0, [12, 41, 0]], r2(d0)], OH0 = [0, [15, 0], r2(N0)], IH0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], AH0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], NH0 = [0, [17, 0, [12, 41, 0]], r2(d0)], CH0 = [0, [15, 0], r2(N0)], PH0 = r2(Yr), DH0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], LH0 = r2("Flow_ast.Statement.EnumDeclaration.id"), RH0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jH0 = [0, [17, 0, 0], r2(z)], GH0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], MH0 = r2(Wn), BH0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], qH0 = [0, [17, 0, 0], r2(z)], UH0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], HH0 = r2(Xr), XH0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], YH0 = r2(tr), VH0 = r2(Z0), zH0 = r2(nr), KH0 = [0, [17, 0, 0], r2(z)], WH0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], JH0 = [0, [15, 0], r2(N0)], $H0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ZH0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], QH0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], rX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], eX0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], nX0 = r2("Flow_ast.Statement.EnumDeclaration.SymbolBody.members"), tX0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], uX0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], iX0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], fX0 = [0, [17, 0, 0], r2(z)], xX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], oX0 = r2(w4), aX0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], cX0 = [0, [9, 0, 0], r2(An)], sX0 = [0, [17, 0, 0], r2(z)], vX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], lX0 = r2(Xr), bX0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], pX0 = r2(tr), mX0 = r2(Z0), _X0 = r2(nr), yX0 = [0, [17, 0, 0], r2(z)], hX0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], dX0 = [0, [15, 0], r2(N0)], kX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], wX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], EX0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.EnumDeclaration.StringBody.Defaulted"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.EnumDeclaration.StringBody.Defaulted@ ")], SX0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], gX0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], FX0 = [0, [17, 0, [12, 41, 0]], r2(d0)], TX0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.EnumDeclaration.StringBody.Initialized"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.EnumDeclaration.StringBody.Initialized@ ")], OX0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], IX0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], AX0 = [0, [17, 0, [12, 41, 0]], r2(d0)], NX0 = [0, [15, 0], r2(N0)], CX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], PX0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], DX0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], LX0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], RX0 = r2("Flow_ast.Statement.EnumDeclaration.StringBody.members"), jX0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], GX0 = [0, [17, 0, 0], r2(z)], MX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], BX0 = r2(Fk), qX0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], UX0 = [0, [9, 0, 0], r2(An)], HX0 = [0, [17, 0, 0], r2(z)], XX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], YX0 = r2(w4), VX0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], zX0 = [0, [9, 0, 0], r2(An)], KX0 = [0, [17, 0, 0], r2(z)], WX0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], JX0 = r2(Xr), $X0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ZX0 = r2(tr), QX0 = r2(Z0), rY0 = r2(nr), eY0 = [0, [17, 0, 0], r2(z)], nY0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], tY0 = [0, [15, 0], r2(N0)], uY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], iY0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], fY0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], xY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], oY0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], aY0 = r2("Flow_ast.Statement.EnumDeclaration.NumberBody.members"), cY0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], sY0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], vY0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], lY0 = [0, [17, 0, 0], r2(z)], bY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], pY0 = r2(Fk), mY0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], _Y0 = [0, [9, 0, 0], r2(An)], yY0 = [0, [17, 0, 0], r2(z)], hY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], dY0 = r2(w4), kY0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], wY0 = [0, [9, 0, 0], r2(An)], EY0 = [0, [17, 0, 0], r2(z)], SY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], gY0 = r2(Xr), FY0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], TY0 = r2(tr), OY0 = r2(Z0), IY0 = r2(nr), AY0 = [0, [17, 0, 0], r2(z)], NY0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], CY0 = [0, [15, 0], r2(N0)], PY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], DY0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], LY0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], RY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], jY0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], GY0 = r2("Flow_ast.Statement.EnumDeclaration.BooleanBody.members"), MY0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], BY0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], qY0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], UY0 = [0, [17, 0, 0], r2(z)], HY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], XY0 = r2(Fk), YY0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], VY0 = [0, [9, 0, 0], r2(An)], zY0 = [0, [17, 0, 0], r2(z)], KY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], WY0 = r2(w4), JY0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $Y0 = [0, [9, 0, 0], r2(An)], ZY0 = [0, [17, 0, 0], r2(z)], QY0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], rV0 = r2(Xr), eV0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], nV0 = r2(tr), tV0 = r2(Z0), uV0 = r2(nr), iV0 = [0, [17, 0, 0], r2(z)], fV0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], xV0 = [0, [15, 0], r2(N0)], oV0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], aV0 = r2("Flow_ast.Statement.EnumDeclaration.InitializedMember.id"), cV0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], sV0 = [0, [17, 0, 0], r2(z)], vV0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], lV0 = r2(ji), bV0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], pV0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], mV0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], _V0 = [0, [17, 0, [12, 41, 0]], r2(d0)], yV0 = [0, [17, 0, 0], r2(z)], hV0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], dV0 = [0, [15, 0], r2(N0)], kV0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], wV0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], EV0 = [0, [17, 0, [12, 41, 0]], r2(d0)], SV0 = [0, [15, 0], r2(N0)], gV0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], FV0 = r2("Flow_ast.Statement.EnumDeclaration.DefaultedMember.id"), TV0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], OV0 = [0, [17, 0, 0], r2(z)], IV0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], AV0 = [0, [15, 0], r2(N0)], NV0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], CV0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], PV0 = [0, [17, 0, [12, 41, 0]], r2(d0)], DV0 = [0, [15, 0], r2(N0)], LV0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ForOf.LeftDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ForOf.LeftDeclaration@ ")], RV0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], jV0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], GV0 = [0, [17, 0, [12, 41, 0]], r2(d0)], MV0 = [0, [17, 0, [12, 41, 0]], r2(d0)], BV0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ForOf.LeftPattern"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ForOf.LeftPattern@ ")], qV0 = [0, [17, 0, [12, 41, 0]], r2(d0)], UV0 = [0, [15, 0], r2(N0)], HV0 = r2(Yr), XV0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], YV0 = r2("Flow_ast.Statement.ForOf.left"), VV0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], zV0 = [0, [17, 0, 0], r2(z)], KV0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], WV0 = r2(Cu), JV0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $V0 = [0, [17, 0, 0], r2(z)], ZV0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], QV0 = r2(Wn), rz0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ez0 = [0, [17, 0, 0], r2(z)], nz0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], tz0 = r2(dx), uz0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], iz0 = [0, [9, 0, 0], r2(An)], fz0 = [0, [17, 0, 0], r2(z)], xz0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], oz0 = r2(Xr), az0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], cz0 = r2(tr), sz0 = r2(Z0), vz0 = r2(nr), lz0 = [0, [17, 0, 0], r2(z)], bz0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], pz0 = [0, [15, 0], r2(N0)], mz0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ForIn.LeftDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ForIn.LeftDeclaration@ ")], _z0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], yz0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], hz0 = [0, [17, 0, [12, 41, 0]], r2(d0)], dz0 = [0, [17, 0, [12, 41, 0]], r2(d0)], kz0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.ForIn.LeftPattern"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.ForIn.LeftPattern@ ")], wz0 = [0, [17, 0, [12, 41, 0]], r2(d0)], Ez0 = [0, [15, 0], r2(N0)], Sz0 = r2(Yr), gz0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Fz0 = r2("Flow_ast.Statement.ForIn.left"), Tz0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Oz0 = [0, [17, 0, 0], r2(z)], Iz0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Az0 = r2(Cu), Nz0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Cz0 = [0, [17, 0, 0], r2(z)], Pz0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Dz0 = r2(Wn), Lz0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Rz0 = [0, [17, 0, 0], r2(z)], jz0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Gz0 = r2(R8), Mz0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Bz0 = [0, [9, 0, 0], r2(An)], qz0 = [0, [17, 0, 0], r2(z)], Uz0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Hz0 = r2(Xr), Xz0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Yz0 = r2(tr), Vz0 = r2(Z0), zz0 = r2(nr), Kz0 = [0, [17, 0, 0], r2(z)], Wz0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Jz0 = [0, [15, 0], r2(N0)], $z0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.For.InitDeclaration"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.For.InitDeclaration@ ")], Zz0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Qz0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], rK0 = [0, [17, 0, [12, 41, 0]], r2(d0)], eK0 = [0, [17, 0, [12, 41, 0]], r2(d0)], nK0 = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Statement.For.InitExpression"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Statement.For.InitExpression@ ")], tK0 = [0, [17, 0, [12, 41, 0]], r2(d0)], uK0 = [0, [15, 0], r2(N0)], iK0 = r2(Yr), fK0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], xK0 = r2("Flow_ast.Statement.For.init"), oK0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], aK0 = r2(tr), cK0 = r2(Z0), sK0 = r2(nr), vK0 = [0, [17, 0, 0], r2(z)], lK0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], bK0 = r2(Ss), pK0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], mK0 = r2(tr), _K0 = r2(Z0), yK0 = r2(nr), hK0 = [0, [17, 0, 0], r2(z)], dK0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], kK0 = r2(fU), wK0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], EK0 = r2(tr), SK0 = r2(Z0), gK0 = r2(nr), FK0 = [0, [17, 0, 0], r2(z)], TK0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], OK0 = r2(Wn), IK0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], AK0 = [0, [17, 0, 0], r2(z)], NK0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], CK0 = r2(Xr), PK0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], DK0 = r2(tr), LK0 = r2(Z0), RK0 = r2(nr), jK0 = [0, [17, 0, 0], r2(z)], GK0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], MK0 = [0, [15, 0], r2(N0)], BK0 = r2(Yr), qK0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], UK0 = r2("Flow_ast.Statement.DoWhile.body"), HK0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], XK0 = [0, [17, 0, 0], r2(z)], YK0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], VK0 = r2(Ss), zK0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], KK0 = [0, [17, 0, 0], r2(z)], WK0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], JK0 = r2(Xr), $K0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ZK0 = r2(tr), QK0 = r2(Z0), rW0 = r2(nr), eW0 = [0, [17, 0, 0], r2(z)], nW0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], tW0 = [0, [15, 0], r2(N0)], uW0 = r2(Yr), iW0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], fW0 = r2("Flow_ast.Statement.While.test"), xW0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], oW0 = [0, [17, 0, 0], r2(z)], aW0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], cW0 = r2(Wn), sW0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], vW0 = [0, [17, 0, 0], r2(z)], lW0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], bW0 = r2(Xr), pW0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], mW0 = r2(tr), _W0 = r2(Z0), yW0 = r2(nr), hW0 = [0, [17, 0, 0], r2(z)], dW0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], kW0 = [0, [15, 0], r2(N0)], wW0 = r2("Flow_ast.Statement.VariableDeclaration.Var"), EW0 = r2("Flow_ast.Statement.VariableDeclaration.Let"), SW0 = r2("Flow_ast.Statement.VariableDeclaration.Const"), gW0 = [0, [15, 0], r2(N0)], FW0 = r2(Yr), TW0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], OW0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], IW0 = r2("Flow_ast.Statement.VariableDeclaration.declarations"), AW0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], NW0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], CW0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], PW0 = [0, [17, 0, 0], r2(z)], DW0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], LW0 = r2($c), RW0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jW0 = [0, [17, 0, 0], r2(z)], GW0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], MW0 = r2(Xr), BW0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], qW0 = r2(tr), UW0 = r2(Z0), HW0 = r2(nr), XW0 = [0, [17, 0, 0], r2(z)], YW0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], VW0 = [0, [15, 0], r2(N0)], zW0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], KW0 = r2("Flow_ast.Statement.VariableDeclaration.Declarator.id"), WW0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], JW0 = [0, [17, 0, 0], r2(z)], $W0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ZW0 = r2(ji), QW0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], rJ0 = r2(tr), eJ0 = r2(Z0), nJ0 = r2(nr), tJ0 = [0, [17, 0, 0], r2(z)], uJ0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], iJ0 = [0, [15, 0], r2(N0)], fJ0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], xJ0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], oJ0 = [0, [17, 0, [12, 41, 0]], r2(d0)], aJ0 = [0, [15, 0], r2(N0)], cJ0 = r2(Yr), sJ0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], vJ0 = r2("Flow_ast.Statement.Try.block"), lJ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], bJ0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], pJ0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], mJ0 = [0, [17, 0, [12, 41, 0]], r2(d0)], _J0 = [0, [17, 0, 0], r2(z)], yJ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], hJ0 = r2(MU), dJ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kJ0 = r2(tr), wJ0 = r2(Z0), EJ0 = r2(nr), SJ0 = [0, [17, 0, 0], r2(z)], gJ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], FJ0 = r2(CH), TJ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], OJ0 = r2(tr), IJ0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], AJ0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], NJ0 = [0, [17, 0, [12, 41, 0]], r2(d0)], CJ0 = r2(Z0), PJ0 = r2(nr), DJ0 = [0, [17, 0, 0], r2(z)], LJ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], RJ0 = r2(Xr), jJ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], GJ0 = r2(tr), MJ0 = r2(Z0), BJ0 = r2(nr), qJ0 = [0, [17, 0, 0], r2(z)], UJ0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], HJ0 = [0, [15, 0], r2(N0)], XJ0 = r2(Yr), YJ0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], VJ0 = r2("Flow_ast.Statement.Try.CatchClause.param"), zJ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], KJ0 = r2(tr), WJ0 = r2(Z0), JJ0 = r2(nr), $J0 = [0, [17, 0, 0], r2(z)], ZJ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], QJ0 = r2(Wn), r$0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], e$0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], n$0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], t$0 = [0, [17, 0, [12, 41, 0]], r2(d0)], u$0 = [0, [17, 0, 0], r2(z)], i$0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], f$0 = r2(Xr), x$0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], o$0 = r2(tr), a$0 = r2(Z0), c$0 = r2(nr), s$0 = [0, [17, 0, 0], r2(z)], v$0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], l$0 = [0, [15, 0], r2(N0)], b$0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], p$0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], m$0 = [0, [17, 0, [12, 41, 0]], r2(d0)], _$0 = [0, [15, 0], r2(N0)], y$0 = r2(Yr), h$0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], d$0 = r2("Flow_ast.Statement.Throw.argument"), k$0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], w$0 = [0, [17, 0, 0], r2(z)], E$0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], S$0 = r2(Xr), g$0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], F$0 = r2(tr), T$0 = r2(Z0), O$0 = r2(nr), I$0 = [0, [17, 0, 0], r2(z)], A$0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], N$0 = [0, [15, 0], r2(N0)], C$0 = r2(Yr), P$0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], D$0 = r2("Flow_ast.Statement.Return.argument"), L$0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], R$0 = r2(tr), j$0 = r2(Z0), G$0 = r2(nr), M$0 = [0, [17, 0, 0], r2(z)], B$0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], q$0 = r2(Xr), U$0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], H$0 = r2(tr), X$0 = r2(Z0), Y$0 = r2(nr), V$0 = [0, [17, 0, 0], r2(z)], z$0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], K$0 = r2("return_out"), W$0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], J$0 = [0, [17, 0, 0], r2(z)], $$0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Z$0 = [0, [15, 0], r2(N0)], Q$0 = r2(Yr), rZ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], eZ0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], nZ0 = r2("Flow_ast.Statement.Switch.discriminant"), tZ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], uZ0 = [0, [17, 0, 0], r2(z)], iZ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], fZ0 = r2(QX), xZ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], oZ0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], aZ0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], cZ0 = [0, [17, 0, 0], r2(z)], sZ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], vZ0 = r2(Xr), lZ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], bZ0 = r2(tr), pZ0 = r2(Z0), mZ0 = r2(nr), _Z0 = [0, [17, 0, 0], r2(z)], yZ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], hZ0 = r2("exhaustive_out"), dZ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], kZ0 = [0, [17, 0, 0], r2(z)], wZ0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], EZ0 = [0, [15, 0], r2(N0)], SZ0 = r2(Yr), gZ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], FZ0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], TZ0 = r2("Flow_ast.Statement.Switch.Case.test"), OZ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], IZ0 = r2(tr), AZ0 = r2(Z0), NZ0 = r2(nr), CZ0 = [0, [17, 0, 0], r2(z)], PZ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], DZ0 = r2(kv), LZ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], RZ0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], jZ0 = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], GZ0 = [0, [17, 0, 0], r2(z)], MZ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], BZ0 = r2(Xr), qZ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], UZ0 = r2(tr), HZ0 = r2(Z0), XZ0 = r2(nr), YZ0 = [0, [17, 0, 0], r2(z)], VZ0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], zZ0 = [0, [15, 0], r2(N0)], KZ0 = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], WZ0 = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], JZ0 = [0, [17, 0, [12, 41, 0]], r2(d0)], $Z0 = [0, [15, 0], r2(N0)], ZZ0 = r2(Yr), QZ0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], rQ0 = r2("Flow_ast.Statement.OpaqueType.id"), eQ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], nQ0 = [0, [17, 0, 0], r2(z)], tQ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], uQ0 = r2(sv), iQ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], fQ0 = r2(tr), xQ0 = r2(Z0), oQ0 = r2(nr), aQ0 = [0, [17, 0, 0], r2(z)], cQ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], sQ0 = r2(mX), vQ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], lQ0 = r2(tr), bQ0 = r2(Z0), pQ0 = r2(nr), mQ0 = [0, [17, 0, 0], r2(z)], _Q0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], yQ0 = r2(SX), hQ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], dQ0 = r2(tr), kQ0 = r2(Z0), wQ0 = r2(nr), EQ0 = [0, [17, 0, 0], r2(z)], SQ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], gQ0 = r2(Xr), FQ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], TQ0 = r2(tr), OQ0 = r2(Z0), IQ0 = r2(nr), AQ0 = [0, [17, 0, 0], r2(z)], NQ0 = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], CQ0 = [0, [15, 0], r2(N0)], PQ0 = r2(Yr), DQ0 = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], LQ0 = r2("Flow_ast.Statement.TypeAlias.id"), RQ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jQ0 = [0, [17, 0, 0], r2(z)], GQ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], MQ0 = r2(sv), BQ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], qQ0 = r2(tr), UQ0 = r2(Z0), HQ0 = r2(nr), XQ0 = [0, [17, 0, 0], r2(z)], YQ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], VQ0 = r2(Cu), zQ0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], KQ0 = [0, [17, 0, 0], r2(z)], WQ0 = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], JQ0 = r2(Xr), $Q0 = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ZQ0 = r2(tr), QQ0 = r2(Z0), r0r = r2(nr), e0r = [0, [17, 0, 0], r2(z)], n0r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], t0r = [0, [15, 0], r2(N0)], u0r = r2(Yr), i0r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], f0r = r2("Flow_ast.Statement.With._object"), x0r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], o0r = [0, [17, 0, 0], r2(z)], a0r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], c0r = r2(Wn), s0r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], v0r = [0, [17, 0, 0], r2(z)], l0r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], b0r = r2(Xr), p0r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], m0r = r2(tr), _0r = r2(Z0), y0r = r2(nr), h0r = [0, [17, 0, 0], r2(z)], d0r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], k0r = [0, [15, 0], r2(N0)], w0r = r2(Yr), E0r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], S0r = r2("Flow_ast.Statement.Debugger.comments"), g0r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], F0r = r2(tr), T0r = r2(Z0), O0r = r2(nr), I0r = [0, [17, 0, 0], r2(z)], A0r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], N0r = [0, [15, 0], r2(N0)], C0r = r2(Yr), P0r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], D0r = r2("Flow_ast.Statement.Continue.label"), L0r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], R0r = r2(tr), j0r = r2(Z0), G0r = r2(nr), M0r = [0, [17, 0, 0], r2(z)], B0r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], q0r = r2(Xr), U0r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], H0r = r2(tr), X0r = r2(Z0), Y0r = r2(nr), V0r = [0, [17, 0, 0], r2(z)], z0r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], K0r = [0, [15, 0], r2(N0)], W0r = r2(Yr), J0r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], $0r = r2("Flow_ast.Statement.Break.label"), Z0r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Q0r = r2(tr), rrr = r2(Z0), err = r2(nr), nrr = [0, [17, 0, 0], r2(z)], trr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], urr = r2(Xr), irr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], frr = r2(tr), xrr = r2(Z0), orr = r2(nr), arr = [0, [17, 0, 0], r2(z)], crr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], srr = [0, [15, 0], r2(N0)], vrr = r2(Yr), lrr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], brr = r2("Flow_ast.Statement.Labeled.label"), prr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], mrr = [0, [17, 0, 0], r2(z)], _rr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], yrr = r2(Wn), hrr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], drr = [0, [17, 0, 0], r2(z)], krr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], wrr = r2(Xr), Err = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Srr = r2(tr), grr = r2(Z0), Frr = r2(nr), Trr = [0, [17, 0, 0], r2(z)], Orr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Irr = [0, [15, 0], r2(N0)], Arr = r2(Yr), Nrr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Crr = r2("Flow_ast.Statement.If.test"), Prr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Drr = [0, [17, 0, 0], r2(z)], Lrr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Rrr = r2(kv), jrr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Grr = [0, [17, 0, 0], r2(z)], Mrr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Brr = r2(m3), qrr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Urr = r2(tr), Hrr = r2(Z0), Xrr = r2(nr), Yrr = [0, [17, 0, 0], r2(z)], Vrr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], zrr = r2(Xr), Krr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Wrr = r2(tr), Jrr = r2(Z0), $rr = r2(nr), Zrr = [0, [17, 0, 0], r2(z)], Qrr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], rer = [0, [15, 0], r2(N0)], eer = r2(Yr), ner = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], ter = r2("Flow_ast.Statement.If.Alternate.body"), uer = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ier = [0, [17, 0, 0], r2(z)], fer = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], xer = r2(Xr), oer = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], aer = r2(tr), cer = r2(Z0), ser = r2(nr), ver = [0, [17, 0, 0], r2(z)], ler = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], ber = [0, [15, 0], r2(N0)], per = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], mer = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], _er = [0, [17, 0, [12, 41, 0]], r2(d0)], yer = [0, [15, 0], r2(N0)], her = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], der = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], ker = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], wer = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Eer = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Ser = r2("Flow_ast.Statement.Block.body"), ger = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Fer = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Ter = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Oer = [0, [17, 0, 0], r2(z)], Ier = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Aer = r2(Xr), Ner = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Cer = r2(tr), Per = r2(Z0), Der = r2(nr), Ler = [0, [17, 0, 0], r2(z)], Rer = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], jer = [0, [15, 0], r2(N0)], Ger = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Predicate.Declared"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Predicate.Declared@ ")], Mer = [0, [17, 0, [12, 41, 0]], r2(d0)], Ber = r2("Flow_ast.Type.Predicate.Inferred"), qer = [0, [15, 0], r2(N0)], Uer = r2(Yr), Her = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Xer = r2("Flow_ast.Type.Predicate.kind"), Yer = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ver = [0, [17, 0, 0], r2(z)], zer = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ker = r2(Xr), Wer = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Jer = r2(tr), $er = r2(Z0), Zer = r2(nr), Qer = [0, [17, 0, 0], r2(z)], rnr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], enr = [0, [15, 0], r2(N0)], nnr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], tnr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], unr = [0, [17, 0, [12, 41, 0]], r2(d0)], inr = [0, [15, 0], r2(N0)], fnr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], xnr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], onr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], anr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], cnr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], snr = r2("Flow_ast.Type.TypeArgs.arguments"), vnr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], lnr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], bnr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], pnr = [0, [17, 0, 0], r2(z)], mnr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], _nr = r2(Xr), ynr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], hnr = r2(tr), dnr = r2(Z0), knr = r2(nr), wnr = [0, [17, 0, 0], r2(z)], Enr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Snr = [0, [15, 0], r2(N0)], gnr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Fnr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Tnr = [0, [17, 0, [12, 41, 0]], r2(d0)], Onr = [0, [15, 0], r2(N0)], Inr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Anr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Nnr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Cnr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Pnr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Dnr = r2("Flow_ast.Type.TypeParams.params"), Lnr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Rnr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], jnr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Gnr = [0, [17, 0, 0], r2(z)], Mnr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Bnr = r2(Xr), qnr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Unr = r2(tr), Hnr = r2(Z0), Xnr = r2(nr), Ynr = [0, [17, 0, 0], r2(z)], Vnr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], znr = [0, [15, 0], r2(N0)], Knr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Wnr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Jnr = [0, [17, 0, [12, 41, 0]], r2(d0)], $nr = [0, [15, 0], r2(N0)], Znr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Qnr = r2("Flow_ast.Type.TypeParam.name"), rtr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], etr = [0, [17, 0, 0], r2(z)], ntr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ttr = r2(DU), utr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], itr = [0, [17, 0, 0], r2(z)], ftr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], xtr = r2(cu), otr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], atr = r2(tr), ctr = r2(Z0), str = r2(nr), vtr = [0, [17, 0, 0], r2(z)], ltr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], btr = r2(_i), ptr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], mtr = r2(tr), _tr = r2(Z0), ytr = r2(nr), htr = [0, [17, 0, 0], r2(z)], dtr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], ktr = [0, [15, 0], r2(N0)], wtr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Etr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Str = [0, [17, 0, [12, 41, 0]], r2(d0)], gtr = [0, [15, 0], r2(N0)], Ftr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Missing"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Missing@ ")], Ttr = [0, [17, 0, [12, 41, 0]], r2(d0)], Otr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Available"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Available@ ")], Itr = [0, [17, 0, [12, 41, 0]], r2(d0)], Atr = [0, [15, 0], r2(N0)], Ntr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Ctr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Ptr = [0, [17, 0, [12, 41, 0]], r2(d0)], Dtr = [0, [15, 0], r2(N0)], Ltr = r2(Yr), Rtr = r2(Yr), jtr = r2(Yr), Gtr = r2(Yr), Mtr = r2(Yr), Btr = r2(Yr), qtr = r2(Yr), Utr = r2(Yr), Htr = r2(Yr), Xtr = r2(Yr), Ytr = r2(Yr), Vtr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Any"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Any@ ")], ztr = r2(tr), Ktr = r2(Z0), Wtr = r2(nr), Jtr = [0, [17, 0, [12, 41, 0]], r2(d0)], $tr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Mixed"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Mixed@ ")], Ztr = r2(tr), Qtr = r2(Z0), rur = r2(nr), eur = [0, [17, 0, [12, 41, 0]], r2(d0)], nur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Empty"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Empty@ ")], tur = r2(tr), uur = r2(Z0), iur = r2(nr), fur = [0, [17, 0, [12, 41, 0]], r2(d0)], xur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Void"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Void@ ")], our = r2(tr), aur = r2(Z0), cur = r2(nr), sur = [0, [17, 0, [12, 41, 0]], r2(d0)], vur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Null"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Null@ ")], lur = r2(tr), bur = r2(Z0), pur = r2(nr), mur = [0, [17, 0, [12, 41, 0]], r2(d0)], _ur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Number"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Number@ ")], yur = r2(tr), hur = r2(Z0), dur = r2(nr), kur = [0, [17, 0, [12, 41, 0]], r2(d0)], wur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.BigInt"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.BigInt@ ")], Eur = r2(tr), Sur = r2(Z0), gur = r2(nr), Fur = [0, [17, 0, [12, 41, 0]], r2(d0)], Tur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.String"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.String@ ")], Our = r2(tr), Iur = r2(Z0), Aur = r2(nr), Nur = [0, [17, 0, [12, 41, 0]], r2(d0)], Cur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Boolean"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Boolean@ ")], Pur = r2(tr), Dur = r2(Z0), Lur = r2(nr), Rur = [0, [17, 0, [12, 41, 0]], r2(d0)], jur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Symbol"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Symbol@ ")], Gur = r2(tr), Mur = r2(Z0), Bur = r2(nr), qur = [0, [17, 0, [12, 41, 0]], r2(d0)], Uur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Exists"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Exists@ ")], Hur = r2(tr), Xur = r2(Z0), Yur = r2(nr), Vur = [0, [17, 0, [12, 41, 0]], r2(d0)], zur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Nullable"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Nullable@ ")], Kur = [0, [17, 0, [12, 41, 0]], r2(d0)], Wur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Function"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Function@ ")], Jur = [0, [17, 0, [12, 41, 0]], r2(d0)], $ur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object@ ")], Zur = [0, [17, 0, [12, 41, 0]], r2(d0)], Qur = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Interface"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Interface@ ")], r7r = [0, [17, 0, [12, 41, 0]], r2(d0)], e7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Array"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Array@ ")], n7r = [0, [17, 0, [12, 41, 0]], r2(d0)], t7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Generic"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Generic@ ")], u7r = [0, [17, 0, [12, 41, 0]], r2(d0)], i7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.IndexedAccess"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.IndexedAccess@ ")], f7r = [0, [17, 0, [12, 41, 0]], r2(d0)], x7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.OptionalIndexedAccess"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.OptionalIndexedAccess@ ")], o7r = [0, [17, 0, [12, 41, 0]], r2(d0)], a7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Union"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Union@ ")], c7r = [0, [17, 0, [12, 41, 0]], r2(d0)], s7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Intersection"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Intersection@ ")], v7r = [0, [17, 0, [12, 41, 0]], r2(d0)], l7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Typeof"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Typeof@ ")], b7r = [0, [17, 0, [12, 41, 0]], r2(d0)], p7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Tuple"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Tuple@ ")], m7r = [0, [17, 0, [12, 41, 0]], r2(d0)], _7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.StringLiteral"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.StringLiteral@ ")], y7r = [0, [17, 0, [12, 41, 0]], r2(d0)], h7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.NumberLiteral"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.NumberLiteral@ ")], d7r = [0, [17, 0, [12, 41, 0]], r2(d0)], k7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.BigIntLiteral"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.BigIntLiteral@ ")], w7r = [0, [17, 0, [12, 41, 0]], r2(d0)], E7r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.BooleanLiteral"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.BooleanLiteral@ ")], S7r = [0, [17, 0, [12, 41, 0]], r2(d0)], g7r = [0, [15, 0], r2(N0)], F7r = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], T7r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], O7r = [0, [17, 0, [12, 41, 0]], r2(d0)], I7r = [0, [15, 0], r2(N0)], A7r = r2(Yr), N7r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], C7r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], P7r = r2("Flow_ast.Type.Intersection.types"), D7r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], L7r = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], R7r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], j7r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], G7r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], M7r = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], B7r = [0, [17, 0, [12, 41, 0]], r2(d0)], q7r = [0, [17, 0, 0], r2(z)], U7r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], H7r = r2(Xr), X7r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Y7r = r2(tr), V7r = r2(Z0), z7r = r2(nr), K7r = [0, [17, 0, 0], r2(z)], W7r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], J7r = [0, [15, 0], r2(N0)], $7r = r2(Yr), Z7r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Q7r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], rir = r2("Flow_ast.Type.Union.types"), eir = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], nir = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], tir = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], uir = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], iir = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], fir = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], xir = [0, [17, 0, [12, 41, 0]], r2(d0)], oir = [0, [17, 0, 0], r2(z)], air = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], cir = r2(Xr), sir = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], vir = r2(tr), lir = r2(Z0), bir = r2(nr), pir = [0, [17, 0, 0], r2(z)], mir = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], _ir = [0, [15, 0], r2(N0)], yir = r2(Yr), hir = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], dir = r2("Flow_ast.Type.Array.argument"), kir = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], wir = [0, [17, 0, 0], r2(z)], Eir = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Sir = r2(Xr), gir = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Fir = r2(tr), Tir = r2(Z0), Oir = r2(nr), Iir = [0, [17, 0, 0], r2(z)], Air = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Nir = [0, [15, 0], r2(N0)], Cir = r2(Yr), Pir = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Dir = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Lir = r2("Flow_ast.Type.Tuple.types"), Rir = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], jir = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Gir = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Mir = [0, [17, 0, 0], r2(z)], Bir = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], qir = r2(Xr), Uir = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Hir = r2(tr), Xir = r2(Z0), Yir = r2(nr), Vir = [0, [17, 0, 0], r2(z)], zir = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Kir = [0, [15, 0], r2(N0)], Wir = r2(Yr), Jir = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], $ir = r2("Flow_ast.Type.Typeof.argument"), Zir = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Qir = [0, [17, 0, 0], r2(z)], rfr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], efr = r2(Xr), nfr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], tfr = r2(tr), ufr = r2(Z0), ifr = r2(nr), ffr = [0, [17, 0, 0], r2(z)], xfr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], ofr = [0, [15, 0], r2(N0)], afr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], cfr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], sfr = [0, [17, 0, [12, 41, 0]], r2(d0)], vfr = [0, [15, 0], r2(N0)], lfr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], bfr = r2("Flow_ast.Type.Typeof.Target.qualification"), pfr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], mfr = [0, [17, 0, 0], r2(z)], _fr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], yfr = r2(mt), hfr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], dfr = [0, [17, 0, 0], r2(z)], kfr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], wfr = [0, [15, 0], r2(N0)], Efr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Typeof.Target.Unqualified"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Typeof.Target.Unqualified@ ")], Sfr = [0, [17, 0, [12, 41, 0]], r2(d0)], gfr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Typeof.Target.Qualified"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Typeof.Target.Qualified@ ")], Ffr = [0, [17, 0, [12, 41, 0]], r2(d0)], Tfr = [0, [15, 0], r2(N0)], Ofr = r2(Yr), Ifr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Afr = r2("Flow_ast.Type.Nullable.argument"), Nfr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Cfr = [0, [17, 0, 0], r2(z)], Pfr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Dfr = r2(Xr), Lfr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Rfr = r2(tr), jfr = r2(Z0), Gfr = r2(nr), Mfr = [0, [17, 0, 0], r2(z)], Bfr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], qfr = [0, [15, 0], r2(N0)], Ufr = r2(Yr), Hfr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Xfr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Yfr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Vfr = [0, [17, 0, [12, 41, 0]], r2(d0)], zfr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Kfr = r2("Flow_ast.Type.Interface.body"), Wfr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Jfr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], $fr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Zfr = [0, [17, 0, [12, 41, 0]], r2(d0)], Qfr = [0, [17, 0, 0], r2(z)], rxr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], exr = r2(P7), nxr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], txr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], uxr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], ixr = [0, [17, 0, 0], r2(z)], fxr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], xxr = r2(Xr), oxr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], axr = r2(tr), cxr = r2(Z0), sxr = r2(nr), vxr = [0, [17, 0, 0], r2(z)], lxr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], bxr = [0, [15, 0], r2(N0)], pxr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object.Property"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object.Property@ ")], mxr = [0, [17, 0, [12, 41, 0]], r2(d0)], _xr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object.SpreadProperty"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object.SpreadProperty@ ")], yxr = [0, [17, 0, [12, 41, 0]], r2(d0)], hxr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object.Indexer"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object.Indexer@ ")], dxr = [0, [17, 0, [12, 41, 0]], r2(d0)], kxr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object.CallProperty"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object.CallProperty@ ")], wxr = [0, [17, 0, [12, 41, 0]], r2(d0)], Exr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object.InternalSlot"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object.InternalSlot@ ")], Sxr = [0, [17, 0, [12, 41, 0]], r2(d0)], gxr = [0, [15, 0], r2(N0)], Fxr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Txr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Oxr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Ixr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Axr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Nxr = r2("Flow_ast.Type.Object.exact"), Cxr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Pxr = [0, [9, 0, 0], r2(An)], Dxr = [0, [17, 0, 0], r2(z)], Lxr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Rxr = r2(GY), jxr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Gxr = [0, [9, 0, 0], r2(An)], Mxr = [0, [17, 0, 0], r2(z)], Bxr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], qxr = r2(H4), Uxr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Hxr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Xxr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Yxr = [0, [17, 0, 0], r2(z)], Vxr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], zxr = r2(Xr), Kxr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Wxr = r2(tr), Jxr = r2(Z0), $xr = r2(nr), Zxr = [0, [17, 0, 0], r2(z)], Qxr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], ror = [0, [15, 0], r2(N0)], eor = r2(Yr), nor = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], tor = r2("Flow_ast.Type.Object.InternalSlot.id"), uor = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ior = [0, [17, 0, 0], r2(z)], xor = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], oor = r2(Bn), aor = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], cor = [0, [17, 0, 0], r2(z)], sor = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], vor = r2(qu), lor = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], bor = [0, [9, 0, 0], r2(An)], por = [0, [17, 0, 0], r2(z)], mor = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], _or = r2(nu), yor = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], hor = [0, [9, 0, 0], r2(An)], dor = [0, [17, 0, 0], r2(z)], kor = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], wor = r2(nU), Eor = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Sor = [0, [9, 0, 0], r2(An)], gor = [0, [17, 0, 0], r2(z)], For = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Tor = r2(Xr), Oor = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ior = r2(tr), Aor = r2(Z0), Nor = r2(nr), Cor = [0, [17, 0, 0], r2(z)], Por = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Dor = [0, [15, 0], r2(N0)], Lor = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Ror = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], jor = [0, [17, 0, [12, 41, 0]], r2(d0)], Gor = [0, [15, 0], r2(N0)], Mor = r2(Yr), Bor = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], qor = r2("Flow_ast.Type.Object.CallProperty.value"), Uor = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Hor = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Xor = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Yor = [0, [17, 0, [12, 41, 0]], r2(d0)], Vor = [0, [17, 0, 0], r2(z)], zor = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Kor = r2(nu), Wor = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Jor = [0, [9, 0, 0], r2(An)], $or = [0, [17, 0, 0], r2(z)], Zor = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Qor = r2(Xr), rar = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ear = r2(tr), nar = r2(Z0), tar = r2(nr), uar = [0, [17, 0, 0], r2(z)], iar = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], far = [0, [15, 0], r2(N0)], xar = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], oar = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], aar = [0, [17, 0, [12, 41, 0]], r2(d0)], car = [0, [15, 0], r2(N0)], sar = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], lar = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], bar = [0, [17, 0, [12, 41, 0]], r2(d0)], par = [0, [15, 0], r2(N0)], mar = r2(Yr), _ar = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], yar = r2("Flow_ast.Type.Object.Indexer.id"), har = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], dar = r2(tr), kar = r2(Z0), war = r2(nr), Ear = [0, [17, 0, 0], r2(z)], Sar = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], gar = r2(ii), Far = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Tar = [0, [17, 0, 0], r2(z)], Oar = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Iar = r2(Bn), Aar = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Nar = [0, [17, 0, 0], r2(z)], Car = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Par = r2(nu), Dar = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Lar = [0, [9, 0, 0], r2(An)], Rar = [0, [17, 0, 0], r2(z)], jar = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Gar = r2(cu), Mar = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Bar = r2(tr), qar = r2(Z0), Uar = r2(nr), Har = [0, [17, 0, 0], r2(z)], Xar = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Yar = r2(Xr), Var = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], zar = r2(tr), Kar = r2(Z0), War = r2(nr), Jar = [0, [17, 0, 0], r2(z)], $ar = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Zar = [0, [15, 0], r2(N0)], Qar = r2(Yr), rcr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], ecr = r2("Flow_ast.Type.Object.SpreadProperty.argument"), ncr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], tcr = [0, [17, 0, 0], r2(z)], ucr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], icr = r2(Xr), fcr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], xcr = r2(tr), ocr = r2(Z0), acr = r2(nr), ccr = [0, [17, 0, 0], r2(z)], scr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], vcr = [0, [15, 0], r2(N0)], lcr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], bcr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], pcr = [0, [17, 0, [12, 41, 0]], r2(d0)], mcr = [0, [15, 0], r2(N0)], _cr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object.Property.Init"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object.Property.Init@ ")], ycr = [0, [17, 0, [12, 41, 0]], r2(d0)], hcr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object.Property.Get"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object.Property.Get@ ")], dcr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], kcr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], wcr = [0, [17, 0, [12, 41, 0]], r2(d0)], Ecr = [0, [17, 0, [12, 41, 0]], r2(d0)], Scr = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Object.Property.Set"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Object.Property.Set@ ")], gcr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Fcr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Tcr = [0, [17, 0, [12, 41, 0]], r2(d0)], Ocr = [0, [17, 0, [12, 41, 0]], r2(d0)], Icr = [0, [15, 0], r2(N0)], Acr = r2(Yr), Ncr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Ccr = r2("Flow_ast.Type.Object.Property.key"), Pcr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Dcr = [0, [17, 0, 0], r2(z)], Lcr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Rcr = r2(Bn), jcr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Gcr = [0, [17, 0, 0], r2(z)], Mcr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Bcr = r2(qu), qcr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ucr = [0, [9, 0, 0], r2(An)], Hcr = [0, [17, 0, 0], r2(z)], Xcr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ycr = r2(nu), Vcr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], zcr = [0, [9, 0, 0], r2(An)], Kcr = [0, [17, 0, 0], r2(z)], Wcr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Jcr = r2(X3), $cr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Zcr = [0, [9, 0, 0], r2(An)], Qcr = [0, [17, 0, 0], r2(z)], rsr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], esr = r2(nU), nsr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], tsr = [0, [9, 0, 0], r2(An)], usr = [0, [17, 0, 0], r2(z)], isr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], fsr = r2(cu), xsr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], osr = r2(tr), asr = r2(Z0), csr = r2(nr), ssr = [0, [17, 0, 0], r2(z)], vsr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], lsr = r2(Xr), bsr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], psr = r2(tr), msr = r2(Z0), _sr = r2(nr), ysr = [0, [17, 0, 0], r2(z)], hsr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], dsr = [0, [15, 0], r2(N0)], ksr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], wsr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Esr = [0, [17, 0, [12, 41, 0]], r2(d0)], Ssr = [0, [15, 0], r2(N0)], gsr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Fsr = r2("Flow_ast.Type.OptionalIndexedAccess.indexed_access"), Tsr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Osr = [0, [17, 0, 0], r2(z)], Isr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Asr = r2(qu), Nsr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Csr = [0, [9, 0, 0], r2(An)], Psr = [0, [17, 0, 0], r2(z)], Dsr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Lsr = [0, [15, 0], r2(N0)], Rsr = r2(Yr), jsr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Gsr = r2("Flow_ast.Type.IndexedAccess._object"), Msr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Bsr = [0, [17, 0, 0], r2(z)], qsr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Usr = r2("index"), Hsr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Xsr = [0, [17, 0, 0], r2(z)], Ysr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Vsr = r2(Xr), zsr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ksr = r2(tr), Wsr = r2(Z0), Jsr = r2(nr), $sr = [0, [17, 0, 0], r2(z)], Zsr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Qsr = [0, [15, 0], r2(N0)], r1r = r2(Yr), e1r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], n1r = r2("Flow_ast.Type.Generic.id"), t1r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], u1r = [0, [17, 0, 0], r2(z)], i1r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], f1r = r2(Z2), x1r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], o1r = r2(tr), a1r = r2(Z0), c1r = r2(nr), s1r = [0, [17, 0, 0], r2(z)], v1r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], l1r = r2(Xr), b1r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], p1r = r2(tr), m1r = r2(Z0), _1r = r2(nr), y1r = [0, [17, 0, 0], r2(z)], h1r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], d1r = [0, [15, 0], r2(N0)], k1r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], w1r = r2("Flow_ast.Type.Generic.Identifier.qualification"), E1r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], S1r = [0, [17, 0, 0], r2(z)], g1r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], F1r = r2(mt), T1r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], O1r = [0, [17, 0, 0], r2(z)], I1r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], A1r = [0, [15, 0], r2(N0)], N1r = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], C1r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], P1r = [0, [17, 0, [12, 41, 0]], r2(d0)], D1r = [0, [15, 0], r2(N0)], L1r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Generic.Identifier.Unqualified"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Generic.Identifier.Unqualified@ ")], R1r = [0, [17, 0, [12, 41, 0]], r2(d0)], j1r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Type.Generic.Identifier.Qualified"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Type.Generic.Identifier.Qualified@ ")], G1r = [0, [17, 0, [12, 41, 0]], r2(d0)], M1r = [0, [15, 0], r2(N0)], B1r = r2(Yr), q1r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], U1r = r2("Flow_ast.Type.Function.tparams"), H1r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], X1r = r2(tr), Y1r = r2(Z0), V1r = r2(nr), z1r = [0, [17, 0, 0], r2(z)], K1r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], W1r = r2(Dt), J1r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], $1r = [0, [17, 0, 0], r2(z)], Z1r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Q1r = r2(Ju), rvr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], evr = [0, [17, 0, 0], r2(z)], nvr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], tvr = r2(Xr), uvr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], ivr = r2(tr), fvr = r2(Z0), xvr = r2(nr), ovr = [0, [17, 0, 0], r2(z)], avr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], cvr = [0, [15, 0], r2(N0)], svr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], vvr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], lvr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], bvr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], pvr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], mvr = r2("Flow_ast.Type.Function.Params.this_"), _vr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], yvr = r2(tr), hvr = r2(Z0), dvr = r2(nr), kvr = [0, [17, 0, 0], r2(z)], wvr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Evr = r2(Dt), Svr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], gvr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], Fvr = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], Tvr = [0, [17, 0, 0], r2(z)], Ovr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ivr = r2(xd), Avr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Nvr = r2(tr), Cvr = r2(Z0), Pvr = r2(nr), Dvr = [0, [17, 0, 0], r2(z)], Lvr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Rvr = r2(Xr), jvr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Gvr = r2(tr), Mvr = r2(Z0), Bvr = r2(nr), qvr = [0, [17, 0, 0], r2(z)], Uvr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Hvr = [0, [15, 0], r2(N0)], Xvr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Yvr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Vvr = [0, [17, 0, [12, 41, 0]], r2(d0)], zvr = [0, [15, 0], r2(N0)], Kvr = r2(Yr), Wvr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Jvr = r2("Flow_ast.Type.Function.ThisParam.annot"), $vr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Zvr = [0, [17, 0, 0], r2(z)], Qvr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], r2r = r2(Xr), e2r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], n2r = r2(tr), t2r = r2(Z0), u2r = r2(nr), i2r = [0, [17, 0, 0], r2(z)], f2r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], x2r = [0, [15, 0], r2(N0)], o2r = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], a2r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], c2r = [0, [17, 0, [12, 41, 0]], r2(d0)], s2r = [0, [15, 0], r2(N0)], v2r = r2(Yr), l2r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], b2r = r2("Flow_ast.Type.Function.RestParam.argument"), p2r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], m2r = [0, [17, 0, 0], r2(z)], _2r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], y2r = r2(Xr), h2r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], d2r = r2(tr), k2r = r2(Z0), w2r = r2(nr), E2r = [0, [17, 0, 0], r2(z)], S2r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], g2r = [0, [15, 0], r2(N0)], F2r = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], T2r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], O2r = [0, [17, 0, [12, 41, 0]], r2(d0)], I2r = [0, [15, 0], r2(N0)], A2r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], N2r = r2("Flow_ast.Type.Function.Param.name"), C2r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], P2r = r2(tr), D2r = r2(Z0), L2r = r2(nr), R2r = [0, [17, 0, 0], r2(z)], j2r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], G2r = r2(Qc), M2r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], B2r = [0, [17, 0, 0], r2(z)], q2r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], U2r = r2(qu), H2r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], X2r = [0, [9, 0, 0], r2(An)], Y2r = [0, [17, 0, 0], r2(z)], V2r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], z2r = [0, [15, 0], r2(N0)], K2r = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], W2r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], J2r = [0, [17, 0, [12, 41, 0]], r2(d0)], $2r = [0, [15, 0], r2(N0)], Z2r = r2(Yr), Q2r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], rlr = r2("Flow_ast.ComputedKey.expression"), elr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], nlr = [0, [17, 0, 0], r2(z)], tlr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ulr = r2(Xr), ilr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], flr = r2(tr), xlr = r2(Z0), olr = r2(nr), alr = [0, [17, 0, 0], r2(z)], clr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], slr = [0, [15, 0], r2(N0)], vlr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], llr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], blr = [0, [17, 0, [12, 41, 0]], r2(d0)], plr = [0, [15, 0], r2(N0)], mlr = r2(Yr), _lr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], ylr = r2("Flow_ast.Variance.kind"), hlr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], dlr = [0, [17, 0, 0], r2(z)], klr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], wlr = r2(Xr), Elr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Slr = r2(tr), glr = r2(Z0), Flr = r2(nr), Tlr = [0, [17, 0, 0], r2(z)], Olr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], Ilr = [0, [15, 0], r2(N0)], Alr = r2("Flow_ast.Variance.Minus"), Nlr = r2("Flow_ast.Variance.Plus"), Clr = [0, [15, 0], r2(N0)], Plr = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], Dlr = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], Llr = [0, [17, 0, [12, 41, 0]], r2(d0)], Rlr = [0, [15, 0], r2(N0)], jlr = r2(Yr), Glr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Mlr = r2("Flow_ast.BooleanLiteral.value"), Blr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], qlr = [0, [9, 0, 0], r2(An)], Ulr = [0, [17, 0, 0], r2(z)], Hlr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Xlr = r2(Xr), Ylr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Vlr = r2(tr), zlr = r2(Z0), Klr = r2(nr), Wlr = [0, [17, 0, 0], r2(z)], Jlr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], $lr = [0, [15, 0], r2(N0)], Zlr = r2(Yr), Qlr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], rbr = r2("Flow_ast.BigIntLiteral.approx_value"), ebr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], nbr = [0, [8, [0, 0, 5], 0, 0, 0], r2(r8)], tbr = [0, [17, 0, 0], r2(z)], ubr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], ibr = r2(x1), fbr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], xbr = [0, [3, 0, 0], r2(Vt)], obr = [0, [17, 0, 0], r2(z)], abr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], cbr = r2(Xr), sbr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], vbr = r2(tr), lbr = r2(Z0), bbr = r2(nr), pbr = [0, [17, 0, 0], r2(z)], mbr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], _br = [0, [15, 0], r2(N0)], ybr = r2(Yr), hbr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], dbr = r2("Flow_ast.NumberLiteral.value"), kbr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], wbr = [0, [8, [0, 0, 5], 0, 0, 0], r2(r8)], Ebr = [0, [17, 0, 0], r2(z)], Sbr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], gbr = r2(c7), Fbr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Tbr = [0, [3, 0, 0], r2(Vt)], Obr = [0, [17, 0, 0], r2(z)], Ibr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Abr = r2(Xr), Nbr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Cbr = r2(tr), Pbr = r2(Z0), Dbr = r2(nr), Lbr = [0, [17, 0, 0], r2(z)], Rbr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], jbr = [0, [15, 0], r2(N0)], Gbr = r2(Yr), Mbr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Bbr = r2("Flow_ast.StringLiteral.value"), qbr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Ubr = [0, [3, 0, 0], r2(Vt)], Hbr = [0, [17, 0, 0], r2(z)], Xbr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Ybr = r2(c7), Vbr = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], zbr = [0, [3, 0, 0], r2(Vt)], Kbr = [0, [17, 0, 0], r2(z)], Wbr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Jbr = r2(Xr), $br = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Zbr = r2(tr), Qbr = r2(Z0), r4r = r2(nr), e4r = [0, [17, 0, 0], r2(z)], n4r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], t4r = [0, [15, 0], r2(N0)], u4r = r2("Flow_ast.Literal.Null"), i4r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Literal.String"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Literal.String@ ")], f4r = [0, [3, 0, 0], r2(Vt)], x4r = [0, [17, 0, [12, 41, 0]], r2(d0)], o4r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Literal.Boolean"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Literal.Boolean@ ")], a4r = [0, [9, 0, 0], r2(An)], c4r = [0, [17, 0, [12, 41, 0]], r2(d0)], s4r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Literal.Number"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Literal.Number@ ")], v4r = [0, [8, [0, 0, 5], 0, 0, 0], r2(r8)], l4r = [0, [17, 0, [12, 41, 0]], r2(d0)], b4r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Literal.BigInt"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Literal.BigInt@ ")], p4r = [0, [8, [0, 0, 5], 0, 0, 0], r2(r8)], m4r = [0, [17, 0, [12, 41, 0]], r2(d0)], _4r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("Flow_ast.Literal.RegExp"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>Flow_ast.Literal.RegExp@ ")], y4r = [0, [17, 0, [12, 41, 0]], r2(d0)], h4r = [0, [15, 0], r2(N0)], d4r = r2(Yr), k4r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], w4r = r2("Flow_ast.Literal.value"), E4r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], S4r = [0, [17, 0, 0], r2(z)], g4r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], F4r = r2(c7), T4r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], O4r = [0, [3, 0, 0], r2(Vt)], I4r = [0, [17, 0, 0], r2(z)], A4r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], N4r = r2(Xr), C4r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], P4r = r2(tr), D4r = r2(Z0), L4r = r2(nr), R4r = [0, [17, 0, 0], r2(z)], j4r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], G4r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], M4r = r2("Flow_ast.Literal.RegExp.pattern"), B4r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], q4r = [0, [3, 0, 0], r2(Vt)], U4r = [0, [17, 0, 0], r2(z)], H4r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], X4r = r2(jX), Y4r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], V4r = [0, [3, 0, 0], r2(Vt)], z4r = [0, [17, 0, 0], r2(z)], K4r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], W4r = [0, [15, 0], r2(N0)], J4r = [0, [15, 0], r2(N0)], $4r = r2(Yr), Z4r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], Q4r = r2("Flow_ast.PrivateName.name"), r8r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], e8r = [0, [3, 0, 0], r2(Vt)], n8r = [0, [17, 0, 0], r2(z)], t8r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], u8r = r2(Xr), i8r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], f8r = r2(tr), x8r = r2(Z0), o8r = r2(nr), a8r = [0, [17, 0, 0], r2(z)], c8r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], s8r = [0, [15, 0], r2(N0)], v8r = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], l8r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], b8r = [0, [17, 0, [12, 41, 0]], r2(d0)], p8r = [0, [15, 0], r2(N0)], m8r = r2(Yr), _8r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], y8r = r2("Flow_ast.Identifier.name"), h8r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], d8r = [0, [3, 0, 0], r2(Vt)], k8r = [0, [17, 0, 0], r2(z)], w8r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], E8r = r2(Xr), S8r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], g8r = r2(tr), F8r = r2(Z0), T8r = r2(nr), O8r = [0, [17, 0, 0], r2(z)], I8r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], A8r = [0, [15, 0], r2(N0)], N8r = [0, [12, 40, [18, [1, [0, 0, r2(C)]], 0]], r2(Zr)], C8r = [0, [12, 44, [17, [0, r2(v), 1, 0], 0]], r2(zr)], P8r = [0, [17, 0, [12, 41, 0]], r2(d0)], D8r = [0, [15, 0], r2(N0)], L8r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], R8r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], j8r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], G8r = r2("Flow_ast.Syntax.leading"), M8r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], B8r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], q8r = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], U8r = [0, [17, 0, 0], r2(z)], H8r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], X8r = r2("trailing"), Y8r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], V8r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, 91, 0]], r2(Ye)], z8r = [0, [17, [0, r2(Ce), 0, 0], [12, 93, [17, 0, 0]]], r2(Xe)], K8r = [0, [17, 0, 0], r2(z)], W8r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], J8r = r2("internal"), $8r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], Z8r = [0, [17, 0, 0], r2(z)], Q8r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], r3r = [0, [0, 0, 0]], e3r = [0, r2(Su), 21, 2], n3r = [0, [0, 0, 0, 0, 0]], t3r = [0, r2(Su), 32, 2], u3r = [0, [0, 0, 0, 0, 0]], i3r = [0, r2(Su), 43, 2], f3r = [0, [0, [0, [0, 0, 0]], 0, 0, 0, 0]], x3r = [0, r2(Su), 70, 2], o3r = [0, [0, 0, 0]], a3r = [0, r2(Su), 80, 2], c3r = [0, [0, 0, 0]], s3r = [0, r2(Su), 90, 2], v3r = [0, [0, 0, 0]], l3r = [0, r2(Su), R7, 2], b3r = [0, [0, 0, 0]], p3r = [0, r2(Su), Xt, 2], m3r = [0, [0, 0, 0, 0, 0, 0, 0]], _3r = [0, r2(Su), br, 2], y3r = [0, [0, 0, 0, 0, 0]], h3r = [0, r2(Su), KH, 2], d3r = [0, [0, [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0, 0, 0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]]]], k3r = [0, r2(Su), 485, 2], w3r = [0, [0, [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0]], E3r = [0, r2(Su), BX, 2], S3r = [0, [0, [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], g3r = [0, r2(Su), 1460, 2], F3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0, 0, 0]], T3r = [0, r2(Su), 1604, 2], O3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], I3r = [0, r2(Su), 1689, 2], A3r = [0, [0, 0, 0, 0, 0, 0, 0]], N3r = [0, r2(Su), 1705, 2], C3r = [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0]], P3r = [0, r2(Su), 1828, 2], D3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], L3r = [0, r2(Su), 1895, 2], R3r = [0, [0, 0, 0, 0, 0]], j3r = [0, r2(Su), 1907, 2], G3r = [0, [0, 0, 0]], M3r = [0, [0, 0, 0, 0, 0]], B3r = [0, [0, 0, 0, 0, 0]], q3r = [0, [0, [0, [0, 0, 0]], 0, 0, 0, 0]], U3r = [0, [0, 0, 0]], H3r = [0, [0, 0, 0]], X3r = [0, [0, 0, 0]], Y3r = [0, [0, 0, 0]], V3r = [0, [0, 0, 0, 0, 0, 0, 0]], z3r = [0, [0, 0, 0, 0, 0]], K3r = [0, [0, [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0, 0, 0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]]]], W3r = [0, [0, [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0]], J3r = [0, [0, [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], $3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0, 0, 0, 0, 0]], Z3r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0]], 0, 0, 0, 0]], Q3r = [0, [0, 0, 0, 0, 0, 0, 0]], r6r = [0, [0, [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0]], e6r = [0, [0, [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], [0, [0, 0, 0, 0, 0]], 0, 0, 0, 0]], n6r = [0, [0, 0, 0, 0, 0]], t6r = [0, 1], u6r = [0, 0], i6r = [0, 2], f6r = [0, 0], x6r = [0, 1], o6r = [0, 1], a6r = [0, 1], c6r = [0, 1], s6r = [0, 1], v6r = [0, 0, 0], l6r = [0, 0, 0], b6r = [0, r2(Eu), r2(Yx), r2(to), r2(Oo), r2(cu), r2(dc), r2(ux), r2(oc), r2(Gf), r2(To), r2(Po), r2(ec), r2(No), r2(wf), r2(Ja), r2(uo), r2(Cx), r2(Ff), r2(ax), r2(Oa), r2(qf), r2(Ro), r2(Ka), r2(Xx), r2(Jx), r2(_x), r2(xo), r2(fa), r2(no), r2(F7), r2(Io), r2(Pf), r2(wo), r2($x), r2(Jf), r2(Uo), r2(yo), r2(D7), r2(yc), r2(Na), r2(Sx), r2(Vx), r2(_f), r2(Sc), r2(Mf), r2(cx), r2(Ju), r2(px), r2(pa), r2(De), r2(r7), r2($a), r2(Yo), r2(wa), r2(Zx), r2(sc), r2(aa), r2(ta), r2(Cf), r2(Bo), r2(Yf), r2(Wf), r2(kc), r2(vc), r2(va), r2(bf), r2(zo), r2(Zf), r2(rx), r2(mi), r2(Qo), r2(Mo), r2(df), r2(Va), r2(Xo), r2(lc), r2(fc), r2(Zo), r2(oo), r2(ix), r2(Nf), r2(uf), r2(Xf), r2(ex), r2(ma), r2(da), r2(Kf), r2(nc), r2(gf), r2(Lx), r2(qo), r2(bx), r2(yf), r2(Of), r2(mc), r2(xr), r2(_c), r2(Wx), r2(Ux), r2(Pa), r2(zx), r2(nx), r2(Dx), r2(ha), r2(Px), r2(hc), r2(vx), r2(Jo), r2(wc), r2(Da), r2(Ko), r2(rc), r2(rf), r2(Nx), r2(ao), r2(Ox), r2(io), r2(jo), r2(Ao), r2(pc), r2(Ax), r2(ff), r2(of), r2(Qf), r2(Wo), r2(ya), r2(ac), r2(Rf), r2(za), r2(ro), r2(ko), r2(af), r2(e7), r2(Aa), r2(Fx), r2(Ca), r2(Hx), r2(bo), r2(Ec), r2(Uu), r2(Ya), r2(ia), r2(pf), r2(yi), r2(Vf), r2(bc), r2(Wa), r2(G7), r2(mx), r2(ba), r2(vf), r2(Ba), r2(kx), r2(Go), r2(_a4), r2(tx), r2(nf), r2(Lf), r2(gc), r2(Ix), r2(hx), r2(Ia), r2(Tc), r2(lo), r2(So), r2(li), r2(ic), r2(yx), r2(La), r2(Xa), r2(Fc), r2(Mx), r2(ka), r2(Bf), r2(Sf), r2(eo), r2(Tx), r2(Nu), r2(ea), r2(ua), r2(Qa), r2(sf), r2(Sa), r2(vo), r2(Af), r2(jx), r2(Za), r2(If), r2(jf), r2(Bx), r2(Ho), r2(qx), r2(sa), r2(ra), r2(la), r2(v7), r2(ho), r2(Ra), r2(wx), r2(Fo), r2(so), r2(na), r2(zf), r2(ja), r2(Ta), r2(xx), r2(I7), r2(N7), r2($o), r2(xa), r2($f), r2(_o), r2(hf), r2(go), r2(fx), r2(gx), r2(Uf), r2(Ga), r2(kf), r2(tf), r2(ga), r2(Df), r2(tc), r2(mf), r2(qa), r2(oa), r2(Ua), r2(Ef), r2(Qi), r2(sx), r2(po), r2(lx), r2(Tf), r2(A7), r2(Ha), r2(Tn), r2(Gx), r2(xf), r2(lf), r2(Kx), r2(Hf), r2(Vo), r2(ca), r2(Ea), r2(co), r2(Rx), r2(W4)], p6r = [0, r2(_f), r2(Qf), r2(_a4), r2(Vf), r2(Tf), r2(Yf), r2(qo), r2(ex), r2(Nx), r2(ko), r2(Ka), r2(D7), r2(Xo), r2(ea), r2(tc), r2(pc), r2(bx), r2(ff), r2(ra), r2(Bx), r2(Yx), r2(li), r2(hc), r2(Lx), r2(Wa), r2(sa), r2(Of), r2(yi), r2(Oo), r2(Mx), r2(ta), r2(zf), r2(sx), r2(tx), r2(Qi), r2(jo), r2(Af), r2(ba), r2(vc), r2(ic), r2(yo), r2(Kx), r2(ma), r2(ia), r2(Sx), r2(la), r2(Px), r2(yf), r2(tf), r2(go), r2(Qo), r2(wa), r2(Xf), r2(Yo), r2(Ko), r2(Uf), r2(fc), r2(r7), r2(Nf), r2(Ba), r2(mc), r2(ao), r2(Ao), r2(bc), r2(nx), r2($o), r2(Jx), r2(If), r2(uf), r2(rc), r2($f), r2(Dx), r2(Go), r2(aa), r2(Ea), r2(so), r2(Sa), r2(Wx), r2(rx), r2(co), r2(po), r2(cx), r2(cu), r2($a), r2(uo), r2(Ya), r2(lf), r2(So), r2(no), r2(ac), r2(Df), r2(nc), r2(Uo), r2(v7), r2(Xa), r2(Xx), r2(Eu), r2(fa), r2(Ta), r2(ec), r2(zo), r2(px), r2(Po), r2(hf), r2(ja), r2(oc), r2(Ax), r2(Zx), r2(ro), r2(Ho), r2(Sf), r2(lc), r2(ua), r2(ha), r2(bf), r2(ka), r2(Ff), r2(xo), r2(dc), r2(Sc), r2(Cx), r2(To), r2(Ga), r2(yx), r2(fx), r2(Pa), r2(kx), r2(Gf), r2(_o), r2(gf), r2(Jo), r2(Hf), r2(Ux), r2(oa), r2(ga), r2(Aa), r2(va), r2(Mo), r2(wc), r2(_c), r2(Uu), r2(Ju), r2(Ha), r2(Ja), r2(ax), r2(yc), r2(kc), r2(F7), r2(I7), r2(pf), r2(Va), r2(Tx), r2(of), r2(mi), r2(Ix), r2(qx), r2(Fx), r2(gx), r2(nf), r2(zx), r2(Wo), r2(G7), r2(vf), r2(wf), r2(jf), r2(De), r2(Tc), r2(bo), r2(Za), r2(sf), r2(Kf), r2(Mf), r2(Ca), r2(oo), r2(Cf), r2(_x), r2(ix), r2(Oa), r2(lx), r2(Fo), r2(Ua), r2(na), r2(Gx), r2(Rf), r2(Jf), r2(mx), r2(pa), r2(Ec), r2(qa), r2(da), r2(io), r2(kf), r2(af), r2(ho), r2(Ro), r2(Rx), r2(ux), r2(Ef), r2(qf), r2(Ra), r2(Ox), r2(ya), r2(xa), r2(vx), r2(Bo), r2(za), r2(Bf), r2(Da), r2(wo), r2(Vo), r2(Wf), r2(xf), r2(Nu), r2(Zf), r2(eo), r2(hx), r2(Ia), r2(Vx), r2(N7), r2(Lf), r2(sc), r2(vo), r2(wx), r2(Pf), r2($x), r2(Na), r2(lo), r2(Qa), r2(No), r2(La), r2(df), r2(Tn), r2(Hx), r2(mf), r2(rf), r2(Zo), r2(gc), r2(xx), r2(jx), r2(A7), r2(ca), r2(e7), r2(to), r2(Fc), r2(Io), r2(xr)], m6r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("File_key.LibFile"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>File_key.LibFile@ ")], _6r = [0, [3, 0, 0], r2(Vt)], y6r = [0, [17, 0, [12, 41, 0]], r2(d0)], h6r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("File_key.SourceFile"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>File_key.SourceFile@ ")], d6r = [0, [3, 0, 0], r2(Vt)], k6r = [0, [17, 0, [12, 41, 0]], r2(d0)], w6r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("File_key.JsonFile"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>File_key.JsonFile@ ")], E6r = [0, [3, 0, 0], r2(Vt)], S6r = [0, [17, 0, [12, 41, 0]], r2(d0)], g6r = [0, [12, 40, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2("File_key.ResourceFile"), [17, [0, r2(v), 1, 0], 0]]]], r2("(@[<2>File_key.ResourceFile@ ")], F6r = [0, [3, 0, 0], r2(Vt)], T6r = [0, [17, 0, [12, 41, 0]], r2(d0)], O6r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], I6r = r2("Loc.line"), A6r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], N6r = [0, [4, 0, 0, 0, 0], r2(N2)], C6r = [0, [17, 0, 0], r2(z)], P6r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], D6r = r2(I2), L6r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], R6r = [0, [4, 0, 0, 0, 0], r2(N2)], j6r = [0, [17, 0, 0], r2(z)], G6r = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], M6r = [0, [15, 0], r2(N0)], B6r = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [11, r2(kr), 0]], r2(dr)], q6r = r2("Loc.source"), U6r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], H6r = r2(tr), X6r = r2(Z0), Y6r = r2(nr), V6r = [0, [17, 0, 0], r2(z)], z6r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], K6r = r2(g7), W6r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], J6r = [0, [17, 0, 0], r2(z)], $6r = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Z6r = r2("_end"), Q6r = [0, [18, [1, [0, 0, r2(C)]], [2, 0, [11, r2(J), [17, [0, r2(v), 1, 0], 0]]]], r2(W)], rpr = [0, [17, 0, 0], r2(z)], epr = [0, [17, [0, r2(v), 1, 0], [12, br, [17, 0, 0]]], r2(wr)], npr = [0, r2(Rx), r2(co), r2(Ea), r2(ca), r2(Vo), r2(Hf), r2(Kx), r2(lf), r2(xf), r2(Gx), r2(Tn), r2(Ha), r2(A7), r2(Tf), r2(lx), r2(po), r2(sx), r2(Qi), r2(Ef), r2(Ua), r2(oa), r2(qa), r2(mf), r2(tc), r2(Df), r2(ga), r2(tf), r2(kf), r2(Ga), r2(Uf), r2(gx), r2(fx), r2(go), r2(hf), r2(_o), r2($f), r2(xa), r2($o), r2(N7), r2(I7), r2(xx), r2(Ta), r2(ja), r2(zf), r2(na), r2(so), r2(Fo), r2(wx), r2(Ra), r2(ho), r2(v7), r2(la), r2(ra), r2(sa), r2(qx), r2(Ho), r2(Bx), r2(jf), r2(If), r2(Za), r2(jx), r2(Af), r2(vo), r2(Sa), r2(sf), r2(Qa), r2(ua), r2(ea), r2(Nu), r2(Tx), r2(eo), r2(Sf), r2(Bf), r2(ka), r2(Mx), r2(Fc), r2(Xa), r2(La), r2(yx), r2(ic), r2(li), r2(So), r2(lo), r2(Tc), r2(Ia), r2(hx), r2(Ix), r2(gc), r2(Lf), r2(nf), r2(tx), r2(_a4), r2(Go), r2(kx), r2(Ba), r2(vf), r2(ba), r2(mx), r2(G7), r2(Wa), r2(bc), r2(Vf), r2(yi), r2(pf), r2(ia), r2(Ya), r2(Uu), r2(Ec), r2(bo), r2(Hx), r2(Ca), r2(Fx), r2(Aa), r2(e7), r2(af), r2(ko), r2(ro), r2(za), r2(Rf), r2(ac), r2(ya), r2(Wo), r2(Qf), r2(of), r2(ff), r2(Ax), r2(pc), r2(Ao), r2(jo), r2(io), r2(Ox), r2(ao), r2(Nx), r2(rf), r2(rc), r2(Ko), r2(Da), r2(wc), r2(Jo), r2(vx), r2(hc), r2(Px), r2(ha), r2(Dx), r2(nx), r2(zx), r2(Pa), r2(Ux), r2(Wx), r2(_c), r2(xr), r2(mc), r2(Of), r2(yf), r2(bx), r2(qo), r2(Lx), r2(gf), r2(nc), r2(Kf), r2(da), r2(ma), r2(ex), r2(Xf), r2(uf), r2(Nf), r2(ix), r2(oo), r2(Zo), r2(fc), r2(lc), r2(Xo), r2(Va), r2(df), r2(Mo), r2(Qo), r2(mi), r2(rx), r2(Zf), r2(zo), r2(bf), r2(va), r2(vc), r2(kc), r2(Wf), r2(Yf), r2(Bo), r2(Cf), r2(ta), r2(aa), r2(sc), r2(Zx), r2(wa), r2(Yo), r2($a), r2(r7), r2(De), r2(pa), r2(px), r2(Ju), r2(cx), r2(Mf), r2(Sc), r2(_f), r2(Vx), r2(Sx), r2(Na), r2(yc), r2(D7), r2(yo), r2(Uo), r2(Jf), r2($x), r2(wo), r2(Pf), r2(Io), r2(F7), r2(no), r2(fa), r2(xo), r2(_x), r2(Jx), r2(Xx), r2(Ka), r2(Ro), r2(qf), r2(Oa), r2(ax), r2(Ff), r2(Cx), r2(uo), r2(Ja), r2(wf), r2(No), r2(ec), r2(Po), r2(To), r2(Gf), r2(oc), r2(ux), r2(dc), r2(cu), r2(Oo), r2(to), r2(Yx), r2(Eu)], tpr = [0, r2(Eu), r2(Yx), r2(to), r2(Oo), r2(cu), r2(dc), r2(ux), r2(oc), r2(Gf), r2(To), r2(Po), r2(ec), r2(No), r2(wf), r2(Ja), r2(uo), r2(Cx), r2(Ff), r2(ax), r2(Oa), r2(qf), r2(Ro), r2(Ka), r2(Xx), r2(Jx), r2(_x), r2(xo), r2(fa), r2(no), r2(F7), r2(Io), r2(Pf), r2(wo), r2($x), r2(Jf), r2(Uo), r2(yo), r2(D7), r2(yc), r2(Na), r2(Sx), r2(Vx), r2(_f), r2(Sc), r2(Mf), r2(cx), r2(Ju), r2(px), r2(pa), r2(De), r2(r7), r2($a), r2(Yo), r2(wa), r2(Zx), r2(sc), r2(aa), r2(ta), r2(Cf), r2(Bo), r2(Yf), r2(Wf), r2(kc), r2(vc), r2(va), r2(bf), r2(zo), r2(Zf), r2(rx), r2(mi), r2(Qo), r2(Mo), r2(df), r2(Va), r2(Xo), r2(lc), r2(fc), r2(Zo), r2(oo), r2(ix), r2(Nf), r2(uf), r2(Xf), r2(ex), r2(ma), r2(da), r2(Kf), r2(nc), r2(gf), r2(Lx), r2(qo), r2(bx), r2(yf), r2(Of), r2(mc), r2(xr), r2(_c), r2(Wx), r2(Ux), r2(Pa), r2(zx), r2(nx), r2(Dx), r2(ha), r2(Px), r2(hc), r2(vx), r2(Jo), r2(wc), r2(Da), r2(Ko), r2(rc), r2(rf), r2(Nx), r2(ao), r2(Ox), r2(io), r2(jo), r2(Ao), r2(pc), r2(Ax), r2(ff), r2(of), r2(Qf), r2(Wo), r2(ya), r2(ac), r2(Rf), r2(za), r2(ro), r2(ko), r2(af), r2(e7), r2(Aa), r2(Fx), r2(Ca), r2(Hx), r2(bo), r2(Ec), r2(Uu), r2(Ya), r2(ia), r2(pf), r2(yi), r2(Vf), r2(bc), r2(Wa), r2(G7), r2(mx), r2(ba), r2(vf), r2(Ba), r2(kx), r2(Go), r2(_a4), r2(tx), r2(nf), r2(Lf), r2(gc), r2(Ix), r2(hx), r2(Ia), r2(Tc), r2(lo), r2(So), r2(li), r2(ic), r2(yx), r2(La), r2(Xa), r2(Fc), r2(Mx), r2(ka), r2(Bf), r2(Sf), r2(eo), r2(Tx), r2(Nu), r2(ea), r2(ua), r2(Qa), r2(sf), r2(Sa), r2(vo), r2(Af), r2(jx), r2(Za), r2(If), r2(jf), r2(Bx), r2(Ho), r2(qx), r2(sa), r2(ra), r2(la), r2(v7), r2(ho), r2(Ra), r2(wx), r2(Fo), r2(so), r2(na), r2(zf), r2(ja), r2(Ta), r2(xx), r2(I7), r2(N7), r2($o), r2(xa), r2($f), r2(_o), r2(hf), r2(go), r2(fx), r2(gx), r2(Uf), r2(Ga), r2(kf), r2(tf), r2(ga), r2(Df), r2(tc), r2(mf), r2(qa), r2(oa), r2(Ua), r2(Ef), r2(Qi), r2(sx), r2(po), r2(lx), r2(Tf), r2(A7), r2(Ha), r2(Tn), r2(Gx), r2(xf), r2(lf), r2(Kx), r2(Hf), r2(Vo), r2(ca), r2(Ea), r2(co), r2(Rx), r2(W4)], upr = [0, r2(_f), r2(Qf), r2(_a4), r2(Vf), r2(Tf), r2(Yf), r2(qo), r2(ex), r2(Nx), r2(ko), r2(Ka), r2(D7), r2(Xo), r2(ea), r2(tc), r2(pc), r2(bx), r2(ff), r2(ra), r2(Bx), r2(Yx), r2(li), r2(hc), r2(Lx), r2(Wa), r2(sa), r2(Of), r2(yi), r2(Oo), r2(Mx), r2(ta), r2(zf), r2(sx), r2(tx), r2(Qi), r2(jo), r2(Af), r2(ba), r2(vc), r2(ic), r2(yo), r2(Kx), r2(ma), r2(ia), r2(Sx), r2(la), r2(Px), r2(yf), r2(tf), r2(go), r2(Qo), r2(wa), r2(Xf), r2(Yo), r2(Ko), r2(Uf), r2(fc), r2(r7), r2(Nf), r2(Ba), r2(mc), r2(ao), r2(Ao), r2(bc), r2(nx), r2($o), r2(Jx), r2(If), r2(uf), r2(rc), r2($f), r2(Dx), r2(Go), r2(aa), r2(Ea), r2(so), r2(Sa), r2(Wx), r2(rx), r2(co), r2(po), r2(cx), r2(cu), r2($a), r2(uo), r2(Ya), r2(lf), r2(So), r2(no), r2(ac), r2(Df), r2(nc), r2(Uo), r2(v7), r2(Xa), r2(Xx), r2(Eu), r2(fa), r2(Ta), r2(ec), r2(zo), r2(px), r2(Po), r2(hf), r2(ja), r2(oc), r2(Ax), r2(Zx), r2(ro), r2(Ho), r2(Sf), r2(lc), r2(ua), r2(ha), r2(bf), r2(ka), r2(Ff), r2(xo), r2(dc), r2(Sc), r2(Cx), r2(To), r2(Ga), r2(yx), r2(fx), r2(Pa), r2(kx), r2(Gf), r2(_o), r2(gf), r2(Jo), r2(Hf), r2(Ux), r2(oa), r2(ga), r2(Aa), r2(va), r2(Mo), r2(wc), r2(_c), r2(Uu), r2(Ju), r2(Ha), r2(Ja), r2(ax), r2(yc), r2(kc), r2(F7), r2(I7), r2(pf), r2(Va), r2(Tx), r2(of), r2(mi), r2(Ix), r2(qx), r2(Fx), r2(gx), r2(nf), r2(zx), r2(Wo), r2(G7), r2(vf), r2(wf), r2(jf), r2(De), r2(Tc), r2(bo), r2(Za), r2(sf), r2(Kf), r2(Mf), r2(Ca), r2(oo), r2(Cf), r2(_x), r2(ix), r2(Oa), r2(lx), r2(Fo), r2(Ua), r2(na), r2(Gx), r2(Rf), r2(Jf), r2(mx), r2(pa), r2(Ec), r2(qa), r2(da), r2(io), r2(kf), r2(af), r2(ho), r2(Ro), r2(Rx), r2(ux), r2(Ef), r2(qf), r2(Ra), r2(Ox), r2(ya), r2(xa), r2(vx), r2(Bo), r2(za), r2(Bf), r2(Da), r2(wo), r2(Vo), r2(Wf), r2(xf), r2(Nu), r2(Zf), r2(eo), r2(hx), r2(Ia), r2(Vx), r2(N7), r2(Lf), r2(sc), r2(vo), r2(wx), r2(Pf), r2($x), r2(Na), r2(lo), r2(Qa), r2(No), r2(La), r2(df), r2(Tn), r2(Hx), r2(mf), r2(rf), r2(Zo), r2(gc), r2(xx), r2(jx), r2(A7), r2(ca), r2(e7), r2(to), r2(Fc), r2(Io), r2(xr)], ipr = r2(lV), fpr = r2(jY), xpr = r2(PX), opr = r2(zY), apr = r2(S3), cpr = r2(ZH), spr = r2(cv), vpr = r2(OU), lpr = r2(vY), bpr = r2(_X), ppr = r2(sX), mpr = r2(xs), _pr = r2(Fa), ypr = r2(UU), hpr = r2(WH), dpr = r2(Qu), kpr = r2(XY), wpr = r2(OH), Epr = r2(I6), Spr = r2(jd), gpr = r2(R2), Fpr = r2(j2), Tpr = r2(WU), Opr = r2(BU), Ipr = r2(nY), Apr = r2(xX), Npr = r2(lH), Cpr = r2(hX), Ppr = r2(xU), Dpr = r2(zX), Lpr = r2(aX), Rpr = r2(bH), jpr = r2(wH), Gpr = r2(XH), Mpr = r2(rV), Bpr = r2(AU), qpr = r2(tX), Upr = r2("Set.remove_min_elt"), Hpr = [0, [12, 59, [17, [0, r2(v), 1, 0], 0]], r2(a0)], Xpr = [0, [18, [1, [0, [11, r2(h2), 0], r2(h2)]], [12, ts, 0]], r2("@[<2>{")], Ypr = [0, [12, 32, 0], r2(pi)], Vpr = [0, [12, 32, 0], r2(pi)], zpr = [0, [17, [0, r2(Ce), 0, 0], [12, br, [17, 0, 0]]], r2("@,}@]")], Kpr = [0, r2("src/hack_forked/utils/collections/flow_set.ml"), 363, 14], Wpr = [0, [0, 36, 37], [0, 48, 58], [0, 65, 91], [0, 95, 96], [0, 97, ts], [0, qg, pg], [0, Ai, Yg], [0, lS, hk], [0, md, nw], [0, rt, xT], [0, y6, Dw], [0, wt, 706], [0, rX, 722], [0, 736, 741], [0, 748, 749], [0, 750, 751], [0, 768, 885], [0, 886, 888], [0, 890, 894], [0, 895, 896], [0, 902, 907], [0, 908, ZX], [0, 910, 930], [0, UX, 1014], [0, 1015, 1154], [0, 1155, 1160], [0, 1162, CU], [0, 1329, 1367], [0, 1369, 1370], [0, 1376, 1417], [0, 1425, 1470], [0, 1471, 1472], [0, 1473, 1475], [0, 1476, 1478], [0, 1479, 1480], [0, 1488, 1515], [0, 1519, 1523], [0, 1552, 1563], [0, 1568, 1642], [0, 1646, 1748], [0, 1749, 1757], [0, 1759, 1769], [0, 1770, 1789], [0, 1791, 1792], [0, 1808, 1867], [0, 1869, 1970], [0, 1984, 2038], [0, 2042, 2043], [0, 2045, 2046], [0, Hh, 2094], [0, 2112, 2140], [0, 2144, 2155], [0, 2208, 2229], [0, 2230, 2238], [0, 2259, 2274], [0, 2275, 2404], [0, 2406, 2416], [0, 2417, 2436], [0, 2437, 2445], [0, 2447, 2449], [0, 2451, 2473], [0, 2474, 2481], [0, 2482, 2483], [0, 2486, 2490], [0, 2492, 2501], [0, 2503, 2505], [0, 2507, 2511], [0, 2519, 2520], [0, 2524, 2526], [0, 2527, 2532], [0, 2534, 2546], [0, 2556, 2557], [0, 2558, 2559], [0, 2561, 2564], [0, 2565, 2571], [0, 2575, 2577], [0, 2579, 2601], [0, 2602, 2609], [0, 2610, 2612], [0, 2613, 2615], [0, 2616, 2618], [0, 2620, 2621], [0, 2622, 2627], [0, 2631, 2633], [0, 2635, 2638], [0, 2641, 2642], [0, 2649, 2653], [0, 2654, 2655], [0, 2662, 2678], [0, 2689, 2692], [0, 2693, 2702], [0, 2703, 2706], [0, 2707, 2729], [0, 2730, 2737], [0, 2738, 2740], [0, 2741, 2746], [0, 2748, 2758], [0, 2759, 2762], [0, 2763, 2766], [0, 2768, 2769], [0, 2784, 2788], [0, 2790, 2800], [0, 2809, 2816], [0, 2817, 2820], [0, 2821, 2829], [0, 2831, 2833], [0, 2835, 2857], [0, 2858, 2865], [0, 2866, 2868], [0, 2869, 2874], [0, 2876, 2885], [0, 2887, 2889], [0, 2891, 2894], [0, 2902, 2904], [0, 2908, 2910], [0, 2911, 2916], [0, 2918, 2928], [0, 2929, 2930], [0, 2946, 2948], [0, 2949, 2955], [0, 2958, 2961], [0, 2962, 2966], [0, 2969, 2971], [0, 2972, 2973], [0, 2974, 2976], [0, 2979, 2981], [0, 2984, 2987], [0, 2990, 3002], [0, 3006, 3011], [0, 3014, 3017], [0, 3018, 3022], [0, 3024, 3025], [0, 3031, 3032], [0, 3046, 3056], [0, 3072, 3085], [0, 3086, 3089], [0, 3090, 3113], [0, 3114, 3130], [0, 3133, 3141], [0, 3142, 3145], [0, 3146, 3150], [0, 3157, 3159], [0, 3160, 3163], [0, 3168, 3172], [0, 3174, 3184], [0, 3200, 3204], [0, 3205, 3213], [0, 3214, 3217], [0, 3218, 3241], [0, 3242, 3252], [0, 3253, 3258], [0, 3260, 3269], [0, 3270, 3273], [0, 3274, 3278], [0, 3285, 3287], [0, 3294, 3295], [0, 3296, 3300], [0, 3302, 3312], [0, 3313, 3315], [0, 3328, 3332], [0, 3333, 3341], [0, 3342, 3345], [0, 3346, 3397], [0, 3398, 3401], [0, 3402, 3407], [0, 3412, 3416], [0, 3423, 3428], [0, 3430, 3440], [0, 3450, 3456], [0, 3458, 3460], [0, 3461, 3479], [0, 3482, 3506], [0, 3507, 3516], [0, 3517, 3518], [0, 3520, 3527], [0, 3530, 3531], [0, 3535, 3541], [0, 3542, 3543], [0, 3544, 3552], [0, 3558, 3568], [0, 3570, 3572], [0, 3585, 3643], [0, 3648, 3663], [0, 3664, 3674], [0, 3713, 3715], [0, 3716, 3717], [0, 3718, 3723], [0, 3724, 3748], [0, 3749, 3750], [0, 3751, 3774], [0, 3776, 3781], [0, 3782, 3783], [0, 3784, 3790], [0, 3792, 3802], [0, 3804, 3808], [0, 3840, 3841], [0, 3864, 3866], [0, 3872, 3882], [0, 3893, 3894], [0, 3895, 3896], [0, 3897, 3898], [0, 3902, 3912], [0, 3913, 3949], [0, 3953, 3973], [0, 3974, 3992], [0, 3993, 4029], [0, 4038, 4039], [0, vX, 4170], [0, 4176, 4254], [0, 4256, 4294], [0, 4295, 4296], [0, 4301, 4302], [0, 4304, 4347], [0, 4348, 4681], [0, 4682, 4686], [0, 4688, 4695], [0, 4696, 4697], [0, 4698, 4702], [0, 4704, 4745], [0, 4746, 4750], [0, 4752, 4785], [0, 4786, 4790], [0, 4792, 4799], [0, 4800, 4801], [0, 4802, 4806], [0, 4808, 4823], [0, 4824, 4881], [0, 4882, 4886], [0, 4888, 4955], [0, 4957, 4960], [0, 4969, 4978], [0, 4992, 5008], [0, 5024, 5110], [0, 5112, 5118], [0, 5121, 5741], [0, 5743, Ev], [0, 5761, 5787], [0, 5792, 5867], [0, 5870, 5881], [0, 5888, 5901], [0, 5902, 5909], [0, 5920, 5941], [0, 5952, 5972], [0, 5984, 5997], [0, 5998, 6001], [0, 6002, 6004], [0, 6016, 6100], [0, 6103, 6104], [0, 6108, 6110], [0, 6112, 6122], [0, 6155, 6158], [0, 6160, 6170], [0, 6176, 6265], [0, 6272, 6315], [0, 6320, 6390], [0, 6400, 6431], [0, 6432, 6444], [0, 6448, 6460], [0, 6470, 6510], [0, 6512, 6517], [0, 6528, 6572], [0, 6576, 6602], [0, 6608, 6619], [0, 6656, 6684], [0, 6688, 6751], [0, 6752, 6781], [0, 6783, 6794], [0, 6800, 6810], [0, 6823, 6824], [0, 6832, 6846], [0, 6912, 6988], [0, 6992, 7002], [0, 7019, 7028], [0, 7040, 7156], [0, 7168, 7224], [0, 7232, 7242], [0, 7245, 7294], [0, 7296, 7305], [0, 7312, 7355], [0, 7357, 7360], [0, 7376, 7379], [0, 7380, 7419], [0, 7424, 7674], [0, 7675, 7958], [0, 7960, 7966], [0, 7968, 8006], [0, 8008, 8014], [0, 8016, 8024], [0, 8025, 8026], [0, 8027, 8028], [0, 8029, 8030], [0, 8031, 8062], [0, 8064, 8117], [0, 8118, 8125], [0, 8126, 8127], [0, 8130, 8133], [0, 8134, 8141], [0, 8144, 8148], [0, 8150, 8156], [0, 8160, 8173], [0, 8178, 8181], [0, 8182, 8189], [0, kY, vU], [0, 8255, 8257], [0, 8276, 8277], [0, ep, 8306], [0, O3, 8320], [0, 8336, 8349], [0, 8400, 8413], [0, 8417, 8418], [0, 8421, 8433], [0, x3, 8451], [0, R3, 8456], [0, 8458, g4], [0, m6, 8470], [0, iU, 8478], [0, t8, $3], [0, Q8, sp], [0, P8, N8], [0, 8490, 8506], [0, 8508, 8512], [0, 8517, 8522], [0, s8, 8527], [0, 8544, 8585], [0, 11264, 11311], [0, 11312, 11359], [0, 11360, 11493], [0, 11499, 11508], [0, 11520, G4], [0, B8, 11560], [0, N3, 11566], [0, 11568, 11624], [0, p4, 11632], [0, P6, 11671], [0, 11680, j4], [0, 11688, z8], [0, 11696, o8], [0, 11704, K8], [0, 11712, z6], [0, 11720, j8], [0, 11728, F6], [0, 11736, 11743], [0, 11744, 11776], [0, 12293, 12296], [0, 12321, T3], [0, 12337, 12342], [0, 12344, 12349], [0, 12353, 12439], [0, 12441, E3], [0, 12449, q4], [0, 12540, 12544], [0, 12549, E8], [0, 12593, 12687], [0, 12704, 12731], [0, 12784, 12800], [0, 13312, 19894], [0, 19968, 40944], [0, 40960, 42125], [0, 42192, 42238], [0, 42240, 42509], [0, 42512, 42540], [0, 42560, 42608], [0, 42612, U3], [0, 42623, 42738], [0, 42775, 42784], [0, 42786, 42889], [0, 42891, 42944], [0, 42946, 42951], [0, F8, 43048], [0, 43072, 43124], [0, 43136, 43206], [0, 43216, 43226], [0, 43232, 43256], [0, n3, _8], [0, 43261, 43310], [0, 43312, 43348], [0, 43360, 43389], [0, 43392, 43457], [0, k8, 43482], [0, 43488, v6], [0, 43520, 43575], [0, 43584, 43598], [0, 43600, 43610], [0, 43616, 43639], [0, lp, 43715], [0, 43739, 43742], [0, 43744, 43760], [0, 43762, 43767], [0, 43777, 43783], [0, 43785, 43791], [0, 43793, 43799], [0, 43808, k6], [0, 43816, H3], [0, 43824, av], [0, 43868, o3], [0, 43888, 44011], [0, 44012, 44014], [0, 44016, 44026], [0, 44032, 55204], [0, 55216, 55239], [0, 55243, 55292], [0, 63744, 64110], [0, 64112, 64218], [0, 64256, 64263], [0, 64275, 64280], [0, e3, ip], [0, 64298, Qn], [0, 64312, z3], [0, L6, R4], [0, 64320, q3], [0, 64323, D8], [0, 64326, 64434], [0, 64467, 64830], [0, 64848, 64912], [0, 64914, 64968], [0, 65008, 65020], [0, 65024, 65040], [0, 65056, 65072], [0, 65075, 65077], [0, 65101, 65104], [0, 65136, t3], [0, 65142, 65277], [0, 65296, 65306], [0, 65313, 65339], [0, 65343, Q4], [0, 65345, 65371], [0, 65382, 65471], [0, 65474, 65480], [0, 65482, 65488], [0, 65490, 65496], [0, 65498, 65501], [0, fw, rp], [0, 65549, $8], [0, 65576, z4], [0, 65596, S6], [0, 65599, 65614], [0, 65616, 65630], [0, 65664, 65787], [0, 65856, 65909], [0, 66045, 66046], [0, 66176, 66205], [0, 66208, 66257], [0, 66272, 66273], [0, 66304, 66336], [0, 66349, 66379], [0, 66384, 66427], [0, 66432, 66462], [0, 66464, 66500], [0, 66504, Z3], [0, 66513, 66518], [0, 66560, 66718], [0, 66720, 66730], [0, 66736, 66772], [0, 66776, 66812], [0, 66816, 66856], [0, 66864, 66916], [0, 67072, 67383], [0, 67392, 67414], [0, 67424, 67432], [0, 67584, 67590], [0, op, J4], [0, 67594, p8], [0, 67639, 67641], [0, M6, 67645], [0, 67647, 67670], [0, 67680, 67703], [0, 67712, 67743], [0, 67808, X8], [0, 67828, 67830], [0, 67840, 67862], [0, 67872, 67898], [0, 67968, 68024], [0, 68030, 68032], [0, S7, 68100], [0, 68101, 68103], [0, 68108, b4], [0, 68117, Z8], [0, 68121, 68150], [0, 68152, 68155], [0, 68159, 68160], [0, 68192, 68221], [0, 68224, 68253], [0, 68288, J6], [0, 68297, 68327], [0, 68352, 68406], [0, 68416, 68438], [0, 68448, 68467], [0, 68480, 68498], [0, 68608, 68681], [0, 68736, 68787], [0, 68800, 68851], [0, 68864, 68904], [0, 68912, 68922], [0, 69376, 69405], [0, J8, 69416], [0, 69424, 69457], [0, 69600, 69623], [0, 69632, 69703], [0, 69734, B3], [0, 69759, 69819], [0, 69840, 69865], [0, 69872, 69882], [0, 69888, 69941], [0, 69942, 69952], [0, m4, F3], [0, 69968, 70004], [0, X6, 70007], [0, 70016, 70085], [0, 70089, 70093], [0, 70096, h8], [0, i3, 70109], [0, 70144, A8], [0, 70163, 70200], [0, 70206, 70207], [0, 70272, y3], [0, I8, fp], [0, 70282, O8], [0, 70287, c8], [0, 70303, 70313], [0, 70320, 70379], [0, 70384, 70394], [0, 70400, u6], [0, 70405, 70413], [0, 70415, 70417], [0, 70419, f3], [0, 70442, a8], [0, 70450, C4], [0, 70453, 70458], [0, 70459, 70469], [0, 70471, 70473], [0, 70475, 70478], [0, j6, 70481], [0, 70487, 70488], [0, 70493, 70500], [0, 70502, 70509], [0, 70512, 70517], [0, 70656, 70731], [0, 70736, 70746], [0, W6, 70752], [0, 70784, Q3], [0, Z6, 70856], [0, 70864, 70874], [0, 71040, 71094], [0, 71096, 71105], [0, 71128, 71134], [0, 71168, 71233], [0, u8, 71237], [0, 71248, 71258], [0, 71296, 71353], [0, 71360, 71370], [0, 71424, 71451], [0, 71453, 71468], [0, 71472, 71482], [0, 71680, 71739], [0, 71840, 71914], [0, 71935, 71936], [0, 72096, 72104], [0, 72106, 72152], [0, 72154, up], [0, p3, 72165], [0, M8, 72255], [0, 72263, 72264], [0, u3, 72346], [0, P4, 72350], [0, 72384, 72441], [0, 72704, W3], [0, 72714, 72759], [0, 72760, 72769], [0, 72784, 72794], [0, 72818, 72848], [0, 72850, 72872], [0, 72873, 72887], [0, 72960, D3], [0, 72968, h4], [0, 72971, 73015], [0, 73018, 73019], [0, 73020, 73022], [0, 73023, 73032], [0, 73040, 73050], [0, 73056, R6], [0, 73063, h3], [0, 73066, 73103], [0, 73104, 73106], [0, 73107, 73113], [0, 73120, 73130], [0, 73440, 73463], [0, 73728, 74650], [0, 74752, 74863], [0, 74880, 75076], [0, 77824, 78895], [0, 82944, 83527], [0, 92160, 92729], [0, 92736, 92767], [0, 92768, 92778], [0, 92880, 92910], [0, 92912, 92917], [0, 92928, 92983], [0, 92992, 92996], [0, 93008, 93018], [0, 93027, 93048], [0, 93053, 93072], [0, 93760, 93824], [0, 93952, 94027], [0, Z4, 94088], [0, 94095, 94112], [0, 94176, b6], [0, h6, 94180], [0, 94208, 100344], [0, 100352, 101107], [0, 110592, 110879], [0, 110928, 110931], [0, 110948, 110952], [0, 110960, 111356], [0, 113664, 113771], [0, 113776, 113789], [0, 113792, 113801], [0, 113808, 113818], [0, 113821, 113823], [0, 119141, 119146], [0, 119149, 119155], [0, 119163, 119171], [0, 119173, 119180], [0, 119210, 119214], [0, 119362, 119365], [0, 119808, T6], [0, 119894, M3], [0, 119966, 119968], [0, d3, 119971], [0, 119973, 119975], [0, 119977, Q6], [0, 119982, l8], [0, l4, G6], [0, 119997, I3], [0, 120005, L4], [0, 120071, 120075], [0, 120077, N6], [0, 120086, vp], [0, 120094, C3], [0, 120123, r6], [0, 120128, B4], [0, G3, 120135], [0, 120138, D6], [0, 120146, 120486], [0, 120488, D4], [0, 120514, V3], [0, 120540, c6], [0, 120572, X4], [0, 120598, c3], [0, 120630, V4], [0, 120656, w6], [0, 120688, v4], [0, 120714, l6], [0, 120746, k3], [0, 120772, 120780], [0, 120782, 120832], [0, 121344, 121399], [0, 121403, 121453], [0, 121461, 121462], [0, 121476, 121477], [0, 121499, 121504], [0, 121505, 121520], [0, 122880, 122887], [0, 122888, 122905], [0, 122907, 122914], [0, 122915, 122917], [0, 122918, 122923], [0, 123136, 123181], [0, 123184, 123198], [0, 123200, 123210], [0, ap, 123215], [0, 123584, 123642], [0, 124928, 125125], [0, 125136, 125143], [0, 125184, 125260], [0, 125264, 125274], [0, 126464, C6], [0, 126469, J3], [0, 126497, a3], [0, g8, 126501], [0, e8, m8], [0, 126505, s6], [0, 126516, f8], [0, _6, x8], [0, w3, 126524], [0, K3, 126531], [0, L8, U6], [0, S8, n8], [0, s3, M4], [0, 126541, F4], [0, 126545, g6], [0, d8, 126549], [0, i8, E4], [0, fn, B6], [0, S4, G8], [0, q6, s4], [0, t6, O4], [0, 126561, xp], [0, V6, 126565], [0, 126567, l3], [0, 126572, x6], [0, 126580, W8], [0, 126585, L3], [0, $4, w8], [0, 126592, V8], [0, 126603, 126620], [0, 126625, j3], [0, 126629, r3], [0, 126635, 126652], [0, 131072, 173783], [0, 173824, 177973], [0, 177984, 178206], [0, 178208, 183970], [0, 183984, 191457], [0, 194560, 195102], [0, 917760, 918e3]], Jpr = r2(O2), $pr = r2(dv), Zpr = r2(Tv), Qpr = r2(K4), r5r = r2("Cannot export an enum with `export type`, try `export enum E {}` or `module.exports = E;` instead."), e5r = r2("Enum members are separated with `,`. Replace `;` with `,`."), n5r = r2("Unexpected reserved word"), t5r = r2("Unexpected reserved type"), u5r = r2("Unexpected `super` outside of a class method"), i5r = r2("`super()` is only valid in a class constructor"), f5r = r2("Unexpected end of input"), x5r = r2("Unexpected variance sigil"), o5r = r2("Unexpected static modifier"), a5r = r2("Unexpected proto modifier"), c5r = r2("Type aliases are not allowed in untyped mode"), s5r = r2("Opaque type aliases are not allowed in untyped mode"), v5r = r2("Type annotations are not allowed in untyped mode"), l5r = r2("Type declarations are not allowed in untyped mode"), b5r = r2("Type imports are not allowed in untyped mode"), p5r = r2("Type exports are not allowed in untyped mode"), m5r = r2("Interfaces are not allowed in untyped mode"), _5r = r2("Spreading a type is only allowed inside an object type"), y5r = r2("Explicit inexact syntax must come at the end of an object type"), h5r = r2("Explicit inexact syntax cannot appear inside an explicit exact object type"), d5r = r2("Explicit inexact syntax can only appear inside an object type"), k5r = r2("Illegal newline after throw"), w5r = r2("A bigint literal must be an integer"), E5r = r2("A bigint literal cannot use exponential notation"), S5r = r2("Invalid regular expression"), g5r = r2("Invalid regular expression: missing /"), F5r = r2("Invalid left-hand side in assignment"), T5r = r2("Invalid left-hand side in exponentiation expression"), O5r = r2("Invalid left-hand side in for-in"), I5r = r2("Invalid left-hand side in for-of"), A5r = r2("Invalid optional indexed access. Indexed access uses bracket notation. Use the format `T?.[K]`."), N5r = r2("found an expression instead"), C5r = r2("Expected an object pattern, array pattern, or an identifier but "), P5r = r2("More than one default clause in switch statement"), D5r = r2("Missing catch or finally after try"), L5r = r2("Illegal continue statement"), R5r = r2("Illegal break statement"), j5r = r2("Illegal return statement"), G5r = r2("Illegal Unicode escape"), M5r = r2("Strict mode code may not include a with statement"), B5r = r2("Catch variable may not be eval or arguments in strict mode"), q5r = r2("Variable name may not be eval or arguments in strict mode"), U5r = r2("Parameter name eval or arguments is not allowed in strict mode"), H5r = r2("Strict mode function may not have duplicate parameter names"), X5r = r2('Illegal "use strict" directive in function with non-simple parameter list'), Y5r = r2("Function name may not be eval or arguments in strict mode"), V5r = r2("Octal literals are not allowed in strict mode."), z5r = r2("Number literals with leading zeros are not allowed in strict mode."), K5r = r2("Delete of an unqualified identifier in strict mode."), W5r = r2("Duplicate data property in object literal not allowed in strict mode"), J5r = r2("Object literal may not have data and accessor property with the same name"), $5r = r2("Object literal may not have multiple get/set accessors with the same name"), Z5r = r2("`typeof` can only be used to get the type of variables."), Q5r = r2("Assignment to eval or arguments is not allowed in strict mode"), rmr = r2("Postfix increment/decrement may not have eval or arguments operand in strict mode"), emr = r2("Prefix increment/decrement may not have eval or arguments operand in strict mode"), nmr = r2("Use of future reserved word in strict mode"), tmr = r2("JSX attributes must only be assigned a non-empty expression"), umr = r2("JSX value should be either an expression or a quoted JSX text"), imr = r2("Const must be initialized"), fmr = r2("Destructuring assignment must be initialized"), xmr = r2("Illegal newline before arrow"), omr = r2(aF), amr = r2("Async functions can only be declared at top level or "), cmr = r2(aF), smr = r2("Generators can only be declared at top level or "), vmr = r2("elements must be wrapped in an enclosing parent tag"), lmr = r2("Unexpected token <. Remember, adjacent JSX "), bmr = r2("Rest parameter must be final parameter of an argument list"), pmr = r2("Rest element must be final element of an array pattern"), mmr = r2("Rest property must be final property of an object pattern"), _mr = r2("async is an implementation detail and isn't necessary for your declare function statement. It is sufficient for your declare function to just have a Promise return type."), ymr = r2("`declare` modifier can only appear on class fields."), hmr = r2("Unexpected token `=`. Initializers are not allowed in a `declare`."), dmr = r2("Unexpected token `=`. Initializers are not allowed in a `declare opaque type`."), kmr = r2("`declare export let` is not supported. Use `declare export var` instead."), wmr = r2("`declare export const` is not supported. Use `declare export var` instead."), Emr = r2("`declare export type` is not supported. Use `export type` instead."), Smr = r2("`declare export interface` is not supported. Use `export interface` instead."), gmr = r2("`export * as` is an early-stage proposal and is not enabled by default. To enable support in the parser, use the `esproposal_export_star_as` option"), Fmr = r2("Found a decorator in an unsupported position."), Tmr = r2("Type parameter declaration needs a default, since a preceding type parameter declaration has a default."), Omr = r2("Duplicate `declare module.exports` statement!"), Imr = r2("Found both `declare module.exports` and `declare export` in the same module. Modules can only have 1 since they are either an ES module xor they are a CommonJS module."), Amr = r2("Getter should have zero parameters"), Nmr = r2("Setter should have exactly one parameter"), Cmr = r2("`import type` or `import typeof`!"), Pmr = r2("Imports within a `declare module` body must always be "), Dmr = r2("The `type` and `typeof` keywords on named imports can only be used on regular `import` statements. It cannot be used with `import type` or `import typeof` statements"), Lmr = r2("Missing comma between import specifiers"), Rmr = r2("Missing comma between export specifiers"), jmr = r2("Malformed unicode"), Gmr = r2("Classes may only have one constructor"), Mmr = r2("Private fields may not be deleted."), Bmr = r2("Private fields can only be referenced from within a class."), qmr = r2("You may not access a private field through the `super` keyword."), Umr = r2("Yield expression not allowed in formal parameter"), Hmr = r2("`await` is an invalid identifier in async functions"), Xmr = r2("`yield` is an invalid identifier in generators"), Ymr = r2("either a `let` binding pattern, or a member expression."), Vmr = r2("`let [` is ambiguous in this position because it is "), zmr = r2("Literals cannot be used as shorthand properties."), Kmr = r2("Computed properties must have a value."), Wmr = r2("Object pattern can't contain methods"), Jmr = r2("A trailing comma is not permitted after the rest element"), $mr = r2("An optional chain may not be used in a `new` expression."), Zmr = r2("Template literals may not be used in an optional chain."), Qmr = r2("Unexpected whitespace between `#` and identifier"), r9r = r2("A type annotation is required for the `this` parameter."), e9r = r2("The `this` parameter must be the first function parameter."), n9r = r2("The `this` parameter cannot be optional."), t9r = r2("A getter cannot have a `this` parameter."), u9r = r2("A setter cannot have a `this` parameter."), i9r = r2("Arrow functions cannot have a `this` parameter; arrow functions automatically bind `this` when declared."), f9r = r2("Constructors cannot have a `this` parameter; constructors don't bind `this` like other functions."), x9r = [0, [11, r2("Boolean enum members need to be initialized. Use either `"), [2, 0, [11, r2(" = true,` or `"), [2, 0, [11, r2(" = false,` in enum `"), [2, 0, [11, r2(Es), 0]]]]]]], r2("Boolean enum members need to be initialized. Use either `%s = true,` or `%s = false,` in enum `%s`.")], o9r = [0, [11, r2("Enum member names need to be unique, but the name `"), [2, 0, [11, r2("` has already been used before in enum `"), [2, 0, [11, r2(Es), 0]]]]], r2("Enum member names need to be unique, but the name `%s` has already been used before in enum `%s`.")], a9r = [0, [11, r2(IU), [2, 0, [11, r2("` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers."), 0]]], r2("Enum `%s` has inconsistent member initializers. Either use no initializers, or consistently use literals (either booleans, numbers, or strings) for all member initializers.")], c9r = [0, [11, r2("Use one of `boolean`, `number`, `string`, or `symbol` in enum `"), [2, 0, [11, r2(Es), 0]]], r2("Use one of `boolean`, `number`, `string`, or `symbol` in enum `%s`.")], s9r = [0, [11, r2("Enum type `"), [2, 0, [11, r2("` is not valid. "), [2, 0, 0]]]], r2("Enum type `%s` is not valid. %s")], v9r = [0, [11, r2("Supplied enum type is not valid. "), [2, 0, 0]], r2("Supplied enum type is not valid. %s")], l9r = [0, [11, r2("Enum member names and initializers are separated with `=`. Replace `"), [2, 0, [11, r2(":` with `"), [2, 0, [11, r2(" =`."), 0]]]]], r2("Enum member names and initializers are separated with `=`. Replace `%s:` with `%s =`.")], b9r = [0, [11, r2("Symbol enum members cannot be initialized. Use `"), [2, 0, [11, r2(",` in enum `"), [2, 0, [11, r2(Es), 0]]]]], r2("Symbol enum members cannot be initialized. Use `%s,` in enum `%s`.")], p9r = [0, [11, r2(IU), [2, 0, [11, r2("` has type `"), [2, 0, [11, r2("`, so the initializer of `"), [2, 0, [11, r2("` needs to be a "), [2, 0, [11, r2(" literal."), 0]]]]]]]]], r2("Enum `%s` has type `%s`, so the initializer of `%s` needs to be a %s literal.")], m9r = [0, [11, r2("The enum member initializer for `"), [2, 0, [11, r2("` needs to be a literal (either a boolean, number, or string) in enum `"), [2, 0, [11, r2(Es), 0]]]]], r2("The enum member initializer for `%s` needs to be a literal (either a boolean, number, or string) in enum `%s`.")], _9r = [0, [11, r2("Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `"), [2, 0, [11, r2("`, consider using `"), [2, 0, [11, r2("`, in enum `"), [2, 0, [11, r2(Es), 0]]]]]]], r2("Enum member names cannot start with lowercase 'a' through 'z'. Instead of using `%s`, consider using `%s`, in enum `%s`.")], y9r = r2("The `...` must come at the end of the enum body. Remove the trailing comma."), h9r = r2("The `...` must come after all enum members. Move it to the end of the enum body."), d9r = [0, [11, r2("Number enum members need to be initialized, e.g. `"), [2, 0, [11, r2(" = 1,` in enum `"), [2, 0, [11, r2(Es), 0]]]]], r2("Number enum members need to be initialized, e.g. `%s = 1,` in enum `%s`.")], k9r = [0, [11, r2("String enum members need to consistently either all use initializers, or use no initializers, in enum "), [2, 0, [12, 46, 0]]], r2("String enum members need to consistently either all use initializers, or use no initializers, in enum %s.")], w9r = [0, [11, r2(UH), [2, 0, 0]], r2("Unexpected %s")], E9r = [0, [11, r2(UH), [2, 0, [11, r2(", expected "), [2, 0, 0]]]], r2("Unexpected %s, expected %s")], S9r = [0, [11, r2(bV), [2, 0, [11, r2("`. Did you mean `"), [2, 0, [11, r2("`?"), 0]]]]], r2("Unexpected token `%s`. Did you mean `%s`?")], g9r = r2(P3), F9r = r2("Invalid flags supplied to RegExp constructor '"), T9r = r2("Remove the period."), O9r = r2("Indexed access uses bracket notation."), I9r = [0, [11, r2("Invalid indexed access. "), [2, 0, [11, r2(" Use the format `T[K]`."), 0]]], r2("Invalid indexed access. %s Use the format `T[K]`.")], A9r = r2(P3), N9r = r2("Undefined label '"), C9r = r2("' has already been declared"), P9r = r2(" '"), D9r = r2("Expected corresponding JSX closing tag for "), L9r = r2(aF), R9r = r2("In strict mode code, functions can only be declared at top level or "), j9r = r2("inside a block, or as the body of an if statement."), G9r = r2("In non-strict mode code, functions can only be declared at top level, "), M9r = [0, [11, r2("Duplicate export for `"), [2, 0, [12, 96, 0]]], r2("Duplicate export for `%s`")], B9r = r2("` is declared more than once."), q9r = r2("Private fields may only be declared once. `#"), U9r = r2("static "), H9r = r2(C), X9r = r2(YY), Y9r = r2("methods"), V9r = r2("fields"), z9r = r2(Es), K9r = r2(" named `"), W9r = r2("Classes may not have "), J9r = r2("` has not been declared."), $9r = r2("Private fields must be declared before they can be referenced. `#"), Z9r = [0, [11, r2(bV), [2, 0, [11, r2("`. Parentheses are required to combine `??` with `&&` or `||` expressions."), 0]]], r2("Unexpected token `%s`. Parentheses are required to combine `??` with `&&` or `||` expressions.")], Q9r = r2("Parse_error.Error"), r_r = [0, r2("src/third-party/sedlex/flow_sedlexing.ml"), s1, 4], e_r = r2("Flow_sedlexing.MalFormed"), n_r = [0, 1, 0], t_r = [0, 0, [0, 1, 0], [0, 1, 0]], u_r = r2(YU), i_r = r2("end of input"), f_r = r2(rl), x_r = r2("template literal part"), o_r = r2(rl), a_r = r2(MH), c_r = r2(YU), s_r = r2(rl), v_r = r2(dv), l_r = r2(rl), b_r = r2(x1), p_r = r2(rl), m_r = r2(Tv), __r = r2("an"), y_r = r2(yi), h_r = r2(pi), d_r = [0, [11, r2("token `"), [2, 0, [12, 96, 0]]], r2("token `%s`")], k_r = r2(hH), w_r = r2(b3), E_r = r2("{|"), S_r = r2("|}"), g_r = r2(HX), F_r = r2(Z0), T_r = r2("["), O_r = r2("]"), I_r = r2(VY), A_r = r2(","), N_r = r2(Lo), C_r = r2("=>"), P_r = r2("..."), D_r = r2(gX), L_r = r2(YY), R_r = r2(M2), j_r = r2(A3), G_r = r2(R2), M_r = r2(j2), B_r = r2(Ju), q_r = r2(D7), U_r = r2(i1), H_r = r2(F7), X_r = r2(d4), Y_r = r2(U2), V_r = r2(K6), z_r = r2(C8), K_r = r2(D2), W_r = r2(G2), J_r = r2(fs4), $_r = r2(Ci), Z_r = r2(Gi), Q_r = r2(A7), ryr = r2(d6), eyr = r2(o6), nyr = r2(N7), tyr = r2(_i), uyr = r2(_4), iyr = r2(q8), fyr = r2(np), xyr = r2(q2), oyr = r2(P7), ayr = r2(nu), cyr = r2(U4), syr = r2(u1), vyr = r2(J2), lyr = r2(rs), byr = r2(es), pyr = r2(b8), myr = r2(_3), _yr = r2(Uu), yyr = r2(yv), hyr = r2(ws), dyr = r2(e7), kyr = r2(y4), wyr = r2(k4), Eyr = r2(a6), Syr = r2(E6), gyr = r2(Eu), Fyr = r2(I7), Tyr = r2(T2), Oyr = r2(Jc), Iyr = r2(eh), Ayr = r2(CS), Nyr = r2(gs), Cyr = r2(dx), Pyr = r2("%checks"), Dyr = r2(aX), Lyr = r2(zX), Ryr = r2(xU), jyr = r2(wH), Gyr = r2(bH), Myr = r2(XH), Byr = r2(hX), qyr = r2(lH), Uyr = r2(nY), Hyr = r2(xX), Xyr = r2(BU), Yyr = r2(WU), Vyr = r2(rV), zyr = r2(AU), Kyr = r2(tX), Wyr = r2(XO), Jyr = r2("?."), $yr = r2(Ke), Zyr = r2("?"), Qyr = r2(o1), rhr = r2(zH), ehr = r2(MX), nhr = r2(OH), thr = r2(I6), uhr = r2(jd), ihr = r2(lV), fhr = r2(jY), xhr = r2(PX), ohr = r2(zY), ahr = r2(ZH), chr = r2(OU), shr = r2(S3), vhr = r2(cv), lhr = r2(vY), bhr = r2(_X), phr = r2(sX), mhr = r2(xs), _hr = r2(Fa), yhr = r2(Qu), hhr = r2(UU), dhr = r2(WH), khr = r2(XY), whr = r2(Kt), Ehr = r2(ZY), Shr = r2(sH), ghr = r2(oV), Fhr = r2(C), Thr = r2(n6), Ohr = r2(H8), Ihr = r2(v7), Ahr = r2(dv), Nhr = r2(x1), Chr = r2(Tv), Phr = r2(es), Dhr = r2(K4), Lhr = r2(Qu), Rhr = r2(Qu), jhr = r2(O2), Ghr = r2(O6), Mhr = r2("T_LCURLY"), Bhr = r2("T_RCURLY"), qhr = r2("T_LCURLYBAR"), Uhr = r2("T_RCURLYBAR"), Hhr = r2("T_LPAREN"), Xhr = r2("T_RPAREN"), Yhr = r2("T_LBRACKET"), Vhr = r2("T_RBRACKET"), zhr = r2("T_SEMICOLON"), Khr = r2("T_COMMA"), Whr = r2("T_PERIOD"), Jhr = r2("T_ARROW"), $hr = r2("T_ELLIPSIS"), Zhr = r2("T_AT"), Qhr = r2("T_POUND"), rdr = r2("T_FUNCTION"), edr = r2("T_IF"), ndr = r2("T_IN"), tdr = r2("T_INSTANCEOF"), udr = r2("T_RETURN"), idr = r2("T_SWITCH"), fdr = r2("T_THIS"), xdr = r2("T_THROW"), odr = r2("T_TRY"), adr = r2("T_VAR"), cdr = r2("T_WHILE"), sdr = r2("T_WITH"), vdr = r2("T_CONST"), ldr = r2("T_LET"), bdr = r2("T_NULL"), pdr = r2("T_FALSE"), mdr = r2("T_TRUE"), _dr = r2("T_BREAK"), ydr = r2("T_CASE"), hdr = r2("T_CATCH"), ddr = r2("T_CONTINUE"), kdr = r2("T_DEFAULT"), wdr = r2("T_DO"), Edr = r2("T_FINALLY"), Sdr = r2("T_FOR"), gdr = r2("T_CLASS"), Fdr = r2("T_EXTENDS"), Tdr = r2("T_STATIC"), Odr = r2("T_ELSE"), Idr = r2("T_NEW"), Adr = r2("T_DELETE"), Ndr = r2("T_TYPEOF"), Cdr = r2("T_VOID"), Pdr = r2("T_ENUM"), Ddr = r2("T_EXPORT"), Ldr = r2("T_IMPORT"), Rdr = r2("T_SUPER"), jdr = r2("T_IMPLEMENTS"), Gdr = r2("T_INTERFACE"), Mdr = r2("T_PACKAGE"), Bdr = r2("T_PRIVATE"), qdr = r2("T_PROTECTED"), Udr = r2("T_PUBLIC"), Hdr = r2("T_YIELD"), Xdr = r2("T_DEBUGGER"), Ydr = r2("T_DECLARE"), Vdr = r2("T_TYPE"), zdr = r2("T_OPAQUE"), Kdr = r2("T_OF"), Wdr = r2("T_ASYNC"), Jdr = r2("T_AWAIT"), $dr = r2("T_CHECKS"), Zdr = r2("T_RSHIFT3_ASSIGN"), Qdr = r2("T_RSHIFT_ASSIGN"), rkr = r2("T_LSHIFT_ASSIGN"), ekr = r2("T_BIT_XOR_ASSIGN"), nkr = r2("T_BIT_OR_ASSIGN"), tkr = r2("T_BIT_AND_ASSIGN"), ukr = r2("T_MOD_ASSIGN"), ikr = r2("T_DIV_ASSIGN"), fkr = r2("T_MULT_ASSIGN"), xkr = r2("T_EXP_ASSIGN"), okr = r2("T_MINUS_ASSIGN"), akr = r2("T_PLUS_ASSIGN"), ckr = r2("T_NULLISH_ASSIGN"), skr = r2("T_AND_ASSIGN"), vkr = r2("T_OR_ASSIGN"), lkr = r2("T_ASSIGN"), bkr = r2("T_PLING_PERIOD"), pkr = r2("T_PLING_PLING"), mkr = r2("T_PLING"), _kr = r2("T_COLON"), ykr = r2("T_OR"), hkr = r2("T_AND"), dkr = r2("T_BIT_OR"), kkr = r2("T_BIT_XOR"), wkr = r2("T_BIT_AND"), Ekr = r2("T_EQUAL"), Skr = r2("T_NOT_EQUAL"), gkr = r2("T_STRICT_EQUAL"), Fkr = r2("T_STRICT_NOT_EQUAL"), Tkr = r2("T_LESS_THAN_EQUAL"), Okr = r2("T_GREATER_THAN_EQUAL"), Ikr = r2("T_LESS_THAN"), Akr = r2("T_GREATER_THAN"), Nkr = r2("T_LSHIFT"), Ckr = r2("T_RSHIFT"), Pkr = r2("T_RSHIFT3"), Dkr = r2("T_PLUS"), Lkr = r2("T_MINUS"), Rkr = r2("T_DIV"), jkr = r2("T_MULT"), Gkr = r2("T_EXP"), Mkr = r2("T_MOD"), Bkr = r2("T_NOT"), qkr = r2("T_BIT_NOT"), Ukr = r2("T_INCR"), Hkr = r2("T_DECR"), Xkr = r2("T_EOF"), Ykr = r2("T_ANY_TYPE"), Vkr = r2("T_MIXED_TYPE"), zkr = r2("T_EMPTY_TYPE"), Kkr = r2("T_NUMBER_TYPE"), Wkr = r2("T_BIGINT_TYPE"), Jkr = r2("T_STRING_TYPE"), $kr = r2("T_VOID_TYPE"), Zkr = r2("T_SYMBOL_TYPE"), Qkr = r2("T_NUMBER"), rwr = r2("T_BIGINT"), ewr = r2("T_STRING"), nwr = r2("T_TEMPLATE_PART"), twr = r2("T_IDENTIFIER"), uwr = r2("T_REGEXP"), iwr = r2("T_ERROR"), fwr = r2("T_JSX_IDENTIFIER"), xwr = r2("T_JSX_TEXT"), owr = r2("T_BOOLEAN_TYPE"), awr = r2("T_NUMBER_SINGLETON_TYPE"), cwr = r2("T_BIGINT_SINGLETON_TYPE"), swr = [0, r2(kX), HT, 9], vwr = [0, r2(kX), A6, 9], lwr = r2(GH), bwr = r2("*/"), pwr = r2(GH), mwr = r2("unreachable line_comment"), _wr = r2("unreachable string_quote"), ywr = r2("\\"), hwr = r2("unreachable template_part"), dwr = r2("${"), kwr = r2(UY), wwr = r2(UY), Ewr = r2(MI), Swr = r2("unreachable regexp_class"), gwr = r2(uY), Fwr = r2("unreachable regexp_body"), Twr = r2(C), Owr = r2(C), Iwr = r2(C), Awr = r2(C), Nwr = r2("unreachable jsxtext"), Cwr = r2(P3), Pwr = r2(V2), Dwr = r2(S3), Lwr = r2(cv), Rwr = r2(hH), jwr = r2(b3), Gwr = r2("{'}'}"), Mwr = r2(b3), Bwr = r2("{'>'}"), qwr = r2(cv), Uwr = r2(l1), Hwr = r2("iexcl"), Xwr = r2("aelig"), Ywr = r2("Nu"), Vwr = r2("Eacute"), zwr = r2("Atilde"), Kwr = r2("'int'"), Wwr = r2("AElig"), Jwr = r2("Aacute"), $wr = r2("Acirc"), Zwr = r2("Agrave"), Qwr = r2("Alpha"), rEr = r2("Aring"), eEr = [0, hY], nEr = [0, 913], tEr = [0, rt], uEr = [0, nI], iEr = [0, HT], fEr = [0, vH], xEr = [0, 8747], oEr = r2("Auml"), aEr = r2("Beta"), cEr = r2("Ccedil"), sEr = r2("Chi"), vEr = r2("Dagger"), lEr = r2("Delta"), bEr = r2("ETH"), pEr = [0, _H], mEr = [0, 916], _Er = [0, 8225], yEr = [0, 935], hEr = [0, QH], dEr = [0, 914], kEr = [0, XX], wEr = [0, xY], EEr = r2("Icirc"), SEr = r2("Ecirc"), gEr = r2("Egrave"), FEr = r2("Epsilon"), TEr = r2("Eta"), OEr = r2("Euml"), IEr = r2("Gamma"), AEr = r2("Iacute"), NEr = [0, VH], CEr = [0, 915], PEr = [0, eV], DEr = [0, 919], LEr = [0, 917], REr = [0, NU], jEr = [0, nH], GEr = r2("Igrave"), MEr = r2("Iota"), BEr = r2("Iuml"), qEr = r2("Kappa"), UEr = r2("Lambda"), HEr = r2("Mu"), XEr = r2("Ntilde"), YEr = [0, Wg], VEr = [0, 924], zEr = [0, 923], KEr = [0, 922], WEr = [0, AX], JEr = [0, 921], $Er = [0, WX], ZEr = [0, TH], QEr = [0, sY], rSr = r2("Sigma"), eSr = r2("Otilde"), nSr = r2("OElig"), tSr = r2("Oacute"), uSr = r2("Ocirc"), iSr = r2("Ograve"), fSr = r2("Omega"), xSr = r2("Omicron"), oSr = r2("Oslash"), aSr = [0, y6], cSr = [0, 927], sSr = [0, 937], vSr = [0, A6], lSr = [0, yY], bSr = [0, yU], pSr = [0, 338], mSr = r2("Ouml"), _Sr = r2("Phi"), ySr = r2("Pi"), hSr = r2("Prime"), dSr = r2("Psi"), kSr = r2("Rho"), wSr = r2("Scaron"), ESr = [0, 352], SSr = [0, 929], gSr = [0, 936], FSr = [0, 8243], TSr = [0, 928], OSr = [0, 934], ISr = [0, mT], ASr = [0, RX], NSr = r2("Uuml"), CSr = r2("THORN"), PSr = r2("Tau"), DSr = r2("Theta"), LSr = r2("Uacute"), RSr = r2("Ucirc"), jSr = r2("Ugrave"), GSr = r2("Upsilon"), MSr = [0, 933], BSr = [0, cp], qSr = [0, FU], USr = [0, Cw], HSr = [0, 920], XSr = [0, 932], YSr = [0, FX], VSr = r2("Xi"), zSr = r2("Yacute"), KSr = r2("Yuml"), WSr = r2("Zeta"), JSr = r2("aacute"), $Sr = r2("acirc"), ZSr = r2("acute"), QSr = [0, sU], rgr = [0, rk], egr = [0, BO], ngr = [0, 918], tgr = [0, 376], ugr = [0, GX], igr = [0, 926], fgr = [0, iA], xgr = [0, UX], ogr = [0, 925], agr = r2("delta"), cgr = r2("cap"), sgr = r2("aring"), vgr = r2("agrave"), lgr = r2("alefsym"), bgr = r2("alpha"), pgr = r2("amp"), mgr = r2("and"), _gr = r2("ang"), ygr = r2("apos"), hgr = [0, 39], dgr = [0, 8736], kgr = [0, 8743], wgr = [0, 38], Egr = [0, 945], Sgr = [0, 8501], ggr = [0, hv], Fgr = r2("asymp"), Tgr = r2("atilde"), Ogr = r2("auml"), Igr = r2("bdquo"), Agr = r2("beta"), Ngr = r2("brvbar"), Cgr = r2("bull"), Pgr = [0, 8226], Dgr = [0, DY], Lgr = [0, 946], Rgr = [0, 8222], jgr = [0, fV], Ggr = [0, JH], Mgr = [0, 8776], Bgr = [0, bU], qgr = r2("copy"), Ugr = r2("ccedil"), Hgr = r2("cedil"), Xgr = r2("cent"), Ygr = r2("chi"), Vgr = r2("circ"), zgr = r2("clubs"), Kgr = r2("cong"), Wgr = [0, 8773], Jgr = [0, 9827], $gr = [0, rX], Zgr = [0, 967], Qgr = [0, kh], rFr = [0, hk], eFr = [0, qX], nFr = r2("crarr"), tFr = r2("cup"), uFr = r2("curren"), iFr = r2("dArr"), fFr = r2("dagger"), xFr = r2("darr"), oFr = r2("deg"), aFr = [0, mV], cFr = [0, 8595], sFr = [0, 8224], vFr = [0, 8659], lFr = [0, AF], bFr = [0, 8746], pFr = [0, 8629], mFr = [0, NX], _Fr = [0, 8745], yFr = r2("fnof"), hFr = r2("ensp"), dFr = r2("diams"), kFr = r2("divide"), wFr = r2("eacute"), EFr = r2("ecirc"), SFr = r2("egrave"), gFr = r2(v7), FFr = r2("emsp"), TFr = [0, 8195], OFr = [0, 8709], IFr = [0, ZF], AFr = [0, tH], NFr = [0, hT], CFr = [0, Dw], PFr = [0, 9830], DFr = r2("epsilon"), LFr = r2("equiv"), RFr = r2("eta"), jFr = r2("eth"), GFr = r2("euml"), MFr = r2("euro"), BFr = r2("exist"), qFr = [0, 8707], UFr = [0, 8364], HFr = [0, JU], XFr = [0, s1], YFr = [0, 951], VFr = [0, 8801], zFr = [0, 949], KFr = [0, 8194], WFr = r2("gt"), JFr = r2("forall"), $Fr = r2("frac12"), ZFr = r2("frac14"), QFr = r2("frac34"), rTr = r2("frasl"), eTr = r2("gamma"), nTr = r2("ge"), tTr = [0, 8805], uTr = [0, 947], iTr = [0, 8260], fTr = [0, OY], xTr = [0, iY], oTr = [0, fX], aTr = [0, 8704], cTr = r2("hArr"), sTr = r2("harr"), vTr = r2("hearts"), lTr = r2("hellip"), bTr = r2("iacute"), pTr = r2("icirc"), mTr = [0, cH], _Tr = [0, BY], yTr = [0, 8230], hTr = [0, 9829], dTr = [0, 8596], kTr = [0, 8660], wTr = [0, 62], ETr = [0, 402], STr = [0, 948], gTr = [0, jh], FTr = r2("prime"), TTr = r2("ndash"), OTr = r2("le"), ITr = r2("kappa"), ATr = r2("igrave"), NTr = r2("image"), CTr = r2("infin"), PTr = r2("iota"), DTr = r2("iquest"), LTr = r2("isin"), RTr = r2("iuml"), jTr = [0, i6], GTr = [0, 8712], MTr = [0, lX], BTr = [0, 953], qTr = [0, 8734], UTr = [0, 8465], HTr = [0, lO], XTr = r2("lArr"), YTr = r2("lambda"), VTr = r2("lang"), zTr = r2("laquo"), KTr = r2("larr"), WTr = r2("lceil"), JTr = r2("ldquo"), $Tr = [0, 8220], ZTr = [0, 8968], QTr = [0, 8592], rOr = [0, pg], eOr = [0, 10216], nOr = [0, 955], tOr = [0, 8656], uOr = [0, 954], iOr = r2("macr"), fOr = r2("lfloor"), xOr = r2("lowast"), oOr = r2("loz"), aOr = r2("lrm"), cOr = r2("lsaquo"), sOr = r2("lsquo"), vOr = r2("lt"), lOr = [0, 60], bOr = [0, 8216], pOr = [0, 8249], mOr = [0, vU], _Or = [0, 9674], yOr = [0, 8727], hOr = [0, 8970], dOr = r2("mdash"), kOr = r2("micro"), wOr = r2("middot"), EOr = r2(cY), SOr = r2("mu"), gOr = r2("nabla"), FOr = r2("nbsp"), TOr = [0, fY], OOr = [0, 8711], IOr = [0, 956], AOr = [0, 8722], NOr = [0, lS], COr = [0, Ai], POr = [0, 8212], DOr = [0, bX], LOr = [0, 8804], ROr = r2("or"), jOr = r2("oacute"), GOr = r2("ne"), MOr = r2("ni"), BOr = r2("not"), qOr = r2("notin"), UOr = r2("nsub"), HOr = r2("ntilde"), XOr = r2("nu"), YOr = [0, 957], VOr = [0, Vy], zOr = [0, 8836], KOr = [0, 8713], WOr = [0, LU], JOr = [0, 8715], $Or = [0, 8800], ZOr = r2("ocirc"), QOr = r2("oelig"), rIr = r2("ograve"), eIr = r2("oline"), nIr = r2("omega"), tIr = r2("omicron"), uIr = r2("oplus"), iIr = [0, 8853], fIr = [0, 959], xIr = [0, 969], oIr = [0, 8254], aIr = [0, ST], cIr = [0, 339], sIr = [0, v8], vIr = [0, QU], lIr = r2("part"), bIr = r2("ordf"), pIr = r2("ordm"), mIr = r2("oslash"), _Ir = r2("otilde"), yIr = r2("otimes"), hIr = r2("ouml"), dIr = r2("para"), kIr = [0, Yg], wIr = [0, $2], EIr = [0, 8855], SIr = [0, WY], gIr = [0, wt], FIr = [0, md], TIr = [0, qg], OIr = r2("permil"), IIr = r2("perp"), AIr = r2("phi"), NIr = r2("pi"), CIr = r2("piv"), PIr = r2("plusmn"), DIr = r2("pound"), LIr = [0, Ln], RIr = [0, uV], jIr = [0, 982], GIr = [0, 960], MIr = [0, 966], BIr = [0, 8869], qIr = [0, 8240], UIr = [0, 8706], HIr = [0, 8744], XIr = [0, 8211], YIr = r2("sup1"), VIr = r2("rlm"), zIr = r2("raquo"), KIr = r2("prod"), WIr = r2("prop"), JIr = r2("psi"), $Ir = r2("quot"), ZIr = r2("rArr"), QIr = r2("radic"), rAr = r2("rang"), eAr = [0, 10217], nAr = [0, 8730], tAr = [0, 8658], uAr = [0, 34], iAr = [0, 968], fAr = [0, 8733], xAr = [0, 8719], oAr = r2("rarr"), aAr = r2("rceil"), cAr = r2("rdquo"), sAr = r2("real"), vAr = r2("reg"), lAr = r2("rfloor"), bAr = r2("rho"), pAr = [0, 961], mAr = [0, 8971], _Ar = [0, $U], yAr = [0, 8476], hAr = [0, 8221], dAr = [0, 8969], kAr = [0, 8594], wAr = [0, nw], EAr = r2("sigma"), SAr = r2("rsaquo"), gAr = r2("rsquo"), FAr = r2("sbquo"), TAr = r2("scaron"), OAr = r2("sdot"), IAr = r2("sect"), AAr = r2("shy"), NAr = [0, _Y], CAr = [0, NT], PAr = [0, 8901], DAr = [0, 353], LAr = [0, 8218], RAr = [0, 8217], jAr = [0, 8250], GAr = r2("sigmaf"), MAr = r2("sim"), BAr = r2("spades"), qAr = r2("sub"), UAr = r2("sube"), HAr = r2("sum"), XAr = r2("sup"), YAr = [0, 8835], VAr = [0, 8721], zAr = [0, 8838], KAr = [0, 8834], WAr = [0, 9824], JAr = [0, 8764], $Ar = [0, 962], ZAr = [0, 963], QAr = [0, 8207], rNr = r2("uarr"), eNr = r2("thetasym"), nNr = r2("sup2"), tNr = r2("sup3"), uNr = r2("supe"), iNr = r2("szlig"), fNr = r2("tau"), xNr = r2("there4"), oNr = r2("theta"), aNr = [0, 952], cNr = [0, 8756], sNr = [0, 964], vNr = [0, y8], lNr = [0, 8839], bNr = [0, RY], pNr = [0, gO], mNr = r2("thinsp"), _Nr = r2("thorn"), yNr = r2("tilde"), hNr = r2("times"), dNr = r2("trade"), kNr = r2("uArr"), wNr = r2("uacute"), ENr = [0, nl], SNr = [0, 8657], gNr = [0, 8482], FNr = [0, xT], TNr = [0, 732], ONr = [0, gv], INr = [0, 8201], ANr = [0, 977], NNr = r2("xi"), CNr = r2("ucirc"), PNr = r2("ugrave"), DNr = r2("uml"), LNr = r2("upsih"), RNr = r2("upsilon"), jNr = r2("uuml"), GNr = r2("weierp"), MNr = [0, iU], BNr = [0, Y2], qNr = [0, 965], UNr = [0, 978], HNr = [0, IY], XNr = [0, 249], YNr = [0, 251], VNr = r2("yacute"), zNr = r2("yen"), KNr = r2("yuml"), WNr = r2("zeta"), JNr = r2("zwj"), $Nr = r2("zwnj"), ZNr = [0, kY], QNr = [0, 8205], rCr = [0, 950], eCr = [0, gw], nCr = [0, $X], tCr = [0, nd], uCr = [0, 958], iCr = [0, 8593], fCr = [0, gU], xCr = [0, 8242], oCr = [0, XU], aCr = r2(VY), cCr = r2(jd), sCr = r2("unreachable jsx_child"), vCr = r2("unreachable type_token wholenumber"), lCr = r2("unreachable type_token wholebigint"), bCr = r2("unreachable type_token floatbigint"), pCr = r2("unreachable type_token scinumber"), mCr = r2("unreachable type_token scibigint"), _Cr = r2("unreachable type_token hexnumber"), yCr = r2("unreachable type_token hexbigint"), hCr = r2("unreachable type_token legacyoctnumber"), dCr = r2("unreachable type_token octnumber"), kCr = r2("unreachable type_token octbigint"), wCr = r2("unreachable type_token binnumber"), ECr = r2("unreachable type_token bigbigint"), SCr = r2("unreachable type_token"), gCr = r2(o1), FCr = r2(o1), TCr = r2(kU), OCr = r2(H8), ICr = r2(n6), ACr = r2(x1), NCr = r2(O6), CCr = r2(O2), PCr = r2(v7), DCr = r2(P7), LCr = r2(Ci), RCr = r2(e7), jCr = [9, 1], GCr = [9, 0], MCr = r2(fs4), BCr = r2(dv), qCr = r2(nu), UCr = r2(Tv), HCr = r2(K4), XCr = r2(Gi), YCr = r2(rs), VCr = r2(es), zCr = r2("unreachable template_tail"), KCr = r2(b3), WCr = [0, r2(C), r2(C), r2(C)], JCr = r2("unreachable jsx_tag"), $Cr = r2(P3), ZCr = r2("unreachable regexp"), QCr = r2("unreachable token wholenumber"), rPr = r2("unreachable token wholebigint"), ePr = r2("unreachable token floatbigint"), nPr = r2("unreachable token scinumber"), tPr = r2("unreachable token scibigint"), uPr = r2("unreachable token hexnumber"), iPr = r2("unreachable token hexbigint"), fPr = r2("unreachable token legacyoctnumber"), xPr = r2("unreachable token legacynonoctnumber"), oPr = r2("unreachable token octnumber"), aPr = r2("unreachable token octbigint"), cPr = r2("unreachable token bignumber"), sPr = r2("unreachable token bigint"), vPr = r2("unreachable token"), lPr = r2(o1), bPr = r2(o1), pPr = r2(kU), mPr = [6, r2("#!")], _Pr = r2("expected ?"), yPr = r2(j2), hPr = r2(_4), dPr = r2(D2), kPr = r2(gs), wPr = r2(dx), EPr = r2(A7), SPr = r2(d6), gPr = r2(o6), FPr = r2(q2), TPr = r2(N7), OPr = r2(I7), IPr = r2(T2), APr = r2(_i), NPr = r2(J2), CPr = r2(np), PPr = r2(U4), DPr = r2(b8), LPr = r2(_3), RPr = r2(P7), jPr = r2(Ci), GPr = r2(q8), MPr = r2(M2), BPr = r2(A3), qPr = r2(ws), UPr = r2(Uu), HPr = r2(R2), XPr = r2(yv), YPr = r2(y4), VPr = r2(e7), zPr = r2(G2), KPr = r2(u1), WPr = r2(fs4), JPr = r2(CS), $Pr = r2(eh), ZPr = r2(k4), QPr = r2(a6), rDr = r2(E6), eDr = r2(Ju), nDr = r2(nu), tDr = r2(rs), uDr = r2(D7), iDr = r2(i1), fDr = r2(F7), xDr = r2(Gi), oDr = r2(d4), aDr = r2(Jc), cDr = r2(U2), sDr = r2(es), vDr = r2(K6), lDr = r2(C8), bDr = r2(Eu), pDr = r2("unreachable string_escape"), mDr = r2(Zu), _Dr = r2(H2), yDr = r2(H2), hDr = r2(Zu), dDr = r2(dX), kDr = r2(oY), wDr = r2("n"), EDr = r2("r"), SDr = r2("t"), gDr = r2(pV), FDr = r2(H2), TDr = r2(l1), ODr = r2(l1), IDr = r2("unreachable id_char"), ADr = r2(l1), NDr = r2(l1), CDr = r2("Invalid (lexer) bigint "), PDr = r2("Invalid (lexer) bigint binary/octal "), DDr = r2(H2), LDr = r2(pH), RDr = r2(oU), jDr = r2(Nh), GDr = [10, r2("token ILLEGAL")], MDr = r2("\0"), BDr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), qDr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), UDr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), HDr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), XDr = r2("\0\0"), YDr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), VDr = r2(""), zDr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), KDr = r2("\0"), WDr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), JDr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), $Dr = r2("\0\0\0\0"), ZDr = r2("\0\0\0"), QDr = r2("\x07\x07"), rLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), eLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), nLr = r2(`\x07\b	
\v\f\r`), tLr = r2(""), uLr = r2("\0\0\0"), iLr = r2("\0"), fLr = r2("\0\0\0\0\0\0"), xLr = r2(""), oLr = r2(""), aLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), cLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), sLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), vLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), lLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), bLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), pLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), mLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), _Lr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), yLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), hLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), dLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\x07\b\0\0\0\0\0\0	\x07\b"), kLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), wLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), ELr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), SLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), gLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), FLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), TLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), OLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), ILr = r2(`\x07\b	
\v\x07\f\r\x1B																										 	!																										"#$%																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																																													`), ALr = r2(""), NLr = r2(""), CLr = r2("\0\0\0\0"), PLr = r2(`\x07\b	
\v\f\r\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x1B\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07`), DLr = r2(`\x07\b	
\v\f\r\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07\x07`), LLr = r2("\0\0"), RLr = r2(""), jLr = r2(""), GLr = r2("\x07"), MLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), BLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), qLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), ULr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), HLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), XLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), YLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), VLr = r2("\0\0\0\0\0\0\0"), zLr = r2("\x07"), KLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), WLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), JLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), $Lr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), ZLr = r2("\0"), QLr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), rRr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), eRr = r2("\0\0"), nRr = r2("\0"), tRr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), uRr = r2(""), iRr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), fRr = r2(""), xRr = r2(""), oRr = r2(""), aRr = r2("\0"), cRr = r2("\0\0\0"), sRr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), vRr = r2(""), lRr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), bRr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), pRr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), mRr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), _Rr = r2("\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"), yRr = [0, [11, r2("the identifier `"), [2, 0, [12, 96, 0]]], r2("the identifier `%s`")], hRr = [0, 1], dRr = [0, 1], kRr = r2("@flow"), wRr = r2(yX), ERr = r2(yX), SRr = [0, [11, r2("an identifier. When exporting a "), [2, 0, [11, r2(" as a named export, you must specify a "), [2, 0, [11, r2(" name. Did you mean `export default "), [2, 0, [11, r2(" ...`?"), 0]]]]]]], r2("an identifier. When exporting a %s as a named export, you must specify a %s name. Did you mean `export default %s ...`?")], gRr = r2(g3), FRr = r2("Peeking current location when not available"), TRr = r2(e7), ORr = r2(bv), IRr = r2(n6), ARr = r2(x1), NRr = r2(O6), CRr = r2(O2), PRr = r2(v7), DRr = r2(P7), LRr = r2(Ci), RRr = r2(H8), jRr = r2(fs4), GRr = r2(dv), MRr = r2(nu), BRr = r2(Tv), qRr = r2(Gi), URr = r2(rs), HRr = r2(es), XRr = r2(Ci), YRr = r2(fs4), VRr = r2(Gi), zRr = r2(Ci), KRr = r2(fs4), WRr = r2(Gi), JRr = r2(C2), $Rr = r2("eval"), ZRr = r2(ws), QRr = r2(e7), rjr = r2(y4), ejr = r2(k4), njr = r2(a6), tjr = r2(E6), ujr = r2(nu), ijr = r2(Eu), fjr = r2(b8), xjr = r2(A3), ojr = r2(_i), ajr = r2(dx), cjr = r2(A7), sjr = r2(d6), vjr = r2(o6), ljr = r2(q2), bjr = r2(D2), pjr = r2(N7), mjr = r2(I7), _jr = r2(J2), yjr = r2(_4), hjr = r2(U4), djr = r2(_3), kjr = r2(P7), wjr = r2(q8), Ejr = r2(np), Sjr = r2(M2), gjr = r2(F7), Fjr = r2(Uu), Tjr = r2(R2), Ojr = r2(j2), Ijr = r2(u1), Ajr = r2(Ju), Njr = r2(yv), Cjr = r2(D7), Pjr = r2(i1), Djr = r2(d4), Ljr = r2(rs), Rjr = r2(U2), jjr = r2(es), Gjr = r2(K6), Mjr = r2(C8), Bjr = r2(Eu), qjr = [0, r2("src/parser/parser_env.ml"), 343, 9], Ujr = r2("Internal Error: Tried to add_declared_private with outside of class scope."), Hjr = r2("Internal Error: `exit_class` called before a matching `enter_class`"), Xjr = r2(C), Yjr = [0, 0, 0], Vjr = [0, 0, 0], zjr = r2("Parser_env.Try.Rollback"), Kjr = r2(C), Wjr = r2(C), Jjr = [0, r2(Eu), r2(Yx), r2(to), r2(dU), r2(gY), r2(Oo), r2(cu), r2(dc), r2(ux), r2(oc), r2(Gf), r2(To), r2(Po), r2(ec), r2(No), r2(wf), r2(Ja), r2(uo), r2(Cx), r2(Ff), r2(ax), r2(Oa), r2(qf), r2(Ro), r2(Ka), r2(Xx), r2(Jx), r2(_x), r2(xo), r2(fa), r2(no), r2(F7), r2(Io), r2(Pf), r2(wo), r2($x), r2(Jf), r2(Uo), r2(yo), r2(D7), r2(yc), r2(Na), r2(Sx), r2(Vx), r2(_f), r2(Sc), r2(Mf), r2(cx), r2(Ju), r2(px), r2(pa), r2(De), r2(r7), r2($a), r2(Yo), r2(wa), r2(Zx), r2(sc), r2(aa), r2(ta), r2(Cf), r2(Bo), r2(Yf), r2(Wf), r2(kc), r2(vc), r2(va), r2(bf), r2(zo), r2(Zf), r2(rx), r2(mi), r2(Qo), r2(Mo), r2(df), r2(Va), r2(Xo), r2(lc), r2(fc), r2(Zo), r2(oo), r2(ix), r2(Nf), r2(uf), r2(Xf), r2(ex), r2(ma), r2(da), r2(Kf), r2(nc), r2(gf), r2(Lx), r2(qo), r2(bx), r2(yf), r2(Of), r2(mc), r2(xr), r2(_c), r2(Wx), r2(Ux), r2(Pa), r2(zx), r2(nx), r2(Dx), r2(ha), r2(Px), r2(hc), r2(vx), r2(Jo), r2(wc), r2(Da), r2(Ko), r2(rc), r2(rf), r2(Nx), r2(ao), r2(Ox), r2(io), r2(jo), r2(Ao), r2(pc), r2(Ax), r2(ff), r2(of), r2(Qf), r2(Wo), r2(ya), r2(ac), r2(Rf), r2(za), r2(ro), r2(ko), r2(af), r2(e7), r2(Aa), r2(Fx), r2(Ca), r2(Hx), r2(bo), r2(Ec), r2(Uu), r2(Ya), r2(ia), r2(pf), r2(yi), r2(Vf), r2(bc), r2(Wa), r2(G7), r2(mx), r2(ba), r2(vf), r2(Ba), r2(kx), r2(Go), r2(_a4), r2(tx), r2(nf), r2(Lf), r2(gc), r2(Ix), r2(hx), r2(Ia), r2(Tc), r2(lo), r2(So), r2(li), r2(ic), r2(yx), r2(La), r2(Xa), r2(Fc), r2(Mx), r2(ka), r2(Bf), r2(Sf), r2(eo), r2(Tx), r2(Nu), r2(ea), r2(ua), r2(Qa), r2(sf), r2(Sa), r2(vo), r2(Af), r2(jx), r2(Za), r2(If), r2(jf), r2(Bx), r2(Ho), r2(qx), r2(sa), r2(ra), r2(la), r2(v7), r2(ho), r2(Ra), r2(wx), r2(Fo), r2(so), r2(na), r2(zf), r2(ja), r2(Ta), r2(xx), r2(I7), r2(N7), r2($o), r2(xa), r2($f), r2(iH), r2(_o), r2(uH), r2(qU), r2(hf), r2(go), r2(fx), r2(gx), r2(Uf), r2(Ga), r2(kf), r2(tf), r2(ga), r2(Df), r2(tc), r2(mf), r2(qa), r2(oa), r2(Ua), r2(Ef), r2(Qi), r2(sx), r2(po), r2(lx), r2(Tf), r2(A7), r2(Ha), r2(Tn), r2(Gx), r2(xf), r2(lf), r2(Kx), r2(Hf), r2(Vo), r2(ca), r2(Ea), r2(co), r2(Rx), r2(W4)], $jr = [0, r2(Eu), r2(Yx), r2(to), r2(Oo), r2(cu), r2(dc), r2(ux), r2(oc), r2(Gf), r2(To), r2(Po), r2(ec), r2(No), r2(wf), r2(Ja), r2(uo), r2(Cx), r2(Ff), r2(ax), r2(Oa), r2(qf), r2(Ro), r2(Ka), r2(Xx), r2(Jx), r2(_x), r2(xo), r2(fa), r2(no), r2(F7), r2(Io), r2(Pf), r2(wo), r2($x), r2(Jf), r2(Uo), r2(yo), r2(D7), r2(yc), r2(Na), r2(Sx), r2(Vx), r2(_f), r2(Sc), r2(Mf), r2(cx), r2(Ju), r2(px), r2(pa), r2(De), r2(r7), r2($a), r2(Yo), r2(wa), r2(Zx), r2(sc), r2(aa), r2(ta), r2(Cf), r2(Bo), r2(Yf), r2(Wf), r2(kc), r2(vc), r2(va), r2(bf), r2(zo), r2(Zf), r2(rx), r2(mi), r2(Qo), r2(Mo), r2(df), r2(Va), r2(Xo), r2(lc), r2(fc), r2(Zo), r2(oo), r2(ix), r2(Nf), r2(uf), r2(Xf), r2(ex), r2(ma), r2(da), r2(Kf), r2(nc), r2(gf), r2(Lx), r2(qo), r2(bx), r2(yf), r2(Of), r2(mc), r2(xr), r2(_c), r2(Wx), r2(Ux), r2(Pa), r2(zx), r2(nx), r2(Dx), r2(ha), r2(Px), r2(hc), r2(vx), r2(Jo), r2(wc), r2(Da), r2(Ko), r2(rc), r2(rf), r2(Nx), r2(ao), r2(Ox), r2(io), r2(jo), r2(Ao), r2(pc), r2(Ax), r2(ff), r2(of), r2(Qf), r2(Wo), r2(ya), r2(ac), r2(Rf), r2(za), r2(ro), r2(ko), r2(af), r2(e7), r2(Aa), r2(Fx), r2(Ca), r2(Hx), r2(bo), r2(Ec), r2(Uu), r2(Ya), r2(ia), r2(pf), r2(yi), r2(Vf), r2(bc), r2(Wa), r2(G7), r2(mx), r2(ba), r2(vf), r2(Ba), r2(kx), r2(Go), r2(_a4), r2(tx), r2(nf), r2(Lf), r2(gc), r2(Ix), r2(hx), r2(Ia), r2(Tc), r2(lo), r2(So), r2(li), r2(ic), r2(yx), r2(La), r2(Xa), r2(Fc), r2(Mx), r2(ka), r2(Bf), r2(Sf), r2(eo), r2(Tx), r2(Nu), r2(ea), r2(ua), r2(Qa), r2(sf), r2(Sa), r2(vo), r2(Af), r2(jx), r2(Za), r2(If), r2(jf), r2(Bx), r2(Ho), r2(qx), r2(sa), r2(ra), r2(la), r2(v7), r2(ho), r2(Ra), r2(wx), r2(Fo), r2(so), r2(na), r2(zf), r2(ja), r2(Ta), r2(xx), r2(I7), r2(N7), r2($o), r2(xa), r2($f), r2(_o), r2(hf), r2(go), r2(fx), r2(gx), r2(Uf), r2(Ga), r2(kf), r2(tf), r2(ga), r2(Df), r2(tc), r2(mf), r2(qa), r2(oa), r2(Ua), r2(Ef), r2(Qi), r2(sx), r2(po), r2(lx), r2(Tf), r2(A7), r2(Ha), r2(Tn), r2(Gx), r2(xf), r2(lf), r2(Kx), r2(Hf), r2(Vo), r2(ca), r2(Ea), r2(co), r2(Rx), r2(W4)], Zjr = [0, r2(_f), r2(Qf), r2(_a4), r2(Vf), r2(Tf), r2(Yf), r2(qo), r2(ex), r2(Nx), r2(ko), r2(Ka), r2(D7), r2(Xo), r2(ea), r2(tc), r2(pc), r2(bx), r2(ff), r2(ra), r2(Bx), r2(Yx), r2(li), r2(hc), r2(Lx), r2(Wa), r2(sa), r2(Of), r2(yi), r2(Oo), r2(Mx), r2(ta), r2(zf), r2(sx), r2(tx), r2(Qi), r2(jo), r2(Af), r2(ba), r2(vc), r2(ic), r2(yo), r2(Kx), r2(ma), r2(ia), r2(Sx), r2(la), r2(Px), r2(yf), r2(tf), r2(go), r2(Qo), r2(wa), r2(Xf), r2(Yo), r2(Ko), r2(Uf), r2(fc), r2(r7), r2(Nf), r2(Ba), r2(mc), r2(ao), r2(Ao), r2(bc), r2(nx), r2($o), r2(Jx), r2(If), r2(uf), r2(rc), r2($f), r2(Dx), r2(Go), r2(aa), r2(Ea), r2(so), r2(Sa), r2(Wx), r2(rx), r2(co), r2(po), r2(cx), r2(cu), r2($a), r2(uo), r2(Ya), r2(lf), r2(So), r2(no), r2(ac), r2(Df), r2(nc), r2(Uo), r2(v7), r2(Xa), r2(Xx), r2(Eu), r2(fa), r2(Ta), r2(ec), r2(zo), r2(px), r2(Po), r2(hf), r2(ja), r2(oc), r2(Ax), r2(Zx), r2(ro), r2(Ho), r2(Sf), r2(lc), r2(ua), r2(ha), r2(bf), r2(ka), r2(Ff), r2(xo), r2(dc), r2(Sc), r2(Cx), r2(To), r2(Ga), r2(yx), r2(fx), r2(Pa), r2(kx), r2(Gf), r2(_o), r2(gf), r2(Jo), r2(Hf), r2(Ux), r2(oa), r2(ga), r2(Aa), r2(va), r2(Mo), r2(wc), r2(_c), r2(Uu), r2(Ju), r2(Ha), r2(Ja), r2(ax), r2(yc), r2(kc), r2(F7), r2(I7), r2(pf), r2(Va), r2(Tx), r2(of), r2(mi), r2(Ix), r2(qx), r2(Fx), r2(gx), r2(nf), r2(zx), r2(Wo), r2(G7), r2(vf), r2(wf), r2(jf), r2(De), r2(Tc), r2(bo), r2(Za), r2(sf), r2(Kf), r2(Mf), r2(Ca), r2(oo), r2(Cf), r2(_x), r2(ix), r2(Oa), r2(lx), r2(Fo), r2(Ua), r2(na), r2(Gx), r2(Rf), r2(Jf), r2(mx), r2(pa), r2(Ec), r2(qa), r2(da), r2(io), r2(kf), r2(af), r2(ho), r2(Ro), r2(Rx), r2(ux), r2(Ef), r2(qf), r2(Ra), r2(Ox), r2(ya), r2(xa), r2(vx), r2(Bo), r2(za), r2(Bf), r2(Da), r2(wo), r2(Vo), r2(Wf), r2(xf), r2(Nu), r2(Zf), r2(eo), r2(hx), r2(Ia), r2(Vx), r2(N7), r2(Lf), r2(sc), r2(vo), r2(wx), r2(Pf), r2($x), r2(Na), r2(lo), r2(Qa), r2(No), r2(La), r2(df), r2(Tn), r2(Hx), r2(mf), r2(rf), r2(Zo), r2(gc), r2(xx), r2(jx), r2(A7), r2(ca), r2(e7), r2(to), r2(Fc), r2(Io), r2(xr)], Qjr = [0, r2(_f), r2(Qf), r2(_a4), r2(Vf), r2(Tf), r2(Yf), r2(qo), r2(ex), r2(Nx), r2(ko), r2(Ka), r2(D7), r2(Xo), r2(ea), r2(tc), r2(pc), r2(bx), r2(ff), r2(ra), r2(Bx), r2(Yx), r2(li), r2(hc), r2(Lx), r2(Wa), r2(sa), r2(Of), r2(yi), r2(Oo), r2(gY), r2(Mx), r2(ta), r2(zf), r2(sx), r2(tx), r2(Qi), r2(jo), r2(Af), r2(ba), r2(vc), r2(ic), r2(yo), r2(Kx), r2(ma), r2(ia), r2(Sx), r2(la), r2(Px), r2(yf), r2(tf), r2(go), r2(Qo), r2(wa), r2(uH), r2(Xf), r2(Yo), r2(Ko), r2(Uf), r2(fc), r2(r7), r2(Nf), r2(Ba), r2(mc), r2(ao), r2(Ao), r2(bc), r2(nx), r2($o), r2(Jx), r2(If), r2(uf), r2(rc), r2($f), r2(Dx), r2(Go), r2(aa), r2(Ea), r2(so), r2(Sa), r2(Wx), r2(rx), r2(co), r2(po), r2(cx), r2(cu), r2($a), r2(uo), r2(Ya), r2(lf), r2(So), r2(no), r2(ac), r2(Df), r2(nc), r2(Uo), r2(v7), r2(Xa), r2(Xx), r2(Eu), r2(fa), r2(Ta), r2(ec), r2(zo), r2(px), r2(Po), r2(hf), r2(ja), r2(oc), r2(Ax), r2(Zx), r2(ro), r2(Ho), r2(Sf), r2(lc), r2(ua), r2(ha), r2(bf), r2(ka), r2(Ff), r2(xo), r2(dc), r2(Sc), r2(Cx), r2(To), r2(Ga), r2(yx), r2(fx), r2(Pa), r2(kx), r2(Gf), r2(_o), r2(gf), r2(Jo), r2(Hf), r2(Ux), r2(oa), r2(ga), r2(Aa), r2(va), r2(Mo), r2(wc), r2(_c), r2(Uu), r2(Ju), r2(Ha), r2(Ja), r2(ax), r2(yc), r2(kc), r2(F7), r2(I7), r2(pf), r2(Va), r2(Tx), r2(of), r2(mi), r2(Ix), r2(qx), r2(Fx), r2(gx), r2(nf), r2(zx), r2(Wo), r2(G7), r2(vf), r2(wf), r2(jf), r2(De), r2(Tc), r2(bo), r2(Za), r2(sf), r2(Kf), r2(Mf), r2(Ca), r2(oo), r2(Cf), r2(_x), r2(ix), r2(Oa), r2(lx), r2(Fo), r2(Ua), r2(na), r2(Gx), r2(Rf), r2(qU), r2(Jf), r2(mx), r2(pa), r2(Ec), r2(qa), r2(da), r2(io), r2(kf), r2(af), r2(ho), r2(Ro), r2(iH), r2(Rx), r2(ux), r2(Ef), r2(qf), r2(dU), r2(Ra), r2(Ox), r2(ya), r2(xa), r2(vx), r2(Bo), r2(za), r2(Bf), r2(Da), r2(wo), r2(Vo), r2(Wf), r2(xf), r2(Nu), r2(Zf), r2(eo), r2(hx), r2(Ia), r2(Vx), r2(N7), r2(Lf), r2(sc), r2(vo), r2(wx), r2(Pf), r2($x), r2(Na), r2(lo), r2(Qa), r2(No), r2(La), r2(df), r2(Tn), r2(Hx), r2(mf), r2(rf), r2(Zo), r2(gc), r2(xx), r2(jx), r2(A7), r2(ca), r2(e7), r2(to), r2(Fc), r2(Io), r2(xr)], rGr = r2(Y4), eGr = r2(I2), nGr = [0, [11, r2("Failure while looking up "), [2, 0, [11, r2(". Index: "), [4, 0, 0, 0, [11, r2(". Length: "), [4, 0, 0, 0, [12, 46, 0]]]]]]], r2("Failure while looking up %s. Index: %d. Length: %d.")], tGr = [0, 0, 0, 0], uGr = r2("Offset_utils.Offset_lookup_failed"), iGr = r2(KY), fGr = r2(hE), xGr = r2(CY), oGr = r2(VX), aGr = r2(VX), cGr = r2(CY), sGr = r2(Jc), vGr = r2(Xr), lGr = r2(Wn), bGr = r2("Program"), pGr = r2(Ud), mGr = r2("BreakStatement"), _Gr = r2(Ud), yGr = r2("ContinueStatement"), hGr = r2("DebuggerStatement"), dGr = r2(cc), kGr = r2("DeclareExportAllDeclaration"), wGr = r2(cc), EGr = r2(Cv), SGr = r2(P2), gGr = r2(_i), FGr = r2("DeclareExportDeclaration"), TGr = r2($c), OGr = r2(Wn), IGr = r2(mt), AGr = r2("DeclareModule"), NGr = r2(C7), CGr = r2("DeclareModuleExports"), PGr = r2(Ss), DGr = r2(Wn), LGr = r2("DoWhileStatement"), RGr = r2("EmptyStatement"), jGr = r2(bO), GGr = r2(P2), MGr = r2("ExportDefaultDeclaration"), BGr = r2(bO), qGr = r2(I4), UGr = r2(cc), HGr = r2("ExportAllDeclaration"), XGr = r2(bO), YGr = r2(cc), VGr = r2(Cv), zGr = r2(P2), KGr = r2("ExportNamedDeclaration"), WGr = r2(Zi), JGr = r2(Nu), $Gr = r2("ExpressionStatement"), ZGr = r2(Wn), QGr = r2(fU), rMr = r2(Ss), eMr = r2(ji), nMr = r2("ForStatement"), tMr = r2(R8), uMr = r2(Wn), iMr = r2(Cu), fMr = r2(bi), xMr = r2("ForInStatement"), oMr = r2(dx), aMr = r2(Wn), cMr = r2(Cu), sMr = r2(bi), vMr = r2("ForOfStatement"), lMr = r2(m3), bMr = r2(kv), pMr = r2(Ss), mMr = r2("IfStatement"), _Mr = r2(Jc), yMr = r2(rs), hMr = r2(Bn), dMr = r2(cX), kMr = r2(cc), wMr = r2(Cv), EMr = r2("ImportDeclaration"), SMr = r2(Wn), gMr = r2(Ud), FMr = r2("LabeledStatement"), TMr = r2(l7), OMr = r2("ReturnStatement"), IMr = r2(QX), AMr = r2("discriminant"), NMr = r2("SwitchStatement"), CMr = r2(l7), PMr = r2("ThrowStatement"), DMr = r2(CH), LMr = r2(MU), RMr = r2(Tn), jMr = r2("TryStatement"), GMr = r2(Wn), MMr = r2(Ss), BMr = r2("WhileStatement"), qMr = r2(Wn), UMr = r2(xk), HMr = r2("WithStatement"), XMr = r2(PH), YMr = r2("ArrayExpression"), VMr = r2(O7), zMr = r2(p6), KMr = r2(Nu), WMr = r2(r7), JMr = r2(G7), $Mr = r2(gs), ZMr = r2(Wn), QMr = r2(Dt), rBr = r2(mt), eBr = r2("ArrowFunctionExpression"), nBr = r2(XO), tBr = r2(Cu), uBr = r2(bi), iBr = r2(ul), fBr = r2("AssignmentExpression"), xBr = r2(Cu), oBr = r2(bi), aBr = r2(ul), cBr = r2("BinaryExpression"), sBr = r2("CallExpression"), vBr = r2(T4), lBr = r2(aY), bBr = r2("ComprehensionExpression"), pBr = r2(m3), mBr = r2(kv), _Br = r2(Ss), yBr = r2("ConditionalExpression"), hBr = r2(T4), dBr = r2(aY), kBr = r2("GeneratorExpression"), wBr = r2(cc), EBr = r2("ImportExpression"), SBr = r2(zH), gBr = r2(MX), FBr = r2(Ke), TBr = r2(Cu), OBr = r2(bi), IBr = r2(ul), ABr = r2("LogicalExpression"), NBr = r2("MemberExpression"), CBr = r2(Iv), PBr = r2(el), DBr = r2("MetaProperty"), LBr = r2(C2), RBr = r2(TX), jBr = r2(jH), GBr = r2("NewExpression"), MBr = r2(H4), BBr = r2("ObjectExpression"), qBr = r2(qu), UBr = r2("OptionalCallExpression"), HBr = r2(qu), XBr = r2("OptionalMemberExpression"), YBr = r2(Mg), VBr = r2("SequenceExpression"), zBr = r2("Super"), KBr = r2("ThisExpression"), WBr = r2(C7), JBr = r2(Nu), $Br = r2("TypeCastExpression"), ZBr = r2(l7), QBr = r2("AwaitExpression"), rqr = r2(Fa), eqr = r2(xs), nqr = r2(Kt), tqr = r2(ZY), uqr = r2(rs), iqr = r2(es), fqr = r2(J2), xqr = r2("matched above"), oqr = r2(l7), aqr = r2(qE), cqr = r2(ul), sqr = r2("UnaryExpression"), vqr = r2(oV), lqr = r2(sH), bqr = r2(qE), pqr = r2(l7), mqr = r2(ul), _qr = r2("UpdateExpression"), yqr = r2(lY), hqr = r2(l7), dqr = r2("YieldExpression"), kqr = r2("Unexpected FunctionDeclaration with BodyExpression"), wqr = r2(O7), Eqr = r2(p6), Sqr = r2(Nu), gqr = r2(r7), Fqr = r2(G7), Tqr = r2(gs), Oqr = r2(Wn), Iqr = r2(Dt), Aqr = r2(mt), Nqr = r2("FunctionDeclaration"), Cqr = r2("Unexpected FunctionExpression with BodyExpression"), Pqr = r2(O7), Dqr = r2(p6), Lqr = r2(Nu), Rqr = r2(r7), jqr = r2(G7), Gqr = r2(gs), Mqr = r2(Wn), Bqr = r2(Dt), qqr = r2(mt), Uqr = r2("FunctionExpression"), Hqr = r2(qu), Xqr = r2(C7), Yqr = r2(ui), Vqr = r2(tn), zqr = r2(qu), Kqr = r2(C7), Wqr = r2(ui), Jqr = r2("PrivateIdentifier"), $qr = r2(qu), Zqr = r2(C7), Qqr = r2(ui), rUr = r2(tn), eUr = r2(kv), nUr = r2(Ss), tUr = r2("SwitchCase"), uUr = r2(Wn), iUr = r2("param"), fUr = r2("CatchClause"), xUr = r2(Wn), oUr = r2("BlockStatement"), aUr = r2(mt), cUr = r2("DeclareVariable"), sUr = r2(r7), vUr = r2(mt), lUr = r2("DeclareFunction"), bUr = r2(Hy), pUr = r2(ws), mUr = r2(P7), _Ur = r2(Wn), yUr = r2(O7), hUr = r2(mt), dUr = r2("DeclareClass"), kUr = r2(P7), wUr = r2(Wn), EUr = r2(O7), SUr = r2(mt), gUr = r2("DeclareInterface"), FUr = r2(Bn), TUr = r2(Jc), OUr = r2(I4), IUr = r2("ExportNamespaceSpecifier"), AUr = r2(Cu), NUr = r2(O7), CUr = r2(mt), PUr = r2("DeclareTypeAlias"), DUr = r2(Cu), LUr = r2(O7), RUr = r2(mt), jUr = r2("TypeAlias"), GUr = r2("DeclareOpaqueType"), MUr = r2("OpaqueType"), BUr = r2(SX), qUr = r2(mX), UUr = r2(O7), HUr = r2(mt), XUr = r2("ClassDeclaration"), YUr = r2("ClassExpression"), VUr = r2(j_), zUr = r2(ws), KUr = r2("superTypeParameters"), WUr = r2("superClass"), JUr = r2(O7), $Ur = r2(Wn), ZUr = r2(mt), QUr = r2(Nu), rHr = r2("Decorator"), eHr = r2(O7), nHr = r2(mt), tHr = r2("ClassImplements"), uHr = r2(Wn), iHr = r2("ClassBody"), fHr = r2(wv), xHr = r2(F2), oHr = r2(n1), aHr = r2(lv), cHr = r2(j_), sHr = r2(pv), vHr = r2(nu), lHr = r2($c), bHr = r2(Bn), pHr = r2(ii), mHr = r2("MethodDefinition"), _Hr = r2(T2), yHr = r2(cu), hHr = r2(nu), dHr = r2(pv), kHr = r2(C7), wHr = r2(Bn), EHr = r2(ii), SHr = r2(xV), gHr = r2("Internal Error: Private name found in class prop"), FHr = r2(T2), THr = r2(cu), OHr = r2(nu), IHr = r2(pv), AHr = r2(C7), NHr = r2(Bn), CHr = r2(ii), PHr = r2(xV), DHr = r2(mt), LHr = r2(OX), RHr = r2(ji), jHr = r2(mt), GHr = r2("EnumStringMember"), MHr = r2(mt), BHr = r2(OX), qHr = r2(ji), UHr = r2(mt), HHr = r2("EnumNumberMember"), XHr = r2(ji), YHr = r2(mt), VHr = r2("EnumBooleanMember"), zHr = r2(T8), KHr = r2(DT), WHr = r2(A4), JHr = r2("EnumBooleanBody"), $Hr = r2(T8), ZHr = r2(DT), QHr = r2(A4), rXr = r2("EnumNumberBody"), eXr = r2(T8), nXr = r2(DT), tXr = r2(A4), uXr = r2("EnumStringBody"), iXr = r2(T8), fXr = r2(A4), xXr = r2("EnumSymbolBody"), oXr = r2(Wn), aXr = r2(mt), cXr = r2("EnumDeclaration"), sXr = r2(P7), vXr = r2(Wn), lXr = r2(O7), bXr = r2(mt), pXr = r2("InterfaceDeclaration"), mXr = r2(O7), _Xr = r2(mt), yXr = r2("InterfaceExtends"), hXr = r2(C7), dXr = r2(H4), kXr = r2("ObjectPattern"), wXr = r2(C7), EXr = r2(PH), SXr = r2("ArrayPattern"), gXr = r2(Cu), FXr = r2(bi), TXr = r2(DF), OXr = r2(C7), IXr = r2(ui), AXr = r2(tn), NXr = r2(l7), CXr = r2(iX), PXr = r2(l7), DXr = r2(iX), LXr = r2(Cu), RXr = r2(bi), jXr = r2(DF), GXr = r2(ji), MXr = r2(ji), BXr = r2(n1), qXr = r2(lv), UXr = r2(aH), HXr = r2(pv), XXr = r2(f6), YXr = r2(F2), VXr = r2($c), zXr = r2(Bn), KXr = r2(ii), WXr = r2(_U), JXr = r2(l7), $Xr = r2("SpreadProperty"), ZXr = r2(Cu), QXr = r2(bi), rYr = r2(DF), eYr = r2(pv), nYr = r2(f6), tYr = r2(F2), uYr = r2($c), iYr = r2(Bn), fYr = r2(ii), xYr = r2(_U), oYr = r2(l7), aYr = r2("SpreadElement"), cYr = r2(R8), sYr = r2(Cu), vYr = r2(bi), lYr = r2("ComprehensionBlock"), bYr = r2("We should not create Literal nodes for bigints"), pYr = r2(jX), mYr = r2(mi), _Yr = r2("regex"), yYr = r2(c7), hYr = r2(Bn), dYr = r2(c7), kYr = r2(Bn), wYr = r2(H6), EYr = r2(c7), SYr = r2(Bn), gYr = r2(H6), FYr = r2(x1), TYr = r2(Bn), OYr = r2("BigIntLiteral"), IYr = r2(c7), AYr = r2(Bn), NYr = r2(H6), CYr = r2(Gi), PYr = r2(Ci), DYr = r2(c7), LYr = r2(Bn), RYr = r2(H6), jYr = r2(Mg), GYr = r2("quasis"), MYr = r2("TemplateLiteral"), BYr = r2(PY), qYr = r2(c7), UYr = r2(aU), HYr = r2(Bn), XYr = r2("TemplateElement"), YYr = r2(EY), VYr = r2("tag"), zYr = r2("TaggedTemplateExpression"), KYr = r2(U2), WYr = r2(G2), JYr = r2(D2), $Yr = r2($c), ZYr = r2("declarations"), QYr = r2("VariableDeclaration"), rVr = r2(ji), eVr = r2(mt), nVr = r2("VariableDeclarator"), tVr = r2($c), uVr = r2("Variance"), iVr = r2("AnyTypeAnnotation"), fVr = r2("MixedTypeAnnotation"), xVr = r2("EmptyTypeAnnotation"), oVr = r2("VoidTypeAnnotation"), aVr = r2("NullLiteralTypeAnnotation"), cVr = r2("SymbolTypeAnnotation"), sVr = r2("NumberTypeAnnotation"), vVr = r2("BigIntTypeAnnotation"), lVr = r2("StringTypeAnnotation"), bVr = r2("BooleanTypeAnnotation"), pVr = r2(C7), mVr = r2("NullableTypeAnnotation"), _Vr = r2(O7), yVr = r2(xd), hVr = r2(p6), dVr = r2(i1), kVr = r2(Dt), wVr = r2("FunctionTypeAnnotation"), EVr = r2(qu), SVr = r2(C7), gVr = r2(ui), FVr = r2(RH), TVr = r2(qu), OVr = r2(C7), IVr = r2(ui), AVr = r2(RH), NVr = [0, 0, 0, 0, 0], CVr = r2("internalSlots"), PVr = r2("callProperties"), DVr = r2("indexers"), LVr = r2(H4), RVr = r2("exact"), jVr = r2(GY), GVr = r2("ObjectTypeAnnotation"), MVr = r2(aH), BVr = r2("There should not be computed object type property keys"), qVr = r2(ji), UVr = r2(n1), HVr = r2(lv), XVr = r2($c), YVr = r2(cu), VVr = r2(X3), zVr = r2(nu), KVr = r2(qu), WVr = r2(F2), JVr = r2(Bn), $Vr = r2(ii), ZVr = r2("ObjectTypeProperty"), QVr = r2(l7), rzr = r2("ObjectTypeSpreadProperty"), ezr = r2(cu), nzr = r2(nu), tzr = r2(Bn), uzr = r2(ii), izr = r2(mt), fzr = r2("ObjectTypeIndexer"), xzr = r2(nu), ozr = r2(Bn), azr = r2("ObjectTypeCallProperty"), czr = r2(Bn), szr = r2(F2), vzr = r2(nu), lzr = r2(qu), bzr = r2(mt), pzr = r2("ObjectTypeInternalSlot"), mzr = r2(Wn), _zr = r2(P7), yzr = r2("InterfaceTypeAnnotation"), hzr = r2("elementType"), dzr = r2("ArrayTypeAnnotation"), kzr = r2(mt), wzr = r2(eY), Ezr = r2("QualifiedTypeIdentifier"), Szr = r2(O7), gzr = r2(mt), Fzr = r2("GenericTypeAnnotation"), Tzr = r2("indexType"), Ozr = r2("objectType"), Izr = r2("IndexedAccessType"), Azr = r2(qu), Nzr = r2("OptionalIndexedAccessType"), Czr = r2($6), Pzr = r2("UnionTypeAnnotation"), Dzr = r2($6), Lzr = r2("IntersectionTypeAnnotation"), Rzr = r2(l7), jzr = r2("TypeofTypeAnnotation"), Gzr = r2(mt), Mzr = r2(eY), Bzr = r2("QualifiedTypeofIdentifier"), qzr = r2($6), Uzr = r2("TupleTypeAnnotation"), Hzr = r2(c7), Xzr = r2(Bn), Yzr = r2("StringLiteralTypeAnnotation"), Vzr = r2(c7), zzr = r2(Bn), Kzr = r2("NumberLiteralTypeAnnotation"), Wzr = r2(c7), Jzr = r2(Bn), $zr = r2("BigIntLiteralTypeAnnotation"), Zzr = r2(Gi), Qzr = r2(Ci), rKr = r2(c7), eKr = r2(Bn), nKr = r2("BooleanLiteralTypeAnnotation"), tKr = r2("ExistsTypeAnnotation"), uKr = r2(C7), iKr = r2("TypeAnnotation"), fKr = r2(Dt), xKr = r2("TypeParameterDeclaration"), oKr = r2(_i), aKr = r2(cu), cKr = r2(DU), sKr = r2(ui), vKr = r2("TypeParameter"), lKr = r2(Dt), bKr = r2(gH), pKr = r2(Dt), mKr = r2(gH), _Kr = r2(bv), yKr = r2(Ve), hKr = r2("closingElement"), dKr = r2("openingElement"), kKr = r2("JSXElement"), wKr = r2("closingFragment"), EKr = r2(Ve), SKr = r2("openingFragment"), gKr = r2("JSXFragment"), FKr = r2("selfClosing"), TKr = r2(mY), OKr = r2(ui), IKr = r2("JSXOpeningElement"), AKr = r2("JSXOpeningFragment"), NKr = r2(ui), CKr = r2("JSXClosingElement"), PKr = r2("JSXClosingFragment"), DKr = r2(Bn), LKr = r2(ui), RKr = r2("JSXAttribute"), jKr = r2(l7), GKr = r2("JSXSpreadAttribute"), MKr = r2("JSXEmptyExpression"), BKr = r2(Nu), qKr = r2("JSXExpressionContainer"), UKr = r2(Nu), HKr = r2("JSXSpreadChild"), XKr = r2(c7), YKr = r2(Bn), VKr = r2("JSXText"), zKr = r2(Iv), KKr = r2(xk), WKr = r2("JSXMemberExpression"), JKr = r2(ui), $Kr = r2("namespace"), ZKr = r2("JSXNamespacedName"), QKr = r2(ui), rWr = r2("JSXIdentifier"), eWr = r2(I4), nWr = r2(B2), tWr = r2("ExportSpecifier"), uWr = r2(B2), iWr = r2("ImportDefaultSpecifier"), fWr = r2(B2), xWr = r2("ImportNamespaceSpecifier"), oWr = r2(cX), aWr = r2(B2), cWr = r2("imported"), sWr = r2("ImportSpecifier"), vWr = r2("Line"), lWr = r2("Block"), bWr = r2(Bn), pWr = r2(Bn), mWr = r2("DeclaredPredicate"), _Wr = r2("InferredPredicate"), yWr = r2(C2), hWr = r2(TX), dWr = r2(jH), kWr = r2(pv), wWr = r2(Iv), EWr = r2(xk), SWr = r2("message"), gWr = r2(hE), FWr = r2(HH), TWr = r2(g7), OWr = r2(cc), IWr = r2(I2), AWr = r2(Y4), NWr = [0, [3, 0, 0], r2(Vt)], CWr = r2(M2), PWr = r2(A3), DWr = r2(R2), LWr = r2(j2), RWr = r2(Ju), jWr = r2(D7), GWr = r2(i1), MWr = r2(F7), BWr = r2(d4), qWr = r2(U2), UWr = r2(K6), HWr = r2(C8), XWr = r2(D2), YWr = r2(G2), VWr = r2(fs4), zWr = r2(Ci), KWr = r2(Gi), WWr = r2(A7), JWr = r2(d6), $Wr = r2(o6), ZWr = r2(N7), QWr = r2(_i), rJr = r2(_4), eJr = r2(q8), nJr = r2(np), tJr = r2(q2), uJr = r2(P7), iJr = r2(nu), fJr = r2(U4), xJr = r2(u1), oJr = r2(J2), aJr = r2(rs), cJr = r2(es), sJr = r2(b8), vJr = r2(_3), lJr = r2(Uu), bJr = r2(yv), pJr = r2(ws), mJr = r2(e7), _Jr = r2(y4), yJr = r2(k4), hJr = r2(a6), dJr = r2(E6), kJr = r2(Eu), wJr = r2(I7), EJr = r2(T2), SJr = r2(Jc), gJr = r2(eh), FJr = r2(CS), TJr = r2(gs), OJr = r2(dx), IJr = r2(n6), AJr = r2(H8), NJr = r2(v7), CJr = r2(dv), PJr = r2(x1), DJr = r2(Tv), LJr = r2(es), RJr = r2(K4), jJr = r2(O2), GJr = r2(O6), MJr = [0, r2(g3)], BJr = r2(C), qJr = [7, 0], UJr = r2(C), HJr = [0, 1], XJr = [0, 2], YJr = [0, 3], VJr = [0, 0], zJr = [0, 0], KJr = [0, 0, 0, 0, 0], WJr = [0, r2(vv), 906, 6], JJr = [0, r2(vv), ZX, 6], $Jr = [0, 0], ZJr = [0, r2(vv), 1012, 8], QJr = r2(X3), r$r = [0, r2(vv), 1029, 8], e$r = r2("Can not have both `static` and `proto`"), n$r = r2(nu), t$r = r2(X3), u$r = r2(n1), i$r = r2(lv), f$r = r2(n1), x$r = r2(wv), o$r = r2(oH), a$r = [0, 0, 0, 0], c$r = [0, [0, 0, 0, 0, 0]], s$r = r2(i1), v$r = [0, r2("a type")], l$r = [0, 0], b$r = [0, 0], p$r = [14, 1], m$r = [14, 0], _$r = [0, r2(vv), EH, 15], y$r = [0, r2(vv), L7, 15], h$r = [0, 44], d$r = [0, 44], k$r = r2(M2), w$r = [0, r2(C), 0], E$r = [0, 0, 0], S$r = [0, 0, 0], g$r = [0, 0, 0], F$r = [0, 41], T$r = r2(Qu), O$r = r2(Qu), I$r = [0, r2("a regular expression")], A$r = r2(C), N$r = r2(C), C$r = r2(C), P$r = [0, r2("src/parser/expression_parser.ml"), CU, 17], D$r = [0, r2("a template literal part")], L$r = [0, [0, r2(C), r2(C)], 1], R$r = r2(fs4), j$r = r2(fs4), G$r = r2(Gi), M$r = r2(Ci), B$r = r2("Invalid bigint "), q$r = r2("Invalid bigint binary/octal "), U$r = r2(H2), H$r = r2(pH), X$r = r2(Nh), Y$r = r2(Nh), V$r = r2(oU), z$r = [0, 44], K$r = [0, 1], W$r = [0, 1], J$r = [0, 1], $$r = [0, 1], Z$r = [0, 0], Q$r = r2(bv), rZr = r2(bv), eZr = r2(u1), nZr = r2(gS), tZr = [0, r2("the identifier `target`")], uZr = [0, 0], iZr = r2(Uu), fZr = r2(el), xZr = r2(el), oZr = r2(yv), aZr = [0, 0], cZr = [0, r2("either a call or access of `super`")], sZr = r2(yv), vZr = [0, 0], lZr = [0, 1], bZr = [0, 0], pZr = [0, 1], mZr = [0, 0], _Zr = [0, 1], yZr = [0, 0], hZr = [0, 2], dZr = [0, 3], kZr = [0, 7], wZr = [0, 6], EZr = [0, 4], SZr = [0, 5], gZr = [0, [0, 17, [0, 2]]], FZr = [0, [0, 18, [0, 3]]], TZr = [0, [0, 19, [0, 4]]], OZr = [0, [0, 0, [0, 5]]], IZr = [0, [0, 1, [0, 5]]], AZr = [0, [0, 2, [0, 5]]], NZr = [0, [0, 3, [0, 5]]], CZr = [0, [0, 5, [0, 6]]], PZr = [0, [0, 7, [0, 6]]], DZr = [0, [0, 4, [0, 6]]], LZr = [0, [0, 6, [0, 6]]], RZr = [0, [0, 8, [0, 7]]], jZr = [0, [0, 9, [0, 7]]], GZr = [0, [0, 10, [0, 7]]], MZr = [0, [0, 11, [0, 8]]], BZr = [0, [0, 12, [0, 8]]], qZr = [0, [0, 15, [0, 9]]], UZr = [0, [0, 13, [0, 9]]], HZr = [0, [0, 14, [1, 10]]], XZr = [0, [0, 16, [0, 9]]], YZr = [0, [0, 21, [0, 6]]], VZr = [0, [0, 20, [0, 6]]], zZr = [23, r2(Ke)], KZr = [0, [0, 8]], WZr = [0, [0, 7]], JZr = [0, [0, 6]], $Zr = [0, [0, 10]], ZZr = [0, [0, 9]], QZr = [0, [0, 11]], rQr = [0, [0, 5]], eQr = [0, [0, 4]], nQr = [0, [0, 2]], tQr = [0, [0, 3]], uQr = [0, [0, 1]], iQr = [0, [0, 0]], fQr = [0, [0, 12]], xQr = [0, [0, 13]], oQr = [0, [0, 14]], aQr = [0, 0], cQr = r2(Uu), sQr = r2(u1), vQr = r2(gS), lQr = r2(el), bQr = r2(gs), pQr = r2(Uu), mQr = r2(u1), _Qr = r2(gS), yQr = r2(el), hQr = r2(o1), dQr = r2(Lo), kQr = [17, r2("JSX fragment")], wQr = [0, Ni], EQr = [1, Ni], SQr = r2(C), gQr = [0, r2(C)], FQr = [0, r2(g3)], TQr = r2(C), OQr = [0, 0, 0, 0], IQr = [0, r2("src/hack_forked/utils/collections/flow_map.ml"), 717, 36], AQr = [0, 0, 0], NQr = r2(q2), CQr = [0, r2(C), 0], PQr = r2("unexpected PrivateName in Property, expected a PrivateField"), DQr = r2(wv), LQr = r2(oH), RQr = [0, 0, 0], jQr = r2(wv), GQr = r2(wv), MQr = r2(n1), BQr = r2(lv), qQr = [0, 1], UQr = [0, 1], HQr = [0, 1], XQr = r2(wv), YQr = r2(n1), VQr = r2(lv), zQr = r2(XO), KQr = r2(Eu), WQr = r2(dx), JQr = r2("Internal Error: private name found in object props"), $Qr = r2(cV), ZQr = [0, r2(g3)], QQr = r2(Eu), r0e = r2(dx), e0e = r2(Eu), n0e = r2(dx), t0e = r2(cV), u0e = [10, r2(yi)], i0e = [0, 1], f0e = r2(a1), x0e = r2(K2), o0e = [0, r2(LS), 1763, 21], a0e = r2(K2), c0e = r2(a1), s0e = [0, r2("a declaration, statement or export specifiers")], v0e = [0, 40], l0e = r2(a1), b0e = r2(K2), p0e = [0, r2(C), r2(C), 0], m0e = [0, r2(EU)], _0e = r2(pU), y0e = r2("exports"), h0e = [0, 1], d0e = [0, 1], k0e = [0, 0], w0e = r2(pU), E0e = [0, 40], S0e = r2(Hy), g0e = [0, 0], F0e = [0, 1], T0e = [0, 83], O0e = [0, 0], I0e = [0, 1], A0e = r2(a1), N0e = r2(a1), C0e = r2(K2), P0e = r2(a1), D0e = [0, r2("the keyword `as`")], L0e = r2(a1), R0e = r2(K2), j0e = [0, r2(EU)], G0e = [0, r2("the keyword `from`")], M0e = [0, r2(C), r2(C), 0], B0e = [0, r2(tU)], q0e = r2("Label"), U0e = [0, r2(tU)], H0e = [0, 0, 0], X0e = [0, 29], Y0e = [0, r2(LS), 431, 22], V0e = [0, 28], z0e = [0, r2(LS), 450, 22], K0e = [0, 0], W0e = r2("the token `;`"), J0e = [0, 0], $0e = [0, 0], Z0e = r2(dx), Q0e = r2(G2), rre = r2(Eu), ere = [0, r2(HU)], nre = [15, [0, 0]], tre = [0, r2(HU)], ure = r2("use strict"), ire = [0, 0, 0, 0], fre = r2(MI), xre = r2("Nooo: "), ore = r2(_i), are = r2("Parser error: No such thing as an expression pattern!"), cre = r2(C), sre = [0, [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]], vre = [0, r2("src/parser/parser_flow.ml"), NT, 28], lre = [0, [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]], bre = r2(Bn), pre = r2(KY), mre = r2(I2), _re = r2(Y4), yre = r2(HH), hre = r2(I2), dre = r2(Y4), kre = r2(g7), wre = r2(hE), Ere = r2("normal"), Sre = r2(Jc), gre = r2("jsxTag"), Fre = r2("jsxChild"), Tre = r2("template"), Ore = r2(MH), Ire = r2("context"), Are = r2(Jc), Nre = r2("use_strict"), Cre = r2($6), Pre = r2("esproposal_export_star_as"), Dre = r2("esproposal_decorators"), Lre = r2("enums"), Rre = r2("Internal error: ");
            function Gt(t4) {
              if (typeof t4 == "number")
                return 0;
              switch (t4[0]) {
                case 0:
                  return [0, Gt(t4[1])];
                case 1:
                  return [1, Gt(t4[1])];
                case 2:
                  return [2, Gt(t4[1])];
                case 3:
                  return [3, Gt(t4[1])];
                case 4:
                  return [4, Gt(t4[1])];
                case 5:
                  return [5, Gt(t4[1])];
                case 6:
                  return [6, Gt(t4[1])];
                case 7:
                  return [7, Gt(t4[1])];
                case 8:
                  var n = t4[1];
                  return [8, n, Gt(t4[2])];
                case 9:
                  var e4 = t4[1];
                  return [9, e4, e4, Gt(t4[3])];
                case 10:
                  return [10, Gt(t4[1])];
                case 11:
                  return [11, Gt(t4[1])];
                case 12:
                  return [12, Gt(t4[1])];
                case 13:
                  return [13, Gt(t4[1])];
                default:
                  return [14, Gt(t4[1])];
              }
            }
            function u7(t4, n) {
              if (typeof t4 == "number")
                return n;
              switch (t4[0]) {
                case 0:
                  return [0, u7(t4[1], n)];
                case 1:
                  return [1, u7(t4[1], n)];
                case 2:
                  return [2, u7(t4[1], n)];
                case 3:
                  return [3, u7(t4[1], n)];
                case 4:
                  return [4, u7(t4[1], n)];
                case 5:
                  return [5, u7(t4[1], n)];
                case 6:
                  return [6, u7(t4[1], n)];
                case 7:
                  return [7, u7(t4[1], n)];
                case 8:
                  var e4 = t4[1];
                  return [8, e4, u7(t4[2], n)];
                case 9:
                  var i4 = t4[2], x4 = t4[1];
                  return [9, x4, i4, u7(t4[3], n)];
                case 10:
                  return [10, u7(t4[1], n)];
                case 11:
                  return [11, u7(t4[1], n)];
                case 12:
                  return [12, u7(t4[1], n)];
                case 13:
                  return [13, u7(t4[1], n)];
                default:
                  return [14, u7(t4[1], n)];
              }
            }
            function At(t4, n) {
              if (typeof t4 == "number")
                return n;
              switch (t4[0]) {
                case 0:
                  return [0, At(t4[1], n)];
                case 1:
                  return [1, At(t4[1], n)];
                case 2:
                  var e4 = t4[1];
                  return [2, e4, At(t4[2], n)];
                case 3:
                  var i4 = t4[1];
                  return [3, i4, At(t4[2], n)];
                case 4:
                  var x4 = t4[3], c = t4[2], s2 = t4[1];
                  return [4, s2, c, x4, At(t4[4], n)];
                case 5:
                  var p = t4[3], y = t4[2], T = t4[1];
                  return [5, T, y, p, At(t4[4], n)];
                case 6:
                  var E = t4[3], d = t4[2], w = t4[1];
                  return [6, w, d, E, At(t4[4], n)];
                case 7:
                  var G = t4[3], A11 = t4[2], S11 = t4[1];
                  return [7, S11, A11, G, At(t4[4], n)];
                case 8:
                  var M = t4[3], K = t4[2], V = t4[1];
                  return [8, V, K, M, At(t4[4], n)];
                case 9:
                  var f0 = t4[1];
                  return [9, f0, At(t4[2], n)];
                case 10:
                  return [10, At(t4[1], n)];
                case 11:
                  var m0 = t4[1];
                  return [11, m0, At(t4[2], n)];
                case 12:
                  var k0 = t4[1];
                  return [12, k0, At(t4[2], n)];
                case 13:
                  var g0 = t4[2], e0 = t4[1];
                  return [13, e0, g0, At(t4[3], n)];
                case 14:
                  var x0 = t4[2], l = t4[1];
                  return [14, l, x0, At(t4[3], n)];
                case 15:
                  return [15, At(t4[1], n)];
                case 16:
                  return [16, At(t4[1], n)];
                case 17:
                  var c0 = t4[1];
                  return [17, c0, At(t4[2], n)];
                case 18:
                  var t0 = t4[1];
                  return [18, t0, At(t4[2], n)];
                case 19:
                  return [19, At(t4[1], n)];
                case 20:
                  var o0 = t4[2], w0 = t4[1];
                  return [20, w0, o0, At(t4[3], n)];
                case 21:
                  var _0 = t4[1];
                  return [21, _0, At(t4[2], n)];
                case 22:
                  return [22, At(t4[1], n)];
                case 23:
                  var E0 = t4[1];
                  return [23, E0, At(t4[2], n)];
                default:
                  var U0 = t4[2], b = t4[1];
                  return [24, b, U0, At(t4[3], n)];
              }
            }
            function nN(t4, n, e4) {
              return t4[1] === n ? (t4[1] = e4, 1) : 0;
            }
            function ke(t4) {
              throw [0, q7, t4];
            }
            function Pu(t4) {
              throw [0, ZA, t4];
            }
            M7(0);
            function gp(t4) {
              return 0 <= t4 ? t4 : -t4 | 0;
            }
            var jre = mH;
            function Te(t4, n) {
              var e4 = un(t4), i4 = un(n), x4 = Lt(e4 + i4 | 0);
              return Ts(t4, 0, x4, 0, e4), Ts(n, 0, x4, e4, i4), x4;
            }
            function Gre(t4) {
              return t4 ? fi0 : xi0;
            }
            function on(t4, n) {
              if (t4) {
                var e4 = t4[1];
                return [0, e4, on(t4[2], n)];
              }
              return n;
            }
            M70(0);
            var Mre = zV(1), Pc = zV(2);
            function Bre(t4) {
              function n(e4) {
                for (var i4 = e4; ; ) {
                  if (i4) {
                    var x4 = i4[2], c = i4[1];
                    try {
                      p1(c);
                    } catch (y) {
                      if (y = Et(y), y[1] !== $V)
                        throw y;
                      var s2 = y;
                    }
                    var i4 = x4;
                    continue;
                  }
                  return 0;
                }
              }
              return n(B70(0));
            }
            function vl(t4, n) {
              return zA(t4, n, 0, un(n));
            }
            function iz(t4) {
              return vl(Pc, t4), KV(Pc, 10), p1(Pc);
            }
            var tN = [0, Bre];
            function fz(t4) {
              for (; ; ) {
                var n = tN[1], e4 = [0, 1], i4 = 1 - nN(tN, n, function(x4, c) {
                  return function(s2) {
                    return nN(x4, 1, 0) && u(t4, 0), u(c, 0);
                  };
                }(e4, n));
                if (!i4)
                  return i4;
              }
            }
            function uN(t4) {
              return u(tN[1], 0);
            }
            WA(r2(sV), uN), K70(0) && fz(function(t4) {
              return l70(t4);
            });
            function xz(t4) {
              return 25 < (t4 + Y3 | 0) >>> 0 ? t4 : t4 + hU | 0;
            }
            var oz = J70(0)[1], ll = (4 * z70(0) | 0) - 1 | 0;
            M7(0);
            var qre = V70(0);
            function Dc(t4) {
              for (var n = 0, e4 = t4; ; ) {
                if (e4) {
                  var n = n + 1 | 0, e4 = e4[2];
                  continue;
                }
                return n;
              }
            }
            function bl(t4) {
              return t4 ? t4[1] : ke(mi0);
            }
            function az(t4) {
              return t4 ? t4[2] : ke(pi0);
            }
            function Lc(t4, n) {
              for (var e4 = t4, i4 = n; ; ) {
                if (e4) {
                  var x4 = [0, e4[1], i4], e4 = e4[2], i4 = x4;
                  continue;
                }
                return i4;
              }
            }
            function ye(t4) {
              return Lc(t4, 0);
            }
            function pl(t4) {
              if (t4) {
                var n = t4[1];
                return on(n, pl(t4[2]));
              }
              return 0;
            }
            function d1(t4, n) {
              if (n) {
                var e4 = n[2], i4 = u(t4, n[1]);
                return [0, i4, d1(t4, e4)];
              }
              return 0;
            }
            function Fp(t4, n) {
              for (var e4 = 0, i4 = n; ; ) {
                if (i4) {
                  var x4 = i4[2], e4 = [0, u(t4, i4[1]), e4], i4 = x4;
                  continue;
                }
                return e4;
              }
            }
            function Du(t4, n) {
              for (var e4 = n; ; ) {
                if (e4) {
                  var i4 = e4[2];
                  u(t4, e4[1]);
                  var e4 = i4;
                  continue;
                }
                return 0;
              }
            }
            function le(t4, n, e4) {
              for (var i4 = n, x4 = e4; ; ) {
                if (x4) {
                  var c = x4[2], i4 = o(t4, i4, x4[1]), x4 = c;
                  continue;
                }
                return i4;
              }
            }
            function iN(t4, n, e4) {
              if (n) {
                var i4 = n[1];
                return o(t4, i4, iN(t4, n[2], e4));
              }
              return e4;
            }
            function cz(t4, n, e4) {
              for (var i4 = n, x4 = e4; ; ) {
                if (i4) {
                  if (x4) {
                    var c = x4[2], s2 = i4[2];
                    o(t4, i4[1], x4[1]);
                    var i4 = s2, x4 = c;
                    continue;
                  }
                } else if (!x4)
                  return 0;
                return Pu(bi0);
              }
            }
            function fN(t4, n) {
              for (var e4 = n; ; ) {
                if (e4) {
                  var i4 = e4[2], x4 = LV(e4[1], t4) === 0 ? 1 : 0;
                  if (x4)
                    return x4;
                  var e4 = i4;
                  continue;
                }
                return 0;
              }
            }
            function Ure(t4, n) {
              for (var e4 = n; ; ) {
                if (e4) {
                  var i4 = e4[1], x4 = e4[2], c = i4[2];
                  if (LV(i4[1], t4) === 0)
                    return c;
                  var e4 = x4;
                  continue;
                }
                throw Jt;
              }
            }
            function ml(t4) {
              var n = 0;
              return function(e4) {
                for (var i4 = n, x4 = e4; ; ) {
                  if (x4) {
                    var c = x4[2], s2 = x4[1];
                    if (u(t4, s2)) {
                      var i4 = [0, s2, i4], x4 = c;
                      continue;
                    }
                    var x4 = c;
                    continue;
                  }
                  return ye(i4);
                }
              };
            }
            function k1(t4, n) {
              var e4 = Lt(t4);
              return v70(e4, 0, t4, n), e4;
            }
            function sz(t4) {
              var n = b7(t4), e4 = Lt(n);
              return Fs(t4, 0, e4, 0, n), e4;
            }
            function vz(t4, n, e4) {
              if (0 <= n && 0 <= e4 && !((b7(t4) - e4 | 0) < n)) {
                var i4 = Lt(e4);
                return Fs(t4, n, i4, 0, e4), i4;
              }
              return Pu(hi0);
            }
            function qv(t4, n, e4) {
              return vz(t4, n, e4);
            }
            function lz(t4, n, e4, i4, x4) {
              return 0 <= x4 && 0 <= n && !((b7(t4) - x4 | 0) < n) && 0 <= i4 && !((b7(e4) - x4 | 0) < i4) ? Fs(t4, n, e4, i4, x4) : Pu(yi0);
            }
            function cs(t4, n, e4, i4, x4) {
              return 0 <= x4 && 0 <= n && !((un(t4) - x4 | 0) < n) && 0 <= i4 && !((b7(e4) - x4 | 0) < i4) ? Ts(t4, n, e4, i4, x4) : Pu(_i0);
            }
            function Tp(t4, n) {
              return k1(t4, n);
            }
            function m7(t4, n, e4) {
              return vz(t4, n, e4);
            }
            var bz = Ee;
            function pz(t4, n) {
              var e4 = n.length - 1 - 1 | 0, i4 = 0;
              if (!(e4 < 0))
                for (var x4 = i4; ; ) {
                  u(t4, n[1 + x4]);
                  var c = x4 + 1 | 0;
                  if (e4 !== x4) {
                    var x4 = c;
                    continue;
                  }
                  break;
                }
              return 0;
            }
            function Op(t4, n) {
              var e4 = n.length - 1;
              if (e4 === 0)
                return [0];
              var i4 = Gv(e4, u(t4, n[1])), x4 = e4 - 1 | 0, c = 1;
              if (!(x4 < 1))
                for (var s2 = c; ; ) {
                  i4[1 + s2] = u(t4, n[1 + s2]);
                  var p = s2 + 1 | 0;
                  if (x4 !== s2) {
                    var s2 = p;
                    continue;
                  }
                  break;
                }
              return i4;
            }
            function _l(t4) {
              if (t4)
                for (var n = 0, e4 = t4, i4 = t4[2], x4 = t4[1]; ; ) {
                  if (e4) {
                    var n = n + 1 | 0, e4 = e4[2];
                    continue;
                  }
                  for (var c = Gv(n, x4), s2 = 1, p = i4; ; ) {
                    if (p) {
                      var y = p[2];
                      c[1 + s2] = p[1];
                      var s2 = s2 + 1 | 0, p = y;
                      continue;
                    }
                    return c;
                  }
                }
              return [0];
            }
            M7(0);
            function xN(t4) {
              function n(v0) {
                return v0 ? v0[5] : 0;
              }
              function e4(v0, P, L, Q) {
                var i0 = n(v0), l0 = n(Q), S0 = l0 <= i0 ? i0 + 1 | 0 : l0 + 1 | 0;
                return [0, v0, P, L, Q, S0];
              }
              function i4(v0, P) {
                return [0, 0, v0, P, 0, 1];
              }
              function x4(v0, P, L, Q) {
                var i0 = v0 ? v0[5] : 0, l0 = Q ? Q[5] : 0;
                if ((l0 + 2 | 0) < i0) {
                  if (v0) {
                    var S0 = v0[4], T0 = v0[3], rr = v0[2], L0 = v0[1], B = n(S0);
                    if (B <= n(L0))
                      return e4(L0, rr, T0, e4(S0, P, L, Q));
                    if (S0) {
                      var Z7 = S0[3], p0 = S0[2], b0 = S0[1], O0 = e4(S0[4], P, L, Q);
                      return e4(e4(L0, rr, T0, b0), p0, Z7, O0);
                    }
                    return Pu(Fi0);
                  }
                  return Pu(Ti0);
                }
                if ((i0 + 2 | 0) < l0) {
                  if (Q) {
                    var M0 = Q[4], er = Q[3], yr = Q[2], vr = Q[1], $0 = n(vr);
                    if ($0 <= n(M0))
                      return e4(e4(v0, P, L, vr), yr, er, M0);
                    if (vr) {
                      var Er = vr[3], Mr = vr[2], Br = vr[1], qr = e4(vr[4], yr, er, M0);
                      return e4(e4(v0, P, L, Br), Mr, Er, qr);
                    }
                    return Pu(Oi0);
                  }
                  return Pu(Ii0);
                }
                var jr = l0 <= i0 ? i0 + 1 | 0 : l0 + 1 | 0;
                return [0, v0, P, L, Q, jr];
              }
              var c = 0;
              function s2(v0) {
                return v0 ? 0 : 1;
              }
              function p(v0, P, L) {
                if (L) {
                  var Q = L[4], i0 = L[3], l0 = L[2], S0 = L[1], T0 = L[5], rr = o(t4[1], v0, l0);
                  if (rr === 0)
                    return i0 === P ? L : [0, S0, v0, P, Q, T0];
                  if (0 <= rr) {
                    var L0 = p(v0, P, Q);
                    return Q === L0 ? L : x4(S0, l0, i0, L0);
                  }
                  var B = p(v0, P, S0);
                  return S0 === B ? L : x4(B, l0, i0, Q);
                }
                return [0, 0, v0, P, 0, 1];
              }
              function y(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[3], l0 = L[1], S0 = o(t4[1], v0, L[2]);
                    if (S0 === 0)
                      return i0;
                    var T0 = 0 <= S0 ? Q : l0, L = T0;
                    continue;
                  }
                  throw Jt;
                }
              }
              function T(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[2], i0 = L[4], l0 = L[3], S0 = L[1];
                    if (u(v0, Q))
                      for (var T0 = Q, rr = l0, L0 = S0; ; ) {
                        if (L0) {
                          var B = L0[2], Z7 = L0[4], p0 = L0[3], b0 = L0[1];
                          if (u(v0, B)) {
                            var T0 = B, rr = p0, L0 = b0;
                            continue;
                          }
                          var L0 = Z7;
                          continue;
                        }
                        return [0, T0, rr];
                      }
                    var L = i0;
                    continue;
                  }
                  throw Jt;
                }
              }
              function E(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[2], i0 = L[4], l0 = L[3], S0 = L[1];
                    if (u(v0, Q))
                      for (var T0 = Q, rr = l0, L0 = S0; ; ) {
                        if (L0) {
                          var B = L0[2], Z7 = L0[4], p0 = L0[3], b0 = L0[1];
                          if (u(v0, B)) {
                            var T0 = B, rr = p0, L0 = b0;
                            continue;
                          }
                          var L0 = Z7;
                          continue;
                        }
                        return [0, [0, T0, rr]];
                      }
                    var L = i0;
                    continue;
                  }
                  return 0;
                }
              }
              function d(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[2], i0 = L[4], l0 = L[3], S0 = L[1];
                    if (u(v0, Q))
                      for (var T0 = Q, rr = l0, L0 = i0; ; ) {
                        if (L0) {
                          var B = L0[2], Z7 = L0[4], p0 = L0[3], b0 = L0[1];
                          if (u(v0, B)) {
                            var T0 = B, rr = p0, L0 = Z7;
                            continue;
                          }
                          var L0 = b0;
                          continue;
                        }
                        return [0, T0, rr];
                      }
                    var L = S0;
                    continue;
                  }
                  throw Jt;
                }
              }
              function w(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[2], i0 = L[4], l0 = L[3], S0 = L[1];
                    if (u(v0, Q))
                      for (var T0 = Q, rr = l0, L0 = i0; ; ) {
                        if (L0) {
                          var B = L0[2], Z7 = L0[4], p0 = L0[3], b0 = L0[1];
                          if (u(v0, B)) {
                            var T0 = B, rr = p0, L0 = Z7;
                            continue;
                          }
                          var L0 = b0;
                          continue;
                        }
                        return [0, [0, T0, rr]];
                      }
                    var L = S0;
                    continue;
                  }
                  return 0;
                }
              }
              function G(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[3], l0 = L[1], S0 = o(t4[1], v0, L[2]);
                    if (S0 === 0)
                      return [0, i0];
                    var T0 = 0 <= S0 ? Q : l0, L = T0;
                    continue;
                  }
                  return 0;
                }
              }
              function A11(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[1], l0 = o(t4[1], v0, L[2]), S0 = l0 === 0 ? 1 : 0;
                    if (S0)
                      return S0;
                    var T0 = 0 <= l0 ? Q : i0, L = T0;
                    continue;
                  }
                  return 0;
                }
              }
              function S11(v0) {
                for (var P = v0; ; ) {
                  if (P) {
                    var L = P[1];
                    if (L) {
                      var P = L;
                      continue;
                    }
                    return [0, P[2], P[3]];
                  }
                  throw Jt;
                }
              }
              function M(v0) {
                for (var P = v0; ; ) {
                  if (P) {
                    var L = P[1];
                    if (L) {
                      var P = L;
                      continue;
                    }
                    return [0, [0, P[2], P[3]]];
                  }
                  return 0;
                }
              }
              function K(v0) {
                for (var P = v0; ; ) {
                  if (P) {
                    if (P[4]) {
                      var P = P[4];
                      continue;
                    }
                    return [0, P[2], P[3]];
                  }
                  throw Jt;
                }
              }
              function V(v0) {
                for (var P = v0; ; ) {
                  if (P) {
                    if (P[4]) {
                      var P = P[4];
                      continue;
                    }
                    return [0, [0, P[2], P[3]]];
                  }
                  return 0;
                }
              }
              function f0(v0) {
                if (v0) {
                  var P = v0[1];
                  if (P) {
                    var L = v0[4], Q = v0[3], i0 = v0[2];
                    return x4(f0(P), i0, Q, L);
                  }
                  return v0[4];
                }
                return Pu(wi0);
              }
              function m0(v0, P) {
                if (v0) {
                  if (P) {
                    var L = S11(P), Q = L[2], i0 = L[1];
                    return x4(v0, i0, Q, f0(P));
                  }
                  return v0;
                }
                return P;
              }
              function k0(v0, P) {
                if (P) {
                  var L = P[4], Q = P[3], i0 = P[2], l0 = P[1], S0 = o(t4[1], v0, i0);
                  if (S0 === 0)
                    return m0(l0, L);
                  if (0 <= S0) {
                    var T0 = k0(v0, L);
                    return L === T0 ? P : x4(l0, i0, Q, T0);
                  }
                  var rr = k0(v0, l0);
                  return l0 === rr ? P : x4(rr, i0, Q, L);
                }
                return 0;
              }
              function g0(v0, P, L) {
                if (L) {
                  var Q = L[4], i0 = L[3], l0 = L[2], S0 = L[1], T0 = L[5], rr = o(t4[1], v0, l0);
                  if (rr === 0) {
                    var L0 = u(P, [0, i0]);
                    if (L0) {
                      var B = L0[1];
                      return i0 === B ? L : [0, S0, v0, B, Q, T0];
                    }
                    return m0(S0, Q);
                  }
                  if (0 <= rr) {
                    var Z7 = g0(v0, P, Q);
                    return Q === Z7 ? L : x4(S0, l0, i0, Z7);
                  }
                  var p0 = g0(v0, P, S0);
                  return S0 === p0 ? L : x4(p0, l0, i0, Q);
                }
                var b0 = u(P, 0);
                return b0 ? [0, 0, v0, b0[1], 0, 1] : 0;
              }
              function e0(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[3], l0 = L[2];
                    e0(v0, L[1]), o(v0, l0, i0);
                    var L = Q;
                    continue;
                  }
                  return 0;
                }
              }
              function x0(v0, P) {
                if (P) {
                  var L = P[5], Q = P[4], i0 = P[3], l0 = P[2], S0 = x0(v0, P[1]), T0 = u(v0, i0);
                  return [0, S0, l0, T0, x0(v0, Q), L];
                }
                return 0;
              }
              function l(v0, P) {
                if (P) {
                  var L = P[2], Q = P[5], i0 = P[4], l0 = P[3], S0 = l(v0, P[1]), T0 = o(v0, L, l0);
                  return [0, S0, L, T0, l(v0, i0), Q];
                }
                return 0;
              }
              function c0(v0, P, L) {
                for (var Q = P, i0 = L; ; ) {
                  if (Q) {
                    var l0 = Q[4], S0 = Q[3], T0 = Q[2], rr = ur(v0, T0, S0, c0(v0, Q[1], i0)), Q = l0, i0 = rr;
                    continue;
                  }
                  return i0;
                }
              }
              function t0(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[1], l0 = o(v0, L[2], L[3]);
                    if (l0) {
                      var S0 = t0(v0, i0);
                      if (S0) {
                        var L = Q;
                        continue;
                      }
                      var T0 = S0;
                    } else
                      var T0 = l0;
                    return T0;
                  }
                  return 1;
                }
              }
              function o0(v0, P) {
                for (var L = P; ; ) {
                  if (L) {
                    var Q = L[4], i0 = L[1], l0 = o(v0, L[2], L[3]);
                    if (l0)
                      var S0 = l0;
                    else {
                      var T0 = o0(v0, i0);
                      if (!T0) {
                        var L = Q;
                        continue;
                      }
                      var S0 = T0;
                    }
                    return S0;
                  }
                  return 0;
                }
              }
              function w0(v0, P, L) {
                if (L) {
                  var Q = L[4], i0 = L[3], l0 = L[2];
                  return x4(w0(v0, P, L[1]), l0, i0, Q);
                }
                return i4(v0, P);
              }
              function _0(v0, P, L) {
                if (L) {
                  var Q = L[3], i0 = L[2], l0 = L[1];
                  return x4(l0, i0, Q, _0(v0, P, L[4]));
                }
                return i4(v0, P);
              }
              function E0(v0, P, L, Q) {
                if (v0) {
                  if (Q) {
                    var i0 = Q[5], l0 = v0[5], S0 = Q[4], T0 = Q[3], rr = Q[2], L0 = Q[1], B = v0[4], Z7 = v0[3], p0 = v0[2], b0 = v0[1];
                    return (i0 + 2 | 0) < l0 ? x4(b0, p0, Z7, E0(B, P, L, Q)) : (l0 + 2 | 0) < i0 ? x4(E0(v0, P, L, L0), rr, T0, S0) : e4(v0, P, L, Q);
                  }
                  return _0(P, L, v0);
                }
                return w0(P, L, Q);
              }
              function U0(v0, P) {
                if (v0) {
                  if (P) {
                    var L = S11(P), Q = L[2], i0 = L[1];
                    return E0(v0, i0, Q, f0(P));
                  }
                  return v0;
                }
                return P;
              }
              function b(v0, P, L, Q) {
                return L ? E0(v0, P, L[1], Q) : U0(v0, Q);
              }
              function R0(v0, P) {
                if (P) {
                  var L = P[4], Q = P[3], i0 = P[2], l0 = P[1], S0 = o(t4[1], v0, i0);
                  if (S0 === 0)
                    return [0, l0, [0, Q], L];
                  if (0 <= S0) {
                    var T0 = R0(v0, L), rr = T0[3], L0 = T0[2];
                    return [0, E0(l0, i0, Q, T0[1]), L0, rr];
                  }
                  var B = R0(v0, l0), Z7 = B[2], p0 = B[1];
                  return [0, p0, Z7, E0(B[3], i0, Q, L)];
                }
                return Ei0;
              }
              function X(v0, P, L) {
                if (P) {
                  var Q = P[2], i0 = P[5], l0 = P[4], S0 = P[3], T0 = P[1];
                  if (n(L) <= i0) {
                    var rr = R0(Q, L), L0 = rr[2], B = rr[1], Z7 = X(v0, l0, rr[3]), p0 = ur(v0, Q, [0, S0], L0);
                    return b(X(v0, T0, B), Q, p0, Z7);
                  }
                } else if (!L)
                  return 0;
                if (L) {
                  var b0 = L[2], O0 = L[4], M0 = L[3], er = L[1], yr = R0(b0, P), vr = yr[2], $0 = yr[1], Er = X(v0, yr[3], O0), Mr = ur(v0, b0, vr, [0, M0]);
                  return b(X(v0, $0, er), b0, Mr, Er);
                }
                throw [0, Sn, Si0];
              }
              function s0(v0, P, L) {
                if (P) {
                  if (L) {
                    var Q = L[3], i0 = L[2], l0 = P[3], S0 = P[2], T0 = L[4], rr = L[1], L0 = P[4], B = P[1];
                    if (L[5] <= P[5]) {
                      var Z7 = R0(S0, L), p0 = Z7[2], b0 = Z7[3], O0 = s0(v0, B, Z7[1]), M0 = s0(v0, L0, b0);
                      return p0 ? b(O0, S0, ur(v0, S0, l0, p0[1]), M0) : E0(O0, S0, l0, M0);
                    }
                    var er = R0(i0, P), yr = er[2], vr = er[3], $0 = s0(v0, er[1], rr), Er = s0(v0, vr, T0);
                    return yr ? b($0, i0, ur(v0, i0, yr[1], Q), Er) : E0($0, i0, Q, Er);
                  }
                  var Mr = P;
                } else
                  var Mr = L;
                return Mr;
              }
              function hr(v0, P) {
                if (P) {
                  var L = P[4], Q = P[3], i0 = P[2], l0 = P[1], S0 = hr(v0, l0), T0 = o(v0, i0, Q), rr = hr(v0, L);
                  return T0 ? l0 === S0 && L === rr ? P : E0(S0, i0, Q, rr) : U0(S0, rr);
                }
                return 0;
              }
              function Ar(v0, P) {
                if (P) {
                  var L = P[2], Q = P[4], i0 = P[3], l0 = Ar(v0, P[1]), S0 = o(v0, L, i0), T0 = Ar(v0, Q);
                  return S0 ? E0(l0, L, S0[1], T0) : U0(l0, T0);
                }
                return 0;
              }
              function or(v0, P) {
                if (P) {
                  var L = P[3], Q = P[2], i0 = P[4], l0 = or(v0, P[1]), S0 = l0[2], T0 = l0[1], rr = o(v0, Q, L), L0 = or(v0, i0), B = L0[2], Z7 = L0[1];
                  if (rr) {
                    var p0 = U0(S0, B);
                    return [0, E0(T0, Q, L, Z7), p0];
                  }
                  var b0 = E0(S0, Q, L, B);
                  return [0, U0(T0, Z7), b0];
                }
                return gi0;
              }
              function W0(v0, P) {
                for (var L = v0, Q = P; ; ) {
                  if (L) {
                    var i0 = [0, L[2], L[3], L[4], Q], L = L[1], Q = i0;
                    continue;
                  }
                  return Q;
                }
              }
              function Lr(v0, P, L) {
                for (var Q = W0(L, 0), i0 = W0(P, 0), l0 = Q; ; ) {
                  if (i0) {
                    if (l0) {
                      var S0 = l0[4], T0 = l0[3], rr = l0[2], L0 = i0[4], B = i0[3], Z7 = i0[2], p0 = o(t4[1], i0[1], l0[1]);
                      if (p0 === 0) {
                        var b0 = o(v0, Z7, rr);
                        if (b0 === 0) {
                          var O0 = W0(T0, S0), i0 = W0(B, L0), l0 = O0;
                          continue;
                        }
                        return b0;
                      }
                      return p0;
                    }
                    return 1;
                  }
                  return l0 ? -1 : 0;
                }
              }
              function Tr(v0, P, L) {
                for (var Q = W0(L, 0), i0 = W0(P, 0), l0 = Q; ; ) {
                  if (i0) {
                    if (l0) {
                      var S0 = l0[4], T0 = l0[3], rr = l0[2], L0 = i0[4], B = i0[3], Z7 = i0[2], p0 = o(t4[1], i0[1], l0[1]) === 0 ? 1 : 0;
                      if (p0) {
                        var b0 = o(v0, Z7, rr);
                        if (b0) {
                          var O0 = W0(T0, S0), i0 = W0(B, L0), l0 = O0;
                          continue;
                        }
                        var M0 = b0;
                      } else
                        var M0 = p0;
                      return M0;
                    }
                    return 0;
                  }
                  return l0 ? 0 : 1;
                }
              }
              function Hr(v0) {
                if (v0) {
                  var P = v0[1], L = Hr(v0[4]);
                  return (Hr(P) + 1 | 0) + L | 0;
                }
                return 0;
              }
              function Or(v0, P) {
                for (var L = v0, Q = P; ; ) {
                  if (Q) {
                    var i0 = Q[3], l0 = Q[2], S0 = Q[1], L = [0, [0, l0, i0], Or(L, Q[4])], Q = S0;
                    continue;
                  }
                  return L;
                }
              }
              function fr(v0) {
                return Or(0, v0);
              }
              function Rr(v0, P) {
                for (var L = P, Q = v0; ; ) {
                  var i0 = u(Q, 0);
                  if (i0) {
                    var l0 = i0[1], S0 = i0[2], L = p(l0[1], l0[2], L), Q = S0;
                    continue;
                  }
                  return L;
                }
              }
              function Wr(v0) {
                return Rr(v0, c);
              }
              function Jr(v0, P) {
                if (v0) {
                  var L = v0[2], Q = v0[1], i0 = W0(v0[3], v0[4]);
                  return [0, [0, Q, L], function(l0) {
                    return Jr(i0, l0);
                  }];
                }
                return 0;
              }
              function ar(v0) {
                var P = W0(v0, 0);
                return function(L) {
                  return Jr(P, L);
                };
              }
              function _r(v0, P) {
                for (var L = v0, Q = P; ; ) {
                  if (L) {
                    var i0 = [0, L[2], L[3], L[1], Q], L = L[4], Q = i0;
                    continue;
                  }
                  return Q;
                }
              }
              function Ir(v0, P) {
                if (v0) {
                  var L = v0[2], Q = v0[1], i0 = _r(v0[3], v0[4]);
                  return [0, [0, Q, L], function(l0) {
                    return Ir(i0, l0);
                  }];
                }
                return 0;
              }
              function fe(v0) {
                var P = _r(v0, 0);
                return function(L) {
                  return Ir(P, L);
                };
              }
              return [0, c, s2, A11, p, g0, i4, k0, X, s0, Lr, Tr, e0, c0, t0, o0, hr, Ar, or, Hr, fr, S11, M, K, V, S11, M, R0, y, G, T, E, d, w, x0, l, ar, fe, function(v0, P) {
                for (var L = P, Q = 0; ; ) {
                  if (L) {
                    var i0 = L[4], l0 = L[3], S0 = L[2], T0 = L[1], rr = o(t4[1], S0, v0);
                    if (rr !== 0) {
                      if (0 <= rr) {
                        var L = T0, Q = [0, S0, l0, i0, Q];
                        continue;
                      }
                      var L = i0;
                      continue;
                    }
                    var L0 = [0, S0, l0, i0, Q];
                  } else
                    var L0 = Q;
                  return function(B) {
                    return Jr(L0, B);
                  };
                }
              }, Rr, Wr];
            }
            M7(0);
            function yl(t4) {
              return [0, 0, 0];
            }
            function hl(t4) {
              return t4[1] = 0, t4[2] = 0, 0;
            }
            function w1(t4, n) {
              return n[1] = [0, t4, n[1]], n[2] = n[2] + 1 | 0, 0;
            }
            function Uv(t4) {
              var n = t4[1];
              if (n) {
                var e4 = n[1];
                return t4[1] = n[2], t4[2] = t4[2] - 1 | 0, [0, e4];
              }
              return 0;
            }
            function Hv(t4) {
              var n = t4[1];
              return n ? [0, n[1]] : 0;
            }
            var Hre = [wt, Ai0, M7(0)];
            function mz(t4) {
              return [0, 0, 0, 0];
            }
            function oN(t4) {
              return t4[1] = 0, t4[2] = 0, t4[3] = 0, 0;
            }
            function aN(t4, n) {
              var e4 = [0, t4, 0], i4 = n[3];
              return i4 ? (n[1] = n[1] + 1 | 0, i4[2] = e4, n[3] = e4, 0) : (n[1] = 1, n[2] = e4, n[3] = e4, 0);
            }
            var Xre = [wt, Ni0, M7(0)];
            function Yre(t4) {
              throw Xre;
            }
            function Vre(t4) {
              var n = t4[1];
              t4[1] = Yre;
              try {
                var e4 = u(n, 0);
                return U70(t4, e4), e4;
              } catch (i4) {
                throw i4 = Et(i4), t4[1] = function(x4) {
                  throw i4;
                }, i4;
              }
            }
            function $n(t4) {
              var n = 1 <= t4 ? t4 : 1, e4 = ll < n ? ll : n, i4 = Lt(e4);
              return [0, i4, 0, e4, i4];
            }
            function Mt(t4) {
              return qv(t4[1], 0, t4[2]);
            }
            function cN(t4, n) {
              for (var e4 = t4[2], i4 = [0, t4[3]]; ; ) {
                if (i4[1] < (e4 + n | 0)) {
                  i4[1] = 2 * i4[1] | 0;
                  continue;
                }
                ll < i4[1] && ((e4 + n | 0) <= ll ? i4[1] = ll : ke(Pi0));
                var x4 = Lt(i4[1]);
                if (lz(t4[1], 0, x4, 0, t4[2]), t4[1] = x4, t4[3] = i4[1], (t4[2] + n | 0) <= t4[3]) {
                  if ((e4 + n | 0) <= t4[3])
                    return 0;
                  throw [0, Sn, Li0];
                }
                throw [0, Sn, Di0];
              }
            }
            function qi(t4, n) {
              var e4 = t4[2];
              return t4[3] <= e4 && cN(t4, 1), Jn(t4[1], e4, n), t4[2] = e4 + 1 | 0, 0;
            }
            function _z(t4, n, e4, i4) {
              var x4 = e4 < 0 ? 1 : 0;
              if (x4)
                var s2 = x4;
              else
                var c = i4 < 0 ? 1 : 0, s2 = c || ((un(n) - i4 | 0) < e4 ? 1 : 0);
              s2 && Pu(Ci0);
              var p = t4[2] + i4 | 0;
              return t4[3] < p && cN(t4, i4), Ts(n, e4, t4[1], t4[2], i4), t4[2] = p, 0;
            }
            function sN(t4, n, e4, i4) {
              return _z(t4, n, e4, i4);
            }
            function hn(t4, n) {
              var e4 = un(n), i4 = t4[2] + e4 | 0;
              return t4[3] < i4 && cN(t4, e4), Ts(n, 0, t4[1], t4[2], e4), t4[2] = i4, 0;
            }
            function vN(t4) {
              return t4[2] === 5 ? 12 : -6;
            }
            function yz(t4) {
              return [0, 0, Lt(t4)];
            }
            function hz(t4, n) {
              var e4 = b7(t4[2]), i4 = t4[1] + n | 0, x4 = e4 < i4 ? 1 : 0;
              if (x4) {
                var c = e4 * 2 | 0, s2 = i4 <= c ? c : i4, p = Lt(s2);
                lz(t4[2], 0, p, 0, e4), t4[2] = p;
                var y = 0;
              } else
                var y = x4;
              return y;
            }
            function Xv(t4, n) {
              return hz(t4, 1), b1(t4[2], t4[1], n), t4[1] = t4[1] + 1 | 0, 0;
            }
            function Lu(t4, n) {
              var e4 = un(n);
              return hz(t4, e4), cs(n, 0, t4[2], t4[1], e4), t4[1] = t4[1] + e4 | 0, 0;
            }
            function dz(t4) {
              return qv(t4[2], 0, t4[1]);
            }
            function kz(t4) {
              if (typeof t4 == "number")
                switch (t4) {
                  case 0:
                    return Gx0;
                  case 1:
                    return Mx0;
                  case 2:
                    return Bx0;
                  case 3:
                    return qx0;
                  case 4:
                    return Ux0;
                  case 5:
                    return Hx0;
                  default:
                    return Xx0;
                }
              else
                switch (t4[0]) {
                  case 0:
                    return t4[1];
                  case 1:
                    return t4[1];
                  default:
                    return Te(Yx0, Tp(1, t4[1]));
                }
            }
            function lN(t4, n) {
              for (var e4 = n; ; ) {
                if (typeof e4 == "number")
                  return 0;
                switch (e4[0]) {
                  case 0:
                    var i4 = e4[1];
                    Lu(t4, ji0);
                    var e4 = i4;
                    continue;
                  case 1:
                    var x4 = e4[1];
                    Lu(t4, Gi0);
                    var e4 = x4;
                    continue;
                  case 2:
                    var c = e4[1];
                    Lu(t4, Mi0);
                    var e4 = c;
                    continue;
                  case 3:
                    var s2 = e4[1];
                    Lu(t4, Bi0);
                    var e4 = s2;
                    continue;
                  case 4:
                    var p = e4[1];
                    Lu(t4, qi0);
                    var e4 = p;
                    continue;
                  case 5:
                    var y = e4[1];
                    Lu(t4, Ui0);
                    var e4 = y;
                    continue;
                  case 6:
                    var T = e4[1];
                    Lu(t4, Hi0);
                    var e4 = T;
                    continue;
                  case 7:
                    var E = e4[1];
                    Lu(t4, Xi0);
                    var e4 = E;
                    continue;
                  case 8:
                    var d = e4[2], w = e4[1];
                    Lu(t4, Yi0), lN(t4, w), Lu(t4, Vi0);
                    var e4 = d;
                    continue;
                  case 9:
                    var G = e4[3], A11 = e4[1];
                    Lu(t4, zi0), lN(t4, A11), Lu(t4, Ki0);
                    var e4 = G;
                    continue;
                  case 10:
                    var S11 = e4[1];
                    Lu(t4, Wi0);
                    var e4 = S11;
                    continue;
                  case 11:
                    var M = e4[1];
                    Lu(t4, Ji0);
                    var e4 = M;
                    continue;
                  case 12:
                    var K = e4[1];
                    Lu(t4, $i0);
                    var e4 = K;
                    continue;
                  case 13:
                    var V = e4[1];
                    Lu(t4, Zi0);
                    var e4 = V;
                    continue;
                  default:
                    var f0 = e4[1];
                    Lu(t4, Qi0);
                    var e4 = f0;
                    continue;
                }
              }
            }
            function uu(t4) {
              if (typeof t4 == "number")
                return 0;
              switch (t4[0]) {
                case 0:
                  return [0, uu(t4[1])];
                case 1:
                  return [1, uu(t4[1])];
                case 2:
                  return [2, uu(t4[1])];
                case 3:
                  return [3, uu(t4[1])];
                case 4:
                  return [4, uu(t4[1])];
                case 5:
                  return [5, uu(t4[1])];
                case 6:
                  return [6, uu(t4[1])];
                case 7:
                  return [7, uu(t4[1])];
                case 8:
                  var n = t4[1];
                  return [8, n, uu(t4[2])];
                case 9:
                  var e4 = t4[2], i4 = t4[1];
                  return [9, e4, i4, uu(t4[3])];
                case 10:
                  return [10, uu(t4[1])];
                case 11:
                  return [11, uu(t4[1])];
                case 12:
                  return [12, uu(t4[1])];
                case 13:
                  return [13, uu(t4[1])];
                default:
                  return [14, uu(t4[1])];
              }
            }
            function Ru(t4) {
              if (typeof t4 == "number") {
                var n = function(sr) {
                  return 0;
                }, e4 = function(sr) {
                  return 0;
                }, i4 = function(sr) {
                  return 0;
                };
                return [0, function(sr) {
                  return 0;
                }, i4, e4, n];
              } else
                switch (t4[0]) {
                  case 0:
                    var x4 = Ru(t4[1]), c = x4[4], s2 = x4[3], p = x4[2], y = x4[1], T = function(sr) {
                      return u(p, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(y, 0), 0;
                    }, T, s2, c];
                  case 1:
                    var E = Ru(t4[1]), d = E[4], w = E[3], G = E[2], A11 = E[1], S11 = function(sr) {
                      return u(G, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(A11, 0), 0;
                    }, S11, w, d];
                  case 2:
                    var M = Ru(t4[1]), K = M[4], V = M[3], f0 = M[2], m0 = M[1], k0 = function(sr) {
                      return u(f0, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(m0, 0), 0;
                    }, k0, V, K];
                  case 3:
                    var g0 = Ru(t4[1]), e0 = g0[4], x0 = g0[3], l = g0[2], c0 = g0[1], t0 = function(sr) {
                      return u(l, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(c0, 0), 0;
                    }, t0, x0, e0];
                  case 4:
                    var o0 = Ru(t4[1]), w0 = o0[4], _0 = o0[3], E0 = o0[2], U0 = o0[1], b = function(sr) {
                      return u(E0, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(U0, 0), 0;
                    }, b, _0, w0];
                  case 5:
                    var R0 = Ru(t4[1]), X = R0[4], s0 = R0[3], hr = R0[2], Ar = R0[1], or = function(sr) {
                      return u(hr, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(Ar, 0), 0;
                    }, or, s0, X];
                  case 6:
                    var W0 = Ru(t4[1]), Lr = W0[4], Tr = W0[3], Hr = W0[2], Or = W0[1], fr = function(sr) {
                      return u(Hr, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(Or, 0), 0;
                    }, fr, Tr, Lr];
                  case 7:
                    var Rr = Ru(t4[1]), Wr = Rr[4], Jr = Rr[3], ar = Rr[2], _r = Rr[1], Ir = function(sr) {
                      return u(ar, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(_r, 0), 0;
                    }, Ir, Jr, Wr];
                  case 8:
                    var fe = Ru(t4[2]), v0 = fe[4], P = fe[3], L = fe[2], Q = fe[1], i0 = function(sr) {
                      return u(L, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(Q, 0), 0;
                    }, i0, P, v0];
                  case 9:
                    var l0 = t4[2], S0 = t4[1], T0 = Ru(t4[3]), rr = T0[4], L0 = T0[3], B = T0[2], Z7 = T0[1], p0 = Ru(bu(uu(S0), l0)), b0 = p0[4], O0 = p0[3], M0 = p0[2], er = p0[1], yr = function(sr) {
                      return u(b0, 0), u(rr, 0), 0;
                    }, vr = function(sr) {
                      return u(L0, 0), u(O0, 0), 0;
                    }, $0 = function(sr) {
                      return u(M0, 0), u(B, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(Z7, 0), u(er, 0), 0;
                    }, $0, vr, yr];
                  case 10:
                    var Er = Ru(t4[1]), Mr = Er[4], Br = Er[3], qr = Er[2], jr = Er[1], $r = function(sr) {
                      return u(qr, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(jr, 0), 0;
                    }, $r, Br, Mr];
                  case 11:
                    var ne = Ru(t4[1]), Qr = ne[4], be = ne[3], ae = ne[2], pe = ne[1], oe = function(sr) {
                      return u(ae, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(pe, 0), 0;
                    }, oe, be, Qr];
                  case 12:
                    var ce = Ru(t4[1]), ge = ce[4], q0 = ce[3], Fr = ce[2], _ = ce[1], k = function(sr) {
                      return u(Fr, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(_, 0), 0;
                    }, k, q0, ge];
                  case 13:
                    var I = Ru(t4[1]), U = I[4], Y = I[3], y0 = I[2], P0 = I[1], I0 = function(sr) {
                      return u(U, 0), 0;
                    }, D = function(sr) {
                      return u(Y, 0), 0;
                    }, u0 = function(sr) {
                      return u(y0, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(P0, 0), 0;
                    }, u0, D, I0];
                  default:
                    var X0 = Ru(t4[1]), J0 = X0[4], ir = X0[3], Q0 = X0[2], F0 = X0[1], Sr = function(sr) {
                      return u(J0, 0), 0;
                    }, mr = function(sr) {
                      return u(ir, 0), 0;
                    }, Cr = function(sr) {
                      return u(Q0, 0), 0;
                    };
                    return [0, function(sr) {
                      return u(F0, 0), 0;
                    }, Cr, mr, Sr];
                }
            }
            function bu(t4, n) {
              var e4 = 0;
              if (typeof t4 == "number") {
                if (typeof n == "number")
                  return 0;
                switch (n[0]) {
                  case 10:
                    break;
                  case 11:
                    e4 = 1;
                    break;
                  case 12:
                    e4 = 2;
                    break;
                  case 13:
                    e4 = 3;
                    break;
                  case 14:
                    e4 = 4;
                    break;
                  case 8:
                    e4 = 5;
                    break;
                  case 9:
                    e4 = 6;
                    break;
                  default:
                    throw [0, Sn, rf0];
                }
              } else
                switch (t4[0]) {
                  case 0:
                    var i4 = 0, x4 = t4[1];
                    if (typeof n != "number")
                      switch (n[0]) {
                        case 0:
                          return [0, bu(x4, n[1])];
                        case 8:
                          e4 = 5, i4 = 1;
                          break;
                        case 9:
                          e4 = 6, i4 = 1;
                          break;
                        case 10:
                          i4 = 1;
                          break;
                        case 11:
                          e4 = 1, i4 = 1;
                          break;
                        case 12:
                          e4 = 2, i4 = 1;
                          break;
                        case 13:
                          e4 = 3, i4 = 1;
                          break;
                        case 14:
                          e4 = 4, i4 = 1;
                          break;
                      }
                    i4 || (e4 = 7);
                    break;
                  case 1:
                    var c = 0, s2 = t4[1];
                    if (typeof n != "number")
                      switch (n[0]) {
                        case 1:
                          return [1, bu(s2, n[1])];
                        case 8:
                          e4 = 5, c = 1;
                          break;
                        case 9:
                          e4 = 6, c = 1;
                          break;
                        case 10:
                          c = 1;
                          break;
                        case 11:
                          e4 = 1, c = 1;
                          break;
                        case 12:
                          e4 = 2, c = 1;
                          break;
                        case 13:
                          e4 = 3, c = 1;
                          break;
                        case 14:
                          e4 = 4, c = 1;
                          break;
                      }
                    c || (e4 = 7);
                    break;
                  case 2:
                    var p = 0, y = t4[1];
                    if (typeof n == "number")
                      p = 1;
                    else
                      switch (n[0]) {
                        case 2:
                          return [2, bu(y, n[1])];
                        case 8:
                          e4 = 5;
                          break;
                        case 9:
                          e4 = 6;
                          break;
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          e4 = 4;
                          break;
                        default:
                          p = 1;
                      }
                    p && (e4 = 7);
                    break;
                  case 3:
                    var T = 0, E = t4[1];
                    if (typeof n == "number")
                      T = 1;
                    else
                      switch (n[0]) {
                        case 3:
                          return [3, bu(E, n[1])];
                        case 8:
                          e4 = 5;
                          break;
                        case 9:
                          e4 = 6;
                          break;
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          e4 = 4;
                          break;
                        default:
                          T = 1;
                      }
                    T && (e4 = 7);
                    break;
                  case 4:
                    var d = 0, w = t4[1];
                    if (typeof n == "number")
                      d = 1;
                    else
                      switch (n[0]) {
                        case 4:
                          return [4, bu(w, n[1])];
                        case 8:
                          e4 = 5;
                          break;
                        case 9:
                          e4 = 6;
                          break;
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          e4 = 4;
                          break;
                        default:
                          d = 1;
                      }
                    d && (e4 = 7);
                    break;
                  case 5:
                    var G = 0, A11 = t4[1];
                    if (typeof n == "number")
                      G = 1;
                    else
                      switch (n[0]) {
                        case 5:
                          return [5, bu(A11, n[1])];
                        case 8:
                          e4 = 5;
                          break;
                        case 9:
                          e4 = 6;
                          break;
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          e4 = 4;
                          break;
                        default:
                          G = 1;
                      }
                    G && (e4 = 7);
                    break;
                  case 6:
                    var S11 = 0, M = t4[1];
                    if (typeof n == "number")
                      S11 = 1;
                    else
                      switch (n[0]) {
                        case 6:
                          return [6, bu(M, n[1])];
                        case 8:
                          e4 = 5;
                          break;
                        case 9:
                          e4 = 6;
                          break;
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          e4 = 4;
                          break;
                        default:
                          S11 = 1;
                      }
                    S11 && (e4 = 7);
                    break;
                  case 7:
                    var K = 0, V = t4[1];
                    if (typeof n == "number")
                      K = 1;
                    else
                      switch (n[0]) {
                        case 7:
                          return [7, bu(V, n[1])];
                        case 8:
                          e4 = 5;
                          break;
                        case 9:
                          e4 = 6;
                          break;
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          e4 = 4;
                          break;
                        default:
                          K = 1;
                      }
                    K && (e4 = 7);
                    break;
                  case 8:
                    var f0 = 0, m0 = t4[2], k0 = t4[1];
                    if (typeof n == "number")
                      f0 = 1;
                    else
                      switch (n[0]) {
                        case 8:
                          var g0 = n[1], e0 = bu(m0, n[2]);
                          return [8, bu(k0, g0), e0];
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          e4 = 4;
                          break;
                        default:
                          f0 = 1;
                      }
                    if (f0)
                      throw [0, Sn, sf0];
                    break;
                  case 9:
                    var x0 = 0, l = t4[3], c0 = t4[2], t0 = t4[1];
                    if (typeof n == "number")
                      x0 = 1;
                    else
                      switch (n[0]) {
                        case 8:
                          e4 = 5;
                          break;
                        case 9:
                          var o0 = n[3], w0 = n[2], _0 = n[1], E0 = Ru(bu(uu(c0), _0)), U0 = E0[4];
                          return u(E0[2], 0), u(U0, 0), [9, t0, w0, bu(l, o0)];
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          e4 = 4;
                          break;
                        default:
                          x0 = 1;
                      }
                    if (x0)
                      throw [0, Sn, lf0];
                    break;
                  case 10:
                    var b = t4[1];
                    if (typeof n != "number" && n[0] === 10)
                      return [10, bu(b, n[1])];
                    throw [0, Sn, ef0];
                  case 11:
                    var R0 = 0, X = t4[1];
                    if (typeof n == "number")
                      R0 = 1;
                    else
                      switch (n[0]) {
                        case 10:
                          break;
                        case 11:
                          return [11, bu(X, n[1])];
                        default:
                          R0 = 1;
                      }
                    if (R0)
                      throw [0, Sn, tf0];
                    break;
                  case 12:
                    var s0 = 0, hr = t4[1];
                    if (typeof n == "number")
                      s0 = 1;
                    else
                      switch (n[0]) {
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          return [12, bu(hr, n[1])];
                        default:
                          s0 = 1;
                      }
                    if (s0)
                      throw [0, Sn, if0];
                    break;
                  case 13:
                    var Ar = 0, or = t4[1];
                    if (typeof n == "number")
                      Ar = 1;
                    else
                      switch (n[0]) {
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          return [13, bu(or, n[1])];
                        default:
                          Ar = 1;
                      }
                    if (Ar)
                      throw [0, Sn, xf0];
                    break;
                  default:
                    var W0 = 0, Lr = t4[1];
                    if (typeof n == "number")
                      W0 = 1;
                    else
                      switch (n[0]) {
                        case 10:
                          break;
                        case 11:
                          e4 = 1;
                          break;
                        case 12:
                          e4 = 2;
                          break;
                        case 13:
                          e4 = 3;
                          break;
                        case 14:
                          return [14, bu(Lr, n[1])];
                        default:
                          W0 = 1;
                      }
                    if (W0)
                      throw [0, Sn, af0];
                }
              switch (e4) {
                case 0:
                  throw [0, Sn, nf0];
                case 1:
                  throw [0, Sn, uf0];
                case 2:
                  throw [0, Sn, ff0];
                case 3:
                  throw [0, Sn, of0];
                case 4:
                  throw [0, Sn, cf0];
                case 5:
                  throw [0, Sn, vf0];
                case 6:
                  throw [0, Sn, bf0];
                default:
                  throw [0, Sn, pf0];
              }
            }
            var Ou = [wt, Vx0, M7(0)];
            function Ip(t4, n) {
              if (typeof t4 == "number")
                return [0, 0, n];
              if (t4[0] === 0)
                return [0, [0, t4[1], t4[2]], n];
              if (typeof n != "number" && n[0] === 2)
                return [0, [1, t4[1]], n[1]];
              throw Ou;
            }
            function dl(t4, n, e4) {
              var i4 = Ip(t4, e4);
              if (typeof n == "number") {
                if (n) {
                  var x4 = i4[2];
                  if (typeof x4 != "number" && x4[0] === 2)
                    return [0, i4[1], 1, x4[1]];
                  throw Ou;
                }
                return [0, i4[1], 0, i4[2]];
              }
              return [0, i4[1], [0, n[1]], i4[2]];
            }
            function _7(t4, n, e4) {
              if (typeof t4 == "number")
                return [0, 0, _t(n, e4)];
              switch (t4[0]) {
                case 0:
                  if (typeof e4 != "number" && e4[0] === 0) {
                    var i4 = _7(t4[1], n, e4[1]);
                    return [0, [0, i4[1]], i4[2]];
                  }
                  break;
                case 1:
                  if (typeof e4 != "number" && e4[0] === 1) {
                    var x4 = _7(t4[1], n, e4[1]);
                    return [0, [1, x4[1]], x4[2]];
                  }
                  break;
                case 2:
                  if (typeof e4 != "number" && e4[0] === 2) {
                    var c = _7(t4[1], n, e4[1]);
                    return [0, [2, c[1]], c[2]];
                  }
                  break;
                case 3:
                  if (typeof e4 != "number" && e4[0] === 3) {
                    var s2 = _7(t4[1], n, e4[1]);
                    return [0, [3, s2[1]], s2[2]];
                  }
                  break;
                case 4:
                  if (typeof e4 != "number" && e4[0] === 4) {
                    var p = _7(t4[1], n, e4[1]);
                    return [0, [4, p[1]], p[2]];
                  }
                  break;
                case 5:
                  if (typeof e4 != "number" && e4[0] === 5) {
                    var y = _7(t4[1], n, e4[1]);
                    return [0, [5, y[1]], y[2]];
                  }
                  break;
                case 6:
                  if (typeof e4 != "number" && e4[0] === 6) {
                    var T = _7(t4[1], n, e4[1]);
                    return [0, [6, T[1]], T[2]];
                  }
                  break;
                case 7:
                  if (typeof e4 != "number" && e4[0] === 7) {
                    var E = _7(t4[1], n, e4[1]);
                    return [0, [7, E[1]], E[2]];
                  }
                  break;
                case 8:
                  if (typeof e4 != "number" && e4[0] === 8) {
                    var d = e4[1], w = e4[2], G = t4[2];
                    if (cl([0, t4[1]], [0, d]))
                      throw Ou;
                    var A11 = _7(G, n, w);
                    return [0, [8, d, A11[1]], A11[2]];
                  }
                  break;
                case 9:
                  if (typeof e4 != "number" && e4[0] === 9) {
                    var S11 = e4[2], M = e4[1], K = e4[3], V = t4[3], f0 = t4[2], m0 = t4[1], k0 = [0, Gt(M)];
                    if (cl([0, Gt(m0)], k0))
                      throw Ou;
                    var g0 = [0, Gt(S11)];
                    if (cl([0, Gt(f0)], g0))
                      throw Ou;
                    var e0 = Ru(bu(uu(M), S11)), x0 = e0[4];
                    u(e0[2], 0), u(x0, 0);
                    var l = _7(Gt(V), n, K), c0 = l[2];
                    return [0, [9, M, S11, uu(l[1])], c0];
                  }
                  break;
                case 10:
                  if (typeof e4 != "number" && e4[0] === 10) {
                    var t0 = _7(t4[1], n, e4[1]);
                    return [0, [10, t0[1]], t0[2]];
                  }
                  break;
                case 11:
                  if (typeof e4 != "number" && e4[0] === 11) {
                    var o0 = _7(t4[1], n, e4[1]);
                    return [0, [11, o0[1]], o0[2]];
                  }
                  break;
                case 13:
                  if (typeof e4 != "number" && e4[0] === 13) {
                    var w0 = _7(t4[1], n, e4[1]);
                    return [0, [13, w0[1]], w0[2]];
                  }
                  break;
                case 14:
                  if (typeof e4 != "number" && e4[0] === 14) {
                    var _0 = _7(t4[1], n, e4[1]);
                    return [0, [14, _0[1]], _0[2]];
                  }
                  break;
              }
              throw Ou;
            }
            function _t(t4, n) {
              if (typeof t4 == "number")
                return [0, 0, n];
              switch (t4[0]) {
                case 0:
                  if (typeof n != "number" && n[0] === 0) {
                    var e4 = _t(t4[1], n[1]);
                    return [0, [0, e4[1]], e4[2]];
                  }
                  break;
                case 1:
                  if (typeof n != "number" && n[0] === 0) {
                    var i4 = _t(t4[1], n[1]);
                    return [0, [1, i4[1]], i4[2]];
                  }
                  break;
                case 2:
                  var x4 = t4[2], c = Ip(t4[1], n), s2 = c[2], p = c[1];
                  if (typeof s2 != "number" && s2[0] === 1) {
                    var y = _t(x4, s2[1]);
                    return [0, [2, p, y[1]], y[2]];
                  }
                  throw Ou;
                case 3:
                  var T = t4[2], E = Ip(t4[1], n), d = E[2], w = E[1];
                  if (typeof d != "number" && d[0] === 1) {
                    var G = _t(T, d[1]);
                    return [0, [3, w, G[1]], G[2]];
                  }
                  throw Ou;
                case 4:
                  var A11 = t4[4], S11 = t4[1], M = dl(t4[2], t4[3], n), K = M[3], V = M[1];
                  if (typeof K != "number" && K[0] === 2) {
                    var f0 = M[2], m0 = _t(A11, K[1]);
                    return [0, [4, S11, V, f0, m0[1]], m0[2]];
                  }
                  throw Ou;
                case 5:
                  var k0 = t4[4], g0 = t4[1], e0 = dl(t4[2], t4[3], n), x0 = e0[3], l = e0[1];
                  if (typeof x0 != "number" && x0[0] === 3) {
                    var c0 = e0[2], t0 = _t(k0, x0[1]);
                    return [0, [5, g0, l, c0, t0[1]], t0[2]];
                  }
                  throw Ou;
                case 6:
                  var o0 = t4[4], w0 = t4[1], _0 = dl(t4[2], t4[3], n), E0 = _0[3], U0 = _0[1];
                  if (typeof E0 != "number" && E0[0] === 4) {
                    var b = _0[2], R0 = _t(o0, E0[1]);
                    return [0, [6, w0, U0, b, R0[1]], R0[2]];
                  }
                  throw Ou;
                case 7:
                  var X = t4[4], s0 = t4[1], hr = dl(t4[2], t4[3], n), Ar = hr[3], or = hr[1];
                  if (typeof Ar != "number" && Ar[0] === 5) {
                    var W0 = hr[2], Lr = _t(X, Ar[1]);
                    return [0, [7, s0, or, W0, Lr[1]], Lr[2]];
                  }
                  throw Ou;
                case 8:
                  var Tr = t4[4], Hr = t4[1], Or = dl(t4[2], t4[3], n), fr = Or[3], Rr = Or[1];
                  if (typeof fr != "number" && fr[0] === 6) {
                    var Wr = Or[2], Jr = _t(Tr, fr[1]);
                    return [0, [8, Hr, Rr, Wr, Jr[1]], Jr[2]];
                  }
                  throw Ou;
                case 9:
                  var ar = t4[2], _r = Ip(t4[1], n), Ir = _r[2], fe = _r[1];
                  if (typeof Ir != "number" && Ir[0] === 7) {
                    var v0 = _t(ar, Ir[1]);
                    return [0, [9, fe, v0[1]], v0[2]];
                  }
                  throw Ou;
                case 10:
                  var P = _t(t4[1], n);
                  return [0, [10, P[1]], P[2]];
                case 11:
                  var L = t4[1], Q = _t(t4[2], n);
                  return [0, [11, L, Q[1]], Q[2]];
                case 12:
                  var i0 = t4[1], l0 = _t(t4[2], n);
                  return [0, [12, i0, l0[1]], l0[2]];
                case 13:
                  if (typeof n != "number" && n[0] === 8) {
                    var S0 = n[1], T0 = n[2], rr = t4[3], L0 = t4[1];
                    if (cl([0, t4[2]], [0, S0]))
                      throw Ou;
                    var B = _t(rr, T0);
                    return [0, [13, L0, S0, B[1]], B[2]];
                  }
                  break;
                case 14:
                  if (typeof n != "number" && n[0] === 9) {
                    var Z7 = n[1], p0 = n[3], b0 = t4[3], O0 = t4[2], M0 = t4[1], er = [0, Gt(Z7)];
                    if (cl([0, Gt(O0)], er))
                      throw Ou;
                    var yr = _t(b0, Gt(p0));
                    return [0, [14, M0, Z7, yr[1]], yr[2]];
                  }
                  break;
                case 15:
                  if (typeof n != "number" && n[0] === 10) {
                    var vr = _t(t4[1], n[1]);
                    return [0, [15, vr[1]], vr[2]];
                  }
                  break;
                case 16:
                  if (typeof n != "number" && n[0] === 11) {
                    var $0 = _t(t4[1], n[1]);
                    return [0, [16, $0[1]], $0[2]];
                  }
                  break;
                case 17:
                  var Er = t4[1], Mr = _t(t4[2], n);
                  return [0, [17, Er, Mr[1]], Mr[2]];
                case 18:
                  var Br = t4[2], qr = t4[1];
                  if (qr[0] === 0) {
                    var jr = qr[1], $r = jr[2], ne = _t(jr[1], n), Qr = ne[1], be = _t(Br, ne[2]);
                    return [0, [18, [0, [0, Qr, $r]], be[1]], be[2]];
                  }
                  var ae = qr[1], pe = ae[2], oe = _t(ae[1], n), ce = oe[1], ge = _t(Br, oe[2]);
                  return [0, [18, [1, [0, ce, pe]], ge[1]], ge[2]];
                case 19:
                  if (typeof n != "number" && n[0] === 13) {
                    var q0 = _t(t4[1], n[1]);
                    return [0, [19, q0[1]], q0[2]];
                  }
                  break;
                case 20:
                  if (typeof n != "number" && n[0] === 1) {
                    var Fr = t4[2], _ = t4[1], k = _t(t4[3], n[1]);
                    return [0, [20, _, Fr, k[1]], k[2]];
                  }
                  break;
                case 21:
                  if (typeof n != "number" && n[0] === 2) {
                    var I = t4[1], U = _t(t4[2], n[1]);
                    return [0, [21, I, U[1]], U[2]];
                  }
                  break;
                case 23:
                  var Y = t4[2], y0 = t4[1];
                  if (typeof y0 == "number")
                    switch (y0) {
                      case 0:
                        return U7(y0, Y, n);
                      case 1:
                        return U7(y0, Y, n);
                      case 2:
                        if (typeof n != "number" && n[0] === 14) {
                          var P0 = _t(Y, n[1]);
                          return [0, [23, 2, P0[1]], P0[2]];
                        }
                        throw Ou;
                      default:
                        return U7(y0, Y, n);
                    }
                  else
                    switch (y0[0]) {
                      case 0:
                        return U7(y0, Y, n);
                      case 1:
                        return U7(y0, Y, n);
                      case 2:
                        return U7(y0, Y, n);
                      case 3:
                        return U7(y0, Y, n);
                      case 4:
                        return U7(y0, Y, n);
                      case 5:
                        return U7(y0, Y, n);
                      case 6:
                        return U7(y0, Y, n);
                      case 7:
                        return U7(y0, Y, n);
                      case 8:
                        return U7([8, y0[1], y0[2]], Y, n);
                      case 9:
                        var I0 = y0[1], D = _7(y0[2], Y, n), u0 = D[2];
                        return [0, [23, [9, I0, D[1]], u0[1]], u0[2]];
                      case 10:
                        return U7(y0, Y, n);
                      default:
                        return U7(y0, Y, n);
                    }
              }
              throw Ou;
            }
            function U7(t4, n, e4) {
              var i4 = _t(n, e4);
              return [0, [23, t4, i4[1]], i4[2]];
            }
            function H7(t4, n, e4) {
              var i4 = un(e4), x4 = 0 <= n ? t4 : 0, c = gp(n);
              if (c <= i4)
                return e4;
              var s2 = x4 === 2 ? 48 : 32, p = k1(c, s2);
              switch (x4) {
                case 0:
                  cs(e4, 0, p, 0, i4);
                  break;
                case 1:
                  cs(e4, 0, p, c - i4 | 0, i4);
                  break;
                default:
                  var y = 0;
                  if (0 < i4) {
                    var T = 0;
                    It(e4, 0) !== 43 && It(e4, 0) !== 45 && It(e4, 0) !== 32 && (y = 1, T = 1), T || (b1(p, 0, It(e4, 0)), cs(e4, 1, p, (c - i4 | 0) + 1 | 0, i4 - 1 | 0));
                  } else
                    y = 1;
                  if (y) {
                    var E = 0;
                    if (1 < i4 && It(e4, 0) === 48) {
                      var d = 0;
                      uc !== It(e4, 1) && It(e4, 1) !== 88 && (E = 1, d = 1), d || (b1(p, 1, It(e4, 1)), cs(e4, 2, p, (c - i4 | 0) + 2 | 0, i4 - 2 | 0));
                    } else
                      E = 1;
                    E && cs(e4, 0, p, c - i4 | 0, i4);
                  }
              }
              return p;
            }
            function Yv(t4, n) {
              var e4 = gp(t4), i4 = un(n), x4 = It(n, 0), c = 0;
              if (58 <= x4)
                71 <= x4 ? 5 < (x4 + Y3 | 0) >>> 0 || (c = 1) : 65 <= x4 && (c = 1);
              else {
                var s2 = 0;
                if (x4 !== 32)
                  if (43 <= x4)
                    switch (x4 + xy | 0) {
                      case 5:
                        if (i4 < (e4 + 2 | 0) && 1 < i4) {
                          var p = 0;
                          if ((uc === It(n, 1) || It(n, 1) === 88) && (p = 1), p) {
                            var y = k1(e4 + 2 | 0, 48);
                            return b1(y, 1, It(n, 1)), cs(n, 2, y, (e4 - i4 | 0) + 4 | 0, i4 - 2 | 0), y;
                          }
                        }
                        c = 1, s2 = 1;
                        break;
                      case 0:
                      case 2:
                        break;
                      case 1:
                      case 3:
                      case 4:
                        s2 = 1;
                        break;
                      default:
                        c = 1, s2 = 1;
                    }
                  else
                    s2 = 1;
                if (!s2 && i4 < (e4 + 1 | 0)) {
                  var T = k1(e4 + 1 | 0, 48);
                  return b1(T, 0, x4), cs(n, 1, T, (e4 - i4 | 0) + 2 | 0, i4 - 1 | 0), T;
                }
              }
              if (c && i4 < e4) {
                var E = k1(e4, 48);
                return cs(n, 0, E, e4 - i4 | 0, i4), E;
              }
              return n;
            }
            function zre(t4) {
              for (var n = 0, e4 = un(t4); ; ) {
                if (e4 <= n)
                  var i4 = t4;
                else {
                  var x4 = Vr(t4, n) + hU | 0, c = 0;
                  if (59 < x4 >>> 0 ? 33 < (x4 + SS | 0) >>> 0 && (c = 1) : x4 === 2 && (c = 1), !c) {
                    var n = n + 1 | 0;
                    continue;
                  }
                  var s2 = t4, p = [0, 0], y = b7(s2) - 1 | 0, T = 0;
                  if (!(y < 0))
                    for (var E = T; ; ) {
                      var d = Xu(s2, E), w = 0;
                      if (32 <= d) {
                        var G = d - 34 | 0, A11 = 0;
                        if (58 < G >>> 0 ? 93 <= G && (A11 = 1) : 56 < (G - 1 | 0) >>> 0 && (w = 1, A11 = 1), !A11) {
                          var S11 = 1;
                          w = 2;
                        }
                      } else
                        11 <= d ? d === 13 && (w = 1) : 8 <= d && (w = 1);
                      switch (w) {
                        case 0:
                          var S11 = 4;
                          break;
                        case 1:
                          var S11 = 2;
                          break;
                      }
                      p[1] = p[1] + S11 | 0;
                      var M = E + 1 | 0;
                      if (y !== E) {
                        var E = M;
                        continue;
                      }
                      break;
                    }
                  if (p[1] === b7(s2))
                    var K = sz(s2);
                  else {
                    var V = Lt(p[1]);
                    p[1] = 0;
                    var f0 = b7(s2) - 1 | 0, m0 = 0;
                    if (!(f0 < 0))
                      for (var k0 = m0; ; ) {
                        var g0 = Xu(s2, k0), e0 = 0;
                        if (35 <= g0)
                          g0 === 92 ? e0 = 2 : zn <= g0 ? e0 = 1 : e0 = 3;
                        else if (32 <= g0)
                          34 <= g0 ? e0 = 2 : e0 = 3;
                        else if (14 <= g0)
                          e0 = 1;
                        else
                          switch (g0) {
                            case 8:
                              Jn(V, p[1], 92), p[1]++, Jn(V, p[1], 98);
                              break;
                            case 9:
                              Jn(V, p[1], 92), p[1]++, Jn(V, p[1], f1);
                              break;
                            case 10:
                              Jn(V, p[1], 92), p[1]++, Jn(V, p[1], Xt);
                              break;
                            case 13:
                              Jn(V, p[1], 92), p[1]++, Jn(V, p[1], t1);
                              break;
                            default:
                              e0 = 1;
                          }
                        switch (e0) {
                          case 1:
                            Jn(V, p[1], 92), p[1]++, Jn(V, p[1], 48 + (g0 / ti | 0) | 0), p[1]++, Jn(V, p[1], 48 + ((g0 / 10 | 0) % 10 | 0) | 0), p[1]++, Jn(V, p[1], 48 + (g0 % 10 | 0) | 0);
                            break;
                          case 2:
                            Jn(V, p[1], 92), p[1]++, Jn(V, p[1], g0);
                            break;
                          case 3:
                            Jn(V, p[1], g0);
                            break;
                        }
                        p[1]++;
                        var x0 = k0 + 1 | 0;
                        if (f0 !== k0) {
                          var k0 = x0;
                          continue;
                        }
                        break;
                      }
                    var K = V;
                  }
                  var i4 = K;
                }
                var l = un(i4), c0 = k1(l + 2 | 0, 34);
                return Ts(i4, 0, c0, 1, l), c0;
              }
            }
            function wz(t4, n) {
              var e4 = gp(n), i4 = rz ? rz[1] : 70;
              switch (t4[2]) {
                case 0:
                  var x4 = Ri;
                  break;
                case 1:
                  var x4 = R7;
                  break;
                case 2:
                  var x4 = 69;
                  break;
                case 3:
                  var x4 = s7;
                  break;
                case 4:
                  var x4 = 71;
                  break;
                case 5:
                  var x4 = i4;
                  break;
                case 6:
                  var x4 = L7;
                  break;
                case 7:
                  var x4 = 72;
                  break;
                default:
                  var x4 = 70;
              }
              var c = yz(16);
              switch (Xv(c, 37), t4[1]) {
                case 0:
                  break;
                case 1:
                  Xv(c, 43);
                  break;
                default:
                  Xv(c, 32);
              }
              return 8 <= t4[2] && Xv(c, 35), Xv(c, 46), Lu(c, r2(C + e4)), Xv(c, x4), dz(c);
            }
            function Ap(t4, n) {
              if (13 <= t4) {
                var e4 = [0, 0], i4 = un(n) - 1 | 0, x4 = 0;
                if (!(i4 < 0))
                  for (var c = x4; ; ) {
                    9 < (Vr(n, c) + Wt | 0) >>> 0 || e4[1]++;
                    var s2 = c + 1 | 0;
                    if (i4 !== c) {
                      var c = s2;
                      continue;
                    }
                    break;
                  }
                var p = e4[1], y = Lt(un(n) + ((p - 1 | 0) / 3 | 0) | 0), T = [0, 0], E = function(K) {
                  return b1(y, T[1], K), T[1]++, 0;
                }, d = [0, ((p - 1 | 0) % 3 | 0) + 1 | 0], w = un(n) - 1 | 0, G = 0;
                if (!(w < 0))
                  for (var A11 = G; ; ) {
                    var S11 = Vr(n, A11);
                    9 < (S11 + Wt | 0) >>> 0 || (d[1] === 0 && (E(95), d[1] = 3), d[1] += -1), E(S11);
                    var M = A11 + 1 | 0;
                    if (w !== A11) {
                      var A11 = M;
                      continue;
                    }
                    break;
                  }
                return y;
              }
              return n;
            }
            function Kre(t4, n) {
              switch (t4) {
                case 1:
                  var e4 = gx0;
                  break;
                case 2:
                  var e4 = Fx0;
                  break;
                case 4:
                  var e4 = Tx0;
                  break;
                case 5:
                  var e4 = Ox0;
                  break;
                case 6:
                  var e4 = Ix0;
                  break;
                case 7:
                  var e4 = Ax0;
                  break;
                case 8:
                  var e4 = Nx0;
                  break;
                case 9:
                  var e4 = Cx0;
                  break;
                case 10:
                  var e4 = Px0;
                  break;
                case 11:
                  var e4 = Dx0;
                  break;
                case 0:
                case 13:
                  var e4 = Lx0;
                  break;
                case 3:
                case 14:
                  var e4 = Rx0;
                  break;
                default:
                  var e4 = jx0;
              }
              return Ap(t4, hp(e4, n));
            }
            function Wre(t4, n) {
              switch (t4) {
                case 1:
                  var e4 = Qf0;
                  break;
                case 2:
                  var e4 = rx0;
                  break;
                case 4:
                  var e4 = ex0;
                  break;
                case 5:
                  var e4 = nx0;
                  break;
                case 6:
                  var e4 = tx0;
                  break;
                case 7:
                  var e4 = ux0;
                  break;
                case 8:
                  var e4 = ix0;
                  break;
                case 9:
                  var e4 = fx0;
                  break;
                case 10:
                  var e4 = xx0;
                  break;
                case 11:
                  var e4 = ox0;
                  break;
                case 0:
                case 13:
                  var e4 = ax0;
                  break;
                case 3:
                case 14:
                  var e4 = cx0;
                  break;
                default:
                  var e4 = sx0;
              }
              return Ap(t4, hp(e4, n));
            }
            function Jre(t4, n) {
              switch (t4) {
                case 1:
                  var e4 = Bf0;
                  break;
                case 2:
                  var e4 = qf0;
                  break;
                case 4:
                  var e4 = Uf0;
                  break;
                case 5:
                  var e4 = Hf0;
                  break;
                case 6:
                  var e4 = Xf0;
                  break;
                case 7:
                  var e4 = Yf0;
                  break;
                case 8:
                  var e4 = Vf0;
                  break;
                case 9:
                  var e4 = zf0;
                  break;
                case 10:
                  var e4 = Kf0;
                  break;
                case 11:
                  var e4 = Wf0;
                  break;
                case 0:
                case 13:
                  var e4 = Jf0;
                  break;
                case 3:
                case 14:
                  var e4 = $f0;
                  break;
                default:
                  var e4 = Zf0;
              }
              return Ap(t4, hp(e4, n));
            }
            function $re(t4, n) {
              switch (t4) {
                case 1:
                  var e4 = vx0;
                  break;
                case 2:
                  var e4 = lx0;
                  break;
                case 4:
                  var e4 = bx0;
                  break;
                case 5:
                  var e4 = px0;
                  break;
                case 6:
                  var e4 = mx0;
                  break;
                case 7:
                  var e4 = _x0;
                  break;
                case 8:
                  var e4 = yx0;
                  break;
                case 9:
                  var e4 = hx0;
                  break;
                case 10:
                  var e4 = dx0;
                  break;
                case 11:
                  var e4 = kx0;
                  break;
                case 0:
                case 13:
                  var e4 = wx0;
                  break;
                case 3:
                case 14:
                  var e4 = Ex0;
                  break;
                default:
                  var e4 = Sx0;
              }
              return Ap(t4, d70(e4, n));
            }
            function ss(t4, n, e4) {
              function i4(m0) {
                switch (t4[1]) {
                  case 0:
                    var k0 = 45;
                    break;
                  case 1:
                    var k0 = 43;
                    break;
                  default:
                    var k0 = 32;
                }
                return m70(e4, n, k0);
              }
              function x4(m0) {
                var k0 = Zu0(e4);
                return k0 === 3 ? e4 < 0 ? jf0 : Gf0 : 4 <= k0 ? Rf0 : m0;
              }
              switch (t4[2]) {
                case 5:
                  for (var c = XA(wz(t4, n), e4), s2 = 0, p = un(c); ; ) {
                    if (s2 === p)
                      var y = 0;
                    else {
                      var T = It(c, s2) + v1 | 0, E = 0;
                      if (23 < T >>> 0 ? T === 55 && (E = 1) : 21 < (T - 1 | 0) >>> 0 && (E = 1), !E) {
                        var s2 = s2 + 1 | 0;
                        continue;
                      }
                      var y = 1;
                    }
                    var d = y ? c : Te(c, Mf0);
                    return x4(d);
                  }
                case 6:
                  return i4(0);
                case 7:
                  var w = i4(0), G = b7(w);
                  if (G === 0)
                    var A11 = w;
                  else {
                    var S11 = Lt(G), M = G - 1 | 0, K = 0;
                    if (!(M < 0))
                      for (var V = K; ; ) {
                        Jn(S11, V, xz(Xu(w, V)));
                        var f0 = V + 1 | 0;
                        if (M !== V) {
                          var V = f0;
                          continue;
                        }
                        break;
                      }
                    var A11 = S11;
                  }
                  return A11;
                case 8:
                  return x4(i4(0));
                default:
                  return XA(wz(t4, n), e4);
              }
            }
            function kl(t4, n, e4, i4) {
              for (var x4 = n, c = e4, s2 = i4; ; ) {
                if (typeof s2 == "number")
                  return u(x4, c);
                switch (s2[0]) {
                  case 0:
                    var p = s2[1];
                    return function(ar) {
                      return Xn(x4, [5, c, ar], p);
                    };
                  case 1:
                    var y = s2[1];
                    return function(ar) {
                      var _r = 0;
                      if (40 <= ar)
                        if (ar === 92)
                          var Ir = oi0;
                        else
                          zn <= ar ? _r = 1 : _r = 2;
                      else if (32 <= ar)
                        if (39 <= ar)
                          var Ir = ai0;
                        else
                          _r = 2;
                      else if (14 <= ar)
                        _r = 1;
                      else
                        switch (ar) {
                          case 8:
                            var Ir = ci0;
                            break;
                          case 9:
                            var Ir = si0;
                            break;
                          case 10:
                            var Ir = vi0;
                            break;
                          case 13:
                            var Ir = li0;
                            break;
                          default:
                            _r = 1;
                        }
                      switch (_r) {
                        case 1:
                          var fe = Lt(4);
                          Jn(fe, 0, 92), Jn(fe, 1, 48 + (ar / ti | 0) | 0), Jn(fe, 2, 48 + ((ar / 10 | 0) % 10 | 0) | 0), Jn(fe, 3, 48 + (ar % 10 | 0) | 0);
                          var Ir = fe;
                          break;
                        case 2:
                          var v0 = Lt(1);
                          Jn(v0, 0, ar);
                          var Ir = v0;
                          break;
                      }
                      var P = un(Ir), L = k1(P + 2 | 0, 39);
                      return Ts(Ir, 0, L, 1, P), Xn(x4, [4, c, L], y);
                    };
                  case 2:
                    var T = s2[2], E = s2[1];
                    return mN(x4, c, T, E, function(ar) {
                      return ar;
                    });
                  case 3:
                    return mN(x4, c, s2[2], s2[1], zre);
                  case 4:
                    return Np(x4, c, s2[4], s2[2], s2[3], Kre, s2[1]);
                  case 5:
                    return Np(x4, c, s2[4], s2[2], s2[3], Wre, s2[1]);
                  case 6:
                    return Np(x4, c, s2[4], s2[2], s2[3], Jre, s2[1]);
                  case 7:
                    return Np(x4, c, s2[4], s2[2], s2[3], $re, s2[1]);
                  case 8:
                    var d = s2[4], w = s2[3], G = s2[2], A11 = s2[1];
                    if (typeof G == "number") {
                      if (typeof w == "number")
                        return w ? function(ar, _r) {
                          return Xn(x4, [4, c, ss(A11, ar, _r)], d);
                        } : function(ar) {
                          return Xn(x4, [4, c, ss(A11, vN(A11), ar)], d);
                        };
                      var S11 = w[1];
                      return function(ar) {
                        return Xn(x4, [4, c, ss(A11, S11, ar)], d);
                      };
                    } else {
                      if (G[0] === 0) {
                        var M = G[2], K = G[1];
                        if (typeof w == "number")
                          return w ? function(ar, _r) {
                            return Xn(x4, [4, c, H7(K, M, ss(A11, ar, _r))], d);
                          } : function(ar) {
                            return Xn(x4, [4, c, H7(K, M, ss(A11, vN(A11), ar))], d);
                          };
                        var V = w[1];
                        return function(ar) {
                          return Xn(x4, [4, c, H7(K, M, ss(A11, V, ar))], d);
                        };
                      }
                      var f0 = G[1];
                      if (typeof w == "number")
                        return w ? function(ar, _r, Ir) {
                          return Xn(x4, [4, c, H7(f0, ar, ss(A11, _r, Ir))], d);
                        } : function(ar, _r) {
                          return Xn(x4, [4, c, H7(f0, ar, ss(A11, vN(A11), _r))], d);
                        };
                      var m0 = w[1];
                      return function(ar, _r) {
                        return Xn(x4, [4, c, H7(f0, ar, ss(A11, m0, _r))], d);
                      };
                    }
                  case 9:
                    return mN(x4, c, s2[2], s2[1], Gre);
                  case 10:
                    var c = [7, c], s2 = s2[1];
                    continue;
                  case 11:
                    var c = [2, c, s2[1]], s2 = s2[2];
                    continue;
                  case 12:
                    var c = [3, c, s2[1]], s2 = s2[2];
                    continue;
                  case 13:
                    var k0 = s2[3], g0 = s2[2], e0 = yz(16);
                    lN(e0, g0);
                    var x0 = dz(e0);
                    return function(ar) {
                      return Xn(x4, [4, c, x0], k0);
                    };
                  case 14:
                    var l = s2[3], c0 = s2[2];
                    return function(ar) {
                      var _r = ar[1], Ir = _t(_r, Gt(uu(c0)));
                      if (typeof Ir[2] == "number")
                        return Xn(x4, c, At(Ir[1], l));
                      throw Ou;
                    };
                  case 15:
                    var t0 = s2[1];
                    return function(ar, _r) {
                      return Xn(x4, [6, c, function(Ir) {
                        return o(ar, Ir, _r);
                      }], t0);
                    };
                  case 16:
                    var o0 = s2[1];
                    return function(ar) {
                      return Xn(x4, [6, c, ar], o0);
                    };
                  case 17:
                    var c = [0, c, s2[1]], s2 = s2[2];
                    continue;
                  case 18:
                    var w0 = s2[1];
                    if (w0[0] === 0) {
                      var _0 = s2[2], E0 = w0[1][1], U0 = 0, x4 = function(fe, v0, P) {
                        return function(L) {
                          return Xn(v0, [1, fe, [0, L]], P);
                        };
                      }(c, x4, _0), c = U0, s2 = E0;
                      continue;
                    }
                    var b = s2[2], R0 = w0[1][1], X = 0, x4 = function(ar, _r, Ir) {
                      return function(fe) {
                        return Xn(_r, [1, ar, [1, fe]], Ir);
                      };
                    }(c, x4, b), c = X, s2 = R0;
                    continue;
                  case 19:
                    throw [0, Sn, _f0];
                  case 20:
                    var s0 = s2[3], hr = [8, c, yf0];
                    return function(ar) {
                      return Xn(x4, hr, s0);
                    };
                  case 21:
                    var Ar = s2[2];
                    return function(ar) {
                      return Xn(x4, [4, c, hp(mf0, ar)], Ar);
                    };
                  case 22:
                    var or = s2[1];
                    return function(ar) {
                      return Xn(x4, [5, c, ar], or);
                    };
                  case 23:
                    var W0 = s2[2], Lr = s2[1];
                    if (typeof Lr == "number")
                      switch (Lr) {
                        case 0:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 1:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 2:
                          throw [0, Sn, hf0];
                        default:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                      }
                    else
                      switch (Lr[0]) {
                        case 0:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 1:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 2:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 3:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 4:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 5:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 6:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 7:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 8:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        case 9:
                          var Tr = Lr[2];
                          return t4 < 50 ? bN(t4 + 1 | 0, x4, c, Tr, W0) : Tu(bN, [0, x4, c, Tr, W0]);
                        case 10:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                        default:
                          return t4 < 50 ? ct(t4 + 1 | 0, x4, c, W0) : Tu(ct, [0, x4, c, W0]);
                      }
                  default:
                    var Hr = s2[3], Or = s2[1], fr = u(s2[2], 0);
                    return t4 < 50 ? pN(t4 + 1 | 0, x4, c, Hr, Or, fr) : Tu(pN, [0, x4, c, Hr, Or, fr]);
                }
              }
            }
            function bN(t4, n, e4, i4, x4) {
              if (typeof i4 == "number")
                return t4 < 50 ? ct(t4 + 1 | 0, n, e4, x4) : Tu(ct, [0, n, e4, x4]);
              switch (i4[0]) {
                case 0:
                  var c = i4[1];
                  return function(m0) {
                    return fi(n, e4, c, x4);
                  };
                case 1:
                  var s2 = i4[1];
                  return function(m0) {
                    return fi(n, e4, s2, x4);
                  };
                case 2:
                  var p = i4[1];
                  return function(m0) {
                    return fi(n, e4, p, x4);
                  };
                case 3:
                  var y = i4[1];
                  return function(m0) {
                    return fi(n, e4, y, x4);
                  };
                case 4:
                  var T = i4[1];
                  return function(m0) {
                    return fi(n, e4, T, x4);
                  };
                case 5:
                  var E = i4[1];
                  return function(m0) {
                    return fi(n, e4, E, x4);
                  };
                case 6:
                  var d = i4[1];
                  return function(m0) {
                    return fi(n, e4, d, x4);
                  };
                case 7:
                  var w = i4[1];
                  return function(m0) {
                    return fi(n, e4, w, x4);
                  };
                case 8:
                  var G = i4[2];
                  return function(m0) {
                    return fi(n, e4, G, x4);
                  };
                case 9:
                  var A11 = i4[3], S11 = i4[2], M = bu(uu(i4[1]), S11);
                  return function(m0) {
                    return fi(n, e4, u7(M, A11), x4);
                  };
                case 10:
                  var K = i4[1];
                  return function(m0, k0) {
                    return fi(n, e4, K, x4);
                  };
                case 11:
                  var V = i4[1];
                  return function(m0) {
                    return fi(n, e4, V, x4);
                  };
                case 12:
                  var f0 = i4[1];
                  return function(m0) {
                    return fi(n, e4, f0, x4);
                  };
                case 13:
                  throw [0, Sn, df0];
                default:
                  throw [0, Sn, kf0];
              }
            }
            function ct(t4, n, e4, i4) {
              var x4 = [8, e4, wf0];
              return t4 < 50 ? kl(t4 + 1 | 0, n, x4, i4) : Tu(kl, [0, n, x4, i4]);
            }
            function pN(t4, n, e4, i4, x4, c) {
              if (x4) {
                var s2 = x4[1];
                return function(y) {
                  return Zre(n, e4, i4, s2, u(c, y));
                };
              }
              var p = [4, e4, c];
              return t4 < 50 ? kl(t4 + 1 | 0, n, p, i4) : Tu(kl, [0, n, p, i4]);
            }
            function Xn(t4, n, e4) {
              return JA(kl(0, t4, n, e4));
            }
            function fi(t4, n, e4, i4) {
              return JA(bN(0, t4, n, e4, i4));
            }
            function Zre(t4, n, e4, i4, x4) {
              return JA(pN(0, t4, n, e4, i4, x4));
            }
            function mN(t4, n, e4, i4, x4) {
              if (typeof i4 == "number")
                return function(y) {
                  return Xn(t4, [4, n, u(x4, y)], e4);
                };
              if (i4[0] === 0) {
                var c = i4[2], s2 = i4[1];
                return function(y) {
                  return Xn(t4, [4, n, H7(s2, c, u(x4, y))], e4);
                };
              }
              var p = i4[1];
              return function(y, T) {
                return Xn(t4, [4, n, H7(p, y, u(x4, T))], e4);
              };
            }
            function Np(t4, n, e4, i4, x4, c, s2) {
              if (typeof i4 == "number") {
                if (typeof x4 == "number")
                  return x4 ? function(G, A11) {
                    return Xn(t4, [4, n, Yv(G, o(c, s2, A11))], e4);
                  } : function(G) {
                    return Xn(t4, [4, n, o(c, s2, G)], e4);
                  };
                var p = x4[1];
                return function(G) {
                  return Xn(t4, [4, n, Yv(p, o(c, s2, G))], e4);
                };
              } else {
                if (i4[0] === 0) {
                  var y = i4[2], T = i4[1];
                  if (typeof x4 == "number")
                    return x4 ? function(G, A11) {
                      return Xn(t4, [4, n, H7(T, y, Yv(G, o(c, s2, A11)))], e4);
                    } : function(G) {
                      return Xn(t4, [4, n, H7(T, y, o(c, s2, G))], e4);
                    };
                  var E = x4[1];
                  return function(G) {
                    return Xn(t4, [4, n, H7(T, y, Yv(E, o(c, s2, G)))], e4);
                  };
                }
                var d = i4[1];
                if (typeof x4 == "number")
                  return x4 ? function(G, A11, S11) {
                    return Xn(t4, [4, n, H7(d, G, Yv(A11, o(c, s2, S11)))], e4);
                  } : function(G, A11) {
                    return Xn(t4, [4, n, H7(d, G, o(c, s2, A11))], e4);
                  };
                var w = x4[1];
                return function(G, A11) {
                  return Xn(t4, [4, n, H7(d, G, Yv(w, o(c, s2, A11)))], e4);
                };
              }
            }
            function vs(t4, n) {
              for (var e4 = n; ; ) {
                if (typeof e4 == "number")
                  return 0;
                switch (e4[0]) {
                  case 0:
                    var i4 = e4[1], x4 = kz(e4[2]);
                    return vs(t4, i4), vl(t4, x4);
                  case 1:
                    var c = e4[2], s2 = e4[1];
                    if (c[0] === 0) {
                      var p = c[1];
                      vs(t4, s2), vl(t4, Ef0);
                      var e4 = p;
                      continue;
                    }
                    var y = c[1];
                    vs(t4, s2), vl(t4, Sf0);
                    var e4 = y;
                    continue;
                  case 6:
                    var T = e4[2];
                    return vs(t4, e4[1]), u(T, t4);
                  case 7:
                    return vs(t4, e4[1]), p1(t4);
                  case 8:
                    var E = e4[2];
                    return vs(t4, e4[1]), Pu(E);
                  case 2:
                  case 4:
                    var d = e4[2];
                    return vs(t4, e4[1]), vl(t4, d);
                  default:
                    var w = e4[2];
                    return vs(t4, e4[1]), KV(t4, w);
                }
              }
            }
            function ls(t4, n) {
              for (var e4 = n; ; ) {
                if (typeof e4 == "number")
                  return 0;
                switch (e4[0]) {
                  case 0:
                    var i4 = e4[1], x4 = kz(e4[2]);
                    return ls(t4, i4), hn(t4, x4);
                  case 1:
                    var c = e4[2], s2 = e4[1];
                    if (c[0] === 0) {
                      var p = c[1];
                      ls(t4, s2), hn(t4, gf0);
                      var e4 = p;
                      continue;
                    }
                    var y = c[1];
                    ls(t4, s2), hn(t4, Ff0);
                    var e4 = y;
                    continue;
                  case 6:
                    var T = e4[2];
                    return ls(t4, e4[1]), hn(t4, u(T, 0));
                  case 7:
                    var e4 = e4[1];
                    continue;
                  case 8:
                    var E = e4[2];
                    return ls(t4, e4[1]), Pu(E);
                  case 2:
                  case 4:
                    var d = e4[2];
                    return ls(t4, e4[1]), hn(t4, d);
                  default:
                    var w = e4[2];
                    return ls(t4, e4[1]), qi(t4, w);
                }
              }
            }
            function Qre(t4) {
              if (qn(t4, Of0))
                return If0;
              var n = un(t4);
              function e4(S11) {
                var M = Tf0[1], K = $n(N4);
                return u(Xn(function(V) {
                  return ls(K, V), ke(Mt(K));
                }, 0, M), t4);
              }
              function i4(S11) {
                for (var M = S11; ; ) {
                  if (M === n)
                    return M;
                  var K = It(t4, M);
                  if (K !== 9 && K !== 32)
                    return M;
                  var M = M + 1 | 0;
                }
              }
              function x4(S11, M) {
                for (var K = M; ; ) {
                  if (K === n || 25 < (It(t4, K) + Y3 | 0) >>> 0)
                    return K;
                  var K = K + 1 | 0;
                }
              }
              function c(S11, M) {
                for (var K = M; ; ) {
                  if (K === n)
                    return K;
                  var V = It(t4, K), f0 = 0;
                  if (48 <= V ? 58 <= V || (f0 = 1) : V === 45 && (f0 = 1), f0) {
                    var K = K + 1 | 0;
                    continue;
                  }
                  return K;
                }
              }
              var s2 = i4(0), p = x4(s2, s2), y = m7(t4, s2, p - s2 | 0), T = i4(p), E = c(T, T);
              if (T === E)
                var d = 0;
              else
                try {
                  var w = Bi(m7(t4, T, E - T | 0)), d = w;
                } catch (S11) {
                  if (S11 = Et(S11), S11[1] !== q7)
                    throw S11;
                  var d = e4(0);
                }
              i4(E) !== n && e4(0);
              var G = 0;
              if (n0(y, Af0) && n0(y, Nf0))
                var A11 = n0(y, Cf0) ? n0(y, Pf0) ? n0(y, Df0) ? n0(y, Lf0) ? e4(0) : 1 : 2 : 3 : 0;
              else
                G = 1;
              if (G)
                var A11 = 4;
              return [0, d, A11];
            }
            function _N(t4, n) {
              var e4 = n[1], i4 = 0;
              return Xn(function(x4) {
                return vs(t4, x4), 0;
              }, i4, e4);
            }
            function yN(t4) {
              return _N(Pc, t4);
            }
            function et(t4) {
              var n = t4[1];
              return Xn(function(e4) {
                var i4 = $n(64);
                return ls(i4, e4), Mt(i4);
              }, 0, n);
            }
            var hN = [0, 0];
            function dN(t4, n) {
              var e4 = t4[1 + n];
              if (1 - (typeof e4 == "number" ? 1 : 0)) {
                if (h1(e4) === Y2)
                  return u(et(ho0), e4);
                if (h1(e4) === nd)
                  for (var i4 = XA(ui0, e4), x4 = 0, c = un(i4); ; ) {
                    if (c <= x4)
                      return Te(i4, ii0);
                    var s2 = It(i4, x4), p = 0;
                    if (48 <= s2 ? 58 <= s2 || (p = 1) : s2 === 45 && (p = 1), p) {
                      var x4 = x4 + 1 | 0;
                      continue;
                    }
                    return i4;
                  }
                return do0;
              }
              return u(et(yo0), e4);
            }
            function Ez(t4, n) {
              if (t4.length - 1 <= n)
                return zx0;
              var e4 = Ez(t4, n + 1 | 0), i4 = dN(t4, n);
              return o(et(Kx0), i4, e4);
            }
            function Cp(t4) {
              function n(k0) {
                for (var g0 = k0; ; ) {
                  if (g0) {
                    var e0 = g0[2], x0 = g0[1];
                    try {
                      var l = 0, c0 = u(x0, t4);
                      l = 1;
                    } catch {
                    }
                    if (l && c0)
                      return [0, c0[1]];
                    var g0 = e0;
                    continue;
                  }
                  return 0;
                }
              }
              var e4 = n(hN[1]);
              if (e4)
                return e4[1];
              if (t4 === $A)
                return ao0;
              if (t4 === QV)
                return co0;
              if (t4[1] === ZV) {
                var i4 = t4[2], x4 = i4[3], c = i4[2], s2 = i4[1];
                return p7(et(QA), s2, c, x4, x4 + 5 | 0, so0);
              }
              if (t4[1] === Sn) {
                var p = t4[2], y = p[3], T = p[2], E = p[1];
                return p7(et(QA), E, T, y, y + 6 | 0, vo0);
              }
              if (t4[1] === sl) {
                var d = t4[2], w = d[3], G = d[2], A11 = d[1];
                return p7(et(QA), A11, G, w, w + 6 | 0, lo0);
              }
              if (h1(t4) === 0) {
                var S11 = t4.length - 1, M = t4[1][1];
                if (2 < S11 >>> 0)
                  var K = Ez(t4, 2), V = dN(t4, 1), f0 = o(et(bo0), V, K);
                else
                  switch (S11) {
                    case 0:
                      var f0 = po0;
                      break;
                    case 1:
                      var f0 = mo0;
                      break;
                    default:
                      var m0 = dN(t4, 1), f0 = u(et(_o0), m0);
                  }
                return Te(M, f0);
              }
              return t4[1];
            }
            function kN(t4, n) {
              var e4 = s70(n), i4 = e4.length - 1 - 1 | 0, x4 = 0;
              if (!(i4 < 0))
                for (var c = x4; ; ) {
                  var s2 = tu(e4, c)[1 + c], p = function(f0) {
                    return function(m0) {
                      return m0 ? f0 === 0 ? eo0 : no0 : f0 === 0 ? to0 : uo0;
                    };
                  }(c);
                  if (s2[0] === 0)
                    var y = s2[5], T = s2[4], E = s2[3], d = s2[6] ? io0 : fo0, w = s2[2], G = s2[7], A11 = p(s2[1]), M = [0, ei0(et(xo0), A11, G, w, d, E, T, y)];
                  else if (s2[1])
                    var M = 0;
                  else
                    var S11 = p(0), M = [0, u(et(oo0), S11)];
                  if (M) {
                    var K = M[1];
                    u(_N(t4, Qx0), K);
                  }
                  var V = c + 1 | 0;
                  if (i4 !== c) {
                    var c = V;
                    continue;
                  }
                  break;
                }
              return 0;
            }
            function Sz(t4) {
              for (; ; ) {
                var n = hN[1], e4 = 1 - nN(hN, n, [0, t4, n]);
                if (!e4)
                  return e4;
              }
            }
            var ree = ko0.slice();
            function eee(t4, n) {
              var e4 = Cp(t4);
              u(yN(Zx0), e4), kN(Pc, n);
              var i4 = T70(0);
              if (i4 < 0) {
                var x4 = gp(i4);
                iz(tu(ree, x4)[1 + x4]);
              }
              return p1(Pc);
            }
            var nee = [0];
            WA(r2(LH), function(t4, n) {
              try {
                try {
                  var e4 = n ? nee : GV(0);
                  try {
                    uN(0);
                  } catch {
                  }
                  try {
                    var i4 = eee(t4, e4), x4 = i4;
                  } catch (y) {
                    y = Et(y);
                    var c = Cp(t4);
                    u(yN(Wx0), c), kN(Pc, e4);
                    var s2 = Cp(y);
                    u(yN(Jx0), s2), kN(Pc, GV(0));
                    var x4 = p1(Pc);
                  }
                  var p = x4;
                } catch (y) {
                  if (y = Et(y), y !== $A)
                    throw y;
                  var p = iz($x0);
                }
                return p;
              } catch {
                return 0;
              }
            });
            var wN = [wt, Uo0, M7(0)], Pp = 0, gz = -1;
            function wl(t4, n) {
              return t4[13] = t4[13] + n[3] | 0, aN(n, t4[28]);
            }
            var Fz = 1000000010;
            function EN(t4, n) {
              return ur(t4[17], n, 0, un(n));
            }
            function Dp(t4) {
              return u(t4[19], 0);
            }
            function Tz(t4, n, e4) {
              return t4[9] = t4[9] - n | 0, EN(t4, e4), t4[11] = 0, 0;
            }
            function Lp(t4, n) {
              var e4 = n0(n, qo0);
              return e4 && Tz(t4, un(n), n);
            }
            function Vv(t4, n, e4) {
              var i4 = n[3], x4 = n[2];
              Lp(t4, n[1]), Dp(t4), t4[11] = 1;
              var c = (t4[6] - e4 | 0) + x4 | 0, s2 = t4[8], p = s2 <= c ? s2 : c;
              return t4[10] = p, t4[9] = t4[6] - t4[10] | 0, u(t4[21], t4[10]), Lp(t4, i4);
            }
            function Oz(t4, n) {
              return Vv(t4, Bo0, n);
            }
            function El(t4, n) {
              var e4 = n[2], i4 = n[3];
              return Lp(t4, n[1]), t4[9] = t4[9] - e4 | 0, u(t4[20], e4), Lp(t4, i4);
            }
            function Iz(t4) {
              for (; ; ) {
                var n = t4[28][2], e4 = n ? [0, n[1]] : 0;
                if (e4) {
                  var i4 = e4[1], x4 = i4[1], c = i4[2], s2 = 0 <= x4 ? 1 : 0, p = i4[3], y = t4[13] - t4[12] | 0, T = s2 || (t4[9] <= y ? 1 : 0);
                  if (T) {
                    var E = t4[28], d = E[2];
                    if (d) {
                      if (d[2]) {
                        var w = d[2];
                        E[1] = E[1] - 1 | 0, E[2] = w;
                      } else
                        oN(E);
                      var G = 0 <= x4 ? x4 : Fz;
                      if (typeof c == "number")
                        switch (c) {
                          case 0:
                            var A11 = Hv(t4[3]);
                            if (A11) {
                              var S11 = A11[1][1], M = function(L, Q) {
                                if (Q) {
                                  var i0 = Q[1], l0 = Q[2];
                                  return F70(L, i0) ? [0, L, Q] : [0, i0, M(L, l0)];
                                }
                                return [0, L, 0];
                              };
                              S11[1] = M(t4[6] - t4[9] | 0, S11[1]);
                            }
                            break;
                          case 1:
                            Uv(t4[2]);
                            break;
                          case 2:
                            Uv(t4[3]);
                            break;
                          case 3:
                            var K = Hv(t4[2]);
                            K ? Oz(t4, K[1][2]) : Dp(t4);
                            break;
                          case 4:
                            if (t4[10] !== (t4[6] - t4[9] | 0)) {
                              var V = t4[28], f0 = V[2];
                              if (f0) {
                                var m0 = f0[1];
                                if (f0[2]) {
                                  var k0 = f0[2];
                                  V[1] = V[1] - 1 | 0, V[2] = k0;
                                  var g0 = [0, m0];
                                } else {
                                  oN(V);
                                  var g0 = [0, m0];
                                }
                              } else
                                var g0 = 0;
                              if (g0) {
                                var e0 = g0[1], x0 = e0[1];
                                t4[12] = t4[12] - e0[3] | 0, t4[9] = t4[9] + x0 | 0;
                              }
                            }
                            break;
                          default:
                            var l = Uv(t4[5]);
                            l && EN(t4, u(t4[25], l[1]));
                        }
                      else
                        switch (c[0]) {
                          case 0:
                            Tz(t4, G, c[1]);
                            break;
                          case 1:
                            var c0 = c[2], t0 = c[1], o0 = c0[1], w0 = c0[2], _0 = Hv(t4[2]);
                            if (_0) {
                              var E0 = _0[1], U0 = E0[2];
                              switch (E0[1]) {
                                case 0:
                                  El(t4, t0);
                                  break;
                                case 1:
                                  Vv(t4, c0, U0);
                                  break;
                                case 2:
                                  Vv(t4, c0, U0);
                                  break;
                                case 3:
                                  t4[9] < (G + un(o0) | 0) ? Vv(t4, c0, U0) : El(t4, t0);
                                  break;
                                case 4:
                                  t4[11] || !(t4[9] < (G + un(o0) | 0) || ((t4[6] - U0 | 0) + w0 | 0) < t4[10]) ? El(t4, t0) : Vv(t4, c0, U0);
                                  break;
                                default:
                                  El(t4, t0);
                              }
                            }
                            break;
                          case 2:
                            var b = t4[6] - t4[9] | 0, R0 = c[2], X = c[1], s0 = Hv(t4[3]);
                            if (s0) {
                              var hr = s0[1][1], Ar = hr[1];
                              if (Ar)
                                for (var or = hr[1], W0 = Ar[1]; ; ) {
                                  if (or) {
                                    var Lr = or[1], Tr = or[2];
                                    if (!(b <= Lr)) {
                                      var or = Tr;
                                      continue;
                                    }
                                    var Hr = Lr;
                                  } else
                                    var Hr = W0;
                                  var Or = Hr;
                                  break;
                                }
                              else
                                var Or = b;
                              var fr = Or - b | 0;
                              0 <= fr ? El(t4, [0, jo0, fr + X | 0, Ro0]) : Vv(t4, [0, Mo0, Or + R0 | 0, Go0], t4[6]);
                            }
                            break;
                          case 3:
                            var Rr = c[2], Wr = c[1];
                            if (t4[8] < (t4[6] - t4[9] | 0)) {
                              var Jr = Hv(t4[2]);
                              if (Jr) {
                                var ar = Jr[1], _r = ar[2], Ir = ar[1];
                                t4[9] < _r && !(3 < (Ir - 1 | 0) >>> 0) && Oz(t4, _r);
                              } else
                                Dp(t4);
                            }
                            var fe = t4[9] - Wr | 0, v0 = Rr === 1 ? 1 : t4[9] < G ? Rr : 5;
                            w1([0, v0, fe], t4[2]);
                            break;
                          case 4:
                            w1(c[1], t4[3]);
                            break;
                          default:
                            var P = c[1];
                            EN(t4, u(t4[24], P)), w1(P, t4[5]);
                        }
                      t4[12] = p + t4[12] | 0;
                      continue;
                    }
                    throw Hre;
                  }
                  return T;
                }
                return 0;
              }
            }
            function Az(t4, n) {
              return wl(t4, n), Iz(t4);
            }
            function Nz(t4, n, e4) {
              return Az(t4, [0, n, [0, e4], n]);
            }
            function SN(t4) {
              return hl(t4), w1([0, -1, [0, gz, Lo0, 0]], t4);
            }
            function gN(t4, n) {
              var e4 = Hv(t4[1]);
              if (e4) {
                var i4 = e4[1], x4 = i4[2], c = x4[1];
                if (i4[1] < t4[12])
                  return SN(t4[1]);
                var s2 = x4[2];
                if (typeof s2 != "number")
                  switch (s2[0]) {
                    case 3:
                      var p = 1 - n, y = p && (x4[1] = t4[13] + c | 0, Uv(t4[1]), 0);
                      return y;
                    case 1:
                    case 2:
                      var T = n && (x4[1] = t4[13] + c | 0, Uv(t4[1]), 0);
                      return T;
                  }
                return 0;
              }
              return 0;
            }
            function Cz(t4, n, e4) {
              return wl(t4, e4), n && gN(t4, 1), w1([0, t4[13], e4], t4[1]);
            }
            function Pz(t4, n, e4) {
              if (t4[14] = t4[14] + 1 | 0, t4[14] < t4[15])
                return Cz(t4, 0, [0, -t4[13] | 0, [3, n, e4], 0]);
              var i4 = t4[14] === t4[15] ? 1 : 0;
              if (i4) {
                var x4 = t4[16];
                return Nz(t4, un(x4), x4);
              }
              return i4;
            }
            function Dz(t4, n) {
              var e4 = 1 < t4[14] ? 1 : 0;
              if (e4) {
                t4[14] < t4[15] && (wl(t4, [0, Pp, 1, 0]), gN(t4, 1), gN(t4, 0)), t4[14] = t4[14] - 1 | 0;
                var i4 = 0;
              } else
                var i4 = e4;
              return i4;
            }
            function Lz(t4, n) {
              t4[23] && wl(t4, [0, Pp, 5, 0]);
              var e4 = t4[22];
              if (e4) {
                var i4 = Uv(t4[4]);
                if (i4)
                  return u(t4[27], i4[1]);
                var x4 = 0;
              } else
                var x4 = e4;
              return x4;
            }
            function FN(t4, n) {
              var e4 = t4[4];
              function i4(x4) {
                return Lz(t4, 0);
              }
              for (Du(i4, e4[1]); ; ) {
                if (1 < t4[14]) {
                  Dz(t4, 0);
                  continue;
                }
                return t4[13] = Fz, Iz(t4), n && Dp(t4), t4[12] = 1, t4[13] = 1, oN(t4[28]), SN(t4[1]), hl(t4[2]), hl(t4[3]), hl(t4[4]), hl(t4[5]), t4[10] = 0, t4[14] = 0, t4[9] = t4[6], Pz(t4, 0, 3);
              }
            }
            function TN(t4, n, e4) {
              var i4 = t4[14] < t4[15] ? 1 : 0;
              return i4 && Nz(t4, n, e4);
            }
            function Rz(t4, n, e4) {
              return TN(t4, n, e4);
            }
            function g(t4, n) {
              return Rz(t4, un(n), n);
            }
            function Sl(t4, n) {
              return Rz(t4, 1, Tp(1, n));
            }
            function gl(t4, n) {
              return FN(t4, 0), u(t4[18], 0);
            }
            var jz = Tp(80, 32);
            function Gz(t4, n) {
              for (var e4 = n; ; ) {
                var i4 = 0 < e4 ? 1 : 0;
                if (i4) {
                  if (80 < e4) {
                    ur(t4[17], jz, 0, 80);
                    var e4 = e4 + eX | 0;
                    continue;
                  }
                  return ur(t4[17], jz, 0, e4);
                }
                return i4;
              }
            }
            function tee(t4) {
              return t4[1] === wN ? Te(Oo0, Te(t4[2], To0)) : Io0;
            }
            function uee(t4) {
              return t4[1] === wN ? Te(go0, Te(t4[2], So0)) : Fo0;
            }
            function iee(t4) {
              return 0;
            }
            function fee(t4) {
              return 0;
            }
            function Mz(t4, n) {
              function e4(w) {
                return 0;
              }
              function i4(w) {
                return 0;
              }
              function x4(w) {
                return 0;
              }
              var c = mz(0), s2 = [0, gz, wo0, 0];
              aN(s2, c);
              var p = yl(0);
              SN(p), w1([0, 1, s2], p);
              var y = yl(0), T = yl(0), E = yl(0), d = [0, p, yl(0), E, T, y, 78, 10, 68, 78, 0, 1, 1, 1, 1, jre, Eo0, t4, n, x4, i4, e4, 0, 0, tee, uee, iee, fee, c];
              return d[19] = function(w) {
                return ur(d[17], Ao0, 0, 1);
              }, d[20] = function(w) {
                return Gz(d, w);
              }, d[21] = function(w) {
                return Gz(d, w);
              }, d;
            }
            function Bz(t4) {
              function n(e4) {
                return p1(t4);
              }
              return Mz(function(e4, i4, x4) {
                return 0 <= i4 && 0 <= x4 && !((un(e4) - x4 | 0) < i4) ? zA(t4, e4, i4, x4) : Pu(ti0);
              }, n);
            }
            function ON(t4) {
              function n(e4) {
                return 0;
              }
              return Mz(function(e4, i4, x4) {
                return _z(t4, e4, i4, x4);
              }, n);
            }
            var xee = II;
            function qz(t4) {
              return $n(xee);
            }
            var oee = qz(0), aee = Bz(Mre), cee = Bz(Pc);
            ON(oee);
            function Uz(t4, n) {
              var e4 = $n(16), i4 = ON(e4);
              o(t4, i4, n), gl(i4, 0);
              var x4 = e4[2];
              if (2 <= x4) {
                var c = x4 - 2 | 0, s2 = 1;
                return 0 <= c && !((e4[2] - c | 0) < 1) ? qv(e4[1], s2, c) : Pu(Ri0);
              }
              return Mt(e4);
            }
            function X7(t4, n) {
              var e4 = 0;
              if (typeof n == "number")
                return 0;
              switch (n[0]) {
                case 0:
                  var i4 = n[2];
                  if (X7(t4, n[1]), typeof i4 == "number")
                    switch (i4) {
                      case 0:
                        return Dz(t4, 0);
                      case 1:
                        return Lz(t4, 0);
                      case 2:
                        return gl(t4, 0);
                      case 3:
                        var x4 = t4[14] < t4[15] ? 1 : 0;
                        return x4 && Az(t4, [0, Pp, 3, 0]);
                      case 4:
                        return FN(t4, 1), u(t4[18], 0);
                      case 5:
                        return Sl(t4, 64);
                      default:
                        return Sl(t4, 37);
                    }
                  else
                    switch (i4[0]) {
                      case 0:
                        var c = [0, Do0, i4[2], Po0], s2 = t4[14] < t4[15] ? 1 : 0, p = [0, Co0, i4[3], No0], y = c[3], T = c[2], E = c[1];
                        return s2 && Cz(t4, 1, [0, -t4[13] | 0, [1, c, p], (un(E) + T | 0) + un(y) | 0]);
                      case 1:
                        return 0;
                      default:
                        var d = i4[1];
                        return Sl(t4, 64), Sl(t4, d);
                    }
                case 1:
                  var w = n[2], G = n[1];
                  if (w[0] === 0) {
                    var A11 = w[1];
                    X7(t4, G);
                    var S11 = [0, wN, Uz(X7, A11)];
                    t4[22] && (w1(S11, t4[4]), u(t4[26], S11));
                    var M = t4[23];
                    return M && wl(t4, [0, Pp, [5, S11], 0]);
                  }
                  var K = w[1];
                  X7(t4, G);
                  var V = Qre(Uz(X7, K));
                  return Pz(t4, V[1], V[2]);
                case 2:
                  var f0 = n[1], m0 = 0;
                  if (typeof f0 != "number" && f0[0] === 0) {
                    var k0 = f0[2], g0 = 0;
                    if (typeof k0 != "number" && k0[0] === 1) {
                      var e0 = n[2], x0 = k0[2], l = f0[1];
                      m0 = 1, g0 = 1;
                    }
                  }
                  if (!m0) {
                    var c0 = n[2], t0 = f0;
                    e4 = 2;
                  }
                  break;
                case 3:
                  var o0 = n[1], w0 = 0;
                  if (typeof o0 != "number" && o0[0] === 0) {
                    var _0 = o0[2], E0 = 0;
                    if (typeof _0 != "number" && _0[0] === 1) {
                      var U0 = n[2], b = _0[2], R0 = o0[1];
                      e4 = 1, w0 = 1, E0 = 1;
                    }
                  }
                  if (!w0) {
                    var X = n[2], s0 = o0;
                    e4 = 3;
                  }
                  break;
                case 4:
                  var hr = n[1], Ar = 0;
                  if (typeof hr != "number" && hr[0] === 0) {
                    var or = hr[2], W0 = 0;
                    if (typeof or != "number" && or[0] === 1) {
                      var e0 = n[2], x0 = or[2], l = hr[1];
                      Ar = 1, W0 = 1;
                    }
                  }
                  if (!Ar) {
                    var c0 = n[2], t0 = hr;
                    e4 = 2;
                  }
                  break;
                case 5:
                  var Lr = n[1], Tr = 0;
                  if (typeof Lr == "number" || Lr[0] !== 0)
                    Tr = 1;
                  else {
                    var Hr = Lr[2], Or = 0;
                    if (typeof Hr != "number" && Hr[0] === 1) {
                      var U0 = n[2], b = Hr[2], R0 = Lr[1];
                      e4 = 1, Or = 1;
                    }
                    Or || (Tr = 1);
                  }
                  if (Tr) {
                    var X = n[2], s0 = Lr;
                    e4 = 3;
                  }
                  break;
                case 6:
                  var fr = n[2];
                  return X7(t4, n[1]), u(fr, t4);
                case 7:
                  return X7(t4, n[1]), gl(t4, 0);
                default:
                  var Rr = n[2];
                  return X7(t4, n[1]), Pu(Rr);
              }
              switch (e4) {
                case 0:
                  return X7(t4, l), TN(t4, x0, e0);
                case 1:
                  return X7(t4, R0), TN(t4, b, Tp(1, U0));
                case 2:
                  return X7(t4, t0), g(t4, c0);
                default:
                  return X7(t4, s0), Sl(t4, X);
              }
            }
            function f4(t4) {
              return function(n) {
                var e4 = n[1], i4 = 0;
                return Xn(function(x4) {
                  return X7(t4, x4), 0;
                }, i4, e4);
              };
            }
            function C0(t4) {
              var n = t4[1], e4 = qz(0), i4 = ON(e4);
              return Xn(function(x4) {
                X7(i4, x4), FN(i4, 0);
                var c = Mt(e4);
                return e4[2] = 0, e4[1] = e4[4], e4[3] = b7(e4[1]), c;
              }, 0, n);
            }
            fz(function(t4) {
              return gl(aee, 0), gl(cee, 0);
            });
            function see(t4, n) {
              var e4 = h1(n) === wt ? n : n[1];
              return WA(t4, e4);
            }
            var vee = 2;
            function lee(t4) {
              var n = [0, 0], e4 = un(t4) - 1 | 0, i4 = 0;
              if (!(e4 < 0))
                for (var x4 = i4; ; ) {
                  var c = It(t4, x4);
                  n[1] = (y8 * n[1] | 0) + c | 0;
                  var s2 = x4 + 1 | 0;
                  if (e4 !== x4) {
                    var x4 = s2;
                    continue;
                  }
                  break;
                }
              n[1] = n[1] & mH;
              var p = 1073741823 < n[1] ? n[1] + 2147483648 | 0 : n[1];
              return p;
            }
            var bs = xN([0, Ee]), E1 = xN([0, Ee]), Is = xN([0, Ac]), Hz = KA(0, 0), bee = [0, 0];
            function Xz(t4) {
              return 2 < t4 ? Xz((t4 + 1 | 0) / 2 | 0) * 2 | 0 : t4;
            }
            function Yz(t4) {
              bee[1]++;
              var n = t4.length - 1, e4 = Gv((n * 2 | 0) + 2 | 0, Hz);
              tu(e4, 0)[1] = n;
              var i4 = ((Xz(n) * 32 | 0) / 8 | 0) - 1 | 0;
              tu(e4, 1)[2] = i4;
              var x4 = n - 1 | 0, c = 0;
              if (!(x4 < 0))
                for (var s2 = c; ; ) {
                  var p = (s2 * 2 | 0) + 3 | 0, y = tu(t4, s2)[1 + s2];
                  tu(e4, p)[1 + p] = y;
                  var T = s2 + 1 | 0;
                  if (x4 !== s2) {
                    var s2 = T;
                    continue;
                  }
                  break;
                }
              return [0, vee, e4, E1[1], Is[1], 0, 0, bs[1], 0];
            }
            function IN(t4, n) {
              var e4 = t4[2].length - 1, i4 = e4 < n ? 1 : 0;
              if (i4) {
                var x4 = Gv(n, Hz), c = t4[2], s2 = 0;
                0 <= e4 && !((c.length - 1 - e4 | 0) < 0) && !((x4.length - 1 - e4 | 0) < 0) && (Ku0(c, 0, x4, 0, e4), s2 = 1), s2 || Pu(di0), t4[2] = x4;
                var p = 0;
              } else
                var p = i4;
              return p;
            }
            var Vz = [0, 0], pee = [0, 0];
            function AN(t4) {
              var n = t4[2].length - 1;
              return IN(t4, n + 1 | 0), n;
            }
            function Fl(t4, n) {
              try {
                var e4 = o(E1[28], n, t4[3]);
                return e4;
              } catch (x4) {
                if (x4 = Et(x4), x4 === Jt) {
                  var i4 = AN(t4);
                  return t4[3] = ur(E1[4], n, i4, t4[3]), t4[4] = ur(Is[4], i4, 1, t4[4]), i4;
                }
                throw x4;
              }
            }
            function NN(t4, n) {
              return Op(function(e4) {
                return Fl(t4, e4);
              }, n);
            }
            function zz(t4, n, e4) {
              return pee[1]++, o(Is[28], n, t4[4]) ? (IN(t4, n + 1 | 0), tu(t4[2], n)[1 + n] = e4, 0) : (t4[6] = [0, [0, n, e4], t4[6]], 0);
            }
            function mee(t4, n) {
              try {
                var e4 = Ure(n, t4[6]);
                return e4;
              } catch (i4) {
                if (i4 = Et(i4), i4 === Jt)
                  return tu(t4[2], n)[1 + n];
                throw i4;
              }
            }
            function CN(t4) {
              if (t4 === 0)
                return 0;
              for (var n = t4.length - 1 - 1 | 0, e4 = 0; ; ) {
                if (0 <= n) {
                  var i4 = [0, t4[1 + n], e4], n = n - 1 | 0, e4 = i4;
                  continue;
                }
                return e4;
              }
            }
            function _ee(t4) {
              var n = t4[1];
              return t4[1] = n + 1 | 0, n;
            }
            function PN(t4, n) {
              try {
                var e4 = o(bs[28], n, t4[7]);
                return e4;
              } catch (x4) {
                if (x4 = Et(x4), x4 === Jt) {
                  var i4 = _ee(t4);
                  return n0(n, Xo0) && (t4[7] = ur(bs[4], n, i4, t4[7])), i4;
                }
                throw x4;
              }
            }
            function DN(t4) {
              return RV(t4, 0) ? [0] : t4;
            }
            function yee(t4, n) {
              try {
                var e4 = o(bs[28], n, t4[7]);
                return e4;
              } catch (i4) {
                throw i4 = Et(i4), i4 === Jt ? [0, Sn, Ho0] : i4;
              }
            }
            function LN(t4, n, e4, i4, x4, c) {
              var s2 = x4[2], p = x4[4], y = CN(n), T = CN(e4), E = CN(i4), d = d1(function(b) {
                return Fl(t4, b);
              }, T), w = d1(function(b) {
                return Fl(t4, b);
              }, E);
              t4[5] = [0, [0, t4[3], t4[4], t4[6], t4[7], d, y], t4[5]];
              var G = bs[1], A11 = t4[7];
              function S11(b, R0, X) {
                return fN(b, y) ? ur(bs[4], b, R0, X) : X;
              }
              t4[7] = ur(bs[13], S11, A11, G);
              var M = [0, E1[1]], K = [0, Is[1]];
              cz(function(b, R0) {
                M[1] = ur(E1[4], b, R0, M[1]);
                var X = K[1];
                try {
                  var s0 = o(Is[28], R0, t4[4]), hr = s0;
                } catch (Ar) {
                  if (Ar = Et(Ar), Ar !== Jt)
                    throw Ar;
                  var hr = 1;
                }
                return K[1] = ur(Is[4], R0, hr, X), 0;
              }, E, w), cz(function(b, R0) {
                return M[1] = ur(E1[4], b, R0, M[1]), K[1] = ur(Is[4], R0, 0, K[1]), 0;
              }, T, d), t4[3] = M[1], t4[4] = K[1];
              var V = 0, f0 = t4[6];
              t4[6] = iN(function(b, R0) {
                return fN(b[1], d) ? R0 : [0, b, R0];
              }, f0, V);
              var m0 = c ? o(s2, t4, p) : u(s2, t4), k0 = bl(t4[5]), g0 = k0[6], e0 = k0[5], x0 = k0[4], l = k0[3], c0 = k0[2], t0 = k0[1];
              t4[5] = az(t4[5]), t4[7] = le(function(b, R0) {
                var X = o(bs[28], R0, t4[7]);
                return ur(bs[4], R0, X, b);
              }, x0, g0), t4[3] = t0, t4[4] = c0;
              var o0 = t4[6];
              t4[6] = iN(function(b, R0) {
                return fN(b[1], e0) ? R0 : [0, b, R0];
              }, o0, l);
              var w0 = 0, _0 = DN(i4), E0 = [0, Op(function(b) {
                return mee(t4, Fl(t4, b));
              }, _0), w0], U0 = DN(n);
              return Wu0([0, [0, m0], [0, Op(function(b) {
                return yee(t4, b);
              }, U0), E0]]);
            }
            function Rp(t4, n) {
              if (t4 === 0)
                var e4 = Yz([0]);
              else {
                var i4 = Yz(Op(lee, t4)), x4 = t4.length - 1 - 1 | 0, c = 0;
                if (!(x4 < 0))
                  for (var s2 = c; ; ) {
                    var p = (s2 * 2 | 0) + 2 | 0;
                    i4[3] = ur(E1[4], t4[1 + s2], p, i4[3]), i4[4] = ur(Is[4], p, 1, i4[4]);
                    var y = s2 + 1 | 0;
                    if (x4 !== s2) {
                      var s2 = y;
                      continue;
                    }
                    break;
                  }
                var e4 = i4;
              }
              var T = u(n, e4);
              return Vz[1] = (Vz[1] + e4[1] | 0) - 1 | 0, e4[8] = ye(e4[8]), IN(e4, 3 + ((tu(e4[2], 1)[2] * 16 | 0) / 32 | 0) | 0), [0, u(T, 0), n, T, 0];
            }
            function jp(t4, n) {
              if (t4)
                return t4;
              var e4 = KA(wt, n[1]);
              return e4[1] = n[2], H70(e4);
            }
            function RN(t4, n, e4) {
              if (t4)
                return n;
              var i4 = e4[8];
              if (i4 !== 0)
                for (var x4 = i4; ; ) {
                  if (x4) {
                    var c = x4[2];
                    u(x4[1], n);
                    var x4 = c;
                    continue;
                  }
                  break;
                }
              return n;
            }
            function Gp(t4) {
              var n = AN(t4), e4 = 0;
              if ((n % 2 | 0) !== 0 && !((2 + ((tu(t4[2], 1)[2] * 16 | 0) / 32 | 0) | 0) < n)) {
                var i4 = AN(t4);
                e4 = 1;
              }
              if (!e4)
                var i4 = n;
              return tu(t4[2], i4)[1 + i4] = 0, i4;
            }
            function jN(t4, n) {
              for (var e4 = [0, 0], i4 = n.length - 1; ; ) {
                if (e4[1] < i4) {
                  var x4 = e4[1], c = tu(n, x4)[1 + x4], s2 = function(p0) {
                    e4[1]++;
                    var b0 = e4[1];
                    return tu(n, b0)[1 + b0];
                  }, p = s2(0);
                  if (typeof p == "number")
                    switch (p) {
                      case 0:
                        var y = s2(0), Z7 = function(b0) {
                          return function(O0) {
                            return b0;
                          };
                        }(y);
                        break;
                      case 1:
                        var T = s2(0), Z7 = function(b0) {
                          return function(O0) {
                            return O0[1 + b0];
                          };
                        }(T);
                        break;
                      case 2:
                        var E = s2(0), d = s2(0), Z7 = function(b0, O0) {
                          return function(M0) {
                            return M0[1 + b0][1 + O0];
                          };
                        }(E, d);
                        break;
                      case 3:
                        var w = s2(0), Z7 = function(b0) {
                          return function(O0) {
                            return u(O0[1][1 + b0], O0);
                          };
                        }(w);
                        break;
                      case 4:
                        var G = s2(0), Z7 = function(b0) {
                          return function(O0, M0) {
                            return O0[1 + b0] = M0, 0;
                          };
                        }(G);
                        break;
                      case 5:
                        var A11 = s2(0), S11 = s2(0), Z7 = function(b0, O0) {
                          return function(M0) {
                            return u(b0, O0);
                          };
                        }(A11, S11);
                        break;
                      case 6:
                        var M = s2(0), K = s2(0), Z7 = function(b0, O0) {
                          return function(M0) {
                            return u(b0, M0[1 + O0]);
                          };
                        }(M, K);
                        break;
                      case 7:
                        var V = s2(0), f0 = s2(0), m0 = s2(0), Z7 = function(b0, O0, M0) {
                          return function(er) {
                            return u(b0, er[1 + O0][1 + M0]);
                          };
                        }(V, f0, m0);
                        break;
                      case 8:
                        var k0 = s2(0), g0 = s2(0), Z7 = function(b0, O0) {
                          return function(M0) {
                            return u(b0, u(M0[1][1 + O0], M0));
                          };
                        }(k0, g0);
                        break;
                      case 9:
                        var e0 = s2(0), x0 = s2(0), l = s2(0), Z7 = function(b0, O0, M0) {
                          return function(er) {
                            return o(b0, O0, M0);
                          };
                        }(e0, x0, l);
                        break;
                      case 10:
                        var c0 = s2(0), t0 = s2(0), o0 = s2(0), Z7 = function(b0, O0, M0) {
                          return function(er) {
                            return o(b0, O0, er[1 + M0]);
                          };
                        }(c0, t0, o0);
                        break;
                      case 11:
                        var w0 = s2(0), _0 = s2(0), E0 = s2(0), U0 = s2(0), Z7 = function(b0, O0, M0, er) {
                          return function(yr) {
                            return o(b0, O0, yr[1 + M0][1 + er]);
                          };
                        }(w0, _0, E0, U0);
                        break;
                      case 12:
                        var b = s2(0), R0 = s2(0), X = s2(0), Z7 = function(b0, O0, M0) {
                          return function(er) {
                            return o(b0, O0, u(er[1][1 + M0], er));
                          };
                        }(b, R0, X);
                        break;
                      case 13:
                        var s0 = s2(0), hr = s2(0), Ar = s2(0), Z7 = function(b0, O0, M0) {
                          return function(er) {
                            return o(b0, er[1 + O0], M0);
                          };
                        }(s0, hr, Ar);
                        break;
                      case 14:
                        var or = s2(0), W0 = s2(0), Lr = s2(0), Tr = s2(0), Z7 = function(b0, O0, M0, er) {
                          return function(yr) {
                            return o(b0, yr[1 + O0][1 + M0], er);
                          };
                        }(or, W0, Lr, Tr);
                        break;
                      case 15:
                        var Hr = s2(0), Or = s2(0), fr = s2(0), Z7 = function(b0, O0, M0) {
                          return function(er) {
                            return o(b0, u(er[1][1 + O0], er), M0);
                          };
                        }(Hr, Or, fr);
                        break;
                      case 16:
                        var Rr = s2(0), Wr = s2(0), Z7 = function(b0, O0) {
                          return function(M0) {
                            return o(M0[1][1 + b0], M0, O0);
                          };
                        }(Rr, Wr);
                        break;
                      case 17:
                        var Jr = s2(0), ar = s2(0), Z7 = function(b0, O0) {
                          return function(M0) {
                            return o(M0[1][1 + b0], M0, M0[1 + O0]);
                          };
                        }(Jr, ar);
                        break;
                      case 18:
                        var _r = s2(0), Ir = s2(0), fe = s2(0), Z7 = function(b0, O0, M0) {
                          return function(er) {
                            return o(er[1][1 + b0], er, er[1 + O0][1 + M0]);
                          };
                        }(_r, Ir, fe);
                        break;
                      case 19:
                        var v0 = s2(0), P = s2(0), Z7 = function(b0, O0) {
                          return function(M0) {
                            var er = u(M0[1][1 + O0], M0);
                            return o(M0[1][1 + b0], M0, er);
                          };
                        }(v0, P);
                        break;
                      case 20:
                        var L = s2(0), Q = s2(0);
                        Gp(t4);
                        var Z7 = function(b0, O0) {
                          return function(M0) {
                            return u(Qe(O0, b0, 0), O0);
                          };
                        }(L, Q);
                        break;
                      case 21:
                        var i0 = s2(0), l0 = s2(0);
                        Gp(t4);
                        var Z7 = function(b0, O0) {
                          return function(M0) {
                            var er = M0[1 + O0];
                            return u(Qe(er, b0, 0), er);
                          };
                        }(i0, l0);
                        break;
                      case 22:
                        var S0 = s2(0), T0 = s2(0), rr = s2(0);
                        Gp(t4);
                        var Z7 = function(b0, O0, M0) {
                          return function(er) {
                            var yr = er[1 + O0][1 + M0];
                            return u(Qe(yr, b0, 0), yr);
                          };
                        }(S0, T0, rr);
                        break;
                      default:
                        var L0 = s2(0), B = s2(0);
                        Gp(t4);
                        var Z7 = function(b0, O0) {
                          return function(M0) {
                            var er = u(M0[1][1 + O0], M0);
                            return u(Qe(er, b0, 0), er);
                          };
                        }(L0, B);
                    }
                  else
                    var Z7 = p;
                  zz(t4, c, Z7), e4[1]++;
                  continue;
                }
                return 0;
              }
            }
            function Kz(t4, n) {
              var e4 = n.length - 1, i4 = KA(0, e4), x4 = e4 - 1 | 0, c = 0;
              if (!(x4 < 0))
                for (var s2 = c; ; ) {
                  var p = tu(n, s2)[1 + s2];
                  if (typeof p == "number")
                    switch (p) {
                      case 0:
                        var E = function(G) {
                          function A11(S11) {
                            var M = i4[1 + G];
                            if (A11 === M)
                              throw [0, sl, t4];
                            return u(M, S11);
                          }
                          return A11;
                        }(s2);
                        break;
                      case 1:
                        var y = [];
                        N(y, [$2, function(G, A11) {
                          return function(S11) {
                            var M = i4[1 + A11];
                            if (G === M)
                              throw [0, sl, t4];
                            var K = h1(M);
                            return nl === K ? M[1] : $2 === K ? Vre(M) : M;
                          };
                        }(y, s2)]);
                        var E = y;
                        break;
                      default:
                        var T = function(G) {
                          throw [0, sl, t4];
                        }, E = [0, T, T, T, 0];
                    }
                  else
                    var E = p[0] === 0 ? Kz(t4, p[1]) : p[1];
                  i4[1 + s2] = E;
                  var d = s2 + 1 | 0;
                  if (x4 !== s2) {
                    var s2 = d;
                    continue;
                  }
                  break;
                }
              return i4;
            }
            function pu(t4, n) {
              return typeof n != "number" && n[0] === 0 ? Kz(t4, n[1]) : ke(Ko0);
            }
            function Wz(t4, n, e4) {
              if (h1(e4) === 0 && t4.length - 1 <= e4.length - 1) {
                var i4 = t4.length - 1 - 1 | 0, x4 = 0;
                if (!(i4 < 0))
                  for (var c = x4; ; ) {
                    var s2 = e4[1 + c], p = tu(t4, c)[1 + c];
                    if (typeof p == "number")
                      if (p === 2) {
                        var y = 0;
                        if (h1(s2) === 0 && s2.length - 1 === 4)
                          for (var T = 0, E = n[1 + c]; ; ) {
                            E[1 + T] = s2[1 + T];
                            var d = T + 1 | 0;
                            if (T !== 3) {
                              var T = d;
                              continue;
                            }
                            break;
                          }
                        else
                          y = 1;
                        if (y)
                          throw [0, Sn, Yo0];
                      } else
                        n[1 + c] = s2;
                    else
                      p[0] === 0 && Wz(p[1], n[1 + c], s2);
                    var w = c + 1 | 0;
                    if (i4 !== c) {
                      var c = w;
                      continue;
                    }
                    break;
                  }
                return 0;
              }
              throw [0, Sn, Vo0];
            }
            function mu(t4, n, e4) {
              return typeof t4 != "number" && t4[0] === 0 ? Wz(t4[1], n, e4) : ke(zo0);
            }
            try {
              WV(Wo0);
            } catch (t4) {
              if (t4 = Et(t4), t4 !== Jt)
                throw t4;
            }
            try {
              WV(Jo0);
            } catch (t4) {
              if (t4 = Et(t4), t4 !== Jt)
                throw t4;
            }
            n0(oz, $o0) && n0(oz, Zo0);
            function S1(t4, n) {
              function e4(i4) {
                return qi(t4, i4);
              }
              return fw <= n ? (e4(s1 | n >>> 18 | 0), e4(jt | (n >>> 12 | 0) & 63), e4(jt | (n >>> 6 | 0) & 63), e4(jt | n & 63)) : Hh <= n ? (e4(hv | n >>> 12 | 0), e4(jt | (n >>> 6 | 0) & 63), e4(jt | n & 63)) : jt <= n ? (e4(rt | n >>> 6 | 0), e4(jt | n & 63)) : e4(n);
            }
            var GN = z0, i7 = null, Jz = void 0;
            function Mp(t4) {
              return t4 !== Jz ? 1 : 0;
            }
            var hee = GN.Array, MN = [wt, ra0, M7(0)], dee = GN.Error;
            see(ea0, [0, MN, {}]);
            function $z(t4) {
              throw t4;
            }
            Sz(function(t4) {
              return t4[1] === MN ? [0, B7(t4[2].toString())] : 0;
            }), Sz(function(t4) {
              return t4 instanceof hee ? 0 : [0, B7(t4.toString())];
            });
            var Dr = pu(e3r, r3r), Rn = pu(t3r, n3r), Bp = pu(i3r, u3r), Tl = pu(x3r, f3r), g1 = pu(a3r, o3r), BN = pu(s3r, c3r), Zz = pu(l3r, v3r), qN = pu(p3r, b3r), zv = pu(_3r, m3r), qp = pu(h3r, y3r), $e = pu(k3r, d3r), Yu = pu(E3r, w3r), qe = pu(g3r, S3r), UN = pu(T3r, F3r), di = pu(I3r, O3r), iu = pu(N3r, A3r), F1 = pu(P3r, C3r), As = pu(L3r, D3r), HN = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, Qz = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, kee = pu(j3r, R3r);
            N(HN, function(t4, n, e4, i4) {
              u(f4(e4), j8r), o(f4(e4), M8r, G8r);
              var x4 = i4[1];
              u(f4(e4), B8r);
              var c = 0;
              le(function(y, T) {
                y && u(f4(e4), R8r);
                function E(d) {
                  return u(t4, d);
                }
                return ur(iu[1], E, e4, T), 1;
              }, c, x4), u(f4(e4), q8r), u(f4(e4), U8r), u(f4(e4), H8r), o(f4(e4), Y8r, X8r);
              var s2 = i4[2];
              u(f4(e4), V8r);
              var p = 0;
              return le(function(y, T) {
                y && u(f4(e4), L8r);
                function E(d) {
                  return u(t4, d);
                }
                return ur(iu[1], E, e4, T), 1;
              }, p, s2), u(f4(e4), z8r), u(f4(e4), K8r), u(f4(e4), W8r), o(f4(e4), $8r, J8r), o(n, e4, i4[3]), u(f4(e4), Z8r), u(f4(e4), Q8r);
            }), N(Qz, function(t4, n, e4) {
              var i4 = o(HN, t4, n);
              return o(C0(D8r), i4, e4);
            }), mu(G3r, Dr, [0, HN, Qz]);
            var XN = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, rK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Up = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, eK = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(XN, function(t4, n, e4, i4) {
              u(f4(e4), N8r), o(n, e4, i4[1]), u(f4(e4), C8r);
              var x4 = i4[2];
              return ur(Up, function(c) {
                return u(t4, c);
              }, e4, x4), u(f4(e4), P8r);
            }), N(rK, function(t4, n, e4) {
              var i4 = o(XN, t4, n);
              return o(C0(A8r), i4, e4);
            }), N(Up, function(t4, n, e4) {
              u(f4(n), _8r), o(f4(n), h8r, y8r);
              var i4 = e4[1];
              o(f4(n), d8r, i4), u(f4(n), k8r), u(f4(n), w8r), o(f4(n), S8r, E8r);
              var x4 = e4[2];
              if (x4) {
                g(n, g8r);
                var c = x4[1], s2 = function(y, T) {
                  return g(y, m8r);
                }, p = function(y) {
                  return u(t4, y);
                };
                R(Dr[1], p, s2, n, c), g(n, F8r);
              } else
                g(n, T8r);
              return u(f4(n), O8r), u(f4(n), I8r);
            }), N(eK, function(t4, n) {
              var e4 = u(Up, t4);
              return o(C0(p8r), e4, n);
            }), mu(M3r, Rn, [0, XN, rK, Up, eK]);
            var YN = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, nK = function t4(n, e4) {
              return t4.fun(n, e4);
            }, Hp = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, tK = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(YN, function(t4, n, e4) {
              u(f4(n), v8r), o(t4, n, e4[1]), u(f4(n), l8r);
              var i4 = e4[2];
              return ur(Hp, function(x4) {
                return u(t4, x4);
              }, n, i4), u(f4(n), b8r);
            }), N(nK, function(t4, n) {
              var e4 = u(YN, t4);
              return o(C0(s8r), e4, n);
            }), N(Hp, function(t4, n, e4) {
              u(f4(n), Z4r), o(f4(n), r8r, Q4r);
              var i4 = e4[1];
              o(f4(n), e8r, i4), u(f4(n), n8r), u(f4(n), t8r), o(f4(n), i8r, u8r);
              var x4 = e4[2];
              if (x4) {
                g(n, f8r);
                var c = x4[1], s2 = function(y, T) {
                  return g(y, $4r);
                }, p = function(y) {
                  return u(t4, y);
                };
                R(Dr[1], p, s2, n, c), g(n, x8r);
              } else
                g(n, o8r);
              return u(f4(n), a8r), u(f4(n), c8r);
            }), N(tK, function(t4, n) {
              var e4 = u(Hp, t4);
              return o(C0(J4r), e4, n);
            }), mu(B3r, Bp, [0, YN, nK, Hp, tK]);
            function uK(t4, n) {
              u(f4(t4), G4r), o(f4(t4), B4r, M4r);
              var e4 = n[1];
              o(f4(t4), q4r, e4), u(f4(t4), U4r), u(f4(t4), H4r), o(f4(t4), Y4r, X4r);
              var i4 = n[2];
              return o(f4(t4), V4r, i4), u(f4(t4), z4r), u(f4(t4), K4r);
            }
            var iK = [0, uK, function(t4) {
              return o(C0(W4r), uK, t4);
            }], VN = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, fK = function t4(n, e4) {
              return t4.fun(n, e4);
            }, Xp = function t4(n, e4) {
              return t4.fun(n, e4);
            }, xK = function t4(n) {
              return t4.fun(n);
            };
            N(VN, function(t4, n, e4) {
              u(f4(n), k4r), o(f4(n), E4r, w4r), o(Xp, n, e4[1]), u(f4(n), S4r), u(f4(n), g4r), o(f4(n), T4r, F4r);
              var i4 = e4[2];
              o(f4(n), O4r, i4), u(f4(n), I4r), u(f4(n), A4r), o(f4(n), C4r, N4r);
              var x4 = e4[3];
              if (x4) {
                g(n, P4r);
                var c = x4[1], s2 = function(y, T) {
                  return g(y, d4r);
                }, p = function(y) {
                  return u(t4, y);
                };
                R(Dr[1], p, s2, n, c), g(n, D4r);
              } else
                g(n, L4r);
              return u(f4(n), R4r), u(f4(n), j4r);
            }), N(fK, function(t4, n) {
              var e4 = u(VN, t4);
              return o(C0(h4r), e4, n);
            }), N(Xp, function(t4, n) {
              if (typeof n == "number")
                return g(t4, u4r);
              switch (n[0]) {
                case 0:
                  u(f4(t4), i4r);
                  var e4 = n[1];
                  return o(f4(t4), f4r, e4), u(f4(t4), x4r);
                case 1:
                  u(f4(t4), o4r);
                  var i4 = n[1];
                  return o(f4(t4), a4r, i4), u(f4(t4), c4r);
                case 2:
                  u(f4(t4), s4r);
                  var x4 = n[1];
                  return o(f4(t4), v4r, x4), u(f4(t4), l4r);
                case 3:
                  u(f4(t4), b4r);
                  var c = n[1];
                  return o(f4(t4), p4r, c), u(f4(t4), m4r);
                default:
                  return u(f4(t4), _4r), o(iK[1], t4, n[1]), u(f4(t4), y4r);
              }
            }), N(xK, function(t4) {
              return o(C0(t4r), Xp, t4);
            }), mu(q3r, Tl, [0, iK, VN, fK, Xp, xK]);
            var zN = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, oK = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(zN, function(t4, n, e4) {
              u(f4(n), Mbr), o(f4(n), qbr, Bbr);
              var i4 = e4[1];
              o(f4(n), Ubr, i4), u(f4(n), Hbr), u(f4(n), Xbr), o(f4(n), Vbr, Ybr);
              var x4 = e4[2];
              o(f4(n), zbr, x4), u(f4(n), Kbr), u(f4(n), Wbr), o(f4(n), $br, Jbr);
              var c = e4[3];
              if (c) {
                g(n, Zbr);
                var s2 = c[1], p = function(T, E) {
                  return g(T, Gbr);
                }, y = function(T) {
                  return u(t4, T);
                };
                R(Dr[1], y, p, n, s2), g(n, Qbr);
              } else
                g(n, r4r);
              return u(f4(n), e4r), u(f4(n), n4r);
            }), N(oK, function(t4, n) {
              var e4 = u(zN, t4);
              return o(C0(jbr), e4, n);
            }), mu(U3r, g1, [0, zN, oK]);
            var KN = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, aK = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(KN, function(t4, n, e4) {
              u(f4(n), hbr), o(f4(n), kbr, dbr);
              var i4 = e4[1];
              o(f4(n), wbr, i4), u(f4(n), Ebr), u(f4(n), Sbr), o(f4(n), Fbr, gbr);
              var x4 = e4[2];
              o(f4(n), Tbr, x4), u(f4(n), Obr), u(f4(n), Ibr), o(f4(n), Nbr, Abr);
              var c = e4[3];
              if (c) {
                g(n, Cbr);
                var s2 = c[1], p = function(T, E) {
                  return g(T, ybr);
                }, y = function(T) {
                  return u(t4, T);
                };
                R(Dr[1], y, p, n, s2), g(n, Pbr);
              } else
                g(n, Dbr);
              return u(f4(n), Lbr), u(f4(n), Rbr);
            }), N(aK, function(t4, n) {
              var e4 = u(KN, t4);
              return o(C0(_br), e4, n);
            }), mu(H3r, BN, [0, KN, aK]);
            var WN = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, cK = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(WN, function(t4, n, e4) {
              u(f4(n), Qlr), o(f4(n), ebr, rbr);
              var i4 = e4[1];
              o(f4(n), nbr, i4), u(f4(n), tbr), u(f4(n), ubr), o(f4(n), fbr, ibr);
              var x4 = e4[2];
              o(f4(n), xbr, x4), u(f4(n), obr), u(f4(n), abr), o(f4(n), sbr, cbr);
              var c = e4[3];
              if (c) {
                g(n, vbr);
                var s2 = c[1], p = function(T, E) {
                  return g(T, Zlr);
                }, y = function(T) {
                  return u(t4, T);
                };
                R(Dr[1], y, p, n, s2), g(n, lbr);
              } else
                g(n, bbr);
              return u(f4(n), pbr), u(f4(n), mbr);
            }), N(cK, function(t4, n) {
              var e4 = u(WN, t4);
              return o(C0($lr), e4, n);
            }), mu(X3r, Zz, [0, WN, cK]);
            var JN = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, sK = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(JN, function(t4, n, e4) {
              u(f4(n), Glr), o(f4(n), Blr, Mlr);
              var i4 = e4[1];
              o(f4(n), qlr, i4), u(f4(n), Ulr), u(f4(n), Hlr), o(f4(n), Ylr, Xlr);
              var x4 = e4[2];
              if (x4) {
                g(n, Vlr);
                var c = x4[1], s2 = function(y, T) {
                  return g(y, jlr);
                }, p = function(y) {
                  return u(t4, y);
                };
                R(Dr[1], p, s2, n, c), g(n, zlr);
              } else
                g(n, Klr);
              return u(f4(n), Wlr), u(f4(n), Jlr);
            }), N(sK, function(t4, n) {
              var e4 = u(JN, t4);
              return o(C0(Rlr), e4, n);
            }), mu(Y3r, qN, [0, JN, sK]);
            var $N = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, vK = function t4(n, e4) {
              return t4.fun(n, e4);
            }, Yp = function t4(n, e4) {
              return t4.fun(n, e4);
            }, lK = function t4(n) {
              return t4.fun(n);
            }, Vp = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, bK = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N($N, function(t4, n, e4) {
              u(f4(n), Plr), o(t4, n, e4[1]), u(f4(n), Dlr);
              var i4 = e4[2];
              return ur(Vp, function(x4) {
                return u(t4, x4);
              }, n, i4), u(f4(n), Llr);
            }), N(vK, function(t4, n) {
              var e4 = u($N, t4);
              return o(C0(Clr), e4, n);
            }), N(Yp, function(t4, n) {
              return n ? g(t4, Alr) : g(t4, Nlr);
            }), N(lK, function(t4) {
              return o(C0(Ilr), Yp, t4);
            }), N(Vp, function(t4, n, e4) {
              u(f4(n), _lr), o(f4(n), hlr, ylr), o(Yp, n, e4[1]), u(f4(n), dlr), u(f4(n), klr), o(f4(n), Elr, wlr);
              var i4 = e4[2];
              if (i4) {
                g(n, Slr);
                var x4 = i4[1], c = function(p, y) {
                  return g(p, mlr);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                R(Dr[1], s2, c, n, x4), g(n, glr);
              } else
                g(n, Flr);
              return u(f4(n), Tlr), u(f4(n), Olr);
            }), N(bK, function(t4, n) {
              var e4 = u(Vp, t4);
              return o(C0(plr), e4, n);
            }), mu(V3r, zv, [0, $N, vK, Yp, lK, Vp, bK]);
            var ZN = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, pK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, QN = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, mK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(ZN, function(t4, n, e4, i4) {
              u(f4(e4), vlr), o(t4, e4, i4[1]), u(f4(e4), llr);
              var x4 = i4[2];
              function c(p) {
                return u(n, p);
              }
              function s2(p) {
                return u(t4, p);
              }
              return R(qp[3], s2, c, e4, x4), u(f4(e4), blr);
            }), N(pK, function(t4, n, e4) {
              var i4 = o(ZN, t4, n);
              return o(C0(slr), i4, e4);
            }), N(QN, function(t4, n, e4, i4) {
              u(f4(e4), Q2r), o(f4(e4), elr, rlr);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), nlr), u(f4(e4), tlr), o(f4(e4), ilr, ulr);
              var p = i4[2];
              if (p) {
                g(e4, flr);
                var y = p[1], T = function(d, w) {
                  return g(d, Z2r);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, xlr);
              } else
                g(e4, olr);
              return u(f4(e4), alr), u(f4(e4), clr);
            }), N(mK, function(t4, n, e4) {
              var i4 = o(QN, t4, n);
              return o(C0($2r), i4, e4);
            }), mu(z3r, qp, [0, ZN, pK, QN, mK]);
            var rC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, _K = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, zp = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, yK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(rC, function(t4, n, e4, i4) {
              u(f4(e4), K2r), o(t4, e4, i4[1]), u(f4(e4), W2r);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(zp, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), J2r);
            }), N(_K, function(t4, n, e4) {
              var i4 = o(rC, t4, n);
              return o(C0(z2r), i4, e4);
            }), N(zp, function(t4, n, e4, i4) {
              u(f4(e4), A2r), o(f4(e4), C2r, N2r);
              var x4 = i4[1];
              if (x4) {
                g(e4, P2r);
                var c = x4[1], s2 = function(w) {
                  return u(n, w);
                }, p = function(w) {
                  return u(t4, w);
                };
                R(Rn[1], p, s2, e4, c), g(e4, D2r);
              } else
                g(e4, L2r);
              u(f4(e4), R2r), u(f4(e4), j2r), o(f4(e4), M2r, G2r);
              var y = i4[2];
              function T(w) {
                return u(n, w);
              }
              function E(w) {
                return u(t4, w);
              }
              R($e[13], E, T, e4, y), u(f4(e4), B2r), u(f4(e4), q2r), o(f4(e4), H2r, U2r);
              var d = i4[3];
              return o(f4(e4), X2r, d), u(f4(e4), Y2r), u(f4(e4), V2r);
            }), N(yK, function(t4, n, e4) {
              var i4 = o(zp, t4, n);
              return o(C0(I2r), i4, e4);
            });
            var eC = [0, rC, _K, zp, yK], nC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, hK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Kp = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, dK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(nC, function(t4, n, e4, i4) {
              u(f4(e4), F2r), o(t4, e4, i4[1]), u(f4(e4), T2r);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Kp, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), O2r);
            }), N(hK, function(t4, n, e4) {
              var i4 = o(nC, t4, n);
              return o(C0(g2r), i4, e4);
            }), N(Kp, function(t4, n, e4, i4) {
              u(f4(e4), l2r), o(f4(e4), p2r, b2r);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(eC[1], s2, c, e4, x4), u(f4(e4), m2r), u(f4(e4), _2r), o(f4(e4), h2r, y2r);
              var p = i4[2];
              if (p) {
                g(e4, d2r);
                var y = p[1], T = function(d, w) {
                  return g(d, v2r);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, k2r);
              } else
                g(e4, w2r);
              return u(f4(e4), E2r), u(f4(e4), S2r);
            }), N(dK, function(t4, n, e4) {
              var i4 = o(Kp, t4, n);
              return o(C0(s2r), i4, e4);
            });
            var kK = [0, nC, hK, Kp, dK], tC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, wK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Wp = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, EK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(tC, function(t4, n, e4, i4) {
              u(f4(e4), o2r), o(t4, e4, i4[1]), u(f4(e4), a2r);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Wp, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), c2r);
            }), N(wK, function(t4, n, e4) {
              var i4 = o(tC, t4, n);
              return o(C0(x2r), i4, e4);
            }), N(Wp, function(t4, n, e4, i4) {
              u(f4(e4), Wvr), o(f4(e4), $vr, Jvr);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R($e[17], s2, c, e4, x4), u(f4(e4), Zvr), u(f4(e4), Qvr), o(f4(e4), e2r, r2r);
              var p = i4[2];
              if (p) {
                g(e4, n2r);
                var y = p[1], T = function(d, w) {
                  return g(d, Kvr);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, t2r);
              } else
                g(e4, u2r);
              return u(f4(e4), i2r), u(f4(e4), f2r);
            }), N(EK, function(t4, n, e4) {
              var i4 = o(Wp, t4, n);
              return o(C0(zvr), i4, e4);
            });
            var SK = [0, tC, wK, Wp, EK], uC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, gK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Jp = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, FK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(uC, function(t4, n, e4, i4) {
              u(f4(e4), Xvr), o(t4, e4, i4[1]), u(f4(e4), Yvr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Jp, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Vvr);
            }), N(gK, function(t4, n, e4) {
              var i4 = o(uC, t4, n);
              return o(C0(Hvr), i4, e4);
            }), N(Jp, function(t4, n, e4, i4) {
              u(f4(e4), pvr), o(f4(e4), _vr, mvr);
              var x4 = i4[1];
              if (x4) {
                g(e4, yvr);
                var c = x4[1], s2 = function(V) {
                  return u(n, V);
                }, p = function(V) {
                  return u(t4, V);
                };
                R(SK[1], p, s2, e4, c), g(e4, hvr);
              } else
                g(e4, dvr);
              u(f4(e4), kvr), u(f4(e4), wvr), o(f4(e4), Svr, Evr);
              var y = i4[2];
              u(f4(e4), gvr);
              var T = 0;
              le(function(V, f0) {
                V && u(f4(e4), bvr);
                function m0(g0) {
                  return u(n, g0);
                }
                function k0(g0) {
                  return u(t4, g0);
                }
                return R(eC[1], k0, m0, e4, f0), 1;
              }, T, y), u(f4(e4), Fvr), u(f4(e4), Tvr), u(f4(e4), Ovr), o(f4(e4), Avr, Ivr);
              var E = i4[3];
              if (E) {
                g(e4, Nvr);
                var d = E[1], w = function(V) {
                  return u(n, V);
                }, G = function(V) {
                  return u(t4, V);
                };
                R(kK[1], G, w, e4, d), g(e4, Cvr);
              } else
                g(e4, Pvr);
              u(f4(e4), Dvr), u(f4(e4), Lvr), o(f4(e4), jvr, Rvr);
              var A11 = i4[4];
              if (A11) {
                g(e4, Gvr);
                var S11 = A11[1], M = function(V, f0) {
                  u(f4(V), vvr);
                  var m0 = 0;
                  return le(function(k0, g0) {
                    k0 && u(f4(V), svr);
                    function e0(x0) {
                      return u(t4, x0);
                    }
                    return ur(iu[1], e0, V, g0), 1;
                  }, m0, f0), u(f4(V), lvr);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, Mvr);
              } else
                g(e4, Bvr);
              return u(f4(e4), qvr), u(f4(e4), Uvr);
            }), N(FK, function(t4, n, e4) {
              var i4 = o(Jp, t4, n);
              return o(C0(cvr), i4, e4);
            });
            var TK = [0, uC, gK, Jp, FK], iC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, OK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(iC, function(t4, n, e4, i4) {
              u(f4(e4), q1r), o(f4(e4), H1r, U1r);
              var x4 = i4[1];
              if (x4) {
                g(e4, X1r);
                var c = x4[1], s2 = function(V) {
                  return u(n, V);
                }, p = function(V) {
                  return u(t4, V);
                };
                R($e[22][1], p, s2, e4, c), g(e4, Y1r);
              } else
                g(e4, V1r);
              u(f4(e4), z1r), u(f4(e4), K1r), o(f4(e4), J1r, W1r);
              var y = i4[2];
              function T(V) {
                return u(n, V);
              }
              function E(V) {
                return u(t4, V);
              }
              R(TK[1], E, T, e4, y), u(f4(e4), $1r), u(f4(e4), Z1r), o(f4(e4), rvr, Q1r);
              var d = i4[3];
              function w(V) {
                return u(n, V);
              }
              function G(V) {
                return u(t4, V);
              }
              R($e[13], G, w, e4, d), u(f4(e4), evr), u(f4(e4), nvr), o(f4(e4), uvr, tvr);
              var A11 = i4[4];
              if (A11) {
                g(e4, ivr);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, B1r);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, fvr);
              } else
                g(e4, xvr);
              return u(f4(e4), ovr), u(f4(e4), avr);
            }), N(OK, function(t4, n, e4) {
              var i4 = o(iC, t4, n);
              return o(C0(M1r), i4, e4);
            });
            var Ol = [0, eC, kK, SK, TK, iC, OK], $p = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, IK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Zp = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, AK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Qp = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, NK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N($p, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), L1r);
                var x4 = i4[1], c = function(T) {
                  return u(n, T);
                }, s2 = function(T) {
                  return u(t4, T);
                };
                return R(Rn[1], s2, c, e4, x4), u(f4(e4), R1r);
              }
              u(f4(e4), j1r);
              var p = i4[1];
              function y(T) {
                return u(n, T);
              }
              return R(Zp, function(T) {
                return u(t4, T);
              }, y, e4, p), u(f4(e4), G1r);
            }), N(IK, function(t4, n, e4) {
              var i4 = o($p, t4, n);
              return o(C0(D1r), i4, e4);
            }), N(Zp, function(t4, n, e4, i4) {
              u(f4(e4), N1r), o(t4, e4, i4[1]), u(f4(e4), C1r);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Qp, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), P1r);
            }), N(AK, function(t4, n, e4) {
              var i4 = o(Zp, t4, n);
              return o(C0(A1r), i4, e4);
            }), N(Qp, function(t4, n, e4, i4) {
              u(f4(e4), k1r), o(f4(e4), E1r, w1r);
              var x4 = i4[1];
              function c(T) {
                return u(n, T);
              }
              R($p, function(T) {
                return u(t4, T);
              }, c, e4, x4), u(f4(e4), S1r), u(f4(e4), g1r), o(f4(e4), T1r, F1r);
              var s2 = i4[2];
              function p(T) {
                return u(n, T);
              }
              function y(T) {
                return u(t4, T);
              }
              return R(Rn[1], y, p, e4, s2), u(f4(e4), O1r), u(f4(e4), I1r);
            }), N(NK, function(t4, n, e4) {
              var i4 = o(Qp, t4, n);
              return o(C0(d1r), i4, e4);
            });
            var CK = [0, $p, IK, Zp, AK, Qp, NK], fC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, PK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(fC, function(t4, n, e4, i4) {
              u(f4(e4), e1r), o(f4(e4), t1r, n1r);
              var x4 = i4[1];
              function c(S11) {
                return u(n, S11);
              }
              function s2(S11) {
                return u(t4, S11);
              }
              R(CK[1], s2, c, e4, x4), u(f4(e4), u1r), u(f4(e4), i1r), o(f4(e4), x1r, f1r);
              var p = i4[2];
              if (p) {
                g(e4, o1r);
                var y = p[1], T = function(S11) {
                  return u(n, S11);
                }, E = function(S11) {
                  return u(t4, S11);
                };
                R($e[23][1], E, T, e4, y), g(e4, a1r);
              } else
                g(e4, c1r);
              u(f4(e4), s1r), u(f4(e4), v1r), o(f4(e4), b1r, l1r);
              var d = i4[3];
              if (d) {
                g(e4, p1r);
                var w = d[1], G = function(S11, M) {
                  return g(S11, r1r);
                }, A11 = function(S11) {
                  return u(t4, S11);
                };
                R(Dr[1], A11, G, e4, w), g(e4, m1r);
              } else
                g(e4, _1r);
              return u(f4(e4), y1r), u(f4(e4), h1r);
            }), N(PK, function(t4, n, e4) {
              var i4 = o(fC, t4, n);
              return o(C0(Qsr), i4, e4);
            });
            var xC = [0, CK, fC, PK], oC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, DK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(oC, function(t4, n, e4, i4) {
              u(f4(e4), jsr), o(f4(e4), Msr, Gsr);
              var x4 = i4[1];
              function c(A11) {
                return u(n, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R($e[13], s2, c, e4, x4), u(f4(e4), Bsr), u(f4(e4), qsr), o(f4(e4), Hsr, Usr);
              var p = i4[2];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R($e[13], T, y, e4, p), u(f4(e4), Xsr), u(f4(e4), Ysr), o(f4(e4), zsr, Vsr);
              var E = i4[3];
              if (E) {
                g(e4, Ksr);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, Rsr);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, Wsr);
              } else
                g(e4, Jsr);
              return u(f4(e4), $sr), u(f4(e4), Zsr);
            }), N(DK, function(t4, n, e4) {
              var i4 = o(oC, t4, n);
              return o(C0(Lsr), i4, e4);
            });
            var aC = [0, oC, DK], cC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, LK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(cC, function(t4, n, e4, i4) {
              u(f4(e4), gsr), o(f4(e4), Tsr, Fsr);
              var x4 = i4[1];
              function c(y) {
                return u(n, y);
              }
              function s2(y) {
                return u(t4, y);
              }
              R(aC[1], s2, c, e4, x4), u(f4(e4), Osr), u(f4(e4), Isr), o(f4(e4), Nsr, Asr);
              var p = i4[2];
              return o(f4(e4), Csr, p), u(f4(e4), Psr), u(f4(e4), Dsr);
            }), N(LK, function(t4, n, e4) {
              var i4 = o(cC, t4, n);
              return o(C0(Ssr), i4, e4);
            });
            var RK = [0, cC, LK], sC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, jK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, r5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, GK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, e5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, MK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(sC, function(t4, n, e4, i4) {
              u(f4(e4), ksr), o(t4, e4, i4[1]), u(f4(e4), wsr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(r5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Esr);
            }), N(jK, function(t4, n, e4) {
              var i4 = o(sC, t4, n);
              return o(C0(dsr), i4, e4);
            }), N(r5, function(t4, n, e4, i4) {
              u(f4(e4), Ncr), o(f4(e4), Pcr, Ccr);
              var x4 = i4[1];
              function c(m0) {
                return u(n, m0);
              }
              function s2(m0) {
                return u(t4, m0);
              }
              R(qe[7][1][1], s2, c, e4, x4), u(f4(e4), Dcr), u(f4(e4), Lcr), o(f4(e4), jcr, Rcr);
              var p = i4[2];
              function y(m0) {
                return u(n, m0);
              }
              R(e5, function(m0) {
                return u(t4, m0);
              }, y, e4, p), u(f4(e4), Gcr), u(f4(e4), Mcr), o(f4(e4), qcr, Bcr);
              var T = i4[3];
              o(f4(e4), Ucr, T), u(f4(e4), Hcr), u(f4(e4), Xcr), o(f4(e4), Vcr, Ycr);
              var E = i4[4];
              o(f4(e4), zcr, E), u(f4(e4), Kcr), u(f4(e4), Wcr), o(f4(e4), $cr, Jcr);
              var d = i4[5];
              o(f4(e4), Zcr, d), u(f4(e4), Qcr), u(f4(e4), rsr), o(f4(e4), nsr, esr);
              var w = i4[6];
              o(f4(e4), tsr, w), u(f4(e4), usr), u(f4(e4), isr), o(f4(e4), xsr, fsr);
              var G = i4[7];
              if (G) {
                g(e4, osr);
                var A11 = G[1], S11 = function(m0) {
                  return u(t4, m0);
                };
                ur(zv[1], S11, e4, A11), g(e4, asr);
              } else
                g(e4, csr);
              u(f4(e4), ssr), u(f4(e4), vsr), o(f4(e4), bsr, lsr);
              var M = i4[8];
              if (M) {
                g(e4, psr);
                var K = M[1], V = function(m0, k0) {
                  return g(m0, Acr);
                }, f0 = function(m0) {
                  return u(t4, m0);
                };
                R(Dr[1], f0, V, e4, K), g(e4, msr);
              } else
                g(e4, _sr);
              return u(f4(e4), ysr), u(f4(e4), hsr);
            }), N(GK, function(t4, n, e4) {
              var i4 = o(r5, t4, n);
              return o(C0(Icr), i4, e4);
            }), N(e5, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), _cr);
                  var x4 = i4[1], c = function(S11) {
                    return u(n, S11);
                  }, s2 = function(S11) {
                    return u(t4, S11);
                  };
                  return R($e[13], s2, c, e4, x4), u(f4(e4), ycr);
                case 1:
                  var p = i4[1];
                  u(f4(e4), hcr), u(f4(e4), dcr), o(t4, e4, p[1]), u(f4(e4), kcr);
                  var y = p[2], T = function(S11) {
                    return u(n, S11);
                  }, E = function(S11) {
                    return u(t4, S11);
                  };
                  return R(Ol[5], E, T, e4, y), u(f4(e4), wcr), u(f4(e4), Ecr);
                default:
                  var d = i4[1];
                  u(f4(e4), Scr), u(f4(e4), gcr), o(t4, e4, d[1]), u(f4(e4), Fcr);
                  var w = d[2], G = function(S11) {
                    return u(n, S11);
                  }, A11 = function(S11) {
                    return u(t4, S11);
                  };
                  return R(Ol[5], A11, G, e4, w), u(f4(e4), Tcr), u(f4(e4), Ocr);
              }
            }), N(MK, function(t4, n, e4) {
              var i4 = o(e5, t4, n);
              return o(C0(mcr), i4, e4);
            });
            var BK = [0, sC, jK, r5, GK, e5, MK], vC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, qK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, n5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, UK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(vC, function(t4, n, e4, i4) {
              u(f4(e4), lcr), o(t4, e4, i4[1]), u(f4(e4), bcr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(n5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), pcr);
            }), N(qK, function(t4, n, e4) {
              var i4 = o(vC, t4, n);
              return o(C0(vcr), i4, e4);
            }), N(n5, function(t4, n, e4, i4) {
              u(f4(e4), rcr), o(f4(e4), ncr, ecr);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R($e[13], s2, c, e4, x4), u(f4(e4), tcr), u(f4(e4), ucr), o(f4(e4), fcr, icr);
              var p = i4[2];
              if (p) {
                g(e4, xcr);
                var y = p[1], T = function(d, w) {
                  return g(d, Qar);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, ocr);
              } else
                g(e4, acr);
              return u(f4(e4), ccr), u(f4(e4), scr);
            }), N(UK, function(t4, n, e4) {
              var i4 = o(n5, t4, n);
              return o(C0(Zar), i4, e4);
            });
            var HK = [0, vC, qK, n5, UK], t5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, XK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, lC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, YK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(t5, function(t4, n, e4, i4) {
              u(f4(e4), _ar), o(f4(e4), har, yar);
              var x4 = i4[1];
              if (x4) {
                g(e4, dar);
                var c = x4[1], s2 = function(g0) {
                  return u(t4, g0);
                }, p = function(g0) {
                  return u(t4, g0);
                };
                R(Rn[1], p, s2, e4, c), g(e4, kar);
              } else
                g(e4, war);
              u(f4(e4), Ear), u(f4(e4), Sar), o(f4(e4), Far, gar);
              var y = i4[2];
              function T(g0) {
                return u(n, g0);
              }
              function E(g0) {
                return u(t4, g0);
              }
              R($e[13], E, T, e4, y), u(f4(e4), Tar), u(f4(e4), Oar), o(f4(e4), Aar, Iar);
              var d = i4[3];
              function w(g0) {
                return u(n, g0);
              }
              function G(g0) {
                return u(t4, g0);
              }
              R($e[13], G, w, e4, d), u(f4(e4), Nar), u(f4(e4), Car), o(f4(e4), Dar, Par);
              var A11 = i4[4];
              o(f4(e4), Lar, A11), u(f4(e4), Rar), u(f4(e4), jar), o(f4(e4), Mar, Gar);
              var S11 = i4[5];
              if (S11) {
                g(e4, Bar);
                var M = S11[1], K = function(g0) {
                  return u(t4, g0);
                };
                ur(zv[1], K, e4, M), g(e4, qar);
              } else
                g(e4, Uar);
              u(f4(e4), Har), u(f4(e4), Xar), o(f4(e4), Var, Yar);
              var V = i4[6];
              if (V) {
                g(e4, zar);
                var f0 = V[1], m0 = function(g0, e0) {
                  return g(g0, mar);
                }, k0 = function(g0) {
                  return u(t4, g0);
                };
                R(Dr[1], k0, m0, e4, f0), g(e4, Kar);
              } else
                g(e4, War);
              return u(f4(e4), Jar), u(f4(e4), $ar);
            }), N(XK, function(t4, n, e4) {
              var i4 = o(t5, t4, n);
              return o(C0(par), i4, e4);
            }), N(lC, function(t4, n, e4, i4) {
              u(f4(e4), sar), o(t4, e4, i4[1]), u(f4(e4), lar);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(t5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), bar);
            }), N(YK, function(t4, n, e4) {
              var i4 = o(lC, t4, n);
              return o(C0(car), i4, e4);
            });
            var VK = [0, t5, XK, lC, YK], bC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, zK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, u5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, KK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(bC, function(t4, n, e4, i4) {
              u(f4(e4), xar), o(t4, e4, i4[1]), u(f4(e4), oar);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(u5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), aar);
            }), N(zK, function(t4, n, e4) {
              var i4 = o(bC, t4, n);
              return o(C0(far), i4, e4);
            }), N(u5, function(t4, n, e4, i4) {
              u(f4(e4), Bor), o(f4(e4), Uor, qor);
              var x4 = i4[1];
              u(f4(e4), Hor), o(t4, e4, x4[1]), u(f4(e4), Xor);
              var c = x4[2];
              function s2(G) {
                return u(n, G);
              }
              function p(G) {
                return u(t4, G);
              }
              R(Ol[5], p, s2, e4, c), u(f4(e4), Yor), u(f4(e4), Vor), u(f4(e4), zor), o(f4(e4), Wor, Kor);
              var y = i4[2];
              o(f4(e4), Jor, y), u(f4(e4), $or), u(f4(e4), Zor), o(f4(e4), rar, Qor);
              var T = i4[3];
              if (T) {
                g(e4, ear);
                var E = T[1], d = function(G, A11) {
                  return g(G, Mor);
                }, w = function(G) {
                  return u(t4, G);
                };
                R(Dr[1], w, d, e4, E), g(e4, nar);
              } else
                g(e4, tar);
              return u(f4(e4), uar), u(f4(e4), iar);
            }), N(KK, function(t4, n, e4) {
              var i4 = o(u5, t4, n);
              return o(C0(Gor), i4, e4);
            });
            var WK = [0, bC, zK, u5, KK], pC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, JK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, i5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, $K = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(pC, function(t4, n, e4, i4) {
              u(f4(e4), Lor), o(t4, e4, i4[1]), u(f4(e4), Ror);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(i5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), jor);
            }), N(JK, function(t4, n, e4) {
              var i4 = o(pC, t4, n);
              return o(C0(Dor), i4, e4);
            }), N(i5, function(t4, n, e4, i4) {
              u(f4(e4), nor), o(f4(e4), uor, tor);
              var x4 = i4[1];
              function c(K) {
                return u(t4, K);
              }
              function s2(K) {
                return u(t4, K);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), ior), u(f4(e4), xor), o(f4(e4), aor, oor);
              var p = i4[2];
              function y(K) {
                return u(n, K);
              }
              function T(K) {
                return u(t4, K);
              }
              R($e[13], T, y, e4, p), u(f4(e4), cor), u(f4(e4), sor), o(f4(e4), lor, vor);
              var E = i4[3];
              o(f4(e4), bor, E), u(f4(e4), por), u(f4(e4), mor), o(f4(e4), yor, _or);
              var d = i4[4];
              o(f4(e4), hor, d), u(f4(e4), dor), u(f4(e4), kor), o(f4(e4), Eor, wor);
              var w = i4[5];
              o(f4(e4), Sor, w), u(f4(e4), gor), u(f4(e4), For), o(f4(e4), Oor, Tor);
              var G = i4[6];
              if (G) {
                g(e4, Ior);
                var A11 = G[1], S11 = function(K, V) {
                  return g(K, eor);
                }, M = function(K) {
                  return u(t4, K);
                };
                R(Dr[1], M, S11, e4, A11), g(e4, Aor);
              } else
                g(e4, Nor);
              return u(f4(e4), Cor), u(f4(e4), Por);
            }), N($K, function(t4, n, e4) {
              var i4 = o(i5, t4, n);
              return o(C0(ror), i4, e4);
            });
            var ZK = [0, pC, JK, i5, $K], mC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, QK = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, f5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, rW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(mC, function(t4, n, e4, i4) {
              u(f4(e4), Axr), o(f4(e4), Cxr, Nxr);
              var x4 = i4[1];
              o(f4(e4), Pxr, x4), u(f4(e4), Dxr), u(f4(e4), Lxr), o(f4(e4), jxr, Rxr);
              var c = i4[2];
              o(f4(e4), Gxr, c), u(f4(e4), Mxr), u(f4(e4), Bxr), o(f4(e4), Uxr, qxr);
              var s2 = i4[3];
              u(f4(e4), Hxr);
              var p = 0;
              le(function(w, G) {
                w && u(f4(e4), Ixr);
                function A11(S11) {
                  return u(n, S11);
                }
                return R(f5, function(S11) {
                  return u(t4, S11);
                }, A11, e4, G), 1;
              }, p, s2), u(f4(e4), Xxr), u(f4(e4), Yxr), u(f4(e4), Vxr), o(f4(e4), Kxr, zxr);
              var y = i4[4];
              if (y) {
                g(e4, Wxr);
                var T = y[1], E = function(w, G) {
                  u(f4(w), Txr);
                  var A11 = 0;
                  return le(function(S11, M) {
                    S11 && u(f4(w), Fxr);
                    function K(V) {
                      return u(t4, V);
                    }
                    return ur(iu[1], K, w, M), 1;
                  }, A11, G), u(f4(w), Oxr);
                }, d = function(w) {
                  return u(t4, w);
                };
                R(Dr[1], d, E, e4, T), g(e4, Jxr);
              } else
                g(e4, $xr);
              return u(f4(e4), Zxr), u(f4(e4), Qxr);
            }), N(QK, function(t4, n, e4) {
              var i4 = o(mC, t4, n);
              return o(C0(gxr), i4, e4);
            }), N(f5, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), pxr);
                  var x4 = i4[1], c = function(f0) {
                    return u(n, f0);
                  }, s2 = function(f0) {
                    return u(t4, f0);
                  };
                  return R(BK[1], s2, c, e4, x4), u(f4(e4), mxr);
                case 1:
                  u(f4(e4), _xr);
                  var p = i4[1], y = function(f0) {
                    return u(n, f0);
                  }, T = function(f0) {
                    return u(t4, f0);
                  };
                  return R(HK[1], T, y, e4, p), u(f4(e4), yxr);
                case 2:
                  u(f4(e4), hxr);
                  var E = i4[1], d = function(f0) {
                    return u(n, f0);
                  }, w = function(f0) {
                    return u(t4, f0);
                  };
                  return R(VK[3], w, d, e4, E), u(f4(e4), dxr);
                case 3:
                  u(f4(e4), kxr);
                  var G = i4[1], A11 = function(f0) {
                    return u(n, f0);
                  }, S11 = function(f0) {
                    return u(t4, f0);
                  };
                  return R(WK[1], S11, A11, e4, G), u(f4(e4), wxr);
                default:
                  u(f4(e4), Exr);
                  var M = i4[1], K = function(f0) {
                    return u(n, f0);
                  }, V = function(f0) {
                    return u(t4, f0);
                  };
                  return R(ZK[1], V, K, e4, M), u(f4(e4), Sxr);
              }
            }), N(rW, function(t4, n, e4) {
              var i4 = o(f5, t4, n);
              return o(C0(bxr), i4, e4);
            });
            var _C = [0, BK, HK, VK, WK, ZK, mC, QK, f5, rW], yC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, eW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(yC, function(t4, n, e4, i4) {
              u(f4(e4), zfr), o(f4(e4), Wfr, Kfr);
              var x4 = i4[1];
              u(f4(e4), Jfr), o(t4, e4, x4[1]), u(f4(e4), $fr);
              var c = x4[2];
              function s2(A11) {
                return u(n, A11);
              }
              function p(A11) {
                return u(t4, A11);
              }
              R(_C[6], p, s2, e4, c), u(f4(e4), Zfr), u(f4(e4), Qfr), u(f4(e4), rxr), o(f4(e4), nxr, exr);
              var y = i4[2];
              u(f4(e4), txr);
              var T = 0;
              le(function(A11, S11) {
                A11 && u(f4(e4), Hfr), u(f4(e4), Xfr), o(t4, e4, S11[1]), u(f4(e4), Yfr);
                var M = S11[2];
                function K(f0) {
                  return u(n, f0);
                }
                function V(f0) {
                  return u(t4, f0);
                }
                return R(xC[2], V, K, e4, M), u(f4(e4), Vfr), 1;
              }, T, y), u(f4(e4), uxr), u(f4(e4), ixr), u(f4(e4), fxr), o(f4(e4), oxr, xxr);
              var E = i4[3];
              if (E) {
                g(e4, axr);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, Ufr);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, cxr);
              } else
                g(e4, sxr);
              return u(f4(e4), vxr), u(f4(e4), lxr);
            }), N(eW, function(t4, n, e4) {
              var i4 = o(yC, t4, n);
              return o(C0(qfr), i4, e4);
            });
            var nW = [0, yC, eW], hC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, tW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(hC, function(t4, n, e4, i4) {
              u(f4(e4), Ifr), o(f4(e4), Nfr, Afr);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R($e[13], s2, c, e4, x4), u(f4(e4), Cfr), u(f4(e4), Pfr), o(f4(e4), Lfr, Dfr);
              var p = i4[2];
              if (p) {
                g(e4, Rfr);
                var y = p[1], T = function(d, w) {
                  return g(d, Ofr);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, jfr);
              } else
                g(e4, Gfr);
              return u(f4(e4), Mfr), u(f4(e4), Bfr);
            }), N(tW, function(t4, n, e4) {
              var i4 = o(hC, t4, n);
              return o(C0(Tfr), i4, e4);
            });
            var uW = [0, hC, tW], x5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, iW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, o5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, fW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, a5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, xW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(x5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), Efr);
                var x4 = i4[1], c = function(T) {
                  return u(n, T);
                }, s2 = function(T) {
                  return u(t4, T);
                };
                return R(Rn[1], s2, c, e4, x4), u(f4(e4), Sfr);
              }
              u(f4(e4), gfr);
              var p = i4[1];
              function y(T) {
                return u(n, T);
              }
              return R(a5, function(T) {
                return u(t4, T);
              }, y, e4, p), u(f4(e4), Ffr);
            }), N(iW, function(t4, n, e4) {
              var i4 = o(x5, t4, n);
              return o(C0(wfr), i4, e4);
            }), N(o5, function(t4, n, e4, i4) {
              u(f4(e4), lfr), o(f4(e4), pfr, bfr);
              var x4 = i4[1];
              function c(T) {
                return u(n, T);
              }
              R(x5, function(T) {
                return u(t4, T);
              }, c, e4, x4), u(f4(e4), mfr), u(f4(e4), _fr), o(f4(e4), hfr, yfr);
              var s2 = i4[2];
              function p(T) {
                return u(n, T);
              }
              function y(T) {
                return u(t4, T);
              }
              return R(Rn[1], y, p, e4, s2), u(f4(e4), dfr), u(f4(e4), kfr);
            }), N(fW, function(t4, n, e4) {
              var i4 = o(o5, t4, n);
              return o(C0(vfr), i4, e4);
            }), N(a5, function(t4, n, e4, i4) {
              u(f4(e4), afr), o(n, e4, i4[1]), u(f4(e4), cfr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(o5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), sfr);
            }), N(xW, function(t4, n, e4) {
              var i4 = o(a5, t4, n);
              return o(C0(ofr), i4, e4);
            });
            var oW = [0, x5, iW, o5, fW, a5, xW], dC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, aW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(dC, function(t4, n, e4, i4) {
              u(f4(e4), Jir), o(f4(e4), Zir, $ir);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(oW[1], s2, c, e4, x4), u(f4(e4), Qir), u(f4(e4), rfr), o(f4(e4), nfr, efr);
              var p = i4[2];
              if (p) {
                g(e4, tfr);
                var y = p[1], T = function(d, w) {
                  return g(d, Wir);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, ufr);
              } else
                g(e4, ifr);
              return u(f4(e4), ffr), u(f4(e4), xfr);
            }), N(aW, function(t4, n, e4) {
              var i4 = o(dC, t4, n);
              return o(C0(Kir), i4, e4);
            });
            var cW = [0, oW, dC, aW], kC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, sW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(kC, function(t4, n, e4, i4) {
              u(f4(e4), Dir), o(f4(e4), Rir, Lir);
              var x4 = i4[1];
              u(f4(e4), jir);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), Pir);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R($e[13], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), Gir), u(f4(e4), Mir), u(f4(e4), Bir), o(f4(e4), Uir, qir);
              var s2 = i4[2];
              if (s2) {
                g(e4, Hir);
                var p = s2[1], y = function(E, d) {
                  return g(E, Cir);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, Xir);
              } else
                g(e4, Yir);
              return u(f4(e4), Vir), u(f4(e4), zir);
            }), N(sW, function(t4, n, e4) {
              var i4 = o(kC, t4, n);
              return o(C0(Nir), i4, e4);
            });
            var vW = [0, kC, sW], wC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, lW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(wC, function(t4, n, e4, i4) {
              u(f4(e4), hir), o(f4(e4), kir, dir);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R($e[13], s2, c, e4, x4), u(f4(e4), wir), u(f4(e4), Eir), o(f4(e4), gir, Sir);
              var p = i4[2];
              if (p) {
                g(e4, Fir);
                var y = p[1], T = function(d, w) {
                  return g(d, yir);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, Tir);
              } else
                g(e4, Oir);
              return u(f4(e4), Iir), u(f4(e4), Air);
            }), N(lW, function(t4, n, e4) {
              var i4 = o(wC, t4, n);
              return o(C0(_ir), i4, e4);
            });
            var bW = [0, wC, lW], EC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, pW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(EC, function(t4, n, e4, i4) {
              u(f4(e4), Q7r), o(f4(e4), eir, rir);
              var x4 = i4[1];
              u(f4(e4), nir);
              var c = x4[1];
              function s2(K) {
                return u(n, K);
              }
              function p(K) {
                return u(t4, K);
              }
              R($e[13], p, s2, e4, c), u(f4(e4), tir);
              var y = x4[2];
              function T(K) {
                return u(n, K);
              }
              function E(K) {
                return u(t4, K);
              }
              R($e[13], E, T, e4, y), u(f4(e4), uir), u(f4(e4), iir);
              var d = x4[3], w = 0;
              le(function(K, V) {
                K && u(f4(e4), Z7r);
                function f0(k0) {
                  return u(n, k0);
                }
                function m0(k0) {
                  return u(t4, k0);
                }
                return R($e[13], m0, f0, e4, V), 1;
              }, w, d), u(f4(e4), fir), u(f4(e4), xir), u(f4(e4), oir), u(f4(e4), air), o(f4(e4), sir, cir);
              var G = i4[2];
              if (G) {
                g(e4, vir);
                var A11 = G[1], S11 = function(K, V) {
                  return g(K, $7r);
                }, M = function(K) {
                  return u(t4, K);
                };
                R(Dr[1], M, S11, e4, A11), g(e4, lir);
              } else
                g(e4, bir);
              return u(f4(e4), pir), u(f4(e4), mir);
            }), N(pW, function(t4, n, e4) {
              var i4 = o(EC, t4, n);
              return o(C0(J7r), i4, e4);
            });
            var mW = [0, EC, pW], SC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, _W = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(SC, function(t4, n, e4, i4) {
              u(f4(e4), C7r), o(f4(e4), D7r, P7r);
              var x4 = i4[1];
              u(f4(e4), L7r);
              var c = x4[1];
              function s2(K) {
                return u(n, K);
              }
              function p(K) {
                return u(t4, K);
              }
              R($e[13], p, s2, e4, c), u(f4(e4), R7r);
              var y = x4[2];
              function T(K) {
                return u(n, K);
              }
              function E(K) {
                return u(t4, K);
              }
              R($e[13], E, T, e4, y), u(f4(e4), j7r), u(f4(e4), G7r);
              var d = x4[3], w = 0;
              le(function(K, V) {
                K && u(f4(e4), N7r);
                function f0(k0) {
                  return u(n, k0);
                }
                function m0(k0) {
                  return u(t4, k0);
                }
                return R($e[13], m0, f0, e4, V), 1;
              }, w, d), u(f4(e4), M7r), u(f4(e4), B7r), u(f4(e4), q7r), u(f4(e4), U7r), o(f4(e4), X7r, H7r);
              var G = i4[2];
              if (G) {
                g(e4, Y7r);
                var A11 = G[1], S11 = function(K, V) {
                  return g(K, A7r);
                }, M = function(K) {
                  return u(t4, K);
                };
                R(Dr[1], M, S11, e4, A11), g(e4, V7r);
              } else
                g(e4, z7r);
              return u(f4(e4), K7r), u(f4(e4), W7r);
            }), N(_W, function(t4, n, e4) {
              var i4 = o(SC, t4, n);
              return o(C0(I7r), i4, e4);
            });
            var yW = [0, SC, _W], c5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, hW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, s5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, dW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, gC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, kW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, FC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, wW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(c5, function(t4, n, e4, i4) {
              u(f4(e4), F7r), o(n, e4, i4[1]), u(f4(e4), T7r);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(s5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), O7r);
            }), N(hW, function(t4, n, e4) {
              var i4 = o(c5, t4, n);
              return o(C0(g7r), i4, e4);
            }), N(s5, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  var x4 = i4[1];
                  if (u(f4(e4), Vtr), x4) {
                    g(e4, ztr);
                    var c = x4[1], s2 = function(U, Y) {
                      return g(U, Ytr);
                    }, p = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], p, s2, e4, c), g(e4, Ktr);
                  } else
                    g(e4, Wtr);
                  return u(f4(e4), Jtr);
                case 1:
                  var y = i4[1];
                  if (u(f4(e4), $tr), y) {
                    g(e4, Ztr);
                    var T = y[1], E = function(U, Y) {
                      return g(U, Xtr);
                    }, d = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], d, E, e4, T), g(e4, Qtr);
                  } else
                    g(e4, rur);
                  return u(f4(e4), eur);
                case 2:
                  var w = i4[1];
                  if (u(f4(e4), nur), w) {
                    g(e4, tur);
                    var G = w[1], A11 = function(U, Y) {
                      return g(U, Htr);
                    }, S11 = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], S11, A11, e4, G), g(e4, uur);
                  } else
                    g(e4, iur);
                  return u(f4(e4), fur);
                case 3:
                  var M = i4[1];
                  if (u(f4(e4), xur), M) {
                    g(e4, our);
                    var K = M[1], V = function(U, Y) {
                      return g(U, Utr);
                    }, f0 = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], f0, V, e4, K), g(e4, aur);
                  } else
                    g(e4, cur);
                  return u(f4(e4), sur);
                case 4:
                  var m0 = i4[1];
                  if (u(f4(e4), vur), m0) {
                    g(e4, lur);
                    var k0 = m0[1], g0 = function(U, Y) {
                      return g(U, qtr);
                    }, e0 = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], e0, g0, e4, k0), g(e4, bur);
                  } else
                    g(e4, pur);
                  return u(f4(e4), mur);
                case 5:
                  var x0 = i4[1];
                  if (u(f4(e4), _ur), x0) {
                    g(e4, yur);
                    var l = x0[1], c0 = function(U, Y) {
                      return g(U, Btr);
                    }, t0 = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], t0, c0, e4, l), g(e4, hur);
                  } else
                    g(e4, dur);
                  return u(f4(e4), kur);
                case 6:
                  var o0 = i4[1];
                  if (u(f4(e4), wur), o0) {
                    g(e4, Eur);
                    var w0 = o0[1], _0 = function(U, Y) {
                      return g(U, Mtr);
                    }, E0 = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], E0, _0, e4, w0), g(e4, Sur);
                  } else
                    g(e4, gur);
                  return u(f4(e4), Fur);
                case 7:
                  var U0 = i4[1];
                  if (u(f4(e4), Tur), U0) {
                    g(e4, Our);
                    var b = U0[1], R0 = function(U, Y) {
                      return g(U, Gtr);
                    }, X = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], X, R0, e4, b), g(e4, Iur);
                  } else
                    g(e4, Aur);
                  return u(f4(e4), Nur);
                case 8:
                  var s0 = i4[1];
                  if (u(f4(e4), Cur), s0) {
                    g(e4, Pur);
                    var hr = s0[1], Ar = function(U, Y) {
                      return g(U, jtr);
                    }, or = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], or, Ar, e4, hr), g(e4, Dur);
                  } else
                    g(e4, Lur);
                  return u(f4(e4), Rur);
                case 9:
                  var W0 = i4[1];
                  if (u(f4(e4), jur), W0) {
                    g(e4, Gur);
                    var Lr = W0[1], Tr = function(U, Y) {
                      return g(U, Rtr);
                    }, Hr = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], Hr, Tr, e4, Lr), g(e4, Mur);
                  } else
                    g(e4, Bur);
                  return u(f4(e4), qur);
                case 10:
                  var Or = i4[1];
                  if (u(f4(e4), Uur), Or) {
                    g(e4, Hur);
                    var fr = Or[1], Rr = function(U, Y) {
                      return g(U, Ltr);
                    }, Wr = function(U) {
                      return u(t4, U);
                    };
                    R(Dr[1], Wr, Rr, e4, fr), g(e4, Xur);
                  } else
                    g(e4, Yur);
                  return u(f4(e4), Vur);
                case 11:
                  u(f4(e4), zur);
                  var Jr = i4[1], ar = function(U) {
                    return u(n, U);
                  }, _r = function(U) {
                    return u(t4, U);
                  };
                  return R(uW[1], _r, ar, e4, Jr), u(f4(e4), Kur);
                case 12:
                  u(f4(e4), Wur);
                  var Ir = i4[1], fe = function(U) {
                    return u(n, U);
                  }, v0 = function(U) {
                    return u(t4, U);
                  };
                  return R(Ol[5], v0, fe, e4, Ir), u(f4(e4), Jur);
                case 13:
                  u(f4(e4), $ur);
                  var P = i4[1], L = function(U) {
                    return u(n, U);
                  }, Q = function(U) {
                    return u(t4, U);
                  };
                  return R(_C[6], Q, L, e4, P), u(f4(e4), Zur);
                case 14:
                  u(f4(e4), Qur);
                  var i0 = i4[1], l0 = function(U) {
                    return u(n, U);
                  }, S0 = function(U) {
                    return u(t4, U);
                  };
                  return R(nW[1], S0, l0, e4, i0), u(f4(e4), r7r);
                case 15:
                  u(f4(e4), e7r);
                  var T0 = i4[1], rr = function(U) {
                    return u(n, U);
                  }, L0 = function(U) {
                    return u(t4, U);
                  };
                  return R(bW[1], L0, rr, e4, T0), u(f4(e4), n7r);
                case 16:
                  u(f4(e4), t7r);
                  var B = i4[1], Z7 = function(U) {
                    return u(n, U);
                  }, p0 = function(U) {
                    return u(t4, U);
                  };
                  return R(xC[2], p0, Z7, e4, B), u(f4(e4), u7r);
                case 17:
                  u(f4(e4), i7r);
                  var b0 = i4[1], O0 = function(U) {
                    return u(n, U);
                  }, M0 = function(U) {
                    return u(t4, U);
                  };
                  return R(aC[1], M0, O0, e4, b0), u(f4(e4), f7r);
                case 18:
                  u(f4(e4), x7r);
                  var er = i4[1], yr = function(U) {
                    return u(n, U);
                  }, vr = function(U) {
                    return u(t4, U);
                  };
                  return R(RK[1], vr, yr, e4, er), u(f4(e4), o7r);
                case 19:
                  u(f4(e4), a7r);
                  var $0 = i4[1], Er = function(U) {
                    return u(n, U);
                  }, Mr = function(U) {
                    return u(t4, U);
                  };
                  return R(mW[1], Mr, Er, e4, $0), u(f4(e4), c7r);
                case 20:
                  u(f4(e4), s7r);
                  var Br = i4[1], qr = function(U) {
                    return u(n, U);
                  }, jr = function(U) {
                    return u(t4, U);
                  };
                  return R(yW[1], jr, qr, e4, Br), u(f4(e4), v7r);
                case 21:
                  u(f4(e4), l7r);
                  var $r = i4[1], ne = function(U) {
                    return u(n, U);
                  }, Qr = function(U) {
                    return u(t4, U);
                  };
                  return R(cW[2], Qr, ne, e4, $r), u(f4(e4), b7r);
                case 22:
                  u(f4(e4), p7r);
                  var be = i4[1], ae = function(U) {
                    return u(n, U);
                  }, pe = function(U) {
                    return u(t4, U);
                  };
                  return R(vW[1], pe, ae, e4, be), u(f4(e4), m7r);
                case 23:
                  u(f4(e4), _7r);
                  var oe = i4[1], ce = function(U) {
                    return u(t4, U);
                  };
                  return ur(g1[1], ce, e4, oe), u(f4(e4), y7r);
                case 24:
                  u(f4(e4), h7r);
                  var ge = i4[1], q0 = function(U) {
                    return u(t4, U);
                  };
                  return ur(BN[1], q0, e4, ge), u(f4(e4), d7r);
                case 25:
                  u(f4(e4), k7r);
                  var Fr = i4[1], _ = function(U) {
                    return u(t4, U);
                  };
                  return ur(Zz[1], _, e4, Fr), u(f4(e4), w7r);
                default:
                  u(f4(e4), E7r);
                  var k = i4[1], I = function(U) {
                    return u(t4, U);
                  };
                  return ur(qN[1], I, e4, k), u(f4(e4), S7r);
              }
            }), N(dW, function(t4, n, e4) {
              var i4 = o(s5, t4, n);
              return o(C0(Dtr), i4, e4);
            }), N(gC, function(t4, n, e4, i4) {
              u(f4(e4), Ntr), o(t4, e4, i4[1]), u(f4(e4), Ctr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(c5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Ptr);
            }), N(kW, function(t4, n, e4) {
              var i4 = o(gC, t4, n);
              return o(C0(Atr), i4, e4);
            }), N(FC, function(t4, n, e4, i4) {
              if (i4[0] === 0)
                return u(f4(e4), Ftr), o(n, e4, i4[1]), u(f4(e4), Ttr);
              u(f4(e4), Otr);
              var x4 = i4[1];
              function c(p) {
                return u(n, p);
              }
              function s2(p) {
                return u(t4, p);
              }
              return R($e[17], s2, c, e4, x4), u(f4(e4), Itr);
            }), N(wW, function(t4, n, e4) {
              var i4 = o(FC, t4, n);
              return o(C0(gtr), i4, e4);
            });
            var TC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, EW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, v5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, SW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(TC, function(t4, n, e4, i4) {
              u(f4(e4), wtr), o(t4, e4, i4[1]), u(f4(e4), Etr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(v5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Str);
            }), N(EW, function(t4, n, e4) {
              var i4 = o(TC, t4, n);
              return o(C0(ktr), i4, e4);
            }), N(v5, function(t4, n, e4, i4) {
              u(f4(e4), Znr), o(f4(e4), rtr, Qnr);
              var x4 = i4[1];
              function c(K) {
                return u(t4, K);
              }
              function s2(K) {
                return u(t4, K);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), etr), u(f4(e4), ntr), o(f4(e4), utr, ttr);
              var p = i4[2];
              function y(K) {
                return u(n, K);
              }
              function T(K) {
                return u(t4, K);
              }
              R($e[19], T, y, e4, p), u(f4(e4), itr), u(f4(e4), ftr), o(f4(e4), otr, xtr);
              var E = i4[3];
              if (E) {
                g(e4, atr);
                var d = E[1], w = function(K) {
                  return u(t4, K);
                };
                ur(zv[1], w, e4, d), g(e4, ctr);
              } else
                g(e4, str);
              u(f4(e4), vtr), u(f4(e4), ltr), o(f4(e4), ptr, btr);
              var G = i4[4];
              if (G) {
                g(e4, mtr);
                var A11 = G[1], S11 = function(K) {
                  return u(n, K);
                }, M = function(K) {
                  return u(t4, K);
                };
                R($e[13], M, S11, e4, A11), g(e4, _tr);
              } else
                g(e4, ytr);
              return u(f4(e4), htr), u(f4(e4), dtr);
            }), N(SW, function(t4, n, e4) {
              var i4 = o(v5, t4, n);
              return o(C0($nr), i4, e4);
            });
            var gW = [0, TC, EW, v5, SW], OC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, FW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, l5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, TW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(OC, function(t4, n, e4, i4) {
              u(f4(e4), Knr), o(t4, e4, i4[1]), u(f4(e4), Wnr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(l5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Jnr);
            }), N(FW, function(t4, n, e4) {
              var i4 = o(OC, t4, n);
              return o(C0(znr), i4, e4);
            }), N(l5, function(t4, n, e4, i4) {
              u(f4(e4), Pnr), o(f4(e4), Lnr, Dnr);
              var x4 = i4[1];
              u(f4(e4), Rnr);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), Cnr);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R(gW[1], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), jnr), u(f4(e4), Gnr), u(f4(e4), Mnr), o(f4(e4), qnr, Bnr);
              var s2 = i4[2];
              if (s2) {
                g(e4, Unr);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), Anr);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), Inr);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), Nnr);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, Hnr);
              } else
                g(e4, Xnr);
              return u(f4(e4), Ynr), u(f4(e4), Vnr);
            }), N(TW, function(t4, n, e4) {
              var i4 = o(l5, t4, n);
              return o(C0(Onr), i4, e4);
            });
            var IC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, OW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, b5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, IW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, wee = [0, OC, FW, l5, TW];
            N(IC, function(t4, n, e4, i4) {
              u(f4(e4), gnr), o(t4, e4, i4[1]), u(f4(e4), Fnr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(b5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Tnr);
            }), N(OW, function(t4, n, e4) {
              var i4 = o(IC, t4, n);
              return o(C0(Snr), i4, e4);
            }), N(b5, function(t4, n, e4, i4) {
              u(f4(e4), cnr), o(f4(e4), vnr, snr);
              var x4 = i4[1];
              u(f4(e4), lnr);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), anr);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R($e[13], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), bnr), u(f4(e4), pnr), u(f4(e4), mnr), o(f4(e4), ynr, _nr);
              var s2 = i4[2];
              if (s2) {
                g(e4, hnr);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), xnr);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), fnr);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), onr);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, dnr);
              } else
                g(e4, knr);
              return u(f4(e4), wnr), u(f4(e4), Enr);
            }), N(IW, function(t4, n, e4) {
              var i4 = o(b5, t4, n);
              return o(C0(inr), i4, e4);
            });
            var AC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, AW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, p5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, NW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, m5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, CW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Eee = [0, IC, OW, b5, IW];
            N(AC, function(t4, n, e4, i4) {
              u(f4(e4), nnr), o(t4, e4, i4[1]), u(f4(e4), tnr);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(p5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), unr);
            }), N(AW, function(t4, n, e4) {
              var i4 = o(AC, t4, n);
              return o(C0(enr), i4, e4);
            }), N(p5, function(t4, n, e4, i4) {
              u(f4(e4), Her), o(f4(e4), Yer, Xer);
              var x4 = i4[1];
              function c(E) {
                return u(n, E);
              }
              R(m5, function(E) {
                return u(t4, E);
              }, c, e4, x4), u(f4(e4), Ver), u(f4(e4), zer), o(f4(e4), Wer, Ker);
              var s2 = i4[2];
              if (s2) {
                g(e4, Jer);
                var p = s2[1], y = function(E, d) {
                  return g(E, Uer);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, $er);
              } else
                g(e4, Zer);
              return u(f4(e4), Qer), u(f4(e4), rnr);
            }), N(NW, function(t4, n, e4) {
              var i4 = o(p5, t4, n);
              return o(C0(qer), i4, e4);
            }), N(m5, function(t4, n, e4, i4) {
              if (i4) {
                u(f4(e4), Ger);
                var x4 = i4[1], c = function(p) {
                  return u(n, p);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                return R(qe[31], s2, c, e4, x4), u(f4(e4), Mer);
              }
              return g(e4, Ber);
            }), N(CW, function(t4, n, e4) {
              var i4 = o(m5, t4, n);
              return o(C0(jer), i4, e4);
            }), mu(K3r, $e, [0, Ol, xC, aC, RK, _C, nW, uW, cW, vW, bW, mW, yW, c5, hW, s5, dW, gC, kW, FC, wW, gW, wee, Eee, [0, AC, AW, p5, NW, m5, CW]]);
            var NC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, PW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(NC, function(t4, n, e4, i4) {
              u(f4(e4), Eer), o(f4(e4), ger, Ser);
              var x4 = i4[1];
              u(f4(e4), Fer);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), wer);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R(Yu[35], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), Ter), u(f4(e4), Oer), u(f4(e4), Ier), o(f4(e4), Ner, Aer);
              var s2 = i4[2];
              if (s2) {
                g(e4, Cer);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), der);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), her);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), ker);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, Per);
              } else
                g(e4, Der);
              return u(f4(e4), Ler), u(f4(e4), Rer);
            }), N(PW, function(t4, n, e4) {
              var i4 = o(NC, t4, n);
              return o(C0(yer), i4, e4);
            });
            var Kv = [0, NC, PW], CC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, DW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, _5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, LW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(CC, function(t4, n, e4, i4) {
              u(f4(e4), per), o(t4, e4, i4[1]), u(f4(e4), mer);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(_5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), _er);
            }), N(DW, function(t4, n, e4) {
              var i4 = o(CC, t4, n);
              return o(C0(ber), i4, e4);
            }), N(_5, function(t4, n, e4, i4) {
              u(f4(e4), ner), o(f4(e4), uer, ter);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(Yu[35], s2, c, e4, x4), u(f4(e4), ier), u(f4(e4), fer), o(f4(e4), oer, xer);
              var p = i4[2];
              if (p) {
                g(e4, aer);
                var y = p[1], T = function(d, w) {
                  return g(d, eer);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, cer);
              } else
                g(e4, ser);
              return u(f4(e4), ver), u(f4(e4), ler);
            }), N(LW, function(t4, n, e4) {
              var i4 = o(_5, t4, n);
              return o(C0(rer), i4, e4);
            });
            var RW = [0, CC, DW, _5, LW], PC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, jW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(PC, function(t4, n, e4, i4) {
              u(f4(e4), Nrr), o(f4(e4), Prr, Crr);
              var x4 = i4[1];
              function c(V) {
                return u(n, V);
              }
              function s2(V) {
                return u(t4, V);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), Drr), u(f4(e4), Lrr), o(f4(e4), jrr, Rrr);
              var p = i4[2];
              function y(V) {
                return u(n, V);
              }
              function T(V) {
                return u(t4, V);
              }
              R(Yu[35], T, y, e4, p), u(f4(e4), Grr), u(f4(e4), Mrr), o(f4(e4), qrr, Brr);
              var E = i4[3];
              if (E) {
                g(e4, Urr);
                var d = E[1], w = function(V) {
                  return u(n, V);
                }, G = function(V) {
                  return u(t4, V);
                };
                R(RW[1], G, w, e4, d), g(e4, Hrr);
              } else
                g(e4, Xrr);
              u(f4(e4), Yrr), u(f4(e4), Vrr), o(f4(e4), Krr, zrr);
              var A11 = i4[4];
              if (A11) {
                g(e4, Wrr);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, Arr);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, Jrr);
              } else
                g(e4, $rr);
              return u(f4(e4), Zrr), u(f4(e4), Qrr);
            }), N(jW, function(t4, n, e4) {
              var i4 = o(PC, t4, n);
              return o(C0(Irr), i4, e4);
            });
            var GW = [0, RW, PC, jW], DC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, MW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(DC, function(t4, n, e4, i4) {
              u(f4(e4), lrr), o(f4(e4), prr, brr);
              var x4 = i4[1];
              function c(A11) {
                return u(t4, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), mrr), u(f4(e4), _rr), o(f4(e4), hrr, yrr);
              var p = i4[2];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R(Yu[35], T, y, e4, p), u(f4(e4), drr), u(f4(e4), krr), o(f4(e4), Err, wrr);
              var E = i4[3];
              if (E) {
                g(e4, Srr);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, vrr);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, grr);
              } else
                g(e4, Frr);
              return u(f4(e4), Trr), u(f4(e4), Orr);
            }), N(MW, function(t4, n, e4) {
              var i4 = o(DC, t4, n);
              return o(C0(srr), i4, e4);
            });
            var BW = [0, DC, MW], LC = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, qW = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(LC, function(t4, n, e4) {
              u(f4(n), J0r), o(f4(n), Z0r, $0r);
              var i4 = e4[1];
              if (i4) {
                g(n, Q0r);
                var x4 = i4[1], c = function(d) {
                  return u(t4, d);
                }, s2 = function(d) {
                  return u(t4, d);
                };
                R(Rn[1], s2, c, n, x4), g(n, rrr);
              } else
                g(n, err);
              u(f4(n), nrr), u(f4(n), trr), o(f4(n), irr, urr);
              var p = e4[2];
              if (p) {
                g(n, frr);
                var y = p[1], T = function(d, w) {
                  return g(d, W0r);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, n, y), g(n, xrr);
              } else
                g(n, orr);
              return u(f4(n), arr), u(f4(n), crr);
            }), N(qW, function(t4, n) {
              var e4 = u(LC, t4);
              return o(C0(K0r), e4, n);
            });
            var UW = [0, LC, qW], RC = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, HW = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(RC, function(t4, n, e4) {
              u(f4(n), P0r), o(f4(n), L0r, D0r);
              var i4 = e4[1];
              if (i4) {
                g(n, R0r);
                var x4 = i4[1], c = function(d) {
                  return u(t4, d);
                }, s2 = function(d) {
                  return u(t4, d);
                };
                R(Rn[1], s2, c, n, x4), g(n, j0r);
              } else
                g(n, G0r);
              u(f4(n), M0r), u(f4(n), B0r), o(f4(n), U0r, q0r);
              var p = e4[2];
              if (p) {
                g(n, H0r);
                var y = p[1], T = function(d, w) {
                  return g(d, C0r);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, n, y), g(n, X0r);
              } else
                g(n, Y0r);
              return u(f4(n), V0r), u(f4(n), z0r);
            }), N(HW, function(t4, n) {
              var e4 = u(RC, t4);
              return o(C0(N0r), e4, n);
            });
            var XW = [0, RC, HW], jC = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, YW = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(jC, function(t4, n, e4) {
              u(f4(n), E0r), o(f4(n), g0r, S0r);
              var i4 = e4[1];
              if (i4) {
                g(n, F0r);
                var x4 = i4[1], c = function(p, y) {
                  return g(p, w0r);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                R(Dr[1], s2, c, n, x4), g(n, T0r);
              } else
                g(n, O0r);
              return u(f4(n), I0r), u(f4(n), A0r);
            }), N(YW, function(t4, n) {
              var e4 = u(jC, t4);
              return o(C0(k0r), e4, n);
            });
            var VW = [0, jC, YW], GC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, zW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(GC, function(t4, n, e4, i4) {
              u(f4(e4), i0r), o(f4(e4), x0r, f0r);
              var x4 = i4[1];
              function c(A11) {
                return u(n, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), o0r), u(f4(e4), a0r), o(f4(e4), s0r, c0r);
              var p = i4[2];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R(Yu[35], T, y, e4, p), u(f4(e4), v0r), u(f4(e4), l0r), o(f4(e4), p0r, b0r);
              var E = i4[3];
              if (E) {
                g(e4, m0r);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, u0r);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, _0r);
              } else
                g(e4, y0r);
              return u(f4(e4), h0r), u(f4(e4), d0r);
            }), N(zW, function(t4, n, e4) {
              var i4 = o(GC, t4, n);
              return o(C0(t0r), i4, e4);
            });
            var KW = [0, GC, zW], MC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, WW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(MC, function(t4, n, e4, i4) {
              u(f4(e4), DQ0), o(f4(e4), RQ0, LQ0);
              var x4 = i4[1];
              function c(V) {
                return u(n, V);
              }
              function s2(V) {
                return u(t4, V);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), jQ0), u(f4(e4), GQ0), o(f4(e4), BQ0, MQ0);
              var p = i4[2];
              if (p) {
                g(e4, qQ0);
                var y = p[1], T = function(V) {
                  return u(n, V);
                }, E = function(V) {
                  return u(t4, V);
                };
                R($e[22][1], E, T, e4, y), g(e4, UQ0);
              } else
                g(e4, HQ0);
              u(f4(e4), XQ0), u(f4(e4), YQ0), o(f4(e4), zQ0, VQ0);
              var d = i4[3];
              function w(V) {
                return u(n, V);
              }
              function G(V) {
                return u(t4, V);
              }
              R($e[13], G, w, e4, d), u(f4(e4), KQ0), u(f4(e4), WQ0), o(f4(e4), $Q0, JQ0);
              var A11 = i4[4];
              if (A11) {
                g(e4, ZQ0);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, PQ0);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, QQ0);
              } else
                g(e4, r0r);
              return u(f4(e4), e0r), u(f4(e4), n0r);
            }), N(WW, function(t4, n, e4) {
              var i4 = o(MC, t4, n);
              return o(C0(CQ0), i4, e4);
            });
            var y5 = [0, MC, WW], BC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, JW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(BC, function(t4, n, e4, i4) {
              u(f4(e4), QZ0), o(f4(e4), eQ0, rQ0);
              var x4 = i4[1];
              function c(e0) {
                return u(n, e0);
              }
              function s2(e0) {
                return u(t4, e0);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), nQ0), u(f4(e4), tQ0), o(f4(e4), iQ0, uQ0);
              var p = i4[2];
              if (p) {
                g(e4, fQ0);
                var y = p[1], T = function(e0) {
                  return u(n, e0);
                }, E = function(e0) {
                  return u(t4, e0);
                };
                R($e[22][1], E, T, e4, y), g(e4, xQ0);
              } else
                g(e4, oQ0);
              u(f4(e4), aQ0), u(f4(e4), cQ0), o(f4(e4), vQ0, sQ0);
              var d = i4[3];
              if (d) {
                g(e4, lQ0);
                var w = d[1], G = function(e0) {
                  return u(n, e0);
                }, A11 = function(e0) {
                  return u(t4, e0);
                };
                R($e[13], A11, G, e4, w), g(e4, bQ0);
              } else
                g(e4, pQ0);
              u(f4(e4), mQ0), u(f4(e4), _Q0), o(f4(e4), hQ0, yQ0);
              var S11 = i4[4];
              if (S11) {
                g(e4, dQ0);
                var M = S11[1], K = function(e0) {
                  return u(n, e0);
                }, V = function(e0) {
                  return u(t4, e0);
                };
                R($e[13], V, K, e4, M), g(e4, kQ0);
              } else
                g(e4, wQ0);
              u(f4(e4), EQ0), u(f4(e4), SQ0), o(f4(e4), FQ0, gQ0);
              var f0 = i4[5];
              if (f0) {
                g(e4, TQ0);
                var m0 = f0[1], k0 = function(e0, x0) {
                  return g(e0, ZZ0);
                }, g0 = function(e0) {
                  return u(t4, e0);
                };
                R(Dr[1], g0, k0, e4, m0), g(e4, OQ0);
              } else
                g(e4, IQ0);
              return u(f4(e4), AQ0), u(f4(e4), NQ0);
            }), N(JW, function(t4, n, e4) {
              var i4 = o(BC, t4, n);
              return o(C0($Z0), i4, e4);
            });
            var h5 = [0, BC, JW], qC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, $W = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, d5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, ZW = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(qC, function(t4, n, e4, i4) {
              u(f4(e4), KZ0), o(t4, e4, i4[1]), u(f4(e4), WZ0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(d5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), JZ0);
            }), N($W, function(t4, n, e4) {
              var i4 = o(qC, t4, n);
              return o(C0(zZ0), i4, e4);
            }), N(d5, function(t4, n, e4, i4) {
              u(f4(e4), FZ0), o(f4(e4), OZ0, TZ0);
              var x4 = i4[1];
              if (x4) {
                g(e4, IZ0);
                var c = x4[1], s2 = function(A11) {
                  return u(n, A11);
                }, p = function(A11) {
                  return u(t4, A11);
                };
                R(qe[31], p, s2, e4, c), g(e4, AZ0);
              } else
                g(e4, NZ0);
              u(f4(e4), CZ0), u(f4(e4), PZ0), o(f4(e4), LZ0, DZ0);
              var y = i4[2];
              u(f4(e4), RZ0);
              var T = 0;
              le(function(A11, S11) {
                A11 && u(f4(e4), gZ0);
                function M(V) {
                  return u(n, V);
                }
                function K(V) {
                  return u(t4, V);
                }
                return R(Yu[35], K, M, e4, S11), 1;
              }, T, y), u(f4(e4), jZ0), u(f4(e4), GZ0), u(f4(e4), MZ0), o(f4(e4), qZ0, BZ0);
              var E = i4[3];
              if (E) {
                g(e4, UZ0);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, SZ0);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, HZ0);
              } else
                g(e4, XZ0);
              return u(f4(e4), YZ0), u(f4(e4), VZ0);
            }), N(ZW, function(t4, n, e4) {
              var i4 = o(d5, t4, n);
              return o(C0(EZ0), i4, e4);
            });
            var QW = [0, qC, $W, d5, ZW], UC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, rJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(UC, function(t4, n, e4, i4) {
              u(f4(e4), eZ0), o(f4(e4), tZ0, nZ0);
              var x4 = i4[1];
              function c(G) {
                return u(n, G);
              }
              function s2(G) {
                return u(t4, G);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), uZ0), u(f4(e4), iZ0), o(f4(e4), xZ0, fZ0);
              var p = i4[2];
              u(f4(e4), oZ0);
              var y = 0;
              le(function(G, A11) {
                G && u(f4(e4), rZ0);
                function S11(K) {
                  return u(n, K);
                }
                function M(K) {
                  return u(t4, K);
                }
                return R(QW[1], M, S11, e4, A11), 1;
              }, y, p), u(f4(e4), aZ0), u(f4(e4), cZ0), u(f4(e4), sZ0), o(f4(e4), lZ0, vZ0);
              var T = i4[3];
              if (T) {
                g(e4, bZ0);
                var E = T[1], d = function(G, A11) {
                  return g(G, Q$0);
                }, w = function(G) {
                  return u(t4, G);
                };
                R(Dr[1], w, d, e4, E), g(e4, pZ0);
              } else
                g(e4, mZ0);
              return u(f4(e4), _Z0), u(f4(e4), yZ0), o(f4(e4), dZ0, hZ0), o(n, e4, i4[4]), u(f4(e4), kZ0), u(f4(e4), wZ0);
            }), N(rJ, function(t4, n, e4) {
              var i4 = o(UC, t4, n);
              return o(C0(Z$0), i4, e4);
            });
            var eJ = [0, QW, UC, rJ], HC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, nJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(HC, function(t4, n, e4, i4) {
              u(f4(e4), P$0), o(f4(e4), L$0, D$0);
              var x4 = i4[1];
              if (x4) {
                g(e4, R$0);
                var c = x4[1], s2 = function(w) {
                  return u(n, w);
                }, p = function(w) {
                  return u(t4, w);
                };
                R(qe[31], p, s2, e4, c), g(e4, j$0);
              } else
                g(e4, G$0);
              u(f4(e4), M$0), u(f4(e4), B$0), o(f4(e4), U$0, q$0);
              var y = i4[2];
              if (y) {
                g(e4, H$0);
                var T = y[1], E = function(w, G) {
                  return g(w, C$0);
                }, d = function(w) {
                  return u(t4, w);
                };
                R(Dr[1], d, E, e4, T), g(e4, X$0);
              } else
                g(e4, Y$0);
              return u(f4(e4), V$0), u(f4(e4), z$0), o(f4(e4), W$0, K$0), o(n, e4, i4[3]), u(f4(e4), J$0), u(f4(e4), $$0);
            }), N(nJ, function(t4, n, e4) {
              var i4 = o(HC, t4, n);
              return o(C0(N$0), i4, e4);
            });
            var tJ = [0, HC, nJ], XC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, uJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(XC, function(t4, n, e4, i4) {
              u(f4(e4), h$0), o(f4(e4), k$0, d$0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), w$0), u(f4(e4), E$0), o(f4(e4), g$0, S$0);
              var p = i4[2];
              if (p) {
                g(e4, F$0);
                var y = p[1], T = function(d, w) {
                  return g(d, y$0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, T$0);
              } else
                g(e4, O$0);
              return u(f4(e4), I$0), u(f4(e4), A$0);
            }), N(uJ, function(t4, n, e4) {
              var i4 = o(XC, t4, n);
              return o(C0(_$0), i4, e4);
            });
            var iJ = [0, XC, uJ], YC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, fJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, k5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, xJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(YC, function(t4, n, e4, i4) {
              u(f4(e4), b$0), o(t4, e4, i4[1]), u(f4(e4), p$0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(k5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), m$0);
            }), N(fJ, function(t4, n, e4) {
              var i4 = o(YC, t4, n);
              return o(C0(l$0), i4, e4);
            }), N(k5, function(t4, n, e4, i4) {
              u(f4(e4), YJ0), o(f4(e4), zJ0, VJ0);
              var x4 = i4[1];
              if (x4) {
                g(e4, KJ0);
                var c = x4[1], s2 = function(M) {
                  return u(n, M);
                }, p = function(M) {
                  return u(t4, M);
                };
                R(di[5], p, s2, e4, c), g(e4, WJ0);
              } else
                g(e4, JJ0);
              u(f4(e4), $J0), u(f4(e4), ZJ0), o(f4(e4), r$0, QJ0);
              var y = i4[2];
              u(f4(e4), e$0), o(t4, e4, y[1]), u(f4(e4), n$0);
              var T = y[2];
              function E(M) {
                return u(n, M);
              }
              function d(M) {
                return u(t4, M);
              }
              R(Kv[1], d, E, e4, T), u(f4(e4), t$0), u(f4(e4), u$0), u(f4(e4), i$0), o(f4(e4), x$0, f$0);
              var w = i4[3];
              if (w) {
                g(e4, o$0);
                var G = w[1], A11 = function(M, K) {
                  return g(M, XJ0);
                }, S11 = function(M) {
                  return u(t4, M);
                };
                R(Dr[1], S11, A11, e4, G), g(e4, a$0);
              } else
                g(e4, c$0);
              return u(f4(e4), s$0), u(f4(e4), v$0);
            }), N(xJ, function(t4, n, e4) {
              var i4 = o(k5, t4, n);
              return o(C0(HJ0), i4, e4);
            });
            var oJ = [0, YC, fJ, k5, xJ], VC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, aJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(VC, function(t4, n, e4, i4) {
              u(f4(e4), sJ0), o(f4(e4), lJ0, vJ0);
              var x4 = i4[1];
              u(f4(e4), bJ0), o(t4, e4, x4[1]), u(f4(e4), pJ0);
              var c = x4[2];
              function s2(k0) {
                return u(n, k0);
              }
              function p(k0) {
                return u(t4, k0);
              }
              R(Kv[1], p, s2, e4, c), u(f4(e4), mJ0), u(f4(e4), _J0), u(f4(e4), yJ0), o(f4(e4), dJ0, hJ0);
              var y = i4[2];
              if (y) {
                g(e4, kJ0);
                var T = y[1], E = function(k0) {
                  return u(n, k0);
                }, d = function(k0) {
                  return u(t4, k0);
                };
                R(oJ[1], d, E, e4, T), g(e4, wJ0);
              } else
                g(e4, EJ0);
              u(f4(e4), SJ0), u(f4(e4), gJ0), o(f4(e4), TJ0, FJ0);
              var w = i4[3];
              if (w) {
                var G = w[1];
                g(e4, OJ0), u(f4(e4), IJ0), o(t4, e4, G[1]), u(f4(e4), AJ0);
                var A11 = G[2], S11 = function(k0) {
                  return u(n, k0);
                }, M = function(k0) {
                  return u(t4, k0);
                };
                R(Kv[1], M, S11, e4, A11), u(f4(e4), NJ0), g(e4, CJ0);
              } else
                g(e4, PJ0);
              u(f4(e4), DJ0), u(f4(e4), LJ0), o(f4(e4), jJ0, RJ0);
              var K = i4[4];
              if (K) {
                g(e4, GJ0);
                var V = K[1], f0 = function(k0, g0) {
                  return g(k0, cJ0);
                }, m0 = function(k0) {
                  return u(t4, k0);
                };
                R(Dr[1], m0, f0, e4, V), g(e4, MJ0);
              } else
                g(e4, BJ0);
              return u(f4(e4), qJ0), u(f4(e4), UJ0);
            }), N(aJ, function(t4, n, e4) {
              var i4 = o(VC, t4, n);
              return o(C0(aJ0), i4, e4);
            });
            var cJ = [0, oJ, VC, aJ], zC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, sJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, w5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, vJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(zC, function(t4, n, e4, i4) {
              u(f4(e4), fJ0), o(t4, e4, i4[1]), u(f4(e4), xJ0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(w5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), oJ0);
            }), N(sJ, function(t4, n, e4) {
              var i4 = o(zC, t4, n);
              return o(C0(iJ0), i4, e4);
            }), N(w5, function(t4, n, e4, i4) {
              u(f4(e4), zW0), o(f4(e4), WW0, KW0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(di[5], s2, c, e4, x4), u(f4(e4), JW0), u(f4(e4), $W0), o(f4(e4), QW0, ZW0);
              var p = i4[2];
              if (p) {
                g(e4, rJ0);
                var y = p[1], T = function(d) {
                  return u(n, d);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(qe[31], E, T, e4, y), g(e4, eJ0);
              } else
                g(e4, nJ0);
              return u(f4(e4), tJ0), u(f4(e4), uJ0);
            }), N(vJ, function(t4, n, e4) {
              var i4 = o(w5, t4, n);
              return o(C0(VW0), i4, e4);
            });
            var lJ = [0, zC, sJ, w5, vJ], KC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, bJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, E5 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, pJ = function t4(n) {
              return t4.fun(n);
            };
            N(KC, function(t4, n, e4, i4) {
              u(f4(e4), OW0), o(f4(e4), AW0, IW0);
              var x4 = i4[1];
              u(f4(e4), NW0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), TW0);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R(lJ[1], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), CW0), u(f4(e4), PW0), u(f4(e4), DW0), o(f4(e4), RW0, LW0), o(E5, e4, i4[2]), u(f4(e4), jW0), u(f4(e4), GW0), o(f4(e4), BW0, MW0);
              var s2 = i4[3];
              if (s2) {
                g(e4, qW0);
                var p = s2[1], y = function(E, d) {
                  return g(E, FW0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, UW0);
              } else
                g(e4, HW0);
              return u(f4(e4), XW0), u(f4(e4), YW0);
            }), N(bJ, function(t4, n, e4) {
              var i4 = o(KC, t4, n);
              return o(C0(gW0), i4, e4);
            }), N(E5, function(t4, n) {
              switch (n) {
                case 0:
                  return g(t4, wW0);
                case 1:
                  return g(t4, EW0);
                default:
                  return g(t4, SW0);
              }
            }), N(pJ, function(t4) {
              return o(C0(kW0), E5, t4);
            });
            var Il = [0, lJ, KC, bJ, E5, pJ], WC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, mJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(WC, function(t4, n, e4, i4) {
              u(f4(e4), iW0), o(f4(e4), xW0, fW0);
              var x4 = i4[1];
              function c(A11) {
                return u(n, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), oW0), u(f4(e4), aW0), o(f4(e4), sW0, cW0);
              var p = i4[2];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R(Yu[35], T, y, e4, p), u(f4(e4), vW0), u(f4(e4), lW0), o(f4(e4), pW0, bW0);
              var E = i4[3];
              if (E) {
                g(e4, mW0);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, uW0);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, _W0);
              } else
                g(e4, yW0);
              return u(f4(e4), hW0), u(f4(e4), dW0);
            }), N(mJ, function(t4, n, e4) {
              var i4 = o(WC, t4, n);
              return o(C0(tW0), i4, e4);
            });
            var _J = [0, WC, mJ], JC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, yJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(JC, function(t4, n, e4, i4) {
              u(f4(e4), qK0), o(f4(e4), HK0, UK0);
              var x4 = i4[1];
              function c(A11) {
                return u(n, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R(Yu[35], s2, c, e4, x4), u(f4(e4), XK0), u(f4(e4), YK0), o(f4(e4), zK0, VK0);
              var p = i4[2];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R(qe[31], T, y, e4, p), u(f4(e4), KK0), u(f4(e4), WK0), o(f4(e4), $K0, JK0);
              var E = i4[3];
              if (E) {
                g(e4, ZK0);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, BK0);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, QK0);
              } else
                g(e4, rW0);
              return u(f4(e4), eW0), u(f4(e4), nW0);
            }), N(yJ, function(t4, n, e4) {
              var i4 = o(JC, t4, n);
              return o(C0(MK0), i4, e4);
            });
            var hJ = [0, JC, yJ], $C = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, dJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, S5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, kJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N($C, function(t4, n, e4, i4) {
              u(f4(e4), fK0), o(f4(e4), oK0, xK0);
              var x4 = i4[1];
              if (x4) {
                g(e4, aK0);
                var c = x4[1], s2 = function(g0) {
                  return u(n, g0);
                };
                R(S5, function(g0) {
                  return u(t4, g0);
                }, s2, e4, c), g(e4, cK0);
              } else
                g(e4, sK0);
              u(f4(e4), vK0), u(f4(e4), lK0), o(f4(e4), pK0, bK0);
              var p = i4[2];
              if (p) {
                g(e4, mK0);
                var y = p[1], T = function(g0) {
                  return u(n, g0);
                }, E = function(g0) {
                  return u(t4, g0);
                };
                R(qe[31], E, T, e4, y), g(e4, _K0);
              } else
                g(e4, yK0);
              u(f4(e4), hK0), u(f4(e4), dK0), o(f4(e4), wK0, kK0);
              var d = i4[3];
              if (d) {
                g(e4, EK0);
                var w = d[1], G = function(g0) {
                  return u(n, g0);
                }, A11 = function(g0) {
                  return u(t4, g0);
                };
                R(qe[31], A11, G, e4, w), g(e4, SK0);
              } else
                g(e4, gK0);
              u(f4(e4), FK0), u(f4(e4), TK0), o(f4(e4), IK0, OK0);
              var S11 = i4[4];
              function M(g0) {
                return u(n, g0);
              }
              function K(g0) {
                return u(t4, g0);
              }
              R(Yu[35], K, M, e4, S11), u(f4(e4), AK0), u(f4(e4), NK0), o(f4(e4), PK0, CK0);
              var V = i4[5];
              if (V) {
                g(e4, DK0);
                var f0 = V[1], m0 = function(g0, e0) {
                  return g(g0, iK0);
                }, k0 = function(g0) {
                  return u(t4, g0);
                };
                R(Dr[1], k0, m0, e4, f0), g(e4, LK0);
              } else
                g(e4, RK0);
              return u(f4(e4), jK0), u(f4(e4), GK0);
            }), N(dJ, function(t4, n, e4) {
              var i4 = o($C, t4, n);
              return o(C0(uK0), i4, e4);
            }), N(S5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                var x4 = i4[1];
                u(f4(e4), $z0), u(f4(e4), Zz0), o(t4, e4, x4[1]), u(f4(e4), Qz0);
                var c = x4[2], s2 = function(d) {
                  return u(n, d);
                }, p = function(d) {
                  return u(t4, d);
                };
                return R(Il[2], p, s2, e4, c), u(f4(e4), rK0), u(f4(e4), eK0);
              }
              u(f4(e4), nK0);
              var y = i4[1];
              function T(d) {
                return u(n, d);
              }
              function E(d) {
                return u(t4, d);
              }
              return R(qe[31], E, T, e4, y), u(f4(e4), tK0);
            }), N(kJ, function(t4, n, e4) {
              var i4 = o(S5, t4, n);
              return o(C0(Jz0), i4, e4);
            });
            var wJ = [0, $C, dJ, S5, kJ], ZC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, EJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, g5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, SJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(ZC, function(t4, n, e4, i4) {
              u(f4(e4), gz0), o(f4(e4), Tz0, Fz0);
              var x4 = i4[1];
              function c(K) {
                return u(n, K);
              }
              R(g5, function(K) {
                return u(t4, K);
              }, c, e4, x4), u(f4(e4), Oz0), u(f4(e4), Iz0), o(f4(e4), Nz0, Az0);
              var s2 = i4[2];
              function p(K) {
                return u(n, K);
              }
              function y(K) {
                return u(t4, K);
              }
              R(qe[31], y, p, e4, s2), u(f4(e4), Cz0), u(f4(e4), Pz0), o(f4(e4), Lz0, Dz0);
              var T = i4[3];
              function E(K) {
                return u(n, K);
              }
              function d(K) {
                return u(t4, K);
              }
              R(Yu[35], d, E, e4, T), u(f4(e4), Rz0), u(f4(e4), jz0), o(f4(e4), Mz0, Gz0);
              var w = i4[4];
              o(f4(e4), Bz0, w), u(f4(e4), qz0), u(f4(e4), Uz0), o(f4(e4), Xz0, Hz0);
              var G = i4[5];
              if (G) {
                g(e4, Yz0);
                var A11 = G[1], S11 = function(K, V) {
                  return g(K, Sz0);
                }, M = function(K) {
                  return u(t4, K);
                };
                R(Dr[1], M, S11, e4, A11), g(e4, Vz0);
              } else
                g(e4, zz0);
              return u(f4(e4), Kz0), u(f4(e4), Wz0);
            }), N(EJ, function(t4, n, e4) {
              var i4 = o(ZC, t4, n);
              return o(C0(Ez0), i4, e4);
            }), N(g5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                var x4 = i4[1];
                u(f4(e4), mz0), u(f4(e4), _z0), o(t4, e4, x4[1]), u(f4(e4), yz0);
                var c = x4[2], s2 = function(d) {
                  return u(n, d);
                }, p = function(d) {
                  return u(t4, d);
                };
                return R(Il[2], p, s2, e4, c), u(f4(e4), hz0), u(f4(e4), dz0);
              }
              u(f4(e4), kz0);
              var y = i4[1];
              function T(d) {
                return u(n, d);
              }
              function E(d) {
                return u(t4, d);
              }
              return R(di[5], E, T, e4, y), u(f4(e4), wz0);
            }), N(SJ, function(t4, n, e4) {
              var i4 = o(g5, t4, n);
              return o(C0(pz0), i4, e4);
            });
            var gJ = [0, ZC, EJ, g5, SJ], QC = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, FJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, F5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, TJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(QC, function(t4, n, e4, i4) {
              u(f4(e4), XV0), o(f4(e4), VV0, YV0);
              var x4 = i4[1];
              function c(K) {
                return u(n, K);
              }
              R(F5, function(K) {
                return u(t4, K);
              }, c, e4, x4), u(f4(e4), zV0), u(f4(e4), KV0), o(f4(e4), JV0, WV0);
              var s2 = i4[2];
              function p(K) {
                return u(n, K);
              }
              function y(K) {
                return u(t4, K);
              }
              R(qe[31], y, p, e4, s2), u(f4(e4), $V0), u(f4(e4), ZV0), o(f4(e4), rz0, QV0);
              var T = i4[3];
              function E(K) {
                return u(n, K);
              }
              function d(K) {
                return u(t4, K);
              }
              R(Yu[35], d, E, e4, T), u(f4(e4), ez0), u(f4(e4), nz0), o(f4(e4), uz0, tz0);
              var w = i4[4];
              o(f4(e4), iz0, w), u(f4(e4), fz0), u(f4(e4), xz0), o(f4(e4), az0, oz0);
              var G = i4[5];
              if (G) {
                g(e4, cz0);
                var A11 = G[1], S11 = function(K, V) {
                  return g(K, HV0);
                }, M = function(K) {
                  return u(t4, K);
                };
                R(Dr[1], M, S11, e4, A11), g(e4, sz0);
              } else
                g(e4, vz0);
              return u(f4(e4), lz0), u(f4(e4), bz0);
            }), N(FJ, function(t4, n, e4) {
              var i4 = o(QC, t4, n);
              return o(C0(UV0), i4, e4);
            }), N(F5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                var x4 = i4[1];
                u(f4(e4), LV0), u(f4(e4), RV0), o(t4, e4, x4[1]), u(f4(e4), jV0);
                var c = x4[2], s2 = function(d) {
                  return u(n, d);
                }, p = function(d) {
                  return u(t4, d);
                };
                return R(Il[2], p, s2, e4, c), u(f4(e4), GV0), u(f4(e4), MV0);
              }
              u(f4(e4), BV0);
              var y = i4[1];
              function T(d) {
                return u(n, d);
              }
              function E(d) {
                return u(t4, d);
              }
              return R(di[5], E, T, e4, y), u(f4(e4), qV0);
            }), N(TJ, function(t4, n, e4) {
              var i4 = o(F5, t4, n);
              return o(C0(DV0), i4, e4);
            });
            var OJ = [0, QC, FJ, F5, TJ], rP = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, IJ = function t4(n, e4) {
              return t4.fun(n, e4);
            }, T5 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, AJ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(rP, function(t4, n, e4) {
              u(f4(n), NV0), o(t4, n, e4[1]), u(f4(n), CV0);
              var i4 = e4[2];
              return ur(T5, function(x4) {
                return u(t4, x4);
              }, n, i4), u(f4(n), PV0);
            }), N(IJ, function(t4, n) {
              var e4 = u(rP, t4);
              return o(C0(AV0), e4, n);
            }), N(T5, function(t4, n, e4) {
              u(f4(n), gV0), o(f4(n), TV0, FV0);
              var i4 = e4[1];
              function x4(s2) {
                return u(t4, s2);
              }
              function c(s2) {
                return u(t4, s2);
              }
              return R(Rn[1], c, x4, n, i4), u(f4(n), OV0), u(f4(n), IV0);
            }), N(AJ, function(t4, n) {
              var e4 = u(T5, t4);
              return o(C0(SV0), e4, n);
            });
            var eP = [0, rP, IJ, T5, AJ], nP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, NJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, O5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, CJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(nP, function(t4, n, e4, i4) {
              u(f4(e4), kV0), o(n, e4, i4[1]), u(f4(e4), wV0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(O5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), EV0);
            }), N(NJ, function(t4, n, e4) {
              var i4 = o(nP, t4, n);
              return o(C0(dV0), i4, e4);
            }), N(O5, function(t4, n, e4, i4) {
              u(f4(e4), oV0), o(f4(e4), cV0, aV0);
              var x4 = i4[1];
              function c(y) {
                return u(n, y);
              }
              function s2(y) {
                return u(n, y);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), sV0), u(f4(e4), vV0), o(f4(e4), bV0, lV0);
              var p = i4[2];
              return u(f4(e4), pV0), o(n, e4, p[1]), u(f4(e4), mV0), o(t4, e4, p[2]), u(f4(e4), _V0), u(f4(e4), yV0), u(f4(e4), hV0);
            }), N(CJ, function(t4, n, e4) {
              var i4 = o(O5, t4, n);
              return o(C0(xV0), i4, e4);
            });
            var I5 = [0, nP, NJ, O5, CJ], tP = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, PJ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(tP, function(t4, n, e4) {
              u(f4(n), jY0), o(f4(n), MY0, GY0);
              var i4 = e4[1];
              u(f4(n), BY0);
              var x4 = 0;
              le(function(d, w) {
                d && u(f4(n), RY0);
                function G(S11) {
                  return u(t4, S11);
                }
                function A11(S11) {
                  function M(K) {
                    return u(t4, K);
                  }
                  return o(qN[1], M, S11);
                }
                return R(I5[1], A11, G, n, w), 1;
              }, x4, i4), u(f4(n), qY0), u(f4(n), UY0), u(f4(n), HY0), o(f4(n), YY0, XY0);
              var c = e4[2];
              o(f4(n), VY0, c), u(f4(n), zY0), u(f4(n), KY0), o(f4(n), JY0, WY0);
              var s2 = e4[3];
              o(f4(n), $Y0, s2), u(f4(n), ZY0), u(f4(n), QY0), o(f4(n), eV0, rV0);
              var p = e4[4];
              if (p) {
                g(n, nV0);
                var y = p[1], T = function(d, w) {
                  u(f4(d), DY0);
                  var G = 0;
                  return le(function(A11, S11) {
                    A11 && u(f4(d), PY0);
                    function M(K) {
                      return u(t4, K);
                    }
                    return ur(iu[1], M, d, S11), 1;
                  }, G, w), u(f4(d), LY0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, n, y), g(n, tV0);
              } else
                g(n, uV0);
              return u(f4(n), iV0), u(f4(n), fV0);
            }), N(PJ, function(t4, n) {
              var e4 = u(tP, t4);
              return o(C0(CY0), e4, n);
            });
            var DJ = [0, tP, PJ], uP = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, LJ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(uP, function(t4, n, e4) {
              u(f4(n), oY0), o(f4(n), cY0, aY0);
              var i4 = e4[1];
              u(f4(n), sY0);
              var x4 = 0;
              le(function(d, w) {
                d && u(f4(n), xY0);
                function G(S11) {
                  return u(t4, S11);
                }
                function A11(S11) {
                  function M(K) {
                    return u(t4, K);
                  }
                  return o(BN[1], M, S11);
                }
                return R(I5[1], A11, G, n, w), 1;
              }, x4, i4), u(f4(n), vY0), u(f4(n), lY0), u(f4(n), bY0), o(f4(n), mY0, pY0);
              var c = e4[2];
              o(f4(n), _Y0, c), u(f4(n), yY0), u(f4(n), hY0), o(f4(n), kY0, dY0);
              var s2 = e4[3];
              o(f4(n), wY0, s2), u(f4(n), EY0), u(f4(n), SY0), o(f4(n), FY0, gY0);
              var p = e4[4];
              if (p) {
                g(n, TY0);
                var y = p[1], T = function(d, w) {
                  u(f4(d), iY0);
                  var G = 0;
                  return le(function(A11, S11) {
                    A11 && u(f4(d), uY0);
                    function M(K) {
                      return u(t4, K);
                    }
                    return ur(iu[1], M, d, S11), 1;
                  }, G, w), u(f4(d), fY0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, n, y), g(n, OY0);
              } else
                g(n, IY0);
              return u(f4(n), AY0), u(f4(n), NY0);
            }), N(LJ, function(t4, n) {
              var e4 = u(uP, t4);
              return o(C0(tY0), e4, n);
            });
            var RJ = [0, uP, LJ], iP = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, jJ = function t4(n, e4) {
              return t4.fun(n, e4);
            }, A5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, GJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(iP, function(t4, n, e4) {
              u(f4(n), LX0), o(f4(n), jX0, RX0);
              var i4 = e4[1];
              function x4(d) {
                return u(t4, d);
              }
              R(A5, function(d) {
                function w(G) {
                  return u(t4, G);
                }
                return o(g1[1], w, d);
              }, x4, n, i4), u(f4(n), GX0), u(f4(n), MX0), o(f4(n), qX0, BX0);
              var c = e4[2];
              o(f4(n), UX0, c), u(f4(n), HX0), u(f4(n), XX0), o(f4(n), VX0, YX0);
              var s2 = e4[3];
              o(f4(n), zX0, s2), u(f4(n), KX0), u(f4(n), WX0), o(f4(n), $X0, JX0);
              var p = e4[4];
              if (p) {
                g(n, ZX0);
                var y = p[1], T = function(d, w) {
                  u(f4(d), PX0);
                  var G = 0;
                  return le(function(A11, S11) {
                    A11 && u(f4(d), CX0);
                    function M(K) {
                      return u(t4, K);
                    }
                    return ur(iu[1], M, d, S11), 1;
                  }, G, w), u(f4(d), DX0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, n, y), g(n, QX0);
              } else
                g(n, rY0);
              return u(f4(n), eY0), u(f4(n), nY0);
            }), N(jJ, function(t4, n) {
              var e4 = u(iP, t4);
              return o(C0(NX0), e4, n);
            }), N(A5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), EX0), u(f4(e4), SX0);
                var x4 = i4[1], c = 0;
                return le(function(y, T) {
                  y && u(f4(e4), wX0);
                  function E(d) {
                    return u(n, d);
                  }
                  return ur(eP[1], E, e4, T), 1;
                }, c, x4), u(f4(e4), gX0), u(f4(e4), FX0);
              }
              u(f4(e4), TX0), u(f4(e4), OX0);
              var s2 = i4[1], p = 0;
              return le(function(y, T) {
                y && u(f4(e4), kX0);
                function E(w) {
                  return u(n, w);
                }
                function d(w) {
                  return u(t4, w);
                }
                return R(I5[1], d, E, e4, T), 1;
              }, p, s2), u(f4(e4), IX0), u(f4(e4), AX0);
            }), N(GJ, function(t4, n, e4) {
              var i4 = o(A5, t4, n);
              return o(C0(dX0), i4, e4);
            });
            var MJ = [0, iP, jJ, A5, GJ], fP = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, BJ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(fP, function(t4, n, e4) {
              u(f4(n), eX0), o(f4(n), tX0, nX0);
              var i4 = e4[1];
              u(f4(n), uX0);
              var x4 = 0;
              le(function(E, d) {
                E && u(f4(n), rX0);
                function w(G) {
                  return u(t4, G);
                }
                return ur(eP[1], w, n, d), 1;
              }, x4, i4), u(f4(n), iX0), u(f4(n), fX0), u(f4(n), xX0), o(f4(n), aX0, oX0);
              var c = e4[2];
              o(f4(n), cX0, c), u(f4(n), sX0), u(f4(n), vX0), o(f4(n), bX0, lX0);
              var s2 = e4[3];
              if (s2) {
                g(n, pX0);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), ZH0);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), $H0);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), QH0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, n, p), g(n, mX0);
              } else
                g(n, _X0);
              return u(f4(n), yX0), u(f4(n), hX0);
            }), N(BJ, function(t4, n) {
              var e4 = u(fP, t4);
              return o(C0(JH0), e4, n);
            });
            var qJ = [0, fP, BJ], xP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, UJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, N5 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, HJ = function t4(n, e4) {
              return t4.fun(n, e4);
            }, C5 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, XJ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(xP, function(t4, n, e4, i4) {
              u(f4(e4), DH0), o(f4(e4), RH0, LH0);
              var x4 = i4[1];
              function c(w) {
                return u(n, w);
              }
              function s2(w) {
                return u(t4, w);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), jH0), u(f4(e4), GH0), o(f4(e4), BH0, MH0);
              var p = i4[2];
              ur(N5, function(w) {
                return u(t4, w);
              }, e4, p), u(f4(e4), qH0), u(f4(e4), UH0), o(f4(e4), XH0, HH0);
              var y = i4[3];
              if (y) {
                g(e4, YH0);
                var T = y[1], E = function(w, G) {
                  return g(w, PH0);
                }, d = function(w) {
                  return u(t4, w);
                };
                R(Dr[1], d, E, e4, T), g(e4, VH0);
              } else
                g(e4, zH0);
              return u(f4(e4), KH0), u(f4(e4), WH0);
            }), N(UJ, function(t4, n, e4) {
              var i4 = o(xP, t4, n);
              return o(C0(CH0), i4, e4);
            }), N(N5, function(t4, n, e4) {
              u(f4(n), IH0), o(t4, n, e4[1]), u(f4(n), AH0);
              var i4 = e4[2];
              return ur(C5, function(x4) {
                return u(t4, x4);
              }, n, i4), u(f4(n), NH0);
            }), N(HJ, function(t4, n) {
              var e4 = u(N5, t4);
              return o(C0(OH0), e4, n);
            }), N(C5, function(t4, n, e4) {
              switch (e4[0]) {
                case 0:
                  u(f4(n), dH0);
                  var i4 = e4[1], x4 = function(d) {
                    return u(t4, d);
                  };
                  return ur(DJ[1], x4, n, i4), u(f4(n), kH0);
                case 1:
                  u(f4(n), wH0);
                  var c = e4[1], s2 = function(d) {
                    return u(t4, d);
                  };
                  return ur(RJ[1], s2, n, c), u(f4(n), EH0);
                case 2:
                  u(f4(n), SH0);
                  var p = e4[1], y = function(d) {
                    return u(t4, d);
                  };
                  return ur(MJ[1], y, n, p), u(f4(n), gH0);
                default:
                  u(f4(n), FH0);
                  var T = e4[1], E = function(d) {
                    return u(t4, d);
                  };
                  return ur(qJ[1], E, n, T), u(f4(n), TH0);
              }
            }), N(XJ, function(t4, n) {
              var e4 = u(C5, t4);
              return o(C0(hH0), e4, n);
            });
            var YJ = [0, eP, I5, DJ, RJ, MJ, qJ, xP, UJ, N5, HJ, C5, XJ], oP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, VJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(oP, function(t4, n, e4, i4) {
              u(f4(e4), qU0), o(f4(e4), HU0, UU0);
              var x4 = i4[1];
              function c(k0) {
                return u(n, k0);
              }
              function s2(k0) {
                return u(t4, k0);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), XU0), u(f4(e4), YU0), o(f4(e4), zU0, VU0);
              var p = i4[2];
              if (p) {
                g(e4, KU0);
                var y = p[1], T = function(k0) {
                  return u(n, k0);
                }, E = function(k0) {
                  return u(t4, k0);
                };
                R($e[22][1], E, T, e4, y), g(e4, WU0);
              } else
                g(e4, JU0);
              u(f4(e4), $U0), u(f4(e4), ZU0), o(f4(e4), rH0, QU0);
              var d = i4[3];
              u(f4(e4), eH0);
              var w = 0;
              le(function(k0, g0) {
                k0 && u(f4(e4), jU0), u(f4(e4), GU0), o(t4, e4, g0[1]), u(f4(e4), MU0);
                var e0 = g0[2];
                function x0(c0) {
                  return u(n, c0);
                }
                function l(c0) {
                  return u(t4, c0);
                }
                return R($e[2][2], l, x0, e4, e0), u(f4(e4), BU0), 1;
              }, w, d), u(f4(e4), nH0), u(f4(e4), tH0), u(f4(e4), uH0), o(f4(e4), fH0, iH0);
              var G = i4[4];
              u(f4(e4), xH0), o(t4, e4, G[1]), u(f4(e4), oH0);
              var A11 = G[2];
              function S11(k0) {
                return u(n, k0);
              }
              function M(k0) {
                return u(t4, k0);
              }
              R($e[5][6], M, S11, e4, A11), u(f4(e4), aH0), u(f4(e4), cH0), u(f4(e4), sH0), o(f4(e4), lH0, vH0);
              var K = i4[5];
              if (K) {
                g(e4, bH0);
                var V = K[1], f0 = function(k0, g0) {
                  return g(k0, RU0);
                }, m0 = function(k0) {
                  return u(t4, k0);
                };
                R(Dr[1], m0, f0, e4, V), g(e4, pH0);
              } else
                g(e4, mH0);
              return u(f4(e4), _H0), u(f4(e4), yH0);
            }), N(VJ, function(t4, n, e4) {
              var i4 = o(oP, t4, n);
              return o(C0(LU0), i4, e4);
            });
            var P5 = [0, oP, VJ], aP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, zJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(aP, function(t4, n, e4, i4) {
              u(f4(e4), Bq0), o(f4(e4), Uq0, qq0);
              var x4 = i4[1];
              function c(_0) {
                return u(n, _0);
              }
              function s2(_0) {
                return u(t4, _0);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), Hq0), u(f4(e4), Xq0), o(f4(e4), Vq0, Yq0);
              var p = i4[2];
              if (p) {
                g(e4, zq0);
                var y = p[1], T = function(_0) {
                  return u(n, _0);
                }, E = function(_0) {
                  return u(t4, _0);
                };
                R($e[22][1], E, T, e4, y), g(e4, Kq0);
              } else
                g(e4, Wq0);
              u(f4(e4), Jq0), u(f4(e4), $q0), o(f4(e4), Qq0, Zq0);
              var d = i4[3];
              u(f4(e4), rU0), o(t4, e4, d[1]), u(f4(e4), eU0);
              var w = d[2];
              function G(_0) {
                return u(n, _0);
              }
              function A11(_0) {
                return u(t4, _0);
              }
              R($e[5][6], A11, G, e4, w), u(f4(e4), nU0), u(f4(e4), tU0), u(f4(e4), uU0), o(f4(e4), fU0, iU0);
              var S11 = i4[4];
              if (S11) {
                var M = S11[1];
                g(e4, xU0), u(f4(e4), oU0), o(t4, e4, M[1]), u(f4(e4), aU0);
                var K = M[2], V = function(_0) {
                  return u(n, _0);
                }, f0 = function(_0) {
                  return u(t4, _0);
                };
                R($e[2][2], f0, V, e4, K), u(f4(e4), cU0), g(e4, sU0);
              } else
                g(e4, vU0);
              u(f4(e4), lU0), u(f4(e4), bU0), o(f4(e4), mU0, pU0);
              var m0 = i4[5];
              u(f4(e4), _U0);
              var k0 = 0;
              le(function(_0, E0) {
                _0 && u(f4(e4), Rq0), u(f4(e4), jq0), o(t4, e4, E0[1]), u(f4(e4), Gq0);
                var U0 = E0[2];
                function b(X) {
                  return u(n, X);
                }
                function R0(X) {
                  return u(t4, X);
                }
                return R($e[2][2], R0, b, e4, U0), u(f4(e4), Mq0), 1;
              }, k0, m0), u(f4(e4), yU0), u(f4(e4), hU0), u(f4(e4), dU0), o(f4(e4), wU0, kU0);
              var g0 = i4[6];
              if (g0) {
                g(e4, EU0);
                var e0 = g0[1], x0 = function(_0) {
                  return u(n, _0);
                }, l = function(_0) {
                  return u(t4, _0);
                };
                R(F1[5][2], l, x0, e4, e0), g(e4, SU0);
              } else
                g(e4, gU0);
              u(f4(e4), FU0), u(f4(e4), TU0), o(f4(e4), IU0, OU0);
              var c0 = i4[7];
              if (c0) {
                g(e4, AU0);
                var t0 = c0[1], o0 = function(_0, E0) {
                  return g(_0, Lq0);
                }, w0 = function(_0) {
                  return u(t4, _0);
                };
                R(Dr[1], w0, o0, e4, t0), g(e4, NU0);
              } else
                g(e4, CU0);
              return u(f4(e4), PU0), u(f4(e4), DU0);
            }), N(zJ, function(t4, n, e4) {
              var i4 = o(aP, t4, n);
              return o(C0(Dq0), i4, e4);
            });
            var cP = [0, aP, zJ], sP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, KJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(sP, function(t4, n, e4, i4) {
              u(f4(e4), yq0), o(f4(e4), dq0, hq0);
              var x4 = i4[1];
              function c(A11) {
                return u(n, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), kq0), u(f4(e4), wq0), o(f4(e4), Sq0, Eq0);
              var p = i4[2];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R($e[17], T, y, e4, p), u(f4(e4), gq0), u(f4(e4), Fq0), o(f4(e4), Oq0, Tq0);
              var E = i4[3];
              if (E) {
                g(e4, Iq0);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, _q0);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, Aq0);
              } else
                g(e4, Nq0);
              return u(f4(e4), Cq0), u(f4(e4), Pq0);
            }), N(KJ, function(t4, n, e4) {
              var i4 = o(sP, t4, n);
              return o(C0(mq0), i4, e4);
            });
            var vP = [0, sP, KJ], lP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, WJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(lP, function(t4, n, e4, i4) {
              u(f4(e4), zB0), o(f4(e4), WB0, KB0);
              var x4 = i4[1];
              function c(V) {
                return u(n, V);
              }
              function s2(V) {
                return u(t4, V);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), JB0), u(f4(e4), $B0), o(f4(e4), QB0, ZB0);
              var p = i4[2];
              function y(V) {
                return u(n, V);
              }
              function T(V) {
                return u(t4, V);
              }
              R($e[17], T, y, e4, p), u(f4(e4), rq0), u(f4(e4), eq0), o(f4(e4), tq0, nq0);
              var E = i4[3];
              if (E) {
                g(e4, uq0);
                var d = E[1], w = function(V) {
                  return u(n, V);
                }, G = function(V) {
                  return u(t4, V);
                };
                R($e[24][1], G, w, e4, d), g(e4, iq0);
              } else
                g(e4, fq0);
              u(f4(e4), xq0), u(f4(e4), oq0), o(f4(e4), cq0, aq0);
              var A11 = i4[4];
              if (A11) {
                g(e4, sq0);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, VB0);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, vq0);
              } else
                g(e4, lq0);
              return u(f4(e4), bq0), u(f4(e4), pq0);
            }), N(WJ, function(t4, n, e4) {
              var i4 = o(lP, t4, n);
              return o(C0(YB0), i4, e4);
            });
            var bP = [0, lP, WJ], D5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, JJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, L5 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, $J = function t4(n) {
              return t4.fun(n);
            }, pP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, ZJ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(D5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), GB0);
                var x4 = i4[1], c = function(E) {
                  return u(n, E);
                }, s2 = function(E) {
                  return u(t4, E);
                };
                return R(Rn[1], s2, c, e4, x4), u(f4(e4), MB0);
              }
              var p = i4[1];
              u(f4(e4), BB0), u(f4(e4), qB0), o(n, e4, p[1]), u(f4(e4), UB0);
              var y = p[2];
              function T(E) {
                return u(t4, E);
              }
              return ur(g1[1], T, e4, y), u(f4(e4), HB0), u(f4(e4), XB0);
            }), N(JJ, function(t4, n, e4) {
              var i4 = o(D5, t4, n);
              return o(C0(jB0), i4, e4);
            }), N(L5, function(t4, n) {
              return n ? g(t4, LB0) : g(t4, RB0);
            }), N($J, function(t4) {
              return o(C0(DB0), L5, t4);
            }), N(pP, function(t4, n, e4, i4) {
              u(f4(e4), sB0), o(f4(e4), lB0, vB0);
              var x4 = i4[1];
              function c(A11) {
                return u(n, A11);
              }
              R(D5, function(A11) {
                return u(t4, A11);
              }, c, e4, x4), u(f4(e4), bB0), u(f4(e4), pB0), o(f4(e4), _B0, mB0);
              var s2 = i4[2];
              u(f4(e4), yB0), o(t4, e4, s2[1]), u(f4(e4), hB0);
              var p = s2[2];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R(Kv[1], T, y, e4, p), u(f4(e4), dB0), u(f4(e4), kB0), u(f4(e4), wB0), o(f4(e4), SB0, EB0), o(L5, e4, i4[3]), u(f4(e4), gB0), u(f4(e4), FB0), o(f4(e4), OB0, TB0);
              var E = i4[4];
              if (E) {
                g(e4, IB0);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, cB0);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, AB0);
              } else
                g(e4, NB0);
              return u(f4(e4), CB0), u(f4(e4), PB0);
            }), N(ZJ, function(t4, n, e4) {
              var i4 = o(pP, t4, n);
              return o(C0(aB0), i4, e4);
            });
            var QJ = [0, D5, JJ, L5, $J, pP, ZJ], mP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, r$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(mP, function(t4, n, e4, i4) {
              u(f4(e4), $M0), o(f4(e4), QM0, ZM0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R($e[17], s2, c, e4, x4), u(f4(e4), rB0), u(f4(e4), eB0), o(f4(e4), tB0, nB0);
              var p = i4[2];
              if (p) {
                g(e4, uB0);
                var y = p[1], T = function(d, w) {
                  return g(d, JM0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, iB0);
              } else
                g(e4, fB0);
              return u(f4(e4), xB0), u(f4(e4), oB0);
            }), N(r$, function(t4, n, e4) {
              var i4 = o(mP, t4, n);
              return o(C0(WM0), i4, e4);
            });
            var e$ = [0, mP, r$], _P = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, n$ = function t4(n, e4) {
              return t4.fun(n, e4);
            }, R5 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, t$ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(_P, function(t4, n, e4) {
              u(f4(n), VM0), o(t4, n, e4[1]), u(f4(n), zM0);
              var i4 = e4[2];
              return ur(R5, function(x4) {
                return u(t4, x4);
              }, n, i4), u(f4(n), KM0);
            }), N(n$, function(t4, n) {
              var e4 = u(_P, t4);
              return o(C0(YM0), e4, n);
            }), N(R5, function(t4, n, e4) {
              u(f4(n), PM0), o(f4(n), LM0, DM0);
              var i4 = e4[1];
              function x4(E) {
                return u(t4, E);
              }
              function c(E) {
                return u(t4, E);
              }
              R(Rn[1], c, x4, n, i4), u(f4(n), RM0), u(f4(n), jM0), o(f4(n), MM0, GM0);
              var s2 = e4[2];
              if (s2) {
                g(n, BM0);
                var p = s2[1], y = function(E) {
                  return u(t4, E);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Rn[1], T, y, n, p), g(n, qM0);
              } else
                g(n, UM0);
              return u(f4(n), HM0), u(f4(n), XM0);
            }), N(t$, function(t4, n) {
              var e4 = u(R5, t4);
              return o(C0(CM0), e4, n);
            });
            var u$ = [0, _P, n$, R5, t$], yP = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, i$ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(yP, function(t4, n, e4) {
              var i4 = e4[2];
              if (u(f4(n), FM0), o(t4, n, e4[1]), u(f4(n), TM0), i4) {
                g(n, OM0);
                var x4 = i4[1], c = function(p) {
                  return u(t4, p);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                R(Rn[1], s2, c, n, x4), g(n, IM0);
              } else
                g(n, AM0);
              return u(f4(n), NM0);
            }), N(i$, function(t4, n) {
              var e4 = u(yP, t4);
              return o(C0(gM0), e4, n);
            });
            var f$ = [0, yP, i$], hP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, x$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, j5 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, o$ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(hP, function(t4, n, e4, i4) {
              u(f4(e4), HG0), o(f4(e4), YG0, XG0);
              var x4 = i4[1];
              if (x4) {
                g(e4, VG0);
                var c = x4[1], s2 = function(V) {
                  return u(n, V);
                }, p = function(V) {
                  return u(t4, V);
                };
                R(Yu[35], p, s2, e4, c), g(e4, zG0);
              } else
                g(e4, KG0);
              u(f4(e4), WG0), u(f4(e4), JG0), o(f4(e4), ZG0, $G0);
              var y = i4[2];
              if (y) {
                g(e4, QG0);
                var T = y[1];
                ur(j5, function(V) {
                  return u(t4, V);
                }, e4, T), g(e4, rM0);
              } else
                g(e4, eM0);
              u(f4(e4), nM0), u(f4(e4), tM0), o(f4(e4), iM0, uM0);
              var E = i4[3];
              if (E) {
                var d = E[1];
                g(e4, fM0), u(f4(e4), xM0), o(t4, e4, d[1]), u(f4(e4), oM0);
                var w = d[2], G = function(V) {
                  return u(t4, V);
                };
                ur(g1[1], G, e4, w), u(f4(e4), aM0), g(e4, cM0);
              } else
                g(e4, sM0);
              u(f4(e4), vM0), u(f4(e4), lM0), o(f4(e4), pM0, bM0), o(Yu[33], e4, i4[4]), u(f4(e4), mM0), u(f4(e4), _M0), o(f4(e4), hM0, yM0);
              var A11 = i4[5];
              if (A11) {
                g(e4, dM0);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, UG0);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, kM0);
              } else
                g(e4, wM0);
              return u(f4(e4), EM0), u(f4(e4), SM0);
            }), N(x$, function(t4, n, e4) {
              var i4 = o(hP, t4, n);
              return o(C0(qG0), i4, e4);
            }), N(j5, function(t4, n, e4) {
              if (e4[0] === 0) {
                u(f4(n), LG0), u(f4(n), RG0);
                var i4 = e4[1], x4 = 0;
                return le(function(p, y) {
                  p && u(f4(n), DG0);
                  function T(E) {
                    return u(t4, E);
                  }
                  return ur(u$[1], T, n, y), 1;
                }, x4, i4), u(f4(n), jG0), u(f4(n), GG0);
              }
              u(f4(n), MG0);
              var c = e4[1];
              function s2(p) {
                return u(t4, p);
              }
              return ur(f$[1], s2, n, c), u(f4(n), BG0);
            }), N(o$, function(t4, n) {
              var e4 = u(j5, t4);
              return o(C0(PG0), e4, n);
            });
            var dP = [0, u$, f$, hP, x$, j5, o$], kP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, a$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, G5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, c$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(kP, function(t4, n, e4, i4) {
              u(f4(e4), _G0), o(f4(e4), hG0, yG0), o(t4, e4, i4[1]), u(f4(e4), dG0), u(f4(e4), kG0), o(f4(e4), EG0, wG0);
              var x4 = i4[2];
              function c(E) {
                return u(n, E);
              }
              R(G5, function(E) {
                return u(t4, E);
              }, c, e4, x4), u(f4(e4), SG0), u(f4(e4), gG0), o(f4(e4), TG0, FG0);
              var s2 = i4[3];
              if (s2) {
                g(e4, OG0);
                var p = s2[1], y = function(E, d) {
                  return g(E, mG0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, IG0);
              } else
                g(e4, AG0);
              return u(f4(e4), NG0), u(f4(e4), CG0);
            }), N(a$, function(t4, n, e4) {
              var i4 = o(kP, t4, n);
              return o(C0(pG0), i4, e4);
            }), N(G5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), sG0);
                var x4 = i4[1], c = function(E) {
                  return u(n, E);
                }, s2 = function(E) {
                  return u(t4, E);
                };
                return R(Yu[35], s2, c, e4, x4), u(f4(e4), vG0);
              }
              u(f4(e4), lG0);
              var p = i4[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(qe[31], T, y, e4, p), u(f4(e4), bG0);
            }), N(c$, function(t4, n, e4) {
              var i4 = o(G5, t4, n);
              return o(C0(cG0), i4, e4);
            });
            var s$ = [0, kP, a$, G5, c$], M5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, v$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, wP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, l$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(M5, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  var x4 = i4[1];
                  u(f4(e4), Cj0), u(f4(e4), Pj0), o(t4, e4, x4[1]), u(f4(e4), Dj0);
                  var c = x4[2], s2 = function(E0) {
                    return u(n, E0);
                  }, p = function(E0) {
                    return u(t4, E0);
                  };
                  return R(vP[1], p, s2, e4, c), u(f4(e4), Lj0), u(f4(e4), Rj0);
                case 1:
                  var y = i4[1];
                  u(f4(e4), jj0), u(f4(e4), Gj0), o(t4, e4, y[1]), u(f4(e4), Mj0);
                  var T = y[2], E = function(E0) {
                    return u(n, E0);
                  }, d = function(E0) {
                    return u(t4, E0);
                  };
                  return R(bP[1], d, E, e4, T), u(f4(e4), Bj0), u(f4(e4), qj0);
                case 2:
                  var w = i4[1];
                  u(f4(e4), Uj0), u(f4(e4), Hj0), o(t4, e4, w[1]), u(f4(e4), Xj0);
                  var G = w[2], A11 = function(E0) {
                    return u(n, E0);
                  }, S11 = function(E0) {
                    return u(t4, E0);
                  };
                  return R(cP[1], S11, A11, e4, G), u(f4(e4), Yj0), u(f4(e4), Vj0);
                case 3:
                  u(f4(e4), zj0);
                  var M = i4[1], K = function(E0) {
                    return u(n, E0);
                  }, V = function(E0) {
                    return u(t4, E0);
                  };
                  return R($e[13], V, K, e4, M), u(f4(e4), Kj0);
                case 4:
                  var f0 = i4[1];
                  u(f4(e4), Wj0), u(f4(e4), Jj0), o(t4, e4, f0[1]), u(f4(e4), $j0);
                  var m0 = f0[2], k0 = function(E0) {
                    return u(n, E0);
                  }, g0 = function(E0) {
                    return u(t4, E0);
                  };
                  return R(y5[1], g0, k0, e4, m0), u(f4(e4), Zj0), u(f4(e4), Qj0);
                case 5:
                  var e0 = i4[1];
                  u(f4(e4), rG0), u(f4(e4), eG0), o(t4, e4, e0[1]), u(f4(e4), nG0);
                  var x0 = e0[2], l = function(E0) {
                    return u(n, E0);
                  }, c0 = function(E0) {
                    return u(t4, E0);
                  };
                  return R(h5[1], c0, l, e4, x0), u(f4(e4), tG0), u(f4(e4), uG0);
                default:
                  var t0 = i4[1];
                  u(f4(e4), iG0), u(f4(e4), fG0), o(t4, e4, t0[1]), u(f4(e4), xG0);
                  var o0 = t0[2], w0 = function(E0) {
                    return u(n, E0);
                  }, _0 = function(E0) {
                    return u(t4, E0);
                  };
                  return R(P5[1], _0, w0, e4, o0), u(f4(e4), oG0), u(f4(e4), aG0);
              }
            }), N(v$, function(t4, n, e4) {
              var i4 = o(M5, t4, n);
              return o(C0(Nj0), i4, e4);
            }), N(wP, function(t4, n, e4, i4) {
              u(f4(e4), VR0), o(f4(e4), KR0, zR0);
              var x4 = i4[1];
              x4 ? (g(e4, WR0), o(t4, e4, x4[1]), g(e4, JR0)) : g(e4, $R0), u(f4(e4), ZR0), u(f4(e4), QR0), o(f4(e4), ej0, rj0);
              var c = i4[2];
              if (c) {
                g(e4, nj0);
                var s2 = c[1], p = function(f0) {
                  return u(n, f0);
                };
                R(M5, function(f0) {
                  return u(t4, f0);
                }, p, e4, s2), g(e4, tj0);
              } else
                g(e4, uj0);
              u(f4(e4), ij0), u(f4(e4), fj0), o(f4(e4), oj0, xj0);
              var y = i4[3];
              if (y) {
                g(e4, aj0);
                var T = y[1], E = function(f0) {
                  return u(t4, f0);
                };
                ur(dP[5], E, e4, T), g(e4, cj0);
              } else
                g(e4, sj0);
              u(f4(e4), vj0), u(f4(e4), lj0), o(f4(e4), pj0, bj0);
              var d = i4[4];
              if (d) {
                var w = d[1];
                g(e4, mj0), u(f4(e4), _j0), o(t4, e4, w[1]), u(f4(e4), yj0);
                var G = w[2], A11 = function(f0) {
                  return u(t4, f0);
                };
                ur(g1[1], A11, e4, G), u(f4(e4), hj0), g(e4, dj0);
              } else
                g(e4, kj0);
              u(f4(e4), wj0), u(f4(e4), Ej0), o(f4(e4), gj0, Sj0);
              var S11 = i4[5];
              if (S11) {
                g(e4, Fj0);
                var M = S11[1], K = function(f0, m0) {
                  return g(f0, YR0);
                }, V = function(f0) {
                  return u(t4, f0);
                };
                R(Dr[1], V, K, e4, M), g(e4, Tj0);
              } else
                g(e4, Oj0);
              return u(f4(e4), Ij0), u(f4(e4), Aj0);
            }), N(l$, function(t4, n, e4) {
              var i4 = o(wP, t4, n);
              return o(C0(XR0), i4, e4);
            });
            var b$ = [0, M5, v$, wP, l$], Al = function t4(n, e4) {
              return t4.fun(n, e4);
            }, p$ = function t4(n) {
              return t4.fun(n);
            }, B5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, m$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, q5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, _$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, EP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, y$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(Al, function(t4, n) {
              switch (n) {
                case 0:
                  return g(t4, qR0);
                case 1:
                  return g(t4, UR0);
                default:
                  return g(t4, HR0);
              }
            }), N(p$, function(t4) {
              return o(C0(BR0), Al, t4);
            }), N(B5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), NR0), u(f4(e4), CR0);
                var x4 = i4[1], c = 0;
                return le(function(E, d) {
                  E && u(f4(e4), AR0);
                  function w(G) {
                    return u(n, G);
                  }
                  return R(q5, function(G) {
                    return u(t4, G);
                  }, w, e4, d), 1;
                }, c, x4), u(f4(e4), PR0), u(f4(e4), DR0);
              }
              var s2 = i4[1];
              u(f4(e4), LR0), u(f4(e4), RR0), o(t4, e4, s2[1]), u(f4(e4), jR0);
              var p = s2[2];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(Rn[1], T, y, e4, p), u(f4(e4), GR0), u(f4(e4), MR0);
            }), N(m$, function(t4, n, e4) {
              var i4 = o(B5, t4, n);
              return o(C0(IR0), i4, e4);
            }), N(q5, function(t4, n, e4, i4) {
              u(f4(e4), cR0), o(f4(e4), vR0, sR0);
              var x4 = i4[1];
              x4 ? (g(e4, lR0), o(Al, e4, x4[1]), g(e4, bR0)) : g(e4, pR0), u(f4(e4), mR0), u(f4(e4), _R0), o(f4(e4), hR0, yR0);
              var c = i4[2];
              if (c) {
                g(e4, dR0);
                var s2 = c[1], p = function(w) {
                  return u(n, w);
                }, y = function(w) {
                  return u(t4, w);
                };
                R(Rn[1], y, p, e4, s2), g(e4, kR0);
              } else
                g(e4, wR0);
              u(f4(e4), ER0), u(f4(e4), SR0), o(f4(e4), FR0, gR0);
              var T = i4[3];
              function E(w) {
                return u(n, w);
              }
              function d(w) {
                return u(t4, w);
              }
              return R(Rn[1], d, E, e4, T), u(f4(e4), TR0), u(f4(e4), OR0);
            }), N(_$, function(t4, n, e4) {
              var i4 = o(q5, t4, n);
              return o(C0(aR0), i4, e4);
            }), N(EP, function(t4, n, e4, i4) {
              u(f4(e4), AL0), o(f4(e4), CL0, NL0), o(Al, e4, i4[1]), u(f4(e4), PL0), u(f4(e4), DL0), o(f4(e4), RL0, LL0);
              var x4 = i4[2];
              u(f4(e4), jL0), o(t4, e4, x4[1]), u(f4(e4), GL0);
              var c = x4[2];
              function s2(V) {
                return u(t4, V);
              }
              ur(g1[1], s2, e4, c), u(f4(e4), ML0), u(f4(e4), BL0), u(f4(e4), qL0), o(f4(e4), HL0, UL0);
              var p = i4[3];
              if (p) {
                g(e4, XL0);
                var y = p[1], T = function(V) {
                  return u(n, V);
                }, E = function(V) {
                  return u(t4, V);
                };
                R(Rn[1], E, T, e4, y), g(e4, YL0);
              } else
                g(e4, VL0);
              u(f4(e4), zL0), u(f4(e4), KL0), o(f4(e4), JL0, WL0);
              var d = i4[4];
              if (d) {
                g(e4, $L0);
                var w = d[1], G = function(V) {
                  return u(n, V);
                };
                R(B5, function(V) {
                  return u(t4, V);
                }, G, e4, w), g(e4, ZL0);
              } else
                g(e4, QL0);
              u(f4(e4), rR0), u(f4(e4), eR0), o(f4(e4), tR0, nR0);
              var A11 = i4[5];
              if (A11) {
                g(e4, uR0);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, IL0);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, iR0);
              } else
                g(e4, fR0);
              return u(f4(e4), xR0), u(f4(e4), oR0);
            }), N(y$, function(t4, n, e4) {
              var i4 = o(EP, t4, n);
              return o(C0(OL0), i4, e4);
            });
            var h$ = [0, Al, p$, B5, m$, q5, _$, EP, y$], SP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, d$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(SP, function(t4, n, e4, i4) {
              u(f4(e4), oL0), o(f4(e4), cL0, aL0);
              var x4 = i4[1];
              function c(G) {
                return u(n, G);
              }
              function s2(G) {
                return u(t4, G);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), sL0), u(f4(e4), vL0), o(f4(e4), bL0, lL0);
              var p = i4[2];
              if (p) {
                g(e4, pL0);
                var y = p[1];
                o(f4(e4), mL0, y), g(e4, _L0);
              } else
                g(e4, yL0);
              u(f4(e4), hL0), u(f4(e4), dL0), o(f4(e4), wL0, kL0);
              var T = i4[3];
              if (T) {
                g(e4, EL0);
                var E = T[1], d = function(G, A11) {
                  return g(G, xL0);
                }, w = function(G) {
                  return u(t4, G);
                };
                R(Dr[1], w, d, e4, E), g(e4, SL0);
              } else
                g(e4, gL0);
              return u(f4(e4), FL0), u(f4(e4), TL0);
            }), N(d$, function(t4, n, e4) {
              var i4 = o(SP, t4, n);
              return o(C0(fL0), i4, e4);
            });
            var k$ = [0, SP, d$], gP = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, w$ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(gP, function(t4, n, e4) {
              u(f4(n), ZD0), o(f4(n), rL0, QD0);
              var i4 = e4[1];
              if (i4) {
                g(n, eL0);
                var x4 = i4[1], c = function(p, y) {
                  return g(p, $D0);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                R(Dr[1], s2, c, n, x4), g(n, nL0);
              } else
                g(n, tL0);
              return u(f4(n), uL0), u(f4(n), iL0);
            }), N(w$, function(t4, n) {
              var e4 = u(gP, t4);
              return o(C0(JD0), e4, n);
            });
            var E$ = [0, gP, w$], FP = function t4(n, e4) {
              return t4.fun(n, e4);
            }, S$ = function t4(n) {
              return t4.fun(n);
            }, TP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, g$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, U5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, F$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(FP, function(t4, n) {
              return n ? g(t4, KD0) : g(t4, WD0);
            }), N(S$, function(t4) {
              return o(C0(zD0), FP, t4);
            }), N(TP, function(t4, n, e4, i4) {
              u(f4(e4), XD0), o(t4, e4, i4[1]), u(f4(e4), YD0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(U5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), VD0);
            }), N(g$, function(t4, n, e4) {
              var i4 = o(TP, t4, n);
              return o(C0(HD0), i4, e4);
            }), N(U5, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), EP0);
                  var x4 = i4[1], c = function(h0) {
                    return u(n, h0);
                  }, s2 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(Kv[1], s2, c, e4, x4), u(f4(e4), SP0);
                case 1:
                  u(f4(e4), gP0);
                  var p = i4[1], y = function(h0) {
                    return u(t4, h0);
                  };
                  return ur(UW[1], y, e4, p), u(f4(e4), FP0);
                case 2:
                  u(f4(e4), TP0);
                  var T = i4[1], E = function(h0) {
                    return u(n, h0);
                  }, d = function(h0) {
                    return u(t4, h0);
                  };
                  return R(F1[8], d, E, e4, T), u(f4(e4), OP0);
                case 3:
                  u(f4(e4), IP0);
                  var w = i4[1], G = function(h0) {
                    return u(t4, h0);
                  };
                  return ur(XW[1], G, e4, w), u(f4(e4), AP0);
                case 4:
                  u(f4(e4), NP0);
                  var A11 = i4[1], S11 = function(h0) {
                    return u(t4, h0);
                  };
                  return ur(VW[1], S11, e4, A11), u(f4(e4), CP0);
                case 5:
                  u(f4(e4), PP0);
                  var M = i4[1], K = function(h0) {
                    return u(n, h0);
                  }, V = function(h0) {
                    return u(t4, h0);
                  };
                  return R(cP[1], V, K, e4, M), u(f4(e4), DP0);
                case 6:
                  u(f4(e4), LP0);
                  var f0 = i4[1], m0 = function(h0) {
                    return u(n, h0);
                  }, k0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(b$[3], k0, m0, e4, f0), u(f4(e4), RP0);
                case 7:
                  u(f4(e4), jP0);
                  var g0 = i4[1], e0 = function(h0) {
                    return u(n, h0);
                  }, x0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(bP[1], x0, e0, e4, g0), u(f4(e4), GP0);
                case 8:
                  u(f4(e4), MP0);
                  var l = i4[1], c0 = function(h0) {
                    return u(n, h0);
                  }, t0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(P5[1], t0, c0, e4, l), u(f4(e4), BP0);
                case 9:
                  u(f4(e4), qP0);
                  var o0 = i4[1], w0 = function(h0) {
                    return u(n, h0);
                  }, _0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(QJ[5], _0, w0, e4, o0), u(f4(e4), UP0);
                case 10:
                  u(f4(e4), HP0);
                  var E0 = i4[1], U0 = function(h0) {
                    return u(n, h0);
                  }, b = function(h0) {
                    return u(t4, h0);
                  };
                  return R(e$[1], b, U0, e4, E0), u(f4(e4), XP0);
                case 11:
                  u(f4(e4), YP0);
                  var R0 = i4[1], X = function(h0) {
                    return u(n, h0);
                  }, s0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(y5[1], s0, X, e4, R0), u(f4(e4), VP0);
                case 12:
                  u(f4(e4), zP0);
                  var hr = i4[1], Ar = function(h0) {
                    return u(n, h0);
                  }, or = function(h0) {
                    return u(t4, h0);
                  };
                  return R(h5[1], or, Ar, e4, hr), u(f4(e4), KP0);
                case 13:
                  u(f4(e4), WP0);
                  var W0 = i4[1], Lr = function(h0) {
                    return u(n, h0);
                  }, Tr = function(h0) {
                    return u(t4, h0);
                  };
                  return R(vP[1], Tr, Lr, e4, W0), u(f4(e4), JP0);
                case 14:
                  u(f4(e4), $P0);
                  var Hr = i4[1], Or = function(h0) {
                    return u(n, h0);
                  }, fr = function(h0) {
                    return u(t4, h0);
                  };
                  return R(hJ[1], fr, Or, e4, Hr), u(f4(e4), ZP0);
                case 15:
                  u(f4(e4), QP0);
                  var Rr = i4[1], Wr = function(h0) {
                    return u(t4, h0);
                  };
                  return ur(E$[1], Wr, e4, Rr), u(f4(e4), rD0);
                case 16:
                  u(f4(e4), eD0);
                  var Jr = i4[1], ar = function(h0) {
                    return u(n, h0);
                  }, _r = function(h0) {
                    return u(t4, h0);
                  };
                  return R(YJ[7], _r, ar, e4, Jr), u(f4(e4), nD0);
                case 17:
                  u(f4(e4), tD0);
                  var Ir = i4[1], fe = function(h0) {
                    return u(n, h0);
                  }, v0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(s$[1], v0, fe, e4, Ir), u(f4(e4), uD0);
                case 18:
                  u(f4(e4), iD0);
                  var P = i4[1], L = function(h0) {
                    return u(n, h0);
                  }, Q = function(h0) {
                    return u(t4, h0);
                  };
                  return R(dP[3], Q, L, e4, P), u(f4(e4), fD0);
                case 19:
                  u(f4(e4), xD0);
                  var i0 = i4[1], l0 = function(h0) {
                    return u(n, h0);
                  }, S0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(k$[1], S0, l0, e4, i0), u(f4(e4), oD0);
                case 20:
                  u(f4(e4), aD0);
                  var T0 = i4[1], rr = function(h0) {
                    return u(n, h0);
                  }, L0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(wJ[1], L0, rr, e4, T0), u(f4(e4), cD0);
                case 21:
                  u(f4(e4), sD0);
                  var B = i4[1], Z7 = function(h0) {
                    return u(n, h0);
                  }, p0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(gJ[1], p0, Z7, e4, B), u(f4(e4), vD0);
                case 22:
                  u(f4(e4), lD0);
                  var b0 = i4[1], O0 = function(h0) {
                    return u(n, h0);
                  }, M0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(OJ[1], M0, O0, e4, b0), u(f4(e4), bD0);
                case 23:
                  u(f4(e4), pD0);
                  var er = i4[1], yr = function(h0) {
                    return u(n, h0);
                  }, vr = function(h0) {
                    return u(t4, h0);
                  };
                  return R(As[5], vr, yr, e4, er), u(f4(e4), mD0);
                case 24:
                  u(f4(e4), _D0);
                  var $0 = i4[1], Er = function(h0) {
                    return u(n, h0);
                  }, Mr = function(h0) {
                    return u(t4, h0);
                  };
                  return R(GW[2], Mr, Er, e4, $0), u(f4(e4), yD0);
                case 25:
                  u(f4(e4), hD0);
                  var Br = i4[1], qr = function(h0) {
                    return u(n, h0);
                  }, jr = function(h0) {
                    return u(t4, h0);
                  };
                  return R(h$[7], jr, qr, e4, Br), u(f4(e4), dD0);
                case 26:
                  u(f4(e4), kD0);
                  var $r = i4[1], ne = function(h0) {
                    return u(n, h0);
                  }, Qr = function(h0) {
                    return u(t4, h0);
                  };
                  return R(P5[1], Qr, ne, e4, $r), u(f4(e4), wD0);
                case 27:
                  u(f4(e4), ED0);
                  var be = i4[1], ae = function(h0) {
                    return u(n, h0);
                  }, pe = function(h0) {
                    return u(t4, h0);
                  };
                  return R(BW[1], pe, ae, e4, be), u(f4(e4), SD0);
                case 28:
                  u(f4(e4), gD0);
                  var oe = i4[1], ce = function(h0) {
                    return u(n, h0);
                  }, ge = function(h0) {
                    return u(t4, h0);
                  };
                  return R(tJ[1], ge, ce, e4, oe), u(f4(e4), FD0);
                case 29:
                  u(f4(e4), TD0);
                  var q0 = i4[1], Fr = function(h0) {
                    return u(n, h0);
                  }, _ = function(h0) {
                    return u(t4, h0);
                  };
                  return R(eJ[2], _, Fr, e4, q0), u(f4(e4), OD0);
                case 30:
                  u(f4(e4), ID0);
                  var k = i4[1], I = function(h0) {
                    return u(n, h0);
                  }, U = function(h0) {
                    return u(t4, h0);
                  };
                  return R(iJ[1], U, I, e4, k), u(f4(e4), AD0);
                case 31:
                  u(f4(e4), ND0);
                  var Y = i4[1], y0 = function(h0) {
                    return u(n, h0);
                  }, P0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(cJ[2], P0, y0, e4, Y), u(f4(e4), CD0);
                case 32:
                  u(f4(e4), PD0);
                  var I0 = i4[1], D = function(h0) {
                    return u(n, h0);
                  }, u0 = function(h0) {
                    return u(t4, h0);
                  };
                  return R(y5[1], u0, D, e4, I0), u(f4(e4), DD0);
                case 33:
                  u(f4(e4), LD0);
                  var X0 = i4[1], J0 = function(h0) {
                    return u(n, h0);
                  }, ir = function(h0) {
                    return u(t4, h0);
                  };
                  return R(h5[1], ir, J0, e4, X0), u(f4(e4), RD0);
                case 34:
                  u(f4(e4), jD0);
                  var Q0 = i4[1], F0 = function(h0) {
                    return u(n, h0);
                  }, Sr = function(h0) {
                    return u(t4, h0);
                  };
                  return R(Il[2], Sr, F0, e4, Q0), u(f4(e4), GD0);
                case 35:
                  u(f4(e4), MD0);
                  var mr = i4[1], Cr = function(h0) {
                    return u(n, h0);
                  }, sr = function(h0) {
                    return u(t4, h0);
                  };
                  return R(_J[1], sr, Cr, e4, mr), u(f4(e4), BD0);
                default:
                  u(f4(e4), qD0);
                  var Pr = i4[1], K0 = function(h0) {
                    return u(n, h0);
                  }, Ur = function(h0) {
                    return u(t4, h0);
                  };
                  return R(KW[1], Ur, K0, e4, Pr), u(f4(e4), UD0);
              }
            }), N(F$, function(t4, n, e4) {
              var i4 = o(U5, t4, n);
              return o(C0(wP0), i4, e4);
            }), mu(W3r, Yu, [0, Kv, GW, BW, UW, XW, VW, KW, y5, h5, eJ, tJ, iJ, cJ, Il, _J, hJ, wJ, gJ, OJ, YJ, P5, cP, vP, bP, QJ, e$, dP, s$, b$, h$, k$, E$, FP, S$, TP, g$, U5, F$]);
            var OP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, T$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, H5 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, O$ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(OP, function(t4, n, e4, i4) {
              u(f4(e4), hP0), o(n, e4, i4[1]), u(f4(e4), dP0);
              var x4 = i4[2];
              return ur(H5, function(c) {
                return u(t4, c);
              }, e4, x4), u(f4(e4), kP0);
            }), N(T$, function(t4, n, e4) {
              var i4 = o(OP, t4, n);
              return o(C0(yP0), i4, e4);
            }), N(H5, function(t4, n, e4) {
              u(f4(n), cP0), o(f4(n), vP0, sP0);
              var i4 = e4[1];
              if (i4) {
                g(n, lP0);
                var x4 = i4[1], c = function(p, y) {
                  return g(p, aP0);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                R(Dr[1], s2, c, n, x4), g(n, bP0);
              } else
                g(n, pP0);
              return u(f4(n), mP0), u(f4(n), _P0);
            }), N(O$, function(t4, n) {
              var e4 = u(H5, t4);
              return o(C0(oP0), e4, n);
            });
            var I$ = [0, OP, T$, H5, O$], IP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, A$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(IP, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), uP0);
                var x4 = i4[1], c = function(E) {
                  return u(n, E);
                }, s2 = function(E) {
                  return u(t4, E);
                };
                return R($e[13], s2, c, e4, x4), u(f4(e4), iP0);
              }
              u(f4(e4), fP0);
              var p = i4[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(I$[1], T, y, e4, p), u(f4(e4), xP0);
            }), N(A$, function(t4, n, e4) {
              var i4 = o(IP, t4, n);
              return o(C0(tP0), i4, e4);
            });
            var N$ = [0, I$, IP, A$], AP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, C$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, X5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, P$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(AP, function(t4, n, e4, i4) {
              u(f4(e4), rP0), o(t4, e4, i4[1]), u(f4(e4), eP0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(X5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), nP0);
            }), N(C$, function(t4, n, e4) {
              var i4 = o(AP, t4, n);
              return o(C0(QC0), i4, e4);
            }), N(X5, function(t4, n, e4, i4) {
              u(f4(e4), MC0), o(f4(e4), qC0, BC0);
              var x4 = i4[1];
              u(f4(e4), UC0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), GC0);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R(N$[2], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), HC0), u(f4(e4), XC0), u(f4(e4), YC0), o(f4(e4), zC0, VC0);
              var s2 = i4[2];
              if (s2) {
                g(e4, KC0);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), RC0);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), LC0);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), jC0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, WC0);
              } else
                g(e4, JC0);
              return u(f4(e4), $C0), u(f4(e4), ZC0);
            }), N(P$, function(t4, n, e4) {
              var i4 = o(X5, t4, n);
              return o(C0(DC0), i4, e4);
            });
            var NP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, D$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Y5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, L$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, See = [0, AP, C$, X5, P$];
            N(NP, function(t4, n, e4, i4) {
              u(f4(e4), NC0), o(t4, e4, i4[1]), u(f4(e4), CC0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Y5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), PC0);
            }), N(D$, function(t4, n, e4) {
              var i4 = o(NP, t4, n);
              return o(C0(AC0), i4, e4);
            }), N(Y5, function(t4, n, e4, i4) {
              u(f4(e4), yC0), o(f4(e4), dC0, hC0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), kC0), u(f4(e4), wC0), o(f4(e4), SC0, EC0);
              var p = i4[2];
              if (p) {
                g(e4, gC0);
                var y = p[1], T = function(d, w) {
                  return g(d, _C0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, FC0);
              } else
                g(e4, TC0);
              return u(f4(e4), OC0), u(f4(e4), IC0);
            }), N(L$, function(t4, n, e4) {
              var i4 = o(Y5, t4, n);
              return o(C0(mC0), i4, e4);
            });
            var CP = [0, NP, D$, Y5, L$], V5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, R$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(V5, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), cC0);
                  var x4 = i4[1], c = function(E) {
                    return u(n, E);
                  }, s2 = function(E) {
                    return u(t4, E);
                  };
                  return R(qe[31], s2, c, e4, x4), u(f4(e4), sC0);
                case 1:
                  u(f4(e4), vC0);
                  var p = i4[1], y = function(E) {
                    return u(n, E);
                  }, T = function(E) {
                    return u(t4, E);
                  };
                  return R(CP[1], T, y, e4, p), u(f4(e4), lC0);
                default:
                  return u(f4(e4), bC0), o(t4, e4, i4[1]), u(f4(e4), pC0);
              }
            }), N(R$, function(t4, n, e4) {
              var i4 = o(V5, t4, n);
              return o(C0(aC0), i4, e4);
            });
            var PP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, j$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(PP, function(t4, n, e4, i4) {
              u(f4(e4), WN0), o(f4(e4), $N0, JN0);
              var x4 = i4[1];
              u(f4(e4), ZN0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), KN0);
                function w(G) {
                  return u(n, G);
                }
                return R(V5, function(G) {
                  return u(t4, G);
                }, w, e4, d), 1;
              }, c, x4), u(f4(e4), QN0), u(f4(e4), rC0), u(f4(e4), eC0), o(f4(e4), tC0, nC0);
              var s2 = i4[2];
              if (s2) {
                g(e4, uC0);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), VN0);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), YN0);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), zN0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, iC0);
              } else
                g(e4, fC0);
              return u(f4(e4), xC0), u(f4(e4), oC0);
            }), N(j$, function(t4, n, e4) {
              var i4 = o(PP, t4, n);
              return o(C0(XN0), i4, e4);
            });
            var G$ = [0, V5, R$, PP, j$], z5 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, M$ = function t4(n) {
              return t4.fun(n);
            }, DP = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, B$ = function t4(n, e4) {
              return t4.fun(n, e4);
            }, K5 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, q$ = function t4(n) {
              return t4.fun(n);
            };
            N(z5, function(t4, n) {
              u(f4(t4), PN0), o(f4(t4), LN0, DN0);
              var e4 = n[1];
              o(f4(t4), RN0, e4), u(f4(t4), jN0), u(f4(t4), GN0), o(f4(t4), BN0, MN0);
              var i4 = n[2];
              return o(f4(t4), qN0, i4), u(f4(t4), UN0), u(f4(t4), HN0);
            }), N(M$, function(t4) {
              return o(C0(CN0), z5, t4);
            }), N(DP, function(t4, n, e4) {
              return u(f4(n), IN0), o(t4, n, e4[1]), u(f4(n), AN0), o(K5, n, e4[2]), u(f4(n), NN0);
            }), N(B$, function(t4, n) {
              var e4 = u(DP, t4);
              return o(C0(ON0), e4, n);
            }), N(K5, function(t4, n) {
              u(f4(t4), yN0), o(f4(t4), dN0, hN0), o(z5, t4, n[1]), u(f4(t4), kN0), u(f4(t4), wN0), o(f4(t4), SN0, EN0);
              var e4 = n[2];
              return o(f4(t4), gN0, e4), u(f4(t4), FN0), u(f4(t4), TN0);
            }), N(q$, function(t4) {
              return o(C0(_N0), K5, t4);
            });
            var U$ = [0, z5, M$, DP, B$, K5, q$], LP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, H$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(LP, function(t4, n, e4, i4) {
              u(f4(e4), $A0), o(f4(e4), QA0, ZA0);
              var x4 = i4[1];
              u(f4(e4), rN0);
              var c = 0;
              le(function(w, G) {
                w && u(f4(e4), JA0);
                function A11(S11) {
                  return u(t4, S11);
                }
                return ur(U$[3], A11, e4, G), 1;
              }, c, x4), u(f4(e4), eN0), u(f4(e4), nN0), u(f4(e4), tN0), o(f4(e4), iN0, uN0);
              var s2 = i4[2];
              u(f4(e4), fN0);
              var p = 0;
              le(function(w, G) {
                w && u(f4(e4), WA0);
                function A11(M) {
                  return u(n, M);
                }
                function S11(M) {
                  return u(t4, M);
                }
                return R(qe[31], S11, A11, e4, G), 1;
              }, p, s2), u(f4(e4), xN0), u(f4(e4), oN0), u(f4(e4), aN0), o(f4(e4), sN0, cN0);
              var y = i4[3];
              if (y) {
                g(e4, vN0);
                var T = y[1], E = function(w, G) {
                  return g(w, KA0);
                }, d = function(w) {
                  return u(t4, w);
                };
                R(Dr[1], d, E, e4, T), g(e4, lN0);
              } else
                g(e4, bN0);
              return u(f4(e4), pN0), u(f4(e4), mN0);
            }), N(H$, function(t4, n, e4) {
              var i4 = o(LP, t4, n);
              return o(C0(zA0), i4, e4);
            });
            var RP = [0, U$, LP, H$], jP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, X$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(jP, function(t4, n, e4, i4) {
              u(f4(e4), OA0), o(f4(e4), AA0, IA0);
              var x4 = i4[1];
              function c(S11) {
                return u(n, S11);
              }
              function s2(S11) {
                return u(t4, S11);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), NA0), u(f4(e4), CA0), o(f4(e4), DA0, PA0);
              var p = i4[2];
              u(f4(e4), LA0), o(t4, e4, p[1]), u(f4(e4), RA0);
              var y = p[2];
              function T(S11) {
                return u(n, S11);
              }
              function E(S11) {
                return u(t4, S11);
              }
              R(RP[2], E, T, e4, y), u(f4(e4), jA0), u(f4(e4), GA0), u(f4(e4), MA0), o(f4(e4), qA0, BA0);
              var d = i4[3];
              if (d) {
                g(e4, UA0);
                var w = d[1], G = function(S11, M) {
                  return g(S11, TA0);
                }, A11 = function(S11) {
                  return u(t4, S11);
                };
                R(Dr[1], A11, G, e4, w), g(e4, HA0);
              } else
                g(e4, XA0);
              return u(f4(e4), YA0), u(f4(e4), VA0);
            }), N(X$, function(t4, n, e4) {
              var i4 = o(jP, t4, n);
              return o(C0(FA0), i4, e4);
            });
            var Y$ = [0, jP, X$], T1 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, V$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, GP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, z$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, W5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, K$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(T1, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  var x4 = i4[1];
                  u(f4(e4), pA0), u(f4(e4), mA0), o(n, e4, x4[1]), u(f4(e4), _A0);
                  var c = x4[2], s2 = function(S11) {
                    return u(t4, S11);
                  };
                  return ur(Tl[2], s2, e4, c), u(f4(e4), yA0), u(f4(e4), hA0);
                case 1:
                  u(f4(e4), dA0);
                  var p = i4[1], y = function(S11) {
                    return u(n, S11);
                  }, T = function(S11) {
                    return u(t4, S11);
                  };
                  return R(Rn[1], T, y, e4, p), u(f4(e4), kA0);
                case 2:
                  u(f4(e4), wA0);
                  var E = i4[1], d = function(S11) {
                    return u(t4, S11);
                  };
                  return ur(Bp[1], d, e4, E), u(f4(e4), EA0);
                default:
                  u(f4(e4), SA0);
                  var w = i4[1], G = function(S11) {
                    return u(n, S11);
                  }, A11 = function(S11) {
                    return u(t4, S11);
                  };
                  return R(qp[1], A11, G, e4, w), u(f4(e4), gA0);
              }
            }), N(V$, function(t4, n, e4) {
              var i4 = o(T1, t4, n);
              return o(C0(bA0), i4, e4);
            }), N(GP, function(t4, n, e4, i4) {
              u(f4(e4), sA0), o(t4, e4, i4[1]), u(f4(e4), vA0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(W5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), lA0);
            }), N(z$, function(t4, n, e4) {
              var i4 = o(GP, t4, n);
              return o(C0(cA0), i4, e4);
            }), N(W5, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), rI0), o(f4(e4), nI0, eI0);
                  var x4 = i4[1], c = function(s0) {
                    return u(n, s0);
                  };
                  R(T1, function(s0) {
                    return u(t4, s0);
                  }, c, e4, x4), u(f4(e4), tI0), u(f4(e4), uI0), o(f4(e4), fI0, iI0);
                  var s2 = i4[2], p = function(s0) {
                    return u(n, s0);
                  }, y = function(s0) {
                    return u(t4, s0);
                  };
                  R(qe[31], y, p, e4, s2), u(f4(e4), xI0), u(f4(e4), oI0), o(f4(e4), cI0, aI0);
                  var T = i4[3];
                  return o(f4(e4), sI0, T), u(f4(e4), vI0), u(f4(e4), lI0);
                case 1:
                  var E = i4[2];
                  u(f4(e4), bI0), o(f4(e4), mI0, pI0);
                  var d = i4[1], w = function(s0) {
                    return u(n, s0);
                  };
                  R(T1, function(s0) {
                    return u(t4, s0);
                  }, w, e4, d), u(f4(e4), _I0), u(f4(e4), yI0), o(f4(e4), dI0, hI0), u(f4(e4), kI0), o(t4, e4, E[1]), u(f4(e4), wI0);
                  var G = E[2], A11 = function(s0) {
                    return u(n, s0);
                  }, S11 = function(s0) {
                    return u(t4, s0);
                  };
                  return R(As[5], S11, A11, e4, G), u(f4(e4), EI0), u(f4(e4), SI0), u(f4(e4), gI0);
                case 2:
                  var M = i4[3], K = i4[2];
                  u(f4(e4), FI0), o(f4(e4), OI0, TI0);
                  var V = i4[1], f0 = function(s0) {
                    return u(n, s0);
                  };
                  R(T1, function(s0) {
                    return u(t4, s0);
                  }, f0, e4, V), u(f4(e4), II0), u(f4(e4), AI0), o(f4(e4), CI0, NI0), u(f4(e4), PI0), o(t4, e4, K[1]), u(f4(e4), DI0);
                  var m0 = K[2], k0 = function(s0) {
                    return u(n, s0);
                  }, g0 = function(s0) {
                    return u(t4, s0);
                  };
                  if (R(As[5], g0, k0, e4, m0), u(f4(e4), LI0), u(f4(e4), RI0), u(f4(e4), jI0), o(f4(e4), MI0, GI0), M) {
                    g(e4, BI0);
                    var e0 = M[1], x0 = function(s0, hr) {
                      return g(s0, QO0);
                    }, l = function(s0) {
                      return u(t4, s0);
                    };
                    R(Dr[1], l, x0, e4, e0), g(e4, qI0);
                  } else
                    g(e4, UI0);
                  return u(f4(e4), HI0), u(f4(e4), XI0);
                default:
                  var c0 = i4[3], t0 = i4[2];
                  u(f4(e4), YI0), o(f4(e4), zI0, VI0);
                  var o0 = i4[1], w0 = function(s0) {
                    return u(n, s0);
                  };
                  R(T1, function(s0) {
                    return u(t4, s0);
                  }, w0, e4, o0), u(f4(e4), KI0), u(f4(e4), WI0), o(f4(e4), $I0, JI0), u(f4(e4), ZI0), o(t4, e4, t0[1]), u(f4(e4), QI0);
                  var _0 = t0[2], E0 = function(s0) {
                    return u(n, s0);
                  }, U0 = function(s0) {
                    return u(t4, s0);
                  };
                  if (R(As[5], U0, E0, e4, _0), u(f4(e4), rA0), u(f4(e4), eA0), u(f4(e4), nA0), o(f4(e4), uA0, tA0), c0) {
                    g(e4, iA0);
                    var b = c0[1], R0 = function(s0, hr) {
                      return g(s0, ZO0);
                    }, X = function(s0) {
                      return u(t4, s0);
                    };
                    R(Dr[1], X, R0, e4, b), g(e4, fA0);
                  } else
                    g(e4, xA0);
                  return u(f4(e4), oA0), u(f4(e4), aA0);
              }
            }), N(K$, function(t4, n, e4) {
              var i4 = o(W5, t4, n);
              return o(C0($O0), i4, e4);
            });
            var W$ = [0, T1, V$, GP, z$, W5, K$], MP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, J$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, J5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, $$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(MP, function(t4, n, e4, i4) {
              u(f4(e4), KO0), o(t4, e4, i4[1]), u(f4(e4), WO0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(J5, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), JO0);
            }), N(J$, function(t4, n, e4) {
              var i4 = o(MP, t4, n);
              return o(C0(zO0), i4, e4);
            }), N(J5, function(t4, n, e4, i4) {
              u(f4(e4), LO0), o(f4(e4), jO0, RO0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), GO0), u(f4(e4), MO0), o(f4(e4), qO0, BO0);
              var p = i4[2];
              if (p) {
                g(e4, UO0);
                var y = p[1], T = function(d, w) {
                  return g(d, DO0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, HO0);
              } else
                g(e4, XO0);
              return u(f4(e4), YO0), u(f4(e4), VO0);
            }), N($$, function(t4, n, e4) {
              var i4 = o(J5, t4, n);
              return o(C0(PO0), i4, e4);
            });
            var Z$ = [0, MP, J$, J5, $$], $5 = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, Q$ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, BP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, rZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N($5, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), IO0);
                var x4 = i4[1], c = function(E) {
                  return u(n, E);
                }, s2 = function(E) {
                  return u(t4, E);
                };
                return R(W$[3], s2, c, e4, x4), u(f4(e4), AO0);
              }
              u(f4(e4), NO0);
              var p = i4[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(Z$[1], T, y, e4, p), u(f4(e4), CO0);
            }), N(Q$, function(t4, n, e4) {
              var i4 = o($5, t4, n);
              return o(C0(OO0), i4, e4);
            }), N(BP, function(t4, n, e4, i4) {
              u(f4(e4), bO0), o(f4(e4), mO0, pO0);
              var x4 = i4[1];
              u(f4(e4), _O0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), lO0);
                function w(G) {
                  return u(n, G);
                }
                return R($5, function(G) {
                  return u(t4, G);
                }, w, e4, d), 1;
              }, c, x4), u(f4(e4), yO0), u(f4(e4), hO0), u(f4(e4), dO0), o(f4(e4), wO0, kO0);
              var s2 = i4[2];
              if (s2) {
                g(e4, EO0);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), sO0);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), cO0);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), vO0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, SO0);
              } else
                g(e4, gO0);
              return u(f4(e4), FO0), u(f4(e4), TO0);
            }), N(rZ, function(t4, n, e4) {
              var i4 = o(BP, t4, n);
              return o(C0(aO0), i4, e4);
            });
            var eZ = [0, W$, Z$, $5, Q$, BP, rZ], qP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, nZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(qP, function(t4, n, e4, i4) {
              u(f4(e4), WT0), o(f4(e4), $T0, JT0);
              var x4 = i4[1];
              u(f4(e4), ZT0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), KT0);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R(qe[31], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), QT0), u(f4(e4), rO0), u(f4(e4), eO0), o(f4(e4), tO0, nO0);
              var s2 = i4[2];
              if (s2) {
                g(e4, uO0);
                var p = s2[1], y = function(E, d) {
                  return g(E, zT0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, iO0);
              } else
                g(e4, fO0);
              return u(f4(e4), xO0), u(f4(e4), oO0);
            }), N(nZ, function(t4, n, e4) {
              var i4 = o(qP, t4, n);
              return o(C0(VT0), i4, e4);
            });
            var tZ = [0, qP, nZ], Z5 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, uZ = function t4(n) {
              return t4.fun(n);
            }, UP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, iZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(Z5, function(t4, n) {
              switch (n) {
                case 0:
                  return g(t4, GT0);
                case 1:
                  return g(t4, MT0);
                case 2:
                  return g(t4, BT0);
                case 3:
                  return g(t4, qT0);
                case 4:
                  return g(t4, UT0);
                case 5:
                  return g(t4, HT0);
                case 6:
                  return g(t4, XT0);
                default:
                  return g(t4, YT0);
              }
            }), N(uZ, function(t4) {
              return o(C0(jT0), Z5, t4);
            }), N(UP, function(t4, n, e4, i4) {
              u(f4(e4), kT0), o(f4(e4), ET0, wT0), o(Z5, e4, i4[1]), u(f4(e4), ST0), u(f4(e4), gT0), o(f4(e4), TT0, FT0);
              var x4 = i4[2];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), OT0), u(f4(e4), IT0), o(f4(e4), NT0, AT0);
              var p = i4[3];
              if (p) {
                g(e4, CT0);
                var y = p[1], T = function(d, w) {
                  return g(d, dT0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, PT0);
              } else
                g(e4, DT0);
              return u(f4(e4), LT0), u(f4(e4), RT0);
            }), N(iZ, function(t4, n, e4) {
              var i4 = o(UP, t4, n);
              return o(C0(hT0), i4, e4);
            });
            var fZ = [0, Z5, uZ, UP, iZ], Q5 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, xZ = function t4(n) {
              return t4.fun(n);
            }, HP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, oZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(Q5, function(t4, n) {
              switch (n) {
                case 0:
                  return g(t4, $F0);
                case 1:
                  return g(t4, ZF0);
                case 2:
                  return g(t4, QF0);
                case 3:
                  return g(t4, rT0);
                case 4:
                  return g(t4, eT0);
                case 5:
                  return g(t4, nT0);
                case 6:
                  return g(t4, tT0);
                case 7:
                  return g(t4, uT0);
                case 8:
                  return g(t4, iT0);
                case 9:
                  return g(t4, fT0);
                case 10:
                  return g(t4, xT0);
                case 11:
                  return g(t4, oT0);
                case 12:
                  return g(t4, aT0);
                case 13:
                  return g(t4, cT0);
                case 14:
                  return g(t4, sT0);
                case 15:
                  return g(t4, vT0);
                case 16:
                  return g(t4, lT0);
                case 17:
                  return g(t4, bT0);
                case 18:
                  return g(t4, pT0);
                case 19:
                  return g(t4, mT0);
                case 20:
                  return g(t4, _T0);
                default:
                  return g(t4, yT0);
              }
            }), N(xZ, function(t4) {
              return o(C0(JF0), Q5, t4);
            }), N(HP, function(t4, n, e4, i4) {
              u(f4(e4), AF0), o(f4(e4), CF0, NF0), o(Q5, e4, i4[1]), u(f4(e4), PF0), u(f4(e4), DF0), o(f4(e4), RF0, LF0);
              var x4 = i4[2];
              function c(A11) {
                return u(n, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), jF0), u(f4(e4), GF0), o(f4(e4), BF0, MF0);
              var p = i4[3];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R(qe[31], T, y, e4, p), u(f4(e4), qF0), u(f4(e4), UF0), o(f4(e4), XF0, HF0);
              var E = i4[4];
              if (E) {
                g(e4, YF0);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, IF0);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, VF0);
              } else
                g(e4, zF0);
              return u(f4(e4), KF0), u(f4(e4), WF0);
            }), N(oZ, function(t4, n, e4) {
              var i4 = o(HP, t4, n);
              return o(C0(OF0), i4, e4);
            });
            var aZ = [0, Q5, xZ, HP, oZ], rm = function t4(n, e4) {
              return t4.fun(n, e4);
            }, cZ = function t4(n) {
              return t4.fun(n);
            }, XP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, sZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(rm, function(t4, n) {
              switch (n) {
                case 0:
                  return g(t4, lF0);
                case 1:
                  return g(t4, bF0);
                case 2:
                  return g(t4, pF0);
                case 3:
                  return g(t4, mF0);
                case 4:
                  return g(t4, _F0);
                case 5:
                  return g(t4, yF0);
                case 6:
                  return g(t4, hF0);
                case 7:
                  return g(t4, dF0);
                case 8:
                  return g(t4, kF0);
                case 9:
                  return g(t4, wF0);
                case 10:
                  return g(t4, EF0);
                case 11:
                  return g(t4, SF0);
                case 12:
                  return g(t4, gF0);
                case 13:
                  return g(t4, FF0);
                default:
                  return g(t4, TF0);
              }
            }), N(cZ, function(t4) {
              return o(C0(vF0), rm, t4);
            }), N(XP, function(t4, n, e4, i4) {
              u(f4(e4), Hg0), o(f4(e4), Yg0, Xg0);
              var x4 = i4[1];
              x4 ? (g(e4, Vg0), o(rm, e4, x4[1]), g(e4, zg0)) : g(e4, Kg0), u(f4(e4), Wg0), u(f4(e4), Jg0), o(f4(e4), Zg0, $g0);
              var c = i4[2];
              function s2(S11) {
                return u(n, S11);
              }
              function p(S11) {
                return u(t4, S11);
              }
              R(di[5], p, s2, e4, c), u(f4(e4), Qg0), u(f4(e4), rF0), o(f4(e4), nF0, eF0);
              var y = i4[3];
              function T(S11) {
                return u(n, S11);
              }
              function E(S11) {
                return u(t4, S11);
              }
              R(qe[31], E, T, e4, y), u(f4(e4), tF0), u(f4(e4), uF0), o(f4(e4), fF0, iF0);
              var d = i4[4];
              if (d) {
                g(e4, xF0);
                var w = d[1], G = function(S11, M) {
                  return g(S11, Ug0);
                }, A11 = function(S11) {
                  return u(t4, S11);
                };
                R(Dr[1], A11, G, e4, w), g(e4, oF0);
              } else
                g(e4, aF0);
              return u(f4(e4), cF0), u(f4(e4), sF0);
            }), N(sZ, function(t4, n, e4) {
              var i4 = o(XP, t4, n);
              return o(C0(qg0), i4, e4);
            });
            var vZ = [0, rm, cZ, XP, sZ], em = function t4(n, e4) {
              return t4.fun(n, e4);
            }, lZ = function t4(n) {
              return t4.fun(n);
            }, YP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, bZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(em, function(t4, n) {
              return n ? g(t4, Mg0) : g(t4, Bg0);
            }), N(lZ, function(t4) {
              return o(C0(Gg0), em, t4);
            }), N(YP, function(t4, n, e4, i4) {
              u(f4(e4), _g0), o(f4(e4), hg0, yg0), o(em, e4, i4[1]), u(f4(e4), dg0), u(f4(e4), kg0), o(f4(e4), Eg0, wg0);
              var x4 = i4[2];
              function c(w) {
                return u(n, w);
              }
              function s2(w) {
                return u(t4, w);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), Sg0), u(f4(e4), gg0), o(f4(e4), Tg0, Fg0);
              var p = i4[3];
              o(f4(e4), Og0, p), u(f4(e4), Ig0), u(f4(e4), Ag0), o(f4(e4), Cg0, Ng0);
              var y = i4[4];
              if (y) {
                g(e4, Pg0);
                var T = y[1], E = function(w, G) {
                  return g(w, mg0);
                }, d = function(w) {
                  return u(t4, w);
                };
                R(Dr[1], d, E, e4, T), g(e4, Dg0);
              } else
                g(e4, Lg0);
              return u(f4(e4), Rg0), u(f4(e4), jg0);
            }), N(bZ, function(t4, n, e4) {
              var i4 = o(YP, t4, n);
              return o(C0(pg0), i4, e4);
            });
            var pZ = [0, em, lZ, YP, bZ], nm = function t4(n, e4) {
              return t4.fun(n, e4);
            }, mZ = function t4(n) {
              return t4.fun(n);
            }, VP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, _Z = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(nm, function(t4, n) {
              switch (n) {
                case 0:
                  return g(t4, vg0);
                case 1:
                  return g(t4, lg0);
                default:
                  return g(t4, bg0);
              }
            }), N(mZ, function(t4) {
              return o(C0(sg0), nm, t4);
            }), N(VP, function(t4, n, e4, i4) {
              u(f4(e4), YS0), o(f4(e4), zS0, VS0), o(nm, e4, i4[1]), u(f4(e4), KS0), u(f4(e4), WS0), o(f4(e4), $S0, JS0);
              var x4 = i4[2];
              function c(A11) {
                return u(n, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), ZS0), u(f4(e4), QS0), o(f4(e4), eg0, rg0);
              var p = i4[3];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R(qe[31], T, y, e4, p), u(f4(e4), ng0), u(f4(e4), tg0), o(f4(e4), ig0, ug0);
              var E = i4[4];
              if (E) {
                g(e4, fg0);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, XS0);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, xg0);
              } else
                g(e4, og0);
              return u(f4(e4), ag0), u(f4(e4), cg0);
            }), N(_Z, function(t4, n, e4) {
              var i4 = o(VP, t4, n);
              return o(C0(HS0), i4, e4);
            });
            var yZ = [0, nm, mZ, VP, _Z], zP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, hZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(zP, function(t4, n, e4, i4) {
              u(f4(e4), ES0), o(f4(e4), gS0, SS0);
              var x4 = i4[1];
              function c(K) {
                return u(n, K);
              }
              function s2(K) {
                return u(t4, K);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), FS0), u(f4(e4), TS0), o(f4(e4), IS0, OS0);
              var p = i4[2];
              function y(K) {
                return u(n, K);
              }
              function T(K) {
                return u(t4, K);
              }
              R(qe[31], T, y, e4, p), u(f4(e4), AS0), u(f4(e4), NS0), o(f4(e4), PS0, CS0);
              var E = i4[3];
              function d(K) {
                return u(n, K);
              }
              function w(K) {
                return u(t4, K);
              }
              R(qe[31], w, d, e4, E), u(f4(e4), DS0), u(f4(e4), LS0), o(f4(e4), jS0, RS0);
              var G = i4[4];
              if (G) {
                g(e4, GS0);
                var A11 = G[1], S11 = function(K, V) {
                  return g(K, wS0);
                }, M = function(K) {
                  return u(t4, K);
                };
                R(Dr[1], M, S11, e4, A11), g(e4, MS0);
              } else
                g(e4, BS0);
              return u(f4(e4), qS0), u(f4(e4), US0);
            }), N(hZ, function(t4, n, e4) {
              var i4 = o(zP, t4, n);
              return o(C0(kS0), i4, e4);
            });
            var dZ = [0, zP, hZ], tm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, kZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(tm, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), _S0);
                var x4 = i4[1], c = function(E) {
                  return u(n, E);
                }, s2 = function(E) {
                  return u(t4, E);
                };
                return R(qe[31], s2, c, e4, x4), u(f4(e4), yS0);
              }
              u(f4(e4), hS0);
              var p = i4[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(CP[1], T, y, e4, p), u(f4(e4), dS0);
            }), N(kZ, function(t4, n, e4) {
              var i4 = o(tm, t4, n);
              return o(C0(mS0), i4, e4);
            });
            var KP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, wZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, um = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, EZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(KP, function(t4, n, e4, i4) {
              u(f4(e4), lS0), o(t4, e4, i4[1]), u(f4(e4), bS0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(um, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), pS0);
            }), N(wZ, function(t4, n, e4) {
              var i4 = o(KP, t4, n);
              return o(C0(vS0), i4, e4);
            }), N(um, function(t4, n, e4, i4) {
              u(f4(e4), ZE0), o(f4(e4), rS0, QE0);
              var x4 = i4[1];
              u(f4(e4), eS0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), $E0);
                function w(G) {
                  return u(n, G);
                }
                return R(tm, function(G) {
                  return u(t4, G);
                }, w, e4, d), 1;
              }, c, x4), u(f4(e4), nS0), u(f4(e4), tS0), u(f4(e4), uS0), o(f4(e4), fS0, iS0);
              var s2 = i4[2];
              if (s2) {
                g(e4, xS0);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), WE0);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), KE0);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), JE0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, oS0);
              } else
                g(e4, aS0);
              return u(f4(e4), cS0), u(f4(e4), sS0);
            }), N(EZ, function(t4, n, e4) {
              var i4 = o(um, t4, n);
              return o(C0(zE0), i4, e4);
            });
            var WP = [0, KP, wZ, um, EZ], JP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, SZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(JP, function(t4, n, e4, i4) {
              u(f4(e4), kE0), o(f4(e4), EE0, wE0);
              var x4 = i4[1];
              function c(f0) {
                return u(n, f0);
              }
              function s2(f0) {
                return u(t4, f0);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), SE0), u(f4(e4), gE0), o(f4(e4), TE0, FE0);
              var p = i4[2];
              if (p) {
                g(e4, OE0);
                var y = p[1], T = function(f0) {
                  return u(n, f0);
                }, E = function(f0) {
                  return u(t4, f0);
                };
                R(qe[2][1], E, T, e4, y), g(e4, IE0);
              } else
                g(e4, AE0);
              u(f4(e4), NE0), u(f4(e4), CE0), o(f4(e4), DE0, PE0);
              var d = i4[3];
              if (d) {
                g(e4, LE0);
                var w = d[1], G = function(f0) {
                  return u(n, f0);
                }, A11 = function(f0) {
                  return u(t4, f0);
                };
                R(WP[1], A11, G, e4, w), g(e4, RE0);
              } else
                g(e4, jE0);
              u(f4(e4), GE0), u(f4(e4), ME0), o(f4(e4), qE0, BE0);
              var S11 = i4[4];
              if (S11) {
                g(e4, UE0);
                var M = S11[1], K = function(f0, m0) {
                  return g(f0, dE0);
                }, V = function(f0) {
                  return u(t4, f0);
                };
                R(Dr[1], V, K, e4, M), g(e4, HE0);
              } else
                g(e4, XE0);
              return u(f4(e4), YE0), u(f4(e4), VE0);
            }), N(SZ, function(t4, n, e4) {
              var i4 = o(JP, t4, n);
              return o(C0(hE0), i4, e4);
            });
            var gZ = [0, JP, SZ], $P = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, FZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N($P, function(t4, n, e4, i4) {
              u(f4(e4), Jw0), o(f4(e4), Zw0, $w0);
              var x4 = i4[1];
              function c(V) {
                return u(n, V);
              }
              function s2(V) {
                return u(t4, V);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), Qw0), u(f4(e4), rE0), o(f4(e4), nE0, eE0);
              var p = i4[2];
              if (p) {
                g(e4, tE0);
                var y = p[1], T = function(V) {
                  return u(n, V);
                }, E = function(V) {
                  return u(t4, V);
                };
                R(qe[2][1], E, T, e4, y), g(e4, uE0);
              } else
                g(e4, iE0);
              u(f4(e4), fE0), u(f4(e4), xE0), o(f4(e4), aE0, oE0);
              var d = i4[3];
              function w(V) {
                return u(n, V);
              }
              function G(V) {
                return u(t4, V);
              }
              R(WP[1], G, w, e4, d), u(f4(e4), cE0), u(f4(e4), sE0), o(f4(e4), lE0, vE0);
              var A11 = i4[4];
              if (A11) {
                g(e4, bE0);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, Ww0);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, pE0);
              } else
                g(e4, mE0);
              return u(f4(e4), _E0), u(f4(e4), yE0);
            }), N(FZ, function(t4, n, e4) {
              var i4 = o($P, t4, n);
              return o(C0(Kw0), i4, e4);
            });
            var ZP = [0, $P, FZ], QP = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, TZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(QP, function(t4, n, e4, i4) {
              u(f4(e4), Dw0), o(f4(e4), Rw0, Lw0);
              var x4 = i4[1];
              function c(y) {
                return u(n, y);
              }
              function s2(y) {
                return u(t4, y);
              }
              R(ZP[1], s2, c, e4, x4), u(f4(e4), jw0), u(f4(e4), Gw0), o(f4(e4), Bw0, Mw0), o(n, e4, i4[2]), u(f4(e4), qw0), u(f4(e4), Uw0), o(f4(e4), Xw0, Hw0);
              var p = i4[3];
              return o(f4(e4), Yw0, p), u(f4(e4), Vw0), u(f4(e4), zw0);
            }), N(TZ, function(t4, n, e4) {
              var i4 = o(QP, t4, n);
              return o(C0(Pw0), i4, e4);
            });
            var OZ = [0, QP, TZ], im = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, IZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, rD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, AZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(im, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), Tw0);
                  var x4 = i4[1], c = function(w) {
                    return u(n, w);
                  }, s2 = function(w) {
                    return u(t4, w);
                  };
                  return R(Rn[1], s2, c, e4, x4), u(f4(e4), Ow0);
                case 1:
                  u(f4(e4), Iw0);
                  var p = i4[1], y = function(w) {
                    return u(t4, w);
                  };
                  return ur(Bp[1], y, e4, p), u(f4(e4), Aw0);
                default:
                  u(f4(e4), Nw0);
                  var T = i4[1], E = function(w) {
                    return u(n, w);
                  }, d = function(w) {
                    return u(t4, w);
                  };
                  return R(qe[31], d, E, e4, T), u(f4(e4), Cw0);
              }
            }), N(IZ, function(t4, n, e4) {
              var i4 = o(im, t4, n);
              return o(C0(Fw0), i4, e4);
            }), N(rD, function(t4, n, e4, i4) {
              u(f4(e4), cw0), o(f4(e4), vw0, sw0);
              var x4 = i4[1];
              function c(G) {
                return u(n, G);
              }
              function s2(G) {
                return u(t4, G);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), lw0), u(f4(e4), bw0), o(f4(e4), mw0, pw0);
              var p = i4[2];
              function y(G) {
                return u(n, G);
              }
              R(im, function(G) {
                return u(t4, G);
              }, y, e4, p), u(f4(e4), _w0), u(f4(e4), yw0), o(f4(e4), dw0, hw0);
              var T = i4[3];
              if (T) {
                g(e4, kw0);
                var E = T[1], d = function(G, A11) {
                  return g(G, aw0);
                }, w = function(G) {
                  return u(t4, G);
                };
                R(Dr[1], w, d, e4, E), g(e4, ww0);
              } else
                g(e4, Ew0);
              return u(f4(e4), Sw0), u(f4(e4), gw0);
            }), N(AZ, function(t4, n, e4) {
              var i4 = o(rD, t4, n);
              return o(C0(ow0), i4, e4);
            });
            var eD = [0, im, IZ, rD, AZ], nD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, NZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(nD, function(t4, n, e4, i4) {
              u(f4(e4), Kk0), o(f4(e4), Jk0, Wk0);
              var x4 = i4[1];
              function c(y) {
                return u(n, y);
              }
              function s2(y) {
                return u(t4, y);
              }
              R(eD[3], s2, c, e4, x4), u(f4(e4), $k0), u(f4(e4), Zk0), o(f4(e4), rw0, Qk0), o(n, e4, i4[2]), u(f4(e4), ew0), u(f4(e4), nw0), o(f4(e4), uw0, tw0);
              var p = i4[3];
              return o(f4(e4), iw0, p), u(f4(e4), fw0), u(f4(e4), xw0);
            }), N(NZ, function(t4, n, e4) {
              var i4 = o(nD, t4, n);
              return o(C0(zk0), i4, e4);
            });
            var CZ = [0, nD, NZ], tD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, PZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(tD, function(t4, n, e4, i4) {
              u(f4(e4), Ek0), o(f4(e4), gk0, Sk0);
              var x4 = i4[1];
              if (x4) {
                g(e4, Fk0);
                var c = x4[1], s2 = function(G) {
                  return u(n, G);
                }, p = function(G) {
                  return u(t4, G);
                };
                R(qe[31], p, s2, e4, c), g(e4, Tk0);
              } else
                g(e4, Ok0);
              u(f4(e4), Ik0), u(f4(e4), Ak0), o(f4(e4), Ck0, Nk0);
              var y = i4[2];
              if (y) {
                g(e4, Pk0);
                var T = y[1], E = function(G, A11) {
                  return g(G, wk0);
                }, d = function(G) {
                  return u(t4, G);
                };
                R(Dr[1], d, E, e4, T), g(e4, Dk0);
              } else
                g(e4, Lk0);
              u(f4(e4), Rk0), u(f4(e4), jk0), o(f4(e4), Mk0, Gk0);
              var w = i4[3];
              return o(f4(e4), Bk0, w), u(f4(e4), qk0), u(f4(e4), Uk0), o(f4(e4), Xk0, Hk0), o(n, e4, i4[4]), u(f4(e4), Yk0), u(f4(e4), Vk0);
            }), N(PZ, function(t4, n, e4) {
              var i4 = o(tD, t4, n);
              return o(C0(kk0), i4, e4);
            });
            var DZ = [0, tD, PZ], uD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, LZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, fm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, RZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(uD, function(t4, n, e4, i4) {
              u(f4(e4), yk0), o(t4, e4, i4[1]), u(f4(e4), hk0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(fm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), dk0);
            }), N(LZ, function(t4, n, e4) {
              var i4 = o(uD, t4, n);
              return o(C0(_k0), i4, e4);
            }), N(fm, function(t4, n, e4, i4) {
              u(f4(e4), tk0), o(f4(e4), ik0, uk0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(di[5], s2, c, e4, x4), u(f4(e4), fk0), u(f4(e4), xk0), o(f4(e4), ak0, ok0);
              var p = i4[2];
              function y(d) {
                return u(n, d);
              }
              function T(d) {
                return u(t4, d);
              }
              R(qe[31], T, y, e4, p), u(f4(e4), ck0), u(f4(e4), sk0), o(f4(e4), lk0, vk0);
              var E = i4[3];
              return o(f4(e4), bk0, E), u(f4(e4), pk0), u(f4(e4), mk0);
            }), N(RZ, function(t4, n, e4) {
              var i4 = o(fm, t4, n);
              return o(C0(nk0), i4, e4);
            });
            var jZ = [0, uD, LZ, fm, RZ], iD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, GZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(iD, function(t4, n, e4, i4) {
              u(f4(e4), Ud0), o(f4(e4), Xd0, Hd0);
              var x4 = i4[1];
              u(f4(e4), Yd0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), qd0);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R(jZ[1], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), Vd0), u(f4(e4), zd0), u(f4(e4), Kd0), o(f4(e4), Jd0, Wd0);
              var s2 = i4[2];
              if (s2) {
                g(e4, $d0);
                var p = s2[1], y = function(E) {
                  return u(n, E);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(qe[31], T, y, e4, p), g(e4, Zd0);
              } else
                g(e4, Qd0);
              return u(f4(e4), rk0), u(f4(e4), ek0);
            }), N(GZ, function(t4, n, e4) {
              var i4 = o(iD, t4, n);
              return o(C0(Bd0), i4, e4);
            });
            var fD = [0, jZ, iD, GZ], xD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, MZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(xD, function(t4, n, e4, i4) {
              u(f4(e4), Fd0), o(f4(e4), Od0, Td0);
              var x4 = i4[1];
              u(f4(e4), Id0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), gd0);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R(fD[1][1], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), Ad0), u(f4(e4), Nd0), u(f4(e4), Cd0), o(f4(e4), Dd0, Pd0);
              var s2 = i4[2];
              if (s2) {
                g(e4, Ld0);
                var p = s2[1], y = function(E) {
                  return u(n, E);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(qe[31], T, y, e4, p), g(e4, Rd0);
              } else
                g(e4, jd0);
              return u(f4(e4), Gd0), u(f4(e4), Md0);
            }), N(MZ, function(t4, n, e4) {
              var i4 = o(xD, t4, n);
              return o(C0(Sd0), i4, e4);
            });
            var BZ = [0, xD, MZ], oD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, qZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(oD, function(t4, n, e4, i4) {
              u(f4(e4), od0), o(f4(e4), cd0, ad0);
              var x4 = i4[1];
              function c(A11) {
                return u(n, A11);
              }
              function s2(A11) {
                return u(t4, A11);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), sd0), u(f4(e4), vd0), o(f4(e4), bd0, ld0);
              var p = i4[2];
              function y(A11) {
                return u(n, A11);
              }
              function T(A11) {
                return u(t4, A11);
              }
              R($e[17], T, y, e4, p), u(f4(e4), pd0), u(f4(e4), md0), o(f4(e4), yd0, _d0);
              var E = i4[3];
              if (E) {
                g(e4, hd0);
                var d = E[1], w = function(A11, S11) {
                  return g(A11, xd0);
                }, G = function(A11) {
                  return u(t4, A11);
                };
                R(Dr[1], G, w, e4, d), g(e4, dd0);
              } else
                g(e4, kd0);
              return u(f4(e4), wd0), u(f4(e4), Ed0);
            }), N(qZ, function(t4, n, e4) {
              var i4 = o(oD, t4, n);
              return o(C0(fd0), i4, e4);
            });
            var UZ = [0, oD, qZ], aD = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, HZ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(aD, function(t4, n, e4) {
              u(f4(n), Xh0), o(f4(n), Vh0, Yh0);
              var i4 = e4[1];
              function x4(G) {
                return u(t4, G);
              }
              function c(G) {
                return u(t4, G);
              }
              R(Rn[1], c, x4, n, i4), u(f4(n), zh0), u(f4(n), Kh0), o(f4(n), Jh0, Wh0);
              var s2 = e4[2];
              function p(G) {
                return u(t4, G);
              }
              function y(G) {
                return u(t4, G);
              }
              R(Rn[1], y, p, n, s2), u(f4(n), $h0), u(f4(n), Zh0), o(f4(n), rd0, Qh0);
              var T = e4[3];
              if (T) {
                g(n, ed0);
                var E = T[1], d = function(G, A11) {
                  return g(G, Hh0);
                }, w = function(G) {
                  return u(t4, G);
                };
                R(Dr[1], w, d, n, E), g(n, nd0);
              } else
                g(n, td0);
              return u(f4(n), ud0), u(f4(n), id0);
            }), N(HZ, function(t4, n) {
              var e4 = u(aD, t4);
              return o(C0(Uh0), e4, n);
            });
            var XZ = [0, aD, HZ], cD = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, YZ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(cD, function(t4, n, e4) {
              u(f4(n), Dh0), o(f4(n), Rh0, Lh0);
              var i4 = e4[1];
              if (i4) {
                g(n, jh0);
                var x4 = i4[1], c = function(p, y) {
                  return g(p, Ph0);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                R(Dr[1], s2, c, n, x4), g(n, Gh0);
              } else
                g(n, Mh0);
              return u(f4(n), Bh0), u(f4(n), qh0);
            }), N(YZ, function(t4, n) {
              var e4 = u(cD, t4);
              return o(C0(Ch0), e4, n);
            });
            var VZ = [0, cD, YZ], sD = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, zZ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(sD, function(t4, n, e4) {
              u(f4(n), Sh0), o(f4(n), Fh0, gh0);
              var i4 = e4[1];
              if (i4) {
                g(n, Th0);
                var x4 = i4[1], c = function(p, y) {
                  return g(p, Eh0);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                R(Dr[1], s2, c, n, x4), g(n, Oh0);
              } else
                g(n, Ih0);
              return u(f4(n), Ah0), u(f4(n), Nh0);
            }), N(zZ, function(t4, n) {
              var e4 = u(sD, t4);
              return o(C0(wh0), e4, n);
            });
            var KZ = [0, sD, zZ], vD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, WZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(vD, function(t4, n, e4, i4) {
              u(f4(e4), ch0), o(f4(e4), vh0, sh0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), lh0), u(f4(e4), bh0), o(f4(e4), mh0, ph0);
              var p = i4[2];
              if (p) {
                g(e4, _h0);
                var y = p[1], T = function(d, w) {
                  return g(d, ah0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, yh0);
              } else
                g(e4, hh0);
              return u(f4(e4), dh0), u(f4(e4), kh0);
            }), N(WZ, function(t4, n, e4) {
              var i4 = o(vD, t4, n);
              return o(C0(oh0), i4, e4);
            });
            var JZ = [0, vD, WZ], lD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, $Z = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, xm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, ZZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(lD, function(t4, n, e4, i4) {
              u(f4(e4), ih0), o(n, e4, i4[1]), u(f4(e4), fh0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(xm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), xh0);
            }), N($Z, function(t4, n, e4) {
              var i4 = o(lD, t4, n);
              return o(C0(uh0), i4, e4);
            }), N(xm, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), J_0);
                  var x4 = i4[1], c = function(Y) {
                    return u(n, Y);
                  }, s2 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(G$[3], s2, c, e4, x4), u(f4(e4), $_0);
                case 1:
                  u(f4(e4), Z_0);
                  var p = i4[1], y = function(Y) {
                    return u(n, Y);
                  }, T = function(Y) {
                    return u(t4, Y);
                  };
                  return R(As[5], T, y, e4, p), u(f4(e4), Q_0);
                case 2:
                  u(f4(e4), ry0);
                  var E = i4[1], d = function(Y) {
                    return u(n, Y);
                  }, w = function(Y) {
                    return u(t4, Y);
                  };
                  return R(vZ[3], w, d, e4, E), u(f4(e4), ey0);
                case 3:
                  u(f4(e4), ny0);
                  var G = i4[1], A11 = function(Y) {
                    return u(n, Y);
                  }, S11 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(aZ[3], S11, A11, e4, G), u(f4(e4), ty0);
                case 4:
                  u(f4(e4), uy0);
                  var M = i4[1], K = function(Y) {
                    return u(n, Y);
                  }, V = function(Y) {
                    return u(t4, Y);
                  };
                  return R(ZP[1], V, K, e4, M), u(f4(e4), iy0);
                case 5:
                  u(f4(e4), fy0);
                  var f0 = i4[1], m0 = function(Y) {
                    return u(n, Y);
                  }, k0 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(F1[8], k0, m0, e4, f0), u(f4(e4), xy0);
                case 6:
                  u(f4(e4), oy0);
                  var g0 = i4[1], e0 = function(Y) {
                    return u(n, Y);
                  }, x0 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(fD[2], x0, e0, e4, g0), u(f4(e4), ay0);
                case 7:
                  u(f4(e4), cy0);
                  var l = i4[1], c0 = function(Y) {
                    return u(n, Y);
                  }, t0 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(dZ[1], t0, c0, e4, l), u(f4(e4), sy0);
                case 8:
                  u(f4(e4), vy0);
                  var o0 = i4[1], w0 = function(Y) {
                    return u(n, Y);
                  }, _0 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(As[5], _0, w0, e4, o0), u(f4(e4), ly0);
                case 9:
                  u(f4(e4), by0);
                  var E0 = i4[1], U0 = function(Y) {
                    return u(n, Y);
                  }, b = function(Y) {
                    return u(t4, Y);
                  };
                  return R(BZ[1], b, U0, e4, E0), u(f4(e4), py0);
                case 10:
                  u(f4(e4), my0);
                  var R0 = i4[1], X = function(Y) {
                    return u(n, Y);
                  }, s0 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(Rn[1], s0, X, e4, R0), u(f4(e4), _y0);
                case 11:
                  u(f4(e4), yy0);
                  var hr = i4[1], Ar = function(Y) {
                    return u(n, Y);
                  }, or = function(Y) {
                    return u(t4, Y);
                  };
                  return R(JZ[1], or, Ar, e4, hr), u(f4(e4), hy0);
                case 12:
                  u(f4(e4), dy0);
                  var W0 = i4[1], Lr = function(Y) {
                    return u(n, Y);
                  }, Tr = function(Y) {
                    return u(t4, Y);
                  };
                  return R(UN[17], Tr, Lr, e4, W0), u(f4(e4), ky0);
                case 13:
                  u(f4(e4), wy0);
                  var Hr = i4[1], Or = function(Y) {
                    return u(n, Y);
                  }, fr = function(Y) {
                    return u(t4, Y);
                  };
                  return R(UN[19], fr, Or, e4, Hr), u(f4(e4), Ey0);
                case 14:
                  u(f4(e4), Sy0);
                  var Rr = i4[1], Wr = function(Y) {
                    return u(t4, Y);
                  };
                  return ur(Tl[2], Wr, e4, Rr), u(f4(e4), gy0);
                case 15:
                  u(f4(e4), Fy0);
                  var Jr = i4[1], ar = function(Y) {
                    return u(n, Y);
                  }, _r = function(Y) {
                    return u(t4, Y);
                  };
                  return R(yZ[3], _r, ar, e4, Jr), u(f4(e4), Ty0);
                case 16:
                  u(f4(e4), Oy0);
                  var Ir = i4[1], fe = function(Y) {
                    return u(n, Y);
                  }, v0 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(eD[3], v0, fe, e4, Ir), u(f4(e4), Iy0);
                case 17:
                  u(f4(e4), Ay0);
                  var P = i4[1], L = function(Y) {
                    return u(t4, Y);
                  };
                  return ur(XZ[1], L, e4, P), u(f4(e4), Ny0);
                case 18:
                  u(f4(e4), Cy0);
                  var Q = i4[1], i0 = function(Y) {
                    return u(n, Y);
                  }, l0 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(gZ[1], l0, i0, e4, Q), u(f4(e4), Py0);
                case 19:
                  u(f4(e4), Dy0);
                  var S0 = i4[1], T0 = function(Y) {
                    return u(n, Y);
                  }, rr = function(Y) {
                    return u(t4, Y);
                  };
                  return R(eZ[5], rr, T0, e4, S0), u(f4(e4), Ly0);
                case 20:
                  u(f4(e4), Ry0);
                  var L0 = i4[1], B = function(Y) {
                    return u(n, Y);
                  }, Z7 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(OZ[1], Z7, B, e4, L0), u(f4(e4), jy0);
                case 21:
                  u(f4(e4), Gy0);
                  var p0 = i4[1], b0 = function(Y) {
                    return u(n, Y);
                  }, O0 = function(Y) {
                    return u(t4, Y);
                  };
                  return R(CZ[1], O0, b0, e4, p0), u(f4(e4), My0);
                case 22:
                  u(f4(e4), By0);
                  var M0 = i4[1], er = function(Y) {
                    return u(n, Y);
                  }, yr = function(Y) {
                    return u(t4, Y);
                  };
                  return R(tZ[1], yr, er, e4, M0), u(f4(e4), qy0);
                case 23:
                  u(f4(e4), Uy0);
                  var vr = i4[1], $0 = function(Y) {
                    return u(t4, Y);
                  };
                  return ur(KZ[1], $0, e4, vr), u(f4(e4), Hy0);
                case 24:
                  u(f4(e4), Xy0);
                  var Er = i4[1], Mr = function(Y) {
                    return u(n, Y);
                  }, Br = function(Y) {
                    return u(t4, Y);
                  };
                  return R(Y$[1], Br, Mr, e4, Er), u(f4(e4), Yy0);
                case 25:
                  u(f4(e4), Vy0);
                  var qr = i4[1], jr = function(Y) {
                    return u(n, Y);
                  }, $r = function(Y) {
                    return u(t4, Y);
                  };
                  return R(RP[2], $r, jr, e4, qr), u(f4(e4), zy0);
                case 26:
                  u(f4(e4), Ky0);
                  var ne = i4[1], Qr = function(Y) {
                    return u(t4, Y);
                  };
                  return ur(VZ[1], Qr, e4, ne), u(f4(e4), Wy0);
                case 27:
                  u(f4(e4), Jy0);
                  var be = i4[1], ae = function(Y) {
                    return u(n, Y);
                  }, pe = function(Y) {
                    return u(t4, Y);
                  };
                  return R(UZ[1], pe, ae, e4, be), u(f4(e4), $y0);
                case 28:
                  u(f4(e4), Zy0);
                  var oe = i4[1], ce = function(Y) {
                    return u(n, Y);
                  }, ge = function(Y) {
                    return u(t4, Y);
                  };
                  return R(fZ[3], ge, ce, e4, oe), u(f4(e4), Qy0);
                case 29:
                  u(f4(e4), rh0);
                  var q0 = i4[1], Fr = function(Y) {
                    return u(n, Y);
                  }, _ = function(Y) {
                    return u(t4, Y);
                  };
                  return R(pZ[3], _, Fr, e4, q0), u(f4(e4), eh0);
                default:
                  u(f4(e4), nh0);
                  var k = i4[1], I = function(Y) {
                    return u(n, Y);
                  }, U = function(Y) {
                    return u(t4, Y);
                  };
                  return R(DZ[1], U, I, e4, k), u(f4(e4), th0);
              }
            }), N(ZZ, function(t4, n, e4) {
              var i4 = o(xm, t4, n);
              return o(C0(W_0), i4, e4);
            }), mu(J3r, qe, [0, N$, See, CP, G$, RP, Y$, eZ, tZ, fZ, aZ, vZ, pZ, yZ, dZ, tm, kZ, WP, gZ, ZP, OZ, eD, CZ, DZ, fD, BZ, UZ, XZ, VZ, KZ, JZ, lD, $Z, xm, ZZ]);
            var bD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, QZ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, om = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, rQ = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(bD, function(t4, n, e4, i4) {
              u(f4(e4), V_0), o(n, e4, i4[1]), u(f4(e4), z_0);
              var x4 = i4[2];
              return ur(om, function(c) {
                return u(t4, c);
              }, e4, x4), u(f4(e4), K_0);
            }), N(QZ, function(t4, n, e4) {
              var i4 = o(bD, t4, n);
              return o(C0(Y_0), i4, e4);
            }), N(om, function(t4, n, e4) {
              u(f4(n), C_0), o(f4(n), D_0, P_0);
              var i4 = e4[1];
              o(f4(n), L_0, i4), u(f4(n), R_0), u(f4(n), j_0), o(f4(n), M_0, G_0);
              var x4 = e4[2];
              if (x4) {
                g(n, B_0);
                var c = x4[1], s2 = function(y, T) {
                  return g(y, N_0);
                }, p = function(y) {
                  return u(t4, y);
                };
                R(Dr[1], p, s2, n, c), g(n, q_0);
              } else
                g(n, U_0);
              return u(f4(n), H_0), u(f4(n), X_0);
            }), N(rQ, function(t4, n) {
              var e4 = u(om, t4);
              return o(C0(A_0), e4, n);
            });
            var O1 = [0, bD, QZ, om, rQ], pD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, eQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, am = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, nQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(pD, function(t4, n, e4, i4) {
              u(f4(e4), T_0), o(t4, e4, i4[1]), u(f4(e4), O_0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(am, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), I_0);
            }), N(eQ, function(t4, n, e4) {
              var i4 = o(pD, t4, n);
              return o(C0(F_0), i4, e4);
            }), N(am, function(t4, n, e4, i4) {
              u(f4(e4), __0), o(f4(e4), h_0, y_0);
              var x4 = i4[1];
              function c(E) {
                return u(n, E);
              }
              function s2(E) {
                return u(t4, E);
              }
              R(O1[1], s2, c, e4, x4), u(f4(e4), d_0), u(f4(e4), k_0), o(f4(e4), E_0, w_0);
              var p = i4[2];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(O1[1], T, y, e4, p), u(f4(e4), S_0), u(f4(e4), g_0);
            }), N(nQ, function(t4, n, e4) {
              var i4 = o(am, t4, n);
              return o(C0(m_0), i4, e4);
            });
            var mD = [0, pD, eQ, am, nQ], _D = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, tQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, cm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, uQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(_D, function(t4, n, e4, i4) {
              u(f4(e4), u_0), o(f4(e4), f_0, i_0);
              var x4 = i4[1];
              function c(E) {
                return u(n, E);
              }
              R(cm, function(E) {
                return u(t4, E);
              }, c, e4, x4), u(f4(e4), x_0), u(f4(e4), o_0), o(f4(e4), c_0, a_0);
              var s2 = i4[2];
              if (s2) {
                g(e4, s_0);
                var p = s2[1], y = function(E, d) {
                  u(f4(E), n_0);
                  var w = 0;
                  return le(function(G, A11) {
                    G && u(f4(E), e_0);
                    function S11(M) {
                      return u(t4, M);
                    }
                    return ur(iu[1], S11, E, A11), 1;
                  }, w, d), u(f4(E), t_0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, v_0);
              } else
                g(e4, l_0);
              return u(f4(e4), b_0), u(f4(e4), p_0);
            }), N(tQ, function(t4, n, e4) {
              var i4 = o(_D, t4, n);
              return o(C0(r_0), i4, e4);
            }), N(cm, function(t4, n, e4, i4) {
              if (i4) {
                u(f4(e4), $90);
                var x4 = i4[1], c = function(p) {
                  return u(n, p);
                }, s2 = function(p) {
                  return u(t4, p);
                };
                return R(qe[31], s2, c, e4, x4), u(f4(e4), Z90);
              }
              return g(e4, Q90);
            }), N(uQ, function(t4, n, e4) {
              var i4 = o(cm, t4, n);
              return o(C0(J90), i4, e4);
            });
            var yD = [0, _D, tQ, cm, uQ];
            function iQ(t4, n) {
              u(f4(t4), G90), o(f4(t4), B90, M90);
              var e4 = n[1];
              o(f4(t4), q90, e4), u(f4(t4), U90), u(f4(t4), H90), o(f4(t4), Y90, X90);
              var i4 = n[2];
              return o(f4(t4), V90, i4), u(f4(t4), z90), u(f4(t4), K90);
            }
            var fQ = [0, iQ, function(t4) {
              return o(C0(W90), iQ, t4);
            }], hD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, xQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, sm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, oQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, vm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, aQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, lm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, cQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(hD, function(t4, n, e4, i4) {
              u(f4(e4), L90), o(t4, e4, i4[1]), u(f4(e4), R90);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(lm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), j90);
            }), N(xQ, function(t4, n, e4) {
              var i4 = o(hD, t4, n);
              return o(C0(D90), i4, e4);
            }), N(sm, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), A90);
                var x4 = i4[1], c = function(E) {
                  return u(n, E);
                }, s2 = function(E) {
                  return u(t4, E);
                };
                return R(O1[1], s2, c, e4, x4), u(f4(e4), N90);
              }
              u(f4(e4), C90);
              var p = i4[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(mD[1], T, y, e4, p), u(f4(e4), P90);
            }), N(oQ, function(t4, n, e4) {
              var i4 = o(sm, t4, n);
              return o(C0(I90), i4, e4);
            }), N(vm, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), E90), o(n, e4, i4[1]), u(f4(e4), S90);
                var x4 = i4[2], c = function(T) {
                  return u(t4, T);
                };
                return ur(Tl[2], c, e4, x4), u(f4(e4), g90);
              }
              u(f4(e4), F90), o(n, e4, i4[1]), u(f4(e4), T90);
              var s2 = i4[2];
              function p(T) {
                return u(n, T);
              }
              function y(T) {
                return u(t4, T);
              }
              return R(yD[1], y, p, e4, s2), u(f4(e4), O90);
            }), N(aQ, function(t4, n, e4) {
              var i4 = o(vm, t4, n);
              return o(C0(w90), i4, e4);
            }), N(lm, function(t4, n, e4, i4) {
              u(f4(e4), c90), o(f4(e4), v90, s90);
              var x4 = i4[1];
              function c(T) {
                return u(n, T);
              }
              R(sm, function(T) {
                return u(t4, T);
              }, c, e4, x4), u(f4(e4), l90), u(f4(e4), b90), o(f4(e4), m90, p90);
              var s2 = i4[2];
              if (s2) {
                g(e4, _90);
                var p = s2[1], y = function(T) {
                  return u(n, T);
                };
                R(vm, function(T) {
                  return u(t4, T);
                }, y, e4, p), g(e4, y90);
              } else
                g(e4, h90);
              return u(f4(e4), d90), u(f4(e4), k90);
            }), N(cQ, function(t4, n, e4) {
              var i4 = o(lm, t4, n);
              return o(C0(a90), i4, e4);
            });
            var sQ = [0, hD, xQ, sm, oQ, vm, aQ, lm, cQ], dD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, vQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, bm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, lQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(dD, function(t4, n, e4, i4) {
              u(f4(e4), f90), o(t4, e4, i4[1]), u(f4(e4), x90);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(bm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), o90);
            }), N(vQ, function(t4, n, e4) {
              var i4 = o(dD, t4, n);
              return o(C0(i90), i4, e4);
            }), N(bm, function(t4, n, e4, i4) {
              u(f4(e4), zm0), o(f4(e4), Wm0, Km0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), Jm0), u(f4(e4), $m0), o(f4(e4), Qm0, Zm0);
              var p = i4[2];
              if (p) {
                g(e4, r90);
                var y = p[1], T = function(d, w) {
                  return g(d, Vm0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, e90);
              } else
                g(e4, n90);
              return u(f4(e4), t90), u(f4(e4), u90);
            }), N(lQ, function(t4, n, e4) {
              var i4 = o(bm, t4, n);
              return o(C0(Ym0), i4, e4);
            });
            var bQ = [0, dD, vQ, bm, lQ], pm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, pQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, mm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, mQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, _m = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, _Q = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(pm, function(t4, n, e4, i4) {
              u(f4(e4), Um0), o(t4, e4, i4[1]), u(f4(e4), Hm0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(_m, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Xm0);
            }), N(pQ, function(t4, n, e4) {
              var i4 = o(pm, t4, n);
              return o(C0(qm0), i4, e4);
            }), N(mm, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), jm0);
                var x4 = i4[1], c = function(T) {
                  return u(n, T);
                }, s2 = function(T) {
                  return u(t4, T);
                };
                return R(O1[1], s2, c, e4, x4), u(f4(e4), Gm0);
              }
              u(f4(e4), Mm0);
              var p = i4[1];
              function y(T) {
                return u(n, T);
              }
              return R(pm, function(T) {
                return u(t4, T);
              }, y, e4, p), u(f4(e4), Bm0);
            }), N(mQ, function(t4, n, e4) {
              var i4 = o(mm, t4, n);
              return o(C0(Rm0), i4, e4);
            }), N(_m, function(t4, n, e4, i4) {
              u(f4(e4), Tm0), o(f4(e4), Im0, Om0);
              var x4 = i4[1];
              function c(T) {
                return u(n, T);
              }
              R(mm, function(T) {
                return u(t4, T);
              }, c, e4, x4), u(f4(e4), Am0), u(f4(e4), Nm0), o(f4(e4), Pm0, Cm0);
              var s2 = i4[2];
              function p(T) {
                return u(n, T);
              }
              function y(T) {
                return u(t4, T);
              }
              return R(O1[1], y, p, e4, s2), u(f4(e4), Dm0), u(f4(e4), Lm0);
            }), N(_Q, function(t4, n, e4) {
              var i4 = o(_m, t4, n);
              return o(C0(Fm0), i4, e4);
            });
            var yQ = [0, pm, pQ, mm, mQ, _m, _Q], Nl = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, hQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(Nl, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), dm0);
                  var x4 = i4[1], c = function(G) {
                    return u(n, G);
                  }, s2 = function(G) {
                    return u(t4, G);
                  };
                  return R(O1[1], s2, c, e4, x4), u(f4(e4), km0);
                case 1:
                  u(f4(e4), wm0);
                  var p = i4[1], y = function(G) {
                    return u(n, G);
                  }, T = function(G) {
                    return u(t4, G);
                  };
                  return R(mD[1], T, y, e4, p), u(f4(e4), Em0);
                default:
                  u(f4(e4), Sm0);
                  var E = i4[1], d = function(G) {
                    return u(n, G);
                  }, w = function(G) {
                    return u(t4, G);
                  };
                  return R(yQ[1], w, d, e4, E), u(f4(e4), gm0);
              }
            }), N(hQ, function(t4, n, e4) {
              var i4 = o(Nl, t4, n);
              return o(C0(hm0), i4, e4);
            });
            var kD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, dQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, ym = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, kQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, hm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, wQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(kD, function(t4, n, e4, i4) {
              u(f4(e4), mm0), o(t4, e4, i4[1]), u(f4(e4), _m0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(hm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), ym0);
            }), N(dQ, function(t4, n, e4) {
              var i4 = o(kD, t4, n);
              return o(C0(pm0), i4, e4);
            }), N(ym, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), sm0);
                var x4 = i4[1], c = function(E) {
                  return u(n, E);
                }, s2 = function(E) {
                  return u(t4, E);
                };
                return R(sQ[1], s2, c, e4, x4), u(f4(e4), vm0);
              }
              u(f4(e4), lm0);
              var p = i4[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(bQ[1], T, y, e4, p), u(f4(e4), bm0);
            }), N(kQ, function(t4, n, e4) {
              var i4 = o(ym, t4, n);
              return o(C0(cm0), i4, e4);
            }), N(hm, function(t4, n, e4, i4) {
              u(f4(e4), K50), o(f4(e4), J50, W50);
              var x4 = i4[1];
              function c(T) {
                return u(n, T);
              }
              R(Nl, function(T) {
                return u(t4, T);
              }, c, e4, x4), u(f4(e4), $50), u(f4(e4), Z50), o(f4(e4), rm0, Q50);
              var s2 = i4[2];
              o(f4(e4), em0, s2), u(f4(e4), nm0), u(f4(e4), tm0), o(f4(e4), im0, um0);
              var p = i4[3];
              u(f4(e4), fm0);
              var y = 0;
              return le(function(T, E) {
                T && u(f4(e4), z50);
                function d(w) {
                  return u(n, w);
                }
                return R(ym, function(w) {
                  return u(t4, w);
                }, d, e4, E), 1;
              }, y, p), u(f4(e4), xm0), u(f4(e4), om0), u(f4(e4), am0);
            }), N(wQ, function(t4, n, e4) {
              var i4 = o(hm, t4, n);
              return o(C0(V50), i4, e4);
            });
            var EQ = [0, kD, dQ, ym, kQ, hm, wQ], wD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, SQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, dm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, gQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(wD, function(t4, n, e4, i4) {
              u(f4(e4), H50), o(t4, e4, i4[1]), u(f4(e4), X50);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(dm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Y50);
            }), N(SQ, function(t4, n, e4) {
              var i4 = o(wD, t4, n);
              return o(C0(U50), i4, e4);
            }), N(dm, function(t4, n, e4, i4) {
              u(f4(e4), j50), o(f4(e4), M50, G50);
              var x4 = i4[1];
              function c(s2) {
                return u(n, s2);
              }
              return R(Nl, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), B50), u(f4(e4), q50);
            }), N(gQ, function(t4, n, e4) {
              var i4 = o(dm, t4, n);
              return o(C0(R50), i4, e4);
            });
            var FQ = [0, wD, SQ, dm, gQ], ED = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, TQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(ED, function(t4, n, e4, i4) {
              u(f4(e4), S50), o(f4(e4), F50, g50);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), T50), u(f4(e4), O50), o(f4(e4), A50, I50);
              var p = i4[2];
              if (p) {
                g(e4, N50);
                var y = p[1], T = function(d, w) {
                  return g(d, E50);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, C50);
              } else
                g(e4, P50);
              return u(f4(e4), D50), u(f4(e4), L50);
            }), N(TQ, function(t4, n, e4) {
              var i4 = o(ED, t4, n);
              return o(C0(w50), i4, e4);
            });
            var OQ = [0, ED, TQ], Cl = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, IQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, km = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, AQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, wm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, NQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Em = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, CQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(Cl, function(t4, n, e4, i4) {
              u(f4(e4), h50), o(t4, e4, i4[1]), u(f4(e4), d50);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(km, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), k50);
            }), N(IQ, function(t4, n, e4) {
              var i4 = o(Cl, t4, n);
              return o(C0(y50), i4, e4);
            }), N(km, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), o50);
                  var x4 = i4[1], c = function(A11) {
                    return u(n, A11);
                  };
                  return R(wm, function(A11) {
                    return u(t4, A11);
                  }, c, e4, x4), u(f4(e4), a50);
                case 1:
                  u(f4(e4), c50);
                  var s2 = i4[1], p = function(A11) {
                    return u(n, A11);
                  };
                  return R(Em, function(A11) {
                    return u(t4, A11);
                  }, p, e4, s2), u(f4(e4), s50);
                case 2:
                  u(f4(e4), v50);
                  var y = i4[1], T = function(A11) {
                    return u(n, A11);
                  }, E = function(A11) {
                    return u(t4, A11);
                  };
                  return R(yD[1], E, T, e4, y), u(f4(e4), l50);
                case 3:
                  u(f4(e4), b50);
                  var d = i4[1], w = function(A11) {
                    return u(n, A11);
                  }, G = function(A11) {
                    return u(t4, A11);
                  };
                  return R(OQ[1], G, w, e4, d), u(f4(e4), p50);
                default:
                  return u(f4(e4), m50), o(fQ[1], e4, i4[1]), u(f4(e4), _50);
              }
            }), N(AQ, function(t4, n, e4) {
              var i4 = o(km, t4, n);
              return o(C0(x50), i4, e4);
            }), N(wm, function(t4, n, e4, i4) {
              u(f4(e4), Pp0), o(f4(e4), Lp0, Dp0);
              var x4 = i4[1];
              function c(V) {
                return u(n, V);
              }
              function s2(V) {
                return u(t4, V);
              }
              R(EQ[1], s2, c, e4, x4), u(f4(e4), Rp0), u(f4(e4), jp0), o(f4(e4), Mp0, Gp0);
              var p = i4[2];
              if (p) {
                g(e4, Bp0);
                var y = p[1], T = function(V) {
                  return u(n, V);
                }, E = function(V) {
                  return u(t4, V);
                };
                R(FQ[1], E, T, e4, y), g(e4, qp0);
              } else
                g(e4, Up0);
              u(f4(e4), Hp0), u(f4(e4), Xp0), o(f4(e4), Vp0, Yp0);
              var d = i4[3];
              u(f4(e4), zp0), o(t4, e4, d[1]), u(f4(e4), Kp0), u(f4(e4), Wp0);
              var w = d[2], G = 0;
              le(function(V, f0) {
                V && u(f4(e4), Cp0);
                function m0(k0) {
                  return u(n, k0);
                }
                return R(Cl, function(k0) {
                  return u(t4, k0);
                }, m0, e4, f0), 1;
              }, G, w), u(f4(e4), Jp0), u(f4(e4), $p0), u(f4(e4), Zp0), u(f4(e4), Qp0), o(f4(e4), e50, r50);
              var A11 = i4[4];
              if (A11) {
                g(e4, n50);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, Np0);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, t50);
              } else
                g(e4, u50);
              return u(f4(e4), i50), u(f4(e4), f50);
            }), N(NQ, function(t4, n, e4) {
              var i4 = o(wm, t4, n);
              return o(C0(Ap0), i4, e4);
            }), N(Em, function(t4, n, e4, i4) {
              u(f4(e4), ip0), o(f4(e4), xp0, fp0), o(t4, e4, i4[1]), u(f4(e4), op0), u(f4(e4), ap0), o(f4(e4), sp0, cp0), o(t4, e4, i4[2]), u(f4(e4), vp0), u(f4(e4), lp0), o(f4(e4), pp0, bp0);
              var x4 = i4[3];
              u(f4(e4), mp0), o(t4, e4, x4[1]), u(f4(e4), _p0), u(f4(e4), yp0);
              var c = x4[2], s2 = 0;
              le(function(d, w) {
                d && u(f4(e4), up0);
                function G(A11) {
                  return u(n, A11);
                }
                return R(Cl, function(A11) {
                  return u(t4, A11);
                }, G, e4, w), 1;
              }, s2, c), u(f4(e4), hp0), u(f4(e4), dp0), u(f4(e4), kp0), u(f4(e4), wp0), o(f4(e4), Sp0, Ep0);
              var p = i4[4];
              if (p) {
                g(e4, gp0);
                var y = p[1], T = function(d, w) {
                  return g(d, tp0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, Fp0);
              } else
                g(e4, Tp0);
              return u(f4(e4), Op0), u(f4(e4), Ip0);
            }), N(CQ, function(t4, n, e4) {
              var i4 = o(Em, t4, n);
              return o(C0(np0), i4, e4);
            }), mu($3r, UN, [0, O1, mD, yD, fQ, sQ, bQ, yQ, Nl, hQ, EQ, FQ, OQ, Cl, IQ, km, AQ, wm, NQ, Em, CQ]);
            var SD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, PQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Sm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, DQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(SD, function(t4, n, e4, i4) {
              u(f4(e4), Q60), o(t4, e4, i4[1]), u(f4(e4), rp0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Sm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), ep0);
            }), N(PQ, function(t4, n, e4) {
              var i4 = o(SD, t4, n);
              return o(C0(Z60), i4, e4);
            }), N(Sm, function(t4, n, e4, i4) {
              u(f4(e4), B60), o(f4(e4), U60, q60);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(di[5], s2, c, e4, x4), u(f4(e4), H60), u(f4(e4), X60), o(f4(e4), V60, Y60);
              var p = i4[2];
              if (p) {
                g(e4, z60);
                var y = p[1], T = function(d, w) {
                  return g(d, M60);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, K60);
              } else
                g(e4, W60);
              return u(f4(e4), J60), u(f4(e4), $60);
            }), N(DQ, function(t4, n, e4) {
              var i4 = o(Sm, t4, n);
              return o(C0(G60), i4, e4);
            });
            var gD = [0, SD, PQ, Sm, DQ], gm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, LQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, FD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, RQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Fm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, jQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(gm, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  var x4 = i4[1];
                  u(f4(e4), I60), u(f4(e4), A60), o(t4, e4, x4[1]), u(f4(e4), N60);
                  var c = x4[2], s2 = function(G) {
                    return u(t4, G);
                  };
                  return ur(Tl[2], s2, e4, c), u(f4(e4), C60), u(f4(e4), P60);
                case 1:
                  u(f4(e4), D60);
                  var p = i4[1], y = function(G) {
                    return u(n, G);
                  }, T = function(G) {
                    return u(t4, G);
                  };
                  return R(Rn[1], T, y, e4, p), u(f4(e4), L60);
                default:
                  u(f4(e4), R60);
                  var E = i4[1], d = function(G) {
                    return u(n, G);
                  }, w = function(G) {
                    return u(t4, G);
                  };
                  return R(qp[1], w, d, e4, E), u(f4(e4), j60);
              }
            }), N(LQ, function(t4, n, e4) {
              var i4 = o(gm, t4, n);
              return o(C0(O60), i4, e4);
            }), N(FD, function(t4, n, e4, i4) {
              u(f4(e4), g60), o(t4, e4, i4[1]), u(f4(e4), F60);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Fm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), T60);
            }), N(RQ, function(t4, n, e4) {
              var i4 = o(FD, t4, n);
              return o(C0(S60), i4, e4);
            }), N(Fm, function(t4, n, e4, i4) {
              u(f4(e4), t60), o(f4(e4), i60, u60);
              var x4 = i4[1];
              function c(A11) {
                return u(n, A11);
              }
              R(gm, function(A11) {
                return u(t4, A11);
              }, c, e4, x4), u(f4(e4), f60), u(f4(e4), x60), o(f4(e4), a60, o60);
              var s2 = i4[2];
              function p(A11) {
                return u(n, A11);
              }
              function y(A11) {
                return u(t4, A11);
              }
              R(di[5], y, p, e4, s2), u(f4(e4), c60), u(f4(e4), s60), o(f4(e4), l60, v60);
              var T = i4[3];
              if (T) {
                g(e4, b60);
                var E = T[1], d = function(A11) {
                  return u(n, A11);
                }, w = function(A11) {
                  return u(t4, A11);
                };
                R(qe[31], w, d, e4, E), g(e4, p60);
              } else
                g(e4, m60);
              u(f4(e4), _60), u(f4(e4), y60), o(f4(e4), d60, h60);
              var G = i4[4];
              return o(f4(e4), k60, G), u(f4(e4), w60), u(f4(e4), E60);
            }), N(jQ, function(t4, n, e4) {
              var i4 = o(Fm, t4, n);
              return o(C0(n60), i4, e4);
            });
            var GQ = [0, gm, LQ, FD, RQ, Fm, jQ], Tm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, MQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, TD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, BQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(Tm, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                u(f4(e4), Z30);
                var x4 = i4[1], c = function(E) {
                  return u(n, E);
                }, s2 = function(E) {
                  return u(t4, E);
                };
                return R(GQ[3], s2, c, e4, x4), u(f4(e4), Q30);
              }
              u(f4(e4), r60);
              var p = i4[1];
              function y(E) {
                return u(n, E);
              }
              function T(E) {
                return u(t4, E);
              }
              return R(gD[1], T, y, e4, p), u(f4(e4), e60);
            }), N(MQ, function(t4, n, e4) {
              var i4 = o(Tm, t4, n);
              return o(C0($30), i4, e4);
            }), N(TD, function(t4, n, e4, i4) {
              u(f4(e4), P30), o(f4(e4), L30, D30);
              var x4 = i4[1];
              u(f4(e4), R30);
              var c = 0;
              le(function(G, A11) {
                G && u(f4(e4), C30);
                function S11(M) {
                  return u(n, M);
                }
                return R(Tm, function(M) {
                  return u(t4, M);
                }, S11, e4, A11), 1;
              }, c, x4), u(f4(e4), j30), u(f4(e4), G30), u(f4(e4), M30), o(f4(e4), q30, B30);
              var s2 = i4[2];
              function p(G) {
                return u(n, G);
              }
              function y(G) {
                return u(t4, G);
              }
              R($e[19], y, p, e4, s2), u(f4(e4), U30), u(f4(e4), H30), o(f4(e4), Y30, X30);
              var T = i4[3];
              if (T) {
                g(e4, V30);
                var E = T[1], d = function(G, A11) {
                  u(f4(G), A30);
                  var S11 = 0;
                  return le(function(M, K) {
                    M && u(f4(G), I30);
                    function V(f0) {
                      return u(t4, f0);
                    }
                    return ur(iu[1], V, G, K), 1;
                  }, S11, A11), u(f4(G), N30);
                }, w = function(G) {
                  return u(t4, G);
                };
                R(Dr[1], w, d, e4, E), g(e4, z30);
              } else
                g(e4, K30);
              return u(f4(e4), W30), u(f4(e4), J30);
            }), N(BQ, function(t4, n, e4) {
              var i4 = o(TD, t4, n);
              return o(C0(O30), i4, e4);
            });
            var qQ = [0, GQ, Tm, MQ, TD, BQ], OD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, UQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Om = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, HQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(OD, function(t4, n, e4, i4) {
              u(f4(e4), g30), o(t4, e4, i4[1]), u(f4(e4), F30);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Om, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), T30);
            }), N(UQ, function(t4, n, e4) {
              var i4 = o(OD, t4, n);
              return o(C0(S30), i4, e4);
            }), N(Om, function(t4, n, e4, i4) {
              u(f4(e4), v30), o(f4(e4), b30, l30);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(di[5], s2, c, e4, x4), u(f4(e4), p30), u(f4(e4), m30), o(f4(e4), y30, _30);
              var p = i4[2];
              if (p) {
                g(e4, h30);
                var y = p[1], T = function(d) {
                  return u(n, d);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(qe[31], E, T, e4, y), g(e4, d30);
              } else
                g(e4, k30);
              return u(f4(e4), w30), u(f4(e4), E30);
            }), N(HQ, function(t4, n, e4) {
              var i4 = o(Om, t4, n);
              return o(C0(s30), i4, e4);
            });
            var XQ = [0, OD, UQ, Om, HQ], Im = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, YQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, ID = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, VQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(Im, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), i30);
                  var x4 = i4[1], c = function(E) {
                    return u(n, E);
                  }, s2 = function(E) {
                    return u(t4, E);
                  };
                  return R(XQ[1], s2, c, e4, x4), u(f4(e4), f30);
                case 1:
                  u(f4(e4), x30);
                  var p = i4[1], y = function(E) {
                    return u(n, E);
                  }, T = function(E) {
                    return u(t4, E);
                  };
                  return R(gD[1], T, y, e4, p), u(f4(e4), o30);
                default:
                  return u(f4(e4), a30), o(t4, e4, i4[1]), u(f4(e4), c30);
              }
            }), N(YQ, function(t4, n, e4) {
              var i4 = o(Im, t4, n);
              return o(C0(u30), i4, e4);
            }), N(ID, function(t4, n, e4, i4) {
              u(f4(e4), B80), o(f4(e4), U80, q80);
              var x4 = i4[1];
              u(f4(e4), H80);
              var c = 0;
              le(function(G, A11) {
                G && u(f4(e4), M80);
                function S11(M) {
                  return u(n, M);
                }
                return R(Im, function(M) {
                  return u(t4, M);
                }, S11, e4, A11), 1;
              }, c, x4), u(f4(e4), X80), u(f4(e4), Y80), u(f4(e4), V80), o(f4(e4), K80, z80);
              var s2 = i4[2];
              function p(G) {
                return u(n, G);
              }
              function y(G) {
                return u(t4, G);
              }
              R($e[19], y, p, e4, s2), u(f4(e4), W80), u(f4(e4), J80), o(f4(e4), Z80, $80);
              var T = i4[3];
              if (T) {
                g(e4, Q80);
                var E = T[1], d = function(G, A11) {
                  u(f4(G), j80);
                  var S11 = 0;
                  return le(function(M, K) {
                    M && u(f4(G), R80);
                    function V(f0) {
                      return u(t4, f0);
                    }
                    return ur(iu[1], V, G, K), 1;
                  }, S11, A11), u(f4(G), G80);
                }, w = function(G) {
                  return u(t4, G);
                };
                R(Dr[1], w, d, e4, E), g(e4, r30);
              } else
                g(e4, e30);
              return u(f4(e4), n30), u(f4(e4), t30);
            }), N(VQ, function(t4, n, e4) {
              var i4 = o(ID, t4, n);
              return o(C0(L80), i4, e4);
            });
            var zQ = [0, XQ, Im, YQ, ID, VQ], AD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, KQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(AD, function(t4, n, e4, i4) {
              u(f4(e4), k80), o(f4(e4), E80, w80);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), S80), u(f4(e4), g80), o(f4(e4), T80, F80);
              var p = i4[2];
              function y(d) {
                return u(n, d);
              }
              function T(d) {
                return u(t4, d);
              }
              R($e[19], T, y, e4, p), u(f4(e4), O80), u(f4(e4), I80), o(f4(e4), N80, A80);
              var E = i4[3];
              return o(f4(e4), C80, E), u(f4(e4), P80), u(f4(e4), D80);
            }), N(KQ, function(t4, n, e4) {
              var i4 = o(AD, t4, n);
              return o(C0(d80), i4, e4);
            });
            var WQ = [0, AD, KQ], ND = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, JQ = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Am = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, $Q = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(ND, function(t4, n, e4, i4) {
              u(f4(e4), _80), o(n, e4, i4[1]), u(f4(e4), y80);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Am, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), h80);
            }), N(JQ, function(t4, n, e4) {
              var i4 = o(ND, t4, n);
              return o(C0(m80), i4, e4);
            }), N(Am, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), o80);
                  var x4 = i4[1], c = function(M) {
                    return u(n, M);
                  }, s2 = function(M) {
                    return u(t4, M);
                  };
                  return R(qQ[4], s2, c, e4, x4), u(f4(e4), a80);
                case 1:
                  u(f4(e4), c80);
                  var p = i4[1], y = function(M) {
                    return u(n, M);
                  }, T = function(M) {
                    return u(t4, M);
                  };
                  return R(zQ[4], T, y, e4, p), u(f4(e4), s80);
                case 2:
                  u(f4(e4), v80);
                  var E = i4[1], d = function(M) {
                    return u(n, M);
                  }, w = function(M) {
                    return u(t4, M);
                  };
                  return R(WQ[1], w, d, e4, E), u(f4(e4), l80);
                default:
                  u(f4(e4), b80);
                  var G = i4[1], A11 = function(M) {
                    return u(n, M);
                  }, S11 = function(M) {
                    return u(t4, M);
                  };
                  return R(qe[31], S11, A11, e4, G), u(f4(e4), p80);
              }
            }), N($Q, function(t4, n, e4) {
              var i4 = o(Am, t4, n);
              return o(C0(x80), i4, e4);
            }), mu(Z3r, di, [0, gD, qQ, zQ, WQ, ND, JQ, Am, $Q]);
            var CD = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, ZQ = function t4(n, e4) {
              return t4.fun(n, e4);
            }, Nm = function t4(n, e4) {
              return t4.fun(n, e4);
            }, QQ = function t4(n) {
              return t4.fun(n);
            }, Cm = function t4(n, e4) {
              return t4.fun(n, e4);
            }, r00 = function t4(n) {
              return t4.fun(n);
            };
            N(CD, function(t4, n, e4) {
              return u(f4(n), u80), o(t4, n, e4[1]), u(f4(n), i80), o(Cm, n, e4[2]), u(f4(n), f80);
            }), N(ZQ, function(t4, n) {
              var e4 = u(CD, t4);
              return o(C0(t80), e4, n);
            }), N(Nm, function(t4, n) {
              return n ? g(t4, e80) : g(t4, n80);
            }), N(QQ, function(t4) {
              return o(C0(r80), Nm, t4);
            }), N(Cm, function(t4, n) {
              u(f4(t4), M40), o(f4(t4), q40, B40), o(Nm, t4, n[1]), u(f4(t4), U40), u(f4(t4), H40), o(f4(t4), Y40, X40);
              var e4 = n[2];
              o(f4(t4), V40, e4), u(f4(t4), z40), u(f4(t4), K40), o(f4(t4), J40, W40);
              var i4 = n[3];
              return o(f4(t4), $40, i4), u(f4(t4), Z40), u(f4(t4), Q40);
            }), N(r00, function(t4) {
              return o(C0(G40), Cm, t4);
            }), mu(Q3r, iu, [0, CD, ZQ, Nm, QQ, Cm, r00]);
            var PD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, e00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Pm = function t4(n, e4) {
              return t4.fun(n, e4);
            }, n00 = function t4(n) {
              return t4.fun(n);
            }, Dm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, t00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(PD, function(t4, n, e4, i4) {
              u(f4(e4), L40), o(n, e4, i4[1]), u(f4(e4), R40);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Dm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), j40);
            }), N(e00, function(t4, n, e4) {
              var i4 = o(PD, t4, n);
              return o(C0(D40), i4, e4);
            }), N(Pm, function(t4, n) {
              switch (n) {
                case 0:
                  return g(t4, A40);
                case 1:
                  return g(t4, N40);
                case 2:
                  return g(t4, C40);
                default:
                  return g(t4, P40);
              }
            }), N(n00, function(t4) {
              return o(C0(I40), Pm, t4);
            }), N(Dm, function(t4, n, e4, i4) {
              u(f4(e4), Wb0), o(f4(e4), $b0, Jb0), o(Pm, e4, i4[1]), u(f4(e4), Zb0), u(f4(e4), Qb0), o(f4(e4), e40, r40);
              var x4 = i4[2];
              function c(V) {
                return u(n, V);
              }
              function s2(V) {
                return u(t4, V);
              }
              R(qe[7][1][1], s2, c, e4, x4), u(f4(e4), n40), u(f4(e4), t40), o(f4(e4), i40, u40);
              var p = i4[3];
              u(f4(e4), f40), o(t4, e4, p[1]), u(f4(e4), x40);
              var y = p[2];
              function T(V) {
                return u(n, V);
              }
              function E(V) {
                return u(t4, V);
              }
              R(As[5], E, T, e4, y), u(f4(e4), o40), u(f4(e4), a40), u(f4(e4), c40), o(f4(e4), v40, s40);
              var d = i4[4];
              o(f4(e4), l40, d), u(f4(e4), b40), u(f4(e4), p40), o(f4(e4), _40, m40);
              var w = i4[5];
              u(f4(e4), y40);
              var G = 0;
              le(function(V, f0) {
                V && u(f4(e4), Kb0);
                function m0(g0) {
                  return u(n, g0);
                }
                function k0(g0) {
                  return u(t4, g0);
                }
                return R(F1[7][1], k0, m0, e4, f0), 1;
              }, G, w), u(f4(e4), h40), u(f4(e4), d40), u(f4(e4), k40), o(f4(e4), E40, w40);
              var A11 = i4[6];
              if (A11) {
                g(e4, S40);
                var S11 = A11[1], M = function(V, f0) {
                  return g(V, zb0);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, g40);
              } else
                g(e4, F40);
              return u(f4(e4), T40), u(f4(e4), O40);
            }), N(t00, function(t4, n, e4) {
              var i4 = o(Dm, t4, n);
              return o(C0(Vb0), i4, e4);
            });
            var u00 = [0, PD, e00, Pm, n00, Dm, t00], DD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, i00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Lm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, f00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Rm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, x00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(DD, function(t4, n, e4, i4) {
              u(f4(e4), Hb0), o(n, e4, i4[1]), u(f4(e4), Xb0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Lm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Yb0);
            }), N(i00, function(t4, n, e4) {
              var i4 = o(DD, t4, n);
              return o(C0(Ub0), i4, e4);
            }), N(Lm, function(t4, n, e4, i4) {
              u(f4(e4), cb0), o(f4(e4), vb0, sb0);
              var x4 = i4[1];
              function c(m0) {
                return u(n, m0);
              }
              function s2(m0) {
                return u(t4, m0);
              }
              R(qe[7][1][1], s2, c, e4, x4), u(f4(e4), lb0), u(f4(e4), bb0), o(f4(e4), mb0, pb0);
              var p = i4[2];
              function y(m0) {
                return u(n, m0);
              }
              R(Rm, function(m0) {
                return u(t4, m0);
              }, y, e4, p), u(f4(e4), _b0), u(f4(e4), yb0), o(f4(e4), db0, hb0);
              var T = i4[3];
              function E(m0) {
                return u(n, m0);
              }
              function d(m0) {
                return u(t4, m0);
              }
              R($e[19], d, E, e4, T), u(f4(e4), kb0), u(f4(e4), wb0), o(f4(e4), Sb0, Eb0);
              var w = i4[4];
              o(f4(e4), gb0, w), u(f4(e4), Fb0), u(f4(e4), Tb0), o(f4(e4), Ib0, Ob0);
              var G = i4[5];
              if (G) {
                g(e4, Ab0);
                var A11 = G[1], S11 = function(m0) {
                  return u(t4, m0);
                };
                ur(zv[1], S11, e4, A11), g(e4, Nb0);
              } else
                g(e4, Cb0);
              u(f4(e4), Pb0), u(f4(e4), Db0), o(f4(e4), Rb0, Lb0);
              var M = i4[6];
              if (M) {
                g(e4, jb0);
                var K = M[1], V = function(m0, k0) {
                  return g(m0, ab0);
                }, f0 = function(m0) {
                  return u(t4, m0);
                };
                R(Dr[1], f0, V, e4, K), g(e4, Gb0);
              } else
                g(e4, Mb0);
              return u(f4(e4), Bb0), u(f4(e4), qb0);
            }), N(f00, function(t4, n, e4) {
              var i4 = o(Lm, t4, n);
              return o(C0(ob0), i4, e4);
            }), N(Rm, function(t4, n, e4, i4) {
              if (typeof i4 == "number")
                return i4 ? g(e4, ub0) : g(e4, ib0);
              u(f4(e4), fb0);
              var x4 = i4[1];
              function c(p) {
                return u(n, p);
              }
              function s2(p) {
                return u(t4, p);
              }
              return R(qe[31], s2, c, e4, x4), u(f4(e4), xb0);
            }), N(x00, function(t4, n, e4) {
              var i4 = o(Rm, t4, n);
              return o(C0(tb0), i4, e4);
            });
            var o00 = [0, DD, i00, Lm, f00, Rm, x00], LD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, a00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, jm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, c00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(LD, function(t4, n, e4, i4) {
              u(f4(e4), rb0), o(n, e4, i4[1]), u(f4(e4), eb0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(jm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), nb0);
            }), N(a00, function(t4, n, e4) {
              var i4 = o(LD, t4, n);
              return o(C0(Ql0), i4, e4);
            }), N(jm, function(t4, n, e4, i4) {
              u(f4(e4), kl0), o(f4(e4), El0, wl0);
              var x4 = i4[1];
              function c(m0) {
                return u(t4, m0);
              }
              ur(Bp[1], c, e4, x4), u(f4(e4), Sl0), u(f4(e4), gl0), o(f4(e4), Tl0, Fl0);
              var s2 = i4[2];
              function p(m0) {
                return u(n, m0);
              }
              function y(m0) {
                return u(t4, m0);
              }
              R(F1[2][5], y, p, e4, s2), u(f4(e4), Ol0), u(f4(e4), Il0), o(f4(e4), Nl0, Al0);
              var T = i4[3];
              function E(m0) {
                return u(n, m0);
              }
              function d(m0) {
                return u(t4, m0);
              }
              R($e[19], d, E, e4, T), u(f4(e4), Cl0), u(f4(e4), Pl0), o(f4(e4), Ll0, Dl0);
              var w = i4[4];
              o(f4(e4), Rl0, w), u(f4(e4), jl0), u(f4(e4), Gl0), o(f4(e4), Bl0, Ml0);
              var G = i4[5];
              if (G) {
                g(e4, ql0);
                var A11 = G[1], S11 = function(m0) {
                  return u(t4, m0);
                };
                ur(zv[1], S11, e4, A11), g(e4, Ul0);
              } else
                g(e4, Hl0);
              u(f4(e4), Xl0), u(f4(e4), Yl0), o(f4(e4), zl0, Vl0);
              var M = i4[6];
              if (M) {
                g(e4, Kl0);
                var K = M[1], V = function(m0, k0) {
                  return g(m0, dl0);
                }, f0 = function(m0) {
                  return u(t4, m0);
                };
                R(Dr[1], f0, V, e4, K), g(e4, Wl0);
              } else
                g(e4, Jl0);
              return u(f4(e4), $l0), u(f4(e4), Zl0);
            }), N(c00, function(t4, n, e4) {
              var i4 = o(jm, t4, n);
              return o(C0(hl0), i4, e4);
            });
            var s00 = [0, LD, a00, jm, c00], RD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, v00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Gm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, l00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(RD, function(t4, n, e4, i4) {
              u(f4(e4), ml0), o(t4, e4, i4[1]), u(f4(e4), _l0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Gm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), yl0);
            }), N(v00, function(t4, n, e4) {
              var i4 = o(RD, t4, n);
              return o(C0(pl0), i4, e4);
            }), N(Gm, function(t4, n, e4, i4) {
              u(f4(e4), J20), o(f4(e4), Z20, $20);
              var x4 = i4[1];
              function c(S11) {
                return u(n, S11);
              }
              function s2(S11) {
                return u(t4, S11);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), Q20), u(f4(e4), rl0), o(f4(e4), nl0, el0);
              var p = i4[2];
              if (p) {
                g(e4, tl0);
                var y = p[1], T = function(S11) {
                  return u(n, S11);
                }, E = function(S11) {
                  return u(t4, S11);
                };
                R($e[23][1], E, T, e4, y), g(e4, ul0);
              } else
                g(e4, il0);
              u(f4(e4), fl0), u(f4(e4), xl0), o(f4(e4), al0, ol0);
              var d = i4[3];
              if (d) {
                g(e4, cl0);
                var w = d[1], G = function(S11, M) {
                  return g(S11, W20);
                }, A11 = function(S11) {
                  return u(t4, S11);
                };
                R(Dr[1], A11, G, e4, w), g(e4, sl0);
              } else
                g(e4, vl0);
              return u(f4(e4), ll0), u(f4(e4), bl0);
            }), N(l00, function(t4, n, e4) {
              var i4 = o(Gm, t4, n);
              return o(C0(K20), i4, e4);
            });
            var b00 = [0, RD, v00, Gm, l00], jD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, p00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Mm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, m00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(jD, function(t4, n, e4, i4) {
              u(f4(e4), Y20), o(t4, e4, i4[1]), u(f4(e4), V20);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Mm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), z20);
            }), N(p00, function(t4, n, e4) {
              var i4 = o(jD, t4, n);
              return o(C0(X20), i4, e4);
            }), N(Mm, function(t4, n, e4, i4) {
              u(f4(e4), C20), o(f4(e4), D20, P20);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(Rn[1], s2, c, e4, x4), u(f4(e4), L20), u(f4(e4), R20), o(f4(e4), G20, j20);
              var p = i4[2];
              if (p) {
                g(e4, M20);
                var y = p[1], T = function(d) {
                  return u(n, d);
                }, E = function(d) {
                  return u(t4, d);
                };
                R($e[23][1], E, T, e4, y), g(e4, B20);
              } else
                g(e4, q20);
              return u(f4(e4), U20), u(f4(e4), H20);
            }), N(m00, function(t4, n, e4) {
              var i4 = o(Mm, t4, n);
              return o(C0(N20), i4, e4);
            });
            var _00 = [0, jD, p00, Mm, m00], GD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, y00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Bm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, h00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(GD, function(t4, n, e4, i4) {
              u(f4(e4), O20), o(t4, e4, i4[1]), u(f4(e4), I20);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Bm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), A20);
            }), N(y00, function(t4, n, e4) {
              var i4 = o(GD, t4, n);
              return o(C0(T20), i4, e4);
            }), N(Bm, function(t4, n, e4, i4) {
              u(f4(e4), l20), o(f4(e4), p20, b20);
              var x4 = i4[1];
              u(f4(e4), m20);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), v20);
                function w(A11) {
                  return u(n, A11);
                }
                function G(A11) {
                  return u(t4, A11);
                }
                return R(_00[1], G, w, e4, d), 1;
              }, c, x4), u(f4(e4), _20), u(f4(e4), y20), u(f4(e4), h20), o(f4(e4), k20, d20);
              var s2 = i4[2];
              if (s2) {
                g(e4, w20);
                var p = s2[1], y = function(E, d) {
                  return g(E, s20);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, E20);
              } else
                g(e4, S20);
              return u(f4(e4), g20), u(f4(e4), F20);
            }), N(h00, function(t4, n, e4) {
              var i4 = o(Bm, t4, n);
              return o(C0(c20), i4, e4);
            });
            var d00 = [0, _00, GD, y00, Bm, h00], MD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, k00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, qm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, w00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Um = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, E00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(MD, function(t4, n, e4, i4) {
              u(f4(e4), x20), o(t4, e4, i4[1]), u(f4(e4), o20);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(qm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), a20);
            }), N(k00, function(t4, n, e4) {
              var i4 = o(MD, t4, n);
              return o(C0(f20), i4, e4);
            }), N(qm, function(t4, n, e4, i4) {
              u(f4(e4), Vv0), o(f4(e4), Kv0, zv0);
              var x4 = i4[1];
              u(f4(e4), Wv0);
              var c = 0;
              le(function(E, d) {
                E && u(f4(e4), Yv0);
                function w(G) {
                  return u(n, G);
                }
                return R(Um, function(G) {
                  return u(t4, G);
                }, w, e4, d), 1;
              }, c, x4), u(f4(e4), Jv0), u(f4(e4), $v0), u(f4(e4), Zv0), o(f4(e4), r20, Qv0);
              var s2 = i4[2];
              if (s2) {
                g(e4, e20);
                var p = s2[1], y = function(E, d) {
                  return g(E, Xv0);
                }, T = function(E) {
                  return u(t4, E);
                };
                R(Dr[1], T, y, e4, p), g(e4, n20);
              } else
                g(e4, t20);
              return u(f4(e4), u20), u(f4(e4), i20);
            }), N(w00, function(t4, n, e4) {
              var i4 = o(qm, t4, n);
              return o(C0(Hv0), i4, e4);
            }), N(Um, function(t4, n, e4, i4) {
              switch (i4[0]) {
                case 0:
                  u(f4(e4), jv0);
                  var x4 = i4[1], c = function(G) {
                    return u(n, G);
                  }, s2 = function(G) {
                    return u(t4, G);
                  };
                  return R(u00[1], s2, c, e4, x4), u(f4(e4), Gv0);
                case 1:
                  u(f4(e4), Mv0);
                  var p = i4[1], y = function(G) {
                    return u(n, G);
                  }, T = function(G) {
                    return u(t4, G);
                  };
                  return R(o00[1], T, y, e4, p), u(f4(e4), Bv0);
                default:
                  u(f4(e4), qv0);
                  var E = i4[1], d = function(G) {
                    return u(n, G);
                  }, w = function(G) {
                    return u(t4, G);
                  };
                  return R(s00[1], w, d, e4, E), u(f4(e4), Uv0);
              }
            }), N(E00, function(t4, n, e4) {
              var i4 = o(Um, t4, n);
              return o(C0(Rv0), i4, e4);
            });
            var BD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, S00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Hm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, g00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, gee = [0, MD, k00, qm, w00, Um, E00];
            N(BD, function(t4, n, e4, i4) {
              u(f4(e4), Pv0), o(t4, e4, i4[1]), u(f4(e4), Dv0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Hm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Lv0);
            }), N(S00, function(t4, n, e4) {
              var i4 = o(BD, t4, n);
              return o(C0(Cv0), i4, e4);
            }), N(Hm, function(t4, n, e4, i4) {
              u(f4(e4), dv0), o(f4(e4), wv0, kv0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(qe[31], s2, c, e4, x4), u(f4(e4), Ev0), u(f4(e4), Sv0), o(f4(e4), Fv0, gv0);
              var p = i4[2];
              if (p) {
                g(e4, Tv0);
                var y = p[1], T = function(d, w) {
                  return g(d, hv0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, Ov0);
              } else
                g(e4, Iv0);
              return u(f4(e4), Av0), u(f4(e4), Nv0);
            }), N(g00, function(t4, n, e4) {
              var i4 = o(Hm, t4, n);
              return o(C0(yv0), i4, e4);
            });
            var F00 = [0, BD, S00, Hm, g00], qD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, T00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(qD, function(t4, n, e4, i4) {
              u(f4(e4), F10), o(f4(e4), O10, T10);
              var x4 = i4[1];
              if (x4) {
                g(e4, I10);
                var c = x4[1], s2 = function(w0) {
                  return u(n, w0);
                }, p = function(w0) {
                  return u(t4, w0);
                };
                R(Rn[1], p, s2, e4, c), g(e4, A10);
              } else
                g(e4, N10);
              u(f4(e4), C10), u(f4(e4), P10), o(f4(e4), L10, D10);
              var y = i4[2];
              function T(w0) {
                return u(n, w0);
              }
              function E(w0) {
                return u(t4, w0);
              }
              R(F1[6][1], E, T, e4, y), u(f4(e4), R10), u(f4(e4), j10), o(f4(e4), M10, G10);
              var d = i4[3];
              if (d) {
                g(e4, B10);
                var w = d[1], G = function(w0) {
                  return u(n, w0);
                }, A11 = function(w0) {
                  return u(t4, w0);
                };
                R($e[22][1], A11, G, e4, w), g(e4, q10);
              } else
                g(e4, U10);
              u(f4(e4), H10), u(f4(e4), X10), o(f4(e4), V10, Y10);
              var S11 = i4[4];
              if (S11) {
                g(e4, z10);
                var M = S11[1], K = function(w0) {
                  return u(n, w0);
                }, V = function(w0) {
                  return u(t4, w0);
                };
                R(b00[1], V, K, e4, M), g(e4, K10);
              } else
                g(e4, W10);
              u(f4(e4), J10), u(f4(e4), $10), o(f4(e4), Q10, Z10);
              var f0 = i4[5];
              if (f0) {
                g(e4, rv0);
                var m0 = f0[1], k0 = function(w0) {
                  return u(n, w0);
                }, g0 = function(w0) {
                  return u(t4, w0);
                };
                R(d00[2], g0, k0, e4, m0), g(e4, ev0);
              } else
                g(e4, nv0);
              u(f4(e4), tv0), u(f4(e4), uv0), o(f4(e4), fv0, iv0);
              var e0 = i4[6];
              u(f4(e4), xv0);
              var x0 = 0;
              le(function(w0, _0) {
                w0 && u(f4(e4), g10);
                function E0(b) {
                  return u(n, b);
                }
                function U0(b) {
                  return u(t4, b);
                }
                return R(F00[1], U0, E0, e4, _0), 1;
              }, x0, e0), u(f4(e4), ov0), u(f4(e4), av0), u(f4(e4), cv0), o(f4(e4), vv0, sv0);
              var l = i4[7];
              if (l) {
                g(e4, lv0);
                var c0 = l[1], t0 = function(w0, _0) {
                  return g(w0, S10);
                }, o0 = function(w0) {
                  return u(t4, w0);
                };
                R(Dr[1], o0, t0, e4, c0), g(e4, bv0);
              } else
                g(e4, pv0);
              return u(f4(e4), mv0), u(f4(e4), _v0);
            }), N(T00, function(t4, n, e4) {
              var i4 = o(qD, t4, n);
              return o(C0(E10), i4, e4);
            }), mu(r6r, F1, [0, u00, o00, s00, b00, d00, gee, F00, qD, T00]);
            var UD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, O00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Xm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, I00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(UD, function(t4, n, e4, i4) {
              u(f4(e4), d10), o(t4, e4, i4[1]), u(f4(e4), k10);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Xm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), w10);
            }), N(O00, function(t4, n, e4) {
              var i4 = o(UD, t4, n);
              return o(C0(h10), i4, e4);
            }), N(Xm, function(t4, n, e4, i4) {
              u(f4(e4), x10), o(f4(e4), a10, o10);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(di[5], s2, c, e4, x4), u(f4(e4), c10), u(f4(e4), s10), o(f4(e4), l10, v10);
              var p = i4[2];
              if (p) {
                g(e4, b10);
                var y = p[1], T = function(d, w) {
                  return g(d, f10);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, p10);
              } else
                g(e4, m10);
              return u(f4(e4), _10), u(f4(e4), y10);
            }), N(I00, function(t4, n, e4) {
              var i4 = o(Xm, t4, n);
              return o(C0(i10), i4, e4);
            });
            var A00 = [0, UD, O00, Xm, I00], HD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, N00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Ym = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, C00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(HD, function(t4, n, e4, i4) {
              u(f4(e4), n10), o(t4, e4, i4[1]), u(f4(e4), t10);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Ym, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), u10);
            }), N(N00, function(t4, n, e4) {
              var i4 = o(HD, t4, n);
              return o(C0(e10), i4, e4);
            }), N(Ym, function(t4, n, e4, i4) {
              u(f4(e4), Hs0), o(f4(e4), Ys0, Xs0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R(di[5], s2, c, e4, x4), u(f4(e4), Vs0), u(f4(e4), zs0), o(f4(e4), Ws0, Ks0);
              var p = i4[2];
              if (p) {
                g(e4, Js0);
                var y = p[1], T = function(d) {
                  return u(n, d);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(qe[31], E, T, e4, y), g(e4, $s0);
              } else
                g(e4, Zs0);
              return u(f4(e4), Qs0), u(f4(e4), r10);
            }), N(C00, function(t4, n, e4) {
              var i4 = o(Ym, t4, n);
              return o(C0(Us0), i4, e4);
            });
            var P00 = [0, HD, N00, Ym, C00], XD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, D00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Vm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, L00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(XD, function(t4, n, e4, i4) {
              u(f4(e4), Ms0), o(t4, e4, i4[1]), u(f4(e4), Bs0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Vm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), qs0);
            }), N(D00, function(t4, n, e4) {
              var i4 = o(XD, t4, n);
              return o(C0(Gs0), i4, e4);
            }), N(Vm, function(t4, n, e4, i4) {
              u(f4(e4), Fs0), o(f4(e4), Os0, Ts0);
              var x4 = i4[1];
              function c(d) {
                return u(n, d);
              }
              function s2(d) {
                return u(t4, d);
              }
              R($e[17], s2, c, e4, x4), u(f4(e4), Is0), u(f4(e4), As0), o(f4(e4), Cs0, Ns0);
              var p = i4[2];
              if (p) {
                g(e4, Ps0);
                var y = p[1], T = function(d, w) {
                  return g(d, gs0);
                }, E = function(d) {
                  return u(t4, d);
                };
                R(Dr[1], E, T, e4, y), g(e4, Ds0);
              } else
                g(e4, Ls0);
              return u(f4(e4), Rs0), u(f4(e4), js0);
            }), N(L00, function(t4, n, e4) {
              var i4 = o(Vm, t4, n);
              return o(C0(Ss0), i4, e4);
            });
            var R00 = [0, XD, D00, Vm, L00], YD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, j00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, zm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, G00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(YD, function(t4, n, e4, i4) {
              u(f4(e4), ks0), o(t4, e4, i4[1]), u(f4(e4), ws0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(zm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Es0);
            }), N(j00, function(t4, n, e4) {
              var i4 = o(YD, t4, n);
              return o(C0(ds0), i4, e4);
            }), N(zm, function(t4, n, e4, i4) {
              u(f4(e4), Vc0), o(f4(e4), Kc0, zc0);
              var x4 = i4[1];
              if (x4) {
                g(e4, Wc0);
                var c = x4[1], s2 = function(V) {
                  return u(n, V);
                }, p = function(V) {
                  return u(t4, V);
                };
                R(R00[1], p, s2, e4, c), g(e4, Jc0);
              } else
                g(e4, $c0);
              u(f4(e4), Zc0), u(f4(e4), Qc0), o(f4(e4), es0, rs0);
              var y = i4[2];
              u(f4(e4), ns0);
              var T = 0;
              le(function(V, f0) {
                V && u(f4(e4), Yc0);
                function m0(g0) {
                  return u(n, g0);
                }
                function k0(g0) {
                  return u(t4, g0);
                }
                return R(P00[1], k0, m0, e4, f0), 1;
              }, T, y), u(f4(e4), ts0), u(f4(e4), us0), u(f4(e4), is0), o(f4(e4), xs0, fs0);
              var E = i4[3];
              if (E) {
                g(e4, os0);
                var d = E[1], w = function(V) {
                  return u(n, V);
                }, G = function(V) {
                  return u(t4, V);
                };
                R(A00[1], G, w, e4, d), g(e4, as0);
              } else
                g(e4, cs0);
              u(f4(e4), ss0), u(f4(e4), vs0), o(f4(e4), bs0, ls0);
              var A11 = i4[4];
              if (A11) {
                g(e4, ps0);
                var S11 = A11[1], M = function(V, f0) {
                  u(f4(V), Hc0);
                  var m0 = 0;
                  return le(function(k0, g0) {
                    k0 && u(f4(V), Uc0);
                    function e0(x0) {
                      return u(t4, x0);
                    }
                    return ur(iu[1], e0, V, g0), 1;
                  }, m0, f0), u(f4(V), Xc0);
                }, K = function(V) {
                  return u(t4, V);
                };
                R(Dr[1], K, M, e4, S11), g(e4, ms0);
              } else
                g(e4, _s0);
              return u(f4(e4), ys0), u(f4(e4), hs0);
            }), N(G00, function(t4, n, e4) {
              var i4 = o(zm, t4, n);
              return o(C0(qc0), i4, e4);
            });
            var M00 = [0, YD, j00, zm, G00], VD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, B00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Km = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, q00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(VD, function(t4, n, e4, i4) {
              u(f4(e4), Ba0), o(f4(e4), Ua0, qa0);
              var x4 = i4[1];
              if (x4) {
                g(e4, Ha0);
                var c = x4[1], s2 = function(_0) {
                  return u(n, _0);
                }, p = function(_0) {
                  return u(t4, _0);
                };
                R(Rn[1], p, s2, e4, c), g(e4, Xa0);
              } else
                g(e4, Ya0);
              u(f4(e4), Va0), u(f4(e4), za0), o(f4(e4), Wa0, Ka0);
              var y = i4[2];
              function T(_0) {
                return u(n, _0);
              }
              function E(_0) {
                return u(t4, _0);
              }
              R(M00[1], E, T, e4, y), u(f4(e4), Ja0), u(f4(e4), $a0), o(f4(e4), Qa0, Za0);
              var d = i4[3];
              function w(_0) {
                return u(n, _0);
              }
              R(Km, function(_0) {
                return u(t4, _0);
              }, w, e4, d), u(f4(e4), rc0), u(f4(e4), ec0), o(f4(e4), tc0, nc0);
              var G = i4[4];
              o(f4(e4), uc0, G), u(f4(e4), ic0), u(f4(e4), fc0), o(f4(e4), oc0, xc0);
              var A11 = i4[5];
              o(f4(e4), ac0, A11), u(f4(e4), cc0), u(f4(e4), sc0), o(f4(e4), lc0, vc0);
              var S11 = i4[6];
              if (S11) {
                g(e4, bc0);
                var M = S11[1], K = function(_0) {
                  return u(n, _0);
                }, V = function(_0) {
                  return u(t4, _0);
                };
                R($e[24][1], V, K, e4, M), g(e4, pc0);
              } else
                g(e4, mc0);
              u(f4(e4), _c0), u(f4(e4), yc0), o(f4(e4), dc0, hc0);
              var f0 = i4[7];
              function m0(_0) {
                return u(n, _0);
              }
              function k0(_0) {
                return u(t4, _0);
              }
              R($e[19], k0, m0, e4, f0), u(f4(e4), kc0), u(f4(e4), wc0), o(f4(e4), Sc0, Ec0);
              var g0 = i4[8];
              if (g0) {
                g(e4, gc0);
                var e0 = g0[1], x0 = function(_0) {
                  return u(n, _0);
                }, l = function(_0) {
                  return u(t4, _0);
                };
                R($e[22][1], l, x0, e4, e0), g(e4, Fc0);
              } else
                g(e4, Tc0);
              u(f4(e4), Oc0), u(f4(e4), Ic0), o(f4(e4), Nc0, Ac0);
              var c0 = i4[9];
              if (c0) {
                g(e4, Cc0);
                var t0 = c0[1], o0 = function(_0, E0) {
                  return g(_0, Ma0);
                }, w0 = function(_0) {
                  return u(t4, _0);
                };
                R(Dr[1], w0, o0, e4, t0), g(e4, Pc0);
              } else
                g(e4, Dc0);
              return u(f4(e4), Lc0), u(f4(e4), Rc0), o(f4(e4), Gc0, jc0), o(t4, e4, i4[10]), u(f4(e4), Mc0), u(f4(e4), Bc0);
            }), N(B00, function(t4, n, e4) {
              var i4 = o(VD, t4, n);
              return o(C0(Ga0), i4, e4);
            }), N(Km, function(t4, n, e4, i4) {
              if (i4[0] === 0) {
                var x4 = i4[1];
                u(f4(e4), Na0), u(f4(e4), Ca0), o(t4, e4, x4[1]), u(f4(e4), Pa0);
                var c = x4[2], s2 = function(d) {
                  return u(n, d);
                }, p = function(d) {
                  return u(t4, d);
                };
                return R(Yu[1][1], p, s2, e4, c), u(f4(e4), Da0), u(f4(e4), La0);
              }
              u(f4(e4), Ra0);
              var y = i4[1];
              function T(d) {
                return u(n, d);
              }
              function E(d) {
                return u(t4, d);
              }
              return R(qe[31], E, T, e4, y), u(f4(e4), ja0);
            }), N(q00, function(t4, n, e4) {
              var i4 = o(Km, t4, n);
              return o(C0(Aa0), i4, e4);
            }), mu(e6r, As, [0, A00, P00, R00, M00, VD, B00, Km, q00]);
            var zD = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, U00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Wm = function t4(n, e4, i4, x4) {
              return t4.fun(n, e4, i4, x4);
            }, H00 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            };
            N(zD, function(t4, n, e4, i4) {
              u(f4(e4), Ta0), o(t4, e4, i4[1]), u(f4(e4), Oa0);
              var x4 = i4[2];
              function c(s2) {
                return u(n, s2);
              }
              return R(Wm, function(s2) {
                return u(t4, s2);
              }, c, e4, x4), u(f4(e4), Ia0);
            }), N(U00, function(t4, n, e4) {
              var i4 = o(zD, t4, n);
              return o(C0(Fa0), i4, e4);
            }), N(Wm, function(t4, n, e4, i4) {
              u(f4(e4), fa0), o(f4(e4), oa0, xa0);
              var x4 = i4[1];
              u(f4(e4), aa0);
              var c = 0;
              le(function(w, G) {
                w && u(f4(e4), ia0);
                function A11(M) {
                  return u(n, M);
                }
                function S11(M) {
                  return u(t4, M);
                }
                return R(Yu[35], S11, A11, e4, G), 1;
              }, c, x4), u(f4(e4), ca0), u(f4(e4), sa0), u(f4(e4), va0), o(f4(e4), ba0, la0);
              var s2 = i4[2];
              if (s2) {
                g(e4, pa0);
                var p = s2[1], y = function(w, G) {
                  return g(w, ua0);
                }, T = function(w) {
                  return u(t4, w);
                };
                R(Dr[1], T, y, e4, p), g(e4, ma0);
              } else
                g(e4, _a0);
              u(f4(e4), ya0), u(f4(e4), ha0), o(f4(e4), ka0, da0);
              var E = i4[3];
              u(f4(e4), wa0);
              var d = 0;
              return le(function(w, G) {
                w && u(f4(e4), ta0);
                function A11(S11) {
                  return u(t4, S11);
                }
                return ur(iu[1], A11, e4, G), 1;
              }, d, E), u(f4(e4), Ea0), u(f4(e4), Sa0), u(f4(e4), ga0);
            }), N(H00, function(t4, n, e4) {
              var i4 = o(Wm, t4, n);
              return o(C0(na0), i4, e4);
            }), mu(n6r, kee, [0, zD, U00, Wm, H00]);
            function ze(t4, n) {
              if (n) {
                var e4 = n[1], i4 = u(t4, e4);
                return e4 === i4 ? n : [0, i4];
              }
              return n;
            }
            function te(t4, n, e4, i4, x4) {
              var c = o(t4, n, e4);
              return e4 === c ? i4 : u(x4, c);
            }
            function ee(t4, n, e4, i4) {
              var x4 = u(t4, n);
              return n === x4 ? e4 : u(i4, x4);
            }
            function _u(t4, n) {
              var e4 = n[1];
              function i4(x4) {
                return [0, e4, x4];
              }
              return te(t4, e4, n[2], n, i4);
            }
            function Un(t4, n) {
              var e4 = le(function(i4, x4) {
                var c = u(t4, x4), s2 = i4[2], p = s2 || (c !== x4 ? 1 : 0);
                return [0, [0, c, i4[1]], p];
              }, l6r, n);
              return e4[2] ? ye(e4[1]) : n;
            }
            var KD = Rp(p6r, function(t4) {
              var n = NN(t4, b6r), e4 = n[1], i4 = n[2], x4 = n[3], c = n[4], s2 = n[5], p = n[6], y = n[7], T = n[8], E = n[9], d = n[10], w = n[11], G = n[12], A11 = n[13], S11 = n[14], M = n[15], K = n[16], V = n[17], f0 = n[18], m0 = n[19], k0 = n[20], g0 = n[21], e0 = n[22], x0 = n[23], l = n[24], c0 = n[25], t0 = n[26], o0 = n[27], w0 = n[28], _0 = n[29], E0 = n[30], U0 = n[31], b = n[32], R0 = n[33], X = n[34], s0 = n[35], hr = n[36], Ar = n[37], or = n[38], W0 = n[39], Lr = n[40], Tr = n[41], Hr = n[42], Or = n[43], fr = n[44], Rr = n[45], Wr = n[46], Jr = n[47], ar = n[49], _r = n[50], Ir = n[51], fe = n[52], v0 = n[53], P = n[54], L = n[55], Q = n[56], i0 = n[57], l0 = n[58], S0 = n[59], T0 = n[60], rr = n[61], L0 = n[62], B = n[63], Z7 = n[65], p0 = n[66], b0 = n[67], O0 = n[68], M0 = n[69], er = n[70], yr = n[71], vr = n[72], $0 = n[73], Er = n[74], Mr = n[75], Br = n[76], qr = n[77], jr = n[78], $r = n[79], ne = n[80], Qr = n[81], be = n[82], ae = n[83], pe = n[84], oe = n[85], ce = n[86], ge = n[87], q0 = n[88], Fr = n[89], _ = n[90], k = n[91], I = n[92], U = n[93], Y = n[94], y0 = n[95], P0 = n[96], I0 = n[97], D = n[98], u0 = n[99], X0 = n[ti], J0 = n[R7], ir = n[Ri], Q0 = n[s7], F0 = n[L7], Sr = n[j7], mr = n[Yt], Cr = n[Zc], sr = n[is], Pr = n[Fv], K0 = n[Xt], Ur = n[cf], h0 = n[T7], Kr = n[Pn], re = n[t1], xe = n[Av], Re = n[f1], ve = n[A2], Ie = n[z2], Ge = n[Sv], Me = n[uc], an = n[tl], We = n[In], Ae = n[ts], cn = n[X2], rn = n[br], kn = n[IX], vn = n[zn], Ne = n[jt], Je = n[JY], en = n[zw], _n = n[Jg], Cn = n[BH], Hn = n[133], Fn = n[134], vt = n[135], Nt = n[KH], gt = n[137], Zt = n[EH], qt = n[139], Ft = n[dH], Ct = n[141], du = n[142], Wu = n[143], lt = n[iV], ou = n[145], Bu = n[146], K7 = n[DX], Yi = n[148], a7 = n[eH], Hc = n[150], W7 = n[151], Ut = n[152], bt = n[153], B0 = n[FH], D0 = n[155], Le = n[156], He = n[157], he = n[158], me = n[159], Zn = n[fY], wn = n[XU], ft = n[kh], xt = n[Ln], jn = n[AF], ut = n[$X], dt = n[DY], xn = n[NT], ln = n[IY], it = n[NX], Tt = n[qg], Ti = n[pg], hs = n[LU], Au = n[_Y], Hs = n[$U], Vi = n[bX], Xs = n[mV], Ys = n[uV], nn = n[gO], si = n[RY], Vs = n[sU], c2 = n[Ai], M9 = n[Yg], B9 = n[lS], q9 = n[hk], zs = n[gU], s22 = n[md], U9 = n[nw], H9 = n[iY], X9 = n[fX], H1 = n[OY], vi = n[lX], ab = n[rt], cb = n[HT], sb = n[nI], Y9 = n[xY], V9 = n[XX], z9 = n[hY], vb = n[vH], K9 = n[QH], W9 = n[NU], J9 = n[sY], $9 = n[nH], lb = n[eV], Z9 = n[WX], X1 = n[VH], v2 = n[TH], bb = n[AX], pb = n[_H], mb = n[Wg], On = n[A6], Gn = n[yU], Y1 = n[yY], _b = n[RX], yb = n[mT], Q9 = n[xT], Xc = n[y6], r_ = n[cp], l2 = n[Cw], hb = n[FU], Yc = n[iA], e_ = n[GX], Ks = n[FX], db = n[y8], V1 = n[hv], n_ = n[BO], ds = n[rk], t_ = n[JH], z1 = n[fV], u_ = n[bU], b2 = n[jh], i_ = n[qX], Ws = n[ZF], kb = n[hT], Js = n[tH], f_ = n[JU], zi = n[lO], Vc = n[BY], $s = n[cH], x_ = n[i6], p2 = n[s1], m2 = n[Vy], _2 = n[ST], o_ = n[QU], Zs = n[v8], a_ = n[WY], y2 = n[$2], qL = n[48], K1 = n[64];
              function UL(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = ze(u(a[1][1 + nn], a), H), r0 = o(a[1][1 + s0], a, O);
                return O === r0 && H === $ ? m11 : [0, $, r0, m11[3], m11[4]];
              }
              function W1(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + Vc], a, r0), V0 = ze(u(a[1][1 + V], a), $), Nr = o(a[1][1 + t0], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && H === Nr && $ === V0 && O === Gr ? m11 : [0, j0, V0, Nr, Gr];
              }
              function HL(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + Or], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function J1(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + _r], a, $), j0 = o(a[1][1 + Or], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function XL(a, F11, m11) {
                var O = m11[2], H = O[2], $ = O[1], r0 = ur(a[1][1 + p], a, F11, $), j0 = ze(u(a[1][1 + nn], a), H);
                return $ === r0 && H === j0 ? m11 : [0, m11[1], [0, r0, j0]];
              }
              function Oi(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = Un(o(a[1][1 + y], a, H), $), j0 = o(a[1][1 + s0], a, O);
                return $ === r0 && O === j0 ? m11 : [0, r0, H, j0];
              }
              function YL(a, F11, m11) {
                var O = m11[4], H = m11[2], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, m11[1], $, m11[3], r0];
              }
              function VL(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, m11[1], $, r0];
              }
              function h22(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + l], a, H), V0 = o(a[1][1 + s0], a, O);
                return r0 === $ && j0 === H && V0 === O ? m11 : [0, r0, j0, V0];
              }
              function zL(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = _u(u(a[1][1 + zi], a), r0);
                if ($)
                  var V0 = $[1], Nr = V0[1], Gr = function(Qt) {
                    return [0, [0, Nr, Qt]];
                  }, Fe = V0[2], _e = te(u(a[1][1 + z1], a), Nr, Fe, $, Gr);
                else
                  var _e = $;
                if (H)
                  var Dn = H[1], yn = Dn[1], ot = function(Qt) {
                    return [0, [0, yn, Qt]];
                  }, pt = Dn[2], kt = te(u(a[1][1 + zi], a), yn, pt, H, ot);
                else
                  var kt = H;
                var Kn = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === _e && H === kt && O === Kn ? m11 : [0, j0, _e, kt, Kn];
              }
              function $1(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function KL(a, F11, m11) {
                var O = m11[1], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, H];
              }
              function Z1(a, F11) {
                return F11;
              }
              function WL(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = Un(u(a[1][1 + b], a), $), j0 = Un(u(a[1][1 + nn], a), H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function wb(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + nn], a, $), j0 = _u(u(a[1][1 + R0], a), H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function JL(a, F11) {
                var m11 = F11[2], O = m11[3], H = m11[2], $ = m11[1], r0 = ze(u(a[1][1 + nn], a), $), j0 = o(a[1][1 + Tr], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? F11 : [0, F11[1], [0, r0, j0, V0]];
              }
              function Eb(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + nn], a, $), j0 = Un(u(a[1][1 + Ar], a), H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0, m11[4]];
              }
              function $L(a, F11, m11) {
                var O = m11[1], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, H];
              }
              function ZL(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function d2(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function QL(a, F11) {
                return [0, o(a[1][1 + Or], a, F11), 0];
              }
              function rR(a, F11) {
                var m11 = u(a[1][1 + Hr], a), O = le(function(H, $) {
                  var r0 = H[1], j0 = u(m11, $);
                  if (j0) {
                    if (j0[2])
                      return [0, Lc(j0, r0), 1];
                    var V0 = j0[1], Nr = H[2], Gr = Nr || ($ !== V0 ? 1 : 0);
                    return [0, [0, V0, r0], Gr];
                  }
                  return [0, r0, 1];
                }, v6r, F11);
                return O[2] ? ye(O[1]) : F11;
              }
              function c_(a, F11) {
                return o(a[1][1 + Tr], a, F11);
              }
              function eR(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = Un(u(a[1][1 + nn], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function k2(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = ze(u(a[1][1 + nn], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0, m11[3]];
              }
              function nR(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + Le], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function w2(a, F11) {
                return o(a[1][1 + nn], a, F11);
              }
              function tR(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1];
                if (H)
                  var $ = function(Nr) {
                    return [0, Nr];
                  }, r0 = H[1], j0 = ee(u(a[1][1 + nn], a), r0, H, $);
                else
                  var j0 = H;
                var V0 = o(a[1][1 + s0], a, O);
                return H === j0 && O === V0 ? F11 : [0, F11[1], [0, j0, V0]];
              }
              function Q1(a, F11) {
                return o(a[1][1 + nn], a, F11);
              }
              function uR(a, F11, m11) {
                return ur(a[1][1 + er], a, F11, m11);
              }
              function Sb(a, F11, m11) {
                return ur(a[1][1 + er], a, F11, m11);
              }
              function iR(a, F11, m11) {
                var O = m11[2], H = O[2], $ = O[1], r0 = ur(a[1][1 + Z7], a, F11, $), j0 = o(a[1][1 + s0], a, H);
                return r0 === $ && H === j0 ? m11 : [0, m11[1], [0, r0, j0]];
              }
              function gb(a, F11, m11) {
                return ur(a[1][1 + er], a, F11, m11);
              }
              function fR(a, F11, m11) {
                var O = m11[2], H = O[2], $ = O[1], r0 = ur(a[1][1 + b0], a, F11, $), j0 = ze(u(a[1][1 + nn], a), H);
                return $ === r0 && H === j0 ? m11 : [0, m11[1], [0, r0, j0]];
              }
              function Fb(a, F11, m11) {
                switch (m11[0]) {
                  case 0:
                    var O = function(j0) {
                      return [0, j0];
                    }, H = m11[1];
                    return ee(o(a[1][1 + O0], a, F11), H, m11, O);
                  case 1:
                    var $ = function(j0) {
                      return [1, j0];
                    }, r0 = m11[1];
                    return ee(o(a[1][1 + p0], a, F11), r0, m11, $);
                  default:
                    return m11;
                }
              }
              function xR(a, F11, m11) {
                return ur(a[1][1 + er], a, F11, m11);
              }
              function Mn(a, F11, m11) {
                return ur(a[1][1 + er], a, F11, m11);
              }
              function s_(a, F11, m11) {
                var O = m11[2], H = O[2], $ = O[1], r0 = ur(a[1][1 + fe], a, F11, $), j0 = o(a[1][1 + s0], a, H);
                return r0 === $ && H === j0 ? m11 : [0, m11[1], [0, r0, j0]];
              }
              function oR(a, F11, m11) {
                return o(a[1][1 + On], a, m11);
              }
              function aR(a, F11, m11) {
                return ur(a[1][1 + L0], a, F11, m11);
              }
              function rv(a, F11, m11) {
                var O = m11[1];
                function H(r0) {
                  return [0, O, r0];
                }
                var $ = m11[2];
                return te(o(a[1][1 + rr], a, F11), O, $, m11, H);
              }
              function Tb(a, F11, m11) {
                switch (m11[0]) {
                  case 0:
                    var O = function(Nr) {
                      return [0, Nr];
                    }, H = m11[1];
                    return ee(o(a[1][1 + L], a, F11), H, m11, O);
                  case 1:
                    var $ = function(Nr) {
                      return [1, Nr];
                    }, r0 = m11[1];
                    return ee(o(a[1][1 + i0], a, F11), r0, m11, $);
                  default:
                    var j0 = function(Nr) {
                      return [2, Nr];
                    }, V0 = m11[1];
                    return ee(o(a[1][1 + l0], a, F11), V0, m11, j0);
                }
              }
              function v_(a, F11, m11) {
                var O = m11[2], H = O[4], $ = O[3], r0 = O[2], j0 = O[1], V0 = ur(a[1][1 + Q], a, F11, j0), Nr = ur(a[1][1 + P], a, F11, r0), Gr = ze(u(a[1][1 + nn], a), $);
                if (H) {
                  var Fe = 0;
                  if (V0[0] === 1) {
                    var _e = Nr[2];
                    if (_e[0] === 2)
                      var yn = qn(V0[1][2][1], _e[1][1][2][1]);
                    else
                      Fe = 1;
                  } else
                    Fe = 1;
                  if (Fe)
                    var Dn = j0 === V0 ? 1 : 0, yn = Dn && (r0 === Nr ? 1 : 0);
                } else
                  var yn = H;
                return V0 === j0 && Nr === r0 && Gr === $ && H === yn ? m11 : [0, m11[1], [0, V0, Nr, Gr, yn]];
              }
              function Ob(a, F11, m11) {
                if (m11[0] === 0) {
                  var O = function(j0) {
                    return [0, j0];
                  }, H = m11[1];
                  return ee(o(a[1][1 + S0], a, F11), H, m11, O);
                }
                function $(j0) {
                  return [1, j0];
                }
                var r0 = m11[1];
                return ee(o(a[1][1 + v0], a, F11), r0, m11, $);
              }
              function cR(a, F11, m11, O) {
                return ur(a[1][1 + J0], a, m11, O);
              }
              function l_(a, F11, m11) {
                return o(a[1][1 + lt], a, m11);
              }
              function sR(a, F11, m11) {
                var O = m11[2];
                switch (O[0]) {
                  case 0:
                    var H = O[1], $ = H[3], r0 = H[2], j0 = H[1], V0 = Un(o(a[1][1 + T0], a, F11), j0), Nr = o(a[1][1 + x0], a, r0), Gr = o(a[1][1 + s0], a, $), Fe = 0;
                    if (V0 === j0 && Nr === r0 && Gr === $) {
                      var _e = O;
                      Fe = 1;
                    }
                    if (!Fe)
                      var _e = [0, [0, V0, Nr, Gr]];
                    var Ji = _e;
                    break;
                  case 1:
                    var Dn = O[1], yn = Dn[3], ot = Dn[2], pt = Dn[1], kt = Un(o(a[1][1 + M0], a, F11), pt), Kn = o(a[1][1 + x0], a, ot), Qt = o(a[1][1 + s0], a, yn), J7 = 0;
                    if (yn === Qt && kt === pt && Kn === ot) {
                      var $7 = O;
                      J7 = 1;
                    }
                    if (!J7)
                      var $7 = [1, [0, kt, Kn, Qt]];
                    var Ji = $7;
                    break;
                  case 2:
                    var E7 = O[1], Z72 = E7[2], Q7 = E7[1], ri = ur(a[1][1 + L0], a, F11, Q7), ei = o(a[1][1 + x0], a, Z72), ni = 0;
                    if (Q7 === ri && Z72 === ei) {
                      var Wi = O;
                      ni = 1;
                    }
                    if (!ni)
                      var Wi = [2, [0, ri, ei, E7[3]]];
                    var Ji = Wi;
                    break;
                  default:
                    var tv = function(iv) {
                      return [3, iv];
                    }, uv = O[1], Ji = ee(u(a[1][1 + B], a), uv, O, tv);
                }
                return O === Ji ? m11 : [0, m11[1], Ji];
              }
              function b_(a, F11) {
                return ur(a[1][1 + er], a, 0, F11);
              }
              function Ib(a, F11, m11) {
                var O = F11 && F11[1];
                return ur(a[1][1 + er], a, [0, O], m11);
              }
              function p_(a, F11) {
                return o(a[1][1 + m2], a, F11);
              }
              function vR(a, F11) {
                return o(a[1][1 + m2], a, F11);
              }
              function m_(a, F11) {
                return ur(a[1][1 + $s], a, s6r, F11);
              }
              function Ab(a, F11, m11) {
                return ur(a[1][1 + $s], a, [0, F11], m11);
              }
              function lR(a, F11) {
                return ur(a[1][1 + $s], a, c6r, F11);
              }
              function bR(a, F11, m11) {
                var O = m11[5], H = m11[4], $ = m11[3], r0 = m11[2], j0 = m11[1], V0 = o(a[1][1 + Vc], a, j0), Nr = ze(u(a[1][1 + V], a), r0), Gr = ze(u(a[1][1 + t0], a), $), Fe = ze(u(a[1][1 + t0], a), H), _e = o(a[1][1 + s0], a, O);
                return j0 === V0 && $ === Gr && r0 === Nr && $ === Gr && H === Fe && O === _e ? m11 : [0, V0, Nr, Gr, Fe, _e];
              }
              function pR(a, F11) {
                return o(a[1][1 + On], a, F11);
              }
              function Nb(a, F11) {
                return o(a[1][1 + lt], a, F11);
              }
              function mR(a, F11) {
                var m11 = F11[1];
                function O($) {
                  return [0, m11, $];
                }
                var H = F11[2];
                return te(u(a[1][1 + J0], a), m11, H, F11, O);
              }
              function _R(a, F11) {
                switch (F11[0]) {
                  case 0:
                    var m11 = function(Gr) {
                      return [0, Gr];
                    }, O = F11[1];
                    return ee(u(a[1][1 + be], a), O, F11, m11);
                  case 1:
                    var H = function(Gr) {
                      return [1, Gr];
                    }, $ = F11[1];
                    return ee(u(a[1][1 + ae], a), $, F11, H);
                  case 2:
                    var r0 = function(Gr) {
                      return [2, Gr];
                    }, j0 = F11[1];
                    return ee(u(a[1][1 + ar], a), j0, F11, r0);
                  default:
                    var V0 = function(Gr) {
                      return [3, Gr];
                    }, Nr = F11[1];
                    return ee(u(a[1][1 + pe], a), Nr, F11, V0);
                }
              }
              function __(a, F11) {
                var m11 = F11[2], O = F11[1];
                switch (m11[0]) {
                  case 0:
                    var H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + oe], a, r0), V0 = o(a[1][1 + nn], a, $);
                    if (H) {
                      var Nr = 0;
                      if (j0[0] === 1) {
                        var Gr = V0[2];
                        if (Gr[0] === 10)
                          var _e = qn(j0[1][2][1], Gr[1][2][1]);
                        else
                          Nr = 1;
                      } else
                        Nr = 1;
                      if (Nr)
                        var Fe = r0 === j0 ? 1 : 0, _e = Fe && ($ === V0 ? 1 : 0);
                    } else
                      var _e = H;
                    return r0 === j0 && $ === V0 && H === _e ? F11 : [0, O, [0, j0, V0, _e]];
                  case 1:
                    var Dn = m11[2], yn = m11[1], ot = o(a[1][1 + oe], a, yn), pt = _u(u(a[1][1 + me], a), Dn);
                    return yn === ot && Dn === pt ? F11 : [0, O, [1, ot, pt]];
                  case 2:
                    var kt = m11[3], Kn = m11[2], Qt = m11[1], J7 = o(a[1][1 + oe], a, Qt), $7 = _u(u(a[1][1 + me], a), Kn), E7 = o(a[1][1 + s0], a, kt);
                    return Qt === J7 && Kn === $7 && kt === E7 ? F11 : [0, O, [2, J7, $7, E7]];
                  default:
                    var Z72 = m11[3], Q7 = m11[2], ri = m11[1], ei = o(a[1][1 + oe], a, ri), ni = _u(u(a[1][1 + me], a), Q7), Wi = o(a[1][1 + s0], a, Z72);
                    return ri === ei && Q7 === ni && Z72 === Wi ? F11 : [0, O, [3, ei, ni, Wi]];
                }
              }
              function yR(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = Un(function(j0) {
                  if (j0[0] === 0) {
                    var V0 = j0[1], Nr = o(a[1][1 + Qr], a, V0);
                    return V0 === Nr ? j0 : [0, Nr];
                  }
                  var Gr = j0[1], Fe = o(a[1][1 + fr], a, Gr);
                  return Gr === Fe ? j0 : [1, Fe];
                }, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function Cb(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + nn], a, r0), V0 = ze(u(a[1][1 + b2], a), $), Nr = ze(u(a[1][1 + Ws], a), H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m11 : [0, j0, V0, Nr, Gr];
              }
              function hR(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + lt], a, $), j0 = o(a[1][1 + lt], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function dR(a, F11) {
                return o(a[1][1 + nn], a, F11);
              }
              function y_(a, F11) {
                return o(a[1][1 + ar], a, F11);
              }
              function kR(a, F11) {
                return o(a[1][1 + lt], a, F11);
              }
              function E2(a, F11) {
                switch (F11[0]) {
                  case 0:
                    var m11 = function(V0) {
                      return [0, V0];
                    }, O = F11[1];
                    return ee(u(a[1][1 + y0], a), O, F11, m11);
                  case 1:
                    var H = function(V0) {
                      return [1, V0];
                    }, $ = F11[1];
                    return ee(u(a[1][1 + D], a), $, F11, H);
                  default:
                    var r0 = function(V0) {
                      return [2, V0];
                    }, j0 = F11[1];
                    return ee(u(a[1][1 + P0], a), j0, F11, r0);
                }
              }
              function wR(a, F11, m11) {
                var O = m11[1], H = ur(a[1][1 + u0], a, F11, O);
                return O === H ? m11 : [0, H, m11[2], m11[3]];
              }
              function ER(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + I0], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function SR(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + nn], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, m11[1], r0, j0, V0];
              }
              function Pb(a, F11, m11) {
                var O = m11[3], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, m11[1], m11[2], H];
              }
              function gR(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + Q0], a, $), j0 = o(a[1][1 + Or], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function FR(a, F11) {
                var m11 = F11[2], O = m11[2], H = o(a[1][1 + s0], a, O);
                return O === H ? F11 : [0, F11[1], [0, m11[1], H]];
              }
              function Db(a, F11) {
                return o(a[1][1 + ve], a, F11);
              }
              function TR(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + K0], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + Ur], a), $, F11, H);
              }
              function OR(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + Pr], a, H), r0 = o(a[1][1 + h0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function ku(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + h0], a, H), r0 = o(a[1][1 + h0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function wu(a, F11) {
                return o(a[1][1 + Ur], a, F11);
              }
              function Ii(a, F11) {
                return o(a[1][1 + sr], a, F11);
              }
              function w7(a, F11) {
                return o(a[1][1 + h0], a, F11);
              }
              function Ki(a, F11) {
                switch (F11[0]) {
                  case 0:
                    var m11 = function(V0) {
                      return [0, V0];
                    }, O = F11[1];
                    return ee(u(a[1][1 + ve], a), O, F11, m11);
                  case 1:
                    var H = function(V0) {
                      return [1, V0];
                    }, $ = F11[1];
                    return ee(u(a[1][1 + xe], a), $, F11, H);
                  default:
                    var r0 = function(V0) {
                      return [2, V0];
                    }, j0 = F11[1];
                    return ee(u(a[1][1 + Re], a), j0, F11, r0);
                }
              }
              function ev(a, F11) {
                var m11 = F11[2], O = F11[1], H = o(a[1][1 + nn], a, O), $ = o(a[1][1 + s0], a, m11);
                return O === H && m11 === $ ? F11 : [0, H, $];
              }
              function Lb(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = o(a[1][1 + s0], a, O);
                if (H) {
                  var r0 = H[1], j0 = o(a[1][1 + nn], a, r0);
                  return r0 === j0 && O === $ ? m11 : [0, [0, j0], $];
                }
                return O === $ ? m11 : [0, 0, $];
              }
              function nv(a, F11) {
                var m11 = F11[2], O = F11[1];
                switch (m11[0]) {
                  case 0:
                    var H = function(_e) {
                      return [0, O, [0, _e]];
                    }, $ = m11[1];
                    return te(u(a[1][1 + Ge], a), O, $, F11, H);
                  case 1:
                    var r0 = function(_e) {
                      return [0, O, [1, _e]];
                    }, j0 = m11[1];
                    return te(u(a[1][1 + Kr], a), O, j0, F11, r0);
                  case 2:
                    var V0 = function(_e) {
                      return [0, O, [2, _e]];
                    }, Nr = m11[1];
                    return te(u(a[1][1 + re], a), O, Nr, F11, V0);
                  case 3:
                    var Gr = function(_e) {
                      return [0, O, [3, _e]];
                    }, Fe = m11[1];
                    return ee(u(a[1][1 + F0], a), Fe, F11, Gr);
                  default:
                    return F11;
                }
              }
              function Rb(a, F11) {
                var m11 = F11[2], O = Un(u(a[1][1 + We], a), m11);
                return m11 === O ? F11 : [0, F11[1], O];
              }
              function jb(a, F11, m11) {
                return ur(a[1][1 + J0], a, F11, m11);
              }
              function IR(a, F11, m11) {
                return ur(a[1][1 + re], a, F11, m11);
              }
              function Sne(a, F11) {
                if (F11[0] === 0) {
                  var m11 = F11[1], O = function(V0) {
                    return [0, m11, V0];
                  }, H = F11[2];
                  return te(u(a[1][1 + Ae], a), m11, H, F11, O);
                }
                var $ = F11[1];
                function r0(V0) {
                  return [1, $, V0];
                }
                var j0 = F11[2];
                return te(u(a[1][1 + cn], a), $, j0, F11, r0);
              }
              function gne(a, F11) {
                return o(a[1][1 + sr], a, F11);
              }
              function Fne(a, F11) {
                return o(a[1][1 + h0], a, F11);
              }
              function Tne(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + vn], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + kn], a), $, F11, H);
              }
              function One(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + Ne], a, H), r0 = ze(u(a[1][1 + rn], a), O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Ine(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function Ane(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(V0) {
                    return [0, V0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + Je], a), O, F11, m11);
                }
                var H = F11[1], $ = H[1];
                function r0(V0) {
                  return [1, [0, $, V0]];
                }
                var j0 = H[2];
                return te(u(a[1][1 + Sr], a), $, j0, F11, r0);
              }
              function Nne(a, F11) {
                var m11 = F11[2][1], O = o(a[1][1 + Ie], a, m11);
                return m11 === O ? F11 : [0, F11[1], [0, O]];
              }
              function Cne(a, F11) {
                var m11 = F11[2], O = m11[3], H = m11[1], $ = o(a[1][1 + Ie], a, H), r0 = Un(u(a[1][1 + Cr], a), O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, m11[2], r0]];
              }
              function Pne(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = o(a[1][1 + an], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, m11[1], m11[2], $, r0];
              }
              function Dne(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + mr], a, r0), V0 = ze(u(a[1][1 + Me], a), $), Nr = o(a[1][1 + an], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m11 : [0, j0, V0, Nr, Gr];
              }
              function Lne(a, F11, m11, O) {
                var H = 2 <= F11 ? o(a[1][1 + L0], a, a6r) : u(a[1][1 + Vc], a);
                return u(H, O);
              }
              function Rne(a, F11, m11) {
                var O = 2 <= F11 ? o(a[1][1 + L0], a, o6r) : u(a[1][1 + Vc], a);
                return u(O, m11);
              }
              function jne(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = 0;
                if (F11) {
                  var j0 = 0;
                  if ($)
                    switch ($[1]) {
                      case 2:
                        break;
                      case 0:
                        r0 = 1, j0 = 2;
                        break;
                      default:
                        j0 = 1;
                    }
                  var V0 = 0;
                  switch (j0) {
                    case 2:
                      V0 = 1;
                      break;
                    case 0:
                      if (2 <= F11) {
                        var Nr = 0, Gr = 0;
                        V0 = 1;
                      }
                      break;
                  }
                  if (!V0)
                    var Nr = 1, Gr = 0;
                } else
                  r0 = 1;
                if (r0)
                  var Nr = 1, Gr = 1;
                var Fe = o(Gr ? a[1][1 + m0] : a[1][1 + lt], a, O);
                if (H)
                  var _e = Nr ? u(a[1][1 + Vc], a) : o(a[1][1 + L0], a, x6r), Dn = function(ot) {
                    return [0, ot];
                  }, yn = ee(_e, H[1], H, Dn);
                else
                  var yn = H;
                return H === yn && O === Fe ? m11 : [0, $, yn, Fe];
              }
              function Gne(a, F11, m11) {
                if (m11[0] === 0) {
                  var O = m11[1], H = Un(o(a[1][1 + gt], a, F11), O);
                  return O === H ? m11 : [0, H];
                }
                var $ = m11[1], r0 = $[1];
                function j0(Nr) {
                  return [1, [0, r0, Nr]];
                }
                var V0 = $[2];
                return te(o(a[1][1 + Nt], a, F11), r0, V0, m11, j0);
              }
              function Mne(a, F11, m11) {
                var O = m11[5], H = m11[4], $ = m11[3], r0 = m11[1], j0 = ze(o(a[1][1 + vt], a, r0), H), V0 = ze(o(a[1][1 + Zt], a, r0), $), Nr = o(a[1][1 + s0], a, O);
                return H === j0 && $ === V0 && O === Nr ? m11 : [0, r0, m11[2], V0, j0, Nr];
              }
              function Bne(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + _r], a, r0), V0 = ur(a[1][1 + du], a, H !== 0 ? 1 : 0, $), Nr = u(a[1][1 + Wu], a), Gr = ze(function(_e) {
                  return _u(Nr, _e);
                }, H), Fe = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Gr && O === Fe ? m11 : [0, j0, V0, Gr, Fe];
              }
              function qne(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = o(a[1][1 + Or], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function Une(a, F11, m11) {
                return o(a[1][1 + Or], a, m11);
              }
              function Hne(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function Xne(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Yne(a, F11) {
                var m11 = F11[2], O = m11[2], H = o(a[1][1 + s0], a, O);
                return O === H ? F11 : [0, F11[1], [0, m11[1], H]];
              }
              function Vne(a, F11, m11) {
                return ur(a[1][1 + Hn], a, F11, m11);
              }
              function zne(a, F11, m11) {
                var O = m11[5], H = m11[4], $ = m11[3], r0 = m11[2], j0 = m11[1], V0 = o(a[1][1 + Vc], a, j0), Nr = ze(u(a[1][1 + V], a), r0), Gr = u(a[1][1 + ou], a), Fe = Un(function(yn) {
                  return _u(Gr, yn);
                }, $), _e = _u(u(a[1][1 + qr], a), H), Dn = o(a[1][1 + s0], a, O);
                return V0 === j0 && Nr === r0 && Fe === $ && _e === H && Dn === O ? m11 : [0, V0, Nr, Fe, _e, Dn];
              }
              function Kne(a, F11) {
                return o(a[1][1 + k0], a, F11);
              }
              function Wne(a, F11) {
                return o(a[1][1 + k0], a, F11);
              }
              function Jne(a, F11) {
                return o(a[1][1 + lt], a, F11);
              }
              function $ne(a, F11) {
                var m11 = F11[2], O = m11[2], H = o(a[1][1 + s0], a, O);
                return O === H ? F11 : [0, F11[1], [0, m11[1], H]];
              }
              function Zne(a, F11, m11) {
                return m11;
              }
              function Qne(a, F11) {
                return ur(a[1][1 + L0], a, f6r, F11);
              }
              function rte(a, F11) {
                var m11 = F11[1];
                function O($) {
                  return [0, m11, $];
                }
                var H = F11[2];
                return te(u(a[1][1 + zi], a), m11, H, F11, O);
              }
              function ete(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + xt], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + nn], a), $, F11, H);
              }
              function nte(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + Le], a, H), r0 = ze(u(a[1][1 + nn], a), O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function tte(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + l], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? F11 : [0, F11[1], [0, $, r0]];
              }
              function ute(a, F11) {
                var m11 = F11[2], O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = Un(u(a[1][1 + He], a), $), V0 = ze(u(a[1][1 + bt], a), H), Nr = ze(u(a[1][1 + W7], a), r0), Gr = o(a[1][1 + s0], a, O);
                return $ === j0 && H === V0 && O === Gr && r0 === Nr ? F11 : [0, F11[1], [0, Nr, j0, V0, Gr]];
              }
              function ite(a, F11, m11) {
                var O = m11[9], H = m11[8], $ = m11[7], r0 = m11[6], j0 = m11[3], V0 = m11[2], Nr = m11[1], Gr = ze(u(a[1][1 + he], a), Nr), Fe = o(a[1][1 + B0], a, V0), _e = o(a[1][1 + x0], a, $), Dn = o(a[1][1 + ft], a, j0), yn = ze(u(a[1][1 + Ir], a), r0), ot = ze(u(a[1][1 + V], a), H), pt = o(a[1][1 + s0], a, O);
                return Nr === Gr && V0 === Fe && j0 === Dn && r0 === yn && $ === _e && H === ot && O === pt ? m11 : [0, Gr, Fe, Dn, m11[4], m11[5], yn, _e, ot, pt, m11[10]];
              }
              function fte(a, F11, m11) {
                return ur(a[1][1 + jn], a, F11, m11);
              }
              function xte(a, F11, m11) {
                return ur(a[1][1 + me], a, F11, m11);
              }
              function ote(a, F11, m11) {
                return ur(a[1][1 + jn], a, F11, m11);
              }
              function ate(a, F11) {
                if (F11[0] === 0)
                  return F11;
                var m11 = F11[1], O = o(a[1][1 + l], a, m11);
                return O === m11 ? F11 : [1, O];
              }
              function cte(a, F11) {
                var m11 = F11[1];
                function O($) {
                  return [0, m11, $];
                }
                var H = F11[2];
                return ee(u(a[1][1 + t0], a), H, F11, O);
              }
              function ste(a, F11) {
                var m11 = F11[2], O = F11[1];
                switch (m11[0]) {
                  case 0:
                    var H = function(Ze) {
                      return [0, O, [0, Ze]];
                    }, $ = m11[1];
                    return ee(u(a[1][1 + s0], a), $, F11, H);
                  case 1:
                    var r0 = function(Ze) {
                      return [0, O, [1, Ze]];
                    }, j0 = m11[1];
                    return ee(u(a[1][1 + s0], a), j0, F11, r0);
                  case 2:
                    var V0 = function(Ze) {
                      return [0, O, [2, Ze]];
                    }, Nr = m11[1];
                    return ee(u(a[1][1 + s0], a), Nr, F11, V0);
                  case 3:
                    var Gr = function(Ze) {
                      return [0, O, [3, Ze]];
                    }, Fe = m11[1];
                    return ee(u(a[1][1 + s0], a), Fe, F11, Gr);
                  case 4:
                    var _e = function(Ze) {
                      return [0, O, [4, Ze]];
                    }, Dn = m11[1];
                    return ee(u(a[1][1 + s0], a), Dn, F11, _e);
                  case 5:
                    var yn = function(Ze) {
                      return [0, O, [5, Ze]];
                    }, ot = m11[1];
                    return ee(u(a[1][1 + s0], a), ot, F11, yn);
                  case 6:
                    var pt = function(Ze) {
                      return [0, O, [6, Ze]];
                    }, kt = m11[1];
                    return ee(u(a[1][1 + s0], a), kt, F11, pt);
                  case 7:
                    var Kn = function(Ze) {
                      return [0, O, [7, Ze]];
                    }, Qt = m11[1];
                    return ee(u(a[1][1 + s0], a), Qt, F11, Kn);
                  case 8:
                    var J7 = function(Ze) {
                      return [0, O, [8, Ze]];
                    }, $7 = m11[1];
                    return ee(u(a[1][1 + s0], a), $7, F11, J7);
                  case 9:
                    var E7 = function(Ze) {
                      return [0, O, [9, Ze]];
                    }, Z72 = m11[1];
                    return ee(u(a[1][1 + s0], a), Z72, F11, E7);
                  case 10:
                    var Q7 = function(Ze) {
                      return [0, O, [10, Ze]];
                    }, ri = m11[1];
                    return ee(u(a[1][1 + s0], a), ri, F11, Q7);
                  case 11:
                    var ei = function(Ze) {
                      return [0, O, [11, Ze]];
                    }, ni = m11[1];
                    return ee(u(a[1][1 + k], a), ni, F11, ei);
                  case 12:
                    var Wi = function(Ze) {
                      return [0, O, [12, Ze]];
                    }, tv = m11[1];
                    return te(u(a[1][1 + a7], a), O, tv, F11, Wi);
                  case 13:
                    var uv = function(Ze) {
                      return [0, O, [13, Ze]];
                    }, Ji = m11[1];
                    return te(u(a[1][1 + qr], a), O, Ji, F11, uv);
                  case 14:
                    var iv = function(Ze) {
                      return [0, O, [14, Ze]];
                    }, Gb = m11[1];
                    return te(u(a[1][1 + _n], a), O, Gb, F11, iv);
                  case 15:
                    var Mb = function(Ze) {
                      return [0, O, [15, Ze]];
                    }, Bb = m11[1];
                    return ee(u(a[1][1 + Zs], a), Bb, F11, Mb);
                  case 16:
                    var qb = function(Ze) {
                      return [0, O, [16, Ze]];
                    }, Ub = m11[1];
                    return te(u(a[1][1 + ou], a), O, Ub, F11, qb);
                  case 17:
                    var Hb = function(Ze) {
                      return [0, O, [17, Ze]];
                    }, Xb = m11[1];
                    return te(u(a[1][1 + Fn], a), O, Xb, F11, Hb);
                  case 18:
                    var Yb = function(Ze) {
                      return [0, O, [18, Ze]];
                    }, Vb = m11[1];
                    return te(u(a[1][1 + vr], a), O, Vb, F11, Yb);
                  case 19:
                    var zb = function(Ze) {
                      return [0, O, [19, Ze]];
                    }, Kb = m11[1];
                    return te(u(a[1][1 + d], a), O, Kb, F11, zb);
                  case 20:
                    var Wb = function(Ze) {
                      return [0, O, [20, Ze]];
                    }, Jb = m11[1];
                    return te(u(a[1][1 + en], a), O, Jb, F11, Wb);
                  case 21:
                    var $b = function(Ze) {
                      return [0, O, [21, Ze]];
                    }, Zb = m11[1];
                    return ee(u(a[1][1 + G], a), Zb, F11, $b);
                  case 22:
                    var Qb = function(Ze) {
                      return [0, O, [22, Ze]];
                    }, r4 = m11[1];
                    return ee(u(a[1][1 + o0], a), r4, F11, Qb);
                  case 23:
                    var e42 = function(Ze) {
                      return [0, O, [23, Ze]];
                    }, n4 = m11[1];
                    return te(u(a[1][1 + Lr], a), O, n4, F11, e42);
                  case 24:
                    var t42 = function(Ze) {
                      return [0, O, [24, Ze]];
                    }, u4 = m11[1];
                    return te(u(a[1][1 + _], a), O, u4, F11, t42);
                  case 25:
                    var i42 = function(Ze) {
                      return [0, O, [25, Ze]];
                    }, f42 = m11[1];
                    return te(u(a[1][1 + p2], a), O, f42, F11, i42);
                  default:
                    var x42 = function(Ze) {
                      return [0, O, [26, Ze]];
                    }, o4 = m11[1];
                    return te(u(a[1][1 + f_], a), O, o4, F11, x42);
                }
              }
              function vte(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = H[3], r0 = H[2], j0 = H[1], V0 = o(a[1][1 + t0], a, j0), Nr = o(a[1][1 + t0], a, r0), Gr = Un(u(a[1][1 + t0], a), $), Fe = o(a[1][1 + s0], a, O);
                return V0 === j0 && Nr === r0 && Gr === $ && Fe === O ? m11 : [0, [0, V0, Nr, Gr], Fe];
              }
              function lte(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = H[3], r0 = H[2], j0 = H[1], V0 = o(a[1][1 + t0], a, j0), Nr = o(a[1][1 + t0], a, r0), Gr = Un(u(a[1][1 + t0], a), $), Fe = o(a[1][1 + s0], a, O);
                return V0 === j0 && Nr === r0 && Gr === $ && Fe === O ? m11 : [0, [0, V0, Nr, Gr], Fe];
              }
              function bte(a, F11) {
                var m11 = F11[2], O = F11[1], H = o(a[1][1 + t0], a, O), $ = o(a[1][1 + s0], a, m11);
                return O === H && m11 === $ ? F11 : [0, H, $];
              }
              function pte(a, F11) {
                var m11 = F11[2], O = F11[1], H = Un(u(a[1][1 + t0], a), O), $ = o(a[1][1 + s0], a, m11);
                return O === H && m11 === $ ? F11 : [0, H, $];
              }
              function mte(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + K], a, H), r0 = o(a[1][1 + S11], a, O);
                return $ === H && r0 === O ? F11 : [0, F11[1], [0, $, r0]];
              }
              function _te(a, F11) {
                return o(a[1][1 + lt], a, F11);
              }
              function yte(a, F11) {
                return o(a[1][1 + lt], a, F11);
              }
              function hte(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + M], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + A11], a), $, F11, H);
              }
              function dte(a, F11) {
                var m11 = F11[2], O = F11[1], H = o(a[1][1 + K], a, O), $ = o(a[1][1 + s0], a, m11);
                return O === H && m11 === $ ? F11 : [0, H, $];
              }
              function kte(a, F11) {
                var m11 = F11[2], O = F11[1], H = o(a[1][1 + t0], a, O), $ = o(a[1][1 + s0], a, m11);
                return O === H && m11 === $ ? F11 : [0, H, $];
              }
              function wte(a, F11, m11) {
                var O = m11[2], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, m11[1], H];
              }
              function Ete(a, F11, m11) {
                var O = m11[3], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, m11[1], m11[2], H];
              }
              function Ste(a, F11, m11) {
                var O = m11[3], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, m11[1], m11[2], H];
              }
              function gte(a, F11, m11) {
                var O = m11[3], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, m11[1], m11[2], H];
              }
              function Fte(a, F11, m11) {
                var O = m11[1], H = ur(a[1][1 + Fn], a, F11, O);
                return H === O ? m11 : [0, H, m11[2]];
              }
              function Tte(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + t0], a, $), j0 = o(a[1][1 + t0], a, H), V0 = o(a[1][1 + s0], a, O);
                return r0 === $ && j0 === H && V0 === O ? m11 : [0, r0, j0, V0];
              }
              function Ote(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + K7], a, $), j0 = ze(u(a[1][1 + e0], a), H), V0 = o(a[1][1 + s0], a, O);
                return r0 === $ && j0 === H && V0 === O ? m11 : [0, r0, j0, V0];
              }
              function Ite(a, F11) {
                var m11 = F11[2], O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + x0], a, $), V0 = o(a[1][1 + c], a, H), Nr = ze(u(a[1][1 + t0], a), O), Gr = o(a[1][1 + Vc], a, r0);
                return Gr === r0 && j0 === $ && V0 === H && Nr === O ? F11 : [0, F11[1], [0, Gr, j0, V0, Nr]];
              }
              function Ate(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = Un(u(a[1][1 + f0], a), H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Nte(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = Un(u(a[1][1 + t0], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Cte(a, F11) {
                return ze(u(a[1][1 + s2], a), F11);
              }
              function Pte(a, F11) {
                var m11 = F11[2], O = m11[2], H = o(a[1][1 + s0], a, O);
                return O === H ? F11 : [0, F11[1], [0, m11[1], H]];
              }
              function Dte(a, F11) {
                return o(a[1][1 + lt], a, F11);
              }
              function Lte(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + K7], a, H), r0 = o(a[1][1 + Y], a, O);
                return $ === H && r0 === O ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Rte(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + m0], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + Bu], a), $, F11, H);
              }
              function jte(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = u(a[1][1 + ou], a), j0 = Un(function(Gr) {
                  return _u(r0, Gr);
                }, H), V0 = _u(u(a[1][1 + qr], a), $), Nr = o(a[1][1 + s0], a, O);
                return j0 === H && V0 === $ && O === Nr ? m11 : [0, V0, j0, Nr];
              }
              function Gte(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = Un(function(j0) {
                  switch (j0[0]) {
                    case 0:
                      var V0 = function(Kn) {
                        return [0, Kn];
                      }, Nr = j0[1];
                      return ee(u(a[1][1 + ne], a), Nr, j0, V0);
                    case 1:
                      var Gr = function(Kn) {
                        return [1, Kn];
                      }, Fe = j0[1];
                      return ee(u(a[1][1 + jr], a), Fe, j0, Gr);
                    case 2:
                      var _e = function(Kn) {
                        return [2, Kn];
                      }, Dn = j0[1];
                      return ee(u(a[1][1 + ge], a), Dn, j0, _e);
                    case 3:
                      var yn = function(Kn) {
                        return [3, Kn];
                      }, ot = j0[1];
                      return ee(u(a[1][1 + q0], a), ot, j0, yn);
                    default:
                      var pt = function(Kn) {
                        return [4, Kn];
                      }, kt = j0[1];
                      return ee(u(a[1][1 + ce], a), kt, j0, pt);
                  }
                }, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && O === r0 ? m11 : [0, m11[1], m11[2], $, r0];
              }
              function Mte(a, F11) {
                var m11 = F11[2], O = m11[3], H = m11[1], $ = H[2], r0 = H[1], j0 = ur(a[1][1 + a7], a, r0, $), V0 = o(a[1][1 + s0], a, O);
                return $ === j0 && O === V0 ? F11 : [0, F11[1], [0, [0, r0, j0], m11[2], V0]];
              }
              function Bte(a, F11) {
                var m11 = F11[2], O = m11[6], H = m11[2], $ = m11[1], r0 = o(a[1][1 + lt], a, $), j0 = o(a[1][1 + t0], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? F11 : [0, F11[1], [0, r0, j0, m11[3], m11[4], m11[5], V0]];
              }
              function qte(a, F11) {
                var m11 = F11[2], O = m11[6], H = m11[5], $ = m11[3], r0 = m11[2], j0 = o(a[1][1 + t0], a, r0), V0 = o(a[1][1 + t0], a, $), Nr = o(a[1][1 + c], a, H), Gr = o(a[1][1 + s0], a, O);
                return j0 === r0 && V0 === $ && Nr === H && Gr === O ? F11 : [0, F11[1], [0, m11[1], j0, V0, m11[4], Nr, Gr]];
              }
              function Ute(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + t0], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Hte(a, F11) {
                var m11 = F11[2], O = m11[8], H = m11[7], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + oe], a, r0), V0 = o(a[1][1 + $r], a, $), Nr = o(a[1][1 + c], a, H), Gr = o(a[1][1 + s0], a, O);
                return j0 === r0 && V0 === $ && Nr === H && Gr === O ? F11 : [0, F11[1], [0, j0, V0, m11[3], m11[4], m11[5], m11[6], Nr, Gr]];
              }
              function Xte(a, F11) {
                var m11 = F11[1];
                function O($) {
                  return [0, m11, $];
                }
                var H = F11[2];
                return te(u(a[1][1 + a7], a), m11, H, F11, O);
              }
              function Yte(a, F11) {
                var m11 = F11[1];
                function O($) {
                  return [0, m11, $];
                }
                var H = F11[2];
                return te(u(a[1][1 + a7], a), m11, H, F11, O);
              }
              function Vte(a, F11) {
                switch (F11[0]) {
                  case 0:
                    var m11 = function(V0) {
                      return [0, V0];
                    }, O = F11[1];
                    return ee(u(a[1][1 + t0], a), O, F11, m11);
                  case 1:
                    var H = function(V0) {
                      return [1, V0];
                    }, $ = F11[1];
                    return ee(u(a[1][1 + Br], a), $, F11, H);
                  default:
                    var r0 = function(V0) {
                      return [2, V0];
                    }, j0 = F11[1];
                    return ee(u(a[1][1 + Mr], a), j0, F11, r0);
                }
              }
              function zte(a, F11) {
                return o(a[1][1 + lt], a, F11);
              }
              function Kte(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = $[2], j0 = r0[4], V0 = r0[3], Nr = r0[2], Gr = r0[1], Fe = m11[1], _e = ze(u(a[1][1 + Hc], a), Gr), Dn = Un(u(a[1][1 + D0], a), Nr), yn = ze(u(a[1][1 + Ut], a), V0), ot = o(a[1][1 + t0], a, H), pt = ze(u(a[1][1 + V], a), Fe), kt = o(a[1][1 + s0], a, O), Kn = o(a[1][1 + s0], a, j0);
                return Dn === Nr && yn === V0 && ot === H && pt === Fe && kt === O && Kn === j0 && _e === Gr ? m11 : [0, pt, [0, $[1], [0, _e, Dn, yn, Kn]], ot, kt];
              }
              function Wte(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + l], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Jte(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + D0], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? F11 : [0, F11[1], [0, $, r0]];
              }
              function $te(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + t0], a, O), r0 = ze(u(a[1][1 + lt], a), H);
                return $ === O && r0 === H ? F11 : [0, F11[1], [0, r0, $, m11[3]]];
              }
              function Zte(a, F11) {
                var m11 = F11[1];
                function O($) {
                  return [0, m11, $];
                }
                var H = F11[2];
                return te(u(a[1][1 + T], a), m11, H, F11, O);
              }
              function Qte(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + Ti], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + nn], a), $, F11, H);
              }
              function rue(a, F11, m11) {
                var O = m11[5], H = m11[4], $ = m11[3], r0 = m11[2], j0 = m11[1], V0 = ze(u(a[1][1 + ut], a), j0), Nr = ze(u(a[1][1 + _r], a), r0), Gr = ze(u(a[1][1 + nn], a), $), Fe = o(a[1][1 + Or], a, H), _e = o(a[1][1 + s0], a, O);
                return j0 === V0 && r0 === Nr && $ === Gr && H === Fe && O === _e ? m11 : [0, V0, Nr, Gr, Fe, _e];
              }
              function eue(a, F11) {
                var m11 = F11[1];
                function O($) {
                  return [0, m11, $];
                }
                var H = F11[2];
                return te(u(a[1][1 + T], a), m11, H, F11, O);
              }
              function nue(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + it], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + Tt], a), $, F11, H);
              }
              function tue(a, F11, m11) {
                var O = m11[5], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + xn], a, r0), V0 = o(a[1][1 + nn], a, $), Nr = o(a[1][1 + Or], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m11 : [0, j0, V0, Nr, m11[4], Gr];
              }
              function uue(a, F11) {
                var m11 = F11[1];
                function O($) {
                  return [0, m11, $];
                }
                var H = F11[2];
                return te(u(a[1][1 + T], a), m11, H, F11, O);
              }
              function iue(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + Hs], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + Vi], a), $, F11, H);
              }
              function fue(a, F11, m11) {
                var O = m11[5], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + hs], a, r0), V0 = o(a[1][1 + nn], a, $), Nr = o(a[1][1 + Or], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m11 : [0, j0, V0, Nr, m11[4], Gr];
              }
              function xue(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + nn], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + Rr], a), $, F11, H);
              }
              function oue(a, F11, m11) {
                var O = m11[3], H = m11[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, m11[2], r0];
              }
              function aue(a, F11) {
                if (F11[0] === 0) {
                  var m11 = F11[1], O = Un(u(a[1][1 + Vs], a), m11);
                  return m11 === O ? F11 : [0, O];
                }
                var H = F11[1], $ = o(a[1][1 + q9], a, H);
                return H === $ ? F11 : [1, $];
              }
              function cue(a, F11) {
                var m11 = F11[2], O = ze(u(a[1][1 + lt], a), m11);
                return m11 === O ? F11 : [0, F11[1], O];
              }
              function sue(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + lt], a, H), r0 = ze(u(a[1][1 + lt], a), O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function vue(a, F11, m11) {
                var O = m11[5], H = m11[2], $ = m11[1], r0 = ze(u(a[1][1 + si], a), H), j0 = ze(u(a[1][1 + Or], a), $), V0 = o(a[1][1 + s0], a, O);
                return H === r0 && $ === j0 && O === V0 ? m11 : [0, j0, r0, m11[3], m11[4], V0];
              }
              function lue(a, F11) {
                if (F11[0] === 0) {
                  var m11 = function(r0) {
                    return [0, r0];
                  }, O = F11[1];
                  return ee(u(a[1][1 + Or], a), O, F11, m11);
                }
                function H(r0) {
                  return [1, r0];
                }
                var $ = F11[1];
                return ee(u(a[1][1 + nn], a), $, F11, H);
              }
              function bue(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = o(a[1][1 + M9], a, H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && r0 === O ? m11 : [0, m11[1], $, r0];
              }
              function pue(a, F11) {
                return o(a[1][1 + lt], a, F11);
              }
              function mue(a, F11) {
                var m11 = F11[2], O = m11[1], H = o(a[1][1 + H1], a, O);
                return O === H ? F11 : [0, F11[1], [0, H, m11[2]]];
              }
              function _ue(a, F11) {
                var m11 = F11[2], O = m11[1], H = o(a[1][1 + H1], a, O);
                return O === H ? F11 : [0, F11[1], [0, H, m11[2]]];
              }
              function yue(a, F11) {
                var m11 = F11[2], O = m11[1], H = o(a[1][1 + H1], a, O);
                return O === H ? F11 : [0, F11[1], [0, H, m11[2]]];
              }
              function hue(a, F11) {
                var m11 = F11[2][1], O = o(a[1][1 + H1], a, m11);
                return m11 === O ? F11 : [0, F11[1], [0, O]];
              }
              function due(a, F11) {
                var m11 = F11[3], O = F11[1], H = Un(u(a[1][1 + vi], a), O), $ = o(a[1][1 + s0], a, m11);
                return O === H && m11 === $ ? F11 : [0, H, F11[2], $];
              }
              function kue(a, F11) {
                var m11 = F11[4], O = F11[1];
                if (O[0] === 0)
                  var H = function(_e) {
                    return [0, _e];
                  }, $ = O[1], r0 = u(a[1][1 + vi], a), Gr = ee(function(_e) {
                    return Un(r0, _e);
                  }, $, O, H);
                else
                  var j0 = function(_e) {
                    return [1, _e];
                  }, V0 = O[1], Nr = u(a[1][1 + s22], a), Gr = ee(function(_e) {
                    return Un(Nr, _e);
                  }, V0, O, j0);
                var Fe = o(a[1][1 + s0], a, m11);
                return O === Gr && m11 === Fe ? F11 : [0, Gr, F11[2], F11[3], Fe];
              }
              function wue(a, F11) {
                var m11 = F11[4], O = F11[1], H = Un(u(a[1][1 + H9], a), O), $ = o(a[1][1 + s0], a, m11);
                return O === H && m11 === $ ? F11 : [0, H, F11[2], F11[3], $];
              }
              function Eue(a, F11) {
                var m11 = F11[4], O = F11[1], H = Un(u(a[1][1 + cb], a), O), $ = o(a[1][1 + s0], a, m11);
                return O === H && m11 === $ ? F11 : [0, H, F11[2], F11[3], $];
              }
              function Sue(a, F11) {
                var m11 = F11[2], O = F11[1];
                switch (m11[0]) {
                  case 0:
                    var H = function(_e) {
                      return [0, O, [0, _e]];
                    }, $ = m11[1];
                    return ee(u(a[1][1 + sb], a), $, F11, H);
                  case 1:
                    var r0 = function(_e) {
                      return [0, O, [1, _e]];
                    }, j0 = m11[1];
                    return ee(u(a[1][1 + X9], a), j0, F11, r0);
                  case 2:
                    var V0 = function(_e) {
                      return [0, O, [2, _e]];
                    }, Nr = m11[1];
                    return ee(u(a[1][1 + U9], a), Nr, F11, V0);
                  default:
                    var Gr = function(_e) {
                      return [0, O, [3, _e]];
                    }, Fe = m11[1];
                    return ee(u(a[1][1 + zs], a), Fe, F11, Gr);
                }
              }
              function gue(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = ur(a[1][1 + L0], a, i6r, $), j0 = o(a[1][1 + Y9], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function Fue(a, F11, m11) {
                var O = m11[1], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, H];
              }
              function Tue(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + Or], a, $), j0 = o(a[1][1 + _r], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function Oue(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = ur(a[1][1 + L0], a, u6r, $), j0 = o(a[1][1 + l], a, H), V0 = o(a[1][1 + s0], a, O);
                return r0 === $ && j0 === H && V0 === O ? m11 : [0, r0, j0, V0];
              }
              function Iue(a, F11, m11) {
                return ur(a[1][1 + c0], a, F11, m11);
              }
              function Aue(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = o(a[1][1 + l], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function Nue(a, F11, m11) {
                var O = m11[4], H = m11[2], $ = _u(u(a[1][1 + zi], a), H), r0 = o(a[1][1 + s0], a, O);
                return $ === H && O === r0 ? m11 : [0, m11[1], $, m11[3], r0];
              }
              function Cue(a, F11, m11) {
                return ur(a[1][1 + Hn], a, F11, m11);
              }
              function Pue(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + he], a, r0), V0 = o(a[1][1 + l], a, $), Nr = ze(u(a[1][1 + Ir], a), H), Gr = o(a[1][1 + s0], a, O);
                return j0 === r0 && V0 === $ && Nr === H && Gr === O ? m11 : [0, j0, V0, Nr, Gr];
              }
              function Due(a, F11) {
                switch (F11[0]) {
                  case 0:
                    var m11 = F11[1], O = m11[2], H = m11[1], $ = ur(a[1][1 + vb], a, H, O);
                    return $ === O ? F11 : [0, [0, H, $]];
                  case 1:
                    var r0 = F11[1], j0 = r0[2], V0 = r0[1], Nr = ur(a[1][1 + lb], a, V0, j0);
                    return Nr === j0 ? F11 : [1, [0, V0, Nr]];
                  case 2:
                    var Gr = F11[1], Fe = Gr[2], _e = Gr[1], Dn = ur(a[1][1 + v2], a, _e, Fe);
                    return Dn === Fe ? F11 : [2, [0, _e, Dn]];
                  case 3:
                    var yn = F11[1], ot = o(a[1][1 + t0], a, yn);
                    return ot === yn ? F11 : [3, ot];
                  case 4:
                    var pt = F11[1], kt = pt[2], Kn = pt[1], Qt = ur(a[1][1 + c0], a, Kn, kt);
                    return Qt === kt ? F11 : [4, [0, Kn, Qt]];
                  case 5:
                    var J7 = F11[1], $7 = J7[2], E7 = J7[1], Z72 = ur(a[1][1 + Er], a, E7, $7);
                    return Z72 === $7 ? F11 : [5, [0, E7, Z72]];
                  default:
                    var Q7 = F11[1], ri = Q7[2], ei = Q7[1], ni = ur(a[1][1 + Hn], a, ei, ri);
                    return ni === ri ? F11 : [6, [0, ei, ni]];
                }
              }
              function Lue(a, F11, m11) {
                var O = m11[5], H = m11[3], $ = m11[2], r0 = ze(u(a[1][1 + si], a), H), j0 = ze(u(a[1][1 + Z9], a), $), V0 = o(a[1][1 + s0], a, O);
                return H === r0 && $ === j0 && O === V0 ? m11 : [0, m11[1], j0, r0, m11[4], V0];
              }
              function Rue(a, F11, m11) {
                var O = m11[7], H = m11[6], $ = m11[5], r0 = m11[4], j0 = m11[3], V0 = m11[2], Nr = m11[1], Gr = o(a[1][1 + hb], a, Nr), Fe = ze(u(a[1][1 + V], a), V0), _e = _u(u(a[1][1 + qr], a), j0), Dn = u(a[1][1 + ou], a), yn = ze(function(Qt) {
                  return _u(Dn, Qt);
                }, r0), ot = u(a[1][1 + ou], a), pt = Un(function(Qt) {
                  return _u(ot, Qt);
                }, $), kt = ze(u(a[1][1 + l2], a), H), Kn = o(a[1][1 + s0], a, O);
                return Gr === Nr && Fe === V0 && _e === j0 && yn === r0 && pt === $ && kt === H && Kn === O ? m11 : [0, Gr, Fe, _e, yn, pt, kt, Kn];
              }
              function jue(a, F11, m11) {
                var O = m11[1], H = o(a[1][1 + s0], a, O);
                return O === H ? m11 : [0, H];
              }
              function Gue(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = ze(u(a[1][1 + Q0], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function Mue(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + _r], a, r0), V0 = o(a[1][1 + nn], a, $), Nr = o(a[1][1 + nn], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m11 : [0, j0, V0, Nr, Gr];
              }
              function Bue(a, F11, m11) {
                return m11;
              }
              function que(a, F11, m11) {
                var O = m11[6], H = m11[5], $ = m11[3], r0 = m11[2], j0 = m11[1], V0 = o(a[1][1 + ar], a, j0), Nr = o(a[1][1 + _b], a, r0), Gr = o(a[1][1 + x0], a, $), Fe = o(a[1][1 + c], a, H), _e = o(a[1][1 + s0], a, O);
                return j0 === V0 && r0 === Nr && Gr === $ && Fe === H && _e === O ? m11 : [0, V0, Nr, Gr, m11[4], Fe, _e];
              }
              function Uue(a, F11) {
                if (typeof F11 == "number")
                  return F11;
                var m11 = F11[1], O = o(a[1][1 + nn], a, m11);
                return m11 === O ? F11 : [0, O];
              }
              function Hue(a, F11, m11) {
                var O = m11[6], H = m11[5], $ = m11[3], r0 = m11[2], j0 = m11[1], V0 = o(a[1][1 + oe], a, j0), Nr = o(a[1][1 + _b], a, r0), Gr = o(a[1][1 + x0], a, $), Fe = o(a[1][1 + c], a, H), _e = o(a[1][1 + s0], a, O);
                return j0 === V0 && r0 === Nr && Gr === $ && Fe === H && _e === O ? m11 : [0, V0, Nr, Gr, m11[4], Fe, _e];
              }
              function Xue(a, F11, m11) {
                var O = m11[6], H = m11[5], $ = m11[3], r0 = m11[2], j0 = o(a[1][1 + oe], a, r0), V0 = _u(u(a[1][1 + me], a), $), Nr = Un(u(a[1][1 + db], a), H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m11 : [0, m11[1], j0, V0, m11[4], Nr, Gr];
              }
              function Yue(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + m0], a, H), r0 = ze(u(a[1][1 + e0], a), O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Vue(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = Un(u(a[1][1 + r_], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function zue(a, F11) {
                switch (F11[0]) {
                  case 0:
                    var m11 = F11[1], O = m11[1], H = function(yn) {
                      return [0, [0, O, yn]];
                    }, $ = m11[2];
                    return te(u(a[1][1 + Xc], a), O, $, F11, H);
                  case 1:
                    var r0 = F11[1], j0 = r0[1], V0 = function(yn) {
                      return [1, [0, j0, yn]];
                    }, Nr = r0[2];
                    return te(u(a[1][1 + yb], a), j0, Nr, F11, V0);
                  default:
                    var Gr = F11[1], Fe = Gr[1], _e = function(yn) {
                      return [2, [0, Fe, yn]];
                    }, Dn = Gr[2];
                    return te(u(a[1][1 + Q9], a), Fe, Dn, F11, _e);
                }
              }
              function Kue(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = o(a[1][1 + nn], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Wue(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = Un(u(a[1][1 + Ks], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function Jue(a, F11) {
                return ur(a[1][1 + L0], a, t6r, F11);
              }
              function $ue(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + nn], a, $), j0 = ze(u(a[1][1 + e0], a), H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function Zue(a, F11, m11) {
                var O = m11[7], H = m11[6], $ = m11[5], r0 = m11[4], j0 = m11[3], V0 = m11[2], Nr = m11[1], Gr = ze(u(a[1][1 + hb], a), Nr), Fe = o(a[1][1 + n_], a, V0), _e = ze(u(a[1][1 + V], a), j0), Dn = u(a[1][1 + Yc], a), yn = ze(function(Kn) {
                  return _u(Dn, Kn);
                }, r0), ot = ze(u(a[1][1 + l2], a), $), pt = Un(u(a[1][1 + db], a), H), kt = o(a[1][1 + s0], a, O);
                return Nr === Gr && V0 === Fe && r0 === yn && $ === ot && H === pt && O === kt && j0 === _e ? m11 : [0, Gr, Fe, _e, yn, ot, pt, kt];
              }
              function Que(a, F11, m11) {
                return ur(a[1][1 + ds], a, F11, m11);
              }
              function r7e(a, F11, m11) {
                return ur(a[1][1 + ds], a, F11, m11);
              }
              function e7e(a, F11, m11) {
                var O = m11[3], H = m11[2], $ = m11[1], r0 = ze(u(a[1][1 + t_], a), $), j0 = o(a[1][1 + u_], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, r0, j0, V0];
              }
              function n7e(a, F11) {
                return _u(u(a[1][1 + zi], a), F11);
              }
              function t7e(a, F11) {
                if (F11[0] === 0) {
                  var m11 = F11[1], O = o(a[1][1 + t0], a, m11);
                  return O === m11 ? F11 : [0, O];
                }
                var H = F11[1], $ = H[2][1], r0 = o(a[1][1 + s0], a, $);
                return $ === r0 ? F11 : [1, [0, H[1], [0, r0]]];
              }
              function u7e(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = Un(u(a[1][1 + i_], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function i7e(a, F11, m11) {
                var O = m11[1], H = ur(a[1][1 + kb], a, F11, O);
                return O === H ? m11 : [0, H, m11[2], m11[3]];
              }
              function f7e(a, F11) {
                var m11 = F11[2], O = m11[2], H = m11[1], $ = Un(u(a[1][1 + Ys], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? F11 : [0, F11[1], [0, $, r0]];
              }
              function x7e(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = m11[1], j0 = o(a[1][1 + nn], a, r0), V0 = ze(u(a[1][1 + b2], a), $), Nr = o(a[1][1 + Ws], a, H), Gr = o(a[1][1 + s0], a, O);
                return r0 === j0 && $ === V0 && H === Nr && O === Gr ? m11 : [0, j0, V0, Nr, Gr];
              }
              function o7e(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = ze(u(a[1][1 + Q0], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function a7e(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = o(a[1][1 + Tr], a, H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function c7e(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = o(a[1][1 + nn], a, $), j0 = o(a[1][1 + nn], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, m11[1], r0, j0, V0];
              }
              function s7e(a, F11, m11) {
                var O = m11[4], H = m11[3], $ = m11[2], r0 = o(a[1][1 + m2], a, $), j0 = o(a[1][1 + nn], a, H), V0 = o(a[1][1 + s0], a, O);
                return $ === r0 && H === j0 && O === V0 ? m11 : [0, m11[1], r0, j0, V0];
              }
              function v7e(a, F11, m11) {
                return ur(a[1][1 + jn], a, F11, m11);
              }
              function l7e(a, F11) {
                switch (F11[0]) {
                  case 0:
                    var m11 = function(r0) {
                      return [0, r0];
                    }, O = F11[1];
                    return ee(u(a[1][1 + nn], a), O, F11, m11);
                  case 1:
                    var H = function(r0) {
                      return [1, r0];
                    }, $ = F11[1];
                    return ee(u(a[1][1 + Rr], a), $, F11, H);
                  default:
                    return F11;
                }
              }
              function b7e(a, F11, m11) {
                var O = m11[2], H = m11[1], $ = Un(u(a[1][1 + a_], a), H), r0 = o(a[1][1 + s0], a, O);
                return H === $ && O === r0 ? m11 : [0, $, r0];
              }
              function p7e(a, F11) {
                var m11 = F11[2], O = F11[1];
                switch (m11[0]) {
                  case 0:
                    var H = function(Ue) {
                      return [0, O, [0, Ue]];
                    }, $ = m11[1];
                    return te(u(a[1][1 + y2], a), O, $, F11, H);
                  case 1:
                    var r0 = function(Ue) {
                      return [0, O, [1, Ue]];
                    }, j0 = m11[1];
                    return te(u(a[1][1 + o_], a), O, j0, F11, r0);
                  case 2:
                    var V0 = function(Ue) {
                      return [0, O, [2, Ue]];
                    }, Nr = m11[1];
                    return te(u(a[1][1 + _2], a), O, Nr, F11, V0);
                  case 3:
                    var Gr = function(Ue) {
                      return [0, O, [3, Ue]];
                    }, Fe = m11[1];
                    return te(u(a[1][1 + x_], a), O, Fe, F11, Gr);
                  case 4:
                    var _e = function(Ue) {
                      return [0, O, [4, Ue]];
                    }, Dn = m11[1];
                    return te(u(a[1][1 + kb], a), O, Dn, F11, _e);
                  case 5:
                    var yn = function(Ue) {
                      return [0, O, [5, Ue]];
                    }, ot = m11[1];
                    return te(u(a[1][1 + e_], a), O, ot, F11, yn);
                  case 6:
                    var pt = function(Ue) {
                      return [0, O, [6, Ue]];
                    }, kt = m11[1];
                    return te(u(a[1][1 + Gn], a), O, kt, F11, pt);
                  case 7:
                    var Kn = function(Ue) {
                      return [0, O, [7, Ue]];
                    }, Qt = m11[1];
                    return te(u(a[1][1 + mb], a), O, Qt, F11, Kn);
                  case 8:
                    var J7 = function(Ue) {
                      return [0, O, [8, Ue]];
                    }, $7 = m11[1];
                    return te(u(a[1][1 + Zn], a), O, $7, F11, J7);
                  case 9:
                    var E7 = function(Ue) {
                      return [0, O, [9, Ue]];
                    }, Z72 = m11[1];
                    return te(u(a[1][1 + Yi], a), O, Z72, F11, E7);
                  case 10:
                    var Q7 = function(Ue) {
                      return [0, O, [10, Ue]];
                    }, ri = m11[1];
                    return ee(u(a[1][1 + lt], a), ri, F11, Q7);
                  case 11:
                    var ei = function(Ue) {
                      return [0, O, [11, Ue]];
                    }, ni = m11[1];
                    return ee(o(a[1][1 + Ft], a, O), ni, F11, ei);
                  case 12:
                    var Wi = function(Ue) {
                      return [0, O, [12, Ue]];
                    }, tv = m11[1];
                    return te(u(a[1][1 + Ge], a), O, tv, F11, Wi);
                  case 13:
                    var uv = function(Ue) {
                      return [0, O, [13, Ue]];
                    }, Ji = m11[1];
                    return te(u(a[1][1 + Kr], a), O, Ji, F11, uv);
                  case 14:
                    var iv = function(Ue) {
                      return [0, O, [14, Ue]];
                    }, Gb = m11[1];
                    return te(u(a[1][1 + J0], a), O, Gb, F11, iv);
                  case 15:
                    var Mb = function(Ue) {
                      return [0, O, [15, Ue]];
                    }, Bb = m11[1];
                    return te(u(a[1][1 + X0], a), O, Bb, F11, Mb);
                  case 16:
                    var qb = function(Ue) {
                      return [0, O, [16, Ue]];
                    }, Ub = m11[1];
                    return te(u(a[1][1 + u0], a), O, Ub, F11, qb);
                  case 17:
                    var Hb = function(Ue) {
                      return [0, O, [17, Ue]];
                    }, Xb = m11[1];
                    return te(u(a[1][1 + U], a), O, Xb, F11, Hb);
                  case 18:
                    var Yb = function(Ue) {
                      return [0, O, [18, Ue]];
                    }, Vb = m11[1];
                    return te(u(a[1][1 + I], a), O, Vb, F11, Yb);
                  case 19:
                    var zb = function(Ue) {
                      return [0, O, [19, Ue]];
                    }, Kb = m11[1];
                    return te(u(a[1][1 + Fr], a), O, Kb, F11, zb);
                  case 20:
                    var Wb = function(Ue) {
                      return [0, O, [20, Ue]];
                    }, Jb = m11[1];
                    return ee(o(a[1][1 + $0], a, O), Jb, F11, Wb);
                  case 21:
                    var $b = function(Ue) {
                      return [0, O, [21, Ue]];
                    }, Zb = m11[1];
                    return te(u(a[1][1 + yr], a), O, Zb, F11, $b);
                  case 22:
                    var Qb = function(Ue) {
                      return [0, O, [22, Ue]];
                    }, r4 = m11[1];
                    return te(u(a[1][1 + Wr], a), O, r4, F11, Qb);
                  case 23:
                    var e42 = function(Ue) {
                      return [0, O, [23, Ue]];
                    }, n4 = m11[1];
                    return te(u(a[1][1 + W0], a), O, n4, F11, e42);
                  case 24:
                    var t42 = function(Ue) {
                      return [0, O, [24, Ue]];
                    }, u4 = m11[1];
                    return te(u(a[1][1 + X], a), O, u4, F11, t42);
                  case 25:
                    var i42 = function(Ue) {
                      return [0, O, [25, Ue]];
                    }, f42 = m11[1];
                    return te(u(a[1][1 + R0], a), O, f42, F11, i42);
                  case 26:
                    var x42 = function(Ue) {
                      return [0, O, [26, Ue]];
                    }, o4 = m11[1];
                    return te(u(a[1][1 + U0], a), O, o4, F11, x42);
                  case 27:
                    var Ze = function(Ue) {
                      return [0, O, [27, Ue]];
                    }, AR = m11[1];
                    return te(u(a[1][1 + g0], a), O, AR, F11, Ze);
                  case 28:
                    var NR = function(Ue) {
                      return [0, O, [28, Ue]];
                    }, CR2 = m11[1];
                    return te(u(a[1][1 + w], a), O, CR2, F11, NR);
                  case 29:
                    var PR = function(Ue) {
                      return [0, O, [29, Ue]];
                    }, DR = m11[1];
                    return te(u(a[1][1 + E], a), O, DR, F11, PR);
                  default:
                    var LR = function(Ue) {
                      return [0, O, [30, Ue]];
                    }, RR = m11[1];
                    return te(u(a[1][1 + e4], a), O, RR, F11, LR);
                }
              }
              function m7e(a, F11) {
                var m11 = F11[2], O = F11[1], H = Un(u(a[1][1 + Y1], a), O), $ = Un(u(a[1][1 + Y1], a), m11);
                return O === H && m11 === $ ? F11 : [0, H, $, F11[3]];
              }
              var _7e = 8;
              function y7e(a, F11) {
                return F11;
              }
              function h7e(a, F11) {
                var m11 = F11[2], O = F11[1];
                switch (m11[0]) {
                  case 0:
                    var H = function(Oe) {
                      return [0, O, [0, Oe]];
                    }, $ = m11[1];
                    return te(u(a[1][1 + zi], a), O, $, F11, H);
                  case 1:
                    var r0 = function(Oe) {
                      return [0, O, [1, Oe]];
                    }, j0 = m11[1];
                    return te(u(a[1][1 + Js], a), O, j0, F11, r0);
                  case 2:
                    var V0 = function(Oe) {
                      return [0, O, [2, Oe]];
                    }, Nr = m11[1];
                    return te(u(a[1][1 + V1], a), O, Nr, F11, V0);
                  case 3:
                    var Gr = function(Oe) {
                      return [0, O, [3, Oe]];
                    }, Fe = m11[1];
                    return te(u(a[1][1 + pb], a), O, Fe, F11, Gr);
                  case 4:
                    var _e = function(Oe) {
                      return [0, O, [4, Oe]];
                    }, Dn = m11[1];
                    return te(u(a[1][1 + bb], a), O, Dn, F11, _e);
                  case 5:
                    var yn = function(Oe) {
                      return [0, O, [5, Oe]];
                    }, ot = m11[1];
                    return te(u(a[1][1 + v2], a), O, ot, F11, yn);
                  case 6:
                    var pt = function(Oe) {
                      return [0, O, [6, Oe]];
                    }, kt = m11[1];
                    return te(u(a[1][1 + X1], a), O, kt, F11, pt);
                  case 7:
                    var Kn = function(Oe) {
                      return [0, O, [7, Oe]];
                    }, Qt = m11[1];
                    return te(u(a[1][1 + lb], a), O, Qt, F11, Kn);
                  case 8:
                    var J7 = function(Oe) {
                      return [0, O, [8, Oe]];
                    }, $7 = m11[1];
                    return te(u(a[1][1 + $9], a), O, $7, F11, J7);
                  case 9:
                    var E7 = function(Oe) {
                      return [0, O, [9, Oe]];
                    }, Z72 = m11[1];
                    return te(u(a[1][1 + J9], a), O, Z72, F11, E7);
                  case 10:
                    var Q7 = function(Oe) {
                      return [0, O, [10, Oe]];
                    }, ri = m11[1];
                    return te(u(a[1][1 + W9], a), O, ri, F11, Q7);
                  case 11:
                    var ei = function(Oe) {
                      return [0, O, [11, Oe]];
                    }, ni = m11[1];
                    return te(u(a[1][1 + K9], a), O, ni, F11, ei);
                  case 12:
                    var Wi = function(Oe) {
                      return [0, O, [33, Oe]];
                    }, tv = m11[1];
                    return te(u(a[1][1 + Er], a), O, tv, F11, Wi);
                  case 13:
                    var uv = function(Oe) {
                      return [0, O, [13, Oe]];
                    }, Ji = m11[1];
                    return te(u(a[1][1 + vb], a), O, Ji, F11, uv);
                  case 14:
                    var iv = function(Oe) {
                      return [0, O, [14, Oe]];
                    }, Gb = m11[1];
                    return te(u(a[1][1 + z9], a), O, Gb, F11, iv);
                  case 15:
                    var Mb = function(Oe) {
                      return [0, O, [15, Oe]];
                    }, Bb = m11[1];
                    return te(u(a[1][1 + V9], a), O, Bb, F11, Mb);
                  case 16:
                    var qb = function(Oe) {
                      return [0, O, [16, Oe]];
                    }, Ub = m11[1];
                    return te(u(a[1][1 + ab], a), O, Ub, F11, qb);
                  case 17:
                    var Hb = function(Oe) {
                      return [0, O, [17, Oe]];
                    }, Xb = m11[1];
                    return te(u(a[1][1 + B9], a), O, Xb, F11, Hb);
                  case 18:
                    var Yb = function(Oe) {
                      return [0, O, [18, Oe]];
                    }, Vb = m11[1];
                    return te(u(a[1][1 + c2], a), O, Vb, F11, Yb);
                  case 19:
                    var zb = function(Oe) {
                      return [0, O, [19, Oe]];
                    }, Kb = m11[1];
                    return te(u(a[1][1 + Xs], a), O, Kb, F11, zb);
                  case 20:
                    var Wb = function(Oe) {
                      return [0, O, [20, Oe]];
                    }, Jb = m11[1];
                    return te(u(a[1][1 + dt], a), O, Jb, F11, Wb);
                  case 21:
                    var $b = function(Oe) {
                      return [0, O, [21, Oe]];
                    }, Zb = m11[1];
                    return te(u(a[1][1 + Au], a), O, Zb, F11, $b);
                  case 22:
                    var Qb = function(Oe) {
                      return [0, O, [22, Oe]];
                    }, r4 = m11[1];
                    return te(u(a[1][1 + ln], a), O, r4, F11, Qb);
                  case 23:
                    var e42 = function(Oe) {
                      return [0, O, [23, Oe]];
                    }, n4 = m11[1];
                    return te(u(a[1][1 + wn], a), O, n4, F11, e42);
                  case 24:
                    var t42 = function(Oe) {
                      return [0, O, [24, Oe]];
                    }, u4 = m11[1];
                    return te(u(a[1][1 + Ct], a), O, u4, F11, t42);
                  case 25:
                    var i42 = function(Oe) {
                      return [0, O, [25, Oe]];
                    }, f42 = m11[1];
                    return te(u(a[1][1 + qt], a), O, f42, F11, i42);
                  case 26:
                    var x42 = function(Oe) {
                      return [0, O, [26, Oe]];
                    }, o4 = m11[1];
                    return te(u(a[1][1 + Cn], a), O, o4, F11, x42);
                  case 27:
                    var Ze = function(Oe) {
                      return [0, O, [27, Oe]];
                    }, AR = m11[1];
                    return te(u(a[1][1 + ir], a), O, AR, F11, Ze);
                  case 28:
                    var NR = function(Oe) {
                      return [0, O, [28, Oe]];
                    }, CR2 = m11[1];
                    return te(u(a[1][1 + Jr], a), O, CR2, F11, NR);
                  case 29:
                    var PR = function(Oe) {
                      return [0, O, [29, Oe]];
                    }, DR = m11[1];
                    return te(u(a[1][1 + or], a), O, DR, F11, PR);
                  case 30:
                    var LR = function(Oe) {
                      return [0, O, [30, Oe]];
                    }, RR = m11[1];
                    return te(u(a[1][1 + E0], a), O, RR, F11, LR);
                  case 31:
                    var Ue = function(Oe) {
                      return [0, O, [31, Oe]];
                    }, d7e = m11[1];
                    return te(u(a[1][1 + w0], a), O, d7e, F11, Ue);
                  case 32:
                    var k7e = function(Oe) {
                      return [0, O, [32, Oe]];
                    }, w7e = m11[1];
                    return te(u(a[1][1 + c0], a), O, w7e, F11, k7e);
                  case 33:
                    var E7e = function(Oe) {
                      return [0, O, [33, Oe]];
                    }, S7e = m11[1];
                    return te(u(a[1][1 + Er], a), O, S7e, F11, E7e);
                  case 34:
                    var g7e = function(Oe) {
                      return [0, O, [34, Oe]];
                    }, F7e = m11[1];
                    return te(u(a[1][1 + T], a), O, F7e, F11, g7e);
                  case 35:
                    var T7e = function(Oe) {
                      return [0, O, [35, Oe]];
                    }, O7e = m11[1];
                    return te(u(a[1][1 + x4], a), O, O7e, F11, T7e);
                  default:
                    var I7e = function(Oe) {
                      return [0, O, [36, Oe]];
                    }, A7e = m11[1];
                    return te(u(a[1][1 + i4], a), O, A7e, F11, I7e);
                }
              }
              return jN(t4, [0, qL, function(a, F11) {
                var m11 = F11[2], O = m11[3], H = m11[2], $ = m11[1], r0 = o(a[1][1 + _0], a, $), j0 = o(a[1][1 + s0], a, H), V0 = Un(u(a[1][1 + Y1], a), O);
                return $ === r0 && H === j0 && O === V0 ? F11 : [0, F11[1], [0, r0, j0, V0]];
              }, Or, h7e, Y1, y7e, s0, _7e, ze, hr, hr, m7e, nn, p7e, y2, b7e, a_, l7e, o_, v7e, _2, s7e, x_, c7e, zi, a7e, Js, o7e, kb, x7e, Ws, f7e, $0, i7e, b2, u7e, i_, t7e, u_, n7e, z1, e7e, V1, r7e, e_, Que, ds, Zue, Yc, $ue, hb, Jue, n_, Wue, db, Kue, Ks, zue, l2, Vue, r_, Yue, Xc, Xue, yb, Hue, _b, Uue, Q9, que, Gn, Bue, mb, Mue, pb, Gue, bb, jue, v2, Rue, X1, Lue, Z9, Due, lb, Pue, $9, Cue, J9, Nue, W9, Aue, K9, Iue, vb, Oue, z9, Tue, V9, Fue, ab, gue, Y9, Sue, sb, Eue, X9, wue, U9, kue, zs, due, vi, hue, cb, yue, H9, _ue, s22, mue, H1, pue, B9, bue, M9, lue, c2, vue, Vs, sue, q9, cue, si, aue, Xs, oue, Ys, xue, Au, fue, hs, iue, Hs, uue, ln, tue, xn, nue, it, eue, dt, rue, ut, Qte, Ti, Zte, D0, $te, Ut, Jte, Hc, Wte, a7, Kte, Q0, zte, $r, Vte, Br, Yte, Mr, Xte, ne, Hte, jr, Ute, ge, qte, ce, Bte, q0, Mte, qr, Gte, _n, jte, K7, Rte, Bu, Lte, Y, Dte, s2, Pte, c, Cte, e0, Nte, V, Ate, f0, Ite, ou, Ote, Fn, Tte, vr, Fte, Lr, gte, _, Ste, p2, Ete, f_, wte, k, kte, G, dte, K, hte, M, yte, S11, _te, A11, mte, o0, pte, Zs, bte, d, lte, en, vte, t0, ste, l, cte, x0, ate, wn, ote, Zn, xte, me, fte, jn, ite, B0, ute, W7, tte, He, nte, ft, ete, xt, rte, he, Qne, Yi, Zne, lt, $ne, k0, Jne, m0, Wne, Vc, Kne, Hn, zne, Cn, Vne, ar, Yne, On, Xne, Ft, Hne, du, Une, Wu, qne, Ct, Bne, qt, Mne, vt, Gne, gt, jne, Zt, Rne, Nt, Lne, Ge, Dne, Kr, Pne, mr, Cne, Me, Nne, Cr, Ane, Sr, Ine, Je, One, Ne, Tne, vn, Fne, kn, gne, rn, Sne, cn, IR, Ae, jb, an, Rb, We, nv, re, Lb, F0, ev, Ie, Ki, ve, w7, xe, Ii, Re, wu, sr, ku, Ur, OR, Pr, TR, K0, Db, h0, FR, ir, gR, J0, Pb, X0, SR, u0, ER, yr, wR, I0, E2, y0, kR, D, y_, P0, dR, U, hR, I, Cb, Fr, yR, Qr, __, oe, _R, be, mR, ae, Nb, pe, pR, Er, bR, Le, lR, p, Ab, t_, m_, Vi, vR, Tt, p_, $s, Ib, m2, b_, er, sR, L0, l_, rr, cR, T0, Ob, S0, v_, Q, Tb, L, rv, i0, aR, l0, oR, v0, s_, P, Mn, fe, xR, M0, Fb, O0, fR, b0, gb, p0, iR, Z7, Sb, K1, uR, B, Q1, Ir, tR, _r, w2, bt, nR, Jr, k2, Wr, eR, _0, c_, Tr, rR, Hr, QL, Rr, d2, fr, ZL, W0, $L, or, Eb, Ar, JL, X, wb, R0, WL, b, Z1, U0, KL, E0, $1, w0, zL, g0, h22, w, VL, E, YL, T, Oi, y, XL, x4, J1, i4, HL, c0, W1, e4, UL]), function(a, F11) {
                return jp(F11, t4);
              };
            });
            function X00(t4) {
              switch (t4[0]) {
                case 0:
                  return 1;
                case 3:
                  return 3;
                default:
                  return 2;
              }
            }
            function Y00(t4, n) {
              u(f4(t4), O6r), o(f4(t4), A6r, I6r);
              var e4 = n[1];
              o(f4(t4), N6r, e4), u(f4(t4), C6r), u(f4(t4), P6r), o(f4(t4), L6r, D6r);
              var i4 = n[2];
              return o(f4(t4), R6r, i4), u(f4(t4), j6r), u(f4(t4), G6r);
            }
            var V00 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, Fee = function t4(n) {
              return t4.fun(n);
            };
            N(V00, function(t4, n) {
              u(f4(t4), B6r), o(f4(t4), U6r, q6r);
              var e4 = n[1];
              if (e4) {
                g(t4, H6r);
                var i4 = e4[1];
                switch (i4[0]) {
                  case 0:
                    u(f4(t4), m6r);
                    var x4 = i4[1];
                    o(f4(t4), _6r, x4), u(f4(t4), y6r);
                    break;
                  case 1:
                    u(f4(t4), h6r);
                    var c = i4[1];
                    o(f4(t4), d6r, c), u(f4(t4), k6r);
                    break;
                  case 2:
                    u(f4(t4), w6r);
                    var s2 = i4[1];
                    o(f4(t4), E6r, s2), u(f4(t4), S6r);
                    break;
                  default:
                    u(f4(t4), g6r);
                    var p = i4[1];
                    o(f4(t4), F6r, p), u(f4(t4), T6r);
                }
                g(t4, X6r);
              } else
                g(t4, Y6r);
              return u(f4(t4), V6r), u(f4(t4), z6r), o(f4(t4), W6r, K6r), Y00(t4, n[2]), u(f4(t4), J6r), u(f4(t4), $6r), o(f4(t4), Q6r, Z6r), Y00(t4, n[3]), u(f4(t4), rpr), u(f4(t4), epr);
            }), N(Fee, function(t4) {
              return o(C0(M6r), V00, t4);
            });
            function yt(t4, n) {
              return [0, t4[1], t4[2], n[3]];
            }
            function ps(t4, n) {
              var e4 = t4[1] - n[1] | 0;
              return e4 === 0 ? t4[2] - n[2] | 0 : e4;
            }
            function z00(t4, n) {
              var e4 = n[1], i4 = t4[1];
              if (i4)
                if (e4)
                  var x4 = e4[1], c = i4[1], s2 = X00(x4), p = X00(c) - s2 | 0, T = p === 0 ? Ee(c[1], x4[1]) : p;
                else
                  var T = -1;
              else
                var y = e4 && 1, T = y;
              if (T === 0) {
                var E = ps(t4[2], n[2]);
                return E === 0 ? ps(t4[3], n[3]) : E;
              }
              return T;
            }
            function Wv(t4, n) {
              return z00(t4, n) === 0 ? 1 : 0;
            }
            var WD = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Tee = Rp(upr, function(t4) {
              var n = NN(t4, tpr)[35], e4 = LN(t4, 0, 0, npr, KD, 1)[1];
              return zz(t4, n, function(i4, x4) {
                return 0;
              }), function(i4, x4) {
                var c = jp(x4, t4);
                return u(e4, c), RN(x4, c, t4);
              };
            });
            N(WD, function(t4, n, e4) {
              var i4 = e4[2];
              switch (i4[0]) {
                case 0:
                  var x4 = i4[1][1];
                  return le(function(s2, p) {
                    var y = p[0] === 0 ? p[1][2][2] : p[1][2][1];
                    return ur(WD, t4, s2, y);
                  }, n, x4);
                case 1:
                  var c = i4[1][1];
                  return le(function(s2, p) {
                    return p[0] === 2 ? s2 : ur(WD, t4, s2, p[1][2][1]);
                  }, n, c);
                case 2:
                  return o(t4, n, i4[1][1]);
                default:
                  return n;
              }
            });
            function Rc(t4, n) {
              return [0, n[1], [0, n[2], t4]];
            }
            function K00(t4, n, e4) {
              var i4 = t4 && t4[1], x4 = n && n[1];
              return [0, i4, x4, e4];
            }
            function lr(t4, n, e4) {
              var i4 = t4 && t4[1], x4 = n && n[1];
              return !i4 && !x4 ? x4 : [0, K00([0, i4], [0, x4], 0)];
            }
            function yu(t4, n, e4, i4) {
              var x4 = t4 && t4[1], c = n && n[1];
              return !x4 && !c && !e4 ? e4 : [0, K00([0, x4], [0, c], e4)];
            }
            function y7(t4, n) {
              if (t4) {
                if (n) {
                  var e4 = n[1], i4 = t4[1], x4 = [0, on(i4[2], e4[2])];
                  return lr([0, on(e4[1], i4[1])], x4, 0);
                }
                var c = t4;
              } else
                var c = n;
              return c;
            }
            function JD(t4, n) {
              if (n) {
                if (t4) {
                  var e4 = n[1], i4 = t4[1], x4 = i4[3], c = [0, on(i4[2], e4[2])];
                  return yu([0, on(e4[1], i4[1])], c, x4, 0);
                }
                var s2 = n[1];
                return yu([0, s2[1]], [0, s2[2]], 0, 0);
              }
              return t4;
            }
            function Jv(t4, n) {
              for (var e4 = t4, i4 = n; ; ) {
                if (typeof e4 == "number")
                  return i4;
                if (e4[0] === 0)
                  return [0, e4[1], 0, i4];
                var x4 = [0, e4[2], e4[4], i4], e4 = e4[3], i4 = x4;
              }
            }
            function W00(t4, n) {
              if (t4)
                var e4 = Jv(t4[2], t4[3]), i4 = function(c) {
                  return W00(e4, c);
                }, x4 = [0, t4[1], i4];
              else
                var x4 = t4;
              return x4;
            }
            function Oee(t4) {
              var n = Jv(t4, 0);
              return function(e4) {
                return W00(n, e4);
              };
            }
            function ms(t4) {
              return typeof t4 == "number" ? 0 : t4[0] === 0 ? 1 : t4[1];
            }
            function Iee(t4) {
              return [0, t4];
            }
            function Y7(t4, n, e4) {
              var i4 = 0;
              if (typeof t4 == "number") {
                if (typeof e4 == "number")
                  return [0, n];
                e4[0] === 1 && (i4 = 1);
              } else if (t4[0] === 0)
                typeof e4 != "number" && e4[0] === 1 && (i4 = 1);
              else {
                var x4 = t4[1];
                if (typeof e4 != "number" && e4[0] === 1) {
                  var c = e4[1], s2 = c <= x4 ? x4 + 1 | 0 : c + 1 | 0;
                  return [1, s2, n, t4, e4];
                }
                var p = x4;
                i4 = 2;
              }
              switch (i4) {
                case 1:
                  var p = e4[1];
                  break;
                case 0:
                  return [1, 2, n, t4, e4];
              }
              return [1, p + 1 | 0, n, t4, e4];
            }
            function Ns(t4, n, e4) {
              var i4 = ms(t4), x4 = ms(e4), c = x4 <= i4 ? i4 + 1 | 0 : x4 + 1 | 0;
              return [1, c, n, t4, e4];
            }
            function $D(t4, n) {
              var e4 = n !== 0 ? 1 : 0;
              if (e4) {
                if (n !== 1) {
                  var i4 = n >>> 1 | 0, x4 = $D(t4, i4), c = u(t4, 0), s2 = $D(t4, (n - i4 | 0) - 1 | 0);
                  return [1, ms(x4) + 1 | 0, c, x4, s2];
                }
                var p = [0, u(t4, 0)];
              } else
                var p = e4;
              return p;
            }
            function ki(t4, n, e4) {
              var i4 = ms(t4), x4 = ms(e4);
              if ((x4 + 2 | 0) < i4) {
                var c = t4[4], s2 = t4[3], p = t4[2], y = ms(c);
                if (y <= ms(s2))
                  return Ns(s2, p, Y7(c, n, e4));
                var T = Y7(c[4], n, e4), E = c[2];
                return Ns(Y7(s2, p, c[3]), E, T);
              }
              if ((i4 + 2 | 0) < x4) {
                var d = e4[4], w = e4[3], G = e4[2], A11 = ms(w);
                if (A11 <= ms(d))
                  return Ns(Y7(t4, n, w), G, d);
                var S11 = Y7(w[4], G, d), M = w[2];
                return Ns(Y7(t4, n, w[3]), M, S11);
              }
              return Y7(t4, n, e4);
            }
            function J00(t4, n) {
              if (typeof n == "number")
                return [0, t4];
              if (n[0] === 0)
                return Y7([0, t4], n[1], 0);
              var e4 = n[4], i4 = n[2];
              return ki(J00(t4, n[3]), i4, e4);
            }
            function $00(t4, n) {
              if (typeof n == "number")
                return [0, t4];
              if (n[0] === 0)
                return Y7(0, n[1], [0, t4]);
              var e4 = $00(t4, n[4]);
              return ki(n[3], n[2], e4);
            }
            function Vu(t4, n, e4) {
              if (typeof t4 == "number")
                return J00(n, e4);
              if (t4[0] === 0) {
                if (typeof e4 != "number") {
                  if (e4[0] === 0)
                    return Y7(t4, n, e4);
                  if (3 < e4[1]) {
                    var i4 = e4[4], x4 = e4[2];
                    return ki(Vu(t4, n, e4[3]), x4, i4);
                  }
                  return Ns(t4, n, e4);
                }
              } else {
                var c = t4[4], s2 = t4[3], p = t4[2], y = t4[1];
                if (typeof e4 != "number") {
                  if (e4[0] === 0)
                    return 3 < y ? ki(s2, p, Vu(c, n, e4)) : Ns(t4, n, e4);
                  var T = e4[1];
                  if ((T + 2 | 0) < y)
                    return ki(s2, p, Vu(c, n, e4));
                  if ((y + 2 | 0) < T) {
                    var E = e4[4], d = e4[2];
                    return ki(Vu(t4, n, e4[3]), d, E);
                  }
                  return Ns(t4, n, e4);
                }
              }
              return $00(n, t4);
            }
            function Pl(t4) {
              for (var n = t4; ; ) {
                if (typeof n == "number")
                  throw Jt;
                if (n[0] === 0)
                  return n[1];
                if (typeof n[3] == "number")
                  return n[2];
                var n = n[3];
              }
            }
            function Z00(t4) {
              for (var n = t4; ; ) {
                if (typeof n == "number")
                  return 0;
                if (n[0] === 0)
                  return [0, n[1]];
                if (typeof n[3] == "number")
                  return [0, n[2]];
                var n = n[3];
              }
            }
            function Q00(t4) {
              for (var n = t4; ; ) {
                if (typeof n == "number")
                  throw Jt;
                if (n[0] === 0)
                  return n[1];
                if (typeof n[4] == "number")
                  return n[2];
                var n = n[4];
              }
            }
            function Aee(t4) {
              for (var n = t4; ; ) {
                if (typeof n == "number")
                  return 0;
                if (n[0] === 0)
                  return [0, n[1]];
                if (typeof n[4] == "number")
                  return [0, n[2]];
                var n = n[4];
              }
            }
            function ZD(t4) {
              if (typeof t4 == "number")
                return Pu(Upr);
              if (t4[0] === 0)
                return 0;
              if (typeof t4[3] == "number")
                return t4[4];
              var n = t4[4], e4 = t4[2];
              return ki(ZD(t4[3]), e4, n);
            }
            function Dl(t4, n) {
              if (typeof t4 == "number")
                return n;
              if (typeof n == "number")
                return t4;
              var e4 = ZD(n);
              return Vu(t4, Pl(n), e4);
            }
            function QD(t4) {
              if (typeof t4 == "number")
                return 0;
              if (t4[0] === 0)
                return 1;
              var n = QD(t4[4]);
              return (QD(t4[3]) + 1 | 0) + n | 0;
            }
            function rr0(t4, n) {
              for (var e4 = t4, i4 = n; ; ) {
                if (typeof i4 == "number")
                  return e4;
                if (i4[0] === 0)
                  return [0, i4[1], e4];
                var x4 = i4[3], c = rr0(e4, i4[4]), e4 = [0, i4[2], c], i4 = x4;
              }
            }
            function er0(t4) {
              return rr0(0, t4);
            }
            var st = 0;
            function rL(t4) {
              var n = typeof t4 == "number" ? 1 : 0, e4 = n && 1;
              return e4;
            }
            function eL(t4) {
              function n(e0, x0) {
                if (typeof x0 == "number")
                  return [0, e0];
                if (x0[0] === 0) {
                  var l = x0[1], c0 = o(t4[1], e0, l);
                  return c0 === 0 ? x0 : 0 <= c0 ? Y7(x0, e0, st) : Y7([0, e0], l, st);
                }
                var t0 = x0[4], o0 = x0[3], w0 = x0[2], _0 = o(t4[1], e0, w0);
                if (_0 === 0)
                  return x0;
                if (0 <= _0) {
                  var E0 = n(e0, t0);
                  return t0 === E0 ? x0 : ki(o0, w0, E0);
                }
                var U0 = n(e0, o0);
                return o0 === U0 ? x0 : ki(U0, w0, t0);
              }
              function e4(e0, x0) {
                if (typeof x0 == "number")
                  return [0, st, 0, st];
                if (x0[0] === 0) {
                  var l = o(t4[1], e0, x0[1]);
                  return l === 0 ? [0, st, 1, st] : 0 <= l ? [0, x0, 0, st] : [0, st, 0, x0];
                }
                var c0 = x0[4], t0 = x0[3], o0 = x0[2], w0 = o(t4[1], e0, o0);
                if (w0 === 0)
                  return [0, t0, 1, c0];
                if (0 <= w0) {
                  var _0 = e4(e0, c0), E0 = _0[3], U0 = _0[2];
                  return [0, Vu(t0, o0, _0[1]), U0, E0];
                }
                var b = e4(e0, t0), R0 = Vu(b[3], o0, c0);
                return [0, b[1], b[2], R0];
              }
              function i4(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number")
                    return 0;
                  if (l[0] === 0)
                    return o(t4[1], e0, l[1]) === 0 ? 1 : 0;
                  var c0 = o(t4[1], e0, l[2]), t0 = c0 === 0 ? 1 : 0;
                  if (t0)
                    return t0;
                  var o0 = 0 <= c0 ? l[4] : l[3], l = o0;
                }
              }
              function x4(e0, x0) {
                if (typeof x0 == "number")
                  return st;
                if (x0[0] === 0)
                  return o(t4[1], e0, x0[1]) === 0 ? st : x0;
                var l = x0[4], c0 = x0[3], t0 = x0[2], o0 = o(t4[1], e0, t0);
                if (o0 === 0) {
                  if (typeof c0 == "number")
                    return l;
                  if (typeof l == "number")
                    return c0;
                  var w0 = ZD(l);
                  return ki(c0, Pl(l), w0);
                }
                if (0 <= o0) {
                  var _0 = x4(e0, l);
                  return l === _0 ? x0 : ki(c0, t0, _0);
                }
                var E0 = x4(e0, c0);
                return c0 === E0 ? x0 : ki(E0, t0, l);
              }
              function c(e0, x0) {
                if (typeof e0 == "number")
                  return x0;
                if (e0[0] === 1) {
                  var l = e0[2], c0 = e0[1];
                  if (typeof x0 != "number") {
                    if (x0[0] === 0)
                      return n(x0[1], e0);
                    var t0 = x0[2], o0 = x0[1];
                    if (o0 <= c0) {
                      if (o0 === 1)
                        return n(t0, e0);
                      var w0 = e4(l, x0), _0 = c(e0[4], w0[3]);
                      return Vu(c(e0[3], w0[1]), l, _0);
                    }
                    if (c0 === 1)
                      return n(l, x0);
                    var E0 = e4(t0, e0), U0 = c(E0[3], x0[4]);
                    return Vu(c(E0[1], x0[3]), t0, U0);
                  }
                }
                return typeof x0 == "number" ? e0 : n(e0[1], x0);
              }
              function s2(e0, x0) {
                if (typeof e0 == "number" || typeof x0 == "number")
                  return st;
                if (typeof e0 != "number" && e0[0] !== 0) {
                  var l = e0[4], c0 = e0[3], t0 = e0[2], o0 = e4(t0, x0), w0 = o0[1];
                  if (o0[2]) {
                    var _0 = s2(l, o0[3]);
                    return Vu(s2(c0, w0), t0, _0);
                  }
                  var E0 = s2(l, o0[3]);
                  return Dl(s2(c0, w0), E0);
                }
                return i4(e0[1], x0) ? e0 : st;
              }
              function p(e0, x0) {
                if (typeof x0 == "number")
                  return [0, st, function(s0) {
                    return st;
                  }];
                if (x0[0] === 0)
                  return o(t4[1], e0, x0[1]) === 0 ? 0 : [0, st, function(s0) {
                    return st;
                  }];
                var l = x0[4], c0 = x0[3], t0 = x0[2], o0 = o(t4[1], e0, t0);
                if (o0 === 0)
                  return 0;
                if (0 <= o0) {
                  var w0 = p(e0, l);
                  if (w0)
                    var _0 = w0[2], E0 = [0, Vu(c0, t0, w0[1]), _0];
                  else
                    var E0 = w0;
                  return E0;
                }
                var U0 = p(e0, c0);
                if (U0)
                  var b = U0[2], R0 = function(s0) {
                    return Vu(u(b, 0), t0, l);
                  }, X = [0, U0[1], R0];
                else
                  var X = U0;
                return X;
              }
              function y(e0, x0) {
                for (var l = e0, c0 = x0; ; ) {
                  if (typeof l != "number" && typeof c0 != "number") {
                    var t0 = 0;
                    if (typeof l != "number" && l[0] !== 0) {
                      if (typeof c0 != "number" && c0[0] !== 0) {
                        if (l === c0)
                          return 0;
                        var o0 = p(l[2], c0);
                        if (o0) {
                          var w0 = y(l[3], o0[1]);
                          if (w0) {
                            var _0 = u(o0[2], 0), l = l[4], c0 = _0;
                            continue;
                          }
                          var E0 = w0;
                        } else
                          var E0 = o0;
                        return E0;
                      }
                      var U0 = l, b = c0[1];
                      t0 = 1;
                    }
                    if (!t0)
                      var U0 = c0, b = l[1];
                    return 1 - i4(b, U0);
                  }
                  return 1;
                }
              }
              function T(e0, x0) {
                if (typeof e0 == "number")
                  return st;
                if (typeof x0 == "number")
                  return e0;
                if (typeof e0 != "number" && e0[0] !== 0) {
                  var l = e0[4], c0 = e0[3], t0 = e0[2], o0 = e4(t0, x0), w0 = o0[1];
                  if (o0[2]) {
                    var _0 = T(l, o0[3]);
                    return Dl(T(c0, w0), _0);
                  }
                  var E0 = T(l, o0[3]);
                  return Vu(T(c0, w0), t0, E0);
                }
                return i4(e0[1], x0) ? st : e0;
              }
              function E(e0, x0) {
                for (var l = Jv(x0, 0), c0 = Jv(e0, 0), t0 = l; ; ) {
                  if (c0) {
                    if (t0) {
                      var o0 = o(t4[1], c0[1], t0[1]);
                      if (o0 === 0) {
                        var w0 = Jv(t0[2], t0[3]), c0 = Jv(c0[2], c0[3]), t0 = w0;
                        continue;
                      }
                      return o0;
                    }
                    return 1;
                  }
                  var _0 = t0 && -1;
                  return _0;
                }
              }
              function d(e0, x0) {
                return E(e0, x0) === 0 ? 1 : 0;
              }
              function w(e0, x0) {
                for (var l = e0, c0 = x0; ; ) {
                  if (typeof l == "number")
                    return 1;
                  if (l[0] === 0) {
                    var t0 = l[1];
                    if (typeof c0 != "number") {
                      if (c0[0] === 0) {
                        var o0 = o(t4[1], t0, c0[1]) === 0 ? 1 : 0, w0 = o0 && 1;
                        return w0;
                      }
                      var _0 = o(t4[1], t0, c0[2]);
                      if (_0 === 0)
                        return 1;
                      if (0 <= _0) {
                        var c0 = c0[4];
                        continue;
                      }
                      var c0 = c0[3];
                      continue;
                    }
                  } else {
                    var E0 = l[4], U0 = l[3], b = l[2];
                    if (typeof c0 != "number") {
                      if (c0[0] === 0) {
                        var R0 = l[1] === 1 ? 1 : 0, X = R0 && (o(t4[1], b, c0[1]) === 0 ? 1 : 0);
                        return X;
                      }
                      var s0 = c0[4], hr = c0[3], Ar = o(t4[1], b, c0[2]);
                      if (Ar === 0) {
                        var or = w(U0, hr);
                        if (or) {
                          var l = E0, c0 = s0;
                          continue;
                        }
                        return or;
                      }
                      if (0 <= Ar) {
                        var W0 = w(Y7(st, b, E0), s0);
                        if (W0) {
                          var l = U0;
                          continue;
                        }
                        return W0;
                      }
                      var Lr = w(Y7(U0, b, st), hr);
                      if (Lr) {
                        var l = E0;
                        continue;
                      }
                      return Lr;
                    }
                  }
                  return 0;
                }
              }
              function G(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number")
                    return 0;
                  if (l[0] === 0)
                    return u(e0, l[1]);
                  G(e0, l[3]), u(e0, l[2]);
                  var l = l[4];
                }
              }
              function A11(e0, x0, l) {
                for (var c0 = x0, t0 = l; ; ) {
                  if (typeof c0 == "number")
                    return t0;
                  if (c0[0] === 0)
                    return o(e0, c0[1], t0);
                  var o0 = A11(e0, c0[3], t0), w0 = o(e0, c0[2], o0), c0 = c0[4], t0 = w0;
                }
              }
              function S11(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number")
                    return 1;
                  if (l[0] === 0)
                    return u(e0, l[1]);
                  var c0 = u(e0, l[2]);
                  if (c0) {
                    var t0 = S11(e0, l[3]);
                    if (t0) {
                      var l = l[4];
                      continue;
                    }
                    var o0 = t0;
                  } else
                    var o0 = c0;
                  return o0;
                }
              }
              function M(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number")
                    return 0;
                  if (l[0] === 0)
                    return u(e0, l[1]);
                  var c0 = u(e0, l[2]);
                  if (c0)
                    var t0 = c0;
                  else {
                    var o0 = M(e0, l[3]);
                    if (!o0) {
                      var l = l[4];
                      continue;
                    }
                    var t0 = o0;
                  }
                  return t0;
                }
              }
              function K(e0, x0) {
                if (typeof x0 == "number")
                  return st;
                if (x0[0] === 0)
                  return u(e0, x0[1]) ? x0 : st;
                var l = x0[4], c0 = x0[3], t0 = x0[2], o0 = K(e0, c0), w0 = u(e0, t0), _0 = K(e0, l);
                return w0 ? c0 === o0 && l === _0 ? x0 : Vu(o0, t0, _0) : Dl(o0, _0);
              }
              function V(e0, x0) {
                if (typeof x0 == "number")
                  return [0, st, st];
                if (x0[0] === 0)
                  return u(e0, x0[1]) ? [0, x0, st] : [0, st, x0];
                var l = x0[2], c0 = V(e0, x0[3]), t0 = c0[2], o0 = c0[1], w0 = u(e0, l), _0 = V(e0, x0[4]), E0 = _0[2], U0 = _0[1];
                if (w0) {
                  var b = Dl(t0, E0);
                  return [0, Vu(o0, l, U0), b];
                }
                var R0 = Vu(t0, l, E0);
                return [0, Dl(o0, U0), R0];
              }
              function f0(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number")
                    throw Jt;
                  if (l[0] === 0) {
                    var c0 = l[1];
                    if (o(t4[1], e0, c0) === 0)
                      return c0;
                    throw Jt;
                  }
                  var t0 = l[2], o0 = o(t4[1], e0, t0);
                  if (o0 === 0)
                    return t0;
                  var w0 = 0 <= o0 ? l[4] : l[3], l = w0;
                }
              }
              function m0(e0, x0) {
                for (var l = x0; ; ) {
                  if (typeof l == "number")
                    return 0;
                  if (l[0] === 0) {
                    var c0 = l[1], t0 = o(t4[1], e0, c0) === 0 ? 1 : 0, o0 = t0 && [0, c0];
                    return o0;
                  }
                  var w0 = l[2], _0 = o(t4[1], e0, w0);
                  if (_0 === 0)
                    return [0, w0];
                  var E0 = 0 <= _0 ? l[4] : l[3], l = E0;
                }
              }
              function k0(e0, x0) {
                if (typeof x0 == "number")
                  return st;
                if (x0[0] === 0) {
                  var l = x0[1], c0 = u(e0, l);
                  return l === c0 ? x0 : [0, c0];
                }
                var t0 = x0[4], o0 = x0[3], w0 = x0[2], _0 = k0(e0, o0), E0 = u(e0, w0), U0 = k0(e0, t0);
                if (o0 === _0 && w0 === E0 && t0 === U0)
                  return x0;
                var b = 0;
                if (!rL(_0)) {
                  var R0 = Q00(_0);
                  0 <= o(t4[1], R0, E0) && (b = 1);
                }
                if (!b) {
                  var X = 0;
                  if (!rL(U0)) {
                    var s0 = Pl(U0);
                    0 <= o(t4[1], E0, s0) && (X = 1);
                  }
                  if (!X)
                    return Vu(_0, E0, U0);
                }
                return c(_0, n(E0, U0));
              }
              function g0(e0) {
                if (e0) {
                  var x0 = e0[2], l = e0[1];
                  if (x0) {
                    var c0 = x0[2], t0 = x0[1];
                    if (c0) {
                      var o0 = c0[2], w0 = c0[1];
                      if (o0) {
                        var _0 = o0[2], E0 = o0[1];
                        if (_0) {
                          if (_0[2]) {
                            var U0 = t4[1], b = function(or, W0) {
                              if (or === 2) {
                                if (W0) {
                                  var Lr = W0[2];
                                  if (Lr) {
                                    var Tr = Lr[1], Hr = W0[1], Or = Lr[2], fr = o(U0, Hr, Tr), Rr = fr === 0 ? [0, Hr, 0] : 0 < fr ? [0, Hr, [0, Tr, 0]] : [0, Tr, [0, Hr, 0]];
                                    return [0, Rr, Or];
                                  }
                                }
                              } else if (or === 3 && W0) {
                                var Wr = W0[2];
                                if (Wr) {
                                  var Jr = Wr[2];
                                  if (Jr) {
                                    var ar = Jr[1], _r = Wr[1], Ir = W0[1], fe = Jr[2], v0 = o(U0, Ir, _r);
                                    if (v0 === 0)
                                      var P = o(U0, _r, ar), L = P === 0 ? [0, _r, 0] : 0 < P ? [0, _r, [0, ar, 0]] : [0, ar, [0, _r, 0]], Q = L;
                                    else if (0 < v0) {
                                      var i0 = o(U0, _r, ar);
                                      if (i0 === 0)
                                        var T0 = [0, Ir, [0, _r, 0]];
                                      else if (0 < i0)
                                        var T0 = [0, Ir, [0, _r, [0, ar, 0]]];
                                      else
                                        var l0 = o(U0, Ir, ar), S0 = l0 === 0 ? [0, Ir, [0, _r, 0]] : 0 < l0 ? [0, Ir, [0, ar, [0, _r, 0]]] : [0, ar, [0, Ir, [0, _r, 0]]], T0 = S0;
                                      var Q = T0;
                                    } else {
                                      var rr = o(U0, Ir, ar);
                                      if (rr === 0)
                                        var Z7 = [0, _r, [0, Ir, 0]];
                                      else if (0 < rr)
                                        var Z7 = [0, _r, [0, Ir, [0, ar, 0]]];
                                      else
                                        var L0 = o(U0, _r, ar), B = L0 === 0 ? [0, _r, [0, Ir, 0]] : 0 < L0 ? [0, _r, [0, ar, [0, Ir, 0]]] : [0, ar, [0, _r, [0, Ir, 0]]], Z7 = B;
                                      var Q = Z7;
                                    }
                                    return [0, Q, fe];
                                  }
                                }
                              }
                              for (var p0 = or >> 1, b0 = R0(p0, W0), O0 = b0[1], M0 = R0(or - p0 | 0, b0[2]), er = O0, yr = M0[1], vr = 0, $0 = M0[2]; ; ) {
                                if (er) {
                                  if (yr) {
                                    var Er = yr[2], Mr = yr[1], Br = er[2], qr = er[1], jr = o(U0, qr, Mr);
                                    if (jr === 0) {
                                      var er = Br, yr = Er, vr = [0, qr, vr];
                                      continue;
                                    }
                                    if (0 <= jr) {
                                      var yr = Er, vr = [0, Mr, vr];
                                      continue;
                                    }
                                    var er = Br, vr = [0, qr, vr];
                                    continue;
                                  }
                                  var $r = Lc(er, vr);
                                } else
                                  var $r = Lc(yr, vr);
                                return [0, $r, $0];
                              }
                            }, R0 = function(or, W0) {
                              if (or === 2) {
                                if (W0) {
                                  var Lr = W0[2];
                                  if (Lr) {
                                    var Tr = Lr[1], Hr = W0[1], Or = Lr[2], fr = o(U0, Hr, Tr), Rr = fr === 0 ? [0, Hr, 0] : 0 <= fr ? [0, Tr, [0, Hr, 0]] : [0, Hr, [0, Tr, 0]];
                                    return [0, Rr, Or];
                                  }
                                }
                              } else if (or === 3 && W0) {
                                var Wr = W0[2];
                                if (Wr) {
                                  var Jr = Wr[2];
                                  if (Jr) {
                                    var ar = Jr[1], _r = Wr[1], Ir = W0[1], fe = Jr[2], v0 = o(U0, Ir, _r);
                                    if (v0 === 0)
                                      var P = o(U0, _r, ar), L = P === 0 ? [0, _r, 0] : 0 <= P ? [0, ar, [0, _r, 0]] : [0, _r, [0, ar, 0]], Q = L;
                                    else if (0 <= v0) {
                                      var i0 = o(U0, Ir, ar);
                                      if (i0 === 0)
                                        var T0 = [0, _r, [0, Ir, 0]];
                                      else if (0 <= i0)
                                        var l0 = o(U0, _r, ar), S0 = l0 === 0 ? [0, _r, [0, Ir, 0]] : 0 <= l0 ? [0, ar, [0, _r, [0, Ir, 0]]] : [0, _r, [0, ar, [0, Ir, 0]]], T0 = S0;
                                      else
                                        var T0 = [0, _r, [0, Ir, [0, ar, 0]]];
                                      var Q = T0;
                                    } else {
                                      var rr = o(U0, _r, ar);
                                      if (rr === 0)
                                        var Z7 = [0, Ir, [0, _r, 0]];
                                      else if (0 <= rr)
                                        var L0 = o(U0, Ir, ar), B = L0 === 0 ? [0, Ir, [0, _r, 0]] : 0 <= L0 ? [0, ar, [0, Ir, [0, _r, 0]]] : [0, Ir, [0, ar, [0, _r, 0]]], Z7 = B;
                                      else
                                        var Z7 = [0, Ir, [0, _r, [0, ar, 0]]];
                                      var Q = Z7;
                                    }
                                    return [0, Q, fe];
                                  }
                                }
                              }
                              for (var p0 = or >> 1, b0 = b(p0, W0), O0 = b0[1], M0 = b(or - p0 | 0, b0[2]), er = O0, yr = M0[1], vr = 0, $0 = M0[2]; ; ) {
                                if (er) {
                                  if (yr) {
                                    var Er = yr[2], Mr = yr[1], Br = er[2], qr = er[1], jr = o(U0, qr, Mr);
                                    if (jr === 0) {
                                      var er = Br, yr = Er, vr = [0, qr, vr];
                                      continue;
                                    }
                                    if (0 < jr) {
                                      var er = Br, vr = [0, qr, vr];
                                      continue;
                                    }
                                    var yr = Er, vr = [0, Mr, vr];
                                    continue;
                                  }
                                  var $r = Lc(er, vr);
                                } else
                                  var $r = Lc(yr, vr);
                                return [0, $r, $0];
                              }
                            }, X = Dc(e0), s0 = 2 <= X ? R0(X, e0)[1] : e0, hr = function(or, W0) {
                              if (!(3 < or >>> 0))
                                switch (or) {
                                  case 0:
                                    return [0, 0, W0];
                                  case 1:
                                    if (W0)
                                      return [0, [0, W0[1]], W0[2]];
                                    break;
                                  case 2:
                                    if (W0) {
                                      var Lr = W0[2];
                                      if (Lr)
                                        return [0, [1, 2, Lr[1], [0, W0[1]], 0], Lr[2]];
                                    }
                                    break;
                                  default:
                                    if (W0) {
                                      var Tr = W0[2];
                                      if (Tr) {
                                        var Hr = Tr[2];
                                        if (Hr)
                                          return [0, [1, 2, Tr[1], [0, W0[1]], [0, Hr[1]]], Hr[2]];
                                      }
                                    }
                                }
                              var Or = or / 2 | 0, fr = hr(Or, W0), Rr = fr[2];
                              if (Rr) {
                                var Wr = hr((or - Or | 0) - 1 | 0, Rr[2]), Jr = Wr[2];
                                return [0, Ns(fr[1], Rr[1], Wr[1]), Jr];
                              }
                              throw [0, Sn, Kpr];
                            };
                            return hr(Dc(s0), s0)[1];
                          }
                          var Ar = n(E0, n(w0, n(t0, [0, l])));
                          return n(_0[1], Ar);
                        }
                        return n(E0, n(w0, n(t0, [0, l])));
                      }
                      return n(w0, n(t0, [0, l]));
                    }
                    return n(t0, [0, l]);
                  }
                  return [0, l];
                }
                return st;
              }
              return [0, st, rL, i4, n, Iee, x4, c, s2, y, T, E, d, w, G, k0, A11, S11, M, K, V, QD, er0, Pl, Z00, Q00, Aee, Pl, Z00, f0, m0, Oee, g0, function(e0, x0, l) {
                u(f4(x0), Xpr);
                var c0 = er0(l);
                c0 && u(f4(x0), Ypr);
                var t0 = 0;
                return le(function(o0, w0) {
                  return o0 && u(f4(x0), Hpr), o(e0, x0, w0), 1;
                }, t0, c0), c0 && u(f4(x0), Vpr), u(f4(x0), zpr);
              }, $D];
            }
            var nr0 = Wpr.slice();
            function nL(t4) {
              for (var n = 0, e4 = nr0.length - 1 - 1 | 0; ; ) {
                if (e4 < n)
                  return 0;
                var i4 = n + ((e4 - n | 0) / 2 | 0) | 0, x4 = nr0[1 + i4];
                if (t4 < x4[1]) {
                  var e4 = i4 - 1 | 0;
                  continue;
                }
                if (x4[2] <= t4) {
                  var n = i4 + 1 | 0;
                  continue;
                }
                return 1;
              }
            }
            var tr0 = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(tr0, function(t4, n) {
              if (typeof t4 == "number") {
                var e4 = t4;
                if (55 <= e4)
                  switch (e4) {
                    case 55:
                      if (typeof n == "number") {
                        var i4 = n !== 55 ? 1 : 0;
                        if (!i4)
                          return i4;
                      }
                      break;
                    case 56:
                      if (typeof n == "number") {
                        var x4 = n !== 56 ? 1 : 0;
                        if (!x4)
                          return x4;
                      }
                      break;
                    case 57:
                      if (typeof n == "number") {
                        var c = n !== 57 ? 1 : 0;
                        if (!c)
                          return c;
                      }
                      break;
                    case 58:
                      if (typeof n == "number") {
                        var s2 = n !== 58 ? 1 : 0;
                        if (!s2)
                          return s2;
                      }
                      break;
                    case 59:
                      if (typeof n == "number") {
                        var p = n !== 59 ? 1 : 0;
                        if (!p)
                          return p;
                      }
                      break;
                    case 60:
                      if (typeof n == "number") {
                        var y = n !== 60 ? 1 : 0;
                        if (!y)
                          return y;
                      }
                      break;
                    case 61:
                      if (typeof n == "number") {
                        var T = n !== 61 ? 1 : 0;
                        if (!T)
                          return T;
                      }
                      break;
                    case 62:
                      if (typeof n == "number") {
                        var E = n !== 62 ? 1 : 0;
                        if (!E)
                          return E;
                      }
                      break;
                    case 63:
                      if (typeof n == "number") {
                        var d = n !== 63 ? 1 : 0;
                        if (!d)
                          return d;
                      }
                      break;
                    case 64:
                      if (typeof n == "number") {
                        var w = n !== 64 ? 1 : 0;
                        if (!w)
                          return w;
                      }
                      break;
                    case 65:
                      if (typeof n == "number") {
                        var G = n !== 65 ? 1 : 0;
                        if (!G)
                          return G;
                      }
                      break;
                    case 66:
                      if (typeof n == "number") {
                        var A11 = n !== 66 ? 1 : 0;
                        if (!A11)
                          return A11;
                      }
                      break;
                    case 67:
                      if (typeof n == "number") {
                        var S11 = n !== 67 ? 1 : 0;
                        if (!S11)
                          return S11;
                      }
                      break;
                    case 68:
                      if (typeof n == "number") {
                        var M = n !== 68 ? 1 : 0;
                        if (!M)
                          return M;
                      }
                      break;
                    case 69:
                      if (typeof n == "number") {
                        var K = n !== 69 ? 1 : 0;
                        if (!K)
                          return K;
                      }
                      break;
                    case 70:
                      if (typeof n == "number") {
                        var V = n !== 70 ? 1 : 0;
                        if (!V)
                          return V;
                      }
                      break;
                    case 71:
                      if (typeof n == "number") {
                        var f0 = n !== 71 ? 1 : 0;
                        if (!f0)
                          return f0;
                      }
                      break;
                    case 72:
                      if (typeof n == "number") {
                        var m0 = n !== 72 ? 1 : 0;
                        if (!m0)
                          return m0;
                      }
                      break;
                    case 73:
                      if (typeof n == "number") {
                        var k0 = n !== 73 ? 1 : 0;
                        if (!k0)
                          return k0;
                      }
                      break;
                    case 74:
                      if (typeof n == "number") {
                        var g0 = n !== 74 ? 1 : 0;
                        if (!g0)
                          return g0;
                      }
                      break;
                    case 75:
                      if (typeof n == "number") {
                        var e0 = n !== 75 ? 1 : 0;
                        if (!e0)
                          return e0;
                      }
                      break;
                    case 76:
                      if (typeof n == "number") {
                        var x0 = n !== 76 ? 1 : 0;
                        if (!x0)
                          return x0;
                      }
                      break;
                    case 77:
                      if (typeof n == "number") {
                        var l = n !== 77 ? 1 : 0;
                        if (!l)
                          return l;
                      }
                      break;
                    case 78:
                      if (typeof n == "number") {
                        var c0 = n !== 78 ? 1 : 0;
                        if (!c0)
                          return c0;
                      }
                      break;
                    case 79:
                      if (typeof n == "number") {
                        var t0 = n !== 79 ? 1 : 0;
                        if (!t0)
                          return t0;
                      }
                      break;
                    case 80:
                      if (typeof n == "number") {
                        var o0 = n !== 80 ? 1 : 0;
                        if (!o0)
                          return o0;
                      }
                      break;
                    case 81:
                      if (typeof n == "number") {
                        var w0 = n !== 81 ? 1 : 0;
                        if (!w0)
                          return w0;
                      }
                      break;
                    case 82:
                      if (typeof n == "number") {
                        var _0 = n !== 82 ? 1 : 0;
                        if (!_0)
                          return _0;
                      }
                      break;
                    case 83:
                      if (typeof n == "number") {
                        var E0 = n !== 83 ? 1 : 0;
                        if (!E0)
                          return E0;
                      }
                      break;
                    case 84:
                      if (typeof n == "number") {
                        var U0 = n !== 84 ? 1 : 0;
                        if (!U0)
                          return U0;
                      }
                      break;
                    case 85:
                      if (typeof n == "number") {
                        var b = n !== 85 ? 1 : 0;
                        if (!b)
                          return b;
                      }
                      break;
                    case 86:
                      if (typeof n == "number") {
                        var R0 = n !== 86 ? 1 : 0;
                        if (!R0)
                          return R0;
                      }
                      break;
                    case 87:
                      if (typeof n == "number") {
                        var X = n !== 87 ? 1 : 0;
                        if (!X)
                          return X;
                      }
                      break;
                    case 88:
                      if (typeof n == "number") {
                        var s0 = n !== 88 ? 1 : 0;
                        if (!s0)
                          return s0;
                      }
                      break;
                    case 89:
                      if (typeof n == "number") {
                        var hr = n !== 89 ? 1 : 0;
                        if (!hr)
                          return hr;
                      }
                      break;
                    case 90:
                      if (typeof n == "number") {
                        var Ar = n !== 90 ? 1 : 0;
                        if (!Ar)
                          return Ar;
                      }
                      break;
                    case 91:
                      if (typeof n == "number") {
                        var or = n !== 91 ? 1 : 0;
                        if (!or)
                          return or;
                      }
                      break;
                    case 92:
                      if (typeof n == "number") {
                        var W0 = n !== 92 ? 1 : 0;
                        if (!W0)
                          return W0;
                      }
                      break;
                    case 93:
                      if (typeof n == "number") {
                        var Lr = n !== 93 ? 1 : 0;
                        if (!Lr)
                          return Lr;
                      }
                      break;
                    case 94:
                      if (typeof n == "number") {
                        var Tr = n !== 94 ? 1 : 0;
                        if (!Tr)
                          return Tr;
                      }
                      break;
                    case 95:
                      if (typeof n == "number") {
                        var Hr = n !== 95 ? 1 : 0;
                        if (!Hr)
                          return Hr;
                      }
                      break;
                    case 96:
                      if (typeof n == "number") {
                        var Or = n !== 96 ? 1 : 0;
                        if (!Or)
                          return Or;
                      }
                      break;
                    case 97:
                      if (typeof n == "number") {
                        var fr = n !== 97 ? 1 : 0;
                        if (!fr)
                          return fr;
                      }
                      break;
                    case 98:
                      if (typeof n == "number") {
                        var Rr = n !== 98 ? 1 : 0;
                        if (!Rr)
                          return Rr;
                      }
                      break;
                    case 99:
                      if (typeof n == "number") {
                        var Wr = n !== 99 ? 1 : 0;
                        if (!Wr)
                          return Wr;
                      }
                      break;
                    case 100:
                      if (typeof n == "number") {
                        var Jr = ti !== n ? 1 : 0;
                        if (!Jr)
                          return Jr;
                      }
                      break;
                    case 101:
                      if (typeof n == "number") {
                        var ar = R7 !== n ? 1 : 0;
                        if (!ar)
                          return ar;
                      }
                      break;
                    case 102:
                      if (typeof n == "number") {
                        var _r = Ri !== n ? 1 : 0;
                        if (!_r)
                          return _r;
                      }
                      break;
                    case 103:
                      if (typeof n == "number") {
                        var Ir = s7 !== n ? 1 : 0;
                        if (!Ir)
                          return Ir;
                      }
                      break;
                    case 104:
                      if (typeof n == "number") {
                        var fe = L7 !== n ? 1 : 0;
                        if (!fe)
                          return fe;
                      }
                      break;
                    case 105:
                      if (typeof n == "number") {
                        var v0 = j7 !== n ? 1 : 0;
                        if (!v0)
                          return v0;
                      }
                      break;
                    case 106:
                      if (typeof n == "number") {
                        var P = Yt !== n ? 1 : 0;
                        if (!P)
                          return P;
                      }
                      break;
                    case 107:
                      if (typeof n == "number") {
                        var L = Zc !== n ? 1 : 0;
                        if (!L)
                          return L;
                      }
                      break;
                    default:
                      if (typeof n == "number" && is <= n)
                        return 0;
                  }
                else
                  switch (e4) {
                    case 0:
                      if (typeof n == "number" && !n)
                        return n;
                      break;
                    case 1:
                      if (typeof n == "number") {
                        var Q = n !== 1 ? 1 : 0;
                        if (!Q)
                          return Q;
                      }
                      break;
                    case 2:
                      if (typeof n == "number") {
                        var i0 = n !== 2 ? 1 : 0;
                        if (!i0)
                          return i0;
                      }
                      break;
                    case 3:
                      if (typeof n == "number") {
                        var l0 = n !== 3 ? 1 : 0;
                        if (!l0)
                          return l0;
                      }
                      break;
                    case 4:
                      if (typeof n == "number") {
                        var S0 = n !== 4 ? 1 : 0;
                        if (!S0)
                          return S0;
                      }
                      break;
                    case 5:
                      if (typeof n == "number") {
                        var T0 = n !== 5 ? 1 : 0;
                        if (!T0)
                          return T0;
                      }
                      break;
                    case 6:
                      if (typeof n == "number") {
                        var rr = n !== 6 ? 1 : 0;
                        if (!rr)
                          return rr;
                      }
                      break;
                    case 7:
                      if (typeof n == "number") {
                        var L0 = n !== 7 ? 1 : 0;
                        if (!L0)
                          return L0;
                      }
                      break;
                    case 8:
                      if (typeof n == "number") {
                        var B = n !== 8 ? 1 : 0;
                        if (!B)
                          return B;
                      }
                      break;
                    case 9:
                      if (typeof n == "number") {
                        var Z7 = n !== 9 ? 1 : 0;
                        if (!Z7)
                          return Z7;
                      }
                      break;
                    case 10:
                      if (typeof n == "number") {
                        var p0 = n !== 10 ? 1 : 0;
                        if (!p0)
                          return p0;
                      }
                      break;
                    case 11:
                      if (typeof n == "number") {
                        var b0 = n !== 11 ? 1 : 0;
                        if (!b0)
                          return b0;
                      }
                      break;
                    case 12:
                      if (typeof n == "number") {
                        var O0 = n !== 12 ? 1 : 0;
                        if (!O0)
                          return O0;
                      }
                      break;
                    case 13:
                      if (typeof n == "number") {
                        var M0 = n !== 13 ? 1 : 0;
                        if (!M0)
                          return M0;
                      }
                      break;
                    case 14:
                      if (typeof n == "number") {
                        var er = n !== 14 ? 1 : 0;
                        if (!er)
                          return er;
                      }
                      break;
                    case 15:
                      if (typeof n == "number") {
                        var yr = n !== 15 ? 1 : 0;
                        if (!yr)
                          return yr;
                      }
                      break;
                    case 16:
                      if (typeof n == "number") {
                        var vr = n !== 16 ? 1 : 0;
                        if (!vr)
                          return vr;
                      }
                      break;
                    case 17:
                      if (typeof n == "number") {
                        var $0 = n !== 17 ? 1 : 0;
                        if (!$0)
                          return $0;
                      }
                      break;
                    case 18:
                      if (typeof n == "number") {
                        var Er = n !== 18 ? 1 : 0;
                        if (!Er)
                          return Er;
                      }
                      break;
                    case 19:
                      if (typeof n == "number") {
                        var Mr = n !== 19 ? 1 : 0;
                        if (!Mr)
                          return Mr;
                      }
                      break;
                    case 20:
                      if (typeof n == "number") {
                        var Br = n !== 20 ? 1 : 0;
                        if (!Br)
                          return Br;
                      }
                      break;
                    case 21:
                      if (typeof n == "number") {
                        var qr = n !== 21 ? 1 : 0;
                        if (!qr)
                          return qr;
                      }
                      break;
                    case 22:
                      if (typeof n == "number") {
                        var jr = n !== 22 ? 1 : 0;
                        if (!jr)
                          return jr;
                      }
                      break;
                    case 23:
                      if (typeof n == "number") {
                        var $r = n !== 23 ? 1 : 0;
                        if (!$r)
                          return $r;
                      }
                      break;
                    case 24:
                      if (typeof n == "number") {
                        var ne = n !== 24 ? 1 : 0;
                        if (!ne)
                          return ne;
                      }
                      break;
                    case 25:
                      if (typeof n == "number") {
                        var Qr = n !== 25 ? 1 : 0;
                        if (!Qr)
                          return Qr;
                      }
                      break;
                    case 26:
                      if (typeof n == "number") {
                        var be = n !== 26 ? 1 : 0;
                        if (!be)
                          return be;
                      }
                      break;
                    case 27:
                      if (typeof n == "number") {
                        var ae = n !== 27 ? 1 : 0;
                        if (!ae)
                          return ae;
                      }
                      break;
                    case 28:
                      if (typeof n == "number") {
                        var pe = n !== 28 ? 1 : 0;
                        if (!pe)
                          return pe;
                      }
                      break;
                    case 29:
                      if (typeof n == "number") {
                        var oe = n !== 29 ? 1 : 0;
                        if (!oe)
                          return oe;
                      }
                      break;
                    case 30:
                      if (typeof n == "number") {
                        var ce = n !== 30 ? 1 : 0;
                        if (!ce)
                          return ce;
                      }
                      break;
                    case 31:
                      if (typeof n == "number") {
                        var ge = n !== 31 ? 1 : 0;
                        if (!ge)
                          return ge;
                      }
                      break;
                    case 32:
                      if (typeof n == "number") {
                        var q0 = n !== 32 ? 1 : 0;
                        if (!q0)
                          return q0;
                      }
                      break;
                    case 33:
                      if (typeof n == "number") {
                        var Fr = n !== 33 ? 1 : 0;
                        if (!Fr)
                          return Fr;
                      }
                      break;
                    case 34:
                      if (typeof n == "number") {
                        var _ = n !== 34 ? 1 : 0;
                        if (!_)
                          return _;
                      }
                      break;
                    case 35:
                      if (typeof n == "number") {
                        var k = n !== 35 ? 1 : 0;
                        if (!k)
                          return k;
                      }
                      break;
                    case 36:
                      if (typeof n == "number") {
                        var I = n !== 36 ? 1 : 0;
                        if (!I)
                          return I;
                      }
                      break;
                    case 37:
                      if (typeof n == "number") {
                        var U = n !== 37 ? 1 : 0;
                        if (!U)
                          return U;
                      }
                      break;
                    case 38:
                      if (typeof n == "number") {
                        var Y = n !== 38 ? 1 : 0;
                        if (!Y)
                          return Y;
                      }
                      break;
                    case 39:
                      if (typeof n == "number") {
                        var y0 = n !== 39 ? 1 : 0;
                        if (!y0)
                          return y0;
                      }
                      break;
                    case 40:
                      if (typeof n == "number") {
                        var P0 = n !== 40 ? 1 : 0;
                        if (!P0)
                          return P0;
                      }
                      break;
                    case 41:
                      if (typeof n == "number") {
                        var I0 = n !== 41 ? 1 : 0;
                        if (!I0)
                          return I0;
                      }
                      break;
                    case 42:
                      if (typeof n == "number") {
                        var D = n !== 42 ? 1 : 0;
                        if (!D)
                          return D;
                      }
                      break;
                    case 43:
                      if (typeof n == "number") {
                        var u0 = n !== 43 ? 1 : 0;
                        if (!u0)
                          return u0;
                      }
                      break;
                    case 44:
                      if (typeof n == "number") {
                        var X0 = n !== 44 ? 1 : 0;
                        if (!X0)
                          return X0;
                      }
                      break;
                    case 45:
                      if (typeof n == "number") {
                        var J0 = n !== 45 ? 1 : 0;
                        if (!J0)
                          return J0;
                      }
                      break;
                    case 46:
                      if (typeof n == "number") {
                        var ir = n !== 46 ? 1 : 0;
                        if (!ir)
                          return ir;
                      }
                      break;
                    case 47:
                      if (typeof n == "number") {
                        var Q0 = n !== 47 ? 1 : 0;
                        if (!Q0)
                          return Q0;
                      }
                      break;
                    case 48:
                      if (typeof n == "number") {
                        var F0 = n !== 48 ? 1 : 0;
                        if (!F0)
                          return F0;
                      }
                      break;
                    case 49:
                      if (typeof n == "number") {
                        var Sr = n !== 49 ? 1 : 0;
                        if (!Sr)
                          return Sr;
                      }
                      break;
                    case 50:
                      if (typeof n == "number") {
                        var mr = n !== 50 ? 1 : 0;
                        if (!mr)
                          return mr;
                      }
                      break;
                    case 51:
                      if (typeof n == "number") {
                        var Cr = n !== 51 ? 1 : 0;
                        if (!Cr)
                          return Cr;
                      }
                      break;
                    case 52:
                      if (typeof n == "number") {
                        var sr = n !== 52 ? 1 : 0;
                        if (!sr)
                          return sr;
                      }
                      break;
                    case 53:
                      if (typeof n == "number") {
                        var Pr = n !== 53 ? 1 : 0;
                        if (!Pr)
                          return Pr;
                      }
                      break;
                    default:
                      if (typeof n == "number") {
                        var K0 = n !== 54 ? 1 : 0;
                        if (!K0)
                          return K0;
                      }
                  }
              } else
                switch (t4[0]) {
                  case 0:
                    if (typeof n != "number" && n[0] === 0) {
                      var Ur = Ee(t4[1], n[1]);
                      return Ur === 0 ? Ee(t4[2], n[2]) : Ur;
                    }
                    break;
                  case 1:
                    if (typeof n != "number" && n[0] === 1) {
                      var h0 = Ee(t4[1], n[1]);
                      return h0 === 0 ? Ee(t4[2], n[2]) : h0;
                    }
                    break;
                  case 2:
                    if (typeof n != "number" && n[0] === 2)
                      return Ee(t4[1], n[1]);
                    break;
                  case 3:
                    if (typeof n != "number" && n[0] === 3) {
                      var Kr = n[2], re = t4[2], xe = Ee(t4[1], n[1]);
                      if (xe === 0) {
                        if (re)
                          return Kr ? Ee(re[1], Kr[1]) : 1;
                        var Re = Kr && -1;
                        return Re;
                      }
                      return xe;
                    }
                    break;
                  case 4:
                    if (typeof n != "number" && n[0] === 4)
                      return Ee(t4[1], n[1]);
                    break;
                  case 5:
                    if (typeof n != "number" && n[0] === 5) {
                      var ve = n[2], Ie = t4[2], Ge = Ee(t4[1], n[1]);
                      if (Ge === 0) {
                        if (Ie)
                          if (ve) {
                            var Me = ve[1], an = Ie[1], We = 0;
                            switch (an) {
                              case 0:
                                if (Me)
                                  We = 1;
                                else
                                  var vn = Me;
                                break;
                              case 1:
                                var Ae = Me !== 1 ? 1 : 0;
                                if (Ae)
                                  We = 1;
                                else
                                  var vn = Ae;
                                break;
                              case 2:
                                var cn = Me !== 2 ? 1 : 0;
                                if (cn)
                                  We = 1;
                                else
                                  var vn = cn;
                                break;
                              default:
                                if (3 <= Me)
                                  var vn = 0;
                                else
                                  We = 1;
                            }
                            if (We)
                              var rn = function(Ct) {
                                switch (Ct) {
                                  case 0:
                                    return 0;
                                  case 1:
                                    return 1;
                                  case 2:
                                    return 2;
                                  default:
                                    return 3;
                                }
                              }, kn = rn(Me), vn = Ac(rn(an), kn);
                            var Ne = vn;
                          } else
                            var Ne = 1;
                        else
                          var Ne = ve && -1;
                        return Ne === 0 ? Ee(t4[3], n[3]) : Ne;
                      }
                      return Ge;
                    }
                    break;
                  case 6:
                    if (typeof n != "number" && n[0] === 6) {
                      var Je = Ee(t4[1], n[1]);
                      return Je === 0 ? Ee(t4[2], n[2]) : Je;
                    }
                    break;
                  case 7:
                    if (typeof n != "number" && n[0] === 7)
                      return Ac(t4[1], n[1]);
                    break;
                  case 8:
                    if (typeof n != "number" && n[0] === 8) {
                      var en = Ee(t4[1], n[1]);
                      return en === 0 ? Ee(t4[2], n[2]) : en;
                    }
                    break;
                  case 9:
                    if (typeof n != "number" && n[0] === 9)
                      return Ee(t4[1], n[1]);
                    break;
                  case 10:
                    if (typeof n != "number" && n[0] === 10)
                      return Ee(t4[1], n[1]);
                    break;
                  case 11:
                    if (typeof n != "number" && n[0] === 11) {
                      var _n = Ee(t4[1], n[1]);
                      return _n === 0 ? Ee(t4[2], n[2]) : _n;
                    }
                    break;
                  case 12:
                    if (typeof n != "number" && n[0] === 12) {
                      var Cn = Ee(t4[1], n[1]);
                      return Cn === 0 ? Ee(t4[2], n[2]) : Cn;
                    }
                    break;
                  case 13:
                    if (typeof n != "number" && n[0] === 13)
                      return Ee(t4[1], n[1]);
                    break;
                  case 14:
                    if (typeof n != "number" && n[0] === 14)
                      return Ac(t4[1], n[1]);
                    break;
                  case 15:
                    if (typeof n != "number" && n[0] === 15)
                      return Ee(t4[1], n[1]);
                    break;
                  case 16:
                    if (typeof n != "number" && n[0] === 16) {
                      var Hn = Ee(t4[1], n[1]);
                      return Hn === 0 ? Ee(t4[2], n[2]) : Hn;
                    }
                    break;
                  case 17:
                    if (typeof n != "number" && n[0] === 17)
                      return Ee(t4[1], n[1]);
                    break;
                  case 18:
                    if (typeof n != "number" && n[0] === 18)
                      return Ac(t4[1], n[1]);
                    break;
                  case 19:
                    if (typeof n != "number" && n[0] === 19)
                      return Ee(t4[1], n[1]);
                    break;
                  case 20:
                    if (typeof n != "number" && n[0] === 20)
                      return Ee(t4[1], n[1]);
                    break;
                  case 21:
                    if (typeof n != "number" && n[0] === 21) {
                      var Fn = Ee(t4[1], n[1]);
                      if (Fn === 0) {
                        var vt = Ac(t4[2], n[2]);
                        if (vt === 0) {
                          var Nt = Ac(t4[3], n[3]);
                          return Nt === 0 ? Ac(t4[4], n[4]) : Nt;
                        }
                        return vt;
                      }
                      return Fn;
                    }
                    break;
                  case 22:
                    if (typeof n != "number" && n[0] === 22)
                      return Ee(t4[1], n[1]);
                    break;
                  default:
                    if (typeof n != "number" && n[0] === 23)
                      return Ee(t4[1], n[1]);
                }
              function gt(qt) {
                if (typeof qt == "number") {
                  var Ft = qt;
                  if (55 <= Ft)
                    switch (Ft) {
                      case 55:
                        return 72;
                      case 56:
                        return 73;
                      case 57:
                        return 74;
                      case 58:
                        return 76;
                      case 59:
                        return 77;
                      case 60:
                        return 78;
                      case 61:
                        return 80;
                      case 62:
                        return 81;
                      case 63:
                        return 82;
                      case 64:
                        return 83;
                      case 65:
                        return 84;
                      case 66:
                        return 85;
                      case 67:
                        return 86;
                      case 68:
                        return 87;
                      case 69:
                        return 88;
                      case 70:
                        return 89;
                      case 71:
                        return 90;
                      case 72:
                        return 91;
                      case 73:
                        return 92;
                      case 74:
                        return 93;
                      case 75:
                        return 94;
                      case 76:
                        return 96;
                      case 77:
                        return 97;
                      case 78:
                        return 98;
                      case 79:
                        return 99;
                      case 80:
                        return ti;
                      case 81:
                        return R7;
                      case 82:
                        return Ri;
                      case 83:
                        return s7;
                      case 84:
                        return L7;
                      case 85:
                        return j7;
                      case 86:
                        return Yt;
                      case 87:
                        return Zc;
                      case 88:
                        return Xt;
                      case 89:
                        return T7;
                      case 90:
                        return Pn;
                      case 91:
                        return t1;
                      case 92:
                        return Av;
                      case 93:
                        return f1;
                      case 94:
                        return A2;
                      case 95:
                        return z2;
                      case 96:
                        return Sv;
                      case 97:
                        return uc;
                      case 98:
                        return tl;
                      case 99:
                        return In;
                      case 100:
                        return ts;
                      case 101:
                        return br;
                      case 102:
                        return IX;
                      case 103:
                        return zn;
                      case 104:
                        return jt;
                      case 105:
                        return JY;
                      case 106:
                        return zw;
                      case 107:
                        return Jg;
                      default:
                        return BH;
                    }
                  switch (Ft) {
                    case 0:
                      return 4;
                    case 1:
                      return 8;
                    case 2:
                      return 15;
                    case 3:
                      return 16;
                    case 4:
                      return 17;
                    case 5:
                      return 18;
                    case 6:
                      return 19;
                    case 7:
                      return 20;
                    case 8:
                      return 21;
                    case 9:
                      return 22;
                    case 10:
                      return 23;
                    case 11:
                      return 24;
                    case 12:
                      return 25;
                    case 13:
                      return 26;
                    case 14:
                      return 27;
                    case 15:
                      return 28;
                    case 16:
                      return 29;
                    case 17:
                      return 30;
                    case 18:
                      return 31;
                    case 19:
                      return 32;
                    case 20:
                      return 33;
                    case 21:
                      return 34;
                    case 22:
                      return 35;
                    case 23:
                      return 36;
                    case 24:
                      return 37;
                    case 25:
                      return 39;
                    case 26:
                      return 40;
                    case 27:
                      return 41;
                    case 28:
                      return 42;
                    case 29:
                      return 43;
                    case 30:
                      return 45;
                    case 31:
                      return 46;
                    case 32:
                      return 47;
                    case 33:
                      return 48;
                    case 34:
                      return 51;
                    case 35:
                      return 52;
                    case 36:
                      return 53;
                    case 37:
                      return 54;
                    case 38:
                      return 55;
                    case 39:
                      return 56;
                    case 40:
                      return 57;
                    case 41:
                      return 58;
                    case 42:
                      return 59;
                    case 43:
                      return 60;
                    case 44:
                      return 61;
                    case 45:
                      return 62;
                    case 46:
                      return 63;
                    case 47:
                      return 64;
                    case 48:
                      return 65;
                    case 49:
                      return 66;
                    case 50:
                      return 67;
                    case 51:
                      return 68;
                    case 52:
                      return 69;
                    case 53:
                      return 70;
                    default:
                      return 71;
                  }
                } else
                  switch (qt[0]) {
                    case 0:
                      return 0;
                    case 1:
                      return 1;
                    case 2:
                      return 2;
                    case 3:
                      return 3;
                    case 4:
                      return 5;
                    case 5:
                      return 6;
                    case 6:
                      return 7;
                    case 7:
                      return 9;
                    case 8:
                      return 10;
                    case 9:
                      return 11;
                    case 10:
                      return 12;
                    case 11:
                      return 13;
                    case 12:
                      return 14;
                    case 13:
                      return 38;
                    case 14:
                      return 44;
                    case 15:
                      return 49;
                    case 16:
                      return 50;
                    case 17:
                      return 75;
                    case 18:
                      return 79;
                    case 19:
                      return 95;
                    case 20:
                      return is;
                    case 21:
                      return Fv;
                    case 22:
                      return cf;
                    default:
                      return X2;
                  }
              }
              var Zt = gt(n);
              return Ac(gt(t4), Zt);
            });
            var Nee = [wt, Q9r, M7(0)];
            M7(0);
            var I1 = [wt, e_r, M7(0)], ur0 = 0, ir0 = 0, fr0 = 0, xr0 = 0, or0 = 0, ar0 = 0, cr0 = 0, sr0 = 0, vr0 = 0, lr0 = 0;
            function j(t4) {
              if (t4[3] === t4[2])
                return -1;
              var n = t4[1][1 + t4[3]];
              return t4[3] = t4[3] + 1 | 0, n === 10 && (t4[5] !== 0 && (t4[5] = t4[5] + 1 | 0), t4[4] = t4[3]), n;
            }
            function G0(t4, n) {
              return t4[9] = t4[3], t4[10] = t4[4], t4[11] = t4[5], t4[12] = n, 0;
            }
            function gn(t4) {
              return t4[6] = t4[3], t4[7] = t4[4], t4[8] = t4[5], G0(t4, -1);
            }
            function q(t4) {
              return t4[3] = t4[9], t4[4] = t4[10], t4[5] = t4[11], t4[12];
            }
            function $v(t4) {
              return t4[3] = t4[6], t4[4] = t4[7], t4[5] = t4[8], 0;
            }
            function tL(t4, n) {
              return t4[6] = n, 0;
            }
            function Jm(t4) {
              return t4[3] - t4[6] | 0;
            }
            function Ll(t4) {
              var n = t4[3] - t4[6] | 0, e4 = t4[6], i4 = t4[1];
              return 0 <= e4 && 0 <= n && !((i4.length - 1 - n | 0) < e4) ? Ju0(i4, e4, n) : Pu(ki0);
            }
            function br0(t4) {
              var n = t4[6];
              return tu(t4[1], n)[1 + n];
            }
            function Rl(t4, n, e4, i4) {
              for (var x4 = 0, c = e4, s2 = n; ; ) {
                if (0 < c) {
                  var p = t4[1 + s2];
                  if (0 <= p) {
                    if (zn < p)
                      if (nX < p)
                        if (U8 < p) {
                          if (lI < p)
                            throw I1;
                          Jn(i4, x4, s1 | p >>> 18 | 0), Jn(i4, x4 + 1 | 0, jt | (p >>> 12 | 0) & 63), Jn(i4, x4 + 2 | 0, jt | (p >>> 6 | 0) & 63), Jn(i4, x4 + 3 | 0, jt | p & 63);
                          var y = x4 + 4 | 0;
                        } else {
                          Jn(i4, x4, hv | p >>> 12 | 0), Jn(i4, x4 + 1 | 0, jt | (p >>> 6 | 0) & 63), Jn(i4, x4 + 2 | 0, jt | p & 63);
                          var y = x4 + 3 | 0;
                        }
                      else {
                        Jn(i4, x4, rt | p >>> 6 | 0), Jn(i4, x4 + 1 | 0, jt | p & 63);
                        var y = x4 + 2 | 0;
                      }
                    else {
                      Jn(i4, x4, p);
                      var y = x4 + 1 | 0;
                    }
                    var x4 = y, c = c - 1 | 0, s2 = s2 + 1 | 0;
                    continue;
                  }
                  throw I1;
                }
                return x4;
              }
            }
            function pr0(t4) {
              for (var n = un(t4), e4 = Gv(n, 0), i4 = 0, x4 = 0; ; ) {
                if (x4 < n) {
                  var c = Vr(t4, x4), s2 = 0;
                  if (rt <= c)
                    if (s1 <= c)
                      if (wt <= c)
                        s2 = 1;
                      else {
                        var p = Vr(t4, x4 + 1 | 0), y = Vr(t4, x4 + 2 | 0), T = Vr(t4, x4 + 3 | 0), E = (p >>> 6 | 0) !== 2 ? 1 : 0;
                        if (E)
                          var w = E;
                        else
                          var d = (y >>> 6 | 0) !== 2 ? 1 : 0, w = d || ((T >>> 6 | 0) !== 2 ? 1 : 0);
                        if (w)
                          throw I1;
                        e4[1 + i4] = (c & 7) << 18 | (p & 63) << 12 | (y & 63) << 6 | T & 63;
                        var G = x4 + 4 | 0;
                      }
                    else if (hv <= c) {
                      var A11 = Vr(t4, x4 + 1 | 0), S11 = Vr(t4, x4 + 2 | 0), M = (c & 15) << 12 | (A11 & 63) << 6 | S11 & 63, K = (A11 >>> 6 | 0) !== 2 ? 1 : 0, V = K || ((S11 >>> 6 | 0) !== 2 ? 1 : 0);
                      if (V)
                        var m0 = V;
                      else
                        var f0 = 55296 <= M ? 1 : 0, m0 = f0 && (M <= 57088 ? 1 : 0);
                      if (m0)
                        throw I1;
                      e4[1 + i4] = M;
                      var G = x4 + 3 | 0;
                    } else {
                      var k0 = Vr(t4, x4 + 1 | 0);
                      if ((k0 >>> 6 | 0) !== 2)
                        throw I1;
                      e4[1 + i4] = (c & 31) << 6 | k0 & 63;
                      var G = x4 + 2 | 0;
                    }
                  else if (jt <= c)
                    s2 = 1;
                  else {
                    e4[1 + i4] = c;
                    var G = x4 + 1 | 0;
                  }
                  if (s2)
                    throw I1;
                  var i4 = i4 + 1 | 0, x4 = G;
                  continue;
                }
                return [0, e4, i4, lr0, vr0, sr0, cr0, ar0, or0, xr0, fr0, ir0, ur0];
              }
            }
            function jl(t4, n, e4) {
              var i4 = t4[6] + n | 0, x4 = Lt(e4 * 4 | 0), c = t4[1];
              if ((i4 + e4 | 0) <= c.length - 1)
                return qv(x4, 0, Rl(c, i4, e4, x4));
              throw [0, Sn, r_r];
            }
            function Se(t4) {
              var n = t4[6], e4 = t4[3] - n | 0, i4 = Lt(e4 * 4 | 0);
              return qv(i4, 0, Rl(t4[1], n, e4, i4));
            }
            function Gl(t4, n) {
              var e4 = t4[6], i4 = t4[3] - e4 | 0, x4 = Lt(i4 * 4 | 0);
              return sN(n, x4, 0, Rl(t4[1], e4, i4, x4));
            }
            function uL(t4) {
              var n = t4.length - 1, e4 = Lt(n * 4 | 0);
              return qv(e4, 0, Rl(t4, 0, n, e4));
            }
            function mr0(t4, n) {
              return t4[3] = t4[3] - n | 0, 0;
            }
            var _r0 = 0;
            function Cee(t4, n, e4) {
              return [0, t4, n, n_r, 0, e4, _r0, t_r];
            }
            function yr0(t4) {
              var n = t4[2];
              return [0, t4[1], [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12]], t4[3], t4[4], t4[5], t4[6], t4[7]];
            }
            function hr0(t4) {
              return t4[3][1];
            }
            function $m(t4, n) {
              return t4 !== n[4] ? [0, n[1], n[2], n[3], t4, n[5], n[6], n[7]] : n;
            }
            var iL = function t4(n, e4) {
              return t4.fun(n, e4);
            }, dr0 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, fL = function t4(n, e4) {
              return t4.fun(n, e4);
            }, xL = function t4(n, e4) {
              return t4.fun(n, e4);
            }, kr0 = function t4(n, e4) {
              return t4.fun(n, e4);
            };
            N(iL, function(t4, n) {
              if (typeof t4 == "number") {
                var e4 = t4;
                if (61 <= e4)
                  if (92 <= e4)
                    switch (e4) {
                      case 92:
                        if (typeof n == "number" && n === 92)
                          return 1;
                        break;
                      case 93:
                        if (typeof n == "number" && n === 93)
                          return 1;
                        break;
                      case 94:
                        if (typeof n == "number" && n === 94)
                          return 1;
                        break;
                      case 95:
                        if (typeof n == "number" && n === 95)
                          return 1;
                        break;
                      case 96:
                        if (typeof n == "number" && n === 96)
                          return 1;
                        break;
                      case 97:
                        if (typeof n == "number" && n === 97)
                          return 1;
                        break;
                      case 98:
                        if (typeof n == "number" && n === 98)
                          return 1;
                        break;
                      case 99:
                        if (typeof n == "number" && n === 99)
                          return 1;
                        break;
                      case 100:
                        if (typeof n == "number" && ti === n)
                          return 1;
                        break;
                      case 101:
                        if (typeof n == "number" && R7 === n)
                          return 1;
                        break;
                      case 102:
                        if (typeof n == "number" && Ri === n)
                          return 1;
                        break;
                      case 103:
                        if (typeof n == "number" && s7 === n)
                          return 1;
                        break;
                      case 104:
                        if (typeof n == "number" && L7 === n)
                          return 1;
                        break;
                      case 105:
                        if (typeof n == "number" && j7 === n)
                          return 1;
                        break;
                      case 106:
                        if (typeof n == "number" && Yt === n)
                          return 1;
                        break;
                      case 107:
                        if (typeof n == "number" && Zc === n)
                          return 1;
                        break;
                      case 108:
                        if (typeof n == "number" && is === n)
                          return 1;
                        break;
                      case 109:
                        if (typeof n == "number" && Fv === n)
                          return 1;
                        break;
                      case 110:
                        if (typeof n == "number" && Xt === n)
                          return 1;
                        break;
                      case 111:
                        if (typeof n == "number" && cf === n)
                          return 1;
                        break;
                      case 112:
                        if (typeof n == "number" && T7 === n)
                          return 1;
                        break;
                      case 113:
                        if (typeof n == "number" && Pn === n)
                          return 1;
                        break;
                      case 114:
                        if (typeof n == "number" && t1 === n)
                          return 1;
                        break;
                      case 115:
                        if (typeof n == "number" && Av === n)
                          return 1;
                        break;
                      case 116:
                        if (typeof n == "number" && f1 === n)
                          return 1;
                        break;
                      case 117:
                        if (typeof n == "number" && A2 === n)
                          return 1;
                        break;
                      case 118:
                        if (typeof n == "number" && z2 === n)
                          return 1;
                        break;
                      case 119:
                        if (typeof n == "number" && Sv === n)
                          return 1;
                        break;
                      case 120:
                        if (typeof n == "number" && uc === n)
                          return 1;
                        break;
                      default:
                        if (typeof n == "number" && tl <= n)
                          return 1;
                    }
                  else
                    switch (e4) {
                      case 61:
                        if (typeof n == "number" && n === 61)
                          return 1;
                        break;
                      case 62:
                        if (typeof n == "number" && n === 62)
                          return 1;
                        break;
                      case 63:
                        if (typeof n == "number" && n === 63)
                          return 1;
                        break;
                      case 64:
                        if (typeof n == "number" && n === 64)
                          return 1;
                        break;
                      case 65:
                        if (typeof n == "number" && n === 65)
                          return 1;
                        break;
                      case 66:
                        if (typeof n == "number" && n === 66)
                          return 1;
                        break;
                      case 67:
                        if (typeof n == "number" && n === 67)
                          return 1;
                        break;
                      case 68:
                        if (typeof n == "number" && n === 68)
                          return 1;
                        break;
                      case 69:
                        if (typeof n == "number" && n === 69)
                          return 1;
                        break;
                      case 70:
                        if (typeof n == "number" && n === 70)
                          return 1;
                        break;
                      case 71:
                        if (typeof n == "number" && n === 71)
                          return 1;
                        break;
                      case 72:
                        if (typeof n == "number" && n === 72)
                          return 1;
                        break;
                      case 73:
                        if (typeof n == "number" && n === 73)
                          return 1;
                        break;
                      case 74:
                        if (typeof n == "number" && n === 74)
                          return 1;
                        break;
                      case 75:
                        if (typeof n == "number" && n === 75)
                          return 1;
                        break;
                      case 76:
                        if (typeof n == "number" && n === 76)
                          return 1;
                        break;
                      case 77:
                        if (typeof n == "number" && n === 77)
                          return 1;
                        break;
                      case 78:
                        if (typeof n == "number" && n === 78)
                          return 1;
                        break;
                      case 79:
                        if (typeof n == "number" && n === 79)
                          return 1;
                        break;
                      case 80:
                        if (typeof n == "number" && n === 80)
                          return 1;
                        break;
                      case 81:
                        if (typeof n == "number" && n === 81)
                          return 1;
                        break;
                      case 82:
                        if (typeof n == "number" && n === 82)
                          return 1;
                        break;
                      case 83:
                        if (typeof n == "number" && n === 83)
                          return 1;
                        break;
                      case 84:
                        if (typeof n == "number" && n === 84)
                          return 1;
                        break;
                      case 85:
                        if (typeof n == "number" && n === 85)
                          return 1;
                        break;
                      case 86:
                        if (typeof n == "number" && n === 86)
                          return 1;
                        break;
                      case 87:
                        if (typeof n == "number" && n === 87)
                          return 1;
                        break;
                      case 88:
                        if (typeof n == "number" && n === 88)
                          return 1;
                        break;
                      case 89:
                        if (typeof n == "number" && n === 89)
                          return 1;
                        break;
                      case 90:
                        if (typeof n == "number" && n === 90)
                          return 1;
                        break;
                      default:
                        if (typeof n == "number" && n === 91)
                          return 1;
                    }
                else if (31 <= e4)
                  switch (e4) {
                    case 31:
                      if (typeof n == "number" && n === 31)
                        return 1;
                      break;
                    case 32:
                      if (typeof n == "number" && n === 32)
                        return 1;
                      break;
                    case 33:
                      if (typeof n == "number" && n === 33)
                        return 1;
                      break;
                    case 34:
                      if (typeof n == "number" && n === 34)
                        return 1;
                      break;
                    case 35:
                      if (typeof n == "number" && n === 35)
                        return 1;
                      break;
                    case 36:
                      if (typeof n == "number" && n === 36)
                        return 1;
                      break;
                    case 37:
                      if (typeof n == "number" && n === 37)
                        return 1;
                      break;
                    case 38:
                      if (typeof n == "number" && n === 38)
                        return 1;
                      break;
                    case 39:
                      if (typeof n == "number" && n === 39)
                        return 1;
                      break;
                    case 40:
                      if (typeof n == "number" && n === 40)
                        return 1;
                      break;
                    case 41:
                      if (typeof n == "number" && n === 41)
                        return 1;
                      break;
                    case 42:
                      if (typeof n == "number" && n === 42)
                        return 1;
                      break;
                    case 43:
                      if (typeof n == "number" && n === 43)
                        return 1;
                      break;
                    case 44:
                      if (typeof n == "number" && n === 44)
                        return 1;
                      break;
                    case 45:
                      if (typeof n == "number" && n === 45)
                        return 1;
                      break;
                    case 46:
                      if (typeof n == "number" && n === 46)
                        return 1;
                      break;
                    case 47:
                      if (typeof n == "number" && n === 47)
                        return 1;
                      break;
                    case 48:
                      if (typeof n == "number" && n === 48)
                        return 1;
                      break;
                    case 49:
                      if (typeof n == "number" && n === 49)
                        return 1;
                      break;
                    case 50:
                      if (typeof n == "number" && n === 50)
                        return 1;
                      break;
                    case 51:
                      if (typeof n == "number" && n === 51)
                        return 1;
                      break;
                    case 52:
                      if (typeof n == "number" && n === 52)
                        return 1;
                      break;
                    case 53:
                      if (typeof n == "number" && n === 53)
                        return 1;
                      break;
                    case 54:
                      if (typeof n == "number" && n === 54)
                        return 1;
                      break;
                    case 55:
                      if (typeof n == "number" && n === 55)
                        return 1;
                      break;
                    case 56:
                      if (typeof n == "number" && n === 56)
                        return 1;
                      break;
                    case 57:
                      if (typeof n == "number" && n === 57)
                        return 1;
                      break;
                    case 58:
                      if (typeof n == "number" && n === 58)
                        return 1;
                      break;
                    case 59:
                      if (typeof n == "number" && n === 59)
                        return 1;
                      break;
                    default:
                      if (typeof n == "number" && n === 60)
                        return 1;
                  }
                else
                  switch (e4) {
                    case 0:
                      if (typeof n == "number" && !n)
                        return 1;
                      break;
                    case 1:
                      if (typeof n == "number" && n === 1)
                        return 1;
                      break;
                    case 2:
                      if (typeof n == "number" && n === 2)
                        return 1;
                      break;
                    case 3:
                      if (typeof n == "number" && n === 3)
                        return 1;
                      break;
                    case 4:
                      if (typeof n == "number" && n === 4)
                        return 1;
                      break;
                    case 5:
                      if (typeof n == "number" && n === 5)
                        return 1;
                      break;
                    case 6:
                      if (typeof n == "number" && n === 6)
                        return 1;
                      break;
                    case 7:
                      if (typeof n == "number" && n === 7)
                        return 1;
                      break;
                    case 8:
                      if (typeof n == "number" && n === 8)
                        return 1;
                      break;
                    case 9:
                      if (typeof n == "number" && n === 9)
                        return 1;
                      break;
                    case 10:
                      if (typeof n == "number" && n === 10)
                        return 1;
                      break;
                    case 11:
                      if (typeof n == "number" && n === 11)
                        return 1;
                      break;
                    case 12:
                      if (typeof n == "number" && n === 12)
                        return 1;
                      break;
                    case 13:
                      if (typeof n == "number" && n === 13)
                        return 1;
                      break;
                    case 14:
                      if (typeof n == "number" && n === 14)
                        return 1;
                      break;
                    case 15:
                      if (typeof n == "number" && n === 15)
                        return 1;
                      break;
                    case 16:
                      if (typeof n == "number" && n === 16)
                        return 1;
                      break;
                    case 17:
                      if (typeof n == "number" && n === 17)
                        return 1;
                      break;
                    case 18:
                      if (typeof n == "number" && n === 18)
                        return 1;
                      break;
                    case 19:
                      if (typeof n == "number" && n === 19)
                        return 1;
                      break;
                    case 20:
                      if (typeof n == "number" && n === 20)
                        return 1;
                      break;
                    case 21:
                      if (typeof n == "number" && n === 21)
                        return 1;
                      break;
                    case 22:
                      if (typeof n == "number" && n === 22)
                        return 1;
                      break;
                    case 23:
                      if (typeof n == "number" && n === 23)
                        return 1;
                      break;
                    case 24:
                      if (typeof n == "number" && n === 24)
                        return 1;
                      break;
                    case 25:
                      if (typeof n == "number" && n === 25)
                        return 1;
                      break;
                    case 26:
                      if (typeof n == "number" && n === 26)
                        return 1;
                      break;
                    case 27:
                      if (typeof n == "number" && n === 27)
                        return 1;
                      break;
                    case 28:
                      if (typeof n == "number" && n === 28)
                        return 1;
                      break;
                    case 29:
                      if (typeof n == "number" && n === 29)
                        return 1;
                      break;
                    default:
                      if (typeof n == "number" && n === 30)
                        return 1;
                  }
              } else
                switch (t4[0]) {
                  case 0:
                    if (typeof n != "number" && n[0] === 0) {
                      var i4 = n[1], x4 = u(u(fL, t4[1]), i4), c = x4 && qn(t4[2], n[2]);
                      return c;
                    }
                    break;
                  case 1:
                    if (typeof n != "number" && n[0] === 1) {
                      var s2 = n[1], p = u(u(xL, t4[1]), s2), y = p && qn(t4[2], n[2]);
                      return y;
                    }
                    break;
                  case 2:
                    if (typeof n != "number" && n[0] === 2) {
                      var T = n[1], E = t4[1], d = Wv(E[1], T[1]), w = d && qn(E[2], T[2]), G = w && qn(E[3], T[3]), A11 = G && (E[4] === T[4] ? 1 : 0);
                      return A11;
                    }
                    break;
                  case 3:
                    if (typeof n != "number" && n[0] === 3) {
                      var S11 = n[1], M = t4[1], K = Wv(M[1], S11[1]);
                      if (K)
                        var V = S11[2], f0 = u(u(kr0, M[2]), V);
                      else
                        var f0 = K;
                      var m0 = f0 && (M[3] === S11[3] ? 1 : 0);
                      return m0;
                    }
                    break;
                  case 4:
                    if (typeof n != "number" && n[0] === 4) {
                      var k0 = Wv(t4[1], n[1]), g0 = k0 && qn(t4[2], n[2]), e0 = g0 && qn(t4[3], n[3]);
                      return e0;
                    }
                    break;
                  case 5:
                    if (typeof n != "number" && n[0] === 5) {
                      var x0 = Wv(t4[1], n[1]), l = x0 && qn(t4[2], n[2]), c0 = l && qn(t4[3], n[3]);
                      return c0;
                    }
                    break;
                  case 6:
                    if (typeof n != "number" && n[0] === 6)
                      return qn(t4[1], n[1]);
                    break;
                  case 7:
                    if (typeof n != "number" && n[0] === 7) {
                      var t0 = qn(t4[1], n[1]);
                      return t0 && Wv(t4[2], n[2]);
                    }
                    break;
                  case 8:
                    if (typeof n != "number" && n[0] === 8) {
                      var o0 = Wv(t4[1], n[1]), w0 = o0 && qn(t4[2], n[2]), _0 = w0 && qn(t4[3], n[3]);
                      return _0;
                    }
                    break;
                  case 9:
                    if (typeof n != "number" && n[0] === 9) {
                      var E0 = n[1];
                      return u(u(dr0, t4[1]), E0);
                    }
                    break;
                  case 10:
                    if (typeof n != "number" && n[0] === 10) {
                      var U0 = n[1], b = u(u(fL, t4[1]), U0), R0 = b && (t4[2] == n[2] ? 1 : 0), X = R0 && qn(t4[3], n[3]);
                      return X;
                    }
                    break;
                  default:
                    if (typeof n != "number" && n[0] === 11) {
                      var s0 = n[1], hr = u(u(xL, t4[1]), s0), Ar = hr && (t4[2] == n[2] ? 1 : 0), or = Ar && qn(t4[3], n[3]);
                      return or;
                    }
                }
              return 0;
            }), N(dr0, function(t4, n) {
              if (t4) {
                if (n)
                  return 1;
              } else if (!n)
                return 1;
              return 0;
            }), N(fL, function(t4, n) {
              switch (t4) {
                case 0:
                  if (!n)
                    return 1;
                  break;
                case 1:
                  if (n === 1)
                    return 1;
                  break;
                case 2:
                  if (n === 2)
                    return 1;
                  break;
                case 3:
                  if (n === 3)
                    return 1;
                  break;
                default:
                  if (4 <= n)
                    return 1;
              }
              return 0;
            }), N(xL, function(t4, n) {
              switch (t4) {
                case 0:
                  if (!n)
                    return 1;
                  break;
                case 1:
                  if (n === 1)
                    return 1;
                  break;
                default:
                  if (2 <= n)
                    return 1;
              }
              return 0;
            }), N(kr0, function(t4, n) {
              var e4 = qn(t4[1], n[1]), i4 = e4 && qn(t4[2], n[2]), x4 = i4 && qn(t4[3], n[3]);
              return x4;
            });
            function wr0(t4) {
              if (typeof t4 == "number") {
                var n = t4;
                if (61 <= n) {
                  if (92 <= n)
                    switch (n) {
                      case 92:
                        return Ekr;
                      case 93:
                        return Skr;
                      case 94:
                        return gkr;
                      case 95:
                        return Fkr;
                      case 96:
                        return Tkr;
                      case 97:
                        return Okr;
                      case 98:
                        return Ikr;
                      case 99:
                        return Akr;
                      case 100:
                        return Nkr;
                      case 101:
                        return Ckr;
                      case 102:
                        return Pkr;
                      case 103:
                        return Dkr;
                      case 104:
                        return Lkr;
                      case 105:
                        return Rkr;
                      case 106:
                        return jkr;
                      case 107:
                        return Gkr;
                      case 108:
                        return Mkr;
                      case 109:
                        return Bkr;
                      case 110:
                        return qkr;
                      case 111:
                        return Ukr;
                      case 112:
                        return Hkr;
                      case 113:
                        return Xkr;
                      case 114:
                        return Ykr;
                      case 115:
                        return Vkr;
                      case 116:
                        return zkr;
                      case 117:
                        return Kkr;
                      case 118:
                        return Wkr;
                      case 119:
                        return Jkr;
                      case 120:
                        return $kr;
                      default:
                        return Zkr;
                    }
                  switch (n) {
                    case 61:
                      return Vdr;
                    case 62:
                      return zdr;
                    case 63:
                      return Kdr;
                    case 64:
                      return Wdr;
                    case 65:
                      return Jdr;
                    case 66:
                      return $dr;
                    case 67:
                      return Zdr;
                    case 68:
                      return Qdr;
                    case 69:
                      return rkr;
                    case 70:
                      return ekr;
                    case 71:
                      return nkr;
                    case 72:
                      return tkr;
                    case 73:
                      return ukr;
                    case 74:
                      return ikr;
                    case 75:
                      return fkr;
                    case 76:
                      return xkr;
                    case 77:
                      return okr;
                    case 78:
                      return akr;
                    case 79:
                      return ckr;
                    case 80:
                      return skr;
                    case 81:
                      return vkr;
                    case 82:
                      return lkr;
                    case 83:
                      return bkr;
                    case 84:
                      return pkr;
                    case 85:
                      return mkr;
                    case 86:
                      return _kr;
                    case 87:
                      return ykr;
                    case 88:
                      return hkr;
                    case 89:
                      return dkr;
                    case 90:
                      return kkr;
                    default:
                      return wkr;
                  }
                }
                if (31 <= n)
                  switch (n) {
                    case 31:
                      return mdr;
                    case 32:
                      return _dr;
                    case 33:
                      return ydr;
                    case 34:
                      return hdr;
                    case 35:
                      return ddr;
                    case 36:
                      return kdr;
                    case 37:
                      return wdr;
                    case 38:
                      return Edr;
                    case 39:
                      return Sdr;
                    case 40:
                      return gdr;
                    case 41:
                      return Fdr;
                    case 42:
                      return Tdr;
                    case 43:
                      return Odr;
                    case 44:
                      return Idr;
                    case 45:
                      return Adr;
                    case 46:
                      return Ndr;
                    case 47:
                      return Cdr;
                    case 48:
                      return Pdr;
                    case 49:
                      return Ddr;
                    case 50:
                      return Ldr;
                    case 51:
                      return Rdr;
                    case 52:
                      return jdr;
                    case 53:
                      return Gdr;
                    case 54:
                      return Mdr;
                    case 55:
                      return Bdr;
                    case 56:
                      return qdr;
                    case 57:
                      return Udr;
                    case 58:
                      return Hdr;
                    case 59:
                      return Xdr;
                    default:
                      return Ydr;
                  }
                switch (n) {
                  case 0:
                    return Mhr;
                  case 1:
                    return Bhr;
                  case 2:
                    return qhr;
                  case 3:
                    return Uhr;
                  case 4:
                    return Hhr;
                  case 5:
                    return Xhr;
                  case 6:
                    return Yhr;
                  case 7:
                    return Vhr;
                  case 8:
                    return zhr;
                  case 9:
                    return Khr;
                  case 10:
                    return Whr;
                  case 11:
                    return Jhr;
                  case 12:
                    return $hr;
                  case 13:
                    return Zhr;
                  case 14:
                    return Qhr;
                  case 15:
                    return rdr;
                  case 16:
                    return edr;
                  case 17:
                    return ndr;
                  case 18:
                    return tdr;
                  case 19:
                    return udr;
                  case 20:
                    return idr;
                  case 21:
                    return fdr;
                  case 22:
                    return xdr;
                  case 23:
                    return odr;
                  case 24:
                    return adr;
                  case 25:
                    return cdr;
                  case 26:
                    return sdr;
                  case 27:
                    return vdr;
                  case 28:
                    return ldr;
                  case 29:
                    return bdr;
                  default:
                    return pdr;
                }
              } else
                switch (t4[0]) {
                  case 0:
                    return Qkr;
                  case 1:
                    return rwr;
                  case 2:
                    return ewr;
                  case 3:
                    return nwr;
                  case 4:
                    return twr;
                  case 5:
                    return uwr;
                  case 6:
                    return iwr;
                  case 7:
                    return fwr;
                  case 8:
                    return xwr;
                  case 9:
                    return owr;
                  case 10:
                    return awr;
                  default:
                    return cwr;
                }
            }
            function oL(t4) {
              if (typeof t4 == "number") {
                var n = t4;
                if (61 <= n) {
                  if (92 <= n)
                    switch (n) {
                      case 92:
                        return ihr;
                      case 93:
                        return fhr;
                      case 94:
                        return xhr;
                      case 95:
                        return ohr;
                      case 96:
                        return ahr;
                      case 97:
                        return chr;
                      case 98:
                        return shr;
                      case 99:
                        return vhr;
                      case 100:
                        return lhr;
                      case 101:
                        return bhr;
                      case 102:
                        return phr;
                      case 103:
                        return mhr;
                      case 104:
                        return _hr;
                      case 105:
                        return yhr;
                      case 106:
                        return hhr;
                      case 107:
                        return dhr;
                      case 108:
                        return khr;
                      case 109:
                        return whr;
                      case 110:
                        return Ehr;
                      case 111:
                        return Shr;
                      case 112:
                        return ghr;
                      case 113:
                        return Fhr;
                      case 114:
                        return Thr;
                      case 115:
                        return Ohr;
                      case 116:
                        return Ihr;
                      case 117:
                        return Ahr;
                      case 118:
                        return Nhr;
                      case 119:
                        return Chr;
                      case 120:
                        return Phr;
                      default:
                        return Dhr;
                    }
                  switch (n) {
                    case 61:
                      return Oyr;
                    case 62:
                      return Iyr;
                    case 63:
                      return Ayr;
                    case 64:
                      return Nyr;
                    case 65:
                      return Cyr;
                    case 66:
                      return Pyr;
                    case 67:
                      return Dyr;
                    case 68:
                      return Lyr;
                    case 69:
                      return Ryr;
                    case 70:
                      return jyr;
                    case 71:
                      return Gyr;
                    case 72:
                      return Myr;
                    case 73:
                      return Byr;
                    case 74:
                      return qyr;
                    case 75:
                      return Uyr;
                    case 76:
                      return Hyr;
                    case 77:
                      return Xyr;
                    case 78:
                      return Yyr;
                    case 79:
                      return Vyr;
                    case 80:
                      return zyr;
                    case 81:
                      return Kyr;
                    case 82:
                      return Wyr;
                    case 83:
                      return Jyr;
                    case 84:
                      return $yr;
                    case 85:
                      return Zyr;
                    case 86:
                      return Qyr;
                    case 87:
                      return rhr;
                    case 88:
                      return ehr;
                    case 89:
                      return nhr;
                    case 90:
                      return thr;
                    default:
                      return uhr;
                  }
                }
                if (31 <= n)
                  switch (n) {
                    case 31:
                      return Z_r;
                    case 32:
                      return Q_r;
                    case 33:
                      return ryr;
                    case 34:
                      return eyr;
                    case 35:
                      return nyr;
                    case 36:
                      return tyr;
                    case 37:
                      return uyr;
                    case 38:
                      return iyr;
                    case 39:
                      return fyr;
                    case 40:
                      return xyr;
                    case 41:
                      return oyr;
                    case 42:
                      return ayr;
                    case 43:
                      return cyr;
                    case 44:
                      return syr;
                    case 45:
                      return vyr;
                    case 46:
                      return lyr;
                    case 47:
                      return byr;
                    case 48:
                      return pyr;
                    case 49:
                      return myr;
                    case 50:
                      return _yr;
                    case 51:
                      return yyr;
                    case 52:
                      return hyr;
                    case 53:
                      return dyr;
                    case 54:
                      return kyr;
                    case 55:
                      return wyr;
                    case 56:
                      return Eyr;
                    case 57:
                      return Syr;
                    case 58:
                      return gyr;
                    case 59:
                      return Fyr;
                    default:
                      return Tyr;
                  }
                switch (n) {
                  case 0:
                    return k_r;
                  case 1:
                    return w_r;
                  case 2:
                    return E_r;
                  case 3:
                    return S_r;
                  case 4:
                    return g_r;
                  case 5:
                    return F_r;
                  case 6:
                    return T_r;
                  case 7:
                    return O_r;
                  case 8:
                    return I_r;
                  case 9:
                    return A_r;
                  case 10:
                    return N_r;
                  case 11:
                    return C_r;
                  case 12:
                    return P_r;
                  case 13:
                    return D_r;
                  case 14:
                    return L_r;
                  case 15:
                    return R_r;
                  case 16:
                    return j_r;
                  case 17:
                    return G_r;
                  case 18:
                    return M_r;
                  case 19:
                    return B_r;
                  case 20:
                    return q_r;
                  case 21:
                    return U_r;
                  case 22:
                    return H_r;
                  case 23:
                    return X_r;
                  case 24:
                    return Y_r;
                  case 25:
                    return V_r;
                  case 26:
                    return z_r;
                  case 27:
                    return K_r;
                  case 28:
                    return W_r;
                  case 29:
                    return J_r;
                  default:
                    return $_r;
                }
              } else
                switch (t4[0]) {
                  case 2:
                    return t4[1][3];
                  case 3:
                    return t4[1][2][3];
                  case 5:
                    var e4 = Te(Lhr, t4[3]);
                    return Te(Rhr, Te(t4[2], e4));
                  case 9:
                    return t4[1] ? jhr : Ghr;
                  case 0:
                  case 1:
                    return t4[2];
                  case 6:
                  case 7:
                    return t4[1];
                  default:
                    return t4[3];
                }
            }
            function Ml(t4) {
              return u(et(d_r), t4);
            }
            function aL(t4, n) {
              var e4 = t4 && t4[1], i4 = 0;
              if (typeof n == "number")
                if (Pn === n)
                  var x4 = u_r, c = i_r;
                else
                  i4 = 1;
              else
                switch (n[0]) {
                  case 3:
                    var x4 = f_r, c = x_r;
                    break;
                  case 5:
                    var x4 = o_r, c = a_r;
                    break;
                  case 6:
                  case 9:
                    i4 = 1;
                    break;
                  case 0:
                  case 10:
                    var x4 = s_r, c = v_r;
                    break;
                  case 1:
                  case 11:
                    var x4 = l_r, c = b_r;
                    break;
                  case 2:
                  case 8:
                    var x4 = p_r, c = m_r;
                    break;
                  default:
                    var x4 = __r, c = y_r;
                }
              if (i4)
                var x4 = c_r, c = Ml(oL(n));
              return e4 ? Te(x4, Te(h_r, c)) : c;
            }
            function cL(t4) {
              return 45 < t4 ? 46 < t4 ? -1 : 0 : -1;
            }
            function jc(t4) {
              if (8 < t4) {
                if (Ev < t4) {
                  if (ef < t4) {
                    if (Do < t4)
                      return -1;
                    if (Qx < t4) {
                      var n = t4 <= Ma ? 1 : 0, e4 = n && -1;
                      return e4;
                    }
                    if (fo < t4) {
                      if (xc < t4) {
                        if (ox < t4) {
                          var i4 = t4 <= Eo ? 1 : 0, x4 = i4 && -1;
                          return x4;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t4) {
                      var c = t4 <= mo ? 1 : 0, s2 = c && -1;
                      return s2;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(BDr, t4 - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function pn(t4) {
              return 47 < t4 ? 57 < t4 ? -1 : 0 : -1;
            }
            function Nn(t4) {
              return 47 < t4 ? Ri < t4 ? -1 : Vr($Lr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function wi(t4) {
              return 47 < t4 ? Xt < t4 ? -1 : Vr(ULr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function Zv(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(cLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function Zm(t4) {
              return 87 < t4 ? uc < t4 ? -1 : Vr(eN, t4 - 88 | 0) - 1 | 0 : -1;
            }
            function Qm(t4) {
              return 45 < t4 ? 57 < t4 ? -1 : Vr(ZLr, t4 + v1 | 0) - 1 | 0 : -1;
            }
            function Er0(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(sLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function A1(t4) {
              return 47 < t4 ? br < t4 ? -1 : Vr(MLr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function Qv(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(vLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function N1(t4) {
              if (8 < t4) {
                if (Ev < t4) {
                  if (ef < t4) {
                    if (Do < t4)
                      return -1;
                    if (Qx < t4) {
                      var n = t4 <= Ma ? 1 : 0, e4 = n && -1;
                      return e4;
                    }
                    if (fo < t4) {
                      if (xc < t4) {
                        if (ox < t4) {
                          var i4 = t4 <= Eo ? 1 : 0, x4 = i4 && -1;
                          return x4;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t4) {
                      var c = t4 <= mo ? 1 : 0, s2 = c && -1;
                      return s2;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(qDr, t4 - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function r9(t4) {
              return 45 < t4 ? R7 < t4 ? -1 : Vr(rLr, t4 + v1 | 0) - 1 | 0 : -1;
            }
            function Sr0(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(lLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function e9(t4) {
              return 47 < t4 ? 95 < t4 ? -1 : Vr(sRr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function n9(t4) {
              return 47 < t4 ? Xt < t4 ? -1 : Vr(lRr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function t9(t4) {
              return 47 < t4 ? Xt < t4 ? -1 : Vr(HLr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function u9(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(bLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function i9(t4) {
              if (8 < t4) {
                if (Ev < t4) {
                  if (ef < t4) {
                    if (Do < t4)
                      return -1;
                    if (Qx < t4) {
                      var n = t4 <= Ma ? 1 : 0, e4 = n && -1;
                      return e4;
                    }
                    if (fo < t4) {
                      if (xc < t4) {
                        if (ox < t4) {
                          var i4 = t4 <= Eo ? 1 : 0, x4 = i4 && -1;
                          return x4;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t4) {
                      var c = t4 <= mo ? 1 : 0, s2 = c && -1;
                      return s2;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(UDr, t4 - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function f9(t4) {
              return 44 < t4 ? 57 < t4 ? -1 : Vr(KDr, t4 + mv | 0) - 1 | 0 : -1;
            }
            function Gc(t4) {
              return 47 < t4 ? 49 < t4 ? -1 : 0 : -1;
            }
            function x9(t4) {
              return 47 < t4 ? 95 < t4 ? -1 : Vr(WDr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function C1(t4) {
              return 47 < t4 ? 57 < t4 ? -1 : Vr(vRr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function o9(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(pLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function gr0(t4) {
              return t1 < t4 ? Av < t4 ? -1 : 0 : -1;
            }
            function Ui(t4) {
              return 60 < t4 ? 61 < t4 ? -1 : 0 : -1;
            }
            function Fr0(t4) {
              if (-1 < t4) {
                if (In < t4) {
                  if (ts < t4) {
                    if ($u < t4) {
                      var n = t4 <= Hu ? 1 : 0, e4 = n && -1;
                      return e4;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(fLr, t4) - 1 | 0;
              }
              return -1;
            }
            function r22(t4) {
              return 47 < t4 ? Xt < t4 ? -1 : Vr(XLr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function a9(t4) {
              return 47 < t4 ? Xt < t4 ? -1 : Vr(JLr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function sL(t4) {
              return 60 < t4 ? 62 < t4 ? -1 : Vr(rN, t4 + SS | 0) - 1 | 0 : -1;
            }
            function c9(t4) {
              return 65 < t4 ? 98 < t4 ? -1 : Vr(eN, t4 - 66 | 0) - 1 | 0 : -1;
            }
            function Bt(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(mLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function s9(t4) {
              return Av < t4 ? f1 < t4 ? -1 : 0 : -1;
            }
            function zu(t4) {
              return 47 < t4 ? 55 < t4 ? -1 : 0 : -1;
            }
            function vL(t4) {
              return Fv < t4 ? Xt < t4 ? -1 : 0 : -1;
            }
            function v9(t4) {
              return Xt < t4 ? cf < t4 ? -1 : 0 : -1;
            }
            function Bl(t4) {
              return 98 < t4 ? 99 < t4 ? -1 : 0 : -1;
            }
            function Cs(t4) {
              return 47 < t4 ? 48 < t4 ? -1 : 0 : -1;
            }
            function ql(t4) {
              if (8 < t4) {
                if (Ev < t4) {
                  if (ef < t4) {
                    if (Do < t4)
                      return -1;
                    if (Qx < t4) {
                      var n = t4 <= Ma ? 1 : 0, e4 = n && -1;
                      return e4;
                    }
                    if (fo < t4) {
                      if (xc < t4) {
                        if (ox < t4) {
                          var i4 = t4 <= Eo ? 1 : 0, x4 = i4 && -1;
                          return x4;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t4) {
                      var c = t4 <= mo ? 1 : 0, s2 = c && -1;
                      return s2;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(HDr, t4 - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function l9(t4) {
              return 45 < t4 ? R7 < t4 ? -1 : Vr(JDr, t4 + v1 | 0) - 1 | 0 : -1;
            }
            function b9(t4) {
              return 78 < t4 ? cf < t4 ? -1 : Vr(eN, t4 - 79 | 0) - 1 | 0 : -1;
            }
            function Tr0(t4) {
              return 41 < t4 ? 42 < t4 ? -1 : 0 : -1;
            }
            function Or0(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(_Lr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function p9(t4) {
              return 47 < t4 ? R7 < t4 ? -1 : Vr(BLr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function Ps(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(yLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function Ir0(t4) {
              return 41 < t4 ? 61 < t4 ? -1 : Vr(KLr, t4 + _y | 0) - 1 | 0 : -1;
            }
            function P1(t4) {
              return 44 < t4 ? 48 < t4 ? -1 : Vr(LLr, t4 + mv | 0) - 1 | 0 : -1;
            }
            function Ar0(t4) {
              return 44 < t4 ? 45 < t4 ? -1 : 0 : -1;
            }
            function Nr0(t4) {
              return L7 < t4 ? j7 < t4 ? -1 : 0 : -1;
            }
            function m9(t4) {
              return Zc < t4 ? is < t4 ? -1 : 0 : -1;
            }
            function Cr0(t4) {
              return 99 < t4 ? ti < t4 ? -1 : 0 : -1;
            }
            function _9(t4) {
              return 47 < t4 ? Ri < t4 ? -1 : Vr(QLr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function y9(t4) {
              return Pn < t4 ? t1 < t4 ? -1 : 0 : -1;
            }
            function D1(t4) {
              return 45 < t4 ? 57 < t4 ? -1 : Vr(nRr, t4 + v1 | 0) - 1 | 0 : -1;
            }
            function Pr0(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(hLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function L1(t4) {
              return 47 < t4 ? ts < t4 ? -1 : Vr(bRr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function lL(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(dLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function xi(t4) {
              return 9 < t4 ? 10 < t4 ? -1 : 0 : -1;
            }
            function Dr0(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(kLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function Lr0(t4) {
              return 96 < t4 ? 97 < t4 ? -1 : 0 : -1;
            }
            function Mc(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(wLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function h9(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(ELr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function Ds(t4) {
              return 47 < t4 ? 95 < t4 ? -1 : Vr(YLr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function Rr0(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(SLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function Ul(t4) {
              return ti < t4 ? R7 < t4 ? -1 : 0 : -1;
            }
            function jr0(t4) {
              if (8 < t4) {
                if (Ev < t4) {
                  if (ef < t4) {
                    if (Do < t4)
                      return -1;
                    if (Qx < t4) {
                      var n = t4 <= Ma ? 1 : 0, e4 = n && -1;
                      return e4;
                    }
                    if (fo < t4) {
                      if (xc < t4) {
                        if (ox < t4) {
                          var i4 = t4 <= Eo ? 1 : 0, x4 = i4 && -1;
                          return x4;
                        }
                        return 0;
                      }
                      return -1;
                    }
                    if (Co < t4) {
                      var c = t4 <= mo ? 1 : 0, s2 = c && -1;
                      return s2;
                    }
                    return 0;
                  }
                  return -1;
                }
                return Vr(YDr, t4 - 9 | 0) - 1 | 0;
              }
              return -1;
            }
            function Gr0(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(tRr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function d9(t4) {
              return 41 < t4 ? 47 < t4 ? -1 : Vr(CLr, t4 + _y | 0) - 1 | 0 : -1;
            }
            function k9(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(gLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function Mr0(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(FLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function Br0(t4) {
              return z2 < t4 ? Sv < t4 ? -1 : 0 : -1;
            }
            function w9(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(TLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function f7(t4) {
              return 47 < t4 ? R7 < t4 ? -1 : Vr(qLr, t4 + Wt | 0) - 1 | 0 : -1;
            }
            function E9(t4) {
              return 42 < t4 ? 57 < t4 ? -1 : Vr(uLr, t4 + xy | 0) - 1 | 0 : -1;
            }
            function Bc(t4) {
              return 45 < t4 ? 95 < t4 ? -1 : Vr(aLr, t4 + v1 | 0) - 1 | 0 : -1;
            }
            function Ls(t4) {
              return f1 < t4 ? A2 < t4 ? -1 : 0 : -1;
            }
            function qr0(t4) {
              return 46 < t4 ? 47 < t4 ? -1 : 0 : -1;
            }
            function Ur0(t4) {
              return 57 < t4 ? 58 < t4 ? -1 : 0 : -1;
            }
            function dn(t4) {
              return 35 < t4 ? In < t4 ? -1 : Vr(OLr, t4 + vu | 0) - 1 | 0 : -1;
            }
            function Hr0(t4) {
              for (; ; ) {
                gn(t4);
                var n = j(t4), e4 = In < n ? 1 : Vr(xRr, n + 1 | 0) - 1 | 0;
                if (3 < e4 >>> 0)
                  var i4 = q(t4);
                else
                  switch (e4) {
                    case 0:
                      var i4 = 1;
                      break;
                    case 1:
                      var i4 = 2;
                      break;
                    case 2:
                      var i4 = 0;
                      break;
                    default:
                      if (G0(t4, 2), Ls(j(t4)) === 0) {
                        var x4 = L1(j(t4));
                        if (x4 === 0)
                          if (Nn(j(t4)) === 0 && Nn(j(t4)) === 0)
                            var c = Nn(j(t4)) !== 0 ? 1 : 0, i4 = c && q(t4);
                          else
                            var i4 = q(t4);
                        else if (x4 === 1 && Nn(j(t4)) === 0)
                          for (; ; ) {
                            var s2 = A1(j(t4));
                            if (s2 !== 0) {
                              var p = s2 !== 1 ? 1 : 0, i4 = p && q(t4);
                              break;
                            }
                          }
                        else
                          var i4 = q(t4);
                      } else
                        var i4 = q(t4);
                  }
                if (2 < i4 >>> 0)
                  throw [0, Sn, swr];
                switch (i4) {
                  case 0:
                    continue;
                  case 1:
                    return 1;
                  default:
                    if (nL(br0(t4)))
                      continue;
                    return mr0(t4, 1), 0;
                }
              }
            }
            function S9(t4, n) {
              var e4 = n - t4[3][2] | 0;
              return [0, hr0(t4), e4];
            }
            function Hl(t4, n, e4) {
              var i4 = S9(t4, e4), x4 = S9(t4, n);
              return [0, t4[1], x4, i4];
            }
            function ju(t4, n) {
              return S9(t4, n[6]);
            }
            function h7(t4, n) {
              return S9(t4, n[3]);
            }
            function nt(t4, n) {
              return Hl(t4, n[6], n[3]);
            }
            function Xr0(t4, n) {
              var e4 = 0;
              if (typeof n == "number")
                e4 = 1;
              else
                switch (n[0]) {
                  case 2:
                    var i4 = n[1][1];
                    break;
                  case 3:
                    return n[1][1];
                  case 4:
                    var i4 = n[1];
                    break;
                  case 7:
                    var i4 = n[2];
                    break;
                  case 5:
                  case 8:
                    return n[1];
                  default:
                    e4 = 1;
                }
              return e4 ? nt(t4, t4[2]) : i4;
            }
            function Gu(t4, n, e4) {
              return [0, t4[1], t4[2], t4[3], t4[4], t4[5], [0, [0, n, e4], t4[6]], t4[7]];
            }
            function Yr0(t4, n, e4) {
              return Gu(t4, n, [10, Ml(e4)]);
            }
            function bL(t4, n, e4, i4) {
              return Gu(t4, n, [12, e4, i4]);
            }
            function Ei(t4, n) {
              return Gu(t4, n, GDr);
            }
            function d7(t4, n) {
              var e4 = n[3], i4 = [0, hr0(t4) + 1 | 0, e4];
              return [0, t4[1], t4[2], i4, t4[4], t4[5], t4[6], t4[7]];
            }
            function Vr0(t4) {
              var n = un(t4);
              return n !== 0 && Xt === It(t4, n - 1 | 0) ? m7(t4, 0, n - 1 | 0) : t4;
            }
            function Si(t4, n, e4, i4, x4) {
              var c = [0, t4[1], n, e4], s2 = Mt(i4), p = x4 ? 0 : 1;
              return [0, c, [0, p, s2, t4[7][3][1] < c[2][1] ? 1 : 0]];
            }
            function qc(t4, n) {
              if (It(n, 0) === 45)
                var e4 = m7(n, 1, un(n) - 1 | 0), i4 = 1;
              else
                var e4 = n, i4 = 0;
              switch (t4) {
                case 1:
                  try {
                    var x4 = jv(Rv(Te(DDr, e4))), c = x4;
                  } catch (T) {
                    if (T = Et(T), T[1] !== q7)
                      throw T;
                    var c = ke(Te(LDr, e4));
                  }
                  break;
                case 0:
                case 3:
                  try {
                    var s2 = jv(Rv(e4)), c = s2;
                  } catch (T) {
                    if (T = Et(T), T[1] !== q7)
                      throw T;
                    var c = ke(Te(RDr, e4));
                  }
                  break;
                default:
                  try {
                    var p = ol(e4), c = p;
                  } catch (T) {
                    if (T = Et(T), T[1] !== q7)
                      throw T;
                    var c = ke(Te(jDr, e4));
                  }
              }
              var y = i4 ? -c : c;
              return [10, t4, y, n];
            }
            function Hi(t4, n) {
              if (It(n, 0) === 45)
                var e4 = m7(n, 1, un(n) - 1 | 0), i4 = 1;
              else
                var e4 = n, i4 = 0;
              if (2 <= t4) {
                var x4 = Vr0(e4);
                try {
                  var c = ol(x4), s2 = c;
                } catch (w) {
                  if (w = Et(w), w[1] !== q7)
                    throw w;
                  var s2 = ke(Te(CDr, x4));
                }
                var p = s2;
              } else {
                var y = Vr0(e4);
                try {
                  var T = jv(Rv(y)), E = T;
                } catch (G) {
                  if (G = Et(G), G[1] !== q7)
                    throw G;
                  var E = ke(Te(PDr, y));
                }
                var p = E;
              }
              var d = i4 ? -p : p;
              return [11, t4, d, n];
            }
            function zr0(t4, n, e4) {
              return nL(e4) ? t4 : Gu(t4, n, 37);
            }
            function Kr0(t4, n, e4, i4, x4) {
              var c = Hl(t4, n + e4[6] | 0, n + e4[3] | 0);
              return [0, c, jl(e4, i4, (Jm(e4) - i4 | 0) - x4 | 0)];
            }
            function Wr0(t4, n) {
              for (var e4 = t4[2][6], i4 = [0, n, n.length - 1, lr0, vr0, sr0, cr0, ar0, or0, xr0, fr0, ir0, ur0], x4 = $n(n.length - 1), c = t4; ; ) {
                gn(i4);
                var s2 = j(i4), p = 92 < s2 ? 1 : Vr(jLr, s2 + 1 | 0) - 1 | 0;
                if (2 < p >>> 0)
                  var y = q(i4);
                else
                  switch (p) {
                    case 0:
                      var y = 2;
                      break;
                    case 1:
                      for (; ; ) {
                        G0(i4, 3);
                        var T = j(i4);
                        if (-1 < T)
                          if (91 < T)
                            var E = T <= 92 ? 1 : 0, d = E && -1;
                          else
                            var d = 0;
                        else
                          var d = -1;
                        if (d !== 0) {
                          var y = q(i4);
                          break;
                        }
                      }
                      break;
                    default:
                      if (G0(i4, 3), Ls(j(i4)) === 0) {
                        var w = L1(j(i4));
                        if (w === 0)
                          if (Nn(j(i4)) === 0 && Nn(j(i4)) === 0)
                            var G = Nn(j(i4)) !== 0 ? 1 : 0, y = G && q(i4);
                          else
                            var y = q(i4);
                        else if (w === 1 && Nn(j(i4)) === 0)
                          for (; ; ) {
                            var A11 = A1(j(i4));
                            if (A11 !== 0) {
                              var y = A11 === 1 ? 1 : q(i4);
                              break;
                            }
                          }
                        else
                          var y = q(i4);
                      } else
                        var y = q(i4);
                  }
                if (3 < y >>> 0)
                  return ke(IDr);
                switch (y) {
                  case 0:
                    var S11 = Kr0(c, e4, i4, 2, 0), M = S11[1], K = Bi(Te(ADr, S11[2])), V = 0 <= K ? 1 : 0, f0 = V && (K <= 55295 ? 1 : 0);
                    if (f0)
                      var k0 = f0;
                    else
                      var m0 = 57344 <= K ? 1 : 0, k0 = m0 && (K <= lI ? 1 : 0);
                    var g0 = k0 ? zr0(c, M, K) : Gu(c, M, 37);
                    S1(x4, K);
                    var c = g0;
                    continue;
                  case 1:
                    var e0 = Kr0(c, e4, i4, 3, 1), x0 = Bi(Te(NDr, e0[2])), l = zr0(c, e0[1], x0);
                    S1(x4, x0);
                    var c = l;
                    continue;
                  case 2:
                    return [0, c, Mt(x4)];
                  default:
                    Gl(i4, x4);
                    continue;
                }
              }
            }
            function Rt(t4, n, e4) {
              var i4 = Ei(t4, nt(t4, n));
              return $v(n), o(e4, i4, n);
            }
            function R1(t4, n, e4) {
              for (var i4 = t4; ; ) {
                gn(e4);
                var x4 = j(e4);
                if (-1 < x4)
                  if (42 < x4)
                    var c = x4 <= Hu ? 1 : 0, s2 = c && ($u < x4 ? 1 : 0);
                  else
                    var s2 = Vr(VDr, x4) - 1 | 0;
                else
                  var s2 = -1;
                if (3 < s2 >>> 0)
                  var p = q(e4);
                else
                  switch (s2) {
                    case 0:
                      for (; ; ) {
                        G0(e4, 3);
                        var y = j(e4);
                        if (-1 < y)
                          if (41 < y)
                            if (42 < y)
                              if ($u < y)
                                var T = y <= Hu ? 1 : 0, E = T && -1;
                              else
                                var E = 0;
                            else
                              var E = -1;
                          else
                            var E = Vr(eRr, y) - 1 | 0;
                        else
                          var E = -1;
                        if (E !== 0) {
                          var p = q(e4);
                          break;
                        }
                      }
                      break;
                    case 1:
                      var p = 0;
                      break;
                    case 2:
                      G0(e4, 0);
                      var d = xi(j(e4)) !== 0 ? 1 : 0, p = d && q(e4);
                      break;
                    default:
                      G0(e4, 3);
                      var w = j(e4), G = 44 < w ? 47 < w ? -1 : Vr(aRr, w + mv | 0) - 1 | 0 : -1, p = G === 0 ? qr0(j(e4)) === 0 ? 2 : q(e4) : G === 1 ? 1 : q(e4);
                  }
                if (3 < p >>> 0) {
                  var A11 = Ei(i4, nt(i4, e4));
                  return [0, A11, h7(A11, e4)];
                }
                switch (p) {
                  case 0:
                    var S11 = d7(i4, e4);
                    Gl(e4, n);
                    var i4 = S11;
                    continue;
                  case 1:
                    var M = i4[4] ? bL(i4, nt(i4, e4), bwr, lwr) : i4;
                    return [0, M, h7(M, e4)];
                  case 2:
                    if (i4[4])
                      return [0, i4, h7(i4, e4)];
                    hn(n, pwr);
                    continue;
                  default:
                    Gl(e4, n);
                    continue;
                }
              }
            }
            function e2(t4, n, e4) {
              for (; ; ) {
                gn(e4);
                var i4 = j(e4), x4 = 13 < i4 ? Hu < i4 ? 1 : $u < i4 ? 2 : 1 : Vr(NLr, i4 + 1 | 0) - 1 | 0;
                if (3 < x4 >>> 0)
                  var c = q(e4);
                else
                  switch (x4) {
                    case 0:
                      var c = 0;
                      break;
                    case 1:
                      for (; ; ) {
                        G0(e4, 2);
                        var s2 = j(e4);
                        if (-1 < s2)
                          if (12 < s2)
                            if (13 < s2)
                              if ($u < s2)
                                var p = s2 <= Hu ? 1 : 0, y = p && -1;
                              else
                                var y = 0;
                            else
                              var y = -1;
                          else
                            var y = Vr(MDr, s2) - 1 | 0;
                        else
                          var y = -1;
                        if (y !== 0) {
                          var c = q(e4);
                          break;
                        }
                      }
                      break;
                    case 2:
                      var c = 1;
                      break;
                    default:
                      G0(e4, 1);
                      var c = xi(j(e4)) === 0 ? 1 : q(e4);
                  }
                if (2 < c >>> 0)
                  return ke(mwr);
                switch (c) {
                  case 0:
                    return [0, t4, h7(t4, e4)];
                  case 1:
                    var T = h7(t4, e4), E = d7(t4, e4), d = Jm(e4);
                    return [0, E, [0, T[1], T[2] - d | 0]];
                  default:
                    Gl(e4, n);
                    continue;
                }
              }
            }
            function Jr0(t4, n) {
              function e4(k0) {
                return G0(k0, 3), zu(j(k0)) === 0 ? 2 : q(k0);
              }
              gn(n);
              var i4 = j(n), x4 = uc < i4 ? Hu < i4 ? 1 : $u < i4 ? 2 : 1 : Vr(nLr, i4 + 1 | 0) - 1 | 0;
              if (14 < x4 >>> 0)
                var c = q(n);
              else
                switch (x4) {
                  case 1:
                    var c = 16;
                    break;
                  case 2:
                    var c = 15;
                    break;
                  case 3:
                    G0(n, 15);
                    var c = xi(j(n)) === 0 ? 15 : q(n);
                    break;
                  case 4:
                    G0(n, 4);
                    var c = zu(j(n)) === 0 ? e4(n) : q(n);
                    break;
                  case 5:
                    G0(n, 11);
                    var c = zu(j(n)) === 0 ? e4(n) : q(n);
                    break;
                  case 7:
                    var c = 5;
                    break;
                  case 8:
                    var c = 6;
                    break;
                  case 9:
                    var c = 7;
                    break;
                  case 10:
                    var c = 8;
                    break;
                  case 11:
                    var c = 9;
                    break;
                  case 12:
                    G0(n, 14);
                    var s2 = L1(j(n));
                    if (s2 === 0)
                      var c = Nn(j(n)) === 0 && Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 12 : q(n);
                    else if (s2 === 1 && Nn(j(n)) === 0)
                      for (; ; ) {
                        var p = A1(j(n));
                        if (p !== 0) {
                          var c = p === 1 ? 13 : q(n);
                          break;
                        }
                      }
                    else
                      var c = q(n);
                    break;
                  case 13:
                    var c = 10;
                    break;
                  case 14:
                    G0(n, 14);
                    var c = Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 1 : q(n);
                    break;
                  default:
                    var c = 0;
                }
              if (16 < c >>> 0)
                return ke(pDr);
              switch (c) {
                case 1:
                  var y = Se(n);
                  return [0, t4, y, [0, Bi(Te(mDr, y))], 0];
                case 2:
                  var T = Se(n), E = Bi(Te(_Dr, T));
                  return N4 <= E ? [0, t4, T, [0, E >>> 3 | 0, 48 + (E & 7) | 0], 1] : [0, t4, T, [0, E], 1];
                case 3:
                  var d = Se(n);
                  return [0, t4, d, [0, Bi(Te(yDr, d))], 1];
                case 4:
                  return [0, t4, hDr, [0, 0], 0];
                case 5:
                  return [0, t4, dDr, [0, 8], 0];
                case 6:
                  return [0, t4, kDr, [0, 12], 0];
                case 7:
                  return [0, t4, wDr, [0, 10], 0];
                case 8:
                  return [0, t4, EDr, [0, 13], 0];
                case 9:
                  return [0, t4, SDr, [0, 9], 0];
                case 10:
                  return [0, t4, gDr, [0, 11], 0];
                case 11:
                  var w = Se(n);
                  return [0, t4, w, [0, Bi(Te(FDr, w))], 1];
                case 12:
                  var G = Se(n);
                  return [0, t4, G, [0, Bi(Te(TDr, m7(G, 1, un(G) - 1 | 0)))], 0];
                case 13:
                  var A11 = Se(n), S11 = Bi(Te(ODr, m7(A11, 2, un(A11) - 3 | 0))), M = lI < S11 ? Ei(t4, nt(t4, n)) : t4;
                  return [0, M, A11, [0, S11], 0];
                case 14:
                  var K = Se(n), V = Ll(n);
                  return [0, Ei(t4, nt(t4, n)), K, V, 0];
                case 15:
                  var f0 = Se(n);
                  return [0, d7(t4, n), f0, [0], 0];
                default:
                  var m0 = Se(n);
                  return [0, t4, m0, Ll(n), 0];
              }
            }
            function $r0(t4, n, e4, i4, x4, c) {
              for (var s2 = t4, p = x4; ; ) {
                gn(c);
                var y = j(c), T = 92 < y ? 1 : Vr(RLr, y + 1 | 0) - 1 | 0;
                if (4 < T >>> 0)
                  var E = q(c);
                else
                  switch (T) {
                    case 0:
                      var E = 3;
                      break;
                    case 1:
                      for (; ; ) {
                        G0(c, 4);
                        var d = j(c);
                        if (-1 < d)
                          if (91 < d)
                            var w = d <= 92 ? 1 : 0, G = w && -1;
                          else
                            var G = Vr(ZDr, d) - 1 | 0;
                        else
                          var G = -1;
                        if (G !== 0) {
                          var E = q(c);
                          break;
                        }
                      }
                      break;
                    case 2:
                      var E = 2;
                      break;
                    case 3:
                      var E = 0;
                      break;
                    default:
                      var E = 1;
                  }
                if (4 < E >>> 0)
                  return ke(_wr);
                switch (E) {
                  case 0:
                    var A11 = Se(c);
                    if (hn(i4, A11), qn(n, A11))
                      return [0, s2, h7(s2, c), p];
                    hn(e4, A11);
                    continue;
                  case 1:
                    hn(i4, ywr);
                    var S11 = Jr0(s2, c), M = S11[4], K = M || p;
                    hn(i4, S11[2]);
                    var V = S11[3];
                    pz(function(w0) {
                      return S1(e4, w0);
                    }, V);
                    var s2 = S11[1], p = K;
                    continue;
                  case 2:
                    var f0 = Se(c);
                    hn(i4, f0);
                    var m0 = d7(Ei(s2, nt(s2, c)), c);
                    return hn(e4, f0), [0, m0, h7(m0, c), p];
                  case 3:
                    var k0 = Se(c);
                    hn(i4, k0);
                    var g0 = Ei(s2, nt(s2, c));
                    return hn(e4, k0), [0, g0, h7(g0, c), p];
                  default:
                    var e0 = c[6], x0 = c[3] - e0 | 0, l = Lt(x0 * 4 | 0), c0 = Rl(c[1], e0, x0, l);
                    sN(i4, l, 0, c0), sN(e4, l, 0, c0);
                    continue;
                }
              }
            }
            function Zr0(t4, n, e4, i4, x4) {
              for (var c = t4; ; ) {
                gn(x4);
                var s2 = j(x4), p = 96 < s2 ? 1 : Vr(zLr, s2 + 1 | 0) - 1 | 0;
                if (6 < p >>> 0)
                  var y = q(x4);
                else
                  switch (p) {
                    case 0:
                      var y = 0;
                      break;
                    case 1:
                      for (; ; ) {
                        G0(x4, 6);
                        var T = j(x4);
                        if (-1 < T)
                          if (95 < T)
                            var E = T <= 96 ? 1 : 0, d = E && -1;
                          else
                            var d = Vr($Dr, T) - 1 | 0;
                        else
                          var d = -1;
                        if (d !== 0) {
                          var y = q(x4);
                          break;
                        }
                      }
                      break;
                    case 2:
                      var y = 5;
                      break;
                    case 3:
                      G0(x4, 5);
                      var y = xi(j(x4)) === 0 ? 4 : q(x4);
                      break;
                    case 4:
                      G0(x4, 6);
                      var w = j(x4), G = In < w ? ts < w ? -1 : 0 : -1, y = G === 0 ? 2 : q(x4);
                      break;
                    case 5:
                      var y = 3;
                      break;
                    default:
                      var y = 1;
                  }
                if (6 < y >>> 0)
                  return ke(hwr);
                switch (y) {
                  case 0:
                    return [0, Ei(c, nt(c, x4)), 1];
                  case 1:
                    return qi(i4, 96), [0, c, 1];
                  case 2:
                    return hn(i4, dwr), [0, c, 0];
                  case 3:
                    qi(e4, 92), qi(i4, 92);
                    var A11 = Jr0(c, x4), S11 = A11[2];
                    hn(e4, S11), hn(i4, S11);
                    var M = A11[3];
                    pz(function(m0) {
                      return S1(n, m0);
                    }, M);
                    var c = A11[1];
                    continue;
                  case 4:
                    hn(e4, kwr), hn(i4, wwr), hn(n, Ewr);
                    var c = d7(c, x4);
                    continue;
                  case 5:
                    var K = Se(x4);
                    hn(e4, K), hn(i4, K), qi(n, 10);
                    var c = d7(c, x4);
                    continue;
                  default:
                    var V = Se(x4);
                    hn(e4, V), hn(i4, V), hn(n, V);
                    continue;
                }
              }
            }
            function Pee(t4, n) {
              function e4(B0) {
                for (; ; )
                  if (G0(B0, 33), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function i4(B0) {
                for (; ; )
                  if (G0(B0, 27), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function x4(B0) {
                G0(B0, 26);
                var D0 = Bt(j(B0));
                if (D0 === 0) {
                  for (; ; )
                    if (G0(B0, 25), dn(j(B0)) !== 0)
                      return q(B0);
                }
                return D0 === 1 ? i4(B0) : q(B0);
              }
              function c(B0) {
                for (; ; )
                  if (G0(B0, 27), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function s2(B0) {
                G0(B0, 26);
                var D0 = Bt(j(B0));
                if (D0 === 0) {
                  for (; ; )
                    if (G0(B0, 25), dn(j(B0)) !== 0)
                      return q(B0);
                }
                return D0 === 1 ? c(B0) : q(B0);
              }
              function p(B0) {
                r:
                  for (; ; ) {
                    if (pn(j(B0)) === 0)
                      for (; ; ) {
                        G0(B0, 28);
                        var D0 = Mc(j(B0));
                        if (3 < D0 >>> 0)
                          return q(B0);
                        switch (D0) {
                          case 0:
                            return c(B0);
                          case 1:
                            continue;
                          case 2:
                            continue r;
                          default:
                            return s2(B0);
                        }
                      }
                    return q(B0);
                  }
              }
              function y(B0) {
                G0(B0, 33);
                var D0 = Gr0(j(B0));
                if (3 < D0 >>> 0)
                  return q(B0);
                switch (D0) {
                  case 0:
                    return e4(B0);
                  case 1:
                    var Le = C1(j(B0));
                    if (Le === 0)
                      for (; ; ) {
                        G0(B0, 28);
                        var He = Qv(j(B0));
                        if (2 < He >>> 0)
                          return q(B0);
                        switch (He) {
                          case 0:
                            return c(B0);
                          case 1:
                            continue;
                          default:
                            return s2(B0);
                        }
                      }
                    if (Le === 1)
                      for (; ; ) {
                        G0(B0, 28);
                        var he = Mc(j(B0));
                        if (3 < he >>> 0)
                          return q(B0);
                        switch (he) {
                          case 0:
                            return c(B0);
                          case 1:
                            continue;
                          case 2:
                            return p(B0);
                          default:
                            return s2(B0);
                        }
                      }
                    return q(B0);
                  case 2:
                    for (; ; ) {
                      G0(B0, 28);
                      var me = Qv(j(B0));
                      if (2 < me >>> 0)
                        return q(B0);
                      switch (me) {
                        case 0:
                          return i4(B0);
                        case 1:
                          continue;
                        default:
                          return x4(B0);
                      }
                    }
                  default:
                    for (; ; ) {
                      G0(B0, 28);
                      var Zn = Mc(j(B0));
                      if (3 < Zn >>> 0)
                        return q(B0);
                      switch (Zn) {
                        case 0:
                          return i4(B0);
                        case 1:
                          continue;
                        case 2:
                          return p(B0);
                        default:
                          return x4(B0);
                      }
                    }
                }
              }
              function T(B0) {
                G0(B0, 31);
                var D0 = Bt(j(B0));
                if (D0 === 0) {
                  for (; ; )
                    if (G0(B0, 29), dn(j(B0)) !== 0)
                      return q(B0);
                }
                return D0 === 1 ? e4(B0) : q(B0);
              }
              function E(B0) {
                return G0(B0, 3), Ur0(j(B0)) === 0 ? 3 : q(B0);
              }
              function d(B0) {
                return m9(j(B0)) === 0 && v9(j(B0)) === 0 && Br0(j(B0)) === 0 && Ar0(j(B0)) === 0 && Nr0(j(B0)) === 0 && vL(j(B0)) === 0 && Bl(j(B0)) === 0 && m9(j(B0)) === 0 && Ls(j(B0)) === 0 && Cr0(j(B0)) === 0 && Ul(j(B0)) === 0 ? 3 : q(B0);
              }
              function w(B0) {
                G0(B0, 34);
                var D0 = Or0(j(B0));
                if (3 < D0 >>> 0)
                  return q(B0);
                switch (D0) {
                  case 0:
                    return e4(B0);
                  case 1:
                    for (; ; ) {
                      G0(B0, 34);
                      var Le = Ps(j(B0));
                      if (4 < Le >>> 0)
                        return q(B0);
                      switch (Le) {
                        case 0:
                          return e4(B0);
                        case 1:
                          continue;
                        case 2:
                          return y(B0);
                        case 3:
                          r:
                            for (; ; ) {
                              if (pn(j(B0)) === 0)
                                for (; ; ) {
                                  G0(B0, 34);
                                  var He = Ps(j(B0));
                                  if (4 < He >>> 0)
                                    return q(B0);
                                  switch (He) {
                                    case 0:
                                      return e4(B0);
                                    case 1:
                                      continue;
                                    case 2:
                                      return y(B0);
                                    case 3:
                                      continue r;
                                    default:
                                      return T(B0);
                                  }
                                }
                              return q(B0);
                            }
                        default:
                          return T(B0);
                      }
                    }
                  case 2:
                    return y(B0);
                  default:
                    return T(B0);
                }
              }
              function G(B0) {
                for (; ; )
                  if (G0(B0, 19), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function A11(B0) {
                G0(B0, 34);
                var D0 = Qv(j(B0));
                if (2 < D0 >>> 0)
                  return q(B0);
                switch (D0) {
                  case 0:
                    return e4(B0);
                  case 1:
                    for (; ; ) {
                      G0(B0, 34);
                      var Le = Mc(j(B0));
                      if (3 < Le >>> 0)
                        return q(B0);
                      switch (Le) {
                        case 0:
                          return e4(B0);
                        case 1:
                          continue;
                        case 2:
                          r:
                            for (; ; ) {
                              if (pn(j(B0)) === 0)
                                for (; ; ) {
                                  G0(B0, 34);
                                  var He = Mc(j(B0));
                                  if (3 < He >>> 0)
                                    return q(B0);
                                  switch (He) {
                                    case 0:
                                      return e4(B0);
                                    case 1:
                                      continue;
                                    case 2:
                                      continue r;
                                    default:
                                      return T(B0);
                                  }
                                }
                              return q(B0);
                            }
                        default:
                          return T(B0);
                      }
                    }
                  default:
                    return T(B0);
                }
              }
              function S11(B0) {
                for (; ; )
                  if (G0(B0, 17), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function M(B0) {
                for (; ; )
                  if (G0(B0, 17), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function K(B0) {
                for (; ; )
                  if (G0(B0, 11), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function V(B0) {
                for (; ; )
                  if (G0(B0, 11), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function f0(B0) {
                for (; ; )
                  if (G0(B0, 15), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function m0(B0) {
                for (; ; )
                  if (G0(B0, 15), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function k0(B0) {
                for (; ; )
                  if (G0(B0, 23), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function g0(B0) {
                for (; ; )
                  if (G0(B0, 23), dn(j(B0)) !== 0)
                    return q(B0);
              }
              function e0(B0) {
                G0(B0, 32);
                var D0 = Bt(j(B0));
                if (D0 === 0) {
                  for (; ; )
                    if (G0(B0, 30), dn(j(B0)) !== 0)
                      return q(B0);
                }
                return D0 === 1 ? e4(B0) : q(B0);
              }
              function x0(B0) {
                r:
                  for (; ; ) {
                    if (pn(j(B0)) === 0)
                      for (; ; ) {
                        G0(B0, 34);
                        var D0 = Rr0(j(B0));
                        if (4 < D0 >>> 0)
                          return q(B0);
                        switch (D0) {
                          case 0:
                            return e4(B0);
                          case 1:
                            return A11(B0);
                          case 2:
                            continue;
                          case 3:
                            continue r;
                          default:
                            return e0(B0);
                        }
                      }
                    return q(B0);
                  }
              }
              gn(n);
              var l = j(n), c0 = ef < l ? vw < l ? -1 : Uk < l ? C3 < l ? Bw < l ? EE < l ? Wy < l ? 1 : 8 : Jd < l ? lE < l ? uF < l ? 1 : 8 : ZT < l ? 1 : 8 : WF < l ? bA < l ? 1 : 8 : sI < l ? 1 : 8 : C6 < l ? E4 < l ? x6 < l ? V8 < l ? j3 < l ? r3 < l ? CO < l ? 1 : 8 : LI < l ? 1 : 8 : Iy < l ? hg < l ? 1 : 8 : Mw < l ? 1 : 8 : L3 < l ? w8 < l ? jg < l ? 1 : 8 : $4 < l ? 1 : 8 : W8 < l ? zT < l ? 1 : 8 : kk < l ? 1 : 8 : O4 < l ? YO < l ? l3 < l ? Qk < l ? 1 : 8 : fk < l ? 1 : 8 : xp < l ? V6 < l ? 1 : 8 : Td < l ? 1 : 8 : G8 < l ? s4 < l ? t6 < l ? 1 : 8 : q6 < l ? 1 : 8 : B6 < l ? S4 < l ? 1 : 8 : fn < l ? 1 : 8 : LE < l ? M4 < l ? g6 < l ? SF < l ? i8 < l ? 1 : 8 : d8 < l ? 1 : 8 : F4 < l ? JF < l ? 1 : 8 : mh < l ? 1 : 8 : U6 < l ? n8 < l ? s3 < l ? 1 : 8 : S8 < l ? 1 : 8 : BS < l ? L8 < l ? 1 : 8 : K3 < l ? 1 : 8 : m8 < l ? f8 < l ? x8 < l ? w3 < l ? 1 : 8 : _6 < l ? 1 : 8 : s6 < l ? oF < l ? 1 : 8 : ZO < l ? 1 : 8 : a3 < l ? DS < l ? e8 < l ? 1 : 8 : g8 < l ? 1 : 8 : J3 < l ? sF < l ? 1 : 8 : ig < l ? 1 : 8 : iw < l ? Ek < l ? wk < l ? qk < l ? FT < l ? Vk < l ? 1 : 8 : uA < l ? 1 : 8 : dy < l ? VS < l ? 1 : 8 : _d2 < l ? 1 : 8 : Th < l ? pF < l ? FE < l ? 1 : 8 : Zw < l ? 1 : 8 : Sy < l ? L_ < l ? 1 : 8 : CE < l ? 1 : 8 : LF2 < l ? Vw < l ? My < l ? rw < l ? 1 : 8 : XI < l ? 1 : 8 : jO < l ? ap < l ? 1 : 8 : jT < l ? 1 : 8 : Ot < l ? OA < l ? gA < l ? 1 : 8 : 1 : 8 : c6 < l ? w6 < l ? l6 < l ? k3 < l ? VE < l ? 1 : 8 : qw < l ? 1 : 8 : v4 < l ? nE < l ? 1 : 8 : Ty < l ? 1 : 8 : c3 < l ? V4 < l ? eg < l ? 1 : 8 : qF < l ? 1 : 8 : X4 < l ? _T < l ? 1 : 8 : Oy < l ? 1 : 8 : D6 < l ? D4 < l ? V3 < l ? MS < l ? 1 : 8 : Ww < l ? 1 : 8 : cy < l ? jy < l ? 1 : 8 : VT < l ? 1 : 8 : B4 < l ? bh < l ? JT < l ? 1 : 8 : G3 < l ? 1 : 8 : r6 < l ? sO < l ? 1 : 8 : ZE < l ? 1 : 8 : uT < l ? Z4 < l ? Yd < l ? Q6 < l ? L4 < l ? N6 < l ? vp < l ? D_ < l ? 1 : 8 : Pd < l ? 1 : 8 : pd < l ? Rg < l ? 1 : 8 : OS < l ? 1 : 8 : G6 < l ? I3 < l ? uk < l ? 1 : 8 : cE < l ? 1 : 8 : l8 < l ? l4 < l ? 1 : 8 : rh < l ? 1 : 8 : M3 < l ? FS < l ? NE < l ? aT < l ? 1 : 8 : kT < l ? 1 : 8 : uS < l ? d3 < l ? 1 : 8 : zd < l ? 1 : 8 : ly < l ? T6 < l ? Pg < l ? 1 : 8 : vy < l ? 1 : 8 : LO < l ? yF < l ? 1 : 8 : YF < l ? 1 : 8 : DI < l ? au < l ? jF < l ? Ah < l ? AO < l ? 1 : 8 : Cd < l ? 1 : 8 : qh < l ? AS < l ? 1 : 8 : lA < l ? 1 : 8 : cO < l ? AI < l ? xI < l ? 1 : 8 : B_ < l ? 1 : 8 : hS < l ? fT < l ? 1 : 8 : mg < l ? 1 : 8 : NO < l ? Nw < l ? Yh < l ? lw < l ? 1 : 8 : Qg < l ? 1 : 8 : Vg < l ? Lk < l ? 1 : 8 : qO < l ? 1 : 8 : iS < l ? b6 < l ? h6 < l ? 1 : 8 : $F < l ? 1 : 8 : ph < l ? rT < l ? 1 : 8 : HS < l ? 1 : 8 : zO < l ? Ck < l ? yS < l ? Iw < l ? CI < l ? Kg < l ? 1 : 8 : VO < l ? 1 : 8 : Mk < l ? ks < l ? 1 : 8 : PF < l ? 1 : 8 : kd < l ? TS < l ? wI < l ? 1 : 8 : xg < l ? 1 : 8 : Rd < l ? dh < l ? 1 : 8 : oI < l ? 1 : 8 : oT < l ? lg < l ? tF < l ? KI < l ? 1 : 8 : pk < l ? 1 : 8 : G_ < l ? kw < l ? 1 : 8 : QF < l ? 1 : 8 : jk < l ? FO < l ? mA < l ? 1 : 8 : _g < l ? 1 : 8 : WE < l ? lF < l ? 1 : 8 : MF < l ? 1 : 8 : h4 < l ? h3 < l ? vT < l ? jI < l ? mS < l ? 1 : 8 : cA < l ? 1 : 8 : DE < l ? zk < l ? 1 : 8 : Lg < l ? 1 : 8 : AT < l ? R6 < l ? bk < l ? 1 : 8 : iT < l ? 1 : 8 : US < l ? BT < l ? 1 : 8 : vE < l ? 1 : 8 : Wc < l ? Sk < l ? D3 < l ? Xg < l ? 1 : 8 : fd < l ? 1 : 8 : IF < l ? ld < l ? 1 : 8 : nA < l ? 1 : 8 : BE < l ? W3 < l ? sy < l ? 1 : 8 : kI < l ? 1 : 8 : VF < l ? fS < l ? 1 : 8 : P4 < l ? 1 : 8 : vS < l ? jw < l ? ik < l ? hO < l ? iI < l ? bg < l ? Nd < l ? 1 : 8 : u3 < l ? 1 : 8 : sE < l ? Ld < l ? 1 : 8 : Xk < l ? 1 : 8 : up < l ? hh < l ? M8 < l ? 1 : 8 : p3 < l ? 1 : 8 : Ew < l ? pE < l ? 1 : 8 : Bg < l ? 1 : 8 : by < l ? Zk < l ? $T < l ? zF < l ? 1 : 8 : Bd < l ? 1 : 8 : $k < l ? TI < l ? 1 : 8 : pO < l ? 1 : 8 : sS < l ? RO < l ? kA < l ? 1 : 8 : wA < l ? 1 : 8 : fg < l ? qI < l ? 1 : 8 : dS < l ? 1 : 8 : hI < l ? NI < l ? nS < l ? Xy < l ? J_ < l ? 1 : 8 : bT < l ? 1 : 8 : $O < l ? Eg < l ? 1 : 8 : oA < l ? 1 : 8 : uE < l ? ET < l ? dg < l ? 1 : 8 : TT < l ? 1 : 8 : Ay < l ? u8 < l ? 1 : 8 : ZS < l ? 1 : 8 : Gh < l ? M_ < l ? SO < l ? lh < l ? 1 : 8 : XE < l ? 1 : 8 : Q3 < l ? Z6 < l ? 1 : 8 : Od < l ? 1 : 8 : W6 < l ? RF < l ? qy < l ? 1 : 8 : Nk < l ? 1 : 8 : PE < l ? Tg < l ? 1 : 8 : OI < l ? 1 : 8 : A8 < l ? P_ < l ? C4 < l ? $g < l ? Uh < l ? WS < l ? 1 : 8 : j6 < l ? 1 : 8 : _E < l ? fI < l ? 1 : 8 : Pw < l ? 1 : 8 : f3 < l ? a8 < l ? UF < l ? 1 : 8 : Lw < l ? 1 : 8 : mk < l ? aI < l ? 1 : 8 : yy < l ? 1 : 8 : O8 < l ? uI < l ? u6 < l ? ky < l ? 1 : 8 : GI < l ? 1 : 8 : c8 < l ? Ow < l ? 1 : 8 : bE < l ? 1 : 8 : y3 < l ? fp < l ? eE < l ? 1 : 8 : I8 < l ? 1 : 8 : cw < l ? KF < l ? 1 : 8 : VI < l ? 1 : 8 : zh < l ? QO < l ? h8 < l ? hy < l ? ew < l ? 1 : 8 : i3 < l ? 1 : 8 : pI < l ? dA < l ? 1 : 8 : qd < l ? 1 : 8 : kg < l ? iE < l ? TO < l ? 1 : 8 : X6 < l ? 1 : 8 : Rw < l ? aw < l ? 1 : 8 : F3 < l ? 1 : 8 : Ik < l ? OF < l ? Ly < l ? m4 < l ? 1 : 8 : cd < l ? 1 : 8 : zg < l ? Jk < l ? 1 : 8 : aS < l ? 1 : 8 : B3 < l ? IO < l ? hw < l ? 1 : 8 : mE < l ? 1 : 8 : $S < l ? QI < l ? 1 : 8 : FA < l ? 1 : 8 : od < l ? KE < l ? Rk < l ? J6 < l ? Md < l ? xF < l ? Zg < l ? sh < l ? eT < l ? 1 : 8 : YI < l ? 1 : 8 : RE < l ? OT < l ? 1 : 8 : J8 < l ? 1 : 8 : IA < l ? dE < l ? qT < l ? 1 : 8 : hd < l ? 1 : 8 : Id < l ? Mh < l ? 1 : 8 : _S < l ? 1 : 8 : EA < l ? PO < l ? Hg < l ? sg < l ? 1 : 8 : Ug < l ? 1 : 8 : Xw < l ? td < l ? 1 : 8 : Dg < l ? 1 : 8 : Ag < l ? bS < l ? Wd < l ? 1 : 8 : Fg < l ? 1 : 8 : tA < l ? wT < l ? 1 : 8 : Dk < l ? 1 : 8 : rS < l ? Z8 < l ? JI < l ? AE < l ? ME < l ? 1 : 8 : pA < l ? 1 : 8 : EO < l ? Gy < l ? 1 : 8 : fA < l ? 1 : 8 : xA < l ? b4 < l ? _k < l ? 1 : 8 : oO < l ? 1 : 8 : wd < l ? S7 < l ? 1 : 8 : $d < l ? 1 : 8 : X8 < l ? z_ < l ? Fd < l ? Ph < l ? 1 : 8 : dT < l ? 1 : 8 : Dd < l ? Ok < l ? 1 : 8 : ah < l ? 1 : 8 : nh < l ? ag < l ? $w < l ? 1 : 8 : WT < l ? 1 : 8 : QS < l ? Fw < l ? 1 : 8 : LT < l ? 1 : 8 : Ih < l ? vk < l ? En < l ? p8 < l ? gT < l ? M6 < l ? 1 : 8 : gh < l ? 1 : 8 : J4 < l ? Q_ < l ? 1 : 8 : op < l ? 1 : 8 : vO < l ? GE < l ? ch < l ? 1 : 8 : q_ < l ? 1 : 8 : ES < l ? UT < l ? 1 : 8 : jS < l ? 1 : 8 : Uw < l ? ty < l ? sA < l ? Vh < l ? 1 : 8 : sT < l ? 1 : 8 : iF < l ? Zd < l ? 1 : 8 : FI < l ? 1 : 8 : xO < l ? th < l ? ng < l ? 1 : 8 : bd < l ? 1 : 8 : iO < l ? _O < l ? 1 : 8 : eO < l ? 1 : 8 : IS < l ? zE < l ? fO < l ? ck < l ? xh < l ? 1 : 8 : ud < l ? 1 : 8 : JS < l ? _w < l ? 1 : 8 : Fy < l ? 1 : 8 : vA < l ? $E < l ? KT < l ? 1 : 8 : rI < l ? 1 : 8 : uy < l ? Tw < l ? 1 : 8 : 1 : nT < l ? Z3 < l ? ek < l ? 8 : $y < l ? 1 : 8 : GF < l ? Qw < l ? 1 : 8 : sk < l ? 1 : 8 : vg < l ? nO < l ? tI < l ? 1 : 8 : GO < l ? 1 : 8 : Ry < l ? 1 : 8 : D8 < l ? Ed < l ? xw < l ? Oh < l ? rA < l ? 8 : $h < l ? tT < l ? 1 : 8 : vF < l ? 1 : 8 : Qy < l ? zI < l ? ry < l ? 1 : 8 : yh < l ? 1 : 8 : HE < l ? Jh < l ? 1 : 8 : hF < l ? 1 : 8 : rp < l ? z4 < l ? S6 < l ? py < l ? 1 : 8 : rg < l ? 1 : 8 : $8 < l ? yO < l ? 1 : 8 : Bk < l ? 1 : 8 : gk < l ? U8 < l ? EF < l ? 1 : 8 : wy < l ? 1 : 8 : og < l ? Tk < l ? 1 : 8 : wE < l ? 1 : 8 : Gw < l ? $_ < l ? ey < l ? pS < l ? oE < l ? 1 : 8 : 1 : 8 : dw < l ? 8 : Q4 < l ? IT < l ? 1 : 8 : yg < l ? 1 : 8 : eI < l ? t3 < l ? Ma < l ? Do < l ? 1 : 2 : BI < l ? 1 : 8 : ow < l ? MT < l ? 1 : 8 : YS < l ? 1 : 8 : yI < l ? tS < l ? Zh < l ? 1 : 8 : CT < l ? 1 : 8 : GT < l ? Kw < l ? 1 : 8 : SI < l ? 1 : 8 : UI < l ? tk < l ? Qn < l ? R4 < l ? q3 < l ? id < l ? 1 : 8 : _F < l ? 1 : 8 : z3 < l ? L6 < l ? 1 : 8 : fh < l ? 1 : 8 : PT < l ? ip < l ? uw < l ? 1 : 8 : eS < l ? 1 : 8 : tO < l ? e3 < l ? 1 : 8 : oh < l ? 1 : 8 : dk < l ? zS < l ? Qh < l ? ug < l ? 1 : 8 : iy < l ? 1 : 8 : Wk < l ? Kd < l ? 1 : 8 : TE < l ? 1 : 8 : dd < l ? my < l ? cF < l ? 1 : 8 : _A < l ? 1 : 8 : Ny < l ? 1 : 8 : Xd < l ? H3 < l ? o3 < l ? Jw < l ? 1 : 8 : av < l ? 8 : RT < l ? 1 : 8 : gF < l ? k6 < l ? NF < l ? 1 : 8 : Wh < l ? 1 : 8 : Gk < l ? Dh < l ? 1 : 8 : ZI < l ? 1 : 8 : Vd < l ? cS < l ? lT < l ? cI < l ? 1 : 8 : 1 : Dy < l ? 8 : Jy < l ? 1 : 8 : FF < l ? sd < l ? 1 : 8 : XT < l ? OO < l ? 1 : 8 : aO < l ? 1 : 8 : wh < l ? F8 < l ? W_ < l ? uh < l ? kO < l ? ed < l ? EI < l ? Aw < l ? 1 : 8 : yA < l ? 1 : 8 : Bh < l ? fy < l ? 1 : 8 : ak < l ? 1 : 8 : CF < l ? TA < l ? lp < l ? 1 : 8 : 1 : 8 : yT < l ? Hd < l ? kS < l ? zy < l ? 1 : 8 : wS < l ? 1 : 8 : v6 < l ? Hk < l ? 1 : 8 : kE < l ? 1 : 8 : Sw < l ? pw < l ? 1 : 8 : _h < l ? WO < l ? 1 : 8 : k8 < l ? 1 : 8 : kF < l ? DO < l ? XF < l ? gy < l ? Sd < l ? 1 : 8 : eA < l ? 1 : 8 : Z_ < l ? JE < l ? 1 : 8 : ay < l ? 1 : 8 : Ky < l ? _8 < l ? Uy < l ? 1 : 8 : n3 < l ? 1 : 8 : rE < l ? oy < l ? 1 : 8 : cg < l ? 1 : 8 : Yy < l ? SA < l ? xS < l ? rF < l ? 1 : 8 : Xh < l ? 1 : 8 : mI < l ? lk < l ? 1 : 8 : uO < l ? 1 : 8 : PS < l && aA < l ? 1 : 8 : yk < l ? Rh < l ? tg < l ? nk < l ? 8 : Zy < l ? bI < l ? 1 : 8 : Ch < l ? 1 : 8 : xE < l ? ok < l ? V_ < l ? 1 : 8 : 1 : 8 : Og < l ? UO < l && oS < l ? 1 : 8 : bw < l ? rO < l ? Lh < l ? 1 : 8 : 1 : dF < l ? 8 : 1 : Eh < l ? gE < l ? U3 < l ? 8 : tw < l ? 1 : 8 : dI < l ? Qd < l ? wO < l ? 1 : 8 : R_ < l ? 1 : 8 : Sh < l ? 1 : 8 : BF < l ? gg < l ? Ad < l ? 1 : 8 : XS < l ? 1 : 8 : Kk < l ? YE < l ? 8 : ih < l ? 1 : 8 : U_ < l ? yE < l ? 1 : 8 : Ht < l ? 1 : 8 : GS < l ? jE < l ? dO < l ? q4 < l ? Ey < l ? E8 < l ? RI < l ? 1 : 8 : nF < l ? 1 : 8 : HF < l ? 1 : 8 : ww < l ? E3 < l ? de < l ? 1 : 8 : 1 : 8 : Ig < l ? Gd < l ? X_ < l ? H_ < l ? 1 : 8 : 1 : 8 : Hw < l ? T3 < l ? vd < l ? 1 : 8 : fF < l ? 1 : 8 : wg < l ? 1 : 8 : z8 < l ? j8 < l ? Eo < l ? PI < l ? 8 : Qx < l ? 1 : 2 : F6 < l ? By < l ? 1 : 8 : IE < l ? 1 : 8 : K8 < l ? z6 < l ? Cg < l ? 1 : 8 : cT < l ? 1 : 8 : o8 < l ? tt < l ? 1 : 8 : Ak < l ? 1 : 8 : NS < l ? tE < l ? j4 < l ? Ng < l ? 1 : 8 : $I < l ? 1 : 8 : P6 < l ? TF < l ? 1 : 8 : p4 < l ? 1 : 8 : _I < l ? fE < l ? gI < l ? 1 : 8 : N3 < l ? 1 : 8 : G4 < l ? B8 < l ? 1 : 8 : Sg < l ? 1 : 8 : N8 < l ? QE < l ? aE < l ? Yk < l ? pT < l ? K_ < l ? 1 : 8 : wF < l ? 1 : 8 : UE < l ? 1 : 8 : rd < l ? vI < l ? 8 : 1 : 8 : MO < l ? mw < l ? YT < l ? s8 < l ? 1 : 8 : AA < l ? 1 : 8 : Yw < l ? Y_ < l ? 1 : 8 : 1 : 8 : Gg < l ? JO < l ? $3 < l ? sp < l ? P8 < l ? 1 : 8 : Q8 < l ? 1 : 8 : gr < l ? t8 < l ? 1 : 8 : 1 : g4 < l ? KS < l ? 8 : m6 < l ? 1 : 8 : mF < l ? Cy < l ? 1 : 8 : R3 < l ? 1 : 8 : Pk < l ? HI < l ? QT < l ? x3 < l ? 1 : 8 : mO < l ? 1 : 8 : Py < l ? O3 < l ? 1 : 8 : ep < l ? 1 : 8 : mo < l ? xc < l ? ox < l ? 1 : 2 : fo < l ? 1 : 2 : $u < l ? Hu < l ? 1 : 3 : Co < l ? 1 : 2 : Vr(ILr, l + 1 | 0) - 1 | 0;
              if (36 < c0 >>> 0)
                var t0 = q(n);
              else
                switch (c0) {
                  case 0:
                    var t0 = 98;
                    break;
                  case 1:
                    var t0 = 99;
                    break;
                  case 2:
                    if (G0(n, 1), jc(j(n)) === 0) {
                      for (; ; )
                        if (G0(n, 1), jc(j(n)) !== 0) {
                          var t0 = q(n);
                          break;
                        }
                    } else
                      var t0 = q(n);
                    break;
                  case 3:
                    var t0 = 0;
                    break;
                  case 4:
                    G0(n, 0);
                    var o0 = xi(j(n)) !== 0 ? 1 : 0, t0 = o0 && q(n);
                    break;
                  case 5:
                    G0(n, 88);
                    var t0 = Ui(j(n)) === 0 ? (G0(n, 58), Ui(j(n)) === 0 ? 54 : q(n)) : q(n);
                    break;
                  case 6:
                    var t0 = 7;
                    break;
                  case 7:
                    G0(n, 95);
                    var w0 = j(n), _0 = 32 < w0 ? 33 < w0 ? -1 : 0 : -1, t0 = _0 === 0 ? 6 : q(n);
                    break;
                  case 8:
                    var t0 = 97;
                    break;
                  case 9:
                    G0(n, 84);
                    var t0 = Ui(j(n)) === 0 ? 71 : q(n);
                    break;
                  case 10:
                    G0(n, 86);
                    var E0 = j(n), U0 = 37 < E0 ? 61 < E0 ? -1 : Vr(pRr, E0 - 38 | 0) - 1 | 0 : -1, t0 = U0 === 0 ? (G0(n, 51), Ui(j(n)) === 0 ? 76 : q(n)) : U0 === 1 ? 72 : q(n);
                    break;
                  case 11:
                    var t0 = 38;
                    break;
                  case 12:
                    var t0 = 39;
                    break;
                  case 13:
                    G0(n, 82);
                    var b = Ir0(j(n));
                    if (2 < b >>> 0)
                      var t0 = q(n);
                    else
                      switch (b) {
                        case 0:
                          G0(n, 83);
                          var t0 = Ui(j(n)) === 0 ? 70 : q(n);
                          break;
                        case 1:
                          var t0 = 4;
                          break;
                        default:
                          var t0 = 69;
                      }
                    break;
                  case 14:
                    G0(n, 80);
                    var R0 = j(n), X = 42 < R0 ? 61 < R0 ? -1 : Vr(mRr, R0 + xy | 0) - 1 | 0 : -1, t0 = X === 0 ? 59 : X === 1 ? 67 : q(n);
                    break;
                  case 15:
                    var t0 = 45;
                    break;
                  case 16:
                    G0(n, 81);
                    var s0 = j(n), hr = 44 < s0 ? 61 < s0 ? -1 : Vr(eLr, s0 + mv | 0) - 1 | 0 : -1, t0 = hr === 0 ? 60 : hr === 1 ? 68 : q(n);
                    break;
                  case 17:
                    G0(n, 43);
                    var Ar = D1(j(n));
                    if (Ar === 0)
                      var t0 = cL(j(n)) === 0 ? 42 : q(n);
                    else if (Ar === 1)
                      for (; ; ) {
                        G0(n, 34);
                        var or = Ps(j(n));
                        if (4 < or >>> 0)
                          var t0 = q(n);
                        else
                          switch (or) {
                            case 0:
                              var t0 = e4(n);
                              break;
                            case 1:
                              continue;
                            case 2:
                              var t0 = y(n);
                              break;
                            case 3:
                              r:
                                for (; ; ) {
                                  if (pn(j(n)) === 0)
                                    for (; ; ) {
                                      G0(n, 34);
                                      var W0 = Ps(j(n));
                                      if (4 < W0 >>> 0)
                                        var Lr = q(n);
                                      else
                                        switch (W0) {
                                          case 0:
                                            var Lr = e4(n);
                                            break;
                                          case 1:
                                            continue;
                                          case 2:
                                            var Lr = y(n);
                                            break;
                                          case 3:
                                            continue r;
                                          default:
                                            var Lr = T(n);
                                        }
                                      break;
                                    }
                                  else
                                    var Lr = q(n);
                                  var t0 = Lr;
                                  break;
                                }
                              break;
                            default:
                              var t0 = T(n);
                          }
                        break;
                      }
                    else
                      var t0 = q(n);
                    break;
                  case 18:
                    G0(n, 93);
                    var Tr = Ir0(j(n));
                    if (2 < Tr >>> 0)
                      var t0 = q(n);
                    else
                      switch (Tr) {
                        case 0:
                          G0(n, 2);
                          var Hr = i9(j(n));
                          if (2 < Hr >>> 0)
                            var t0 = q(n);
                          else
                            switch (Hr) {
                              case 0:
                                for (; ; ) {
                                  var Or = i9(j(n));
                                  if (2 < Or >>> 0)
                                    var t0 = q(n);
                                  else
                                    switch (Or) {
                                      case 0:
                                        continue;
                                      case 1:
                                        var t0 = E(n);
                                        break;
                                      default:
                                        var t0 = d(n);
                                    }
                                  break;
                                }
                                break;
                              case 1:
                                var t0 = E(n);
                                break;
                              default:
                                var t0 = d(n);
                            }
                          break;
                        case 1:
                          var t0 = 5;
                          break;
                        default:
                          var t0 = 92;
                      }
                    break;
                  case 19:
                    G0(n, 34);
                    var fr = lL(j(n));
                    if (8 < fr >>> 0)
                      var t0 = q(n);
                    else
                      switch (fr) {
                        case 0:
                          var t0 = e4(n);
                          break;
                        case 1:
                          var t0 = w(n);
                          break;
                        case 2:
                          for (; ; ) {
                            G0(n, 20);
                            var Rr = Mr0(j(n));
                            if (4 < Rr >>> 0)
                              var t0 = q(n);
                            else
                              switch (Rr) {
                                case 0:
                                  var t0 = G(n);
                                  break;
                                case 1:
                                  var t0 = A11(n);
                                  break;
                                case 2:
                                  continue;
                                case 3:
                                  for (; ; ) {
                                    G0(n, 18);
                                    var Wr = u9(j(n));
                                    if (3 < Wr >>> 0)
                                      var t0 = q(n);
                                    else
                                      switch (Wr) {
                                        case 0:
                                          var t0 = S11(n);
                                          break;
                                        case 1:
                                          var t0 = A11(n);
                                          break;
                                        case 2:
                                          continue;
                                        default:
                                          G0(n, 17);
                                          var Jr = Bt(j(n));
                                          if (Jr === 0) {
                                            for (; ; )
                                              if (G0(n, 17), dn(j(n)) !== 0) {
                                                var t0 = q(n);
                                                break;
                                              }
                                          } else
                                            var t0 = Jr === 1 ? S11(n) : q(n);
                                      }
                                    break;
                                  }
                                  break;
                                default:
                                  G0(n, 19);
                                  var ar = Bt(j(n));
                                  if (ar === 0) {
                                    for (; ; )
                                      if (G0(n, 19), dn(j(n)) !== 0) {
                                        var t0 = q(n);
                                        break;
                                      }
                                  } else
                                    var t0 = ar === 1 ? G(n) : q(n);
                              }
                            break;
                          }
                          break;
                        case 3:
                          for (; ; ) {
                            G0(n, 18);
                            var _r = u9(j(n));
                            if (3 < _r >>> 0)
                              var t0 = q(n);
                            else
                              switch (_r) {
                                case 0:
                                  var t0 = M(n);
                                  break;
                                case 1:
                                  var t0 = A11(n);
                                  break;
                                case 2:
                                  continue;
                                default:
                                  G0(n, 17);
                                  var Ir = Bt(j(n));
                                  if (Ir === 0) {
                                    for (; ; )
                                      if (G0(n, 17), dn(j(n)) !== 0) {
                                        var t0 = q(n);
                                        break;
                                      }
                                  } else
                                    var t0 = Ir === 1 ? M(n) : q(n);
                              }
                            break;
                          }
                          break;
                        case 4:
                          G0(n, 33);
                          var fe = Pr0(j(n));
                          if (fe === 0)
                            var t0 = e4(n);
                          else if (fe === 1)
                            for (; ; ) {
                              G0(n, 12);
                              var v0 = k9(j(n));
                              if (3 < v0 >>> 0)
                                var t0 = q(n);
                              else
                                switch (v0) {
                                  case 0:
                                    var t0 = K(n);
                                    break;
                                  case 1:
                                    continue;
                                  case 2:
                                    r:
                                      for (; ; ) {
                                        if (Gc(j(n)) === 0)
                                          for (; ; ) {
                                            G0(n, 12);
                                            var P = k9(j(n));
                                            if (3 < P >>> 0)
                                              var Q = q(n);
                                            else
                                              switch (P) {
                                                case 0:
                                                  var Q = V(n);
                                                  break;
                                                case 1:
                                                  continue;
                                                case 2:
                                                  continue r;
                                                default:
                                                  G0(n, 10);
                                                  var L = Bt(j(n));
                                                  if (L === 0) {
                                                    for (; ; )
                                                      if (G0(n, 9), dn(j(n)) !== 0) {
                                                        var Q = q(n);
                                                        break;
                                                      }
                                                  } else
                                                    var Q = L === 1 ? V(n) : q(n);
                                              }
                                            break;
                                          }
                                        else
                                          var Q = q(n);
                                        var t0 = Q;
                                        break;
                                      }
                                    break;
                                  default:
                                    G0(n, 10);
                                    var i0 = Bt(j(n));
                                    if (i0 === 0) {
                                      for (; ; )
                                        if (G0(n, 9), dn(j(n)) !== 0) {
                                          var t0 = q(n);
                                          break;
                                        }
                                    } else
                                      var t0 = i0 === 1 ? K(n) : q(n);
                                }
                              break;
                            }
                          else
                            var t0 = q(n);
                          break;
                        case 5:
                          var t0 = y(n);
                          break;
                        case 6:
                          G0(n, 33);
                          var l0 = Dr0(j(n));
                          if (l0 === 0)
                            var t0 = e4(n);
                          else if (l0 === 1)
                            for (; ; ) {
                              G0(n, 16);
                              var S0 = h9(j(n));
                              if (3 < S0 >>> 0)
                                var t0 = q(n);
                              else
                                switch (S0) {
                                  case 0:
                                    var t0 = f0(n);
                                    break;
                                  case 1:
                                    continue;
                                  case 2:
                                    r:
                                      for (; ; ) {
                                        if (zu(j(n)) === 0)
                                          for (; ; ) {
                                            G0(n, 16);
                                            var T0 = h9(j(n));
                                            if (3 < T0 >>> 0)
                                              var L0 = q(n);
                                            else
                                              switch (T0) {
                                                case 0:
                                                  var L0 = m0(n);
                                                  break;
                                                case 1:
                                                  continue;
                                                case 2:
                                                  continue r;
                                                default:
                                                  G0(n, 14);
                                                  var rr = Bt(j(n));
                                                  if (rr === 0) {
                                                    for (; ; )
                                                      if (G0(n, 13), dn(j(n)) !== 0) {
                                                        var L0 = q(n);
                                                        break;
                                                      }
                                                  } else
                                                    var L0 = rr === 1 ? m0(n) : q(n);
                                              }
                                            break;
                                          }
                                        else
                                          var L0 = q(n);
                                        var t0 = L0;
                                        break;
                                      }
                                    break;
                                  default:
                                    G0(n, 14);
                                    var B = Bt(j(n));
                                    if (B === 0) {
                                      for (; ; )
                                        if (G0(n, 13), dn(j(n)) !== 0) {
                                          var t0 = q(n);
                                          break;
                                        }
                                    } else
                                      var t0 = B === 1 ? f0(n) : q(n);
                                }
                              break;
                            }
                          else
                            var t0 = q(n);
                          break;
                        case 7:
                          G0(n, 33);
                          var Z7 = Er0(j(n));
                          if (Z7 === 0)
                            var t0 = e4(n);
                          else if (Z7 === 1)
                            for (; ; ) {
                              G0(n, 24);
                              var p0 = w9(j(n));
                              if (3 < p0 >>> 0)
                                var t0 = q(n);
                              else
                                switch (p0) {
                                  case 0:
                                    var t0 = k0(n);
                                    break;
                                  case 1:
                                    continue;
                                  case 2:
                                    r:
                                      for (; ; ) {
                                        if (Nn(j(n)) === 0)
                                          for (; ; ) {
                                            G0(n, 24);
                                            var b0 = w9(j(n));
                                            if (3 < b0 >>> 0)
                                              var M0 = q(n);
                                            else
                                              switch (b0) {
                                                case 0:
                                                  var M0 = g0(n);
                                                  break;
                                                case 1:
                                                  continue;
                                                case 2:
                                                  continue r;
                                                default:
                                                  G0(n, 22);
                                                  var O0 = Bt(j(n));
                                                  if (O0 === 0) {
                                                    for (; ; )
                                                      if (G0(n, 21), dn(j(n)) !== 0) {
                                                        var M0 = q(n);
                                                        break;
                                                      }
                                                  } else
                                                    var M0 = O0 === 1 ? g0(n) : q(n);
                                              }
                                            break;
                                          }
                                        else
                                          var M0 = q(n);
                                        var t0 = M0;
                                        break;
                                      }
                                    break;
                                  default:
                                    G0(n, 22);
                                    var er = Bt(j(n));
                                    if (er === 0) {
                                      for (; ; )
                                        if (G0(n, 21), dn(j(n)) !== 0) {
                                          var t0 = q(n);
                                          break;
                                        }
                                    } else
                                      var t0 = er === 1 ? k0(n) : q(n);
                                }
                              break;
                            }
                          else
                            var t0 = q(n);
                          break;
                        default:
                          var t0 = e0(n);
                      }
                    break;
                  case 20:
                    G0(n, 34);
                    var yr = o9(j(n));
                    if (5 < yr >>> 0)
                      var t0 = q(n);
                    else
                      switch (yr) {
                        case 0:
                          var t0 = e4(n);
                          break;
                        case 1:
                          var t0 = w(n);
                          break;
                        case 2:
                          for (; ; ) {
                            G0(n, 34);
                            var vr = o9(j(n));
                            if (5 < vr >>> 0)
                              var t0 = q(n);
                            else
                              switch (vr) {
                                case 0:
                                  var t0 = e4(n);
                                  break;
                                case 1:
                                  var t0 = w(n);
                                  break;
                                case 2:
                                  continue;
                                case 3:
                                  var t0 = y(n);
                                  break;
                                case 4:
                                  var t0 = x0(n);
                                  break;
                                default:
                                  var t0 = e0(n);
                              }
                            break;
                          }
                          break;
                        case 3:
                          var t0 = y(n);
                          break;
                        case 4:
                          var t0 = x0(n);
                          break;
                        default:
                          var t0 = e0(n);
                      }
                    break;
                  case 21:
                    var t0 = 46;
                    break;
                  case 22:
                    var t0 = 44;
                    break;
                  case 23:
                    G0(n, 78);
                    var $0 = j(n), Er = 59 < $0 ? 61 < $0 ? -1 : Vr(rN, $0 - 60 | 0) - 1 | 0 : -1, t0 = Er === 0 ? (G0(n, 62), Ui(j(n)) === 0 ? 61 : q(n)) : Er === 1 ? 55 : q(n);
                    break;
                  case 24:
                    G0(n, 90);
                    var Mr = sL(j(n)), t0 = Mr === 0 ? (G0(n, 57), Ui(j(n)) === 0 ? 53 : q(n)) : Mr === 1 ? 91 : q(n);
                    break;
                  case 25:
                    G0(n, 79);
                    var Br = sL(j(n));
                    if (Br === 0)
                      var t0 = 56;
                    else if (Br === 1) {
                      G0(n, 66);
                      var qr = sL(j(n)), t0 = qr === 0 ? 63 : qr === 1 ? (G0(n, 65), Ui(j(n)) === 0 ? 64 : q(n)) : q(n);
                    } else
                      var t0 = q(n);
                    break;
                  case 26:
                    G0(n, 50);
                    var jr = j(n), $r = 45 < jr ? 63 < jr ? -1 : Vr(zDr, jr + v1 | 0) - 1 | 0 : -1, t0 = $r === 0 ? (G0(n, 48), pn(j(n)) === 0 ? 47 : q(n)) : $r === 1 ? (G0(n, 49), Ui(j(n)) === 0 ? 75 : q(n)) : q(n);
                    break;
                  case 27:
                    G0(n, 94);
                    var ne = j(n), Qr = 63 < ne ? 64 < ne ? -1 : 0 : -1;
                    if (Qr === 0) {
                      var be = j(n), ae = 96 < be ? j7 < be ? -1 : Vr(VLr, be + Y3 | 0) - 1 | 0 : -1;
                      if (ae === 0)
                        if (gr0(j(n)) === 0) {
                          var pe = j(n), oe = uc < pe ? tl < pe ? -1 : 0 : -1;
                          if (oe === 0 && vL(j(n)) === 0 && Bl(j(n)) === 0)
                            var ce = j(n), ge = 72 < ce ? 73 < ce ? -1 : 0 : -1, t0 = ge === 0 && s9(j(n)) === 0 && Ul(j(n)) === 0 && y9(j(n)) === 0 && Lr0(j(n)) === 0 && s9(j(n)) === 0 && v9(j(n)) === 0 && y9(j(n)) === 0 ? 35 : q(n);
                          else
                            var t0 = q(n);
                        } else
                          var t0 = q(n);
                      else
                        var t0 = ae === 1 && s9(j(n)) === 0 && Ul(j(n)) === 0 && y9(j(n)) === 0 && Lr0(j(n)) === 0 && s9(j(n)) === 0 && v9(j(n)) === 0 && y9(j(n)) === 0 ? 35 : q(n);
                    } else
                      var t0 = q(n);
                    break;
                  case 28:
                    var t0 = 40;
                    break;
                  case 29:
                    if (G0(n, 96), Ls(j(n)) === 0) {
                      var q0 = L1(j(n));
                      if (q0 === 0)
                        var t0 = Nn(j(n)) === 0 && Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 97 : q(n);
                      else if (q0 === 1 && Nn(j(n)) === 0)
                        for (; ; ) {
                          var Fr = A1(j(n));
                          if (Fr !== 0) {
                            var t0 = Fr === 1 ? 97 : q(n);
                            break;
                          }
                        }
                      else
                        var t0 = q(n);
                    } else
                      var t0 = q(n);
                    break;
                  case 30:
                    var t0 = 41;
                    break;
                  case 31:
                    G0(n, 87);
                    var t0 = Ui(j(n)) === 0 ? 74 : q(n);
                    break;
                  case 32:
                    var t0 = 8;
                    break;
                  case 33:
                    var t0 = 36;
                    break;
                  case 34:
                    G0(n, 85);
                    var _ = j(n), k = 60 < _ ? X2 < _ ? -1 : Vr(_Rr, _ + SS | 0) - 1 | 0 : -1, t0 = k === 0 ? 73 : k === 1 ? (G0(n, 52), Ui(j(n)) === 0 ? 77 : q(n)) : q(n);
                    break;
                  case 35:
                    var t0 = 37;
                    break;
                  default:
                    var t0 = 89;
                }
              if (99 < t0 >>> 0)
                return ke(vPr);
              var I = t0;
              if (50 <= I)
                switch (I) {
                  case 50:
                    return [0, t4, 85];
                  case 51:
                    return [0, t4, 88];
                  case 52:
                    return [0, t4, 87];
                  case 53:
                    return [0, t4, 94];
                  case 54:
                    return [0, t4, 95];
                  case 55:
                    return [0, t4, 96];
                  case 56:
                    return [0, t4, 97];
                  case 57:
                    return [0, t4, 92];
                  case 58:
                    return [0, t4, 93];
                  case 59:
                    return [0, t4, cf];
                  case 60:
                    return [0, t4, T7];
                  case 61:
                    return [0, t4, 69];
                  case 62:
                    return [0, t4, ti];
                  case 63:
                    return [0, t4, 68];
                  case 64:
                    return [0, t4, 67];
                  case 65:
                    return [0, t4, Ri];
                  case 66:
                    return [0, t4, R7];
                  case 67:
                    return [0, t4, 78];
                  case 68:
                    return [0, t4, 77];
                  case 69:
                    return [0, t4, 75];
                  case 70:
                    return [0, t4, 76];
                  case 71:
                    return [0, t4, 73];
                  case 72:
                    return [0, t4, 72];
                  case 73:
                    return [0, t4, 71];
                  case 74:
                    return [0, t4, 70];
                  case 75:
                    return [0, t4, 79];
                  case 76:
                    return [0, t4, 80];
                  case 77:
                    return [0, t4, 81];
                  case 78:
                    return [0, t4, 98];
                  case 79:
                    return [0, t4, 99];
                  case 80:
                    return [0, t4, s7];
                  case 81:
                    return [0, t4, L7];
                  case 82:
                    return [0, t4, Yt];
                  case 83:
                    return [0, t4, Zc];
                  case 84:
                    return [0, t4, is];
                  case 85:
                    return [0, t4, 89];
                  case 86:
                    return [0, t4, 91];
                  case 87:
                    return [0, t4, 90];
                  case 88:
                    return [0, t4, Fv];
                  case 89:
                    return [0, t4, Xt];
                  case 90:
                    return [0, t4, 82];
                  case 91:
                    return [0, t4, 11];
                  case 92:
                    return [0, t4, 74];
                  case 93:
                    return [0, t4, j7];
                  case 94:
                    return [0, t4, 13];
                  case 95:
                    return [0, t4, 14];
                  case 96:
                    return [2, Ei(t4, nt(t4, n))];
                  case 97:
                    var U = n[6];
                    Hr0(n);
                    var Y = Hl(t4, U, n[3]);
                    tL(n, U);
                    var y0 = Ll(n), P0 = Wr0(t4, y0), I0 = P0[2], D = Ee(I0, yPr);
                    if (0 <= D) {
                      if (!(0 < D))
                        return [0, t4, 18];
                      var u0 = Ee(I0, XPr);
                      if (0 <= u0) {
                        if (!(0 < u0))
                          return [0, t4, 51];
                        var X0 = Ee(I0, tDr);
                        if (0 <= X0) {
                          if (!(0 < X0))
                            return [0, t4, 46];
                          if (!n0(I0, cDr))
                            return [0, t4, 24];
                          if (!n0(I0, sDr))
                            return [0, t4, 47];
                          if (!n0(I0, vDr))
                            return [0, t4, 25];
                          if (!n0(I0, lDr))
                            return [0, t4, 26];
                          if (!n0(I0, bDr))
                            return [0, t4, 58];
                        } else {
                          if (!n0(I0, uDr))
                            return [0, t4, 20];
                          if (!n0(I0, iDr))
                            return [0, t4, 21];
                          if (!n0(I0, fDr))
                            return [0, t4, 22];
                          if (!n0(I0, xDr))
                            return [0, t4, 31];
                          if (!n0(I0, oDr))
                            return [0, t4, 23];
                          if (!n0(I0, aDr))
                            return [0, t4, 61];
                        }
                      } else {
                        var J0 = Ee(I0, YPr);
                        if (0 <= J0) {
                          if (!(0 < J0))
                            return [0, t4, 54];
                          if (!n0(I0, ZPr))
                            return [0, t4, 55];
                          if (!n0(I0, QPr))
                            return [0, t4, 56];
                          if (!n0(I0, rDr))
                            return [0, t4, 57];
                          if (!n0(I0, eDr))
                            return [0, t4, 19];
                          if (!n0(I0, nDr))
                            return [0, t4, 42];
                        } else {
                          if (!n0(I0, VPr))
                            return [0, t4, 53];
                          if (!n0(I0, zPr))
                            return [0, t4, 28];
                          if (!n0(I0, KPr))
                            return [0, t4, 44];
                          if (!n0(I0, WPr))
                            return [0, t4, 29];
                          if (!n0(I0, JPr))
                            return [0, t4, 63];
                          if (!n0(I0, $Pr))
                            return [0, t4, 62];
                        }
                      }
                    } else {
                      var ir = Ee(I0, hPr);
                      if (0 <= ir) {
                        if (!(0 < ir))
                          return [0, t4, 37];
                        var Q0 = Ee(I0, CPr);
                        if (0 <= Q0) {
                          if (!(0 < Q0))
                            return [0, t4, 39];
                          if (!n0(I0, MPr))
                            return [0, t4, 15];
                          if (!n0(I0, BPr))
                            return [0, t4, 16];
                          if (!n0(I0, qPr))
                            return [0, t4, 52];
                          if (!n0(I0, UPr))
                            return [0, t4, 50];
                          if (!n0(I0, HPr))
                            return [0, t4, 17];
                        } else {
                          if (!n0(I0, PPr))
                            return [0, t4, 43];
                          if (!n0(I0, DPr))
                            return [0, t4, 48];
                          if (!n0(I0, LPr))
                            return [0, t4, 49];
                          if (!n0(I0, RPr))
                            return [0, t4, 41];
                          if (!n0(I0, jPr))
                            return [0, t4, 30];
                          if (!n0(I0, GPr))
                            return [0, t4, 38];
                        }
                      } else {
                        var F0 = Ee(I0, dPr);
                        if (0 <= F0) {
                          if (!(0 < F0))
                            return [0, t4, 27];
                          if (!n0(I0, TPr))
                            return [0, t4, 35];
                          if (!n0(I0, OPr))
                            return [0, t4, 59];
                          if (!n0(I0, IPr))
                            return [0, t4, 60];
                          if (!n0(I0, APr))
                            return [0, t4, 36];
                          if (!n0(I0, NPr))
                            return [0, t4, 45];
                        } else {
                          if (!n0(I0, kPr))
                            return [0, t4, 64];
                          if (!n0(I0, wPr))
                            return [0, t4, 65];
                          if (!n0(I0, EPr))
                            return [0, t4, 32];
                          if (!n0(I0, SPr))
                            return [0, t4, 33];
                          if (!n0(I0, gPr))
                            return [0, t4, 34];
                          if (!n0(I0, FPr))
                            return [0, t4, 40];
                        }
                      }
                    }
                    var Sr = [4, Y, I0, uL(y0)];
                    return [0, P0[1], Sr];
                  case 98:
                    var mr = t4[4] ? Gu(t4, nt(t4, n), 6) : t4;
                    return [0, mr, Pn];
                  default:
                    var Cr = Ei(t4, nt(t4, n));
                    return [0, Cr, [6, Se(n)]];
                }
              switch (I) {
                case 0:
                  return [2, d7(t4, n)];
                case 1:
                  return [2, t4];
                case 2:
                  var sr = ju(t4, n), Pr = $n(zn), K0 = R1(t4, Pr, n), Ur = K0[1];
                  return [1, Ur, Si(Ur, sr, K0[2], Pr, 1)];
                case 3:
                  var h0 = Se(n);
                  if (t4[5]) {
                    var Kr = t4[4] ? Yr0(t4, nt(t4, n), h0) : t4, re = $m(1, Kr), xe = Jm(n);
                    return qn(jl(n, xe - 1 | 0, 1), lPr) && n0(jl(n, xe - 2 | 0, 1), bPr) ? [0, re, 86] : [2, re];
                  }
                  var Re = ju(t4, n), ve = $n(zn);
                  hn(ve, m7(h0, 2, un(h0) - 2 | 0));
                  var Ie = R1(t4, ve, n), Ge = Ie[1];
                  return [1, Ge, Si(Ge, Re, Ie[2], ve, 1)];
                case 4:
                  if (t4[4])
                    return [2, $m(0, t4)];
                  $v(n), gn(n);
                  var Me = Tr0(j(n)) !== 0 ? 1 : 0, an = Me && q(n);
                  return an === 0 ? [0, t4, Yt] : ke(pPr);
                case 5:
                  var We = ju(t4, n), Ae = $n(zn), cn = e2(t4, Ae, n), rn = cn[1];
                  return [1, rn, Si(rn, We, cn[2], Ae, 0)];
                case 6:
                  return n[6] === 0 ? [2, e2(t4, $n(zn), n)[1]] : [0, t4, mPr];
                case 7:
                  var kn = Se(n), vn = ju(t4, n), Ne = $n(zn), Je = $n(zn);
                  hn(Je, kn);
                  var en = $r0(t4, kn, Ne, Je, 0, n), _n = en[1], Cn = [0, _n[1], vn, en[2]], Hn = en[3], Fn = Mt(Je);
                  return [0, _n, [2, [0, Cn, Mt(Ne), Fn, Hn]]];
                case 8:
                  var vt = $n(zn), Nt = $n(zn), gt = $n(zn);
                  Gl(n, gt);
                  var Zt = ju(t4, n), qt = Zr0(t4, vt, Nt, gt, n), Ft = qt[1], Ct = h7(Ft, n), du = [0, Ft[1], Zt, Ct], Wu = qt[2], lt = Mt(gt), ou = Mt(Nt);
                  return [0, Ft, [3, [0, du, [0, Mt(vt), ou, lt], Wu]]];
                case 9:
                  return Rt(t4, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && c9(j(D0)) === 0 && Gc(j(D0)) === 0)
                      for (; ; ) {
                        var Le = n9(j(D0));
                        if (2 < Le >>> 0)
                          var me = q(D0);
                        else
                          switch (Le) {
                            case 0:
                              continue;
                            case 1:
                              r:
                                for (; ; ) {
                                  if (Gc(j(D0)) === 0)
                                    for (; ; ) {
                                      var He = n9(j(D0));
                                      if (2 < He >>> 0)
                                        var he = q(D0);
                                      else
                                        switch (He) {
                                          case 0:
                                            continue;
                                          case 1:
                                            continue r;
                                          default:
                                            var he = 0;
                                        }
                                      break;
                                    }
                                  else
                                    var he = q(D0);
                                  var me = he;
                                  break;
                                }
                              break;
                            default:
                              var me = 0;
                          }
                        break;
                      }
                    else
                      var me = q(D0);
                    return me === 0 ? [0, B0, [1, 0, Se(D0)]] : ke(sPr);
                  });
                case 10:
                  return [0, t4, [1, 0, Se(n)]];
                case 11:
                  return Rt(t4, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && c9(j(D0)) === 0 && Gc(j(D0)) === 0)
                      for (; ; ) {
                        G0(D0, 0);
                        var Le = e9(j(D0));
                        if (Le !== 0) {
                          if (Le === 1)
                            r:
                              for (; ; ) {
                                if (Gc(j(D0)) === 0)
                                  for (; ; ) {
                                    G0(D0, 0);
                                    var He = e9(j(D0));
                                    if (He !== 0) {
                                      if (He === 1)
                                        continue r;
                                      var he = q(D0);
                                      break;
                                    }
                                  }
                                else
                                  var he = q(D0);
                                var me = he;
                                break;
                              }
                          else
                            var me = q(D0);
                          break;
                        }
                      }
                    else
                      var me = q(D0);
                    return me === 0 ? [0, B0, [0, 0, Se(D0)]] : ke(cPr);
                  });
                case 12:
                  return [0, t4, [0, 0, Se(n)]];
                case 13:
                  return Rt(t4, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && b9(j(D0)) === 0 && zu(j(D0)) === 0)
                      for (; ; ) {
                        var Le = a9(j(D0));
                        if (2 < Le >>> 0)
                          var me = q(D0);
                        else
                          switch (Le) {
                            case 0:
                              continue;
                            case 1:
                              r:
                                for (; ; ) {
                                  if (zu(j(D0)) === 0)
                                    for (; ; ) {
                                      var He = a9(j(D0));
                                      if (2 < He >>> 0)
                                        var he = q(D0);
                                      else
                                        switch (He) {
                                          case 0:
                                            continue;
                                          case 1:
                                            continue r;
                                          default:
                                            var he = 0;
                                        }
                                      break;
                                    }
                                  else
                                    var he = q(D0);
                                  var me = he;
                                  break;
                                }
                              break;
                            default:
                              var me = 0;
                          }
                        break;
                      }
                    else
                      var me = q(D0);
                    return me === 0 ? [0, B0, [1, 1, Se(D0)]] : ke(aPr);
                  });
                case 14:
                  return [0, t4, [1, 1, Se(n)]];
                case 15:
                  return Rt(t4, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && b9(j(D0)) === 0 && zu(j(D0)) === 0)
                      for (; ; ) {
                        G0(D0, 0);
                        var Le = x9(j(D0));
                        if (Le !== 0) {
                          if (Le === 1)
                            r:
                              for (; ; ) {
                                if (zu(j(D0)) === 0)
                                  for (; ; ) {
                                    G0(D0, 0);
                                    var He = x9(j(D0));
                                    if (He !== 0) {
                                      if (He === 1)
                                        continue r;
                                      var he = q(D0);
                                      break;
                                    }
                                  }
                                else
                                  var he = q(D0);
                                var me = he;
                                break;
                              }
                          else
                            var me = q(D0);
                          break;
                        }
                      }
                    else
                      var me = q(D0);
                    return me === 0 ? [0, B0, [0, 3, Se(D0)]] : ke(oPr);
                  });
                case 16:
                  return [0, t4, [0, 3, Se(n)]];
                case 17:
                  return Rt(t4, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0)
                      for (; ; ) {
                        var Le = j(D0), He = 47 < Le ? 57 < Le ? -1 : Vr(uRr, Le + Wt | 0) - 1 | 0 : -1;
                        if (He !== 0) {
                          if (He === 1) {
                            for (; ; )
                              if (G0(D0, 0), pn(j(D0)) !== 0) {
                                var he = q(D0);
                                break;
                              }
                          } else
                            var he = q(D0);
                          break;
                        }
                      }
                    else
                      var he = q(D0);
                    return he === 0 ? [0, B0, [0, 2, Se(D0)]] : ke(xPr);
                  });
                case 18:
                  return [0, t4, [0, 2, Se(n)]];
                case 19:
                  return Rt(t4, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && zu(j(D0)) === 0) {
                      for (; ; )
                        if (G0(D0, 0), zu(j(D0)) !== 0) {
                          var Le = q(D0);
                          break;
                        }
                    } else
                      var Le = q(D0);
                    return Le === 0 ? [0, B0, [0, 1, Se(D0)]] : ke(fPr);
                  });
                case 20:
                  return [0, t4, [0, 1, Se(n)]];
                case 21:
                  return Rt(t4, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && Zm(j(D0)) === 0 && Nn(j(D0)) === 0)
                      for (; ; ) {
                        var Le = t9(j(D0));
                        if (2 < Le >>> 0)
                          var me = q(D0);
                        else
                          switch (Le) {
                            case 0:
                              continue;
                            case 1:
                              r:
                                for (; ; ) {
                                  if (Nn(j(D0)) === 0)
                                    for (; ; ) {
                                      var He = t9(j(D0));
                                      if (2 < He >>> 0)
                                        var he = q(D0);
                                      else
                                        switch (He) {
                                          case 0:
                                            continue;
                                          case 1:
                                            continue r;
                                          default:
                                            var he = 0;
                                        }
                                      break;
                                    }
                                  else
                                    var he = q(D0);
                                  var me = he;
                                  break;
                                }
                              break;
                            default:
                              var me = 0;
                          }
                        break;
                      }
                    else
                      var me = q(D0);
                    return me === 0 ? [0, B0, [1, 2, Se(D0)]] : ke(iPr);
                  });
                case 23:
                  return Rt(t4, n, function(B0, D0) {
                    if (gn(D0), Cs(j(D0)) === 0 && Zm(j(D0)) === 0 && Nn(j(D0)) === 0)
                      for (; ; ) {
                        G0(D0, 0);
                        var Le = _9(j(D0));
                        if (Le !== 0) {
                          if (Le === 1)
                            r:
                              for (; ; ) {
                                if (Nn(j(D0)) === 0)
                                  for (; ; ) {
                                    G0(D0, 0);
                                    var He = _9(j(D0));
                                    if (He !== 0) {
                                      if (He === 1)
                                        continue r;
                                      var he = q(D0);
                                      break;
                                    }
                                  }
                                else
                                  var he = q(D0);
                                var me = he;
                                break;
                              }
                          else
                            var me = q(D0);
                          break;
                        }
                      }
                    else
                      var me = q(D0);
                    return me === 0 ? [0, B0, [0, 4, Se(D0)]] : ke(uPr);
                  });
                case 25:
                  return Rt(t4, n, function(B0, D0) {
                    function Le(ln) {
                      for (; ; ) {
                        var it = wi(j(ln));
                        if (2 < it >>> 0)
                          return q(ln);
                        switch (it) {
                          case 0:
                            continue;
                          case 1:
                            r:
                              for (; ; ) {
                                if (pn(j(ln)) === 0)
                                  for (; ; ) {
                                    var Tt = wi(j(ln));
                                    if (2 < Tt >>> 0)
                                      return q(ln);
                                    switch (Tt) {
                                      case 0:
                                        continue;
                                      case 1:
                                        continue r;
                                      default:
                                        return 0;
                                    }
                                  }
                                return q(ln);
                              }
                          default:
                            return 0;
                        }
                      }
                    }
                    function He(ln) {
                      for (; ; ) {
                        var it = r22(j(ln));
                        if (it !== 0) {
                          var Tt = it !== 1 ? 1 : 0;
                          return Tt && q(ln);
                        }
                      }
                    }
                    function he(ln) {
                      var it = E9(j(ln));
                      if (2 < it >>> 0)
                        return q(ln);
                      switch (it) {
                        case 0:
                          var Tt = C1(j(ln));
                          return Tt === 0 ? He(ln) : Tt === 1 ? Le(ln) : q(ln);
                        case 1:
                          return He(ln);
                        default:
                          return Le(ln);
                      }
                    }
                    function me(ln) {
                      var it = p9(j(ln));
                      if (it === 0)
                        for (; ; ) {
                          var Tt = f7(j(ln));
                          if (2 < Tt >>> 0)
                            return q(ln);
                          switch (Tt) {
                            case 0:
                              continue;
                            case 1:
                              return he(ln);
                            default:
                              r:
                                for (; ; ) {
                                  if (pn(j(ln)) === 0)
                                    for (; ; ) {
                                      var Ti = f7(j(ln));
                                      if (2 < Ti >>> 0)
                                        return q(ln);
                                      switch (Ti) {
                                        case 0:
                                          continue;
                                        case 1:
                                          return he(ln);
                                        default:
                                          continue r;
                                      }
                                    }
                                  return q(ln);
                                }
                          }
                        }
                      return it === 1 ? he(ln) : q(ln);
                    }
                    gn(D0);
                    var Zn = Qm(j(D0));
                    if (2 < Zn >>> 0)
                      var wn = q(D0);
                    else
                      switch (Zn) {
                        case 0:
                          if (pn(j(D0)) === 0)
                            for (; ; ) {
                              var ft = f7(j(D0));
                              if (2 < ft >>> 0)
                                var wn = q(D0);
                              else
                                switch (ft) {
                                  case 0:
                                    continue;
                                  case 1:
                                    var wn = he(D0);
                                    break;
                                  default:
                                    r:
                                      for (; ; ) {
                                        if (pn(j(D0)) === 0)
                                          for (; ; ) {
                                            var xt = f7(j(D0));
                                            if (2 < xt >>> 0)
                                              var jn = q(D0);
                                            else
                                              switch (xt) {
                                                case 0:
                                                  continue;
                                                case 1:
                                                  var jn = he(D0);
                                                  break;
                                                default:
                                                  continue r;
                                              }
                                            break;
                                          }
                                        else
                                          var jn = q(D0);
                                        var wn = jn;
                                        break;
                                      }
                                }
                              break;
                            }
                          else
                            var wn = q(D0);
                          break;
                        case 1:
                          var ut = r9(j(D0)), wn = ut === 0 ? me(D0) : ut === 1 ? he(D0) : q(D0);
                          break;
                        default:
                          for (; ; ) {
                            var dt = l9(j(D0));
                            if (2 < dt >>> 0)
                              var wn = q(D0);
                            else
                              switch (dt) {
                                case 0:
                                  var wn = me(D0);
                                  break;
                                case 1:
                                  continue;
                                default:
                                  var wn = he(D0);
                              }
                            break;
                          }
                      }
                    if (wn === 0) {
                      var xn = Gu(B0, nt(B0, D0), 23);
                      return [0, xn, [1, 2, Se(D0)]];
                    }
                    return ke(tPr);
                  });
                case 26:
                  var Bu = Gu(t4, nt(t4, n), 23);
                  return [0, Bu, [1, 2, Se(n)]];
                case 27:
                  return Rt(t4, n, function(B0, D0) {
                    function Le(xn) {
                      for (; ; ) {
                        G0(xn, 0);
                        var ln = Ds(j(xn));
                        if (ln !== 0) {
                          if (ln === 1)
                            r:
                              for (; ; ) {
                                if (pn(j(xn)) === 0)
                                  for (; ; ) {
                                    G0(xn, 0);
                                    var it = Ds(j(xn));
                                    if (it !== 0) {
                                      if (it === 1)
                                        continue r;
                                      return q(xn);
                                    }
                                  }
                                return q(xn);
                              }
                          return q(xn);
                        }
                      }
                    }
                    function He(xn) {
                      for (; ; )
                        if (G0(xn, 0), pn(j(xn)) !== 0)
                          return q(xn);
                    }
                    function he(xn) {
                      var ln = E9(j(xn));
                      if (2 < ln >>> 0)
                        return q(xn);
                      switch (ln) {
                        case 0:
                          var it = C1(j(xn));
                          return it === 0 ? He(xn) : it === 1 ? Le(xn) : q(xn);
                        case 1:
                          return He(xn);
                        default:
                          return Le(xn);
                      }
                    }
                    function me(xn) {
                      var ln = p9(j(xn));
                      if (ln === 0)
                        for (; ; ) {
                          var it = f7(j(xn));
                          if (2 < it >>> 0)
                            return q(xn);
                          switch (it) {
                            case 0:
                              continue;
                            case 1:
                              return he(xn);
                            default:
                              r:
                                for (; ; ) {
                                  if (pn(j(xn)) === 0)
                                    for (; ; ) {
                                      var Tt = f7(j(xn));
                                      if (2 < Tt >>> 0)
                                        return q(xn);
                                      switch (Tt) {
                                        case 0:
                                          continue;
                                        case 1:
                                          return he(xn);
                                        default:
                                          continue r;
                                      }
                                    }
                                  return q(xn);
                                }
                          }
                        }
                      return ln === 1 ? he(xn) : q(xn);
                    }
                    gn(D0);
                    var Zn = Qm(j(D0));
                    if (2 < Zn >>> 0)
                      var wn = q(D0);
                    else
                      switch (Zn) {
                        case 0:
                          if (pn(j(D0)) === 0)
                            for (; ; ) {
                              var ft = f7(j(D0));
                              if (2 < ft >>> 0)
                                var wn = q(D0);
                              else
                                switch (ft) {
                                  case 0:
                                    continue;
                                  case 1:
                                    var wn = he(D0);
                                    break;
                                  default:
                                    r:
                                      for (; ; ) {
                                        if (pn(j(D0)) === 0)
                                          for (; ; ) {
                                            var xt = f7(j(D0));
                                            if (2 < xt >>> 0)
                                              var jn = q(D0);
                                            else
                                              switch (xt) {
                                                case 0:
                                                  continue;
                                                case 1:
                                                  var jn = he(D0);
                                                  break;
                                                default:
                                                  continue r;
                                              }
                                            break;
                                          }
                                        else
                                          var jn = q(D0);
                                        var wn = jn;
                                        break;
                                      }
                                }
                              break;
                            }
                          else
                            var wn = q(D0);
                          break;
                        case 1:
                          var ut = r9(j(D0)), wn = ut === 0 ? me(D0) : ut === 1 ? he(D0) : q(D0);
                          break;
                        default:
                          for (; ; ) {
                            var dt = l9(j(D0));
                            if (2 < dt >>> 0)
                              var wn = q(D0);
                            else
                              switch (dt) {
                                case 0:
                                  var wn = me(D0);
                                  break;
                                case 1:
                                  continue;
                                default:
                                  var wn = he(D0);
                              }
                            break;
                          }
                      }
                    return wn === 0 ? [0, B0, [0, 4, Se(D0)]] : ke(nPr);
                  });
                case 29:
                  return Rt(t4, n, function(B0, D0) {
                    function Le(ut) {
                      for (; ; ) {
                        var dt = wi(j(ut));
                        if (2 < dt >>> 0)
                          return q(ut);
                        switch (dt) {
                          case 0:
                            continue;
                          case 1:
                            r:
                              for (; ; ) {
                                if (pn(j(ut)) === 0)
                                  for (; ; ) {
                                    var xn = wi(j(ut));
                                    if (2 < xn >>> 0)
                                      return q(ut);
                                    switch (xn) {
                                      case 0:
                                        continue;
                                      case 1:
                                        continue r;
                                      default:
                                        return 0;
                                    }
                                  }
                                return q(ut);
                              }
                          default:
                            return 0;
                        }
                      }
                    }
                    function He(ut) {
                      var dt = r22(j(ut));
                      if (dt === 0)
                        return Le(ut);
                      var xn = dt !== 1 ? 1 : 0;
                      return xn && q(ut);
                    }
                    gn(D0);
                    var he = Qm(j(D0));
                    if (2 < he >>> 0)
                      var me = q(D0);
                    else
                      switch (he) {
                        case 0:
                          var me = pn(j(D0)) === 0 ? Le(D0) : q(D0);
                          break;
                        case 1:
                          for (; ; ) {
                            var Zn = D1(j(D0));
                            if (Zn === 0)
                              var me = He(D0);
                            else {
                              if (Zn === 1)
                                continue;
                              var me = q(D0);
                            }
                            break;
                          }
                          break;
                        default:
                          for (; ; ) {
                            var wn = Bc(j(D0));
                            if (2 < wn >>> 0)
                              var me = q(D0);
                            else
                              switch (wn) {
                                case 0:
                                  var me = He(D0);
                                  break;
                                case 1:
                                  continue;
                                default:
                                  r:
                                    for (; ; ) {
                                      if (pn(j(D0)) === 0)
                                        for (; ; ) {
                                          var ft = Bc(j(D0));
                                          if (2 < ft >>> 0)
                                            var xt = q(D0);
                                          else
                                            switch (ft) {
                                              case 0:
                                                var xt = He(D0);
                                                break;
                                              case 1:
                                                continue;
                                              default:
                                                continue r;
                                            }
                                          break;
                                        }
                                      else
                                        var xt = q(D0);
                                      var me = xt;
                                      break;
                                    }
                              }
                            break;
                          }
                      }
                    if (me === 0) {
                      var jn = Gu(B0, nt(B0, D0), 22);
                      return [0, jn, [1, 2, Se(D0)]];
                    }
                    return ke(ePr);
                  });
                case 30:
                  return Rt(t4, n, function(B0, D0) {
                    gn(D0);
                    var Le = C1(j(D0));
                    if (Le === 0)
                      for (; ; ) {
                        var He = r22(j(D0));
                        if (He !== 0) {
                          var he = He !== 1 ? 1 : 0, ft = he && q(D0);
                          break;
                        }
                      }
                    else if (Le === 1)
                      for (; ; ) {
                        var me = wi(j(D0));
                        if (2 < me >>> 0)
                          var ft = q(D0);
                        else
                          switch (me) {
                            case 0:
                              continue;
                            case 1:
                              r:
                                for (; ; ) {
                                  if (pn(j(D0)) === 0)
                                    for (; ; ) {
                                      var Zn = wi(j(D0));
                                      if (2 < Zn >>> 0)
                                        var wn = q(D0);
                                      else
                                        switch (Zn) {
                                          case 0:
                                            continue;
                                          case 1:
                                            continue r;
                                          default:
                                            var wn = 0;
                                        }
                                      break;
                                    }
                                  else
                                    var wn = q(D0);
                                  var ft = wn;
                                  break;
                                }
                              break;
                            default:
                              var ft = 0;
                          }
                        break;
                      }
                    else
                      var ft = q(D0);
                    return ft === 0 ? [0, B0, [1, 2, Se(D0)]] : ke(rPr);
                  });
                case 31:
                  var K7 = Gu(t4, nt(t4, n), 22);
                  return [0, K7, [1, 2, Se(n)]];
                case 33:
                  return Rt(t4, n, function(B0, D0) {
                    function Le(jn) {
                      for (; ; ) {
                        G0(jn, 0);
                        var ut = Ds(j(jn));
                        if (ut !== 0) {
                          if (ut === 1)
                            r:
                              for (; ; ) {
                                if (pn(j(jn)) === 0)
                                  for (; ; ) {
                                    G0(jn, 0);
                                    var dt = Ds(j(jn));
                                    if (dt !== 0) {
                                      if (dt === 1)
                                        continue r;
                                      return q(jn);
                                    }
                                  }
                                return q(jn);
                              }
                          return q(jn);
                        }
                      }
                    }
                    function He(jn) {
                      return G0(jn, 0), pn(j(jn)) === 0 ? Le(jn) : q(jn);
                    }
                    gn(D0);
                    var he = Qm(j(D0));
                    if (2 < he >>> 0)
                      var me = q(D0);
                    else
                      switch (he) {
                        case 0:
                          var me = pn(j(D0)) === 0 ? Le(D0) : q(D0);
                          break;
                        case 1:
                          for (; ; ) {
                            G0(D0, 0);
                            var Zn = D1(j(D0));
                            if (Zn === 0)
                              var me = He(D0);
                            else {
                              if (Zn === 1)
                                continue;
                              var me = q(D0);
                            }
                            break;
                          }
                          break;
                        default:
                          for (; ; ) {
                            G0(D0, 0);
                            var wn = Bc(j(D0));
                            if (2 < wn >>> 0)
                              var me = q(D0);
                            else
                              switch (wn) {
                                case 0:
                                  var me = He(D0);
                                  break;
                                case 1:
                                  continue;
                                default:
                                  r:
                                    for (; ; ) {
                                      if (pn(j(D0)) === 0)
                                        for (; ; ) {
                                          G0(D0, 0);
                                          var ft = Bc(j(D0));
                                          if (2 < ft >>> 0)
                                            var xt = q(D0);
                                          else
                                            switch (ft) {
                                              case 0:
                                                var xt = He(D0);
                                                break;
                                              case 1:
                                                continue;
                                              default:
                                                continue r;
                                            }
                                          break;
                                        }
                                      else
                                        var xt = q(D0);
                                      var me = xt;
                                      break;
                                    }
                              }
                            break;
                          }
                      }
                    return me === 0 ? [0, B0, [0, 4, Se(D0)]] : ke(QCr);
                  });
                case 35:
                  var Yi = nt(t4, n), a7 = Se(n);
                  return [0, t4, [4, Yi, a7, a7]];
                case 36:
                  return [0, t4, 0];
                case 37:
                  return [0, t4, 1];
                case 38:
                  return [0, t4, 4];
                case 39:
                  return [0, t4, 5];
                case 40:
                  return [0, t4, 6];
                case 41:
                  return [0, t4, 7];
                case 42:
                  return [0, t4, 12];
                case 43:
                  return [0, t4, 10];
                case 44:
                  return [0, t4, 8];
                case 45:
                  return [0, t4, 9];
                case 46:
                  return [0, t4, 86];
                case 47:
                  $v(n), gn(n);
                  var Hc = j(n), W7 = 62 < Hc ? 63 < Hc ? -1 : 0 : -1, Ut = W7 !== 0 ? 1 : 0, bt = Ut && q(n);
                  return bt === 0 ? [0, t4, 85] : ke(_Pr);
                case 48:
                  return [0, t4, 83];
                case 49:
                  return [0, t4, 84];
                case 22:
                case 32:
                  return [0, t4, [1, 2, Se(n)]];
                default:
                  return [0, t4, [0, 4, Se(n)]];
              }
            }
            function Dee(t4, n) {
              gn(n);
              var e4 = j(n), i4 = ef < e4 ? Eo < e4 ? Ma < e4 ? Do < e4 ? 1 : 2 : Qx < e4 ? 1 : 2 : mo < e4 ? xc < e4 ? ox < e4 ? 1 : 2 : fo < e4 ? 1 : 2 : $u < e4 ? Hu < e4 ? 1 : 3 : Co < e4 ? 1 : 2 : Vr(ALr, e4 + 1 | 0) - 1 | 0;
              if (5 < i4 >>> 0)
                var x4 = q(n);
              else
                switch (i4) {
                  case 0:
                    var x4 = 0;
                    break;
                  case 1:
                    var x4 = 6;
                    break;
                  case 2:
                    if (G0(n, 2), jc(j(n)) === 0) {
                      for (; ; )
                        if (G0(n, 2), jc(j(n)) !== 0) {
                          var x4 = q(n);
                          break;
                        }
                    } else
                      var x4 = q(n);
                    break;
                  case 3:
                    var x4 = 1;
                    break;
                  case 4:
                    G0(n, 1);
                    var x4 = xi(j(n)) === 0 ? 1 : q(n);
                    break;
                  default:
                    G0(n, 5);
                    var c = d9(j(n)), x4 = c === 0 ? 4 : c === 1 ? 3 : q(n);
                }
              if (6 < x4 >>> 0)
                return ke(ZCr);
              switch (x4) {
                case 0:
                  return [0, t4, Pn];
                case 1:
                  return [2, d7(t4, n)];
                case 2:
                  return [2, t4];
                case 3:
                  var s2 = ju(t4, n), p = $n(zn), y = e2(t4, p, n), T = y[1];
                  return [1, T, Si(T, s2, y[2], p, 0)];
                case 4:
                  var E = ju(t4, n), d = $n(zn), w = R1(t4, d, n), G = w[1];
                  return [1, G, Si(G, E, w[2], d, 1)];
                case 5:
                  var A11 = ju(t4, n), S11 = $n(zn), M = t4;
                  r:
                    for (; ; ) {
                      gn(n);
                      var K = j(n), V = 92 < K ? Hu < K ? 1 : $u < K ? 2 : 1 : Vr(GLr, K + 1 | 0) - 1 | 0;
                      if (6 < V >>> 0)
                        var f0 = q(n);
                      else
                        switch (V) {
                          case 0:
                            var f0 = 0;
                            break;
                          case 1:
                            for (; ; ) {
                              G0(n, 7);
                              var m0 = j(n);
                              if (-1 < m0)
                                if (90 < m0)
                                  if (92 < m0)
                                    if ($u < m0)
                                      var k0 = m0 <= Hu ? 1 : 0, g0 = k0 && -1;
                                    else
                                      var g0 = 0;
                                  else
                                    var g0 = -1;
                                else
                                  var g0 = Vr(cRr, m0) - 1 | 0;
                              else
                                var g0 = -1;
                              if (g0 !== 0) {
                                var f0 = q(n);
                                break;
                              }
                            }
                            break;
                          case 2:
                            var f0 = 6;
                            break;
                          case 3:
                            G0(n, 6);
                            var f0 = xi(j(n)) === 0 ? 6 : q(n);
                            break;
                          case 4:
                            if (G0(n, 4), Sr0(j(n)) === 0) {
                              for (; ; )
                                if (G0(n, 3), Sr0(j(n)) !== 0) {
                                  var f0 = q(n);
                                  break;
                                }
                            } else
                              var f0 = q(n);
                            break;
                          case 5:
                            var f0 = 5;
                            break;
                          default:
                            G0(n, 7);
                            var e0 = j(n);
                            if (-1 < e0)
                              if (13 < e0)
                                var x0 = e0 <= Hu ? 1 : 0, l = x0 && ($u < e0 ? 1 : 0);
                              else
                                var l = Vr(xLr, e0) - 1 | 0;
                            else
                              var l = -1;
                            if (2 < l >>> 0)
                              var f0 = q(n);
                            else
                              switch (l) {
                                case 0:
                                  var f0 = 2;
                                  break;
                                case 1:
                                  var f0 = 1;
                                  break;
                                default:
                                  G0(n, 1);
                                  var f0 = xi(j(n)) === 0 ? 1 : q(n);
                              }
                        }
                      if (7 < f0 >>> 0)
                        var c0 = ke(Fwr);
                      else
                        switch (f0) {
                          case 0:
                            var c0 = [0, Gu(M, nt(M, n), 25), Twr];
                            break;
                          case 1:
                            var c0 = [0, d7(Gu(M, nt(M, n), 25), n), Owr];
                            break;
                          case 3:
                            var t0 = Se(n), c0 = [0, M, m7(t0, 1, un(t0) - 1 | 0)];
                            break;
                          case 4:
                            var c0 = [0, M, Iwr];
                            break;
                          case 5:
                            for (qi(S11, 91); ; ) {
                              gn(n);
                              var o0 = j(n), w0 = 93 < o0 ? 1 : Vr(oLr, o0 + 1 | 0) - 1 | 0;
                              if (3 < w0 >>> 0)
                                var _0 = q(n);
                              else
                                switch (w0) {
                                  case 0:
                                    var _0 = 0;
                                    break;
                                  case 1:
                                    for (; ; ) {
                                      G0(n, 4);
                                      var E0 = j(n);
                                      if (-1 < E0)
                                        if (91 < E0)
                                          var U0 = E0 <= 93 ? 1 : 0, b = U0 && -1;
                                        else
                                          var b = 0;
                                      else
                                        var b = -1;
                                      if (b !== 0) {
                                        var _0 = q(n);
                                        break;
                                      }
                                    }
                                    break;
                                  case 2:
                                    G0(n, 4);
                                    var R0 = j(n), X = 91 < R0 ? 93 < R0 ? -1 : Vr(rN, R0 - 92 | 0) - 1 | 0 : -1, _0 = X === 0 ? 1 : X === 1 ? 2 : q(n);
                                    break;
                                  default:
                                    var _0 = 3;
                                }
                              if (4 < _0 >>> 0)
                                var s0 = ke(Swr);
                              else
                                switch (_0) {
                                  case 0:
                                    var s0 = M;
                                    break;
                                  case 1:
                                    hn(S11, gwr);
                                    continue;
                                  case 2:
                                    qi(S11, 92), qi(S11, 93);
                                    continue;
                                  case 3:
                                    qi(S11, 93);
                                    var s0 = M;
                                    break;
                                  default:
                                    hn(S11, Se(n));
                                    continue;
                                }
                              var M = s0;
                              continue r;
                            }
                          case 6:
                            var c0 = [0, d7(Gu(M, nt(M, n), 25), n), Awr];
                            break;
                          default:
                            hn(S11, Se(n));
                            continue;
                        }
                      var hr = c0[1], Ar = h7(hr, n), or = [0, hr[1], A11, Ar], W0 = c0[2];
                      return [0, hr, [5, or, Mt(S11), W0]];
                    }
                default:
                  var Lr = Ei(t4, nt(t4, n));
                  return [0, Lr, [6, Se(n)]];
              }
            }
            function pL(t4, n, e4, i4, x4) {
              for (var c = t4; ; ) {
                var s2 = function(Cn) {
                  for (; ; )
                    if (G0(Cn, 6), Fr0(j(Cn)) !== 0)
                      return q(Cn);
                };
                gn(x4);
                var p = j(x4), y = br < p ? Hu < p ? 1 : $u < p ? 2 : 1 : Vr(QDr, p + 1 | 0) - 1 | 0;
                if (6 < y >>> 0)
                  var T = q(x4);
                else
                  switch (y) {
                    case 0:
                      var T = 1;
                      break;
                    case 1:
                      var T = s2(x4);
                      break;
                    case 2:
                      var T = 2;
                      break;
                    case 3:
                      G0(x4, 2);
                      var T = xi(j(x4)) === 0 ? 2 : q(x4);
                      break;
                    case 4:
                      var T = 0;
                      break;
                    case 5:
                      G0(x4, 6);
                      var E = j(x4), d = 34 < E ? In < E ? -1 : Vr(WLr, E - 35 | 0) - 1 | 0 : -1;
                      if (d === 0) {
                        var w = j(x4), G = 47 < w ? uc < w ? -1 : Vr(iRr, w + Wt | 0) - 1 | 0 : -1;
                        if (G === 0)
                          for (; ; ) {
                            var A11 = j(x4), S11 = 47 < A11 ? 59 < A11 ? -1 : Vr(iLr, A11 + Wt | 0) - 1 | 0 : -1;
                            if (S11 !== 0) {
                              var T = S11 === 1 ? 4 : q(x4);
                              break;
                            }
                          }
                        else if (G === 1 && Nn(j(x4)) === 0)
                          for (; ; ) {
                            var M = j(x4), K = 47 < M ? Ri < M ? -1 : Vr(rRr, M + Wt | 0) - 1 | 0 : -1;
                            if (K !== 0) {
                              var T = K === 1 ? 3 : q(x4);
                              break;
                            }
                          }
                        else
                          var T = q(x4);
                      } else if (d === 1 && dn(j(x4)) === 0) {
                        var V = Zv(j(x4));
                        if (V === 0) {
                          var f0 = Zv(j(x4));
                          if (f0 === 0) {
                            var m0 = Zv(j(x4));
                            if (m0 === 0) {
                              var k0 = Zv(j(x4));
                              if (k0 === 0) {
                                var g0 = Zv(j(x4));
                                if (g0 === 0) {
                                  var e0 = Zv(j(x4));
                                  if (e0 === 0)
                                    var x0 = j(x4), l = 58 < x0 ? 59 < x0 ? -1 : 0 : -1, T = l === 0 ? 5 : q(x4);
                                  else
                                    var T = e0 === 1 ? 5 : q(x4);
                                } else
                                  var T = g0 === 1 ? 5 : q(x4);
                              } else
                                var T = k0 === 1 ? 5 : q(x4);
                            } else
                              var T = m0 === 1 ? 5 : q(x4);
                          } else
                            var T = f0 === 1 ? 5 : q(x4);
                        } else
                          var T = V === 1 ? 5 : q(x4);
                      } else
                        var T = q(x4);
                      break;
                    default:
                      G0(x4, 0);
                      var T = Fr0(j(x4)) === 0 ? s2(x4) : q(x4);
                  }
                if (6 < T >>> 0)
                  return ke(Nwr);
                switch (T) {
                  case 0:
                    var c0 = Se(x4), t0 = 0;
                    switch (n) {
                      case 0:
                        n0(c0, Cwr) || (t0 = 1);
                        break;
                      case 1:
                        n0(c0, Pwr) || (t0 = 1);
                        break;
                      default:
                        var o0 = 0;
                        if (n0(c0, Dwr)) {
                          if (!n0(c0, Lwr))
                            return bL(c, nt(c, x4), qwr, Bwr);
                          if (n0(c0, Rwr)) {
                            if (!n0(c0, jwr))
                              return bL(c, nt(c, x4), Mwr, Gwr);
                            o0 = 1;
                          }
                        }
                        if (!o0)
                          return $v(x4), c;
                    }
                    if (t0)
                      return c;
                    hn(i4, c0), hn(e4, c0);
                    continue;
                  case 1:
                    return Ei(c, nt(c, x4));
                  case 2:
                    var w0 = Se(x4);
                    hn(i4, w0), hn(e4, w0);
                    var c = d7(c, x4);
                    continue;
                  case 3:
                    var _0 = Se(x4), E0 = m7(_0, 3, un(_0) - 4 | 0);
                    hn(i4, _0), S1(e4, Bi(Te(Uwr, E0)));
                    continue;
                  case 4:
                    var U0 = Se(x4), b = m7(U0, 2, un(U0) - 3 | 0);
                    hn(i4, U0), S1(e4, Bi(b));
                    continue;
                  case 5:
                    var R0 = Se(x4), X = m7(R0, 1, un(R0) - 2 | 0);
                    hn(i4, R0);
                    var s0 = Ee(X, Hwr), hr = 0;
                    if (0 <= s0)
                      if (0 < s0) {
                        var Ar = Ee(X, FTr), or = 0;
                        if (0 <= Ar)
                          if (0 < Ar) {
                            var W0 = Ee(X, YIr), Lr = 0;
                            if (0 <= W0)
                              if (0 < W0) {
                                var Tr = Ee(X, rNr), Hr = 0;
                                if (0 <= Tr)
                                  if (0 < Tr) {
                                    var Or = Ee(X, NNr), fr = 0;
                                    if (0 <= Or)
                                      if (0 < Or)
                                        if (n0(X, VNr))
                                          if (n0(X, zNr))
                                            if (n0(X, KNr))
                                              if (n0(X, WNr))
                                                if (n0(X, JNr))
                                                  if (n0(X, $Nr))
                                                    or = 1, Lr = 1, Hr = 1, fr = 1;
                                                  else
                                                    var Rr = ZNr;
                                                else
                                                  var Rr = QNr;
                                              else
                                                var Rr = rCr;
                                            else
                                              var Rr = eCr;
                                          else
                                            var Rr = nCr;
                                        else
                                          var Rr = tCr;
                                      else
                                        var Rr = uCr;
                                    else if (n0(X, CNr))
                                      if (n0(X, PNr))
                                        if (n0(X, DNr))
                                          if (n0(X, LNr))
                                            if (n0(X, RNr))
                                              if (n0(X, jNr))
                                                if (n0(X, GNr))
                                                  or = 1, Lr = 1, Hr = 1, fr = 1;
                                                else
                                                  var Rr = MNr;
                                              else
                                                var Rr = BNr;
                                            else
                                              var Rr = qNr;
                                          else
                                            var Rr = UNr;
                                        else
                                          var Rr = HNr;
                                      else
                                        var Rr = XNr;
                                    else
                                      var Rr = YNr;
                                    if (!fr)
                                      var Wr = Rr;
                                  } else
                                    var Wr = iCr;
                                else {
                                  var Jr = Ee(X, eNr), ar = 0;
                                  if (0 <= Jr)
                                    if (0 < Jr)
                                      if (n0(X, mNr))
                                        if (n0(X, _Nr))
                                          if (n0(X, yNr))
                                            if (n0(X, hNr))
                                              if (n0(X, dNr))
                                                if (n0(X, kNr))
                                                  if (n0(X, wNr))
                                                    or = 1, Lr = 1, Hr = 1, ar = 1;
                                                  else
                                                    var _r = ENr;
                                                else
                                                  var _r = SNr;
                                              else
                                                var _r = gNr;
                                            else
                                              var _r = FNr;
                                          else
                                            var _r = TNr;
                                        else
                                          var _r = ONr;
                                      else
                                        var _r = INr;
                                    else
                                      var _r = ANr;
                                  else if (n0(X, nNr))
                                    if (n0(X, tNr))
                                      if (n0(X, uNr))
                                        if (n0(X, iNr))
                                          if (n0(X, fNr))
                                            if (n0(X, xNr))
                                              if (n0(X, oNr))
                                                or = 1, Lr = 1, Hr = 1, ar = 1;
                                              else
                                                var _r = aNr;
                                            else
                                              var _r = cNr;
                                          else
                                            var _r = sNr;
                                        else
                                          var _r = vNr;
                                      else
                                        var _r = lNr;
                                    else
                                      var _r = bNr;
                                  else
                                    var _r = pNr;
                                  if (!ar)
                                    var Wr = _r;
                                }
                                if (!Hr)
                                  var Ir = Wr;
                              } else
                                var Ir = fCr;
                            else {
                              var fe = Ee(X, VIr), v0 = 0;
                              if (0 <= fe)
                                if (0 < fe) {
                                  var P = Ee(X, EAr), L = 0;
                                  if (0 <= P)
                                    if (0 < P)
                                      if (n0(X, GAr))
                                        if (n0(X, MAr))
                                          if (n0(X, BAr))
                                            if (n0(X, qAr))
                                              if (n0(X, UAr))
                                                if (n0(X, HAr))
                                                  if (n0(X, XAr))
                                                    or = 1, Lr = 1, v0 = 1, L = 1;
                                                  else
                                                    var Q = YAr;
                                                else
                                                  var Q = VAr;
                                              else
                                                var Q = zAr;
                                            else
                                              var Q = KAr;
                                          else
                                            var Q = WAr;
                                        else
                                          var Q = JAr;
                                      else
                                        var Q = $Ar;
                                    else
                                      var Q = ZAr;
                                  else if (n0(X, SAr))
                                    if (n0(X, gAr))
                                      if (n0(X, FAr))
                                        if (n0(X, TAr))
                                          if (n0(X, OAr))
                                            if (n0(X, IAr))
                                              if (n0(X, AAr))
                                                or = 1, Lr = 1, v0 = 1, L = 1;
                                              else
                                                var Q = NAr;
                                            else
                                              var Q = CAr;
                                          else
                                            var Q = PAr;
                                        else
                                          var Q = DAr;
                                      else
                                        var Q = LAr;
                                    else
                                      var Q = RAr;
                                  else
                                    var Q = jAr;
                                  if (!L)
                                    var i0 = Q;
                                } else
                                  var i0 = QAr;
                              else {
                                var l0 = Ee(X, zIr), S0 = 0;
                                if (0 <= l0)
                                  if (0 < l0)
                                    if (n0(X, oAr))
                                      if (n0(X, aAr))
                                        if (n0(X, cAr))
                                          if (n0(X, sAr))
                                            if (n0(X, vAr))
                                              if (n0(X, lAr))
                                                if (n0(X, bAr))
                                                  or = 1, Lr = 1, v0 = 1, S0 = 1;
                                                else
                                                  var T0 = pAr;
                                              else
                                                var T0 = mAr;
                                            else
                                              var T0 = _Ar;
                                          else
                                            var T0 = yAr;
                                        else
                                          var T0 = hAr;
                                      else
                                        var T0 = dAr;
                                    else
                                      var T0 = kAr;
                                  else
                                    var T0 = wAr;
                                else if (n0(X, KIr))
                                  if (n0(X, WIr))
                                    if (n0(X, JIr))
                                      if (n0(X, $Ir))
                                        if (n0(X, ZIr))
                                          if (n0(X, QIr))
                                            if (n0(X, rAr))
                                              or = 1, Lr = 1, v0 = 1, S0 = 1;
                                            else
                                              var T0 = eAr;
                                          else
                                            var T0 = nAr;
                                        else
                                          var T0 = tAr;
                                      else
                                        var T0 = uAr;
                                    else
                                      var T0 = iAr;
                                  else
                                    var T0 = fAr;
                                else
                                  var T0 = xAr;
                                if (!S0)
                                  var i0 = T0;
                              }
                              if (!v0)
                                var Ir = i0;
                            }
                            if (!Lr)
                              var rr = Ir;
                          } else
                            var rr = xCr;
                        else {
                          var L0 = Ee(X, TTr), B = 0;
                          if (0 <= L0)
                            if (0 < L0) {
                              var Z7 = Ee(X, ROr), p0 = 0;
                              if (0 <= Z7)
                                if (0 < Z7) {
                                  var b0 = Ee(X, lIr), O0 = 0;
                                  if (0 <= b0)
                                    if (0 < b0)
                                      if (n0(X, OIr))
                                        if (n0(X, IIr))
                                          if (n0(X, AIr))
                                            if (n0(X, NIr))
                                              if (n0(X, CIr))
                                                if (n0(X, PIr))
                                                  if (n0(X, DIr))
                                                    or = 1, B = 1, p0 = 1, O0 = 1;
                                                  else
                                                    var M0 = LIr;
                                                else
                                                  var M0 = RIr;
                                              else
                                                var M0 = jIr;
                                            else
                                              var M0 = GIr;
                                          else
                                            var M0 = MIr;
                                        else
                                          var M0 = BIr;
                                      else
                                        var M0 = qIr;
                                    else
                                      var M0 = UIr;
                                  else if (n0(X, bIr))
                                    if (n0(X, pIr))
                                      if (n0(X, mIr))
                                        if (n0(X, _Ir))
                                          if (n0(X, yIr))
                                            if (n0(X, hIr))
                                              if (n0(X, dIr))
                                                or = 1, B = 1, p0 = 1, O0 = 1;
                                              else
                                                var M0 = kIr;
                                            else
                                              var M0 = wIr;
                                          else
                                            var M0 = EIr;
                                        else
                                          var M0 = SIr;
                                      else
                                        var M0 = gIr;
                                    else
                                      var M0 = FIr;
                                  else
                                    var M0 = TIr;
                                  if (!O0)
                                    var er = M0;
                                } else
                                  var er = HIr;
                              else {
                                var yr = Ee(X, jOr), vr = 0;
                                if (0 <= yr)
                                  if (0 < yr)
                                    if (n0(X, ZOr))
                                      if (n0(X, QOr))
                                        if (n0(X, rIr))
                                          if (n0(X, eIr))
                                            if (n0(X, nIr))
                                              if (n0(X, tIr))
                                                if (n0(X, uIr))
                                                  or = 1, B = 1, p0 = 1, vr = 1;
                                                else
                                                  var $0 = iIr;
                                              else
                                                var $0 = fIr;
                                            else
                                              var $0 = xIr;
                                          else
                                            var $0 = oIr;
                                        else
                                          var $0 = aIr;
                                      else
                                        var $0 = cIr;
                                    else
                                      var $0 = sIr;
                                  else
                                    var $0 = vIr;
                                else if (n0(X, GOr))
                                  if (n0(X, MOr))
                                    if (n0(X, BOr))
                                      if (n0(X, qOr))
                                        if (n0(X, UOr))
                                          if (n0(X, HOr))
                                            if (n0(X, XOr))
                                              or = 1, B = 1, p0 = 1, vr = 1;
                                            else
                                              var $0 = YOr;
                                          else
                                            var $0 = VOr;
                                        else
                                          var $0 = zOr;
                                      else
                                        var $0 = KOr;
                                    else
                                      var $0 = WOr;
                                  else
                                    var $0 = JOr;
                                else
                                  var $0 = $Or;
                                if (!vr)
                                  var er = $0;
                              }
                              if (!p0)
                                var Er = er;
                            } else
                              var Er = XIr;
                          else {
                            var Mr = Ee(X, OTr), Br = 0;
                            if (0 <= Mr)
                              if (0 < Mr) {
                                var qr = Ee(X, iOr), jr = 0;
                                if (0 <= qr)
                                  if (0 < qr)
                                    if (n0(X, dOr))
                                      if (n0(X, kOr))
                                        if (n0(X, wOr))
                                          if (n0(X, EOr))
                                            if (n0(X, SOr))
                                              if (n0(X, gOr))
                                                if (n0(X, FOr))
                                                  or = 1, B = 1, Br = 1, jr = 1;
                                                else
                                                  var $r = TOr;
                                              else
                                                var $r = OOr;
                                            else
                                              var $r = IOr;
                                          else
                                            var $r = AOr;
                                        else
                                          var $r = NOr;
                                      else
                                        var $r = COr;
                                    else
                                      var $r = POr;
                                  else
                                    var $r = DOr;
                                else if (n0(X, fOr))
                                  if (n0(X, xOr))
                                    if (n0(X, oOr))
                                      if (n0(X, aOr))
                                        if (n0(X, cOr))
                                          if (n0(X, sOr))
                                            if (n0(X, vOr))
                                              or = 1, B = 1, Br = 1, jr = 1;
                                            else
                                              var $r = lOr;
                                          else
                                            var $r = bOr;
                                        else
                                          var $r = pOr;
                                      else
                                        var $r = mOr;
                                    else
                                      var $r = _Or;
                                  else
                                    var $r = yOr;
                                else
                                  var $r = hOr;
                                if (!jr)
                                  var ne = $r;
                              } else
                                var ne = LOr;
                            else {
                              var Qr = Ee(X, ITr), be = 0;
                              if (0 <= Qr)
                                if (0 < Qr)
                                  if (n0(X, XTr))
                                    if (n0(X, YTr))
                                      if (n0(X, VTr))
                                        if (n0(X, zTr))
                                          if (n0(X, KTr))
                                            if (n0(X, WTr))
                                              if (n0(X, JTr))
                                                or = 1, B = 1, Br = 1, be = 1;
                                              else
                                                var ae = $Tr;
                                            else
                                              var ae = ZTr;
                                          else
                                            var ae = QTr;
                                        else
                                          var ae = rOr;
                                      else
                                        var ae = eOr;
                                    else
                                      var ae = nOr;
                                  else
                                    var ae = tOr;
                                else
                                  var ae = uOr;
                              else if (n0(X, ATr))
                                if (n0(X, NTr))
                                  if (n0(X, CTr))
                                    if (n0(X, PTr))
                                      if (n0(X, DTr))
                                        if (n0(X, LTr))
                                          if (n0(X, RTr))
                                            or = 1, B = 1, Br = 1, be = 1;
                                          else
                                            var ae = jTr;
                                        else
                                          var ae = GTr;
                                      else
                                        var ae = MTr;
                                    else
                                      var ae = BTr;
                                  else
                                    var ae = qTr;
                                else
                                  var ae = UTr;
                              else
                                var ae = HTr;
                              if (!be)
                                var ne = ae;
                            }
                            if (!Br)
                              var Er = ne;
                          }
                          if (!B)
                            var rr = Er;
                        }
                        if (!or) {
                          var pe = rr;
                          hr = 1;
                        }
                      } else {
                        var pe = oCr;
                        hr = 1;
                      }
                    else {
                      var oe = Ee(X, Xwr), ce = 0;
                      if (0 <= oe)
                        if (0 < oe) {
                          var ge = Ee(X, agr), q0 = 0;
                          if (0 <= ge)
                            if (0 < ge) {
                              var Fr = Ee(X, yFr), _ = 0;
                              if (0 <= Fr)
                                if (0 < Fr) {
                                  var k = Ee(X, WFr), I = 0;
                                  if (0 <= k)
                                    if (0 < k)
                                      if (n0(X, cTr))
                                        if (n0(X, sTr))
                                          if (n0(X, vTr))
                                            if (n0(X, lTr))
                                              if (n0(X, bTr))
                                                if (n0(X, pTr))
                                                  ce = 1, q0 = 1, _ = 1, I = 1;
                                                else
                                                  var U = mTr;
                                              else
                                                var U = _Tr;
                                            else
                                              var U = yTr;
                                          else
                                            var U = hTr;
                                        else
                                          var U = dTr;
                                      else
                                        var U = kTr;
                                    else
                                      var U = wTr;
                                  else if (n0(X, JFr))
                                    if (n0(X, $Fr))
                                      if (n0(X, ZFr))
                                        if (n0(X, QFr))
                                          if (n0(X, rTr))
                                            if (n0(X, eTr))
                                              if (n0(X, nTr))
                                                ce = 1, q0 = 1, _ = 1, I = 1;
                                              else
                                                var U = tTr;
                                            else
                                              var U = uTr;
                                          else
                                            var U = iTr;
                                        else
                                          var U = fTr;
                                      else
                                        var U = xTr;
                                    else
                                      var U = oTr;
                                  else
                                    var U = aTr;
                                  if (!I)
                                    var Y = U;
                                } else
                                  var Y = ETr;
                              else {
                                var y0 = Ee(X, hFr), P0 = 0;
                                if (0 <= y0)
                                  if (0 < y0)
                                    if (n0(X, DFr))
                                      if (n0(X, LFr))
                                        if (n0(X, RFr))
                                          if (n0(X, jFr))
                                            if (n0(X, GFr))
                                              if (n0(X, MFr))
                                                if (n0(X, BFr))
                                                  ce = 1, q0 = 1, _ = 1, P0 = 1;
                                                else
                                                  var I0 = qFr;
                                              else
                                                var I0 = UFr;
                                            else
                                              var I0 = HFr;
                                          else
                                            var I0 = XFr;
                                        else
                                          var I0 = YFr;
                                      else
                                        var I0 = VFr;
                                    else
                                      var I0 = zFr;
                                  else
                                    var I0 = KFr;
                                else if (n0(X, dFr))
                                  if (n0(X, kFr))
                                    if (n0(X, wFr))
                                      if (n0(X, EFr))
                                        if (n0(X, SFr))
                                          if (n0(X, gFr))
                                            if (n0(X, FFr))
                                              ce = 1, q0 = 1, _ = 1, P0 = 1;
                                            else
                                              var I0 = TFr;
                                          else
                                            var I0 = OFr;
                                        else
                                          var I0 = IFr;
                                      else
                                        var I0 = AFr;
                                    else
                                      var I0 = NFr;
                                  else
                                    var I0 = CFr;
                                else
                                  var I0 = PFr;
                                if (!P0)
                                  var Y = I0;
                              }
                              if (!_)
                                var D = Y;
                            } else
                              var D = STr;
                          else {
                            var u0 = Ee(X, cgr), X0 = 0;
                            if (0 <= u0)
                              if (0 < u0) {
                                var J0 = Ee(X, qgr), ir = 0;
                                if (0 <= J0)
                                  if (0 < J0)
                                    if (n0(X, nFr))
                                      if (n0(X, tFr))
                                        if (n0(X, uFr))
                                          if (n0(X, iFr))
                                            if (n0(X, fFr))
                                              if (n0(X, xFr))
                                                if (n0(X, oFr))
                                                  ce = 1, q0 = 1, X0 = 1, ir = 1;
                                                else
                                                  var Q0 = aFr;
                                              else
                                                var Q0 = cFr;
                                            else
                                              var Q0 = sFr;
                                          else
                                            var Q0 = vFr;
                                        else
                                          var Q0 = lFr;
                                      else
                                        var Q0 = bFr;
                                    else
                                      var Q0 = pFr;
                                  else
                                    var Q0 = mFr;
                                else if (n0(X, Ugr))
                                  if (n0(X, Hgr))
                                    if (n0(X, Xgr))
                                      if (n0(X, Ygr))
                                        if (n0(X, Vgr))
                                          if (n0(X, zgr))
                                            if (n0(X, Kgr))
                                              ce = 1, q0 = 1, X0 = 1, ir = 1;
                                            else
                                              var Q0 = Wgr;
                                          else
                                            var Q0 = Jgr;
                                        else
                                          var Q0 = $gr;
                                      else
                                        var Q0 = Zgr;
                                    else
                                      var Q0 = Qgr;
                                  else
                                    var Q0 = rFr;
                                else
                                  var Q0 = eFr;
                                if (!ir)
                                  var F0 = Q0;
                              } else
                                var F0 = _Fr;
                            else {
                              var Sr = Ee(X, sgr), mr = 0;
                              if (0 <= Sr)
                                if (0 < Sr)
                                  if (n0(X, Fgr))
                                    if (n0(X, Tgr))
                                      if (n0(X, Ogr))
                                        if (n0(X, Igr))
                                          if (n0(X, Agr))
                                            if (n0(X, Ngr))
                                              if (n0(X, Cgr))
                                                ce = 1, q0 = 1, X0 = 1, mr = 1;
                                              else
                                                var Cr = Pgr;
                                            else
                                              var Cr = Dgr;
                                          else
                                            var Cr = Lgr;
                                        else
                                          var Cr = Rgr;
                                      else
                                        var Cr = jgr;
                                    else
                                      var Cr = Ggr;
                                  else
                                    var Cr = Mgr;
                                else
                                  var Cr = Bgr;
                              else if (n0(X, vgr))
                                if (n0(X, lgr))
                                  if (n0(X, bgr))
                                    if (n0(X, pgr))
                                      if (n0(X, mgr))
                                        if (n0(X, _gr))
                                          if (n0(X, ygr))
                                            ce = 1, q0 = 1, X0 = 1, mr = 1;
                                          else
                                            var Cr = hgr;
                                        else
                                          var Cr = dgr;
                                      else
                                        var Cr = kgr;
                                    else
                                      var Cr = wgr;
                                  else
                                    var Cr = Egr;
                                else
                                  var Cr = Sgr;
                              else
                                var Cr = ggr;
                              if (!mr)
                                var F0 = Cr;
                            }
                            if (!X0)
                              var D = F0;
                          }
                          if (!q0)
                            var sr = D;
                        } else
                          var sr = gTr;
                      else {
                        var Pr = Ee(X, Ywr), K0 = 0;
                        if (0 <= Pr)
                          if (0 < Pr) {
                            var Ur = Ee(X, rSr), h0 = 0;
                            if (0 <= Ur)
                              if (0 < Ur) {
                                var Kr = Ee(X, NSr), re = 0;
                                if (0 <= Kr)
                                  if (0 < Kr)
                                    if (n0(X, VSr))
                                      if (n0(X, zSr))
                                        if (n0(X, KSr))
                                          if (n0(X, WSr))
                                            if (n0(X, JSr))
                                              if (n0(X, $Sr))
                                                if (n0(X, ZSr))
                                                  ce = 1, K0 = 1, h0 = 1, re = 1;
                                                else
                                                  var xe = QSr;
                                              else
                                                var xe = rgr;
                                            else
                                              var xe = egr;
                                          else
                                            var xe = ngr;
                                        else
                                          var xe = tgr;
                                      else
                                        var xe = ugr;
                                    else
                                      var xe = igr;
                                  else
                                    var xe = fgr;
                                else if (n0(X, CSr))
                                  if (n0(X, PSr))
                                    if (n0(X, DSr))
                                      if (n0(X, LSr))
                                        if (n0(X, RSr))
                                          if (n0(X, jSr))
                                            if (n0(X, GSr))
                                              ce = 1, K0 = 1, h0 = 1, re = 1;
                                            else
                                              var xe = MSr;
                                          else
                                            var xe = BSr;
                                        else
                                          var xe = qSr;
                                      else
                                        var xe = USr;
                                    else
                                      var xe = HSr;
                                  else
                                    var xe = XSr;
                                else
                                  var xe = YSr;
                                if (!re)
                                  var Re = xe;
                              } else
                                var Re = xgr;
                            else {
                              var ve = Ee(X, eSr), Ie = 0;
                              if (0 <= ve)
                                if (0 < ve)
                                  if (n0(X, mSr))
                                    if (n0(X, _Sr))
                                      if (n0(X, ySr))
                                        if (n0(X, hSr))
                                          if (n0(X, dSr))
                                            if (n0(X, kSr))
                                              if (n0(X, wSr))
                                                ce = 1, K0 = 1, h0 = 1, Ie = 1;
                                              else
                                                var Ge = ESr;
                                            else
                                              var Ge = SSr;
                                          else
                                            var Ge = gSr;
                                        else
                                          var Ge = FSr;
                                      else
                                        var Ge = TSr;
                                    else
                                      var Ge = OSr;
                                  else
                                    var Ge = ISr;
                                else
                                  var Ge = ASr;
                              else if (n0(X, nSr))
                                if (n0(X, tSr))
                                  if (n0(X, uSr))
                                    if (n0(X, iSr))
                                      if (n0(X, fSr))
                                        if (n0(X, xSr))
                                          if (n0(X, oSr))
                                            ce = 1, K0 = 1, h0 = 1, Ie = 1;
                                          else
                                            var Ge = aSr;
                                        else
                                          var Ge = cSr;
                                      else
                                        var Ge = sSr;
                                    else
                                      var Ge = vSr;
                                  else
                                    var Ge = lSr;
                                else
                                  var Ge = bSr;
                              else
                                var Ge = pSr;
                              if (!Ie)
                                var Re = Ge;
                            }
                            if (!h0)
                              var Me = Re;
                          } else
                            var Me = ogr;
                        else {
                          var an = Ee(X, Vwr), We = 0;
                          if (0 <= an)
                            if (0 < an) {
                              var Ae = Ee(X, EEr), cn = 0;
                              if (0 <= Ae)
                                if (0 < Ae)
                                  if (n0(X, GEr))
                                    if (n0(X, MEr))
                                      if (n0(X, BEr))
                                        if (n0(X, qEr))
                                          if (n0(X, UEr))
                                            if (n0(X, HEr))
                                              if (n0(X, XEr))
                                                ce = 1, K0 = 1, We = 1, cn = 1;
                                              else
                                                var rn = YEr;
                                            else
                                              var rn = VEr;
                                          else
                                            var rn = zEr;
                                        else
                                          var rn = KEr;
                                      else
                                        var rn = WEr;
                                    else
                                      var rn = JEr;
                                  else
                                    var rn = $Er;
                                else
                                  var rn = ZEr;
                              else if (n0(X, SEr))
                                if (n0(X, gEr))
                                  if (n0(X, FEr))
                                    if (n0(X, TEr))
                                      if (n0(X, OEr))
                                        if (n0(X, IEr))
                                          if (n0(X, AEr))
                                            ce = 1, K0 = 1, We = 1, cn = 1;
                                          else
                                            var rn = NEr;
                                        else
                                          var rn = CEr;
                                      else
                                        var rn = PEr;
                                    else
                                      var rn = DEr;
                                  else
                                    var rn = LEr;
                                else
                                  var rn = REr;
                              else
                                var rn = jEr;
                              if (!cn)
                                var kn = rn;
                            } else
                              var kn = QEr;
                          else {
                            var vn = Ee(X, zwr), Ne = 0;
                            if (0 <= vn)
                              if (0 < vn)
                                if (n0(X, oEr))
                                  if (n0(X, aEr))
                                    if (n0(X, cEr))
                                      if (n0(X, sEr))
                                        if (n0(X, vEr))
                                          if (n0(X, lEr))
                                            if (n0(X, bEr))
                                              ce = 1, K0 = 1, We = 1, Ne = 1;
                                            else
                                              var Je = pEr;
                                          else
                                            var Je = mEr;
                                        else
                                          var Je = _Er;
                                      else
                                        var Je = yEr;
                                    else
                                      var Je = hEr;
                                  else
                                    var Je = dEr;
                                else
                                  var Je = kEr;
                              else
                                var Je = wEr;
                            else if (n0(X, Kwr))
                              if (n0(X, Wwr))
                                if (n0(X, Jwr))
                                  if (n0(X, $wr))
                                    if (n0(X, Zwr))
                                      if (n0(X, Qwr))
                                        if (n0(X, rEr))
                                          ce = 1, K0 = 1, We = 1, Ne = 1;
                                        else
                                          var Je = eEr;
                                      else
                                        var Je = nEr;
                                    else
                                      var Je = tEr;
                                  else
                                    var Je = uEr;
                                else
                                  var Je = iEr;
                              else
                                var Je = fEr;
                            else
                              var Je = xEr;
                            if (!Ne)
                              var kn = Je;
                          }
                          if (!We)
                            var Me = kn;
                        }
                        if (!K0)
                          var sr = Me;
                      }
                      if (!ce) {
                        var pe = sr;
                        hr = 1;
                      }
                    }
                    var en = hr ? pe : 0;
                    en ? S1(e4, en[1]) : hn(e4, Te(cCr, Te(X, aCr)));
                    continue;
                  default:
                    var _n = Se(x4);
                    hn(i4, _n), hn(e4, _n);
                    continue;
                }
              }
            }
            function Lee(t4, n) {
              gn(n);
              var e4 = j(n), i4 = ef < e4 ? vw < e4 ? -1 : Uk < e4 ? C3 < e4 ? Bw < e4 ? EE < e4 ? Wy < e4 ? 1 : 6 : Jd < e4 ? lE < e4 ? uF < e4 ? 1 : 6 : ZT < e4 ? 1 : 6 : WF < e4 ? bA < e4 ? 1 : 6 : sI < e4 ? 1 : 6 : C6 < e4 ? E4 < e4 ? x6 < e4 ? V8 < e4 ? j3 < e4 ? r3 < e4 ? CO < e4 ? 1 : 6 : LI < e4 ? 1 : 6 : Iy < e4 ? hg < e4 ? 1 : 6 : Mw < e4 ? 1 : 6 : L3 < e4 ? w8 < e4 ? jg < e4 ? 1 : 6 : $4 < e4 ? 1 : 6 : W8 < e4 ? zT < e4 ? 1 : 6 : kk < e4 ? 1 : 6 : O4 < e4 ? YO < e4 ? l3 < e4 ? Qk < e4 ? 1 : 6 : fk < e4 ? 1 : 6 : xp < e4 ? V6 < e4 ? 1 : 6 : Td < e4 ? 1 : 6 : G8 < e4 ? s4 < e4 ? t6 < e4 ? 1 : 6 : q6 < e4 ? 1 : 6 : B6 < e4 ? S4 < e4 ? 1 : 6 : fn < e4 ? 1 : 6 : LE < e4 ? M4 < e4 ? g6 < e4 ? SF < e4 ? i8 < e4 ? 1 : 6 : d8 < e4 ? 1 : 6 : F4 < e4 ? JF < e4 ? 1 : 6 : mh < e4 ? 1 : 6 : U6 < e4 ? n8 < e4 ? s3 < e4 ? 1 : 6 : S8 < e4 ? 1 : 6 : BS < e4 ? L8 < e4 ? 1 : 6 : K3 < e4 ? 1 : 6 : m8 < e4 ? f8 < e4 ? x8 < e4 ? w3 < e4 ? 1 : 6 : _6 < e4 ? 1 : 6 : s6 < e4 ? oF < e4 ? 1 : 6 : ZO < e4 ? 1 : 6 : a3 < e4 ? DS < e4 ? e8 < e4 ? 1 : 6 : g8 < e4 ? 1 : 6 : J3 < e4 ? sF < e4 ? 1 : 6 : ig < e4 ? 1 : 6 : iw < e4 ? Ek < e4 ? wk < e4 ? qk < e4 ? FT < e4 ? Vk < e4 ? 1 : 6 : uA < e4 ? 1 : 6 : dy < e4 ? VS < e4 ? 1 : 6 : _d2 < e4 ? 1 : 6 : Th < e4 ? pF < e4 ? FE < e4 ? 1 : 6 : Zw < e4 ? 1 : 6 : Sy < e4 ? L_ < e4 ? 1 : 6 : CE < e4 ? 1 : 6 : LF2 < e4 ? Vw < e4 ? My < e4 ? rw < e4 ? 1 : 6 : XI < e4 ? 1 : 6 : jO < e4 ? ap < e4 ? 1 : 6 : jT < e4 ? 1 : 6 : Ot < e4 ? OA < e4 ? gA < e4 ? 1 : 6 : 1 : 6 : c6 < e4 ? w6 < e4 ? l6 < e4 ? k3 < e4 ? VE < e4 ? 1 : 6 : qw < e4 ? 1 : 6 : v4 < e4 ? nE < e4 ? 1 : 6 : Ty < e4 ? 1 : 6 : c3 < e4 ? V4 < e4 ? eg < e4 ? 1 : 6 : qF < e4 ? 1 : 6 : X4 < e4 ? _T < e4 ? 1 : 6 : Oy < e4 ? 1 : 6 : D6 < e4 ? D4 < e4 ? V3 < e4 ? MS < e4 ? 1 : 6 : Ww < e4 ? 1 : 6 : cy < e4 ? jy < e4 ? 1 : 6 : VT < e4 ? 1 : 6 : B4 < e4 ? bh < e4 ? JT < e4 ? 1 : 6 : G3 < e4 ? 1 : 6 : r6 < e4 ? sO < e4 ? 1 : 6 : ZE < e4 ? 1 : 6 : uT < e4 ? Z4 < e4 ? Yd < e4 ? Q6 < e4 ? L4 < e4 ? N6 < e4 ? vp < e4 ? D_ < e4 ? 1 : 6 : Pd < e4 ? 1 : 6 : pd < e4 ? Rg < e4 ? 1 : 6 : OS < e4 ? 1 : 6 : G6 < e4 ? I3 < e4 ? uk < e4 ? 1 : 6 : cE < e4 ? 1 : 6 : l8 < e4 ? l4 < e4 ? 1 : 6 : rh < e4 ? 1 : 6 : M3 < e4 ? FS < e4 ? NE < e4 ? aT < e4 ? 1 : 6 : kT < e4 ? 1 : 6 : uS < e4 ? d3 < e4 ? 1 : 6 : zd < e4 ? 1 : 6 : ly < e4 ? T6 < e4 ? Pg < e4 ? 1 : 6 : vy < e4 ? 1 : 6 : LO < e4 ? yF < e4 ? 1 : 6 : YF < e4 ? 1 : 6 : DI < e4 ? au < e4 ? jF < e4 ? Ah < e4 ? AO < e4 ? 1 : 6 : Cd < e4 ? 1 : 6 : qh < e4 ? AS < e4 ? 1 : 6 : lA < e4 ? 1 : 6 : cO < e4 ? AI < e4 ? xI < e4 ? 1 : 6 : B_ < e4 ? 1 : 6 : hS < e4 ? fT < e4 ? 1 : 6 : mg < e4 ? 1 : 6 : NO < e4 ? Nw < e4 ? Yh < e4 ? lw < e4 ? 1 : 6 : Qg < e4 ? 1 : 6 : Vg < e4 ? Lk < e4 ? 1 : 6 : qO < e4 ? 1 : 6 : iS < e4 ? b6 < e4 ? h6 < e4 ? 1 : 6 : $F < e4 ? 1 : 6 : ph < e4 ? rT < e4 ? 1 : 6 : HS < e4 ? 1 : 6 : zO < e4 ? Ck < e4 ? yS < e4 ? Iw < e4 ? CI < e4 ? Kg < e4 ? 1 : 6 : VO < e4 ? 1 : 6 : Mk < e4 ? ks < e4 ? 1 : 6 : PF < e4 ? 1 : 6 : kd < e4 ? TS < e4 ? wI < e4 ? 1 : 6 : xg < e4 ? 1 : 6 : Rd < e4 ? dh < e4 ? 1 : 6 : oI < e4 ? 1 : 6 : oT < e4 ? lg < e4 ? tF < e4 ? KI < e4 ? 1 : 6 : pk < e4 ? 1 : 6 : G_ < e4 ? kw < e4 ? 1 : 6 : QF < e4 ? 1 : 6 : jk < e4 ? FO < e4 ? mA < e4 ? 1 : 6 : _g < e4 ? 1 : 6 : WE < e4 ? lF < e4 ? 1 : 6 : MF < e4 ? 1 : 6 : h4 < e4 ? h3 < e4 ? vT < e4 ? jI < e4 ? mS < e4 ? 1 : 6 : cA < e4 ? 1 : 6 : DE < e4 ? zk < e4 ? 1 : 6 : Lg < e4 ? 1 : 6 : AT < e4 ? R6 < e4 ? bk < e4 ? 1 : 6 : iT < e4 ? 1 : 6 : US < e4 ? BT < e4 ? 1 : 6 : vE < e4 ? 1 : 6 : Wc < e4 ? Sk < e4 ? D3 < e4 ? Xg < e4 ? 1 : 6 : fd < e4 ? 1 : 6 : IF < e4 ? ld < e4 ? 1 : 6 : nA < e4 ? 1 : 6 : BE < e4 ? W3 < e4 ? sy < e4 ? 1 : 6 : kI < e4 ? 1 : 6 : VF < e4 ? fS < e4 ? 1 : 6 : P4 < e4 ? 1 : 6 : vS < e4 ? jw < e4 ? ik < e4 ? hO < e4 ? iI < e4 ? bg < e4 ? Nd < e4 ? 1 : 6 : u3 < e4 ? 1 : 6 : sE < e4 ? Ld < e4 ? 1 : 6 : Xk < e4 ? 1 : 6 : up < e4 ? hh < e4 ? M8 < e4 ? 1 : 6 : p3 < e4 ? 1 : 6 : Ew < e4 ? pE < e4 ? 1 : 6 : Bg < e4 ? 1 : 6 : by < e4 ? Zk < e4 ? $T < e4 ? zF < e4 ? 1 : 6 : Bd < e4 ? 1 : 6 : $k < e4 ? TI < e4 ? 1 : 6 : pO < e4 ? 1 : 6 : sS < e4 ? RO < e4 ? kA < e4 ? 1 : 6 : wA < e4 ? 1 : 6 : fg < e4 ? qI < e4 ? 1 : 6 : dS < e4 ? 1 : 6 : hI < e4 ? NI < e4 ? nS < e4 ? Xy < e4 ? J_ < e4 ? 1 : 6 : bT < e4 ? 1 : 6 : $O < e4 ? Eg < e4 ? 1 : 6 : oA < e4 ? 1 : 6 : uE < e4 ? ET < e4 ? dg < e4 ? 1 : 6 : TT < e4 ? 1 : 6 : Ay < e4 ? u8 < e4 ? 1 : 6 : ZS < e4 ? 1 : 6 : Gh < e4 ? M_ < e4 ? SO < e4 ? lh < e4 ? 1 : 6 : XE < e4 ? 1 : 6 : Q3 < e4 ? Z6 < e4 ? 1 : 6 : Od < e4 ? 1 : 6 : W6 < e4 ? RF < e4 ? qy < e4 ? 1 : 6 : Nk < e4 ? 1 : 6 : PE < e4 ? Tg < e4 ? 1 : 6 : OI < e4 ? 1 : 6 : A8 < e4 ? P_ < e4 ? C4 < e4 ? $g < e4 ? Uh < e4 ? WS < e4 ? 1 : 6 : j6 < e4 ? 1 : 6 : _E < e4 ? fI < e4 ? 1 : 6 : Pw < e4 ? 1 : 6 : f3 < e4 ? a8 < e4 ? UF < e4 ? 1 : 6 : Lw < e4 ? 1 : 6 : mk < e4 ? aI < e4 ? 1 : 6 : yy < e4 ? 1 : 6 : O8 < e4 ? uI < e4 ? u6 < e4 ? ky < e4 ? 1 : 6 : GI < e4 ? 1 : 6 : c8 < e4 ? Ow < e4 ? 1 : 6 : bE < e4 ? 1 : 6 : y3 < e4 ? fp < e4 ? eE < e4 ? 1 : 6 : I8 < e4 ? 1 : 6 : cw < e4 ? KF < e4 ? 1 : 6 : VI < e4 ? 1 : 6 : zh < e4 ? QO < e4 ? h8 < e4 ? hy < e4 ? ew < e4 ? 1 : 6 : i3 < e4 ? 1 : 6 : pI < e4 ? dA < e4 ? 1 : 6 : qd < e4 ? 1 : 6 : kg < e4 ? iE < e4 ? TO < e4 ? 1 : 6 : X6 < e4 ? 1 : 6 : Rw < e4 ? aw < e4 ? 1 : 6 : F3 < e4 ? 1 : 6 : Ik < e4 ? OF < e4 ? Ly < e4 ? m4 < e4 ? 1 : 6 : cd < e4 ? 1 : 6 : zg < e4 ? Jk < e4 ? 1 : 6 : aS < e4 ? 1 : 6 : B3 < e4 ? IO < e4 ? hw < e4 ? 1 : 6 : mE < e4 ? 1 : 6 : $S < e4 ? QI < e4 ? 1 : 6 : FA < e4 ? 1 : 6 : od < e4 ? KE < e4 ? Rk < e4 ? J6 < e4 ? Md < e4 ? xF < e4 ? Zg < e4 ? sh < e4 ? eT < e4 ? 1 : 6 : YI < e4 ? 1 : 6 : RE < e4 ? OT < e4 ? 1 : 6 : J8 < e4 ? 1 : 6 : IA < e4 ? dE < e4 ? qT < e4 ? 1 : 6 : hd < e4 ? 1 : 6 : Id < e4 ? Mh < e4 ? 1 : 6 : _S < e4 ? 1 : 6 : EA < e4 ? PO < e4 ? Hg < e4 ? sg < e4 ? 1 : 6 : Ug < e4 ? 1 : 6 : Xw < e4 ? td < e4 ? 1 : 6 : Dg < e4 ? 1 : 6 : Ag < e4 ? bS < e4 ? Wd < e4 ? 1 : 6 : Fg < e4 ? 1 : 6 : tA < e4 ? wT < e4 ? 1 : 6 : Dk < e4 ? 1 : 6 : rS < e4 ? Z8 < e4 ? JI < e4 ? AE < e4 ? ME < e4 ? 1 : 6 : pA < e4 ? 1 : 6 : EO < e4 ? Gy < e4 ? 1 : 6 : fA < e4 ? 1 : 6 : xA < e4 ? b4 < e4 ? _k < e4 ? 1 : 6 : oO < e4 ? 1 : 6 : wd < e4 ? S7 < e4 ? 1 : 6 : $d < e4 ? 1 : 6 : X8 < e4 ? z_ < e4 ? Fd < e4 ? Ph < e4 ? 1 : 6 : dT < e4 ? 1 : 6 : Dd < e4 ? Ok < e4 ? 1 : 6 : ah < e4 ? 1 : 6 : nh < e4 ? ag < e4 ? $w < e4 ? 1 : 6 : WT < e4 ? 1 : 6 : QS < e4 ? Fw < e4 ? 1 : 6 : LT < e4 ? 1 : 6 : Ih < e4 ? vk < e4 ? En < e4 ? p8 < e4 ? gT < e4 ? M6 < e4 ? 1 : 6 : gh < e4 ? 1 : 6 : J4 < e4 ? Q_ < e4 ? 1 : 6 : op < e4 ? 1 : 6 : vO < e4 ? GE < e4 ? ch < e4 ? 1 : 6 : q_ < e4 ? 1 : 6 : ES < e4 ? UT < e4 ? 1 : 6 : jS < e4 ? 1 : 6 : Uw < e4 ? ty < e4 ? sA < e4 ? Vh < e4 ? 1 : 6 : sT < e4 ? 1 : 6 : iF < e4 ? Zd < e4 ? 1 : 6 : FI < e4 ? 1 : 6 : xO < e4 ? th < e4 ? ng < e4 ? 1 : 6 : bd < e4 ? 1 : 6 : iO < e4 ? _O < e4 ? 1 : 6 : eO < e4 ? 1 : 6 : IS < e4 ? zE < e4 ? fO < e4 ? ck < e4 ? xh < e4 ? 1 : 6 : ud < e4 ? 1 : 6 : JS < e4 ? _w < e4 ? 1 : 6 : Fy < e4 ? 1 : 6 : vA < e4 ? $E < e4 ? KT < e4 ? 1 : 6 : rI < e4 ? 1 : 6 : uy < e4 ? Tw < e4 ? 1 : 6 : 1 : nT < e4 ? Z3 < e4 ? ek < e4 ? 6 : $y < e4 ? 1 : 6 : GF < e4 ? Qw < e4 ? 1 : 6 : sk < e4 ? 1 : 6 : vg < e4 ? nO < e4 ? tI < e4 ? 1 : 6 : GO < e4 ? 1 : 6 : Ry < e4 ? 1 : 6 : D8 < e4 ? Ed < e4 ? xw < e4 ? Oh < e4 ? rA < e4 ? 6 : $h < e4 ? tT < e4 ? 1 : 6 : vF < e4 ? 1 : 6 : Qy < e4 ? zI < e4 ? ry < e4 ? 1 : 6 : yh < e4 ? 1 : 6 : HE < e4 ? Jh < e4 ? 1 : 6 : hF < e4 ? 1 : 6 : rp < e4 ? z4 < e4 ? S6 < e4 ? py < e4 ? 1 : 6 : rg < e4 ? 1 : 6 : $8 < e4 ? yO < e4 ? 1 : 6 : Bk < e4 ? 1 : 6 : gk < e4 ? U8 < e4 ? EF < e4 ? 1 : 6 : wy < e4 ? 1 : 6 : og < e4 ? Tk < e4 ? 1 : 6 : wE < e4 ? 1 : 6 : Gw < e4 ? $_ < e4 ? ey < e4 ? pS < e4 ? oE < e4 ? 1 : 6 : 1 : 6 : dw < e4 ? 6 : Q4 < e4 ? IT < e4 ? 1 : 6 : yg < e4 ? 1 : 6 : eI < e4 ? t3 < e4 ? Ma < e4 ? Do < e4 ? 1 : 2 : BI < e4 ? 1 : 6 : ow < e4 ? MT < e4 ? 1 : 6 : YS < e4 ? 1 : 6 : yI < e4 ? tS < e4 ? Zh < e4 ? 1 : 6 : CT < e4 ? 1 : 6 : GT < e4 ? Kw < e4 ? 1 : 6 : SI < e4 ? 1 : 6 : UI < e4 ? tk < e4 ? Qn < e4 ? R4 < e4 ? q3 < e4 ? id < e4 ? 1 : 6 : _F < e4 ? 1 : 6 : z3 < e4 ? L6 < e4 ? 1 : 6 : fh < e4 ? 1 : 6 : PT < e4 ? ip < e4 ? uw < e4 ? 1 : 6 : eS < e4 ? 1 : 6 : tO < e4 ? e3 < e4 ? 1 : 6 : oh < e4 ? 1 : 6 : dk < e4 ? zS < e4 ? Qh < e4 ? ug < e4 ? 1 : 6 : iy < e4 ? 1 : 6 : Wk < e4 ? Kd < e4 ? 1 : 6 : TE < e4 ? 1 : 6 : dd < e4 ? my < e4 ? cF < e4 ? 1 : 6 : _A < e4 ? 1 : 6 : Ny < e4 ? 1 : 6 : Xd < e4 ? H3 < e4 ? o3 < e4 ? Jw < e4 ? 1 : 6 : av < e4 ? 6 : RT < e4 ? 1 : 6 : gF < e4 ? k6 < e4 ? NF < e4 ? 1 : 6 : Wh < e4 ? 1 : 6 : Gk < e4 ? Dh < e4 ? 1 : 6 : ZI < e4 ? 1 : 6 : Vd < e4 ? cS < e4 ? lT < e4 ? cI < e4 ? 1 : 6 : 1 : Dy < e4 ? 6 : Jy < e4 ? 1 : 6 : FF < e4 ? sd < e4 ? 1 : 6 : XT < e4 ? OO < e4 ? 1 : 6 : aO < e4 ? 1 : 6 : wh < e4 ? F8 < e4 ? W_ < e4 ? uh < e4 ? kO < e4 ? ed < e4 ? EI < e4 ? Aw < e4 ? 1 : 6 : yA < e4 ? 1 : 6 : Bh < e4 ? fy < e4 ? 1 : 6 : ak < e4 ? 1 : 6 : CF < e4 ? TA < e4 ? lp < e4 ? 1 : 6 : 1 : 6 : yT < e4 ? Hd < e4 ? kS < e4 ? zy < e4 ? 1 : 6 : wS < e4 ? 1 : 6 : v6 < e4 ? Hk < e4 ? 1 : 6 : kE < e4 ? 1 : 6 : Sw < e4 ? pw < e4 ? 1 : 6 : _h < e4 ? WO < e4 ? 1 : 6 : k8 < e4 ? 1 : 6 : kF < e4 ? DO < e4 ? XF < e4 ? gy < e4 ? Sd < e4 ? 1 : 6 : eA < e4 ? 1 : 6 : Z_ < e4 ? JE < e4 ? 1 : 6 : ay < e4 ? 1 : 6 : Ky < e4 ? _8 < e4 ? Uy < e4 ? 1 : 6 : n3 < e4 ? 1 : 6 : rE < e4 ? oy < e4 ? 1 : 6 : cg < e4 ? 1 : 6 : Yy < e4 ? SA < e4 ? xS < e4 ? rF < e4 ? 1 : 6 : Xh < e4 ? 1 : 6 : mI < e4 ? lk < e4 ? 1 : 6 : uO < e4 ? 1 : 6 : PS < e4 && aA < e4 ? 1 : 6 : yk < e4 ? Rh < e4 ? tg < e4 ? nk < e4 ? 6 : Zy < e4 ? bI < e4 ? 1 : 6 : Ch < e4 ? 1 : 6 : xE < e4 ? ok < e4 ? V_ < e4 ? 1 : 6 : 1 : 6 : Og < e4 ? UO < e4 && oS < e4 ? 1 : 6 : bw < e4 ? rO < e4 ? Lh < e4 ? 1 : 6 : 1 : dF < e4 ? 6 : 1 : Eh < e4 ? gE < e4 ? U3 < e4 ? 6 : tw < e4 ? 1 : 6 : dI < e4 ? Qd < e4 ? wO < e4 ? 1 : 6 : R_ < e4 ? 1 : 6 : Sh < e4 ? 1 : 6 : BF < e4 ? gg < e4 ? Ad < e4 ? 1 : 6 : XS < e4 ? 1 : 6 : Kk < e4 ? YE < e4 ? 6 : ih < e4 ? 1 : 6 : U_ < e4 ? yE < e4 ? 1 : 6 : Ht < e4 ? 1 : 6 : GS < e4 ? jE < e4 ? dO < e4 ? q4 < e4 ? Ey < e4 ? E8 < e4 ? RI < e4 ? 1 : 6 : nF < e4 ? 1 : 6 : HF < e4 ? 1 : 6 : ww < e4 ? E3 < e4 ? de < e4 ? 1 : 6 : 1 : 6 : Ig < e4 ? Gd < e4 ? X_ < e4 ? H_ < e4 ? 1 : 6 : 1 : 6 : Hw < e4 ? T3 < e4 ? vd < e4 ? 1 : 6 : fF < e4 ? 1 : 6 : wg < e4 ? 1 : 6 : z8 < e4 ? j8 < e4 ? Eo < e4 ? PI < e4 ? 6 : Qx < e4 ? 1 : 2 : F6 < e4 ? By < e4 ? 1 : 6 : IE < e4 ? 1 : 6 : K8 < e4 ? z6 < e4 ? Cg < e4 ? 1 : 6 : cT < e4 ? 1 : 6 : o8 < e4 ? tt < e4 ? 1 : 6 : Ak < e4 ? 1 : 6 : NS < e4 ? tE < e4 ? j4 < e4 ? Ng < e4 ? 1 : 6 : $I < e4 ? 1 : 6 : P6 < e4 ? TF < e4 ? 1 : 6 : p4 < e4 ? 1 : 6 : _I < e4 ? fE < e4 ? gI < e4 ? 1 : 6 : N3 < e4 ? 1 : 6 : G4 < e4 ? B8 < e4 ? 1 : 6 : Sg < e4 ? 1 : 6 : N8 < e4 ? QE < e4 ? aE < e4 ? Yk < e4 ? pT < e4 ? K_ < e4 ? 1 : 6 : wF < e4 ? 1 : 6 : UE < e4 ? 1 : 6 : rd < e4 ? vI < e4 ? 6 : 1 : 6 : MO < e4 ? mw < e4 ? YT < e4 ? s8 < e4 ? 1 : 6 : AA < e4 ? 1 : 6 : Yw < e4 ? Y_ < e4 ? 1 : 6 : 1 : 6 : Gg < e4 ? JO < e4 ? $3 < e4 ? sp < e4 ? P8 < e4 ? 1 : 6 : Q8 < e4 ? 1 : 6 : gr < e4 ? t8 < e4 ? 1 : 6 : 1 : g4 < e4 ? KS < e4 ? 6 : m6 < e4 ? 1 : 6 : mF < e4 ? Cy < e4 ? 1 : 6 : R3 < e4 ? 1 : 6 : Pk < e4 ? HI < e4 ? QT < e4 ? x3 < e4 ? 1 : 6 : mO < e4 ? 1 : 6 : Py < e4 ? O3 < e4 ? 1 : 6 : ep < e4 ? 1 : 6 : mo < e4 ? xc < e4 ? ox < e4 ? 1 : 2 : fo < e4 ? 1 : 2 : $u < e4 ? Hu < e4 ? 1 : 3 : Co < e4 ? 1 : 2 : Vr(DLr, e4 + 1 | 0) - 1 | 0;
              if (14 < i4 >>> 0)
                var x4 = q(n);
              else
                switch (i4) {
                  case 0:
                    var x4 = 0;
                    break;
                  case 1:
                    var x4 = 14;
                    break;
                  case 2:
                    if (G0(n, 2), jc(j(n)) === 0) {
                      for (; ; )
                        if (G0(n, 2), jc(j(n)) !== 0) {
                          var x4 = q(n);
                          break;
                        }
                    } else
                      var x4 = q(n);
                    break;
                  case 3:
                    var x4 = 1;
                    break;
                  case 4:
                    G0(n, 1);
                    var x4 = xi(j(n)) === 0 ? 1 : q(n);
                    break;
                  case 5:
                    var x4 = 12;
                    break;
                  case 6:
                    var x4 = 13;
                    break;
                  case 7:
                    var x4 = 10;
                    break;
                  case 8:
                    G0(n, 6);
                    var c = d9(j(n)), x4 = c === 0 ? 4 : c === 1 ? 3 : q(n);
                    break;
                  case 9:
                    var x4 = 9;
                    break;
                  case 10:
                    var x4 = 5;
                    break;
                  case 11:
                    var x4 = 11;
                    break;
                  case 12:
                    var x4 = 7;
                    break;
                  case 13:
                    if (G0(n, 14), Ls(j(n)) === 0) {
                      var s2 = L1(j(n));
                      if (s2 === 0)
                        var x4 = Nn(j(n)) === 0 && Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 13 : q(n);
                      else if (s2 === 1 && Nn(j(n)) === 0)
                        for (; ; ) {
                          var p = A1(j(n));
                          if (p !== 0) {
                            var x4 = p === 1 ? 13 : q(n);
                            break;
                          }
                        }
                      else
                        var x4 = q(n);
                    } else
                      var x4 = q(n);
                    break;
                  default:
                    var x4 = 8;
                }
              if (14 < x4 >>> 0)
                return ke(JCr);
              switch (x4) {
                case 0:
                  return [0, t4, Pn];
                case 1:
                  return [2, d7(t4, n)];
                case 2:
                  return [2, t4];
                case 3:
                  var y = ju(t4, n), T = $n(zn), E = e2(t4, T, n), d = E[1];
                  return [1, d, Si(d, y, E[2], T, 0)];
                case 4:
                  var w = ju(t4, n), G = $n(zn), A11 = R1(t4, G, n), S11 = A11[1];
                  return [1, S11, Si(S11, w, A11[2], G, 1)];
                case 5:
                  return [0, t4, 98];
                case 6:
                  return [0, t4, j7];
                case 7:
                  return [0, t4, 99];
                case 8:
                  return [0, t4, 0];
                case 9:
                  return [0, t4, 86];
                case 10:
                  return [0, t4, 10];
                case 11:
                  return [0, t4, 82];
                case 12:
                  var M = Se(n), K = ju(t4, n), V = $n(zn), f0 = $n(zn);
                  hn(f0, M);
                  var m0 = qn(M, $Cr) ? 0 : 1, k0 = pL(t4, m0, V, f0, n), g0 = h7(k0, n);
                  hn(f0, M);
                  var e0 = Mt(V), x0 = Mt(f0);
                  return [0, k0, [8, [0, k0[1], K, g0], e0, x0]];
                case 13:
                  for (var l = n[6]; ; ) {
                    gn(n);
                    var c0 = j(n), t0 = In < c0 ? 1 : Vr(oRr, c0 + 1 | 0) - 1 | 0;
                    if (3 < t0 >>> 0)
                      var o0 = q(n);
                    else
                      switch (t0) {
                        case 0:
                          var o0 = 1;
                          break;
                        case 1:
                          var o0 = 2;
                          break;
                        case 2:
                          var o0 = 0;
                          break;
                        default:
                          if (G0(n, 2), Ls(j(n)) === 0) {
                            var w0 = L1(j(n));
                            if (w0 === 0)
                              if (Nn(j(n)) === 0 && Nn(j(n)) === 0)
                                var _0 = Nn(j(n)) !== 0 ? 1 : 0, o0 = _0 && q(n);
                              else
                                var o0 = q(n);
                            else if (w0 === 1 && Nn(j(n)) === 0)
                              for (; ; ) {
                                var E0 = A1(j(n));
                                if (E0 !== 0) {
                                  var U0 = E0 !== 1 ? 1 : 0, o0 = U0 && q(n);
                                  break;
                                }
                              }
                            else
                              var o0 = q(n);
                          } else
                            var o0 = q(n);
                      }
                    if (2 < o0 >>> 0)
                      throw [0, Sn, vwr];
                    switch (o0) {
                      case 0:
                        continue;
                      case 1:
                        break;
                      default:
                        if (nL(br0(n)))
                          continue;
                        mr0(n, 1);
                    }
                    var b = n[3];
                    tL(n, l);
                    var R0 = Ll(n), X = Hl(t4, l, b);
                    return [0, t4, [7, uL(R0), X]];
                  }
                default:
                  return [0, t4, [6, Se(n)]];
              }
            }
            function Ree(t4, n) {
              gn(n);
              var e4 = j(n);
              if (-1 < e4)
                if (ef < e4)
                  if (Eo < e4)
                    if (Ma < e4)
                      var i4 = e4 <= Do ? 1 : 0, T = i4 && 1;
                    else
                      var x4 = e4 <= Qx ? 1 : 0, T = x4 && 1;
                  else if (mo < e4)
                    if (xc < e4)
                      var c = e4 <= ox ? 1 : 0, T = c && 1;
                    else
                      var s2 = e4 <= fo ? 1 : 0, T = s2 && 1;
                  else if ($u < e4)
                    var p = e4 <= Hu ? 1 : 0, T = p && 2;
                  else
                    var y = e4 <= Co ? 1 : 0, T = y && 1;
                else
                  var T = Vr(tLr, e4) - 1 | 0;
              else
                var T = -1;
              if (5 < T >>> 0)
                var E = q(n);
              else
                switch (T) {
                  case 0:
                    var E = 5;
                    break;
                  case 1:
                    if (G0(n, 1), jc(j(n)) === 0) {
                      for (; ; )
                        if (G0(n, 1), jc(j(n)) !== 0) {
                          var E = q(n);
                          break;
                        }
                    } else
                      var E = q(n);
                    break;
                  case 2:
                    var E = 0;
                    break;
                  case 3:
                    G0(n, 0);
                    var d = xi(j(n)) !== 0 ? 1 : 0, E = d && q(n);
                    break;
                  case 4:
                    G0(n, 5);
                    var w = d9(j(n)), E = w === 0 ? 3 : w === 1 ? 2 : q(n);
                    break;
                  default:
                    var E = 4;
                }
              if (5 < E >>> 0)
                return ke(zCr);
              switch (E) {
                case 0:
                  return [2, d7(t4, n)];
                case 1:
                  return [2, t4];
                case 2:
                  var G = ju(t4, n), A11 = $n(zn), S11 = e2(t4, A11, n), M = S11[1];
                  return [1, M, Si(M, G, S11[2], A11, 0)];
                case 3:
                  var K = ju(t4, n), V = $n(zn), f0 = R1(t4, V, n), m0 = f0[1];
                  return [1, m0, Si(m0, K, f0[2], V, 1)];
                case 4:
                  var k0 = ju(t4, n), g0 = $n(zn), e0 = $n(zn), x0 = $n(zn);
                  hn(x0, KCr);
                  var l = Zr0(t4, g0, e0, x0, n), c0 = l[1], t0 = h7(c0, n), o0 = [0, c0[1], k0, t0], w0 = l[2], _0 = Mt(x0), E0 = Mt(e0);
                  return [0, c0, [3, [0, o0, [0, Mt(g0), E0, _0], w0]]];
                default:
                  var U0 = Ei(t4, nt(t4, n));
                  return [0, U0, [3, [0, nt(U0, n), WCr, 1]]];
              }
            }
            function jee(t4, n) {
              function e4(D) {
                for (; ; )
                  if (G0(D, 29), dn(j(D)) !== 0)
                    return q(D);
              }
              function i4(D) {
                G0(D, 27);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; )
                    if (G0(D, 25), dn(j(D)) !== 0)
                      return q(D);
                }
                return u0 === 1 ? e4(D) : q(D);
              }
              function x4(D) {
                for (; ; )
                  if (G0(D, 23), dn(j(D)) !== 0)
                    return q(D);
              }
              function c(D) {
                G0(D, 22);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; )
                    if (G0(D, 21), dn(j(D)) !== 0)
                      return q(D);
                }
                return u0 === 1 ? x4(D) : q(D);
              }
              function s2(D) {
                for (; ; )
                  if (G0(D, 23), dn(j(D)) !== 0)
                    return q(D);
              }
              function p(D) {
                G0(D, 22);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; )
                    if (G0(D, 21), dn(j(D)) !== 0)
                      return q(D);
                }
                return u0 === 1 ? s2(D) : q(D);
              }
              function y(D) {
                r:
                  for (; ; ) {
                    if (pn(j(D)) === 0)
                      for (; ; ) {
                        G0(D, 24);
                        var u0 = Mc(j(D));
                        if (3 < u0 >>> 0)
                          return q(D);
                        switch (u0) {
                          case 0:
                            return s2(D);
                          case 1:
                            continue;
                          case 2:
                            continue r;
                          default:
                            return p(D);
                        }
                      }
                    return q(D);
                  }
              }
              function T(D) {
                G0(D, 29);
                var u0 = Gr0(j(D));
                if (3 < u0 >>> 0)
                  return q(D);
                switch (u0) {
                  case 0:
                    return e4(D);
                  case 1:
                    var X0 = C1(j(D));
                    if (X0 === 0)
                      for (; ; ) {
                        G0(D, 24);
                        var J0 = Qv(j(D));
                        if (2 < J0 >>> 0)
                          return q(D);
                        switch (J0) {
                          case 0:
                            return s2(D);
                          case 1:
                            continue;
                          default:
                            return p(D);
                        }
                      }
                    if (X0 === 1)
                      for (; ; ) {
                        G0(D, 24);
                        var ir = Mc(j(D));
                        if (3 < ir >>> 0)
                          return q(D);
                        switch (ir) {
                          case 0:
                            return s2(D);
                          case 1:
                            continue;
                          case 2:
                            return y(D);
                          default:
                            return p(D);
                        }
                      }
                    return q(D);
                  case 2:
                    for (; ; ) {
                      G0(D, 24);
                      var Q0 = Qv(j(D));
                      if (2 < Q0 >>> 0)
                        return q(D);
                      switch (Q0) {
                        case 0:
                          return x4(D);
                        case 1:
                          continue;
                        default:
                          return c(D);
                      }
                    }
                  default:
                    for (; ; ) {
                      G0(D, 24);
                      var F0 = Mc(j(D));
                      if (3 < F0 >>> 0)
                        return q(D);
                      switch (F0) {
                        case 0:
                          return x4(D);
                        case 1:
                          continue;
                        case 2:
                          return y(D);
                        default:
                          return c(D);
                      }
                    }
                }
              }
              function E(D) {
                for (; ; ) {
                  G0(D, 30);
                  var u0 = Ps(j(D));
                  if (4 < u0 >>> 0)
                    return q(D);
                  switch (u0) {
                    case 0:
                      return e4(D);
                    case 1:
                      continue;
                    case 2:
                      return T(D);
                    case 3:
                      r:
                        for (; ; ) {
                          if (pn(j(D)) === 0)
                            for (; ; ) {
                              G0(D, 30);
                              var X0 = Ps(j(D));
                              if (4 < X0 >>> 0)
                                return q(D);
                              switch (X0) {
                                case 0:
                                  return e4(D);
                                case 1:
                                  continue;
                                case 2:
                                  return T(D);
                                case 3:
                                  continue r;
                                default:
                                  return i4(D);
                              }
                            }
                          return q(D);
                        }
                    default:
                      return i4(D);
                  }
                }
              }
              function d(D) {
                return pn(j(D)) === 0 ? E(D) : q(D);
              }
              function w(D) {
                for (; ; )
                  if (G0(D, 19), dn(j(D)) !== 0)
                    return q(D);
              }
              function G(D) {
                for (; ; )
                  if (G0(D, 19), dn(j(D)) !== 0)
                    return q(D);
              }
              function A11(D) {
                G0(D, 29);
                var u0 = Er0(j(D));
                if (u0 === 0)
                  return e4(D);
                if (u0 === 1)
                  for (; ; ) {
                    G0(D, 20);
                    var X0 = w9(j(D));
                    if (3 < X0 >>> 0)
                      return q(D);
                    switch (X0) {
                      case 0:
                        return G(D);
                      case 1:
                        continue;
                      case 2:
                        r:
                          for (; ; ) {
                            if (Nn(j(D)) === 0)
                              for (; ; ) {
                                G0(D, 20);
                                var J0 = w9(j(D));
                                if (3 < J0 >>> 0)
                                  return q(D);
                                switch (J0) {
                                  case 0:
                                    return w(D);
                                  case 1:
                                    continue;
                                  case 2:
                                    continue r;
                                  default:
                                    G0(D, 18);
                                    var ir = Bt(j(D));
                                    if (ir === 0) {
                                      for (; ; )
                                        if (G0(D, 17), dn(j(D)) !== 0)
                                          return q(D);
                                    }
                                    return ir === 1 ? w(D) : q(D);
                                }
                              }
                            return q(D);
                          }
                      default:
                        G0(D, 18);
                        var Q0 = Bt(j(D));
                        if (Q0 === 0) {
                          for (; ; )
                            if (G0(D, 17), dn(j(D)) !== 0)
                              return q(D);
                        }
                        return Q0 === 1 ? G(D) : q(D);
                    }
                  }
                return q(D);
              }
              function S11(D) {
                for (; ; )
                  if (G0(D, 13), dn(j(D)) !== 0)
                    return q(D);
              }
              function M(D) {
                for (; ; )
                  if (G0(D, 13), dn(j(D)) !== 0)
                    return q(D);
              }
              function K(D) {
                G0(D, 29);
                var u0 = Dr0(j(D));
                if (u0 === 0)
                  return e4(D);
                if (u0 === 1)
                  for (; ; ) {
                    G0(D, 14);
                    var X0 = h9(j(D));
                    if (3 < X0 >>> 0)
                      return q(D);
                    switch (X0) {
                      case 0:
                        return M(D);
                      case 1:
                        continue;
                      case 2:
                        r:
                          for (; ; ) {
                            if (zu(j(D)) === 0)
                              for (; ; ) {
                                G0(D, 14);
                                var J0 = h9(j(D));
                                if (3 < J0 >>> 0)
                                  return q(D);
                                switch (J0) {
                                  case 0:
                                    return S11(D);
                                  case 1:
                                    continue;
                                  case 2:
                                    continue r;
                                  default:
                                    G0(D, 12);
                                    var ir = Bt(j(D));
                                    if (ir === 0) {
                                      for (; ; )
                                        if (G0(D, 11), dn(j(D)) !== 0)
                                          return q(D);
                                    }
                                    return ir === 1 ? S11(D) : q(D);
                                }
                              }
                            return q(D);
                          }
                      default:
                        G0(D, 12);
                        var Q0 = Bt(j(D));
                        if (Q0 === 0) {
                          for (; ; )
                            if (G0(D, 11), dn(j(D)) !== 0)
                              return q(D);
                        }
                        return Q0 === 1 ? M(D) : q(D);
                    }
                  }
                return q(D);
              }
              function V(D) {
                for (; ; )
                  if (G0(D, 9), dn(j(D)) !== 0)
                    return q(D);
              }
              function f0(D) {
                for (; ; )
                  if (G0(D, 9), dn(j(D)) !== 0)
                    return q(D);
              }
              function m0(D) {
                G0(D, 29);
                var u0 = Pr0(j(D));
                if (u0 === 0)
                  return e4(D);
                if (u0 === 1)
                  for (; ; ) {
                    G0(D, 10);
                    var X0 = k9(j(D));
                    if (3 < X0 >>> 0)
                      return q(D);
                    switch (X0) {
                      case 0:
                        return f0(D);
                      case 1:
                        continue;
                      case 2:
                        r:
                          for (; ; ) {
                            if (Gc(j(D)) === 0)
                              for (; ; ) {
                                G0(D, 10);
                                var J0 = k9(j(D));
                                if (3 < J0 >>> 0)
                                  return q(D);
                                switch (J0) {
                                  case 0:
                                    return V(D);
                                  case 1:
                                    continue;
                                  case 2:
                                    continue r;
                                  default:
                                    G0(D, 8);
                                    var ir = Bt(j(D));
                                    if (ir === 0) {
                                      for (; ; )
                                        if (G0(D, 7), dn(j(D)) !== 0)
                                          return q(D);
                                    }
                                    return ir === 1 ? V(D) : q(D);
                                }
                              }
                            return q(D);
                          }
                      default:
                        G0(D, 8);
                        var Q0 = Bt(j(D));
                        if (Q0 === 0) {
                          for (; ; )
                            if (G0(D, 7), dn(j(D)) !== 0)
                              return q(D);
                        }
                        return Q0 === 1 ? f0(D) : q(D);
                    }
                  }
                return q(D);
              }
              function k0(D) {
                G0(D, 28);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; )
                    if (G0(D, 26), dn(j(D)) !== 0)
                      return q(D);
                }
                return u0 === 1 ? e4(D) : q(D);
              }
              function g0(D) {
                G0(D, 30);
                var u0 = Qv(j(D));
                if (2 < u0 >>> 0)
                  return q(D);
                switch (u0) {
                  case 0:
                    return e4(D);
                  case 1:
                    for (; ; ) {
                      G0(D, 30);
                      var X0 = Mc(j(D));
                      if (3 < X0 >>> 0)
                        return q(D);
                      switch (X0) {
                        case 0:
                          return e4(D);
                        case 1:
                          continue;
                        case 2:
                          r:
                            for (; ; ) {
                              if (pn(j(D)) === 0)
                                for (; ; ) {
                                  G0(D, 30);
                                  var J0 = Mc(j(D));
                                  if (3 < J0 >>> 0)
                                    return q(D);
                                  switch (J0) {
                                    case 0:
                                      return e4(D);
                                    case 1:
                                      continue;
                                    case 2:
                                      continue r;
                                    default:
                                      return i4(D);
                                  }
                                }
                              return q(D);
                            }
                        default:
                          return i4(D);
                      }
                    }
                  default:
                    return i4(D);
                }
              }
              function e0(D) {
                for (; ; ) {
                  G0(D, 30);
                  var u0 = u9(j(D));
                  if (3 < u0 >>> 0)
                    return q(D);
                  switch (u0) {
                    case 0:
                      return e4(D);
                    case 1:
                      return g0(D);
                    case 2:
                      continue;
                    default:
                      return k0(D);
                  }
                }
              }
              function x0(D) {
                for (; ; )
                  if (G0(D, 15), dn(j(D)) !== 0)
                    return q(D);
              }
              function l(D) {
                G0(D, 15);
                var u0 = Bt(j(D));
                if (u0 === 0) {
                  for (; ; )
                    if (G0(D, 15), dn(j(D)) !== 0)
                      return q(D);
                }
                return u0 === 1 ? x0(D) : q(D);
              }
              function c0(D) {
                for (; ; ) {
                  G0(D, 16);
                  var u0 = Mr0(j(D));
                  if (4 < u0 >>> 0)
                    return q(D);
                  switch (u0) {
                    case 0:
                      return x0(D);
                    case 1:
                      return g0(D);
                    case 2:
                      continue;
                    case 3:
                      for (; ; ) {
                        G0(D, 15);
                        var X0 = u9(j(D));
                        if (3 < X0 >>> 0)
                          return q(D);
                        switch (X0) {
                          case 0:
                            return x0(D);
                          case 1:
                            return g0(D);
                          case 2:
                            continue;
                          default:
                            return l(D);
                        }
                      }
                    default:
                      return l(D);
                  }
                }
              }
              function t0(D) {
                G0(D, 30);
                var u0 = Or0(j(D));
                if (3 < u0 >>> 0)
                  return q(D);
                switch (u0) {
                  case 0:
                    return e4(D);
                  case 1:
                    for (; ; ) {
                      G0(D, 30);
                      var X0 = Ps(j(D));
                      if (4 < X0 >>> 0)
                        return q(D);
                      switch (X0) {
                        case 0:
                          return e4(D);
                        case 1:
                          continue;
                        case 2:
                          return T(D);
                        case 3:
                          r:
                            for (; ; ) {
                              if (pn(j(D)) === 0)
                                for (; ; ) {
                                  G0(D, 30);
                                  var J0 = Ps(j(D));
                                  if (4 < J0 >>> 0)
                                    return q(D);
                                  switch (J0) {
                                    case 0:
                                      return e4(D);
                                    case 1:
                                      continue;
                                    case 2:
                                      return T(D);
                                    case 3:
                                      continue r;
                                    default:
                                      return i4(D);
                                  }
                                }
                              return q(D);
                            }
                        default:
                          return i4(D);
                      }
                    }
                  case 2:
                    return T(D);
                  default:
                    return i4(D);
                }
              }
              function o0(D) {
                G0(D, 30);
                var u0 = lL(j(D));
                if (8 < u0 >>> 0)
                  return q(D);
                switch (u0) {
                  case 0:
                    return e4(D);
                  case 1:
                    return t0(D);
                  case 2:
                    return c0(D);
                  case 3:
                    return e0(D);
                  case 4:
                    return m0(D);
                  case 5:
                    return T(D);
                  case 6:
                    return K(D);
                  case 7:
                    return A11(D);
                  default:
                    return k0(D);
                }
              }
              function w0(D) {
                r:
                  for (; ; ) {
                    if (pn(j(D)) === 0)
                      for (; ; ) {
                        G0(D, 30);
                        var u0 = Rr0(j(D));
                        if (4 < u0 >>> 0)
                          return q(D);
                        switch (u0) {
                          case 0:
                            return e4(D);
                          case 1:
                            return g0(D);
                          case 2:
                            continue;
                          case 3:
                            continue r;
                          default:
                            return k0(D);
                        }
                      }
                    return q(D);
                  }
              }
              function _0(D) {
                for (; ; ) {
                  G0(D, 30);
                  var u0 = o9(j(D));
                  if (5 < u0 >>> 0)
                    return q(D);
                  switch (u0) {
                    case 0:
                      return e4(D);
                    case 1:
                      return t0(D);
                    case 2:
                      continue;
                    case 3:
                      return T(D);
                    case 4:
                      return w0(D);
                    default:
                      return k0(D);
                  }
                }
              }
              function E0(D) {
                return G0(D, 3), Ur0(j(D)) === 0 ? 3 : q(D);
              }
              function U0(D) {
                return m9(j(D)) === 0 && v9(j(D)) === 0 && Br0(j(D)) === 0 && Ar0(j(D)) === 0 && Nr0(j(D)) === 0 && vL(j(D)) === 0 && Bl(j(D)) === 0 && m9(j(D)) === 0 && Ls(j(D)) === 0 && Cr0(j(D)) === 0 && Ul(j(D)) === 0 ? 3 : q(D);
              }
              gn(n);
              var b = j(n), R0 = ef < b ? vw < b ? -1 : Uk < b ? C3 < b ? Bw < b ? EE < b ? Wy < b ? 1 : 6 : Jd < b ? lE < b ? uF < b ? 1 : 6 : ZT < b ? 1 : 6 : WF < b ? bA < b ? 1 : 6 : sI < b ? 1 : 6 : C6 < b ? E4 < b ? x6 < b ? V8 < b ? j3 < b ? r3 < b ? CO < b ? 1 : 6 : LI < b ? 1 : 6 : Iy < b ? hg < b ? 1 : 6 : Mw < b ? 1 : 6 : L3 < b ? w8 < b ? jg < b ? 1 : 6 : $4 < b ? 1 : 6 : W8 < b ? zT < b ? 1 : 6 : kk < b ? 1 : 6 : O4 < b ? YO < b ? l3 < b ? Qk < b ? 1 : 6 : fk < b ? 1 : 6 : xp < b ? V6 < b ? 1 : 6 : Td < b ? 1 : 6 : G8 < b ? s4 < b ? t6 < b ? 1 : 6 : q6 < b ? 1 : 6 : B6 < b ? S4 < b ? 1 : 6 : fn < b ? 1 : 6 : LE < b ? M4 < b ? g6 < b ? SF < b ? i8 < b ? 1 : 6 : d8 < b ? 1 : 6 : F4 < b ? JF < b ? 1 : 6 : mh < b ? 1 : 6 : U6 < b ? n8 < b ? s3 < b ? 1 : 6 : S8 < b ? 1 : 6 : BS < b ? L8 < b ? 1 : 6 : K3 < b ? 1 : 6 : m8 < b ? f8 < b ? x8 < b ? w3 < b ? 1 : 6 : _6 < b ? 1 : 6 : s6 < b ? oF < b ? 1 : 6 : ZO < b ? 1 : 6 : a3 < b ? DS < b ? e8 < b ? 1 : 6 : g8 < b ? 1 : 6 : J3 < b ? sF < b ? 1 : 6 : ig < b ? 1 : 6 : iw < b ? Ek < b ? wk < b ? qk < b ? FT < b ? Vk < b ? 1 : 6 : uA < b ? 1 : 6 : dy < b ? VS < b ? 1 : 6 : _d2 < b ? 1 : 6 : Th < b ? pF < b ? FE < b ? 1 : 6 : Zw < b ? 1 : 6 : Sy < b ? L_ < b ? 1 : 6 : CE < b ? 1 : 6 : LF2 < b ? Vw < b ? My < b ? rw < b ? 1 : 6 : XI < b ? 1 : 6 : jO < b ? ap < b ? 1 : 6 : jT < b ? 1 : 6 : Ot < b ? OA < b ? gA < b ? 1 : 6 : 1 : 6 : c6 < b ? w6 < b ? l6 < b ? k3 < b ? VE < b ? 1 : 6 : qw < b ? 1 : 6 : v4 < b ? nE < b ? 1 : 6 : Ty < b ? 1 : 6 : c3 < b ? V4 < b ? eg < b ? 1 : 6 : qF < b ? 1 : 6 : X4 < b ? _T < b ? 1 : 6 : Oy < b ? 1 : 6 : D6 < b ? D4 < b ? V3 < b ? MS < b ? 1 : 6 : Ww < b ? 1 : 6 : cy < b ? jy < b ? 1 : 6 : VT < b ? 1 : 6 : B4 < b ? bh < b ? JT < b ? 1 : 6 : G3 < b ? 1 : 6 : r6 < b ? sO < b ? 1 : 6 : ZE < b ? 1 : 6 : uT < b ? Z4 < b ? Yd < b ? Q6 < b ? L4 < b ? N6 < b ? vp < b ? D_ < b ? 1 : 6 : Pd < b ? 1 : 6 : pd < b ? Rg < b ? 1 : 6 : OS < b ? 1 : 6 : G6 < b ? I3 < b ? uk < b ? 1 : 6 : cE < b ? 1 : 6 : l8 < b ? l4 < b ? 1 : 6 : rh < b ? 1 : 6 : M3 < b ? FS < b ? NE < b ? aT < b ? 1 : 6 : kT < b ? 1 : 6 : uS < b ? d3 < b ? 1 : 6 : zd < b ? 1 : 6 : ly < b ? T6 < b ? Pg < b ? 1 : 6 : vy < b ? 1 : 6 : LO < b ? yF < b ? 1 : 6 : YF < b ? 1 : 6 : DI < b ? au < b ? jF < b ? Ah < b ? AO < b ? 1 : 6 : Cd < b ? 1 : 6 : qh < b ? AS < b ? 1 : 6 : lA < b ? 1 : 6 : cO < b ? AI < b ? xI < b ? 1 : 6 : B_ < b ? 1 : 6 : hS < b ? fT < b ? 1 : 6 : mg < b ? 1 : 6 : NO < b ? Nw < b ? Yh < b ? lw < b ? 1 : 6 : Qg < b ? 1 : 6 : Vg < b ? Lk < b ? 1 : 6 : qO < b ? 1 : 6 : iS < b ? b6 < b ? h6 < b ? 1 : 6 : $F < b ? 1 : 6 : ph < b ? rT < b ? 1 : 6 : HS < b ? 1 : 6 : zO < b ? Ck < b ? yS < b ? Iw < b ? CI < b ? Kg < b ? 1 : 6 : VO < b ? 1 : 6 : Mk < b ? ks < b ? 1 : 6 : PF < b ? 1 : 6 : kd < b ? TS < b ? wI < b ? 1 : 6 : xg < b ? 1 : 6 : Rd < b ? dh < b ? 1 : 6 : oI < b ? 1 : 6 : oT < b ? lg < b ? tF < b ? KI < b ? 1 : 6 : pk < b ? 1 : 6 : G_ < b ? kw < b ? 1 : 6 : QF < b ? 1 : 6 : jk < b ? FO < b ? mA < b ? 1 : 6 : _g < b ? 1 : 6 : WE < b ? lF < b ? 1 : 6 : MF < b ? 1 : 6 : h4 < b ? h3 < b ? vT < b ? jI < b ? mS < b ? 1 : 6 : cA < b ? 1 : 6 : DE < b ? zk < b ? 1 : 6 : Lg < b ? 1 : 6 : AT < b ? R6 < b ? bk < b ? 1 : 6 : iT < b ? 1 : 6 : US < b ? BT < b ? 1 : 6 : vE < b ? 1 : 6 : Wc < b ? Sk < b ? D3 < b ? Xg < b ? 1 : 6 : fd < b ? 1 : 6 : IF < b ? ld < b ? 1 : 6 : nA < b ? 1 : 6 : BE < b ? W3 < b ? sy < b ? 1 : 6 : kI < b ? 1 : 6 : VF < b ? fS < b ? 1 : 6 : P4 < b ? 1 : 6 : vS < b ? jw < b ? ik < b ? hO < b ? iI < b ? bg < b ? Nd < b ? 1 : 6 : u3 < b ? 1 : 6 : sE < b ? Ld < b ? 1 : 6 : Xk < b ? 1 : 6 : up < b ? hh < b ? M8 < b ? 1 : 6 : p3 < b ? 1 : 6 : Ew < b ? pE < b ? 1 : 6 : Bg < b ? 1 : 6 : by < b ? Zk < b ? $T < b ? zF < b ? 1 : 6 : Bd < b ? 1 : 6 : $k < b ? TI < b ? 1 : 6 : pO < b ? 1 : 6 : sS < b ? RO < b ? kA < b ? 1 : 6 : wA < b ? 1 : 6 : fg < b ? qI < b ? 1 : 6 : dS < b ? 1 : 6 : hI < b ? NI < b ? nS < b ? Xy < b ? J_ < b ? 1 : 6 : bT < b ? 1 : 6 : $O < b ? Eg < b ? 1 : 6 : oA < b ? 1 : 6 : uE < b ? ET < b ? dg < b ? 1 : 6 : TT < b ? 1 : 6 : Ay < b ? u8 < b ? 1 : 6 : ZS < b ? 1 : 6 : Gh < b ? M_ < b ? SO < b ? lh < b ? 1 : 6 : XE < b ? 1 : 6 : Q3 < b ? Z6 < b ? 1 : 6 : Od < b ? 1 : 6 : W6 < b ? RF < b ? qy < b ? 1 : 6 : Nk < b ? 1 : 6 : PE < b ? Tg < b ? 1 : 6 : OI < b ? 1 : 6 : A8 < b ? P_ < b ? C4 < b ? $g < b ? Uh < b ? WS < b ? 1 : 6 : j6 < b ? 1 : 6 : _E < b ? fI < b ? 1 : 6 : Pw < b ? 1 : 6 : f3 < b ? a8 < b ? UF < b ? 1 : 6 : Lw < b ? 1 : 6 : mk < b ? aI < b ? 1 : 6 : yy < b ? 1 : 6 : O8 < b ? uI < b ? u6 < b ? ky < b ? 1 : 6 : GI < b ? 1 : 6 : c8 < b ? Ow < b ? 1 : 6 : bE < b ? 1 : 6 : y3 < b ? fp < b ? eE < b ? 1 : 6 : I8 < b ? 1 : 6 : cw < b ? KF < b ? 1 : 6 : VI < b ? 1 : 6 : zh < b ? QO < b ? h8 < b ? hy < b ? ew < b ? 1 : 6 : i3 < b ? 1 : 6 : pI < b ? dA < b ? 1 : 6 : qd < b ? 1 : 6 : kg < b ? iE < b ? TO < b ? 1 : 6 : X6 < b ? 1 : 6 : Rw < b ? aw < b ? 1 : 6 : F3 < b ? 1 : 6 : Ik < b ? OF < b ? Ly < b ? m4 < b ? 1 : 6 : cd < b ? 1 : 6 : zg < b ? Jk < b ? 1 : 6 : aS < b ? 1 : 6 : B3 < b ? IO < b ? hw < b ? 1 : 6 : mE < b ? 1 : 6 : $S < b ? QI < b ? 1 : 6 : FA < b ? 1 : 6 : od < b ? KE < b ? Rk < b ? J6 < b ? Md < b ? xF < b ? Zg < b ? sh < b ? eT < b ? 1 : 6 : YI < b ? 1 : 6 : RE < b ? OT < b ? 1 : 6 : J8 < b ? 1 : 6 : IA < b ? dE < b ? qT < b ? 1 : 6 : hd < b ? 1 : 6 : Id < b ? Mh < b ? 1 : 6 : _S < b ? 1 : 6 : EA < b ? PO < b ? Hg < b ? sg < b ? 1 : 6 : Ug < b ? 1 : 6 : Xw < b ? td < b ? 1 : 6 : Dg < b ? 1 : 6 : Ag < b ? bS < b ? Wd < b ? 1 : 6 : Fg < b ? 1 : 6 : tA < b ? wT < b ? 1 : 6 : Dk < b ? 1 : 6 : rS < b ? Z8 < b ? JI < b ? AE < b ? ME < b ? 1 : 6 : pA < b ? 1 : 6 : EO < b ? Gy < b ? 1 : 6 : fA < b ? 1 : 6 : xA < b ? b4 < b ? _k < b ? 1 : 6 : oO < b ? 1 : 6 : wd < b ? S7 < b ? 1 : 6 : $d < b ? 1 : 6 : X8 < b ? z_ < b ? Fd < b ? Ph < b ? 1 : 6 : dT < b ? 1 : 6 : Dd < b ? Ok < b ? 1 : 6 : ah < b ? 1 : 6 : nh < b ? ag < b ? $w < b ? 1 : 6 : WT < b ? 1 : 6 : QS < b ? Fw < b ? 1 : 6 : LT < b ? 1 : 6 : Ih < b ? vk < b ? En < b ? p8 < b ? gT < b ? M6 < b ? 1 : 6 : gh < b ? 1 : 6 : J4 < b ? Q_ < b ? 1 : 6 : op < b ? 1 : 6 : vO < b ? GE < b ? ch < b ? 1 : 6 : q_ < b ? 1 : 6 : ES < b ? UT < b ? 1 : 6 : jS < b ? 1 : 6 : Uw < b ? ty < b ? sA < b ? Vh < b ? 1 : 6 : sT < b ? 1 : 6 : iF < b ? Zd < b ? 1 : 6 : FI < b ? 1 : 6 : xO < b ? th < b ? ng < b ? 1 : 6 : bd < b ? 1 : 6 : iO < b ? _O < b ? 1 : 6 : eO < b ? 1 : 6 : IS < b ? zE < b ? fO < b ? ck < b ? xh < b ? 1 : 6 : ud < b ? 1 : 6 : JS < b ? _w < b ? 1 : 6 : Fy < b ? 1 : 6 : vA < b ? $E < b ? KT < b ? 1 : 6 : rI < b ? 1 : 6 : uy < b ? Tw < b ? 1 : 6 : 1 : nT < b ? Z3 < b ? ek < b ? 6 : $y < b ? 1 : 6 : GF < b ? Qw < b ? 1 : 6 : sk < b ? 1 : 6 : vg < b ? nO < b ? tI < b ? 1 : 6 : GO < b ? 1 : 6 : Ry < b ? 1 : 6 : D8 < b ? Ed < b ? xw < b ? Oh < b ? rA < b ? 6 : $h < b ? tT < b ? 1 : 6 : vF < b ? 1 : 6 : Qy < b ? zI < b ? ry < b ? 1 : 6 : yh < b ? 1 : 6 : HE < b ? Jh < b ? 1 : 6 : hF < b ? 1 : 6 : rp < b ? z4 < b ? S6 < b ? py < b ? 1 : 6 : rg < b ? 1 : 6 : $8 < b ? yO < b ? 1 : 6 : Bk < b ? 1 : 6 : gk < b ? U8 < b ? EF < b ? 1 : 6 : wy < b ? 1 : 6 : og < b ? Tk < b ? 1 : 6 : wE < b ? 1 : 6 : Gw < b ? $_ < b ? ey < b ? pS < b ? oE < b ? 1 : 6 : 1 : 6 : dw < b ? 6 : Q4 < b ? IT < b ? 1 : 6 : yg < b ? 1 : 6 : eI < b ? t3 < b ? Ma < b ? Do < b ? 1 : 2 : BI < b ? 1 : 6 : ow < b ? MT < b ? 1 : 6 : YS < b ? 1 : 6 : yI < b ? tS < b ? Zh < b ? 1 : 6 : CT < b ? 1 : 6 : GT < b ? Kw < b ? 1 : 6 : SI < b ? 1 : 6 : UI < b ? tk < b ? Qn < b ? R4 < b ? q3 < b ? id < b ? 1 : 6 : _F < b ? 1 : 6 : z3 < b ? L6 < b ? 1 : 6 : fh < b ? 1 : 6 : PT < b ? ip < b ? uw < b ? 1 : 6 : eS < b ? 1 : 6 : tO < b ? e3 < b ? 1 : 6 : oh < b ? 1 : 6 : dk < b ? zS < b ? Qh < b ? ug < b ? 1 : 6 : iy < b ? 1 : 6 : Wk < b ? Kd < b ? 1 : 6 : TE < b ? 1 : 6 : dd < b ? my < b ? cF < b ? 1 : 6 : _A < b ? 1 : 6 : Ny < b ? 1 : 6 : Xd < b ? H3 < b ? o3 < b ? Jw < b ? 1 : 6 : av < b ? 6 : RT < b ? 1 : 6 : gF < b ? k6 < b ? NF < b ? 1 : 6 : Wh < b ? 1 : 6 : Gk < b ? Dh < b ? 1 : 6 : ZI < b ? 1 : 6 : Vd < b ? cS < b ? lT < b ? cI < b ? 1 : 6 : 1 : Dy < b ? 6 : Jy < b ? 1 : 6 : FF < b ? sd < b ? 1 : 6 : XT < b ? OO < b ? 1 : 6 : aO < b ? 1 : 6 : wh < b ? F8 < b ? W_ < b ? uh < b ? kO < b ? ed < b ? EI < b ? Aw < b ? 1 : 6 : yA < b ? 1 : 6 : Bh < b ? fy < b ? 1 : 6 : ak < b ? 1 : 6 : CF < b ? TA < b ? lp < b ? 1 : 6 : 1 : 6 : yT < b ? Hd < b ? kS < b ? zy < b ? 1 : 6 : wS < b ? 1 : 6 : v6 < b ? Hk < b ? 1 : 6 : kE < b ? 1 : 6 : Sw < b ? pw < b ? 1 : 6 : _h < b ? WO < b ? 1 : 6 : k8 < b ? 1 : 6 : kF < b ? DO < b ? XF < b ? gy < b ? Sd < b ? 1 : 6 : eA < b ? 1 : 6 : Z_ < b ? JE < b ? 1 : 6 : ay < b ? 1 : 6 : Ky < b ? _8 < b ? Uy < b ? 1 : 6 : n3 < b ? 1 : 6 : rE < b ? oy < b ? 1 : 6 : cg < b ? 1 : 6 : Yy < b ? SA < b ? xS < b ? rF < b ? 1 : 6 : Xh < b ? 1 : 6 : mI < b ? lk < b ? 1 : 6 : uO < b ? 1 : 6 : PS < b && aA < b ? 1 : 6 : yk < b ? Rh < b ? tg < b ? nk < b ? 6 : Zy < b ? bI < b ? 1 : 6 : Ch < b ? 1 : 6 : xE < b ? ok < b ? V_ < b ? 1 : 6 : 1 : 6 : Og < b ? UO < b && oS < b ? 1 : 6 : bw < b ? rO < b ? Lh < b ? 1 : 6 : 1 : dF < b ? 6 : 1 : Eh < b ? gE < b ? U3 < b ? 6 : tw < b ? 1 : 6 : dI < b ? Qd < b ? wO < b ? 1 : 6 : R_ < b ? 1 : 6 : Sh < b ? 1 : 6 : BF < b ? gg < b ? Ad < b ? 1 : 6 : XS < b ? 1 : 6 : Kk < b ? YE < b ? 6 : ih < b ? 1 : 6 : U_ < b ? yE < b ? 1 : 6 : Ht < b ? 1 : 6 : GS < b ? jE < b ? dO < b ? q4 < b ? Ey < b ? E8 < b ? RI < b ? 1 : 6 : nF < b ? 1 : 6 : HF < b ? 1 : 6 : ww < b ? E3 < b ? de < b ? 1 : 6 : 1 : 6 : Ig < b ? Gd < b ? X_ < b ? H_ < b ? 1 : 6 : 1 : 6 : Hw < b ? T3 < b ? vd < b ? 1 : 6 : fF < b ? 1 : 6 : wg < b ? 1 : 6 : z8 < b ? j8 < b ? Eo < b ? PI < b ? 6 : Qx < b ? 1 : 2 : F6 < b ? By < b ? 1 : 6 : IE < b ? 1 : 6 : K8 < b ? z6 < b ? Cg < b ? 1 : 6 : cT < b ? 1 : 6 : o8 < b ? tt < b ? 1 : 6 : Ak < b ? 1 : 6 : NS < b ? tE < b ? j4 < b ? Ng < b ? 1 : 6 : $I < b ? 1 : 6 : P6 < b ? TF < b ? 1 : 6 : p4 < b ? 1 : 6 : _I < b ? fE < b ? gI < b ? 1 : 6 : N3 < b ? 1 : 6 : G4 < b ? B8 < b ? 1 : 6 : Sg < b ? 1 : 6 : N8 < b ? QE < b ? aE < b ? Yk < b ? pT < b ? K_ < b ? 1 : 6 : wF < b ? 1 : 6 : UE < b ? 1 : 6 : rd < b ? vI < b ? 6 : 1 : 6 : MO < b ? mw < b ? YT < b ? s8 < b ? 1 : 6 : AA < b ? 1 : 6 : Yw < b ? Y_ < b ? 1 : 6 : 1 : 6 : Gg < b ? JO < b ? $3 < b ? sp < b ? P8 < b ? 1 : 6 : Q8 < b ? 1 : 6 : gr < b ? t8 < b ? 1 : 6 : 1 : g4 < b ? KS < b ? 6 : m6 < b ? 1 : 6 : mF < b ? Cy < b ? 1 : 6 : R3 < b ? 1 : 6 : Pk < b ? HI < b ? QT < b ? x3 < b ? 1 : 6 : mO < b ? 1 : 6 : Py < b ? O3 < b ? 1 : 6 : ep < b ? 1 : 6 : mo < b ? xc < b ? ox < b ? 1 : 2 : fo < b ? 1 : 2 : $u < b ? Hu < b ? 1 : 3 : Co < b ? 1 : 2 : Vr(PLr, b + 1 | 0) - 1 | 0;
              if (30 < R0 >>> 0)
                var X = q(n);
              else
                switch (R0) {
                  case 0:
                    var X = 62;
                    break;
                  case 1:
                    var X = 63;
                    break;
                  case 2:
                    if (G0(n, 1), jc(j(n)) === 0) {
                      for (; ; )
                        if (G0(n, 1), jc(j(n)) !== 0) {
                          var X = q(n);
                          break;
                        }
                    } else
                      var X = q(n);
                    break;
                  case 3:
                    var X = 0;
                    break;
                  case 4:
                    G0(n, 0);
                    var s0 = xi(j(n)) !== 0 ? 1 : 0, X = s0 && q(n);
                    break;
                  case 5:
                    var X = 6;
                    break;
                  case 6:
                    var X = 61;
                    break;
                  case 7:
                    if (G0(n, 63), Bl(j(n)) === 0) {
                      var hr = j(n), Ar = s7 < hr ? L7 < hr ? -1 : 0 : -1;
                      if (Ar === 0 && Ul(j(n)) === 0 && Bl(j(n)) === 0)
                        var or = j(n), W0 = Yt < or ? Zc < or ? -1 : 0 : -1, X = W0 === 0 && gr0(j(n)) === 0 ? 31 : q(n);
                      else
                        var X = q(n);
                    } else
                      var X = q(n);
                    break;
                  case 8:
                    var X = 56;
                    break;
                  case 9:
                    var X = 38;
                    break;
                  case 10:
                    var X = 39;
                    break;
                  case 11:
                    G0(n, 53);
                    var X = qr0(j(n)) === 0 ? 4 : q(n);
                    break;
                  case 12:
                    var X = 59;
                    break;
                  case 13:
                    var X = 43;
                    break;
                  case 14:
                    G0(n, 60);
                    var Lr = ql(j(n));
                    if (3 < Lr >>> 0)
                      var X = q(n);
                    else
                      switch (Lr) {
                        case 0:
                          for (; ; ) {
                            var Tr = ql(j(n));
                            if (3 < Tr >>> 0)
                              var X = q(n);
                            else
                              switch (Tr) {
                                case 0:
                                  continue;
                                case 1:
                                  var X = d(n);
                                  break;
                                case 2:
                                  var X = o0(n);
                                  break;
                                default:
                                  var X = _0(n);
                              }
                            break;
                          }
                          break;
                        case 1:
                          var X = d(n);
                          break;
                        case 2:
                          var X = o0(n);
                          break;
                        default:
                          var X = _0(n);
                      }
                    break;
                  case 15:
                    G0(n, 41);
                    var Hr = D1(j(n)), X = Hr === 0 ? cL(j(n)) === 0 ? 40 : q(n) : Hr === 1 ? E(n) : q(n);
                    break;
                  case 16:
                    G0(n, 63);
                    var Or = d9(j(n));
                    if (Or === 0) {
                      G0(n, 2);
                      var fr = i9(j(n));
                      if (2 < fr >>> 0)
                        var X = q(n);
                      else
                        switch (fr) {
                          case 0:
                            for (; ; ) {
                              var Rr = i9(j(n));
                              if (2 < Rr >>> 0)
                                var X = q(n);
                              else
                                switch (Rr) {
                                  case 0:
                                    continue;
                                  case 1:
                                    var X = E0(n);
                                    break;
                                  default:
                                    var X = U0(n);
                                }
                              break;
                            }
                            break;
                          case 1:
                            var X = E0(n);
                            break;
                          default:
                            var X = U0(n);
                        }
                    } else
                      var X = Or === 1 ? 5 : q(n);
                    break;
                  case 17:
                    G0(n, 30);
                    var Wr = lL(j(n));
                    if (8 < Wr >>> 0)
                      var X = q(n);
                    else
                      switch (Wr) {
                        case 0:
                          var X = e4(n);
                          break;
                        case 1:
                          var X = t0(n);
                          break;
                        case 2:
                          var X = c0(n);
                          break;
                        case 3:
                          var X = e0(n);
                          break;
                        case 4:
                          var X = m0(n);
                          break;
                        case 5:
                          var X = T(n);
                          break;
                        case 6:
                          var X = K(n);
                          break;
                        case 7:
                          var X = A11(n);
                          break;
                        default:
                          var X = k0(n);
                      }
                    break;
                  case 18:
                    G0(n, 30);
                    var Jr = o9(j(n));
                    if (5 < Jr >>> 0)
                      var X = q(n);
                    else
                      switch (Jr) {
                        case 0:
                          var X = e4(n);
                          break;
                        case 1:
                          var X = t0(n);
                          break;
                        case 2:
                          var X = _0(n);
                          break;
                        case 3:
                          var X = T(n);
                          break;
                        case 4:
                          var X = w0(n);
                          break;
                        default:
                          var X = k0(n);
                      }
                    break;
                  case 19:
                    var X = 44;
                    break;
                  case 20:
                    var X = 42;
                    break;
                  case 21:
                    var X = 49;
                    break;
                  case 22:
                    G0(n, 51);
                    var ar = j(n), _r = 61 < ar ? 62 < ar ? -1 : 0 : -1, X = _r === 0 ? 57 : q(n);
                    break;
                  case 23:
                    var X = 50;
                    break;
                  case 24:
                    G0(n, 46);
                    var X = cL(j(n)) === 0 ? 45 : q(n);
                    break;
                  case 25:
                    var X = 32;
                    break;
                  case 26:
                    if (G0(n, 63), Ls(j(n)) === 0) {
                      var Ir = L1(j(n));
                      if (Ir === 0)
                        var X = Nn(j(n)) === 0 && Nn(j(n)) === 0 && Nn(j(n)) === 0 ? 61 : q(n);
                      else if (Ir === 1 && Nn(j(n)) === 0)
                        for (; ; ) {
                          var fe = A1(j(n));
                          if (fe !== 0) {
                            var X = fe === 1 ? 61 : q(n);
                            break;
                          }
                        }
                      else
                        var X = q(n);
                    } else
                      var X = q(n);
                    break;
                  case 27:
                    var X = 33;
                    break;
                  case 28:
                    G0(n, 34);
                    var v0 = j(n), P = ts < v0 ? X2 < v0 ? -1 : 0 : -1, X = P === 0 ? 36 : q(n);
                    break;
                  case 29:
                    G0(n, 55);
                    var L = j(n), Q = X2 < L ? br < L ? -1 : 0 : -1, X = Q === 0 ? 37 : q(n);
                    break;
                  default:
                    var X = 35;
                }
              if (63 < X >>> 0)
                return ke(SCr);
              var i0 = X;
              if (32 <= i0)
                switch (i0) {
                  case 34:
                    return [0, t4, 0];
                  case 35:
                    return [0, t4, 1];
                  case 36:
                    return [0, t4, 2];
                  case 37:
                    return [0, t4, 3];
                  case 38:
                    return [0, t4, 4];
                  case 39:
                    return [0, t4, 5];
                  case 40:
                    return [0, t4, 12];
                  case 41:
                    return [0, t4, 10];
                  case 42:
                    return [0, t4, 8];
                  case 43:
                    return [0, t4, 9];
                  case 45:
                    return [0, t4, 83];
                  case 49:
                    return [0, t4, 98];
                  case 50:
                    return [0, t4, 99];
                  case 53:
                    return [0, t4, Yt];
                  case 55:
                    return [0, t4, 89];
                  case 56:
                    return [0, t4, 91];
                  case 57:
                    return [0, t4, 11];
                  case 59:
                    return [0, t4, s7];
                  case 60:
                    return [0, t4, L7];
                  case 61:
                    var l0 = n[6];
                    Hr0(n);
                    var S0 = Hl(t4, l0, n[3]);
                    tL(n, l0);
                    var T0 = Ll(n), rr = Wr0(t4, T0), L0 = rr[2], B = rr[1], Z7 = Ee(L0, OCr);
                    if (0 <= Z7) {
                      if (!(0 < Z7))
                        return [0, B, Av];
                      if (!n0(L0, MCr))
                        return [0, B, 29];
                      if (!n0(L0, BCr))
                        return [0, B, A2];
                      if (!n0(L0, qCr))
                        return [0, B, 42];
                      if (!n0(L0, UCr))
                        return [0, B, Sv];
                      if (!n0(L0, HCr))
                        return [0, B, tl];
                      if (!n0(L0, XCr))
                        return [0, B, 31];
                      if (!n0(L0, YCr))
                        return [0, B, 46];
                      if (!n0(L0, VCr))
                        return [0, B, uc];
                    } else {
                      if (!n0(L0, ICr))
                        return [0, B, t1];
                      if (!n0(L0, ACr))
                        return [0, B, z2];
                      if (!n0(L0, NCr))
                        return [0, B, GCr];
                      if (!n0(L0, CCr))
                        return [0, B, jCr];
                      if (!n0(L0, PCr))
                        return [0, B, f1];
                      if (!n0(L0, DCr))
                        return [0, B, 41];
                      if (!n0(L0, LCr))
                        return [0, B, 30];
                      if (!n0(L0, RCr))
                        return [0, B, 53];
                    }
                    return [0, B, [4, S0, L0, uL(T0)]];
                  case 62:
                    var p0 = t4[4] ? Gu(t4, nt(t4, n), 6) : t4;
                    return [0, p0, Pn];
                  case 63:
                    return [0, t4, [6, Se(n)]];
                  case 32:
                  case 47:
                    return [0, t4, 6];
                  case 33:
                  case 48:
                    return [0, t4, 7];
                  case 44:
                  case 54:
                    return [0, t4, 86];
                  case 46:
                  case 52:
                    return [0, t4, 85];
                  default:
                    return [0, t4, 82];
                }
              switch (i0) {
                case 0:
                  return [2, d7(t4, n)];
                case 1:
                  return [2, t4];
                case 2:
                  var b0 = ju(t4, n), O0 = $n(zn), M0 = R1(t4, O0, n), er = M0[1];
                  return [1, er, Si(er, b0, M0[2], O0, 1)];
                case 3:
                  var yr = Se(n);
                  if (t4[5]) {
                    var vr = t4[4] ? Yr0(t4, nt(t4, n), yr) : t4, $0 = $m(1, vr), Er = Jm(n);
                    return qn(jl(n, Er - 1 | 0, 1), gCr) && n0(jl(n, Er - 2 | 0, 1), FCr) ? [0, $0, 86] : [2, $0];
                  }
                  var Mr = ju(t4, n), Br = $n(zn);
                  hn(Br, yr);
                  var qr = R1(t4, Br, n), jr = qr[1];
                  return [1, jr, Si(jr, Mr, qr[2], Br, 1)];
                case 4:
                  if (t4[4])
                    return [2, $m(0, t4)];
                  $v(n), gn(n);
                  var $r = Tr0(j(n)) !== 0 ? 1 : 0, ne = $r && q(n);
                  return ne === 0 ? [0, t4, Yt] : ke(TCr);
                case 5:
                  var Qr = ju(t4, n), be = $n(zn), ae = e2(t4, be, n), pe = ae[1];
                  return [1, pe, Si(pe, Qr, ae[2], be, 0)];
                case 6:
                  var oe = Se(n), ce = ju(t4, n), ge = $n(zn), q0 = $n(zn);
                  hn(q0, oe);
                  var Fr = $r0(t4, oe, ge, q0, 0, n), _ = Fr[1], k = [0, _[1], ce, Fr[2]], I = Fr[3], U = Mt(q0);
                  return [0, _, [2, [0, k, Mt(ge), U, I]]];
                case 7:
                  return Rt(t4, n, function(D, u0) {
                    function X0(F0) {
                      if (c9(j(F0)) === 0) {
                        if (Gc(j(F0)) === 0)
                          for (; ; ) {
                            var Sr = n9(j(F0));
                            if (2 < Sr >>> 0)
                              return q(F0);
                            switch (Sr) {
                              case 0:
                                continue;
                              case 1:
                                r:
                                  for (; ; ) {
                                    if (Gc(j(F0)) === 0)
                                      for (; ; ) {
                                        var mr = n9(j(F0));
                                        if (2 < mr >>> 0)
                                          return q(F0);
                                        switch (mr) {
                                          case 0:
                                            continue;
                                          case 1:
                                            continue r;
                                          default:
                                            return 0;
                                        }
                                      }
                                    return q(F0);
                                  }
                              default:
                                return 0;
                            }
                          }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0)
                      for (; ; ) {
                        var ir = N1(j(u0));
                        if (ir !== 0) {
                          var Q0 = ir === 1 ? X0(u0) : q(u0);
                          break;
                        }
                      }
                    else
                      var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, Hi(0, Se(u0))] : ke(ECr);
                  });
                case 8:
                  return [0, t4, Hi(0, Se(n))];
                case 9:
                  return Rt(t4, n, function(D, u0) {
                    function X0(F0) {
                      if (c9(j(F0)) === 0) {
                        if (Gc(j(F0)) === 0)
                          for (; ; ) {
                            G0(F0, 0);
                            var Sr = e9(j(F0));
                            if (Sr !== 0) {
                              if (Sr === 1)
                                r:
                                  for (; ; ) {
                                    if (Gc(j(F0)) === 0)
                                      for (; ; ) {
                                        G0(F0, 0);
                                        var mr = e9(j(F0));
                                        if (mr !== 0) {
                                          if (mr === 1)
                                            continue r;
                                          return q(F0);
                                        }
                                      }
                                    return q(F0);
                                  }
                              return q(F0);
                            }
                          }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0)
                      for (; ; ) {
                        var ir = N1(j(u0));
                        if (ir !== 0) {
                          var Q0 = ir === 1 ? X0(u0) : q(u0);
                          break;
                        }
                      }
                    else
                      var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, qc(0, Se(u0))] : ke(wCr);
                  });
                case 10:
                  return [0, t4, qc(0, Se(n))];
                case 11:
                  return Rt(t4, n, function(D, u0) {
                    function X0(F0) {
                      if (b9(j(F0)) === 0) {
                        if (zu(j(F0)) === 0)
                          for (; ; ) {
                            var Sr = a9(j(F0));
                            if (2 < Sr >>> 0)
                              return q(F0);
                            switch (Sr) {
                              case 0:
                                continue;
                              case 1:
                                r:
                                  for (; ; ) {
                                    if (zu(j(F0)) === 0)
                                      for (; ; ) {
                                        var mr = a9(j(F0));
                                        if (2 < mr >>> 0)
                                          return q(F0);
                                        switch (mr) {
                                          case 0:
                                            continue;
                                          case 1:
                                            continue r;
                                          default:
                                            return 0;
                                        }
                                      }
                                    return q(F0);
                                  }
                              default:
                                return 0;
                            }
                          }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0)
                      for (; ; ) {
                        var ir = N1(j(u0));
                        if (ir !== 0) {
                          var Q0 = ir === 1 ? X0(u0) : q(u0);
                          break;
                        }
                      }
                    else
                      var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, Hi(1, Se(u0))] : ke(kCr);
                  });
                case 12:
                  return [0, t4, Hi(1, Se(n))];
                case 13:
                  return Rt(t4, n, function(D, u0) {
                    function X0(F0) {
                      if (b9(j(F0)) === 0) {
                        if (zu(j(F0)) === 0)
                          for (; ; ) {
                            G0(F0, 0);
                            var Sr = x9(j(F0));
                            if (Sr !== 0) {
                              if (Sr === 1)
                                r:
                                  for (; ; ) {
                                    if (zu(j(F0)) === 0)
                                      for (; ; ) {
                                        G0(F0, 0);
                                        var mr = x9(j(F0));
                                        if (mr !== 0) {
                                          if (mr === 1)
                                            continue r;
                                          return q(F0);
                                        }
                                      }
                                    return q(F0);
                                  }
                              return q(F0);
                            }
                          }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0)
                      for (; ; ) {
                        var ir = N1(j(u0));
                        if (ir !== 0) {
                          var Q0 = ir === 1 ? X0(u0) : q(u0);
                          break;
                        }
                      }
                    else
                      var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, qc(3, Se(u0))] : ke(dCr);
                  });
                case 14:
                  return [0, t4, qc(3, Se(n))];
                case 15:
                  return Rt(t4, n, function(D, u0) {
                    function X0(F0) {
                      if (zu(j(F0)) === 0) {
                        for (; ; )
                          if (G0(F0, 0), zu(j(F0)) !== 0)
                            return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0)
                      for (; ; ) {
                        var ir = N1(j(u0));
                        if (ir !== 0) {
                          var Q0 = ir === 1 ? X0(u0) : q(u0);
                          break;
                        }
                      }
                    else
                      var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, qc(1, Se(u0))] : ke(hCr);
                  });
                case 16:
                  return [0, t4, qc(1, Se(n))];
                case 17:
                  return Rt(t4, n, function(D, u0) {
                    function X0(F0) {
                      if (Zm(j(F0)) === 0) {
                        if (Nn(j(F0)) === 0)
                          for (; ; ) {
                            var Sr = t9(j(F0));
                            if (2 < Sr >>> 0)
                              return q(F0);
                            switch (Sr) {
                              case 0:
                                continue;
                              case 1:
                                r:
                                  for (; ; ) {
                                    if (Nn(j(F0)) === 0)
                                      for (; ; ) {
                                        var mr = t9(j(F0));
                                        if (2 < mr >>> 0)
                                          return q(F0);
                                        switch (mr) {
                                          case 0:
                                            continue;
                                          case 1:
                                            continue r;
                                          default:
                                            return 0;
                                        }
                                      }
                                    return q(F0);
                                  }
                              default:
                                return 0;
                            }
                          }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0)
                      for (; ; ) {
                        var ir = N1(j(u0));
                        if (ir !== 0) {
                          var Q0 = ir === 1 ? X0(u0) : q(u0);
                          break;
                        }
                      }
                    else
                      var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, Hi(2, Se(u0))] : ke(yCr);
                  });
                case 19:
                  return Rt(t4, n, function(D, u0) {
                    function X0(F0) {
                      if (Zm(j(F0)) === 0) {
                        if (Nn(j(F0)) === 0)
                          for (; ; ) {
                            G0(F0, 0);
                            var Sr = _9(j(F0));
                            if (Sr !== 0) {
                              if (Sr === 1)
                                r:
                                  for (; ; ) {
                                    if (Nn(j(F0)) === 0)
                                      for (; ; ) {
                                        G0(F0, 0);
                                        var mr = _9(j(F0));
                                        if (mr !== 0) {
                                          if (mr === 1)
                                            continue r;
                                          return q(F0);
                                        }
                                      }
                                    return q(F0);
                                  }
                              return q(F0);
                            }
                          }
                        return q(F0);
                      }
                      return q(F0);
                    }
                    gn(u0);
                    var J0 = P1(j(u0));
                    if (J0 === 0)
                      for (; ; ) {
                        var ir = N1(j(u0));
                        if (ir !== 0) {
                          var Q0 = ir === 1 ? X0(u0) : q(u0);
                          break;
                        }
                      }
                    else
                      var Q0 = J0 === 1 ? X0(u0) : q(u0);
                    return Q0 === 0 ? [0, D, qc(4, Se(u0))] : ke(_Cr);
                  });
                case 21:
                  return Rt(t4, n, function(D, u0) {
                    function X0(h0) {
                      for (; ; ) {
                        var Kr = wi(j(h0));
                        if (2 < Kr >>> 0)
                          return q(h0);
                        switch (Kr) {
                          case 0:
                            continue;
                          case 1:
                            r:
                              for (; ; ) {
                                if (pn(j(h0)) === 0)
                                  for (; ; ) {
                                    var re = wi(j(h0));
                                    if (2 < re >>> 0)
                                      return q(h0);
                                    switch (re) {
                                      case 0:
                                        continue;
                                      case 1:
                                        continue r;
                                      default:
                                        return 0;
                                    }
                                  }
                                return q(h0);
                              }
                          default:
                            return 0;
                        }
                      }
                    }
                    function J0(h0) {
                      for (; ; ) {
                        var Kr = r22(j(h0));
                        if (Kr !== 0) {
                          var re = Kr !== 1 ? 1 : 0;
                          return re && q(h0);
                        }
                      }
                    }
                    function ir(h0) {
                      var Kr = E9(j(h0));
                      if (2 < Kr >>> 0)
                        return q(h0);
                      switch (Kr) {
                        case 0:
                          var re = C1(j(h0));
                          return re === 0 ? J0(h0) : re === 1 ? X0(h0) : q(h0);
                        case 1:
                          return J0(h0);
                        default:
                          return X0(h0);
                      }
                    }
                    function Q0(h0) {
                      if (pn(j(h0)) === 0)
                        for (; ; ) {
                          var Kr = f7(j(h0));
                          if (2 < Kr >>> 0)
                            return q(h0);
                          switch (Kr) {
                            case 0:
                              continue;
                            case 1:
                              return ir(h0);
                            default:
                              r:
                                for (; ; ) {
                                  if (pn(j(h0)) === 0)
                                    for (; ; ) {
                                      var re = f7(j(h0));
                                      if (2 < re >>> 0)
                                        return q(h0);
                                      switch (re) {
                                        case 0:
                                          continue;
                                        case 1:
                                          return ir(h0);
                                        default:
                                          continue r;
                                      }
                                    }
                                  return q(h0);
                                }
                          }
                        }
                      return q(h0);
                    }
                    function F0(h0) {
                      var Kr = p9(j(h0));
                      if (Kr === 0)
                        for (; ; ) {
                          var re = f7(j(h0));
                          if (2 < re >>> 0)
                            return q(h0);
                          switch (re) {
                            case 0:
                              continue;
                            case 1:
                              return ir(h0);
                            default:
                              r:
                                for (; ; ) {
                                  if (pn(j(h0)) === 0)
                                    for (; ; ) {
                                      var xe = f7(j(h0));
                                      if (2 < xe >>> 0)
                                        return q(h0);
                                      switch (xe) {
                                        case 0:
                                          continue;
                                        case 1:
                                          return ir(h0);
                                        default:
                                          continue r;
                                      }
                                    }
                                  return q(h0);
                                }
                          }
                        }
                      return Kr === 1 ? ir(h0) : q(h0);
                    }
                    function Sr(h0) {
                      var Kr = r9(j(h0));
                      return Kr === 0 ? F0(h0) : Kr === 1 ? ir(h0) : q(h0);
                    }
                    function mr(h0) {
                      for (; ; ) {
                        var Kr = l9(j(h0));
                        if (2 < Kr >>> 0)
                          return q(h0);
                        switch (Kr) {
                          case 0:
                            return F0(h0);
                          case 1:
                            continue;
                          default:
                            return ir(h0);
                        }
                      }
                    }
                    gn(u0);
                    var Cr = f9(j(u0));
                    if (3 < Cr >>> 0)
                      var sr = q(u0);
                    else
                      switch (Cr) {
                        case 0:
                          for (; ; ) {
                            var Pr = ql(j(u0));
                            if (3 < Pr >>> 0)
                              var sr = q(u0);
                            else
                              switch (Pr) {
                                case 0:
                                  continue;
                                case 1:
                                  var sr = Q0(u0);
                                  break;
                                case 2:
                                  var sr = Sr(u0);
                                  break;
                                default:
                                  var sr = mr(u0);
                              }
                            break;
                          }
                          break;
                        case 1:
                          var sr = Q0(u0);
                          break;
                        case 2:
                          var sr = Sr(u0);
                          break;
                        default:
                          var sr = mr(u0);
                      }
                    if (sr === 0) {
                      var K0 = Se(u0), Ur = Gu(D, nt(D, u0), 23);
                      return [0, Ur, Hi(2, K0)];
                    }
                    return ke(mCr);
                  });
                case 22:
                  var Y = Se(n), y0 = Gu(t4, nt(t4, n), 23);
                  return [0, y0, Hi(2, Y)];
                case 23:
                  return Rt(t4, n, function(D, u0) {
                    function X0(K0) {
                      for (; ; ) {
                        G0(K0, 0);
                        var Ur = Ds(j(K0));
                        if (Ur !== 0) {
                          if (Ur === 1)
                            r:
                              for (; ; ) {
                                if (pn(j(K0)) === 0)
                                  for (; ; ) {
                                    G0(K0, 0);
                                    var h0 = Ds(j(K0));
                                    if (h0 !== 0) {
                                      if (h0 === 1)
                                        continue r;
                                      return q(K0);
                                    }
                                  }
                                return q(K0);
                              }
                          return q(K0);
                        }
                      }
                    }
                    function J0(K0) {
                      for (; ; )
                        if (G0(K0, 0), pn(j(K0)) !== 0)
                          return q(K0);
                    }
                    function ir(K0) {
                      var Ur = E9(j(K0));
                      if (2 < Ur >>> 0)
                        return q(K0);
                      switch (Ur) {
                        case 0:
                          var h0 = C1(j(K0));
                          return h0 === 0 ? J0(K0) : h0 === 1 ? X0(K0) : q(K0);
                        case 1:
                          return J0(K0);
                        default:
                          return X0(K0);
                      }
                    }
                    function Q0(K0) {
                      if (pn(j(K0)) === 0)
                        for (; ; ) {
                          var Ur = f7(j(K0));
                          if (2 < Ur >>> 0)
                            return q(K0);
                          switch (Ur) {
                            case 0:
                              continue;
                            case 1:
                              return ir(K0);
                            default:
                              r:
                                for (; ; ) {
                                  if (pn(j(K0)) === 0)
                                    for (; ; ) {
                                      var h0 = f7(j(K0));
                                      if (2 < h0 >>> 0)
                                        return q(K0);
                                      switch (h0) {
                                        case 0:
                                          continue;
                                        case 1:
                                          return ir(K0);
                                        default:
                                          continue r;
                                      }
                                    }
                                  return q(K0);
                                }
                          }
                        }
                      return q(K0);
                    }
                    function F0(K0) {
                      var Ur = p9(j(K0));
                      if (Ur === 0)
                        for (; ; ) {
                          var h0 = f7(j(K0));
                          if (2 < h0 >>> 0)
                            return q(K0);
                          switch (h0) {
                            case 0:
                              continue;
                            case 1:
                              return ir(K0);
                            default:
                              r:
                                for (; ; ) {
                                  if (pn(j(K0)) === 0)
                                    for (; ; ) {
                                      var Kr = f7(j(K0));
                                      if (2 < Kr >>> 0)
                                        return q(K0);
                                      switch (Kr) {
                                        case 0:
                                          continue;
                                        case 1:
                                          return ir(K0);
                                        default:
                                          continue r;
                                      }
                                    }
                                  return q(K0);
                                }
                          }
                        }
                      return Ur === 1 ? ir(K0) : q(K0);
                    }
                    function Sr(K0) {
                      var Ur = r9(j(K0));
                      return Ur === 0 ? F0(K0) : Ur === 1 ? ir(K0) : q(K0);
                    }
                    function mr(K0) {
                      for (; ; ) {
                        var Ur = l9(j(K0));
                        if (2 < Ur >>> 0)
                          return q(K0);
                        switch (Ur) {
                          case 0:
                            return F0(K0);
                          case 1:
                            continue;
                          default:
                            return ir(K0);
                        }
                      }
                    }
                    gn(u0);
                    var Cr = f9(j(u0));
                    if (3 < Cr >>> 0)
                      var sr = q(u0);
                    else
                      switch (Cr) {
                        case 0:
                          for (; ; ) {
                            var Pr = ql(j(u0));
                            if (3 < Pr >>> 0)
                              var sr = q(u0);
                            else
                              switch (Pr) {
                                case 0:
                                  continue;
                                case 1:
                                  var sr = Q0(u0);
                                  break;
                                case 2:
                                  var sr = Sr(u0);
                                  break;
                                default:
                                  var sr = mr(u0);
                              }
                            break;
                          }
                          break;
                        case 1:
                          var sr = Q0(u0);
                          break;
                        case 2:
                          var sr = Sr(u0);
                          break;
                        default:
                          var sr = mr(u0);
                      }
                    return sr === 0 ? [0, D, qc(4, Se(u0))] : ke(pCr);
                  });
                case 25:
                  return Rt(t4, n, function(D, u0) {
                    function X0(K0) {
                      for (; ; ) {
                        var Ur = wi(j(K0));
                        if (2 < Ur >>> 0)
                          return q(K0);
                        switch (Ur) {
                          case 0:
                            continue;
                          case 1:
                            r:
                              for (; ; ) {
                                if (pn(j(K0)) === 0)
                                  for (; ; ) {
                                    var h0 = wi(j(K0));
                                    if (2 < h0 >>> 0)
                                      return q(K0);
                                    switch (h0) {
                                      case 0:
                                        continue;
                                      case 1:
                                        continue r;
                                      default:
                                        return 0;
                                    }
                                  }
                                return q(K0);
                              }
                          default:
                            return 0;
                        }
                      }
                    }
                    function J0(K0) {
                      return pn(j(K0)) === 0 ? X0(K0) : q(K0);
                    }
                    function ir(K0) {
                      var Ur = r22(j(K0));
                      if (Ur === 0)
                        return X0(K0);
                      var h0 = Ur !== 1 ? 1 : 0;
                      return h0 && q(K0);
                    }
                    function Q0(K0) {
                      for (; ; ) {
                        var Ur = D1(j(K0));
                        if (Ur === 0)
                          return ir(K0);
                        if (Ur !== 1)
                          return q(K0);
                      }
                    }
                    function F0(K0) {
                      for (; ; ) {
                        var Ur = Bc(j(K0));
                        if (2 < Ur >>> 0)
                          return q(K0);
                        switch (Ur) {
                          case 0:
                            return ir(K0);
                          case 1:
                            continue;
                          default:
                            r:
                              for (; ; ) {
                                if (pn(j(K0)) === 0)
                                  for (; ; ) {
                                    var h0 = Bc(j(K0));
                                    if (2 < h0 >>> 0)
                                      return q(K0);
                                    switch (h0) {
                                      case 0:
                                        return ir(K0);
                                      case 1:
                                        continue;
                                      default:
                                        continue r;
                                    }
                                  }
                                return q(K0);
                              }
                        }
                      }
                    }
                    gn(u0);
                    var Sr = f9(j(u0));
                    if (3 < Sr >>> 0)
                      var mr = q(u0);
                    else
                      switch (Sr) {
                        case 0:
                          for (; ; ) {
                            var Cr = ql(j(u0));
                            if (3 < Cr >>> 0)
                              var mr = q(u0);
                            else
                              switch (Cr) {
                                case 0:
                                  continue;
                                case 1:
                                  var mr = J0(u0);
                                  break;
                                case 2:
                                  var mr = Q0(u0);
                                  break;
                                default:
                                  var mr = F0(u0);
                              }
                            break;
                          }
                          break;
                        case 1:
                          var mr = J0(u0);
                          break;
                        case 2:
                          var mr = Q0(u0);
                          break;
                        default:
                          var mr = F0(u0);
                      }
                    if (mr === 0) {
                      var sr = Se(u0), Pr = Gu(D, nt(D, u0), 22);
                      return [0, Pr, Hi(2, sr)];
                    }
                    return ke(bCr);
                  });
                case 26:
                  return Rt(t4, n, function(D, u0) {
                    function X0(mr) {
                      for (; ; ) {
                        var Cr = r22(j(mr));
                        if (Cr !== 0) {
                          var sr = Cr !== 1 ? 1 : 0;
                          return sr && q(mr);
                        }
                      }
                    }
                    function J0(mr) {
                      for (; ; ) {
                        var Cr = wi(j(mr));
                        if (2 < Cr >>> 0)
                          return q(mr);
                        switch (Cr) {
                          case 0:
                            continue;
                          case 1:
                            r:
                              for (; ; ) {
                                if (pn(j(mr)) === 0)
                                  for (; ; ) {
                                    var sr = wi(j(mr));
                                    if (2 < sr >>> 0)
                                      return q(mr);
                                    switch (sr) {
                                      case 0:
                                        continue;
                                      case 1:
                                        continue r;
                                      default:
                                        return 0;
                                    }
                                  }
                                return q(mr);
                              }
                          default:
                            return 0;
                        }
                      }
                    }
                    gn(u0);
                    var ir = j(u0), Q0 = 44 < ir ? 57 < ir ? -1 : Vr(XDr, ir + mv | 0) - 1 | 0 : -1;
                    if (2 < Q0 >>> 0)
                      var F0 = q(u0);
                    else
                      switch (Q0) {
                        case 0:
                          for (; ; ) {
                            var Sr = jr0(j(u0));
                            if (2 < Sr >>> 0)
                              var F0 = q(u0);
                            else
                              switch (Sr) {
                                case 0:
                                  continue;
                                case 1:
                                  var F0 = X0(u0);
                                  break;
                                default:
                                  var F0 = J0(u0);
                              }
                            break;
                          }
                          break;
                        case 1:
                          var F0 = X0(u0);
                          break;
                        default:
                          var F0 = J0(u0);
                      }
                    return F0 === 0 ? [0, D, Hi(2, Se(u0))] : ke(lCr);
                  });
                case 27:
                  var P0 = Se(n), I0 = Gu(t4, nt(t4, n), 22);
                  return [0, I0, Hi(2, P0)];
                case 29:
                  return Rt(t4, n, function(D, u0) {
                    function X0(re) {
                      for (; ; ) {
                        G0(re, 0);
                        var xe = Ds(j(re));
                        if (xe !== 0) {
                          if (xe === 1)
                            r:
                              for (; ; ) {
                                if (pn(j(re)) === 0)
                                  for (; ; ) {
                                    G0(re, 0);
                                    var Re = Ds(j(re));
                                    if (Re !== 0) {
                                      if (Re === 1)
                                        continue r;
                                      return q(re);
                                    }
                                  }
                                return q(re);
                              }
                          return q(re);
                        }
                      }
                    }
                    function J0(re) {
                      return G0(re, 0), pn(j(re)) === 0 ? X0(re) : q(re);
                    }
                    gn(u0);
                    var ir = f9(j(u0));
                    if (3 < ir >>> 0)
                      var Q0 = q(u0);
                    else
                      switch (ir) {
                        case 0:
                          for (; ; ) {
                            var F0 = jr0(j(u0));
                            if (2 < F0 >>> 0)
                              var Q0 = q(u0);
                            else
                              switch (F0) {
                                case 0:
                                  continue;
                                case 1:
                                  for (; ; ) {
                                    G0(u0, 0);
                                    var Sr = D1(j(u0)), mr = Sr !== 0 ? 1 : 0;
                                    if (mr) {
                                      if (Sr === 1)
                                        continue;
                                      var Q0 = q(u0);
                                    } else
                                      var Q0 = mr;
                                    break;
                                  }
                                  break;
                                default:
                                  for (; ; ) {
                                    G0(u0, 0);
                                    var Cr = Bc(j(u0));
                                    if (2 < Cr >>> 0)
                                      var Q0 = q(u0);
                                    else
                                      switch (Cr) {
                                        case 0:
                                          var Q0 = 0;
                                          break;
                                        case 1:
                                          continue;
                                        default:
                                          r:
                                            for (; ; ) {
                                              if (pn(j(u0)) === 0)
                                                for (; ; ) {
                                                  G0(u0, 0);
                                                  var sr = Bc(j(u0));
                                                  if (2 < sr >>> 0)
                                                    var Pr = q(u0);
                                                  else
                                                    switch (sr) {
                                                      case 0:
                                                        var Pr = 0;
                                                        break;
                                                      case 1:
                                                        continue;
                                                      default:
                                                        continue r;
                                                    }
                                                  break;
                                                }
                                              else
                                                var Pr = q(u0);
                                              var Q0 = Pr;
                                              break;
                                            }
                                      }
                                    break;
                                  }
                              }
                            break;
                          }
                          break;
                        case 1:
                          var Q0 = pn(j(u0)) === 0 ? X0(u0) : q(u0);
                          break;
                        case 2:
                          for (; ; ) {
                            G0(u0, 0);
                            var K0 = D1(j(u0));
                            if (K0 === 0)
                              var Q0 = J0(u0);
                            else {
                              if (K0 === 1)
                                continue;
                              var Q0 = q(u0);
                            }
                            break;
                          }
                          break;
                        default:
                          for (; ; ) {
                            G0(u0, 0);
                            var Ur = Bc(j(u0));
                            if (2 < Ur >>> 0)
                              var Q0 = q(u0);
                            else
                              switch (Ur) {
                                case 0:
                                  var Q0 = J0(u0);
                                  break;
                                case 1:
                                  continue;
                                default:
                                  r:
                                    for (; ; ) {
                                      if (pn(j(u0)) === 0)
                                        for (; ; ) {
                                          G0(u0, 0);
                                          var h0 = Bc(j(u0));
                                          if (2 < h0 >>> 0)
                                            var Kr = q(u0);
                                          else
                                            switch (h0) {
                                              case 0:
                                                var Kr = J0(u0);
                                                break;
                                              case 1:
                                                continue;
                                              default:
                                                continue r;
                                            }
                                          break;
                                        }
                                      else
                                        var Kr = q(u0);
                                      var Q0 = Kr;
                                      break;
                                    }
                              }
                            break;
                          }
                      }
                    return Q0 === 0 ? [0, D, qc(4, Se(u0))] : ke(vCr);
                  });
                case 31:
                  return [0, t4, 66];
                case 18:
                case 28:
                  return [0, t4, Hi(2, Se(n))];
                default:
                  return [0, t4, qc(4, Se(n))];
              }
            }
            function Xl(t4) {
              return function(n) {
                for (var e4 = 0, i4 = n; ; ) {
                  var x4 = o(t4, i4, i4[2]);
                  switch (x4[0]) {
                    case 0:
                      var c = x4[2], s2 = x4[1], p = Xr0(s2, c), y = e4 === 0 ? 0 : ye(e4), T = s2[6];
                      if (T === 0)
                        return [0, [0, s2[1], s2[2], s2[3], s2[4], s2[5], s2[6], p], [0, c, p, 0, y]];
                      var E = [0, c, p, ye(T), y];
                      return [0, [0, s2[1], s2[2], s2[3], s2[4], s2[5], _r0, p], E];
                    case 1:
                      var d = x4[2], w = x4[1], e4 = [0, d, e4], i4 = [0, w[1], w[2], w[3], w[4], w[5], w[6], d[1]];
                      continue;
                    default:
                      var i4 = x4[1];
                      continue;
                  }
                }
              };
            }
            var Gee = Xl(Dee), Mee = Xl(Lee), Bee = Xl(Ree), qee = Xl(jee), Uee = Xl(Pee), Mu = eL([0, bz]);
            function Yl(t4, n) {
              return [0, 0, 0, n, yr0(t4)];
            }
            function g9(t4) {
              var n = t4[4];
              switch (t4[3]) {
                case 0:
                  var c0 = u(Uee, n);
                  break;
                case 1:
                  var c0 = u(qee, n);
                  break;
                case 2:
                  var c0 = u(Mee, n);
                  break;
                case 3:
                  var e4 = h7(n, n[2]), i4 = $n(zn), x4 = $n(zn), c = n[2];
                  gn(c);
                  var s2 = j(c), p = ts < s2 ? Hu < s2 ? 1 : $u < s2 ? 2 : 1 : Vr(fRr, s2 + 1 | 0) - 1 | 0;
                  if (5 < p >>> 0)
                    var y = q(c);
                  else
                    switch (p) {
                      case 0:
                        var y = 1;
                        break;
                      case 1:
                        var y = 4;
                        break;
                      case 2:
                        var y = 0;
                        break;
                      case 3:
                        G0(c, 0);
                        var T = xi(j(c)) !== 0 ? 1 : 0, y = T && q(c);
                        break;
                      case 4:
                        var y = 2;
                        break;
                      default:
                        var y = 3;
                    }
                  if (4 < y >>> 0)
                    var E = ke(sCr);
                  else
                    switch (y) {
                      case 0:
                        var d = Se(c);
                        hn(x4, d), hn(i4, d);
                        var w = pL(d7(n, c), 2, i4, x4, c), G = h7(w, c), A11 = Mt(i4), S11 = Mt(x4), E = [0, w, [8, [0, w[1], e4, G], A11, S11]];
                        break;
                      case 1:
                        var E = [0, n, Pn];
                        break;
                      case 2:
                        var E = [0, n, 98];
                        break;
                      case 3:
                        var E = [0, n, 0];
                        break;
                      default:
                        $v(c);
                        var M = pL(n, 2, i4, x4, c), K = h7(M, c), V = Mt(i4), f0 = Mt(x4), E = [0, M, [8, [0, M[1], e4, K], V, f0]];
                    }
                  var m0 = E[2], k0 = E[1], g0 = Xr0(k0, m0), e0 = k0[6];
                  if (e0 === 0)
                    var l = [0, k0, [0, m0, g0, 0, 0]];
                  else
                    var x0 = [0, m0, g0, ye(e0), 0], l = [0, [0, k0[1], k0[2], k0[3], k0[4], k0[5], 0, k0[7]], x0];
                  var c0 = l;
                  break;
                case 4:
                  var c0 = u(Bee, n);
                  break;
                default:
                  var c0 = u(Gee, n);
              }
              var t0 = c0[1], o0 = yr0(t0), w0 = [0, o0, c0[2]];
              return t4[4] = t0, t4[1] ? t4[2] = [0, w0] : t4[1] = [0, w0], w0;
            }
            function Qr0(t4) {
              var n = t4[1];
              return n ? n[1][2] : g9(t4)[2];
            }
            function Hee(t4, n, e4, i4) {
              var x4 = t4 && t4[1], c = n && n[1];
              try {
                var s2 = 0, p = pr0(i4), y = s2, T = p;
              } catch (A11) {
                if (A11 = Et(A11), A11 !== I1)
                  throw A11;
                var E = [0, [0, [0, e4, ez[2], ez[3]], 86], 0], y = E, T = pr0(Xjr);
              }
              var d = c ? c[1] : Bv, w = Cee(e4, T, d[4]), G = [0, Yl(w, 0)];
              return [0, [0, y], [0, 0], Mu[1], [0, 0], d[5], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, [0, Vjr], [0, w], G, [0, x4], d, e4, [0, 0], [0, Yjr]];
            }
            function n2(t4) {
              return bl(t4[23][1]);
            }
            function fu(t4) {
              return t4[27][4];
            }
            function ue(t4, n) {
              var e4 = n[2];
              t4[1][1] = [0, [0, n[1], e4], t4[1][1]];
              var i4 = t4[22];
              return i4 && o(i4[1], t4, e4);
            }
            function Vl(t4, n) {
              return t4[30][1] = n, 0;
            }
            function Rs(t4, n) {
              if (t4 === 0)
                return Qr0(n[25][1]);
              if (t4 === 1) {
                var e4 = n[25][1];
                e4[1] || g9(e4);
                var i4 = e4[2];
                return i4 ? i4[1][2] : g9(e4)[2];
              }
              throw [0, Sn, qjr];
            }
            function _s(t4, n) {
              return t4 === n[5] ? n : [0, n[1], n[2], n[3], n[4], t4, n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function mL(t4, n) {
              return t4 === n[17] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], t4, n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function re0(t4, n) {
              return t4 === n[18] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], t4, n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function ee0(t4, n) {
              return t4 === n[19] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], t4, n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function t2(t4, n) {
              return t4 === n[21] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], t4, n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function F9(t4, n) {
              return t4 === n[14] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], t4, n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function zl(t4, n) {
              return t4 === n[8] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], t4, n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function Kl(t4, n) {
              return t4 === n[12] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], t4, n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function u2(t4, n) {
              return t4 === n[15] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], t4, n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function ne0(t4, n) {
              return t4 === n[6] ? n : [0, n[1], n[2], n[3], n[4], n[5], t4, n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function te0(t4, n) {
              return t4 === n[7] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], t4, n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function _L(t4, n) {
              return t4 === n[13] ? n : [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], t4, n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], n[22], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function T9(t4, n) {
              return [0, n[1], n[2], n[3], n[4], n[5], n[6], n[7], n[8], n[9], n[10], n[11], n[12], n[13], n[14], n[15], n[16], n[17], n[18], n[19], n[20], n[21], [0, t4], n[23], n[24], n[25], n[26], n[27], n[28], n[29], n[30]];
            }
            function yL(t4) {
              function n(e4) {
                return ue(t4, e4);
              }
              return function(e4) {
                return Du(n, e4);
              };
            }
            function i2(t4) {
              var n = t4[4][1], e4 = n && [0, n[1][2]];
              return e4;
            }
            function ue0(t4) {
              var n = t4[4][1], e4 = n && [0, n[1][1]];
              return e4;
            }
            function ie0(t4) {
              return [0, t4[1], t4[2], t4[3], t4[4], t4[5], t4[6], t4[7], t4[8], t4[9], t4[10], t4[11], t4[12], t4[13], t4[14], t4[15], t4[16], t4[17], t4[18], t4[19], t4[20], t4[21], 0, t4[23], t4[24], t4[25], t4[26], t4[27], t4[28], t4[29], t4[30]];
            }
            function fe0(t4, n, e4, i4) {
              return [0, t4[1], t4[2], Mu[1], t4[4], t4[5], 0, 0, 0, 0, 0, 1, t4[12], t4[13], t4[14], t4[15], t4[16], e4, n, t4[19], i4, t4[21], t4[22], t4[23], t4[24], t4[25], t4[26], t4[27], t4[28], t4[29], t4[30]];
            }
            function xe0(t4) {
              var n = Ee(t4, xjr), e4 = 0;
              if (0 <= n) {
                if (0 < n) {
                  var i4 = Ee(t4, gjr);
                  0 <= i4 ? 0 < i4 && n0(t4, Djr) && n0(t4, Ljr) && n0(t4, Rjr) && n0(t4, jjr) && n0(t4, Gjr) && n0(t4, Mjr) && n0(t4, Bjr) && (e4 = 1) : n0(t4, Fjr) && n0(t4, Tjr) && n0(t4, Ojr) && n0(t4, Ijr) && n0(t4, Ajr) && n0(t4, Njr) && n0(t4, Cjr) && n0(t4, Pjr) && (e4 = 1);
                }
              } else {
                var x4 = Ee(t4, ojr);
                0 <= x4 ? 0 < x4 && n0(t4, _jr) && n0(t4, yjr) && n0(t4, hjr) && n0(t4, djr) && n0(t4, kjr) && n0(t4, wjr) && n0(t4, Ejr) && n0(t4, Sjr) && (e4 = 1) : n0(t4, ajr) && n0(t4, cjr) && n0(t4, sjr) && n0(t4, vjr) && n0(t4, ljr) && n0(t4, bjr) && n0(t4, pjr) && n0(t4, mjr) && (e4 = 1);
              }
              return e4 ? 0 : 1;
            }
            function O9(t4) {
              return n0(t4, fjr) ? 0 : 1;
            }
            function hL(t4) {
              if (typeof t4 == "number") {
                if (t4 === 48)
                  return 1;
              } else if (t4[0] === 4 && O9(t4[3]))
                return 1;
              return 0;
            }
            function f22(t4) {
              return n0(t4, ZRr) && n0(t4, QRr) && n0(t4, rjr) && n0(t4, ejr) && n0(t4, njr) && n0(t4, tjr) && n0(t4, ujr) && n0(t4, ijr) ? 0 : 1;
            }
            function dL(t4) {
              if (typeof t4 == "number")
                switch (t4) {
                  case 42:
                  case 52:
                  case 53:
                  case 54:
                  case 55:
                  case 56:
                  case 57:
                  case 58:
                    return 1;
                }
              else if (t4[0] === 4 && f22(t4[3]))
                return 1;
              return 0;
            }
            function js(t4) {
              return n0(t4, JRr) && n0(t4, $Rr) ? 0 : 1;
            }
            function oe0(t4) {
              return typeof t4 != "number" && t4[0] === 4 && js(t4[3]) ? 1 : 0;
            }
            function kL(t4) {
              var n = xe0(t4);
              if (n)
                var e4 = n;
              else {
                var i4 = O9(t4);
                if (i4)
                  var e4 = i4;
                else {
                  if (n0(t4, zRr) && n0(t4, KRr) && n0(t4, WRr))
                    return 0;
                  var e4 = 1;
                }
              }
              return e4;
            }
            function ae0(t4) {
              var n = Ee(t4, TRr), e4 = 0;
              return 0 <= n ? 0 < n && n0(t4, RRr) && n0(t4, jRr) && n0(t4, GRr) && n0(t4, MRr) && n0(t4, BRr) && n0(t4, qRr) && n0(t4, URr) && n0(t4, HRr) && (e4 = 1) : n0(t4, ORr) && n0(t4, IRr) && n0(t4, ARr) && n0(t4, NRr) && n0(t4, CRr) && n0(t4, PRr) && n0(t4, DRr) && n0(t4, LRr) && (e4 = 1), e4 ? 0 : 1;
            }
            function Yn(t4, n) {
              return Rs(t4, n)[1];
            }
            function Wl(t4, n) {
              return Rs(t4, n)[2];
            }
            function A0(t4) {
              return Yn(0, t4);
            }
            function Pe(t4) {
              return Wl(0, t4);
            }
            function j1(t4) {
              var n = i2(t4), e4 = n ? n[1] : ke(FRr);
              return [0, e4[1], e4[3], e4[3]];
            }
            function wL(t4) {
              return Rs(0, t4)[3];
            }
            function pr(t4) {
              var n = Rs(0, t4)[4];
              return n && u(ml(function(e4) {
                return ps(t4[30][1], e4[1][2]) <= 0 ? 1 : 0;
              }), n);
            }
            function ce0(t4) {
              for (var n = Rs(0, t4)[4]; ; ) {
                if (n) {
                  var e4 = n[2], i4 = ps(n[1][1][2], t4[30][1]) < 0 ? 1 : 0;
                  if (i4)
                    return i4;
                  var n = e4;
                  continue;
                }
                return 0;
              }
            }
            function Jl(t4, n) {
              var e4 = 0 < t4 ? [0, Wl(t4 - 1 | 0, n)] : i2(n);
              if (e4)
                var i4 = e4[1][2][1], x4 = i4 < Wl(t4, n)[2][1] ? 1 : 0;
              else
                var x4 = e4;
              return x4;
            }
            function x7(t4) {
              return Jl(0, t4);
            }
            function se0(t4, n) {
              var e4 = Yn(t4, n);
              if (typeof e4 == "number") {
                var i4 = e4 - 2 | 0;
                if (Xt < i4 >>> 0) {
                  if (!(T7 < (i4 + 1 | 0) >>> 0))
                    return 1;
                } else {
                  var x4 = i4 !== 6 ? 1 : 0;
                  if (!x4)
                    return x4;
                }
              }
              return Jl(t4, n);
            }
            function x2(t4) {
              return se0(0, t4);
            }
            function I9(t4, n) {
              var e4 = Yn(t4, n);
              if (dL(e4) || hL(e4) || oe0(e4))
                return 1;
              var i4 = 0;
              if (typeof e4 == "number")
                switch (e4) {
                  case 14:
                  case 28:
                  case 60:
                  case 61:
                  case 62:
                  case 63:
                  case 64:
                  case 65:
                    i4 = 1;
                    break;
                }
              else
                e4[0] === 4 && (i4 = 1);
              return i4 ? 1 : 0;
            }
            function ve0(t4, n) {
              var e4 = n2(n);
              if (e4 === 1) {
                var i4 = Yn(t4, n);
                return typeof i4 != "number" && i4[0] === 4 ? 1 : 0;
              }
              if (e4)
                return 0;
              var x4 = Yn(t4, n);
              if (typeof x4 == "number")
                switch (x4) {
                  case 42:
                  case 46:
                  case 47:
                    return 0;
                  case 15:
                  case 16:
                  case 17:
                  case 18:
                  case 19:
                  case 20:
                  case 21:
                  case 22:
                  case 23:
                  case 24:
                  case 25:
                  case 26:
                  case 27:
                  case 28:
                  case 29:
                  case 30:
                  case 31:
                  case 32:
                  case 33:
                  case 34:
                  case 35:
                  case 36:
                  case 37:
                  case 38:
                  case 39:
                  case 40:
                  case 41:
                  case 43:
                  case 44:
                  case 45:
                  case 48:
                  case 49:
                  case 50:
                  case 51:
                  case 52:
                  case 53:
                  case 54:
                  case 55:
                  case 56:
                  case 57:
                  case 58:
                  case 59:
                  case 60:
                  case 61:
                  case 62:
                  case 63:
                  case 64:
                  case 65:
                  case 114:
                  case 115:
                  case 116:
                  case 117:
                  case 118:
                  case 119:
                  case 120:
                  case 121:
                    break;
                  default:
                    return 0;
                }
              else
                switch (x4[0]) {
                  case 4:
                    if (ae0(x4[3]))
                      return 0;
                    break;
                  case 9:
                  case 10:
                  case 11:
                    break;
                  default:
                    return 0;
                }
              return 1;
            }
            function G1(t4) {
              return I9(0, t4);
            }
            function Gs(t4) {
              var n = A0(t4) === 15 ? 1 : 0;
              if (n)
                var e4 = n;
              else {
                var i4 = A0(t4) === 64 ? 1 : 0;
                if (i4) {
                  var x4 = Yn(1, t4) === 15 ? 1 : 0;
                  if (x4)
                    var c = Wl(1, t4)[2][1], e4 = Pe(t4)[3][1] === c ? 1 : 0;
                  else
                    var e4 = x4;
                } else
                  var e4 = i4;
              }
              return e4;
            }
            function $l(t4) {
              var n = A0(t4);
              if (typeof n == "number") {
                var e4 = 0;
                if ((n === 13 || n === 40) && (e4 = 1), e4)
                  return 1;
              }
              return 0;
            }
            function je(t4, n) {
              return ue(t4, [0, Pe(t4), n]);
            }
            function le0(t4, n) {
              if (hL(n))
                return 2;
              if (dL(n))
                return 55;
              var e4 = aL(0, n);
              return t4 ? [11, e4, t4[1]] : [10, e4];
            }
            function St(t4, n) {
              var e4 = wL(n);
              return u(yL(n), e4), je(n, le0(t4, A0(n)));
            }
            function A9(t4) {
              function n(e4) {
                return ue(t4, [0, e4[1], 76]);
              }
              return function(e4) {
                return Du(n, e4);
              };
            }
            function be0(t4, n) {
              var e4 = t4[6] ? ur(et(SRr), n, n, n) : gRr;
              return St([0, e4], t4);
            }
            function gi(t4, n) {
              var e4 = t4[5];
              return e4 && je(t4, n);
            }
            function V7(t4, n) {
              var e4 = t4[5];
              return e4 && ue(t4, [0, n[1], n[2]]);
            }
            function M1(t4, n) {
              return ue(t4, [0, n, [18, t4[5]]]);
            }
            function ie(t4) {
              var n = t4[26][1];
              if (n) {
                var e4 = n2(t4), i4 = A0(t4), x4 = [0, Pe(t4), i4, e4];
                u(n[1], x4);
              }
              var c = t4[25][1], s2 = c[1], p = s2 ? s2[1][1] : g9(c)[1];
              t4[24][1] = p;
              var y = wL(t4);
              u(yL(t4), y);
              var T = t4[2][1], E = Lc(Rs(0, t4)[4], T);
              t4[2][1] = E;
              var d = [0, Rs(0, t4)];
              t4[4][1] = d;
              var w = t4[25][1];
              return w[2] ? (w[1] = w[2], w[2] = 0, 0) : (Qr0(w), w[1] = 0, 0);
            }
            function xu(t4, n) {
              var e4 = o(iL, A0(t4), n);
              return e4 && ie(t4), e4;
            }
            function Ku(t4, n) {
              t4[23][1] = [0, n, t4[23][1]];
              var e4 = n2(t4), i4 = Yl(t4[24][1], e4);
              return t4[25][1] = i4, 0;
            }
            function k7(t4) {
              var n = t4[23][1], e4 = n ? n[2] : ke(ERr);
              t4[23][1] = e4;
              var i4 = n2(t4), x4 = Yl(t4[24][1], i4);
              return t4[25][1] = x4, 0;
            }
            function we(t4) {
              var n = Pe(t4);
              if (A0(t4) === 9 && Jl(1, t4)) {
                var e4 = pr(t4), i4 = Rs(1, t4)[4], x4 = on(e4, u(ml(function(s2) {
                  return s2[1][2][1] <= n[3][1] ? 1 : 0;
                }), i4));
                return Vl(t4, [0, n[3][1] + 1 | 0, 0]), x4;
              }
              var c = pr(t4);
              return Vl(t4, n[3]), c;
            }
            function Ms(t4) {
              var n = t4[4][1];
              if (n) {
                var e4 = n[1][2], i4 = pr(t4), x4 = u(ml(function(p) {
                  return p[1][2][1] <= e4[3][1] ? 1 : 0;
                }), i4);
                Vl(t4, [0, e4[3][1] + 1 | 0, 0]);
                var c = x4;
              } else
                var c = n;
              return c;
            }
            function B1(t4, n) {
              return St([0, aL(hRr, n)], t4);
            }
            function Y0(t4, n) {
              return 1 - o(iL, A0(t4), n) && B1(t4, n), ie(t4);
            }
            function pe0(t4, n) {
              var e4 = xu(t4, n);
              return 1 - e4 && B1(t4, n), e4;
            }
            function Zl(t4, n) {
              var e4 = A0(t4), i4 = 0;
              return typeof e4 != "number" && e4[0] === 4 && qn(e4[3], n) && (i4 = 1), i4 || St([0, u(et(yRr), n)], t4), ie(t4);
            }
            var Bs = [wt, zjr, M7(0)];
            function Xee(t4) {
              var n = t4[26][1];
              if (n) {
                var e4 = mz(0), i4 = [0, function(s2) {
                  return aN(s2, e4);
                }];
                t4[26][1] = i4;
                var x4 = [0, [0, n[1], e4]];
              } else
                var x4 = n;
              return [0, t4[1][1], t4[2][1], t4[4][1], t4[23][1], t4[24][1], t4[30][1], x4];
            }
            function me0(t4, n, e4) {
              if (e4) {
                var i4 = e4[1], x4 = i4[1];
                if (n[26][1] = [0, x4], t4)
                  for (var c = i4[2][2]; ; ) {
                    if (c) {
                      var s2 = c[2];
                      u(x4, c[1]);
                      var c = s2;
                      continue;
                    }
                    return 0;
                  }
                var p = t4;
              } else
                var p = e4;
              return p;
            }
            function Yee(t4, n) {
              me0(0, t4, n[7]), t4[1][1] = n[1], t4[2][1] = n[2], t4[4][1] = n[3], t4[23][1] = n[4], t4[24][1] = n[5], t4[30][1] = n[6];
              var e4 = n2(t4), i4 = Yl(t4[24][1], e4);
              return t4[25][1] = i4, 0;
            }
            function Vee(t4, n, e4) {
              return me0(1, t4, n[7]), [0, e4];
            }
            function EL(t4, n) {
              var e4 = Xee(t4);
              try {
                var i4 = Vee(t4, e4, u(n, t4));
                return i4;
              } catch (x4) {
                if (x4 = Et(x4), x4 === Bs)
                  return Yee(t4, e4);
                throw x4;
              }
            }
            function _e0(t4, n, e4) {
              var i4 = EL(t4, e4);
              return i4 ? i4[1] : n;
            }
            function Ql(t4, n) {
              var e4 = ye(n);
              if (e4) {
                var i4 = e4[1], x4 = u(t4, i4);
                return i4 === x4 ? n : ye([0, x4, e4[2]]);
              }
              return n;
            }
            var ye0 = Rp(Zjr, function(t4) {
              var n = PN(t4, Wjr), e4 = NN(t4, $jr), i4 = e4[22], x4 = e4[26], c = e4[35], s2 = e4[77], p = e4[iV], y = e4[gO], T = e4[cp], E = e4[BO], d = e4[jh], w = e4[ZF], G = e4[6], A11 = e4[7], S11 = e4[10], M = e4[17], K = e4[21], V = e4[27], f0 = e4[33], m0 = e4[36], k0 = e4[46], g0 = e4[51], e0 = e4[89], x0 = e4[92], l = e4[97], c0 = e4[99], t0 = e4[ti], o0 = e4[Pn], w0 = e4[Sv], _0 = e4[zw], E0 = e4[Jg], U0 = e4[dH], b = e4[DX], R0 = e4[eH], X = e4[FH], s0 = e4[kh], hr = e4[AF], Ar = e4[Wg], or = e4[A6], W0 = e4[Cw], Lr = e4[iA], Tr = e4[rk], Hr = e4[hT], Or = e4[lO], fr = e4[i6], Rr = e4[ST], Wr = e4[v8], Jr = e4[$2], ar = LN(t4, 0, 0, nz, KD, 1)[1];
              function _r(q0, Fr, _) {
                var k = _[2], I = k[2], U = k[1], Y = _[1];
                if (I) {
                  var y0 = function(D) {
                    return [0, Y, [0, U, [0, D]]];
                  }, P0 = I[1];
                  return ee(u(q0[1][1 + y], q0), P0, _, y0);
                }
                function I0(D) {
                  return [0, Y, [0, D, I]];
                }
                return ee(o(q0[1][1 + G], q0, Fr), U, _, I0);
              }
              function Ir(q0, Fr, _) {
                var k = _[2], I = _[1], U = I[3], Y = I[2];
                if (U)
                  var y0 = Ql(u(q0[1][1 + x4], q0), U), P0 = Y;
                else
                  var y0 = 0, P0 = o(q0[1][1 + x4], q0, Y);
                var I0 = o(q0[1][1 + c], q0, k);
                return Y === P0 && U === y0 && k === I0 ? _ : [0, [0, I[1], P0, y0], I0];
              }
              function fe(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function v0(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], U];
                }
                var I = _[3];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function P(q0, Fr) {
                function _(I) {
                  return [0, Fr[1], I];
                }
                var k = Fr[2];
                return ee(u(q0[1][1 + c], q0), k, Fr, _);
              }
              function L(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], U];
                }
                var I = _[3];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function Q(q0, Fr, _) {
                var k = _[2], I = _[1], U = Ql(u(q0[1][1 + y], q0), I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, U, Y];
              }
              function i0(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function l0(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], _[3], U];
                }
                var I = _[4];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function S0(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], U];
                }
                var I = _[2];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function T0(q0, Fr, _) {
                var k = _[3], I = _[2], U = o(q0[1][1 + l], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], U, Y];
              }
              function rr(q0, Fr, _) {
                var k = _[4], I = _[3], U = _[2], Y = _[1], y0 = o(q0[1][1 + c], q0, k);
                if (I) {
                  var P0 = ze(u(q0[1][1 + w], q0), I);
                  return I === P0 && k === y0 ? _ : [0, _[1], _[2], P0, y0];
                }
                if (U) {
                  var I0 = ze(u(q0[1][1 + d], q0), U);
                  return U === I0 && k === y0 ? _ : [0, _[1], I0, _[3], y0];
                }
                var D = o(q0[1][1 + y], q0, Y);
                return Y === D && k === y0 ? _ : [0, D, _[2], _[3], y0];
              }
              function L0(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + y], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function B(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], _[3], U];
                }
                var I = _[4];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function Z7(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], _[2], _[3], U];
                }
                var I = _[4];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function p0(q0, Fr, _) {
                var k = _[2], I = _[1], U = I[3], Y = I[2];
                if (U)
                  var y0 = Ql(u(q0[1][1 + x4], q0), U), P0 = Y;
                else
                  var y0 = 0, P0 = o(q0[1][1 + x4], q0, Y);
                var I0 = o(q0[1][1 + c], q0, k);
                return Y === P0 && U === y0 && k === I0 ? _ : [0, [0, I[1], P0, y0], I0];
              }
              function b0(q0, Fr, _) {
                var k = _[3], I = _[1], U = _u(u(q0[1][1 + s2], q0), I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, U, _[2], Y];
              }
              function O0(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], U];
                }
                var I = _[2];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function M0(q0, Fr) {
                if (Fr[0] === 0) {
                  var _ = function(P0) {
                    return [0, P0];
                  }, k = Fr[1];
                  return ee(u(q0[1][1 + p], q0), k, Fr, _);
                }
                var I = Fr[1], U = I[2], Y = U[2], y0 = o(q0[1][1 + p], q0, Y);
                return Y === y0 ? Fr : [1, [0, I[1], [0, U[1], y0]]];
              }
              function er(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + x4], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function yr(q0, Fr) {
                var _ = Fr[2], k = Fr[1];
                function I(Y) {
                  return [0, k, [0, _[1], _[2], _[3], Y]];
                }
                var U = _[4];
                return ee(u(q0[1][1 + c], q0), U, [0, k, _], I);
              }
              function vr(q0, Fr, _) {
                var k = _[9], I = _[3], U = o(q0[1][1 + s0], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, _[4], _[5], _[6], _[7], _[8], Y, _[10]];
              }
              function $0(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + y], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function Er(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function Mr(q0, Fr) {
                var _ = Fr[2], k = _[2], I = _[1], U = Fr[1];
                if (k === 0) {
                  var Y = function(I0) {
                    return [0, U, [0, I0, k]];
                  };
                  return ee(u(q0[1][1 + p], q0), I, Fr, Y);
                }
                function y0(I0) {
                  return [0, U, [0, I, I0]];
                }
                var P0 = u(q0[1][1 + i4], q0);
                return ee(function(I0) {
                  return ze(P0, I0);
                }, k, Fr, y0);
              }
              function Br(q0, Fr) {
                var _ = Fr[2], k = _[2], I = Fr[1];
                function U(P0) {
                  return [0, I, [0, P0, k]];
                }
                var Y = _[1], y0 = u(q0[1][1 + T], q0);
                return ee(function(P0) {
                  return Ql(y0, P0);
                }, Y, Fr, U);
              }
              function qr(q0, Fr, _) {
                var k = _[2];
                if (k === 0) {
                  var I = function(P0) {
                    return [0, P0, _[2], _[3]];
                  }, U = _[1];
                  return ee(u(q0[1][1 + y], q0), U, _, I);
                }
                function Y(P0) {
                  return [0, _[1], P0, _[3]];
                }
                var y0 = u(q0[1][1 + i4], q0);
                return ee(function(P0) {
                  return ze(y0, P0);
                }, k, _, Y);
              }
              function jr(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function $r(q0, Fr, _) {
                var k = _[7], I = _[2], U = o(q0[1][1 + E], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], U, _[3], _[4], _[5], _[6], Y];
              }
              function ne(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function Qr(q0, Fr) {
                var _ = Fr[2], k = _[1], I = Fr[1];
                function U(y0) {
                  return [0, I, [0, k, y0]];
                }
                var Y = _[2];
                return ee(u(q0[1][1 + c], q0), Y, Fr, U);
              }
              function be(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + w], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function ae(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], U];
                }
                var I = _[2];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              function pe(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + y], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function oe(q0, Fr, _) {
                var k = _[4], I = _[3], U = o(q0[1][1 + y], q0, I), Y = o(q0[1][1 + c], q0, k);
                return I === U && k === Y ? _ : [0, _[1], _[2], U, Y];
              }
              function ce(q0, Fr) {
                function _(I) {
                  return [0, Fr[1], I];
                }
                var k = Fr[2];
                return ee(u(q0[1][1 + c], q0), k, Fr, _);
              }
              function ge(q0, Fr, _) {
                function k(U) {
                  return [0, _[1], U];
                }
                var I = _[2];
                return ee(u(q0[1][1 + c], q0), I, _, k);
              }
              return jN(t4, [0, m0, function(q0, Fr) {
                var _ = Fr[2], k = u(ml(function(U) {
                  return ps(U[1][2], q0[1 + n]) < 0 ? 1 : 0;
                }), _), I = Dc(k);
                return Dc(_) === I ? Fr : [0, Fr[1], k, Fr[3]];
              }, Jr, ge, Wr, ce, Rr, oe, fr, pe, Or, ae, Hr, be, w, Qr, d, ne, Tr, $r, E, jr, Lr, qr, W0, Br, T, Mr, or, Er, Ar, $0, hr, vr, X, yr, R0, er, b, M0, U0, O0, E0, b0, _0, p0, w0, Z7, o0, B, t0, L0, x0, rr, c0, T0, e0, S0, s2, l0, g0, i0, k0, Q, f0, L, V, P, K, v0, M, fe, S11, Ir, A11, _r]), function(q0, Fr, _) {
                var k = jp(Fr, t4);
                return k[1 + n] = _, u(ar, k), RN(Fr, k, t4);
              };
            });
            function N9(t4) {
              var n = i2(t4);
              if (n)
                var e4 = n[1], i4 = ce0(t4) ? (Vl(t4, e4[3]), [0, o(ye0[1], 0, e4[3])]) : 0, x4 = i4;
              else
                var x4 = n;
              return [0, 0, function(c, s2) {
                return x4 ? o(s2, x4[1], c) : c;
              }];
            }
            function rb(t4) {
              var n = i2(t4);
              if (n) {
                var e4 = n[1];
                if (ce0(t4)) {
                  Vl(t4, e4[3]);
                  var i4 = Ms(t4), x4 = [0, o(ye0[1], 0, [0, e4[3][1] + 1 | 0, 0])], c = i4;
                } else
                  var x4 = 0, c = Ms(t4);
              } else
                var x4 = 0, c = 0;
              return [0, c, function(s2, p) {
                return x4 ? o(p, x4[1], s2) : s2;
              }];
            }
            function $t(t4) {
              return x7(t4) ? rb(t4) : N9(t4);
            }
            function ys(t4, n) {
              var e4 = $t(t4);
              function i4(x4, c) {
                return o(Qe(x4, Nv, 27), x4, c);
              }
              return o(e4[2], n, i4);
            }
            function oi(t4, n) {
              if (n)
                var e4 = $t(t4), i4 = function(c, s2) {
                  return o(Qe(c, bF, 30), c, s2);
                }, x4 = [0, o(e4[2], n[1], i4)];
              else
                var x4 = n;
              return x4;
            }
            function o2(t4, n) {
              var e4 = $t(t4);
              function i4(x4, c) {
                return o(Qe(x4, -983660142, 32), x4, c);
              }
              return o(e4[2], n, i4);
            }
            function eb(t4, n) {
              var e4 = $t(t4);
              function i4(x4, c) {
                return o(Qe(x4, -455772979, 33), x4, c);
              }
              return o(e4[2], n, i4);
            }
            function he0(t4, n) {
              if (n)
                var e4 = $t(t4), i4 = function(c, s2) {
                  return o(Qe(c, kH, 34), c, s2);
                }, x4 = [0, o(e4[2], n[1], i4)];
              else
                var x4 = n;
              return x4;
            }
            function Xi(t4, n) {
              var e4 = $t(t4);
              function i4(x4, c) {
                return o(Qe(x4, qY, 35), x4, c);
              }
              return o(e4[2], n, i4);
            }
            function de0(t4, n) {
              var e4 = $t(t4);
              function i4(x4, c) {
                var s2 = u(Qe(x4, ZU, 37), x4);
                return Ql(function(p) {
                  return _u(s2, p);
                }, c);
              }
              return o(e4[2], n, i4);
            }
            function ke0(t4, n) {
              var e4 = $t(t4);
              function i4(x4, c) {
                return o(Qe(x4, -21476009, 38), x4, c);
              }
              return o(e4[2], n, i4);
            }
            Rp(Qjr, function(t4) {
              var n = PN(t4, Kjr), e4 = DN(Jjr), i4 = e4.length - 1, x4 = tz.length - 1, c = Gv(i4 + x4 | 0, 0), s2 = i4 - 1 | 0, p = 0;
              if (!(s2 < 0))
                for (var y = p; ; ) {
                  var T = Fl(t4, tu(e4, y)[1 + y]);
                  tu(c, y)[1 + y] = T;
                  var E = y + 1 | 0;
                  if (s2 !== y) {
                    var y = E;
                    continue;
                  }
                  break;
                }
              var d = x4 - 1 | 0, w = 0;
              if (!(d < 0))
                for (var G = w; ; ) {
                  var A11 = G + i4 | 0, S11 = PN(t4, tu(tz, G)[1 + G]);
                  tu(c, A11)[1 + A11] = S11;
                  var M = G + 1 | 0;
                  if (d !== G) {
                    var G = M;
                    continue;
                  }
                  break;
                }
              var K = c[4], V = c[5], f0 = c[y6], m0 = c[cp], k0 = c[nd], g0 = c[gv], e0 = c[38], x0 = c[mT], l = c[Vy], c0 = LN(t4, 0, 0, nz, KD, 1)[1];
              function t0(b, R0, X) {
                return o(b[1][1 + f0], b, X[2]), X;
              }
              function o0(b, R0) {
                return o(b[1][1 + m0], b, R0), R0;
              }
              function w0(b, R0) {
                var X = R0[1], s0 = b[1 + g0];
                if (s0) {
                  var hr = ps(s0[1][1][2], X[2]) < 0 ? 1 : 0, Ar = hr && (b[1 + g0] = [0, R0], 0);
                  return Ar;
                }
                var or = 0 <= ps(X[2], b[1 + n][3]) ? 1 : 0, W0 = or && (b[1 + g0] = [0, R0], 0);
                return W0;
              }
              function _0(b, R0) {
                var X = R0[1], s0 = b[1 + k0];
                if (s0) {
                  var hr = ps(X[2], s0[1][1][2]) < 0 ? 1 : 0, Ar = hr && (b[1 + k0] = [0, R0], 0);
                  return Ar;
                }
                var or = ps(X[2], b[1 + n][2]) < 0 ? 1 : 0, W0 = or && (b[1 + k0] = [0, R0], 0);
                return W0;
              }
              function E0(b, R0) {
                return R0 && o(b[1][1 + m0], b, R0[1]);
              }
              function U0(b, R0) {
                var X = R0[1];
                Du(u(b[1][1 + V], b), X);
                var s0 = R0[2];
                return Du(u(b[1][1 + K], b), s0);
              }
              return jN(t4, [0, x0, function(b) {
                return [0, b[1 + k0], b[1 + g0]];
              }, m0, U0, f0, E0, V, _0, K, w0, e0, o0, l, t0]), function(b, R0, X) {
                var s0 = jp(R0, t4);
                return s0[1 + n] = X, u(c0, s0), s0[1 + k0] = 0, s0[1 + g0] = 0, RN(R0, s0, t4);
              };
            });
            function we0(t4) {
              return t4 === 3 ? 2 : (4 <= t4, 1);
            }
            function SL(t4, n, e4) {
              if (e4) {
                var i4 = e4[1], x4 = 0;
                if (i4 === 8232 || Hu === i4)
                  x4 = 1;
                else if (i4 === 10)
                  var s2 = 6;
                else if (i4 === 13)
                  var s2 = 5;
                else if (fw <= i4)
                  var s2 = 3;
                else if (Hh <= i4)
                  var s2 = 2;
                else
                  var c = jt <= i4 ? 1 : 0, s2 = c && 1;
                if (x4)
                  var s2 = 7;
                var p = s2;
              } else
                var p = 4;
              return [0, p, t4];
            }
            var zee = [wt, uGr, M7(0)];
            function Ee0(t4, n, e4, i4) {
              try {
                var x4 = tu(t4, n)[1 + n];
                return x4;
              } catch (c) {
                throw c = Et(c), c[1] === ZA ? [0, zee, e4, ur(et(nGr), i4, n, t4.length - 1)] : c;
              }
            }
            function C9(t4, n) {
              if (n[1] === 0 && n[2] === 0)
                return 0;
              var e4 = Ee0(t4, n[1] - 1 | 0, n, rGr);
              return Ee0(e4, n[2], n, eGr);
            }
            var Kee = Ee;
            function Wee(t4, n) {
              return o(f4(t4), NWr, n);
            }
            u(eL([0, Kee])[33], Wee);
            function Se0(t4) {
              var n = A0(t4), e4 = 0;
              if (typeof n == "number")
                switch (n) {
                  case 15:
                    var i4 = CWr;
                    break;
                  case 16:
                    var i4 = PWr;
                    break;
                  case 17:
                    var i4 = DWr;
                    break;
                  case 18:
                    var i4 = LWr;
                    break;
                  case 19:
                    var i4 = RWr;
                    break;
                  case 20:
                    var i4 = jWr;
                    break;
                  case 21:
                    var i4 = GWr;
                    break;
                  case 22:
                    var i4 = MWr;
                    break;
                  case 23:
                    var i4 = BWr;
                    break;
                  case 24:
                    var i4 = qWr;
                    break;
                  case 25:
                    var i4 = UWr;
                    break;
                  case 26:
                    var i4 = HWr;
                    break;
                  case 27:
                    var i4 = XWr;
                    break;
                  case 28:
                    var i4 = YWr;
                    break;
                  case 29:
                    var i4 = VWr;
                    break;
                  case 30:
                    var i4 = zWr;
                    break;
                  case 31:
                    var i4 = KWr;
                    break;
                  case 32:
                    var i4 = WWr;
                    break;
                  case 33:
                    var i4 = JWr;
                    break;
                  case 34:
                    var i4 = $Wr;
                    break;
                  case 35:
                    var i4 = ZWr;
                    break;
                  case 36:
                    var i4 = QWr;
                    break;
                  case 37:
                    var i4 = rJr;
                    break;
                  case 38:
                    var i4 = eJr;
                    break;
                  case 39:
                    var i4 = nJr;
                    break;
                  case 40:
                    var i4 = tJr;
                    break;
                  case 41:
                    var i4 = uJr;
                    break;
                  case 42:
                    var i4 = iJr;
                    break;
                  case 43:
                    var i4 = fJr;
                    break;
                  case 44:
                    var i4 = xJr;
                    break;
                  case 45:
                    var i4 = oJr;
                    break;
                  case 46:
                    var i4 = aJr;
                    break;
                  case 47:
                    var i4 = cJr;
                    break;
                  case 48:
                    var i4 = sJr;
                    break;
                  case 49:
                    var i4 = vJr;
                    break;
                  case 50:
                    var i4 = lJr;
                    break;
                  case 51:
                    var i4 = bJr;
                    break;
                  case 52:
                    var i4 = pJr;
                    break;
                  case 53:
                    var i4 = mJr;
                    break;
                  case 54:
                    var i4 = _Jr;
                    break;
                  case 55:
                    var i4 = yJr;
                    break;
                  case 56:
                    var i4 = hJr;
                    break;
                  case 57:
                    var i4 = dJr;
                    break;
                  case 58:
                    var i4 = kJr;
                    break;
                  case 59:
                    var i4 = wJr;
                    break;
                  case 60:
                    var i4 = EJr;
                    break;
                  case 61:
                    var i4 = SJr;
                    break;
                  case 62:
                    var i4 = gJr;
                    break;
                  case 63:
                    var i4 = FJr;
                    break;
                  case 64:
                    var i4 = TJr;
                    break;
                  case 65:
                    var i4 = OJr;
                    break;
                  case 114:
                    var i4 = IJr;
                    break;
                  case 115:
                    var i4 = AJr;
                    break;
                  case 116:
                    var i4 = NJr;
                    break;
                  case 117:
                    var i4 = CJr;
                    break;
                  case 118:
                    var i4 = PJr;
                    break;
                  case 119:
                    var i4 = DJr;
                    break;
                  case 120:
                    var i4 = LJr;
                    break;
                  case 121:
                    var i4 = RJr;
                    break;
                  default:
                    e4 = 1;
                }
              else
                switch (n[0]) {
                  case 4:
                    var i4 = n[2];
                    break;
                  case 9:
                    var i4 = n[1] ? jJr : GJr;
                    break;
                  default:
                    e4 = 1;
                }
              if (e4) {
                St(MJr, t4);
                var i4 = BJr;
              }
              return ie(t4), i4;
            }
            function z7(t4) {
              var n = Pe(t4), e4 = pr(t4), i4 = Se0(t4);
              return [0, n, [0, i4, lr([0, e4], [0, we(t4)], 0)]];
            }
            function ge0(t4) {
              var n = Pe(t4), e4 = pr(t4);
              Y0(t4, 14);
              var i4 = Pe(t4), x4 = Se0(t4), c = lr([0, e4], [0, we(t4)], 0), s2 = yt(n, i4), p = i4[2], y = n[3], T = y[1] === p[1] ? 1 : 0, E = T && (y[2] === p[2] ? 1 : 0);
              return 1 - E && ue(t4, [0, s2, R7]), [0, s2, [0, x4, c]];
            }
            function q1(t4) {
              var n = t4[2], e4 = n[3] === 0 ? 1 : 0;
              if (e4)
                for (var i4 = n[2]; ; ) {
                  if (i4) {
                    var x4 = i4[1][2], c = 0, s2 = i4[2];
                    if (x4[1][2][0] === 2 && !x4[2]) {
                      var p = 1;
                      c = 1;
                    }
                    if (!c)
                      var p = 0;
                    if (p) {
                      var i4 = s2;
                      continue;
                    }
                    return p;
                  }
                  return 1;
                }
              return e4;
            }
            function nb(t4) {
              for (var n = t4; ; ) {
                var e4 = n[2];
                if (e4[0] === 27) {
                  var i4 = e4[1][2];
                  if (i4[2][0] === 23)
                    return 1;
                  var n = i4;
                  continue;
                }
                return 0;
              }
            }
            function cr(t4, n, e4) {
              var i4 = t4 ? t4[1] : Pe(e4), x4 = u(n, e4), c = i2(e4), s2 = c ? yt(i4, c[1]) : i4;
              return [0, s2, x4];
            }
            function gL(t4, n, e4) {
              var i4 = cr(t4, n, e4), x4 = i4[2];
              return [0, [0, i4[1], x4[1]], x4[2]];
            }
            function Jee(t4) {
              function n(B) {
                var Z7 = Pe(B), p0 = A0(B);
                if (typeof p0 == "number") {
                  if (s7 === p0) {
                    var b0 = pr(B);
                    return ie(B), [0, [0, Z7, [0, 0, lr([0, b0], 0, 0)]]];
                  }
                  if (L7 === p0) {
                    var O0 = pr(B);
                    return ie(B), [0, [0, Z7, [0, 1, lr([0, O0], 0, 0)]]];
                  }
                }
                return 0;
              }
              var e4 = function B(Z7) {
                return B.fun(Z7);
              }, i4 = function B(Z7) {
                return B.fun(Z7);
              }, x4 = function B(Z7) {
                return B.fun(Z7);
              }, c = function B(Z7, p0, b0) {
                return B.fun(Z7, p0, b0);
              }, s2 = function B(Z7) {
                return B.fun(Z7);
              }, p = function B(Z7, p0, b0) {
                return B.fun(Z7, p0, b0);
              }, y = function B(Z7) {
                return B.fun(Z7);
              }, T = function B(Z7, p0) {
                return B.fun(Z7, p0);
              }, E = function B(Z7) {
                return B.fun(Z7);
              }, d = function B(Z7) {
                return B.fun(Z7);
              }, w = function B(Z7, p0, b0) {
                return B.fun(Z7, p0, b0);
              }, G = function B(Z7, p0, b0, O0) {
                return B.fun(Z7, p0, b0, O0);
              }, A11 = function B(Z7) {
                return B.fun(Z7);
              }, S11 = function B(Z7, p0) {
                return B.fun(Z7, p0);
              }, M = function B(Z7) {
                return B.fun(Z7);
              }, K = function B(Z7) {
                return B.fun(Z7);
              }, V = function B(Z7) {
                return B.fun(Z7);
              }, f0 = function B(Z7) {
                return B.fun(Z7);
              }, m0 = function B(Z7) {
                return B.fun(Z7);
              }, k0 = function B(Z7) {
                return B.fun(Z7);
              }, g0 = function B(Z7, p0) {
                return B.fun(Z7, p0);
              }, e0 = function B(Z7) {
                return B.fun(Z7);
              }, x0 = function B(Z7) {
                return B.fun(Z7);
              }, l = function B(Z7) {
                return B.fun(Z7);
              }, c0 = function B(Z7) {
                return B.fun(Z7);
              }, t0 = function B(Z7) {
                return B.fun(Z7);
              }, o0 = function B(Z7) {
                return B.fun(Z7);
              }, w0 = function B(Z7) {
                return B.fun(Z7);
              }, _0 = function B(Z7, p0, b0, O0) {
                return B.fun(Z7, p0, b0, O0);
              }, E0 = function B(Z7, p0, b0, O0) {
                return B.fun(Z7, p0, b0, O0);
              }, U0 = function B(Z7) {
                return B.fun(Z7);
              }, b = function B(Z7) {
                return B.fun(Z7);
              }, R0 = function B(Z7) {
                return B.fun(Z7);
              }, X = function B(Z7) {
                return B.fun(Z7);
              }, s0 = function B(Z7) {
                return B.fun(Z7);
              }, hr = function B(Z7) {
                return B.fun(Z7);
              }, Ar = function B(Z7, p0) {
                return B.fun(Z7, p0);
              }, or = function B(Z7, p0) {
                return B.fun(Z7, p0);
              }, W0 = function B(Z7) {
                return B.fun(Z7);
              }, Lr = function B(Z7, p0, b0) {
                return B.fun(Z7, p0, b0);
              };
              N(e4, function(B) {
                return u(x4, B);
              }), N(i4, function(B) {
                return 1 - fu(B) && je(B, 12), cr(0, function(Z7) {
                  return Y0(Z7, 86), u(e4, Z7);
                }, B);
              }), N(x4, function(B) {
                var Z7 = A0(B) === 89 ? 1 : 0;
                if (Z7) {
                  var p0 = pr(B);
                  ie(B);
                  var b0 = p0;
                } else
                  var b0 = Z7;
                return ur(c, B, [0, b0], u(s2, B));
              }), N(c, function(B, Z7, p0) {
                var b0 = Z7 && Z7[1];
                if (A0(B) === 89) {
                  var O0 = [0, p0, 0], M0 = function(er) {
                    for (var yr = O0; ; ) {
                      var vr = A0(er);
                      if (typeof vr == "number" && vr === 89) {
                        Y0(er, 89);
                        var yr = [0, u(s2, er), yr];
                        continue;
                      }
                      var $0 = ye(yr);
                      if ($0) {
                        var Er = $0[2];
                        if (Er) {
                          var Mr = lr([0, b0], 0, 0);
                          return [19, [0, [0, $0[1], Er[1], Er[2]], Mr]];
                        }
                      }
                      throw [0, Sn, y$r];
                    }
                  };
                  return cr([0, p0[1]], M0, B);
                }
                return p0;
              }), N(s2, function(B) {
                var Z7 = A0(B) === 91 ? 1 : 0;
                if (Z7) {
                  var p0 = pr(B);
                  ie(B);
                  var b0 = p0;
                } else
                  var b0 = Z7;
                return ur(p, B, [0, b0], u(y, B));
              }), N(p, function(B, Z7, p0) {
                var b0 = Z7 && Z7[1];
                if (A0(B) === 91) {
                  var O0 = [0, p0, 0], M0 = function(er) {
                    for (var yr = O0; ; ) {
                      var vr = A0(er);
                      if (typeof vr == "number" && vr === 91) {
                        Y0(er, 91);
                        var yr = [0, u(y, er), yr];
                        continue;
                      }
                      var $0 = ye(yr);
                      if ($0) {
                        var Er = $0[2];
                        if (Er) {
                          var Mr = lr([0, b0], 0, 0);
                          return [20, [0, [0, $0[1], Er[1], Er[2]], Mr]];
                        }
                      }
                      throw [0, Sn, _$r];
                    }
                  };
                  return cr([0, p0[1]], M0, B);
                }
                return p0;
              }), N(y, function(B) {
                return o(T, B, u(E, B));
              }), N(T, function(B, Z7) {
                var p0 = A0(B);
                if (typeof p0 == "number" && p0 === 11 && !B[15]) {
                  var b0 = o(g0, B, Z7);
                  return R(_0, B, b0[1], 0, [0, b0[1], [0, 0, [0, b0, 0], 0, 0]]);
                }
                return Z7;
              }), N(E, function(B) {
                var Z7 = A0(B);
                return typeof Z7 == "number" && Z7 === 85 ? cr(0, function(p0) {
                  var b0 = pr(p0);
                  Y0(p0, 85);
                  var O0 = lr([0, b0], 0, 0);
                  return [11, [0, u(E, p0), O0]];
                }, B) : u(d, B);
              }), N(d, function(B) {
                return ur(w, 0, B, u(V, B));
              }), N(w, function(B, Z7, p0) {
                var b0 = B && B[1];
                if (x7(Z7))
                  return p0;
                var O0 = A0(Z7);
                if (typeof O0 == "number") {
                  if (O0 === 6)
                    return ie(Z7), R(G, b0, 0, Z7, p0);
                  if (O0 === 10) {
                    var M0 = Yn(1, Z7);
                    return typeof M0 == "number" && M0 === 6 ? (je(Z7, p$r), Y0(Z7, 10), Y0(Z7, 6), R(G, b0, 0, Z7, p0)) : (je(Z7, m$r), p0);
                  }
                  if (O0 === 83)
                    return ie(Z7), A0(Z7) !== 6 && je(Z7, 30), Y0(Z7, 6), R(G, 1, 1, Z7, p0);
                }
                return p0;
              }), N(G, function(B, Z7, p0, b0) {
                function O0(M0) {
                  if (!Z7 && xu(M0, 7))
                    return [15, [0, b0, lr(0, [0, we(M0)], 0)]];
                  var er = u(e4, M0);
                  Y0(M0, 7);
                  var yr = [0, b0, er, lr(0, [0, we(M0)], 0)];
                  return B ? [18, [0, yr, Z7]] : [17, yr];
                }
                return ur(w, [0, B], p0, cr([0, b0[1]], O0, p0));
              }), N(A11, function(B) {
                return o(S11, B, o(t4[13], 0, B));
              }), N(S11, function(B, Z7) {
                for (var p0 = [0, Z7[1], [0, Z7]]; ; ) {
                  var b0 = p0[2];
                  if (A0(B) === 10 && I9(1, B)) {
                    var O0 = function(vr) {
                      return function($0) {
                        return Y0($0, 10), [0, vr, z7($0)];
                      };
                    }(b0), M0 = cr([0, p0[1]], O0, B), er = M0[1], p0 = [0, er, [1, [0, er, M0[2]]]];
                    continue;
                  }
                  return b0;
                }
              }), N(M, function(B) {
                var Z7 = A0(B);
                if (typeof Z7 == "number") {
                  if (Z7 === 4) {
                    ie(B);
                    var p0 = u(M, B);
                    return Y0(B, 5), p0;
                  }
                } else if (Z7[0] === 4)
                  return [0, u(A11, B)];
                return je(B, 51), 0;
              }), N(K, function(B) {
                return cr(0, function(Z7) {
                  var p0 = pr(Z7);
                  Y0(Z7, 46);
                  var b0 = u(M, Z7);
                  if (b0) {
                    var O0 = lr([0, p0], 0, 0);
                    return [21, [0, b0[1], O0]];
                  }
                  return b$r;
                }, B);
              }), N(V, function(B) {
                var Z7 = Pe(B), p0 = A0(B), b0 = 0;
                if (typeof p0 == "number")
                  switch (p0) {
                    case 4:
                      return u(o0, B);
                    case 6:
                      return u(k0, B);
                    case 46:
                      return u(K, B);
                    case 53:
                      return cr(0, function(ge) {
                        var q0 = pr(ge);
                        Y0(ge, 53);
                        var Fr = u(U0, ge), _ = lr([0, q0], 0, 0);
                        return [14, [0, Fr[2], Fr[1], _]];
                      }, B);
                    case 98:
                      return u(w0, B);
                    case 106:
                      var O0 = pr(B);
                      return Y0(B, Yt), [0, Z7, [10, lr([0, O0], [0, we(B)], 0)]];
                    case 42:
                      b0 = 1;
                      break;
                    case 0:
                    case 2:
                      var M0 = R(E0, 0, 1, 1, B);
                      return [0, M0[1], [13, M0[2]]];
                    case 30:
                    case 31:
                      var er = pr(B);
                      return Y0(B, p0), [0, Z7, [26, [0, p0 === 31 ? 1 : 0, lr([0, er], [0, we(B)], 0)]]];
                  }
                else
                  switch (p0[0]) {
                    case 2:
                      var yr = p0[1], vr = yr[4], $0 = yr[3], Er = yr[2], Mr = yr[1];
                      vr && gi(B, 45);
                      var Br = pr(B);
                      return Y0(B, [2, [0, Mr, Er, $0, vr]]), [0, Mr, [23, [0, Er, $0, lr([0, Br], [0, we(B)], 0)]]];
                    case 10:
                      var qr = p0[3], jr = p0[2], $r = p0[1], ne = pr(B);
                      Y0(B, [10, $r, jr, qr]);
                      var Qr = we(B);
                      return $r === 1 && gi(B, 45), [0, Z7, [24, [0, jr, qr, lr([0, ne], [0, Qr], 0)]]];
                    case 11:
                      var be = p0[3], ae = p0[2], pe = pr(B);
                      return Y0(B, [11, p0[1], ae, be]), [0, Z7, [25, [0, ae, be, lr([0, pe], [0, we(B)], 0)]]];
                    case 4:
                      b0 = 1;
                      break;
                  }
                if (b0) {
                  var oe = u(hr, B);
                  return [0, oe[1], [16, oe[2]]];
                }
                var ce = u(m0, B);
                return ce ? [0, Z7, ce[1]] : (St(v$r, B), [0, Z7, l$r]);
              }), N(f0, function(B) {
                var Z7 = 0;
                if (typeof B == "number")
                  switch (B) {
                    case 29:
                    case 114:
                    case 115:
                    case 116:
                    case 117:
                    case 118:
                    case 119:
                    case 120:
                    case 121:
                      Z7 = 1;
                      break;
                  }
                else
                  B[0] === 9 && (Z7 = 1);
                return Z7 ? 1 : 0;
              }), N(m0, function(B) {
                var Z7 = pr(B), p0 = A0(B);
                if (typeof p0 == "number")
                  switch (p0) {
                    case 29:
                      return ie(B), [0, [4, lr([0, Z7], [0, we(B)], 0)]];
                    case 114:
                      return ie(B), [0, [0, lr([0, Z7], [0, we(B)], 0)]];
                    case 115:
                      return ie(B), [0, [1, lr([0, Z7], [0, we(B)], 0)]];
                    case 116:
                      return ie(B), [0, [2, lr([0, Z7], [0, we(B)], 0)]];
                    case 117:
                      return ie(B), [0, [5, lr([0, Z7], [0, we(B)], 0)]];
                    case 118:
                      return ie(B), [0, [6, lr([0, Z7], [0, we(B)], 0)]];
                    case 119:
                      return ie(B), [0, [7, lr([0, Z7], [0, we(B)], 0)]];
                    case 120:
                      return ie(B), [0, [3, lr([0, Z7], [0, we(B)], 0)]];
                    case 121:
                      return ie(B), [0, [9, lr([0, Z7], [0, we(B)], 0)]];
                  }
                else if (p0[0] === 9)
                  return ie(B), [0, [8, lr([0, Z7], [0, we(B)], 0)]];
                return 0;
              }), N(k0, function(B) {
                return cr(0, function(Z7) {
                  var p0 = pr(Z7);
                  Y0(Z7, 6);
                  for (var b0 = u2(0, Z7), O0 = 0; ; ) {
                    var M0 = A0(b0);
                    if (typeof M0 == "number") {
                      var er = 0;
                      if ((M0 === 7 || Pn === M0) && (er = 1), er) {
                        var yr = ye(O0);
                        return Y0(Z7, 7), [22, [0, yr, lr([0, p0], [0, we(Z7)], 0)]];
                      }
                    }
                    var vr = [0, u(e4, b0), O0];
                    A0(b0) !== 7 && Y0(b0, 9);
                    var O0 = vr;
                  }
                }, B);
              }), N(g0, function(B, Z7) {
                return [0, Z7[1], [0, 0, Z7, 0]];
              }), N(e0, function(B) {
                return cr(0, function(Z7) {
                  Ku(Z7, 0);
                  var p0 = o(t4[13], 0, Z7);
                  k7(Z7), 1 - fu(Z7) && je(Z7, 12);
                  var b0 = xu(Z7, 85);
                  return Y0(Z7, 86), [0, [0, p0], u(e4, Z7), b0];
                }, B);
              });
              function Tr(B) {
                var Z7 = Yn(1, B);
                return typeof Z7 == "number" && !(1 < (Z7 + W2 | 0) >>> 0) ? u(e0, B) : o(g0, B, u(e4, B));
              }
              N(x0, function(B) {
                var Z7 = 0;
                return function(p0) {
                  for (var b0 = Z7, O0 = p0; ; ) {
                    var M0 = A0(B);
                    if (typeof M0 == "number")
                      switch (M0) {
                        case 5:
                        case 12:
                        case 113:
                          var er = M0 === 12 ? 1 : 0, yr = er && [0, cr(0, function(jr) {
                            var $r = pr(jr);
                            Y0(jr, 12);
                            var ne = lr([0, $r], 0, 0);
                            return [0, Tr(jr), ne];
                          }, B)];
                          return [0, b0, ye(O0), yr, 0];
                      }
                    else if (M0[0] === 4 && !n0(M0[3], s$r)) {
                      var vr = 0;
                      if ((Yn(1, B) === 86 || Yn(1, B) === 85) && (vr = 1), vr) {
                        var $0 = b0 !== 0 ? 1 : 0, Er = $0 || (O0 !== 0 ? 1 : 0);
                        Er && je(B, s7);
                        var Mr = cr(0, function($r) {
                          var ne = pr($r);
                          ie($r), A0($r) === 85 && je($r, L7);
                          var Qr = lr([0, ne], 0, 0);
                          return [0, u(i4, $r), Qr];
                        }, B);
                        A0(B) !== 5 && Y0(B, 9);
                        var b0 = [0, Mr];
                        continue;
                      }
                    }
                    var Br = [0, Tr(B), O0];
                    A0(B) !== 5 && Y0(B, 9);
                    var O0 = Br;
                  }
                };
              }), N(l, function(B) {
                return cr(0, function(Z7) {
                  var p0 = pr(Z7);
                  Y0(Z7, 4);
                  var b0 = o(x0, Z7, 0), O0 = pr(Z7);
                  Y0(Z7, 5);
                  var M0 = yu([0, p0], [0, we(Z7)], O0, 0);
                  return [0, b0[1], b0[2], b0[3], M0];
                }, B);
              }), N(c0, function(B) {
                var Z7 = pr(B);
                Y0(B, 4);
                var p0 = u2(0, B), b0 = A0(p0), O0 = 0;
                if (typeof b0 == "number")
                  switch (b0) {
                    case 5:
                      var M0 = c$r;
                      break;
                    case 42:
                      O0 = 2;
                      break;
                    case 12:
                    case 113:
                      var M0 = [0, o(x0, p0, 0)];
                      break;
                    default:
                      O0 = 1;
                  }
                else
                  b0[0] === 4 ? O0 = 2 : O0 = 1;
                switch (O0) {
                  case 1:
                    if (u(f0, b0)) {
                      var er = Yn(1, p0), yr = 0;
                      if (typeof er == "number" && !(1 < (er + W2 | 0) >>> 0)) {
                        var vr = [0, o(x0, p0, 0)];
                        yr = 1;
                      }
                      if (!yr)
                        var vr = [1, u(e4, p0)];
                      var M0 = vr;
                    } else
                      var M0 = [1, u(e4, p0)];
                    break;
                  case 2:
                    var M0 = u(t0, p0);
                    break;
                }
                if (M0[0] === 0)
                  var $0 = M0;
                else {
                  var Er = M0[1];
                  if (B[15])
                    var Mr = M0;
                  else {
                    var Br = A0(B), qr = 0;
                    if (typeof Br == "number")
                      if (Br === 5)
                        var jr = Yn(1, B) === 11 ? [0, o(x0, B, [0, o(g0, B, Er), 0])] : [1, Er];
                      else if (Br === 9) {
                        Y0(B, 9);
                        var jr = [0, o(x0, B, [0, o(g0, B, Er), 0])];
                      } else
                        qr = 1;
                    else
                      qr = 1;
                    if (qr)
                      var jr = M0;
                    var Mr = jr;
                  }
                  var $0 = Mr;
                }
                var $r = pr(B);
                Y0(B, 5);
                var ne = we(B);
                if ($0[0] === 0) {
                  var Qr = $0[1], be = yu([0, Z7], [0, ne], $r, 0);
                  return [0, [0, Qr[1], Qr[2], Qr[3], be]];
                }
                return [1, ur(Lr, $0[1], Z7, ne)];
              }), N(t0, function(B) {
                var Z7 = Yn(1, B);
                return typeof Z7 == "number" && !(1 < (Z7 + W2 | 0) >>> 0) ? [0, o(x0, B, 0)] : [1, ur(c, B, 0, ur(p, B, 0, o(T, B, ur(w, 0, B, o(or, B, u(b, B))))))];
              }), N(o0, function(B) {
                var Z7 = Pe(B), p0 = cr(0, c0, B), b0 = p0[2];
                return b0[0] === 0 ? R(_0, B, Z7, 0, [0, p0[1], b0[1]]) : b0[1];
              }), N(w0, function(B) {
                var Z7 = Pe(B), p0 = oi(B, u(X, B));
                return R(_0, B, Z7, p0, u(l, B));
              }), N(_0, function(B, Z7, p0, b0) {
                return cr([0, Z7], function(O0) {
                  return Y0(O0, 11), [12, [0, p0, b0, u(e4, O0), 0]];
                }, B);
              });
              function Hr(B, Z7, p0) {
                return cr([0, Z7], function(b0) {
                  var O0 = u(l, b0);
                  return Y0(b0, 86), [0, p0, O0, u(e4, b0), 0];
                }, B);
              }
              function Or(B, Z7) {
                var p0 = A0(Z7);
                if (typeof p0 == "number" && !(10 <= p0))
                  switch (p0) {
                    case 1:
                      if (!B)
                        return 0;
                      break;
                    case 3:
                      if (B)
                        return 0;
                      break;
                    case 8:
                    case 9:
                      return ie(Z7);
                  }
                return B1(Z7, 9);
              }
              function fr(B, Z7) {
                return Z7 && ue(B, [0, Z7[1][1], 7]);
              }
              function Rr(B, Z7) {
                return Z7 && ue(B, [0, Z7[1], 9]);
              }
              N(E0, function(B, Z7, p0, b0) {
                var O0 = Z7 && (A0(b0) === 2 ? 1 : 0), M0 = Z7 && 1 - O0;
                return cr(0, function(er) {
                  var yr = pr(er), vr = O0 && 2;
                  Y0(er, vr);
                  var $0 = u2(0, er), Er = a$r;
                  r:
                    for (; ; ) {
                      var Mr = Er[3], Br = Er[2], qr = Er[1];
                      if (B && p0)
                        throw [0, Sn, WJr];
                      if (M0 && !p0)
                        throw [0, Sn, JJr];
                      var jr = Pe($0), $r = A0($0);
                      if (typeof $r == "number") {
                        var ne = 0;
                        if (13 <= $r) {
                          if (Pn === $r) {
                            var Qr = [0, ye(qr), Br, Mr];
                            ne = 1;
                          }
                        } else if ($r)
                          switch ($r - 1 | 0) {
                            case 0:
                              if (!O0) {
                                var Qr = [0, ye(qr), Br, Mr];
                                ne = 1;
                              }
                              break;
                            case 2:
                              if (O0) {
                                var Qr = [0, ye(qr), Br, Mr];
                                ne = 1;
                              }
                              break;
                            case 11:
                              if (!p0) {
                                ie($0);
                                var be = A0($0);
                                if (typeof be == "number" && !(10 <= be))
                                  switch (be) {
                                    case 1:
                                    case 3:
                                    case 8:
                                    case 9:
                                      ue($0, [0, jr, 20]), Or(O0, $0);
                                      continue;
                                  }
                                var ae = wL($0);
                                u(yL($0), ae), ue($0, [0, jr, 17]), ie($0), Or(O0, $0);
                                continue;
                              }
                              var pe = pr($0);
                              ie($0);
                              var oe = A0($0), ce = 0;
                              if (typeof oe == "number" && !(10 <= oe))
                                switch (oe) {
                                  case 1:
                                  case 3:
                                  case 8:
                                  case 9:
                                    Or(O0, $0);
                                    var ge = A0($0), q0 = 0;
                                    if (typeof ge == "number") {
                                      var Fr = ge - 1 | 0;
                                      if (!(2 < Fr >>> 0))
                                        switch (Fr) {
                                          case 0:
                                            if (M0) {
                                              var Qr = [0, ye(qr), 1, pe];
                                              ne = 1, ce = 1, q0 = 1;
                                            }
                                            break;
                                          case 1:
                                            break;
                                          default:
                                            ue($0, [0, jr, 19]);
                                            var Qr = [0, ye(qr), Br, Mr];
                                            ne = 1, ce = 1, q0 = 1;
                                        }
                                    }
                                    if (!q0) {
                                      ue($0, [0, jr, 18]);
                                      continue;
                                    }
                                    break;
                                }
                              if (!ce) {
                                var _ = [1, cr([0, jr], function(W7) {
                                  return function(Ut) {
                                    var bt = lr([0, W7], 0, 0);
                                    return [0, u(e4, Ut), bt];
                                  };
                                }(pe), $0)];
                                Or(O0, $0);
                                var Er = [0, [0, _, qr], Br, Mr];
                                continue;
                              }
                              break;
                          }
                        if (ne) {
                          var k = pr(er), I = on(Qr[3], k), U = O0 ? 3 : 1;
                          Y0(er, U);
                          var Y = yu([0, yr], [0, we(er)], I, 0);
                          return [0, O0, Qr[2], Qr[1], Y];
                        }
                      }
                      for (var y0 = B, P0 = B, I0 = 0, D = 0, u0 = 0, X0 = 0; ; ) {
                        var J0 = A0($0), ir = 0;
                        if (typeof J0 == "number")
                          switch (J0) {
                            case 6:
                              Rr($0, u0);
                              var Q0 = Yn(1, $0), F0 = 0;
                              if (typeof Q0 == "number" && Q0 === 6) {
                                fr($0, I0);
                                var Cr = [4, cr([0, jr], function(Ut, bt, B0) {
                                  return function(D0) {
                                    var Le = on(bt, pr(D0));
                                    Y0(D0, 6), Y0(D0, 6);
                                    var He = z7(D0);
                                    Y0(D0, 7), Y0(D0, 7);
                                    var he = A0(D0), me = 0;
                                    if (typeof he == "number") {
                                      var Zn = 0;
                                      if (he !== 4 && he !== 98 && (Zn = 1), !Zn) {
                                        var wn = Hr(D0, Ut, oi(D0, u(X, D0))), ft = 0, xt = [0, wn[1], [12, wn[2]]], jn = 1, ut = 0;
                                        me = 1;
                                      }
                                    }
                                    if (!me) {
                                      var dt = xu(D0, 85), xn = we(D0);
                                      Y0(D0, 86);
                                      var ft = xn, xt = u(e4, D0), jn = 0, ut = dt;
                                    }
                                    return [0, He, xt, ut, B0 !== 0 ? 1 : 0, jn, lr([0, Le], [0, ft], 0)];
                                  };
                                }(jr, X0, D), $0)];
                                F0 = 1;
                              }
                              if (!F0)
                                var Cr = [2, cr([0, jr], function(W7, Ut, bt) {
                                  return function(B0) {
                                    var D0 = on(W7, pr(B0));
                                    Y0(B0, 6);
                                    var Le = Yn(1, B0) === 86 ? 1 : 0;
                                    if (Le) {
                                      var He = z7(B0);
                                      Y0(B0, 86);
                                      var he = [0, He];
                                    } else
                                      var he = Le;
                                    var me = u(e4, B0);
                                    Y0(B0, 7);
                                    var Zn = we(B0);
                                    Y0(B0, 86);
                                    var wn = u(e4, B0);
                                    return [0, he, me, wn, Ut !== 0 ? 1 : 0, bt, lr([0, D0], [0, Zn], 0)];
                                  };
                                }(X0, D, I0), $0)];
                              break;
                            case 42:
                              if (y0) {
                                if (I0 === 0) {
                                  var Sr = [0, Pe($0)], mr = on(X0, pr($0));
                                  ie($0);
                                  var y0 = 0, P0 = 0, D = Sr, X0 = mr;
                                  continue;
                                }
                                throw [0, Sn, ZJr];
                              }
                              ir = 1;
                              break;
                            case 103:
                            case 104:
                              if (I0 === 0) {
                                var y0 = 0, P0 = 0, I0 = n($0);
                                continue;
                              }
                              ir = 1;
                              break;
                            case 4:
                            case 98:
                              Rr($0, u0), fr($0, I0);
                              var Cr = [3, cr([0, jr], function(W7, Ut) {
                                return function(bt) {
                                  var B0 = Pe(bt), D0 = Hr(bt, B0, oi(bt, u(X, bt)));
                                  return [0, D0, Ut !== 0 ? 1 : 0, lr([0, W7], 0, 0)];
                                };
                              }(X0, D), $0)];
                              break;
                            default:
                              ir = 1;
                          }
                        else if (J0[0] === 4 && !n0(J0[3], QJr)) {
                          if (P0) {
                            if (I0 === 0) {
                              var sr = [0, Pe($0)], Pr = on(X0, pr($0));
                              ie($0);
                              var y0 = 0, P0 = 0, u0 = sr, X0 = Pr;
                              continue;
                            }
                            throw [0, Sn, r$r];
                          }
                          ir = 1;
                        } else
                          ir = 1;
                        if (ir) {
                          var K0 = 0;
                          if (D) {
                            var Ur = D[1];
                            if (u0) {
                              var Cr = ke(e$r);
                              K0 = 1;
                            } else if (typeof J0 == "number" && !(1 < (J0 + W2 | 0) >>> 0)) {
                              var h0 = [0, Ur, [1, Rc(lr([0, X0], 0, 0), [0, Ur, n$r])]], Kr = 0, re = u0, xe = 0;
                              K0 = 2;
                            }
                          } else if (u0) {
                            var Re = u0[1];
                            if (typeof J0 == "number" && !(1 < (J0 + W2 | 0) >>> 0)) {
                              var h0 = [0, Re, [1, Rc(lr([0, X0], 0, 0), [0, Re, t$r])]], Kr = 0, re = 0, xe = D;
                              K0 = 2;
                            }
                          }
                          var ve = 0;
                          switch (K0) {
                            case 0:
                              var Ie = function(Ut) {
                                Ku(Ut, 0);
                                var bt = o(t4[20], 0, Ut);
                                return k7(Ut), bt;
                              }, Ge = pr($0), Me = Ie($0), an = Me[1], We = Me[2], Ae = 0;
                              if (We[0] === 1) {
                                var cn = We[1][2][1], rn = 0;
                                if (n0(cn, u$r) && n0(cn, i$r) && (rn = 1), !rn) {
                                  var kn = A0($0), vn = 0;
                                  if (typeof kn == "number") {
                                    var Ne = kn - 5 | 0;
                                    if (92 < Ne >>> 0) {
                                      if (!(94 < (Ne + 1 | 0) >>> 0)) {
                                        Rr($0, u0), fr($0, I0);
                                        var Je = We;
                                        Ae = 1, vn = 1;
                                      }
                                    } else if (!(1 < (Ne + eX | 0) >>> 0)) {
                                      var h0 = [0, an, We], Kr = X0, re = u0, xe = D;
                                      ve = 1, Ae = 2, vn = 1;
                                    }
                                  }
                                  if (!vn) {
                                    Xi($0, We);
                                    var en = Ie($0), _n = qn(cn, f$r), Cn = on(X0, Ge);
                                    Rr($0, u0), fr($0, I0);
                                    var Cr = [0, cr([0, jr], function(bt, B0, D0, Le, He) {
                                      return function(he) {
                                        var me = D0[1], Zn = Xi(he, D0[2]), wn = Hr(he, bt, 0), ft = wn[2][2];
                                        if (Le) {
                                          var xt = ft[2], jn = 0;
                                          if (xt[1])
                                            ue(he, [0, me, j7]), jn = 1;
                                          else {
                                            var ut = 0;
                                            !xt[2] && !xt[3] && (jn = 1, ut = 1), ut || ue(he, [0, me, 80]);
                                          }
                                        } else {
                                          var dt = ft[2], xn = 0;
                                          if (dt[1])
                                            ue(he, [0, me, Yt]), xn = 1;
                                          else {
                                            var ln = dt[2], it = 0;
                                            if (dt[3])
                                              ue(he, [0, me, 81]);
                                            else {
                                              var Tt = 0;
                                              ln && !ln[2] && (Tt = 1), Tt || (ue(he, [0, me, 81]), it = 1);
                                            }
                                            it || (xn = 1);
                                          }
                                        }
                                        var Ti = lr([0, He], 0, 0), hs = 0, Au = 0, Hs = 0, Vi = B0 !== 0 ? 1 : 0, Xs = 0, Ys = Le ? [1, wn] : [2, wn];
                                        return [0, Zn, Ys, Xs, Vi, Hs, Au, hs, Ti];
                                      };
                                    }(jr, D, en, _n, Cn), $0)];
                                    Ae = 2;
                                  }
                                }
                              }
                              var Hn = 0;
                              switch (Ae) {
                                case 2:
                                  Hn = 1;
                                  break;
                                case 0:
                                  var Fn = Me[2], vt = A0($0), Nt = 0;
                                  if (typeof vt == "number") {
                                    var gt = 0;
                                    if (vt !== 4 && vt !== 98 && (gt = 1), !gt) {
                                      Rr($0, u0), fr($0, I0);
                                      var Je = Fn;
                                      Nt = 1;
                                    }
                                  }
                                  if (!Nt) {
                                    var Zt = D !== 0 ? 1 : 0, qt = 0;
                                    if (Fn[0] === 1) {
                                      var Ft = Fn[1], Ct = Ft[2][1], du = 0;
                                      if (B) {
                                        var Wu = 0;
                                        !qn(x$r, Ct) && (!Zt || !qn(o$r, Ct)) && (Wu = 1), Wu || (ue($0, [0, Ft[1], [21, Ct, Zt, 0, 0]]), qt = 1, du = 1);
                                      }
                                    }
                                    var h0 = [0, an, Fn], Kr = X0, re = u0, xe = D;
                                    ve = 1, Hn = 1;
                                  }
                                  break;
                              }
                              if (!Hn)
                                var lt = Xi($0, Je), ou = Hr($0, jr, oi($0, u(X, $0))), Bu = [0, ou[1], [12, ou[2]]], K7 = [0, lt, [0, Bu], 0, D !== 0 ? 1 : 0, 0, 1, 0, lr([0, X0], 0, 0)], Cr = [0, [0, Bu[1], K7]];
                              break;
                            case 2:
                              ve = 1;
                              break;
                          }
                          if (ve) {
                            var Yi = h0[2], a7 = h0[1];
                            1 - fu($0) && je($0, 12);
                            var Cr = [0, cr([0, jr], function(Ut, bt, B0, D0, Le, He) {
                              return function(he) {
                                var me = xu(he, 85), Zn = pe0(he, 86) ? u(e4, he) : [0, He, $Jr];
                                return [0, Le, [0, Zn], me, bt !== 0 ? 1 : 0, B0 !== 0 ? 1 : 0, 0, Ut, lr([0, D0], 0, 0)];
                              };
                            }(I0, xe, re, Kr, Yi, a7), $0)];
                          }
                        }
                        Or(O0, $0);
                        var Er = [0, [0, Cr, qr], Br, Mr];
                        continue r;
                      }
                    }
                }, b0);
              }), N(U0, function(B) {
                var Z7 = A0(B) === 41 ? 1 : 0;
                if (Z7) {
                  Y0(B, 41);
                  for (var p0 = 0; ; ) {
                    var b0 = [0, u(hr, B), p0], O0 = A0(B);
                    if (typeof O0 == "number" && O0 === 9) {
                      Y0(B, 9);
                      var p0 = b0;
                      continue;
                    }
                    var M0 = de0(B, ye(b0));
                    break;
                  }
                } else
                  var M0 = Z7;
                return [0, M0, R(E0, 0, 0, 0, B)];
              }), N(b, function(B) {
                var Z7 = z7(B), p0 = Z7[2], b0 = p0[1], O0 = Z7[1];
                return ae0(b0) && ue(B, [0, O0, 3]), [0, O0, [0, b0, p0[2]]];
              }), N(R0, function(B) {
                return cr(0, function(Z7) {
                  var p0 = u(b, Z7), b0 = A0(Z7) === 86 ? [1, u(i4, Z7)] : [0, j1(Z7)];
                  return [0, p0, b0];
                }, B);
              }), N(X, function(B) {
                var Z7 = A0(B) === 98 ? 1 : 0;
                if (Z7) {
                  1 - fu(B) && je(B, 12);
                  var p0 = [0, cr(0, function(O0) {
                    var M0 = pr(O0);
                    Y0(O0, 98);
                    for (var er = 0, yr = 0; ; ) {
                      var vr = cr(0, function(ne) {
                        return function(Qr) {
                          var be = n(Qr), ae = u(R0, Qr), pe = ae[2], oe = A0(Qr), ce = 0;
                          if (typeof oe == "number" && oe === 82) {
                            ie(Qr);
                            var ge = 1, q0 = [0, u(e4, Qr)];
                            ce = 1;
                          }
                          if (!ce) {
                            ne && ue(Qr, [0, ae[1], 77]);
                            var ge = ne, q0 = 0;
                          }
                          return [0, be, pe[1], pe[2], q0, ge];
                        };
                      }(er), O0), $0 = vr[2], Er = [0, [0, vr[1], [0, $0[2], $0[3], $0[1], $0[4]]], yr], Mr = A0(O0), Br = 0;
                      if (typeof Mr == "number") {
                        var qr = 0;
                        if (Mr !== 99 && Pn !== Mr && (qr = 1), !qr) {
                          var jr = ye(Er);
                          Br = 1;
                        }
                      }
                      if (!Br) {
                        if (Y0(O0, 9), A0(O0) !== 99) {
                          var er = $0[5], yr = Er;
                          continue;
                        }
                        var jr = ye(Er);
                      }
                      var $r = pr(O0);
                      return Y0(O0, 99), [0, jr, yu([0, M0], [0, we(O0)], $r, 0)];
                    }
                  }, B)];
                } else
                  var p0 = Z7;
                return p0;
              }), N(s0, function(B) {
                var Z7 = A0(B) === 98 ? 1 : 0, p0 = Z7 && [0, cr(0, function(b0) {
                  var O0 = pr(b0);
                  Y0(b0, 98);
                  for (var M0 = u2(0, b0), er = 0; ; ) {
                    var yr = A0(M0);
                    if (typeof yr == "number") {
                      var vr = 0;
                      if ((yr === 99 || Pn === yr) && (vr = 1), vr) {
                        var $0 = ye(er), Er = pr(M0);
                        return Y0(M0, 99), [0, $0, yu([0, O0], [0, we(M0)], Er, 0)];
                      }
                    }
                    var Mr = [0, u(e4, M0), er];
                    A0(M0) !== 99 && Y0(M0, 9);
                    var er = Mr;
                  }
                }, B)];
                return p0;
              }), N(hr, function(B) {
                return o(Ar, B, u(b, B));
              }), N(Ar, function(B, Z7) {
                function p0(b0) {
                  for (var O0 = [0, Z7[1], [0, Z7]]; ; ) {
                    var M0 = O0[2], er = O0[1];
                    if (A0(b0) === 10 && ve0(1, b0)) {
                      var yr = cr([0, er], function(qr) {
                        return function(jr) {
                          return Y0(jr, 10), [0, qr, u(b, jr)];
                        };
                      }(M0), b0), vr = yr[1], O0 = [0, vr, [1, [0, vr, yr[2]]]];
                      continue;
                    }
                    if (A0(b0) === 98)
                      var $0 = $t(b0), Er = function(Br, qr) {
                        return o(Qe(Br, -860373976, 77), Br, qr);
                      }, Mr = o($0[2], M0, Er);
                    else
                      var Mr = M0;
                    return [0, Mr, u(s0, b0), 0];
                  }
                }
                return cr([0, Z7[1]], p0, B);
              }), N(or, function(B, Z7) {
                var p0 = o(Ar, B, Z7);
                return [0, p0[1], [16, p0[2]]];
              }), N(W0, function(B) {
                var Z7 = A0(B);
                return typeof Z7 == "number" && Z7 === 86 ? [1, u(i4, B)] : [0, j1(B)];
              }), N(Lr, function(B, Z7, p0) {
                var b0 = B[2];
                function O0(Sr) {
                  return y7(Sr, lr([0, Z7], [0, p0], 0));
                }
                switch (b0[0]) {
                  case 0:
                    var F0 = [0, O0(b0[1])];
                    break;
                  case 1:
                    var F0 = [1, O0(b0[1])];
                    break;
                  case 2:
                    var F0 = [2, O0(b0[1])];
                    break;
                  case 3:
                    var F0 = [3, O0(b0[1])];
                    break;
                  case 4:
                    var F0 = [4, O0(b0[1])];
                    break;
                  case 5:
                    var F0 = [5, O0(b0[1])];
                    break;
                  case 6:
                    var F0 = [6, O0(b0[1])];
                    break;
                  case 7:
                    var F0 = [7, O0(b0[1])];
                    break;
                  case 8:
                    var F0 = [8, O0(b0[1])];
                    break;
                  case 9:
                    var F0 = [9, O0(b0[1])];
                    break;
                  case 10:
                    var F0 = [10, O0(b0[1])];
                    break;
                  case 11:
                    var M0 = b0[1], er = O0(M0[2]), F0 = [11, [0, M0[1], er]];
                    break;
                  case 12:
                    var yr = b0[1], vr = O0(yr[4]), F0 = [12, [0, yr[1], yr[2], yr[3], vr]];
                    break;
                  case 13:
                    var $0 = b0[1], Er = lr([0, Z7], [0, p0], 0), Mr = JD($0[4], Er), F0 = [13, [0, $0[1], $0[2], $0[3], Mr]];
                    break;
                  case 14:
                    var Br = b0[1], qr = O0(Br[3]), F0 = [14, [0, Br[1], Br[2], qr]];
                    break;
                  case 15:
                    var jr = b0[1], $r = O0(jr[2]), F0 = [15, [0, jr[1], $r]];
                    break;
                  case 16:
                    var ne = b0[1], Qr = O0(ne[3]), F0 = [16, [0, ne[1], ne[2], Qr]];
                    break;
                  case 17:
                    var be = b0[1], ae = O0(be[3]), F0 = [17, [0, be[1], be[2], ae]];
                    break;
                  case 18:
                    var pe = b0[1], oe = pe[1], ce = pe[2], ge = O0(oe[3]), F0 = [18, [0, [0, oe[1], oe[2], ge], ce]];
                    break;
                  case 19:
                    var q0 = b0[1], Fr = O0(q0[2]), F0 = [19, [0, q0[1], Fr]];
                    break;
                  case 20:
                    var _ = b0[1], k = O0(_[2]), F0 = [20, [0, _[1], k]];
                    break;
                  case 21:
                    var I = b0[1], U = O0(I[2]), F0 = [21, [0, I[1], U]];
                    break;
                  case 22:
                    var Y = b0[1], y0 = O0(Y[2]), F0 = [22, [0, Y[1], y0]];
                    break;
                  case 23:
                    var P0 = b0[1], I0 = O0(P0[3]), F0 = [23, [0, P0[1], P0[2], I0]];
                    break;
                  case 24:
                    var D = b0[1], u0 = O0(D[3]), F0 = [24, [0, D[1], D[2], u0]];
                    break;
                  case 25:
                    var X0 = b0[1], J0 = O0(X0[3]), F0 = [25, [0, X0[1], X0[2], J0]];
                    break;
                  default:
                    var ir = b0[1], Q0 = O0(ir[2]), F0 = [26, [0, ir[1], Q0]];
                }
                return [0, B[1], F0];
              });
              function Wr(B) {
                var Z7 = pr(B);
                if (Y0(B, 66), A0(B) === 4) {
                  var p0 = on(Z7, pr(B));
                  Y0(B, 4), Ku(B, 0);
                  var b0 = u(t4[9], B);
                  return k7(B), Y0(B, 5), [0, [0, b0], lr([0, p0], [0, we(B)], 0)];
                }
                return [0, 0, lr([0, Z7], [0, we(B)], 0)];
              }
              var Jr = 0;
              function ar(B) {
                var Z7 = u2(0, B), p0 = A0(Z7);
                return typeof p0 == "number" && p0 === 66 ? [0, cr(Jr, Wr, Z7)] : 0;
              }
              function _r(B) {
                var Z7 = A0(B), p0 = Yn(1, B);
                if (typeof Z7 == "number" && Z7 === 86) {
                  if (typeof p0 == "number" && p0 === 66) {
                    Y0(B, 86);
                    var b0 = ar(B);
                    return [0, [0, j1(B)], b0];
                  }
                  var O0 = u(W0, B), M0 = A0(B) === 66 ? o2(B, O0) : O0;
                  return [0, M0, ar(B)];
                }
                return [0, [0, j1(B)], 0];
              }
              function Ir(B, Z7) {
                var p0 = _s(1, Z7);
                Ku(p0, 1);
                var b0 = u(B, p0);
                return k7(p0), b0;
              }
              function fe(B) {
                return Ir(e4, B);
              }
              function v0(B) {
                return Ir(b, B);
              }
              function P(B) {
                return Ir(X, B);
              }
              function L(B) {
                return Ir(s0, B);
              }
              function Q(B, Z7) {
                return Ir(ur(E0, B, 0, 0), Z7);
              }
              function i0(B) {
                return Ir(U0, B);
              }
              function l0(B) {
                return Ir(l, B);
              }
              function S0(B) {
                return Ir(i4, B);
              }
              function T0(B) {
                return Ir(W0, B);
              }
              function rr(B) {
                return Ir(ar, B);
              }
              function L0(B) {
                return Ir(_r, B);
              }
              return [0, fe, v0, P, L, function(B) {
                return Ir(hr, B);
              }, Q, i0, l0, S0, T0, rr, L0];
            }
            function $ee(t4) {
              function n(c, s2) {
                if (s2[0] === 0)
                  return s2[1];
                var p = s2[2][1];
                return Du(function(y) {
                  return ue(c, y);
                }, p), s2[1];
              }
              function e4(c, s2, p) {
                var y = c ? c[1] : 26;
                if (p[0] === 0)
                  var T = p[1];
                else {
                  var E = p[2][2];
                  Du(function(A11) {
                    return ue(s2, A11);
                  }, E);
                  var T = p[1];
                }
                1 - u(t4[23], T) && ue(s2, [0, T[1], y]);
                var d = T[2], w = 0;
                return d[0] === 10 && js(d[1][2][1]) && (V7(s2, [0, T[1], 52]), w = 1), o(t4[19], s2, T);
              }
              function i4(c, s2) {
                return [0, [0, c, s2[1]], [0, c, s2[2]]];
              }
              function x4(c, s2) {
                var p = Lc(c[2], s2[2]);
                return [0, Lc(c[1], s2[1]), p];
              }
              return [0, n, e4, g$r, i4, x4, function(c) {
                var s2 = ye(c[2]);
                return [0, ye(c[1]), s2];
              }];
            }
            function Zee(t4) {
              function n(S11) {
                var M = A0(S11);
                if (typeof M == "number") {
                  var K = M - 99 | 0, V = 0;
                  if (6 < K >>> 0 ? K === 14 && (V = 1) : 4 < (K - 1 | 0) >>> 0 && (V = 1), V)
                    return we(S11);
                }
                var f0 = x7(S11);
                return f0 && Ms(S11);
              }
              function e4(S11) {
                var M = pr(S11);
                Ku(S11, 0);
                var K = cr(0, function(f0) {
                  Y0(f0, 0), Y0(f0, 12);
                  var m0 = u(t4[10], f0);
                  return Y0(f0, 1), m0;
                }, S11);
                k7(S11);
                var V = lr([0, M], [0, n(S11)], 0);
                return [0, K[1], [0, K[2], V]];
              }
              function i4(S11) {
                return A0(S11) === 1 ? 0 : [0, u(t4[7], S11)];
              }
              function x4(S11) {
                var M = pr(S11);
                Ku(S11, 0);
                var K = cr(0, function(f0) {
                  Y0(f0, 0);
                  var m0 = i4(f0);
                  return Y0(f0, 1), m0;
                }, S11);
                k7(S11);
                var V = yu([0, M], [0, n(S11)], 0, 0);
                return [0, K[1], [0, K[2], V]];
              }
              function c(S11) {
                Ku(S11, 0);
                var M = cr(0, function(K) {
                  Y0(K, 0);
                  var V = A0(K), f0 = 0;
                  if (typeof V == "number" && V === 12) {
                    var m0 = pr(K);
                    Y0(K, 12);
                    var k0 = u(t4[10], K), x0 = [3, [0, k0, lr([0, m0], 0, 0)]];
                    f0 = 1;
                  }
                  if (!f0)
                    var g0 = i4(K), e0 = g0 ? 0 : pr(K), x0 = [2, [0, g0, yu(0, 0, e0, 0)]];
                  return Y0(K, 1), x0;
                }, S11);
                return k7(S11), [0, M[1], M[2]];
              }
              function s2(S11) {
                var M = Pe(S11), K = A0(S11), V = 0;
                if (typeof K != "number" && K[0] === 7) {
                  var f0 = K[1];
                  V = 1;
                }
                if (!V) {
                  St(FQr, S11);
                  var f0 = TQr;
                }
                var m0 = pr(S11);
                ie(S11);
                var k0 = A0(S11), g0 = 0;
                if (typeof k0 == "number") {
                  var e0 = k0 + CX | 0, x0 = 0;
                  if (72 < e0 >>> 0 ? e0 !== 76 && (x0 = 1) : 70 < (e0 - 1 | 0) >>> 0 || (x0 = 1), !x0) {
                    var l = we(S11);
                    g0 = 1;
                  }
                }
                if (!g0)
                  var l = n(S11);
                return [0, M, [0, f0, lr([0, m0], [0, l], 0)]];
              }
              function p(S11) {
                var M = Yn(1, S11);
                if (typeof M == "number") {
                  if (M === 10)
                    for (var K = cr(0, function(m0) {
                      var k0 = [0, s2(m0)];
                      return Y0(m0, 10), [0, k0, s2(m0)];
                    }, S11); ; ) {
                      var V = A0(S11);
                      if (typeof V == "number" && V === 10) {
                        var f0 = function(k0) {
                          return function(g0) {
                            return Y0(g0, 10), [0, [1, k0], s2(g0)];
                          };
                        }(K), K = cr([0, K[1]], f0, S11);
                        continue;
                      }
                      return [2, K];
                    }
                  if (M === 86)
                    return [1, cr(0, function(m0) {
                      var k0 = s2(m0);
                      return Y0(m0, 86), [0, k0, s2(m0)];
                    }, S11)];
                }
                return [0, s2(S11)];
              }
              function y(S11) {
                return cr(0, function(M) {
                  var K = Yn(1, M), V = 0;
                  if (typeof K == "number" && K === 86) {
                    var f0 = [1, cr(0, function(b) {
                      var R0 = s2(b);
                      return Y0(b, 86), [0, R0, s2(b)];
                    }, M)];
                    V = 1;
                  }
                  if (!V)
                    var f0 = [0, s2(M)];
                  var m0 = A0(M), k0 = 0;
                  if (typeof m0 == "number" && m0 === 82) {
                    Y0(M, 82);
                    var g0 = pr(M), e0 = A0(M), x0 = 0;
                    if (typeof e0 == "number")
                      if (e0 === 0) {
                        var l = x4(M), c0 = l[2], t0 = l[1];
                        c0[1] || ue(M, [0, t0, 56]);
                        var o0 = [0, [1, t0, c0]];
                      } else
                        x0 = 1;
                    else if (e0[0] === 8) {
                      Y0(M, e0);
                      var w0 = [0, e0[2]], _0 = lr([0, g0], [0, n(M)], 0), o0 = [0, [0, e0[1], [0, w0, e0[3], _0]]];
                    } else
                      x0 = 1;
                    if (x0) {
                      je(M, 57);
                      var o0 = [0, [0, Pe(M), [0, gQr, SQr, 0]]];
                    }
                    var E0 = o0;
                    k0 = 1;
                  }
                  if (!k0)
                    var E0 = 0;
                  return [0, f0, E0];
                }, S11);
              }
              function T(S11) {
                return cr(0, function(M) {
                  Y0(M, 98);
                  var K = A0(M);
                  if (typeof K == "number") {
                    if (K === 99)
                      return ie(M), wQr;
                  } else if (K[0] === 7)
                    for (var V = 0, f0 = p(M); ; ) {
                      var m0 = A0(M);
                      if (typeof m0 == "number") {
                        if (m0 === 0) {
                          var V = [0, [1, e4(M)], V];
                          continue;
                        }
                      } else if (m0[0] === 7) {
                        var V = [0, [0, y(M)], V];
                        continue;
                      }
                      var k0 = ye(V), g0 = [0, c1, [0, f0, xu(M, j7), k0]];
                      return xu(M, 99) ? [0, g0] : (B1(M, 99), [1, g0]);
                    }
                  return B1(M, 99), EQr;
                }, S11);
              }
              function E(S11) {
                return cr(0, function(M) {
                  Y0(M, 98), Y0(M, j7);
                  var K = A0(M);
                  if (typeof K == "number") {
                    if (K === 99)
                      return ie(M), Ni;
                  } else if (K[0] === 7) {
                    var V = p(M);
                    return pe0(M, 99), [0, c1, [0, V]];
                  }
                  return B1(M, 99), Ni;
                }, S11);
              }
              var d = function S11(M) {
                return S11.fun(M);
              }, w = function S11(M) {
                return S11.fun(M);
              }, G = function S11(M) {
                return S11.fun(M);
              };
              N(d, function(S11) {
                var M = A0(S11);
                if (typeof M == "number") {
                  if (M === 0)
                    return c(S11);
                } else if (M[0] === 8)
                  return Y0(S11, M), [0, M[1], [4, [0, M[2], M[3]]]];
                var K = u(G, S11), V = K[2], f0 = K[1];
                return Ni <= V[1] ? [0, f0, [1, V[2]]] : [0, f0, [0, V[2]]];
              });
              function A11(S11) {
                switch (S11[0]) {
                  case 0:
                    return S11[1][2][1];
                  case 1:
                    var M = S11[1][2], K = Te(hQr, M[2][2][1]);
                    return Te(M[1][2][1], K);
                  default:
                    var V = S11[1][2], f0 = V[1], m0 = f0[0] === 0 ? f0[1][2][1] : A11([2, f0[1]]);
                    return Te(m0, Te(dQr, V[2][2][1]));
                }
              }
              return N(w, function(S11) {
                var M = pr(S11), K = T(S11);
                k7(S11);
                var V = K[2];
                if (V[0] === 0)
                  var f0 = V[1], m0 = typeof f0 == "number" ? 0 : f0[2][2], k0 = m0;
                else
                  var k0 = 1;
                if (k0)
                  var g0 = SU, e0 = g0, x0 = cr(0, function(qr) {
                    return 0;
                  }, S11);
                else {
                  Ku(S11, 3);
                  for (var l = Pe(S11), c0 = 0; ; ) {
                    var t0 = i2(S11), o0 = A0(S11), w0 = 0;
                    if (typeof o0 == "number") {
                      var _0 = 0;
                      if (o0 === 98) {
                        Ku(S11, 2);
                        var E0 = A0(S11), U0 = Yn(1, S11), b = 0;
                        if (typeof E0 == "number" && E0 === 98 && typeof U0 == "number") {
                          var R0 = 0;
                          if (j7 !== U0 && Pn !== U0 && (R0 = 1), !R0) {
                            var X = E(S11), s0 = X[2], hr = X[1], Ar = typeof s0 == "number" ? [0, Ni, hr] : [0, c1, [0, hr, s0[2]]], or = S11[23][1], W0 = 0;
                            if (or) {
                              var Lr = or[2];
                              if (Lr) {
                                var Tr = Lr[2];
                                W0 = 1;
                              }
                            }
                            if (!W0)
                              var Tr = ke(wRr);
                            S11[23][1] = Tr;
                            var Hr = n2(S11), Or = Yl(S11[24][1], Hr);
                            S11[25][1] = Or;
                            var fr = [0, ye(c0), t0, Ar];
                            b = 1;
                          }
                        }
                        if (!b) {
                          var Rr = u(w, S11), Wr = Rr[2], Jr = Rr[1], ar = Ni <= Wr[1] ? [0, Jr, [1, Wr[2]]] : [0, Jr, [0, Wr[2]]], c0 = [0, ar, c0];
                          continue;
                        }
                      } else if (Pn === o0) {
                        St(0, S11);
                        var fr = [0, ye(c0), t0, SU];
                      } else
                        w0 = 1, _0 = 1;
                      if (!_0)
                        var _r = t0 ? t0[1] : l, Ir = yt(l, _r), e0 = fr[3], x0 = [0, Ir, fr[1]];
                    } else
                      w0 = 1;
                    if (w0) {
                      var c0 = [0, u(d, S11), c0];
                      continue;
                    }
                    break;
                  }
                }
                var fe = we(S11), v0 = 0;
                if (typeof e0 != "number") {
                  var P = e0[1], L = 0;
                  if (c1 === P) {
                    var Q = e0[2], i0 = K[2];
                    if (i0[0] === 0) {
                      var l0 = i0[1];
                      if (typeof l0 == "number")
                        je(S11, kQr);
                      else {
                        var S0 = A11(l0[2][1]);
                        n0(A11(Q[2][1]), S0) && je(S11, [17, S0]);
                      }
                    }
                    var T0 = Q[1];
                  } else if (Ni === P) {
                    var rr = K[2];
                    if (rr[0] === 0) {
                      var L0 = rr[1];
                      typeof L0 != "number" && je(S11, [17, A11(L0[2][1])]);
                    }
                    var T0 = e0[2];
                  } else
                    L = 1;
                  if (!L) {
                    var B = T0;
                    v0 = 1;
                  }
                }
                if (!v0)
                  var B = K[1];
                var Z7 = K[2][1], p0 = K[1];
                if (typeof Z7 == "number") {
                  var b0 = 0, O0 = lr([0, M], [0, fe], 0);
                  if (typeof e0 != "number") {
                    var M0 = e0[1], er = 0;
                    if (c1 === M0)
                      var yr = e0[2][1];
                    else if (Ni === M0)
                      var yr = e0[2];
                    else
                      er = 1;
                    if (!er) {
                      var vr = yr;
                      b0 = 1;
                    }
                  }
                  if (!b0)
                    var vr = B;
                  var $0 = [0, Ni, [0, p0, vr, x0, O0]];
                } else {
                  var Er = 0, Mr = lr([0, M], [0, fe], 0);
                  if (typeof e0 != "number" && c1 === e0[1]) {
                    var Br = [0, e0[2]];
                    Er = 1;
                  }
                  if (!Er)
                    var Br = 0;
                  var $0 = [0, c1, [0, [0, p0, Z7[2]], Br, x0, Mr]];
                }
                return [0, yt(K[1], B), $0];
              }), N(G, function(S11) {
                return Ku(S11, 2), u(w, S11);
              }), [0, n, e4, i4, x4, c, s2, p, y, T, E, d, w, G];
            }
            function Fi(t4) {
              return typeof t4 == "number" ? 0 : t4[0] === 0 ? 1 : t4[1];
            }
            function Qee(t4, n) {
              return [0, t4, n];
            }
            function tb(t4, n, e4) {
              return [1, 2, n, e4, t4, 0];
            }
            function ub(t4, n, e4) {
              return [1, 2, t4, n, 0, e4];
            }
            function Uc(t4, n, e4, i4) {
              var x4 = Fi(t4), c = Fi(i4), s2 = c <= x4 ? x4 + 1 | 0 : c + 1 | 0;
              return s2 === 1 ? [0, n, e4] : [1, s2, n, e4, t4, i4];
            }
            function FL(t4, n) {
              var e4 = n !== 0 ? 1 : 0;
              if (e4) {
                if (n !== 1) {
                  var i4 = n >>> 1 | 0, x4 = FL(t4, i4), c = u(t4, 0), s2 = FL(t4, (n - i4 | 0) - 1 | 0), p = c[2], y = c[1];
                  return [1, Fi(x4) + 1 | 0, y, p, x4, s2];
                }
                var T = u(t4, 0), E = [0, T[1], T[2]];
              } else
                var E = e4;
              return E;
            }
            function P9(t4, n, e4, i4) {
              var x4 = Fi(t4), c = Fi(i4), s2 = c <= x4 ? x4 + 1 | 0 : c + 1 | 0;
              return [1, s2, n, e4, t4, i4];
            }
            function Iu(t4, n, e4, i4) {
              var x4 = Fi(t4), c = Fi(i4);
              if ((c + 2 | 0) < x4) {
                var s2 = t4[5], p = t4[4], y = t4[3], T = t4[2], E = Fi(s2);
                if (E <= Fi(p))
                  return P9(p, T, y, Uc(s2, n, e4, i4));
                var d = Uc(s2[5], n, e4, i4), w = s2[3], G = s2[2];
                return P9(Uc(p, T, y, s2[4]), G, w, d);
              }
              if ((x4 + 2 | 0) < c) {
                var A11 = i4[5], S11 = i4[4], M = i4[3], K = i4[2], V = Fi(S11);
                if (V <= Fi(A11))
                  return P9(Uc(t4, n, e4, S11), K, M, A11);
                var f0 = Uc(S11[5], K, M, A11), m0 = S11[3], k0 = S11[2];
                return P9(Uc(t4, n, e4, S11[4]), k0, m0, f0);
              }
              return Uc(t4, n, e4, i4);
            }
            var o7 = 0;
            function rne(t4) {
              var n = typeof t4 == "number" ? 1 : 0, e4 = n && 1;
              return e4;
            }
            function qs(t4, n) {
              for (var e4 = t4, i4 = n; ; ) {
                if (typeof e4 == "number")
                  return i4;
                if (e4[0] === 0)
                  return [0, e4[1], e4[2], o7, i4];
                var x4 = [0, e4[2], e4[3], e4[5], i4], e4 = e4[4], i4 = x4;
              }
            }
            function Fe0(t4) {
              for (var n = t4; ; ) {
                if (typeof n == "number")
                  throw Jt;
                if (n[0] === 0)
                  return n;
                if (typeof n[4] == "number")
                  return [0, n[2], n[3]];
                var n = n[4];
              }
            }
            function Te0(t4) {
              for (var n = t4; ; ) {
                var e4 = n[4];
                if (typeof e4 == "number")
                  return [0, n[2], n[3]];
                if (e4[0] === 0)
                  return e4;
                var n = e4;
              }
            }
            function Oe0(t4) {
              for (var n = t4; ; ) {
                if (typeof n == "number")
                  return 0;
                if (n[0] === 0)
                  return [0, [0, n[1], n[2]]];
                if (typeof n[4] == "number")
                  return [0, [0, n[2], n[3]]];
                var n = n[4];
              }
            }
            function ene(t4) {
              for (var n = t4; ; ) {
                if (typeof n == "number")
                  throw Jt;
                if (n[0] === 0)
                  return n;
                if (typeof n[5] == "number")
                  return [0, n[2], n[3]];
                var n = n[5];
              }
            }
            function nne(t4) {
              for (var n = t4; ; ) {
                if (typeof n == "number")
                  return 0;
                if (n[0] === 0)
                  return [0, [0, n[1], n[2]]];
                if (typeof n[5] == "number")
                  return [0, [0, n[2], n[3]]];
                var n = n[5];
              }
            }
            function TL(t4) {
              var n = t4[5], e4 = t4[4], i4 = t4[3], x4 = t4[2];
              return typeof e4 == "number" ? n : e4[0] === 0 ? Iu(0, x4, i4, n) : Iu(TL(e4), x4, i4, n);
            }
            function OL(t4, n) {
              if (typeof n == "number")
                return t4;
              if (n[0] === 0)
                return tb(t4, n[1], n[2]);
              var e4 = n[5], i4 = n[3], x4 = n[2];
              return Iu(OL(t4, n[4]), x4, i4, e4);
            }
            function Ie0(t4, n, e4) {
              if (typeof e4 == "number")
                return [0, t4, n];
              if (e4[0] === 0)
                return ub(t4, n, e4);
              var i4 = e4[5], x4 = e4[3], c = e4[2];
              return Iu(Ie0(t4, n, e4[4]), c, x4, i4);
            }
            function IL(t4, n) {
              if (typeof n == "number")
                return t4;
              if (n[0] === 0)
                return ub(n[1], n[2], t4);
              var e4 = IL(t4, n[5]);
              return Iu(n[4], n[2], n[3], e4);
            }
            function Ae0(t4, n, e4) {
              if (typeof e4 == "number")
                return [0, t4, n];
              if (e4[0] === 0)
                return tb(e4, t4, n);
              var i4 = Ae0(t4, n, e4[5]);
              return Iu(e4[4], e4[2], e4[3], i4);
            }
            function Ne0(t4, n) {
              if (typeof t4 == "number")
                return n;
              if (t4[0] === 1 && typeof n != "number") {
                if (n[0] === 0)
                  return IL(n, t4);
                var e4 = Te0(n), i4 = TL(n);
                return Iu(t4, e4[1], e4[2], i4);
              }
              return typeof n == "number" ? t4 : OL(t4, n);
            }
            function ai(t4, n, e4, i4) {
              if (typeof t4 == "number")
                return Ie0(n, e4, i4);
              if (t4[0] === 0) {
                if (typeof i4 != "number") {
                  if (i4[0] === 0)
                    return [1, 2, n, e4, t4, i4];
                  if (3 < i4[1]) {
                    var x4 = i4[5], c = i4[3], s2 = i4[2];
                    return Iu(ai(t4, n, e4, i4[4]), s2, c, x4);
                  }
                  return Uc(t4, n, e4, i4);
                }
              } else {
                var p = t4[5], y = t4[4], T = t4[3], E = t4[2], d = t4[1];
                if (typeof i4 != "number") {
                  if (i4[0] === 0)
                    return 3 < d ? Iu(y, E, T, ai(p, n, e4, i4)) : Uc(t4, n, e4, i4);
                  var w = i4[1];
                  if ((w + 2 | 0) < d)
                    return Iu(y, E, T, ai(p, n, e4, i4));
                  if ((d + 2 | 0) < w) {
                    var G = i4[5], A11 = i4[3], S11 = i4[2];
                    return Iu(ai(t4, n, e4, i4[4]), S11, A11, G);
                  }
                  return Uc(t4, n, e4, i4);
                }
              }
              return Ae0(n, e4, t4);
            }
            function D9(t4, n) {
              if (typeof t4 == "number")
                return n;
              if (t4[0] === 1 && typeof n != "number") {
                if (n[0] === 0)
                  return IL(n, t4);
                var e4 = Te0(n), i4 = TL(n);
                return ai(t4, e4[1], e4[2], i4);
              }
              return typeof n == "number" ? t4 : OL(t4, n);
            }
            function ib(t4, n, e4, i4) {
              return e4 ? ai(t4, n, e4[1], i4) : D9(t4, i4);
            }
            function Ce0(t4, n) {
              for (var e4 = n; ; ) {
                if (typeof e4 == "number")
                  return 0;
                if (e4[0] === 0)
                  return o(t4, e4[1], e4[2]);
                Ce0(t4, e4[4]), o(t4, e4[2], e4[3]);
                var e4 = e4[5];
              }
            }
            function AL(t4, n) {
              if (typeof n == "number")
                return 0;
              if (n[0] === 0) {
                var e4 = u(t4, n[2]);
                return [0, n[1], e4];
              }
              var i4 = AL(t4, n[4]), x4 = u(t4, n[3]), c = AL(t4, n[5]);
              return [1, n[1], n[2], x4, i4, c];
            }
            function NL(t4, n) {
              if (typeof n == "number")
                return 0;
              if (n[0] === 0) {
                var e4 = n[1];
                return [0, e4, o(t4, e4, n[2])];
              }
              var i4 = n[2], x4 = NL(t4, n[4]), c = o(t4, i4, n[3]), s2 = NL(t4, n[5]);
              return [1, n[1], i4, c, x4, s2];
            }
            function CL(t4, n, e4) {
              for (var i4 = n, x4 = e4; ; ) {
                if (typeof i4 == "number")
                  return x4;
                if (i4[0] === 0)
                  return ur(t4, i4[1], i4[2], x4);
                var c = CL(t4, i4[4], x4), s2 = ur(t4, i4[2], i4[3], c), i4 = i4[5], x4 = s2;
              }
            }
            function Pe0(t4, n) {
              for (var e4 = t4, i4 = n; ; ) {
                if (typeof i4 == "number")
                  return e4;
                if (i4[0] === 0)
                  return [0, i4[1], e4];
                var x4 = i4[4], c = Pe0(e4, i4[5]), e4 = [0, i4[2], c], i4 = x4;
              }
            }
            function De0(t4) {
              return Pe0(0, t4);
            }
            function Le0(t4, n) {
              for (var e4 = n; ; ) {
                if (typeof e4 == "number")
                  return 1;
                if (e4[0] === 0)
                  return o(t4, e4[1], e4[2]);
                var i4 = o(t4, e4[2], e4[3]);
                if (i4) {
                  var x4 = Le0(t4, e4[4]);
                  if (x4) {
                    var e4 = e4[5];
                    continue;
                  }
                  var c = x4;
                } else
                  var c = i4;
                return c;
              }
            }
            function Re0(t4, n) {
              for (var e4 = n; ; ) {
                if (typeof e4 == "number")
                  return 0;
                if (e4[0] === 0)
                  return o(t4, e4[1], e4[2]);
                var i4 = o(t4, e4[2], e4[3]);
                if (i4)
                  var x4 = i4;
                else {
                  var c = Re0(t4, e4[4]);
                  if (!c) {
                    var e4 = e4[5];
                    continue;
                  }
                  var x4 = c;
                }
                return x4;
              }
            }
            function PL(t4, n) {
              if (typeof n == "number")
                return 0;
              if (n[0] === 0)
                return o(t4, n[1], n[2]) ? n : o7;
              var e4 = n[5], i4 = n[4], x4 = n[3], c = n[2], s2 = PL(t4, i4), p = o(t4, c, x4), y = PL(t4, e4);
              return p ? i4 === s2 && e4 === y ? n : ai(s2, c, x4, y) : D9(s2, y);
            }
            function DL(t4) {
              if (typeof t4 == "number")
                return 0;
              if (t4[0] === 0)
                return 1;
              var n = DL(t4[5]);
              return (DL(t4[4]) + 1 | 0) + n | 0;
            }
            function je0(t4, n) {
              for (var e4 = t4, i4 = n; ; ) {
                if (typeof i4 == "number")
                  return e4;
                if (i4[0] === 0)
                  return [0, i4, e4];
                var x4 = i4[4], c = je0(e4, i4[5]), e4 = [0, [0, i4[2], i4[3]], c], i4 = x4;
              }
            }
            function tne(t4) {
              return je0(0, t4);
            }
            var L9 = function(t4) {
              function n(A11, S11, M) {
                if (typeof M == "number")
                  return [0, A11, S11];
                if (M[0] === 0) {
                  var K = M[1], V = o(t4[1], A11, K);
                  return V === 0 ? M[2] === S11 ? M : [0, K, S11] : 0 <= V ? tb(M, A11, S11) : ub(A11, S11, M);
                }
                var f0 = M[5], m0 = M[4], k0 = M[3], g0 = M[2], e0 = o(t4[1], A11, g0);
                if (e0 === 0)
                  return k0 === S11 ? M : [1, M[1], A11, S11, m0, f0];
                if (0 <= e0) {
                  var x0 = n(A11, S11, f0);
                  return f0 === x0 ? M : Iu(m0, g0, k0, x0);
                }
                var l = n(A11, S11, m0);
                return m0 === l ? M : Iu(l, g0, k0, f0);
              }
              function e4(A11, S11) {
                for (var M = S11; ; ) {
                  if (typeof M == "number")
                    throw Jt;
                  if (M[0] === 0) {
                    if (o(t4[1], A11, M[1]) === 0)
                      return M[2];
                    throw Jt;
                  }
                  var K = o(t4[1], A11, M[2]);
                  if (K === 0)
                    return M[3];
                  var V = 0 <= K ? M[5] : M[4], M = V;
                }
              }
              function i4(A11, S11) {
                for (var M = S11; ; ) {
                  if (typeof M == "number")
                    return 0;
                  if (M[0] === 0) {
                    var K = o(t4[1], A11, M[1]) === 0 ? 1 : 0, V = K && [0, M[2]];
                    return V;
                  }
                  var f0 = o(t4[1], A11, M[2]);
                  if (f0 === 0)
                    return [0, M[3]];
                  var m0 = 0 <= f0 ? M[5] : M[4], M = m0;
                }
              }
              function x4(A11, S11) {
                for (var M = S11; ; ) {
                  if (typeof M == "number")
                    return 0;
                  if (M[0] === 0)
                    return o(t4[1], A11, M[1]) === 0 ? 1 : 0;
                  var K = o(t4[1], A11, M[2]), V = K === 0 ? 1 : 0;
                  if (V)
                    return V;
                  var f0 = 0 <= K ? M[5] : M[4], M = f0;
                }
              }
              function c(A11, S11) {
                if (typeof S11 == "number")
                  return S11;
                if (S11[0] === 0)
                  return o(t4[1], A11, S11[1]) === 0 ? o7 : S11;
                var M = S11[5], K = S11[4], V = S11[3], f0 = S11[2], m0 = o(t4[1], A11, f0);
                if (m0 === 0)
                  return Ne0(K, M);
                if (0 <= m0) {
                  var k0 = c(A11, M);
                  return M === k0 ? S11 : Iu(K, f0, V, k0);
                }
                var g0 = c(A11, K);
                return K === g0 ? S11 : Iu(g0, f0, V, M);
              }
              function s2(A11, S11, M) {
                if (typeof M == "number")
                  return [0, A11, u(S11, 0)];
                if (M[0] === 0) {
                  var K = M[2], V = M[1], f0 = o(t4[1], A11, V);
                  if (f0 === 0) {
                    var m0 = u(S11, [0, K]);
                    return K === m0 ? M : [0, V, m0];
                  }
                  var k0 = u(S11, 0);
                  return 0 <= f0 ? tb(M, A11, k0) : ub(A11, k0, M);
                }
                var g0 = M[5], e0 = M[4], x0 = M[3], l = M[2], c0 = o(t4[1], A11, l);
                if (c0 === 0) {
                  var t0 = u(S11, [0, x0]);
                  return x0 === t0 ? M : [1, M[1], A11, t0, e0, g0];
                }
                if (0 <= c0) {
                  var o0 = s2(A11, S11, g0);
                  return g0 === o0 ? M : Iu(e0, l, x0, o0);
                }
                var w0 = s2(A11, S11, e0);
                return e0 === w0 ? M : Iu(w0, l, x0, g0);
              }
              function p(A11, S11, M) {
                if (typeof M == "number") {
                  var K = u(S11, 0);
                  return K && [0, A11, K[1]];
                } else {
                  if (M[0] === 0) {
                    var V = M[2], f0 = M[1], m0 = o(t4[1], A11, f0);
                    if (m0 === 0) {
                      var k0 = u(S11, [0, V]);
                      if (k0) {
                        var g0 = k0[1];
                        return V === g0 ? M : [0, f0, g0];
                      }
                      return o7;
                    }
                    var e0 = u(S11, 0);
                    if (e0) {
                      var x0 = e0[1];
                      return 0 <= m0 ? tb(M, A11, x0) : ub(A11, x0, M);
                    }
                    return M;
                  }
                  var l = M[5], c0 = M[4], t0 = M[3], o0 = M[2], w0 = o(t4[1], A11, o0);
                  if (w0 === 0) {
                    var _0 = u(S11, [0, t0]);
                    if (_0) {
                      var E0 = _0[1];
                      return t0 === E0 ? M : [1, M[1], A11, E0, c0, l];
                    }
                    return Ne0(c0, l);
                  }
                  if (0 <= w0) {
                    var U0 = p(A11, S11, l);
                    return l === U0 ? M : Iu(c0, o0, t0, U0);
                  }
                  var b = p(A11, S11, c0);
                  return c0 === b ? M : Iu(b, o0, t0, l);
                }
              }
              function y(A11, S11) {
                if (typeof S11 == "number")
                  return OQr;
                if (S11[0] === 0) {
                  var M = o(t4[1], A11, S11[1]);
                  return M === 0 ? [0, o7, [0, S11[2]], o7] : 0 <= M ? [0, S11, 0, o7] : [0, o7, 0, S11];
                }
                var K = S11[5], V = S11[4], f0 = S11[3], m0 = S11[2], k0 = o(t4[1], A11, m0);
                if (k0 === 0)
                  return [0, V, [0, f0], K];
                if (0 <= k0) {
                  var g0 = y(A11, K), e0 = g0[3], x0 = g0[2];
                  return [0, ai(V, m0, f0, g0[1]), x0, e0];
                }
                var l = y(A11, V), c0 = ai(l[3], m0, f0, K);
                return [0, l[1], l[2], c0];
              }
              function T(A11, S11, M) {
                if (typeof S11 == "number") {
                  if (typeof M == "number")
                    return 0;
                  if (M[0] === 0) {
                    var K = M[1], V = ur(A11, K, 0, [0, M[2]]);
                    return V ? [0, K, V[1]] : o7;
                  }
                } else if (S11[0] === 0) {
                  var f0 = S11[2], m0 = S11[1];
                  if (typeof M == "number") {
                    var k0 = ur(A11, m0, [0, f0], 0);
                    return k0 ? [0, m0, k0[1]] : o7;
                  } else if (M[0] === 0) {
                    var g0 = y(m0, M), e0 = T(A11, o7, g0[3]), x0 = ur(A11, m0, [0, f0], g0[2]);
                    return ib(T(A11, o7, g0[1]), m0, x0, e0);
                  }
                } else {
                  var l = S11[2], c0 = Fi(M);
                  if (c0 <= S11[1]) {
                    var t0 = y(l, M), o0 = T(A11, S11[5], t0[3]), w0 = ur(A11, l, [0, S11[3]], t0[2]);
                    return ib(T(A11, S11[4], t0[1]), l, w0, o0);
                  }
                  var _0 = 0;
                  if ((typeof M == "number" || M[0] !== 1) && (_0 = 1), _0)
                    throw [0, Sn, IQr];
                }
                var E0 = M[2], U0 = y(E0, S11), b = T(A11, U0[3], M[5]), R0 = ur(A11, E0, U0[2], [0, M[3]]);
                return ib(T(A11, U0[1], M[4]), E0, R0, b);
              }
              function E(A11, S11, M) {
                var K = 0;
                if (typeof S11 == "number") {
                  var _0 = M;
                  K = 1;
                } else if (S11[0] === 1) {
                  var V = S11[3], f0 = S11[2];
                  if (typeof M != "number" && M[0] !== 0) {
                    var m0 = M[3], k0 = M[2];
                    if (M[1] <= S11[1]) {
                      var g0 = y(f0, M), e0 = g0[2], x0 = E(A11, S11[4], g0[1]), l = E(A11, S11[5], g0[3]);
                      return e0 ? ib(x0, f0, ur(A11, f0, V, e0[1]), l) : ai(x0, f0, V, l);
                    }
                    var c0 = y(k0, S11), t0 = c0[2], o0 = E(A11, c0[1], M[4]), w0 = E(A11, c0[3], M[5]);
                    return t0 ? ib(o0, k0, ur(A11, k0, t0[1], m0), w0) : ai(o0, k0, m0, w0);
                  }
                }
                if (!K)
                  if (typeof M == "number")
                    var _0 = S11;
                  else {
                    if (M[0] === 0) {
                      var E0 = M[2], U0 = M[1];
                      return p(U0, function(X) {
                        return X ? ur(A11, U0, X[1], E0) : [0, E0];
                      }, S11);
                    }
                    var b = S11[2], R0 = S11[1];
                    return p(R0, function(X) {
                      return X ? ur(A11, R0, b, X[1]) : [0, b];
                    }, M);
                  }
                return _0;
              }
              function d(A11, S11) {
                if (typeof S11 == "number")
                  return AQr;
                if (S11[0] === 0)
                  return o(A11, S11[1], S11[2]) ? [0, S11, o7] : [0, o7, S11];
                var M = S11[3], K = S11[2], V = d(A11, S11[4]), f0 = V[2], m0 = V[1], k0 = o(A11, K, M), g0 = d(A11, S11[5]), e0 = g0[2], x0 = g0[1];
                if (k0) {
                  var l = D9(f0, e0);
                  return [0, ai(m0, K, M, x0), l];
                }
                var c0 = ai(f0, K, M, e0);
                return [0, D9(m0, x0), c0];
              }
              function w(A11, S11, M) {
                for (var K = qs(M, 0), V = qs(S11, 0), f0 = K; ; ) {
                  if (V) {
                    if (f0) {
                      var m0 = o(t4[1], V[1], f0[1]);
                      if (m0 === 0) {
                        var k0 = o(A11, V[2], f0[2]);
                        if (k0 === 0) {
                          var g0 = qs(f0[3], f0[4]), V = qs(V[3], V[4]), f0 = g0;
                          continue;
                        }
                        return k0;
                      }
                      return m0;
                    }
                    return 1;
                  }
                  var e0 = f0 && -1;
                  return e0;
                }
              }
              function G(A11, S11, M) {
                for (var K = qs(M, 0), V = qs(S11, 0), f0 = K; ; ) {
                  if (V) {
                    if (f0) {
                      var m0 = o(t4[1], V[1], f0[1]) === 0 ? 1 : 0;
                      if (m0) {
                        var k0 = o(A11, V[2], f0[2]);
                        if (k0) {
                          var g0 = qs(f0[3], f0[4]), V = qs(V[3], V[4]), f0 = g0;
                          continue;
                        }
                        var e0 = k0;
                      } else
                        var e0 = m0;
                    } else
                      var e0 = f0;
                    return e0;
                  }
                  return f0 ? 0 : 1;
                }
              }
              return [0, o7, rne, x4, n, p, s2, Qee, c, T, E, w, G, Ce0, CL, Le0, Re0, PL, d, DL, tne, Fe0, Oe0, ene, nne, De0, De0, function(A11, S11, M) {
                var K = [0, o7, 0], V = CL(function(f0, m0, k0) {
                  var g0 = k0[1], e0 = u(S11, f0), x0 = k0[2], l = x0 || (e0 !== f0 ? 1 : 0);
                  if (A11)
                    var c0 = A11[1], t0 = s2(e0, function(o0) {
                      return o0 ? o(c0, o0[1], m0) : m0;
                    }, g0);
                  else
                    var t0 = n(e0, m0, g0);
                  return [0, t0, l];
                }, M, K);
                return V[2] ? V[1] : M;
              }, Fe0, Oe0, y, e4, i4, AL, NL, FL];
            }([0, bz]);
            function a2(t4) {
              return [0, j1(t4)];
            }
            var LL = eL([0, function(t4, n) {
              var e4 = z00(t4[1], n[1]);
              return e4 === 0 ? o(tr0, t4[2], n[2]) : e4;
            }]);
            function fb(t4, n, e4) {
              var i4 = e4[2][1];
              return qn(i4, cre) ? n : o(Mu[3], i4, n) ? (ue(t4, [0, e4[1], [19, i4]]), n) : o(Mu[4], i4, n);
            }
            function RL(t4, n) {
              var e4 = n[2];
              switch (e4[0]) {
                case 0:
                  var i4 = e4[1][1];
                  return le(function(c, s2) {
                    var p = s2[0] === 0 ? s2[1][2][2] : s2[1][2][1];
                    return RL(c, p);
                  }, t4, i4);
                case 1:
                  var x4 = e4[1][1];
                  return le(function(c, s2) {
                    return s2[0] === 2 ? c : RL(c, s2[1][2][1]);
                  }, t4, x4);
                case 2:
                  return [0, e4[1][1], t4];
                default:
                  return ke(are);
              }
            }
            var se = pu(vre, sre), mn = Jee(se), Vn = function(t4) {
              var n = [0, KJr, Mu[1], 0, 0];
              function e4(o0) {
                var w0 = A0(o0);
                if (typeof w0 == "number") {
                  var _0 = 0;
                  if (8 <= w0 ? 10 <= w0 || (_0 = 1) : w0 === 1 && (_0 = 1), _0)
                    return 1;
                }
                return 0;
              }
              function i4(o0) {
                var w0 = z7(o0), _0 = A0(o0), E0 = 0;
                if (typeof _0 == "number") {
                  var U0 = 0;
                  if (_0 === 82 ? Y0(o0, 82) : _0 === 86 ? (je(o0, [4, w0[2][1]]), Y0(o0, 86)) : U0 = 1, !U0) {
                    var b = Pe(o0), R0 = pr(o0), X = A0(o0), s0 = 0;
                    if (typeof X == "number")
                      switch (X) {
                        case 30:
                        case 31:
                          ie(o0);
                          var hr = we(o0), Ar = e4(o0) ? [1, b, [0, X === 31 ? 1 : 0, lr([0, R0], [0, hr], 0)]] : [0, b], or = Ar;
                          break;
                        default:
                          s0 = 1;
                      }
                    else
                      switch (X[0]) {
                        case 0:
                          var W0 = X[2], Lr = ur(se[24], o0, X[1], W0), Tr = we(o0), Hr = e4(o0) ? [2, b, [0, Lr, W0, lr([0, R0], [0, Tr], 0)]] : [0, b], or = Hr;
                          break;
                        case 2:
                          var Or = X[1], fr = Or[1];
                          Or[4] && gi(o0, 45), ie(o0);
                          var Rr = we(o0);
                          if (e4(o0))
                            var Wr = lr([0, R0], [0, Rr], 0), Jr = [3, fr, [0, Or[2], Or[3], Wr]];
                          else
                            var Jr = [0, fr];
                          var or = Jr;
                          break;
                        default:
                          s0 = 1;
                      }
                    if (s0) {
                      ie(o0);
                      var or = [0, b];
                    }
                    var ar = or;
                    E0 = 1;
                  }
                }
                if (!E0)
                  var ar = 0;
                return [0, w0, ar];
              }
              var x4 = 0;
              function c(o0) {
                var w0 = pr(o0);
                Y0(o0, 48);
                var _0 = o(se[13], 0, o0), E0 = _0[2][1], U0 = _0[1], b = cr(0, function(R0) {
                  var X = xu(R0, 63);
                  if (X) {
                    Ku(R0, 1);
                    var s0 = A0(R0), hr = 0;
                    if (typeof s0 == "number")
                      switch (s0) {
                        case 117:
                          var Ar = HJr;
                          break;
                        case 119:
                          var Ar = XJr;
                          break;
                        case 121:
                          var Ar = YJr;
                          break;
                        default:
                          hr = 1;
                      }
                    else
                      switch (s0[0]) {
                        case 4:
                          je(R0, [3, E0, [0, s0[2]]]);
                          var Ar = 0;
                          break;
                        case 9:
                          if (s0[1])
                            var Ar = VJr;
                          else
                            hr = 1;
                          break;
                        default:
                          hr = 1;
                      }
                    if (hr) {
                      je(R0, [3, E0, 0]);
                      var Ar = 0;
                    }
                    ie(R0), k7(R0);
                    var or = Ar;
                  } else
                    var or = X;
                  var W0 = or !== 0 ? 1 : 0, Lr = W0 && pr(R0);
                  Y0(R0, 0);
                  for (var Tr = n; ; ) {
                    var Hr = A0(R0);
                    if (typeof Hr == "number") {
                      var Or = Hr - 2 | 0;
                      if (Xt < Or >>> 0) {
                        if (!(T7 < (Or + 1 | 0) >>> 0)) {
                          var fr = Tr[3], Rr = Tr[4], Wr = ye(Tr[1][4]), Jr = ye(Tr[1][3]), ar = ye(Tr[1][2]), _r = ye(Tr[1][1]), Ir = on(Rr, pr(R0));
                          Y0(R0, 1);
                          var fe = A0(R0), v0 = 0;
                          if (typeof fe == "number") {
                            var P = 0;
                            if (fe !== 1 && Pn !== fe && (v0 = 1, P = 1), !P)
                              var Q = we(R0);
                          } else
                            v0 = 1;
                          if (v0)
                            var L = x7(R0), Q = L && Ms(R0);
                          var i0 = yu([0, Lr], [0, Q], Ir, 0);
                          if (or)
                            switch (or[1]) {
                              case 0:
                                return [0, [0, _r, 1, fr, i0]];
                              case 1:
                                return [1, [0, ar, 1, fr, i0]];
                              case 2:
                                var l0 = 1;
                                break;
                              default:
                                return [3, [0, Wr, fr, i0]];
                            }
                          else {
                            var S0 = Dc(_r), T0 = Dc(ar), rr = Dc(Jr), L0 = Dc(Wr), B = 0;
                            if (S0 === 0 && T0 === 0) {
                              var Z7 = 0;
                              if (rr === 0 && L0 === 0 && (B = 1, Z7 = 1), !Z7) {
                                var l0 = 0;
                                B = 2;
                              }
                            }
                            var p0 = 0;
                            switch (B) {
                              case 0:
                                if (T0 === 0 && rr === 0 && L0 <= S0)
                                  return Du(function(K0) {
                                    return ue(R0, [0, K0[1], [0, E0, K0[2][1][2][1]]]);
                                  }, Wr), [0, [0, _r, 0, fr, i0]];
                                if (S0 === 0 && rr === 0 && L0 <= T0)
                                  return Du(function(K0) {
                                    return ue(R0, [0, K0[1], [8, E0, K0[2][1][2][1]]]);
                                  }, Wr), [1, [0, ar, 0, fr, i0]];
                                ue(R0, [0, U0, [2, E0]]);
                                break;
                              case 1:
                                break;
                              default:
                                p0 = 1;
                            }
                            if (!p0)
                              return [2, [0, zJr, 0, fr, i0]];
                          }
                          var b0 = Dc(Jr), O0 = Dc(Wr);
                          if (b0 !== 0) {
                            var M0 = 0;
                            if (O0 !== 0 && (b0 < O0 ? (Du(function(K0) {
                              return ue(R0, [0, K0[1], [9, E0]]);
                            }, Jr), M0 = 1) : Du(function(K0) {
                              return ue(R0, [0, K0[1], [9, E0]]);
                            }, Wr)), !M0)
                              return [2, [0, [1, Jr], l0, fr, i0]];
                          }
                          return [2, [0, [0, Wr], l0, fr, i0]];
                        }
                      } else if (Or === 10) {
                        var er = Pe(R0), yr = pr(R0);
                        ie(R0);
                        var vr = A0(R0), $0 = 0;
                        if (typeof vr == "number") {
                          var Er = vr - 2 | 0, Mr = 0;
                          if (Xt < Er >>> 0)
                            T7 < (Er + 1 | 0) >>> 0 && (Mr = 1);
                          else if (Er === 7) {
                            Y0(R0, 9);
                            var Br = A0(R0), qr = 0;
                            if (typeof Br == "number") {
                              var jr = 0;
                              if (Br !== 1 && Pn !== Br && (jr = 1), !jr) {
                                var $r = 1;
                                qr = 1;
                              }
                            }
                            if (!qr)
                              var $r = 0;
                            ue(R0, [0, er, [7, $r]]);
                          } else
                            Mr = 1;
                          Mr || ($0 = 1);
                        }
                        $0 || ue(R0, [0, er, qJr]);
                        var Tr = [0, Tr[1], Tr[2], 1, yr];
                        continue;
                      }
                    }
                    var ne = Tr[2], Qr = Tr[1], be = cr(x4, i4, R0), ae = be[2], pe = ae[1], oe = pe[2][1];
                    if (qn(oe, UJr))
                      var ce = Tr;
                    else {
                      var ge = pe[1], q0 = ae[2], Fr = be[1], _ = It(oe, 0), k = 97 <= _ ? 1 : 0, I = k && (_ <= In ? 1 : 0);
                      I && ue(R0, [0, ge, [6, E0, oe]]), o(Mu[3], oe, ne) && ue(R0, [0, ge, [1, E0, oe]]);
                      var U = Tr[4], Y = Tr[3], y0 = o(Mu[4], oe, ne), P0 = [0, Tr[1], y0, Y, U], I0 = function(Ur) {
                        return function(h0, Kr) {
                          return or && or[1] !== h0 ? ue(R0, [0, Kr, [5, E0, or, Ur]]) : 0;
                        };
                      }(oe);
                      if (typeof q0 == "number") {
                        var D = 0;
                        if (or) {
                          var u0 = or[1], X0 = 0;
                          if (u0 === 1 ? ue(R0, [0, Fr, [8, E0, oe]]) : u0 ? (D = 1, X0 = 1) : ue(R0, [0, Fr, [0, E0, oe]]), !X0)
                            var J0 = P0;
                        } else
                          D = 1;
                        if (D)
                          var J0 = [0, [0, Qr[1], Qr[2], Qr[3], [0, [0, Fr, [0, pe]], Qr[4]]], y0, Y, U];
                      } else
                        switch (q0[0]) {
                          case 0:
                            ue(R0, [0, q0[1], [5, E0, or, oe]]);
                            var J0 = P0;
                            break;
                          case 1:
                            var ir = q0[1];
                            I0(0, ir);
                            var J0 = [0, [0, [0, [0, Fr, [0, pe, [0, ir, q0[2]]]], Qr[1]], Qr[2], Qr[3], Qr[4]], y0, Y, U];
                            break;
                          case 2:
                            var Q0 = q0[1];
                            I0(1, Q0);
                            var J0 = [0, [0, Qr[1], [0, [0, Fr, [0, pe, [0, Q0, q0[2]]]], Qr[2]], Qr[3], Qr[4]], y0, Y, U];
                            break;
                          default:
                            var F0 = q0[1];
                            I0(2, F0);
                            var J0 = [0, [0, Qr[1], Qr[2], [0, [0, Fr, [0, pe, [0, F0, q0[2]]]], Qr[3]], Qr[4]], y0, Y, U];
                        }
                      var ce = J0;
                    }
                    var Sr = A0(R0), mr = 0;
                    if (typeof Sr == "number") {
                      var Cr = Sr - 2 | 0, sr = 0;
                      Xt < Cr >>> 0 ? T7 < (Cr + 1 | 0) >>> 0 && (sr = 1) : Cr === 6 ? (je(R0, 1), Y0(R0, 8)) : sr = 1, sr || (mr = 1);
                    }
                    mr || Y0(R0, 9);
                    var Tr = ce;
                  }
                }, o0);
                return [16, [0, _0, b, lr([0, w0], 0, 0)]];
              }
              var s2 = 0;
              function p(o0) {
                return cr(s2, c, o0);
              }
              function y(o0, w0) {
                var _0 = w0[2][1], E0 = w0[1], U0 = o0[1];
                js(_0) && V7(U0, [0, E0, 41]);
                var b = O9(_0), R0 = b || f22(_0);
                return R0 && V7(U0, [0, E0, 55]), [0, U0, o0[2]];
              }
              function T(o0, w0) {
                var _0 = w0[2];
                switch (_0[0]) {
                  case 0:
                    return le(E, o0, _0[1][1]);
                  case 1:
                    return le(d, o0, _0[1][1]);
                  case 2:
                    var E0 = _0[1][1], U0 = E0[2][1], b = o0[2], R0 = o0[1];
                    o(Mu[3], U0, b) && ue(R0, [0, E0[1], 42]);
                    var X = y([0, R0, b], E0), s0 = o(Mu[4], U0, X[2]);
                    return [0, X[1], s0];
                  default:
                    return ue(o0[1], [0, w0[1], 31]), o0;
                }
              }
              function E(o0, w0) {
                if (w0[0] === 0) {
                  var _0 = w0[1][2], E0 = _0[1], U0 = E0[0] === 1 ? y(o0, E0[1]) : o0;
                  return T(U0, _0[2]);
                }
                return T(o0, w0[1][2][1]);
              }
              function d(o0, w0) {
                return w0[0] === 2 ? o0 : T(o0, w0[1][2][1]);
              }
              function w(o0, w0, _0, E0) {
                var U0 = o0[5], b = q1(E0), R0 = E0[2], X = R0[3], s0 = _s(U0 ? 0 : w0, o0), hr = w0 || U0 || 1 - b;
                if (hr) {
                  if (_0) {
                    var Ar = _0[1], or = Ar[2][1], W0 = Ar[1];
                    js(or) && V7(s0, [0, W0, 44]);
                    var Lr = O9(or), Tr = Lr || f22(or);
                    Tr && V7(s0, [0, W0, 55]);
                  }
                  var Hr = R0[2], Or = [0, s0, Mu[1]], fr = le(function(ar, _r) {
                    return T(ar, _r[2][1]);
                  }, Or, Hr), Rr = X && (T(fr, X[1][2][1]), 0), Wr = Rr;
                } else
                  var Wr = hr;
                return Wr;
              }
              var G = function o0(w0, _0) {
                return o0.fun(w0, _0);
              };
              function A11(o0) {
                A0(o0) === 21 && je(o0, s7);
                var w0 = o(se[18], o0, 41), _0 = A0(o0) === 82 ? 1 : 0, E0 = _0 && (Y0(o0, 82), [0, u(se[10], o0)]);
                return [0, w0, E0];
              }
              var S11 = 0;
              N(G, function(o0, w0) {
                var _0 = A0(o0);
                if (typeof _0 == "number") {
                  var E0 = _0 - 5 | 0, U0 = 0;
                  if (7 < E0 >>> 0 ? is === E0 && (U0 = 1) : 5 < (E0 - 1 | 0) >>> 0 && (U0 = 1), U0) {
                    var b = _0 === 12 ? 1 : 0;
                    if (b)
                      var R0 = pr(o0), X = cr(0, function(or) {
                        return Y0(or, 12), o(se[18], or, 41);
                      }, o0), s0 = lr([0, R0], 0, 0), hr = [0, [0, X[1], [0, X[2], s0]]];
                    else
                      var hr = b;
                    return A0(o0) !== 5 && je(o0, 64), [0, ye(w0), hr];
                  }
                }
                var Ar = cr(S11, A11, o0);
                return A0(o0) !== 5 && Y0(o0, 9), o(G, o0, [0, Ar, w0]);
              });
              function M(o0, w0) {
                function _0(U0) {
                  var b = mL(w0, re0(o0, U0)), R0 = 1, X = b[10] === 1 ? b : [0, b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8], b[9], R0, b[11], b[12], b[13], b[14], b[15], b[16], b[17], b[18], b[19], b[20], b[21], b[22], b[23], b[24], b[25], b[26], b[27], b[28], b[29], b[30]], s0 = pr(X);
                  Y0(X, 4);
                  var hr = fu(X), Ar = hr && (A0(X) === 21 ? 1 : 0);
                  if (Ar) {
                    var or = pr(X), W0 = cr(0, function(ar) {
                      return Y0(ar, 21), A0(ar) === 86 ? [0, u(t4[9], ar)] : (je(ar, Ri), 0);
                    }, X), Lr = W0[2];
                    if (Lr) {
                      A0(X) === 9 && ie(X);
                      var Tr = lr([0, or], 0, 0), Hr = [0, [0, W0[1], [0, Lr[1], Tr]]];
                    } else
                      var Hr = Lr;
                    var Or = Hr;
                  } else
                    var Or = Ar;
                  var fr = o(G, X, 0), Rr = pr(X);
                  Y0(X, 5);
                  var Wr = yu([0, s0], [0, we(X)], Rr, 0);
                  return [0, Or, fr[1], fr[2], Wr];
                }
                var E0 = 0;
                return function(U0) {
                  return cr(E0, _0, U0);
                };
              }
              function K(o0, w0, _0, E0, U0) {
                var b = fe0(o0, w0, _0, U0), R0 = o(se[16], E0, b);
                return [0, [0, R0[1]], R0[2]];
              }
              function V(o0, w0, _0) {
                var E0 = Pe(o0), U0 = A0(o0), b = 0;
                if (typeof U0 == "number")
                  if (s7 === U0) {
                    var R0 = pr(o0);
                    ie(o0);
                    var s0 = [0, [0, E0, [0, 0, lr([0, R0], 0, 0)]]];
                  } else if (L7 === U0) {
                    var X = pr(o0);
                    ie(o0);
                    var s0 = [0, [0, E0, [0, 1, lr([0, X], 0, 0)]]];
                  } else
                    b = 1;
                else
                  b = 1;
                if (b)
                  var s0 = 0;
                if (s0) {
                  var hr = 0;
                  if (!w0 && !_0 && (hr = 1), !hr)
                    return ue(o0, [0, s0[1][1], 7]), 0;
                }
                return s0;
              }
              function f0(o0) {
                if (Yt === A0(o0)) {
                  var w0 = pr(o0);
                  return ie(o0), [0, 1, w0];
                }
                return S$r;
              }
              function m0(o0) {
                if (A0(o0) === 64 && !Jl(1, o0)) {
                  var w0 = pr(o0);
                  return ie(o0), [0, 1, w0];
                }
                return E$r;
              }
              function k0(o0) {
                var w0 = m0(o0), _0 = w0[1], E0 = w0[2], U0 = cr(0, function(W0) {
                  var Lr = pr(W0);
                  Y0(W0, 15);
                  var Tr = f0(W0), Hr = Tr[1], Or = pl([0, E0, [0, Lr, [0, Tr[2], 0]]]), fr = W0[7], Rr = A0(W0), Wr = 0;
                  if (fr && typeof Rr == "number") {
                    if (Rr === 4) {
                      var Ir = 0, fe = 0;
                      Wr = 1;
                    } else if (Rr === 98) {
                      var Jr = oi(W0, u(t4[3], W0)), ar = A0(W0) === 4 ? 0 : [0, ys(W0, o(se[13], h$r, W0))], Ir = ar, fe = Jr;
                      Wr = 1;
                    }
                  }
                  if (!Wr)
                    var _r = G1(W0) ? ys(W0, o(se[13], d$r, W0)) : (be0(W0, k$r), [0, Pe(W0), w$r]), Ir = [0, _r], fe = oi(W0, u(t4[3], W0));
                  var v0 = u(M(_0, Hr), W0), P = A0(W0) === 86 ? v0 : eb(W0, v0), L = u(t4[12], W0), Q = L[2], i0 = L[1];
                  if (Q)
                    var l0 = he0(W0, Q), S0 = i0;
                  else
                    var l0 = Q, S0 = o2(W0, i0);
                  return [0, Hr, fe, Ir, P, S0, l0, Or];
                }, o0), b = U0[2], R0 = b[4], X = b[3], s0 = b[1], hr = K(o0, _0, s0, 0, q1(R0));
                w(o0, hr[2], X, R0);
                var Ar = U0[1], or = lr([0, b[7]], 0, 0);
                return [23, [0, X, R0, hr[1], _0, s0, b[6], b[5], b[2], or, Ar]];
              }
              var g0 = 0;
              function e0(o0) {
                return cr(g0, k0, o0);
              }
              function x0(o0, w0) {
                var _0 = pr(w0);
                Y0(w0, o0);
                for (var E0 = 0, U0 = 0; ; ) {
                  var b = cr(0, function(or) {
                    var W0 = o(se[18], or, 40);
                    if (xu(or, 82))
                      var Lr = 0, Tr = [0, u(se[10], or)];
                    else if (W0[2][0] === 2)
                      var Lr = 0, Tr = 0;
                    else
                      var Lr = [0, [0, W0[1], 59]], Tr = 0;
                    return [0, [0, W0, Tr], Lr];
                  }, w0), R0 = b[2], X = R0[2], s0 = [0, [0, b[1], R0[1]], E0], hr = X ? [0, X[1], U0] : U0;
                  if (xu(w0, 9)) {
                    var E0 = s0, U0 = hr;
                    continue;
                  }
                  var Ar = ye(hr);
                  return [0, ye(s0), _0, Ar];
                }
              }
              var l = 24;
              function c0(o0) {
                return x0(l, o0);
              }
              function t0(o0) {
                var w0 = x0(27, F9(1, o0)), _0 = w0[1], E0 = w0[3], U0 = ye(le(function(b, R0) {
                  return R0[2][2] ? b : [0, [0, R0[1], 58], b];
                }, E0, _0));
                return [0, _0, w0[2], U0];
              }
              return [0, m0, f0, V, M, K, w, function(o0) {
                return x0(28, F9(1, o0));
              }, t0, c0, e0, p];
            }(mn), R9 = $ee(se), ci = function(t4) {
              function n(P) {
                var L = P[2];
                switch (L[0]) {
                  case 17:
                    var Q = L[1], i0 = Q[1][2][1];
                    if (n0(i0, pQr)) {
                      if (!n0(i0, mQr)) {
                        var l0 = n0(Q[2][2][1], _Qr);
                        if (!l0)
                          return l0;
                      }
                    } else {
                      var S0 = n0(Q[2][2][1], yQr);
                      if (!S0)
                        return S0;
                    }
                    break;
                  case 0:
                  case 10:
                  case 16:
                  case 19:
                    break;
                  default:
                    return 0;
                }
                return 1;
              }
              var e4 = t4[1], i4 = function P(L) {
                return P.fun(L);
              }, x4 = function P(L) {
                return P.fun(L);
              }, c = function P(L) {
                return P.fun(L);
              }, s2 = function P(L) {
                return P.fun(L);
              }, p = function P(L) {
                return P.fun(L);
              }, y = function P(L) {
                return P.fun(L);
              }, T = function P(L) {
                return P.fun(L);
              }, E = function P(L) {
                return P.fun(L);
              }, d = function P(L) {
                return P.fun(L);
              }, w = function P(L) {
                return P.fun(L);
              }, G = function P(L) {
                return P.fun(L);
              }, A11 = function P(L) {
                return P.fun(L);
              }, S11 = function P(L) {
                return P.fun(L);
              }, M = function P(L) {
                return P.fun(L);
              }, K = function P(L) {
                return P.fun(L);
              }, V = function P(L) {
                return P.fun(L);
              }, f0 = function P(L) {
                return P.fun(L);
              }, m0 = function P(L, Q, i0, l0, S0) {
                return P.fun(L, Q, i0, l0, S0);
              }, k0 = function P(L, Q, i0, l0) {
                return P.fun(L, Q, i0, l0);
              }, g0 = function P(L) {
                return P.fun(L);
              }, e0 = function P(L) {
                return P.fun(L);
              }, x0 = function P(L) {
                return P.fun(L);
              }, l = function P(L, Q, i0, l0, S0) {
                return P.fun(L, Q, i0, l0, S0);
              }, c0 = function P(L, Q, i0, l0) {
                return P.fun(L, Q, i0, l0);
              }, t0 = function P(L) {
                return P.fun(L);
              }, o0 = function P(L, Q, i0) {
                return P.fun(L, Q, i0);
              }, w0 = function P(L) {
                return P.fun(L);
              }, _0 = function P(L, Q, i0) {
                return P.fun(L, Q, i0);
              }, E0 = function P(L) {
                return P.fun(L);
              }, U0 = function P(L) {
                return P.fun(L);
              }, b = function P(L, Q) {
                return P.fun(L, Q);
              }, R0 = function P(L, Q, i0, l0) {
                return P.fun(L, Q, i0, l0);
              }, X = function P(L) {
                return P.fun(L);
              }, s0 = function P(L, Q, i0) {
                return P.fun(L, Q, i0);
              }, hr = function P(L) {
                return P.fun(L);
              }, Ar = function P(L) {
                return P.fun(L);
              }, or = function P(L) {
                return P.fun(L);
              }, W0 = function P(L, Q, i0) {
                return P.fun(L, Q, i0);
              }, Lr = t4[2];
              function Tr(P) {
                var L = Pe(P), Q = u(y, P), i0 = u(p, P);
                if (i0) {
                  var l0 = i0[1];
                  return [0, cr([0, L], function(S0) {
                    var T0 = ur(Lr, 0, S0, Q);
                    return [2, [0, l0, T0, u(x4, S0), 0]];
                  }, P)];
                }
                return Q;
              }
              function Hr(P, L) {
                if (typeof L == "number") {
                  var Q = L !== 55 ? 1 : 0;
                  if (!Q)
                    return Q;
                }
                throw Bs;
              }
              function Or(P) {
                var L = T9(Hr, P), Q = Tr(L), i0 = A0(L);
                if (typeof i0 == "number") {
                  if (i0 === 11)
                    throw Bs;
                  if (i0 === 86) {
                    var l0 = ue0(L), S0 = 0;
                    if (l0) {
                      var T0 = l0[1];
                      if (typeof T0 == "number" && T0 === 5) {
                        var rr = 1;
                        S0 = 1;
                      }
                    }
                    if (!S0)
                      var rr = 0;
                    if (rr)
                      throw Bs;
                  }
                }
                if (G1(L)) {
                  if (Q[0] === 0) {
                    var L0 = Q[1][2];
                    if (L0[0] === 10 && !n0(L0[1][2][1], bQr) && !x7(L))
                      throw Bs;
                  }
                  return Q;
                }
                return Q;
              }
              N(i4, function(P) {
                var L = A0(P), Q = 0, i0 = G1(P);
                if (typeof L == "number") {
                  var l0 = 0;
                  if (22 <= L)
                    if (L === 58) {
                      if (P[17])
                        return [0, u(c, P)];
                      l0 = 1;
                    } else
                      L !== 98 && (l0 = 1);
                  else
                    L !== 4 && !(21 <= L) && (l0 = 1);
                  l0 || (Q = 1);
                }
                if (!Q && !i0)
                  return Tr(P);
                var S0 = 0;
                if (L === 64 && fu(P) && Yn(1, P) === 98) {
                  var T0 = Or, rr = or;
                  S0 = 1;
                }
                if (!S0)
                  var T0 = or, rr = Or;
                var L0 = EL(P, rr);
                if (L0)
                  return L0[1];
                var B = EL(P, T0);
                return B ? B[1] : Tr(P);
              }), N(x4, function(P) {
                return o(e4, P, u(i4, P));
              }), N(c, function(P) {
                return cr(0, function(L) {
                  L[10] && je(L, 91);
                  var Q = pr(L), i0 = Pe(L);
                  Y0(L, 58);
                  var l0 = Pe(L);
                  if (x2(L))
                    var S0 = 0, T0 = 0;
                  else {
                    var rr = xu(L, Yt), L0 = A0(L), B = 0;
                    if (typeof L0 == "number") {
                      var Z7 = 0;
                      if (L0 !== 86)
                        if (10 <= L0)
                          Z7 = 1;
                        else
                          switch (L0) {
                            case 0:
                            case 2:
                            case 3:
                            case 4:
                            case 6:
                              Z7 = 1;
                              break;
                          }
                      if (!Z7) {
                        var p0 = 0;
                        B = 1;
                      }
                    }
                    if (!B)
                      var p0 = 1;
                    var b0 = rr || p0, O0 = b0 && [0, u(x4, L)], S0 = rr, T0 = O0;
                  }
                  var M0 = T0 ? 0 : we(L), er = yt(i0, l0);
                  return [30, [0, T0, lr([0, Q], [0, M0], 0), S0, er]];
                }, P);
              }), N(s2, function(P) {
                var L = P[2];
                switch (L[0]) {
                  case 17:
                    var Q = L[1], i0 = Q[1][2][1];
                    if (n0(i0, cQr)) {
                      if (!n0(i0, sQr)) {
                        var l0 = n0(Q[2][2][1], vQr);
                        if (!l0)
                          return l0;
                      }
                    } else {
                      var S0 = n0(Q[2][2][1], lQr);
                      if (!S0)
                        return S0;
                    }
                    break;
                  case 10:
                  case 16:
                    break;
                  default:
                    return 0;
                }
                return 1;
              }), N(p, function(P) {
                var L = A0(P), Q = 0;
                if (typeof L == "number") {
                  var i0 = L - 67 | 0;
                  if (!(15 < i0 >>> 0)) {
                    switch (i0) {
                      case 0:
                        var l0 = KZr;
                        break;
                      case 1:
                        var l0 = WZr;
                        break;
                      case 2:
                        var l0 = JZr;
                        break;
                      case 3:
                        var l0 = $Zr;
                        break;
                      case 4:
                        var l0 = ZZr;
                        break;
                      case 5:
                        var l0 = QZr;
                        break;
                      case 6:
                        var l0 = rQr;
                        break;
                      case 7:
                        var l0 = eQr;
                        break;
                      case 8:
                        var l0 = nQr;
                        break;
                      case 9:
                        var l0 = tQr;
                        break;
                      case 10:
                        var l0 = uQr;
                        break;
                      case 11:
                        var l0 = iQr;
                        break;
                      case 12:
                        var l0 = fQr;
                        break;
                      case 13:
                        var l0 = xQr;
                        break;
                      case 14:
                        var l0 = oQr;
                        break;
                      default:
                        var l0 = aQr;
                    }
                    var S0 = l0;
                    Q = 1;
                  }
                }
                if (!Q)
                  var S0 = 0;
                return S0 !== 0 && ie(P), S0;
              }), N(y, function(P) {
                var L = Pe(P), Q = u(E, P);
                if (A0(P) === 85) {
                  ie(P);
                  var i0 = u(x4, Kl(0, P));
                  Y0(P, 86);
                  var l0 = cr(0, x4, P), S0 = yt(L, l0[1]), T0 = l0[2];
                  return [0, [0, S0, [7, [0, o(e4, P, Q), i0, T0, 0]]]];
                }
                return Q;
              }), N(T, function(P) {
                return o(e4, P, u(y, P));
              });
              function fr(P, L, Q, i0, l0) {
                var S0 = o(e4, P, L);
                return [0, [0, l0, [15, [0, i0, S0, o(e4, P, Q), 0]]]];
              }
              function Rr(P, L, Q, i0) {
                for (var l0 = P, S0 = Q, T0 = i0; ; ) {
                  var rr = A0(L);
                  if (typeof rr == "number" && rr === 84) {
                    1 - l0 && je(L, zZr), Y0(L, 84);
                    var L0 = cr(0, d, L), B = L0[2], Z7 = L0[1], p0 = A0(L), b0 = 0;
                    if (typeof p0 == "number" && !(1 < (p0 - 87 | 0) >>> 0)) {
                      je(L, [23, oL(p0)]);
                      var O0 = Jr(L, B, Z7), M0 = Wr(L, O0[2], O0[1]), er = M0[2], yr = M0[1];
                      b0 = 1;
                    }
                    if (!b0)
                      var er = B, yr = Z7;
                    var vr = yt(T0, yr), l0 = 1, S0 = fr(L, S0, er, 2, vr), T0 = vr;
                    continue;
                  }
                  return [0, T0, S0];
                }
              }
              function Wr(P, L, Q) {
                for (var i0 = L, l0 = Q; ; ) {
                  var S0 = A0(P);
                  if (typeof S0 == "number" && S0 === 87) {
                    ie(P);
                    var T0 = cr(0, d, P), rr = Jr(P, T0[2], T0[1]), L0 = yt(l0, rr[1]), B = Rr(0, P, fr(P, i0, rr[2], 0, L0), L0), i0 = B[2], l0 = B[1];
                    continue;
                  }
                  return [0, l0, i0];
                }
              }
              function Jr(P, L, Q) {
                for (var i0 = L, l0 = Q; ; ) {
                  var S0 = A0(P);
                  if (typeof S0 == "number" && S0 === 88) {
                    ie(P);
                    var T0 = cr(0, d, P), rr = yt(l0, T0[1]), L0 = Rr(0, P, fr(P, i0, T0[2], 1, rr), rr), i0 = L0[2], l0 = L0[1];
                    continue;
                  }
                  return [0, l0, i0];
                }
              }
              N(E, function(P) {
                var L = cr(0, d, P), Q = L[2], i0 = L[1], l0 = A0(P), S0 = 0;
                if (typeof l0 == "number" && l0 === 84) {
                  var rr = Rr(1, P, Q, i0);
                  S0 = 1;
                }
                if (!S0)
                  var T0 = Jr(P, Q, i0), rr = Wr(P, T0[2], T0[1]);
                return rr[2];
              });
              function ar(P, L, Q, i0) {
                return [0, i0, [3, [0, Q, P, L, 0]]];
              }
              N(d, function(P) {
                var L = 0;
                r:
                  for (; ; ) {
                    var Q = cr(0, function(k) {
                      var I = u(w, k) !== 0 ? 1 : 0;
                      return [0, I, u(G, Kl(0, k))];
                    }, P), i0 = Q[2], l0 = i0[2], S0 = Q[1];
                    if (A0(P) === 98) {
                      var T0 = 0;
                      l0[0] === 0 && l0[1][2][0] === 12 ? je(P, 63) : T0 = 1;
                    }
                    var rr = A0(P), L0 = 0;
                    if (typeof rr == "number") {
                      var B = rr - 17 | 0, Z7 = 0;
                      if (1 < B >>> 0)
                        if (72 <= B)
                          switch (B - 72 | 0) {
                            case 0:
                              var p0 = gZr;
                              break;
                            case 1:
                              var p0 = FZr;
                              break;
                            case 2:
                              var p0 = TZr;
                              break;
                            case 3:
                              var p0 = OZr;
                              break;
                            case 4:
                              var p0 = IZr;
                              break;
                            case 5:
                              var p0 = AZr;
                              break;
                            case 6:
                              var p0 = NZr;
                              break;
                            case 7:
                              var p0 = CZr;
                              break;
                            case 8:
                              var p0 = PZr;
                              break;
                            case 9:
                              var p0 = DZr;
                              break;
                            case 10:
                              var p0 = LZr;
                              break;
                            case 11:
                              var p0 = RZr;
                              break;
                            case 12:
                              var p0 = jZr;
                              break;
                            case 13:
                              var p0 = GZr;
                              break;
                            case 14:
                              var p0 = MZr;
                              break;
                            case 15:
                              var p0 = BZr;
                              break;
                            case 16:
                              var p0 = qZr;
                              break;
                            case 17:
                              var p0 = UZr;
                              break;
                            case 18:
                              var p0 = HZr;
                              break;
                            case 19:
                              var p0 = XZr;
                              break;
                            default:
                              Z7 = 1;
                          }
                        else
                          Z7 = 1;
                      else
                        var p0 = B ? YZr : P[12] ? 0 : VZr;
                      if (!Z7) {
                        var b0 = p0;
                        L0 = 1;
                      }
                    }
                    if (!L0)
                      var b0 = 0;
                    if (b0 !== 0 && ie(P), !L && !b0)
                      return l0;
                    if (b0) {
                      var O0 = b0[1], M0 = O0[1], er = i0[1], yr = er && (M0 === 14 ? 1 : 0);
                      yr && ue(P, [0, S0, 27]);
                      for (var vr = o(e4, P, l0), $0 = vr, Er = [0, M0, O0[2]], Mr = S0, Br = L; ; ) {
                        var qr = Er[2], jr = Er[1];
                        if (Br) {
                          var $r = Br[1], ne = $r[2], Qr = ne[2], be = Qr[0] === 0 ? Qr[1] : Qr[1] - 1 | 0;
                          if (qr[1] <= be) {
                            var ae = yt($r[3], Mr), pe = ar($r[1], $0, ne[1], ae), $0 = pe, Er = [0, jr, qr], Mr = ae, Br = Br[2];
                            continue;
                          }
                        }
                        var L = [0, [0, $0, [0, jr, qr], Mr], Br];
                        continue r;
                      }
                    }
                    for (var oe = o(e4, P, l0), ce = S0, ge = L; ; ) {
                      if (ge) {
                        var q0 = ge[1], Fr = yt(q0[3], ce), _ = ge[2], oe = ar(q0[1], oe, q0[2][1], Fr), ce = Fr, ge = _;
                        continue;
                      }
                      return [0, oe];
                    }
                  }
              }), N(w, function(P) {
                var L = A0(P);
                if (typeof L == "number") {
                  if (48 <= L) {
                    if (s7 <= L) {
                      if (!(cf <= L))
                        switch (L - 103 | 0) {
                          case 0:
                            return _Zr;
                          case 1:
                            return yZr;
                          case 6:
                            return hZr;
                          case 7:
                            return dZr;
                        }
                    } else if (L === 65 && P[18])
                      return kZr;
                  } else if (45 <= L)
                    switch (L + mv | 0) {
                      case 0:
                        return wZr;
                      case 1:
                        return EZr;
                      default:
                        return SZr;
                    }
                }
                return 0;
              }), N(G, function(P) {
                var L = Pe(P), Q = pr(P), i0 = u(w, P);
                if (i0) {
                  var l0 = i0[1];
                  ie(P);
                  var S0 = cr(0, A11, P), T0 = S0[2], rr = yt(L, S0[1]), L0 = 0;
                  if (l0 === 6) {
                    var B = T0[2], Z7 = 0;
                    switch (B[0]) {
                      case 10:
                        V7(P, [0, rr, 47]);
                        break;
                      case 16:
                        B[1][2][0] === 1 && ue(P, [0, rr, 88]);
                        break;
                      default:
                        Z7 = 1;
                    }
                    Z7 || (L0 = 1);
                  }
                  return [0, [0, rr, [28, [0, l0, T0, lr([0, Q], 0, 0)]]]];
                }
                var p0 = A0(P), b0 = 0;
                if (typeof p0 == "number")
                  if (cf === p0)
                    var O0 = mZr;
                  else if (T7 === p0)
                    var O0 = pZr;
                  else
                    b0 = 1;
                else
                  b0 = 1;
                if (b0)
                  var O0 = 0;
                if (O0) {
                  ie(P);
                  var M0 = cr(0, A11, P), er = M0[2];
                  1 - u(s2, er) && ue(P, [0, er[1], 26]);
                  var yr = er[2], vr = 0;
                  yr[0] === 10 && js(yr[1][2][1]) && (gi(P, 54), vr = 1);
                  var $0 = yt(L, M0[1]), Er = lr([0, Q], 0, 0);
                  return [0, [0, $0, [29, [0, O0[1], er, 1, Er]]]];
                }
                return u(S11, P);
              }), N(A11, function(P) {
                return o(e4, P, u(G, P));
              }), N(S11, function(P) {
                var L = u(M, P);
                if (x7(P))
                  return L;
                var Q = A0(P), i0 = 0;
                if (typeof Q == "number")
                  if (cf === Q)
                    var l0 = bZr;
                  else if (T7 === Q)
                    var l0 = lZr;
                  else
                    i0 = 1;
                else
                  i0 = 1;
                if (i0)
                  var l0 = 0;
                if (l0) {
                  var S0 = o(e4, P, L);
                  1 - u(s2, S0) && ue(P, [0, S0[1], 26]);
                  var T0 = S0[2], rr = 0;
                  T0[0] === 10 && js(T0[1][2][1]) && (gi(P, 53), rr = 1);
                  var L0 = Pe(P);
                  ie(P);
                  var B = we(P), Z7 = yt(S0[1], L0), p0 = lr(0, [0, B], 0);
                  return [0, [0, Z7, [29, [0, l0[1], S0, 0, p0]]]];
                }
                return L;
              }), N(M, function(P) {
                var L = Pe(P), Q = 1 - P[16], i0 = 0, l0 = P[16] === 0 ? P : [0, P[1], P[2], P[3], P[4], P[5], P[6], P[7], P[8], P[9], P[10], P[11], P[12], P[13], P[14], P[15], i0, P[17], P[18], P[19], P[20], P[21], P[22], P[23], P[24], P[25], P[26], P[27], P[28], P[29], P[30]], S0 = A0(l0), T0 = 0;
                if (typeof S0 == "number") {
                  var rr = S0 - 44 | 0;
                  if (!(7 < rr >>> 0)) {
                    var L0 = 0;
                    switch (rr) {
                      case 0:
                        if (Q)
                          var B = [0, u(g0, l0)];
                        else
                          L0 = 1;
                        break;
                      case 6:
                        var B = [0, u(f0, l0)];
                        break;
                      case 7:
                        var B = [0, u(V, l0)];
                        break;
                      default:
                        L0 = 1;
                    }
                    if (!L0) {
                      var Z7 = B;
                      T0 = 1;
                    }
                  }
                }
                if (!T0)
                  var Z7 = Gs(l0) ? [0, u(t0, l0)] : u(E0, l0);
                return p7(m0, 0, 0, l0, L, Z7);
              }), N(K, function(P) {
                return o(e4, P, u(M, P));
              }), N(V, function(P) {
                switch (P[21]) {
                  case 0:
                    var L = 0, Q = 0;
                    break;
                  case 1:
                    var L = 0, Q = 1;
                    break;
                  default:
                    var L = 1, Q = 1;
                }
                var i0 = Pe(P), l0 = pr(P);
                Y0(P, 51);
                var S0 = [0, i0, [23, [0, lr([0, l0], [0, we(P)], 0)]]], T0 = A0(P);
                if (typeof T0 == "number" && !(11 <= T0))
                  switch (T0) {
                    case 4:
                      var rr = L ? S0 : (ue(P, [0, i0, 5]), [0, i0, [10, Rc(0, [0, i0, oZr])]]);
                      return R(k0, aZr, P, i0, rr);
                    case 6:
                    case 10:
                      var L0 = Q ? S0 : (ue(P, [0, i0, 4]), [0, i0, [10, Rc(0, [0, i0, sZr])]]);
                      return R(k0, vZr, P, i0, L0);
                  }
                return Q ? St(cZr, P) : ue(P, [0, i0, 4]), S0;
              }), N(f0, function(P) {
                return cr(0, function(L) {
                  var Q = pr(L), i0 = Pe(L);
                  if (Y0(L, 50), xu(L, 10)) {
                    var l0 = Rc(0, [0, i0, iZr]), S0 = Pe(L);
                    Zl(L, fZr);
                    var T0 = Rc(0, [0, S0, xZr]);
                    return [17, [0, l0, T0, lr([0, Q], [0, we(L)], 0)]];
                  }
                  var rr = pr(L);
                  Y0(L, 4);
                  var L0 = ur(s0, [0, rr], 0, u(x4, Kl(0, L)));
                  return Y0(L, 5), [11, [0, L0, lr([0, Q], [0, we(L)], 0)]];
                }, P);
              }), N(m0, function(P, L, Q, i0, l0) {
                var S0 = P ? P[1] : 1, T0 = L && L[1], rr = p7(l, [0, S0], [0, T0], Q, i0, l0), L0 = ue0(Q), B = 0;
                if (L0) {
                  var Z7 = L0[1];
                  if (typeof Z7 == "number" && Z7 === 83) {
                    var p0 = 1;
                    B = 1;
                  }
                }
                if (!B)
                  var p0 = 0;
                function b0(vr) {
                  var $0 = $t(vr);
                  function Er(Br, qr) {
                    return o(Qe(Br, Di, 78), Br, qr);
                  }
                  var Mr = o(e4, vr, rr);
                  return o($0[2], Mr, Er);
                }
                function O0(vr, $0, Er) {
                  var Mr = u(x0, $0), Br = Mr[1], qr = yt(i0, Br), jr = [0, Er, vr, [0, Br, Mr[2]], 0], $r = 0;
                  if (!p0 && !T0) {
                    var ne = [4, jr];
                    $r = 1;
                  }
                  if (!$r)
                    var ne = [20, [0, jr, qr, p0]];
                  var Qr = T0 || p0;
                  return p7(m0, [0, S0], [0, Qr], $0, i0, [0, [0, qr, ne]]);
                }
                if (Q[13])
                  return rr;
                var M0 = A0(Q);
                if (typeof M0 == "number") {
                  var er = M0 - 98 | 0;
                  if (2 < er >>> 0) {
                    if (er === -94)
                      return O0(0, Q, b0(Q));
                  } else if (er !== 1 && fu(Q)) {
                    var yr = T9(function(vr, $0) {
                      throw Bs;
                    }, Q);
                    return _e0(yr, rr, function(vr) {
                      var $0 = b0(vr);
                      return O0(u(e0, vr), vr, $0);
                    });
                  }
                }
                return rr;
              }), N(k0, function(P, L, Q, i0) {
                var l0 = P ? P[1] : 1;
                return o(e4, L, p7(m0, [0, l0], 0, L, Q, [0, i0]));
              }), N(g0, function(P) {
                return cr(0, function(L) {
                  var Q = Pe(L), i0 = pr(L);
                  if (Y0(L, 44), L[11] && A0(L) === 10) {
                    var l0 = we(L);
                    ie(L);
                    var S0 = Rc(lr([0, i0], [0, l0], 0), [0, Q, eZr]), T0 = A0(L);
                    return typeof T0 != "number" && T0[0] === 4 && !n0(T0[3], nZr) ? [17, [0, S0, o(se[13], 0, L), 0]] : (St(tZr, L), ie(L), [10, S0]);
                  }
                  var rr = Pe(L), L0 = A0(L), B = 0;
                  if (typeof L0 == "number")
                    if (L0 === 44)
                      var Z7 = u(g0, L);
                    else if (L0 === 51)
                      var Z7 = u(V, _L(1, L));
                    else
                      B = 1;
                  else
                    B = 1;
                  if (B)
                    var Z7 = Gs(L) ? u(t0, L) : u(U0, L);
                  var p0 = R(c0, uZr, _L(1, L), rr, Z7), b0 = A0(L), O0 = 0;
                  if (typeof b0 != "number" && b0[0] === 3) {
                    var M0 = R(R0, L, rr, p0, b0[1]);
                    O0 = 1;
                  }
                  if (!O0)
                    var M0 = p0;
                  var er = 0;
                  if (A0(L) !== 4) {
                    var yr = 0;
                    if (fu(L) && A0(L) === 98 && (yr = 1), !yr) {
                      var Er = M0;
                      er = 1;
                    }
                  }
                  if (!er)
                    var vr = $t(L), $0 = function(ne, Qr) {
                      return o(Qe(ne, Di, 79), ne, Qr);
                    }, Er = o(vr[2], M0, $0);
                  var Mr = fu(L), Br = Mr && _e0(T9(function(ne, Qr) {
                    throw Bs;
                  }, L), 0, e0), qr = A0(L), jr = 0;
                  if (typeof qr == "number" && qr === 4) {
                    var $r = [0, u(x0, L)];
                    jr = 1;
                  }
                  if (!jr)
                    var $r = 0;
                  return [18, [0, Er, Br, $r, lr([0, i0], 0, 0)]];
                }, P);
              });
              function _r(P) {
                var L = pr(P);
                Y0(P, 98);
                for (var Q = 0; ; ) {
                  var i0 = A0(P);
                  if (typeof i0 == "number") {
                    var l0 = 0;
                    if ((i0 === 99 || Pn === i0) && (l0 = 1), l0) {
                      var S0 = ye(Q), T0 = pr(P);
                      Y0(P, 99);
                      var rr = A0(P) === 4 ? $t(P)[1] : we(P);
                      return [0, S0, yu([0, L], [0, rr], T0, 0)];
                    }
                  }
                  var L0 = A0(P), B = 0;
                  if (typeof L0 != "number" && L0[0] === 4 && !n0(L0[2], Q$r)) {
                    var Z7 = Pe(P), p0 = pr(P);
                    Zl(P, rZr);
                    var b0 = [1, [0, Z7, [0, lr([0, p0], [0, we(P)], 0)]]];
                    B = 1;
                  }
                  if (!B)
                    var b0 = [0, u(mn[1], P)];
                  var O0 = [0, b0, Q];
                  A0(P) !== 99 && Y0(P, 9);
                  var Q = O0;
                }
              }
              N(e0, function(P) {
                Ku(P, 1);
                var L = A0(P) === 98 ? 1 : 0, Q = L && [0, cr(0, _r, P)];
                return k7(P), Q;
              });
              function Ir(P) {
                var L = pr(P);
                Y0(P, 12);
                var Q = u(x4, P);
                return [0, Q, lr([0, L], 0, 0)];
              }
              N(x0, function(P) {
                return cr(0, function(L) {
                  var Q = pr(L);
                  Y0(L, 4);
                  for (var i0 = 0; ; ) {
                    var l0 = A0(L);
                    if (typeof l0 == "number") {
                      var S0 = 0;
                      if ((l0 === 5 || Pn === l0) && (S0 = 1), S0) {
                        var T0 = ye(i0), rr = pr(L);
                        return Y0(L, 5), [0, T0, yu([0, Q], [0, we(L)], rr, 0)];
                      }
                    }
                    var L0 = A0(L), B = 0;
                    if (typeof L0 == "number" && L0 === 12) {
                      var Z7 = [1, cr(0, Ir, L)];
                      B = 1;
                    }
                    if (!B)
                      var Z7 = [0, u(x4, L)];
                    var p0 = [0, Z7, i0];
                    A0(L) !== 5 && Y0(L, 9);
                    var i0 = p0;
                  }
                }, P);
              }), N(l, function(P, L, Q, i0, l0) {
                var S0 = P ? P[1] : 1, T0 = L && L[1], rr = A0(Q), L0 = 0;
                if (typeof rr == "number")
                  switch (rr) {
                    case 6:
                      ie(Q);
                      var B = 0, Z7 = [0, T0], p0 = [0, S0];
                      L0 = 2;
                      break;
                    case 10:
                      ie(Q);
                      var b0 = 0, O0 = [0, T0], M0 = [0, S0];
                      L0 = 1;
                      break;
                    case 83:
                      1 - S0 && je(Q, 99), Y0(Q, 83);
                      var er = 0, yr = A0(Q);
                      if (typeof yr == "number")
                        switch (yr) {
                          case 4:
                            return l0;
                          case 6:
                            ie(Q);
                            var B = K$r, Z7 = W$r, p0 = [0, S0];
                            L0 = 2, er = 1;
                            break;
                          case 98:
                            if (fu(Q))
                              return l0;
                            break;
                        }
                      else if (yr[0] === 3)
                        return je(Q, ti), l0;
                      if (!er) {
                        var b0 = J$r, O0 = $$r, M0 = [0, S0];
                        L0 = 1;
                      }
                      break;
                  }
                else if (rr[0] === 3) {
                  T0 && je(Q, ti);
                  var vr = rr[1];
                  return p7(m0, Z$r, 0, Q, i0, [0, R(R0, Q, i0, o(e4, Q, l0), vr)]);
                }
                switch (L0) {
                  case 0:
                    return l0;
                  case 1:
                    var $0 = M0 ? S0 : 1, Er = O0 && O0[1], Mr = b0 && b0[1], Br = A0(Q), qr = 0;
                    if (typeof Br == "number" && Br === 14) {
                      var jr = ge0(Q), $r = jr[1], ne = Q[29][1], Qr = jr[2][1];
                      if (ne) {
                        var be = ne[1];
                        Q[29][1] = [0, [0, be[1], [0, [0, Qr, $r], be[2]]], ne[2]];
                      } else
                        ue(Q, [0, $r, 89]);
                      var pe = [1, jr], oe = $r;
                      qr = 1;
                    }
                    if (!qr)
                      var ae = z7(Q), pe = [0, ae], oe = ae[1];
                    var ce = yt(i0, oe), ge = 0;
                    l0[0] === 0 && l0[1][2][0] === 23 && pe[0] === 1 && (ue(Q, [0, ce, 90]), ge = 1);
                    var q0 = [0, o(e4, Q, l0), pe, 0], Fr = Er ? [21, [0, q0, ce, Mr]] : [16, q0];
                    return p7(m0, [0, $0], [0, Er], Q, i0, [0, [0, ce, Fr]]);
                  default:
                    var _ = p0 ? S0 : 1, k = Z7 && Z7[1], I = B && B[1], U = _L(0, Q), Y = u(se[7], U), y0 = Pe(Q);
                    Y0(Q, 7);
                    var P0 = we(Q), I0 = yt(i0, y0), D = lr(0, [0, P0], 0), u0 = [0, o(e4, Q, l0), [2, Y], D], X0 = k ? [21, [0, u0, I0, I]] : [16, u0];
                    return p7(m0, [0, _], [0, k], Q, i0, [0, [0, I0, X0]]);
                }
              }), N(c0, function(P, L, Q, i0) {
                var l0 = P ? P[1] : 1;
                return o(e4, L, p7(l, [0, l0], 0, L, Q, [0, i0]));
              }), N(t0, function(P) {
                return cr(0, function(L) {
                  var Q = u(Vn[1], L), i0 = Q[1], l0 = Q[2], S0 = cr(0, function(M0) {
                    var er = pr(M0);
                    Y0(M0, 15);
                    var yr = u(Vn[2], M0), vr = yr[1], $0 = pl([0, l0, [0, er, [0, yr[2], 0]]]);
                    if (A0(M0) === 4)
                      var Er = 0, Mr = 0;
                    else {
                      var Br = A0(M0), qr = 0;
                      if (typeof Br == "number") {
                        var jr = Br !== 98 ? 1 : 0;
                        if (!jr) {
                          var ne = jr;
                          qr = 1;
                        }
                      }
                      if (!qr)
                        var $r = mL(vr, re0(i0, M0)), ne = [0, ys($r, o(se[13], z$r, $r))];
                      var Er = oi(M0, u(mn[3], M0)), Mr = ne;
                    }
                    var Qr = t2(0, M0), be = ur(Vn[4], i0, vr, Qr), ae = A0(Qr) === 86 ? be : eb(Qr, be), pe = u(mn[12], Qr), oe = pe[2], ce = pe[1];
                    if (oe)
                      var ge = he0(Qr, oe), q0 = ce;
                    else
                      var ge = oe, q0 = o2(Qr, ce);
                    return [0, Mr, ae, vr, ge, q0, Er, $0];
                  }, L), T0 = S0[2], rr = T0[3], L0 = T0[2], B = T0[1], Z7 = q1(L0), p0 = p7(Vn[5], L, i0, rr, 1, Z7);
                  R(Vn[6], L, p0[2], B, L0);
                  var b0 = S0[1], O0 = lr([0, T0[7]], 0, 0);
                  return [8, [0, B, L0, p0[1], i0, rr, T0[4], T0[5], T0[6], O0, b0]];
                }, P);
              }), N(o0, function(P, L, Q) {
                switch (L) {
                  case 1:
                    gi(P, 45);
                    try {
                      var i0 = jv(Rv(Te(U$r, Q))), l0 = i0;
                    } catch (L0) {
                      if (L0 = Et(L0), L0[1] !== q7)
                        throw L0;
                      var l0 = ke(Te(H$r, Q));
                    }
                    break;
                  case 2:
                    gi(P, 46);
                    try {
                      var S0 = ol(Q), l0 = S0;
                    } catch (L0) {
                      if (L0 = Et(L0), L0[1] !== q7)
                        throw L0;
                      var l0 = ke(Te(X$r, Q));
                    }
                    break;
                  case 4:
                    try {
                      var T0 = ol(Q), l0 = T0;
                    } catch (L0) {
                      if (L0 = Et(L0), L0[1] !== q7)
                        throw L0;
                      var l0 = ke(Te(Y$r, Q));
                    }
                    break;
                  default:
                    try {
                      var rr = jv(Rv(Q)), l0 = rr;
                    } catch (L0) {
                      if (L0 = Et(L0), L0[1] !== q7)
                        throw L0;
                      var l0 = ke(Te(V$r, Q));
                    }
                }
                return Y0(P, [0, L, Q]), l0;
              }), N(w0, function(P) {
                var L = un(P);
                return L !== 0 && Xt === It(P, L - 1 | 0) ? m7(P, 0, L - 1 | 0) : P;
              }), N(_0, function(P, L, Q) {
                if (2 <= L) {
                  var i0 = u(w0, Q);
                  try {
                    var l0 = ol(i0), S0 = l0;
                  } catch (Z7) {
                    if (Z7 = Et(Z7), Z7[1] !== q7)
                      throw Z7;
                    var S0 = ke(Te(B$r, i0));
                  }
                  var T0 = S0;
                } else {
                  var rr = u(w0, Q);
                  try {
                    var L0 = jv(Rv(rr)), B = L0;
                  } catch (p0) {
                    if (p0 = Et(p0), p0[1] !== q7)
                      throw p0;
                    var B = ke(Te(q$r, rr));
                  }
                  var T0 = B;
                }
                return Y0(P, [1, L, Q]), T0;
              }), N(E0, function(P) {
                var L = Pe(P), Q = pr(P), i0 = A0(P);
                if (typeof i0 == "number")
                  switch (i0) {
                    case 0:
                      var l0 = u(se[12], P);
                      return [1, [0, l0[1], [19, l0[2]]], l0[3]];
                    case 4:
                      return [0, u(X, P)];
                    case 6:
                      var S0 = cr(0, hr, P), T0 = S0[2];
                      return [1, [0, S0[1], [0, T0[1]]], T0[2]];
                    case 21:
                      return ie(P), [0, [0, L, [26, [0, lr([0, Q], [0, we(P)], 0)]]]];
                    case 29:
                      return ie(P), [0, [0, L, [14, [0, 0, R$r, lr([0, Q], [0, we(P)], 0)]]]];
                    case 40:
                      return [0, u(se[22], P)];
                    case 98:
                      var rr = u(se[17], P), L0 = rr[2], B = rr[1], Z7 = Ni <= L0[1] ? [13, L0[2]] : [12, L0[2]];
                      return [0, [0, B, Z7]];
                    case 30:
                    case 31:
                      ie(P);
                      var p0 = i0 === 31 ? 1 : 0, b0 = p0 ? G$r : M$r;
                      return [0, [0, L, [14, [0, [1, p0], b0, lr([0, Q], [0, we(P)], 0)]]]];
                    case 74:
                    case 105:
                      return [0, u(Ar, P)];
                  }
                else
                  switch (i0[0]) {
                    case 0:
                      var O0 = i0[2], M0 = [2, ur(o0, P, i0[1], O0)];
                      return [0, [0, L, [14, [0, M0, O0, lr([0, Q], [0, we(P)], 0)]]]];
                    case 1:
                      var er = i0[2], yr = [3, ur(_0, P, i0[1], er)];
                      return [0, [0, L, [14, [0, yr, er, lr([0, Q], [0, we(P)], 0)]]]];
                    case 2:
                      var vr = i0[1];
                      vr[4] && gi(P, 45), ie(P);
                      var $0 = [0, vr[2]], Er = lr([0, Q], [0, we(P)], 0);
                      return [0, [0, vr[1], [14, [0, $0, vr[3], Er]]]];
                    case 3:
                      var Mr = o(b, P, i0[1]);
                      return [0, [0, Mr[1], [25, Mr[2]]]];
                  }
                if (G1(P)) {
                  var Br = o(se[13], 0, P);
                  return [0, [0, Br[1], [10, Br]]];
                }
                St(0, P);
                var qr = 0;
                return typeof i0 != "number" && i0[0] === 6 && (ie(P), qr = 1), [0, [0, L, [14, [0, 0, j$r, lr([0, Q], [0, 0], 0)]]]];
              }), N(U0, function(P) {
                return o(e4, P, u(E0, P));
              }), N(b, function(P, L) {
                var Q = L[3], i0 = L[2], l0 = L[1], S0 = pr(P);
                Y0(P, [3, L]);
                var T0 = [0, l0, [0, [0, i0[2], i0[1]], Q]];
                if (Q)
                  var rr = 0, L0 = [0, T0, 0], B = l0;
                else
                  for (var Z7 = [0, T0, 0], p0 = 0; ; ) {
                    var b0 = u(se[7], P), O0 = [0, b0, p0], M0 = A0(P), er = 0;
                    if (typeof M0 == "number" && M0 === 1) {
                      Ku(P, 4);
                      var yr = A0(P), vr = 0;
                      if (typeof yr != "number" && yr[0] === 3) {
                        var $0 = yr[1], Er = $0[3], Mr = $0[2], Br = $0[1];
                        ie(P);
                        var qr = [0, [0, Mr[2], Mr[1]], Er];
                        k7(P);
                        var jr = [0, [0, Br, qr], Z7];
                        if (!Er) {
                          var Z7 = jr, p0 = O0;
                          continue;
                        }
                        var $r = ye(O0), ne = [0, Br, ye(jr), $r];
                        er = 1, vr = 1;
                      }
                      if (!vr)
                        throw [0, Sn, P$r];
                    }
                    if (!er) {
                      St(D$r, P);
                      var Qr = [0, b0[1], L$r], be = ye(O0), ae = ye([0, Qr, Z7]), ne = [0, b0[1], ae, be];
                    }
                    var rr = ne[3], L0 = ne[2], B = ne[1];
                    break;
                  }
                var pe = we(P), oe = yt(l0, B);
                return [0, oe, [0, L0, rr, lr([0, S0], [0, pe], 0)]];
              }), N(R0, function(P, L, Q, i0) {
                var l0 = $t(P);
                function S0(L0, B) {
                  return o(Qe(L0, Di, 28), L0, B);
                }
                var T0 = o(l0[2], Q, S0), rr = o(b, P, i0);
                return [0, yt(L, rr[1]), [24, [0, T0, rr, 0]]];
              }), N(X, function(P) {
                var L = pr(P), Q = cr(0, function(T0) {
                  Y0(T0, 4);
                  var rr = Pe(T0), L0 = u(x4, T0), B = A0(T0), Z7 = 0;
                  if (typeof B == "number")
                    if (B === 9)
                      var p0 = [0, ur(W0, T0, rr, [0, L0, 0])];
                    else if (B === 86)
                      var p0 = [1, [0, L0, u(mn[9], T0), 0]];
                    else
                      Z7 = 1;
                  else
                    Z7 = 1;
                  if (Z7)
                    var p0 = [0, L0];
                  return Y0(T0, 5), p0;
                }, P), i0 = Q[2], l0 = we(P), S0 = i0[0] === 0 ? i0[1] : [0, Q[1], [27, i0[1]]];
                return ur(s0, [0, L], [0, l0], S0);
              }), N(s0, function(P, L, Q) {
                var i0 = Q[2], l0 = P && P[1], S0 = L && L[1];
                function T0(Je) {
                  return y7(Je, lr([0, l0], [0, S0], 0));
                }
                function rr(Je) {
                  return JD(Je, lr([0, l0], [0, S0], 0));
                }
                switch (i0[0]) {
                  case 0:
                    var L0 = i0[1], B = rr(L0[2]), Ne = [0, [0, L0[1], B]];
                    break;
                  case 1:
                    var Z7 = i0[1], p0 = Z7[10], b0 = T0(Z7[9]), Ne = [1, [0, Z7[1], Z7[2], Z7[3], Z7[4], Z7[5], Z7[6], Z7[7], Z7[8], b0, p0]];
                    break;
                  case 2:
                    var O0 = i0[1], M0 = T0(O0[4]), Ne = [2, [0, O0[1], O0[2], O0[3], M0]];
                    break;
                  case 3:
                    var er = i0[1], yr = T0(er[4]), Ne = [3, [0, er[1], er[2], er[3], yr]];
                    break;
                  case 4:
                    var vr = i0[1], $0 = T0(vr[4]), Ne = [4, [0, vr[1], vr[2], vr[3], $0]];
                    break;
                  case 5:
                    var Er = i0[1], Mr = T0(Er[7]), Ne = [5, [0, Er[1], Er[2], Er[3], Er[4], Er[5], Er[6], Mr]];
                    break;
                  case 7:
                    var Br = i0[1], qr = T0(Br[4]), Ne = [7, [0, Br[1], Br[2], Br[3], qr]];
                    break;
                  case 8:
                    var jr = i0[1], $r = jr[10], ne = T0(jr[9]), Ne = [8, [0, jr[1], jr[2], jr[3], jr[4], jr[5], jr[6], jr[7], jr[8], ne, $r]];
                    break;
                  case 10:
                    var Qr = i0[1], be = Qr[2], ae = T0(be[2]), Ne = [10, [0, Qr[1], [0, be[1], ae]]];
                    break;
                  case 11:
                    var pe = i0[1], oe = T0(pe[2]), Ne = [11, [0, pe[1], oe]];
                    break;
                  case 12:
                    var ce = i0[1], ge = T0(ce[4]), Ne = [12, [0, ce[1], ce[2], ce[3], ge]];
                    break;
                  case 13:
                    var q0 = i0[1], Fr = T0(q0[4]), Ne = [13, [0, q0[1], q0[2], q0[3], Fr]];
                    break;
                  case 14:
                    var _ = i0[1], k = T0(_[3]), Ne = [14, [0, _[1], _[2], k]];
                    break;
                  case 15:
                    var I = i0[1], U = T0(I[4]), Ne = [15, [0, I[1], I[2], I[3], U]];
                    break;
                  case 16:
                    var Y = i0[1], y0 = T0(Y[3]), Ne = [16, [0, Y[1], Y[2], y0]];
                    break;
                  case 17:
                    var P0 = i0[1], I0 = T0(P0[3]), Ne = [17, [0, P0[1], P0[2], I0]];
                    break;
                  case 18:
                    var D = i0[1], u0 = T0(D[4]), Ne = [18, [0, D[1], D[2], D[3], u0]];
                    break;
                  case 19:
                    var X0 = i0[1], J0 = rr(X0[2]), Ne = [19, [0, X0[1], J0]];
                    break;
                  case 20:
                    var ir = i0[1], Q0 = ir[1], F0 = ir[3], Sr = ir[2], mr = T0(Q0[4]), Ne = [20, [0, [0, Q0[1], Q0[2], Q0[3], mr], Sr, F0]];
                    break;
                  case 21:
                    var Cr = i0[1], sr = Cr[1], Pr = Cr[3], K0 = Cr[2], Ur = T0(sr[3]), Ne = [21, [0, [0, sr[1], sr[2], Ur], K0, Pr]];
                    break;
                  case 22:
                    var h0 = i0[1], Kr = T0(h0[2]), Ne = [22, [0, h0[1], Kr]];
                    break;
                  case 23:
                    var Ne = [23, [0, T0(i0[1][1])]];
                    break;
                  case 24:
                    var re = i0[1], xe = T0(re[3]), Ne = [24, [0, re[1], re[2], xe]];
                    break;
                  case 25:
                    var Re = i0[1], ve = T0(Re[3]), Ne = [25, [0, Re[1], Re[2], ve]];
                    break;
                  case 26:
                    var Ne = [26, [0, T0(i0[1][1])]];
                    break;
                  case 27:
                    var Ie = i0[1], Ge = T0(Ie[3]), Ne = [27, [0, Ie[1], Ie[2], Ge]];
                    break;
                  case 28:
                    var Me = i0[1], an = T0(Me[3]), Ne = [28, [0, Me[1], Me[2], an]];
                    break;
                  case 29:
                    var We = i0[1], Ae = T0(We[4]), Ne = [29, [0, We[1], We[2], We[3], Ae]];
                    break;
                  case 30:
                    var cn = i0[1], rn = cn[4], kn = cn[3], vn = T0(cn[2]), Ne = [30, [0, cn[1], vn, kn, rn]];
                    break;
                  default:
                    var Ne = i0;
                }
                return [0, Q[1], Ne];
              }), N(hr, function(P) {
                var L = pr(P);
                Y0(P, 6);
                for (var Q = [0, 0, t4[3]]; ; ) {
                  var i0 = Q[2], l0 = Q[1], S0 = A0(P);
                  if (typeof S0 == "number") {
                    var T0 = 0;
                    if (13 <= S0)
                      Pn === S0 && (T0 = 1);
                    else if (7 <= S0)
                      switch (S0 - 7 | 0) {
                        case 2:
                          var rr = Pe(P);
                          ie(P);
                          var Q = [0, [0, [2, rr], l0], i0];
                          continue;
                        case 5:
                          var L0 = pr(P), B = cr(0, function(Qr) {
                            ie(Qr);
                            var be = u(i4, Qr);
                            return be[0] === 0 ? [0, be[1], t4[3]] : [0, be[1], be[2]];
                          }, P), Z7 = B[2], p0 = Z7[2], b0 = B[1], O0 = lr([0, L0], 0, 0), M0 = [1, [0, b0, [0, Z7[1], O0]]], er = A0(P) === 7 ? 1 : 0, yr = 0;
                          if (!er && Yn(1, P) === 7) {
                            var vr = [0, p0[1], [0, [0, b0, 65], p0[2]]];
                            yr = 1;
                          }
                          if (!yr)
                            var vr = p0;
                          1 - er && Y0(P, 9);
                          var Q = [0, [0, M0, l0], o(t4[5], vr, i0)];
                          continue;
                        case 0:
                          T0 = 1;
                          break;
                      }
                    if (T0) {
                      var $0 = u(t4[6], i0), Er = ye(l0), Mr = pr(P);
                      return Y0(P, 7), [0, [0, Er, yu([0, L], [0, we(P)], Mr, 0)], $0];
                    }
                  }
                  var Br = u(i4, P);
                  if (Br[0] === 0)
                    var qr = t4[3], jr = Br[1];
                  else
                    var qr = Br[2], jr = Br[1];
                  A0(P) !== 7 && Y0(P, 9);
                  var Q = [0, [0, [0, jr], l0], o(t4[5], qr, i0)];
                }
              }), N(Ar, function(P) {
                Ku(P, 5);
                var L = Pe(P), Q = pr(P), i0 = A0(P), l0 = 0;
                if (typeof i0 != "number" && i0[0] === 5) {
                  var S0 = i0[3], T0 = i0[2];
                  ie(P);
                  var rr = we(P), L0 = rr, B = S0, Z7 = T0, p0 = Te(O$r, Te(T0, Te(T$r, S0)));
                  l0 = 1;
                }
                if (!l0) {
                  St(I$r, P);
                  var L0 = 0, B = A$r, Z7 = N$r, p0 = C$r;
                }
                k7(P);
                var b0 = $n(un(B)), O0 = un(B) - 1 | 0, M0 = 0;
                if (!(O0 < 0))
                  for (var er = M0; ; ) {
                    var yr = Vr(B, er), vr = yr - 100 | 0, $0 = 0;
                    if (!(21 < vr >>> 0))
                      switch (vr) {
                        case 0:
                        case 3:
                        case 5:
                        case 9:
                        case 15:
                        case 17:
                        case 21:
                          qi(b0, yr), $0 = 1;
                          break;
                      }
                    var Er = er + 1 | 0;
                    if (O0 !== er) {
                      var er = Er;
                      continue;
                    }
                    break;
                  }
                var Mr = Mt(b0);
                return n0(Mr, B) && je(P, [13, B]), [0, L, [14, [0, [4, [0, Z7, Mr]], p0, lr([0, Q], [0, L0], 0)]]];
              });
              function fe(P, L) {
                if (typeof L == "number") {
                  var Q = 0;
                  if (61 <= L) {
                    var i0 = L - 64 | 0;
                    27 < i0 >>> 0 ? i0 === 43 && (Q = 1) : 25 < (i0 - 1 | 0) >>> 0 && (Q = 1);
                  } else {
                    var l0 = L + _y | 0;
                    17 < l0 >>> 0 ? -1 <= l0 && (Q = 1) : l0 === 13 && (Q = 1);
                  }
                  if (Q)
                    return 0;
                }
                throw Bs;
              }
              function v0(P) {
                var L = A0(P);
                if (typeof L == "number" && !L) {
                  var Q = o(se[16], 1, P);
                  return [0, [0, Q[1]], Q[2]];
                }
                return [0, [1, u(se[10], P)], 0];
              }
              return N(or, function(P) {
                var L = T9(fe, P), Q = Pe(L);
                if (Yn(1, L) === 11)
                  var l0 = 0, S0 = 0;
                else
                  var i0 = u(Vn[1], L), l0 = i0[2], S0 = i0[1];
                var T0 = cr(0, function(ne) {
                  var Qr = oi(ne, u(mn[3], ne));
                  if (G1(ne) && Qr === 0) {
                    var be = o(se[13], F$r, ne), ae = be[1], pe = [0, ae, [0, [0, ae, [2, [0, be, [0, j1(ne)], 0]]], 0]];
                    return [0, Qr, [0, ae, [0, 0, [0, pe, 0], 0, 0]], [0, [0, ae[1], ae[3], ae[3]]], 0];
                  }
                  var oe = ur(Vn[4], ne[18], ne[17], ne), ce = u2(1, ne), ge = u(mn[12], ce);
                  return [0, Qr, oe, ge[1], ge[2]];
                }, L), rr = T0[2], L0 = rr[2], B = L0[2], Z7 = 0;
                if (!B[1]) {
                  var p0 = 0;
                  if (!B[3] && B[2] && (p0 = 1), !p0) {
                    var b0 = ie0(L);
                    Z7 = 1;
                  }
                }
                if (!Z7)
                  var b0 = L;
                var O0 = L0[2], M0 = O0[1], er = M0 ? (ue(b0, [0, M0[1][1], Zc]), [0, L0[1], [0, 0, O0[2], O0[3], O0[4]]]) : L0, yr = q1(er), vr = x7(b0), $0 = vr && (A0(b0) === 11 ? 1 : 0);
                $0 && je(b0, 60), Y0(b0, 11);
                var Er = fe0(ie0(b0), S0, 0, yr), Mr = cr(0, v0, Er), Br = Mr[2];
                R(Vn[6], Er, Br[2], 0, er);
                var qr = yt(Q, Mr[1]), jr = T0[1], $r = lr([0, l0], 0, 0);
                return [0, [0, qr, [1, [0, 0, er, Br[1], S0, 0, rr[4], rr[3], rr[1], $r, jr]]]];
              }), N(W0, function(P, L, Q) {
                return cr([0, L], function(i0) {
                  for (var l0 = Q; ; ) {
                    var S0 = A0(i0);
                    if (typeof S0 == "number" && S0 === 9) {
                      ie(i0);
                      var l0 = [0, u(x4, i0), l0];
                      continue;
                    }
                    return [22, [0, ye(l0), 0]];
                  }
                }, P);
              }), [0, x4, i4, T, n, K, o0, W0];
            }(R9), Us = function(t4) {
              function n(e0) {
                var x0 = pr(e0);
                ie(e0);
                var l = lr([0, x0], 0, 0), c0 = u(ci[5], e0), t0 = x7(e0) ? rb(e0) : N9(e0);
                function o0(w0, _0) {
                  return o(Qe(w0, Di, 80), w0, _0);
                }
                return [0, o(t0[2], c0, o0), l];
              }
              function e4(e0) {
                var x0 = e0[27][2];
                if (x0)
                  for (var l = 0; ; ) {
                    var c0 = A0(e0);
                    if (typeof c0 == "number" && c0 === 13) {
                      var l = [0, cr(0, n, e0), l];
                      continue;
                    }
                    return ye(l);
                  }
                return x0;
              }
              function i4(e0, x0) {
                var l = e0 && e0[1], c0 = pr(x0), t0 = A0(x0);
                if (typeof t0 == "number")
                  switch (t0) {
                    case 6:
                      var o0 = cr(0, function(Jr) {
                        var ar = pr(Jr);
                        Y0(Jr, 6);
                        var _r = Kl(0, Jr), Ir = u(se[10], _r);
                        return Y0(Jr, 7), [0, Ir, lr([0, ar], [0, we(Jr)], 0)];
                      }, x0), w0 = o0[1];
                      return [0, w0, [3, [0, w0, o0[2]]]];
                    case 14:
                      if (l) {
                        var _0 = ge0(x0), E0 = x0[29][1], U0 = _0[2][1];
                        if (E0) {
                          var b = E0[1], R0 = E0[2], X = b[2], s0 = [0, [0, o(Mu[4], U0, b[1]), X], R0];
                          x0[29][1] = s0;
                        } else
                          ke(Ujr);
                        return [0, _0[1], [2, _0]];
                      }
                      var hr = cr(0, function(Jr) {
                        return ie(Jr), [1, z7(Jr)];
                      }, x0), Ar = hr[1];
                      return ue(x0, [0, Ar, 89]), [0, Ar, hr[2]];
                  }
                else
                  switch (t0[0]) {
                    case 0:
                      var or = t0[2], W0 = Pe(x0), Lr = [2, ur(ci[6], x0, t0[1], or)];
                      return [0, W0, [0, [0, W0, [0, Lr, or, lr([0, c0], [0, we(x0)], 0)]]]];
                    case 2:
                      var Tr = t0[1], Hr = Tr[4], Or = Tr[3], fr = Tr[2], Rr = Tr[1];
                      return Hr && gi(x0, 45), Y0(x0, [2, [0, Rr, fr, Or, Hr]]), [0, Rr, [0, [0, Rr, [0, [0, fr], Or, lr([0, c0], [0, we(x0)], 0)]]]];
                  }
                var Wr = z7(x0);
                return [0, Wr[1], [1, Wr]];
              }
              function x4(e0, x0, l) {
                var c0 = u(Vn[2], e0), t0 = c0[1], o0 = c0[2], w0 = i4([0, x0], e0), _0 = w0[1], E0 = 0, U0 = Xi(e0, w0[2]);
                return [0, U0, cr(0, function(b) {
                  var R0 = t2(1, b), X = cr(0, function(Tr) {
                    var Hr = ur(Vn[4], 0, 0, Tr), Or = 0, fr = A0(Tr) === 86 ? Hr : eb(Tr, Hr);
                    if (l) {
                      var Rr = fr[2], Wr = 0;
                      if (Rr[1])
                        ue(Tr, [0, _0, j7]), Wr = 1;
                      else {
                        var Jr = 0;
                        !Rr[2] && !Rr[3] && (Wr = 1, Jr = 1), Jr || ue(Tr, [0, _0, 80]);
                      }
                    } else {
                      var ar = fr[2];
                      if (ar[1])
                        ue(Tr, [0, _0, Yt]);
                      else {
                        var _r = ar[2], Ir = 0;
                        (!_r || _r[2] || ar[3]) && (Ir = 1), Ir && (ar[3] ? ue(Tr, [0, _0, 81]) : ue(Tr, [0, _0, 81]));
                      }
                    }
                    return [0, Or, fr, o2(Tr, u(mn[10], Tr))];
                  }, R0), s0 = X[2], hr = s0[2], Ar = q1(hr), or = p7(Vn[5], R0, E0, t0, 0, Ar);
                  R(Vn[6], R0, or[2], 0, hr);
                  var W0 = X[1], Lr = lr([0, o0], 0, 0);
                  return [0, 0, hr, or[1], E0, t0, 0, s0[3], s0[1], Lr, W0];
                }, e0)];
              }
              function c(e0) {
                var x0 = u(ci[2], e0);
                return x0[0] === 0 ? [0, x0[1], t4[3]] : [0, x0[1], x0[2]];
              }
              function s2(e0, x0) {
                switch (x0[0]) {
                  case 0:
                    var l = x0[1], c0 = l[1];
                    return ue(e0, [0, c0, 95]), [0, c0, [14, l[2]]];
                  case 1:
                    var t0 = x0[1], o0 = t0[2][1], w0 = t0[1], _0 = 0;
                    return kL(o0) && n0(o0, KQr) && n0(o0, WQr) && (ue(e0, [0, w0, 2]), _0 = 1), !_0 && f22(o0) && V7(e0, [0, w0, 55]), [0, w0, [10, t0]];
                  case 2:
                    return ke(JQr);
                  default:
                    var E0 = x0[1][2][1];
                    return ue(e0, [0, E0[1], 96]), E0;
                }
              }
              function p(e0, x0, l) {
                function c0(o0) {
                  var w0 = t2(1, o0), _0 = cr(0, function(hr) {
                    var Ar = oi(hr, u(mn[3], hr));
                    if (e0)
                      if (x0)
                        var or = 1, W0 = 1;
                      else
                        var or = hr[18], W0 = 0;
                    else if (x0)
                      var or = 0, W0 = 1;
                    else
                      var or = 0, W0 = 0;
                    var Lr = ur(Vn[4], or, W0, hr), Tr = A0(hr) === 86 ? Lr : eb(hr, Lr);
                    return [0, Ar, Tr, o2(hr, u(mn[10], hr))];
                  }, w0), E0 = _0[2], U0 = E0[2], b = q1(U0), R0 = p7(Vn[5], w0, e0, x0, 0, b);
                  R(Vn[6], w0, R0[2], 0, U0);
                  var X = _0[1], s0 = lr([0, l], 0, 0);
                  return [0, 0, U0, R0[1], e0, x0, 0, E0[3], E0[1], s0, X];
                }
                var t0 = 0;
                return function(o0) {
                  return cr(t0, c0, o0);
                };
              }
              function y(e0) {
                return Y0(e0, 86), c(e0);
              }
              function T(e0, x0, l, c0, t0, o0) {
                var w0 = cr([0, x0], function(E0) {
                  if (!c0 && !t0) {
                    var U0 = A0(E0);
                    if (typeof U0 == "number") {
                      var b = 0;
                      if (86 <= U0) {
                        if (U0 === 98)
                          b = 1;
                        else if (!(87 <= U0)) {
                          var R0 = y(E0);
                          return [0, [0, l, R0[1], 0], R0[2]];
                        }
                      } else {
                        if (U0 === 82) {
                          if (l[0] === 1)
                            var X = l[1], s0 = Pe(E0), hr = function(Rr) {
                              var Wr = pr(Rr);
                              Y0(Rr, 82);
                              var Jr = we(Rr), ar = o(se[19], Rr, [0, X[1], [10, X]]), _r = u(se[10], Rr);
                              return [2, [0, 0, ar, _r, lr([0, Wr], [0, Jr], 0)]];
                            }, Ar = cr([0, X[1]], hr, E0), or = [0, Ar, [0, [0, [0, s0, [10, Ml(zQr)]], 0], 0]];
                          else
                            var or = y(E0);
                          return [0, [0, l, or[1], 1], or[2]];
                        }
                        if (!(10 <= U0))
                          switch (U0) {
                            case 4:
                              b = 1;
                              break;
                            case 1:
                            case 9:
                              var W0 = [0, l, s2(E0, l), 1];
                              return [0, W0, t4[3]];
                          }
                      }
                      if (b) {
                        var Lr = Xi(E0, l), Tr = [1, Lr, u(p(c0, t0, o0), E0)];
                        return [0, Tr, t4[3]];
                      }
                    }
                    var Hr = [0, l, s2(E0, l), 1];
                    return [0, Hr, t4[3]];
                  }
                  var Or = Xi(E0, l), fr = [1, Or, u(p(c0, t0, o0), E0)];
                  return [0, fr, t4[3]];
                }, e0), _0 = w0[2];
                return [0, [0, [0, w0[1], _0[1]]], _0[2]];
              }
              function E(e0) {
                var x0 = cr(0, function(c0) {
                  var t0 = pr(c0);
                  Y0(c0, 0);
                  for (var o0 = 0, w0 = [0, 0, t4[3]]; ; ) {
                    var _0 = w0[2], E0 = w0[1], U0 = A0(c0);
                    if (typeof U0 == "number") {
                      var b = 0;
                      if ((U0 === 1 || Pn === U0) && (b = 1), b) {
                        var R0 = o0 ? [0, _0[1], [0, [0, o0[1], 98], _0[2]]] : _0, X = u(t4[6], R0), s0 = ye(E0), hr = pr(c0);
                        return Y0(c0, 1), [0, [0, s0, yu([0, t0], [0, we(c0)], hr, 0)], X];
                      }
                    }
                    if (A0(c0) === 12)
                      var Ar = pr(c0), or = cr(0, function(y0) {
                        return Y0(y0, 12), c(y0);
                      }, c0), W0 = or[2], Lr = W0[2], Tr = lr([0, Ar], 0, 0), Hr = [0, [1, [0, or[1], [0, W0[1], Tr]]], Lr];
                    else {
                      var Or = Pe(c0), fr = Yn(1, c0), Rr = 0;
                      if (typeof fr == "number") {
                        var Wr = 0;
                        if (86 <= fr)
                          fr !== 98 && 87 <= fr && (Wr = 1);
                        else if (fr !== 82)
                          if (10 <= fr)
                            Wr = 1;
                          else
                            switch (fr) {
                              case 1:
                              case 4:
                              case 9:
                                break;
                              default:
                                Wr = 1;
                            }
                        if (!Wr) {
                          var ar = 0, _r = 0;
                          Rr = 1;
                        }
                      }
                      if (!Rr)
                        var Jr = u(Vn[1], c0), ar = Jr[2], _r = Jr[1];
                      var Ir = u(Vn[2], c0), fe = Ir[1], v0 = on(ar, Ir[2]), P = A0(c0), L = 0;
                      if (!_r && !fe && typeof P != "number" && P[0] === 4) {
                        var Q = P[3], i0 = 0;
                        if (n0(Q, YQr))
                          if (n0(Q, VQr))
                            i0 = 1;
                          else {
                            var l0 = pr(c0), S0 = i4(0, c0)[2], T0 = A0(c0), rr = 0;
                            if (typeof T0 == "number") {
                              var L0 = 0;
                              if (86 <= T0)
                                T0 !== 98 && 87 <= T0 && (L0 = 1);
                              else if (T0 !== 82)
                                if (10 <= T0)
                                  L0 = 1;
                                else
                                  switch (T0) {
                                    case 1:
                                    case 4:
                                    case 9:
                                      break;
                                    default:
                                      L0 = 1;
                                  }
                              if (!L0) {
                                var B = T(c0, Or, S0, 0, 0, 0);
                                rr = 1;
                              }
                            }
                            if (!rr) {
                              Xi(c0, S0);
                              var Z7 = t4[3], p0 = cr([0, Or], function(I0) {
                                return x4(I0, 0, 0);
                              }, c0), b0 = p0[2], O0 = lr([0, l0], 0, 0), B = [0, [0, [0, p0[1], [3, b0[1], b0[2], O0]]], Z7];
                            }
                            var M0 = B;
                          }
                        else {
                          var er = pr(c0), yr = i4(0, c0)[2], vr = A0(c0), $0 = 0;
                          if (typeof vr == "number") {
                            var Er = 0;
                            if (86 <= vr)
                              vr !== 98 && 87 <= vr && (Er = 1);
                            else if (vr !== 82)
                              if (10 <= vr)
                                Er = 1;
                              else
                                switch (vr) {
                                  case 1:
                                  case 4:
                                  case 9:
                                    break;
                                  default:
                                    Er = 1;
                                }
                            if (!Er) {
                              var Mr = T(c0, Or, yr, 0, 0, 0);
                              $0 = 1;
                            }
                          }
                          if (!$0) {
                            Xi(c0, yr);
                            var Br = t4[3], qr = cr([0, Or], function(D) {
                              return x4(D, 0, 1);
                            }, c0), jr = qr[2], $r = lr([0, er], 0, 0), Mr = [0, [0, [0, qr[1], [2, jr[1], jr[2], $r]]], Br];
                          }
                          var M0 = Mr;
                        }
                        if (!i0) {
                          var ne = M0;
                          L = 1;
                        }
                      }
                      if (!L)
                        var ne = T(c0, Or, i4(0, c0)[2], _r, fe, v0);
                      var Hr = ne;
                    }
                    var Qr = Hr[1], be = 0;
                    if (Qr[0] === 1 && A0(c0) === 9) {
                      var ae = [0, Pe(c0)];
                      be = 1;
                    }
                    if (!be)
                      var ae = 0;
                    var pe = o(t4[5], Hr[2], _0), oe = A0(c0), ce = 0;
                    if (typeof oe == "number") {
                      var ge = oe - 2 | 0, q0 = 0;
                      if (Xt < ge >>> 0 ? T7 < (ge + 1 | 0) >>> 0 && (q0 = 1) : ge === 7 ? ie(c0) : q0 = 1, !q0) {
                        var Fr = pe;
                        ce = 1;
                      }
                    }
                    if (!ce) {
                      var _ = aL(dRr, 9), k = le0([0, _], A0(c0)), I = [0, Pe(c0), k];
                      xu(c0, 8);
                      var Fr = o(t4[4], I, pe);
                    }
                    var o0 = ae, w0 = [0, [0, Qr, E0], Fr];
                  }
                }, e0), l = x0[2];
                return [0, x0[1], l[1], l[2]];
              }
              function d(e0, x0, l, c0) {
                var t0 = l[2][1], o0 = l[1];
                if (qn(t0, XQr))
                  return ue(e0, [0, o0, [21, t0, 0, QY === c0 ? 1 : 0, 1]]), x0;
                var w0 = o(L9[32], t0, x0);
                if (w0) {
                  var _0 = w0[1], E0 = 0;
                  return SE === c0 ? Fh === _0 && (E0 = 1) : Fh === c0 && SE === _0 && (E0 = 1), E0 || ue(e0, [0, o0, [20, t0]]), ur(L9[4], t0, KX, x0);
                }
                return ur(L9[4], t0, c0, x0);
              }
              function w(e0, x0) {
                return cr(0, function(l) {
                  var c0 = x0 && pr(l);
                  Y0(l, 52);
                  for (var t0 = 0; ; ) {
                    var o0 = [0, cr(0, function(E0) {
                      var U0 = u(mn[2], E0);
                      if (A0(E0) === 98)
                        var b = $t(E0), R0 = function(s0, hr) {
                          return o(Qe(s0, Nv, 81), s0, hr);
                        }, X = o(b[2], U0, R0);
                      else
                        var X = U0;
                      return [0, X, u(mn[4], E0)];
                    }, l), t0], w0 = A0(l);
                    if (typeof w0 == "number" && w0 === 9) {
                      Y0(l, 9);
                      var t0 = o0;
                      continue;
                    }
                    var _0 = ye(o0);
                    return [0, _0, lr([0, c0], 0, 0)];
                  }
                }, e0);
              }
              function G(e0, x0) {
                return x0 && ue(e0, [0, x0[1][1], 7]);
              }
              function A11(e0, x0) {
                return x0 && ue(e0, [0, x0[1], 68]);
              }
              function S11(e0, x0, l, c0, t0, o0, w0, _0, E0, U0) {
                for (; ; ) {
                  var b = A0(e0), R0 = 0;
                  if (typeof b == "number") {
                    var X = b - 1 | 0, s0 = 0;
                    if (7 < X >>> 0) {
                      var hr = X - 81 | 0;
                      if (4 < hr >>> 0)
                        s0 = 1;
                      else
                        switch (hr) {
                          case 3:
                            St(0, e0), ie(e0);
                            continue;
                          case 0:
                          case 4:
                            break;
                          default:
                            s0 = 1;
                        }
                    } else
                      5 < (X - 1 | 0) >>> 0 || (s0 = 1);
                    !s0 && !t0 && !o0 && (R0 = 1);
                  }
                  if (!R0) {
                    var Ar = A0(e0), or = 0;
                    if (typeof Ar == "number") {
                      var W0 = 0;
                      if (Ar !== 4 && Ar !== 98 && (or = 1, W0 = 1), !W0)
                        var Tr = 0;
                    } else
                      or = 1;
                    if (or)
                      var Lr = x2(e0), Tr = Lr && 1;
                    if (!Tr) {
                      A11(e0, _0), G(e0, E0);
                      var Hr = 0;
                      if (!w0) {
                        var Or = 0;
                        switch (c0[0]) {
                          case 0:
                            var fr = c0[1][2][1], Rr = 0;
                            typeof fr != "number" && fr[0] === 0 && (n0(fr[1], jQr) && (Or = 1), Rr = 1), Rr || (Or = 1);
                            break;
                          case 1:
                            n0(c0[1][2][1], GQr) && (Or = 1);
                            break;
                          default:
                            Or = 1;
                        }
                        if (!Or) {
                          var Wr = t2(2, e0), Jr = 0;
                          Hr = 1;
                        }
                      }
                      if (!Hr)
                        var Wr = t2(1, e0), Jr = 1;
                      var ar = Xi(Wr, c0), _r = cr(0, function(S0) {
                        var T0 = cr(0, function(p0) {
                          var b0 = oi(p0, u(mn[3], p0));
                          if (t0)
                            if (o0)
                              var O0 = 1, M0 = 1;
                            else
                              var O0 = p0[18], M0 = 0;
                          else if (o0)
                            var O0 = 0, M0 = 1;
                          else
                            var O0 = 0, M0 = 0;
                          var er = ur(Vn[4], O0, M0, p0), yr = A0(p0) === 86 ? er : eb(p0, er), vr = yr[2], $0 = vr[1], Er = 0;
                          if ($0 && Jr === 0) {
                            ue(p0, [0, $0[1][1], is]);
                            var Mr = [0, yr[1], [0, 0, vr[2], vr[3], vr[4]]];
                            Er = 1;
                          }
                          if (!Er)
                            var Mr = yr;
                          return [0, b0, Mr, o2(p0, u(mn[10], p0))];
                        }, S0), rr = T0[2], L0 = rr[2], B = q1(L0), Z7 = p7(Vn[5], S0, t0, o0, 0, B);
                        return R(Vn[6], S0, Z7[2], 0, L0), [0, 0, L0, Z7[1], t0, o0, 0, rr[3], rr[1], 0, T0[1]];
                      }, Wr), Ir = [0, Jr, ar, _r, w0, l, lr([0, U0], 0, 0)];
                      return [0, [0, yt(x0, _r[1]), Ir]];
                    }
                  }
                  var fe = cr([0, x0], function(S0) {
                    var T0 = u(mn[10], S0), rr = A0(S0);
                    if (_0) {
                      var L0 = 0;
                      if (typeof rr == "number" && rr === 82) {
                        je(S0, 69), ie(S0);
                        var B = 0;
                      } else
                        L0 = 1;
                      if (L0)
                        var B = 0;
                    } else {
                      var Z7 = 0;
                      if (typeof rr == "number" && rr === 82) {
                        ie(S0);
                        var p0 = t2(1, S0), B = [0, u(se[7], p0)];
                      } else
                        Z7 = 1;
                      if (Z7)
                        var B = 1;
                    }
                    var b0 = A0(S0), O0 = 0;
                    if (typeof b0 == "number" && !(9 <= b0))
                      switch (b0) {
                        case 8:
                          ie(S0);
                          var M0 = A0(S0), er = 0;
                          if (typeof M0 == "number") {
                            var yr = 0;
                            if (M0 !== 1 && Pn !== M0 && (er = 1, yr = 1), !yr)
                              var $0 = we(S0);
                          } else
                            er = 1;
                          if (er)
                            var vr = x7(S0), $0 = vr && Ms(S0);
                          var Er = [0, c0, T0, B, $0];
                          O0 = 1;
                          break;
                        case 4:
                        case 6:
                          St(0, S0);
                          var Er = [0, c0, T0, B, 0];
                          O0 = 1;
                          break;
                      }
                    if (!O0) {
                      var Mr = A0(S0), Br = 0;
                      if (typeof Mr == "number") {
                        var qr = 0;
                        if (Mr !== 1 && Pn !== Mr && (Br = 1, qr = 1), !qr)
                          var jr = [0, 0, function(q0, Fr) {
                            return q0;
                          }];
                      } else
                        Br = 1;
                      if (Br)
                        var jr = x7(S0) ? rb(S0) : N9(S0);
                      if (typeof B == "number")
                        if (T0[0] === 0)
                          var $r = function(_, k) {
                            return o(Qe(_, qY, 83), _, k);
                          }, be = B, ae = T0, pe = o(jr[2], c0, $r);
                        else
                          var ne = function(_, k) {
                            return o(Qe(_, OE, 84), _, k);
                          }, be = B, ae = [1, o(jr[2], T0[1], ne)], pe = c0;
                      else
                        var Qr = function(ge, q0) {
                          return o(Qe(ge, Di, 85), ge, q0);
                        }, be = [0, o(jr[2], B[1], Qr)], ae = T0, pe = c0;
                      var Er = [0, pe, ae, be, 0];
                    }
                    var oe = lr([0, U0], [0, Er[4]], 0);
                    return [0, Er[1], Er[2], Er[3], oe];
                  }, e0), v0 = fe[2], P = v0[4], L = v0[3], Q = v0[2], i0 = v0[1], l0 = fe[1];
                  return i0[0] === 2 ? [2, [0, l0, [0, i0[1], L, Q, w0, E0, P]]] : [1, [0, l0, [0, i0, L, Q, w0, E0, P]]];
                }
              }
              function M(e0, x0) {
                var l = Yn(e0, x0);
                if (typeof l == "number") {
                  var c0 = 0;
                  if (86 <= l)
                    (l === 98 || !(87 <= l)) && (c0 = 1);
                  else if (l === 82)
                    c0 = 1;
                  else if (!(9 <= l))
                    switch (l) {
                      case 1:
                      case 4:
                      case 8:
                        c0 = 1;
                        break;
                    }
                  if (c0)
                    return 1;
                }
                return 0;
              }
              var K = 0;
              function V(e0) {
                return M(K, e0);
              }
              function f0(e0, x0, l, c0) {
                var t0 = e0 && e0[1], o0 = _s(1, x0), w0 = on(t0, e4(o0)), _0 = pr(o0);
                Y0(o0, 40);
                var E0 = F9(1, o0), U0 = A0(E0), b = 0;
                if (l && typeof U0 == "number") {
                  var R0 = 0;
                  if (52 <= U0 ? U0 !== 98 && 53 <= U0 && (R0 = 1) : U0 !== 41 && U0 && (R0 = 1), !R0) {
                    var Ar = 0;
                    b = 1;
                  }
                }
                if (!b)
                  if (G1(o0))
                    var X = o(se[13], 0, E0), s0 = $t(o0), hr = function(v0, P) {
                      return o(Qe(v0, Nv, 88), v0, P);
                    }, Ar = [0, o(s0[2], X, hr)];
                  else {
                    be0(o0, NQr);
                    var Ar = [0, [0, Pe(o0), CQr]];
                  }
                var or = u(mn[3], o0);
                if (or)
                  var W0 = $t(o0), Lr = function(v0, P) {
                    return o(Qe(v0, bF, 86), v0, P);
                  }, Tr = [0, o(W0[2], or[1], Lr)];
                else
                  var Tr = or;
                var Hr = pr(o0), Or = xu(o0, 41);
                if (Or)
                  var fr = cr(0, function(v0) {
                    var P = mL(0, v0), L = u(ci[5], P);
                    if (A0(v0) === 98)
                      var Q = $t(v0), i0 = function(T0, rr) {
                        return o(Qe(T0, Di, 82), T0, rr);
                      }, l0 = o(Q[2], L, i0);
                    else
                      var l0 = L;
                    var S0 = u(mn[4], v0);
                    return [0, l0, S0, lr([0, Hr], 0, 0)];
                  }, o0), Rr = fr[1], Wr = $t(o0), Jr = function(v0, P) {
                    return ur(Qe(v0, -663447790, 87), v0, Rr, P);
                  }, ar = [0, [0, Rr, o(Wr[2], fr[2], Jr)]];
                else
                  var ar = Or;
                var _r = A0(o0) === 52 ? 1 : 0;
                if (_r) {
                  1 - fu(o0) && je(o0, 16);
                  var Ir = [0, ke0(o0, w(o0, 1))];
                } else
                  var Ir = _r;
                var fe = cr(0, function(v0) {
                  var P = pr(v0);
                  if (xu(v0, 0)) {
                    v0[29][1] = [0, [0, Mu[1], 0], v0[29][1]];
                    for (var L = 0, Q = L9[1], i0 = 0; ; ) {
                      var l0 = A0(v0);
                      if (typeof l0 == "number") {
                        var S0 = l0 - 2 | 0;
                        if (Xt < S0 >>> 0) {
                          if (!(T7 < (S0 + 1 | 0) >>> 0)) {
                            var T0 = ye(i0), rr = function(ou, Bu) {
                              return u(ml(function(K7) {
                                return 1 - o(Mu[3], K7[1], ou);
                              }), Bu);
                            }, L0 = v0[29][1];
                            if (L0) {
                              var B = L0[1], Z7 = B[1];
                              if (L0[2]) {
                                var p0 = L0[2], b0 = rr(Z7, B[2]), O0 = bl(p0), M0 = az(p0), er = on(O0[2], b0);
                                v0[29][1] = [0, [0, O0[1], er], M0];
                              } else {
                                var yr = rr(Z7, B[2]);
                                Du(function(ou) {
                                  return ue(v0, [0, ou[2], [22, ou[1]]]);
                                }, yr), v0[29][1] = 0;
                              }
                            } else
                              ke(Hjr);
                            Y0(v0, 1);
                            var vr = A0(v0), $0 = 0;
                            if (!c0) {
                              var Er = 0;
                              if (typeof vr == "number" && (vr === 1 || Pn === vr) && (Er = 1), !Er) {
                                var Mr = x7(v0);
                                if (Mr) {
                                  var Br = Ms(v0);
                                  $0 = 1;
                                } else {
                                  var Br = Mr;
                                  $0 = 1;
                                }
                              }
                            }
                            if (!$0)
                              var Br = we(v0);
                            return [0, T0, lr([0, P], [0, Br], 0)];
                          }
                        } else if (S0 === 6) {
                          Y0(v0, 8);
                          continue;
                        }
                      }
                      var qr = Pe(v0), jr = e4(v0), $r = A0(v0), ne = 0;
                      if (typeof $r == "number" && $r === 60 && !M(1, v0)) {
                        var Qr = [0, Pe(v0)], be = pr(v0);
                        ie(v0);
                        var ae = be, pe = Qr;
                        ne = 1;
                      }
                      if (!ne)
                        var ae = 0, pe = 0;
                      var oe = Yn(1, v0) !== 4 ? 1 : 0;
                      if (oe)
                        var ce = Yn(1, v0) !== 98 ? 1 : 0, ge = ce && (A0(v0) === 42 ? 1 : 0);
                      else
                        var ge = oe;
                      if (ge) {
                        var q0 = pr(v0);
                        ie(v0);
                        var Fr = q0;
                      } else
                        var Fr = ge;
                      var _ = A0(v0) === 64 ? 1 : 0;
                      if (_)
                        var k = 1 - M(1, v0), I = k && 1 - Jl(1, v0);
                      else
                        var I = _;
                      if (I) {
                        var U = pr(v0);
                        ie(v0);
                        var Y = U;
                      } else
                        var Y = I;
                      var y0 = u(Vn[2], v0), P0 = y0[1], I0 = ur(Vn[3], v0, I, P0), D = 0;
                      if (!P0 && I0) {
                        var u0 = u(Vn[2], v0), X0 = u0[2], J0 = u0[1];
                        D = 1;
                      }
                      if (!D)
                        var X0 = y0[2], J0 = P0;
                      var ir = pl([0, ae, [0, Fr, [0, Y, [0, X0, 0]]]]), Q0 = A0(v0), F0 = 0;
                      if (!I && !J0 && typeof Q0 != "number" && Q0[0] === 4) {
                        var Sr = Q0[3];
                        if (n0(Sr, MQr)) {
                          if (!n0(Sr, BQr)) {
                            var mr = pr(v0), Cr = i4(qQr, v0)[2];
                            if (V(v0)) {
                              var Ie = S11(v0, qr, jr, Cr, I, J0, ge, pe, I0, ir);
                              F0 = 1;
                            } else {
                              A11(v0, pe), G(v0, I0), Xi(v0, Cr);
                              var sr = on(ir, mr), Pr = cr([0, qr], function(Bu) {
                                return x4(Bu, 1, 0);
                              }, v0), K0 = Pr[2], Ur = lr([0, sr], 0, 0), Ie = [0, [0, Pr[1], [0, 3, K0[1], K0[2], ge, jr, Ur]]];
                              F0 = 1;
                            }
                          }
                        } else {
                          var h0 = pr(v0), Kr = i4(UQr, v0)[2];
                          if (V(v0)) {
                            var Ie = S11(v0, qr, jr, Kr, I, J0, ge, pe, I0, ir);
                            F0 = 1;
                          } else {
                            A11(v0, pe), G(v0, I0), Xi(v0, Kr);
                            var re = on(ir, h0), xe = cr([0, qr], function(Bu) {
                              return x4(Bu, 1, 1);
                            }, v0), Re = xe[2], ve = lr([0, re], 0, 0), Ie = [0, [0, xe[1], [0, 2, Re[1], Re[2], ge, jr, ve]]];
                            F0 = 1;
                          }
                        }
                      }
                      if (!F0)
                        var Ie = S11(v0, qr, jr, i4(HQr, v0)[2], I, J0, ge, pe, I0, ir);
                      switch (Ie[0]) {
                        case 0:
                          var Ge = Ie[1], Me = Ge[2];
                          switch (Me[1]) {
                            case 0:
                              if (Me[4])
                                var Ft = Q, Ct = L;
                              else {
                                L && ue(v0, [0, Ge[1], 87]);
                                var Ft = Q, Ct = 1;
                              }
                              break;
                            case 1:
                              var an = Me[2], We = an[0] === 2 ? d(v0, Q, an[1], QY) : Q, Ft = We, Ct = L;
                              break;
                            case 2:
                              var Ae = Me[2], cn = Ae[0] === 2 ? d(v0, Q, Ae[1], SE) : Q, Ft = cn, Ct = L;
                              break;
                            default:
                              var rn = Me[2], kn = rn[0] === 2 ? d(v0, Q, rn[1], Fh) : Q, Ft = kn, Ct = L;
                          }
                          break;
                        case 1:
                          var vn = Ie[1][2], Ne = vn[4], Je = vn[1], en = 0;
                          switch (Je[0]) {
                            case 0:
                              var _n = Je[1], Cn = _n[2][1], Hn = 0;
                              if (typeof Cn != "number" && Cn[0] === 0) {
                                var vt = Cn[1], Nt = _n[1];
                                en = 1, Hn = 1;
                              }
                              Hn || (en = 2);
                              break;
                            case 1:
                              var Fn = Je[1], vt = Fn[2][1], Nt = Fn[1];
                              en = 1;
                              break;
                            case 2:
                              ke(PQr);
                              break;
                            default:
                              en = 2;
                          }
                          switch (en) {
                            case 1:
                              var gt = qn(vt, DQr);
                              if (gt)
                                var qt = gt;
                              else
                                var Zt = qn(vt, LQr), qt = Zt && Ne;
                              qt && ue(v0, [0, Nt, [21, vt, Ne, 0, 0]]);
                              break;
                            case 2:
                              break;
                          }
                          var Ft = Q, Ct = L;
                          break;
                        default:
                          var Ft = d(v0, Q, Ie[1][2][1], KX), Ct = L;
                      }
                      var L = Ct, Q = Ft, i0 = [0, Ie, i0];
                    }
                  }
                  return B1(v0, 0), RQr;
                }, o0);
                return [0, Ar, fe, Tr, ar, Ir, w0, lr([0, _0], 0, 0)];
              }
              function m0(e0, x0) {
                return cr(0, function(l) {
                  return [2, f0([0, x0], l, l[7], 0)];
                }, e0);
              }
              function k0(e0) {
                return [5, f0(0, e0, 1, 1)];
              }
              var g0 = 0;
              return [0, i4, E, m0, function(e0) {
                return cr(g0, k0, e0);
              }, w, e4];
            }(R9), ht = function(t4) {
              function n(_) {
                var k = u(Vn[10], _);
                if (_[5])
                  M1(_, k[1]);
                else {
                  var I = k[2], U = 0;
                  if (I[0] === 23) {
                    var Y = I[1], y0 = k[1], P0 = 0;
                    Y[4] ? ue(_, [0, y0, 61]) : Y[5] ? ue(_, [0, y0, 62]) : (U = 1, P0 = 1);
                  } else
                    U = 1;
                }
                return k;
              }
              function e4(_, k, I) {
                var U = I[2][1], Y = I[1];
                if (n0(U, Z0e)) {
                  if (n0(U, Q0e))
                    return n0(U, rre) ? f22(U) ? V7(k, [0, Y, 55]) : kL(U) ? ue(k, [0, Y, [10, Ml(U)]]) : _ && js(U) ? V7(k, [0, Y, _[1]]) : 0 : k[17] ? ue(k, [0, Y, 2]) : V7(k, [0, Y, 55]);
                  if (k[5])
                    return V7(k, [0, Y, 55]);
                  var y0 = k[14];
                  return y0 && ue(k, [0, Y, [10, Ml(U)]]);
                }
                var P0 = k[18];
                return P0 && ue(k, [0, Y, 2]);
              }
              function i4(_, k) {
                var I = k[4], U = k[3], Y = k[2], y0 = k[1];
                I && gi(_, 45);
                var P0 = pr(_);
                return Y0(_, [2, [0, y0, Y, U, I]]), [0, y0, [0, Y, U, lr([0, P0], [0, we(_)], 0)]];
              }
              function x4(_, k, I) {
                var U = _ ? _[1] : W0e, Y = k ? k[1] : 1, y0 = A0(I);
                if (typeof y0 == "number") {
                  var P0 = y0 - 2 | 0;
                  if (Xt < P0 >>> 0) {
                    if (!(T7 < (P0 + 1 | 0) >>> 0)) {
                      var I0 = function(X0, J0) {
                        return X0;
                      };
                      return [1, [0, we(I), I0]];
                    }
                  } else if (P0 === 6) {
                    ie(I);
                    var D = A0(I);
                    if (typeof D == "number") {
                      var u0 = 0;
                      if ((D === 1 || Pn === D) && (u0 = 1), u0)
                        return [0, we(I)];
                    }
                    return x7(I) ? [0, Ms(I)] : J0e;
                  }
                }
                return x7(I) ? [1, rb(I)] : (Y && St([0, U], I), $0e);
              }
              function c(_) {
                var k = A0(_);
                if (typeof k == "number") {
                  var I = 0;
                  if ((k === 1 || Pn === k) && (I = 1), I) {
                    var U = function(Y, y0) {
                      return Y;
                    };
                    return [0, we(_), U];
                  }
                }
                return x7(_) ? rb(_) : N9(_);
              }
              function s2(_, k, I) {
                var U = x4(0, 0, k);
                if (U[0] === 0)
                  return [0, U[1], I];
                var Y = ye(I);
                if (Y)
                  var y0 = function(D, u0) {
                    return ur(Qe(D, 634872468, 89), D, _, u0);
                  }, P0 = o(U[1][2], Y[1], y0), I0 = ye([0, P0, Y[2]]);
                else
                  var I0 = Y;
                return [0, 0, I0];
              }
              var p = function _(k) {
                return _.fun(k);
              }, y = function _(k) {
                return _.fun(k);
              }, T = function _(k) {
                return _.fun(k);
              }, E = function _(k) {
                return _.fun(k);
              }, d = function _(k) {
                return _.fun(k);
              }, w = function _(k, I) {
                return _.fun(k, I);
              }, G = function _(k) {
                return _.fun(k);
              }, A11 = function _(k) {
                return _.fun(k);
              }, S11 = function _(k, I, U) {
                return _.fun(k, I, U);
              }, M = function _(k) {
                return _.fun(k);
              }, K = function _(k) {
                return _.fun(k);
              }, V = function _(k, I) {
                return _.fun(k, I);
              }, f0 = function _(k) {
                return _.fun(k);
              }, m0 = function _(k) {
                return _.fun(k);
              }, k0 = function _(k, I) {
                return _.fun(k, I);
              }, g0 = function _(k) {
                return _.fun(k);
              }, e0 = function _(k, I) {
                return _.fun(k, I);
              }, x0 = function _(k) {
                return _.fun(k);
              }, l = function _(k, I) {
                return _.fun(k, I);
              }, c0 = function _(k) {
                return _.fun(k);
              }, t0 = function _(k, I) {
                return _.fun(k, I);
              }, o0 = function _(k, I) {
                return _.fun(k, I);
              }, w0 = function _(k, I) {
                return _.fun(k, I);
              }, _0 = function _(k) {
                return _.fun(k);
              }, E0 = function _(k) {
                return _.fun(k);
              }, U0 = function _(k, I, U) {
                return _.fun(k, I, U);
              }, b = function _(k, I) {
                return _.fun(k, I);
              }, R0 = function _(k, I) {
                return _.fun(k, I);
              }, X = function _(k) {
                return _.fun(k);
              };
              function s0(_) {
                var k = pr(_);
                Y0(_, 59);
                var I = A0(_) === 8 ? 1 : 0, U = I && we(_), Y = x4(0, 0, _), y0 = Y[0] === 0 ? Y[1] : Y[1][1];
                return [4, [0, lr([0, k], [0, on(U, y0)], 0)]];
              }
              var hr = 0;
              function Ar(_) {
                return cr(hr, s0, _);
              }
              function or(_) {
                var k = pr(_);
                Y0(_, 37);
                var I = zl(1, _), U = u(se[2], I), Y = 1 - _[5], y0 = Y && nb(U);
                y0 && M1(_, U[1]);
                var P0 = we(_);
                Y0(_, 25);
                var I0 = we(_);
                Y0(_, 4);
                var D = u(se[7], _);
                Y0(_, 5);
                var u0 = A0(_) === 8 ? 1 : 0, X0 = u0 && we(_), J0 = x4(0, K0e, _), ir = J0[0] === 0 ? on(X0, J0[1]) : J0[1][1];
                return [14, [0, U, D, lr([0, k], [0, on(P0, on(I0, ir))], 0)]];
              }
              var W0 = 0;
              function Lr(_) {
                return cr(W0, or, _);
              }
              function Tr(_, k, I) {
                var U = I[2][1];
                if (U && !U[1][2][2]) {
                  var Y = U[2];
                  if (!Y)
                    return Y;
                }
                return ue(_, [0, I[1], k]);
              }
              function Hr(_, k) {
                var I = 1 - _[5], U = I && nb(k);
                return U && M1(_, k[1]);
              }
              function Or(_) {
                var k = pr(_);
                Y0(_, 39);
                var I = _[18], U = I && xu(_, 65), Y = on(k, pr(_));
                Y0(_, 4);
                var y0 = lr([0, Y], 0, 0), P0 = Kl(1, _), I0 = A0(P0), D = 0;
                if (typeof I0 == "number")
                  if (24 <= I0)
                    if (29 <= I0)
                      D = 1;
                    else
                      switch (I0 - 24 | 0) {
                        case 0:
                          var u0 = cr(0, Vn[9], P0), X0 = u0[2], J0 = lr([0, X0[2]], 0, 0), Pr = X0[3], K0 = [0, [1, [0, u0[1], [0, X0[1], 0, J0]]]];
                          break;
                        case 3:
                          var ir = cr(0, Vn[8], P0), Q0 = ir[2], F0 = lr([0, Q0[2]], 0, 0), Pr = Q0[3], K0 = [0, [1, [0, ir[1], [0, Q0[1], 2, F0]]]];
                          break;
                        case 4:
                          var Sr = cr(0, Vn[7], P0), mr = Sr[2], Cr = lr([0, mr[2]], 0, 0), Pr = mr[3], K0 = [0, [1, [0, Sr[1], [0, mr[1], 1, Cr]]]];
                          break;
                        default:
                          D = 1;
                      }
                  else if (I0 === 8)
                    var Pr = 0, K0 = 0;
                  else
                    D = 1;
                else
                  D = 1;
                if (D)
                  var sr = F9(1, P0), Pr = 0, K0 = [0, [0, u(se[8], sr)]];
                var Ur = A0(_);
                if (typeof Ur == "number") {
                  if (Ur === 17) {
                    if (K0) {
                      var h0 = K0[1];
                      if (h0[0] === 0)
                        var Kr = [1, ur(t4[2], V0e, _, h0[1])];
                      else {
                        var re = h0[1];
                        Tr(_, 28, re);
                        var Kr = [0, re];
                      }
                      U ? Y0(_, 63) : Y0(_, 17);
                      var xe = u(se[7], _);
                      Y0(_, 5);
                      var Re = zl(1, _), ve = u(se[2], Re);
                      return Hr(_, ve), [21, [0, Kr, xe, ve, 0, y0]];
                    }
                    throw [0, Sn, z0e];
                  }
                  if (Ur === 63) {
                    if (K0) {
                      var Ie = K0[1];
                      if (Ie[0] === 0)
                        var Ge = [1, ur(t4[2], X0e, _, Ie[1])];
                      else {
                        var Me = Ie[1];
                        Tr(_, 29, Me);
                        var Ge = [0, Me];
                      }
                      Y0(_, 63);
                      var an = u(se[10], _);
                      Y0(_, 5);
                      var We = zl(1, _), Ae = u(se[2], We);
                      return Hr(_, Ae), [22, [0, Ge, an, Ae, U, y0]];
                    }
                    throw [0, Sn, Y0e];
                  }
                }
                if (Du(function(gt) {
                  return ue(_, gt);
                }, Pr), U ? Y0(_, 63) : Y0(_, 8), K0)
                  var cn = K0[1], rn = cn[0] === 0 ? [0, [1, o(t4[1], _, cn[1])]] : [0, [0, cn[1]]], kn = rn;
                else
                  var kn = K0;
                var vn = A0(_), Ne = 0;
                if (typeof vn == "number") {
                  var Je = vn !== 8 ? 1 : 0;
                  if (!Je) {
                    var en = Je;
                    Ne = 1;
                  }
                }
                if (!Ne)
                  var en = [0, u(se[7], _)];
                Y0(_, 8);
                var _n = A0(_), Cn = 0;
                if (typeof _n == "number") {
                  var Hn = _n !== 5 ? 1 : 0;
                  if (!Hn) {
                    var Fn = Hn;
                    Cn = 1;
                  }
                }
                if (!Cn)
                  var Fn = [0, u(se[7], _)];
                Y0(_, 5);
                var vt = zl(1, _), Nt = u(se[2], vt);
                return Hr(_, Nt), [20, [0, kn, en, Fn, Nt, y0]];
              }
              var fr = 0;
              function Rr(_) {
                return cr(fr, Or, _);
              }
              function Wr(_) {
                var k = Gs(_) ? n(_) : u(se[2], _), I = 1 - _[5], U = I && nb(k);
                return U && M1(_, k[1]), k;
              }
              function Jr(_) {
                var k = pr(_);
                Y0(_, 43);
                var I = Wr(_);
                return [0, I, lr([0, k], 0, 0)];
              }
              function ar(_) {
                var k = pr(_);
                Y0(_, 16);
                var I = on(k, pr(_));
                Y0(_, 4);
                var U = u(se[7], _);
                Y0(_, 5);
                var Y = Wr(_), y0 = A0(_) === 43 ? 1 : 0, P0 = y0 && [0, cr(0, Jr, _)];
                return [24, [0, U, Y, P0, lr([0, I], 0, 0)]];
              }
              var _r = 0;
              function Ir(_) {
                return cr(_r, ar, _);
              }
              function fe(_) {
                1 - _[11] && je(_, 36);
                var k = pr(_), I = Pe(_);
                Y0(_, 19);
                var U = A0(_) === 8 ? 1 : 0, Y = U && we(_), y0 = 0;
                if (A0(_) !== 8 && !x2(_)) {
                  var P0 = [0, u(se[7], _)];
                  y0 = 1;
                }
                if (!y0)
                  var P0 = 0;
                var I0 = yt(I, Pe(_)), D = x4(0, 0, _), u0 = 0;
                if (D[0] === 0)
                  var X0 = D[1];
                else {
                  var J0 = D[1];
                  if (P0) {
                    var ir = function(sr, Pr) {
                      return o(Qe(sr, Di, 90), sr, Pr);
                    }, Q0 = [0, o(J0[2], P0[1], ir)], F0 = Y;
                    u0 = 1;
                  } else
                    var X0 = J0[1];
                }
                if (!u0)
                  var Q0 = P0, F0 = on(Y, X0);
                return [28, [0, Q0, lr([0, k], [0, F0], 0), I0]];
              }
              var v0 = 0;
              function P(_) {
                return cr(v0, fe, _);
              }
              function L(_) {
                var k = pr(_);
                Y0(_, 20), Y0(_, 4);
                var I = u(se[7], _);
                Y0(_, 5), Y0(_, 0);
                for (var U = H0e; ; ) {
                  var Y = U[2], y0 = A0(_);
                  if (typeof y0 == "number") {
                    var P0 = 0;
                    if ((y0 === 1 || Pn === y0) && (P0 = 1), P0) {
                      var I0 = ye(Y);
                      Y0(_, 1);
                      var D = c(_), u0 = I[1];
                      return [29, [0, I, I0, lr([0, k], [0, D[1]], 0), u0]];
                    }
                  }
                  var X0 = U[1], J0 = gL(0, function(Q0) {
                    return function(F0) {
                      var Sr = pr(F0), mr = A0(F0), Cr = 0;
                      if (typeof mr == "number" && mr === 36) {
                        Q0 && je(F0, 32), Y0(F0, 36);
                        var sr = we(F0), Pr = 0;
                        Cr = 1;
                      }
                      if (!Cr) {
                        Y0(F0, 33);
                        var sr = 0, Pr = [0, u(se[7], F0)];
                      }
                      var K0 = Q0 || (Pr === 0 ? 1 : 0);
                      Y0(F0, 86);
                      var Ur = on(sr, c(F0)[1]);
                      function h0(Re) {
                        if (typeof Re == "number") {
                          var ve = Re - 1 | 0, Ie = 0;
                          if (32 < ve >>> 0 ? ve === 35 && (Ie = 1) : 30 < (ve - 1 | 0) >>> 0 && (Ie = 1), Ie)
                            return 1;
                        }
                        return 0;
                      }
                      var Kr = 1, re = F0[9] === 1 ? F0 : [0, F0[1], F0[2], F0[3], F0[4], F0[5], F0[6], F0[7], F0[8], Kr, F0[10], F0[11], F0[12], F0[13], F0[14], F0[15], F0[16], F0[17], F0[18], F0[19], F0[20], F0[21], F0[22], F0[23], F0[24], F0[25], F0[26], F0[27], F0[28], F0[29], F0[30]], xe = o(se[4], h0, re);
                      return [0, [0, Pr, xe, lr([0, Sr], [0, Ur], 0)], K0];
                    };
                  }(X0), _), U = [0, J0[2], [0, J0[1], Y]];
                }
              }
              var Q = 0;
              function i0(_) {
                return cr(Q, L, _);
              }
              function l0(_) {
                var k = pr(_), I = Pe(_);
                Y0(_, 22), x7(_) && ue(_, [0, I, 21]);
                var U = u(se[7], _), Y = x4(0, 0, _);
                if (Y[0] === 0)
                  var P0 = U, I0 = Y[1];
                else
                  var y0 = function(D, u0) {
                    return o(Qe(D, Di, 91), D, u0);
                  }, P0 = o(Y[1][2], U, y0), I0 = 0;
                return [30, [0, P0, lr([0, k], [0, I0], 0)]];
              }
              var S0 = 0;
              function T0(_) {
                return cr(S0, l0, _);
              }
              function rr(_) {
                var k = pr(_);
                Y0(_, 23);
                var I = u(se[15], _);
                if (A0(_) === 34)
                  var U = $t(_), Y = function(sr, Pr) {
                    var K0 = Pr[1];
                    return [0, K0, ur(Qe(sr, Y8, 29), sr, K0, Pr[2])];
                  }, y0 = o(U[2], I, Y);
                else
                  var y0 = I;
                var P0 = A0(_), I0 = 0;
                if (typeof P0 == "number" && P0 === 34) {
                  var D = [0, cr(0, function(Pr) {
                    var K0 = pr(Pr);
                    Y0(Pr, 34);
                    var Ur = we(Pr), h0 = A0(Pr) === 4 ? 1 : 0;
                    if (h0) {
                      Y0(Pr, 4);
                      var Kr = [0, o(se[18], Pr, 39)];
                      Y0(Pr, 5);
                      var re = Kr;
                    } else
                      var re = h0;
                    var xe = u(se[15], Pr);
                    if (A0(Pr) === 38)
                      var Ie = xe;
                    else
                      var Re = c(Pr), ve = function(Ge, Me) {
                        var an = Me[1];
                        return [0, an, ur(Qe(Ge, Y8, 92), Ge, an, Me[2])];
                      }, Ie = o(Re[2], xe, ve);
                    return [0, re, Ie, lr([0, K0], [0, Ur], 0)];
                  }, _)];
                  I0 = 1;
                }
                if (!I0)
                  var D = 0;
                var u0 = A0(_), X0 = 0;
                if (typeof u0 == "number" && u0 === 38) {
                  Y0(_, 38);
                  var J0 = u(se[15], _), ir = J0[1], Q0 = c(_), F0 = function(Pr, K0) {
                    return ur(Qe(Pr, Y8, 93), Pr, ir, K0);
                  }, Sr = [0, [0, ir, o(Q0[2], J0[2], F0)]];
                  X0 = 1;
                }
                if (!X0)
                  var Sr = 0;
                var mr = D === 0 ? 1 : 0, Cr = mr && (Sr === 0 ? 1 : 0);
                return Cr && ue(_, [0, y0[1], 33]), [31, [0, y0, D, Sr, lr([0, k], 0, 0)]];
              }
              var L0 = 0;
              function B(_) {
                return cr(L0, rr, _);
              }
              function Z7(_) {
                var k = u(Vn[9], _), I = s2(0, _, k[1]), U = 0, Y = k[3];
                Du(function(P0) {
                  return ue(_, P0);
                }, Y);
                var y0 = lr([0, k[2]], [0, I[1]], 0);
                return [34, [0, I[2], U, y0]];
              }
              var p0 = 0;
              function b0(_) {
                return cr(p0, Z7, _);
              }
              function O0(_) {
                var k = u(Vn[8], _), I = s2(2, _, k[1]), U = 2, Y = k[3];
                Du(function(P0) {
                  return ue(_, P0);
                }, Y);
                var y0 = lr([0, k[2]], [0, I[1]], 0);
                return [34, [0, I[2], U, y0]];
              }
              var M0 = 0;
              function er(_) {
                return cr(M0, O0, _);
              }
              function yr(_) {
                var k = u(Vn[7], _), I = s2(1, _, k[1]), U = 1, Y = k[3];
                Du(function(P0) {
                  return ue(_, P0);
                }, Y);
                var y0 = lr([0, k[2]], [0, I[1]], 0);
                return [34, [0, I[2], U, y0]];
              }
              var vr = 0;
              function $0(_) {
                return cr(vr, yr, _);
              }
              function Er(_) {
                var k = pr(_);
                Y0(_, 25);
                var I = on(k, pr(_));
                Y0(_, 4);
                var U = u(se[7], _);
                Y0(_, 5);
                var Y = zl(1, _), y0 = u(se[2], Y), P0 = 1 - _[5], I0 = P0 && nb(y0);
                return I0 && M1(_, y0[1]), [35, [0, U, y0, lr([0, I], 0, 0)]];
              }
              var Mr = 0;
              function Br(_) {
                return cr(Mr, Er, _);
              }
              function qr(_) {
                var k = pr(_), I = u(se[7], _), U = A0(_), Y = I[2];
                if (Y[0] === 10 && typeof U == "number" && U === 86) {
                  var y0 = Y[1], P0 = y0[2][1];
                  Y0(_, 86), o(Mu[3], P0, _[3]) && ue(_, [0, I[1], [16, q0e, P0]]);
                  var I0 = _[30], D = _[29], u0 = _[28], X0 = _[27], J0 = _[26], ir = _[25], Q0 = _[24], F0 = _[23], Sr = _[22], mr = _[21], Cr = _[20], sr = _[19], Pr = _[18], K0 = _[17], Ur = _[16], h0 = _[15], Kr = _[14], re = _[13], xe = _[12], Re = _[11], ve = _[10], Ie = _[9], Ge = _[8], Me = _[7], an = _[6], We = _[5], Ae = _[4], cn = o(Mu[4], P0, _[3]), rn = [0, _[1], _[2], cn, Ae, We, an, Me, Ge, Ie, ve, Re, xe, re, Kr, h0, Ur, K0, Pr, sr, Cr, mr, Sr, F0, Q0, ir, J0, X0, u0, D, I0], kn = Gs(rn) ? n(rn) : u(se[2], rn);
                  return [27, [0, y0, kn, lr([0, k], 0, 0)]];
                }
                var vn = x4(U0e, 0, _);
                if (vn[0] === 0)
                  var Je = I, en = vn[1];
                else
                  var Ne = function(_n, Cn) {
                    return o(Qe(_n, Di, 94), _n, Cn);
                  }, Je = o(vn[1][2], I, Ne), en = 0;
                return [19, [0, Je, 0, lr(0, [0, en], 0)]];
              }
              var jr = 0;
              function $r(_) {
                return cr(jr, qr, _);
              }
              function ne(_) {
                var k = u(se[7], _), I = x4(B0e, 0, _);
                if (I[0] === 0)
                  var Y = k, y0 = I[1];
                else
                  var U = function(sr, Pr) {
                    return o(Qe(sr, Di, 95), sr, Pr);
                  }, Y = o(I[1][2], k, U), y0 = 0;
                var P0 = _[19];
                if (P0) {
                  var I0 = Y[2], D = 0;
                  if (I0[0] === 14) {
                    var u0 = I0[1], X0 = 0, J0 = u0[1];
                    if (typeof J0 != "number" && J0[0] === 0) {
                      var ir = u0[2], Q0 = 1 < un(ir) ? 1 : 0;
                      if (Q0)
                        var F0 = It(ir, un(ir) - 1 | 0), Sr = It(ir, 0) === F0 ? 1 : 0;
                      else
                        var Sr = Q0;
                      var mr = Sr && [0, m7(ir, 1, un(ir) - 2 | 0)], Cr = mr;
                      X0 = 1;
                    }
                    X0 || (D = 1);
                  } else
                    D = 1;
                  if (D)
                    var Cr = 0;
                } else
                  var Cr = P0;
                return [19, [0, Y, Cr, lr(0, [0, y0], 0)]];
              }
              var Qr = 0;
              function be(_) {
                return cr(Qr, ne, _);
              }
              function ae(_) {
                var k = A0(_), I = 0;
                if (typeof k != "number" && k[0] === 4 && !n0(k[3], R0e)) {
                  ie(_);
                  var U = A0(_);
                  if (typeof U != "number" && U[0] === 2)
                    return i4(_, U[1]);
                  St(j0e, _), I = 1;
                }
                return I || St(G0e, _), [0, j1(_), M0e];
              }
              function pe(_, k, I) {
                function U(D) {
                  return _ ? u(mn[2], D) : o(se[13], 0, D);
                }
                var Y = Yn(1, I);
                if (typeof Y == "number")
                  switch (Y) {
                    case 1:
                    case 9:
                    case 113:
                      return [0, U(I), 0];
                  }
                else if (Y[0] === 4 && !n0(Y[3], L0e)) {
                  var y0 = z7(I);
                  return ie(I), [0, y0, [0, U(I)]];
                }
                var P0 = A0(I);
                if (k && typeof P0 == "number") {
                  var I0 = 0;
                  if ((P0 === 46 || P0 === 61) && (I0 = 1), I0)
                    return je(I, k[1]), ie(I), [0, u(mn[2], I), 0];
                }
                return [0, U(I), 0];
              }
              function oe(_, k) {
                var I = A0(_);
                if (typeof I == "number" && Yt === I) {
                  var U = cr(0, function(Ae) {
                    ie(Ae);
                    var cn = A0(Ae);
                    return typeof cn != "number" && cn[0] === 4 && !n0(cn[3], P0e) ? (ie(Ae), 2 <= k ? [0, o(se[13], 0, Ae)] : [0, u(mn[2], Ae)]) : (St(D0e, Ae), 0);
                  }, _), Y = U[2], y0 = Y && [0, [0, U[1], Y[1]]], P0 = y0 && [0, [1, y0[1]]];
                  return P0;
                }
                Y0(_, 0);
                for (var I0 = 0, D = 0; ; ) {
                  var u0 = I0 ? I0[1] : 1, X0 = A0(_);
                  if (typeof X0 == "number") {
                    var J0 = 0;
                    if ((X0 === 1 || Pn === X0) && (J0 = 1), J0) {
                      var ir = ye(D);
                      return Y0(_, 1), [0, [0, ir]];
                    }
                  }
                  if (1 - u0 && je(_, 84), k === 2) {
                    var Q0 = A0(_), F0 = 0;
                    if (typeof Q0 == "number")
                      if (Q0 === 46)
                        var Sr = I0e;
                      else if (Q0 === 61)
                        var Sr = O0e;
                      else
                        F0 = 1;
                    else
                      F0 = 1;
                    if (F0)
                      var Sr = 0;
                    var mr = A0(_), Cr = 0;
                    if (typeof mr == "number") {
                      var sr = 0;
                      if (mr !== 46 && mr !== 61 && (sr = 1), !sr) {
                        var Pr = 1;
                        Cr = 1;
                      }
                    }
                    if (!Cr)
                      var Pr = 0;
                    if (Pr) {
                      var K0 = z7(_), Ur = A0(_), h0 = 0;
                      if (typeof Ur == "number")
                        switch (Ur) {
                          case 1:
                          case 9:
                          case 113:
                            e4(0, _, K0);
                            var Ie = [0, 0, 0, K0];
                            h0 = 1;
                            break;
                        }
                      else if (Ur[0] === 4 && !n0(Ur[3], A0e)) {
                        var Kr = Yn(1, _), re = 0;
                        if (typeof Kr == "number")
                          switch (Kr) {
                            case 1:
                            case 9:
                            case 113:
                              var xe = [0, Sr, 0, u(mn[2], _)];
                              re = 1;
                              break;
                          }
                        else if (Kr[0] === 4 && !n0(Kr[3], N0e)) {
                          var Re = z7(_);
                          ie(_);
                          var xe = [0, Sr, [0, u(mn[2], _)], Re];
                          re = 1;
                        }
                        if (!re) {
                          e4(0, _, K0), ie(_);
                          var xe = [0, 0, [0, o(se[13], 0, _)], K0];
                        }
                        var Ie = xe;
                        h0 = 1;
                      }
                      if (!h0)
                        var ve = pe(1, 0, _), Ie = [0, Sr, ve[2], ve[1]];
                      var Me = Ie;
                    } else
                      var Ge = pe(0, 0, _), Me = [0, 0, Ge[2], Ge[1]];
                    var We = Me;
                  } else
                    var an = pe(1, T0e, _), We = [0, 0, an[2], an[1]];
                  var I0 = [0, xu(_, 9)], D = [0, We, D];
                }
              }
              function ce(_, k) {
                var I = x4(0, 0, _);
                if (I[0] === 0)
                  return [0, I[1], k];
                function U(Y, y0) {
                  var P0 = y0[1];
                  return [0, P0, ur(Qe(Y, hA, 96), Y, P0, y0[2])];
                }
                return [0, 0, o(I[1][2], k, U)];
              }
              function ge(_) {
                var k = _s(1, _), I = pr(k);
                Y0(k, 50);
                var U = A0(k), Y = 0;
                if (typeof U == "number")
                  switch (U) {
                    case 46:
                      if (fu(k)) {
                        Y0(k, 46);
                        var y0 = A0(k), P0 = 0;
                        if (typeof y0 == "number") {
                          var I0 = 0;
                          if (Yt !== y0 && y0 && (I0 = 1), !I0) {
                            var J0 = 1;
                            Y = 2, P0 = 1;
                          }
                        }
                        if (!P0) {
                          var D = 1;
                          Y = 1;
                        }
                      }
                      break;
                    case 61:
                      if (fu(k)) {
                        var u0 = Yn(1, k), X0 = 0;
                        if (typeof u0 == "number")
                          switch (u0) {
                            case 0:
                              ie(k);
                              var J0 = 0;
                              Y = 2, X0 = 2;
                              break;
                            case 106:
                              ie(k), St(0, k);
                              var J0 = 0;
                              Y = 2, X0 = 2;
                              break;
                            case 9:
                              X0 = 1;
                              break;
                          }
                        else
                          u0[0] === 4 && !n0(u0[3], C0e) && (X0 = 1);
                        switch (X0) {
                          case 2:
                            break;
                          case 0:
                            ie(k);
                            var D = 0;
                            Y = 1;
                            break;
                          default:
                            var D = 2;
                            Y = 1;
                        }
                      }
                      break;
                    case 0:
                    case 106:
                      var J0 = 2;
                      Y = 2;
                      break;
                  }
                else if (U[0] === 2) {
                  var ir = ce(k, i4(k, U[1])), Q0 = lr([0, I], [0, ir[1]], 0);
                  return [25, [0, 2, ir[2], 0, 0, Q0]];
                }
                switch (Y) {
                  case 0:
                    var D = 2;
                    break;
                  case 1:
                    break;
                  default:
                    var F0 = oe(k, J0), Sr = ce(k, ae(k)), mr = lr([0, I], [0, Sr[1]], 0);
                    return [25, [0, J0, Sr[2], 0, F0, mr]];
                }
                var Cr = 2 <= D ? o(se[13], 0, k) : u(mn[2], k), sr = A0(k), Pr = 0;
                if (typeof sr == "number" && sr === 9) {
                  Y0(k, 9);
                  var K0 = oe(k, D);
                  Pr = 1;
                }
                if (!Pr)
                  var K0 = 0;
                var Ur = ce(k, ae(k)), h0 = lr([0, I], [0, Ur[1]], 0);
                return [25, [0, D, Ur[2], [0, Cr], K0, h0]];
              }
              var q0 = 0;
              function Fr(_) {
                return cr(q0, ge, _);
              }
              return N(p, function(_) {
                var k = Pe(_), I = pr(_);
                return Y0(_, 8), [0, k, [15, [0, lr([0, I], [0, c(_)[1]], 0)]]];
              }), N(y, function(_) {
                var k = pr(_), I = cr(0, function(X0) {
                  Y0(X0, 32);
                  var J0 = 0;
                  if (A0(X0) !== 8 && !x2(X0)) {
                    var ir = o(se[13], 0, X0), Q0 = ir[2][1];
                    1 - o(Mu[3], Q0, X0[3]) && je(X0, [15, Q0]);
                    var F0 = [0, ir];
                    J0 = 1;
                  }
                  if (!J0)
                    var F0 = 0;
                  var Sr = x4(0, 0, X0), mr = 0;
                  if (Sr[0] === 0)
                    var Cr = Sr[1];
                  else {
                    var sr = Sr[1];
                    if (F0) {
                      var Pr = function(xe, Re) {
                        return o(Qe(xe, Nv, 97), xe, Re);
                      }, K0 = [0, o(sr[2], F0[1], Pr)], Ur = 0;
                      mr = 1;
                    } else
                      var Cr = sr[1];
                  }
                  if (!mr)
                    var K0 = F0, Ur = Cr;
                  return [0, K0, Ur];
                }, _), U = I[2], Y = U[1], y0 = I[1], P0 = Y === 0 ? 1 : 0;
                if (P0)
                  var I0 = _[8], D = I0 || _[9], u0 = 1 - D;
                else
                  var u0 = P0;
                return u0 && ue(_, [0, y0, 35]), [0, y0, [1, [0, Y, lr([0, k], [0, U[2]], 0)]]];
              }), N(T, function(_) {
                var k = pr(_), I = cr(0, function(P0) {
                  Y0(P0, 35);
                  var I0 = 0;
                  if (A0(P0) !== 8 && !x2(P0)) {
                    var D = o(se[13], 0, P0), u0 = D[2][1];
                    1 - o(Mu[3], u0, P0[3]) && je(P0, [15, u0]);
                    var X0 = [0, D];
                    I0 = 1;
                  }
                  if (!I0)
                    var X0 = 0;
                  var J0 = x4(0, 0, P0), ir = 0;
                  if (J0[0] === 0)
                    var Q0 = J0[1];
                  else {
                    var F0 = J0[1];
                    if (X0) {
                      var Sr = function(Ur, h0) {
                        return o(Qe(Ur, Nv, 98), Ur, h0);
                      }, mr = [0, o(F0[2], X0[1], Sr)], Cr = 0;
                      ir = 1;
                    } else
                      var Q0 = F0[1];
                  }
                  if (!ir)
                    var mr = X0, Cr = Q0;
                  return [0, mr, Cr];
                }, _), U = I[2], Y = I[1];
                1 - _[8] && ue(_, [0, Y, 34]);
                var y0 = lr([0, k], [0, U[2]], 0);
                return [0, Y, [3, [0, U[1], y0]]];
              }), N(E, function(_) {
                var k = cr(0, function(U) {
                  var Y = pr(U);
                  Y0(U, 26);
                  var y0 = on(Y, pr(U));
                  Y0(U, 4);
                  var P0 = u(se[7], U);
                  Y0(U, 5);
                  var I0 = u(se[2], U), D = 1 - U[5], u0 = D && nb(I0);
                  return u0 && M1(U, I0[1]), [36, [0, P0, I0, lr([0, y0], 0, 0)]];
                }, _), I = k[1];
                return V7(_, [0, I, 38]), [0, I, k[2]];
              }), N(d, function(_) {
                var k = u(se[15], _), I = k[1], U = c(_);
                function Y(y0, P0) {
                  return ur(Qe(y0, Y8, 99), y0, I, P0);
                }
                return [0, I, [0, o(U[2], k[2], Y)]];
              }), N(w, function(_, k) {
                1 - fu(k) && je(k, 10);
                var I = on(_, pr(k));
                Y0(k, 61), Ku(k, 1);
                var U = u(mn[2], k), Y = A0(k) === 98 ? ys(k, U) : U, y0 = u(mn[3], k);
                Y0(k, 82);
                var P0 = u(mn[1], k);
                k7(k);
                var I0 = x4(0, 0, k);
                if (I0[0] === 0)
                  var u0 = P0, X0 = I0[1];
                else
                  var D = function(J0, ir) {
                    return o(Qe(J0, _v, ti), J0, ir);
                  }, u0 = o(I0[1][2], P0, D), X0 = 0;
                return [0, Y, y0, u0, lr([0, I], [0, X0], 0)];
              }), N(G, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [11, o(w, I, k)];
                }, _);
              }), N(A11, function(_) {
                if (I9(1, _) && !se0(1, _)) {
                  var k = cr(0, u(w, 0), _);
                  return [0, k[1], [32, k[2]]];
                }
                return u(se[2], _);
              }), N(S11, function(_, k, I) {
                var U = _ && _[1];
                1 - fu(I) && je(I, 11);
                var Y = on(k, pr(I));
                Y0(I, 62);
                var y0 = pr(I);
                Y0(I, 61);
                var P0 = on(Y, y0);
                Ku(I, 1);
                var I0 = u(mn[2], I), D = A0(I) === 98 ? ys(I, I0) : I0, u0 = u(mn[3], I), X0 = A0(I), J0 = 0;
                if (typeof X0 == "number" && X0 === 86) {
                  Y0(I, 86);
                  var ir = [0, u(mn[1], I)];
                  J0 = 1;
                }
                if (!J0)
                  var ir = 0;
                if (U) {
                  var Q0 = A0(I), F0 = 0;
                  if (typeof Q0 == "number" && Q0 === 82) {
                    je(I, 70), ie(I);
                    var Sr = 0;
                    if (A0(I) !== 8 && !x2(I)) {
                      var mr = [0, u(mn[1], I)];
                      Sr = 1;
                    }
                    if (!Sr)
                      var mr = 0;
                  } else
                    F0 = 1;
                  if (F0)
                    var mr = 0;
                  var Cr = mr;
                } else {
                  Y0(I, 82);
                  var Cr = [0, u(mn[1], I)];
                }
                k7(I);
                var sr = x4(0, 0, I);
                if (sr[0] === 0)
                  var Pr = Cr, K0 = ir, Ur = u0, h0 = D, Kr = sr[1];
                else {
                  var re = sr[1][2];
                  if (Cr)
                    var xe = function(en, _n) {
                      return o(Qe(en, _v, R7), en, _n);
                    }, Pr = [0, o(re, Cr[1], xe)], K0 = ir, Ur = u0, h0 = D, Kr = 0;
                  else if (ir)
                    var Re = 0, ve = function(en, _n) {
                      return o(Qe(en, _v, Ri), en, _n);
                    }, Pr = Re, K0 = [0, o(re, ir[1], ve)], Ur = u0, h0 = D, Kr = 0;
                  else if (u0)
                    var Ie = 0, Ge = 0, Me = function(en, _n) {
                      return o(Qe(en, bF, s7), en, _n);
                    }, Pr = Ie, K0 = Ge, Ur = [0, o(re, u0[1], Me)], h0 = D, Kr = 0;
                  else
                    var an = 0, We = 0, Ae = 0, Pr = an, K0 = We, Ur = Ae, cn = 0, h0 = o(re, D, function(en, _n) {
                      return o(Qe(en, Nv, L7), en, _n);
                    }), Kr = cn;
                }
                return [0, h0, Ur, Pr, K0, lr([0, P0], [0, Kr], 0)];
              }), N(M, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [12, ur(S11, F0e, I, k)];
                }, _);
              }), N(K, function(_) {
                var k = Yn(1, _);
                if (typeof k == "number" && k === 61) {
                  var I = cr(0, o(S11, g0e, 0), _);
                  return [0, I[1], [33, I[2]]];
                }
                return u(se[2], _);
              }), N(V, function(_, k) {
                1 - fu(k) && je(k, 16);
                var I = on(_, pr(k));
                Y0(k, 53);
                var U = u(mn[2], k), Y = A0(k) === 41 ? U : ys(k, U), y0 = u(mn[3], k), P0 = A0(k) === 41 ? y0 : oi(k, y0), I0 = u(mn[7], k), D = c(k);
                function u0(ir, Q0) {
                  var F0 = Q0[1];
                  return [0, F0, ur(Qe(ir, qH, j7), ir, F0, Q0[2])];
                }
                var X0 = o(D[2], I0[2], u0), J0 = lr([0, I], 0, 0);
                return [0, Y, P0, I0[1], X0, J0];
              }), N(f0, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [8, o(V, I, k)];
                }, _);
              }), N(m0, function(_) {
                var k = I9(1, _), I = 1, U = k || ve0(I, _);
                if (U) {
                  var Y = cr(0, u(V, 0), _);
                  return [0, Y[1], [26, Y[2]]];
                }
                return be(_);
              }), N(k0, function(_, k) {
                var I = _s(1, k), U = on(_, pr(I));
                Y0(I, 40);
                var Y = o(se[13], 0, I), y0 = A0(I), P0 = 0;
                if (typeof y0 == "number") {
                  var I0 = 0;
                  if (y0 !== 98 && y0 && (I0 = 1), !I0) {
                    var D = ys(I, Y);
                    P0 = 1;
                  }
                }
                if (!P0)
                  var D = Y;
                var u0 = u(mn[3], I), X0 = A0(I), J0 = 0;
                if (typeof X0 == "number" && !X0) {
                  var ir = oi(I, u0);
                  J0 = 1;
                }
                if (!J0)
                  var ir = u0;
                var Q0 = xu(I, 41);
                if (Q0) {
                  var F0 = u(mn[5], I), Sr = A0(I), mr = 0;
                  if (typeof Sr == "number" && !Sr) {
                    var Cr = $t(I), sr = function(Fn, vt) {
                      return _u(u(Qe(Fn, ZU, 36), Fn), vt);
                    }, Pr = [0, o(Cr[2], F0, sr)];
                    mr = 1;
                  }
                  if (!mr)
                    var Pr = [0, F0];
                  var K0 = Pr;
                } else
                  var K0 = Q0;
                var Ur = A0(I), h0 = 0;
                if (typeof Ur != "number" && Ur[0] === 4 && !n0(Ur[3], S0e)) {
                  ie(I);
                  for (var Kr = 0; ; ) {
                    var re = [0, u(mn[5], I), Kr], xe = A0(I);
                    if (typeof xe == "number" && xe === 9) {
                      Y0(I, 9);
                      var Kr = re;
                      continue;
                    }
                    var Re = ye(re), ve = A0(I), Ie = 0;
                    if (typeof ve == "number" && !ve) {
                      var Ge = de0(I, Re);
                      Ie = 1;
                    }
                    if (!Ie)
                      var Ge = Re;
                    var Me = Ge;
                    h0 = 1;
                    break;
                  }
                }
                if (!h0)
                  var Me = 0;
                var an = A0(I), We = 0;
                if (typeof an == "number" && an === 52) {
                  var Ae = o(Us[5], I, 0), cn = A0(I), rn = 0;
                  if (typeof cn == "number" && !cn) {
                    var kn = [0, ke0(I, Ae)];
                    rn = 1;
                  }
                  if (!rn)
                    var kn = [0, Ae];
                  var vn = kn;
                  We = 1;
                }
                if (!We)
                  var vn = 0;
                var Ne = o(mn[6], 1, I), Je = c(I);
                function en(Cn, Hn) {
                  var Fn = Hn[1];
                  return [0, Fn, ur(Qe(Cn, qH, Yt), Cn, Fn, Hn[2])];
                }
                var _n = o(Je[2], Ne, en);
                return [0, D, ir, _n, K0, Me, vn, lr([0, U], 0, 0)];
              }), N(g0, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [5, o(k0, I, k)];
                }, _);
              }), N(e0, function(_, k) {
                var I = _ && _[1], U = on(I, pr(k));
                Y0(k, 15);
                var Y = ys(k, o(se[13], 0, k)), y0 = cr(0, function(mr) {
                  var Cr = oi(mr, u(mn[3], mr)), sr = u(mn[8], mr);
                  Y0(mr, 86);
                  var Pr = u(mn[1], mr);
                  Ku(mr, 1);
                  var K0 = A0(mr);
                  if (k7(mr), K0 === 66)
                    var Ur = $t(mr), h0 = function(re, xe) {
                      return o(Qe(re, _v, 31), re, xe);
                    }, Kr = o(Ur[2], Pr, h0);
                  else
                    var Kr = Pr;
                  return [12, [0, Cr, sr, Kr, 0]];
                }, k), P0 = u(mn[11], k), I0 = x4(0, 0, k);
                if (I0[0] === 0)
                  var D = P0, u0 = y0, X0 = I0[1];
                else {
                  var J0 = I0[1][2];
                  if (P0)
                    var ir = function(Pr, K0) {
                      return o(Qe(Pr, kH, Zc), Pr, K0);
                    }, D = [0, o(J0, P0[1], ir)], u0 = y0, X0 = 0;
                  else
                    var Q0 = 0, D = Q0, F0 = 0, u0 = o(J0, y0, function(Pr, K0) {
                      return o(Qe(Pr, _v, is), Pr, K0);
                    }), X0 = F0;
                }
                var Sr = [0, u0[1], u0];
                return [0, Y, Sr, D, lr([0, U], [0, X0], 0)];
              }), N(x0, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  Y0(k, 60);
                  var U = A0(k), Y = 0;
                  return typeof U == "number" && U === 64 && (je(k, 67), Y0(k, 64), Y = 1), [7, o(e0, [0, I], k)];
                }, _);
              }), N(l, function(_, k) {
                var I = on(k, pr(_));
                Y0(_, 24);
                var U = o(se[13], E0e, _), Y = u(mn[9], _), y0 = x4(0, 0, _);
                if (y0[0] === 0)
                  var I0 = Y, D = y0[1];
                else
                  var P0 = function(u0, X0) {
                    return o(Qe(u0, OE, Fv), u0, X0);
                  }, I0 = o(y0[1][2], Y, P0), D = 0;
                return [0, U, I0, lr([0, I], [0, D], 0)];
              }), N(c0, function(_) {
                return cr(0, function(k) {
                  var I = pr(k);
                  return Y0(k, 60), [13, o(l, k, I)];
                }, _);
              }), N(t0, function(_, k) {
                var I = Pe(k), U = pr(k);
                Y0(k, 60);
                var Y = on(U, pr(k));
                return Zl(k, w0e), !_ && A0(k) !== 10 ? cr([0, I], function(y0) {
                  var P0 = A0(y0), I0 = 0;
                  if (typeof P0 != "number" && P0[0] === 2) {
                    var D = i4(y0, P0[1]), u0 = $t(y0), X0 = function(Cr, sr) {
                      var Pr = sr[1];
                      return [0, Pr, ur(Qe(Cr, hA, 39), Cr, Pr, sr[2])];
                    }, J0 = [1, o(u0[2], D, X0)];
                    I0 = 1;
                  }
                  if (!I0)
                    var J0 = [0, ys(y0, o(se[13], 0, y0))];
                  var ir = gL(0, function(mr) {
                    var Cr = pr(mr);
                    Y0(mr, 0);
                    for (var sr = 0, Pr = 0; ; ) {
                      var K0 = A0(mr);
                      if (typeof K0 == "number") {
                        var Ur = 0;
                        if ((K0 === 1 || Pn === K0) && (Ur = 1), Ur) {
                          var h0 = ye(Pr), Kr = h0 === 0 ? 1 : 0, re = Kr && pr(mr);
                          return Y0(mr, 1), [0, [0, h0, yu([0, Cr], [0, c(mr)[1]], re, 0)], sr];
                        }
                      }
                      var xe = o(w0, h0e, mr), Re = xe[2], ve = 0;
                      if (sr)
                        if (sr[1])
                          if (Re[0] === 10) {
                            je(mr, 79);
                            var Ae = sr;
                          } else
                            ve = 1;
                        else
                          switch (Re[0]) {
                            case 6:
                              var Ie = Re[1][2], Ge = 0;
                              if (Ie)
                                switch (Ie[1][0]) {
                                  case 4:
                                  case 6:
                                    Ge = 1;
                                    break;
                                }
                              Ge || je(mr, 79);
                              var Ae = sr;
                              break;
                            case 10:
                              je(mr, 78);
                              var Ae = sr;
                              break;
                            default:
                              ve = 1;
                          }
                      else
                        switch (Re[0]) {
                          case 6:
                            var Me = Re[1][2], an = 0;
                            if (Me)
                              switch (Me[1][0]) {
                                case 4:
                                case 6:
                                  var We = sr;
                                  an = 1;
                                  break;
                              }
                            if (!an)
                              var We = d0e;
                            var Ae = We;
                            break;
                          case 10:
                            var Ae = k0e;
                            break;
                          default:
                            ve = 1;
                        }
                      if (ve)
                        var Ae = sr;
                      var sr = Ae, Pr = [0, xe, Pr];
                    }
                  }, y0), Q0 = ir[2], F0 = Q0 && Q0[1], Sr = lr([0, Y], 0, 0);
                  return [9, [0, J0, ir[1], F0, Sr]];
                }, k) : cr([0, I], u(o0, Y), k);
              }), N(o0, function(_, k) {
                var I = pr(k);
                Y0(k, 10);
                var U = pr(k);
                Zl(k, y0e);
                var Y = pl([0, _, [0, I, [0, U, [0, pr(k), 0]]]]), y0 = u(mn[9], k), P0 = x4(0, 0, k);
                if (P0[0] === 0)
                  var u0 = P0[1], X0 = y0;
                else
                  var I0 = 0, D = function(J0, ir) {
                    return o(Qe(J0, OE, Xt), J0, ir);
                  }, u0 = I0, X0 = o(P0[1][2], y0, D);
                return [10, [0, X0, lr([0, Y], [0, u0], 0)]];
              }), N(w0, function(_, k) {
                var I = _ && _[1];
                1 - fu(k) && je(k, 13);
                var U = Yn(1, k);
                if (typeof U == "number")
                  switch (U) {
                    case 24:
                      return u(c0, k);
                    case 40:
                      return u(g0, k);
                    case 46:
                      if (A0(k) === 50)
                        return Fr(k);
                      break;
                    case 49:
                      if (I)
                        return o(X, [0, I], k);
                      break;
                    case 53:
                      return u(f0, k);
                    case 61:
                      var Y = A0(k);
                      return typeof Y == "number" && Y === 50 && I ? Fr(k) : u(G, k);
                    case 62:
                      return u(M, k);
                    case 15:
                    case 64:
                      return u(x0, k);
                  }
                else if (U[0] === 4 && !n0(U[3], _0e))
                  return o(t0, I, k);
                if (I) {
                  var y0 = A0(k);
                  return typeof y0 == "number" && y0 === 50 ? (je(k, 82), u(se[2], k)) : u(c0, k);
                }
                return u(se[2], k);
              }), N(_0, function(_) {
                Zl(_, b0e);
                var k = A0(_);
                if (typeof k != "number" && k[0] === 2)
                  return i4(_, k[1]);
                var I = [0, Pe(_), p0e];
                return St(m0e, _), I;
              }), N(E0, function(_) {
                var k = u(_0, _), I = k[2], U = k[1], Y = x4(0, 0, _);
                if (Y[0] === 0)
                  return [0, [0, U, I], Y[1]];
                var y0 = 0;
                function P0(I0, D) {
                  return ur(Qe(I0, hA, cf), I0, U, D);
                }
                return [0, [0, U, o(Y[1][2], I, P0)], y0];
              }), N(U0, function(_, k, I) {
                var U = _ ? _[1] : 1, Y = A0(k);
                if (typeof Y == "number") {
                  var y0 = 0;
                  if ((Y === 1 || Pn === Y) && (y0 = 1), y0)
                    return ye(I);
                }
                1 - U && je(k, 85);
                var P0 = cr(0, function(I0) {
                  var D = z7(I0), u0 = A0(I0), X0 = 0;
                  if (typeof u0 != "number" && u0[0] === 4 && !n0(u0[3], l0e)) {
                    ie(I0);
                    var J0 = [0, z7(I0)];
                    X0 = 1;
                  }
                  if (!X0)
                    var J0 = 0;
                  return [0, D, J0];
                }, k);
                return ur(U0, [0, xu(k, 9)], k, [0, P0, I]);
              }), N(b, function(_, k) {
                return Du(function(I) {
                  var U = I[2];
                  return U[2] ? 0 : e4(v0e, _, U[1]);
                }, k);
              }), N(R0, function(_, k) {
                var I = ne0(1, _s(1, k)), U = pr(I), Y = Pe(I);
                Y0(I, 49);
                var y0 = A0(I);
                if (typeof y0 == "number") {
                  if (53 <= y0) {
                    if (!(63 <= y0))
                      switch (y0 + cU | 0) {
                        case 0:
                          return cr([0, Y], function(D) {
                            1 - fu(D) && je(D, 15);
                            var u0 = cr(0, u(V, 0), D), X0 = [0, u0[1], [26, u0[2]]];
                            return [18, [0, [0, X0], 0, 0, 0, lr([0, U], 0, 0)]];
                          }, I);
                        case 8:
                          if (Yn(1, I) !== 0)
                            return cr([0, Y], function(D) {
                              1 - fu(D) && je(D, 15);
                              var u0 = Yn(1, D);
                              if (typeof u0 == "number") {
                                if (u0 === 48)
                                  return je(D, 0), Y0(D, 61), [18, [0, 0, 0, 0, 0, lr([0, U], 0, 0)]];
                                if (Yt === u0) {
                                  Y0(D, 61);
                                  var X0 = Pe(D);
                                  Y0(D, Yt);
                                  var J0 = u(E0, D), ir = lr([0, U], [0, J0[2]], 0);
                                  return [18, [0, 0, [0, [1, [0, X0, 0]]], [0, J0[1]], 0, ir]];
                                }
                              }
                              var Q0 = cr(0, u(w, 0), D), F0 = [0, Q0[1], [32, Q0[2]]];
                              return [18, [0, [0, F0], 0, 0, 0, lr([0, U], 0, 0)]];
                            }, I);
                          break;
                        case 9:
                          return cr([0, Y], function(D) {
                            var u0 = cr(0, function(J0) {
                              return u(o(S11, 0, 0), J0);
                            }, D), X0 = [0, u0[1], [33, u0[2]]];
                            return [18, [0, [0, X0], 0, 0, 0, lr([0, U], 0, 0)]];
                          }, I);
                      }
                  } else if (y0 === 36)
                    return cr([0, Y], function(D) {
                      var u0 = on(U, pr(D)), X0 = cr(0, function(Ur) {
                        return Y0(Ur, 36);
                      }, D), J0 = te0(1, D);
                      if (Gs(J0))
                        var ir = 0, Q0 = [0, u(Vn[10], J0)];
                      else if ($l(J0))
                        var ir = 0, Q0 = [0, o(Us[3], J0, _)];
                      else if (A0(J0) === 48)
                        var ir = 0, Q0 = [0, u(Vn[11], J0)];
                      else {
                        var F0 = u(se[10], J0), Sr = x4(0, 0, J0);
                        if (Sr[0] === 0)
                          var sr = Sr[1], Pr = F0;
                        else
                          var mr = 0, Cr = function(Kr, re) {
                            return o(Qe(Kr, Di, T7), Kr, re);
                          }, sr = mr, Pr = o(Sr[1][2], F0, Cr);
                        var ir = sr, Q0 = [1, Pr];
                      }
                      var K0 = lr([0, u0], [0, ir], 0);
                      return [17, [0, X0[1], Q0, K0]];
                    }, I);
                }
                if ($l(I))
                  return cr([0, Y], function(D) {
                    var u0 = o(Us[3], D, _);
                    return [18, [0, [0, u0], 0, 0, 1, lr([0, U], 0, 0)]];
                  }, I);
                if (Gs(I))
                  return cr([0, Y], function(D) {
                    u(A9(D), _);
                    var u0 = u(Vn[10], D);
                    return [18, [0, [0, u0], 0, 0, 1, lr([0, U], 0, 0)]];
                  }, I);
                if (typeof y0 == "number")
                  if (29 <= y0) {
                    if (y0 === 48) {
                      if (I[27][1])
                        return cr([0, Y], function(D) {
                          var u0 = o(se[3], [0, _], D);
                          return [18, [0, [0, u0], 0, 0, 1, lr([0, U], 0, 0)]];
                        }, I);
                    } else if (Yt === y0)
                      return cr([0, Y], function(D) {
                        var u0 = Pe(D);
                        Y0(D, Yt);
                        var X0 = D[27][3], J0 = A0(D), ir = 0;
                        if (typeof J0 != "number" && J0[0] === 4 && !n0(J0[3], c0e)) {
                          ie(D);
                          var Q0 = X0 ? [0, o(se[13], 0, D)] : (je(D, 13), 0), F0 = Q0;
                          ir = 1;
                        }
                        if (!ir)
                          var F0 = 0;
                        var Sr = u(E0, D), mr = lr([0, U], [0, Sr[2]], 0);
                        return [18, [0, 0, [0, [1, [0, u0, F0]]], [0, Sr[1]], 1, mr]];
                      }, I);
                  } else {
                    var P0 = 0;
                    if ((y0 === 24 || 27 <= y0) && (P0 = 1), P0)
                      return cr([0, Y], function(D) {
                        var u0 = o(se[3], [0, _], D);
                        return [18, [0, [0, u0], 0, 0, 1, lr([0, U], 0, 0)]];
                      }, I);
                  }
                var I0 = xu(I, 61) ? 0 : 1;
                return xu(I, 0) ? cr([0, Y], function(D) {
                  var u0 = ur(U0, 0, D, 0);
                  Y0(D, 1);
                  var X0 = A0(D), J0 = 0;
                  if (typeof X0 != "number" && X0[0] === 4 && !n0(X0[3], a0e)) {
                    var ir = u(E0, D), Q0 = ir[2], F0 = [0, ir[1]];
                    J0 = 1;
                  }
                  if (!J0) {
                    o(b, D, u0);
                    var Sr = x4(0, 0, D), mr = Sr[0] === 0 ? Sr[1] : Sr[1][1], Q0 = mr, F0 = 0;
                  }
                  return [18, [0, 0, [0, [0, u0]], F0, I0, lr([0, U], [0, Q0], 0)]];
                }, I) : (St(s0e, I), o(se[3], [0, _], I));
              }), N(X, function(_) {
                var k = _ && _[1];
                function I(Y) {
                  1 - fu(Y) && je(Y, 13);
                  var y0 = pr(Y);
                  Y0(Y, 60);
                  var P0 = ne0(1, _s(1, Y)), I0 = on(y0, pr(P0));
                  Y0(P0, 49);
                  var D = A0(P0);
                  if (typeof D == "number")
                    if (53 <= D) {
                      if (Yt === D) {
                        var u0 = Pe(P0);
                        Y0(P0, Yt);
                        var X0 = P0[27][3], J0 = A0(P0), ir = 0;
                        if (typeof J0 != "number" && J0[0] === 4 && !n0(J0[3], f0e)) {
                          ie(P0);
                          var Q0 = X0 ? [0, o(se[13], 0, P0)] : (je(P0, 13), 0), F0 = Q0;
                          ir = 1;
                        }
                        if (!ir)
                          var F0 = 0;
                        var Sr = u(E0, P0), mr = lr([0, I0], [0, Sr[2]], 0);
                        return [6, [0, 0, 0, [0, [1, [0, u0, F0]]], [0, Sr[1]], mr]];
                      }
                      if (!(63 <= D))
                        switch (D + cU | 0) {
                          case 0:
                            if (k) {
                              var Cr = cr(0, u(V, 0), P0);
                              return [6, [0, 0, [0, [6, Cr]], 0, 0, lr([0, I0], 0, 0)]];
                            }
                            break;
                          case 8:
                            if (k) {
                              var sr = cr(0, u(w, 0), P0);
                              return [6, [0, 0, [0, [4, sr]], 0, 0, lr([0, I0], 0, 0)]];
                            }
                            break;
                          case 9:
                            var Pr = cr(0, o(S11, i0e, 0), P0);
                            return [6, [0, 0, [0, [5, Pr]], 0, 0, lr([0, I0], 0, 0)]];
                        }
                    } else {
                      var K0 = D - 15 | 0;
                      if (!(25 < K0 >>> 0))
                        switch (K0) {
                          case 21:
                            var Ur = on(I0, pr(P0)), h0 = cr(0, function(Ct) {
                              return Y0(Ct, 36);
                            }, P0), Kr = te0(1, P0), re = A0(Kr), xe = 0;
                            if (typeof re == "number")
                              if (re === 15)
                                var Re = 0, ve = Re, Ie = [0, [1, cr(0, function(Ct) {
                                  return o(e0, 0, Ct);
                                }, Kr)]];
                              else if (re === 40)
                                var ve = 0, Ie = [0, [2, cr(0, u(k0, 0), Kr)]];
                              else
                                xe = 1;
                            else
                              xe = 1;
                            if (xe) {
                              var Ge = u(mn[1], Kr), Me = x4(0, 0, Kr);
                              if (Me[0] === 0)
                                var Ae = Me[1], cn = Ge;
                              else
                                var an = 0, We = function(Wu, lt) {
                                  return o(Qe(Wu, _v, Pn), Wu, lt);
                                }, Ae = an, cn = o(Me[1][2], Ge, We);
                              var ve = Ae, Ie = [0, [3, cn]];
                            }
                            var rn = lr([0, Ur], [0, ve], 0);
                            return [6, [0, [0, h0[1]], Ie, 0, 0, rn]];
                          case 0:
                          case 9:
                          case 12:
                          case 13:
                          case 25:
                            var kn = A0(P0);
                            if (typeof kn == "number") {
                              var vn = 0;
                              if (25 <= kn)
                                if (29 <= kn) {
                                  if (kn === 40) {
                                    var Ne = [0, [2, cr(0, u(k0, 0), P0)]];
                                    vn = 1;
                                  }
                                } else
                                  27 <= kn && (vn = 2);
                              else if (kn === 15) {
                                var Ne = [0, [1, cr(0, function(du) {
                                  return o(e0, 0, du);
                                }, P0)]];
                                vn = 1;
                              } else
                                24 <= kn && (vn = 2);
                              var Je = 0;
                              switch (vn) {
                                case 0:
                                  break;
                                case 2:
                                  var en = 0;
                                  typeof kn == "number" ? kn === 27 ? je(P0, 72) : kn === 28 ? je(P0, 71) : en = 1 : en = 1;
                                  var Ne = [0, [0, cr(0, function(du) {
                                    return o(l, du, 0);
                                  }, P0)]];
                                  Je = 1;
                                  break;
                                default:
                                  Je = 1;
                              }
                              if (Je)
                                return [6, [0, 0, Ne, 0, 0, lr([0, I0], 0, 0)]];
                            }
                            throw [0, Sn, o0e];
                        }
                    }
                  var _n = A0(P0), Cn = 0;
                  typeof _n == "number" ? _n === 53 ? je(P0, 74) : _n === 61 ? je(P0, 73) : Cn = 1 : Cn = 1, Y0(P0, 0);
                  var Hn = ur(U0, 0, P0, 0);
                  Y0(P0, 1);
                  var Fn = A0(P0), vt = 0;
                  if (typeof Fn != "number" && Fn[0] === 4 && !n0(Fn[3], x0e)) {
                    var Nt = u(E0, P0), gt = Nt[2], Zt = [0, Nt[1]];
                    vt = 1;
                  }
                  if (!vt) {
                    o(b, P0, Hn);
                    var qt = x4(0, 0, P0), Ft = qt[0] === 0 ? qt[1] : qt[1][1], gt = Ft, Zt = 0;
                  }
                  return [6, [0, 0, 0, [0, [0, Hn]], Zt, lr([0, I0], [0, gt], 0)]];
                }
                var U = 0;
                return function(Y) {
                  return cr(U, I, Y);
                };
              }), [0, Rr, Ir, $0, B, Br, E, d, y, T, Ar, w0, X, M, Lr, p, R0, be, Fr, m0, $r, K, P, i0, T0, A11, b0, er];
            }(R9), Ge0 = function(t4) {
              var n = function y(T, E) {
                return y.fun(T, E);
              }, e4 = function y(T, E) {
                return y.fun(T, E);
              }, i4 = function y(T, E) {
                return y.fun(T, E);
              };
              N(n, function(y, T) {
                for (var E = T[2], d = E[2], w = a2(y), G = 0, A11 = E[1]; ; ) {
                  if (A11) {
                    var S11 = A11[1];
                    if (S11[0] === 0) {
                      var M = S11[1], K = M[2];
                      switch (K[0]) {
                        case 0:
                          var V = K[2], f0 = K[1];
                          switch (f0[0]) {
                            case 0:
                              var m0 = [0, f0[1]];
                              break;
                            case 1:
                              var m0 = [1, f0[1]];
                              break;
                            case 2:
                              var m0 = ke(t0e);
                              break;
                            default:
                              var m0 = [2, f0[1]];
                          }
                          var k0 = V[2], g0 = 0;
                          if (k0[0] === 2) {
                            var e0 = k0[1];
                            if (!e0[1]) {
                              var x0 = [0, e0[3]], l = e0[2];
                              g0 = 1;
                            }
                          }
                          if (!g0)
                            var x0 = 0, l = o(i4, y, V);
                          var c0 = [0, [0, [0, M[1], [0, m0, l, x0, K[3]]]], G];
                          break;
                        case 1:
                          ue(y, [0, K[2][1], 97]);
                          var c0 = G;
                          break;
                        default:
                          ue(y, [0, K[2][1], u0e]);
                          var c0 = G;
                      }
                      var G = c0, A11 = A11[2];
                      continue;
                    }
                    var t0 = S11[1], o0 = t0[1];
                    if (A11[2]) {
                      ue(y, [0, o0, 66]);
                      var A11 = A11[2];
                      continue;
                    }
                    var w0 = t0[2], _0 = w0[2], G = [0, [1, [0, o0, [0, o(i4, y, w0[1]), _0]]], G], A11 = 0;
                    continue;
                  }
                  var E0 = [0, [0, ye(G), w, d]];
                  return [0, T[1], E0];
                }
              });
              function x4(y, T) {
                return u(se[23], T) ? [0, o(i4, y, T)] : (ue(y, [0, T[1], 26]), 0);
              }
              N(e4, function(y, T) {
                for (var E = T[2], d = E[2], w = a2(y), G = 0, A11 = E[1]; ; ) {
                  if (A11) {
                    var S11 = A11[1];
                    switch (S11[0]) {
                      case 0:
                        var M = S11[1], K = M[2];
                        if (K[0] === 2) {
                          var V = K[1];
                          if (!V[1]) {
                            var G = [0, [0, [0, M[1], [0, V[2], [0, V[3]]]]], G], A11 = A11[2];
                            continue;
                          }
                        }
                        var f0 = x4(y, M);
                        if (f0)
                          var m0 = f0[1], k0 = [0, [0, [0, m0[1], [0, m0, 0]]], G];
                        else
                          var k0 = G;
                        var G = k0, A11 = A11[2];
                        continue;
                      case 1:
                        var g0 = S11[1], e0 = g0[1];
                        if (A11[2]) {
                          ue(y, [0, e0, 65]);
                          var A11 = A11[2];
                          continue;
                        }
                        var x0 = g0[2], l = x4(y, x0[1]), c0 = l ? [0, [1, [0, e0, [0, l[1], x0[2]]]], G] : G, G = c0, A11 = 0;
                        continue;
                      default:
                        var G = [0, [2, S11[1]], G], A11 = A11[2];
                        continue;
                    }
                  }
                  var t0 = [1, [0, ye(G), w, d]];
                  return [0, T[1], t0];
                }
              }), N(i4, function(y, T) {
                var E = T[2], d = T[1];
                switch (E[0]) {
                  case 0:
                    return o(e4, y, [0, d, E[1]]);
                  case 10:
                    var w = E[1], G = w[2][1], A11 = w[1], S11 = 0;
                    if (y[5] && js(G) ? ue(y, [0, A11, 52]) : S11 = 1, S11 && 1 - y[5]) {
                      var M = 0;
                      if (y[17] && qn(G, e0e) ? ue(y, [0, A11, 93]) : M = 1, M) {
                        var K = y[18], V = K && qn(G, n0e);
                        V && ue(y, [0, A11, 92]);
                      }
                    }
                    return [0, d, [2, [0, w, a2(y), 0]]];
                  case 19:
                    return o(n, y, [0, d, E[1]]);
                  default:
                    return [0, d, [3, [0, d, E]]];
                }
              });
              function c(y) {
                function T(w) {
                  var G = A0(w);
                  return typeof G == "number" && G === 82 ? (Y0(w, 82), [0, u(se[10], w)]) : 0;
                }
                function E(w) {
                  var G = pr(w);
                  Y0(w, 0);
                  for (var A11 = 0, S11 = 0, M = 0; ; ) {
                    var K = A0(w);
                    if (typeof K == "number") {
                      var V = 0;
                      if ((K === 1 || Pn === K) && (V = 1), V) {
                        S11 && ue(w, [0, S11[1], 98]);
                        var f0 = ye(M), m0 = pr(w);
                        Y0(w, 1);
                        var k0 = we(w), g0 = A0(w) === 86 ? [1, u(t4[9], w)] : a2(w);
                        return [0, [0, f0, g0, yu([0, G], [0, k0], m0, 0)]];
                      }
                    }
                    if (A0(w) === 12)
                      var e0 = pr(w), x0 = cr(0, function(Jr) {
                        return Y0(Jr, 12), p(Jr, y);
                      }, w), l = lr([0, e0], 0, 0), c0 = [0, [1, [0, x0[1], [0, x0[2], l]]]];
                    else {
                      var t0 = Pe(w), o0 = o(se[20], 0, w), w0 = A0(w), _0 = 0;
                      if (typeof w0 == "number" && w0 === 86) {
                        Y0(w, 86);
                        var E0 = cr([0, t0], function(ar) {
                          var _r = p(ar, y);
                          return [0, _r, T(ar)];
                        }, w), U0 = E0[2], b = o0[2];
                        switch (b[0]) {
                          case 0:
                            var R0 = [0, b[1]];
                            break;
                          case 1:
                            var R0 = [1, b[1]];
                            break;
                          case 2:
                            var R0 = ke($Qr);
                            break;
                          default:
                            var R0 = [2, b[1]];
                        }
                        var c0 = [0, [0, [0, E0[1], [0, R0, U0[1], U0[2], 0]]]];
                      } else
                        _0 = 1;
                      if (_0) {
                        var X = o0[2];
                        if (X[0] === 1) {
                          var s0 = X[1], hr = s0[2][1], Ar = s0[1], or = 0;
                          kL(hr) && n0(hr, QQr) && n0(hr, r0e) && (ue(w, [0, Ar, 2]), or = 1), !or && f22(hr) && V7(w, [0, Ar, 55]);
                          var W0 = cr([0, t0], function(ar, _r) {
                            return function(Ir) {
                              var fe = [0, _r, [2, [0, ar, a2(Ir), 0]]];
                              return [0, fe, T(Ir)];
                            };
                          }(s0, Ar), w), Lr = W0[2], c0 = [0, [0, [0, W0[1], [0, [1, s0], Lr[1], Lr[2], 1]]]];
                        } else {
                          St(ZQr, w);
                          var c0 = 0;
                        }
                      }
                    }
                    if (c0) {
                      var Tr = c0[1], Hr = A11 ? (ue(w, [0, Tr[1][1], 66]), 0) : S11;
                      if (Tr[0] === 0)
                        var Rr = Hr, Wr = A11;
                      else
                        var Or = A0(w) === 9 ? 1 : 0, fr = Or && [0, Pe(w)], Rr = fr, Wr = 1;
                      A0(w) !== 1 && Y0(w, 9);
                      var A11 = Wr, S11 = Rr, M = [0, Tr, M];
                      continue;
                    }
                  }
                }
                var d = 0;
                return function(w) {
                  return cr(d, E, w);
                };
              }
              function s2(y) {
                function T(d) {
                  var w = pr(d);
                  Y0(d, 6);
                  for (var G = 0; ; ) {
                    var A11 = A0(d);
                    if (typeof A11 == "number") {
                      var S11 = 0;
                      if (13 <= A11)
                        Pn === A11 && (S11 = 1);
                      else if (7 <= A11)
                        switch (A11 - 7 | 0) {
                          case 2:
                            var M = Pe(d);
                            Y0(d, 9);
                            var G = [0, [2, M], G];
                            continue;
                          case 5:
                            var K = pr(d), V = cr(0, function(_0) {
                              return Y0(_0, 12), p(_0, y);
                            }, d), f0 = V[1], m0 = lr([0, K], 0, 0), k0 = [1, [0, f0, [0, V[2], m0]]];
                            A0(d) !== 7 && (ue(d, [0, f0, 65]), A0(d) === 9 && ie(d));
                            var G = [0, k0, G];
                            continue;
                          case 0:
                            S11 = 1;
                            break;
                        }
                      if (S11) {
                        var g0 = ye(G), e0 = pr(d);
                        Y0(d, 7);
                        var x0 = A0(d) === 86 ? [1, u(t4[9], d)] : a2(d);
                        return [1, [0, g0, x0, yu([0, w], [0, we(d)], e0, 0)]];
                      }
                    }
                    var l = cr(0, function(w0) {
                      var _0 = p(w0, y), E0 = A0(w0), U0 = 0;
                      if (typeof E0 == "number" && E0 === 82) {
                        Y0(w0, 82);
                        var b = [0, u(se[10], w0)];
                        U0 = 1;
                      }
                      if (!U0)
                        var b = 0;
                      return [0, _0, b];
                    }, d), c0 = l[2], t0 = [0, [0, l[1], [0, c0[1], c0[2]]]];
                    A0(d) !== 7 && Y0(d, 9);
                    var G = [0, t0, G];
                  }
                }
                var E = 0;
                return function(d) {
                  return cr(E, T, d);
                };
              }
              function p(y, T) {
                var E = A0(y);
                if (typeof E == "number") {
                  if (E === 6)
                    return u(s2(T), y);
                  if (!E)
                    return u(c(T), y);
                }
                var d = ur(se[14], y, 0, T);
                return [0, d[1], [2, d[2]]];
              }
              return [0, n, e4, i4, c, s2, p];
            }(mn), une = Zee(se), ine = mn[9];
            function Me0(t4, n) {
              var e4 = A0(n), i4 = 0;
              if (typeof e4 == "number" ? e4 === 28 ? n[5] ? je(n, 55) : n[14] && St(0, n) : e4 === 58 ? n[17] ? je(n, 2) : n[5] && je(n, 55) : e4 === 65 ? n[18] && je(n, 2) : i4 = 1 : i4 = 1, i4)
                if (dL(e4))
                  gi(n, 55);
                else {
                  var x4 = 0;
                  if (typeof e4 == "number")
                    switch (e4) {
                      case 15:
                      case 16:
                      case 17:
                      case 18:
                      case 19:
                      case 20:
                      case 21:
                      case 22:
                      case 23:
                      case 24:
                      case 25:
                      case 26:
                      case 27:
                      case 32:
                      case 33:
                      case 34:
                      case 35:
                      case 36:
                      case 37:
                      case 38:
                      case 39:
                      case 40:
                      case 41:
                      case 43:
                      case 44:
                      case 45:
                      case 46:
                      case 47:
                      case 49:
                      case 50:
                      case 51:
                      case 58:
                      case 59:
                      case 65:
                        var c = 1;
                        x4 = 1;
                        break;
                    }
                  else if (e4[0] === 4 && xe0(e4[3])) {
                    var c = 1;
                    x4 = 1;
                  }
                  if (!x4)
                    var c = 0;
                  var s2 = 0;
                  if (c)
                    var p = c;
                  else {
                    var y = hL(e4);
                    if (y)
                      var p = y;
                    else {
                      var T = 0;
                      if (typeof e4 == "number")
                        switch (e4) {
                          case 29:
                          case 30:
                          case 31:
                            break;
                          default:
                            T = 1;
                        }
                      else if (e4[0] === 4) {
                        var E = e4[3];
                        n0(E, XRr) && n0(E, YRr) && n0(E, VRr) && (T = 1);
                      } else
                        T = 1;
                      if (T) {
                        var d = 0;
                        s2 = 1;
                      } else
                        var p = 1;
                    }
                  }
                  if (!s2)
                    var d = p;
                  if (d)
                    St(0, n);
                  else {
                    var w = 0;
                    t4 && oe0(e4) ? gi(n, t4[1]) : w = 1;
                  }
                }
              return z7(n);
            }
            var Be0 = function t4(n) {
              return t4.fun(n);
            }, jL = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, GL = function t4(n) {
              return t4.fun(n);
            }, qe0 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, ML = function t4(n, e4) {
              return t4.fun(n, e4);
            }, BL = function t4(n, e4) {
              return t4.fun(n, e4);
            }, j9 = function t4(n, e4) {
              return t4.fun(n, e4);
            }, xb = function t4(n, e4) {
              return t4.fun(n, e4);
            }, G9 = function t4(n) {
              return t4.fun(n);
            }, Ue0 = function t4(n) {
              return t4.fun(n);
            }, He0 = function t4(n) {
              return t4.fun(n);
            }, Xe0 = function t4(n, e4, i4) {
              return t4.fun(n, e4, i4);
            }, Ye0 = function t4(n) {
              return t4.fun(n);
            }, Ve0 = function t4(n) {
              return t4.fun(n);
            }, ze0 = Us[3], fne = ci[3], xne = ci[1], one = ci[5], ane = Us[2], cne = Us[1], sne = Us[4], vne = ci[4], lne = ci[6], bne = une[13], pne = Ge0[6], mne = Ge0[3];
            N(Be0, function(t4) {
              var n = pr(t4), e4 = ye(n), i4 = 5;
              r:
                for (; ; ) {
                  if (e4)
                    for (var x4 = e4[2], c = e4[1], s2 = c[2], p = c[1], y = s2[2], T = 0, E = un(y); ; ) {
                      if (E < (T + 5 | 0))
                        var d = 0;
                      else {
                        var w = qn(m7(y, T, i4), kRr);
                        if (!w) {
                          var T = T + 1 | 0;
                          continue;
                        }
                        var d = w;
                      }
                      if (!d) {
                        var e4 = x4;
                        continue r;
                      }
                      t4[30][1] = p[3];
                      var G = ye([0, [0, p, s2], x4]);
                      break;
                    }
                  else
                    var G = e4;
                  if (G === 0) {
                    var A11 = 0;
                    if (n) {
                      var S11 = n[1], M = S11[2];
                      if (!M[1]) {
                        var K = M[2], V = 0;
                        if (1 <= un(K) && It(K, 0) === 42) {
                          t4[30][1] = S11[1][3];
                          var f0 = [0, S11, 0];
                          A11 = 1, V = 1;
                        }
                      }
                    }
                    if (!A11)
                      var f0 = 0;
                  } else
                    var f0 = G;
                  var m0 = o(qe0, t4, function(c0) {
                    return 0;
                  }), k0 = Pe(t4);
                  Y0(t4, Pn);
                  var g0 = Mu[1];
                  if (le(function(c0, t0) {
                    var o0 = t0[2];
                    switch (o0[0]) {
                      case 17:
                        return fb(t4, c0, Rc(0, [0, o0[1][1], ore]));
                      case 18:
                        var w0 = o0[1], _0 = w0[1];
                        if (_0) {
                          if (!w0[2]) {
                            var E0 = _0[1], U0 = E0[2], b = 0;
                            switch (U0[0]) {
                              case 34:
                                var R0 = U0[1][1], X = 0, s0 = le(function(Tr, Hr) {
                                  return le(RL, Tr, [0, Hr[2][1], 0]);
                                }, X, R0);
                                return le(function(Tr, Hr) {
                                  return fb(t4, Tr, Hr);
                                }, c0, s0);
                              case 2:
                              case 23:
                                var hr = U0[1][1];
                                if (hr)
                                  var Ar = hr[1];
                                else
                                  b = 1;
                                break;
                              case 16:
                              case 26:
                              case 32:
                              case 33:
                                var Ar = U0[1][1];
                                break;
                              default:
                                b = 1;
                            }
                            return b ? c0 : fb(t4, c0, Rc(0, [0, E0[1], Ar[2][1]]));
                          }
                        } else {
                          var or = w0[2];
                          if (or) {
                            var W0 = or[1];
                            if (W0[0] === 0) {
                              var Lr = W0[1];
                              return le(function(Tr, Hr) {
                                var Or = Hr[2], fr = Or[2];
                                return fr ? fb(t4, Tr, fr[1]) : fb(t4, Tr, Or[1]);
                              }, c0, Lr);
                            }
                            return c0;
                          }
                        }
                        return c0;
                      default:
                        return c0;
                    }
                  }, g0, m0), m0)
                    var e0 = bl(ye(m0))[1], x0 = yt(bl(m0)[1], e0);
                  else
                    var x0 = k0;
                  var l = ye(t4[2][1]);
                  return [0, x0, [0, m0, lr([0, f0], 0, 0), l]];
                }
            }), N(jL, function(t4, n, e4) {
              for (var i4 = ee0(1, t4), x4 = ire; ; ) {
                var c = x4[3], s2 = x4[2], p = x4[1], y = A0(i4), T = 0;
                if (typeof y == "number" && Pn === y)
                  var E = [0, i4, p, s2, c];
                else
                  T = 1;
                if (T)
                  if (u(n, y))
                    var E = [0, i4, p, s2, c];
                  else {
                    var d = 0;
                    if (typeof y == "number" || y[0] !== 2)
                      d = 1;
                    else {
                      var w = u(e4, i4), G = [0, w, s2], A11 = w[2];
                      if (A11[0] === 19) {
                        var S11 = A11[1][2];
                        if (S11) {
                          var M = qn(S11[1], ure), K = M && 1 - i4[20];
                          K && ue(i4, [0, w[1], 43]);
                          var V = M ? _s(1, i4) : i4, f0 = [0, y, p], m0 = c || M, i4 = V, x4 = [0, f0, G, m0];
                          continue;
                        }
                      }
                      var E = [0, i4, p, G, c];
                    }
                    if (d)
                      var E = [0, i4, p, s2, c];
                  }
                var k0 = ee0(0, i4), g0 = ye(p);
                return Du(function(e0) {
                  if (typeof e0 != "number" && e0[0] === 2) {
                    var x0 = e0[1], l = x0[4];
                    return l && V7(k0, [0, x0[1], 45]);
                  }
                  return ke(Te(xre, Te(wr0(e0), fre)));
                }, g0), [0, k0, E[3], c];
              }
            }), N(GL, function(t4) {
              var n = u(Us[6], t4), e4 = A0(t4);
              if (typeof e4 == "number") {
                var i4 = e4 - 49 | 0;
                if (!(11 < i4 >>> 0))
                  switch (i4) {
                    case 0:
                      return o(ht[16], n, t4);
                    case 1:
                      u(A9(t4), n);
                      var x4 = Yn(1, t4);
                      if (typeof x4 == "number") {
                        var c = 0;
                        if ((x4 === 4 || x4 === 10) && (c = 1), c)
                          return u(ht[17], t4);
                      }
                      return u(ht[18], t4);
                    case 11:
                      if (Yn(1, t4) === 49)
                        return u(A9(t4), n), o(ht[12], 0, t4);
                      break;
                  }
              }
              return o(xb, [0, n], t4);
            }), N(qe0, function(t4, n) {
              var e4 = ur(jL, t4, n, GL), i4 = o(ML, n, e4[1]), x4 = e4[2];
              return le(function(c, s2) {
                return [0, s2, c];
              }, i4, x4);
            }), N(ML, function(t4, n) {
              for (var e4 = 0; ; ) {
                var i4 = A0(n);
                if (typeof i4 == "number" && Pn === i4 || u(t4, i4))
                  return ye(e4);
                var e4 = [0, u(GL, n), e4];
              }
            }), N(BL, function(t4, n) {
              var e4 = ur(jL, n, t4, function(s2) {
                return o(xb, 0, s2);
              }), i4 = o(j9, t4, e4[1]), x4 = e4[2], c = le(function(s2, p) {
                return [0, p, s2];
              }, i4, x4);
              return [0, c, e4[3]];
            }), N(j9, function(t4, n) {
              for (var e4 = 0; ; ) {
                var i4 = A0(n);
                if (typeof i4 == "number" && Pn === i4 || u(t4, i4))
                  return ye(e4);
                var e4 = [0, o(xb, 0, n), e4];
              }
            }), N(xb, function(t4, n) {
              var e4 = t4 && t4[1];
              1 - $l(n) && u(A9(n), e4);
              var i4 = A0(n);
              if (typeof i4 == "number") {
                if (i4 === 27)
                  return u(ht[27], n);
                if (i4 === 28)
                  return u(ht[3], n);
              }
              if (Gs(n))
                return u(Vn[10], n);
              if ($l(n))
                return o(ze0, n, e4);
              if (typeof i4 == "number") {
                var x4 = i4 + Wt | 0;
                if (!(14 < x4 >>> 0))
                  switch (x4) {
                    case 0:
                      if (n[27][1])
                        return u(Vn[11], n);
                      break;
                    case 5:
                      return u(ht[19], n);
                    case 12:
                      return o(ht[11], 0, n);
                    case 13:
                      return u(ht[25], n);
                    case 14:
                      return u(ht[21], n);
                  }
              }
              return u(G9, n);
            }), N(G9, function(t4) {
              var n = A0(t4);
              if (typeof n == "number")
                switch (n) {
                  case 0:
                    return u(ht[7], t4);
                  case 8:
                    return u(ht[15], t4);
                  case 19:
                    return u(ht[22], t4);
                  case 20:
                    return u(ht[23], t4);
                  case 22:
                    return u(ht[24], t4);
                  case 23:
                    return u(ht[4], t4);
                  case 24:
                    return u(ht[26], t4);
                  case 25:
                    return u(ht[5], t4);
                  case 26:
                    return u(ht[6], t4);
                  case 32:
                    return u(ht[8], t4);
                  case 35:
                    return u(ht[9], t4);
                  case 37:
                    return u(ht[14], t4);
                  case 39:
                    return u(ht[1], t4);
                  case 59:
                    return u(ht[10], t4);
                  case 113:
                    return St(ere, t4), [0, Pe(t4), nre];
                  case 16:
                  case 43:
                    return u(ht[2], t4);
                  case 1:
                  case 5:
                  case 7:
                  case 9:
                  case 10:
                  case 11:
                  case 12:
                  case 17:
                  case 18:
                  case 33:
                  case 34:
                  case 36:
                  case 38:
                  case 41:
                  case 42:
                  case 49:
                  case 83:
                  case 86:
                    return St(tre, t4), ie(t4), u(G9, t4);
                }
              if (Gs(t4)) {
                var e4 = u(Vn[10], t4);
                return M1(t4, e4[1]), e4;
              }
              if (typeof n == "number" && n === 28 && Yn(1, t4) === 6) {
                var i4 = Wl(1, t4);
                return ue(t4, [0, yt(Pe(t4), i4), 94]), u(ht[17], t4);
              }
              return G1(t4) ? u(ht[20], t4) : ($l(t4) && (St(0, t4), ie(t4)), u(ht[17], t4));
            }), N(Ue0, function(t4) {
              var n = Pe(t4), e4 = u(ci[1], t4), i4 = A0(t4);
              return typeof i4 == "number" && i4 === 9 ? ur(ci[7], t4, n, [0, e4, 0]) : e4;
            }), N(He0, function(t4) {
              var n = Pe(t4), e4 = u(ci[2], t4), i4 = A0(t4);
              if (typeof i4 == "number" && i4 === 9) {
                var x4 = [0, o(R9[1], t4, e4), 0];
                return [0, ur(ci[7], t4, n, x4)];
              }
              return e4;
            }), N(Xe0, function(t4, n, e4) {
              var i4 = n && n[1];
              return cr(0, function(x4) {
                var c = 1 - i4, s2 = Me0([0, e4], x4), p = c && (A0(x4) === 85 ? 1 : 0);
                return p && (1 - fu(x4) && je(x4, 12), Y0(x4, 85)), [0, s2, u(mn[10], x4), p];
              }, t4);
            }), N(Ye0, function(t4) {
              var n = Pe(t4), e4 = pr(t4);
              Y0(t4, 0);
              var i4 = o(j9, function(y) {
                return y === 1 ? 1 : 0;
              }, t4), x4 = i4 === 0 ? 1 : 0, c = Pe(t4), s2 = x4 && pr(t4);
              Y0(t4, 1);
              var p = [0, i4, yu([0, e4], [0, we(t4)], s2, 0)];
              return [0, yt(n, c), p];
            }), N(Ve0, function(t4) {
              function n(i4) {
                var x4 = pr(i4);
                Y0(i4, 0);
                var c = o(BL, function(S11) {
                  return S11 === 1 ? 1 : 0;
                }, i4), s2 = c[1], p = s2 === 0 ? 1 : 0, y = p && pr(i4);
                Y0(i4, 1);
                var T = A0(i4), E = 0;
                if (!t4) {
                  var d = 0;
                  if (typeof T == "number" && (T === 1 || Pn === T) && (d = 1), !d) {
                    var w = x7(i4);
                    if (w) {
                      var G = Ms(i4);
                      E = 1;
                    } else {
                      var G = w;
                      E = 1;
                    }
                  }
                }
                if (!E)
                  var G = we(i4);
                var A11 = yu([0, x4], [0, G], y, 0);
                return [0, [0, s2, A11], c[2]];
              }
              var e4 = 0;
              return function(i4) {
                return gL(e4, n, i4);
              };
            }), mu(lre, se, [0, Be0, G9, xb, j9, BL, ML, Ue0, He0, fne, xne, one, ane, Me0, Xe0, Ye0, Ve0, bne, pne, mne, cne, ze0, sne, vne, lne, ine]);
            var Ke0 = [0, 0], We0 = bn;
            function _ne(t4) {
              function n(e4, i4) {
                var x4 = i4[2], c = i4[1], s2 = oL(x4), p = [0, [0, bre, u(t4[1], s2)], 0], y = C9(e4, c[3]), T = [0, u(t4[5], y), 0], E = C9(e4, c[2]), d = [0, u(t4[5], E), T], w = [0, [0, pre, u(t4[4], d)], p], G = [0, [0, mre, u(t4[5], c[3][2])], 0], A11 = [0, [0, _re, u(t4[5], c[3][1])], G], S11 = [0, [0, yre, u(t4[3], A11)], 0], M = [0, [0, hre, u(t4[5], c[2][2])], 0], K = [0, [0, dre, u(t4[5], c[2][1])], M], V = [0, [0, kre, u(t4[3], K)], S11], f0 = [0, [0, wre, u(t4[3], V)], w];
                switch (i4[3]) {
                  case 0:
                    var m0 = Ere;
                    break;
                  case 1:
                    var m0 = Sre;
                    break;
                  case 2:
                    var m0 = gre;
                    break;
                  case 3:
                    var m0 = Fre;
                    break;
                  case 4:
                    var m0 = Tre;
                    break;
                  default:
                    var m0 = Ore;
                }
                var k0 = [0, [0, Ire, u(t4[1], m0)], f0], g0 = wr0(x4), e0 = [0, [0, Are, u(t4[1], g0)], k0];
                return u(t4[3], e0);
              }
              return [0, n, function(e4, i4) {
                var x4 = ye(Fp(function(c) {
                  return n(e4, c);
                }, i4));
                return u(t4[4], x4);
              }];
            }
            var yne = S70;
            function U1(t4) {
              return g70(_l(t4));
            }
            function hu(t4) {
              return E70(_l(t4));
            }
            function hne(t4) {
              return t4;
            }
            function dne(t4) {
              return t4;
            }
            function Je0(t4, n, e4) {
              try {
                var i4 = new RegExp(bn(n), bn(e4));
                return i4;
              } catch {
                return i7;
              }
            }
            var kne = _ne([0, We0, yne, U1, hu, hne, dne, i7, Je0]), wne = [0, 1], $e0 = function(t4) {
              function n(E, d) {
                return hu(ye(Fp(E, d)));
              }
              function e4(E, d) {
                return d ? u(E, d[1]) : i7;
              }
              function i4(E, d) {
                return d[0] === 0 ? i7 : u(E, d[1]);
              }
              function x4(E) {
                return U1([0, [0, AWr, E[1]], [0, [0, IWr, E[2]], 0]]);
              }
              function c(E) {
                var d = E[1], w = d ? bn(d[1][1]) : i7, G = [0, [0, FWr, x4(E[3])], 0];
                return U1([0, [0, OWr, w], [0, [0, TWr, x4(E[2])], G]]);
              }
              function s2(E) {
                return n(function(d) {
                  var w = d[2], G = 0;
                  if (typeof w == "number") {
                    var A11 = w;
                    if (55 <= A11)
                      switch (A11) {
                        case 55:
                          var S11 = nmr;
                          break;
                        case 56:
                          var S11 = tmr;
                          break;
                        case 57:
                          var S11 = umr;
                          break;
                        case 58:
                          var S11 = imr;
                          break;
                        case 59:
                          var S11 = fmr;
                          break;
                        case 60:
                          var S11 = xmr;
                          break;
                        case 61:
                          var S11 = Te(amr, omr);
                          break;
                        case 62:
                          var S11 = Te(smr, cmr);
                          break;
                        case 63:
                          var S11 = Te(lmr, vmr);
                          break;
                        case 64:
                          var S11 = bmr;
                          break;
                        case 65:
                          var S11 = pmr;
                          break;
                        case 66:
                          var S11 = mmr;
                          break;
                        case 67:
                          var S11 = _mr;
                          break;
                        case 68:
                          var S11 = ymr;
                          break;
                        case 69:
                          var S11 = hmr;
                          break;
                        case 70:
                          var S11 = dmr;
                          break;
                        case 71:
                          var S11 = kmr;
                          break;
                        case 72:
                          var S11 = wmr;
                          break;
                        case 73:
                          var S11 = Emr;
                          break;
                        case 74:
                          var S11 = Smr;
                          break;
                        case 75:
                          var S11 = gmr;
                          break;
                        case 76:
                          var S11 = Fmr;
                          break;
                        case 77:
                          var S11 = Tmr;
                          break;
                        case 78:
                          var S11 = Omr;
                          break;
                        case 79:
                          var S11 = Imr;
                          break;
                        case 80:
                          var S11 = Amr;
                          break;
                        case 81:
                          var S11 = Nmr;
                          break;
                        case 82:
                          var S11 = Te(Pmr, Cmr);
                          break;
                        case 83:
                          var S11 = Dmr;
                          break;
                        case 84:
                          var S11 = Lmr;
                          break;
                        case 85:
                          var S11 = Rmr;
                          break;
                        case 86:
                          var S11 = jmr;
                          break;
                        case 87:
                          var S11 = Gmr;
                          break;
                        case 88:
                          var S11 = Mmr;
                          break;
                        case 89:
                          var S11 = Bmr;
                          break;
                        case 90:
                          var S11 = qmr;
                          break;
                        case 91:
                          var S11 = Umr;
                          break;
                        case 92:
                          var S11 = Hmr;
                          break;
                        case 93:
                          var S11 = Xmr;
                          break;
                        case 94:
                          var S11 = Te(Vmr, Ymr);
                          break;
                        case 95:
                          var S11 = zmr;
                          break;
                        case 96:
                          var S11 = Kmr;
                          break;
                        case 97:
                          var S11 = Wmr;
                          break;
                        case 98:
                          var S11 = Jmr;
                          break;
                        case 99:
                          var S11 = $mr;
                          break;
                        case 100:
                          var S11 = Zmr;
                          break;
                        case 101:
                          var S11 = Qmr;
                          break;
                        case 102:
                          var S11 = r9r;
                          break;
                        case 103:
                          var S11 = e9r;
                          break;
                        case 104:
                          var S11 = n9r;
                          break;
                        case 105:
                          var S11 = t9r;
                          break;
                        case 106:
                          var S11 = u9r;
                          break;
                        case 107:
                          var S11 = i9r;
                          break;
                        default:
                          var S11 = f9r;
                      }
                    else
                      switch (A11) {
                        case 0:
                          var S11 = r5r;
                          break;
                        case 1:
                          var S11 = e5r;
                          break;
                        case 2:
                          var S11 = n5r;
                          break;
                        case 3:
                          var S11 = t5r;
                          break;
                        case 4:
                          var S11 = u5r;
                          break;
                        case 5:
                          var S11 = i5r;
                          break;
                        case 6:
                          var S11 = f5r;
                          break;
                        case 7:
                          var S11 = x5r;
                          break;
                        case 8:
                          var S11 = o5r;
                          break;
                        case 9:
                          var S11 = a5r;
                          break;
                        case 10:
                          var S11 = c5r;
                          break;
                        case 11:
                          var S11 = s5r;
                          break;
                        case 12:
                          var S11 = v5r;
                          break;
                        case 13:
                          var S11 = l5r;
                          break;
                        case 14:
                          var S11 = b5r;
                          break;
                        case 15:
                          var S11 = p5r;
                          break;
                        case 16:
                          var S11 = m5r;
                          break;
                        case 17:
                          var S11 = _5r;
                          break;
                        case 18:
                          var S11 = y5r;
                          break;
                        case 19:
                          var S11 = h5r;
                          break;
                        case 20:
                          var S11 = d5r;
                          break;
                        case 21:
                          var S11 = k5r;
                          break;
                        case 22:
                          var S11 = w5r;
                          break;
                        case 23:
                          var S11 = E5r;
                          break;
                        case 24:
                          var S11 = S5r;
                          break;
                        case 25:
                          var S11 = g5r;
                          break;
                        case 26:
                          var S11 = F5r;
                          break;
                        case 27:
                          var S11 = T5r;
                          break;
                        case 28:
                          var S11 = O5r;
                          break;
                        case 29:
                          var S11 = I5r;
                          break;
                        case 30:
                          var S11 = A5r;
                          break;
                        case 31:
                          var S11 = Te(C5r, N5r);
                          break;
                        case 32:
                          var S11 = P5r;
                          break;
                        case 33:
                          var S11 = D5r;
                          break;
                        case 34:
                          var S11 = L5r;
                          break;
                        case 35:
                          var S11 = R5r;
                          break;
                        case 36:
                          var S11 = j5r;
                          break;
                        case 37:
                          var S11 = G5r;
                          break;
                        case 38:
                          var S11 = M5r;
                          break;
                        case 39:
                          var S11 = B5r;
                          break;
                        case 40:
                          var S11 = q5r;
                          break;
                        case 41:
                          var S11 = U5r;
                          break;
                        case 42:
                          var S11 = H5r;
                          break;
                        case 43:
                          var S11 = X5r;
                          break;
                        case 44:
                          var S11 = Y5r;
                          break;
                        case 45:
                          var S11 = V5r;
                          break;
                        case 46:
                          var S11 = z5r;
                          break;
                        case 47:
                          var S11 = K5r;
                          break;
                        case 48:
                          var S11 = W5r;
                          break;
                        case 49:
                          var S11 = J5r;
                          break;
                        case 50:
                          var S11 = $5r;
                          break;
                        case 51:
                          var S11 = Z5r;
                          break;
                        case 52:
                          var S11 = Q5r;
                          break;
                        case 53:
                          var S11 = rmr;
                          break;
                        default:
                          var S11 = emr;
                      }
                  } else
                    switch (w[0]) {
                      case 0:
                        var M = w[2], K = w[1], S11 = ur(et(x9r), M, M, K);
                        break;
                      case 1:
                        var V = w[1], f0 = w[2], S11 = o(et(o9r), f0, V);
                        break;
                      case 2:
                        var m0 = w[1], S11 = u(et(a9r), m0);
                        break;
                      case 3:
                        var k0 = w[2], g0 = w[1], e0 = u(et(c9r), g0);
                        if (k0)
                          var x0 = k0[1], S11 = o(et(s9r), x0, e0);
                        else
                          var S11 = u(et(v9r), e0);
                        break;
                      case 4:
                        var l = w[1], S11 = o(et(l9r), l, l);
                        break;
                      case 5:
                        var c0 = w[3], t0 = w[2], o0 = w[1];
                        if (t0) {
                          var w0 = t0[1];
                          if (3 <= w0)
                            var S11 = o(et(b9r), c0, o0);
                          else {
                            switch (w0) {
                              case 0:
                                var _0 = Jpr;
                                break;
                              case 1:
                                var _0 = $pr;
                                break;
                              case 2:
                                var _0 = Zpr;
                                break;
                              default:
                                var _0 = Qpr;
                            }
                            var S11 = R(et(p9r), o0, _0, c0, _0);
                          }
                        } else
                          var S11 = o(et(m9r), c0, o0);
                        break;
                      case 6:
                        var E0 = w[2], U0 = E0;
                        if (b7(U0) === 0)
                          var b = U0;
                        else {
                          var R0 = sz(U0);
                          Jn(R0, 0, xz(Xu(U0, 0)));
                          var b = R0;
                        }
                        var X = b, s0 = w[1], S11 = ur(et(_9r), E0, X, s0);
                        break;
                      case 7:
                        var S11 = w[1] ? y9r : h9r;
                        break;
                      case 8:
                        var hr = w[1], Ar = w[2], S11 = o(et(d9r), Ar, hr);
                        break;
                      case 9:
                        var or = w[1], S11 = u(et(k9r), or);
                        break;
                      case 10:
                        var W0 = w[1], S11 = u(et(w9r), W0);
                        break;
                      case 11:
                        var Lr = w[2], Tr = w[1], S11 = o(et(E9r), Tr, Lr);
                        break;
                      case 12:
                        var Hr = w[2], Or = w[1], S11 = o(et(S9r), Or, Hr);
                        break;
                      case 13:
                        var S11 = Te(F9r, Te(w[1], g9r));
                        break;
                      case 14:
                        var fr = w[1] ? T9r : O9r, S11 = u(et(I9r), fr);
                        break;
                      case 15:
                        var S11 = Te(N9r, Te(w[1], A9r));
                        break;
                      case 16:
                        var Rr = Te(P9r, Te(w[2], C9r)), S11 = Te(w[1], Rr);
                        break;
                      case 17:
                        var S11 = Te(D9r, w[1]);
                        break;
                      case 18:
                        var S11 = w[1] ? Te(R9r, L9r) : Te(G9r, j9r);
                        break;
                      case 19:
                        var Wr = w[1], S11 = u(et(M9r), Wr);
                        break;
                      case 20:
                        var S11 = Te(q9r, Te(w[1], B9r));
                        break;
                      case 21:
                        var Jr = w[1], ar = w[2] ? U9r : H9r, _r = w[4] ? Te(X9r, Jr) : Jr, Ir = w[3] ? Y9r : V9r, S11 = Te(W9r, Te(ar, Te(Ir, Te(K9r, Te(_r, z9r)))));
                        break;
                      case 22:
                        var S11 = Te($9r, Te(w[1], J9r));
                        break;
                      default:
                        var fe = w[1], S11 = u(et(Z9r), fe);
                    }
                  var v0 = [0, [0, SWr, bn(S11)], G];
                  return U1([0, [0, gWr, c(d[1])], v0]);
                }, E);
              }
              function p(E) {
                if (E) {
                  var d = E[1], w = [0, on(d[3], d[2])];
                  return lr([0, d[1]], w, 0);
                }
                return E;
              }
              function y(E) {
                function d(_) {
                  return n(q0, _);
                }
                function w(_, k, I, U) {
                  var Y = t4[1];
                  if (Y) {
                    if (E)
                      var y0 = E[1], P0 = [0, C9(y0, k[3]), 0], I0 = [0, [0, iGr, hu([0, C9(y0, k[2]), P0])], 0];
                    else
                      var I0 = E;
                    var D = on(I0, [0, [0, fGr, c(k)], 0]);
                  } else
                    var D = Y;
                  if (I) {
                    var u0 = I[1], X0 = u0[1];
                    if (X0) {
                      var J0 = u0[2];
                      if (J0)
                        var ir = [0, [0, xGr, d(J0)], 0], Q0 = [0, [0, oGr, d(X0)], ir];
                      else
                        var Q0 = [0, [0, aGr, d(X0)], 0];
                      var mr = Q0;
                    } else
                      var F0 = u0[2], Sr = F0 && [0, [0, cGr, d(F0)], 0], mr = Sr;
                    var Cr = mr;
                  } else
                    var Cr = I;
                  return U1(Lc(on(D, on(Cr, [0, [0, sGr, bn(_)], 0])), U));
                }
                function G(_) {
                  return n(Q, _);
                }
                function A11(_) {
                  var k = _[2], I = G(k[1]), U = [0, [0, lGr, I], [0, [0, vGr, d(k[3])], 0]];
                  return w(bGr, _[1], k[2], U);
                }
                function S11(_) {
                  var k = _[2];
                  return w(Vqr, _[1], k[2], [0, [0, Yqr, bn(k[1])], [0, [0, Xqr, i7], [0, [0, Hqr, false], 0]]]);
                }
                function M(_) {
                  if (_[0] === 0)
                    return S11(_[1]);
                  var k = _[1], I = k[2], U = M(I[1]), Y = [0, [0, Mzr, U], [0, [0, Gzr, S11(I[2])], 0]];
                  return w(Bzr, k[1], 0, Y);
                }
                function K(_) {
                  var k = _[2], I = k[1], U = I[0] === 0 ? S11(I[1]) : K(I[1]), Y = [0, [0, wzr, U], [0, [0, kzr, S11(k[2])], 0]];
                  return w(Ezr, _[1], 0, Y);
                }
                function V(_) {
                  var k = _[2], I = k[1], U = I[0] === 0 ? S11(I[1]) : K(I[1]), Y = [0, [0, gzr, U], [0, [0, Szr, e4($r, k[2])], 0]];
                  return w(Fzr, _[1], k[3], Y);
                }
                function f0(_) {
                  var k = _[2], I = k[2], U = k[1], Y = _[1];
                  if (typeof U == "number")
                    var y0 = i7;
                  else
                    switch (U[0]) {
                      case 0:
                        var y0 = bn(U[1]);
                        break;
                      case 1:
                        var y0 = !!U[1];
                        break;
                      case 2:
                        var y0 = U[1];
                        break;
                      case 3:
                        var y0 = ke(bYr);
                        break;
                      default:
                        var P0 = U[1], y0 = Je0(Y, P0[1], P0[2]);
                    }
                  var I0 = 0;
                  if (typeof U != "number" && U[0] === 4) {
                    var D = U[1], u0 = [0, [0, _Yr, U1([0, [0, mYr, bn(D[1])], [0, [0, pYr, bn(D[2])], 0]])], 0], X0 = [0, [0, hYr, y0], [0, [0, yYr, bn(I)], u0]];
                    I0 = 1;
                  }
                  if (!I0)
                    var X0 = [0, [0, kYr, y0], [0, [0, dYr, bn(I)], 0]];
                  return w(wYr, Y, k[3], X0);
                }
                function m0(_) {
                  var k = [0, [0, Tzr, g0(_[2])], 0];
                  return [0, [0, Ozr, g0(_[1])], k];
                }
                function k0(_, k) {
                  var I = k[2], U = [0, [0, EVr, !!I[3]], 0], Y = [0, [0, SVr, g0(I[2])], U], y0 = [0, [0, gVr, e4(S11, I[1])], Y];
                  return w(FVr, k[1], _, y0);
                }
                function g0(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      return w(iVr, I, k[1], 0);
                    case 1:
                      return w(fVr, I, k[1], 0);
                    case 2:
                      return w(xVr, I, k[1], 0);
                    case 3:
                      return w(oVr, I, k[1], 0);
                    case 4:
                      return w(aVr, I, k[1], 0);
                    case 5:
                      return w(sVr, I, k[1], 0);
                    case 6:
                      return w(vVr, I, k[1], 0);
                    case 7:
                      return w(lVr, I, k[1], 0);
                    case 8:
                      return w(bVr, I, k[1], 0);
                    case 9:
                      return w(cVr, I, k[1], 0);
                    case 10:
                      return w(tKr, I, k[1], 0);
                    case 11:
                      var U = k[1], Y = [0, [0, pVr, g0(U[1])], 0];
                      return w(mVr, I, U[2], Y);
                    case 12:
                      return e0([0, I, k[1]]);
                    case 13:
                      return x0(1, [0, I, k[1]]);
                    case 14:
                      var y0 = k[1], P0 = [0, [0, mzr, x0(0, y0[1])], 0], I0 = [0, [0, _zr, n(fe, y0[2])], P0];
                      return w(yzr, I, y0[3], I0);
                    case 15:
                      var D = k[1], u0 = [0, [0, hzr, g0(D[1])], 0];
                      return w(dzr, I, D[2], u0);
                    case 16:
                      return V([0, I, k[1]]);
                    case 17:
                      var X0 = k[1], J0 = m0(X0);
                      return w(Izr, I, X0[3], J0);
                    case 18:
                      var ir = k[1], Q0 = ir[1], F0 = [0, [0, Azr, !!ir[2]], 0], Sr = on(m0(Q0), F0);
                      return w(Nzr, I, Q0[3], Sr);
                    case 19:
                      var mr = k[1], Cr = mr[1], sr = [0, [0, Czr, n(g0, [0, Cr[1], [0, Cr[2], Cr[3]]])], 0];
                      return w(Pzr, I, mr[2], sr);
                    case 20:
                      var Pr = k[1], K0 = Pr[1], Ur = [0, [0, Dzr, n(g0, [0, K0[1], [0, K0[2], K0[3]]])], 0];
                      return w(Lzr, I, Pr[2], Ur);
                    case 21:
                      var h0 = k[1], Kr = [0, [0, Rzr, M(h0[1])], 0];
                      return w(jzr, I, h0[2], Kr);
                    case 22:
                      var re = k[1], xe = [0, [0, qzr, n(g0, re[1])], 0];
                      return w(Uzr, I, re[2], xe);
                    case 23:
                      var Re = k[1];
                      return w(Yzr, I, Re[3], [0, [0, Xzr, bn(Re[1])], [0, [0, Hzr, bn(Re[2])], 0]]);
                    case 24:
                      var ve = k[1];
                      return w(Kzr, I, ve[3], [0, [0, zzr, ve[1]], [0, [0, Vzr, bn(ve[2])], 0]]);
                    case 25:
                      var Ie = k[1];
                      return w($zr, I, Ie[3], [0, [0, Jzr, i7], [0, [0, Wzr, bn(Ie[2])], 0]]);
                    default:
                      var Ge = k[1], Me = Ge[1], an = 0, We = Me ? Zzr : Qzr;
                      return w(nKr, I, Ge[2], [0, [0, eKr, !!Me], [0, [0, rKr, bn(We)], an]]);
                  }
                }
                function e0(_) {
                  var k = _[2], I = k[2][2], U = k[4], Y = y7(p(I[4]), U), y0 = [0, [0, _Vr, e4(qr, k[1])], 0], P0 = [0, [0, yVr, e4(Mr, I[3])], y0], I0 = [0, [0, hVr, g0(k[3])], P0], D = [0, [0, dVr, e4(Br, I[1])], I0], u0 = I[2], X0 = [0, [0, kVr, n(function(J0) {
                    return k0(0, J0);
                  }, u0)], D];
                  return w(wVr, _[1], Y, X0);
                }
                function x0(_, k) {
                  var I = k[2], U = I[3], Y = le(function(ir, Q0) {
                    var F0 = ir[4], Sr = ir[3], mr = ir[2], Cr = ir[1];
                    switch (Q0[0]) {
                      case 0:
                        var sr = Q0[1], Pr = sr[2], K0 = Pr[2], Ur = Pr[1];
                        switch (Ur[0]) {
                          case 0:
                            var h0 = f0(Ur[1]);
                            break;
                          case 1:
                            var h0 = S11(Ur[1]);
                            break;
                          case 2:
                            var h0 = ke(MVr);
                            break;
                          default:
                            var h0 = ke(BVr);
                        }
                        switch (K0[0]) {
                          case 0:
                            var xe = qVr, Re = g0(K0[1]);
                            break;
                          case 1:
                            var Kr = K0[1], xe = UVr, Re = e0([0, Kr[1], Kr[2]]);
                            break;
                          default:
                            var re = K0[1], xe = HVr, Re = e0([0, re[1], re[2]]);
                        }
                        var ve = [0, [0, XVr, bn(xe)], 0], Ie = [0, [0, YVr, e4(Er, Pr[7])], ve];
                        return [0, [0, w(ZVr, sr[1], Pr[8], [0, [0, $Vr, h0], [0, [0, JVr, Re], [0, [0, WVr, !!Pr[6]], [0, [0, KVr, !!Pr[3]], [0, [0, zVr, !!Pr[4]], [0, [0, VVr, !!Pr[5]], Ie]]]]]]), Cr], mr, Sr, F0];
                      case 1:
                        var Ge = Q0[1], Me = Ge[2], an = [0, [0, QVr, g0(Me[1])], 0];
                        return [0, [0, w(rzr, Ge[1], Me[2], an), Cr], mr, Sr, F0];
                      case 2:
                        var We = Q0[1], Ae = We[2], cn = [0, [0, ezr, e4(Er, Ae[5])], 0], rn = [0, [0, nzr, !!Ae[4]], cn], kn = [0, [0, tzr, g0(Ae[3])], rn], vn = [0, [0, uzr, g0(Ae[2])], kn], Ne = [0, [0, izr, e4(S11, Ae[1])], vn];
                        return [0, Cr, [0, w(fzr, We[1], Ae[6], Ne), mr], Sr, F0];
                      case 3:
                        var Je = Q0[1], en = Je[2], _n = [0, [0, xzr, !!en[2]], 0], Cn = [0, [0, ozr, e0(en[1])], _n];
                        return [0, Cr, mr, [0, w(azr, Je[1], en[3], Cn), Sr], F0];
                      default:
                        var Hn = Q0[1], Fn = Hn[2], vt = [0, [0, czr, g0(Fn[2])], 0], Nt = [0, [0, lzr, !!Fn[3]], [0, [0, vzr, !!Fn[4]], [0, [0, szr, !!Fn[5]], vt]]], gt = [0, [0, bzr, S11(Fn[1])], Nt];
                        return [0, Cr, mr, Sr, [0, w(pzr, Hn[1], Fn[6], gt), F0]];
                    }
                  }, NVr, U), y0 = [0, [0, CVr, hu(ye(Y[4]))], 0], P0 = [0, [0, PVr, hu(ye(Y[3]))], y0], I0 = [0, [0, DVr, hu(ye(Y[2]))], P0], D = [0, [0, LVr, hu(ye(Y[1]))], I0], u0 = [0, [0, RVr, !!I[1]], D], X0 = _ ? [0, [0, jVr, !!I[2]], u0] : u0, J0 = p(I[4]);
                  return w(GVr, k[1], J0, X0);
                }
                function l(_) {
                  var k = [0, [0, uKr, g0(_[2])], 0];
                  return w(iKr, _[1], 0, k);
                }
                function c0(_) {
                  var k = _[2];
                  switch (k[2]) {
                    case 0:
                      var I = KYr;
                      break;
                    case 1:
                      var I = WYr;
                      break;
                    default:
                      var I = JYr;
                  }
                  var U = [0, [0, $Yr, bn(I)], 0], Y = [0, [0, ZYr, n($0, k[1])], U];
                  return w(QYr, _[1], k[3], Y);
                }
                function t0(_) {
                  var k = _[2];
                  return w(NYr, _[1], k[3], [0, [0, AYr, bn(k[1])], [0, [0, IYr, bn(k[2])], 0]]);
                }
                function o0(_) {
                  var k = _[2], I = [0, [0, IXr, i1], [0, [0, OXr, l(k[1])], 0]];
                  return w(AXr, _[1], k[2], I);
                }
                function w0(_, k) {
                  var I = k[1][2], U = [0, [0, $qr, !!k[3]], 0], Y = [0, [0, Zqr, i4(l, k[2])], U];
                  return w(rUr, _, I[2], [0, [0, Qqr, bn(I[1])], Y]);
                }
                function _0(_) {
                  var k = _[2];
                  return w(Jqr, _[1], k[2], [0, [0, Wqr, bn(k[1])], [0, [0, Kqr, i7], [0, [0, zqr, false], 0]]]);
                }
                function E0(_) {
                  return n(M0, _[2][1]);
                }
                function U0(_) {
                  var k = _[2], I = [0, [0, wKr, w(PKr, k[2], 0, 0)], 0], U = [0, [0, EKr, n(oe, k[3][2])], I], Y = [0, [0, SKr, w(AKr, k[1], 0, 0)], U];
                  return w(gKr, _[1], k[4], Y);
                }
                function b(_) {
                  var k = _[2];
                  return w(rWr, _[1], k[2], [0, [0, QKr, bn(k[1])], 0]);
                }
                function R0(_) {
                  var k = _[2], I = [0, [0, JKr, b(k[2])], 0], U = [0, [0, $Kr, b(k[1])], I];
                  return w(ZKr, _[1], 0, U);
                }
                function X(_) {
                  var k = _[2], I = k[1], U = I[0] === 0 ? b(I[1]) : X(I[1]), Y = [0, [0, KKr, U], [0, [0, zKr, b(k[2])], 0]];
                  return w(WKr, _[1], 0, Y);
                }
                function s0(_) {
                  switch (_[0]) {
                    case 0:
                      return b(_[1]);
                    case 1:
                      return R0(_[1]);
                    default:
                      return X(_[1]);
                  }
                }
                function hr(_) {
                  var k = _[2], I = [0, [0, yKr, n(oe, k[3][2])], 0], U = [0, [0, hKr, e4(ae, k[2])], I], Y = k[1], y0 = Y[2], P0 = [0, [0, FKr, !!y0[2]], 0], I0 = [0, [0, TKr, n(be, y0[3])], P0], D = [0, [0, OKr, s0(y0[1])], I0], u0 = [0, [0, dKr, w(IKr, Y[1], 0, D)], U];
                  return w(kKr, _[1], k[4], u0);
                }
                function Ar(_) {
                  var k = _[2], I = [0, [0, jYr, n(fr, k[2])], 0], U = [0, [0, GYr, n(vr, k[1])], I];
                  return w(MYr, _[1], k[3], U);
                }
                function or(_, k) {
                  var I = k[2], U = I[7], Y = I[5], y0 = I[4];
                  if (y0)
                    var P0 = y0[1][2], I0 = y7(P0[3], U), D = I0, u0 = P0[2], X0 = [0, P0[1]];
                  else
                    var D = U, u0 = 0, X0 = 0;
                  if (Y)
                    var J0 = Y[1][2], ir = y7(J0[2], D), Q0 = ir, F0 = n(T0, J0[1]);
                  else
                    var Q0 = D, F0 = hu(0);
                  var Sr = [0, [0, zUr, F0], [0, [0, VUr, n(S0, I[6])], 0]], mr = [0, [0, KUr, e4($r, u0)], Sr], Cr = [0, [0, WUr, e4(fr, X0)], mr], sr = [0, [0, JUr, e4(qr, I[3])], Cr], Pr = I[2], K0 = Pr[2], Ur = [0, [0, uHr, n(rr, K0[1])], 0], h0 = [0, [0, $Ur, w(iHr, Pr[1], K0[2], Ur)], sr], Kr = [0, [0, ZUr, e4(S11, I[1])], h0];
                  return w(_, k[1], Q0, Kr);
                }
                function W0(_) {
                  var k = _[2], I = [0, [0, xUr, G(k[1])], 0], U = p(k[2]);
                  return w(oUr, _[1], U, I);
                }
                function Lr(_) {
                  var k = _[2];
                  switch (k[0]) {
                    case 0:
                      var I = 0, U = S11(k[1]);
                      break;
                    case 1:
                      var I = 0, U = _0(k[1]);
                      break;
                    default:
                      var I = 1, U = fr(k[1]);
                  }
                  return [0, [0, EWr, fr(_[1])], [0, [0, wWr, U], [0, [0, kWr, !!I], 0]]];
                }
                function Tr(_) {
                  var k = [0, [0, yWr, E0(_[3])], 0], I = [0, [0, hWr, e4(ne, _[2])], k];
                  return [0, [0, dWr, fr(_[1])], I];
                }
                function Hr(_) {
                  var k = _[2], I = k[3], U = k[2], Y = k[1];
                  if (I) {
                    var y0 = I[1], P0 = y0[2], I0 = [0, [0, NXr, Or(P0[1])], 0], D = w(CXr, y0[1], P0[2], I0), u0 = ye([0, D, Fp(L0, U)]), X0 = Y ? [0, o0(Y[1]), u0] : u0;
                    return hu(X0);
                  }
                  var J0 = d1(L0, U), ir = Y ? [0, o0(Y[1]), J0] : J0;
                  return hu(ir);
                }
                function Or(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      var U = k[1], Y = [0, [0, hXr, i4(l, U[2])], 0], y0 = [0, [0, dXr, n(b0, U[1])], Y];
                      return w(kXr, I, p(U[3]), y0);
                    case 1:
                      var P0 = k[1], I0 = [0, [0, wXr, i4(l, P0[2])], 0], D = [0, [0, EXr, n(Z7, P0[1])], I0];
                      return w(SXr, I, p(P0[3]), D);
                    case 2:
                      return w0(I, k[1]);
                    default:
                      return fr(k[1]);
                  }
                }
                function fr(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      var U = k[1], Y = [0, [0, XMr, n(er, U[1])], 0];
                      return w(YMr, I, p(U[2]), Y);
                    case 1:
                      var y0 = k[1], P0 = y0[7], I0 = y0[3], D = y0[2];
                      if (I0[0] === 0)
                        var u0 = 0, X0 = W0(I0[1]);
                      else
                        var u0 = 1, X0 = fr(I0[1]);
                      var J0 = P0[0] === 0 ? 0 : [0, P0[1]], ir = y0[9], Q0 = y7(p(D[2][4]), ir), F0 = [0, [0, VMr, e4(qr, y0[8])], 0], Sr = [0, [0, KMr, !!u0], [0, [0, zMr, e4(l, J0)], F0]], mr = [0, [0, JMr, false], [0, [0, WMr, e4(Fr, y0[6])], Sr]], Cr = [0, [0, ZMr, X0], [0, [0, $Mr, !!y0[4]], mr]];
                      return w(eBr, I, Q0, [0, [0, rBr, i7], [0, [0, QMr, Hr(D)], Cr]]);
                    case 2:
                      var sr = k[1], Pr = sr[1];
                      if (Pr) {
                        switch (Pr[1]) {
                          case 0:
                            var K0 = Tpr;
                            break;
                          case 1:
                            var K0 = Opr;
                            break;
                          case 2:
                            var K0 = Ipr;
                            break;
                          case 3:
                            var K0 = Apr;
                            break;
                          case 4:
                            var K0 = Npr;
                            break;
                          case 5:
                            var K0 = Cpr;
                            break;
                          case 6:
                            var K0 = Ppr;
                            break;
                          case 7:
                            var K0 = Dpr;
                            break;
                          case 8:
                            var K0 = Lpr;
                            break;
                          case 9:
                            var K0 = Rpr;
                            break;
                          case 10:
                            var K0 = jpr;
                            break;
                          case 11:
                            var K0 = Gpr;
                            break;
                          case 12:
                            var K0 = Mpr;
                            break;
                          case 13:
                            var K0 = Bpr;
                            break;
                          default:
                            var K0 = qpr;
                        }
                        var Ur = K0;
                      } else
                        var Ur = nBr;
                      var h0 = [0, [0, tBr, fr(sr[3])], 0], Kr = [0, [0, uBr, Or(sr[2])], h0];
                      return w(fBr, I, sr[4], [0, [0, iBr, bn(Ur)], Kr]);
                    case 3:
                      var re = k[1], xe = [0, [0, xBr, fr(re[3])], 0], Re = [0, [0, oBr, fr(re[2])], xe];
                      switch (re[1]) {
                        case 0:
                          var ve = ipr;
                          break;
                        case 1:
                          var ve = fpr;
                          break;
                        case 2:
                          var ve = xpr;
                          break;
                        case 3:
                          var ve = opr;
                          break;
                        case 4:
                          var ve = apr;
                          break;
                        case 5:
                          var ve = cpr;
                          break;
                        case 6:
                          var ve = spr;
                          break;
                        case 7:
                          var ve = vpr;
                          break;
                        case 8:
                          var ve = lpr;
                          break;
                        case 9:
                          var ve = bpr;
                          break;
                        case 10:
                          var ve = ppr;
                          break;
                        case 11:
                          var ve = mpr;
                          break;
                        case 12:
                          var ve = _pr;
                          break;
                        case 13:
                          var ve = ypr;
                          break;
                        case 14:
                          var ve = hpr;
                          break;
                        case 15:
                          var ve = dpr;
                          break;
                        case 16:
                          var ve = kpr;
                          break;
                        case 17:
                          var ve = wpr;
                          break;
                        case 18:
                          var ve = Epr;
                          break;
                        case 19:
                          var ve = Spr;
                          break;
                        case 20:
                          var ve = gpr;
                          break;
                        default:
                          var ve = Fpr;
                      }
                      return w(cBr, I, re[4], [0, [0, aBr, bn(ve)], Re]);
                    case 4:
                      var Ie = k[1], Ge = Ie[4], Me = y7(p(Ie[3][2][2]), Ge);
                      return w(sBr, I, Me, Tr(Ie));
                    case 5:
                      return or(YUr, [0, I, k[1]]);
                    case 6:
                      var an = k[1], We = [0, [0, vBr, e4(fr, an[2])], 0];
                      return w(bBr, I, 0, [0, [0, lBr, n(yr, an[1])], We]);
                    case 7:
                      var Ae = k[1], cn = [0, [0, pBr, fr(Ae[3])], 0], rn = [0, [0, mBr, fr(Ae[2])], cn], kn = [0, [0, _Br, fr(Ae[1])], rn];
                      return w(yBr, I, Ae[4], kn);
                    case 8:
                      return Rr([0, I, k[1]]);
                    case 9:
                      var vn = k[1], Ne = [0, [0, hBr, e4(fr, vn[2])], 0];
                      return w(kBr, I, 0, [0, [0, dBr, n(yr, vn[1])], Ne]);
                    case 10:
                      return S11(k[1]);
                    case 11:
                      var Je = k[1], en = [0, [0, wBr, fr(Je[1])], 0];
                      return w(EBr, I, Je[2], en);
                    case 12:
                      return hr([0, I, k[1]]);
                    case 13:
                      return U0([0, I, k[1]]);
                    case 14:
                      var _n = k[1], Cn = _n[1];
                      return typeof Cn != "number" && Cn[0] === 3 ? w(OYr, I, _n[3], [0, [0, TYr, i7], [0, [0, FYr, bn(_n[2])], 0]]) : f0([0, I, _n]);
                    case 15:
                      var Hn = k[1];
                      switch (Hn[1]) {
                        case 0:
                          var Fn = SBr;
                          break;
                        case 1:
                          var Fn = gBr;
                          break;
                        default:
                          var Fn = FBr;
                      }
                      var vt = [0, [0, TBr, fr(Hn[3])], 0], Nt = [0, [0, OBr, fr(Hn[2])], vt];
                      return w(ABr, I, Hn[4], [0, [0, IBr, bn(Fn)], Nt]);
                    case 16:
                      var gt = k[1], Zt = Lr(gt);
                      return w(NBr, I, gt[3], Zt);
                    case 17:
                      var qt = k[1], Ft = [0, [0, CBr, S11(qt[2])], 0], Ct = [0, [0, PBr, S11(qt[1])], Ft];
                      return w(DBr, I, qt[3], Ct);
                    case 18:
                      var du = k[1], Wu = du[4], lt = du[3];
                      if (lt)
                        var ou = lt[1], Bu = y7(p(ou[2][2]), Wu), K7 = Bu, Yi = E0(ou);
                      else
                        var K7 = Wu, Yi = hu(0);
                      var a7 = [0, [0, RBr, e4(ne, du[2])], [0, [0, LBr, Yi], 0]];
                      return w(GBr, I, K7, [0, [0, jBr, fr(du[1])], a7]);
                    case 19:
                      var Hc = k[1], W7 = [0, [0, MBr, n(p0, Hc[1])], 0];
                      return w(BBr, I, p(Hc[2]), W7);
                    case 20:
                      var Ut = k[1], bt = Ut[1], B0 = bt[4], D0 = y7(p(bt[3][2][2]), B0), Le = [0, [0, qBr, !!Ut[3]], 0];
                      return w(UBr, I, D0, on(Tr(bt), Le));
                    case 21:
                      var He = k[1], he = He[1], me = [0, [0, HBr, !!He[3]], 0], Zn = on(Lr(he), me);
                      return w(XBr, I, he[3], Zn);
                    case 22:
                      var wn = k[1], ft = [0, [0, YBr, n(fr, wn[1])], 0];
                      return w(VBr, I, wn[2], ft);
                    case 23:
                      return w(zBr, I, k[1][1], 0);
                    case 24:
                      var xt = k[1], jn = [0, [0, YYr, Ar(xt[2])], 0], ut = [0, [0, VYr, fr(xt[1])], jn];
                      return w(zYr, I, xt[3], ut);
                    case 25:
                      return Ar([0, I, k[1]]);
                    case 26:
                      return w(KBr, I, k[1][1], 0);
                    case 27:
                      var dt = k[1], xn = [0, [0, WBr, l(dt[2])], 0], ln = [0, [0, JBr, fr(dt[1])], xn];
                      return w($Br, I, dt[3], ln);
                    case 28:
                      var it = k[1], Tt = it[3], Ti = it[2], hs = it[1];
                      if (7 <= hs)
                        return w(QBr, I, Tt, [0, [0, ZBr, fr(Ti)], 0]);
                      switch (hs) {
                        case 0:
                          var Au = rqr;
                          break;
                        case 1:
                          var Au = eqr;
                          break;
                        case 2:
                          var Au = nqr;
                          break;
                        case 3:
                          var Au = tqr;
                          break;
                        case 4:
                          var Au = uqr;
                          break;
                        case 5:
                          var Au = iqr;
                          break;
                        case 6:
                          var Au = fqr;
                          break;
                        default:
                          var Au = ke(xqr);
                      }
                      var Hs = [0, [0, aqr, true], [0, [0, oqr, fr(Ti)], 0]];
                      return w(sqr, I, Tt, [0, [0, cqr, bn(Au)], Hs]);
                    case 29:
                      var Vi = k[1], Xs = Vi[1] ? vqr : lqr, Ys = [0, [0, bqr, !!Vi[3]], 0], nn = [0, [0, pqr, fr(Vi[2])], Ys];
                      return w(_qr, I, Vi[4], [0, [0, mqr, bn(Xs)], nn]);
                    default:
                      var si = k[1], Vs = [0, [0, yqr, !!si[3]], 0], c2 = [0, [0, hqr, e4(fr, si[1])], Vs];
                      return w(dqr, I, si[2], c2);
                  }
                }
                function Rr(_) {
                  var k = _[2], I = k[7], U = k[3], Y = k[2], y0 = U[0] === 0 ? U[1] : ke(Cqr), P0 = I[0] === 0 ? 0 : [0, I[1]], I0 = k[9], D = y7(p(Y[2][4]), I0), u0 = [0, [0, Pqr, e4(qr, k[8])], 0], X0 = [0, [0, Lqr, false], [0, [0, Dqr, e4(l, P0)], u0]], J0 = [0, [0, Rqr, e4(Fr, k[6])], X0], ir = [0, [0, Gqr, !!k[4]], [0, [0, jqr, !!k[5]], J0]], Q0 = [0, [0, Mqr, W0(y0)], ir], F0 = [0, [0, Bqr, Hr(Y)], Q0], Sr = [0, [0, qqr, e4(S11, k[1])], F0];
                  return w(Uqr, _[1], D, Sr);
                }
                function Wr(_) {
                  var k = _[2], I = [0, [0, sXr, n(fe, k[3])], 0], U = [0, [0, vXr, x0(0, k[4])], I], Y = [0, [0, lXr, e4(qr, k[2])], U], y0 = [0, [0, bXr, S11(k[1])], Y];
                  return w(pXr, _[1], k[5], y0);
                }
                function Jr(_, k) {
                  var I = k[2], U = _ ? GUr : MUr, Y = [0, [0, BUr, e4(g0, I[4])], 0], y0 = [0, [0, qUr, e4(g0, I[3])], Y], P0 = [0, [0, UUr, e4(qr, I[2])], y0], I0 = [0, [0, HUr, S11(I[1])], P0];
                  return w(U, k[1], I[5], I0);
                }
                function ar(_) {
                  var k = _[2], I = [0, [0, DUr, g0(k[3])], 0], U = [0, [0, LUr, e4(qr, k[2])], I], Y = [0, [0, RUr, S11(k[1])], U];
                  return w(jUr, _[1], k[4], Y);
                }
                function _r(_) {
                  if (_) {
                    var k = _[1];
                    if (k[0] === 0)
                      return n(ge, k[1]);
                    var I = k[1], U = I[2];
                    if (U) {
                      var Y = [0, [0, OUr, S11(U[1])], 0];
                      return hu([0, w(IUr, I[1], 0, Y), 0]);
                    }
                    return hu(0);
                  }
                  return hu(0);
                }
                function Ir(_) {
                  return _ ? FUr : TUr;
                }
                function fe(_) {
                  var k = _[2], I = k[1], U = I[0] === 0 ? S11(I[1]) : K(I[1]), Y = [0, [0, _Xr, U], [0, [0, mXr, e4($r, k[2])], 0]];
                  return w(yXr, _[1], k[3], Y);
                }
                function v0(_) {
                  var k = _[2], I = k[6], U = k[4], Y = hu(U ? [0, fe(U[1]), 0] : 0), y0 = I ? n(T0, I[1][2][1]) : hu(0), P0 = [0, [0, mUr, Y], [0, [0, pUr, y0], [0, [0, bUr, n(fe, k[5])], 0]]], I0 = [0, [0, _Ur, x0(0, k[3])], P0], D = [0, [0, yUr, e4(qr, k[2])], I0], u0 = [0, [0, hUr, S11(k[1])], D];
                  return w(dUr, _[1], k[7], u0);
                }
                function P(_) {
                  var k = _[2], I = k[2], U = k[1], Y = yt(U[1], I[1]), y0 = [0, [0, sUr, e4(Fr, k[3])], 0], P0 = [0, [0, vUr, w0(Y, [0, U, [1, I], 0])], y0];
                  return w(lUr, _[1], k[4], P0);
                }
                function L(_) {
                  var k = _[2], I = k[2], U = k[1], Y = [0, [0, aUr, w0(yt(U[1], I[1]), [0, U, [1, I], 0])], 0];
                  return w(cUr, _[1], k[3], Y);
                }
                function Q(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      return W0([0, I, k[1]]);
                    case 1:
                      var U = k[1], Y = [0, [0, pGr, e4(S11, U[1])], 0];
                      return w(mGr, I, U[2], Y);
                    case 2:
                      return or(XUr, [0, I, k[1]]);
                    case 3:
                      var y0 = k[1], P0 = [0, [0, _Gr, e4(S11, y0[1])], 0];
                      return w(yGr, I, y0[2], P0);
                    case 4:
                      return w(hGr, I, k[1][1], 0);
                    case 5:
                      return v0([0, I, k[1]]);
                    case 6:
                      var I0 = k[1], D = I0[5], u0 = I0[4], X0 = I0[3], J0 = I0[2];
                      if (X0) {
                        var ir = X0[1];
                        if (ir[0] !== 0 && !ir[1][2])
                          return w(kGr, I, D, [0, [0, dGr, e4(t0, u0)], 0]);
                      }
                      if (J0) {
                        var Q0 = J0[1];
                        switch (Q0[0]) {
                          case 0:
                            var F0 = L(Q0[1]);
                            break;
                          case 1:
                            var F0 = P(Q0[1]);
                            break;
                          case 2:
                            var F0 = v0(Q0[1]);
                            break;
                          case 3:
                            var F0 = g0(Q0[1]);
                            break;
                          case 4:
                            var F0 = ar(Q0[1]);
                            break;
                          case 5:
                            var F0 = Jr(1, Q0[1]);
                            break;
                          default:
                            var F0 = Wr(Q0[1]);
                        }
                        var Sr = F0;
                      } else
                        var Sr = i7;
                      var mr = [0, [0, wGr, e4(t0, u0)], 0], Cr = [0, [0, SGr, Sr], [0, [0, EGr, _r(X0)], mr]], sr = I0[1], Pr = sr && 1;
                      return w(FGr, I, D, [0, [0, gGr, !!Pr], Cr]);
                    case 7:
                      return P([0, I, k[1]]);
                    case 8:
                      var K0 = k[1], Ur = [0, [0, kUr, n(fe, K0[3])], 0], h0 = [0, [0, wUr, x0(0, K0[4])], Ur], Kr = [0, [0, EUr, e4(qr, K0[2])], h0], re = [0, [0, SUr, S11(K0[1])], Kr];
                      return w(gUr, I, K0[5], re);
                    case 9:
                      var xe = k[1], Re = xe[1], ve = Re[0] === 0 ? S11(Re[1]) : t0(Re[1]), Ie = 0, Ge = xe[3] ? "ES" : "CommonJS", Me = [0, [0, IGr, ve], [0, [0, OGr, W0(xe[2])], [0, [0, TGr, Ge], Ie]]];
                      return w(AGr, I, xe[4], Me);
                    case 10:
                      var an = k[1], We = [0, [0, NGr, l(an[1])], 0];
                      return w(CGr, I, an[2], We);
                    case 11:
                      var Ae = k[1], cn = [0, [0, AUr, g0(Ae[3])], 0], rn = [0, [0, NUr, e4(qr, Ae[2])], cn], kn = [0, [0, CUr, S11(Ae[1])], rn];
                      return w(PUr, I, Ae[4], kn);
                    case 12:
                      return Jr(1, [0, I, k[1]]);
                    case 13:
                      return L([0, I, k[1]]);
                    case 14:
                      var vn = k[1], Ne = [0, [0, PGr, fr(vn[2])], 0], Je = [0, [0, DGr, Q(vn[1])], Ne];
                      return w(LGr, I, vn[3], Je);
                    case 15:
                      return w(RGr, I, k[1][1], 0);
                    case 16:
                      var en = k[1], _n = en[2], Cn = _n[2], Hn = _n[1];
                      switch (Cn[0]) {
                        case 0:
                          var Fn = Cn[1], vt = [0, [0, KHr, !!Fn[2]], [0, [0, zHr, !!Fn[3]], 0]], Nt = Fn[1], gt = [0, [0, WHr, n(function(ku) {
                            var wu = ku[2], Ii = wu[2], w7 = Ii[2], Ki = w7[1], ev = 0, Lb = Ki ? CYr : PYr, nv = [0, [0, XHr, w(RYr, Ii[1], w7[2], [0, [0, LYr, !!Ki], [0, [0, DYr, bn(Lb)], 0]])], ev], Rb = [0, [0, YHr, S11(wu[1])], nv];
                            return w(VHr, ku[1], 0, Rb);
                          }, Nt)], vt], bt = w(JHr, Hn, p(Fn[4]), gt);
                          break;
                        case 1:
                          var Zt = Cn[1], qt = [0, [0, ZHr, !!Zt[2]], [0, [0, $Hr, !!Zt[3]], 0]], Ft = Zt[1], Ct = [0, [0, QHr, n(function(ku) {
                            var wu = ku[2], Ii = wu[2], w7 = Ii[2], Ki = [0, [0, qHr, w(gYr, Ii[1], w7[3], [0, [0, SYr, w7[1]], [0, [0, EYr, bn(w7[2])], 0]])], 0], ev = [0, [0, UHr, S11(wu[1])], Ki];
                            return w(HHr, ku[1], 0, ev);
                          }, Ft)], qt], bt = w(rXr, Hn, p(Zt[4]), Ct);
                          break;
                        case 2:
                          var du = Cn[1], Wu = du[1];
                          if (Wu[0] === 0)
                            var lt = Wu[1], Bu = d1(function(ku) {
                              var wu = [0, [0, MHr, S11(ku[2][1])], 0];
                              return w(BHr, ku[1], 0, wu);
                            }, lt);
                          else
                            var ou = Wu[1], Bu = d1(function(ku) {
                              var wu = ku[2], Ii = [0, [0, RHr, t0(wu[2])], 0], w7 = [0, [0, jHr, S11(wu[1])], Ii];
                              return w(GHr, ku[1], 0, w7);
                            }, ou);
                          var K7 = [0, [0, nXr, !!du[2]], [0, [0, eXr, !!du[3]], 0]], Yi = [0, [0, tXr, hu(Bu)], K7], bt = w(uXr, Hn, p(du[4]), Yi);
                          break;
                        default:
                          var a7 = Cn[1], Hc = [0, [0, iXr, !!a7[2]], 0], W7 = a7[1], Ut = [0, [0, fXr, n(function(ku) {
                            var wu = [0, [0, DHr, S11(ku[2][1])], 0];
                            return w(LHr, ku[1], 0, wu);
                          }, W7)], Hc], bt = w(xXr, Hn, p(a7[3]), Ut);
                      }
                      var B0 = [0, [0, aXr, S11(en[1])], [0, [0, oXr, bt], 0]];
                      return w(cXr, I, en[3], B0);
                    case 17:
                      var D0 = k[1], Le = D0[2], He = Le[0] === 0 ? Q(Le[1]) : fr(Le[1]), he = [0, [0, GGr, He], [0, [0, jGr, bn(Ir(1))], 0]];
                      return w(MGr, I, D0[3], he);
                    case 18:
                      var me = k[1], Zn = me[5], wn = me[4], ft = me[3], xt = me[2];
                      if (xt) {
                        var jn = xt[1];
                        if (jn[0] !== 0) {
                          var ut = [0, [0, BGr, bn(Ir(wn))], 0], dt = [0, [0, qGr, e4(S11, jn[1][2])], ut];
                          return w(HGr, I, Zn, [0, [0, UGr, e4(t0, ft)], dt]);
                        }
                      }
                      var xn = [0, [0, XGr, bn(Ir(wn))], 0], ln = [0, [0, YGr, e4(t0, ft)], xn], it = [0, [0, VGr, _r(xt)], ln];
                      return w(KGr, I, Zn, [0, [0, zGr, e4(Q, me[1])], it]);
                    case 19:
                      var Tt = k[1], Ti = [0, [0, WGr, e4(We0, Tt[2])], 0], hs = [0, [0, JGr, fr(Tt[1])], Ti];
                      return w($Gr, I, Tt[3], hs);
                    case 20:
                      var Au = k[1], Hs = function(ku) {
                        return ku[0] === 0 ? c0(ku[1]) : fr(ku[1]);
                      }, Vi = [0, [0, ZGr, Q(Au[4])], 0], Xs = [0, [0, QGr, e4(fr, Au[3])], Vi], Ys = [0, [0, rMr, e4(fr, Au[2])], Xs], nn = [0, [0, eMr, e4(Hs, Au[1])], Ys];
                      return w(nMr, I, Au[5], nn);
                    case 21:
                      var si = k[1], Vs = si[1], c2 = Vs[0] === 0 ? c0(Vs[1]) : Or(Vs[1]), M9 = [0, [0, tMr, !!si[4]], 0], B9 = [0, [0, uMr, Q(si[3])], M9], q9 = [0, [0, fMr, c2], [0, [0, iMr, fr(si[2])], B9]];
                      return w(xMr, I, si[5], q9);
                    case 22:
                      var zs = k[1], s22 = zs[1], U9 = s22[0] === 0 ? c0(s22[1]) : Or(s22[1]), H9 = [0, [0, oMr, !!zs[4]], 0], X9 = [0, [0, aMr, Q(zs[3])], H9], H1 = [0, [0, sMr, U9], [0, [0, cMr, fr(zs[2])], X9]];
                      return w(vMr, I, zs[5], H1);
                    case 23:
                      var vi = k[1], ab = vi[7], cb = vi[3], sb = vi[2], Y9 = cb[0] === 0 ? cb[1] : ke(kqr), V9 = ab[0] === 0 ? 0 : [0, ab[1]], z9 = vi[9], vb = y7(p(sb[2][4]), z9), K9 = [0, [0, wqr, e4(qr, vi[8])], 0], W9 = [0, [0, Sqr, false], [0, [0, Eqr, e4(l, V9)], K9]], J9 = [0, [0, gqr, e4(Fr, vi[6])], W9], $9 = [0, [0, Tqr, !!vi[4]], [0, [0, Fqr, !!vi[5]], J9]], lb = [0, [0, Oqr, W0(Y9)], $9], Z9 = [0, [0, Iqr, Hr(sb)], lb];
                      return w(Nqr, I, vb, [0, [0, Aqr, e4(S11, vi[1])], Z9]);
                    case 24:
                      var X1 = k[1], v2 = X1[3];
                      if (v2) {
                        var bb = v2[1][2], pb = bb[2], mb = bb[1], On = mb[2], Gn = function(wu) {
                          return y7(wu, pb);
                        };
                        switch (On[0]) {
                          case 0:
                            var Y1 = On[1], _b = JD(Y1[2], pb), Mn = [0, [0, Y1[1], _b]];
                            break;
                          case 1:
                            var yb = On[1], Q9 = Gn(yb[2]), Mn = [1, [0, yb[1], Q9]];
                            break;
                          case 2:
                            var Xc = On[1], r_ = Gn(Xc[7]), Mn = [2, [0, Xc[1], Xc[2], Xc[3], Xc[4], Xc[5], Xc[6], r_]];
                            break;
                          case 3:
                            var l2 = On[1], hb = Gn(l2[2]), Mn = [3, [0, l2[1], hb]];
                            break;
                          case 4:
                            var Mn = [4, [0, Gn(On[1][1])]];
                            break;
                          case 5:
                            var Yc = On[1], e_ = Gn(Yc[7]), Mn = [5, [0, Yc[1], Yc[2], Yc[3], Yc[4], Yc[5], Yc[6], e_]];
                            break;
                          case 6:
                            var Ks = On[1], db = Gn(Ks[5]), Mn = [6, [0, Ks[1], Ks[2], Ks[3], Ks[4], db]];
                            break;
                          case 7:
                            var V1 = On[1], n_ = Gn(V1[4]), Mn = [7, [0, V1[1], V1[2], V1[3], n_]];
                            break;
                          case 8:
                            var ds = On[1], t_ = Gn(ds[5]), Mn = [8, [0, ds[1], ds[2], ds[3], ds[4], t_]];
                            break;
                          case 9:
                            var z1 = On[1], u_ = Gn(z1[4]), Mn = [9, [0, z1[1], z1[2], z1[3], u_]];
                            break;
                          case 10:
                            var b2 = On[1], i_ = Gn(b2[2]), Mn = [10, [0, b2[1], i_]];
                            break;
                          case 11:
                            var Ws = On[1], kb = Gn(Ws[4]), Mn = [11, [0, Ws[1], Ws[2], Ws[3], kb]];
                            break;
                          case 12:
                            var Js = On[1], f_ = Gn(Js[5]), Mn = [12, [0, Js[1], Js[2], Js[3], Js[4], f_]];
                            break;
                          case 13:
                            var zi = On[1], Vc = Gn(zi[3]), Mn = [13, [0, zi[1], zi[2], Vc]];
                            break;
                          case 14:
                            var $s = On[1], x_ = Gn($s[3]), Mn = [14, [0, $s[1], $s[2], x_]];
                            break;
                          case 15:
                            var Mn = [15, [0, Gn(On[1][1])]];
                            break;
                          case 16:
                            var p2 = On[1], m2 = Gn(p2[3]), Mn = [16, [0, p2[1], p2[2], m2]];
                            break;
                          case 17:
                            var _2 = On[1], o_ = Gn(_2[3]), Mn = [17, [0, _2[1], _2[2], o_]];
                            break;
                          case 18:
                            var Zs = On[1], a_ = Gn(Zs[5]), Mn = [18, [0, Zs[1], Zs[2], Zs[3], Zs[4], a_]];
                            break;
                          case 19:
                            var y2 = On[1], qL = Gn(y2[3]), Mn = [19, [0, y2[1], y2[2], qL]];
                            break;
                          case 20:
                            var K1 = On[1], UL = Gn(K1[5]), Mn = [20, [0, K1[1], K1[2], K1[3], K1[4], UL]];
                            break;
                          case 21:
                            var W1 = On[1], HL = Gn(W1[5]), Mn = [21, [0, W1[1], W1[2], W1[3], W1[4], HL]];
                            break;
                          case 22:
                            var J1 = On[1], XL = Gn(J1[5]), Mn = [22, [0, J1[1], J1[2], J1[3], J1[4], XL]];
                            break;
                          case 23:
                            var Oi = On[1], YL = Oi[10], VL = Gn(Oi[9]), Mn = [23, [0, Oi[1], Oi[2], Oi[3], Oi[4], Oi[5], Oi[6], Oi[7], Oi[8], VL, YL]];
                            break;
                          case 24:
                            var h22 = On[1], zL = Gn(h22[4]), Mn = [24, [0, h22[1], h22[2], h22[3], zL]];
                            break;
                          case 25:
                            var $1 = On[1], KL = Gn($1[5]), Mn = [25, [0, $1[1], $1[2], $1[3], $1[4], KL]];
                            break;
                          case 26:
                            var Z1 = On[1], WL = Gn(Z1[5]), Mn = [26, [0, Z1[1], Z1[2], Z1[3], Z1[4], WL]];
                            break;
                          case 27:
                            var wb = On[1], JL = Gn(wb[3]), Mn = [27, [0, wb[1], wb[2], JL]];
                            break;
                          case 28:
                            var Eb = On[1], $L = Eb[3], ZL = Gn(Eb[2]), Mn = [28, [0, Eb[1], ZL, $L]];
                            break;
                          case 29:
                            var d2 = On[1], QL = d2[4], rR = Gn(d2[3]), Mn = [29, [0, d2[1], d2[2], rR, QL]];
                            break;
                          case 30:
                            var c_ = On[1], eR = Gn(c_[2]), Mn = [30, [0, c_[1], eR]];
                            break;
                          case 31:
                            var k2 = On[1], nR = Gn(k2[4]), Mn = [31, [0, k2[1], k2[2], k2[3], nR]];
                            break;
                          case 32:
                            var w2 = On[1], tR = Gn(w2[4]), Mn = [32, [0, w2[1], w2[2], w2[3], tR]];
                            break;
                          case 33:
                            var Q1 = On[1], uR = Gn(Q1[5]), Mn = [33, [0, Q1[1], Q1[2], Q1[3], Q1[4], uR]];
                            break;
                          case 34:
                            var Sb = On[1], iR = Gn(Sb[3]), Mn = [34, [0, Sb[1], Sb[2], iR]];
                            break;
                          case 35:
                            var gb = On[1], fR = Gn(gb[3]), Mn = [35, [0, gb[1], gb[2], fR]];
                            break;
                          default:
                            var Fb = On[1], xR = Gn(Fb[3]), Mn = [36, [0, Fb[1], Fb[2], xR]];
                        }
                        var s_ = Q([0, mb[1], Mn]);
                      } else
                        var s_ = i7;
                      var oR = [0, [0, bMr, Q(X1[2])], [0, [0, lMr, s_], 0]], aR = [0, [0, pMr, fr(X1[1])], oR];
                      return w(mMr, I, X1[4], aR);
                    case 25:
                      var rv = k[1], Tb = rv[4], v_ = rv[3];
                      if (Tb) {
                        var Ob = Tb[1];
                        if (Ob[0] === 0)
                          var cR = Ob[1], b_ = d1(function(wu) {
                            var Ii = wu[1], w7 = wu[3], Ki = wu[2], ev = Ki ? yt(w7[1], Ki[1][1]) : w7[1], Lb = Ki ? Ki[1] : w7, nv = 0, Rb = 0;
                            if (Ii)
                              switch (Ii[1]) {
                                case 0:
                                  var jb = Jc;
                                  break;
                                case 1:
                                  var jb = rs;
                                  break;
                                default:
                                  nv = 1;
                              }
                            else
                              nv = 1;
                            if (nv)
                              var jb = i7;
                            var IR = [0, [0, aWr, S11(Lb)], [0, [0, oWr, jb], Rb]];
                            return w(sWr, ev, 0, [0, [0, cWr, S11(w7)], IR]);
                          }, cR);
                        else
                          var l_ = Ob[1], sR = [0, [0, fWr, S11(l_[2])], 0], b_ = [0, w(xWr, l_[1], 0, sR), 0];
                        var Ib = b_;
                      } else
                        var Ib = Tb;
                      if (v_)
                        var p_ = v_[1], vR = [0, [0, uWr, S11(p_)], 0], m_ = [0, w(iWr, p_[1], 0, vR), Ib];
                      else
                        var m_ = Ib;
                      switch (rv[1]) {
                        case 0:
                          var Ab = _Mr;
                          break;
                        case 1:
                          var Ab = yMr;
                          break;
                        default:
                          var Ab = hMr;
                      }
                      var lR = [0, [0, dMr, bn(Ab)], 0], bR = [0, [0, kMr, t0(rv[2])], lR], pR = [0, [0, wMr, hu(m_)], bR];
                      return w(EMr, I, rv[5], pR);
                    case 26:
                      return Wr([0, I, k[1]]);
                    case 27:
                      var Nb = k[1], mR = [0, [0, SMr, Q(Nb[2])], 0], _R = [0, [0, gMr, S11(Nb[1])], mR];
                      return w(FMr, I, Nb[3], _R);
                    case 28:
                      var __ = k[1], yR = [0, [0, TMr, e4(fr, __[1])], 0];
                      return w(OMr, I, __[2], yR);
                    case 29:
                      var Cb = k[1], hR = [0, [0, IMr, n(i0, Cb[2])], 0], dR = [0, [0, AMr, fr(Cb[1])], hR];
                      return w(NMr, I, Cb[3], dR);
                    case 30:
                      var y_ = k[1], kR = [0, [0, CMr, fr(y_[1])], 0];
                      return w(PMr, I, y_[2], kR);
                    case 31:
                      var E2 = k[1], wR = [0, [0, DMr, e4(W0, E2[3])], 0], ER = [0, [0, LMr, e4(l0, E2[2])], wR], SR = [0, [0, RMr, W0(E2[1])], ER];
                      return w(jMr, I, E2[4], SR);
                    case 32:
                      return ar([0, I, k[1]]);
                    case 33:
                      return Jr(0, [0, I, k[1]]);
                    case 34:
                      return c0([0, I, k[1]]);
                    case 35:
                      var Pb = k[1], gR = [0, [0, GMr, Q(Pb[2])], 0], FR = [0, [0, MMr, fr(Pb[1])], gR];
                      return w(BMr, I, Pb[3], FR);
                    default:
                      var Db = k[1], TR = [0, [0, qMr, Q(Db[2])], 0], OR = [0, [0, UMr, fr(Db[1])], TR];
                      return w(HMr, I, Db[3], OR);
                  }
                }
                function i0(_) {
                  var k = _[2], I = [0, [0, eUr, n(Q, k[2])], 0], U = [0, [0, nUr, e4(fr, k[1])], I];
                  return w(tUr, _[1], k[3], U);
                }
                function l0(_) {
                  var k = _[2], I = [0, [0, uUr, W0(k[2])], 0], U = [0, [0, iUr, e4(Or, k[1])], I];
                  return w(fUr, _[1], k[3], U);
                }
                function S0(_) {
                  var k = _[2], I = [0, [0, QUr, fr(k[1])], 0];
                  return w(rHr, _[1], k[2], I);
                }
                function T0(_) {
                  var k = _[2], I = [0, [0, eHr, e4($r, k[2])], 0], U = [0, [0, nHr, S11(k[1])], I];
                  return w(tHr, _[1], 0, U);
                }
                function rr(_) {
                  switch (_[0]) {
                    case 0:
                      var k = _[1], I = k[2], U = I[6], Y = I[2];
                      switch (Y[0]) {
                        case 0:
                          var I0 = U, D = 0, u0 = f0(Y[1]);
                          break;
                        case 1:
                          var I0 = U, D = 0, u0 = S11(Y[1]);
                          break;
                        case 2:
                          var I0 = U, D = 0, u0 = _0(Y[1]);
                          break;
                        default:
                          var y0 = Y[1][2], P0 = y7(y0[2], U), I0 = P0, D = 1, u0 = fr(y0[1]);
                      }
                      switch (I[1]) {
                        case 0:
                          var X0 = fHr;
                          break;
                        case 1:
                          var X0 = xHr;
                          break;
                        case 2:
                          var X0 = oHr;
                          break;
                        default:
                          var X0 = aHr;
                      }
                      var J0 = [0, [0, sHr, !!D], [0, [0, cHr, n(S0, I[5])], 0]], ir = [0, [0, lHr, bn(X0)], [0, [0, vHr, !!I[4]], J0]], Q0 = [0, [0, pHr, u0], [0, [0, bHr, Rr(I[3])], ir]];
                      return w(mHr, k[1], I0, Q0);
                    case 1:
                      var F0 = _[1], Sr = F0[2], mr = Sr[6], Cr = Sr[2], sr = Sr[1];
                      switch (sr[0]) {
                        case 0:
                          var h0 = mr, Kr = 0, re = f0(sr[1]);
                          break;
                        case 1:
                          var h0 = mr, Kr = 0, re = S11(sr[1]);
                          break;
                        case 2:
                          var Pr = ke(gHr), h0 = Pr[3], Kr = Pr[2], re = Pr[1];
                          break;
                        default:
                          var K0 = sr[1][2], Ur = y7(K0[2], mr), h0 = Ur, Kr = 1, re = fr(K0[1]);
                      }
                      if (typeof Cr == "number")
                        if (Cr)
                          var xe = 0, Re = 0;
                        else
                          var xe = 1, Re = 0;
                      else
                        var xe = 0, Re = [0, Cr[1]];
                      var ve = xe && [0, [0, FHr, !!xe], 0], Ie = [0, [0, THr, e4(Er, Sr[5])], 0], Ge = [0, [0, IHr, !!Kr], [0, [0, OHr, !!Sr[4]], Ie]], Me = [0, [0, AHr, i4(l, Sr[3])], Ge], an = on([0, [0, CHr, re], [0, [0, NHr, e4(fr, Re)], Me]], ve);
                      return w(PHr, F0[1], h0, an);
                    default:
                      var We = _[1], Ae = We[2], cn = Ae[2];
                      if (typeof cn == "number")
                        if (cn)
                          var rn = 0, kn = 0;
                        else
                          var rn = 1, kn = 0;
                      else
                        var rn = 0, kn = [0, cn[1]];
                      var vn = rn && [0, [0, _Hr, !!rn], 0], Ne = [0, [0, yHr, e4(Er, Ae[5])], 0], Je = [0, [0, dHr, false], [0, [0, hHr, !!Ae[4]], Ne]], en = [0, [0, kHr, i4(l, Ae[3])], Je], _n = [0, [0, wHr, e4(fr, kn)], en], Cn = on([0, [0, EHr, _0(Ae[1])], _n], vn);
                      return w(SHr, We[1], Ae[6], Cn);
                  }
                }
                function L0(_) {
                  var k = _[2], I = k[2], U = k[1];
                  if (I) {
                    var Y = [0, [0, gXr, fr(I[1])], 0], y0 = [0, [0, FXr, Or(U)], Y];
                    return w(TXr, _[1], 0, y0);
                  }
                  return Or(U);
                }
                function B(_, k) {
                  var I = [0, [0, PXr, Or(k[1])], 0];
                  return w(DXr, _, k[2], I);
                }
                function Z7(_) {
                  switch (_[0]) {
                    case 0:
                      var k = _[1], I = k[2], U = I[2], Y = I[1];
                      if (U) {
                        var y0 = [0, [0, LXr, fr(U[1])], 0], P0 = [0, [0, RXr, Or(Y)], y0];
                        return w(jXr, k[1], 0, P0);
                      }
                      return Or(Y);
                    case 1:
                      var I0 = _[1];
                      return B(I0[1], I0[2]);
                    default:
                      return i7;
                  }
                }
                function p0(_) {
                  if (_[0] === 0) {
                    var k = _[1], I = k[2];
                    switch (I[0]) {
                      case 0:
                        var U = fr(I[2]), X0 = 0, J0 = I[3], ir = 0, Q0 = GXr, F0 = U, Sr = I[1];
                        break;
                      case 1:
                        var Y = I[2], y0 = Rr([0, Y[1], Y[2]]), X0 = 0, J0 = 0, ir = 1, Q0 = MXr, F0 = y0, Sr = I[1];
                        break;
                      case 2:
                        var P0 = I[2], I0 = Rr([0, P0[1], P0[2]]), X0 = I[3], J0 = 0, ir = 0, Q0 = BXr, F0 = I0, Sr = I[1];
                        break;
                      default:
                        var D = I[2], u0 = Rr([0, D[1], D[2]]), X0 = I[3], J0 = 0, ir = 0, Q0 = qXr, F0 = u0, Sr = I[1];
                    }
                    switch (Sr[0]) {
                      case 0:
                        var Pr = X0, K0 = 0, Ur = f0(Sr[1]);
                        break;
                      case 1:
                        var Pr = X0, K0 = 0, Ur = S11(Sr[1]);
                        break;
                      case 2:
                        var mr = ke(UXr), Pr = mr[3], K0 = mr[2], Ur = mr[1];
                        break;
                      default:
                        var Cr = Sr[1][2], sr = y7(Cr[2], X0), Pr = sr, K0 = 1, Ur = fr(Cr[1]);
                    }
                    return w(WXr, k[1], Pr, [0, [0, KXr, Ur], [0, [0, zXr, F0], [0, [0, VXr, bn(Q0)], [0, [0, YXr, !!ir], [0, [0, XXr, !!J0], [0, [0, HXr, !!K0], 0]]]]]]);
                  }
                  var h0 = _[1], Kr = h0[2], re = [0, [0, JXr, fr(Kr[1])], 0];
                  return w($Xr, h0[1], Kr[2], re);
                }
                function b0(_) {
                  if (_[0] === 0) {
                    var k = _[1], I = k[2], U = I[3], Y = I[2], y0 = I[1];
                    switch (y0[0]) {
                      case 0:
                        var D = 0, u0 = 0, X0 = f0(y0[1]);
                        break;
                      case 1:
                        var D = 0, u0 = 0, X0 = S11(y0[1]);
                        break;
                      default:
                        var P0 = y0[1][2], I0 = fr(P0[1]), D = P0[2], u0 = 1, X0 = I0;
                    }
                    if (U)
                      var J0 = U[1], ir = yt(Y[1], J0[1]), Q0 = [0, [0, ZXr, fr(J0)], 0], F0 = w(rYr, ir, 0, [0, [0, QXr, Or(Y)], Q0]);
                    else
                      var F0 = Or(Y);
                    return w(xYr, k[1], D, [0, [0, fYr, X0], [0, [0, iYr, F0], [0, [0, uYr, ji], [0, [0, tYr, false], [0, [0, nYr, !!I[4]], [0, [0, eYr, !!u0], 0]]]]]]);
                  }
                  var Sr = _[1];
                  return B(Sr[1], Sr[2]);
                }
                function O0(_) {
                  var k = _[2], I = [0, [0, oYr, fr(k[1])], 0];
                  return w(aYr, _[1], k[2], I);
                }
                function M0(_) {
                  return _[0] === 0 ? fr(_[1]) : O0(_[1]);
                }
                function er(_) {
                  switch (_[0]) {
                    case 0:
                      return fr(_[1]);
                    case 1:
                      return O0(_[1]);
                    default:
                      return i7;
                  }
                }
                function yr(_) {
                  var k = _[2], I = [0, [0, cYr, !!k[3]], 0], U = [0, [0, sYr, fr(k[2])], I], Y = [0, [0, vYr, Or(k[1])], U];
                  return w(lYr, _[1], 0, Y);
                }
                function vr(_) {
                  var k = _[2], I = k[1], U = U1([0, [0, qYr, bn(I[1])], [0, [0, BYr, bn(I[2])], 0]]);
                  return w(XYr, _[1], 0, [0, [0, HYr, U], [0, [0, UYr, !!k[2]], 0]]);
                }
                function $0(_) {
                  var k = _[2], I = [0, [0, rVr, e4(fr, k[2])], 0], U = [0, [0, eVr, Or(k[1])], I];
                  return w(nVr, _[1], 0, U);
                }
                function Er(_) {
                  var k = _[2], I = k[1] ? cY : "plus";
                  return w(uVr, _[1], k[2], [0, [0, tVr, I], 0]);
                }
                function Mr(_) {
                  var k = _[2];
                  return k0(k[2], k[1]);
                }
                function Br(_) {
                  var k = _[2], I = [0, [0, OVr, g0(k[1][2])], [0, [0, TVr, false], 0]], U = [0, [0, IVr, e4(S11, 0)], I];
                  return w(AVr, _[1], k[2], U);
                }
                function qr(_) {
                  var k = _[2], I = [0, [0, fKr, n(jr, k[1])], 0], U = p(k[2]);
                  return w(xKr, _[1], U, I);
                }
                function jr(_) {
                  var k = _[2], I = k[1][2], U = [0, [0, oKr, e4(g0, k[4])], 0], Y = [0, [0, aKr, e4(Er, k[3])], U], y0 = [0, [0, cKr, i4(l, k[2])], Y];
                  return w(vKr, _[1], I[2], [0, [0, sKr, bn(I[1])], y0]);
                }
                function $r(_) {
                  var k = _[2], I = [0, [0, lKr, n(g0, k[1])], 0], U = p(k[2]);
                  return w(bKr, _[1], U, I);
                }
                function ne(_) {
                  var k = _[2], I = [0, [0, pKr, n(Qr, k[1])], 0], U = p(k[2]);
                  return w(mKr, _[1], U, I);
                }
                function Qr(_) {
                  if (_[0] === 0)
                    return g0(_[1]);
                  var k = _[1], I = k[1], U = k[2][1];
                  return V([0, I, [0, [0, Rc(0, [0, I, _Kr])], 0, U]]);
                }
                function be(_) {
                  if (_[0] === 0) {
                    var k = _[1], I = k[2], U = I[1], Y = U[0] === 0 ? b(U[1]) : R0(U[1]), y0 = [0, [0, LKr, Y], [0, [0, DKr, e4(ce, I[2])], 0]];
                    return w(RKr, k[1], 0, y0);
                  }
                  var P0 = _[1], I0 = P0[2], D = [0, [0, jKr, fr(I0[1])], 0];
                  return w(GKr, P0[1], I0[2], D);
                }
                function ae(_) {
                  var k = [0, [0, NKr, s0(_[2][1])], 0];
                  return w(CKr, _[1], 0, k);
                }
                function pe(_) {
                  var k = _[2], I = k[1], U = _[1], Y = I ? fr(I[1]) : w(MKr, [0, U[1], [0, U[2][1], U[2][2] + 1 | 0], [0, U[3][1], U[3][2] - 1 | 0]], 0, 0);
                  return w(qKr, U, p(k[2]), [0, [0, BKr, Y], 0]);
                }
                function oe(_) {
                  var k = _[2], I = _[1];
                  switch (k[0]) {
                    case 0:
                      return hr([0, I, k[1]]);
                    case 1:
                      return U0([0, I, k[1]]);
                    case 2:
                      return pe([0, I, k[1]]);
                    case 3:
                      var U = k[1], Y = [0, [0, UKr, fr(U[1])], 0];
                      return w(HKr, I, U[2], Y);
                    default:
                      var y0 = k[1];
                      return w(VKr, I, 0, [0, [0, YKr, bn(y0[1])], [0, [0, XKr, bn(y0[2])], 0]]);
                  }
                }
                function ce(_) {
                  return _[0] === 0 ? f0([0, _[1], _[2]]) : pe([0, _[1], _[2]]);
                }
                function ge(_) {
                  var k = _[2], I = k[2], U = k[1], Y = S11(I ? I[1] : U), y0 = [0, [0, nWr, S11(U)], [0, [0, eWr, Y], 0]];
                  return w(tWr, _[1], 0, y0);
                }
                function q0(_) {
                  var k = _[2];
                  if (k[1])
                    var I = k[2], U = vWr;
                  else
                    var I = k[2], U = lWr;
                  return w(U, _[1], 0, [0, [0, bWr, bn(I)], 0]);
                }
                function Fr(_) {
                  var k = _[2], I = k[1];
                  if (I)
                    var U = [0, [0, pWr, fr(I[1])], 0], Y = mWr;
                  else
                    var U = 0, Y = _Wr;
                  return w(Y, _[1], k[2], U);
                }
                return [0, A11, fr];
              }
              function T(E) {
                return y(E)[1];
              }
              return [0, T, function(E) {
                return y(E)[2];
              }, s2];
            }(wne);
            function ob(t4, n, e4) {
              var i4 = n[e4];
              return Mp(i4) ? i4 | 0 : t4;
            }
            function Ene(t4, n) {
              var e4 = RV(n, Jz) ? {} : n, i4 = B7(t4), x4 = ob(Bv[5], e4, Nre), c = ob(Bv[4], e4, Cre), s2 = ob(Bv[3], e4, Pre), p = ob(Bv[2], e4, Dre), y = [0, [0, ob(Bv[1], e4, Lre), p, s2, c, x4]], T = e4.tokens, E = Mp(T), d = E && T | 0, w = e4.comments, G = Mp(w) ? w | 0 : 1, A11 = e4.all_comments, S11 = Mp(A11) ? A11 | 0 : 1, M = [0, 0], K = d && [0, function(b0) {
                return M[1] = [0, b0, M[1]], 0;
              }], V = [0, y], f0 = [0, K], m0 = uz ? uz[1] : 1, k0 = f0 && f0[1], g0 = V && V[1], e0 = [0, g0], x0 = [0, k0], l = 0, c0 = x0 && x0[1], t0 = e0 && e0[1], o0 = Hee([0, c0], [0, t0], l, i4), w0 = u(se[1], o0), _0 = ye(o0[1][1]), E0 = [0, LL[1], 0], U0 = ye(le(function(b0, O0) {
                var M0 = b0[2], er = b0[1];
                return o(LL[3], O0, er) ? [0, er, M0] : [0, o(LL[4], O0, er), [0, O0, M0]];
              }, E0, _0)[2]);
              if (U0 && m0)
                throw [0, Nee, U0[1], U0[2]];
              Ke0[1] = 0;
              for (var b = un(i4) - 0 | 0, R0 = i4, X = 0, s0 = 0; ; ) {
                if (s0 === b)
                  var hr = X;
                else {
                  var Ar = Xu(R0, s0), or = 0;
                  if (0 <= Ar && !(zn < Ar))
                    var W0 = 1;
                  else
                    or = 1;
                  if (or) {
                    var Lr = 0;
                    if (nI <= Ar && !(y8 < Ar))
                      var W0 = 2;
                    else
                      Lr = 1;
                    if (Lr) {
                      var Tr = 0;
                      if (hv <= Ar && !(i6 < Ar))
                        var W0 = 3;
                      else
                        Tr = 1;
                      if (Tr) {
                        var Hr = 0;
                        if (s1 <= Ar && !(v8 < Ar))
                          var W0 = 4;
                        else
                          Hr = 1;
                        if (Hr)
                          var W0 = 0;
                      }
                    }
                  }
                  if (W0 === 0) {
                    var X = SL(X, s0, 0), s0 = s0 + 1 | 0;
                    continue;
                  }
                  if (!((b - s0 | 0) < W0)) {
                    var Or = W0 - 1 | 0, fr = s0 + W0 | 0;
                    if (3 < Or >>> 0)
                      throw [0, Sn, Qo0];
                    switch (Or) {
                      case 0:
                        var Rr = Xu(R0, s0);
                        break;
                      case 1:
                        var Rr = (Xu(R0, s0) & 31) << 6 | Xu(R0, s0 + 1 | 0) & 63;
                        break;
                      case 2:
                        var Rr = (Xu(R0, s0) & 15) << 12 | (Xu(R0, s0 + 1 | 0) & 63) << 6 | Xu(R0, s0 + 2 | 0) & 63;
                        break;
                      default:
                        var Rr = (Xu(R0, s0) & 7) << 18 | (Xu(R0, s0 + 1 | 0) & 63) << 12 | (Xu(R0, s0 + 2 | 0) & 63) << 6 | Xu(R0, s0 + 3 | 0) & 63;
                    }
                    var X = SL(X, s0, [0, Rr]), s0 = fr;
                    continue;
                  }
                  var hr = SL(X, s0, 0);
                }
                for (var Wr = tGr, Jr = ye([0, 6, hr]); ; ) {
                  var ar = Wr[3], _r = Wr[2], Ir = Wr[1];
                  if (Jr) {
                    var fe = Jr[1];
                    if (fe === 5) {
                      var v0 = Jr[2];
                      if (v0 && v0[1] === 6) {
                        var P = _l(ye([0, Ir, _r])), Wr = [0, Ir + 2 | 0, 0, [0, P, ar]], Jr = v0[2];
                        continue;
                      }
                    } else if (!(6 <= fe)) {
                      var L = Jr[2], Wr = [0, Ir + we0(fe) | 0, [0, Ir, _r], ar], Jr = L;
                      continue;
                    }
                    var Q = _l(ye([0, Ir, _r])), i0 = Jr[2], Wr = [0, Ir + we0(fe) | 0, 0, [0, Q, ar]], Jr = i0;
                    continue;
                  }
                  var l0 = _l(ye(ar));
                  if (G)
                    var T0 = w0;
                  else
                    var S0 = u(Tee[1], 0), T0 = o(Qe(S0, -201766268, 25), S0, w0);
                  if (S11)
                    var L0 = T0;
                  else
                    var rr = T0[2], L0 = [0, T0[1], [0, rr[1], rr[2], 0]];
                  var B = o($e0[1], [0, l0], L0), Z7 = on(U0, Ke0[1]);
                  if (B.errors = u($e0[3], Z7), d) {
                    var p0 = M[1];
                    B.tokens = hu(Fp(u(kne[1], l0), p0));
                  }
                  return B;
                }
              }
            }
            if (typeof H0 < "u")
              var Ze0 = H0;
            else {
              var Qe0 = {};
              GN.flow = Qe0;
              var Ze0 = Qe0;
            }
            Ze0.parse = function(t4, n) {
              try {
                var e4 = Ene(t4, n);
                return e4;
              } catch (i4) {
                return i4 = Et(i4), i4[1] === MN ? u($z, i4[2]) : u($z, new dee(bn(Te(Rre, Cp(i4)))));
              }
            }, uN(0);
          }(globalThis);
        } });
        Pt();
        var uoe = Fu0(), ioe = Vxe(), foe = zxe(), xoe = Qxe(), ooe = { comments: false, enums: true, esproposal_decorators: true, esproposal_export_star_as: true, tokens: true };
        function aoe(H0) {
          let { message: z0, loc: { start: xr, end: gr } } = H0;
          return uoe(z0, { start: { line: xr.line, column: xr.column + 1 }, end: { line: gr.line, column: gr.column + 1 } });
        }
        function coe(H0, z0) {
          let xr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { parse: gr } = toe(), de = gr(foe(H0), ooe), [Ve] = de.errors;
          if (Ve)
            throw aoe(Ve);
          return xr.originalText = H0, xoe(de, xr);
        }
        zu0.exports = { parsers: { flow: ioe(coe) } };
      });
      return soe();
    });
  }
});

// node_modules/prettier/parser-typescript.js
var require_parser_typescript = __commonJS({
  "node_modules/prettier/parser-typescript.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.typescript = e2();
      }
    })(function() {
      "use strict";
      var Bn = (M, re) => () => (re || M((re = { exports: {} }).exports, re), re.exports);
      var qc = Bn((Sz, CA) => {
        var $0 = function(M) {
          return M && M.Math == Math && M;
        };
        CA.exports = $0(typeof globalThis == "object" && globalThis) || $0(typeof window == "object" && window) || $0(typeof self == "object" && self) || $0(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      });
      var cg = Bn((Tz, kA) => {
        kA.exports = function(M) {
          try {
            return !!M();
          } catch {
            return true;
          }
        };
      });
      var Am = Bn((xz, AA) => {
        var OL = cg();
        AA.exports = !OL(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Z0 = Bn((Ez, NA) => {
        var FL = cg();
        NA.exports = !FL(function() {
          var M = function() {
          }.bind();
          return typeof M != "function" || M.hasOwnProperty("prototype");
        });
      });
      var r1 = Bn((Cz, PA) => {
        var ML = Z0(), e1 = Function.prototype.call;
        PA.exports = ML ? e1.bind(e1) : function() {
          return e1.apply(e1, arguments);
        };
      });
      var FA = Bn((OA) => {
        "use strict";
        var IA = {}.propertyIsEnumerable, wA = Object.getOwnPropertyDescriptor, LL = wA && !IA.call({ 1: 2 }, 1);
        OA.f = LL ? function(re) {
          var Ve = wA(this, re);
          return !!Ve && Ve.enumerable;
        } : IA;
      });
      var XS = Bn((Az, MA) => {
        MA.exports = function(M, re) {
          return { enumerable: !(M & 1), configurable: !(M & 2), writable: !(M & 4), value: re };
        };
      });
      var dp = Bn((Nz, BA) => {
        var LA = Z0(), RA = Function.prototype, RL = RA.bind, QS = RA.call, BL = LA && RL.bind(QS, QS);
        BA.exports = LA ? function(M) {
          return M && BL(M);
        } : function(M) {
          return M && function() {
            return QS.apply(M, arguments);
          };
        };
      });
      var i1 = Bn((Pz, jA) => {
        var JA = dp(), JL = JA({}.toString), jL = JA("".slice);
        jA.exports = function(M) {
          return jL(JL(M), 8, -1);
        };
      });
      var zA = Bn((Iz, UA) => {
        var UL = qc(), zL = dp(), WL = cg(), qL = i1(), YS = UL.Object, VL = zL("".split);
        UA.exports = WL(function() {
          return !YS("z").propertyIsEnumerable(0);
        }) ? function(M) {
          return qL(M) == "String" ? VL(M, "") : YS(M);
        } : YS;
      });
      var $S = Bn((wz, WA) => {
        var KL = qc(), GL = KL.TypeError;
        WA.exports = function(M) {
          if (M == null)
            throw GL("Can't call method on " + M);
          return M;
        };
      });
      var t1 = Bn((Oz, qA) => {
        var HL = zA(), XL = $S();
        qA.exports = function(M) {
          return HL(XL(M));
        };
      });
      var gp = Bn((Fz, VA) => {
        VA.exports = function(M) {
          return typeof M == "function";
        };
      });
      var Nm = Bn((Mz, KA) => {
        var QL = gp();
        KA.exports = function(M) {
          return typeof M == "object" ? M !== null : QL(M);
        };
      });
      var qy = Bn((Lz, GA) => {
        var ZS = qc(), YL = gp(), $L = function(M) {
          return YL(M) ? M : void 0;
        };
        GA.exports = function(M, re) {
          return arguments.length < 2 ? $L(ZS[M]) : ZS[M] && ZS[M][re];
        };
      });
      var XA = Bn((Rz, HA) => {
        var ZL = dp();
        HA.exports = ZL({}.isPrototypeOf);
      });
      var YA = Bn((Bz, QA) => {
        var eR = qy();
        QA.exports = eR("navigator", "userAgent") || "";
      });
      var aN = Bn((Jz, tN) => {
        var iN = qc(), eT = YA(), $A = iN.process, ZA = iN.Deno, eN = $A && $A.versions || ZA && ZA.version, rN = eN && eN.v8, ad, a1;
        rN && (ad = rN.split("."), a1 = ad[0] > 0 && ad[0] < 4 ? 1 : +(ad[0] + ad[1]));
        !a1 && eT && (ad = eT.match(/Edge\/(\d+)/), (!ad || ad[1] >= 74) && (ad = eT.match(/Chrome\/(\d+)/), ad && (a1 = +ad[1])));
        tN.exports = a1;
      });
      var rT = Bn((jz, oN) => {
        var nN = aN(), rR = cg();
        oN.exports = !!Object.getOwnPropertySymbols && !rR(function() {
          var M = Symbol();
          return !String(M) || !(Object(M) instanceof Symbol) || !Symbol.sham && nN && nN < 41;
        });
      });
      var iT = Bn((Uz, sN) => {
        var iR = rT();
        sN.exports = iR && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var tT = Bn((zz, cN) => {
        var tR = qc(), aR = qy(), nR = gp(), oR = XA(), sR = iT(), cR = tR.Object;
        cN.exports = sR ? function(M) {
          return typeof M == "symbol";
        } : function(M) {
          var re = aR("Symbol");
          return nR(re) && oR(re.prototype, cR(M));
        };
      });
      var lN = Bn((Wz, uN) => {
        var uR = qc(), lR = uR.String;
        uN.exports = function(M) {
          try {
            return lR(M);
          } catch {
            return "Object";
          }
        };
      });
      var n1 = Bn((qz, fN) => {
        var fR = qc(), _R = gp(), pR = lN(), dR = fR.TypeError;
        fN.exports = function(M) {
          if (_R(M))
            return M;
          throw dR(pR(M) + " is not a function");
        };
      });
      var pN = Bn((Vz, _N) => {
        var gR = n1();
        _N.exports = function(M, re) {
          var Ve = M[re];
          return Ve == null ? void 0 : gR(Ve);
        };
      });
      var gN = Bn((Kz, dN) => {
        var mR = qc(), aT = r1(), nT = gp(), oT = Nm(), vR = mR.TypeError;
        dN.exports = function(M, re) {
          var Ve, Ke;
          if (re === "string" && nT(Ve = M.toString) && !oT(Ke = aT(Ve, M)) || nT(Ve = M.valueOf) && !oT(Ke = aT(Ve, M)) || re !== "string" && nT(Ve = M.toString) && !oT(Ke = aT(Ve, M)))
            return Ke;
          throw vR("Can't convert object to primitive value");
        };
      });
      var vN = Bn((Gz, mN) => {
        mN.exports = false;
      });
      var o1 = Bn((Hz, hN) => {
        var yN = qc(), yR = Object.defineProperty;
        hN.exports = function(M, re) {
          try {
            yR(yN, M, { value: re, configurable: true, writable: true });
          } catch {
            yN[M] = re;
          }
          return re;
        };
      });
      var s1 = Bn((Xz, bN) => {
        var hR = qc(), DR = o1(), DN = "__core-js_shared__", bR = hR[DN] || DR(DN, {});
        bN.exports = bR;
      });
      var sT = Bn((Qz, TN) => {
        var SR = vN(), SN = s1();
        (TN.exports = function(M, re) {
          return SN[M] || (SN[M] = re !== void 0 ? re : {});
        })("versions", []).push({ version: "3.22.2", mode: SR ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var cT = Bn((Yz, xN) => {
        var TR = qc(), xR = $S(), ER = TR.Object;
        xN.exports = function(M) {
          return ER(xR(M));
        };
      });
      var Wg = Bn(($z, EN) => {
        var CR2 = dp(), kR = cT(), AR = CR2({}.hasOwnProperty);
        EN.exports = Object.hasOwn || function(re, Ve) {
          return AR(kR(re), Ve);
        };
      });
      var uT = Bn((Zz, CN) => {
        var NR = dp(), PR = 0, IR = Math.random(), wR = NR(1 .toString);
        CN.exports = function(M) {
          return "Symbol(" + (M === void 0 ? "" : M) + ")_" + wR(++PR + IR, 36);
        };
      });
      var Vy = Bn((eW, IN) => {
        var OR = qc(), FR = sT(), kN = Wg(), MR = uT(), AN = rT(), PN = iT(), Iv = FR("wks"), Pm = OR.Symbol, NN = Pm && Pm.for, LR = PN ? Pm : Pm && Pm.withoutSetter || MR;
        IN.exports = function(M) {
          if (!kN(Iv, M) || !(AN || typeof Iv[M] == "string")) {
            var re = "Symbol." + M;
            AN && kN(Pm, M) ? Iv[M] = Pm[M] : PN && NN ? Iv[M] = NN(re) : Iv[M] = LR(re);
          }
          return Iv[M];
        };
      });
      var MN = Bn((rW, FN) => {
        var RR = qc(), BR = r1(), wN = Nm(), ON = tT(), JR = pN(), jR = gN(), UR = Vy(), zR = RR.TypeError, WR = UR("toPrimitive");
        FN.exports = function(M, re) {
          if (!wN(M) || ON(M))
            return M;
          var Ve = JR(M, WR), Ke;
          if (Ve) {
            if (re === void 0 && (re = "default"), Ke = BR(Ve, M, re), !wN(Ke) || ON(Ke))
              return Ke;
            throw zR("Can't convert object to primitive value");
          }
          return re === void 0 && (re = "number"), jR(M, re);
        };
      });
      var lT = Bn((iW, LN) => {
        var qR = MN(), VR = tT();
        LN.exports = function(M) {
          var re = qR(M, "string");
          return VR(re) ? re : re + "";
        };
      });
      var JN = Bn((tW, BN) => {
        var KR = qc(), RN = Nm(), fT = KR.document, GR = RN(fT) && RN(fT.createElement);
        BN.exports = function(M) {
          return GR ? fT.createElement(M) : {};
        };
      });
      var _T = Bn((aW, jN) => {
        var HR = Am(), XR = cg(), QR = JN();
        jN.exports = !HR && !XR(function() {
          return Object.defineProperty(QR("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var pT = Bn((zN) => {
        var YR = Am(), $R = r1(), ZR = FA(), eB = XS(), rB = t1(), iB = lT(), tB = Wg(), aB = _T(), UN = Object.getOwnPropertyDescriptor;
        zN.f = YR ? UN : function(re, Ve) {
          if (re = rB(re), Ve = iB(Ve), aB)
            try {
              return UN(re, Ve);
            } catch {
            }
          if (tB(re, Ve))
            return eB(!$R(ZR.f, re, Ve), re[Ve]);
        };
      });
      var qN = Bn((oW, WN) => {
        var nB = Am(), oB = cg();
        WN.exports = nB && oB(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var dT = Bn((sW, KN) => {
        var VN = qc(), sB = Nm(), cB = VN.String, uB = VN.TypeError;
        KN.exports = function(M) {
          if (sB(M))
            return M;
          throw uB(cB(M) + " is not an object");
        };
      });
      var hT = Bn((HN) => {
        var lB = qc(), fB = Am(), _B = _T(), pB = qN(), c1 = dT(), GN = lT(), dB = lB.TypeError, gT = Object.defineProperty, gB = Object.getOwnPropertyDescriptor, mT = "enumerable", vT = "configurable", yT = "writable";
        HN.f = fB ? pB ? function(re, Ve, Ke) {
          if (c1(re), Ve = GN(Ve), c1(Ke), typeof re == "function" && Ve === "prototype" && "value" in Ke && yT in Ke && !Ke[yT]) {
            var oi = gB(re, Ve);
            oi && oi[yT] && (re[Ve] = Ke.value, Ke = { configurable: vT in Ke ? Ke[vT] : oi[vT], enumerable: mT in Ke ? Ke[mT] : oi[mT], writable: false });
          }
          return gT(re, Ve, Ke);
        } : gT : function(re, Ve, Ke) {
          if (c1(re), Ve = GN(Ve), c1(Ke), _B)
            try {
              return gT(re, Ve, Ke);
            } catch {
            }
          if ("get" in Ke || "set" in Ke)
            throw dB("Accessors not supported");
          return "value" in Ke && (re[Ve] = Ke.value), re;
        };
      });
      var u1 = Bn((uW, XN) => {
        var mB = Am(), vB = hT(), yB = XS();
        XN.exports = mB ? function(M, re, Ve) {
          return vB.f(M, re, yB(1, Ve));
        } : function(M, re, Ve) {
          return M[re] = Ve, M;
        };
      });
      var l1 = Bn((lW, QN) => {
        var hB = dp(), DB = gp(), DT = s1(), bB = hB(Function.toString);
        DB(DT.inspectSource) || (DT.inspectSource = function(M) {
          return bB(M);
        });
        QN.exports = DT.inspectSource;
      });
      var ZN = Bn((fW, $N) => {
        var SB = qc(), TB = gp(), xB = l1(), YN = SB.WeakMap;
        $N.exports = TB(YN) && /native code/.test(xB(YN));
      });
      var iP = Bn((_W, rP) => {
        var EB = sT(), CB = uT(), eP = EB("keys");
        rP.exports = function(M) {
          return eP[M] || (eP[M] = CB(M));
        };
      });
      var bT = Bn((pW, tP) => {
        tP.exports = {};
      });
      var uP = Bn((dW, cP) => {
        var kB = ZN(), sP = qc(), ST = dp(), AB = Nm(), NB = u1(), TT = Wg(), xT = s1(), PB = iP(), IB = bT(), aP = "Object already initialized", CT = sP.TypeError, wB = sP.WeakMap, f1, Ky, _1, OB = function(M) {
          return _1(M) ? Ky(M) : f1(M, {});
        }, FB = function(M) {
          return function(re) {
            var Ve;
            if (!AB(re) || (Ve = Ky(re)).type !== M)
              throw CT("Incompatible receiver, " + M + " required");
            return Ve;
          };
        };
        kB || xT.state ? (qg = xT.state || (xT.state = new wB()), nP = ST(qg.get), ET = ST(qg.has), oP = ST(qg.set), f1 = function(M, re) {
          if (ET(qg, M))
            throw new CT(aP);
          return re.facade = M, oP(qg, M, re), re;
        }, Ky = function(M) {
          return nP(qg, M) || {};
        }, _1 = function(M) {
          return ET(qg, M);
        }) : (Im = PB("state"), IB[Im] = true, f1 = function(M, re) {
          if (TT(M, Im))
            throw new CT(aP);
          return re.facade = M, NB(M, Im, re), re;
        }, Ky = function(M) {
          return TT(M, Im) ? M[Im] : {};
        }, _1 = function(M) {
          return TT(M, Im);
        });
        var qg, nP, ET, oP, Im;
        cP.exports = { set: f1, get: Ky, has: _1, enforce: OB, getterFor: FB };
      });
      var _P = Bn((gW, fP) => {
        var kT = Am(), MB = Wg(), lP = Function.prototype, LB = kT && Object.getOwnPropertyDescriptor, AT = MB(lP, "name"), RB = AT && function() {
        }.name === "something", BB = AT && (!kT || kT && LB(lP, "name").configurable);
        fP.exports = { EXISTS: AT, PROPER: RB, CONFIGURABLE: BB };
      });
      var vP = Bn((mW, mP) => {
        var JB = qc(), pP = gp(), jB = Wg(), dP = u1(), UB = o1(), zB = l1(), gP = uP(), WB = _P().CONFIGURABLE, qB = gP.get, VB = gP.enforce, KB = String(String).split("String");
        (mP.exports = function(M, re, Ve, Ke) {
          var oi = Ke ? !!Ke.unsafe : false, kr = Ke ? !!Ke.enumerable : false, pr = Ke ? !!Ke.noTargetGet : false, Lr = Ke && Ke.name !== void 0 ? Ke.name : re, ar;
          if (pP(Ve) && (String(Lr).slice(0, 7) === "Symbol(" && (Lr = "[" + String(Lr).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!jB(Ve, "name") || WB && Ve.name !== Lr) && dP(Ve, "name", Lr), ar = VB(Ve), ar.source || (ar.source = KB.join(typeof Lr == "string" ? Lr : ""))), M === JB) {
            kr ? M[re] = Ve : UB(re, Ve);
            return;
          } else
            oi ? !pr && M[re] && (kr = true) : delete M[re];
          kr ? M[re] = Ve : dP(M, re, Ve);
        })(Function.prototype, "toString", function() {
          return pP(this) && qB(this).source || zB(this);
        });
      });
      var NT = Bn((vW, yP) => {
        var GB = Math.ceil, HB = Math.floor;
        yP.exports = function(M) {
          var re = +M;
          return re !== re || re === 0 ? 0 : (re > 0 ? HB : GB)(re);
        };
      });
      var DP = Bn((yW, hP) => {
        var XB = NT(), QB = Math.max, YB = Math.min;
        hP.exports = function(M, re) {
          var Ve = XB(M);
          return Ve < 0 ? QB(Ve + re, 0) : YB(Ve, re);
        };
      });
      var SP = Bn((hW, bP) => {
        var $B = NT(), ZB = Math.min;
        bP.exports = function(M) {
          return M > 0 ? ZB($B(M), 9007199254740991) : 0;
        };
      });
      var p1 = Bn((DW, TP) => {
        var eJ = SP();
        TP.exports = function(M) {
          return eJ(M.length);
        };
      });
      var CP = Bn((bW, EP) => {
        var rJ = t1(), iJ = DP(), tJ = p1(), xP = function(M) {
          return function(re, Ve, Ke) {
            var oi = rJ(re), kr = tJ(oi), pr = iJ(Ke, kr), Lr;
            if (M && Ve != Ve) {
              for (; kr > pr; )
                if (Lr = oi[pr++], Lr != Lr)
                  return true;
            } else
              for (; kr > pr; pr++)
                if ((M || pr in oi) && oi[pr] === Ve)
                  return M || pr || 0;
            return !M && -1;
          };
        };
        EP.exports = { includes: xP(true), indexOf: xP(false) };
      });
      var NP = Bn((SW, AP) => {
        var aJ = dp(), PT = Wg(), nJ = t1(), oJ = CP().indexOf, sJ = bT(), kP = aJ([].push);
        AP.exports = function(M, re) {
          var Ve = nJ(M), Ke = 0, oi = [], kr;
          for (kr in Ve)
            !PT(sJ, kr) && PT(Ve, kr) && kP(oi, kr);
          for (; re.length > Ke; )
            PT(Ve, kr = re[Ke++]) && (~oJ(oi, kr) || kP(oi, kr));
          return oi;
        };
      });
      var IP = Bn((TW, PP) => {
        PP.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var OP = Bn((wP) => {
        var cJ = NP(), uJ = IP(), lJ = uJ.concat("length", "prototype");
        wP.f = Object.getOwnPropertyNames || function(re) {
          return cJ(re, lJ);
        };
      });
      var MP = Bn((FP) => {
        FP.f = Object.getOwnPropertySymbols;
      });
      var RP = Bn((CW, LP) => {
        var fJ = qy(), _J = dp(), pJ = OP(), dJ = MP(), gJ = dT(), mJ = _J([].concat);
        LP.exports = fJ("Reflect", "ownKeys") || function(re) {
          var Ve = pJ.f(gJ(re)), Ke = dJ.f;
          return Ke ? mJ(Ve, Ke(re)) : Ve;
        };
      });
      var jP = Bn((kW, JP) => {
        var BP = Wg(), vJ = RP(), yJ = pT(), hJ = hT();
        JP.exports = function(M, re, Ve) {
          for (var Ke = vJ(re), oi = hJ.f, kr = yJ.f, pr = 0; pr < Ke.length; pr++) {
            var Lr = Ke[pr];
            !BP(M, Lr) && !(Ve && BP(Ve, Lr)) && oi(M, Lr, kr(re, Lr));
          }
        };
      });
      var zP = Bn((AW, UP) => {
        var DJ = cg(), bJ = gp(), SJ = /#|\.prototype\./, Gy = function(M, re) {
          var Ve = xJ[TJ(M)];
          return Ve == CJ ? true : Ve == EJ ? false : bJ(re) ? DJ(re) : !!re;
        }, TJ = Gy.normalize = function(M) {
          return String(M).replace(SJ, ".").toLowerCase();
        }, xJ = Gy.data = {}, EJ = Gy.NATIVE = "N", CJ = Gy.POLYFILL = "P";
        UP.exports = Gy;
      });
      var wT = Bn((NW, WP) => {
        var IT = qc(), kJ = pT().f, AJ = u1(), NJ = vP(), PJ = o1(), IJ = jP(), wJ = zP();
        WP.exports = function(M, re) {
          var Ve = M.target, Ke = M.global, oi = M.stat, kr, pr, Lr, ar, ke, e2;
          if (Ke ? pr = IT : oi ? pr = IT[Ve] || PJ(Ve, {}) : pr = (IT[Ve] || {}).prototype, pr)
            for (Lr in re) {
              if (ke = re[Lr], M.noTargetGet ? (e2 = kJ(pr, Lr), ar = e2 && e2.value) : ar = pr[Lr], kr = wJ(Ke ? Lr : Ve + (oi ? "." : "#") + Lr, M.forced), !kr && ar !== void 0) {
                if (typeof ke == typeof ar)
                  continue;
                IJ(ke, ar);
              }
              (M.sham || ar && ar.sham) && AJ(ke, "sham", true), NJ(pr, Lr, ke, M);
            }
        };
      });
      var qP = Bn(() => {
        var OJ = wT(), FJ = qc();
        OJ({ global: true }, { globalThis: FJ });
      });
      var VP = Bn(() => {
        qP();
      });
      var OT = Bn((FW, KP) => {
        var MJ = i1();
        KP.exports = Array.isArray || function(re) {
          return MJ(re) == "Array";
        };
      });
      var XP = Bn((MW, HP) => {
        var GP = dp(), LJ = n1(), RJ = Z0(), BJ = GP(GP.bind);
        HP.exports = function(M, re) {
          return LJ(M), re === void 0 ? M : RJ ? BJ(M, re) : function() {
            return M.apply(re, arguments);
          };
        };
      });
      var $P = Bn((LW, YP) => {
        "use strict";
        var JJ = qc(), jJ = OT(), UJ = p1(), zJ = XP(), WJ = JJ.TypeError, QP = function(M, re, Ve, Ke, oi, kr, pr, Lr) {
          for (var ar = oi, ke = 0, e2 = pr ? zJ(pr, Lr) : false, a, C; ke < Ke; ) {
            if (ke in Ve) {
              if (a = e2 ? e2(Ve[ke], ke, re) : Ve[ke], kr > 0 && jJ(a))
                C = UJ(a), ar = QP(M, re, a, C, ar, kr - 1) - 1;
              else {
                if (ar >= 9007199254740991)
                  throw WJ("Exceed the acceptable array length");
                M[ar] = a;
              }
              ar++;
            }
            ke++;
          }
          return ar;
        };
        YP.exports = QP;
      });
      var r4 = Bn((RW, e4) => {
        var qJ = Vy(), VJ = qJ("toStringTag"), ZP = {};
        ZP[VJ] = "z";
        e4.exports = String(ZP) === "[object z]";
      });
      var t4 = Bn((BW, i4) => {
        var KJ = qc(), GJ = r4(), HJ = gp(), d1 = i1(), XJ = Vy(), QJ = XJ("toStringTag"), YJ = KJ.Object, $J = d1(function() {
          return arguments;
        }()) == "Arguments", ZJ = function(M, re) {
          try {
            return M[re];
          } catch {
          }
        };
        i4.exports = GJ ? d1 : function(M) {
          var re, Ve, Ke;
          return M === void 0 ? "Undefined" : M === null ? "Null" : typeof (Ve = ZJ(re = YJ(M), QJ)) == "string" ? Ve : $J ? d1(re) : (Ke = d1(re)) == "Object" && HJ(re.callee) ? "Arguments" : Ke;
        };
      });
      var u4 = Bn((JW, c4) => {
        var ej = dp(), rj = cg(), a4 = gp(), ij = t4(), tj = qy(), aj = l1(), n4 = function() {
        }, nj = [], o4 = tj("Reflect", "construct"), FT = /^\s*(?:class|function)\b/, oj = ej(FT.exec), sj = !FT.exec(n4), Hy = function(re) {
          if (!a4(re))
            return false;
          try {
            return o4(n4, nj, re), true;
          } catch {
            return false;
          }
        }, s4 = function(re) {
          if (!a4(re))
            return false;
          switch (ij(re)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return sj || !!oj(FT, aj(re));
          } catch {
            return true;
          }
        };
        s4.sham = true;
        c4.exports = !o4 || rj(function() {
          var M;
          return Hy(Hy.call) || !Hy(Object) || !Hy(function() {
            M = true;
          }) || M;
        }) ? s4 : Hy;
      });
      var p4 = Bn((jW, _4) => {
        var cj = qc(), l4 = OT(), uj = u4(), lj = Nm(), fj = Vy(), _j = fj("species"), f4 = cj.Array;
        _4.exports = function(M) {
          var re;
          return l4(M) && (re = M.constructor, uj(re) && (re === f4 || l4(re.prototype)) ? re = void 0 : lj(re) && (re = re[_j], re === null && (re = void 0))), re === void 0 ? f4 : re;
        };
      });
      var g4 = Bn((UW, d4) => {
        var pj = p4();
        d4.exports = function(M, re) {
          return new (pj(M))(re === 0 ? 0 : re);
        };
      });
      var m4 = Bn(() => {
        "use strict";
        var dj = wT(), gj = $P(), mj = n1(), vj = cT(), yj = p1(), hj = g4();
        dj({ target: "Array", proto: true }, { flatMap: function(re) {
          var Ve = vj(this), Ke = yj(Ve), oi;
          return mj(re), oi = hj(Ve, 0), oi.length = gj(oi, Ve, Ve, Ke, 0, 1, re, arguments.length > 1 ? arguments[1] : void 0), oi;
        } });
      });
      var Dz = Bn((qW, f3) => {
        VP();
        m4();
        var zT = Object.defineProperty, Dj = Object.getOwnPropertyDescriptor, WT = Object.getOwnPropertyNames, bj = Object.prototype.hasOwnProperty, Qy = (M, re) => function() {
          return M && (re = (0, M[WT(M)[0]])(M = 0)), re;
        }, Oa = (M, re) => function() {
          return re || (0, M[WT(M)[0]])((re = { exports: {} }).exports, re), re.exports;
        }, h1 = (M, re) => {
          for (var Ve in re)
            zT(M, Ve, { get: re[Ve], enumerable: true });
        }, Sj = (M, re, Ve, Ke) => {
          if (re && typeof re == "object" || typeof re == "function")
            for (let oi of WT(re))
              !bj.call(M, oi) && oi !== Ve && zT(M, oi, { get: () => re[oi], enumerable: !(Ke = Dj(re, oi)) || Ke.enumerable });
          return M;
        }, mp = (M) => Sj(zT({}, "__esModule", { value: true }), M), v4, y4, Eu, Ea = Qy({ "<define:process>"() {
          v4 = {}, y4 = [], Eu = { env: v4, argv: y4 };
        } }), S4 = Oa({ "src/common/parser-create-error.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke, oi) {
            let kr = new SyntaxError(Ke + " (" + oi.start.line + ":" + oi.start.column + ")");
            return kr.loc = oi, kr;
          }
          re.exports = Ve;
        } }), Tj = Oa({ "src/utils/try-combinations.js"(M, re) {
          "use strict";
          Ea();
          function Ve() {
            let Ke;
            for (var oi = arguments.length, kr = new Array(oi), pr = 0; pr < oi; pr++)
              kr[pr] = arguments[pr];
            for (let [Lr, ar] of kr.entries())
              try {
                return { result: ar() };
              } catch (ke) {
                Lr === 0 && (Ke = ke);
              }
            return { error: Ke };
          }
          re.exports = Ve;
        } }), T4 = {};
        h1(T4, { EOL: () => RT, arch: () => xj, cpus: () => P4, default: () => M4, endianness: () => x4, freemem: () => A4, getNetworkInterfaces: () => F4, hostname: () => E4, loadavg: () => C4, networkInterfaces: () => O4, platform: () => Ej, release: () => w4, tmpDir: () => MT, tmpdir: () => LT, totalmem: () => N4, type: () => I4, uptime: () => k4 });
        function x4() {
          if (typeof g1 > "u") {
            var M = new ArrayBuffer(2), re = new Uint8Array(M), Ve = new Uint16Array(M);
            if (re[0] = 1, re[1] = 2, Ve[0] === 258)
              g1 = "BE";
            else if (Ve[0] === 513)
              g1 = "LE";
            else
              throw new Error("unable to figure out endianess");
          }
          return g1;
        }
        function E4() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function C4() {
          return [];
        }
        function k4() {
          return 0;
        }
        function A4() {
          return Number.MAX_VALUE;
        }
        function N4() {
          return Number.MAX_VALUE;
        }
        function P4() {
          return [];
        }
        function I4() {
          return "Browser";
        }
        function w4() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function O4() {
        }
        function F4() {
        }
        function xj() {
          return "javascript";
        }
        function Ej() {
          return "browser";
        }
        function MT() {
          return "/tmp";
        }
        var g1, LT, RT, M4, Cj = Qy({ "node-modules-polyfills:os"() {
          Ea(), LT = MT, RT = `
`, M4 = { EOL: RT, tmpdir: LT, tmpDir: MT, networkInterfaces: O4, getNetworkInterfaces: F4, release: w4, type: I4, cpus: P4, totalmem: N4, freemem: A4, uptime: k4, loadavg: C4, hostname: E4, endianness: x4 };
        } }), kj = Oa({ "node-modules-polyfills-commonjs:os"(M, re) {
          Ea();
          var Ve = (Cj(), mp(T4));
          if (Ve && Ve.default) {
            re.exports = Ve.default;
            for (let Ke in Ve)
              re.exports[Ke] = Ve[Ke];
          } else
            Ve && (re.exports = Ve);
        } }), Aj = Oa({ "node_modules/detect-newline/index.js"(M, re) {
          "use strict";
          Ea();
          var Ve = (Ke) => {
            if (typeof Ke != "string")
              throw new TypeError("Expected a string");
            let oi = Ke.match(/(?:\r?\n)/g) || [];
            if (oi.length === 0)
              return;
            let kr = oi.filter((Lr) => Lr === `\r
`).length, pr = oi.length - kr;
            return kr > pr ? `\r
` : `
`;
          };
          re.exports = Ve, re.exports.graceful = (Ke) => typeof Ke == "string" && Ve(Ke) || `
`;
        } }), Nj = Oa({ "node_modules/jest-docblock/build/index.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.extract = w, M.parse = E, M.parseWithComments = Q, M.print = le, M.strip = B;
          function re() {
            let p = kj();
            return re = function() {
              return p;
            }, p;
          }
          function Ve() {
            let p = Ke(Aj());
            return Ve = function() {
              return p;
            }, p;
          }
          function Ke(p) {
            return p && p.__esModule ? p : { default: p };
          }
          var oi = /\*\/$/, kr = /^\/\*\*/, pr = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, Lr = /(^|\s+)\/\/([^\r\n]*)/g, ar = /^(\r?\n)+/, ke = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, e2 = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, a = /(\r?\n|^) *\* ?/g, C = [];
          function w(p) {
            let m2 = p.match(pr);
            return m2 ? m2[0].trimLeft() : "";
          }
          function B(p) {
            let m2 = p.match(pr);
            return m2 && m2[0] ? p.substring(m2[0].length) : p;
          }
          function E(p) {
            return Q(p).pragmas;
          }
          function Q(p) {
            let m2 = (0, Ve().default)(p) || re().EOL;
            p = p.replace(kr, "").replace(oi, "").replace(a, "$1");
            let G = "";
            for (; G !== p; )
              G = p, p = p.replace(ke, "".concat(m2, "$1 $2").concat(m2));
            p = p.replace(ar, "").trimRight();
            let oe = /* @__PURE__ */ Object.create(null), f4 = p.replace(e2, "").replace(ar, "").trimRight(), T;
            for (; T = e2.exec(p); ) {
              let K = T[2].replace(Lr, "");
              typeof oe[T[1]] == "string" || Array.isArray(oe[T[1]]) ? oe[T[1]] = C.concat(oe[T[1]], K) : oe[T[1]] = K;
            }
            return { comments: f4, pragmas: oe };
          }
          function le(p) {
            let { comments: m2 = "", pragmas: G = {} } = p, oe = (0, Ve().default)(m2) || re().EOL, f4 = "/**", T = " *", K = " */", b = Object.keys(G), se = b.map((ie) => N(ie, G[ie])).reduce((ie, R) => ie.concat(R), []).map((ie) => T + " " + ie + oe).join("");
            if (!m2) {
              if (b.length === 0)
                return "";
              if (b.length === 1 && !Array.isArray(G[b[0]])) {
                let ie = G[b[0]];
                return "".concat(f4, " ").concat(N(b[0], ie)[0]).concat(K);
              }
            }
            let J = m2.split(oe).map((ie) => "".concat(T, " ").concat(ie)).join(oe) + oe;
            return f4 + oe + (m2 ? J : "") + (m2 && b.length ? T + oe : "") + se + K;
          }
          function N(p, m2) {
            return C.concat(m2).map((G) => "@".concat(p, " ").concat(G).trim());
          }
        } }), Pj = Oa({ "src/common/end-of-line.js"(M, re) {
          "use strict";
          Ea();
          function Ve(pr) {
            let Lr = pr.indexOf("\r");
            return Lr >= 0 ? pr.charAt(Lr + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function Ke(pr) {
            switch (pr) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function oi(pr, Lr) {
            let ar;
            switch (Lr) {
              case `
`:
                ar = /\n/g;
                break;
              case "\r":
                ar = /\r/g;
                break;
              case `\r
`:
                ar = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(Lr), "."));
            }
            let ke = pr.match(ar);
            return ke ? ke.length : 0;
          }
          function kr(pr) {
            return pr.replace(/\r\n?/g, `
`);
          }
          re.exports = { guessEndOfLine: Ve, convertEndOfLineToChars: Ke, countEndOfLineChars: oi, normalizeEndOfLine: kr };
        } }), Ij = Oa({ "src/language-js/utils/get-shebang.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke) {
            if (!Ke.startsWith("#!"))
              return "";
            let oi = Ke.indexOf(`
`);
            return oi === -1 ? Ke : Ke.slice(0, oi);
          }
          re.exports = Ve;
        } }), wj = Oa({ "src/language-js/pragma.js"(M, re) {
          "use strict";
          Ea();
          var { parseWithComments: Ve, strip: Ke, extract: oi, print: kr } = Nj(), { normalizeEndOfLine: pr } = Pj(), Lr = Ij();
          function ar(a) {
            let C = Lr(a);
            C && (a = a.slice(C.length + 1));
            let w = oi(a), { pragmas: B, comments: E } = Ve(w);
            return { shebang: C, text: a, pragmas: B, comments: E };
          }
          function ke(a) {
            let C = Object.keys(ar(a).pragmas);
            return C.includes("prettier") || C.includes("format");
          }
          function e2(a) {
            let { shebang: C, text: w, pragmas: B, comments: E } = ar(a), Q = Ke(w), le = kr({ pragmas: Object.assign({ format: "" }, B), comments: E.trimStart() });
            return (C ? "".concat(C, `
`) : "") + pr(le) + (Q.startsWith(`
`) ? `
` : `

`) + Q;
          }
          re.exports = { hasPragma: ke, insertPragma: e2 };
        } }), Oj = Oa({ "src/utils/is-non-empty-array.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke) {
            return Array.isArray(Ke) && Ke.length > 0;
          }
          re.exports = Ve;
        } }), L4 = Oa({ "src/language-js/loc.js"(M, re) {
          "use strict";
          Ea();
          var Ve = Oj();
          function Ke(ar, ke) {
            let { ignoreDecorators: e2 } = ke || {};
            if (!e2) {
              let a = ar.declaration && ar.declaration.decorators || ar.decorators;
              if (Ve(a))
                return Ke(a[0]);
            }
            return ar.range ? ar.range[0] : ar.start;
          }
          function oi(ar) {
            return ar.range ? ar.range[1] : ar.end;
          }
          function kr(ar, ke) {
            let e2 = Ke(ar);
            return Number.isInteger(e2) && e2 === Ke(ke);
          }
          function pr(ar, ke) {
            let e2 = oi(ar);
            return Number.isInteger(e2) && e2 === oi(ke);
          }
          function Lr(ar, ke) {
            return kr(ar, ke) && pr(ar, ke);
          }
          re.exports = { locStart: Ke, locEnd: oi, hasSameLocStart: kr, hasSameLoc: Lr };
        } }), Fj = Oa({ "src/language-js/parse/utils/create-parser.js"(M, re) {
          "use strict";
          Ea();
          var { hasPragma: Ve } = wj(), { locStart: Ke, locEnd: oi } = L4();
          function kr(pr) {
            return pr = typeof pr == "function" ? { parse: pr } : pr, Object.assign({ astFormat: "estree", hasPragma: Ve, locStart: Ke, locEnd: oi }, pr);
          }
          re.exports = kr;
        } }), Mj = Oa({ "src/language-js/parse/utils/replace-hashbang.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke) {
            return Ke.charAt(0) === "#" && Ke.charAt(1) === "!" ? "//" + Ke.slice(2) : Ke;
          }
          re.exports = Ve;
        } }), Lj = Oa({ "src/language-js/utils/is-ts-keyword-type.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke) {
            let { type: oi } = Ke;
            return oi.startsWith("TS") && oi.endsWith("Keyword");
          }
          re.exports = Ve;
        } }), Rj = Oa({ "src/language-js/utils/is-block-comment.js"(M, re) {
          "use strict";
          Ea();
          var Ve = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), Ke = (oi) => Ve.has(oi == null ? void 0 : oi.type);
          re.exports = Ke;
        } }), Bj = Oa({ "src/language-js/utils/is-type-cast-comment.js"(M, re) {
          "use strict";
          Ea();
          var Ve = Rj();
          function Ke(oi) {
            return Ve(oi) && oi.value[0] === "*" && /@type\b/.test(oi.value);
          }
          re.exports = Ke;
        } }), Jj = Oa({ "src/utils/get-last.js"(M, re) {
          "use strict";
          Ea();
          var Ve = (Ke) => Ke[Ke.length - 1];
          re.exports = Ve;
        } }), R4 = Oa({ "src/language-js/parse/postprocess/visit-node.js"(M, re) {
          "use strict";
          Ea();
          function Ve(Ke, oi) {
            if (Array.isArray(Ke)) {
              for (let kr = 0; kr < Ke.length; kr++)
                Ke[kr] = Ve(Ke[kr], oi);
              return Ke;
            }
            if (Ke && typeof Ke == "object" && typeof Ke.type == "string") {
              let kr = Object.keys(Ke);
              for (let pr = 0; pr < kr.length; pr++)
                Ke[kr[pr]] = Ve(Ke[kr[pr]], oi);
              return oi(Ke) || Ke;
            }
            return Ke;
          }
          re.exports = Ve;
        } }), B4 = Oa({ "src/language-js/parse/postprocess/throw-syntax-error.js"(M, re) {
          "use strict";
          Ea();
          var Ve = S4();
          function Ke(oi, kr) {
            let { start: pr, end: Lr } = oi.loc;
            throw Ve(kr, { start: { line: pr.line, column: pr.column + 1 }, end: { line: Lr.line, column: Lr.column + 1 } });
          }
          re.exports = Ke;
        } }), jj = Oa({ "src/language-js/parse/postprocess/typescript.js"(M, re) {
          "use strict";
          Ea();
          var Ve = R4(), Ke = B4();
          function oi(Lr, ar, ke) {
            let e2 = Lr.decorators;
            if (!Array.isArray(e2))
              return;
            let a = ar.decorators;
            (!Array.isArray(a) || a.length !== e2.length || e2.some((C) => {
              let w = ke.get(C);
              return !w || !a.includes(w);
            })) && Ke(ar, "Leading decorators must be attached to a class declaration");
          }
          function kr(Lr, ar) {
            Lr.kind !== 167 || Lr.modifiers && !Lr.modifiers.some((a) => a.kind === 126) || Lr.initializer && ar.value === null && Ke(ar, "Abstract property cannot have an initializer");
          }
          function pr(Lr, ar) {
            let { esTreeNodeToTSNodeMap: ke, tsNodeToESTreeNodeMap: e2 } = ar.tsParseResult;
            Ve(Lr, (a) => {
              let C = ke.get(a);
              if (!C)
                return;
              let w = e2.get(C);
              w === a && (oi(C, w, e2), kr(C, w));
            });
          }
          re.exports = { throwErrorForInvalidNodes: pr };
        } }), Uj = Oa({ "src/language-js/parse/postprocess/index.js"(M, re) {
          "use strict";
          Ea();
          var { locStart: Ve, locEnd: Ke } = L4(), oi = Lj(), kr = Bj(), pr = Jj(), Lr = R4(), { throwErrorForInvalidNodes: ar } = jj(), ke = B4();
          function e2(B, E) {
            if (E.parser === "typescript" && /@|abstract/.test(E.originalText) && ar(B, E), E.parser !== "typescript" && E.parser !== "flow" && E.parser !== "acorn" && E.parser !== "espree" && E.parser !== "meriyah") {
              let le = /* @__PURE__ */ new Set();
              B = Lr(B, (N) => {
                N.leadingComments && N.leadingComments.some(kr) && le.add(Ve(N));
              }), B = Lr(B, (N) => {
                if (N.type === "ParenthesizedExpression") {
                  let { expression: p } = N;
                  if (p.type === "TypeCastExpression")
                    return p.range = N.range, p;
                  let m2 = Ve(N);
                  if (!le.has(m2))
                    return p.extra = Object.assign(Object.assign({}, p.extra), {}, { parenthesized: true }), p;
                }
              });
            }
            return B = Lr(B, (le) => {
              switch (le.type) {
                case "ChainExpression":
                  return a(le.expression);
                case "LogicalExpression": {
                  if (C(le))
                    return w(le);
                  break;
                }
                case "VariableDeclaration": {
                  let N = pr(le.declarations);
                  N && N.init && Q(le, N);
                  break;
                }
                case "TSParenthesizedType":
                  return oi(le.typeAnnotation) || le.typeAnnotation.type === "TSThisType" || (le.typeAnnotation.range = [Ve(le), Ke(le)]), le.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof le.name == "string") {
                    let N = Ve(le);
                    le.name = { type: "Identifier", name: le.name, range: [N, N + le.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (E.parser === "typescript") {
                    let N = le.properties.find((p) => p.type === "Property" && p.value.type === "TSEmptyBodyFunctionExpression");
                    N && ke(N.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let N = pr(le.expressions);
                  le.range = [Ve(le), Math.min(Ke(N), Ke(le))];
                  break;
                }
                case "TopicReference":
                  E.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: N } = le;
                  if (E.parser === "meriyah" && N && N.type === "Identifier") {
                    let p = E.originalText.slice(Ve(N), Ke(N));
                    (p.startsWith('"') || p.startsWith("'")) && (le.exported = Object.assign(Object.assign({}, le.exported), {}, { type: "Literal", value: le.exported.name, raw: p }));
                  }
                  break;
                }
              }
            }), B;
            function Q(le, N) {
              E.originalText[Ke(N)] !== ";" && (le.range = [Ve(le), Ke(N)]);
            }
          }
          function a(B) {
            switch (B.type) {
              case "CallExpression":
                B.type = "OptionalCallExpression", B.callee = a(B.callee);
                break;
              case "MemberExpression":
                B.type = "OptionalMemberExpression", B.object = a(B.object);
                break;
              case "TSNonNullExpression":
                B.expression = a(B.expression);
                break;
            }
            return B;
          }
          function C(B) {
            return B.type === "LogicalExpression" && B.right.type === "LogicalExpression" && B.operator === B.right.operator;
          }
          function w(B) {
            return C(B) ? w({ type: "LogicalExpression", operator: B.operator, left: w({ type: "LogicalExpression", operator: B.operator, left: B.left, right: B.right.left, range: [Ve(B.left), Ke(B.right.left)] }), right: B.right.right, range: [Ve(B), Ke(B)] }) : B;
          }
          re.exports = e2;
        } }), zj = Oa({ "node_modules/ms/index.js"(M, re) {
          Ea();
          var Ve = 1e3, Ke = Ve * 60, oi = Ke * 60, kr = oi * 24, pr = kr * 7, Lr = kr * 365.25;
          re.exports = function(C, w) {
            w = w || {};
            var B = typeof C;
            if (B === "string" && C.length > 0)
              return ar(C);
            if (B === "number" && isFinite(C))
              return w.long ? e2(C) : ke(C);
            throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(C));
          };
          function ar(C) {
            if (C = String(C), !(C.length > 100)) {
              var w = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(C);
              if (!!w) {
                var B = parseFloat(w[1]), E = (w[2] || "ms").toLowerCase();
                switch (E) {
                  case "years":
                  case "year":
                  case "yrs":
                  case "yr":
                  case "y":
                    return B * Lr;
                  case "weeks":
                  case "week":
                  case "w":
                    return B * pr;
                  case "days":
                  case "day":
                  case "d":
                    return B * kr;
                  case "hours":
                  case "hour":
                  case "hrs":
                  case "hr":
                  case "h":
                    return B * oi;
                  case "minutes":
                  case "minute":
                  case "mins":
                  case "min":
                  case "m":
                    return B * Ke;
                  case "seconds":
                  case "second":
                  case "secs":
                  case "sec":
                  case "s":
                    return B * Ve;
                  case "milliseconds":
                  case "millisecond":
                  case "msecs":
                  case "msec":
                  case "ms":
                    return B;
                  default:
                    return;
                }
              }
            }
          }
          function ke(C) {
            var w = Math.abs(C);
            return w >= kr ? Math.round(C / kr) + "d" : w >= oi ? Math.round(C / oi) + "h" : w >= Ke ? Math.round(C / Ke) + "m" : w >= Ve ? Math.round(C / Ve) + "s" : C + "ms";
          }
          function e2(C) {
            var w = Math.abs(C);
            return w >= kr ? a(C, w, kr, "day") : w >= oi ? a(C, w, oi, "hour") : w >= Ke ? a(C, w, Ke, "minute") : w >= Ve ? a(C, w, Ve, "second") : C + " ms";
          }
          function a(C, w, B, E) {
            var Q = w >= B * 1.5;
            return Math.round(C / B) + " " + E + (Q ? "s" : "");
          }
        } }), Wj = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/debug/src/common.js"(M, re) {
          Ea();
          function Ve(Ke) {
            kr.debug = kr, kr.default = kr, kr.coerce = a, kr.disable = ar, kr.enable = Lr, kr.enabled = ke, kr.humanize = zj(), kr.destroy = C, Object.keys(Ke).forEach((w) => {
              kr[w] = Ke[w];
            }), kr.names = [], kr.skips = [], kr.formatters = {};
            function oi(w) {
              let B = 0;
              for (let E = 0; E < w.length; E++)
                B = (B << 5) - B + w.charCodeAt(E), B |= 0;
              return kr.colors[Math.abs(B) % kr.colors.length];
            }
            kr.selectColor = oi;
            function kr(w) {
              let B, E = null, Q, le;
              function N() {
                for (var p = arguments.length, m2 = new Array(p), G = 0; G < p; G++)
                  m2[G] = arguments[G];
                if (!N.enabled)
                  return;
                let oe = N, f4 = Number(new Date()), T = f4 - (B || f4);
                oe.diff = T, oe.prev = B, oe.curr = f4, B = f4, m2[0] = kr.coerce(m2[0]), typeof m2[0] != "string" && m2.unshift("%O");
                let K = 0;
                m2[0] = m2[0].replace(/%([a-zA-Z%])/g, (se, J) => {
                  if (se === "%%")
                    return "%";
                  K++;
                  let ie = kr.formatters[J];
                  if (typeof ie == "function") {
                    let R = m2[K];
                    se = ie.call(oe, R), m2.splice(K, 1), K--;
                  }
                  return se;
                }), kr.formatArgs.call(oe, m2), (oe.log || kr.log).apply(oe, m2);
              }
              return N.namespace = w, N.useColors = kr.useColors(), N.color = kr.selectColor(w), N.extend = pr, N.destroy = kr.destroy, Object.defineProperty(N, "enabled", { enumerable: true, configurable: false, get: () => E !== null ? E : (Q !== kr.namespaces && (Q = kr.namespaces, le = kr.enabled(w)), le), set: (p) => {
                E = p;
              } }), typeof kr.init == "function" && kr.init(N), N;
            }
            function pr(w, B) {
              let E = kr(this.namespace + (typeof B > "u" ? ":" : B) + w);
              return E.log = this.log, E;
            }
            function Lr(w) {
              kr.save(w), kr.namespaces = w, kr.names = [], kr.skips = [];
              let B, E = (typeof w == "string" ? w : "").split(/[\s,]+/), Q = E.length;
              for (B = 0; B < Q; B++)
                !E[B] || (w = E[B].replace(/\*/g, ".*?"), w[0] === "-" ? kr.skips.push(new RegExp("^" + w.slice(1) + "$")) : kr.names.push(new RegExp("^" + w + "$")));
            }
            function ar() {
              let w = [...kr.names.map(e2), ...kr.skips.map(e2).map((B) => "-" + B)].join(",");
              return kr.enable(""), w;
            }
            function ke(w) {
              if (w[w.length - 1] === "*")
                return true;
              let B, E;
              for (B = 0, E = kr.skips.length; B < E; B++)
                if (kr.skips[B].test(w))
                  return false;
              for (B = 0, E = kr.names.length; B < E; B++)
                if (kr.names[B].test(w))
                  return true;
              return false;
            }
            function e2(w) {
              return w.toString().substring(2, w.toString().length - 2).replace(/\.\*\?$/, "*");
            }
            function a(w) {
              return w instanceof Error ? w.stack || w.message : w;
            }
            function C() {
              console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`.");
            }
            return kr.enable(kr.load()), kr;
          }
          re.exports = Ve;
        } }), wm = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/debug/src/browser.js"(M, re) {
          Ea(), M.formatArgs = Ke, M.save = oi, M.load = kr, M.useColors = Ve, M.storage = pr(), M.destroy = (() => {
            let ar = false;
            return () => {
              ar || (ar = true, console.warn("Instance method `debug.destroy()` is deprecated and no longer does anything. It will be removed in the next major version of `debug`."));
            };
          })(), M.colors = ["#0000CC", "#0000FF", "#0033CC", "#0033FF", "#0066CC", "#0066FF", "#0099CC", "#0099FF", "#00CC00", "#00CC33", "#00CC66", "#00CC99", "#00CCCC", "#00CCFF", "#3300CC", "#3300FF", "#3333CC", "#3333FF", "#3366CC", "#3366FF", "#3399CC", "#3399FF", "#33CC00", "#33CC33", "#33CC66", "#33CC99", "#33CCCC", "#33CCFF", "#6600CC", "#6600FF", "#6633CC", "#6633FF", "#66CC00", "#66CC33", "#9900CC", "#9900FF", "#9933CC", "#9933FF", "#99CC00", "#99CC33", "#CC0000", "#CC0033", "#CC0066", "#CC0099", "#CC00CC", "#CC00FF", "#CC3300", "#CC3333", "#CC3366", "#CC3399", "#CC33CC", "#CC33FF", "#CC6600", "#CC6633", "#CC9900", "#CC9933", "#CCCC00", "#CCCC33", "#FF0000", "#FF0033", "#FF0066", "#FF0099", "#FF00CC", "#FF00FF", "#FF3300", "#FF3333", "#FF3366", "#FF3399", "#FF33CC", "#FF33FF", "#FF6600", "#FF6633", "#FF9900", "#FF9933", "#FFCC00", "#FFCC33"];
          function Ve() {
            return typeof window < "u" && window.process && (window.process.type === "renderer" || window.process.__nwjs) ? true : typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/(edge|trident)\/(\d+)/) ? false : typeof document < "u" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window < "u" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator < "u" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
          }
          function Ke(ar) {
            if (ar[0] = (this.useColors ? "%c" : "") + this.namespace + (this.useColors ? " %c" : " ") + ar[0] + (this.useColors ? "%c " : " ") + "+" + re.exports.humanize(this.diff), !this.useColors)
              return;
            let ke = "color: " + this.color;
            ar.splice(1, 0, ke, "color: inherit");
            let e2 = 0, a = 0;
            ar[0].replace(/%[a-zA-Z%]/g, (C) => {
              C !== "%%" && (e2++, C === "%c" && (a = e2));
            }), ar.splice(a, 0, ke);
          }
          M.log = console.debug || console.log || (() => {
          });
          function oi(ar) {
            try {
              ar ? M.storage.setItem("debug", ar) : M.storage.removeItem("debug");
            } catch {
            }
          }
          function kr() {
            let ar;
            try {
              ar = M.storage.getItem("debug");
            } catch {
            }
            return !ar && typeof Eu < "u" && "env" in Eu && (ar = Eu.env.DEBUG), ar;
          }
          function pr() {
            try {
              return localStorage;
            } catch {
            }
          }
          re.exports = Wj()(M);
          var { formatters: Lr } = re.exports;
          Lr.j = function(ar) {
            try {
              return JSON.stringify(ar);
            } catch (ke) {
              return "[UnexpectedJSONParseError]: " + ke.message;
            }
          };
        } }), qj = Oa({ "node_modules/is-extglob/index.js"(M, re) {
          Ea(), re.exports = function(Ke) {
            if (typeof Ke != "string" || Ke === "")
              return false;
            for (var oi; oi = /(\\).|([@?!+*]\(.*\))/g.exec(Ke); ) {
              if (oi[2])
                return true;
              Ke = Ke.slice(oi.index + oi[0].length);
            }
            return false;
          };
        } }), Vj = Oa({ "node_modules/is-glob/index.js"(M, re) {
          Ea();
          var Ve = qj(), Ke = { "{": "}", "(": ")", "[": "]" }, oi = function(pr) {
            if (pr[0] === "!")
              return true;
            for (var Lr = 0, ar = -2, ke = -2, e2 = -2, a = -2, C = -2; Lr < pr.length; ) {
              if (pr[Lr] === "*" || pr[Lr + 1] === "?" && /[\].+)]/.test(pr[Lr]) || ke !== -1 && pr[Lr] === "[" && pr[Lr + 1] !== "]" && (ke < Lr && (ke = pr.indexOf("]", Lr)), ke > Lr && (C === -1 || C > ke || (C = pr.indexOf("\\", Lr), C === -1 || C > ke))) || e2 !== -1 && pr[Lr] === "{" && pr[Lr + 1] !== "}" && (e2 = pr.indexOf("}", Lr), e2 > Lr && (C = pr.indexOf("\\", Lr), C === -1 || C > e2)) || a !== -1 && pr[Lr] === "(" && pr[Lr + 1] === "?" && /[:!=]/.test(pr[Lr + 2]) && pr[Lr + 3] !== ")" && (a = pr.indexOf(")", Lr), a > Lr && (C = pr.indexOf("\\", Lr), C === -1 || C > a)) || ar !== -1 && pr[Lr] === "(" && pr[Lr + 1] !== "|" && (ar < Lr && (ar = pr.indexOf("|", Lr)), ar !== -1 && pr[ar + 1] !== ")" && (a = pr.indexOf(")", ar), a > ar && (C = pr.indexOf("\\", ar), C === -1 || C > a))))
                return true;
              if (pr[Lr] === "\\") {
                var w = pr[Lr + 1];
                Lr += 2;
                var B = Ke[w];
                if (B) {
                  var E = pr.indexOf(B, Lr);
                  E !== -1 && (Lr = E + 1);
                }
                if (pr[Lr] === "!")
                  return true;
              } else
                Lr++;
            }
            return false;
          }, kr = function(pr) {
            if (pr[0] === "!")
              return true;
            for (var Lr = 0; Lr < pr.length; ) {
              if (/[*?{}()[\]]/.test(pr[Lr]))
                return true;
              if (pr[Lr] === "\\") {
                var ar = pr[Lr + 1];
                Lr += 2;
                var ke = Ke[ar];
                if (ke) {
                  var e2 = pr.indexOf(ke, Lr);
                  e2 !== -1 && (Lr = e2 + 1);
                }
                if (pr[Lr] === "!")
                  return true;
              } else
                Lr++;
            }
            return false;
          };
          re.exports = function(Lr, ar) {
            if (typeof Lr != "string" || Lr === "")
              return false;
            if (Ve(Lr))
              return true;
            var ke = oi;
            return ar && ar.strict === false && (ke = kr), ke(Lr);
          };
        } }), D1 = Oa({ "node_modules/semver/internal/constants.js"(M, re) {
          Ea();
          var Ve = "2.0.0", Ke = 256, oi = Number.MAX_SAFE_INTEGER || 9007199254740991, kr = 16;
          re.exports = { SEMVER_SPEC_VERSION: Ve, MAX_LENGTH: Ke, MAX_SAFE_INTEGER: oi, MAX_SAFE_COMPONENT_LENGTH: kr };
        } }), b1 = Oa({ "node_modules/semver/internal/debug.js"(M, re) {
          Ea();
          var Ve = typeof Eu == "object" && Eu.env && Eu.env.NODE_DEBUG && /\bsemver\b/i.test(Eu.env.NODE_DEBUG) ? function() {
            for (var Ke = arguments.length, oi = new Array(Ke), kr = 0; kr < Ke; kr++)
              oi[kr] = arguments[kr];
            return console.error("SEMVER", ...oi);
          } : () => {
          };
          re.exports = Ve;
        } }), wv = Oa({ "node_modules/semver/internal/re.js"(M, re) {
          Ea();
          var { MAX_SAFE_COMPONENT_LENGTH: Ve } = D1(), Ke = b1();
          M = re.exports = {};
          var oi = M.re = [], kr = M.src = [], pr = M.t = {}, Lr = 0, ar = (ke, e2, a) => {
            let C = Lr++;
            Ke(ke, C, e2), pr[ke] = C, kr[C] = e2, oi[C] = new RegExp(e2, a ? "g" : void 0);
          };
          ar("NUMERICIDENTIFIER", "0|[1-9]\\d*"), ar("NUMERICIDENTIFIERLOOSE", "[0-9]+"), ar("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*"), ar("MAINVERSION", "(".concat(kr[pr.NUMERICIDENTIFIER], ")\\.(").concat(kr[pr.NUMERICIDENTIFIER], ")\\.(").concat(kr[pr.NUMERICIDENTIFIER], ")")), ar("MAINVERSIONLOOSE", "(".concat(kr[pr.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(kr[pr.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(kr[pr.NUMERICIDENTIFIERLOOSE], ")")), ar("PRERELEASEIDENTIFIER", "(?:".concat(kr[pr.NUMERICIDENTIFIER], "|").concat(kr[pr.NONNUMERICIDENTIFIER], ")")), ar("PRERELEASEIDENTIFIERLOOSE", "(?:".concat(kr[pr.NUMERICIDENTIFIERLOOSE], "|").concat(kr[pr.NONNUMERICIDENTIFIER], ")")), ar("PRERELEASE", "(?:-(".concat(kr[pr.PRERELEASEIDENTIFIER], "(?:\\.").concat(kr[pr.PRERELEASEIDENTIFIER], ")*))")), ar("PRERELEASELOOSE", "(?:-?(".concat(kr[pr.PRERELEASEIDENTIFIERLOOSE], "(?:\\.").concat(kr[pr.PRERELEASEIDENTIFIERLOOSE], ")*))")), ar("BUILDIDENTIFIER", "[0-9A-Za-z-]+"), ar("BUILD", "(?:\\+(".concat(kr[pr.BUILDIDENTIFIER], "(?:\\.").concat(kr[pr.BUILDIDENTIFIER], ")*))")), ar("FULLPLAIN", "v?".concat(kr[pr.MAINVERSION]).concat(kr[pr.PRERELEASE], "?").concat(kr[pr.BUILD], "?")), ar("FULL", "^".concat(kr[pr.FULLPLAIN], "$")), ar("LOOSEPLAIN", "[v=\\s]*".concat(kr[pr.MAINVERSIONLOOSE]).concat(kr[pr.PRERELEASELOOSE], "?").concat(kr[pr.BUILD], "?")), ar("LOOSE", "^".concat(kr[pr.LOOSEPLAIN], "$")), ar("GTLT", "((?:<|>)?=?)"), ar("XRANGEIDENTIFIERLOOSE", "".concat(kr[pr.NUMERICIDENTIFIERLOOSE], "|x|X|\\*")), ar("XRANGEIDENTIFIER", "".concat(kr[pr.NUMERICIDENTIFIER], "|x|X|\\*")), ar("XRANGEPLAIN", "[v=\\s]*(".concat(kr[pr.XRANGEIDENTIFIER], ")(?:\\.(").concat(kr[pr.XRANGEIDENTIFIER], ")(?:\\.(").concat(kr[pr.XRANGEIDENTIFIER], ")(?:").concat(kr[pr.PRERELEASE], ")?").concat(kr[pr.BUILD], "?)?)?")), ar("XRANGEPLAINLOOSE", "[v=\\s]*(".concat(kr[pr.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(kr[pr.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(kr[pr.XRANGEIDENTIFIERLOOSE], ")(?:").concat(kr[pr.PRERELEASELOOSE], ")?").concat(kr[pr.BUILD], "?)?)?")), ar("XRANGE", "^".concat(kr[pr.GTLT], "\\s*").concat(kr[pr.XRANGEPLAIN], "$")), ar("XRANGELOOSE", "^".concat(kr[pr.GTLT], "\\s*").concat(kr[pr.XRANGEPLAINLOOSE], "$")), ar("COERCE", "(^|[^\\d])(\\d{1,".concat(Ve, "})(?:\\.(\\d{1,").concat(Ve, "}))?(?:\\.(\\d{1,").concat(Ve, "}))?(?:$|[^\\d])")), ar("COERCERTL", kr[pr.COERCE], true), ar("LONETILDE", "(?:~>?)"), ar("TILDETRIM", "(\\s*)".concat(kr[pr.LONETILDE], "\\s+"), true), M.tildeTrimReplace = "$1~", ar("TILDE", "^".concat(kr[pr.LONETILDE]).concat(kr[pr.XRANGEPLAIN], "$")), ar("TILDELOOSE", "^".concat(kr[pr.LONETILDE]).concat(kr[pr.XRANGEPLAINLOOSE], "$")), ar("LONECARET", "(?:\\^)"), ar("CARETTRIM", "(\\s*)".concat(kr[pr.LONECARET], "\\s+"), true), M.caretTrimReplace = "$1^", ar("CARET", "^".concat(kr[pr.LONECARET]).concat(kr[pr.XRANGEPLAIN], "$")), ar("CARETLOOSE", "^".concat(kr[pr.LONECARET]).concat(kr[pr.XRANGEPLAINLOOSE], "$")), ar("COMPARATORLOOSE", "^".concat(kr[pr.GTLT], "\\s*(").concat(kr[pr.LOOSEPLAIN], ")$|^$")), ar("COMPARATOR", "^".concat(kr[pr.GTLT], "\\s*(").concat(kr[pr.FULLPLAIN], ")$|^$")), ar("COMPARATORTRIM", "(\\s*)".concat(kr[pr.GTLT], "\\s*(").concat(kr[pr.LOOSEPLAIN], "|").concat(kr[pr.XRANGEPLAIN], ")"), true), M.comparatorTrimReplace = "$1$2$3", ar("HYPHENRANGE", "^\\s*(".concat(kr[pr.XRANGEPLAIN], ")\\s+-\\s+(").concat(kr[pr.XRANGEPLAIN], ")\\s*$")), ar("HYPHENRANGELOOSE", "^\\s*(".concat(kr[pr.XRANGEPLAINLOOSE], ")\\s+-\\s+(").concat(kr[pr.XRANGEPLAINLOOSE], ")\\s*$")), ar("STAR", "(<|>)?=?\\s*\\*"), ar("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$"), ar("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
        } }), S1 = Oa({ "node_modules/semver/internal/parse-options.js"(M, re) {
          Ea();
          var Ve = ["includePrerelease", "loose", "rtl"], Ke = (oi) => oi ? typeof oi != "object" ? { loose: true } : Ve.filter((kr) => oi[kr]).reduce((kr, pr) => (kr[pr] = true, kr), {}) : {};
          re.exports = Ke;
        } }), BT = Oa({ "node_modules/semver/internal/identifiers.js"(M, re) {
          Ea();
          var Ve = /^[0-9]+$/, Ke = (kr, pr) => {
            let Lr = Ve.test(kr), ar = Ve.test(pr);
            return Lr && ar && (kr = +kr, pr = +pr), kr === pr ? 0 : Lr && !ar ? -1 : ar && !Lr ? 1 : kr < pr ? -1 : 1;
          }, oi = (kr, pr) => Ke(pr, kr);
          re.exports = { compareIdentifiers: Ke, rcompareIdentifiers: oi };
        } }), Lf = Oa({ "node_modules/semver/classes/semver.js"(M, re) {
          Ea();
          var Ve = b1(), { MAX_LENGTH: Ke, MAX_SAFE_INTEGER: oi } = D1(), { re: kr, t: pr } = wv(), Lr = S1(), { compareIdentifiers: ar } = BT(), ke = class {
            constructor(e2, a) {
              if (a = Lr(a), e2 instanceof ke) {
                if (e2.loose === !!a.loose && e2.includePrerelease === !!a.includePrerelease)
                  return e2;
                e2 = e2.version;
              } else if (typeof e2 != "string")
                throw new TypeError("Invalid Version: ".concat(e2));
              if (e2.length > Ke)
                throw new TypeError("version is longer than ".concat(Ke, " characters"));
              Ve("SemVer", e2, a), this.options = a, this.loose = !!a.loose, this.includePrerelease = !!a.includePrerelease;
              let C = e2.trim().match(a.loose ? kr[pr.LOOSE] : kr[pr.FULL]);
              if (!C)
                throw new TypeError("Invalid Version: ".concat(e2));
              if (this.raw = e2, this.major = +C[1], this.minor = +C[2], this.patch = +C[3], this.major > oi || this.major < 0)
                throw new TypeError("Invalid major version");
              if (this.minor > oi || this.minor < 0)
                throw new TypeError("Invalid minor version");
              if (this.patch > oi || this.patch < 0)
                throw new TypeError("Invalid patch version");
              C[4] ? this.prerelease = C[4].split(".").map((w) => {
                if (/^[0-9]+$/.test(w)) {
                  let B = +w;
                  if (B >= 0 && B < oi)
                    return B;
                }
                return w;
              }) : this.prerelease = [], this.build = C[5] ? C[5].split(".") : [], this.format();
            }
            format() {
              return this.version = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch), this.prerelease.length && (this.version += "-".concat(this.prerelease.join("."))), this.version;
            }
            toString() {
              return this.version;
            }
            compare(e2) {
              if (Ve("SemVer.compare", this.version, this.options, e2), !(e2 instanceof ke)) {
                if (typeof e2 == "string" && e2 === this.version)
                  return 0;
                e2 = new ke(e2, this.options);
              }
              return e2.version === this.version ? 0 : this.compareMain(e2) || this.comparePre(e2);
            }
            compareMain(e2) {
              return e2 instanceof ke || (e2 = new ke(e2, this.options)), ar(this.major, e2.major) || ar(this.minor, e2.minor) || ar(this.patch, e2.patch);
            }
            comparePre(e2) {
              if (e2 instanceof ke || (e2 = new ke(e2, this.options)), this.prerelease.length && !e2.prerelease.length)
                return -1;
              if (!this.prerelease.length && e2.prerelease.length)
                return 1;
              if (!this.prerelease.length && !e2.prerelease.length)
                return 0;
              let a = 0;
              do {
                let C = this.prerelease[a], w = e2.prerelease[a];
                if (Ve("prerelease compare", a, C, w), C === void 0 && w === void 0)
                  return 0;
                if (w === void 0)
                  return 1;
                if (C === void 0)
                  return -1;
                if (C === w)
                  continue;
                return ar(C, w);
              } while (++a);
            }
            compareBuild(e2) {
              e2 instanceof ke || (e2 = new ke(e2, this.options));
              let a = 0;
              do {
                let C = this.build[a], w = e2.build[a];
                if (Ve("prerelease compare", a, C, w), C === void 0 && w === void 0)
                  return 0;
                if (w === void 0)
                  return 1;
                if (C === void 0)
                  return -1;
                if (C === w)
                  continue;
                return ar(C, w);
              } while (++a);
            }
            inc(e2, a) {
              switch (e2) {
                case "premajor":
                  this.prerelease.length = 0, this.patch = 0, this.minor = 0, this.major++, this.inc("pre", a);
                  break;
                case "preminor":
                  this.prerelease.length = 0, this.patch = 0, this.minor++, this.inc("pre", a);
                  break;
                case "prepatch":
                  this.prerelease.length = 0, this.inc("patch", a), this.inc("pre", a);
                  break;
                case "prerelease":
                  this.prerelease.length === 0 && this.inc("patch", a), this.inc("pre", a);
                  break;
                case "major":
                  (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) && this.major++, this.minor = 0, this.patch = 0, this.prerelease = [];
                  break;
                case "minor":
                  (this.patch !== 0 || this.prerelease.length === 0) && this.minor++, this.patch = 0, this.prerelease = [];
                  break;
                case "patch":
                  this.prerelease.length === 0 && this.patch++, this.prerelease = [];
                  break;
                case "pre":
                  if (this.prerelease.length === 0)
                    this.prerelease = [0];
                  else {
                    let C = this.prerelease.length;
                    for (; --C >= 0; )
                      typeof this.prerelease[C] == "number" && (this.prerelease[C]++, C = -2);
                    C === -1 && this.prerelease.push(0);
                  }
                  a && (ar(this.prerelease[0], a) === 0 ? isNaN(this.prerelease[1]) && (this.prerelease = [a, 0]) : this.prerelease = [a, 0]);
                  break;
                default:
                  throw new Error("invalid increment argument: ".concat(e2));
              }
              return this.format(), this.raw = this.version, this;
            }
          };
          re.exports = ke;
        } }), Ov = Oa({ "node_modules/semver/functions/parse.js"(M, re) {
          Ea();
          var { MAX_LENGTH: Ve } = D1(), { re: Ke, t: oi } = wv(), kr = Lf(), pr = S1(), Lr = (ar, ke) => {
            if (ke = pr(ke), ar instanceof kr)
              return ar;
            if (typeof ar != "string" || ar.length > Ve || !(ke.loose ? Ke[oi.LOOSE] : Ke[oi.FULL]).test(ar))
              return null;
            try {
              return new kr(ar, ke);
            } catch {
              return null;
            }
          };
          re.exports = Lr;
        } }), Kj = Oa({ "node_modules/semver/functions/valid.js"(M, re) {
          Ea();
          var Ve = Ov(), Ke = (oi, kr) => {
            let pr = Ve(oi, kr);
            return pr ? pr.version : null;
          };
          re.exports = Ke;
        } }), Gj = Oa({ "node_modules/semver/functions/clean.js"(M, re) {
          Ea();
          var Ve = Ov(), Ke = (oi, kr) => {
            let pr = Ve(oi.trim().replace(/^[=v]+/, ""), kr);
            return pr ? pr.version : null;
          };
          re.exports = Ke;
        } }), Hj = Oa({ "node_modules/semver/functions/inc.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr, pr, Lr) => {
            typeof pr == "string" && (Lr = pr, pr = void 0);
            try {
              return new Ve(oi instanceof Ve ? oi.version : oi, pr).inc(kr, Lr).version;
            } catch {
              return null;
            }
          };
          re.exports = Ke;
        } }), nd = Oa({ "node_modules/semver/functions/compare.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr, pr) => new Ve(oi, pr).compare(new Ve(kr, pr));
          re.exports = Ke;
        } }), qT = Oa({ "node_modules/semver/functions/eq.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) === 0;
          re.exports = Ke;
        } }), Xj = Oa({ "node_modules/semver/functions/diff.js"(M, re) {
          Ea();
          var Ve = Ov(), Ke = qT(), oi = (kr, pr) => {
            if (Ke(kr, pr))
              return null;
            {
              let Lr = Ve(kr), ar = Ve(pr), ke = Lr.prerelease.length || ar.prerelease.length, e2 = ke ? "pre" : "", a = ke ? "prerelease" : "";
              for (let C in Lr)
                if ((C === "major" || C === "minor" || C === "patch") && Lr[C] !== ar[C])
                  return e2 + C;
              return a;
            }
          };
          re.exports = oi;
        } }), Qj = Oa({ "node_modules/semver/functions/major.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr) => new Ve(oi, kr).major;
          re.exports = Ke;
        } }), Yj = Oa({ "node_modules/semver/functions/minor.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr) => new Ve(oi, kr).minor;
          re.exports = Ke;
        } }), $j = Oa({ "node_modules/semver/functions/patch.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr) => new Ve(oi, kr).patch;
          re.exports = Ke;
        } }), Zj = Oa({ "node_modules/semver/functions/prerelease.js"(M, re) {
          Ea();
          var Ve = Ov(), Ke = (oi, kr) => {
            let pr = Ve(oi, kr);
            return pr && pr.prerelease.length ? pr.prerelease : null;
          };
          re.exports = Ke;
        } }), eU = Oa({ "node_modules/semver/functions/rcompare.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(kr, oi, pr);
          re.exports = Ke;
        } }), rU = Oa({ "node_modules/semver/functions/compare-loose.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr) => Ve(oi, kr, true);
          re.exports = Ke;
        } }), VT = Oa({ "node_modules/semver/functions/compare-build.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = (oi, kr, pr) => {
            let Lr = new Ve(oi, pr), ar = new Ve(kr, pr);
            return Lr.compare(ar) || Lr.compareBuild(ar);
          };
          re.exports = Ke;
        } }), iU = Oa({ "node_modules/semver/functions/sort.js"(M, re) {
          Ea();
          var Ve = VT(), Ke = (oi, kr) => oi.sort((pr, Lr) => Ve(pr, Lr, kr));
          re.exports = Ke;
        } }), tU = Oa({ "node_modules/semver/functions/rsort.js"(M, re) {
          Ea();
          var Ve = VT(), Ke = (oi, kr) => oi.sort((pr, Lr) => Ve(Lr, pr, kr));
          re.exports = Ke;
        } }), T1 = Oa({ "node_modules/semver/functions/gt.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) > 0;
          re.exports = Ke;
        } }), KT = Oa({ "node_modules/semver/functions/lt.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) < 0;
          re.exports = Ke;
        } }), J4 = Oa({ "node_modules/semver/functions/neq.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) !== 0;
          re.exports = Ke;
        } }), GT = Oa({ "node_modules/semver/functions/gte.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) >= 0;
          re.exports = Ke;
        } }), HT = Oa({ "node_modules/semver/functions/lte.js"(M, re) {
          Ea();
          var Ve = nd(), Ke = (oi, kr, pr) => Ve(oi, kr, pr) <= 0;
          re.exports = Ke;
        } }), j4 = Oa({ "node_modules/semver/functions/cmp.js"(M, re) {
          Ea();
          var Ve = qT(), Ke = J4(), oi = T1(), kr = GT(), pr = KT(), Lr = HT(), ar = (ke, e2, a, C) => {
            switch (e2) {
              case "===":
                return typeof ke == "object" && (ke = ke.version), typeof a == "object" && (a = a.version), ke === a;
              case "!==":
                return typeof ke == "object" && (ke = ke.version), typeof a == "object" && (a = a.version), ke !== a;
              case "":
              case "=":
              case "==":
                return Ve(ke, a, C);
              case "!=":
                return Ke(ke, a, C);
              case ">":
                return oi(ke, a, C);
              case ">=":
                return kr(ke, a, C);
              case "<":
                return pr(ke, a, C);
              case "<=":
                return Lr(ke, a, C);
              default:
                throw new TypeError("Invalid operator: ".concat(e2));
            }
          };
          re.exports = ar;
        } }), aU = Oa({ "node_modules/semver/functions/coerce.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = Ov(), { re: oi, t: kr } = wv(), pr = (Lr, ar) => {
            if (Lr instanceof Ve)
              return Lr;
            if (typeof Lr == "number" && (Lr = String(Lr)), typeof Lr != "string")
              return null;
            ar = ar || {};
            let ke = null;
            if (!ar.rtl)
              ke = Lr.match(oi[kr.COERCE]);
            else {
              let e2;
              for (; (e2 = oi[kr.COERCERTL].exec(Lr)) && (!ke || ke.index + ke[0].length !== Lr.length); )
                (!ke || e2.index + e2[0].length !== ke.index + ke[0].length) && (ke = e2), oi[kr.COERCERTL].lastIndex = e2.index + e2[1].length + e2[2].length;
              oi[kr.COERCERTL].lastIndex = -1;
            }
            return ke === null ? null : Ke("".concat(ke[2], ".").concat(ke[3] || "0", ".").concat(ke[4] || "0"), ar);
          };
          re.exports = pr;
        } }), nU = Oa({ "node_modules/yallist/iterator.js"(M, re) {
          "use strict";
          Ea(), re.exports = function(Ve) {
            Ve.prototype[Symbol.iterator] = function* () {
              for (let Ke = this.head; Ke; Ke = Ke.next)
                yield Ke.value;
            };
          };
        } }), oU = Oa({ "node_modules/yallist/yallist.js"(M, re) {
          "use strict";
          Ea(), re.exports = Ve, Ve.Node = pr, Ve.create = Ve;
          function Ve(Lr) {
            var ar = this;
            if (ar instanceof Ve || (ar = new Ve()), ar.tail = null, ar.head = null, ar.length = 0, Lr && typeof Lr.forEach == "function")
              Lr.forEach(function(a) {
                ar.push(a);
              });
            else if (arguments.length > 0)
              for (var ke = 0, e2 = arguments.length; ke < e2; ke++)
                ar.push(arguments[ke]);
            return ar;
          }
          Ve.prototype.removeNode = function(Lr) {
            if (Lr.list !== this)
              throw new Error("removing node which does not belong to this list");
            var ar = Lr.next, ke = Lr.prev;
            return ar && (ar.prev = ke), ke && (ke.next = ar), Lr === this.head && (this.head = ar), Lr === this.tail && (this.tail = ke), Lr.list.length--, Lr.next = null, Lr.prev = null, Lr.list = null, ar;
          }, Ve.prototype.unshiftNode = function(Lr) {
            if (Lr !== this.head) {
              Lr.list && Lr.list.removeNode(Lr);
              var ar = this.head;
              Lr.list = this, Lr.next = ar, ar && (ar.prev = Lr), this.head = Lr, this.tail || (this.tail = Lr), this.length++;
            }
          }, Ve.prototype.pushNode = function(Lr) {
            if (Lr !== this.tail) {
              Lr.list && Lr.list.removeNode(Lr);
              var ar = this.tail;
              Lr.list = this, Lr.prev = ar, ar && (ar.next = Lr), this.tail = Lr, this.head || (this.head = Lr), this.length++;
            }
          }, Ve.prototype.push = function() {
            for (var Lr = 0, ar = arguments.length; Lr < ar; Lr++)
              oi(this, arguments[Lr]);
            return this.length;
          }, Ve.prototype.unshift = function() {
            for (var Lr = 0, ar = arguments.length; Lr < ar; Lr++)
              kr(this, arguments[Lr]);
            return this.length;
          }, Ve.prototype.pop = function() {
            if (!!this.tail) {
              var Lr = this.tail.value;
              return this.tail = this.tail.prev, this.tail ? this.tail.next = null : this.head = null, this.length--, Lr;
            }
          }, Ve.prototype.shift = function() {
            if (!!this.head) {
              var Lr = this.head.value;
              return this.head = this.head.next, this.head ? this.head.prev = null : this.tail = null, this.length--, Lr;
            }
          }, Ve.prototype.forEach = function(Lr, ar) {
            ar = ar || this;
            for (var ke = this.head, e2 = 0; ke !== null; e2++)
              Lr.call(ar, ke.value, e2, this), ke = ke.next;
          }, Ve.prototype.forEachReverse = function(Lr, ar) {
            ar = ar || this;
            for (var ke = this.tail, e2 = this.length - 1; ke !== null; e2--)
              Lr.call(ar, ke.value, e2, this), ke = ke.prev;
          }, Ve.prototype.get = function(Lr) {
            for (var ar = 0, ke = this.head; ke !== null && ar < Lr; ar++)
              ke = ke.next;
            if (ar === Lr && ke !== null)
              return ke.value;
          }, Ve.prototype.getReverse = function(Lr) {
            for (var ar = 0, ke = this.tail; ke !== null && ar < Lr; ar++)
              ke = ke.prev;
            if (ar === Lr && ke !== null)
              return ke.value;
          }, Ve.prototype.map = function(Lr, ar) {
            ar = ar || this;
            for (var ke = new Ve(), e2 = this.head; e2 !== null; )
              ke.push(Lr.call(ar, e2.value, this)), e2 = e2.next;
            return ke;
          }, Ve.prototype.mapReverse = function(Lr, ar) {
            ar = ar || this;
            for (var ke = new Ve(), e2 = this.tail; e2 !== null; )
              ke.push(Lr.call(ar, e2.value, this)), e2 = e2.prev;
            return ke;
          }, Ve.prototype.reduce = function(Lr, ar) {
            var ke, e2 = this.head;
            if (arguments.length > 1)
              ke = ar;
            else if (this.head)
              e2 = this.head.next, ke = this.head.value;
            else
              throw new TypeError("Reduce of empty list with no initial value");
            for (var a = 0; e2 !== null; a++)
              ke = Lr(ke, e2.value, a), e2 = e2.next;
            return ke;
          }, Ve.prototype.reduceReverse = function(Lr, ar) {
            var ke, e2 = this.tail;
            if (arguments.length > 1)
              ke = ar;
            else if (this.tail)
              e2 = this.tail.prev, ke = this.tail.value;
            else
              throw new TypeError("Reduce of empty list with no initial value");
            for (var a = this.length - 1; e2 !== null; a--)
              ke = Lr(ke, e2.value, a), e2 = e2.prev;
            return ke;
          }, Ve.prototype.toArray = function() {
            for (var Lr = new Array(this.length), ar = 0, ke = this.head; ke !== null; ar++)
              Lr[ar] = ke.value, ke = ke.next;
            return Lr;
          }, Ve.prototype.toArrayReverse = function() {
            for (var Lr = new Array(this.length), ar = 0, ke = this.tail; ke !== null; ar++)
              Lr[ar] = ke.value, ke = ke.prev;
            return Lr;
          }, Ve.prototype.slice = function(Lr, ar) {
            ar = ar || this.length, ar < 0 && (ar += this.length), Lr = Lr || 0, Lr < 0 && (Lr += this.length);
            var ke = new Ve();
            if (ar < Lr || ar < 0)
              return ke;
            Lr < 0 && (Lr = 0), ar > this.length && (ar = this.length);
            for (var e2 = 0, a = this.head; a !== null && e2 < Lr; e2++)
              a = a.next;
            for (; a !== null && e2 < ar; e2++, a = a.next)
              ke.push(a.value);
            return ke;
          }, Ve.prototype.sliceReverse = function(Lr, ar) {
            ar = ar || this.length, ar < 0 && (ar += this.length), Lr = Lr || 0, Lr < 0 && (Lr += this.length);
            var ke = new Ve();
            if (ar < Lr || ar < 0)
              return ke;
            Lr < 0 && (Lr = 0), ar > this.length && (ar = this.length);
            for (var e2 = this.length, a = this.tail; a !== null && e2 > ar; e2--)
              a = a.prev;
            for (; a !== null && e2 > Lr; e2--, a = a.prev)
              ke.push(a.value);
            return ke;
          }, Ve.prototype.splice = function(Lr, ar) {
            Lr > this.length && (Lr = this.length - 1), Lr < 0 && (Lr = this.length + Lr);
            for (var ke = 0, e2 = this.head; e2 !== null && ke < Lr; ke++)
              e2 = e2.next;
            for (var a = [], ke = 0; e2 && ke < ar; ke++)
              a.push(e2.value), e2 = this.removeNode(e2);
            e2 === null && (e2 = this.tail), e2 !== this.head && e2 !== this.tail && (e2 = e2.prev);
            for (var ke = 0; ke < (arguments.length <= 2 ? 0 : arguments.length - 2); ke++)
              e2 = Ke(this, e2, ke + 2 < 2 || arguments.length <= ke + 2 ? void 0 : arguments[ke + 2]);
            return a;
          }, Ve.prototype.reverse = function() {
            for (var Lr = this.head, ar = this.tail, ke = Lr; ke !== null; ke = ke.prev) {
              var e2 = ke.prev;
              ke.prev = ke.next, ke.next = e2;
            }
            return this.head = ar, this.tail = Lr, this;
          };
          function Ke(Lr, ar, ke) {
            var e2 = ar === Lr.head ? new pr(ke, null, ar, Lr) : new pr(ke, ar, ar.next, Lr);
            return e2.next === null && (Lr.tail = e2), e2.prev === null && (Lr.head = e2), Lr.length++, e2;
          }
          function oi(Lr, ar) {
            Lr.tail = new pr(ar, Lr.tail, null, Lr), Lr.head || (Lr.head = Lr.tail), Lr.length++;
          }
          function kr(Lr, ar) {
            Lr.head = new pr(ar, null, Lr.head, Lr), Lr.tail || (Lr.tail = Lr.head), Lr.length++;
          }
          function pr(Lr, ar, ke, e2) {
            if (!(this instanceof pr))
              return new pr(Lr, ar, ke, e2);
            this.list = e2, this.value = Lr, ar ? (ar.next = this, this.prev = ar) : this.prev = null, ke ? (ke.prev = this, this.next = ke) : this.next = null;
          }
          try {
            nU()(Ve);
          } catch {
          }
        } }), sU = Oa({ "node_modules/lru-cache/index.js"(M, re) {
          "use strict";
          Ea();
          var Ve = oU(), Ke = Symbol("max"), oi = Symbol("length"), kr = Symbol("lengthCalculator"), pr = Symbol("allowStale"), Lr = Symbol("maxAge"), ar = Symbol("dispose"), ke = Symbol("noDisposeOnSet"), e2 = Symbol("lruList"), a = Symbol("cache"), C = Symbol("updateAgeOnGet"), w = () => 1, B = class {
            constructor(G) {
              if (typeof G == "number" && (G = { max: G }), G || (G = {}), G.max && (typeof G.max != "number" || G.max < 0))
                throw new TypeError("max must be a non-negative number");
              let oe = this[Ke] = G.max || 1 / 0, f4 = G.length || w;
              if (this[kr] = typeof f4 != "function" ? w : f4, this[pr] = G.stale || false, G.maxAge && typeof G.maxAge != "number")
                throw new TypeError("maxAge must be a number");
              this[Lr] = G.maxAge || 0, this[ar] = G.dispose, this[ke] = G.noDisposeOnSet || false, this[C] = G.updateAgeOnGet || false, this.reset();
            }
            set max(G) {
              if (typeof G != "number" || G < 0)
                throw new TypeError("max must be a non-negative number");
              this[Ke] = G || 1 / 0, le(this);
            }
            get max() {
              return this[Ke];
            }
            set allowStale(G) {
              this[pr] = !!G;
            }
            get allowStale() {
              return this[pr];
            }
            set maxAge(G) {
              if (typeof G != "number")
                throw new TypeError("maxAge must be a non-negative number");
              this[Lr] = G, le(this);
            }
            get maxAge() {
              return this[Lr];
            }
            set lengthCalculator(G) {
              typeof G != "function" && (G = w), G !== this[kr] && (this[kr] = G, this[oi] = 0, this[e2].forEach((oe) => {
                oe.length = this[kr](oe.value, oe.key), this[oi] += oe.length;
              })), le(this);
            }
            get lengthCalculator() {
              return this[kr];
            }
            get length() {
              return this[oi];
            }
            get itemCount() {
              return this[e2].length;
            }
            rforEach(G, oe) {
              oe = oe || this;
              for (let f4 = this[e2].tail; f4 !== null; ) {
                let T = f4.prev;
                m2(this, G, f4, oe), f4 = T;
              }
            }
            forEach(G, oe) {
              oe = oe || this;
              for (let f4 = this[e2].head; f4 !== null; ) {
                let T = f4.next;
                m2(this, G, f4, oe), f4 = T;
              }
            }
            keys() {
              return this[e2].toArray().map((G) => G.key);
            }
            values() {
              return this[e2].toArray().map((G) => G.value);
            }
            reset() {
              this[ar] && this[e2] && this[e2].length && this[e2].forEach((G) => this[ar](G.key, G.value)), this[a] = /* @__PURE__ */ new Map(), this[e2] = new Ve(), this[oi] = 0;
            }
            dump() {
              return this[e2].map((G) => Q(this, G) ? false : { k: G.key, v: G.value, e: G.now + (G.maxAge || 0) }).toArray().filter((G) => G);
            }
            dumpLru() {
              return this[e2];
            }
            set(G, oe, f4) {
              if (f4 = f4 || this[Lr], f4 && typeof f4 != "number")
                throw new TypeError("maxAge must be a number");
              let T = f4 ? Date.now() : 0, K = this[kr](oe, G);
              if (this[a].has(G)) {
                if (K > this[Ke])
                  return N(this, this[a].get(G)), false;
                let J = this[a].get(G).value;
                return this[ar] && (this[ke] || this[ar](G, J.value)), J.now = T, J.maxAge = f4, J.value = oe, this[oi] += K - J.length, J.length = K, this.get(G), le(this), true;
              }
              let b = new p(G, oe, K, T, f4);
              return b.length > this[Ke] ? (this[ar] && this[ar](G, oe), false) : (this[oi] += b.length, this[e2].unshift(b), this[a].set(G, this[e2].head), le(this), true);
            }
            has(G) {
              if (!this[a].has(G))
                return false;
              let oe = this[a].get(G).value;
              return !Q(this, oe);
            }
            get(G) {
              return E(this, G, true);
            }
            peek(G) {
              return E(this, G, false);
            }
            pop() {
              let G = this[e2].tail;
              return G ? (N(this, G), G.value) : null;
            }
            del(G) {
              N(this, this[a].get(G));
            }
            load(G) {
              this.reset();
              let oe = Date.now();
              for (let f4 = G.length - 1; f4 >= 0; f4--) {
                let T = G[f4], K = T.e || 0;
                if (K === 0)
                  this.set(T.k, T.v);
                else {
                  let b = K - oe;
                  b > 0 && this.set(T.k, T.v, b);
                }
              }
            }
            prune() {
              this[a].forEach((G, oe) => E(this, oe, false));
            }
          }, E = (G, oe, f4) => {
            let T = G[a].get(oe);
            if (T) {
              let K = T.value;
              if (Q(G, K)) {
                if (N(G, T), !G[pr])
                  return;
              } else
                f4 && (G[C] && (T.value.now = Date.now()), G[e2].unshiftNode(T));
              return K.value;
            }
          }, Q = (G, oe) => {
            if (!oe || !oe.maxAge && !G[Lr])
              return false;
            let f4 = Date.now() - oe.now;
            return oe.maxAge ? f4 > oe.maxAge : G[Lr] && f4 > G[Lr];
          }, le = (G) => {
            if (G[oi] > G[Ke])
              for (let oe = G[e2].tail; G[oi] > G[Ke] && oe !== null; ) {
                let f4 = oe.prev;
                N(G, oe), oe = f4;
              }
          }, N = (G, oe) => {
            if (oe) {
              let f4 = oe.value;
              G[ar] && G[ar](f4.key, f4.value), G[oi] -= f4.length, G[a].delete(f4.key), G[e2].removeNode(oe);
            }
          }, p = class {
            constructor(G, oe, f4, T, K) {
              this.key = G, this.value = oe, this.length = f4, this.now = T, this.maxAge = K || 0;
            }
          }, m2 = (G, oe, f4, T) => {
            let K = f4.value;
            Q(G, K) && (N(G, f4), G[pr] || (K = void 0)), K && oe.call(T, K.value, K.key, G);
          };
          re.exports = B;
        } }), od = Oa({ "node_modules/semver/classes/range.js"(M, re) {
          Ea();
          var Ve = class {
            constructor(ie, R) {
              if (R = kr(R), ie instanceof Ve)
                return ie.loose === !!R.loose && ie.includePrerelease === !!R.includePrerelease ? ie : new Ve(ie.raw, R);
              if (ie instanceof pr)
                return this.raw = ie.value, this.set = [[ie]], this.format(), this;
              if (this.options = R, this.loose = !!R.loose, this.includePrerelease = !!R.includePrerelease, this.raw = ie, this.set = ie.split("||").map((q) => this.parseRange(q.trim())).filter((q) => q.length), !this.set.length)
                throw new TypeError("Invalid SemVer Range: ".concat(ie));
              if (this.set.length > 1) {
                let q = this.set[0];
                if (this.set = this.set.filter((O) => !B(O[0])), this.set.length === 0)
                  this.set = [q];
                else if (this.set.length > 1) {
                  for (let O of this.set)
                    if (O.length === 1 && E(O[0])) {
                      this.set = [O];
                      break;
                    }
                }
              }
              this.format();
            }
            format() {
              return this.range = this.set.map((ie) => ie.join(" ").trim()).join("||").trim(), this.range;
            }
            toString() {
              return this.range;
            }
            parseRange(ie) {
              ie = ie.trim();
              let R = Object.keys(this.options).join(","), q = "parseRange:".concat(R, ":").concat(ie), O = oi.get(q);
              if (O)
                return O;
              let ve = this.options.loose, ee = ve ? ke[e2.HYPHENRANGELOOSE] : ke[e2.HYPHENRANGE];
              ie = ie.replace(ee, se(this.options.includePrerelease)), Lr("hyphen replace", ie), ie = ie.replace(ke[e2.COMPARATORTRIM], a), Lr("comparator trim", ie), ie = ie.replace(ke[e2.TILDETRIM], C), ie = ie.replace(ke[e2.CARETTRIM], w), ie = ie.split(/\s+/).join(" ");
              let he = ie.split(" ").map(($) => le($, this.options)).join(" ").split(/\s+/).map(($) => b($, this.options));
              ve && (he = he.filter(($) => (Lr("loose invalid filter", $, this.options), !!$.match(ke[e2.COMPARATORLOOSE])))), Lr("range list", he);
              let F2 = /* @__PURE__ */ new Map(), x2 = he.map(($) => new pr($, this.options));
              for (let $ of x2) {
                if (B($))
                  return [$];
                F2.set($.value, $);
              }
              F2.size > 1 && F2.has("") && F2.delete("");
              let X = [...F2.values()];
              return oi.set(q, X), X;
            }
            intersects(ie, R) {
              if (!(ie instanceof Ve))
                throw new TypeError("a Range is required");
              return this.set.some((q) => Q(q, R) && ie.set.some((O) => Q(O, R) && q.every((ve) => O.every((ee) => ve.intersects(ee, R)))));
            }
            test(ie) {
              if (!ie)
                return false;
              if (typeof ie == "string")
                try {
                  ie = new ar(ie, this.options);
                } catch {
                  return false;
                }
              for (let R = 0; R < this.set.length; R++)
                if (J(this.set[R], ie, this.options))
                  return true;
              return false;
            }
          };
          re.exports = Ve;
          var Ke = sU(), oi = new Ke({ max: 1e3 }), kr = S1(), pr = x1(), Lr = b1(), ar = Lf(), { re: ke, t: e2, comparatorTrimReplace: a, tildeTrimReplace: C, caretTrimReplace: w } = wv(), B = (ie) => ie.value === "<0.0.0-0", E = (ie) => ie.value === "", Q = (ie, R) => {
            let q = true, O = ie.slice(), ve = O.pop();
            for (; q && O.length; )
              q = O.every((ee) => ve.intersects(ee, R)), ve = O.pop();
            return q;
          }, le = (ie, R) => (Lr("comp", ie, R), ie = G(ie, R), Lr("caret", ie), ie = p(ie, R), Lr("tildes", ie), ie = f4(ie, R), Lr("xrange", ie), ie = K(ie, R), Lr("stars", ie), ie), N = (ie) => !ie || ie.toLowerCase() === "x" || ie === "*", p = (ie, R) => ie.trim().split(/\s+/).map((q) => m2(q, R)).join(" "), m2 = (ie, R) => {
            let q = R.loose ? ke[e2.TILDELOOSE] : ke[e2.TILDE];
            return ie.replace(q, (O, ve, ee, he, F2) => {
              Lr("tilde", ie, O, ve, ee, he, F2);
              let x2;
              return N(ve) ? x2 = "" : N(ee) ? x2 = ">=".concat(ve, ".0.0 <").concat(+ve + 1, ".0.0-0") : N(he) ? x2 = ">=".concat(ve, ".").concat(ee, ".0 <").concat(ve, ".").concat(+ee + 1, ".0-0") : F2 ? (Lr("replaceTilde pr", F2), x2 = ">=".concat(ve, ".").concat(ee, ".").concat(he, "-").concat(F2, " <").concat(ve, ".").concat(+ee + 1, ".0-0")) : x2 = ">=".concat(ve, ".").concat(ee, ".").concat(he, " <").concat(ve, ".").concat(+ee + 1, ".0-0"), Lr("tilde return", x2), x2;
            });
          }, G = (ie, R) => ie.trim().split(/\s+/).map((q) => oe(q, R)).join(" "), oe = (ie, R) => {
            Lr("caret", ie, R);
            let q = R.loose ? ke[e2.CARETLOOSE] : ke[e2.CARET], O = R.includePrerelease ? "-0" : "";
            return ie.replace(q, (ve, ee, he, F2, x2) => {
              Lr("caret", ie, ve, ee, he, F2, x2);
              let X;
              return N(ee) ? X = "" : N(he) ? X = ">=".concat(ee, ".0.0").concat(O, " <").concat(+ee + 1, ".0.0-0") : N(F2) ? ee === "0" ? X = ">=".concat(ee, ".").concat(he, ".0").concat(O, " <").concat(ee, ".").concat(+he + 1, ".0-0") : X = ">=".concat(ee, ".").concat(he, ".0").concat(O, " <").concat(+ee + 1, ".0.0-0") : x2 ? (Lr("replaceCaret pr", x2), ee === "0" ? he === "0" ? X = ">=".concat(ee, ".").concat(he, ".").concat(F2, "-").concat(x2, " <").concat(ee, ".").concat(he, ".").concat(+F2 + 1, "-0") : X = ">=".concat(ee, ".").concat(he, ".").concat(F2, "-").concat(x2, " <").concat(ee, ".").concat(+he + 1, ".0-0") : X = ">=".concat(ee, ".").concat(he, ".").concat(F2, "-").concat(x2, " <").concat(+ee + 1, ".0.0-0")) : (Lr("no pr"), ee === "0" ? he === "0" ? X = ">=".concat(ee, ".").concat(he, ".").concat(F2).concat(O, " <").concat(ee, ".").concat(he, ".").concat(+F2 + 1, "-0") : X = ">=".concat(ee, ".").concat(he, ".").concat(F2).concat(O, " <").concat(ee, ".").concat(+he + 1, ".0-0") : X = ">=".concat(ee, ".").concat(he, ".").concat(F2, " <").concat(+ee + 1, ".0.0-0")), Lr("caret return", X), X;
            });
          }, f4 = (ie, R) => (Lr("replaceXRanges", ie, R), ie.split(/\s+/).map((q) => T(q, R)).join(" ")), T = (ie, R) => {
            ie = ie.trim();
            let q = R.loose ? ke[e2.XRANGELOOSE] : ke[e2.XRANGE];
            return ie.replace(q, (O, ve, ee, he, F2, x2) => {
              Lr("xRange", ie, O, ve, ee, he, F2, x2);
              let X = N(ee), $ = X || N(he), A2 = $ || N(F2), y = A2;
              return ve === "=" && y && (ve = ""), x2 = R.includePrerelease ? "-0" : "", X ? ve === ">" || ve === "<" ? O = "<0.0.0-0" : O = "*" : ve && y ? ($ && (he = 0), F2 = 0, ve === ">" ? (ve = ">=", $ ? (ee = +ee + 1, he = 0, F2 = 0) : (he = +he + 1, F2 = 0)) : ve === "<=" && (ve = "<", $ ? ee = +ee + 1 : he = +he + 1), ve === "<" && (x2 = "-0"), O = "".concat(ve + ee, ".").concat(he, ".").concat(F2).concat(x2)) : $ ? O = ">=".concat(ee, ".0.0").concat(x2, " <").concat(+ee + 1, ".0.0-0") : A2 && (O = ">=".concat(ee, ".").concat(he, ".0").concat(x2, " <").concat(ee, ".").concat(+he + 1, ".0-0")), Lr("xRange return", O), O;
            });
          }, K = (ie, R) => (Lr("replaceStars", ie, R), ie.trim().replace(ke[e2.STAR], "")), b = (ie, R) => (Lr("replaceGTE0", ie, R), ie.trim().replace(ke[R.includePrerelease ? e2.GTE0PRE : e2.GTE0], "")), se = (ie) => (R, q, O, ve, ee, he, F2, x2, X, $, A2, y, V) => (N(O) ? q = "" : N(ve) ? q = ">=".concat(O, ".0.0").concat(ie ? "-0" : "") : N(ee) ? q = ">=".concat(O, ".").concat(ve, ".0").concat(ie ? "-0" : "") : he ? q = ">=".concat(q) : q = ">=".concat(q).concat(ie ? "-0" : ""), N(X) ? x2 = "" : N($) ? x2 = "<".concat(+X + 1, ".0.0-0") : N(A2) ? x2 = "<".concat(X, ".").concat(+$ + 1, ".0-0") : y ? x2 = "<=".concat(X, ".").concat($, ".").concat(A2, "-").concat(y) : ie ? x2 = "<".concat(X, ".").concat($, ".").concat(+A2 + 1, "-0") : x2 = "<=".concat(x2), "".concat(q, " ").concat(x2).trim()), J = (ie, R, q) => {
            for (let O = 0; O < ie.length; O++)
              if (!ie[O].test(R))
                return false;
            if (R.prerelease.length && !q.includePrerelease) {
              for (let O = 0; O < ie.length; O++)
                if (Lr(ie[O].semver), ie[O].semver !== pr.ANY && ie[O].semver.prerelease.length > 0) {
                  let ve = ie[O].semver;
                  if (ve.major === R.major && ve.minor === R.minor && ve.patch === R.patch)
                    return true;
                }
              return false;
            }
            return true;
          };
        } }), x1 = Oa({ "node_modules/semver/classes/comparator.js"(M, re) {
          Ea();
          var Ve = Symbol("SemVer ANY"), Ke = class {
            static get ANY() {
              return Ve;
            }
            constructor(a, C) {
              if (C = oi(C), a instanceof Ke) {
                if (a.loose === !!C.loose)
                  return a;
                a = a.value;
              }
              ar("comparator", a, C), this.options = C, this.loose = !!C.loose, this.parse(a), this.semver === Ve ? this.value = "" : this.value = this.operator + this.semver.version, ar("comp", this);
            }
            parse(a) {
              let C = this.options.loose ? kr[pr.COMPARATORLOOSE] : kr[pr.COMPARATOR], w = a.match(C);
              if (!w)
                throw new TypeError("Invalid comparator: ".concat(a));
              this.operator = w[1] !== void 0 ? w[1] : "", this.operator === "=" && (this.operator = ""), w[2] ? this.semver = new ke(w[2], this.options.loose) : this.semver = Ve;
            }
            toString() {
              return this.value;
            }
            test(a) {
              if (ar("Comparator.test", a, this.options.loose), this.semver === Ve || a === Ve)
                return true;
              if (typeof a == "string")
                try {
                  a = new ke(a, this.options);
                } catch {
                  return false;
                }
              return Lr(a, this.operator, this.semver, this.options);
            }
            intersects(a, C) {
              if (!(a instanceof Ke))
                throw new TypeError("a Comparator is required");
              if ((!C || typeof C != "object") && (C = { loose: !!C, includePrerelease: false }), this.operator === "")
                return this.value === "" ? true : new e2(a.value, C).test(this.value);
              if (a.operator === "")
                return a.value === "" ? true : new e2(this.value, C).test(a.semver);
              let w = (this.operator === ">=" || this.operator === ">") && (a.operator === ">=" || a.operator === ">"), B = (this.operator === "<=" || this.operator === "<") && (a.operator === "<=" || a.operator === "<"), E = this.semver.version === a.semver.version, Q = (this.operator === ">=" || this.operator === "<=") && (a.operator === ">=" || a.operator === "<="), le = Lr(this.semver, "<", a.semver, C) && (this.operator === ">=" || this.operator === ">") && (a.operator === "<=" || a.operator === "<"), N = Lr(this.semver, ">", a.semver, C) && (this.operator === "<=" || this.operator === "<") && (a.operator === ">=" || a.operator === ">");
              return w || B || E && Q || le || N;
            }
          };
          re.exports = Ke;
          var oi = S1(), { re: kr, t: pr } = wv(), Lr = j4(), ar = b1(), ke = Lf(), e2 = od();
        } }), E1 = Oa({ "node_modules/semver/functions/satisfies.js"(M, re) {
          Ea();
          var Ve = od(), Ke = (oi, kr, pr) => {
            try {
              kr = new Ve(kr, pr);
            } catch {
              return false;
            }
            return kr.test(oi);
          };
          re.exports = Ke;
        } }), cU = Oa({ "node_modules/semver/ranges/to-comparators.js"(M, re) {
          Ea();
          var Ve = od(), Ke = (oi, kr) => new Ve(oi, kr).set.map((pr) => pr.map((Lr) => Lr.value).join(" ").trim().split(" "));
          re.exports = Ke;
        } }), uU = Oa({ "node_modules/semver/ranges/max-satisfying.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = od(), oi = (kr, pr, Lr) => {
            let ar = null, ke = null, e2 = null;
            try {
              e2 = new Ke(pr, Lr);
            } catch {
              return null;
            }
            return kr.forEach((a) => {
              e2.test(a) && (!ar || ke.compare(a) === -1) && (ar = a, ke = new Ve(ar, Lr));
            }), ar;
          };
          re.exports = oi;
        } }), lU = Oa({ "node_modules/semver/ranges/min-satisfying.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = od(), oi = (kr, pr, Lr) => {
            let ar = null, ke = null, e2 = null;
            try {
              e2 = new Ke(pr, Lr);
            } catch {
              return null;
            }
            return kr.forEach((a) => {
              e2.test(a) && (!ar || ke.compare(a) === 1) && (ar = a, ke = new Ve(ar, Lr));
            }), ar;
          };
          re.exports = oi;
        } }), fU = Oa({ "node_modules/semver/ranges/min-version.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = od(), oi = T1(), kr = (pr, Lr) => {
            pr = new Ke(pr, Lr);
            let ar = new Ve("0.0.0");
            if (pr.test(ar) || (ar = new Ve("0.0.0-0"), pr.test(ar)))
              return ar;
            ar = null;
            for (let ke = 0; ke < pr.set.length; ++ke) {
              let e2 = pr.set[ke], a = null;
              e2.forEach((C) => {
                let w = new Ve(C.semver.version);
                switch (C.operator) {
                  case ">":
                    w.prerelease.length === 0 ? w.patch++ : w.prerelease.push(0), w.raw = w.format();
                  case "":
                  case ">=":
                    (!a || oi(w, a)) && (a = w);
                    break;
                  case "<":
                  case "<=":
                    break;
                  default:
                    throw new Error("Unexpected operation: ".concat(C.operator));
                }
              }), a && (!ar || oi(ar, a)) && (ar = a);
            }
            return ar && pr.test(ar) ? ar : null;
          };
          re.exports = kr;
        } }), _U = Oa({ "node_modules/semver/ranges/valid.js"(M, re) {
          Ea();
          var Ve = od(), Ke = (oi, kr) => {
            try {
              return new Ve(oi, kr).range || "*";
            } catch {
              return null;
            }
          };
          re.exports = Ke;
        } }), XT = Oa({ "node_modules/semver/ranges/outside.js"(M, re) {
          Ea();
          var Ve = Lf(), Ke = x1(), { ANY: oi } = Ke, kr = od(), pr = E1(), Lr = T1(), ar = KT(), ke = HT(), e2 = GT(), a = (C, w, B, E) => {
            C = new Ve(C, E), w = new kr(w, E);
            let Q, le, N, p, m2;
            switch (B) {
              case ">":
                Q = Lr, le = ke, N = ar, p = ">", m2 = ">=";
                break;
              case "<":
                Q = ar, le = e2, N = Lr, p = "<", m2 = "<=";
                break;
              default:
                throw new TypeError('Must provide a hilo val of "<" or ">"');
            }
            if (pr(C, w, E))
              return false;
            for (let G = 0; G < w.set.length; ++G) {
              let oe = w.set[G], f4 = null, T = null;
              if (oe.forEach((K) => {
                K.semver === oi && (K = new Ke(">=0.0.0")), f4 = f4 || K, T = T || K, Q(K.semver, f4.semver, E) ? f4 = K : N(K.semver, T.semver, E) && (T = K);
              }), f4.operator === p || f4.operator === m2 || (!T.operator || T.operator === p) && le(C, T.semver))
                return false;
              if (T.operator === m2 && N(C, T.semver))
                return false;
            }
            return true;
          };
          re.exports = a;
        } }), pU = Oa({ "node_modules/semver/ranges/gtr.js"(M, re) {
          Ea();
          var Ve = XT(), Ke = (oi, kr, pr) => Ve(oi, kr, ">", pr);
          re.exports = Ke;
        } }), dU = Oa({ "node_modules/semver/ranges/ltr.js"(M, re) {
          Ea();
          var Ve = XT(), Ke = (oi, kr, pr) => Ve(oi, kr, "<", pr);
          re.exports = Ke;
        } }), gU = Oa({ "node_modules/semver/ranges/intersects.js"(M, re) {
          Ea();
          var Ve = od(), Ke = (oi, kr, pr) => (oi = new Ve(oi, pr), kr = new Ve(kr, pr), oi.intersects(kr));
          re.exports = Ke;
        } }), mU = Oa({ "node_modules/semver/ranges/simplify.js"(M, re) {
          Ea();
          var Ve = E1(), Ke = nd();
          re.exports = (oi, kr, pr) => {
            let Lr = [], ar = null, ke = null, e2 = oi.sort((B, E) => Ke(B, E, pr));
            for (let B of e2)
              Ve(B, kr, pr) ? (ke = B, ar || (ar = B)) : (ke && Lr.push([ar, ke]), ke = null, ar = null);
            ar && Lr.push([ar, null]);
            let a = [];
            for (let [B, E] of Lr)
              B === E ? a.push(B) : !E && B === e2[0] ? a.push("*") : E ? B === e2[0] ? a.push("<=".concat(E)) : a.push("".concat(B, " - ").concat(E)) : a.push(">=".concat(B));
            let C = a.join(" || "), w = typeof kr.raw == "string" ? kr.raw : String(kr);
            return C.length < w.length ? C : kr;
          };
        } }), vU = Oa({ "node_modules/semver/ranges/subset.js"(M, re) {
          Ea();
          var Ve = od(), Ke = x1(), { ANY: oi } = Ke, kr = E1(), pr = nd(), Lr = function(a, C) {
            let w = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            if (a === C)
              return true;
            a = new Ve(a, w), C = new Ve(C, w);
            let B = false;
            e:
              for (let E of a.set) {
                for (let Q of C.set) {
                  let le = ar(E, Q, w);
                  if (B = B || le !== null, le)
                    continue e;
                }
                if (B)
                  return false;
              }
            return true;
          }, ar = (a, C, w) => {
            if (a === C)
              return true;
            if (a.length === 1 && a[0].semver === oi) {
              if (C.length === 1 && C[0].semver === oi)
                return true;
              w.includePrerelease ? a = [new Ke(">=0.0.0-0")] : a = [new Ke(">=0.0.0")];
            }
            if (C.length === 1 && C[0].semver === oi) {
              if (w.includePrerelease)
                return true;
              C = [new Ke(">=0.0.0")];
            }
            let B = /* @__PURE__ */ new Set(), E, Q;
            for (let T of a)
              T.operator === ">" || T.operator === ">=" ? E = ke(E, T, w) : T.operator === "<" || T.operator === "<=" ? Q = e2(Q, T, w) : B.add(T.semver);
            if (B.size > 1)
              return null;
            let le;
            if (E && Q) {
              if (le = pr(E.semver, Q.semver, w), le > 0)
                return null;
              if (le === 0 && (E.operator !== ">=" || Q.operator !== "<="))
                return null;
            }
            for (let T of B) {
              if (E && !kr(T, String(E), w) || Q && !kr(T, String(Q), w))
                return null;
              for (let K of C)
                if (!kr(T, String(K), w))
                  return false;
              return true;
            }
            let N, p, m2, G, oe = Q && !w.includePrerelease && Q.semver.prerelease.length ? Q.semver : false, f4 = E && !w.includePrerelease && E.semver.prerelease.length ? E.semver : false;
            oe && oe.prerelease.length === 1 && Q.operator === "<" && oe.prerelease[0] === 0 && (oe = false);
            for (let T of C) {
              if (G = G || T.operator === ">" || T.operator === ">=", m2 = m2 || T.operator === "<" || T.operator === "<=", E) {
                if (f4 && T.semver.prerelease && T.semver.prerelease.length && T.semver.major === f4.major && T.semver.minor === f4.minor && T.semver.patch === f4.patch && (f4 = false), T.operator === ">" || T.operator === ">=") {
                  if (N = ke(E, T, w), N === T && N !== E)
                    return false;
                } else if (E.operator === ">=" && !kr(E.semver, String(T), w))
                  return false;
              }
              if (Q) {
                if (oe && T.semver.prerelease && T.semver.prerelease.length && T.semver.major === oe.major && T.semver.minor === oe.minor && T.semver.patch === oe.patch && (oe = false), T.operator === "<" || T.operator === "<=") {
                  if (p = e2(Q, T, w), p === T && p !== Q)
                    return false;
                } else if (Q.operator === "<=" && !kr(Q.semver, String(T), w))
                  return false;
              }
              if (!T.operator && (Q || E) && le !== 0)
                return false;
            }
            return !(E && m2 && !Q && le !== 0 || Q && G && !E && le !== 0 || f4 || oe);
          }, ke = (a, C, w) => {
            if (!a)
              return C;
            let B = pr(a.semver, C.semver, w);
            return B > 0 ? a : B < 0 || C.operator === ">" && a.operator === ">=" ? C : a;
          }, e2 = (a, C, w) => {
            if (!a)
              return C;
            let B = pr(a.semver, C.semver, w);
            return B < 0 ? a : B > 0 || C.operator === "<" && a.operator === "<=" ? C : a;
          };
          re.exports = Lr;
        } }), QT = Oa({ "node_modules/semver/index.js"(M, re) {
          Ea();
          var Ve = wv();
          re.exports = { re: Ve.re, src: Ve.src, tokens: Ve.t, SEMVER_SPEC_VERSION: D1().SEMVER_SPEC_VERSION, SemVer: Lf(), compareIdentifiers: BT().compareIdentifiers, rcompareIdentifiers: BT().rcompareIdentifiers, parse: Ov(), valid: Kj(), clean: Gj(), inc: Hj(), diff: Xj(), major: Qj(), minor: Yj(), patch: $j(), prerelease: Zj(), compare: nd(), rcompare: eU(), compareLoose: rU(), compareBuild: VT(), sort: iU(), rsort: tU(), gt: T1(), lt: KT(), eq: qT(), neq: J4(), gte: GT(), lte: HT(), cmp: j4(), coerce: aU(), Comparator: x1(), Range: od(), satisfies: E1(), toComparators: cU(), maxSatisfying: uU(), minSatisfying: lU(), minVersion: fU(), validRange: _U(), outside: XT(), gtr: pU(), ltr: dU(), intersects: gU(), simplifyRange: mU(), subset: vU() };
        } }), U4 = {};
        h1(U4, { basename: () => K4, default: () => H4, delimiter: () => jT, dirname: () => V4, extname: () => G4, isAbsolute: () => $T, join: () => W4, normalize: () => YT, relative: () => q4, resolve: () => y1, sep: () => JT });
        function z4(M, re) {
          for (var Ve = 0, Ke = M.length - 1; Ke >= 0; Ke--) {
            var oi = M[Ke];
            oi === "." ? M.splice(Ke, 1) : oi === ".." ? (M.splice(Ke, 1), Ve++) : Ve && (M.splice(Ke, 1), Ve--);
          }
          if (re)
            for (; Ve--; Ve)
              M.unshift("..");
          return M;
        }
        function y1() {
          for (var M = "", re = false, Ve = arguments.length - 1; Ve >= -1 && !re; Ve--) {
            var Ke = Ve >= 0 ? arguments[Ve] : "/";
            if (typeof Ke != "string")
              throw new TypeError("Arguments to path.resolve must be strings");
            if (!Ke)
              continue;
            M = Ke + "/" + M, re = Ke.charAt(0) === "/";
          }
          return M = z4(ZT(M.split("/"), function(oi) {
            return !!oi;
          }), !re).join("/"), (re ? "/" : "") + M || ".";
        }
        function YT(M) {
          var re = $T(M), Ve = X4(M, -1) === "/";
          return M = z4(ZT(M.split("/"), function(Ke) {
            return !!Ke;
          }), !re).join("/"), !M && !re && (M = "."), M && Ve && (M += "/"), (re ? "/" : "") + M;
        }
        function $T(M) {
          return M.charAt(0) === "/";
        }
        function W4() {
          var M = Array.prototype.slice.call(arguments, 0);
          return YT(ZT(M, function(re, Ve) {
            if (typeof re != "string")
              throw new TypeError("Arguments to path.join must be strings");
            return re;
          }).join("/"));
        }
        function q4(M, re) {
          M = y1(M).substr(1), re = y1(re).substr(1);
          function Ve(ke) {
            for (var e2 = 0; e2 < ke.length && ke[e2] === ""; e2++)
              ;
            for (var a = ke.length - 1; a >= 0 && ke[a] === ""; a--)
              ;
            return e2 > a ? [] : ke.slice(e2, a - e2 + 1);
          }
          for (var Ke = Ve(M.split("/")), oi = Ve(re.split("/")), kr = Math.min(Ke.length, oi.length), pr = kr, Lr = 0; Lr < kr; Lr++)
            if (Ke[Lr] !== oi[Lr]) {
              pr = Lr;
              break;
            }
          for (var ar = [], Lr = pr; Lr < Ke.length; Lr++)
            ar.push("..");
          return ar = ar.concat(oi.slice(pr)), ar.join("/");
        }
        function V4(M) {
          var re = C1(M), Ve = re[0], Ke = re[1];
          return !Ve && !Ke ? "." : (Ke && (Ke = Ke.substr(0, Ke.length - 1)), Ve + Ke);
        }
        function K4(M, re) {
          var Ve = C1(M)[2];
          return re && Ve.substr(-1 * re.length) === re && (Ve = Ve.substr(0, Ve.length - re.length)), Ve;
        }
        function G4(M) {
          return C1(M)[3];
        }
        function ZT(M, re) {
          if (M.filter)
            return M.filter(re);
          for (var Ve = [], Ke = 0; Ke < M.length; Ke++)
            re(M[Ke], Ke, M) && Ve.push(M[Ke]);
          return Ve;
        }
        var h4, C1, JT, jT, H4, X4, yU = Qy({ "node-modules-polyfills:path"() {
          Ea(), h4 = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/, C1 = function(M) {
            return h4.exec(M).slice(1);
          }, JT = "/", jT = ":", H4 = { extname: G4, basename: K4, dirname: V4, sep: JT, delimiter: jT, relative: q4, join: W4, isAbsolute: $T, normalize: YT, resolve: y1 }, X4 = "ab".substr(-1) === "b" ? function(M, re, Ve) {
            return M.substr(re, Ve);
          } : function(M, re, Ve) {
            return re < 0 && (re = M.length + re), M.substr(re, Ve);
          };
        } }), Fv = Oa({ "node-modules-polyfills-commonjs:path"(M, re) {
          Ea();
          var Ve = (yU(), mp(U4));
          if (Ve && Ve.default) {
            re.exports = Ve.default;
            for (let Ke in Ve)
              re.exports[Ke] = Ve[Ke];
          } else
            Ve && (re.exports = Ve);
        } }), Q4 = {};
        h1(Q4, { default: () => Y4 });
        var Y4, hU = Qy({ "node-modules-polyfills:fs"() {
          Ea(), Y4 = {};
        } }), ex = Oa({ "node-modules-polyfills-commonjs:fs"(M, re) {
          Ea();
          var Ve = (hU(), mp(Q4));
          if (Ve && Ve.default) {
            re.exports = Ve.default;
            for (let Ke in Ve)
              re.exports[Ke] = Ve[Ke];
          } else
            Ve && (re.exports = Ve);
        } }), _u = Oa({ "node_modules/typescript/lib/typescript.js"(M, re) {
          "use strict";
          Ea();
          var Ve = M && M.__spreadArray || function(e2, a, C) {
            if (C || arguments.length === 2)
              for (var w = 0, B = a.length, E; w < B; w++)
                (E || !(w in a)) && (E || (E = Array.prototype.slice.call(a, 0, w)), E[w] = a[w]);
            return e2.concat(E || Array.prototype.slice.call(a));
          }, Ke = M && M.__assign || function() {
            return Ke = Object.assign || function(e2) {
              for (var a, C = 1, w = arguments.length; C < w; C++) {
                a = arguments[C];
                for (var B in a)
                  Object.prototype.hasOwnProperty.call(a, B) && (e2[B] = a[B]);
              }
              return e2;
            }, Ke.apply(this, arguments);
          }, oi = M && M.__makeTemplateObject || function(e2, a) {
            return Object.defineProperty ? Object.defineProperty(e2, "raw", { value: a }) : e2.raw = a, e2;
          }, kr = M && M.__generator || function(e2, a) {
            var C = { label: 0, sent: function() {
              if (E[0] & 1)
                throw E[1];
              return E[1];
            }, trys: [], ops: [] }, w, B, E, Q;
            return Q = { next: le(0), throw: le(1), return: le(2) }, typeof Symbol == "function" && (Q[Symbol.iterator] = function() {
              return this;
            }), Q;
            function le(p) {
              return function(m2) {
                return N([p, m2]);
              };
            }
            function N(p) {
              if (w)
                throw new TypeError("Generator is already executing.");
              for (; C; )
                try {
                  if (w = 1, B && (E = p[0] & 2 ? B.return : p[0] ? B.throw || ((E = B.return) && E.call(B), 0) : B.next) && !(E = E.call(B, p[1])).done)
                    return E;
                  switch (B = 0, E && (p = [p[0] & 2, E.value]), p[0]) {
                    case 0:
                    case 1:
                      E = p;
                      break;
                    case 4:
                      return C.label++, { value: p[1], done: false };
                    case 5:
                      C.label++, B = p[1], p = [0];
                      continue;
                    case 7:
                      p = C.ops.pop(), C.trys.pop();
                      continue;
                    default:
                      if (E = C.trys, !(E = E.length > 0 && E[E.length - 1]) && (p[0] === 6 || p[0] === 2)) {
                        C = 0;
                        continue;
                      }
                      if (p[0] === 3 && (!E || p[1] > E[0] && p[1] < E[3])) {
                        C.label = p[1];
                        break;
                      }
                      if (p[0] === 6 && C.label < E[1]) {
                        C.label = E[1], E = p;
                        break;
                      }
                      if (E && C.label < E[2]) {
                        C.label = E[2], C.ops.push(p);
                        break;
                      }
                      E[2] && C.ops.pop(), C.trys.pop();
                      continue;
                  }
                  p = a.call(e2, C);
                } catch (m2) {
                  p = [6, m2], B = 0;
                } finally {
                  w = E = 0;
                }
              if (p[0] & 5)
                throw p[1];
              return { value: p[0] ? p[1] : void 0, done: true };
            }
          }, pr = M && M.__rest || function(e2, a) {
            var C = {};
            for (var w in e2)
              Object.prototype.hasOwnProperty.call(e2, w) && a.indexOf(w) < 0 && (C[w] = e2[w]);
            if (e2 != null && typeof Object.getOwnPropertySymbols == "function")
              for (var B = 0, w = Object.getOwnPropertySymbols(e2); B < w.length; B++)
                a.indexOf(w[B]) < 0 && Object.prototype.propertyIsEnumerable.call(e2, w[B]) && (C[w[B]] = e2[w[B]]);
            return C;
          }, Lr = M && M.__extends || function() {
            var e2 = function(a, C) {
              return e2 = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(w, B) {
                w.__proto__ = B;
              } || function(w, B) {
                for (var E in B)
                  Object.prototype.hasOwnProperty.call(B, E) && (w[E] = B[E]);
              }, e2(a, C);
            };
            return function(a, C) {
              if (typeof C != "function" && C !== null)
                throw new TypeError("Class extends value " + String(C) + " is not a constructor or null");
              e2(a, C);
              function w() {
                this.constructor = a;
              }
              a.prototype = C === null ? Object.create(C) : (w.prototype = C.prototype, new w());
            };
          }(), ke;
          (function(e2) {
            function a() {
              var K = {};
              return K.prev = K, { head: K, tail: K, size: 0 };
            }
            function C(K, b) {
              return { key: K, value: b, next: void 0, prev: void 0 };
            }
            function w(K, b) {
              return K === b || K !== K && b !== b;
            }
            function B(K) {
              var b = K.prev;
              if (!b || b === K)
                throw new Error("Illegal state");
              return b;
            }
            function E(K) {
              for (; K; ) {
                var b = !K.prev;
                if (K = K.next, !b)
                  return K;
              }
            }
            function Q(K, b) {
              for (var se = K.tail; se !== K.head; se = B(se))
                if (w(se.key, b))
                  return se;
            }
            function le(K, b, se) {
              var J = Q(K, b);
              if (J) {
                J.value = se;
                return;
              }
              var ie = C(b, se);
              return ie.prev = K.tail, K.tail.next = ie, K.tail = ie, K.size++, ie;
            }
            function N(K, b) {
              for (var se = K.tail; se !== K.head; se = B(se)) {
                if (se.prev === void 0)
                  throw new Error("Illegal state");
                if (w(se.key, b)) {
                  if (se.next)
                    se.next.prev = se.prev;
                  else {
                    if (K.tail !== se)
                      throw new Error("Illegal state");
                    K.tail = se.prev;
                  }
                  return se.prev.next = se.next, se.next = se.prev, se.prev = void 0, K.size--, se;
                }
              }
            }
            function p(K) {
              for (var b = K.tail; b !== K.head; ) {
                var se = B(b);
                b.next = K.head, b.prev = void 0, b = se;
              }
              K.head.next = void 0, K.tail = K.head, K.size = 0;
            }
            function m2(K, b) {
              for (var se = K.head; se; )
                se = E(se), se && b(se.value, se.key);
            }
            function G(K, b) {
              if (K)
                for (var se = K.next(); !se.done; se = K.next())
                  b(se.value);
            }
            function oe(K, b) {
              return { current: K.head, selector: b };
            }
            function f4(K) {
              return K.current = E(K.current), K.current ? { value: K.selector(K.current.key, K.current.value), done: false } : { value: void 0, done: true };
            }
            var T;
            (function(K) {
              function b(J) {
                var ie = function() {
                  function R(q, O) {
                    this._data = oe(q, O);
                  }
                  return R.prototype.next = function() {
                    return f4(this._data);
                  }, R;
                }();
                return function() {
                  function R(q) {
                    var O = this;
                    this._mapData = a(), G(J(q), function(ve) {
                      var ee = ve[0], he = ve[1];
                      return O.set(ee, he);
                    });
                  }
                  return Object.defineProperty(R.prototype, "size", { get: function() {
                    return this._mapData.size;
                  }, enumerable: false, configurable: true }), R.prototype.get = function(q) {
                    var O;
                    return (O = Q(this._mapData, q)) === null || O === void 0 ? void 0 : O.value;
                  }, R.prototype.set = function(q, O) {
                    return le(this._mapData, q, O), this;
                  }, R.prototype.has = function(q) {
                    return !!Q(this._mapData, q);
                  }, R.prototype.delete = function(q) {
                    return !!N(this._mapData, q);
                  }, R.prototype.clear = function() {
                    p(this._mapData);
                  }, R.prototype.keys = function() {
                    return new ie(this._mapData, function(q, O) {
                      return q;
                    });
                  }, R.prototype.values = function() {
                    return new ie(this._mapData, function(q, O) {
                      return O;
                    });
                  }, R.prototype.entries = function() {
                    return new ie(this._mapData, function(q, O) {
                      return [q, O];
                    });
                  }, R.prototype.forEach = function(q) {
                    m2(this._mapData, q);
                  }, R;
                }();
              }
              K.createMapShim = b;
              function se(J) {
                var ie = function() {
                  function R(q, O) {
                    this._data = oe(q, O);
                  }
                  return R.prototype.next = function() {
                    return f4(this._data);
                  }, R;
                }();
                return function() {
                  function R(q) {
                    var O = this;
                    this._mapData = a(), G(J(q), function(ve) {
                      return O.add(ve);
                    });
                  }
                  return Object.defineProperty(R.prototype, "size", { get: function() {
                    return this._mapData.size;
                  }, enumerable: false, configurable: true }), R.prototype.add = function(q) {
                    return le(this._mapData, q, q), this;
                  }, R.prototype.has = function(q) {
                    return !!Q(this._mapData, q);
                  }, R.prototype.delete = function(q) {
                    return !!N(this._mapData, q);
                  }, R.prototype.clear = function() {
                    p(this._mapData);
                  }, R.prototype.keys = function() {
                    return new ie(this._mapData, function(q, O) {
                      return q;
                    });
                  }, R.prototype.values = function() {
                    return new ie(this._mapData, function(q, O) {
                      return O;
                    });
                  }, R.prototype.entries = function() {
                    return new ie(this._mapData, function(q, O) {
                      return [q, O];
                    });
                  }, R.prototype.forEach = function(q) {
                    m2(this._mapData, q);
                  }, R;
                }();
              }
              K.createSetShim = se;
            })(T = e2.ShimCollections || (e2.ShimCollections = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            e2.versionMajorMinor = "4.7", e2.version = "4.7.2";
            var a;
            (function(B) {
              B[B.LessThan = -1] = "LessThan", B[B.EqualTo = 0] = "EqualTo", B[B.GreaterThan = 1] = "GreaterThan";
            })(a = e2.Comparison || (e2.Comparison = {}));
            var C;
            (function(B) {
              var E = typeof globalThis < "u" || typeof globalThis < "u" ? globalThis : typeof self < "u" ? self : void 0;
              function Q() {
                var N = E == null ? void 0 : E.Map;
                return typeof N < "u" && "entries" in N.prototype && new N([[0, 0]]).size === 1 ? N : void 0;
              }
              B.tryGetNativeMap = Q;
              function le() {
                var N = E == null ? void 0 : E.Set;
                return typeof N < "u" && "entries" in N.prototype && new N([0]).size === 1 ? N : void 0;
              }
              B.tryGetNativeSet = le;
            })(C || (C = {})), e2.Map = w("Map", "tryGetNativeMap", "createMapShim"), e2.Set = w("Set", "tryGetNativeSet", "createSetShim");
            function w(B, E, Q) {
              var le, N = (le = C[E]()) !== null && le !== void 0 ? le : e2.ShimCollections === null || e2.ShimCollections === void 0 ? void 0 : e2.ShimCollections[Q](e2.getIterator);
              if (N)
                return N;
              throw new Error("TypeScript requires an environment that provides a compatible native ".concat(B, " implementation."));
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(S2) {
              if (S2) {
                if (Oe(S2))
                  return Br(S2);
                if (S2 instanceof e2.Map)
                  return S2.entries();
                if (S2 instanceof e2.Set)
                  return S2.values();
                throw new Error("Iteration not supported.");
              }
            }
            e2.getIterator = a, e2.emptyArray = [], e2.emptyMap = new e2.Map(), e2.emptySet = new e2.Set();
            function C(S2) {
              return S2 ? S2.length : 0;
            }
            e2.length = C;
            function w(S2, Ce) {
              if (S2)
                for (var qe = 0; qe < S2.length; qe++) {
                  var br = Ce(S2[qe], qe);
                  if (br)
                    return br;
                }
            }
            e2.forEach = w;
            function B(S2, Ce) {
              if (S2)
                for (var qe = S2.length - 1; qe >= 0; qe--) {
                  var br = Ce(S2[qe], qe);
                  if (br)
                    return br;
                }
            }
            e2.forEachRight = B;
            function E(S2, Ce) {
              if (S2 !== void 0)
                for (var qe = 0; qe < S2.length; qe++) {
                  var br = Ce(S2[qe], qe);
                  if (br !== void 0)
                    return br;
                }
            }
            e2.firstDefined = E;
            function Q(S2, Ce) {
              for (; ; ) {
                var qe = S2.next();
                if (qe.done)
                  return;
                var br = Ce(qe.value);
                if (br !== void 0)
                  return br;
              }
            }
            e2.firstDefinedIterator = Q;
            function le(S2, Ce, qe) {
              var br = qe;
              if (S2)
                for (var Zr = S2.next(), Si = 0; !Zr.done; Zr = S2.next(), Si++)
                  br = Ce(br, Zr.value, Si);
              return br;
            }
            e2.reduceLeftIterator = le;
            function N(S2, Ce, qe) {
              var br = [];
              e2.Debug.assertEqual(S2.length, Ce.length);
              for (var Zr = 0; Zr < S2.length; Zr++)
                br.push(qe(S2[Zr], Ce[Zr], Zr));
              return br;
            }
            e2.zipWith = N;
            function p(S2, Ce) {
              e2.Debug.assertEqual(S2.length, Ce.length);
              var qe = 0;
              return { next: function() {
                return qe === S2.length ? { value: void 0, done: true } : (qe++, { value: [S2[qe - 1], Ce[qe - 1]], done: false });
              } };
            }
            e2.zipToIterator = p;
            function m2(S2, Ce) {
              e2.Debug.assert(S2.length === Ce.length);
              for (var qe = new e2.Map(), br = 0; br < S2.length; ++br)
                qe.set(S2[br], Ce[br]);
              return qe;
            }
            e2.zipToMap = m2;
            function G(S2, Ce) {
              if (S2.length <= 1)
                return S2;
              for (var qe = [], br = 0, Zr = S2.length; br < Zr; br++)
                br && qe.push(Ce), qe.push(S2[br]);
              return qe;
            }
            e2.intersperse = G;
            function oe(S2, Ce) {
              if (S2) {
                for (var qe = 0; qe < S2.length; qe++)
                  if (!Ce(S2[qe], qe))
                    return false;
              }
              return true;
            }
            e2.every = oe;
            function f4(S2, Ce) {
              for (var qe = 0; qe < S2.length; qe++) {
                var br = S2[qe];
                if (Ce(br, qe))
                  return br;
              }
            }
            e2.find = f4;
            function T(S2, Ce) {
              for (var qe = S2.length - 1; qe >= 0; qe--) {
                var br = S2[qe];
                if (Ce(br, qe))
                  return br;
              }
            }
            e2.findLast = T;
            function K(S2, Ce, qe) {
              for (var br = qe || 0; br < S2.length; br++)
                if (Ce(S2[br], br))
                  return br;
              return -1;
            }
            e2.findIndex = K;
            function b(S2, Ce, qe) {
              for (var br = qe === void 0 ? S2.length - 1 : qe; br >= 0; br--)
                if (Ce(S2[br], br))
                  return br;
              return -1;
            }
            e2.findLastIndex = b;
            function se(S2, Ce) {
              for (var qe = 0; qe < S2.length; qe++) {
                var br = Ce(S2[qe], qe);
                if (br)
                  return br;
              }
              return e2.Debug.fail();
            }
            e2.findMap = se;
            function J(S2, Ce, qe) {
              if (qe === void 0 && (qe = ut), S2)
                for (var br = 0, Zr = S2; br < Zr.length; br++) {
                  var Si = Zr[br];
                  if (qe(Si, Ce))
                    return true;
                }
              return false;
            }
            e2.contains = J;
            function ie(S2, Ce, qe) {
              return qe === void 0 && (qe = ut), S2.length === Ce.length && S2.every(function(br, Zr) {
                return qe(br, Ce[Zr]);
              });
            }
            e2.arraysEqual = ie;
            function R(S2, Ce, qe) {
              for (var br = qe || 0; br < S2.length; br++)
                if (J(Ce, S2.charCodeAt(br)))
                  return br;
              return -1;
            }
            e2.indexOfAnyCharCode = R;
            function q(S2, Ce) {
              var qe = 0;
              if (S2)
                for (var br = 0; br < S2.length; br++) {
                  var Zr = S2[br];
                  Ce(Zr, br) && qe++;
                }
              return qe;
            }
            e2.countWhere = q;
            function O(S2, Ce) {
              if (S2) {
                for (var qe = S2.length, br = 0; br < qe && Ce(S2[br]); )
                  br++;
                if (br < qe) {
                  var Zr = S2.slice(0, br);
                  for (br++; br < qe; ) {
                    var Si = S2[br];
                    Ce(Si) && Zr.push(Si), br++;
                  }
                  return Zr;
                }
              }
              return S2;
            }
            e2.filter = O;
            function ve(S2, Ce) {
              for (var qe = 0, br = 0; br < S2.length; br++)
                Ce(S2[br], br, S2) && (S2[qe] = S2[br], qe++);
              S2.length = qe;
            }
            e2.filterMutate = ve;
            function ee(S2) {
              S2.length = 0;
            }
            e2.clear = ee;
            function he(S2, Ce) {
              var qe;
              if (S2) {
                qe = [];
                for (var br = 0; br < S2.length; br++)
                  qe.push(Ce(S2[br], br));
              }
              return qe;
            }
            e2.map = he;
            function F2(S2, Ce) {
              return { next: function() {
                var qe = S2.next();
                return qe.done ? qe : { value: Ce(qe.value), done: false };
              } };
            }
            e2.mapIterator = F2;
            function x2(S2, Ce) {
              if (S2)
                for (var qe = 0; qe < S2.length; qe++) {
                  var br = S2[qe], Zr = Ce(br, qe);
                  if (br !== Zr) {
                    var Si = S2.slice(0, qe);
                    for (Si.push(Zr), qe++; qe < S2.length; qe++)
                      Si.push(Ce(S2[qe], qe));
                    return Si;
                  }
                }
              return S2;
            }
            e2.sameMap = x2;
            function X(S2) {
              for (var Ce = [], qe = 0, br = S2; qe < br.length; qe++) {
                var Zr = br[qe];
                Zr && (Oe(Zr) ? Ae(Ce, Zr) : Ce.push(Zr));
              }
              return Ce;
            }
            e2.flatten = X;
            function $(S2, Ce) {
              var qe;
              if (S2)
                for (var br = 0; br < S2.length; br++) {
                  var Zr = Ce(S2[br], br);
                  Zr && (Oe(Zr) ? qe = Ae(qe, Zr) : qe = we(qe, Zr));
                }
              return qe || e2.emptyArray;
            }
            e2.flatMap = $;
            function A2(S2, Ce) {
              var qe = [];
              if (S2)
                for (var br = 0; br < S2.length; br++) {
                  var Zr = Ce(S2[br], br);
                  Zr && (Oe(Zr) ? Ae(qe, Zr) : qe.push(Zr));
                }
              return qe;
            }
            e2.flatMapToMutable = A2;
            function y(S2, Ce) {
              var qe = S2.next();
              if (qe.done)
                return e2.emptyIterator;
              var br = Zr(qe.value);
              return { next: function() {
                for (; ; ) {
                  var Si = br.next();
                  if (!Si.done)
                    return Si;
                  var Pi = S2.next();
                  if (Pi.done)
                    return Pi;
                  br = Zr(Pi.value);
                }
              } };
              function Zr(Si) {
                var Pi = Ce(Si);
                return Pi === void 0 ? e2.emptyIterator : Oe(Pi) ? Br(Pi) : Pi;
              }
            }
            e2.flatMapIterator = y;
            function V(S2, Ce) {
              var qe;
              if (S2)
                for (var br = 0; br < S2.length; br++) {
                  var Zr = S2[br], Si = Ce(Zr, br);
                  (qe || Zr !== Si || Oe(Si)) && (qe || (qe = S2.slice(0, br)), Oe(Si) ? Ae(qe, Si) : qe.push(Si));
                }
              return qe || S2;
            }
            e2.sameFlatMap = V;
            function L(S2, Ce) {
              for (var qe = [], br = 0; br < S2.length; br++) {
                var Zr = Ce(S2[br], br);
                if (Zr === void 0)
                  return;
                qe.push(Zr);
              }
              return qe;
            }
            e2.mapAllOrFail = L;
            function P(S2, Ce) {
              var qe = [];
              if (S2)
                for (var br = 0; br < S2.length; br++) {
                  var Zr = Ce(S2[br], br);
                  Zr !== void 0 && qe.push(Zr);
                }
              return qe;
            }
            e2.mapDefined = P;
            function k(S2, Ce) {
              return { next: function() {
                for (; ; ) {
                  var qe = S2.next();
                  if (qe.done)
                    return qe;
                  var br = Ce(qe.value);
                  if (br !== void 0)
                    return { value: br, done: false };
                }
              } };
            }
            e2.mapDefinedIterator = k;
            function Y(S2, Ce) {
              if (!!S2) {
                var qe = new e2.Map();
                return S2.forEach(function(br, Zr) {
                  var Si = Ce(Zr, br);
                  if (Si !== void 0) {
                    var Pi = Si[0], Qi = Si[1];
                    Pi !== void 0 && Qi !== void 0 && qe.set(Pi, Qi);
                  }
                }), qe;
              }
            }
            e2.mapDefinedEntries = Y;
            function U(S2, Ce) {
              if (S2) {
                var qe = new e2.Set();
                return S2.forEach(function(br) {
                  var Zr = Ce(br);
                  Zr !== void 0 && qe.add(Zr);
                }), qe;
              }
            }
            e2.mapDefinedValues = U;
            function j(S2, Ce, qe) {
              if (S2.has(Ce))
                return S2.get(Ce);
              var br = qe();
              return S2.set(Ce, br), br;
            }
            e2.getOrUpdate = j;
            function H(S2, Ce) {
              return S2.has(Ce) ? false : (S2.add(Ce), true);
            }
            e2.tryAddToSet = H, e2.emptyIterator = { next: function() {
              return { value: void 0, done: true };
            } };
            function I(S2) {
              var Ce = false;
              return { next: function() {
                var qe = Ce;
                return Ce = true, qe ? { value: void 0, done: true } : { value: S2, done: false };
              } };
            }
            e2.singleIterator = I;
            function l(S2, Ce, qe) {
              var br;
              if (S2) {
                br = [];
                for (var Zr = S2.length, Si = void 0, Pi = void 0, Qi = 0, Ct = 0; Qi < Zr; ) {
                  for (; Ct < Zr; ) {
                    var sa = S2[Ct];
                    if (Pi = Ce(sa, Ct), Ct === 0)
                      Si = Pi;
                    else if (Pi !== Si)
                      break;
                    Ct++;
                  }
                  if (Qi < Ct) {
                    var en = qe(S2.slice(Qi, Ct), Si, Qi, Ct);
                    en && br.push(en), Qi = Ct;
                  }
                  Si = Pi, Ct++;
                }
              }
              return br;
            }
            e2.spanMap = l;
            function d(S2, Ce) {
              if (!!S2) {
                var qe = new e2.Map();
                return S2.forEach(function(br, Zr) {
                  var Si = Ce(Zr, br), Pi = Si[0], Qi = Si[1];
                  qe.set(Pi, Qi);
                }), qe;
              }
            }
            e2.mapEntries = d;
            function D(S2, Ce) {
              if (S2)
                if (Ce)
                  for (var qe = 0, br = S2; qe < br.length; qe++) {
                    var Zr = br[qe];
                    if (Ce(Zr))
                      return true;
                  }
                else
                  return S2.length > 0;
              return false;
            }
            e2.some = D;
            function fe(S2, Ce, qe) {
              for (var br, Zr = 0; Zr < S2.length; Zr++)
                Ce(S2[Zr]) ? br = br === void 0 ? Zr : br : br !== void 0 && (qe(br, Zr), br = void 0);
              br !== void 0 && qe(br, S2.length);
            }
            e2.getRangesWhere = fe;
            function g(S2, Ce) {
              return D(Ce) ? D(S2) ? Ve(Ve([], S2, true), Ce, true) : Ce : S2;
            }
            e2.concatenate = g;
            function ne(S2, Ce) {
              return Ce;
            }
            function ue(S2) {
              return S2.map(ne);
            }
            e2.indicesOf = ue;
            function We(S2, Ce, qe) {
              var br = ue(S2);
              Cr(S2, br, qe);
              for (var Zr = S2[br[0]], Si = [br[0]], Pi = 1; Pi < br.length; Pi++) {
                var Qi = br[Pi], Ct = S2[Qi];
                Ce(Zr, Ct) || (Si.push(Qi), Zr = Ct);
              }
              return Si.sort(), Si.map(function(sa) {
                return S2[sa];
              });
            }
            function Fe(S2, Ce) {
              for (var qe = [], br = 0, Zr = S2; br < Zr.length; br++) {
                var Si = Zr[br];
                er(qe, Si, Ce);
              }
              return qe;
            }
            function Z2(S2, Ce, qe) {
              return S2.length === 0 ? [] : S2.length === 1 ? S2.slice() : qe ? We(S2, Ce, qe) : Fe(S2, Ce);
            }
            e2.deduplicate = Z2;
            function Be(S2, Ce) {
              if (S2.length === 0)
                return e2.emptyArray;
              for (var qe = S2[0], br = [qe], Zr = 1; Zr < S2.length; Zr++) {
                var Si = S2[Zr];
                switch (Ce(Si, qe)) {
                  case true:
                  case 0:
                    continue;
                  case -1:
                    return e2.Debug.fail("Array is unsorted.");
                }
                br.push(qe = Si);
              }
              return br;
            }
            function ge() {
              return [];
            }
            e2.createSortedArray = ge;
            function Re(S2, Ce, qe, br) {
              if (S2.length === 0) {
                S2.push(Ce);
                return;
              }
              var Zr = ii(S2, Ce, vi, qe);
              Zr < 0 ? S2.splice(~Zr, 0, Ce) : br && S2.splice(Zr, 0, Ce);
            }
            e2.insertSorted = Re;
            function ze(S2, Ce, qe) {
              return Be(Ye(S2, Ce), qe || Ce || wt);
            }
            e2.sortAndDeduplicate = ze;
            function Ee(S2, Ce) {
              if (S2.length < 2)
                return true;
              for (var qe = S2[0], br = 0, Zr = S2.slice(1); br < Zr.length; br++) {
                var Si = Zr[br];
                if (Ce(qe, Si) === 1)
                  return false;
                qe = Si;
              }
              return true;
            }
            e2.arrayIsSorted = Ee;
            function He(S2, Ce, qe) {
              if (qe === void 0 && (qe = ut), !S2 || !Ce)
                return S2 === Ce;
              if (S2.length !== Ce.length)
                return false;
              for (var br = 0; br < S2.length; br++)
                if (!qe(S2[br], Ce[br], br))
                  return false;
              return true;
            }
            e2.arrayIsEqualTo = He;
            function rr(S2) {
              var Ce;
              if (S2)
                for (var qe = 0; qe < S2.length; qe++) {
                  var br = S2[qe];
                  (Ce || !br) && (Ce || (Ce = S2.slice(0, qe)), br && Ce.push(br));
                }
              return Ce || S2;
            }
            e2.compact = rr;
            function Ie(S2, Ce, qe) {
              if (!Ce || !S2 || Ce.length === 0 || S2.length === 0)
                return Ce;
              var br = [];
              e:
                for (var Zr = 0, Si = 0; Si < Ce.length; Si++) {
                  Si > 0 && e2.Debug.assertGreaterThanOrEqual(qe(Ce[Si], Ce[Si - 1]), 0);
                  r:
                    for (var Pi = Zr; Zr < S2.length; Zr++)
                      switch (Zr > Pi && e2.Debug.assertGreaterThanOrEqual(qe(S2[Zr], S2[Zr - 1]), 0), qe(Ce[Si], S2[Zr])) {
                        case -1:
                          br.push(Ce[Si]);
                          continue e;
                        case 0:
                          continue e;
                        case 1:
                          continue r;
                      }
                }
              return br;
            }
            e2.relativeComplement = Ie;
            function _e(S2, Ce) {
              for (var qe = 0, br = 0, Zr = S2; br < Zr.length; br++) {
                var Si = Zr[br];
                qe += Si[Ce];
              }
              return qe;
            }
            e2.sum = _e;
            function we(S2, Ce) {
              return Ce === void 0 ? S2 : S2 === void 0 ? [Ce] : (S2.push(Ce), S2);
            }
            e2.append = we;
            function de(S2, Ce) {
              return S2 === void 0 ? Ce : Ce === void 0 ? S2 : Oe(S2) ? Oe(Ce) ? g(S2, Ce) : we(S2, Ce) : Oe(Ce) ? we(Ce, S2) : [S2, Ce];
            }
            e2.combine = de;
            function ye(S2, Ce) {
              return Ce < 0 ? S2.length + Ce : Ce;
            }
            function Ae(S2, Ce, qe, br) {
              if (Ce === void 0 || Ce.length === 0)
                return S2;
              if (S2 === void 0)
                return Ce.slice(qe, br);
              qe = qe === void 0 ? 0 : ye(Ce, qe), br = br === void 0 ? Ce.length : ye(Ce, br);
              for (var Zr = qe; Zr < br && Zr < Ce.length; Zr++)
                Ce[Zr] !== void 0 && S2.push(Ce[Zr]);
              return S2;
            }
            e2.addRange = Ae;
            function er(S2, Ce, qe) {
              return J(S2, Ce, qe) ? false : (S2.push(Ce), true);
            }
            e2.pushIfUnique = er;
            function ir(S2, Ce, qe) {
              return S2 ? (er(S2, Ce, qe), S2) : [Ce];
            }
            e2.appendIfUnique = ir;
            function Cr(S2, Ce, qe) {
              Ce.sort(function(br, Zr) {
                return qe(S2[br], S2[Zr]) || Ki(br, Zr);
              });
            }
            function Ye(S2, Ce) {
              return S2.length === 0 ? S2 : S2.slice().sort(Ce);
            }
            e2.sort = Ye;
            function Br(S2) {
              var Ce = 0;
              return { next: function() {
                return Ce === S2.length ? { value: void 0, done: true } : (Ce++, { value: S2[Ce - 1], done: false });
              } };
            }
            e2.arrayIterator = Br;
            function Er(S2) {
              var Ce = S2.length;
              return { next: function() {
                return Ce === 0 ? { value: void 0, done: true } : (Ce--, { value: S2[Ce], done: false });
              } };
            }
            e2.arrayReverseIterator = Er;
            function Ne(S2, Ce) {
              var qe = ue(S2);
              return Cr(S2, qe, Ce), qe.map(function(br) {
                return S2[br];
              });
            }
            e2.stableSort = Ne;
            function n(S2, Ce, qe, br) {
              for (; qe < br; ) {
                if (S2[qe] !== Ce[qe])
                  return false;
                qe++;
              }
              return true;
            }
            e2.rangeEquals = n;
            function lr(S2, Ce) {
              if (S2 && (Ce = ye(S2, Ce), Ce < S2.length))
                return S2[Ce];
            }
            e2.elementAt = lr;
            function be(S2) {
              return S2.length === 0 ? void 0 : S2[0];
            }
            e2.firstOrUndefined = be;
            function Ge(S2) {
              return e2.Debug.assert(S2.length !== 0), S2[0];
            }
            e2.first = Ge;
            function ur(S2) {
              return S2.length === 0 ? void 0 : S2[S2.length - 1];
            }
            e2.lastOrUndefined = ur;
            function yr(S2) {
              return e2.Debug.assert(S2.length !== 0), S2[S2.length - 1];
            }
            e2.last = yr;
            function Ir(S2) {
              return S2 && S2.length === 1 ? S2[0] : void 0;
            }
            e2.singleOrUndefined = Ir;
            function wr(S2) {
              return S2 && S2.length === 1 ? S2[0] : S2;
            }
            e2.singleOrMany = wr;
            function Ur(S2, Ce, qe) {
              var br = S2.slice(0);
              return br[Ce] = qe, br;
            }
            e2.replaceElement = Ur;
            function ii(S2, Ce, qe, br, Zr) {
              return mi(S2, qe(Ce), qe, br, Zr);
            }
            e2.binarySearch = ii;
            function mi(S2, Ce, qe, br, Zr) {
              if (!D(S2))
                return -1;
              for (var Si = Zr || 0, Pi = S2.length - 1; Si <= Pi; ) {
                var Qi = Si + (Pi - Si >> 1), Ct = qe(S2[Qi], Qi);
                switch (br(Ct, Ce)) {
                  case -1:
                    Si = Qi + 1;
                    break;
                  case 0:
                    return Qi;
                  case 1:
                    Pi = Qi - 1;
                    break;
                }
              }
              return ~Si;
            }
            e2.binarySearchKey = mi;
            function pe(S2, Ce, qe, br, Zr) {
              if (S2 && S2.length > 0) {
                var Si = S2.length;
                if (Si > 0) {
                  var Pi = br === void 0 || br < 0 ? 0 : br, Qi = Zr === void 0 || Pi + Zr > Si - 1 ? Si - 1 : Pi + Zr, Ct = void 0;
                  for (arguments.length <= 2 ? (Ct = S2[Pi], Pi++) : Ct = qe; Pi <= Qi; )
                    Ct = Ce(Ct, S2[Pi], Pi), Pi++;
                  return Ct;
                }
              }
              return qe;
            }
            e2.reduceLeft = pe;
            var or = Object.prototype.hasOwnProperty;
            function qr(S2, Ce) {
              return or.call(S2, Ce);
            }
            e2.hasProperty = qr;
            function si(S2, Ce) {
              return or.call(S2, Ce) ? S2[Ce] : void 0;
            }
            e2.getProperty = si;
            function Di(S2) {
              var Ce = [];
              for (var qe in S2)
                or.call(S2, qe) && Ce.push(qe);
              return Ce;
            }
            e2.getOwnKeys = Di;
            function wi(S2) {
              var Ce = [];
              do
                for (var qe = Object.getOwnPropertyNames(S2), br = 0, Zr = qe; br < Zr.length; br++) {
                  var Si = Zr[br];
                  er(Ce, Si);
                }
              while (S2 = Object.getPrototypeOf(S2));
              return Ce;
            }
            e2.getAllKeys = wi;
            function Xi(S2) {
              var Ce = [];
              for (var qe in S2)
                or.call(S2, qe) && Ce.push(S2[qe]);
              return Ce;
            }
            e2.getOwnValues = Xi;
            var et = Object.entries || function(S2) {
              for (var Ce = Di(S2), qe = Array(Ce.length), br = 0; br < Ce.length; br++)
                qe[br] = [Ce[br], S2[Ce[br]]];
              return qe;
            };
            function Gi(S2) {
              return S2 ? et(S2) : [];
            }
            e2.getEntries = Gi;
            function Wt(S2, Ce) {
              for (var qe = new Array(S2), br = 0; br < S2; br++)
                qe[br] = Ce(br);
              return qe;
            }
            e2.arrayOf = Wt;
            function Zt(S2, Ce) {
              for (var qe = [], br = S2.next(); !br.done; br = S2.next())
                qe.push(Ce ? Ce(br.value) : br.value);
              return qe;
            }
            e2.arrayFrom = Zt;
            function _r(S2) {
              for (var Ce = [], qe = 1; qe < arguments.length; qe++)
                Ce[qe - 1] = arguments[qe];
              for (var br = 0, Zr = Ce; br < Zr.length; br++) {
                var Si = Zr[br];
                if (Si !== void 0)
                  for (var Pi in Si)
                    qr(Si, Pi) && (S2[Pi] = Si[Pi]);
              }
              return S2;
            }
            e2.assign = _r;
            function pi(S2, Ce, qe) {
              if (qe === void 0 && (qe = ut), S2 === Ce)
                return true;
              if (!S2 || !Ce)
                return false;
              for (var br in S2)
                if (or.call(S2, br) && (!or.call(Ce, br) || !qe(S2[br], Ce[br])))
                  return false;
              for (var br in Ce)
                if (or.call(Ce, br) && !or.call(S2, br))
                  return false;
              return true;
            }
            e2.equalOwnProperties = pi;
            function ae(S2, Ce, qe) {
              qe === void 0 && (qe = vi);
              for (var br = new e2.Map(), Zr = 0, Si = S2; Zr < Si.length; Zr++) {
                var Pi = Si[Zr], Qi = Ce(Pi);
                Qi !== void 0 && br.set(Qi, qe(Pi));
              }
              return br;
            }
            e2.arrayToMap = ae;
            function Xe(S2, Ce, qe) {
              qe === void 0 && (qe = vi);
              for (var br = [], Zr = 0, Si = S2; Zr < Si.length; Zr++) {
                var Pi = Si[Zr];
                br[Ce(Pi)] = qe(Pi);
              }
              return br;
            }
            e2.arrayToNumericMap = Xe;
            function Jr(S2, Ce, qe) {
              qe === void 0 && (qe = vi);
              for (var br = Je(), Zr = 0, Si = S2; Zr < Si.length; Zr++) {
                var Pi = Si[Zr];
                br.add(Ce(Pi), qe(Pi));
              }
              return br;
            }
            e2.arrayToMultiMap = Jr;
            function ti(S2, Ce, qe) {
              return qe === void 0 && (qe = vi), Zt(Jr(S2, Ce).values(), qe);
            }
            e2.group = ti;
            function Ze(S2) {
              var Ce = {};
              for (var qe in S2)
                or.call(S2, qe) && (Ce[qe] = S2[qe]);
              return Ce;
            }
            e2.clone = Ze;
            function Sr(S2, Ce) {
              var qe = {};
              for (var br in Ce)
                or.call(Ce, br) && (qe[br] = Ce[br]);
              for (var br in S2)
                or.call(S2, br) && (qe[br] = S2[br]);
              return qe;
            }
            e2.extend = Sr;
            function zr(S2, Ce) {
              for (var qe in Ce)
                or.call(Ce, qe) && (S2[qe] = Ce[qe]);
            }
            e2.copyProperties = zr;
            function Wr(S2, Ce) {
              return Ce ? Ce.bind(S2) : void 0;
            }
            e2.maybeBind = Wr;
            function Je() {
              var S2 = new e2.Map();
              return S2.add = xe, S2.remove = vr, S2;
            }
            e2.createMultiMap = Je;
            function xe(S2, Ce) {
              var qe = this.get(S2);
              return qe ? qe.push(Ce) : this.set(S2, qe = [Ce]), qe;
            }
            function vr(S2, Ce) {
              var qe = this.get(S2);
              qe && (Kn(qe, Ce), qe.length || this.delete(S2));
            }
            function mr() {
              return Je();
            }
            e2.createUnderscoreEscapedMultiMap = mr;
            function Ar(S2, Ce) {
              var qe = new e2.Map(), br = 0;
              function Zr() {
                var Pi = qe.values(), Qi;
                return { next: function() {
                  for (; ; )
                    if (Qi) {
                      var Ct = Qi.next();
                      if (!Ct.done)
                        return { value: Ct.value };
                      Qi = void 0;
                    } else {
                      var Ct = Pi.next();
                      if (Ct.done)
                        return { value: void 0, done: true };
                      if (!Oe(Ct.value))
                        return { value: Ct.value };
                      Qi = Br(Ct.value);
                    }
                } };
              }
              var Si = { has: function(Pi) {
                var Qi = S2(Pi);
                if (!qe.has(Qi))
                  return false;
                var Ct = qe.get(Qi);
                if (!Oe(Ct))
                  return Ce(Ct, Pi);
                for (var sa = 0, en = Ct; sa < en.length; sa++) {
                  var Wa = en[sa];
                  if (Ce(Wa, Pi))
                    return true;
                }
                return false;
              }, add: function(Pi) {
                var Qi = S2(Pi);
                if (qe.has(Qi)) {
                  var Ct = qe.get(Qi);
                  if (Oe(Ct))
                    J(Ct, Pi, Ce) || (Ct.push(Pi), br++);
                  else {
                    var sa = Ct;
                    Ce(sa, Pi) || (qe.set(Qi, [sa, Pi]), br++);
                  }
                } else
                  qe.set(Qi, Pi), br++;
                return this;
              }, delete: function(Pi) {
                var Qi = S2(Pi);
                if (!qe.has(Qi))
                  return false;
                var Ct = qe.get(Qi);
                if (Oe(Ct)) {
                  for (var sa = 0; sa < Ct.length; sa++)
                    if (Ce(Ct[sa], Pi))
                      return Ct.length === 1 ? qe.delete(Qi) : Ct.length === 2 ? qe.set(Qi, Ct[1 - sa]) : xn(Ct, sa), br--, true;
                } else {
                  var en = Ct;
                  if (Ce(en, Pi))
                    return qe.delete(Qi), br--, true;
                }
                return false;
              }, clear: function() {
                qe.clear(), br = 0;
              }, get size() {
                return br;
              }, forEach: function(Pi) {
                for (var Qi = 0, Ct = Zt(qe.values()); Qi < Ct.length; Qi++) {
                  var sa = Ct[Qi];
                  if (Oe(sa))
                    for (var en = 0, Wa = sa; en < Wa.length; en++) {
                      var qn = Wa[en];
                      Pi(qn, qn);
                    }
                  else {
                    var qn = sa;
                    Pi(qn, qn);
                  }
                }
              }, keys: function() {
                return Zr();
              }, values: function() {
                return Zr();
              }, entries: function() {
                var Pi = Zr();
                return { next: function() {
                  var Qi = Pi.next();
                  return Qi.done ? Qi : { value: [Qi.value, Qi.value] };
                } };
              } };
              return Si;
            }
            e2.createSet = Ar;
            function Oe(S2) {
              return Array.isArray ? Array.isArray(S2) : S2 instanceof Array;
            }
            e2.isArray = Oe;
            function nr(S2) {
              return Oe(S2) ? S2 : [S2];
            }
            e2.toArray = nr;
            function Mr(S2) {
              return typeof S2 == "string";
            }
            e2.isString = Mr;
            function Pe(S2) {
              return typeof S2 == "number";
            }
            e2.isNumber = Pe;
            function Ue(S2, Ce) {
              return S2 !== void 0 && Ce(S2) ? S2 : void 0;
            }
            e2.tryCast = Ue;
            function fr(S2, Ce) {
              return S2 !== void 0 && Ce(S2) ? S2 : e2.Debug.fail("Invalid cast. The supplied value ".concat(S2, " did not pass the test '").concat(e2.Debug.getFunctionName(Ce), "'."));
            }
            e2.cast = fr;
            function De(S2) {
            }
            e2.noop = De;
            function gr() {
              return false;
            }
            e2.returnFalse = gr;
            function Vr() {
              return true;
            }
            e2.returnTrue = Vr;
            function Tr() {
            }
            e2.returnUndefined = Tr;
            function vi(S2) {
              return S2;
            }
            e2.identity = vi;
            function Ui(S2) {
              return S2.toLowerCase();
            }
            e2.toLowerCase = Ui;
            var Yi = /[^\u0130\u0131\u00DFa-z0-9\\/:\-_\. ]+/g;
            function Wi(S2) {
              return Yi.test(S2) ? S2.replace(Yi, Ui) : S2;
            }
            e2.toFileNameLowerCase = Wi;
            function ct() {
              throw new Error("Not implemented");
            }
            e2.notImplemented = ct;
            function Li(S2) {
              var Ce;
              return function() {
                return S2 && (Ce = S2(), S2 = void 0), Ce;
              };
            }
            e2.memoize = Li;
            function nt(S2) {
              var Ce = new e2.Map();
              return function(qe) {
                var br = "".concat(typeof qe, ":").concat(qe), Zr = Ce.get(br);
                return Zr === void 0 && !Ce.has(br) && (Zr = S2(qe), Ce.set(br, Zr)), Zr;
              };
            }
            e2.memoizeOne = nt;
            function Mt(S2, Ce, qe, br, Zr) {
              if (Zr) {
                for (var Si = [], Pi = 0; Pi < arguments.length; Pi++)
                  Si[Pi] = arguments[Pi];
                return function(Qi) {
                  return pe(Si, function(Ct, sa) {
                    return sa(Ct);
                  }, Qi);
                };
              } else
                return br ? function(Qi) {
                  return br(qe(Ce(S2(Qi))));
                } : qe ? function(Qi) {
                  return qe(Ce(S2(Qi)));
                } : Ce ? function(Qi) {
                  return Ce(S2(Qi));
                } : S2 ? function(Qi) {
                  return S2(Qi);
                } : function(Qi) {
                  return Qi;
                };
            }
            e2.compose = Mt;
            var xt;
            (function(S2) {
              S2[S2.None = 0] = "None", S2[S2.Normal = 1] = "Normal", S2[S2.Aggressive = 2] = "Aggressive", S2[S2.VeryAggressive = 3] = "VeryAggressive";
            })(xt = e2.AssertionLevel || (e2.AssertionLevel = {}));
            function ut(S2, Ce) {
              return S2 === Ce;
            }
            e2.equateValues = ut;
            function Dt(S2, Ce) {
              return S2 === Ce || S2 !== void 0 && Ce !== void 0 && S2.toUpperCase() === Ce.toUpperCase();
            }
            e2.equateStringsCaseInsensitive = Dt;
            function Rt(S2, Ce) {
              return ut(S2, Ce);
            }
            e2.equateStringsCaseSensitive = Rt;
            function Ii(S2, Ce) {
              return S2 === Ce ? 0 : S2 === void 0 ? -1 : Ce === void 0 ? 1 : S2 < Ce ? -1 : 1;
            }
            function Ki(S2, Ce) {
              return Ii(S2, Ce);
            }
            e2.compareValues = Ki;
            function Fi(S2, Ce) {
              return Ki(S2 == null ? void 0 : S2.start, Ce == null ? void 0 : Ce.start) || Ki(S2 == null ? void 0 : S2.length, Ce == null ? void 0 : Ce.length);
            }
            e2.compareTextSpans = Fi;
            function ui(S2, Ce, qe) {
              return qe(S2, Ce) === -1 ? S2 : Ce;
            }
            e2.min = ui;
            function Bt(S2, Ce) {
              return S2 === Ce ? 0 : S2 === void 0 ? -1 : Ce === void 0 ? 1 : (S2 = S2.toUpperCase(), Ce = Ce.toUpperCase(), S2 < Ce ? -1 : S2 > Ce ? 1 : 0);
            }
            e2.compareStringsCaseInsensitive = Bt;
            function wt(S2, Ce) {
              return Ii(S2, Ce);
            }
            e2.compareStringsCaseSensitive = wt;
            function na(S2) {
              return S2 ? Bt : wt;
            }
            e2.getStringComparer = na;
            var Ai = function() {
              var S2, Ce, qe = Qi();
              return Ct;
              function br(sa, en, Wa) {
                if (sa === en)
                  return 0;
                if (sa === void 0)
                  return -1;
                if (en === void 0)
                  return 1;
                var qn = Wa(sa, en);
                return qn < 0 ? -1 : qn > 0 ? 1 : 0;
              }
              function Zr(sa) {
                var en = new Intl.Collator(sa, { usage: "sort", sensitivity: "variant" }).compare;
                return function(Wa, qn) {
                  return br(Wa, qn, en);
                };
              }
              function Si(sa) {
                if (sa !== void 0)
                  return Pi();
                return function(Wa, qn) {
                  return br(Wa, qn, en);
                };
                function en(Wa, qn) {
                  return Wa.localeCompare(qn);
                }
              }
              function Pi() {
                return function(Wa, qn) {
                  return br(Wa, qn, sa);
                };
                function sa(Wa, qn) {
                  return en(Wa.toUpperCase(), qn.toUpperCase()) || en(Wa, qn);
                }
                function en(Wa, qn) {
                  return Wa < qn ? -1 : Wa > qn ? 1 : 0;
                }
              }
              function Qi() {
                return typeof Intl == "object" && typeof Intl.Collator == "function" ? Zr : typeof String.prototype.localeCompare == "function" && typeof String.prototype.toLocaleUpperCase == "function" && "a".localeCompare("B") < 0 ? Si : Pi;
              }
              function Ct(sa) {
                return sa === void 0 ? S2 || (S2 = qe(sa)) : sa === "en-US" ? Ce || (Ce = qe(sa)) : qe(sa);
              }
            }(), Oi, ji;
            function Vi() {
              return ji;
            }
            e2.getUILocale = Vi;
            function at(S2) {
              ji !== S2 && (ji = S2, Oi = void 0);
            }
            e2.setUILocale = at;
            function At(S2, Ce) {
              var qe = Oi || (Oi = Ai(ji));
              return qe(S2, Ce);
            }
            e2.compareStringsCaseSensitiveUI = At;
            function ba(S2, Ce, qe, br) {
              return S2 === Ce ? 0 : S2 === void 0 ? -1 : Ce === void 0 ? 1 : br(S2[qe], Ce[qe]);
            }
            e2.compareProperties = ba;
            function $a(S2, Ce) {
              return Ki(S2 ? 1 : 0, Ce ? 1 : 0);
            }
            e2.compareBooleans = $a;
            function Qa(S2, Ce, qe) {
              for (var br = Math.min(2, Math.floor(S2.length * 0.34)), Zr = Math.floor(S2.length * 0.4) + 1, Si, Pi = 0, Qi = Ce; Pi < Qi.length; Pi++) {
                var Ct = Qi[Pi], sa = qe(Ct);
                if (sa !== void 0 && Math.abs(sa.length - S2.length) <= br) {
                  if (sa === S2 || sa.length < 3 && sa.toLowerCase() !== S2.toLowerCase())
                    continue;
                  var en = ai(S2, sa, Zr - 0.1);
                  if (en === void 0)
                    continue;
                  e2.Debug.assert(en < Zr), Zr = en, Si = Ct;
                }
              }
              return Si;
            }
            e2.getSpellingSuggestion = Qa;
            function ai(S2, Ce, qe) {
              for (var br = new Array(Ce.length + 1), Zr = new Array(Ce.length + 1), Si = qe + 0.01, Pi = 0; Pi <= Ce.length; Pi++)
                br[Pi] = Pi;
              for (var Pi = 1; Pi <= S2.length; Pi++) {
                var Qi = S2.charCodeAt(Pi - 1), Ct = Math.ceil(Pi > qe ? Pi - qe : 1), sa = Math.floor(Ce.length > qe + Pi ? qe + Pi : Ce.length);
                Zr[0] = Pi;
                for (var en = Pi, Wa = 1; Wa < Ct; Wa++)
                  Zr[Wa] = Si;
                for (var Wa = Ct; Wa <= sa; Wa++) {
                  var qn = S2[Pi - 1].toLowerCase() === Ce[Wa - 1].toLowerCase() ? br[Wa - 1] + 0.1 : br[Wa - 1] + 2, mo = Qi === Ce.charCodeAt(Wa - 1) ? br[Wa - 1] : Math.min(br[Wa] + 1, Zr[Wa - 1] + 1, qn);
                  Zr[Wa] = mo, en = Math.min(en, mo);
                }
                for (var Wa = sa + 1; Wa <= Ce.length; Wa++)
                  Zr[Wa] = Si;
                if (en > qe)
                  return;
                var So = br;
                br = Zr, Zr = So;
              }
              var Go = br[Ce.length];
              return Go > qe ? void 0 : Go;
            }
            function Dn(S2, Ce) {
              var qe = S2.length - Ce.length;
              return qe >= 0 && S2.indexOf(Ce, qe) === qe;
            }
            e2.endsWith = Dn;
            function ka(S2, Ce) {
              return Dn(S2, Ce) ? S2.slice(0, S2.length - Ce.length) : S2;
            }
            e2.removeSuffix = ka;
            function Ba(S2, Ce) {
              return Dn(S2, Ce) ? S2.slice(0, S2.length - Ce.length) : void 0;
            }
            e2.tryRemoveSuffix = Ba;
            function pn(S2, Ce) {
              return S2.indexOf(Ce) !== -1;
            }
            e2.stringContains = pn;
            function Cn(S2) {
              for (var Ce = S2.length, qe = Ce - 1; qe > 0; qe--) {
                var br = S2.charCodeAt(qe);
                if (br >= 48 && br <= 57)
                  do
                    --qe, br = S2.charCodeAt(qe);
                  while (qe > 0 && br >= 48 && br <= 57);
                else if (qe > 4 && (br === 110 || br === 78)) {
                  if (--qe, br = S2.charCodeAt(qe), br !== 105 && br !== 73 || (--qe, br = S2.charCodeAt(qe), br !== 109 && br !== 77))
                    break;
                  --qe, br = S2.charCodeAt(qe);
                } else
                  break;
                if (br !== 45 && br !== 46)
                  break;
                Ce = qe;
              }
              return Ce === S2.length ? S2 : S2.slice(0, Ce);
            }
            e2.removeMinAndVersionNumbers = Cn;
            function Bi(S2, Ce) {
              for (var qe = 0; qe < S2.length; qe++)
                if (S2[qe] === Ce)
                  return kn(S2, qe), true;
              return false;
            }
            e2.orderedRemoveItem = Bi;
            function kn(S2, Ce) {
              for (var qe = Ce; qe < S2.length - 1; qe++)
                S2[qe] = S2[qe + 1];
              S2.pop();
            }
            e2.orderedRemoveItemAt = kn;
            function xn(S2, Ce) {
              S2[Ce] = S2[S2.length - 1], S2.pop();
            }
            e2.unorderedRemoveItemAt = xn;
            function Kn(S2, Ce) {
              return Pn(S2, function(qe) {
                return qe === Ce;
              });
            }
            e2.unorderedRemoveItem = Kn;
            function Pn(S2, Ce) {
              for (var qe = 0; qe < S2.length; qe++)
                if (Ce(S2[qe]))
                  return xn(S2, qe), true;
              return false;
            }
            function eo(S2) {
              return S2 ? vi : Wi;
            }
            e2.createGetCanonicalFileName = eo;
            function Rn(S2) {
              var Ce = S2.prefix, qe = S2.suffix;
              return "".concat(Ce, "*").concat(qe);
            }
            e2.patternText = Rn;
            function Da(S2, Ce) {
              return e2.Debug.assert(to(S2, Ce)), Ce.substring(S2.prefix.length, Ce.length - S2.suffix.length);
            }
            e2.matchedText = Da;
            function bo(S2, Ce, qe) {
              for (var br, Zr = -1, Si = 0, Pi = S2; Si < Pi.length; Si++) {
                var Qi = Pi[Si], Ct = Ce(Qi);
                to(Ct, qe) && Ct.prefix.length > Zr && (Zr = Ct.prefix.length, br = Qi);
              }
              return br;
            }
            e2.findBestPatternMatch = bo;
            function Ro(S2, Ce) {
              return S2.lastIndexOf(Ce, 0) === 0;
            }
            e2.startsWith = Ro;
            function En(S2, Ce) {
              return Ro(S2, Ce) ? S2.substr(Ce.length) : S2;
            }
            e2.removePrefix = En;
            function Wn(S2, Ce, qe) {
              return qe === void 0 && (qe = vi), Ro(qe(S2), qe(Ce)) ? S2.substring(Ce.length) : void 0;
            }
            e2.tryRemovePrefix = Wn;
            function to(S2, Ce) {
              var qe = S2.prefix, br = S2.suffix;
              return Ce.length >= qe.length + br.length && Ro(Ce, qe) && Dn(Ce, br);
            }
            function Co(S2, Ce) {
              return function(qe) {
                return S2(qe) && Ce(qe);
              };
            }
            e2.and = Co;
            function Ko() {
              for (var S2 = [], Ce = 0; Ce < arguments.length; Ce++)
                S2[Ce] = arguments[Ce];
              return function() {
                for (var qe = [], br = 0; br < arguments.length; br++)
                  qe[br] = arguments[br];
                for (var Zr, Si = 0, Pi = S2; Si < Pi.length; Si++) {
                  var Qi = Pi[Si];
                  if (Zr = Qi.apply(void 0, qe), Zr)
                    return Zr;
                }
                return Zr;
              };
            }
            e2.or = Ko;
            function Oo(S2) {
              return function() {
                for (var Ce = [], qe = 0; qe < arguments.length; qe++)
                  Ce[qe] = arguments[qe];
                return !S2.apply(void 0, Ce);
              };
            }
            e2.not = Oo;
            function no(S2) {
            }
            e2.assertType = no;
            function $o(S2) {
              return S2 === void 0 ? void 0 : [S2];
            }
            e2.singleElementArray = $o;
            function Pr(S2, Ce, qe, br, Zr, Si) {
              Si = Si || De;
              for (var Pi = 0, Qi = 0, Ct = S2.length, sa = Ce.length, en = false; Pi < Ct && Qi < sa; ) {
                var Wa = S2[Pi], qn = Ce[Qi], mo = qe(Wa, qn);
                mo === -1 ? (br(Wa), Pi++, en = true) : mo === 1 ? (Zr(qn), Qi++, en = true) : (Si(qn, Wa), Pi++, Qi++);
              }
              for (; Pi < Ct; )
                br(S2[Pi++]), en = true;
              for (; Qi < sa; )
                Zr(Ce[Qi++]), en = true;
              return en;
            }
            e2.enumerateInsertsAndDeletes = Pr;
            function xi(S2, Ce) {
              for (var qe = Array(S2), br = 0; br < S2; br++)
                qe[br] = Ce(br);
              return qe;
            }
            e2.fill = xi;
            function St(S2) {
              var Ce = [];
              return pa(S2, Ce, void 0, 0), Ce;
            }
            e2.cartesianProduct = St;
            function pa(S2, Ce, qe, br) {
              for (var Zr = 0, Si = S2[br]; Zr < Si.length; Zr++) {
                var Pi = Si[Zr], Qi = void 0;
                qe ? (Qi = qe.slice(), Qi.push(Pi)) : Qi = [Pi], br === S2.length - 1 ? Ce.push(Qi) : pa(S2, Ce, Qi, br + 1);
              }
            }
            function dn(S2, Ce, qe) {
              return qe === void 0 && (qe = " "), Ce <= S2.length ? S2 : qe.repeat(Ce - S2.length) + S2;
            }
            e2.padLeft = dn;
            function Jn(S2, Ce, qe) {
              return qe === void 0 && (qe = " "), Ce <= S2.length ? S2 : S2 + qe.repeat(Ce - S2.length);
            }
            e2.padRight = Jn;
            function Qe(S2, Ce) {
              for (var qe = S2.length, br = 0; br < qe && Ce(S2[br]); )
                br++;
              return S2.slice(0, br);
            }
            e2.takeWhile = Qe, e2.trimString = String.prototype.trim ? function(S2) {
              return S2.trim();
            } : function(S2) {
              return e2.trimStringEnd(e2.trimStringStart(S2));
            }, e2.trimStringEnd = String.prototype.trimEnd ? function(S2) {
              return S2.trimEnd();
            } : Gr, e2.trimStringStart = String.prototype.trimStart ? function(S2) {
              return S2.trimStart();
            } : function(S2) {
              return S2.replace(/^\s+/g, "");
            };
            function Gr(S2) {
              for (var Ce = S2.length - 1; Ce >= 0 && e2.isWhiteSpaceLike(S2.charCodeAt(Ce)); )
                Ce--;
              return S2.slice(0, Ce + 1);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(w) {
              w[w.Off = 0] = "Off", w[w.Error = 1] = "Error", w[w.Warning = 2] = "Warning", w[w.Info = 3] = "Info", w[w.Verbose = 4] = "Verbose";
            })(a = e2.LogLevel || (e2.LogLevel = {}));
            var C;
            (function(w) {
              var B, E = 0;
              w.currentLogLevel = a.Warning, w.isDebugging = false;
              function Q() {
                return B != null ? B : B = new e2.Version(e2.version);
              }
              w.getTypeScriptVersion = Q;
              function le(Ye) {
                return w.currentLogLevel <= Ye;
              }
              w.shouldLog = le;
              function N(Ye, Br) {
                w.loggingHost && le(Ye) && w.loggingHost.log(Ye, Br);
              }
              function p(Ye) {
                N(a.Info, Ye);
              }
              w.log = p, function(Ye) {
                function Br(lr) {
                  N(a.Error, lr);
                }
                Ye.error = Br;
                function Er(lr) {
                  N(a.Warning, lr);
                }
                Ye.warn = Er;
                function Ne(lr) {
                  N(a.Info, lr);
                }
                Ye.log = Ne;
                function n(lr) {
                  N(a.Verbose, lr);
                }
                Ye.trace = n;
              }(p = w.log || (w.log = {}));
              var m2 = {};
              function G() {
                return E;
              }
              w.getAssertionLevel = G;
              function oe(Ye) {
                var Br = E;
                if (E = Ye, Ye > Br)
                  for (var Er = 0, Ne = e2.getOwnKeys(m2); Er < Ne.length; Er++) {
                    var n = Ne[Er], lr = m2[n];
                    lr !== void 0 && w[n] !== lr.assertion && Ye >= lr.level && (w[n] = lr, m2[n] = void 0);
                  }
              }
              w.setAssertionLevel = oe;
              function f4(Ye) {
                return E >= Ye;
              }
              w.shouldAssert = f4;
              function T(Ye, Br) {
                return f4(Ye) ? true : (m2[Br] = { level: Ye, assertion: w[Br] }, w[Br] = e2.noop, false);
              }
              function K(Ye, Br) {
                debugger;
                var Er = new Error(Ye ? "Debug Failure. ".concat(Ye) : "Debug Failure.");
                throw Error.captureStackTrace && Error.captureStackTrace(Er, Br || K), Er;
              }
              w.fail = K;
              function b(Ye, Br, Er) {
                return K("".concat(Br || "Unexpected node.", `\r
Node `).concat(j(Ye.kind), " was unexpected."), Er || b);
              }
              w.failBadSyntaxKind = b;
              function se(Ye, Br, Er, Ne) {
                Ye || (Br = Br ? "False expression: ".concat(Br) : "False expression.", Er && (Br += `\r
Verbose Debug Information: ` + (typeof Er == "string" ? Er : Er())), K(Br, Ne || se));
              }
              w.assert = se;
              function J(Ye, Br, Er, Ne, n) {
                if (Ye !== Br) {
                  var lr = Er ? Ne ? "".concat(Er, " ").concat(Ne) : Er : "";
                  K("Expected ".concat(Ye, " === ").concat(Br, ". ").concat(lr), n || J);
                }
              }
              w.assertEqual = J;
              function ie(Ye, Br, Er, Ne) {
                Ye >= Br && K("Expected ".concat(Ye, " < ").concat(Br, ". ").concat(Er || ""), Ne || ie);
              }
              w.assertLessThan = ie;
              function R(Ye, Br, Er) {
                Ye > Br && K("Expected ".concat(Ye, " <= ").concat(Br), Er || R);
              }
              w.assertLessThanOrEqual = R;
              function q(Ye, Br, Er) {
                Ye < Br && K("Expected ".concat(Ye, " >= ").concat(Br), Er || q);
              }
              w.assertGreaterThanOrEqual = q;
              function O(Ye, Br, Er) {
                Ye == null && K(Br, Er || O);
              }
              w.assertIsDefined = O;
              function ve(Ye, Br, Er) {
                return O(Ye, Br, Er || ve), Ye;
              }
              w.checkDefined = ve;
              function ee(Ye, Br, Er) {
                for (var Ne = 0, n = Ye; Ne < n.length; Ne++) {
                  var lr = n[Ne];
                  O(lr, Br, Er || ee);
                }
              }
              w.assertEachIsDefined = ee;
              function he(Ye, Br, Er) {
                return ee(Ye, Br, Er || he), Ye;
              }
              w.checkEachDefined = he;
              function F2(Ye, Br, Er) {
                Br === void 0 && (Br = "Illegal value:");
                var Ne = typeof Ye == "object" && e2.hasProperty(Ye, "kind") && e2.hasProperty(Ye, "pos") ? "SyntaxKind: " + j(Ye.kind) : JSON.stringify(Ye);
                return K("".concat(Br, " ").concat(Ne), Er || F2);
              }
              w.assertNever = F2;
              function x2(Ye, Br, Er, Ne) {
                T(1, "assertEachNode") && se(Br === void 0 || e2.every(Ye, Br), Er || "Unexpected node.", function() {
                  return "Node array did not pass test '".concat(P(Br), "'.");
                }, Ne || x2);
              }
              w.assertEachNode = x2;
              function X(Ye, Br, Er, Ne) {
                T(1, "assertNode") && se(Ye !== void 0 && (Br === void 0 || Br(Ye)), Er || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye == null ? void 0 : Ye.kind), " did not pass test '").concat(P(Br), "'.");
                }, Ne || X);
              }
              w.assertNode = X;
              function $(Ye, Br, Er, Ne) {
                T(1, "assertNotNode") && se(Ye === void 0 || Br === void 0 || !Br(Ye), Er || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye.kind), " should not have passed test '").concat(P(Br), "'.");
                }, Ne || $);
              }
              w.assertNotNode = $;
              function A2(Ye, Br, Er, Ne) {
                T(1, "assertOptionalNode") && se(Br === void 0 || Ye === void 0 || Br(Ye), Er || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye == null ? void 0 : Ye.kind), " did not pass test '").concat(P(Br), "'.");
                }, Ne || A2);
              }
              w.assertOptionalNode = A2;
              function y(Ye, Br, Er, Ne) {
                T(1, "assertOptionalToken") && se(Br === void 0 || Ye === void 0 || Ye.kind === Br, Er || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye == null ? void 0 : Ye.kind), " was not a '").concat(j(Br), "' token.");
                }, Ne || y);
              }
              w.assertOptionalToken = y;
              function V(Ye, Br, Er) {
                T(1, "assertMissingNode") && se(Ye === void 0, Br || "Unexpected node.", function() {
                  return "Node ".concat(j(Ye.kind), " was unexpected'.");
                }, Er || V);
              }
              w.assertMissingNode = V;
              function L(Ye) {
              }
              w.type = L;
              function P(Ye) {
                if (typeof Ye != "function")
                  return "";
                if (Ye.hasOwnProperty("name"))
                  return Ye.name;
                var Br = Function.prototype.toString.call(Ye), Er = /^function\s+([\w\$]+)\s*\(/.exec(Br);
                return Er ? Er[1] : "";
              }
              w.getFunctionName = P;
              function k(Ye) {
                return "{ name: ".concat(e2.unescapeLeadingUnderscores(Ye.escapedName), "; flags: ").concat(fe(Ye.flags), "; declarations: ").concat(e2.map(Ye.declarations, function(Br) {
                  return j(Br.kind);
                }), " }");
              }
              w.formatSymbol = k;
              function Y(Ye, Br, Er) {
                Ye === void 0 && (Ye = 0);
                var Ne = U(Br);
                if (Ye === 0)
                  return Ne.length > 0 && Ne[0][0] === 0 ? Ne[0][1] : "0";
                if (Er) {
                  for (var n = "", lr = Ye, be = 0, Ge = Ne; be < Ge.length; be++) {
                    var ur = Ge[be], yr = ur[0], Ir = ur[1];
                    if (yr > Ye)
                      break;
                    yr !== 0 && yr & Ye && (n = "".concat(n).concat(n ? "|" : "").concat(Ir), lr &= ~yr);
                  }
                  if (lr === 0)
                    return n;
                } else
                  for (var wr = 0, Ur = Ne; wr < Ur.length; wr++) {
                    var ii = Ur[wr], yr = ii[0], Ir = ii[1];
                    if (yr === Ye)
                      return Ir;
                  }
                return Ye.toString();
              }
              w.formatEnum = Y;
              function U(Ye) {
                var Br = [];
                for (var Er in Ye) {
                  var Ne = Ye[Er];
                  typeof Ne == "number" && Br.push([Ne, Er]);
                }
                return e2.stableSort(Br, function(n, lr) {
                  return e2.compareValues(n[0], lr[0]);
                });
              }
              function j(Ye) {
                return Y(Ye, e2.SyntaxKind, false);
              }
              w.formatSyntaxKind = j;
              function H(Ye) {
                return Y(Ye, e2.SnippetKind, false);
              }
              w.formatSnippetKind = H;
              function I(Ye) {
                return Y(Ye, e2.NodeFlags, true);
              }
              w.formatNodeFlags = I;
              function l(Ye) {
                return Y(Ye, e2.ModifierFlags, true);
              }
              w.formatModifierFlags = l;
              function d(Ye) {
                return Y(Ye, e2.TransformFlags, true);
              }
              w.formatTransformFlags = d;
              function D(Ye) {
                return Y(Ye, e2.EmitFlags, true);
              }
              w.formatEmitFlags = D;
              function fe(Ye) {
                return Y(Ye, e2.SymbolFlags, true);
              }
              w.formatSymbolFlags = fe;
              function g(Ye) {
                return Y(Ye, e2.TypeFlags, true);
              }
              w.formatTypeFlags = g;
              function ne(Ye) {
                return Y(Ye, e2.SignatureFlags, true);
              }
              w.formatSignatureFlags = ne;
              function ue(Ye) {
                return Y(Ye, e2.ObjectFlags, true);
              }
              w.formatObjectFlags = ue;
              function We(Ye) {
                return Y(Ye, e2.FlowFlags, true);
              }
              w.formatFlowFlags = We;
              var Fe = false, Z2;
              function Be() {
                if (we(), !Z2)
                  throw new Error("Debugging helpers could not be loaded.");
                return Z2;
              }
              function ge(Ye) {
                return console.log(Re(Ye));
              }
              w.printControlFlowGraph = ge;
              function Re(Ye) {
                return Be().formatControlFlowGraph(Ye);
              }
              w.formatControlFlowGraph = Re;
              var ze;
              function Ee(Ye) {
                "__debugFlowFlags" in Ye || Object.defineProperties(Ye, { __tsDebuggerDisplay: { value: function() {
                  var Br = this.flags & 2 ? "FlowStart" : this.flags & 4 ? "FlowBranchLabel" : this.flags & 8 ? "FlowLoopLabel" : this.flags & 16 ? "FlowAssignment" : this.flags & 32 ? "FlowTrueCondition" : this.flags & 64 ? "FlowFalseCondition" : this.flags & 128 ? "FlowSwitchClause" : this.flags & 256 ? "FlowArrayMutation" : this.flags & 512 ? "FlowCall" : this.flags & 1024 ? "FlowReduceLabel" : this.flags & 1 ? "FlowUnreachable" : "UnknownFlow", Er = this.flags & ~(2048 - 1);
                  return "".concat(Br).concat(Er ? " (".concat(We(Er), ")") : "");
                } }, __debugFlowFlags: { get: function() {
                  return Y(this.flags, e2.FlowFlags, true);
                } }, __debugToString: { value: function() {
                  return Re(this);
                } } });
              }
              function He(Ye) {
                Fe && (typeof Object.setPrototypeOf == "function" ? (ze || (ze = Object.create(Object.prototype), Ee(ze)), Object.setPrototypeOf(Ye, ze)) : Ee(Ye));
              }
              w.attachFlowNodeDebugInfo = He;
              var rr;
              function Ie(Ye) {
                "__tsDebuggerDisplay" in Ye || Object.defineProperties(Ye, { __tsDebuggerDisplay: { value: function(Br) {
                  return Br = String(Br).replace(/(?:,[\s\w\d_]+:[^,]+)+\]$/, "]"), "NodeArray ".concat(Br);
                } } });
              }
              function _e(Ye) {
                Fe && (typeof Object.setPrototypeOf == "function" ? (rr || (rr = Object.create(Array.prototype), Ie(rr)), Object.setPrototypeOf(Ye, rr)) : Ie(Ye));
              }
              w.attachNodeArrayDebugInfo = _e;
              function we() {
                if (Fe)
                  return;
                var Ye, Br;
                function Er() {
                  return Ye === void 0 && typeof WeakMap == "function" && (Ye = /* @__PURE__ */ new WeakMap()), Ye;
                }
                function Ne() {
                  return Br === void 0 && typeof WeakMap == "function" && (Br = /* @__PURE__ */ new WeakMap()), Br;
                }
                Object.defineProperties(e2.objectAllocator.getSymbolConstructor().prototype, { __tsDebuggerDisplay: { value: function() {
                  var Ir = this.flags & 33554432 ? "TransientSymbol" : "Symbol", wr = this.flags & -33554433;
                  return "".concat(Ir, " '").concat(e2.symbolName(this), "'").concat(wr ? " (".concat(fe(wr), ")") : "");
                } }, __debugFlags: { get: function() {
                  return fe(this.flags);
                } } }), Object.defineProperties(e2.objectAllocator.getTypeConstructor().prototype, { __tsDebuggerDisplay: { value: function() {
                  var Ir = this.flags & 98304 ? "NullableType" : this.flags & 384 ? "LiteralType ".concat(JSON.stringify(this.value)) : this.flags & 2048 ? "LiteralType ".concat(this.value.negative ? "-" : "").concat(this.value.base10Value, "n") : this.flags & 8192 ? "UniqueESSymbolType" : this.flags & 32 ? "EnumType" : this.flags & 67359327 ? "IntrinsicType ".concat(this.intrinsicName) : this.flags & 1048576 ? "UnionType" : this.flags & 2097152 ? "IntersectionType" : this.flags & 4194304 ? "IndexType" : this.flags & 8388608 ? "IndexedAccessType" : this.flags & 16777216 ? "ConditionalType" : this.flags & 33554432 ? "SubstitutionType" : this.flags & 262144 ? "TypeParameter" : this.flags & 524288 ? this.objectFlags & 3 ? "InterfaceType" : this.objectFlags & 4 ? "TypeReference" : this.objectFlags & 8 ? "TupleType" : this.objectFlags & 16 ? "AnonymousType" : this.objectFlags & 32 ? "MappedType" : this.objectFlags & 1024 ? "ReverseMappedType" : this.objectFlags & 256 ? "EvolvingArrayType" : "ObjectType" : "Type", wr = this.flags & 524288 ? this.objectFlags & -1344 : 0;
                  return "".concat(Ir).concat(this.symbol ? " '".concat(e2.symbolName(this.symbol), "'") : "").concat(wr ? " (".concat(ue(wr), ")") : "");
                } }, __debugFlags: { get: function() {
                  return g(this.flags);
                } }, __debugObjectFlags: { get: function() {
                  return this.flags & 524288 ? ue(this.objectFlags) : "";
                } }, __debugTypeToString: { value: function() {
                  var Ir = Er(), wr = Ir == null ? void 0 : Ir.get(this);
                  return wr === void 0 && (wr = this.checker.typeToString(this), Ir == null || Ir.set(this, wr)), wr;
                } } }), Object.defineProperties(e2.objectAllocator.getSignatureConstructor().prototype, { __debugFlags: { get: function() {
                  return ne(this.flags);
                } }, __debugSignatureToString: { value: function() {
                  var Ir;
                  return (Ir = this.checker) === null || Ir === void 0 ? void 0 : Ir.signatureToString(this);
                } } });
                for (var n = [e2.objectAllocator.getNodeConstructor(), e2.objectAllocator.getIdentifierConstructor(), e2.objectAllocator.getTokenConstructor(), e2.objectAllocator.getSourceFileConstructor()], lr = 0, be = n; lr < be.length; lr++) {
                  var Ge = be[lr];
                  Ge.prototype.hasOwnProperty("__debugKind") || Object.defineProperties(Ge.prototype, { __tsDebuggerDisplay: { value: function() {
                    var Ir = e2.isGeneratedIdentifier(this) ? "GeneratedIdentifier" : e2.isIdentifier(this) ? "Identifier '".concat(e2.idText(this), "'") : e2.isPrivateIdentifier(this) ? "PrivateIdentifier '".concat(e2.idText(this), "'") : e2.isStringLiteral(this) ? "StringLiteral ".concat(JSON.stringify(this.text.length < 10 ? this.text : this.text.slice(10) + "...")) : e2.isNumericLiteral(this) ? "NumericLiteral ".concat(this.text) : e2.isBigIntLiteral(this) ? "BigIntLiteral ".concat(this.text, "n") : e2.isTypeParameterDeclaration(this) ? "TypeParameterDeclaration" : e2.isParameter(this) ? "ParameterDeclaration" : e2.isConstructorDeclaration(this) ? "ConstructorDeclaration" : e2.isGetAccessorDeclaration(this) ? "GetAccessorDeclaration" : e2.isSetAccessorDeclaration(this) ? "SetAccessorDeclaration" : e2.isCallSignatureDeclaration(this) ? "CallSignatureDeclaration" : e2.isConstructSignatureDeclaration(this) ? "ConstructSignatureDeclaration" : e2.isIndexSignatureDeclaration(this) ? "IndexSignatureDeclaration" : e2.isTypePredicateNode(this) ? "TypePredicateNode" : e2.isTypeReferenceNode(this) ? "TypeReferenceNode" : e2.isFunctionTypeNode(this) ? "FunctionTypeNode" : e2.isConstructorTypeNode(this) ? "ConstructorTypeNode" : e2.isTypeQueryNode(this) ? "TypeQueryNode" : e2.isTypeLiteralNode(this) ? "TypeLiteralNode" : e2.isArrayTypeNode(this) ? "ArrayTypeNode" : e2.isTupleTypeNode(this) ? "TupleTypeNode" : e2.isOptionalTypeNode(this) ? "OptionalTypeNode" : e2.isRestTypeNode(this) ? "RestTypeNode" : e2.isUnionTypeNode(this) ? "UnionTypeNode" : e2.isIntersectionTypeNode(this) ? "IntersectionTypeNode" : e2.isConditionalTypeNode(this) ? "ConditionalTypeNode" : e2.isInferTypeNode(this) ? "InferTypeNode" : e2.isParenthesizedTypeNode(this) ? "ParenthesizedTypeNode" : e2.isThisTypeNode(this) ? "ThisTypeNode" : e2.isTypeOperatorNode(this) ? "TypeOperatorNode" : e2.isIndexedAccessTypeNode(this) ? "IndexedAccessTypeNode" : e2.isMappedTypeNode(this) ? "MappedTypeNode" : e2.isLiteralTypeNode(this) ? "LiteralTypeNode" : e2.isNamedTupleMember(this) ? "NamedTupleMember" : e2.isImportTypeNode(this) ? "ImportTypeNode" : j(this.kind);
                    return "".concat(Ir).concat(this.flags ? " (".concat(I(this.flags), ")") : "");
                  } }, __debugKind: { get: function() {
                    return j(this.kind);
                  } }, __debugNodeFlags: { get: function() {
                    return I(this.flags);
                  } }, __debugModifierFlags: { get: function() {
                    return l(e2.getEffectiveModifierFlagsNoCache(this));
                  } }, __debugTransformFlags: { get: function() {
                    return d(this.transformFlags);
                  } }, __debugIsParseTreeNode: { get: function() {
                    return e2.isParseTreeNode(this);
                  } }, __debugEmitFlags: { get: function() {
                    return D(e2.getEmitFlags(this));
                  } }, __debugGetText: { value: function(Ir) {
                    if (e2.nodeIsSynthesized(this))
                      return "";
                    var wr = Ne(), Ur = wr == null ? void 0 : wr.get(this);
                    if (Ur === void 0) {
                      var ii = e2.getParseTreeNode(this), mi = ii && e2.getSourceFileOfNode(ii);
                      Ur = mi ? e2.getSourceTextOfNodeFromSourceFile(mi, ii, Ir) : "", wr == null || wr.set(this, Ur);
                    }
                    return Ur;
                  } } });
                }
                try {
                  if (false)
                    var ur, yr;
                } catch {
                }
                Fe = true;
              }
              w.enableDebugInfo = we;
              function de(Ye, Br, Er, Ne, n) {
                var lr = Br ? "DeprecationError: " : "DeprecationWarning: ";
                return lr += "'".concat(Ye, "' "), lr += Ne ? "has been deprecated since v".concat(Ne) : "is deprecated", lr += Br ? " and can no longer be used." : Er ? " and will no longer be usable after v".concat(Er, ".") : ".", lr += n ? " ".concat(e2.formatStringFromArgs(n, [Ye], 0)) : "", lr;
              }
              function ye(Ye, Br, Er, Ne) {
                var n = de(Ye, true, Br, Er, Ne);
                return function() {
                  throw new TypeError(n);
                };
              }
              function Ae(Ye, Br, Er, Ne) {
                var n = false;
                return function() {
                  n || (p.warn(de(Ye, false, Br, Er, Ne)), n = true);
                };
              }
              function er(Ye, Br) {
                var Er, Ne;
                Br === void 0 && (Br = {});
                var n = typeof Br.typeScriptVersion == "string" ? new e2.Version(Br.typeScriptVersion) : (Er = Br.typeScriptVersion) !== null && Er !== void 0 ? Er : Q(), lr = typeof Br.errorAfter == "string" ? new e2.Version(Br.errorAfter) : Br.errorAfter, be = typeof Br.warnAfter == "string" ? new e2.Version(Br.warnAfter) : Br.warnAfter, Ge = typeof Br.since == "string" ? new e2.Version(Br.since) : (Ne = Br.since) !== null && Ne !== void 0 ? Ne : be, ur = Br.error || lr && n.compareTo(lr) <= 0, yr = !be || n.compareTo(be) >= 0;
                return ur ? ye(Ye, lr, Ge, Br.message) : yr ? Ae(Ye, lr, Ge, Br.message) : e2.noop;
              }
              function ir(Ye, Br) {
                return function() {
                  return Ye(), Br.apply(this, arguments);
                };
              }
              function Cr(Ye, Br) {
                var Er = er(P(Ye), Br);
                return ir(Er, Ye);
              }
              w.deprecate = Cr;
            })(C = e2.Debug || (e2.Debug = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = /^(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\.(0|[1-9]\d*)(?:\-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i, C = /^(?:0|[1-9]\d*|[a-z-][a-z0-9-]*)(?:\.(?:0|[1-9]\d*|[a-z-][a-z0-9-]*))*$/i, w = /^[a-z0-9-]+(?:\.[a-z0-9-]+)*$/i, B = /^(0|[1-9]\d*)$/, E = function() {
              function F2(x2, X, $, A2, y) {
                if (X === void 0 && (X = 0), $ === void 0 && ($ = 0), A2 === void 0 && (A2 = ""), y === void 0 && (y = ""), typeof x2 == "string") {
                  var V = e2.Debug.checkDefined(Q(x2), "Invalid version");
                  x2 = V.major, X = V.minor, $ = V.patch, A2 = V.prerelease, y = V.build;
                }
                e2.Debug.assert(x2 >= 0, "Invalid argument: major"), e2.Debug.assert(X >= 0, "Invalid argument: minor"), e2.Debug.assert($ >= 0, "Invalid argument: patch"), e2.Debug.assert(!A2 || C.test(A2), "Invalid argument: prerelease"), e2.Debug.assert(!y || w.test(y), "Invalid argument: build"), this.major = x2, this.minor = X, this.patch = $, this.prerelease = A2 ? A2.split(".") : e2.emptyArray, this.build = y ? y.split(".") : e2.emptyArray;
              }
              return F2.tryParse = function(x2) {
                var X = Q(x2);
                if (!!X) {
                  var $ = X.major, A2 = X.minor, y = X.patch, V = X.prerelease, L = X.build;
                  return new F2($, A2, y, V, L);
                }
              }, F2.prototype.compareTo = function(x2) {
                return this === x2 ? 0 : x2 === void 0 ? 1 : e2.compareValues(this.major, x2.major) || e2.compareValues(this.minor, x2.minor) || e2.compareValues(this.patch, x2.patch) || le(this.prerelease, x2.prerelease);
              }, F2.prototype.increment = function(x2) {
                switch (x2) {
                  case "major":
                    return new F2(this.major + 1, 0, 0);
                  case "minor":
                    return new F2(this.major, this.minor + 1, 0);
                  case "patch":
                    return new F2(this.major, this.minor, this.patch + 1);
                  default:
                    return e2.Debug.assertNever(x2);
                }
              }, F2.prototype.toString = function() {
                var x2 = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch);
                return e2.some(this.prerelease) && (x2 += "-".concat(this.prerelease.join("."))), e2.some(this.build) && (x2 += "+".concat(this.build.join("."))), x2;
              }, F2.zero = new F2(0, 0, 0), F2;
            }();
            e2.Version = E;
            function Q(F2) {
              var x2 = a.exec(F2);
              if (!!x2) {
                var X = x2[1], $ = x2[2], A2 = $ === void 0 ? "0" : $, y = x2[3], V = y === void 0 ? "0" : y, L = x2[4], P = L === void 0 ? "" : L, k = x2[5], Y = k === void 0 ? "" : k;
                if (!(P && !C.test(P)) && !(Y && !w.test(Y)))
                  return { major: parseInt(X, 10), minor: parseInt(A2, 10), patch: parseInt(V, 10), prerelease: P, build: Y };
              }
            }
            function le(F2, x2) {
              if (F2 === x2)
                return 0;
              if (F2.length === 0)
                return x2.length === 0 ? 0 : 1;
              if (x2.length === 0)
                return -1;
              for (var X = Math.min(F2.length, x2.length), $ = 0; $ < X; $++) {
                var A2 = F2[$], y = x2[$];
                if (A2 !== y) {
                  var V = B.test(A2), L = B.test(y);
                  if (V || L) {
                    if (V !== L)
                      return V ? -1 : 1;
                    var P = e2.compareValues(+A2, +y);
                    if (P)
                      return P;
                  } else {
                    var P = e2.compareStringsCaseSensitive(A2, y);
                    if (P)
                      return P;
                  }
                }
              }
              return e2.compareValues(F2.length, x2.length);
            }
            var N = function() {
              function F2(x2) {
                this._alternatives = x2 ? e2.Debug.checkDefined(T(x2), "Invalid range spec.") : e2.emptyArray;
              }
              return F2.tryParse = function(x2) {
                var X = T(x2);
                if (X) {
                  var $ = new F2("");
                  return $._alternatives = X, $;
                }
              }, F2.prototype.test = function(x2) {
                return typeof x2 == "string" && (x2 = new E(x2)), R(x2, this._alternatives);
              }, F2.prototype.toString = function() {
                return ve(this._alternatives);
              }, F2;
            }();
            e2.VersionRange = N;
            var p = /\|\|/g, m2 = /\s+/g, G = /^([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:\.([xX*0]|[1-9]\d*)(?:-([a-z0-9-.]+))?(?:\+([a-z0-9-.]+))?)?)?$/i, oe = /^\s*([a-z0-9-+.*]+)\s+-\s+([a-z0-9-+.*]+)\s*$/i, f4 = /^(~|\^|<|<=|>|>=|=)?\s*([a-z0-9-+.*]+)$/i;
            function T(F2) {
              for (var x2 = [], X = 0, $ = e2.trimString(F2).split(p); X < $.length; X++) {
                var A2 = $[X];
                if (!!A2) {
                  var y = [];
                  A2 = e2.trimString(A2);
                  var V = oe.exec(A2);
                  if (V) {
                    if (!b(V[1], V[2], y))
                      return;
                  } else
                    for (var L = 0, P = A2.split(m2); L < P.length; L++) {
                      var k = P[L], Y = f4.exec(e2.trimString(k));
                      if (!Y || !se(Y[1], Y[2], y))
                        return;
                    }
                  x2.push(y);
                }
              }
              return x2;
            }
            function K(F2) {
              var x2 = G.exec(F2);
              if (!!x2) {
                var X = x2[1], $ = x2[2], A2 = $ === void 0 ? "*" : $, y = x2[3], V = y === void 0 ? "*" : y, L = x2[4], P = x2[5], k = new E(J(X) ? 0 : parseInt(X, 10), J(X) || J(A2) ? 0 : parseInt(A2, 10), J(X) || J(A2) || J(V) ? 0 : parseInt(V, 10), L, P);
                return { version: k, major: X, minor: A2, patch: V };
              }
            }
            function b(F2, x2, X) {
              var $ = K(F2);
              if (!$)
                return false;
              var A2 = K(x2);
              return A2 ? (J($.major) || X.push(ie(">=", $.version)), J(A2.major) || X.push(J(A2.minor) ? ie("<", A2.version.increment("major")) : J(A2.patch) ? ie("<", A2.version.increment("minor")) : ie("<=", A2.version)), true) : false;
            }
            function se(F2, x2, X) {
              var $ = K(x2);
              if (!$)
                return false;
              var A2 = $.version, y = $.major, V = $.minor, L = $.patch;
              if (J(y))
                (F2 === "<" || F2 === ">") && X.push(ie("<", E.zero));
              else
                switch (F2) {
                  case "~":
                    X.push(ie(">=", A2)), X.push(ie("<", A2.increment(J(V) ? "major" : "minor")));
                    break;
                  case "^":
                    X.push(ie(">=", A2)), X.push(ie("<", A2.increment(A2.major > 0 || J(V) ? "major" : A2.minor > 0 || J(L) ? "minor" : "patch")));
                    break;
                  case "<":
                  case ">=":
                    X.push(ie(F2, A2));
                    break;
                  case "<=":
                  case ">":
                    X.push(J(V) ? ie(F2 === "<=" ? "<" : ">=", A2.increment("major")) : J(L) ? ie(F2 === "<=" ? "<" : ">=", A2.increment("minor")) : ie(F2, A2));
                    break;
                  case "=":
                  case void 0:
                    J(V) || J(L) ? (X.push(ie(">=", A2)), X.push(ie("<", A2.increment(J(V) ? "major" : "minor")))) : X.push(ie("=", A2));
                    break;
                  default:
                    return false;
                }
              return true;
            }
            function J(F2) {
              return F2 === "*" || F2 === "x" || F2 === "X";
            }
            function ie(F2, x2) {
              return { operator: F2, operand: x2 };
            }
            function R(F2, x2) {
              if (x2.length === 0)
                return true;
              for (var X = 0, $ = x2; X < $.length; X++) {
                var A2 = $[X];
                if (q(F2, A2))
                  return true;
              }
              return false;
            }
            function q(F2, x2) {
              for (var X = 0, $ = x2; X < $.length; X++) {
                var A2 = $[X];
                if (!O(F2, A2.operator, A2.operand))
                  return false;
              }
              return true;
            }
            function O(F2, x2, X) {
              var $ = F2.compareTo(X);
              switch (x2) {
                case "<":
                  return $ < 0;
                case "<=":
                  return $ <= 0;
                case ">":
                  return $ > 0;
                case ">=":
                  return $ >= 0;
                case "=":
                  return $ === 0;
                default:
                  return e2.Debug.assertNever(x2);
              }
            }
            function ve(F2) {
              return e2.map(F2, ee).join(" || ") || "*";
            }
            function ee(F2) {
              return e2.map(F2, he).join(" ");
            }
            function he(F2) {
              return "".concat(F2.operator).concat(F2.operand);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(le, N) {
              return typeof le == "object" && typeof le.timeOrigin == "number" && typeof le.mark == "function" && typeof le.measure == "function" && typeof le.now == "function" && typeof N == "function";
            }
            function C() {
              if (typeof performance == "object" && typeof PerformanceObserver == "function" && a(performance, PerformanceObserver))
                return { shouldWriteNativeEvents: true, performance, PerformanceObserver };
            }
            function w() {
            }
            var B = C() || void 0, E = B == null ? void 0 : B.performance;
            function Q() {
              return B;
            }
            e2.tryGetNativePerformanceHooks = Q, e2.timestamp = E ? function() {
              return E.now();
            } : Date.now ? Date.now : function() {
              return +new Date();
            };
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w, B;
              function E(R, q, O, ve) {
                return R ? Q(q, O, ve) : C.nullTimer;
              }
              C.createTimerIf = E;
              function Q(R, q, O) {
                var ve = 0;
                return { enter: ee, exit: he };
                function ee() {
                  ++ve === 1 && oe(q);
                }
                function he() {
                  --ve === 0 ? (oe(O), f4(R, q, O)) : ve < 0 && e2.Debug.fail("enter/exit count does not match.");
                }
              }
              C.createTimer = Q, C.nullTimer = { enter: e2.noop, exit: e2.noop };
              var le = false, N = e2.timestamp(), p = new e2.Map(), m2 = new e2.Map(), G = new e2.Map();
              function oe(R) {
                var q;
                if (le) {
                  var O = (q = m2.get(R)) !== null && q !== void 0 ? q : 0;
                  m2.set(R, O + 1), p.set(R, e2.timestamp()), B == null || B.mark(R);
                }
              }
              C.mark = oe;
              function f4(R, q, O) {
                var ve, ee;
                if (le) {
                  var he = (ve = O !== void 0 ? p.get(O) : void 0) !== null && ve !== void 0 ? ve : e2.timestamp(), F2 = (ee = q !== void 0 ? p.get(q) : void 0) !== null && ee !== void 0 ? ee : N, x2 = G.get(R) || 0;
                  G.set(R, x2 + (he - F2)), B == null || B.measure(R, q, O);
                }
              }
              C.measure = f4;
              function T(R) {
                return m2.get(R) || 0;
              }
              C.getCount = T;
              function K(R) {
                return G.get(R) || 0;
              }
              C.getDuration = K;
              function b(R) {
                G.forEach(function(q, O) {
                  return R(O, q);
                });
              }
              C.forEachMeasure = b;
              function se() {
                return le;
              }
              C.isEnabled = se;
              function J(R) {
                var q;
                return R === void 0 && (R = e2.sys), le || (le = true, w || (w = e2.tryGetNativePerformanceHooks()), w && (N = w.performance.timeOrigin, (w.shouldWriteNativeEvents || ((q = R == null ? void 0 : R.cpuProfilingEnabled) === null || q === void 0 ? void 0 : q.call(R)) || (R == null ? void 0 : R.debugMode)) && (B = w.performance))), true;
              }
              C.enable = J;
              function ie() {
                le && (p.clear(), m2.clear(), G.clear(), B = void 0, le = false);
              }
              C.disable = ie;
            })(a = e2.performance || (e2.performance = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a, C = { logEvent: e2.noop, logErrEvent: e2.noop, logPerfEvent: e2.noop, logInfoEvent: e2.noop, logStartCommand: e2.noop, logStopCommand: e2.noop, logStartUpdateProgram: e2.noop, logStopUpdateProgram: e2.noop, logStartUpdateGraph: e2.noop, logStopUpdateGraph: e2.noop, logStartResolveModule: e2.noop, logStopResolveModule: e2.noop, logStartParseSourceFile: e2.noop, logStopParseSourceFile: e2.noop, logStartReadFile: e2.noop, logStopReadFile: e2.noop, logStartBindFile: e2.noop, logStopBindFile: e2.noop, logStartScheduledOperation: e2.noop, logStopScheduledOperation: e2.noop }, w;
            try {
              var B = (a = Eu.env.TS_ETW_MODULE_PATH) !== null && a !== void 0 ? a : "./node_modules/@microsoft/typescript-etw";
              w = void 0;
            } catch {
              w = void 0;
            }
            e2.perfLogger = w && w.logEvent ? w : C;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w, B = 0, E = 0, Q, le = [], N, p = [];
              function m2(he, F2, x2) {
                if (e2.Debug.assert(!e2.tracing, "Tracing already started"), w === void 0)
                  try {
                    w = ex();
                  } catch (V) {
                    throw new Error(`tracing requires having fs
(original error: `.concat(V.message || V, ")"));
                  }
                Q = he, le.length = 0, N === void 0 && (N = e2.combinePaths(F2, "legend.json")), w.existsSync(F2) || w.mkdirSync(F2, { recursive: true });
                var X = Q === "build" ? ".".concat(Eu.pid, "-").concat(++B) : Q === "server" ? ".".concat(Eu.pid) : "", $ = e2.combinePaths(F2, "trace".concat(X, ".json")), A2 = e2.combinePaths(F2, "types".concat(X, ".json"));
                p.push({ configFilePath: x2, tracePath: $, typesPath: A2 }), E = w.openSync($, "w"), e2.tracing = C;
                var y = { cat: "__metadata", ph: "M", ts: 1e3 * e2.timestamp(), pid: 1, tid: 1 };
                w.writeSync(E, `[
` + [Ke({ name: "process_name", args: { name: "tsc" } }, y), Ke({ name: "thread_name", args: { name: "Main" } }, y), Ke(Ke({ name: "TracingStartedInBrowser" }, y), { cat: "disabled-by-default-devtools.timeline" })].map(function(V) {
                  return JSON.stringify(V);
                }).join(`,
`));
              }
              C.startTracing = m2;
              function G() {
                e2.Debug.assert(e2.tracing, "Tracing is not in progress"), e2.Debug.assert(!!le.length == (Q !== "server")), w.writeSync(E, `
]
`), w.closeSync(E), e2.tracing = void 0, le.length ? ve(le) : p[p.length - 1].typesPath = void 0;
              }
              C.stopTracing = G;
              function oe(he) {
                Q !== "server" && le.push(he);
              }
              C.recordType = oe;
              var f4;
              (function(he) {
                he.Parse = "parse", he.Program = "program", he.Bind = "bind", he.Check = "check", he.CheckTypes = "checkTypes", he.Emit = "emit", he.Session = "session";
              })(f4 = C.Phase || (C.Phase = {}));
              function T(he, F2, x2) {
                q("I", he, F2, x2, '"s":"g"');
              }
              C.instant = T;
              var K = [];
              function b(he, F2, x2, X) {
                X === void 0 && (X = false), X && q("B", he, F2, x2), K.push({ phase: he, name: F2, args: x2, time: 1e3 * e2.timestamp(), separateBeginAndEnd: X });
              }
              C.push = b;
              function se() {
                e2.Debug.assert(K.length > 0), R(K.length - 1, 1e3 * e2.timestamp()), K.length--;
              }
              C.pop = se;
              function J() {
                for (var he = 1e3 * e2.timestamp(), F2 = K.length - 1; F2 >= 0; F2--)
                  R(F2, he);
                K.length = 0;
              }
              C.popAll = J;
              var ie = 1e3 * 10;
              function R(he, F2) {
                var x2 = K[he], X = x2.phase, $ = x2.name, A2 = x2.args, y = x2.time, V = x2.separateBeginAndEnd;
                V ? q("E", X, $, A2, void 0, F2) : ie - y % ie <= F2 - y && q("X", X, $, A2, '"dur":'.concat(F2 - y), y);
              }
              function q(he, F2, x2, X, $, A2) {
                A2 === void 0 && (A2 = 1e3 * e2.timestamp()), !(Q === "server" && F2 === "checkTypes") && (e2.performance.mark("beginTracing"), w.writeSync(E, `,
{"pid":1,"tid":1,"ph":"`.concat(he, '","cat":"').concat(F2, '","ts":').concat(A2, ',"name":"').concat(x2, '"')), $ && w.writeSync(E, ",".concat($)), X && w.writeSync(E, ',"args":'.concat(JSON.stringify(X))), w.writeSync(E, "}"), e2.performance.mark("endTracing"), e2.performance.measure("Tracing", "beginTracing", "endTracing"));
              }
              function O(he) {
                var F2 = e2.getSourceFileOfNode(he);
                return F2 ? { path: F2.path, start: x2(e2.getLineAndCharacterOfPosition(F2, he.pos)), end: x2(e2.getLineAndCharacterOfPosition(F2, he.end)) } : void 0;
                function x2(X) {
                  return { line: X.line + 1, character: X.character + 1 };
                }
              }
              function ve(he) {
                var F2, x2, X, $, A2, y, V, L, P, k, Y, U, j, H, I, l, d, D, fe, g, ne, ue;
                e2.performance.mark("beginDumpTypes");
                var We = p[p.length - 1].typesPath, Fe = w.openSync(We, "w"), Z2 = new e2.Map();
                w.writeSync(Fe, "[");
                for (var Be = he.length, ge = 0; ge < Be; ge++) {
                  var Re = he[ge], ze = Re.objectFlags, Ee = (F2 = Re.aliasSymbol) !== null && F2 !== void 0 ? F2 : Re.symbol, He = void 0;
                  if (ze & 16 | Re.flags & 2944)
                    try {
                      He = (x2 = Re.checker) === null || x2 === void 0 ? void 0 : x2.typeToString(Re);
                    } catch {
                      He = void 0;
                    }
                  var rr = {};
                  if (Re.flags & 8388608) {
                    var Ie = Re;
                    rr = { indexedAccessObjectType: (X = Ie.objectType) === null || X === void 0 ? void 0 : X.id, indexedAccessIndexType: ($ = Ie.indexType) === null || $ === void 0 ? void 0 : $.id };
                  }
                  var _e = {};
                  if (ze & 4) {
                    var we = Re;
                    _e = { instantiatedType: (A2 = we.target) === null || A2 === void 0 ? void 0 : A2.id, typeArguments: (y = we.resolvedTypeArguments) === null || y === void 0 ? void 0 : y.map(function(lr) {
                      return lr.id;
                    }), referenceLocation: O(we.node) };
                  }
                  var de = {};
                  if (Re.flags & 16777216) {
                    var ye = Re;
                    de = { conditionalCheckType: (V = ye.checkType) === null || V === void 0 ? void 0 : V.id, conditionalExtendsType: (L = ye.extendsType) === null || L === void 0 ? void 0 : L.id, conditionalTrueType: (k = (P = ye.resolvedTrueType) === null || P === void 0 ? void 0 : P.id) !== null && k !== void 0 ? k : -1, conditionalFalseType: (U = (Y = ye.resolvedFalseType) === null || Y === void 0 ? void 0 : Y.id) !== null && U !== void 0 ? U : -1 };
                  }
                  var Ae = {};
                  if (Re.flags & 33554432) {
                    var er = Re;
                    Ae = { substitutionBaseType: (j = er.baseType) === null || j === void 0 ? void 0 : j.id, substituteType: (H = er.substitute) === null || H === void 0 ? void 0 : H.id };
                  }
                  var ir = {};
                  if (ze & 1024) {
                    var Cr = Re;
                    ir = { reverseMappedSourceType: (I = Cr.source) === null || I === void 0 ? void 0 : I.id, reverseMappedMappedType: (l = Cr.mappedType) === null || l === void 0 ? void 0 : l.id, reverseMappedConstraintType: (d = Cr.constraintType) === null || d === void 0 ? void 0 : d.id };
                  }
                  var Ye = {};
                  if (ze & 256) {
                    var Br = Re;
                    Ye = { evolvingArrayElementType: Br.elementType.id, evolvingArrayFinalType: (D = Br.finalArrayType) === null || D === void 0 ? void 0 : D.id };
                  }
                  var Er = void 0, Ne = Re.checker.getRecursionIdentity(Re);
                  Ne && (Er = Z2.get(Ne), Er || (Er = Z2.size, Z2.set(Ne, Er)));
                  var n = Ke(Ke(Ke(Ke(Ke(Ke(Ke({ id: Re.id, intrinsicName: Re.intrinsicName, symbolName: (Ee == null ? void 0 : Ee.escapedName) && e2.unescapeLeadingUnderscores(Ee.escapedName), recursionId: Er, isTuple: ze & 8 ? true : void 0, unionTypes: Re.flags & 1048576 ? (fe = Re.types) === null || fe === void 0 ? void 0 : fe.map(function(lr) {
                    return lr.id;
                  }) : void 0, intersectionTypes: Re.flags & 2097152 ? Re.types.map(function(lr) {
                    return lr.id;
                  }) : void 0, aliasTypeArguments: (g = Re.aliasTypeArguments) === null || g === void 0 ? void 0 : g.map(function(lr) {
                    return lr.id;
                  }), keyofType: Re.flags & 4194304 ? (ne = Re.type) === null || ne === void 0 ? void 0 : ne.id : void 0 }, rr), _e), de), Ae), ir), Ye), { destructuringPattern: O(Re.pattern), firstDeclaration: O((ue = Ee == null ? void 0 : Ee.declarations) === null || ue === void 0 ? void 0 : ue[0]), flags: e2.Debug.formatTypeFlags(Re.flags).split("|"), display: He });
                  w.writeSync(Fe, JSON.stringify(n)), ge < Be - 1 && w.writeSync(Fe, `,
`);
                }
                w.writeSync(Fe, `]
`), w.closeSync(Fe), e2.performance.mark("endDumpTypes"), e2.performance.measure("Dump types", "beginDumpTypes", "endDumpTypes");
              }
              function ee() {
                !N || w.writeFileSync(N, JSON.stringify(p));
              }
              C.dumpLegend = ee;
            })(a || (a = {})), e2.startTracing = a.startTracing, e2.dumpTracingLegend = a.dumpLegend;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(n) {
              n[n.Unknown = 0] = "Unknown", n[n.EndOfFileToken = 1] = "EndOfFileToken", n[n.SingleLineCommentTrivia = 2] = "SingleLineCommentTrivia", n[n.MultiLineCommentTrivia = 3] = "MultiLineCommentTrivia", n[n.NewLineTrivia = 4] = "NewLineTrivia", n[n.WhitespaceTrivia = 5] = "WhitespaceTrivia", n[n.ShebangTrivia = 6] = "ShebangTrivia", n[n.ConflictMarkerTrivia = 7] = "ConflictMarkerTrivia", n[n.NumericLiteral = 8] = "NumericLiteral", n[n.BigIntLiteral = 9] = "BigIntLiteral", n[n.StringLiteral = 10] = "StringLiteral", n[n.JsxText = 11] = "JsxText", n[n.JsxTextAllWhiteSpaces = 12] = "JsxTextAllWhiteSpaces", n[n.RegularExpressionLiteral = 13] = "RegularExpressionLiteral", n[n.NoSubstitutionTemplateLiteral = 14] = "NoSubstitutionTemplateLiteral", n[n.TemplateHead = 15] = "TemplateHead", n[n.TemplateMiddle = 16] = "TemplateMiddle", n[n.TemplateTail = 17] = "TemplateTail", n[n.OpenBraceToken = 18] = "OpenBraceToken", n[n.CloseBraceToken = 19] = "CloseBraceToken", n[n.OpenParenToken = 20] = "OpenParenToken", n[n.CloseParenToken = 21] = "CloseParenToken", n[n.OpenBracketToken = 22] = "OpenBracketToken", n[n.CloseBracketToken = 23] = "CloseBracketToken", n[n.DotToken = 24] = "DotToken", n[n.DotDotDotToken = 25] = "DotDotDotToken", n[n.SemicolonToken = 26] = "SemicolonToken", n[n.CommaToken = 27] = "CommaToken", n[n.QuestionDotToken = 28] = "QuestionDotToken", n[n.LessThanToken = 29] = "LessThanToken", n[n.LessThanSlashToken = 30] = "LessThanSlashToken", n[n.GreaterThanToken = 31] = "GreaterThanToken", n[n.LessThanEqualsToken = 32] = "LessThanEqualsToken", n[n.GreaterThanEqualsToken = 33] = "GreaterThanEqualsToken", n[n.EqualsEqualsToken = 34] = "EqualsEqualsToken", n[n.ExclamationEqualsToken = 35] = "ExclamationEqualsToken", n[n.EqualsEqualsEqualsToken = 36] = "EqualsEqualsEqualsToken", n[n.ExclamationEqualsEqualsToken = 37] = "ExclamationEqualsEqualsToken", n[n.EqualsGreaterThanToken = 38] = "EqualsGreaterThanToken", n[n.PlusToken = 39] = "PlusToken", n[n.MinusToken = 40] = "MinusToken", n[n.AsteriskToken = 41] = "AsteriskToken", n[n.AsteriskAsteriskToken = 42] = "AsteriskAsteriskToken", n[n.SlashToken = 43] = "SlashToken", n[n.PercentToken = 44] = "PercentToken", n[n.PlusPlusToken = 45] = "PlusPlusToken", n[n.MinusMinusToken = 46] = "MinusMinusToken", n[n.LessThanLessThanToken = 47] = "LessThanLessThanToken", n[n.GreaterThanGreaterThanToken = 48] = "GreaterThanGreaterThanToken", n[n.GreaterThanGreaterThanGreaterThanToken = 49] = "GreaterThanGreaterThanGreaterThanToken", n[n.AmpersandToken = 50] = "AmpersandToken", n[n.BarToken = 51] = "BarToken", n[n.CaretToken = 52] = "CaretToken", n[n.ExclamationToken = 53] = "ExclamationToken", n[n.TildeToken = 54] = "TildeToken", n[n.AmpersandAmpersandToken = 55] = "AmpersandAmpersandToken", n[n.BarBarToken = 56] = "BarBarToken", n[n.QuestionToken = 57] = "QuestionToken", n[n.ColonToken = 58] = "ColonToken", n[n.AtToken = 59] = "AtToken", n[n.QuestionQuestionToken = 60] = "QuestionQuestionToken", n[n.BacktickToken = 61] = "BacktickToken", n[n.HashToken = 62] = "HashToken", n[n.EqualsToken = 63] = "EqualsToken", n[n.PlusEqualsToken = 64] = "PlusEqualsToken", n[n.MinusEqualsToken = 65] = "MinusEqualsToken", n[n.AsteriskEqualsToken = 66] = "AsteriskEqualsToken", n[n.AsteriskAsteriskEqualsToken = 67] = "AsteriskAsteriskEqualsToken", n[n.SlashEqualsToken = 68] = "SlashEqualsToken", n[n.PercentEqualsToken = 69] = "PercentEqualsToken", n[n.LessThanLessThanEqualsToken = 70] = "LessThanLessThanEqualsToken", n[n.GreaterThanGreaterThanEqualsToken = 71] = "GreaterThanGreaterThanEqualsToken", n[n.GreaterThanGreaterThanGreaterThanEqualsToken = 72] = "GreaterThanGreaterThanGreaterThanEqualsToken", n[n.AmpersandEqualsToken = 73] = "AmpersandEqualsToken", n[n.BarEqualsToken = 74] = "BarEqualsToken", n[n.BarBarEqualsToken = 75] = "BarBarEqualsToken", n[n.AmpersandAmpersandEqualsToken = 76] = "AmpersandAmpersandEqualsToken", n[n.QuestionQuestionEqualsToken = 77] = "QuestionQuestionEqualsToken", n[n.CaretEqualsToken = 78] = "CaretEqualsToken", n[n.Identifier = 79] = "Identifier", n[n.PrivateIdentifier = 80] = "PrivateIdentifier", n[n.BreakKeyword = 81] = "BreakKeyword", n[n.CaseKeyword = 82] = "CaseKeyword", n[n.CatchKeyword = 83] = "CatchKeyword", n[n.ClassKeyword = 84] = "ClassKeyword", n[n.ConstKeyword = 85] = "ConstKeyword", n[n.ContinueKeyword = 86] = "ContinueKeyword", n[n.DebuggerKeyword = 87] = "DebuggerKeyword", n[n.DefaultKeyword = 88] = "DefaultKeyword", n[n.DeleteKeyword = 89] = "DeleteKeyword", n[n.DoKeyword = 90] = "DoKeyword", n[n.ElseKeyword = 91] = "ElseKeyword", n[n.EnumKeyword = 92] = "EnumKeyword", n[n.ExportKeyword = 93] = "ExportKeyword", n[n.ExtendsKeyword = 94] = "ExtendsKeyword", n[n.FalseKeyword = 95] = "FalseKeyword", n[n.FinallyKeyword = 96] = "FinallyKeyword", n[n.ForKeyword = 97] = "ForKeyword", n[n.FunctionKeyword = 98] = "FunctionKeyword", n[n.IfKeyword = 99] = "IfKeyword", n[n.ImportKeyword = 100] = "ImportKeyword", n[n.InKeyword = 101] = "InKeyword", n[n.InstanceOfKeyword = 102] = "InstanceOfKeyword", n[n.NewKeyword = 103] = "NewKeyword", n[n.NullKeyword = 104] = "NullKeyword", n[n.ReturnKeyword = 105] = "ReturnKeyword", n[n.SuperKeyword = 106] = "SuperKeyword", n[n.SwitchKeyword = 107] = "SwitchKeyword", n[n.ThisKeyword = 108] = "ThisKeyword", n[n.ThrowKeyword = 109] = "ThrowKeyword", n[n.TrueKeyword = 110] = "TrueKeyword", n[n.TryKeyword = 111] = "TryKeyword", n[n.TypeOfKeyword = 112] = "TypeOfKeyword", n[n.VarKeyword = 113] = "VarKeyword", n[n.VoidKeyword = 114] = "VoidKeyword", n[n.WhileKeyword = 115] = "WhileKeyword", n[n.WithKeyword = 116] = "WithKeyword", n[n.ImplementsKeyword = 117] = "ImplementsKeyword", n[n.InterfaceKeyword = 118] = "InterfaceKeyword", n[n.LetKeyword = 119] = "LetKeyword", n[n.PackageKeyword = 120] = "PackageKeyword", n[n.PrivateKeyword = 121] = "PrivateKeyword", n[n.ProtectedKeyword = 122] = "ProtectedKeyword", n[n.PublicKeyword = 123] = "PublicKeyword", n[n.StaticKeyword = 124] = "StaticKeyword", n[n.YieldKeyword = 125] = "YieldKeyword", n[n.AbstractKeyword = 126] = "AbstractKeyword", n[n.AsKeyword = 127] = "AsKeyword", n[n.AssertsKeyword = 128] = "AssertsKeyword", n[n.AssertKeyword = 129] = "AssertKeyword", n[n.AnyKeyword = 130] = "AnyKeyword", n[n.AsyncKeyword = 131] = "AsyncKeyword", n[n.AwaitKeyword = 132] = "AwaitKeyword", n[n.BooleanKeyword = 133] = "BooleanKeyword", n[n.ConstructorKeyword = 134] = "ConstructorKeyword", n[n.DeclareKeyword = 135] = "DeclareKeyword", n[n.GetKeyword = 136] = "GetKeyword", n[n.InferKeyword = 137] = "InferKeyword", n[n.IntrinsicKeyword = 138] = "IntrinsicKeyword", n[n.IsKeyword = 139] = "IsKeyword", n[n.KeyOfKeyword = 140] = "KeyOfKeyword", n[n.ModuleKeyword = 141] = "ModuleKeyword", n[n.NamespaceKeyword = 142] = "NamespaceKeyword", n[n.NeverKeyword = 143] = "NeverKeyword", n[n.OutKeyword = 144] = "OutKeyword", n[n.ReadonlyKeyword = 145] = "ReadonlyKeyword", n[n.RequireKeyword = 146] = "RequireKeyword", n[n.NumberKeyword = 147] = "NumberKeyword", n[n.ObjectKeyword = 148] = "ObjectKeyword", n[n.SetKeyword = 149] = "SetKeyword", n[n.StringKeyword = 150] = "StringKeyword", n[n.SymbolKeyword = 151] = "SymbolKeyword", n[n.TypeKeyword = 152] = "TypeKeyword", n[n.UndefinedKeyword = 153] = "UndefinedKeyword", n[n.UniqueKeyword = 154] = "UniqueKeyword", n[n.UnknownKeyword = 155] = "UnknownKeyword", n[n.FromKeyword = 156] = "FromKeyword", n[n.GlobalKeyword = 157] = "GlobalKeyword", n[n.BigIntKeyword = 158] = "BigIntKeyword", n[n.OverrideKeyword = 159] = "OverrideKeyword", n[n.OfKeyword = 160] = "OfKeyword", n[n.QualifiedName = 161] = "QualifiedName", n[n.ComputedPropertyName = 162] = "ComputedPropertyName", n[n.TypeParameter = 163] = "TypeParameter", n[n.Parameter = 164] = "Parameter", n[n.Decorator = 165] = "Decorator", n[n.PropertySignature = 166] = "PropertySignature", n[n.PropertyDeclaration = 167] = "PropertyDeclaration", n[n.MethodSignature = 168] = "MethodSignature", n[n.MethodDeclaration = 169] = "MethodDeclaration", n[n.ClassStaticBlockDeclaration = 170] = "ClassStaticBlockDeclaration", n[n.Constructor = 171] = "Constructor", n[n.GetAccessor = 172] = "GetAccessor", n[n.SetAccessor = 173] = "SetAccessor", n[n.CallSignature = 174] = "CallSignature", n[n.ConstructSignature = 175] = "ConstructSignature", n[n.IndexSignature = 176] = "IndexSignature", n[n.TypePredicate = 177] = "TypePredicate", n[n.TypeReference = 178] = "TypeReference", n[n.FunctionType = 179] = "FunctionType", n[n.ConstructorType = 180] = "ConstructorType", n[n.TypeQuery = 181] = "TypeQuery", n[n.TypeLiteral = 182] = "TypeLiteral", n[n.ArrayType = 183] = "ArrayType", n[n.TupleType = 184] = "TupleType", n[n.OptionalType = 185] = "OptionalType", n[n.RestType = 186] = "RestType", n[n.UnionType = 187] = "UnionType", n[n.IntersectionType = 188] = "IntersectionType", n[n.ConditionalType = 189] = "ConditionalType", n[n.InferType = 190] = "InferType", n[n.ParenthesizedType = 191] = "ParenthesizedType", n[n.ThisType = 192] = "ThisType", n[n.TypeOperator = 193] = "TypeOperator", n[n.IndexedAccessType = 194] = "IndexedAccessType", n[n.MappedType = 195] = "MappedType", n[n.LiteralType = 196] = "LiteralType", n[n.NamedTupleMember = 197] = "NamedTupleMember", n[n.TemplateLiteralType = 198] = "TemplateLiteralType", n[n.TemplateLiteralTypeSpan = 199] = "TemplateLiteralTypeSpan", n[n.ImportType = 200] = "ImportType", n[n.ObjectBindingPattern = 201] = "ObjectBindingPattern", n[n.ArrayBindingPattern = 202] = "ArrayBindingPattern", n[n.BindingElement = 203] = "BindingElement", n[n.ArrayLiteralExpression = 204] = "ArrayLiteralExpression", n[n.ObjectLiteralExpression = 205] = "ObjectLiteralExpression", n[n.PropertyAccessExpression = 206] = "PropertyAccessExpression", n[n.ElementAccessExpression = 207] = "ElementAccessExpression", n[n.CallExpression = 208] = "CallExpression", n[n.NewExpression = 209] = "NewExpression", n[n.TaggedTemplateExpression = 210] = "TaggedTemplateExpression", n[n.TypeAssertionExpression = 211] = "TypeAssertionExpression", n[n.ParenthesizedExpression = 212] = "ParenthesizedExpression", n[n.FunctionExpression = 213] = "FunctionExpression", n[n.ArrowFunction = 214] = "ArrowFunction", n[n.DeleteExpression = 215] = "DeleteExpression", n[n.TypeOfExpression = 216] = "TypeOfExpression", n[n.VoidExpression = 217] = "VoidExpression", n[n.AwaitExpression = 218] = "AwaitExpression", n[n.PrefixUnaryExpression = 219] = "PrefixUnaryExpression", n[n.PostfixUnaryExpression = 220] = "PostfixUnaryExpression", n[n.BinaryExpression = 221] = "BinaryExpression", n[n.ConditionalExpression = 222] = "ConditionalExpression", n[n.TemplateExpression = 223] = "TemplateExpression", n[n.YieldExpression = 224] = "YieldExpression", n[n.SpreadElement = 225] = "SpreadElement", n[n.ClassExpression = 226] = "ClassExpression", n[n.OmittedExpression = 227] = "OmittedExpression", n[n.ExpressionWithTypeArguments = 228] = "ExpressionWithTypeArguments", n[n.AsExpression = 229] = "AsExpression", n[n.NonNullExpression = 230] = "NonNullExpression", n[n.MetaProperty = 231] = "MetaProperty", n[n.SyntheticExpression = 232] = "SyntheticExpression", n[n.TemplateSpan = 233] = "TemplateSpan", n[n.SemicolonClassElement = 234] = "SemicolonClassElement", n[n.Block = 235] = "Block", n[n.EmptyStatement = 236] = "EmptyStatement", n[n.VariableStatement = 237] = "VariableStatement", n[n.ExpressionStatement = 238] = "ExpressionStatement", n[n.IfStatement = 239] = "IfStatement", n[n.DoStatement = 240] = "DoStatement", n[n.WhileStatement = 241] = "WhileStatement", n[n.ForStatement = 242] = "ForStatement", n[n.ForInStatement = 243] = "ForInStatement", n[n.ForOfStatement = 244] = "ForOfStatement", n[n.ContinueStatement = 245] = "ContinueStatement", n[n.BreakStatement = 246] = "BreakStatement", n[n.ReturnStatement = 247] = "ReturnStatement", n[n.WithStatement = 248] = "WithStatement", n[n.SwitchStatement = 249] = "SwitchStatement", n[n.LabeledStatement = 250] = "LabeledStatement", n[n.ThrowStatement = 251] = "ThrowStatement", n[n.TryStatement = 252] = "TryStatement", n[n.DebuggerStatement = 253] = "DebuggerStatement", n[n.VariableDeclaration = 254] = "VariableDeclaration", n[n.VariableDeclarationList = 255] = "VariableDeclarationList", n[n.FunctionDeclaration = 256] = "FunctionDeclaration", n[n.ClassDeclaration = 257] = "ClassDeclaration", n[n.InterfaceDeclaration = 258] = "InterfaceDeclaration", n[n.TypeAliasDeclaration = 259] = "TypeAliasDeclaration", n[n.EnumDeclaration = 260] = "EnumDeclaration", n[n.ModuleDeclaration = 261] = "ModuleDeclaration", n[n.ModuleBlock = 262] = "ModuleBlock", n[n.CaseBlock = 263] = "CaseBlock", n[n.NamespaceExportDeclaration = 264] = "NamespaceExportDeclaration", n[n.ImportEqualsDeclaration = 265] = "ImportEqualsDeclaration", n[n.ImportDeclaration = 266] = "ImportDeclaration", n[n.ImportClause = 267] = "ImportClause", n[n.NamespaceImport = 268] = "NamespaceImport", n[n.NamedImports = 269] = "NamedImports", n[n.ImportSpecifier = 270] = "ImportSpecifier", n[n.ExportAssignment = 271] = "ExportAssignment", n[n.ExportDeclaration = 272] = "ExportDeclaration", n[n.NamedExports = 273] = "NamedExports", n[n.NamespaceExport = 274] = "NamespaceExport", n[n.ExportSpecifier = 275] = "ExportSpecifier", n[n.MissingDeclaration = 276] = "MissingDeclaration", n[n.ExternalModuleReference = 277] = "ExternalModuleReference", n[n.JsxElement = 278] = "JsxElement", n[n.JsxSelfClosingElement = 279] = "JsxSelfClosingElement", n[n.JsxOpeningElement = 280] = "JsxOpeningElement", n[n.JsxClosingElement = 281] = "JsxClosingElement", n[n.JsxFragment = 282] = "JsxFragment", n[n.JsxOpeningFragment = 283] = "JsxOpeningFragment", n[n.JsxClosingFragment = 284] = "JsxClosingFragment", n[n.JsxAttribute = 285] = "JsxAttribute", n[n.JsxAttributes = 286] = "JsxAttributes", n[n.JsxSpreadAttribute = 287] = "JsxSpreadAttribute", n[n.JsxExpression = 288] = "JsxExpression", n[n.CaseClause = 289] = "CaseClause", n[n.DefaultClause = 290] = "DefaultClause", n[n.HeritageClause = 291] = "HeritageClause", n[n.CatchClause = 292] = "CatchClause", n[n.AssertClause = 293] = "AssertClause", n[n.AssertEntry = 294] = "AssertEntry", n[n.ImportTypeAssertionContainer = 295] = "ImportTypeAssertionContainer", n[n.PropertyAssignment = 296] = "PropertyAssignment", n[n.ShorthandPropertyAssignment = 297] = "ShorthandPropertyAssignment", n[n.SpreadAssignment = 298] = "SpreadAssignment", n[n.EnumMember = 299] = "EnumMember", n[n.UnparsedPrologue = 300] = "UnparsedPrologue", n[n.UnparsedPrepend = 301] = "UnparsedPrepend", n[n.UnparsedText = 302] = "UnparsedText", n[n.UnparsedInternalText = 303] = "UnparsedInternalText", n[n.UnparsedSyntheticReference = 304] = "UnparsedSyntheticReference", n[n.SourceFile = 305] = "SourceFile", n[n.Bundle = 306] = "Bundle", n[n.UnparsedSource = 307] = "UnparsedSource", n[n.InputFiles = 308] = "InputFiles", n[n.JSDocTypeExpression = 309] = "JSDocTypeExpression", n[n.JSDocNameReference = 310] = "JSDocNameReference", n[n.JSDocMemberName = 311] = "JSDocMemberName", n[n.JSDocAllType = 312] = "JSDocAllType", n[n.JSDocUnknownType = 313] = "JSDocUnknownType", n[n.JSDocNullableType = 314] = "JSDocNullableType", n[n.JSDocNonNullableType = 315] = "JSDocNonNullableType", n[n.JSDocOptionalType = 316] = "JSDocOptionalType", n[n.JSDocFunctionType = 317] = "JSDocFunctionType", n[n.JSDocVariadicType = 318] = "JSDocVariadicType", n[n.JSDocNamepathType = 319] = "JSDocNamepathType", n[n.JSDocComment = 320] = "JSDocComment", n[n.JSDocText = 321] = "JSDocText", n[n.JSDocTypeLiteral = 322] = "JSDocTypeLiteral", n[n.JSDocSignature = 323] = "JSDocSignature", n[n.JSDocLink = 324] = "JSDocLink", n[n.JSDocLinkCode = 325] = "JSDocLinkCode", n[n.JSDocLinkPlain = 326] = "JSDocLinkPlain", n[n.JSDocTag = 327] = "JSDocTag", n[n.JSDocAugmentsTag = 328] = "JSDocAugmentsTag", n[n.JSDocImplementsTag = 329] = "JSDocImplementsTag", n[n.JSDocAuthorTag = 330] = "JSDocAuthorTag", n[n.JSDocDeprecatedTag = 331] = "JSDocDeprecatedTag", n[n.JSDocClassTag = 332] = "JSDocClassTag", n[n.JSDocPublicTag = 333] = "JSDocPublicTag", n[n.JSDocPrivateTag = 334] = "JSDocPrivateTag", n[n.JSDocProtectedTag = 335] = "JSDocProtectedTag", n[n.JSDocReadonlyTag = 336] = "JSDocReadonlyTag", n[n.JSDocOverrideTag = 337] = "JSDocOverrideTag", n[n.JSDocCallbackTag = 338] = "JSDocCallbackTag", n[n.JSDocEnumTag = 339] = "JSDocEnumTag", n[n.JSDocParameterTag = 340] = "JSDocParameterTag", n[n.JSDocReturnTag = 341] = "JSDocReturnTag", n[n.JSDocThisTag = 342] = "JSDocThisTag", n[n.JSDocTypeTag = 343] = "JSDocTypeTag", n[n.JSDocTemplateTag = 344] = "JSDocTemplateTag", n[n.JSDocTypedefTag = 345] = "JSDocTypedefTag", n[n.JSDocSeeTag = 346] = "JSDocSeeTag", n[n.JSDocPropertyTag = 347] = "JSDocPropertyTag", n[n.SyntaxList = 348] = "SyntaxList", n[n.NotEmittedStatement = 349] = "NotEmittedStatement", n[n.PartiallyEmittedExpression = 350] = "PartiallyEmittedExpression", n[n.CommaListExpression = 351] = "CommaListExpression", n[n.MergeDeclarationMarker = 352] = "MergeDeclarationMarker", n[n.EndOfDeclarationMarker = 353] = "EndOfDeclarationMarker", n[n.SyntheticReferenceExpression = 354] = "SyntheticReferenceExpression", n[n.Count = 355] = "Count", n[n.FirstAssignment = 63] = "FirstAssignment", n[n.LastAssignment = 78] = "LastAssignment", n[n.FirstCompoundAssignment = 64] = "FirstCompoundAssignment", n[n.LastCompoundAssignment = 78] = "LastCompoundAssignment", n[n.FirstReservedWord = 81] = "FirstReservedWord", n[n.LastReservedWord = 116] = "LastReservedWord", n[n.FirstKeyword = 81] = "FirstKeyword", n[n.LastKeyword = 160] = "LastKeyword", n[n.FirstFutureReservedWord = 117] = "FirstFutureReservedWord", n[n.LastFutureReservedWord = 125] = "LastFutureReservedWord", n[n.FirstTypeNode = 177] = "FirstTypeNode", n[n.LastTypeNode = 200] = "LastTypeNode", n[n.FirstPunctuation = 18] = "FirstPunctuation", n[n.LastPunctuation = 78] = "LastPunctuation", n[n.FirstToken = 0] = "FirstToken", n[n.LastToken = 160] = "LastToken", n[n.FirstTriviaToken = 2] = "FirstTriviaToken", n[n.LastTriviaToken = 7] = "LastTriviaToken", n[n.FirstLiteralToken = 8] = "FirstLiteralToken", n[n.LastLiteralToken = 14] = "LastLiteralToken", n[n.FirstTemplateToken = 14] = "FirstTemplateToken", n[n.LastTemplateToken = 17] = "LastTemplateToken", n[n.FirstBinaryOperator = 29] = "FirstBinaryOperator", n[n.LastBinaryOperator = 78] = "LastBinaryOperator", n[n.FirstStatement = 237] = "FirstStatement", n[n.LastStatement = 253] = "LastStatement", n[n.FirstNode = 161] = "FirstNode", n[n.FirstJSDocNode = 309] = "FirstJSDocNode", n[n.LastJSDocNode = 347] = "LastJSDocNode", n[n.FirstJSDocTagNode = 327] = "FirstJSDocTagNode", n[n.LastJSDocTagNode = 347] = "LastJSDocTagNode", n[n.FirstContextualKeyword = 126] = "FirstContextualKeyword", n[n.LastContextualKeyword = 160] = "LastContextualKeyword", n[n.JSDoc = 320] = "JSDoc";
            })(a = e2.SyntaxKind || (e2.SyntaxKind = {}));
            var C;
            (function(n) {
              n[n.None = 0] = "None", n[n.Let = 1] = "Let", n[n.Const = 2] = "Const", n[n.NestedNamespace = 4] = "NestedNamespace", n[n.Synthesized = 8] = "Synthesized", n[n.Namespace = 16] = "Namespace", n[n.OptionalChain = 32] = "OptionalChain", n[n.ExportContext = 64] = "ExportContext", n[n.ContainsThis = 128] = "ContainsThis", n[n.HasImplicitReturn = 256] = "HasImplicitReturn", n[n.HasExplicitReturn = 512] = "HasExplicitReturn", n[n.GlobalAugmentation = 1024] = "GlobalAugmentation", n[n.HasAsyncFunctions = 2048] = "HasAsyncFunctions", n[n.DisallowInContext = 4096] = "DisallowInContext", n[n.YieldContext = 8192] = "YieldContext", n[n.DecoratorContext = 16384] = "DecoratorContext", n[n.AwaitContext = 32768] = "AwaitContext", n[n.DisallowConditionalTypesContext = 65536] = "DisallowConditionalTypesContext", n[n.ThisNodeHasError = 131072] = "ThisNodeHasError", n[n.JavaScriptFile = 262144] = "JavaScriptFile", n[n.ThisNodeOrAnySubNodesHasError = 524288] = "ThisNodeOrAnySubNodesHasError", n[n.HasAggregatedChildData = 1048576] = "HasAggregatedChildData", n[n.PossiblyContainsDynamicImport = 2097152] = "PossiblyContainsDynamicImport", n[n.PossiblyContainsImportMeta = 4194304] = "PossiblyContainsImportMeta", n[n.JSDoc = 8388608] = "JSDoc", n[n.Ambient = 16777216] = "Ambient", n[n.InWithStatement = 33554432] = "InWithStatement", n[n.JsonFile = 67108864] = "JsonFile", n[n.TypeCached = 134217728] = "TypeCached", n[n.Deprecated = 268435456] = "Deprecated", n[n.BlockScoped = 3] = "BlockScoped", n[n.ReachabilityCheckFlags = 768] = "ReachabilityCheckFlags", n[n.ReachabilityAndEmitFlags = 2816] = "ReachabilityAndEmitFlags", n[n.ContextFlags = 50720768] = "ContextFlags", n[n.TypeExcludesFlags = 40960] = "TypeExcludesFlags", n[n.PermanentlySetIncrementalFlags = 6291456] = "PermanentlySetIncrementalFlags";
            })(C = e2.NodeFlags || (e2.NodeFlags = {}));
            var w;
            (function(n) {
              n[n.None = 0] = "None", n[n.Export = 1] = "Export", n[n.Ambient = 2] = "Ambient", n[n.Public = 4] = "Public", n[n.Private = 8] = "Private", n[n.Protected = 16] = "Protected", n[n.Static = 32] = "Static", n[n.Readonly = 64] = "Readonly", n[n.Abstract = 128] = "Abstract", n[n.Async = 256] = "Async", n[n.Default = 512] = "Default", n[n.Const = 2048] = "Const", n[n.HasComputedJSDocModifiers = 4096] = "HasComputedJSDocModifiers", n[n.Deprecated = 8192] = "Deprecated", n[n.Override = 16384] = "Override", n[n.In = 32768] = "In", n[n.Out = 65536] = "Out", n[n.HasComputedFlags = 536870912] = "HasComputedFlags", n[n.AccessibilityModifier = 28] = "AccessibilityModifier", n[n.ParameterPropertyModifier = 16476] = "ParameterPropertyModifier", n[n.NonPublicAccessibilityModifier = 24] = "NonPublicAccessibilityModifier", n[n.TypeScriptModifier = 116958] = "TypeScriptModifier", n[n.ExportDefault = 513] = "ExportDefault", n[n.All = 125951] = "All";
            })(w = e2.ModifierFlags || (e2.ModifierFlags = {}));
            var B;
            (function(n) {
              n[n.None = 0] = "None", n[n.IntrinsicNamedElement = 1] = "IntrinsicNamedElement", n[n.IntrinsicIndexedElement = 2] = "IntrinsicIndexedElement", n[n.IntrinsicElement = 3] = "IntrinsicElement";
            })(B = e2.JsxFlags || (e2.JsxFlags = {}));
            var E;
            (function(n) {
              n[n.Succeeded = 1] = "Succeeded", n[n.Failed = 2] = "Failed", n[n.Reported = 4] = "Reported", n[n.ReportsUnmeasurable = 8] = "ReportsUnmeasurable", n[n.ReportsUnreliable = 16] = "ReportsUnreliable", n[n.ReportsMask = 24] = "ReportsMask";
            })(E = e2.RelationComparisonResult || (e2.RelationComparisonResult = {}));
            var Q;
            (function(n) {
              n[n.None = 0] = "None", n[n.Auto = 1] = "Auto", n[n.Loop = 2] = "Loop", n[n.Unique = 3] = "Unique", n[n.Node = 4] = "Node", n[n.KindMask = 7] = "KindMask", n[n.ReservedInNestedScopes = 8] = "ReservedInNestedScopes", n[n.Optimistic = 16] = "Optimistic", n[n.FileLevel = 32] = "FileLevel", n[n.AllowNameSubstitution = 64] = "AllowNameSubstitution";
            })(Q = e2.GeneratedIdentifierFlags || (e2.GeneratedIdentifierFlags = {}));
            var le;
            (function(n) {
              n[n.None = 0] = "None", n[n.PrecedingLineBreak = 1] = "PrecedingLineBreak", n[n.PrecedingJSDocComment = 2] = "PrecedingJSDocComment", n[n.Unterminated = 4] = "Unterminated", n[n.ExtendedUnicodeEscape = 8] = "ExtendedUnicodeEscape", n[n.Scientific = 16] = "Scientific", n[n.Octal = 32] = "Octal", n[n.HexSpecifier = 64] = "HexSpecifier", n[n.BinarySpecifier = 128] = "BinarySpecifier", n[n.OctalSpecifier = 256] = "OctalSpecifier", n[n.ContainsSeparator = 512] = "ContainsSeparator", n[n.UnicodeEscape = 1024] = "UnicodeEscape", n[n.ContainsInvalidEscape = 2048] = "ContainsInvalidEscape", n[n.BinaryOrOctalSpecifier = 384] = "BinaryOrOctalSpecifier", n[n.NumericLiteralFlags = 1008] = "NumericLiteralFlags", n[n.TemplateLiteralLikeFlags = 2048] = "TemplateLiteralLikeFlags";
            })(le = e2.TokenFlags || (e2.TokenFlags = {}));
            var N;
            (function(n) {
              n[n.Unreachable = 1] = "Unreachable", n[n.Start = 2] = "Start", n[n.BranchLabel = 4] = "BranchLabel", n[n.LoopLabel = 8] = "LoopLabel", n[n.Assignment = 16] = "Assignment", n[n.TrueCondition = 32] = "TrueCondition", n[n.FalseCondition = 64] = "FalseCondition", n[n.SwitchClause = 128] = "SwitchClause", n[n.ArrayMutation = 256] = "ArrayMutation", n[n.Call = 512] = "Call", n[n.ReduceLabel = 1024] = "ReduceLabel", n[n.Referenced = 2048] = "Referenced", n[n.Shared = 4096] = "Shared", n[n.Label = 12] = "Label", n[n.Condition = 96] = "Condition";
            })(N = e2.FlowFlags || (e2.FlowFlags = {}));
            var p;
            (function(n) {
              n[n.ExpectError = 0] = "ExpectError", n[n.Ignore = 1] = "Ignore";
            })(p = e2.CommentDirectiveType || (e2.CommentDirectiveType = {}));
            var m2 = function() {
              function n() {
              }
              return n;
            }();
            e2.OperationCanceledException = m2;
            var G;
            (function(n) {
              n[n.RootFile = 0] = "RootFile", n[n.SourceFromProjectReference = 1] = "SourceFromProjectReference", n[n.OutputFromProjectReference = 2] = "OutputFromProjectReference", n[n.Import = 3] = "Import", n[n.ReferenceFile = 4] = "ReferenceFile", n[n.TypeReferenceDirective = 5] = "TypeReferenceDirective", n[n.LibFile = 6] = "LibFile", n[n.LibReferenceDirective = 7] = "LibReferenceDirective", n[n.AutomaticTypeDirectiveFile = 8] = "AutomaticTypeDirectiveFile";
            })(G = e2.FileIncludeKind || (e2.FileIncludeKind = {}));
            var oe;
            (function(n) {
              n[n.FilePreprocessingReferencedDiagnostic = 0] = "FilePreprocessingReferencedDiagnostic", n[n.FilePreprocessingFileExplainingDiagnostic = 1] = "FilePreprocessingFileExplainingDiagnostic";
            })(oe = e2.FilePreprocessingDiagnosticsKind || (e2.FilePreprocessingDiagnosticsKind = {}));
            var f4;
            (function(n) {
              n[n.Not = 0] = "Not", n[n.SafeModules = 1] = "SafeModules", n[n.Completely = 2] = "Completely";
            })(f4 = e2.StructureIsReused || (e2.StructureIsReused = {}));
            var T;
            (function(n) {
              n[n.Success = 0] = "Success", n[n.DiagnosticsPresent_OutputsSkipped = 1] = "DiagnosticsPresent_OutputsSkipped", n[n.DiagnosticsPresent_OutputsGenerated = 2] = "DiagnosticsPresent_OutputsGenerated", n[n.InvalidProject_OutputsSkipped = 3] = "InvalidProject_OutputsSkipped", n[n.ProjectReferenceCycle_OutputsSkipped = 4] = "ProjectReferenceCycle_OutputsSkipped", n[n.ProjectReferenceCycle_OutputsSkupped = 4] = "ProjectReferenceCycle_OutputsSkupped";
            })(T = e2.ExitStatus || (e2.ExitStatus = {}));
            var K;
            (function(n) {
              n[n.Ok = 0] = "Ok", n[n.NeedsOverride = 1] = "NeedsOverride", n[n.HasInvalidOverride = 2] = "HasInvalidOverride";
            })(K = e2.MemberOverrideStatus || (e2.MemberOverrideStatus = {}));
            var b;
            (function(n) {
              n[n.None = 0] = "None", n[n.Literal = 1] = "Literal", n[n.Subtype = 2] = "Subtype";
            })(b = e2.UnionReduction || (e2.UnionReduction = {}));
            var se;
            (function(n) {
              n[n.None = 0] = "None", n[n.Signature = 1] = "Signature", n[n.NoConstraints = 2] = "NoConstraints", n[n.Completions = 4] = "Completions", n[n.SkipBindingPatterns = 8] = "SkipBindingPatterns";
            })(se = e2.ContextFlags || (e2.ContextFlags = {}));
            var J;
            (function(n) {
              n[n.None = 0] = "None", n[n.NoTruncation = 1] = "NoTruncation", n[n.WriteArrayAsGenericType = 2] = "WriteArrayAsGenericType", n[n.GenerateNamesForShadowedTypeParams = 4] = "GenerateNamesForShadowedTypeParams", n[n.UseStructuralFallback = 8] = "UseStructuralFallback", n[n.ForbidIndexedAccessSymbolReferences = 16] = "ForbidIndexedAccessSymbolReferences", n[n.WriteTypeArgumentsOfSignature = 32] = "WriteTypeArgumentsOfSignature", n[n.UseFullyQualifiedType = 64] = "UseFullyQualifiedType", n[n.UseOnlyExternalAliasing = 128] = "UseOnlyExternalAliasing", n[n.SuppressAnyReturnType = 256] = "SuppressAnyReturnType", n[n.WriteTypeParametersInQualifiedName = 512] = "WriteTypeParametersInQualifiedName", n[n.MultilineObjectLiterals = 1024] = "MultilineObjectLiterals", n[n.WriteClassExpressionAsTypeLiteral = 2048] = "WriteClassExpressionAsTypeLiteral", n[n.UseTypeOfFunction = 4096] = "UseTypeOfFunction", n[n.OmitParameterModifiers = 8192] = "OmitParameterModifiers", n[n.UseAliasDefinedOutsideCurrentScope = 16384] = "UseAliasDefinedOutsideCurrentScope", n[n.UseSingleQuotesForStringLiteralType = 268435456] = "UseSingleQuotesForStringLiteralType", n[n.NoTypeReduction = 536870912] = "NoTypeReduction", n[n.AllowThisInObjectLiteral = 32768] = "AllowThisInObjectLiteral", n[n.AllowQualifiedNameInPlaceOfIdentifier = 65536] = "AllowQualifiedNameInPlaceOfIdentifier", n[n.AllowQualifedNameInPlaceOfIdentifier = 65536] = "AllowQualifedNameInPlaceOfIdentifier", n[n.AllowAnonymousIdentifier = 131072] = "AllowAnonymousIdentifier", n[n.AllowEmptyUnionOrIntersection = 262144] = "AllowEmptyUnionOrIntersection", n[n.AllowEmptyTuple = 524288] = "AllowEmptyTuple", n[n.AllowUniqueESSymbolType = 1048576] = "AllowUniqueESSymbolType", n[n.AllowEmptyIndexInfoType = 2097152] = "AllowEmptyIndexInfoType", n[n.AllowNodeModulesRelativePaths = 67108864] = "AllowNodeModulesRelativePaths", n[n.DoNotIncludeSymbolChain = 134217728] = "DoNotIncludeSymbolChain", n[n.IgnoreErrors = 70221824] = "IgnoreErrors", n[n.InObjectTypeLiteral = 4194304] = "InObjectTypeLiteral", n[n.InTypeAlias = 8388608] = "InTypeAlias", n[n.InInitialEntityName = 16777216] = "InInitialEntityName";
            })(J = e2.NodeBuilderFlags || (e2.NodeBuilderFlags = {}));
            var ie;
            (function(n) {
              n[n.None = 0] = "None", n[n.NoTruncation = 1] = "NoTruncation", n[n.WriteArrayAsGenericType = 2] = "WriteArrayAsGenericType", n[n.UseStructuralFallback = 8] = "UseStructuralFallback", n[n.WriteTypeArgumentsOfSignature = 32] = "WriteTypeArgumentsOfSignature", n[n.UseFullyQualifiedType = 64] = "UseFullyQualifiedType", n[n.SuppressAnyReturnType = 256] = "SuppressAnyReturnType", n[n.MultilineObjectLiterals = 1024] = "MultilineObjectLiterals", n[n.WriteClassExpressionAsTypeLiteral = 2048] = "WriteClassExpressionAsTypeLiteral", n[n.UseTypeOfFunction = 4096] = "UseTypeOfFunction", n[n.OmitParameterModifiers = 8192] = "OmitParameterModifiers", n[n.UseAliasDefinedOutsideCurrentScope = 16384] = "UseAliasDefinedOutsideCurrentScope", n[n.UseSingleQuotesForStringLiteralType = 268435456] = "UseSingleQuotesForStringLiteralType", n[n.NoTypeReduction = 536870912] = "NoTypeReduction", n[n.AllowUniqueESSymbolType = 1048576] = "AllowUniqueESSymbolType", n[n.AddUndefined = 131072] = "AddUndefined", n[n.WriteArrowStyleSignature = 262144] = "WriteArrowStyleSignature", n[n.InArrayType = 524288] = "InArrayType", n[n.InElementType = 2097152] = "InElementType", n[n.InFirstTypeArgument = 4194304] = "InFirstTypeArgument", n[n.InTypeAlias = 8388608] = "InTypeAlias", n[n.WriteOwnNameForAnyLike = 0] = "WriteOwnNameForAnyLike", n[n.NodeBuilderFlagsMask = 814775659] = "NodeBuilderFlagsMask";
            })(ie = e2.TypeFormatFlags || (e2.TypeFormatFlags = {}));
            var R;
            (function(n) {
              n[n.None = 0] = "None", n[n.WriteTypeParametersOrArguments = 1] = "WriteTypeParametersOrArguments", n[n.UseOnlyExternalAliasing = 2] = "UseOnlyExternalAliasing", n[n.AllowAnyNodeKind = 4] = "AllowAnyNodeKind", n[n.UseAliasDefinedOutsideCurrentScope = 8] = "UseAliasDefinedOutsideCurrentScope", n[n.DoNotIncludeSymbolChain = 16] = "DoNotIncludeSymbolChain";
            })(R = e2.SymbolFormatFlags || (e2.SymbolFormatFlags = {}));
            var q;
            (function(n) {
              n[n.Accessible = 0] = "Accessible", n[n.NotAccessible = 1] = "NotAccessible", n[n.CannotBeNamed = 2] = "CannotBeNamed";
            })(q = e2.SymbolAccessibility || (e2.SymbolAccessibility = {}));
            var O;
            (function(n) {
              n[n.UnionOrIntersection = 0] = "UnionOrIntersection", n[n.Spread = 1] = "Spread";
            })(O = e2.SyntheticSymbolKind || (e2.SyntheticSymbolKind = {}));
            var ve;
            (function(n) {
              n[n.This = 0] = "This", n[n.Identifier = 1] = "Identifier", n[n.AssertsThis = 2] = "AssertsThis", n[n.AssertsIdentifier = 3] = "AssertsIdentifier";
            })(ve = e2.TypePredicateKind || (e2.TypePredicateKind = {}));
            var ee;
            (function(n) {
              n[n.Unknown = 0] = "Unknown", n[n.TypeWithConstructSignatureAndValue = 1] = "TypeWithConstructSignatureAndValue", n[n.VoidNullableOrNeverType = 2] = "VoidNullableOrNeverType", n[n.NumberLikeType = 3] = "NumberLikeType", n[n.BigIntLikeType = 4] = "BigIntLikeType", n[n.StringLikeType = 5] = "StringLikeType", n[n.BooleanType = 6] = "BooleanType", n[n.ArrayLikeType = 7] = "ArrayLikeType", n[n.ESSymbolType = 8] = "ESSymbolType", n[n.Promise = 9] = "Promise", n[n.TypeWithCallSignature = 10] = "TypeWithCallSignature", n[n.ObjectType = 11] = "ObjectType";
            })(ee = e2.TypeReferenceSerializationKind || (e2.TypeReferenceSerializationKind = {}));
            var he;
            (function(n) {
              n[n.None = 0] = "None", n[n.FunctionScopedVariable = 1] = "FunctionScopedVariable", n[n.BlockScopedVariable = 2] = "BlockScopedVariable", n[n.Property = 4] = "Property", n[n.EnumMember = 8] = "EnumMember", n[n.Function = 16] = "Function", n[n.Class = 32] = "Class", n[n.Interface = 64] = "Interface", n[n.ConstEnum = 128] = "ConstEnum", n[n.RegularEnum = 256] = "RegularEnum", n[n.ValueModule = 512] = "ValueModule", n[n.NamespaceModule = 1024] = "NamespaceModule", n[n.TypeLiteral = 2048] = "TypeLiteral", n[n.ObjectLiteral = 4096] = "ObjectLiteral", n[n.Method = 8192] = "Method", n[n.Constructor = 16384] = "Constructor", n[n.GetAccessor = 32768] = "GetAccessor", n[n.SetAccessor = 65536] = "SetAccessor", n[n.Signature = 131072] = "Signature", n[n.TypeParameter = 262144] = "TypeParameter", n[n.TypeAlias = 524288] = "TypeAlias", n[n.ExportValue = 1048576] = "ExportValue", n[n.Alias = 2097152] = "Alias", n[n.Prototype = 4194304] = "Prototype", n[n.ExportStar = 8388608] = "ExportStar", n[n.Optional = 16777216] = "Optional", n[n.Transient = 33554432] = "Transient", n[n.Assignment = 67108864] = "Assignment", n[n.ModuleExports = 134217728] = "ModuleExports", n[n.All = 67108863] = "All", n[n.Enum = 384] = "Enum", n[n.Variable = 3] = "Variable", n[n.Value = 111551] = "Value", n[n.Type = 788968] = "Type", n[n.Namespace = 1920] = "Namespace", n[n.Module = 1536] = "Module", n[n.Accessor = 98304] = "Accessor", n[n.FunctionScopedVariableExcludes = 111550] = "FunctionScopedVariableExcludes", n[n.BlockScopedVariableExcludes = 111551] = "BlockScopedVariableExcludes", n[n.ParameterExcludes = 111551] = "ParameterExcludes", n[n.PropertyExcludes = 0] = "PropertyExcludes", n[n.EnumMemberExcludes = 900095] = "EnumMemberExcludes", n[n.FunctionExcludes = 110991] = "FunctionExcludes", n[n.ClassExcludes = 899503] = "ClassExcludes", n[n.InterfaceExcludes = 788872] = "InterfaceExcludes", n[n.RegularEnumExcludes = 899327] = "RegularEnumExcludes", n[n.ConstEnumExcludes = 899967] = "ConstEnumExcludes", n[n.ValueModuleExcludes = 110735] = "ValueModuleExcludes", n[n.NamespaceModuleExcludes = 0] = "NamespaceModuleExcludes", n[n.MethodExcludes = 103359] = "MethodExcludes", n[n.GetAccessorExcludes = 46015] = "GetAccessorExcludes", n[n.SetAccessorExcludes = 78783] = "SetAccessorExcludes", n[n.TypeParameterExcludes = 526824] = "TypeParameterExcludes", n[n.TypeAliasExcludes = 788968] = "TypeAliasExcludes", n[n.AliasExcludes = 2097152] = "AliasExcludes", n[n.ModuleMember = 2623475] = "ModuleMember", n[n.ExportHasLocal = 944] = "ExportHasLocal", n[n.BlockScoped = 418] = "BlockScoped", n[n.PropertyOrAccessor = 98308] = "PropertyOrAccessor", n[n.ClassMember = 106500] = "ClassMember", n[n.ExportSupportsDefaultModifier = 112] = "ExportSupportsDefaultModifier", n[n.ExportDoesNotSupportDefaultModifier = -113] = "ExportDoesNotSupportDefaultModifier", n[n.Classifiable = 2885600] = "Classifiable", n[n.LateBindingContainer = 6256] = "LateBindingContainer";
            })(he = e2.SymbolFlags || (e2.SymbolFlags = {}));
            var F2;
            (function(n) {
              n[n.Numeric = 0] = "Numeric", n[n.Literal = 1] = "Literal";
            })(F2 = e2.EnumKind || (e2.EnumKind = {}));
            var x2;
            (function(n) {
              n[n.Instantiated = 1] = "Instantiated", n[n.SyntheticProperty = 2] = "SyntheticProperty", n[n.SyntheticMethod = 4] = "SyntheticMethod", n[n.Readonly = 8] = "Readonly", n[n.ReadPartial = 16] = "ReadPartial", n[n.WritePartial = 32] = "WritePartial", n[n.HasNonUniformType = 64] = "HasNonUniformType", n[n.HasLiteralType = 128] = "HasLiteralType", n[n.ContainsPublic = 256] = "ContainsPublic", n[n.ContainsProtected = 512] = "ContainsProtected", n[n.ContainsPrivate = 1024] = "ContainsPrivate", n[n.ContainsStatic = 2048] = "ContainsStatic", n[n.Late = 4096] = "Late", n[n.ReverseMapped = 8192] = "ReverseMapped", n[n.OptionalParameter = 16384] = "OptionalParameter", n[n.RestParameter = 32768] = "RestParameter", n[n.DeferredType = 65536] = "DeferredType", n[n.HasNeverType = 131072] = "HasNeverType", n[n.Mapped = 262144] = "Mapped", n[n.StripOptional = 524288] = "StripOptional", n[n.Unresolved = 1048576] = "Unresolved", n[n.Synthetic = 6] = "Synthetic", n[n.Discriminant = 192] = "Discriminant", n[n.Partial = 48] = "Partial";
            })(x2 = e2.CheckFlags || (e2.CheckFlags = {}));
            var X;
            (function(n) {
              n.Call = "__call", n.Constructor = "__constructor", n.New = "__new", n.Index = "__index", n.ExportStar = "__export", n.Global = "__global", n.Missing = "__missing", n.Type = "__type", n.Object = "__object", n.JSXAttributes = "__jsxAttributes", n.Class = "__class", n.Function = "__function", n.Computed = "__computed", n.Resolving = "__resolving__", n.ExportEquals = "export=", n.Default = "default", n.This = "this";
            })(X = e2.InternalSymbolName || (e2.InternalSymbolName = {}));
            var $;
            (function(n) {
              n[n.TypeChecked = 1] = "TypeChecked", n[n.LexicalThis = 2] = "LexicalThis", n[n.CaptureThis = 4] = "CaptureThis", n[n.CaptureNewTarget = 8] = "CaptureNewTarget", n[n.SuperInstance = 256] = "SuperInstance", n[n.SuperStatic = 512] = "SuperStatic", n[n.ContextChecked = 1024] = "ContextChecked", n[n.AsyncMethodWithSuper = 2048] = "AsyncMethodWithSuper", n[n.AsyncMethodWithSuperBinding = 4096] = "AsyncMethodWithSuperBinding", n[n.CaptureArguments = 8192] = "CaptureArguments", n[n.EnumValuesComputed = 16384] = "EnumValuesComputed", n[n.LexicalModuleMergesWithClass = 32768] = "LexicalModuleMergesWithClass", n[n.LoopWithCapturedBlockScopedBinding = 65536] = "LoopWithCapturedBlockScopedBinding", n[n.ContainsCapturedBlockScopeBinding = 131072] = "ContainsCapturedBlockScopeBinding", n[n.CapturedBlockScopedBinding = 262144] = "CapturedBlockScopedBinding", n[n.BlockScopedBindingInLoop = 524288] = "BlockScopedBindingInLoop", n[n.ClassWithBodyScopedClassBinding = 1048576] = "ClassWithBodyScopedClassBinding", n[n.BodyScopedClassBinding = 2097152] = "BodyScopedClassBinding", n[n.NeedsLoopOutParameter = 4194304] = "NeedsLoopOutParameter", n[n.AssignmentsMarked = 8388608] = "AssignmentsMarked", n[n.ClassWithConstructorReference = 16777216] = "ClassWithConstructorReference", n[n.ConstructorReferenceInClass = 33554432] = "ConstructorReferenceInClass", n[n.ContainsClassWithPrivateIdentifiers = 67108864] = "ContainsClassWithPrivateIdentifiers", n[n.ContainsSuperPropertyInStaticInitializer = 134217728] = "ContainsSuperPropertyInStaticInitializer", n[n.InCheckIdentifier = 268435456] = "InCheckIdentifier";
            })($ = e2.NodeCheckFlags || (e2.NodeCheckFlags = {}));
            var A2;
            (function(n) {
              n[n.Any = 1] = "Any", n[n.Unknown = 2] = "Unknown", n[n.String = 4] = "String", n[n.Number = 8] = "Number", n[n.Boolean = 16] = "Boolean", n[n.Enum = 32] = "Enum", n[n.BigInt = 64] = "BigInt", n[n.StringLiteral = 128] = "StringLiteral", n[n.NumberLiteral = 256] = "NumberLiteral", n[n.BooleanLiteral = 512] = "BooleanLiteral", n[n.EnumLiteral = 1024] = "EnumLiteral", n[n.BigIntLiteral = 2048] = "BigIntLiteral", n[n.ESSymbol = 4096] = "ESSymbol", n[n.UniqueESSymbol = 8192] = "UniqueESSymbol", n[n.Void = 16384] = "Void", n[n.Undefined = 32768] = "Undefined", n[n.Null = 65536] = "Null", n[n.Never = 131072] = "Never", n[n.TypeParameter = 262144] = "TypeParameter", n[n.Object = 524288] = "Object", n[n.Union = 1048576] = "Union", n[n.Intersection = 2097152] = "Intersection", n[n.Index = 4194304] = "Index", n[n.IndexedAccess = 8388608] = "IndexedAccess", n[n.Conditional = 16777216] = "Conditional", n[n.Substitution = 33554432] = "Substitution", n[n.NonPrimitive = 67108864] = "NonPrimitive", n[n.TemplateLiteral = 134217728] = "TemplateLiteral", n[n.StringMapping = 268435456] = "StringMapping", n[n.AnyOrUnknown = 3] = "AnyOrUnknown", n[n.Nullable = 98304] = "Nullable", n[n.Literal = 2944] = "Literal", n[n.Unit = 109440] = "Unit", n[n.StringOrNumberLiteral = 384] = "StringOrNumberLiteral", n[n.StringOrNumberLiteralOrUnique = 8576] = "StringOrNumberLiteralOrUnique", n[n.DefinitelyFalsy = 117632] = "DefinitelyFalsy", n[n.PossiblyFalsy = 117724] = "PossiblyFalsy", n[n.Intrinsic = 67359327] = "Intrinsic", n[n.Primitive = 131068] = "Primitive", n[n.StringLike = 402653316] = "StringLike", n[n.NumberLike = 296] = "NumberLike", n[n.BigIntLike = 2112] = "BigIntLike", n[n.BooleanLike = 528] = "BooleanLike", n[n.EnumLike = 1056] = "EnumLike", n[n.ESSymbolLike = 12288] = "ESSymbolLike", n[n.VoidLike = 49152] = "VoidLike", n[n.DefinitelyNonNullable = 470302716] = "DefinitelyNonNullable", n[n.DisjointDomains = 469892092] = "DisjointDomains", n[n.UnionOrIntersection = 3145728] = "UnionOrIntersection", n[n.StructuredType = 3670016] = "StructuredType", n[n.TypeVariable = 8650752] = "TypeVariable", n[n.InstantiableNonPrimitive = 58982400] = "InstantiableNonPrimitive", n[n.InstantiablePrimitive = 406847488] = "InstantiablePrimitive", n[n.Instantiable = 465829888] = "Instantiable", n[n.StructuredOrInstantiable = 469499904] = "StructuredOrInstantiable", n[n.ObjectFlagsType = 3899393] = "ObjectFlagsType", n[n.Simplifiable = 25165824] = "Simplifiable", n[n.Singleton = 67358815] = "Singleton", n[n.Narrowable = 536624127] = "Narrowable", n[n.IncludesMask = 205258751] = "IncludesMask", n[n.IncludesMissingType = 262144] = "IncludesMissingType", n[n.IncludesNonWideningType = 4194304] = "IncludesNonWideningType", n[n.IncludesWildcard = 8388608] = "IncludesWildcard", n[n.IncludesEmptyObject = 16777216] = "IncludesEmptyObject", n[n.IncludesInstantiable = 33554432] = "IncludesInstantiable", n[n.NotPrimitiveUnion = 36323363] = "NotPrimitiveUnion";
            })(A2 = e2.TypeFlags || (e2.TypeFlags = {}));
            var y;
            (function(n) {
              n[n.Class = 1] = "Class", n[n.Interface = 2] = "Interface", n[n.Reference = 4] = "Reference", n[n.Tuple = 8] = "Tuple", n[n.Anonymous = 16] = "Anonymous", n[n.Mapped = 32] = "Mapped", n[n.Instantiated = 64] = "Instantiated", n[n.ObjectLiteral = 128] = "ObjectLiteral", n[n.EvolvingArray = 256] = "EvolvingArray", n[n.ObjectLiteralPatternWithComputedProperties = 512] = "ObjectLiteralPatternWithComputedProperties", n[n.ReverseMapped = 1024] = "ReverseMapped", n[n.JsxAttributes = 2048] = "JsxAttributes", n[n.JSLiteral = 4096] = "JSLiteral", n[n.FreshLiteral = 8192] = "FreshLiteral", n[n.ArrayLiteral = 16384] = "ArrayLiteral", n[n.PrimitiveUnion = 32768] = "PrimitiveUnion", n[n.ContainsWideningType = 65536] = "ContainsWideningType", n[n.ContainsObjectOrArrayLiteral = 131072] = "ContainsObjectOrArrayLiteral", n[n.NonInferrableType = 262144] = "NonInferrableType", n[n.CouldContainTypeVariablesComputed = 524288] = "CouldContainTypeVariablesComputed", n[n.CouldContainTypeVariables = 1048576] = "CouldContainTypeVariables", n[n.ClassOrInterface = 3] = "ClassOrInterface", n[n.RequiresWidening = 196608] = "RequiresWidening", n[n.PropagatingFlags = 458752] = "PropagatingFlags", n[n.ObjectTypeKindMask = 1343] = "ObjectTypeKindMask", n[n.ContainsSpread = 2097152] = "ContainsSpread", n[n.ObjectRestType = 4194304] = "ObjectRestType", n[n.InstantiationExpressionType = 8388608] = "InstantiationExpressionType", n[n.IsClassInstanceClone = 16777216] = "IsClassInstanceClone", n[n.IdenticalBaseTypeCalculated = 33554432] = "IdenticalBaseTypeCalculated", n[n.IdenticalBaseTypeExists = 67108864] = "IdenticalBaseTypeExists", n[n.IsGenericTypeComputed = 2097152] = "IsGenericTypeComputed", n[n.IsGenericObjectType = 4194304] = "IsGenericObjectType", n[n.IsGenericIndexType = 8388608] = "IsGenericIndexType", n[n.IsGenericType = 12582912] = "IsGenericType", n[n.ContainsIntersections = 16777216] = "ContainsIntersections", n[n.IsNeverIntersectionComputed = 16777216] = "IsNeverIntersectionComputed", n[n.IsNeverIntersection = 33554432] = "IsNeverIntersection";
            })(y = e2.ObjectFlags || (e2.ObjectFlags = {}));
            var V;
            (function(n) {
              n[n.Invariant = 0] = "Invariant", n[n.Covariant = 1] = "Covariant", n[n.Contravariant = 2] = "Contravariant", n[n.Bivariant = 3] = "Bivariant", n[n.Independent = 4] = "Independent", n[n.VarianceMask = 7] = "VarianceMask", n[n.Unmeasurable = 8] = "Unmeasurable", n[n.Unreliable = 16] = "Unreliable", n[n.AllowsStructuralFallback = 24] = "AllowsStructuralFallback";
            })(V = e2.VarianceFlags || (e2.VarianceFlags = {}));
            var L;
            (function(n) {
              n[n.Required = 1] = "Required", n[n.Optional = 2] = "Optional", n[n.Rest = 4] = "Rest", n[n.Variadic = 8] = "Variadic", n[n.Fixed = 3] = "Fixed", n[n.Variable = 12] = "Variable", n[n.NonRequired = 14] = "NonRequired", n[n.NonRest = 11] = "NonRest";
            })(L = e2.ElementFlags || (e2.ElementFlags = {}));
            var P;
            (function(n) {
              n[n.None = 0] = "None", n[n.IncludeUndefined = 1] = "IncludeUndefined", n[n.NoIndexSignatures = 2] = "NoIndexSignatures", n[n.Writing = 4] = "Writing", n[n.CacheSymbol = 8] = "CacheSymbol", n[n.NoTupleBoundsCheck = 16] = "NoTupleBoundsCheck", n[n.ExpressionPosition = 32] = "ExpressionPosition", n[n.ReportDeprecated = 64] = "ReportDeprecated", n[n.SuppressNoImplicitAnyError = 128] = "SuppressNoImplicitAnyError", n[n.Contextual = 256] = "Contextual", n[n.Persistent = 1] = "Persistent";
            })(P = e2.AccessFlags || (e2.AccessFlags = {}));
            var k;
            (function(n) {
              n[n.Component = 0] = "Component", n[n.Function = 1] = "Function", n[n.Mixed = 2] = "Mixed";
            })(k = e2.JsxReferenceKind || (e2.JsxReferenceKind = {}));
            var Y;
            (function(n) {
              n[n.Call = 0] = "Call", n[n.Construct = 1] = "Construct";
            })(Y = e2.SignatureKind || (e2.SignatureKind = {}));
            var U;
            (function(n) {
              n[n.None = 0] = "None", n[n.HasRestParameter = 1] = "HasRestParameter", n[n.HasLiteralTypes = 2] = "HasLiteralTypes", n[n.Abstract = 4] = "Abstract", n[n.IsInnerCallChain = 8] = "IsInnerCallChain", n[n.IsOuterCallChain = 16] = "IsOuterCallChain", n[n.IsUntypedSignatureInJSFile = 32] = "IsUntypedSignatureInJSFile", n[n.PropagatingFlags = 39] = "PropagatingFlags", n[n.CallChainFlags = 24] = "CallChainFlags";
            })(U = e2.SignatureFlags || (e2.SignatureFlags = {}));
            var j;
            (function(n) {
              n[n.String = 0] = "String", n[n.Number = 1] = "Number";
            })(j = e2.IndexKind || (e2.IndexKind = {}));
            var H;
            (function(n) {
              n[n.Simple = 0] = "Simple", n[n.Array = 1] = "Array", n[n.Function = 2] = "Function", n[n.Composite = 3] = "Composite", n[n.Merged = 4] = "Merged";
            })(H = e2.TypeMapKind || (e2.TypeMapKind = {}));
            var I;
            (function(n) {
              n[n.NakedTypeVariable = 1] = "NakedTypeVariable", n[n.SpeculativeTuple = 2] = "SpeculativeTuple", n[n.SubstituteSource = 4] = "SubstituteSource", n[n.HomomorphicMappedType = 8] = "HomomorphicMappedType", n[n.PartialHomomorphicMappedType = 16] = "PartialHomomorphicMappedType", n[n.MappedTypeConstraint = 32] = "MappedTypeConstraint", n[n.ContravariantConditional = 64] = "ContravariantConditional", n[n.ReturnType = 128] = "ReturnType", n[n.LiteralKeyof = 256] = "LiteralKeyof", n[n.NoConstraints = 512] = "NoConstraints", n[n.AlwaysStrict = 1024] = "AlwaysStrict", n[n.MaxValue = 2048] = "MaxValue", n[n.PriorityImpliesCombination = 416] = "PriorityImpliesCombination", n[n.Circularity = -1] = "Circularity";
            })(I = e2.InferencePriority || (e2.InferencePriority = {}));
            var l;
            (function(n) {
              n[n.None = 0] = "None", n[n.NoDefault = 1] = "NoDefault", n[n.AnyDefault = 2] = "AnyDefault", n[n.SkippedGenericFunction = 4] = "SkippedGenericFunction";
            })(l = e2.InferenceFlags || (e2.InferenceFlags = {}));
            var d;
            (function(n) {
              n[n.False = 0] = "False", n[n.Unknown = 1] = "Unknown", n[n.Maybe = 3] = "Maybe", n[n.True = -1] = "True";
            })(d = e2.Ternary || (e2.Ternary = {}));
            var D;
            (function(n) {
              n[n.None = 0] = "None", n[n.ExportsProperty = 1] = "ExportsProperty", n[n.ModuleExports = 2] = "ModuleExports", n[n.PrototypeProperty = 3] = "PrototypeProperty", n[n.ThisProperty = 4] = "ThisProperty", n[n.Property = 5] = "Property", n[n.Prototype = 6] = "Prototype", n[n.ObjectDefinePropertyValue = 7] = "ObjectDefinePropertyValue", n[n.ObjectDefinePropertyExports = 8] = "ObjectDefinePropertyExports", n[n.ObjectDefinePrototypeProperty = 9] = "ObjectDefinePrototypeProperty";
            })(D = e2.AssignmentDeclarationKind || (e2.AssignmentDeclarationKind = {}));
            var fe;
            (function(n) {
              n[n.Warning = 0] = "Warning", n[n.Error = 1] = "Error", n[n.Suggestion = 2] = "Suggestion", n[n.Message = 3] = "Message";
            })(fe = e2.DiagnosticCategory || (e2.DiagnosticCategory = {}));
            function g(n, lr) {
              lr === void 0 && (lr = true);
              var be = fe[n.category];
              return lr ? be.toLowerCase() : be;
            }
            e2.diagnosticCategoryName = g;
            var ne;
            (function(n) {
              n[n.Classic = 1] = "Classic", n[n.NodeJs = 2] = "NodeJs", n[n.Node16 = 3] = "Node16", n[n.NodeNext = 99] = "NodeNext";
            })(ne = e2.ModuleResolutionKind || (e2.ModuleResolutionKind = {}));
            var ue;
            (function(n) {
              n[n.Legacy = 1] = "Legacy", n[n.Auto = 2] = "Auto", n[n.Force = 3] = "Force";
            })(ue = e2.ModuleDetectionKind || (e2.ModuleDetectionKind = {}));
            var We;
            (function(n) {
              n[n.FixedPollingInterval = 0] = "FixedPollingInterval", n[n.PriorityPollingInterval = 1] = "PriorityPollingInterval", n[n.DynamicPriorityPolling = 2] = "DynamicPriorityPolling", n[n.FixedChunkSizePolling = 3] = "FixedChunkSizePolling", n[n.UseFsEvents = 4] = "UseFsEvents", n[n.UseFsEventsOnParentDirectory = 5] = "UseFsEventsOnParentDirectory";
            })(We = e2.WatchFileKind || (e2.WatchFileKind = {}));
            var Fe;
            (function(n) {
              n[n.UseFsEvents = 0] = "UseFsEvents", n[n.FixedPollingInterval = 1] = "FixedPollingInterval", n[n.DynamicPriorityPolling = 2] = "DynamicPriorityPolling", n[n.FixedChunkSizePolling = 3] = "FixedChunkSizePolling";
            })(Fe = e2.WatchDirectoryKind || (e2.WatchDirectoryKind = {}));
            var Z2;
            (function(n) {
              n[n.FixedInterval = 0] = "FixedInterval", n[n.PriorityInterval = 1] = "PriorityInterval", n[n.DynamicPriority = 2] = "DynamicPriority", n[n.FixedChunkSize = 3] = "FixedChunkSize";
            })(Z2 = e2.PollingWatchKind || (e2.PollingWatchKind = {}));
            var Be;
            (function(n) {
              n[n.None = 0] = "None", n[n.CommonJS = 1] = "CommonJS", n[n.AMD = 2] = "AMD", n[n.UMD = 3] = "UMD", n[n.System = 4] = "System", n[n.ES2015 = 5] = "ES2015", n[n.ES2020 = 6] = "ES2020", n[n.ES2022 = 7] = "ES2022", n[n.ESNext = 99] = "ESNext", n[n.Node16 = 100] = "Node16", n[n.NodeNext = 199] = "NodeNext";
            })(Be = e2.ModuleKind || (e2.ModuleKind = {}));
            var ge;
            (function(n) {
              n[n.None = 0] = "None", n[n.Preserve = 1] = "Preserve", n[n.React = 2] = "React", n[n.ReactNative = 3] = "ReactNative", n[n.ReactJSX = 4] = "ReactJSX", n[n.ReactJSXDev = 5] = "ReactJSXDev";
            })(ge = e2.JsxEmit || (e2.JsxEmit = {}));
            var Re;
            (function(n) {
              n[n.Remove = 0] = "Remove", n[n.Preserve = 1] = "Preserve", n[n.Error = 2] = "Error";
            })(Re = e2.ImportsNotUsedAsValues || (e2.ImportsNotUsedAsValues = {}));
            var ze;
            (function(n) {
              n[n.CarriageReturnLineFeed = 0] = "CarriageReturnLineFeed", n[n.LineFeed = 1] = "LineFeed";
            })(ze = e2.NewLineKind || (e2.NewLineKind = {}));
            var Ee;
            (function(n) {
              n[n.Unknown = 0] = "Unknown", n[n.JS = 1] = "JS", n[n.JSX = 2] = "JSX", n[n.TS = 3] = "TS", n[n.TSX = 4] = "TSX", n[n.External = 5] = "External", n[n.JSON = 6] = "JSON", n[n.Deferred = 7] = "Deferred";
            })(Ee = e2.ScriptKind || (e2.ScriptKind = {}));
            var He;
            (function(n) {
              n[n.ES3 = 0] = "ES3", n[n.ES5 = 1] = "ES5", n[n.ES2015 = 2] = "ES2015", n[n.ES2016 = 3] = "ES2016", n[n.ES2017 = 4] = "ES2017", n[n.ES2018 = 5] = "ES2018", n[n.ES2019 = 6] = "ES2019", n[n.ES2020 = 7] = "ES2020", n[n.ES2021 = 8] = "ES2021", n[n.ES2022 = 9] = "ES2022", n[n.ESNext = 99] = "ESNext", n[n.JSON = 100] = "JSON", n[n.Latest = 99] = "Latest";
            })(He = e2.ScriptTarget || (e2.ScriptTarget = {}));
            var rr;
            (function(n) {
              n[n.Standard = 0] = "Standard", n[n.JSX = 1] = "JSX";
            })(rr = e2.LanguageVariant || (e2.LanguageVariant = {}));
            var Ie;
            (function(n) {
              n[n.None = 0] = "None", n[n.Recursive = 1] = "Recursive";
            })(Ie = e2.WatchDirectoryFlags || (e2.WatchDirectoryFlags = {}));
            var _e;
            (function(n) {
              n[n.nullCharacter = 0] = "nullCharacter", n[n.maxAsciiCharacter = 127] = "maxAsciiCharacter", n[n.lineFeed = 10] = "lineFeed", n[n.carriageReturn = 13] = "carriageReturn", n[n.lineSeparator = 8232] = "lineSeparator", n[n.paragraphSeparator = 8233] = "paragraphSeparator", n[n.nextLine = 133] = "nextLine", n[n.space = 32] = "space", n[n.nonBreakingSpace = 160] = "nonBreakingSpace", n[n.enQuad = 8192] = "enQuad", n[n.emQuad = 8193] = "emQuad", n[n.enSpace = 8194] = "enSpace", n[n.emSpace = 8195] = "emSpace", n[n.threePerEmSpace = 8196] = "threePerEmSpace", n[n.fourPerEmSpace = 8197] = "fourPerEmSpace", n[n.sixPerEmSpace = 8198] = "sixPerEmSpace", n[n.figureSpace = 8199] = "figureSpace", n[n.punctuationSpace = 8200] = "punctuationSpace", n[n.thinSpace = 8201] = "thinSpace", n[n.hairSpace = 8202] = "hairSpace", n[n.zeroWidthSpace = 8203] = "zeroWidthSpace", n[n.narrowNoBreakSpace = 8239] = "narrowNoBreakSpace", n[n.ideographicSpace = 12288] = "ideographicSpace", n[n.mathematicalSpace = 8287] = "mathematicalSpace", n[n.ogham = 5760] = "ogham", n[n._ = 95] = "_", n[n.$ = 36] = "$", n[n._0 = 48] = "_0", n[n._1 = 49] = "_1", n[n._2 = 50] = "_2", n[n._3 = 51] = "_3", n[n._4 = 52] = "_4", n[n._5 = 53] = "_5", n[n._6 = 54] = "_6", n[n._7 = 55] = "_7", n[n._8 = 56] = "_8", n[n._9 = 57] = "_9", n[n.a = 97] = "a", n[n.b = 98] = "b", n[n.c = 99] = "c", n[n.d = 100] = "d", n[n.e = 101] = "e", n[n.f = 102] = "f", n[n.g = 103] = "g", n[n.h = 104] = "h", n[n.i = 105] = "i", n[n.j = 106] = "j", n[n.k = 107] = "k", n[n.l = 108] = "l", n[n.m = 109] = "m", n[n.n = 110] = "n", n[n.o = 111] = "o", n[n.p = 112] = "p", n[n.q = 113] = "q", n[n.r = 114] = "r", n[n.s = 115] = "s", n[n.t = 116] = "t", n[n.u = 117] = "u", n[n.v = 118] = "v", n[n.w = 119] = "w", n[n.x = 120] = "x", n[n.y = 121] = "y", n[n.z = 122] = "z", n[n.A = 65] = "A", n[n.B = 66] = "B", n[n.C = 67] = "C", n[n.D = 68] = "D", n[n.E = 69] = "E", n[n.F = 70] = "F", n[n.G = 71] = "G", n[n.H = 72] = "H", n[n.I = 73] = "I", n[n.J = 74] = "J", n[n.K = 75] = "K", n[n.L = 76] = "L", n[n.M = 77] = "M", n[n.N = 78] = "N", n[n.O = 79] = "O", n[n.P = 80] = "P", n[n.Q = 81] = "Q", n[n.R = 82] = "R", n[n.S = 83] = "S", n[n.T = 84] = "T", n[n.U = 85] = "U", n[n.V = 86] = "V", n[n.W = 87] = "W", n[n.X = 88] = "X", n[n.Y = 89] = "Y", n[n.Z = 90] = "Z", n[n.ampersand = 38] = "ampersand", n[n.asterisk = 42] = "asterisk", n[n.at = 64] = "at", n[n.backslash = 92] = "backslash", n[n.backtick = 96] = "backtick", n[n.bar = 124] = "bar", n[n.caret = 94] = "caret", n[n.closeBrace = 125] = "closeBrace", n[n.closeBracket = 93] = "closeBracket", n[n.closeParen = 41] = "closeParen", n[n.colon = 58] = "colon", n[n.comma = 44] = "comma", n[n.dot = 46] = "dot", n[n.doubleQuote = 34] = "doubleQuote", n[n.equals = 61] = "equals", n[n.exclamation = 33] = "exclamation", n[n.greaterThan = 62] = "greaterThan", n[n.hash = 35] = "hash", n[n.lessThan = 60] = "lessThan", n[n.minus = 45] = "minus", n[n.openBrace = 123] = "openBrace", n[n.openBracket = 91] = "openBracket", n[n.openParen = 40] = "openParen", n[n.percent = 37] = "percent", n[n.plus = 43] = "plus", n[n.question = 63] = "question", n[n.semicolon = 59] = "semicolon", n[n.singleQuote = 39] = "singleQuote", n[n.slash = 47] = "slash", n[n.tilde = 126] = "tilde", n[n.backspace = 8] = "backspace", n[n.formFeed = 12] = "formFeed", n[n.byteOrderMark = 65279] = "byteOrderMark", n[n.tab = 9] = "tab", n[n.verticalTab = 11] = "verticalTab";
            })(_e = e2.CharacterCodes || (e2.CharacterCodes = {}));
            var we;
            (function(n) {
              n.Ts = ".ts", n.Tsx = ".tsx", n.Dts = ".d.ts", n.Js = ".js", n.Jsx = ".jsx", n.Json = ".json", n.TsBuildInfo = ".tsbuildinfo", n.Mjs = ".mjs", n.Mts = ".mts", n.Dmts = ".d.mts", n.Cjs = ".cjs", n.Cts = ".cts", n.Dcts = ".d.cts";
            })(we = e2.Extension || (e2.Extension = {}));
            var de;
            (function(n) {
              n[n.None = 0] = "None", n[n.ContainsTypeScript = 1] = "ContainsTypeScript", n[n.ContainsJsx = 2] = "ContainsJsx", n[n.ContainsESNext = 4] = "ContainsESNext", n[n.ContainsES2022 = 8] = "ContainsES2022", n[n.ContainsES2021 = 16] = "ContainsES2021", n[n.ContainsES2020 = 32] = "ContainsES2020", n[n.ContainsES2019 = 64] = "ContainsES2019", n[n.ContainsES2018 = 128] = "ContainsES2018", n[n.ContainsES2017 = 256] = "ContainsES2017", n[n.ContainsES2016 = 512] = "ContainsES2016", n[n.ContainsES2015 = 1024] = "ContainsES2015", n[n.ContainsGenerator = 2048] = "ContainsGenerator", n[n.ContainsDestructuringAssignment = 4096] = "ContainsDestructuringAssignment", n[n.ContainsTypeScriptClassSyntax = 4096] = "ContainsTypeScriptClassSyntax", n[n.ContainsLexicalThis = 8192] = "ContainsLexicalThis", n[n.ContainsRestOrSpread = 16384] = "ContainsRestOrSpread", n[n.ContainsObjectRestOrSpread = 32768] = "ContainsObjectRestOrSpread", n[n.ContainsComputedPropertyName = 65536] = "ContainsComputedPropertyName", n[n.ContainsBlockScopedBinding = 131072] = "ContainsBlockScopedBinding", n[n.ContainsBindingPattern = 262144] = "ContainsBindingPattern", n[n.ContainsYield = 524288] = "ContainsYield", n[n.ContainsAwait = 1048576] = "ContainsAwait", n[n.ContainsHoistedDeclarationOrCompletion = 2097152] = "ContainsHoistedDeclarationOrCompletion", n[n.ContainsDynamicImport = 4194304] = "ContainsDynamicImport", n[n.ContainsClassFields = 8388608] = "ContainsClassFields", n[n.ContainsPossibleTopLevelAwait = 16777216] = "ContainsPossibleTopLevelAwait", n[n.ContainsLexicalSuper = 33554432] = "ContainsLexicalSuper", n[n.ContainsUpdateExpressionForIdentifier = 67108864] = "ContainsUpdateExpressionForIdentifier", n[n.HasComputedFlags = 536870912] = "HasComputedFlags", n[n.AssertTypeScript = 1] = "AssertTypeScript", n[n.AssertJsx = 2] = "AssertJsx", n[n.AssertESNext = 4] = "AssertESNext", n[n.AssertES2022 = 8] = "AssertES2022", n[n.AssertES2021 = 16] = "AssertES2021", n[n.AssertES2020 = 32] = "AssertES2020", n[n.AssertES2019 = 64] = "AssertES2019", n[n.AssertES2018 = 128] = "AssertES2018", n[n.AssertES2017 = 256] = "AssertES2017", n[n.AssertES2016 = 512] = "AssertES2016", n[n.AssertES2015 = 1024] = "AssertES2015", n[n.AssertGenerator = 2048] = "AssertGenerator", n[n.AssertDestructuringAssignment = 4096] = "AssertDestructuringAssignment", n[n.OuterExpressionExcludes = 536870912] = "OuterExpressionExcludes", n[n.PropertyAccessExcludes = 536870912] = "PropertyAccessExcludes", n[n.NodeExcludes = 536870912] = "NodeExcludes", n[n.ArrowFunctionExcludes = 557748224] = "ArrowFunctionExcludes", n[n.FunctionExcludes = 591310848] = "FunctionExcludes", n[n.ConstructorExcludes = 591306752] = "ConstructorExcludes", n[n.MethodOrAccessorExcludes = 574529536] = "MethodOrAccessorExcludes", n[n.PropertyExcludes = 570433536] = "PropertyExcludes", n[n.ClassExcludes = 536940544] = "ClassExcludes", n[n.ModuleExcludes = 589443072] = "ModuleExcludes", n[n.TypeExcludes = -2] = "TypeExcludes", n[n.ObjectLiteralExcludes = 536973312] = "ObjectLiteralExcludes", n[n.ArrayLiteralOrCallOrNewExcludes = 536887296] = "ArrayLiteralOrCallOrNewExcludes", n[n.VariableDeclarationListExcludes = 537165824] = "VariableDeclarationListExcludes", n[n.ParameterExcludes = 536870912] = "ParameterExcludes", n[n.CatchClauseExcludes = 536903680] = "CatchClauseExcludes", n[n.BindingPatternExcludes = 536887296] = "BindingPatternExcludes", n[n.ContainsLexicalThisOrSuper = 33562624] = "ContainsLexicalThisOrSuper", n[n.PropertyNamePropagatingFlags = 33562624] = "PropertyNamePropagatingFlags";
            })(de = e2.TransformFlags || (e2.TransformFlags = {}));
            var ye;
            (function(n) {
              n[n.TabStop = 0] = "TabStop", n[n.Placeholder = 1] = "Placeholder", n[n.Choice = 2] = "Choice", n[n.Variable = 3] = "Variable";
            })(ye = e2.SnippetKind || (e2.SnippetKind = {}));
            var Ae;
            (function(n) {
              n[n.None = 0] = "None", n[n.SingleLine = 1] = "SingleLine", n[n.AdviseOnEmitNode = 2] = "AdviseOnEmitNode", n[n.NoSubstitution = 4] = "NoSubstitution", n[n.CapturesThis = 8] = "CapturesThis", n[n.NoLeadingSourceMap = 16] = "NoLeadingSourceMap", n[n.NoTrailingSourceMap = 32] = "NoTrailingSourceMap", n[n.NoSourceMap = 48] = "NoSourceMap", n[n.NoNestedSourceMaps = 64] = "NoNestedSourceMaps", n[n.NoTokenLeadingSourceMaps = 128] = "NoTokenLeadingSourceMaps", n[n.NoTokenTrailingSourceMaps = 256] = "NoTokenTrailingSourceMaps", n[n.NoTokenSourceMaps = 384] = "NoTokenSourceMaps", n[n.NoLeadingComments = 512] = "NoLeadingComments", n[n.NoTrailingComments = 1024] = "NoTrailingComments", n[n.NoComments = 1536] = "NoComments", n[n.NoNestedComments = 2048] = "NoNestedComments", n[n.HelperName = 4096] = "HelperName", n[n.ExportName = 8192] = "ExportName", n[n.LocalName = 16384] = "LocalName", n[n.InternalName = 32768] = "InternalName", n[n.Indented = 65536] = "Indented", n[n.NoIndentation = 131072] = "NoIndentation", n[n.AsyncFunctionBody = 262144] = "AsyncFunctionBody", n[n.ReuseTempVariableScope = 524288] = "ReuseTempVariableScope", n[n.CustomPrologue = 1048576] = "CustomPrologue", n[n.NoHoisting = 2097152] = "NoHoisting", n[n.HasEndOfDeclarationMarker = 4194304] = "HasEndOfDeclarationMarker", n[n.Iterator = 8388608] = "Iterator", n[n.NoAsciiEscaping = 16777216] = "NoAsciiEscaping", n[n.TypeScriptClassWrapper = 33554432] = "TypeScriptClassWrapper", n[n.NeverApplyImportHelper = 67108864] = "NeverApplyImportHelper", n[n.IgnoreSourceNewlines = 134217728] = "IgnoreSourceNewlines", n[n.Immutable = 268435456] = "Immutable", n[n.IndirectCall = 536870912] = "IndirectCall";
            })(Ae = e2.EmitFlags || (e2.EmitFlags = {}));
            var er;
            (function(n) {
              n[n.Extends = 1] = "Extends", n[n.Assign = 2] = "Assign", n[n.Rest = 4] = "Rest", n[n.Decorate = 8] = "Decorate", n[n.Metadata = 16] = "Metadata", n[n.Param = 32] = "Param", n[n.Awaiter = 64] = "Awaiter", n[n.Generator = 128] = "Generator", n[n.Values = 256] = "Values", n[n.Read = 512] = "Read", n[n.SpreadArray = 1024] = "SpreadArray", n[n.Await = 2048] = "Await", n[n.AsyncGenerator = 4096] = "AsyncGenerator", n[n.AsyncDelegator = 8192] = "AsyncDelegator", n[n.AsyncValues = 16384] = "AsyncValues", n[n.ExportStar = 32768] = "ExportStar", n[n.ImportStar = 65536] = "ImportStar", n[n.ImportDefault = 131072] = "ImportDefault", n[n.MakeTemplateObject = 262144] = "MakeTemplateObject", n[n.ClassPrivateFieldGet = 524288] = "ClassPrivateFieldGet", n[n.ClassPrivateFieldSet = 1048576] = "ClassPrivateFieldSet", n[n.ClassPrivateFieldIn = 2097152] = "ClassPrivateFieldIn", n[n.CreateBinding = 4194304] = "CreateBinding", n[n.FirstEmitHelper = 1] = "FirstEmitHelper", n[n.LastEmitHelper = 4194304] = "LastEmitHelper", n[n.ForOfIncludes = 256] = "ForOfIncludes", n[n.ForAwaitOfIncludes = 16384] = "ForAwaitOfIncludes", n[n.AsyncGeneratorIncludes = 6144] = "AsyncGeneratorIncludes", n[n.AsyncDelegatorIncludes = 26624] = "AsyncDelegatorIncludes", n[n.SpreadIncludes = 1536] = "SpreadIncludes";
            })(er = e2.ExternalEmitHelpers || (e2.ExternalEmitHelpers = {}));
            var ir;
            (function(n) {
              n[n.SourceFile = 0] = "SourceFile", n[n.Expression = 1] = "Expression", n[n.IdentifierName = 2] = "IdentifierName", n[n.MappedTypeParameter = 3] = "MappedTypeParameter", n[n.Unspecified = 4] = "Unspecified", n[n.EmbeddedStatement = 5] = "EmbeddedStatement", n[n.JsxAttributeValue = 6] = "JsxAttributeValue";
            })(ir = e2.EmitHint || (e2.EmitHint = {}));
            var Cr;
            (function(n) {
              n[n.Parentheses = 1] = "Parentheses", n[n.TypeAssertions = 2] = "TypeAssertions", n[n.NonNullAssertions = 4] = "NonNullAssertions", n[n.PartiallyEmittedExpressions = 8] = "PartiallyEmittedExpressions", n[n.Assertions = 6] = "Assertions", n[n.All = 15] = "All", n[n.ExcludeJSDocTypeAssertion = 16] = "ExcludeJSDocTypeAssertion";
            })(Cr = e2.OuterExpressionKinds || (e2.OuterExpressionKinds = {}));
            var Ye;
            (function(n) {
              n[n.None = 0] = "None", n[n.InParameters = 1] = "InParameters", n[n.VariablesHoistedInParameters = 2] = "VariablesHoistedInParameters";
            })(Ye = e2.LexicalEnvironmentFlags || (e2.LexicalEnvironmentFlags = {}));
            var Br;
            (function(n) {
              n.Prologue = "prologue", n.EmitHelpers = "emitHelpers", n.NoDefaultLib = "no-default-lib", n.Reference = "reference", n.Type = "type", n.TypeResolutionModeRequire = "type-require", n.TypeResolutionModeImport = "type-import", n.Lib = "lib", n.Prepend = "prepend", n.Text = "text", n.Internal = "internal";
            })(Br = e2.BundleFileSectionKind || (e2.BundleFileSectionKind = {}));
            var Er;
            (function(n) {
              n[n.None = 0] = "None", n[n.SingleLine = 0] = "SingleLine", n[n.MultiLine = 1] = "MultiLine", n[n.PreserveLines = 2] = "PreserveLines", n[n.LinesMask = 3] = "LinesMask", n[n.NotDelimited = 0] = "NotDelimited", n[n.BarDelimited = 4] = "BarDelimited", n[n.AmpersandDelimited = 8] = "AmpersandDelimited", n[n.CommaDelimited = 16] = "CommaDelimited", n[n.AsteriskDelimited = 32] = "AsteriskDelimited", n[n.DelimitersMask = 60] = "DelimitersMask", n[n.AllowTrailingComma = 64] = "AllowTrailingComma", n[n.Indented = 128] = "Indented", n[n.SpaceBetweenBraces = 256] = "SpaceBetweenBraces", n[n.SpaceBetweenSiblings = 512] = "SpaceBetweenSiblings", n[n.Braces = 1024] = "Braces", n[n.Parenthesis = 2048] = "Parenthesis", n[n.AngleBrackets = 4096] = "AngleBrackets", n[n.SquareBrackets = 8192] = "SquareBrackets", n[n.BracketsMask = 15360] = "BracketsMask", n[n.OptionalIfUndefined = 16384] = "OptionalIfUndefined", n[n.OptionalIfEmpty = 32768] = "OptionalIfEmpty", n[n.Optional = 49152] = "Optional", n[n.PreferNewLine = 65536] = "PreferNewLine", n[n.NoTrailingNewLine = 131072] = "NoTrailingNewLine", n[n.NoInterveningComments = 262144] = "NoInterveningComments", n[n.NoSpaceIfEmpty = 524288] = "NoSpaceIfEmpty", n[n.SingleElement = 1048576] = "SingleElement", n[n.SpaceAfterList = 2097152] = "SpaceAfterList", n[n.Modifiers = 262656] = "Modifiers", n[n.HeritageClauses = 512] = "HeritageClauses", n[n.SingleLineTypeLiteralMembers = 768] = "SingleLineTypeLiteralMembers", n[n.MultiLineTypeLiteralMembers = 32897] = "MultiLineTypeLiteralMembers", n[n.SingleLineTupleTypeElements = 528] = "SingleLineTupleTypeElements", n[n.MultiLineTupleTypeElements = 657] = "MultiLineTupleTypeElements", n[n.UnionTypeConstituents = 516] = "UnionTypeConstituents", n[n.IntersectionTypeConstituents = 520] = "IntersectionTypeConstituents", n[n.ObjectBindingPatternElements = 525136] = "ObjectBindingPatternElements", n[n.ArrayBindingPatternElements = 524880] = "ArrayBindingPatternElements", n[n.ObjectLiteralExpressionProperties = 526226] = "ObjectLiteralExpressionProperties", n[n.ImportClauseEntries = 526226] = "ImportClauseEntries", n[n.ArrayLiteralExpressionElements = 8914] = "ArrayLiteralExpressionElements", n[n.CommaListElements = 528] = "CommaListElements", n[n.CallExpressionArguments = 2576] = "CallExpressionArguments", n[n.NewExpressionArguments = 18960] = "NewExpressionArguments", n[n.TemplateExpressionSpans = 262144] = "TemplateExpressionSpans", n[n.SingleLineBlockStatements = 768] = "SingleLineBlockStatements", n[n.MultiLineBlockStatements = 129] = "MultiLineBlockStatements", n[n.VariableDeclarationList = 528] = "VariableDeclarationList", n[n.SingleLineFunctionBodyStatements = 768] = "SingleLineFunctionBodyStatements", n[n.MultiLineFunctionBodyStatements = 1] = "MultiLineFunctionBodyStatements", n[n.ClassHeritageClauses = 0] = "ClassHeritageClauses", n[n.ClassMembers = 129] = "ClassMembers", n[n.InterfaceMembers = 129] = "InterfaceMembers", n[n.EnumMembers = 145] = "EnumMembers", n[n.CaseBlockClauses = 129] = "CaseBlockClauses", n[n.NamedImportsOrExportsElements = 525136] = "NamedImportsOrExportsElements", n[n.JsxElementOrFragmentChildren = 262144] = "JsxElementOrFragmentChildren", n[n.JsxElementAttributes = 262656] = "JsxElementAttributes", n[n.CaseOrDefaultClauseStatements = 163969] = "CaseOrDefaultClauseStatements", n[n.HeritageClauseTypes = 528] = "HeritageClauseTypes", n[n.SourceFileStatements = 131073] = "SourceFileStatements", n[n.Decorators = 2146305] = "Decorators", n[n.TypeArguments = 53776] = "TypeArguments", n[n.TypeParameters = 53776] = "TypeParameters", n[n.Parameters = 2576] = "Parameters", n[n.IndexSignatureParameters = 8848] = "IndexSignatureParameters", n[n.JSDocComment = 33] = "JSDocComment";
            })(Er = e2.ListFormat || (e2.ListFormat = {}));
            var Ne;
            (function(n) {
              n[n.None = 0] = "None", n[n.TripleSlashXML = 1] = "TripleSlashXML", n[n.SingleLine = 2] = "SingleLine", n[n.MultiLine = 4] = "MultiLine", n[n.All = 7] = "All", n[n.Default = 7] = "Default";
            })(Ne = e2.PragmaKindFlags || (e2.PragmaKindFlags = {})), e2.commentPragmas = { reference: { args: [{ name: "types", optional: true, captureSpan: true }, { name: "lib", optional: true, captureSpan: true }, { name: "path", optional: true, captureSpan: true }, { name: "no-default-lib", optional: true }, { name: "resolution-mode", optional: true }], kind: 1 }, "amd-dependency": { args: [{ name: "path" }, { name: "name", optional: true }], kind: 1 }, "amd-module": { args: [{ name: "name" }], kind: 1 }, "ts-check": { kind: 2 }, "ts-nocheck": { kind: 2 }, jsx: { args: [{ name: "factory" }], kind: 4 }, jsxfrag: { args: [{ name: "factory" }], kind: 4 }, jsximportsource: { args: [{ name: "factory" }], kind: 4 }, jsxruntime: { args: [{ name: "factory" }], kind: 4 } };
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(A2) {
              for (var y = 5381, V = 0; V < A2.length; V++)
                y = (y << 5) + y + A2.charCodeAt(V);
              return y.toString();
            }
            e2.generateDjb2Hash = a;
            function C() {
              Error.stackTraceLimit < 100 && (Error.stackTraceLimit = 100);
            }
            e2.setStackTraceLimit = C;
            var w;
            (function(A2) {
              A2[A2.Created = 0] = "Created", A2[A2.Changed = 1] = "Changed", A2[A2.Deleted = 2] = "Deleted";
            })(w = e2.FileWatcherEventKind || (e2.FileWatcherEventKind = {}));
            var B;
            (function(A2) {
              A2[A2.High = 2e3] = "High", A2[A2.Medium = 500] = "Medium", A2[A2.Low = 250] = "Low";
            })(B = e2.PollingInterval || (e2.PollingInterval = {})), e2.missingFileModifiedTime = new Date(0);
            function E(A2, y) {
              return A2.getModifiedTime(y) || e2.missingFileModifiedTime;
            }
            e2.getModifiedTime = E;
            function Q(A2) {
              var y;
              return y = {}, y[B.Low] = A2.Low, y[B.Medium] = A2.Medium, y[B.High] = A2.High, y;
            }
            var le = { Low: 32, Medium: 64, High: 256 }, N = Q(le);
            e2.unchangedPollThresholds = Q(le);
            function p(A2) {
              if (!A2.getEnvironmentVariable)
                return;
              var y = P("TSC_WATCH_POLLINGINTERVAL", B);
              N = k("TSC_WATCH_POLLINGCHUNKSIZE", le) || N, e2.unchangedPollThresholds = k("TSC_WATCH_UNCHANGEDPOLLTHRESHOLDS", le) || e2.unchangedPollThresholds;
              function V(Y, U) {
                return A2.getEnvironmentVariable("".concat(Y, "_").concat(U.toUpperCase()));
              }
              function L(Y) {
                var U;
                return j("Low"), j("Medium"), j("High"), U;
                function j(H) {
                  var I = V(Y, H);
                  I && ((U || (U = {}))[H] = Number(I));
                }
              }
              function P(Y, U) {
                var j = L(Y);
                if (j)
                  return H("Low"), H("Medium"), H("High"), true;
                return false;
                function H(I) {
                  U[I] = j[I] || U[I];
                }
              }
              function k(Y, U) {
                var j = L(Y);
                return (y || j) && Q(j ? Ke(Ke({}, U), j) : U);
              }
            }
            e2.setCustomPollingValues = p;
            function m2(A2, y, V, L, P) {
              for (var k = V, Y = y.length; L && Y; H(), Y--) {
                var U = y[V];
                if (U) {
                  if (U.isClosed) {
                    y[V] = void 0;
                    continue;
                  }
                } else
                  continue;
                L--;
                var j = K(U, E(A2, U.fileName));
                if (U.isClosed) {
                  y[V] = void 0;
                  continue;
                }
                P == null || P(U, V, j), y[V] && (k < V && (y[k] = U, y[V] = void 0), k++);
              }
              return V;
              function H() {
                V++, V === y.length && (k < V && (y.length = k), V = 0, k = 0);
              }
            }
            function G(A2) {
              var y = [], V = [], L = U(B.Low), P = U(B.Medium), k = U(B.High);
              return Y;
              function Y(ne, ue, We) {
                var Fe = { fileName: ne, callback: ue, unchangedPolls: 0, mtime: E(A2, ne) };
                return y.push(Fe), d(Fe, We), { close: function() {
                  Fe.isClosed = true, e2.unorderedRemoveItem(y, Fe);
                } };
              }
              function U(ne) {
                var ue = [];
                return ue.pollingInterval = ne, ue.pollIndex = 0, ue.pollScheduled = false, ue;
              }
              function j(ne) {
                ne.pollIndex = I(ne, ne.pollingInterval, ne.pollIndex, N[ne.pollingInterval]), ne.length ? g(ne.pollingInterval) : (e2.Debug.assert(ne.pollIndex === 0), ne.pollScheduled = false);
              }
              function H(ne) {
                I(V, B.Low, 0, V.length), j(ne), !ne.pollScheduled && V.length && g(B.Low);
              }
              function I(ne, ue, We, Fe) {
                return m2(A2, ne, We, Fe, Z2);
                function Z2(Be, ge, Re) {
                  Re ? (Be.unchangedPolls = 0, ne !== V && (ne[ge] = void 0, D(Be))) : Be.unchangedPolls !== e2.unchangedPollThresholds[ue] ? Be.unchangedPolls++ : ne === V ? (Be.unchangedPolls = 1, ne[ge] = void 0, d(Be, B.Low)) : ue !== B.High && (Be.unchangedPolls++, ne[ge] = void 0, d(Be, ue === B.Low ? B.Medium : B.High));
                }
              }
              function l(ne) {
                switch (ne) {
                  case B.Low:
                    return L;
                  case B.Medium:
                    return P;
                  case B.High:
                    return k;
                }
              }
              function d(ne, ue) {
                l(ue).push(ne), fe(ue);
              }
              function D(ne) {
                V.push(ne), fe(B.Low);
              }
              function fe(ne) {
                l(ne).pollScheduled || g(ne);
              }
              function g(ne) {
                l(ne).pollScheduled = A2.setTimeout(ne === B.Low ? H : j, ne, l(ne));
              }
            }
            e2.createDynamicPriorityPollingWatchFile = G;
            function oe(A2, y) {
              var V = e2.createMultiMap(), L = new e2.Map(), P = e2.createGetCanonicalFileName(y);
              return k;
              function k(U, j, H, I) {
                var l = P(U);
                V.add(l, j);
                var d = e2.getDirectoryPath(l) || ".", D = L.get(d) || Y(e2.getDirectoryPath(U) || ".", d, I);
                return D.referenceCount++, { close: function() {
                  D.referenceCount === 1 ? (D.close(), L.delete(d)) : D.referenceCount--, V.remove(l, j);
                } };
              }
              function Y(U, j, H) {
                var I = A2(U, 1, function(l, d) {
                  if (!!e2.isString(d)) {
                    var D = e2.getNormalizedAbsolutePath(d, U), fe = D && V.get(P(D));
                    if (fe)
                      for (var g = 0, ne = fe; g < ne.length; g++) {
                        var ue = ne[g];
                        ue(D, w.Changed);
                      }
                  }
                }, false, B.Medium, H);
                return I.referenceCount = 0, L.set(j, I), I;
              }
            }
            function f4(A2) {
              var y = [], V = 0, L;
              return P;
              function P(U, j) {
                var H = { fileName: U, callback: j, mtime: E(A2, U) };
                return y.push(H), Y(), { close: function() {
                  H.isClosed = true, e2.unorderedRemoveItem(y, H);
                } };
              }
              function k() {
                L = void 0, V = m2(A2, y, V, N[B.Low]), Y();
              }
              function Y() {
                !y.length || L || (L = A2.setTimeout(k, B.High));
              }
            }
            function T(A2, y) {
              var V = new e2.Map(), L = e2.createMultiMap(), P = e2.createGetCanonicalFileName(y);
              return function(k, Y, U, j) {
                var H = P(k), I = V.get(H);
                return I ? I.refCount++ : V.set(H, { watcher: A2(k, function(l, d) {
                  return e2.forEach(L.get(H), function(D) {
                    return D(l, d);
                  });
                }, U, j), refCount: 1 }), L.add(H, Y), { close: function() {
                  var l = e2.Debug.checkDefined(V.get(H));
                  L.remove(H, Y), l.refCount--, !l.refCount && (V.delete(H), e2.closeFileWatcherOf(l));
                } };
              };
            }
            e2.createSingleFileWatcherPerName = T;
            function K(A2, y) {
              var V = A2.mtime.getTime(), L = y.getTime();
              return V !== L ? (A2.mtime = y, A2.callback(A2.fileName, b(V, L)), true) : false;
            }
            e2.onWatchedFileStat = K;
            function b(A2, y) {
              return A2 === 0 ? w.Created : y === 0 ? w.Deleted : w.Changed;
            }
            e2.getFileWatcherEventKind = b, e2.ignoredPaths = ["/node_modules/.", "/.git", "/.#"];
            var se = e2.noop;
            function J(A2) {
              return se(A2);
            }
            e2.sysLog = J;
            function ie(A2) {
              se = A2;
            }
            e2.setSysLog = ie;
            function R(A2) {
              var y = A2.watchDirectory, V = A2.useCaseSensitiveFileNames, L = A2.getCurrentDirectory, P = A2.getAccessibleSortedChildDirectories, k = A2.directoryExists, Y = A2.realpath, U = A2.setTimeout, j = A2.clearTimeout, H = new e2.Map(), I = e2.createMultiMap(), l = new e2.Map(), d, D = e2.getStringComparer(!V), fe = e2.createGetCanonicalFileName(V);
              return function(ze, Ee, He, rr) {
                return He ? g(ze, rr, Ee) : y(ze, Ee, He, rr);
              };
              function g(ze, Ee, He) {
                var rr = fe(ze), Ie = H.get(rr);
                Ie ? Ie.refCount++ : (Ie = { watcher: y(ze, function(we) {
                  ge(we, Ee) || (Ee != null && Ee.synchronousWatchDirectory ? (ne(rr, we), Be(ze, rr, Ee)) : ue(ze, rr, we, Ee));
                }, false, Ee), refCount: 1, childWatches: e2.emptyArray }, H.set(rr, Ie), Be(ze, rr, Ee));
                var _e = He && { dirName: ze, callback: He };
                return _e && I.add(rr, _e), { dirName: ze, close: function() {
                  var we = e2.Debug.checkDefined(H.get(rr));
                  _e && I.remove(rr, _e), we.refCount--, !we.refCount && (H.delete(rr), e2.closeFileWatcherOf(we), we.childWatches.forEach(e2.closeFileWatcher));
                } };
              }
              function ne(ze, Ee, He) {
                var rr, Ie;
                e2.isString(Ee) ? rr = Ee : Ie = Ee, I.forEach(function(_e, we) {
                  var de;
                  if (!(Ie && Ie.get(we) === true) && (we === ze || e2.startsWith(ze, we) && ze[we.length] === e2.directorySeparator))
                    if (Ie)
                      if (He) {
                        var ye = Ie.get(we);
                        ye ? (de = ye).push.apply(de, He) : Ie.set(we, He.slice());
                      } else
                        Ie.set(we, true);
                    else
                      _e.forEach(function(Ae) {
                        var er = Ae.callback;
                        return er(rr);
                      });
                });
              }
              function ue(ze, Ee, He, rr) {
                var Ie = H.get(Ee);
                if (Ie && k(ze)) {
                  We(ze, Ee, He, rr);
                  return;
                }
                ne(Ee, He), Z2(Ie);
              }
              function We(ze, Ee, He, rr) {
                var Ie = l.get(Ee);
                Ie ? Ie.fileNames.push(He) : l.set(Ee, { dirName: ze, options: rr, fileNames: [He] }), d && (j(d), d = void 0), d = U(Fe, 1e3);
              }
              function Fe() {
                d = void 0, J("sysLog:: onTimerToUpdateChildWatches:: ".concat(l.size));
                for (var ze = e2.timestamp(), Ee = new e2.Map(); !d && l.size; ) {
                  var He = l.entries().next();
                  e2.Debug.assert(!He.done);
                  var rr = He.value, Ie = rr[0], _e = rr[1], we = _e.dirName, de = _e.options, ye = _e.fileNames;
                  l.delete(Ie);
                  var Ae = Be(we, Ie, de);
                  ne(Ie, Ee, Ae ? void 0 : ye);
                }
                J("sysLog:: invokingWatchers:: Elapsed:: ".concat(e2.timestamp() - ze, "ms:: ").concat(l.size)), I.forEach(function(ir, Cr) {
                  var Ye = Ee.get(Cr);
                  Ye && ir.forEach(function(Br) {
                    var Er = Br.callback, Ne = Br.dirName;
                    e2.isArray(Ye) ? Ye.forEach(Er) : Er(Ne);
                  });
                });
                var er = e2.timestamp() - ze;
                J("sysLog:: Elapsed:: ".concat(er, "ms:: onTimerToUpdateChildWatches:: ").concat(l.size, " ").concat(d));
              }
              function Z2(ze) {
                if (!!ze) {
                  var Ee = ze.childWatches;
                  ze.childWatches = e2.emptyArray;
                  for (var He = 0, rr = Ee; He < rr.length; He++) {
                    var Ie = rr[He];
                    Ie.close(), Z2(H.get(fe(Ie.dirName)));
                  }
                }
              }
              function Be(ze, Ee, He) {
                var rr = H.get(Ee);
                if (!rr)
                  return false;
                var Ie, _e = e2.enumerateInsertsAndDeletes(k(ze) ? e2.mapDefined(P(ze), function(ye) {
                  var Ae = e2.getNormalizedAbsolutePath(ye, ze);
                  return !ge(Ae, He) && D(Ae, e2.normalizePath(Y(Ae))) === 0 ? Ae : void 0;
                }) : e2.emptyArray, rr.childWatches, function(ye, Ae) {
                  return D(ye, Ae.dirName);
                }, we, e2.closeFileWatcher, de);
                return rr.childWatches = Ie || e2.emptyArray, _e;
                function we(ye) {
                  var Ae = g(ye, He);
                  de(Ae);
                }
                function de(ye) {
                  (Ie || (Ie = [])).push(ye);
                }
              }
              function ge(ze, Ee) {
                return e2.some(e2.ignoredPaths, function(He) {
                  return Re(ze, He);
                }) || ee(ze, Ee, V, L);
              }
              function Re(ze, Ee) {
                return e2.stringContains(ze, Ee) ? true : V ? false : e2.stringContains(fe(ze), Ee);
              }
            }
            e2.createDirectoryWatcherSupportingRecursive = R;
            var q;
            (function(A2) {
              A2[A2.File = 0] = "File", A2[A2.Directory = 1] = "Directory";
            })(q = e2.FileSystemEntryKind || (e2.FileSystemEntryKind = {}));
            function O(A2) {
              return function(y, V) {
                return A2(V === w.Changed ? "change" : "rename", "");
              };
            }
            e2.createFileWatcherCallback = O;
            function ve(A2, y, V) {
              return function(L) {
                L === "rename" ? y(A2, V(A2) ? w.Created : w.Deleted) : y(A2, w.Changed);
              };
            }
            function ee(A2, y, V, L) {
              return ((y == null ? void 0 : y.excludeDirectories) || (y == null ? void 0 : y.excludeFiles)) && (e2.matchesExclude(A2, y == null ? void 0 : y.excludeFiles, V, L()) || e2.matchesExclude(A2, y == null ? void 0 : y.excludeDirectories, V, L()));
            }
            function he(A2, y, V, L, P) {
              return function(k, Y) {
                if (k === "rename") {
                  var U = Y ? e2.normalizePath(e2.combinePaths(A2, Y)) : A2;
                  (!Y || !ee(U, V, L, P)) && y(U);
                }
              };
            }
            function F2(A2) {
              var y = A2.pollingWatchFile, V = A2.getModifiedTime, L = A2.setTimeout, P = A2.clearTimeout, k = A2.fsWatch, Y = A2.fileExists, U = A2.useCaseSensitiveFileNames, j = A2.getCurrentDirectory, H = A2.fsSupportsRecursiveFsWatch, I = A2.directoryExists, l = A2.getAccessibleSortedChildDirectories, d = A2.realpath, D = A2.tscWatchFile, fe = A2.useNonPollingWatchers, g = A2.tscWatchDirectory, ne = A2.defaultWatchFileKind, ue, We, Fe, Z2;
              return { watchFile: Be, watchDirectory: He };
              function Be(_e, we, de, ye) {
                ye = ze(ye, fe);
                var Ae = e2.Debug.checkDefined(ye.watchFile);
                switch (Ae) {
                  case e2.WatchFileKind.FixedPollingInterval:
                    return y(_e, we, B.Low, void 0);
                  case e2.WatchFileKind.PriorityPollingInterval:
                    return y(_e, we, de, void 0);
                  case e2.WatchFileKind.DynamicPriorityPolling:
                    return ge()(_e, we, de, void 0);
                  case e2.WatchFileKind.FixedChunkSizePolling:
                    return Re()(_e, we, void 0, void 0);
                  case e2.WatchFileKind.UseFsEvents:
                    return k(_e, 0, ve(_e, we, Y), false, de, e2.getFallbackOptions(ye));
                  case e2.WatchFileKind.UseFsEventsOnParentDirectory:
                    return Fe || (Fe = oe(k, U)), Fe(_e, we, de, e2.getFallbackOptions(ye));
                  default:
                    e2.Debug.assertNever(Ae);
                }
              }
              function ge() {
                return ue || (ue = G({ getModifiedTime: V, setTimeout: L }));
              }
              function Re() {
                return We || (We = f4({ getModifiedTime: V, setTimeout: L }));
              }
              function ze(_e, we) {
                if (_e && _e.watchFile !== void 0)
                  return _e;
                switch (D) {
                  case "PriorityPollingInterval":
                    return { watchFile: e2.WatchFileKind.PriorityPollingInterval };
                  case "DynamicPriorityPolling":
                    return { watchFile: e2.WatchFileKind.DynamicPriorityPolling };
                  case "UseFsEvents":
                    return Ee(e2.WatchFileKind.UseFsEvents, e2.PollingWatchKind.PriorityInterval, _e);
                  case "UseFsEventsWithFallbackDynamicPolling":
                    return Ee(e2.WatchFileKind.UseFsEvents, e2.PollingWatchKind.DynamicPriority, _e);
                  case "UseFsEventsOnParentDirectory":
                    we = true;
                  default:
                    return we ? Ee(e2.WatchFileKind.UseFsEventsOnParentDirectory, e2.PollingWatchKind.PriorityInterval, _e) : { watchFile: (ne == null ? void 0 : ne()) || e2.WatchFileKind.FixedPollingInterval };
                }
              }
              function Ee(_e, we, de) {
                var ye = de == null ? void 0 : de.fallbackPolling;
                return { watchFile: _e, fallbackPolling: ye === void 0 ? we : ye };
              }
              function He(_e, we, de, ye) {
                return H ? k(_e, 1, he(_e, we, ye, U, j), de, B.Medium, e2.getFallbackOptions(ye)) : (Z2 || (Z2 = R({ useCaseSensitiveFileNames: U, getCurrentDirectory: j, directoryExists: I, getAccessibleSortedChildDirectories: l, watchDirectory: rr, realpath: d, setTimeout: L, clearTimeout: P })), Z2(_e, we, de, ye));
              }
              function rr(_e, we, de, ye) {
                e2.Debug.assert(!de);
                var Ae = Ie(ye), er = e2.Debug.checkDefined(Ae.watchDirectory);
                switch (er) {
                  case e2.WatchDirectoryKind.FixedPollingInterval:
                    return y(_e, function() {
                      return we(_e);
                    }, B.Medium, void 0);
                  case e2.WatchDirectoryKind.DynamicPriorityPolling:
                    return ge()(_e, function() {
                      return we(_e);
                    }, B.Medium, void 0);
                  case e2.WatchDirectoryKind.FixedChunkSizePolling:
                    return Re()(_e, function() {
                      return we(_e);
                    }, void 0, void 0);
                  case e2.WatchDirectoryKind.UseFsEvents:
                    return k(_e, 1, he(_e, we, ye, U, j), de, B.Medium, e2.getFallbackOptions(Ae));
                  default:
                    e2.Debug.assertNever(er);
                }
              }
              function Ie(_e) {
                if (_e && _e.watchDirectory !== void 0)
                  return _e;
                switch (g) {
                  case "RecursiveDirectoryUsingFsWatchFile":
                    return { watchDirectory: e2.WatchDirectoryKind.FixedPollingInterval };
                  case "RecursiveDirectoryUsingDynamicPriorityPolling":
                    return { watchDirectory: e2.WatchDirectoryKind.DynamicPriorityPolling };
                  default:
                    var we = _e == null ? void 0 : _e.fallbackPolling;
                    return { watchDirectory: e2.WatchDirectoryKind.UseFsEvents, fallbackPolling: we !== void 0 ? we : void 0 };
                }
              }
            }
            e2.createSystemWatchFunctions = F2;
            function x2(A2) {
              var y = A2.writeFile;
              A2.writeFile = function(V, L, P) {
                return e2.writeFileEnsuringDirectories(V, L, !!P, function(k, Y, U) {
                  return y.call(A2, k, Y, U);
                }, function(k) {
                  return A2.createDirectory(k);
                }, function(k) {
                  return A2.directoryExists(k);
                });
              };
            }
            e2.patchWriteFileEnsuringDirectory = x2;
            function X() {
              if (!(typeof Eu > "u")) {
                var A2 = Eu.version;
                if (!!A2) {
                  var y = A2.indexOf(".");
                  if (y !== -1)
                    return parseInt(A2.substring(1, y));
                }
              }
            }
            e2.getNodeMajorVersion = X, e2.sys = void 0;
            function $(A2) {
              e2.sys = void 0;
            }
            e2.setSys = $, e2.sys && e2.sys.getEnvironmentVariable && (p(e2.sys), e2.Debug.setAssertionLevel(/^development$/i.test(e2.sys.getEnvironmentVariable("NODE_ENV")) ? 1 : 0)), e2.sys && e2.sys.debugMode && (e2.Debug.isDebugging = true);
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            e2.directorySeparator = "/", e2.altDirectorySeparator = "\\";
            var a = "://", C = /\\/g;
            function w(ze) {
              return ze === 47 || ze === 92;
            }
            e2.isAnyDirectorySeparator = w;
            function B(ze) {
              return b(ze) < 0;
            }
            e2.isUrl = B;
            function E(ze) {
              return b(ze) > 0;
            }
            e2.isRootedDiskPath = E;
            function Q(ze) {
              var Ee = b(ze);
              return Ee > 0 && Ee === ze.length;
            }
            e2.isDiskPathRoot = Q;
            function le(ze) {
              return b(ze) !== 0;
            }
            e2.pathIsAbsolute = le;
            function N(ze) {
              return /^\.\.?($|[\\/])/.test(ze);
            }
            e2.pathIsRelative = N;
            function p(ze) {
              return !le(ze) && !N(ze);
            }
            e2.pathIsBareSpecifier = p;
            function m2(ze) {
              return e2.stringContains(ie(ze), ".");
            }
            e2.hasExtension = m2;
            function G(ze, Ee) {
              return ze.length > Ee.length && e2.endsWith(ze, Ee);
            }
            e2.fileExtensionIs = G;
            function oe(ze, Ee) {
              for (var He = 0, rr = Ee; He < rr.length; He++) {
                var Ie = rr[He];
                if (G(ze, Ie))
                  return true;
              }
              return false;
            }
            e2.fileExtensionIsOneOf = oe;
            function f4(ze) {
              return ze.length > 0 && w(ze.charCodeAt(ze.length - 1));
            }
            e2.hasTrailingDirectorySeparator = f4;
            function T(ze) {
              return ze >= 97 && ze <= 122 || ze >= 65 && ze <= 90;
            }
            function K(ze, Ee) {
              var He = ze.charCodeAt(Ee);
              if (He === 58)
                return Ee + 1;
              if (He === 37 && ze.charCodeAt(Ee + 1) === 51) {
                var rr = ze.charCodeAt(Ee + 2);
                if (rr === 97 || rr === 65)
                  return Ee + 3;
              }
              return -1;
            }
            function b(ze) {
              if (!ze)
                return 0;
              var Ee = ze.charCodeAt(0);
              if (Ee === 47 || Ee === 92) {
                if (ze.charCodeAt(1) !== Ee)
                  return 1;
                var He = ze.indexOf(Ee === 47 ? e2.directorySeparator : e2.altDirectorySeparator, 2);
                return He < 0 ? ze.length : He + 1;
              }
              if (T(Ee) && ze.charCodeAt(1) === 58) {
                var rr = ze.charCodeAt(2);
                if (rr === 47 || rr === 92)
                  return 3;
                if (ze.length === 2)
                  return 2;
              }
              var Ie = ze.indexOf(a);
              if (Ie !== -1) {
                var _e = Ie + a.length, we = ze.indexOf(e2.directorySeparator, _e);
                if (we !== -1) {
                  var de = ze.slice(0, Ie), ye = ze.slice(_e, we);
                  if (de === "file" && (ye === "" || ye === "localhost") && T(ze.charCodeAt(we + 1))) {
                    var Ae = K(ze, we + 2);
                    if (Ae !== -1) {
                      if (ze.charCodeAt(Ae) === 47)
                        return ~(Ae + 1);
                      if (Ae === ze.length)
                        return ~Ae;
                    }
                  }
                  return ~(we + 1);
                }
                return ~ze.length;
              }
              return 0;
            }
            function se(ze) {
              var Ee = b(ze);
              return Ee < 0 ? ~Ee : Ee;
            }
            e2.getRootLength = se;
            function J(ze) {
              ze = F2(ze);
              var Ee = se(ze);
              return Ee === ze.length ? ze : (ze = Y(ze), ze.slice(0, Math.max(Ee, ze.lastIndexOf(e2.directorySeparator))));
            }
            e2.getDirectoryPath = J;
            function ie(ze, Ee, He) {
              ze = F2(ze);
              var rr = se(ze);
              if (rr === ze.length)
                return "";
              ze = Y(ze);
              var Ie = ze.slice(Math.max(se(ze), ze.lastIndexOf(e2.directorySeparator) + 1)), _e = Ee !== void 0 && He !== void 0 ? O(Ie, Ee, He) : void 0;
              return _e ? Ie.slice(0, Ie.length - _e.length) : Ie;
            }
            e2.getBaseFileName = ie;
            function R(ze, Ee, He) {
              if (e2.startsWith(Ee, ".") || (Ee = "." + Ee), ze.length >= Ee.length && ze.charCodeAt(ze.length - Ee.length) === 46) {
                var rr = ze.slice(ze.length - Ee.length);
                if (He(rr, Ee))
                  return rr;
              }
            }
            function q(ze, Ee, He) {
              if (typeof Ee == "string")
                return R(ze, Ee, He) || "";
              for (var rr = 0, Ie = Ee; rr < Ie.length; rr++) {
                var _e = Ie[rr], we = R(ze, _e, He);
                if (we)
                  return we;
              }
              return "";
            }
            function O(ze, Ee, He) {
              if (Ee)
                return q(Y(ze), Ee, He ? e2.equateStringsCaseInsensitive : e2.equateStringsCaseSensitive);
              var rr = ie(ze), Ie = rr.lastIndexOf(".");
              return Ie >= 0 ? rr.substring(Ie) : "";
            }
            e2.getAnyExtensionFromPath = O;
            function ve(ze, Ee) {
              var He = ze.substring(0, Ee), rr = ze.substring(Ee).split(e2.directorySeparator);
              return rr.length && !e2.lastOrUndefined(rr) && rr.pop(), Ve([He], rr, true);
            }
            function ee(ze, Ee) {
              return Ee === void 0 && (Ee = ""), ze = X(Ee, ze), ve(ze, se(ze));
            }
            e2.getPathComponents = ee;
            function he(ze) {
              if (ze.length === 0)
                return "";
              var Ee = ze[0] && U(ze[0]);
              return Ee + ze.slice(1).join(e2.directorySeparator);
            }
            e2.getPathFromPathComponents = he;
            function F2(ze) {
              var Ee = ze.indexOf("\\");
              return Ee === -1 ? ze : (C.lastIndex = Ee, ze.replace(C, e2.directorySeparator));
            }
            e2.normalizeSlashes = F2;
            function x2(ze) {
              if (!e2.some(ze))
                return [];
              for (var Ee = [ze[0]], He = 1; He < ze.length; He++) {
                var rr = ze[He];
                if (!!rr && rr !== ".") {
                  if (rr === "..") {
                    if (Ee.length > 1) {
                      if (Ee[Ee.length - 1] !== "..") {
                        Ee.pop();
                        continue;
                      }
                    } else if (Ee[0])
                      continue;
                  }
                  Ee.push(rr);
                }
              }
              return Ee;
            }
            e2.reducePathComponents = x2;
            function X(ze) {
              for (var Ee = [], He = 1; He < arguments.length; He++)
                Ee[He - 1] = arguments[He];
              ze && (ze = F2(ze));
              for (var rr = 0, Ie = Ee; rr < Ie.length; rr++) {
                var _e = Ie[rr];
                !_e || (_e = F2(_e), !ze || se(_e) !== 0 ? ze = _e : ze = U(ze) + _e);
              }
              return ze;
            }
            e2.combinePaths = X;
            function $(ze) {
              for (var Ee = [], He = 1; He < arguments.length; He++)
                Ee[He - 1] = arguments[He];
              return V(e2.some(Ee) ? X.apply(void 0, Ve([ze], Ee, false)) : F2(ze));
            }
            e2.resolvePath = $;
            function A2(ze, Ee) {
              return x2(ee(ze, Ee));
            }
            e2.getNormalizedPathComponents = A2;
            function y(ze, Ee) {
              return he(A2(ze, Ee));
            }
            e2.getNormalizedAbsolutePath = y;
            function V(ze) {
              if (ze = F2(ze), !I.test(ze))
                return ze;
              var Ee = ze.replace(/\/\.\//g, "/").replace(/^\.\//, "");
              if (Ee !== ze && (ze = Ee, !I.test(ze)))
                return ze;
              var He = he(x2(ee(ze)));
              return He && f4(ze) ? U(He) : He;
            }
            e2.normalizePath = V;
            function L(ze) {
              return ze.length === 0 ? "" : ze.slice(1).join(e2.directorySeparator);
            }
            function P(ze, Ee) {
              return L(A2(ze, Ee));
            }
            e2.getNormalizedAbsolutePathWithoutRoot = P;
            function k(ze, Ee, He) {
              var rr = E(ze) ? V(ze) : y(ze, Ee);
              return He(rr);
            }
            e2.toPath = k;
            function Y(ze) {
              return f4(ze) ? ze.substr(0, ze.length - 1) : ze;
            }
            e2.removeTrailingDirectorySeparator = Y;
            function U(ze) {
              return f4(ze) ? ze : ze + e2.directorySeparator;
            }
            e2.ensureTrailingDirectorySeparator = U;
            function j(ze) {
              return !le(ze) && !N(ze) ? "./" + ze : ze;
            }
            e2.ensurePathIsNonModuleName = j;
            function H(ze, Ee, He, rr) {
              var Ie = He !== void 0 && rr !== void 0 ? O(ze, He, rr) : O(ze);
              return Ie ? ze.slice(0, ze.length - Ie.length) + (e2.startsWith(Ee, ".") ? Ee : "." + Ee) : ze;
            }
            e2.changeAnyExtension = H;
            var I = /(?:\/\/)|(?:^|\/)\.\.?(?:$|\/)/;
            function l(ze, Ee, He) {
              if (ze === Ee)
                return 0;
              if (ze === void 0)
                return -1;
              if (Ee === void 0)
                return 1;
              var rr = ze.substring(0, se(ze)), Ie = Ee.substring(0, se(Ee)), _e = e2.compareStringsCaseInsensitive(rr, Ie);
              if (_e !== 0)
                return _e;
              var we = ze.substring(rr.length), de = Ee.substring(Ie.length);
              if (!I.test(we) && !I.test(de))
                return He(we, de);
              for (var ye = x2(ee(ze)), Ae = x2(ee(Ee)), er = Math.min(ye.length, Ae.length), ir = 1; ir < er; ir++) {
                var Cr = He(ye[ir], Ae[ir]);
                if (Cr !== 0)
                  return Cr;
              }
              return e2.compareValues(ye.length, Ae.length);
            }
            function d(ze, Ee) {
              return l(ze, Ee, e2.compareStringsCaseSensitive);
            }
            e2.comparePathsCaseSensitive = d;
            function D(ze, Ee) {
              return l(ze, Ee, e2.compareStringsCaseInsensitive);
            }
            e2.comparePathsCaseInsensitive = D;
            function fe(ze, Ee, He, rr) {
              return typeof He == "string" ? (ze = X(He, ze), Ee = X(He, Ee)) : typeof He == "boolean" && (rr = He), l(ze, Ee, e2.getStringComparer(rr));
            }
            e2.comparePaths = fe;
            function g(ze, Ee, He, rr) {
              if (typeof He == "string" ? (ze = X(He, ze), Ee = X(He, Ee)) : typeof He == "boolean" && (rr = He), ze === void 0 || Ee === void 0)
                return false;
              if (ze === Ee)
                return true;
              var Ie = x2(ee(ze)), _e = x2(ee(Ee));
              if (_e.length < Ie.length)
                return false;
              for (var we = rr ? e2.equateStringsCaseInsensitive : e2.equateStringsCaseSensitive, de = 0; de < Ie.length; de++) {
                var ye = de === 0 ? e2.equateStringsCaseInsensitive : we;
                if (!ye(Ie[de], _e[de]))
                  return false;
              }
              return true;
            }
            e2.containsPath = g;
            function ne(ze, Ee, He) {
              var rr = He(ze), Ie = He(Ee);
              return e2.startsWith(rr, Ie + "/") || e2.startsWith(rr, Ie + "\\");
            }
            e2.startsWithDirectory = ne;
            function ue(ze, Ee, He, rr) {
              var Ie = x2(ee(ze)), _e = x2(ee(Ee)), we;
              for (we = 0; we < Ie.length && we < _e.length; we++) {
                var de = rr(Ie[we]), ye = rr(_e[we]), Ae = we === 0 ? e2.equateStringsCaseInsensitive : He;
                if (!Ae(de, ye))
                  break;
              }
              if (we === 0)
                return _e;
              for (var er = _e.slice(we), ir = []; we < Ie.length; we++)
                ir.push("..");
              return Ve(Ve([""], ir, true), er, true);
            }
            e2.getPathComponentsRelativeTo = ue;
            function We(ze, Ee, He) {
              e2.Debug.assert(se(ze) > 0 == se(Ee) > 0, "Paths must either both be absolute or both be relative");
              var rr = typeof He == "function" ? He : e2.identity, Ie = typeof He == "boolean" ? He : false, _e = ue(ze, Ee, Ie ? e2.equateStringsCaseInsensitive : e2.equateStringsCaseSensitive, rr);
              return he(_e);
            }
            e2.getRelativePathFromDirectory = We;
            function Fe(ze, Ee, He) {
              return E(ze) ? Be(Ee, ze, Ee, He, false) : ze;
            }
            e2.convertToRelativePath = Fe;
            function Z2(ze, Ee, He) {
              return j(We(J(ze), Ee, He));
            }
            e2.getRelativePathFromFile = Z2;
            function Be(ze, Ee, He, rr, Ie) {
              var _e = ue($(He, ze), $(He, Ee), e2.equateStringsCaseSensitive, rr), we = _e[0];
              if (Ie && E(we)) {
                var de = we.charAt(0) === e2.directorySeparator ? "file://" : "file:///";
                _e[0] = de + we;
              }
              return he(_e);
            }
            e2.getRelativePathToDirectoryOrUrl = Be;
            function ge(ze, Ee) {
              for (; ; ) {
                var He = Ee(ze);
                if (He !== void 0)
                  return He;
                var rr = J(ze);
                if (rr === ze)
                  return;
                ze = rr;
              }
            }
            e2.forEachAncestorDirectory = ge;
            function Re(ze) {
              return e2.endsWith(ze, "/node_modules");
            }
            e2.isNodeModulesDirectory = Re;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C, w, B, E, Q, le, N) {
              return { code: C, category: w, key: B, message: E, reportsUnnecessary: Q, elidedInCompatabilityPyramid: le, reportsDeprecated: N };
            }
            e2.Diagnostics = { Unterminated_string_literal: a(1002, e2.DiagnosticCategory.Error, "Unterminated_string_literal_1002", "Unterminated string literal."), Identifier_expected: a(1003, e2.DiagnosticCategory.Error, "Identifier_expected_1003", "Identifier expected."), _0_expected: a(1005, e2.DiagnosticCategory.Error, "_0_expected_1005", "'{0}' expected."), A_file_cannot_have_a_reference_to_itself: a(1006, e2.DiagnosticCategory.Error, "A_file_cannot_have_a_reference_to_itself_1006", "A file cannot have a reference to itself."), The_parser_expected_to_find_a_1_to_match_the_0_token_here: a(1007, e2.DiagnosticCategory.Error, "The_parser_expected_to_find_a_1_to_match_the_0_token_here_1007", "The parser expected to find a '{1}' to match the '{0}' token here."), Trailing_comma_not_allowed: a(1009, e2.DiagnosticCategory.Error, "Trailing_comma_not_allowed_1009", "Trailing comma not allowed."), Asterisk_Slash_expected: a(1010, e2.DiagnosticCategory.Error, "Asterisk_Slash_expected_1010", "'*/' expected."), An_element_access_expression_should_take_an_argument: a(1011, e2.DiagnosticCategory.Error, "An_element_access_expression_should_take_an_argument_1011", "An element access expression should take an argument."), Unexpected_token: a(1012, e2.DiagnosticCategory.Error, "Unexpected_token_1012", "Unexpected token."), A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma: a(1013, e2.DiagnosticCategory.Error, "A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma_1013", "A rest parameter or binding pattern may not have a trailing comma."), A_rest_parameter_must_be_last_in_a_parameter_list: a(1014, e2.DiagnosticCategory.Error, "A_rest_parameter_must_be_last_in_a_parameter_list_1014", "A rest parameter must be last in a parameter list."), Parameter_cannot_have_question_mark_and_initializer: a(1015, e2.DiagnosticCategory.Error, "Parameter_cannot_have_question_mark_and_initializer_1015", "Parameter cannot have question mark and initializer."), A_required_parameter_cannot_follow_an_optional_parameter: a(1016, e2.DiagnosticCategory.Error, "A_required_parameter_cannot_follow_an_optional_parameter_1016", "A required parameter cannot follow an optional parameter."), An_index_signature_cannot_have_a_rest_parameter: a(1017, e2.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_rest_parameter_1017", "An index signature cannot have a rest parameter."), An_index_signature_parameter_cannot_have_an_accessibility_modifier: a(1018, e2.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_accessibility_modifier_1018", "An index signature parameter cannot have an accessibility modifier."), An_index_signature_parameter_cannot_have_a_question_mark: a(1019, e2.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_a_question_mark_1019", "An index signature parameter cannot have a question mark."), An_index_signature_parameter_cannot_have_an_initializer: a(1020, e2.DiagnosticCategory.Error, "An_index_signature_parameter_cannot_have_an_initializer_1020", "An index signature parameter cannot have an initializer."), An_index_signature_must_have_a_type_annotation: a(1021, e2.DiagnosticCategory.Error, "An_index_signature_must_have_a_type_annotation_1021", "An index signature must have a type annotation."), An_index_signature_parameter_must_have_a_type_annotation: a(1022, e2.DiagnosticCategory.Error, "An_index_signature_parameter_must_have_a_type_annotation_1022", "An index signature parameter must have a type annotation."), readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature: a(1024, e2.DiagnosticCategory.Error, "readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature_1024", "'readonly' modifier can only appear on a property declaration or index signature."), An_index_signature_cannot_have_a_trailing_comma: a(1025, e2.DiagnosticCategory.Error, "An_index_signature_cannot_have_a_trailing_comma_1025", "An index signature cannot have a trailing comma."), Accessibility_modifier_already_seen: a(1028, e2.DiagnosticCategory.Error, "Accessibility_modifier_already_seen_1028", "Accessibility modifier already seen."), _0_modifier_must_precede_1_modifier: a(1029, e2.DiagnosticCategory.Error, "_0_modifier_must_precede_1_modifier_1029", "'{0}' modifier must precede '{1}' modifier."), _0_modifier_already_seen: a(1030, e2.DiagnosticCategory.Error, "_0_modifier_already_seen_1030", "'{0}' modifier already seen."), _0_modifier_cannot_appear_on_class_elements_of_this_kind: a(1031, e2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_class_elements_of_this_kind_1031", "'{0}' modifier cannot appear on class elements of this kind."), super_must_be_followed_by_an_argument_list_or_member_access: a(1034, e2.DiagnosticCategory.Error, "super_must_be_followed_by_an_argument_list_or_member_access_1034", "'super' must be followed by an argument list or member access."), Only_ambient_modules_can_use_quoted_names: a(1035, e2.DiagnosticCategory.Error, "Only_ambient_modules_can_use_quoted_names_1035", "Only ambient modules can use quoted names."), Statements_are_not_allowed_in_ambient_contexts: a(1036, e2.DiagnosticCategory.Error, "Statements_are_not_allowed_in_ambient_contexts_1036", "Statements are not allowed in ambient contexts."), A_declare_modifier_cannot_be_used_in_an_already_ambient_context: a(1038, e2.DiagnosticCategory.Error, "A_declare_modifier_cannot_be_used_in_an_already_ambient_context_1038", "A 'declare' modifier cannot be used in an already ambient context."), Initializers_are_not_allowed_in_ambient_contexts: a(1039, e2.DiagnosticCategory.Error, "Initializers_are_not_allowed_in_ambient_contexts_1039", "Initializers are not allowed in ambient contexts."), _0_modifier_cannot_be_used_in_an_ambient_context: a(1040, e2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_in_an_ambient_context_1040", "'{0}' modifier cannot be used in an ambient context."), _0_modifier_cannot_be_used_here: a(1042, e2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_here_1042", "'{0}' modifier cannot be used here."), _0_modifier_cannot_appear_on_a_module_or_namespace_element: a(1044, e2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_module_or_namespace_element_1044", "'{0}' modifier cannot appear on a module or namespace element."), Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier: a(1046, e2.DiagnosticCategory.Error, "Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier_1046", "Top-level declarations in .d.ts files must start with either a 'declare' or 'export' modifier."), A_rest_parameter_cannot_be_optional: a(1047, e2.DiagnosticCategory.Error, "A_rest_parameter_cannot_be_optional_1047", "A rest parameter cannot be optional."), A_rest_parameter_cannot_have_an_initializer: a(1048, e2.DiagnosticCategory.Error, "A_rest_parameter_cannot_have_an_initializer_1048", "A rest parameter cannot have an initializer."), A_set_accessor_must_have_exactly_one_parameter: a(1049, e2.DiagnosticCategory.Error, "A_set_accessor_must_have_exactly_one_parameter_1049", "A 'set' accessor must have exactly one parameter."), A_set_accessor_cannot_have_an_optional_parameter: a(1051, e2.DiagnosticCategory.Error, "A_set_accessor_cannot_have_an_optional_parameter_1051", "A 'set' accessor cannot have an optional parameter."), A_set_accessor_parameter_cannot_have_an_initializer: a(1052, e2.DiagnosticCategory.Error, "A_set_accessor_parameter_cannot_have_an_initializer_1052", "A 'set' accessor parameter cannot have an initializer."), A_set_accessor_cannot_have_rest_parameter: a(1053, e2.DiagnosticCategory.Error, "A_set_accessor_cannot_have_rest_parameter_1053", "A 'set' accessor cannot have rest parameter."), A_get_accessor_cannot_have_parameters: a(1054, e2.DiagnosticCategory.Error, "A_get_accessor_cannot_have_parameters_1054", "A 'get' accessor cannot have parameters."), Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value: a(1055, e2.DiagnosticCategory.Error, "Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Prom_1055", "Type '{0}' is not a valid async function return type in ES5/ES3 because it does not refer to a Promise-compatible constructor value."), Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher: a(1056, e2.DiagnosticCategory.Error, "Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher_1056", "Accessors are only available when targeting ECMAScript 5 and higher."), The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: a(1058, e2.DiagnosticCategory.Error, "The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_t_1058", "The return type of an async function must either be a valid promise or must not contain a callable 'then' member."), A_promise_must_have_a_then_method: a(1059, e2.DiagnosticCategory.Error, "A_promise_must_have_a_then_method_1059", "A promise must have a 'then' method."), The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback: a(1060, e2.DiagnosticCategory.Error, "The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback_1060", "The first parameter of the 'then' method of a promise must be a callback."), Enum_member_must_have_initializer: a(1061, e2.DiagnosticCategory.Error, "Enum_member_must_have_initializer_1061", "Enum member must have initializer."), Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method: a(1062, e2.DiagnosticCategory.Error, "Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method_1062", "Type is referenced directly or indirectly in the fulfillment callback of its own 'then' method."), An_export_assignment_cannot_be_used_in_a_namespace: a(1063, e2.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_namespace_1063", "An export assignment cannot be used in a namespace."), The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0: a(1064, e2.DiagnosticCategory.Error, "The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_wri_1064", "The return type of an async function or method must be the global Promise<T> type. Did you mean to write 'Promise<{0}>'?"), In_ambient_enum_declarations_member_initializer_must_be_constant_expression: a(1066, e2.DiagnosticCategory.Error, "In_ambient_enum_declarations_member_initializer_must_be_constant_expression_1066", "In ambient enum declarations member initializer must be constant expression."), Unexpected_token_A_constructor_method_accessor_or_property_was_expected: a(1068, e2.DiagnosticCategory.Error, "Unexpected_token_A_constructor_method_accessor_or_property_was_expected_1068", "Unexpected token. A constructor, method, accessor, or property was expected."), Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces: a(1069, e2.DiagnosticCategory.Error, "Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces_1069", "Unexpected token. A type parameter name was expected without curly braces."), _0_modifier_cannot_appear_on_a_type_member: a(1070, e2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_type_member_1070", "'{0}' modifier cannot appear on a type member."), _0_modifier_cannot_appear_on_an_index_signature: a(1071, e2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_an_index_signature_1071", "'{0}' modifier cannot appear on an index signature."), A_0_modifier_cannot_be_used_with_an_import_declaration: a(1079, e2.DiagnosticCategory.Error, "A_0_modifier_cannot_be_used_with_an_import_declaration_1079", "A '{0}' modifier cannot be used with an import declaration."), Invalid_reference_directive_syntax: a(1084, e2.DiagnosticCategory.Error, "Invalid_reference_directive_syntax_1084", "Invalid 'reference' directive syntax."), Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0: a(1085, e2.DiagnosticCategory.Error, "Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0_1085", "Octal literals are not available when targeting ECMAScript 5 and higher. Use the syntax '{0}'."), _0_modifier_cannot_appear_on_a_constructor_declaration: a(1089, e2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_constructor_declaration_1089", "'{0}' modifier cannot appear on a constructor declaration."), _0_modifier_cannot_appear_on_a_parameter: a(1090, e2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_parameter_1090", "'{0}' modifier cannot appear on a parameter."), Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement: a(1091, e2.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement_1091", "Only a single variable declaration is allowed in a 'for...in' statement."), Type_parameters_cannot_appear_on_a_constructor_declaration: a(1092, e2.DiagnosticCategory.Error, "Type_parameters_cannot_appear_on_a_constructor_declaration_1092", "Type parameters cannot appear on a constructor declaration."), Type_annotation_cannot_appear_on_a_constructor_declaration: a(1093, e2.DiagnosticCategory.Error, "Type_annotation_cannot_appear_on_a_constructor_declaration_1093", "Type annotation cannot appear on a constructor declaration."), An_accessor_cannot_have_type_parameters: a(1094, e2.DiagnosticCategory.Error, "An_accessor_cannot_have_type_parameters_1094", "An accessor cannot have type parameters."), A_set_accessor_cannot_have_a_return_type_annotation: a(1095, e2.DiagnosticCategory.Error, "A_set_accessor_cannot_have_a_return_type_annotation_1095", "A 'set' accessor cannot have a return type annotation."), An_index_signature_must_have_exactly_one_parameter: a(1096, e2.DiagnosticCategory.Error, "An_index_signature_must_have_exactly_one_parameter_1096", "An index signature must have exactly one parameter."), _0_list_cannot_be_empty: a(1097, e2.DiagnosticCategory.Error, "_0_list_cannot_be_empty_1097", "'{0}' list cannot be empty."), Type_parameter_list_cannot_be_empty: a(1098, e2.DiagnosticCategory.Error, "Type_parameter_list_cannot_be_empty_1098", "Type parameter list cannot be empty."), Type_argument_list_cannot_be_empty: a(1099, e2.DiagnosticCategory.Error, "Type_argument_list_cannot_be_empty_1099", "Type argument list cannot be empty."), Invalid_use_of_0_in_strict_mode: a(1100, e2.DiagnosticCategory.Error, "Invalid_use_of_0_in_strict_mode_1100", "Invalid use of '{0}' in strict mode."), with_statements_are_not_allowed_in_strict_mode: a(1101, e2.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_strict_mode_1101", "'with' statements are not allowed in strict mode."), delete_cannot_be_called_on_an_identifier_in_strict_mode: a(1102, e2.DiagnosticCategory.Error, "delete_cannot_be_called_on_an_identifier_in_strict_mode_1102", "'delete' cannot be called on an identifier in strict mode."), for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: a(1103, e2.DiagnosticCategory.Error, "for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1103", "'for await' loops are only allowed within async functions and at the top levels of modules."), A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement: a(1104, e2.DiagnosticCategory.Error, "A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement_1104", "A 'continue' statement can only be used within an enclosing iteration statement."), A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement: a(1105, e2.DiagnosticCategory.Error, "A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement_1105", "A 'break' statement can only be used within an enclosing iteration or switch statement."), The_left_hand_side_of_a_for_of_statement_may_not_be_async: a(1106, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_may_not_be_async_1106", "The left-hand side of a 'for...of' statement may not be 'async'."), Jump_target_cannot_cross_function_boundary: a(1107, e2.DiagnosticCategory.Error, "Jump_target_cannot_cross_function_boundary_1107", "Jump target cannot cross function boundary."), A_return_statement_can_only_be_used_within_a_function_body: a(1108, e2.DiagnosticCategory.Error, "A_return_statement_can_only_be_used_within_a_function_body_1108", "A 'return' statement can only be used within a function body."), Expression_expected: a(1109, e2.DiagnosticCategory.Error, "Expression_expected_1109", "Expression expected."), Type_expected: a(1110, e2.DiagnosticCategory.Error, "Type_expected_1110", "Type expected."), A_default_clause_cannot_appear_more_than_once_in_a_switch_statement: a(1113, e2.DiagnosticCategory.Error, "A_default_clause_cannot_appear_more_than_once_in_a_switch_statement_1113", "A 'default' clause cannot appear more than once in a 'switch' statement."), Duplicate_label_0: a(1114, e2.DiagnosticCategory.Error, "Duplicate_label_0_1114", "Duplicate label '{0}'."), A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement: a(1115, e2.DiagnosticCategory.Error, "A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement_1115", "A 'continue' statement can only jump to a label of an enclosing iteration statement."), A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement: a(1116, e2.DiagnosticCategory.Error, "A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement_1116", "A 'break' statement can only jump to a label of an enclosing statement."), An_object_literal_cannot_have_multiple_properties_with_the_same_name: a(1117, e2.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_properties_with_the_same_name_1117", "An object literal cannot have multiple properties with the same name."), An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name: a(1118, e2.DiagnosticCategory.Error, "An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name_1118", "An object literal cannot have multiple get/set accessors with the same name."), An_object_literal_cannot_have_property_and_accessor_with_the_same_name: a(1119, e2.DiagnosticCategory.Error, "An_object_literal_cannot_have_property_and_accessor_with_the_same_name_1119", "An object literal cannot have property and accessor with the same name."), An_export_assignment_cannot_have_modifiers: a(1120, e2.DiagnosticCategory.Error, "An_export_assignment_cannot_have_modifiers_1120", "An export assignment cannot have modifiers."), Octal_literals_are_not_allowed_in_strict_mode: a(1121, e2.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_strict_mode_1121", "Octal literals are not allowed in strict mode."), Variable_declaration_list_cannot_be_empty: a(1123, e2.DiagnosticCategory.Error, "Variable_declaration_list_cannot_be_empty_1123", "Variable declaration list cannot be empty."), Digit_expected: a(1124, e2.DiagnosticCategory.Error, "Digit_expected_1124", "Digit expected."), Hexadecimal_digit_expected: a(1125, e2.DiagnosticCategory.Error, "Hexadecimal_digit_expected_1125", "Hexadecimal digit expected."), Unexpected_end_of_text: a(1126, e2.DiagnosticCategory.Error, "Unexpected_end_of_text_1126", "Unexpected end of text."), Invalid_character: a(1127, e2.DiagnosticCategory.Error, "Invalid_character_1127", "Invalid character."), Declaration_or_statement_expected: a(1128, e2.DiagnosticCategory.Error, "Declaration_or_statement_expected_1128", "Declaration or statement expected."), Statement_expected: a(1129, e2.DiagnosticCategory.Error, "Statement_expected_1129", "Statement expected."), case_or_default_expected: a(1130, e2.DiagnosticCategory.Error, "case_or_default_expected_1130", "'case' or 'default' expected."), Property_or_signature_expected: a(1131, e2.DiagnosticCategory.Error, "Property_or_signature_expected_1131", "Property or signature expected."), Enum_member_expected: a(1132, e2.DiagnosticCategory.Error, "Enum_member_expected_1132", "Enum member expected."), Variable_declaration_expected: a(1134, e2.DiagnosticCategory.Error, "Variable_declaration_expected_1134", "Variable declaration expected."), Argument_expression_expected: a(1135, e2.DiagnosticCategory.Error, "Argument_expression_expected_1135", "Argument expression expected."), Property_assignment_expected: a(1136, e2.DiagnosticCategory.Error, "Property_assignment_expected_1136", "Property assignment expected."), Expression_or_comma_expected: a(1137, e2.DiagnosticCategory.Error, "Expression_or_comma_expected_1137", "Expression or comma expected."), Parameter_declaration_expected: a(1138, e2.DiagnosticCategory.Error, "Parameter_declaration_expected_1138", "Parameter declaration expected."), Type_parameter_declaration_expected: a(1139, e2.DiagnosticCategory.Error, "Type_parameter_declaration_expected_1139", "Type parameter declaration expected."), Type_argument_expected: a(1140, e2.DiagnosticCategory.Error, "Type_argument_expected_1140", "Type argument expected."), String_literal_expected: a(1141, e2.DiagnosticCategory.Error, "String_literal_expected_1141", "String literal expected."), Line_break_not_permitted_here: a(1142, e2.DiagnosticCategory.Error, "Line_break_not_permitted_here_1142", "Line break not permitted here."), or_expected: a(1144, e2.DiagnosticCategory.Error, "or_expected_1144", "'{' or ';' expected."), Declaration_expected: a(1146, e2.DiagnosticCategory.Error, "Declaration_expected_1146", "Declaration expected."), Import_declarations_in_a_namespace_cannot_reference_a_module: a(1147, e2.DiagnosticCategory.Error, "Import_declarations_in_a_namespace_cannot_reference_a_module_1147", "Import declarations in a namespace cannot reference a module."), Cannot_use_imports_exports_or_module_augmentations_when_module_is_none: a(1148, e2.DiagnosticCategory.Error, "Cannot_use_imports_exports_or_module_augmentations_when_module_is_none_1148", "Cannot use imports, exports, or module augmentations when '--module' is 'none'."), File_name_0_differs_from_already_included_file_name_1_only_in_casing: a(1149, e2.DiagnosticCategory.Error, "File_name_0_differs_from_already_included_file_name_1_only_in_casing_1149", "File name '{0}' differs from already included file name '{1}' only in casing."), const_declarations_must_be_initialized: a(1155, e2.DiagnosticCategory.Error, "const_declarations_must_be_initialized_1155", "'const' declarations must be initialized."), const_declarations_can_only_be_declared_inside_a_block: a(1156, e2.DiagnosticCategory.Error, "const_declarations_can_only_be_declared_inside_a_block_1156", "'const' declarations can only be declared inside a block."), let_declarations_can_only_be_declared_inside_a_block: a(1157, e2.DiagnosticCategory.Error, "let_declarations_can_only_be_declared_inside_a_block_1157", "'let' declarations can only be declared inside a block."), Unterminated_template_literal: a(1160, e2.DiagnosticCategory.Error, "Unterminated_template_literal_1160", "Unterminated template literal."), Unterminated_regular_expression_literal: a(1161, e2.DiagnosticCategory.Error, "Unterminated_regular_expression_literal_1161", "Unterminated regular expression literal."), An_object_member_cannot_be_declared_optional: a(1162, e2.DiagnosticCategory.Error, "An_object_member_cannot_be_declared_optional_1162", "An object member cannot be declared optional."), A_yield_expression_is_only_allowed_in_a_generator_body: a(1163, e2.DiagnosticCategory.Error, "A_yield_expression_is_only_allowed_in_a_generator_body_1163", "A 'yield' expression is only allowed in a generator body."), Computed_property_names_are_not_allowed_in_enums: a(1164, e2.DiagnosticCategory.Error, "Computed_property_names_are_not_allowed_in_enums_1164", "Computed property names are not allowed in enums."), A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: a(1165, e2.DiagnosticCategory.Error, "A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_t_1165", "A computed property name in an ambient context must refer to an expression whose type is a literal type or a 'unique symbol' type."), A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type: a(1166, e2.DiagnosticCategory.Error, "A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_1166", "A computed property name in a class property declaration must have a simple literal type or a 'unique symbol' type."), A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: a(1168, e2.DiagnosticCategory.Error, "A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_ty_1168", "A computed property name in a method overload must refer to an expression whose type is a literal type or a 'unique symbol' type."), A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: a(1169, e2.DiagnosticCategory.Error, "A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_1169", "A computed property name in an interface must refer to an expression whose type is a literal type or a 'unique symbol' type."), A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type: a(1170, e2.DiagnosticCategory.Error, "A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type__1170", "A computed property name in a type literal must refer to an expression whose type is a literal type or a 'unique symbol' type."), A_comma_expression_is_not_allowed_in_a_computed_property_name: a(1171, e2.DiagnosticCategory.Error, "A_comma_expression_is_not_allowed_in_a_computed_property_name_1171", "A comma expression is not allowed in a computed property name."), extends_clause_already_seen: a(1172, e2.DiagnosticCategory.Error, "extends_clause_already_seen_1172", "'extends' clause already seen."), extends_clause_must_precede_implements_clause: a(1173, e2.DiagnosticCategory.Error, "extends_clause_must_precede_implements_clause_1173", "'extends' clause must precede 'implements' clause."), Classes_can_only_extend_a_single_class: a(1174, e2.DiagnosticCategory.Error, "Classes_can_only_extend_a_single_class_1174", "Classes can only extend a single class."), implements_clause_already_seen: a(1175, e2.DiagnosticCategory.Error, "implements_clause_already_seen_1175", "'implements' clause already seen."), Interface_declaration_cannot_have_implements_clause: a(1176, e2.DiagnosticCategory.Error, "Interface_declaration_cannot_have_implements_clause_1176", "Interface declaration cannot have 'implements' clause."), Binary_digit_expected: a(1177, e2.DiagnosticCategory.Error, "Binary_digit_expected_1177", "Binary digit expected."), Octal_digit_expected: a(1178, e2.DiagnosticCategory.Error, "Octal_digit_expected_1178", "Octal digit expected."), Unexpected_token_expected: a(1179, e2.DiagnosticCategory.Error, "Unexpected_token_expected_1179", "Unexpected token. '{' expected."), Property_destructuring_pattern_expected: a(1180, e2.DiagnosticCategory.Error, "Property_destructuring_pattern_expected_1180", "Property destructuring pattern expected."), Array_element_destructuring_pattern_expected: a(1181, e2.DiagnosticCategory.Error, "Array_element_destructuring_pattern_expected_1181", "Array element destructuring pattern expected."), A_destructuring_declaration_must_have_an_initializer: a(1182, e2.DiagnosticCategory.Error, "A_destructuring_declaration_must_have_an_initializer_1182", "A destructuring declaration must have an initializer."), An_implementation_cannot_be_declared_in_ambient_contexts: a(1183, e2.DiagnosticCategory.Error, "An_implementation_cannot_be_declared_in_ambient_contexts_1183", "An implementation cannot be declared in ambient contexts."), Modifiers_cannot_appear_here: a(1184, e2.DiagnosticCategory.Error, "Modifiers_cannot_appear_here_1184", "Modifiers cannot appear here."), Merge_conflict_marker_encountered: a(1185, e2.DiagnosticCategory.Error, "Merge_conflict_marker_encountered_1185", "Merge conflict marker encountered."), A_rest_element_cannot_have_an_initializer: a(1186, e2.DiagnosticCategory.Error, "A_rest_element_cannot_have_an_initializer_1186", "A rest element cannot have an initializer."), A_parameter_property_may_not_be_declared_using_a_binding_pattern: a(1187, e2.DiagnosticCategory.Error, "A_parameter_property_may_not_be_declared_using_a_binding_pattern_1187", "A parameter property may not be declared using a binding pattern."), Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement: a(1188, e2.DiagnosticCategory.Error, "Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement_1188", "Only a single variable declaration is allowed in a 'for...of' statement."), The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer: a(1189, e2.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer_1189", "The variable declaration of a 'for...in' statement cannot have an initializer."), The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer: a(1190, e2.DiagnosticCategory.Error, "The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer_1190", "The variable declaration of a 'for...of' statement cannot have an initializer."), An_import_declaration_cannot_have_modifiers: a(1191, e2.DiagnosticCategory.Error, "An_import_declaration_cannot_have_modifiers_1191", "An import declaration cannot have modifiers."), Module_0_has_no_default_export: a(1192, e2.DiagnosticCategory.Error, "Module_0_has_no_default_export_1192", "Module '{0}' has no default export."), An_export_declaration_cannot_have_modifiers: a(1193, e2.DiagnosticCategory.Error, "An_export_declaration_cannot_have_modifiers_1193", "An export declaration cannot have modifiers."), Export_declarations_are_not_permitted_in_a_namespace: a(1194, e2.DiagnosticCategory.Error, "Export_declarations_are_not_permitted_in_a_namespace_1194", "Export declarations are not permitted in a namespace."), export_Asterisk_does_not_re_export_a_default: a(1195, e2.DiagnosticCategory.Error, "export_Asterisk_does_not_re_export_a_default_1195", "'export *' does not re-export a default."), Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified: a(1196, e2.DiagnosticCategory.Error, "Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified_1196", "Catch clause variable type annotation must be 'any' or 'unknown' if specified."), Catch_clause_variable_cannot_have_an_initializer: a(1197, e2.DiagnosticCategory.Error, "Catch_clause_variable_cannot_have_an_initializer_1197", "Catch clause variable cannot have an initializer."), An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive: a(1198, e2.DiagnosticCategory.Error, "An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive_1198", "An extended Unicode escape value must be between 0x0 and 0x10FFFF inclusive."), Unterminated_Unicode_escape_sequence: a(1199, e2.DiagnosticCategory.Error, "Unterminated_Unicode_escape_sequence_1199", "Unterminated Unicode escape sequence."), Line_terminator_not_permitted_before_arrow: a(1200, e2.DiagnosticCategory.Error, "Line_terminator_not_permitted_before_arrow_1200", "Line terminator not permitted before arrow."), Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead: a(1202, e2.DiagnosticCategory.Error, "Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_1202", `Import assignment cannot be used when targeting ECMAScript modules. Consider using 'import * as ns from "mod"', 'import {a} from "mod"', 'import d from "mod"', or another module format instead.`), Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead: a(1203, e2.DiagnosticCategory.Error, "Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or__1203", "Export assignment cannot be used when targeting ECMAScript modules. Consider using 'export default' or another module format instead."), Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type: a(1205, e2.DiagnosticCategory.Error, "Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type_1205", "Re-exporting a type when the '--isolatedModules' flag is provided requires using 'export type'."), Decorators_are_not_valid_here: a(1206, e2.DiagnosticCategory.Error, "Decorators_are_not_valid_here_1206", "Decorators are not valid here."), Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name: a(1207, e2.DiagnosticCategory.Error, "Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name_1207", "Decorators cannot be applied to multiple get/set accessors of the same name."), _0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_import_export_or_an_empty_export_statement_to_make_it_a_module: a(1208, e2.DiagnosticCategory.Error, "_0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_imp_1208", "'{0}' cannot be compiled under '--isolatedModules' because it is considered a global script file. Add an import, export, or an empty 'export {}' statement to make it a module."), Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode: a(1210, e2.DiagnosticCategory.Error, "Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of__1210", "Code contained in a class is evaluated in JavaScript's strict mode which does not allow this use of '{0}'. For more information, see https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Strict_mode."), A_class_declaration_without_the_default_modifier_must_have_a_name: a(1211, e2.DiagnosticCategory.Error, "A_class_declaration_without_the_default_modifier_must_have_a_name_1211", "A class declaration without the 'default' modifier must have a name."), Identifier_expected_0_is_a_reserved_word_in_strict_mode: a(1212, e2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_1212", "Identifier expected. '{0}' is a reserved word in strict mode."), Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode: a(1213, e2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_stric_1213", "Identifier expected. '{0}' is a reserved word in strict mode. Class definitions are automatically in strict mode."), Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode: a(1214, e2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode_1214", "Identifier expected. '{0}' is a reserved word in strict mode. Modules are automatically in strict mode."), Invalid_use_of_0_Modules_are_automatically_in_strict_mode: a(1215, e2.DiagnosticCategory.Error, "Invalid_use_of_0_Modules_are_automatically_in_strict_mode_1215", "Invalid use of '{0}'. Modules are automatically in strict mode."), Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules: a(1216, e2.DiagnosticCategory.Error, "Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules_1216", "Identifier expected. '__esModule' is reserved as an exported marker when transforming ECMAScript modules."), Export_assignment_is_not_supported_when_module_flag_is_system: a(1218, e2.DiagnosticCategory.Error, "Export_assignment_is_not_supported_when_module_flag_is_system_1218", "Export assignment is not supported when '--module' flag is 'system'."), Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning: a(1219, e2.DiagnosticCategory.Error, "Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_t_1219", "Experimental support for decorators is a feature that is subject to change in a future release. Set the 'experimentalDecorators' option in your 'tsconfig' or 'jsconfig' to remove this warning."), Generators_are_not_allowed_in_an_ambient_context: a(1221, e2.DiagnosticCategory.Error, "Generators_are_not_allowed_in_an_ambient_context_1221", "Generators are not allowed in an ambient context."), An_overload_signature_cannot_be_declared_as_a_generator: a(1222, e2.DiagnosticCategory.Error, "An_overload_signature_cannot_be_declared_as_a_generator_1222", "An overload signature cannot be declared as a generator."), _0_tag_already_specified: a(1223, e2.DiagnosticCategory.Error, "_0_tag_already_specified_1223", "'{0}' tag already specified."), Signature_0_must_be_a_type_predicate: a(1224, e2.DiagnosticCategory.Error, "Signature_0_must_be_a_type_predicate_1224", "Signature '{0}' must be a type predicate."), Cannot_find_parameter_0: a(1225, e2.DiagnosticCategory.Error, "Cannot_find_parameter_0_1225", "Cannot find parameter '{0}'."), Type_predicate_0_is_not_assignable_to_1: a(1226, e2.DiagnosticCategory.Error, "Type_predicate_0_is_not_assignable_to_1_1226", "Type predicate '{0}' is not assignable to '{1}'."), Parameter_0_is_not_in_the_same_position_as_parameter_1: a(1227, e2.DiagnosticCategory.Error, "Parameter_0_is_not_in_the_same_position_as_parameter_1_1227", "Parameter '{0}' is not in the same position as parameter '{1}'."), A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods: a(1228, e2.DiagnosticCategory.Error, "A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods_1228", "A type predicate is only allowed in return type position for functions and methods."), A_type_predicate_cannot_reference_a_rest_parameter: a(1229, e2.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_a_rest_parameter_1229", "A type predicate cannot reference a rest parameter."), A_type_predicate_cannot_reference_element_0_in_a_binding_pattern: a(1230, e2.DiagnosticCategory.Error, "A_type_predicate_cannot_reference_element_0_in_a_binding_pattern_1230", "A type predicate cannot reference element '{0}' in a binding pattern."), An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration: a(1231, e2.DiagnosticCategory.Error, "An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration_1231", "An export assignment must be at the top level of a file or module declaration."), An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module: a(1232, e2.DiagnosticCategory.Error, "An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1232", "An import declaration can only be used at the top level of a namespace or module."), An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module: a(1233, e2.DiagnosticCategory.Error, "An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module_1233", "An export declaration can only be used at the top level of a namespace or module."), An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file: a(1234, e2.DiagnosticCategory.Error, "An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file_1234", "An ambient module declaration is only allowed at the top level in a file."), A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module: a(1235, e2.DiagnosticCategory.Error, "A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module_1235", "A namespace declaration is only allowed at the top level of a namespace or module."), The_return_type_of_a_property_decorator_function_must_be_either_void_or_any: a(1236, e2.DiagnosticCategory.Error, "The_return_type_of_a_property_decorator_function_must_be_either_void_or_any_1236", "The return type of a property decorator function must be either 'void' or 'any'."), The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any: a(1237, e2.DiagnosticCategory.Error, "The_return_type_of_a_parameter_decorator_function_must_be_either_void_or_any_1237", "The return type of a parameter decorator function must be either 'void' or 'any'."), Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression: a(1238, e2.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression_1238", "Unable to resolve signature of class decorator when called as an expression."), Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression: a(1239, e2.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression_1239", "Unable to resolve signature of parameter decorator when called as an expression."), Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression: a(1240, e2.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression_1240", "Unable to resolve signature of property decorator when called as an expression."), Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression: a(1241, e2.DiagnosticCategory.Error, "Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression_1241", "Unable to resolve signature of method decorator when called as an expression."), abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration: a(1242, e2.DiagnosticCategory.Error, "abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration_1242", "'abstract' modifier can only appear on a class, method, or property declaration."), _0_modifier_cannot_be_used_with_1_modifier: a(1243, e2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_1_modifier_1243", "'{0}' modifier cannot be used with '{1}' modifier."), Abstract_methods_can_only_appear_within_an_abstract_class: a(1244, e2.DiagnosticCategory.Error, "Abstract_methods_can_only_appear_within_an_abstract_class_1244", "Abstract methods can only appear within an abstract class."), Method_0_cannot_have_an_implementation_because_it_is_marked_abstract: a(1245, e2.DiagnosticCategory.Error, "Method_0_cannot_have_an_implementation_because_it_is_marked_abstract_1245", "Method '{0}' cannot have an implementation because it is marked abstract."), An_interface_property_cannot_have_an_initializer: a(1246, e2.DiagnosticCategory.Error, "An_interface_property_cannot_have_an_initializer_1246", "An interface property cannot have an initializer."), A_type_literal_property_cannot_have_an_initializer: a(1247, e2.DiagnosticCategory.Error, "A_type_literal_property_cannot_have_an_initializer_1247", "A type literal property cannot have an initializer."), A_class_member_cannot_have_the_0_keyword: a(1248, e2.DiagnosticCategory.Error, "A_class_member_cannot_have_the_0_keyword_1248", "A class member cannot have the '{0}' keyword."), A_decorator_can_only_decorate_a_method_implementation_not_an_overload: a(1249, e2.DiagnosticCategory.Error, "A_decorator_can_only_decorate_a_method_implementation_not_an_overload_1249", "A decorator can only decorate a method implementation, not an overload."), Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5: a(1250, e2.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_1250", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'."), Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode: a(1251, e2.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_d_1251", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Class definitions are automatically in strict mode."), Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode: a(1252, e2.DiagnosticCategory.Error, "Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_1252", "Function declarations are not allowed inside blocks in strict mode when targeting 'ES3' or 'ES5'. Modules are automatically in strict mode."), A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference: a(1254, e2.DiagnosticCategory.Error, "A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_refere_1254", "A 'const' initializer in an ambient context must be a string or numeric literal or literal enum reference."), A_definite_assignment_assertion_is_not_permitted_in_this_context: a(1255, e2.DiagnosticCategory.Error, "A_definite_assignment_assertion_is_not_permitted_in_this_context_1255", "A definite assignment assertion '!' is not permitted in this context."), A_required_element_cannot_follow_an_optional_element: a(1257, e2.DiagnosticCategory.Error, "A_required_element_cannot_follow_an_optional_element_1257", "A required element cannot follow an optional element."), A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration: a(1258, e2.DiagnosticCategory.Error, "A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration_1258", "A default export must be at the top level of a file or module declaration."), Module_0_can_only_be_default_imported_using_the_1_flag: a(1259, e2.DiagnosticCategory.Error, "Module_0_can_only_be_default_imported_using_the_1_flag_1259", "Module '{0}' can only be default-imported using the '{1}' flag"), Keywords_cannot_contain_escape_characters: a(1260, e2.DiagnosticCategory.Error, "Keywords_cannot_contain_escape_characters_1260", "Keywords cannot contain escape characters."), Already_included_file_name_0_differs_from_file_name_1_only_in_casing: a(1261, e2.DiagnosticCategory.Error, "Already_included_file_name_0_differs_from_file_name_1_only_in_casing_1261", "Already included file name '{0}' differs from file name '{1}' only in casing."), Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module: a(1262, e2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module_1262", "Identifier expected. '{0}' is a reserved word at the top-level of a module."), Declarations_with_initializers_cannot_also_have_definite_assignment_assertions: a(1263, e2.DiagnosticCategory.Error, "Declarations_with_initializers_cannot_also_have_definite_assignment_assertions_1263", "Declarations with initializers cannot also have definite assignment assertions."), Declarations_with_definite_assignment_assertions_must_also_have_type_annotations: a(1264, e2.DiagnosticCategory.Error, "Declarations_with_definite_assignment_assertions_must_also_have_type_annotations_1264", "Declarations with definite assignment assertions must also have type annotations."), A_rest_element_cannot_follow_another_rest_element: a(1265, e2.DiagnosticCategory.Error, "A_rest_element_cannot_follow_another_rest_element_1265", "A rest element cannot follow another rest element."), An_optional_element_cannot_follow_a_rest_element: a(1266, e2.DiagnosticCategory.Error, "An_optional_element_cannot_follow_a_rest_element_1266", "An optional element cannot follow a rest element."), Property_0_cannot_have_an_initializer_because_it_is_marked_abstract: a(1267, e2.DiagnosticCategory.Error, "Property_0_cannot_have_an_initializer_because_it_is_marked_abstract_1267", "Property '{0}' cannot have an initializer because it is marked abstract."), An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type: a(1268, e2.DiagnosticCategory.Error, "An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type_1268", "An index signature parameter type must be 'string', 'number', 'symbol', or a template literal type."), Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided: a(1269, e2.DiagnosticCategory.Error, "Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided_1269", "Cannot use 'export import' on a type or type-only namespace when the '--isolatedModules' flag is provided."), Decorator_function_return_type_0_is_not_assignable_to_type_1: a(1270, e2.DiagnosticCategory.Error, "Decorator_function_return_type_0_is_not_assignable_to_type_1_1270", "Decorator function return type '{0}' is not assignable to type '{1}'."), Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any: a(1271, e2.DiagnosticCategory.Error, "Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any_1271", "Decorator function return type is '{0}' but is expected to be 'void' or 'any'."), A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled: a(1272, e2.DiagnosticCategory.Error, "A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_w_1272", "A type referenced in a decorated signature must be imported with 'import type' or a namespace import when 'isolatedModules' and 'emitDecoratorMetadata' are enabled."), _0_modifier_cannot_appear_on_a_type_parameter: a(1273, e2.DiagnosticCategory.Error, "_0_modifier_cannot_appear_on_a_type_parameter_1273", "'{0}' modifier cannot appear on a type parameter"), _0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias: a(1274, e2.DiagnosticCategory.Error, "_0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias_1274", "'{0}' modifier can only appear on a type parameter of a class, interface or type alias"), with_statements_are_not_allowed_in_an_async_function_block: a(1300, e2.DiagnosticCategory.Error, "with_statements_are_not_allowed_in_an_async_function_block_1300", "'with' statements are not allowed in an async function block."), await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules: a(1308, e2.DiagnosticCategory.Error, "await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules_1308", "'await' expressions are only allowed within async functions and at the top levels of modules."), The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level: a(1309, e2.DiagnosticCategory.Error, "The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level_1309", "The current file is a CommonJS module and cannot use 'await' at the top level."), Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern: a(1312, e2.DiagnosticCategory.Error, "Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_1312", "Did you mean to use a ':'? An '=' can only follow a property name when the containing object literal is part of a destructuring pattern."), The_body_of_an_if_statement_cannot_be_the_empty_statement: a(1313, e2.DiagnosticCategory.Error, "The_body_of_an_if_statement_cannot_be_the_empty_statement_1313", "The body of an 'if' statement cannot be the empty statement."), Global_module_exports_may_only_appear_in_module_files: a(1314, e2.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_module_files_1314", "Global module exports may only appear in module files."), Global_module_exports_may_only_appear_in_declaration_files: a(1315, e2.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_in_declaration_files_1315", "Global module exports may only appear in declaration files."), Global_module_exports_may_only_appear_at_top_level: a(1316, e2.DiagnosticCategory.Error, "Global_module_exports_may_only_appear_at_top_level_1316", "Global module exports may only appear at top level."), A_parameter_property_cannot_be_declared_using_a_rest_parameter: a(1317, e2.DiagnosticCategory.Error, "A_parameter_property_cannot_be_declared_using_a_rest_parameter_1317", "A parameter property cannot be declared using a rest parameter."), An_abstract_accessor_cannot_have_an_implementation: a(1318, e2.DiagnosticCategory.Error, "An_abstract_accessor_cannot_have_an_implementation_1318", "An abstract accessor cannot have an implementation."), A_default_export_can_only_be_used_in_an_ECMAScript_style_module: a(1319, e2.DiagnosticCategory.Error, "A_default_export_can_only_be_used_in_an_ECMAScript_style_module_1319", "A default export can only be used in an ECMAScript-style module."), Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: a(1320, e2.DiagnosticCategory.Error, "Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member_1320", "Type of 'await' operand must either be a valid promise or must not contain a callable 'then' member."), Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: a(1321, e2.DiagnosticCategory.Error, "Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_cal_1321", "Type of 'yield' operand in an async generator must either be a valid promise or must not contain a callable 'then' member."), Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member: a(1322, e2.DiagnosticCategory.Error, "Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_con_1322", "Type of iterated elements of a 'yield*' operand must either be a valid promise or must not contain a callable 'then' member."), Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext: a(1323, e2.DiagnosticCategory.Error, "Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd__1323", "Dynamic imports are only supported when the '--module' flag is set to 'es2020', 'es2022', 'esnext', 'commonjs', 'amd', 'system', 'umd', 'node16', or 'nodenext'."), Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext: a(1324, e2.DiagnosticCategory.Error, "Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nod_1324", "Dynamic imports only support a second argument when the '--module' option is set to 'esnext', 'node16', or 'nodenext'."), Argument_of_dynamic_import_cannot_be_spread_element: a(1325, e2.DiagnosticCategory.Error, "Argument_of_dynamic_import_cannot_be_spread_element_1325", "Argument of dynamic import cannot be spread element."), This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments: a(1326, e2.DiagnosticCategory.Error, "This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot__1326", "This use of 'import' is invalid. 'import()' calls can be written, but they must have parentheses and cannot have type arguments."), String_literal_with_double_quotes_expected: a(1327, e2.DiagnosticCategory.Error, "String_literal_with_double_quotes_expected_1327", "String literal with double quotes expected."), Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal: a(1328, e2.DiagnosticCategory.Error, "Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_li_1328", "Property value can only be string literal, numeric literal, 'true', 'false', 'null', object literal or array literal."), _0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0: a(1329, e2.DiagnosticCategory.Error, "_0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write__1329", "'{0}' accepts too few arguments to be used as a decorator here. Did you mean to call it first and write '@{0}()'?"), A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly: a(1330, e2.DiagnosticCategory.Error, "A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly_1330", "A property of an interface or type literal whose type is a 'unique symbol' type must be 'readonly'."), A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly: a(1331, e2.DiagnosticCategory.Error, "A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly_1331", "A property of a class whose type is a 'unique symbol' type must be both 'static' and 'readonly'."), A_variable_whose_type_is_a_unique_symbol_type_must_be_const: a(1332, e2.DiagnosticCategory.Error, "A_variable_whose_type_is_a_unique_symbol_type_must_be_const_1332", "A variable whose type is a 'unique symbol' type must be 'const'."), unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name: a(1333, e2.DiagnosticCategory.Error, "unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name_1333", "'unique symbol' types may not be used on a variable declaration with a binding name."), unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement: a(1334, e2.DiagnosticCategory.Error, "unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement_1334", "'unique symbol' types are only allowed on variables in a variable statement."), unique_symbol_types_are_not_allowed_here: a(1335, e2.DiagnosticCategory.Error, "unique_symbol_types_are_not_allowed_here_1335", "'unique symbol' types are not allowed here."), An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead: a(1337, e2.DiagnosticCategory.Error, "An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_o_1337", "An index signature parameter type cannot be a literal type or generic type. Consider using a mapped object type instead."), infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type: a(1338, e2.DiagnosticCategory.Error, "infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type_1338", "'infer' declarations are only permitted in the 'extends' clause of a conditional type."), Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here: a(1339, e2.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here_1339", "Module '{0}' does not refer to a value, but is used as a value here."), Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0: a(1340, e2.DiagnosticCategory.Error, "Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0_1340", "Module '{0}' does not refer to a type, but is used as a type here. Did you mean 'typeof import('{0}')'?"), Type_arguments_cannot_be_used_here: a(1342, e2.DiagnosticCategory.Error, "Type_arguments_cannot_be_used_here_1342", "Type arguments cannot be used here."), The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext: a(1343, e2.DiagnosticCategory.Error, "The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system__1343", "The 'import.meta' meta-property is only allowed when the '--module' option is 'es2020', 'es2022', 'esnext', 'system', 'node16', or 'nodenext'."), A_label_is_not_allowed_here: a(1344, e2.DiagnosticCategory.Error, "A_label_is_not_allowed_here_1344", "'A label is not allowed here."), An_expression_of_type_void_cannot_be_tested_for_truthiness: a(1345, e2.DiagnosticCategory.Error, "An_expression_of_type_void_cannot_be_tested_for_truthiness_1345", "An expression of type 'void' cannot be tested for truthiness."), This_parameter_is_not_allowed_with_use_strict_directive: a(1346, e2.DiagnosticCategory.Error, "This_parameter_is_not_allowed_with_use_strict_directive_1346", "This parameter is not allowed with 'use strict' directive."), use_strict_directive_cannot_be_used_with_non_simple_parameter_list: a(1347, e2.DiagnosticCategory.Error, "use_strict_directive_cannot_be_used_with_non_simple_parameter_list_1347", "'use strict' directive cannot be used with non-simple parameter list."), Non_simple_parameter_declared_here: a(1348, e2.DiagnosticCategory.Error, "Non_simple_parameter_declared_here_1348", "Non-simple parameter declared here."), use_strict_directive_used_here: a(1349, e2.DiagnosticCategory.Error, "use_strict_directive_used_here_1349", "'use strict' directive used here."), Print_the_final_configuration_instead_of_building: a(1350, e2.DiagnosticCategory.Message, "Print_the_final_configuration_instead_of_building_1350", "Print the final configuration instead of building."), An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal: a(1351, e2.DiagnosticCategory.Error, "An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal_1351", "An identifier or keyword cannot immediately follow a numeric literal."), A_bigint_literal_cannot_use_exponential_notation: a(1352, e2.DiagnosticCategory.Error, "A_bigint_literal_cannot_use_exponential_notation_1352", "A bigint literal cannot use exponential notation."), A_bigint_literal_must_be_an_integer: a(1353, e2.DiagnosticCategory.Error, "A_bigint_literal_must_be_an_integer_1353", "A bigint literal must be an integer."), readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types: a(1354, e2.DiagnosticCategory.Error, "readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types_1354", "'readonly' type modifier is only permitted on array and tuple literal types."), A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals: a(1355, e2.DiagnosticCategory.Error, "A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array__1355", "A 'const' assertions can only be applied to references to enum members, or string, number, boolean, array, or object literals."), Did_you_mean_to_mark_this_function_as_async: a(1356, e2.DiagnosticCategory.Error, "Did_you_mean_to_mark_this_function_as_async_1356", "Did you mean to mark this function as 'async'?"), An_enum_member_name_must_be_followed_by_a_or: a(1357, e2.DiagnosticCategory.Error, "An_enum_member_name_must_be_followed_by_a_or_1357", "An enum member name must be followed by a ',', '=', or '}'."), Tagged_template_expressions_are_not_permitted_in_an_optional_chain: a(1358, e2.DiagnosticCategory.Error, "Tagged_template_expressions_are_not_permitted_in_an_optional_chain_1358", "Tagged template expressions are not permitted in an optional chain."), Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here: a(1359, e2.DiagnosticCategory.Error, "Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here_1359", "Identifier expected. '{0}' is a reserved word that cannot be used here."), _0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type: a(1361, e2.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type_1361", "'{0}' cannot be used as a value because it was imported using 'import type'."), _0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type: a(1362, e2.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type_1362", "'{0}' cannot be used as a value because it was exported using 'export type'."), A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both: a(1363, e2.DiagnosticCategory.Error, "A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both_1363", "A type-only import can specify a default import or named bindings, but not both."), Convert_to_type_only_export: a(1364, e2.DiagnosticCategory.Message, "Convert_to_type_only_export_1364", "Convert to type-only export"), Convert_all_re_exported_types_to_type_only_exports: a(1365, e2.DiagnosticCategory.Message, "Convert_all_re_exported_types_to_type_only_exports_1365", "Convert all re-exported types to type-only exports"), Split_into_two_separate_import_declarations: a(1366, e2.DiagnosticCategory.Message, "Split_into_two_separate_import_declarations_1366", "Split into two separate import declarations"), Split_all_invalid_type_only_imports: a(1367, e2.DiagnosticCategory.Message, "Split_all_invalid_type_only_imports_1367", "Split all invalid type-only imports"), Did_you_mean_0: a(1369, e2.DiagnosticCategory.Message, "Did_you_mean_0_1369", "Did you mean '{0}'?"), This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error: a(1371, e2.DiagnosticCategory.Error, "This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set__1371", "This import is never used as a value and must use 'import type' because 'importsNotUsedAsValues' is set to 'error'."), Convert_to_type_only_import: a(1373, e2.DiagnosticCategory.Message, "Convert_to_type_only_import_1373", "Convert to type-only import"), Convert_all_imports_not_used_as_a_value_to_type_only_imports: a(1374, e2.DiagnosticCategory.Message, "Convert_all_imports_not_used_as_a_value_to_type_only_imports_1374", "Convert all imports not used as a value to type-only imports"), await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: a(1375, e2.DiagnosticCategory.Error, "await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_fi_1375", "'await' expressions are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."), _0_was_imported_here: a(1376, e2.DiagnosticCategory.Message, "_0_was_imported_here_1376", "'{0}' was imported here."), _0_was_exported_here: a(1377, e2.DiagnosticCategory.Message, "_0_was_exported_here_1377", "'{0}' was exported here."), Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher: a(1378, e2.DiagnosticCategory.Error, "Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_n_1378", "Top-level 'await' expressions are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', or 'nodenext', and the 'target' option is set to 'es2017' or higher."), An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type: a(1379, e2.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type_1379", "An import alias cannot reference a declaration that was exported using 'export type'."), An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type: a(1380, e2.DiagnosticCategory.Error, "An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type_1380", "An import alias cannot reference a declaration that was imported using 'import type'."), Unexpected_token_Did_you_mean_or_rbrace: a(1381, e2.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_rbrace_1381", "Unexpected token. Did you mean `{'}'}` or `&rbrace;`?"), Unexpected_token_Did_you_mean_or_gt: a(1382, e2.DiagnosticCategory.Error, "Unexpected_token_Did_you_mean_or_gt_1382", "Unexpected token. Did you mean `{'>'}` or `&gt;`?"), Only_named_exports_may_use_export_type: a(1383, e2.DiagnosticCategory.Error, "Only_named_exports_may_use_export_type_1383", "Only named exports may use 'export type'."), Function_type_notation_must_be_parenthesized_when_used_in_a_union_type: a(1385, e2.DiagnosticCategory.Error, "Function_type_notation_must_be_parenthesized_when_used_in_a_union_type_1385", "Function type notation must be parenthesized when used in a union type."), Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type: a(1386, e2.DiagnosticCategory.Error, "Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type_1386", "Constructor type notation must be parenthesized when used in a union type."), Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: a(1387, e2.DiagnosticCategory.Error, "Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1387", "Function type notation must be parenthesized when used in an intersection type."), Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type: a(1388, e2.DiagnosticCategory.Error, "Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type_1388", "Constructor type notation must be parenthesized when used in an intersection type."), _0_is_not_allowed_as_a_variable_declaration_name: a(1389, e2.DiagnosticCategory.Error, "_0_is_not_allowed_as_a_variable_declaration_name_1389", "'{0}' is not allowed as a variable declaration name."), _0_is_not_allowed_as_a_parameter_name: a(1390, e2.DiagnosticCategory.Error, "_0_is_not_allowed_as_a_parameter_name_1390", "'{0}' is not allowed as a parameter name."), An_import_alias_cannot_use_import_type: a(1392, e2.DiagnosticCategory.Error, "An_import_alias_cannot_use_import_type_1392", "An import alias cannot use 'import type'"), Imported_via_0_from_file_1: a(1393, e2.DiagnosticCategory.Message, "Imported_via_0_from_file_1_1393", "Imported via {0} from file '{1}'"), Imported_via_0_from_file_1_with_packageId_2: a(1394, e2.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_1394", "Imported via {0} from file '{1}' with packageId '{2}'"), Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions: a(1395, e2.DiagnosticCategory.Message, "Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions_1395", "Imported via {0} from file '{1}' to import 'importHelpers' as specified in compilerOptions"), Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions: a(1396, e2.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions_1396", "Imported via {0} from file '{1}' with packageId '{2}' to import 'importHelpers' as specified in compilerOptions"), Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions: a(1397, e2.DiagnosticCategory.Message, "Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions_1397", "Imported via {0} from file '{1}' to import 'jsx' and 'jsxs' factory functions"), Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions: a(1398, e2.DiagnosticCategory.Message, "Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions_1398", "Imported via {0} from file '{1}' with packageId '{2}' to import 'jsx' and 'jsxs' factory functions"), File_is_included_via_import_here: a(1399, e2.DiagnosticCategory.Message, "File_is_included_via_import_here_1399", "File is included via import here."), Referenced_via_0_from_file_1: a(1400, e2.DiagnosticCategory.Message, "Referenced_via_0_from_file_1_1400", "Referenced via '{0}' from file '{1}'"), File_is_included_via_reference_here: a(1401, e2.DiagnosticCategory.Message, "File_is_included_via_reference_here_1401", "File is included via reference here."), Type_library_referenced_via_0_from_file_1: a(1402, e2.DiagnosticCategory.Message, "Type_library_referenced_via_0_from_file_1_1402", "Type library referenced via '{0}' from file '{1}'"), Type_library_referenced_via_0_from_file_1_with_packageId_2: a(1403, e2.DiagnosticCategory.Message, "Type_library_referenced_via_0_from_file_1_with_packageId_2_1403", "Type library referenced via '{0}' from file '{1}' with packageId '{2}'"), File_is_included_via_type_library_reference_here: a(1404, e2.DiagnosticCategory.Message, "File_is_included_via_type_library_reference_here_1404", "File is included via type library reference here."), Library_referenced_via_0_from_file_1: a(1405, e2.DiagnosticCategory.Message, "Library_referenced_via_0_from_file_1_1405", "Library referenced via '{0}' from file '{1}'"), File_is_included_via_library_reference_here: a(1406, e2.DiagnosticCategory.Message, "File_is_included_via_library_reference_here_1406", "File is included via library reference here."), Matched_by_include_pattern_0_in_1: a(1407, e2.DiagnosticCategory.Message, "Matched_by_include_pattern_0_in_1_1407", "Matched by include pattern '{0}' in '{1}'"), File_is_matched_by_include_pattern_specified_here: a(1408, e2.DiagnosticCategory.Message, "File_is_matched_by_include_pattern_specified_here_1408", "File is matched by include pattern specified here."), Part_of_files_list_in_tsconfig_json: a(1409, e2.DiagnosticCategory.Message, "Part_of_files_list_in_tsconfig_json_1409", "Part of 'files' list in tsconfig.json"), File_is_matched_by_files_list_specified_here: a(1410, e2.DiagnosticCategory.Message, "File_is_matched_by_files_list_specified_here_1410", "File is matched by 'files' list specified here."), Output_from_referenced_project_0_included_because_1_specified: a(1411, e2.DiagnosticCategory.Message, "Output_from_referenced_project_0_included_because_1_specified_1411", "Output from referenced project '{0}' included because '{1}' specified"), Output_from_referenced_project_0_included_because_module_is_specified_as_none: a(1412, e2.DiagnosticCategory.Message, "Output_from_referenced_project_0_included_because_module_is_specified_as_none_1412", "Output from referenced project '{0}' included because '--module' is specified as 'none'"), File_is_output_from_referenced_project_specified_here: a(1413, e2.DiagnosticCategory.Message, "File_is_output_from_referenced_project_specified_here_1413", "File is output from referenced project specified here."), Source_from_referenced_project_0_included_because_1_specified: a(1414, e2.DiagnosticCategory.Message, "Source_from_referenced_project_0_included_because_1_specified_1414", "Source from referenced project '{0}' included because '{1}' specified"), Source_from_referenced_project_0_included_because_module_is_specified_as_none: a(1415, e2.DiagnosticCategory.Message, "Source_from_referenced_project_0_included_because_module_is_specified_as_none_1415", "Source from referenced project '{0}' included because '--module' is specified as 'none'"), File_is_source_from_referenced_project_specified_here: a(1416, e2.DiagnosticCategory.Message, "File_is_source_from_referenced_project_specified_here_1416", "File is source from referenced project specified here."), Entry_point_of_type_library_0_specified_in_compilerOptions: a(1417, e2.DiagnosticCategory.Message, "Entry_point_of_type_library_0_specified_in_compilerOptions_1417", "Entry point of type library '{0}' specified in compilerOptions"), Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1: a(1418, e2.DiagnosticCategory.Message, "Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1_1418", "Entry point of type library '{0}' specified in compilerOptions with packageId '{1}'"), File_is_entry_point_of_type_library_specified_here: a(1419, e2.DiagnosticCategory.Message, "File_is_entry_point_of_type_library_specified_here_1419", "File is entry point of type library specified here."), Entry_point_for_implicit_type_library_0: a(1420, e2.DiagnosticCategory.Message, "Entry_point_for_implicit_type_library_0_1420", "Entry point for implicit type library '{0}'"), Entry_point_for_implicit_type_library_0_with_packageId_1: a(1421, e2.DiagnosticCategory.Message, "Entry_point_for_implicit_type_library_0_with_packageId_1_1421", "Entry point for implicit type library '{0}' with packageId '{1}'"), Library_0_specified_in_compilerOptions: a(1422, e2.DiagnosticCategory.Message, "Library_0_specified_in_compilerOptions_1422", "Library '{0}' specified in compilerOptions"), File_is_library_specified_here: a(1423, e2.DiagnosticCategory.Message, "File_is_library_specified_here_1423", "File is library specified here."), Default_library: a(1424, e2.DiagnosticCategory.Message, "Default_library_1424", "Default library"), Default_library_for_target_0: a(1425, e2.DiagnosticCategory.Message, "Default_library_for_target_0_1425", "Default library for target '{0}'"), File_is_default_library_for_target_specified_here: a(1426, e2.DiagnosticCategory.Message, "File_is_default_library_for_target_specified_here_1426", "File is default library for target specified here."), Root_file_specified_for_compilation: a(1427, e2.DiagnosticCategory.Message, "Root_file_specified_for_compilation_1427", "Root file specified for compilation"), File_is_output_of_project_reference_source_0: a(1428, e2.DiagnosticCategory.Message, "File_is_output_of_project_reference_source_0_1428", "File is output of project reference source '{0}'"), File_redirects_to_file_0: a(1429, e2.DiagnosticCategory.Message, "File_redirects_to_file_0_1429", "File redirects to file '{0}'"), The_file_is_in_the_program_because_Colon: a(1430, e2.DiagnosticCategory.Message, "The_file_is_in_the_program_because_Colon_1430", "The file is in the program because:"), for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module: a(1431, e2.DiagnosticCategory.Error, "for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_1431", "'for await' loops are only allowed at the top level of a file when that file is a module, but this file has no imports or exports. Consider adding an empty 'export {}' to make this file a module."), Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher: a(1432, e2.DiagnosticCategory.Error, "Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_nod_1432", "Top-level 'for await' loops are only allowed when the 'module' option is set to 'es2022', 'esnext', 'system', 'node16', or 'nodenext', and the 'target' option is set to 'es2017' or higher."), Decorators_may_not_be_applied_to_this_parameters: a(1433, e2.DiagnosticCategory.Error, "Decorators_may_not_be_applied_to_this_parameters_1433", "Decorators may not be applied to 'this' parameters."), Unexpected_keyword_or_identifier: a(1434, e2.DiagnosticCategory.Error, "Unexpected_keyword_or_identifier_1434", "Unexpected keyword or identifier."), Unknown_keyword_or_identifier_Did_you_mean_0: a(1435, e2.DiagnosticCategory.Error, "Unknown_keyword_or_identifier_Did_you_mean_0_1435", "Unknown keyword or identifier. Did you mean '{0}'?"), Decorators_must_precede_the_name_and_all_keywords_of_property_declarations: a(1436, e2.DiagnosticCategory.Error, "Decorators_must_precede_the_name_and_all_keywords_of_property_declarations_1436", "Decorators must precede the name and all keywords of property declarations."), Namespace_must_be_given_a_name: a(1437, e2.DiagnosticCategory.Error, "Namespace_must_be_given_a_name_1437", "Namespace must be given a name."), Interface_must_be_given_a_name: a(1438, e2.DiagnosticCategory.Error, "Interface_must_be_given_a_name_1438", "Interface must be given a name."), Type_alias_must_be_given_a_name: a(1439, e2.DiagnosticCategory.Error, "Type_alias_must_be_given_a_name_1439", "Type alias must be given a name."), Variable_declaration_not_allowed_at_this_location: a(1440, e2.DiagnosticCategory.Error, "Variable_declaration_not_allowed_at_this_location_1440", "Variable declaration not allowed at this location."), Cannot_start_a_function_call_in_a_type_annotation: a(1441, e2.DiagnosticCategory.Error, "Cannot_start_a_function_call_in_a_type_annotation_1441", "Cannot start a function call in a type annotation."), Expected_for_property_initializer: a(1442, e2.DiagnosticCategory.Error, "Expected_for_property_initializer_1442", "Expected '=' for property initializer."), Module_declaration_names_may_only_use_or_quoted_strings: a(1443, e2.DiagnosticCategory.Error, "Module_declaration_names_may_only_use_or_quoted_strings_1443", `Module declaration names may only use ' or " quoted strings.`), _0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled: a(1444, e2.DiagnosticCategory.Error, "_0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedMod_1444", "'{0}' is a type and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."), _0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled: a(1446, e2.DiagnosticCategory.Error, "_0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveVa_1446", "'{0}' resolves to a type-only declaration and must be imported using a type-only import when 'preserveValueImports' and 'isolatedModules' are both enabled."), _0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isolatedModules_is_enabled: a(1448, e2.DiagnosticCategory.Error, "_0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isol_1448", "'{0}' resolves to a type-only declaration and must be re-exported using a type-only re-export when 'isolatedModules' is enabled."), Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed: a(1449, e2.DiagnosticCategory.Message, "Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed_1449", "Preserve unused imported values in the JavaScript output that would otherwise be removed."), Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments: a(1450, e2.DiagnosticCategory.Message, "Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments_1450", "Dynamic imports can only accept a module specifier and an optional assertion as arguments"), Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression: a(1451, e2.DiagnosticCategory.Error, "Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member__1451", "Private identifiers are only allowed in class bodies and may only be used as part of a class member declaration, property access, or on the left-hand-side of an 'in' expression"), Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext: a(1452, e2.DiagnosticCategory.Error, "Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext_1452", "Resolution modes are only supported when `moduleResolution` is `node16` or `nodenext`."), resolution_mode_should_be_either_require_or_import: a(1453, e2.DiagnosticCategory.Error, "resolution_mode_should_be_either_require_or_import_1453", "`resolution-mode` should be either `require` or `import`."), resolution_mode_can_only_be_set_for_type_only_imports: a(1454, e2.DiagnosticCategory.Error, "resolution_mode_can_only_be_set_for_type_only_imports_1454", "`resolution-mode` can only be set for type-only imports."), resolution_mode_is_the_only_valid_key_for_type_import_assertions: a(1455, e2.DiagnosticCategory.Error, "resolution_mode_is_the_only_valid_key_for_type_import_assertions_1455", "`resolution-mode` is the only valid key for type import assertions."), Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require: a(1456, e2.DiagnosticCategory.Error, "Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require_1456", "Type import assertions should have exactly one key - `resolution-mode` - with value `import` or `require`."), The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output: a(1470, e2.DiagnosticCategory.Error, "The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output_1470", "The 'import.meta' meta-property is not allowed in files which will build into CommonJS output."), Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_synchronously_Use_dynamic_import_instead: a(1471, e2.DiagnosticCategory.Error, "Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_c_1471", "Module '{0}' cannot be imported using this construct. The specifier only resolves to an ES module, which cannot be imported synchronously. Use dynamic import instead."), catch_or_finally_expected: a(1472, e2.DiagnosticCategory.Error, "catch_or_finally_expected_1472", "'catch' or 'finally' expected."), An_import_declaration_can_only_be_used_at_the_top_level_of_a_module: a(1473, e2.DiagnosticCategory.Error, "An_import_declaration_can_only_be_used_at_the_top_level_of_a_module_1473", "An import declaration can only be used at the top level of a module."), An_export_declaration_can_only_be_used_at_the_top_level_of_a_module: a(1474, e2.DiagnosticCategory.Error, "An_export_declaration_can_only_be_used_at_the_top_level_of_a_module_1474", "An export declaration can only be used at the top level of a module."), Control_what_method_is_used_to_detect_module_format_JS_files: a(1475, e2.DiagnosticCategory.Message, "Control_what_method_is_used_to_detect_module_format_JS_files_1475", "Control what method is used to detect module-format JS files."), auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules: a(1476, e2.DiagnosticCategory.Message, "auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_w_1476", '"auto": Treat files with imports, exports, import.meta, jsx (with jsx: react-jsx), or esm format (with module: node16+) as modules.'), The_types_of_0_are_incompatible_between_these_types: a(2200, e2.DiagnosticCategory.Error, "The_types_of_0_are_incompatible_between_these_types_2200", "The types of '{0}' are incompatible between these types."), The_types_returned_by_0_are_incompatible_between_these_types: a(2201, e2.DiagnosticCategory.Error, "The_types_returned_by_0_are_incompatible_between_these_types_2201", "The types returned by '{0}' are incompatible between these types."), Call_signature_return_types_0_and_1_are_incompatible: a(2202, e2.DiagnosticCategory.Error, "Call_signature_return_types_0_and_1_are_incompatible_2202", "Call signature return types '{0}' and '{1}' are incompatible.", void 0, true), Construct_signature_return_types_0_and_1_are_incompatible: a(2203, e2.DiagnosticCategory.Error, "Construct_signature_return_types_0_and_1_are_incompatible_2203", "Construct signature return types '{0}' and '{1}' are incompatible.", void 0, true), Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: a(2204, e2.DiagnosticCategory.Error, "Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2204", "Call signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true), Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1: a(2205, e2.DiagnosticCategory.Error, "Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1_2205", "Construct signatures with no arguments have incompatible return types '{0}' and '{1}'.", void 0, true), The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement: a(2206, e2.DiagnosticCategory.Error, "The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement_2206", "The 'type' modifier cannot be used on a named import when 'import type' is used on its import statement."), The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement: a(2207, e2.DiagnosticCategory.Error, "The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement_2207", "The 'type' modifier cannot be used on a named export when 'export type' is used on its export statement."), The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate: a(2209, e2.DiagnosticCategory.Error, "The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_roo_2209", "The project root is ambiguous, but is required to resolve export map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."), The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate: a(2210, e2.DiagnosticCategory.Error, "The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_roo_2210", "The project root is ambiguous, but is required to resolve import map entry '{0}' in file '{1}'. Supply the `rootDir` compiler option to disambiguate."), Duplicate_identifier_0: a(2300, e2.DiagnosticCategory.Error, "Duplicate_identifier_0_2300", "Duplicate identifier '{0}'."), Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor: a(2301, e2.DiagnosticCategory.Error, "Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor_2301", "Initializer of instance member variable '{0}' cannot reference identifier '{1}' declared in the constructor."), Static_members_cannot_reference_class_type_parameters: a(2302, e2.DiagnosticCategory.Error, "Static_members_cannot_reference_class_type_parameters_2302", "Static members cannot reference class type parameters."), Circular_definition_of_import_alias_0: a(2303, e2.DiagnosticCategory.Error, "Circular_definition_of_import_alias_0_2303", "Circular definition of import alias '{0}'."), Cannot_find_name_0: a(2304, e2.DiagnosticCategory.Error, "Cannot_find_name_0_2304", "Cannot find name '{0}'."), Module_0_has_no_exported_member_1: a(2305, e2.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_2305", "Module '{0}' has no exported member '{1}'."), File_0_is_not_a_module: a(2306, e2.DiagnosticCategory.Error, "File_0_is_not_a_module_2306", "File '{0}' is not a module."), Cannot_find_module_0_or_its_corresponding_type_declarations: a(2307, e2.DiagnosticCategory.Error, "Cannot_find_module_0_or_its_corresponding_type_declarations_2307", "Cannot find module '{0}' or its corresponding type declarations."), Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity: a(2308, e2.DiagnosticCategory.Error, "Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambig_2308", "Module {0} has already exported a member named '{1}'. Consider explicitly re-exporting to resolve the ambiguity."), An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements: a(2309, e2.DiagnosticCategory.Error, "An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements_2309", "An export assignment cannot be used in a module with other exported elements."), Type_0_recursively_references_itself_as_a_base_type: a(2310, e2.DiagnosticCategory.Error, "Type_0_recursively_references_itself_as_a_base_type_2310", "Type '{0}' recursively references itself as a base type."), Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function: a(2311, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function_2311", "Cannot find name '{0}'. Did you mean to write this in an async function?"), An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members: a(2312, e2.DiagnosticCategory.Error, "An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_me_2312", "An interface can only extend an object type or intersection of object types with statically known members."), Type_parameter_0_has_a_circular_constraint: a(2313, e2.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_constraint_2313", "Type parameter '{0}' has a circular constraint."), Generic_type_0_requires_1_type_argument_s: a(2314, e2.DiagnosticCategory.Error, "Generic_type_0_requires_1_type_argument_s_2314", "Generic type '{0}' requires {1} type argument(s)."), Type_0_is_not_generic: a(2315, e2.DiagnosticCategory.Error, "Type_0_is_not_generic_2315", "Type '{0}' is not generic."), Global_type_0_must_be_a_class_or_interface_type: a(2316, e2.DiagnosticCategory.Error, "Global_type_0_must_be_a_class_or_interface_type_2316", "Global type '{0}' must be a class or interface type."), Global_type_0_must_have_1_type_parameter_s: a(2317, e2.DiagnosticCategory.Error, "Global_type_0_must_have_1_type_parameter_s_2317", "Global type '{0}' must have {1} type parameter(s)."), Cannot_find_global_type_0: a(2318, e2.DiagnosticCategory.Error, "Cannot_find_global_type_0_2318", "Cannot find global type '{0}'."), Named_property_0_of_types_1_and_2_are_not_identical: a(2319, e2.DiagnosticCategory.Error, "Named_property_0_of_types_1_and_2_are_not_identical_2319", "Named property '{0}' of types '{1}' and '{2}' are not identical."), Interface_0_cannot_simultaneously_extend_types_1_and_2: a(2320, e2.DiagnosticCategory.Error, "Interface_0_cannot_simultaneously_extend_types_1_and_2_2320", "Interface '{0}' cannot simultaneously extend types '{1}' and '{2}'."), Excessive_stack_depth_comparing_types_0_and_1: a(2321, e2.DiagnosticCategory.Error, "Excessive_stack_depth_comparing_types_0_and_1_2321", "Excessive stack depth comparing types '{0}' and '{1}'."), Type_0_is_not_assignable_to_type_1: a(2322, e2.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_2322", "Type '{0}' is not assignable to type '{1}'."), Cannot_redeclare_exported_variable_0: a(2323, e2.DiagnosticCategory.Error, "Cannot_redeclare_exported_variable_0_2323", "Cannot redeclare exported variable '{0}'."), Property_0_is_missing_in_type_1: a(2324, e2.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_2324", "Property '{0}' is missing in type '{1}'."), Property_0_is_private_in_type_1_but_not_in_type_2: a(2325, e2.DiagnosticCategory.Error, "Property_0_is_private_in_type_1_but_not_in_type_2_2325", "Property '{0}' is private in type '{1}' but not in type '{2}'."), Types_of_property_0_are_incompatible: a(2326, e2.DiagnosticCategory.Error, "Types_of_property_0_are_incompatible_2326", "Types of property '{0}' are incompatible."), Property_0_is_optional_in_type_1_but_required_in_type_2: a(2327, e2.DiagnosticCategory.Error, "Property_0_is_optional_in_type_1_but_required_in_type_2_2327", "Property '{0}' is optional in type '{1}' but required in type '{2}'."), Types_of_parameters_0_and_1_are_incompatible: a(2328, e2.DiagnosticCategory.Error, "Types_of_parameters_0_and_1_are_incompatible_2328", "Types of parameters '{0}' and '{1}' are incompatible."), Index_signature_for_type_0_is_missing_in_type_1: a(2329, e2.DiagnosticCategory.Error, "Index_signature_for_type_0_is_missing_in_type_1_2329", "Index signature for type '{0}' is missing in type '{1}'."), _0_and_1_index_signatures_are_incompatible: a(2330, e2.DiagnosticCategory.Error, "_0_and_1_index_signatures_are_incompatible_2330", "'{0}' and '{1}' index signatures are incompatible."), this_cannot_be_referenced_in_a_module_or_namespace_body: a(2331, e2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_module_or_namespace_body_2331", "'this' cannot be referenced in a module or namespace body."), this_cannot_be_referenced_in_current_location: a(2332, e2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_current_location_2332", "'this' cannot be referenced in current location."), this_cannot_be_referenced_in_constructor_arguments: a(2333, e2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_constructor_arguments_2333", "'this' cannot be referenced in constructor arguments."), this_cannot_be_referenced_in_a_static_property_initializer: a(2334, e2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_static_property_initializer_2334", "'this' cannot be referenced in a static property initializer."), super_can_only_be_referenced_in_a_derived_class: a(2335, e2.DiagnosticCategory.Error, "super_can_only_be_referenced_in_a_derived_class_2335", "'super' can only be referenced in a derived class."), super_cannot_be_referenced_in_constructor_arguments: a(2336, e2.DiagnosticCategory.Error, "super_cannot_be_referenced_in_constructor_arguments_2336", "'super' cannot be referenced in constructor arguments."), Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors: a(2337, e2.DiagnosticCategory.Error, "Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors_2337", "Super calls are not permitted outside constructors or in nested functions inside constructors."), super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class: a(2338, e2.DiagnosticCategory.Error, "super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_der_2338", "'super' property access is permitted only in a constructor, member function, or member accessor of a derived class."), Property_0_does_not_exist_on_type_1: a(2339, e2.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_2339", "Property '{0}' does not exist on type '{1}'."), Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword: a(2340, e2.DiagnosticCategory.Error, "Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword_2340", "Only public and protected methods of the base class are accessible via the 'super' keyword."), Property_0_is_private_and_only_accessible_within_class_1: a(2341, e2.DiagnosticCategory.Error, "Property_0_is_private_and_only_accessible_within_class_1_2341", "Property '{0}' is private and only accessible within class '{1}'."), This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0: a(2343, e2.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_ve_2343", "This syntax requires an imported helper named '{1}' which does not exist in '{0}'. Consider upgrading your version of '{0}'."), Type_0_does_not_satisfy_the_constraint_1: a(2344, e2.DiagnosticCategory.Error, "Type_0_does_not_satisfy_the_constraint_1_2344", "Type '{0}' does not satisfy the constraint '{1}'."), Argument_of_type_0_is_not_assignable_to_parameter_of_type_1: a(2345, e2.DiagnosticCategory.Error, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_2345", "Argument of type '{0}' is not assignable to parameter of type '{1}'."), Call_target_does_not_contain_any_signatures: a(2346, e2.DiagnosticCategory.Error, "Call_target_does_not_contain_any_signatures_2346", "Call target does not contain any signatures."), Untyped_function_calls_may_not_accept_type_arguments: a(2347, e2.DiagnosticCategory.Error, "Untyped_function_calls_may_not_accept_type_arguments_2347", "Untyped function calls may not accept type arguments."), Value_of_type_0_is_not_callable_Did_you_mean_to_include_new: a(2348, e2.DiagnosticCategory.Error, "Value_of_type_0_is_not_callable_Did_you_mean_to_include_new_2348", "Value of type '{0}' is not callable. Did you mean to include 'new'?"), This_expression_is_not_callable: a(2349, e2.DiagnosticCategory.Error, "This_expression_is_not_callable_2349", "This expression is not callable."), Only_a_void_function_can_be_called_with_the_new_keyword: a(2350, e2.DiagnosticCategory.Error, "Only_a_void_function_can_be_called_with_the_new_keyword_2350", "Only a void function can be called with the 'new' keyword."), This_expression_is_not_constructable: a(2351, e2.DiagnosticCategory.Error, "This_expression_is_not_constructable_2351", "This expression is not constructable."), Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first: a(2352, e2.DiagnosticCategory.Error, "Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the__2352", "Conversion of type '{0}' to type '{1}' may be a mistake because neither type sufficiently overlaps with the other. If this was intentional, convert the expression to 'unknown' first."), Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1: a(2353, e2.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1_2353", "Object literal may only specify known properties, and '{0}' does not exist in type '{1}'."), This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found: a(2354, e2.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found_2354", "This syntax requires an imported helper but module '{0}' cannot be found."), A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value: a(2355, e2.DiagnosticCategory.Error, "A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value_2355", "A function whose declared type is neither 'void' nor 'any' must return a value."), An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type: a(2356, e2.DiagnosticCategory.Error, "An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type_2356", "An arithmetic operand must be of type 'any', 'number', 'bigint' or an enum type."), The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access: a(2357, e2.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access_2357", "The operand of an increment or decrement operator must be a variable or a property access."), The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter: a(2358, e2.DiagnosticCategory.Error, "The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_paramete_2358", "The left-hand side of an 'instanceof' expression must be of type 'any', an object type or a type parameter."), The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type: a(2359, e2.DiagnosticCategory.Error, "The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_F_2359", "The right-hand side of an 'instanceof' expression must be of type 'any' or of a type assignable to the 'Function' interface type."), The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or_symbol: a(2360, e2.DiagnosticCategory.Error, "The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or__2360", "The left-hand side of an 'in' expression must be a private identifier or of type 'any', 'string', 'number', or 'symbol'."), The_right_hand_side_of_an_in_expression_must_not_be_a_primitive: a(2361, e2.DiagnosticCategory.Error, "The_right_hand_side_of_an_in_expression_must_not_be_a_primitive_2361", "The right-hand side of an 'in' expression must not be a primitive."), The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: a(2362, e2.DiagnosticCategory.Error, "The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2362", "The left-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."), The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type: a(2363, e2.DiagnosticCategory.Error, "The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type_2363", "The right-hand side of an arithmetic operation must be of type 'any', 'number', 'bigint' or an enum type."), The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access: a(2364, e2.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access_2364", "The left-hand side of an assignment expression must be a variable or a property access."), Operator_0_cannot_be_applied_to_types_1_and_2: a(2365, e2.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_types_1_and_2_2365", "Operator '{0}' cannot be applied to types '{1}' and '{2}'."), Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined: a(2366, e2.DiagnosticCategory.Error, "Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined_2366", "Function lacks ending return statement and return type does not include 'undefined'."), This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap: a(2367, e2.DiagnosticCategory.Error, "This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap_2367", "This condition will always return '{0}' since the types '{1}' and '{2}' have no overlap."), Type_parameter_name_cannot_be_0: a(2368, e2.DiagnosticCategory.Error, "Type_parameter_name_cannot_be_0_2368", "Type parameter name cannot be '{0}'."), A_parameter_property_is_only_allowed_in_a_constructor_implementation: a(2369, e2.DiagnosticCategory.Error, "A_parameter_property_is_only_allowed_in_a_constructor_implementation_2369", "A parameter property is only allowed in a constructor implementation."), A_rest_parameter_must_be_of_an_array_type: a(2370, e2.DiagnosticCategory.Error, "A_rest_parameter_must_be_of_an_array_type_2370", "A rest parameter must be of an array type."), A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation: a(2371, e2.DiagnosticCategory.Error, "A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation_2371", "A parameter initializer is only allowed in a function or constructor implementation."), Parameter_0_cannot_reference_itself: a(2372, e2.DiagnosticCategory.Error, "Parameter_0_cannot_reference_itself_2372", "Parameter '{0}' cannot reference itself."), Parameter_0_cannot_reference_identifier_1_declared_after_it: a(2373, e2.DiagnosticCategory.Error, "Parameter_0_cannot_reference_identifier_1_declared_after_it_2373", "Parameter '{0}' cannot reference identifier '{1}' declared after it."), Duplicate_index_signature_for_type_0: a(2374, e2.DiagnosticCategory.Error, "Duplicate_index_signature_for_type_0_2374", "Duplicate index signature for type '{0}'."), Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties: a(2375, e2.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2375", "Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."), A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers: a(2376, e2.DiagnosticCategory.Error, "A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_2376", "A 'super' call must be the first statement in the constructor to refer to 'super' or 'this' when a derived class contains initialized properties, parameter properties, or private identifiers."), Constructors_for_derived_classes_must_contain_a_super_call: a(2377, e2.DiagnosticCategory.Error, "Constructors_for_derived_classes_must_contain_a_super_call_2377", "Constructors for derived classes must contain a 'super' call."), A_get_accessor_must_return_a_value: a(2378, e2.DiagnosticCategory.Error, "A_get_accessor_must_return_a_value_2378", "A 'get' accessor must return a value."), Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties: a(2379, e2.DiagnosticCategory.Error, "Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_tr_2379", "Argument of type '{0}' is not assignable to parameter of type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the types of the target's properties."), The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type: a(2380, e2.DiagnosticCategory.Error, "The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type_2380", "The return type of a 'get' accessor must be assignable to its 'set' accessor type"), Overload_signatures_must_all_be_exported_or_non_exported: a(2383, e2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_exported_or_non_exported_2383", "Overload signatures must all be exported or non-exported."), Overload_signatures_must_all_be_ambient_or_non_ambient: a(2384, e2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_ambient_or_non_ambient_2384", "Overload signatures must all be ambient or non-ambient."), Overload_signatures_must_all_be_public_private_or_protected: a(2385, e2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_public_private_or_protected_2385", "Overload signatures must all be public, private or protected."), Overload_signatures_must_all_be_optional_or_required: a(2386, e2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_optional_or_required_2386", "Overload signatures must all be optional or required."), Function_overload_must_be_static: a(2387, e2.DiagnosticCategory.Error, "Function_overload_must_be_static_2387", "Function overload must be static."), Function_overload_must_not_be_static: a(2388, e2.DiagnosticCategory.Error, "Function_overload_must_not_be_static_2388", "Function overload must not be static."), Function_implementation_name_must_be_0: a(2389, e2.DiagnosticCategory.Error, "Function_implementation_name_must_be_0_2389", "Function implementation name must be '{0}'."), Constructor_implementation_is_missing: a(2390, e2.DiagnosticCategory.Error, "Constructor_implementation_is_missing_2390", "Constructor implementation is missing."), Function_implementation_is_missing_or_not_immediately_following_the_declaration: a(2391, e2.DiagnosticCategory.Error, "Function_implementation_is_missing_or_not_immediately_following_the_declaration_2391", "Function implementation is missing or not immediately following the declaration."), Multiple_constructor_implementations_are_not_allowed: a(2392, e2.DiagnosticCategory.Error, "Multiple_constructor_implementations_are_not_allowed_2392", "Multiple constructor implementations are not allowed."), Duplicate_function_implementation: a(2393, e2.DiagnosticCategory.Error, "Duplicate_function_implementation_2393", "Duplicate function implementation."), This_overload_signature_is_not_compatible_with_its_implementation_signature: a(2394, e2.DiagnosticCategory.Error, "This_overload_signature_is_not_compatible_with_its_implementation_signature_2394", "This overload signature is not compatible with its implementation signature."), Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local: a(2395, e2.DiagnosticCategory.Error, "Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local_2395", "Individual declarations in merged declaration '{0}' must be all exported or all local."), Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters: a(2396, e2.DiagnosticCategory.Error, "Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters_2396", "Duplicate identifier 'arguments'. Compiler uses 'arguments' to initialize rest parameters."), Declaration_name_conflicts_with_built_in_global_identifier_0: a(2397, e2.DiagnosticCategory.Error, "Declaration_name_conflicts_with_built_in_global_identifier_0_2397", "Declaration name conflicts with built-in global identifier '{0}'."), constructor_cannot_be_used_as_a_parameter_property_name: a(2398, e2.DiagnosticCategory.Error, "constructor_cannot_be_used_as_a_parameter_property_name_2398", "'constructor' cannot be used as a parameter property name."), Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference: a(2399, e2.DiagnosticCategory.Error, "Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference_2399", "Duplicate identifier '_this'. Compiler uses variable declaration '_this' to capture 'this' reference."), Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference: a(2400, e2.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference_2400", "Expression resolves to variable declaration '_this' that compiler uses to capture 'this' reference."), A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers: a(2401, e2.DiagnosticCategory.Error, "A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_in_2401", "A 'super' call must be a root-level statement within a constructor of a derived class that contains initialized properties, parameter properties, or private identifiers."), Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference: a(2402, e2.DiagnosticCategory.Error, "Expression_resolves_to_super_that_compiler_uses_to_capture_base_class_reference_2402", "Expression resolves to '_super' that compiler uses to capture base class reference."), Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2: a(2403, e2.DiagnosticCategory.Error, "Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_t_2403", "Subsequent variable declarations must have the same type.  Variable '{0}' must be of type '{1}', but here has type '{2}'."), The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation: a(2404, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation_2404", "The left-hand side of a 'for...in' statement cannot use a type annotation."), The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any: a(2405, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any_2405", "The left-hand side of a 'for...in' statement must be of type 'string' or 'any'."), The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access: a(2406, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access_2406", "The left-hand side of a 'for...in' statement must be a variable or a property access."), The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0: a(2407, e2.DiagnosticCategory.Error, "The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_2407", "The right-hand side of a 'for...in' statement must be of type 'any', an object type or a type parameter, but here has type '{0}'."), Setters_cannot_return_a_value: a(2408, e2.DiagnosticCategory.Error, "Setters_cannot_return_a_value_2408", "Setters cannot return a value."), Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class: a(2409, e2.DiagnosticCategory.Error, "Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class_2409", "Return type of constructor signature must be assignable to the instance type of the class."), The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any: a(2410, e2.DiagnosticCategory.Error, "The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any_2410", "The 'with' statement is not supported. All symbols in a 'with' block will have type 'any'."), Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target: a(2412, e2.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefi_2412", "Type '{0}' is not assignable to type '{1}' with 'exactOptionalPropertyTypes: true'. Consider adding 'undefined' to the type of the target."), Property_0_of_type_1_is_not_assignable_to_2_index_type_3: a(2411, e2.DiagnosticCategory.Error, "Property_0_of_type_1_is_not_assignable_to_2_index_type_3_2411", "Property '{0}' of type '{1}' is not assignable to '{2}' index type '{3}'."), _0_index_type_1_is_not_assignable_to_2_index_type_3: a(2413, e2.DiagnosticCategory.Error, "_0_index_type_1_is_not_assignable_to_2_index_type_3_2413", "'{0}' index type '{1}' is not assignable to '{2}' index type '{3}'."), Class_name_cannot_be_0: a(2414, e2.DiagnosticCategory.Error, "Class_name_cannot_be_0_2414", "Class name cannot be '{0}'."), Class_0_incorrectly_extends_base_class_1: a(2415, e2.DiagnosticCategory.Error, "Class_0_incorrectly_extends_base_class_1_2415", "Class '{0}' incorrectly extends base class '{1}'."), Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2: a(2416, e2.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2_2416", "Property '{0}' in type '{1}' is not assignable to the same property in base type '{2}'."), Class_static_side_0_incorrectly_extends_base_class_static_side_1: a(2417, e2.DiagnosticCategory.Error, "Class_static_side_0_incorrectly_extends_base_class_static_side_1_2417", "Class static side '{0}' incorrectly extends base class static side '{1}'."), Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1: a(2418, e2.DiagnosticCategory.Error, "Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1_2418", "Type of computed property's value is '{0}', which is not assignable to type '{1}'."), Types_of_construct_signatures_are_incompatible: a(2419, e2.DiagnosticCategory.Error, "Types_of_construct_signatures_are_incompatible_2419", "Types of construct signatures are incompatible."), Class_0_incorrectly_implements_interface_1: a(2420, e2.DiagnosticCategory.Error, "Class_0_incorrectly_implements_interface_1_2420", "Class '{0}' incorrectly implements interface '{1}'."), A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members: a(2422, e2.DiagnosticCategory.Error, "A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_memb_2422", "A class can only implement an object type or intersection of object types with statically known members."), Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor: a(2423, e2.DiagnosticCategory.Error, "Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_access_2423", "Class '{0}' defines instance member function '{1}', but extended class '{2}' defines it as instance member accessor."), Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function: a(2425, e2.DiagnosticCategory.Error, "Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_functi_2425", "Class '{0}' defines instance member property '{1}', but extended class '{2}' defines it as instance member function."), Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function: a(2426, e2.DiagnosticCategory.Error, "Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_functi_2426", "Class '{0}' defines instance member accessor '{1}', but extended class '{2}' defines it as instance member function."), Interface_name_cannot_be_0: a(2427, e2.DiagnosticCategory.Error, "Interface_name_cannot_be_0_2427", "Interface name cannot be '{0}'."), All_declarations_of_0_must_have_identical_type_parameters: a(2428, e2.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_type_parameters_2428", "All declarations of '{0}' must have identical type parameters."), Interface_0_incorrectly_extends_interface_1: a(2430, e2.DiagnosticCategory.Error, "Interface_0_incorrectly_extends_interface_1_2430", "Interface '{0}' incorrectly extends interface '{1}'."), Enum_name_cannot_be_0: a(2431, e2.DiagnosticCategory.Error, "Enum_name_cannot_be_0_2431", "Enum name cannot be '{0}'."), In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element: a(2432, e2.DiagnosticCategory.Error, "In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enu_2432", "In an enum with multiple declarations, only one declaration can omit an initializer for its first enum element."), A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged: a(2433, e2.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merg_2433", "A namespace declaration cannot be in a different file from a class or function with which it is merged."), A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged: a(2434, e2.DiagnosticCategory.Error, "A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged_2434", "A namespace declaration cannot be located prior to a class or function with which it is merged."), Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces: a(2435, e2.DiagnosticCategory.Error, "Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces_2435", "Ambient modules cannot be nested in other modules or namespaces."), Ambient_module_declaration_cannot_specify_relative_module_name: a(2436, e2.DiagnosticCategory.Error, "Ambient_module_declaration_cannot_specify_relative_module_name_2436", "Ambient module declaration cannot specify relative module name."), Module_0_is_hidden_by_a_local_declaration_with_the_same_name: a(2437, e2.DiagnosticCategory.Error, "Module_0_is_hidden_by_a_local_declaration_with_the_same_name_2437", "Module '{0}' is hidden by a local declaration with the same name."), Import_name_cannot_be_0: a(2438, e2.DiagnosticCategory.Error, "Import_name_cannot_be_0_2438", "Import name cannot be '{0}'."), Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name: a(2439, e2.DiagnosticCategory.Error, "Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relati_2439", "Import or export declaration in an ambient module declaration cannot reference module through relative module name."), Import_declaration_conflicts_with_local_declaration_of_0: a(2440, e2.DiagnosticCategory.Error, "Import_declaration_conflicts_with_local_declaration_of_0_2440", "Import declaration conflicts with local declaration of '{0}'."), Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module: a(2441, e2.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_2441", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module."), Types_have_separate_declarations_of_a_private_property_0: a(2442, e2.DiagnosticCategory.Error, "Types_have_separate_declarations_of_a_private_property_0_2442", "Types have separate declarations of a private property '{0}'."), Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2: a(2443, e2.DiagnosticCategory.Error, "Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2_2443", "Property '{0}' is protected but type '{1}' is not a class derived from '{2}'."), Property_0_is_protected_in_type_1_but_public_in_type_2: a(2444, e2.DiagnosticCategory.Error, "Property_0_is_protected_in_type_1_but_public_in_type_2_2444", "Property '{0}' is protected in type '{1}' but public in type '{2}'."), Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses: a(2445, e2.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses_2445", "Property '{0}' is protected and only accessible within class '{1}' and its subclasses."), Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2: a(2446, e2.DiagnosticCategory.Error, "Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_cl_2446", "Property '{0}' is protected and only accessible through an instance of class '{1}'. This is an instance of class '{2}'."), The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead: a(2447, e2.DiagnosticCategory.Error, "The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead_2447", "The '{0}' operator is not allowed for boolean types. Consider using '{1}' instead."), Block_scoped_variable_0_used_before_its_declaration: a(2448, e2.DiagnosticCategory.Error, "Block_scoped_variable_0_used_before_its_declaration_2448", "Block-scoped variable '{0}' used before its declaration."), Class_0_used_before_its_declaration: a(2449, e2.DiagnosticCategory.Error, "Class_0_used_before_its_declaration_2449", "Class '{0}' used before its declaration."), Enum_0_used_before_its_declaration: a(2450, e2.DiagnosticCategory.Error, "Enum_0_used_before_its_declaration_2450", "Enum '{0}' used before its declaration."), Cannot_redeclare_block_scoped_variable_0: a(2451, e2.DiagnosticCategory.Error, "Cannot_redeclare_block_scoped_variable_0_2451", "Cannot redeclare block-scoped variable '{0}'."), An_enum_member_cannot_have_a_numeric_name: a(2452, e2.DiagnosticCategory.Error, "An_enum_member_cannot_have_a_numeric_name_2452", "An enum member cannot have a numeric name."), Variable_0_is_used_before_being_assigned: a(2454, e2.DiagnosticCategory.Error, "Variable_0_is_used_before_being_assigned_2454", "Variable '{0}' is used before being assigned."), Type_alias_0_circularly_references_itself: a(2456, e2.DiagnosticCategory.Error, "Type_alias_0_circularly_references_itself_2456", "Type alias '{0}' circularly references itself."), Type_alias_name_cannot_be_0: a(2457, e2.DiagnosticCategory.Error, "Type_alias_name_cannot_be_0_2457", "Type alias name cannot be '{0}'."), An_AMD_module_cannot_have_multiple_name_assignments: a(2458, e2.DiagnosticCategory.Error, "An_AMD_module_cannot_have_multiple_name_assignments_2458", "An AMD module cannot have multiple name assignments."), Module_0_declares_1_locally_but_it_is_not_exported: a(2459, e2.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_not_exported_2459", "Module '{0}' declares '{1}' locally, but it is not exported."), Module_0_declares_1_locally_but_it_is_exported_as_2: a(2460, e2.DiagnosticCategory.Error, "Module_0_declares_1_locally_but_it_is_exported_as_2_2460", "Module '{0}' declares '{1}' locally, but it is exported as '{2}'."), Type_0_is_not_an_array_type: a(2461, e2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_2461", "Type '{0}' is not an array type."), A_rest_element_must_be_last_in_a_destructuring_pattern: a(2462, e2.DiagnosticCategory.Error, "A_rest_element_must_be_last_in_a_destructuring_pattern_2462", "A rest element must be last in a destructuring pattern."), A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature: a(2463, e2.DiagnosticCategory.Error, "A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature_2463", "A binding pattern parameter cannot be optional in an implementation signature."), A_computed_property_name_must_be_of_type_string_number_symbol_or_any: a(2464, e2.DiagnosticCategory.Error, "A_computed_property_name_must_be_of_type_string_number_symbol_or_any_2464", "A computed property name must be of type 'string', 'number', 'symbol', or 'any'."), this_cannot_be_referenced_in_a_computed_property_name: a(2465, e2.DiagnosticCategory.Error, "this_cannot_be_referenced_in_a_computed_property_name_2465", "'this' cannot be referenced in a computed property name."), super_cannot_be_referenced_in_a_computed_property_name: a(2466, e2.DiagnosticCategory.Error, "super_cannot_be_referenced_in_a_computed_property_name_2466", "'super' cannot be referenced in a computed property name."), A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type: a(2467, e2.DiagnosticCategory.Error, "A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type_2467", "A computed property name cannot reference a type parameter from its containing type."), Cannot_find_global_value_0: a(2468, e2.DiagnosticCategory.Error, "Cannot_find_global_value_0_2468", "Cannot find global value '{0}'."), The_0_operator_cannot_be_applied_to_type_symbol: a(2469, e2.DiagnosticCategory.Error, "The_0_operator_cannot_be_applied_to_type_symbol_2469", "The '{0}' operator cannot be applied to type 'symbol'."), Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher: a(2472, e2.DiagnosticCategory.Error, "Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher_2472", "Spread operator in 'new' expressions is only available when targeting ECMAScript 5 and higher."), Enum_declarations_must_all_be_const_or_non_const: a(2473, e2.DiagnosticCategory.Error, "Enum_declarations_must_all_be_const_or_non_const_2473", "Enum declarations must all be const or non-const."), const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values: a(2474, e2.DiagnosticCategory.Error, "const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values_2474", "const enum member initializers can only contain literal values and other computed enum values."), const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query: a(2475, e2.DiagnosticCategory.Error, "const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_im_2475", "'const' enums can only be used in property or index access expressions or the right hand side of an import declaration or export assignment or type query."), A_const_enum_member_can_only_be_accessed_using_a_string_literal: a(2476, e2.DiagnosticCategory.Error, "A_const_enum_member_can_only_be_accessed_using_a_string_literal_2476", "A const enum member can only be accessed using a string literal."), const_enum_member_initializer_was_evaluated_to_a_non_finite_value: a(2477, e2.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_a_non_finite_value_2477", "'const' enum member initializer was evaluated to a non-finite value."), const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN: a(2478, e2.DiagnosticCategory.Error, "const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN_2478", "'const' enum member initializer was evaluated to disallowed value 'NaN'."), let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations: a(2480, e2.DiagnosticCategory.Error, "let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations_2480", "'let' is not allowed to be used as a name in 'let' or 'const' declarations."), Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1: a(2481, e2.DiagnosticCategory.Error, "Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1_2481", "Cannot initialize outer scoped variable '{0}' in the same scope as block scoped declaration '{1}'."), The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation: a(2483, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation_2483", "The left-hand side of a 'for...of' statement cannot use a type annotation."), Export_declaration_conflicts_with_exported_declaration_of_0: a(2484, e2.DiagnosticCategory.Error, "Export_declaration_conflicts_with_exported_declaration_of_0_2484", "Export declaration conflicts with exported declaration of '{0}'."), The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access: a(2487, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access_2487", "The left-hand side of a 'for...of' statement must be a variable or a property access."), Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator: a(2488, e2.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator_2488", "Type '{0}' must have a '[Symbol.iterator]()' method that returns an iterator."), An_iterator_must_have_a_next_method: a(2489, e2.DiagnosticCategory.Error, "An_iterator_must_have_a_next_method_2489", "An iterator must have a 'next()' method."), The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property: a(2490, e2.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property_2490", "The type returned by the '{0}()' method of an iterator must have a 'value' property."), The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern: a(2491, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern_2491", "The left-hand side of a 'for...in' statement cannot be a destructuring pattern."), Cannot_redeclare_identifier_0_in_catch_clause: a(2492, e2.DiagnosticCategory.Error, "Cannot_redeclare_identifier_0_in_catch_clause_2492", "Cannot redeclare identifier '{0}' in catch clause."), Tuple_type_0_of_length_1_has_no_element_at_index_2: a(2493, e2.DiagnosticCategory.Error, "Tuple_type_0_of_length_1_has_no_element_at_index_2_2493", "Tuple type '{0}' of length '{1}' has no element at index '{2}'."), Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher: a(2494, e2.DiagnosticCategory.Error, "Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher_2494", "Using a string in a 'for...of' statement is only supported in ECMAScript 5 and higher."), Type_0_is_not_an_array_type_or_a_string_type: a(2495, e2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_2495", "Type '{0}' is not an array type or a string type."), The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression: a(2496, e2.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_stand_2496", "The 'arguments' object cannot be referenced in an arrow function in ES3 and ES5. Consider using a standard function expression."), This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export: a(2497, e2.DiagnosticCategory.Error, "This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_2497", "This module can only be referenced with ECMAScript imports/exports by turning on the '{0}' flag and referencing its default export."), Module_0_uses_export_and_cannot_be_used_with_export_Asterisk: a(2498, e2.DiagnosticCategory.Error, "Module_0_uses_export_and_cannot_be_used_with_export_Asterisk_2498", "Module '{0}' uses 'export =' and cannot be used with 'export *'."), An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments: a(2499, e2.DiagnosticCategory.Error, "An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments_2499", "An interface can only extend an identifier/qualified-name with optional type arguments."), A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments: a(2500, e2.DiagnosticCategory.Error, "A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments_2500", "A class can only implement an identifier/qualified-name with optional type arguments."), A_rest_element_cannot_contain_a_binding_pattern: a(2501, e2.DiagnosticCategory.Error, "A_rest_element_cannot_contain_a_binding_pattern_2501", "A rest element cannot contain a binding pattern."), _0_is_referenced_directly_or_indirectly_in_its_own_type_annotation: a(2502, e2.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_type_annotation_2502", "'{0}' is referenced directly or indirectly in its own type annotation."), Cannot_find_namespace_0: a(2503, e2.DiagnosticCategory.Error, "Cannot_find_namespace_0_2503", "Cannot find namespace '{0}'."), Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator: a(2504, e2.DiagnosticCategory.Error, "Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator_2504", "Type '{0}' must have a '[Symbol.asyncIterator]()' method that returns an async iterator."), A_generator_cannot_have_a_void_type_annotation: a(2505, e2.DiagnosticCategory.Error, "A_generator_cannot_have_a_void_type_annotation_2505", "A generator cannot have a 'void' type annotation."), _0_is_referenced_directly_or_indirectly_in_its_own_base_expression: a(2506, e2.DiagnosticCategory.Error, "_0_is_referenced_directly_or_indirectly_in_its_own_base_expression_2506", "'{0}' is referenced directly or indirectly in its own base expression."), Type_0_is_not_a_constructor_function_type: a(2507, e2.DiagnosticCategory.Error, "Type_0_is_not_a_constructor_function_type_2507", "Type '{0}' is not a constructor function type."), No_base_constructor_has_the_specified_number_of_type_arguments: a(2508, e2.DiagnosticCategory.Error, "No_base_constructor_has_the_specified_number_of_type_arguments_2508", "No base constructor has the specified number of type arguments."), Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members: a(2509, e2.DiagnosticCategory.Error, "Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_2509", "Base constructor return type '{0}' is not an object type or intersection of object types with statically known members."), Base_constructors_must_all_have_the_same_return_type: a(2510, e2.DiagnosticCategory.Error, "Base_constructors_must_all_have_the_same_return_type_2510", "Base constructors must all have the same return type."), Cannot_create_an_instance_of_an_abstract_class: a(2511, e2.DiagnosticCategory.Error, "Cannot_create_an_instance_of_an_abstract_class_2511", "Cannot create an instance of an abstract class."), Overload_signatures_must_all_be_abstract_or_non_abstract: a(2512, e2.DiagnosticCategory.Error, "Overload_signatures_must_all_be_abstract_or_non_abstract_2512", "Overload signatures must all be abstract or non-abstract."), Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression: a(2513, e2.DiagnosticCategory.Error, "Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression_2513", "Abstract method '{0}' in class '{1}' cannot be accessed via super expression."), Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2: a(2515, e2.DiagnosticCategory.Error, "Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2_2515", "Non-abstract class '{0}' does not implement inherited abstract member '{1}' from class '{2}'."), All_declarations_of_an_abstract_method_must_be_consecutive: a(2516, e2.DiagnosticCategory.Error, "All_declarations_of_an_abstract_method_must_be_consecutive_2516", "All declarations of an abstract method must be consecutive."), Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type: a(2517, e2.DiagnosticCategory.Error, "Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type_2517", "Cannot assign an abstract constructor type to a non-abstract constructor type."), A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard: a(2518, e2.DiagnosticCategory.Error, "A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard_2518", "A 'this'-based type guard is not compatible with a parameter-based type guard."), An_async_iterator_must_have_a_next_method: a(2519, e2.DiagnosticCategory.Error, "An_async_iterator_must_have_a_next_method_2519", "An async iterator must have a 'next()' method."), Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions: a(2520, e2.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions_2520", "Duplicate identifier '{0}'. Compiler uses declaration '{1}' to support async functions."), The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method: a(2522, e2.DiagnosticCategory.Error, "The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_usi_2522", "The 'arguments' object cannot be referenced in an async function or method in ES3 and ES5. Consider using a standard function or method."), yield_expressions_cannot_be_used_in_a_parameter_initializer: a(2523, e2.DiagnosticCategory.Error, "yield_expressions_cannot_be_used_in_a_parameter_initializer_2523", "'yield' expressions cannot be used in a parameter initializer."), await_expressions_cannot_be_used_in_a_parameter_initializer: a(2524, e2.DiagnosticCategory.Error, "await_expressions_cannot_be_used_in_a_parameter_initializer_2524", "'await' expressions cannot be used in a parameter initializer."), Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value: a(2525, e2.DiagnosticCategory.Error, "Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value_2525", "Initializer provides no value for this binding element and the binding element has no default value."), A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface: a(2526, e2.DiagnosticCategory.Error, "A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface_2526", "A 'this' type is available only in a non-static member of a class or interface."), The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary: a(2527, e2.DiagnosticCategory.Error, "The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary_2527", "The inferred type of '{0}' references an inaccessible '{1}' type. A type annotation is necessary."), A_module_cannot_have_multiple_default_exports: a(2528, e2.DiagnosticCategory.Error, "A_module_cannot_have_multiple_default_exports_2528", "A module cannot have multiple default exports."), Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions: a(2529, e2.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_func_2529", "Duplicate identifier '{0}'. Compiler reserves name '{1}' in top level scope of a module containing async functions."), Property_0_is_incompatible_with_index_signature: a(2530, e2.DiagnosticCategory.Error, "Property_0_is_incompatible_with_index_signature_2530", "Property '{0}' is incompatible with index signature."), Object_is_possibly_null: a(2531, e2.DiagnosticCategory.Error, "Object_is_possibly_null_2531", "Object is possibly 'null'."), Object_is_possibly_undefined: a(2532, e2.DiagnosticCategory.Error, "Object_is_possibly_undefined_2532", "Object is possibly 'undefined'."), Object_is_possibly_null_or_undefined: a(2533, e2.DiagnosticCategory.Error, "Object_is_possibly_null_or_undefined_2533", "Object is possibly 'null' or 'undefined'."), A_function_returning_never_cannot_have_a_reachable_end_point: a(2534, e2.DiagnosticCategory.Error, "A_function_returning_never_cannot_have_a_reachable_end_point_2534", "A function returning 'never' cannot have a reachable end point."), Enum_type_0_has_members_with_initializers_that_are_not_literals: a(2535, e2.DiagnosticCategory.Error, "Enum_type_0_has_members_with_initializers_that_are_not_literals_2535", "Enum type '{0}' has members with initializers that are not literals."), Type_0_cannot_be_used_to_index_type_1: a(2536, e2.DiagnosticCategory.Error, "Type_0_cannot_be_used_to_index_type_1_2536", "Type '{0}' cannot be used to index type '{1}'."), Type_0_has_no_matching_index_signature_for_type_1: a(2537, e2.DiagnosticCategory.Error, "Type_0_has_no_matching_index_signature_for_type_1_2537", "Type '{0}' has no matching index signature for type '{1}'."), Type_0_cannot_be_used_as_an_index_type: a(2538, e2.DiagnosticCategory.Error, "Type_0_cannot_be_used_as_an_index_type_2538", "Type '{0}' cannot be used as an index type."), Cannot_assign_to_0_because_it_is_not_a_variable: a(2539, e2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_not_a_variable_2539", "Cannot assign to '{0}' because it is not a variable."), Cannot_assign_to_0_because_it_is_a_read_only_property: a(2540, e2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_read_only_property_2540", "Cannot assign to '{0}' because it is a read-only property."), Index_signature_in_type_0_only_permits_reading: a(2542, e2.DiagnosticCategory.Error, "Index_signature_in_type_0_only_permits_reading_2542", "Index signature in type '{0}' only permits reading."), Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference: a(2543, e2.DiagnosticCategory.Error, "Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_me_2543", "Duplicate identifier '_newTarget'. Compiler uses variable declaration '_newTarget' to capture 'new.target' meta-property reference."), Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference: a(2544, e2.DiagnosticCategory.Error, "Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta__2544", "Expression resolves to variable declaration '_newTarget' that compiler uses to capture 'new.target' meta-property reference."), A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any: a(2545, e2.DiagnosticCategory.Error, "A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any_2545", "A mixin class must have a constructor with a single rest parameter of type 'any[]'."), The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property: a(2547, e2.DiagnosticCategory.Error, "The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_pro_2547", "The type returned by the '{0}()' method of an async iterator must be a promise for a type with a 'value' property."), Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: a(2548, e2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator_2548", "Type '{0}' is not an array type or does not have a '[Symbol.iterator]()' method that returns an iterator."), Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator: a(2549, e2.DiagnosticCategory.Error, "Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns__2549", "Type '{0}' is not an array type or a string type or does not have a '[Symbol.iterator]()' method that returns an iterator."), Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later: a(2550, e2.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_c_2550", "Property '{0}' does not exist on type '{1}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{2}' or later."), Property_0_does_not_exist_on_type_1_Did_you_mean_2: a(2551, e2.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_2_2551", "Property '{0}' does not exist on type '{1}'. Did you mean '{2}'?"), Cannot_find_name_0_Did_you_mean_1: a(2552, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_1_2552", "Cannot find name '{0}'. Did you mean '{1}'?"), Computed_values_are_not_permitted_in_an_enum_with_string_valued_members: a(2553, e2.DiagnosticCategory.Error, "Computed_values_are_not_permitted_in_an_enum_with_string_valued_members_2553", "Computed values are not permitted in an enum with string valued members."), Expected_0_arguments_but_got_1: a(2554, e2.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_2554", "Expected {0} arguments, but got {1}."), Expected_at_least_0_arguments_but_got_1: a(2555, e2.DiagnosticCategory.Error, "Expected_at_least_0_arguments_but_got_1_2555", "Expected at least {0} arguments, but got {1}."), A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter: a(2556, e2.DiagnosticCategory.Error, "A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter_2556", "A spread argument must either have a tuple type or be passed to a rest parameter."), Expected_0_type_arguments_but_got_1: a(2558, e2.DiagnosticCategory.Error, "Expected_0_type_arguments_but_got_1_2558", "Expected {0} type arguments, but got {1}."), Type_0_has_no_properties_in_common_with_type_1: a(2559, e2.DiagnosticCategory.Error, "Type_0_has_no_properties_in_common_with_type_1_2559", "Type '{0}' has no properties in common with type '{1}'."), Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it: a(2560, e2.DiagnosticCategory.Error, "Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it_2560", "Value of type '{0}' has no properties in common with type '{1}'. Did you mean to call it?"), Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2: a(2561, e2.DiagnosticCategory.Error, "Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_writ_2561", "Object literal may only specify known properties, but '{0}' does not exist in type '{1}'. Did you mean to write '{2}'?"), Base_class_expressions_cannot_reference_class_type_parameters: a(2562, e2.DiagnosticCategory.Error, "Base_class_expressions_cannot_reference_class_type_parameters_2562", "Base class expressions cannot reference class type parameters."), The_containing_function_or_module_body_is_too_large_for_control_flow_analysis: a(2563, e2.DiagnosticCategory.Error, "The_containing_function_or_module_body_is_too_large_for_control_flow_analysis_2563", "The containing function or module body is too large for control flow analysis."), Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor: a(2564, e2.DiagnosticCategory.Error, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor_2564", "Property '{0}' has no initializer and is not definitely assigned in the constructor."), Property_0_is_used_before_being_assigned: a(2565, e2.DiagnosticCategory.Error, "Property_0_is_used_before_being_assigned_2565", "Property '{0}' is used before being assigned."), A_rest_element_cannot_have_a_property_name: a(2566, e2.DiagnosticCategory.Error, "A_rest_element_cannot_have_a_property_name_2566", "A rest element cannot have a property name."), Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations: a(2567, e2.DiagnosticCategory.Error, "Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations_2567", "Enum declarations can only merge with namespace or other enum declarations."), Property_0_may_not_exist_on_type_1_Did_you_mean_2: a(2568, e2.DiagnosticCategory.Error, "Property_0_may_not_exist_on_type_1_Did_you_mean_2_2568", "Property '{0}' may not exist on type '{1}'. Did you mean '{2}'?"), Could_not_find_name_0_Did_you_mean_1: a(2570, e2.DiagnosticCategory.Error, "Could_not_find_name_0_Did_you_mean_1_2570", "Could not find name '{0}'. Did you mean '{1}'?"), Object_is_of_type_unknown: a(2571, e2.DiagnosticCategory.Error, "Object_is_of_type_unknown_2571", "Object is of type 'unknown'."), A_rest_element_type_must_be_an_array_type: a(2574, e2.DiagnosticCategory.Error, "A_rest_element_type_must_be_an_array_type_2574", "A rest element type must be an array type."), No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments: a(2575, e2.DiagnosticCategory.Error, "No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments_2575", "No overload expects {0} arguments, but overloads do exist that expect either {1} or {2} arguments."), Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead: a(2576, e2.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead_2576", "Property '{0}' does not exist on type '{1}'. Did you mean to access the static member '{2}' instead?"), Return_type_annotation_circularly_references_itself: a(2577, e2.DiagnosticCategory.Error, "Return_type_annotation_circularly_references_itself_2577", "Return type annotation circularly references itself."), Unused_ts_expect_error_directive: a(2578, e2.DiagnosticCategory.Error, "Unused_ts_expect_error_directive_2578", "Unused '@ts-expect-error' directive."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode: a(2580, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2580", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node`."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery: a(2581, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2581", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery`."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha: a(2582, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2582", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha`."), Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later: a(2583, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2583", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to '{1}' or later."), Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom: a(2584, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2584", "Cannot find name '{0}'. Do you need to change your target library? Try changing the 'lib' compiler option to include 'dom'."), _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later: a(2585, e2.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_2585", "'{0}' only refers to a type, but is being used as a value here. Do you need to change your target library? Try changing the 'lib' compiler option to es2015 or later."), Cannot_assign_to_0_because_it_is_a_constant: a(2588, e2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_constant_2588", "Cannot assign to '{0}' because it is a constant."), Type_instantiation_is_excessively_deep_and_possibly_infinite: a(2589, e2.DiagnosticCategory.Error, "Type_instantiation_is_excessively_deep_and_possibly_infinite_2589", "Type instantiation is excessively deep and possibly infinite."), Expression_produces_a_union_type_that_is_too_complex_to_represent: a(2590, e2.DiagnosticCategory.Error, "Expression_produces_a_union_type_that_is_too_complex_to_represent_2590", "Expression produces a union type that is too complex to represent."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig: a(2591, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashno_2591", "Cannot find name '{0}'. Do you need to install type definitions for node? Try `npm i --save-dev @types/node` and then add 'node' to the types field in your tsconfig."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig: a(2592, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slash_2592", "Cannot find name '{0}'. Do you need to install type definitions for jQuery? Try `npm i --save-dev @types/jquery` and then add 'jquery' to the types field in your tsconfig."), Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig: a(2593, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_type_2593", "Cannot find name '{0}'. Do you need to install type definitions for a test runner? Try `npm i --save-dev @types/jest` or `npm i --save-dev @types/mocha` and then add 'jest' or 'mocha' to the types field in your tsconfig."), This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag: a(2594, e2.DiagnosticCategory.Error, "This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the__2594", "This module is declared with using 'export =', and can only be used with a default import when using the '{0}' flag."), _0_can_only_be_imported_by_using_a_default_import: a(2595, e2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_default_import_2595", "'{0}' can only be imported by using a default import."), _0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: a(2596, e2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import_2596", "'{0}' can only be imported by turning on the 'esModuleInterop' flag and using a default import."), _0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import: a(2597, e2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import_2597", "'{0}' can only be imported by using a 'require' call or by using a default import."), _0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: a(2598, e2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using__2598", "'{0}' can only be imported by using a 'require' call or by turning on the 'esModuleInterop' flag and using a default import."), JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist: a(2602, e2.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist_2602", "JSX element implicitly has type 'any' because the global type 'JSX.Element' does not exist."), Property_0_in_type_1_is_not_assignable_to_type_2: a(2603, e2.DiagnosticCategory.Error, "Property_0_in_type_1_is_not_assignable_to_type_2_2603", "Property '{0}' in type '{1}' is not assignable to type '{2}'."), JSX_element_type_0_does_not_have_any_construct_or_call_signatures: a(2604, e2.DiagnosticCategory.Error, "JSX_element_type_0_does_not_have_any_construct_or_call_signatures_2604", "JSX element type '{0}' does not have any construct or call signatures."), Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property: a(2606, e2.DiagnosticCategory.Error, "Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property_2606", "Property '{0}' of JSX spread attribute is not assignable to target property."), JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property: a(2607, e2.DiagnosticCategory.Error, "JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property_2607", "JSX element class does not support attributes because it does not have a '{0}' property."), The_global_type_JSX_0_may_not_have_more_than_one_property: a(2608, e2.DiagnosticCategory.Error, "The_global_type_JSX_0_may_not_have_more_than_one_property_2608", "The global type 'JSX.{0}' may not have more than one property."), JSX_spread_child_must_be_an_array_type: a(2609, e2.DiagnosticCategory.Error, "JSX_spread_child_must_be_an_array_type_2609", "JSX spread child must be an array type."), _0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property: a(2610, e2.DiagnosticCategory.Error, "_0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property_2610", "'{0}' is defined as an accessor in class '{1}', but is overridden here in '{2}' as an instance property."), _0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor: a(2611, e2.DiagnosticCategory.Error, "_0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor_2611", "'{0}' is defined as a property in class '{1}', but is overridden here in '{2}' as an accessor."), Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration: a(2612, e2.DiagnosticCategory.Error, "Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_2612", "Property '{0}' will overwrite the base property in '{1}'. If this is intentional, add an initializer. Otherwise, add a 'declare' modifier or remove the redundant declaration."), Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead: a(2613, e2.DiagnosticCategory.Error, "Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead_2613", "Module '{0}' has no default export. Did you mean to use 'import { {1} } from {0}' instead?"), Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead: a(2614, e2.DiagnosticCategory.Error, "Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead_2614", "Module '{0}' has no exported member '{1}'. Did you mean to use 'import {1} from {0}' instead?"), Type_of_property_0_circularly_references_itself_in_mapped_type_1: a(2615, e2.DiagnosticCategory.Error, "Type_of_property_0_circularly_references_itself_in_mapped_type_1_2615", "Type of property '{0}' circularly references itself in mapped type '{1}'."), _0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import: a(2616, e2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import_2616", "'{0}' can only be imported by using 'import {1} = require({2})' or a default import."), _0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import: a(2617, e2.DiagnosticCategory.Error, "_0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_us_2617", "'{0}' can only be imported by using 'import {1} = require({2})' or by turning on the 'esModuleInterop' flag and using a default import."), Source_has_0_element_s_but_target_requires_1: a(2618, e2.DiagnosticCategory.Error, "Source_has_0_element_s_but_target_requires_1_2618", "Source has {0} element(s) but target requires {1}."), Source_has_0_element_s_but_target_allows_only_1: a(2619, e2.DiagnosticCategory.Error, "Source_has_0_element_s_but_target_allows_only_1_2619", "Source has {0} element(s) but target allows only {1}."), Target_requires_0_element_s_but_source_may_have_fewer: a(2620, e2.DiagnosticCategory.Error, "Target_requires_0_element_s_but_source_may_have_fewer_2620", "Target requires {0} element(s) but source may have fewer."), Target_allows_only_0_element_s_but_source_may_have_more: a(2621, e2.DiagnosticCategory.Error, "Target_allows_only_0_element_s_but_source_may_have_more_2621", "Target allows only {0} element(s) but source may have more."), Source_provides_no_match_for_required_element_at_position_0_in_target: a(2623, e2.DiagnosticCategory.Error, "Source_provides_no_match_for_required_element_at_position_0_in_target_2623", "Source provides no match for required element at position {0} in target."), Source_provides_no_match_for_variadic_element_at_position_0_in_target: a(2624, e2.DiagnosticCategory.Error, "Source_provides_no_match_for_variadic_element_at_position_0_in_target_2624", "Source provides no match for variadic element at position {0} in target."), Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target: a(2625, e2.DiagnosticCategory.Error, "Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target_2625", "Variadic element at position {0} in source does not match element at position {1} in target."), Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target: a(2626, e2.DiagnosticCategory.Error, "Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target_2626", "Type at position {0} in source is not compatible with type at position {1} in target."), Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target: a(2627, e2.DiagnosticCategory.Error, "Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target_2627", "Type at positions {0} through {1} in source is not compatible with type at position {2} in target."), Cannot_assign_to_0_because_it_is_an_enum: a(2628, e2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_an_enum_2628", "Cannot assign to '{0}' because it is an enum."), Cannot_assign_to_0_because_it_is_a_class: a(2629, e2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_class_2629", "Cannot assign to '{0}' because it is a class."), Cannot_assign_to_0_because_it_is_a_function: a(2630, e2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_function_2630", "Cannot assign to '{0}' because it is a function."), Cannot_assign_to_0_because_it_is_a_namespace: a(2631, e2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_a_namespace_2631", "Cannot assign to '{0}' because it is a namespace."), Cannot_assign_to_0_because_it_is_an_import: a(2632, e2.DiagnosticCategory.Error, "Cannot_assign_to_0_because_it_is_an_import_2632", "Cannot assign to '{0}' because it is an import."), JSX_property_access_expressions_cannot_include_JSX_namespace_names: a(2633, e2.DiagnosticCategory.Error, "JSX_property_access_expressions_cannot_include_JSX_namespace_names_2633", "JSX property access expressions cannot include JSX namespace names"), _0_index_signatures_are_incompatible: a(2634, e2.DiagnosticCategory.Error, "_0_index_signatures_are_incompatible_2634", "'{0}' index signatures are incompatible."), Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable: a(2635, e2.DiagnosticCategory.Error, "Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable_2635", "Type '{0}' has no signatures for which the type argument list is applicable."), Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation: a(2636, e2.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation_2636", "Type '{0}' is not assignable to type '{1}' as implied by variance annotation."), Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types: a(2637, e2.DiagnosticCategory.Error, "Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_t_2637", "Variance annotations are only supported in type aliases for object, function, constructor, and mapped types."), Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity: a(2649, e2.DiagnosticCategory.Error, "Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity_2649", "Cannot augment module '{0}' with value exports because it resolves to a non-module entity."), A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums: a(2651, e2.DiagnosticCategory.Error, "A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_memb_2651", "A member initializer in a enum declaration cannot reference members declared after it, including members defined in other enums."), Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead: a(2652, e2.DiagnosticCategory.Error, "Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_d_2652", "Merged declaration '{0}' cannot include a default export declaration. Consider adding a separate 'export default {0}' declaration instead."), Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1: a(2653, e2.DiagnosticCategory.Error, "Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1_2653", "Non-abstract class expression does not implement inherited abstract member '{0}' from class '{1}'."), JSX_expressions_must_have_one_parent_element: a(2657, e2.DiagnosticCategory.Error, "JSX_expressions_must_have_one_parent_element_2657", "JSX expressions must have one parent element."), Type_0_provides_no_match_for_the_signature_1: a(2658, e2.DiagnosticCategory.Error, "Type_0_provides_no_match_for_the_signature_1_2658", "Type '{0}' provides no match for the signature '{1}'."), super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher: a(2659, e2.DiagnosticCategory.Error, "super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_highe_2659", "'super' is only allowed in members of object literal expressions when option 'target' is 'ES2015' or higher."), super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions: a(2660, e2.DiagnosticCategory.Error, "super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions_2660", "'super' can only be referenced in members of derived classes or object literal expressions."), Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module: a(2661, e2.DiagnosticCategory.Error, "Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module_2661", "Cannot export '{0}'. Only local declarations can be exported from a module."), Cannot_find_name_0_Did_you_mean_the_static_member_1_0: a(2662, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_static_member_1_0_2662", "Cannot find name '{0}'. Did you mean the static member '{1}.{0}'?"), Cannot_find_name_0_Did_you_mean_the_instance_member_this_0: a(2663, e2.DiagnosticCategory.Error, "Cannot_find_name_0_Did_you_mean_the_instance_member_this_0_2663", "Cannot find name '{0}'. Did you mean the instance member 'this.{0}'?"), Invalid_module_name_in_augmentation_module_0_cannot_be_found: a(2664, e2.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_module_0_cannot_be_found_2664", "Invalid module name in augmentation, module '{0}' cannot be found."), Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented: a(2665, e2.DiagnosticCategory.Error, "Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augm_2665", "Invalid module name in augmentation. Module '{0}' resolves to an untyped module at '{1}', which cannot be augmented."), Exports_and_export_assignments_are_not_permitted_in_module_augmentations: a(2666, e2.DiagnosticCategory.Error, "Exports_and_export_assignments_are_not_permitted_in_module_augmentations_2666", "Exports and export assignments are not permitted in module augmentations."), Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module: a(2667, e2.DiagnosticCategory.Error, "Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_mod_2667", "Imports are not permitted in module augmentations. Consider moving them to the enclosing external module."), export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible: a(2668, e2.DiagnosticCategory.Error, "export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always__2668", "'export' modifier cannot be applied to ambient modules and module augmentations since they are always visible."), Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations: a(2669, e2.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_2669", "Augmentations for the global scope can only be directly nested in external modules or ambient module declarations."), Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context: a(2670, e2.DiagnosticCategory.Error, "Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambien_2670", "Augmentations for the global scope should have 'declare' modifier unless they appear in already ambient context."), Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity: a(2671, e2.DiagnosticCategory.Error, "Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity_2671", "Cannot augment module '{0}' because it resolves to a non-module entity."), Cannot_assign_a_0_constructor_type_to_a_1_constructor_type: a(2672, e2.DiagnosticCategory.Error, "Cannot_assign_a_0_constructor_type_to_a_1_constructor_type_2672", "Cannot assign a '{0}' constructor type to a '{1}' constructor type."), Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration: a(2673, e2.DiagnosticCategory.Error, "Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration_2673", "Constructor of class '{0}' is private and only accessible within the class declaration."), Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration: a(2674, e2.DiagnosticCategory.Error, "Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration_2674", "Constructor of class '{0}' is protected and only accessible within the class declaration."), Cannot_extend_a_class_0_Class_constructor_is_marked_as_private: a(2675, e2.DiagnosticCategory.Error, "Cannot_extend_a_class_0_Class_constructor_is_marked_as_private_2675", "Cannot extend a class '{0}'. Class constructor is marked as private."), Accessors_must_both_be_abstract_or_non_abstract: a(2676, e2.DiagnosticCategory.Error, "Accessors_must_both_be_abstract_or_non_abstract_2676", "Accessors must both be abstract or non-abstract."), A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type: a(2677, e2.DiagnosticCategory.Error, "A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type_2677", "A type predicate's type must be assignable to its parameter's type."), Type_0_is_not_comparable_to_type_1: a(2678, e2.DiagnosticCategory.Error, "Type_0_is_not_comparable_to_type_1_2678", "Type '{0}' is not comparable to type '{1}'."), A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void: a(2679, e2.DiagnosticCategory.Error, "A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void_2679", "A function that is called with the 'new' keyword cannot have a 'this' type that is 'void'."), A_0_parameter_must_be_the_first_parameter: a(2680, e2.DiagnosticCategory.Error, "A_0_parameter_must_be_the_first_parameter_2680", "A '{0}' parameter must be the first parameter."), A_constructor_cannot_have_a_this_parameter: a(2681, e2.DiagnosticCategory.Error, "A_constructor_cannot_have_a_this_parameter_2681", "A constructor cannot have a 'this' parameter."), this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation: a(2683, e2.DiagnosticCategory.Error, "this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_2683", "'this' implicitly has type 'any' because it does not have a type annotation."), The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1: a(2684, e2.DiagnosticCategory.Error, "The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1_2684", "The 'this' context of type '{0}' is not assignable to method's 'this' of type '{1}'."), The_this_types_of_each_signature_are_incompatible: a(2685, e2.DiagnosticCategory.Error, "The_this_types_of_each_signature_are_incompatible_2685", "The 'this' types of each signature are incompatible."), _0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead: a(2686, e2.DiagnosticCategory.Error, "_0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead_2686", "'{0}' refers to a UMD global, but the current file is a module. Consider adding an import instead."), All_declarations_of_0_must_have_identical_modifiers: a(2687, e2.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_modifiers_2687", "All declarations of '{0}' must have identical modifiers."), Cannot_find_type_definition_file_for_0: a(2688, e2.DiagnosticCategory.Error, "Cannot_find_type_definition_file_for_0_2688", "Cannot find type definition file for '{0}'."), Cannot_extend_an_interface_0_Did_you_mean_implements: a(2689, e2.DiagnosticCategory.Error, "Cannot_extend_an_interface_0_Did_you_mean_implements_2689", "Cannot extend an interface '{0}'. Did you mean 'implements'?"), _0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0: a(2690, e2.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0_2690", "'{0}' only refers to a type, but is being used as a value here. Did you mean to use '{1} in {0}'?"), An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead: a(2691, e2.DiagnosticCategory.Error, "An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead_2691", "An import path cannot end with a '{0}' extension. Consider importing '{1}' instead."), _0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible: a(2692, e2.DiagnosticCategory.Error, "_0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible_2692", "'{0}' is a primitive, but '{1}' is a wrapper object. Prefer using '{0}' when possible."), _0_only_refers_to_a_type_but_is_being_used_as_a_value_here: a(2693, e2.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_value_here_2693", "'{0}' only refers to a type, but is being used as a value here."), Namespace_0_has_no_exported_member_1: a(2694, e2.DiagnosticCategory.Error, "Namespace_0_has_no_exported_member_1_2694", "Namespace '{0}' has no exported member '{1}'."), Left_side_of_comma_operator_is_unused_and_has_no_side_effects: a(2695, e2.DiagnosticCategory.Error, "Left_side_of_comma_operator_is_unused_and_has_no_side_effects_2695", "Left side of comma operator is unused and has no side effects.", true), The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead: a(2696, e2.DiagnosticCategory.Error, "The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead_2696", "The 'Object' type is assignable to very few other types. Did you mean to use the 'any' type instead?"), An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: a(2697, e2.DiagnosticCategory.Error, "An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_in_2697", "An async function or method must return a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."), Spread_types_may_only_be_created_from_object_types: a(2698, e2.DiagnosticCategory.Error, "Spread_types_may_only_be_created_from_object_types_2698", "Spread types may only be created from object types."), Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1: a(2699, e2.DiagnosticCategory.Error, "Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1_2699", "Static property '{0}' conflicts with built-in property 'Function.{0}' of constructor function '{1}'."), Rest_types_may_only_be_created_from_object_types: a(2700, e2.DiagnosticCategory.Error, "Rest_types_may_only_be_created_from_object_types_2700", "Rest types may only be created from object types."), The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access: a(2701, e2.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access_2701", "The target of an object rest assignment must be a variable or a property access."), _0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here: a(2702, e2.DiagnosticCategory.Error, "_0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here_2702", "'{0}' only refers to a type, but is being used as a namespace here."), The_operand_of_a_delete_operator_must_be_a_property_reference: a(2703, e2.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_a_property_reference_2703", "The operand of a 'delete' operator must be a property reference."), The_operand_of_a_delete_operator_cannot_be_a_read_only_property: a(2704, e2.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_read_only_property_2704", "The operand of a 'delete' operator cannot be a read-only property."), An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: a(2705, e2.DiagnosticCategory.Error, "An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_de_2705", "An async function or method in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."), Required_type_parameters_may_not_follow_optional_type_parameters: a(2706, e2.DiagnosticCategory.Error, "Required_type_parameters_may_not_follow_optional_type_parameters_2706", "Required type parameters may not follow optional type parameters."), Generic_type_0_requires_between_1_and_2_type_arguments: a(2707, e2.DiagnosticCategory.Error, "Generic_type_0_requires_between_1_and_2_type_arguments_2707", "Generic type '{0}' requires between {1} and {2} type arguments."), Cannot_use_namespace_0_as_a_value: a(2708, e2.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_value_2708", "Cannot use namespace '{0}' as a value."), Cannot_use_namespace_0_as_a_type: a(2709, e2.DiagnosticCategory.Error, "Cannot_use_namespace_0_as_a_type_2709", "Cannot use namespace '{0}' as a type."), _0_are_specified_twice_The_attribute_named_0_will_be_overwritten: a(2710, e2.DiagnosticCategory.Error, "_0_are_specified_twice_The_attribute_named_0_will_be_overwritten_2710", "'{0}' are specified twice. The attribute named '{0}' will be overwritten."), A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option: a(2711, e2.DiagnosticCategory.Error, "A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES20_2711", "A dynamic import call returns a 'Promise'. Make sure you have a declaration for 'Promise' or include 'ES2015' in your '--lib' option."), A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option: a(2712, e2.DiagnosticCategory.Error, "A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declarat_2712", "A dynamic import call in ES5/ES3 requires the 'Promise' constructor.  Make sure you have a declaration for the 'Promise' constructor or include 'ES2015' in your '--lib' option."), Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1: a(2713, e2.DiagnosticCategory.Error, "Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_p_2713", `Cannot access '{0}.{1}' because '{0}' is a type, but not a namespace. Did you mean to retrieve the type of the property '{1}' in '{0}' with '{0}["{1}"]'?`), The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context: a(2714, e2.DiagnosticCategory.Error, "The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context_2714", "The expression of an export assignment must be an identifier or qualified name in an ambient context."), Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor: a(2715, e2.DiagnosticCategory.Error, "Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor_2715", "Abstract property '{0}' in class '{1}' cannot be accessed in the constructor."), Type_parameter_0_has_a_circular_default: a(2716, e2.DiagnosticCategory.Error, "Type_parameter_0_has_a_circular_default_2716", "Type parameter '{0}' has a circular default."), Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2: a(2717, e2.DiagnosticCategory.Error, "Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_t_2717", "Subsequent property declarations must have the same type.  Property '{0}' must be of type '{1}', but here has type '{2}'."), Duplicate_property_0: a(2718, e2.DiagnosticCategory.Error, "Duplicate_property_0_2718", "Duplicate property '{0}'."), Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated: a(2719, e2.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated_2719", "Type '{0}' is not assignable to type '{1}'. Two different types with this name exist, but they are unrelated."), Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass: a(2720, e2.DiagnosticCategory.Error, "Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclas_2720", "Class '{0}' incorrectly implements class '{1}'. Did you mean to extend '{1}' and inherit its members as a subclass?"), Cannot_invoke_an_object_which_is_possibly_null: a(2721, e2.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_2721", "Cannot invoke an object which is possibly 'null'."), Cannot_invoke_an_object_which_is_possibly_undefined: a(2722, e2.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_undefined_2722", "Cannot invoke an object which is possibly 'undefined'."), Cannot_invoke_an_object_which_is_possibly_null_or_undefined: a(2723, e2.DiagnosticCategory.Error, "Cannot_invoke_an_object_which_is_possibly_null_or_undefined_2723", "Cannot invoke an object which is possibly 'null' or 'undefined'."), _0_has_no_exported_member_named_1_Did_you_mean_2: a(2724, e2.DiagnosticCategory.Error, "_0_has_no_exported_member_named_1_Did_you_mean_2_2724", "'{0}' has no exported member named '{1}'. Did you mean '{2}'?"), Class_name_cannot_be_Object_when_targeting_ES5_with_module_0: a(2725, e2.DiagnosticCategory.Error, "Class_name_cannot_be_Object_when_targeting_ES5_with_module_0_2725", "Class name cannot be 'Object' when targeting ES5 with module {0}."), Cannot_find_lib_definition_for_0: a(2726, e2.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_2726", "Cannot find lib definition for '{0}'."), Cannot_find_lib_definition_for_0_Did_you_mean_1: a(2727, e2.DiagnosticCategory.Error, "Cannot_find_lib_definition_for_0_Did_you_mean_1_2727", "Cannot find lib definition for '{0}'. Did you mean '{1}'?"), _0_is_declared_here: a(2728, e2.DiagnosticCategory.Message, "_0_is_declared_here_2728", "'{0}' is declared here."), Property_0_is_used_before_its_initialization: a(2729, e2.DiagnosticCategory.Error, "Property_0_is_used_before_its_initialization_2729", "Property '{0}' is used before its initialization."), An_arrow_function_cannot_have_a_this_parameter: a(2730, e2.DiagnosticCategory.Error, "An_arrow_function_cannot_have_a_this_parameter_2730", "An arrow function cannot have a 'this' parameter."), Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String: a(2731, e2.DiagnosticCategory.Error, "Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_i_2731", "Implicit conversion of a 'symbol' to a 'string' will fail at runtime. Consider wrapping this expression in 'String(...)'."), Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension: a(2732, e2.DiagnosticCategory.Error, "Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension_2732", "Cannot find module '{0}'. Consider using '--resolveJsonModule' to import module with '.json' extension."), Property_0_was_also_declared_here: a(2733, e2.DiagnosticCategory.Error, "Property_0_was_also_declared_here_2733", "Property '{0}' was also declared here."), Are_you_missing_a_semicolon: a(2734, e2.DiagnosticCategory.Error, "Are_you_missing_a_semicolon_2734", "Are you missing a semicolon?"), Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1: a(2735, e2.DiagnosticCategory.Error, "Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1_2735", "Did you mean for '{0}' to be constrained to type 'new (...args: any[]) => {1}'?"), Operator_0_cannot_be_applied_to_type_1: a(2736, e2.DiagnosticCategory.Error, "Operator_0_cannot_be_applied_to_type_1_2736", "Operator '{0}' cannot be applied to type '{1}'."), BigInt_literals_are_not_available_when_targeting_lower_than_ES2020: a(2737, e2.DiagnosticCategory.Error, "BigInt_literals_are_not_available_when_targeting_lower_than_ES2020_2737", "BigInt literals are not available when targeting lower than ES2020."), An_outer_value_of_this_is_shadowed_by_this_container: a(2738, e2.DiagnosticCategory.Message, "An_outer_value_of_this_is_shadowed_by_this_container_2738", "An outer value of 'this' is shadowed by this container."), Type_0_is_missing_the_following_properties_from_type_1_Colon_2: a(2739, e2.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_2739", "Type '{0}' is missing the following properties from type '{1}': {2}"), Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more: a(2740, e2.DiagnosticCategory.Error, "Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more_2740", "Type '{0}' is missing the following properties from type '{1}': {2}, and {3} more."), Property_0_is_missing_in_type_1_but_required_in_type_2: a(2741, e2.DiagnosticCategory.Error, "Property_0_is_missing_in_type_1_but_required_in_type_2_2741", "Property '{0}' is missing in type '{1}' but required in type '{2}'."), The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary: a(2742, e2.DiagnosticCategory.Error, "The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_a_2742", "The inferred type of '{0}' cannot be named without a reference to '{1}'. This is likely not portable. A type annotation is necessary."), No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments: a(2743, e2.DiagnosticCategory.Error, "No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments_2743", "No overload expects {0} type arguments, but overloads do exist that expect either {1} or {2} type arguments."), Type_parameter_defaults_can_only_reference_previously_declared_type_parameters: a(2744, e2.DiagnosticCategory.Error, "Type_parameter_defaults_can_only_reference_previously_declared_type_parameters_2744", "Type parameter defaults can only reference previously declared type parameters."), This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided: a(2745, e2.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_pr_2745", "This JSX tag's '{0}' prop expects type '{1}' which requires multiple children, but only a single child was provided."), This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided: a(2746, e2.DiagnosticCategory.Error, "This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided_2746", "This JSX tag's '{0}' prop expects a single child of type '{1}', but multiple children were provided."), _0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2: a(2747, e2.DiagnosticCategory.Error, "_0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_t_2747", "'{0}' components don't accept text as child elements. Text in JSX has the type 'string', but the expected type of '{1}' is '{2}'."), Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided: a(2748, e2.DiagnosticCategory.Error, "Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided_2748", "Cannot access ambient const enums when the '--isolatedModules' flag is provided."), _0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0: a(2749, e2.DiagnosticCategory.Error, "_0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0_2749", "'{0}' refers to a value, but is being used as a type here. Did you mean 'typeof {0}'?"), The_implementation_signature_is_declared_here: a(2750, e2.DiagnosticCategory.Error, "The_implementation_signature_is_declared_here_2750", "The implementation signature is declared here."), Circularity_originates_in_type_at_this_location: a(2751, e2.DiagnosticCategory.Error, "Circularity_originates_in_type_at_this_location_2751", "Circularity originates in type at this location."), The_first_export_default_is_here: a(2752, e2.DiagnosticCategory.Error, "The_first_export_default_is_here_2752", "The first export default is here."), Another_export_default_is_here: a(2753, e2.DiagnosticCategory.Error, "Another_export_default_is_here_2753", "Another export default is here."), super_may_not_use_type_arguments: a(2754, e2.DiagnosticCategory.Error, "super_may_not_use_type_arguments_2754", "'super' may not use type arguments."), No_constituent_of_type_0_is_callable: a(2755, e2.DiagnosticCategory.Error, "No_constituent_of_type_0_is_callable_2755", "No constituent of type '{0}' is callable."), Not_all_constituents_of_type_0_are_callable: a(2756, e2.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_callable_2756", "Not all constituents of type '{0}' are callable."), Type_0_has_no_call_signatures: a(2757, e2.DiagnosticCategory.Error, "Type_0_has_no_call_signatures_2757", "Type '{0}' has no call signatures."), Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other: a(2758, e2.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_2758", "Each member of the union type '{0}' has signatures, but none of those signatures are compatible with each other."), No_constituent_of_type_0_is_constructable: a(2759, e2.DiagnosticCategory.Error, "No_constituent_of_type_0_is_constructable_2759", "No constituent of type '{0}' is constructable."), Not_all_constituents_of_type_0_are_constructable: a(2760, e2.DiagnosticCategory.Error, "Not_all_constituents_of_type_0_are_constructable_2760", "Not all constituents of type '{0}' are constructable."), Type_0_has_no_construct_signatures: a(2761, e2.DiagnosticCategory.Error, "Type_0_has_no_construct_signatures_2761", "Type '{0}' has no construct signatures."), Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other: a(2762, e2.DiagnosticCategory.Error, "Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_2762", "Each member of the union type '{0}' has construct signatures, but none of those signatures are compatible with each other."), Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0: a(2763, e2.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_s_2763", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but for-of will always send '{0}'."), Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0: a(2764, e2.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_al_2764", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array spread will always send '{0}'."), Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0: a(2765, e2.DiagnosticCategory.Error, "Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring__2765", "Cannot iterate value because the 'next' method of its iterator expects type '{1}', but array destructuring will always send '{0}'."), Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0: a(2766, e2.DiagnosticCategory.Error, "Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_co_2766", "Cannot delegate iteration to value because the 'next' method of its iterator expects type '{1}', but the containing generator will always send '{0}'."), The_0_property_of_an_iterator_must_be_a_method: a(2767, e2.DiagnosticCategory.Error, "The_0_property_of_an_iterator_must_be_a_method_2767", "The '{0}' property of an iterator must be a method."), The_0_property_of_an_async_iterator_must_be_a_method: a(2768, e2.DiagnosticCategory.Error, "The_0_property_of_an_async_iterator_must_be_a_method_2768", "The '{0}' property of an async iterator must be a method."), No_overload_matches_this_call: a(2769, e2.DiagnosticCategory.Error, "No_overload_matches_this_call_2769", "No overload matches this call."), The_last_overload_gave_the_following_error: a(2770, e2.DiagnosticCategory.Error, "The_last_overload_gave_the_following_error_2770", "The last overload gave the following error."), The_last_overload_is_declared_here: a(2771, e2.DiagnosticCategory.Error, "The_last_overload_is_declared_here_2771", "The last overload is declared here."), Overload_0_of_1_2_gave_the_following_error: a(2772, e2.DiagnosticCategory.Error, "Overload_0_of_1_2_gave_the_following_error_2772", "Overload {0} of {1}, '{2}', gave the following error."), Did_you_forget_to_use_await: a(2773, e2.DiagnosticCategory.Error, "Did_you_forget_to_use_await_2773", "Did you forget to use 'await'?"), This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead: a(2774, e2.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_2774", "This condition will always return true since this function is always defined. Did you mean to call it instead?"), Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation: a(2775, e2.DiagnosticCategory.Error, "Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation_2775", "Assertions require every name in the call target to be declared with an explicit type annotation."), Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name: a(2776, e2.DiagnosticCategory.Error, "Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name_2776", "Assertions require the call target to be an identifier or qualified name."), The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access: a(2777, e2.DiagnosticCategory.Error, "The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access_2777", "The operand of an increment or decrement operator may not be an optional property access."), The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access: a(2778, e2.DiagnosticCategory.Error, "The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access_2778", "The target of an object rest assignment may not be an optional property access."), The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access: a(2779, e2.DiagnosticCategory.Error, "The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access_2779", "The left-hand side of an assignment expression may not be an optional property access."), The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access: a(2780, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access_2780", "The left-hand side of a 'for...in' statement may not be an optional property access."), The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access: a(2781, e2.DiagnosticCategory.Error, "The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access_2781", "The left-hand side of a 'for...of' statement may not be an optional property access."), _0_needs_an_explicit_type_annotation: a(2782, e2.DiagnosticCategory.Message, "_0_needs_an_explicit_type_annotation_2782", "'{0}' needs an explicit type annotation."), _0_is_specified_more_than_once_so_this_usage_will_be_overwritten: a(2783, e2.DiagnosticCategory.Error, "_0_is_specified_more_than_once_so_this_usage_will_be_overwritten_2783", "'{0}' is specified more than once, so this usage will be overwritten."), get_and_set_accessors_cannot_declare_this_parameters: a(2784, e2.DiagnosticCategory.Error, "get_and_set_accessors_cannot_declare_this_parameters_2784", "'get' and 'set' accessors cannot declare 'this' parameters."), This_spread_always_overwrites_this_property: a(2785, e2.DiagnosticCategory.Error, "This_spread_always_overwrites_this_property_2785", "This spread always overwrites this property."), _0_cannot_be_used_as_a_JSX_component: a(2786, e2.DiagnosticCategory.Error, "_0_cannot_be_used_as_a_JSX_component_2786", "'{0}' cannot be used as a JSX component."), Its_return_type_0_is_not_a_valid_JSX_element: a(2787, e2.DiagnosticCategory.Error, "Its_return_type_0_is_not_a_valid_JSX_element_2787", "Its return type '{0}' is not a valid JSX element."), Its_instance_type_0_is_not_a_valid_JSX_element: a(2788, e2.DiagnosticCategory.Error, "Its_instance_type_0_is_not_a_valid_JSX_element_2788", "Its instance type '{0}' is not a valid JSX element."), Its_element_type_0_is_not_a_valid_JSX_element: a(2789, e2.DiagnosticCategory.Error, "Its_element_type_0_is_not_a_valid_JSX_element_2789", "Its element type '{0}' is not a valid JSX element."), The_operand_of_a_delete_operator_must_be_optional: a(2790, e2.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_must_be_optional_2790", "The operand of a 'delete' operator must be optional."), Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later: a(2791, e2.DiagnosticCategory.Error, "Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_lat_2791", "Exponentiation cannot be performed on 'bigint' values unless the 'target' option is set to 'es2016' or later."), Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option: a(2792, e2.DiagnosticCategory.Error, "Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_th_2792", "Cannot find module '{0}'. Did you mean to set the 'moduleResolution' option to 'node', or to add aliases to the 'paths' option?"), The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible: a(2793, e2.DiagnosticCategory.Error, "The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_2793", "The call would have succeeded against this implementation, but implementation signatures of overloads are not externally visible."), Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise: a(2794, e2.DiagnosticCategory.Error, "Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise_2794", "Expected {0} arguments, but got {1}. Did you forget to include 'void' in your type argument to 'Promise'?"), The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types: a(2795, e2.DiagnosticCategory.Error, "The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types_2795", "The 'intrinsic' keyword can only be used to declare compiler provided intrinsic types."), It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked: a(2796, e2.DiagnosticCategory.Error, "It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tag_2796", "It is likely that you are missing a comma to separate these two template expressions. They form a tagged template expression which cannot be invoked."), A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract: a(2797, e2.DiagnosticCategory.Error, "A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_2797", "A mixin class that extends from a type variable containing an abstract construct signature must also be declared 'abstract'."), The_declaration_was_marked_as_deprecated_here: a(2798, e2.DiagnosticCategory.Error, "The_declaration_was_marked_as_deprecated_here_2798", "The declaration was marked as deprecated here."), Type_produces_a_tuple_type_that_is_too_large_to_represent: a(2799, e2.DiagnosticCategory.Error, "Type_produces_a_tuple_type_that_is_too_large_to_represent_2799", "Type produces a tuple type that is too large to represent."), Expression_produces_a_tuple_type_that_is_too_large_to_represent: a(2800, e2.DiagnosticCategory.Error, "Expression_produces_a_tuple_type_that_is_too_large_to_represent_2800", "Expression produces a tuple type that is too large to represent."), This_condition_will_always_return_true_since_this_0_is_always_defined: a(2801, e2.DiagnosticCategory.Error, "This_condition_will_always_return_true_since_this_0_is_always_defined_2801", "This condition will always return true since this '{0}' is always defined."), Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher: a(2802, e2.DiagnosticCategory.Error, "Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es201_2802", "Type '{0}' can only be iterated through when using the '--downlevelIteration' flag or with a '--target' of 'es2015' or higher."), Cannot_assign_to_private_method_0_Private_methods_are_not_writable: a(2803, e2.DiagnosticCategory.Error, "Cannot_assign_to_private_method_0_Private_methods_are_not_writable_2803", "Cannot assign to private method '{0}'. Private methods are not writable."), Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name: a(2804, e2.DiagnosticCategory.Error, "Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name_2804", "Duplicate identifier '{0}'. Static and instance elements cannot share the same private name."), Private_accessor_was_defined_without_a_getter: a(2806, e2.DiagnosticCategory.Error, "Private_accessor_was_defined_without_a_getter_2806", "Private accessor was defined without a getter."), This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0: a(2807, e2.DiagnosticCategory.Error, "This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_o_2807", "This syntax requires an imported helper named '{1}' with {2} parameters, which is not compatible with the one in '{0}'. Consider upgrading your version of '{0}'."), A_get_accessor_must_be_at_least_as_accessible_as_the_setter: a(2808, e2.DiagnosticCategory.Error, "A_get_accessor_must_be_at_least_as_accessible_as_the_setter_2808", "A get accessor must be at least as accessible as the setter"), Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_the_whole_assignment_in_parentheses: a(2809, e2.DiagnosticCategory.Error, "Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_d_2809", "Declaration or statement expected. This '=' follows a block of statements, so if you intended to write a destructuring assignment, you might need to wrap the the whole assignment in parentheses."), Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments: a(2810, e2.DiagnosticCategory.Error, "Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_2810", "Expected 1 argument, but got 0. 'new Promise()' needs a JSDoc hint to produce a 'resolve' that can be called without arguments."), Initializer_for_property_0: a(2811, e2.DiagnosticCategory.Error, "Initializer_for_property_0_2811", "Initializer for property '{0}'"), Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom: a(2812, e2.DiagnosticCategory.Error, "Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom_2812", "Property '{0}' does not exist on type '{1}'. Try changing the 'lib' compiler option to include 'dom'."), Class_declaration_cannot_implement_overload_list_for_0: a(2813, e2.DiagnosticCategory.Error, "Class_declaration_cannot_implement_overload_list_for_0_2813", "Class declaration cannot implement overload list for '{0}'."), Function_with_bodies_can_only_merge_with_classes_that_are_ambient: a(2814, e2.DiagnosticCategory.Error, "Function_with_bodies_can_only_merge_with_classes_that_are_ambient_2814", "Function with bodies can only merge with classes that are ambient."), arguments_cannot_be_referenced_in_property_initializers: a(2815, e2.DiagnosticCategory.Error, "arguments_cannot_be_referenced_in_property_initializers_2815", "'arguments' cannot be referenced in property initializers."), Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class: a(2816, e2.DiagnosticCategory.Error, "Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class_2816", "Cannot use 'this' in a static property initializer of a decorated class."), Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block: a(2817, e2.DiagnosticCategory.Error, "Property_0_has_no_initializer_and_is_not_definitely_assigned_in_a_class_static_block_2817", "Property '{0}' has no initializer and is not definitely assigned in a class static block."), Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers: a(2818, e2.DiagnosticCategory.Error, "Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializer_2818", "Duplicate identifier '{0}'. Compiler reserves name '{1}' when emitting 'super' references in static initializers."), Namespace_name_cannot_be_0: a(2819, e2.DiagnosticCategory.Error, "Namespace_name_cannot_be_0_2819", "Namespace name cannot be '{0}'."), Type_0_is_not_assignable_to_type_1_Did_you_mean_2: a(2820, e2.DiagnosticCategory.Error, "Type_0_is_not_assignable_to_type_1_Did_you_mean_2_2820", "Type '{0}' is not assignable to type '{1}'. Did you mean '{2}'?"), Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext: a(2821, e2.DiagnosticCategory.Error, "Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext_2821", "Import assertions are only supported when the '--module' option is set to 'esnext' or 'nodenext'."), Import_assertions_cannot_be_used_with_type_only_imports_or_exports: a(2822, e2.DiagnosticCategory.Error, "Import_assertions_cannot_be_used_with_type_only_imports_or_exports_2822", "Import assertions cannot be used with type-only imports or exports."), Cannot_find_namespace_0_Did_you_mean_1: a(2833, e2.DiagnosticCategory.Error, "Cannot_find_namespace_0_Did_you_mean_1_2833", "Cannot find namespace '{0}'. Did you mean '{1}'?"), Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path: a(2834, e2.DiagnosticCategory.Error, "Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_n_2834", "Relative import paths need explicit file extensions in EcmaScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Consider adding an extension to the import path."), Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0: a(2835, e2.DiagnosticCategory.Error, "Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_n_2835", "Relative import paths need explicit file extensions in EcmaScript imports when '--moduleResolution' is 'node16' or 'nodenext'. Did you mean '{0}'?"), Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls: a(2836, e2.DiagnosticCategory.Error, "Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls_2836", "Import assertions are not allowed on statements that transpile to commonjs 'require' calls."), Import_assertion_values_must_be_string_literal_expressions: a(2837, e2.DiagnosticCategory.Error, "Import_assertion_values_must_be_string_literal_expressions_2837", "Import assertion values must be string literal expressions."), All_declarations_of_0_must_have_identical_constraints: a(2838, e2.DiagnosticCategory.Error, "All_declarations_of_0_must_have_identical_constraints_2838", "All declarations of '{0}' must have identical constraints."), Import_declaration_0_is_using_private_name_1: a(4e3, e2.DiagnosticCategory.Error, "Import_declaration_0_is_using_private_name_1_4000", "Import declaration '{0}' is using private name '{1}'."), Type_parameter_0_of_exported_class_has_or_is_using_private_name_1: a(4002, e2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_class_has_or_is_using_private_name_1_4002", "Type parameter '{0}' of exported class has or is using private name '{1}'."), Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1: a(4004, e2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1_4004", "Type parameter '{0}' of exported interface has or is using private name '{1}'."), Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: a(4006, e2.DiagnosticCategory.Error, "Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4006", "Type parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."), Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: a(4008, e2.DiagnosticCategory.Error, "Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4008", "Type parameter '{0}' of call signature from exported interface has or is using private name '{1}'."), Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: a(4010, e2.DiagnosticCategory.Error, "Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4010", "Type parameter '{0}' of public static method from exported class has or is using private name '{1}'."), Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: a(4012, e2.DiagnosticCategory.Error, "Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4012", "Type parameter '{0}' of public method from exported class has or is using private name '{1}'."), Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: a(4014, e2.DiagnosticCategory.Error, "Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4014", "Type parameter '{0}' of method from exported interface has or is using private name '{1}'."), Type_parameter_0_of_exported_function_has_or_is_using_private_name_1: a(4016, e2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_function_has_or_is_using_private_name_1_4016", "Type parameter '{0}' of exported function has or is using private name '{1}'."), Implements_clause_of_exported_class_0_has_or_is_using_private_name_1: a(4019, e2.DiagnosticCategory.Error, "Implements_clause_of_exported_class_0_has_or_is_using_private_name_1_4019", "Implements clause of exported class '{0}' has or is using private name '{1}'."), extends_clause_of_exported_class_0_has_or_is_using_private_name_1: a(4020, e2.DiagnosticCategory.Error, "extends_clause_of_exported_class_0_has_or_is_using_private_name_1_4020", "'extends' clause of exported class '{0}' has or is using private name '{1}'."), extends_clause_of_exported_class_has_or_is_using_private_name_0: a(4021, e2.DiagnosticCategory.Error, "extends_clause_of_exported_class_has_or_is_using_private_name_0_4021", "'extends' clause of exported class has or is using private name '{0}'."), extends_clause_of_exported_interface_0_has_or_is_using_private_name_1: a(4022, e2.DiagnosticCategory.Error, "extends_clause_of_exported_interface_0_has_or_is_using_private_name_1_4022", "'extends' clause of exported interface '{0}' has or is using private name '{1}'."), Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4023, e2.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4023", "Exported variable '{0}' has or is using name '{1}' from external module {2} but cannot be named."), Exported_variable_0_has_or_is_using_name_1_from_private_module_2: a(4024, e2.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_name_1_from_private_module_2_4024", "Exported variable '{0}' has or is using name '{1}' from private module '{2}'."), Exported_variable_0_has_or_is_using_private_name_1: a(4025, e2.DiagnosticCategory.Error, "Exported_variable_0_has_or_is_using_private_name_1_4025", "Exported variable '{0}' has or is using private name '{1}'."), Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4026, e2.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot__4026", "Public static property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."), Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: a(4027, e2.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4027", "Public static property '{0}' of exported class has or is using name '{1}' from private module '{2}'."), Public_static_property_0_of_exported_class_has_or_is_using_private_name_1: a(4028, e2.DiagnosticCategory.Error, "Public_static_property_0_of_exported_class_has_or_is_using_private_name_1_4028", "Public static property '{0}' of exported class has or is using private name '{1}'."), Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4029, e2.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_name_4029", "Public property '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."), Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: a(4030, e2.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4030", "Public property '{0}' of exported class has or is using name '{1}' from private module '{2}'."), Public_property_0_of_exported_class_has_or_is_using_private_name_1: a(4031, e2.DiagnosticCategory.Error, "Public_property_0_of_exported_class_has_or_is_using_private_name_1_4031", "Public property '{0}' of exported class has or is using private name '{1}'."), Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4032, e2.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4032", "Property '{0}' of exported interface has or is using name '{1}' from private module '{2}'."), Property_0_of_exported_interface_has_or_is_using_private_name_1: a(4033, e2.DiagnosticCategory.Error, "Property_0_of_exported_interface_has_or_is_using_private_name_1_4033", "Property '{0}' of exported interface has or is using private name '{1}'."), Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4034, e2.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_mod_4034", "Parameter type of public static setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."), Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1: a(4035, e2.DiagnosticCategory.Error, "Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1_4035", "Parameter type of public static setter '{0}' from exported class has or is using private name '{1}'."), Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4036, e2.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4036", "Parameter type of public setter '{0}' from exported class has or is using name '{1}' from private module '{2}'."), Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1: a(4037, e2.DiagnosticCategory.Error, "Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1_4037", "Parameter type of public setter '{0}' from exported class has or is using private name '{1}'."), Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4038, e2.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_modul_4038", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."), Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4039, e2.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_4039", "Return type of public static getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."), Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1: a(4040, e2.DiagnosticCategory.Error, "Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1_4040", "Return type of public static getter '{0}' from exported class has or is using private name '{1}'."), Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4041, e2.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_4041", "Return type of public getter '{0}' from exported class has or is using name '{1}' from external module {2} but cannot be named."), Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4042, e2.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2_4042", "Return type of public getter '{0}' from exported class has or is using name '{1}' from private module '{2}'."), Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1: a(4043, e2.DiagnosticCategory.Error, "Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1_4043", "Return type of public getter '{0}' from exported class has or is using private name '{1}'."), Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: a(4044, e2.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_mod_4044", "Return type of constructor signature from exported interface has or is using name '{0}' from private module '{1}'."), Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0: a(4045, e2.DiagnosticCategory.Error, "Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0_4045", "Return type of constructor signature from exported interface has or is using private name '{0}'."), Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: a(4046, e2.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4046", "Return type of call signature from exported interface has or is using name '{0}' from private module '{1}'."), Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0: a(4047, e2.DiagnosticCategory.Error, "Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0_4047", "Return type of call signature from exported interface has or is using private name '{0}'."), Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1: a(4048, e2.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4048", "Return type of index signature from exported interface has or is using name '{0}' from private module '{1}'."), Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0: a(4049, e2.DiagnosticCategory.Error, "Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0_4049", "Return type of index signature from exported interface has or is using private name '{0}'."), Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: a(4050, e2.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module__4050", "Return type of public static method from exported class has or is using name '{0}' from external module {1} but cannot be named."), Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: a(4051, e2.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4051", "Return type of public static method from exported class has or is using name '{0}' from private module '{1}'."), Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0: a(4052, e2.DiagnosticCategory.Error, "Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0_4052", "Return type of public static method from exported class has or is using private name '{0}'."), Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: a(4053, e2.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_c_4053", "Return type of public method from exported class has or is using name '{0}' from external module {1} but cannot be named."), Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1: a(4054, e2.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1_4054", "Return type of public method from exported class has or is using name '{0}' from private module '{1}'."), Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0: a(4055, e2.DiagnosticCategory.Error, "Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0_4055", "Return type of public method from exported class has or is using private name '{0}'."), Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1: a(4056, e2.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1_4056", "Return type of method from exported interface has or is using name '{0}' from private module '{1}'."), Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0: a(4057, e2.DiagnosticCategory.Error, "Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0_4057", "Return type of method from exported interface has or is using private name '{0}'."), Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named: a(4058, e2.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named_4058", "Return type of exported function has or is using name '{0}' from external module {1} but cannot be named."), Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1: a(4059, e2.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1_4059", "Return type of exported function has or is using name '{0}' from private module '{1}'."), Return_type_of_exported_function_has_or_is_using_private_name_0: a(4060, e2.DiagnosticCategory.Error, "Return_type_of_exported_function_has_or_is_using_private_name_0_4060", "Return type of exported function has or is using private name '{0}'."), Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4061, e2.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_can_4061", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from external module {2} but cannot be named."), Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4062, e2.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2_4062", "Parameter '{0}' of constructor from exported class has or is using name '{1}' from private module '{2}'."), Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1: a(4063, e2.DiagnosticCategory.Error, "Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1_4063", "Parameter '{0}' of constructor from exported class has or is using private name '{1}'."), Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4064, e2.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_mod_4064", "Parameter '{0}' of constructor signature from exported interface has or is using name '{1}' from private module '{2}'."), Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1: a(4065, e2.DiagnosticCategory.Error, "Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1_4065", "Parameter '{0}' of constructor signature from exported interface has or is using private name '{1}'."), Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4066, e2.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4066", "Parameter '{0}' of call signature from exported interface has or is using name '{1}' from private module '{2}'."), Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1: a(4067, e2.DiagnosticCategory.Error, "Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1_4067", "Parameter '{0}' of call signature from exported interface has or is using private name '{1}'."), Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4068, e2.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module__4068", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from external module {2} but cannot be named."), Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4069, e2.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4069", "Parameter '{0}' of public static method from exported class has or is using name '{1}' from private module '{2}'."), Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1: a(4070, e2.DiagnosticCategory.Error, "Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1_4070", "Parameter '{0}' of public static method from exported class has or is using private name '{1}'."), Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4071, e2.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_c_4071", "Parameter '{0}' of public method from exported class has or is using name '{1}' from external module {2} but cannot be named."), Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2: a(4072, e2.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2_4072", "Parameter '{0}' of public method from exported class has or is using name '{1}' from private module '{2}'."), Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1: a(4073, e2.DiagnosticCategory.Error, "Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1_4073", "Parameter '{0}' of public method from exported class has or is using private name '{1}'."), Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4074, e2.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4074", "Parameter '{0}' of method from exported interface has or is using name '{1}' from private module '{2}'."), Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1: a(4075, e2.DiagnosticCategory.Error, "Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1_4075", "Parameter '{0}' of method from exported interface has or is using private name '{1}'."), Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4076, e2.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4076", "Parameter '{0}' of exported function has or is using name '{1}' from external module {2} but cannot be named."), Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2: a(4077, e2.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2_4077", "Parameter '{0}' of exported function has or is using name '{1}' from private module '{2}'."), Parameter_0_of_exported_function_has_or_is_using_private_name_1: a(4078, e2.DiagnosticCategory.Error, "Parameter_0_of_exported_function_has_or_is_using_private_name_1_4078", "Parameter '{0}' of exported function has or is using private name '{1}'."), Exported_type_alias_0_has_or_is_using_private_name_1: a(4081, e2.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_4081", "Exported type alias '{0}' has or is using private name '{1}'."), Default_export_of_the_module_has_or_is_using_private_name_0: a(4082, e2.DiagnosticCategory.Error, "Default_export_of_the_module_has_or_is_using_private_name_0_4082", "Default export of the module has or is using private name '{0}'."), Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1: a(4083, e2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1_4083", "Type parameter '{0}' of exported type alias has or is using private name '{1}'."), Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2: a(4084, e2.DiagnosticCategory.Error, "Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2_4084", "Exported type alias '{0}' has or is using private name '{1}' from module {2}."), Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict: a(4090, e2.DiagnosticCategory.Error, "Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_librar_4090", "Conflicting definitions for '{0}' found at '{1}' and '{2}'. Consider installing a specific version of this library to resolve the conflict."), Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4091, e2.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2_4091", "Parameter '{0}' of index signature from exported interface has or is using name '{1}' from private module '{2}'."), Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1: a(4092, e2.DiagnosticCategory.Error, "Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1_4092", "Parameter '{0}' of index signature from exported interface has or is using private name '{1}'."), Property_0_of_exported_class_expression_may_not_be_private_or_protected: a(4094, e2.DiagnosticCategory.Error, "Property_0_of_exported_class_expression_may_not_be_private_or_protected_4094", "Property '{0}' of exported class expression may not be private or protected."), Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4095, e2.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_4095", "Public static method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."), Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: a(4096, e2.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4096", "Public static method '{0}' of exported class has or is using name '{1}' from private module '{2}'."), Public_static_method_0_of_exported_class_has_or_is_using_private_name_1: a(4097, e2.DiagnosticCategory.Error, "Public_static_method_0_of_exported_class_has_or_is_using_private_name_1_4097", "Public static method '{0}' of exported class has or is using private name '{1}'."), Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4098, e2.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4098", "Public method '{0}' of exported class has or is using name '{1}' from external module {2} but cannot be named."), Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2: a(4099, e2.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2_4099", "Public method '{0}' of exported class has or is using name '{1}' from private module '{2}'."), Public_method_0_of_exported_class_has_or_is_using_private_name_1: a(4100, e2.DiagnosticCategory.Error, "Public_method_0_of_exported_class_has_or_is_using_private_name_1_4100", "Public method '{0}' of exported class has or is using private name '{1}'."), Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2: a(4101, e2.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2_4101", "Method '{0}' of exported interface has or is using name '{1}' from private module '{2}'."), Method_0_of_exported_interface_has_or_is_using_private_name_1: a(4102, e2.DiagnosticCategory.Error, "Method_0_of_exported_interface_has_or_is_using_private_name_1_4102", "Method '{0}' of exported interface has or is using private name '{1}'."), Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1: a(4103, e2.DiagnosticCategory.Error, "Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1_4103", "Type parameter '{0}' of exported mapped object type is using private name '{1}'."), The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1: a(4104, e2.DiagnosticCategory.Error, "The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1_4104", "The type '{0}' is 'readonly' and cannot be assigned to the mutable type '{1}'."), Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter: a(4105, e2.DiagnosticCategory.Error, "Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter_4105", "Private or protected member '{0}' cannot be accessed on a type parameter."), Parameter_0_of_accessor_has_or_is_using_private_name_1: a(4106, e2.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_private_name_1_4106", "Parameter '{0}' of accessor has or is using private name '{1}'."), Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2: a(4107, e2.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2_4107", "Parameter '{0}' of accessor has or is using name '{1}' from private module '{2}'."), Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named: a(4108, e2.DiagnosticCategory.Error, "Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named_4108", "Parameter '{0}' of accessor has or is using name '{1}' from external module '{2}' but cannot be named."), Type_arguments_for_0_circularly_reference_themselves: a(4109, e2.DiagnosticCategory.Error, "Type_arguments_for_0_circularly_reference_themselves_4109", "Type arguments for '{0}' circularly reference themselves."), Tuple_type_arguments_circularly_reference_themselves: a(4110, e2.DiagnosticCategory.Error, "Tuple_type_arguments_circularly_reference_themselves_4110", "Tuple type arguments circularly reference themselves."), Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0: a(4111, e2.DiagnosticCategory.Error, "Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0_4111", "Property '{0}' comes from an index signature, so it must be accessed with ['{0}']."), This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class: a(4112, e2.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another__4112", "This member cannot have an 'override' modifier because its containing class '{0}' does not extend another class."), This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0: a(4113, e2.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_4113", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'."), This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0: a(4114, e2.DiagnosticCategory.Error, "This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0_4114", "This member must have an 'override' modifier because it overrides a member in the base class '{0}'."), This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0: a(4115, e2.DiagnosticCategory.Error, "This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0_4115", "This parameter property must have an 'override' modifier because it overrides a member in base class '{0}'."), This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0: a(4116, e2.DiagnosticCategory.Error, "This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared__4116", "This member must have an 'override' modifier because it overrides an abstract method that is declared in the base class '{0}'."), This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1: a(4117, e2.DiagnosticCategory.Error, "This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you__4117", "This member cannot have an 'override' modifier because it is not declared in the base class '{0}'. Did you mean '{1}'?"), The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized: a(4118, e2.DiagnosticCategory.Error, "The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized_4118", "The type of this node cannot be serialized because its property '{0}' cannot be serialized."), This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0: a(4119, e2.DiagnosticCategory.Error, "This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_4119", "This member must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."), This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0: a(4120, e2.DiagnosticCategory.Error, "This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_4120", "This parameter property must have a JSDoc comment with an '@override' tag because it overrides a member in the base class '{0}'."), This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class: a(4121, e2.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_4121", "This member cannot have a JSDoc comment with an '@override' tag because its containing class '{0}' does not extend another class."), This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0: a(4122, e2.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4122", "This member cannot have a JSDoc comment with an '@override' tag because it is not declared in the base class '{0}'."), This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1: a(4123, e2.DiagnosticCategory.Error, "This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base__4123", "This member cannot have a JSDoc comment with an 'override' tag because it is not declared in the base class '{0}'. Did you mean '{1}'?"), Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next: a(4124, e2.DiagnosticCategory.Error, "Compiler_option_0_of_value_1_is_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_w_4124", "Compiler option '{0}' of value '{1}' is unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."), Resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next: a(4125, e2.DiagnosticCategory.Error, "Resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_wi_4125", "Resolution mode assertions are unstable. Use nightly TypeScript to silence this error. Try updating with 'npm install -D typescript@next'."), The_current_host_does_not_support_the_0_option: a(5001, e2.DiagnosticCategory.Error, "The_current_host_does_not_support_the_0_option_5001", "The current host does not support the '{0}' option."), Cannot_find_the_common_subdirectory_path_for_the_input_files: a(5009, e2.DiagnosticCategory.Error, "Cannot_find_the_common_subdirectory_path_for_the_input_files_5009", "Cannot find the common subdirectory path for the input files."), File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: a(5010, e2.DiagnosticCategory.Error, "File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0_5010", "File specification cannot end in a recursive directory wildcard ('**'): '{0}'."), Cannot_read_file_0_Colon_1: a(5012, e2.DiagnosticCategory.Error, "Cannot_read_file_0_Colon_1_5012", "Cannot read file '{0}': {1}."), Failed_to_parse_file_0_Colon_1: a(5014, e2.DiagnosticCategory.Error, "Failed_to_parse_file_0_Colon_1_5014", "Failed to parse file '{0}': {1}."), Unknown_compiler_option_0: a(5023, e2.DiagnosticCategory.Error, "Unknown_compiler_option_0_5023", "Unknown compiler option '{0}'."), Compiler_option_0_requires_a_value_of_type_1: a(5024, e2.DiagnosticCategory.Error, "Compiler_option_0_requires_a_value_of_type_1_5024", "Compiler option '{0}' requires a value of type {1}."), Unknown_compiler_option_0_Did_you_mean_1: a(5025, e2.DiagnosticCategory.Error, "Unknown_compiler_option_0_Did_you_mean_1_5025", "Unknown compiler option '{0}'. Did you mean '{1}'?"), Could_not_write_file_0_Colon_1: a(5033, e2.DiagnosticCategory.Error, "Could_not_write_file_0_Colon_1_5033", "Could not write file '{0}': {1}."), Option_project_cannot_be_mixed_with_source_files_on_a_command_line: a(5042, e2.DiagnosticCategory.Error, "Option_project_cannot_be_mixed_with_source_files_on_a_command_line_5042", "Option 'project' cannot be mixed with source files on a command line."), Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher: a(5047, e2.DiagnosticCategory.Error, "Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES_5047", "Option 'isolatedModules' can only be used when either option '--module' is provided or option 'target' is 'ES2015' or higher."), Option_0_cannot_be_specified_when_option_target_is_ES3: a(5048, e2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_target_is_ES3_5048", "Option '{0}' cannot be specified when option 'target' is 'ES3'."), Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided: a(5051, e2.DiagnosticCategory.Error, "Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided_5051", "Option '{0} can only be used when either option '--inlineSourceMap' or option '--sourceMap' is provided."), Option_0_cannot_be_specified_without_specifying_option_1: a(5052, e2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_5052", "Option '{0}' cannot be specified without specifying option '{1}'."), Option_0_cannot_be_specified_with_option_1: a(5053, e2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_with_option_1_5053", "Option '{0}' cannot be specified with option '{1}'."), A_tsconfig_json_file_is_already_defined_at_Colon_0: a(5054, e2.DiagnosticCategory.Error, "A_tsconfig_json_file_is_already_defined_at_Colon_0_5054", "A 'tsconfig.json' file is already defined at: '{0}'."), Cannot_write_file_0_because_it_would_overwrite_input_file: a(5055, e2.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_overwrite_input_file_5055", "Cannot write file '{0}' because it would overwrite input file."), Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files: a(5056, e2.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files_5056", "Cannot write file '{0}' because it would be overwritten by multiple input files."), Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0: a(5057, e2.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_specified_directory_Colon_0_5057", "Cannot find a tsconfig.json file at the specified directory: '{0}'."), The_specified_path_does_not_exist_Colon_0: a(5058, e2.DiagnosticCategory.Error, "The_specified_path_does_not_exist_Colon_0_5058", "The specified path does not exist: '{0}'."), Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier: a(5059, e2.DiagnosticCategory.Error, "Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier_5059", "Invalid value for '--reactNamespace'. '{0}' is not a valid identifier."), Pattern_0_can_have_at_most_one_Asterisk_character: a(5061, e2.DiagnosticCategory.Error, "Pattern_0_can_have_at_most_one_Asterisk_character_5061", "Pattern '{0}' can have at most one '*' character."), Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character: a(5062, e2.DiagnosticCategory.Error, "Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character_5062", "Substitution '{0}' in pattern '{1}' can have at most one '*' character."), Substitutions_for_pattern_0_should_be_an_array: a(5063, e2.DiagnosticCategory.Error, "Substitutions_for_pattern_0_should_be_an_array_5063", "Substitutions for pattern '{0}' should be an array."), Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2: a(5064, e2.DiagnosticCategory.Error, "Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2_5064", "Substitution '{0}' for pattern '{1}' has incorrect type, expected 'string', got '{2}'."), File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0: a(5065, e2.DiagnosticCategory.Error, "File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildca_5065", "File specification cannot contain a parent directory ('..') that appears after a recursive directory wildcard ('**'): '{0}'."), Substitutions_for_pattern_0_shouldn_t_be_an_empty_array: a(5066, e2.DiagnosticCategory.Error, "Substitutions_for_pattern_0_shouldn_t_be_an_empty_array_5066", "Substitutions for pattern '{0}' shouldn't be an empty array."), Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name: a(5067, e2.DiagnosticCategory.Error, "Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name_5067", "Invalid value for 'jsxFactory'. '{0}' is not a valid identifier or qualified-name."), Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig: a(5068, e2.DiagnosticCategory.Error, "Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript__5068", "Adding a tsconfig.json file will help organize projects that contain both TypeScript and JavaScript files. Learn more at https://aka.ms/tsconfig."), Option_0_cannot_be_specified_without_specifying_option_1_or_option_2: a(5069, e2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_without_specifying_option_1_or_option_2_5069", "Option '{0}' cannot be specified without specifying option '{1}' or option '{2}'."), Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy: a(5070, e2.DiagnosticCategory.Error, "Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy_5070", "Option '--resolveJsonModule' cannot be specified without 'node' module resolution strategy."), Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext: a(5071, e2.DiagnosticCategory.Error, "Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_5071", "Option '--resolveJsonModule' can only be specified when module code generation is 'commonjs', 'amd', 'es2015' or 'esNext'."), Unknown_build_option_0: a(5072, e2.DiagnosticCategory.Error, "Unknown_build_option_0_5072", "Unknown build option '{0}'."), Build_option_0_requires_a_value_of_type_1: a(5073, e2.DiagnosticCategory.Error, "Build_option_0_requires_a_value_of_type_1_5073", "Build option '{0}' requires a value of type {1}."), Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified: a(5074, e2.DiagnosticCategory.Error, "Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBui_5074", "Option '--incremental' can only be specified using tsconfig, emitting to single file or when option '--tsBuildInfoFile' is specified."), _0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2: a(5075, e2.DiagnosticCategory.Error, "_0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_5075", "'{0}' is assignable to the constraint of type '{1}', but '{1}' could be instantiated with a different subtype of constraint '{2}'."), _0_and_1_operations_cannot_be_mixed_without_parentheses: a(5076, e2.DiagnosticCategory.Error, "_0_and_1_operations_cannot_be_mixed_without_parentheses_5076", "'{0}' and '{1}' operations cannot be mixed without parentheses."), Unknown_build_option_0_Did_you_mean_1: a(5077, e2.DiagnosticCategory.Error, "Unknown_build_option_0_Did_you_mean_1_5077", "Unknown build option '{0}'. Did you mean '{1}'?"), Unknown_watch_option_0: a(5078, e2.DiagnosticCategory.Error, "Unknown_watch_option_0_5078", "Unknown watch option '{0}'."), Unknown_watch_option_0_Did_you_mean_1: a(5079, e2.DiagnosticCategory.Error, "Unknown_watch_option_0_Did_you_mean_1_5079", "Unknown watch option '{0}'. Did you mean '{1}'?"), Watch_option_0_requires_a_value_of_type_1: a(5080, e2.DiagnosticCategory.Error, "Watch_option_0_requires_a_value_of_type_1_5080", "Watch option '{0}' requires a value of type {1}."), Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0: a(5081, e2.DiagnosticCategory.Error, "Cannot_find_a_tsconfig_json_file_at_the_current_directory_Colon_0_5081", "Cannot find a tsconfig.json file at the current directory: {0}."), _0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1: a(5082, e2.DiagnosticCategory.Error, "_0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1_5082", "'{0}' could be instantiated with an arbitrary type which could be unrelated to '{1}'."), Cannot_read_file_0: a(5083, e2.DiagnosticCategory.Error, "Cannot_read_file_0_5083", "Cannot read file '{0}'."), Tuple_members_must_all_have_names_or_all_not_have_names: a(5084, e2.DiagnosticCategory.Error, "Tuple_members_must_all_have_names_or_all_not_have_names_5084", "Tuple members must all have names or all not have names."), A_tuple_member_cannot_be_both_optional_and_rest: a(5085, e2.DiagnosticCategory.Error, "A_tuple_member_cannot_be_both_optional_and_rest_5085", "A tuple member cannot be both optional and rest."), A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type: a(5086, e2.DiagnosticCategory.Error, "A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_c_5086", "A labeled tuple element is declared as optional with a question mark after the name and before the colon, rather than after the type."), A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type: a(5087, e2.DiagnosticCategory.Error, "A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type_5087", "A labeled tuple element is declared as rest with a '...' before the name, rather than before the type."), The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary: a(5088, e2.DiagnosticCategory.Error, "The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialize_5088", "The inferred type of '{0}' references a type with a cyclic structure which cannot be trivially serialized. A type annotation is necessary."), Option_0_cannot_be_specified_when_option_jsx_is_1: a(5089, e2.DiagnosticCategory.Error, "Option_0_cannot_be_specified_when_option_jsx_is_1_5089", "Option '{0}' cannot be specified when option 'jsx' is '{1}'."), Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash: a(5090, e2.DiagnosticCategory.Error, "Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash_5090", "Non-relative paths are not allowed when 'baseUrl' is not set. Did you forget a leading './'?"), Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled: a(5091, e2.DiagnosticCategory.Error, "Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled_5091", "Option 'preserveConstEnums' cannot be disabled when 'isolatedModules' is enabled."), The_root_value_of_a_0_file_must_be_an_object: a(5092, e2.DiagnosticCategory.Error, "The_root_value_of_a_0_file_must_be_an_object_5092", "The root value of a '{0}' file must be an object."), Compiler_option_0_may_only_be_used_with_build: a(5093, e2.DiagnosticCategory.Error, "Compiler_option_0_may_only_be_used_with_build_5093", "Compiler option '--{0}' may only be used with '--build'."), Compiler_option_0_may_not_be_used_with_build: a(5094, e2.DiagnosticCategory.Error, "Compiler_option_0_may_not_be_used_with_build_5094", "Compiler option '--{0}' may not be used with '--build'."), Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later: a(5095, e2.DiagnosticCategory.Error, "Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later_5095", "Option 'preserveValueImports' can only be used when 'module' is set to 'es2015' or later."), Generates_a_sourcemap_for_each_corresponding_d_ts_file: a(6e3, e2.DiagnosticCategory.Message, "Generates_a_sourcemap_for_each_corresponding_d_ts_file_6000", "Generates a sourcemap for each corresponding '.d.ts' file."), Concatenate_and_emit_output_to_single_file: a(6001, e2.DiagnosticCategory.Message, "Concatenate_and_emit_output_to_single_file_6001", "Concatenate and emit output to single file."), Generates_corresponding_d_ts_file: a(6002, e2.DiagnosticCategory.Message, "Generates_corresponding_d_ts_file_6002", "Generates corresponding '.d.ts' file."), Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations: a(6004, e2.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_TypeScript_files_instead_of_source_locations_6004", "Specify the location where debugger should locate TypeScript files instead of source locations."), Watch_input_files: a(6005, e2.DiagnosticCategory.Message, "Watch_input_files_6005", "Watch input files."), Redirect_output_structure_to_the_directory: a(6006, e2.DiagnosticCategory.Message, "Redirect_output_structure_to_the_directory_6006", "Redirect output structure to the directory."), Do_not_erase_const_enum_declarations_in_generated_code: a(6007, e2.DiagnosticCategory.Message, "Do_not_erase_const_enum_declarations_in_generated_code_6007", "Do not erase const enum declarations in generated code."), Do_not_emit_outputs_if_any_errors_were_reported: a(6008, e2.DiagnosticCategory.Message, "Do_not_emit_outputs_if_any_errors_were_reported_6008", "Do not emit outputs if any errors were reported."), Do_not_emit_comments_to_output: a(6009, e2.DiagnosticCategory.Message, "Do_not_emit_comments_to_output_6009", "Do not emit comments to output."), Do_not_emit_outputs: a(6010, e2.DiagnosticCategory.Message, "Do_not_emit_outputs_6010", "Do not emit outputs."), Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typechecking: a(6011, e2.DiagnosticCategory.Message, "Allow_default_imports_from_modules_with_no_default_export_This_does_not_affect_code_emit_just_typech_6011", "Allow default imports from modules with no default export. This does not affect code emit, just typechecking."), Skip_type_checking_of_declaration_files: a(6012, e2.DiagnosticCategory.Message, "Skip_type_checking_of_declaration_files_6012", "Skip type checking of declaration files."), Do_not_resolve_the_real_path_of_symlinks: a(6013, e2.DiagnosticCategory.Message, "Do_not_resolve_the_real_path_of_symlinks_6013", "Do not resolve the real path of symlinks."), Only_emit_d_ts_declaration_files: a(6014, e2.DiagnosticCategory.Message, "Only_emit_d_ts_declaration_files_6014", "Only emit '.d.ts' declaration files."), Specify_ECMAScript_target_version: a(6015, e2.DiagnosticCategory.Message, "Specify_ECMAScript_target_version_6015", "Specify ECMAScript target version."), Specify_module_code_generation: a(6016, e2.DiagnosticCategory.Message, "Specify_module_code_generation_6016", "Specify module code generation."), Print_this_message: a(6017, e2.DiagnosticCategory.Message, "Print_this_message_6017", "Print this message."), Print_the_compiler_s_version: a(6019, e2.DiagnosticCategory.Message, "Print_the_compiler_s_version_6019", "Print the compiler's version."), Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json: a(6020, e2.DiagnosticCategory.Message, "Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json_6020", "Compile the project given the path to its configuration file, or to a folder with a 'tsconfig.json'."), Syntax_Colon_0: a(6023, e2.DiagnosticCategory.Message, "Syntax_Colon_0_6023", "Syntax: {0}"), options: a(6024, e2.DiagnosticCategory.Message, "options_6024", "options"), file: a(6025, e2.DiagnosticCategory.Message, "file_6025", "file"), Examples_Colon_0: a(6026, e2.DiagnosticCategory.Message, "Examples_Colon_0_6026", "Examples: {0}"), Options_Colon: a(6027, e2.DiagnosticCategory.Message, "Options_Colon_6027", "Options:"), Version_0: a(6029, e2.DiagnosticCategory.Message, "Version_0_6029", "Version {0}"), Insert_command_line_options_and_files_from_a_file: a(6030, e2.DiagnosticCategory.Message, "Insert_command_line_options_and_files_from_a_file_6030", "Insert command line options and files from a file."), Starting_compilation_in_watch_mode: a(6031, e2.DiagnosticCategory.Message, "Starting_compilation_in_watch_mode_6031", "Starting compilation in watch mode..."), File_change_detected_Starting_incremental_compilation: a(6032, e2.DiagnosticCategory.Message, "File_change_detected_Starting_incremental_compilation_6032", "File change detected. Starting incremental compilation..."), KIND: a(6034, e2.DiagnosticCategory.Message, "KIND_6034", "KIND"), FILE: a(6035, e2.DiagnosticCategory.Message, "FILE_6035", "FILE"), VERSION: a(6036, e2.DiagnosticCategory.Message, "VERSION_6036", "VERSION"), LOCATION: a(6037, e2.DiagnosticCategory.Message, "LOCATION_6037", "LOCATION"), DIRECTORY: a(6038, e2.DiagnosticCategory.Message, "DIRECTORY_6038", "DIRECTORY"), STRATEGY: a(6039, e2.DiagnosticCategory.Message, "STRATEGY_6039", "STRATEGY"), FILE_OR_DIRECTORY: a(6040, e2.DiagnosticCategory.Message, "FILE_OR_DIRECTORY_6040", "FILE OR DIRECTORY"), Errors_Files: a(6041, e2.DiagnosticCategory.Message, "Errors_Files_6041", "Errors  Files"), Generates_corresponding_map_file: a(6043, e2.DiagnosticCategory.Message, "Generates_corresponding_map_file_6043", "Generates corresponding '.map' file."), Compiler_option_0_expects_an_argument: a(6044, e2.DiagnosticCategory.Error, "Compiler_option_0_expects_an_argument_6044", "Compiler option '{0}' expects an argument."), Unterminated_quoted_string_in_response_file_0: a(6045, e2.DiagnosticCategory.Error, "Unterminated_quoted_string_in_response_file_0_6045", "Unterminated quoted string in response file '{0}'."), Argument_for_0_option_must_be_Colon_1: a(6046, e2.DiagnosticCategory.Error, "Argument_for_0_option_must_be_Colon_1_6046", "Argument for '{0}' option must be: {1}."), Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1: a(6048, e2.DiagnosticCategory.Error, "Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1_6048", "Locale must be of the form <language> or <language>-<territory>. For example '{0}' or '{1}'."), Unable_to_open_file_0: a(6050, e2.DiagnosticCategory.Error, "Unable_to_open_file_0_6050", "Unable to open file '{0}'."), Corrupted_locale_file_0: a(6051, e2.DiagnosticCategory.Error, "Corrupted_locale_file_0_6051", "Corrupted locale file {0}."), Raise_error_on_expressions_and_declarations_with_an_implied_any_type: a(6052, e2.DiagnosticCategory.Message, "Raise_error_on_expressions_and_declarations_with_an_implied_any_type_6052", "Raise error on expressions and declarations with an implied 'any' type."), File_0_not_found: a(6053, e2.DiagnosticCategory.Error, "File_0_not_found_6053", "File '{0}' not found."), File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1: a(6054, e2.DiagnosticCategory.Error, "File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1_6054", "File '{0}' has an unsupported extension. The only supported extensions are {1}."), Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures: a(6055, e2.DiagnosticCategory.Message, "Suppress_noImplicitAny_errors_for_indexing_objects_lacking_index_signatures_6055", "Suppress noImplicitAny errors for indexing objects lacking index signatures."), Do_not_emit_declarations_for_code_that_has_an_internal_annotation: a(6056, e2.DiagnosticCategory.Message, "Do_not_emit_declarations_for_code_that_has_an_internal_annotation_6056", "Do not emit declarations for code that has an '@internal' annotation."), Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir: a(6058, e2.DiagnosticCategory.Message, "Specify_the_root_directory_of_input_files_Use_to_control_the_output_directory_structure_with_outDir_6058", "Specify the root directory of input files. Use to control the output directory structure with --outDir."), File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files: a(6059, e2.DiagnosticCategory.Error, "File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files_6059", "File '{0}' is not under 'rootDir' '{1}'. 'rootDir' is expected to contain all source files."), Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix: a(6060, e2.DiagnosticCategory.Message, "Specify_the_end_of_line_sequence_to_be_used_when_emitting_files_Colon_CRLF_dos_or_LF_unix_6060", "Specify the end of line sequence to be used when emitting files: 'CRLF' (dos) or 'LF' (unix)."), NEWLINE: a(6061, e2.DiagnosticCategory.Message, "NEWLINE_6061", "NEWLINE"), Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line: a(6064, e2.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line_6064", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'null' on command line."), Enables_experimental_support_for_ES7_decorators: a(6065, e2.DiagnosticCategory.Message, "Enables_experimental_support_for_ES7_decorators_6065", "Enables experimental support for ES7 decorators."), Enables_experimental_support_for_emitting_type_metadata_for_decorators: a(6066, e2.DiagnosticCategory.Message, "Enables_experimental_support_for_emitting_type_metadata_for_decorators_6066", "Enables experimental support for emitting type metadata for decorators."), Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6: a(6069, e2.DiagnosticCategory.Message, "Specify_module_resolution_strategy_Colon_node_Node_js_or_classic_TypeScript_pre_1_6_6069", "Specify module resolution strategy: 'node' (Node.js) or 'classic' (TypeScript pre-1.6)."), Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file: a(6070, e2.DiagnosticCategory.Message, "Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file_6070", "Initializes a TypeScript project and creates a tsconfig.json file."), Successfully_created_a_tsconfig_json_file: a(6071, e2.DiagnosticCategory.Message, "Successfully_created_a_tsconfig_json_file_6071", "Successfully created a tsconfig.json file."), Suppress_excess_property_checks_for_object_literals: a(6072, e2.DiagnosticCategory.Message, "Suppress_excess_property_checks_for_object_literals_6072", "Suppress excess property checks for object literals."), Stylize_errors_and_messages_using_color_and_context_experimental: a(6073, e2.DiagnosticCategory.Message, "Stylize_errors_and_messages_using_color_and_context_experimental_6073", "Stylize errors and messages using color and context (experimental)."), Do_not_report_errors_on_unused_labels: a(6074, e2.DiagnosticCategory.Message, "Do_not_report_errors_on_unused_labels_6074", "Do not report errors on unused labels."), Report_error_when_not_all_code_paths_in_function_return_a_value: a(6075, e2.DiagnosticCategory.Message, "Report_error_when_not_all_code_paths_in_function_return_a_value_6075", "Report error when not all code paths in function return a value."), Report_errors_for_fallthrough_cases_in_switch_statement: a(6076, e2.DiagnosticCategory.Message, "Report_errors_for_fallthrough_cases_in_switch_statement_6076", "Report errors for fallthrough cases in switch statement."), Do_not_report_errors_on_unreachable_code: a(6077, e2.DiagnosticCategory.Message, "Do_not_report_errors_on_unreachable_code_6077", "Do not report errors on unreachable code."), Disallow_inconsistently_cased_references_to_the_same_file: a(6078, e2.DiagnosticCategory.Message, "Disallow_inconsistently_cased_references_to_the_same_file_6078", "Disallow inconsistently-cased references to the same file."), Specify_library_files_to_be_included_in_the_compilation: a(6079, e2.DiagnosticCategory.Message, "Specify_library_files_to_be_included_in_the_compilation_6079", "Specify library files to be included in the compilation."), Specify_JSX_code_generation: a(6080, e2.DiagnosticCategory.Message, "Specify_JSX_code_generation_6080", "Specify JSX code generation."), File_0_has_an_unsupported_extension_so_skipping_it: a(6081, e2.DiagnosticCategory.Message, "File_0_has_an_unsupported_extension_so_skipping_it_6081", "File '{0}' has an unsupported extension, so skipping it."), Only_amd_and_system_modules_are_supported_alongside_0: a(6082, e2.DiagnosticCategory.Error, "Only_amd_and_system_modules_are_supported_alongside_0_6082", "Only 'amd' and 'system' modules are supported alongside --{0}."), Base_directory_to_resolve_non_absolute_module_names: a(6083, e2.DiagnosticCategory.Message, "Base_directory_to_resolve_non_absolute_module_names_6083", "Base directory to resolve non-absolute module names."), Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react_JSX_emit: a(6084, e2.DiagnosticCategory.Message, "Deprecated_Use_jsxFactory_instead_Specify_the_object_invoked_for_createElement_when_targeting_react__6084", "[Deprecated] Use '--jsxFactory' instead. Specify the object invoked for createElement when targeting 'react' JSX emit"), Enable_tracing_of_the_name_resolution_process: a(6085, e2.DiagnosticCategory.Message, "Enable_tracing_of_the_name_resolution_process_6085", "Enable tracing of the name resolution process."), Resolving_module_0_from_1: a(6086, e2.DiagnosticCategory.Message, "Resolving_module_0_from_1_6086", "======== Resolving module '{0}' from '{1}'. ========"), Explicitly_specified_module_resolution_kind_Colon_0: a(6087, e2.DiagnosticCategory.Message, "Explicitly_specified_module_resolution_kind_Colon_0_6087", "Explicitly specified module resolution kind: '{0}'."), Module_resolution_kind_is_not_specified_using_0: a(6088, e2.DiagnosticCategory.Message, "Module_resolution_kind_is_not_specified_using_0_6088", "Module resolution kind is not specified, using '{0}'."), Module_name_0_was_successfully_resolved_to_1: a(6089, e2.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_6089", "======== Module name '{0}' was successfully resolved to '{1}'. ========"), Module_name_0_was_not_resolved: a(6090, e2.DiagnosticCategory.Message, "Module_name_0_was_not_resolved_6090", "======== Module name '{0}' was not resolved. ========"), paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0: a(6091, e2.DiagnosticCategory.Message, "paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0_6091", "'paths' option is specified, looking for a pattern to match module name '{0}'."), Module_name_0_matched_pattern_1: a(6092, e2.DiagnosticCategory.Message, "Module_name_0_matched_pattern_1_6092", "Module name '{0}', matched pattern '{1}'."), Trying_substitution_0_candidate_module_location_Colon_1: a(6093, e2.DiagnosticCategory.Message, "Trying_substitution_0_candidate_module_location_Colon_1_6093", "Trying substitution '{0}', candidate module location: '{1}'."), Resolving_module_name_0_relative_to_base_url_1_2: a(6094, e2.DiagnosticCategory.Message, "Resolving_module_name_0_relative_to_base_url_1_2_6094", "Resolving module name '{0}' relative to base url '{1}' - '{2}'."), Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1: a(6095, e2.DiagnosticCategory.Message, "Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1_6095", "Loading module as file / folder, candidate module location '{0}', target file type '{1}'."), File_0_does_not_exist: a(6096, e2.DiagnosticCategory.Message, "File_0_does_not_exist_6096", "File '{0}' does not exist."), File_0_exist_use_it_as_a_name_resolution_result: a(6097, e2.DiagnosticCategory.Message, "File_0_exist_use_it_as_a_name_resolution_result_6097", "File '{0}' exist - use it as a name resolution result."), Loading_module_0_from_node_modules_folder_target_file_type_1: a(6098, e2.DiagnosticCategory.Message, "Loading_module_0_from_node_modules_folder_target_file_type_1_6098", "Loading module '{0}' from 'node_modules' folder, target file type '{1}'."), Found_package_json_at_0: a(6099, e2.DiagnosticCategory.Message, "Found_package_json_at_0_6099", "Found 'package.json' at '{0}'."), package_json_does_not_have_a_0_field: a(6100, e2.DiagnosticCategory.Message, "package_json_does_not_have_a_0_field_6100", "'package.json' does not have a '{0}' field."), package_json_has_0_field_1_that_references_2: a(6101, e2.DiagnosticCategory.Message, "package_json_has_0_field_1_that_references_2_6101", "'package.json' has '{0}' field '{1}' that references '{2}'."), Allow_javascript_files_to_be_compiled: a(6102, e2.DiagnosticCategory.Message, "Allow_javascript_files_to_be_compiled_6102", "Allow javascript files to be compiled."), Checking_if_0_is_the_longest_matching_prefix_for_1_2: a(6104, e2.DiagnosticCategory.Message, "Checking_if_0_is_the_longest_matching_prefix_for_1_2_6104", "Checking if '{0}' is the longest matching prefix for '{1}' - '{2}'."), Expected_type_of_0_field_in_package_json_to_be_1_got_2: a(6105, e2.DiagnosticCategory.Message, "Expected_type_of_0_field_in_package_json_to_be_1_got_2_6105", "Expected type of '{0}' field in 'package.json' to be '{1}', got '{2}'."), baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1: a(6106, e2.DiagnosticCategory.Message, "baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1_6106", "'baseUrl' option is set to '{0}', using this value to resolve non-relative module name '{1}'."), rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0: a(6107, e2.DiagnosticCategory.Message, "rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0_6107", "'rootDirs' option is set, using it to resolve relative module name '{0}'."), Longest_matching_prefix_for_0_is_1: a(6108, e2.DiagnosticCategory.Message, "Longest_matching_prefix_for_0_is_1_6108", "Longest matching prefix for '{0}' is '{1}'."), Loading_0_from_the_root_dir_1_candidate_location_2: a(6109, e2.DiagnosticCategory.Message, "Loading_0_from_the_root_dir_1_candidate_location_2_6109", "Loading '{0}' from the root dir '{1}', candidate location '{2}'."), Trying_other_entries_in_rootDirs: a(6110, e2.DiagnosticCategory.Message, "Trying_other_entries_in_rootDirs_6110", "Trying other entries in 'rootDirs'."), Module_resolution_using_rootDirs_has_failed: a(6111, e2.DiagnosticCategory.Message, "Module_resolution_using_rootDirs_has_failed_6111", "Module resolution using 'rootDirs' has failed."), Do_not_emit_use_strict_directives_in_module_output: a(6112, e2.DiagnosticCategory.Message, "Do_not_emit_use_strict_directives_in_module_output_6112", "Do not emit 'use strict' directives in module output."), Enable_strict_null_checks: a(6113, e2.DiagnosticCategory.Message, "Enable_strict_null_checks_6113", "Enable strict null checks."), Unknown_option_excludes_Did_you_mean_exclude: a(6114, e2.DiagnosticCategory.Error, "Unknown_option_excludes_Did_you_mean_exclude_6114", "Unknown option 'excludes'. Did you mean 'exclude'?"), Raise_error_on_this_expressions_with_an_implied_any_type: a(6115, e2.DiagnosticCategory.Message, "Raise_error_on_this_expressions_with_an_implied_any_type_6115", "Raise error on 'this' expressions with an implied 'any' type."), Resolving_type_reference_directive_0_containing_file_1_root_directory_2: a(6116, e2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_2_6116", "======== Resolving type reference directive '{0}', containing file '{1}', root directory '{2}'. ========"), Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2: a(6119, e2.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2_6119", "======== Type reference directive '{0}' was successfully resolved to '{1}', primary: {2}. ========"), Type_reference_directive_0_was_not_resolved: a(6120, e2.DiagnosticCategory.Message, "Type_reference_directive_0_was_not_resolved_6120", "======== Type reference directive '{0}' was not resolved. ========"), Resolving_with_primary_search_path_0: a(6121, e2.DiagnosticCategory.Message, "Resolving_with_primary_search_path_0_6121", "Resolving with primary search path '{0}'."), Root_directory_cannot_be_determined_skipping_primary_search_paths: a(6122, e2.DiagnosticCategory.Message, "Root_directory_cannot_be_determined_skipping_primary_search_paths_6122", "Root directory cannot be determined, skipping primary search paths."), Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set: a(6123, e2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set_6123", "======== Resolving type reference directive '{0}', containing file '{1}', root directory not set. ========"), Type_declaration_files_to_be_included_in_compilation: a(6124, e2.DiagnosticCategory.Message, "Type_declaration_files_to_be_included_in_compilation_6124", "Type declaration files to be included in compilation."), Looking_up_in_node_modules_folder_initial_location_0: a(6125, e2.DiagnosticCategory.Message, "Looking_up_in_node_modules_folder_initial_location_0_6125", "Looking up in 'node_modules' folder, initial location '{0}'."), Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder: a(6126, e2.DiagnosticCategory.Message, "Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_mod_6126", "Containing file is not specified and root directory cannot be determined, skipping lookup in 'node_modules' folder."), Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1: a(6127, e2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1_6127", "======== Resolving type reference directive '{0}', containing file not set, root directory '{1}'. ========"), Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set: a(6128, e2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set_6128", "======== Resolving type reference directive '{0}', containing file not set, root directory not set. ========"), Resolving_real_path_for_0_result_1: a(6130, e2.DiagnosticCategory.Message, "Resolving_real_path_for_0_result_1_6130", "Resolving real path for '{0}', result '{1}'."), Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system: a(6131, e2.DiagnosticCategory.Error, "Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system_6131", "Cannot compile modules using option '{0}' unless the '--module' flag is 'amd' or 'system'."), File_name_0_has_a_1_extension_stripping_it: a(6132, e2.DiagnosticCategory.Message, "File_name_0_has_a_1_extension_stripping_it_6132", "File name '{0}' has a '{1}' extension - stripping it."), _0_is_declared_but_its_value_is_never_read: a(6133, e2.DiagnosticCategory.Error, "_0_is_declared_but_its_value_is_never_read_6133", "'{0}' is declared but its value is never read.", true), Report_errors_on_unused_locals: a(6134, e2.DiagnosticCategory.Message, "Report_errors_on_unused_locals_6134", "Report errors on unused locals."), Report_errors_on_unused_parameters: a(6135, e2.DiagnosticCategory.Message, "Report_errors_on_unused_parameters_6135", "Report errors on unused parameters."), The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files: a(6136, e2.DiagnosticCategory.Message, "The_maximum_dependency_depth_to_search_under_node_modules_and_load_JavaScript_files_6136", "The maximum dependency depth to search under node_modules and load JavaScript files."), Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1: a(6137, e2.DiagnosticCategory.Error, "Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1_6137", "Cannot import type declaration files. Consider importing '{0}' instead of '{1}'."), Property_0_is_declared_but_its_value_is_never_read: a(6138, e2.DiagnosticCategory.Error, "Property_0_is_declared_but_its_value_is_never_read_6138", "Property '{0}' is declared but its value is never read.", true), Import_emit_helpers_from_tslib: a(6139, e2.DiagnosticCategory.Message, "Import_emit_helpers_from_tslib_6139", "Import emit helpers from 'tslib'."), Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2: a(6140, e2.DiagnosticCategory.Error, "Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using__6140", "Auto discovery for typings is enabled in project '{0}'. Running extra resolution pass for module '{1}' using cache location '{2}'."), Parse_in_strict_mode_and_emit_use_strict_for_each_source_file: a(6141, e2.DiagnosticCategory.Message, "Parse_in_strict_mode_and_emit_use_strict_for_each_source_file_6141", 'Parse in strict mode and emit "use strict" for each source file.'), Module_0_was_resolved_to_1_but_jsx_is_not_set: a(6142, e2.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_jsx_is_not_set_6142", "Module '{0}' was resolved to '{1}', but '--jsx' is not set."), Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1: a(6144, e2.DiagnosticCategory.Message, "Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1_6144", "Module '{0}' was resolved as locally declared ambient module in file '{1}'."), Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified: a(6145, e2.DiagnosticCategory.Message, "Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified_6145", "Module '{0}' was resolved as ambient module declared in '{1}' since this file was not modified."), Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h: a(6146, e2.DiagnosticCategory.Message, "Specify_the_JSX_factory_function_to_use_when_targeting_react_JSX_emit_e_g_React_createElement_or_h_6146", "Specify the JSX factory function to use when targeting 'react' JSX emit, e.g. 'React.createElement' or 'h'."), Resolution_for_module_0_was_found_in_cache_from_location_1: a(6147, e2.DiagnosticCategory.Message, "Resolution_for_module_0_was_found_in_cache_from_location_1_6147", "Resolution for module '{0}' was found in cache from location '{1}'."), Directory_0_does_not_exist_skipping_all_lookups_in_it: a(6148, e2.DiagnosticCategory.Message, "Directory_0_does_not_exist_skipping_all_lookups_in_it_6148", "Directory '{0}' does not exist, skipping all lookups in it."), Show_diagnostic_information: a(6149, e2.DiagnosticCategory.Message, "Show_diagnostic_information_6149", "Show diagnostic information."), Show_verbose_diagnostic_information: a(6150, e2.DiagnosticCategory.Message, "Show_verbose_diagnostic_information_6150", "Show verbose diagnostic information."), Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file: a(6151, e2.DiagnosticCategory.Message, "Emit_a_single_file_with_source_maps_instead_of_having_a_separate_file_6151", "Emit a single file with source maps instead of having a separate file."), Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap_to_be_set: a(6152, e2.DiagnosticCategory.Message, "Emit_the_source_alongside_the_sourcemaps_within_a_single_file_requires_inlineSourceMap_or_sourceMap__6152", "Emit the source alongside the sourcemaps within a single file; requires '--inlineSourceMap' or '--sourceMap' to be set."), Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule: a(6153, e2.DiagnosticCategory.Message, "Transpile_each_file_as_a_separate_module_similar_to_ts_transpileModule_6153", "Transpile each file as a separate module (similar to 'ts.transpileModule')."), Print_names_of_generated_files_part_of_the_compilation: a(6154, e2.DiagnosticCategory.Message, "Print_names_of_generated_files_part_of_the_compilation_6154", "Print names of generated files part of the compilation."), Print_names_of_files_part_of_the_compilation: a(6155, e2.DiagnosticCategory.Message, "Print_names_of_files_part_of_the_compilation_6155", "Print names of files part of the compilation."), The_locale_used_when_displaying_messages_to_the_user_e_g_en_us: a(6156, e2.DiagnosticCategory.Message, "The_locale_used_when_displaying_messages_to_the_user_e_g_en_us_6156", "The locale used when displaying messages to the user (e.g. 'en-us')"), Do_not_generate_custom_helper_functions_like_extends_in_compiled_output: a(6157, e2.DiagnosticCategory.Message, "Do_not_generate_custom_helper_functions_like_extends_in_compiled_output_6157", "Do not generate custom helper functions like '__extends' in compiled output."), Do_not_include_the_default_library_file_lib_d_ts: a(6158, e2.DiagnosticCategory.Message, "Do_not_include_the_default_library_file_lib_d_ts_6158", "Do not include the default library file (lib.d.ts)."), Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files: a(6159, e2.DiagnosticCategory.Message, "Do_not_add_triple_slash_references_or_imported_modules_to_the_list_of_compiled_files_6159", "Do not add triple-slash references or imported modules to the list of compiled files."), Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files: a(6160, e2.DiagnosticCategory.Message, "Deprecated_Use_skipLibCheck_instead_Skip_type_checking_of_default_library_declaration_files_6160", "[Deprecated] Use '--skipLibCheck' instead. Skip type checking of default library declaration files."), List_of_folders_to_include_type_definitions_from: a(6161, e2.DiagnosticCategory.Message, "List_of_folders_to_include_type_definitions_from_6161", "List of folders to include type definitions from."), Disable_size_limitations_on_JavaScript_projects: a(6162, e2.DiagnosticCategory.Message, "Disable_size_limitations_on_JavaScript_projects_6162", "Disable size limitations on JavaScript projects."), The_character_set_of_the_input_files: a(6163, e2.DiagnosticCategory.Message, "The_character_set_of_the_input_files_6163", "The character set of the input files."), Do_not_truncate_error_messages: a(6165, e2.DiagnosticCategory.Message, "Do_not_truncate_error_messages_6165", "Do not truncate error messages."), Output_directory_for_generated_declaration_files: a(6166, e2.DiagnosticCategory.Message, "Output_directory_for_generated_declaration_files_6166", "Output directory for generated declaration files."), A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl: a(6167, e2.DiagnosticCategory.Message, "A_series_of_entries_which_re_map_imports_to_lookup_locations_relative_to_the_baseUrl_6167", "A series of entries which re-map imports to lookup locations relative to the 'baseUrl'."), List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime: a(6168, e2.DiagnosticCategory.Message, "List_of_root_folders_whose_combined_content_represents_the_structure_of_the_project_at_runtime_6168", "List of root folders whose combined content represents the structure of the project at runtime."), Show_all_compiler_options: a(6169, e2.DiagnosticCategory.Message, "Show_all_compiler_options_6169", "Show all compiler options."), Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file: a(6170, e2.DiagnosticCategory.Message, "Deprecated_Use_outFile_instead_Concatenate_and_emit_output_to_single_file_6170", "[Deprecated] Use '--outFile' instead. Concatenate and emit output to single file"), Command_line_Options: a(6171, e2.DiagnosticCategory.Message, "Command_line_Options_6171", "Command-line Options"), Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3: a(6179, e2.DiagnosticCategory.Message, "Provide_full_support_for_iterables_in_for_of_spread_and_destructuring_when_targeting_ES5_or_ES3_6179", "Provide full support for iterables in 'for-of', spread, and destructuring when targeting 'ES5' or 'ES3'."), Enable_all_strict_type_checking_options: a(6180, e2.DiagnosticCategory.Message, "Enable_all_strict_type_checking_options_6180", "Enable all strict type-checking options."), Scoped_package_detected_looking_in_0: a(6182, e2.DiagnosticCategory.Message, "Scoped_package_detected_looking_in_0_6182", "Scoped package detected, looking in '{0}'"), Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2: a(6183, e2.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_6183", "Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."), Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3: a(6184, e2.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package__6184", "Reusing resolution of module '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."), Enable_strict_checking_of_function_types: a(6186, e2.DiagnosticCategory.Message, "Enable_strict_checking_of_function_types_6186", "Enable strict checking of function types."), Enable_strict_checking_of_property_initialization_in_classes: a(6187, e2.DiagnosticCategory.Message, "Enable_strict_checking_of_property_initialization_in_classes_6187", "Enable strict checking of property initialization in classes."), Numeric_separators_are_not_allowed_here: a(6188, e2.DiagnosticCategory.Error, "Numeric_separators_are_not_allowed_here_6188", "Numeric separators are not allowed here."), Multiple_consecutive_numeric_separators_are_not_permitted: a(6189, e2.DiagnosticCategory.Error, "Multiple_consecutive_numeric_separators_are_not_permitted_6189", "Multiple consecutive numeric separators are not permitted."), Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen: a(6191, e2.DiagnosticCategory.Message, "Whether_to_keep_outdated_console_output_in_watch_mode_instead_of_clearing_the_screen_6191", "Whether to keep outdated console output in watch mode instead of clearing the screen."), All_imports_in_import_declaration_are_unused: a(6192, e2.DiagnosticCategory.Error, "All_imports_in_import_declaration_are_unused_6192", "All imports in import declaration are unused.", true), Found_1_error_Watching_for_file_changes: a(6193, e2.DiagnosticCategory.Message, "Found_1_error_Watching_for_file_changes_6193", "Found 1 error. Watching for file changes."), Found_0_errors_Watching_for_file_changes: a(6194, e2.DiagnosticCategory.Message, "Found_0_errors_Watching_for_file_changes_6194", "Found {0} errors. Watching for file changes."), Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols: a(6195, e2.DiagnosticCategory.Message, "Resolve_keyof_to_string_valued_property_names_only_no_numbers_or_symbols_6195", "Resolve 'keyof' to string valued property names only (no numbers or symbols)."), _0_is_declared_but_never_used: a(6196, e2.DiagnosticCategory.Error, "_0_is_declared_but_never_used_6196", "'{0}' is declared but never used.", true), Include_modules_imported_with_json_extension: a(6197, e2.DiagnosticCategory.Message, "Include_modules_imported_with_json_extension_6197", "Include modules imported with '.json' extension"), All_destructured_elements_are_unused: a(6198, e2.DiagnosticCategory.Error, "All_destructured_elements_are_unused_6198", "All destructured elements are unused.", true), All_variables_are_unused: a(6199, e2.DiagnosticCategory.Error, "All_variables_are_unused_6199", "All variables are unused.", true), Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0: a(6200, e2.DiagnosticCategory.Error, "Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0_6200", "Definitions of the following identifiers conflict with those in another file: {0}"), Conflicts_are_in_this_file: a(6201, e2.DiagnosticCategory.Message, "Conflicts_are_in_this_file_6201", "Conflicts are in this file."), Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0: a(6202, e2.DiagnosticCategory.Error, "Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0_6202", "Project references may not form a circular graph. Cycle detected: {0}"), _0_was_also_declared_here: a(6203, e2.DiagnosticCategory.Message, "_0_was_also_declared_here_6203", "'{0}' was also declared here."), and_here: a(6204, e2.DiagnosticCategory.Message, "and_here_6204", "and here."), All_type_parameters_are_unused: a(6205, e2.DiagnosticCategory.Error, "All_type_parameters_are_unused_6205", "All type parameters are unused."), package_json_has_a_typesVersions_field_with_version_specific_path_mappings: a(6206, e2.DiagnosticCategory.Message, "package_json_has_a_typesVersions_field_with_version_specific_path_mappings_6206", "'package.json' has a 'typesVersions' field with version-specific path mappings."), package_json_does_not_have_a_typesVersions_entry_that_matches_version_0: a(6207, e2.DiagnosticCategory.Message, "package_json_does_not_have_a_typesVersions_entry_that_matches_version_0_6207", "'package.json' does not have a 'typesVersions' entry that matches version '{0}'."), package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2: a(6208, e2.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_ma_6208", "'package.json' has a 'typesVersions' entry '{0}' that matches compiler version '{1}', looking for a pattern to match module name '{2}'."), package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range: a(6209, e2.DiagnosticCategory.Message, "package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range_6209", "'package.json' has a 'typesVersions' entry '{0}' that is not a valid semver range."), An_argument_for_0_was_not_provided: a(6210, e2.DiagnosticCategory.Message, "An_argument_for_0_was_not_provided_6210", "An argument for '{0}' was not provided."), An_argument_matching_this_binding_pattern_was_not_provided: a(6211, e2.DiagnosticCategory.Message, "An_argument_matching_this_binding_pattern_was_not_provided_6211", "An argument matching this binding pattern was not provided."), Did_you_mean_to_call_this_expression: a(6212, e2.DiagnosticCategory.Message, "Did_you_mean_to_call_this_expression_6212", "Did you mean to call this expression?"), Did_you_mean_to_use_new_with_this_expression: a(6213, e2.DiagnosticCategory.Message, "Did_you_mean_to_use_new_with_this_expression_6213", "Did you mean to use 'new' with this expression?"), Enable_strict_bind_call_and_apply_methods_on_functions: a(6214, e2.DiagnosticCategory.Message, "Enable_strict_bind_call_and_apply_methods_on_functions_6214", "Enable strict 'bind', 'call', and 'apply' methods on functions."), Using_compiler_options_of_project_reference_redirect_0: a(6215, e2.DiagnosticCategory.Message, "Using_compiler_options_of_project_reference_redirect_0_6215", "Using compiler options of project reference redirect '{0}'."), Found_1_error: a(6216, e2.DiagnosticCategory.Message, "Found_1_error_6216", "Found 1 error."), Found_0_errors: a(6217, e2.DiagnosticCategory.Message, "Found_0_errors_6217", "Found {0} errors."), Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2: a(6218, e2.DiagnosticCategory.Message, "Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2_6218", "======== Module name '{0}' was successfully resolved to '{1}' with Package ID '{2}'. ========"), Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3: a(6219, e2.DiagnosticCategory.Message, "Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3_6219", "======== Type reference directive '{0}' was successfully resolved to '{1}' with Package ID '{2}', primary: {3}. ========"), package_json_had_a_falsy_0_field: a(6220, e2.DiagnosticCategory.Message, "package_json_had_a_falsy_0_field_6220", "'package.json' had a falsy '{0}' field."), Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects: a(6221, e2.DiagnosticCategory.Message, "Disable_use_of_source_files_instead_of_declaration_files_from_referenced_projects_6221", "Disable use of source files instead of declaration files from referenced projects."), Emit_class_fields_with_Define_instead_of_Set: a(6222, e2.DiagnosticCategory.Message, "Emit_class_fields_with_Define_instead_of_Set_6222", "Emit class fields with Define instead of Set."), Generates_a_CPU_profile: a(6223, e2.DiagnosticCategory.Message, "Generates_a_CPU_profile_6223", "Generates a CPU profile."), Disable_solution_searching_for_this_project: a(6224, e2.DiagnosticCategory.Message, "Disable_solution_searching_for_this_project_6224", "Disable solution searching for this project."), Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling_UseFsEvents_UseFsEventsOnParentDirectory: a(6225, e2.DiagnosticCategory.Message, "Specify_strategy_for_watching_file_Colon_FixedPollingInterval_default_PriorityPollingInterval_Dynami_6225", "Specify strategy for watching file: 'FixedPollingInterval' (default), 'PriorityPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling', 'UseFsEvents', 'UseFsEventsOnParentDirectory'."), Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively_Colon_UseFsEvents_default_FixedPollingInterval_DynamicPriorityPolling_FixedChunkSizePolling: a(6226, e2.DiagnosticCategory.Message, "Specify_strategy_for_watching_directory_on_platforms_that_don_t_support_recursive_watching_natively__6226", "Specify strategy for watching directory on platforms that don't support recursive watching natively: 'UseFsEvents' (default), 'FixedPollingInterval', 'DynamicPriorityPolling', 'FixedChunkSizePolling'."), Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_FixedInterval_default_PriorityInterval_DynamicPriority_FixedChunkSize: a(6227, e2.DiagnosticCategory.Message, "Specify_strategy_for_creating_a_polling_watch_when_it_fails_to_create_using_file_system_events_Colon_6227", "Specify strategy for creating a polling watch when it fails to create using file system events: 'FixedInterval' (default), 'PriorityInterval', 'DynamicPriority', 'FixedChunkSize'."), Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3: a(6229, e2.DiagnosticCategory.Error, "Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3_6229", "Tag '{0}' expects at least '{1}' arguments, but the JSX factory '{2}' provides at most '{3}'."), Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line: a(6230, e2.DiagnosticCategory.Error, "Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line_6230", "Option '{0}' can only be specified in 'tsconfig.json' file or set to 'false' or 'null' on command line."), Could_not_resolve_the_path_0_with_the_extensions_Colon_1: a(6231, e2.DiagnosticCategory.Error, "Could_not_resolve_the_path_0_with_the_extensions_Colon_1_6231", "Could not resolve the path '{0}' with the extensions: {1}."), Declaration_augments_declaration_in_another_file_This_cannot_be_serialized: a(6232, e2.DiagnosticCategory.Error, "Declaration_augments_declaration_in_another_file_This_cannot_be_serialized_6232", "Declaration augments declaration in another file. This cannot be serialized."), This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file: a(6233, e2.DiagnosticCategory.Error, "This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_fil_6233", "This is the declaration being augmented. Consider moving the augmenting declaration into the same file."), This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without: a(6234, e2.DiagnosticCategory.Error, "This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without_6234", "This expression is not callable because it is a 'get' accessor. Did you mean to use it without '()'?"), Disable_loading_referenced_projects: a(6235, e2.DiagnosticCategory.Message, "Disable_loading_referenced_projects_6235", "Disable loading referenced projects."), Arguments_for_the_rest_parameter_0_were_not_provided: a(6236, e2.DiagnosticCategory.Error, "Arguments_for_the_rest_parameter_0_were_not_provided_6236", "Arguments for the rest parameter '{0}' were not provided."), Generates_an_event_trace_and_a_list_of_types: a(6237, e2.DiagnosticCategory.Message, "Generates_an_event_trace_and_a_list_of_types_6237", "Generates an event trace and a list of types."), Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react: a(6238, e2.DiagnosticCategory.Error, "Specify_the_module_specifier_to_be_used_to_import_the_jsx_and_jsxs_factory_functions_from_eg_react_6238", "Specify the module specifier to be used to import the 'jsx' and 'jsxs' factory functions from. eg, react"), File_0_exists_according_to_earlier_cached_lookups: a(6239, e2.DiagnosticCategory.Message, "File_0_exists_according_to_earlier_cached_lookups_6239", "File '{0}' exists according to earlier cached lookups."), File_0_does_not_exist_according_to_earlier_cached_lookups: a(6240, e2.DiagnosticCategory.Message, "File_0_does_not_exist_according_to_earlier_cached_lookups_6240", "File '{0}' does not exist according to earlier cached lookups."), Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1: a(6241, e2.DiagnosticCategory.Message, "Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1_6241", "Resolution for type reference directive '{0}' was found in cache from location '{1}'."), Resolving_type_reference_directive_0_containing_file_1: a(6242, e2.DiagnosticCategory.Message, "Resolving_type_reference_directive_0_containing_file_1_6242", "======== Resolving type reference directive '{0}', containing file '{1}'. ========"), Interpret_optional_property_types_as_written_rather_than_adding_undefined: a(6243, e2.DiagnosticCategory.Message, "Interpret_optional_property_types_as_written_rather_than_adding_undefined_6243", "Interpret optional property types as written, rather than adding 'undefined'."), Modules: a(6244, e2.DiagnosticCategory.Message, "Modules_6244", "Modules"), File_Management: a(6245, e2.DiagnosticCategory.Message, "File_Management_6245", "File Management"), Emit: a(6246, e2.DiagnosticCategory.Message, "Emit_6246", "Emit"), JavaScript_Support: a(6247, e2.DiagnosticCategory.Message, "JavaScript_Support_6247", "JavaScript Support"), Type_Checking: a(6248, e2.DiagnosticCategory.Message, "Type_Checking_6248", "Type Checking"), Editor_Support: a(6249, e2.DiagnosticCategory.Message, "Editor_Support_6249", "Editor Support"), Watch_and_Build_Modes: a(6250, e2.DiagnosticCategory.Message, "Watch_and_Build_Modes_6250", "Watch and Build Modes"), Compiler_Diagnostics: a(6251, e2.DiagnosticCategory.Message, "Compiler_Diagnostics_6251", "Compiler Diagnostics"), Interop_Constraints: a(6252, e2.DiagnosticCategory.Message, "Interop_Constraints_6252", "Interop Constraints"), Backwards_Compatibility: a(6253, e2.DiagnosticCategory.Message, "Backwards_Compatibility_6253", "Backwards Compatibility"), Language_and_Environment: a(6254, e2.DiagnosticCategory.Message, "Language_and_Environment_6254", "Language and Environment"), Projects: a(6255, e2.DiagnosticCategory.Message, "Projects_6255", "Projects"), Output_Formatting: a(6256, e2.DiagnosticCategory.Message, "Output_Formatting_6256", "Output Formatting"), Completeness: a(6257, e2.DiagnosticCategory.Message, "Completeness_6257", "Completeness"), _0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file: a(6258, e2.DiagnosticCategory.Error, "_0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file_6258", "'{0}' should be set inside the 'compilerOptions' object of the config json file"), Found_1_error_in_1: a(6259, e2.DiagnosticCategory.Message, "Found_1_error_in_1_6259", "Found 1 error in {1}"), Found_0_errors_in_the_same_file_starting_at_Colon_1: a(6260, e2.DiagnosticCategory.Message, "Found_0_errors_in_the_same_file_starting_at_Colon_1_6260", "Found {0} errors in the same file, starting at: {1}"), Found_0_errors_in_1_files: a(6261, e2.DiagnosticCategory.Message, "Found_0_errors_in_1_files_6261", "Found {0} errors in {1} files."), Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve: a(6270, e2.DiagnosticCategory.Message, "Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve_6270", "Directory '{0}' has no containing package.json scope. Imports will not resolve."), Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1: a(6271, e2.DiagnosticCategory.Message, "Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6271", "Import specifier '{0}' does not exist in package.json scope at path '{1}'."), Invalid_import_specifier_0_has_no_possible_resolutions: a(6272, e2.DiagnosticCategory.Message, "Invalid_import_specifier_0_has_no_possible_resolutions_6272", "Invalid import specifier '{0}' has no possible resolutions."), package_json_scope_0_has_no_imports_defined: a(6273, e2.DiagnosticCategory.Message, "package_json_scope_0_has_no_imports_defined_6273", "package.json scope '{0}' has no imports defined."), package_json_scope_0_explicitly_maps_specifier_1_to_null: a(6274, e2.DiagnosticCategory.Message, "package_json_scope_0_explicitly_maps_specifier_1_to_null_6274", "package.json scope '{0}' explicitly maps specifier '{1}' to null."), package_json_scope_0_has_invalid_type_for_target_of_specifier_1: a(6275, e2.DiagnosticCategory.Message, "package_json_scope_0_has_invalid_type_for_target_of_specifier_1_6275", "package.json scope '{0}' has invalid type for target of specifier '{1}'"), Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1: a(6276, e2.DiagnosticCategory.Message, "Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1_6276", "Export specifier '{0}' does not exist in package.json scope at path '{1}'."), Enable_project_compilation: a(6302, e2.DiagnosticCategory.Message, "Enable_project_compilation_6302", "Enable project compilation"), Composite_projects_may_not_disable_declaration_emit: a(6304, e2.DiagnosticCategory.Error, "Composite_projects_may_not_disable_declaration_emit_6304", "Composite projects may not disable declaration emit."), Output_file_0_has_not_been_built_from_source_file_1: a(6305, e2.DiagnosticCategory.Error, "Output_file_0_has_not_been_built_from_source_file_1_6305", "Output file '{0}' has not been built from source file '{1}'."), Referenced_project_0_must_have_setting_composite_Colon_true: a(6306, e2.DiagnosticCategory.Error, "Referenced_project_0_must_have_setting_composite_Colon_true_6306", `Referenced project '{0}' must have setting "composite": true.`), File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern: a(6307, e2.DiagnosticCategory.Error, "File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_includ_6307", "File '{0}' is not listed within the file list of project '{1}'. Projects must list all files or use an 'include' pattern."), Cannot_prepend_project_0_because_it_does_not_have_outFile_set: a(6308, e2.DiagnosticCategory.Error, "Cannot_prepend_project_0_because_it_does_not_have_outFile_set_6308", "Cannot prepend project '{0}' because it does not have 'outFile' set"), Output_file_0_from_project_1_does_not_exist: a(6309, e2.DiagnosticCategory.Error, "Output_file_0_from_project_1_does_not_exist_6309", "Output file '{0}' from project '{1}' does not exist"), Referenced_project_0_may_not_disable_emit: a(6310, e2.DiagnosticCategory.Error, "Referenced_project_0_may_not_disable_emit_6310", "Referenced project '{0}' may not disable emit."), Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2: a(6350, e2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2_6350", "Project '{0}' is out of date because oldest output '{1}' is older than newest input '{2}'"), Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2: a(6351, e2.DiagnosticCategory.Message, "Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2_6351", "Project '{0}' is up to date because newest input '{1}' is older than oldest output '{2}'"), Project_0_is_out_of_date_because_output_file_1_does_not_exist: a(6352, e2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_file_1_does_not_exist_6352", "Project '{0}' is out of date because output file '{1}' does not exist"), Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date: a(6353, e2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date_6353", "Project '{0}' is out of date because its dependency '{1}' is out of date"), Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies: a(6354, e2.DiagnosticCategory.Message, "Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies_6354", "Project '{0}' is up to date with .d.ts files from its dependencies"), Projects_in_this_build_Colon_0: a(6355, e2.DiagnosticCategory.Message, "Projects_in_this_build_Colon_0_6355", "Projects in this build: {0}"), A_non_dry_build_would_delete_the_following_files_Colon_0: a(6356, e2.DiagnosticCategory.Message, "A_non_dry_build_would_delete_the_following_files_Colon_0_6356", "A non-dry build would delete the following files: {0}"), A_non_dry_build_would_build_project_0: a(6357, e2.DiagnosticCategory.Message, "A_non_dry_build_would_build_project_0_6357", "A non-dry build would build project '{0}'"), Building_project_0: a(6358, e2.DiagnosticCategory.Message, "Building_project_0_6358", "Building project '{0}'..."), Updating_output_timestamps_of_project_0: a(6359, e2.DiagnosticCategory.Message, "Updating_output_timestamps_of_project_0_6359", "Updating output timestamps of project '{0}'..."), Project_0_is_up_to_date: a(6361, e2.DiagnosticCategory.Message, "Project_0_is_up_to_date_6361", "Project '{0}' is up to date"), Skipping_build_of_project_0_because_its_dependency_1_has_errors: a(6362, e2.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_has_errors_6362", "Skipping build of project '{0}' because its dependency '{1}' has errors"), Project_0_can_t_be_built_because_its_dependency_1_has_errors: a(6363, e2.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_has_errors_6363", "Project '{0}' can't be built because its dependency '{1}' has errors"), Build_one_or_more_projects_and_their_dependencies_if_out_of_date: a(6364, e2.DiagnosticCategory.Message, "Build_one_or_more_projects_and_their_dependencies_if_out_of_date_6364", "Build one or more projects and their dependencies, if out of date"), Delete_the_outputs_of_all_projects: a(6365, e2.DiagnosticCategory.Message, "Delete_the_outputs_of_all_projects_6365", "Delete the outputs of all projects."), Show_what_would_be_built_or_deleted_if_specified_with_clean: a(6367, e2.DiagnosticCategory.Message, "Show_what_would_be_built_or_deleted_if_specified_with_clean_6367", "Show what would be built (or deleted, if specified with '--clean')"), Option_build_must_be_the_first_command_line_argument: a(6369, e2.DiagnosticCategory.Error, "Option_build_must_be_the_first_command_line_argument_6369", "Option '--build' must be the first command line argument."), Options_0_and_1_cannot_be_combined: a(6370, e2.DiagnosticCategory.Error, "Options_0_and_1_cannot_be_combined_6370", "Options '{0}' and '{1}' cannot be combined."), Updating_unchanged_output_timestamps_of_project_0: a(6371, e2.DiagnosticCategory.Message, "Updating_unchanged_output_timestamps_of_project_0_6371", "Updating unchanged output timestamps of project '{0}'..."), Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed: a(6372, e2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed_6372", "Project '{0}' is out of date because output of its dependency '{1}' has changed"), Updating_output_of_project_0: a(6373, e2.DiagnosticCategory.Message, "Updating_output_of_project_0_6373", "Updating output of project '{0}'..."), A_non_dry_build_would_update_timestamps_for_output_of_project_0: a(6374, e2.DiagnosticCategory.Message, "A_non_dry_build_would_update_timestamps_for_output_of_project_0_6374", "A non-dry build would update timestamps for output of project '{0}'"), A_non_dry_build_would_update_output_of_project_0: a(6375, e2.DiagnosticCategory.Message, "A_non_dry_build_would_update_output_of_project_0_6375", "A non-dry build would update output of project '{0}'"), Cannot_update_output_of_project_0_because_there_was_error_reading_file_1: a(6376, e2.DiagnosticCategory.Message, "Cannot_update_output_of_project_0_because_there_was_error_reading_file_1_6376", "Cannot update output of project '{0}' because there was error reading file '{1}'"), Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1: a(6377, e2.DiagnosticCategory.Error, "Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1_6377", "Cannot write file '{0}' because it will overwrite '.tsbuildinfo' file generated by referenced project '{1}'"), Composite_projects_may_not_disable_incremental_compilation: a(6379, e2.DiagnosticCategory.Error, "Composite_projects_may_not_disable_incremental_compilation_6379", "Composite projects may not disable incremental compilation."), Specify_file_to_store_incremental_compilation_information: a(6380, e2.DiagnosticCategory.Message, "Specify_file_to_store_incremental_compilation_information_6380", "Specify file to store incremental compilation information"), Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2: a(6381, e2.DiagnosticCategory.Message, "Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_curren_6381", "Project '{0}' is out of date because output for it was generated with version '{1}' that differs with current version '{2}'"), Skipping_build_of_project_0_because_its_dependency_1_was_not_built: a(6382, e2.DiagnosticCategory.Message, "Skipping_build_of_project_0_because_its_dependency_1_was_not_built_6382", "Skipping build of project '{0}' because its dependency '{1}' was not built"), Project_0_can_t_be_built_because_its_dependency_1_was_not_built: a(6383, e2.DiagnosticCategory.Message, "Project_0_can_t_be_built_because_its_dependency_1_was_not_built_6383", "Project '{0}' can't be built because its dependency '{1}' was not built"), Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: a(6384, e2.DiagnosticCategory.Message, "Have_recompiles_in_incremental_and_watch_assume_that_changes_within_a_file_will_only_affect_files_di_6384", "Have recompiles in '--incremental' and '--watch' assume that changes within a file will only affect files directly depending on it."), _0_is_deprecated: a(6385, e2.DiagnosticCategory.Suggestion, "_0_is_deprecated_6385", "'{0}' is deprecated.", void 0, void 0, true), Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_native_implementation_of_the_Web_Performance_API_could_not_be_found: a(6386, e2.DiagnosticCategory.Message, "Performance_timings_for_diagnostics_or_extendedDiagnostics_are_not_available_in_this_session_A_nativ_6386", "Performance timings for '--diagnostics' or '--extendedDiagnostics' are not available in this session. A native implementation of the Web Performance API could not be found."), The_signature_0_of_1_is_deprecated: a(6387, e2.DiagnosticCategory.Suggestion, "The_signature_0_of_1_is_deprecated_6387", "The signature '{0}' of '{1}' is deprecated.", void 0, void 0, true), Project_0_is_being_forcibly_rebuilt: a(6388, e2.DiagnosticCategory.Message, "Project_0_is_being_forcibly_rebuilt_6388", "Project '{0}' is being forcibly rebuilt"), Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved: a(6389, e2.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved_6389", "Reusing resolution of module '{0}' from '{1}' of old program, it was not resolved."), Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2: a(6390, e2.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6390", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}'."), Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3: a(6391, e2.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved__6391", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was successfully resolved to '{2}' with Package ID '{3}'."), Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved: a(6392, e2.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved_6392", "Reusing resolution of type reference directive '{0}' from '{1}' of old program, it was not resolved."), Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3: a(6393, e2.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6393", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."), Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4: a(6394, e2.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_6394", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."), Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved: a(6395, e2.DiagnosticCategory.Message, "Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved_6395", "Reusing resolution of module '{0}' from '{1}' found in cache from location '{2}', it was not resolved."), Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3: a(6396, e2.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6396", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}'."), Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4: a(6397, e2.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_succes_6397", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was successfully resolved to '{3}' with Package ID '{4}'."), Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved: a(6398, e2.DiagnosticCategory.Message, "Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_re_6398", "Reusing resolution of type reference directive '{0}' from '{1}' found in cache from location '{2}', it was not resolved."), The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1: a(6500, e2.DiagnosticCategory.Message, "The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1_6500", "The expected type comes from property '{0}' which is declared here on type '{1}'"), The_expected_type_comes_from_this_index_signature: a(6501, e2.DiagnosticCategory.Message, "The_expected_type_comes_from_this_index_signature_6501", "The expected type comes from this index signature."), The_expected_type_comes_from_the_return_type_of_this_signature: a(6502, e2.DiagnosticCategory.Message, "The_expected_type_comes_from_the_return_type_of_this_signature_6502", "The expected type comes from the return type of this signature."), Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing: a(6503, e2.DiagnosticCategory.Message, "Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing_6503", "Print names of files that are part of the compilation and then stop processing."), File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option: a(6504, e2.DiagnosticCategory.Error, "File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option_6504", "File '{0}' is a JavaScript file. Did you mean to enable the 'allowJs' option?"), Print_names_of_files_and_the_reason_they_are_part_of_the_compilation: a(6505, e2.DiagnosticCategory.Message, "Print_names_of_files_and_the_reason_they_are_part_of_the_compilation_6505", "Print names of files and the reason they are part of the compilation."), Consider_adding_a_declare_modifier_to_this_class: a(6506, e2.DiagnosticCategory.Message, "Consider_adding_a_declare_modifier_to_this_class_6506", "Consider adding a 'declare' modifier to this class."), Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files: a(6600, e2.DiagnosticCategory.Message, "Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these__6600", "Allow JavaScript files to be a part of your program. Use the 'checkJS' option to get errors from these files."), Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export: a(6601, e2.DiagnosticCategory.Message, "Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export_6601", "Allow 'import x from y' when a module doesn't have a default export."), Allow_accessing_UMD_globals_from_modules: a(6602, e2.DiagnosticCategory.Message, "Allow_accessing_UMD_globals_from_modules_6602", "Allow accessing UMD globals from modules."), Disable_error_reporting_for_unreachable_code: a(6603, e2.DiagnosticCategory.Message, "Disable_error_reporting_for_unreachable_code_6603", "Disable error reporting for unreachable code."), Disable_error_reporting_for_unused_labels: a(6604, e2.DiagnosticCategory.Message, "Disable_error_reporting_for_unused_labels_6604", "Disable error reporting for unused labels."), Ensure_use_strict_is_always_emitted: a(6605, e2.DiagnosticCategory.Message, "Ensure_use_strict_is_always_emitted_6605", "Ensure 'use strict' is always emitted."), Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it: a(6606, e2.DiagnosticCategory.Message, "Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_wi_6606", "Have recompiles in projects that use 'incremental' and 'watch' mode assume that changes within a file will only affect files directly depending on it."), Specify_the_base_directory_to_resolve_non_relative_module_names: a(6607, e2.DiagnosticCategory.Message, "Specify_the_base_directory_to_resolve_non_relative_module_names_6607", "Specify the base directory to resolve non-relative module names."), No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files: a(6608, e2.DiagnosticCategory.Message, "No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files_6608", "No longer supported. In early versions, manually set the text encoding for reading files."), Enable_error_reporting_in_type_checked_JavaScript_files: a(6609, e2.DiagnosticCategory.Message, "Enable_error_reporting_in_type_checked_JavaScript_files_6609", "Enable error reporting in type-checked JavaScript files."), Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references: a(6611, e2.DiagnosticCategory.Message, "Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references_6611", "Enable constraints that allow a TypeScript project to be used with project references."), Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project: a(6612, e2.DiagnosticCategory.Message, "Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project_6612", "Generate .d.ts files from TypeScript and JavaScript files in your project."), Specify_the_output_directory_for_generated_declaration_files: a(6613, e2.DiagnosticCategory.Message, "Specify_the_output_directory_for_generated_declaration_files_6613", "Specify the output directory for generated declaration files."), Create_sourcemaps_for_d_ts_files: a(6614, e2.DiagnosticCategory.Message, "Create_sourcemaps_for_d_ts_files_6614", "Create sourcemaps for d.ts files."), Output_compiler_performance_information_after_building: a(6615, e2.DiagnosticCategory.Message, "Output_compiler_performance_information_after_building_6615", "Output compiler performance information after building."), Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project: a(6616, e2.DiagnosticCategory.Message, "Disables_inference_for_type_acquisition_by_looking_at_filenames_in_a_project_6616", "Disables inference for type acquisition by looking at filenames in a project."), Reduce_the_number_of_projects_loaded_automatically_by_TypeScript: a(6617, e2.DiagnosticCategory.Message, "Reduce_the_number_of_projects_loaded_automatically_by_TypeScript_6617", "Reduce the number of projects loaded automatically by TypeScript."), Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server: a(6618, e2.DiagnosticCategory.Message, "Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server_6618", "Remove the 20mb cap on total source code size for JavaScript files in the TypeScript language server."), Opt_a_project_out_of_multi_project_reference_checking_when_editing: a(6619, e2.DiagnosticCategory.Message, "Opt_a_project_out_of_multi_project_reference_checking_when_editing_6619", "Opt a project out of multi-project reference checking when editing."), Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects: a(6620, e2.DiagnosticCategory.Message, "Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects_6620", "Disable preferring source files instead of declaration files when referencing composite projects."), Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration: a(6621, e2.DiagnosticCategory.Message, "Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration_6621", "Emit more compliant, but verbose and less performant JavaScript for iteration."), Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files: a(6622, e2.DiagnosticCategory.Message, "Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files_6622", "Emit a UTF-8 Byte Order Mark (BOM) in the beginning of output files."), Only_output_d_ts_files_and_not_JavaScript_files: a(6623, e2.DiagnosticCategory.Message, "Only_output_d_ts_files_and_not_JavaScript_files_6623", "Only output d.ts files and not JavaScript files."), Emit_design_type_metadata_for_decorated_declarations_in_source_files: a(6624, e2.DiagnosticCategory.Message, "Emit_design_type_metadata_for_decorated_declarations_in_source_files_6624", "Emit design-type metadata for decorated declarations in source files."), Disable_the_type_acquisition_for_JavaScript_projects: a(6625, e2.DiagnosticCategory.Message, "Disable_the_type_acquisition_for_JavaScript_projects_6625", "Disable the type acquisition for JavaScript projects"), Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility: a(6626, e2.DiagnosticCategory.Message, "Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheti_6626", "Emit additional JavaScript to ease support for importing CommonJS modules. This enables 'allowSyntheticDefaultImports' for type compatibility."), Filters_results_from_the_include_option: a(6627, e2.DiagnosticCategory.Message, "Filters_results_from_the_include_option_6627", "Filters results from the `include` option."), Remove_a_list_of_directories_from_the_watch_process: a(6628, e2.DiagnosticCategory.Message, "Remove_a_list_of_directories_from_the_watch_process_6628", "Remove a list of directories from the watch process."), Remove_a_list_of_files_from_the_watch_mode_s_processing: a(6629, e2.DiagnosticCategory.Message, "Remove_a_list_of_files_from_the_watch_mode_s_processing_6629", "Remove a list of files from the watch mode's processing."), Enable_experimental_support_for_TC39_stage_2_draft_decorators: a(6630, e2.DiagnosticCategory.Message, "Enable_experimental_support_for_TC39_stage_2_draft_decorators_6630", "Enable experimental support for TC39 stage 2 draft decorators."), Print_files_read_during_the_compilation_including_why_it_was_included: a(6631, e2.DiagnosticCategory.Message, "Print_files_read_during_the_compilation_including_why_it_was_included_6631", "Print files read during the compilation including why it was included."), Output_more_detailed_compiler_performance_information_after_building: a(6632, e2.DiagnosticCategory.Message, "Output_more_detailed_compiler_performance_information_after_building_6632", "Output more detailed compiler performance information after building."), Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_are_inherited: a(6633, e2.DiagnosticCategory.Message, "Specify_one_or_more_path_or_node_module_references_to_base_configuration_files_from_which_settings_a_6633", "Specify one or more path or node module references to base configuration files from which settings are inherited."), Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers: a(6634, e2.DiagnosticCategory.Message, "Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers_6634", "Specify what approach the watcher should use if the system runs out of native file watchers."), Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include: a(6635, e2.DiagnosticCategory.Message, "Include_a_list_of_files_This_does_not_support_glob_patterns_as_opposed_to_include_6635", "Include a list of files. This does not support glob patterns, as opposed to `include`."), Build_all_projects_including_those_that_appear_to_be_up_to_date: a(6636, e2.DiagnosticCategory.Message, "Build_all_projects_including_those_that_appear_to_be_up_to_date_6636", "Build all projects, including those that appear to be up to date."), Ensure_that_casing_is_correct_in_imports: a(6637, e2.DiagnosticCategory.Message, "Ensure_that_casing_is_correct_in_imports_6637", "Ensure that casing is correct in imports."), Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging: a(6638, e2.DiagnosticCategory.Message, "Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging_6638", "Emit a v8 CPU profile of the compiler run for debugging."), Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file: a(6639, e2.DiagnosticCategory.Message, "Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file_6639", "Allow importing helper functions from tslib once per project, instead of including them per-file."), Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation: a(6641, e2.DiagnosticCategory.Message, "Specify_a_list_of_glob_patterns_that_match_files_to_be_included_in_compilation_6641", "Specify a list of glob patterns that match files to be included in compilation."), Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects: a(6642, e2.DiagnosticCategory.Message, "Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects_6642", "Save .tsbuildinfo files to allow for incremental compilation of projects."), Include_sourcemap_files_inside_the_emitted_JavaScript: a(6643, e2.DiagnosticCategory.Message, "Include_sourcemap_files_inside_the_emitted_JavaScript_6643", "Include sourcemap files inside the emitted JavaScript."), Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript: a(6644, e2.DiagnosticCategory.Message, "Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript_6644", "Include source code in the sourcemaps inside the emitted JavaScript."), Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports: a(6645, e2.DiagnosticCategory.Message, "Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports_6645", "Ensure that each file can be safely transpiled without relying on other imports."), Specify_what_JSX_code_is_generated: a(6646, e2.DiagnosticCategory.Message, "Specify_what_JSX_code_is_generated_6646", "Specify what JSX code is generated."), Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h: a(6647, e2.DiagnosticCategory.Message, "Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h_6647", "Specify the JSX factory function used when targeting React JSX emit, e.g. 'React.createElement' or 'h'."), Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment: a(6648, e2.DiagnosticCategory.Message, "Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragme_6648", "Specify the JSX Fragment reference used for fragments when targeting React JSX emit e.g. 'React.Fragment' or 'Fragment'."), Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk: a(6649, e2.DiagnosticCategory.Message, "Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Ast_6649", "Specify module specifier used to import the JSX factory functions when using 'jsx: react-jsx*'."), Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option: a(6650, e2.DiagnosticCategory.Message, "Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option_6650", "Make keyof only return strings instead of string, numbers or symbols. Legacy option."), Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment: a(6651, e2.DiagnosticCategory.Message, "Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment_6651", "Specify a set of bundled library declaration files that describe the target runtime environment."), Print_the_names_of_emitted_files_after_a_compilation: a(6652, e2.DiagnosticCategory.Message, "Print_the_names_of_emitted_files_after_a_compilation_6652", "Print the names of emitted files after a compilation."), Print_all_of_the_files_read_during_the_compilation: a(6653, e2.DiagnosticCategory.Message, "Print_all_of_the_files_read_during_the_compilation_6653", "Print all of the files read during the compilation."), Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit: a(6654, e2.DiagnosticCategory.Message, "Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit_6654", "Set the language of the messaging from TypeScript. This does not affect emit."), Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations: a(6655, e2.DiagnosticCategory.Message, "Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations_6655", "Specify the location where debugger should locate map files instead of generated locations."), Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs: a(6656, e2.DiagnosticCategory.Message, "Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicabl_6656", "Specify the maximum folder depth used for checking JavaScript files from 'node_modules'. Only applicable with 'allowJs'."), Specify_what_module_code_is_generated: a(6657, e2.DiagnosticCategory.Message, "Specify_what_module_code_is_generated_6657", "Specify what module code is generated."), Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier: a(6658, e2.DiagnosticCategory.Message, "Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier_6658", "Specify how TypeScript looks up a file from a given module specifier."), Set_the_newline_character_for_emitting_files: a(6659, e2.DiagnosticCategory.Message, "Set_the_newline_character_for_emitting_files_6659", "Set the newline character for emitting files."), Disable_emitting_files_from_a_compilation: a(6660, e2.DiagnosticCategory.Message, "Disable_emitting_files_from_a_compilation_6660", "Disable emitting files from a compilation."), Disable_generating_custom_helper_functions_like_extends_in_compiled_output: a(6661, e2.DiagnosticCategory.Message, "Disable_generating_custom_helper_functions_like_extends_in_compiled_output_6661", "Disable generating custom helper functions like '__extends' in compiled output."), Disable_emitting_files_if_any_type_checking_errors_are_reported: a(6662, e2.DiagnosticCategory.Message, "Disable_emitting_files_if_any_type_checking_errors_are_reported_6662", "Disable emitting files if any type checking errors are reported."), Disable_truncating_types_in_error_messages: a(6663, e2.DiagnosticCategory.Message, "Disable_truncating_types_in_error_messages_6663", "Disable truncating types in error messages."), Enable_error_reporting_for_fallthrough_cases_in_switch_statements: a(6664, e2.DiagnosticCategory.Message, "Enable_error_reporting_for_fallthrough_cases_in_switch_statements_6664", "Enable error reporting for fallthrough cases in switch statements."), Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type: a(6665, e2.DiagnosticCategory.Message, "Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type_6665", "Enable error reporting for expressions and declarations with an implied 'any' type."), Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier: a(6666, e2.DiagnosticCategory.Message, "Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier_6666", "Ensure overriding members in derived classes are marked with an override modifier."), Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function: a(6667, e2.DiagnosticCategory.Message, "Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function_6667", "Enable error reporting for codepaths that do not explicitly return in a function."), Enable_error_reporting_when_this_is_given_the_type_any: a(6668, e2.DiagnosticCategory.Message, "Enable_error_reporting_when_this_is_given_the_type_any_6668", "Enable error reporting when 'this' is given the type 'any'."), Disable_adding_use_strict_directives_in_emitted_JavaScript_files: a(6669, e2.DiagnosticCategory.Message, "Disable_adding_use_strict_directives_in_emitted_JavaScript_files_6669", "Disable adding 'use strict' directives in emitted JavaScript files."), Disable_including_any_library_files_including_the_default_lib_d_ts: a(6670, e2.DiagnosticCategory.Message, "Disable_including_any_library_files_including_the_default_lib_d_ts_6670", "Disable including any library files, including the default lib.d.ts."), Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type: a(6671, e2.DiagnosticCategory.Message, "Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type_6671", "Enforces using indexed accessors for keys declared using an indexed type."), Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project: a(6672, e2.DiagnosticCategory.Message, "Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add__6672", "Disallow 'import's, 'require's or '<reference>'s from expanding the number of files TypeScript should add to a project."), Disable_strict_checking_of_generic_signatures_in_function_types: a(6673, e2.DiagnosticCategory.Message, "Disable_strict_checking_of_generic_signatures_in_function_types_6673", "Disable strict checking of generic signatures in function types."), Add_undefined_to_a_type_when_accessed_using_an_index: a(6674, e2.DiagnosticCategory.Message, "Add_undefined_to_a_type_when_accessed_using_an_index_6674", "Add 'undefined' to a type when accessed using an index."), Enable_error_reporting_when_local_variables_aren_t_read: a(6675, e2.DiagnosticCategory.Message, "Enable_error_reporting_when_local_variables_aren_t_read_6675", "Enable error reporting when local variables aren't read."), Raise_an_error_when_a_function_parameter_isn_t_read: a(6676, e2.DiagnosticCategory.Message, "Raise_an_error_when_a_function_parameter_isn_t_read_6676", "Raise an error when a function parameter isn't read."), Deprecated_setting_Use_outFile_instead: a(6677, e2.DiagnosticCategory.Message, "Deprecated_setting_Use_outFile_instead_6677", "Deprecated setting. Use 'outFile' instead."), Specify_an_output_folder_for_all_emitted_files: a(6678, e2.DiagnosticCategory.Message, "Specify_an_output_folder_for_all_emitted_files_6678", "Specify an output folder for all emitted files."), Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output: a(6679, e2.DiagnosticCategory.Message, "Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designa_6679", "Specify a file that bundles all outputs into one JavaScript file. If 'declaration' is true, also designates a file that bundles all .d.ts output."), Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations: a(6680, e2.DiagnosticCategory.Message, "Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations_6680", "Specify a set of entries that re-map imports to additional lookup locations."), Specify_a_list_of_language_service_plugins_to_include: a(6681, e2.DiagnosticCategory.Message, "Specify_a_list_of_language_service_plugins_to_include_6681", "Specify a list of language service plugins to include."), Disable_erasing_const_enum_declarations_in_generated_code: a(6682, e2.DiagnosticCategory.Message, "Disable_erasing_const_enum_declarations_in_generated_code_6682", "Disable erasing 'const enum' declarations in generated code."), Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node: a(6683, e2.DiagnosticCategory.Message, "Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node_6683", "Disable resolving symlinks to their realpath. This correlates to the same flag in node."), Disable_wiping_the_console_in_watch_mode: a(6684, e2.DiagnosticCategory.Message, "Disable_wiping_the_console_in_watch_mode_6684", "Disable wiping the console in watch mode."), Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read: a(6685, e2.DiagnosticCategory.Message, "Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read_6685", "Enable color and formatting in TypeScript's output to make compiler errors easier to read."), Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit: a(6686, e2.DiagnosticCategory.Message, "Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit_6686", "Specify the object invoked for 'createElement'. This only applies when targeting 'react' JSX emit."), Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references: a(6687, e2.DiagnosticCategory.Message, "Specify_an_array_of_objects_that_specify_paths_for_projects_Used_in_project_references_6687", "Specify an array of objects that specify paths for projects. Used in project references."), Disable_emitting_comments: a(6688, e2.DiagnosticCategory.Message, "Disable_emitting_comments_6688", "Disable emitting comments."), Enable_importing_json_files: a(6689, e2.DiagnosticCategory.Message, "Enable_importing_json_files_6689", "Enable importing .json files."), Specify_the_root_folder_within_your_source_files: a(6690, e2.DiagnosticCategory.Message, "Specify_the_root_folder_within_your_source_files_6690", "Specify the root folder within your source files."), Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules: a(6691, e2.DiagnosticCategory.Message, "Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules_6691", "Allow multiple folders to be treated as one when resolving modules."), Skip_type_checking_d_ts_files_that_are_included_with_TypeScript: a(6692, e2.DiagnosticCategory.Message, "Skip_type_checking_d_ts_files_that_are_included_with_TypeScript_6692", "Skip type checking .d.ts files that are included with TypeScript."), Skip_type_checking_all_d_ts_files: a(6693, e2.DiagnosticCategory.Message, "Skip_type_checking_all_d_ts_files_6693", "Skip type checking all .d.ts files."), Create_source_map_files_for_emitted_JavaScript_files: a(6694, e2.DiagnosticCategory.Message, "Create_source_map_files_for_emitted_JavaScript_files_6694", "Create source map files for emitted JavaScript files."), Specify_the_root_path_for_debuggers_to_find_the_reference_source_code: a(6695, e2.DiagnosticCategory.Message, "Specify_the_root_path_for_debuggers_to_find_the_reference_source_code_6695", "Specify the root path for debuggers to find the reference source code."), Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function: a(6697, e2.DiagnosticCategory.Message, "Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function_6697", "Check that the arguments for 'bind', 'call', and 'apply' methods match the original function."), When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible: a(6698, e2.DiagnosticCategory.Message, "When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible_6698", "When assigning functions, check to ensure parameters and the return values are subtype-compatible."), When_type_checking_take_into_account_null_and_undefined: a(6699, e2.DiagnosticCategory.Message, "When_type_checking_take_into_account_null_and_undefined_6699", "When type checking, take into account 'null' and 'undefined'."), Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor: a(6700, e2.DiagnosticCategory.Message, "Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor_6700", "Check for class properties that are declared but not set in the constructor."), Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments: a(6701, e2.DiagnosticCategory.Message, "Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments_6701", "Disable emitting declarations that have '@internal' in their JSDoc comments."), Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals: a(6702, e2.DiagnosticCategory.Message, "Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals_6702", "Disable reporting of excess property errors during the creation of object literals."), Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures: a(6703, e2.DiagnosticCategory.Message, "Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures_6703", "Suppress 'noImplicitAny' errors when indexing objects that lack index signatures."), Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively: a(6704, e2.DiagnosticCategory.Message, "Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_supp_6704", "Synchronously call callbacks and update the state of directory watchers on platforms that don`t support recursive watching natively."), Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations: a(6705, e2.DiagnosticCategory.Message, "Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declaratio_6705", "Set the JavaScript language version for emitted JavaScript and include compatible library declarations."), Log_paths_used_during_the_moduleResolution_process: a(6706, e2.DiagnosticCategory.Message, "Log_paths_used_during_the_moduleResolution_process_6706", "Log paths used during the 'moduleResolution' process."), Specify_the_path_to_tsbuildinfo_incremental_compilation_file: a(6707, e2.DiagnosticCategory.Message, "Specify_the_path_to_tsbuildinfo_incremental_compilation_file_6707", "Specify the path to .tsbuildinfo incremental compilation file."), Specify_options_for_automatic_acquisition_of_declaration_files: a(6709, e2.DiagnosticCategory.Message, "Specify_options_for_automatic_acquisition_of_declaration_files_6709", "Specify options for automatic acquisition of declaration files."), Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types: a(6710, e2.DiagnosticCategory.Message, "Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types_6710", "Specify multiple folders that act like './node_modules/@types'."), Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file: a(6711, e2.DiagnosticCategory.Message, "Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file_6711", "Specify type package names to be included without being referenced in a source file."), Emit_ECMAScript_standard_compliant_class_fields: a(6712, e2.DiagnosticCategory.Message, "Emit_ECMAScript_standard_compliant_class_fields_6712", "Emit ECMAScript-standard-compliant class fields."), Enable_verbose_logging: a(6713, e2.DiagnosticCategory.Message, "Enable_verbose_logging_6713", "Enable verbose logging."), Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality: a(6714, e2.DiagnosticCategory.Message, "Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality_6714", "Specify how directories are watched on systems that lack recursive file-watching functionality."), Specify_how_the_TypeScript_watch_mode_works: a(6715, e2.DiagnosticCategory.Message, "Specify_how_the_TypeScript_watch_mode_works_6715", "Specify how the TypeScript watch mode works."), Require_undeclared_properties_from_index_signatures_to_use_element_accesses: a(6717, e2.DiagnosticCategory.Message, "Require_undeclared_properties_from_index_signatures_to_use_element_accesses_6717", "Require undeclared properties from index signatures to use element accesses."), Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types: a(6718, e2.DiagnosticCategory.Message, "Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types_6718", "Specify emit/checking behavior for imports that are only used for types."), Default_catch_clause_variables_as_unknown_instead_of_any: a(6803, e2.DiagnosticCategory.Message, "Default_catch_clause_variables_as_unknown_instead_of_any_6803", "Default catch clause variables as 'unknown' instead of 'any'."), one_of_Colon: a(6900, e2.DiagnosticCategory.Message, "one_of_Colon_6900", "one of:"), one_or_more_Colon: a(6901, e2.DiagnosticCategory.Message, "one_or_more_Colon_6901", "one or more:"), type_Colon: a(6902, e2.DiagnosticCategory.Message, "type_Colon_6902", "type:"), default_Colon: a(6903, e2.DiagnosticCategory.Message, "default_Colon_6903", "default:"), module_system_or_esModuleInterop: a(6904, e2.DiagnosticCategory.Message, "module_system_or_esModuleInterop_6904", 'module === "system" or esModuleInterop'), false_unless_strict_is_set: a(6905, e2.DiagnosticCategory.Message, "false_unless_strict_is_set_6905", "`false`, unless `strict` is set"), false_unless_composite_is_set: a(6906, e2.DiagnosticCategory.Message, "false_unless_composite_is_set_6906", "`false`, unless `composite` is set"), node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified: a(6907, e2.DiagnosticCategory.Message, "node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified_6907", '`["node_modules", "bower_components", "jspm_packages"]`, plus the value of `outDir` if one is specified.'), if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk: a(6908, e2.DiagnosticCategory.Message, "if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk_6908", '`[]` if `files` is specified, otherwise `["**/*"]`'), true_if_composite_false_otherwise: a(6909, e2.DiagnosticCategory.Message, "true_if_composite_false_otherwise_6909", "`true` if `composite`, `false` otherwise"), module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node: a(69010, e2.DiagnosticCategory.Message, "module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node_69010", "module === `AMD` or `UMD` or `System` or `ES6`, then `Classic`, Otherwise `Node`"), Computed_from_the_list_of_input_files: a(6911, e2.DiagnosticCategory.Message, "Computed_from_the_list_of_input_files_6911", "Computed from the list of input files"), Platform_specific: a(6912, e2.DiagnosticCategory.Message, "Platform_specific_6912", "Platform specific"), You_can_learn_about_all_of_the_compiler_options_at_0: a(6913, e2.DiagnosticCategory.Message, "You_can_learn_about_all_of_the_compiler_options_at_0_6913", "You can learn about all of the compiler options at {0}"), Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_config_watch_mode_with_Colon: a(6914, e2.DiagnosticCategory.Message, "Including_watch_w_will_start_watching_the_current_project_for_the_file_changes_Once_set_you_can_conf_6914", "Including --watch, -w will start watching the current project for the file changes. Once set, you can config watch mode with:"), Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_trigger_building_composite_projects_which_you_can_learn_more_about_at_0: a(6915, e2.DiagnosticCategory.Message, "Using_build_b_will_make_tsc_behave_more_like_a_build_orchestrator_than_a_compiler_This_is_used_to_tr_6915", "Using --build, -b will make tsc behave more like a build orchestrator than a compiler. This is used to trigger building composite projects which you can learn more about at {0}"), COMMON_COMMANDS: a(6916, e2.DiagnosticCategory.Message, "COMMON_COMMANDS_6916", "COMMON COMMANDS"), ALL_COMPILER_OPTIONS: a(6917, e2.DiagnosticCategory.Message, "ALL_COMPILER_OPTIONS_6917", "ALL COMPILER OPTIONS"), WATCH_OPTIONS: a(6918, e2.DiagnosticCategory.Message, "WATCH_OPTIONS_6918", "WATCH OPTIONS"), BUILD_OPTIONS: a(6919, e2.DiagnosticCategory.Message, "BUILD_OPTIONS_6919", "BUILD OPTIONS"), COMMON_COMPILER_OPTIONS: a(6920, e2.DiagnosticCategory.Message, "COMMON_COMPILER_OPTIONS_6920", "COMMON COMPILER OPTIONS"), COMMAND_LINE_FLAGS: a(6921, e2.DiagnosticCategory.Message, "COMMAND_LINE_FLAGS_6921", "COMMAND LINE FLAGS"), tsc_Colon_The_TypeScript_Compiler: a(6922, e2.DiagnosticCategory.Message, "tsc_Colon_The_TypeScript_Compiler_6922", "tsc: The TypeScript Compiler"), Compiles_the_current_project_tsconfig_json_in_the_working_directory: a(6923, e2.DiagnosticCategory.Message, "Compiles_the_current_project_tsconfig_json_in_the_working_directory_6923", "Compiles the current project (tsconfig.json in the working directory.)"), Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options: a(6924, e2.DiagnosticCategory.Message, "Ignoring_tsconfig_json_compiles_the_specified_files_with_default_compiler_options_6924", "Ignoring tsconfig.json, compiles the specified files with default compiler options."), Build_a_composite_project_in_the_working_directory: a(6925, e2.DiagnosticCategory.Message, "Build_a_composite_project_in_the_working_directory_6925", "Build a composite project in the working directory."), Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory: a(6926, e2.DiagnosticCategory.Message, "Creates_a_tsconfig_json_with_the_recommended_settings_in_the_working_directory_6926", "Creates a tsconfig.json with the recommended settings in the working directory."), Compiles_the_TypeScript_project_located_at_the_specified_path: a(6927, e2.DiagnosticCategory.Message, "Compiles_the_TypeScript_project_located_at_the_specified_path_6927", "Compiles the TypeScript project located at the specified path."), An_expanded_version_of_this_information_showing_all_possible_compiler_options: a(6928, e2.DiagnosticCategory.Message, "An_expanded_version_of_this_information_showing_all_possible_compiler_options_6928", "An expanded version of this information, showing all possible compiler options"), Compiles_the_current_project_with_additional_settings: a(6929, e2.DiagnosticCategory.Message, "Compiles_the_current_project_with_additional_settings_6929", "Compiles the current project, with additional settings."), true_for_ES2022_and_above_including_ESNext: a(6930, e2.DiagnosticCategory.Message, "true_for_ES2022_and_above_including_ESNext_6930", "`true` for ES2022 and above, including ESNext."), List_of_file_name_suffixes_to_search_when_resolving_a_module: a(6931, e2.DiagnosticCategory.Error, "List_of_file_name_suffixes_to_search_when_resolving_a_module_6931", "List of file name suffixes to search when resolving a module."), Variable_0_implicitly_has_an_1_type: a(7005, e2.DiagnosticCategory.Error, "Variable_0_implicitly_has_an_1_type_7005", "Variable '{0}' implicitly has an '{1}' type."), Parameter_0_implicitly_has_an_1_type: a(7006, e2.DiagnosticCategory.Error, "Parameter_0_implicitly_has_an_1_type_7006", "Parameter '{0}' implicitly has an '{1}' type."), Member_0_implicitly_has_an_1_type: a(7008, e2.DiagnosticCategory.Error, "Member_0_implicitly_has_an_1_type_7008", "Member '{0}' implicitly has an '{1}' type."), new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type: a(7009, e2.DiagnosticCategory.Error, "new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type_7009", "'new' expression, whose target lacks a construct signature, implicitly has an 'any' type."), _0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type: a(7010, e2.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type_7010", "'{0}', which lacks return-type annotation, implicitly has an '{1}' return type."), Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: a(7011, e2.DiagnosticCategory.Error, "Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7011", "Function expression, which lacks return-type annotation, implicitly has an '{0}' return type."), Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: a(7013, e2.DiagnosticCategory.Error, "Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7013", "Construct signature, which lacks return-type annotation, implicitly has an 'any' return type."), Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type: a(7014, e2.DiagnosticCategory.Error, "Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type_7014", "Function type, which lacks return-type annotation, implicitly has an '{0}' return type."), Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number: a(7015, e2.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number_7015", "Element implicitly has an 'any' type because index expression is not of type 'number'."), Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type: a(7016, e2.DiagnosticCategory.Error, "Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type_7016", "Could not find a declaration file for module '{0}'. '{1}' implicitly has an 'any' type."), Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature: a(7017, e2.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_7017", "Element implicitly has an 'any' type because type '{0}' has no index signature."), Object_literal_s_property_0_implicitly_has_an_1_type: a(7018, e2.DiagnosticCategory.Error, "Object_literal_s_property_0_implicitly_has_an_1_type_7018", "Object literal's property '{0}' implicitly has an '{1}' type."), Rest_parameter_0_implicitly_has_an_any_type: a(7019, e2.DiagnosticCategory.Error, "Rest_parameter_0_implicitly_has_an_any_type_7019", "Rest parameter '{0}' implicitly has an 'any[]' type."), Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type: a(7020, e2.DiagnosticCategory.Error, "Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type_7020", "Call signature, which lacks return-type annotation, implicitly has an 'any' return type."), _0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer: a(7022, e2.DiagnosticCategory.Error, "_0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or__7022", "'{0}' implicitly has type 'any' because it does not have a type annotation and is referenced directly or indirectly in its own initializer."), _0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: a(7023, e2.DiagnosticCategory.Error, "_0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_reference_7023", "'{0}' implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."), Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions: a(7024, e2.DiagnosticCategory.Error, "Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_ref_7024", "Function implicitly has return type 'any' because it does not have a return type annotation and is referenced directly or indirectly in one of its return expressions."), Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation: a(7025, e2.DiagnosticCategory.Error, "Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_retu_7025", "Generator implicitly has yield type '{0}' because it does not yield any values. Consider supplying a return type annotation."), JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists: a(7026, e2.DiagnosticCategory.Error, "JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists_7026", "JSX element implicitly has type 'any' because no interface 'JSX.{0}' exists."), Unreachable_code_detected: a(7027, e2.DiagnosticCategory.Error, "Unreachable_code_detected_7027", "Unreachable code detected.", true), Unused_label: a(7028, e2.DiagnosticCategory.Error, "Unused_label_7028", "Unused label.", true), Fallthrough_case_in_switch: a(7029, e2.DiagnosticCategory.Error, "Fallthrough_case_in_switch_7029", "Fallthrough case in switch."), Not_all_code_paths_return_a_value: a(7030, e2.DiagnosticCategory.Error, "Not_all_code_paths_return_a_value_7030", "Not all code paths return a value."), Binding_element_0_implicitly_has_an_1_type: a(7031, e2.DiagnosticCategory.Error, "Binding_element_0_implicitly_has_an_1_type_7031", "Binding element '{0}' implicitly has an '{1}' type."), Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation: a(7032, e2.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation_7032", "Property '{0}' implicitly has type 'any', because its set accessor lacks a parameter type annotation."), Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation: a(7033, e2.DiagnosticCategory.Error, "Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation_7033", "Property '{0}' implicitly has type 'any', because its get accessor lacks a return type annotation."), Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined: a(7034, e2.DiagnosticCategory.Error, "Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined_7034", "Variable '{0}' implicitly has type '{1}' in some locations where its type cannot be determined."), Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0: a(7035, e2.DiagnosticCategory.Error, "Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare__7035", "Try `npm i --save-dev @types/{1}` if it exists or add a new declaration (.d.ts) file containing `declare module '{0}';`"), Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0: a(7036, e2.DiagnosticCategory.Error, "Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0_7036", "Dynamic import's specifier must be of type 'string', but here has type '{0}'."), Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for_all_imports_Implies_allowSyntheticDefaultImports: a(7037, e2.DiagnosticCategory.Message, "Enables_emit_interoperability_between_CommonJS_and_ES_Modules_via_creation_of_namespace_objects_for__7037", "Enables emit interoperability between CommonJS and ES Modules via creation of namespace objects for all imports. Implies 'allowSyntheticDefaultImports'."), Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead: a(7038, e2.DiagnosticCategory.Message, "Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cau_7038", "Type originates at this import. A namespace-style import cannot be called or constructed, and will cause a failure at runtime. Consider using a default import or import require here instead."), Mapped_object_type_implicitly_has_an_any_template_type: a(7039, e2.DiagnosticCategory.Error, "Mapped_object_type_implicitly_has_an_any_template_type_7039", "Mapped object type implicitly has an 'any' template type."), If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1: a(7040, e2.DiagnosticCategory.Error, "If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_S_7040", "If the '{0}' package actually exposes this module, consider sending a pull request to amend 'https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/{1}'"), The_containing_arrow_function_captures_the_global_value_of_this: a(7041, e2.DiagnosticCategory.Error, "The_containing_arrow_function_captures_the_global_value_of_this_7041", "The containing arrow function captures the global value of 'this'."), Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used: a(7042, e2.DiagnosticCategory.Error, "Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used_7042", "Module '{0}' was resolved to '{1}', but '--resolveJsonModule' is not used."), Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: a(7043, e2.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7043", "Variable '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."), Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: a(7044, e2.DiagnosticCategory.Suggestion, "Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7044", "Parameter '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."), Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage: a(7045, e2.DiagnosticCategory.Suggestion, "Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage_7045", "Member '{0}' implicitly has an '{1}' type, but a better type may be inferred from usage."), Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage: a(7046, e2.DiagnosticCategory.Suggestion, "Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage_7046", "Variable '{0}' implicitly has type '{1}' in some locations, but a better type may be inferred from usage."), Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage: a(7047, e2.DiagnosticCategory.Suggestion, "Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage_7047", "Rest parameter '{0}' implicitly has an 'any[]' type, but a better type may be inferred from usage."), Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage: a(7048, e2.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage_7048", "Property '{0}' implicitly has type 'any', but a better type for its get accessor may be inferred from usage."), Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage: a(7049, e2.DiagnosticCategory.Suggestion, "Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage_7049", "Property '{0}' implicitly has type 'any', but a better type for its set accessor may be inferred from usage."), _0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage: a(7050, e2.DiagnosticCategory.Suggestion, "_0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage_7050", "'{0}' implicitly has an '{1}' return type, but a better type may be inferred from usage."), Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1: a(7051, e2.DiagnosticCategory.Error, "Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1_7051", "Parameter has a name but no type. Did you mean '{0}: {1}'?"), Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1: a(7052, e2.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1_7052", "Element implicitly has an 'any' type because type '{0}' has no index signature. Did you mean to call '{1}'?"), Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1: a(7053, e2.DiagnosticCategory.Error, "Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1_7053", "Element implicitly has an 'any' type because expression of type '{0}' can't be used to index type '{1}'."), No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1: a(7054, e2.DiagnosticCategory.Error, "No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1_7054", "No index signature with a parameter of type '{0}' was found on type '{1}'."), _0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type: a(7055, e2.DiagnosticCategory.Error, "_0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type_7055", "'{0}', which lacks return-type annotation, implicitly has an '{1}' yield type."), The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed: a(7056, e2.DiagnosticCategory.Error, "The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_ty_7056", "The inferred type of this node exceeds the maximum length the compiler will serialize. An explicit type annotation is needed."), yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation: a(7057, e2.DiagnosticCategory.Error, "yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_t_7057", "'yield' expression implicitly results in an 'any' type because its containing generator lacks a return-type annotation."), If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1: a(7058, e2.DiagnosticCategory.Error, "If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_decl_7058", "If the '{0}' package actually exposes this module, try adding a new declaration (.d.ts) file containing `declare module '{1}';`"), This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead: a(7059, e2.DiagnosticCategory.Error, "This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead_7059", "This syntax is reserved in files with the .mts or .cts extension. Use an `as` expression instead."), This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint: a(7060, e2.DiagnosticCategory.Error, "This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_cons_7060", "This syntax is reserved in files with the .mts or .cts extension. Add a trailing comma or explicit constraint."), A_mapped_type_may_not_declare_properties_or_methods: a(7061, e2.DiagnosticCategory.Error, "A_mapped_type_may_not_declare_properties_or_methods_7061", "A mapped type may not declare properties or methods."), You_cannot_rename_this_element: a(8e3, e2.DiagnosticCategory.Error, "You_cannot_rename_this_element_8000", "You cannot rename this element."), You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library: a(8001, e2.DiagnosticCategory.Error, "You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library_8001", "You cannot rename elements that are defined in the standard TypeScript library."), import_can_only_be_used_in_TypeScript_files: a(8002, e2.DiagnosticCategory.Error, "import_can_only_be_used_in_TypeScript_files_8002", "'import ... =' can only be used in TypeScript files."), export_can_only_be_used_in_TypeScript_files: a(8003, e2.DiagnosticCategory.Error, "export_can_only_be_used_in_TypeScript_files_8003", "'export =' can only be used in TypeScript files."), Type_parameter_declarations_can_only_be_used_in_TypeScript_files: a(8004, e2.DiagnosticCategory.Error, "Type_parameter_declarations_can_only_be_used_in_TypeScript_files_8004", "Type parameter declarations can only be used in TypeScript files."), implements_clauses_can_only_be_used_in_TypeScript_files: a(8005, e2.DiagnosticCategory.Error, "implements_clauses_can_only_be_used_in_TypeScript_files_8005", "'implements' clauses can only be used in TypeScript files."), _0_declarations_can_only_be_used_in_TypeScript_files: a(8006, e2.DiagnosticCategory.Error, "_0_declarations_can_only_be_used_in_TypeScript_files_8006", "'{0}' declarations can only be used in TypeScript files."), Type_aliases_can_only_be_used_in_TypeScript_files: a(8008, e2.DiagnosticCategory.Error, "Type_aliases_can_only_be_used_in_TypeScript_files_8008", "Type aliases can only be used in TypeScript files."), The_0_modifier_can_only_be_used_in_TypeScript_files: a(8009, e2.DiagnosticCategory.Error, "The_0_modifier_can_only_be_used_in_TypeScript_files_8009", "The '{0}' modifier can only be used in TypeScript files."), Type_annotations_can_only_be_used_in_TypeScript_files: a(8010, e2.DiagnosticCategory.Error, "Type_annotations_can_only_be_used_in_TypeScript_files_8010", "Type annotations can only be used in TypeScript files."), Type_arguments_can_only_be_used_in_TypeScript_files: a(8011, e2.DiagnosticCategory.Error, "Type_arguments_can_only_be_used_in_TypeScript_files_8011", "Type arguments can only be used in TypeScript files."), Parameter_modifiers_can_only_be_used_in_TypeScript_files: a(8012, e2.DiagnosticCategory.Error, "Parameter_modifiers_can_only_be_used_in_TypeScript_files_8012", "Parameter modifiers can only be used in TypeScript files."), Non_null_assertions_can_only_be_used_in_TypeScript_files: a(8013, e2.DiagnosticCategory.Error, "Non_null_assertions_can_only_be_used_in_TypeScript_files_8013", "Non-null assertions can only be used in TypeScript files."), Type_assertion_expressions_can_only_be_used_in_TypeScript_files: a(8016, e2.DiagnosticCategory.Error, "Type_assertion_expressions_can_only_be_used_in_TypeScript_files_8016", "Type assertion expressions can only be used in TypeScript files."), Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0: a(8017, e2.DiagnosticCategory.Error, "Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0_8017", "Octal literal types must use ES2015 syntax. Use the syntax '{0}'."), Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0: a(8018, e2.DiagnosticCategory.Error, "Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0_8018", "Octal literals are not allowed in enums members initializer. Use the syntax '{0}'."), Report_errors_in_js_files: a(8019, e2.DiagnosticCategory.Message, "Report_errors_in_js_files_8019", "Report errors in .js files."), JSDoc_types_can_only_be_used_inside_documentation_comments: a(8020, e2.DiagnosticCategory.Error, "JSDoc_types_can_only_be_used_inside_documentation_comments_8020", "JSDoc types can only be used inside documentation comments."), JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags: a(8021, e2.DiagnosticCategory.Error, "JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags_8021", "JSDoc '@typedef' tag should either have a type annotation or be followed by '@property' or '@member' tags."), JSDoc_0_is_not_attached_to_a_class: a(8022, e2.DiagnosticCategory.Error, "JSDoc_0_is_not_attached_to_a_class_8022", "JSDoc '@{0}' is not attached to a class."), JSDoc_0_1_does_not_match_the_extends_2_clause: a(8023, e2.DiagnosticCategory.Error, "JSDoc_0_1_does_not_match_the_extends_2_clause_8023", "JSDoc '@{0} {1}' does not match the 'extends {2}' clause."), JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name: a(8024, e2.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_8024", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name."), Class_declarations_cannot_have_more_than_one_augments_or_extends_tag: a(8025, e2.DiagnosticCategory.Error, "Class_declarations_cannot_have_more_than_one_augments_or_extends_tag_8025", "Class declarations cannot have more than one '@augments' or '@extends' tag."), Expected_0_type_arguments_provide_these_with_an_extends_tag: a(8026, e2.DiagnosticCategory.Error, "Expected_0_type_arguments_provide_these_with_an_extends_tag_8026", "Expected {0} type arguments; provide these with an '@extends' tag."), Expected_0_1_type_arguments_provide_these_with_an_extends_tag: a(8027, e2.DiagnosticCategory.Error, "Expected_0_1_type_arguments_provide_these_with_an_extends_tag_8027", "Expected {0}-{1} type arguments; provide these with an '@extends' tag."), JSDoc_may_only_appear_in_the_last_parameter_of_a_signature: a(8028, e2.DiagnosticCategory.Error, "JSDoc_may_only_appear_in_the_last_parameter_of_a_signature_8028", "JSDoc '...' may only appear in the last parameter of a signature."), JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type: a(8029, e2.DiagnosticCategory.Error, "JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_h_8029", "JSDoc '@param' tag has name '{0}', but there is no parameter with that name. It would match 'arguments' if it had an array type."), The_type_of_a_function_declaration_must_match_the_function_s_signature: a(8030, e2.DiagnosticCategory.Error, "The_type_of_a_function_declaration_must_match_the_function_s_signature_8030", "The type of a function declaration must match the function's signature."), You_cannot_rename_a_module_via_a_global_import: a(8031, e2.DiagnosticCategory.Error, "You_cannot_rename_a_module_via_a_global_import_8031", "You cannot rename a module via a global import."), Qualified_name_0_is_not_allowed_without_a_leading_param_object_1: a(8032, e2.DiagnosticCategory.Error, "Qualified_name_0_is_not_allowed_without_a_leading_param_object_1_8032", "Qualified name '{0}' is not allowed without a leading '@param {object} {1}'."), A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags: a(8033, e2.DiagnosticCategory.Error, "A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags_8033", "A JSDoc '@typedef' comment may not contain multiple '@type' tags."), The_tag_was_first_specified_here: a(8034, e2.DiagnosticCategory.Error, "The_tag_was_first_specified_here_8034", "The tag was first specified here."), Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit: a(9005, e2.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_9005", "Declaration emit for this file requires using private name '{0}'. An explicit type annotation may unblock declaration emit."), Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit: a(9006, e2.DiagnosticCategory.Error, "Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotati_9006", "Declaration emit for this file requires using private name '{0}' from module '{1}'. An explicit type annotation may unblock declaration emit."), JSX_attributes_must_only_be_assigned_a_non_empty_expression: a(17e3, e2.DiagnosticCategory.Error, "JSX_attributes_must_only_be_assigned_a_non_empty_expression_17000", "JSX attributes must only be assigned a non-empty 'expression'."), JSX_elements_cannot_have_multiple_attributes_with_the_same_name: a(17001, e2.DiagnosticCategory.Error, "JSX_elements_cannot_have_multiple_attributes_with_the_same_name_17001", "JSX elements cannot have multiple attributes with the same name."), Expected_corresponding_JSX_closing_tag_for_0: a(17002, e2.DiagnosticCategory.Error, "Expected_corresponding_JSX_closing_tag_for_0_17002", "Expected corresponding JSX closing tag for '{0}'."), Cannot_use_JSX_unless_the_jsx_flag_is_provided: a(17004, e2.DiagnosticCategory.Error, "Cannot_use_JSX_unless_the_jsx_flag_is_provided_17004", "Cannot use JSX unless the '--jsx' flag is provided."), A_constructor_cannot_contain_a_super_call_when_its_class_extends_null: a(17005, e2.DiagnosticCategory.Error, "A_constructor_cannot_contain_a_super_call_when_its_class_extends_null_17005", "A constructor cannot contain a 'super' call when its class extends 'null'."), An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: a(17006, e2.DiagnosticCategory.Error, "An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_ex_17006", "An unary expression with the '{0}' operator is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."), A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses: a(17007, e2.DiagnosticCategory.Error, "A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Con_17007", "A type assertion expression is not allowed in the left-hand side of an exponentiation expression. Consider enclosing the expression in parentheses."), JSX_element_0_has_no_corresponding_closing_tag: a(17008, e2.DiagnosticCategory.Error, "JSX_element_0_has_no_corresponding_closing_tag_17008", "JSX element '{0}' has no corresponding closing tag."), super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class: a(17009, e2.DiagnosticCategory.Error, "super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class_17009", "'super' must be called before accessing 'this' in the constructor of a derived class."), Unknown_type_acquisition_option_0: a(17010, e2.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_17010", "Unknown type acquisition option '{0}'."), super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class: a(17011, e2.DiagnosticCategory.Error, "super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class_17011", "'super' must be called before accessing a property of 'super' in the constructor of a derived class."), _0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2: a(17012, e2.DiagnosticCategory.Error, "_0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2_17012", "'{0}' is not a valid meta-property for keyword '{1}'. Did you mean '{2}'?"), Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor: a(17013, e2.DiagnosticCategory.Error, "Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constru_17013", "Meta-property '{0}' is only allowed in the body of a function declaration, function expression, or constructor."), JSX_fragment_has_no_corresponding_closing_tag: a(17014, e2.DiagnosticCategory.Error, "JSX_fragment_has_no_corresponding_closing_tag_17014", "JSX fragment has no corresponding closing tag."), Expected_corresponding_closing_tag_for_JSX_fragment: a(17015, e2.DiagnosticCategory.Error, "Expected_corresponding_closing_tag_for_JSX_fragment_17015", "Expected corresponding closing tag for JSX fragment."), The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option: a(17016, e2.DiagnosticCategory.Error, "The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_com_17016", "The 'jsxFragmentFactory' compiler option must be provided to use JSX fragments with the 'jsxFactory' compiler option."), An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments: a(17017, e2.DiagnosticCategory.Error, "An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments_17017", "An @jsxFrag pragma is required when using an @jsx pragma with JSX fragments."), Unknown_type_acquisition_option_0_Did_you_mean_1: a(17018, e2.DiagnosticCategory.Error, "Unknown_type_acquisition_option_0_Did_you_mean_1_17018", "Unknown type acquisition option '{0}'. Did you mean '{1}'?"), Circularity_detected_while_resolving_configuration_Colon_0: a(18e3, e2.DiagnosticCategory.Error, "Circularity_detected_while_resolving_configuration_Colon_0_18000", "Circularity detected while resolving configuration: {0}"), The_files_list_in_config_file_0_is_empty: a(18002, e2.DiagnosticCategory.Error, "The_files_list_in_config_file_0_is_empty_18002", "The 'files' list in config file '{0}' is empty."), No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2: a(18003, e2.DiagnosticCategory.Error, "No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2_18003", "No inputs were found in config file '{0}'. Specified 'include' paths were '{1}' and 'exclude' paths were '{2}'."), File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module: a(80001, e2.DiagnosticCategory.Suggestion, "File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module_80001", "File is a CommonJS module; it may be converted to an ES module."), This_constructor_function_may_be_converted_to_a_class_declaration: a(80002, e2.DiagnosticCategory.Suggestion, "This_constructor_function_may_be_converted_to_a_class_declaration_80002", "This constructor function may be converted to a class declaration."), Import_may_be_converted_to_a_default_import: a(80003, e2.DiagnosticCategory.Suggestion, "Import_may_be_converted_to_a_default_import_80003", "Import may be converted to a default import."), JSDoc_types_may_be_moved_to_TypeScript_types: a(80004, e2.DiagnosticCategory.Suggestion, "JSDoc_types_may_be_moved_to_TypeScript_types_80004", "JSDoc types may be moved to TypeScript types."), require_call_may_be_converted_to_an_import: a(80005, e2.DiagnosticCategory.Suggestion, "require_call_may_be_converted_to_an_import_80005", "'require' call may be converted to an import."), This_may_be_converted_to_an_async_function: a(80006, e2.DiagnosticCategory.Suggestion, "This_may_be_converted_to_an_async_function_80006", "This may be converted to an async function."), await_has_no_effect_on_the_type_of_this_expression: a(80007, e2.DiagnosticCategory.Suggestion, "await_has_no_effect_on_the_type_of_this_expression_80007", "'await' has no effect on the type of this expression."), Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers: a(80008, e2.DiagnosticCategory.Suggestion, "Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accur_80008", "Numeric literals with absolute values equal to 2^53 or greater are too large to be represented accurately as integers."), Add_missing_super_call: a(90001, e2.DiagnosticCategory.Message, "Add_missing_super_call_90001", "Add missing 'super()' call"), Make_super_call_the_first_statement_in_the_constructor: a(90002, e2.DiagnosticCategory.Message, "Make_super_call_the_first_statement_in_the_constructor_90002", "Make 'super()' call the first statement in the constructor"), Change_extends_to_implements: a(90003, e2.DiagnosticCategory.Message, "Change_extends_to_implements_90003", "Change 'extends' to 'implements'"), Remove_unused_declaration_for_Colon_0: a(90004, e2.DiagnosticCategory.Message, "Remove_unused_declaration_for_Colon_0_90004", "Remove unused declaration for: '{0}'"), Remove_import_from_0: a(90005, e2.DiagnosticCategory.Message, "Remove_import_from_0_90005", "Remove import from '{0}'"), Implement_interface_0: a(90006, e2.DiagnosticCategory.Message, "Implement_interface_0_90006", "Implement interface '{0}'"), Implement_inherited_abstract_class: a(90007, e2.DiagnosticCategory.Message, "Implement_inherited_abstract_class_90007", "Implement inherited abstract class"), Add_0_to_unresolved_variable: a(90008, e2.DiagnosticCategory.Message, "Add_0_to_unresolved_variable_90008", "Add '{0}.' to unresolved variable"), Remove_variable_statement: a(90010, e2.DiagnosticCategory.Message, "Remove_variable_statement_90010", "Remove variable statement"), Remove_template_tag: a(90011, e2.DiagnosticCategory.Message, "Remove_template_tag_90011", "Remove template tag"), Remove_type_parameters: a(90012, e2.DiagnosticCategory.Message, "Remove_type_parameters_90012", "Remove type parameters"), Import_0_from_1: a(90013, e2.DiagnosticCategory.Message, "Import_0_from_1_90013", `Import '{0}' from "{1}"`), Change_0_to_1: a(90014, e2.DiagnosticCategory.Message, "Change_0_to_1_90014", "Change '{0}' to '{1}'"), Declare_property_0: a(90016, e2.DiagnosticCategory.Message, "Declare_property_0_90016", "Declare property '{0}'"), Add_index_signature_for_property_0: a(90017, e2.DiagnosticCategory.Message, "Add_index_signature_for_property_0_90017", "Add index signature for property '{0}'"), Disable_checking_for_this_file: a(90018, e2.DiagnosticCategory.Message, "Disable_checking_for_this_file_90018", "Disable checking for this file"), Ignore_this_error_message: a(90019, e2.DiagnosticCategory.Message, "Ignore_this_error_message_90019", "Ignore this error message"), Initialize_property_0_in_the_constructor: a(90020, e2.DiagnosticCategory.Message, "Initialize_property_0_in_the_constructor_90020", "Initialize property '{0}' in the constructor"), Initialize_static_property_0: a(90021, e2.DiagnosticCategory.Message, "Initialize_static_property_0_90021", "Initialize static property '{0}'"), Change_spelling_to_0: a(90022, e2.DiagnosticCategory.Message, "Change_spelling_to_0_90022", "Change spelling to '{0}'"), Declare_method_0: a(90023, e2.DiagnosticCategory.Message, "Declare_method_0_90023", "Declare method '{0}'"), Declare_static_method_0: a(90024, e2.DiagnosticCategory.Message, "Declare_static_method_0_90024", "Declare static method '{0}'"), Prefix_0_with_an_underscore: a(90025, e2.DiagnosticCategory.Message, "Prefix_0_with_an_underscore_90025", "Prefix '{0}' with an underscore"), Rewrite_as_the_indexed_access_type_0: a(90026, e2.DiagnosticCategory.Message, "Rewrite_as_the_indexed_access_type_0_90026", "Rewrite as the indexed access type '{0}'"), Declare_static_property_0: a(90027, e2.DiagnosticCategory.Message, "Declare_static_property_0_90027", "Declare static property '{0}'"), Call_decorator_expression: a(90028, e2.DiagnosticCategory.Message, "Call_decorator_expression_90028", "Call decorator expression"), Add_async_modifier_to_containing_function: a(90029, e2.DiagnosticCategory.Message, "Add_async_modifier_to_containing_function_90029", "Add async modifier to containing function"), Replace_infer_0_with_unknown: a(90030, e2.DiagnosticCategory.Message, "Replace_infer_0_with_unknown_90030", "Replace 'infer {0}' with 'unknown'"), Replace_all_unused_infer_with_unknown: a(90031, e2.DiagnosticCategory.Message, "Replace_all_unused_infer_with_unknown_90031", "Replace all unused 'infer' with 'unknown'"), Add_parameter_name: a(90034, e2.DiagnosticCategory.Message, "Add_parameter_name_90034", "Add parameter name"), Declare_private_property_0: a(90035, e2.DiagnosticCategory.Message, "Declare_private_property_0_90035", "Declare private property '{0}'"), Replace_0_with_Promise_1: a(90036, e2.DiagnosticCategory.Message, "Replace_0_with_Promise_1_90036", "Replace '{0}' with 'Promise<{1}>'"), Fix_all_incorrect_return_type_of_an_async_functions: a(90037, e2.DiagnosticCategory.Message, "Fix_all_incorrect_return_type_of_an_async_functions_90037", "Fix all incorrect return type of an async functions"), Declare_private_method_0: a(90038, e2.DiagnosticCategory.Message, "Declare_private_method_0_90038", "Declare private method '{0}'"), Remove_unused_destructuring_declaration: a(90039, e2.DiagnosticCategory.Message, "Remove_unused_destructuring_declaration_90039", "Remove unused destructuring declaration"), Remove_unused_declarations_for_Colon_0: a(90041, e2.DiagnosticCategory.Message, "Remove_unused_declarations_for_Colon_0_90041", "Remove unused declarations for: '{0}'"), Declare_a_private_field_named_0: a(90053, e2.DiagnosticCategory.Message, "Declare_a_private_field_named_0_90053", "Declare a private field named '{0}'."), Includes_imports_of_types_referenced_by_0: a(90054, e2.DiagnosticCategory.Message, "Includes_imports_of_types_referenced_by_0_90054", "Includes imports of types referenced by '{0}'"), Remove_type_from_import_declaration_from_0: a(90055, e2.DiagnosticCategory.Message, "Remove_type_from_import_declaration_from_0_90055", `Remove 'type' from import declaration from "{0}"`), Remove_type_from_import_of_0_from_1: a(90056, e2.DiagnosticCategory.Message, "Remove_type_from_import_of_0_from_1_90056", `Remove 'type' from import of '{0}' from "{1}"`), Add_import_from_0: a(90057, e2.DiagnosticCategory.Message, "Add_import_from_0_90057", 'Add import from "{0}"'), Update_import_from_0: a(90058, e2.DiagnosticCategory.Message, "Update_import_from_0_90058", 'Update import from "{0}"'), Convert_function_to_an_ES2015_class: a(95001, e2.DiagnosticCategory.Message, "Convert_function_to_an_ES2015_class_95001", "Convert function to an ES2015 class"), Convert_0_to_1_in_0: a(95003, e2.DiagnosticCategory.Message, "Convert_0_to_1_in_0_95003", "Convert '{0}' to '{1} in {0}'"), Extract_to_0_in_1: a(95004, e2.DiagnosticCategory.Message, "Extract_to_0_in_1_95004", "Extract to {0} in {1}"), Extract_function: a(95005, e2.DiagnosticCategory.Message, "Extract_function_95005", "Extract function"), Extract_constant: a(95006, e2.DiagnosticCategory.Message, "Extract_constant_95006", "Extract constant"), Extract_to_0_in_enclosing_scope: a(95007, e2.DiagnosticCategory.Message, "Extract_to_0_in_enclosing_scope_95007", "Extract to {0} in enclosing scope"), Extract_to_0_in_1_scope: a(95008, e2.DiagnosticCategory.Message, "Extract_to_0_in_1_scope_95008", "Extract to {0} in {1} scope"), Annotate_with_type_from_JSDoc: a(95009, e2.DiagnosticCategory.Message, "Annotate_with_type_from_JSDoc_95009", "Annotate with type from JSDoc"), Infer_type_of_0_from_usage: a(95011, e2.DiagnosticCategory.Message, "Infer_type_of_0_from_usage_95011", "Infer type of '{0}' from usage"), Infer_parameter_types_from_usage: a(95012, e2.DiagnosticCategory.Message, "Infer_parameter_types_from_usage_95012", "Infer parameter types from usage"), Convert_to_default_import: a(95013, e2.DiagnosticCategory.Message, "Convert_to_default_import_95013", "Convert to default import"), Install_0: a(95014, e2.DiagnosticCategory.Message, "Install_0_95014", "Install '{0}'"), Replace_import_with_0: a(95015, e2.DiagnosticCategory.Message, "Replace_import_with_0_95015", "Replace import with '{0}'."), Use_synthetic_default_member: a(95016, e2.DiagnosticCategory.Message, "Use_synthetic_default_member_95016", "Use synthetic 'default' member."), Convert_to_ES_module: a(95017, e2.DiagnosticCategory.Message, "Convert_to_ES_module_95017", "Convert to ES module"), Add_undefined_type_to_property_0: a(95018, e2.DiagnosticCategory.Message, "Add_undefined_type_to_property_0_95018", "Add 'undefined' type to property '{0}'"), Add_initializer_to_property_0: a(95019, e2.DiagnosticCategory.Message, "Add_initializer_to_property_0_95019", "Add initializer to property '{0}'"), Add_definite_assignment_assertion_to_property_0: a(95020, e2.DiagnosticCategory.Message, "Add_definite_assignment_assertion_to_property_0_95020", "Add definite assignment assertion to property '{0}'"), Convert_all_type_literals_to_mapped_type: a(95021, e2.DiagnosticCategory.Message, "Convert_all_type_literals_to_mapped_type_95021", "Convert all type literals to mapped type"), Add_all_missing_members: a(95022, e2.DiagnosticCategory.Message, "Add_all_missing_members_95022", "Add all missing members"), Infer_all_types_from_usage: a(95023, e2.DiagnosticCategory.Message, "Infer_all_types_from_usage_95023", "Infer all types from usage"), Delete_all_unused_declarations: a(95024, e2.DiagnosticCategory.Message, "Delete_all_unused_declarations_95024", "Delete all unused declarations"), Prefix_all_unused_declarations_with_where_possible: a(95025, e2.DiagnosticCategory.Message, "Prefix_all_unused_declarations_with_where_possible_95025", "Prefix all unused declarations with '_' where possible"), Fix_all_detected_spelling_errors: a(95026, e2.DiagnosticCategory.Message, "Fix_all_detected_spelling_errors_95026", "Fix all detected spelling errors"), Add_initializers_to_all_uninitialized_properties: a(95027, e2.DiagnosticCategory.Message, "Add_initializers_to_all_uninitialized_properties_95027", "Add initializers to all uninitialized properties"), Add_definite_assignment_assertions_to_all_uninitialized_properties: a(95028, e2.DiagnosticCategory.Message, "Add_definite_assignment_assertions_to_all_uninitialized_properties_95028", "Add definite assignment assertions to all uninitialized properties"), Add_undefined_type_to_all_uninitialized_properties: a(95029, e2.DiagnosticCategory.Message, "Add_undefined_type_to_all_uninitialized_properties_95029", "Add undefined type to all uninitialized properties"), Change_all_jsdoc_style_types_to_TypeScript: a(95030, e2.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_95030", "Change all jsdoc-style types to TypeScript"), Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types: a(95031, e2.DiagnosticCategory.Message, "Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types_95031", "Change all jsdoc-style types to TypeScript (and add '| undefined' to nullable types)"), Implement_all_unimplemented_interfaces: a(95032, e2.DiagnosticCategory.Message, "Implement_all_unimplemented_interfaces_95032", "Implement all unimplemented interfaces"), Install_all_missing_types_packages: a(95033, e2.DiagnosticCategory.Message, "Install_all_missing_types_packages_95033", "Install all missing types packages"), Rewrite_all_as_indexed_access_types: a(95034, e2.DiagnosticCategory.Message, "Rewrite_all_as_indexed_access_types_95034", "Rewrite all as indexed access types"), Convert_all_to_default_imports: a(95035, e2.DiagnosticCategory.Message, "Convert_all_to_default_imports_95035", "Convert all to default imports"), Make_all_super_calls_the_first_statement_in_their_constructor: a(95036, e2.DiagnosticCategory.Message, "Make_all_super_calls_the_first_statement_in_their_constructor_95036", "Make all 'super()' calls the first statement in their constructor"), Add_qualifier_to_all_unresolved_variables_matching_a_member_name: a(95037, e2.DiagnosticCategory.Message, "Add_qualifier_to_all_unresolved_variables_matching_a_member_name_95037", "Add qualifier to all unresolved variables matching a member name"), Change_all_extended_interfaces_to_implements: a(95038, e2.DiagnosticCategory.Message, "Change_all_extended_interfaces_to_implements_95038", "Change all extended interfaces to 'implements'"), Add_all_missing_super_calls: a(95039, e2.DiagnosticCategory.Message, "Add_all_missing_super_calls_95039", "Add all missing super calls"), Implement_all_inherited_abstract_classes: a(95040, e2.DiagnosticCategory.Message, "Implement_all_inherited_abstract_classes_95040", "Implement all inherited abstract classes"), Add_all_missing_async_modifiers: a(95041, e2.DiagnosticCategory.Message, "Add_all_missing_async_modifiers_95041", "Add all missing 'async' modifiers"), Add_ts_ignore_to_all_error_messages: a(95042, e2.DiagnosticCategory.Message, "Add_ts_ignore_to_all_error_messages_95042", "Add '@ts-ignore' to all error messages"), Annotate_everything_with_types_from_JSDoc: a(95043, e2.DiagnosticCategory.Message, "Annotate_everything_with_types_from_JSDoc_95043", "Annotate everything with types from JSDoc"), Add_to_all_uncalled_decorators: a(95044, e2.DiagnosticCategory.Message, "Add_to_all_uncalled_decorators_95044", "Add '()' to all uncalled decorators"), Convert_all_constructor_functions_to_classes: a(95045, e2.DiagnosticCategory.Message, "Convert_all_constructor_functions_to_classes_95045", "Convert all constructor functions to classes"), Generate_get_and_set_accessors: a(95046, e2.DiagnosticCategory.Message, "Generate_get_and_set_accessors_95046", "Generate 'get' and 'set' accessors"), Convert_require_to_import: a(95047, e2.DiagnosticCategory.Message, "Convert_require_to_import_95047", "Convert 'require' to 'import'"), Convert_all_require_to_import: a(95048, e2.DiagnosticCategory.Message, "Convert_all_require_to_import_95048", "Convert all 'require' to 'import'"), Move_to_a_new_file: a(95049, e2.DiagnosticCategory.Message, "Move_to_a_new_file_95049", "Move to a new file"), Remove_unreachable_code: a(95050, e2.DiagnosticCategory.Message, "Remove_unreachable_code_95050", "Remove unreachable code"), Remove_all_unreachable_code: a(95051, e2.DiagnosticCategory.Message, "Remove_all_unreachable_code_95051", "Remove all unreachable code"), Add_missing_typeof: a(95052, e2.DiagnosticCategory.Message, "Add_missing_typeof_95052", "Add missing 'typeof'"), Remove_unused_label: a(95053, e2.DiagnosticCategory.Message, "Remove_unused_label_95053", "Remove unused label"), Remove_all_unused_labels: a(95054, e2.DiagnosticCategory.Message, "Remove_all_unused_labels_95054", "Remove all unused labels"), Convert_0_to_mapped_object_type: a(95055, e2.DiagnosticCategory.Message, "Convert_0_to_mapped_object_type_95055", "Convert '{0}' to mapped object type"), Convert_namespace_import_to_named_imports: a(95056, e2.DiagnosticCategory.Message, "Convert_namespace_import_to_named_imports_95056", "Convert namespace import to named imports"), Convert_named_imports_to_namespace_import: a(95057, e2.DiagnosticCategory.Message, "Convert_named_imports_to_namespace_import_95057", "Convert named imports to namespace import"), Add_or_remove_braces_in_an_arrow_function: a(95058, e2.DiagnosticCategory.Message, "Add_or_remove_braces_in_an_arrow_function_95058", "Add or remove braces in an arrow function"), Add_braces_to_arrow_function: a(95059, e2.DiagnosticCategory.Message, "Add_braces_to_arrow_function_95059", "Add braces to arrow function"), Remove_braces_from_arrow_function: a(95060, e2.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_95060", "Remove braces from arrow function"), Convert_default_export_to_named_export: a(95061, e2.DiagnosticCategory.Message, "Convert_default_export_to_named_export_95061", "Convert default export to named export"), Convert_named_export_to_default_export: a(95062, e2.DiagnosticCategory.Message, "Convert_named_export_to_default_export_95062", "Convert named export to default export"), Add_missing_enum_member_0: a(95063, e2.DiagnosticCategory.Message, "Add_missing_enum_member_0_95063", "Add missing enum member '{0}'"), Add_all_missing_imports: a(95064, e2.DiagnosticCategory.Message, "Add_all_missing_imports_95064", "Add all missing imports"), Convert_to_async_function: a(95065, e2.DiagnosticCategory.Message, "Convert_to_async_function_95065", "Convert to async function"), Convert_all_to_async_functions: a(95066, e2.DiagnosticCategory.Message, "Convert_all_to_async_functions_95066", "Convert all to async functions"), Add_missing_call_parentheses: a(95067, e2.DiagnosticCategory.Message, "Add_missing_call_parentheses_95067", "Add missing call parentheses"), Add_all_missing_call_parentheses: a(95068, e2.DiagnosticCategory.Message, "Add_all_missing_call_parentheses_95068", "Add all missing call parentheses"), Add_unknown_conversion_for_non_overlapping_types: a(95069, e2.DiagnosticCategory.Message, "Add_unknown_conversion_for_non_overlapping_types_95069", "Add 'unknown' conversion for non-overlapping types"), Add_unknown_to_all_conversions_of_non_overlapping_types: a(95070, e2.DiagnosticCategory.Message, "Add_unknown_to_all_conversions_of_non_overlapping_types_95070", "Add 'unknown' to all conversions of non-overlapping types"), Add_missing_new_operator_to_call: a(95071, e2.DiagnosticCategory.Message, "Add_missing_new_operator_to_call_95071", "Add missing 'new' operator to call"), Add_missing_new_operator_to_all_calls: a(95072, e2.DiagnosticCategory.Message, "Add_missing_new_operator_to_all_calls_95072", "Add missing 'new' operator to all calls"), Add_names_to_all_parameters_without_names: a(95073, e2.DiagnosticCategory.Message, "Add_names_to_all_parameters_without_names_95073", "Add names to all parameters without names"), Enable_the_experimentalDecorators_option_in_your_configuration_file: a(95074, e2.DiagnosticCategory.Message, "Enable_the_experimentalDecorators_option_in_your_configuration_file_95074", "Enable the 'experimentalDecorators' option in your configuration file"), Convert_parameters_to_destructured_object: a(95075, e2.DiagnosticCategory.Message, "Convert_parameters_to_destructured_object_95075", "Convert parameters to destructured object"), Extract_type: a(95077, e2.DiagnosticCategory.Message, "Extract_type_95077", "Extract type"), Extract_to_type_alias: a(95078, e2.DiagnosticCategory.Message, "Extract_to_type_alias_95078", "Extract to type alias"), Extract_to_typedef: a(95079, e2.DiagnosticCategory.Message, "Extract_to_typedef_95079", "Extract to typedef"), Infer_this_type_of_0_from_usage: a(95080, e2.DiagnosticCategory.Message, "Infer_this_type_of_0_from_usage_95080", "Infer 'this' type of '{0}' from usage"), Add_const_to_unresolved_variable: a(95081, e2.DiagnosticCategory.Message, "Add_const_to_unresolved_variable_95081", "Add 'const' to unresolved variable"), Add_const_to_all_unresolved_variables: a(95082, e2.DiagnosticCategory.Message, "Add_const_to_all_unresolved_variables_95082", "Add 'const' to all unresolved variables"), Add_await: a(95083, e2.DiagnosticCategory.Message, "Add_await_95083", "Add 'await'"), Add_await_to_initializer_for_0: a(95084, e2.DiagnosticCategory.Message, "Add_await_to_initializer_for_0_95084", "Add 'await' to initializer for '{0}'"), Fix_all_expressions_possibly_missing_await: a(95085, e2.DiagnosticCategory.Message, "Fix_all_expressions_possibly_missing_await_95085", "Fix all expressions possibly missing 'await'"), Remove_unnecessary_await: a(95086, e2.DiagnosticCategory.Message, "Remove_unnecessary_await_95086", "Remove unnecessary 'await'"), Remove_all_unnecessary_uses_of_await: a(95087, e2.DiagnosticCategory.Message, "Remove_all_unnecessary_uses_of_await_95087", "Remove all unnecessary uses of 'await'"), Enable_the_jsx_flag_in_your_configuration_file: a(95088, e2.DiagnosticCategory.Message, "Enable_the_jsx_flag_in_your_configuration_file_95088", "Enable the '--jsx' flag in your configuration file"), Add_await_to_initializers: a(95089, e2.DiagnosticCategory.Message, "Add_await_to_initializers_95089", "Add 'await' to initializers"), Extract_to_interface: a(95090, e2.DiagnosticCategory.Message, "Extract_to_interface_95090", "Extract to interface"), Convert_to_a_bigint_numeric_literal: a(95091, e2.DiagnosticCategory.Message, "Convert_to_a_bigint_numeric_literal_95091", "Convert to a bigint numeric literal"), Convert_all_to_bigint_numeric_literals: a(95092, e2.DiagnosticCategory.Message, "Convert_all_to_bigint_numeric_literals_95092", "Convert all to bigint numeric literals"), Convert_const_to_let: a(95093, e2.DiagnosticCategory.Message, "Convert_const_to_let_95093", "Convert 'const' to 'let'"), Prefix_with_declare: a(95094, e2.DiagnosticCategory.Message, "Prefix_with_declare_95094", "Prefix with 'declare'"), Prefix_all_incorrect_property_declarations_with_declare: a(95095, e2.DiagnosticCategory.Message, "Prefix_all_incorrect_property_declarations_with_declare_95095", "Prefix all incorrect property declarations with 'declare'"), Convert_to_template_string: a(95096, e2.DiagnosticCategory.Message, "Convert_to_template_string_95096", "Convert to template string"), Add_export_to_make_this_file_into_a_module: a(95097, e2.DiagnosticCategory.Message, "Add_export_to_make_this_file_into_a_module_95097", "Add 'export {}' to make this file into a module"), Set_the_target_option_in_your_configuration_file_to_0: a(95098, e2.DiagnosticCategory.Message, "Set_the_target_option_in_your_configuration_file_to_0_95098", "Set the 'target' option in your configuration file to '{0}'"), Set_the_module_option_in_your_configuration_file_to_0: a(95099, e2.DiagnosticCategory.Message, "Set_the_module_option_in_your_configuration_file_to_0_95099", "Set the 'module' option in your configuration file to '{0}'"), Convert_invalid_character_to_its_html_entity_code: a(95100, e2.DiagnosticCategory.Message, "Convert_invalid_character_to_its_html_entity_code_95100", "Convert invalid character to its html entity code"), Convert_all_invalid_characters_to_HTML_entity_code: a(95101, e2.DiagnosticCategory.Message, "Convert_all_invalid_characters_to_HTML_entity_code_95101", "Convert all invalid characters to HTML entity code"), Convert_function_expression_0_to_arrow_function: a(95105, e2.DiagnosticCategory.Message, "Convert_function_expression_0_to_arrow_function_95105", "Convert function expression '{0}' to arrow function"), Convert_function_declaration_0_to_arrow_function: a(95106, e2.DiagnosticCategory.Message, "Convert_function_declaration_0_to_arrow_function_95106", "Convert function declaration '{0}' to arrow function"), Fix_all_implicit_this_errors: a(95107, e2.DiagnosticCategory.Message, "Fix_all_implicit_this_errors_95107", "Fix all implicit-'this' errors"), Wrap_invalid_character_in_an_expression_container: a(95108, e2.DiagnosticCategory.Message, "Wrap_invalid_character_in_an_expression_container_95108", "Wrap invalid character in an expression container"), Wrap_all_invalid_characters_in_an_expression_container: a(95109, e2.DiagnosticCategory.Message, "Wrap_all_invalid_characters_in_an_expression_container_95109", "Wrap all invalid characters in an expression container"), Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file: a(95110, e2.DiagnosticCategory.Message, "Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file_95110", "Visit https://aka.ms/tsconfig to read more about this file"), Add_a_return_statement: a(95111, e2.DiagnosticCategory.Message, "Add_a_return_statement_95111", "Add a return statement"), Remove_braces_from_arrow_function_body: a(95112, e2.DiagnosticCategory.Message, "Remove_braces_from_arrow_function_body_95112", "Remove braces from arrow function body"), Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal: a(95113, e2.DiagnosticCategory.Message, "Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal_95113", "Wrap the following body with parentheses which should be an object literal"), Add_all_missing_return_statement: a(95114, e2.DiagnosticCategory.Message, "Add_all_missing_return_statement_95114", "Add all missing return statement"), Remove_braces_from_all_arrow_function_bodies_with_relevant_issues: a(95115, e2.DiagnosticCategory.Message, "Remove_braces_from_all_arrow_function_bodies_with_relevant_issues_95115", "Remove braces from all arrow function bodies with relevant issues"), Wrap_all_object_literal_with_parentheses: a(95116, e2.DiagnosticCategory.Message, "Wrap_all_object_literal_with_parentheses_95116", "Wrap all object literal with parentheses"), Move_labeled_tuple_element_modifiers_to_labels: a(95117, e2.DiagnosticCategory.Message, "Move_labeled_tuple_element_modifiers_to_labels_95117", "Move labeled tuple element modifiers to labels"), Convert_overload_list_to_single_signature: a(95118, e2.DiagnosticCategory.Message, "Convert_overload_list_to_single_signature_95118", "Convert overload list to single signature"), Generate_get_and_set_accessors_for_all_overriding_properties: a(95119, e2.DiagnosticCategory.Message, "Generate_get_and_set_accessors_for_all_overriding_properties_95119", "Generate 'get' and 'set' accessors for all overriding properties"), Wrap_in_JSX_fragment: a(95120, e2.DiagnosticCategory.Message, "Wrap_in_JSX_fragment_95120", "Wrap in JSX fragment"), Wrap_all_unparented_JSX_in_JSX_fragment: a(95121, e2.DiagnosticCategory.Message, "Wrap_all_unparented_JSX_in_JSX_fragment_95121", "Wrap all unparented JSX in JSX fragment"), Convert_arrow_function_or_function_expression: a(95122, e2.DiagnosticCategory.Message, "Convert_arrow_function_or_function_expression_95122", "Convert arrow function or function expression"), Convert_to_anonymous_function: a(95123, e2.DiagnosticCategory.Message, "Convert_to_anonymous_function_95123", "Convert to anonymous function"), Convert_to_named_function: a(95124, e2.DiagnosticCategory.Message, "Convert_to_named_function_95124", "Convert to named function"), Convert_to_arrow_function: a(95125, e2.DiagnosticCategory.Message, "Convert_to_arrow_function_95125", "Convert to arrow function"), Remove_parentheses: a(95126, e2.DiagnosticCategory.Message, "Remove_parentheses_95126", "Remove parentheses"), Could_not_find_a_containing_arrow_function: a(95127, e2.DiagnosticCategory.Message, "Could_not_find_a_containing_arrow_function_95127", "Could not find a containing arrow function"), Containing_function_is_not_an_arrow_function: a(95128, e2.DiagnosticCategory.Message, "Containing_function_is_not_an_arrow_function_95128", "Containing function is not an arrow function"), Could_not_find_export_statement: a(95129, e2.DiagnosticCategory.Message, "Could_not_find_export_statement_95129", "Could not find export statement"), This_file_already_has_a_default_export: a(95130, e2.DiagnosticCategory.Message, "This_file_already_has_a_default_export_95130", "This file already has a default export"), Could_not_find_import_clause: a(95131, e2.DiagnosticCategory.Message, "Could_not_find_import_clause_95131", "Could not find import clause"), Could_not_find_namespace_import_or_named_imports: a(95132, e2.DiagnosticCategory.Message, "Could_not_find_namespace_import_or_named_imports_95132", "Could not find namespace import or named imports"), Selection_is_not_a_valid_type_node: a(95133, e2.DiagnosticCategory.Message, "Selection_is_not_a_valid_type_node_95133", "Selection is not a valid type node"), No_type_could_be_extracted_from_this_type_node: a(95134, e2.DiagnosticCategory.Message, "No_type_could_be_extracted_from_this_type_node_95134", "No type could be extracted from this type node"), Could_not_find_property_for_which_to_generate_accessor: a(95135, e2.DiagnosticCategory.Message, "Could_not_find_property_for_which_to_generate_accessor_95135", "Could not find property for which to generate accessor"), Name_is_not_valid: a(95136, e2.DiagnosticCategory.Message, "Name_is_not_valid_95136", "Name is not valid"), Can_only_convert_property_with_modifier: a(95137, e2.DiagnosticCategory.Message, "Can_only_convert_property_with_modifier_95137", "Can only convert property with modifier"), Switch_each_misused_0_to_1: a(95138, e2.DiagnosticCategory.Message, "Switch_each_misused_0_to_1_95138", "Switch each misused '{0}' to '{1}'"), Convert_to_optional_chain_expression: a(95139, e2.DiagnosticCategory.Message, "Convert_to_optional_chain_expression_95139", "Convert to optional chain expression"), Could_not_find_convertible_access_expression: a(95140, e2.DiagnosticCategory.Message, "Could_not_find_convertible_access_expression_95140", "Could not find convertible access expression"), Could_not_find_matching_access_expressions: a(95141, e2.DiagnosticCategory.Message, "Could_not_find_matching_access_expressions_95141", "Could not find matching access expressions"), Can_only_convert_logical_AND_access_chains: a(95142, e2.DiagnosticCategory.Message, "Can_only_convert_logical_AND_access_chains_95142", "Can only convert logical AND access chains"), Add_void_to_Promise_resolved_without_a_value: a(95143, e2.DiagnosticCategory.Message, "Add_void_to_Promise_resolved_without_a_value_95143", "Add 'void' to Promise resolved without a value"), Add_void_to_all_Promises_resolved_without_a_value: a(95144, e2.DiagnosticCategory.Message, "Add_void_to_all_Promises_resolved_without_a_value_95144", "Add 'void' to all Promises resolved without a value"), Use_element_access_for_0: a(95145, e2.DiagnosticCategory.Message, "Use_element_access_for_0_95145", "Use element access for '{0}'"), Use_element_access_for_all_undeclared_properties: a(95146, e2.DiagnosticCategory.Message, "Use_element_access_for_all_undeclared_properties_95146", "Use element access for all undeclared properties."), Delete_all_unused_imports: a(95147, e2.DiagnosticCategory.Message, "Delete_all_unused_imports_95147", "Delete all unused imports"), Infer_function_return_type: a(95148, e2.DiagnosticCategory.Message, "Infer_function_return_type_95148", "Infer function return type"), Return_type_must_be_inferred_from_a_function: a(95149, e2.DiagnosticCategory.Message, "Return_type_must_be_inferred_from_a_function_95149", "Return type must be inferred from a function"), Could_not_determine_function_return_type: a(95150, e2.DiagnosticCategory.Message, "Could_not_determine_function_return_type_95150", "Could not determine function return type"), Could_not_convert_to_arrow_function: a(95151, e2.DiagnosticCategory.Message, "Could_not_convert_to_arrow_function_95151", "Could not convert to arrow function"), Could_not_convert_to_named_function: a(95152, e2.DiagnosticCategory.Message, "Could_not_convert_to_named_function_95152", "Could not convert to named function"), Could_not_convert_to_anonymous_function: a(95153, e2.DiagnosticCategory.Message, "Could_not_convert_to_anonymous_function_95153", "Could not convert to anonymous function"), Can_only_convert_string_concatenation: a(95154, e2.DiagnosticCategory.Message, "Can_only_convert_string_concatenation_95154", "Can only convert string concatenation"), Selection_is_not_a_valid_statement_or_statements: a(95155, e2.DiagnosticCategory.Message, "Selection_is_not_a_valid_statement_or_statements_95155", "Selection is not a valid statement or statements"), Add_missing_function_declaration_0: a(95156, e2.DiagnosticCategory.Message, "Add_missing_function_declaration_0_95156", "Add missing function declaration '{0}'"), Add_all_missing_function_declarations: a(95157, e2.DiagnosticCategory.Message, "Add_all_missing_function_declarations_95157", "Add all missing function declarations"), Method_not_implemented: a(95158, e2.DiagnosticCategory.Message, "Method_not_implemented_95158", "Method not implemented."), Function_not_implemented: a(95159, e2.DiagnosticCategory.Message, "Function_not_implemented_95159", "Function not implemented."), Add_override_modifier: a(95160, e2.DiagnosticCategory.Message, "Add_override_modifier_95160", "Add 'override' modifier"), Remove_override_modifier: a(95161, e2.DiagnosticCategory.Message, "Remove_override_modifier_95161", "Remove 'override' modifier"), Add_all_missing_override_modifiers: a(95162, e2.DiagnosticCategory.Message, "Add_all_missing_override_modifiers_95162", "Add all missing 'override' modifiers"), Remove_all_unnecessary_override_modifiers: a(95163, e2.DiagnosticCategory.Message, "Remove_all_unnecessary_override_modifiers_95163", "Remove all unnecessary 'override' modifiers"), Can_only_convert_named_export: a(95164, e2.DiagnosticCategory.Message, "Can_only_convert_named_export_95164", "Can only convert named export"), Add_missing_properties: a(95165, e2.DiagnosticCategory.Message, "Add_missing_properties_95165", "Add missing properties"), Add_all_missing_properties: a(95166, e2.DiagnosticCategory.Message, "Add_all_missing_properties_95166", "Add all missing properties"), Add_missing_attributes: a(95167, e2.DiagnosticCategory.Message, "Add_missing_attributes_95167", "Add missing attributes"), Add_all_missing_attributes: a(95168, e2.DiagnosticCategory.Message, "Add_all_missing_attributes_95168", "Add all missing attributes"), Add_undefined_to_optional_property_type: a(95169, e2.DiagnosticCategory.Message, "Add_undefined_to_optional_property_type_95169", "Add 'undefined' to optional property type"), Convert_named_imports_to_default_import: a(95170, e2.DiagnosticCategory.Message, "Convert_named_imports_to_default_import_95170", "Convert named imports to default import"), Delete_unused_param_tag_0: a(95171, e2.DiagnosticCategory.Message, "Delete_unused_param_tag_0_95171", "Delete unused '@param' tag '{0}'"), Delete_all_unused_param_tags: a(95172, e2.DiagnosticCategory.Message, "Delete_all_unused_param_tags_95172", "Delete all unused '@param' tags"), Rename_param_tag_name_0_to_1: a(95173, e2.DiagnosticCategory.Message, "Rename_param_tag_name_0_to_1_95173", "Rename '@param' tag name '{0}' to '{1}'"), No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer: a(18004, e2.DiagnosticCategory.Error, "No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer_18004", "No value exists in scope for the shorthand property '{0}'. Either declare one or provide an initializer."), Classes_may_not_have_a_field_named_constructor: a(18006, e2.DiagnosticCategory.Error, "Classes_may_not_have_a_field_named_constructor_18006", "Classes may not have a field named 'constructor'."), JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array: a(18007, e2.DiagnosticCategory.Error, "JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array_18007", "JSX expressions may not use the comma operator. Did you mean to write an array?"), Private_identifiers_cannot_be_used_as_parameters: a(18009, e2.DiagnosticCategory.Error, "Private_identifiers_cannot_be_used_as_parameters_18009", "Private identifiers cannot be used as parameters."), An_accessibility_modifier_cannot_be_used_with_a_private_identifier: a(18010, e2.DiagnosticCategory.Error, "An_accessibility_modifier_cannot_be_used_with_a_private_identifier_18010", "An accessibility modifier cannot be used with a private identifier."), The_operand_of_a_delete_operator_cannot_be_a_private_identifier: a(18011, e2.DiagnosticCategory.Error, "The_operand_of_a_delete_operator_cannot_be_a_private_identifier_18011", "The operand of a 'delete' operator cannot be a private identifier."), constructor_is_a_reserved_word: a(18012, e2.DiagnosticCategory.Error, "constructor_is_a_reserved_word_18012", "'#constructor' is a reserved word."), Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier: a(18013, e2.DiagnosticCategory.Error, "Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier_18013", "Property '{0}' is not accessible outside class '{1}' because it has a private identifier."), The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling: a(18014, e2.DiagnosticCategory.Error, "The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_priv_18014", "The property '{0}' cannot be accessed on type '{1}' within this class because it is shadowed by another private identifier with the same spelling."), Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2: a(18015, e2.DiagnosticCategory.Error, "Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2_18015", "Property '{0}' in type '{1}' refers to a different member that cannot be accessed from within type '{2}'."), Private_identifiers_are_not_allowed_outside_class_bodies: a(18016, e2.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_outside_class_bodies_18016", "Private identifiers are not allowed outside class bodies."), The_shadowing_declaration_of_0_is_defined_here: a(18017, e2.DiagnosticCategory.Error, "The_shadowing_declaration_of_0_is_defined_here_18017", "The shadowing declaration of '{0}' is defined here"), The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here: a(18018, e2.DiagnosticCategory.Error, "The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here_18018", "The declaration of '{0}' that you probably intended to use is defined here"), _0_modifier_cannot_be_used_with_a_private_identifier: a(18019, e2.DiagnosticCategory.Error, "_0_modifier_cannot_be_used_with_a_private_identifier_18019", "'{0}' modifier cannot be used with a private identifier."), An_enum_member_cannot_be_named_with_a_private_identifier: a(18024, e2.DiagnosticCategory.Error, "An_enum_member_cannot_be_named_with_a_private_identifier_18024", "An enum member cannot be named with a private identifier."), can_only_be_used_at_the_start_of_a_file: a(18026, e2.DiagnosticCategory.Error, "can_only_be_used_at_the_start_of_a_file_18026", "'#!' can only be used at the start of a file."), Compiler_reserves_name_0_when_emitting_private_identifier_downlevel: a(18027, e2.DiagnosticCategory.Error, "Compiler_reserves_name_0_when_emitting_private_identifier_downlevel_18027", "Compiler reserves name '{0}' when emitting private identifier downlevel."), Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher: a(18028, e2.DiagnosticCategory.Error, "Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher_18028", "Private identifiers are only available when targeting ECMAScript 2015 and higher."), Private_identifiers_are_not_allowed_in_variable_declarations: a(18029, e2.DiagnosticCategory.Error, "Private_identifiers_are_not_allowed_in_variable_declarations_18029", "Private identifiers are not allowed in variable declarations."), An_optional_chain_cannot_contain_private_identifiers: a(18030, e2.DiagnosticCategory.Error, "An_optional_chain_cannot_contain_private_identifiers_18030", "An optional chain cannot contain private identifiers."), The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents: a(18031, e2.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituent_18031", "The intersection '{0}' was reduced to 'never' because property '{1}' has conflicting types in some constituents."), The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some: a(18032, e2.DiagnosticCategory.Error, "The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_pr_18032", "The intersection '{0}' was reduced to 'never' because property '{1}' exists in multiple constituents and is private in some."), Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead: a(18033, e2.DiagnosticCategory.Error, "Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhau_18033", "Only numeric enums can have computed members, but this expression has type '{0}'. If you do not need exhaustiveness checks, consider using an object literal instead."), Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compiler_option_is_specified_e_g_Fragment: a(18034, e2.DiagnosticCategory.Message, "Specify_the_JSX_fragment_factory_function_to_use_when_targeting_react_JSX_emit_with_jsxFactory_compi_18034", "Specify the JSX fragment factory function to use when targeting 'react' JSX emit with 'jsxFactory' compiler option is specified, e.g. 'Fragment'."), Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name: a(18035, e2.DiagnosticCategory.Error, "Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name_18035", "Invalid value for 'jsxFragmentFactory'. '{0}' is not a valid identifier or qualified-name."), Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator: a(18036, e2.DiagnosticCategory.Error, "Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_dec_18036", "Class decorators can't be used with static private identifier. Consider removing the experimental decorator."), Await_expression_cannot_be_used_inside_a_class_static_block: a(18037, e2.DiagnosticCategory.Error, "Await_expression_cannot_be_used_inside_a_class_static_block_18037", "Await expression cannot be used inside a class static block."), For_await_loops_cannot_be_used_inside_a_class_static_block: a(18038, e2.DiagnosticCategory.Error, "For_await_loops_cannot_be_used_inside_a_class_static_block_18038", "'For await' loops cannot be used inside a class static block."), Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block: a(18039, e2.DiagnosticCategory.Error, "Invalid_use_of_0_It_cannot_be_used_inside_a_class_static_block_18039", "Invalid use of '{0}'. It cannot be used inside a class static block."), A_return_statement_cannot_be_used_inside_a_class_static_block: a(18041, e2.DiagnosticCategory.Error, "A_return_statement_cannot_be_used_inside_a_class_static_block_18041", "A 'return' statement cannot be used inside a class static block.") };
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            function C(ye) {
              return ye >= 79;
            }
            e2.tokenIsIdentifierOrKeyword = C;
            function w(ye) {
              return ye === 31 || C(ye);
            }
            e2.tokenIsIdentifierOrKeywordOrGreaterThan = w, e2.textToKeywordObj = (a = { abstract: 126, any: 130, as: 127, asserts: 128, assert: 129, bigint: 158, boolean: 133, break: 81, case: 82, catch: 83, class: 84, continue: 86, const: 85 }, a.constructor = 134, a.debugger = 87, a.declare = 135, a.default = 88, a.delete = 89, a.do = 90, a.else = 91, a.enum = 92, a.export = 93, a.extends = 94, a.false = 95, a.finally = 96, a.for = 97, a.from = 156, a.function = 98, a.get = 136, a.if = 99, a.implements = 117, a.import = 100, a.in = 101, a.infer = 137, a.instanceof = 102, a.interface = 118, a.intrinsic = 138, a.is = 139, a.keyof = 140, a.let = 119, a.module = 141, a.namespace = 142, a.never = 143, a.new = 103, a.null = 104, a.number = 147, a.object = 148, a.package = 120, a.private = 121, a.protected = 122, a.public = 123, a.override = 159, a.out = 144, a.readonly = 145, a.require = 146, a.global = 157, a.return = 105, a.set = 149, a.static = 124, a.string = 150, a.super = 106, a.switch = 107, a.symbol = 151, a.this = 108, a.throw = 109, a.true = 110, a.try = 111, a.type = 152, a.typeof = 112, a.undefined = 153, a.unique = 154, a.unknown = 155, a.var = 113, a.void = 114, a.while = 115, a.with = 116, a.yield = 125, a.async = 131, a.await = 132, a.of = 160, a);
            var B = new e2.Map(e2.getEntries(e2.textToKeywordObj)), E = new e2.Map(e2.getEntries(Ke(Ke({}, e2.textToKeywordObj), { "{": 18, "}": 19, "(": 20, ")": 21, "[": 22, "]": 23, ".": 24, "...": 25, ";": 26, ",": 27, "<": 29, ">": 31, "<=": 32, ">=": 33, "==": 34, "!=": 35, "===": 36, "!==": 37, "=>": 38, "+": 39, "-": 40, "**": 42, "*": 41, "/": 43, "%": 44, "++": 45, "--": 46, "<<": 47, "</": 30, ">>": 48, ">>>": 49, "&": 50, "|": 51, "^": 52, "!": 53, "~": 54, "&&": 55, "||": 56, "?": 57, "??": 60, "?.": 28, ":": 58, "=": 63, "+=": 64, "-=": 65, "*=": 66, "**=": 67, "/=": 68, "%=": 69, "<<=": 70, ">>=": 71, ">>>=": 72, "&=": 73, "|=": 74, "^=": 78, "||=": 75, "&&=": 76, "??=": 77, "@": 59, "#": 62, "`": 61 }))), Q = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1610, 1649, 1747, 1749, 1749, 1765, 1766, 1786, 1788, 1808, 1808, 1810, 1836, 1920, 1957, 2309, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2784, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3294, 3294, 3296, 3297, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3424, 3425, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3805, 3840, 3840, 3904, 3911, 3913, 3946, 3976, 3979, 4096, 4129, 4131, 4135, 4137, 4138, 4176, 4181, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6067, 6176, 6263, 6272, 6312, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8319, 8319, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12346, 12353, 12436, 12445, 12446, 12449, 12538, 12540, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65138, 65140, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500], le = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 543, 546, 563, 592, 685, 688, 696, 699, 705, 720, 721, 736, 740, 750, 750, 768, 846, 864, 866, 890, 890, 902, 902, 904, 906, 908, 908, 910, 929, 931, 974, 976, 983, 986, 1011, 1024, 1153, 1155, 1158, 1164, 1220, 1223, 1224, 1227, 1228, 1232, 1269, 1272, 1273, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1441, 1443, 1465, 1467, 1469, 1471, 1471, 1473, 1474, 1476, 1476, 1488, 1514, 1520, 1522, 1569, 1594, 1600, 1621, 1632, 1641, 1648, 1747, 1749, 1756, 1759, 1768, 1770, 1773, 1776, 1788, 1808, 1836, 1840, 1866, 1920, 1968, 2305, 2307, 2309, 2361, 2364, 2381, 2384, 2388, 2392, 2403, 2406, 2415, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2492, 2494, 2500, 2503, 2504, 2507, 2509, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2562, 2562, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2649, 2652, 2654, 2654, 2662, 2676, 2689, 2691, 2693, 2699, 2701, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2784, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2870, 2873, 2876, 2883, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2913, 2918, 2927, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 2997, 2999, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3031, 3031, 3047, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3134, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3168, 3169, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3262, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3297, 3302, 3311, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3368, 3370, 3385, 3390, 3395, 3398, 3400, 3402, 3405, 3415, 3415, 3424, 3425, 3430, 3439, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3805, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3946, 3953, 3972, 3974, 3979, 3984, 3991, 3993, 4028, 4038, 4038, 4096, 4129, 4131, 4135, 4137, 4138, 4140, 4146, 4150, 4153, 4160, 4169, 4176, 4185, 4256, 4293, 4304, 4342, 4352, 4441, 4447, 4514, 4520, 4601, 4608, 4614, 4616, 4678, 4680, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4742, 4744, 4744, 4746, 4749, 4752, 4782, 4784, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4814, 4816, 4822, 4824, 4846, 4848, 4878, 4880, 4880, 4882, 4885, 4888, 4894, 4896, 4934, 4936, 4954, 4969, 4977, 5024, 5108, 5121, 5740, 5743, 5750, 5761, 5786, 5792, 5866, 6016, 6099, 6112, 6121, 6160, 6169, 6176, 6263, 6272, 6313, 7680, 7835, 7840, 7929, 7936, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8319, 8319, 8400, 8412, 8417, 8417, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8497, 8499, 8505, 8544, 8579, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12346, 12353, 12436, 12441, 12442, 12445, 12446, 12449, 12542, 12549, 12588, 12593, 12686, 12704, 12727, 13312, 19893, 19968, 40869, 40960, 42124, 44032, 55203, 63744, 64045, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65056, 65059, 65075, 65076, 65101, 65103, 65136, 65138, 65140, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65381, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500], N = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1488, 1514, 1520, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2208, 2208, 2210, 2220, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2423, 2425, 2431, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3133, 3160, 3161, 3168, 3169, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3424, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6263, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6428, 6480, 6509, 6512, 6516, 6528, 6571, 6593, 6599, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7401, 7404, 7406, 7409, 7413, 7414, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11823, 11823, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42647, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43648, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500], p = [170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1319, 1329, 1366, 1369, 1369, 1377, 1415, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1520, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2048, 2093, 2112, 2139, 2208, 2208, 2210, 2220, 2276, 2302, 2304, 2403, 2406, 2415, 2417, 2423, 2425, 2431, 2433, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3073, 3075, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3123, 3125, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3161, 3168, 3171, 3174, 3183, 3202, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3330, 3331, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3396, 3398, 3400, 3402, 3406, 3415, 3415, 3424, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3719, 3720, 3722, 3722, 3725, 3725, 3732, 3735, 3737, 3743, 3745, 3747, 3749, 3749, 3751, 3751, 3754, 3755, 3757, 3769, 3771, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4992, 5007, 5024, 5108, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5872, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6263, 6272, 6314, 6320, 6389, 6400, 6428, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6617, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7376, 7378, 7380, 7414, 7424, 7654, 7676, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8204, 8205, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8473, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8493, 8495, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 11823, 11823, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12442, 12445, 12447, 12449, 12538, 12540, 12543, 12549, 12589, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40908, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42647, 42655, 42737, 42775, 42783, 42786, 42888, 42891, 42894, 42896, 42899, 42912, 42922, 43e3, 43047, 43072, 43123, 43136, 43204, 43216, 43225, 43232, 43255, 43259, 43259, 43264, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43643, 43648, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43968, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65062, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500], m2 = [65, 90, 97, 122, 170, 170, 181, 181, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 880, 884, 886, 887, 890, 893, 895, 895, 902, 902, 904, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1488, 1514, 1519, 1522, 1568, 1610, 1646, 1647, 1649, 1747, 1749, 1749, 1765, 1766, 1774, 1775, 1786, 1788, 1791, 1791, 1808, 1808, 1810, 1839, 1869, 1957, 1969, 1969, 1994, 2026, 2036, 2037, 2042, 2042, 2048, 2069, 2074, 2074, 2084, 2084, 2088, 2088, 2112, 2136, 2144, 2154, 2208, 2228, 2230, 2237, 2308, 2361, 2365, 2365, 2384, 2384, 2392, 2401, 2417, 2432, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2493, 2493, 2510, 2510, 2524, 2525, 2527, 2529, 2544, 2545, 2556, 2556, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2649, 2652, 2654, 2654, 2674, 2676, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2749, 2749, 2768, 2768, 2784, 2785, 2809, 2809, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2877, 2877, 2908, 2909, 2911, 2913, 2929, 2929, 2947, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3024, 3024, 3077, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3133, 3160, 3162, 3168, 3169, 3200, 3200, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3261, 3261, 3294, 3294, 3296, 3297, 3313, 3314, 3333, 3340, 3342, 3344, 3346, 3386, 3389, 3389, 3406, 3406, 3412, 3414, 3423, 3425, 3450, 3455, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3585, 3632, 3634, 3635, 3648, 3654, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3760, 3762, 3763, 3773, 3773, 3776, 3780, 3782, 3782, 3804, 3807, 3840, 3840, 3904, 3911, 3913, 3948, 3976, 3980, 4096, 4138, 4159, 4159, 4176, 4181, 4186, 4189, 4193, 4193, 4197, 4198, 4206, 4208, 4213, 4225, 4238, 4238, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5905, 5920, 5937, 5952, 5969, 5984, 5996, 5998, 6e3, 6016, 6067, 6103, 6103, 6108, 6108, 6176, 6264, 6272, 6312, 6314, 6314, 6320, 6389, 6400, 6430, 6480, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6656, 6678, 6688, 6740, 6823, 6823, 6917, 6963, 6981, 6987, 7043, 7072, 7086, 7087, 7098, 7141, 7168, 7203, 7245, 7247, 7258, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7401, 7404, 7406, 7411, 7413, 7414, 7418, 7418, 7424, 7615, 7680, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8305, 8305, 8319, 8319, 8336, 8348, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11502, 11506, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11648, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 12293, 12295, 12321, 12329, 12337, 12341, 12344, 12348, 12353, 12438, 12443, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42527, 42538, 42539, 42560, 42606, 42623, 42653, 42656, 42735, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43009, 43011, 43013, 43015, 43018, 43020, 43042, 43072, 43123, 43138, 43187, 43250, 43255, 43259, 43259, 43261, 43262, 43274, 43301, 43312, 43334, 43360, 43388, 43396, 43442, 43471, 43471, 43488, 43492, 43494, 43503, 43514, 43518, 43520, 43560, 43584, 43586, 43588, 43595, 43616, 43638, 43642, 43642, 43646, 43695, 43697, 43697, 43701, 43702, 43705, 43709, 43712, 43712, 43714, 43714, 43739, 43741, 43744, 43754, 43762, 43764, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44002, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64285, 64287, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65136, 65140, 65142, 65276, 65313, 65338, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66176, 66204, 66208, 66256, 66304, 66335, 66349, 66378, 66384, 66421, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68096, 68112, 68115, 68117, 68119, 68121, 68149, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68324, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68899, 69376, 69404, 69415, 69415, 69424, 69445, 69600, 69622, 69635, 69687, 69763, 69807, 69840, 69864, 69891, 69926, 69956, 69956, 69968, 70002, 70006, 70006, 70019, 70066, 70081, 70084, 70106, 70106, 70108, 70108, 70144, 70161, 70163, 70187, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70366, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70461, 70461, 70480, 70480, 70493, 70497, 70656, 70708, 70727, 70730, 70751, 70751, 70784, 70831, 70852, 70853, 70855, 70855, 71040, 71086, 71128, 71131, 71168, 71215, 71236, 71236, 71296, 71338, 71352, 71352, 71424, 71450, 71680, 71723, 71840, 71903, 71935, 71935, 72096, 72103, 72106, 72144, 72161, 72161, 72163, 72163, 72192, 72192, 72203, 72242, 72250, 72250, 72272, 72272, 72284, 72329, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72750, 72768, 72768, 72818, 72847, 72960, 72966, 72968, 72969, 72971, 73008, 73030, 73030, 73056, 73061, 73063, 73064, 73066, 73097, 73112, 73112, 73440, 73458, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92880, 92909, 92928, 92975, 92992, 92995, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94032, 94032, 94099, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 123136, 123180, 123191, 123197, 123214, 123214, 123584, 123627, 124928, 125124, 125184, 125251, 125259, 125259, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101], G = [48, 57, 65, 90, 95, 95, 97, 122, 170, 170, 181, 181, 183, 183, 186, 186, 192, 214, 216, 246, 248, 705, 710, 721, 736, 740, 748, 748, 750, 750, 768, 884, 886, 887, 890, 893, 895, 895, 902, 906, 908, 908, 910, 929, 931, 1013, 1015, 1153, 1155, 1159, 1162, 1327, 1329, 1366, 1369, 1369, 1376, 1416, 1425, 1469, 1471, 1471, 1473, 1474, 1476, 1477, 1479, 1479, 1488, 1514, 1519, 1522, 1552, 1562, 1568, 1641, 1646, 1747, 1749, 1756, 1759, 1768, 1770, 1788, 1791, 1791, 1808, 1866, 1869, 1969, 1984, 2037, 2042, 2042, 2045, 2045, 2048, 2093, 2112, 2139, 2144, 2154, 2208, 2228, 2230, 2237, 2259, 2273, 2275, 2403, 2406, 2415, 2417, 2435, 2437, 2444, 2447, 2448, 2451, 2472, 2474, 2480, 2482, 2482, 2486, 2489, 2492, 2500, 2503, 2504, 2507, 2510, 2519, 2519, 2524, 2525, 2527, 2531, 2534, 2545, 2556, 2556, 2558, 2558, 2561, 2563, 2565, 2570, 2575, 2576, 2579, 2600, 2602, 2608, 2610, 2611, 2613, 2614, 2616, 2617, 2620, 2620, 2622, 2626, 2631, 2632, 2635, 2637, 2641, 2641, 2649, 2652, 2654, 2654, 2662, 2677, 2689, 2691, 2693, 2701, 2703, 2705, 2707, 2728, 2730, 2736, 2738, 2739, 2741, 2745, 2748, 2757, 2759, 2761, 2763, 2765, 2768, 2768, 2784, 2787, 2790, 2799, 2809, 2815, 2817, 2819, 2821, 2828, 2831, 2832, 2835, 2856, 2858, 2864, 2866, 2867, 2869, 2873, 2876, 2884, 2887, 2888, 2891, 2893, 2902, 2903, 2908, 2909, 2911, 2915, 2918, 2927, 2929, 2929, 2946, 2947, 2949, 2954, 2958, 2960, 2962, 2965, 2969, 2970, 2972, 2972, 2974, 2975, 2979, 2980, 2984, 2986, 2990, 3001, 3006, 3010, 3014, 3016, 3018, 3021, 3024, 3024, 3031, 3031, 3046, 3055, 3072, 3084, 3086, 3088, 3090, 3112, 3114, 3129, 3133, 3140, 3142, 3144, 3146, 3149, 3157, 3158, 3160, 3162, 3168, 3171, 3174, 3183, 3200, 3203, 3205, 3212, 3214, 3216, 3218, 3240, 3242, 3251, 3253, 3257, 3260, 3268, 3270, 3272, 3274, 3277, 3285, 3286, 3294, 3294, 3296, 3299, 3302, 3311, 3313, 3314, 3328, 3331, 3333, 3340, 3342, 3344, 3346, 3396, 3398, 3400, 3402, 3406, 3412, 3415, 3423, 3427, 3430, 3439, 3450, 3455, 3458, 3459, 3461, 3478, 3482, 3505, 3507, 3515, 3517, 3517, 3520, 3526, 3530, 3530, 3535, 3540, 3542, 3542, 3544, 3551, 3558, 3567, 3570, 3571, 3585, 3642, 3648, 3662, 3664, 3673, 3713, 3714, 3716, 3716, 3718, 3722, 3724, 3747, 3749, 3749, 3751, 3773, 3776, 3780, 3782, 3782, 3784, 3789, 3792, 3801, 3804, 3807, 3840, 3840, 3864, 3865, 3872, 3881, 3893, 3893, 3895, 3895, 3897, 3897, 3902, 3911, 3913, 3948, 3953, 3972, 3974, 3991, 3993, 4028, 4038, 4038, 4096, 4169, 4176, 4253, 4256, 4293, 4295, 4295, 4301, 4301, 4304, 4346, 4348, 4680, 4682, 4685, 4688, 4694, 4696, 4696, 4698, 4701, 4704, 4744, 4746, 4749, 4752, 4784, 4786, 4789, 4792, 4798, 4800, 4800, 4802, 4805, 4808, 4822, 4824, 4880, 4882, 4885, 4888, 4954, 4957, 4959, 4969, 4977, 4992, 5007, 5024, 5109, 5112, 5117, 5121, 5740, 5743, 5759, 5761, 5786, 5792, 5866, 5870, 5880, 5888, 5900, 5902, 5908, 5920, 5940, 5952, 5971, 5984, 5996, 5998, 6e3, 6002, 6003, 6016, 6099, 6103, 6103, 6108, 6109, 6112, 6121, 6155, 6157, 6160, 6169, 6176, 6264, 6272, 6314, 6320, 6389, 6400, 6430, 6432, 6443, 6448, 6459, 6470, 6509, 6512, 6516, 6528, 6571, 6576, 6601, 6608, 6618, 6656, 6683, 6688, 6750, 6752, 6780, 6783, 6793, 6800, 6809, 6823, 6823, 6832, 6845, 6912, 6987, 6992, 7001, 7019, 7027, 7040, 7155, 7168, 7223, 7232, 7241, 7245, 7293, 7296, 7304, 7312, 7354, 7357, 7359, 7376, 7378, 7380, 7418, 7424, 7673, 7675, 7957, 7960, 7965, 7968, 8005, 8008, 8013, 8016, 8023, 8025, 8025, 8027, 8027, 8029, 8029, 8031, 8061, 8064, 8116, 8118, 8124, 8126, 8126, 8130, 8132, 8134, 8140, 8144, 8147, 8150, 8155, 8160, 8172, 8178, 8180, 8182, 8188, 8255, 8256, 8276, 8276, 8305, 8305, 8319, 8319, 8336, 8348, 8400, 8412, 8417, 8417, 8421, 8432, 8450, 8450, 8455, 8455, 8458, 8467, 8469, 8469, 8472, 8477, 8484, 8484, 8486, 8486, 8488, 8488, 8490, 8505, 8508, 8511, 8517, 8521, 8526, 8526, 8544, 8584, 11264, 11310, 11312, 11358, 11360, 11492, 11499, 11507, 11520, 11557, 11559, 11559, 11565, 11565, 11568, 11623, 11631, 11631, 11647, 11670, 11680, 11686, 11688, 11694, 11696, 11702, 11704, 11710, 11712, 11718, 11720, 11726, 11728, 11734, 11736, 11742, 11744, 11775, 12293, 12295, 12321, 12335, 12337, 12341, 12344, 12348, 12353, 12438, 12441, 12447, 12449, 12538, 12540, 12543, 12549, 12591, 12593, 12686, 12704, 12730, 12784, 12799, 13312, 19893, 19968, 40943, 40960, 42124, 42192, 42237, 42240, 42508, 42512, 42539, 42560, 42607, 42612, 42621, 42623, 42737, 42775, 42783, 42786, 42888, 42891, 42943, 42946, 42950, 42999, 43047, 43072, 43123, 43136, 43205, 43216, 43225, 43232, 43255, 43259, 43259, 43261, 43309, 43312, 43347, 43360, 43388, 43392, 43456, 43471, 43481, 43488, 43518, 43520, 43574, 43584, 43597, 43600, 43609, 43616, 43638, 43642, 43714, 43739, 43741, 43744, 43759, 43762, 43766, 43777, 43782, 43785, 43790, 43793, 43798, 43808, 43814, 43816, 43822, 43824, 43866, 43868, 43879, 43888, 44010, 44012, 44013, 44016, 44025, 44032, 55203, 55216, 55238, 55243, 55291, 63744, 64109, 64112, 64217, 64256, 64262, 64275, 64279, 64285, 64296, 64298, 64310, 64312, 64316, 64318, 64318, 64320, 64321, 64323, 64324, 64326, 64433, 64467, 64829, 64848, 64911, 64914, 64967, 65008, 65019, 65024, 65039, 65056, 65071, 65075, 65076, 65101, 65103, 65136, 65140, 65142, 65276, 65296, 65305, 65313, 65338, 65343, 65343, 65345, 65370, 65382, 65470, 65474, 65479, 65482, 65487, 65490, 65495, 65498, 65500, 65536, 65547, 65549, 65574, 65576, 65594, 65596, 65597, 65599, 65613, 65616, 65629, 65664, 65786, 65856, 65908, 66045, 66045, 66176, 66204, 66208, 66256, 66272, 66272, 66304, 66335, 66349, 66378, 66384, 66426, 66432, 66461, 66464, 66499, 66504, 66511, 66513, 66517, 66560, 66717, 66720, 66729, 66736, 66771, 66776, 66811, 66816, 66855, 66864, 66915, 67072, 67382, 67392, 67413, 67424, 67431, 67584, 67589, 67592, 67592, 67594, 67637, 67639, 67640, 67644, 67644, 67647, 67669, 67680, 67702, 67712, 67742, 67808, 67826, 67828, 67829, 67840, 67861, 67872, 67897, 67968, 68023, 68030, 68031, 68096, 68099, 68101, 68102, 68108, 68115, 68117, 68119, 68121, 68149, 68152, 68154, 68159, 68159, 68192, 68220, 68224, 68252, 68288, 68295, 68297, 68326, 68352, 68405, 68416, 68437, 68448, 68466, 68480, 68497, 68608, 68680, 68736, 68786, 68800, 68850, 68864, 68903, 68912, 68921, 69376, 69404, 69415, 69415, 69424, 69456, 69600, 69622, 69632, 69702, 69734, 69743, 69759, 69818, 69840, 69864, 69872, 69881, 69888, 69940, 69942, 69951, 69956, 69958, 69968, 70003, 70006, 70006, 70016, 70084, 70089, 70092, 70096, 70106, 70108, 70108, 70144, 70161, 70163, 70199, 70206, 70206, 70272, 70278, 70280, 70280, 70282, 70285, 70287, 70301, 70303, 70312, 70320, 70378, 70384, 70393, 70400, 70403, 70405, 70412, 70415, 70416, 70419, 70440, 70442, 70448, 70450, 70451, 70453, 70457, 70459, 70468, 70471, 70472, 70475, 70477, 70480, 70480, 70487, 70487, 70493, 70499, 70502, 70508, 70512, 70516, 70656, 70730, 70736, 70745, 70750, 70751, 70784, 70853, 70855, 70855, 70864, 70873, 71040, 71093, 71096, 71104, 71128, 71133, 71168, 71232, 71236, 71236, 71248, 71257, 71296, 71352, 71360, 71369, 71424, 71450, 71453, 71467, 71472, 71481, 71680, 71738, 71840, 71913, 71935, 71935, 72096, 72103, 72106, 72151, 72154, 72161, 72163, 72164, 72192, 72254, 72263, 72263, 72272, 72345, 72349, 72349, 72384, 72440, 72704, 72712, 72714, 72758, 72760, 72768, 72784, 72793, 72818, 72847, 72850, 72871, 72873, 72886, 72960, 72966, 72968, 72969, 72971, 73014, 73018, 73018, 73020, 73021, 73023, 73031, 73040, 73049, 73056, 73061, 73063, 73064, 73066, 73102, 73104, 73105, 73107, 73112, 73120, 73129, 73440, 73462, 73728, 74649, 74752, 74862, 74880, 75075, 77824, 78894, 82944, 83526, 92160, 92728, 92736, 92766, 92768, 92777, 92880, 92909, 92912, 92916, 92928, 92982, 92992, 92995, 93008, 93017, 93027, 93047, 93053, 93071, 93760, 93823, 93952, 94026, 94031, 94087, 94095, 94111, 94176, 94177, 94179, 94179, 94208, 100343, 100352, 101106, 110592, 110878, 110928, 110930, 110948, 110951, 110960, 111355, 113664, 113770, 113776, 113788, 113792, 113800, 113808, 113817, 113821, 113822, 119141, 119145, 119149, 119154, 119163, 119170, 119173, 119179, 119210, 119213, 119362, 119364, 119808, 119892, 119894, 119964, 119966, 119967, 119970, 119970, 119973, 119974, 119977, 119980, 119982, 119993, 119995, 119995, 119997, 120003, 120005, 120069, 120071, 120074, 120077, 120084, 120086, 120092, 120094, 120121, 120123, 120126, 120128, 120132, 120134, 120134, 120138, 120144, 120146, 120485, 120488, 120512, 120514, 120538, 120540, 120570, 120572, 120596, 120598, 120628, 120630, 120654, 120656, 120686, 120688, 120712, 120714, 120744, 120746, 120770, 120772, 120779, 120782, 120831, 121344, 121398, 121403, 121452, 121461, 121461, 121476, 121476, 121499, 121503, 121505, 121519, 122880, 122886, 122888, 122904, 122907, 122913, 122915, 122916, 122918, 122922, 123136, 123180, 123184, 123197, 123200, 123209, 123214, 123214, 123584, 123641, 124928, 125124, 125136, 125142, 125184, 125259, 125264, 125273, 126464, 126467, 126469, 126495, 126497, 126498, 126500, 126500, 126503, 126503, 126505, 126514, 126516, 126519, 126521, 126521, 126523, 126523, 126530, 126530, 126535, 126535, 126537, 126537, 126539, 126539, 126541, 126543, 126545, 126546, 126548, 126548, 126551, 126551, 126553, 126553, 126555, 126555, 126557, 126557, 126559, 126559, 126561, 126562, 126564, 126564, 126567, 126570, 126572, 126578, 126580, 126583, 126585, 126588, 126590, 126590, 126592, 126601, 126603, 126619, 126625, 126627, 126629, 126633, 126635, 126651, 131072, 173782, 173824, 177972, 177984, 178205, 178208, 183969, 183984, 191456, 194560, 195101, 917760, 917999], oe = /^\/\/\/?\s*@(ts-expect-error|ts-ignore)/, f4 = /^(?:\/|\*)*\s*@(ts-expect-error|ts-ignore)/;
            function T(ye, Ae) {
              if (ye < Ae[0])
                return false;
              for (var er = 0, ir = Ae.length, Cr; er + 1 < ir; ) {
                if (Cr = er + (ir - er) / 2, Cr -= Cr % 2, Ae[Cr] <= ye && ye <= Ae[Cr + 1])
                  return true;
                ye < Ae[Cr] ? ir = Cr : er = Cr + 2;
              }
              return false;
            }
            function K(ye, Ae) {
              return Ae >= 2 ? T(ye, m2) : Ae === 1 ? T(ye, N) : T(ye, Q);
            }
            e2.isUnicodeIdentifierStart = K;
            function b(ye, Ae) {
              return Ae >= 2 ? T(ye, G) : Ae === 1 ? T(ye, p) : T(ye, le);
            }
            function se(ye) {
              var Ae = [];
              return ye.forEach(function(er, ir) {
                Ae[er] = ir;
              }), Ae;
            }
            var J = se(E);
            function ie(ye) {
              return J[ye];
            }
            e2.tokenToString = ie;
            function R(ye) {
              return E.get(ye);
            }
            e2.stringToToken = R;
            function q(ye) {
              for (var Ae = new Array(), er = 0, ir = 0; er < ye.length; ) {
                var Cr = ye.charCodeAt(er);
                switch (er++, Cr) {
                  case 13:
                    ye.charCodeAt(er) === 10 && er++;
                  case 10:
                    Ae.push(ir), ir = er;
                    break;
                  default:
                    Cr > 127 && y(Cr) && (Ae.push(ir), ir = er);
                    break;
                }
              }
              return Ae.push(ir), Ae;
            }
            e2.computeLineStarts = q;
            function O(ye, Ae, er, ir) {
              return ye.getPositionOfLineAndCharacter ? ye.getPositionOfLineAndCharacter(Ae, er, ir) : ve(ee(ye), Ae, er, ye.text, ir);
            }
            e2.getPositionOfLineAndCharacter = O;
            function ve(ye, Ae, er, ir, Cr) {
              (Ae < 0 || Ae >= ye.length) && (Cr ? Ae = Ae < 0 ? 0 : Ae >= ye.length ? ye.length - 1 : Ae : e2.Debug.fail("Bad line number. Line: ".concat(Ae, ", lineStarts.length: ").concat(ye.length, " , line map is correct? ").concat(ir !== void 0 ? e2.arraysEqual(ye, q(ir)) : "unknown")));
              var Ye = ye[Ae] + er;
              return Cr ? Ye > ye[Ae + 1] ? ye[Ae + 1] : typeof ir == "string" && Ye > ir.length ? ir.length : Ye : (Ae < ye.length - 1 ? e2.Debug.assert(Ye < ye[Ae + 1]) : ir !== void 0 && e2.Debug.assert(Ye <= ir.length), Ye);
            }
            e2.computePositionOfLineAndCharacter = ve;
            function ee(ye) {
              return ye.lineMap || (ye.lineMap = q(ye.text));
            }
            e2.getLineStarts = ee;
            function he(ye, Ae) {
              var er = F2(ye, Ae);
              return { line: er, character: Ae - ye[er] };
            }
            e2.computeLineAndCharacterOfPosition = he;
            function F2(ye, Ae, er) {
              var ir = e2.binarySearch(ye, Ae, e2.identity, e2.compareValues, er);
              return ir < 0 && (ir = ~ir - 1, e2.Debug.assert(ir !== -1, "position cannot precede the beginning of the file")), ir;
            }
            e2.computeLineOfPosition = F2;
            function x2(ye, Ae, er) {
              if (Ae === er)
                return 0;
              var ir = ee(ye), Cr = Math.min(Ae, er), Ye = Cr === er, Br = Ye ? Ae : er, Er = F2(ir, Cr), Ne = F2(ir, Br, Er);
              return Ye ? Er - Ne : Ne - Er;
            }
            e2.getLinesBetweenPositions = x2;
            function X(ye, Ae) {
              return he(ee(ye), Ae);
            }
            e2.getLineAndCharacterOfPosition = X;
            function $(ye) {
              return A2(ye) || y(ye);
            }
            e2.isWhiteSpaceLike = $;
            function A2(ye) {
              return ye === 32 || ye === 9 || ye === 11 || ye === 12 || ye === 160 || ye === 133 || ye === 5760 || ye >= 8192 && ye <= 8203 || ye === 8239 || ye === 8287 || ye === 12288 || ye === 65279;
            }
            e2.isWhiteSpaceSingleLine = A2;
            function y(ye) {
              return ye === 10 || ye === 13 || ye === 8232 || ye === 8233;
            }
            e2.isLineBreak = y;
            function V(ye) {
              return ye >= 48 && ye <= 57;
            }
            function L(ye) {
              return V(ye) || ye >= 65 && ye <= 70 || ye >= 97 && ye <= 102;
            }
            function P(ye) {
              return ye <= 1114111;
            }
            function k(ye) {
              return ye >= 48 && ye <= 55;
            }
            e2.isOctalDigit = k;
            function Y(ye, Ae) {
              var er = ye.charCodeAt(Ae);
              switch (er) {
                case 13:
                case 10:
                case 9:
                case 11:
                case 12:
                case 32:
                case 47:
                case 60:
                case 124:
                case 61:
                case 62:
                  return true;
                case 35:
                  return Ae === 0;
                default:
                  return er > 127;
              }
            }
            e2.couldStartTrivia = Y;
            function U(ye, Ae, er, ir, Cr) {
              if (e2.positionIsSynthesized(Ae))
                return Ae;
              for (var Ye = false; ; ) {
                var Br = ye.charCodeAt(Ae);
                switch (Br) {
                  case 13:
                    ye.charCodeAt(Ae + 1) === 10 && Ae++;
                  case 10:
                    if (Ae++, er)
                      return Ae;
                    Ye = !!Cr;
                    continue;
                  case 9:
                  case 11:
                  case 12:
                  case 32:
                    Ae++;
                    continue;
                  case 47:
                    if (ir)
                      break;
                    if (ye.charCodeAt(Ae + 1) === 47) {
                      for (Ae += 2; Ae < ye.length && !y(ye.charCodeAt(Ae)); )
                        Ae++;
                      Ye = false;
                      continue;
                    }
                    if (ye.charCodeAt(Ae + 1) === 42) {
                      for (Ae += 2; Ae < ye.length; ) {
                        if (ye.charCodeAt(Ae) === 42 && ye.charCodeAt(Ae + 1) === 47) {
                          Ae += 2;
                          break;
                        }
                        Ae++;
                      }
                      Ye = false;
                      continue;
                    }
                    break;
                  case 60:
                  case 124:
                  case 61:
                  case 62:
                    if (H(ye, Ae)) {
                      Ae = I(ye, Ae), Ye = false;
                      continue;
                    }
                    break;
                  case 35:
                    if (Ae === 0 && d(ye, Ae)) {
                      Ae = D(ye, Ae), Ye = false;
                      continue;
                    }
                    break;
                  case 42:
                    if (Ye) {
                      Ae++, Ye = false;
                      continue;
                    }
                    break;
                  default:
                    if (Br > 127 && $(Br)) {
                      Ae++;
                      continue;
                    }
                    break;
                }
                return Ae;
              }
            }
            e2.skipTrivia = U;
            var j = 7;
            function H(ye, Ae) {
              if (e2.Debug.assert(Ae >= 0), Ae === 0 || y(ye.charCodeAt(Ae - 1))) {
                var er = ye.charCodeAt(Ae);
                if (Ae + j < ye.length) {
                  for (var ir = 0; ir < j; ir++)
                    if (ye.charCodeAt(Ae + ir) !== er)
                      return false;
                  return er === 61 || ye.charCodeAt(Ae + j) === 32;
                }
              }
              return false;
            }
            function I(ye, Ae, er) {
              er && er(e2.Diagnostics.Merge_conflict_marker_encountered, Ae, j);
              var ir = ye.charCodeAt(Ae), Cr = ye.length;
              if (ir === 60 || ir === 62)
                for (; Ae < Cr && !y(ye.charCodeAt(Ae)); )
                  Ae++;
              else
                for (e2.Debug.assert(ir === 124 || ir === 61); Ae < Cr; ) {
                  var Ye = ye.charCodeAt(Ae);
                  if ((Ye === 61 || Ye === 62) && Ye !== ir && H(ye, Ae))
                    break;
                  Ae++;
                }
              return Ae;
            }
            var l = /^#!.*/;
            function d(ye, Ae) {
              return e2.Debug.assert(Ae === 0), l.test(ye);
            }
            e2.isShebangTrivia = d;
            function D(ye, Ae) {
              var er = l.exec(ye)[0];
              return Ae = Ae + er.length, Ae;
            }
            e2.scanShebangTrivia = D;
            function fe(ye, Ae, er, ir, Cr, Ye, Br) {
              var Er, Ne, n, lr, be = false, Ge = ir, ur = Br;
              if (er === 0) {
                Ge = true;
                var yr = ge(Ae);
                yr && (er = yr.length);
              }
              e:
                for (; er >= 0 && er < Ae.length; ) {
                  var Ir = Ae.charCodeAt(er);
                  switch (Ir) {
                    case 13:
                      Ae.charCodeAt(er + 1) === 10 && er++;
                    case 10:
                      if (er++, ir)
                        break e;
                      Ge = true, be && (lr = true);
                      continue;
                    case 9:
                    case 11:
                    case 12:
                    case 32:
                      er++;
                      continue;
                    case 47:
                      var wr = Ae.charCodeAt(er + 1), Ur = false;
                      if (wr === 47 || wr === 42) {
                        var ii = wr === 47 ? 2 : 3, mi = er;
                        if (er += 2, wr === 47)
                          for (; er < Ae.length; ) {
                            if (y(Ae.charCodeAt(er))) {
                              Ur = true;
                              break;
                            }
                            er++;
                          }
                        else
                          for (; er < Ae.length; ) {
                            if (Ae.charCodeAt(er) === 42 && Ae.charCodeAt(er + 1) === 47) {
                              er += 2;
                              break;
                            }
                            er++;
                          }
                        if (Ge) {
                          if (be && (ur = Cr(Er, Ne, n, lr, Ye, ur), !ye && ur))
                            return ur;
                          Er = mi, Ne = er, n = ii, lr = Ur, be = true;
                        }
                        continue;
                      }
                      break e;
                    default:
                      if (Ir > 127 && $(Ir)) {
                        be && y(Ir) && (lr = true), er++;
                        continue;
                      }
                      break e;
                  }
                }
              return be && (ur = Cr(Er, Ne, n, lr, Ye, ur)), ur;
            }
            function g(ye, Ae, er, ir) {
              return fe(false, ye, Ae, false, er, ir);
            }
            e2.forEachLeadingCommentRange = g;
            function ne(ye, Ae, er, ir) {
              return fe(false, ye, Ae, true, er, ir);
            }
            e2.forEachTrailingCommentRange = ne;
            function ue(ye, Ae, er, ir, Cr) {
              return fe(true, ye, Ae, false, er, ir, Cr);
            }
            e2.reduceEachLeadingCommentRange = ue;
            function We(ye, Ae, er, ir, Cr) {
              return fe(true, ye, Ae, true, er, ir, Cr);
            }
            e2.reduceEachTrailingCommentRange = We;
            function Fe(ye, Ae, er, ir, Cr, Ye) {
              return Ye || (Ye = []), Ye.push({ kind: er, pos: ye, end: Ae, hasTrailingNewLine: ir }), Ye;
            }
            function Z2(ye, Ae) {
              return ue(ye, Ae, Fe, void 0, void 0);
            }
            e2.getLeadingCommentRanges = Z2;
            function Be(ye, Ae) {
              return We(ye, Ae, Fe, void 0, void 0);
            }
            e2.getTrailingCommentRanges = Be;
            function ge(ye) {
              var Ae = l.exec(ye);
              if (Ae)
                return Ae[0];
            }
            e2.getShebang = ge;
            function Re(ye, Ae) {
              return ye >= 65 && ye <= 90 || ye >= 97 && ye <= 122 || ye === 36 || ye === 95 || ye > 127 && K(ye, Ae);
            }
            e2.isIdentifierStart = Re;
            function ze(ye, Ae, er) {
              return ye >= 65 && ye <= 90 || ye >= 97 && ye <= 122 || ye >= 48 && ye <= 57 || ye === 36 || ye === 95 || (er === 1 ? ye === 45 || ye === 58 : false) || ye > 127 && b(ye, Ae);
            }
            e2.isIdentifierPart = ze;
            function Ee(ye, Ae, er) {
              var ir = rr(ye, 0);
              if (!Re(ir, Ae))
                return false;
              for (var Cr = Ie(ir); Cr < ye.length; Cr += Ie(ir))
                if (!ze(ir = rr(ye, Cr), Ae, er))
                  return false;
              return true;
            }
            e2.isIdentifierText = Ee;
            function He(ye, Ae, er, ir, Cr, Ye, Br) {
              er === void 0 && (er = 0);
              var Er = ir, Ne, n, lr, be, Ge, ur, yr, Ir, wr = 0;
              nt(Er, Ye, Br);
              var Ur = { getStartPos: function() {
                return lr;
              }, getTextPos: function() {
                return Ne;
              }, getToken: function() {
                return Ge;
              }, getTokenPos: function() {
                return be;
              }, getTokenText: function() {
                return Er.substring(be, Ne);
              }, getTokenValue: function() {
                return ur;
              }, hasUnicodeEscape: function() {
                return (yr & 1024) !== 0;
              }, hasExtendedUnicodeEscape: function() {
                return (yr & 8) !== 0;
              }, hasPrecedingLineBreak: function() {
                return (yr & 1) !== 0;
              }, hasPrecedingJSDocComment: function() {
                return (yr & 2) !== 0;
              }, isIdentifier: function() {
                return Ge === 79 || Ge > 116;
              }, isReservedWord: function() {
                return Ge >= 81 && Ge <= 116;
              }, isUnterminated: function() {
                return (yr & 4) !== 0;
              }, getCommentDirectives: function() {
                return Ir;
              }, getNumericLiteralFlags: function() {
                return yr & 1008;
              }, getTokenFlags: function() {
                return yr;
              }, reScanGreaterToken: Wr, reScanAsteriskEqualsToken: Je, reScanSlashToken: xe, reScanTemplateToken: Ar, reScanTemplateHeadOrNoSubstitutionTemplate: Oe, scanJsxIdentifier: De, scanJsxAttributeValue: gr, reScanJsxAttributeValue: Vr, reScanJsxToken: nr, reScanLessThanToken: Mr, reScanHashToken: Pe, reScanQuestionToken: Ue, reScanInvalidIdentifier: Sr, scanJsxToken: fr, scanJsDocToken: Tr, scan: Ze, getText: ct, clearCommentDirectives: Li, setText: nt, setScriptTarget: xt, setLanguageVariant: ut, setOnError: Mt, setTextPos: Dt, setInJSDocType: Rt, tryScan: Wi, lookAhead: Yi, scanRange: Ui };
              return e2.Debug.isDebugging && Object.defineProperty(Ur, "__debugShowCurrentPositionInText", { get: function() {
                var Ii = Ur.getText();
                return Ii.slice(0, Ur.getStartPos()) + "\u2551" + Ii.slice(Ur.getStartPos());
              } }), Ur;
              function ii(Ii, Ki, Fi) {
                if (Ki === void 0 && (Ki = Ne), Cr) {
                  var ui = Ne;
                  Ne = Ki, Cr(Ii, Fi || 0), Ne = ui;
                }
              }
              function mi() {
                for (var Ii = Ne, Ki = false, Fi = false, ui = ""; ; ) {
                  var Bt = Er.charCodeAt(Ne);
                  if (Bt === 95) {
                    yr |= 512, Ki ? (Ki = false, Fi = true, ui += Er.substring(Ii, Ne)) : ii(Fi ? e2.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted : e2.Diagnostics.Numeric_separators_are_not_allowed_here, Ne, 1), Ne++, Ii = Ne;
                    continue;
                  }
                  if (V(Bt)) {
                    Ki = true, Fi = false, Ne++;
                    continue;
                  }
                  break;
                }
                return Er.charCodeAt(Ne - 1) === 95 && ii(e2.Diagnostics.Numeric_separators_are_not_allowed_here, Ne - 1, 1), ui + Er.substring(Ii, Ne);
              }
              function pe() {
                var Ii = Ne, Ki = mi(), Fi, ui;
                Er.charCodeAt(Ne) === 46 && (Ne++, Fi = mi());
                var Bt = Ne;
                if (Er.charCodeAt(Ne) === 69 || Er.charCodeAt(Ne) === 101) {
                  Ne++, yr |= 16, (Er.charCodeAt(Ne) === 43 || Er.charCodeAt(Ne) === 45) && Ne++;
                  var wt = Ne, na = mi();
                  na ? (ui = Er.substring(Bt, wt) + na, Bt = Ne) : ii(e2.Diagnostics.Digit_expected);
                }
                var Ai;
                if (yr & 512 ? (Ai = Ki, Fi && (Ai += "." + Fi), ui && (Ai += ui)) : Ai = Er.substring(Ii, Bt), Fi !== void 0 || yr & 16)
                  return or(Ii, Fi === void 0 && !!(yr & 16)), { type: 8, value: "" + +Ai };
                ur = Ai;
                var Oi = ti();
                return or(Ii), { type: Oi, value: ur };
              }
              function or(Ii, Ki) {
                if (!!Re(rr(Er, Ne), ye)) {
                  var Fi = Ne, ui = ae().length;
                  ui === 1 && Er[Fi] === "n" ? ii(Ki ? e2.Diagnostics.A_bigint_literal_cannot_use_exponential_notation : e2.Diagnostics.A_bigint_literal_must_be_an_integer, Ii, Fi - Ii + 1) : (ii(e2.Diagnostics.An_identifier_or_keyword_cannot_immediately_follow_a_numeric_literal, Fi, ui), Ne = Fi);
                }
              }
              function qr() {
                for (var Ii = Ne; k(Er.charCodeAt(Ne)); )
                  Ne++;
                return +Er.substring(Ii, Ne);
              }
              function si(Ii, Ki) {
                var Fi = wi(Ii, false, Ki);
                return Fi ? parseInt(Fi, 16) : -1;
              }
              function Di(Ii, Ki) {
                return wi(Ii, true, Ki);
              }
              function wi(Ii, Ki, Fi) {
                for (var ui = [], Bt = false, wt = false; ui.length < Ii || Ki; ) {
                  var na = Er.charCodeAt(Ne);
                  if (Fi && na === 95) {
                    yr |= 512, Bt ? (Bt = false, wt = true) : ii(wt ? e2.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted : e2.Diagnostics.Numeric_separators_are_not_allowed_here, Ne, 1), Ne++;
                    continue;
                  }
                  if (Bt = Fi, na >= 65 && na <= 70)
                    na += 97 - 65;
                  else if (!(na >= 48 && na <= 57 || na >= 97 && na <= 102))
                    break;
                  ui.push(na), Ne++, wt = false;
                }
                return ui.length < Ii && (ui = []), Er.charCodeAt(Ne - 1) === 95 && ii(e2.Diagnostics.Numeric_separators_are_not_allowed_here, Ne - 1, 1), String.fromCharCode.apply(String, ui);
              }
              function Xi(Ii) {
                Ii === void 0 && (Ii = false);
                var Ki = Er.charCodeAt(Ne);
                Ne++;
                for (var Fi = "", ui = Ne; ; ) {
                  if (Ne >= n) {
                    Fi += Er.substring(ui, Ne), yr |= 4, ii(e2.Diagnostics.Unterminated_string_literal);
                    break;
                  }
                  var Bt = Er.charCodeAt(Ne);
                  if (Bt === Ki) {
                    Fi += Er.substring(ui, Ne), Ne++;
                    break;
                  }
                  if (Bt === 92 && !Ii) {
                    Fi += Er.substring(ui, Ne), Fi += Gi(), ui = Ne;
                    continue;
                  }
                  if (y(Bt) && !Ii) {
                    Fi += Er.substring(ui, Ne), yr |= 4, ii(e2.Diagnostics.Unterminated_string_literal);
                    break;
                  }
                  Ne++;
                }
                return Fi;
              }
              function et(Ii) {
                var Ki = Er.charCodeAt(Ne) === 96;
                Ne++;
                for (var Fi = Ne, ui = "", Bt; ; ) {
                  if (Ne >= n) {
                    ui += Er.substring(Fi, Ne), yr |= 4, ii(e2.Diagnostics.Unterminated_template_literal), Bt = Ki ? 14 : 17;
                    break;
                  }
                  var wt = Er.charCodeAt(Ne);
                  if (wt === 96) {
                    ui += Er.substring(Fi, Ne), Ne++, Bt = Ki ? 14 : 17;
                    break;
                  }
                  if (wt === 36 && Ne + 1 < n && Er.charCodeAt(Ne + 1) === 123) {
                    ui += Er.substring(Fi, Ne), Ne += 2, Bt = Ki ? 15 : 16;
                    break;
                  }
                  if (wt === 92) {
                    ui += Er.substring(Fi, Ne), ui += Gi(Ii), Fi = Ne;
                    continue;
                  }
                  if (wt === 13) {
                    ui += Er.substring(Fi, Ne), Ne++, Ne < n && Er.charCodeAt(Ne) === 10 && Ne++, ui += `
`, Fi = Ne;
                    continue;
                  }
                  Ne++;
                }
                return e2.Debug.assert(Bt !== void 0), ur = ui, Bt;
              }
              function Gi(Ii) {
                var Ki = Ne;
                if (Ne++, Ne >= n)
                  return ii(e2.Diagnostics.Unexpected_end_of_text), "";
                var Fi = Er.charCodeAt(Ne);
                switch (Ne++, Fi) {
                  case 48:
                    return Ii && Ne < n && V(Er.charCodeAt(Ne)) ? (Ne++, yr |= 2048, Er.substring(Ki, Ne)) : "\0";
                  case 98:
                    return "\b";
                  case 116:
                    return "	";
                  case 110:
                    return `
`;
                  case 118:
                    return "\v";
                  case 102:
                    return "\f";
                  case 114:
                    return "\r";
                  case 39:
                    return "'";
                  case 34:
                    return '"';
                  case 117:
                    if (Ii) {
                      for (var ui = Ne; ui < Ne + 4; ui++)
                        if (ui < n && !L(Er.charCodeAt(ui)) && Er.charCodeAt(ui) !== 123)
                          return Ne = ui, yr |= 2048, Er.substring(Ki, Ne);
                    }
                    if (Ne < n && Er.charCodeAt(Ne) === 123) {
                      if (Ne++, Ii && !L(Er.charCodeAt(Ne)))
                        return yr |= 2048, Er.substring(Ki, Ne);
                      if (Ii) {
                        var Bt = Ne, wt = Di(1, false), na = wt ? parseInt(wt, 16) : -1;
                        if (!P(na) || Er.charCodeAt(Ne) !== 125)
                          return yr |= 2048, Er.substring(Ki, Ne);
                        Ne = Bt;
                      }
                      return yr |= 8, Zt();
                    }
                    return yr |= 1024, Wt(4);
                  case 120:
                    if (Ii)
                      if (L(Er.charCodeAt(Ne))) {
                        if (!L(Er.charCodeAt(Ne + 1)))
                          return Ne++, yr |= 2048, Er.substring(Ki, Ne);
                      } else
                        return yr |= 2048, Er.substring(Ki, Ne);
                    return Wt(2);
                  case 13:
                    Ne < n && Er.charCodeAt(Ne) === 10 && Ne++;
                  case 10:
                  case 8232:
                  case 8233:
                    return "";
                  default:
                    return String.fromCharCode(Fi);
                }
              }
              function Wt(Ii) {
                var Ki = si(Ii, false);
                return Ki >= 0 ? String.fromCharCode(Ki) : (ii(e2.Diagnostics.Hexadecimal_digit_expected), "");
              }
              function Zt() {
                var Ii = Di(1, false), Ki = Ii ? parseInt(Ii, 16) : -1, Fi = false;
                return Ki < 0 ? (ii(e2.Diagnostics.Hexadecimal_digit_expected), Fi = true) : Ki > 1114111 && (ii(e2.Diagnostics.An_extended_Unicode_escape_value_must_be_between_0x0_and_0x10FFFF_inclusive), Fi = true), Ne >= n ? (ii(e2.Diagnostics.Unexpected_end_of_text), Fi = true) : Er.charCodeAt(Ne) === 125 ? Ne++ : (ii(e2.Diagnostics.Unterminated_Unicode_escape_sequence), Fi = true), Fi ? "" : de(Ki);
              }
              function _r() {
                if (Ne + 5 < n && Er.charCodeAt(Ne + 1) === 117) {
                  var Ii = Ne;
                  Ne += 2;
                  var Ki = si(4, false);
                  return Ne = Ii, Ki;
                }
                return -1;
              }
              function pi() {
                if (ye >= 2 && rr(Er, Ne + 1) === 117 && rr(Er, Ne + 2) === 123) {
                  var Ii = Ne;
                  Ne += 3;
                  var Ki = Di(1, false), Fi = Ki ? parseInt(Ki, 16) : -1;
                  return Ne = Ii, Fi;
                }
                return -1;
              }
              function ae() {
                for (var Ii = "", Ki = Ne; Ne < n; ) {
                  var Fi = rr(Er, Ne);
                  if (ze(Fi, ye))
                    Ne += Ie(Fi);
                  else if (Fi === 92) {
                    if (Fi = pi(), Fi >= 0 && ze(Fi, ye)) {
                      Ne += 3, yr |= 8, Ii += Zt(), Ki = Ne;
                      continue;
                    }
                    if (Fi = _r(), !(Fi >= 0 && ze(Fi, ye)))
                      break;
                    yr |= 1024, Ii += Er.substring(Ki, Ne), Ii += de(Fi), Ne += 6, Ki = Ne;
                  } else
                    break;
                }
                return Ii += Er.substring(Ki, Ne), Ii;
              }
              function Xe() {
                var Ii = ur.length;
                if (Ii >= 2 && Ii <= 12) {
                  var Ki = ur.charCodeAt(0);
                  if (Ki >= 97 && Ki <= 122) {
                    var Fi = B.get(ur);
                    if (Fi !== void 0)
                      return Ge = Fi;
                  }
                }
                return Ge = 79;
              }
              function Jr(Ii) {
                for (var Ki = "", Fi = false, ui = false; ; ) {
                  var Bt = Er.charCodeAt(Ne);
                  if (Bt === 95) {
                    yr |= 512, Fi ? (Fi = false, ui = true) : ii(ui ? e2.Diagnostics.Multiple_consecutive_numeric_separators_are_not_permitted : e2.Diagnostics.Numeric_separators_are_not_allowed_here, Ne, 1), Ne++;
                    continue;
                  }
                  if (Fi = true, !V(Bt) || Bt - 48 >= Ii)
                    break;
                  Ki += Er[Ne], Ne++, ui = false;
                }
                return Er.charCodeAt(Ne - 1) === 95 && ii(e2.Diagnostics.Numeric_separators_are_not_allowed_here, Ne - 1, 1), Ki;
              }
              function ti() {
                if (Er.charCodeAt(Ne) === 110)
                  return ur += "n", yr & 384 && (ur = e2.parsePseudoBigInt(ur) + "n"), Ne++, 9;
                var Ii = yr & 128 ? parseInt(ur.slice(2), 2) : yr & 256 ? parseInt(ur.slice(2), 8) : +ur;
                return ur = "" + Ii, 8;
              }
              function Ze() {
                var Ii;
                lr = Ne, yr = 0;
                for (var Ki = false; ; ) {
                  if (be = Ne, Ne >= n)
                    return Ge = 1;
                  var Fi = rr(Er, Ne);
                  if (Fi === 35 && Ne === 0 && d(Er, Ne)) {
                    if (Ne = D(Er, Ne), Ae)
                      continue;
                    return Ge = 6;
                  }
                  switch (Fi) {
                    case 10:
                    case 13:
                      if (yr |= 1, Ae) {
                        Ne++;
                        continue;
                      } else
                        return Fi === 13 && Ne + 1 < n && Er.charCodeAt(Ne + 1) === 10 ? Ne += 2 : Ne++, Ge = 4;
                    case 9:
                    case 11:
                    case 12:
                    case 32:
                    case 160:
                    case 5760:
                    case 8192:
                    case 8193:
                    case 8194:
                    case 8195:
                    case 8196:
                    case 8197:
                    case 8198:
                    case 8199:
                    case 8200:
                    case 8201:
                    case 8202:
                    case 8203:
                    case 8239:
                    case 8287:
                    case 12288:
                    case 65279:
                      if (Ae) {
                        Ne++;
                        continue;
                      } else {
                        for (; Ne < n && A2(Er.charCodeAt(Ne)); )
                          Ne++;
                        return Ge = 5;
                      }
                    case 33:
                      return Er.charCodeAt(Ne + 1) === 61 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 37) : (Ne += 2, Ge = 35) : (Ne++, Ge = 53);
                    case 34:
                    case 39:
                      return ur = Xi(), Ge = 10;
                    case 96:
                      return Ge = et(false);
                    case 37:
                      return Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 69) : (Ne++, Ge = 44);
                    case 38:
                      return Er.charCodeAt(Ne + 1) === 38 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 76) : (Ne += 2, Ge = 55) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 73) : (Ne++, Ge = 50);
                    case 40:
                      return Ne++, Ge = 20;
                    case 41:
                      return Ne++, Ge = 21;
                    case 42:
                      if (Er.charCodeAt(Ne + 1) === 61)
                        return Ne += 2, Ge = 66;
                      if (Er.charCodeAt(Ne + 1) === 42)
                        return Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 67) : (Ne += 2, Ge = 42);
                      if (Ne++, wr && !Ki && yr & 1) {
                        Ki = true;
                        continue;
                      }
                      return Ge = 41;
                    case 43:
                      return Er.charCodeAt(Ne + 1) === 43 ? (Ne += 2, Ge = 45) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 64) : (Ne++, Ge = 39);
                    case 44:
                      return Ne++, Ge = 27;
                    case 45:
                      return Er.charCodeAt(Ne + 1) === 45 ? (Ne += 2, Ge = 46) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 65) : (Ne++, Ge = 40);
                    case 46:
                      return V(Er.charCodeAt(Ne + 1)) ? (ur = pe().value, Ge = 8) : Er.charCodeAt(Ne + 1) === 46 && Er.charCodeAt(Ne + 2) === 46 ? (Ne += 3, Ge = 25) : (Ne++, Ge = 24);
                    case 47:
                      if (Er.charCodeAt(Ne + 1) === 47) {
                        for (Ne += 2; Ne < n && !y(Er.charCodeAt(Ne)); )
                          Ne++;
                        if (Ir = vr(Ir, Er.slice(be, Ne), oe, be), Ae)
                          continue;
                        return Ge = 2;
                      }
                      if (Er.charCodeAt(Ne + 1) === 42) {
                        Ne += 2, Er.charCodeAt(Ne) === 42 && Er.charCodeAt(Ne + 1) !== 47 && (yr |= 2);
                        for (var ui = false, Bt = be; Ne < n; ) {
                          var wt = Er.charCodeAt(Ne);
                          if (wt === 42 && Er.charCodeAt(Ne + 1) === 47) {
                            Ne += 2, ui = true;
                            break;
                          }
                          Ne++, y(wt) && (Bt = Ne, yr |= 1);
                        }
                        if (Ir = vr(Ir, Er.slice(Bt, Ne), f4, Bt), ui || ii(e2.Diagnostics.Asterisk_Slash_expected), Ae)
                          continue;
                        return ui || (yr |= 4), Ge = 3;
                      }
                      return Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 68) : (Ne++, Ge = 43);
                    case 48:
                      if (Ne + 2 < n && (Er.charCodeAt(Ne + 1) === 88 || Er.charCodeAt(Ne + 1) === 120))
                        return Ne += 2, ur = Di(1, true), ur || (ii(e2.Diagnostics.Hexadecimal_digit_expected), ur = "0"), ur = "0x" + ur, yr |= 64, Ge = ti();
                      if (Ne + 2 < n && (Er.charCodeAt(Ne + 1) === 66 || Er.charCodeAt(Ne + 1) === 98))
                        return Ne += 2, ur = Jr(2), ur || (ii(e2.Diagnostics.Binary_digit_expected), ur = "0"), ur = "0b" + ur, yr |= 128, Ge = ti();
                      if (Ne + 2 < n && (Er.charCodeAt(Ne + 1) === 79 || Er.charCodeAt(Ne + 1) === 111))
                        return Ne += 2, ur = Jr(8), ur || (ii(e2.Diagnostics.Octal_digit_expected), ur = "0"), ur = "0o" + ur, yr |= 256, Ge = ti();
                      if (Ne + 1 < n && k(Er.charCodeAt(Ne + 1)))
                        return ur = "" + qr(), yr |= 32, Ge = 8;
                    case 49:
                    case 50:
                    case 51:
                    case 52:
                    case 53:
                    case 54:
                    case 55:
                    case 56:
                    case 57:
                      return Ii = pe(), Ge = Ii.type, ur = Ii.value, Ge;
                    case 58:
                      return Ne++, Ge = 58;
                    case 59:
                      return Ne++, Ge = 26;
                    case 60:
                      if (H(Er, Ne)) {
                        if (Ne = I(Er, Ne, ii), Ae)
                          continue;
                        return Ge = 7;
                      }
                      return Er.charCodeAt(Ne + 1) === 60 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 70) : (Ne += 2, Ge = 47) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 32) : er === 1 && Er.charCodeAt(Ne + 1) === 47 && Er.charCodeAt(Ne + 2) !== 42 ? (Ne += 2, Ge = 30) : (Ne++, Ge = 29);
                    case 61:
                      if (H(Er, Ne)) {
                        if (Ne = I(Er, Ne, ii), Ae)
                          continue;
                        return Ge = 7;
                      }
                      return Er.charCodeAt(Ne + 1) === 61 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 36) : (Ne += 2, Ge = 34) : Er.charCodeAt(Ne + 1) === 62 ? (Ne += 2, Ge = 38) : (Ne++, Ge = 63);
                    case 62:
                      if (H(Er, Ne)) {
                        if (Ne = I(Er, Ne, ii), Ae)
                          continue;
                        return Ge = 7;
                      }
                      return Ne++, Ge = 31;
                    case 63:
                      return Er.charCodeAt(Ne + 1) === 46 && !V(Er.charCodeAt(Ne + 2)) ? (Ne += 2, Ge = 28) : Er.charCodeAt(Ne + 1) === 63 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 77) : (Ne += 2, Ge = 60) : (Ne++, Ge = 57);
                    case 91:
                      return Ne++, Ge = 22;
                    case 93:
                      return Ne++, Ge = 23;
                    case 94:
                      return Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 78) : (Ne++, Ge = 52);
                    case 123:
                      return Ne++, Ge = 18;
                    case 124:
                      if (H(Er, Ne)) {
                        if (Ne = I(Er, Ne, ii), Ae)
                          continue;
                        return Ge = 7;
                      }
                      return Er.charCodeAt(Ne + 1) === 124 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 75) : (Ne += 2, Ge = 56) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 74) : (Ne++, Ge = 51);
                    case 125:
                      return Ne++, Ge = 19;
                    case 126:
                      return Ne++, Ge = 54;
                    case 64:
                      return Ne++, Ge = 59;
                    case 92:
                      var na = pi();
                      if (na >= 0 && Re(na, ye))
                        return Ne += 3, yr |= 8, ur = Zt() + ae(), Ge = Xe();
                      var Ai = _r();
                      return Ai >= 0 && Re(Ai, ye) ? (Ne += 6, yr |= 1024, ur = String.fromCharCode(Ai) + ae(), Ge = Xe()) : (ii(e2.Diagnostics.Invalid_character), Ne++, Ge = 0);
                    case 35:
                      return Ne !== 0 && Er[Ne + 1] === "!" ? (ii(e2.Diagnostics.can_only_be_used_at_the_start_of_a_file), Ne++, Ge = 0) : (Re(rr(Er, Ne + 1), ye) ? (Ne++, zr(rr(Er, Ne), ye)) : (ur = String.fromCharCode(rr(Er, Ne)), ii(e2.Diagnostics.Invalid_character, Ne++, Ie(Fi))), Ge = 80);
                    default:
                      var Oi = zr(Fi, ye);
                      if (Oi)
                        return Ge = Oi;
                      if (A2(Fi)) {
                        Ne += Ie(Fi);
                        continue;
                      } else if (y(Fi)) {
                        yr |= 1, Ne += Ie(Fi);
                        continue;
                      }
                      var ji = Ie(Fi);
                      return ii(e2.Diagnostics.Invalid_character, Ne, ji), Ne += ji, Ge = 0;
                  }
                }
              }
              function Sr() {
                e2.Debug.assert(Ge === 0, "'reScanInvalidIdentifier' should only be called when the current token is 'SyntaxKind.Unknown'."), Ne = be = lr, yr = 0;
                var Ii = rr(Er, Ne), Ki = zr(Ii, 99);
                return Ki ? Ge = Ki : (Ne += Ie(Ii), Ge);
              }
              function zr(Ii, Ki) {
                var Fi = Ii;
                if (Re(Fi, Ki)) {
                  for (Ne += Ie(Fi); Ne < n && ze(Fi = rr(Er, Ne), Ki); )
                    Ne += Ie(Fi);
                  return ur = Er.substring(be, Ne), Fi === 92 && (ur += ae()), Xe();
                }
              }
              function Wr() {
                if (Ge === 31) {
                  if (Er.charCodeAt(Ne) === 62)
                    return Er.charCodeAt(Ne + 1) === 62 ? Er.charCodeAt(Ne + 2) === 61 ? (Ne += 3, Ge = 72) : (Ne += 2, Ge = 49) : Er.charCodeAt(Ne + 1) === 61 ? (Ne += 2, Ge = 71) : (Ne++, Ge = 48);
                  if (Er.charCodeAt(Ne) === 61)
                    return Ne++, Ge = 33;
                }
                return Ge;
              }
              function Je() {
                return e2.Debug.assert(Ge === 66, "'reScanAsteriskEqualsToken' should only be called on a '*='"), Ne = be + 1, Ge = 63;
              }
              function xe() {
                if (Ge === 43 || Ge === 68) {
                  for (var Ii = be + 1, Ki = false, Fi = false; ; ) {
                    if (Ii >= n) {
                      yr |= 4, ii(e2.Diagnostics.Unterminated_regular_expression_literal);
                      break;
                    }
                    var ui = Er.charCodeAt(Ii);
                    if (y(ui)) {
                      yr |= 4, ii(e2.Diagnostics.Unterminated_regular_expression_literal);
                      break;
                    }
                    if (Ki)
                      Ki = false;
                    else if (ui === 47 && !Fi) {
                      Ii++;
                      break;
                    } else
                      ui === 91 ? Fi = true : ui === 92 ? Ki = true : ui === 93 && (Fi = false);
                    Ii++;
                  }
                  for (; Ii < n && ze(Er.charCodeAt(Ii), ye); )
                    Ii++;
                  Ne = Ii, ur = Er.substring(be, Ne), Ge = 13;
                }
                return Ge;
              }
              function vr(Ii, Ki, Fi, ui) {
                var Bt = mr(e2.trimStringStart(Ki), Fi);
                return Bt === void 0 ? Ii : e2.append(Ii, { range: { pos: ui, end: Ne }, type: Bt });
              }
              function mr(Ii, Ki) {
                var Fi = Ki.exec(Ii);
                if (!!Fi)
                  switch (Fi[1]) {
                    case "ts-expect-error":
                      return 0;
                    case "ts-ignore":
                      return 1;
                  }
              }
              function Ar(Ii) {
                return e2.Debug.assert(Ge === 19, "'reScanTemplateToken' should only be called on a '}'"), Ne = be, Ge = et(Ii);
              }
              function Oe() {
                return Ne = be, Ge = et(true);
              }
              function nr(Ii) {
                return Ii === void 0 && (Ii = true), Ne = be = lr, Ge = fr(Ii);
              }
              function Mr() {
                return Ge === 47 ? (Ne = be + 1, Ge = 29) : Ge;
              }
              function Pe() {
                return Ge === 80 ? (Ne = be + 1, Ge = 62) : Ge;
              }
              function Ue() {
                return e2.Debug.assert(Ge === 60, "'reScanQuestionToken' should only be called on a '??'"), Ne = be + 1, Ge = 57;
              }
              function fr(Ii) {
                if (Ii === void 0 && (Ii = true), lr = be = Ne, Ne >= n)
                  return Ge = 1;
                var Ki = Er.charCodeAt(Ne);
                if (Ki === 60)
                  return Er.charCodeAt(Ne + 1) === 47 ? (Ne += 2, Ge = 30) : (Ne++, Ge = 29);
                if (Ki === 123)
                  return Ne++, Ge = 18;
                for (var Fi = 0; Ne < n && (Ki = Er.charCodeAt(Ne), Ki !== 123); ) {
                  if (Ki === 60) {
                    if (H(Er, Ne))
                      return Ne = I(Er, Ne, ii), Ge = 7;
                    break;
                  }
                  if (Ki === 62 && ii(e2.Diagnostics.Unexpected_token_Did_you_mean_or_gt, Ne, 1), Ki === 125 && ii(e2.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace, Ne, 1), y(Ki) && Fi === 0)
                    Fi = -1;
                  else {
                    if (!Ii && y(Ki) && Fi > 0)
                      break;
                    $(Ki) || (Fi = Ne);
                  }
                  Ne++;
                }
                return ur = Er.substring(lr, Ne), Fi === -1 ? 12 : 11;
              }
              function De() {
                if (C(Ge)) {
                  for (var Ii = false; Ne < n; ) {
                    var Ki = Er.charCodeAt(Ne);
                    if (Ki === 45) {
                      ur += "-", Ne++;
                      continue;
                    } else if (Ki === 58 && !Ii) {
                      ur += ":", Ne++, Ii = true, Ge = 79;
                      continue;
                    }
                    var Fi = Ne;
                    if (ur += ae(), Ne === Fi)
                      break;
                  }
                  return ur.slice(-1) === ":" && (ur = ur.slice(0, -1), Ne--), Xe();
                }
                return Ge;
              }
              function gr() {
                switch (lr = Ne, Er.charCodeAt(Ne)) {
                  case 34:
                  case 39:
                    return ur = Xi(true), Ge = 10;
                  default:
                    return Ze();
                }
              }
              function Vr() {
                return Ne = be = lr, gr();
              }
              function Tr() {
                if (lr = be = Ne, yr = 0, Ne >= n)
                  return Ge = 1;
                var Ii = rr(Er, Ne);
                switch (Ne += Ie(Ii), Ii) {
                  case 9:
                  case 11:
                  case 12:
                  case 32:
                    for (; Ne < n && A2(Er.charCodeAt(Ne)); )
                      Ne++;
                    return Ge = 5;
                  case 64:
                    return Ge = 59;
                  case 13:
                    Er.charCodeAt(Ne) === 10 && Ne++;
                  case 10:
                    return yr |= 1, Ge = 4;
                  case 42:
                    return Ge = 41;
                  case 123:
                    return Ge = 18;
                  case 125:
                    return Ge = 19;
                  case 91:
                    return Ge = 22;
                  case 93:
                    return Ge = 23;
                  case 60:
                    return Ge = 29;
                  case 62:
                    return Ge = 31;
                  case 61:
                    return Ge = 63;
                  case 44:
                    return Ge = 27;
                  case 46:
                    return Ge = 24;
                  case 96:
                    return Ge = 61;
                  case 35:
                    return Ge = 62;
                  case 92:
                    Ne--;
                    var Ki = pi();
                    if (Ki >= 0 && Re(Ki, ye))
                      return Ne += 3, yr |= 8, ur = Zt() + ae(), Ge = Xe();
                    var Fi = _r();
                    return Fi >= 0 && Re(Fi, ye) ? (Ne += 6, yr |= 1024, ur = String.fromCharCode(Fi) + ae(), Ge = Xe()) : (Ne++, Ge = 0);
                }
                if (Re(Ii, ye)) {
                  for (var ui = Ii; Ne < n && ze(ui = rr(Er, Ne), ye) || Er.charCodeAt(Ne) === 45; )
                    Ne += Ie(ui);
                  return ur = Er.substring(be, Ne), ui === 92 && (ur += ae()), Ge = Xe();
                } else
                  return Ge = 0;
              }
              function vi(Ii, Ki) {
                var Fi = Ne, ui = lr, Bt = be, wt = Ge, na = ur, Ai = yr, Oi = Ii();
                return (!Oi || Ki) && (Ne = Fi, lr = ui, be = Bt, Ge = wt, ur = na, yr = Ai), Oi;
              }
              function Ui(Ii, Ki, Fi) {
                var ui = n, Bt = Ne, wt = lr, na = be, Ai = Ge, Oi = ur, ji = yr, Vi = Ir;
                nt(Er, Ii, Ki);
                var at = Fi();
                return n = ui, Ne = Bt, lr = wt, be = na, Ge = Ai, ur = Oi, yr = ji, Ir = Vi, at;
              }
              function Yi(Ii) {
                return vi(Ii, true);
              }
              function Wi(Ii) {
                return vi(Ii, false);
              }
              function ct() {
                return Er;
              }
              function Li() {
                Ir = void 0;
              }
              function nt(Ii, Ki, Fi) {
                Er = Ii || "", n = Fi === void 0 ? Er.length : Ki + Fi, Dt(Ki || 0);
              }
              function Mt(Ii) {
                Cr = Ii;
              }
              function xt(Ii) {
                ye = Ii;
              }
              function ut(Ii) {
                er = Ii;
              }
              function Dt(Ii) {
                e2.Debug.assert(Ii >= 0), Ne = Ii, lr = Ii, be = Ii, Ge = 0, ur = void 0, yr = 0;
              }
              function Rt(Ii) {
                wr += Ii ? 1 : -1;
              }
            }
            e2.createScanner = He;
            var rr = String.prototype.codePointAt ? function(ye, Ae) {
              return ye.codePointAt(Ae);
            } : function(Ae, er) {
              var ir = Ae.length;
              if (!(er < 0 || er >= ir)) {
                var Cr = Ae.charCodeAt(er);
                if (Cr >= 55296 && Cr <= 56319 && ir > er + 1) {
                  var Ye = Ae.charCodeAt(er + 1);
                  if (Ye >= 56320 && Ye <= 57343)
                    return (Cr - 55296) * 1024 + Ye - 56320 + 65536;
                }
                return Cr;
              }
            };
            function Ie(ye) {
              return ye >= 65536 ? 2 : 1;
            }
            function _e(ye) {
              if (e2.Debug.assert(0 <= ye && ye <= 1114111), ye <= 65535)
                return String.fromCharCode(ye);
              var Ae = Math.floor((ye - 65536) / 1024) + 55296, er = (ye - 65536) % 1024 + 56320;
              return String.fromCharCode(Ae, er);
            }
            var we = String.fromCodePoint ? function(ye) {
              return String.fromCodePoint(ye);
            } : _e;
            function de(ye) {
              return we(ye);
            }
            e2.utf16EncodeAsString = de;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(je) {
              return e2.pathIsRelative(je) || e2.isRootedDiskPath(je);
            }
            e2.isExternalModuleNameRelative = a;
            function C(je) {
              return e2.sortAndDeduplicate(je, e2.compareDiagnostics);
            }
            e2.sortAndDeduplicateDiagnostics = C;
            function w(je) {
              switch (e2.getEmitScriptTarget(je)) {
                case 99:
                  return "lib.esnext.full.d.ts";
                case 9:
                  return "lib.es2022.full.d.ts";
                case 8:
                  return "lib.es2021.full.d.ts";
                case 7:
                  return "lib.es2020.full.d.ts";
                case 6:
                  return "lib.es2019.full.d.ts";
                case 5:
                  return "lib.es2018.full.d.ts";
                case 4:
                  return "lib.es2017.full.d.ts";
                case 3:
                  return "lib.es2016.full.d.ts";
                case 2:
                  return "lib.es6.d.ts";
                default:
                  return "lib.d.ts";
              }
            }
            e2.getDefaultLibFileName = w;
            function B(je) {
              return je.start + je.length;
            }
            e2.textSpanEnd = B;
            function E(je) {
              return je.length === 0;
            }
            e2.textSpanIsEmpty = E;
            function Q(je, Hr) {
              return Hr >= je.start && Hr < B(je);
            }
            e2.textSpanContainsPosition = Q;
            function le(je, Hr) {
              return Hr >= je.pos && Hr <= je.end;
            }
            e2.textRangeContainsPositionInclusive = le;
            function N(je, Hr) {
              return Hr.start >= je.start && B(Hr) <= B(je);
            }
            e2.textSpanContainsTextSpan = N;
            function p(je, Hr) {
              return m2(je, Hr) !== void 0;
            }
            e2.textSpanOverlapsWith = p;
            function m2(je, Hr) {
              var pt = K(je, Hr);
              return pt && pt.length === 0 ? void 0 : pt;
            }
            e2.textSpanOverlap = m2;
            function G(je, Hr) {
              return f4(je.start, je.length, Hr.start, Hr.length);
            }
            e2.textSpanIntersectsWithTextSpan = G;
            function oe(je, Hr, pt) {
              return f4(je.start, je.length, Hr, pt);
            }
            e2.textSpanIntersectsWith = oe;
            function f4(je, Hr, pt, Pt) {
              var ga = je + Hr, ua = pt + Pt;
              return pt <= ga && ua >= je;
            }
            e2.decodedTextSpanIntersectsWith = f4;
            function T(je, Hr) {
              return Hr <= B(je) && Hr >= je.start;
            }
            e2.textSpanIntersectsWithPosition = T;
            function K(je, Hr) {
              var pt = Math.max(je.start, Hr.start), Pt = Math.min(B(je), B(Hr));
              return pt <= Pt ? se(pt, Pt) : void 0;
            }
            e2.textSpanIntersection = K;
            function b(je, Hr) {
              if (je < 0)
                throw new Error("start < 0");
              if (Hr < 0)
                throw new Error("length < 0");
              return { start: je, length: Hr };
            }
            e2.createTextSpan = b;
            function se(je, Hr) {
              return b(je, Hr - je);
            }
            e2.createTextSpanFromBounds = se;
            function J(je) {
              return b(je.span.start, je.newLength);
            }
            e2.textChangeRangeNewSpan = J;
            function ie(je) {
              return E(je.span) && je.newLength === 0;
            }
            e2.textChangeRangeIsUnchanged = ie;
            function R(je, Hr) {
              if (Hr < 0)
                throw new Error("newLength < 0");
              return { span: je, newLength: Hr };
            }
            e2.createTextChangeRange = R, e2.unchangedTextChangeRange = R(b(0, 0), 0);
            function q(je) {
              if (je.length === 0)
                return e2.unchangedTextChangeRange;
              if (je.length === 1)
                return je[0];
              for (var Hr = je[0], pt = Hr.span.start, Pt = B(Hr.span), ga = pt + Hr.newLength, ua = 1; ua < je.length; ua++) {
                var Xn = je[ua], jr = pt, fo = Pt, xs = ga, Fo = Xn.span.start, ko = B(Xn.span), Ao = Fo + Xn.newLength;
                pt = Math.min(jr, Fo), Pt = Math.max(fo, fo + (ko - xs)), ga = Math.max(Ao, Ao + (xs - ko));
              }
              return R(se(pt, Pt), ga - pt);
            }
            e2.collapseTextChangeRangesAcrossMultipleVersions = q;
            function O(je) {
              if (je && je.kind === 163) {
                for (var Hr = je; Hr; Hr = Hr.parent)
                  if (Dt(Hr) || na(Hr) || Hr.kind === 258)
                    return Hr;
              }
            }
            e2.getTypeParameterOwner = O;
            function ve(je, Hr) {
              return e2.hasSyntacticModifier(je, 16476) && Hr.kind === 171;
            }
            e2.isParameterPropertyDeclaration = ve;
            function ee(je) {
              return $a(je) ? e2.every(je.elements, he) : false;
            }
            e2.isEmptyBindingPattern = ee;
            function he(je) {
              return e2.isOmittedExpression(je) ? true : ee(je.name);
            }
            e2.isEmptyBindingElement = he;
            function F2(je) {
              for (var Hr = je.parent; e2.isBindingElement(Hr.parent); )
                Hr = Hr.parent.parent;
              return Hr.parent;
            }
            e2.walkUpBindingElementsAndPatterns = F2;
            function x2(je, Hr) {
              e2.isBindingElement(je) && (je = F2(je));
              var pt = Hr(je);
              return je.kind === 254 && (je = je.parent), je && je.kind === 255 && (pt |= Hr(je), je = je.parent), je && je.kind === 237 && (pt |= Hr(je)), pt;
            }
            function X(je) {
              return x2(je, e2.getEffectiveModifierFlags);
            }
            e2.getCombinedModifierFlags = X;
            function $(je) {
              return x2(je, e2.getEffectiveModifierFlagsAlwaysIncludeJSDoc);
            }
            e2.getCombinedNodeFlagsAlwaysIncludeJSDoc = $;
            function A2(je) {
              return x2(je, function(Hr) {
                return Hr.flags;
              });
            }
            e2.getCombinedNodeFlags = A2, e2.supportedLocaleDirectories = ["cs", "de", "es", "fr", "it", "ja", "ko", "pl", "pt-br", "ru", "tr", "zh-cn", "zh-tw"];
            function y(je, Hr, pt) {
              var Pt = je.toLowerCase(), ga = /^([a-z]+)([_\-]([a-z]+))?$/.exec(Pt);
              if (!ga) {
                pt && pt.push(e2.createCompilerDiagnostic(e2.Diagnostics.Locale_must_be_of_the_form_language_or_language_territory_For_example_0_or_1, "en", "ja-jp"));
                return;
              }
              var ua = ga[1], Xn = ga[3];
              e2.contains(e2.supportedLocaleDirectories, Pt) && !jr(ua, Xn, pt) && jr(ua, void 0, pt), e2.setUILocale(je);
              function jr(fo, xs, Fo) {
                var ko = e2.normalizePath(Hr.getExecutingFilePath()), Ao = e2.getDirectoryPath(ko), Ms = e2.combinePaths(Ao, fo);
                if (xs && (Ms = Ms + "-" + xs), Ms = Hr.resolvePath(e2.combinePaths(Ms, "diagnosticMessages.generated.json")), !Hr.fileExists(Ms))
                  return false;
                var Bs = "";
                try {
                  Bs = Hr.readFile(Ms);
                } catch {
                  return Fo && Fo.push(e2.createCompilerDiagnostic(e2.Diagnostics.Unable_to_open_file_0, Ms)), false;
                }
                try {
                  e2.setLocalizedDiagnosticMessages(JSON.parse(Bs));
                } catch {
                  return Fo && Fo.push(e2.createCompilerDiagnostic(e2.Diagnostics.Corrupted_locale_file_0, Ms)), false;
                }
                return true;
              }
            }
            e2.validateLocaleAndSetLanguage = y;
            function V(je, Hr) {
              if (je)
                for (; je.original !== void 0; )
                  je = je.original;
              return !Hr || Hr(je) ? je : void 0;
            }
            e2.getOriginalNode = V;
            function L(je, Hr) {
              for (; je; ) {
                var pt = Hr(je);
                if (pt === "quit")
                  return;
                if (pt)
                  return je;
                je = je.parent;
              }
            }
            e2.findAncestor = L;
            function P(je) {
              return (je.flags & 8) === 0;
            }
            e2.isParseTreeNode = P;
            function k(je, Hr) {
              if (je === void 0 || P(je))
                return je;
              for (je = je.original; je; ) {
                if (P(je))
                  return !Hr || Hr(je) ? je : void 0;
                je = je.original;
              }
            }
            e2.getParseTreeNode = k;
            function Y(je) {
              return je.length >= 2 && je.charCodeAt(0) === 95 && je.charCodeAt(1) === 95 ? "_" + je : je;
            }
            e2.escapeLeadingUnderscores = Y;
            function U(je) {
              var Hr = je;
              return Hr.length >= 3 && Hr.charCodeAt(0) === 95 && Hr.charCodeAt(1) === 95 && Hr.charCodeAt(2) === 95 ? Hr.substr(1) : Hr;
            }
            e2.unescapeLeadingUnderscores = U;
            function j(je) {
              return U(je.escapedText);
            }
            e2.idText = j;
            function H(je) {
              return je.valueDeclaration && Ui(je.valueDeclaration) ? j(je.valueDeclaration.name) : U(je.escapedName);
            }
            e2.symbolName = H;
            function I(je) {
              var Hr = je.parent.parent;
              if (!!Hr) {
                if (Si(Hr))
                  return l(Hr);
                switch (Hr.kind) {
                  case 237:
                    if (Hr.declarationList && Hr.declarationList.declarations[0])
                      return l(Hr.declarationList.declarations[0]);
                    break;
                  case 238:
                    var pt = Hr.expression;
                    switch (pt.kind === 221 && pt.operatorToken.kind === 63 && (pt = pt.left), pt.kind) {
                      case 206:
                        return pt.name;
                      case 207:
                        var Pt = pt.argumentExpression;
                        if (e2.isIdentifier(Pt))
                          return Pt;
                    }
                    break;
                  case 212:
                    return l(Hr.expression);
                  case 250: {
                    if (Si(Hr.statement) || En(Hr.statement))
                      return l(Hr.statement);
                    break;
                  }
                }
              }
            }
            function l(je) {
              var Hr = ne(je);
              return Hr && e2.isIdentifier(Hr) ? Hr : void 0;
            }
            function d(je, Hr) {
              return !!(fe(je) && e2.isIdentifier(je.name) && j(je.name) === j(Hr) || e2.isVariableStatement(je) && e2.some(je.declarationList.declarations, function(pt) {
                return d(pt, Hr);
              }));
            }
            e2.nodeHasName = d;
            function D(je) {
              return je.name || I(je);
            }
            e2.getNameOfJSDocTypedef = D;
            function fe(je) {
              return !!je.name;
            }
            e2.isNamedDeclaration = fe;
            function g(je) {
              switch (je.kind) {
                case 79:
                  return je;
                case 347:
                case 340: {
                  var Hr = je.name;
                  if (Hr.kind === 161)
                    return Hr.right;
                  break;
                }
                case 208:
                case 221: {
                  var pt = je;
                  switch (e2.getAssignmentDeclarationKind(pt)) {
                    case 1:
                    case 4:
                    case 5:
                    case 3:
                      return e2.getElementOrPropertyAccessArgumentExpressionOrName(pt.left);
                    case 7:
                    case 8:
                    case 9:
                      return pt.arguments[1];
                    default:
                      return;
                  }
                }
                case 345:
                  return D(je);
                case 339:
                  return I(je);
                case 271: {
                  var Pt = je.expression;
                  return e2.isIdentifier(Pt) ? Pt : void 0;
                }
                case 207:
                  var ga = je;
                  if (e2.isBindableStaticElementAccessExpression(ga))
                    return ga.argumentExpression;
              }
              return je.name;
            }
            e2.getNonAssignedNameOfDeclaration = g;
            function ne(je) {
              if (je !== void 0)
                return g(je) || (e2.isFunctionExpression(je) || e2.isArrowFunction(je) || e2.isClassExpression(je) ? ue(je) : void 0);
            }
            e2.getNameOfDeclaration = ne;
            function ue(je) {
              if (je.parent) {
                if (e2.isPropertyAssignment(je.parent) || e2.isBindingElement(je.parent))
                  return je.parent.name;
                if (e2.isBinaryExpression(je.parent) && je === je.parent.right) {
                  if (e2.isIdentifier(je.parent.left))
                    return je.parent.left;
                  if (e2.isAccessExpression(je.parent.left))
                    return e2.getElementOrPropertyAccessArgumentExpressionOrName(je.parent.left);
                } else if (e2.isVariableDeclaration(je.parent) && e2.isIdentifier(je.parent.name))
                  return je.parent.name;
              } else
                return;
            }
            e2.getAssignedName = ue;
            function We(je, Hr) {
              if (je.name)
                if (e2.isIdentifier(je.name)) {
                  var pt = je.name.escapedText;
                  return yr(je.parent, Hr).filter(function(ua) {
                    return e2.isJSDocParameterTag(ua) && e2.isIdentifier(ua.name) && ua.name.escapedText === pt;
                  });
                } else {
                  var Pt = je.parent.parameters.indexOf(je);
                  e2.Debug.assert(Pt > -1, "Parameters should always be in their parents' parameter list");
                  var ga = yr(je.parent, Hr).filter(e2.isJSDocParameterTag);
                  if (Pt < ga.length)
                    return [ga[Pt]];
                }
              return e2.emptyArray;
            }
            function Fe(je) {
              return We(je, false);
            }
            e2.getJSDocParameterTags = Fe;
            function Z2(je) {
              return We(je, true);
            }
            e2.getJSDocParameterTagsNoCache = Z2;
            function Be(je, Hr) {
              var pt = je.name.escapedText;
              return yr(je.parent, Hr).filter(function(Pt) {
                return e2.isJSDocTemplateTag(Pt) && Pt.typeParameters.some(function(ga) {
                  return ga.name.escapedText === pt;
                });
              });
            }
            function ge(je) {
              return Be(je, false);
            }
            e2.getJSDocTypeParameterTags = ge;
            function Re(je) {
              return Be(je, true);
            }
            e2.getJSDocTypeParameterTagsNoCache = Re;
            function ze(je) {
              return !!Ur(je, e2.isJSDocParameterTag);
            }
            e2.hasJSDocParameterTags = ze;
            function Ee(je) {
              return Ur(je, e2.isJSDocAugmentsTag);
            }
            e2.getJSDocAugmentsTag = Ee;
            function He(je) {
              return ii(je, e2.isJSDocImplementsTag);
            }
            e2.getJSDocImplementsTags = He;
            function rr(je) {
              return Ur(je, e2.isJSDocClassTag);
            }
            e2.getJSDocClassTag = rr;
            function Ie(je) {
              return Ur(je, e2.isJSDocPublicTag);
            }
            e2.getJSDocPublicTag = Ie;
            function _e(je) {
              return Ur(je, e2.isJSDocPublicTag, true);
            }
            e2.getJSDocPublicTagNoCache = _e;
            function we(je) {
              return Ur(je, e2.isJSDocPrivateTag);
            }
            e2.getJSDocPrivateTag = we;
            function de(je) {
              return Ur(je, e2.isJSDocPrivateTag, true);
            }
            e2.getJSDocPrivateTagNoCache = de;
            function ye(je) {
              return Ur(je, e2.isJSDocProtectedTag);
            }
            e2.getJSDocProtectedTag = ye;
            function Ae(je) {
              return Ur(je, e2.isJSDocProtectedTag, true);
            }
            e2.getJSDocProtectedTagNoCache = Ae;
            function er(je) {
              return Ur(je, e2.isJSDocReadonlyTag);
            }
            e2.getJSDocReadonlyTag = er;
            function ir(je) {
              return Ur(je, e2.isJSDocReadonlyTag, true);
            }
            e2.getJSDocReadonlyTagNoCache = ir;
            function Cr(je) {
              return Ur(je, e2.isJSDocOverrideTag, true);
            }
            e2.getJSDocOverrideTagNoCache = Cr;
            function Ye(je) {
              return Ur(je, e2.isJSDocDeprecatedTag);
            }
            e2.getJSDocDeprecatedTag = Ye;
            function Br(je) {
              return Ur(je, e2.isJSDocDeprecatedTag, true);
            }
            e2.getJSDocDeprecatedTagNoCache = Br;
            function Er(je) {
              return Ur(je, e2.isJSDocEnumTag);
            }
            e2.getJSDocEnumTag = Er;
            function Ne(je) {
              return Ur(je, e2.isJSDocThisTag);
            }
            e2.getJSDocThisTag = Ne;
            function n(je) {
              return Ur(je, e2.isJSDocReturnTag);
            }
            e2.getJSDocReturnTag = n;
            function lr(je) {
              return Ur(je, e2.isJSDocTemplateTag);
            }
            e2.getJSDocTemplateTag = lr;
            function be(je) {
              var Hr = Ur(je, e2.isJSDocTypeTag);
              if (Hr && Hr.typeExpression && Hr.typeExpression.type)
                return Hr;
            }
            e2.getJSDocTypeTag = be;
            function Ge(je) {
              var Hr = Ur(je, e2.isJSDocTypeTag);
              return !Hr && e2.isParameter(je) && (Hr = e2.find(Fe(je), function(pt) {
                return !!pt.typeExpression;
              })), Hr && Hr.typeExpression && Hr.typeExpression.type;
            }
            e2.getJSDocType = Ge;
            function ur(je) {
              var Hr = n(je);
              if (Hr && Hr.typeExpression)
                return Hr.typeExpression.type;
              var pt = be(je);
              if (pt && pt.typeExpression) {
                var Pt = pt.typeExpression.type;
                if (e2.isTypeLiteralNode(Pt)) {
                  var ga = e2.find(Pt.members, e2.isCallSignatureDeclaration);
                  return ga && ga.type;
                }
                if (e2.isFunctionTypeNode(Pt) || e2.isJSDocFunctionType(Pt))
                  return Pt.type;
              }
            }
            e2.getJSDocReturnType = ur;
            function yr(je, Hr) {
              var pt = je.jsDocCache;
              if (pt === void 0 || Hr) {
                var Pt = e2.getJSDocCommentsAndTags(je, Hr);
                e2.Debug.assert(Pt.length < 2 || Pt[0] !== Pt[1]), pt = e2.flatMap(Pt, function(ga) {
                  return e2.isJSDoc(ga) ? ga.tags : ga;
                }), Hr || (je.jsDocCache = pt);
              }
              return pt;
            }
            function Ir(je) {
              return yr(je, false);
            }
            e2.getJSDocTags = Ir;
            function wr(je) {
              return yr(je, true);
            }
            e2.getJSDocTagsNoCache = wr;
            function Ur(je, Hr, pt) {
              return e2.find(yr(je, pt), Hr);
            }
            function ii(je, Hr) {
              return Ir(je).filter(Hr);
            }
            e2.getAllJSDocTags = ii;
            function mi(je, Hr) {
              return Ir(je).filter(function(pt) {
                return pt.kind === Hr;
              });
            }
            e2.getAllJSDocTagsOfKind = mi;
            function pe(je) {
              return typeof je == "string" ? je : je == null ? void 0 : je.map(function(Hr) {
                return Hr.kind === 321 ? Hr.text : or(Hr);
              }).join("");
            }
            e2.getTextOfJSDocComment = pe;
            function or(je) {
              var Hr = je.kind === 324 ? "link" : je.kind === 325 ? "linkcode" : "linkplain", pt = je.name ? e2.entityNameToString(je.name) : "", Pt = je.name && je.text.startsWith("://") ? "" : " ";
              return "{@".concat(Hr, " ").concat(pt).concat(Pt).concat(je.text, "}");
            }
            function qr(je) {
              if (e2.isJSDocSignature(je))
                return e2.emptyArray;
              if (e2.isJSDocTypeAlias(je))
                return e2.Debug.assert(je.parent.kind === 320), e2.flatMap(je.parent.tags, function(Pt) {
                  return e2.isJSDocTemplateTag(Pt) ? Pt.typeParameters : void 0;
                });
              if (je.typeParameters)
                return je.typeParameters;
              if (e2.isInJSFile(je)) {
                var Hr = e2.getJSDocTypeParameterDeclarations(je);
                if (Hr.length)
                  return Hr;
                var pt = Ge(je);
                if (pt && e2.isFunctionTypeNode(pt) && pt.typeParameters)
                  return pt.typeParameters;
              }
              return e2.emptyArray;
            }
            e2.getEffectiveTypeParameterDeclarations = qr;
            function si(je) {
              return je.constraint ? je.constraint : e2.isJSDocTemplateTag(je.parent) && je === je.parent.typeParameters[0] ? je.parent.constraint : void 0;
            }
            e2.getEffectiveConstraintOfTypeParameter = si;
            function Di(je) {
              return je.kind === 79 || je.kind === 80;
            }
            e2.isMemberName = Di;
            function wi(je) {
              return je.kind === 173 || je.kind === 172;
            }
            e2.isGetOrSetAccessorDeclaration = wi;
            function Xi(je) {
              return e2.isPropertyAccessExpression(je) && !!(je.flags & 32);
            }
            e2.isPropertyAccessChain = Xi;
            function et(je) {
              return e2.isElementAccessExpression(je) && !!(je.flags & 32);
            }
            e2.isElementAccessChain = et;
            function Gi(je) {
              return e2.isCallExpression(je) && !!(je.flags & 32);
            }
            e2.isCallChain = Gi;
            function Wt(je) {
              var Hr = je.kind;
              return !!(je.flags & 32) && (Hr === 206 || Hr === 207 || Hr === 208 || Hr === 230);
            }
            e2.isOptionalChain = Wt;
            function Zt(je) {
              return Wt(je) && !e2.isNonNullExpression(je) && !!je.questionDotToken;
            }
            e2.isOptionalChainRoot = Zt;
            function _r(je) {
              return Zt(je.parent) && je.parent.expression === je;
            }
            e2.isExpressionOfOptionalChainRoot = _r;
            function pi(je) {
              return !Wt(je.parent) || Zt(je.parent) || je !== je.parent.expression;
            }
            e2.isOutermostOptionalChain = pi;
            function ae(je) {
              return je.kind === 221 && je.operatorToken.kind === 60;
            }
            e2.isNullishCoalesce = ae;
            function Xe(je) {
              return e2.isTypeReferenceNode(je) && e2.isIdentifier(je.typeName) && je.typeName.escapedText === "const" && !je.typeArguments;
            }
            e2.isConstTypeReference = Xe;
            function Jr(je) {
              return e2.skipOuterExpressions(je, 8);
            }
            e2.skipPartiallyEmittedExpressions = Jr;
            function ti(je) {
              return e2.isNonNullExpression(je) && !!(je.flags & 32);
            }
            e2.isNonNullChain = ti;
            function Ze(je) {
              return je.kind === 246 || je.kind === 245;
            }
            e2.isBreakOrContinueStatement = Ze;
            function Sr(je) {
              return je.kind === 274 || je.kind === 273;
            }
            e2.isNamedExportBindings = Sr;
            function zr(je) {
              switch (je.kind) {
                case 302:
                case 303:
                  return true;
                default:
                  return false;
              }
            }
            e2.isUnparsedTextLike = zr;
            function Wr(je) {
              return zr(je) || je.kind === 300 || je.kind === 304;
            }
            e2.isUnparsedNode = Wr;
            function Je(je) {
              return je.kind === 347 || je.kind === 340;
            }
            e2.isJSDocPropertyLikeTag = Je;
            function xe(je) {
              return vr(je.kind);
            }
            e2.isNode = xe;
            function vr(je) {
              return je >= 161;
            }
            e2.isNodeKind = vr;
            function mr(je) {
              return je >= 0 && je <= 160;
            }
            e2.isTokenKind = mr;
            function Ar(je) {
              return mr(je.kind);
            }
            e2.isToken = Ar;
            function Oe(je) {
              return je.hasOwnProperty("pos") && je.hasOwnProperty("end");
            }
            e2.isNodeArray = Oe;
            function nr(je) {
              return 8 <= je && je <= 14;
            }
            e2.isLiteralKind = nr;
            function Mr(je) {
              return nr(je.kind);
            }
            e2.isLiteralExpression = Mr;
            function Pe(je) {
              return 14 <= je && je <= 17;
            }
            e2.isTemplateLiteralKind = Pe;
            function Ue(je) {
              return Pe(je.kind);
            }
            e2.isTemplateLiteralToken = Ue;
            function fr(je) {
              var Hr = je.kind;
              return Hr === 16 || Hr === 17;
            }
            e2.isTemplateMiddleOrTemplateTail = fr;
            function De(je) {
              return e2.isImportSpecifier(je) || e2.isExportSpecifier(je);
            }
            e2.isImportOrExportSpecifier = De;
            function gr(je) {
              switch (je.kind) {
                case 270:
                case 275:
                  return je.isTypeOnly || je.parent.parent.isTypeOnly;
                case 268:
                  return je.parent.isTypeOnly;
                case 267:
                case 265:
                  return je.isTypeOnly;
                default:
                  return false;
              }
            }
            e2.isTypeOnlyImportOrExportDeclaration = gr;
            function Vr(je) {
              return e2.isStringLiteral(je) || e2.isIdentifier(je);
            }
            e2.isAssertionKey = Vr;
            function Tr(je) {
              return je.kind === 10 || Pe(je.kind);
            }
            e2.isStringTextContainingNode = Tr;
            function vi(je) {
              return e2.isIdentifier(je) && (je.autoGenerateFlags & 7) > 0;
            }
            e2.isGeneratedIdentifier = vi;
            function Ui(je) {
              return (e2.isPropertyDeclaration(je) || Oi(je)) && e2.isPrivateIdentifier(je.name);
            }
            e2.isPrivateIdentifierClassElementDeclaration = Ui;
            function Yi(je) {
              return e2.isPropertyAccessExpression(je) && e2.isPrivateIdentifier(je.name);
            }
            e2.isPrivateIdentifierPropertyAccessExpression = Yi;
            function Wi(je) {
              switch (je) {
                case 126:
                case 131:
                case 85:
                case 135:
                case 88:
                case 93:
                case 101:
                case 123:
                case 121:
                case 122:
                case 145:
                case 124:
                case 144:
                case 159:
                  return true;
              }
              return false;
            }
            e2.isModifierKind = Wi;
            function ct(je) {
              return !!(e2.modifierToFlag(je) & 16476);
            }
            e2.isParameterPropertyModifier = ct;
            function Li(je) {
              return ct(je) || je === 124 || je === 159;
            }
            e2.isClassMemberModifier = Li;
            function nt(je) {
              return Wi(je.kind);
            }
            e2.isModifier = nt;
            function Mt(je) {
              var Hr = je.kind;
              return Hr === 161 || Hr === 79;
            }
            e2.isEntityName = Mt;
            function xt(je) {
              var Hr = je.kind;
              return Hr === 79 || Hr === 80 || Hr === 10 || Hr === 8 || Hr === 162;
            }
            e2.isPropertyName = xt;
            function ut(je) {
              var Hr = je.kind;
              return Hr === 79 || Hr === 201 || Hr === 202;
            }
            e2.isBindingName = ut;
            function Dt(je) {
              return !!je && ui(je.kind);
            }
            e2.isFunctionLike = Dt;
            function Rt(je) {
              return !!je && (ui(je.kind) || e2.isClassStaticBlockDeclaration(je));
            }
            e2.isFunctionLikeOrClassStaticBlockDeclaration = Rt;
            function Ii(je) {
              return je && Fi(je.kind);
            }
            e2.isFunctionLikeDeclaration = Ii;
            function Ki(je) {
              return je.kind === 110 || je.kind === 95;
            }
            e2.isBooleanLiteral = Ki;
            function Fi(je) {
              switch (je) {
                case 256:
                case 169:
                case 171:
                case 172:
                case 173:
                case 213:
                case 214:
                  return true;
                default:
                  return false;
              }
            }
            function ui(je) {
              switch (je) {
                case 168:
                case 174:
                case 323:
                case 175:
                case 176:
                case 179:
                case 317:
                case 180:
                  return true;
                default:
                  return Fi(je);
              }
            }
            e2.isFunctionLikeKind = ui;
            function Bt(je) {
              return e2.isSourceFile(je) || e2.isModuleBlock(je) || e2.isBlock(je) && Dt(je.parent);
            }
            e2.isFunctionOrModuleBlock = Bt;
            function wt(je) {
              var Hr = je.kind;
              return Hr === 171 || Hr === 167 || Hr === 169 || Hr === 172 || Hr === 173 || Hr === 176 || Hr === 170 || Hr === 234;
            }
            e2.isClassElement = wt;
            function na(je) {
              return je && (je.kind === 257 || je.kind === 226);
            }
            e2.isClassLike = na;
            function Ai(je) {
              return je && (je.kind === 172 || je.kind === 173);
            }
            e2.isAccessor = Ai;
            function Oi(je) {
              switch (je.kind) {
                case 169:
                case 172:
                case 173:
                  return true;
                default:
                  return false;
              }
            }
            e2.isMethodOrAccessor = Oi;
            function ji(je) {
              var Hr = je.kind;
              return Hr === 175 || Hr === 174 || Hr === 166 || Hr === 168 || Hr === 176 || Hr === 172 || Hr === 173;
            }
            e2.isTypeElement = ji;
            function Vi(je) {
              return ji(je) || wt(je);
            }
            e2.isClassOrTypeElement = Vi;
            function at(je) {
              var Hr = je.kind;
              return Hr === 296 || Hr === 297 || Hr === 298 || Hr === 169 || Hr === 172 || Hr === 173;
            }
            e2.isObjectLiteralElementLike = at;
            function At(je) {
              return e2.isTypeNodeKind(je.kind);
            }
            e2.isTypeNode = At;
            function ba(je) {
              switch (je.kind) {
                case 179:
                case 180:
                  return true;
              }
              return false;
            }
            e2.isFunctionOrConstructorTypeNode = ba;
            function $a(je) {
              if (je) {
                var Hr = je.kind;
                return Hr === 202 || Hr === 201;
              }
              return false;
            }
            e2.isBindingPattern = $a;
            function Qa(je) {
              var Hr = je.kind;
              return Hr === 204 || Hr === 205;
            }
            e2.isAssignmentPattern = Qa;
            function ai(je) {
              var Hr = je.kind;
              return Hr === 203 || Hr === 227;
            }
            e2.isArrayBindingElement = ai;
            function Dn(je) {
              switch (je.kind) {
                case 254:
                case 164:
                case 203:
                  return true;
              }
              return false;
            }
            e2.isDeclarationBindingElement = Dn;
            function ka(je) {
              return Ba(je) || Cn(je);
            }
            e2.isBindingOrAssignmentPattern = ka;
            function Ba(je) {
              switch (je.kind) {
                case 201:
                case 205:
                  return true;
              }
              return false;
            }
            e2.isObjectBindingOrAssignmentPattern = Ba;
            function pn(je) {
              switch (je.kind) {
                case 203:
                case 296:
                case 297:
                case 298:
                  return true;
              }
              return false;
            }
            e2.isObjectBindingOrAssignmentElement = pn;
            function Cn(je) {
              switch (je.kind) {
                case 202:
                case 204:
                  return true;
              }
              return false;
            }
            e2.isArrayBindingOrAssignmentPattern = Cn;
            function Bi(je) {
              var Hr = je.kind;
              return Hr === 206 || Hr === 161 || Hr === 200;
            }
            e2.isPropertyAccessOrQualifiedNameOrImportTypeNode = Bi;
            function kn(je) {
              var Hr = je.kind;
              return Hr === 206 || Hr === 161;
            }
            e2.isPropertyAccessOrQualifiedName = kn;
            function xn(je) {
              switch (je.kind) {
                case 280:
                case 279:
                case 208:
                case 209:
                case 210:
                case 165:
                  return true;
                default:
                  return false;
              }
            }
            e2.isCallLikeExpression = xn;
            function Kn(je) {
              return je.kind === 208 || je.kind === 209;
            }
            e2.isCallOrNewExpression = Kn;
            function Pn(je) {
              var Hr = je.kind;
              return Hr === 223 || Hr === 14;
            }
            e2.isTemplateLiteral = Pn;
            function eo(je) {
              return Rn(Jr(je).kind);
            }
            e2.isLeftHandSideExpression = eo;
            function Rn(je) {
              switch (je) {
                case 206:
                case 207:
                case 209:
                case 208:
                case 278:
                case 279:
                case 282:
                case 210:
                case 204:
                case 212:
                case 205:
                case 226:
                case 213:
                case 79:
                case 80:
                case 13:
                case 8:
                case 9:
                case 10:
                case 14:
                case 223:
                case 95:
                case 104:
                case 108:
                case 110:
                case 106:
                case 230:
                case 228:
                case 231:
                case 100:
                  return true;
                default:
                  return false;
              }
            }
            function Da(je) {
              return bo(Jr(je).kind);
            }
            e2.isUnaryExpression = Da;
            function bo(je) {
              switch (je) {
                case 219:
                case 220:
                case 215:
                case 216:
                case 217:
                case 218:
                case 211:
                  return true;
                default:
                  return Rn(je);
              }
            }
            function Ro(je) {
              switch (je.kind) {
                case 220:
                  return true;
                case 219:
                  return je.operator === 45 || je.operator === 46;
                default:
                  return false;
              }
            }
            e2.isUnaryExpressionWithWrite = Ro;
            function En(je) {
              return Wn(Jr(je).kind);
            }
            e2.isExpression = En;
            function Wn(je) {
              switch (je) {
                case 222:
                case 224:
                case 214:
                case 221:
                case 225:
                case 229:
                case 227:
                case 351:
                case 350:
                  return true;
                default:
                  return bo(je);
              }
            }
            function to(je) {
              var Hr = je.kind;
              return Hr === 211 || Hr === 229;
            }
            e2.isAssertionExpression = to;
            function Co(je) {
              return e2.isNotEmittedStatement(je) || e2.isPartiallyEmittedExpression(je);
            }
            e2.isNotEmittedOrPartiallyEmittedNode = Co;
            function Ko(je, Hr) {
              switch (je.kind) {
                case 242:
                case 243:
                case 244:
                case 240:
                case 241:
                  return true;
                case 250:
                  return Hr && Ko(je.statement, Hr);
              }
              return false;
            }
            e2.isIterationStatement = Ko;
            function Oo(je) {
              return e2.isExportAssignment(je) || e2.isExportDeclaration(je);
            }
            e2.isScopeMarker = Oo;
            function no(je) {
              return e2.some(je, Oo);
            }
            e2.hasScopeMarker = no;
            function $o(je) {
              return !e2.isAnyImportOrReExport(je) && !e2.isExportAssignment(je) && !e2.hasSyntacticModifier(je, 1) && !e2.isAmbientModule(je);
            }
            e2.needsScopeMarker = $o;
            function Pr(je) {
              return e2.isAnyImportOrReExport(je) || e2.isExportAssignment(je) || e2.hasSyntacticModifier(je, 1);
            }
            e2.isExternalModuleIndicator = Pr;
            function xi(je) {
              return je.kind === 243 || je.kind === 244;
            }
            e2.isForInOrOfStatement = xi;
            function St(je) {
              return e2.isBlock(je) || En(je);
            }
            e2.isConciseBody = St;
            function pa(je) {
              return e2.isBlock(je);
            }
            e2.isFunctionBody = pa;
            function dn(je) {
              return e2.isVariableDeclarationList(je) || En(je);
            }
            e2.isForInitializer = dn;
            function Jn(je) {
              var Hr = je.kind;
              return Hr === 262 || Hr === 261 || Hr === 79;
            }
            e2.isModuleBody = Jn;
            function Qe(je) {
              var Hr = je.kind;
              return Hr === 262 || Hr === 261;
            }
            e2.isNamespaceBody = Qe;
            function Gr(je) {
              var Hr = je.kind;
              return Hr === 79 || Hr === 261;
            }
            e2.isJSDocNamespaceBody = Gr;
            function S2(je) {
              var Hr = je.kind;
              return Hr === 269 || Hr === 268;
            }
            e2.isNamedImportBindings = S2;
            function Ce(je) {
              return je.kind === 261 || je.kind === 260;
            }
            e2.isModuleOrEnumDeclaration = Ce;
            function qe(je) {
              return je === 214 || je === 203 || je === 257 || je === 226 || je === 170 || je === 171 || je === 260 || je === 299 || je === 275 || je === 256 || je === 213 || je === 172 || je === 267 || je === 265 || je === 270 || je === 258 || je === 285 || je === 169 || je === 168 || je === 261 || je === 264 || je === 268 || je === 274 || je === 164 || je === 296 || je === 167 || je === 166 || je === 173 || je === 297 || je === 259 || je === 163 || je === 254 || je === 345 || je === 338 || je === 347;
            }
            function br(je) {
              return je === 256 || je === 276 || je === 257 || je === 258 || je === 259 || je === 260 || je === 261 || je === 266 || je === 265 || je === 272 || je === 271 || je === 264;
            }
            function Zr(je) {
              return je === 246 || je === 245 || je === 253 || je === 240 || je === 238 || je === 236 || je === 243 || je === 244 || je === 242 || je === 239 || je === 250 || je === 247 || je === 249 || je === 251 || je === 252 || je === 237 || je === 241 || je === 248 || je === 349 || je === 353 || je === 352;
            }
            function Si(je) {
              return je.kind === 163 ? je.parent && je.parent.kind !== 344 || e2.isInJSFile(je) : qe(je.kind);
            }
            e2.isDeclaration = Si;
            function Pi(je) {
              return br(je.kind);
            }
            e2.isDeclarationStatement = Pi;
            function Qi(je) {
              return Zr(je.kind);
            }
            e2.isStatementButNotDeclaration = Qi;
            function Ct(je) {
              var Hr = je.kind;
              return Zr(Hr) || br(Hr) || sa(je);
            }
            e2.isStatement = Ct;
            function sa(je) {
              return je.kind !== 235 || je.parent !== void 0 && (je.parent.kind === 252 || je.parent.kind === 292) ? false : !e2.isFunctionBlock(je);
            }
            function en(je) {
              var Hr = je.kind;
              return Zr(Hr) || br(Hr) || Hr === 235;
            }
            e2.isStatementOrBlock = en;
            function Wa(je) {
              var Hr = je.kind;
              return Hr === 277 || Hr === 161 || Hr === 79;
            }
            e2.isModuleReference = Wa;
            function qn(je) {
              var Hr = je.kind;
              return Hr === 108 || Hr === 79 || Hr === 206;
            }
            e2.isJsxTagNameExpression = qn;
            function mo(je) {
              var Hr = je.kind;
              return Hr === 278 || Hr === 288 || Hr === 279 || Hr === 11 || Hr === 282;
            }
            e2.isJsxChild = mo;
            function So(je) {
              var Hr = je.kind;
              return Hr === 285 || Hr === 287;
            }
            e2.isJsxAttributeLike = So;
            function Go(je) {
              var Hr = je.kind;
              return Hr === 10 || Hr === 288;
            }
            e2.isStringLiteralOrJsxExpression = Go;
            function ys(je) {
              var Hr = je.kind;
              return Hr === 280 || Hr === 279;
            }
            e2.isJsxOpeningLikeElement = ys;
            function Pc(je) {
              var Hr = je.kind;
              return Hr === 289 || Hr === 290;
            }
            e2.isCaseOrDefaultClause = Pc;
            function Vc(je) {
              return je.kind >= 309 && je.kind <= 347;
            }
            e2.isJSDocNode = Vc;
            function Kc(je) {
              return je.kind === 320 || je.kind === 319 || je.kind === 321 || qi(je) || Xs(je) || e2.isJSDocTypeLiteral(je) || e2.isJSDocSignature(je);
            }
            e2.isJSDocCommentContainingNode = Kc;
            function Xs(je) {
              return je.kind >= 327 && je.kind <= 347;
            }
            e2.isJSDocTag = Xs;
            function pc(je) {
              return je.kind === 173;
            }
            e2.isSetAccessor = pc;
            function hs(je) {
              return je.kind === 172;
            }
            e2.isGetAccessor = hs;
            function tc(je) {
              var Hr = je.jsDoc;
              return !!Hr && Hr.length > 0;
            }
            e2.hasJSDocNodes = tc;
            function ps(je) {
              return !!je.type;
            }
            e2.hasType = ps;
            function Qs(je) {
              return !!je.initializer;
            }
            e2.hasInitializer = Qs;
            function js(je) {
              switch (je.kind) {
                case 254:
                case 164:
                case 203:
                case 166:
                case 167:
                case 296:
                case 299:
                  return true;
                default:
                  return false;
              }
            }
            e2.hasOnlyExpressionInitializer = js;
            function ds(je) {
              return je.kind === 285 || je.kind === 287 || at(je);
            }
            e2.isObjectLiteralElement = ds;
            function Ji(je) {
              return je.kind === 178 || je.kind === 228;
            }
            e2.isTypeReferenceType = Ji;
            var ce = 1073741823;
            function Rr(je) {
              for (var Hr = ce, pt = 0, Pt = je; pt < Pt.length; pt++) {
                var ga = Pt[pt];
                if (!!ga.length) {
                  for (var ua = 0; ua < ga.length && ua < Hr && e2.isWhiteSpaceLike(ga.charCodeAt(ua)); ua++)
                    ;
                  if (ua < Hr && (Hr = ua), Hr === 0)
                    return 0;
                }
              }
              return Hr === ce ? void 0 : Hr;
            }
            e2.guessIndentation = Rr;
            function yi(je) {
              return je.kind === 10 || je.kind === 14;
            }
            e2.isStringLiteralLike = yi;
            function qi(je) {
              return je.kind === 324 || je.kind === 325 || je.kind === 326;
            }
            e2.isJSDocLinkLike = qi;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            e2.resolvingEmptyArray = [], e2.externalHelpersModuleNameText = "tslib", e2.defaultMaximumTruncationLength = 160, e2.noTruncationMaximumTruncationLength = 1e6;
            function a(c, te) {
              var xr = c.declarations;
              if (xr)
                for (var ei = 0, bi = xr; ei < bi.length; ei++) {
                  var Ft = bi[ei];
                  if (Ft.kind === te)
                    return Ft;
                }
            }
            e2.getDeclarationOfKind = a;
            function C(c, te) {
              return e2.filter(c.declarations || e2.emptyArray, function(xr) {
                return xr.kind === te;
              });
            }
            e2.getDeclarationsOfKind = C;
            function w(c) {
              var te = new e2.Map();
              if (c)
                for (var xr = 0, ei = c; xr < ei.length; xr++) {
                  var bi = ei[xr];
                  te.set(bi.escapedName, bi);
                }
              return te;
            }
            e2.createSymbolTable = w;
            function B(c) {
              return (c.flags & 33554432) !== 0;
            }
            e2.isTransientSymbol = B;
            var E = Q();
            function Q() {
              var c = "", te = function(xr) {
                return c += xr;
              };
              return { getText: function() {
                return c;
              }, write: te, rawWrite: te, writeKeyword: te, writeOperator: te, writePunctuation: te, writeSpace: te, writeStringLiteral: te, writeLiteral: te, writeParameter: te, writeProperty: te, writeSymbol: function(xr, ei) {
                return te(xr);
              }, writeTrailingSemicolon: te, writeComment: te, getTextPos: function() {
                return c.length;
              }, getLine: function() {
                return 0;
              }, getColumn: function() {
                return 0;
              }, getIndent: function() {
                return 0;
              }, isAtStartOfLine: function() {
                return false;
              }, hasTrailingComment: function() {
                return false;
              }, hasTrailingWhitespace: function() {
                return !!c.length && e2.isWhiteSpaceLike(c.charCodeAt(c.length - 1));
              }, writeLine: function() {
                return c += " ";
              }, increaseIndent: e2.noop, decreaseIndent: e2.noop, clear: function() {
                return c = "";
              }, trackSymbol: function() {
                return false;
              }, reportInaccessibleThisError: e2.noop, reportInaccessibleUniqueSymbolError: e2.noop, reportPrivateInBaseOfClassExpression: e2.noop };
            }
            function le(c, te) {
              return c.configFilePath !== te.configFilePath || N(c, te);
            }
            e2.changesAffectModuleResolution = le;
            function N(c, te) {
              return m2(c, te, e2.moduleResolutionOptionDeclarations);
            }
            e2.optionsHaveModuleResolutionChanges = N;
            function p(c, te) {
              return m2(c, te, e2.optionsAffectingProgramStructure);
            }
            e2.changesAffectingProgramStructure = p;
            function m2(c, te, xr) {
              return c !== te && xr.some(function(ei) {
                return !uo(Bm(c, ei), Bm(te, ei));
              });
            }
            e2.optionsHaveChanges = m2;
            function G(c, te) {
              for (; ; ) {
                var xr = te(c);
                if (xr === "quit")
                  return;
                if (xr !== void 0)
                  return xr;
                if (e2.isSourceFile(c))
                  return;
                c = c.parent;
              }
            }
            e2.forEachAncestor = G;
            function oe(c, te) {
              for (var xr = c.entries(), ei = xr.next(); !ei.done; ei = xr.next()) {
                var bi = ei.value, Ft = bi[0], ot = bi[1], xa = te(ot, Ft);
                if (xa)
                  return xa;
              }
            }
            e2.forEachEntry = oe;
            function f4(c, te) {
              for (var xr = c.keys(), ei = xr.next(); !ei.done; ei = xr.next()) {
                var bi = te(ei.value);
                if (bi)
                  return bi;
              }
            }
            e2.forEachKey = f4;
            function T(c, te) {
              c.forEach(function(xr, ei) {
                te.set(ei, xr);
              });
            }
            e2.copyEntries = T;
            function K(c) {
              var te = E.getText();
              try {
                return c(E), E.getText();
              } finally {
                E.clear(), E.writeKeyword(te);
              }
            }
            e2.usingSingleLineStringWriter = K;
            function b(c) {
              return c.end - c.pos;
            }
            e2.getFullWidth = b;
            function se(c, te, xr) {
              return c && c.resolvedModules && c.resolvedModules.get(te, xr);
            }
            e2.getResolvedModule = se;
            function J(c, te, xr, ei) {
              c.resolvedModules || (c.resolvedModules = e2.createModeAwareCache()), c.resolvedModules.set(te, ei, xr);
            }
            e2.setResolvedModule = J;
            function ie(c, te, xr) {
              c.resolvedTypeReferenceDirectiveNames || (c.resolvedTypeReferenceDirectiveNames = e2.createModeAwareCache()), c.resolvedTypeReferenceDirectiveNames.set(te, void 0, xr);
            }
            e2.setResolvedTypeReferenceDirective = ie;
            function R(c, te) {
              return c.path === te.path && !c.prepend == !te.prepend && !c.circular == !te.circular;
            }
            e2.projectReferenceIsEqualTo = R;
            function q(c, te) {
              return c.isExternalLibraryImport === te.isExternalLibraryImport && c.extension === te.extension && c.resolvedFileName === te.resolvedFileName && c.originalPath === te.originalPath && O(c.packageId, te.packageId);
            }
            e2.moduleResolutionIsEqualTo = q;
            function O(c, te) {
              return c === te || !!c && !!te && c.name === te.name && c.subModuleName === te.subModuleName && c.version === te.version;
            }
            function ve(c) {
              var te = c.name, xr = c.subModuleName;
              return xr ? "".concat(te, "/").concat(xr) : te;
            }
            e2.packageIdToPackageName = ve;
            function ee(c) {
              return "".concat(ve(c), "@").concat(c.version);
            }
            e2.packageIdToString = ee;
            function he(c, te) {
              return c.resolvedFileName === te.resolvedFileName && c.primary === te.primary && c.originalPath === te.originalPath;
            }
            e2.typeDirectiveIsEqualTo = he;
            function F2(c, te, xr, ei, bi) {
              e2.Debug.assert(c.length === te.length);
              for (var Ft = 0; Ft < c.length; Ft++) {
                var ot = te[Ft], xa = c[Ft], mn = e2.isString(xa) ? xa : xa.fileName.toLowerCase(), an = e2.isString(xa) ? ei && e2.getModeForResolutionAtIndex(ei, Ft) : e2.getModeForFileReference(xa, ei == null ? void 0 : ei.impliedNodeFormat), To = xr && xr.get(mn, an), Hn = To ? !ot || !bi(To, ot) : ot;
                if (Hn)
                  return true;
              }
              return false;
            }
            e2.hasChangesInResolutions = F2;
            function x2(c) {
              return X(c), (c.flags & 524288) !== 0;
            }
            e2.containsParseError = x2;
            function X(c) {
              if (!(c.flags & 1048576)) {
                var te = (c.flags & 131072) !== 0 || e2.forEachChild(c, x2);
                te && (c.flags |= 524288), c.flags |= 1048576;
              }
            }
            function $(c) {
              for (; c && c.kind !== 305; )
                c = c.parent;
              return c;
            }
            e2.getSourceFileOfNode = $;
            function A2(c) {
              return $(c.valueDeclaration || Ir(c));
            }
            e2.getSourceFileOfModule = A2;
            function y(c, te) {
              return !!c && (c.scriptKind === 1 || c.scriptKind === 2) && !c.checkJsDirective && te === void 0;
            }
            e2.isPlainJsFile = y;
            function V(c) {
              switch (c.kind) {
                case 235:
                case 263:
                case 242:
                case 243:
                case 244:
                  return true;
              }
              return false;
            }
            e2.isStatementWithLocals = V;
            function L(c, te) {
              return e2.Debug.assert(c >= 0), e2.getLineStarts(te)[c];
            }
            e2.getStartPositionOfLine = L;
            function P(c) {
              var te = $(c), xr = e2.getLineAndCharacterOfPosition(te, c.pos);
              return "".concat(te.fileName, "(").concat(xr.line + 1, ",").concat(xr.character + 1, ")");
            }
            e2.nodePosToString = P;
            function k(c, te) {
              e2.Debug.assert(c >= 0);
              var xr = e2.getLineStarts(te), ei = c, bi = te.text;
              if (ei + 1 === xr.length)
                return bi.length - 1;
              var Ft = xr[ei], ot = xr[ei + 1] - 1;
              for (e2.Debug.assert(e2.isLineBreak(bi.charCodeAt(ot))); Ft <= ot && e2.isLineBreak(bi.charCodeAt(ot)); )
                ot--;
              return ot;
            }
            e2.getEndLinePosition = k;
            function Y(c, te, xr) {
              return !(xr && xr(te)) && !c.identifiers.has(te);
            }
            e2.isFileLevelUniqueName = Y;
            function U(c) {
              return c === void 0 ? true : c.pos === c.end && c.pos >= 0 && c.kind !== 1;
            }
            e2.nodeIsMissing = U;
            function j(c) {
              return !U(c);
            }
            e2.nodeIsPresent = j;
            function H(c, te, xr) {
              if (te === void 0 || te.length === 0)
                return c;
              for (var ei = 0; ei < c.length && xr(c[ei]); ++ei)
                ;
              return c.splice.apply(c, Ve([ei, 0], te, false)), c;
            }
            function I(c, te, xr) {
              if (te === void 0)
                return c;
              for (var ei = 0; ei < c.length && xr(c[ei]); ++ei)
                ;
              return c.splice(ei, 0, te), c;
            }
            function l(c) {
              return Ui(c) || !!(Ie(c) & 1048576);
            }
            function d(c, te) {
              return H(c, te, Ui);
            }
            e2.insertStatementsAfterStandardPrologue = d;
            function D(c, te) {
              return H(c, te, l);
            }
            e2.insertStatementsAfterCustomPrologue = D;
            function fe(c, te) {
              return I(c, te, Ui);
            }
            e2.insertStatementAfterStandardPrologue = fe;
            function g(c, te) {
              return I(c, te, l);
            }
            e2.insertStatementAfterCustomPrologue = g;
            function ne(c, te, xr) {
              if (c.charCodeAt(te + 1) === 47 && te + 2 < xr && c.charCodeAt(te + 2) === 47) {
                var ei = c.substring(te, xr);
                return !!(e2.fullTripleSlashReferencePathRegEx.test(ei) || e2.fullTripleSlashAMDReferencePathRegEx.test(ei) || xt.test(ei) || ut.test(ei));
              }
              return false;
            }
            e2.isRecognizedTripleSlashComment = ne;
            function ue(c, te) {
              return c.charCodeAt(te + 1) === 42 && c.charCodeAt(te + 2) === 33;
            }
            e2.isPinnedComment = ue;
            function We(c, te) {
              var xr = new e2.Map(te.map(function(ot) {
                return ["".concat(e2.getLineAndCharacterOfPosition(c, ot.range.end).line), ot];
              })), ei = new e2.Map();
              return { getUnusedExpectations: bi, markUsed: Ft };
              function bi() {
                return e2.arrayFrom(xr.entries()).filter(function(ot) {
                  var xa = ot[0], mn = ot[1];
                  return mn.type === 0 && !ei.get(xa);
                }).map(function(ot) {
                  var xa = ot[0], mn = ot[1];
                  return mn;
                });
              }
              function Ft(ot) {
                return xr.has("".concat(ot)) ? (ei.set("".concat(ot), true), true) : false;
              }
            }
            e2.createCommentDirectivesMap = We;
            function Fe(c, te, xr) {
              return U(c) ? c.pos : e2.isJSDocNode(c) || c.kind === 11 ? e2.skipTrivia((te || $(c)).text, c.pos, false, true) : xr && e2.hasJSDocNodes(c) ? Fe(c.jsDoc[0], te) : c.kind === 348 && c._children.length > 0 ? Fe(c._children[0], te, xr) : e2.skipTrivia((te || $(c)).text, c.pos, false, false, Wa(c));
            }
            e2.getTokenPosOfNode = Fe;
            function Z2(c, te) {
              return U(c) || !c.decorators ? Fe(c, te) : e2.skipTrivia((te || $(c)).text, c.decorators.end);
            }
            e2.getNonDecoratorTokenPosOfNode = Z2;
            function Be(c, te, xr) {
              return xr === void 0 && (xr = false), ze(c.text, te, xr);
            }
            e2.getSourceTextOfNodeFromSourceFile = Be;
            function ge(c) {
              return !!e2.findAncestor(c, e2.isJSDocTypeExpression);
            }
            function Re(c) {
              return !!(e2.isExportDeclaration(c) && c.exportClause && e2.isNamespaceExport(c.exportClause) && c.exportClause.name.escapedText === "default");
            }
            e2.isExportNamespaceAsDefaultDeclaration = Re;
            function ze(c, te, xr) {
              if (xr === void 0 && (xr = false), U(te))
                return "";
              var ei = c.substring(xr ? te.pos : e2.skipTrivia(c, te.pos), te.end);
              return ge(te) && (ei = ei.split(/\r\n|\n|\r/).map(function(bi) {
                return e2.trimStringStart(bi.replace(/^\s*\*/, ""));
              }).join(`
`)), ei;
            }
            e2.getTextOfNodeFromSourceText = ze;
            function Ee(c, te) {
              return te === void 0 && (te = false), Be($(c), c, te);
            }
            e2.getTextOfNode = Ee;
            function He(c) {
              return c.pos;
            }
            function rr(c, te) {
              return e2.binarySearch(c, te, He, e2.compareValues);
            }
            e2.indexOfNode = rr;
            function Ie(c) {
              var te = c.emitNode;
              return te && te.flags || 0;
            }
            e2.getEmitFlags = Ie;
            function _e() {
              return { es2015: { Array: ["find", "findIndex", "fill", "copyWithin", "entries", "keys", "values"], RegExp: ["flags", "sticky", "unicode"], Reflect: ["apply", "construct", "defineProperty", "deleteProperty", "get", " getOwnPropertyDescriptor", "getPrototypeOf", "has", "isExtensible", "ownKeys", "preventExtensions", "set", "setPrototypeOf"], ArrayConstructor: ["from", "of"], ObjectConstructor: ["assign", "getOwnPropertySymbols", "keys", "is", "setPrototypeOf"], NumberConstructor: ["isFinite", "isInteger", "isNaN", "isSafeInteger", "parseFloat", "parseInt"], Math: ["clz32", "imul", "sign", "log10", "log2", "log1p", "expm1", "cosh", "sinh", "tanh", "acosh", "asinh", "atanh", "hypot", "trunc", "fround", "cbrt"], Map: ["entries", "keys", "values"], Set: ["entries", "keys", "values"], Promise: e2.emptyArray, PromiseConstructor: ["all", "race", "reject", "resolve"], Symbol: ["for", "keyFor"], WeakMap: ["entries", "keys", "values"], WeakSet: ["entries", "keys", "values"], Iterator: e2.emptyArray, AsyncIterator: e2.emptyArray, String: ["codePointAt", "includes", "endsWith", "normalize", "repeat", "startsWith", "anchor", "big", "blink", "bold", "fixed", "fontcolor", "fontsize", "italics", "link", "small", "strike", "sub", "sup"], StringConstructor: ["fromCodePoint", "raw"] }, es2016: { Array: ["includes"] }, es2017: { Atomics: e2.emptyArray, SharedArrayBuffer: e2.emptyArray, String: ["padStart", "padEnd"], ObjectConstructor: ["values", "entries", "getOwnPropertyDescriptors"], DateTimeFormat: ["formatToParts"] }, es2018: { Promise: ["finally"], RegExpMatchArray: ["groups"], RegExpExecArray: ["groups"], RegExp: ["dotAll"], Intl: ["PluralRules"], AsyncIterable: e2.emptyArray, AsyncIterableIterator: e2.emptyArray, AsyncGenerator: e2.emptyArray, AsyncGeneratorFunction: e2.emptyArray, NumberFormat: ["formatToParts"] }, es2019: { Array: ["flat", "flatMap"], ObjectConstructor: ["fromEntries"], String: ["trimStart", "trimEnd", "trimLeft", "trimRight"], Symbol: ["description"] }, es2020: { BigInt: e2.emptyArray, BigInt64Array: e2.emptyArray, BigUint64Array: e2.emptyArray, PromiseConstructor: ["allSettled"], SymbolConstructor: ["matchAll"], String: ["matchAll"], DataView: ["setBigInt64", "setBigUint64", "getBigInt64", "getBigUint64"], RelativeTimeFormat: ["format", "formatToParts", "resolvedOptions"] }, es2021: { PromiseConstructor: ["any"], String: ["replaceAll"] }, es2022: { Array: ["at"], String: ["at"], Int8Array: ["at"], Uint8Array: ["at"], Uint8ClampedArray: ["at"], Int16Array: ["at"], Uint16Array: ["at"], Int32Array: ["at"], Uint32Array: ["at"], Float32Array: ["at"], Float64Array: ["at"], BigInt64Array: ["at"], BigUint64Array: ["at"], ObjectConstructor: ["hasOwn"], Error: ["cause"] } };
            }
            e2.getScriptTargetFeatures = _e;
            var we;
            (function(c) {
              c[c.None = 0] = "None", c[c.NeverAsciiEscape = 1] = "NeverAsciiEscape", c[c.JsxAttributeEscape = 2] = "JsxAttributeEscape", c[c.TerminateUnterminatedLiterals = 4] = "TerminateUnterminatedLiterals", c[c.AllowNumericSeparator = 8] = "AllowNumericSeparator";
            })(we = e2.GetLiteralTextFlags || (e2.GetLiteralTextFlags = {}));
            function de(c, te, xr) {
              var ei;
              if (te && ye(c, xr))
                return Be(te, c);
              switch (c.kind) {
                case 10: {
                  var bi = xr & 2 ? wc : xr & 1 || Ie(c) & 16777216 ? ks : Zl;
                  return c.singleQuote ? "'" + bi(c.text, 39) + "'" : '"' + bi(c.text, 34) + '"';
                }
                case 14:
                case 15:
                case 16:
                case 17: {
                  var bi = xr & 1 || Ie(c) & 16777216 ? ks : Zl, Ft = (ei = c.rawText) !== null && ei !== void 0 ? ei : gd(bi(c.text, 96));
                  switch (c.kind) {
                    case 14:
                      return "`" + Ft + "`";
                    case 15:
                      return "`" + Ft + "${";
                    case 16:
                      return "}" + Ft + "${";
                    case 17:
                      return "}" + Ft + "`";
                  }
                  break;
                }
                case 8:
                case 9:
                  return c.text;
                case 13:
                  return xr & 4 && c.isUnterminated ? c.text + (c.text.charCodeAt(c.text.length - 1) === 92 ? " /" : "/") : c.text;
              }
              return e2.Debug.fail("Literal kind '".concat(c.kind, "' not accounted for."));
            }
            e2.getLiteralText = de;
            function ye(c, te) {
              return F_(c) || !c.parent || te & 4 && c.isUnterminated ? false : e2.isNumericLiteral(c) && c.numericLiteralFlags & 512 ? !!(te & 8) : !e2.isBigIntLiteral(c);
            }
            function Ae(c) {
              return e2.isString(c) ? '"' + Zl(c) + '"' : "" + c;
            }
            e2.getTextOfConstantValue = Ae;
            function er(c) {
              return e2.getBaseFileName(c).replace(/^(\d)/, "_$1").replace(/\W/g, "_");
            }
            e2.makeIdentifierFromModuleName = er;
            function ir(c) {
              return (e2.getCombinedNodeFlags(c) & 3) !== 0 || Cr(c);
            }
            e2.isBlockOrCatchScoped = ir;
            function Cr(c) {
              var te = jf(c);
              return te.kind === 254 && te.parent.kind === 292;
            }
            e2.isCatchClauseVariableDeclarationOrBindingElement = Cr;
            function Ye(c) {
              return e2.isModuleDeclaration(c) && (c.name.kind === 10 || Ge(c));
            }
            e2.isAmbientModule = Ye;
            function Br(c) {
              return e2.isModuleDeclaration(c) && c.name.kind === 10;
            }
            e2.isModuleWithStringLiteralName = Br;
            function Er(c) {
              return e2.isModuleDeclaration(c) && e2.isStringLiteral(c.name);
            }
            e2.isNonGlobalAmbientModule = Er;
            function Ne(c) {
              return e2.isModuleDeclaration(c) || e2.isIdentifier(c);
            }
            e2.isEffectiveModuleDeclaration = Ne;
            function n(c) {
              return lr(c.valueDeclaration);
            }
            e2.isShorthandAmbientModuleSymbol = n;
            function lr(c) {
              return !!c && c.kind === 261 && !c.body;
            }
            function be(c) {
              return c.kind === 305 || c.kind === 261 || e2.isFunctionLikeOrClassStaticBlockDeclaration(c);
            }
            e2.isBlockScopedContainerTopLevel = be;
            function Ge(c) {
              return !!(c.flags & 1024);
            }
            e2.isGlobalScopeAugmentation = Ge;
            function ur(c) {
              return Ye(c) && yr(c);
            }
            e2.isExternalModuleAugmentation = ur;
            function yr(c) {
              switch (c.parent.kind) {
                case 305:
                  return e2.isExternalModule(c.parent);
                case 262:
                  return Ye(c.parent.parent) && e2.isSourceFile(c.parent.parent.parent) && !e2.isExternalModule(c.parent.parent.parent);
              }
              return false;
            }
            e2.isModuleAugmentationExternal = yr;
            function Ir(c) {
              var te;
              return (te = c.declarations) === null || te === void 0 ? void 0 : te.find(function(xr) {
                return !ur(xr) && !(e2.isModuleDeclaration(xr) && Ge(xr));
              });
            }
            e2.getNonAugmentationDeclaration = Ir;
            function wr(c) {
              return c === e2.ModuleKind.CommonJS || c === e2.ModuleKind.Node16 || c === e2.ModuleKind.NodeNext;
            }
            function Ur(c, te) {
              return e2.isExternalModule(c) || te.isolatedModules || wr(Ja(te)) && !!c.commonJsModuleIndicator;
            }
            e2.isEffectiveExternalModule = Ur;
            function ii(c, te) {
              switch (c.scriptKind) {
                case 1:
                case 3:
                case 2:
                case 4:
                  break;
                default:
                  return false;
              }
              return c.isDeclarationFile ? false : Sd(te, "alwaysStrict") || e2.startsWithUseStrict(c.statements) ? true : e2.isExternalModule(c) || te.isolatedModules ? Ja(te) >= e2.ModuleKind.ES2015 ? true : !te.noImplicitUseStrict : false;
            }
            e2.isEffectiveStrictModeSourceFile = ii;
            function mi(c, te) {
              switch (c.kind) {
                case 305:
                case 263:
                case 292:
                case 261:
                case 242:
                case 243:
                case 244:
                case 171:
                case 169:
                case 172:
                case 173:
                case 256:
                case 213:
                case 214:
                case 167:
                case 170:
                  return true;
                case 235:
                  return !e2.isFunctionLikeOrClassStaticBlockDeclaration(te);
              }
              return false;
            }
            e2.isBlockScope = mi;
            function pe(c) {
              switch (c.kind) {
                case 338:
                case 345:
                case 323:
                  return true;
                default:
                  return e2.assertType(c), or(c);
              }
            }
            e2.isDeclarationWithTypeParameters = pe;
            function or(c) {
              switch (c.kind) {
                case 174:
                case 175:
                case 168:
                case 176:
                case 179:
                case 180:
                case 317:
                case 257:
                case 226:
                case 258:
                case 259:
                case 344:
                case 256:
                case 169:
                case 171:
                case 172:
                case 173:
                case 213:
                case 214:
                  return true;
                default:
                  return e2.assertType(c), false;
              }
            }
            e2.isDeclarationWithTypeParameterChildren = or;
            function qr(c) {
              switch (c.kind) {
                case 266:
                case 265:
                  return true;
                default:
                  return false;
              }
            }
            e2.isAnyImportSyntax = qr;
            function si(c) {
              return qr(c) || Go(c);
            }
            e2.isAnyImportOrBareOrAccessedRequire = si;
            function Di(c) {
              switch (c.kind) {
                case 266:
                case 265:
                case 237:
                case 257:
                case 256:
                case 261:
                case 259:
                case 258:
                case 260:
                  return true;
                default:
                  return false;
              }
            }
            e2.isLateVisibilityPaintedStatement = Di;
            function wi(c) {
              return Xi(c) || e2.isModuleDeclaration(c) || e2.isImportTypeNode(c) || Vr(c);
            }
            e2.hasPossibleExternalModuleReference = wi;
            function Xi(c) {
              return qr(c) || e2.isExportDeclaration(c);
            }
            e2.isAnyImportOrReExport = Xi;
            function et(c) {
              return e2.findAncestor(c.parent, function(te) {
                return mi(te, te.parent);
              });
            }
            e2.getEnclosingBlockScopeContainer = et;
            function Gi(c, te) {
              for (var xr = et(c); xr; )
                te(xr), xr = et(xr);
            }
            e2.forEachEnclosingBlockScopeContainer = Gi;
            function Wt(c) {
              return !c || b(c) === 0 ? "(Missing)" : Ee(c);
            }
            e2.declarationNameToString = Wt;
            function Zt(c) {
              return c.declaration ? Wt(c.declaration.parameters[0].name) : void 0;
            }
            e2.getNameFromIndexInfo = Zt;
            function _r(c) {
              return c.kind === 162 && !ns(c.expression);
            }
            e2.isComputedNonLiteralName = _r;
            function pi(c) {
              switch (c.kind) {
                case 79:
                case 80:
                  return c.escapedText;
                case 10:
                case 8:
                case 14:
                  return e2.escapeLeadingUnderscores(c.text);
                case 162:
                  return ns(c.expression) ? e2.escapeLeadingUnderscores(c.expression.text) : void 0;
                default:
                  return e2.Debug.assertNever(c);
              }
            }
            e2.tryGetTextOfPropertyName = pi;
            function ae(c) {
              return e2.Debug.checkDefined(pi(c));
            }
            e2.getTextOfPropertyName = ae;
            function Xe(c) {
              switch (c.kind) {
                case 108:
                  return "this";
                case 80:
                case 79:
                  return b(c) === 0 ? e2.idText(c) : Ee(c);
                case 161:
                  return Xe(c.left) + "." + Xe(c.right);
                case 206:
                  return e2.isIdentifier(c.name) || e2.isPrivateIdentifier(c.name) ? Xe(c.expression) + "." + Xe(c.name) : e2.Debug.assertNever(c.name);
                case 311:
                  return Xe(c.left) + Xe(c.right);
                default:
                  return e2.Debug.assertNever(c);
              }
            }
            e2.entityNameToString = Xe;
            function Jr(c, te, xr, ei, bi, Ft) {
              var ot = $(c);
              return Ze(ot, c, te, xr, ei, bi, Ft);
            }
            e2.createDiagnosticForNode = Jr;
            function ti(c, te, xr, ei, bi, Ft, ot) {
              var xa = e2.skipTrivia(c.text, te.pos);
              return Hg(c, xa, te.end - xa, xr, ei, bi, Ft, ot);
            }
            e2.createDiagnosticForNodeArray = ti;
            function Ze(c, te, xr, ei, bi, Ft, ot) {
              var xa = Oe(c, te);
              return Hg(c, xa.start, xa.length, xr, ei, bi, Ft, ot);
            }
            e2.createDiagnosticForNodeInSourceFile = Ze;
            function Sr(c, te, xr) {
              var ei = $(c), bi = Oe(ei, c);
              return Wr(ei, bi.start, bi.length, te, xr);
            }
            e2.createDiagnosticForNodeFromMessageChain = Sr;
            function zr(c, te, xr) {
              e2.Debug.assertGreaterThanOrEqual(te, 0), e2.Debug.assertGreaterThanOrEqual(xr, 0), c && (e2.Debug.assertLessThanOrEqual(te, c.text.length), e2.Debug.assertLessThanOrEqual(te + xr, c.text.length));
            }
            function Wr(c, te, xr, ei, bi) {
              return zr(c, te, xr), { file: c, start: te, length: xr, code: ei.code, category: ei.category, messageText: ei.next ? ei : ei.messageText, relatedInformation: bi };
            }
            e2.createFileDiagnosticFromMessageChain = Wr;
            function Je(c, te, xr) {
              return { file: c, start: 0, length: 0, code: te.code, category: te.category, messageText: te.next ? te : te.messageText, relatedInformation: xr };
            }
            e2.createDiagnosticForFileFromMessageChain = Je;
            function xe(c) {
              return typeof c.messageText == "string" ? { code: c.code, category: c.category, messageText: c.messageText, next: c.next } : c.messageText;
            }
            e2.createDiagnosticMessageChainFromDiagnostic = xe;
            function vr(c, te, xr) {
              return { file: c, start: te.pos, length: te.end - te.pos, code: xr.code, category: xr.category, messageText: xr.message };
            }
            e2.createDiagnosticForRange = vr;
            function mr(c, te) {
              var xr = e2.createScanner(c.languageVersion, true, c.languageVariant, c.text, void 0, te);
              xr.scan();
              var ei = xr.getTokenPos();
              return e2.createTextSpanFromBounds(ei, xr.getTextPos());
            }
            e2.getSpanOfTokenAtPosition = mr;
            function Ar(c, te) {
              var xr = e2.skipTrivia(c.text, te.pos);
              if (te.body && te.body.kind === 235) {
                var ei = e2.getLineAndCharacterOfPosition(c, te.body.pos).line, bi = e2.getLineAndCharacterOfPosition(c, te.body.end).line;
                if (ei < bi)
                  return e2.createTextSpan(xr, k(ei, c) - xr + 1);
              }
              return e2.createTextSpanFromBounds(xr, te.end);
            }
            function Oe(c, te) {
              var xr = te;
              switch (te.kind) {
                case 305:
                  var ei = e2.skipTrivia(c.text, 0, false);
                  return ei === c.text.length ? e2.createTextSpan(0, 0) : mr(c, ei);
                case 254:
                case 203:
                case 257:
                case 226:
                case 258:
                case 261:
                case 260:
                case 299:
                case 256:
                case 213:
                case 169:
                case 172:
                case 173:
                case 259:
                case 167:
                case 166:
                case 268:
                  xr = te.name;
                  break;
                case 214:
                  return Ar(c, te);
                case 289:
                case 290:
                  var bi = e2.skipTrivia(c.text, te.pos), Ft = te.statements.length > 0 ? te.statements[0].pos : te.end;
                  return e2.createTextSpanFromBounds(bi, Ft);
              }
              if (xr === void 0)
                return mr(c, te.pos);
              e2.Debug.assert(!e2.isJSDoc(xr));
              var ot = U(xr), xa = ot || e2.isJsxText(te) ? xr.pos : e2.skipTrivia(c.text, xr.pos);
              return ot ? (e2.Debug.assert(xa === xr.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"), e2.Debug.assert(xa === xr.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")) : (e2.Debug.assert(xa >= xr.pos, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809"), e2.Debug.assert(xa <= xr.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809")), e2.createTextSpanFromBounds(xa, xr.end);
            }
            e2.getErrorSpanForNode = Oe;
            function nr(c) {
              return (c.externalModuleIndicator || c.commonJsModuleIndicator) !== void 0;
            }
            e2.isExternalOrCommonJsModule = nr;
            function Mr(c) {
              return c.scriptKind === 6;
            }
            e2.isJsonSourceFile = Mr;
            function Pe(c) {
              return !!(e2.getCombinedModifierFlags(c) & 2048);
            }
            e2.isEnumConst = Pe;
            function Ue(c) {
              return !!(e2.getCombinedModifierFlags(c) & 64 && !e2.isParameterPropertyDeclaration(c, c.parent));
            }
            e2.isDeclarationReadonly = Ue;
            function fr(c) {
              return !!(e2.getCombinedNodeFlags(c) & 2);
            }
            e2.isVarConst = fr;
            function De(c) {
              return !!(e2.getCombinedNodeFlags(c) & 1);
            }
            e2.isLet = De;
            function gr(c) {
              return c.kind === 208 && c.expression.kind === 106;
            }
            e2.isSuperCall = gr;
            function Vr(c) {
              return c.kind === 208 && c.expression.kind === 100;
            }
            e2.isImportCall = Vr;
            function Tr(c) {
              return e2.isMetaProperty(c) && c.keywordToken === 100 && c.name.escapedText === "meta";
            }
            e2.isImportMeta = Tr;
            function vi(c) {
              return e2.isImportTypeNode(c) && e2.isLiteralTypeNode(c.argument) && e2.isStringLiteral(c.argument.literal);
            }
            e2.isLiteralImportTypeNode = vi;
            function Ui(c) {
              return c.kind === 238 && c.expression.kind === 10;
            }
            e2.isPrologueDirective = Ui;
            function Yi(c) {
              return !!(Ie(c) & 1048576);
            }
            e2.isCustomPrologue = Yi;
            function Wi(c) {
              return Yi(c) && e2.isFunctionDeclaration(c);
            }
            e2.isHoistedFunction = Wi;
            function ct(c) {
              return e2.isIdentifier(c.name) && !c.initializer;
            }
            function Li(c) {
              return Yi(c) && e2.isVariableStatement(c) && e2.every(c.declarationList.declarations, ct);
            }
            e2.isHoistedVariableStatement = Li;
            function nt(c, te) {
              return c.kind !== 11 ? e2.getLeadingCommentRanges(te.text, c.pos) : void 0;
            }
            e2.getLeadingCommentRangesOfNode = nt;
            function Mt(c, te) {
              var xr = c.kind === 164 || c.kind === 163 || c.kind === 213 || c.kind === 214 || c.kind === 212 || c.kind === 254 || c.kind === 275 ? e2.concatenate(e2.getTrailingCommentRanges(te, c.pos), e2.getLeadingCommentRanges(te, c.pos)) : e2.getLeadingCommentRanges(te, c.pos);
              return e2.filter(xr, function(ei) {
                return te.charCodeAt(ei.pos + 1) === 42 && te.charCodeAt(ei.pos + 2) === 42 && te.charCodeAt(ei.pos + 3) !== 47;
              });
            }
            e2.getJSDocCommentRanges = Mt, e2.fullTripleSlashReferencePathRegEx = /^(\/\/\/\s*<reference\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
            var xt = /^(\/\/\/\s*<reference\s+types\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
            e2.fullTripleSlashAMDReferencePathRegEx = /^(\/\/\/\s*<amd-dependency\s+path\s*=\s*)(('[^']*')|("[^"]*")).*?\/>/;
            var ut = /^(\/\/\/\s*<reference\s+no-default-lib\s*=\s*)(('[^']*')|("[^"]*"))\s*\/>/;
            function Dt(c) {
              if (177 <= c.kind && c.kind <= 200)
                return true;
              switch (c.kind) {
                case 130:
                case 155:
                case 147:
                case 158:
                case 150:
                case 133:
                case 151:
                case 148:
                case 153:
                case 143:
                  return true;
                case 114:
                  return c.parent.kind !== 217;
                case 228:
                  return e2.isHeritageClause(c.parent) && !Fc(c);
                case 163:
                  return c.parent.kind === 195 || c.parent.kind === 190;
                case 79:
                  (c.parent.kind === 161 && c.parent.right === c || c.parent.kind === 206 && c.parent.name === c) && (c = c.parent), e2.Debug.assert(c.kind === 79 || c.kind === 161 || c.kind === 206, "'node' was expected to be a qualified name, identifier or property access in 'isPartOfTypeNode'.");
                case 161:
                case 206:
                case 108: {
                  var te = c.parent;
                  if (te.kind === 181)
                    return false;
                  if (te.kind === 200)
                    return !te.isTypeOf;
                  if (177 <= te.kind && te.kind <= 200)
                    return true;
                  switch (te.kind) {
                    case 228:
                      return e2.isHeritageClause(te.parent) && !Fc(te);
                    case 163:
                      return c === te.constraint;
                    case 344:
                      return c === te.constraint;
                    case 167:
                    case 166:
                    case 164:
                    case 254:
                      return c === te.type;
                    case 256:
                    case 213:
                    case 214:
                    case 171:
                    case 169:
                    case 168:
                    case 172:
                    case 173:
                      return c === te.type;
                    case 174:
                    case 175:
                    case 176:
                      return c === te.type;
                    case 211:
                      return c === te.type;
                    case 208:
                    case 209:
                      return e2.contains(te.typeArguments, c);
                    case 210:
                      return false;
                  }
                }
              }
              return false;
            }
            e2.isPartOfTypeNode = Dt;
            function Rt(c, te) {
              for (; c; ) {
                if (c.kind === te)
                  return true;
                c = c.parent;
              }
              return false;
            }
            e2.isChildOfNodeWithKind = Rt;
            function Ii(c, te) {
              return xr(c);
              function xr(ei) {
                switch (ei.kind) {
                  case 247:
                    return te(ei);
                  case 263:
                  case 235:
                  case 239:
                  case 240:
                  case 241:
                  case 242:
                  case 243:
                  case 244:
                  case 248:
                  case 249:
                  case 289:
                  case 290:
                  case 250:
                  case 252:
                  case 292:
                    return e2.forEachChild(ei, xr);
                }
              }
            }
            e2.forEachReturnStatement = Ii;
            function Ki(c, te) {
              return xr(c);
              function xr(ei) {
                switch (ei.kind) {
                  case 224:
                    te(ei);
                    var bi = ei.expression;
                    bi && xr(bi);
                    return;
                  case 260:
                  case 258:
                  case 261:
                  case 259:
                    return;
                  default:
                    if (e2.isFunctionLike(ei)) {
                      if (ei.name && ei.name.kind === 162) {
                        xr(ei.name.expression);
                        return;
                      }
                    } else
                      Dt(ei) || e2.forEachChild(ei, xr);
                }
              }
            }
            e2.forEachYieldExpression = Ki;
            function Fi(c) {
              return c && c.kind === 183 ? c.elementType : c && c.kind === 178 ? e2.singleOrUndefined(c.typeArguments) : void 0;
            }
            e2.getRestParameterElementType = Fi;
            function ui(c) {
              switch (c.kind) {
                case 258:
                case 257:
                case 226:
                case 182:
                  return c.members;
                case 205:
                  return c.properties;
              }
            }
            e2.getMembersOfDeclaration = ui;
            function Bt(c) {
              if (c)
                switch (c.kind) {
                  case 203:
                  case 299:
                  case 164:
                  case 296:
                  case 167:
                  case 166:
                  case 297:
                  case 254:
                    return true;
                }
              return false;
            }
            e2.isVariableLike = Bt;
            function wt(c) {
              return Bt(c) || e2.isAccessor(c);
            }
            e2.isVariableLikeOrAccessor = wt;
            function na(c) {
              return c.parent.kind === 255 && c.parent.parent.kind === 237;
            }
            e2.isVariableDeclarationInVariableStatement = na;
            function Ai(c) {
              return Ct(c) ? e2.isObjectLiteralExpression(c.parent) && e2.isBinaryExpression(c.parent.parent) && Hr(c.parent.parent) === 2 || Oi(c.parent) : false;
            }
            e2.isCommonJsExportedExpression = Ai;
            function Oi(c) {
              return Ct(c) ? e2.isBinaryExpression(c) && Hr(c) === 1 : false;
            }
            e2.isCommonJsExportPropertyAssignment = Oi;
            function ji(c) {
              return (e2.isVariableDeclaration(c) ? fr(c) && e2.isIdentifier(c.name) && na(c) : e2.isPropertyDeclaration(c) ? wp(c) && mc(c) : e2.isPropertySignature(c) && wp(c)) || Oi(c);
            }
            e2.isValidESSymbolDeclaration = ji;
            function Vi(c) {
              switch (c.kind) {
                case 169:
                case 168:
                case 171:
                case 172:
                case 173:
                case 256:
                case 213:
                  return true;
              }
              return false;
            }
            e2.introducesArgumentsExoticObject = Vi;
            function at(c, te) {
              for (; ; ) {
                if (te && te(c), c.statement.kind !== 250)
                  return c.statement;
                c = c.statement;
              }
            }
            e2.unwrapInnermostStatementOfLabel = at;
            function At(c) {
              return c && c.kind === 235 && e2.isFunctionLike(c.parent);
            }
            e2.isFunctionBlock = At;
            function ba(c) {
              return c && c.kind === 169 && c.parent.kind === 205;
            }
            e2.isObjectLiteralMethod = ba;
            function $a(c) {
              return (c.kind === 169 || c.kind === 172 || c.kind === 173) && (c.parent.kind === 205 || c.parent.kind === 226);
            }
            e2.isObjectLiteralOrClassExpressionMethodOrAccessor = $a;
            function Qa(c) {
              return c && c.kind === 1;
            }
            e2.isIdentifierTypePredicate = Qa;
            function ai(c) {
              return c && c.kind === 0;
            }
            e2.isThisTypePredicate = ai;
            function Dn(c, te, xr) {
              return c.properties.filter(function(ei) {
                if (ei.kind === 296) {
                  var bi = pi(ei.name);
                  return te === bi || !!xr && xr === bi;
                }
                return false;
              });
            }
            e2.getPropertyAssignment = Dn;
            function ka(c, te, xr) {
              return e2.firstDefined(Dn(c, te), function(ei) {
                return e2.isArrayLiteralExpression(ei.initializer) ? e2.find(ei.initializer.elements, function(bi) {
                  return e2.isStringLiteral(bi) && bi.text === xr;
                }) : void 0;
              });
            }
            e2.getPropertyArrayElementValue = ka;
            function Ba(c) {
              if (c && c.statements.length) {
                var te = c.statements[0].expression;
                return e2.tryCast(te, e2.isObjectLiteralExpression);
              }
            }
            e2.getTsConfigObjectLiteralExpression = Ba;
            function pn(c, te, xr) {
              return e2.firstDefined(Cn(c, te), function(ei) {
                return e2.isArrayLiteralExpression(ei.initializer) ? e2.find(ei.initializer.elements, function(bi) {
                  return e2.isStringLiteral(bi) && bi.text === xr;
                }) : void 0;
              });
            }
            e2.getTsConfigPropArrayElementValue = pn;
            function Cn(c, te) {
              var xr = Ba(c);
              return xr ? Dn(xr, te) : e2.emptyArray;
            }
            e2.getTsConfigPropArray = Cn;
            function Bi(c) {
              return e2.findAncestor(c.parent, e2.isFunctionLike);
            }
            e2.getContainingFunction = Bi;
            function kn(c) {
              return e2.findAncestor(c.parent, e2.isFunctionLikeDeclaration);
            }
            e2.getContainingFunctionDeclaration = kn;
            function xn(c) {
              return e2.findAncestor(c.parent, e2.isClassLike);
            }
            e2.getContainingClass = xn;
            function Kn(c) {
              return e2.findAncestor(c.parent, function(te) {
                return e2.isClassLike(te) || e2.isFunctionLike(te) ? "quit" : e2.isClassStaticBlockDeclaration(te);
              });
            }
            e2.getContainingClassStaticBlock = Kn;
            function Pn(c) {
              return e2.findAncestor(c.parent, e2.isFunctionLikeOrClassStaticBlockDeclaration);
            }
            e2.getContainingFunctionOrClassStaticBlock = Pn;
            function eo(c, te) {
              for (e2.Debug.assert(c.kind !== 305); ; ) {
                if (c = c.parent, !c)
                  return e2.Debug.fail();
                switch (c.kind) {
                  case 162:
                    if (e2.isClassLike(c.parent.parent))
                      return c;
                    c = c.parent;
                    break;
                  case 165:
                    c.parent.kind === 164 && e2.isClassElement(c.parent.parent) ? c = c.parent.parent : e2.isClassElement(c.parent) && (c = c.parent);
                    break;
                  case 214:
                    if (!te)
                      continue;
                  case 256:
                  case 213:
                  case 261:
                  case 170:
                  case 167:
                  case 166:
                  case 169:
                  case 168:
                  case 171:
                  case 172:
                  case 173:
                  case 174:
                  case 175:
                  case 176:
                  case 260:
                  case 305:
                    return c;
                }
              }
            }
            e2.getThisContainer = eo;
            function Rn(c) {
              switch (c.kind) {
                case 214:
                case 256:
                case 213:
                case 167:
                  return true;
                case 235:
                  switch (c.parent.kind) {
                    case 171:
                    case 169:
                    case 172:
                    case 173:
                      return true;
                    default:
                      return false;
                  }
                default:
                  return false;
              }
            }
            e2.isThisContainerOrFunctionBlock = Rn;
            function Da(c) {
              e2.isIdentifier(c) && (e2.isClassDeclaration(c.parent) || e2.isFunctionDeclaration(c.parent)) && c.parent.name === c && (c = c.parent);
              var te = eo(c, true);
              return e2.isSourceFile(te);
            }
            e2.isInTopLevelContext = Da;
            function bo(c) {
              var te = eo(c, false);
              if (te)
                switch (te.kind) {
                  case 171:
                  case 256:
                  case 213:
                    return te;
                }
            }
            e2.getNewTargetContainer = bo;
            function Ro(c, te) {
              for (; ; ) {
                if (c = c.parent, !c)
                  return c;
                switch (c.kind) {
                  case 162:
                    c = c.parent;
                    break;
                  case 256:
                  case 213:
                  case 214:
                    if (!te)
                      continue;
                  case 167:
                  case 166:
                  case 169:
                  case 168:
                  case 171:
                  case 172:
                  case 173:
                  case 170:
                    return c;
                  case 165:
                    c.parent.kind === 164 && e2.isClassElement(c.parent.parent) ? c = c.parent.parent : e2.isClassElement(c.parent) && (c = c.parent);
                    break;
                }
              }
            }
            e2.getSuperContainer = Ro;
            function En(c) {
              if (c.kind === 213 || c.kind === 214) {
                for (var te = c, xr = c.parent; xr.kind === 212; )
                  te = xr, xr = xr.parent;
                if (xr.kind === 208 && xr.expression === te)
                  return xr;
              }
            }
            e2.getImmediatelyInvokedFunctionExpression = En;
            function Wn(c) {
              return c.kind === 106 || to(c);
            }
            e2.isSuperOrSuperProperty = Wn;
            function to(c) {
              var te = c.kind;
              return (te === 206 || te === 207) && c.expression.kind === 106;
            }
            e2.isSuperProperty = to;
            function Co(c) {
              var te = c.kind;
              return (te === 206 || te === 207) && c.expression.kind === 108;
            }
            e2.isThisProperty = Co;
            function Ko(c) {
              var te;
              return !!c && e2.isVariableDeclaration(c) && ((te = c.initializer) === null || te === void 0 ? void 0 : te.kind) === 108;
            }
            e2.isThisInitializedDeclaration = Ko;
            function Oo(c) {
              return !!c && (e2.isShorthandPropertyAssignment(c) || e2.isPropertyAssignment(c)) && e2.isBinaryExpression(c.parent.parent) && c.parent.parent.operatorToken.kind === 63 && c.parent.parent.right.kind === 108;
            }
            e2.isThisInitializedObjectBindingExpression = Oo;
            function no(c) {
              switch (c.kind) {
                case 178:
                  return c.typeName;
                case 228:
                  return Hu(c.expression) ? c.expression : void 0;
                case 79:
                case 161:
                  return c;
              }
            }
            e2.getEntityNameFromTypeNode = no;
            function $o(c) {
              switch (c.kind) {
                case 210:
                  return c.tag;
                case 280:
                case 279:
                  return c.tagName;
                default:
                  return c.expression;
              }
            }
            e2.getInvokedExpression = $o;
            function Pr(c, te, xr) {
              if (e2.isNamedDeclaration(c) && e2.isPrivateIdentifier(c.name))
                return false;
              switch (c.kind) {
                case 257:
                  return true;
                case 167:
                  return te.kind === 257;
                case 172:
                case 173:
                case 169:
                  return c.body !== void 0 && te.kind === 257;
                case 164:
                  return te.body !== void 0 && (te.kind === 171 || te.kind === 169 || te.kind === 173) && xr.kind === 257;
              }
              return false;
            }
            e2.nodeCanBeDecorated = Pr;
            function xi(c, te, xr) {
              return c.decorators !== void 0 && Pr(c, te, xr);
            }
            e2.nodeIsDecorated = xi;
            function St(c, te, xr) {
              return xi(c, te, xr) || pa(c, te);
            }
            e2.nodeOrChildIsDecorated = St;
            function pa(c, te) {
              switch (c.kind) {
                case 257:
                  return e2.some(c.members, function(xr) {
                    return St(xr, c, te);
                  });
                case 169:
                case 173:
                case 171:
                  return e2.some(c.parameters, function(xr) {
                    return xi(xr, c, te);
                  });
                default:
                  return false;
              }
            }
            e2.childIsDecorated = pa;
            function dn(c) {
              if (xi(c))
                return true;
              var te = Nu(c);
              return !!te && pa(te, c);
            }
            e2.classOrConstructorParameterIsDecorated = dn;
            function Jn(c) {
              var te = c.parent;
              return te.kind === 280 || te.kind === 279 || te.kind === 281 ? te.tagName === c : false;
            }
            e2.isJSXTagName = Jn;
            function Qe(c) {
              switch (c.kind) {
                case 106:
                case 104:
                case 110:
                case 95:
                case 13:
                case 204:
                case 205:
                case 206:
                case 207:
                case 208:
                case 209:
                case 210:
                case 229:
                case 211:
                case 230:
                case 212:
                case 213:
                case 226:
                case 214:
                case 217:
                case 215:
                case 216:
                case 219:
                case 220:
                case 221:
                case 222:
                case 225:
                case 223:
                case 227:
                case 278:
                case 279:
                case 282:
                case 224:
                case 218:
                case 231:
                  return true;
                case 161:
                  for (; c.parent.kind === 161; )
                    c = c.parent;
                  return c.parent.kind === 181 || e2.isJSDocLinkLike(c.parent) || e2.isJSDocNameReference(c.parent) || e2.isJSDocMemberName(c.parent) || Jn(c);
                case 311:
                  for (; e2.isJSDocMemberName(c.parent); )
                    c = c.parent;
                  return c.parent.kind === 181 || e2.isJSDocLinkLike(c.parent) || e2.isJSDocNameReference(c.parent) || e2.isJSDocMemberName(c.parent) || Jn(c);
                case 80:
                  return e2.isBinaryExpression(c.parent) && c.parent.left === c && c.parent.operatorToken.kind === 101;
                case 79:
                  if (c.parent.kind === 181 || e2.isJSDocLinkLike(c.parent) || e2.isJSDocNameReference(c.parent) || e2.isJSDocMemberName(c.parent) || Jn(c))
                    return true;
                case 8:
                case 9:
                case 10:
                case 14:
                case 108:
                  return Gr(c);
                default:
                  return false;
              }
            }
            e2.isExpressionNode = Qe;
            function Gr(c) {
              var te = c.parent;
              switch (te.kind) {
                case 254:
                case 164:
                case 167:
                case 166:
                case 299:
                case 296:
                case 203:
                  return te.initializer === c;
                case 238:
                case 239:
                case 240:
                case 241:
                case 247:
                case 248:
                case 249:
                case 289:
                case 251:
                  return te.expression === c;
                case 242:
                  var xr = te;
                  return xr.initializer === c && xr.initializer.kind !== 255 || xr.condition === c || xr.incrementor === c;
                case 243:
                case 244:
                  var ei = te;
                  return ei.initializer === c && ei.initializer.kind !== 255 || ei.expression === c;
                case 211:
                case 229:
                  return c === te.expression;
                case 233:
                  return c === te.expression;
                case 162:
                  return c === te.expression;
                case 165:
                case 288:
                case 287:
                case 298:
                  return true;
                case 228:
                  return te.expression === c && !Dt(te);
                case 297:
                  return te.objectAssignmentInitializer === c;
                default:
                  return Qe(te);
              }
            }
            e2.isInExpressionContext = Gr;
            function S2(c) {
              for (; c.kind === 161 || c.kind === 79; )
                c = c.parent;
              return c.kind === 181;
            }
            e2.isPartOfTypeQuery = S2;
            function Ce(c) {
              return e2.isNamespaceExport(c) && !!c.parent.moduleSpecifier;
            }
            e2.isNamespaceReexportDeclaration = Ce;
            function qe(c) {
              return c.kind === 265 && c.moduleReference.kind === 277;
            }
            e2.isExternalModuleImportEqualsDeclaration = qe;
            function br(c) {
              return e2.Debug.assert(qe(c)), c.moduleReference.expression;
            }
            e2.getExternalModuleImportEqualsDeclarationExpression = br;
            function Zr(c) {
              return Go(c) && Xa(c.initializer).arguments[0];
            }
            e2.getExternalModuleRequireArgument = Zr;
            function Si(c) {
              return c.kind === 265 && c.moduleReference.kind !== 277;
            }
            e2.isInternalModuleImportEqualsDeclaration = Si;
            function Pi(c) {
              return Ct(c);
            }
            e2.isSourceFileJS = Pi;
            function Qi(c) {
              return !Ct(c);
            }
            e2.isSourceFileNotJS = Qi;
            function Ct(c) {
              return !!c && !!(c.flags & 262144);
            }
            e2.isInJSFile = Ct;
            function sa(c) {
              return !!c && !!(c.flags & 67108864);
            }
            e2.isInJsonFile = sa;
            function en(c) {
              return !Mr(c);
            }
            e2.isSourceFileNotJson = en;
            function Wa(c) {
              return !!c && !!(c.flags & 8388608);
            }
            e2.isInJSDoc = Wa;
            function qn(c) {
              return e2.isTypeReferenceNode(c) && e2.isIdentifier(c.typeName) && c.typeName.escapedText === "Object" && c.typeArguments && c.typeArguments.length === 2 && (c.typeArguments[0].kind === 150 || c.typeArguments[0].kind === 147);
            }
            e2.isJSDocIndexSignature = qn;
            function mo(c, te) {
              if (c.kind !== 208)
                return false;
              var xr = c, ei = xr.expression, bi = xr.arguments;
              if (ei.kind !== 79 || ei.escapedText !== "require" || bi.length !== 1)
                return false;
              var Ft = bi[0];
              return !te || e2.isStringLiteralLike(Ft);
            }
            e2.isRequireCall = mo;
            function So(c) {
              return ys(c, false);
            }
            e2.isVariableDeclarationInitializedToRequire = So;
            function Go(c) {
              return ys(c, true);
            }
            e2.isVariableDeclarationInitializedToBareOrAccessedRequire = Go;
            function ys(c, te) {
              return c.kind === 203 && (c = c.parent.parent), e2.isVariableDeclaration(c) && !!c.initializer && mo(te ? Xa(c.initializer) : c.initializer, true);
            }
            function Pc(c) {
              return e2.isVariableStatement(c) && c.declarationList.declarations.length > 0 && e2.every(c.declarationList.declarations, function(te) {
                return So(te);
              });
            }
            e2.isRequireVariableStatement = Pc;
            function Vc(c) {
              return c === 39 || c === 34;
            }
            e2.isSingleOrDoubleQuote = Vc;
            function Kc(c, te) {
              return Be(te, c).charCodeAt(0) === 34;
            }
            e2.isStringDoubleQuoted = Kc;
            function Xs(c) {
              return e2.isBinaryExpression(c) || cr(c) || e2.isIdentifier(c) || e2.isCallExpression(c);
            }
            e2.isAssignmentDeclaration = Xs;
            function pc(c) {
              return Ct(c) && c.initializer && e2.isBinaryExpression(c.initializer) && (c.initializer.operatorToken.kind === 56 || c.initializer.operatorToken.kind === 60) && c.name && Hu(c.name) && ce(c.name, c.initializer.left) ? c.initializer.right : c.initializer;
            }
            e2.getEffectiveInitializer = pc;
            function hs(c) {
              var te = pc(c);
              return te && Qs(te, nf(c.name));
            }
            e2.getDeclaredExpandoInitializer = hs;
            function tc(c, te) {
              return e2.forEach(c.properties, function(xr) {
                return e2.isPropertyAssignment(xr) && e2.isIdentifier(xr.name) && xr.name.escapedText === "value" && xr.initializer && Qs(xr.initializer, te);
              });
            }
            function ps(c) {
              if (c && c.parent && e2.isBinaryExpression(c.parent) && c.parent.operatorToken.kind === 63) {
                var te = nf(c.parent.left);
                return Qs(c.parent.right, te) || js(c.parent.left, c.parent.right, te);
              }
              if (c && e2.isCallExpression(c) && pt(c)) {
                var xr = tc(c.arguments[2], c.arguments[1].text === "prototype");
                if (xr)
                  return xr;
              }
            }
            e2.getAssignedExpandoInitializer = ps;
            function Qs(c, te) {
              if (e2.isCallExpression(c)) {
                var xr = po(c.expression);
                return xr.kind === 213 || xr.kind === 214 ? c : void 0;
              }
              if (c.kind === 213 || c.kind === 226 || c.kind === 214 || e2.isObjectLiteralExpression(c) && (c.properties.length === 0 || te))
                return c;
            }
            e2.getExpandoInitializer = Qs;
            function js(c, te, xr) {
              var ei = e2.isBinaryExpression(te) && (te.operatorToken.kind === 56 || te.operatorToken.kind === 60) && Qs(te.right, xr);
              if (ei && ce(c, te.left))
                return ei;
            }
            function ds(c) {
              var te = e2.isVariableDeclaration(c.parent) ? c.parent.name : e2.isBinaryExpression(c.parent) && c.parent.operatorToken.kind === 63 ? c.parent.left : void 0;
              return te && Qs(c.right, nf(te)) && Hu(te) && ce(te, c.left);
            }
            e2.isDefaultedExpandoInitializer = ds;
            function Ji(c) {
              if (e2.isBinaryExpression(c.parent)) {
                var te = (c.parent.operatorToken.kind === 56 || c.parent.operatorToken.kind === 60) && e2.isBinaryExpression(c.parent.parent) ? c.parent.parent : c.parent;
                if (te.operatorToken.kind === 63 && e2.isIdentifier(te.left))
                  return te.left;
              } else if (e2.isVariableDeclaration(c.parent))
                return c.parent.name;
            }
            e2.getNameOfExpando = Ji;
            function ce(c, te) {
              return Jf(c) && Jf(te) ? w_(c) === w_(te) : e2.isMemberName(c) && Pt(te) && (te.expression.kind === 108 || e2.isIdentifier(te.expression) && (te.expression.escapedText === "window" || te.expression.escapedText === "self" || te.expression.escapedText === "global")) ? ce(c, fo(te)) : Pt(c) && Pt(te) ? Ao(c) === Ao(te) && ce(c.expression, te.expression) : false;
            }
            e2.isSameEntityName = ce;
            function Rr(c) {
              for (; dl(c, true); )
                c = c.right;
              return c;
            }
            e2.getRightMostAssignedExpression = Rr;
            function yi(c) {
              return e2.isIdentifier(c) && c.escapedText === "exports";
            }
            e2.isExportsIdentifier = yi;
            function qi(c) {
              return e2.isIdentifier(c) && c.escapedText === "module";
            }
            e2.isModuleIdentifier = qi;
            function je(c) {
              return (e2.isPropertyAccessExpression(c) || ga(c)) && qi(c.expression) && Ao(c) === "exports";
            }
            e2.isModuleExportsAccessExpression = je;
            function Hr(c) {
              var te = xs(c);
              return te === 5 || Ct(c) ? te : 0;
            }
            e2.getAssignmentDeclarationKind = Hr;
            function pt(c) {
              return e2.length(c.arguments) === 3 && e2.isPropertyAccessExpression(c.expression) && e2.isIdentifier(c.expression.expression) && e2.idText(c.expression.expression) === "Object" && e2.idText(c.expression.name) === "defineProperty" && ns(c.arguments[1]) && jr(c.arguments[0], true);
            }
            e2.isBindableObjectDefinePropertyCall = pt;
            function Pt(c) {
              return e2.isPropertyAccessExpression(c) || ga(c);
            }
            e2.isLiteralLikeAccess = Pt;
            function ga(c) {
              return e2.isElementAccessExpression(c) && ns(c.argumentExpression);
            }
            e2.isLiteralLikeElementAccess = ga;
            function ua(c, te) {
              return e2.isPropertyAccessExpression(c) && (!te && c.expression.kind === 108 || e2.isIdentifier(c.name) && jr(c.expression, true)) || Xn(c, te);
            }
            e2.isBindableStaticAccessExpression = ua;
            function Xn(c, te) {
              return ga(c) && (!te && c.expression.kind === 108 || Hu(c.expression) || ua(c.expression, true));
            }
            e2.isBindableStaticElementAccessExpression = Xn;
            function jr(c, te) {
              return Hu(c) || ua(c, te);
            }
            e2.isBindableStaticNameExpression = jr;
            function fo(c) {
              return e2.isPropertyAccessExpression(c) ? c.name : c.argumentExpression;
            }
            e2.getNameOrArgument = fo;
            function xs(c) {
              if (e2.isCallExpression(c)) {
                if (!pt(c))
                  return 0;
                var te = c.arguments[0];
                return yi(te) || je(te) ? 8 : ua(te) && Ao(te) === "prototype" ? 9 : 7;
              }
              return c.operatorToken.kind !== 63 || !cr(c.left) || Fo(Rr(c)) ? 0 : jr(c.left.expression, true) && Ao(c.left) === "prototype" && e2.isObjectLiteralExpression(Bs(c)) ? 6 : Ms(c.left);
            }
            function Fo(c) {
              return e2.isVoidExpression(c) && e2.isNumericLiteral(c.expression) && c.expression.text === "0";
            }
            function ko(c) {
              if (e2.isPropertyAccessExpression(c))
                return c.name;
              var te = po(c.argumentExpression);
              return e2.isNumericLiteral(te) || e2.isStringLiteralLike(te) ? te : c;
            }
            e2.getElementOrPropertyAccessArgumentExpressionOrName = ko;
            function Ao(c) {
              var te = ko(c);
              if (te) {
                if (e2.isIdentifier(te))
                  return te.escapedText;
                if (e2.isStringLiteralLike(te) || e2.isNumericLiteral(te))
                  return e2.escapeLeadingUnderscores(te.text);
              }
            }
            e2.getElementOrPropertyAccessName = Ao;
            function Ms(c) {
              if (c.expression.kind === 108)
                return 4;
              if (je(c))
                return 2;
              if (jr(c.expression, true)) {
                if (nf(c.expression))
                  return 3;
                for (var te = c; !e2.isIdentifier(te.expression); )
                  te = te.expression;
                var xr = te.expression;
                if ((xr.escapedText === "exports" || xr.escapedText === "module" && Ao(te) === "exports") && ua(c))
                  return 1;
                if (jr(c, true) || e2.isElementAccessExpression(c) && es(c))
                  return 5;
              }
              return 0;
            }
            e2.getAssignmentDeclarationPropertyAccessKind = Ms;
            function Bs(c) {
              for (; e2.isBinaryExpression(c.right); )
                c = c.right;
              return c.right;
            }
            e2.getInitializerOfBinaryExpression = Bs;
            function xc(c) {
              return e2.isBinaryExpression(c) && Hr(c) === 3;
            }
            e2.isPrototypePropertyAssignment = xc;
            function su(c) {
              return Ct(c) && c.parent && c.parent.kind === 238 && (!e2.isElementAccessExpression(c) || ga(c)) && !!e2.getJSDocTypeTag(c.parent);
            }
            e2.isSpecialPropertyDeclaration = su;
            function tl(c, te) {
              var xr = c.valueDeclaration;
              (!xr || !(te.flags & 16777216 && !(xr.flags & 16777216)) && Xs(xr) && !Xs(te) || xr.kind !== te.kind && Ne(xr)) && (c.valueDeclaration = te);
            }
            e2.setValueDeclaration = tl;
            function Zc(c) {
              if (!c || !c.valueDeclaration)
                return false;
              var te = c.valueDeclaration;
              return te.kind === 256 || e2.isVariableDeclaration(te) && te.initializer && e2.isFunctionLike(te.initializer);
            }
            e2.isFunctionSymbol = Zc;
            function Rf(c) {
              var te, xr;
              switch (c.kind) {
                case 254:
                  return (te = e2.findAncestor(c.initializer, function(ei) {
                    return mo(ei, true);
                  })) === null || te === void 0 ? void 0 : te.arguments[0];
                case 266:
                  return e2.tryCast(c.moduleSpecifier, e2.isStringLiteralLike);
                case 265:
                  return e2.tryCast((xr = e2.tryCast(c.moduleReference, e2.isExternalModuleReference)) === null || xr === void 0 ? void 0 : xr.expression, e2.isStringLiteralLike);
                default:
                  e2.Debug.assertNever(c);
              }
            }
            e2.tryGetModuleSpecifierFromDeclaration = Rf;
            function al(c) {
              return Jo(c) || e2.Debug.failBadSyntaxKind(c.parent);
            }
            e2.importFromModuleSpecifier = al;
            function Jo(c) {
              switch (c.parent.kind) {
                case 266:
                case 272:
                  return c.parent;
                case 277:
                  return c.parent.parent;
                case 208:
                  return Vr(c.parent) || mo(c.parent, false) ? c.parent : void 0;
                case 196:
                  return e2.Debug.assert(e2.isStringLiteral(c)), e2.tryCast(c.parent.parent, e2.isImportTypeNode);
                default:
                  return;
              }
            }
            e2.tryGetImportFromModuleSpecifier = Jo;
            function eu(c) {
              switch (c.kind) {
                case 266:
                case 272:
                  return c.moduleSpecifier;
                case 265:
                  return c.moduleReference.kind === 277 ? c.moduleReference.expression : void 0;
                case 200:
                  return vi(c) ? c.argument.literal : void 0;
                case 208:
                  return c.arguments[0];
                case 261:
                  return c.name.kind === 10 ? c.name : void 0;
                default:
                  return e2.Debug.assertNever(c);
              }
            }
            e2.getExternalModuleName = eu;
            function Ws(c) {
              switch (c.kind) {
                case 266:
                  return c.importClause && e2.tryCast(c.importClause.namedBindings, e2.isNamespaceImport);
                case 265:
                  return c;
                case 272:
                  return c.exportClause && e2.tryCast(c.exportClause, e2.isNamespaceExport);
                default:
                  return e2.Debug.assertNever(c);
              }
            }
            e2.getNamespaceDeclarationNode = Ws;
            function pu(c) {
              return c.kind === 266 && !!c.importClause && !!c.importClause.name;
            }
            e2.isDefaultImport = pu;
            function Uu(c, te) {
              if (c.name) {
                var xr = te(c);
                if (xr)
                  return xr;
              }
              if (c.namedBindings) {
                var xr = e2.isNamespaceImport(c.namedBindings) ? te(c.namedBindings) : e2.forEach(c.namedBindings.elements, te);
                if (xr)
                  return xr;
              }
            }
            e2.forEachImportClauseDeclaration = Uu;
            function Ql(c) {
              if (c)
                switch (c.kind) {
                  case 164:
                  case 169:
                  case 168:
                  case 297:
                  case 296:
                  case 167:
                  case 166:
                    return c.questionToken !== void 0;
                }
              return false;
            }
            e2.hasQuestionToken = Ql;
            function xl(c) {
              var te = e2.isJSDocFunctionType(c) ? e2.firstOrUndefined(c.parameters) : void 0, xr = e2.tryCast(te && te.name, e2.isIdentifier);
              return !!xr && xr.escapedText === "new";
            }
            e2.isJSDocConstructSignature = xl;
            function Ya(c) {
              return c.kind === 345 || c.kind === 338 || c.kind === 339;
            }
            e2.isJSDocTypeAlias = Ya;
            function du(c) {
              return Ya(c) || e2.isTypeAliasDeclaration(c);
            }
            e2.isTypeAlias = du;
            function vc(c) {
              return e2.isExpressionStatement(c) && e2.isBinaryExpression(c.expression) && c.expression.operatorToken.kind === 63 ? Rr(c.expression) : void 0;
            }
            function Kr(c) {
              return e2.isExpressionStatement(c) && e2.isBinaryExpression(c.expression) && Hr(c.expression) !== 0 && e2.isBinaryExpression(c.expression.right) && (c.expression.right.operatorToken.kind === 56 || c.expression.right.operatorToken.kind === 60) ? c.expression.right.right : void 0;
            }
            function _i(c) {
              switch (c.kind) {
                case 237:
                  var te = Ei(c);
                  return te && te.initializer;
                case 167:
                  return c.initializer;
                case 296:
                  return c.initializer;
              }
            }
            e2.getSingleInitializerOfVariableStatementOrPropertyDeclaration = _i;
            function Ei(c) {
              return e2.isVariableStatement(c) ? e2.firstOrUndefined(c.declarationList.declarations) : void 0;
            }
            e2.getSingleVariableOfVariableStatement = Ei;
            function tt(c) {
              return e2.isModuleDeclaration(c) && c.body && c.body.kind === 261 ? c.body : void 0;
            }
            function kt(c, te) {
              var xr;
              Bt(c) && e2.hasInitializer(c) && e2.hasJSDocNodes(c.initializer) && (xr = e2.addRange(xr, bt(c, e2.last(c.initializer.jsDoc))));
              for (var ei = c; ei && ei.parent; ) {
                if (e2.hasJSDocNodes(ei) && (xr = e2.addRange(xr, bt(c, e2.last(ei.jsDoc)))), ei.kind === 164) {
                  xr = e2.addRange(xr, (te ? e2.getJSDocParameterTagsNoCache : e2.getJSDocParameterTags)(ei));
                  break;
                }
                if (ei.kind === 163) {
                  xr = e2.addRange(xr, (te ? e2.getJSDocTypeParameterTagsNoCache : e2.getJSDocTypeParameterTags)(ei));
                  break;
                }
                ei = Xt(ei);
              }
              return xr || e2.emptyArray;
            }
            e2.getJSDocCommentsAndTags = kt;
            function bt(c, te) {
              if (e2.isJSDoc(te)) {
                var xr = e2.filter(te.tags, function(ei) {
                  return ia(c, ei);
                });
                return te.tags === xr ? [te] : xr;
              }
              return ia(c, te) ? [te] : void 0;
            }
            function ia(c, te) {
              return !e2.isJSDocTypeTag(te) || !te.parent || !e2.isJSDoc(te.parent) || !e2.isParenthesizedExpression(te.parent.parent) || te.parent.parent === c;
            }
            function Xt(c) {
              var te = c.parent;
              if (te.kind === 296 || te.kind === 271 || te.kind === 167 || te.kind === 238 && c.kind === 206 || te.kind === 247 || tt(te) || e2.isBinaryExpression(c) && c.operatorToken.kind === 63)
                return te;
              if (te.parent && (Ei(te.parent) === c || e2.isBinaryExpression(te) && te.operatorToken.kind === 63))
                return te.parent;
              if (te.parent && te.parent.parent && (Ei(te.parent.parent) || _i(te.parent.parent) === c || Kr(te.parent.parent)))
                return te.parent.parent;
            }
            e2.getNextJSDocCommentLocation = Xt;
            function Za(c) {
              if (c.symbol)
                return c.symbol;
              if (!!e2.isIdentifier(c.name)) {
                var te = c.name.escapedText, xr = _a4(c);
                if (!!xr) {
                  var ei = e2.find(xr.parameters, function(bi) {
                    return bi.name.kind === 79 && bi.name.escapedText === te;
                  });
                  return ei && ei.symbol;
                }
              }
            }
            e2.getParameterSymbolFromJSDoc = Za;
            function bn(c) {
              if (e2.isJSDoc(c.parent) && c.parent.tags) {
                var te = e2.find(c.parent.tags, Ya);
                if (te)
                  return te;
              }
              return _a4(c);
            }
            e2.getEffectiveContainerForJSDocTemplateTag = bn;
            function _a4(c) {
              var te = qa(c);
              if (te)
                return e2.isPropertySignature(te) && te.type && e2.isFunctionLike(te.type) ? te.type : e2.isFunctionLike(te) ? te : void 0;
            }
            e2.getHostSignatureFromJSDoc = _a4;
            function qa(c) {
              var te = rn(c);
              if (te)
                return Kr(te) || vc(te) || _i(te) || Ei(te) || tt(te) || te;
            }
            e2.getEffectiveJSDocHost = qa;
            function rn(c) {
              var te = jn(c);
              if (!!te) {
                var xr = te.parent;
                if (xr && xr.jsDoc && te === e2.lastOrUndefined(xr.jsDoc))
                  return xr;
              }
            }
            e2.getJSDocHost = rn;
            function jn(c) {
              return e2.findAncestor(c.parent, e2.isJSDoc);
            }
            e2.getJSDocRoot = jn;
            function Mo(c) {
              var te = c.name.escapedText, xr = c.parent.parent.parent.typeParameters;
              return xr && e2.find(xr, function(ei) {
                return ei.name.escapedText === te;
              });
            }
            e2.getTypeParameterFromJsDoc = Mo;
            function ho(c) {
              var te = e2.lastOrUndefined(c.parameters);
              return !!te && gs(te);
            }
            e2.hasRestParameter = ho;
            function gs(c) {
              var te = e2.isJSDocParameterTag(c) ? c.typeExpression && c.typeExpression.type : c.type;
              return c.dotDotDotToken !== void 0 || !!te && te.kind === 318;
            }
            e2.isRestParameter = gs;
            function Se(c) {
              return !!c.typeArguments;
            }
            e2.hasTypeArguments = Se;
            var hr;
            (function(c) {
              c[c.None = 0] = "None", c[c.Definite = 1] = "Definite", c[c.Compound = 2] = "Compound";
            })(hr = e2.AssignmentKind || (e2.AssignmentKind = {}));
            function Or(c) {
              for (var te = c.parent; ; ) {
                switch (te.kind) {
                  case 221:
                    var xr = te.operatorToken.kind;
                    return Cf(xr) && te.left === c ? xr === 63 || Gu(xr) ? 1 : 2 : 0;
                  case 219:
                  case 220:
                    var ei = te.operator;
                    return ei === 45 || ei === 46 ? 2 : 0;
                  case 243:
                  case 244:
                    return te.initializer === c ? 1 : 0;
                  case 212:
                  case 204:
                  case 225:
                  case 230:
                    c = te;
                    break;
                  case 298:
                    c = te.parent;
                    break;
                  case 297:
                    if (te.name !== c)
                      return 0;
                    c = te.parent;
                    break;
                  case 296:
                    if (te.name === c)
                      return 0;
                    c = te.parent;
                    break;
                  default:
                    return 0;
                }
                te = c.parent;
              }
            }
            e2.getAssignmentTargetKind = Or;
            function ki(c) {
              return Or(c) !== 0;
            }
            e2.isAssignmentTarget = ki;
            function dt(c) {
              switch (c.kind) {
                case 235:
                case 237:
                case 248:
                case 239:
                case 249:
                case 263:
                case 289:
                case 290:
                case 250:
                case 242:
                case 243:
                case 244:
                case 240:
                case 241:
                case 252:
                case 292:
                  return true;
              }
              return false;
            }
            e2.isNodeWithPossibleHoistedDeclaration = dt;
            function la(c) {
              return e2.isFunctionExpression(c) || e2.isArrowFunction(c) || e2.isMethodOrAccessor(c) || e2.isFunctionDeclaration(c) || e2.isConstructorDeclaration(c);
            }
            e2.isValueSignatureDeclaration = la;
            function wa(c, te) {
              for (; c && c.kind === te; )
                c = c.parent;
              return c;
            }
            function On(c) {
              return wa(c, 191);
            }
            e2.walkUpParenthesizedTypes = On;
            function No(c) {
              return wa(c, 212);
            }
            e2.walkUpParenthesizedExpressions = No;
            function jo(c) {
              for (var te; c && c.kind === 191; )
                te = c, c = c.parent;
              return [te, c];
            }
            e2.walkUpParenthesizedTypesAndGetParentAndChild = jo;
            function po(c, te) {
              var xr = te ? 17 : 1;
              return e2.skipOuterExpressions(c, xr);
            }
            e2.skipParentheses = po;
            function Gn(c) {
              return c.kind !== 206 && c.kind !== 207 ? false : (c = No(c.parent), c && c.kind === 215);
            }
            e2.isDeleteTarget = Gn;
            function $n(c, te) {
              for (; c; ) {
                if (c === te)
                  return true;
                c = c.parent;
              }
              return false;
            }
            e2.isNodeDescendantOf = $n;
            function Ho(c) {
              return !e2.isSourceFile(c) && !e2.isBindingPattern(c) && e2.isDeclaration(c.parent) && c.parent.name === c;
            }
            e2.isDeclarationName = Ho;
            function Zo(c) {
              var te = c.parent;
              switch (c.kind) {
                case 10:
                case 14:
                case 8:
                  if (e2.isComputedPropertyName(te))
                    return te.parent;
                case 79:
                  if (e2.isDeclaration(te))
                    return te.name === c ? te : void 0;
                  if (e2.isQualifiedName(te)) {
                    var xr = te.parent;
                    return e2.isJSDocParameterTag(xr) && xr.name === te ? xr : void 0;
                  } else {
                    var ei = te.parent;
                    return e2.isBinaryExpression(ei) && Hr(ei) !== 0 && (ei.left.symbol || ei.symbol) && e2.getNameOfDeclaration(ei) === c ? ei : void 0;
                  }
                case 80:
                  return e2.isDeclaration(te) && te.name === c ? te : void 0;
                default:
                  return;
              }
            }
            e2.getDeclarationFromName = Zo;
            function Es(c) {
              return ns(c) && c.parent.kind === 162 && e2.isDeclaration(c.parent.parent);
            }
            e2.isLiteralComputedPropertyDeclarationName = Es;
            function yc(c) {
              var te = c.parent;
              switch (te.kind) {
                case 167:
                case 166:
                case 169:
                case 168:
                case 172:
                case 173:
                case 299:
                case 296:
                case 206:
                  return te.name === c;
                case 161:
                  return te.right === c;
                case 203:
                case 270:
                  return te.propertyName === c;
                case 275:
                case 285:
                case 279:
                case 280:
                case 281:
                  return true;
              }
              return false;
            }
            e2.isIdentifierName = yc;
            function Xr(c) {
              return c.kind === 265 || c.kind === 264 || c.kind === 267 && !!c.name || c.kind === 268 || c.kind === 274 || c.kind === 270 || c.kind === 275 || c.kind === 271 && zu(c) ? true : Ct(c) && (e2.isBinaryExpression(c) && Hr(c) === 2 && zu(c) || e2.isPropertyAccessExpression(c) && e2.isBinaryExpression(c.parent) && c.parent.left === c && c.parent.operatorToken.kind === 63 && Ic(c.parent.right));
            }
            e2.isAliasSymbolDeclaration = Xr;
            function Ls(c) {
              switch (c.parent.kind) {
                case 267:
                case 270:
                case 268:
                case 275:
                case 271:
                case 265:
                case 274:
                  return c.parent;
                case 161:
                  do
                    c = c.parent;
                  while (c.parent.kind === 161);
                  return Ls(c);
              }
            }
            e2.getAliasDeclarationFromName = Ls;
            function Ic(c) {
              return Hu(c) || e2.isClassExpression(c);
            }
            e2.isAliasableExpression = Ic;
            function zu(c) {
              var te = vf(c);
              return Ic(te);
            }
            e2.exportAssignmentIsAlias = zu;
            function vf(c) {
              return e2.isExportAssignment(c) ? c.expression : c.right;
            }
            e2.getExportAssignmentExpression = vf;
            function P_(c) {
              return c.kind === 297 ? c.name : c.kind === 296 ? c.initializer : c.parent.right;
            }
            e2.getPropertyAssignmentAliasLikeExpression = P_;
            function El(c) {
              var te = vp(c);
              if (te && Ct(c)) {
                var xr = e2.getJSDocAugmentsTag(c);
                if (xr)
                  return xr.class;
              }
              return te;
            }
            e2.getEffectiveBaseTypeNode = El;
            function vp(c) {
              var te = Yl(c.heritageClauses, 94);
              return te && te.types.length > 0 ? te.types[0] : void 0;
            }
            e2.getClassExtendsHeritageElement = vp;
            function oo(c) {
              if (Ct(c))
                return e2.getJSDocImplementsTags(c).map(function(xr) {
                  return xr.class;
                });
              var te = Yl(c.heritageClauses, 117);
              return te == null ? void 0 : te.types;
            }
            e2.getEffectiveImplementsTypeNodes = oo;
            function I_(c) {
              return e2.isInterfaceDeclaration(c) ? yp(c) || e2.emptyArray : e2.isClassLike(c) && e2.concatenate(e2.singleElementArray(El(c)), oo(c)) || e2.emptyArray;
            }
            e2.getAllSuperTypeNodes = I_;
            function yp(c) {
              var te = Yl(c.heritageClauses, 94);
              return te ? te.types : void 0;
            }
            e2.getInterfaceBaseTypeNodes = yp;
            function Yl(c, te) {
              if (c)
                for (var xr = 0, ei = c; xr < ei.length; xr++) {
                  var bi = ei[xr];
                  if (bi.token === te)
                    return bi;
                }
            }
            e2.getHeritageClause = Yl;
            function Bf(c, te) {
              for (; c; ) {
                if (c.kind === te)
                  return c;
                c = c.parent;
              }
            }
            e2.getAncestor = Bf;
            function Cl(c) {
              return 81 <= c && c <= 160;
            }
            e2.isKeyword = Cl;
            function c_(c) {
              return 126 <= c && c <= 160;
            }
            e2.isContextualKeyword = c_;
            function hp(c) {
              return Cl(c) && !c_(c);
            }
            e2.isNonContextualKeyword = hp;
            function gu(c) {
              return 117 <= c && c <= 125;
            }
            e2.isFutureReservedKeyword = gu;
            function Dp(c) {
              var te = e2.stringToToken(c);
              return te !== void 0 && hp(te);
            }
            e2.isStringANonContextualKeyword = Dp;
            function sd(c) {
              var te = e2.stringToToken(c);
              return te !== void 0 && Cl(te);
            }
            e2.isStringAKeyword = sd;
            function Aa(c) {
              var te = c.originalKeywordKind;
              return !!te && !c_(te);
            }
            e2.isIdentifierANonContextualKeyword = Aa;
            function va(c) {
              return 2 <= c && c <= 7;
            }
            e2.isTrivia = va;
            var Cu;
            (function(c) {
              c[c.Normal = 0] = "Normal", c[c.Generator = 1] = "Generator", c[c.Async = 2] = "Async", c[c.Invalid = 4] = "Invalid", c[c.AsyncGenerator = 3] = "AsyncGenerator";
            })(Cu = e2.FunctionFlags || (e2.FunctionFlags = {}));
            function qs(c) {
              if (!c)
                return 4;
              var te = 0;
              switch (c.kind) {
                case 256:
                case 213:
                case 169:
                  c.asteriskToken && (te |= 1);
                case 214:
                  gc(c, 256) && (te |= 2);
                  break;
              }
              return c.body || (te |= 4), te;
            }
            e2.getFunctionFlags = qs;
            function cd(c) {
              switch (c.kind) {
                case 256:
                case 213:
                case 214:
                case 169:
                  return c.body !== void 0 && c.asteriskToken === void 0 && gc(c, 256);
              }
              return false;
            }
            e2.isAsyncFunction = cd;
            function ns(c) {
              return e2.isStringLiteralLike(c) || e2.isNumericLiteral(c);
            }
            e2.isStringOrNumericLiteralLike = ns;
            function nl(c) {
              return e2.isPrefixUnaryExpression(c) && (c.operator === 39 || c.operator === 40) && e2.isNumericLiteral(c.operand);
            }
            e2.isSignedNumericLiteral = nl;
            function hc(c) {
              var te = e2.getNameOfDeclaration(c);
              return !!te && es(te);
            }
            e2.hasDynamicName = hc;
            function es(c) {
              if (!(c.kind === 162 || c.kind === 207))
                return false;
              var te = e2.isElementAccessExpression(c) ? po(c.argumentExpression) : c.expression;
              return !ns(te) && !nl(te);
            }
            e2.isDynamicName = es;
            function u_(c) {
              switch (c.kind) {
                case 79:
                case 80:
                  return c.escapedText;
                case 10:
                case 8:
                  return e2.escapeLeadingUnderscores(c.text);
                case 162:
                  var te = c.expression;
                  return ns(te) ? e2.escapeLeadingUnderscores(te.text) : nl(te) ? te.operator === 40 ? e2.tokenToString(te.operator) + te.operand.text : te.operand.text : void 0;
                default:
                  return e2.Debug.assertNever(c);
              }
            }
            e2.getPropertyNameForPropertyNameNode = u_;
            function Jf(c) {
              switch (c.kind) {
                case 79:
                case 10:
                case 14:
                case 8:
                  return true;
                default:
                  return false;
              }
            }
            e2.isPropertyNameLiteral = Jf;
            function w_(c) {
              return e2.isMemberName(c) ? e2.idText(c) : c.text;
            }
            e2.getTextOfIdentifierOrLiteral = w_;
            function ud(c) {
              return e2.isMemberName(c) ? c.escapedText : e2.escapeLeadingUnderscores(c.text);
            }
            e2.getEscapedTextOfIdentifierOrLiteral = ud;
            function ku(c) {
              return "__@".concat(e2.getSymbolId(c), "@").concat(c.escapedName);
            }
            e2.getPropertyNameForUniqueESSymbol = ku;
            function ld(c, te) {
              return "__#".concat(e2.getSymbolId(c), "@").concat(te);
            }
            e2.getSymbolNameForPrivateIdentifier = ld;
            function fd(c) {
              return e2.startsWith(c.escapedName, "__@");
            }
            e2.isKnownSymbol = fd;
            function bp(c) {
              return e2.startsWith(c.escapedName, "__#");
            }
            e2.isPrivateIdentifierSymbol = bp;
            function Sp(c) {
              return c.kind === 79 && c.escapedText === "Symbol";
            }
            e2.isESSymbolIdentifier = Sp;
            function Tp(c) {
              return c.escapedText === "push" || c.escapedText === "unshift";
            }
            e2.isPushOrUnshiftIdentifier = Tp;
            function _d2(c) {
              var te = jf(c);
              return te.kind === 164;
            }
            e2.isParameterDeclaration = _d2;
            function jf(c) {
              for (; c.kind === 203; )
                c = c.parent.parent;
              return c;
            }
            e2.getRootDeclaration = jf;
            function O_(c) {
              var te = c.kind;
              return te === 171 || te === 213 || te === 256 || te === 214 || te === 169 || te === 172 || te === 173 || te === 261 || te === 305;
            }
            e2.nodeStartsNewLexicalEnvironment = O_;
            function F_(c) {
              return Jl(c.pos) || Jl(c.end);
            }
            e2.nodeIsSynthesized = F_;
            function pd(c) {
              return e2.getParseTreeNode(c, e2.isSourceFile) || c;
            }
            e2.getOriginalSourceFile = pd;
            var xp;
            (function(c) {
              c[c.Left = 0] = "Left", c[c.Right = 1] = "Right";
            })(xp = e2.Associativity || (e2.Associativity = {}));
            function M_(c) {
              var te = Au(c), xr = c.kind === 209 && c.arguments !== void 0;
              return Ep(c.kind, te, xr);
            }
            e2.getExpressionAssociativity = M_;
            function Ep(c, te, xr) {
              switch (c) {
                case 209:
                  return xr ? 0 : 1;
                case 219:
                case 216:
                case 217:
                case 215:
                case 218:
                case 222:
                case 224:
                  return 1;
                case 221:
                  switch (te) {
                    case 42:
                    case 63:
                    case 64:
                    case 65:
                    case 67:
                    case 66:
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 78:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                      return 1;
                  }
              }
              return 0;
            }
            e2.getOperatorAssociativity = Ep;
            function ol(c) {
              var te = Au(c), xr = c.kind === 209 && c.arguments !== void 0;
              return yf(c.kind, te, xr);
            }
            e2.getExpressionPrecedence = ol;
            function Au(c) {
              return c.kind === 221 ? c.operatorToken.kind : c.kind === 219 || c.kind === 220 ? c.operator : c.kind;
            }
            e2.getOperator = Au;
            var ru;
            (function(c) {
              c[c.Comma = 0] = "Comma", c[c.Spread = 1] = "Spread", c[c.Yield = 2] = "Yield", c[c.Assignment = 3] = "Assignment", c[c.Conditional = 4] = "Conditional", c[c.Coalesce = 4] = "Coalesce", c[c.LogicalOR = 5] = "LogicalOR", c[c.LogicalAND = 6] = "LogicalAND", c[c.BitwiseOR = 7] = "BitwiseOR", c[c.BitwiseXOR = 8] = "BitwiseXOR", c[c.BitwiseAND = 9] = "BitwiseAND", c[c.Equality = 10] = "Equality", c[c.Relational = 11] = "Relational", c[c.Shift = 12] = "Shift", c[c.Additive = 13] = "Additive", c[c.Multiplicative = 14] = "Multiplicative", c[c.Exponentiation = 15] = "Exponentiation", c[c.Unary = 16] = "Unary", c[c.Update = 17] = "Update", c[c.LeftHandSide = 18] = "LeftHandSide", c[c.Member = 19] = "Member", c[c.Primary = 20] = "Primary", c[c.Highest = 20] = "Highest", c[c.Lowest = 0] = "Lowest", c[c.Invalid = -1] = "Invalid";
            })(ru = e2.OperatorPrecedence || (e2.OperatorPrecedence = {}));
            function yf(c, te, xr) {
              switch (c) {
                case 351:
                  return 0;
                case 225:
                  return 1;
                case 224:
                  return 2;
                case 222:
                  return 4;
                case 221:
                  switch (te) {
                    case 27:
                      return 0;
                    case 63:
                    case 64:
                    case 65:
                    case 67:
                    case 66:
                    case 68:
                    case 69:
                    case 70:
                    case 71:
                    case 72:
                    case 73:
                    case 78:
                    case 74:
                    case 75:
                    case 76:
                    case 77:
                      return 3;
                    default:
                      return Cp(te);
                  }
                case 211:
                case 230:
                case 219:
                case 216:
                case 217:
                case 215:
                case 218:
                  return 16;
                case 220:
                  return 17;
                case 208:
                  return 18;
                case 209:
                  return xr ? 19 : 18;
                case 210:
                case 206:
                case 207:
                case 231:
                  return 19;
                case 229:
                  return 11;
                case 108:
                case 106:
                case 79:
                case 80:
                case 104:
                case 110:
                case 95:
                case 8:
                case 9:
                case 10:
                case 204:
                case 205:
                case 213:
                case 214:
                case 226:
                case 13:
                case 14:
                case 223:
                case 212:
                case 227:
                case 278:
                case 279:
                case 282:
                  return 20;
                default:
                  return -1;
              }
            }
            e2.getOperatorPrecedence = yf;
            function Cp(c) {
              switch (c) {
                case 60:
                  return 4;
                case 56:
                  return 5;
                case 55:
                  return 6;
                case 51:
                  return 7;
                case 52:
                  return 8;
                case 50:
                  return 9;
                case 34:
                case 35:
                case 36:
                case 37:
                  return 10;
                case 29:
                case 31:
                case 32:
                case 33:
                case 102:
                case 101:
                case 127:
                  return 11;
                case 47:
                case 48:
                case 49:
                  return 12;
                case 39:
                case 40:
                  return 13;
                case 41:
                case 43:
                case 44:
                  return 14;
                case 42:
                  return 15;
              }
              return -1;
            }
            e2.getBinaryOperatorPrecedence = Cp;
            function dd(c) {
              return e2.filter(c, function(te) {
                switch (te.kind) {
                  case 288:
                    return !!te.expression;
                  case 11:
                    return !te.containsOnlyTriviaWhiteSpaces;
                  default:
                    return true;
                }
              });
            }
            e2.getSemanticJsxChildren = dd;
            function kp() {
              var c = [], te = [], xr = new e2.Map(), ei = false;
              return { add: Ft, lookup: bi, getGlobalDiagnostics: ot, getDiagnostics: xa };
              function bi(mn) {
                var an;
                if (mn.file ? an = xr.get(mn.file.fileName) : an = c, !!an) {
                  var To = e2.binarySearch(an, mn, e2.identity, _g);
                  if (To >= 0)
                    return an[To];
                }
              }
              function Ft(mn) {
                var an;
                mn.file ? (an = xr.get(mn.file.fileName), an || (an = [], xr.set(mn.file.fileName, an), e2.insertSorted(te, mn.file.fileName, e2.compareStringsCaseSensitive))) : (ei && (ei = false, c = c.slice()), an = c), e2.insertSorted(an, mn, Qg);
              }
              function ot() {
                return ei = true, c;
              }
              function xa(mn) {
                if (mn)
                  return xr.get(mn) || [];
                var an = e2.flatMapToMutable(te, function(To) {
                  return xr.get(To);
                });
                return c.length && an.unshift.apply(an, c), an;
              }
            }
            e2.createDiagnosticCollection = kp;
            var mu = /\$\{/g;
            function gd(c) {
              return c.replace(mu, "\\${");
            }
            function hf(c) {
              return c && !!(e2.isNoSubstitutionTemplateLiteral(c) ? c.templateFlags : c.head.templateFlags || e2.some(c.templateSpans, function(te) {
                return !!te.literal.templateFlags;
              }));
            }
            e2.hasInvalidEscape = hf;
            var $l = /[\\\"\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g, Uf = /[\\\'\u0000-\u001f\t\v\f\b\r\n\u2028\u2029\u0085]/g, L_ = /\r\n|[\\\`\u0000-\u001f\t\v\f\b\r\u2028\u2029\u0085]/g, l_ = new e2.Map(e2.getEntries({ "	": "\\t", "\v": "\\v", "\f": "\\f", "\b": "\\b", "\r": "\\r", "\n": "\\n", "\\": "\\\\", '"': '\\"', "'": "\\'", "`": "\\`", "\u2028": "\\u2028", "\u2029": "\\u2029", "\x85": "\\u0085", "\r\n": "\\r\\n" }));
            function f_(c) {
              var te = c.toString(16).toUpperCase(), xr = ("0000" + te).slice(-4);
              return "\\u" + xr;
            }
            function md(c, te, xr) {
              if (c.charCodeAt(0) === 0) {
                var ei = xr.charCodeAt(te + c.length);
                return ei >= 48 && ei <= 57 ? "\\x00" : "\\0";
              }
              return l_.get(c) || f_(c.charCodeAt(0));
            }
            function ks(c, te) {
              var xr = te === 96 ? L_ : te === 39 ? Uf : $l;
              return c.replace(xr, md);
            }
            e2.escapeString = ks;
            var Wu = /[^\u0000-\u007F]/g;
            function Zl(c, te) {
              return c = ks(c, te), Wu.test(c) ? c.replace(Wu, function(xr) {
                return f_(xr.charCodeAt(0));
              }) : c;
            }
            e2.escapeNonAsciiString = Zl;
            var R_ = /[\"\u0000-\u001f\u2028\u2029\u0085]/g, kl = /[\'\u0000-\u001f\u2028\u2029\u0085]/g, __ = new e2.Map(e2.getEntries({ '"': "&quot;", "'": "&apos;" }));
            function zd(c) {
              var te = c.toString(16).toUpperCase();
              return "&#x" + te + ";";
            }
            function Al(c) {
              return c.charCodeAt(0) === 0 ? "&#0;" : __.get(c) || zd(c.charCodeAt(0));
            }
            function wc(c, te) {
              var xr = te === 39 ? kl : R_;
              return c.replace(xr, Al);
            }
            e2.escapeJsxAttributeString = wc;
            function qu(c) {
              var te = c.length;
              return te >= 2 && c.charCodeAt(0) === c.charCodeAt(te - 1) && Vu(c.charCodeAt(0)) ? c.substring(1, te - 1) : c;
            }
            e2.stripQuotes = qu;
            function Vu(c) {
              return c === 39 || c === 34 || c === 96;
            }
            function ef(c) {
              var te = c.charCodeAt(0);
              return te >= 97 && te <= 122 || e2.stringContains(c, "-") || e2.stringContains(c, ":");
            }
            e2.isIntrinsicJsxName = ef;
            var sl = ["", "    "];
            function p_(c) {
              for (var te = sl[1], xr = sl.length; xr <= c; xr++)
                sl.push(sl[xr - 1] + te);
              return sl[c];
            }
            e2.getIndentString = p_;
            function Df() {
              return sl[1].length;
            }
            e2.getIndentSize = Df;
            function Ec() {
              return e2.stringContains(e2.version, "-dev") || e2.stringContains(e2.version, "-insiders");
            }
            e2.isNightly = Ec;
            function Zn(c) {
              var te, xr, ei, bi, Ft, ot = false;
              function xa(Xo) {
                var jl = e2.computeLineStarts(Xo);
                jl.length > 1 ? (bi = bi + jl.length - 1, Ft = te.length - Xo.length + e2.last(jl), ei = Ft - te.length === 0) : ei = false;
              }
              function mn(Xo) {
                Xo && Xo.length && (ei && (Xo = p_(xr) + Xo, ei = false), te += Xo, xa(Xo));
              }
              function an(Xo) {
                Xo && (ot = false), mn(Xo);
              }
              function To(Xo) {
                Xo && (ot = true), mn(Xo);
              }
              function Hn() {
                te = "", xr = 0, ei = true, bi = 0, Ft = 0, ot = false;
              }
              function ss(Xo) {
                Xo !== void 0 && (te += Xo, xa(Xo), ot = false);
              }
              function cs(Xo) {
                Xo && Xo.length && an(Xo);
              }
              function ws(Xo) {
                (!ei || Xo) && (te += c, bi++, Ft = te.length, ei = true, ot = false);
              }
              function nu() {
                return ei ? te.length : te.length + c.length;
              }
              return Hn(), { write: an, rawWrite: ss, writeLiteral: cs, writeLine: ws, increaseIndent: function() {
                xr++;
              }, decreaseIndent: function() {
                xr--;
              }, getIndent: function() {
                return xr;
              }, getTextPos: function() {
                return te.length;
              }, getLine: function() {
                return bi;
              }, getColumn: function() {
                return ei ? xr * Df() : te.length - Ft;
              }, getText: function() {
                return te;
              }, isAtStartOfLine: function() {
                return ei;
              }, hasTrailingComment: function() {
                return ot;
              }, hasTrailingWhitespace: function() {
                return !!te.length && e2.isWhiteSpaceLike(te.charCodeAt(te.length - 1));
              }, clear: Hn, reportInaccessibleThisError: e2.noop, reportPrivateInBaseOfClassExpression: e2.noop, reportInaccessibleUniqueSymbolError: e2.noop, trackSymbol: function() {
                return false;
              }, writeKeyword: an, writeOperator: an, writeParameter: an, writeProperty: an, writePunctuation: an, writeSpace: an, writeStringLiteral: an, writeSymbol: function(Xo, jl) {
                return an(Xo);
              }, writeTrailingSemicolon: an, writeComment: To, getTextPosWithWriteLine: nu };
            }
            e2.createTextWriter = Zn;
            function os(c) {
              var te = false;
              function xr() {
                te && (c.writeTrailingSemicolon(";"), te = false);
              }
              return Ke(Ke({}, c), { writeTrailingSemicolon: function() {
                te = true;
              }, writeLiteral: function(ei) {
                xr(), c.writeLiteral(ei);
              }, writeStringLiteral: function(ei) {
                xr(), c.writeStringLiteral(ei);
              }, writeSymbol: function(ei, bi) {
                xr(), c.writeSymbol(ei, bi);
              }, writePunctuation: function(ei) {
                xr(), c.writePunctuation(ei);
              }, writeKeyword: function(ei) {
                xr(), c.writeKeyword(ei);
              }, writeOperator: function(ei) {
                xr(), c.writeOperator(ei);
              }, writeParameter: function(ei) {
                xr(), c.writeParameter(ei);
              }, writeSpace: function(ei) {
                xr(), c.writeSpace(ei);
              }, writeProperty: function(ei) {
                xr(), c.writeProperty(ei);
              }, writeComment: function(ei) {
                xr(), c.writeComment(ei);
              }, writeLine: function() {
                xr(), c.writeLine();
              }, increaseIndent: function() {
                xr(), c.increaseIndent();
              }, decreaseIndent: function() {
                xr(), c.decreaseIndent();
              } });
            }
            e2.getTrailingSemicolonDeferringWriter = os;
            function Ps(c) {
              return c.useCaseSensitiveFileNames ? c.useCaseSensitiveFileNames() : false;
            }
            e2.hostUsesCaseSensitiveFileNames = Ps;
            function d_(c) {
              return e2.createGetCanonicalFileName(Ps(c));
            }
            e2.hostGetCanonicalFileName = d_;
            function Gc(c, te, xr) {
              return te.moduleName || Gt(c, te.fileName, xr && xr.fileName);
            }
            e2.getResolvedExternalModuleName = Gc;
            function B_(c, te) {
              return c.getCanonicalFileName(e2.getNormalizedAbsolutePath(te, c.getCurrentDirectory()));
            }
            function vu(c, te, xr) {
              var ei = te.getExternalModuleFileFromDeclaration(xr);
              if (!(!ei || ei.isDeclarationFile)) {
                var bi = eu(xr);
                if (!(bi && e2.isStringLiteralLike(bi) && !e2.pathIsRelative(bi.text) && B_(c, ei.path).indexOf(B_(c, e2.ensureTrailingDirectorySeparator(c.getCommonSourceDirectory()))) === -1))
                  return Gc(c, ei);
              }
            }
            e2.getExternalModuleNameFromDeclaration = vu;
            function Gt(c, te, xr) {
              var ei = function(mn) {
                return c.getCanonicalFileName(mn);
              }, bi = e2.toPath(xr ? e2.getDirectoryPath(xr) : c.getCommonSourceDirectory(), c.getCurrentDirectory(), ei), Ft = e2.getNormalizedAbsolutePath(te, c.getCurrentDirectory()), ot = e2.getRelativePathToDirectoryOrUrl(bi, Ft, bi, ei, false), xa = Gd(ot);
              return xr ? e2.ensurePathIsNonModuleName(xa) : xa;
            }
            e2.getExternalModuleNameFromPath = Gt;
            function As(c, te, xr) {
              var ei = te.getCompilerOptions(), bi;
              return ei.outDir ? bi = Gd(Dc(c, te, ei.outDir)) : bi = Gd(c), bi + xr;
            }
            e2.getOwnEmitOutputFilePath = As;
            function vn(c, te) {
              return Nl(c, te.getCompilerOptions(), te.getCurrentDirectory(), te.getCommonSourceDirectory(), function(xr) {
                return te.getCanonicalFileName(xr);
              });
            }
            e2.getDeclarationEmitOutputFilePath = vn;
            function Nl(c, te, xr, ei, bi) {
              var Ft = te.declarationDir || te.outDir, ot = Ft ? Cc(c, Ft, xr, ei, bi) : c, xa = cl(ot);
              return Gd(ot) + xa;
            }
            e2.getDeclarationEmitOutputFilePathWorker = Nl;
            function cl(c) {
              return e2.fileExtensionIsOneOf(c, [".mjs", ".mts"]) ? ".d.mts" : e2.fileExtensionIsOneOf(c, [".cjs", ".cts"]) ? ".d.cts" : e2.fileExtensionIsOneOf(c, [".json"]) ? ".json.d.ts" : ".d.ts";
            }
            e2.getDeclarationEmitExtensionForPath = cl;
            function rf(c) {
              return e2.fileExtensionIsOneOf(c, [".d.mts", ".mjs", ".mts"]) ? [".mts", ".mjs"] : e2.fileExtensionIsOneOf(c, [".d.cts", ".cjs", ".cts"]) ? [".cts", ".cjs"] : e2.fileExtensionIsOneOf(c, [".json.d.ts"]) ? [".json"] : [".tsx", ".ts", ".jsx", ".js"];
            }
            e2.getPossibleOriginalInputExtensionForExtension = rf;
            function Ut(c) {
              return c.outFile || c.out;
            }
            e2.outFile = Ut;
            function Ds(c, te) {
              var xr, ei;
              if (!!c.paths)
                return (xr = c.baseUrl) !== null && xr !== void 0 ? xr : e2.Debug.checkDefined(c.pathsBasePath || ((ei = te.getCurrentDirectory) === null || ei === void 0 ? void 0 : ei.call(te)), "Encountered 'paths' without a 'baseUrl', config file, or host 'getCurrentDirectory'.");
            }
            e2.getPathsBasePath = Ds;
            function bf(c, te, xr) {
              var ei = c.getCompilerOptions();
              if (Ut(ei)) {
                var bi = Ja(ei), Ft = ei.emitDeclarationOnly || bi === e2.ModuleKind.AMD || bi === e2.ModuleKind.System;
                return e2.filter(c.getSourceFiles(), function(xa) {
                  return (Ft || !e2.isExternalModule(xa)) && bs(xa, c, xr);
                });
              } else {
                var ot = te === void 0 ? c.getSourceFiles() : [te];
                return e2.filter(ot, function(xa) {
                  return bs(xa, c, xr);
                });
              }
            }
            e2.getSourceFilesToEmit = bf;
            function bs(c, te, xr) {
              var ei = te.getCompilerOptions();
              return !(ei.noEmitForJsFiles && Pi(c)) && !c.isDeclarationFile && !te.isSourceFileFromExternalLibrary(c) && (xr || !(Mr(c) && te.getResolvedProjectReferenceToRedirect(c.fileName)) && !te.isSourceOfProjectReferenceRedirect(c.fileName));
            }
            e2.sourceFileMayBeEmitted = bs;
            function Dc(c, te, xr) {
              return Cc(c, xr, te.getCurrentDirectory(), te.getCommonSourceDirectory(), function(ei) {
                return te.getCanonicalFileName(ei);
              });
            }
            e2.getSourceFilePathInNewDir = Dc;
            function Cc(c, te, xr, ei, bi) {
              var Ft = e2.getNormalizedAbsolutePath(c, xr), ot = bi(Ft).indexOf(bi(ei)) === 0;
              return Ft = ot ? Ft.substring(ei.length) : Ft, e2.combinePaths(te, Ft);
            }
            e2.getSourceFilePathInNewDirWorker = Cc;
            function ac(c, te, xr, ei, bi, Ft, ot) {
              c.writeFile(xr, ei, bi, function(xa) {
                te.add(qd(e2.Diagnostics.Could_not_write_file_0_Colon_1, xr, xa));
              }, Ft, ot);
            }
            e2.writeFile = ac;
            function Pl(c, te, xr) {
              if (c.length > e2.getRootLength(c) && !xr(c)) {
                var ei = e2.getDirectoryPath(c);
                Pl(ei, te, xr), te(c);
              }
            }
            function Il(c, te, xr, ei, bi, Ft) {
              try {
                ei(c, te, xr);
              } catch {
                Pl(e2.getDirectoryPath(e2.normalizePath(c)), bi, Ft), ei(c, te, xr);
              }
            }
            e2.writeFileEnsuringDirectories = Il;
            function zf(c, te) {
              var xr = e2.getLineStarts(c);
              return e2.computeLineOfPosition(xr, te);
            }
            e2.getLineOfLocalPosition = zf;
            function ul(c, te) {
              return e2.computeLineOfPosition(c, te);
            }
            e2.getLineOfLocalPositionFromLineMap = ul;
            function Nu(c) {
              return e2.find(c.members, function(te) {
                return e2.isConstructorDeclaration(te) && j(te.body);
              });
            }
            e2.getFirstConstructorWithBody = Nu;
            function Us(c) {
              if (c && c.parameters.length > 0) {
                var te = c.parameters.length === 2 && Sf(c.parameters[0]);
                return c.parameters[te ? 1 : 0];
              }
            }
            e2.getSetAccessorValueParameter = Us;
            function Ap(c) {
              var te = Us(c);
              return te && te.type;
            }
            e2.getSetAccessorTypeAnnotationNode = Ap;
            function Wf(c) {
              if (c.parameters.length && !e2.isJSDocSignature(c)) {
                var te = c.parameters[0];
                if (Sf(te))
                  return te;
              }
            }
            e2.getThisParameter = Wf;
            function Sf(c) {
              return ll(c.name);
            }
            e2.parameterIsThisKeyword = Sf;
            function ll(c) {
              return !!c && c.kind === 79 && j_(c);
            }
            e2.isThisIdentifier = ll;
            function J_(c) {
              if (!ll(c))
                return false;
              for (; e2.isQualifiedName(c.parent) && c.parent.left === c; )
                c = c.parent;
              return c.parent.kind === 181;
            }
            e2.isThisInTypeQuery = J_;
            function j_(c) {
              return c.originalKeywordKind === 108;
            }
            e2.identifierIsThisKeyword = j_;
            function U_(c, te) {
              var xr, ei, bi, Ft;
              return hc(te) ? (xr = te, te.kind === 172 ? bi = te : te.kind === 173 ? Ft = te : e2.Debug.fail("Accessor has wrong kind")) : e2.forEach(c, function(ot) {
                if (e2.isAccessor(ot) && Tf(ot) === Tf(te)) {
                  var xa = u_(ot.name), mn = u_(te.name);
                  xa === mn && (xr ? ei || (ei = ot) : xr = ot, ot.kind === 172 && !bi && (bi = ot), ot.kind === 173 && !Ft && (Ft = ot));
                }
              }), { firstAccessor: xr, secondAccessor: ei, getAccessor: bi, setAccessor: Ft };
            }
            e2.getAllAccessorDeclarations = U_;
            function iu(c) {
              if (!(!Ct(c) && e2.isFunctionDeclaration(c))) {
                var te = c.type;
                return te || !Ct(c) ? te : e2.isJSDocPropertyLikeTag(c) ? c.typeExpression && c.typeExpression.type : e2.getJSDocType(c);
              }
            }
            e2.getEffectiveTypeAnnotationNode = iu;
            function vd(c) {
              return c.type;
            }
            e2.getTypeAnnotationNode = vd;
            function qf(c) {
              return e2.isJSDocSignature(c) ? c.type && c.type.typeExpression && c.type.typeExpression.type : c.type || (Ct(c) ? e2.getJSDocReturnType(c) : void 0);
            }
            e2.getEffectiveReturnTypeNode = qf;
            function dc(c) {
              return e2.flatMap(e2.getJSDocTags(c), function(te) {
                return Pu(te) ? te.typeParameters : void 0;
              });
            }
            e2.getJSDocTypeParameterDeclarations = dc;
            function Pu(c) {
              return e2.isJSDocTemplateTag(c) && !(c.parent.kind === 320 && c.parent.tags.some(Ya));
            }
            function wl(c) {
              var te = Us(c);
              return te && iu(te);
            }
            e2.getEffectiveSetAccessorTypeAnnotationNode = wl;
            function Iu(c, te, xr, ei) {
              so(c, te, xr.pos, ei);
            }
            e2.emitNewLineBeforeLeadingComments = Iu;
            function so(c, te, xr, ei) {
              ei && ei.length && xr !== ei[0].pos && ul(c, xr) !== ul(c, ei[0].pos) && te.writeLine();
            }
            e2.emitNewLineBeforeLeadingCommentsOfPosition = so;
            function Et(c, te, xr, ei) {
              xr !== ei && ul(c, xr) !== ul(c, ei) && te.writeLine();
            }
            e2.emitNewLineBeforeLeadingCommentOfPosition = Et;
            function Ys(c, te, xr, ei, bi, Ft, ot, xa) {
              if (ei && ei.length > 0) {
                bi && xr.writeSpace(" ");
                for (var mn = false, an = 0, To = ei; an < To.length; an++) {
                  var Hn = To[an];
                  mn && (xr.writeSpace(" "), mn = false), xa(c, te, xr, Hn.pos, Hn.end, ot), Hn.hasTrailingNewLine ? xr.writeLine() : mn = true;
                }
                mn && Ft && xr.writeSpace(" ");
              }
            }
            e2.emitComments = Ys;
            function Ku(c, te, xr, ei, bi, Ft, ot) {
              var xa, mn;
              if (ot ? bi.pos === 0 && (xa = e2.filter(e2.getLeadingCommentRanges(c, bi.pos), jl)) : xa = e2.getLeadingCommentRanges(c, bi.pos), xa) {
                for (var an = [], To = void 0, Hn = 0, ss = xa; Hn < ss.length; Hn++) {
                  var cs = ss[Hn];
                  if (To) {
                    var ws = ul(te, To.end), nu = ul(te, cs.pos);
                    if (nu >= ws + 2)
                      break;
                  }
                  an.push(cs), To = cs;
                }
                if (an.length) {
                  var ws = ul(te, e2.last(an).end), Xo = ul(te, e2.skipTrivia(c, bi.pos));
                  Xo >= ws + 2 && (Iu(te, xr, bi, xa), Ys(c, te, xr, an, false, true, Ft, ei), mn = { nodePos: bi.pos, detachedCommentEndPos: e2.last(an).end });
                }
              }
              return mn;
              function jl(Y_) {
                return ue(c, Y_.pos);
              }
            }
            e2.emitDetachedComments = Ku;
            function Np(c, te, xr, ei, bi, Ft) {
              if (c.charCodeAt(ei + 1) === 42)
                for (var ot = e2.computeLineAndCharacterOfPosition(te, ei), xa = te.length, mn = void 0, an = ei, To = ot.line; an < bi; To++) {
                  var Hn = To + 1 === xa ? c.length + 1 : te[To + 1];
                  if (an !== ei) {
                    mn === void 0 && (mn = nc(c, te[ot.line], ei));
                    var ss = xr.getIndent() * Df(), cs = ss - mn + nc(c, an, Hn);
                    if (cs > 0) {
                      var ws = cs % Df(), nu = p_((cs - ws) / Df());
                      for (xr.rawWrite(nu); ws; )
                        xr.rawWrite(" "), ws--;
                    } else
                      xr.rawWrite("");
                  }
                  Pp(c, bi, xr, Ft, an, Hn), an = Hn;
                }
              else
                xr.writeComment(c.substring(ei, bi));
            }
            e2.writeCommentRange = Np;
            function Pp(c, te, xr, ei, bi, Ft) {
              var ot = Math.min(te, Ft - 1), xa = e2.trimString(c.substring(bi, ot));
              xa ? (xr.writeComment(xa), ot !== te && xr.writeLine()) : xr.rawWrite(ei);
            }
            function nc(c, te, xr) {
              for (var ei = 0; te < xr && e2.isWhiteSpaceSingleLine(c.charCodeAt(te)); te++)
                c.charCodeAt(te) === 9 ? ei += Df() - ei % Df() : ei++;
              return ei;
            }
            function fl(c) {
              return xf(c) !== 0;
            }
            e2.hasEffectiveModifiers = fl;
            function _l(c) {
              return Oc(c) !== 0;
            }
            e2.hasSyntacticModifiers = _l;
            function cu(c, te) {
              return !!Hc(c, te);
            }
            e2.hasEffectiveModifier = cu;
            function gc(c, te) {
              return !!Ol(c, te);
            }
            e2.hasSyntacticModifier = gc;
            function Tf(c) {
              return e2.isClassElement(c) && mc(c) || e2.isClassStaticBlockDeclaration(c);
            }
            e2.isStatic = Tf;
            function mc(c) {
              return gc(c, 32);
            }
            e2.hasStaticModifier = mc;
            function Ip(c) {
              return cu(c, 16384);
            }
            e2.hasOverrideModifier = Ip;
            function ms(c) {
              return gc(c, 128);
            }
            e2.hasAbstractModifier = ms;
            function tu(c) {
              return gc(c, 2);
            }
            e2.hasAmbientModifier = tu;
            function wp(c) {
              return cu(c, 64);
            }
            e2.hasEffectiveReadonlyModifier = wp;
            function Hc(c, te) {
              return xf(c) & te;
            }
            e2.getSelectedEffectiveModifierFlags = Hc;
            function Ol(c, te) {
              return Oc(c) & te;
            }
            e2.getSelectedSyntacticModifierFlags = Ol;
            function tf(c, te, xr) {
              return c.kind >= 0 && c.kind <= 160 ? 0 : (c.modifierFlagsCache & 536870912 || (c.modifierFlagsCache = Ef(c) | 536870912), te && !(c.modifierFlagsCache & 4096) && (xr || Ct(c)) && c.parent && (c.modifierFlagsCache |= rs(c) | 4096), c.modifierFlagsCache & -536875009);
            }
            function xf(c) {
              return tf(c, true);
            }
            e2.getEffectiveModifierFlags = xf;
            function z_(c) {
              return tf(c, true, true);
            }
            e2.getEffectiveModifierFlagsAlwaysIncludeJSDoc = z_;
            function Oc(c) {
              return tf(c, false);
            }
            e2.getSyntacticModifierFlags = Oc;
            function rs(c) {
              var te = 0;
              return !!c.parent && !e2.isParameter(c) && (Ct(c) && (e2.getJSDocPublicTagNoCache(c) && (te |= 4), e2.getJSDocPrivateTagNoCache(c) && (te |= 8), e2.getJSDocProtectedTagNoCache(c) && (te |= 16), e2.getJSDocReadonlyTagNoCache(c) && (te |= 64), e2.getJSDocOverrideTagNoCache(c) && (te |= 16384)), e2.getJSDocDeprecatedTagNoCache(c) && (te |= 8192)), te;
            }
            function Op(c) {
              return Ef(c) | rs(c);
            }
            e2.getEffectiveModifierFlagsNoCache = Op;
            function Ef(c) {
              var te = Fl(c.modifiers);
              return (c.flags & 4 || c.kind === 79 && c.isInJSDocNamespace) && (te |= 1), te;
            }
            e2.getSyntacticModifierFlagsNoCache = Ef;
            function Fl(c) {
              var te = 0;
              if (c)
                for (var xr = 0, ei = c; xr < ei.length; xr++) {
                  var bi = ei[xr];
                  te |= pl(bi.kind);
                }
              return te;
            }
            e2.modifiersToFlags = Fl;
            function pl(c) {
              switch (c) {
                case 124:
                  return 32;
                case 123:
                  return 4;
                case 122:
                  return 16;
                case 121:
                  return 8;
                case 126:
                  return 128;
                case 93:
                  return 1;
                case 135:
                  return 2;
                case 85:
                  return 2048;
                case 88:
                  return 512;
                case 131:
                  return 256;
                case 145:
                  return 64;
                case 159:
                  return 16384;
                case 101:
                  return 32768;
                case 144:
                  return 65536;
              }
              return 0;
            }
            e2.modifierToFlag = pl;
            function Fp(c) {
              return c ? e2.factory.createNodeArray(e2.factory.createModifiersFromModifierFlags(c)) : void 0;
            }
            e2.createModifiers = Fp;
            function Mp(c) {
              return c === 56 || c === 55 || c === 53;
            }
            e2.isLogicalOperator = Mp;
            function Gu(c) {
              return c === 75 || c === 76 || c === 77;
            }
            e2.isLogicalOrCoalescingAssignmentOperator = Gu;
            function Lp(c) {
              return Gu(c.operatorToken.kind);
            }
            e2.isLogicalOrCoalescingAssignmentExpression = Lp;
            function Cf(c) {
              return c >= 63 && c <= 78;
            }
            e2.isAssignmentOperator = Cf;
            function W_(c) {
              var te = g_(c);
              return te && !te.isImplements ? te.class : void 0;
            }
            e2.tryGetClassExtendingExpressionWithTypeArguments = W_;
            function g_(c) {
              return e2.isExpressionWithTypeArguments(c) && e2.isHeritageClause(c.parent) && e2.isClassLike(c.parent.parent) ? { class: c.parent.parent, isImplements: c.parent.token === 117 } : void 0;
            }
            e2.tryGetClassImplementingOrExtendingExpressionWithTypeArguments = g_;
            function dl(c, te) {
              return e2.isBinaryExpression(c) && (te ? c.operatorToken.kind === 63 : Cf(c.operatorToken.kind)) && e2.isLeftHandSideExpression(c.left);
            }
            e2.isAssignmentExpression = dl;
            function gl(c) {
              return dl(c.parent) && c.parent.left === c;
            }
            e2.isLeftHandSideOfAssignment = gl;
            function Vf(c) {
              if (dl(c, true)) {
                var te = c.left.kind;
                return te === 205 || te === 204;
              }
              return false;
            }
            e2.isDestructuringAssignment = Vf;
            function Fc(c) {
              return W_(c) !== void 0;
            }
            e2.isExpressionWithTypeArgumentsInClassExtendsClause = Fc;
            function Hu(c) {
              return c.kind === 79 || Ml(c);
            }
            e2.isEntityNameExpression = Hu;
            function af(c) {
              switch (c.kind) {
                case 79:
                  return c;
                case 161:
                  do
                    c = c.left;
                  while (c.kind !== 79);
                  return c;
                case 206:
                  do
                    c = c.expression;
                  while (c.kind !== 79);
                  return c;
              }
            }
            e2.getFirstIdentifier = af;
            function tn(c) {
              return c.kind === 79 || c.kind === 108 || c.kind === 106 || c.kind === 231 || c.kind === 206 && tn(c.expression) || c.kind === 212 && tn(c.expression);
            }
            e2.isDottedName = tn;
            function Ml(c) {
              return e2.isPropertyAccessExpression(c) && e2.isIdentifier(c.name) && Hu(c.expression);
            }
            e2.isPropertyAccessEntityNameExpression = Ml;
            function Ot(c) {
              if (e2.isPropertyAccessExpression(c)) {
                var te = Ot(c.expression);
                if (te !== void 0)
                  return te + "." + Xe(c.name);
              } else if (e2.isElementAccessExpression(c)) {
                var te = Ot(c.expression);
                if (te !== void 0 && e2.isPropertyName(c.argumentExpression))
                  return te + "." + u_(c.argumentExpression);
              } else if (e2.isIdentifier(c))
                return e2.unescapeLeadingUnderscores(c.escapedText);
            }
            e2.tryGetPropertyAccessOrIdentifierToString = Ot;
            function nf(c) {
              return ua(c) && Ao(c) === "prototype";
            }
            e2.isPrototypeAccess = nf;
            function q_(c) {
              return c.parent.kind === 161 && c.parent.right === c || c.parent.kind === 206 && c.parent.name === c;
            }
            e2.isRightSideOfQualifiedNameOrPropertyAccess = q_;
            function Kf(c) {
              return e2.isPropertyAccessExpression(c.parent) && c.parent.name === c || e2.isElementAccessExpression(c.parent) && c.parent.argumentExpression === c;
            }
            e2.isRightSideOfAccessExpression = Kf;
            function Rp(c) {
              return e2.isQualifiedName(c.parent) && c.parent.right === c || e2.isPropertyAccessExpression(c.parent) && c.parent.name === c || e2.isJSDocMemberName(c.parent) && c.parent.right === c;
            }
            e2.isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName = Rp;
            function yd(c) {
              return c.kind === 205 && c.properties.length === 0;
            }
            e2.isEmptyObjectLiteral = yd;
            function m_(c) {
              return c.kind === 204 && c.elements.length === 0;
            }
            e2.isEmptyArrayLiteral = m_;
            function Ll(c) {
              if (!(!hd(c) || !c.declarations))
                for (var te = 0, xr = c.declarations; te < xr.length; te++) {
                  var ei = xr[te];
                  if (ei.localSymbol)
                    return ei.localSymbol;
                }
            }
            e2.getLocalSymbolForExportDefault = Ll;
            function hd(c) {
              return c && e2.length(c.declarations) > 0 && gc(c.declarations[0], 512);
            }
            function v_(c) {
              return e2.find(oh, function(te) {
                return e2.fileExtensionIs(c, te);
              });
            }
            e2.tryExtractTSExtension = v_;
            function Bp(c) {
              for (var te = [], xr = c.length, ei = 0; ei < xr; ei++) {
                var bi = c.charCodeAt(ei);
                bi < 128 ? te.push(bi) : bi < 2048 ? (te.push(bi >> 6 | 192), te.push(bi & 63 | 128)) : bi < 65536 ? (te.push(bi >> 12 | 224), te.push(bi >> 6 & 63 | 128), te.push(bi & 63 | 128)) : bi < 131072 ? (te.push(bi >> 18 | 240), te.push(bi >> 12 & 63 | 128), te.push(bi >> 6 & 63 | 128), te.push(bi & 63 | 128)) : e2.Debug.assert(false, "Unexpected code point");
              }
              return te;
            }
            var Xu = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
            function Xc(c) {
              for (var te = "", xr = Bp(c), ei = 0, bi = xr.length, Ft, ot, xa, mn; ei < bi; )
                Ft = xr[ei] >> 2, ot = (xr[ei] & 3) << 4 | xr[ei + 1] >> 4, xa = (xr[ei + 1] & 15) << 2 | xr[ei + 2] >> 6, mn = xr[ei + 2] & 63, ei + 1 >= bi ? xa = mn = 64 : ei + 2 >= bi && (mn = 64), te += Xu.charAt(Ft) + Xu.charAt(ot) + Xu.charAt(xa) + Xu.charAt(mn), ei += 3;
              return te;
            }
            e2.convertToBase64 = Xc;
            function Gf(c) {
              for (var te = "", xr = 0, ei = c.length; xr < ei; ) {
                var bi = c[xr];
                if (bi < 128)
                  te += String.fromCharCode(bi), xr++;
                else if ((bi & 192) === 192) {
                  var Ft = bi & 63;
                  xr++;
                  for (var ot = c[xr]; (ot & 192) === 128; )
                    Ft = Ft << 6 | ot & 63, xr++, ot = c[xr];
                  te += String.fromCharCode(Ft);
                } else
                  te += String.fromCharCode(bi), xr++;
              }
              return te;
            }
            function of(c, te) {
              return c && c.base64encode ? c.base64encode(te) : Xc(te);
            }
            e2.base64encode = of;
            function wu(c, te) {
              if (c && c.base64decode)
                return c.base64decode(te);
              for (var xr = te.length, ei = [], bi = 0; bi < xr && te.charCodeAt(bi) !== Xu.charCodeAt(64); ) {
                var Ft = Xu.indexOf(te[bi]), ot = Xu.indexOf(te[bi + 1]), xa = Xu.indexOf(te[bi + 2]), mn = Xu.indexOf(te[bi + 3]), an = (Ft & 63) << 2 | ot >> 4 & 3, To = (ot & 15) << 4 | xa >> 2 & 15, Hn = (xa & 3) << 6 | mn & 63;
                To === 0 && xa !== 0 ? ei.push(an) : Hn === 0 && mn !== 0 ? ei.push(an, To) : ei.push(an, To, Hn), bi += 4;
              }
              return Gf(ei);
            }
            e2.base64decode = wu;
            function V_(c, te) {
              try {
                var xr = te.readFile(c);
                if (!xr)
                  return {};
                var ei = e2.parseConfigFileTextToJson(c, xr);
                return ei.error ? {} : ei.config;
              } catch {
                return {};
              }
            }
            e2.readJson = V_;
            function yu(c, te) {
              return !te.directoryExists || te.directoryExists(c);
            }
            e2.directoryProbablyExists = yu;
            var v = `\r
`, sr = `
`;
            function fi(c, te) {
              switch (c.newLine) {
                case 0:
                  return v;
                case 1:
                  return sr;
              }
              return te ? te() : e2.sys ? e2.sys.newLine : v;
            }
            e2.getNewLineCharacter = fi;
            function zi(c, te) {
              return te === void 0 && (te = c), e2.Debug.assert(te >= c || te === -1), { pos: c, end: te };
            }
            e2.createRange = zi;
            function Sa(c, te) {
              return zi(c.pos, te);
            }
            e2.moveRangeEnd = Sa;
            function da(c, te) {
              return zi(te, c.end);
            }
            e2.moveRangePos = da;
            function Ha(c) {
              return c.decorators && c.decorators.length > 0 ? da(c, c.decorators.end) : c;
            }
            e2.moveRangePastDecorators = Ha;
            function ta(c) {
              return c.modifiers && c.modifiers.length > 0 ? da(c, c.modifiers.end) : Ha(c);
            }
            e2.moveRangePastModifiers = ta;
            function nn(c) {
              return c.pos === c.end;
            }
            e2.isCollapsedRange = nn;
            function Wo(c, te) {
              return zi(c, c + e2.tokenToString(te).length);
            }
            e2.createTokenRange = Wo;
            function Lo(c, te) {
              return is(c, c, te);
            }
            e2.rangeIsOnSingleLine = Lo;
            function oc(c, te, xr) {
              return cf(uf(c, xr, false), uf(te, xr, false), xr);
            }
            e2.rangeStartPositionsAreOnSameLine = oc;
            function uu(c, te, xr) {
              return cf(c.end, te.end, xr);
            }
            e2.rangeEndPositionsAreOnSameLine = uu;
            function is(c, te, xr) {
              return cf(uf(c, xr, false), te.end, xr);
            }
            e2.rangeStartIsOnSameLineAsRangeEnd = is;
            function au(c, te, xr) {
              return cf(c.end, uf(te, xr, false), xr);
            }
            e2.rangeEndIsOnSameLineAsRangeStart = au;
            function Ou(c, te, xr, ei) {
              var bi = uf(te, xr, ei);
              return e2.getLinesBetweenPositions(xr, c.end, bi);
            }
            e2.getLinesBetweenRangeEndAndRangeStart = Ou;
            function sf(c, te, xr) {
              return e2.getLinesBetweenPositions(xr, c.end, te.end);
            }
            e2.getLinesBetweenRangeEndPositions = sf;
            function lu(c, te) {
              return !cf(c.pos, c.end, te);
            }
            e2.isNodeArrayMultiLine = lu;
            function cf(c, te, xr) {
              return e2.getLinesBetweenPositions(xr, c, te) === 0;
            }
            e2.positionsAreOnSameLine = cf;
            function uf(c, te, xr) {
              return Jl(c.pos) ? -1 : e2.skipTrivia(te.text, c.pos, false, xr);
            }
            e2.getStartPositionOfRange = uf;
            function K_(c, te, xr, ei) {
              var bi = e2.skipTrivia(xr.text, c, false, ei), Ft = Hf(bi, te, xr);
              return e2.getLinesBetweenPositions(xr, Ft != null ? Ft : te, bi);
            }
            e2.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter = K_;
            function Jp(c, te, xr, ei) {
              var bi = e2.skipTrivia(xr.text, c, false, ei);
              return e2.getLinesBetweenPositions(xr, c, Math.min(te, bi));
            }
            e2.getLinesBetweenPositionAndNextNonWhitespaceCharacter = Jp;
            function Hf(c, te, xr) {
              for (te === void 0 && (te = 0); c-- > te; )
                if (!e2.isWhiteSpaceLike(xr.text.charCodeAt(c)))
                  return c;
            }
            function kc(c) {
              var te = e2.getParseTreeNode(c);
              if (te)
                switch (te.parent.kind) {
                  case 260:
                  case 261:
                    return te === te.parent.name;
                }
              return false;
            }
            e2.isDeclarationNameOfEnumOrNamespace = kc;
            function G_(c) {
              return e2.filter(c.declarations, Le);
            }
            e2.getInitializedVariables = G_;
            function Le(c) {
              return c.initializer !== void 0;
            }
            function Nr(c) {
              return c.watch && c.hasOwnProperty("watch");
            }
            e2.isWatchSet = Nr;
            function ri(c) {
              c.close();
            }
            e2.closeFileWatcher = ri;
            function di(c) {
              return c.flags & 33554432 ? c.checkFlags : 0;
            }
            e2.getCheckFlags = di;
            function Mi(c, te) {
              if (te === void 0 && (te = false), c.valueDeclaration) {
                var xr = te && c.declarations && e2.find(c.declarations, function(xa) {
                  return xa.kind === 173;
                }) || c.valueDeclaration, ei = e2.getCombinedModifierFlags(xr);
                return c.parent && c.parent.flags & 32 ? ei : ei & -29;
              }
              if (di(c) & 6) {
                var bi = c.checkFlags, Ft = bi & 1024 ? 8 : bi & 256 ? 4 : 16, ot = bi & 2048 ? 32 : 0;
                return Ft | ot;
              }
              return c.flags & 4194304 ? 36 : 0;
            }
            e2.getDeclarationModifierFlagsFromSymbol = Mi;
            function st(c, te) {
              return c.flags & 2097152 ? te.getAliasedSymbol(c) : c;
            }
            e2.skipAlias = st;
            function ra(c) {
              return c.exportSymbol ? c.exportSymbol.flags | c.flags : c.flags;
            }
            e2.getCombinedLocalAndExportSymbolFlags = ra;
            function Ta(c) {
              return In(c) === 1;
            }
            e2.isWriteOnlyAccess = Ta;
            function ha(c) {
              return In(c) !== 0;
            }
            e2.isWriteAccess = ha;
            var Na;
            (function(c) {
              c[c.Read = 0] = "Read", c[c.Write = 1] = "Write", c[c.ReadWrite = 2] = "ReadWrite";
            })(Na || (Na = {}));
            function In(c) {
              var te = c.parent;
              if (!te)
                return 0;
              switch (te.kind) {
                case 212:
                  return In(te);
                case 220:
                case 219:
                  var xr = te.operator;
                  return xr === 45 || xr === 46 ? xa() : 0;
                case 221:
                  var ei = te, bi = ei.left, Ft = ei.operatorToken;
                  return bi === c && Cf(Ft.kind) ? Ft.kind === 63 ? 1 : xa() : 0;
                case 206:
                  return te.name !== c ? 0 : In(te);
                case 296: {
                  var ot = In(te.parent);
                  return c === te.name ? qo(ot) : ot;
                }
                case 297:
                  return c === te.objectAssignmentInitializer ? 0 : In(te.parent);
                case 204:
                  return In(te);
                default:
                  return 0;
              }
              function xa() {
                return te.parent && No(te.parent).kind === 238 ? 1 : 2;
              }
            }
            function qo(c) {
              switch (c) {
                case 0:
                  return 1;
                case 1:
                  return 0;
                case 2:
                  return 2;
                default:
                  return e2.Debug.assertNever(c);
              }
            }
            function co(c, te) {
              if (!c || !te || Object.keys(c).length !== Object.keys(te).length)
                return false;
              for (var xr in c)
                if (typeof c[xr] == "object") {
                  if (!co(c[xr], te[xr]))
                    return false;
                } else if (typeof c[xr] != "function" && c[xr] !== te[xr])
                  return false;
              return true;
            }
            e2.compareDataObjects = co;
            function ts(c, te) {
              c.forEach(te), c.clear();
            }
            e2.clearMap = ts;
            function vs(c, te, xr) {
              var ei = xr.onDeleteValue, bi = xr.onExistingValue;
              c.forEach(function(Ft, ot) {
                var xa = te.get(ot);
                xa === void 0 ? (c.delete(ot), ei(Ft, ot)) : bi && bi(Ft, xa, ot);
              });
            }
            e2.mutateMapSkippingNewValues = vs;
            function Ac(c, te, xr) {
              vs(c, te, xr);
              var ei = xr.createNewValue;
              te.forEach(function(bi, Ft) {
                c.has(Ft) || c.set(Ft, ei(Ft, bi));
              });
            }
            e2.mutateMap = Ac;
            function Is(c) {
              if (c.flags & 32) {
                var te = Qu(c);
                return !!te && gc(te, 128);
              }
              return false;
            }
            e2.isAbstractConstructorSymbol = Is;
            function Qu(c) {
              var te;
              return (te = c.declarations) === null || te === void 0 ? void 0 : te.find(e2.isClassLike);
            }
            e2.getClassLikeDeclarationOfSymbol = Qu;
            function sc(c) {
              return c.flags & 3899393 ? c.objectFlags : 0;
            }
            e2.getObjectFlags = sc;
            function bc(c, te) {
              return te.getSignaturesOfType(c, 0).length !== 0 || te.getSignaturesOfType(c, 1).length !== 0;
            }
            e2.typeHasCallOrConstructSignatures = bc;
            function Mc(c, te) {
              return !!e2.forEachAncestorDirectory(c, function(xr) {
                return te(xr) ? true : void 0;
              });
            }
            e2.forSomeAncestorDirectory = Mc;
            function Yu(c) {
              return !!c && !!c.declarations && !!c.declarations[0] && e2.isNamespaceExportDeclaration(c.declarations[0]);
            }
            e2.isUMDExportSymbol = Yu;
            function Rl(c) {
              var te = c.moduleSpecifier;
              return e2.isStringLiteral(te) ? te.text : Ee(te);
            }
            e2.showModuleSpecifier = Rl;
            function Lc(c) {
              var te;
              return e2.forEachChild(c, function(xr) {
                j(xr) && (te = xr);
              }, function(xr) {
                for (var ei = xr.length - 1; ei >= 0; ei--)
                  if (j(xr[ei])) {
                    te = xr[ei];
                    break;
                  }
              }), te;
            }
            e2.getLastChild = Lc;
            function _(c, te, xr) {
              return xr === void 0 && (xr = true), c.has(te) ? false : (c.set(te, xr), true);
            }
            e2.addToSeen = _;
            function W(c) {
              return e2.isClassLike(c) || e2.isInterfaceDeclaration(c) || e2.isTypeLiteralNode(c);
            }
            e2.isObjectTypeDeclaration = W;
            function Te(c) {
              return c >= 177 && c <= 200 || c === 130 || c === 155 || c === 147 || c === 158 || c === 148 || c === 133 || c === 150 || c === 151 || c === 114 || c === 153 || c === 143 || c === 228 || c === 312 || c === 313 || c === 314 || c === 315 || c === 316 || c === 317 || c === 318;
            }
            e2.isTypeNodeKind = Te;
            function cr(c) {
              return c.kind === 206 || c.kind === 207;
            }
            e2.isAccessExpression = cr;
            function ni(c) {
              return c.kind === 206 ? c.name : (e2.Debug.assert(c.kind === 207), c.argumentExpression);
            }
            e2.getNameOfAccessExpression = ni;
            function rt(c) {
              switch (c.kind) {
                case "text":
                case "internal":
                  return true;
                default:
                  return false;
              }
            }
            e2.isBundleFileTextLike = rt;
            function yt(c) {
              return c.kind === 269 || c.kind === 273;
            }
            e2.isNamedImportsOrExports = yt;
            function Xa(c) {
              for (; cr(c); )
                c = c.expression;
              return c;
            }
            e2.getLeftmostAccessExpression = Xa;
            function vo(c, te) {
              if (cr(c.parent) && Kf(c))
                return xr(c.parent);
              function xr(ei) {
                if (ei.kind === 206) {
                  var bi = te(ei.name);
                  if (bi !== void 0)
                    return bi;
                } else if (ei.kind === 207)
                  if (e2.isIdentifier(ei.argumentExpression) || e2.isStringLiteralLike(ei.argumentExpression)) {
                    var bi = te(ei.argumentExpression);
                    if (bi !== void 0)
                      return bi;
                  } else
                    return;
                if (cr(ei.expression))
                  return xr(ei.expression);
                if (e2.isIdentifier(ei.expression))
                  return te(ei.expression);
              }
            }
            e2.forEachNameInAccessChainWalkingLeft = vo;
            function Vs(c, te) {
              for (; ; ) {
                switch (c.kind) {
                  case 220:
                    c = c.operand;
                    continue;
                  case 221:
                    c = c.left;
                    continue;
                  case 222:
                    c = c.condition;
                    continue;
                  case 210:
                    c = c.tag;
                    continue;
                  case 208:
                    if (te)
                      return c;
                  case 229:
                  case 207:
                  case 206:
                  case 230:
                  case 350:
                    c = c.expression;
                    continue;
                }
                return c;
              }
            }
            e2.getLeftmostExpression = Vs;
            function H_(c, te) {
              this.flags = c, this.escapedName = te, this.declarations = void 0, this.valueDeclaration = void 0, this.id = void 0, this.mergeId = void 0, this.parent = void 0;
            }
            function y_(c, te) {
              this.flags = te, (e2.Debug.isDebugging || e2.tracing) && (this.checker = c);
            }
            function Dd(c, te) {
              this.flags = te, e2.Debug.isDebugging && (this.checker = c);
            }
            function jp(c, te, xr) {
              this.pos = te, this.end = xr, this.kind = c, this.id = 0, this.flags = 0, this.modifierFlagsCache = 0, this.transformFlags = 0, this.parent = void 0, this.original = void 0;
            }
            function lg(c, te, xr) {
              this.pos = te, this.end = xr, this.kind = c, this.id = 0, this.flags = 0, this.transformFlags = 0, this.parent = void 0;
            }
            function Om(c, te, xr) {
              this.pos = te, this.end = xr, this.kind = c, this.id = 0, this.flags = 0, this.transformFlags = 0, this.parent = void 0, this.original = void 0, this.flowNode = void 0;
            }
            function Fm(c, te, xr) {
              this.fileName = c, this.text = te, this.skipTrivia = xr || function(ei) {
                return ei;
              };
            }
            e2.objectAllocator = { getNodeConstructor: function() {
              return jp;
            }, getTokenConstructor: function() {
              return lg;
            }, getIdentifierConstructor: function() {
              return Om;
            }, getPrivateIdentifierConstructor: function() {
              return jp;
            }, getSourceFileConstructor: function() {
              return jp;
            }, getSymbolConstructor: function() {
              return H_;
            }, getTypeConstructor: function() {
              return y_;
            }, getSignatureConstructor: function() {
              return Dd;
            }, getSourceMapSourceConstructor: function() {
              return Fm;
            } };
            function Vg(c) {
              Object.assign(e2.objectAllocator, c);
            }
            e2.setObjectAllocator = Vg;
            function Jt(c, te, xr) {
              return xr === void 0 && (xr = 0), c.replace(/{(\d+)}/g, function(ei, bi) {
                return "" + e2.Debug.checkDefined(te[+bi + xr]);
              });
            }
            e2.formatStringFromArgs = Jt;
            var ml;
            function Xf(c) {
              ml = c;
            }
            e2.setLocalizedDiagnosticMessages = Xf;
            function bd(c) {
              !ml && c && (ml = c());
            }
            e2.maybeSetLocalizedDiagnosticMessages = bd;
            function lf(c) {
              return ml && ml[c.key] || c.message;
            }
            e2.getLocaleSpecificMessage = lf;
            function Kg(c, te, xr, ei) {
              zr(void 0, te, xr);
              var bi = lf(ei);
              return arguments.length > 4 && (bi = Jt(bi, arguments, 4)), { file: void 0, start: te, length: xr, messageText: bi, category: ei.category, code: ei.code, reportsUnnecessary: ei.reportsUnnecessary, fileName: c };
            }
            e2.createDetachedDiagnostic = Kg;
            function kf(c) {
              return c.file === void 0 && c.start !== void 0 && c.length !== void 0 && typeof c.fileName == "string";
            }
            function Gg(c, te) {
              var xr = te.fileName || "", ei = te.text.length;
              e2.Debug.assertEqual(c.fileName, xr), e2.Debug.assertLessThanOrEqual(c.start, ei), e2.Debug.assertLessThanOrEqual(c.start + c.length, ei);
              var bi = { file: te, start: c.start, length: c.length, messageText: c.messageText, category: c.category, code: c.code, reportsUnnecessary: c.reportsUnnecessary };
              if (c.relatedInformation) {
                bi.relatedInformation = [];
                for (var Ft = 0, ot = c.relatedInformation; Ft < ot.length; Ft++) {
                  var xa = ot[Ft];
                  kf(xa) && xa.fileName === xr ? (e2.Debug.assertLessThanOrEqual(xa.start, ei), e2.Debug.assertLessThanOrEqual(xa.start + xa.length, ei), bi.relatedInformation.push(Gg(xa, te))) : bi.relatedInformation.push(xa);
                }
              }
              return bi;
            }
            function Af(c, te) {
              for (var xr = [], ei = 0, bi = c; ei < bi.length; ei++) {
                var Ft = bi[ei];
                xr.push(Gg(Ft, te));
              }
              return xr;
            }
            e2.attachFileToDiagnostics = Af;
            function Hg(c, te, xr, ei) {
              zr(c, te, xr);
              var bi = lf(ei);
              return arguments.length > 4 && (bi = Jt(bi, arguments, 4)), { file: c, start: te, length: xr, messageText: bi, category: ei.category, code: ei.code, reportsUnnecessary: ei.reportsUnnecessary, reportsDeprecated: ei.reportsDeprecated };
            }
            e2.createFileDiagnostic = Hg;
            function Wd(c, te) {
              var xr = lf(te);
              return arguments.length > 2 && (xr = Jt(xr, arguments, 2)), xr;
            }
            e2.formatMessage = Wd;
            function qd(c) {
              var te = lf(c);
              return arguments.length > 1 && (te = Jt(te, arguments, 1)), { file: void 0, start: void 0, length: void 0, messageText: te, category: c.category, code: c.code, reportsUnnecessary: c.reportsUnnecessary, reportsDeprecated: c.reportsDeprecated };
            }
            e2.createCompilerDiagnostic = qd;
            function fg(c, te) {
              return { file: void 0, start: void 0, length: void 0, code: c.code, category: c.category, messageText: c.next ? c : c.messageText, relatedInformation: te };
            }
            e2.createCompilerDiagnosticFromMessageChain = fg;
            function Mm(c, te) {
              var xr = lf(te);
              return arguments.length > 2 && (xr = Jt(xr, arguments, 2)), { messageText: xr, category: te.category, code: te.code, next: c === void 0 || Array.isArray(c) ? c : [c] };
            }
            e2.chainDiagnosticMessages = Mm;
            function Xg(c, te) {
              for (var xr = c; xr.next; )
                xr = xr.next[0];
              xr.next = [te];
            }
            e2.concatenateDiagnosticMessageChains = Xg;
            function Bl(c) {
              return c.file ? c.file.path : void 0;
            }
            function Qg(c, te) {
              return _g(c, te) || Qc(c, te) || 0;
            }
            e2.compareDiagnostics = Qg;
            function _g(c, te) {
              return e2.compareStringsCaseSensitive(Bl(c), Bl(te)) || e2.compareValues(c.start, te.start) || e2.compareValues(c.length, te.length) || e2.compareValues(c.code, te.code) || Lm(c.messageText, te.messageText) || 0;
            }
            e2.compareDiagnosticsSkipRelatedInformation = _g;
            function Qc(c, te) {
              return !c.relatedInformation && !te.relatedInformation ? 0 : c.relatedInformation && te.relatedInformation ? e2.compareValues(c.relatedInformation.length, te.relatedInformation.length) || e2.forEach(c.relatedInformation, function(xr, ei) {
                var bi = te.relatedInformation[ei];
                return Qg(xr, bi);
              }) || 0 : c.relatedInformation ? -1 : 1;
            }
            function Lm(c, te) {
              if (typeof c == "string" && typeof te == "string")
                return e2.compareStringsCaseSensitive(c, te);
              if (typeof c == "string")
                return -1;
              if (typeof te == "string")
                return 1;
              var xr = e2.compareStringsCaseSensitive(c.messageText, te.messageText);
              if (xr)
                return xr;
              if (!c.next && !te.next)
                return 0;
              if (!c.next)
                return -1;
              if (!te.next)
                return 1;
              for (var ei = Math.min(c.next.length, te.next.length), bi = 0; bi < ei; bi++)
                if (xr = Lm(c.next[bi], te.next[bi]), xr)
                  return xr;
              return c.next.length < te.next.length ? -1 : c.next.length > te.next.length ? 1 : 0;
            }
            function Up(c) {
              return c === 4 || c === 2 || c === 1 || c === 6 ? 1 : 0;
            }
            e2.getLanguageVariant = Up;
            function Rm(c) {
              if (!!(c.transformFlags & 2))
                return e2.isJsxOpeningLikeElement(c) || e2.isJsxFragment(c) ? c : e2.forEachChild(c, Rm);
            }
            function ff(c) {
              return c.isDeclarationFile ? void 0 : Rm(c);
            }
            function It(c) {
              return c.impliedNodeFormat === e2.ModuleKind.ESNext && !c.isDeclarationFile ? true : void 0;
            }
            function Ma(c) {
              switch (ro(c)) {
                case e2.ModuleDetectionKind.Force:
                  return function(Ft) {
                    Ft.externalModuleIndicator = !Ft.isDeclarationFile || e2.isFileProbablyExternalModule(Ft);
                  };
                case e2.ModuleDetectionKind.Legacy:
                  return function(Ft) {
                    Ft.externalModuleIndicator = e2.isFileProbablyExternalModule(Ft);
                  };
                case e2.ModuleDetectionKind.Auto:
                  var te = [e2.isFileProbablyExternalModule];
                  (c.jsx === 4 || c.jsx === 5) && te.push(ff);
                  var xr = Ja(c);
                  (xr === e2.ModuleKind.Node16 || xr === e2.ModuleKind.NodeNext) && te.push(It);
                  var ei = e2.or.apply(void 0, te), bi = function(Ft) {
                    return void (Ft.externalModuleIndicator = ei(Ft));
                  };
                  return bi;
              }
            }
            e2.getSetExternalModuleIndicator = Ma;
            function aa(c) {
              return c.target || c.module === e2.ModuleKind.Node16 && 9 || c.module === e2.ModuleKind.NodeNext && 99 || 0;
            }
            e2.getEmitScriptTarget = aa;
            function Ja(c) {
              return typeof c.module == "number" ? c.module : aa(c) >= 2 ? e2.ModuleKind.ES2015 : e2.ModuleKind.CommonJS;
            }
            e2.getEmitModuleKind = Ja;
            function _n(c) {
              var te = c.moduleResolution;
              if (te === void 0)
                switch (Ja(c)) {
                  case e2.ModuleKind.CommonJS:
                    te = e2.ModuleResolutionKind.NodeJs;
                    break;
                  case e2.ModuleKind.Node16:
                    te = e2.ModuleResolutionKind.Node16;
                    break;
                  case e2.ModuleKind.NodeNext:
                    te = e2.ModuleResolutionKind.NodeNext;
                    break;
                  default:
                    te = e2.ModuleResolutionKind.Classic;
                    break;
                }
              return te;
            }
            e2.getEmitModuleResolutionKind = _n;
            function ro(c) {
              return c.moduleDetection || e2.ModuleDetectionKind.Auto;
            }
            e2.getEmitModuleDetectionKind = ro;
            function as(c) {
              switch (Ja(c)) {
                case e2.ModuleKind.CommonJS:
                case e2.ModuleKind.AMD:
                case e2.ModuleKind.ES2015:
                case e2.ModuleKind.ES2020:
                case e2.ModuleKind.ES2022:
                case e2.ModuleKind.ESNext:
                case e2.ModuleKind.Node16:
                case e2.ModuleKind.NodeNext:
                  return true;
                default:
                  return false;
              }
            }
            e2.hasJsonModuleEmitEnabled = as;
            function cc(c) {
              return c.allowUnreachableCode === false;
            }
            e2.unreachableCodeIsError = cc;
            function Sc(c) {
              return c.allowUnusedLabels === false;
            }
            e2.unusedLabelIsError = Sc;
            function hu(c) {
              return !!(go(c) && c.declarationMap);
            }
            e2.getAreDeclarationMapsEnabled = hu;
            function Js(c) {
              if (c.esModuleInterop !== void 0)
                return c.esModuleInterop;
              switch (Ja(c)) {
                case e2.ModuleKind.Node16:
                case e2.ModuleKind.NodeNext:
                  return true;
              }
            }
            e2.getESModuleInterop = Js;
            function Qf(c) {
              var te = Ja(c);
              return c.allowSyntheticDefaultImports !== void 0 ? c.allowSyntheticDefaultImports : Js(c) || te === e2.ModuleKind.System;
            }
            e2.getAllowSyntheticDefaultImports = Qf;
            function go(c) {
              return !!(c.declaration || c.composite);
            }
            e2.getEmitDeclarations = go;
            function Vd(c) {
              return !!(c.preserveConstEnums || c.isolatedModules);
            }
            e2.shouldPreserveConstEnums = Vd;
            function X_(c) {
              return !!(c.incremental || c.composite);
            }
            e2.isIncrementalCompilation = X_;
            function Sd(c, te) {
              return c[te] === void 0 ? !!c.strict : !!c[te];
            }
            e2.getStrictOptionValue = Sd;
            function Yg(c) {
              return c.allowJs === void 0 ? !!c.checkJs : c.allowJs;
            }
            e2.getAllowJSCompilerOption = Yg;
            function N1(c) {
              return c.useDefineForClassFields === void 0 ? aa(c) >= 9 : c.useDefineForClassFields;
            }
            e2.getUseDefineForClassFields = N1;
            function P1(c, te) {
              return m2(te, c, e2.semanticDiagnosticsOptionDeclarations);
            }
            e2.compilerOptionsAffectSemanticDiagnostics = P1;
            function Yy(c, te) {
              return m2(te, c, e2.affectsEmitOptionDeclarations);
            }
            e2.compilerOptionsAffectEmit = Yy;
            function Bm(c, te) {
              return te.strictFlag ? Sd(c, te.name) : c[te.name];
            }
            e2.getCompilerOptionValue = Bm;
            function $y(c) {
              var te = c.jsx;
              return te === 2 || te === 4 || te === 5;
            }
            e2.getJSXTransformEnabled = $y;
            function Lv(c, te) {
              var xr = te == null ? void 0 : te.pragmas.get("jsximportsource"), ei = e2.isArray(xr) ? xr[xr.length - 1] : xr;
              return c.jsx === 4 || c.jsx === 5 || c.jsxImportSource || ei ? (ei == null ? void 0 : ei.arguments.factory) || c.jsxImportSource || "react" : void 0;
            }
            e2.getJSXImplicitImportBase = Lv;
            function _f(c, te) {
              return c ? "".concat(c, "/").concat(te.jsx === 5 ? "jsx-dev-runtime" : "jsx-runtime") : void 0;
            }
            e2.getJSXRuntimeImport = _f;
            function Rv(c) {
              for (var te = false, xr = 0; xr < c.length; xr++)
                if (c.charCodeAt(xr) === 42)
                  if (!te)
                    te = true;
                  else
                    return false;
              return true;
            }
            e2.hasZeroOrOneAsteriskCharacter = Rv;
            function pg(c, te) {
              var xr, ei, bi, Ft = false;
              return { getSymlinkedFiles: function() {
                return bi;
              }, getSymlinkedDirectories: function() {
                return xr;
              }, getSymlinkedDirectoriesByRealpath: function() {
                return ei;
              }, setSymlinkedFile: function(xa, mn) {
                return (bi || (bi = new e2.Map())).set(xa, mn);
              }, setSymlinkedDirectory: function(xa, mn) {
                var an = e2.toPath(xa, c, te);
                D_(an) || (an = e2.ensureTrailingDirectorySeparator(an), mn !== false && !(xr != null && xr.has(an)) && (ei || (ei = e2.createMultiMap())).add(e2.ensureTrailingDirectorySeparator(mn.realPath), xa), (xr || (xr = new e2.Map())).set(an, mn));
              }, setSymlinksFromResolutions: function(xa, mn) {
                var an = this, To;
                e2.Debug.assert(!Ft), Ft = true;
                for (var Hn = 0, ss = xa; Hn < ss.length; Hn++) {
                  var cs = ss[Hn];
                  (To = cs.resolvedModules) === null || To === void 0 || To.forEach(function(ws) {
                    return ot(an, ws);
                  });
                }
                mn == null || mn.forEach(function(ws) {
                  return ot(an, ws);
                });
              }, hasProcessedResolutions: function() {
                return Ft;
              } };
              function ot(xa, mn) {
                if (!(!mn || !mn.originalPath || !mn.resolvedFileName)) {
                  var an = mn.resolvedFileName, To = mn.originalPath;
                  xa.setSymlinkedFile(e2.toPath(To, c, te), an);
                  var Hn = $g(an, To, c, te) || e2.emptyArray, ss = Hn[0], cs = Hn[1];
                  ss && cs && xa.setSymlinkedDirectory(cs, { real: ss, realPath: e2.toPath(ss, c, te) });
                }
              }
            }
            e2.createSymlinkCache = pg;
            function $g(c, te, xr, ei) {
              for (var bi = e2.getPathComponents(e2.getNormalizedAbsolutePath(c, xr)), Ft = e2.getPathComponents(e2.getNormalizedAbsolutePath(te, xr)), ot = false; bi.length >= 2 && Ft.length >= 2 && !Td(bi[bi.length - 2], ei) && !Td(Ft[Ft.length - 2], ei) && ei(bi[bi.length - 1]) === ei(Ft[Ft.length - 1]); )
                bi.pop(), Ft.pop(), ot = true;
              return ot ? [e2.getPathFromPathComponents(bi), e2.getPathFromPathComponents(Ft)] : void 0;
            }
            function Td(c, te) {
              return c !== void 0 && (te(c) === "node_modules" || e2.startsWith(c, "@"));
            }
            function I1(c) {
              return e2.isAnyDirectorySeparator(c.charCodeAt(0)) ? c.slice(1) : void 0;
            }
            function pf(c, te, xr) {
              var ei = e2.tryRemovePrefix(c, te, xr);
              return ei === void 0 ? void 0 : I1(ei);
            }
            e2.tryRemoveDirectoryPrefix = pf;
            var Bv = /[^\w\s\/]/g;
            function Zy(c) {
              return c.replace(Bv, Jv);
            }
            e2.regExpEscape = Zy;
            function Jv(c) {
              return "\\" + c;
            }
            var Nf = [42, 63];
            e2.commonPackageFolders = ["node_modules", "bower_components", "jspm_packages"];
            var dg = "(?!(".concat(e2.commonPackageFolders.join("|"), ")(/|$))"), Rc = { singleAsteriskRegexFragment: "([^./]|(\\.(?!min\\.js$))?)*", doubleAsteriskRegexFragment: "(/".concat(dg, "[^/.][^/]*)*?"), replaceWildcardCharacter: function(c) {
              return Jm(c, Rc.singleAsteriskRegexFragment);
            } }, jv = { singleAsteriskRegexFragment: "[^/]*", doubleAsteriskRegexFragment: "(/".concat(dg, "[^/.][^/]*)*?"), replaceWildcardCharacter: function(c) {
              return Jm(c, jv.singleAsteriskRegexFragment);
            } }, eh = { singleAsteriskRegexFragment: "[^/]*", doubleAsteriskRegexFragment: "(/.+?)?", replaceWildcardCharacter: function(c) {
              return Jm(c, eh.singleAsteriskRegexFragment);
            } }, rh = { files: Rc, directories: jv, exclude: eh };
            function Fu(c, te, xr) {
              var ei = xd(c, te, xr);
              if (!(!ei || !ei.length)) {
                var bi = ei.map(function(ot) {
                  return "(".concat(ot, ")");
                }).join("|"), Ft = xr === "exclude" ? "($|/)" : "$";
                return "^(".concat(bi, ")").concat(Ft);
              }
            }
            e2.getRegularExpressionForWildcard = Fu;
            function xd(c, te, xr) {
              if (!(c === void 0 || c.length === 0))
                return e2.flatMap(c, function(ei) {
                  return ei && ih(ei, te, xr, rh[xr]);
                });
            }
            e2.getRegularExpressionsForWildcards = xd;
            function Uv(c) {
              return !/[.*?]/.test(c);
            }
            e2.isImplicitGlob = Uv;
            function w1(c, te, xr) {
              var ei = c && ih(c, te, xr, rh[xr]);
              return ei && "^(".concat(ei, ")").concat(xr === "exclude" ? "($|/)" : "$");
            }
            e2.getPatternFromSpec = w1;
            function ih(c, te, xr, ei) {
              var bi = ei.singleAsteriskRegexFragment, Ft = ei.doubleAsteriskRegexFragment, ot = ei.replaceWildcardCharacter, xa = "", mn = false, an = e2.getNormalizedPathComponents(c, te), To = e2.last(an);
              if (!(xr !== "exclude" && To === "**")) {
                an[0] = e2.removeTrailingDirectorySeparator(an[0]), Uv(To) && an.push("**", "*");
                for (var Hn = 0, ss = 0, cs = an; ss < cs.length; ss++) {
                  var ws = cs[ss];
                  if (ws === "**")
                    xa += Ft;
                  else if (xr === "directories" && (xa += "(", Hn++), mn && (xa += e2.directorySeparator), xr !== "exclude") {
                    var nu = "";
                    ws.charCodeAt(0) === 42 ? (nu += "([^./]" + bi + ")?", ws = ws.substr(1)) : ws.charCodeAt(0) === 63 && (nu += "[^./]", ws = ws.substr(1)), nu += ws.replace(Bv, ot), nu !== ws && (xa += dg), xa += nu;
                  } else
                    xa += ws.replace(Bv, ot);
                  mn = true;
                }
                for (; Hn > 0; )
                  xa += ")?", Hn--;
                return xa;
              }
            }
            function Jm(c, te) {
              return c === "*" ? te : c === "?" ? "[^/]" : "\\" + c;
            }
            function th(c, te, xr, ei, bi) {
              c = e2.normalizePath(c), bi = e2.normalizePath(bi);
              var Ft = e2.combinePaths(bi, c);
              return { includeFilePatterns: e2.map(xd(xr, Ft, "files"), function(ot) {
                return "^".concat(ot, "$");
              }), includeFilePattern: Fu(xr, Ft, "files"), includeDirectoryPattern: Fu(xr, Ft, "directories"), excludePattern: Fu(te, Ft, "exclude"), basePaths: zv(c, xr, ei) };
            }
            e2.getFileMatcherPatterns = th;
            function gg(c, te) {
              return new RegExp(c, te ? "" : "i");
            }
            e2.getRegexFromPattern = gg;
            function O1(c, te, xr, ei, bi, Ft, ot, xa, mn) {
              c = e2.normalizePath(c), Ft = e2.normalizePath(Ft);
              for (var an = th(c, xr, ei, bi, Ft), To = an.includeFilePatterns && an.includeFilePatterns.map(function(b_) {
                return gg(b_, bi);
              }), Hn = an.includeDirectoryPattern && gg(an.includeDirectoryPattern, bi), ss = an.excludePattern && gg(an.excludePattern, bi), cs = To ? To.map(function() {
                return [];
              }) : [[]], ws = new e2.Map(), nu = e2.createGetCanonicalFileName(bi), Xo = 0, jl = an.basePaths; Xo < jl.length; Xo++) {
                var Y_ = jl[Xo];
                Cd(Y_, e2.combinePaths(Ft, Y_), ot);
              }
              return e2.flatten(cs);
              function Cd(b_, kd, qm) {
                var Vm = nu(mn(kd));
                if (!ws.has(Vm)) {
                  ws.set(Vm, true);
                  for (var vg = xa(b_), Ul = vg.files, zp = vg.directories, yl = function(T_) {
                    var Yc = e2.combinePaths(b_, T_), gh = e2.combinePaths(kd, T_);
                    if (te && !e2.fileExtensionIsOneOf(Yc, te) || ss && ss.test(gh))
                      return "continue";
                    if (!To)
                      cs[0].push(Yc);
                    else {
                      var iy = e2.findIndex(To, function(yo) {
                        return yo.test(gh);
                      });
                      iy !== -1 && cs[iy].push(Yc);
                    }
                  }, ey = 0, rm = e2.sort(Ul, e2.compareStringsCaseSensitive); ey < rm.length; ey++) {
                    var Km = rm[ey];
                    yl(Km);
                  }
                  if (!(qm !== void 0 && (qm--, qm === 0)))
                    for (var ry = 0, Gm = e2.sort(zp, e2.compareStringsCaseSensitive); ry < Gm.length; ry++) {
                      var Km = Gm[ry], S_ = e2.combinePaths(b_, Km), Hm = e2.combinePaths(kd, Km);
                      (!Hn || Hn.test(Hm)) && (!ss || !ss.test(Hm)) && Cd(S_, Hm, qm);
                    }
                }
              }
            }
            e2.matchFiles = O1;
            function zv(c, te, xr) {
              var ei = [c];
              if (te) {
                for (var bi = [], Ft = 0, ot = te; Ft < ot.length; Ft++) {
                  var xa = ot[Ft], mn = e2.isRootedDiskPath(xa) ? xa : e2.normalizePath(e2.combinePaths(c, xa));
                  bi.push(ah(mn));
                }
                bi.sort(e2.getStringComparer(!xr));
                for (var an = function(cs) {
                  e2.every(ei, function(ws) {
                    return !e2.containsPath(ws, cs, c, !xr);
                  }) && ei.push(cs);
                }, To = 0, Hn = bi; To < Hn.length; To++) {
                  var ss = Hn[To];
                  an(ss);
                }
              }
              return ei;
            }
            function ah(c) {
              var te = e2.indexOfAnyCharCode(c, Nf);
              return te < 0 ? e2.hasExtension(c) ? e2.removeTrailingDirectorySeparator(e2.getDirectoryPath(c)) : c : c.substring(0, c.lastIndexOf(e2.directorySeparator, te));
            }
            function F1(c, te) {
              return te || nh(c) || 3;
            }
            e2.ensureScriptKind = F1;
            function nh(c) {
              var te = c.substr(c.lastIndexOf("."));
              switch (te.toLowerCase()) {
                case ".js":
                case ".cjs":
                case ".mjs":
                  return 1;
                case ".jsx":
                  return 2;
                case ".ts":
                case ".cts":
                case ".mts":
                  return 3;
                case ".tsx":
                  return 4;
                case ".json":
                  return 6;
                default:
                  return 0;
              }
            }
            e2.getScriptKindFromFileName = nh, e2.supportedTSExtensions = [[".ts", ".tsx", ".d.ts"], [".cts", ".d.cts"], [".mts", ".d.mts"]], e2.supportedTSExtensionsFlat = e2.flatten(e2.supportedTSExtensions);
            var M1 = Ve(Ve([], e2.supportedTSExtensions, true), [[".json"]], false), oh = [".d.ts", ".d.cts", ".d.mts", ".cts", ".mts", ".ts", ".tsx", ".cts", ".mts"];
            e2.supportedJSExtensions = [[".js", ".jsx"], [".mjs"], [".cjs"]], e2.supportedJSExtensionsFlat = e2.flatten(e2.supportedJSExtensions);
            var jm = [[".ts", ".tsx", ".d.ts", ".js", ".jsx"], [".cts", ".d.cts", ".cjs"], [".mts", ".d.mts", ".mjs"]], Zg = Ve(Ve([], jm, true), [[".json"]], false);
            e2.supportedDeclarationExtensions = [".d.ts", ".d.cts", ".d.mts"];
            function Wv(c, te) {
              var xr = c && Yg(c);
              if (!te || te.length === 0)
                return xr ? jm : e2.supportedTSExtensions;
              var ei = xr ? jm : e2.supportedTSExtensions, bi = e2.flatten(ei), Ft = Ve(Ve([], ei, true), e2.mapDefined(te, function(ot) {
                return ot.scriptKind === 7 || xr && L1(ot.scriptKind) && bi.indexOf(ot.extension) === -1 ? [ot.extension] : void 0;
              }), true);
              return Ft;
            }
            e2.getSupportedExtensions = Wv;
            function sh(c, te) {
              return !c || !c.resolveJsonModule ? te : te === jm ? Zg : te === e2.supportedTSExtensions ? M1 : Ve(Ve([], te, true), [[".json"]], false);
            }
            e2.getSupportedExtensionsWithJsonIfResolveJsonModule = sh;
            function L1(c) {
              return c === 1 || c === 2;
            }
            function ch(c) {
              return e2.some(e2.supportedJSExtensionsFlat, function(te) {
                return e2.fileExtensionIs(c, te);
              });
            }
            e2.hasJSFileExtension = ch;
            function uh(c) {
              return e2.some(e2.supportedTSExtensionsFlat, function(te) {
                return e2.fileExtensionIs(c, te);
              });
            }
            e2.hasTSFileExtension = uh;
            function R1(c, te, xr) {
              if (!c)
                return false;
              for (var ei = Wv(te, xr), bi = 0, Ft = e2.flatten(sh(te, ei)); bi < Ft.length; bi++) {
                var ot = Ft[bi];
                if (e2.fileExtensionIs(c, ot))
                  return true;
              }
              return false;
            }
            e2.isSupportedSourceFileName = R1;
            function lh(c) {
              var te = c.match(/\//g);
              return te ? te.length : 0;
            }
            function B1(c, te) {
              return e2.compareValues(lh(c), lh(te));
            }
            e2.compareNumberOfDirectorySeparators = B1;
            var Kd = [".d.ts", ".d.mts", ".d.cts", ".mjs", ".mts", ".cjs", ".cts", ".ts", ".js", ".tsx", ".jsx", ".json"];
            function Gd(c) {
              for (var te = 0, xr = Kd; te < xr.length; te++) {
                var ei = xr[te], bi = Um(c, ei);
                if (bi !== void 0)
                  return bi;
              }
              return c;
            }
            e2.removeFileExtension = Gd;
            function Um(c, te) {
              return e2.fileExtensionIs(c, te) ? fh(c, te) : void 0;
            }
            e2.tryRemoveExtension = Um;
            function fh(c, te) {
              return c.substring(0, c.length - te.length);
            }
            e2.removeExtension = fh;
            function J1(c, te) {
              return e2.changeAnyExtension(c, te, Kd, false);
            }
            e2.changeExtension = J1;
            function Du(c) {
              var te = c.indexOf("*");
              return te === -1 ? c : c.indexOf("*", te + 1) !== -1 ? void 0 : { prefix: c.substr(0, te), suffix: c.substr(te + 1) };
            }
            e2.tryParsePattern = Du;
            function Mu(c) {
              return e2.mapDefined(e2.getOwnKeys(c), function(te) {
                return Du(te);
              });
            }
            e2.tryParsePatterns = Mu;
            function Jl(c) {
              return !(c >= 0);
            }
            e2.positionIsSynthesized = Jl;
            function vl(c) {
              return c === ".ts" || c === ".tsx" || c === ".d.ts" || c === ".cts" || c === ".mts" || c === ".d.mts" || c === ".d.cts";
            }
            e2.extensionIsTS = vl;
            function _h(c) {
              return vl(c) || c === ".json";
            }
            e2.resolutionExtensionIsTSOrJson = _h;
            function mg(c) {
              var te = Lu(c);
              return te !== void 0 ? te : e2.Debug.fail("File ".concat(c, " has unknown extension."));
            }
            e2.extensionFromPath = mg;
            function Ed(c) {
              return Lu(c) !== void 0;
            }
            e2.isAnySupportedFileExtension = Ed;
            function Lu(c) {
              return e2.find(Kd, function(te) {
                return e2.fileExtensionIs(c, te);
              });
            }
            e2.tryGetExtensionFromPath = Lu;
            function ph(c, te) {
              return c.checkJsDirective ? c.checkJsDirective.enabled : te.checkJs;
            }
            e2.isCheckJsEnabledForFile = ph, e2.emptyFileSystemEntries = { files: e2.emptyArray, directories: e2.emptyArray };
            function qv(c, te) {
              for (var xr = [], ei = 0, bi = c; ei < bi.length; ei++) {
                var Ft = bi[ei];
                if (Ft === te)
                  return te;
                e2.isString(Ft) || xr.push(Ft);
              }
              return e2.findBestPatternMatch(xr, function(ot) {
                return ot;
              }, te);
            }
            e2.matchPatternOrExact = qv;
            function j1(c, te) {
              var xr = c.indexOf(te);
              return e2.Debug.assert(xr !== -1), c.slice(xr);
            }
            e2.sliceAfter = j1;
            function Bc(c) {
              for (var te, xr = [], ei = 1; ei < arguments.length; ei++)
                xr[ei - 1] = arguments[ei];
              return xr.length && (c.relatedInformation || (c.relatedInformation = []), e2.Debug.assert(c.relatedInformation !== e2.emptyArray, "Diagnostic had empty array singleton for related info, but is still being constructed!"), (te = c.relatedInformation).push.apply(te, xr)), c;
            }
            e2.addRelatedInfo = Bc;
            function Ru(c, te) {
              e2.Debug.assert(c.length !== 0);
              for (var xr = te(c[0]), ei = xr, bi = 1; bi < c.length; bi++) {
                var Ft = te(c[bi]);
                Ft < xr ? xr = Ft : Ft > ei && (ei = Ft);
              }
              return { min: xr, max: ei };
            }
            e2.minAndMax = Ru;
            function Pf(c) {
              return { pos: Fe(c), end: c.end };
            }
            e2.rangeOfNode = Pf;
            function h_(c, te) {
              var xr = te.pos - 1, ei = e2.skipTrivia(c.text, te.end) + 1;
              return { pos: xr, end: ei };
            }
            e2.rangeOfTypeParameters = h_;
            function em(c, te, xr) {
              return te.skipLibCheck && c.isDeclarationFile || te.skipDefaultLibCheck && c.hasNoDefaultLib || xr.isSourceOfProjectReferenceRedirect(c.fileName);
            }
            e2.skipTypeChecking = em;
            function uo(c, te) {
              return c === te || typeof c == "object" && c !== null && typeof te == "object" && te !== null && e2.equalOwnProperties(c, te, uo);
            }
            e2.isJsonEqual = uo;
            function U1(c) {
              var te;
              switch (c.charCodeAt(1)) {
                case 98:
                case 66:
                  te = 1;
                  break;
                case 111:
                case 79:
                  te = 3;
                  break;
                case 120:
                case 88:
                  te = 4;
                  break;
                default:
                  for (var xr = c.length - 1, ei = 0; c.charCodeAt(ei) === 48; )
                    ei++;
                  return c.slice(ei, xr) || "0";
              }
              for (var bi = 2, Ft = c.length - 1, ot = (Ft - bi) * te, xa = new Uint16Array((ot >>> 4) + (ot & 15 ? 1 : 0)), mn = Ft - 1, an = 0; mn >= bi; mn--, an += te) {
                var To = an >>> 4, Hn = c.charCodeAt(mn), ss = Hn <= 57 ? Hn - 48 : 10 + Hn - (Hn <= 70 ? 65 : 97), cs = ss << (an & 15);
                xa[To] |= cs;
                var ws = cs >>> 16;
                ws && (xa[To + 1] |= ws);
              }
              for (var nu = "", Xo = xa.length - 1, jl = true; jl; ) {
                var Y_ = 0;
                jl = false;
                for (var To = Xo; To >= 0; To--) {
                  var Cd = Y_ << 16 | xa[To], b_ = Cd / 10 | 0;
                  xa[To] = b_, Y_ = Cd - b_ * 10, b_ && !jl && (Xo = To, jl = true);
                }
                nu = Y_ + nu;
              }
              return nu;
            }
            e2.parsePseudoBigInt = U1;
            function z1(c) {
              var te = c.negative, xr = c.base10Value;
              return (te && xr !== "0" ? "-" : "") + xr;
            }
            e2.pseudoBigIntToString = z1;
            function W1(c) {
              return !!(c.flags & 16777216) || S2(c) || q1(c) || Tc(c) || !(Qe(c) || Q_(c));
            }
            e2.isValidTypeOnlyAliasUseSite = W1;
            function Q_(c) {
              return e2.isIdentifier(c) && e2.isShorthandPropertyAssignment(c.parent) && c.parent.name === c;
            }
            function Tc(c) {
              for (; c.kind === 79 || c.kind === 206; )
                c = c.parent;
              if (c.kind !== 162)
                return false;
              if (gc(c.parent, 128))
                return true;
              var te = c.parent.parent.kind;
              return te === 258 || te === 182;
            }
            function q1(c) {
              if (c.kind !== 79)
                return false;
              var te = e2.findAncestor(c.parent, function(xr) {
                switch (xr.kind) {
                  case 291:
                    return true;
                  case 206:
                  case 228:
                    return false;
                  default:
                    return "quit";
                }
              });
              return (te == null ? void 0 : te.token) === 117 || (te == null ? void 0 : te.parent.kind) === 258;
            }
            function Vv(c) {
              return e2.isTypeReferenceNode(c) && e2.isIdentifier(c.typeName);
            }
            e2.isIdentifierTypeReference = Vv;
            function V1(c, te) {
              if (te === void 0 && (te = e2.equateValues), c.length < 2)
                return true;
              for (var xr = c[0], ei = 1, bi = c.length; ei < bi; ei++) {
                var Ft = c[ei];
                if (!te(xr, Ft))
                  return false;
              }
              return true;
            }
            e2.arrayIsHomogeneous = V1;
            function zm(c, te) {
              return c.pos = te, c;
            }
            e2.setTextRangePos = zm;
            function Kv(c, te) {
              return c.end = te, c;
            }
            e2.setTextRangeEnd = Kv;
            function Gv(c, te, xr) {
              return Kv(zm(c, te), xr);
            }
            e2.setTextRangePosEnd = Gv;
            function K1(c, te, xr) {
              return Gv(c, te, te + xr);
            }
            e2.setTextRangePosWidth = K1;
            function G1(c, te) {
              return c && (c.flags = te), c;
            }
            e2.setNodeFlags = G1;
            function uc(c, te) {
              return c && te && (c.parent = te), c;
            }
            e2.setParent = uc;
            function Hd(c, te) {
              if (c)
                for (var xr = 0, ei = c; xr < ei.length; xr++) {
                  var bi = ei[xr];
                  uc(bi, te);
                }
              return c;
            }
            e2.setEachParent = Hd;
            function Wm(c, te) {
              if (!c)
                return c;
              return e2.forEachChildRecursively(c, e2.isJSDocNode(c) ? xr : bi), c;
              function xr(Ft, ot) {
                if (te && Ft.parent === ot)
                  return "skip";
                uc(Ft, ot);
              }
              function ei(Ft) {
                if (e2.hasJSDocNodes(Ft))
                  for (var ot = 0, xa = Ft.jsDoc; ot < xa.length; ot++) {
                    var mn = xa[ot];
                    xr(mn, Ft), e2.forEachChildRecursively(mn, xr);
                  }
              }
              function bi(Ft, ot) {
                return xr(Ft, ot) || ei(Ft);
              }
            }
            e2.setParentRecursive = Wm;
            function Hv(c) {
              return !e2.isOmittedExpression(c);
            }
            function H1(c) {
              return e2.isArrayLiteralExpression(c) && e2.every(c.elements, Hv);
            }
            e2.isPackedArrayLiteral = H1;
            function Xv(c) {
              for (e2.Debug.assertIsDefined(c.parent); ; ) {
                var te = c.parent;
                if (e2.isParenthesizedExpression(te)) {
                  c = te;
                  continue;
                }
                if (e2.isExpressionStatement(te) || e2.isVoidExpression(te) || e2.isForStatement(te) && (te.initializer === c || te.incrementor === c))
                  return true;
                if (e2.isCommaListExpression(te)) {
                  if (c !== e2.last(te.elements))
                    return true;
                  c = te;
                  continue;
                }
                if (e2.isBinaryExpression(te) && te.operatorToken.kind === 27) {
                  if (c === te.left)
                    return true;
                  c = te;
                  continue;
                }
                return false;
              }
            }
            e2.expressionResultIsUnused = Xv;
            function D_(c) {
              return e2.some(e2.ignoredPaths, function(te) {
                return e2.stringContains(c, te);
              });
            }
            e2.containsIgnoredPath = D_;
            function X1(c) {
              if (!!c.parent) {
                switch (c.kind) {
                  case 163:
                    var te = c.parent;
                    return te.kind === 190 ? void 0 : te.typeParameters;
                  case 164:
                    return c.parent.parameters;
                  case 199:
                    return c.parent.templateSpans;
                  case 233:
                    return c.parent.templateSpans;
                  case 165:
                    return c.parent.decorators;
                  case 291:
                    return c.parent.heritageClauses;
                }
                var xr = c.parent;
                if (e2.isJSDocTag(c))
                  return e2.isJSDocTypeLiteral(c.parent) ? void 0 : c.parent.tags;
                switch (xr.kind) {
                  case 182:
                  case 258:
                    return e2.isTypeElement(c) ? xr.members : void 0;
                  case 187:
                  case 188:
                    return xr.types;
                  case 184:
                  case 204:
                  case 351:
                  case 269:
                  case 273:
                    return xr.elements;
                  case 205:
                  case 286:
                    return xr.properties;
                  case 208:
                  case 209:
                    return e2.isTypeNode(c) ? xr.typeArguments : xr.expression === c ? void 0 : xr.arguments;
                  case 278:
                  case 282:
                    return e2.isJsxChild(c) ? xr.children : void 0;
                  case 280:
                  case 279:
                    return e2.isTypeNode(c) ? xr.typeArguments : void 0;
                  case 235:
                  case 289:
                  case 290:
                  case 262:
                    return xr.statements;
                  case 263:
                    return xr.clauses;
                  case 257:
                  case 226:
                    return e2.isClassElement(c) ? xr.members : void 0;
                  case 260:
                    return e2.isEnumMember(c) ? xr.members : void 0;
                  case 305:
                    return xr.statements;
                }
              }
            }
            e2.getContainingNodeArray = X1;
            function Q1(c) {
              if (!c.typeParameters) {
                if (e2.some(c.parameters, function(xr) {
                  return !iu(xr);
                }))
                  return true;
                if (c.kind !== 214) {
                  var te = e2.firstOrUndefined(c.parameters);
                  if (!(te && Sf(te)))
                    return true;
                }
              }
              return false;
            }
            e2.hasContextSensitiveParameters = Q1;
            function Y1(c) {
              return c === "Infinity" || c === "-Infinity" || c === "NaN";
            }
            e2.isInfinityOrNaNString = Y1;
            function dh(c) {
              return c.kind === 254 && c.parent.kind === 292;
            }
            e2.isCatchClauseVariableDeclaration = dh;
            function Qv(c) {
              var te = c.valueDeclaration && jf(c.valueDeclaration);
              return !!te && (e2.isParameter(te) || dh(te));
            }
            e2.isParameterOrCatchClauseVariable = Qv;
            function $s(c) {
              return c.kind === 213 || c.kind === 214;
            }
            e2.isFunctionExpressionOrArrowFunction = $s;
            function Xd(c) {
              return c.replace(/\$/gm, function() {
                return "\\$";
              });
            }
            e2.escapeSnippetText = Xd;
            function Yv(c) {
              return (+c).toString() === c;
            }
            e2.isNumericLiteralName = Yv;
            function $v(c, te, xr, ei) {
              return e2.isIdentifierText(c, te) ? e2.factory.createIdentifier(c) : !ei && Yv(c) && +c >= 0 ? e2.factory.createNumericLiteral(+c) : e2.factory.createStringLiteral(c, !!xr);
            }
            e2.createPropertyNameNodeForIdentifierOrLiteral = $v;
            function Zv(c) {
              return !!(c.flags & 262144 && c.isThisType);
            }
            e2.isThisTypeParameter = Zv;
            function bu(c) {
              var te = 0, xr = 0, ei = 0, bi = 0, Ft;
              (function(an) {
                an[an.BeforeNodeModules = 0] = "BeforeNodeModules", an[an.NodeModules = 1] = "NodeModules", an[an.Scope = 2] = "Scope", an[an.PackageContent = 3] = "PackageContent";
              })(Ft || (Ft = {}));
              for (var ot = 0, xa = 0, mn = 0; xa >= 0; )
                switch (ot = xa, xa = c.indexOf("/", ot + 1), mn) {
                  case 0:
                    c.indexOf(e2.nodeModulesPathPart, ot) === ot && (te = ot, xr = xa, mn = 1);
                    break;
                  case 1:
                  case 2:
                    mn === 1 && c.charAt(ot + 1) === "@" ? mn = 2 : (ei = xa, mn = 3);
                    break;
                  case 3:
                    c.indexOf(e2.nodeModulesPathPart, ot) === ot ? mn = 1 : mn = 3;
                    break;
                }
              return bi = ot, mn > 1 ? { topLevelNodeModulesIndex: te, topLevelPackageNameIndex: xr, packageRootIndex: ei, fileNameIndex: bi } : void 0;
            }
            e2.getNodeModulePathParts = bu;
            function $1(c) {
              var te;
              return c.kind === 340 ? (te = c.typeExpression) === null || te === void 0 ? void 0 : te.type : c.type;
            }
            e2.getParameterTypeNode = $1;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a() {
              var C, w, B, E, Q;
              return { createBaseSourceFileNode: le, createBaseIdentifierNode: N, createBasePrivateIdentifierNode: p, createBaseTokenNode: m2, createBaseNode: G };
              function le(oe) {
                return new (Q || (Q = e2.objectAllocator.getSourceFileConstructor()))(oe, -1, -1);
              }
              function N(oe) {
                return new (B || (B = e2.objectAllocator.getIdentifierConstructor()))(oe, -1, -1);
              }
              function p(oe) {
                return new (E || (E = e2.objectAllocator.getPrivateIdentifierConstructor()))(oe, -1, -1);
              }
              function m2(oe) {
                return new (w || (w = e2.objectAllocator.getTokenConstructor()))(oe, -1, -1);
              }
              function G(oe) {
                return new (C || (C = e2.objectAllocator.getNodeConstructor()))(oe, -1, -1);
              }
            }
            e2.createBaseNodeFactory = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w, B;
              return { getParenthesizeLeftSideOfBinaryForOperator: E, getParenthesizeRightSideOfBinaryForOperator: Q, parenthesizeLeftSideOfBinary: G, parenthesizeRightSideOfBinary: oe, parenthesizeExpressionOfComputedPropertyName: f4, parenthesizeConditionOfConditionalExpression: T, parenthesizeBranchOfConditionalExpression: K, parenthesizeExpressionOfExportDefault: b, parenthesizeExpressionOfNew: se, parenthesizeLeftSideOfAccess: J, parenthesizeOperandOfPostfixUnary: ie, parenthesizeOperandOfPrefixUnary: R, parenthesizeExpressionsOfCommaDelimitedList: q, parenthesizeExpressionForDisallowedComma: O, parenthesizeExpressionOfExpressionStatement: ve, parenthesizeConciseBodyOfArrowFunction: ee, parenthesizeCheckTypeOfConditionalType: he, parenthesizeExtendsTypeOfConditionalType: F2, parenthesizeConstituentTypesOfUnionType: X, parenthesizeConstituentTypeOfUnionType: x2, parenthesizeConstituentTypesOfIntersectionType: A2, parenthesizeConstituentTypeOfIntersectionType: $, parenthesizeOperandOfTypeOperator: y, parenthesizeOperandOfReadonlyTypeOperator: V, parenthesizeNonArrayTypeOfPostfixType: L, parenthesizeElementTypesOfTupleType: P, parenthesizeElementTypeOfTupleType: k, parenthesizeTypeOfOptionalType: U, parenthesizeTypeArguments: I, parenthesizeLeadingTypeArgument: j };
              function E(l) {
                w || (w = new e2.Map());
                var d = w.get(l);
                return d || (d = function(D) {
                  return G(l, D);
                }, w.set(l, d)), d;
              }
              function Q(l) {
                B || (B = new e2.Map());
                var d = B.get(l);
                return d || (d = function(D) {
                  return oe(l, void 0, D);
                }, B.set(l, d)), d;
              }
              function le(l, d, D, fe) {
                var g = e2.getOperatorPrecedence(221, l), ne = e2.getOperatorAssociativity(221, l), ue = e2.skipPartiallyEmittedExpressions(d);
                if (!D && d.kind === 214 && g > 3)
                  return true;
                var We = e2.getExpressionPrecedence(ue);
                switch (e2.compareValues(We, g)) {
                  case -1:
                    return !(!D && ne === 1 && d.kind === 224);
                  case 1:
                    return false;
                  case 0:
                    if (D)
                      return ne === 1;
                    if (e2.isBinaryExpression(ue) && ue.operatorToken.kind === l) {
                      if (N(l))
                        return false;
                      if (l === 39) {
                        var Fe = fe ? p(fe) : 0;
                        if (e2.isLiteralKind(Fe) && Fe === p(ue))
                          return false;
                      }
                    }
                    var Z2 = e2.getExpressionAssociativity(ue);
                    return Z2 === 0;
                }
              }
              function N(l) {
                return l === 41 || l === 51 || l === 50 || l === 52;
              }
              function p(l) {
                if (l = e2.skipPartiallyEmittedExpressions(l), e2.isLiteralKind(l.kind))
                  return l.kind;
                if (l.kind === 221 && l.operatorToken.kind === 39) {
                  if (l.cachedLiteralKind !== void 0)
                    return l.cachedLiteralKind;
                  var d = p(l.left), D = e2.isLiteralKind(d) && d === p(l.right) ? d : 0;
                  return l.cachedLiteralKind = D, D;
                }
                return 0;
              }
              function m2(l, d, D, fe) {
                var g = e2.skipPartiallyEmittedExpressions(d);
                return g.kind === 212 ? d : le(l, d, D, fe) ? C.createParenthesizedExpression(d) : d;
              }
              function G(l, d) {
                return m2(l, d, true);
              }
              function oe(l, d, D) {
                return m2(l, D, false, d);
              }
              function f4(l) {
                return e2.isCommaSequence(l) ? C.createParenthesizedExpression(l) : l;
              }
              function T(l) {
                var d = e2.getOperatorPrecedence(222, 57), D = e2.skipPartiallyEmittedExpressions(l), fe = e2.getExpressionPrecedence(D);
                return e2.compareValues(fe, d) !== 1 ? C.createParenthesizedExpression(l) : l;
              }
              function K(l) {
                var d = e2.skipPartiallyEmittedExpressions(l);
                return e2.isCommaSequence(d) ? C.createParenthesizedExpression(l) : l;
              }
              function b(l) {
                var d = e2.skipPartiallyEmittedExpressions(l), D = e2.isCommaSequence(d);
                if (!D)
                  switch (e2.getLeftmostExpression(d, false).kind) {
                    case 226:
                    case 213:
                      D = true;
                  }
                return D ? C.createParenthesizedExpression(l) : l;
              }
              function se(l) {
                var d = e2.getLeftmostExpression(l, true);
                switch (d.kind) {
                  case 208:
                    return C.createParenthesizedExpression(l);
                  case 209:
                    return d.arguments ? l : C.createParenthesizedExpression(l);
                }
                return J(l);
              }
              function J(l) {
                var d = e2.skipPartiallyEmittedExpressions(l);
                return e2.isLeftHandSideExpression(d) && (d.kind !== 209 || d.arguments) ? l : e2.setTextRange(C.createParenthesizedExpression(l), l);
              }
              function ie(l) {
                return e2.isLeftHandSideExpression(l) ? l : e2.setTextRange(C.createParenthesizedExpression(l), l);
              }
              function R(l) {
                return e2.isUnaryExpression(l) ? l : e2.setTextRange(C.createParenthesizedExpression(l), l);
              }
              function q(l) {
                var d = e2.sameMap(l, O);
                return e2.setTextRange(C.createNodeArray(d, l.hasTrailingComma), l);
              }
              function O(l) {
                var d = e2.skipPartiallyEmittedExpressions(l), D = e2.getExpressionPrecedence(d), fe = e2.getOperatorPrecedence(221, 27);
                return D > fe ? l : e2.setTextRange(C.createParenthesizedExpression(l), l);
              }
              function ve(l) {
                var d = e2.skipPartiallyEmittedExpressions(l);
                if (e2.isCallExpression(d)) {
                  var D = d.expression, fe = e2.skipPartiallyEmittedExpressions(D).kind;
                  if (fe === 213 || fe === 214) {
                    var g = C.updateCallExpression(d, e2.setTextRange(C.createParenthesizedExpression(D), D), d.typeArguments, d.arguments);
                    return C.restoreOuterExpressions(l, g, 8);
                  }
                }
                var ne = e2.getLeftmostExpression(d, false).kind;
                return ne === 205 || ne === 213 ? e2.setTextRange(C.createParenthesizedExpression(l), l) : l;
              }
              function ee(l) {
                return !e2.isBlock(l) && (e2.isCommaSequence(l) || e2.getLeftmostExpression(l, false).kind === 205) ? e2.setTextRange(C.createParenthesizedExpression(l), l) : l;
              }
              function he(l) {
                switch (l.kind) {
                  case 179:
                  case 180:
                  case 189:
                    return C.createParenthesizedType(l);
                }
                return l;
              }
              function F2(l) {
                switch (l.kind) {
                  case 189:
                    return C.createParenthesizedType(l);
                }
                return l;
              }
              function x2(l) {
                switch (l.kind) {
                  case 187:
                  case 188:
                    return C.createParenthesizedType(l);
                }
                return he(l);
              }
              function X(l) {
                return C.createNodeArray(e2.sameMap(l, x2));
              }
              function $(l) {
                switch (l.kind) {
                  case 187:
                  case 188:
                    return C.createParenthesizedType(l);
                }
                return x2(l);
              }
              function A2(l) {
                return C.createNodeArray(e2.sameMap(l, $));
              }
              function y(l) {
                switch (l.kind) {
                  case 188:
                    return C.createParenthesizedType(l);
                }
                return $(l);
              }
              function V(l) {
                switch (l.kind) {
                  case 193:
                    return C.createParenthesizedType(l);
                }
                return y(l);
              }
              function L(l) {
                switch (l.kind) {
                  case 190:
                  case 193:
                  case 181:
                    return C.createParenthesizedType(l);
                }
                return y(l);
              }
              function P(l) {
                return C.createNodeArray(e2.sameMap(l, k));
              }
              function k(l) {
                return Y(l) ? C.createParenthesizedType(l) : l;
              }
              function Y(l) {
                return e2.isJSDocNullableType(l) ? l.postfix : e2.isNamedTupleMember(l) || e2.isFunctionTypeNode(l) || e2.isConstructorTypeNode(l) || e2.isTypeOperatorNode(l) ? Y(l.type) : e2.isConditionalTypeNode(l) ? Y(l.falseType) : e2.isUnionTypeNode(l) || e2.isIntersectionTypeNode(l) ? Y(e2.last(l.types)) : e2.isInferTypeNode(l) ? !!l.typeParameter.constraint && Y(l.typeParameter.constraint) : false;
              }
              function U(l) {
                return Y(l) ? C.createParenthesizedType(l) : L(l);
              }
              function j(l) {
                return e2.isFunctionOrConstructorTypeNode(l) && l.typeParameters ? C.createParenthesizedType(l) : l;
              }
              function H(l, d) {
                return d === 0 ? j(l) : l;
              }
              function I(l) {
                if (e2.some(l))
                  return C.createNodeArray(e2.sameMap(l, H));
              }
            }
            e2.createParenthesizerRules = a, e2.nullParenthesizerRules = { getParenthesizeLeftSideOfBinaryForOperator: function(C) {
              return e2.identity;
            }, getParenthesizeRightSideOfBinaryForOperator: function(C) {
              return e2.identity;
            }, parenthesizeLeftSideOfBinary: function(C, w) {
              return w;
            }, parenthesizeRightSideOfBinary: function(C, w, B) {
              return B;
            }, parenthesizeExpressionOfComputedPropertyName: e2.identity, parenthesizeConditionOfConditionalExpression: e2.identity, parenthesizeBranchOfConditionalExpression: e2.identity, parenthesizeExpressionOfExportDefault: e2.identity, parenthesizeExpressionOfNew: function(C) {
              return e2.cast(C, e2.isLeftHandSideExpression);
            }, parenthesizeLeftSideOfAccess: function(C) {
              return e2.cast(C, e2.isLeftHandSideExpression);
            }, parenthesizeOperandOfPostfixUnary: function(C) {
              return e2.cast(C, e2.isLeftHandSideExpression);
            }, parenthesizeOperandOfPrefixUnary: function(C) {
              return e2.cast(C, e2.isUnaryExpression);
            }, parenthesizeExpressionsOfCommaDelimitedList: function(C) {
              return e2.cast(C, e2.isNodeArray);
            }, parenthesizeExpressionForDisallowedComma: e2.identity, parenthesizeExpressionOfExpressionStatement: e2.identity, parenthesizeConciseBodyOfArrowFunction: e2.identity, parenthesizeCheckTypeOfConditionalType: e2.identity, parenthesizeExtendsTypeOfConditionalType: e2.identity, parenthesizeConstituentTypesOfUnionType: function(C) {
              return e2.cast(C, e2.isNodeArray);
            }, parenthesizeConstituentTypeOfUnionType: e2.identity, parenthesizeConstituentTypesOfIntersectionType: function(C) {
              return e2.cast(C, e2.isNodeArray);
            }, parenthesizeConstituentTypeOfIntersectionType: e2.identity, parenthesizeOperandOfTypeOperator: e2.identity, parenthesizeOperandOfReadonlyTypeOperator: e2.identity, parenthesizeNonArrayTypeOfPostfixType: e2.identity, parenthesizeElementTypesOfTupleType: function(C) {
              return e2.cast(C, e2.isNodeArray);
            }, parenthesizeElementTypeOfTupleType: e2.identity, parenthesizeTypeOfOptionalType: e2.identity, parenthesizeTypeArguments: function(C) {
              return C && e2.cast(C, e2.isNodeArray);
            }, parenthesizeLeadingTypeArgument: e2.identity };
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              return { convertToFunctionBlock: w, convertToFunctionExpression: B, convertToArrayAssignmentElement: E, convertToObjectAssignmentElement: Q, convertToAssignmentPattern: le, convertToObjectAssignmentPattern: N, convertToArrayAssignmentPattern: p, convertToAssignmentElementTarget: m2 };
              function w(G, oe) {
                if (e2.isBlock(G))
                  return G;
                var f4 = C.createReturnStatement(G);
                e2.setTextRange(f4, G);
                var T = C.createBlock([f4], oe);
                return e2.setTextRange(T, G), T;
              }
              function B(G) {
                if (!G.body)
                  return e2.Debug.fail("Cannot convert a FunctionDeclaration without a body");
                var oe = C.createFunctionExpression(G.modifiers, G.asteriskToken, G.name, G.typeParameters, G.parameters, G.type, G.body);
                return e2.setOriginalNode(oe, G), e2.setTextRange(oe, G), e2.getStartsOnNewLine(G) && e2.setStartsOnNewLine(oe, true), oe;
              }
              function E(G) {
                if (e2.isBindingElement(G)) {
                  if (G.dotDotDotToken)
                    return e2.Debug.assertNode(G.name, e2.isIdentifier), e2.setOriginalNode(e2.setTextRange(C.createSpreadElement(G.name), G), G);
                  var oe = m2(G.name);
                  return G.initializer ? e2.setOriginalNode(e2.setTextRange(C.createAssignment(oe, G.initializer), G), G) : oe;
                }
                return e2.cast(G, e2.isExpression);
              }
              function Q(G) {
                if (e2.isBindingElement(G)) {
                  if (G.dotDotDotToken)
                    return e2.Debug.assertNode(G.name, e2.isIdentifier), e2.setOriginalNode(e2.setTextRange(C.createSpreadAssignment(G.name), G), G);
                  if (G.propertyName) {
                    var oe = m2(G.name);
                    return e2.setOriginalNode(e2.setTextRange(C.createPropertyAssignment(G.propertyName, G.initializer ? C.createAssignment(oe, G.initializer) : oe), G), G);
                  }
                  return e2.Debug.assertNode(G.name, e2.isIdentifier), e2.setOriginalNode(e2.setTextRange(C.createShorthandPropertyAssignment(G.name, G.initializer), G), G);
                }
                return e2.cast(G, e2.isObjectLiteralElementLike);
              }
              function le(G) {
                switch (G.kind) {
                  case 202:
                  case 204:
                    return p(G);
                  case 201:
                  case 205:
                    return N(G);
                }
              }
              function N(G) {
                return e2.isObjectBindingPattern(G) ? e2.setOriginalNode(e2.setTextRange(C.createObjectLiteralExpression(e2.map(G.elements, Q)), G), G) : e2.cast(G, e2.isObjectLiteralExpression);
              }
              function p(G) {
                return e2.isArrayBindingPattern(G) ? e2.setOriginalNode(e2.setTextRange(C.createArrayLiteralExpression(e2.map(G.elements, E)), G), G) : e2.cast(G, e2.isArrayLiteralExpression);
              }
              function m2(G) {
                return e2.isBindingPattern(G) ? le(G) : e2.cast(G, e2.isExpression);
              }
            }
            e2.createNodeConverters = a, e2.nullNodeConverters = { convertToFunctionBlock: e2.notImplemented, convertToFunctionExpression: e2.notImplemented, convertToArrayAssignmentElement: e2.notImplemented, convertToObjectAssignmentElement: e2.notImplemented, convertToAssignmentPattern: e2.notImplemented, convertToObjectAssignmentPattern: e2.notImplemented, convertToArrayAssignmentPattern: e2.notImplemented, convertToAssignmentElementTarget: e2.notImplemented };
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = 0, C;
            (function(X) {
              X[X.None = 0] = "None", X[X.NoParenthesizerRules = 1] = "NoParenthesizerRules", X[X.NoNodeConverters = 2] = "NoNodeConverters", X[X.NoIndentationOnFreshPropertyAccess = 4] = "NoIndentationOnFreshPropertyAccess", X[X.NoOriginalNode = 8] = "NoOriginalNode";
            })(C = e2.NodeFactoryFlags || (e2.NodeFactoryFlags = {}));
            function w(X, $) {
              var A2 = X & 8 ? B : E, y = e2.memoize(function() {
                return X & 1 ? e2.nullParenthesizerRules : e2.createParenthesizerRules(g);
              }), V = e2.memoize(function() {
                return X & 2 ? e2.nullNodeConverters : e2.createNodeConverters(g);
              }), L = e2.memoizeOne(function(_) {
                return function(W, Te) {
                  return jr(W, _, Te);
                };
              }), P = e2.memoizeOne(function(_) {
                return function(W) {
                  return Pt(_, W);
                };
              }), k = e2.memoizeOne(function(_) {
                return function(W) {
                  return ua(W, _);
                };
              }), Y = e2.memoizeOne(function(_) {
                return function() {
                  return Zl(_);
                };
              }), U = e2.memoizeOne(function(_) {
                return function(W) {
                  return kl(_, W);
                };
              }), j = e2.memoizeOne(function(_) {
                return function(W, Te) {
                  return zd(_, W, Te);
                };
              }), H = e2.memoizeOne(function(_) {
                return function(W, Te) {
                  return R_(_, W, Te);
                };
              }), I = e2.memoizeOne(function(_) {
                return function(W, Te) {
                  return __(_, W, Te);
                };
              }), l = e2.memoizeOne(function(_) {
                return function(W, Te) {
                  return Wf(_, W, Te);
                };
              }), d = e2.memoizeOne(function(_) {
                return function(W, Te, cr) {
                  return Sf(_, W, Te, cr);
                };
              }), D = e2.memoizeOne(function(_) {
                return function(W, Te, cr) {
                  return ll(_, W, Te, cr);
                };
              }), fe = e2.memoizeOne(function(_) {
                return function(W, Te, cr, ni) {
                  return J_(_, W, Te, cr, ni);
                };
              }), g = { get parenthesizer() {
                return y();
              }, get converters() {
                return V();
              }, baseFactory: $, flags: X, createNodeArray: ne, createNumericLiteral: we, createBigIntLiteral: de, createStringLiteral: Ae, createStringLiteralFromNode: er, createRegularExpressionLiteral: ir, createLiteralLikeNode: Cr, createIdentifier: Er, updateIdentifier: Ne, createTempVariable: n, createLoopVariable: lr, createUniqueName: be, getGeneratedNameForNode: Ge, createPrivateIdentifier: ur, createToken: Ir, createSuper: wr, createThis: Ur, createNull: ii, createTrue: mi, createFalse: pe, createModifier: or, createModifiersFromModifierFlags: qr, createQualifiedName: si, updateQualifiedName: Di, createComputedPropertyName: wi, updateComputedPropertyName: Xi, createTypeParameterDeclaration: et, updateTypeParameterDeclaration: Gi, createParameterDeclaration: Wt, updateParameterDeclaration: Zt, createDecorator: _r, updateDecorator: pi, createPropertySignature: ae, updatePropertySignature: Xe, createPropertyDeclaration: Jr, updatePropertyDeclaration: ti, createMethodSignature: Ze, updateMethodSignature: Sr, createMethodDeclaration: zr, updateMethodDeclaration: Wr, createConstructorDeclaration: vr, updateConstructorDeclaration: mr, createGetAccessorDeclaration: Ar, updateGetAccessorDeclaration: Oe, createSetAccessorDeclaration: nr, updateSetAccessorDeclaration: Mr, createCallSignature: Pe, updateCallSignature: Ue, createConstructSignature: fr, updateConstructSignature: De, createIndexSignature: gr, updateIndexSignature: Vr, createClassStaticBlockDeclaration: Je, updateClassStaticBlockDeclaration: xe, createTemplateLiteralTypeSpan: Tr, updateTemplateLiteralTypeSpan: vi, createKeywordTypeNode: Ui, createTypePredicateNode: Yi, updateTypePredicateNode: Wi, createTypeReferenceNode: ct, updateTypeReferenceNode: Li, createFunctionTypeNode: nt, updateFunctionTypeNode: Mt, createConstructorTypeNode: xt, updateConstructorTypeNode: Rt, createTypeQueryNode: Fi, updateTypeQueryNode: ui, createTypeLiteralNode: Bt, updateTypeLiteralNode: wt, createArrayTypeNode: na, updateArrayTypeNode: Ai, createTupleTypeNode: Oi, updateTupleTypeNode: ji, createNamedTupleMember: Vi, updateNamedTupleMember: at, createOptionalTypeNode: At, updateOptionalTypeNode: ba, createRestTypeNode: $a, updateRestTypeNode: Qa, createUnionTypeNode: ka, updateUnionTypeNode: Ba, createIntersectionTypeNode: pn, updateIntersectionTypeNode: Cn, createConditionalTypeNode: Bi, updateConditionalTypeNode: kn, createInferTypeNode: xn, updateInferTypeNode: Kn, createImportTypeNode: Rn, updateImportTypeNode: Da, createParenthesizedType: bo, updateParenthesizedType: Ro, createThisTypeNode: En, createTypeOperatorNode: Wn, updateTypeOperatorNode: to, createIndexedAccessTypeNode: Co, updateIndexedAccessTypeNode: Ko, createMappedTypeNode: Oo, updateMappedTypeNode: no, createLiteralTypeNode: $o, updateLiteralTypeNode: Pr, createTemplateLiteralType: Pn, updateTemplateLiteralType: eo, createObjectBindingPattern: xi, updateObjectBindingPattern: St, createArrayBindingPattern: pa, updateArrayBindingPattern: dn, createBindingElement: Jn, updateBindingElement: Qe, createArrayLiteralExpression: S2, updateArrayLiteralExpression: Ce, createObjectLiteralExpression: qe, updateObjectLiteralExpression: br, createPropertyAccessExpression: X & 4 ? function(_, W) {
                return e2.setEmitFlags(Zr(_, W), 131072);
              } : Zr, updatePropertyAccessExpression: Si, createPropertyAccessChain: X & 4 ? function(_, W, Te) {
                return e2.setEmitFlags(Pi(_, W, Te), 131072);
              } : Pi, updatePropertyAccessChain: Qi, createElementAccessExpression: Ct, updateElementAccessExpression: sa, createElementAccessChain: en, updateElementAccessChain: Wa, createCallExpression: qn, updateCallExpression: mo, createCallChain: So, updateCallChain: Go, createNewExpression: ys, updateNewExpression: Pc, createTaggedTemplateExpression: Vc, updateTaggedTemplateExpression: Kc, createTypeAssertion: Xs, updateTypeAssertion: pc, createParenthesizedExpression: hs, updateParenthesizedExpression: tc, createFunctionExpression: ps, updateFunctionExpression: Qs, createArrowFunction: js, updateArrowFunction: ds, createDeleteExpression: Ji, updateDeleteExpression: ce, createTypeOfExpression: Rr, updateTypeOfExpression: yi, createVoidExpression: qi, updateVoidExpression: je, createAwaitExpression: Hr, updateAwaitExpression: pt, createPrefixUnaryExpression: Pt, updatePrefixUnaryExpression: ga, createPostfixUnaryExpression: ua, updatePostfixUnaryExpression: Xn, createBinaryExpression: jr, updateBinaryExpression: xs, createConditionalExpression: Fo, updateConditionalExpression: ko, createTemplateExpression: Ao, updateTemplateExpression: Ms, createTemplateHead: su, createTemplateMiddle: tl, createTemplateTail: Zc, createNoSubstitutionTemplateLiteral: Rf, createTemplateLiteralLikeNode: xc, createYieldExpression: al, updateYieldExpression: Jo, createSpreadElement: eu, updateSpreadElement: Ws, createClassExpression: pu, updateClassExpression: Uu, createOmittedExpression: Ql, createExpressionWithTypeArguments: xl, updateExpressionWithTypeArguments: Ya, createAsExpression: du, updateAsExpression: vc, createNonNullExpression: Kr, updateNonNullExpression: _i, createNonNullChain: Ei, updateNonNullChain: tt, createMetaProperty: kt, updateMetaProperty: bt, createTemplateSpan: ia, updateTemplateSpan: Xt, createSemicolonClassElement: Za, createBlock: bn, updateBlock: _a4, createVariableStatement: qa, updateVariableStatement: rn, createEmptyStatement: jn, createExpressionStatement: Mo, updateExpressionStatement: ho, createIfStatement: gs, updateIfStatement: Se, createDoStatement: hr, updateDoStatement: Or, createWhileStatement: ki, updateWhileStatement: dt, createForStatement: la, updateForStatement: wa, createForInStatement: On, updateForInStatement: No, createForOfStatement: jo, updateForOfStatement: po, createContinueStatement: Gn, updateContinueStatement: $n, createBreakStatement: Ho, updateBreakStatement: Zo, createReturnStatement: Es, updateReturnStatement: yc, createWithStatement: Xr, updateWithStatement: Ls, createSwitchStatement: Ic, updateSwitchStatement: zu, createLabeledStatement: vf, updateLabeledStatement: P_, createThrowStatement: El, updateThrowStatement: vp, createTryStatement: oo, updateTryStatement: I_, createDebuggerStatement: yp, createVariableDeclaration: Yl, updateVariableDeclaration: Bf, createVariableDeclarationList: Cl, updateVariableDeclarationList: c_, createFunctionDeclaration: hp, updateFunctionDeclaration: gu, createClassDeclaration: Dp, updateClassDeclaration: sd, createInterfaceDeclaration: Aa, updateInterfaceDeclaration: va, createTypeAliasDeclaration: Cu, updateTypeAliasDeclaration: qs, createEnumDeclaration: cd, updateEnumDeclaration: ns, createModuleDeclaration: nl, updateModuleDeclaration: hc, createModuleBlock: es, updateModuleBlock: u_, createCaseBlock: Jf, updateCaseBlock: w_, createNamespaceExportDeclaration: ud, updateNamespaceExportDeclaration: ku, createImportEqualsDeclaration: ld, updateImportEqualsDeclaration: fd, createImportDeclaration: bp, updateImportDeclaration: Sp, createImportClause: Tp, updateImportClause: _d2, createAssertClause: jf, updateAssertClause: O_, createAssertEntry: F_, updateAssertEntry: pd, createImportTypeAssertionContainer: xp, updateImportTypeAssertionContainer: M_, createNamespaceImport: Ep, updateNamespaceImport: ol, createNamespaceExport: Au, updateNamespaceExport: ru, createNamedImports: yf, updateNamedImports: Cp, createImportSpecifier: dd, updateImportSpecifier: kp, createExportAssignment: mu, updateExportAssignment: gd, createExportDeclaration: hf, updateExportDeclaration: $l, createNamedExports: Uf, updateNamedExports: L_, createExportSpecifier: l_, updateExportSpecifier: f_, createMissingDeclaration: md, createExternalModuleReference: ks, updateExternalModuleReference: Wu, get createJSDocAllType() {
                return Y(312);
              }, get createJSDocUnknownType() {
                return Y(313);
              }, get createJSDocNonNullableType() {
                return H(315);
              }, get updateJSDocNonNullableType() {
                return I(315);
              }, get createJSDocNullableType() {
                return H(314);
              }, get updateJSDocNullableType() {
                return I(314);
              }, get createJSDocOptionalType() {
                return U(316);
              }, get updateJSDocOptionalType() {
                return j(316);
              }, get createJSDocVariadicType() {
                return U(318);
              }, get updateJSDocVariadicType() {
                return j(318);
              }, get createJSDocNamepathType() {
                return U(319);
              }, get updateJSDocNamepathType() {
                return j(319);
              }, createJSDocFunctionType: Al, updateJSDocFunctionType: wc, createJSDocTypeLiteral: qu, updateJSDocTypeLiteral: Vu, createJSDocTypeExpression: ef, updateJSDocTypeExpression: sl, createJSDocSignature: p_, updateJSDocSignature: Df, createJSDocTemplateTag: os, updateJSDocTemplateTag: Ps, createJSDocTypedefTag: d_, updateJSDocTypedefTag: Gc, createJSDocParameterTag: B_, updateJSDocParameterTag: vu, createJSDocPropertyTag: Gt, updateJSDocPropertyTag: As, createJSDocCallbackTag: vn, updateJSDocCallbackTag: Nl, createJSDocAugmentsTag: cl, updateJSDocAugmentsTag: rf, createJSDocImplementsTag: Ut, updateJSDocImplementsTag: Ap, createJSDocSeeTag: Ds, updateJSDocSeeTag: bf, createJSDocNameReference: bs, updateJSDocNameReference: Dc, createJSDocMemberName: Cc, updateJSDocMemberName: ac, createJSDocLink: Pl, updateJSDocLink: Il, createJSDocLinkCode: zf, updateJSDocLinkCode: ul, createJSDocLinkPlain: Nu, updateJSDocLinkPlain: Us, get createJSDocTypeTag() {
                return D(343);
              }, get updateJSDocTypeTag() {
                return fe(343);
              }, get createJSDocReturnTag() {
                return D(341);
              }, get updateJSDocReturnTag() {
                return fe(341);
              }, get createJSDocThisTag() {
                return D(342);
              }, get updateJSDocThisTag() {
                return fe(342);
              }, get createJSDocEnumTag() {
                return D(339);
              }, get updateJSDocEnumTag() {
                return fe(339);
              }, get createJSDocAuthorTag() {
                return l(330);
              }, get updateJSDocAuthorTag() {
                return d(330);
              }, get createJSDocClassTag() {
                return l(332);
              }, get updateJSDocClassTag() {
                return d(332);
              }, get createJSDocPublicTag() {
                return l(333);
              }, get updateJSDocPublicTag() {
                return d(333);
              }, get createJSDocPrivateTag() {
                return l(334);
              }, get updateJSDocPrivateTag() {
                return d(334);
              }, get createJSDocProtectedTag() {
                return l(335);
              }, get updateJSDocProtectedTag() {
                return d(335);
              }, get createJSDocReadonlyTag() {
                return l(336);
              }, get updateJSDocReadonlyTag() {
                return d(336);
              }, get createJSDocOverrideTag() {
                return l(337);
              }, get updateJSDocOverrideTag() {
                return d(337);
              }, get createJSDocDeprecatedTag() {
                return l(331);
              }, get updateJSDocDeprecatedTag() {
                return d(331);
              }, createJSDocUnknownTag: j_, updateJSDocUnknownTag: U_, createJSDocText: iu, updateJSDocText: vd, createJSDocComment: qf, updateJSDocComment: dc, createJsxElement: Pu, updateJsxElement: wl, createJsxSelfClosingElement: Iu, updateJsxSelfClosingElement: so, createJsxOpeningElement: Et, updateJsxOpeningElement: Ys, createJsxClosingElement: Ku, updateJsxClosingElement: Np, createJsxFragment: Pp, createJsxText: fl, updateJsxText: _l, createJsxOpeningFragment: cu, createJsxJsxClosingFragment: gc, updateJsxFragment: nc, createJsxAttribute: Tf, updateJsxAttribute: mc, createJsxAttributes: Ip, updateJsxAttributes: ms, createJsxSpreadAttribute: tu, updateJsxSpreadAttribute: wp, createJsxExpression: Hc, updateJsxExpression: Ol, createCaseClause: tf, updateCaseClause: xf, createDefaultClause: z_, updateDefaultClause: Oc, createHeritageClause: rs, updateHeritageClause: Op, createCatchClause: Ef, updateCatchClause: Fl, createPropertyAssignment: pl, updatePropertyAssignment: Mp, createShorthandPropertyAssignment: Gu, updateShorthandPropertyAssignment: Cf, createSpreadAssignment: W_, updateSpreadAssignment: g_, createEnumMember: dl, updateEnumMember: gl, createSourceFile: Vf, updateSourceFile: Hu, createBundle: af, updateBundle: tn, createUnparsedSource: Ml, createUnparsedPrologue: nf, createUnparsedPrepend: q_, createUnparsedTextLike: Kf, createUnparsedSyntheticReference: Rp, createInputFiles: yd, createSyntheticExpression: m_, createSyntaxList: Ll, createNotEmittedStatement: hd, createPartiallyEmittedExpression: v_, updatePartiallyEmittedExpression: Bp, createCommaListExpression: Xc, updateCommaListExpression: Gf, createEndOfDeclarationMarker: of, createMergeDeclarationMarker: wu, createSyntheticReferenceExpression: V_, updateSyntheticReferenceExpression: yu, cloneNode: v, get createComma() {
                return L(27);
              }, get createAssignment() {
                return L(63);
              }, get createLogicalOr() {
                return L(56);
              }, get createLogicalAnd() {
                return L(55);
              }, get createBitwiseOr() {
                return L(51);
              }, get createBitwiseXor() {
                return L(52);
              }, get createBitwiseAnd() {
                return L(50);
              }, get createStrictEquality() {
                return L(36);
              }, get createStrictInequality() {
                return L(37);
              }, get createEquality() {
                return L(34);
              }, get createInequality() {
                return L(35);
              }, get createLessThan() {
                return L(29);
              }, get createLessThanEquals() {
                return L(32);
              }, get createGreaterThan() {
                return L(31);
              }, get createGreaterThanEquals() {
                return L(33);
              }, get createLeftShift() {
                return L(47);
              }, get createRightShift() {
                return L(48);
              }, get createUnsignedRightShift() {
                return L(49);
              }, get createAdd() {
                return L(39);
              }, get createSubtract() {
                return L(40);
              }, get createMultiply() {
                return L(41);
              }, get createDivide() {
                return L(43);
              }, get createModulo() {
                return L(44);
              }, get createExponent() {
                return L(42);
              }, get createPrefixPlus() {
                return P(39);
              }, get createPrefixMinus() {
                return P(40);
              }, get createPrefixIncrement() {
                return P(45);
              }, get createPrefixDecrement() {
                return P(46);
              }, get createBitwiseNot() {
                return P(54);
              }, get createLogicalNot() {
                return P(53);
              }, get createPostfixIncrement() {
                return k(45);
              }, get createPostfixDecrement() {
                return k(46);
              }, createImmediatelyInvokedFunctionExpression: sr, createImmediatelyInvokedArrowFunction: fi, createVoidZero: zi, createExportDefault: Sa, createExternalModuleExport: da, createTypeCheck: Ha, createMethodCall: ta, createGlobalMethodCall: oc, createFunctionBindCall: nn, createFunctionCallCall: Wo, createFunctionApplyCall: Lo, createArraySliceCall: uu, createArrayConcatCall: is, createObjectDefinePropertyCall: au, createReflectGetCall: Ou, createReflectSetCall: sf, createPropertyDescriptor: cf, createCallBinding: G_, createAssignmentTargetWrapper: Le, inlineExpressions: Nr, getInternalName: di, getLocalName: Mi, getExportName: st, getDeclarationName: ra, getNamespaceMemberName: Ta, getExternalModuleOrNamespaceExportName: ha, restoreOuterExpressions: Jp, restoreEnclosingLabel: Hf, createUseStrictPrologue: qo, copyPrologue: Na, copyStandardPrologue: co, copyCustomPrologue: ts, ensureUseStrict: vs, liftToBlock: Ac, mergeLexicalEnvironment: Qu, updateModifiers: sc };
              return g;
              function ne(_, W) {
                if (_ === void 0 || _ === e2.emptyArray)
                  _ = [];
                else if (e2.isNodeArray(_)) {
                  if (W === void 0 || _.hasTrailingComma === W)
                    return _.transformFlags === void 0 && T(_), e2.Debug.attachNodeArrayDebugInfo(_), _;
                  var Te = _.slice();
                  return Te.pos = _.pos, Te.end = _.end, Te.hasTrailingComma = W, Te.transformFlags = _.transformFlags, e2.Debug.attachNodeArrayDebugInfo(Te), Te;
                }
                var cr = _.length, ni = cr >= 1 && cr <= 4 ? _.slice() : _;
                return e2.setTextRangePosEnd(ni, -1, -1), ni.hasTrailingComma = !!W, T(ni), e2.Debug.attachNodeArrayDebugInfo(ni), ni;
              }
              function ue(_) {
                return $.createBaseNode(_);
              }
              function We(_, W, Te) {
                var cr = ue(_);
                return cr.decorators = bc(W), cr.modifiers = bc(Te), cr.transformFlags |= f4(cr.decorators) | f4(cr.modifiers), cr.symbol = void 0, cr.localSymbol = void 0, cr.locals = void 0, cr.nextContainer = void 0, cr;
              }
              function Fe(_, W, Te, cr) {
                var ni = We(_, W, Te);
                if (cr = Mc(cr), ni.name = cr, cr)
                  switch (ni.kind) {
                    case 169:
                    case 172:
                    case 173:
                    case 167:
                    case 296:
                      if (e2.isIdentifier(cr)) {
                        ni.transformFlags |= m2(cr);
                        break;
                      }
                    default:
                      ni.transformFlags |= oe(cr);
                      break;
                  }
                return ni;
              }
              function Z2(_, W, Te, cr, ni) {
                var rt = Fe(_, W, Te, cr);
                return rt.typeParameters = bc(ni), rt.transformFlags |= f4(rt.typeParameters), ni && (rt.transformFlags |= 1), rt;
              }
              function Be(_, W, Te, cr, ni, rt, yt) {
                var Xa = Z2(_, W, Te, cr, ni);
                return Xa.parameters = ne(rt), Xa.type = yt, Xa.transformFlags |= f4(Xa.parameters) | oe(Xa.type), yt && (Xa.transformFlags |= 1), Xa;
              }
              function ge(_, W) {
                return W.typeArguments && (_.typeArguments = W.typeArguments), A2(_, W);
              }
              function Re(_, W, Te, cr, ni, rt, yt, Xa) {
                var vo = Be(_, W, Te, cr, ni, rt, yt);
                return vo.body = Xa, vo.transformFlags |= oe(vo.body) & -16777217, Xa || (vo.transformFlags |= 1), vo;
              }
              function ze(_, W) {
                return W.exclamationToken && (_.exclamationToken = W.exclamationToken), W.typeArguments && (_.typeArguments = W.typeArguments), ge(_, W);
              }
              function Ee(_, W, Te, cr, ni, rt) {
                var yt = Z2(_, W, Te, cr, ni);
                return yt.heritageClauses = bc(rt), yt.transformFlags |= f4(yt.heritageClauses), yt;
              }
              function He(_, W, Te, cr, ni, rt, yt) {
                var Xa = Ee(_, W, Te, cr, ni, rt);
                return Xa.members = ne(yt), Xa.transformFlags |= f4(Xa.members), Xa;
              }
              function rr(_, W, Te, cr, ni) {
                var rt = Fe(_, W, Te, cr);
                return rt.initializer = ni, rt.transformFlags |= oe(rt.initializer), rt;
              }
              function Ie(_, W, Te, cr, ni, rt) {
                var yt = rr(_, W, Te, cr, rt);
                return yt.type = ni, yt.transformFlags |= oe(ni), ni && (yt.transformFlags |= 1), yt;
              }
              function _e(_, W) {
                var Te = yr(_);
                return Te.text = W, Te;
              }
              function we(_, W) {
                W === void 0 && (W = 0);
                var Te = _e(8, typeof _ == "number" ? _ + "" : _);
                return Te.numericLiteralFlags = W, W & 384 && (Te.transformFlags |= 1024), Te;
              }
              function de(_) {
                var W = _e(9, typeof _ == "string" ? _ : e2.pseudoBigIntToString(_) + "n");
                return W.transformFlags |= 4, W;
              }
              function ye(_, W) {
                var Te = _e(10, _);
                return Te.singleQuote = W, Te;
              }
              function Ae(_, W, Te) {
                var cr = ye(_, W);
                return cr.hasExtendedUnicodeEscape = Te, Te && (cr.transformFlags |= 1024), cr;
              }
              function er(_) {
                var W = ye(e2.getTextOfIdentifierOrLiteral(_), void 0);
                return W.textSourceNode = _, W;
              }
              function ir(_) {
                var W = _e(13, _);
                return W;
              }
              function Cr(_, W) {
                switch (_) {
                  case 8:
                    return we(W, 0);
                  case 9:
                    return de(W);
                  case 10:
                    return Ae(W, void 0);
                  case 11:
                    return fl(W, false);
                  case 12:
                    return fl(W, true);
                  case 13:
                    return ir(W);
                  case 14:
                    return xc(_, W, void 0, 0);
                }
              }
              function Ye(_, W) {
                W === void 0 && _ && (W = e2.stringToToken(_)), W === 79 && (W = void 0);
                var Te = $.createBaseIdentifierNode(79);
                return Te.originalKeywordKind = W, Te.escapedText = e2.escapeLeadingUnderscores(_), Te;
              }
              function Br(_, W) {
                var Te = Ye(_, void 0);
                return Te.autoGenerateFlags = W, Te.autoGenerateId = a, a++, Te;
              }
              function Er(_, W, Te) {
                var cr = Ye(_, Te);
                return W && (cr.typeArguments = ne(W)), cr.originalKeywordKind === 132 && (cr.transformFlags |= 16777216), cr;
              }
              function Ne(_, W) {
                return _.typeArguments !== W ? A2(Er(e2.idText(_), W), _) : _;
              }
              function n(_, W) {
                var Te = 1;
                W && (Te |= 8);
                var cr = Br("", Te);
                return _ && _(cr), cr;
              }
              function lr(_) {
                var W = 2;
                return _ && (W |= 8), Br("", W);
              }
              function be(_, W) {
                return W === void 0 && (W = 0), e2.Debug.assert(!(W & 7), "Argument out of range: flags"), e2.Debug.assert((W & 48) !== 32, "GeneratedIdentifierFlags.FileLevel cannot be set without also setting GeneratedIdentifierFlags.Optimistic"), Br(_, 3 | W);
              }
              function Ge(_, W) {
                W === void 0 && (W = 0), e2.Debug.assert(!(W & 7), "Argument out of range: flags");
                var Te = Br(_ && e2.isIdentifier(_) ? e2.idText(_) : "", 4 | W);
                return Te.original = _, Te;
              }
              function ur(_) {
                e2.startsWith(_, "#") || e2.Debug.fail("First character of private identifier must be #: " + _);
                var W = $.createBasePrivateIdentifierNode(80);
                return W.escapedText = e2.escapeLeadingUnderscores(_), W.transformFlags |= 8388608, W;
              }
              function yr(_) {
                return $.createBaseTokenNode(_);
              }
              function Ir(_) {
                e2.Debug.assert(_ >= 0 && _ <= 160, "Invalid token"), e2.Debug.assert(_ <= 14 || _ >= 17, "Invalid token. Use 'createTemplateLiteralLikeNode' to create template literals."), e2.Debug.assert(_ <= 8 || _ >= 14, "Invalid token. Use 'createLiteralLikeNode' to create literals."), e2.Debug.assert(_ !== 79, "Invalid token. Use 'createIdentifier' to create identifiers");
                var W = yr(_), Te = 0;
                switch (_) {
                  case 131:
                    Te = 384;
                    break;
                  case 123:
                  case 121:
                  case 122:
                  case 145:
                  case 126:
                  case 135:
                  case 85:
                  case 130:
                  case 147:
                  case 158:
                  case 143:
                  case 148:
                  case 101:
                  case 144:
                  case 159:
                  case 150:
                  case 133:
                  case 151:
                  case 114:
                  case 155:
                  case 153:
                    Te = 1;
                    break;
                  case 106:
                    Te = 33555456;
                    break;
                  case 124:
                    Te = 1024;
                    break;
                  case 108:
                    Te = 8192;
                    break;
                }
                return Te && (W.transformFlags |= Te), W;
              }
              function wr() {
                return Ir(106);
              }
              function Ur() {
                return Ir(108);
              }
              function ii() {
                return Ir(104);
              }
              function mi() {
                return Ir(110);
              }
              function pe() {
                return Ir(95);
              }
              function or(_) {
                return Ir(_);
              }
              function qr(_) {
                var W = [];
                return _ & 1 && W.push(or(93)), _ & 2 && W.push(or(135)), _ & 512 && W.push(or(88)), _ & 2048 && W.push(or(85)), _ & 4 && W.push(or(123)), _ & 8 && W.push(or(121)), _ & 16 && W.push(or(122)), _ & 128 && W.push(or(126)), _ & 32 && W.push(or(124)), _ & 16384 && W.push(or(159)), _ & 64 && W.push(or(145)), _ & 256 && W.push(or(131)), _ & 32768 && W.push(or(101)), _ & 65536 && W.push(or(144)), W.length ? W : void 0;
              }
              function si(_, W) {
                var Te = ue(161);
                return Te.left = _, Te.right = Mc(W), Te.transformFlags |= oe(Te.left) | m2(Te.right), Te;
              }
              function Di(_, W, Te) {
                return _.left !== W || _.right !== Te ? A2(si(W, Te), _) : _;
              }
              function wi(_) {
                var W = ue(162);
                return W.expression = y().parenthesizeExpressionOfComputedPropertyName(_), W.transformFlags |= oe(W.expression) | 1024 | 65536, W;
              }
              function Xi(_, W) {
                return _.expression !== W ? A2(wi(W), _) : _;
              }
              function et(_, W, Te, cr) {
                var ni, rt, yt;
                _ === void 0 || e2.isArray(_) ? (rt = _, ni = W, yt = Te) : (rt = void 0, ni = _, yt = W);
                var Xa = Fe(163, void 0, rt, ni);
                return Xa.constraint = yt, Xa.default = cr, Xa.transformFlags = 1, Xa;
              }
              function Gi(_, W, Te, cr, ni) {
                var rt, yt, Xa;
                return W === void 0 || e2.isArray(W) ? (yt = W, rt = Te, Xa = cr) : (yt = void 0, rt = W, Xa = Te), _.modifiers !== yt || _.name !== rt || _.constraint !== Xa || _.default !== ni ? A2(et(yt, rt, Xa, ni), _) : _;
              }
              function Wt(_, W, Te, cr, ni, rt, yt) {
                var Xa = Ie(164, _, W, cr, rt, yt && y().parenthesizeExpressionForDisallowedComma(yt));
                return Xa.dotDotDotToken = Te, Xa.questionToken = ni, e2.isThisIdentifier(Xa.name) ? Xa.transformFlags = 1 : (Xa.transformFlags |= oe(Xa.dotDotDotToken) | oe(Xa.questionToken), ni && (Xa.transformFlags |= 1), e2.modifiersToFlags(Xa.modifiers) & 16476 && (Xa.transformFlags |= 4096), (yt || Te) && (Xa.transformFlags |= 1024)), Xa;
              }
              function Zt(_, W, Te, cr, ni, rt, yt, Xa) {
                return _.decorators !== W || _.modifiers !== Te || _.dotDotDotToken !== cr || _.name !== ni || _.questionToken !== rt || _.type !== yt || _.initializer !== Xa ? A2(Wt(W, Te, cr, ni, rt, yt, Xa), _) : _;
              }
              function _r(_) {
                var W = ue(165);
                return W.expression = y().parenthesizeLeftSideOfAccess(_), W.transformFlags |= oe(W.expression) | 1 | 4096, W;
              }
              function pi(_, W) {
                return _.expression !== W ? A2(_r(W), _) : _;
              }
              function ae(_, W, Te, cr) {
                var ni = Fe(166, void 0, _, W);
                return ni.type = cr, ni.questionToken = Te, ni.transformFlags = 1, ni;
              }
              function Xe(_, W, Te, cr, ni) {
                return _.modifiers !== W || _.name !== Te || _.questionToken !== cr || _.type !== ni ? A2(ae(W, Te, cr, ni), _) : _;
              }
              function Jr(_, W, Te, cr, ni, rt) {
                var yt = Ie(167, _, W, Te, ni, rt);
                return yt.questionToken = cr && e2.isQuestionToken(cr) ? cr : void 0, yt.exclamationToken = cr && e2.isExclamationToken(cr) ? cr : void 0, yt.transformFlags |= oe(yt.questionToken) | oe(yt.exclamationToken) | 8388608, (e2.isComputedPropertyName(yt.name) || e2.hasStaticModifier(yt) && yt.initializer) && (yt.transformFlags |= 4096), (cr || e2.modifiersToFlags(yt.modifiers) & 2) && (yt.transformFlags |= 1), yt;
              }
              function ti(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.questionToken !== (ni !== void 0 && e2.isQuestionToken(ni) ? ni : void 0) || _.exclamationToken !== (ni !== void 0 && e2.isExclamationToken(ni) ? ni : void 0) || _.type !== rt || _.initializer !== yt ? A2(Jr(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Ze(_, W, Te, cr, ni, rt) {
                var yt = Be(168, void 0, _, W, cr, ni, rt);
                return yt.questionToken = Te, yt.transformFlags = 1, yt;
              }
              function Sr(_, W, Te, cr, ni, rt, yt) {
                return _.modifiers !== W || _.name !== Te || _.questionToken !== cr || _.typeParameters !== ni || _.parameters !== rt || _.type !== yt ? ge(Ze(W, Te, cr, ni, rt, yt), _) : _;
              }
              function zr(_, W, Te, cr, ni, rt, yt, Xa, vo) {
                var Vs = Re(169, _, W, cr, rt, yt, Xa, vo);
                return Vs.asteriskToken = Te, Vs.questionToken = ni, Vs.transformFlags |= oe(Vs.asteriskToken) | oe(Vs.questionToken) | 1024, ni && (Vs.transformFlags |= 1), e2.modifiersToFlags(Vs.modifiers) & 256 ? Te ? Vs.transformFlags |= 128 : Vs.transformFlags |= 256 : Te && (Vs.transformFlags |= 2048), Vs;
              }
              function Wr(_, W, Te, cr, ni, rt, yt, Xa, vo, Vs) {
                return _.decorators !== W || _.modifiers !== Te || _.asteriskToken !== cr || _.name !== ni || _.questionToken !== rt || _.typeParameters !== yt || _.parameters !== Xa || _.type !== vo || _.body !== Vs ? ze(zr(W, Te, cr, ni, rt, yt, Xa, vo, Vs), _) : _;
              }
              function Je(_, W, Te) {
                var cr = Z2(170, _, W, void 0, void 0);
                return cr.body = Te, cr.transformFlags = oe(Te) | 8388608, cr;
              }
              function xe(_, W, Te, cr) {
                return _.decorators !== W || _.modifier !== Te || _.body !== cr ? A2(Je(W, Te, cr), _) : _;
              }
              function vr(_, W, Te, cr) {
                var ni = Re(171, _, W, void 0, void 0, Te, void 0, cr);
                return ni.transformFlags |= 1024, ni;
              }
              function mr(_, W, Te, cr, ni) {
                return _.decorators !== W || _.modifiers !== Te || _.parameters !== cr || _.body !== ni ? ze(vr(W, Te, cr, ni), _) : _;
              }
              function Ar(_, W, Te, cr, ni, rt) {
                return Re(172, _, W, Te, void 0, cr, ni, rt);
              }
              function Oe(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.parameters !== ni || _.type !== rt || _.body !== yt ? ze(Ar(W, Te, cr, ni, rt, yt), _) : _;
              }
              function nr(_, W, Te, cr, ni) {
                return Re(173, _, W, Te, void 0, cr, void 0, ni);
              }
              function Mr(_, W, Te, cr, ni, rt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.parameters !== ni || _.body !== rt ? ze(nr(W, Te, cr, ni, rt), _) : _;
              }
              function Pe(_, W, Te) {
                var cr = Be(174, void 0, void 0, void 0, _, W, Te);
                return cr.transformFlags = 1, cr;
              }
              function Ue(_, W, Te, cr) {
                return _.typeParameters !== W || _.parameters !== Te || _.type !== cr ? ge(Pe(W, Te, cr), _) : _;
              }
              function fr(_, W, Te) {
                var cr = Be(175, void 0, void 0, void 0, _, W, Te);
                return cr.transformFlags = 1, cr;
              }
              function De(_, W, Te, cr) {
                return _.typeParameters !== W || _.parameters !== Te || _.type !== cr ? ge(fr(W, Te, cr), _) : _;
              }
              function gr(_, W, Te, cr) {
                var ni = Be(176, _, W, void 0, void 0, Te, cr);
                return ni.transformFlags = 1, ni;
              }
              function Vr(_, W, Te, cr, ni) {
                return _.parameters !== cr || _.type !== ni || _.decorators !== W || _.modifiers !== Te ? ge(gr(W, Te, cr, ni), _) : _;
              }
              function Tr(_, W) {
                var Te = ue(199);
                return Te.type = _, Te.literal = W, Te.transformFlags = 1, Te;
              }
              function vi(_, W, Te) {
                return _.type !== W || _.literal !== Te ? A2(Tr(W, Te), _) : _;
              }
              function Ui(_) {
                return Ir(_);
              }
              function Yi(_, W, Te) {
                var cr = ue(177);
                return cr.assertsModifier = _, cr.parameterName = Mc(W), cr.type = Te, cr.transformFlags = 1, cr;
              }
              function Wi(_, W, Te, cr) {
                return _.assertsModifier !== W || _.parameterName !== Te || _.type !== cr ? A2(Yi(W, Te, cr), _) : _;
              }
              function ct(_, W) {
                var Te = ue(178);
                return Te.typeName = Mc(_), Te.typeArguments = W && y().parenthesizeTypeArguments(ne(W)), Te.transformFlags = 1, Te;
              }
              function Li(_, W, Te) {
                return _.typeName !== W || _.typeArguments !== Te ? A2(ct(W, Te), _) : _;
              }
              function nt(_, W, Te) {
                var cr = Be(179, void 0, void 0, void 0, _, W, Te);
                return cr.transformFlags = 1, cr;
              }
              function Mt(_, W, Te, cr) {
                return _.typeParameters !== W || _.parameters !== Te || _.type !== cr ? ge(nt(W, Te, cr), _) : _;
              }
              function xt() {
                for (var _ = [], W = 0; W < arguments.length; W++)
                  _[W] = arguments[W];
                return _.length === 4 ? ut.apply(void 0, _) : _.length === 3 ? Dt.apply(void 0, _) : e2.Debug.fail("Incorrect number of arguments specified.");
              }
              function ut(_, W, Te, cr) {
                var ni = Be(180, void 0, _, void 0, W, Te, cr);
                return ni.transformFlags = 1, ni;
              }
              function Dt(_, W, Te) {
                return ut(void 0, _, W, Te);
              }
              function Rt() {
                for (var _ = [], W = 0; W < arguments.length; W++)
                  _[W] = arguments[W];
                return _.length === 5 ? Ii.apply(void 0, _) : _.length === 4 ? Ki.apply(void 0, _) : e2.Debug.fail("Incorrect number of arguments specified.");
              }
              function Ii(_, W, Te, cr, ni) {
                return _.modifiers !== W || _.typeParameters !== Te || _.parameters !== cr || _.type !== ni ? ge(xt(W, Te, cr, ni), _) : _;
              }
              function Ki(_, W, Te, cr) {
                return Ii(_, _.modifiers, W, Te, cr);
              }
              function Fi(_, W) {
                var Te = ue(181);
                return Te.exprName = _, Te.typeArguments = W && y().parenthesizeTypeArguments(W), Te.transformFlags = 1, Te;
              }
              function ui(_, W, Te) {
                return _.exprName !== W || _.typeArguments !== Te ? A2(Fi(W, Te), _) : _;
              }
              function Bt(_) {
                var W = ue(182);
                return W.members = ne(_), W.transformFlags = 1, W;
              }
              function wt(_, W) {
                return _.members !== W ? A2(Bt(W), _) : _;
              }
              function na(_) {
                var W = ue(183);
                return W.elementType = y().parenthesizeNonArrayTypeOfPostfixType(_), W.transformFlags = 1, W;
              }
              function Ai(_, W) {
                return _.elementType !== W ? A2(na(W), _) : _;
              }
              function Oi(_) {
                var W = ue(184);
                return W.elements = ne(y().parenthesizeElementTypesOfTupleType(_)), W.transformFlags = 1, W;
              }
              function ji(_, W) {
                return _.elements !== W ? A2(Oi(W), _) : _;
              }
              function Vi(_, W, Te, cr) {
                var ni = ue(197);
                return ni.dotDotDotToken = _, ni.name = W, ni.questionToken = Te, ni.type = cr, ni.transformFlags = 1, ni;
              }
              function at(_, W, Te, cr, ni) {
                return _.dotDotDotToken !== W || _.name !== Te || _.questionToken !== cr || _.type !== ni ? A2(Vi(W, Te, cr, ni), _) : _;
              }
              function At(_) {
                var W = ue(185);
                return W.type = y().parenthesizeTypeOfOptionalType(_), W.transformFlags = 1, W;
              }
              function ba(_, W) {
                return _.type !== W ? A2(At(W), _) : _;
              }
              function $a(_) {
                var W = ue(186);
                return W.type = _, W.transformFlags = 1, W;
              }
              function Qa(_, W) {
                return _.type !== W ? A2($a(W), _) : _;
              }
              function ai(_, W, Te) {
                var cr = ue(_);
                return cr.types = g.createNodeArray(Te(W)), cr.transformFlags = 1, cr;
              }
              function Dn(_, W, Te) {
                return _.types !== W ? A2(ai(_.kind, W, Te), _) : _;
              }
              function ka(_) {
                return ai(187, _, y().parenthesizeConstituentTypesOfUnionType);
              }
              function Ba(_, W) {
                return Dn(_, W, y().parenthesizeConstituentTypesOfUnionType);
              }
              function pn(_) {
                return ai(188, _, y().parenthesizeConstituentTypesOfIntersectionType);
              }
              function Cn(_, W) {
                return Dn(_, W, y().parenthesizeConstituentTypesOfIntersectionType);
              }
              function Bi(_, W, Te, cr) {
                var ni = ue(189);
                return ni.checkType = y().parenthesizeCheckTypeOfConditionalType(_), ni.extendsType = y().parenthesizeExtendsTypeOfConditionalType(W), ni.trueType = Te, ni.falseType = cr, ni.transformFlags = 1, ni;
              }
              function kn(_, W, Te, cr, ni) {
                return _.checkType !== W || _.extendsType !== Te || _.trueType !== cr || _.falseType !== ni ? A2(Bi(W, Te, cr, ni), _) : _;
              }
              function xn(_) {
                var W = ue(190);
                return W.typeParameter = _, W.transformFlags = 1, W;
              }
              function Kn(_, W) {
                return _.typeParameter !== W ? A2(xn(W), _) : _;
              }
              function Pn(_, W) {
                var Te = ue(198);
                return Te.head = _, Te.templateSpans = ne(W), Te.transformFlags = 1, Te;
              }
              function eo(_, W, Te) {
                return _.head !== W || _.templateSpans !== Te ? A2(Pn(W, Te), _) : _;
              }
              function Rn(_, W, Te, cr, ni) {
                var rt = W && W.kind === 295 ? W : void 0, yt = W && e2.isEntityName(W) ? W : Te && !e2.isArray(Te) ? Te : void 0, Xa = e2.isArray(Te) ? Te : e2.isArray(cr) ? cr : void 0;
                ni = typeof cr == "boolean" ? cr : typeof ni == "boolean" ? ni : false;
                var vo = ue(200);
                return vo.argument = _, vo.assertions = rt, vo.qualifier = yt, vo.typeArguments = Xa && y().parenthesizeTypeArguments(Xa), vo.isTypeOf = ni, vo.transformFlags = 1, vo;
              }
              function Da(_, W, Te, cr, ni, rt) {
                var yt = Te && Te.kind === 295 ? Te : void 0, Xa = Te && e2.isEntityName(Te) ? Te : cr && !e2.isArray(cr) ? cr : void 0, vo = e2.isArray(cr) ? cr : e2.isArray(ni) ? ni : void 0;
                return rt = typeof ni == "boolean" ? ni : typeof rt == "boolean" ? rt : _.isTypeOf, _.argument !== W || _.assertions !== yt || _.qualifier !== Xa || _.typeArguments !== vo || _.isTypeOf !== rt ? A2(Rn(W, yt, Xa, vo, rt), _) : _;
              }
              function bo(_) {
                var W = ue(191);
                return W.type = _, W.transformFlags = 1, W;
              }
              function Ro(_, W) {
                return _.type !== W ? A2(bo(W), _) : _;
              }
              function En() {
                var _ = ue(192);
                return _.transformFlags = 1, _;
              }
              function Wn(_, W) {
                var Te = ue(193);
                return Te.operator = _, Te.type = _ === 145 ? y().parenthesizeOperandOfReadonlyTypeOperator(W) : y().parenthesizeOperandOfTypeOperator(W), Te.transformFlags = 1, Te;
              }
              function to(_, W) {
                return _.type !== W ? A2(Wn(_.operator, W), _) : _;
              }
              function Co(_, W) {
                var Te = ue(194);
                return Te.objectType = y().parenthesizeNonArrayTypeOfPostfixType(_), Te.indexType = W, Te.transformFlags = 1, Te;
              }
              function Ko(_, W, Te) {
                return _.objectType !== W || _.indexType !== Te ? A2(Co(W, Te), _) : _;
              }
              function Oo(_, W, Te, cr, ni, rt) {
                var yt = ue(195);
                return yt.readonlyToken = _, yt.typeParameter = W, yt.nameType = Te, yt.questionToken = cr, yt.type = ni, yt.members = rt && ne(rt), yt.transformFlags = 1, yt;
              }
              function no(_, W, Te, cr, ni, rt, yt) {
                return _.readonlyToken !== W || _.typeParameter !== Te || _.nameType !== cr || _.questionToken !== ni || _.type !== rt || _.members !== yt ? A2(Oo(W, Te, cr, ni, rt, yt), _) : _;
              }
              function $o(_) {
                var W = ue(196);
                return W.literal = _, W.transformFlags = 1, W;
              }
              function Pr(_, W) {
                return _.literal !== W ? A2($o(W), _) : _;
              }
              function xi(_) {
                var W = ue(201);
                return W.elements = ne(_), W.transformFlags |= f4(W.elements) | 1024 | 262144, W.transformFlags & 16384 && (W.transformFlags |= 32896), W;
              }
              function St(_, W) {
                return _.elements !== W ? A2(xi(W), _) : _;
              }
              function pa(_) {
                var W = ue(202);
                return W.elements = ne(_), W.transformFlags |= f4(W.elements) | 1024 | 262144, W;
              }
              function dn(_, W) {
                return _.elements !== W ? A2(pa(W), _) : _;
              }
              function Jn(_, W, Te, cr) {
                var ni = rr(203, void 0, void 0, Te, cr && y().parenthesizeExpressionForDisallowedComma(cr));
                return ni.propertyName = Mc(W), ni.dotDotDotToken = _, ni.transformFlags |= oe(ni.dotDotDotToken) | 1024, ni.propertyName && (ni.transformFlags |= e2.isIdentifier(ni.propertyName) ? m2(ni.propertyName) : oe(ni.propertyName)), _ && (ni.transformFlags |= 16384), ni;
              }
              function Qe(_, W, Te, cr, ni) {
                return _.propertyName !== Te || _.dotDotDotToken !== W || _.name !== cr || _.initializer !== ni ? A2(Jn(W, Te, cr, ni), _) : _;
              }
              function Gr(_) {
                var W = ue(_);
                return W;
              }
              function S2(_, W) {
                var Te = Gr(204), cr = _ && e2.lastOrUndefined(_), ni = ne(_, cr && e2.isOmittedExpression(cr) ? true : void 0);
                return Te.elements = y().parenthesizeExpressionsOfCommaDelimitedList(ni), Te.multiLine = W, Te.transformFlags |= f4(Te.elements), Te;
              }
              function Ce(_, W) {
                return _.elements !== W ? A2(S2(W, _.multiLine), _) : _;
              }
              function qe(_, W) {
                var Te = Gr(205);
                return Te.properties = ne(_), Te.multiLine = W, Te.transformFlags |= f4(Te.properties), Te;
              }
              function br(_, W) {
                return _.properties !== W ? A2(qe(W, _.multiLine), _) : _;
              }
              function Zr(_, W) {
                var Te = Gr(206);
                return Te.expression = y().parenthesizeLeftSideOfAccess(_), Te.name = Mc(W), Te.transformFlags = oe(Te.expression) | (e2.isIdentifier(Te.name) ? m2(Te.name) : oe(Te.name)), e2.isSuperKeyword(_) && (Te.transformFlags |= 384), Te;
              }
              function Si(_, W, Te) {
                return e2.isPropertyAccessChain(_) ? Qi(_, W, _.questionDotToken, e2.cast(Te, e2.isIdentifier)) : _.expression !== W || _.name !== Te ? A2(Zr(W, Te), _) : _;
              }
              function Pi(_, W, Te) {
                var cr = Gr(206);
                return cr.flags |= 32, cr.expression = y().parenthesizeLeftSideOfAccess(_), cr.questionDotToken = W, cr.name = Mc(Te), cr.transformFlags |= 32 | oe(cr.expression) | oe(cr.questionDotToken) | (e2.isIdentifier(cr.name) ? m2(cr.name) : oe(cr.name)), cr;
              }
              function Qi(_, W, Te, cr) {
                return e2.Debug.assert(!!(_.flags & 32), "Cannot update a PropertyAccessExpression using updatePropertyAccessChain. Use updatePropertyAccess instead."), _.expression !== W || _.questionDotToken !== Te || _.name !== cr ? A2(Pi(W, Te, cr), _) : _;
              }
              function Ct(_, W) {
                var Te = Gr(207);
                return Te.expression = y().parenthesizeLeftSideOfAccess(_), Te.argumentExpression = Yu(W), Te.transformFlags |= oe(Te.expression) | oe(Te.argumentExpression), e2.isSuperKeyword(_) && (Te.transformFlags |= 384), Te;
              }
              function sa(_, W, Te) {
                return e2.isElementAccessChain(_) ? Wa(_, W, _.questionDotToken, Te) : _.expression !== W || _.argumentExpression !== Te ? A2(Ct(W, Te), _) : _;
              }
              function en(_, W, Te) {
                var cr = Gr(207);
                return cr.flags |= 32, cr.expression = y().parenthesizeLeftSideOfAccess(_), cr.questionDotToken = W, cr.argumentExpression = Yu(Te), cr.transformFlags |= oe(cr.expression) | oe(cr.questionDotToken) | oe(cr.argumentExpression) | 32, cr;
              }
              function Wa(_, W, Te, cr) {
                return e2.Debug.assert(!!(_.flags & 32), "Cannot update a ElementAccessExpression using updateElementAccessChain. Use updateElementAccess instead."), _.expression !== W || _.questionDotToken !== Te || _.argumentExpression !== cr ? A2(en(W, Te, cr), _) : _;
              }
              function qn(_, W, Te) {
                var cr = Gr(208);
                return cr.expression = y().parenthesizeLeftSideOfAccess(_), cr.typeArguments = bc(W), cr.arguments = y().parenthesizeExpressionsOfCommaDelimitedList(ne(Te)), cr.transformFlags |= oe(cr.expression) | f4(cr.typeArguments) | f4(cr.arguments), cr.typeArguments && (cr.transformFlags |= 1), e2.isImportKeyword(cr.expression) ? cr.transformFlags |= 4194304 : e2.isSuperProperty(cr.expression) && (cr.transformFlags |= 8192), cr;
              }
              function mo(_, W, Te, cr) {
                return e2.isCallChain(_) ? Go(_, W, _.questionDotToken, Te, cr) : _.expression !== W || _.typeArguments !== Te || _.arguments !== cr ? A2(qn(W, Te, cr), _) : _;
              }
              function So(_, W, Te, cr) {
                var ni = Gr(208);
                return ni.flags |= 32, ni.expression = y().parenthesizeLeftSideOfAccess(_), ni.questionDotToken = W, ni.typeArguments = bc(Te), ni.arguments = y().parenthesizeExpressionsOfCommaDelimitedList(ne(cr)), ni.transformFlags |= oe(ni.expression) | oe(ni.questionDotToken) | f4(ni.typeArguments) | f4(ni.arguments) | 32, ni.typeArguments && (ni.transformFlags |= 1), e2.isSuperProperty(ni.expression) && (ni.transformFlags |= 8192), ni;
              }
              function Go(_, W, Te, cr, ni) {
                return e2.Debug.assert(!!(_.flags & 32), "Cannot update a CallExpression using updateCallChain. Use updateCall instead."), _.expression !== W || _.questionDotToken !== Te || _.typeArguments !== cr || _.arguments !== ni ? A2(So(W, Te, cr, ni), _) : _;
              }
              function ys(_, W, Te) {
                var cr = Gr(209);
                return cr.expression = y().parenthesizeExpressionOfNew(_), cr.typeArguments = bc(W), cr.arguments = Te ? y().parenthesizeExpressionsOfCommaDelimitedList(Te) : void 0, cr.transformFlags |= oe(cr.expression) | f4(cr.typeArguments) | f4(cr.arguments) | 32, cr.typeArguments && (cr.transformFlags |= 1), cr;
              }
              function Pc(_, W, Te, cr) {
                return _.expression !== W || _.typeArguments !== Te || _.arguments !== cr ? A2(ys(W, Te, cr), _) : _;
              }
              function Vc(_, W, Te) {
                var cr = Gr(210);
                return cr.tag = y().parenthesizeLeftSideOfAccess(_), cr.typeArguments = bc(W), cr.template = Te, cr.transformFlags |= oe(cr.tag) | f4(cr.typeArguments) | oe(cr.template) | 1024, cr.typeArguments && (cr.transformFlags |= 1), e2.hasInvalidEscape(cr.template) && (cr.transformFlags |= 128), cr;
              }
              function Kc(_, W, Te, cr) {
                return _.tag !== W || _.typeArguments !== Te || _.template !== cr ? A2(Vc(W, Te, cr), _) : _;
              }
              function Xs(_, W) {
                var Te = Gr(211);
                return Te.expression = y().parenthesizeOperandOfPrefixUnary(W), Te.type = _, Te.transformFlags |= oe(Te.expression) | oe(Te.type) | 1, Te;
              }
              function pc(_, W, Te) {
                return _.type !== W || _.expression !== Te ? A2(Xs(W, Te), _) : _;
              }
              function hs(_) {
                var W = Gr(212);
                return W.expression = _, W.transformFlags = oe(W.expression), W;
              }
              function tc(_, W) {
                return _.expression !== W ? A2(hs(W), _) : _;
              }
              function ps(_, W, Te, cr, ni, rt, yt) {
                var Xa = Re(213, void 0, _, Te, cr, ni, rt, yt);
                return Xa.asteriskToken = W, Xa.transformFlags |= oe(Xa.asteriskToken), Xa.typeParameters && (Xa.transformFlags |= 1), e2.modifiersToFlags(Xa.modifiers) & 256 ? Xa.asteriskToken ? Xa.transformFlags |= 128 : Xa.transformFlags |= 256 : Xa.asteriskToken && (Xa.transformFlags |= 2048), Xa;
              }
              function Qs(_, W, Te, cr, ni, rt, yt, Xa) {
                return _.name !== cr || _.modifiers !== W || _.asteriskToken !== Te || _.typeParameters !== ni || _.parameters !== rt || _.type !== yt || _.body !== Xa ? ze(ps(W, Te, cr, ni, rt, yt, Xa), _) : _;
              }
              function js(_, W, Te, cr, ni, rt) {
                var yt = Re(214, void 0, _, void 0, W, Te, cr, y().parenthesizeConciseBodyOfArrowFunction(rt));
                return yt.equalsGreaterThanToken = ni != null ? ni : Ir(38), yt.transformFlags |= oe(yt.equalsGreaterThanToken) | 1024, e2.modifiersToFlags(yt.modifiers) & 256 && (yt.transformFlags |= 8448), yt;
              }
              function ds(_, W, Te, cr, ni, rt, yt) {
                return _.modifiers !== W || _.typeParameters !== Te || _.parameters !== cr || _.type !== ni || _.equalsGreaterThanToken !== rt || _.body !== yt ? ze(js(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Ji(_) {
                var W = Gr(215);
                return W.expression = y().parenthesizeOperandOfPrefixUnary(_), W.transformFlags |= oe(W.expression), W;
              }
              function ce(_, W) {
                return _.expression !== W ? A2(Ji(W), _) : _;
              }
              function Rr(_) {
                var W = Gr(216);
                return W.expression = y().parenthesizeOperandOfPrefixUnary(_), W.transformFlags |= oe(W.expression), W;
              }
              function yi(_, W) {
                return _.expression !== W ? A2(Rr(W), _) : _;
              }
              function qi(_) {
                var W = Gr(217);
                return W.expression = y().parenthesizeOperandOfPrefixUnary(_), W.transformFlags |= oe(W.expression), W;
              }
              function je(_, W) {
                return _.expression !== W ? A2(qi(W), _) : _;
              }
              function Hr(_) {
                var W = Gr(218);
                return W.expression = y().parenthesizeOperandOfPrefixUnary(_), W.transformFlags |= oe(W.expression) | 256 | 128 | 1048576, W;
              }
              function pt(_, W) {
                return _.expression !== W ? A2(Hr(W), _) : _;
              }
              function Pt(_, W) {
                var Te = Gr(219);
                return Te.operator = _, Te.operand = y().parenthesizeOperandOfPrefixUnary(W), Te.transformFlags |= oe(Te.operand), (_ === 45 || _ === 46) && e2.isIdentifier(Te.operand) && !e2.isGeneratedIdentifier(Te.operand) && !e2.isLocalName(Te.operand) && (Te.transformFlags |= 67108864), Te;
              }
              function ga(_, W) {
                return _.operand !== W ? A2(Pt(_.operator, W), _) : _;
              }
              function ua(_, W) {
                var Te = Gr(220);
                return Te.operator = W, Te.operand = y().parenthesizeOperandOfPostfixUnary(_), Te.transformFlags |= oe(Te.operand), e2.isIdentifier(Te.operand) && !e2.isGeneratedIdentifier(Te.operand) && !e2.isLocalName(Te.operand) && (Te.transformFlags |= 67108864), Te;
              }
              function Xn(_, W) {
                return _.operand !== W ? A2(ua(W, _.operator), _) : _;
              }
              function jr(_, W, Te) {
                var cr = Gr(221), ni = Rl(W), rt = ni.kind;
                return cr.left = y().parenthesizeLeftSideOfBinary(rt, _), cr.operatorToken = ni, cr.right = y().parenthesizeRightSideOfBinary(rt, cr.left, Te), cr.transformFlags |= oe(cr.left) | oe(cr.operatorToken) | oe(cr.right), rt === 60 ? cr.transformFlags |= 32 : rt === 63 ? e2.isObjectLiteralExpression(cr.left) ? cr.transformFlags |= 5248 | fo(cr.left) : e2.isArrayLiteralExpression(cr.left) && (cr.transformFlags |= 5120 | fo(cr.left)) : rt === 42 || rt === 67 ? cr.transformFlags |= 512 : e2.isLogicalOrCoalescingAssignmentOperator(rt) && (cr.transformFlags |= 16), cr;
              }
              function fo(_) {
                if (_.transformFlags & 32768)
                  return 32768;
                if (_.transformFlags & 128)
                  for (var W = 0, Te = e2.getElementsOfBindingOrAssignmentPattern(_); W < Te.length; W++) {
                    var cr = Te[W], ni = e2.getTargetOfBindingOrAssignmentElement(cr);
                    if (ni && e2.isAssignmentPattern(ni)) {
                      if (ni.transformFlags & 32768)
                        return 32768;
                      if (ni.transformFlags & 128) {
                        var rt = fo(ni);
                        if (rt)
                          return rt;
                      }
                    }
                  }
                return 0;
              }
              function xs(_, W, Te, cr) {
                return _.left !== W || _.operatorToken !== Te || _.right !== cr ? A2(jr(W, Te, cr), _) : _;
              }
              function Fo(_, W, Te, cr, ni) {
                var rt = Gr(222);
                return rt.condition = y().parenthesizeConditionOfConditionalExpression(_), rt.questionToken = W != null ? W : Ir(57), rt.whenTrue = y().parenthesizeBranchOfConditionalExpression(Te), rt.colonToken = cr != null ? cr : Ir(58), rt.whenFalse = y().parenthesizeBranchOfConditionalExpression(ni), rt.transformFlags |= oe(rt.condition) | oe(rt.questionToken) | oe(rt.whenTrue) | oe(rt.colonToken) | oe(rt.whenFalse), rt;
              }
              function ko(_, W, Te, cr, ni, rt) {
                return _.condition !== W || _.questionToken !== Te || _.whenTrue !== cr || _.colonToken !== ni || _.whenFalse !== rt ? A2(Fo(W, Te, cr, ni, rt), _) : _;
              }
              function Ao(_, W) {
                var Te = Gr(223);
                return Te.head = _, Te.templateSpans = ne(W), Te.transformFlags |= oe(Te.head) | f4(Te.templateSpans) | 1024, Te;
              }
              function Ms(_, W, Te) {
                return _.head !== W || _.templateSpans !== Te ? A2(Ao(W, Te), _) : _;
              }
              function Bs(_, W, Te, cr) {
                cr === void 0 && (cr = 0), e2.Debug.assert(!(cr & -2049), "Unsupported template flags.");
                var ni = void 0;
                if (Te !== void 0 && Te !== W && (ni = p(_, Te), typeof ni == "object"))
                  return e2.Debug.fail("Invalid raw text");
                if (W === void 0) {
                  if (ni === void 0)
                    return e2.Debug.fail("Arguments 'text' and 'rawText' may not both be undefined.");
                  W = ni;
                } else
                  ni !== void 0 && e2.Debug.assert(W === ni, "Expected argument 'text' to be the normalized (i.e. 'cooked') version of argument 'rawText'.");
                return xc(_, W, Te, cr);
              }
              function xc(_, W, Te, cr) {
                var ni = yr(_);
                return ni.text = W, ni.rawText = Te, ni.templateFlags = cr & 2048, ni.transformFlags |= 1024, ni.templateFlags && (ni.transformFlags |= 128), ni;
              }
              function su(_, W, Te) {
                return Bs(15, _, W, Te);
              }
              function tl(_, W, Te) {
                return Bs(16, _, W, Te);
              }
              function Zc(_, W, Te) {
                return Bs(17, _, W, Te);
              }
              function Rf(_, W, Te) {
                return Bs(14, _, W, Te);
              }
              function al(_, W) {
                e2.Debug.assert(!_ || !!W, "A `YieldExpression` with an asteriskToken must have an expression.");
                var Te = Gr(224);
                return Te.expression = W && y().parenthesizeExpressionForDisallowedComma(W), Te.asteriskToken = _, Te.transformFlags |= oe(Te.expression) | oe(Te.asteriskToken) | 1024 | 128 | 524288, Te;
              }
              function Jo(_, W, Te) {
                return _.expression !== Te || _.asteriskToken !== W ? A2(al(W, Te), _) : _;
              }
              function eu(_) {
                var W = Gr(225);
                return W.expression = y().parenthesizeExpressionForDisallowedComma(_), W.transformFlags |= oe(W.expression) | 1024 | 16384, W;
              }
              function Ws(_, W) {
                return _.expression !== W ? A2(eu(W), _) : _;
              }
              function pu(_, W, Te, cr, ni, rt) {
                var yt = He(226, _, W, Te, cr, ni, rt);
                return yt.transformFlags |= 1024, yt;
              }
              function Uu(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.typeParameters !== ni || _.heritageClauses !== rt || _.members !== yt ? A2(pu(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Ql() {
                return Gr(227);
              }
              function xl(_, W) {
                var Te = ue(228);
                return Te.expression = y().parenthesizeLeftSideOfAccess(_), Te.typeArguments = W && y().parenthesizeTypeArguments(W), Te.transformFlags |= oe(Te.expression) | f4(Te.typeArguments) | 1024, Te;
              }
              function Ya(_, W, Te) {
                return _.expression !== W || _.typeArguments !== Te ? A2(xl(W, Te), _) : _;
              }
              function du(_, W) {
                var Te = Gr(229);
                return Te.expression = _, Te.type = W, Te.transformFlags |= oe(Te.expression) | oe(Te.type) | 1, Te;
              }
              function vc(_, W, Te) {
                return _.expression !== W || _.type !== Te ? A2(du(W, Te), _) : _;
              }
              function Kr(_) {
                var W = Gr(230);
                return W.expression = y().parenthesizeLeftSideOfAccess(_), W.transformFlags |= oe(W.expression) | 1, W;
              }
              function _i(_, W) {
                return e2.isNonNullChain(_) ? tt(_, W) : _.expression !== W ? A2(Kr(W), _) : _;
              }
              function Ei(_) {
                var W = Gr(230);
                return W.flags |= 32, W.expression = y().parenthesizeLeftSideOfAccess(_), W.transformFlags |= oe(W.expression) | 1, W;
              }
              function tt(_, W) {
                return e2.Debug.assert(!!(_.flags & 32), "Cannot update a NonNullExpression using updateNonNullChain. Use updateNonNullExpression instead."), _.expression !== W ? A2(Ei(W), _) : _;
              }
              function kt(_, W) {
                var Te = Gr(231);
                switch (Te.keywordToken = _, Te.name = W, Te.transformFlags |= oe(Te.name), _) {
                  case 103:
                    Te.transformFlags |= 1024;
                    break;
                  case 100:
                    Te.transformFlags |= 4;
                    break;
                  default:
                    return e2.Debug.assertNever(_);
                }
                return Te;
              }
              function bt(_, W) {
                return _.name !== W ? A2(kt(_.keywordToken, W), _) : _;
              }
              function ia(_, W) {
                var Te = ue(233);
                return Te.expression = _, Te.literal = W, Te.transformFlags |= oe(Te.expression) | oe(Te.literal) | 1024, Te;
              }
              function Xt(_, W, Te) {
                return _.expression !== W || _.literal !== Te ? A2(ia(W, Te), _) : _;
              }
              function Za() {
                var _ = ue(234);
                return _.transformFlags |= 1024, _;
              }
              function bn(_, W) {
                var Te = ue(235);
                return Te.statements = ne(_), Te.multiLine = W, Te.transformFlags |= f4(Te.statements), Te;
              }
              function _a4(_, W) {
                return _.statements !== W ? A2(bn(W, _.multiLine), _) : _;
              }
              function qa(_, W) {
                var Te = We(237, void 0, _);
                return Te.declarationList = e2.isArray(W) ? Cl(W) : W, Te.transformFlags |= oe(Te.declarationList), e2.modifiersToFlags(Te.modifiers) & 2 && (Te.transformFlags = 1), Te;
              }
              function rn(_, W, Te) {
                return _.modifiers !== W || _.declarationList !== Te ? A2(qa(W, Te), _) : _;
              }
              function jn() {
                return ue(236);
              }
              function Mo(_) {
                var W = ue(238);
                return W.expression = y().parenthesizeExpressionOfExpressionStatement(_), W.transformFlags |= oe(W.expression), W;
              }
              function ho(_, W) {
                return _.expression !== W ? A2(Mo(W), _) : _;
              }
              function gs(_, W, Te) {
                var cr = ue(239);
                return cr.expression = _, cr.thenStatement = Lc(W), cr.elseStatement = Lc(Te), cr.transformFlags |= oe(cr.expression) | oe(cr.thenStatement) | oe(cr.elseStatement), cr;
              }
              function Se(_, W, Te, cr) {
                return _.expression !== W || _.thenStatement !== Te || _.elseStatement !== cr ? A2(gs(W, Te, cr), _) : _;
              }
              function hr(_, W) {
                var Te = ue(240);
                return Te.statement = Lc(_), Te.expression = W, Te.transformFlags |= oe(Te.statement) | oe(Te.expression), Te;
              }
              function Or(_, W, Te) {
                return _.statement !== W || _.expression !== Te ? A2(hr(W, Te), _) : _;
              }
              function ki(_, W) {
                var Te = ue(241);
                return Te.expression = _, Te.statement = Lc(W), Te.transformFlags |= oe(Te.expression) | oe(Te.statement), Te;
              }
              function dt(_, W, Te) {
                return _.expression !== W || _.statement !== Te ? A2(ki(W, Te), _) : _;
              }
              function la(_, W, Te, cr) {
                var ni = ue(242);
                return ni.initializer = _, ni.condition = W, ni.incrementor = Te, ni.statement = Lc(cr), ni.transformFlags |= oe(ni.initializer) | oe(ni.condition) | oe(ni.incrementor) | oe(ni.statement), ni;
              }
              function wa(_, W, Te, cr, ni) {
                return _.initializer !== W || _.condition !== Te || _.incrementor !== cr || _.statement !== ni ? A2(la(W, Te, cr, ni), _) : _;
              }
              function On(_, W, Te) {
                var cr = ue(243);
                return cr.initializer = _, cr.expression = W, cr.statement = Lc(Te), cr.transformFlags |= oe(cr.initializer) | oe(cr.expression) | oe(cr.statement), cr;
              }
              function No(_, W, Te, cr) {
                return _.initializer !== W || _.expression !== Te || _.statement !== cr ? A2(On(W, Te, cr), _) : _;
              }
              function jo(_, W, Te, cr) {
                var ni = ue(244);
                return ni.awaitModifier = _, ni.initializer = W, ni.expression = y().parenthesizeExpressionForDisallowedComma(Te), ni.statement = Lc(cr), ni.transformFlags |= oe(ni.awaitModifier) | oe(ni.initializer) | oe(ni.expression) | oe(ni.statement) | 1024, _ && (ni.transformFlags |= 128), ni;
              }
              function po(_, W, Te, cr, ni) {
                return _.awaitModifier !== W || _.initializer !== Te || _.expression !== cr || _.statement !== ni ? A2(jo(W, Te, cr, ni), _) : _;
              }
              function Gn(_) {
                var W = ue(245);
                return W.label = Mc(_), W.transformFlags |= oe(W.label) | 2097152, W;
              }
              function $n(_, W) {
                return _.label !== W ? A2(Gn(W), _) : _;
              }
              function Ho(_) {
                var W = ue(246);
                return W.label = Mc(_), W.transformFlags |= oe(W.label) | 2097152, W;
              }
              function Zo(_, W) {
                return _.label !== W ? A2(Ho(W), _) : _;
              }
              function Es(_) {
                var W = ue(247);
                return W.expression = _, W.transformFlags |= oe(W.expression) | 128 | 2097152, W;
              }
              function yc(_, W) {
                return _.expression !== W ? A2(Es(W), _) : _;
              }
              function Xr(_, W) {
                var Te = ue(248);
                return Te.expression = _, Te.statement = Lc(W), Te.transformFlags |= oe(Te.expression) | oe(Te.statement), Te;
              }
              function Ls(_, W, Te) {
                return _.expression !== W || _.statement !== Te ? A2(Xr(W, Te), _) : _;
              }
              function Ic(_, W) {
                var Te = ue(249);
                return Te.expression = y().parenthesizeExpressionForDisallowedComma(_), Te.caseBlock = W, Te.transformFlags |= oe(Te.expression) | oe(Te.caseBlock), Te;
              }
              function zu(_, W, Te) {
                return _.expression !== W || _.caseBlock !== Te ? A2(Ic(W, Te), _) : _;
              }
              function vf(_, W) {
                var Te = ue(250);
                return Te.label = Mc(_), Te.statement = Lc(W), Te.transformFlags |= oe(Te.label) | oe(Te.statement), Te;
              }
              function P_(_, W, Te) {
                return _.label !== W || _.statement !== Te ? A2(vf(W, Te), _) : _;
              }
              function El(_) {
                var W = ue(251);
                return W.expression = _, W.transformFlags |= oe(W.expression), W;
              }
              function vp(_, W) {
                return _.expression !== W ? A2(El(W), _) : _;
              }
              function oo(_, W, Te) {
                var cr = ue(252);
                return cr.tryBlock = _, cr.catchClause = W, cr.finallyBlock = Te, cr.transformFlags |= oe(cr.tryBlock) | oe(cr.catchClause) | oe(cr.finallyBlock), cr;
              }
              function I_(_, W, Te, cr) {
                return _.tryBlock !== W || _.catchClause !== Te || _.finallyBlock !== cr ? A2(oo(W, Te, cr), _) : _;
              }
              function yp() {
                return ue(253);
              }
              function Yl(_, W, Te, cr) {
                var ni = Ie(254, void 0, void 0, _, Te, cr && y().parenthesizeExpressionForDisallowedComma(cr));
                return ni.exclamationToken = W, ni.transformFlags |= oe(ni.exclamationToken), W && (ni.transformFlags |= 1), ni;
              }
              function Bf(_, W, Te, cr, ni) {
                return _.name !== W || _.type !== cr || _.exclamationToken !== Te || _.initializer !== ni ? A2(Yl(W, Te, cr, ni), _) : _;
              }
              function Cl(_, W) {
                W === void 0 && (W = 0);
                var Te = ue(255);
                return Te.flags |= W & 3, Te.declarations = ne(_), Te.transformFlags |= f4(Te.declarations) | 2097152, W & 3 && (Te.transformFlags |= 132096), Te;
              }
              function c_(_, W) {
                return _.declarations !== W ? A2(Cl(W, _.flags), _) : _;
              }
              function hp(_, W, Te, cr, ni, rt, yt, Xa) {
                var vo = Re(256, _, W, cr, ni, rt, yt, Xa);
                return vo.asteriskToken = Te, !vo.body || e2.modifiersToFlags(vo.modifiers) & 2 ? vo.transformFlags = 1 : (vo.transformFlags |= oe(vo.asteriskToken) | 2097152, e2.modifiersToFlags(vo.modifiers) & 256 ? vo.asteriskToken ? vo.transformFlags |= 128 : vo.transformFlags |= 256 : vo.asteriskToken && (vo.transformFlags |= 2048)), vo;
              }
              function gu(_, W, Te, cr, ni, rt, yt, Xa, vo) {
                return _.decorators !== W || _.modifiers !== Te || _.asteriskToken !== cr || _.name !== ni || _.typeParameters !== rt || _.parameters !== yt || _.type !== Xa || _.body !== vo ? ze(hp(W, Te, cr, ni, rt, yt, Xa, vo), _) : _;
              }
              function Dp(_, W, Te, cr, ni, rt) {
                var yt = He(257, _, W, Te, cr, ni, rt);
                return e2.modifiersToFlags(yt.modifiers) & 2 ? yt.transformFlags = 1 : (yt.transformFlags |= 1024, yt.transformFlags & 4096 && (yt.transformFlags |= 1)), yt;
              }
              function sd(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.typeParameters !== ni || _.heritageClauses !== rt || _.members !== yt ? A2(Dp(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Aa(_, W, Te, cr, ni, rt) {
                var yt = Ee(258, _, W, Te, cr, ni);
                return yt.members = ne(rt), yt.transformFlags = 1, yt;
              }
              function va(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.typeParameters !== ni || _.heritageClauses !== rt || _.members !== yt ? A2(Aa(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Cu(_, W, Te, cr, ni) {
                var rt = Z2(259, _, W, Te, cr);
                return rt.type = ni, rt.transformFlags = 1, rt;
              }
              function qs(_, W, Te, cr, ni, rt) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.typeParameters !== ni || _.type !== rt ? A2(Cu(W, Te, cr, ni, rt), _) : _;
              }
              function cd(_, W, Te, cr) {
                var ni = Fe(260, _, W, Te);
                return ni.members = ne(cr), ni.transformFlags |= f4(ni.members) | 1, ni.transformFlags &= -16777217, ni;
              }
              function ns(_, W, Te, cr, ni) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.members !== ni ? A2(cd(W, Te, cr, ni), _) : _;
              }
              function nl(_, W, Te, cr, ni) {
                ni === void 0 && (ni = 0);
                var rt = We(261, _, W);
                return rt.flags |= ni & 1044, rt.name = Te, rt.body = cr, e2.modifiersToFlags(rt.modifiers) & 2 ? rt.transformFlags = 1 : rt.transformFlags |= oe(rt.name) | oe(rt.body) | 1, rt.transformFlags &= -16777217, rt;
              }
              function hc(_, W, Te, cr, ni) {
                return _.decorators !== W || _.modifiers !== Te || _.name !== cr || _.body !== ni ? A2(nl(W, Te, cr, ni, _.flags), _) : _;
              }
              function es(_) {
                var W = ue(262);
                return W.statements = ne(_), W.transformFlags |= f4(W.statements), W;
              }
              function u_(_, W) {
                return _.statements !== W ? A2(es(W), _) : _;
              }
              function Jf(_) {
                var W = ue(263);
                return W.clauses = ne(_), W.transformFlags |= f4(W.clauses), W;
              }
              function w_(_, W) {
                return _.clauses !== W ? A2(Jf(W), _) : _;
              }
              function ud(_) {
                var W = Fe(264, void 0, void 0, _);
                return W.transformFlags = 1, W;
              }
              function ku(_, W) {
                return _.name !== W ? A2(ud(W), _) : _;
              }
              function ld(_, W, Te, cr, ni) {
                var rt = Fe(265, _, W, cr);
                return rt.isTypeOnly = Te, rt.moduleReference = ni, rt.transformFlags |= oe(rt.moduleReference), e2.isExternalModuleReference(rt.moduleReference) || (rt.transformFlags |= 1), rt.transformFlags &= -16777217, rt;
              }
              function fd(_, W, Te, cr, ni, rt) {
                return _.decorators !== W || _.modifiers !== Te || _.isTypeOnly !== cr || _.name !== ni || _.moduleReference !== rt ? A2(ld(W, Te, cr, ni, rt), _) : _;
              }
              function bp(_, W, Te, cr, ni) {
                var rt = We(266, _, W);
                return rt.importClause = Te, rt.moduleSpecifier = cr, rt.assertClause = ni, rt.transformFlags |= oe(rt.importClause) | oe(rt.moduleSpecifier), rt.transformFlags &= -16777217, rt;
              }
              function Sp(_, W, Te, cr, ni, rt) {
                return _.decorators !== W || _.modifiers !== Te || _.importClause !== cr || _.moduleSpecifier !== ni || _.assertClause !== rt ? A2(bp(W, Te, cr, ni, rt), _) : _;
              }
              function Tp(_, W, Te) {
                var cr = ue(267);
                return cr.isTypeOnly = _, cr.name = W, cr.namedBindings = Te, cr.transformFlags |= oe(cr.name) | oe(cr.namedBindings), _ && (cr.transformFlags |= 1), cr.transformFlags &= -16777217, cr;
              }
              function _d2(_, W, Te, cr) {
                return _.isTypeOnly !== W || _.name !== Te || _.namedBindings !== cr ? A2(Tp(W, Te, cr), _) : _;
              }
              function jf(_, W) {
                var Te = ue(293);
                return Te.elements = ne(_), Te.multiLine = W, Te.transformFlags |= 4, Te;
              }
              function O_(_, W, Te) {
                return _.elements !== W || _.multiLine !== Te ? A2(jf(W, Te), _) : _;
              }
              function F_(_, W) {
                var Te = ue(294);
                return Te.name = _, Te.value = W, Te.transformFlags |= 4, Te;
              }
              function pd(_, W, Te) {
                return _.name !== W || _.value !== Te ? A2(F_(W, Te), _) : _;
              }
              function xp(_, W) {
                var Te = ue(295);
                return Te.assertClause = _, Te.multiLine = W, Te;
              }
              function M_(_, W, Te) {
                return _.assertClause !== W || _.multiLine !== Te ? A2(xp(W, Te), _) : _;
              }
              function Ep(_) {
                var W = ue(268);
                return W.name = _, W.transformFlags |= oe(W.name), W.transformFlags &= -16777217, W;
              }
              function ol(_, W) {
                return _.name !== W ? A2(Ep(W), _) : _;
              }
              function Au(_) {
                var W = ue(274);
                return W.name = _, W.transformFlags |= oe(W.name) | 4, W.transformFlags &= -16777217, W;
              }
              function ru(_, W) {
                return _.name !== W ? A2(Au(W), _) : _;
              }
              function yf(_) {
                var W = ue(269);
                return W.elements = ne(_), W.transformFlags |= f4(W.elements), W.transformFlags &= -16777217, W;
              }
              function Cp(_, W) {
                return _.elements !== W ? A2(yf(W), _) : _;
              }
              function dd(_, W, Te) {
                var cr = ue(270);
                return cr.isTypeOnly = _, cr.propertyName = W, cr.name = Te, cr.transformFlags |= oe(cr.propertyName) | oe(cr.name), cr.transformFlags &= -16777217, cr;
              }
              function kp(_, W, Te, cr) {
                return _.isTypeOnly !== W || _.propertyName !== Te || _.name !== cr ? A2(dd(W, Te, cr), _) : _;
              }
              function mu(_, W, Te, cr) {
                var ni = We(271, _, W);
                return ni.isExportEquals = Te, ni.expression = Te ? y().parenthesizeRightSideOfBinary(63, void 0, cr) : y().parenthesizeExpressionOfExportDefault(cr), ni.transformFlags |= oe(ni.expression), ni.transformFlags &= -16777217, ni;
              }
              function gd(_, W, Te, cr) {
                return _.decorators !== W || _.modifiers !== Te || _.expression !== cr ? A2(mu(W, Te, _.isExportEquals, cr), _) : _;
              }
              function hf(_, W, Te, cr, ni, rt) {
                var yt = We(272, _, W);
                return yt.isTypeOnly = Te, yt.exportClause = cr, yt.moduleSpecifier = ni, yt.assertClause = rt, yt.transformFlags |= oe(yt.exportClause) | oe(yt.moduleSpecifier), yt.transformFlags &= -16777217, yt;
              }
              function $l(_, W, Te, cr, ni, rt, yt) {
                return _.decorators !== W || _.modifiers !== Te || _.isTypeOnly !== cr || _.exportClause !== ni || _.moduleSpecifier !== rt || _.assertClause !== yt ? A2(hf(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Uf(_) {
                var W = ue(273);
                return W.elements = ne(_), W.transformFlags |= f4(W.elements), W.transformFlags &= -16777217, W;
              }
              function L_(_, W) {
                return _.elements !== W ? A2(Uf(W), _) : _;
              }
              function l_(_, W, Te) {
                var cr = ue(275);
                return cr.isTypeOnly = _, cr.propertyName = Mc(W), cr.name = Mc(Te), cr.transformFlags |= oe(cr.propertyName) | oe(cr.name), cr.transformFlags &= -16777217, cr;
              }
              function f_(_, W, Te, cr) {
                return _.isTypeOnly !== W || _.propertyName !== Te || _.name !== cr ? A2(l_(W, Te, cr), _) : _;
              }
              function md() {
                var _ = We(276, void 0, void 0);
                return _;
              }
              function ks(_) {
                var W = ue(277);
                return W.expression = _, W.transformFlags |= oe(W.expression), W.transformFlags &= -16777217, W;
              }
              function Wu(_, W) {
                return _.expression !== W ? A2(ks(W), _) : _;
              }
              function Zl(_) {
                return ue(_);
              }
              function R_(_, W, Te) {
                Te === void 0 && (Te = false);
                var cr = kl(_, Te ? W && y().parenthesizeNonArrayTypeOfPostfixType(W) : W);
                return cr.postfix = Te, cr;
              }
              function kl(_, W) {
                var Te = ue(_);
                return Te.type = W, Te;
              }
              function __(_, W, Te) {
                return W.type !== Te ? A2(R_(_, Te, W.postfix), W) : W;
              }
              function zd(_, W, Te) {
                return W.type !== Te ? A2(kl(_, Te), W) : W;
              }
              function Al(_, W) {
                var Te = Be(317, void 0, void 0, void 0, void 0, _, W);
                return Te;
              }
              function wc(_, W, Te) {
                return _.parameters !== W || _.type !== Te ? A2(Al(W, Te), _) : _;
              }
              function qu(_, W) {
                W === void 0 && (W = false);
                var Te = ue(322);
                return Te.jsDocPropertyTags = bc(_), Te.isArrayType = W, Te;
              }
              function Vu(_, W, Te) {
                return _.jsDocPropertyTags !== W || _.isArrayType !== Te ? A2(qu(W, Te), _) : _;
              }
              function ef(_) {
                var W = ue(309);
                return W.type = _, W;
              }
              function sl(_, W) {
                return _.type !== W ? A2(ef(W), _) : _;
              }
              function p_(_, W, Te) {
                var cr = ue(323);
                return cr.typeParameters = bc(_), cr.parameters = ne(W), cr.type = Te, cr;
              }
              function Df(_, W, Te, cr) {
                return _.typeParameters !== W || _.parameters !== Te || _.type !== cr ? A2(p_(W, Te, cr), _) : _;
              }
              function Ec(_) {
                var W = Q(_.kind);
                return _.tagName.escapedText === e2.escapeLeadingUnderscores(W) ? _.tagName : Er(W);
              }
              function Zn(_, W, Te) {
                var cr = ue(_);
                return cr.tagName = W, cr.comment = Te, cr;
              }
              function os(_, W, Te, cr) {
                var ni = Zn(344, _ != null ? _ : Er("template"), cr);
                return ni.constraint = W, ni.typeParameters = ne(Te), ni;
              }
              function Ps(_, W, Te, cr, ni) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.constraint !== Te || _.typeParameters !== cr || _.comment !== ni ? A2(os(W, Te, cr, ni), _) : _;
              }
              function d_(_, W, Te, cr) {
                var ni = Zn(345, _ != null ? _ : Er("typedef"), cr);
                return ni.typeExpression = W, ni.fullName = Te, ni.name = e2.getJSDocTypeAliasName(Te), ni;
              }
              function Gc(_, W, Te, cr, ni) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.typeExpression !== Te || _.fullName !== cr || _.comment !== ni ? A2(d_(W, Te, cr, ni), _) : _;
              }
              function B_(_, W, Te, cr, ni, rt) {
                var yt = Zn(340, _ != null ? _ : Er("param"), rt);
                return yt.typeExpression = cr, yt.name = W, yt.isNameFirst = !!ni, yt.isBracketed = Te, yt;
              }
              function vu(_, W, Te, cr, ni, rt, yt) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.name !== Te || _.isBracketed !== cr || _.typeExpression !== ni || _.isNameFirst !== rt || _.comment !== yt ? A2(B_(W, Te, cr, ni, rt, yt), _) : _;
              }
              function Gt(_, W, Te, cr, ni, rt) {
                var yt = Zn(347, _ != null ? _ : Er("prop"), rt);
                return yt.typeExpression = cr, yt.name = W, yt.isNameFirst = !!ni, yt.isBracketed = Te, yt;
              }
              function As(_, W, Te, cr, ni, rt, yt) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.name !== Te || _.isBracketed !== cr || _.typeExpression !== ni || _.isNameFirst !== rt || _.comment !== yt ? A2(Gt(W, Te, cr, ni, rt, yt), _) : _;
              }
              function vn(_, W, Te, cr) {
                var ni = Zn(338, _ != null ? _ : Er("callback"), cr);
                return ni.typeExpression = W, ni.fullName = Te, ni.name = e2.getJSDocTypeAliasName(Te), ni;
              }
              function Nl(_, W, Te, cr, ni) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.typeExpression !== Te || _.fullName !== cr || _.comment !== ni ? A2(vn(W, Te, cr, ni), _) : _;
              }
              function cl(_, W, Te) {
                var cr = Zn(328, _ != null ? _ : Er("augments"), Te);
                return cr.class = W, cr;
              }
              function rf(_, W, Te, cr) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.class !== Te || _.comment !== cr ? A2(cl(W, Te, cr), _) : _;
              }
              function Ut(_, W, Te) {
                var cr = Zn(329, _ != null ? _ : Er("implements"), Te);
                return cr.class = W, cr;
              }
              function Ds(_, W, Te) {
                var cr = Zn(346, _ != null ? _ : Er("see"), Te);
                return cr.name = W, cr;
              }
              function bf(_, W, Te, cr) {
                return _.tagName !== W || _.name !== Te || _.comment !== cr ? A2(Ds(W, Te, cr), _) : _;
              }
              function bs(_) {
                var W = ue(310);
                return W.name = _, W;
              }
              function Dc(_, W) {
                return _.name !== W ? A2(bs(W), _) : _;
              }
              function Cc(_, W) {
                var Te = ue(311);
                return Te.left = _, Te.right = W, Te.transformFlags |= oe(Te.left) | oe(Te.right), Te;
              }
              function ac(_, W, Te) {
                return _.left !== W || _.right !== Te ? A2(Cc(W, Te), _) : _;
              }
              function Pl(_, W) {
                var Te = ue(324);
                return Te.name = _, Te.text = W, Te;
              }
              function Il(_, W, Te) {
                return _.name !== W ? A2(Pl(W, Te), _) : _;
              }
              function zf(_, W) {
                var Te = ue(325);
                return Te.name = _, Te.text = W, Te;
              }
              function ul(_, W, Te) {
                return _.name !== W ? A2(zf(W, Te), _) : _;
              }
              function Nu(_, W) {
                var Te = ue(326);
                return Te.name = _, Te.text = W, Te;
              }
              function Us(_, W, Te) {
                return _.name !== W ? A2(Nu(W, Te), _) : _;
              }
              function Ap(_, W, Te, cr) {
                return W === void 0 && (W = Ec(_)), _.tagName !== W || _.class !== Te || _.comment !== cr ? A2(Ut(W, Te, cr), _) : _;
              }
              function Wf(_, W, Te) {
                var cr = Zn(_, W != null ? W : Er(Q(_)), Te);
                return cr;
              }
              function Sf(_, W, Te, cr) {
                return Te === void 0 && (Te = Ec(W)), W.tagName !== Te || W.comment !== cr ? A2(Wf(_, Te, cr), W) : W;
              }
              function ll(_, W, Te, cr) {
                var ni = Zn(_, W != null ? W : Er(Q(_)), cr);
                return ni.typeExpression = Te, ni;
              }
              function J_(_, W, Te, cr, ni) {
                return Te === void 0 && (Te = Ec(W)), W.tagName !== Te || W.typeExpression !== cr || W.comment !== ni ? A2(ll(_, Te, cr, ni), W) : W;
              }
              function j_(_, W) {
                var Te = Zn(327, _, W);
                return Te;
              }
              function U_(_, W, Te) {
                return _.tagName !== W || _.comment !== Te ? A2(j_(W, Te), _) : _;
              }
              function iu(_) {
                var W = ue(321);
                return W.text = _, W;
              }
              function vd(_, W) {
                return _.text !== W ? A2(iu(W), _) : _;
              }
              function qf(_, W) {
                var Te = ue(320);
                return Te.comment = _, Te.tags = bc(W), Te;
              }
              function dc(_, W, Te) {
                return _.comment !== W || _.tags !== Te ? A2(qf(W, Te), _) : _;
              }
              function Pu(_, W, Te) {
                var cr = ue(278);
                return cr.openingElement = _, cr.children = ne(W), cr.closingElement = Te, cr.transformFlags |= oe(cr.openingElement) | f4(cr.children) | oe(cr.closingElement) | 2, cr;
              }
              function wl(_, W, Te, cr) {
                return _.openingElement !== W || _.children !== Te || _.closingElement !== cr ? A2(Pu(W, Te, cr), _) : _;
              }
              function Iu(_, W, Te) {
                var cr = ue(279);
                return cr.tagName = _, cr.typeArguments = bc(W), cr.attributes = Te, cr.transformFlags |= oe(cr.tagName) | f4(cr.typeArguments) | oe(cr.attributes) | 2, cr.typeArguments && (cr.transformFlags |= 1), cr;
              }
              function so(_, W, Te, cr) {
                return _.tagName !== W || _.typeArguments !== Te || _.attributes !== cr ? A2(Iu(W, Te, cr), _) : _;
              }
              function Et(_, W, Te) {
                var cr = ue(280);
                return cr.tagName = _, cr.typeArguments = bc(W), cr.attributes = Te, cr.transformFlags |= oe(cr.tagName) | f4(cr.typeArguments) | oe(cr.attributes) | 2, W && (cr.transformFlags |= 1), cr;
              }
              function Ys(_, W, Te, cr) {
                return _.tagName !== W || _.typeArguments !== Te || _.attributes !== cr ? A2(Et(W, Te, cr), _) : _;
              }
              function Ku(_) {
                var W = ue(281);
                return W.tagName = _, W.transformFlags |= oe(W.tagName) | 2, W;
              }
              function Np(_, W) {
                return _.tagName !== W ? A2(Ku(W), _) : _;
              }
              function Pp(_, W, Te) {
                var cr = ue(282);
                return cr.openingFragment = _, cr.children = ne(W), cr.closingFragment = Te, cr.transformFlags |= oe(cr.openingFragment) | f4(cr.children) | oe(cr.closingFragment) | 2, cr;
              }
              function nc(_, W, Te, cr) {
                return _.openingFragment !== W || _.children !== Te || _.closingFragment !== cr ? A2(Pp(W, Te, cr), _) : _;
              }
              function fl(_, W) {
                var Te = ue(11);
                return Te.text = _, Te.containsOnlyTriviaWhiteSpaces = !!W, Te.transformFlags |= 2, Te;
              }
              function _l(_, W, Te) {
                return _.text !== W || _.containsOnlyTriviaWhiteSpaces !== Te ? A2(fl(W, Te), _) : _;
              }
              function cu() {
                var _ = ue(283);
                return _.transformFlags |= 2, _;
              }
              function gc() {
                var _ = ue(284);
                return _.transformFlags |= 2, _;
              }
              function Tf(_, W) {
                var Te = ue(285);
                return Te.name = _, Te.initializer = W, Te.transformFlags |= oe(Te.name) | oe(Te.initializer) | 2, Te;
              }
              function mc(_, W, Te) {
                return _.name !== W || _.initializer !== Te ? A2(Tf(W, Te), _) : _;
              }
              function Ip(_) {
                var W = ue(286);
                return W.properties = ne(_), W.transformFlags |= f4(W.properties) | 2, W;
              }
              function ms(_, W) {
                return _.properties !== W ? A2(Ip(W), _) : _;
              }
              function tu(_) {
                var W = ue(287);
                return W.expression = _, W.transformFlags |= oe(W.expression) | 2, W;
              }
              function wp(_, W) {
                return _.expression !== W ? A2(tu(W), _) : _;
              }
              function Hc(_, W) {
                var Te = ue(288);
                return Te.dotDotDotToken = _, Te.expression = W, Te.transformFlags |= oe(Te.dotDotDotToken) | oe(Te.expression) | 2, Te;
              }
              function Ol(_, W) {
                return _.expression !== W ? A2(Hc(_.dotDotDotToken, W), _) : _;
              }
              function tf(_, W) {
                var Te = ue(289);
                return Te.expression = y().parenthesizeExpressionForDisallowedComma(_), Te.statements = ne(W), Te.transformFlags |= oe(Te.expression) | f4(Te.statements), Te;
              }
              function xf(_, W, Te) {
                return _.expression !== W || _.statements !== Te ? A2(tf(W, Te), _) : _;
              }
              function z_(_) {
                var W = ue(290);
                return W.statements = ne(_), W.transformFlags = f4(W.statements), W;
              }
              function Oc(_, W) {
                return _.statements !== W ? A2(z_(W), _) : _;
              }
              function rs(_, W) {
                var Te = ue(291);
                switch (Te.token = _, Te.types = ne(W), Te.transformFlags |= f4(Te.types), _) {
                  case 94:
                    Te.transformFlags |= 1024;
                    break;
                  case 117:
                    Te.transformFlags |= 1;
                    break;
                  default:
                    return e2.Debug.assertNever(_);
                }
                return Te;
              }
              function Op(_, W) {
                return _.types !== W ? A2(rs(_.token, W), _) : _;
              }
              function Ef(_, W) {
                var Te = ue(292);
                return (typeof _ == "string" || _ && !e2.isVariableDeclaration(_)) && (_ = Yl(_, void 0, void 0, void 0)), Te.variableDeclaration = _, Te.block = W, Te.transformFlags |= oe(Te.variableDeclaration) | oe(Te.block), _ || (Te.transformFlags |= 64), Te;
              }
              function Fl(_, W, Te) {
                return _.variableDeclaration !== W || _.block !== Te ? A2(Ef(W, Te), _) : _;
              }
              function pl(_, W) {
                var Te = Fe(296, void 0, void 0, _);
                return Te.initializer = y().parenthesizeExpressionForDisallowedComma(W), Te.transformFlags |= oe(Te.name) | oe(Te.initializer), Te;
              }
              function Fp(_, W) {
                return W.decorators && (_.decorators = W.decorators), W.modifiers && (_.modifiers = W.modifiers), W.questionToken && (_.questionToken = W.questionToken), W.exclamationToken && (_.exclamationToken = W.exclamationToken), A2(_, W);
              }
              function Mp(_, W, Te) {
                return _.name !== W || _.initializer !== Te ? Fp(pl(W, Te), _) : _;
              }
              function Gu(_, W) {
                var Te = Fe(297, void 0, void 0, _);
                return Te.objectAssignmentInitializer = W && y().parenthesizeExpressionForDisallowedComma(W), Te.transformFlags |= oe(Te.objectAssignmentInitializer) | 1024, Te;
              }
              function Lp(_, W) {
                return W.decorators && (_.decorators = W.decorators), W.modifiers && (_.modifiers = W.modifiers), W.equalsToken && (_.equalsToken = W.equalsToken), W.questionToken && (_.questionToken = W.questionToken), W.exclamationToken && (_.exclamationToken = W.exclamationToken), A2(_, W);
              }
              function Cf(_, W, Te) {
                return _.name !== W || _.objectAssignmentInitializer !== Te ? Lp(Gu(W, Te), _) : _;
              }
              function W_(_) {
                var W = ue(298);
                return W.expression = y().parenthesizeExpressionForDisallowedComma(_), W.transformFlags |= oe(W.expression) | 128 | 32768, W;
              }
              function g_(_, W) {
                return _.expression !== W ? A2(W_(W), _) : _;
              }
              function dl(_, W) {
                var Te = ue(299);
                return Te.name = Mc(_), Te.initializer = W && y().parenthesizeExpressionForDisallowedComma(W), Te.transformFlags |= oe(Te.name) | oe(Te.initializer) | 1, Te;
              }
              function gl(_, W, Te) {
                return _.name !== W || _.initializer !== Te ? A2(dl(W, Te), _) : _;
              }
              function Vf(_, W, Te) {
                var cr = $.createBaseSourceFileNode(305);
                return cr.statements = ne(_), cr.endOfFileToken = W, cr.flags |= Te, cr.fileName = "", cr.text = "", cr.languageVersion = 0, cr.languageVariant = 0, cr.scriptKind = 0, cr.isDeclarationFile = false, cr.hasNoDefaultLib = false, cr.transformFlags |= f4(cr.statements) | oe(cr.endOfFileToken), cr;
              }
              function Fc(_, W, Te, cr, ni, rt, yt) {
                var Xa = _.redirectInfo ? Object.create(_.redirectInfo.redirectTarget) : $.createBaseSourceFileNode(305);
                for (var vo in _)
                  vo === "emitNode" || e2.hasProperty(Xa, vo) || !e2.hasProperty(_, vo) || (Xa[vo] = _[vo]);
                return Xa.flags |= _.flags, Xa.statements = ne(W), Xa.endOfFileToken = _.endOfFileToken, Xa.isDeclarationFile = Te, Xa.referencedFiles = cr, Xa.typeReferenceDirectives = ni, Xa.hasNoDefaultLib = rt, Xa.libReferenceDirectives = yt, Xa.transformFlags = f4(Xa.statements) | oe(Xa.endOfFileToken), Xa.impliedNodeFormat = _.impliedNodeFormat, Xa;
              }
              function Hu(_, W, Te, cr, ni, rt, yt) {
                return Te === void 0 && (Te = _.isDeclarationFile), cr === void 0 && (cr = _.referencedFiles), ni === void 0 && (ni = _.typeReferenceDirectives), rt === void 0 && (rt = _.hasNoDefaultLib), yt === void 0 && (yt = _.libReferenceDirectives), _.statements !== W || _.isDeclarationFile !== Te || _.referencedFiles !== cr || _.typeReferenceDirectives !== ni || _.hasNoDefaultLib !== rt || _.libReferenceDirectives !== yt ? A2(Fc(_, W, Te, cr, ni, rt, yt), _) : _;
              }
              function af(_, W) {
                W === void 0 && (W = e2.emptyArray);
                var Te = ue(306);
                return Te.prepends = W, Te.sourceFiles = _, Te;
              }
              function tn(_, W, Te) {
                return Te === void 0 && (Te = e2.emptyArray), _.sourceFiles !== W || _.prepends !== Te ? A2(af(W, Te), _) : _;
              }
              function Ml(_, W, Te) {
                var cr = ue(307);
                return cr.prologues = _, cr.syntheticReferences = W, cr.texts = Te, cr.fileName = "", cr.text = "", cr.referencedFiles = e2.emptyArray, cr.libReferenceDirectives = e2.emptyArray, cr.getLineAndCharacterOfPosition = function(ni) {
                  return e2.getLineAndCharacterOfPosition(cr, ni);
                }, cr;
              }
              function Ot(_, W) {
                var Te = ue(_);
                return Te.data = W, Te;
              }
              function nf(_) {
                return Ot(300, _);
              }
              function q_(_, W) {
                var Te = Ot(301, _);
                return Te.texts = W, Te;
              }
              function Kf(_, W) {
                return Ot(W ? 303 : 302, _);
              }
              function Rp(_) {
                var W = ue(304);
                return W.data = _.data, W.section = _, W;
              }
              function yd() {
                var _ = ue(308);
                return _.javascriptText = "", _.declarationText = "", _;
              }
              function m_(_, W, Te) {
                W === void 0 && (W = false);
                var cr = ue(232);
                return cr.type = _, cr.isSpread = W, cr.tupleNameSource = Te, cr;
              }
              function Ll(_) {
                var W = ue(348);
                return W._children = _, W;
              }
              function hd(_) {
                var W = ue(349);
                return W.original = _, e2.setTextRange(W, _), W;
              }
              function v_(_, W) {
                var Te = ue(350);
                return Te.expression = _, Te.original = W, Te.transformFlags |= oe(Te.expression) | 1, e2.setTextRange(Te, W), Te;
              }
              function Bp(_, W) {
                return _.expression !== W ? A2(v_(W, _.original), _) : _;
              }
              function Xu(_) {
                if (e2.nodeIsSynthesized(_) && !e2.isParseTreeNode(_) && !_.original && !_.emitNode && !_.id) {
                  if (e2.isCommaListExpression(_))
                    return _.elements;
                  if (e2.isBinaryExpression(_) && e2.isCommaToken(_.operatorToken))
                    return [_.left, _.right];
                }
                return _;
              }
              function Xc(_) {
                var W = ue(351);
                return W.elements = ne(e2.sameFlatMap(_, Xu)), W.transformFlags |= f4(W.elements), W;
              }
              function Gf(_, W) {
                return _.elements !== W ? A2(Xc(W), _) : _;
              }
              function of(_) {
                var W = ue(353);
                return W.emitNode = {}, W.original = _, W;
              }
              function wu(_) {
                var W = ue(352);
                return W.emitNode = {}, W.original = _, W;
              }
              function V_(_, W) {
                var Te = ue(354);
                return Te.expression = _, Te.thisArg = W, Te.transformFlags |= oe(Te.expression) | oe(Te.thisArg), Te;
              }
              function yu(_, W, Te) {
                return _.expression !== W || _.thisArg !== Te ? A2(V_(W, Te), _) : _;
              }
              function v(_) {
                if (_ === void 0)
                  return _;
                var W = e2.isSourceFile(_) ? $.createBaseSourceFileNode(305) : e2.isIdentifier(_) ? $.createBaseIdentifierNode(79) : e2.isPrivateIdentifier(_) ? $.createBasePrivateIdentifierNode(80) : e2.isNodeKind(_.kind) ? $.createBaseNode(_.kind) : $.createBaseTokenNode(_.kind);
                W.flags |= _.flags & -9, W.transformFlags = _.transformFlags, he(W, _);
                for (var Te in _)
                  W.hasOwnProperty(Te) || !_.hasOwnProperty(Te) || (W[Te] = _[Te]);
                return W;
              }
              function sr(_, W, Te) {
                return qn(ps(void 0, void 0, void 0, void 0, W ? [W] : [], void 0, bn(_, true)), void 0, Te ? [Te] : []);
              }
              function fi(_, W, Te) {
                return qn(js(void 0, void 0, W ? [W] : [], void 0, void 0, bn(_, true)), void 0, Te ? [Te] : []);
              }
              function zi() {
                return qi(we("0"));
              }
              function Sa(_) {
                return mu(void 0, void 0, false, _);
              }
              function da(_) {
                return hf(void 0, void 0, false, Uf([l_(false, void 0, _)]));
              }
              function Ha(_, W) {
                return W === "undefined" ? g.createStrictEquality(_, zi()) : g.createStrictEquality(Rr(_), Ae(W));
              }
              function ta(_, W, Te) {
                return e2.isCallChain(_) ? So(Pi(_, void 0, W), void 0, void 0, Te) : qn(Zr(_, W), void 0, Te);
              }
              function nn(_, W, Te) {
                return ta(_, "bind", Ve([W], Te, true));
              }
              function Wo(_, W, Te) {
                return ta(_, "call", Ve([W], Te, true));
              }
              function Lo(_, W, Te) {
                return ta(_, "apply", [W, Te]);
              }
              function oc(_, W, Te) {
                return ta(Er(_), W, Te);
              }
              function uu(_, W) {
                return ta(_, "slice", W === void 0 ? [] : [Yu(W)]);
              }
              function is(_, W) {
                return ta(_, "concat", W);
              }
              function au(_, W, Te) {
                return oc("Object", "defineProperty", [_, Yu(W), Te]);
              }
              function Ou(_, W, Te) {
                return oc("Reflect", "get", Te ? [_, W, Te] : [_, W]);
              }
              function sf(_, W, Te, cr) {
                return oc("Reflect", "set", cr ? [_, W, Te, cr] : [_, W, Te]);
              }
              function lu(_, W, Te) {
                return Te ? (_.push(pl(W, Te)), true) : false;
              }
              function cf(_, W) {
                var Te = [];
                lu(Te, "enumerable", Yu(_.enumerable)), lu(Te, "configurable", Yu(_.configurable));
                var cr = lu(Te, "writable", Yu(_.writable));
                cr = lu(Te, "value", _.value) || cr;
                var ni = lu(Te, "get", _.get);
                return ni = lu(Te, "set", _.set) || ni, e2.Debug.assert(!(cr && ni), "A PropertyDescriptor may not be both an accessor descriptor and a data descriptor."), qe(Te, !W);
              }
              function uf(_, W) {
                switch (_.kind) {
                  case 212:
                    return tc(_, W);
                  case 211:
                    return pc(_, _.type, W);
                  case 229:
                    return vc(_, W, _.type);
                  case 230:
                    return _i(_, W);
                  case 350:
                    return Bp(_, W);
                }
              }
              function K_(_) {
                return e2.isParenthesizedExpression(_) && e2.nodeIsSynthesized(_) && e2.nodeIsSynthesized(e2.getSourceMapRange(_)) && e2.nodeIsSynthesized(e2.getCommentRange(_)) && !e2.some(e2.getSyntheticLeadingComments(_)) && !e2.some(e2.getSyntheticTrailingComments(_));
              }
              function Jp(_, W, Te) {
                return Te === void 0 && (Te = 15), _ && e2.isOuterExpression(_, Te) && !K_(_) ? uf(_, Jp(_.expression, W)) : W;
              }
              function Hf(_, W, Te) {
                if (!W)
                  return _;
                var cr = P_(W, W.label, e2.isLabeledStatement(W.statement) ? Hf(_, W.statement) : _);
                return Te && Te(W), cr;
              }
              function kc(_, W) {
                var Te = e2.skipParentheses(_);
                switch (Te.kind) {
                  case 79:
                    return W;
                  case 108:
                  case 8:
                  case 9:
                  case 10:
                    return false;
                  case 204:
                    var cr = Te.elements;
                    return cr.length !== 0;
                  case 205:
                    return Te.properties.length > 0;
                  default:
                    return true;
                }
              }
              function G_(_, W, Te, cr) {
                cr === void 0 && (cr = false);
                var ni = e2.skipOuterExpressions(_, 15), rt, yt;
                return e2.isSuperProperty(ni) ? (rt = Ur(), yt = ni) : e2.isSuperKeyword(ni) ? (rt = Ur(), yt = Te !== void 0 && Te < 2 ? e2.setTextRange(Er("_super"), ni) : ni) : e2.getEmitFlags(ni) & 4096 ? (rt = zi(), yt = y().parenthesizeLeftSideOfAccess(ni)) : e2.isPropertyAccessExpression(ni) ? kc(ni.expression, cr) ? (rt = n(W), yt = Zr(e2.setTextRange(g.createAssignment(rt, ni.expression), ni.expression), ni.name), e2.setTextRange(yt, ni)) : (rt = ni.expression, yt = ni) : e2.isElementAccessExpression(ni) ? kc(ni.expression, cr) ? (rt = n(W), yt = Ct(e2.setTextRange(g.createAssignment(rt, ni.expression), ni.expression), ni.argumentExpression), e2.setTextRange(yt, ni)) : (rt = ni.expression, yt = ni) : (rt = zi(), yt = y().parenthesizeLeftSideOfAccess(_)), { target: yt, thisArg: rt };
              }
              function Le(_, W) {
                return Zr(hs(qe([nr(void 0, void 0, "value", [Wt(void 0, void 0, void 0, _, void 0, void 0, void 0)], bn([Mo(W)]))])), "value");
              }
              function Nr(_) {
                return _.length > 10 ? Xc(_) : e2.reduceLeft(_, g.createComma);
              }
              function ri(_, W, Te, cr) {
                cr === void 0 && (cr = 0);
                var ni = e2.getNameOfDeclaration(_);
                if (ni && e2.isIdentifier(ni) && !e2.isGeneratedIdentifier(ni)) {
                  var rt = e2.setParent(e2.setTextRange(v(ni), ni), ni.parent);
                  return cr |= e2.getEmitFlags(ni), Te || (cr |= 48), W || (cr |= 1536), cr && e2.setEmitFlags(rt, cr), rt;
                }
                return Ge(_);
              }
              function di(_, W, Te) {
                return ri(_, W, Te, 49152);
              }
              function Mi(_, W, Te) {
                return ri(_, W, Te, 16384);
              }
              function st(_, W, Te) {
                return ri(_, W, Te, 8192);
              }
              function ra(_, W, Te) {
                return ri(_, W, Te);
              }
              function Ta(_, W, Te, cr) {
                var ni = Zr(_, e2.nodeIsSynthesized(W) ? W : v(W));
                e2.setTextRange(ni, W);
                var rt = 0;
                return cr || (rt |= 48), Te || (rt |= 1536), rt && e2.setEmitFlags(ni, rt), ni;
              }
              function ha(_, W, Te, cr) {
                return _ && e2.hasSyntacticModifier(W, 1) ? Ta(_, ri(W), Te, cr) : st(W, Te, cr);
              }
              function Na(_, W, Te, cr) {
                var ni = co(_, W, 0, Te);
                return ts(_, W, ni, cr);
              }
              function In(_) {
                return e2.isStringLiteral(_.expression) && _.expression.text === "use strict";
              }
              function qo() {
                return e2.startOnNewLine(Mo(Ae("use strict")));
              }
              function co(_, W, Te, cr) {
                Te === void 0 && (Te = 0), e2.Debug.assert(W.length === 0, "Prologue directives should be at the first statement in the target statements array");
                for (var ni = false, rt = _.length; Te < rt; ) {
                  var yt = _[Te];
                  if (e2.isPrologueDirective(yt))
                    In(yt) && (ni = true), W.push(yt);
                  else
                    break;
                  Te++;
                }
                return cr && !ni && W.push(qo()), Te;
              }
              function ts(_, W, Te, cr, ni) {
                ni === void 0 && (ni = e2.returnTrue);
                for (var rt = _.length; Te !== void 0 && Te < rt; ) {
                  var yt = _[Te];
                  if (e2.getEmitFlags(yt) & 1048576 && ni(yt))
                    e2.append(W, cr ? e2.visitNode(yt, cr, e2.isStatement) : yt);
                  else
                    break;
                  Te++;
                }
                return Te;
              }
              function vs(_) {
                var W = e2.findUseStrictPrologue(_);
                return W ? _ : e2.setTextRange(ne(Ve([qo()], _, true)), _);
              }
              function Ac(_) {
                return e2.Debug.assert(e2.every(_, e2.isStatementOrBlock), "Cannot lift nodes to a Block."), e2.singleOrUndefined(_) || bn(_);
              }
              function Is(_, W, Te) {
                for (var cr = Te; cr < _.length && W(_[cr]); )
                  cr++;
                return cr;
              }
              function Qu(_, W) {
                if (!e2.some(W))
                  return _;
                var Te = Is(_, e2.isPrologueDirective, 0), cr = Is(_, e2.isHoistedFunction, Te), ni = Is(_, e2.isHoistedVariableStatement, cr), rt = Is(W, e2.isPrologueDirective, 0), yt = Is(W, e2.isHoistedFunction, rt), Xa = Is(W, e2.isHoistedVariableStatement, yt), vo = Is(W, e2.isCustomPrologue, Xa);
                e2.Debug.assert(vo === W.length, "Expected declarations to be valid standard or custom prologues");
                var Vs = e2.isNodeArray(_) ? _.slice() : _;
                if (vo > Xa && Vs.splice.apply(Vs, Ve([ni, 0], W.slice(Xa, vo), false)), Xa > yt && Vs.splice.apply(Vs, Ve([cr, 0], W.slice(yt, Xa), false)), yt > rt && Vs.splice.apply(Vs, Ve([Te, 0], W.slice(rt, yt), false)), rt > 0)
                  if (Te === 0)
                    Vs.splice.apply(Vs, Ve([0, 0], W.slice(0, rt), false));
                  else {
                    for (var H_ = new e2.Map(), y_ = 0; y_ < Te; y_++) {
                      var Dd = _[y_];
                      H_.set(Dd.expression.text, true);
                    }
                    for (var y_ = rt - 1; y_ >= 0; y_--) {
                      var jp = W[y_];
                      H_.has(jp.expression.text) || Vs.unshift(jp);
                    }
                  }
                return e2.isNodeArray(_) ? e2.setTextRange(ne(Vs, _.hasTrailingComma), _) : _;
              }
              function sc(_, W) {
                var Te, cr;
                return typeof W == "number" ? cr = qr(W) : cr = W, e2.isParameter(_) ? Zt(_, _.decorators, cr, _.dotDotDotToken, _.name, _.questionToken, _.type, _.initializer) : e2.isPropertySignature(_) ? Xe(_, cr, _.name, _.questionToken, _.type) : e2.isPropertyDeclaration(_) ? ti(_, _.decorators, cr, _.name, (Te = _.questionToken) !== null && Te !== void 0 ? Te : _.exclamationToken, _.type, _.initializer) : e2.isMethodSignature(_) ? Sr(_, cr, _.name, _.questionToken, _.typeParameters, _.parameters, _.type) : e2.isMethodDeclaration(_) ? Wr(_, _.decorators, cr, _.asteriskToken, _.name, _.questionToken, _.typeParameters, _.parameters, _.type, _.body) : e2.isConstructorDeclaration(_) ? mr(_, _.decorators, cr, _.parameters, _.body) : e2.isGetAccessorDeclaration(_) ? Oe(_, _.decorators, cr, _.name, _.parameters, _.type, _.body) : e2.isSetAccessorDeclaration(_) ? Mr(_, _.decorators, cr, _.name, _.parameters, _.body) : e2.isIndexSignatureDeclaration(_) ? Vr(_, _.decorators, cr, _.parameters, _.type) : e2.isFunctionExpression(_) ? Qs(_, cr, _.asteriskToken, _.name, _.typeParameters, _.parameters, _.type, _.body) : e2.isArrowFunction(_) ? ds(_, cr, _.typeParameters, _.parameters, _.type, _.equalsGreaterThanToken, _.body) : e2.isClassExpression(_) ? Uu(_, _.decorators, cr, _.name, _.typeParameters, _.heritageClauses, _.members) : e2.isVariableStatement(_) ? rn(_, cr, _.declarationList) : e2.isFunctionDeclaration(_) ? gu(_, _.decorators, cr, _.asteriskToken, _.name, _.typeParameters, _.parameters, _.type, _.body) : e2.isClassDeclaration(_) ? sd(_, _.decorators, cr, _.name, _.typeParameters, _.heritageClauses, _.members) : e2.isInterfaceDeclaration(_) ? va(_, _.decorators, cr, _.name, _.typeParameters, _.heritageClauses, _.members) : e2.isTypeAliasDeclaration(_) ? qs(_, _.decorators, cr, _.name, _.typeParameters, _.type) : e2.isEnumDeclaration(_) ? ns(_, _.decorators, cr, _.name, _.members) : e2.isModuleDeclaration(_) ? hc(_, _.decorators, cr, _.name, _.body) : e2.isImportEqualsDeclaration(_) ? fd(_, _.decorators, cr, _.isTypeOnly, _.name, _.moduleReference) : e2.isImportDeclaration(_) ? Sp(_, _.decorators, cr, _.importClause, _.moduleSpecifier, _.assertClause) : e2.isExportAssignment(_) ? gd(_, _.decorators, cr, _.expression) : e2.isExportDeclaration(_) ? $l(_, _.decorators, cr, _.isTypeOnly, _.exportClause, _.moduleSpecifier, _.assertClause) : e2.Debug.assertNever(_);
              }
              function bc(_) {
                return _ ? ne(_) : void 0;
              }
              function Mc(_) {
                return typeof _ == "string" ? Er(_) : _;
              }
              function Yu(_) {
                return typeof _ == "string" ? Ae(_) : typeof _ == "number" ? we(_) : typeof _ == "boolean" ? _ ? mi() : pe() : _;
              }
              function Rl(_) {
                return typeof _ == "number" ? Ir(_) : _;
              }
              function Lc(_) {
                return _ && e2.isNotEmittedStatement(_) ? e2.setTextRange(he(jn(), _), _) : _;
              }
            }
            e2.createNodeFactory = w;
            function B(X, $) {
              return X !== $ && e2.setTextRange(X, $), X;
            }
            function E(X, $) {
              return X !== $ && (he(X, $), e2.setTextRange(X, $)), X;
            }
            function Q(X) {
              switch (X) {
                case 343:
                  return "type";
                case 341:
                  return "returns";
                case 342:
                  return "this";
                case 339:
                  return "enum";
                case 330:
                  return "author";
                case 332:
                  return "class";
                case 333:
                  return "public";
                case 334:
                  return "private";
                case 335:
                  return "protected";
                case 336:
                  return "readonly";
                case 337:
                  return "override";
                case 344:
                  return "template";
                case 345:
                  return "typedef";
                case 340:
                  return "param";
                case 347:
                  return "prop";
                case 338:
                  return "callback";
                case 328:
                  return "augments";
                case 329:
                  return "implements";
                default:
                  return e2.Debug.fail("Unsupported kind: ".concat(e2.Debug.formatSyntaxKind(X)));
              }
            }
            var le, N = {};
            function p(X, $) {
              switch (le || (le = e2.createScanner(99, false, 0)), X) {
                case 14:
                  le.setText("`" + $ + "`");
                  break;
                case 15:
                  le.setText("`" + $ + "${");
                  break;
                case 16:
                  le.setText("}" + $ + "${");
                  break;
                case 17:
                  le.setText("}" + $ + "`");
                  break;
              }
              var A2 = le.scan();
              if (A2 === 19 && (A2 = le.reScanTemplateToken(false)), le.isUnterminated())
                return le.setText(void 0), N;
              var y;
              switch (A2) {
                case 14:
                case 15:
                case 16:
                case 17:
                  y = le.getTokenValue();
                  break;
              }
              return y === void 0 || le.scan() !== 1 ? (le.setText(void 0), N) : (le.setText(void 0), y);
            }
            function m2(X) {
              return oe(X) & -16777217;
            }
            function G(X, $) {
              return $ | X.transformFlags & 33562624;
            }
            function oe(X) {
              if (!X)
                return 0;
              var $ = X.transformFlags & ~K(X.kind);
              return e2.isNamedDeclaration(X) && e2.isPropertyName(X.name) ? G(X.name, $) : $;
            }
            function f4(X) {
              return X ? X.transformFlags : 0;
            }
            function T(X) {
              for (var $ = 0, A2 = 0, y = X; A2 < y.length; A2++) {
                var V = y[A2];
                $ |= oe(V);
              }
              X.transformFlags = $;
            }
            function K(X) {
              if (X >= 177 && X <= 200)
                return -2;
              switch (X) {
                case 208:
                case 209:
                case 204:
                  return 536887296;
                case 261:
                  return 589443072;
                case 164:
                  return 536870912;
                case 214:
                  return 557748224;
                case 213:
                case 256:
                  return 591310848;
                case 255:
                  return 537165824;
                case 257:
                case 226:
                  return 536940544;
                case 171:
                  return 591306752;
                case 167:
                  return 570433536;
                case 169:
                case 172:
                case 173:
                  return 574529536;
                case 130:
                case 147:
                case 158:
                case 143:
                case 150:
                case 148:
                case 133:
                case 151:
                case 114:
                case 163:
                case 166:
                case 168:
                case 174:
                case 175:
                case 176:
                case 258:
                case 259:
                  return -2;
                case 205:
                  return 536973312;
                case 292:
                  return 536903680;
                case 201:
                case 202:
                  return 536887296;
                case 211:
                case 229:
                case 350:
                case 212:
                case 106:
                  return 536870912;
                case 206:
                case 207:
                  return 536870912;
                default:
                  return 536870912;
              }
            }
            e2.getTransformFlagsSubtreeExclusions = K;
            var b = e2.createBaseNodeFactory();
            function se(X) {
              return X.flags |= 8, X;
            }
            var J = { createBaseSourceFileNode: function(X) {
              return se(b.createBaseSourceFileNode(X));
            }, createBaseIdentifierNode: function(X) {
              return se(b.createBaseIdentifierNode(X));
            }, createBasePrivateIdentifierNode: function(X) {
              return se(b.createBasePrivateIdentifierNode(X));
            }, createBaseTokenNode: function(X) {
              return se(b.createBaseTokenNode(X));
            }, createBaseNode: function(X) {
              return se(b.createBaseNode(X));
            } };
            e2.factory = w(4, J);
            function ie(X, $, A2) {
              var y, V, L, P, k, Y, U, j, H, I;
              e2.isString(X) ? (L = "", P = X, k = X.length, Y = $, U = A2) : (e2.Debug.assert($ === "js" || $ === "dts"), L = ($ === "js" ? X.javascriptPath : X.declarationPath) || "", Y = $ === "js" ? X.javascriptMapPath : X.declarationMapPath, j = function() {
                return $ === "js" ? X.javascriptText : X.declarationText;
              }, H = function() {
                return $ === "js" ? X.javascriptMapText : X.declarationMapText;
              }, k = function() {
                return j().length;
              }, X.buildInfo && X.buildInfo.bundle && (e2.Debug.assert(A2 === void 0 || typeof A2 == "boolean"), y = A2, V = $ === "js" ? X.buildInfo.bundle.js : X.buildInfo.bundle.dts, I = X.oldFileOfCurrentEmit));
              var l = I ? q(e2.Debug.checkDefined(V)) : R(V, y, k);
              return l.fileName = L, l.sourceMapPath = Y, l.oldFileOfCurrentEmit = I, j && H ? (Object.defineProperty(l, "text", { get: j }), Object.defineProperty(l, "sourceMapText", { get: H })) : (e2.Debug.assert(!I), l.text = P != null ? P : "", l.sourceMapText = U), l;
            }
            e2.createUnparsedSourceFile = ie;
            function R(X, $, A2) {
              for (var y, V, L, P, k, Y, U, j, H = 0, I = X ? X.sections : e2.emptyArray; H < I.length; H++) {
                var l = I[H];
                switch (l.kind) {
                  case "prologue":
                    y = e2.append(y, e2.setTextRange(e2.factory.createUnparsedPrologue(l.data), l));
                    break;
                  case "emitHelpers":
                    V = e2.append(V, e2.getAllUnscopedEmitHelpers().get(l.data));
                    break;
                  case "no-default-lib":
                    j = true;
                    break;
                  case "reference":
                    L = e2.append(L, { pos: -1, end: -1, fileName: l.data });
                    break;
                  case "type":
                    P = e2.append(P, { pos: -1, end: -1, fileName: l.data });
                    break;
                  case "type-import":
                    P = e2.append(P, { pos: -1, end: -1, fileName: l.data, resolutionMode: e2.ModuleKind.ESNext });
                    break;
                  case "type-require":
                    P = e2.append(P, { pos: -1, end: -1, fileName: l.data, resolutionMode: e2.ModuleKind.CommonJS });
                    break;
                  case "lib":
                    k = e2.append(k, { pos: -1, end: -1, fileName: l.data });
                    break;
                  case "prepend":
                    for (var d = void 0, D = 0, fe = l.texts; D < fe.length; D++) {
                      var g = fe[D];
                      (!$ || g.kind !== "internal") && (d = e2.append(d, e2.setTextRange(e2.factory.createUnparsedTextLike(g.data, g.kind === "internal"), g)));
                    }
                    Y = e2.addRange(Y, d), U = e2.append(U, e2.factory.createUnparsedPrepend(l.data, d != null ? d : e2.emptyArray));
                    break;
                  case "internal":
                    if ($) {
                      U || (U = []);
                      break;
                    }
                  case "text":
                    U = e2.append(U, e2.setTextRange(e2.factory.createUnparsedTextLike(l.data, l.kind === "internal"), l));
                    break;
                  default:
                    e2.Debug.assertNever(l);
                }
              }
              if (!U) {
                var ne = e2.factory.createUnparsedTextLike(void 0, false);
                e2.setTextRangePosWidth(ne, 0, typeof A2 == "function" ? A2() : A2), U = [ne];
              }
              var ue = e2.parseNodeFactory.createUnparsedSource(y != null ? y : e2.emptyArray, void 0, U);
              return e2.setEachParent(y, ue), e2.setEachParent(U, ue), e2.setEachParent(Y, ue), ue.hasNoDefaultLib = j, ue.helpers = V, ue.referencedFiles = L || e2.emptyArray, ue.typeReferenceDirectives = P, ue.libReferenceDirectives = k || e2.emptyArray, ue;
            }
            function q(X) {
              for (var $, A2, y = 0, V = X.sections; y < V.length; y++) {
                var L = V[y];
                switch (L.kind) {
                  case "internal":
                  case "text":
                    $ = e2.append($, e2.setTextRange(e2.factory.createUnparsedTextLike(L.data, L.kind === "internal"), L));
                    break;
                  case "no-default-lib":
                  case "reference":
                  case "type":
                  case "type-import":
                  case "type-require":
                  case "lib":
                    A2 = e2.append(A2, e2.setTextRange(e2.factory.createUnparsedSyntheticReference(L), L));
                    break;
                  case "prologue":
                  case "emitHelpers":
                  case "prepend":
                    break;
                  default:
                    e2.Debug.assertNever(L);
                }
              }
              var P = e2.factory.createUnparsedSource(e2.emptyArray, A2, $ != null ? $ : e2.emptyArray);
              return e2.setEachParent(A2, P), e2.setEachParent($, P), P.helpers = e2.map(X.sources && X.sources.helpers, function(k) {
                return e2.getAllUnscopedEmitHelpers().get(k);
              }), P;
            }
            function O(X, $, A2, y, V, L, P, k, Y, U, j) {
              var H = e2.parseNodeFactory.createInputFiles();
              if (e2.isString(X))
                H.javascriptText = X, H.javascriptMapPath = A2, H.javascriptMapText = y, H.declarationText = $, H.declarationMapPath = V, H.declarationMapText = L, H.javascriptPath = P, H.declarationPath = k, H.buildInfoPath = Y, H.buildInfo = U, H.oldFileOfCurrentEmit = j;
              else {
                var I = new e2.Map(), l = function(g) {
                  if (g !== void 0) {
                    var ne = I.get(g);
                    return ne === void 0 && (ne = X(g), I.set(g, ne !== void 0 ? ne : false)), ne !== false ? ne : void 0;
                  }
                }, d = function(g) {
                  var ne = l(g);
                  return ne !== void 0 ? ne : "/* Input file ".concat(g, ` was missing */\r
`);
                }, D, fe = function(g) {
                  if (D === void 0) {
                    var ne = g();
                    D = ne !== void 0 ? e2.getBuildInfo(ne) : false;
                  }
                  return D || void 0;
                };
                H.javascriptPath = $, H.javascriptMapPath = A2, H.declarationPath = e2.Debug.checkDefined(y), H.declarationMapPath = V, H.buildInfoPath = L, Object.defineProperties(H, { javascriptText: { get: function() {
                  return d($);
                } }, javascriptMapText: { get: function() {
                  return l(A2);
                } }, declarationText: { get: function() {
                  return d(e2.Debug.checkDefined(y));
                } }, declarationMapText: { get: function() {
                  return l(V);
                } }, buildInfo: { get: function() {
                  return fe(function() {
                    return l(L);
                  });
                } } });
              }
              return H;
            }
            e2.createInputFiles = O;
            var ve;
            function ee(X, $, A2) {
              return new (ve || (ve = e2.objectAllocator.getSourceMapSourceConstructor()))(X, $, A2);
            }
            e2.createSourceMapSource = ee;
            function he(X, $) {
              if (X.original = $, $) {
                var A2 = $.emitNode;
                A2 && (X.emitNode = F2(A2, X.emitNode));
              }
              return X;
            }
            e2.setOriginalNode = he;
            function F2(X, $) {
              var A2 = X.flags, y = X.leadingComments, V = X.trailingComments, L = X.commentRange, P = X.sourceMapRange, k = X.tokenSourceMapRanges, Y = X.constantValue, U = X.helpers, j = X.startsOnNewLine;
              if ($ || ($ = {}), y && ($.leadingComments = e2.addRange(y.slice(), $.leadingComments)), V && ($.trailingComments = e2.addRange(V.slice(), $.trailingComments)), A2 && ($.flags = A2 & -268435457), L && ($.commentRange = L), P && ($.sourceMapRange = P), k && ($.tokenSourceMapRanges = x2(k, $.tokenSourceMapRanges)), Y !== void 0 && ($.constantValue = Y), U)
                for (var H = 0, I = U; H < I.length; H++) {
                  var l = I[H];
                  $.helpers = e2.appendIfUnique($.helpers, l);
                }
              return j !== void 0 && ($.startsOnNewLine = j), $;
            }
            function x2(X, $) {
              $ || ($ = []);
              for (var A2 in X)
                $[A2] = X[A2];
              return $;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(L) {
              var P;
              if (L.emitNode)
                e2.Debug.assert(!(L.emitNode.flags & 268435456), "Invalid attempt to mutate an immutable node.");
              else {
                if (e2.isParseTreeNode(L)) {
                  if (L.kind === 305)
                    return L.emitNode = { annotatedNodes: [L] };
                  var k = (P = e2.getSourceFileOfNode(e2.getParseTreeNode(e2.getSourceFileOfNode(L)))) !== null && P !== void 0 ? P : e2.Debug.fail("Could not determine parsed source file.");
                  a(k).annotatedNodes.push(L);
                }
                L.emitNode = {};
              }
              return L.emitNode;
            }
            e2.getOrCreateEmitNode = a;
            function C(L) {
              var P, k, Y = (k = (P = e2.getSourceFileOfNode(e2.getParseTreeNode(L))) === null || P === void 0 ? void 0 : P.emitNode) === null || k === void 0 ? void 0 : k.annotatedNodes;
              if (Y)
                for (var U = 0, j = Y; U < j.length; U++) {
                  var H = j[U];
                  H.emitNode = void 0;
                }
            }
            e2.disposeEmitNodes = C;
            function w(L) {
              var P = a(L);
              return P.flags |= 1536, P.leadingComments = void 0, P.trailingComments = void 0, L;
            }
            e2.removeAllComments = w;
            function B(L, P) {
              return a(L).flags = P, L;
            }
            e2.setEmitFlags = B;
            function E(L, P) {
              var k = a(L);
              return k.flags = k.flags | P, L;
            }
            e2.addEmitFlags = E;
            function Q(L) {
              var P, k;
              return (k = (P = L.emitNode) === null || P === void 0 ? void 0 : P.sourceMapRange) !== null && k !== void 0 ? k : L;
            }
            e2.getSourceMapRange = Q;
            function le(L, P) {
              return a(L).sourceMapRange = P, L;
            }
            e2.setSourceMapRange = le;
            function N(L, P) {
              var k, Y;
              return (Y = (k = L.emitNode) === null || k === void 0 ? void 0 : k.tokenSourceMapRanges) === null || Y === void 0 ? void 0 : Y[P];
            }
            e2.getTokenSourceMapRange = N;
            function p(L, P, k) {
              var Y, U = a(L), j = (Y = U.tokenSourceMapRanges) !== null && Y !== void 0 ? Y : U.tokenSourceMapRanges = [];
              return j[P] = k, L;
            }
            e2.setTokenSourceMapRange = p;
            function m2(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.startsOnNewLine;
            }
            e2.getStartsOnNewLine = m2;
            function G(L, P) {
              return a(L).startsOnNewLine = P, L;
            }
            e2.setStartsOnNewLine = G;
            function oe(L) {
              var P, k;
              return (k = (P = L.emitNode) === null || P === void 0 ? void 0 : P.commentRange) !== null && k !== void 0 ? k : L;
            }
            e2.getCommentRange = oe;
            function f4(L, P) {
              return a(L).commentRange = P, L;
            }
            e2.setCommentRange = f4;
            function T(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.leadingComments;
            }
            e2.getSyntheticLeadingComments = T;
            function K(L, P) {
              return a(L).leadingComments = P, L;
            }
            e2.setSyntheticLeadingComments = K;
            function b(L, P, k, Y) {
              return K(L, e2.append(T(L), { kind: P, pos: -1, end: -1, hasTrailingNewLine: Y, text: k }));
            }
            e2.addSyntheticLeadingComment = b;
            function se(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.trailingComments;
            }
            e2.getSyntheticTrailingComments = se;
            function J(L, P) {
              return a(L).trailingComments = P, L;
            }
            e2.setSyntheticTrailingComments = J;
            function ie(L, P, k, Y) {
              return J(L, e2.append(se(L), { kind: P, pos: -1, end: -1, hasTrailingNewLine: Y, text: k }));
            }
            e2.addSyntheticTrailingComment = ie;
            function R(L, P) {
              K(L, T(P)), J(L, se(P));
              var k = a(P);
              return k.leadingComments = void 0, k.trailingComments = void 0, L;
            }
            e2.moveSyntheticComments = R;
            function q(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.constantValue;
            }
            e2.getConstantValue = q;
            function O(L, P) {
              var k = a(L);
              return k.constantValue = P, L;
            }
            e2.setConstantValue = O;
            function ve(L, P) {
              var k = a(L);
              return k.helpers = e2.append(k.helpers, P), L;
            }
            e2.addEmitHelper = ve;
            function ee(L, P) {
              if (e2.some(P))
                for (var k = a(L), Y = 0, U = P; Y < U.length; Y++) {
                  var j = U[Y];
                  k.helpers = e2.appendIfUnique(k.helpers, j);
                }
              return L;
            }
            e2.addEmitHelpers = ee;
            function he(L, P) {
              var k, Y = (k = L.emitNode) === null || k === void 0 ? void 0 : k.helpers;
              return Y ? e2.orderedRemoveItem(Y, P) : false;
            }
            e2.removeEmitHelper = he;
            function F2(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.helpers;
            }
            e2.getEmitHelpers = F2;
            function x2(L, P, k) {
              var Y = L.emitNode, U = Y && Y.helpers;
              if (!!e2.some(U)) {
                for (var j = a(P), H = 0, I = 0; I < U.length; I++) {
                  var l = U[I];
                  k(l) ? (H++, j.helpers = e2.appendIfUnique(j.helpers, l)) : H > 0 && (U[I - H] = l);
                }
                H > 0 && (U.length -= H);
              }
            }
            e2.moveEmitHelpers = x2;
            function X(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.snippetElement;
            }
            e2.getSnippetElement = X;
            function $(L, P) {
              var k = a(L);
              return k.snippetElement = P, L;
            }
            e2.setSnippetElement = $;
            function A2(L) {
              return a(L).flags |= 134217728, L;
            }
            e2.ignoreSourceNewlines = A2;
            function y(L, P) {
              var k = a(L);
              return k.typeNode = P, L;
            }
            e2.setTypeNode = y;
            function V(L) {
              var P;
              return (P = L.emitNode) === null || P === void 0 ? void 0 : P.typeNode;
            }
            e2.getTypeNode = V;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(le) {
              var N = le.factory, p = e2.memoize(function() {
                return e2.setEmitFlags(N.createTrue(), 268435456);
              }), m2 = e2.memoize(function() {
                return e2.setEmitFlags(N.createFalse(), 268435456);
              });
              return { getUnscopedHelperName: G, createDecorateHelper: oe, createMetadataHelper: f4, createParamHelper: T, createAssignHelper: K, createAwaitHelper: b, createAsyncGeneratorHelper: se, createAsyncDelegatorHelper: J, createAsyncValuesHelper: ie, createRestHelper: R, createAwaiterHelper: q, createExtendsHelper: O, createTemplateObjectHelper: ve, createSpreadArrayHelper: ee, createValuesHelper: he, createReadHelper: F2, createGeneratorHelper: x2, createCreateBindingHelper: X, createImportStarHelper: $, createImportStarCallbackHelper: A2, createImportDefaultHelper: y, createExportStarHelper: V, createClassPrivateFieldGetHelper: L, createClassPrivateFieldSetHelper: P, createClassPrivateFieldInHelper: k };
              function G(Y) {
                return e2.setEmitFlags(N.createIdentifier(Y), 4098);
              }
              function oe(Y, U, j, H) {
                le.requestEmitHelper(e2.decorateHelper);
                var I = [];
                return I.push(N.createArrayLiteralExpression(Y, true)), I.push(U), j && (I.push(j), H && I.push(H)), N.createCallExpression(G("__decorate"), void 0, I);
              }
              function f4(Y, U) {
                return le.requestEmitHelper(e2.metadataHelper), N.createCallExpression(G("__metadata"), void 0, [N.createStringLiteral(Y), U]);
              }
              function T(Y, U, j) {
                return le.requestEmitHelper(e2.paramHelper), e2.setTextRange(N.createCallExpression(G("__param"), void 0, [N.createNumericLiteral(U + ""), Y]), j);
              }
              function K(Y) {
                return e2.getEmitScriptTarget(le.getCompilerOptions()) >= 2 ? N.createCallExpression(N.createPropertyAccessExpression(N.createIdentifier("Object"), "assign"), void 0, Y) : (le.requestEmitHelper(e2.assignHelper), N.createCallExpression(G("__assign"), void 0, Y));
              }
              function b(Y) {
                return le.requestEmitHelper(e2.awaitHelper), N.createCallExpression(G("__await"), void 0, [Y]);
              }
              function se(Y, U) {
                return le.requestEmitHelper(e2.awaitHelper), le.requestEmitHelper(e2.asyncGeneratorHelper), (Y.emitNode || (Y.emitNode = {})).flags |= 786432, N.createCallExpression(G("__asyncGenerator"), void 0, [U ? N.createThis() : N.createVoidZero(), N.createIdentifier("arguments"), Y]);
              }
              function J(Y) {
                return le.requestEmitHelper(e2.awaitHelper), le.requestEmitHelper(e2.asyncDelegator), N.createCallExpression(G("__asyncDelegator"), void 0, [Y]);
              }
              function ie(Y) {
                return le.requestEmitHelper(e2.asyncValues), N.createCallExpression(G("__asyncValues"), void 0, [Y]);
              }
              function R(Y, U, j, H) {
                le.requestEmitHelper(e2.restHelper);
                for (var I = [], l = 0, d = 0; d < U.length - 1; d++) {
                  var D = e2.getPropertyNameOfBindingOrAssignmentElement(U[d]);
                  if (D)
                    if (e2.isComputedPropertyName(D)) {
                      e2.Debug.assertIsDefined(j, "Encountered computed property name but 'computedTempVariables' argument was not provided.");
                      var fe = j[l];
                      l++, I.push(N.createConditionalExpression(N.createTypeCheck(fe, "symbol"), void 0, fe, void 0, N.createAdd(fe, N.createStringLiteral(""))));
                    } else
                      I.push(N.createStringLiteralFromNode(D));
                }
                return N.createCallExpression(G("__rest"), void 0, [Y, e2.setTextRange(N.createArrayLiteralExpression(I), H)]);
              }
              function q(Y, U, j, H) {
                le.requestEmitHelper(e2.awaiterHelper);
                var I = N.createFunctionExpression(void 0, N.createToken(41), void 0, void 0, [], void 0, H);
                return (I.emitNode || (I.emitNode = {})).flags |= 786432, N.createCallExpression(G("__awaiter"), void 0, [Y ? N.createThis() : N.createVoidZero(), U ? N.createIdentifier("arguments") : N.createVoidZero(), j ? e2.createExpressionFromEntityName(N, j) : N.createVoidZero(), I]);
              }
              function O(Y) {
                return le.requestEmitHelper(e2.extendsHelper), N.createCallExpression(G("__extends"), void 0, [Y, N.createUniqueName("_super", 48)]);
              }
              function ve(Y, U) {
                return le.requestEmitHelper(e2.templateObjectHelper), N.createCallExpression(G("__makeTemplateObject"), void 0, [Y, U]);
              }
              function ee(Y, U, j) {
                return le.requestEmitHelper(e2.spreadArrayHelper), N.createCallExpression(G("__spreadArray"), void 0, [Y, U, j ? p() : m2()]);
              }
              function he(Y) {
                return le.requestEmitHelper(e2.valuesHelper), N.createCallExpression(G("__values"), void 0, [Y]);
              }
              function F2(Y, U) {
                return le.requestEmitHelper(e2.readHelper), N.createCallExpression(G("__read"), void 0, U !== void 0 ? [Y, N.createNumericLiteral(U + "")] : [Y]);
              }
              function x2(Y) {
                return le.requestEmitHelper(e2.generatorHelper), N.createCallExpression(G("__generator"), void 0, [N.createThis(), Y]);
              }
              function X(Y, U, j) {
                return le.requestEmitHelper(e2.createBindingHelper), N.createCallExpression(G("__createBinding"), void 0, Ve([N.createIdentifier("exports"), Y, U], j ? [j] : [], true));
              }
              function $(Y) {
                return le.requestEmitHelper(e2.importStarHelper), N.createCallExpression(G("__importStar"), void 0, [Y]);
              }
              function A2() {
                return le.requestEmitHelper(e2.importStarHelper), G("__importStar");
              }
              function y(Y) {
                return le.requestEmitHelper(e2.importDefaultHelper), N.createCallExpression(G("__importDefault"), void 0, [Y]);
              }
              function V(Y, U) {
                return U === void 0 && (U = N.createIdentifier("exports")), le.requestEmitHelper(e2.exportStarHelper), le.requestEmitHelper(e2.createBindingHelper), N.createCallExpression(G("__exportStar"), void 0, [Y, U]);
              }
              function L(Y, U, j, H) {
                le.requestEmitHelper(e2.classPrivateFieldGetHelper);
                var I;
                return H ? I = [Y, U, N.createStringLiteral(j), H] : I = [Y, U, N.createStringLiteral(j)], N.createCallExpression(G("__classPrivateFieldGet"), void 0, I);
              }
              function P(Y, U, j, H, I) {
                le.requestEmitHelper(e2.classPrivateFieldSetHelper);
                var l;
                return I ? l = [Y, U, j, N.createStringLiteral(H), I] : l = [Y, U, j, N.createStringLiteral(H)], N.createCallExpression(G("__classPrivateFieldSet"), void 0, l);
              }
              function k(Y, U) {
                return le.requestEmitHelper(e2.classPrivateFieldInHelper), N.createCallExpression(G("__classPrivateFieldIn"), void 0, [Y, U]);
              }
            }
            e2.createEmitHelperFactory = a;
            function C(le, N) {
              return le === N || le.priority === N.priority ? 0 : le.priority === void 0 ? 1 : N.priority === void 0 ? -1 : e2.compareValues(le.priority, N.priority);
            }
            e2.compareEmitHelpers = C;
            function w(le) {
              for (var N = [], p = 1; p < arguments.length; p++)
                N[p - 1] = arguments[p];
              return function(m2) {
                for (var G = "", oe = 0; oe < N.length; oe++)
                  G += le[oe], G += m2(N[oe]);
                return G += le[le.length - 1], G;
              };
            }
            e2.helperString = w, e2.decorateHelper = { name: "typescript:decorate", importName: "__decorate", scoped: false, priority: 2, text: `
            var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
                var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
                if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
                else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
                return c > 3 && r && Object.defineProperty(target, key, r), r;
            };` }, e2.metadataHelper = { name: "typescript:metadata", importName: "__metadata", scoped: false, priority: 3, text: `
            var __metadata = (this && this.__metadata) || function (k, v) {
                if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
            };` }, e2.paramHelper = { name: "typescript:param", importName: "__param", scoped: false, priority: 4, text: `
            var __param = (this && this.__param) || function (paramIndex, decorator) {
                return function (target, key) { decorator(target, key, paramIndex); }
            };` }, e2.assignHelper = { name: "typescript:assign", importName: "__assign", scoped: false, priority: 1, text: `
            var __assign = (this && this.__assign) || function () {
                __assign = Object.assign || function(t) {
                    for (var s, i = 1, n = arguments.length; i < n; i++) {
                        s = arguments[i];
                        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                            t[p] = s[p];
                    }
                    return t;
                };
                return __assign.apply(this, arguments);
            };` }, e2.awaitHelper = { name: "typescript:await", importName: "__await", scoped: false, text: `
            var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }` }, e2.asyncGeneratorHelper = { name: "typescript:asyncGenerator", importName: "__asyncGenerator", scoped: false, dependencies: [e2.awaitHelper], text: `
            var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
                var g = generator.apply(thisArg, _arguments || []), i, q = [];
                return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
                function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
                function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
                function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
                function fulfill(value) { resume("next", value); }
                function reject(value) { resume("throw", value); }
                function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
            };` }, e2.asyncDelegator = { name: "typescript:asyncDelegator", importName: "__asyncDelegator", scoped: false, dependencies: [e2.awaitHelper], text: `
            var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
                var i, p;
                return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
                function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
            };` }, e2.asyncValues = { name: "typescript:asyncValues", importName: "__asyncValues", scoped: false, text: `
            var __asyncValues = (this && this.__asyncValues) || function (o) {
                if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
                var m = o[Symbol.asyncIterator], i;
                return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
                function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
                function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
            };` }, e2.restHelper = { name: "typescript:rest", importName: "__rest", scoped: false, text: `
            var __rest = (this && this.__rest) || function (s, e) {
                var t = {};
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                    t[p] = s[p];
                if (s != null && typeof Object.getOwnPropertySymbols === "function")
                    for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                        if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                            t[p[i]] = s[p[i]];
                    }
                return t;
            };` }, e2.awaiterHelper = { name: "typescript:awaiter", importName: "__awaiter", scoped: false, priority: 5, text: `
            var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
                function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
                return new (P || (P = Promise))(function (resolve, reject) {
                    function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
                    function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
                    function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
                    step((generator = generator.apply(thisArg, _arguments || [])).next());
                });
            };` }, e2.extendsHelper = { name: "typescript:extends", importName: "__extends", scoped: false, priority: 0, text: `
            var __extends = (this && this.__extends) || (function () {
                var extendStatics = function (d, b) {
                    extendStatics = Object.setPrototypeOf ||
                        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
                    return extendStatics(d, b);
                };

                return function (d, b) {
                    if (typeof b !== "function" && b !== null)
                        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
                    extendStatics(d, b);
                    function __() { this.constructor = d; }
                    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
                };
            })();` }, e2.templateObjectHelper = { name: "typescript:makeTemplateObject", importName: "__makeTemplateObject", scoped: false, priority: 0, text: `
            var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
                if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
                return cooked;
            };` }, e2.readHelper = { name: "typescript:read", importName: "__read", scoped: false, text: `
            var __read = (this && this.__read) || function (o, n) {
                var m = typeof Symbol === "function" && o[Symbol.iterator];
                if (!m) return o;
                var i = m.call(o), r, ar = [], e;
                try {
                    while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
                }
                catch (error) { e = { error: error }; }
                finally {
                    try {
                        if (r && !r.done && (m = i["return"])) m.call(i);
                    }
                    finally { if (e) throw e.error; }
                }
                return ar;
            };` }, e2.spreadArrayHelper = { name: "typescript:spreadArray", importName: "__spreadArray", scoped: false, text: `
            var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
                if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
                    if (ar || !(i in from)) {
                        if (!ar) ar = Array.prototype.slice.call(from, 0, i);
                        ar[i] = from[i];
                    }
                }
                return to.concat(ar || Array.prototype.slice.call(from));
            };` }, e2.valuesHelper = { name: "typescript:values", importName: "__values", scoped: false, text: `
            var __values = (this && this.__values) || function(o) {
                var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
                if (m) return m.call(o);
                if (o && typeof o.length === "number") return {
                    next: function () {
                        if (o && i >= o.length) o = void 0;
                        return { value: o && o[i++], done: !o };
                    }
                };
                throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
            };` }, e2.generatorHelper = { name: "typescript:generator", importName: "__generator", scoped: false, priority: 6, text: `
            var __generator = (this && this.__generator) || function (thisArg, body) {
                var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
                return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
                function verb(n) { return function (v) { return step([n, v]); }; }
                function step(op) {
                    if (f) throw new TypeError("Generator is already executing.");
                    while (_) try {
                        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                        if (y = 0, t) op = [op[0] & 2, t.value];
                        switch (op[0]) {
                            case 0: case 1: t = op; break;
                            case 4: _.label++; return { value: op[1], done: false };
                            case 5: _.label++; y = op[1]; op = [0]; continue;
                            case 7: op = _.ops.pop(); _.trys.pop(); continue;
                            default:
                                if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                                if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                                if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                                if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                                if (t[2]) _.ops.pop();
                                _.trys.pop(); continue;
                        }
                        op = body.call(thisArg, _);
                    } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
                    if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
                }
            };` }, e2.createBindingHelper = { name: "typescript:commonjscreatebinding", importName: "__createBinding", scoped: false, priority: 1, text: `
            var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                var desc = Object.getOwnPropertyDescriptor(m, k);
                if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
                  desc = { enumerable: true, get: function() { return m[k]; } };
                }
                Object.defineProperty(o, k2, desc);
            }) : (function(o, m, k, k2) {
                if (k2 === undefined) k2 = k;
                o[k2] = m[k];
            }));` }, e2.setModuleDefaultHelper = { name: "typescript:commonjscreatevalue", importName: "__setModuleDefault", scoped: false, priority: 1, text: `
            var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
                Object.defineProperty(o, "default", { enumerable: true, value: v });
            }) : function(o, v) {
                o["default"] = v;
            });` }, e2.importStarHelper = { name: "typescript:commonjsimportstar", importName: "__importStar", scoped: false, dependencies: [e2.createBindingHelper, e2.setModuleDefaultHelper], priority: 2, text: `
            var __importStar = (this && this.__importStar) || function (mod) {
                if (mod && mod.__esModule) return mod;
                var result = {};
                if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
                __setModuleDefault(result, mod);
                return result;
            };` }, e2.importDefaultHelper = { name: "typescript:commonjsimportdefault", importName: "__importDefault", scoped: false, text: `
            var __importDefault = (this && this.__importDefault) || function (mod) {
                return (mod && mod.__esModule) ? mod : { "default": mod };
            };` }, e2.exportStarHelper = { name: "typescript:export-star", importName: "__exportStar", scoped: false, dependencies: [e2.createBindingHelper], priority: 2, text: `
            var __exportStar = (this && this.__exportStar) || function(m, exports) {
                for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
            };` }, e2.classPrivateFieldGetHelper = { name: "typescript:classPrivateFieldGet", importName: "__classPrivateFieldGet", scoped: false, text: `
            var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
                return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
            };` }, e2.classPrivateFieldSetHelper = { name: "typescript:classPrivateFieldSet", importName: "__classPrivateFieldSet", scoped: false, text: `
            var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
                if (kind === "m") throw new TypeError("Private method is not writable");
                if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
                if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
                return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
            };` }, e2.classPrivateFieldInHelper = { name: "typescript:classPrivateFieldIn", importName: "__classPrivateFieldIn", scoped: false, text: `
            var __classPrivateFieldIn = (this && this.__classPrivateFieldIn) || function(state, receiver) {
                if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
                return typeof state === "function" ? receiver === state : state.has(receiver);
            };` };
            var B;
            function E() {
              return B || (B = e2.arrayToMap([e2.decorateHelper, e2.metadataHelper, e2.paramHelper, e2.assignHelper, e2.awaitHelper, e2.asyncGeneratorHelper, e2.asyncDelegator, e2.asyncValues, e2.restHelper, e2.awaiterHelper, e2.extendsHelper, e2.templateObjectHelper, e2.spreadArrayHelper, e2.valuesHelper, e2.readHelper, e2.generatorHelper, e2.importStarHelper, e2.importDefaultHelper, e2.exportStarHelper, e2.classPrivateFieldGetHelper, e2.classPrivateFieldSetHelper, e2.classPrivateFieldInHelper, e2.createBindingHelper, e2.setModuleDefaultHelper], function(le) {
                return le.name;
              }));
            }
            e2.getAllUnscopedEmitHelpers = E, e2.asyncSuperHelper = { name: "typescript:async-super", scoped: true, text: w(oi([`
            const `, " = name => super[name];"], [`
            const `, " = name => super[name];"]), "_superIndex") }, e2.advancedAsyncSuperHelper = { name: "typescript:advanced-async-super", scoped: true, text: w(oi([`
            const `, ` = (function (geti, seti) {
                const cache = Object.create(null);
                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });
            })(name => super[name], (name, value) => super[name] = value);`], [`
            const `, ` = (function (geti, seti) {
                const cache = Object.create(null);
                return name => cache[name] || (cache[name] = { get value() { return geti(name); }, set value(v) { seti(name, v); } });
            })(name => super[name], (name, value) => super[name] = value);`]), "_superIndex") };
            function Q(le, N) {
              return e2.isCallExpression(le) && e2.isIdentifier(le.expression) && (e2.getEmitFlags(le.expression) & 4096) !== 0 && le.expression.escapedText === N;
            }
            e2.isCallToHelper = Q;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(jr) {
              return jr.kind === 8;
            }
            e2.isNumericLiteral = a;
            function C(jr) {
              return jr.kind === 9;
            }
            e2.isBigIntLiteral = C;
            function w(jr) {
              return jr.kind === 10;
            }
            e2.isStringLiteral = w;
            function B(jr) {
              return jr.kind === 11;
            }
            e2.isJsxText = B;
            function E(jr) {
              return jr.kind === 13;
            }
            e2.isRegularExpressionLiteral = E;
            function Q(jr) {
              return jr.kind === 14;
            }
            e2.isNoSubstitutionTemplateLiteral = Q;
            function le(jr) {
              return jr.kind === 15;
            }
            e2.isTemplateHead = le;
            function N(jr) {
              return jr.kind === 16;
            }
            e2.isTemplateMiddle = N;
            function p(jr) {
              return jr.kind === 17;
            }
            e2.isTemplateTail = p;
            function m2(jr) {
              return jr.kind === 25;
            }
            e2.isDotDotDotToken = m2;
            function G(jr) {
              return jr.kind === 27;
            }
            e2.isCommaToken = G;
            function oe(jr) {
              return jr.kind === 39;
            }
            e2.isPlusToken = oe;
            function f4(jr) {
              return jr.kind === 40;
            }
            e2.isMinusToken = f4;
            function T(jr) {
              return jr.kind === 41;
            }
            e2.isAsteriskToken = T;
            function K(jr) {
              return jr.kind === 53;
            }
            e2.isExclamationToken = K;
            function b(jr) {
              return jr.kind === 57;
            }
            e2.isQuestionToken = b;
            function se(jr) {
              return jr.kind === 58;
            }
            e2.isColonToken = se;
            function J(jr) {
              return jr.kind === 28;
            }
            e2.isQuestionDotToken = J;
            function ie(jr) {
              return jr.kind === 38;
            }
            e2.isEqualsGreaterThanToken = ie;
            function R(jr) {
              return jr.kind === 79;
            }
            e2.isIdentifier = R;
            function q(jr) {
              return jr.kind === 80;
            }
            e2.isPrivateIdentifier = q;
            function O(jr) {
              return jr.kind === 93;
            }
            e2.isExportModifier = O;
            function ve(jr) {
              return jr.kind === 131;
            }
            e2.isAsyncModifier = ve;
            function ee(jr) {
              return jr.kind === 128;
            }
            e2.isAssertsKeyword = ee;
            function he(jr) {
              return jr.kind === 132;
            }
            e2.isAwaitKeyword = he;
            function F2(jr) {
              return jr.kind === 145;
            }
            e2.isReadonlyKeyword = F2;
            function x2(jr) {
              return jr.kind === 124;
            }
            e2.isStaticModifier = x2;
            function X(jr) {
              return jr.kind === 126;
            }
            e2.isAbstractModifier = X;
            function $(jr) {
              return jr.kind === 106;
            }
            e2.isSuperKeyword = $;
            function A2(jr) {
              return jr.kind === 100;
            }
            e2.isImportKeyword = A2;
            function y(jr) {
              return jr.kind === 161;
            }
            e2.isQualifiedName = y;
            function V(jr) {
              return jr.kind === 162;
            }
            e2.isComputedPropertyName = V;
            function L(jr) {
              return jr.kind === 163;
            }
            e2.isTypeParameterDeclaration = L;
            function P(jr) {
              return jr.kind === 164;
            }
            e2.isParameter = P;
            function k(jr) {
              return jr.kind === 165;
            }
            e2.isDecorator = k;
            function Y(jr) {
              return jr.kind === 166;
            }
            e2.isPropertySignature = Y;
            function U(jr) {
              return jr.kind === 167;
            }
            e2.isPropertyDeclaration = U;
            function j(jr) {
              return jr.kind === 168;
            }
            e2.isMethodSignature = j;
            function H(jr) {
              return jr.kind === 169;
            }
            e2.isMethodDeclaration = H;
            function I(jr) {
              return jr.kind === 170;
            }
            e2.isClassStaticBlockDeclaration = I;
            function l(jr) {
              return jr.kind === 171;
            }
            e2.isConstructorDeclaration = l;
            function d(jr) {
              return jr.kind === 172;
            }
            e2.isGetAccessorDeclaration = d;
            function D(jr) {
              return jr.kind === 173;
            }
            e2.isSetAccessorDeclaration = D;
            function fe(jr) {
              return jr.kind === 174;
            }
            e2.isCallSignatureDeclaration = fe;
            function g(jr) {
              return jr.kind === 175;
            }
            e2.isConstructSignatureDeclaration = g;
            function ne(jr) {
              return jr.kind === 176;
            }
            e2.isIndexSignatureDeclaration = ne;
            function ue(jr) {
              return jr.kind === 177;
            }
            e2.isTypePredicateNode = ue;
            function We(jr) {
              return jr.kind === 178;
            }
            e2.isTypeReferenceNode = We;
            function Fe(jr) {
              return jr.kind === 179;
            }
            e2.isFunctionTypeNode = Fe;
            function Z2(jr) {
              return jr.kind === 180;
            }
            e2.isConstructorTypeNode = Z2;
            function Be(jr) {
              return jr.kind === 181;
            }
            e2.isTypeQueryNode = Be;
            function ge(jr) {
              return jr.kind === 182;
            }
            e2.isTypeLiteralNode = ge;
            function Re(jr) {
              return jr.kind === 183;
            }
            e2.isArrayTypeNode = Re;
            function ze(jr) {
              return jr.kind === 184;
            }
            e2.isTupleTypeNode = ze;
            function Ee(jr) {
              return jr.kind === 197;
            }
            e2.isNamedTupleMember = Ee;
            function He(jr) {
              return jr.kind === 185;
            }
            e2.isOptionalTypeNode = He;
            function rr(jr) {
              return jr.kind === 186;
            }
            e2.isRestTypeNode = rr;
            function Ie(jr) {
              return jr.kind === 187;
            }
            e2.isUnionTypeNode = Ie;
            function _e(jr) {
              return jr.kind === 188;
            }
            e2.isIntersectionTypeNode = _e;
            function we(jr) {
              return jr.kind === 189;
            }
            e2.isConditionalTypeNode = we;
            function de(jr) {
              return jr.kind === 190;
            }
            e2.isInferTypeNode = de;
            function ye(jr) {
              return jr.kind === 191;
            }
            e2.isParenthesizedTypeNode = ye;
            function Ae(jr) {
              return jr.kind === 192;
            }
            e2.isThisTypeNode = Ae;
            function er(jr) {
              return jr.kind === 193;
            }
            e2.isTypeOperatorNode = er;
            function ir(jr) {
              return jr.kind === 194;
            }
            e2.isIndexedAccessTypeNode = ir;
            function Cr(jr) {
              return jr.kind === 195;
            }
            e2.isMappedTypeNode = Cr;
            function Ye(jr) {
              return jr.kind === 196;
            }
            e2.isLiteralTypeNode = Ye;
            function Br(jr) {
              return jr.kind === 200;
            }
            e2.isImportTypeNode = Br;
            function Er(jr) {
              return jr.kind === 199;
            }
            e2.isTemplateLiteralTypeSpan = Er;
            function Ne(jr) {
              return jr.kind === 198;
            }
            e2.isTemplateLiteralTypeNode = Ne;
            function n(jr) {
              return jr.kind === 201;
            }
            e2.isObjectBindingPattern = n;
            function lr(jr) {
              return jr.kind === 202;
            }
            e2.isArrayBindingPattern = lr;
            function be(jr) {
              return jr.kind === 203;
            }
            e2.isBindingElement = be;
            function Ge(jr) {
              return jr.kind === 204;
            }
            e2.isArrayLiteralExpression = Ge;
            function ur(jr) {
              return jr.kind === 205;
            }
            e2.isObjectLiteralExpression = ur;
            function yr(jr) {
              return jr.kind === 206;
            }
            e2.isPropertyAccessExpression = yr;
            function Ir(jr) {
              return jr.kind === 207;
            }
            e2.isElementAccessExpression = Ir;
            function wr(jr) {
              return jr.kind === 208;
            }
            e2.isCallExpression = wr;
            function Ur(jr) {
              return jr.kind === 209;
            }
            e2.isNewExpression = Ur;
            function ii(jr) {
              return jr.kind === 210;
            }
            e2.isTaggedTemplateExpression = ii;
            function mi(jr) {
              return jr.kind === 211;
            }
            e2.isTypeAssertionExpression = mi;
            function pe(jr) {
              return jr.kind === 212;
            }
            e2.isParenthesizedExpression = pe;
            function or(jr) {
              return jr.kind === 213;
            }
            e2.isFunctionExpression = or;
            function qr(jr) {
              return jr.kind === 214;
            }
            e2.isArrowFunction = qr;
            function si(jr) {
              return jr.kind === 215;
            }
            e2.isDeleteExpression = si;
            function Di(jr) {
              return jr.kind === 216;
            }
            e2.isTypeOfExpression = Di;
            function wi(jr) {
              return jr.kind === 217;
            }
            e2.isVoidExpression = wi;
            function Xi(jr) {
              return jr.kind === 218;
            }
            e2.isAwaitExpression = Xi;
            function et(jr) {
              return jr.kind === 219;
            }
            e2.isPrefixUnaryExpression = et;
            function Gi(jr) {
              return jr.kind === 220;
            }
            e2.isPostfixUnaryExpression = Gi;
            function Wt(jr) {
              return jr.kind === 221;
            }
            e2.isBinaryExpression = Wt;
            function Zt(jr) {
              return jr.kind === 222;
            }
            e2.isConditionalExpression = Zt;
            function _r(jr) {
              return jr.kind === 223;
            }
            e2.isTemplateExpression = _r;
            function pi(jr) {
              return jr.kind === 224;
            }
            e2.isYieldExpression = pi;
            function ae(jr) {
              return jr.kind === 225;
            }
            e2.isSpreadElement = ae;
            function Xe(jr) {
              return jr.kind === 226;
            }
            e2.isClassExpression = Xe;
            function Jr(jr) {
              return jr.kind === 227;
            }
            e2.isOmittedExpression = Jr;
            function ti(jr) {
              return jr.kind === 228;
            }
            e2.isExpressionWithTypeArguments = ti;
            function Ze(jr) {
              return jr.kind === 229;
            }
            e2.isAsExpression = Ze;
            function Sr(jr) {
              return jr.kind === 230;
            }
            e2.isNonNullExpression = Sr;
            function zr(jr) {
              return jr.kind === 231;
            }
            e2.isMetaProperty = zr;
            function Wr(jr) {
              return jr.kind === 232;
            }
            e2.isSyntheticExpression = Wr;
            function Je(jr) {
              return jr.kind === 350;
            }
            e2.isPartiallyEmittedExpression = Je;
            function xe(jr) {
              return jr.kind === 351;
            }
            e2.isCommaListExpression = xe;
            function vr(jr) {
              return jr.kind === 233;
            }
            e2.isTemplateSpan = vr;
            function mr(jr) {
              return jr.kind === 234;
            }
            e2.isSemicolonClassElement = mr;
            function Ar(jr) {
              return jr.kind === 235;
            }
            e2.isBlock = Ar;
            function Oe(jr) {
              return jr.kind === 237;
            }
            e2.isVariableStatement = Oe;
            function nr(jr) {
              return jr.kind === 236;
            }
            e2.isEmptyStatement = nr;
            function Mr(jr) {
              return jr.kind === 238;
            }
            e2.isExpressionStatement = Mr;
            function Pe(jr) {
              return jr.kind === 239;
            }
            e2.isIfStatement = Pe;
            function Ue(jr) {
              return jr.kind === 240;
            }
            e2.isDoStatement = Ue;
            function fr(jr) {
              return jr.kind === 241;
            }
            e2.isWhileStatement = fr;
            function De(jr) {
              return jr.kind === 242;
            }
            e2.isForStatement = De;
            function gr(jr) {
              return jr.kind === 243;
            }
            e2.isForInStatement = gr;
            function Vr(jr) {
              return jr.kind === 244;
            }
            e2.isForOfStatement = Vr;
            function Tr(jr) {
              return jr.kind === 245;
            }
            e2.isContinueStatement = Tr;
            function vi(jr) {
              return jr.kind === 246;
            }
            e2.isBreakStatement = vi;
            function Ui(jr) {
              return jr.kind === 247;
            }
            e2.isReturnStatement = Ui;
            function Yi(jr) {
              return jr.kind === 248;
            }
            e2.isWithStatement = Yi;
            function Wi(jr) {
              return jr.kind === 249;
            }
            e2.isSwitchStatement = Wi;
            function ct(jr) {
              return jr.kind === 250;
            }
            e2.isLabeledStatement = ct;
            function Li(jr) {
              return jr.kind === 251;
            }
            e2.isThrowStatement = Li;
            function nt(jr) {
              return jr.kind === 252;
            }
            e2.isTryStatement = nt;
            function Mt(jr) {
              return jr.kind === 253;
            }
            e2.isDebuggerStatement = Mt;
            function xt(jr) {
              return jr.kind === 254;
            }
            e2.isVariableDeclaration = xt;
            function ut(jr) {
              return jr.kind === 255;
            }
            e2.isVariableDeclarationList = ut;
            function Dt(jr) {
              return jr.kind === 256;
            }
            e2.isFunctionDeclaration = Dt;
            function Rt(jr) {
              return jr.kind === 257;
            }
            e2.isClassDeclaration = Rt;
            function Ii(jr) {
              return jr.kind === 258;
            }
            e2.isInterfaceDeclaration = Ii;
            function Ki(jr) {
              return jr.kind === 259;
            }
            e2.isTypeAliasDeclaration = Ki;
            function Fi(jr) {
              return jr.kind === 260;
            }
            e2.isEnumDeclaration = Fi;
            function ui(jr) {
              return jr.kind === 261;
            }
            e2.isModuleDeclaration = ui;
            function Bt(jr) {
              return jr.kind === 262;
            }
            e2.isModuleBlock = Bt;
            function wt(jr) {
              return jr.kind === 263;
            }
            e2.isCaseBlock = wt;
            function na(jr) {
              return jr.kind === 264;
            }
            e2.isNamespaceExportDeclaration = na;
            function Ai(jr) {
              return jr.kind === 265;
            }
            e2.isImportEqualsDeclaration = Ai;
            function Oi(jr) {
              return jr.kind === 266;
            }
            e2.isImportDeclaration = Oi;
            function ji(jr) {
              return jr.kind === 267;
            }
            e2.isImportClause = ji;
            function Vi(jr) {
              return jr.kind === 293;
            }
            e2.isAssertClause = Vi;
            function at(jr) {
              return jr.kind === 294;
            }
            e2.isAssertEntry = at;
            function At(jr) {
              return jr.kind === 268;
            }
            e2.isNamespaceImport = At;
            function ba(jr) {
              return jr.kind === 274;
            }
            e2.isNamespaceExport = ba;
            function $a(jr) {
              return jr.kind === 269;
            }
            e2.isNamedImports = $a;
            function Qa(jr) {
              return jr.kind === 270;
            }
            e2.isImportSpecifier = Qa;
            function ai(jr) {
              return jr.kind === 271;
            }
            e2.isExportAssignment = ai;
            function Dn(jr) {
              return jr.kind === 272;
            }
            e2.isExportDeclaration = Dn;
            function ka(jr) {
              return jr.kind === 273;
            }
            e2.isNamedExports = ka;
            function Ba(jr) {
              return jr.kind === 275;
            }
            e2.isExportSpecifier = Ba;
            function pn(jr) {
              return jr.kind === 276;
            }
            e2.isMissingDeclaration = pn;
            function Cn(jr) {
              return jr.kind === 349;
            }
            e2.isNotEmittedStatement = Cn;
            function Bi(jr) {
              return jr.kind === 354;
            }
            e2.isSyntheticReference = Bi;
            function kn(jr) {
              return jr.kind === 352;
            }
            e2.isMergeDeclarationMarker = kn;
            function xn(jr) {
              return jr.kind === 353;
            }
            e2.isEndOfDeclarationMarker = xn;
            function Kn(jr) {
              return jr.kind === 277;
            }
            e2.isExternalModuleReference = Kn;
            function Pn(jr) {
              return jr.kind === 278;
            }
            e2.isJsxElement = Pn;
            function eo(jr) {
              return jr.kind === 279;
            }
            e2.isJsxSelfClosingElement = eo;
            function Rn(jr) {
              return jr.kind === 280;
            }
            e2.isJsxOpeningElement = Rn;
            function Da(jr) {
              return jr.kind === 281;
            }
            e2.isJsxClosingElement = Da;
            function bo(jr) {
              return jr.kind === 282;
            }
            e2.isJsxFragment = bo;
            function Ro(jr) {
              return jr.kind === 283;
            }
            e2.isJsxOpeningFragment = Ro;
            function En(jr) {
              return jr.kind === 284;
            }
            e2.isJsxClosingFragment = En;
            function Wn(jr) {
              return jr.kind === 285;
            }
            e2.isJsxAttribute = Wn;
            function to(jr) {
              return jr.kind === 286;
            }
            e2.isJsxAttributes = to;
            function Co(jr) {
              return jr.kind === 287;
            }
            e2.isJsxSpreadAttribute = Co;
            function Ko(jr) {
              return jr.kind === 288;
            }
            e2.isJsxExpression = Ko;
            function Oo(jr) {
              return jr.kind === 289;
            }
            e2.isCaseClause = Oo;
            function no(jr) {
              return jr.kind === 290;
            }
            e2.isDefaultClause = no;
            function $o(jr) {
              return jr.kind === 291;
            }
            e2.isHeritageClause = $o;
            function Pr(jr) {
              return jr.kind === 292;
            }
            e2.isCatchClause = Pr;
            function xi(jr) {
              return jr.kind === 296;
            }
            e2.isPropertyAssignment = xi;
            function St(jr) {
              return jr.kind === 297;
            }
            e2.isShorthandPropertyAssignment = St;
            function pa(jr) {
              return jr.kind === 298;
            }
            e2.isSpreadAssignment = pa;
            function dn(jr) {
              return jr.kind === 299;
            }
            e2.isEnumMember = dn;
            function Jn(jr) {
              return jr.kind === 301;
            }
            e2.isUnparsedPrepend = Jn;
            function Qe(jr) {
              return jr.kind === 305;
            }
            e2.isSourceFile = Qe;
            function Gr(jr) {
              return jr.kind === 306;
            }
            e2.isBundle = Gr;
            function S2(jr) {
              return jr.kind === 307;
            }
            e2.isUnparsedSource = S2;
            function Ce(jr) {
              return jr.kind === 309;
            }
            e2.isJSDocTypeExpression = Ce;
            function qe(jr) {
              return jr.kind === 310;
            }
            e2.isJSDocNameReference = qe;
            function br(jr) {
              return jr.kind === 311;
            }
            e2.isJSDocMemberName = br;
            function Zr(jr) {
              return jr.kind === 324;
            }
            e2.isJSDocLink = Zr;
            function Si(jr) {
              return jr.kind === 325;
            }
            e2.isJSDocLinkCode = Si;
            function Pi(jr) {
              return jr.kind === 326;
            }
            e2.isJSDocLinkPlain = Pi;
            function Qi(jr) {
              return jr.kind === 312;
            }
            e2.isJSDocAllType = Qi;
            function Ct(jr) {
              return jr.kind === 313;
            }
            e2.isJSDocUnknownType = Ct;
            function sa(jr) {
              return jr.kind === 314;
            }
            e2.isJSDocNullableType = sa;
            function en(jr) {
              return jr.kind === 315;
            }
            e2.isJSDocNonNullableType = en;
            function Wa(jr) {
              return jr.kind === 316;
            }
            e2.isJSDocOptionalType = Wa;
            function qn(jr) {
              return jr.kind === 317;
            }
            e2.isJSDocFunctionType = qn;
            function mo(jr) {
              return jr.kind === 318;
            }
            e2.isJSDocVariadicType = mo;
            function So(jr) {
              return jr.kind === 319;
            }
            e2.isJSDocNamepathType = So;
            function Go(jr) {
              return jr.kind === 320;
            }
            e2.isJSDoc = Go;
            function ys(jr) {
              return jr.kind === 322;
            }
            e2.isJSDocTypeLiteral = ys;
            function Pc(jr) {
              return jr.kind === 323;
            }
            e2.isJSDocSignature = Pc;
            function Vc(jr) {
              return jr.kind === 328;
            }
            e2.isJSDocAugmentsTag = Vc;
            function Kc(jr) {
              return jr.kind === 330;
            }
            e2.isJSDocAuthorTag = Kc;
            function Xs(jr) {
              return jr.kind === 332;
            }
            e2.isJSDocClassTag = Xs;
            function pc(jr) {
              return jr.kind === 338;
            }
            e2.isJSDocCallbackTag = pc;
            function hs(jr) {
              return jr.kind === 333;
            }
            e2.isJSDocPublicTag = hs;
            function tc(jr) {
              return jr.kind === 334;
            }
            e2.isJSDocPrivateTag = tc;
            function ps(jr) {
              return jr.kind === 335;
            }
            e2.isJSDocProtectedTag = ps;
            function Qs(jr) {
              return jr.kind === 336;
            }
            e2.isJSDocReadonlyTag = Qs;
            function js(jr) {
              return jr.kind === 337;
            }
            e2.isJSDocOverrideTag = js;
            function ds(jr) {
              return jr.kind === 331;
            }
            e2.isJSDocDeprecatedTag = ds;
            function Ji(jr) {
              return jr.kind === 346;
            }
            e2.isJSDocSeeTag = Ji;
            function ce(jr) {
              return jr.kind === 339;
            }
            e2.isJSDocEnumTag = ce;
            function Rr(jr) {
              return jr.kind === 340;
            }
            e2.isJSDocParameterTag = Rr;
            function yi(jr) {
              return jr.kind === 341;
            }
            e2.isJSDocReturnTag = yi;
            function qi(jr) {
              return jr.kind === 342;
            }
            e2.isJSDocThisTag = qi;
            function je(jr) {
              return jr.kind === 343;
            }
            e2.isJSDocTypeTag = je;
            function Hr(jr) {
              return jr.kind === 344;
            }
            e2.isJSDocTemplateTag = Hr;
            function pt(jr) {
              return jr.kind === 345;
            }
            e2.isJSDocTypedefTag = pt;
            function Pt(jr) {
              return jr.kind === 327;
            }
            e2.isJSDocUnknownTag = Pt;
            function ga(jr) {
              return jr.kind === 347;
            }
            e2.isJSDocPropertyTag = ga;
            function ua(jr) {
              return jr.kind === 329;
            }
            e2.isJSDocImplementsTag = ua;
            function Xn(jr) {
              return jr.kind === 348;
            }
            e2.isSyntaxList = Xn;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(lr) {
              return lr.createExportDeclaration(void 0, void 0, false, lr.createNamedExports([]), void 0);
            }
            e2.createEmptyExports = a;
            function C(lr, be, Ge, ur) {
              if (e2.isComputedPropertyName(Ge))
                return e2.setTextRange(lr.createElementAccessExpression(be, Ge.expression), ur);
              var yr = e2.setTextRange(e2.isMemberName(Ge) ? lr.createPropertyAccessExpression(be, Ge) : lr.createElementAccessExpression(be, Ge), Ge);
              return e2.getOrCreateEmitNode(yr).flags |= 64, yr;
            }
            e2.createMemberAccessForPropertyName = C;
            function w(lr, be) {
              var Ge = e2.parseNodeFactory.createIdentifier(lr || "React");
              return e2.setParent(Ge, e2.getParseTreeNode(be)), Ge;
            }
            function B(lr, be, Ge) {
              if (e2.isQualifiedName(be)) {
                var ur = B(lr, be.left, Ge), yr = lr.createIdentifier(e2.idText(be.right));
                return yr.escapedText = be.right.escapedText, lr.createPropertyAccessExpression(ur, yr);
              } else
                return w(e2.idText(be), Ge);
            }
            function E(lr, be, Ge, ur) {
              return be ? B(lr, be, ur) : lr.createPropertyAccessExpression(w(Ge, ur), "createElement");
            }
            e2.createJsxFactoryExpression = E;
            function Q(lr, be, Ge, ur) {
              return be ? B(lr, be, ur) : lr.createPropertyAccessExpression(w(Ge, ur), "Fragment");
            }
            function le(lr, be, Ge, ur, yr, Ir) {
              var wr = [Ge];
              if (ur && wr.push(ur), yr && yr.length > 0)
                if (ur || wr.push(lr.createNull()), yr.length > 1)
                  for (var Ur = 0, ii = yr; Ur < ii.length; Ur++) {
                    var mi = ii[Ur];
                    y(mi), wr.push(mi);
                  }
                else
                  wr.push(yr[0]);
              return e2.setTextRange(lr.createCallExpression(be, void 0, wr), Ir);
            }
            e2.createExpressionForJsxElement = le;
            function N(lr, be, Ge, ur, yr, Ir, wr) {
              var Ur = Q(lr, Ge, ur, Ir), ii = [Ur, lr.createNull()];
              if (yr && yr.length > 0)
                if (yr.length > 1)
                  for (var mi = 0, pe = yr; mi < pe.length; mi++) {
                    var or = pe[mi];
                    y(or), ii.push(or);
                  }
                else
                  ii.push(yr[0]);
              return e2.setTextRange(lr.createCallExpression(E(lr, be, ur, Ir), void 0, ii), wr);
            }
            e2.createExpressionForJsxFragment = N;
            function p(lr, be, Ge) {
              if (e2.isVariableDeclarationList(be)) {
                var ur = e2.first(be.declarations), yr = lr.updateVariableDeclaration(ur, ur.name, void 0, void 0, Ge);
                return e2.setTextRange(lr.createVariableStatement(void 0, lr.updateVariableDeclarationList(be, [yr])), be);
              } else {
                var Ir = e2.setTextRange(lr.createAssignment(be, Ge), be);
                return e2.setTextRange(lr.createExpressionStatement(Ir), be);
              }
            }
            e2.createForOfBindingStatement = p;
            function m2(lr, be, Ge) {
              return e2.isBlock(be) ? lr.updateBlock(be, e2.setTextRange(lr.createNodeArray(Ve([Ge], be.statements, true)), be.statements)) : lr.createBlock(lr.createNodeArray([be, Ge]), true);
            }
            e2.insertLeadingStatement = m2;
            function G(lr, be) {
              if (e2.isQualifiedName(be)) {
                var Ge = G(lr, be.left), ur = e2.setParent(e2.setTextRange(lr.cloneNode(be.right), be.right), be.right.parent);
                return e2.setTextRange(lr.createPropertyAccessExpression(Ge, ur), be);
              } else
                return e2.setParent(e2.setTextRange(lr.cloneNode(be), be), be.parent);
            }
            e2.createExpressionFromEntityName = G;
            function oe(lr, be) {
              return e2.isIdentifier(be) ? lr.createStringLiteralFromNode(be) : e2.isComputedPropertyName(be) ? e2.setParent(e2.setTextRange(lr.cloneNode(be.expression), be.expression), be.expression.parent) : e2.setParent(e2.setTextRange(lr.cloneNode(be), be), be.parent);
            }
            e2.createExpressionForPropertyName = oe;
            function f4(lr, be, Ge, ur, yr) {
              var Ir = e2.getAllAccessorDeclarations(be, Ge), wr = Ir.firstAccessor, Ur = Ir.getAccessor, ii = Ir.setAccessor;
              if (Ge === wr)
                return e2.setTextRange(lr.createObjectDefinePropertyCall(ur, oe(lr, Ge.name), lr.createPropertyDescriptor({ enumerable: lr.createFalse(), configurable: true, get: Ur && e2.setTextRange(e2.setOriginalNode(lr.createFunctionExpression(Ur.modifiers, void 0, void 0, void 0, Ur.parameters, void 0, Ur.body), Ur), Ur), set: ii && e2.setTextRange(e2.setOriginalNode(lr.createFunctionExpression(ii.modifiers, void 0, void 0, void 0, ii.parameters, void 0, ii.body), ii), ii) }, !yr)), wr);
            }
            function T(lr, be, Ge) {
              return e2.setOriginalNode(e2.setTextRange(lr.createAssignment(C(lr, Ge, be.name, be.name), be.initializer), be), be);
            }
            function K(lr, be, Ge) {
              return e2.setOriginalNode(e2.setTextRange(lr.createAssignment(C(lr, Ge, be.name, be.name), lr.cloneNode(be.name)), be), be);
            }
            function b(lr, be, Ge) {
              return e2.setOriginalNode(e2.setTextRange(lr.createAssignment(C(lr, Ge, be.name, be.name), e2.setOriginalNode(e2.setTextRange(lr.createFunctionExpression(be.modifiers, be.asteriskToken, void 0, void 0, be.parameters, void 0, be.body), be), be)), be), be);
            }
            function se(lr, be, Ge, ur) {
              switch (Ge.name && e2.isPrivateIdentifier(Ge.name) && e2.Debug.failBadSyntaxKind(Ge.name, "Private identifiers are not allowed in object literals."), Ge.kind) {
                case 172:
                case 173:
                  return f4(lr, be.properties, Ge, ur, !!be.multiLine);
                case 296:
                  return T(lr, Ge, ur);
                case 297:
                  return K(lr, Ge, ur);
                case 169:
                  return b(lr, Ge, ur);
              }
            }
            e2.createExpressionForObjectLiteralElementLike = se;
            function J(lr, be, Ge, ur, yr) {
              var Ir = be.operator;
              e2.Debug.assert(Ir === 45 || Ir === 46, "Expected 'node' to be a pre- or post-increment or pre- or post-decrement expression");
              var wr = lr.createTempVariable(ur);
              Ge = lr.createAssignment(wr, Ge), e2.setTextRange(Ge, be.operand);
              var Ur = e2.isPrefixUnaryExpression(be) ? lr.createPrefixUnaryExpression(Ir, wr) : lr.createPostfixUnaryExpression(wr, Ir);
              return e2.setTextRange(Ur, be), yr && (Ur = lr.createAssignment(yr, Ur), e2.setTextRange(Ur, be)), Ge = lr.createComma(Ge, Ur), e2.setTextRange(Ge, be), e2.isPostfixUnaryExpression(be) && (Ge = lr.createComma(Ge, wr), e2.setTextRange(Ge, be)), Ge;
            }
            e2.expandPreOrPostfixIncrementOrDecrementExpression = J;
            function ie(lr) {
              return (e2.getEmitFlags(lr) & 32768) !== 0;
            }
            e2.isInternalName = ie;
            function R(lr) {
              return (e2.getEmitFlags(lr) & 16384) !== 0;
            }
            e2.isLocalName = R;
            function q(lr) {
              return (e2.getEmitFlags(lr) & 8192) !== 0;
            }
            e2.isExportName = q;
            function O(lr) {
              return e2.isStringLiteral(lr.expression) && lr.expression.text === "use strict";
            }
            function ve(lr) {
              for (var be = 0, Ge = lr; be < Ge.length; be++) {
                var ur = Ge[be];
                if (e2.isPrologueDirective(ur)) {
                  if (O(ur))
                    return ur;
                } else
                  break;
              }
            }
            e2.findUseStrictPrologue = ve;
            function ee(lr) {
              var be = e2.firstOrUndefined(lr);
              return be !== void 0 && e2.isPrologueDirective(be) && O(be);
            }
            e2.startsWithUseStrict = ee;
            function he(lr) {
              return lr.kind === 221 && lr.operatorToken.kind === 27 || lr.kind === 351;
            }
            e2.isCommaSequence = he;
            function F2(lr) {
              return e2.isParenthesizedExpression(lr) && e2.isInJSFile(lr) && !!e2.getJSDocTypeTag(lr);
            }
            e2.isJSDocTypeAssertion = F2;
            function x2(lr) {
              var be = e2.getJSDocType(lr);
              return e2.Debug.assertIsDefined(be), be;
            }
            e2.getJSDocTypeAssertionType = x2;
            function X(lr, be) {
              switch (be === void 0 && (be = 15), lr.kind) {
                case 212:
                  return be & 16 && F2(lr) ? false : (be & 1) !== 0;
                case 211:
                case 229:
                  return (be & 2) !== 0;
                case 230:
                  return (be & 4) !== 0;
                case 350:
                  return (be & 8) !== 0;
              }
              return false;
            }
            e2.isOuterExpression = X;
            function $(lr, be) {
              for (be === void 0 && (be = 15); X(lr, be); )
                lr = lr.expression;
              return lr;
            }
            e2.skipOuterExpressions = $;
            function A2(lr) {
              return $(lr, 6);
            }
            e2.skipAssertions = A2;
            function y(lr) {
              return e2.setStartsOnNewLine(lr, true);
            }
            e2.startOnNewLine = y;
            function V(lr) {
              var be = e2.getOriginalNode(lr, e2.isSourceFile), Ge = be && be.emitNode;
              return Ge && Ge.externalHelpersModuleName;
            }
            e2.getExternalHelpersModuleName = V;
            function L(lr) {
              var be = e2.getOriginalNode(lr, e2.isSourceFile), Ge = be && be.emitNode;
              return !!Ge && (!!Ge.externalHelpersModuleName || !!Ge.externalHelpers);
            }
            e2.hasRecordedExternalHelpers = L;
            function P(lr, be, Ge, ur, yr, Ir, wr) {
              if (ur.importHelpers && e2.isEffectiveExternalModule(Ge, ur)) {
                var Ur = void 0, ii = e2.getEmitModuleKind(ur);
                if (ii >= e2.ModuleKind.ES2015 && ii <= e2.ModuleKind.ESNext || Ge.impliedNodeFormat === e2.ModuleKind.ESNext) {
                  var mi = e2.getEmitHelpers(Ge);
                  if (mi) {
                    for (var pe = [], or = 0, qr = mi; or < qr.length; or++) {
                      var si = qr[or];
                      if (!si.scoped) {
                        var Di = si.importName;
                        Di && e2.pushIfUnique(pe, Di);
                      }
                    }
                    if (e2.some(pe)) {
                      pe.sort(e2.compareStringsCaseSensitive), Ur = lr.createNamedImports(e2.map(pe, function(Wt) {
                        return e2.isFileLevelUniqueName(Ge, Wt) ? lr.createImportSpecifier(false, void 0, lr.createIdentifier(Wt)) : lr.createImportSpecifier(false, lr.createIdentifier(Wt), be.getUnscopedHelperName(Wt));
                      }));
                      var wi = e2.getOriginalNode(Ge, e2.isSourceFile), Xi = e2.getOrCreateEmitNode(wi);
                      Xi.externalHelpers = true;
                    }
                  }
                } else {
                  var et = k(lr, Ge, ur, yr, Ir || wr);
                  et && (Ur = lr.createNamespaceImport(et));
                }
                if (Ur) {
                  var Gi = lr.createImportDeclaration(void 0, void 0, lr.createImportClause(false, void 0, Ur), lr.createStringLiteral(e2.externalHelpersModuleNameText), void 0);
                  return e2.addEmitFlags(Gi, 67108864), Gi;
                }
              }
            }
            e2.createExternalHelpersImportDeclarationIfNeeded = P;
            function k(lr, be, Ge, ur, yr) {
              if (Ge.importHelpers && e2.isEffectiveExternalModule(be, Ge)) {
                var Ir = V(be);
                if (Ir)
                  return Ir;
                var wr = e2.getEmitModuleKind(Ge), Ur = (ur || e2.getESModuleInterop(Ge) && yr) && wr !== e2.ModuleKind.System && (wr < e2.ModuleKind.ES2015 || be.impliedNodeFormat === e2.ModuleKind.CommonJS);
                if (!Ur) {
                  var ii = e2.getEmitHelpers(be);
                  if (ii)
                    for (var mi = 0, pe = ii; mi < pe.length; mi++) {
                      var or = pe[mi];
                      if (!or.scoped) {
                        Ur = true;
                        break;
                      }
                    }
                }
                if (Ur) {
                  var qr = e2.getOriginalNode(be, e2.isSourceFile), si = e2.getOrCreateEmitNode(qr);
                  return si.externalHelpersModuleName || (si.externalHelpersModuleName = lr.createUniqueName(e2.externalHelpersModuleNameText));
                }
              }
            }
            e2.getOrCreateExternalHelpersModuleNameIfNeeded = k;
            function Y(lr, be, Ge) {
              var ur = e2.getNamespaceDeclarationNode(be);
              if (ur && !e2.isDefaultImport(be) && !e2.isExportNamespaceAsDefaultDeclaration(be)) {
                var yr = ur.name;
                return e2.isGeneratedIdentifier(yr) ? yr : lr.createIdentifier(e2.getSourceTextOfNodeFromSourceFile(Ge, yr) || e2.idText(yr));
              }
              if (be.kind === 266 && be.importClause || be.kind === 272 && be.moduleSpecifier)
                return lr.getGeneratedNameForNode(be);
            }
            e2.getLocalNameForExternalImport = Y;
            function U(lr, be, Ge, ur, yr, Ir) {
              var wr = e2.getExternalModuleName(be);
              if (wr && e2.isStringLiteral(wr))
                return I(be, ur, lr, yr, Ir) || j(lr, wr, Ge) || lr.cloneNode(wr);
            }
            e2.getExternalModuleNameLiteral = U;
            function j(lr, be, Ge) {
              var ur = Ge.renamedDependencies && Ge.renamedDependencies.get(be.text);
              return ur ? lr.createStringLiteral(ur) : void 0;
            }
            function H(lr, be, Ge, ur) {
              if (!!be) {
                if (be.moduleName)
                  return lr.createStringLiteral(be.moduleName);
                if (!be.isDeclarationFile && e2.outFile(ur))
                  return lr.createStringLiteral(e2.getExternalModuleNameFromPath(Ge, be.fileName));
              }
            }
            e2.tryGetModuleNameFromFile = H;
            function I(lr, be, Ge, ur, yr) {
              return H(Ge, ur.getExternalModuleFileFromDeclaration(lr), be, yr);
            }
            function l(lr) {
              if (e2.isDeclarationBindingElement(lr))
                return lr.initializer;
              if (e2.isPropertyAssignment(lr)) {
                var be = lr.initializer;
                return e2.isAssignmentExpression(be, true) ? be.right : void 0;
              }
              if (e2.isShorthandPropertyAssignment(lr))
                return lr.objectAssignmentInitializer;
              if (e2.isAssignmentExpression(lr, true))
                return lr.right;
              if (e2.isSpreadElement(lr))
                return l(lr.expression);
            }
            e2.getInitializerOfBindingOrAssignmentElement = l;
            function d(lr) {
              if (e2.isDeclarationBindingElement(lr))
                return lr.name;
              if (e2.isObjectLiteralElementLike(lr)) {
                switch (lr.kind) {
                  case 296:
                    return d(lr.initializer);
                  case 297:
                    return lr.name;
                  case 298:
                    return d(lr.expression);
                }
                return;
              }
              return e2.isAssignmentExpression(lr, true) ? d(lr.left) : e2.isSpreadElement(lr) ? d(lr.expression) : lr;
            }
            e2.getTargetOfBindingOrAssignmentElement = d;
            function D(lr) {
              switch (lr.kind) {
                case 164:
                case 203:
                  return lr.dotDotDotToken;
                case 225:
                case 298:
                  return lr;
              }
            }
            e2.getRestIndicatorOfBindingOrAssignmentElement = D;
            function fe(lr) {
              var be = g(lr);
              return e2.Debug.assert(!!be || e2.isSpreadAssignment(lr), "Invalid property name for binding element."), be;
            }
            e2.getPropertyNameOfBindingOrAssignmentElement = fe;
            function g(lr) {
              switch (lr.kind) {
                case 203:
                  if (lr.propertyName) {
                    var be = lr.propertyName;
                    return e2.isPrivateIdentifier(be) ? e2.Debug.failBadSyntaxKind(be) : e2.isComputedPropertyName(be) && ne(be.expression) ? be.expression : be;
                  }
                  break;
                case 296:
                  if (lr.name) {
                    var be = lr.name;
                    return e2.isPrivateIdentifier(be) ? e2.Debug.failBadSyntaxKind(be) : e2.isComputedPropertyName(be) && ne(be.expression) ? be.expression : be;
                  }
                  break;
                case 298:
                  return lr.name && e2.isPrivateIdentifier(lr.name) ? e2.Debug.failBadSyntaxKind(lr.name) : lr.name;
              }
              var Ge = d(lr);
              if (Ge && e2.isPropertyName(Ge))
                return Ge;
            }
            e2.tryGetPropertyNameOfBindingOrAssignmentElement = g;
            function ne(lr) {
              var be = lr.kind;
              return be === 10 || be === 8;
            }
            function ue(lr) {
              switch (lr.kind) {
                case 201:
                case 202:
                case 204:
                  return lr.elements;
                case 205:
                  return lr.properties;
              }
            }
            e2.getElementsOfBindingOrAssignmentPattern = ue;
            function We(lr) {
              if (lr)
                for (var be = lr; ; ) {
                  if (e2.isIdentifier(be) || !be.body)
                    return e2.isIdentifier(be) ? be : be.name;
                  be = be.body;
                }
            }
            e2.getJSDocTypeAliasName = We;
            function Fe(lr) {
              var be = lr.kind;
              return be === 164 || be === 166 || be === 167 || be === 168 || be === 169 || be === 171 || be === 172 || be === 173 || be === 176 || be === 213 || be === 214 || be === 226 || be === 237 || be === 256 || be === 257 || be === 258 || be === 259 || be === 260 || be === 261 || be === 265 || be === 266 || be === 271 || be === 272;
            }
            e2.canHaveModifiers = Fe, e2.isTypeNodeOrTypeParameterDeclaration = e2.or(e2.isTypeNode, e2.isTypeParameterDeclaration), e2.isQuestionOrExclamationToken = e2.or(e2.isQuestionToken, e2.isExclamationToken), e2.isIdentifierOrThisTypeNode = e2.or(e2.isIdentifier, e2.isThisTypeNode), e2.isReadonlyKeywordOrPlusOrMinusToken = e2.or(e2.isReadonlyKeyword, e2.isPlusToken, e2.isMinusToken), e2.isQuestionOrPlusOrMinusToken = e2.or(e2.isQuestionToken, e2.isPlusToken, e2.isMinusToken), e2.isModuleName = e2.or(e2.isIdentifier, e2.isStringLiteral);
            function Z2(lr) {
              var be = lr.kind;
              return be === 104 || be === 110 || be === 95 || e2.isLiteralExpression(lr) || e2.isPrefixUnaryExpression(lr);
            }
            e2.isLiteralTypeLikeExpression = Z2;
            function Be(lr) {
              return lr === 42;
            }
            function ge(lr) {
              return lr === 41 || lr === 43 || lr === 44;
            }
            function Re(lr) {
              return Be(lr) || ge(lr);
            }
            function ze(lr) {
              return lr === 39 || lr === 40;
            }
            function Ee(lr) {
              return ze(lr) || Re(lr);
            }
            function He(lr) {
              return lr === 47 || lr === 48 || lr === 49;
            }
            function rr(lr) {
              return He(lr) || Ee(lr);
            }
            function Ie(lr) {
              return lr === 29 || lr === 32 || lr === 31 || lr === 33 || lr === 102 || lr === 101;
            }
            function _e(lr) {
              return Ie(lr) || rr(lr);
            }
            function we(lr) {
              return lr === 34 || lr === 36 || lr === 35 || lr === 37;
            }
            function de(lr) {
              return we(lr) || _e(lr);
            }
            function ye(lr) {
              return lr === 50 || lr === 51 || lr === 52;
            }
            function Ae(lr) {
              return ye(lr) || de(lr);
            }
            function er(lr) {
              return lr === 55 || lr === 56;
            }
            function ir(lr) {
              return er(lr) || Ae(lr);
            }
            function Cr(lr) {
              return lr === 60 || ir(lr) || e2.isAssignmentOperator(lr);
            }
            function Ye(lr) {
              return Cr(lr) || lr === 27;
            }
            function Br(lr) {
              return Ye(lr.kind);
            }
            e2.isBinaryOperatorToken = Br;
            var Er;
            (function(lr) {
              function be(pe, or, qr, si, Di, wi, Xi) {
                var et = or > 0 ? Di[or - 1] : void 0;
                return e2.Debug.assertEqual(qr[or], be), Di[or] = pe.onEnter(si[or], et, Xi), qr[or] = Ur(pe, be), or;
              }
              lr.enter = be;
              function Ge(pe, or, qr, si, Di, wi, Xi) {
                e2.Debug.assertEqual(qr[or], Ge), e2.Debug.assertIsDefined(pe.onLeft), qr[or] = Ur(pe, Ge);
                var et = pe.onLeft(si[or].left, Di[or], si[or]);
                return et ? (mi(or, si, et), ii(or, qr, si, Di, et)) : or;
              }
              lr.left = Ge;
              function ur(pe, or, qr, si, Di, wi, Xi) {
                return e2.Debug.assertEqual(qr[or], ur), e2.Debug.assertIsDefined(pe.onOperator), qr[or] = Ur(pe, ur), pe.onOperator(si[or].operatorToken, Di[or], si[or]), or;
              }
              lr.operator = ur;
              function yr(pe, or, qr, si, Di, wi, Xi) {
                e2.Debug.assertEqual(qr[or], yr), e2.Debug.assertIsDefined(pe.onRight), qr[or] = Ur(pe, yr);
                var et = pe.onRight(si[or].right, Di[or], si[or]);
                return et ? (mi(or, si, et), ii(or, qr, si, Di, et)) : or;
              }
              lr.right = yr;
              function Ir(pe, or, qr, si, Di, wi, Xi) {
                e2.Debug.assertEqual(qr[or], Ir), qr[or] = Ur(pe, Ir);
                var et = pe.onExit(si[or], Di[or]);
                if (or > 0) {
                  if (or--, pe.foldState) {
                    var Gi = qr[or] === Ir ? "right" : "left";
                    Di[or] = pe.foldState(Di[or], et, Gi);
                  }
                } else
                  wi.value = et;
                return or;
              }
              lr.exit = Ir;
              function wr(pe, or, qr, si, Di, wi, Xi) {
                return e2.Debug.assertEqual(qr[or], wr), or;
              }
              lr.done = wr;
              function Ur(pe, or) {
                switch (or) {
                  case be:
                    if (pe.onLeft)
                      return Ge;
                  case Ge:
                    if (pe.onOperator)
                      return ur;
                  case ur:
                    if (pe.onRight)
                      return yr;
                  case yr:
                    return Ir;
                  case Ir:
                    return wr;
                  case wr:
                    return wr;
                  default:
                    e2.Debug.fail("Invalid state");
                }
              }
              lr.nextState = Ur;
              function ii(pe, or, qr, si, Di) {
                return pe++, or[pe] = be, qr[pe] = Di, si[pe] = void 0, pe;
              }
              function mi(pe, or, qr) {
                if (e2.Debug.shouldAssert(2))
                  for (; pe >= 0; )
                    e2.Debug.assert(or[pe] !== qr, "Circular traversal detected."), pe--;
              }
            })(Er || (Er = {}));
            var Ne = function() {
              function lr(be, Ge, ur, yr, Ir, wr) {
                this.onEnter = be, this.onLeft = Ge, this.onOperator = ur, this.onRight = yr, this.onExit = Ir, this.foldState = wr;
              }
              return lr;
            }();
            function n(lr, be, Ge, ur, yr, Ir) {
              var wr = new Ne(lr, be, Ge, ur, yr, Ir);
              return Ur;
              function Ur(ii, mi) {
                for (var pe = { value: void 0 }, or = [Er.enter], qr = [ii], si = [void 0], Di = 0; or[Di] !== Er.done; )
                  Di = or[Di](wr, Di, or, qr, si, pe, mi);
                return e2.Debug.assertEqual(Di, 0), pe.value;
              }
            }
            e2.createBinaryExpressionTrampoline = n;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C, w) {
              return w ? e2.setTextRangePosEnd(C, w.pos, w.end) : C;
            }
            e2.setTextRange = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(d) {
              d[d.None = 0] = "None", d[d.Yield = 1] = "Yield", d[d.Await = 2] = "Await", d[d.Type = 4] = "Type", d[d.IgnoreMissingOpenBrace = 16] = "IgnoreMissingOpenBrace", d[d.JSDoc = 32] = "JSDoc";
            })(a || (a = {}));
            var C;
            (function(d) {
              d[d.TryParse = 0] = "TryParse", d[d.Lookahead = 1] = "Lookahead", d[d.Reparse = 2] = "Reparse";
            })(C || (C = {}));
            var w, B, E, Q, le;
            e2.parseBaseNodeFactory = { createBaseSourceFileNode: function(d) {
              return new (le || (le = e2.objectAllocator.getSourceFileConstructor()))(d, -1, -1);
            }, createBaseIdentifierNode: function(d) {
              return new (E || (E = e2.objectAllocator.getIdentifierConstructor()))(d, -1, -1);
            }, createBasePrivateIdentifierNode: function(d) {
              return new (Q || (Q = e2.objectAllocator.getPrivateIdentifierConstructor()))(d, -1, -1);
            }, createBaseTokenNode: function(d) {
              return new (B || (B = e2.objectAllocator.getTokenConstructor()))(d, -1, -1);
            }, createBaseNode: function(d) {
              return new (w || (w = e2.objectAllocator.getNodeConstructor()))(d, -1, -1);
            } }, e2.parseNodeFactory = e2.createNodeFactory(1, e2.parseBaseNodeFactory);
            function N(d, D) {
              return D && d(D);
            }
            function p(d, D, fe) {
              if (fe) {
                if (D)
                  return D(fe);
                for (var g = 0, ne = fe; g < ne.length; g++) {
                  var ue = ne[g], We = d(ue);
                  if (We)
                    return We;
                }
              }
            }
            function m2(d, D) {
              return d.charCodeAt(D + 1) === 42 && d.charCodeAt(D + 2) === 42 && d.charCodeAt(D + 3) !== 47;
            }
            e2.isJSDocLikeText = m2;
            function G(d) {
              return e2.forEach(d.statements, oe) || f4(d);
            }
            e2.isFileProbablyExternalModule = G;
            function oe(d) {
              return K(d, 93) || e2.isImportEqualsDeclaration(d) && e2.isExternalModuleReference(d.moduleReference) || e2.isImportDeclaration(d) || e2.isExportAssignment(d) || e2.isExportDeclaration(d) ? d : void 0;
            }
            function f4(d) {
              return d.flags & 4194304 ? T(d) : void 0;
            }
            function T(d) {
              return b(d) ? d : se(d, T);
            }
            function K(d, D) {
              return e2.some(d.modifiers, function(fe) {
                return fe.kind === D;
              });
            }
            function b(d) {
              return e2.isMetaProperty(d) && d.keywordToken === 100 && d.name.escapedText === "meta";
            }
            function se(d, D, fe) {
              if (!(!d || d.kind <= 160))
                switch (d.kind) {
                  case 161:
                    return N(D, d.left) || N(D, d.right);
                  case 163:
                    return p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.constraint) || N(D, d.default) || N(D, d.expression);
                  case 297:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.questionToken) || N(D, d.exclamationToken) || N(D, d.equalsToken) || N(D, d.objectAssignmentInitializer);
                  case 298:
                    return N(D, d.expression);
                  case 164:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.dotDotDotToken) || N(D, d.name) || N(D, d.questionToken) || N(D, d.type) || N(D, d.initializer);
                  case 167:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.questionToken) || N(D, d.exclamationToken) || N(D, d.type) || N(D, d.initializer);
                  case 166:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.questionToken) || N(D, d.type) || N(D, d.initializer);
                  case 296:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.questionToken) || N(D, d.initializer);
                  case 254:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.exclamationToken) || N(D, d.type) || N(D, d.initializer);
                  case 203:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.dotDotDotToken) || N(D, d.propertyName) || N(D, d.name) || N(D, d.initializer);
                  case 179:
                  case 180:
                  case 174:
                  case 175:
                  case 176:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || p(D, fe, d.typeParameters) || p(D, fe, d.parameters) || N(D, d.type);
                  case 169:
                  case 168:
                  case 171:
                  case 172:
                  case 173:
                  case 213:
                  case 256:
                  case 214:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.asteriskToken) || N(D, d.name) || N(D, d.questionToken) || N(D, d.exclamationToken) || p(D, fe, d.typeParameters) || p(D, fe, d.parameters) || N(D, d.type) || N(D, d.equalsGreaterThanToken) || N(D, d.body);
                  case 170:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.body);
                  case 178:
                    return N(D, d.typeName) || p(D, fe, d.typeArguments);
                  case 177:
                    return N(D, d.assertsModifier) || N(D, d.parameterName) || N(D, d.type);
                  case 181:
                    return N(D, d.exprName) || p(D, fe, d.typeArguments);
                  case 182:
                    return p(D, fe, d.members);
                  case 183:
                    return N(D, d.elementType);
                  case 184:
                    return p(D, fe, d.elements);
                  case 187:
                  case 188:
                    return p(D, fe, d.types);
                  case 189:
                    return N(D, d.checkType) || N(D, d.extendsType) || N(D, d.trueType) || N(D, d.falseType);
                  case 190:
                    return N(D, d.typeParameter);
                  case 200:
                    return N(D, d.argument) || N(D, d.assertions) || N(D, d.qualifier) || p(D, fe, d.typeArguments);
                  case 295:
                    return N(D, d.assertClause);
                  case 191:
                  case 193:
                    return N(D, d.type);
                  case 194:
                    return N(D, d.objectType) || N(D, d.indexType);
                  case 195:
                    return N(D, d.readonlyToken) || N(D, d.typeParameter) || N(D, d.nameType) || N(D, d.questionToken) || N(D, d.type) || p(D, fe, d.members);
                  case 196:
                    return N(D, d.literal);
                  case 197:
                    return N(D, d.dotDotDotToken) || N(D, d.name) || N(D, d.questionToken) || N(D, d.type);
                  case 201:
                  case 202:
                    return p(D, fe, d.elements);
                  case 204:
                    return p(D, fe, d.elements);
                  case 205:
                    return p(D, fe, d.properties);
                  case 206:
                    return N(D, d.expression) || N(D, d.questionDotToken) || N(D, d.name);
                  case 207:
                    return N(D, d.expression) || N(D, d.questionDotToken) || N(D, d.argumentExpression);
                  case 208:
                  case 209:
                    return N(D, d.expression) || N(D, d.questionDotToken) || p(D, fe, d.typeArguments) || p(D, fe, d.arguments);
                  case 210:
                    return N(D, d.tag) || N(D, d.questionDotToken) || p(D, fe, d.typeArguments) || N(D, d.template);
                  case 211:
                    return N(D, d.type) || N(D, d.expression);
                  case 212:
                    return N(D, d.expression);
                  case 215:
                    return N(D, d.expression);
                  case 216:
                    return N(D, d.expression);
                  case 217:
                    return N(D, d.expression);
                  case 219:
                    return N(D, d.operand);
                  case 224:
                    return N(D, d.asteriskToken) || N(D, d.expression);
                  case 218:
                    return N(D, d.expression);
                  case 220:
                    return N(D, d.operand);
                  case 221:
                    return N(D, d.left) || N(D, d.operatorToken) || N(D, d.right);
                  case 229:
                    return N(D, d.expression) || N(D, d.type);
                  case 230:
                    return N(D, d.expression);
                  case 231:
                    return N(D, d.name);
                  case 222:
                    return N(D, d.condition) || N(D, d.questionToken) || N(D, d.whenTrue) || N(D, d.colonToken) || N(D, d.whenFalse);
                  case 225:
                    return N(D, d.expression);
                  case 235:
                  case 262:
                    return p(D, fe, d.statements);
                  case 305:
                    return p(D, fe, d.statements) || N(D, d.endOfFileToken);
                  case 237:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.declarationList);
                  case 255:
                    return p(D, fe, d.declarations);
                  case 238:
                    return N(D, d.expression);
                  case 239:
                    return N(D, d.expression) || N(D, d.thenStatement) || N(D, d.elseStatement);
                  case 240:
                    return N(D, d.statement) || N(D, d.expression);
                  case 241:
                    return N(D, d.expression) || N(D, d.statement);
                  case 242:
                    return N(D, d.initializer) || N(D, d.condition) || N(D, d.incrementor) || N(D, d.statement);
                  case 243:
                    return N(D, d.initializer) || N(D, d.expression) || N(D, d.statement);
                  case 244:
                    return N(D, d.awaitModifier) || N(D, d.initializer) || N(D, d.expression) || N(D, d.statement);
                  case 245:
                  case 246:
                    return N(D, d.label);
                  case 247:
                    return N(D, d.expression);
                  case 248:
                    return N(D, d.expression) || N(D, d.statement);
                  case 249:
                    return N(D, d.expression) || N(D, d.caseBlock);
                  case 263:
                    return p(D, fe, d.clauses);
                  case 289:
                    return N(D, d.expression) || p(D, fe, d.statements);
                  case 290:
                    return p(D, fe, d.statements);
                  case 250:
                    return N(D, d.label) || N(D, d.statement);
                  case 251:
                    return N(D, d.expression);
                  case 252:
                    return N(D, d.tryBlock) || N(D, d.catchClause) || N(D, d.finallyBlock);
                  case 292:
                    return N(D, d.variableDeclaration) || N(D, d.block);
                  case 165:
                    return N(D, d.expression);
                  case 257:
                  case 226:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || p(D, fe, d.typeParameters) || p(D, fe, d.heritageClauses) || p(D, fe, d.members);
                  case 258:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || p(D, fe, d.typeParameters) || p(D, fe, d.heritageClauses) || p(D, fe, d.members);
                  case 259:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || p(D, fe, d.typeParameters) || N(D, d.type);
                  case 260:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || p(D, fe, d.members);
                  case 299:
                    return N(D, d.name) || N(D, d.initializer);
                  case 261:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.body);
                  case 265:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.name) || N(D, d.moduleReference);
                  case 266:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.importClause) || N(D, d.moduleSpecifier) || N(D, d.assertClause);
                  case 267:
                    return N(D, d.name) || N(D, d.namedBindings);
                  case 293:
                    return p(D, fe, d.elements);
                  case 294:
                    return N(D, d.name) || N(D, d.value);
                  case 264:
                    return N(D, d.name);
                  case 268:
                    return N(D, d.name);
                  case 274:
                    return N(D, d.name);
                  case 269:
                  case 273:
                    return p(D, fe, d.elements);
                  case 272:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.exportClause) || N(D, d.moduleSpecifier) || N(D, d.assertClause);
                  case 270:
                  case 275:
                    return N(D, d.propertyName) || N(D, d.name);
                  case 271:
                    return p(D, fe, d.decorators) || p(D, fe, d.modifiers) || N(D, d.expression);
                  case 223:
                    return N(D, d.head) || p(D, fe, d.templateSpans);
                  case 233:
                    return N(D, d.expression) || N(D, d.literal);
                  case 198:
                    return N(D, d.head) || p(D, fe, d.templateSpans);
                  case 199:
                    return N(D, d.type) || N(D, d.literal);
                  case 162:
                    return N(D, d.expression);
                  case 291:
                    return p(D, fe, d.types);
                  case 228:
                    return N(D, d.expression) || p(D, fe, d.typeArguments);
                  case 277:
                    return N(D, d.expression);
                  case 276:
                    return p(D, fe, d.decorators);
                  case 351:
                    return p(D, fe, d.elements);
                  case 278:
                    return N(D, d.openingElement) || p(D, fe, d.children) || N(D, d.closingElement);
                  case 282:
                    return N(D, d.openingFragment) || p(D, fe, d.children) || N(D, d.closingFragment);
                  case 279:
                  case 280:
                    return N(D, d.tagName) || p(D, fe, d.typeArguments) || N(D, d.attributes);
                  case 286:
                    return p(D, fe, d.properties);
                  case 285:
                    return N(D, d.name) || N(D, d.initializer);
                  case 287:
                    return N(D, d.expression);
                  case 288:
                    return N(D, d.dotDotDotToken) || N(D, d.expression);
                  case 281:
                    return N(D, d.tagName);
                  case 185:
                  case 186:
                  case 309:
                  case 315:
                  case 314:
                  case 316:
                  case 318:
                    return N(D, d.type);
                  case 317:
                    return p(D, fe, d.parameters) || N(D, d.type);
                  case 320:
                    return (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)) || p(D, fe, d.tags);
                  case 346:
                    return N(D, d.tagName) || N(D, d.name) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                  case 310:
                    return N(D, d.name);
                  case 311:
                    return N(D, d.left) || N(D, d.right);
                  case 340:
                  case 347:
                    return N(D, d.tagName) || (d.isNameFirst ? N(D, d.name) || N(D, d.typeExpression) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)) : N(D, d.typeExpression) || N(D, d.name) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)));
                  case 330:
                    return N(D, d.tagName) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                  case 329:
                    return N(D, d.tagName) || N(D, d.class) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                  case 328:
                    return N(D, d.tagName) || N(D, d.class) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                  case 344:
                    return N(D, d.tagName) || N(D, d.constraint) || p(D, fe, d.typeParameters) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                  case 345:
                    return N(D, d.tagName) || (d.typeExpression && d.typeExpression.kind === 309 ? N(D, d.typeExpression) || N(D, d.fullName) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)) : N(D, d.fullName) || N(D, d.typeExpression) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment)));
                  case 338:
                    return N(D, d.tagName) || N(D, d.fullName) || N(D, d.typeExpression) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                  case 341:
                  case 343:
                  case 342:
                  case 339:
                    return N(D, d.tagName) || N(D, d.typeExpression) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                  case 323:
                    return e2.forEach(d.typeParameters, D) || e2.forEach(d.parameters, D) || N(D, d.type);
                  case 324:
                  case 325:
                  case 326:
                    return N(D, d.name);
                  case 322:
                    return e2.forEach(d.jsDocPropertyTags, D);
                  case 327:
                  case 332:
                  case 333:
                  case 334:
                  case 335:
                  case 336:
                  case 331:
                    return N(D, d.tagName) || (typeof d.comment == "string" ? void 0 : p(D, fe, d.comment));
                  case 350:
                    return N(D, d.expression);
                }
            }
            e2.forEachChild = se;
            function J(d, D, fe) {
              for (var g = ie(d), ne = []; ne.length < g.length; )
                ne.push(d);
              for (; g.length !== 0; ) {
                var ue = g.pop(), We = ne.pop();
                if (e2.isArray(ue)) {
                  if (fe) {
                    var Fe = fe(ue, We);
                    if (Fe) {
                      if (Fe === "skip")
                        continue;
                      return Fe;
                    }
                  }
                  for (var Z2 = ue.length - 1; Z2 >= 0; --Z2)
                    g.push(ue[Z2]), ne.push(We);
                } else {
                  var Fe = D(ue, We);
                  if (Fe) {
                    if (Fe === "skip")
                      continue;
                    return Fe;
                  }
                  if (ue.kind >= 161)
                    for (var Be = 0, ge = ie(ue); Be < ge.length; Be++) {
                      var Re = ge[Be];
                      g.push(Re), ne.push(ue);
                    }
                }
              }
            }
            e2.forEachChildRecursively = J;
            function ie(d) {
              var D = [];
              return se(d, fe, fe), D;
              function fe(g) {
                D.unshift(g);
              }
            }
            function R(d) {
              d.externalModuleIndicator = G(d);
            }
            function q(d, D, fe, g, ne) {
              g === void 0 && (g = false), e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("parse", "createSourceFile", { path: d }, true), e2.performance.mark("beforeParse");
              var ue;
              e2.perfLogger.logStartParseSourceFile(d);
              var We = typeof fe == "object" ? fe : { languageVersion: fe }, Fe = We.languageVersion, Z2 = We.setExternalModuleIndicator, Be = We.impliedNodeFormat;
              if (Fe === 100)
                ue = X.parseSourceFile(d, D, Fe, void 0, g, 6, e2.noop);
              else {
                var ge = Be === void 0 ? Z2 : function(Re) {
                  return Re.impliedNodeFormat = Be, (Z2 || R)(Re);
                };
                ue = X.parseSourceFile(d, D, Fe, void 0, g, ne, ge);
              }
              return e2.perfLogger.logStopParseSourceFile(), e2.performance.mark("afterParse"), e2.performance.measure("Parse", "beforeParse", "afterParse"), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), ue;
            }
            e2.createSourceFile = q;
            function O(d, D) {
              return X.parseIsolatedEntityName(d, D);
            }
            e2.parseIsolatedEntityName = O;
            function ve(d, D) {
              return X.parseJsonText(d, D);
            }
            e2.parseJsonText = ve;
            function ee(d) {
              return d.externalModuleIndicator !== void 0;
            }
            e2.isExternalModule = ee;
            function he(d, D, fe, g) {
              g === void 0 && (g = false);
              var ne = $.updateSourceFile(d, D, fe, g);
              return ne.flags |= d.flags & 6291456, ne;
            }
            e2.updateSourceFile = he;
            function F2(d, D, fe) {
              var g = X.JSDocParser.parseIsolatedJSDocComment(d, D, fe);
              return g && g.jsDoc && X.fixupParentReferences(g.jsDoc), g;
            }
            e2.parseIsolatedJSDocComment = F2;
            function x2(d, D, fe) {
              return X.JSDocParser.parseJSDocTypeExpressionForTests(d, D, fe);
            }
            e2.parseJSDocTypeExpressionForTests = x2;
            var X;
            (function(d) {
              var D = e2.createScanner(99, true), fe = 20480, g, ne, ue, We, Fe;
              function Z2(Le) {
                return Ae++, Le;
              }
              var Be = { createBaseSourceFileNode: function(Le) {
                return Z2(new Fe(Le, 0, 0));
              }, createBaseIdentifierNode: function(Le) {
                return Z2(new ue(Le, 0, 0));
              }, createBasePrivateIdentifierNode: function(Le) {
                return Z2(new We(Le, 0, 0));
              }, createBaseTokenNode: function(Le) {
                return Z2(new ne(Le, 0, 0));
              }, createBaseNode: function(Le) {
                return Z2(new g(Le, 0, 0));
              } }, ge = e2.createNodeFactory(11, Be), Re, ze, Ee, He, rr, Ie, _e, we, de, ye, Ae, er, ir, Cr, Ye, Br, Er, Ne = true, n = false;
              function lr(Le, Nr, ri, di, Mi, st, ra) {
                var Ta;
                if (Mi === void 0 && (Mi = false), st = e2.ensureScriptKind(Le, st), st === 6) {
                  var ha = Ge(Le, Nr, ri, di, Mi);
                  return e2.convertToObjectWorker(ha, (Ta = ha.statements[0]) === null || Ta === void 0 ? void 0 : Ta.expression, ha.parseDiagnostics, false, void 0, void 0), ha.referencedFiles = e2.emptyArray, ha.typeReferenceDirectives = e2.emptyArray, ha.libReferenceDirectives = e2.emptyArray, ha.amdDependencies = e2.emptyArray, ha.hasNoDefaultLib = false, ha.pragmas = e2.emptyMap, ha;
                }
                ur(Le, Nr, ri, di, st);
                var Na = Ir(ri, Mi, st, ra || R);
                return yr(), Na;
              }
              d.parseSourceFile = lr;
              function be(Le, Nr) {
                ur("", Le, Nr, void 0, 1), Tr();
                var ri = ds(true), di = De() === 1 && !_e.length;
                return yr(), di ? ri : void 0;
              }
              d.parseIsolatedEntityName = be;
              function Ge(Le, Nr, ri, di, Mi) {
                ri === void 0 && (ri = 2), Mi === void 0 && (Mi = false), ur(Le, Nr, ri, di, 6), ze = Er, Tr();
                var st = Ue(), ra, Ta;
                if (De() === 1)
                  ra = Cn([], st, st), Ta = ai();
                else {
                  for (var ha = void 0; De() !== 1; ) {
                    var Na = void 0;
                    switch (De()) {
                      case 22:
                        Na = cl();
                        break;
                      case 110:
                      case 95:
                      case 104:
                        Na = ai();
                        break;
                      case 40:
                        Rt(function() {
                          return Tr() === 8 && Tr() !== 58;
                        }) ? Na = ol() : Na = Ut();
                        break;
                      case 8:
                      case 10:
                        if (Rt(function() {
                          return Tr() !== 58;
                        })) {
                          Na = ga();
                          break;
                        }
                      default:
                        Na = Ut();
                        break;
                    }
                    ha && e2.isArray(ha) ? ha.push(Na) : ha ? ha = [ha, Na] : (ha = Na, De() !== 1 && Ar(e2.Diagnostics.Unexpected_token));
                  }
                  var In = e2.isArray(ha) ? Bi(ge.createArrayLiteralExpression(ha), st) : e2.Debug.checkDefined(ha), qo = ge.createExpressionStatement(In);
                  Bi(qo, st), ra = Cn([qo], st), Ta = $a(1, e2.Diagnostics.Unexpected_token);
                }
                var co = or(Le, 2, 6, false, ra, Ta, ze, e2.noop);
                Mi && pe(co), co.nodeCount = Ae, co.identifierCount = Cr, co.identifiers = er, co.parseDiagnostics = e2.attachFileToDiagnostics(_e, co), we && (co.jsDocDiagnostics = e2.attachFileToDiagnostics(we, co));
                var ts = co;
                return yr(), ts;
              }
              d.parseJsonText = Ge;
              function ur(Le, Nr, ri, di, Mi) {
                switch (g = e2.objectAllocator.getNodeConstructor(), ne = e2.objectAllocator.getTokenConstructor(), ue = e2.objectAllocator.getIdentifierConstructor(), We = e2.objectAllocator.getPrivateIdentifierConstructor(), Fe = e2.objectAllocator.getSourceFileConstructor(), Re = e2.normalizePath(Le), Ee = Nr, He = ri, de = di, rr = Mi, Ie = e2.getLanguageVariant(Mi), _e = [], Ye = 0, er = new e2.Map(), ir = new e2.Map(), Cr = 0, Ae = 0, ze = 0, Ne = true, rr) {
                  case 1:
                  case 2:
                    Er = 262144;
                    break;
                  case 6:
                    Er = 67371008;
                    break;
                  default:
                    Er = 0;
                    break;
                }
                n = false, D.setText(Ee), D.setOnError(Pe), D.setScriptTarget(He), D.setLanguageVariant(Ie);
              }
              function yr() {
                D.clearCommentDirectives(), D.setText(""), D.setOnError(void 0), Ee = void 0, He = void 0, de = void 0, rr = void 0, Ie = void 0, ze = 0, _e = void 0, we = void 0, Ye = 0, er = void 0, Br = void 0, Ne = true;
              }
              function Ir(Le, Nr, ri, di) {
                var Mi = A2(Re);
                Mi && (Er |= 16777216), ze = Er, Tr();
                var st = Qi(0, nc);
                e2.Debug.assert(De() === 1);
                var ra = ii(ai()), Ta = or(Re, Le, ri, Mi, st, ra, ze, di);
                return V(Ta, Ee), L(Ta, ha), Ta.commentDirectives = D.getCommentDirectives(), Ta.nodeCount = Ae, Ta.identifierCount = Cr, Ta.identifiers = er, Ta.parseDiagnostics = e2.attachFileToDiagnostics(_e, Ta), we && (Ta.jsDocDiagnostics = e2.attachFileToDiagnostics(we, Ta)), Nr && pe(Ta), Ta;
                function ha(Na, In, qo) {
                  _e.push(e2.createDetachedDiagnostic(Re, Na, In, qo));
                }
              }
              function wr(Le, Nr) {
                return Nr ? ii(Le) : Le;
              }
              var Ur = false;
              function ii(Le) {
                e2.Debug.assert(!Le.jsDoc);
                var Nr = e2.mapDefined(e2.getJSDocCommentRanges(Le, Ee), function(ri) {
                  return G_.parseJSDocComment(Le, ri.pos, ri.end - ri.pos);
                });
                return Nr.length && (Le.jsDoc = Nr), Ur && (Ur = false, Le.flags |= 268435456), Le;
              }
              function mi(Le) {
                var Nr = de, ri = $.createSyntaxCursor(Le);
                de = { currentNode: ts };
                var di = [], Mi = _e;
                _e = [];
                for (var st = 0, ra = qo(Le.statements, 0), Ta = function() {
                  var vs = Le.statements[st], Ac = Le.statements[ra];
                  e2.addRange(di, Le.statements, st, ra), st = co(Le.statements, ra);
                  var Is = e2.findIndex(Mi, function(sc) {
                    return sc.start >= vs.pos;
                  }), Qu = Is >= 0 ? e2.findIndex(Mi, function(sc) {
                    return sc.start >= Ac.pos;
                  }, Is) : -1;
                  Is >= 0 && e2.addRange(_e, Mi, Is, Qu >= 0 ? Qu : void 0), Dt(function() {
                    var sc = Er;
                    for (Er |= 32768, D.setTextPos(Ac.pos), Tr(); De() !== 1; ) {
                      var bc = D.getStartPos(), Mc = Ct(0, nc);
                      if (di.push(Mc), bc === D.getStartPos() && Tr(), st >= 0) {
                        var Yu = Le.statements[st];
                        if (Mc.end === Yu.pos)
                          break;
                        Mc.end > Yu.pos && (st = co(Le.statements, st + 1));
                      }
                    }
                    Er = sc;
                  }, 2), ra = st >= 0 ? qo(Le.statements, st) : -1;
                }; ra !== -1; )
                  Ta();
                if (st >= 0) {
                  var ha = Le.statements[st];
                  e2.addRange(di, Le.statements, st);
                  var Na = e2.findIndex(Mi, function(vs) {
                    return vs.start >= ha.pos;
                  });
                  Na >= 0 && e2.addRange(_e, Mi, Na);
                }
                return de = Nr, ge.updateSourceFile(Le, e2.setTextRange(ge.createNodeArray(di), Le.statements));
                function In(vs) {
                  return !(vs.flags & 32768) && !!(vs.transformFlags & 16777216);
                }
                function qo(vs, Ac) {
                  for (var Is = Ac; Is < vs.length; Is++)
                    if (In(vs[Is]))
                      return Is;
                  return -1;
                }
                function co(vs, Ac) {
                  for (var Is = Ac; Is < vs.length; Is++)
                    if (!In(vs[Is]))
                      return Is;
                  return -1;
                }
                function ts(vs) {
                  var Ac = ri.currentNode(vs);
                  return Ne && Ac && In(Ac) && (Ac.intersectsChange = true), Ac;
                }
              }
              function pe(Le) {
                e2.setParentRecursive(Le, true);
              }
              d.fixupParentReferences = pe;
              function or(Le, Nr, ri, di, Mi, st, ra, Ta) {
                var ha = ge.createSourceFile(Mi, st, ra);
                return e2.setTextRangePosWidth(ha, 0, Ee.length), Na(ha), !di && ee(ha) && ha.transformFlags & 16777216 && (ha = mi(ha), Na(ha)), ha;
                function Na(In) {
                  In.text = Ee, In.bindDiagnostics = [], In.bindSuggestionDiagnostics = void 0, In.languageVersion = Nr, In.fileName = Le, In.languageVariant = e2.getLanguageVariant(ri), In.isDeclarationFile = di, In.scriptKind = ri, Ta(In), In.setExternalModuleIndicator = Ta;
                }
              }
              function qr(Le, Nr) {
                Le ? Er |= Nr : Er &= ~Nr;
              }
              function si(Le) {
                qr(Le, 4096);
              }
              function Di(Le) {
                qr(Le, 8192);
              }
              function wi(Le) {
                qr(Le, 16384);
              }
              function Xi(Le) {
                qr(Le, 32768);
              }
              function et(Le, Nr) {
                var ri = Le & Er;
                if (ri) {
                  qr(false, ri);
                  var di = Nr();
                  return qr(true, ri), di;
                }
                return Nr();
              }
              function Gi(Le, Nr) {
                var ri = Le & ~Er;
                if (ri) {
                  qr(true, ri);
                  var di = Nr();
                  return qr(false, ri), di;
                }
                return Nr();
              }
              function Wt(Le) {
                return et(4096, Le);
              }
              function Zt(Le) {
                return Gi(4096, Le);
              }
              function _r(Le) {
                return et(65536, Le);
              }
              function pi(Le) {
                return Gi(65536, Le);
              }
              function ae(Le) {
                return Gi(8192, Le);
              }
              function Xe(Le) {
                return Gi(16384, Le);
              }
              function Jr(Le) {
                return Gi(32768, Le);
              }
              function ti(Le) {
                return et(32768, Le);
              }
              function Ze(Le) {
                return Gi(40960, Le);
              }
              function Sr(Le) {
                return et(40960, Le);
              }
              function zr(Le) {
                return (Er & Le) !== 0;
              }
              function Wr() {
                return zr(8192);
              }
              function Je() {
                return zr(4096);
              }
              function xe() {
                return zr(65536);
              }
              function vr() {
                return zr(16384);
              }
              function mr() {
                return zr(32768);
              }
              function Ar(Le, Nr) {
                return nr(D.getTokenPos(), D.getTextPos(), Le, Nr);
              }
              function Oe(Le, Nr, ri, di) {
                var Mi = e2.lastOrUndefined(_e), st;
                return (!Mi || Le !== Mi.start) && (st = e2.createDetachedDiagnostic(Re, Le, Nr, ri, di), _e.push(st)), n = true, st;
              }
              function nr(Le, Nr, ri, di) {
                return Oe(Le, Nr - Le, ri, di);
              }
              function Mr(Le, Nr, ri) {
                nr(Le.pos, Le.end, Nr, ri);
              }
              function Pe(Le, Nr) {
                Oe(D.getTextPos(), Nr, Le);
              }
              function Ue() {
                return D.getStartPos();
              }
              function fr() {
                return D.hasPrecedingJSDocComment();
              }
              function De() {
                return ye;
              }
              function gr() {
                return ye = D.scan();
              }
              function Vr(Le) {
                return Tr(), Le();
              }
              function Tr() {
                return e2.isKeyword(ye) && (D.hasUnicodeEscape() || D.hasExtendedUnicodeEscape()) && nr(D.getTokenPos(), D.getTextPos(), e2.Diagnostics.Keywords_cannot_contain_escape_characters), gr();
              }
              function vi() {
                return ye = D.scanJsDocToken();
              }
              function Ui() {
                return ye = D.reScanGreaterToken();
              }
              function Yi() {
                return ye = D.reScanSlashToken();
              }
              function Wi(Le) {
                return ye = D.reScanTemplateToken(Le);
              }
              function ct() {
                return ye = D.reScanTemplateHeadOrNoSubstitutionTemplate();
              }
              function Li() {
                return ye = D.reScanLessThanToken();
              }
              function nt() {
                return ye = D.reScanHashToken();
              }
              function Mt() {
                return ye = D.scanJsxIdentifier();
              }
              function xt() {
                return ye = D.scanJsxToken();
              }
              function ut() {
                return ye = D.scanJsxAttributeValue();
              }
              function Dt(Le, Nr) {
                var ri = ye, di = _e.length, Mi = n, st = Er, ra = Nr !== 0 ? D.lookAhead(Le) : D.tryScan(Le);
                return e2.Debug.assert(st === Er), (!ra || Nr !== 0) && (ye = ri, Nr !== 2 && (_e.length = di), n = Mi), ra;
              }
              function Rt(Le) {
                return Dt(Le, 1);
              }
              function Ii(Le) {
                return Dt(Le, 0);
              }
              function Ki() {
                return De() === 79 ? true : De() > 116;
              }
              function Fi() {
                return De() === 79 ? true : De() === 125 && Wr() || De() === 132 && mr() ? false : De() > 116;
              }
              function ui(Le, Nr, ri) {
                return ri === void 0 && (ri = true), De() === Le ? (ri && Tr(), true) : (Nr ? Ar(Nr) : Ar(e2.Diagnostics._0_expected, e2.tokenToString(Le)), false);
              }
              var Bt = Object.keys(e2.textToKeywordObj).filter(function(Le) {
                return Le.length > 2;
              });
              function wt(Le) {
                var Nr;
                if (e2.isTaggedTemplateExpression(Le)) {
                  nr(e2.skipTrivia(Ee, Le.template.pos), Le.template.end, e2.Diagnostics.Module_declaration_names_may_only_use_or_quoted_strings);
                  return;
                }
                var ri = e2.isIdentifier(Le) ? e2.idText(Le) : void 0;
                if (!ri || !e2.isIdentifierText(ri, He)) {
                  Ar(e2.Diagnostics._0_expected, e2.tokenToString(26));
                  return;
                }
                var di = e2.skipTrivia(Ee, Le.pos);
                switch (ri) {
                  case "const":
                  case "let":
                  case "var":
                    nr(di, Le.end, e2.Diagnostics.Variable_declaration_not_allowed_at_this_location);
                    return;
                  case "declare":
                    return;
                  case "interface":
                    na(e2.Diagnostics.Interface_name_cannot_be_0, e2.Diagnostics.Interface_must_be_given_a_name, 18);
                    return;
                  case "is":
                    nr(di, D.getTextPos(), e2.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
                    return;
                  case "module":
                  case "namespace":
                    na(e2.Diagnostics.Namespace_name_cannot_be_0, e2.Diagnostics.Namespace_must_be_given_a_name, 18);
                    return;
                  case "type":
                    na(e2.Diagnostics.Type_alias_name_cannot_be_0, e2.Diagnostics.Type_alias_must_be_given_a_name, 63);
                    return;
                }
                var Mi = (Nr = e2.getSpellingSuggestion(ri, Bt, function(st) {
                  return st;
                })) !== null && Nr !== void 0 ? Nr : Ai(ri);
                if (Mi) {
                  nr(di, Le.end, e2.Diagnostics.Unknown_keyword_or_identifier_Did_you_mean_0, Mi);
                  return;
                }
                De() !== 0 && nr(di, Le.end, e2.Diagnostics.Unexpected_keyword_or_identifier);
              }
              function na(Le, Nr, ri) {
                De() === ri ? Ar(Nr) : Ar(Le, D.getTokenValue());
              }
              function Ai(Le) {
                for (var Nr = 0, ri = Bt; Nr < ri.length; Nr++) {
                  var di = ri[Nr];
                  if (Le.length > di.length + 2 && e2.startsWith(Le, di))
                    return "".concat(di, " ").concat(Le.slice(di.length));
                }
              }
              function Oi(Le, Nr, ri) {
                if (De() === 59 && !D.hasPrecedingLineBreak()) {
                  Ar(e2.Diagnostics.Decorators_must_precede_the_name_and_all_keywords_of_property_declarations);
                  return;
                }
                if (De() === 20) {
                  Ar(e2.Diagnostics.Cannot_start_a_function_call_in_a_type_annotation), Tr();
                  return;
                }
                if (Nr && !ka()) {
                  ri ? Ar(e2.Diagnostics._0_expected, e2.tokenToString(26)) : Ar(e2.Diagnostics.Expected_for_property_initializer);
                  return;
                }
                if (!Ba()) {
                  if (ri) {
                    Ar(e2.Diagnostics._0_expected, e2.tokenToString(26));
                    return;
                  }
                  wt(Le);
                }
              }
              function ji(Le) {
                return De() === Le ? (vi(), true) : (Ar(e2.Diagnostics._0_expected, e2.tokenToString(Le)), false);
              }
              function Vi(Le, Nr, ri, di) {
                if (De() === Nr) {
                  Tr();
                  return;
                }
                var Mi = Ar(e2.Diagnostics._0_expected, e2.tokenToString(Nr));
                !ri || Mi && e2.addRelatedInfo(Mi, e2.createDetachedDiagnostic(Re, di, 1, e2.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, e2.tokenToString(Le), e2.tokenToString(Nr)));
              }
              function at(Le) {
                return De() === Le ? (Tr(), true) : false;
              }
              function At(Le) {
                if (De() === Le)
                  return ai();
              }
              function ba(Le) {
                if (De() === Le)
                  return Dn();
              }
              function $a(Le, Nr, ri) {
                return At(Le) || kn(Le, false, Nr || e2.Diagnostics._0_expected, ri || e2.tokenToString(Le));
              }
              function Qa(Le) {
                return ba(Le) || kn(Le, false, e2.Diagnostics._0_expected, e2.tokenToString(Le));
              }
              function ai() {
                var Le = Ue(), Nr = De();
                return Tr(), Bi(ge.createToken(Nr), Le);
              }
              function Dn() {
                var Le = Ue(), Nr = De();
                return vi(), Bi(ge.createToken(Nr), Le);
              }
              function ka() {
                return De() === 26 ? true : De() === 19 || De() === 1 || D.hasPrecedingLineBreak();
              }
              function Ba() {
                return ka() ? (De() === 26 && Tr(), true) : false;
              }
              function pn() {
                return Ba() || ui(26);
              }
              function Cn(Le, Nr, ri, di) {
                var Mi = ge.createNodeArray(Le, di);
                return e2.setTextRangePosEnd(Mi, Nr, ri != null ? ri : D.getStartPos()), Mi;
              }
              function Bi(Le, Nr, ri) {
                return e2.setTextRangePosEnd(Le, Nr, ri != null ? ri : D.getStartPos()), Er && (Le.flags |= Er), n && (n = false, Le.flags |= 131072), Le;
              }
              function kn(Le, Nr, ri, di) {
                Nr ? Oe(D.getStartPos(), 0, ri, di) : ri && Ar(ri, di);
                var Mi = Ue(), st = Le === 79 ? ge.createIdentifier("", void 0, void 0) : e2.isTemplateLiteralKind(Le) ? ge.createTemplateLiteralLikeNode(Le, "", "", void 0) : Le === 8 ? ge.createNumericLiteral("", void 0) : Le === 10 ? ge.createStringLiteral("", void 0) : Le === 276 ? ge.createMissingDeclaration() : ge.createToken(Le);
                return Bi(st, Mi);
              }
              function xn(Le) {
                var Nr = er.get(Le);
                return Nr === void 0 && er.set(Le, Nr = Le), Nr;
              }
              function Kn(Le, Nr, ri) {
                if (Le) {
                  Cr++;
                  var di = Ue(), Mi = De(), st = xn(D.getTokenValue());
                  return gr(), Bi(ge.createIdentifier(st, void 0, Mi), di);
                }
                if (De() === 80)
                  return Ar(ri || e2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), Kn(true);
                if (De() === 0 && D.tryScan(function() {
                  return D.reScanInvalidIdentifier() === 79;
                }))
                  return Kn(true);
                Cr++;
                var ra = De() === 1, Ta = D.isReservedWord(), ha = D.getTokenText(), Na = Ta ? e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here : e2.Diagnostics.Identifier_expected;
                return kn(79, ra, Nr || Na, ha);
              }
              function Pn(Le) {
                return Kn(Ki(), void 0, Le);
              }
              function eo(Le, Nr) {
                return Kn(Fi(), Le, Nr);
              }
              function Rn(Le) {
                return Kn(e2.tokenIsIdentifierOrKeyword(De()), Le);
              }
              function Da() {
                return e2.tokenIsIdentifierOrKeyword(De()) || De() === 10 || De() === 8;
              }
              function bo() {
                return e2.tokenIsIdentifierOrKeyword(De()) || De() === 10;
              }
              function Ro(Le) {
                if (De() === 10 || De() === 8) {
                  var Nr = ga();
                  return Nr.text = xn(Nr.text), Nr;
                }
                return Le && De() === 22 ? Wn() : De() === 80 ? Co() : Rn();
              }
              function En() {
                return Ro(true);
              }
              function Wn() {
                var Le = Ue();
                ui(22);
                var Nr = Wt(ns);
                return ui(23), Bi(ge.createComputedPropertyName(Nr), Le);
              }
              function to(Le) {
                var Nr = ir.get(Le);
                return Nr === void 0 && ir.set(Le, Nr = Le), Nr;
              }
              function Co() {
                var Le = Ue(), Nr = ge.createPrivateIdentifier(to(D.getTokenText()));
                return Tr(), Bi(Nr, Le);
              }
              function Ko(Le) {
                return De() === Le && Ii(no);
              }
              function Oo() {
                return Tr(), D.hasPrecedingLineBreak() ? false : St();
              }
              function no() {
                switch (De()) {
                  case 85:
                    return Tr() === 92;
                  case 93:
                    return Tr(), De() === 88 ? Rt(pa) : De() === 152 ? Rt(Pr) : $o();
                  case 88:
                    return pa();
                  case 124:
                  case 136:
                  case 149:
                    return Tr(), St();
                  default:
                    return Oo();
                }
              }
              function $o() {
                return De() !== 41 && De() !== 127 && De() !== 18 && St();
              }
              function Pr() {
                return Tr(), $o();
              }
              function xi() {
                return e2.isModifierKind(De()) && Ii(no);
              }
              function St() {
                return De() === 22 || De() === 18 || De() === 41 || De() === 25 || Da();
              }
              function pa() {
                return Tr(), De() === 84 || De() === 98 || De() === 118 || De() === 126 && Rt(wl) || De() === 131 && Rt(Iu);
              }
              function dn(Le, Nr) {
                var ri = sa(Le);
                if (ri)
                  return true;
                switch (Le) {
                  case 0:
                  case 1:
                  case 3:
                    return !(De() === 26 && Nr) && Ku();
                  case 2:
                    return De() === 82 || De() === 88;
                  case 4:
                    return Rt(bn);
                  case 5:
                    return Rt(Lp) || De() === 26 && !Nr;
                  case 6:
                    return De() === 22 || Da();
                  case 12:
                    switch (De()) {
                      case 22:
                      case 41:
                      case 25:
                      case 24:
                        return true;
                      default:
                        return Da();
                    }
                  case 18:
                    return Da();
                  case 9:
                    return De() === 22 || De() === 25 || Da();
                  case 24:
                    return bo();
                  case 7:
                    return De() === 18 ? Rt(Jn) : Nr ? Fi() && !Ce() : Cu() && !Ce();
                  case 8:
                    return Hc();
                  case 10:
                    return De() === 27 || De() === 25 || Hc();
                  case 19:
                    return De() === 101 || Fi();
                  case 15:
                    switch (De()) {
                      case 27:
                      case 24:
                        return true;
                    }
                  case 11:
                    return De() === 25 || qs();
                  case 16:
                    return pu(false);
                  case 17:
                    return pu(true);
                  case 20:
                  case 21:
                    return De() === 27 || Xr();
                  case 22:
                    return Ll();
                  case 23:
                    return e2.tokenIsIdentifierOrKeyword(De());
                  case 13:
                    return e2.tokenIsIdentifierOrKeyword(De()) || De() === 18;
                  case 14:
                    return true;
                }
                return e2.Debug.fail("Non-exhaustive case in 'isListElement'.");
              }
              function Jn() {
                if (e2.Debug.assert(De() === 18), Tr() === 19) {
                  var Le = Tr();
                  return Le === 27 || Le === 18 || Le === 94 || Le === 117;
                }
                return true;
              }
              function Qe() {
                return Tr(), Fi();
              }
              function Gr() {
                return Tr(), e2.tokenIsIdentifierOrKeyword(De());
              }
              function S2() {
                return Tr(), e2.tokenIsIdentifierOrKeywordOrGreaterThan(De());
              }
              function Ce() {
                return De() === 117 || De() === 94 ? Rt(qe) : false;
              }
              function qe() {
                return Tr(), qs();
              }
              function br() {
                return Tr(), Xr();
              }
              function Zr(Le) {
                if (De() === 1)
                  return true;
                switch (Le) {
                  case 1:
                  case 2:
                  case 4:
                  case 5:
                  case 6:
                  case 12:
                  case 9:
                  case 23:
                  case 24:
                    return De() === 19;
                  case 3:
                    return De() === 19 || De() === 82 || De() === 88;
                  case 7:
                    return De() === 18 || De() === 94 || De() === 117;
                  case 8:
                    return Si();
                  case 19:
                    return De() === 31 || De() === 20 || De() === 18 || De() === 94 || De() === 117;
                  case 11:
                    return De() === 21 || De() === 26;
                  case 15:
                  case 21:
                  case 10:
                    return De() === 23;
                  case 17:
                  case 16:
                  case 18:
                    return De() === 21 || De() === 23;
                  case 20:
                    return De() !== 27;
                  case 22:
                    return De() === 18 || De() === 19;
                  case 13:
                    return De() === 31 || De() === 43;
                  case 14:
                    return De() === 29 && Rt(fi);
                  default:
                    return false;
                }
              }
              function Si() {
                return !!(ka() || F_(De()) || De() === 38);
              }
              function Pi() {
                for (var Le = 0; Le < 25; Le++)
                  if (Ye & 1 << Le && (dn(Le, true) || Zr(Le)))
                    return true;
                return false;
              }
              function Qi(Le, Nr) {
                var ri = Ye;
                Ye |= 1 << Le;
                for (var di = [], Mi = Ue(); !Zr(Le); ) {
                  if (dn(Le, false)) {
                    di.push(Ct(Le, Nr));
                    continue;
                  }
                  if (Xs(Le))
                    break;
                }
                return Ye = ri, Cn(di, Mi);
              }
              function Ct(Le, Nr) {
                var ri = sa(Le);
                return ri ? en(ri) : Nr();
              }
              function sa(Le) {
                if (!(!de || !Wa(Le) || n)) {
                  var Nr = de.currentNode(D.getStartPos());
                  if (!(e2.nodeIsMissing(Nr) || Nr.intersectsChange || e2.containsParseError(Nr))) {
                    var ri = Nr.flags & 50720768;
                    if (ri === Er && !!qn(Nr, Le))
                      return Nr.jsDocCache && (Nr.jsDocCache = void 0), Nr;
                  }
                }
              }
              function en(Le) {
                return D.setTextPos(Le.end), Tr(), Le;
              }
              function Wa(Le) {
                switch (Le) {
                  case 5:
                  case 2:
                  case 0:
                  case 1:
                  case 3:
                  case 6:
                  case 4:
                  case 8:
                  case 17:
                  case 16:
                    return true;
                }
                return false;
              }
              function qn(Le, Nr) {
                switch (Nr) {
                  case 5:
                    return mo(Le);
                  case 2:
                    return So(Le);
                  case 0:
                  case 1:
                  case 3:
                    return Go(Le);
                  case 6:
                    return ys(Le);
                  case 4:
                    return Pc(Le);
                  case 8:
                    return Vc(Le);
                  case 17:
                  case 16:
                    return Kc(Le);
                }
                return false;
              }
              function mo(Le) {
                if (Le)
                  switch (Le.kind) {
                    case 171:
                    case 176:
                    case 172:
                    case 173:
                    case 167:
                    case 234:
                      return true;
                    case 169:
                      var Nr = Le, ri = Nr.name.kind === 79 && Nr.name.originalKeywordKind === 134;
                      return !ri;
                  }
                return false;
              }
              function So(Le) {
                if (Le)
                  switch (Le.kind) {
                    case 289:
                    case 290:
                      return true;
                  }
                return false;
              }
              function Go(Le) {
                if (Le)
                  switch (Le.kind) {
                    case 256:
                    case 237:
                    case 235:
                    case 239:
                    case 238:
                    case 251:
                    case 247:
                    case 249:
                    case 246:
                    case 245:
                    case 243:
                    case 244:
                    case 242:
                    case 241:
                    case 248:
                    case 236:
                    case 252:
                    case 250:
                    case 240:
                    case 253:
                    case 266:
                    case 265:
                    case 272:
                    case 271:
                    case 261:
                    case 257:
                    case 258:
                    case 260:
                    case 259:
                      return true;
                  }
                return false;
              }
              function ys(Le) {
                return Le.kind === 299;
              }
              function Pc(Le) {
                if (Le)
                  switch (Le.kind) {
                    case 175:
                    case 168:
                    case 176:
                    case 166:
                    case 174:
                      return true;
                  }
                return false;
              }
              function Vc(Le) {
                if (Le.kind !== 254)
                  return false;
                var Nr = Le;
                return Nr.initializer === void 0;
              }
              function Kc(Le) {
                if (Le.kind !== 164)
                  return false;
                var Nr = Le;
                return Nr.initializer === void 0;
              }
              function Xs(Le) {
                return pc(Le), Pi() ? true : (Tr(), false);
              }
              function pc(Le) {
                switch (Le) {
                  case 0:
                    return De() === 88 ? Ar(e2.Diagnostics._0_expected, e2.tokenToString(93)) : Ar(e2.Diagnostics.Declaration_or_statement_expected);
                  case 1:
                    return Ar(e2.Diagnostics.Declaration_or_statement_expected);
                  case 2:
                    return Ar(e2.Diagnostics.case_or_default_expected);
                  case 3:
                    return Ar(e2.Diagnostics.Statement_expected);
                  case 18:
                  case 4:
                    return Ar(e2.Diagnostics.Property_or_signature_expected);
                  case 5:
                    return Ar(e2.Diagnostics.Unexpected_token_A_constructor_method_accessor_or_property_was_expected);
                  case 6:
                    return Ar(e2.Diagnostics.Enum_member_expected);
                  case 7:
                    return Ar(e2.Diagnostics.Expression_expected);
                  case 8:
                    return e2.isKeyword(De()) ? Ar(e2.Diagnostics._0_is_not_allowed_as_a_variable_declaration_name, e2.tokenToString(De())) : Ar(e2.Diagnostics.Variable_declaration_expected);
                  case 9:
                    return Ar(e2.Diagnostics.Property_destructuring_pattern_expected);
                  case 10:
                    return Ar(e2.Diagnostics.Array_element_destructuring_pattern_expected);
                  case 11:
                    return Ar(e2.Diagnostics.Argument_expression_expected);
                  case 12:
                    return Ar(e2.Diagnostics.Property_assignment_expected);
                  case 15:
                    return Ar(e2.Diagnostics.Expression_or_comma_expected);
                  case 17:
                    return Ar(e2.Diagnostics.Parameter_declaration_expected);
                  case 16:
                    return e2.isKeyword(De()) ? Ar(e2.Diagnostics._0_is_not_allowed_as_a_parameter_name, e2.tokenToString(De())) : Ar(e2.Diagnostics.Parameter_declaration_expected);
                  case 19:
                    return Ar(e2.Diagnostics.Type_parameter_declaration_expected);
                  case 20:
                    return Ar(e2.Diagnostics.Type_argument_expected);
                  case 21:
                    return Ar(e2.Diagnostics.Type_expected);
                  case 22:
                    return Ar(e2.Diagnostics.Unexpected_token_expected);
                  case 23:
                    return Ar(e2.Diagnostics.Identifier_expected);
                  case 13:
                    return Ar(e2.Diagnostics.Identifier_expected);
                  case 14:
                    return Ar(e2.Diagnostics.Identifier_expected);
                  default:
                    return [void 0];
                }
              }
              function hs(Le, Nr, ri) {
                var di = Ye;
                Ye |= 1 << Le;
                for (var Mi = [], st = Ue(), ra = -1; ; ) {
                  if (dn(Le, false)) {
                    var Ta = D.getStartPos(), ha = Ct(Le, Nr);
                    if (!ha) {
                      Ye = di;
                      return;
                    }
                    if (Mi.push(ha), ra = D.getTokenPos(), at(27))
                      continue;
                    if (ra = -1, Zr(Le))
                      break;
                    ui(27, tc(Le)), ri && De() === 26 && !D.hasPrecedingLineBreak() && Tr(), Ta === D.getStartPos() && Tr();
                    continue;
                  }
                  if (Zr(Le) || Xs(Le))
                    break;
                }
                return Ye = di, Cn(Mi, st, void 0, ra >= 0);
              }
              function tc(Le) {
                return Le === 6 ? e2.Diagnostics.An_enum_member_name_must_be_followed_by_a_or : void 0;
              }
              function ps() {
                var Le = Cn([], Ue());
                return Le.isMissingList = true, Le;
              }
              function Qs(Le) {
                return !!Le.isMissingList;
              }
              function js(Le, Nr, ri, di) {
                if (ui(ri)) {
                  var Mi = hs(Le, Nr);
                  return ui(di), Mi;
                }
                return ps();
              }
              function ds(Le, Nr) {
                for (var ri = Ue(), di = Le ? Rn(Nr) : eo(Nr), Mi = Ue(); at(24); ) {
                  if (De() === 29) {
                    di.jsdocDotPos = Mi;
                    break;
                  }
                  Mi = Ue(), di = Bi(ge.createQualifiedName(di, ce(Le, false)), ri);
                }
                return di;
              }
              function Ji(Le, Nr) {
                return Bi(ge.createQualifiedName(Le, Nr), Le.pos);
              }
              function ce(Le, Nr) {
                if (D.hasPrecedingLineBreak() && e2.tokenIsIdentifierOrKeyword(De())) {
                  var ri = Rt(Pu);
                  if (ri)
                    return kn(79, true, e2.Diagnostics.Identifier_expected);
                }
                if (De() === 80) {
                  var di = Co();
                  return Nr ? di : kn(79, true, e2.Diagnostics.Identifier_expected);
                }
                return Le ? Rn() : eo();
              }
              function Rr(Le) {
                var Nr = Ue(), ri = [], di;
                do
                  di = Pt(Le), ri.push(di);
                while (di.literal.kind === 16);
                return Cn(ri, Nr);
              }
              function yi(Le) {
                var Nr = Ue();
                return Bi(ge.createTemplateExpression(ua(Le), Rr(Le)), Nr);
              }
              function qi() {
                var Le = Ue();
                return Bi(ge.createTemplateLiteralType(ua(false), je()), Le);
              }
              function je() {
                var Le = Ue(), Nr = [], ri;
                do
                  ri = Hr(), Nr.push(ri);
                while (ri.literal.kind === 16);
                return Cn(Nr, Le);
              }
              function Hr() {
                var Le = Ue();
                return Bi(ge.createTemplateLiteralTypeSpan(Aa(), pt(false)), Le);
              }
              function pt(Le) {
                return De() === 19 ? (Wi(Le), Xn()) : $a(17, e2.Diagnostics._0_expected, e2.tokenToString(19));
              }
              function Pt(Le) {
                var Nr = Ue();
                return Bi(ge.createTemplateSpan(Wt(ns), pt(Le)), Nr);
              }
              function ga() {
                return fo(De());
              }
              function ua(Le) {
                Le && ct();
                var Nr = fo(De());
                return e2.Debug.assert(Nr.kind === 15, "Template head has wrong token kind"), Nr;
              }
              function Xn() {
                var Le = fo(De());
                return e2.Debug.assert(Le.kind === 16 || Le.kind === 17, "Template fragment has wrong token kind"), Le;
              }
              function jr(Le) {
                var Nr = Le === 14 || Le === 17, ri = D.getTokenText();
                return ri.substring(1, ri.length - (D.isUnterminated() ? 0 : Nr ? 1 : 2));
              }
              function fo(Le) {
                var Nr = Ue(), ri = e2.isTemplateLiteralKind(Le) ? ge.createTemplateLiteralLikeNode(Le, D.getTokenValue(), jr(Le), D.getTokenFlags() & 2048) : Le === 8 ? ge.createNumericLiteral(D.getTokenValue(), D.getNumericLiteralFlags()) : Le === 10 ? ge.createStringLiteral(D.getTokenValue(), void 0, D.hasExtendedUnicodeEscape()) : e2.isLiteralKind(Le) ? ge.createLiteralLikeNode(Le, D.getTokenValue()) : e2.Debug.fail();
                return D.hasExtendedUnicodeEscape() && (ri.hasExtendedUnicodeEscape = true), D.isUnterminated() && (ri.isUnterminated = true), Tr(), Bi(ri, Nr);
              }
              function xs() {
                return ds(true, e2.Diagnostics.Type_expected);
              }
              function Fo() {
                if (!D.hasPrecedingLineBreak() && Li() === 29)
                  return js(20, Aa, 29, 31);
              }
              function ko() {
                var Le = Ue();
                return Bi(ge.createTypeReferenceNode(xs(), Fo()), Le);
              }
              function Ao(Le) {
                switch (Le.kind) {
                  case 178:
                    return e2.nodeIsMissing(Le.typeName);
                  case 179:
                  case 180: {
                    var Nr = Le, ri = Nr.parameters, di = Nr.type;
                    return Qs(ri) || Ao(di);
                  }
                  case 191:
                    return Ao(Le.type);
                  default:
                    return false;
                }
              }
              function Ms(Le) {
                return Tr(), Bi(ge.createTypePredicateNode(void 0, Le, Aa()), Le.pos);
              }
              function Bs() {
                var Le = Ue();
                return Tr(), Bi(ge.createThisTypeNode(), Le);
              }
              function xc() {
                var Le = Ue();
                return Tr(), Bi(ge.createJSDocAllType(), Le);
              }
              function su() {
                var Le = Ue();
                return Tr(), Bi(ge.createJSDocNonNullableType(yc(), false), Le);
              }
              function tl() {
                var Le = Ue();
                return Tr(), De() === 27 || De() === 19 || De() === 21 || De() === 31 || De() === 63 || De() === 51 ? Bi(ge.createJSDocUnknownType(), Le) : Bi(ge.createJSDocNullableType(Aa(), false), Le);
              }
              function Zc() {
                var Le = Ue(), Nr = fr();
                if (Rt(v)) {
                  Tr();
                  var ri = Ei(36), di = vc(58, false);
                  return wr(Bi(ge.createJSDocFunctionType(ri, di), Le), Nr);
                }
                return Bi(ge.createTypeReferenceNode(Rn(), void 0), Le);
              }
              function Rf() {
                var Le = Ue(), Nr;
                return (De() === 108 || De() === 103) && (Nr = Rn(), ui(58)), Bi(ge.createParameterDeclaration(void 0, void 0, void 0, Nr, void 0, al(), void 0), Le);
              }
              function al() {
                D.setInJSDocType(true);
                var Le = Ue();
                if (at(141)) {
                  var Nr = ge.createJSDocNamepathType(void 0);
                  e:
                    for (; ; )
                      switch (De()) {
                        case 19:
                        case 1:
                        case 27:
                        case 5:
                          break e;
                        default:
                          vi();
                      }
                  return D.setInJSDocType(false), Bi(Nr, Le);
                }
                var ri = at(25), di = gu();
                return D.setInJSDocType(false), ri && (di = Bi(ge.createJSDocVariadicType(di), Le)), De() === 63 ? (Tr(), Bi(ge.createJSDocOptionalType(di), Le)) : di;
              }
              function Jo() {
                var Le = Ue();
                ui(112);
                var Nr = ds(true), ri = D.hasPrecedingLineBreak() ? void 0 : m_();
                return Bi(ge.createTypeQueryNode(Nr, ri), Le);
              }
              function eu() {
                var Le = Ue(), Nr = Fc(), ri = eo(), di, Mi;
                at(94) && (Xr() || !qs() ? di = Aa() : Mi = kp());
                var st = at(63) ? Aa() : void 0, ra = ge.createTypeParameterDeclaration(Nr, ri, di, st);
                return ra.expression = Mi, Bi(ra, Le);
              }
              function Ws() {
                if (De() === 29)
                  return js(19, eu, 29, 31);
              }
              function pu(Le) {
                return De() === 25 || Hc() || e2.isModifierKind(De()) || De() === 59 || Xr(!Le);
              }
              function Uu(Le) {
                var Nr = Ol(e2.Diagnostics.Private_identifiers_cannot_be_used_as_parameters);
                return e2.getFullWidth(Nr) === 0 && !e2.some(Le) && e2.isModifierKind(De()) && Tr(), Nr;
              }
              function Ql() {
                return Ki() || De() === 22 || De() === 18;
              }
              function xl(Le) {
                return du(Le);
              }
              function Ya(Le) {
                return du(Le, false);
              }
              function du(Le, Nr) {
                Nr === void 0 && (Nr = true);
                var ri = Ue(), di = fr(), Mi = Le ? Jr(gl) : gl();
                if (De() === 108) {
                  var st = ge.createParameterDeclaration(Mi, void 0, void 0, Kn(true), void 0, va(), void 0);
                  return Mi && Mr(Mi[0], e2.Diagnostics.Decorators_may_not_be_applied_to_this_parameters), wr(Bi(st, ri), di);
                }
                var ra = Ne;
                Ne = false;
                var Ta = Fc(), ha = At(25);
                if (!(!Nr && !Ql())) {
                  var Na = wr(Bi(ge.createParameterDeclaration(Mi, Ta, ha, Uu(Ta), At(57), va(), nl()), ri), di);
                  return Ne = ra, Na;
                }
              }
              function vc(Le, Nr) {
                if (Kr(Le, Nr))
                  return _r(gu);
              }
              function Kr(Le, Nr) {
                return Le === 38 ? (ui(Le), true) : at(58) ? true : Nr && De() === 38 ? (Ar(e2.Diagnostics._0_expected, e2.tokenToString(58)), Tr(), true) : false;
              }
              function _i(Le, Nr) {
                var ri = Wr(), di = mr();
                Di(!!(Le & 1)), Xi(!!(Le & 2));
                var Mi = Le & 32 ? hs(17, Rf) : hs(16, function() {
                  return Nr ? xl(di) : Ya(di);
                });
                return Di(ri), Xi(di), Mi;
              }
              function Ei(Le) {
                if (!ui(20))
                  return ps();
                var Nr = _i(Le, true);
                return ui(21), Nr;
              }
              function tt() {
                at(27) || pn();
              }
              function kt(Le) {
                var Nr = Ue(), ri = fr();
                Le === 175 && ui(103);
                var di = Ws(), Mi = Ei(4), st = vc(58, true);
                tt();
                var ra = Le === 174 ? ge.createCallSignature(di, Mi, st) : ge.createConstructSignature(di, Mi, st);
                return wr(Bi(ra, Nr), ri);
              }
              function bt() {
                return De() === 22 && Rt(ia);
              }
              function ia() {
                if (Tr(), De() === 25 || De() === 23)
                  return true;
                if (e2.isModifierKind(De())) {
                  if (Tr(), Fi())
                    return true;
                } else if (Fi())
                  Tr();
                else
                  return false;
                return De() === 58 || De() === 27 ? true : De() !== 57 ? false : (Tr(), De() === 58 || De() === 27 || De() === 23);
              }
              function Xt(Le, Nr, ri, di) {
                var Mi = js(16, function() {
                  return xl(false);
                }, 22, 23), st = va();
                tt();
                var ra = ge.createIndexSignature(ri, di, Mi, st);
                return wr(Bi(ra, Le), Nr);
              }
              function Za(Le, Nr, ri) {
                var di = En(), Mi = At(57), st;
                if (De() === 20 || De() === 29) {
                  var ra = Ws(), Ta = Ei(4), ha = vc(58, true);
                  st = ge.createMethodSignature(ri, di, Mi, ra, Ta, ha);
                } else {
                  var ha = va();
                  st = ge.createPropertySignature(ri, di, Mi, ha), De() === 63 && (st.initializer = nl());
                }
                return tt(), wr(Bi(st, Le), Nr);
              }
              function bn() {
                if (De() === 20 || De() === 29 || De() === 136 || De() === 149)
                  return true;
                for (var Le = false; e2.isModifierKind(De()); )
                  Le = true, Tr();
                return De() === 22 ? true : (Da() && (Le = true, Tr()), Le ? De() === 20 || De() === 29 || De() === 57 || De() === 58 || De() === 27 || ka() : false);
              }
              function _a4() {
                if (De() === 20 || De() === 29)
                  return kt(174);
                if (De() === 103 && Rt(qa))
                  return kt(175);
                var Le = Ue(), Nr = fr(), ri = Fc();
                return Ko(136) ? Gu(Le, Nr, void 0, ri, 172) : Ko(149) ? Gu(Le, Nr, void 0, ri, 173) : bt() ? Xt(Le, Nr, void 0, ri) : Za(Le, Nr, ri);
              }
              function qa() {
                return Tr(), De() === 20 || De() === 29;
              }
              function rn() {
                return Tr() === 24;
              }
              function jn() {
                switch (Tr()) {
                  case 20:
                  case 29:
                  case 24:
                    return true;
                }
                return false;
              }
              function Mo() {
                var Le = Ue();
                return Bi(ge.createTypeLiteralNode(ho()), Le);
              }
              function ho() {
                var Le;
                return ui(18) ? (Le = Qi(4, _a4), ui(19)) : Le = ps(), Le;
              }
              function gs() {
                return Tr(), De() === 39 || De() === 40 ? Tr() === 145 : (De() === 145 && Tr(), De() === 22 && Qe() && Tr() === 101);
              }
              function Se() {
                var Le = Ue(), Nr = Rn();
                ui(101);
                var ri = Aa();
                return Bi(ge.createTypeParameterDeclaration(void 0, Nr, ri, void 0), Le);
              }
              function hr() {
                var Le = Ue();
                ui(18);
                var Nr;
                (De() === 145 || De() === 39 || De() === 40) && (Nr = ai(), Nr.kind !== 145 && ui(145)), ui(22);
                var ri = Se(), di = at(127) ? Aa() : void 0;
                ui(23);
                var Mi;
                (De() === 57 || De() === 39 || De() === 40) && (Mi = ai(), Mi.kind !== 57 && ui(57));
                var st = va();
                pn();
                var ra = Qi(4, _a4);
                return ui(19), Bi(ge.createMappedTypeNode(Nr, ri, di, Mi, st, ra), Le);
              }
              function Or() {
                var Le = Ue();
                if (at(25))
                  return Bi(ge.createRestTypeNode(Aa()), Le);
                var Nr = Aa();
                if (e2.isJSDocNullableType(Nr) && Nr.pos === Nr.type.pos) {
                  var ri = ge.createOptionalTypeNode(Nr.type);
                  return e2.setTextRange(ri, Nr), ri.flags = Nr.flags, ri;
                }
                return Nr;
              }
              function ki() {
                return Tr() === 58 || De() === 57 && Tr() === 58;
              }
              function dt() {
                return De() === 25 ? e2.tokenIsIdentifierOrKeyword(Tr()) && ki() : e2.tokenIsIdentifierOrKeyword(De()) && ki();
              }
              function la() {
                if (Rt(dt)) {
                  var Le = Ue(), Nr = fr(), ri = At(25), di = Rn(), Mi = At(57);
                  ui(58);
                  var st = Or(), ra = ge.createNamedTupleMember(ri, di, Mi, st);
                  return wr(Bi(ra, Le), Nr);
                }
                return Or();
              }
              function wa() {
                var Le = Ue();
                return Bi(ge.createTupleTypeNode(js(21, la, 22, 23)), Le);
              }
              function On() {
                var Le = Ue();
                ui(20);
                var Nr = Aa();
                return ui(21), Bi(ge.createParenthesizedType(Nr), Le);
              }
              function No() {
                var Le;
                if (De() === 126) {
                  var Nr = Ue();
                  Tr();
                  var ri = Bi(ge.createToken(126), Nr);
                  Le = Cn([ri], Nr);
                }
                return Le;
              }
              function jo() {
                var Le = Ue(), Nr = fr(), ri = No(), di = at(103), Mi = Ws(), st = Ei(4), ra = vc(38, false), Ta = di ? ge.createConstructorTypeNode(ri, Mi, st, ra) : ge.createFunctionTypeNode(Mi, st, ra);
                return di || (Ta.modifiers = ri), wr(Bi(Ta, Le), Nr);
              }
              function po() {
                var Le = ai();
                return De() === 24 ? void 0 : Le;
              }
              function Gn(Le) {
                var Nr = Ue();
                Le && Tr();
                var ri = De() === 110 || De() === 95 || De() === 104 ? ai() : fo(De());
                return Le && (ri = Bi(ge.createPrefixUnaryExpression(40, ri), Nr)), Bi(ge.createLiteralTypeNode(ri), Nr);
              }
              function $n() {
                return Tr(), De() === 100;
              }
              function Ho() {
                var Le = Ue(), Nr = D.getTokenPos();
                ui(18);
                var ri = D.hasPrecedingLineBreak();
                ui(129), ui(58);
                var di = Ha(true);
                if (!ui(19)) {
                  var Mi = e2.lastOrUndefined(_e);
                  Mi && Mi.code === e2.Diagnostics._0_expected.code && e2.addRelatedInfo(Mi, e2.createDetachedDiagnostic(Re, Nr, 1, e2.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, "{", "}"));
                }
                return Bi(ge.createImportTypeAssertionContainer(di, ri), Le);
              }
              function Zo() {
                ze |= 2097152;
                var Le = Ue(), Nr = at(112);
                ui(100), ui(20);
                var ri = Aa(), di;
                at(27) && (di = Ho()), ui(21);
                var Mi = at(24) ? xs() : void 0, st = Fo();
                return Bi(ge.createImportTypeNode(ri, di, Mi, st, Nr), Le);
              }
              function Es() {
                return Tr(), De() === 8 || De() === 9;
              }
              function yc() {
                switch (De()) {
                  case 130:
                  case 155:
                  case 150:
                  case 147:
                  case 158:
                  case 151:
                  case 133:
                  case 153:
                  case 143:
                  case 148:
                    return Ii(po) || ko();
                  case 66:
                    D.reScanAsteriskEqualsToken();
                  case 41:
                    return xc();
                  case 60:
                    D.reScanQuestionToken();
                  case 57:
                    return tl();
                  case 98:
                    return Zc();
                  case 53:
                    return su();
                  case 14:
                  case 10:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 104:
                    return Gn();
                  case 40:
                    return Rt(Es) ? Gn(true) : ko();
                  case 114:
                    return ai();
                  case 108: {
                    var Le = Bs();
                    return De() === 139 && !D.hasPrecedingLineBreak() ? Ms(Le) : Le;
                  }
                  case 112:
                    return Rt($n) ? Zo() : Jo();
                  case 18:
                    return Rt(gs) ? hr() : Mo();
                  case 22:
                    return wa();
                  case 20:
                    return On();
                  case 100:
                    return Zo();
                  case 128:
                    return Rt(Pu) ? sd() : ko();
                  case 15:
                    return qi();
                  default:
                    return ko();
                }
              }
              function Xr(Le) {
                switch (De()) {
                  case 130:
                  case 155:
                  case 150:
                  case 147:
                  case 158:
                  case 133:
                  case 145:
                  case 151:
                  case 154:
                  case 114:
                  case 153:
                  case 104:
                  case 108:
                  case 112:
                  case 143:
                  case 18:
                  case 22:
                  case 29:
                  case 51:
                  case 50:
                  case 103:
                  case 10:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 148:
                  case 41:
                  case 57:
                  case 53:
                  case 25:
                  case 137:
                  case 100:
                  case 128:
                  case 14:
                  case 15:
                    return true;
                  case 98:
                    return !Le;
                  case 40:
                    return !Le && Rt(Es);
                  case 20:
                    return !Le && Rt(Ls);
                  default:
                    return Fi();
                }
              }
              function Ls() {
                return Tr(), De() === 21 || pu(false) || Xr();
              }
              function Ic() {
                for (var Le = Ue(), Nr = yc(); !D.hasPrecedingLineBreak(); )
                  switch (De()) {
                    case 53:
                      Tr(), Nr = Bi(ge.createJSDocNonNullableType(Nr, true), Le);
                      break;
                    case 57:
                      if (Rt(br))
                        return Nr;
                      Tr(), Nr = Bi(ge.createJSDocNullableType(Nr, true), Le);
                      break;
                    case 22:
                      if (ui(22), Xr()) {
                        var ri = Aa();
                        ui(23), Nr = Bi(ge.createIndexedAccessTypeNode(Nr, ri), Le);
                      } else
                        ui(23), Nr = Bi(ge.createArrayTypeNode(Nr), Le);
                      break;
                    default:
                      return Nr;
                  }
                return Nr;
              }
              function zu(Le) {
                var Nr = Ue();
                return ui(Le), Bi(ge.createTypeOperatorNode(Le, vp()), Nr);
              }
              function vf() {
                if (at(94)) {
                  var Le = pi(Aa);
                  if (xe() || De() !== 57)
                    return Le;
                }
              }
              function P_() {
                var Le = Ue(), Nr = eo(), ri = Ii(vf), di = ge.createTypeParameterDeclaration(void 0, Nr, ri);
                return Bi(di, Le);
              }
              function El() {
                var Le = Ue();
                return ui(137), Bi(ge.createInferTypeNode(P_()), Le);
              }
              function vp() {
                var Le = De();
                switch (Le) {
                  case 140:
                  case 154:
                  case 145:
                    return zu(Le);
                  case 137:
                    return El();
                }
                return _r(Ic);
              }
              function oo(Le) {
                if (Cl()) {
                  var Nr = jo(), ri = void 0;
                  return e2.isFunctionTypeNode(Nr) ? ri = Le ? e2.Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_a_union_type : e2.Diagnostics.Function_type_notation_must_be_parenthesized_when_used_in_an_intersection_type : ri = Le ? e2.Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_a_union_type : e2.Diagnostics.Constructor_type_notation_must_be_parenthesized_when_used_in_an_intersection_type, Mr(Nr, ri), Nr;
                }
              }
              function I_(Le, Nr, ri) {
                var di = Ue(), Mi = Le === 51, st = at(Le), ra = st && oo(Mi) || Nr();
                if (De() === Le || st) {
                  for (var Ta = [ra]; at(Le); )
                    Ta.push(oo(Mi) || Nr());
                  ra = Bi(ri(Cn(Ta, di)), di);
                }
                return ra;
              }
              function yp() {
                return I_(50, vp, ge.createIntersectionTypeNode);
              }
              function Yl() {
                return I_(51, yp, ge.createUnionTypeNode);
              }
              function Bf() {
                return Tr(), De() === 103;
              }
              function Cl() {
                return De() === 29 || De() === 20 && Rt(hp) ? true : De() === 103 || De() === 126 && Rt(Bf);
              }
              function c_() {
                if (e2.isModifierKind(De()) && Fc(), Fi() || De() === 108)
                  return Tr(), true;
                if (De() === 22 || De() === 18) {
                  var Le = _e.length;
                  return Ol(), Le === _e.length;
                }
                return false;
              }
              function hp() {
                return Tr(), !!(De() === 21 || De() === 25 || c_() && (De() === 58 || De() === 27 || De() === 57 || De() === 63 || De() === 21 && (Tr(), De() === 38)));
              }
              function gu() {
                var Le = Ue(), Nr = Fi() && Ii(Dp), ri = Aa();
                return Nr ? Bi(ge.createTypePredicateNode(void 0, Nr, ri), Le) : ri;
              }
              function Dp() {
                var Le = eo();
                if (De() === 139 && !D.hasPrecedingLineBreak())
                  return Tr(), Le;
              }
              function sd() {
                var Le = Ue(), Nr = $a(128), ri = De() === 108 ? Bs() : eo(), di = at(139) ? Aa() : void 0;
                return Bi(ge.createTypePredicateNode(Nr, ri, di), Le);
              }
              function Aa() {
                if (Er & 40960)
                  return et(40960, Aa);
                if (Cl())
                  return jo();
                var Le = Ue(), Nr = Yl();
                if (!xe() && !D.hasPrecedingLineBreak() && at(94)) {
                  var ri = pi(Aa);
                  ui(57);
                  var di = _r(Aa);
                  ui(58);
                  var Mi = _r(Aa);
                  return Bi(ge.createConditionalTypeNode(Nr, ri, di, Mi), Le);
                }
                return Nr;
              }
              function va() {
                return at(58) ? Aa() : void 0;
              }
              function Cu() {
                switch (De()) {
                  case 108:
                  case 106:
                  case 104:
                  case 110:
                  case 95:
                  case 8:
                  case 9:
                  case 10:
                  case 14:
                  case 15:
                  case 20:
                  case 22:
                  case 18:
                  case 98:
                  case 84:
                  case 103:
                  case 43:
                  case 68:
                  case 79:
                    return true;
                  case 100:
                    return Rt(jn);
                  default:
                    return Fi();
                }
              }
              function qs() {
                if (Cu())
                  return true;
                switch (De()) {
                  case 39:
                  case 40:
                  case 54:
                  case 53:
                  case 89:
                  case 112:
                  case 114:
                  case 45:
                  case 46:
                  case 29:
                  case 132:
                  case 125:
                  case 80:
                    return true;
                  default:
                    return xp() ? true : Fi();
                }
              }
              function cd() {
                return De() !== 18 && De() !== 98 && De() !== 84 && De() !== 59 && qs();
              }
              function ns() {
                var Le = vr();
                Le && wi(false);
                for (var Nr = Ue(), ri = hc(), di; di = At(27); )
                  ri = M_(ri, di, hc(), Nr);
                return Le && wi(true), ri;
              }
              function nl() {
                return at(63) ? hc() : void 0;
              }
              function hc() {
                if (es())
                  return Jf();
                var Le = ud() || bp();
                if (Le)
                  return Le;
                var Nr = Ue(), ri = O_(0);
                return ri.kind === 79 && De() === 38 ? w_(Nr, ri, void 0) : e2.isLeftHandSideExpression(ri) && e2.isAssignmentOperator(Ui()) ? M_(ri, ai(), hc(), Nr) : jf(ri, Nr);
              }
              function es() {
                return De() === 125 ? Wr() ? true : Rt(so) : false;
              }
              function u_() {
                return Tr(), !D.hasPrecedingLineBreak() && Fi();
              }
              function Jf() {
                var Le = Ue();
                return Tr(), !D.hasPrecedingLineBreak() && (De() === 41 || qs()) ? Bi(ge.createYieldExpression(At(41), hc()), Le) : Bi(ge.createYieldExpression(void 0, void 0), Le);
              }
              function w_(Le, Nr, ri) {
                e2.Debug.assert(De() === 38, "parseSimpleArrowFunctionExpression should only have been called if we had a =>");
                var di = ge.createParameterDeclaration(void 0, void 0, void 0, Nr, void 0, void 0, void 0);
                Bi(di, Nr.pos);
                var Mi = Cn([di], di.pos, di.end), st = $a(38), ra = _d2(!!ri), Ta = ge.createArrowFunction(ri, void 0, Mi, void 0, st, ra);
                return ii(Bi(Ta, Le));
              }
              function ud() {
                var Le = ku();
                if (Le !== 0)
                  return Le === 1 ? Tp(true) : Ii(fd);
              }
              function ku() {
                return De() === 20 || De() === 29 || De() === 131 ? Rt(ld) : De() === 38 ? 1 : 0;
              }
              function ld() {
                if (De() === 131 && (Tr(), D.hasPrecedingLineBreak() || De() !== 20 && De() !== 29))
                  return 0;
                var Le = De(), Nr = Tr();
                if (Le === 20) {
                  if (Nr === 21) {
                    var ri = Tr();
                    switch (ri) {
                      case 38:
                      case 58:
                      case 18:
                        return 1;
                      default:
                        return 0;
                    }
                  }
                  if (Nr === 22 || Nr === 18)
                    return 2;
                  if (Nr === 25)
                    return 1;
                  if (e2.isModifierKind(Nr) && Nr !== 131 && Rt(Qe))
                    return Rt(function() {
                      return Tr() === 127;
                    }) ? 0 : 1;
                  if (!Fi() && Nr !== 108)
                    return 0;
                  switch (Tr()) {
                    case 58:
                      return 1;
                    case 57:
                      return Tr(), De() === 58 || De() === 27 || De() === 63 || De() === 21 ? 1 : 0;
                    case 27:
                    case 63:
                    case 21:
                      return 2;
                  }
                  return 0;
                } else {
                  if (e2.Debug.assert(Le === 29), !Fi())
                    return 0;
                  if (Ie === 1) {
                    var di = Rt(function() {
                      var Mi = Tr();
                      if (Mi === 94) {
                        var st = Tr();
                        switch (st) {
                          case 63:
                          case 31:
                            return false;
                          default:
                            return true;
                        }
                      } else if (Mi === 27 || Mi === 63)
                        return true;
                      return false;
                    });
                    return di ? 1 : 0;
                  }
                  return 2;
                }
              }
              function fd() {
                var Le = D.getTokenPos();
                if (!(Br != null && Br.has(Le))) {
                  var Nr = Tp(false);
                  return Nr || (Br || (Br = new e2.Set())).add(Le), Nr;
                }
              }
              function bp() {
                if (De() === 131 && Rt(Sp) === 1) {
                  var Le = Ue(), Nr = Hu(), ri = O_(0);
                  return w_(Le, ri, Nr);
                }
              }
              function Sp() {
                if (De() === 131) {
                  if (Tr(), D.hasPrecedingLineBreak() || De() === 38)
                    return 0;
                  var Le = O_(0);
                  if (!D.hasPrecedingLineBreak() && Le.kind === 79 && De() === 38)
                    return 1;
                }
                return 0;
              }
              function Tp(Le) {
                var Nr = Ue(), ri = fr(), di = Hu(), Mi = e2.some(di, e2.isAsyncModifier) ? 2 : 0, st = Ws(), ra;
                if (ui(20)) {
                  if (Le)
                    ra = _i(Mi, Le);
                  else {
                    var Ta = _i(Mi, Le);
                    if (!Ta)
                      return;
                    ra = Ta;
                  }
                  if (!ui(21) && !Le)
                    return;
                } else {
                  if (!Le)
                    return;
                  ra = ps();
                }
                var ha = vc(58, false);
                if (!(ha && !Le && Ao(ha))) {
                  for (var Na = ha; (Na == null ? void 0 : Na.kind) === 191; )
                    Na = Na.type;
                  var In = Na && e2.isJSDocFunctionType(Na);
                  if (!(!Le && De() !== 38 && (In || De() !== 18))) {
                    var qo = De(), co = $a(38), ts = qo === 38 || qo === 18 ? _d2(e2.some(di, e2.isAsyncModifier)) : eo(), vs = ge.createArrowFunction(di, st, ra, ha, co, ts);
                    return wr(Bi(vs, Nr), ri);
                  }
                }
              }
              function _d2(Le) {
                if (De() === 18)
                  return Cc(Le ? 2 : 0);
                if (De() !== 26 && De() !== 98 && De() !== 84 && Ku() && !cd())
                  return Cc(16 | (Le ? 2 : 0));
                var Nr = Ne;
                Ne = false;
                var ri = Le ? Jr(hc) : ti(hc);
                return Ne = Nr, ri;
              }
              function jf(Le, Nr) {
                var ri = At(57);
                if (!ri)
                  return Le;
                var di;
                return Bi(ge.createConditionalExpression(Le, ri, et(fe, hc), di = $a(58), e2.nodeIsPresent(di) ? hc() : kn(79, false, e2.Diagnostics._0_expected, e2.tokenToString(58))), Nr);
              }
              function O_(Le) {
                var Nr = Ue(), ri = kp();
                return pd(Le, ri, Nr);
              }
              function F_(Le) {
                return Le === 101 || Le === 160;
              }
              function pd(Le, Nr, ri) {
                for (; ; ) {
                  Ui();
                  var di = e2.getBinaryOperatorPrecedence(De()), Mi = De() === 42 ? di >= Le : di > Le;
                  if (!Mi || De() === 101 && Je())
                    break;
                  if (De() === 127) {
                    if (D.hasPrecedingLineBreak())
                      break;
                    Tr(), Nr = Ep(Nr, Aa());
                  } else
                    Nr = M_(Nr, ai(), O_(di), ri);
                }
                return Nr;
              }
              function xp() {
                return Je() && De() === 101 ? false : e2.getBinaryOperatorPrecedence(De()) > 0;
              }
              function M_(Le, Nr, ri, di) {
                return Bi(ge.createBinaryExpression(Le, Nr, ri), di);
              }
              function Ep(Le, Nr) {
                return Bi(ge.createAsExpression(Le, Nr), Le.pos);
              }
              function ol() {
                var Le = Ue();
                return Bi(ge.createPrefixUnaryExpression(De(), Vr(mu)), Le);
              }
              function Au() {
                var Le = Ue();
                return Bi(ge.createDeleteExpression(Vr(mu)), Le);
              }
              function ru() {
                var Le = Ue();
                return Bi(ge.createTypeOfExpression(Vr(mu)), Le);
              }
              function yf() {
                var Le = Ue();
                return Bi(ge.createVoidExpression(Vr(mu)), Le);
              }
              function Cp() {
                return De() === 132 ? mr() ? true : Rt(so) : false;
              }
              function dd() {
                var Le = Ue();
                return Bi(ge.createAwaitExpression(Vr(mu)), Le);
              }
              function kp() {
                if (gd()) {
                  var Le = Ue(), Nr = hf();
                  return De() === 42 ? pd(e2.getBinaryOperatorPrecedence(De()), Nr, Le) : Nr;
                }
                var ri = De(), di = mu();
                if (De() === 42) {
                  var Le = e2.skipTrivia(Ee, di.pos), Mi = di.end;
                  di.kind === 211 ? nr(Le, Mi, e2.Diagnostics.A_type_assertion_expression_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses) : nr(Le, Mi, e2.Diagnostics.An_unary_expression_with_the_0_operator_is_not_allowed_in_the_left_hand_side_of_an_exponentiation_expression_Consider_enclosing_the_expression_in_parentheses, e2.tokenToString(ri));
                }
                return di;
              }
              function mu() {
                switch (De()) {
                  case 39:
                  case 40:
                  case 54:
                  case 53:
                    return ol();
                  case 89:
                    return Au();
                  case 112:
                    return ru();
                  case 114:
                    return yf();
                  case 29:
                    return qu();
                  case 132:
                    if (Cp())
                      return dd();
                  default:
                    return hf();
                }
              }
              function gd() {
                switch (De()) {
                  case 39:
                  case 40:
                  case 54:
                  case 53:
                  case 89:
                  case 112:
                  case 114:
                  case 132:
                    return false;
                  case 29:
                    if (Ie !== 1)
                      return false;
                  default:
                    return true;
                }
              }
              function hf() {
                if (De() === 45 || De() === 46) {
                  var Le = Ue();
                  return Bi(ge.createPrefixUnaryExpression(De(), Vr($l)), Le);
                } else if (Ie === 1 && De() === 29 && Rt(S2))
                  return l_(true);
                var Nr = $l();
                if (e2.Debug.assert(e2.isLeftHandSideExpression(Nr)), (De() === 45 || De() === 46) && !D.hasPrecedingLineBreak()) {
                  var ri = De();
                  return Tr(), Bi(ge.createPostfixUnaryExpression(Nr, ri), Nr.pos);
                }
                return Nr;
              }
              function $l() {
                var Le = Ue(), Nr;
                return De() === 100 ? Rt(qa) ? (ze |= 2097152, Nr = ai()) : Rt(rn) ? (Tr(), Tr(), Nr = Bi(ge.createMetaProperty(100, Rn()), Le), ze |= 4194304) : Nr = Uf() : Nr = De() === 106 ? L_() : Uf(), Ps(Le, Nr);
              }
              function Uf() {
                var Le = Ue(), Nr = vu();
                return Ec(Le, Nr, true);
              }
              function L_() {
                var Le = Ue(), Nr = ai();
                if (De() === 29) {
                  var ri = Ue(), di = Ii(Gc);
                  di !== void 0 && nr(ri, Ue(), e2.Diagnostics.super_may_not_use_type_arguments);
                }
                return De() === 20 || De() === 24 || De() === 22 ? Nr : ($a(24, e2.Diagnostics.super_must_be_followed_by_an_argument_list_or_member_access), Bi(ge.createPropertyAccessExpression(Nr, ce(true, true)), Le));
              }
              function l_(Le, Nr, ri) {
                var di = Ue(), Mi = Zl(Le), st;
                if (Mi.kind === 280) {
                  var ra = ks(Mi), Ta = void 0, ha = ra[ra.length - 1];
                  if ((ha == null ? void 0 : ha.kind) === 278 && !l(ha.openingElement.tagName, ha.closingElement.tagName) && l(Mi.tagName, ha.closingElement.tagName)) {
                    var Na = ha.children.end, In = Bi(ge.createJsxElement(ha.openingElement, ha.children, Bi(ge.createJsxClosingElement(Bi(ge.createIdentifier(""), Na, Na)), Na, Na)), ha.openingElement.pos, Na);
                    ra = Cn(Ve(Ve([], ra.slice(0, ra.length - 1), true), [In], false), ra.pos, Na), Ta = ha.closingElement;
                  } else
                    Ta = Al(Mi, Le), l(Mi.tagName, Ta.tagName) || (ri && e2.isJsxOpeningElement(ri) && l(Ta.tagName, ri.tagName) ? Mr(Mi.tagName, e2.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, e2.getTextOfNodeFromSourceText(Ee, Mi.tagName)) : Mr(Ta.tagName, e2.Diagnostics.Expected_corresponding_JSX_closing_tag_for_0, e2.getTextOfNodeFromSourceText(Ee, Mi.tagName)));
                  st = Bi(ge.createJsxElement(Mi, ra, Ta), di);
                } else
                  Mi.kind === 283 ? st = Bi(ge.createJsxFragment(Mi, ks(Mi), wc(Le)), di) : (e2.Debug.assert(Mi.kind === 279), st = Mi);
                if (Le && De() === 29) {
                  var qo = typeof Nr > "u" ? st.pos : Nr, co = Ii(function() {
                    return l_(true, qo);
                  });
                  if (co) {
                    var ts = kn(27, false);
                    return e2.setTextRangePosWidth(ts, co.pos, 0), nr(e2.skipTrivia(Ee, qo), co.end, e2.Diagnostics.JSX_expressions_must_have_one_parent_element), Bi(ge.createBinaryExpression(st, ts, co), di);
                  }
                }
                return st;
              }
              function f_() {
                var Le = Ue(), Nr = ge.createJsxText(D.getTokenValue(), ye === 12);
                return ye = D.scanJsxToken(), Bi(Nr, Le);
              }
              function md(Le, Nr) {
                switch (Nr) {
                  case 1:
                    if (e2.isJsxOpeningFragment(Le))
                      Mr(Le, e2.Diagnostics.JSX_fragment_has_no_corresponding_closing_tag);
                    else {
                      var ri = Le.tagName, di = e2.skipTrivia(Ee, ri.pos);
                      nr(di, ri.end, e2.Diagnostics.JSX_element_0_has_no_corresponding_closing_tag, e2.getTextOfNodeFromSourceText(Ee, Le.tagName));
                    }
                    return;
                  case 30:
                  case 7:
                    return;
                  case 11:
                  case 12:
                    return f_();
                  case 18:
                    return kl(false);
                  case 29:
                    return l_(false, void 0, Le);
                  default:
                    return e2.Debug.assertNever(Nr);
                }
              }
              function ks(Le) {
                var Nr = [], ri = Ue(), di = Ye;
                for (Ye |= 1 << 14; ; ) {
                  var Mi = md(Le, ye = D.reScanJsxToken());
                  if (!Mi || (Nr.push(Mi), e2.isJsxOpeningElement(Le) && (Mi == null ? void 0 : Mi.kind) === 278 && !l(Mi.openingElement.tagName, Mi.closingElement.tagName) && l(Le.tagName, Mi.closingElement.tagName)))
                    break;
                }
                return Ye = di, Cn(Nr, ri);
              }
              function Wu() {
                var Le = Ue();
                return Bi(ge.createJsxAttributes(Qi(13, __)), Le);
              }
              function Zl(Le) {
                var Nr = Ue();
                if (ui(29), De() === 31)
                  return xt(), Bi(ge.createJsxOpeningFragment(), Nr);
                var ri = R_(), di = (Er & 262144) === 0 ? m_() : void 0, Mi = Wu(), st;
                return De() === 31 ? (xt(), st = ge.createJsxOpeningElement(ri, di, Mi)) : (ui(43), ui(31, void 0, false) && (Le ? Tr() : xt()), st = ge.createJsxSelfClosingElement(ri, di, Mi)), Bi(st, Nr);
              }
              function R_() {
                var Le = Ue();
                Mt();
                for (var Nr = De() === 108 ? ai() : Rn(); at(24); )
                  Nr = Bi(ge.createPropertyAccessExpression(Nr, ce(true, false)), Le);
                return Nr;
              }
              function kl(Le) {
                var Nr = Ue();
                if (!!ui(18)) {
                  var ri, di;
                  return De() !== 19 && (ri = At(25), di = ns()), Le ? ui(19) : ui(19, void 0, false) && xt(), Bi(ge.createJsxExpression(ri, di), Nr);
                }
              }
              function __() {
                if (De() === 18)
                  return zd();
                Mt();
                var Le = Ue();
                return Bi(ge.createJsxAttribute(Rn(), De() !== 63 ? void 0 : ut() === 10 ? ga() : kl(true)), Le);
              }
              function zd() {
                var Le = Ue();
                ui(18), ui(25);
                var Nr = ns();
                return ui(19), Bi(ge.createJsxSpreadAttribute(Nr), Le);
              }
              function Al(Le, Nr) {
                var ri = Ue();
                ui(30);
                var di = R_();
                return ui(31, void 0, false) && (Nr || !l(Le.tagName, di) ? Tr() : xt()), Bi(ge.createJsxClosingElement(di), ri);
              }
              function wc(Le) {
                var Nr = Ue();
                return ui(30), e2.tokenIsIdentifierOrKeyword(De()) && Mr(R_(), e2.Diagnostics.Expected_corresponding_closing_tag_for_JSX_fragment), ui(31, void 0, false) && (Le ? Tr() : xt()), Bi(ge.createJsxJsxClosingFragment(), Nr);
              }
              function qu() {
                var Le = Ue();
                ui(29);
                var Nr = Aa();
                ui(31);
                var ri = mu();
                return Bi(ge.createTypeAssertion(Nr, ri), Le);
              }
              function Vu() {
                return Tr(), e2.tokenIsIdentifierOrKeyword(De()) || De() === 22 || Zn();
              }
              function ef() {
                return De() === 28 && Rt(Vu);
              }
              function sl(Le) {
                if (Le.flags & 32)
                  return true;
                if (e2.isNonNullExpression(Le)) {
                  for (var Nr = Le.expression; e2.isNonNullExpression(Nr) && !(Nr.flags & 32); )
                    Nr = Nr.expression;
                  if (Nr.flags & 32) {
                    for (; e2.isNonNullExpression(Le); )
                      Le.flags |= 32, Le = Le.expression;
                    return true;
                  }
                }
                return false;
              }
              function p_(Le, Nr, ri) {
                var di = ce(true, true), Mi = ri || sl(Nr), st = Mi ? ge.createPropertyAccessChain(Nr, ri, di) : ge.createPropertyAccessExpression(Nr, di);
                return Mi && e2.isPrivateIdentifier(st.name) && Mr(st.name, e2.Diagnostics.An_optional_chain_cannot_contain_private_identifiers), Bi(st, Le);
              }
              function Df(Le, Nr, ri) {
                var di;
                if (De() === 23)
                  di = kn(79, true, e2.Diagnostics.An_element_access_expression_should_take_an_argument);
                else {
                  var Mi = Wt(ns);
                  e2.isStringOrNumericLiteralLike(Mi) && (Mi.text = xn(Mi.text)), di = Mi;
                }
                ui(23);
                var st = ri || sl(Nr) ? ge.createElementAccessChain(Nr, ri, di) : ge.createElementAccessExpression(Nr, di);
                return Bi(st, Le);
              }
              function Ec(Le, Nr, ri) {
                for (; ; ) {
                  var di = void 0, Mi = false;
                  if (ri && ef() ? (di = $a(28), Mi = e2.tokenIsIdentifierOrKeyword(De())) : Mi = at(24), Mi) {
                    Nr = p_(Le, Nr, di);
                    continue;
                  }
                  if ((di || !vr()) && at(22)) {
                    Nr = Df(Le, Nr, di);
                    continue;
                  }
                  if (Zn()) {
                    Nr = !di && Nr.kind === 228 ? os(Le, Nr.expression, di, Nr.typeArguments) : os(Le, Nr, di, void 0);
                    continue;
                  }
                  if (!di) {
                    if (De() === 53 && !D.hasPrecedingLineBreak()) {
                      Tr(), Nr = Bi(ge.createNonNullExpression(Nr), Le);
                      continue;
                    }
                    var st = Ii(Gc);
                    if (st) {
                      Nr = Bi(ge.createExpressionWithTypeArguments(Nr, st), Le);
                      continue;
                    }
                  }
                  return Nr;
                }
              }
              function Zn() {
                return De() === 14 || De() === 15;
              }
              function os(Le, Nr, ri, di) {
                var Mi = ge.createTaggedTemplateExpression(Nr, di, De() === 14 ? (ct(), ga()) : yi(true));
                return (ri || Nr.flags & 32) && (Mi.flags |= 32), Mi.questionDotToken = ri, Bi(Mi, Le);
              }
              function Ps(Le, Nr) {
                for (; ; ) {
                  Nr = Ec(Le, Nr, true);
                  var ri = void 0, di = At(28);
                  if (di && (ri = Ii(Gc), Zn())) {
                    Nr = os(Le, Nr, di, ri);
                    continue;
                  }
                  if (ri || De() === 20) {
                    !di && Nr.kind === 228 && (ri = Nr.typeArguments, Nr = Nr.expression);
                    var Mi = d_(), st = di || sl(Nr) ? ge.createCallChain(Nr, di, ri, Mi) : ge.createCallExpression(Nr, ri, Mi);
                    Nr = Bi(st, Le);
                    continue;
                  }
                  if (di) {
                    var ra = kn(79, false, e2.Diagnostics.Identifier_expected);
                    Nr = Bi(ge.createPropertyAccessChain(Nr, di, ra), Le);
                  }
                  break;
                }
                return Nr;
              }
              function d_() {
                ui(20);
                var Le = hs(11, Nl);
                return ui(21), Le;
              }
              function Gc() {
                if ((Er & 262144) === 0 && Li() === 29) {
                  Tr();
                  var Le = hs(20, Aa);
                  if (!!ui(31))
                    return Le && B_() ? Le : void 0;
                }
              }
              function B_() {
                switch (De()) {
                  case 20:
                  case 14:
                  case 15:
                    return true;
                }
                return !qs();
              }
              function vu() {
                switch (De()) {
                  case 8:
                  case 9:
                  case 10:
                  case 14:
                    return ga();
                  case 108:
                  case 106:
                  case 104:
                  case 110:
                  case 95:
                    return ai();
                  case 20:
                    return Gt();
                  case 22:
                    return cl();
                  case 18:
                    return Ut();
                  case 131:
                    if (!Rt(Iu))
                      break;
                    return Ds();
                  case 84:
                    return tn();
                  case 98:
                    return Ds();
                  case 103:
                    return bs();
                  case 43:
                  case 68:
                    if (Yi() === 13)
                      return ga();
                    break;
                  case 15:
                    return yi(false);
                  case 80:
                    return Co();
                }
                return eo(e2.Diagnostics.Expression_expected);
              }
              function Gt() {
                var Le = Ue(), Nr = fr();
                ui(20);
                var ri = Wt(ns);
                return ui(21), wr(Bi(ge.createParenthesizedExpression(ri), Le), Nr);
              }
              function As() {
                var Le = Ue();
                ui(25);
                var Nr = hc();
                return Bi(ge.createSpreadElement(Nr), Le);
              }
              function vn() {
                return De() === 25 ? As() : De() === 27 ? Bi(ge.createOmittedExpression(), Ue()) : hc();
              }
              function Nl() {
                return et(fe, vn);
              }
              function cl() {
                var Le = Ue(), Nr = D.getTokenPos(), ri = ui(22), di = D.hasPrecedingLineBreak(), Mi = hs(15, vn);
                return Vi(22, 23, ri, Nr), Bi(ge.createArrayLiteralExpression(Mi, di), Le);
              }
              function rf() {
                var Le = Ue(), Nr = fr();
                if (At(25)) {
                  var ri = hc();
                  return wr(Bi(ge.createSpreadAssignment(ri), Le), Nr);
                }
                var di = gl(), Mi = Fc();
                if (Ko(136))
                  return Gu(Le, Nr, di, Mi, 172);
                if (Ko(149))
                  return Gu(Le, Nr, di, Mi, 173);
                var st = At(41), ra = Fi(), Ta = En(), ha = At(57), Na = At(53);
                if (st || De() === 20 || De() === 29)
                  return pl(Le, Nr, di, Mi, st, Ta, ha, Na);
                var In, qo = ra && De() !== 58;
                if (qo) {
                  var co = At(63), ts = co ? Wt(hc) : void 0;
                  In = ge.createShorthandPropertyAssignment(Ta, ts), In.equalsToken = co;
                } else {
                  ui(58);
                  var vs = Wt(hc);
                  In = ge.createPropertyAssignment(Ta, vs);
                }
                return In.decorators = di, In.modifiers = Mi, In.questionToken = ha, In.exclamationToken = Na, wr(Bi(In, Le), Nr);
              }
              function Ut() {
                var Le = Ue(), Nr = D.getTokenPos(), ri = ui(18), di = D.hasPrecedingLineBreak(), Mi = hs(12, rf, true);
                return Vi(18, 19, ri, Nr), Bi(ge.createObjectLiteralExpression(Mi, di), Le);
              }
              function Ds() {
                var Le = vr();
                wi(false);
                var Nr = Ue(), ri = fr(), di = Fc();
                ui(98);
                var Mi = At(41), st = Mi ? 1 : 0, ra = e2.some(di, e2.isAsyncModifier) ? 2 : 0, Ta = st && ra ? Ze(bf) : st ? ae(bf) : ra ? Jr(bf) : bf(), ha = Ws(), Na = Ei(st | ra), In = vc(58, false), qo = Cc(st | ra);
                wi(Le);
                var co = ge.createFunctionExpression(di, Mi, Ta, ha, Na, In, qo);
                return wr(Bi(co, Nr), ri);
              }
              function bf() {
                return Ki() ? Pn() : void 0;
              }
              function bs() {
                var Le = Ue();
                if (ui(103), at(24)) {
                  var Nr = Rn();
                  return Bi(ge.createMetaProperty(103, Nr), Le);
                }
                var ri = Ue(), di = Ec(ri, vu(), false), Mi;
                di.kind === 228 && (Mi = di.typeArguments, di = di.expression);
                var st = De() === 20 ? d_() : void 0;
                return Bi(ge.createNewExpression(di, Mi, st), Le);
              }
              function Dc(Le, Nr) {
                var ri = Ue(), di = fr(), Mi = D.getTokenPos(), st = ui(18, Nr);
                if (st || Le) {
                  var ra = D.hasPrecedingLineBreak(), Ta = Qi(1, nc);
                  Vi(18, 19, st, Mi);
                  var ha = wr(Bi(ge.createBlock(Ta, ra), ri), di);
                  return De() === 63 && (Ar(e2.Diagnostics.Declaration_or_statement_expected_This_follows_a_block_of_statements_so_if_you_intended_to_write_a_destructuring_assignment_you_might_need_to_wrap_the_the_whole_assignment_in_parentheses), Tr()), ha;
                } else {
                  var Ta = ps();
                  return wr(Bi(ge.createBlock(Ta, void 0), ri), di);
                }
              }
              function Cc(Le, Nr) {
                var ri = Wr();
                Di(!!(Le & 1));
                var di = mr();
                Xi(!!(Le & 2));
                var Mi = Ne;
                Ne = false;
                var st = vr();
                st && wi(false);
                var ra = Dc(!!(Le & 16), Nr);
                return st && wi(true), Ne = Mi, Di(ri), Xi(di), ra;
              }
              function ac() {
                var Le = Ue(), Nr = fr();
                return ui(26), wr(Bi(ge.createEmptyStatement(), Le), Nr);
              }
              function Pl() {
                var Le = Ue(), Nr = fr();
                ui(99);
                var ri = D.getTokenPos(), di = ui(20), Mi = Wt(ns);
                Vi(20, 21, di, ri);
                var st = nc(), ra = at(91) ? nc() : void 0;
                return wr(Bi(ge.createIfStatement(Mi, st, ra), Le), Nr);
              }
              function Il() {
                var Le = Ue(), Nr = fr();
                ui(90);
                var ri = nc();
                ui(115);
                var di = D.getTokenPos(), Mi = ui(20), st = Wt(ns);
                return Vi(20, 21, Mi, di), at(26), wr(Bi(ge.createDoStatement(ri, st), Le), Nr);
              }
              function zf() {
                var Le = Ue(), Nr = fr();
                ui(115);
                var ri = D.getTokenPos(), di = ui(20), Mi = Wt(ns);
                Vi(20, 21, di, ri);
                var st = nc();
                return wr(Bi(ge.createWhileStatement(Mi, st), Le), Nr);
              }
              function ul() {
                var Le = Ue(), Nr = fr();
                ui(97);
                var ri = At(132);
                ui(20);
                var di;
                De() !== 26 && (De() === 113 || De() === 119 || De() === 85 ? di = z_(true) : di = Zt(ns));
                var Mi;
                if (ri ? ui(160) : at(160)) {
                  var st = Wt(hc);
                  ui(21), Mi = ge.createForOfStatement(ri, di, st, nc());
                } else if (at(101)) {
                  var st = Wt(ns);
                  ui(21), Mi = ge.createForInStatement(di, st, nc());
                } else {
                  ui(26);
                  var ra = De() !== 26 && De() !== 21 ? Wt(ns) : void 0;
                  ui(26);
                  var Ta = De() !== 21 ? Wt(ns) : void 0;
                  ui(21), Mi = ge.createForStatement(di, ra, Ta, nc());
                }
                return wr(Bi(Mi, Le), Nr);
              }
              function Nu(Le) {
                var Nr = Ue(), ri = fr();
                ui(Le === 246 ? 81 : 86);
                var di = ka() ? void 0 : eo();
                pn();
                var Mi = Le === 246 ? ge.createBreakStatement(di) : ge.createContinueStatement(di);
                return wr(Bi(Mi, Nr), ri);
              }
              function Us() {
                var Le = Ue(), Nr = fr();
                ui(105);
                var ri = ka() ? void 0 : Wt(ns);
                return pn(), wr(Bi(ge.createReturnStatement(ri), Le), Nr);
              }
              function Ap() {
                var Le = Ue(), Nr = fr();
                ui(116);
                var ri = D.getTokenPos(), di = ui(20), Mi = Wt(ns);
                Vi(20, 21, di, ri);
                var st = Gi(33554432, nc);
                return wr(Bi(ge.createWithStatement(Mi, st), Le), Nr);
              }
              function Wf() {
                var Le = Ue(), Nr = fr();
                ui(82);
                var ri = Wt(ns);
                ui(58);
                var di = Qi(3, nc);
                return wr(Bi(ge.createCaseClause(ri, di), Le), Nr);
              }
              function Sf() {
                var Le = Ue();
                ui(88), ui(58);
                var Nr = Qi(3, nc);
                return Bi(ge.createDefaultClause(Nr), Le);
              }
              function ll() {
                return De() === 82 ? Wf() : Sf();
              }
              function J_() {
                var Le = Ue();
                ui(18);
                var Nr = Qi(2, ll);
                return ui(19), Bi(ge.createCaseBlock(Nr), Le);
              }
              function j_() {
                var Le = Ue(), Nr = fr();
                ui(107), ui(20);
                var ri = Wt(ns);
                ui(21);
                var di = J_();
                return wr(Bi(ge.createSwitchStatement(ri, di), Le), Nr);
              }
              function U_() {
                var Le = Ue(), Nr = fr();
                ui(109);
                var ri = D.hasPrecedingLineBreak() ? void 0 : Wt(ns);
                return ri === void 0 && (Cr++, ri = Bi(ge.createIdentifier(""), Ue())), Ba() || wt(ri), wr(Bi(ge.createThrowStatement(ri), Le), Nr);
              }
              function iu() {
                var Le = Ue(), Nr = fr();
                ui(111);
                var ri = Dc(false), di = De() === 83 ? vd() : void 0, Mi;
                return (!di || De() === 96) && (ui(96, e2.Diagnostics.catch_or_finally_expected), Mi = Dc(false)), wr(Bi(ge.createTryStatement(ri, di, Mi), Le), Nr);
              }
              function vd() {
                var Le = Ue();
                ui(83);
                var Nr;
                at(20) ? (Nr = xf(), ui(21)) : Nr = void 0;
                var ri = Dc(false);
                return Bi(ge.createCatchClause(Nr, ri), Le);
              }
              function qf() {
                var Le = Ue(), Nr = fr();
                return ui(87), pn(), wr(Bi(ge.createDebuggerStatement(), Le), Nr);
              }
              function dc() {
                var Le = Ue(), Nr = fr(), ri, di = De() === 20, Mi = Wt(ns);
                return e2.isIdentifier(Mi) && at(58) ? ri = ge.createLabeledStatement(Mi, nc()) : (Ba() || wt(Mi), ri = ge.createExpressionStatement(Mi), di && (Nr = false)), wr(Bi(ri, Le), Nr);
              }
              function Pu() {
                return Tr(), e2.tokenIsIdentifierOrKeyword(De()) && !D.hasPrecedingLineBreak();
              }
              function wl() {
                return Tr(), De() === 84 && !D.hasPrecedingLineBreak();
              }
              function Iu() {
                return Tr(), De() === 98 && !D.hasPrecedingLineBreak();
              }
              function so() {
                return Tr(), (e2.tokenIsIdentifierOrKeyword(De()) || De() === 8 || De() === 9 || De() === 10) && !D.hasPrecedingLineBreak();
              }
              function Et() {
                for (; ; )
                  switch (De()) {
                    case 113:
                    case 119:
                    case 85:
                    case 98:
                    case 84:
                    case 92:
                      return true;
                    case 118:
                    case 152:
                      return u_();
                    case 141:
                    case 142:
                      return Tf();
                    case 126:
                    case 131:
                    case 135:
                    case 121:
                    case 122:
                    case 123:
                    case 145:
                      if (Tr(), D.hasPrecedingLineBreak())
                        return false;
                      continue;
                    case 157:
                      return Tr(), De() === 18 || De() === 79 || De() === 93;
                    case 100:
                      return Tr(), De() === 10 || De() === 41 || De() === 18 || e2.tokenIsIdentifierOrKeyword(De());
                    case 93:
                      var Le = Tr();
                      if (Le === 152 && (Le = Rt(Tr)), Le === 63 || Le === 41 || Le === 18 || Le === 88 || Le === 127)
                        return true;
                      continue;
                    case 124:
                      Tr();
                      continue;
                    default:
                      return false;
                  }
              }
              function Ys() {
                return Rt(Et);
              }
              function Ku() {
                switch (De()) {
                  case 59:
                  case 26:
                  case 18:
                  case 113:
                  case 119:
                  case 98:
                  case 84:
                  case 92:
                  case 99:
                  case 90:
                  case 115:
                  case 97:
                  case 86:
                  case 81:
                  case 105:
                  case 116:
                  case 107:
                  case 109:
                  case 111:
                  case 87:
                  case 83:
                  case 96:
                    return true;
                  case 100:
                    return Ys() || Rt(jn);
                  case 85:
                  case 93:
                    return Ys();
                  case 131:
                  case 135:
                  case 118:
                  case 141:
                  case 142:
                  case 152:
                  case 157:
                    return true;
                  case 123:
                  case 121:
                  case 122:
                  case 124:
                  case 145:
                    return Ys() || !Rt(Pu);
                  default:
                    return qs();
                }
              }
              function Np() {
                return Tr(), Ki() || De() === 18 || De() === 22;
              }
              function Pp() {
                return Rt(Np);
              }
              function nc() {
                switch (De()) {
                  case 26:
                    return ac();
                  case 18:
                    return Dc(false);
                  case 113:
                    return rs(Ue(), fr(), void 0, void 0);
                  case 119:
                    if (Pp())
                      return rs(Ue(), fr(), void 0, void 0);
                    break;
                  case 98:
                    return Op(Ue(), fr(), void 0, void 0);
                  case 84:
                    return Ml(Ue(), fr(), void 0, void 0);
                  case 99:
                    return Pl();
                  case 90:
                    return Il();
                  case 115:
                    return zf();
                  case 97:
                    return ul();
                  case 86:
                    return Nu(245);
                  case 81:
                    return Nu(246);
                  case 105:
                    return Us();
                  case 116:
                    return Ap();
                  case 107:
                    return j_();
                  case 109:
                    return U_();
                  case 111:
                  case 83:
                  case 96:
                    return iu();
                  case 87:
                    return qf();
                  case 59:
                    return _l();
                  case 131:
                  case 118:
                  case 152:
                  case 141:
                  case 142:
                  case 135:
                  case 85:
                  case 92:
                  case 93:
                  case 100:
                  case 121:
                  case 122:
                  case 123:
                  case 126:
                  case 124:
                  case 145:
                  case 157:
                    if (Ys())
                      return _l();
                    break;
                }
                return dc();
              }
              function fl(Le) {
                return Le.kind === 135;
              }
              function _l() {
                var Le = e2.some(Rt(function() {
                  return gl(), Fc();
                }), fl);
                if (Le) {
                  var Nr = cu();
                  if (Nr)
                    return Nr;
                }
                var ri = Ue(), di = fr(), Mi = gl(), st = Fc();
                if (Le) {
                  for (var ra = 0, Ta = st; ra < Ta.length; ra++) {
                    var ha = Ta[ra];
                    ha.flags |= 16777216;
                  }
                  return Gi(16777216, function() {
                    return gc(ri, di, Mi, st);
                  });
                } else
                  return gc(ri, di, Mi, st);
              }
              function cu() {
                return Gi(16777216, function() {
                  var Le = sa(Ye);
                  if (Le)
                    return en(Le);
                });
              }
              function gc(Le, Nr, ri, di) {
                switch (De()) {
                  case 113:
                  case 119:
                  case 85:
                    return rs(Le, Nr, ri, di);
                  case 98:
                    return Op(Le, Nr, ri, di);
                  case 84:
                    return Ml(Le, Nr, ri, di);
                  case 118:
                    return v_(Le, Nr, ri, di);
                  case 152:
                    return Bp(Le, Nr, ri, di);
                  case 92:
                    return Xc(Le, Nr, ri, di);
                  case 157:
                  case 141:
                  case 142:
                    return V_(Le, Nr, ri, di);
                  case 100:
                    return Sa(Le, Nr, ri, di);
                  case 93:
                    switch (Tr(), De()) {
                      case 88:
                      case 63:
                        return Jp(Le, Nr, ri, di);
                      case 127:
                        return zi(Le, Nr, ri, di);
                      default:
                        return K_(Le, Nr, ri, di);
                    }
                  default:
                    if (ri || di) {
                      var Mi = kn(276, true, e2.Diagnostics.Declaration_expected);
                      return e2.setTextRangePos(Mi, Le), Mi.decorators = ri, Mi.modifiers = di, Mi;
                    }
                    return;
                }
              }
              function Tf() {
                return Tr(), !D.hasPrecedingLineBreak() && (Fi() || De() === 10);
              }
              function mc(Le, Nr) {
                if (De() !== 18 && ka()) {
                  pn();
                  return;
                }
                return Cc(Le, Nr);
              }
              function Ip() {
                var Le = Ue();
                if (De() === 27)
                  return Bi(ge.createOmittedExpression(), Le);
                var Nr = At(25), ri = Ol(), di = nl();
                return Bi(ge.createBindingElement(Nr, void 0, ri, di), Le);
              }
              function ms() {
                var Le = Ue(), Nr = At(25), ri = Ki(), di = En(), Mi;
                ri && De() !== 58 ? (Mi = di, di = void 0) : (ui(58), Mi = Ol());
                var st = nl();
                return Bi(ge.createBindingElement(Nr, di, Mi, st), Le);
              }
              function tu() {
                var Le = Ue();
                ui(18);
                var Nr = hs(9, ms);
                return ui(19), Bi(ge.createObjectBindingPattern(Nr), Le);
              }
              function wp() {
                var Le = Ue();
                ui(22);
                var Nr = hs(10, Ip);
                return ui(23), Bi(ge.createArrayBindingPattern(Nr), Le);
              }
              function Hc() {
                return De() === 18 || De() === 22 || De() === 80 || Ki();
              }
              function Ol(Le) {
                return De() === 22 ? wp() : De() === 18 ? tu() : Pn(Le);
              }
              function tf() {
                return xf(true);
              }
              function xf(Le) {
                var Nr = Ue(), ri = fr(), di = Ol(e2.Diagnostics.Private_identifiers_are_not_allowed_in_variable_declarations), Mi;
                Le && di.kind === 79 && De() === 53 && !D.hasPrecedingLineBreak() && (Mi = ai());
                var st = va(), ra = F_(De()) ? void 0 : nl(), Ta = ge.createVariableDeclaration(di, Mi, st, ra);
                return wr(Bi(Ta, Nr), ri);
              }
              function z_(Le) {
                var Nr = Ue(), ri = 0;
                switch (De()) {
                  case 113:
                    break;
                  case 119:
                    ri |= 1;
                    break;
                  case 85:
                    ri |= 2;
                    break;
                  default:
                    e2.Debug.fail();
                }
                Tr();
                var di;
                if (De() === 160 && Rt(Oc))
                  di = ps();
                else {
                  var Mi = Je();
                  si(Le), di = hs(8, Le ? xf : tf), si(Mi);
                }
                return Bi(ge.createVariableDeclarationList(di, ri), Nr);
              }
              function Oc() {
                return Qe() && Tr() === 21;
              }
              function rs(Le, Nr, ri, di) {
                var Mi = z_(false);
                pn();
                var st = ge.createVariableStatement(di, Mi);
                return st.decorators = ri, wr(Bi(st, Le), Nr);
              }
              function Op(Le, Nr, ri, di) {
                var Mi = mr(), st = e2.modifiersToFlags(di);
                ui(98);
                var ra = At(41), Ta = st & 512 ? bf() : Pn(), ha = ra ? 1 : 0, Na = st & 256 ? 2 : 0, In = Ws();
                st & 1 && Xi(true);
                var qo = Ei(ha | Na), co = vc(58, false), ts = mc(ha | Na, e2.Diagnostics.or_expected);
                Xi(Mi);
                var vs = ge.createFunctionDeclaration(ri, di, ra, Ta, In, qo, co, ts);
                return wr(Bi(vs, Le), Nr);
              }
              function Ef() {
                if (De() === 134)
                  return ui(134);
                if (De() === 10 && Rt(Tr) === 20)
                  return Ii(function() {
                    var Le = ga();
                    return Le.text === "constructor" ? Le : void 0;
                  });
              }
              function Fl(Le, Nr, ri, di) {
                return Ii(function() {
                  if (Ef()) {
                    var Mi = Ws(), st = Ei(0), ra = vc(58, false), Ta = mc(0, e2.Diagnostics.or_expected), ha = ge.createConstructorDeclaration(ri, di, st, Ta);
                    return ha.typeParameters = Mi, ha.type = ra, wr(Bi(ha, Le), Nr);
                  }
                });
              }
              function pl(Le, Nr, ri, di, Mi, st, ra, Ta, ha) {
                var Na = Mi ? 1 : 0, In = e2.some(di, e2.isAsyncModifier) ? 2 : 0, qo = Ws(), co = Ei(Na | In), ts = vc(58, false), vs = mc(Na | In, ha), Ac = ge.createMethodDeclaration(ri, di, Mi, st, ra, qo, co, ts, vs);
                return Ac.exclamationToken = Ta, wr(Bi(Ac, Le), Nr);
              }
              function Fp(Le, Nr, ri, di, Mi, st) {
                var ra = !st && !D.hasPrecedingLineBreak() ? At(53) : void 0, Ta = va(), ha = et(45056, nl);
                Oi(Mi, Ta, ha);
                var Na = ge.createPropertyDeclaration(ri, di, Mi, st || ra, Ta, ha);
                return wr(Bi(Na, Le), Nr);
              }
              function Mp(Le, Nr, ri, di) {
                var Mi = At(41), st = En(), ra = At(57);
                return Mi || De() === 20 || De() === 29 ? pl(Le, Nr, ri, di, Mi, st, ra, void 0, e2.Diagnostics.or_expected) : Fp(Le, Nr, ri, di, st, ra);
              }
              function Gu(Le, Nr, ri, di, Mi) {
                var st = En(), ra = Ws(), Ta = Ei(0), ha = vc(58, false), Na = mc(0), In = Mi === 172 ? ge.createGetAccessorDeclaration(ri, di, st, Ta, ha, Na) : ge.createSetAccessorDeclaration(ri, di, st, Ta, Na);
                return In.typeParameters = ra, ha && In.kind === 173 && (In.type = ha), wr(Bi(In, Le), Nr);
              }
              function Lp() {
                var Le;
                if (De() === 59)
                  return true;
                for (; e2.isModifierKind(De()); ) {
                  if (Le = De(), e2.isClassMemberModifier(Le))
                    return true;
                  Tr();
                }
                if (De() === 41 || (Da() && (Le = De(), Tr()), De() === 22))
                  return true;
                if (Le !== void 0) {
                  if (!e2.isKeyword(Le) || Le === 149 || Le === 136)
                    return true;
                  switch (De()) {
                    case 20:
                    case 29:
                    case 53:
                    case 58:
                    case 63:
                    case 57:
                      return true;
                    default:
                      return ka();
                  }
                }
                return false;
              }
              function Cf(Le, Nr, ri, di) {
                $a(124);
                var Mi = W_();
                return wr(Bi(ge.createClassStaticBlockDeclaration(ri, di, Mi), Le), Nr);
              }
              function W_() {
                var Le = Wr(), Nr = mr();
                Di(false), Xi(true);
                var ri = Dc(false);
                return Di(Le), Xi(Nr), ri;
              }
              function g_() {
                if (mr() && De() === 132) {
                  var Le = Ue(), Nr = eo(e2.Diagnostics.Expression_expected);
                  Tr();
                  var ri = Ec(Le, Nr, true);
                  return Ps(Le, ri);
                }
                return $l();
              }
              function dl() {
                var Le = Ue();
                if (!!at(59)) {
                  var Nr = Xe(g_);
                  return Bi(ge.createDecorator(Nr), Le);
                }
              }
              function gl() {
                for (var Le = Ue(), Nr, ri; ri = dl(); )
                  Nr = e2.append(Nr, ri);
                return Nr && Cn(Nr, Le);
              }
              function Vf(Le, Nr, ri) {
                var di = Ue(), Mi = De();
                if (De() === 85 && Le) {
                  if (!Ii(Oo))
                    return;
                } else {
                  if (Nr && De() === 124 && Rt(sr))
                    return;
                  if (ri && De() === 124)
                    return;
                  if (!xi())
                    return;
                }
                return Bi(ge.createToken(Mi), di);
              }
              function Fc(Le, Nr) {
                for (var ri = Ue(), di, Mi, st = false; Mi = Vf(Le, Nr, st); )
                  Mi.kind === 124 && (st = true), di = e2.append(di, Mi);
                return di && Cn(di, ri);
              }
              function Hu() {
                var Le;
                if (De() === 131) {
                  var Nr = Ue();
                  Tr();
                  var ri = Bi(ge.createToken(131), Nr);
                  Le = Cn([ri], Nr);
                }
                return Le;
              }
              function af() {
                var Le = Ue();
                if (De() === 26)
                  return Tr(), Bi(ge.createSemicolonClassElement(), Le);
                var Nr = fr(), ri = gl(), di = Fc(true, true);
                if (De() === 124 && Rt(sr))
                  return Cf(Le, Nr, ri, di);
                if (Ko(136))
                  return Gu(Le, Nr, ri, di, 172);
                if (Ko(149))
                  return Gu(Le, Nr, ri, di, 173);
                if (De() === 134 || De() === 10) {
                  var Mi = Fl(Le, Nr, ri, di);
                  if (Mi)
                    return Mi;
                }
                if (bt())
                  return Xt(Le, Nr, ri, di);
                if (e2.tokenIsIdentifierOrKeyword(De()) || De() === 10 || De() === 8 || De() === 41 || De() === 22) {
                  var st = e2.some(di, fl);
                  if (st) {
                    for (var ra = 0, Ta = di; ra < Ta.length; ra++) {
                      var ha = Ta[ra];
                      ha.flags |= 16777216;
                    }
                    return Gi(16777216, function() {
                      return Mp(Le, Nr, ri, di);
                    });
                  } else
                    return Mp(Le, Nr, ri, di);
                }
                if (ri || di) {
                  var Na = kn(79, true, e2.Diagnostics.Declaration_expected);
                  return Fp(Le, Nr, ri, di, Na, void 0);
                }
                return e2.Debug.fail("Should not have attempted to parse class member declaration.");
              }
              function tn() {
                return Ot(Ue(), fr(), void 0, void 0, 226);
              }
              function Ml(Le, Nr, ri, di) {
                return Ot(Le, Nr, ri, di, 257);
              }
              function Ot(Le, Nr, ri, di, Mi) {
                var st = mr();
                ui(84);
                var ra = nf(), Ta = Ws();
                e2.some(di, e2.isExportModifier) && Xi(true);
                var ha = Kf(), Na;
                ui(18) ? (Na = hd(), ui(19)) : Na = ps(), Xi(st);
                var In = Mi === 257 ? ge.createClassDeclaration(ri, di, ra, Ta, ha, Na) : ge.createClassExpression(ri, di, ra, Ta, ha, Na);
                return wr(Bi(In, Le), Nr);
              }
              function nf() {
                return Ki() && !q_() ? Kn(Ki()) : void 0;
              }
              function q_() {
                return De() === 117 && Rt(Gr);
              }
              function Kf() {
                if (Ll())
                  return Qi(22, Rp);
              }
              function Rp() {
                var Le = Ue(), Nr = De();
                e2.Debug.assert(Nr === 94 || Nr === 117), Tr();
                var ri = hs(7, yd);
                return Bi(ge.createHeritageClause(Nr, ri), Le);
              }
              function yd() {
                var Le = Ue(), Nr = $l();
                if (Nr.kind === 228)
                  return Nr;
                var ri = m_();
                return Bi(ge.createExpressionWithTypeArguments(Nr, ri), Le);
              }
              function m_() {
                return De() === 29 ? js(20, Aa, 29, 31) : void 0;
              }
              function Ll() {
                return De() === 94 || De() === 117;
              }
              function hd() {
                return Qi(5, af);
              }
              function v_(Le, Nr, ri, di) {
                ui(118);
                var Mi = eo(), st = Ws(), ra = Kf(), Ta = ho(), ha = ge.createInterfaceDeclaration(ri, di, Mi, st, ra, Ta);
                return wr(Bi(ha, Le), Nr);
              }
              function Bp(Le, Nr, ri, di) {
                ui(152);
                var Mi = eo(), st = Ws();
                ui(63);
                var ra = De() === 138 && Ii(po) || Aa();
                pn();
                var Ta = ge.createTypeAliasDeclaration(ri, di, Mi, st, ra);
                return wr(Bi(Ta, Le), Nr);
              }
              function Xu() {
                var Le = Ue(), Nr = fr(), ri = En(), di = Wt(nl);
                return wr(Bi(ge.createEnumMember(ri, di), Le), Nr);
              }
              function Xc(Le, Nr, ri, di) {
                ui(92);
                var Mi = eo(), st;
                ui(18) ? (st = Sr(function() {
                  return hs(6, Xu);
                }), ui(19)) : st = ps();
                var ra = ge.createEnumDeclaration(ri, di, Mi, st);
                return wr(Bi(ra, Le), Nr);
              }
              function Gf() {
                var Le = Ue(), Nr;
                return ui(18) ? (Nr = Qi(1, nc), ui(19)) : Nr = ps(), Bi(ge.createModuleBlock(Nr), Le);
              }
              function of(Le, Nr, ri, di, Mi) {
                var st = Mi & 16, ra = eo(), Ta = at(24) ? of(Ue(), false, void 0, void 0, 4 | st) : Gf(), ha = ge.createModuleDeclaration(ri, di, ra, Ta, Mi);
                return wr(Bi(ha, Le), Nr);
              }
              function wu(Le, Nr, ri, di) {
                var Mi = 0, st;
                De() === 157 ? (st = eo(), Mi |= 1024) : (st = ga(), st.text = xn(st.text));
                var ra;
                De() === 18 ? ra = Gf() : pn();
                var Ta = ge.createModuleDeclaration(ri, di, st, ra, Mi);
                return wr(Bi(Ta, Le), Nr);
              }
              function V_(Le, Nr, ri, di) {
                var Mi = 0;
                if (De() === 157)
                  return wu(Le, Nr, ri, di);
                if (at(142))
                  Mi |= 16;
                else if (ui(141), De() === 10)
                  return wu(Le, Nr, ri, di);
                return of(Le, Nr, ri, di, Mi);
              }
              function yu() {
                return De() === 146 && Rt(v);
              }
              function v() {
                return Tr() === 20;
              }
              function sr() {
                return Tr() === 18;
              }
              function fi() {
                return Tr() === 43;
              }
              function zi(Le, Nr, ri, di) {
                ui(127), ui(142);
                var Mi = eo();
                pn();
                var st = ge.createNamespaceExportDeclaration(Mi);
                return st.decorators = ri, st.modifiers = di, wr(Bi(st, Le), Nr);
              }
              function Sa(Le, Nr, ri, di) {
                ui(100);
                var Mi = D.getStartPos(), st;
                Fi() && (st = eo());
                var ra = false;
                if (De() !== 156 && (st == null ? void 0 : st.escapedText) === "type" && (Fi() || ta()) && (ra = true, st = Fi() ? eo() : void 0), st && !nn())
                  return Wo(Le, Nr, ri, di, st, ra);
                var Ta;
                (st || De() === 41 || De() === 18) && (Ta = Lo(st, Mi, ra), ui(156));
                var ha = is(), Na;
                De() === 129 && !D.hasPrecedingLineBreak() && (Na = Ha()), pn();
                var In = ge.createImportDeclaration(ri, di, Ta, ha, Na);
                return wr(Bi(In, Le), Nr);
              }
              function da() {
                var Le = Ue(), Nr = e2.tokenIsIdentifierOrKeyword(De()) ? Rn() : fo(10);
                ui(58);
                var ri = hc();
                return Bi(ge.createAssertEntry(Nr, ri), Le);
              }
              function Ha(Le) {
                var Nr = Ue();
                Le || ui(129);
                var ri = D.getTokenPos();
                if (ui(18)) {
                  var di = D.hasPrecedingLineBreak(), Mi = hs(24, da, true);
                  if (!ui(19)) {
                    var st = e2.lastOrUndefined(_e);
                    st && st.code === e2.Diagnostics._0_expected.code && e2.addRelatedInfo(st, e2.createDetachedDiagnostic(Re, ri, 1, e2.Diagnostics.The_parser_expected_to_find_a_1_to_match_the_0_token_here, "{", "}"));
                  }
                  return Bi(ge.createAssertClause(Mi, di), Nr);
                } else {
                  var Mi = Cn([], Ue(), void 0, false);
                  return Bi(ge.createAssertClause(Mi, false), Nr);
                }
              }
              function ta() {
                return De() === 41 || De() === 18;
              }
              function nn() {
                return De() === 27 || De() === 156;
              }
              function Wo(Le, Nr, ri, di, Mi, st) {
                ui(63);
                var ra = oc();
                pn();
                var Ta = ge.createImportEqualsDeclaration(ri, di, st, Mi, ra), ha = wr(Bi(Ta, Le), Nr);
                return ha;
              }
              function Lo(Le, Nr, ri) {
                var di;
                return (!Le || at(27)) && (di = De() === 41 ? au() : Ou(269)), Bi(ge.createImportClause(ri, Le, di), Nr);
              }
              function oc() {
                return yu() ? uu() : ds(false);
              }
              function uu() {
                var Le = Ue();
                ui(146), ui(20);
                var Nr = is();
                return ui(21), Bi(ge.createExternalModuleReference(Nr), Le);
              }
              function is() {
                if (De() === 10) {
                  var Le = ga();
                  return Le.text = xn(Le.text), Le;
                } else
                  return ns();
              }
              function au() {
                var Le = Ue();
                ui(41), ui(127);
                var Nr = eo();
                return Bi(ge.createNamespaceImport(Nr), Le);
              }
              function Ou(Le) {
                var Nr = Ue(), ri = Le === 269 ? ge.createNamedImports(js(23, lu, 18, 19)) : ge.createNamedExports(js(23, sf, 18, 19));
                return Bi(ri, Nr);
              }
              function sf() {
                var Le = fr();
                return wr(cf(275), Le);
              }
              function lu() {
                return cf(270);
              }
              function cf(Le) {
                var Nr = Ue(), ri = e2.isKeyword(De()) && !Fi(), di = D.getTokenPos(), Mi = D.getTextPos(), st = false, ra, Ta = true, ha = Rn();
                if (ha.escapedText === "type")
                  if (De() === 127) {
                    var Na = Rn();
                    if (De() === 127) {
                      var In = Rn();
                      e2.tokenIsIdentifierOrKeyword(De()) ? (st = true, ra = Na, ha = co(), Ta = false) : (ra = ha, ha = In, Ta = false);
                    } else
                      e2.tokenIsIdentifierOrKeyword(De()) ? (ra = ha, Ta = false, ha = co()) : (st = true, ha = Na);
                  } else
                    e2.tokenIsIdentifierOrKeyword(De()) && (st = true, ha = co());
                Ta && De() === 127 && (ra = ha, ui(127), ha = co()), Le === 270 && ri && nr(di, Mi, e2.Diagnostics.Identifier_expected);
                var qo = Le === 270 ? ge.createImportSpecifier(st, ra, ha) : ge.createExportSpecifier(st, ra, ha);
                return Bi(qo, Nr);
                function co() {
                  return ri = e2.isKeyword(De()) && !Fi(), di = D.getTokenPos(), Mi = D.getTextPos(), Rn();
                }
              }
              function uf(Le) {
                return Bi(ge.createNamespaceExport(Rn()), Le);
              }
              function K_(Le, Nr, ri, di) {
                var Mi = mr();
                Xi(true);
                var st, ra, Ta, ha = at(152), Na = Ue();
                at(41) ? (at(127) && (st = uf(Na)), ui(156), ra = is()) : (st = Ou(273), (De() === 156 || De() === 10 && !D.hasPrecedingLineBreak()) && (ui(156), ra = is())), ra && De() === 129 && !D.hasPrecedingLineBreak() && (Ta = Ha()), pn(), Xi(Mi);
                var In = ge.createExportDeclaration(ri, di, ha, st, ra, Ta);
                return wr(Bi(In, Le), Nr);
              }
              function Jp(Le, Nr, ri, di) {
                var Mi = mr();
                Xi(true);
                var st;
                at(63) ? st = true : ui(88);
                var ra = hc();
                pn(), Xi(Mi);
                var Ta = ge.createExportAssignment(ri, di, st, ra);
                return wr(Bi(Ta, Le), Nr);
              }
              var Hf;
              (function(Le) {
                Le[Le.SourceElements = 0] = "SourceElements", Le[Le.BlockStatements = 1] = "BlockStatements", Le[Le.SwitchClauses = 2] = "SwitchClauses", Le[Le.SwitchClauseStatements = 3] = "SwitchClauseStatements", Le[Le.TypeMembers = 4] = "TypeMembers", Le[Le.ClassMembers = 5] = "ClassMembers", Le[Le.EnumMembers = 6] = "EnumMembers", Le[Le.HeritageClauseElement = 7] = "HeritageClauseElement", Le[Le.VariableDeclarations = 8] = "VariableDeclarations", Le[Le.ObjectBindingElements = 9] = "ObjectBindingElements", Le[Le.ArrayBindingElements = 10] = "ArrayBindingElements", Le[Le.ArgumentExpressions = 11] = "ArgumentExpressions", Le[Le.ObjectLiteralMembers = 12] = "ObjectLiteralMembers", Le[Le.JsxAttributes = 13] = "JsxAttributes", Le[Le.JsxChildren = 14] = "JsxChildren", Le[Le.ArrayLiteralMembers = 15] = "ArrayLiteralMembers", Le[Le.Parameters = 16] = "Parameters", Le[Le.JSDocParameters = 17] = "JSDocParameters", Le[Le.RestProperties = 18] = "RestProperties", Le[Le.TypeParameters = 19] = "TypeParameters", Le[Le.TypeArguments = 20] = "TypeArguments", Le[Le.TupleElementTypes = 21] = "TupleElementTypes", Le[Le.HeritageClauses = 22] = "HeritageClauses", Le[Le.ImportOrExportSpecifiers = 23] = "ImportOrExportSpecifiers", Le[Le.AssertEntries = 24] = "AssertEntries", Le[Le.Count = 25] = "Count";
              })(Hf || (Hf = {}));
              var kc;
              (function(Le) {
                Le[Le.False = 0] = "False", Le[Le.True = 1] = "True", Le[Le.Unknown = 2] = "Unknown";
              })(kc || (kc = {}));
              var G_;
              (function(Le) {
                function Nr(Na, In, qo) {
                  ur("file.js", Na, 99, void 0, 1), D.setText(Na, In, qo), ye = D.scan();
                  var co = ri(), ts = or("file.js", 99, 1, false, [], ge.createToken(1), 0, e2.noop), vs = e2.attachFileToDiagnostics(_e, ts);
                  return we && (ts.jsDocDiagnostics = e2.attachFileToDiagnostics(we, ts)), yr(), co ? { jsDocTypeExpression: co, diagnostics: vs } : void 0;
                }
                Le.parseJSDocTypeExpressionForTests = Nr;
                function ri(Na) {
                  var In = Ue(), qo = (Na ? at : ui)(18), co = Gi(8388608, al);
                  (!Na || qo) && ji(19);
                  var ts = ge.createJSDocTypeExpression(co);
                  return pe(ts), Bi(ts, In);
                }
                Le.parseJSDocTypeExpression = ri;
                function di() {
                  for (var Na = Ue(), In = at(18), qo = Ue(), co = ds(false); De() === 80; )
                    nt(), vi(), co = Bi(ge.createJSDocMemberName(co, eo()), qo);
                  In && ji(19);
                  var ts = ge.createJSDocNameReference(co);
                  return pe(ts), Bi(ts, Na);
                }
                Le.parseJSDocNameReference = di;
                function Mi(Na, In, qo) {
                  ur("", Na, 99, void 0, 1);
                  var co = Gi(8388608, function() {
                    return ha(In, qo);
                  }), ts = { languageVariant: 0, text: Na }, vs = e2.attachFileToDiagnostics(_e, ts);
                  return yr(), co ? { jsDoc: co, diagnostics: vs } : void 0;
                }
                Le.parseIsolatedJSDocComment = Mi;
                function st(Na, In, qo) {
                  var co = ye, ts = _e.length, vs = n, Ac = Gi(8388608, function() {
                    return ha(In, qo);
                  });
                  return e2.setParent(Ac, Na), Er & 262144 && (we || (we = []), we.push.apply(we, _e)), ye = co, _e.length = ts, n = vs, Ac;
                }
                Le.parseJSDocComment = st;
                var ra;
                (function(Na) {
                  Na[Na.BeginningOfLine = 0] = "BeginningOfLine", Na[Na.SawAsterisk = 1] = "SawAsterisk", Na[Na.SavingComments = 2] = "SavingComments", Na[Na.SavingBackticks = 3] = "SavingBackticks";
                })(ra || (ra = {}));
                var Ta;
                (function(Na) {
                  Na[Na.Property = 1] = "Property", Na[Na.Parameter = 2] = "Parameter", Na[Na.CallbackParameter = 4] = "CallbackParameter";
                })(Ta || (Ta = {}));
                function ha(Na, In) {
                  Na === void 0 && (Na = 0);
                  var qo = Ee, co = In === void 0 ? qo.length : Na + In;
                  if (In = co - Na, e2.Debug.assert(Na >= 0), e2.Debug.assert(Na <= co), e2.Debug.assert(co <= qo.length), !m2(qo, Na))
                    return;
                  var ts, vs, Ac, Is, Qu, sc = [], bc = [];
                  return D.scanRange(Na + 3, In - 5, function() {
                    var It = 1, Ma, aa = Na - (qo.lastIndexOf(`
`, Na) + 1) + 4;
                    function Ja(Js) {
                      Ma || (Ma = aa), sc.push(Js), aa += Js.length;
                    }
                    for (vi(); Up(5); )
                      ;
                    Up(4) && (It = 0, aa = 0);
                    e:
                      for (; ; ) {
                        switch (De()) {
                          case 59:
                            It === 0 || It === 1 ? (Yu(sc), Qu || (Qu = Ue()), Vs(W(aa)), It = 0, Ma = void 0) : Ja(D.getTokenText());
                            break;
                          case 4:
                            sc.push(D.getTokenText()), It = 0, aa = 0;
                            break;
                          case 41:
                            var _n = D.getTokenText();
                            It === 1 || It === 2 ? (It = 2, Ja(_n)) : (It = 1, aa += _n.length);
                            break;
                          case 5:
                            var ro = D.getTokenText();
                            It === 2 ? sc.push(ro) : Ma !== void 0 && aa + ro.length > Ma && sc.push(ro.slice(Ma - aa)), aa += ro.length;
                            break;
                          case 1:
                            break e;
                          case 18:
                            It = 2;
                            var as = D.getStartPos(), cc = D.getTextPos() - 1, Sc = rt(cc);
                            if (Sc) {
                              Is || Mc(sc), bc.push(Bi(ge.createJSDocText(sc.join("")), Is != null ? Is : Na, as)), bc.push(Sc), sc = [], Is = D.getTextPos();
                              break;
                            }
                          default:
                            It = 2, Ja(D.getTokenText());
                            break;
                        }
                        vi();
                      }
                    Yu(sc), bc.length && sc.length && bc.push(Bi(ge.createJSDocText(sc.join("")), Is != null ? Is : Na, Qu)), bc.length && ts && e2.Debug.assertIsDefined(Qu, "having parsed tags implies that the end of the comment span should be set");
                    var hu = ts && Cn(ts, vs, Ac);
                    return Bi(ge.createJSDocComment(bc.length ? Cn(bc, Na, Qu) : sc.length ? sc.join("") : void 0, hu), Na, co);
                  });
                  function Mc(It) {
                    for (; It.length && (It[0] === `
` || It[0] === "\r"); )
                      It.shift();
                  }
                  function Yu(It) {
                    for (; It.length && It[It.length - 1].trim() === ""; )
                      It.pop();
                  }
                  function Rl() {
                    for (; ; ) {
                      if (vi(), De() === 1)
                        return true;
                      if (!(De() === 5 || De() === 4))
                        return false;
                    }
                  }
                  function Lc() {
                    if (!((De() === 5 || De() === 4) && Rt(Rl)))
                      for (; De() === 5 || De() === 4; )
                        vi();
                  }
                  function _() {
                    if ((De() === 5 || De() === 4) && Rt(Rl))
                      return "";
                    for (var It = D.hasPrecedingLineBreak(), Ma = false, aa = ""; It && De() === 41 || De() === 5 || De() === 4; )
                      aa += D.getTokenText(), De() === 4 ? (It = true, Ma = true, aa = "") : De() === 41 && (It = false), vi();
                    return Ma ? aa : "";
                  }
                  function W(It) {
                    e2.Debug.assert(De() === 59);
                    var Ma = D.getTokenPos();
                    vi();
                    var aa = ff(void 0), Ja = _(), _n;
                    switch (aa.escapedText) {
                      case "author":
                        _n = Jt(Ma, aa, It, Ja);
                        break;
                      case "implements":
                        _n = Xf(Ma, aa, It, Ja);
                        break;
                      case "augments":
                      case "extends":
                        _n = bd(Ma, aa, It, Ja);
                        break;
                      case "class":
                      case "constructor":
                        _n = kf(Ma, ge.createJSDocClassTag, aa, It, Ja);
                        break;
                      case "public":
                        _n = kf(Ma, ge.createJSDocPublicTag, aa, It, Ja);
                        break;
                      case "private":
                        _n = kf(Ma, ge.createJSDocPrivateTag, aa, It, Ja);
                        break;
                      case "protected":
                        _n = kf(Ma, ge.createJSDocProtectedTag, aa, It, Ja);
                        break;
                      case "readonly":
                        _n = kf(Ma, ge.createJSDocReadonlyTag, aa, It, Ja);
                        break;
                      case "override":
                        _n = kf(Ma, ge.createJSDocOverrideTag, aa, It, Ja);
                        break;
                      case "deprecated":
                        Ur = true, _n = kf(Ma, ge.createJSDocDeprecatedTag, aa, It, Ja);
                        break;
                      case "this":
                        _n = Gg(Ma, aa, It, Ja);
                        break;
                      case "enum":
                        _n = Af(Ma, aa, It, Ja);
                        break;
                      case "arg":
                      case "argument":
                      case "param":
                        return jp(Ma, aa, 2, It);
                      case "return":
                      case "returns":
                        _n = Om(Ma, aa, It, Ja);
                        break;
                      case "template":
                        _n = Lm(Ma, aa, It, Ja);
                        break;
                      case "type":
                        _n = Fm(Ma, aa, It, Ja);
                        break;
                      case "typedef":
                        _n = Hg(Ma, aa, It, Ja);
                        break;
                      case "callback":
                        _n = fg(Ma, aa, It, Ja);
                        break;
                      case "see":
                        _n = Vg(Ma, aa, It, Ja);
                        break;
                      default:
                        _n = vo(Ma, aa, It, Ja);
                        break;
                    }
                    return _n;
                  }
                  function Te(It, Ma, aa, Ja) {
                    return Ja || (aa += Ma - It), cr(aa, Ja.slice(aa));
                  }
                  function cr(It, Ma) {
                    var aa = Ue(), Ja = [], _n = [], ro, as = 0, cc = true, Sc;
                    function hu(Sd) {
                      Sc || (Sc = It), Ja.push(Sd), It += Sd.length;
                    }
                    Ma !== void 0 && (Ma !== "" && hu(Ma), as = 1);
                    var Js = De();
                    e:
                      for (; ; ) {
                        switch (Js) {
                          case 4:
                            as = 0, Ja.push(D.getTokenText()), It = 0;
                            break;
                          case 59:
                            if (as === 3 || as === 2 && (!cc || Rt(ni))) {
                              Ja.push(D.getTokenText());
                              break;
                            }
                            D.setTextPos(D.getTextPos() - 1);
                          case 1:
                            break e;
                          case 5:
                            if (as === 2 || as === 3)
                              hu(D.getTokenText());
                            else {
                              var Qf = D.getTokenText();
                              Sc !== void 0 && It + Qf.length > Sc && Ja.push(Qf.slice(Sc - It)), It += Qf.length;
                            }
                            break;
                          case 18:
                            as = 2;
                            var go = D.getStartPos(), Vd = D.getTextPos() - 1, X_ = rt(Vd);
                            X_ ? (_n.push(Bi(ge.createJSDocText(Ja.join("")), ro != null ? ro : aa, go)), _n.push(X_), Ja = [], ro = D.getTextPos()) : hu(D.getTokenText());
                            break;
                          case 61:
                            as === 3 ? as = 2 : as = 3, hu(D.getTokenText());
                            break;
                          case 41:
                            if (as === 0) {
                              as = 1, It += 1;
                              break;
                            }
                          default:
                            as !== 3 && (as = 2), hu(D.getTokenText());
                            break;
                        }
                        cc = De() === 5, Js = vi();
                      }
                    if (Mc(Ja), Yu(Ja), _n.length)
                      return Ja.length && _n.push(Bi(ge.createJSDocText(Ja.join("")), ro != null ? ro : aa)), Cn(_n, aa, D.getTextPos());
                    if (Ja.length)
                      return Ja.join("");
                  }
                  function ni() {
                    var It = vi();
                    return It === 5 || It === 4;
                  }
                  function rt(It) {
                    var Ma = Ii(yt);
                    if (!!Ma) {
                      vi(), Lc();
                      var aa = Ue(), Ja = e2.tokenIsIdentifierOrKeyword(De()) ? ds(true) : void 0;
                      if (Ja)
                        for (; De() === 80; )
                          nt(), vi(), Ja = Bi(ge.createJSDocMemberName(Ja, eo()), aa);
                      for (var _n = []; De() !== 19 && De() !== 4 && De() !== 1; )
                        _n.push(D.getTokenText()), vi();
                      var ro = Ma === "link" ? ge.createJSDocLink : Ma === "linkcode" ? ge.createJSDocLinkCode : ge.createJSDocLinkPlain;
                      return Bi(ro(Ja, _n.join("")), It, D.getTextPos());
                    }
                  }
                  function yt() {
                    if (_(), De() === 18 && vi() === 59 && e2.tokenIsIdentifierOrKeyword(vi())) {
                      var It = D.getTokenValue();
                      if (Xa(It))
                        return It;
                    }
                  }
                  function Xa(It) {
                    return It === "link" || It === "linkcode" || It === "linkplain";
                  }
                  function vo(It, Ma, aa, Ja) {
                    return Bi(ge.createJSDocUnknownTag(Ma, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Vs(It) {
                    !It || (ts ? ts.push(It) : (ts = [It], vs = It.pos), Ac = It.end);
                  }
                  function H_() {
                    return _(), De() === 18 ? ri() : void 0;
                  }
                  function y_() {
                    var It = Up(22);
                    It && Lc();
                    var Ma = Up(61), aa = Rm();
                    return Ma && Qa(61), It && (Lc(), At(63) && ns(), ui(23)), { name: aa, isBracketed: It };
                  }
                  function Dd(It) {
                    switch (It.kind) {
                      case 148:
                        return true;
                      case 183:
                        return Dd(It.elementType);
                      default:
                        return e2.isTypeReferenceNode(It) && e2.isIdentifier(It.typeName) && It.typeName.escapedText === "Object" && !It.typeArguments;
                    }
                  }
                  function jp(It, Ma, aa, Ja) {
                    var _n = H_(), ro = !_n;
                    _();
                    var as = y_(), cc = as.name, Sc = as.isBracketed, hu = _();
                    ro && !Rt(yt) && (_n = H_());
                    var Js = Te(It, Ue(), Ja, hu), Qf = aa !== 4 && lg(_n, cc, aa, Ja);
                    Qf && (_n = Qf, ro = true);
                    var go = aa === 1 ? ge.createJSDocPropertyTag(Ma, cc, Sc, _n, ro, Js) : ge.createJSDocParameterTag(Ma, cc, Sc, _n, ro, Js);
                    return Bi(go, It);
                  }
                  function lg(It, Ma, aa, Ja) {
                    if (It && Dd(It.type)) {
                      for (var _n = Ue(), ro = void 0, as = void 0; ro = Ii(function() {
                        return Bl(aa, Ja, Ma);
                      }); )
                        (ro.kind === 340 || ro.kind === 347) && (as = e2.append(as, ro));
                      if (as) {
                        var cc = Bi(ge.createJSDocTypeLiteral(as, It.type.kind === 183), _n);
                        return Bi(ge.createJSDocTypeExpression(cc), _n);
                      }
                    }
                  }
                  function Om(It, Ma, aa, Ja) {
                    e2.some(ts, e2.isJSDocReturnTag) && nr(Ma.pos, D.getTokenPos(), e2.Diagnostics._0_tag_already_specified, Ma.escapedText);
                    var _n = H_();
                    return Bi(ge.createJSDocReturnTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Fm(It, Ma, aa, Ja) {
                    e2.some(ts, e2.isJSDocTypeTag) && nr(Ma.pos, D.getTokenPos(), e2.Diagnostics._0_tag_already_specified, Ma.escapedText);
                    var _n = ri(true), ro = aa !== void 0 && Ja !== void 0 ? Te(It, Ue(), aa, Ja) : void 0;
                    return Bi(ge.createJSDocTypeTag(Ma, _n, ro), It);
                  }
                  function Vg(It, Ma, aa, Ja) {
                    var _n = De() === 22 || Rt(function() {
                      return vi() === 59 && e2.tokenIsIdentifierOrKeyword(vi()) && Xa(D.getTokenValue());
                    }), ro = _n ? void 0 : di(), as = aa !== void 0 && Ja !== void 0 ? Te(It, Ue(), aa, Ja) : void 0;
                    return Bi(ge.createJSDocSeeTag(Ma, ro, as), It);
                  }
                  function Jt(It, Ma, aa, Ja) {
                    var _n = Ue(), ro = ml(), as = D.getStartPos(), cc = Te(It, as, aa, Ja);
                    cc || (as = D.getStartPos());
                    var Sc = typeof cc != "string" ? Cn(e2.concatenate([Bi(ro, _n, as)], cc), _n) : ro.text + cc;
                    return Bi(ge.createJSDocAuthorTag(Ma, Sc), It);
                  }
                  function ml() {
                    for (var It = [], Ma = false, aa = D.getToken(); aa !== 1 && aa !== 4; ) {
                      if (aa === 29)
                        Ma = true;
                      else {
                        if (aa === 59 && !Ma)
                          break;
                        if (aa === 31 && Ma) {
                          It.push(D.getTokenText()), D.setTextPos(D.getTokenPos() + 1);
                          break;
                        }
                      }
                      It.push(D.getTokenText()), aa = vi();
                    }
                    return ge.createJSDocText(It.join(""));
                  }
                  function Xf(It, Ma, aa, Ja) {
                    var _n = lf();
                    return Bi(ge.createJSDocImplementsTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function bd(It, Ma, aa, Ja) {
                    var _n = lf();
                    return Bi(ge.createJSDocAugmentsTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function lf() {
                    var It = at(18), Ma = Ue(), aa = Kg(), Ja = m_(), _n = ge.createExpressionWithTypeArguments(aa, Ja), ro = Bi(_n, Ma);
                    return It && ui(19), ro;
                  }
                  function Kg() {
                    for (var It = Ue(), Ma = ff(); at(24); ) {
                      var aa = ff();
                      Ma = Bi(ge.createPropertyAccessExpression(Ma, aa), It);
                    }
                    return Ma;
                  }
                  function kf(It, Ma, aa, Ja, _n) {
                    return Bi(Ma(aa, Te(It, Ue(), Ja, _n)), It);
                  }
                  function Gg(It, Ma, aa, Ja) {
                    var _n = ri(true);
                    return Lc(), Bi(ge.createJSDocThisTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Af(It, Ma, aa, Ja) {
                    var _n = ri(true);
                    return Lc(), Bi(ge.createJSDocEnumTag(Ma, _n, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Hg(It, Ma, aa, Ja) {
                    var _n, ro = H_();
                    _();
                    var as = Wd();
                    Lc();
                    var cc = cr(aa), Sc;
                    if (!ro || Dd(ro.type)) {
                      for (var hu = void 0, Js = void 0, Qf = void 0, go = false; hu = Ii(function() {
                        return Xg(aa);
                      }); )
                        if (go = true, hu.kind === 343)
                          if (Js) {
                            var Vd = Ar(e2.Diagnostics.A_JSDoc_typedef_comment_may_not_contain_multiple_type_tags);
                            Vd && e2.addRelatedInfo(Vd, e2.createDetachedDiagnostic(Re, 0, 0, e2.Diagnostics.The_tag_was_first_specified_here));
                            break;
                          } else
                            Js = hu;
                        else
                          Qf = e2.append(Qf, hu);
                      if (go) {
                        var X_ = ro && ro.type.kind === 183, Sd = ge.createJSDocTypeLiteral(Qf, X_);
                        ro = Js && Js.typeExpression && !Dd(Js.typeExpression.type) ? Js.typeExpression : Bi(Sd, It), Sc = ro.end;
                      }
                    }
                    Sc = Sc || cc !== void 0 ? Ue() : ((_n = as != null ? as : ro) !== null && _n !== void 0 ? _n : Ma).end, cc || (cc = Te(It, Sc, aa, Ja));
                    var Yg = ge.createJSDocTypedefTag(Ma, ro, as, cc);
                    return Bi(Yg, It, Sc);
                  }
                  function Wd(It) {
                    var Ma = D.getTokenPos();
                    if (!!e2.tokenIsIdentifierOrKeyword(De())) {
                      var aa = ff();
                      if (at(24)) {
                        var Ja = Wd(true), _n = ge.createModuleDeclaration(void 0, void 0, aa, Ja, It ? 4 : void 0);
                        return Bi(_n, Ma);
                      }
                      return It && (aa.isInJSDocNamespace = true), aa;
                    }
                  }
                  function qd(It) {
                    for (var Ma = Ue(), aa, Ja; aa = Ii(function() {
                      return Bl(4, It);
                    }); )
                      Ja = e2.append(Ja, aa);
                    return Cn(Ja || [], Ma);
                  }
                  function fg(It, Ma, aa, Ja) {
                    var _n = Wd();
                    Lc();
                    var ro = cr(aa), as = qd(aa), cc = Ii(function() {
                      if (Up(59)) {
                        var Js = W(aa);
                        if (Js && Js.kind === 341)
                          return Js;
                      }
                    }), Sc = Bi(ge.createJSDocSignature(void 0, as, cc), It);
                    ro || (ro = Te(It, Ue(), aa, Ja));
                    var hu = ro !== void 0 ? Ue() : Sc.end;
                    return Bi(ge.createJSDocCallbackTag(Ma, Sc, _n, ro), It, hu);
                  }
                  function Mm(It, Ma) {
                    for (; !e2.isIdentifier(It) || !e2.isIdentifier(Ma); )
                      if (!e2.isIdentifier(It) && !e2.isIdentifier(Ma) && It.right.escapedText === Ma.right.escapedText)
                        It = It.left, Ma = Ma.left;
                      else
                        return false;
                    return It.escapedText === Ma.escapedText;
                  }
                  function Xg(It) {
                    return Bl(1, It);
                  }
                  function Bl(It, Ma, aa) {
                    for (var Ja = true, _n = false; ; )
                      switch (vi()) {
                        case 59:
                          if (Ja) {
                            var ro = Qg(It, Ma);
                            return ro && (ro.kind === 340 || ro.kind === 347) && It !== 4 && aa && (e2.isIdentifier(ro.name) || !Mm(aa, ro.name.left)) ? false : ro;
                          }
                          _n = false;
                          break;
                        case 4:
                          Ja = true, _n = false;
                          break;
                        case 41:
                          _n && (Ja = false), _n = true;
                          break;
                        case 79:
                          Ja = false;
                          break;
                        case 1:
                          return false;
                      }
                  }
                  function Qg(It, Ma) {
                    e2.Debug.assert(De() === 59);
                    var aa = D.getStartPos();
                    vi();
                    var Ja = ff();
                    Lc();
                    var _n;
                    switch (Ja.escapedText) {
                      case "type":
                        return It === 1 && Fm(aa, Ja);
                      case "prop":
                      case "property":
                        _n = 1;
                        break;
                      case "arg":
                      case "argument":
                      case "param":
                        _n = 6;
                        break;
                      default:
                        return false;
                    }
                    return It & _n ? jp(aa, Ja, It, Ma) : false;
                  }
                  function _g() {
                    var It = Ue(), Ma = Up(22);
                    Ma && Lc();
                    var aa = ff(e2.Diagnostics.Unexpected_token_A_type_parameter_name_was_expected_without_curly_braces), Ja;
                    if (Ma && (Lc(), ui(63), Ja = Gi(8388608, al), ui(23)), !e2.nodeIsMissing(aa))
                      return Bi(ge.createTypeParameterDeclaration(void 0, aa, void 0, Ja), It);
                  }
                  function Qc() {
                    var It = Ue(), Ma = [];
                    do {
                      Lc();
                      var aa = _g();
                      aa !== void 0 && Ma.push(aa), _();
                    } while (Up(27));
                    return Cn(Ma, It);
                  }
                  function Lm(It, Ma, aa, Ja) {
                    var _n = De() === 18 ? ri() : void 0, ro = Qc();
                    return Bi(ge.createJSDocTemplateTag(Ma, _n, ro, Te(It, Ue(), aa, Ja)), It);
                  }
                  function Up(It) {
                    return De() === It ? (vi(), true) : false;
                  }
                  function Rm() {
                    var It = ff();
                    for (at(22) && ui(23); at(24); ) {
                      var Ma = ff();
                      at(22) && ui(23), It = Ji(It, Ma);
                    }
                    return It;
                  }
                  function ff(It) {
                    if (!e2.tokenIsIdentifierOrKeyword(De()))
                      return kn(79, !It, It || e2.Diagnostics.Identifier_expected);
                    Cr++;
                    var Ma = D.getTokenPos(), aa = D.getTextPos(), Ja = De(), _n = xn(D.getTokenValue()), ro = Bi(ge.createIdentifier(_n, void 0, Ja), Ma, aa);
                    return vi(), ro;
                  }
                }
              })(G_ = d.JSDocParser || (d.JSDocParser = {}));
            })(X || (X = {}));
            var $;
            (function(d) {
              function D(Ee, He, rr, Ie) {
                if (Ie = Ie || e2.Debug.shouldAssert(2), ge(Ee, He, rr, Ie), e2.textChangeRangeIsUnchanged(rr))
                  return Ee;
                if (Ee.statements.length === 0)
                  return X.parseSourceFile(Ee.fileName, He, Ee.languageVersion, void 0, true, Ee.scriptKind, Ee.setExternalModuleIndicator);
                var _e = Ee;
                e2.Debug.assert(!_e.hasBeenIncrementallyParsed), _e.hasBeenIncrementallyParsed = true, X.fixupParentReferences(_e);
                var we = Ee.text, de = Re(Ee), ye = Z2(Ee, rr);
                ge(Ee, He, ye, Ie), e2.Debug.assert(ye.span.start <= rr.span.start), e2.Debug.assert(e2.textSpanEnd(ye.span) === e2.textSpanEnd(rr.span)), e2.Debug.assert(e2.textSpanEnd(e2.textChangeRangeNewSpan(ye)) === e2.textSpanEnd(e2.textChangeRangeNewSpan(rr)));
                var Ae = e2.textChangeRangeNewSpan(ye).length - ye.span.length;
                Fe(_e, ye.span.start, e2.textSpanEnd(ye.span), e2.textSpanEnd(e2.textChangeRangeNewSpan(ye)), Ae, we, He, Ie);
                var er = X.parseSourceFile(Ee.fileName, He, Ee.languageVersion, de, true, Ee.scriptKind, Ee.setExternalModuleIndicator);
                return er.commentDirectives = fe(Ee.commentDirectives, er.commentDirectives, ye.span.start, e2.textSpanEnd(ye.span), Ae, we, He, Ie), er.impliedNodeFormat = Ee.impliedNodeFormat, er;
              }
              d.updateSourceFile = D;
              function fe(Ee, He, rr, Ie, _e, we, de, ye) {
                if (!Ee)
                  return He;
                for (var Ae, er = false, ir = 0, Cr = Ee; ir < Cr.length; ir++) {
                  var Ye = Cr[ir], Br = Ye.range, Er = Ye.type;
                  if (Br.end < rr)
                    Ae = e2.append(Ae, Ye);
                  else if (Br.pos > Ie) {
                    n();
                    var Ne = { range: { pos: Br.pos + _e, end: Br.end + _e }, type: Er };
                    Ae = e2.append(Ae, Ne), ye && e2.Debug.assert(we.substring(Br.pos, Br.end) === de.substring(Ne.range.pos, Ne.range.end));
                  }
                }
                return n(), Ae;
                function n() {
                  er || (er = true, Ae ? He && Ae.push.apply(Ae, He) : Ae = He);
                }
              }
              function g(Ee, He, rr, Ie, _e, we) {
                He ? ye(Ee) : de(Ee);
                return;
                function de(Ae) {
                  var er = "";
                  if (we && ne(Ae) && (er = Ie.substring(Ae.pos, Ae.end)), Ae._children && (Ae._children = void 0), e2.setTextRangePosEnd(Ae, Ae.pos + rr, Ae.end + rr), we && ne(Ae) && e2.Debug.assert(er === _e.substring(Ae.pos, Ae.end)), se(Ae, de, ye), e2.hasJSDocNodes(Ae))
                    for (var ir = 0, Cr = Ae.jsDoc; ir < Cr.length; ir++) {
                      var Ye = Cr[ir];
                      de(Ye);
                    }
                  We(Ae, we);
                }
                function ye(Ae) {
                  Ae._children = void 0, e2.setTextRangePosEnd(Ae, Ae.pos + rr, Ae.end + rr);
                  for (var er = 0, ir = Ae; er < ir.length; er++) {
                    var Cr = ir[er];
                    de(Cr);
                  }
                }
              }
              function ne(Ee) {
                switch (Ee.kind) {
                  case 10:
                  case 8:
                  case 79:
                    return true;
                }
                return false;
              }
              function ue(Ee, He, rr, Ie, _e) {
                e2.Debug.assert(Ee.end >= He, "Adjusting an element that was entirely before the change range"), e2.Debug.assert(Ee.pos <= rr, "Adjusting an element that was entirely after the change range"), e2.Debug.assert(Ee.pos <= Ee.end);
                var we = Math.min(Ee.pos, Ie), de = Ee.end >= rr ? Ee.end + _e : Math.min(Ee.end, Ie);
                e2.Debug.assert(we <= de), Ee.parent && (e2.Debug.assertGreaterThanOrEqual(we, Ee.parent.pos), e2.Debug.assertLessThanOrEqual(de, Ee.parent.end)), e2.setTextRangePosEnd(Ee, we, de);
              }
              function We(Ee, He) {
                if (He) {
                  var rr = Ee.pos, Ie = function(ye) {
                    e2.Debug.assert(ye.pos >= rr), rr = ye.end;
                  };
                  if (e2.hasJSDocNodes(Ee))
                    for (var _e = 0, we = Ee.jsDoc; _e < we.length; _e++) {
                      var de = we[_e];
                      Ie(de);
                    }
                  se(Ee, Ie), e2.Debug.assert(rr <= Ee.end);
                }
              }
              function Fe(Ee, He, rr, Ie, _e, we, de, ye) {
                Ae(Ee);
                return;
                function Ae(ir) {
                  if (e2.Debug.assert(ir.pos <= ir.end), ir.pos > rr) {
                    g(ir, false, _e, we, de, ye);
                    return;
                  }
                  var Cr = ir.end;
                  if (Cr >= He) {
                    if (ir.intersectsChange = true, ir._children = void 0, ue(ir, He, rr, Ie, _e), se(ir, Ae, er), e2.hasJSDocNodes(ir))
                      for (var Ye = 0, Br = ir.jsDoc; Ye < Br.length; Ye++) {
                        var Er = Br[Ye];
                        Ae(Er);
                      }
                    We(ir, ye);
                    return;
                  }
                  e2.Debug.assert(Cr < He);
                }
                function er(ir) {
                  if (e2.Debug.assert(ir.pos <= ir.end), ir.pos > rr) {
                    g(ir, true, _e, we, de, ye);
                    return;
                  }
                  var Cr = ir.end;
                  if (Cr >= He) {
                    ir.intersectsChange = true, ir._children = void 0, ue(ir, He, rr, Ie, _e);
                    for (var Ye = 0, Br = ir; Ye < Br.length; Ye++) {
                      var Er = Br[Ye];
                      Ae(Er);
                    }
                    return;
                  }
                  e2.Debug.assert(Cr < He);
                }
              }
              function Z2(Ee, He) {
                for (var rr = 1, Ie = He.span.start, _e = 0; Ie > 0 && _e <= rr; _e++) {
                  var we = Be(Ee, Ie);
                  e2.Debug.assert(we.pos <= Ie);
                  var de = we.pos;
                  Ie = Math.max(0, de - 1);
                }
                var ye = e2.createTextSpanFromBounds(Ie, e2.textSpanEnd(He.span)), Ae = He.newLength + (He.span.start - Ie);
                return e2.createTextChangeRange(ye, Ae);
              }
              function Be(Ee, He) {
                var rr = Ee, Ie;
                if (se(Ee, de), Ie) {
                  var _e = we(Ie);
                  _e.pos > rr.pos && (rr = _e);
                }
                return rr;
                function we(ye) {
                  for (; ; ) {
                    var Ae = e2.getLastChild(ye);
                    if (Ae)
                      ye = Ae;
                    else
                      return ye;
                  }
                }
                function de(ye) {
                  if (!e2.nodeIsMissing(ye))
                    if (ye.pos <= He) {
                      if (ye.pos >= rr.pos && (rr = ye), He < ye.end)
                        return se(ye, de), true;
                      e2.Debug.assert(ye.end <= He), Ie = ye;
                    } else
                      return e2.Debug.assert(ye.pos > He), true;
                }
              }
              function ge(Ee, He, rr, Ie) {
                var _e = Ee.text;
                if (rr && (e2.Debug.assert(_e.length - rr.span.length + rr.newLength === He.length), Ie || e2.Debug.shouldAssert(3))) {
                  var we = _e.substr(0, rr.span.start), de = He.substr(0, rr.span.start);
                  e2.Debug.assert(we === de);
                  var ye = _e.substring(e2.textSpanEnd(rr.span), _e.length), Ae = He.substring(e2.textSpanEnd(e2.textChangeRangeNewSpan(rr)), He.length);
                  e2.Debug.assert(ye === Ae);
                }
              }
              function Re(Ee) {
                var He = Ee.statements, rr = 0;
                e2.Debug.assert(rr < He.length);
                var Ie = He[rr], _e = -1;
                return { currentNode: function(de) {
                  return de !== _e && (Ie && Ie.end === de && rr < He.length - 1 && (rr++, Ie = He[rr]), (!Ie || Ie.pos !== de) && we(de)), _e = de, e2.Debug.assert(!Ie || Ie.pos === de), Ie;
                } };
                function we(de) {
                  He = void 0, rr = -1, Ie = void 0, se(Ee, ye, Ae);
                  return;
                  function ye(er) {
                    return de >= er.pos && de < er.end ? (se(er, ye, Ae), true) : false;
                  }
                  function Ae(er) {
                    if (de >= er.pos && de < er.end)
                      for (var ir = 0; ir < er.length; ir++) {
                        var Cr = er[ir];
                        if (Cr) {
                          if (Cr.pos === de)
                            return He = er, rr = ir, Ie = Cr, true;
                          if (Cr.pos < de && de < Cr.end)
                            return se(Cr, ye, Ae), true;
                        }
                      }
                    return false;
                  }
                }
              }
              d.createSyntaxCursor = Re;
              var ze;
              (function(Ee) {
                Ee[Ee.Value = -1] = "Value";
              })(ze || (ze = {}));
            })($ || ($ = {}));
            function A2(d) {
              return e2.fileExtensionIsOneOf(d, e2.supportedDeclarationExtensions);
            }
            e2.isDeclarationFileName = A2;
            function y(d, D, fe, g) {
              if (!!d) {
                if (d === "import")
                  return e2.ModuleKind.ESNext;
                if (d === "require")
                  return e2.ModuleKind.CommonJS;
                g(D, fe - D, e2.Diagnostics.resolution_mode_should_be_either_require_or_import);
              }
            }
            function V(d, D) {
              for (var fe = [], g = 0, ne = e2.getLeadingCommentRanges(D, 0) || e2.emptyArray; g < ne.length; g++) {
                var ue = ne[g], We = D.substring(ue.pos, ue.end);
                j(fe, ue, We);
              }
              d.pragmas = new e2.Map();
              for (var Fe = 0, Z2 = fe; Fe < Z2.length; Fe++) {
                var Be = Z2[Fe];
                if (d.pragmas.has(Be.name)) {
                  var ge = d.pragmas.get(Be.name);
                  ge instanceof Array ? ge.push(Be.args) : d.pragmas.set(Be.name, [ge, Be.args]);
                  continue;
                }
                d.pragmas.set(Be.name, Be.args);
              }
            }
            e2.processCommentPragmas = V;
            function L(d, D) {
              d.checkJsDirective = void 0, d.referencedFiles = [], d.typeReferenceDirectives = [], d.libReferenceDirectives = [], d.amdDependencies = [], d.hasNoDefaultLib = false, d.pragmas.forEach(function(fe, g) {
                switch (g) {
                  case "reference": {
                    var ne = d.referencedFiles, ue = d.typeReferenceDirectives, We = d.libReferenceDirectives;
                    e2.forEach(e2.toArray(fe), function(ge) {
                      var Re = ge.arguments, ze = Re.types, Ee = Re.lib, He = Re.path, rr = Re["resolution-mode"];
                      if (ge.arguments["no-default-lib"])
                        d.hasNoDefaultLib = true;
                      else if (ze) {
                        var Ie = y(rr, ze.pos, ze.end, D);
                        ue.push(Ke({ pos: ze.pos, end: ze.end, fileName: ze.value }, Ie ? { resolutionMode: Ie } : {}));
                      } else
                        Ee ? We.push({ pos: Ee.pos, end: Ee.end, fileName: Ee.value }) : He ? ne.push({ pos: He.pos, end: He.end, fileName: He.value }) : D(ge.range.pos, ge.range.end - ge.range.pos, e2.Diagnostics.Invalid_reference_directive_syntax);
                    });
                    break;
                  }
                  case "amd-dependency": {
                    d.amdDependencies = e2.map(e2.toArray(fe), function(ge) {
                      return { name: ge.arguments.name, path: ge.arguments.path };
                    });
                    break;
                  }
                  case "amd-module": {
                    if (fe instanceof Array)
                      for (var Fe = 0, Z2 = fe; Fe < Z2.length; Fe++) {
                        var Be = Z2[Fe];
                        d.moduleName && D(Be.range.pos, Be.range.end - Be.range.pos, e2.Diagnostics.An_AMD_module_cannot_have_multiple_name_assignments), d.moduleName = Be.arguments.name;
                      }
                    else
                      d.moduleName = fe.arguments.name;
                    break;
                  }
                  case "ts-nocheck":
                  case "ts-check": {
                    e2.forEach(e2.toArray(fe), function(ge) {
                      (!d.checkJsDirective || ge.range.pos > d.checkJsDirective.pos) && (d.checkJsDirective = { enabled: g === "ts-check", end: ge.range.end, pos: ge.range.pos });
                    });
                    break;
                  }
                  case "jsx":
                  case "jsxfrag":
                  case "jsximportsource":
                  case "jsxruntime":
                    return;
                  default:
                    e2.Debug.fail("Unhandled pragma kind");
                }
              });
            }
            e2.processPragmasIntoFields = L;
            var P = new e2.Map();
            function k(d) {
              if (P.has(d))
                return P.get(d);
              var D = new RegExp("(\\s".concat(d, `\\s*=\\s*)(?:(?:'([^']*)')|(?:"([^"]*)"))`), "im");
              return P.set(d, D), D;
            }
            var Y = /^\/\/\/\s*<(\S+)\s.*?\/>/im, U = /^\/\/\/?\s*@(\S+)\s*(.*)\s*$/im;
            function j(d, D, fe) {
              var g = D.kind === 2 && Y.exec(fe);
              if (g) {
                var ne = g[1].toLowerCase(), ue = e2.commentPragmas[ne];
                if (!ue || !(ue.kind & 1))
                  return;
                if (ue.args) {
                  for (var We = {}, Fe = 0, Z2 = ue.args; Fe < Z2.length; Fe++) {
                    var Be = Z2[Fe], ge = k(Be.name), Re = ge.exec(fe);
                    if (!Re && !Be.optional)
                      return;
                    if (Re) {
                      var ze = Re[2] || Re[3];
                      if (Be.captureSpan) {
                        var Ee = D.pos + Re.index + Re[1].length + 1;
                        We[Be.name] = { value: ze, pos: Ee, end: Ee + ze.length };
                      } else
                        We[Be.name] = ze;
                    }
                  }
                  d.push({ name: ne, args: { arguments: We, range: D } });
                } else
                  d.push({ name: ne, args: { arguments: {}, range: D } });
                return;
              }
              var He = D.kind === 2 && U.exec(fe);
              if (He)
                return H(d, D, 2, He);
              if (D.kind === 3)
                for (var rr = /@(\S+)(\s+.*)?$/gim, Ie = void 0; Ie = rr.exec(fe); )
                  H(d, D, 4, Ie);
            }
            function H(d, D, fe, g) {
              if (!!g) {
                var ne = g[1].toLowerCase(), ue = e2.commentPragmas[ne];
                if (!(!ue || !(ue.kind & fe))) {
                  var We = g[2], Fe = I(ue, We);
                  Fe !== "fail" && d.push({ name: ne, args: { arguments: Fe, range: D } });
                }
              }
            }
            function I(d, D) {
              if (!D)
                return {};
              if (!d.args)
                return {};
              for (var fe = e2.trimString(D).split(/\s+/), g = {}, ne = 0; ne < d.args.length; ne++) {
                var ue = d.args[ne];
                if (!fe[ne] && !ue.optional)
                  return "fail";
                if (ue.captureSpan)
                  return e2.Debug.fail("Capture spans not yet implemented for non-xml pragmas");
                g[ue.name] = fe[ne];
              }
              return g;
            }
            function l(d, D) {
              return d.kind !== D.kind ? false : d.kind === 79 ? d.escapedText === D.escapedText : d.kind === 108 ? true : d.name.escapedText === D.name.escapedText && l(d.expression, D.expression);
            }
            e2.tagNamesAreEquivalent = l;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            e2.compileOnSaveCommandLineOption = { name: "compileOnSave", type: "boolean", defaultValueDescription: false };
            var a = new e2.Map(e2.getEntries({ preserve: 1, "react-native": 3, react: 2, "react-jsx": 4, "react-jsxdev": 5 }));
            e2.inverseJsxOptionMap = new e2.Map(e2.arrayFrom(e2.mapIterator(a.entries(), function(Pe) {
              var Ue = Pe[0], fr = Pe[1];
              return ["" + fr, Ue];
            })));
            var C = [["es5", "lib.es5.d.ts"], ["es6", "lib.es2015.d.ts"], ["es2015", "lib.es2015.d.ts"], ["es7", "lib.es2016.d.ts"], ["es2016", "lib.es2016.d.ts"], ["es2017", "lib.es2017.d.ts"], ["es2018", "lib.es2018.d.ts"], ["es2019", "lib.es2019.d.ts"], ["es2020", "lib.es2020.d.ts"], ["es2021", "lib.es2021.d.ts"], ["es2022", "lib.es2022.d.ts"], ["esnext", "lib.esnext.d.ts"], ["dom", "lib.dom.d.ts"], ["dom.iterable", "lib.dom.iterable.d.ts"], ["webworker", "lib.webworker.d.ts"], ["webworker.importscripts", "lib.webworker.importscripts.d.ts"], ["webworker.iterable", "lib.webworker.iterable.d.ts"], ["scripthost", "lib.scripthost.d.ts"], ["es2015.core", "lib.es2015.core.d.ts"], ["es2015.collection", "lib.es2015.collection.d.ts"], ["es2015.generator", "lib.es2015.generator.d.ts"], ["es2015.iterable", "lib.es2015.iterable.d.ts"], ["es2015.promise", "lib.es2015.promise.d.ts"], ["es2015.proxy", "lib.es2015.proxy.d.ts"], ["es2015.reflect", "lib.es2015.reflect.d.ts"], ["es2015.symbol", "lib.es2015.symbol.d.ts"], ["es2015.symbol.wellknown", "lib.es2015.symbol.wellknown.d.ts"], ["es2016.array.include", "lib.es2016.array.include.d.ts"], ["es2017.object", "lib.es2017.object.d.ts"], ["es2017.sharedmemory", "lib.es2017.sharedmemory.d.ts"], ["es2017.string", "lib.es2017.string.d.ts"], ["es2017.intl", "lib.es2017.intl.d.ts"], ["es2017.typedarrays", "lib.es2017.typedarrays.d.ts"], ["es2018.asyncgenerator", "lib.es2018.asyncgenerator.d.ts"], ["es2018.asynciterable", "lib.es2018.asynciterable.d.ts"], ["es2018.intl", "lib.es2018.intl.d.ts"], ["es2018.promise", "lib.es2018.promise.d.ts"], ["es2018.regexp", "lib.es2018.regexp.d.ts"], ["es2019.array", "lib.es2019.array.d.ts"], ["es2019.object", "lib.es2019.object.d.ts"], ["es2019.string", "lib.es2019.string.d.ts"], ["es2019.symbol", "lib.es2019.symbol.d.ts"], ["es2020.bigint", "lib.es2020.bigint.d.ts"], ["es2020.date", "lib.es2020.date.d.ts"], ["es2020.promise", "lib.es2020.promise.d.ts"], ["es2020.sharedmemory", "lib.es2020.sharedmemory.d.ts"], ["es2020.string", "lib.es2020.string.d.ts"], ["es2020.symbol.wellknown", "lib.es2020.symbol.wellknown.d.ts"], ["es2020.intl", "lib.es2020.intl.d.ts"], ["es2020.number", "lib.es2020.number.d.ts"], ["es2021.promise", "lib.es2021.promise.d.ts"], ["es2021.string", "lib.es2021.string.d.ts"], ["es2021.weakref", "lib.es2021.weakref.d.ts"], ["es2021.intl", "lib.es2021.intl.d.ts"], ["es2022.array", "lib.es2022.array.d.ts"], ["es2022.error", "lib.es2022.error.d.ts"], ["es2022.intl", "lib.es2022.intl.d.ts"], ["es2022.object", "lib.es2022.object.d.ts"], ["es2022.string", "lib.es2022.string.d.ts"], ["esnext.array", "lib.es2022.array.d.ts"], ["esnext.symbol", "lib.es2019.symbol.d.ts"], ["esnext.asynciterable", "lib.es2018.asynciterable.d.ts"], ["esnext.intl", "lib.esnext.intl.d.ts"], ["esnext.bigint", "lib.es2020.bigint.d.ts"], ["esnext.string", "lib.es2022.string.d.ts"], ["esnext.promise", "lib.es2021.promise.d.ts"], ["esnext.weakref", "lib.es2021.weakref.d.ts"]];
            e2.libs = C.map(function(Pe) {
              return Pe[0];
            }), e2.libMap = new e2.Map(C), e2.optionsForWatch = [{ name: "watchFile", type: new e2.Map(e2.getEntries({ fixedpollinginterval: e2.WatchFileKind.FixedPollingInterval, prioritypollinginterval: e2.WatchFileKind.PriorityPollingInterval, dynamicprioritypolling: e2.WatchFileKind.DynamicPriorityPolling, fixedchunksizepolling: e2.WatchFileKind.FixedChunkSizePolling, usefsevents: e2.WatchFileKind.UseFsEvents, usefseventsonparentdirectory: e2.WatchFileKind.UseFsEventsOnParentDirectory })), category: e2.Diagnostics.Watch_and_Build_Modes, description: e2.Diagnostics.Specify_how_the_TypeScript_watch_mode_works, defaultValueDescription: e2.WatchFileKind.UseFsEvents }, { name: "watchDirectory", type: new e2.Map(e2.getEntries({ usefsevents: e2.WatchDirectoryKind.UseFsEvents, fixedpollinginterval: e2.WatchDirectoryKind.FixedPollingInterval, dynamicprioritypolling: e2.WatchDirectoryKind.DynamicPriorityPolling, fixedchunksizepolling: e2.WatchDirectoryKind.FixedChunkSizePolling })), category: e2.Diagnostics.Watch_and_Build_Modes, description: e2.Diagnostics.Specify_how_directories_are_watched_on_systems_that_lack_recursive_file_watching_functionality, defaultValueDescription: e2.WatchDirectoryKind.UseFsEvents }, { name: "fallbackPolling", type: new e2.Map(e2.getEntries({ fixedinterval: e2.PollingWatchKind.FixedInterval, priorityinterval: e2.PollingWatchKind.PriorityInterval, dynamicpriority: e2.PollingWatchKind.DynamicPriority, fixedchunksize: e2.PollingWatchKind.FixedChunkSize })), category: e2.Diagnostics.Watch_and_Build_Modes, description: e2.Diagnostics.Specify_what_approach_the_watcher_should_use_if_the_system_runs_out_of_native_file_watchers, defaultValueDescription: e2.PollingWatchKind.PriorityInterval }, { name: "synchronousWatchDirectory", type: "boolean", category: e2.Diagnostics.Watch_and_Build_Modes, description: e2.Diagnostics.Synchronously_call_callbacks_and_update_the_state_of_directory_watchers_on_platforms_that_don_t_support_recursive_watching_natively, defaultValueDescription: false }, { name: "excludeDirectories", type: "list", element: { name: "excludeDirectory", type: "string", isFilePath: true, extraValidation: Je }, category: e2.Diagnostics.Watch_and_Build_Modes, description: e2.Diagnostics.Remove_a_list_of_directories_from_the_watch_process }, { name: "excludeFiles", type: "list", element: { name: "excludeFile", type: "string", isFilePath: true, extraValidation: Je }, category: e2.Diagnostics.Watch_and_Build_Modes, description: e2.Diagnostics.Remove_a_list_of_files_from_the_watch_mode_s_processing }], e2.commonOptionsWithBuild = [{ name: "help", shortName: "h", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Print_this_message, defaultValueDescription: false }, { name: "help", shortName: "?", type: "boolean", defaultValueDescription: false }, { name: "watch", shortName: "w", type: "boolean", showInSimplifiedHelpView: true, isCommandLineOnly: true, category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Watch_input_files, defaultValueDescription: false }, { name: "preserveWatchOutput", type: "boolean", showInSimplifiedHelpView: false, category: e2.Diagnostics.Output_Formatting, description: e2.Diagnostics.Disable_wiping_the_console_in_watch_mode, defaultValueDescription: false }, { name: "listFiles", type: "boolean", category: e2.Diagnostics.Compiler_Diagnostics, description: e2.Diagnostics.Print_all_of_the_files_read_during_the_compilation, defaultValueDescription: false }, { name: "explainFiles", type: "boolean", category: e2.Diagnostics.Compiler_Diagnostics, description: e2.Diagnostics.Print_files_read_during_the_compilation_including_why_it_was_included, defaultValueDescription: false }, { name: "listEmittedFiles", type: "boolean", category: e2.Diagnostics.Compiler_Diagnostics, description: e2.Diagnostics.Print_the_names_of_emitted_files_after_a_compilation, defaultValueDescription: false }, { name: "pretty", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.Output_Formatting, description: e2.Diagnostics.Enable_color_and_formatting_in_TypeScript_s_output_to_make_compiler_errors_easier_to_read, defaultValueDescription: true }, { name: "traceResolution", type: "boolean", category: e2.Diagnostics.Compiler_Diagnostics, description: e2.Diagnostics.Log_paths_used_during_the_moduleResolution_process, defaultValueDescription: false }, { name: "diagnostics", type: "boolean", category: e2.Diagnostics.Compiler_Diagnostics, description: e2.Diagnostics.Output_compiler_performance_information_after_building, defaultValueDescription: false }, { name: "extendedDiagnostics", type: "boolean", category: e2.Diagnostics.Compiler_Diagnostics, description: e2.Diagnostics.Output_more_detailed_compiler_performance_information_after_building, defaultValueDescription: false }, { name: "generateCpuProfile", type: "string", isFilePath: true, paramType: e2.Diagnostics.FILE_OR_DIRECTORY, category: e2.Diagnostics.Compiler_Diagnostics, description: e2.Diagnostics.Emit_a_v8_CPU_profile_of_the_compiler_run_for_debugging, defaultValueDescription: "profile.cpuprofile" }, { name: "generateTrace", type: "string", isFilePath: true, isCommandLineOnly: true, paramType: e2.Diagnostics.DIRECTORY, category: e2.Diagnostics.Compiler_Diagnostics, description: e2.Diagnostics.Generates_an_event_trace_and_a_list_of_types }, { name: "incremental", shortName: "i", type: "boolean", category: e2.Diagnostics.Projects, description: e2.Diagnostics.Save_tsbuildinfo_files_to_allow_for_incremental_compilation_of_projects, transpileOptionValue: void 0, defaultValueDescription: e2.Diagnostics.false_unless_composite_is_set }, { name: "assumeChangesOnlyAffectDirectDependencies", type: "boolean", affectsSemanticDiagnostics: true, affectsEmit: true, category: e2.Diagnostics.Watch_and_Build_Modes, description: e2.Diagnostics.Have_recompiles_in_projects_that_use_incremental_and_watch_mode_assume_that_changes_within_a_file_will_only_affect_files_directly_depending_on_it, defaultValueDescription: false }, { name: "locale", type: "string", category: e2.Diagnostics.Command_line_Options, isCommandLineOnly: true, description: e2.Diagnostics.Set_the_language_of_the_messaging_from_TypeScript_This_does_not_affect_emit, defaultValueDescription: e2.Diagnostics.Platform_specific }], e2.targetOptionDeclaration = { name: "target", shortName: "t", type: new e2.Map(e2.getEntries({ es3: 0, es5: 1, es6: 2, es2015: 2, es2016: 3, es2017: 4, es2018: 5, es2019: 6, es2020: 7, es2021: 8, es2022: 9, esnext: 99 })), affectsSourceFile: true, affectsModuleResolution: true, affectsEmit: true, paramType: e2.Diagnostics.VERSION, showInSimplifiedHelpView: true, category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Set_the_JavaScript_language_version_for_emitted_JavaScript_and_include_compatible_library_declarations, defaultValueDescription: 0 };
            var w = [{ name: "all", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Show_all_compiler_options, defaultValueDescription: false }, { name: "version", shortName: "v", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Print_the_compiler_s_version, defaultValueDescription: false }, { name: "init", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Initializes_a_TypeScript_project_and_creates_a_tsconfig_json_file, defaultValueDescription: false }, { name: "project", shortName: "p", type: "string", isFilePath: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Command_line_Options, paramType: e2.Diagnostics.FILE_OR_DIRECTORY, description: e2.Diagnostics.Compile_the_project_given_the_path_to_its_configuration_file_or_to_a_folder_with_a_tsconfig_json }, { name: "build", type: "boolean", shortName: "b", showInSimplifiedHelpView: true, category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Build_one_or_more_projects_and_their_dependencies_if_out_of_date, defaultValueDescription: false }, { name: "showConfig", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.Command_line_Options, isCommandLineOnly: true, description: e2.Diagnostics.Print_the_final_configuration_instead_of_building, defaultValueDescription: false }, { name: "listFilesOnly", type: "boolean", category: e2.Diagnostics.Command_line_Options, affectsSemanticDiagnostics: true, affectsEmit: true, isCommandLineOnly: true, description: e2.Diagnostics.Print_names_of_files_that_are_part_of_the_compilation_and_then_stop_processing, defaultValueDescription: false }, e2.targetOptionDeclaration, { name: "module", shortName: "m", type: new e2.Map(e2.getEntries({ none: e2.ModuleKind.None, commonjs: e2.ModuleKind.CommonJS, amd: e2.ModuleKind.AMD, system: e2.ModuleKind.System, umd: e2.ModuleKind.UMD, es6: e2.ModuleKind.ES2015, es2015: e2.ModuleKind.ES2015, es2020: e2.ModuleKind.ES2020, es2022: e2.ModuleKind.ES2022, esnext: e2.ModuleKind.ESNext, node16: e2.ModuleKind.Node16, nodenext: e2.ModuleKind.NodeNext })), affectsModuleResolution: true, affectsEmit: true, paramType: e2.Diagnostics.KIND, showInSimplifiedHelpView: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Specify_what_module_code_is_generated, defaultValueDescription: void 0 }, { name: "lib", type: "list", element: { name: "lib", type: e2.libMap, defaultValueDescription: void 0 }, affectsProgramStructure: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Specify_a_set_of_bundled_library_declaration_files_that_describe_the_target_runtime_environment, transpileOptionValue: void 0 }, { name: "allowJs", type: "boolean", affectsModuleResolution: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.JavaScript_Support, description: e2.Diagnostics.Allow_JavaScript_files_to_be_a_part_of_your_program_Use_the_checkJS_option_to_get_errors_from_these_files, defaultValueDescription: false }, { name: "checkJs", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.JavaScript_Support, description: e2.Diagnostics.Enable_error_reporting_in_type_checked_JavaScript_files, defaultValueDescription: false }, { name: "jsx", type: a, affectsSourceFile: true, affectsEmit: true, affectsModuleResolution: true, paramType: e2.Diagnostics.KIND, showInSimplifiedHelpView: true, category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Specify_what_JSX_code_is_generated, defaultValueDescription: void 0 }, { name: "declaration", shortName: "d", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Emit, transpileOptionValue: void 0, description: e2.Diagnostics.Generate_d_ts_files_from_TypeScript_and_JavaScript_files_in_your_project, defaultValueDescription: e2.Diagnostics.false_unless_composite_is_set }, { name: "declarationMap", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Emit, transpileOptionValue: void 0, defaultValueDescription: false, description: e2.Diagnostics.Create_sourcemaps_for_d_ts_files }, { name: "emitDeclarationOnly", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Only_output_d_ts_files_and_not_JavaScript_files, transpileOptionValue: void 0, defaultValueDescription: false }, { name: "sourceMap", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Emit, defaultValueDescription: false, description: e2.Diagnostics.Create_source_map_files_for_emitted_JavaScript_files }, { name: "outFile", type: "string", affectsEmit: true, isFilePath: true, paramType: e2.Diagnostics.FILE, showInSimplifiedHelpView: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Specify_a_file_that_bundles_all_outputs_into_one_JavaScript_file_If_declaration_is_true_also_designates_a_file_that_bundles_all_d_ts_output, transpileOptionValue: void 0 }, { name: "outDir", type: "string", affectsEmit: true, isFilePath: true, paramType: e2.Diagnostics.DIRECTORY, showInSimplifiedHelpView: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Specify_an_output_folder_for_all_emitted_files }, { name: "rootDir", type: "string", affectsEmit: true, isFilePath: true, paramType: e2.Diagnostics.LOCATION, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Specify_the_root_folder_within_your_source_files, defaultValueDescription: e2.Diagnostics.Computed_from_the_list_of_input_files }, { name: "composite", type: "boolean", affectsEmit: true, isTSConfigOnly: true, category: e2.Diagnostics.Projects, transpileOptionValue: void 0, defaultValueDescription: false, description: e2.Diagnostics.Enable_constraints_that_allow_a_TypeScript_project_to_be_used_with_project_references }, { name: "tsBuildInfoFile", type: "string", affectsEmit: true, isFilePath: true, paramType: e2.Diagnostics.FILE, category: e2.Diagnostics.Projects, transpileOptionValue: void 0, defaultValueDescription: ".tsbuildinfo", description: e2.Diagnostics.Specify_the_path_to_tsbuildinfo_incremental_compilation_file }, { name: "removeComments", type: "boolean", affectsEmit: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Emit, defaultValueDescription: false, description: e2.Diagnostics.Disable_emitting_comments }, { name: "noEmit", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Disable_emitting_files_from_a_compilation, transpileOptionValue: void 0, defaultValueDescription: false }, { name: "importHelpers", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Allow_importing_helper_functions_from_tslib_once_per_project_instead_of_including_them_per_file, defaultValueDescription: false }, { name: "importsNotUsedAsValues", type: new e2.Map(e2.getEntries({ remove: 0, preserve: 1, error: 2 })), affectsEmit: true, affectsSemanticDiagnostics: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Specify_emit_Slashchecking_behavior_for_imports_that_are_only_used_for_types, defaultValueDescription: 0 }, { name: "downlevelIteration", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Emit_more_compliant_but_verbose_and_less_performant_JavaScript_for_iteration, defaultValueDescription: false }, { name: "isolatedModules", type: "boolean", category: e2.Diagnostics.Interop_Constraints, description: e2.Diagnostics.Ensure_that_each_file_can_be_safely_transpiled_without_relying_on_other_imports, transpileOptionValue: true, defaultValueDescription: false }, { name: "strict", type: "boolean", showInSimplifiedHelpView: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Enable_all_strict_type_checking_options, defaultValueDescription: false }, { name: "noImplicitAny", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Enable_error_reporting_for_expressions_and_declarations_with_an_implied_any_type, defaultValueDescription: e2.Diagnostics.false_unless_strict_is_set }, { name: "strictNullChecks", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.When_type_checking_take_into_account_null_and_undefined, defaultValueDescription: e2.Diagnostics.false_unless_strict_is_set }, { name: "strictFunctionTypes", type: "boolean", strictFlag: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.When_assigning_functions_check_to_ensure_parameters_and_the_return_values_are_subtype_compatible, defaultValueDescription: e2.Diagnostics.false_unless_strict_is_set }, { name: "strictBindCallApply", type: "boolean", strictFlag: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Check_that_the_arguments_for_bind_call_and_apply_methods_match_the_original_function, defaultValueDescription: e2.Diagnostics.false_unless_strict_is_set }, { name: "strictPropertyInitialization", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Check_for_class_properties_that_are_declared_but_not_set_in_the_constructor, defaultValueDescription: e2.Diagnostics.false_unless_strict_is_set }, { name: "noImplicitThis", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Enable_error_reporting_when_this_is_given_the_type_any, defaultValueDescription: e2.Diagnostics.false_unless_strict_is_set }, { name: "useUnknownInCatchVariables", type: "boolean", affectsSemanticDiagnostics: true, strictFlag: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Default_catch_clause_variables_as_unknown_instead_of_any, defaultValueDescription: false }, { name: "alwaysStrict", type: "boolean", affectsSourceFile: true, strictFlag: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Ensure_use_strict_is_always_emitted, defaultValueDescription: e2.Diagnostics.false_unless_strict_is_set }, { name: "noUnusedLocals", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Enable_error_reporting_when_local_variables_aren_t_read, defaultValueDescription: false }, { name: "noUnusedParameters", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Raise_an_error_when_a_function_parameter_isn_t_read, defaultValueDescription: false }, { name: "exactOptionalPropertyTypes", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Interpret_optional_property_types_as_written_rather_than_adding_undefined, defaultValueDescription: false }, { name: "noImplicitReturns", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Enable_error_reporting_for_codepaths_that_do_not_explicitly_return_in_a_function, defaultValueDescription: false }, { name: "noFallthroughCasesInSwitch", type: "boolean", affectsBindDiagnostics: true, affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Enable_error_reporting_for_fallthrough_cases_in_switch_statements, defaultValueDescription: false }, { name: "noUncheckedIndexedAccess", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Add_undefined_to_a_type_when_accessed_using_an_index, defaultValueDescription: false }, { name: "noImplicitOverride", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Ensure_overriding_members_in_derived_classes_are_marked_with_an_override_modifier, defaultValueDescription: false }, { name: "noPropertyAccessFromIndexSignature", type: "boolean", showInSimplifiedHelpView: false, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Enforces_using_indexed_accessors_for_keys_declared_using_an_indexed_type, defaultValueDescription: false }, { name: "moduleResolution", type: new e2.Map(e2.getEntries({ node: e2.ModuleResolutionKind.NodeJs, classic: e2.ModuleResolutionKind.Classic, node16: e2.ModuleResolutionKind.Node16, nodenext: e2.ModuleResolutionKind.NodeNext })), affectsModuleResolution: true, paramType: e2.Diagnostics.STRATEGY, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Specify_how_TypeScript_looks_up_a_file_from_a_given_module_specifier, defaultValueDescription: e2.Diagnostics.module_AMD_or_UMD_or_System_or_ES6_then_Classic_Otherwise_Node }, { name: "baseUrl", type: "string", affectsModuleResolution: true, isFilePath: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Specify_the_base_directory_to_resolve_non_relative_module_names }, { name: "paths", type: "object", affectsModuleResolution: true, isTSConfigOnly: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Specify_a_set_of_entries_that_re_map_imports_to_additional_lookup_locations, transpileOptionValue: void 0 }, { name: "rootDirs", type: "list", isTSConfigOnly: true, element: { name: "rootDirs", type: "string", isFilePath: true }, affectsModuleResolution: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Allow_multiple_folders_to_be_treated_as_one_when_resolving_modules, transpileOptionValue: void 0, defaultValueDescription: e2.Diagnostics.Computed_from_the_list_of_input_files }, { name: "typeRoots", type: "list", element: { name: "typeRoots", type: "string", isFilePath: true }, affectsModuleResolution: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Specify_multiple_folders_that_act_like_Slashnode_modules_Slash_types }, { name: "types", type: "list", element: { name: "types", type: "string" }, affectsProgramStructure: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Specify_type_package_names_to_be_included_without_being_referenced_in_a_source_file, transpileOptionValue: void 0 }, { name: "allowSyntheticDefaultImports", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Interop_Constraints, description: e2.Diagnostics.Allow_import_x_from_y_when_a_module_doesn_t_have_a_default_export, defaultValueDescription: e2.Diagnostics.module_system_or_esModuleInterop }, { name: "esModuleInterop", type: "boolean", affectsSemanticDiagnostics: true, affectsEmit: true, showInSimplifiedHelpView: true, category: e2.Diagnostics.Interop_Constraints, description: e2.Diagnostics.Emit_additional_JavaScript_to_ease_support_for_importing_CommonJS_modules_This_enables_allowSyntheticDefaultImports_for_type_compatibility, defaultValueDescription: false }, { name: "preserveSymlinks", type: "boolean", category: e2.Diagnostics.Interop_Constraints, description: e2.Diagnostics.Disable_resolving_symlinks_to_their_realpath_This_correlates_to_the_same_flag_in_node, defaultValueDescription: false }, { name: "allowUmdGlobalAccess", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Allow_accessing_UMD_globals_from_modules, defaultValueDescription: false }, { name: "moduleSuffixes", type: "list", element: { name: "suffix", type: "string" }, listPreserveFalsyValues: true, affectsModuleResolution: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.List_of_file_name_suffixes_to_search_when_resolving_a_module }, { name: "sourceRoot", type: "string", affectsEmit: true, paramType: e2.Diagnostics.LOCATION, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Specify_the_root_path_for_debuggers_to_find_the_reference_source_code }, { name: "mapRoot", type: "string", affectsEmit: true, paramType: e2.Diagnostics.LOCATION, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Specify_the_location_where_debugger_should_locate_map_files_instead_of_generated_locations }, { name: "inlineSourceMap", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Include_sourcemap_files_inside_the_emitted_JavaScript, defaultValueDescription: false }, { name: "inlineSources", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Include_source_code_in_the_sourcemaps_inside_the_emitted_JavaScript, defaultValueDescription: false }, { name: "experimentalDecorators", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Enable_experimental_support_for_TC39_stage_2_draft_decorators, defaultValueDescription: false }, { name: "emitDecoratorMetadata", type: "boolean", affectsSemanticDiagnostics: true, affectsEmit: true, category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Emit_design_type_metadata_for_decorated_declarations_in_source_files, defaultValueDescription: false }, { name: "jsxFactory", type: "string", category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Specify_the_JSX_factory_function_used_when_targeting_React_JSX_emit_e_g_React_createElement_or_h, defaultValueDescription: "`React.createElement`" }, { name: "jsxFragmentFactory", type: "string", category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Specify_the_JSX_Fragment_reference_used_for_fragments_when_targeting_React_JSX_emit_e_g_React_Fragment_or_Fragment, defaultValueDescription: "React.Fragment" }, { name: "jsxImportSource", type: "string", affectsSemanticDiagnostics: true, affectsEmit: true, affectsModuleResolution: true, category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Specify_module_specifier_used_to_import_the_JSX_factory_functions_when_using_jsx_Colon_react_jsx_Asterisk, defaultValueDescription: "react" }, { name: "resolveJsonModule", type: "boolean", affectsModuleResolution: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Enable_importing_json_files, defaultValueDescription: false }, { name: "out", type: "string", affectsEmit: true, isFilePath: false, category: e2.Diagnostics.Backwards_Compatibility, paramType: e2.Diagnostics.FILE, transpileOptionValue: void 0, description: e2.Diagnostics.Deprecated_setting_Use_outFile_instead }, { name: "reactNamespace", type: "string", affectsEmit: true, category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Specify_the_object_invoked_for_createElement_This_only_applies_when_targeting_react_JSX_emit, defaultValueDescription: "`React`" }, { name: "skipDefaultLibCheck", type: "boolean", category: e2.Diagnostics.Completeness, description: e2.Diagnostics.Skip_type_checking_d_ts_files_that_are_included_with_TypeScript, defaultValueDescription: false }, { name: "charset", type: "string", category: e2.Diagnostics.Backwards_Compatibility, description: e2.Diagnostics.No_longer_supported_In_early_versions_manually_set_the_text_encoding_for_reading_files, defaultValueDescription: "utf8" }, { name: "emitBOM", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Emit_a_UTF_8_Byte_Order_Mark_BOM_in_the_beginning_of_output_files, defaultValueDescription: false }, { name: "newLine", type: new e2.Map(e2.getEntries({ crlf: 0, lf: 1 })), affectsEmit: true, paramType: e2.Diagnostics.NEWLINE, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Set_the_newline_character_for_emitting_files, defaultValueDescription: e2.Diagnostics.Platform_specific }, { name: "noErrorTruncation", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Output_Formatting, description: e2.Diagnostics.Disable_truncating_types_in_error_messages, defaultValueDescription: false }, { name: "noLib", type: "boolean", category: e2.Diagnostics.Language_and_Environment, affectsProgramStructure: true, description: e2.Diagnostics.Disable_including_any_library_files_including_the_default_lib_d_ts, transpileOptionValue: true, defaultValueDescription: false }, { name: "noResolve", type: "boolean", affectsModuleResolution: true, category: e2.Diagnostics.Modules, description: e2.Diagnostics.Disallow_import_s_require_s_or_reference_s_from_expanding_the_number_of_files_TypeScript_should_add_to_a_project, transpileOptionValue: true, defaultValueDescription: false }, { name: "stripInternal", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Disable_emitting_declarations_that_have_internal_in_their_JSDoc_comments, defaultValueDescription: false }, { name: "disableSizeLimit", type: "boolean", affectsProgramStructure: true, category: e2.Diagnostics.Editor_Support, description: e2.Diagnostics.Remove_the_20mb_cap_on_total_source_code_size_for_JavaScript_files_in_the_TypeScript_language_server, defaultValueDescription: false }, { name: "disableSourceOfProjectReferenceRedirect", type: "boolean", isTSConfigOnly: true, category: e2.Diagnostics.Projects, description: e2.Diagnostics.Disable_preferring_source_files_instead_of_declaration_files_when_referencing_composite_projects, defaultValueDescription: false }, { name: "disableSolutionSearching", type: "boolean", isTSConfigOnly: true, category: e2.Diagnostics.Projects, description: e2.Diagnostics.Opt_a_project_out_of_multi_project_reference_checking_when_editing, defaultValueDescription: false }, { name: "disableReferencedProjectLoad", type: "boolean", isTSConfigOnly: true, category: e2.Diagnostics.Projects, description: e2.Diagnostics.Reduce_the_number_of_projects_loaded_automatically_by_TypeScript, defaultValueDescription: false }, { name: "noImplicitUseStrict", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Backwards_Compatibility, description: e2.Diagnostics.Disable_adding_use_strict_directives_in_emitted_JavaScript_files, defaultValueDescription: false }, { name: "noEmitHelpers", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Disable_generating_custom_helper_functions_like_extends_in_compiled_output, defaultValueDescription: false }, { name: "noEmitOnError", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, transpileOptionValue: void 0, description: e2.Diagnostics.Disable_emitting_files_if_any_type_checking_errors_are_reported, defaultValueDescription: false }, { name: "preserveConstEnums", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Disable_erasing_const_enum_declarations_in_generated_code, defaultValueDescription: false }, { name: "declarationDir", type: "string", affectsEmit: true, isFilePath: true, paramType: e2.Diagnostics.DIRECTORY, category: e2.Diagnostics.Emit, transpileOptionValue: void 0, description: e2.Diagnostics.Specify_the_output_directory_for_generated_declaration_files }, { name: "skipLibCheck", type: "boolean", category: e2.Diagnostics.Completeness, description: e2.Diagnostics.Skip_type_checking_all_d_ts_files, defaultValueDescription: false }, { name: "allowUnusedLabels", type: "boolean", affectsBindDiagnostics: true, affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Disable_error_reporting_for_unused_labels, defaultValueDescription: void 0 }, { name: "allowUnreachableCode", type: "boolean", affectsBindDiagnostics: true, affectsSemanticDiagnostics: true, category: e2.Diagnostics.Type_Checking, description: e2.Diagnostics.Disable_error_reporting_for_unreachable_code, defaultValueDescription: void 0 }, { name: "suppressExcessPropertyErrors", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Backwards_Compatibility, description: e2.Diagnostics.Disable_reporting_of_excess_property_errors_during_the_creation_of_object_literals, defaultValueDescription: false }, { name: "suppressImplicitAnyIndexErrors", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Backwards_Compatibility, description: e2.Diagnostics.Suppress_noImplicitAny_errors_when_indexing_objects_that_lack_index_signatures, defaultValueDescription: false }, { name: "forceConsistentCasingInFileNames", type: "boolean", affectsModuleResolution: true, category: e2.Diagnostics.Interop_Constraints, description: e2.Diagnostics.Ensure_that_casing_is_correct_in_imports, defaultValueDescription: false }, { name: "maxNodeModuleJsDepth", type: "number", affectsModuleResolution: true, category: e2.Diagnostics.JavaScript_Support, description: e2.Diagnostics.Specify_the_maximum_folder_depth_used_for_checking_JavaScript_files_from_node_modules_Only_applicable_with_allowJs, defaultValueDescription: 0 }, { name: "noStrictGenericChecks", type: "boolean", affectsSemanticDiagnostics: true, category: e2.Diagnostics.Backwards_Compatibility, description: e2.Diagnostics.Disable_strict_checking_of_generic_signatures_in_function_types, defaultValueDescription: false }, { name: "useDefineForClassFields", type: "boolean", affectsSemanticDiagnostics: true, affectsEmit: true, category: e2.Diagnostics.Language_and_Environment, description: e2.Diagnostics.Emit_ECMAScript_standard_compliant_class_fields, defaultValueDescription: e2.Diagnostics.true_for_ES2022_and_above_including_ESNext }, { name: "preserveValueImports", type: "boolean", affectsEmit: true, category: e2.Diagnostics.Emit, description: e2.Diagnostics.Preserve_unused_imported_values_in_the_JavaScript_output_that_would_otherwise_be_removed, defaultValueDescription: false }, { name: "keyofStringsOnly", type: "boolean", category: e2.Diagnostics.Backwards_Compatibility, description: e2.Diagnostics.Make_keyof_only_return_strings_instead_of_string_numbers_or_symbols_Legacy_option, defaultValueDescription: false }, { name: "plugins", type: "list", isTSConfigOnly: true, element: { name: "plugin", type: "object" }, description: e2.Diagnostics.Specify_a_list_of_language_service_plugins_to_include, category: e2.Diagnostics.Editor_Support }, { name: "moduleDetection", type: new e2.Map(e2.getEntries({ auto: e2.ModuleDetectionKind.Auto, legacy: e2.ModuleDetectionKind.Legacy, force: e2.ModuleDetectionKind.Force })), affectsModuleResolution: true, description: e2.Diagnostics.Control_what_method_is_used_to_detect_module_format_JS_files, category: e2.Diagnostics.Language_and_Environment, defaultValueDescription: e2.Diagnostics.auto_Colon_Treat_files_with_imports_exports_import_meta_jsx_with_jsx_Colon_react_jsx_or_esm_format_with_module_Colon_node16_as_modules }];
            e2.optionDeclarations = Ve(Ve([], e2.commonOptionsWithBuild, true), w, true), e2.semanticDiagnosticsOptionDeclarations = e2.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsSemanticDiagnostics;
            }), e2.affectsEmitOptionDeclarations = e2.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsEmit;
            }), e2.moduleResolutionOptionDeclarations = e2.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsModuleResolution;
            }), e2.sourceFileAffectingCompilerOptions = e2.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsSourceFile || !!Pe.affectsModuleResolution || !!Pe.affectsBindDiagnostics;
            }), e2.optionsAffectingProgramStructure = e2.optionDeclarations.filter(function(Pe) {
              return !!Pe.affectsProgramStructure;
            }), e2.transpileOptionValueCompilerOptions = e2.optionDeclarations.filter(function(Pe) {
              return e2.hasProperty(Pe, "transpileOptionValue");
            }), e2.optionsForBuild = [{ name: "verbose", shortName: "v", category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Enable_verbose_logging, type: "boolean", defaultValueDescription: false }, { name: "dry", shortName: "d", category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Show_what_would_be_built_or_deleted_if_specified_with_clean, type: "boolean", defaultValueDescription: false }, { name: "force", shortName: "f", category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Build_all_projects_including_those_that_appear_to_be_up_to_date, type: "boolean", defaultValueDescription: false }, { name: "clean", category: e2.Diagnostics.Command_line_Options, description: e2.Diagnostics.Delete_the_outputs_of_all_projects, type: "boolean", defaultValueDescription: false }], e2.buildOpts = Ve(Ve([], e2.commonOptionsWithBuild, true), e2.optionsForBuild, true), e2.typeAcquisitionDeclarations = [{ name: "enableAutoDiscovery", type: "boolean", defaultValueDescription: false }, { name: "enable", type: "boolean", defaultValueDescription: false }, { name: "include", type: "list", element: { name: "include", type: "string" } }, { name: "exclude", type: "list", element: { name: "exclude", type: "string" } }, { name: "disableFilenameBasedTypeAcquisition", type: "boolean", defaultValueDescription: false }];
            function B(Pe) {
              var Ue = new e2.Map(), fr = new e2.Map();
              return e2.forEach(Pe, function(De) {
                Ue.set(De.name.toLowerCase(), De), De.shortName && fr.set(De.shortName, De.name);
              }), { optionsNameMap: Ue, shortOptionNames: fr };
            }
            e2.createOptionNameMap = B;
            var E;
            function Q() {
              return E || (E = B(e2.optionDeclarations));
            }
            e2.getOptionsNameMap = Q;
            var le = { diagnostic: e2.Diagnostics.Compiler_option_0_may_only_be_used_with_build, getOptionsNameMap: q };
            e2.defaultInitCompilerOptions = { module: e2.ModuleKind.CommonJS, target: 3, strict: true, esModuleInterop: true, forceConsistentCasingInFileNames: true, skipLibCheck: true };
            function N(Pe) {
              return Pe && Pe.enableAutoDiscovery !== void 0 && Pe.enable === void 0 ? { enable: Pe.enableAutoDiscovery, include: Pe.include || [], exclude: Pe.exclude || [] } : Pe;
            }
            e2.convertEnableAutoDiscoveryToEnable = N;
            function p(Pe) {
              return m2(Pe, e2.createCompilerDiagnostic);
            }
            e2.createCompilerDiagnosticForInvalidCustomType = p;
            function m2(Pe, Ue) {
              var fr = e2.arrayFrom(Pe.type.keys()).map(function(De) {
                return "'".concat(De, "'");
              }).join(", ");
              return Ue(e2.Diagnostics.Argument_for_0_option_must_be_Colon_1, "--".concat(Pe.name), fr);
            }
            function G(Pe, Ue, fr) {
              return _r(Pe, e2.trimString(Ue || ""), fr);
            }
            e2.parseCustomTypeOption = G;
            function oe(Pe, Ue, fr) {
              if (Ue === void 0 && (Ue = ""), Ue = e2.trimString(Ue), !e2.startsWith(Ue, "-")) {
                if (Ue === "")
                  return [];
                var De = Ue.split(",");
                switch (Pe.element.type) {
                  case "number":
                    return e2.mapDefined(De, function(gr) {
                      return Zt(Pe.element, parseInt(gr), fr);
                    });
                  case "string":
                    return e2.mapDefined(De, function(gr) {
                      return Zt(Pe.element, gr || "", fr);
                    });
                  default:
                    return e2.mapDefined(De, function(gr) {
                      return G(Pe.element, gr, fr);
                    });
                }
              }
            }
            e2.parseListTypeOption = oe;
            function f4(Pe) {
              return Pe.name;
            }
            function T(Pe, Ue, fr, De) {
              var gr;
              if (!((gr = Ue.alternateMode) === null || gr === void 0) && gr.getOptionsNameMap().optionsNameMap.has(Pe.toLowerCase()))
                return fr(Ue.alternateMode.diagnostic, Pe);
              var Vr = e2.getSpellingSuggestion(Pe, Ue.optionDeclarations, f4);
              return Vr ? fr(Ue.unknownDidYouMeanDiagnostic, De || Pe, Vr.name) : fr(Ue.unknownOptionDiagnostic, De || Pe);
            }
            function K(Pe, Ue, fr) {
              var De = {}, gr, Vr = [], Tr = [];
              return vi(Ue), { options: De, watchOptions: gr, fileNames: Vr, errors: Tr };
              function vi(Yi) {
                for (var Wi = 0; Wi < Yi.length; ) {
                  var ct = Yi[Wi];
                  if (Wi++, ct.charCodeAt(0) === 64)
                    Ui(ct.slice(1));
                  else if (ct.charCodeAt(0) === 45) {
                    var Li = ct.slice(ct.charCodeAt(1) === 45 ? 2 : 1), nt = ie(Pe.getOptionsNameMap, Li, true);
                    if (nt)
                      Wi = b(Yi, Wi, Pe, nt, De, Tr);
                    else {
                      var Mt = ie(k.getOptionsNameMap, Li, true);
                      Mt ? Wi = b(Yi, Wi, k, Mt, gr || (gr = {}), Tr) : Tr.push(T(Li, Pe, e2.createCompilerDiagnostic, ct));
                    }
                  } else
                    Vr.push(ct);
                }
              }
              function Ui(Yi) {
                var Wi = A2(Yi, fr || function(Mt) {
                  return e2.sys.readFile(Mt);
                });
                if (!e2.isString(Wi)) {
                  Tr.push(Wi);
                  return;
                }
                for (var ct = [], Li = 0; ; ) {
                  for (; Li < Wi.length && Wi.charCodeAt(Li) <= 32; )
                    Li++;
                  if (Li >= Wi.length)
                    break;
                  var nt = Li;
                  if (Wi.charCodeAt(nt) === 34) {
                    for (Li++; Li < Wi.length && Wi.charCodeAt(Li) !== 34; )
                      Li++;
                    Li < Wi.length ? (ct.push(Wi.substring(nt + 1, Li)), Li++) : Tr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Unterminated_quoted_string_in_response_file_0, Yi));
                  } else {
                    for (; Wi.charCodeAt(Li) > 32; )
                      Li++;
                    ct.push(Wi.substring(nt, Li));
                  }
                }
                vi(ct);
              }
            }
            e2.parseCommandLineWorker = K;
            function b(Pe, Ue, fr, De, gr, Vr) {
              if (De.isTSConfigOnly) {
                var Tr = Pe[Ue];
                Tr === "null" ? (gr[De.name] = void 0, Ue++) : De.type === "boolean" ? Tr === "false" ? (gr[De.name] = Zt(De, false, Vr), Ue++) : (Tr === "true" && Ue++, Vr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_false_or_null_on_command_line, De.name))) : (Vr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Option_0_can_only_be_specified_in_tsconfig_json_file_or_set_to_null_on_command_line, De.name)), Tr && !e2.startsWith(Tr, "-") && Ue++);
              } else if (!Pe[Ue] && De.type !== "boolean" && Vr.push(e2.createCompilerDiagnostic(fr.optionTypeMismatchDiagnostic, De.name, ue(De))), Pe[Ue] !== "null")
                switch (De.type) {
                  case "number":
                    gr[De.name] = Zt(De, parseInt(Pe[Ue]), Vr), Ue++;
                    break;
                  case "boolean":
                    var Tr = Pe[Ue];
                    gr[De.name] = Zt(De, Tr !== "false", Vr), (Tr === "false" || Tr === "true") && Ue++;
                    break;
                  case "string":
                    gr[De.name] = Zt(De, Pe[Ue] || "", Vr), Ue++;
                    break;
                  case "list":
                    var vi = oe(De, Pe[Ue], Vr);
                    gr[De.name] = vi || [], vi && Ue++;
                    break;
                  default:
                    gr[De.name] = G(De, Pe[Ue], Vr), Ue++;
                    break;
                }
              else
                gr[De.name] = void 0, Ue++;
              return Ue;
            }
            e2.compilerOptionsDidYouMeanDiagnostics = { alternateMode: le, getOptionsNameMap: Q, optionDeclarations: e2.optionDeclarations, unknownOptionDiagnostic: e2.Diagnostics.Unknown_compiler_option_0, unknownDidYouMeanDiagnostic: e2.Diagnostics.Unknown_compiler_option_0_Did_you_mean_1, optionTypeMismatchDiagnostic: e2.Diagnostics.Compiler_option_0_expects_an_argument };
            function se(Pe, Ue) {
              return K(e2.compilerOptionsDidYouMeanDiagnostics, Pe, Ue);
            }
            e2.parseCommandLine = se;
            function J(Pe, Ue) {
              return ie(Q, Pe, Ue);
            }
            e2.getOptionFromName = J;
            function ie(Pe, Ue, fr) {
              fr === void 0 && (fr = false), Ue = Ue.toLowerCase();
              var De = Pe(), gr = De.optionsNameMap, Vr = De.shortOptionNames;
              if (fr) {
                var Tr = Vr.get(Ue);
                Tr !== void 0 && (Ue = Tr);
              }
              return gr.get(Ue);
            }
            var R;
            function q() {
              return R || (R = B(e2.buildOpts));
            }
            var O = { diagnostic: e2.Diagnostics.Compiler_option_0_may_not_be_used_with_build, getOptionsNameMap: Q }, ve = { alternateMode: O, getOptionsNameMap: q, optionDeclarations: e2.buildOpts, unknownOptionDiagnostic: e2.Diagnostics.Unknown_build_option_0, unknownDidYouMeanDiagnostic: e2.Diagnostics.Unknown_build_option_0_Did_you_mean_1, optionTypeMismatchDiagnostic: e2.Diagnostics.Build_option_0_requires_a_value_of_type_1 };
            function ee(Pe) {
              var Ue = K(ve, Pe), fr = Ue.options, De = Ue.watchOptions, gr = Ue.fileNames, Vr = Ue.errors, Tr = fr;
              return gr.length === 0 && gr.push("."), Tr.clean && Tr.force && Vr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "force")), Tr.clean && Tr.verbose && Vr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "verbose")), Tr.clean && Tr.watch && Vr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Options_0_and_1_cannot_be_combined, "clean", "watch")), Tr.watch && Tr.dry && Vr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Options_0_and_1_cannot_be_combined, "watch", "dry")), { buildOptions: Tr, watchOptions: De, projects: gr, errors: Vr };
            }
            e2.parseBuildCommand = ee;
            function he(Pe) {
              for (var Ue = [], fr = 1; fr < arguments.length; fr++)
                Ue[fr - 1] = arguments[fr];
              var De = e2.createCompilerDiagnostic.apply(void 0, arguments);
              return De.messageText;
            }
            e2.getDiagnosticText = he;
            function F2(Pe, Ue, fr, De, gr, Vr) {
              var Tr = A2(Pe, function(Yi) {
                return fr.readFile(Yi);
              });
              if (!e2.isString(Tr)) {
                fr.onUnRecoverableConfigFileDiagnostic(Tr);
                return;
              }
              var vi = e2.parseJsonText(Pe, Tr), Ui = fr.getCurrentDirectory();
              return vi.path = e2.toPath(Pe, Ui, e2.createGetCanonicalFileName(fr.useCaseSensitiveFileNames)), vi.resolvedPath = vi.path, vi.originalFileName = vi.fileName, er(vi, fr, e2.getNormalizedAbsolutePath(e2.getDirectoryPath(Pe), Ui), Ue, e2.getNormalizedAbsolutePath(Pe, Ui), void 0, Vr, De, gr);
            }
            e2.getParsedCommandLineOfConfigFile = F2;
            function x2(Pe, Ue) {
              var fr = A2(Pe, Ue);
              return e2.isString(fr) ? X(Pe, fr) : { config: {}, error: fr };
            }
            e2.readConfigFile = x2;
            function X(Pe, Ue) {
              var fr = e2.parseJsonText(Pe, Ue);
              return { config: fe(fr, fr.parseDiagnostics, false, void 0), error: fr.parseDiagnostics.length ? fr.parseDiagnostics[0] : void 0 };
            }
            e2.parseConfigFileTextToJson = X;
            function $(Pe, Ue) {
              var fr = A2(Pe, Ue);
              return e2.isString(fr) ? e2.parseJsonText(Pe, fr) : { fileName: Pe, parseDiagnostics: [fr] };
            }
            e2.readJsonConfigFile = $;
            function A2(Pe, Ue) {
              var fr;
              try {
                fr = Ue(Pe);
              } catch (De) {
                return e2.createCompilerDiagnostic(e2.Diagnostics.Cannot_read_file_0_Colon_1, Pe, De.message);
              }
              return fr === void 0 ? e2.createCompilerDiagnostic(e2.Diagnostics.Cannot_read_file_0, Pe) : fr;
            }
            e2.tryReadFile = A2;
            function y(Pe) {
              return e2.arrayToMap(Pe, f4);
            }
            var V = { optionDeclarations: e2.typeAcquisitionDeclarations, unknownOptionDiagnostic: e2.Diagnostics.Unknown_type_acquisition_option_0, unknownDidYouMeanDiagnostic: e2.Diagnostics.Unknown_type_acquisition_option_0_Did_you_mean_1 }, L;
            function P() {
              return L || (L = B(e2.optionsForWatch));
            }
            var k = { getOptionsNameMap: P, optionDeclarations: e2.optionsForWatch, unknownOptionDiagnostic: e2.Diagnostics.Unknown_watch_option_0, unknownDidYouMeanDiagnostic: e2.Diagnostics.Unknown_watch_option_0_Did_you_mean_1, optionTypeMismatchDiagnostic: e2.Diagnostics.Watch_option_0_requires_a_value_of_type_1 }, Y;
            function U() {
              return Y || (Y = y(e2.optionDeclarations));
            }
            var j;
            function H() {
              return j || (j = y(e2.optionsForWatch));
            }
            var I;
            function l() {
              return I || (I = y(e2.typeAcquisitionDeclarations));
            }
            var d;
            function D() {
              return d === void 0 && (d = { name: void 0, type: "object", elementOptions: y([{ name: "compilerOptions", type: "object", elementOptions: U(), extraKeyDiagnostics: e2.compilerOptionsDidYouMeanDiagnostics }, { name: "watchOptions", type: "object", elementOptions: H(), extraKeyDiagnostics: k }, { name: "typingOptions", type: "object", elementOptions: l(), extraKeyDiagnostics: V }, { name: "typeAcquisition", type: "object", elementOptions: l(), extraKeyDiagnostics: V }, { name: "extends", type: "string", category: e2.Diagnostics.File_Management }, { name: "references", type: "list", element: { name: "references", type: "object" }, category: e2.Diagnostics.Projects }, { name: "files", type: "list", element: { name: "files", type: "string" }, category: e2.Diagnostics.File_Management }, { name: "include", type: "list", element: { name: "include", type: "string" }, category: e2.Diagnostics.File_Management, defaultValueDescription: e2.Diagnostics.if_files_is_specified_otherwise_Asterisk_Asterisk_Slash_Asterisk }, { name: "exclude", type: "list", element: { name: "exclude", type: "string" }, category: e2.Diagnostics.File_Management, defaultValueDescription: e2.Diagnostics.node_modules_bower_components_jspm_packages_plus_the_value_of_outDir_if_one_is_specified }, e2.compileOnSaveCommandLineOption]) }), d;
            }
            function fe(Pe, Ue, fr, De) {
              var gr, Vr = (gr = Pe.statements[0]) === null || gr === void 0 ? void 0 : gr.expression, Tr = fr ? D() : void 0;
              if (Vr && Vr.kind !== 205) {
                if (Ue.push(e2.createDiagnosticForNodeInSourceFile(Pe, Vr, e2.Diagnostics.The_root_value_of_a_0_file_must_be_an_object, e2.getBaseFileName(Pe.fileName) === "jsconfig.json" ? "jsconfig.json" : "tsconfig.json")), e2.isArrayLiteralExpression(Vr)) {
                  var vi = e2.find(Vr.elements, e2.isObjectLiteralExpression);
                  if (vi)
                    return ne(Pe, vi, Ue, true, Tr, De);
                }
                return {};
              }
              return ne(Pe, Vr, Ue, true, Tr, De);
            }
            function g(Pe, Ue) {
              var fr;
              return ne(Pe, (fr = Pe.statements[0]) === null || fr === void 0 ? void 0 : fr.expression, Ue, true, void 0, void 0);
            }
            e2.convertToObject = g;
            function ne(Pe, Ue, fr, De, gr, Vr) {
              if (!Ue)
                return De ? {} : void 0;
              return Yi(Ue, gr);
              function Tr(ct) {
                return gr && gr.elementOptions === ct;
              }
              function vi(ct, Li, nt, Mt) {
                for (var xt = De ? {} : void 0, ut = function(Ki) {
                  if (Ki.kind !== 296)
                    return fr.push(e2.createDiagnosticForNodeInSourceFile(Pe, Ki, e2.Diagnostics.Property_assignment_expected)), "continue";
                  Ki.questionToken && fr.push(e2.createDiagnosticForNodeInSourceFile(Pe, Ki.questionToken, e2.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?")), Wi(Ki.name) || fr.push(e2.createDiagnosticForNodeInSourceFile(Pe, Ki.name, e2.Diagnostics.String_literal_with_double_quotes_expected));
                  var Fi = e2.isComputedNonLiteralName(Ki.name) ? void 0 : e2.getTextOfPropertyName(Ki.name), ui = Fi && e2.unescapeLeadingUnderscores(Fi), Bt = ui && Li ? Li.get(ui) : void 0;
                  ui && nt && !Bt && (Li ? fr.push(T(ui, nt, function(Ai, Oi, ji) {
                    return e2.createDiagnosticForNodeInSourceFile(Pe, Ki.name, Ai, Oi, ji);
                  })) : fr.push(e2.createDiagnosticForNodeInSourceFile(Pe, Ki.name, nt.unknownOptionDiagnostic, ui)));
                  var wt = Yi(Ki.initializer, Bt);
                  if (typeof ui < "u" && (De && (xt[ui] = wt), Vr && (Mt || Tr(Li)))) {
                    var na = We(Bt, wt);
                    Mt ? na && Vr.onSetValidOptionKeyValueInParent(Mt, Bt, wt) : Tr(Li) && (na ? Vr.onSetValidOptionKeyValueInRoot(ui, Ki.name, wt, Ki.initializer) : Bt || Vr.onSetUnknownOptionKeyValueInRoot(ui, Ki.name, wt, Ki.initializer));
                  }
                }, Dt = 0, Rt = ct.properties; Dt < Rt.length; Dt++) {
                  var Ii = Rt[Dt];
                  ut(Ii);
                }
                return xt;
              }
              function Ui(ct, Li) {
                if (!De) {
                  ct.forEach(function(nt) {
                    return Yi(nt, Li);
                  });
                  return;
                }
                return e2.filter(ct.map(function(nt) {
                  return Yi(nt, Li);
                }), function(nt) {
                  return nt !== void 0;
                });
              }
              function Yi(ct, Li) {
                var nt;
                switch (ct.kind) {
                  case 110:
                    return ui(Li && Li.type !== "boolean"), Fi(true);
                  case 95:
                    return ui(Li && Li.type !== "boolean"), Fi(false);
                  case 104:
                    return ui(Li && Li.name === "extends"), Fi(null);
                  case 10:
                    Wi(ct) || fr.push(e2.createDiagnosticForNodeInSourceFile(Pe, ct, e2.Diagnostics.String_literal_with_double_quotes_expected)), ui(Li && e2.isString(Li.type) && Li.type !== "string");
                    var Mt = ct.text;
                    if (Li && !e2.isString(Li.type)) {
                      var xt = Li;
                      xt.type.has(Mt.toLowerCase()) || (fr.push(m2(xt, function(Bt, wt, na) {
                        return e2.createDiagnosticForNodeInSourceFile(Pe, ct, Bt, wt, na);
                      })), nt = true);
                    }
                    return Fi(Mt);
                  case 8:
                    return ui(Li && Li.type !== "number"), Fi(Number(ct.text));
                  case 219:
                    if (ct.operator !== 40 || ct.operand.kind !== 8)
                      break;
                    return ui(Li && Li.type !== "number"), Fi(-Number(ct.operand.text));
                  case 205:
                    ui(Li && Li.type !== "object");
                    var ut = ct;
                    if (Li) {
                      var Dt = Li, Rt = Dt.elementOptions, Ii = Dt.extraKeyDiagnostics, Ki = Dt.name;
                      return Fi(vi(ut, Rt, Ii, Ki));
                    } else
                      return Fi(vi(ut, void 0, void 0, void 0));
                  case 204:
                    return ui(Li && Li.type !== "list"), Fi(Ui(ct.elements, Li && Li.element));
                }
                Li ? ui(true) : fr.push(e2.createDiagnosticForNodeInSourceFile(Pe, ct, e2.Diagnostics.Property_value_can_only_be_string_literal_numeric_literal_true_false_null_object_literal_or_array_literal));
                return;
                function Fi(Bt) {
                  var wt;
                  if (!nt) {
                    var na = (wt = Li == null ? void 0 : Li.extraValidation) === null || wt === void 0 ? void 0 : wt.call(Li, Bt);
                    if (na) {
                      fr.push(e2.createDiagnosticForNodeInSourceFile.apply(void 0, Ve([Pe, ct], na, false)));
                      return;
                    }
                  }
                  return Bt;
                }
                function ui(Bt) {
                  Bt && (fr.push(e2.createDiagnosticForNodeInSourceFile(Pe, ct, e2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, Li.name, ue(Li))), nt = true);
                }
              }
              function Wi(ct) {
                return e2.isStringLiteral(ct) && e2.isStringDoubleQuoted(ct, Pe);
              }
            }
            e2.convertToObjectWorker = ne;
            function ue(Pe) {
              return Pe.type === "list" ? "Array" : e2.isString(Pe.type) ? Pe.type : "string";
            }
            function We(Pe, Ue) {
              if (Pe) {
                if (Cr(Ue))
                  return true;
                if (Pe.type === "list")
                  return e2.isArray(Ue);
                var fr = e2.isString(Pe.type) ? Pe.type : "string";
                return typeof Ue === fr;
              }
              return false;
            }
            function Fe(Pe, Ue, fr) {
              var De, gr, Vr, Tr = e2.createGetCanonicalFileName(fr.useCaseSensitiveFileNames), vi = e2.map(e2.filter(Pe.fileNames, !((gr = (De = Pe.options.configFile) === null || De === void 0 ? void 0 : De.configFileSpecs) === null || gr === void 0) && gr.validatedIncludeSpecs ? ge(Ue, Pe.options.configFile.configFileSpecs.validatedIncludeSpecs, Pe.options.configFile.configFileSpecs.validatedExcludeSpecs, fr) : e2.returnTrue), function(ct) {
                return e2.getRelativePathFromFile(e2.getNormalizedAbsolutePath(Ue, fr.getCurrentDirectory()), e2.getNormalizedAbsolutePath(ct, fr.getCurrentDirectory()), Tr);
              }), Ui = Ee(Pe.options, { configFilePath: e2.getNormalizedAbsolutePath(Ue, fr.getCurrentDirectory()), useCaseSensitiveFileNames: fr.useCaseSensitiveFileNames }), Yi = Pe.watchOptions && He(Pe.watchOptions), Wi = Ke(Ke({ compilerOptions: Ke(Ke({}, Z2(Ui)), { showConfig: void 0, configFile: void 0, configFilePath: void 0, help: void 0, init: void 0, listFiles: void 0, listEmittedFiles: void 0, project: void 0, build: void 0, version: void 0 }), watchOptions: Yi && Z2(Yi), references: e2.map(Pe.projectReferences, function(ct) {
                return Ke(Ke({}, ct), { path: ct.originalPath ? ct.originalPath : "", originalPath: void 0 });
              }), files: e2.length(vi) ? vi : void 0 }, !((Vr = Pe.options.configFile) === null || Vr === void 0) && Vr.configFileSpecs ? { include: Be(Pe.options.configFile.configFileSpecs.validatedIncludeSpecs), exclude: Pe.options.configFile.configFileSpecs.validatedExcludeSpecs } : {}), { compileOnSave: Pe.compileOnSave ? true : void 0 });
              return Wi;
            }
            e2.convertToTSConfig = Fe;
            function Z2(Pe) {
              return Ke({}, e2.arrayFrom(Pe.entries()).reduce(function(Ue, fr) {
                var De;
                return Ke(Ke({}, Ue), (De = {}, De[fr[0]] = fr[1], De));
              }, {}));
            }
            function Be(Pe) {
              if (!!e2.length(Pe)) {
                if (e2.length(Pe) !== 1)
                  return Pe;
                if (Pe[0] !== "**/*")
                  return Pe;
              }
            }
            function ge(Pe, Ue, fr, De) {
              if (!Ue)
                return e2.returnTrue;
              var gr = e2.getFileMatcherPatterns(Pe, fr, Ue, De.useCaseSensitiveFileNames, De.getCurrentDirectory()), Vr = gr.excludePattern && e2.getRegexFromPattern(gr.excludePattern, De.useCaseSensitiveFileNames), Tr = gr.includeFilePattern && e2.getRegexFromPattern(gr.includeFilePattern, De.useCaseSensitiveFileNames);
              return Tr ? Vr ? function(vi) {
                return !(Tr.test(vi) && !Vr.test(vi));
              } : function(vi) {
                return !Tr.test(vi);
              } : Vr ? function(vi) {
                return Vr.test(vi);
              } : e2.returnTrue;
            }
            function Re(Pe) {
              if (!(Pe.type === "string" || Pe.type === "number" || Pe.type === "boolean" || Pe.type === "object"))
                return Pe.type === "list" ? Re(Pe.element) : Pe.type;
            }
            function ze(Pe, Ue) {
              return e2.forEachEntry(Ue, function(fr, De) {
                if (fr === Pe)
                  return De;
              });
            }
            function Ee(Pe, Ue) {
              return rr(Pe, Q(), Ue);
            }
            function He(Pe) {
              return rr(Pe, P());
            }
            function rr(Pe, Ue, fr) {
              var De = Ue.optionsNameMap, gr = new e2.Map(), Vr = fr && e2.createGetCanonicalFileName(fr.useCaseSensitiveFileNames), Tr = function(Ui) {
                if (e2.hasProperty(Pe, Ui)) {
                  if (De.has(Ui) && (De.get(Ui).category === e2.Diagnostics.Command_line_Options || De.get(Ui).category === e2.Diagnostics.Output_Formatting))
                    return "continue";
                  var Yi = Pe[Ui], Wi = De.get(Ui.toLowerCase());
                  if (Wi) {
                    var ct = Re(Wi);
                    ct ? Wi.type === "list" ? gr.set(Ui, Yi.map(function(Li) {
                      return ze(Li, ct);
                    })) : gr.set(Ui, ze(Yi, ct)) : fr && Wi.isFilePath ? gr.set(Ui, e2.getRelativePathFromFile(fr.configFilePath, e2.getNormalizedAbsolutePath(Yi, e2.getDirectoryPath(fr.configFilePath)), Vr)) : gr.set(Ui, Yi);
                  }
                }
              };
              for (var vi in Pe)
                Tr(vi);
              return gr;
            }
            function Ie(Pe, Ue) {
              var fr = _e(Pe);
              return gr();
              function De(Vr) {
                return Array(Vr + 1).join(" ");
              }
              function gr() {
                var Vr = [], Tr = De(2);
                return w.forEach(function(vi) {
                  if (!!fr.has(vi.name)) {
                    var Ui = fr.get(vi.name), Yi = Mr(vi);
                    Ui !== Yi ? Vr.push("".concat(Tr).concat(vi.name, ": ").concat(Ui)) : e2.hasProperty(e2.defaultInitCompilerOptions, vi.name) && Vr.push("".concat(Tr).concat(vi.name, ": ").concat(Yi));
                  }
                }), Vr.join(Ue) + Ue;
              }
            }
            e2.getCompilerOptionsDiffValue = Ie;
            function _e(Pe) {
              var Ue = e2.extend(Pe, e2.defaultInitCompilerOptions);
              return Ee(Ue);
            }
            function we(Pe, Ue, fr) {
              var De = _e(Pe);
              return Tr();
              function gr(vi) {
                return Array(vi + 1).join(" ");
              }
              function Vr(vi) {
                var Ui = vi.category, Yi = vi.name, Wi = vi.isCommandLineOnly, ct = [e2.Diagnostics.Command_line_Options, e2.Diagnostics.Editor_Support, e2.Diagnostics.Compiler_Diagnostics, e2.Diagnostics.Backwards_Compatibility, e2.Diagnostics.Watch_and_Build_Modes, e2.Diagnostics.Output_Formatting];
                return !Wi && Ui !== void 0 && (!ct.includes(Ui) || De.has(Yi));
              }
              function Tr() {
                for (var vi = e2.createMultiMap(), Ui = 0, Yi = e2.optionDeclarations; Ui < Yi.length; Ui++) {
                  var Wi = Yi[Ui], ct = Wi.category;
                  Vr(Wi) && vi.add(e2.getLocaleSpecificMessage(ct), Wi);
                }
                var Li = 0, nt = 0, Mt = [];
                vi.forEach(function(wt, na) {
                  Mt.length !== 0 && Mt.push({ value: "" }), Mt.push({ value: "/* ".concat(na, " */") });
                  for (var Ai = 0, Oi = wt; Ai < Oi.length; Ai++) {
                    var ji = Oi[Ai], Vi = void 0;
                    De.has(ji.name) ? Vi = '"'.concat(ji.name, '": ').concat(JSON.stringify(De.get(ji.name))).concat((nt += 1) === De.size ? "" : ",") : Vi = '// "'.concat(ji.name, '": ').concat(JSON.stringify(Mr(ji)), ","), Mt.push({ value: Vi, description: "/* ".concat(ji.description && e2.getLocaleSpecificMessage(ji.description) || ji.name, " */") }), Li = Math.max(Vi.length, Li);
                  }
                });
                var xt = gr(2), ut = [];
                ut.push("{"), ut.push("".concat(xt, '"compilerOptions": {')), ut.push("".concat(xt).concat(xt, "/* ").concat(e2.getLocaleSpecificMessage(e2.Diagnostics.Visit_https_Colon_Slash_Slashaka_ms_Slashtsconfig_to_read_more_about_this_file), " */")), ut.push("");
                for (var Dt = 0, Rt = Mt; Dt < Rt.length; Dt++) {
                  var Ii = Rt[Dt], Ki = Ii.value, Fi = Ii.description, ui = Fi === void 0 ? "" : Fi;
                  ut.push(Ki && "".concat(xt).concat(xt).concat(Ki).concat(ui && gr(Li - Ki.length + 2) + ui));
                }
                if (Ue.length) {
                  ut.push("".concat(xt, "},")), ut.push("".concat(xt, '"files": ['));
                  for (var Bt = 0; Bt < Ue.length; Bt++)
                    ut.push("".concat(xt).concat(xt).concat(JSON.stringify(Ue[Bt])).concat(Bt === Ue.length - 1 ? "" : ","));
                  ut.push("".concat(xt, "]"));
                } else
                  ut.push("".concat(xt, "}"));
                return ut.push("}"), ut.join(fr) + fr;
              }
            }
            e2.generateTSConfig = we;
            function de(Pe, Ue) {
              var fr = {}, De = Q().optionsNameMap;
              for (var gr in Pe)
                e2.hasProperty(Pe, gr) && (fr[gr] = ye(De.get(gr.toLowerCase()), Pe[gr], Ue));
              return fr.configFilePath && (fr.configFilePath = Ue(fr.configFilePath)), fr;
            }
            e2.convertToOptionsWithAbsolutePaths = de;
            function ye(Pe, Ue, fr) {
              if (Pe && !Cr(Ue)) {
                if (Pe.type === "list") {
                  var De = Ue;
                  if (Pe.element.isFilePath && De.length)
                    return De.map(fr);
                } else if (Pe.isFilePath)
                  return fr(Ue);
              }
              return Ue;
            }
            function Ae(Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui) {
              return Br(Pe, void 0, Ue, fr, De, Ui, gr, Vr, Tr, vi);
            }
            e2.parseJsonConfigFileContent = Ae;
            function er(Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui) {
              e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("parse", "parseJsonSourceFileConfigFileContent", { path: Pe.fileName });
              var Yi = Br(void 0, Pe, Ue, fr, De, Ui, gr, Vr, Tr, vi);
              return e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), Yi;
            }
            e2.parseJsonSourceFileConfigFileContent = er;
            function ir(Pe, Ue) {
              Ue && Object.defineProperty(Pe, "configFile", { enumerable: false, writable: false, value: Ue });
            }
            e2.setConfigFileInOptions = ir;
            function Cr(Pe) {
              return Pe == null;
            }
            function Ye(Pe, Ue) {
              return e2.getDirectoryPath(e2.getNormalizedAbsolutePath(Pe, Ue));
            }
            function Br(Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui, Yi) {
              gr === void 0 && (gr = {}), vi === void 0 && (vi = []), Ui === void 0 && (Ui = []), e2.Debug.assert(Pe === void 0 && Ue !== void 0 || Pe !== void 0 && Ue === void 0);
              var Wi = [], ct = ur(Pe, Ue, fr, De, Tr, vi, Wi, Yi), Li = ct.raw, nt = e2.extend(gr, ct.options || {}), Mt = Vr && ct.watchOptions ? e2.extend(Vr, ct.watchOptions) : ct.watchOptions || Vr;
              nt.configFilePath = Tr && e2.normalizeSlashes(Tr);
              var xt = Dt();
              Ue && (Ue.configFileSpecs = xt), ir(nt, Ue);
              var ut = e2.normalizePath(Tr ? Ye(Tr, De) : De);
              return { options: nt, watchOptions: Mt, fileNames: Rt(ut), projectReferences: Ii(ut), typeAcquisition: ct.typeAcquisition || si(), raw: Li, errors: Wi, wildcardDirectories: xe(xt, ut, fr.useCaseSensitiveFileNames), compileOnSave: !!Li.compileOnSave };
              function Dt() {
                var wt = ui("references", function(pn) {
                  return typeof pn == "object";
                }, "object"), na = Ki(Fi("files"));
                if (na) {
                  var Ai = wt === "no-prop" || e2.isArray(wt) && wt.length === 0, Oi = e2.hasProperty(Li, "extends");
                  if (na.length === 0 && Ai && !Oi)
                    if (Ue) {
                      var ji = Tr || "tsconfig.json", Vi = e2.Diagnostics.The_files_list_in_config_file_0_is_empty, at = e2.firstDefined(e2.getTsConfigPropArray(Ue, "files"), function(pn) {
                        return pn.initializer;
                      }), At = at ? e2.createDiagnosticForNodeInSourceFile(Ue, at, Vi, ji) : e2.createCompilerDiagnostic(Vi, ji);
                      Wi.push(At);
                    } else
                      Bt(e2.Diagnostics.The_files_list_in_config_file_0_is_empty, Tr || "tsconfig.json");
                }
                var ba = Ki(Fi("include")), $a = Fi("exclude"), Qa = Ki($a);
                if ($a === "no-prop" && Li.compilerOptions) {
                  var ai = Li.compilerOptions.outDir, Dn = Li.compilerOptions.declarationDir;
                  (ai || Dn) && (Qa = [ai, Dn].filter(function(pn) {
                    return !!pn;
                  }));
                }
                na === void 0 && ba === void 0 && (ba = ["**/*"]);
                var ka, Ba;
                return ba && (ka = Wr(ba, Wi, true, Ue, "include")), Qa && (Ba = Wr(Qa, Wi, false, Ue, "exclude")), { filesSpecs: na, includeSpecs: ba, excludeSpecs: Qa, validatedFilesSpec: e2.filter(na, e2.isString), validatedIncludeSpecs: ka, validatedExcludeSpecs: Ba, pathPatterns: void 0 };
              }
              function Rt(wt) {
                var na = Jr(xt, wt, nt, fr, Ui);
                return n(na, lr(Li), vi) && Wi.push(Ne(xt, Tr)), na;
              }
              function Ii(wt) {
                var na, Ai = ui("references", function(at) {
                  return typeof at == "object";
                }, "object");
                if (e2.isArray(Ai))
                  for (var Oi = 0, ji = Ai; Oi < ji.length; Oi++) {
                    var Vi = ji[Oi];
                    typeof Vi.path != "string" ? Bt(e2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "reference.path", "string") : (na || (na = [])).push({ path: e2.getNormalizedAbsolutePath(Vi.path, wt), originalPath: Vi.path, prepend: Vi.prepend, circular: Vi.circular });
                  }
                return na;
              }
              function Ki(wt) {
                return e2.isArray(wt) ? wt : void 0;
              }
              function Fi(wt) {
                return ui(wt, e2.isString, "string");
              }
              function ui(wt, na, Ai) {
                if (e2.hasProperty(Li, wt) && !Cr(Li[wt]))
                  if (e2.isArray(Li[wt])) {
                    var Oi = Li[wt];
                    return !Ue && !e2.every(Oi, na) && Wi.push(e2.createCompilerDiagnostic(e2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, wt, Ai)), Oi;
                  } else
                    return Bt(e2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, wt, "Array"), "not-array";
                return "no-prop";
              }
              function Bt(wt, na, Ai) {
                Ue || Wi.push(e2.createCompilerDiagnostic(wt, na, Ai));
              }
            }
            function Er(Pe) {
              return Pe.code === e2.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2.code;
            }
            function Ne(Pe, Ue) {
              var fr = Pe.includeSpecs, De = Pe.excludeSpecs;
              return e2.createCompilerDiagnostic(e2.Diagnostics.No_inputs_were_found_in_config_file_0_Specified_include_paths_were_1_and_exclude_paths_were_2, Ue || "tsconfig.json", JSON.stringify(fr || []), JSON.stringify(De || []));
            }
            function n(Pe, Ue, fr) {
              return Pe.length === 0 && Ue && (!fr || fr.length === 0);
            }
            function lr(Pe) {
              return !e2.hasProperty(Pe, "files") && !e2.hasProperty(Pe, "references");
            }
            e2.canJsonReportNoInputFiles = lr;
            function be(Pe, Ue, fr, De, gr) {
              var Vr = De.length;
              return n(Pe, gr) ? De.push(Ne(fr, Ue)) : e2.filterMutate(De, function(Tr) {
                return !Er(Tr);
              }), Vr !== De.length;
            }
            e2.updateErrorForNoInputFiles = be;
            function Ge(Pe) {
              return !!Pe.options;
            }
            function ur(Pe, Ue, fr, De, gr, Vr, Tr, vi) {
              var Ui;
              De = e2.normalizeSlashes(De);
              var Yi = e2.getNormalizedAbsolutePath(gr || "", De);
              if (Vr.indexOf(Yi) >= 0)
                return Tr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Circularity_detected_while_resolving_configuration_Colon_0, Ve(Ve([], Vr, true), [Yi], false).join(" -> "))), { raw: Pe || g(Ue, Tr) };
              var Wi = Pe ? yr(Pe, fr, De, gr, Tr) : Ir(Ue, fr, De, gr, Tr);
              if (!((Ui = Wi.options) === null || Ui === void 0) && Ui.paths && (Wi.options.pathsBasePath = De), Wi.extendedConfigPath) {
                Vr = Vr.concat([Yi]);
                var ct = Ur(Ue, Wi.extendedConfigPath, fr, Vr, Tr, vi);
                if (ct && Ge(ct)) {
                  var Li = ct.raw, nt = Wi.raw, Mt, xt = function(ut) {
                    !nt[ut] && Li[ut] && (nt[ut] = e2.map(Li[ut], function(Dt) {
                      return e2.isRootedDiskPath(Dt) ? Dt : e2.combinePaths(Mt || (Mt = e2.convertToRelativePath(e2.getDirectoryPath(Wi.extendedConfigPath), De, e2.createGetCanonicalFileName(fr.useCaseSensitiveFileNames))), Dt);
                    }));
                  };
                  xt("include"), xt("exclude"), xt("files"), nt.compileOnSave === void 0 && (nt.compileOnSave = Li.compileOnSave), Wi.options = e2.assign({}, ct.options, Wi.options), Wi.watchOptions = Wi.watchOptions && ct.watchOptions ? e2.assign({}, ct.watchOptions, Wi.watchOptions) : Wi.watchOptions || ct.watchOptions;
                }
              }
              return Wi;
            }
            function yr(Pe, Ue, fr, De, gr) {
              e2.hasProperty(Pe, "excludes") && gr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude));
              var Vr = qr(Pe.compilerOptions, fr, gr, De), Tr = Di(Pe.typeAcquisition || Pe.typingOptions, fr, gr, De), vi = wi(Pe.watchOptions, fr, gr);
              Pe.compileOnSave = ii(Pe, fr, gr);
              var Ui;
              if (Pe.extends)
                if (!e2.isString(Pe.extends))
                  gr.push(e2.createCompilerDiagnostic(e2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, "extends", "string"));
                else {
                  var Yi = De ? Ye(De, fr) : fr;
                  Ui = wr(Pe.extends, Ue, Yi, gr, e2.createCompilerDiagnostic);
                }
              return { raw: Pe, options: Vr, watchOptions: vi, typeAcquisition: Tr, extendedConfigPath: Ui };
            }
            function Ir(Pe, Ue, fr, De, gr) {
              var Vr = or(De), Tr, vi, Ui, Yi, Wi, ct = { onSetValidOptionKeyValueInParent: function(nt, Mt, xt) {
                var ut;
                switch (nt) {
                  case "compilerOptions":
                    ut = Vr;
                    break;
                  case "watchOptions":
                    ut = Ui || (Ui = {});
                    break;
                  case "typeAcquisition":
                    ut = Tr || (Tr = si(De));
                    break;
                  case "typingOptions":
                    ut = vi || (vi = si(De));
                    break;
                  default:
                    e2.Debug.fail("Unknown option");
                }
                ut[Mt.name] = Gi(Mt, fr, xt);
              }, onSetValidOptionKeyValueInRoot: function(nt, Mt, xt, ut) {
                switch (nt) {
                  case "extends":
                    var Dt = De ? Ye(De, fr) : fr;
                    Yi = wr(xt, Ue, Dt, gr, function(Rt, Ii) {
                      return e2.createDiagnosticForNodeInSourceFile(Pe, ut, Rt, Ii);
                    });
                    return;
                }
              }, onSetUnknownOptionKeyValueInRoot: function(nt, Mt, xt, ut) {
                nt === "excludes" && gr.push(e2.createDiagnosticForNodeInSourceFile(Pe, Mt, e2.Diagnostics.Unknown_option_excludes_Did_you_mean_exclude)), e2.find(w, function(Dt) {
                  return Dt.name === nt;
                }) && (Wi = e2.append(Wi, Mt));
              } }, Li = fe(Pe, gr, true, ct);
              return Tr || (vi ? Tr = vi.enableAutoDiscovery !== void 0 ? { enable: vi.enableAutoDiscovery, include: vi.include, exclude: vi.exclude } : vi : Tr = si(De)), Wi && Li && Li.compilerOptions === void 0 && gr.push(e2.createDiagnosticForNodeInSourceFile(Pe, Wi[0], e2.Diagnostics._0_should_be_set_inside_the_compilerOptions_object_of_the_config_json_file, e2.getTextOfPropertyName(Wi[0]))), { raw: Li, options: Vr, watchOptions: Ui, typeAcquisition: Tr, extendedConfigPath: Yi };
            }
            function wr(Pe, Ue, fr, De, gr) {
              if (Pe = e2.normalizeSlashes(Pe), e2.isRootedDiskPath(Pe) || e2.startsWith(Pe, "./") || e2.startsWith(Pe, "../")) {
                var Vr = e2.getNormalizedAbsolutePath(Pe, fr);
                if (!Ue.fileExists(Vr) && !e2.endsWith(Vr, ".json") && (Vr = "".concat(Vr, ".json"), !Ue.fileExists(Vr))) {
                  De.push(gr(e2.Diagnostics.File_0_not_found, Pe));
                  return;
                }
                return Vr;
              }
              var Tr = e2.nodeModuleNameResolver(Pe, e2.combinePaths(fr, "tsconfig.json"), { moduleResolution: e2.ModuleResolutionKind.NodeJs }, Ue, void 0, void 0, true);
              if (Tr.resolvedModule)
                return Tr.resolvedModule.resolvedFileName;
              De.push(gr(e2.Diagnostics.File_0_not_found, Pe));
            }
            function Ur(Pe, Ue, fr, De, gr, Vr) {
              var Tr, vi = fr.useCaseSensitiveFileNames ? Ue : e2.toFileNameLowerCase(Ue), Ui, Yi, Wi;
              if (Vr && (Ui = Vr.get(vi)) ? (Yi = Ui.extendedResult, Wi = Ui.extendedConfig) : (Yi = $(Ue, function(ct) {
                return fr.readFile(ct);
              }), Yi.parseDiagnostics.length || (Wi = ur(void 0, Yi, fr, e2.getDirectoryPath(Ue), e2.getBaseFileName(Ue), De, gr, Vr)), Vr && Vr.set(vi, { extendedResult: Yi, extendedConfig: Wi })), Pe && (Pe.extendedSourceFiles = [Yi.fileName], Yi.extendedSourceFiles && (Tr = Pe.extendedSourceFiles).push.apply(Tr, Yi.extendedSourceFiles)), Yi.parseDiagnostics.length) {
                gr.push.apply(gr, Yi.parseDiagnostics);
                return;
              }
              return Wi;
            }
            function ii(Pe, Ue, fr) {
              if (!e2.hasProperty(Pe, e2.compileOnSaveCommandLineOption.name))
                return false;
              var De = et(e2.compileOnSaveCommandLineOption, Pe.compileOnSave, Ue, fr);
              return typeof De == "boolean" && De;
            }
            function mi(Pe, Ue, fr) {
              var De = [], gr = qr(Pe, Ue, De, fr);
              return { options: gr, errors: De };
            }
            e2.convertCompilerOptionsFromJson = mi;
            function pe(Pe, Ue, fr) {
              var De = [], gr = Di(Pe, Ue, De, fr);
              return { options: gr, errors: De };
            }
            e2.convertTypeAcquisitionFromJson = pe;
            function or(Pe) {
              var Ue = Pe && e2.getBaseFileName(Pe) === "jsconfig.json" ? { allowJs: true, maxNodeModuleJsDepth: 2, allowSyntheticDefaultImports: true, skipLibCheck: true, noEmit: true } : {};
              return Ue;
            }
            function qr(Pe, Ue, fr, De) {
              var gr = or(De);
              return Xi(U(), Pe, Ue, gr, e2.compilerOptionsDidYouMeanDiagnostics, fr), De && (gr.configFilePath = e2.normalizeSlashes(De)), gr;
            }
            function si(Pe) {
              return { enable: !!Pe && e2.getBaseFileName(Pe) === "jsconfig.json", include: [], exclude: [] };
            }
            function Di(Pe, Ue, fr, De) {
              var gr = si(De), Vr = N(Pe);
              return Xi(l(), Vr, Ue, gr, V, fr), gr;
            }
            function wi(Pe, Ue, fr) {
              return Xi(H(), Pe, Ue, void 0, k, fr);
            }
            function Xi(Pe, Ue, fr, De, gr, Vr) {
              if (!!Ue) {
                for (var Tr in Ue) {
                  var vi = Pe.get(Tr);
                  vi ? (De || (De = {}))[vi.name] = et(vi, Ue[Tr], fr, Vr) : Vr.push(T(Tr, gr, e2.createCompilerDiagnostic));
                }
                return De;
              }
            }
            function et(Pe, Ue, fr, De) {
              if (We(Pe, Ue)) {
                var gr = Pe.type;
                if (gr === "list" && e2.isArray(Ue))
                  return pi(Pe, Ue, fr, De);
                if (!e2.isString(gr))
                  return _r(Pe, Ue, De);
                var Vr = Zt(Pe, Ue, De);
                return Cr(Vr) ? Vr : Wt(Pe, fr, Vr);
              } else
                De.push(e2.createCompilerDiagnostic(e2.Diagnostics.Compiler_option_0_requires_a_value_of_type_1, Pe.name, ue(Pe)));
            }
            e2.convertJsonOption = et;
            function Gi(Pe, Ue, fr) {
              if (!Cr(fr)) {
                if (Pe.type === "list") {
                  var De = Pe;
                  return De.element.isFilePath || !e2.isString(De.element.type) ? e2.filter(e2.map(fr, function(gr) {
                    return Gi(De.element, Ue, gr);
                  }), function(gr) {
                    return De.listPreserveFalsyValues ? true : !!gr;
                  }) : fr;
                } else if (!e2.isString(Pe.type))
                  return Pe.type.get(e2.isString(fr) ? fr.toLowerCase() : fr);
                return Wt(Pe, Ue, fr);
              }
            }
            function Wt(Pe, Ue, fr) {
              return Pe.isFilePath && (fr = e2.getNormalizedAbsolutePath(fr, Ue), fr === "" && (fr = ".")), fr;
            }
            function Zt(Pe, Ue, fr) {
              var De;
              if (!Cr(Ue)) {
                var gr = (De = Pe.extraValidation) === null || De === void 0 ? void 0 : De.call(Pe, Ue);
                if (!gr)
                  return Ue;
                fr.push(e2.createCompilerDiagnostic.apply(void 0, gr));
              }
            }
            function _r(Pe, Ue, fr) {
              if (!Cr(Ue)) {
                var De = Ue.toLowerCase(), gr = Pe.type.get(De);
                if (gr !== void 0)
                  return Zt(Pe, gr, fr);
                fr.push(p(Pe));
              }
            }
            function pi(Pe, Ue, fr, De) {
              return e2.filter(e2.map(Ue, function(gr) {
                return et(Pe.element, gr, fr, De);
              }), function(gr) {
                return Pe.listPreserveFalsyValues ? true : !!gr;
              });
            }
            var ae = /(^|\/)\*\*\/?$/, Xe = /^[^*?]*(?=\/[^/]*[*?])/;
            function Jr(Pe, Ue, fr, De, gr) {
              gr === void 0 && (gr = e2.emptyArray), Ue = e2.normalizePath(Ue);
              var Vr = e2.createGetCanonicalFileName(De.useCaseSensitiveFileNames), Tr = new e2.Map(), vi = new e2.Map(), Ui = new e2.Map(), Yi = Pe.validatedFilesSpec, Wi = Pe.validatedIncludeSpecs, ct = Pe.validatedExcludeSpecs, Li = e2.getSupportedExtensions(fr, gr), nt = e2.getSupportedExtensionsWithJsonIfResolveJsonModule(fr, Li);
              if (Yi)
                for (var Mt = 0, xt = Yi; Mt < xt.length; Mt++) {
                  var ut = xt[Mt], Dt = e2.getNormalizedAbsolutePath(ut, Ue);
                  Tr.set(Vr(Dt), Dt);
                }
              var Rt;
              if (Wi && Wi.length > 0)
                for (var Ii = function(wt) {
                  if (e2.fileExtensionIs(wt, ".json")) {
                    if (!Rt) {
                      var na = Wi.filter(function(at) {
                        return e2.endsWith(at, ".json");
                      }), Ai = e2.map(e2.getRegularExpressionsForWildcards(na, Ue, "files"), function(at) {
                        return "^".concat(at, "$");
                      });
                      Rt = Ai ? Ai.map(function(at) {
                        return e2.getRegexFromPattern(at, De.useCaseSensitiveFileNames);
                      }) : e2.emptyArray;
                    }
                    var Oi = e2.findIndex(Rt, function(at) {
                      return at.test(wt);
                    });
                    if (Oi !== -1) {
                      var ji = Vr(wt);
                      !Tr.has(ji) && !Ui.has(ji) && Ui.set(ji, wt);
                    }
                    return "continue";
                  }
                  if (mr(wt, Tr, vi, Li, Vr))
                    return "continue";
                  Ar(wt, vi, Li, Vr);
                  var Vi = Vr(wt);
                  !Tr.has(Vi) && !vi.has(Vi) && vi.set(Vi, wt);
                }, Ki = 0, Fi = De.readDirectory(Ue, e2.flatten(nt), ct, Wi, void 0); Ki < Fi.length; Ki++) {
                  var Dt = Fi[Ki];
                  Ii(Dt);
                }
              var ui = e2.arrayFrom(Tr.values()), Bt = e2.arrayFrom(vi.values());
              return ui.concat(Bt, e2.arrayFrom(Ui.values()));
            }
            e2.getFileNamesFromConfigSpecs = Jr;
            function ti(Pe, Ue, fr, De, gr) {
              var Vr = Ue.validatedFilesSpec, Tr = Ue.validatedIncludeSpecs, vi = Ue.validatedExcludeSpecs;
              if (!e2.length(Tr) || !e2.length(vi))
                return false;
              fr = e2.normalizePath(fr);
              var Ui = e2.createGetCanonicalFileName(De);
              if (Vr)
                for (var Yi = 0, Wi = Vr; Yi < Wi.length; Yi++) {
                  var ct = Wi[Yi];
                  if (Ui(e2.getNormalizedAbsolutePath(ct, fr)) === Pe)
                    return false;
                }
              return zr(Pe, vi, De, gr, fr);
            }
            e2.isExcludedFile = ti;
            function Ze(Pe) {
              var Ue = e2.startsWith(Pe, "**/") ? 0 : Pe.indexOf("/**/");
              if (Ue === -1)
                return false;
              var fr = e2.endsWith(Pe, "/..") ? Pe.length : Pe.lastIndexOf("/../");
              return fr > Ue;
            }
            function Sr(Pe, Ue, fr, De) {
              return zr(Pe, e2.filter(Ue, function(gr) {
                return !Ze(gr);
              }), fr, De);
            }
            e2.matchesExclude = Sr;
            function zr(Pe, Ue, fr, De, gr) {
              var Vr = e2.getRegularExpressionForWildcard(Ue, e2.combinePaths(e2.normalizePath(De), gr), "exclude"), Tr = Vr && e2.getRegexFromPattern(Vr, fr);
              return Tr ? Tr.test(Pe) ? true : !e2.hasExtension(Pe) && Tr.test(e2.ensureTrailingDirectorySeparator(Pe)) : false;
            }
            function Wr(Pe, Ue, fr, De, gr) {
              return Pe.filter(function(Tr) {
                if (!e2.isString(Tr))
                  return false;
                var vi = Je(Tr, fr);
                return vi !== void 0 && Ue.push(Vr.apply(void 0, vi)), vi === void 0;
              });
              function Vr(Tr, vi) {
                var Ui = e2.getTsConfigPropArrayElementValue(De, gr, vi);
                return Ui ? e2.createDiagnosticForNodeInSourceFile(De, Ui, Tr, vi) : e2.createCompilerDiagnostic(Tr, vi);
              }
            }
            function Je(Pe, Ue) {
              if (Ue && ae.test(Pe))
                return [e2.Diagnostics.File_specification_cannot_end_in_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, Pe];
              if (Ze(Pe))
                return [e2.Diagnostics.File_specification_cannot_contain_a_parent_directory_that_appears_after_a_recursive_directory_wildcard_Asterisk_Asterisk_Colon_0, Pe];
            }
            function xe(Pe, Ue, fr) {
              var De = Pe.validatedIncludeSpecs, gr = Pe.validatedExcludeSpecs, Vr = e2.getRegularExpressionForWildcard(gr, Ue, "exclude"), Tr = Vr && new RegExp(Vr, fr ? "" : "i"), vi = {};
              if (De !== void 0) {
                for (var Ui = [], Yi = 0, Wi = De; Yi < Wi.length; Yi++) {
                  var ct = Wi[Yi], Li = e2.normalizePath(e2.combinePaths(Ue, ct));
                  if (!(Tr && Tr.test(Li))) {
                    var nt = vr(Li, fr);
                    if (nt) {
                      var Mt = nt.key, xt = nt.flags, ut = vi[Mt];
                      (ut === void 0 || ut < xt) && (vi[Mt] = xt, xt === 1 && Ui.push(Mt));
                    }
                  }
                }
                for (var Mt in vi)
                  if (e2.hasProperty(vi, Mt))
                    for (var Dt = 0, Rt = Ui; Dt < Rt.length; Dt++) {
                      var Ii = Rt[Dt];
                      Mt !== Ii && e2.containsPath(Ii, Mt, Ue, !fr) && delete vi[Mt];
                    }
              }
              return vi;
            }
            function vr(Pe, Ue) {
              var fr = Xe.exec(Pe);
              if (fr) {
                var De = Pe.indexOf("?"), gr = Pe.indexOf("*"), Vr = Pe.lastIndexOf(e2.directorySeparator);
                return { key: Ue ? fr[0] : e2.toFileNameLowerCase(fr[0]), flags: De !== -1 && De < Vr || gr !== -1 && gr < Vr ? 1 : 0 };
              }
              if (e2.isImplicitGlob(Pe.substring(Pe.lastIndexOf(e2.directorySeparator) + 1)))
                return { key: Ue ? Pe : e2.toFileNameLowerCase(Pe), flags: 1 };
            }
            function mr(Pe, Ue, fr, De, gr) {
              var Vr = e2.forEach(De, function(Wi) {
                return e2.fileExtensionIsOneOf(Pe, Wi) ? Wi : void 0;
              });
              if (!Vr)
                return false;
              for (var Tr = 0, vi = Vr; Tr < vi.length; Tr++) {
                var Ui = vi[Tr];
                if (e2.fileExtensionIs(Pe, Ui))
                  return false;
                var Yi = gr(e2.changeExtension(Pe, Ui));
                if (Ue.has(Yi) || fr.has(Yi)) {
                  if (Ui === ".d.ts" && (e2.fileExtensionIs(Pe, ".js") || e2.fileExtensionIs(Pe, ".jsx")))
                    continue;
                  return true;
                }
              }
              return false;
            }
            function Ar(Pe, Ue, fr, De) {
              var gr = e2.forEach(fr, function(Ui) {
                return e2.fileExtensionIsOneOf(Pe, Ui) ? Ui : void 0;
              });
              if (!!gr)
                for (var Vr = gr.length - 1; Vr >= 0; Vr--) {
                  var Tr = gr[Vr];
                  if (e2.fileExtensionIs(Pe, Tr))
                    return;
                  var vi = De(e2.changeExtension(Pe, Tr));
                  Ue.delete(vi);
                }
            }
            function Oe(Pe) {
              var Ue = {};
              for (var fr in Pe)
                if (Pe.hasOwnProperty(fr)) {
                  var De = J(fr);
                  De !== void 0 && (Ue[fr] = nr(Pe[fr], De));
                }
              return Ue;
            }
            e2.convertCompilerOptionsForTelemetry = Oe;
            function nr(Pe, Ue) {
              switch (Ue.type) {
                case "object":
                  return "";
                case "string":
                  return "";
                case "number":
                  return typeof Pe == "number" ? Pe : "";
                case "boolean":
                  return typeof Pe == "boolean" ? Pe : "";
                case "list":
                  var fr = Ue.element;
                  return e2.isArray(Pe) ? Pe.map(function(De) {
                    return nr(De, fr);
                  }) : "";
                default:
                  return e2.forEachEntry(Ue.type, function(De, gr) {
                    if (De === Pe)
                      return gr;
                  });
              }
            }
            function Mr(Pe) {
              switch (Pe.type) {
                case "number":
                  return 1;
                case "boolean":
                  return true;
                case "string":
                  var Ue = Pe.defaultValueDescription;
                  return Pe.isFilePath ? "./".concat(Ue && typeof Ue == "string" ? Ue : "") : "";
                case "list":
                  return [];
                case "object":
                  return {};
                default:
                  var fr = Pe.type.keys().next();
                  return fr.done ? e2.Debug.fail("Expected 'option.type' to have entries.") : fr.value;
              }
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(Ze) {
              Ze.trace(e2.formatMessage.apply(void 0, arguments));
            }
            e2.trace = a;
            function C(Ze, Sr) {
              return !!Ze.traceResolution && Sr.trace !== void 0;
            }
            e2.isTraceEnabled = C;
            function w(Ze, Sr) {
              var zr;
              if (Sr && Ze) {
                var Wr = Ze.packageJsonContent;
                typeof Wr.name == "string" && typeof Wr.version == "string" && (zr = { name: Wr.name, subModuleName: Sr.path.slice(Ze.packageDirectory.length + e2.directorySeparator.length), version: Wr.version });
              }
              return Sr && { path: Sr.path, extension: Sr.ext, packageId: zr };
            }
            function B(Ze) {
              return w(void 0, Ze);
            }
            function E(Ze) {
              if (Ze)
                return e2.Debug.assert(Ze.packageId === void 0), { path: Ze.path, ext: Ze.extension };
            }
            var Q;
            (function(Ze) {
              Ze[Ze.TypeScript = 0] = "TypeScript", Ze[Ze.JavaScript = 1] = "JavaScript", Ze[Ze.Json = 2] = "Json", Ze[Ze.TSConfig = 3] = "TSConfig", Ze[Ze.DtsOnly = 4] = "DtsOnly", Ze[Ze.TsOnly = 5] = "TsOnly";
            })(Q || (Q = {}));
            function le(Ze) {
              if (!!Ze)
                return e2.Debug.assert(e2.extensionIsTS(Ze.extension)), { fileName: Ze.path, packageId: Ze.packageId };
            }
            function N(Ze, Sr, zr, Wr, Je) {
              var xe;
              return Je ? ((xe = Je.failedLookupLocations).push.apply(xe, zr), Je) : { resolvedModule: Ze && { resolvedFileName: Ze.path, originalPath: Ze.originalPath === true ? void 0 : Ze.originalPath, extension: Ze.extension, isExternalLibraryImport: Sr, packageId: Ze.packageId }, failedLookupLocations: zr, resolutionDiagnostics: Wr };
            }
            function p(Ze, Sr, zr, Wr) {
              if (!e2.hasProperty(Ze, Sr)) {
                Wr.traceEnabled && a(Wr.host, e2.Diagnostics.package_json_does_not_have_a_0_field, Sr);
                return;
              }
              var Je = Ze[Sr];
              if (typeof Je !== zr || Je === null) {
                Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, Sr, zr, Je === null ? "null" : typeof Je);
                return;
              }
              return Je;
            }
            function m2(Ze, Sr, zr, Wr) {
              var Je = p(Ze, Sr, "string", Wr);
              if (Je !== void 0) {
                if (!Je) {
                  Wr.traceEnabled && a(Wr.host, e2.Diagnostics.package_json_had_a_falsy_0_field, Sr);
                  return;
                }
                var xe = e2.normalizePath(e2.combinePaths(zr, Je));
                return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.package_json_has_0_field_1_that_references_2, Sr, Je, xe), xe;
              }
            }
            function G(Ze, Sr, zr) {
              return m2(Ze, "typings", Sr, zr) || m2(Ze, "types", Sr, zr);
            }
            function oe(Ze, Sr, zr) {
              return m2(Ze, "tsconfig", Sr, zr);
            }
            function f4(Ze, Sr, zr) {
              return m2(Ze, "main", Sr, zr);
            }
            function T(Ze, Sr) {
              var zr = p(Ze, "typesVersions", "object", Sr);
              if (zr !== void 0)
                return Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_has_a_typesVersions_field_with_version_specific_path_mappings), zr;
            }
            function K(Ze, Sr) {
              var zr = T(Ze, Sr);
              if (zr !== void 0) {
                if (Sr.traceEnabled)
                  for (var Wr in zr)
                    e2.hasProperty(zr, Wr) && !e2.VersionRange.tryParse(Wr) && a(Sr.host, e2.Diagnostics.package_json_has_a_typesVersions_entry_0_that_is_not_a_valid_semver_range, Wr);
                var Je = se(zr);
                if (!Je) {
                  Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_does_not_have_a_typesVersions_entry_that_matches_version_0, e2.versionMajorMinor);
                  return;
                }
                var xe = Je.version, vr = Je.paths;
                if (typeof vr != "object") {
                  Sr.traceEnabled && a(Sr.host, e2.Diagnostics.Expected_type_of_0_field_in_package_json_to_be_1_got_2, "typesVersions['".concat(xe, "']"), "object", typeof vr);
                  return;
                }
                return Je;
              }
            }
            var b;
            function se(Ze) {
              b || (b = new e2.Version(e2.version));
              for (var Sr in Ze)
                if (!!e2.hasProperty(Ze, Sr)) {
                  var zr = e2.VersionRange.tryParse(Sr);
                  if (zr !== void 0 && zr.test(b))
                    return { version: Sr, paths: Ze[Sr] };
                }
            }
            e2.getPackageJsonTypesVersionsPaths = se;
            function J(Ze, Sr) {
              if (Ze.typeRoots)
                return Ze.typeRoots;
              var zr;
              if (Ze.configFilePath ? zr = e2.getDirectoryPath(Ze.configFilePath) : Sr.getCurrentDirectory && (zr = Sr.getCurrentDirectory()), zr !== void 0)
                return ie(zr, Sr);
            }
            e2.getEffectiveTypeRoots = J;
            function ie(Ze, Sr) {
              if (!Sr.directoryExists)
                return [e2.combinePaths(Ze, R)];
              var zr;
              return e2.forEachAncestorDirectory(e2.normalizePath(Ze), function(Wr) {
                var Je = e2.combinePaths(Wr, R);
                Sr.directoryExists(Je) && (zr || (zr = [])).push(Je);
              }), zr;
            }
            var R = e2.combinePaths("node_modules", "@types");
            function q(Ze, Sr, zr) {
              var Wr = typeof zr.useCaseSensitiveFileNames == "function" ? zr.useCaseSensitiveFileNames() : zr.useCaseSensitiveFileNames;
              return e2.comparePaths(Ze, Sr, !Wr) === 0;
            }
            function O(Ze, Sr, zr, Wr, Je, xe, vr) {
              e2.Debug.assert(typeof Ze == "string", "Non-string value passed to `ts.resolveTypeReferenceDirective`, likely by a wrapping package working with an outdated `resolveTypeReferenceDirectives` signature. This is probably not a problem in TS itself.");
              var mr = C(zr, Wr);
              Je && (zr = Je.commandLine.options);
              var Ar = Sr ? e2.getDirectoryPath(Sr) : void 0, Oe = Ar ? xe && xe.getOrCreateCacheForDirectory(Ar, Je) : void 0, nr = Oe && Oe.get(Ze, vr);
              if (nr)
                return mr && (a(Wr, e2.Diagnostics.Resolving_type_reference_directive_0_containing_file_1, Ze, Sr), Je && a(Wr, e2.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, Je.sourceFile.fileName), a(Wr, e2.Diagnostics.Resolution_for_type_reference_directive_0_was_found_in_cache_from_location_1, Ze, Ar), ct(nr)), nr;
              var Mr = J(zr, Wr);
              mr && (Sr === void 0 ? Mr === void 0 ? a(Wr, e2.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_not_set, Ze) : a(Wr, e2.Diagnostics.Resolving_type_reference_directive_0_containing_file_not_set_root_directory_1, Ze, Mr) : Mr === void 0 ? a(Wr, e2.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_not_set, Ze, Sr) : a(Wr, e2.Diagnostics.Resolving_type_reference_directive_0_containing_file_1_root_directory_2, Ze, Sr, Mr), Je && a(Wr, e2.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, Je.sourceFile.fileName));
              var Pe = [], Ue = ve(zr);
              vr === e2.ModuleKind.ESNext && (e2.getEmitModuleResolutionKind(zr) === e2.ModuleResolutionKind.Node16 || e2.getEmitModuleResolutionKind(zr) === e2.ModuleResolutionKind.NodeNext) && (Ue |= d.EsmMode);
              var fr = Ue & d.Exports ? Ue & d.EsmMode ? ["node", "import", "types"] : ["node", "require", "types"] : [], De = [], gr = { compilerOptions: zr, host: Wr, traceEnabled: mr, failedLookupLocations: Pe, packageJsonInfoCache: xe, features: Ue, conditions: fr, requestContainingDirectory: Ar, reportDiagnostic: function(Mt) {
                return void De.push(Mt);
              } }, Vr = Li(), Tr = true;
              Vr || (Vr = nt(), Tr = false);
              var vi;
              if (Vr) {
                var Ui = Vr.fileName, Yi = Vr.packageId, Wi = zr.preserveSymlinks ? Ui : ze(Ui, Wr, mr);
                vi = { primary: Tr, resolvedFileName: Wi, originalPath: q(Ui, Wi, Wr) ? void 0 : Ui, packageId: Yi, isExternalLibraryImport: He(Ui) };
              }
              return nr = { resolvedTypeReferenceDirective: vi, failedLookupLocations: Pe, resolutionDiagnostics: De }, Oe == null || Oe.set(Ze, vr, nr), mr && ct(nr), nr;
              function ct(Mt) {
                var xt;
                !((xt = Mt.resolvedTypeReferenceDirective) === null || xt === void 0) && xt.resolvedFileName ? Mt.resolvedTypeReferenceDirective.packageId ? a(Wr, e2.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_with_Package_ID_2_primary_Colon_3, Ze, Mt.resolvedTypeReferenceDirective.resolvedFileName, e2.packageIdToString(Mt.resolvedTypeReferenceDirective.packageId), Mt.resolvedTypeReferenceDirective.primary) : a(Wr, e2.Diagnostics.Type_reference_directive_0_was_successfully_resolved_to_1_primary_Colon_2, Ze, Mt.resolvedTypeReferenceDirective.resolvedFileName, Mt.resolvedTypeReferenceDirective.primary) : a(Wr, e2.Diagnostics.Type_reference_directive_0_was_not_resolved, Ze);
              }
              function Li() {
                if (Mr && Mr.length)
                  return mr && a(Wr, e2.Diagnostics.Resolving_with_primary_search_path_0, Mr.join(", ")), e2.firstDefined(Mr, function(Mt) {
                    var xt = e2.combinePaths(Mt, Ze), ut = e2.getDirectoryPath(xt), Dt = e2.directoryProbablyExists(ut, Wr);
                    return !Dt && mr && a(Wr, e2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, ut), le(Cr(Q.DtsOnly, xt, !Dt, gr));
                  });
                mr && a(Wr, e2.Diagnostics.Root_directory_cannot_be_determined_skipping_primary_search_paths);
              }
              function nt() {
                var Mt = Sr && e2.getDirectoryPath(Sr);
                if (Mt !== void 0) {
                  mr && a(Wr, e2.Diagnostics.Looking_up_in_node_modules_folder_initial_location_0, Mt);
                  var xt;
                  if (e2.isExternalModuleNameRelative(Ze)) {
                    var Dt = Re(Mt, Ze).path;
                    xt = Ee(Q.DtsOnly, Dt, false, gr, true);
                  } else {
                    var ut = or(Q.DtsOnly, Ze, Mt, gr, void 0, void 0);
                    xt = ut && ut.value;
                  }
                  return le(xt);
                } else
                  mr && a(Wr, e2.Diagnostics.Containing_file_is_not_specified_and_root_directory_cannot_be_determined_skipping_lookup_in_node_modules_folder);
              }
            }
            e2.resolveTypeReferenceDirective = O;
            function ve(Ze) {
              return e2.getEmitModuleResolutionKind(Ze) === e2.ModuleResolutionKind.Node16 ? d.Node16Default : e2.getEmitModuleResolutionKind(Ze) === e2.ModuleResolutionKind.NodeNext ? d.NodeNextDefault : d.None;
            }
            function ee(Ze, Sr, zr, Wr, Je) {
              var xe = { compilerOptions: zr, host: Wr, traceEnabled: C(zr, Wr), failedLookupLocations: [], packageJsonInfoCache: Je == null ? void 0 : Je.getPackageJsonInfoCache(), conditions: e2.emptyArray, features: d.None, requestContainingDirectory: Sr, reportDiagnostic: e2.noop };
              return e2.forEachAncestorDirectory(Sr, function(vr) {
                if (e2.getBaseFileName(vr) !== "node_modules") {
                  var mr = e2.combinePaths(vr, "node_modules"), Ar = e2.combinePaths(mr, Ze);
                  return Ne(Ar, false, xe);
                }
              });
            }
            e2.resolvePackageNameToPackageJson = ee;
            function he(Ze, Sr) {
              if (Ze.types)
                return Ze.types;
              var zr = [];
              if (Sr.directoryExists && Sr.getDirectories) {
                var Wr = J(Ze, Sr);
                if (Wr)
                  for (var Je = 0, xe = Wr; Je < xe.length; Je++) {
                    var vr = xe[Je];
                    if (Sr.directoryExists(vr))
                      for (var mr = 0, Ar = Sr.getDirectories(vr); mr < Ar.length; mr++) {
                        var Oe = Ar[mr], nr = e2.normalizePath(Oe), Mr = e2.combinePaths(vr, nr, "package.json"), Pe = Sr.fileExists(Mr) && e2.readJson(Mr, Sr).typings === null;
                        if (!Pe) {
                          var Ue = e2.getBaseFileName(nr);
                          Ue.charCodeAt(0) !== 46 && zr.push(Ue);
                        }
                      }
                  }
              }
              return zr;
            }
            e2.getAutomaticTypeDirectiveNames = he;
            function F2(Ze) {
              var Sr = new e2.Map(), zr = new e2.Map();
              return { getOwnMap: Wr, redirectsMap: zr, getOrCreateMapOfCacheRedirects: vr, clear: mr, setOwnOptions: Je, setOwnMap: xe };
              function Wr() {
                return Sr;
              }
              function Je(Ar) {
                Ze = Ar;
              }
              function xe(Ar) {
                Sr = Ar;
              }
              function vr(Ar) {
                if (!Ar)
                  return Sr;
                var Oe = Ar.sourceFile.path, nr = zr.get(Oe);
                return nr || (nr = !Ze || e2.optionsHaveModuleResolutionChanges(Ze, Ar.commandLine.options) ? new e2.Map() : Sr, zr.set(Oe, nr)), nr;
              }
              function mr() {
                Sr.clear(), zr.clear();
              }
            }
            e2.createCacheWithRedirects = F2;
            function x2(Ze, Sr) {
              var zr;
              return { getPackageJsonInfo: Wr, setPackageJsonInfo: Je, clear: xe, entries: vr };
              function Wr(mr) {
                return zr == null ? void 0 : zr.get(e2.toPath(mr, Ze, Sr));
              }
              function Je(mr, Ar) {
                (zr || (zr = new e2.Map())).set(e2.toPath(mr, Ze, Sr), Ar);
              }
              function xe() {
                zr = void 0;
              }
              function vr() {
                var mr = zr == null ? void 0 : zr.entries();
                return mr ? e2.arrayFrom(mr) : [];
              }
            }
            function X(Ze, Sr, zr, Wr) {
              var Je = Ze.getOrCreateMapOfCacheRedirects(Sr), xe = Je.get(zr);
              return xe || (xe = Wr(), Je.set(zr, xe)), xe;
            }
            function $(Ze, Sr, zr) {
              if (!!Ze.configFile) {
                if (Sr.redirectsMap.size === 0)
                  e2.Debug.assert(!zr || zr.redirectsMap.size === 0), e2.Debug.assert(Sr.getOwnMap().size === 0), e2.Debug.assert(!zr || zr.getOwnMap().size === 0), Sr.redirectsMap.set(Ze.configFile.path, Sr.getOwnMap()), zr == null || zr.redirectsMap.set(Ze.configFile.path, zr.getOwnMap());
                else {
                  e2.Debug.assert(!zr || zr.redirectsMap.size > 0);
                  var Wr = { sourceFile: Ze.configFile, commandLine: { options: Ze } };
                  Sr.setOwnMap(Sr.getOrCreateMapOfCacheRedirects(Wr)), zr == null || zr.setOwnMap(zr.getOrCreateMapOfCacheRedirects(Wr));
                }
                Sr.setOwnOptions(Ze), zr == null || zr.setOwnOptions(Ze);
              }
            }
            function A2(Ze, Sr, zr) {
              return { getOrCreateCacheForDirectory: xe, clear: Wr, update: Je };
              function Wr() {
                zr.clear();
              }
              function Je(vr) {
                $(vr, zr);
              }
              function xe(vr, mr) {
                var Ar = e2.toPath(vr, Ze, Sr);
                return X(zr, mr, Ar, function() {
                  return y();
                });
              }
            }
            function y() {
              var Ze = new e2.Map(), Sr = new e2.Map(), zr = { get: function(Je, xe) {
                return Ze.get(Wr(Je, xe));
              }, set: function(Je, xe, vr) {
                return Ze.set(Wr(Je, xe), vr), zr;
              }, delete: function(Je, xe) {
                return Ze.delete(Wr(Je, xe)), zr;
              }, has: function(Je, xe) {
                return Ze.has(Wr(Je, xe));
              }, forEach: function(Je) {
                return Ze.forEach(function(xe, vr) {
                  var mr = Sr.get(vr), Ar = mr[0], Oe = mr[1];
                  return Je(xe, Ar, Oe);
                });
              }, size: function() {
                return Ze.size;
              } };
              return zr;
              function Wr(Je, xe) {
                var vr = xe === void 0 ? Je : "".concat(xe, "|").concat(Je);
                return Sr.set(vr, [Je, xe]), vr;
              }
            }
            e2.createModeAwareCache = y;
            function V(Ze, Sr, zr) {
              e2.Debug.assert(Sr.length === zr.length);
              for (var Wr = y(), Je = 0; Je < Sr.length; ++Je) {
                var xe = Sr[Je], vr = e2.isString(xe) ? xe : xe.fileName.toLowerCase(), mr = e2.isString(xe) ? e2.getModeForResolutionAtIndex(Ze, Je) : xe.resolutionMode || Ze.impliedNodeFormat;
                Wr.set(vr, mr, zr[Je]);
              }
              return Wr;
            }
            e2.zipToModeAwareCache = V;
            function L(Ze, Sr, zr, Wr, Je) {
              var xe = A2(Ze, Sr, Wr || (Wr = F2(zr)));
              Je || (Je = F2(zr));
              var vr = x2(Ze, Sr);
              return Ke(Ke(Ke({}, vr), xe), { getOrCreateCacheForModuleName: Oe, clear: mr, update: Ar, getPackageJsonInfoCache: function() {
                return vr;
              } });
              function mr() {
                xe.clear(), Je.clear(), vr.clear();
              }
              function Ar(Mr) {
                $(Mr, Wr, Je);
              }
              function Oe(Mr, Pe, Ue) {
                return e2.Debug.assert(!e2.isExternalModuleNameRelative(Mr)), X(Je, Ue, Pe === void 0 ? Mr : "".concat(Pe, "|").concat(Mr), nr);
              }
              function nr() {
                var Mr = new e2.Map();
                return { get: Pe, set: Ue };
                function Pe(De) {
                  return Mr.get(e2.toPath(De, Ze, Sr));
                }
                function Ue(De, gr) {
                  var Vr = e2.toPath(De, Ze, Sr);
                  if (!Mr.has(Vr)) {
                    Mr.set(Vr, gr);
                    for (var Tr = gr.resolvedModule && (gr.resolvedModule.originalPath || gr.resolvedModule.resolvedFileName), vi = Tr && fr(Vr, Tr), Ui = Vr; Ui !== vi; ) {
                      var Yi = e2.getDirectoryPath(Ui);
                      if (Yi === Ui || Mr.has(Yi))
                        break;
                      Mr.set(Yi, gr), Ui = Yi;
                    }
                  }
                }
                function fr(De, gr) {
                  for (var Vr = e2.toPath(e2.getDirectoryPath(gr), Ze, Sr), Tr = 0, vi = Math.min(De.length, Vr.length); Tr < vi && De.charCodeAt(Tr) === Vr.charCodeAt(Tr); )
                    Tr++;
                  if (Tr === De.length && (Vr.length === Tr || Vr[Tr] === e2.directorySeparator))
                    return De;
                  var Ui = e2.getRootLength(De);
                  if (!(Tr < Ui)) {
                    var Yi = De.lastIndexOf(e2.directorySeparator, Tr - 1);
                    if (Yi !== -1)
                      return De.substr(0, Math.max(Yi, Ui));
                  }
                }
              }
            }
            e2.createModuleResolutionCache = L;
            function P(Ze, Sr, zr, Wr, Je) {
              var xe = A2(Ze, Sr, Je || (Je = F2(zr)));
              return Wr || (Wr = x2(Ze, Sr)), Ke(Ke(Ke({}, Wr), xe), { clear: vr });
              function vr() {
                xe.clear(), Wr.clear();
              }
            }
            e2.createTypeReferenceDirectiveResolutionCache = P;
            function k(Ze, Sr, zr, Wr) {
              var Je = e2.getDirectoryPath(Sr), xe = zr && zr.getOrCreateCacheForDirectory(Je);
              if (!!xe)
                return xe.get(Ze, Wr);
            }
            e2.resolveModuleNameFromCache = k;
            function Y(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr = C(zr, Wr);
              xe && (zr = xe.commandLine.options), mr && (a(Wr, e2.Diagnostics.Resolving_module_0_from_1, Ze, Sr), xe && a(Wr, e2.Diagnostics.Using_compiler_options_of_project_reference_redirect_0, xe.sourceFile.fileName));
              var Ar = e2.getDirectoryPath(Sr), Oe = Je && Je.getOrCreateCacheForDirectory(Ar, xe), nr = Oe && Oe.get(Ze, vr);
              if (nr)
                mr && a(Wr, e2.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, Ze, Ar);
              else {
                var Mr = zr.moduleResolution;
                if (Mr === void 0) {
                  switch (e2.getEmitModuleKind(zr)) {
                    case e2.ModuleKind.CommonJS:
                      Mr = e2.ModuleResolutionKind.NodeJs;
                      break;
                    case e2.ModuleKind.Node16:
                      Mr = e2.ModuleResolutionKind.Node16;
                      break;
                    case e2.ModuleKind.NodeNext:
                      Mr = e2.ModuleResolutionKind.NodeNext;
                      break;
                    default:
                      Mr = e2.ModuleResolutionKind.Classic;
                      break;
                  }
                  mr && a(Wr, e2.Diagnostics.Module_resolution_kind_is_not_specified_using_0, e2.ModuleResolutionKind[Mr]);
                } else
                  mr && a(Wr, e2.Diagnostics.Explicitly_specified_module_resolution_kind_Colon_0, e2.ModuleResolutionKind[Mr]);
                switch (e2.perfLogger.logStartResolveModule(Ze), Mr) {
                  case e2.ModuleResolutionKind.Node16:
                    nr = D(Ze, Sr, zr, Wr, Je, xe, vr);
                    break;
                  case e2.ModuleResolutionKind.NodeNext:
                    nr = fe(Ze, Sr, zr, Wr, Je, xe, vr);
                    break;
                  case e2.ModuleResolutionKind.NodeJs:
                    nr = Be(Ze, Sr, zr, Wr, Je, xe);
                    break;
                  case e2.ModuleResolutionKind.Classic:
                    nr = Xe(Ze, Sr, zr, Wr, Je, xe);
                    break;
                  default:
                    return e2.Debug.fail("Unexpected moduleResolution: ".concat(Mr));
                }
                nr && nr.resolvedModule && e2.perfLogger.logInfoEvent('Module "'.concat(Ze, '" resolved to "').concat(nr.resolvedModule.resolvedFileName, '"')), e2.perfLogger.logStopResolveModule(nr && nr.resolvedModule ? "" + nr.resolvedModule.resolvedFileName : "null"), Oe && (Oe.set(Ze, vr, nr), e2.isExternalModuleNameRelative(Ze) || Je.getOrCreateCacheForModuleName(Ze, vr, xe).set(Ar, nr));
              }
              return mr && (nr.resolvedModule ? nr.resolvedModule.packageId ? a(Wr, e2.Diagnostics.Module_name_0_was_successfully_resolved_to_1_with_Package_ID_2, Ze, nr.resolvedModule.resolvedFileName, e2.packageIdToString(nr.resolvedModule.packageId)) : a(Wr, e2.Diagnostics.Module_name_0_was_successfully_resolved_to_1, Ze, nr.resolvedModule.resolvedFileName) : a(Wr, e2.Diagnostics.Module_name_0_was_not_resolved, Ze)), nr;
            }
            e2.resolveModuleName = Y;
            function U(Ze, Sr, zr, Wr, Je) {
              var xe = j(Ze, Sr, Wr, Je);
              return xe ? xe.value : e2.isExternalModuleNameRelative(Sr) ? H(Ze, Sr, zr, Wr, Je) : I(Ze, Sr, Wr, Je);
            }
            function j(Ze, Sr, zr, Wr) {
              var Je, xe = Wr.compilerOptions, vr = xe.baseUrl, mr = xe.paths, Ar = xe.configFile;
              if (mr && !e2.pathIsRelative(Sr)) {
                Wr.traceEnabled && (vr && a(Wr.host, e2.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, vr, Sr), a(Wr.host, e2.Diagnostics.paths_option_is_specified_looking_for_a_pattern_to_match_module_name_0, Sr));
                var Oe = e2.getPathsBasePath(Wr.compilerOptions, Wr.host), nr = Ar != null && Ar.configFileSpecs ? (Je = Ar.configFileSpecs).pathPatterns || (Je.pathPatterns = e2.tryParsePatterns(mr)) : void 0;
                return Xi(Ze, Sr, Oe, mr, nr, zr, false, Wr);
              }
            }
            function H(Ze, Sr, zr, Wr, Je) {
              if (!!Je.compilerOptions.rootDirs) {
                Je.traceEnabled && a(Je.host, e2.Diagnostics.rootDirs_option_is_set_using_it_to_resolve_relative_module_name_0, Sr);
                for (var xe = e2.normalizePath(e2.combinePaths(zr, Sr)), vr, mr, Ar = 0, Oe = Je.compilerOptions.rootDirs; Ar < Oe.length; Ar++) {
                  var nr = Oe[Ar], Mr = e2.normalizePath(nr);
                  e2.endsWith(Mr, e2.directorySeparator) || (Mr += e2.directorySeparator);
                  var Pe = e2.startsWith(xe, Mr) && (mr === void 0 || mr.length < Mr.length);
                  Je.traceEnabled && a(Je.host, e2.Diagnostics.Checking_if_0_is_the_longest_matching_prefix_for_1_2, Mr, xe, Pe), Pe && (mr = Mr, vr = nr);
                }
                if (mr) {
                  Je.traceEnabled && a(Je.host, e2.Diagnostics.Longest_matching_prefix_for_0_is_1, xe, mr);
                  var Ue = xe.substr(mr.length);
                  Je.traceEnabled && a(Je.host, e2.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, Ue, mr, xe);
                  var fr = Wr(Ze, xe, !e2.directoryProbablyExists(zr, Je.host), Je);
                  if (fr)
                    return fr;
                  Je.traceEnabled && a(Je.host, e2.Diagnostics.Trying_other_entries_in_rootDirs);
                  for (var De = 0, gr = Je.compilerOptions.rootDirs; De < gr.length; De++) {
                    var nr = gr[De];
                    if (nr !== vr) {
                      var Vr = e2.combinePaths(e2.normalizePath(nr), Ue);
                      Je.traceEnabled && a(Je.host, e2.Diagnostics.Loading_0_from_the_root_dir_1_candidate_location_2, Ue, nr, Vr);
                      var Tr = e2.getDirectoryPath(Vr), vi = Wr(Ze, Vr, !e2.directoryProbablyExists(Tr, Je.host), Je);
                      if (vi)
                        return vi;
                    }
                  }
                  Je.traceEnabled && a(Je.host, e2.Diagnostics.Module_resolution_using_rootDirs_has_failed);
                }
              }
            }
            function I(Ze, Sr, zr, Wr) {
              var Je = Wr.compilerOptions.baseUrl;
              if (!!Je) {
                Wr.traceEnabled && a(Wr.host, e2.Diagnostics.baseUrl_option_is_set_to_0_using_this_value_to_resolve_non_relative_module_name_1, Je, Sr);
                var xe = e2.normalizePath(e2.combinePaths(Je, Sr));
                return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Resolving_module_name_0_relative_to_base_url_1_2, Sr, Je, xe), zr(Ze, xe, !e2.directoryProbablyExists(e2.getDirectoryPath(xe), Wr.host), Wr);
              }
            }
            function l(Ze, Sr, zr) {
              var Wr = Z2(Ze, Sr, zr), Je = Wr.resolvedModule, xe = Wr.failedLookupLocations;
              if (!Je)
                throw new Error("Could not resolve JS module '".concat(Ze, "' starting at '").concat(Sr, "'. Looked in: ").concat(xe.join(", ")));
              return Je.resolvedFileName;
            }
            e2.resolveJSModule = l;
            var d;
            (function(Ze) {
              Ze[Ze.None = 0] = "None", Ze[Ze.Imports = 2] = "Imports", Ze[Ze.SelfName = 4] = "SelfName", Ze[Ze.Exports = 8] = "Exports", Ze[Ze.ExportsPatternTrailers = 16] = "ExportsPatternTrailers", Ze[Ze.AllFeatures = 30] = "AllFeatures", Ze[Ze.Node16Default = 30] = "Node16Default", Ze[Ze.NodeNextDefault = 30] = "NodeNextDefault", Ze[Ze.EsmMode = 32] = "EsmMode";
            })(d || (d = {}));
            function D(Ze, Sr, zr, Wr, Je, xe, vr) {
              return g(d.Node16Default, Ze, Sr, zr, Wr, Je, xe, vr);
            }
            function fe(Ze, Sr, zr, Wr, Je, xe, vr) {
              return g(d.NodeNextDefault, Ze, Sr, zr, Wr, Je, xe, vr);
            }
            function g(Ze, Sr, zr, Wr, Je, xe, vr, mr) {
              var Ar = e2.getDirectoryPath(zr), Oe = mr === e2.ModuleKind.ESNext ? d.EsmMode : 0;
              return ge(Ze | Oe, Sr, Ar, Wr, Je, xe, Wr.resolveJsonModule ? We : ue, vr);
            }
            var ne = [Q.JavaScript], ue = [Q.TypeScript, Q.JavaScript], We = Ve(Ve([], ue, true), [Q.Json], false), Fe = [Q.TSConfig];
            function Z2(Ze, Sr, zr) {
              return ge(d.None, Ze, Sr, { moduleResolution: e2.ModuleResolutionKind.NodeJs, allowJs: true }, zr, void 0, ne, void 0);
            }
            function Be(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr;
              return vr ? mr = Fe : zr.noDtsResolution ? (mr = [Q.TsOnly], zr.allowJs && mr.push(Q.JavaScript), zr.resolveJsonModule && mr.push(Q.Json)) : mr = zr.resolveJsonModule ? We : ue, ge(d.None, Ze, e2.getDirectoryPath(Sr), zr, Wr, Je, mr, xe);
            }
            e2.nodeModuleNameResolver = Be;
            function ge(Ze, Sr, zr, Wr, Je, xe, vr, mr) {
              var Ar, Oe, nr = C(Wr, Je), Mr = [], Pe = Ze & d.EsmMode ? ["node", "import", "types"] : ["node", "require", "types"];
              Wr.noDtsResolution && Pe.pop();
              var Ue = [], fr = { compilerOptions: Wr, host: Je, traceEnabled: nr, failedLookupLocations: Mr, packageJsonInfoCache: xe, features: Ze, conditions: Pe, requestContainingDirectory: zr, reportDiagnostic: function(Vr) {
                return void Ue.push(Vr);
              } }, De = e2.forEach(vr, function(Vr) {
                return gr(Vr);
              });
              return N((Ar = De == null ? void 0 : De.value) === null || Ar === void 0 ? void 0 : Ar.resolved, (Oe = De == null ? void 0 : De.value) === null || Oe === void 0 ? void 0 : Oe.isExternalLibraryImport, Mr, Ue, fr.resultFromCache);
              function gr(Vr) {
                var Tr = function(ut, Dt, Rt, Ii) {
                  return Ee(ut, Dt, Rt, Ii, true);
                }, vi = U(Vr, Sr, zr, Tr, fr);
                if (vi)
                  return ti({ resolved: vi, isExternalLibraryImport: He(vi.path) });
                if (e2.isExternalModuleNameRelative(Sr)) {
                  var Li = Re(zr, Sr), nt = Li.path, Mt = Li.parts, xt = Ee(Vr, nt, false, fr, true);
                  return xt && ti({ resolved: xt, isExternalLibraryImport: e2.contains(Mt, "node_modules") });
                } else {
                  var Ui;
                  if (Ze & d.Imports && e2.startsWith(Sr, "#") && (Ui = Ur(Vr, Sr, zr, fr, xe, mr)), !Ui && Ze & d.SelfName && (Ui = Ir(Vr, Sr, zr, fr, xe, mr)), Ui || (nr && a(Je, e2.Diagnostics.Loading_module_0_from_node_modules_folder_target_file_type_1, Sr, Q[Vr]), Ui = or(Vr, Sr, zr, fr, xe, mr)), !Ui)
                    return;
                  var Yi = Ui.value;
                  if (!Wr.preserveSymlinks && Yi && !Yi.originalPath) {
                    var Wi = ze(Yi.path, Je, nr), ct = q(Wi, Yi.path, Je) ? void 0 : Yi.path;
                    Yi = Ke(Ke({}, Yi), { path: Wi, originalPath: ct });
                  }
                  return { value: Yi && { resolved: Yi, isExternalLibraryImport: true } };
                }
              }
            }
            function Re(Ze, Sr) {
              var zr = e2.combinePaths(Ze, Sr), Wr = e2.getPathComponents(zr), Je = e2.lastOrUndefined(Wr), xe = Je === "." || Je === ".." ? e2.ensureTrailingDirectorySeparator(e2.normalizePath(zr)) : e2.normalizePath(zr);
              return { path: xe, parts: Wr };
            }
            function ze(Ze, Sr, zr) {
              if (!Sr.realpath)
                return Ze;
              var Wr = e2.normalizePath(Sr.realpath(Ze));
              return zr && a(Sr, e2.Diagnostics.Resolving_real_path_for_0_result_1, Ze, Wr), e2.Debug.assert(Sr.fileExists(Wr), "".concat(Ze, " linked to nonexistent file ").concat(Wr)), Wr;
            }
            function Ee(Ze, Sr, zr, Wr, Je) {
              if (Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Loading_module_as_file_Slash_folder_candidate_module_location_0_target_file_type_1, Sr, Q[Ze]), !e2.hasTrailingDirectorySeparator(Sr)) {
                if (!zr) {
                  var xe = e2.getDirectoryPath(Sr);
                  e2.directoryProbablyExists(xe, Wr.host) || (Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, xe), zr = true);
                }
                var vr = we(Ze, Sr, zr, Wr);
                if (vr) {
                  var mr = Je ? rr(vr.path) : void 0, Ar = mr ? Ne(mr, false, Wr) : void 0;
                  return w(Ar, vr);
                }
              }
              if (!zr) {
                var Oe = e2.directoryProbablyExists(Sr, Wr.host);
                Oe || (Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, Sr), zr = true);
              }
              if (!(Wr.features & d.EsmMode))
                return Cr(Ze, Sr, zr, Wr, Je);
            }
            e2.nodeModulesPathPart = "/node_modules/";
            function He(Ze) {
              return e2.stringContains(Ze, e2.nodeModulesPathPart);
            }
            e2.pathContainsNodeModules = He;
            function rr(Ze) {
              var Sr = e2.normalizePath(Ze), zr = Sr.lastIndexOf(e2.nodeModulesPathPart);
              if (zr !== -1) {
                var Wr = zr + e2.nodeModulesPathPart.length, Je = Ie(Sr, Wr);
                return Sr.charCodeAt(Wr) === 64 && (Je = Ie(Sr, Je)), Sr.slice(0, Je);
              }
            }
            e2.parseNodeModuleFromPath = rr;
            function Ie(Ze, Sr) {
              var zr = Ze.indexOf(e2.directorySeparator, Sr + 1);
              return zr === -1 ? Sr : zr;
            }
            function _e(Ze, Sr, zr, Wr) {
              return B(we(Ze, Sr, zr, Wr));
            }
            function we(Ze, Sr, zr, Wr) {
              if (Ze === Q.Json || Ze === Q.TSConfig) {
                var Je = e2.tryRemoveExtension(Sr, ".json"), xe = Je ? Sr.substring(Je.length) : "";
                return Je === void 0 && Ze === Q.Json ? void 0 : Ae(Je || Sr, Ze, xe, zr, Wr);
              }
              if (!(Wr.features & d.EsmMode)) {
                var vr = Ae(Sr, Ze, "", zr, Wr);
                if (vr)
                  return vr;
              }
              return de(Ze, Sr, zr, Wr);
            }
            function de(Ze, Sr, zr, Wr) {
              if (e2.hasJSFileExtension(Sr) || e2.fileExtensionIs(Sr, ".json") && Wr.compilerOptions.resolveJsonModule) {
                var Je = e2.removeFileExtension(Sr), xe = Sr.substring(Je.length);
                return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.File_name_0_has_a_1_extension_stripping_it, Sr, xe), Ae(Je, Ze, xe, zr, Wr);
              }
            }
            function ye(Ze, Sr, zr, Wr) {
              if ((Ze === Q.TypeScript || Ze === Q.DtsOnly) && e2.fileExtensionIsOneOf(Sr, e2.supportedTSExtensionsFlat)) {
                var Je = er(Sr, zr, Wr);
                return Je !== void 0 ? { path: Sr, ext: e2.tryExtractTSExtension(Sr) } : void 0;
              }
              return de(Ze, Sr, zr, Wr);
            }
            function Ae(Ze, Sr, zr, Wr, Je) {
              if (!Wr) {
                var xe = e2.getDirectoryPath(Ze);
                xe && (Wr = !e2.directoryProbablyExists(xe, Je.host));
              }
              switch (Sr) {
                case Q.DtsOnly:
                  switch (zr) {
                    case ".mjs":
                    case ".mts":
                    case ".d.mts":
                      return mr(".d.mts");
                    case ".cjs":
                    case ".cts":
                    case ".d.cts":
                      return mr(".d.cts");
                    case ".json":
                      return Ze += ".json", mr(".d.ts");
                    default:
                      return mr(".d.ts");
                  }
                case Q.TypeScript:
                case Q.TsOnly:
                  var vr = Sr === Q.TypeScript;
                  switch (zr) {
                    case ".mjs":
                    case ".mts":
                    case ".d.mts":
                      return mr(".mts") || (vr ? mr(".d.mts") : void 0);
                    case ".cjs":
                    case ".cts":
                    case ".d.cts":
                      return mr(".cts") || (vr ? mr(".d.cts") : void 0);
                    case ".json":
                      return Ze += ".json", vr ? mr(".d.ts") : void 0;
                    default:
                      return mr(".ts") || mr(".tsx") || (vr ? mr(".d.ts") : void 0);
                  }
                case Q.JavaScript:
                  switch (zr) {
                    case ".mjs":
                    case ".mts":
                    case ".d.mts":
                      return mr(".mjs");
                    case ".cjs":
                    case ".cts":
                    case ".d.cts":
                      return mr(".cjs");
                    case ".json":
                      return mr(".json");
                    default:
                      return mr(".js") || mr(".jsx");
                  }
                case Q.TSConfig:
                case Q.Json:
                  return mr(".json");
              }
              function mr(Ar) {
                var Oe = er(Ze + Ar, Wr, Je);
                return Oe === void 0 ? void 0 : { path: Oe, ext: Ar };
              }
            }
            function er(Ze, Sr, zr) {
              var Wr, Je;
              if (!(!((Wr = zr.compilerOptions.moduleSuffixes) === null || Wr === void 0) && Wr.length))
                return ir(Ze, Sr, zr);
              var xe = (Je = e2.tryGetExtensionFromPath(Ze)) !== null && Je !== void 0 ? Je : "", vr = xe ? e2.removeExtension(Ze, xe) : Ze;
              return e2.forEach(zr.compilerOptions.moduleSuffixes, function(mr) {
                return ir(vr + mr + xe, Sr, zr);
              });
            }
            function ir(Ze, Sr, zr) {
              if (!Sr) {
                if (zr.host.fileExists(Ze))
                  return zr.traceEnabled && a(zr.host, e2.Diagnostics.File_0_exist_use_it_as_a_name_resolution_result, Ze), Ze;
                zr.traceEnabled && a(zr.host, e2.Diagnostics.File_0_does_not_exist, Ze);
              }
              zr.failedLookupLocations.push(Ze);
            }
            function Cr(Ze, Sr, zr, Wr, Je) {
              Je === void 0 && (Je = true);
              var xe = Je ? Ne(Sr, zr, Wr) : void 0, vr = xe && xe.packageJsonContent, mr = xe && xe.versionPaths;
              return w(xe, n(Ze, Sr, zr, Wr, vr, mr));
            }
            function Ye(Ze, Sr, zr, Wr, Je) {
              if (!Je && Ze.resolvedEntrypoints !== void 0)
                return Ze.resolvedEntrypoints;
              var xe, vr = Je ? Q.JavaScript : Q.TypeScript, mr = ve(Sr), Ar = { compilerOptions: Sr, host: zr, traceEnabled: C(Sr, zr), failedLookupLocations: [], packageJsonInfoCache: Wr == null ? void 0 : Wr.getPackageJsonInfoCache(), conditions: ["node", "require", "types"], features: mr, requestContainingDirectory: Ze.packageDirectory, reportDiagnostic: e2.noop }, Oe = n(vr, Ze.packageDirectory, false, Ar, Ze.packageJsonContent, Ze.versionPaths);
              if (xe = e2.append(xe, Oe == null ? void 0 : Oe.path), mr & d.Exports && Ze.packageJsonContent.exports)
                for (var nr = 0, Mr = [["node", "import", "types"], ["node", "require", "types"]]; nr < Mr.length; nr++) {
                  var Pe = Mr[nr], Ue = Ke(Ke({}, Ar), { failedLookupLocations: [], conditions: Pe }), fr = Br(Ze, Ze.packageJsonContent.exports, Ue, vr);
                  if (fr)
                    for (var De = 0, gr = fr; De < gr.length; De++) {
                      var Vr = gr[De];
                      xe = e2.appendIfUnique(xe, Vr.path);
                    }
                }
              return Ze.resolvedEntrypoints = xe || false;
            }
            e2.getEntrypointsFromPackageJsonInfo = Ye;
            function Br(Ze, Sr, zr, Wr) {
              var Je;
              if (e2.isArray(Sr))
                for (var xe = 0, vr = Sr; xe < vr.length; xe++) {
                  var mr = vr[xe];
                  Oe(mr);
                }
              else if (typeof Sr == "object" && Sr !== null && ur(Sr))
                for (var Ar in Sr)
                  Oe(Sr[Ar]);
              else
                Oe(Sr);
              return Je;
              function Oe(nr) {
                var Mr, Pe;
                if (typeof nr == "string" && e2.startsWith(nr, "./") && nr.indexOf("*") === -1) {
                  var Ue = e2.getPathComponents(nr).slice(2);
                  if (Ue.indexOf("..") >= 0 || Ue.indexOf(".") >= 0 || Ue.indexOf("node_modules") >= 0)
                    return false;
                  var fr = e2.combinePaths(Ze.packageDirectory, nr), De = e2.getNormalizedAbsolutePath(fr, (Pe = (Mr = zr.host).getCurrentDirectory) === null || Pe === void 0 ? void 0 : Pe.call(Mr)), gr = ye(Wr, De, false, zr);
                  if (gr)
                    return Je = e2.appendIfUnique(Je, gr, function(Yi, Wi) {
                      return Yi.path === Wi.path;
                    }), true;
                } else if (Array.isArray(nr))
                  for (var Vr = 0, Tr = nr; Vr < Tr.length; Vr++) {
                    var vi = Tr[Vr], Ui = Oe(vi);
                    if (Ui)
                      return true;
                  }
                else if (typeof nr == "object" && nr !== null)
                  return e2.forEach(e2.getOwnKeys(nr), function(Yi) {
                    if (Yi === "default" || e2.contains(zr.conditions, Yi) || pe(zr.conditions, Yi))
                      return Oe(nr[Yi]), true;
                  });
              }
            }
            function Er(Ze, Sr, zr, Wr) {
              var Je = { host: zr, compilerOptions: Wr, traceEnabled: C(Wr, zr), failedLookupLocations: [], packageJsonInfoCache: Sr, features: 0, conditions: [], requestContainingDirectory: void 0, reportDiagnostic: e2.noop }, xe = e2.getPathComponents(Ze);
              for (xe.pop(); xe.length > 0; ) {
                var vr = Ne(e2.getPathFromPathComponents(xe), false, Je);
                if (vr)
                  return vr;
                xe.pop();
              }
            }
            e2.getPackageScopeForPath = Er;
            function Ne(Ze, Sr, zr) {
              var Wr, Je, xe, vr = zr.host, mr = zr.traceEnabled, Ar = e2.combinePaths(Ze, "package.json");
              if (Sr) {
                zr.failedLookupLocations.push(Ar);
                return;
              }
              var Oe = (Wr = zr.packageJsonInfoCache) === null || Wr === void 0 ? void 0 : Wr.getPackageJsonInfo(Ar);
              if (Oe !== void 0) {
                if (typeof Oe != "boolean")
                  return mr && a(vr, e2.Diagnostics.File_0_exists_according_to_earlier_cached_lookups, Ar), Oe;
                Oe && mr && a(vr, e2.Diagnostics.File_0_does_not_exist_according_to_earlier_cached_lookups, Ar), zr.failedLookupLocations.push(Ar);
                return;
              }
              var nr = e2.directoryProbablyExists(Ze, vr);
              if (nr && vr.fileExists(Ar)) {
                var Mr = e2.readJson(Ar, vr);
                mr && a(vr, e2.Diagnostics.Found_package_json_at_0, Ar);
                var Pe = K(Mr, zr), Ue = { packageDirectory: Ze, packageJsonContent: Mr, versionPaths: Pe, resolvedEntrypoints: void 0 };
                return (Je = zr.packageJsonInfoCache) === null || Je === void 0 || Je.setPackageJsonInfo(Ar, Ue), Ue;
              } else
                nr && mr && a(vr, e2.Diagnostics.File_0_does_not_exist, Ar), (xe = zr.packageJsonInfoCache) === null || xe === void 0 || xe.setPackageJsonInfo(Ar, nr), zr.failedLookupLocations.push(Ar);
            }
            e2.getPackageJsonInfo = Ne;
            function n(Ze, Sr, zr, Wr, Je, xe) {
              var vr;
              if (Je)
                switch (Ze) {
                  case Q.JavaScript:
                  case Q.Json:
                  case Q.TsOnly:
                    vr = f4(Je, Sr, Wr);
                    break;
                  case Q.TypeScript:
                    vr = G(Je, Sr, Wr) || f4(Je, Sr, Wr);
                    break;
                  case Q.DtsOnly:
                    vr = G(Je, Sr, Wr);
                    break;
                  case Q.TSConfig:
                    vr = oe(Je, Sr, Wr);
                    break;
                  default:
                    return e2.Debug.assertNever(Ze);
                }
              var mr = function(fr, De, gr, Vr) {
                var Tr = er(De, gr, Vr);
                if (Tr) {
                  var vi = lr(fr, Tr);
                  if (vi)
                    return B(vi);
                  Vr.traceEnabled && a(Vr.host, e2.Diagnostics.File_0_has_an_unsupported_extension_so_skipping_it, Tr);
                }
                var Ui = fr === Q.DtsOnly ? Q.TypeScript : fr, Yi = Vr.features;
                (Je == null ? void 0 : Je.type) !== "module" && (Vr.features &= ~d.EsmMode);
                var Wi = Ee(Ui, De, gr, Vr, false);
                return Vr.features = Yi, Wi;
              }, Ar = vr ? !e2.directoryProbablyExists(e2.getDirectoryPath(vr), Wr.host) : void 0, Oe = zr || !e2.directoryProbablyExists(Sr, Wr.host), nr = e2.combinePaths(Sr, Ze === Q.TSConfig ? "tsconfig" : "index");
              if (xe && (!vr || e2.containsPath(Sr, vr))) {
                var Mr = e2.getRelativePathFromDirectory(Sr, vr || nr, false);
                Wr.traceEnabled && a(Wr.host, e2.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, xe.version, e2.version, Mr);
                var Pe = Xi(Ze, Mr, Sr, xe.paths, void 0, mr, Ar || Oe, Wr);
                if (Pe)
                  return E(Pe.value);
              }
              var Ue = vr && E(mr(Ze, vr, Ar, Wr));
              if (Ue)
                return Ue;
              if (!(Wr.features & d.EsmMode))
                return we(Ze, nr, Oe, Wr);
            }
            function lr(Ze, Sr) {
              var zr = e2.tryGetExtensionFromPath(Sr);
              return zr !== void 0 && be(Ze, zr) ? { path: Sr, ext: zr } : void 0;
            }
            function be(Ze, Sr) {
              switch (Ze) {
                case Q.JavaScript:
                  return Sr === ".js" || Sr === ".jsx" || Sr === ".mjs" || Sr === ".cjs";
                case Q.TSConfig:
                case Q.Json:
                  return Sr === ".json";
                case Q.TypeScript:
                  return Sr === ".ts" || Sr === ".tsx" || Sr === ".mts" || Sr === ".cts" || Sr === ".d.ts" || Sr === ".d.mts" || Sr === ".d.cts";
                case Q.TsOnly:
                  return Sr === ".ts" || Sr === ".tsx" || Sr === ".mts" || Sr === ".cts";
                case Q.DtsOnly:
                  return Sr === ".d.ts" || Sr === ".d.mts" || Sr === ".d.cts";
              }
            }
            function Ge(Ze) {
              var Sr = Ze.indexOf(e2.directorySeparator);
              return Ze[0] === "@" && (Sr = Ze.indexOf(e2.directorySeparator, Sr + 1)), Sr === -1 ? { packageName: Ze, rest: "" } : { packageName: Ze.slice(0, Sr), rest: Ze.slice(Sr + 1) };
            }
            e2.parsePackageName = Ge;
            function ur(Ze) {
              return e2.every(e2.getOwnKeys(Ze), function(Sr) {
                return e2.startsWith(Sr, ".");
              });
            }
            e2.allKeysStartWithDot = ur;
            function yr(Ze) {
              return !e2.some(e2.getOwnKeys(Ze), function(Sr) {
                return e2.startsWith(Sr, ".");
              });
            }
            function Ir(Ze, Sr, zr, Wr, Je, xe) {
              var vr, mr, Ar = typeof Wr.host.useCaseSensitiveFileNames == "function" ? Wr.host.useCaseSensitiveFileNames() : Wr.host.useCaseSensitiveFileNames, Oe = e2.toPath(e2.combinePaths(zr, "dummy"), (mr = (vr = Wr.host).getCurrentDirectory) === null || mr === void 0 ? void 0 : mr.call(vr), e2.createGetCanonicalFileName(Ar === void 0 ? true : Ar)), nr = Er(Oe, Wr.packageJsonInfoCache, Wr.host, Wr.compilerOptions);
              if (!(!nr || !nr.packageJsonContent.exports) && typeof nr.packageJsonContent.name == "string") {
                var Mr = e2.getPathComponents(Sr), Pe = e2.getPathComponents(nr.packageJsonContent.name);
                if (!!e2.every(Pe, function(fr, De) {
                  return Mr[De] === fr;
                })) {
                  var Ue = Mr.slice(Pe.length);
                  return wr(nr, Ze, e2.length(Ue) ? ".".concat(e2.directorySeparator).concat(Ue.join(e2.directorySeparator)) : ".", Wr, Je, xe);
                }
              }
            }
            function wr(Ze, Sr, zr, Wr, Je, xe) {
              if (!!Ze.packageJsonContent.exports) {
                if (zr === ".") {
                  var vr = void 0;
                  if (typeof Ze.packageJsonContent.exports == "string" || Array.isArray(Ze.packageJsonContent.exports) || typeof Ze.packageJsonContent.exports == "object" && yr(Ze.packageJsonContent.exports) ? vr = Ze.packageJsonContent.exports : e2.hasProperty(Ze.packageJsonContent.exports, ".") && (vr = Ze.packageJsonContent.exports["."]), vr) {
                    var mr = mi(Sr, Wr, Je, xe, zr, Ze, false);
                    return mr(vr, "", false);
                  }
                } else if (ur(Ze.packageJsonContent.exports)) {
                  if (typeof Ze.packageJsonContent.exports != "object")
                    return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1, zr, Ze.packageDirectory), ti(void 0);
                  var Ar = ii(Sr, Wr, Je, xe, zr, Ze.packageJsonContent.exports, Ze, false);
                  if (Ar)
                    return Ar;
                }
                return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Export_specifier_0_does_not_exist_in_package_json_scope_at_path_1, zr, Ze.packageDirectory), ti(void 0);
              }
            }
            function Ur(Ze, Sr, zr, Wr, Je, xe) {
              var vr, mr;
              if (Sr === "#" || e2.startsWith(Sr, "#/"))
                return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Invalid_import_specifier_0_has_no_possible_resolutions, Sr), ti(void 0);
              var Ar = typeof Wr.host.useCaseSensitiveFileNames == "function" ? Wr.host.useCaseSensitiveFileNames() : Wr.host.useCaseSensitiveFileNames, Oe = e2.toPath(e2.combinePaths(zr, "dummy"), (mr = (vr = Wr.host).getCurrentDirectory) === null || mr === void 0 ? void 0 : mr.call(vr), e2.createGetCanonicalFileName(Ar === void 0 ? true : Ar)), nr = Er(Oe, Wr.packageJsonInfoCache, Wr.host, Wr.compilerOptions);
              if (!nr)
                return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Directory_0_has_no_containing_package_json_scope_Imports_will_not_resolve, Oe), ti(void 0);
              if (!nr.packageJsonContent.imports)
                return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.package_json_scope_0_has_no_imports_defined, nr.packageDirectory), ti(void 0);
              var Mr = ii(Ze, Wr, Je, xe, Sr, nr.packageJsonContent.imports, nr, true);
              return Mr || (Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Import_specifier_0_does_not_exist_in_package_json_scope_at_path_1, Sr, nr.packageDirectory), ti(void 0));
            }
            function ii(Ze, Sr, zr, Wr, Je, xe, vr, mr) {
              var Ar = mi(Ze, Sr, zr, Wr, Je, vr, mr);
              if (!e2.endsWith(Je, e2.directorySeparator) && Je.indexOf("*") === -1 && e2.hasProperty(xe, Je)) {
                var Oe = xe[Je];
                return Ar(Oe, "", false);
              }
              for (var nr = e2.sort(e2.filter(e2.getOwnKeys(xe), function(Vr) {
                return Vr.indexOf("*") !== -1 || e2.endsWith(Vr, "/");
              }), function(Vr, Tr) {
                return Vr.length - Tr.length;
              }), Mr = 0, Pe = nr; Mr < Pe.length; Mr++) {
                var Ue = Pe[Mr];
                if (Sr.features & d.ExportsPatternTrailers && gr(Ue, Je)) {
                  var Oe = xe[Ue], fr = Ue.indexOf("*"), De = Je.substring(Ue.substring(0, fr).length, Je.length - (Ue.length - 1 - fr));
                  return Ar(Oe, De, true);
                } else if (e2.endsWith(Ue, "*") && e2.startsWith(Je, Ue.substring(0, Ue.length - 1))) {
                  var Oe = xe[Ue], De = Je.substring(Ue.length - 1);
                  return Ar(Oe, De, true);
                } else if (e2.startsWith(Je, Ue)) {
                  var Oe = xe[Ue], De = Je.substring(Ue.length);
                  return Ar(Oe, De, false);
                }
              }
              function gr(Vr, Tr) {
                if (e2.endsWith(Vr, "*"))
                  return false;
                var vi = Vr.indexOf("*");
                return vi === -1 ? false : e2.startsWith(Tr, Vr.substring(0, vi)) && e2.endsWith(Tr, Vr.substring(vi + 1));
              }
            }
            function mi(Ze, Sr, zr, Wr, Je, xe, vr) {
              return mr;
              function mr(Ar, Oe, nr) {
                if (typeof Ar == "string") {
                  if (!nr && Oe.length > 0 && !e2.endsWith(Ar, "/"))
                    return Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  if (!e2.startsWith(Ar, "./")) {
                    if (vr && !e2.startsWith(Ar, "../") && !e2.startsWith(Ar, "/") && !e2.isRootedDiskPath(Ar)) {
                      var Mr = nr ? Ar.replace(/\*/g, Oe) : Ar + Oe, Pe = ge(Sr.features, Mr, xe.packageDirectory + "/", Sr.compilerOptions, Sr.host, zr, [Ze], Wr);
                      return ti(Pe.resolvedModule ? { path: Pe.resolvedModule.resolvedFileName, extension: Pe.resolvedModule.extension, packageId: Pe.resolvedModule.packageId, originalPath: Pe.resolvedModule.originalPath } : void 0);
                    }
                    return Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  }
                  var Ue = e2.pathIsRelative(Ar) ? e2.getPathComponents(Ar).slice(1) : e2.getPathComponents(Ar), fr = Ue.slice(1);
                  if (fr.indexOf("..") >= 0 || fr.indexOf(".") >= 0 || fr.indexOf("node_modules") >= 0)
                    return Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  var De = e2.combinePaths(xe.packageDirectory, Ar), gr = e2.getPathComponents(Oe);
                  if (gr.indexOf("..") >= 0 || gr.indexOf(".") >= 0 || gr.indexOf("node_modules") >= 0)
                    return Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                  var Vr = Mt(nr ? De.replace(/\*/g, Oe) : De + Oe), Tr = Dt(Vr, Oe, e2.combinePaths(xe.packageDirectory, "package.json"), vr);
                  return Tr || ti(w(xe, ye(Ze, Vr, false, Sr)));
                } else if (typeof Ar == "object" && Ar !== null)
                  if (Array.isArray(Ar)) {
                    if (!e2.length(Ar))
                      return Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                    for (var ct = 0, Li = Ar; ct < Li.length; ct++) {
                      var nt = Li[ct], Pe = mr(nt, Oe, nr);
                      if (Pe)
                        return Pe;
                    }
                  } else {
                    for (var vi = 0, Ui = e2.getOwnKeys(Ar); vi < Ui.length; vi++) {
                      var Yi = Ui[vi];
                      if (Yi === "default" || Sr.conditions.indexOf(Yi) >= 0 || pe(Sr.conditions, Yi)) {
                        var Wi = Ar[Yi], Pe = mr(Wi, Oe, nr);
                        if (Pe)
                          return Pe;
                      }
                    }
                    return;
                  }
                else if (Ar === null)
                  return Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_scope_0_explicitly_maps_specifier_1_to_null, xe.packageDirectory, Je), ti(void 0);
                return Sr.traceEnabled && a(Sr.host, e2.Diagnostics.package_json_scope_0_has_invalid_type_for_target_of_specifier_1, xe.packageDirectory, Je), ti(void 0);
                function Mt(Rt) {
                  var Ii, Ki;
                  return Rt === void 0 ? Rt : e2.hostGetCanonicalFileName({ useCaseSensitiveFileNames: ut })(e2.getNormalizedAbsolutePath(Rt, (Ki = (Ii = Sr.host).getCurrentDirectory) === null || Ki === void 0 ? void 0 : Ki.call(Ii)));
                }
                function xt(Rt, Ii) {
                  return e2.ensureTrailingDirectorySeparator(e2.combinePaths(Rt, Ii));
                }
                function ut() {
                  return Sr.host.useCaseSensitiveFileNames ? typeof Sr.host.useCaseSensitiveFileNames == "boolean" ? Sr.host.useCaseSensitiveFileNames : Sr.host.useCaseSensitiveFileNames() : true;
                }
                function Dt(Rt, Ii, Ki, Fi) {
                  var ui, Bt, wt, na;
                  if ((Ze === Q.TypeScript || Ze === Q.JavaScript || Ze === Q.Json) && (Sr.compilerOptions.declarationDir || Sr.compilerOptions.outDir) && Rt.indexOf("/node_modules/") === -1 && (Sr.compilerOptions.configFile ? e2.startsWith(Mt(Sr.compilerOptions.configFile.fileName), xe.packageDirectory) : true)) {
                    var Ai = e2.hostGetCanonicalFileName({ useCaseSensitiveFileNames: ut }), Oi = [];
                    if (Sr.compilerOptions.rootDir || Sr.compilerOptions.composite && Sr.compilerOptions.configFilePath) {
                      var ji = Mt(e2.getCommonSourceDirectory(Sr.compilerOptions, function() {
                        return [];
                      }, ((Bt = (ui = Sr.host).getCurrentDirectory) === null || Bt === void 0 ? void 0 : Bt.call(ui)) || "", Ai));
                      Oi.push(ji);
                    } else if (Sr.requestContainingDirectory) {
                      var Vi = Mt(e2.combinePaths(Sr.requestContainingDirectory, "index.ts")), ji = Mt(e2.getCommonSourceDirectory(Sr.compilerOptions, function() {
                        return [Vi, Mt(Ki)];
                      }, ((na = (wt = Sr.host).getCurrentDirectory) === null || na === void 0 ? void 0 : na.call(wt)) || "", Ai));
                      Oi.push(ji);
                      for (var at = e2.ensureTrailingDirectorySeparator(ji); at && at.length > 1; ) {
                        var At = e2.getPathComponents(at);
                        At.pop();
                        var ba = e2.getPathFromPathComponents(At);
                        Oi.unshift(ba), at = e2.ensureTrailingDirectorySeparator(ba);
                      }
                    }
                    Oi.length > 1 && Sr.reportDiagnostic(e2.createCompilerDiagnostic(Fi ? e2.Diagnostics.The_project_root_is_ambiguous_but_is_required_to_resolve_import_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate : e2.Diagnostics.The_project_root_is_ambiguous_but_is_required_to_resolve_export_map_entry_0_in_file_1_Supply_the_rootDir_compiler_option_to_disambiguate, Ii === "" ? "." : Ii, Ki));
                    for (var $a = 0, Qa = Oi; $a < Qa.length; $a++)
                      for (var ai = Qa[$a], Dn = En(ai), ka = 0, Ba = Dn; ka < Ba.length; ka++) {
                        var pn = Ba[ka];
                        if (e2.startsWith(Rt, pn))
                          for (var Cn = Rt.slice(pn.length + 1), Bi = e2.combinePaths(ai, Cn), kn = [".mjs", ".cjs", ".js", ".json", ".d.mts", ".d.cts", ".d.ts"], xn = 0, Kn = kn; xn < Kn.length; xn++) {
                            var Pn = Kn[xn];
                            if (e2.fileExtensionIs(Bi, Pn))
                              for (var eo = e2.getPossibleOriginalInputExtensionForExtension(Bi), Rn = 0, Da = eo; Rn < Da.length; Rn++) {
                                var bo = Da[Rn], Ro = e2.changeAnyExtension(Bi, bo, Pn, !ut());
                                if (!(Ze === Q.TypeScript && e2.hasJSFileExtension(Ro) || Ze === Q.JavaScript && e2.hasTSFileExtension(Ro)) && Sr.host.fileExists(Ro))
                                  return ti(w(xe, ye(Ze, Ro, false, Sr)));
                              }
                          }
                      }
                  }
                  return;
                  function En(Wn) {
                    var to, Co, Ko = Sr.compilerOptions.configFile ? ((Co = (to = Sr.host).getCurrentDirectory) === null || Co === void 0 ? void 0 : Co.call(to)) || "" : Wn, Oo = [];
                    return Sr.compilerOptions.declarationDir && Oo.push(Mt(xt(Ko, Sr.compilerOptions.declarationDir))), Sr.compilerOptions.outDir && Sr.compilerOptions.outDir !== Sr.compilerOptions.declarationDir && Oo.push(Mt(xt(Ko, Sr.compilerOptions.outDir))), Oo;
                  }
                }
              }
            }
            function pe(Ze, Sr) {
              if (Ze.indexOf("types") === -1 || !e2.startsWith(Sr, "types@"))
                return false;
              var zr = e2.VersionRange.tryParse(Sr.substring(6));
              return zr ? zr.test(e2.version) : false;
            }
            e2.isApplicableVersionedTypesKey = pe;
            function or(Ze, Sr, zr, Wr, Je, xe) {
              return si(Ze, Sr, zr, Wr, false, Je, xe);
            }
            function qr(Ze, Sr, zr) {
              return si(Q.DtsOnly, Ze, Sr, zr, true, void 0, void 0);
            }
            function si(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr = xe && xe.getOrCreateCacheForModuleName(Sr, Wr.features === 0 ? void 0 : Wr.features & d.EsmMode ? e2.ModuleKind.ESNext : e2.ModuleKind.CommonJS, vr);
              return e2.forEachAncestorDirectory(e2.normalizeSlashes(zr), function(Ar) {
                if (e2.getBaseFileName(Ar) !== "node_modules") {
                  var Oe = ae(mr, Sr, Ar, Wr);
                  return Oe || ti(Di(Ze, Sr, Ar, Wr, Je, xe, vr));
                }
              });
            }
            function Di(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr = e2.combinePaths(zr, "node_modules"), Ar = e2.directoryProbablyExists(mr, Wr.host);
              !Ar && Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, mr);
              var Oe = Je ? void 0 : wi(Ze, Sr, mr, Ar, Wr, xe, vr);
              if (Oe)
                return Oe;
              if (Ze === Q.TypeScript || Ze === Q.DtsOnly) {
                var nr = e2.combinePaths(mr, "@types"), Mr = Ar;
                return Ar && !e2.directoryProbablyExists(nr, Wr.host) && (Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Directory_0_does_not_exist_skipping_all_lookups_in_it, nr), Mr = false), wi(Q.DtsOnly, Gi(Sr, Wr), nr, Mr, Wr, xe, vr);
              }
            }
            function wi(Ze, Sr, zr, Wr, Je, xe, vr) {
              var mr = e2.normalizePath(e2.combinePaths(zr, Sr)), Ar = Ne(mr, !Wr, Je);
              if (!(Je.features & d.Exports) && Ar) {
                var Oe = we(Ze, mr, !Wr, Je);
                if (Oe)
                  return B(Oe);
                var nr = n(Ze, mr, !Wr, Je, Ar.packageJsonContent, Ar.versionPaths);
                return w(Ar, nr);
              }
              var Mr = Ge(Sr), Pe = Mr.packageName, Ue = Mr.rest, fr = function(Tr, vi, Ui, Yi) {
                var Wi;
                if (Ar && Ar.packageJsonContent.exports && Yi.features & d.Exports)
                  return (Wi = wr(Ar, Tr, e2.combinePaths(".", Ue), Yi, xe, vr)) === null || Wi === void 0 ? void 0 : Wi.value;
                var ct = we(Tr, vi, Ui, Yi) || n(Tr, vi, Ui, Yi, Ar && Ar.packageJsonContent, Ar && Ar.versionPaths);
                return !ct && Ar && Ar.packageJsonContent.exports === void 0 && Ar.packageJsonContent.main === void 0 && Yi.features & d.EsmMode && (ct = we(Tr, e2.combinePaths(vi, "index.js"), Ui, Yi)), w(Ar, ct);
              };
              if (Ue !== "") {
                var De = e2.combinePaths(zr, Pe);
                if (Ar = Ne(De, !Wr, Je), Ar && Ar.versionPaths) {
                  Je.traceEnabled && a(Je.host, e2.Diagnostics.package_json_has_a_typesVersions_entry_0_that_matches_compiler_version_1_looking_for_a_pattern_to_match_module_name_2, Ar.versionPaths.version, e2.version, Ue);
                  var gr = Wr && e2.directoryProbablyExists(De, Je.host), Vr = Xi(Ze, Ue, De, Ar.versionPaths.paths, void 0, fr, !gr, Je);
                  if (Vr)
                    return Vr.value;
                }
              }
              return fr(Ze, mr, !Wr, Je);
            }
            function Xi(Ze, Sr, zr, Wr, Je, xe, vr, mr) {
              Je || (Je = e2.tryParsePatterns(Wr));
              var Ar = e2.matchPatternOrExact(Je, Sr);
              if (Ar) {
                var Oe = e2.isString(Ar) ? void 0 : e2.matchedText(Ar, Sr), nr = e2.isString(Ar) ? Ar : e2.patternText(Ar);
                mr.traceEnabled && a(mr.host, e2.Diagnostics.Module_name_0_matched_pattern_1, Sr, nr);
                var Mr = e2.forEach(Wr[nr], function(Pe) {
                  var Ue = Oe ? Pe.replace("*", Oe) : Pe, fr = e2.normalizePath(e2.combinePaths(zr, Ue));
                  mr.traceEnabled && a(mr.host, e2.Diagnostics.Trying_substitution_0_candidate_module_location_Colon_1, Pe, Ue);
                  var De = e2.tryGetExtensionFromPath(Pe);
                  if (De !== void 0) {
                    var gr = er(fr, vr, mr);
                    if (gr !== void 0)
                      return B({ path: gr, ext: De });
                  }
                  return xe(Ze, fr, vr || !e2.directoryProbablyExists(e2.getDirectoryPath(fr), mr.host), mr);
                });
                return { value: Mr };
              }
            }
            var et = "__";
            function Gi(Ze, Sr) {
              var zr = Zt(Ze);
              return Sr.traceEnabled && zr !== Ze && a(Sr.host, e2.Diagnostics.Scoped_package_detected_looking_in_0, zr), zr;
            }
            function Wt(Ze) {
              return "@types/".concat(Zt(Ze));
            }
            e2.getTypesPackageName = Wt;
            function Zt(Ze) {
              if (e2.startsWith(Ze, "@")) {
                var Sr = Ze.replace(e2.directorySeparator, et);
                if (Sr !== Ze)
                  return Sr.slice(1);
              }
              return Ze;
            }
            e2.mangleScopedPackageName = Zt;
            function _r(Ze) {
              var Sr = e2.removePrefix(Ze, "@types/");
              return Sr !== Ze ? pi(Sr) : Ze;
            }
            e2.getPackageNameFromTypesPackageName = _r;
            function pi(Ze) {
              return e2.stringContains(Ze, et) ? "@" + Ze.replace(et, e2.directorySeparator) : Ze;
            }
            e2.unmangleScopedPackageName = pi;
            function ae(Ze, Sr, zr, Wr) {
              var Je = Ze && Ze.get(zr);
              if (Je)
                return Wr.traceEnabled && a(Wr.host, e2.Diagnostics.Resolution_for_module_0_was_found_in_cache_from_location_1, Sr, zr), Wr.resultFromCache = Je, { value: Je.resolvedModule && { path: Je.resolvedModule.resolvedFileName, originalPath: Je.resolvedModule.originalPath || true, extension: Je.resolvedModule.extension, packageId: Je.resolvedModule.packageId } };
            }
            function Xe(Ze, Sr, zr, Wr, Je, xe) {
              var vr = C(zr, Wr), mr = [], Ar = e2.getDirectoryPath(Sr), Oe = [], nr = { compilerOptions: zr, host: Wr, traceEnabled: vr, failedLookupLocations: mr, packageJsonInfoCache: Je, features: d.None, conditions: [], requestContainingDirectory: Ar, reportDiagnostic: function(Ue) {
                return void Oe.push(Ue);
              } }, Mr = Pe(Q.TypeScript) || Pe(Q.JavaScript);
              return N(Mr && Mr.value, false, mr, Oe, nr.resultFromCache);
              function Pe(Ue) {
                var fr = U(Ue, Ze, Ar, _e, nr);
                if (fr)
                  return { value: fr };
                if (e2.isExternalModuleNameRelative(Ze)) {
                  var Vr = e2.normalizePath(e2.combinePaths(Ar, Ze));
                  return ti(_e(Ue, Vr, false, nr));
                } else {
                  var De = Je && Je.getOrCreateCacheForModuleName(Ze, void 0, xe), gr = e2.forEachAncestorDirectory(Ar, function(Tr) {
                    var vi = ae(De, Ze, Tr, nr);
                    if (vi)
                      return vi;
                    var Ui = e2.normalizePath(e2.combinePaths(Tr, Ze));
                    return ti(_e(Ue, Ui, false, nr));
                  });
                  if (gr)
                    return gr;
                  if (Ue === Q.TypeScript)
                    return qr(Ze, Ar, nr);
                }
              }
            }
            e2.classicNameResolver = Xe;
            function Jr(Ze, Sr, zr, Wr, Je, xe) {
              var vr = C(zr, Wr);
              vr && a(Wr, e2.Diagnostics.Auto_discovery_for_typings_is_enabled_in_project_0_Running_extra_resolution_pass_for_module_1_using_cache_location_2, Sr, Ze, Je);
              var mr = [], Ar = [], Oe = { compilerOptions: zr, host: Wr, traceEnabled: vr, failedLookupLocations: mr, packageJsonInfoCache: xe, features: d.None, conditions: [], requestContainingDirectory: void 0, reportDiagnostic: function(Mr) {
                return void Ar.push(Mr);
              } }, nr = Di(Q.DtsOnly, Ze, Je, Oe, false, void 0, void 0);
              return N(nr, true, mr, Ar, Oe.resultFromCache);
            }
            e2.loadModuleFromGlobalCache = Jr;
            function ti(Ze) {
              return Ze !== void 0 ? { value: Ze } : void 0;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(b) {
              b[b.NonInstantiated = 0] = "NonInstantiated", b[b.Instantiated = 1] = "Instantiated", b[b.ConstEnumOnly = 2] = "ConstEnumOnly";
            })(a = e2.ModuleInstanceState || (e2.ModuleInstanceState = {}));
            function C(b, se) {
              return b.body && !b.body.parent && (e2.setParent(b.body, b), e2.setParentRecursive(b.body, false)), b.body ? w(b.body, se) : 1;
            }
            e2.getModuleInstanceState = C;
            function w(b, se) {
              se === void 0 && (se = new e2.Map());
              var J = e2.getNodeId(b);
              if (se.has(J))
                return se.get(J) || 0;
              se.set(J, void 0);
              var ie = B(b, se);
              return se.set(J, ie), ie;
            }
            function B(b, se) {
              switch (b.kind) {
                case 258:
                case 259:
                  return 0;
                case 260:
                  if (e2.isEnumConst(b))
                    return 2;
                  break;
                case 266:
                case 265:
                  if (!e2.hasSyntacticModifier(b, 1))
                    return 0;
                  break;
                case 272:
                  var J = b;
                  if (!J.moduleSpecifier && J.exportClause && J.exportClause.kind === 273) {
                    for (var ie = 0, R = 0, q = J.exportClause.elements; R < q.length; R++) {
                      var O = q[R], ve = E(O, se);
                      if (ve > ie && (ie = ve), ie === 1)
                        return ie;
                    }
                    return ie;
                  }
                  break;
                case 262: {
                  var ee = 0;
                  return e2.forEachChild(b, function(he) {
                    var F2 = w(he, se);
                    switch (F2) {
                      case 0:
                        return;
                      case 2:
                        ee = 2;
                        return;
                      case 1:
                        return ee = 1, true;
                      default:
                        e2.Debug.assertNever(F2);
                    }
                  }), ee;
                }
                case 261:
                  return C(b, se);
                case 79:
                  if (b.isInJSDocNamespace)
                    return 0;
              }
              return 1;
            }
            function E(b, se) {
              for (var J = b.propertyName || b.name, ie = b.parent; ie; ) {
                if (e2.isBlock(ie) || e2.isModuleBlock(ie) || e2.isSourceFile(ie)) {
                  for (var R = ie.statements, q = void 0, O = 0, ve = R; O < ve.length; O++) {
                    var ee = ve[O];
                    if (e2.nodeHasName(ee, J)) {
                      ee.parent || (e2.setParent(ee, ie), e2.setParentRecursive(ee, false));
                      var he = w(ee, se);
                      if ((q === void 0 || he > q) && (q = he), q === 1)
                        return q;
                    }
                  }
                  if (q !== void 0)
                    return q;
                }
                ie = ie.parent;
              }
              return 1;
            }
            var Q;
            (function(b) {
              b[b.None = 0] = "None", b[b.IsContainer = 1] = "IsContainer", b[b.IsBlockScopedContainer = 2] = "IsBlockScopedContainer", b[b.IsControlFlowContainer = 4] = "IsControlFlowContainer", b[b.IsFunctionLike = 8] = "IsFunctionLike", b[b.IsFunctionExpression = 16] = "IsFunctionExpression", b[b.HasLocals = 32] = "HasLocals", b[b.IsInterface = 64] = "IsInterface", b[b.IsObjectLiteralOrClassExpressionMethodOrAccessor = 128] = "IsObjectLiteralOrClassExpressionMethodOrAccessor";
            })(Q || (Q = {}));
            function le(b) {
              return e2.Debug.attachFlowNodeDebugInfo(b), b;
            }
            var N = m2();
            function p(b, se) {
              e2.performance.mark("beforeBind"), e2.perfLogger.logStartBindFile("" + b.fileName), N(b, se), e2.perfLogger.logStopBindFile(), e2.performance.mark("afterBind"), e2.performance.measure("Bind", "beforeBind", "afterBind");
            }
            e2.bindSourceFile = p;
            function m2() {
              var b, se, J, ie, R, q, O, ve, ee, he, F2, x2, X, $, A2, y, V, L, P, k, Y, U, j = false, H = 0, I, l, d = { flags: 1 }, D = { flags: 1 }, fe = Ar();
              function g(ce, Rr, yi, qi, je) {
                return e2.createDiagnosticForNodeInSourceFile(e2.getSourceFileOfNode(ce) || b, ce, Rr, yi, qi, je);
              }
              function ne(ce, Rr) {
                b = ce, se = Rr, J = e2.getEmitScriptTarget(se), U = ue(b, Rr), l = new e2.Set(), H = 0, I = e2.objectAllocator.getSymbolConstructor(), e2.Debug.attachFlowNodeDebugInfo(d), e2.Debug.attachFlowNodeDebugInfo(D), b.locals || (e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("bind", "bindSourceFile", { path: b.path }, true), Da(b), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), b.symbolCount = H, b.classifiableNames = l, Ai()), b = void 0, se = void 0, J = void 0, ie = void 0, R = void 0, q = void 0, O = void 0, ve = void 0, ee = void 0, he = false, F2 = void 0, x2 = void 0, X = void 0, $ = void 0, A2 = void 0, y = void 0, V = void 0, P = void 0, k = false, j = false, Y = 0;
              }
              return ne;
              function ue(ce, Rr) {
                return e2.getStrictOptionValue(Rr, "alwaysStrict") && !ce.isDeclarationFile ? true : !!ce.externalModuleIndicator;
              }
              function We(ce, Rr) {
                return H++, new I(ce, Rr);
              }
              function Fe(ce, Rr, yi) {
                ce.flags |= yi, Rr.symbol = ce, ce.declarations = e2.appendIfUnique(ce.declarations, Rr), yi & 1955 && !ce.exports && (ce.exports = e2.createSymbolTable()), yi & 6240 && !ce.members && (ce.members = e2.createSymbolTable()), ce.constEnumOnlyModule && ce.flags & 304 && (ce.constEnumOnlyModule = false), yi & 111551 && e2.setValueDeclaration(ce, Rr);
              }
              function Z2(ce) {
                if (ce.kind === 271)
                  return ce.isExportEquals ? "export=" : "default";
                var Rr = e2.getNameOfDeclaration(ce);
                if (Rr) {
                  if (e2.isAmbientModule(ce)) {
                    var yi = e2.getTextOfIdentifierOrLiteral(Rr);
                    return e2.isGlobalScopeAugmentation(ce) ? "__global" : '"'.concat(yi, '"');
                  }
                  if (Rr.kind === 162) {
                    var qi = Rr.expression;
                    if (e2.isStringOrNumericLiteralLike(qi))
                      return e2.escapeLeadingUnderscores(qi.text);
                    if (e2.isSignedNumericLiteral(qi))
                      return e2.tokenToString(qi.operator) + qi.operand.text;
                    e2.Debug.fail("Only computed properties with literal names have declaration names");
                  }
                  if (e2.isPrivateIdentifier(Rr)) {
                    var je = e2.getContainingClass(ce);
                    if (!je)
                      return;
                    var Hr = je.symbol;
                    return e2.getSymbolNameForPrivateIdentifier(Hr, Rr.escapedText);
                  }
                  return e2.isPropertyNameLiteral(Rr) ? e2.getEscapedTextOfIdentifierOrLiteral(Rr) : void 0;
                }
                switch (ce.kind) {
                  case 171:
                    return "__constructor";
                  case 179:
                  case 174:
                  case 323:
                    return "__call";
                  case 180:
                  case 175:
                    return "__new";
                  case 176:
                    return "__index";
                  case 272:
                    return "__export";
                  case 305:
                    return "export=";
                  case 221:
                    if (e2.getAssignmentDeclarationKind(ce) === 2)
                      return "export=";
                    e2.Debug.fail("Unknown binary declaration kind");
                    break;
                  case 317:
                    return e2.isJSDocConstructSignature(ce) ? "__new" : "__call";
                  case 164:
                    e2.Debug.assert(ce.parent.kind === 317, "Impossible parameter parent kind", function() {
                      return "parent is: ".concat(e2.SyntaxKind ? e2.SyntaxKind[ce.parent.kind] : ce.parent.kind, ", expected JSDocFunctionType");
                    });
                    var pt = ce.parent, Pt = pt.parameters.indexOf(ce);
                    return "arg" + Pt;
                }
              }
              function Be(ce) {
                return e2.isNamedDeclaration(ce) ? e2.declarationNameToString(ce.name) : e2.unescapeLeadingUnderscores(e2.Debug.checkDefined(Z2(ce)));
              }
              function ge(ce, Rr, yi, qi, je, Hr, pt) {
                e2.Debug.assert(pt || !e2.hasDynamicName(yi));
                var Pt = e2.hasSyntacticModifier(yi, 512) || e2.isExportSpecifier(yi) && yi.name.escapedText === "default", ga = pt ? "__computed" : Pt && Rr ? "default" : Z2(yi), ua;
                if (ga === void 0)
                  ua = We(0, "__missing");
                else if (ua = ce.get(ga), qi & 2885600 && l.add(ga), !ua)
                  ce.set(ga, ua = We(0, ga)), Hr && (ua.isReplaceableByMethod = true);
                else {
                  if (Hr && !ua.isReplaceableByMethod)
                    return ua;
                  if (ua.flags & je) {
                    if (ua.isReplaceableByMethod)
                      ce.set(ga, ua = We(0, ga));
                    else if (!(qi & 3 && ua.flags & 67108864)) {
                      e2.isNamedDeclaration(yi) && e2.setParent(yi.name, yi);
                      var Xn = ua.flags & 2 ? e2.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : e2.Diagnostics.Duplicate_identifier_0, jr = true;
                      (ua.flags & 384 || qi & 384) && (Xn = e2.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations, jr = false);
                      var fo = false;
                      e2.length(ua.declarations) && (Pt || ua.declarations && ua.declarations.length && yi.kind === 271 && !yi.isExportEquals) && (Xn = e2.Diagnostics.A_module_cannot_have_multiple_default_exports, jr = false, fo = true);
                      var xs = [];
                      e2.isTypeAliasDeclaration(yi) && e2.nodeIsMissing(yi.type) && e2.hasSyntacticModifier(yi, 1) && ua.flags & 2887656 && xs.push(g(yi, e2.Diagnostics.Did_you_mean_0, "export type { ".concat(e2.unescapeLeadingUnderscores(yi.name.escapedText), " }")));
                      var Fo = e2.getNameOfDeclaration(yi) || yi;
                      e2.forEach(ua.declarations, function(Ao, Ms) {
                        var Bs = e2.getNameOfDeclaration(Ao) || Ao, xc = g(Bs, Xn, jr ? Be(Ao) : void 0);
                        b.bindDiagnostics.push(fo ? e2.addRelatedInfo(xc, g(Fo, Ms === 0 ? e2.Diagnostics.Another_export_default_is_here : e2.Diagnostics.and_here)) : xc), fo && xs.push(g(Bs, e2.Diagnostics.The_first_export_default_is_here));
                      });
                      var ko = g(Fo, Xn, jr ? Be(yi) : void 0);
                      b.bindDiagnostics.push(e2.addRelatedInfo.apply(void 0, Ve([ko], xs, false))), ua = We(0, ga);
                    }
                  }
                }
                return Fe(ua, yi, qi), ua.parent ? e2.Debug.assert(ua.parent === Rr, "Existing symbol parent should match new one") : ua.parent = Rr, ua;
              }
              function Re(ce, Rr, yi) {
                var qi = !!(e2.getCombinedModifierFlags(ce) & 1) || ze(ce);
                if (Rr & 2097152)
                  return ce.kind === 275 || ce.kind === 265 && qi ? ge(R.symbol.exports, R.symbol, ce, Rr, yi) : ge(R.locals, void 0, ce, Rr, yi);
                if (e2.isJSDocTypeAlias(ce) && e2.Debug.assert(e2.isInJSFile(ce)), !e2.isAmbientModule(ce) && (qi || R.flags & 64)) {
                  if (!R.locals || e2.hasSyntacticModifier(ce, 512) && !Z2(ce))
                    return ge(R.symbol.exports, R.symbol, ce, Rr, yi);
                  var je = Rr & 111551 ? 1048576 : 0, Hr = ge(R.locals, void 0, ce, je, yi);
                  return Hr.exportSymbol = ge(R.symbol.exports, R.symbol, ce, Rr, yi), ce.localSymbol = Hr, Hr;
                } else
                  return ge(R.locals, void 0, ce, Rr, yi);
              }
              function ze(ce) {
                if (ce.parent && e2.isModuleDeclaration(ce) && (ce = ce.parent), !e2.isJSDocTypeAlias(ce))
                  return false;
                if (!e2.isJSDocEnumTag(ce) && !!ce.fullName)
                  return true;
                var Rr = e2.getNameOfDeclaration(ce);
                return Rr ? !!(e2.isPropertyAccessEntityNameExpression(Rr.parent) && Wa(Rr.parent) || e2.isDeclaration(Rr.parent) && e2.getCombinedModifierFlags(Rr.parent) & 1) : false;
              }
              function Ee(ce, Rr) {
                var yi = R, qi = q, je = O;
                if (Rr & 1 ? (ce.kind !== 214 && (q = R), R = O = ce, Rr & 32 && (R.locals = e2.createSymbolTable()), Li(R)) : Rr & 2 && (O = ce, O.locals = void 0), Rr & 4) {
                  var Hr = F2, pt = x2, Pt = X, ga = $, ua = V, Xn = P, jr = k, fo = Rr & 16 && !e2.hasSyntacticModifier(ce, 256) && !ce.asteriskToken && !!e2.getImmediatelyInvokedFunctionExpression(ce) || ce.kind === 170;
                  fo || (F2 = le({ flags: 2 }), Rr & 144 && (F2.node = ce)), $ = fo || ce.kind === 171 || e2.isInJSFile(ce) && (ce.kind === 256 || ce.kind === 213) ? Ye() : void 0, V = void 0, x2 = void 0, X = void 0, P = void 0, k = false, _e(ce), ce.flags &= -2817, !(F2.flags & 1) && Rr & 8 && e2.nodeIsPresent(ce.body) && (ce.flags |= 256, k && (ce.flags |= 512), ce.endFlowNode = F2), ce.kind === 305 && (ce.flags |= Y, ce.endFlowNode = F2), $ && (n($, F2), F2 = yr($), (ce.kind === 171 || ce.kind === 170 || e2.isInJSFile(ce) && (ce.kind === 256 || ce.kind === 213)) && (ce.returnFlowNode = F2)), fo || (F2 = Hr), x2 = pt, X = Pt, $ = ga, V = ua, P = Xn, k = jr;
                } else
                  Rr & 64 ? (he = false, _e(ce), ce.flags = he ? ce.flags | 128 : ce.flags & -129) : _e(ce);
                R = yi, q = qi, O = je;
              }
              function He(ce) {
                rr(ce, function(Rr) {
                  return Rr.kind === 256 ? Da(Rr) : void 0;
                }), rr(ce, function(Rr) {
                  return Rr.kind !== 256 ? Da(Rr) : void 0;
                });
              }
              function rr(ce, Rr) {
                Rr === void 0 && (Rr = Da), ce !== void 0 && e2.forEach(ce, Rr);
              }
              function Ie(ce) {
                e2.forEachChild(ce, Da, rr);
              }
              function _e(ce) {
                var Rr = j;
                if (j = false, Ji(ce)) {
                  Ie(ce), bo(ce), j = Rr;
                  return;
                }
                switch (ce.kind >= 237 && ce.kind <= 253 && !se.allowUnreachableCode && (ce.flowNode = F2), ce.kind) {
                  case 241:
                    si(ce);
                    break;
                  case 240:
                    Di(ce);
                    break;
                  case 242:
                    wi(ce);
                    break;
                  case 243:
                  case 244:
                    Xi(ce);
                    break;
                  case 239:
                    et(ce);
                    break;
                  case 247:
                  case 251:
                    Gi(ce);
                    break;
                  case 246:
                  case 245:
                    _r(ce);
                    break;
                  case 252:
                    pi(ce);
                    break;
                  case 249:
                    ae(ce);
                    break;
                  case 263:
                    Xe(ce);
                    break;
                  case 289:
                    Jr(ce);
                    break;
                  case 238:
                    ti(ce);
                    break;
                  case 250:
                    Sr(ce);
                    break;
                  case 219:
                    xe(ce);
                    break;
                  case 220:
                    vr(ce);
                    break;
                  case 221:
                    if (e2.isDestructuringAssignment(ce)) {
                      j = Rr, mr(ce);
                      return;
                    }
                    fe(ce);
                    break;
                  case 215:
                    Oe(ce);
                    break;
                  case 222:
                    nr(ce);
                    break;
                  case 254:
                    Pe(ce);
                    break;
                  case 206:
                  case 207:
                    Yi(ce);
                    break;
                  case 208:
                    Wi(ce);
                    break;
                  case 230:
                    Ui(ce);
                    break;
                  case 345:
                  case 338:
                  case 339:
                    fr(ce);
                    break;
                  case 305: {
                    He(ce.statements), Da(ce.endOfFileToken);
                    break;
                  }
                  case 235:
                  case 262:
                    He(ce.statements);
                    break;
                  case 203:
                    Ue(ce);
                    break;
                  case 205:
                  case 204:
                  case 296:
                  case 225:
                    j = Rr;
                  default:
                    Ie(ce);
                    break;
                }
                bo(ce), j = Rr;
              }
              function we(ce) {
                switch (ce.kind) {
                  case 79:
                  case 80:
                  case 108:
                  case 206:
                  case 207:
                    return ye(ce);
                  case 208:
                    return Ae(ce);
                  case 212:
                  case 230:
                    return we(ce.expression);
                  case 221:
                    return ir(ce);
                  case 219:
                    return ce.operator === 53 && we(ce.operand);
                  case 216:
                    return we(ce.expression);
                }
                return false;
              }
              function de(ce) {
                return e2.isDottedName(ce) || (e2.isPropertyAccessExpression(ce) || e2.isNonNullExpression(ce) || e2.isParenthesizedExpression(ce)) && de(ce.expression) || e2.isBinaryExpression(ce) && ce.operatorToken.kind === 27 && de(ce.right) || e2.isElementAccessExpression(ce) && (e2.isStringOrNumericLiteralLike(ce.argumentExpression) || e2.isEntityNameExpression(ce.argumentExpression)) && de(ce.expression) || e2.isAssignmentExpression(ce) && de(ce.left);
              }
              function ye(ce) {
                return de(ce) || e2.isOptionalChain(ce) && ye(ce.expression);
              }
              function Ae(ce) {
                if (ce.arguments)
                  for (var Rr = 0, yi = ce.arguments; Rr < yi.length; Rr++) {
                    var qi = yi[Rr];
                    if (ye(qi))
                      return true;
                  }
                return !!(ce.expression.kind === 206 && ye(ce.expression.expression));
              }
              function er(ce, Rr) {
                return e2.isTypeOfExpression(ce) && Cr(ce.expression) && e2.isStringLiteralLike(Rr);
              }
              function ir(ce) {
                switch (ce.operatorToken.kind) {
                  case 63:
                  case 75:
                  case 76:
                  case 77:
                    return ye(ce.left);
                  case 34:
                  case 35:
                  case 36:
                  case 37:
                    return Cr(ce.left) || Cr(ce.right) || er(ce.right, ce.left) || er(ce.left, ce.right);
                  case 102:
                    return Cr(ce.left);
                  case 101:
                    return we(ce.right);
                  case 27:
                    return we(ce.right);
                }
                return false;
              }
              function Cr(ce) {
                switch (ce.kind) {
                  case 212:
                    return Cr(ce.expression);
                  case 221:
                    switch (ce.operatorToken.kind) {
                      case 63:
                        return Cr(ce.left);
                      case 27:
                        return Cr(ce.right);
                    }
                }
                return ye(ce);
              }
              function Ye() {
                return le({ flags: 4, antecedents: void 0 });
              }
              function Br() {
                return le({ flags: 8, antecedents: void 0 });
              }
              function Er(ce, Rr, yi) {
                return le({ flags: 1024, target: ce, antecedents: Rr, antecedent: yi });
              }
              function Ne(ce) {
                ce.flags |= ce.flags & 2048 ? 4096 : 2048;
              }
              function n(ce, Rr) {
                !(Rr.flags & 1) && !e2.contains(ce.antecedents, Rr) && ((ce.antecedents || (ce.antecedents = [])).push(Rr), Ne(Rr));
              }
              function lr(ce, Rr, yi) {
                return Rr.flags & 1 ? Rr : yi ? (yi.kind === 110 && ce & 64 || yi.kind === 95 && ce & 32) && !e2.isExpressionOfOptionalChainRoot(yi) && !e2.isNullishCoalesce(yi.parent) ? d : we(yi) ? (Ne(Rr), le({ flags: ce, antecedent: Rr, node: yi })) : Rr : ce & 32 ? Rr : d;
              }
              function be(ce, Rr, yi, qi) {
                return Ne(ce), le({ flags: 128, antecedent: ce, switchStatement: Rr, clauseStart: yi, clauseEnd: qi });
              }
              function Ge(ce, Rr, yi) {
                Ne(Rr);
                var qi = le({ flags: ce, antecedent: Rr, node: yi });
                return V && n(V, qi), qi;
              }
              function ur(ce, Rr) {
                return Ne(ce), le({ flags: 512, antecedent: ce, node: Rr });
              }
              function yr(ce) {
                var Rr = ce.antecedents;
                return Rr ? Rr.length === 1 ? Rr[0] : ce : d;
              }
              function Ir(ce) {
                var Rr = ce.parent;
                switch (Rr.kind) {
                  case 239:
                  case 241:
                  case 240:
                    return Rr.expression === ce;
                  case 242:
                  case 222:
                    return Rr.condition === ce;
                }
                return false;
              }
              function wr(ce) {
                for (; ; )
                  if (ce.kind === 212)
                    ce = ce.expression;
                  else if (ce.kind === 219 && ce.operator === 53)
                    ce = ce.operand;
                  else
                    return ce.kind === 221 && (ce.operatorToken.kind === 55 || ce.operatorToken.kind === 56 || ce.operatorToken.kind === 60);
              }
              function Ur(ce) {
                return ce = e2.skipParentheses(ce), e2.isBinaryExpression(ce) && e2.isLogicalOrCoalescingAssignmentOperator(ce.operatorToken.kind);
              }
              function ii(ce) {
                for (; e2.isParenthesizedExpression(ce.parent) || e2.isPrefixUnaryExpression(ce.parent) && ce.parent.operator === 53; )
                  ce = ce.parent;
                return !Ir(ce) && !wr(ce.parent) && !(e2.isOptionalChain(ce.parent) && ce.parent.expression === ce);
              }
              function mi(ce, Rr, yi, qi) {
                var je = A2, Hr = y;
                A2 = yi, y = qi, ce(Rr), A2 = je, y = Hr;
              }
              function pe(ce, Rr, yi) {
                mi(Da, ce, Rr, yi), (!ce || !Ur(ce) && !wr(ce) && !(e2.isOptionalChain(ce) && e2.isOutermostOptionalChain(ce))) && (n(Rr, lr(32, F2, ce)), n(yi, lr(64, F2, ce)));
              }
              function or(ce, Rr, yi) {
                var qi = x2, je = X;
                x2 = Rr, X = yi, Da(ce), x2 = qi, X = je;
              }
              function qr(ce, Rr) {
                for (var yi = P; yi && ce.parent.kind === 250; )
                  yi.continueTarget = Rr, yi = yi.next, ce = ce.parent;
                return Rr;
              }
              function si(ce) {
                var Rr = qr(ce, Br()), yi = Ye(), qi = Ye();
                n(Rr, F2), F2 = Rr, pe(ce.expression, yi, qi), F2 = yr(yi), or(ce.statement, qi, Rr), n(Rr, F2), F2 = yr(qi);
              }
              function Di(ce) {
                var Rr = Br(), yi = qr(ce, Ye()), qi = Ye();
                n(Rr, F2), F2 = Rr, or(ce.statement, qi, yi), n(yi, F2), F2 = yr(yi), pe(ce.expression, Rr, qi), F2 = yr(qi);
              }
              function wi(ce) {
                var Rr = qr(ce, Br()), yi = Ye(), qi = Ye();
                Da(ce.initializer), n(Rr, F2), F2 = Rr, pe(ce.condition, yi, qi), F2 = yr(yi), or(ce.statement, qi, Rr), Da(ce.incrementor), n(Rr, F2), F2 = yr(qi);
              }
              function Xi(ce) {
                var Rr = qr(ce, Br()), yi = Ye();
                Da(ce.expression), n(Rr, F2), F2 = Rr, ce.kind === 244 && Da(ce.awaitModifier), n(yi, F2), Da(ce.initializer), ce.initializer.kind !== 255 && Wr(ce.initializer), or(ce.statement, yi, Rr), n(Rr, F2), F2 = yr(yi);
              }
              function et(ce) {
                var Rr = Ye(), yi = Ye(), qi = Ye();
                pe(ce.expression, Rr, yi), F2 = yr(Rr), Da(ce.thenStatement), n(qi, F2), F2 = yr(yi), Da(ce.elseStatement), n(qi, F2), F2 = yr(qi);
              }
              function Gi(ce) {
                Da(ce.expression), ce.kind === 247 && (k = true, $ && n($, F2)), F2 = d;
              }
              function Wt(ce) {
                for (var Rr = P; Rr; Rr = Rr.next)
                  if (Rr.name === ce)
                    return Rr;
              }
              function Zt(ce, Rr, yi) {
                var qi = ce.kind === 246 ? Rr : yi;
                qi && (n(qi, F2), F2 = d);
              }
              function _r(ce) {
                if (Da(ce.label), ce.label) {
                  var Rr = Wt(ce.label.escapedText);
                  Rr && (Rr.referenced = true, Zt(ce, Rr.breakTarget, Rr.continueTarget));
                } else
                  Zt(ce, x2, X);
              }
              function pi(ce) {
                var Rr = $, yi = V, qi = Ye(), je = Ye(), Hr = Ye();
                if (ce.finallyBlock && ($ = je), n(Hr, F2), V = Hr, Da(ce.tryBlock), n(qi, F2), ce.catchClause && (F2 = yr(Hr), Hr = Ye(), n(Hr, F2), V = Hr, Da(ce.catchClause), n(qi, F2)), $ = Rr, V = yi, ce.finallyBlock) {
                  var pt = Ye();
                  pt.antecedents = e2.concatenate(e2.concatenate(qi.antecedents, Hr.antecedents), je.antecedents), F2 = pt, Da(ce.finallyBlock), F2.flags & 1 ? F2 = d : ($ && je.antecedents && n($, Er(pt, je.antecedents, F2)), V && Hr.antecedents && n(V, Er(pt, Hr.antecedents, F2)), F2 = qi.antecedents ? Er(pt, qi.antecedents, F2) : d);
                } else
                  F2 = yr(qi);
              }
              function ae(ce) {
                var Rr = Ye();
                Da(ce.expression);
                var yi = x2, qi = L;
                x2 = Rr, L = F2, Da(ce.caseBlock), n(Rr, F2);
                var je = e2.forEach(ce.caseBlock.clauses, function(Hr) {
                  return Hr.kind === 290;
                });
                ce.possiblyExhaustive = !je && !Rr.antecedents, je || n(Rr, be(L, ce, 0, 0)), x2 = yi, L = qi, F2 = yr(Rr);
              }
              function Xe(ce) {
                for (var Rr = ce.clauses, yi = we(ce.parent.expression), qi = d, je = 0; je < Rr.length; je++) {
                  for (var Hr = je; !Rr[je].statements.length && je + 1 < Rr.length; )
                    Da(Rr[je]), je++;
                  var pt = Ye();
                  n(pt, yi ? be(L, ce.parent, Hr, je + 1) : L), n(pt, qi), F2 = yr(pt);
                  var Pt = Rr[je];
                  Da(Pt), qi = F2, !(F2.flags & 1) && je !== Rr.length - 1 && se.noFallthroughCasesInSwitch && (Pt.fallthroughFlowNode = F2);
                }
              }
              function Jr(ce) {
                var Rr = F2;
                F2 = L, Da(ce.expression), F2 = Rr, rr(ce.statements);
              }
              function ti(ce) {
                Da(ce.expression), Ze(ce.expression);
              }
              function Ze(ce) {
                if (ce.kind === 208) {
                  var Rr = ce;
                  Rr.expression.kind !== 106 && e2.isDottedName(Rr.expression) && (F2 = ur(F2, Rr));
                }
              }
              function Sr(ce) {
                var Rr = Ye();
                P = { next: P, name: ce.label.escapedText, breakTarget: Rr, continueTarget: void 0, referenced: false }, Da(ce.label), Da(ce.statement), !P.referenced && !se.allowUnusedLabels && Pn(e2.unusedLabelIsError(se), ce.label, e2.Diagnostics.Unused_label), P = P.next, n(Rr, F2), F2 = yr(Rr);
              }
              function zr(ce) {
                ce.kind === 221 && ce.operatorToken.kind === 63 ? Wr(ce.left) : Wr(ce);
              }
              function Wr(ce) {
                if (de(ce))
                  F2 = Ge(16, F2, ce);
                else if (ce.kind === 204)
                  for (var Rr = 0, yi = ce.elements; Rr < yi.length; Rr++) {
                    var qi = yi[Rr];
                    qi.kind === 225 ? Wr(qi.expression) : zr(qi);
                  }
                else if (ce.kind === 205)
                  for (var je = 0, Hr = ce.properties; je < Hr.length; je++) {
                    var pt = Hr[je];
                    pt.kind === 296 ? zr(pt.initializer) : pt.kind === 297 ? Wr(pt.name) : pt.kind === 298 && Wr(pt.expression);
                  }
              }
              function Je(ce, Rr, yi) {
                var qi = Ye();
                ce.operatorToken.kind === 55 || ce.operatorToken.kind === 76 ? pe(ce.left, qi, yi) : pe(ce.left, Rr, qi), F2 = yr(qi), Da(ce.operatorToken), e2.isLogicalOrCoalescingAssignmentOperator(ce.operatorToken.kind) ? (mi(Da, ce.right, Rr, yi), Wr(ce.left), n(Rr, lr(32, F2, ce)), n(yi, lr(64, F2, ce))) : pe(ce.right, Rr, yi);
              }
              function xe(ce) {
                if (ce.operator === 53) {
                  var Rr = A2;
                  A2 = y, y = Rr, Ie(ce), y = A2, A2 = Rr;
                } else
                  Ie(ce), (ce.operator === 45 || ce.operator === 46) && Wr(ce.operand);
              }
              function vr(ce) {
                Ie(ce), (ce.operator === 45 || ce.operator === 46) && Wr(ce.operand);
              }
              function mr(ce) {
                j ? (j = false, Da(ce.operatorToken), Da(ce.right), j = true, Da(ce.left)) : (j = true, Da(ce.left), j = false, Da(ce.operatorToken), Da(ce.right)), Wr(ce.left);
              }
              function Ar() {
                return e2.createBinaryExpressionTrampoline(ce, Rr, yi, qi, je, void 0);
                function ce(pt, Pt) {
                  if (Pt) {
                    Pt.stackIndex++, e2.setParent(pt, ie);
                    var ga = U;
                    Wn(pt);
                    var ua = ie;
                    ie = pt, Pt.skip = false, Pt.inStrictModeStack[Pt.stackIndex] = ga, Pt.parentStack[Pt.stackIndex] = ua;
                  } else
                    Pt = { stackIndex: 0, skip: false, inStrictModeStack: [void 0], parentStack: [void 0] };
                  var Xn = pt.operatorToken.kind;
                  if (Xn === 55 || Xn === 56 || Xn === 60 || e2.isLogicalOrCoalescingAssignmentOperator(Xn)) {
                    if (ii(pt)) {
                      var jr = Ye();
                      Je(pt, jr, jr), F2 = yr(jr);
                    } else
                      Je(pt, A2, y);
                    Pt.skip = true;
                  }
                  return Pt;
                }
                function Rr(pt, Pt, ga) {
                  if (!Pt.skip) {
                    var ua = Hr(pt);
                    return ga.operatorToken.kind === 27 && Ze(pt), ua;
                  }
                }
                function yi(pt, Pt, ga) {
                  Pt.skip || Da(pt);
                }
                function qi(pt, Pt, ga) {
                  if (!Pt.skip) {
                    var ua = Hr(pt);
                    return ga.operatorToken.kind === 27 && Ze(pt), ua;
                  }
                }
                function je(pt, Pt) {
                  if (!Pt.skip) {
                    var ga = pt.operatorToken.kind;
                    if (e2.isAssignmentOperator(ga) && !e2.isAssignmentTarget(pt) && (Wr(pt.left), ga === 63 && pt.left.kind === 207)) {
                      var ua = pt.left;
                      Cr(ua.expression) && (F2 = Ge(256, F2, pt));
                    }
                  }
                  var Xn = Pt.inStrictModeStack[Pt.stackIndex], jr = Pt.parentStack[Pt.stackIndex];
                  Xn !== void 0 && (U = Xn), jr !== void 0 && (ie = jr), Pt.skip = false, Pt.stackIndex--;
                }
                function Hr(pt) {
                  if (pt && e2.isBinaryExpression(pt) && !e2.isDestructuringAssignment(pt))
                    return pt;
                  Da(pt);
                }
              }
              function Oe(ce) {
                Ie(ce), ce.expression.kind === 206 && Wr(ce.expression);
              }
              function nr(ce) {
                var Rr = Ye(), yi = Ye(), qi = Ye();
                pe(ce.condition, Rr, yi), F2 = yr(Rr), Da(ce.questionToken), Da(ce.whenTrue), n(qi, F2), F2 = yr(yi), Da(ce.colonToken), Da(ce.whenFalse), n(qi, F2), F2 = yr(qi);
              }
              function Mr(ce) {
                var Rr = e2.isOmittedExpression(ce) ? void 0 : ce.name;
                if (e2.isBindingPattern(Rr))
                  for (var yi = 0, qi = Rr.elements; yi < qi.length; yi++) {
                    var je = qi[yi];
                    Mr(je);
                  }
                else
                  F2 = Ge(16, F2, ce);
              }
              function Pe(ce) {
                Ie(ce), (ce.initializer || e2.isForInOrOfStatement(ce.parent.parent)) && Mr(ce);
              }
              function Ue(ce) {
                e2.isBindingPattern(ce.name) ? (rr(ce.decorators), rr(ce.modifiers), Da(ce.dotDotDotToken), Da(ce.propertyName), Da(ce.initializer), Da(ce.name)) : Ie(ce);
              }
              function fr(ce) {
                Da(ce.tagName), ce.kind !== 339 && ce.fullName && (e2.setParent(ce.fullName, ce), e2.setParentRecursive(ce.fullName, false)), typeof ce.comment != "string" && rr(ce.comment);
              }
              function De(ce) {
                Ie(ce);
                var Rr = e2.getHostSignatureFromJSDoc(ce);
                Rr && Rr.kind !== 169 && Fe(Rr.symbol, Rr, 32);
              }
              function gr(ce, Rr, yi) {
                mi(Da, ce, Rr, yi), (!e2.isOptionalChain(ce) || e2.isOutermostOptionalChain(ce)) && (n(Rr, lr(32, F2, ce)), n(yi, lr(64, F2, ce)));
              }
              function Vr(ce) {
                switch (ce.kind) {
                  case 206:
                    Da(ce.questionDotToken), Da(ce.name);
                    break;
                  case 207:
                    Da(ce.questionDotToken), Da(ce.argumentExpression);
                    break;
                  case 208:
                    Da(ce.questionDotToken), rr(ce.typeArguments), rr(ce.arguments);
                    break;
                }
              }
              function Tr(ce, Rr, yi) {
                var qi = e2.isOptionalChainRoot(ce) ? Ye() : void 0;
                gr(ce.expression, qi || Rr, yi), qi && (F2 = yr(qi)), mi(Vr, ce, Rr, yi), e2.isOutermostOptionalChain(ce) && (n(Rr, lr(32, F2, ce)), n(yi, lr(64, F2, ce)));
              }
              function vi(ce) {
                if (ii(ce)) {
                  var Rr = Ye();
                  Tr(ce, Rr, Rr), F2 = yr(Rr);
                } else
                  Tr(ce, A2, y);
              }
              function Ui(ce) {
                e2.isOptionalChain(ce) ? vi(ce) : Ie(ce);
              }
              function Yi(ce) {
                e2.isOptionalChain(ce) ? vi(ce) : Ie(ce);
              }
              function Wi(ce) {
                if (e2.isOptionalChain(ce))
                  vi(ce);
                else {
                  var Rr = e2.skipParentheses(ce.expression);
                  Rr.kind === 213 || Rr.kind === 214 ? (rr(ce.typeArguments), rr(ce.arguments), Da(ce.expression)) : (Ie(ce), ce.expression.kind === 106 && (F2 = ur(F2, ce)));
                }
                if (ce.expression.kind === 206) {
                  var yi = ce.expression;
                  e2.isIdentifier(yi.name) && Cr(yi.expression) && e2.isPushOrUnshiftIdentifier(yi.name) && (F2 = Ge(256, F2, ce));
                }
              }
              function ct(ce) {
                switch (ce.kind) {
                  case 226:
                  case 257:
                  case 260:
                  case 205:
                  case 182:
                  case 322:
                  case 286:
                    return 1;
                  case 258:
                    return 65;
                  case 261:
                  case 259:
                  case 195:
                  case 176:
                    return 33;
                  case 305:
                    return 37;
                  case 172:
                  case 173:
                  case 169:
                    if (e2.isObjectLiteralOrClassExpressionMethodOrAccessor(ce))
                      return 173;
                  case 171:
                  case 256:
                  case 168:
                  case 174:
                  case 323:
                  case 317:
                  case 179:
                  case 175:
                  case 180:
                  case 170:
                    return 45;
                  case 213:
                  case 214:
                    return 61;
                  case 262:
                    return 4;
                  case 167:
                    return ce.initializer ? 4 : 0;
                  case 292:
                  case 242:
                  case 243:
                  case 244:
                  case 263:
                    return 2;
                  case 235:
                    return e2.isFunctionLike(ce.parent) || e2.isClassStaticBlockDeclaration(ce.parent) ? 0 : 2;
                }
                return 0;
              }
              function Li(ce) {
                ve && (ve.nextContainer = ce), ve = ce;
              }
              function nt(ce, Rr, yi) {
                switch (R.kind) {
                  case 261:
                    return Re(ce, Rr, yi);
                  case 305:
                    return xt(ce, Rr, yi);
                  case 226:
                  case 257:
                    return Mt(ce, Rr, yi);
                  case 260:
                    return ge(R.symbol.exports, R.symbol, ce, Rr, yi);
                  case 182:
                  case 322:
                  case 205:
                  case 258:
                  case 286:
                    return ge(R.symbol.members, R.symbol, ce, Rr, yi);
                  case 179:
                  case 180:
                  case 174:
                  case 175:
                  case 323:
                  case 176:
                  case 169:
                  case 168:
                  case 171:
                  case 172:
                  case 173:
                  case 256:
                  case 213:
                  case 214:
                  case 317:
                  case 345:
                  case 338:
                  case 170:
                  case 259:
                  case 195:
                    return ge(R.locals, void 0, ce, Rr, yi);
                }
              }
              function Mt(ce, Rr, yi) {
                return e2.isStatic(ce) ? ge(R.symbol.exports, R.symbol, ce, Rr, yi) : ge(R.symbol.members, R.symbol, ce, Rr, yi);
              }
              function xt(ce, Rr, yi) {
                return e2.isExternalModule(b) ? Re(ce, Rr, yi) : ge(b.locals, void 0, ce, Rr, yi);
              }
              function ut(ce) {
                var Rr = e2.isSourceFile(ce) ? ce : e2.tryCast(ce.body, e2.isModuleBlock);
                return !!Rr && Rr.statements.some(function(yi) {
                  return e2.isExportDeclaration(yi) || e2.isExportAssignment(yi);
                });
              }
              function Dt(ce) {
                ce.flags & 16777216 && !ut(ce) ? ce.flags |= 64 : ce.flags &= -65;
              }
              function Rt(ce) {
                if (Dt(ce), e2.isAmbientModule(ce))
                  if (e2.hasSyntacticModifier(ce, 1) && Kn(ce, e2.Diagnostics.export_modifier_cannot_be_applied_to_ambient_modules_and_module_augmentations_since_they_are_always_visible), e2.isModuleAugmentationExternal(ce))
                    Ii(ce);
                  else {
                    var Rr = void 0;
                    if (ce.name.kind === 10) {
                      var yi = ce.name.text;
                      Rr = e2.tryParsePattern(yi), Rr === void 0 && Kn(ce.name, e2.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, yi);
                    }
                    var qi = nt(ce, 512, 110735);
                    b.patternAmbientModules = e2.append(b.patternAmbientModules, Rr && !e2.isString(Rr) ? { pattern: Rr, symbol: qi } : void 0);
                  }
                else {
                  var je = Ii(ce);
                  if (je !== 0) {
                    var qi = ce.symbol;
                    qi.constEnumOnlyModule = !(qi.flags & 304) && je === 2 && qi.constEnumOnlyModule !== false;
                  }
                }
              }
              function Ii(ce) {
                var Rr = C(ce), yi = Rr !== 0;
                return nt(ce, yi ? 512 : 1024, yi ? 110735 : 0), Rr;
              }
              function Ki(ce) {
                var Rr = We(131072, Z2(ce));
                Fe(Rr, ce, 131072);
                var yi = We(2048, "__type");
                Fe(yi, ce, 2048), yi.members = e2.createSymbolTable(), yi.members.set(Rr.escapedName, Rr);
              }
              function Fi(ce) {
                var Rr;
                if (function(ua) {
                  ua[ua.Property = 1] = "Property", ua[ua.Accessor = 2] = "Accessor";
                }(Rr || (Rr = {})), U && !e2.isAssignmentTarget(ce))
                  for (var yi = new e2.Map(), qi = 0, je = ce.properties; qi < je.length; qi++) {
                    var Hr = je[qi];
                    if (!(Hr.kind === 298 || Hr.name.kind !== 79)) {
                      var pt = Hr.name, Pt = Hr.kind === 296 || Hr.kind === 297 || Hr.kind === 169 ? 1 : 2, ga = yi.get(pt.escapedText);
                      if (!ga) {
                        yi.set(pt.escapedText, Pt);
                        continue;
                      }
                    }
                  }
                return wt(ce, 4096, "__object");
              }
              function ui(ce) {
                return wt(ce, 4096, "__jsxAttributes");
              }
              function Bt(ce, Rr, yi) {
                return nt(ce, Rr, yi);
              }
              function wt(ce, Rr, yi) {
                var qi = We(Rr, yi);
                return Rr & 106508 && (qi.parent = R.symbol), Fe(qi, ce, Rr), qi;
              }
              function na(ce, Rr, yi) {
                switch (O.kind) {
                  case 261:
                    Re(ce, Rr, yi);
                    break;
                  case 305:
                    if (e2.isExternalOrCommonJsModule(R)) {
                      Re(ce, Rr, yi);
                      break;
                    }
                  default:
                    O.locals || (O.locals = e2.createSymbolTable(), Li(O)), ge(O.locals, void 0, ce, Rr, yi);
                }
              }
              function Ai() {
                if (!!ee) {
                  for (var ce = R, Rr = ve, yi = O, qi = ie, je = F2, Hr = 0, pt = ee; Hr < pt.length; Hr++) {
                    var Pt = pt[Hr], ga = Pt.parent.parent;
                    R = e2.findAncestor(ga.parent, function(fo) {
                      return !!(ct(fo) & 1);
                    }) || b, O = e2.getEnclosingBlockScopeContainer(ga) || b, F2 = le({ flags: 2 }), ie = Pt, Da(Pt.typeExpression);
                    var ua = e2.getNameOfDeclaration(Pt);
                    if ((e2.isJSDocEnumTag(Pt) || !Pt.fullName) && ua && e2.isPropertyAccessEntityNameExpression(ua.parent)) {
                      var Xn = Wa(ua.parent);
                      if (Xn) {
                        sa(b.symbol, ua.parent, Xn, !!e2.findAncestor(ua, function(fo) {
                          return e2.isPropertyAccessExpression(fo) && fo.name.escapedText === "prototype";
                        }), false);
                        var jr = R;
                        switch (e2.getAssignmentDeclarationPropertyAccessKind(ua.parent)) {
                          case 1:
                          case 2:
                            e2.isExternalOrCommonJsModule(b) ? R = b : R = void 0;
                            break;
                          case 4:
                            R = ua.parent.expression;
                            break;
                          case 3:
                            R = ua.parent.expression.name;
                            break;
                          case 5:
                            R = T(b, ua.parent.expression) ? b : e2.isPropertyAccessExpression(ua.parent.expression) ? ua.parent.expression.name : ua.parent.expression;
                            break;
                          case 0:
                            return e2.Debug.fail("Shouldn't have detected typedef or enum on non-assignment declaration");
                        }
                        R && Re(Pt, 524288, 788968), R = jr;
                      }
                    } else
                      e2.isJSDocEnumTag(Pt) || !Pt.fullName || Pt.fullName.kind === 79 ? (ie = Pt.parent, na(Pt, 524288, 788968)) : Da(Pt.fullName);
                  }
                  R = ce, ve = Rr, O = yi, ie = qi, F2 = je;
                }
              }
              function Oi(ce) {
                !b.parseDiagnostics.length && !(ce.flags & 16777216) && !(ce.flags & 8388608) && !e2.isIdentifierName(ce) && (U && ce.originalKeywordKind >= 117 && ce.originalKeywordKind <= 125 ? b.bindDiagnostics.push(g(ce, ji(ce), e2.declarationNameToString(ce))) : ce.originalKeywordKind === 132 ? e2.isExternalModule(b) && e2.isInTopLevelContext(ce) ? b.bindDiagnostics.push(g(ce, e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module, e2.declarationNameToString(ce))) : ce.flags & 32768 && b.bindDiagnostics.push(g(ce, e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, e2.declarationNameToString(ce))) : ce.originalKeywordKind === 125 && ce.flags & 8192 && b.bindDiagnostics.push(g(ce, e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here, e2.declarationNameToString(ce))));
              }
              function ji(ce) {
                return e2.getContainingClass(ce) ? e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Class_definitions_are_automatically_in_strict_mode : b.externalModuleIndicator ? e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode : e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode;
              }
              function Vi(ce) {
                ce.escapedText === "#constructor" && (b.parseDiagnostics.length || b.bindDiagnostics.push(g(ce, e2.Diagnostics.constructor_is_a_reserved_word, e2.declarationNameToString(ce))));
              }
              function at(ce) {
                U && e2.isLeftHandSideExpression(ce.left) && e2.isAssignmentOperator(ce.operatorToken.kind) && Qa(ce, ce.left);
              }
              function At(ce) {
                U && ce.variableDeclaration && Qa(ce, ce.variableDeclaration.name);
              }
              function ba(ce) {
                if (U && ce.expression.kind === 79) {
                  var Rr = e2.getErrorSpanForNode(b, ce.expression);
                  b.bindDiagnostics.push(e2.createFileDiagnostic(b, Rr.start, Rr.length, e2.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode));
                }
              }
              function $a(ce) {
                return e2.isIdentifier(ce) && (ce.escapedText === "eval" || ce.escapedText === "arguments");
              }
              function Qa(ce, Rr) {
                if (Rr && Rr.kind === 79) {
                  var yi = Rr;
                  if ($a(yi)) {
                    var qi = e2.getErrorSpanForNode(b, Rr);
                    b.bindDiagnostics.push(e2.createFileDiagnostic(b, qi.start, qi.length, ai(ce), e2.idText(yi)));
                  }
                }
              }
              function ai(ce) {
                return e2.getContainingClass(ce) ? e2.Diagnostics.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode : b.externalModuleIndicator ? e2.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode : e2.Diagnostics.Invalid_use_of_0_in_strict_mode;
              }
              function Dn(ce) {
                U && Qa(ce, ce.name);
              }
              function ka(ce) {
                return e2.getContainingClass(ce) ? e2.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Class_definitions_are_automatically_in_strict_mode : b.externalModuleIndicator ? e2.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5_Modules_are_automatically_in_strict_mode : e2.Diagnostics.Function_declarations_are_not_allowed_inside_blocks_in_strict_mode_when_targeting_ES3_or_ES5;
              }
              function Ba(ce) {
                if (J < 2 && O.kind !== 305 && O.kind !== 261 && !e2.isFunctionLikeOrClassStaticBlockDeclaration(O)) {
                  var Rr = e2.getErrorSpanForNode(b, ce);
                  b.bindDiagnostics.push(e2.createFileDiagnostic(b, Rr.start, Rr.length, ka(ce)));
                }
              }
              function pn(ce) {
                J < 1 && U && ce.numericLiteralFlags & 32 && b.bindDiagnostics.push(g(ce, e2.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode));
              }
              function Cn(ce) {
                U && Qa(ce, ce.operand);
              }
              function Bi(ce) {
                U && (ce.operator === 45 || ce.operator === 46) && Qa(ce, ce.operand);
              }
              function kn(ce) {
                U && Kn(ce, e2.Diagnostics.with_statements_are_not_allowed_in_strict_mode);
              }
              function xn(ce) {
                U && e2.getEmitScriptTarget(se) >= 2 && (e2.isDeclarationStatement(ce.statement) || e2.isVariableStatement(ce.statement)) && Kn(ce.label, e2.Diagnostics.A_label_is_not_allowed_here);
              }
              function Kn(ce, Rr, yi, qi, je) {
                var Hr = e2.getSpanOfTokenAtPosition(b, ce.pos);
                b.bindDiagnostics.push(e2.createFileDiagnostic(b, Hr.start, Hr.length, Rr, yi, qi, je));
              }
              function Pn(ce, Rr, yi) {
                eo(ce, Rr, Rr, yi);
              }
              function eo(ce, Rr, yi, qi) {
                Rn(ce, { pos: e2.getTokenPosOfNode(Rr, b), end: yi.end }, qi);
              }
              function Rn(ce, Rr, yi) {
                var qi = e2.createFileDiagnostic(b, Rr.pos, Rr.end - Rr.pos, yi);
                ce ? b.bindDiagnostics.push(qi) : b.bindSuggestionDiagnostics = e2.append(b.bindSuggestionDiagnostics, Ke(Ke({}, qi), { category: e2.DiagnosticCategory.Suggestion }));
              }
              function Da(ce) {
                if (!!ce) {
                  e2.setParent(ce, ie), e2.tracing && (ce.tracingPath = b.path);
                  var Rr = U;
                  if (Wn(ce), ce.kind > 160) {
                    var yi = ie;
                    ie = ce;
                    var qi = ct(ce);
                    qi === 0 ? _e(ce) : Ee(ce, qi), ie = yi;
                  } else {
                    var yi = ie;
                    ce.kind === 1 && (ie = ce), bo(ce), ie = yi;
                  }
                  U = Rr;
                }
              }
              function bo(ce) {
                if (e2.hasJSDocNodes(ce))
                  if (e2.isInJSFile(ce))
                    for (var Rr = 0, yi = ce.jsDoc; Rr < yi.length; Rr++) {
                      var qi = yi[Rr];
                      Da(qi);
                    }
                  else
                    for (var je = 0, Hr = ce.jsDoc; je < Hr.length; je++) {
                      var qi = Hr[je];
                      e2.setParent(qi, ce), e2.setParentRecursive(qi, false);
                    }
              }
              function Ro(ce) {
                if (!U)
                  for (var Rr = 0, yi = ce; Rr < yi.length; Rr++) {
                    var qi = yi[Rr];
                    if (!e2.isPrologueDirective(qi))
                      return;
                    if (En(qi)) {
                      U = true;
                      return;
                    }
                  }
              }
              function En(ce) {
                var Rr = e2.getSourceTextOfNodeFromSourceFile(b, ce.expression);
                return Rr === '"use strict"' || Rr === "'use strict'";
              }
              function Wn(ce) {
                switch (ce.kind) {
                  case 79:
                    if (ce.isInJSDocNamespace) {
                      for (var Rr = ce.parent; Rr && !e2.isJSDocTypeAlias(Rr); )
                        Rr = Rr.parent;
                      na(Rr, 524288, 788968);
                      break;
                    }
                  case 108:
                    return F2 && (e2.isExpression(ce) || ie.kind === 297) && (ce.flowNode = F2), Oi(ce);
                  case 161:
                    F2 && e2.isPartOfTypeQuery(ce) && (ce.flowNode = F2);
                    break;
                  case 231:
                  case 106:
                    ce.flowNode = F2;
                    break;
                  case 80:
                    return Vi(ce);
                  case 206:
                  case 207:
                    var yi = ce;
                    F2 && de(yi) && (yi.flowNode = F2), e2.isSpecialPropertyDeclaration(yi) && qe(yi), e2.isInJSFile(yi) && b.commonJsModuleIndicator && e2.isModuleExportsAccessExpression(yi) && !K(O, "module") && ge(b.locals, void 0, yi.expression, 134217729, 111550);
                    break;
                  case 221:
                    var qi = e2.getAssignmentDeclarationKind(ce);
                    switch (qi) {
                      case 1:
                        dn(ce);
                        break;
                      case 2:
                        Jn(ce);
                        break;
                      case 3:
                        Si(ce.left, ce);
                        break;
                      case 6:
                        br(ce);
                        break;
                      case 4:
                        Gr(ce);
                        break;
                      case 5:
                        var je = ce.left.expression;
                        if (e2.isInJSFile(ce) && e2.isIdentifier(je)) {
                          var Hr = K(O, je.escapedText);
                          if (e2.isThisInitializedDeclaration(Hr == null ? void 0 : Hr.valueDeclaration)) {
                            Gr(ce);
                            break;
                          }
                        }
                        Qi(ce);
                        break;
                      case 0:
                        break;
                      default:
                        e2.Debug.fail("Unknown binary expression special property assignment kind");
                    }
                    return at(ce);
                  case 292:
                    return At(ce);
                  case 215:
                    return ba(ce);
                  case 8:
                    return pn(ce);
                  case 220:
                    return Cn(ce);
                  case 219:
                    return Bi(ce);
                  case 248:
                    return kn(ce);
                  case 250:
                    return xn(ce);
                  case 192:
                    he = true;
                    return;
                  case 177:
                    break;
                  case 163:
                    return js(ce);
                  case 164:
                    return pc(ce);
                  case 254:
                    return Xs(ce);
                  case 203:
                    return ce.flowNode = F2, Xs(ce);
                  case 167:
                  case 166:
                    return to(ce);
                  case 296:
                  case 297:
                    return ps(ce, 4, 0);
                  case 299:
                    return ps(ce, 8, 900095);
                  case 174:
                  case 175:
                  case 176:
                    return nt(ce, 131072, 0);
                  case 169:
                  case 168:
                    return ps(ce, 8192 | (ce.questionToken ? 16777216 : 0), e2.isObjectLiteralMethod(ce) ? 0 : 103359);
                  case 256:
                    return hs(ce);
                  case 171:
                    return nt(ce, 16384, 0);
                  case 172:
                    return ps(ce, 32768, 46015);
                  case 173:
                    return ps(ce, 65536, 78783);
                  case 179:
                  case 317:
                  case 323:
                  case 180:
                    return Ki(ce);
                  case 182:
                  case 322:
                  case 195:
                    return Co(ce);
                  case 332:
                    return De(ce);
                  case 205:
                    return Fi(ce);
                  case 213:
                  case 214:
                    return tc(ce);
                  case 208:
                    var pt = e2.getAssignmentDeclarationKind(ce);
                    switch (pt) {
                      case 7:
                        return Pi(ce);
                      case 8:
                        return pa(ce);
                      case 9:
                        return Zr(ce);
                      case 0:
                        break;
                      default:
                        return e2.Debug.fail("Unknown call expression assignment declaration kind");
                    }
                    e2.isInJSFile(ce) && Pc(ce);
                    break;
                  case 226:
                  case 257:
                    return U = true, Vc(ce);
                  case 258:
                    return na(ce, 64, 788872);
                  case 259:
                    return na(ce, 524288, 788968);
                  case 260:
                    return Kc(ce);
                  case 261:
                    return Rt(ce);
                  case 286:
                    return ui(ce);
                  case 285:
                    return Bt(ce, 4, 0);
                  case 265:
                  case 268:
                  case 270:
                  case 275:
                    return nt(ce, 2097152, 2097152);
                  case 264:
                    return $o(ce);
                  case 267:
                    return xi(ce);
                  case 272:
                    return Pr(ce);
                  case 271:
                    return no(ce);
                  case 305:
                    return Ro(ce.statements), Ko();
                  case 235:
                    if (!e2.isFunctionLikeOrClassStaticBlockDeclaration(ce.parent))
                      return;
                  case 262:
                    return Ro(ce.statements);
                  case 340:
                    if (ce.parent.kind === 323)
                      return pc(ce);
                    if (ce.parent.kind !== 322)
                      break;
                  case 347:
                    var Pt = ce, ga = Pt.isBracketed || Pt.typeExpression && Pt.typeExpression.type.kind === 316 ? 16777220 : 4;
                    return nt(Pt, ga, 0);
                  case 345:
                  case 338:
                  case 339:
                    return (ee || (ee = [])).push(ce);
                }
              }
              function to(ce) {
                return ps(ce, 4 | (ce.questionToken ? 16777216 : 0), 0);
              }
              function Co(ce) {
                return wt(ce, 2048, "__type");
              }
              function Ko() {
                if (Dt(b), e2.isExternalModule(b))
                  Oo();
                else if (e2.isJsonSourceFile(b)) {
                  Oo();
                  var ce = b.symbol;
                  ge(b.symbol.exports, b.symbol, b, 4, 67108863), b.symbol = ce;
                }
              }
              function Oo() {
                wt(b, 512, '"'.concat(e2.removeFileExtension(b.fileName), '"'));
              }
              function no(ce) {
                if (!R.symbol || !R.symbol.exports)
                  wt(ce, 111551, Z2(ce));
                else {
                  var Rr = e2.exportAssignmentIsAlias(ce) ? 2097152 : 4, yi = ge(R.symbol.exports, R.symbol, ce, Rr, 67108863);
                  ce.isExportEquals && e2.setValueDeclaration(yi, ce);
                }
              }
              function $o(ce) {
                ce.modifiers && ce.modifiers.length && b.bindDiagnostics.push(g(ce, e2.Diagnostics.Modifiers_cannot_appear_here));
                var Rr = e2.isSourceFile(ce.parent) ? e2.isExternalModule(ce.parent) ? ce.parent.isDeclarationFile ? void 0 : e2.Diagnostics.Global_module_exports_may_only_appear_in_declaration_files : e2.Diagnostics.Global_module_exports_may_only_appear_in_module_files : e2.Diagnostics.Global_module_exports_may_only_appear_at_top_level;
                Rr ? b.bindDiagnostics.push(g(ce, Rr)) : (b.symbol.globalExports = b.symbol.globalExports || e2.createSymbolTable(), ge(b.symbol.globalExports, b.symbol, ce, 2097152, 2097152));
              }
              function Pr(ce) {
                !R.symbol || !R.symbol.exports ? wt(ce, 8388608, Z2(ce)) : ce.exportClause ? e2.isNamespaceExport(ce.exportClause) && (e2.setParent(ce.exportClause, ce), ge(R.symbol.exports, R.symbol, ce.exportClause, 2097152, 2097152)) : ge(R.symbol.exports, R.symbol, ce, 8388608, 0);
              }
              function xi(ce) {
                ce.name && nt(ce, 2097152, 2097152);
              }
              function St(ce) {
                return b.externalModuleIndicator ? false : (b.commonJsModuleIndicator || (b.commonJsModuleIndicator = ce, Oo()), true);
              }
              function pa(ce) {
                if (!!St(ce)) {
                  var Rr = ys(ce.arguments[0], void 0, function(qi, je) {
                    return je && Fe(je, qi, 67110400), je;
                  });
                  if (Rr) {
                    var yi = 1048580;
                    ge(Rr.exports, Rr, ce, yi, 0);
                  }
                }
              }
              function dn(ce) {
                if (!!St(ce)) {
                  var Rr = ys(ce.left.expression, void 0, function(je, Hr) {
                    return Hr && Fe(Hr, je, 67110400), Hr;
                  });
                  if (Rr) {
                    var yi = e2.isAliasableExpression(ce.right) && (e2.isExportsIdentifier(ce.left.expression) || e2.isModuleExportsAccessExpression(ce.left.expression)), qi = yi ? 2097152 : 1048580;
                    e2.setParent(ce.left, ce), ge(Rr.exports, Rr, ce.left, qi, 0);
                  }
                }
              }
              function Jn(ce) {
                if (!!St(ce)) {
                  var Rr = e2.getRightMostAssignedExpression(ce.right);
                  if (!(e2.isEmptyObjectLiteral(Rr) || R === b && T(b, Rr))) {
                    if (e2.isObjectLiteralExpression(Rr) && e2.every(Rr.properties, e2.isShorthandPropertyAssignment)) {
                      e2.forEach(Rr.properties, Qe);
                      return;
                    }
                    var yi = e2.exportAssignmentIsAlias(ce) ? 2097152 : 1049092, qi = ge(b.symbol.exports, b.symbol, ce, yi | 67108864, 0);
                    e2.setValueDeclaration(qi, ce);
                  }
                }
              }
              function Qe(ce) {
                ge(b.symbol.exports, b.symbol, ce, 69206016, 0);
              }
              function Gr(ce) {
                e2.Debug.assert(e2.isInJSFile(ce));
                var Rr = e2.isBinaryExpression(ce) && e2.isPropertyAccessExpression(ce.left) && e2.isPrivateIdentifier(ce.left.name) || e2.isPropertyAccessExpression(ce) && e2.isPrivateIdentifier(ce.name);
                if (!Rr) {
                  var yi = e2.getThisContainer(ce, false);
                  switch (yi.kind) {
                    case 256:
                    case 213:
                      var qi = yi.symbol;
                      if (e2.isBinaryExpression(yi.parent) && yi.parent.operatorToken.kind === 63) {
                        var je = yi.parent.left;
                        e2.isBindableStaticAccessExpression(je) && e2.isPrototypeAccess(je.expression) && (qi = Go(je.expression.expression, q));
                      }
                      qi && qi.valueDeclaration && (qi.members = qi.members || e2.createSymbolTable(), e2.hasDynamicName(ce) ? S2(ce, qi, qi.members) : ge(qi.members, qi, ce, 67108868, 0), Fe(qi, qi.valueDeclaration, 32));
                      break;
                    case 171:
                    case 167:
                    case 169:
                    case 172:
                    case 173:
                    case 170:
                      var Hr = yi.parent, pt = e2.isStatic(yi) ? Hr.symbol.exports : Hr.symbol.members;
                      e2.hasDynamicName(ce) ? S2(ce, Hr.symbol, pt) : ge(pt, Hr.symbol, ce, 67108868, 0, true);
                      break;
                    case 305:
                      if (e2.hasDynamicName(ce))
                        break;
                      yi.commonJsModuleIndicator ? ge(yi.symbol.exports, yi.symbol, ce, 1048580, 0) : nt(ce, 1, 111550);
                      break;
                    default:
                      e2.Debug.failBadSyntaxKind(yi);
                  }
                }
              }
              function S2(ce, Rr, yi) {
                ge(yi, Rr, ce, 4, 0, true, true), Ce(ce, Rr);
              }
              function Ce(ce, Rr) {
                Rr && (Rr.assignmentDeclarationMembers || (Rr.assignmentDeclarationMembers = new e2.Map())).set(e2.getNodeId(ce), ce);
              }
              function qe(ce) {
                ce.expression.kind === 108 ? Gr(ce) : e2.isBindableStaticAccessExpression(ce) && ce.parent.parent.kind === 305 && (e2.isPrototypeAccess(ce.expression) ? Si(ce, ce.parent) : Ct(ce));
              }
              function br(ce) {
                e2.setParent(ce.left, ce), e2.setParent(ce.right, ce), qn(ce.left.expression, ce.left, false, true);
              }
              function Zr(ce) {
                var Rr = Go(ce.arguments[0].expression);
                Rr && Rr.valueDeclaration && Fe(Rr, Rr.valueDeclaration, 32), en(ce, Rr, true);
              }
              function Si(ce, Rr) {
                var yi = ce.expression, qi = yi.expression;
                e2.setParent(qi, yi), e2.setParent(yi, ce), e2.setParent(ce, Rr), qn(qi, ce, true, true);
              }
              function Pi(ce) {
                var Rr = Go(ce.arguments[0]), yi = ce.parent.parent.kind === 305;
                Rr = sa(Rr, ce.arguments[0], yi, false, false), en(ce, Rr, false);
              }
              function Qi(ce) {
                var Rr, yi = Go(ce.left.expression, R) || Go(ce.left.expression, O);
                if (!(!e2.isInJSFile(ce) && !e2.isFunctionSymbol(yi))) {
                  var qi = e2.getLeftmostAccessExpression(ce.left);
                  if (!(e2.isIdentifier(qi) && ((Rr = K(R, qi.escapedText)) === null || Rr === void 0 ? void 0 : Rr.flags) & 2097152))
                    if (e2.setParent(ce.left, ce), e2.setParent(ce.right, ce), e2.isIdentifier(ce.left.expression) && R === b && T(b, ce.left.expression))
                      dn(ce);
                    else if (e2.hasDynamicName(ce)) {
                      wt(ce, 67108868, "__computed");
                      var je = sa(yi, ce.left.expression, Wa(ce.left), false, false);
                      Ce(ce, je);
                    } else
                      Ct(e2.cast(ce.left, e2.isBindableStaticNameExpression));
                }
              }
              function Ct(ce) {
                e2.Debug.assert(!e2.isIdentifier(ce)), e2.setParent(ce.expression, ce), qn(ce.expression, ce, false, false);
              }
              function sa(ce, Rr, yi, qi, je) {
                if ((ce == null ? void 0 : ce.flags) & 2097152)
                  return ce;
                if (yi && !qi) {
                  var Hr = 67110400, pt = 110735;
                  ce = ys(Rr, ce, function(Pt, ga, ua) {
                    if (ga)
                      return Fe(ga, Pt, Hr), ga;
                    var Xn = ua ? ua.exports : b.jsGlobalAugmentations || (b.jsGlobalAugmentations = e2.createSymbolTable());
                    return ge(Xn, ua, Pt, Hr, pt);
                  });
                }
                return je && ce && ce.valueDeclaration && Fe(ce, ce.valueDeclaration, 32), ce;
              }
              function en(ce, Rr, yi) {
                if (!(!Rr || !mo(Rr))) {
                  var qi = yi ? Rr.members || (Rr.members = e2.createSymbolTable()) : Rr.exports || (Rr.exports = e2.createSymbolTable()), je = 0, Hr = 0;
                  e2.isFunctionLikeDeclaration(e2.getAssignedExpandoInitializer(ce)) ? (je = 8192, Hr = 103359) : e2.isCallExpression(ce) && e2.isBindableObjectDefinePropertyCall(ce) && (e2.some(ce.arguments[2].properties, function(pt) {
                    var Pt = e2.getNameOfDeclaration(pt);
                    return !!Pt && e2.isIdentifier(Pt) && e2.idText(Pt) === "set";
                  }) && (je |= 65540, Hr |= 78783), e2.some(ce.arguments[2].properties, function(pt) {
                    var Pt = e2.getNameOfDeclaration(pt);
                    return !!Pt && e2.isIdentifier(Pt) && e2.idText(Pt) === "get";
                  }) && (je |= 32772, Hr |= 46015)), je === 0 && (je = 4, Hr = 0), ge(qi, Rr, ce, je | 67108864, Hr & -67108865);
                }
              }
              function Wa(ce) {
                return e2.isBinaryExpression(ce.parent) ? So(ce.parent).parent.kind === 305 : ce.parent.parent.kind === 305;
              }
              function qn(ce, Rr, yi, qi) {
                var je = Go(ce, R) || Go(ce, O), Hr = Wa(Rr);
                je = sa(je, Rr.expression, Hr, yi, qi), en(Rr, je, yi);
              }
              function mo(ce) {
                if (ce.flags & 1072)
                  return true;
                var Rr = ce.valueDeclaration;
                if (Rr && e2.isCallExpression(Rr))
                  return !!e2.getAssignedExpandoInitializer(Rr);
                var yi = Rr ? e2.isVariableDeclaration(Rr) ? Rr.initializer : e2.isBinaryExpression(Rr) ? Rr.right : e2.isPropertyAccessExpression(Rr) && e2.isBinaryExpression(Rr.parent) ? Rr.parent.right : void 0 : void 0;
                if (yi = yi && e2.getRightMostAssignedExpression(yi), yi) {
                  var qi = e2.isPrototypeAccess(e2.isVariableDeclaration(Rr) ? Rr.name : e2.isBinaryExpression(Rr) ? Rr.left : Rr);
                  return !!e2.getExpandoInitializer(e2.isBinaryExpression(yi) && (yi.operatorToken.kind === 56 || yi.operatorToken.kind === 60) ? yi.right : yi, qi);
                }
                return false;
              }
              function So(ce) {
                for (; e2.isBinaryExpression(ce.parent); )
                  ce = ce.parent;
                return ce.parent;
              }
              function Go(ce, Rr) {
                if (Rr === void 0 && (Rr = R), e2.isIdentifier(ce))
                  return K(Rr, ce.escapedText);
                var yi = Go(ce.expression);
                return yi && yi.exports && yi.exports.get(e2.getElementOrPropertyAccessName(ce));
              }
              function ys(ce, Rr, yi) {
                if (T(b, ce))
                  return b.symbol;
                if (e2.isIdentifier(ce))
                  return yi(ce, Go(ce), Rr);
                var qi = ys(ce.expression, Rr, yi), je = e2.getNameOrArgument(ce);
                return e2.isPrivateIdentifier(je) && e2.Debug.fail("unexpected PrivateIdentifier"), yi(je, qi && qi.exports && qi.exports.get(e2.getElementOrPropertyAccessName(ce)), qi);
              }
              function Pc(ce) {
                !b.commonJsModuleIndicator && e2.isRequireCall(ce, false) && St(ce);
              }
              function Vc(ce) {
                if (ce.kind === 257)
                  na(ce, 32, 899503);
                else {
                  var Rr = ce.name ? ce.name.escapedText : "__class";
                  wt(ce, 32, Rr), ce.name && l.add(ce.name.escapedText);
                }
                var yi = ce.symbol, qi = We(4194308, "prototype"), je = yi.exports.get(qi.escapedName);
                je && (ce.name && e2.setParent(ce.name, ce), b.bindDiagnostics.push(g(je.declarations[0], e2.Diagnostics.Duplicate_identifier_0, e2.symbolName(qi)))), yi.exports.set(qi.escapedName, qi), qi.parent = yi;
              }
              function Kc(ce) {
                return e2.isEnumConst(ce) ? na(ce, 128, 899967) : na(ce, 256, 899327);
              }
              function Xs(ce) {
                U && Qa(ce, ce.name), e2.isBindingPattern(ce.name) || (e2.isInJSFile(ce) && e2.isVariableDeclarationInitializedToBareOrAccessedRequire(ce) && !e2.getJSDocTypeTag(ce) && !(e2.getCombinedModifierFlags(ce) & 1) ? nt(ce, 2097152, 2097152) : e2.isBlockOrCatchScoped(ce) ? na(ce, 2, 111551) : e2.isParameterDeclaration(ce) ? nt(ce, 1, 111551) : nt(ce, 1, 111550));
              }
              function pc(ce) {
                if (!(ce.kind === 340 && R.kind !== 323) && (U && !(ce.flags & 16777216) && Qa(ce, ce.name), e2.isBindingPattern(ce.name) ? wt(ce, 1, "__" + ce.parent.parameters.indexOf(ce)) : nt(ce, 1, 111551), e2.isParameterPropertyDeclaration(ce, ce.parent))) {
                  var Rr = ce.parent.parent;
                  ge(Rr.symbol.members, Rr.symbol, ce, 4 | (ce.questionToken ? 16777216 : 0), 0);
                }
              }
              function hs(ce) {
                !b.isDeclarationFile && !(ce.flags & 16777216) && e2.isAsyncFunction(ce) && (Y |= 2048), Dn(ce), U ? (Ba(ce), na(ce, 16, 110991)) : nt(ce, 16, 110991);
              }
              function tc(ce) {
                !b.isDeclarationFile && !(ce.flags & 16777216) && e2.isAsyncFunction(ce) && (Y |= 2048), F2 && (ce.flowNode = F2), Dn(ce);
                var Rr = ce.name ? ce.name.escapedText : "__function";
                return wt(ce, 16, Rr);
              }
              function ps(ce, Rr, yi) {
                return !b.isDeclarationFile && !(ce.flags & 16777216) && e2.isAsyncFunction(ce) && (Y |= 2048), F2 && e2.isObjectLiteralOrClassExpressionMethodOrAccessor(ce) && (ce.flowNode = F2), e2.hasDynamicName(ce) ? wt(ce, Rr, "__computed") : nt(ce, Rr, yi);
              }
              function Qs(ce) {
                var Rr = e2.findAncestor(ce, function(yi) {
                  return yi.parent && e2.isConditionalTypeNode(yi.parent) && yi.parent.extendsType === yi;
                });
                return Rr && Rr.parent;
              }
              function js(ce) {
                if (e2.isJSDocTemplateTag(ce.parent)) {
                  var Rr = e2.getEffectiveContainerForJSDocTemplateTag(ce.parent);
                  Rr ? (Rr.locals || (Rr.locals = e2.createSymbolTable()), ge(Rr.locals, void 0, ce, 262144, 526824)) : nt(ce, 262144, 526824);
                } else if (ce.parent.kind === 190) {
                  var yi = Qs(ce.parent);
                  yi ? (yi.locals || (yi.locals = e2.createSymbolTable()), ge(yi.locals, void 0, ce, 262144, 526824)) : wt(ce, 262144, Z2(ce));
                } else
                  nt(ce, 262144, 526824);
              }
              function ds(ce) {
                var Rr = C(ce);
                return Rr === 1 || Rr === 2 && e2.shouldPreserveConstEnums(se);
              }
              function Ji(ce) {
                if (!(F2.flags & 1))
                  return false;
                if (F2 === d) {
                  var Rr = e2.isStatementButNotDeclaration(ce) && ce.kind !== 236 || ce.kind === 257 || ce.kind === 261 && ds(ce);
                  if (Rr && (F2 = D, !se.allowUnreachableCode)) {
                    var yi = e2.unreachableCodeIsError(se) && !(ce.flags & 16777216) && (!e2.isVariableStatement(ce) || !!(e2.getCombinedNodeFlags(ce.declarationList) & 3) || ce.declarationList.declarations.some(function(qi) {
                      return !!qi.initializer;
                    }));
                    G(ce, function(qi, je) {
                      return eo(yi, qi, je, e2.Diagnostics.Unreachable_code_detected);
                    });
                  }
                }
                return true;
              }
            }
            function G(b, se) {
              if (e2.isStatement(b) && oe(b) && e2.isBlock(b.parent)) {
                var J = b.parent.statements, ie = e2.sliceAfter(J, b);
                e2.getRangesWhere(ie, oe, function(R, q) {
                  return se(ie[R], ie[q - 1]);
                });
              } else
                se(b, b);
            }
            function oe(b) {
              return !e2.isFunctionDeclaration(b) && !f4(b) && !e2.isEnumDeclaration(b) && !(e2.isVariableStatement(b) && !(e2.getCombinedNodeFlags(b) & 3) && b.declarationList.declarations.some(function(se) {
                return !se.initializer;
              }));
            }
            function f4(b) {
              switch (b.kind) {
                case 258:
                case 259:
                  return true;
                case 261:
                  return C(b) !== 1;
                case 260:
                  return e2.hasSyntacticModifier(b, 2048);
                default:
                  return false;
              }
            }
            function T(b, se) {
              for (var J = 0, ie = [se]; ie.length && J < 100; ) {
                if (J++, se = ie.shift(), e2.isExportsIdentifier(se) || e2.isModuleExportsAccessExpression(se))
                  return true;
                if (e2.isIdentifier(se)) {
                  var R = K(b, se.escapedText);
                  if (!!R && !!R.valueDeclaration && e2.isVariableDeclaration(R.valueDeclaration) && !!R.valueDeclaration.initializer) {
                    var q = R.valueDeclaration.initializer;
                    ie.push(q), e2.isAssignmentExpression(q, true) && (ie.push(q.left), ie.push(q.right));
                  }
                }
              }
              return false;
            }
            e2.isExportsOrModuleExportsOrAlias = T;
            function K(b, se) {
              var J = b.locals && b.locals.get(se);
              return J ? J.exportSymbol || J : e2.isSourceFile(b) && b.jsGlobalAugmentations && b.jsGlobalAugmentations.has(se) ? b.jsGlobalAugmentations.get(se) : b.symbol && b.symbol.exports && b.symbol.exports.get(se);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C, w, B, E, Q, le, N, p, m2, G) {
              return oe;
              function oe(f4) {
                f4 === void 0 && (f4 = function() {
                  return true;
                });
                var T = [], K = [];
                return { walkType: function(x2) {
                  try {
                    return b(x2), { visitedTypes: e2.getOwnValues(T), visitedSymbols: e2.getOwnValues(K) };
                  } finally {
                    e2.clear(T), e2.clear(K);
                  }
                }, walkSymbol: function(x2) {
                  try {
                    return F2(x2), { visitedTypes: e2.getOwnValues(T), visitedSymbols: e2.getOwnValues(K) };
                  } finally {
                    e2.clear(T), e2.clear(K);
                  }
                } };
                function b(x2) {
                  if (!!x2 && !T[x2.id]) {
                    T[x2.id] = x2;
                    var X = F2(x2.symbol);
                    if (!X) {
                      if (x2.flags & 524288) {
                        var $ = x2, A2 = $.objectFlags;
                        A2 & 4 && se(x2), A2 & 32 && O(x2), A2 & 3 && ee(x2), A2 & 24 && he($);
                      }
                      x2.flags & 262144 && J(x2), x2.flags & 3145728 && ie(x2), x2.flags & 4194304 && R(x2), x2.flags & 8388608 && q(x2);
                    }
                  }
                }
                function se(x2) {
                  b(x2.target), e2.forEach(G(x2), b);
                }
                function J(x2) {
                  b(p(x2));
                }
                function ie(x2) {
                  e2.forEach(x2.types, b);
                }
                function R(x2) {
                  b(x2.type);
                }
                function q(x2) {
                  b(x2.objectType), b(x2.indexType), b(x2.constraint);
                }
                function O(x2) {
                  b(x2.typeParameter), b(x2.constraintType), b(x2.templateType), b(x2.modifiersType);
                }
                function ve(x2) {
                  var X = w(x2);
                  X && b(X.type), e2.forEach(x2.typeParameters, b);
                  for (var $ = 0, A2 = x2.parameters; $ < A2.length; $++) {
                    var y = A2[$];
                    F2(y);
                  }
                  b(C(x2)), b(B(x2));
                }
                function ee(x2) {
                  he(x2), e2.forEach(x2.typeParameters, b), e2.forEach(E(x2), b), b(x2.thisType);
                }
                function he(x2) {
                  for (var X = Q(x2), $ = 0, A2 = X.indexInfos; $ < A2.length; $++) {
                    var y = A2[$];
                    b(y.keyType), b(y.type);
                  }
                  for (var V = 0, L = X.callSignatures; V < L.length; V++) {
                    var P = L[V];
                    ve(P);
                  }
                  for (var k = 0, Y = X.constructSignatures; k < Y.length; k++) {
                    var P = Y[k];
                    ve(P);
                  }
                  for (var U = 0, j = X.properties; U < j.length; U++) {
                    var H = j[U];
                    F2(H);
                  }
                }
                function F2(x2) {
                  if (!x2)
                    return false;
                  var X = e2.getSymbolId(x2);
                  if (K[X])
                    return false;
                  if (K[X] = x2, !f4(x2))
                    return true;
                  var $ = le(x2);
                  return b($), x2.exports && x2.exports.forEach(F2), e2.forEach(x2.declarations, function(A2) {
                    if (A2.type && A2.type.kind === 181) {
                      var y = A2.type, V = N(m2(y.exprName));
                      F2(V);
                    }
                  }), false;
                }
              }
            }
            e2.createGetSymbolWalker = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = /^".+"$/, C = "(anonymous)", w = 1, B = 1, E = 1, Q = 1, le;
            (function(l) {
              l[l.AllowsSyncIterablesFlag = 1] = "AllowsSyncIterablesFlag", l[l.AllowsAsyncIterablesFlag = 2] = "AllowsAsyncIterablesFlag", l[l.AllowsStringInputFlag = 4] = "AllowsStringInputFlag", l[l.ForOfFlag = 8] = "ForOfFlag", l[l.YieldStarFlag = 16] = "YieldStarFlag", l[l.SpreadFlag = 32] = "SpreadFlag", l[l.DestructuringFlag = 64] = "DestructuringFlag", l[l.PossiblyOutOfBounds = 128] = "PossiblyOutOfBounds", l[l.Element = 1] = "Element", l[l.Spread = 33] = "Spread", l[l.Destructuring = 65] = "Destructuring", l[l.ForOf = 13] = "ForOf", l[l.ForAwaitOf = 15] = "ForAwaitOf", l[l.YieldStar = 17] = "YieldStar", l[l.AsyncYieldStar = 19] = "AsyncYieldStar", l[l.GeneratorReturnType = 1] = "GeneratorReturnType", l[l.AsyncGeneratorReturnType = 2] = "AsyncGeneratorReturnType";
            })(le || (le = {}));
            var N;
            (function(l) {
              l[l.Yield = 0] = "Yield", l[l.Return = 1] = "Return", l[l.Next = 2] = "Next";
            })(N || (N = {}));
            var p;
            (function(l) {
              l[l.Normal = 0] = "Normal", l[l.FunctionReturn = 1] = "FunctionReturn", l[l.GeneratorNext = 2] = "GeneratorNext", l[l.GeneratorYield = 3] = "GeneratorYield";
            })(p || (p = {}));
            var m2;
            (function(l) {
              l[l.None = 0] = "None", l[l.TypeofEQString = 1] = "TypeofEQString", l[l.TypeofEQNumber = 2] = "TypeofEQNumber", l[l.TypeofEQBigInt = 4] = "TypeofEQBigInt", l[l.TypeofEQBoolean = 8] = "TypeofEQBoolean", l[l.TypeofEQSymbol = 16] = "TypeofEQSymbol", l[l.TypeofEQObject = 32] = "TypeofEQObject", l[l.TypeofEQFunction = 64] = "TypeofEQFunction", l[l.TypeofEQHostObject = 128] = "TypeofEQHostObject", l[l.TypeofNEString = 256] = "TypeofNEString", l[l.TypeofNENumber = 512] = "TypeofNENumber", l[l.TypeofNEBigInt = 1024] = "TypeofNEBigInt", l[l.TypeofNEBoolean = 2048] = "TypeofNEBoolean", l[l.TypeofNESymbol = 4096] = "TypeofNESymbol", l[l.TypeofNEObject = 8192] = "TypeofNEObject", l[l.TypeofNEFunction = 16384] = "TypeofNEFunction", l[l.TypeofNEHostObject = 32768] = "TypeofNEHostObject", l[l.EQUndefined = 65536] = "EQUndefined", l[l.EQNull = 131072] = "EQNull", l[l.EQUndefinedOrNull = 262144] = "EQUndefinedOrNull", l[l.NEUndefined = 524288] = "NEUndefined", l[l.NENull = 1048576] = "NENull", l[l.NEUndefinedOrNull = 2097152] = "NEUndefinedOrNull", l[l.Truthy = 4194304] = "Truthy", l[l.Falsy = 8388608] = "Falsy", l[l.All = 16777215] = "All", l[l.BaseStringStrictFacts = 3735041] = "BaseStringStrictFacts", l[l.BaseStringFacts = 12582401] = "BaseStringFacts", l[l.StringStrictFacts = 16317953] = "StringStrictFacts", l[l.StringFacts = 16776705] = "StringFacts", l[l.EmptyStringStrictFacts = 12123649] = "EmptyStringStrictFacts", l[l.EmptyStringFacts = 12582401] = "EmptyStringFacts", l[l.NonEmptyStringStrictFacts = 7929345] = "NonEmptyStringStrictFacts", l[l.NonEmptyStringFacts = 16776705] = "NonEmptyStringFacts", l[l.BaseNumberStrictFacts = 3734786] = "BaseNumberStrictFacts", l[l.BaseNumberFacts = 12582146] = "BaseNumberFacts", l[l.NumberStrictFacts = 16317698] = "NumberStrictFacts", l[l.NumberFacts = 16776450] = "NumberFacts", l[l.ZeroNumberStrictFacts = 12123394] = "ZeroNumberStrictFacts", l[l.ZeroNumberFacts = 12582146] = "ZeroNumberFacts", l[l.NonZeroNumberStrictFacts = 7929090] = "NonZeroNumberStrictFacts", l[l.NonZeroNumberFacts = 16776450] = "NonZeroNumberFacts", l[l.BaseBigIntStrictFacts = 3734276] = "BaseBigIntStrictFacts", l[l.BaseBigIntFacts = 12581636] = "BaseBigIntFacts", l[l.BigIntStrictFacts = 16317188] = "BigIntStrictFacts", l[l.BigIntFacts = 16775940] = "BigIntFacts", l[l.ZeroBigIntStrictFacts = 12122884] = "ZeroBigIntStrictFacts", l[l.ZeroBigIntFacts = 12581636] = "ZeroBigIntFacts", l[l.NonZeroBigIntStrictFacts = 7928580] = "NonZeroBigIntStrictFacts", l[l.NonZeroBigIntFacts = 16775940] = "NonZeroBigIntFacts", l[l.BaseBooleanStrictFacts = 3733256] = "BaseBooleanStrictFacts", l[l.BaseBooleanFacts = 12580616] = "BaseBooleanFacts", l[l.BooleanStrictFacts = 16316168] = "BooleanStrictFacts", l[l.BooleanFacts = 16774920] = "BooleanFacts", l[l.FalseStrictFacts = 12121864] = "FalseStrictFacts", l[l.FalseFacts = 12580616] = "FalseFacts", l[l.TrueStrictFacts = 7927560] = "TrueStrictFacts", l[l.TrueFacts = 16774920] = "TrueFacts", l[l.SymbolStrictFacts = 7925520] = "SymbolStrictFacts", l[l.SymbolFacts = 16772880] = "SymbolFacts", l[l.ObjectStrictFacts = 7888800] = "ObjectStrictFacts", l[l.ObjectFacts = 16736160] = "ObjectFacts", l[l.FunctionStrictFacts = 7880640] = "FunctionStrictFacts", l[l.FunctionFacts = 16728e3] = "FunctionFacts", l[l.UndefinedFacts = 9830144] = "UndefinedFacts", l[l.NullFacts = 9363232] = "NullFacts", l[l.EmptyObjectStrictFacts = 16318463] = "EmptyObjectStrictFacts", l[l.AllTypeofNE = 556800] = "AllTypeofNE", l[l.EmptyObjectFacts = 16777215] = "EmptyObjectFacts", l[l.OrFactsMask = 8256] = "OrFactsMask", l[l.AndFactsMask = 16768959] = "AndFactsMask";
            })(m2 || (m2 = {}));
            var G = new e2.Map(e2.getEntries({ string: 1, number: 2, bigint: 4, boolean: 8, symbol: 16, undefined: 65536, object: 32, function: 64 })), oe = new e2.Map(e2.getEntries({ string: 256, number: 512, bigint: 1024, boolean: 2048, symbol: 4096, undefined: 524288, object: 8192, function: 16384 })), f4;
            (function(l) {
              l[l.Type = 0] = "Type", l[l.ResolvedBaseConstructorType = 1] = "ResolvedBaseConstructorType", l[l.DeclaredType = 2] = "DeclaredType", l[l.ResolvedReturnType = 3] = "ResolvedReturnType", l[l.ImmediateBaseConstraint = 4] = "ImmediateBaseConstraint", l[l.EnumTagType = 5] = "EnumTagType", l[l.ResolvedTypeArguments = 6] = "ResolvedTypeArguments", l[l.ResolvedBaseTypes = 7] = "ResolvedBaseTypes", l[l.WriteType = 8] = "WriteType";
            })(f4 || (f4 = {}));
            var T;
            (function(l) {
              l[l.Normal = 0] = "Normal", l[l.Contextual = 1] = "Contextual", l[l.Inferential = 2] = "Inferential", l[l.SkipContextSensitive = 4] = "SkipContextSensitive", l[l.SkipGenericFunctions = 8] = "SkipGenericFunctions", l[l.IsForSignatureHelp = 16] = "IsForSignatureHelp", l[l.IsForStringLiteralArgumentCompletions = 32] = "IsForStringLiteralArgumentCompletions", l[l.RestBindingElement = 64] = "RestBindingElement";
            })(T || (T = {}));
            var K;
            (function(l) {
              l[l.BivariantCallback = 1] = "BivariantCallback", l[l.StrictCallback = 2] = "StrictCallback", l[l.IgnoreReturnTypes = 4] = "IgnoreReturnTypes", l[l.StrictArity = 8] = "StrictArity", l[l.Callback = 3] = "Callback";
            })(K || (K = {}));
            var b;
            (function(l) {
              l[l.None = 0] = "None", l[l.Source = 1] = "Source", l[l.Target = 2] = "Target", l[l.PropertyCheck = 4] = "PropertyCheck", l[l.InPropertyCheck = 8] = "InPropertyCheck";
            })(b || (b = {}));
            var se;
            (function(l) {
              l[l.None = 0] = "None", l[l.Source = 1] = "Source", l[l.Target = 2] = "Target", l[l.Both = 3] = "Both";
            })(se || (se = {}));
            var J;
            (function(l) {
              l[l.IncludeReadonly = 1] = "IncludeReadonly", l[l.ExcludeReadonly = 2] = "ExcludeReadonly", l[l.IncludeOptional = 4] = "IncludeOptional", l[l.ExcludeOptional = 8] = "ExcludeOptional";
            })(J || (J = {}));
            var ie;
            (function(l) {
              l[l.None = 0] = "None", l[l.Source = 1] = "Source", l[l.Target = 2] = "Target", l[l.Both = 3] = "Both";
            })(ie || (ie = {}));
            var R;
            (function(l) {
              l.resolvedExports = "resolvedExports", l.resolvedMembers = "resolvedMembers";
            })(R || (R = {}));
            var q;
            (function(l) {
              l[l.Local = 0] = "Local", l[l.Parameter = 1] = "Parameter";
            })(q || (q = {}));
            var O = e2.and(k, P), ve;
            (function(l) {
              l[l.GetAccessor = 1] = "GetAccessor", l[l.SetAccessor = 2] = "SetAccessor", l[l.PropertyAssignment = 4] = "PropertyAssignment", l[l.Method = 8] = "Method", l[l.PrivateStatic = 16] = "PrivateStatic", l[l.GetOrSetAccessor = 3] = "GetOrSetAccessor", l[l.PropertyAssignmentOrMethod = 12] = "PropertyAssignmentOrMethod";
            })(ve || (ve = {}));
            var ee;
            (function(l) {
              l[l.None = 0] = "None", l[l.ExportValue = 1] = "ExportValue", l[l.ExportType = 2] = "ExportType", l[l.ExportNamespace = 4] = "ExportNamespace";
            })(ee || (ee = {}));
            var he;
            (function(l) {
              l[l.None = 0] = "None", l[l.StrongArityForUntypedJS = 1] = "StrongArityForUntypedJS", l[l.VoidIsNonOptional = 2] = "VoidIsNonOptional";
            })(he || (he = {}));
            var F2;
            (function(l) {
              l[l.Uppercase = 0] = "Uppercase", l[l.Lowercase = 1] = "Lowercase", l[l.Capitalize = 2] = "Capitalize", l[l.Uncapitalize = 3] = "Uncapitalize";
            })(F2 || (F2 = {}));
            var x2 = new e2.Map(e2.getEntries({ Uppercase: 0, Lowercase: 1, Capitalize: 2, Uncapitalize: 3 }));
            function X() {
            }
            function $() {
              this.flags = 0;
            }
            function A2(l) {
              return l.id || (l.id = B, B++), l.id;
            }
            e2.getNodeId = A2;
            function y(l) {
              return l.id || (l.id = w, w++), l.id;
            }
            e2.getSymbolId = y;
            function V(l, d) {
              var D = e2.getModuleInstanceState(l);
              return D === 1 || d && D === 2;
            }
            e2.isInstantiatedModule = V;
            function L(l) {
              var d = e2.memoize(function() {
                var r2 = new e2.Map();
                return l.getSourceFiles().forEach(function(i2) {
                  !i2.resolvedModules || i2.resolvedModules.forEach(function(t2) {
                    t2 && t2.packageId && r2.set(t2.packageId.name, t2.extension === ".d.ts" || !!r2.get(t2.packageId.name));
                  });
                }), r2;
              }), D = [], fe = function(r2) {
                D.push(r2);
              }, g, ne, ue, We = e2.objectAllocator.getSymbolConstructor(), Fe = e2.objectAllocator.getTypeConstructor(), Z2 = e2.objectAllocator.getSignatureConstructor(), Be = 0, ge = 0, Re = 0, ze = 0, Ee = 0, He = 0, rr = 0, Ie, _e, we = e2.createSymbolTable(), de = [1], ye = l.getCompilerOptions(), Ae = e2.getEmitScriptTarget(ye), er = e2.getEmitModuleKind(ye), ir = e2.getUseDefineForClassFields(ye), Cr = e2.getAllowSyntheticDefaultImports(ye), Ye = e2.getStrictOptionValue(ye, "strictNullChecks"), Br = e2.getStrictOptionValue(ye, "strictFunctionTypes"), Er = e2.getStrictOptionValue(ye, "strictBindCallApply"), Ne = e2.getStrictOptionValue(ye, "strictPropertyInitialization"), n = e2.getStrictOptionValue(ye, "noImplicitAny"), lr = e2.getStrictOptionValue(ye, "noImplicitThis"), be = e2.getStrictOptionValue(ye, "useUnknownInCatchVariables"), Ge = !!ye.keyofStringsOnly, ur = ye.suppressExcessPropertyErrors ? 0 : 8192, yr = ye.exactOptionalPropertyTypes, Ir = dO(), wr = M9(), Ur = m_(), ii = e2.createSymbolTable(), mi = oo(4, "undefined");
              mi.declarations = [];
              var pe = oo(1536, "globalThis", 8);
              pe.exports = ii, pe.declarations = [], ii.set(pe.escapedName, pe);
              var or = oo(4, "arguments"), qr = oo(4, "require"), si, Di = { getNodeCount: function() {
                return e2.sum(l.getSourceFiles(), "nodeCount");
              }, getIdentifierCount: function() {
                return e2.sum(l.getSourceFiles(), "identifierCount");
              }, getSymbolCount: function() {
                return e2.sum(l.getSourceFiles(), "symbolCount") + ge;
              }, getTypeCount: function() {
                return Be;
              }, getInstantiationCount: function() {
                return ze;
              }, getRelationCacheSizes: function() {
                return { assignable: dt.size, identity: wa.size, subtype: Or.size, strictSubtype: ki.size };
              }, isUndefinedSymbol: function(r2) {
                return r2 === mi;
              }, isArgumentsSymbol: function(r2) {
                return r2 === or;
              }, isUnknownSymbol: function(r2) {
                return r2 === xe;
              }, getMergedSymbol: so, getDiagnostics: X6, getGlobalDiagnostics: $M, getRecursionIdentity: ov, getUnmatchedProperties: sb, getTypeOfSymbolAtLocation: function(r2, i2) {
                var t2 = e2.getParseTreeNode(i2);
                return t2 ? N8(r2, t2) : Pe;
              }, getTypeOfSymbol: Jt, getSymbolsOfParameterPropertyDeclaration: function(r2, i2) {
                var t2 = e2.getParseTreeNode(r2, e2.isParameter);
                return t2 === void 0 ? e2.Debug.fail("Cannot get symbols of a synthetic parameter that cannot be resolved to a parse-tree node.") : cd(t2, e2.escapeLeadingUnderscores(i2));
              }, getDeclaredTypeOfSymbol: go, getPropertiesOfType: uo, getPropertyOfType: function(r2, i2) {
                return bi(r2, e2.escapeLeadingUnderscores(i2));
              }, getPrivateIdentifierPropertyOfType: function(r2, i2, t2) {
                var o = e2.getParseTreeNode(t2);
                if (!!o) {
                  var s2 = e2.escapeLeadingUnderscores(i2), u = g0(s2, o);
                  return u ? Ub(r2, u) : void 0;
                }
              }, getTypeOfPropertyOfType: function(r2, i2) {
                return da(r2, e2.escapeLeadingUnderscores(i2));
              }, getIndexInfoOfType: function(r2, i2) {
                return ss(r2, i2 === 0 ? Li : nt);
              }, getIndexInfosOfType: Hn, getSignaturesOfType: ot, getIndexTypeOfType: function(r2, i2) {
                return cs(r2, i2 === 0 ? Li : nt);
              }, getIndexType: function(r2) {
                return ql(r2);
              }, getBaseTypes: Qc, getBaseTypeOfLiteralType: Kl, getWidenedType: $c, getTypeFromTypeNode: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isTypeNode);
                return i2 ? Va(i2) : Pe;
              }, getParameterType: $u, getParameterIdentifierNameAtPosition: q7, getPromisedTypeOfPromise: Tv, getAwaitedType: function(r2) {
                return ag(r2);
              }, getReturnTypeOfSignature: yo, isNullableType: d0, getNullableType: Uh, getNonNullableType: C_, getNonOptionalType: YD, getTypeArguments: xo, typeToTypeNode: Ur.typeToTypeNode, indexInfoToIndexSignatureDeclaration: Ur.indexInfoToIndexSignatureDeclaration, signatureToSignatureDeclaration: Ur.signatureToSignatureDeclaration, symbolToEntityName: Ur.symbolToEntityName, symbolToExpression: Ur.symbolToExpression, symbolToTypeParameterDeclarations: Ur.symbolToTypeParameterDeclarations, symbolToParameterDeclaration: Ur.symbolToParameterDeclaration, typeParameterToDeclaration: Ur.typeParameterToDeclaration, getSymbolsInScope: function(r2, i2) {
                var t2 = e2.getParseTreeNode(r2);
                return t2 ? ZM(t2, i2) : [];
              }, getSymbolAtLocation: function(r2) {
                var i2 = e2.getParseTreeNode(r2);
                return i2 ? el(i2, true) : void 0;
              }, getIndexInfosAtLocation: function(r2) {
                var i2 = e2.getParseTreeNode(r2);
                return i2 ? o9(i2) : void 0;
              }, getShorthandAssignmentValueSymbol: function(r2) {
                var i2 = e2.getParseTreeNode(r2);
                return i2 ? s9(i2) : void 0;
              }, getExportSpecifierLocalTargetSymbol: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isExportSpecifier);
                return i2 ? c9(i2) : void 0;
              }, getExportSymbolOfSymbol: function(r2) {
                return so(r2.exportSymbol || r2);
              }, getTypeAtLocation: function(r2) {
                var i2 = e2.getParseTreeNode(r2);
                return i2 ? Bd(i2) : Pe;
              }, getTypeOfAssignmentPattern: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isAssignmentPattern);
                return i2 && V0(i2) || Pe;
              }, getPropertySymbolOfDestructuringAssignment: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isIdentifier);
                return i2 ? u9(i2) : void 0;
              }, signatureToString: function(r2, i2, t2, o) {
                return Ml(r2, e2.getParseTreeNode(i2), t2, o);
              }, typeToString: function(r2, i2, t2) {
                return Ot(r2, e2.getParseTreeNode(i2), t2);
              }, symbolToString: function(r2, i2, t2, o) {
                return tn(r2, e2.getParseTreeNode(i2), t2, o);
              }, typePredicateToString: function(r2, i2, t2) {
                return Ll(r2, e2.getParseTreeNode(i2), t2);
              }, writeSignature: function(r2, i2, t2, o, s2) {
                return Ml(r2, e2.getParseTreeNode(i2), t2, o, s2);
              }, writeType: function(r2, i2, t2, o) {
                return Ot(r2, e2.getParseTreeNode(i2), t2, o);
              }, writeSymbol: function(r2, i2, t2, o, s2) {
                return tn(r2, e2.getParseTreeNode(i2), t2, o, s2);
              }, writeTypePredicate: function(r2, i2, t2, o) {
                return Ll(r2, e2.getParseTreeNode(i2), t2, o);
              }, getAugmentedPropertiesOfType: LS, getRootSymbols: eA, getSymbolOfExpando: T0, getContextualType: function(r2, i2) {
                var t2 = e2.getParseTreeNode(r2, e2.isExpression);
                if (!!t2)
                  return i2 & 4 ? wi(t2, function() {
                    return ou(t2, i2);
                  }) : ou(t2, i2);
              }, getContextualTypeForObjectLiteralElement: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isObjectLiteralElementLike);
                return i2 ? kb(i2) : void 0;
              }, getContextualTypeForArgumentAtIndex: function(r2, i2) {
                var t2 = e2.getParseTreeNode(r2, e2.isCallLikeExpression);
                return t2 && Cb(t2, i2);
              }, getContextualTypeForJsxAttribute: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isJsxAttributeLike);
                return i2 && AC(i2);
              }, isContextSensitive: Ju, getTypeOfPropertyOfContextualType: Md, getFullyQualifiedName: cl, getResolvedSignature: function(r2, i2, t2) {
                return Xi(r2, i2, t2, 0);
              }, getResolvedSignatureForStringLiteralCompletions: function(r2, i2, t2) {
                return Xi(r2, t2, void 0, 32, i2);
              }, getResolvedSignatureForSignatureHelp: function(r2, i2, t2) {
                return Xi(r2, i2, t2, 16);
              }, getExpandedParameters: Jm, hasEffectiveRestParameter: Xl, containsArgumentsReference: Gm, getConstantValue: function(r2) {
                var i2 = e2.getParseTreeNode(r2, nA);
                return i2 ? BS(i2) : void 0;
              }, isValidPropertyAccess: function(r2, i2) {
                var t2 = e2.getParseTreeNode(r2, e2.isPropertyAccessOrQualifiedNameOrImportTypeNode);
                return !!t2 && a7(t2, e2.escapeLeadingUnderscores(i2));
              }, isValidPropertyAccessForCompletions: function(r2, i2, t2) {
                var o = e2.getParseTreeNode(r2, e2.isPropertyAccessExpression);
                return !!o && ik(o, i2, t2);
              }, getSignatureFromDeclaration: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isFunctionLike);
                return i2 ? yl(i2) : void 0;
              }, isImplementationOfOverload: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isFunctionLike);
                return i2 ? tA(i2) : void 0;
              }, getImmediateAliasedSymbol: wb, getAliasedSymbol: Ps, getEmitResolver: Ho, getExportsOfModule: J_, getExportsAndPropertiesOfModule: j_, forEachExportAndPropertyOfModule: U_, getSymbolWalker: e2.createGetSymbolWalker(_3, Yc, yo, Qc, Ru, Jt, Dl, Tc, e2.getFirstIdentifier, xo), getAmbientModules: xL, getJsxIntrinsicTagNamesAt: R5, isOptionalParameter: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isParameter);
                return i2 ? kd(i2) : false;
              }, tryGetMemberInModuleExports: function(r2, i2) {
                return iu(e2.escapeLeadingUnderscores(r2), i2);
              }, tryGetMemberInModuleExportsAndProperties: function(r2, i2) {
                return vd(e2.escapeLeadingUnderscores(r2), i2);
              }, tryFindAmbientModule: function(r2) {
                return b_(r2, true);
              }, tryFindAmbientModuleWithoutAugmentations: function(r2) {
                return b_(r2, false);
              }, getApparentType: $s, getUnionType: Pa, isTypeAssignableTo: ao, createAnonymousType: rs, createSignature: Fu, createSymbol: oo, createIndexInfo: zl, getAnyType: function() {
                return Oe;
              }, getStringType: function() {
                return Li;
              }, getNumberType: function() {
                return nt;
              }, createPromiseType: Ny, createArrayType: Zs, getElementTypeOfArrayType: KD, getBooleanType: function() {
                return Ii;
              }, getFalseType: function(r2) {
                return r2 ? xt : ut;
              }, getTrueType: function(r2) {
                return r2 ? Dt : Rt;
              }, getVoidType: function() {
                return Fi;
              }, getUndefinedType: function() {
                return Tr;
              }, getNullType: function() {
                return Wi;
              }, getESSymbolType: function() {
                return Ki;
              }, getNeverType: function() {
                return ui;
              }, getOptionalType: function() {
                return Ui;
              }, getPromiseType: function() {
                return ay(false);
              }, getPromiseLikeType: function() {
                return kx(false);
              }, isSymbolAccessible: g_, isArrayType: Tu, isTupleType: Yn, isArrayLikeType: sp, isTypeInvalidDueToUnionDiscriminant: z1, getExactOptionalProperties: lw, getAllPossiblePropertiesOfTypes: W1, getSuggestedSymbolForNonexistentProperty: qb, getSuggestionForNonexistentProperty: Vb, getSuggestedSymbolForNonexistentJSXAttribute: ek, getSuggestedSymbolForNonexistentSymbol: function(r2, i2, t2) {
                return Kb(r2, e2.escapeLeadingUnderscores(i2), t2);
              }, getSuggestionForNonexistentSymbol: function(r2, i2, t2) {
                return e7(r2, e2.escapeLeadingUnderscores(i2), t2);
              }, getSuggestedSymbolForNonexistentModule: v0, getSuggestionForNonexistentExport: r7, getSuggestedSymbolForNonexistentClassMember: ZC, getBaseConstraintOfType: uc, getDefaultFromTypeParameter: function(r2) {
                return r2 && r2.flags & 262144 ? D_(r2) : void 0;
              }, resolveName: function(r2, i2, t2, o) {
                return es(i2, e2.escapeLeadingUnderscores(r2), t2, void 0, void 0, false, o);
              }, getJsxNamespace: function(r2) {
                return e2.unescapeLeadingUnderscores(po(r2));
              }, getJsxFragmentFactory: function(r2) {
                var i2 = jS(r2);
                return i2 && e2.unescapeLeadingUnderscores(e2.getFirstIdentifier(i2).escapedText);
              }, getAccessibleSymbolChain: pl, getTypePredicateOfSignature: Yc, resolveExternalModuleName: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isExpression);
                return i2 && ac(i2, i2, true);
              }, resolveExternalModuleSymbol: Us, tryGetThisTypeAt: function(r2, i2) {
                var t2 = e2.getParseTreeNode(r2);
                return t2 && bb(t2, i2);
              }, getTypeArgumentConstraint: function(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isTypeNode);
                return i2 && WO(i2);
              }, getSuggestionDiagnostics: function(r2, i2) {
                var t2 = e2.getParseTreeNode(r2, e2.isSourceFile) || e2.Debug.fail("Could not determine parsed source file.");
                if (e2.skipTypeChecking(t2, ye, l))
                  return e2.emptyArray;
                var o;
                try {
                  return g = i2, FS(t2), e2.Debug.assert(!!(va(t2).flags & 1)), o = e2.addRange(o, jn.getDiagnostics(t2.fileName)), _6(H6(t2), function(s2, u, h2) {
                    !e2.containsParseError(s2) && !G6(u, !!(s2.flags & 16777216)) && (o || (o = [])).push(Ke(Ke({}, h2), { category: e2.DiagnosticCategory.Suggestion }));
                  }), o || e2.emptyArray;
                } finally {
                  g = void 0;
                }
              }, runWithCancellationToken: function(r2, i2) {
                try {
                  return g = r2, i2(Di);
                } finally {
                  g = void 0;
                }
              }, getLocalTypeParametersOfClassOrInterfaceOrTypeAlias: Af, isDeclarationVisible: wu, isPropertyAccessible: Hb, getTypeOnlyAliasDeclaration: vu, getMemberOverrideModifierStatus: dM };
              function wi(r2, i2) {
                var t2 = e2.findAncestor(r2, e2.isCallLikeExpression), o = t2 && va(t2).resolvedSignature;
                if (t2) {
                  var s2 = r2;
                  do
                    va(s2).skipDirectInference = true, s2 = s2.parent;
                  while (s2 && s2 !== t2);
                  va(t2).resolvedSignature = void 0;
                }
                var u = i2();
                if (t2) {
                  var s2 = r2;
                  do
                    va(s2).skipDirectInference = void 0, s2 = s2.parent;
                  while (s2 && s2 !== t2);
                  va(t2).resolvedSignature = o;
                }
                return u;
              }
              function Xi(r2, i2, t2, o, s2) {
                var u = e2.getParseTreeNode(r2, e2.isCallLikeExpression);
                si = t2;
                var h2 = u ? s2 ? wi(s2, function() {
                  return Mg(u, i2, o);
                }) : Mg(u, i2, o) : void 0;
                return si = void 0, h2;
              }
              var et = new e2.Map(), Gi = new e2.Map(), Wt = new e2.Map(), Zt = new e2.Map(), _r = new e2.Map(), pi = new e2.Map(), ae = new e2.Map(), Xe = new e2.Map(), Jr = new e2.Map(), ti = new e2.Map(), Ze = new e2.Map(), Sr = new e2.Map(), zr = [], Wr = new e2.Map(), Je = new e2.Set(), xe = oo(4, "unknown"), vr = oo(0, "__resolving__"), mr = new e2.Map(), Ar = new e2.Map(), Oe = ms(1, "any"), nr = ms(1, "any"), Mr = ms(1, "any"), Pe = ms(1, "error"), Ue = ms(1, "unresolved"), fr = ms(1, "any", 65536), De = ms(1, "intrinsic"), gr = ms(2, "unknown"), Vr = ms(2, "unknown"), Tr = ms(32768, "undefined"), vi = Ye ? Tr : ms(32768, "undefined", 65536), Ui = ms(32768, "undefined"), Yi = yr ? ms(32768, "undefined") : Tr, Wi = ms(65536, "null"), ct = Ye ? Wi : ms(65536, "null", 65536), Li = ms(4, "string"), nt = ms(8, "number"), Mt = ms(64, "bigint"), xt = ms(512, "false"), ut = ms(512, "false"), Dt = ms(512, "true"), Rt = ms(512, "true");
              Dt.regularType = Rt, Dt.freshType = Dt, Rt.regularType = Rt, Rt.freshType = Dt, xt.regularType = ut, xt.freshType = xt, ut.regularType = ut, ut.freshType = xt;
              var Ii = Pa([ut, Rt]), Ki = ms(4096, "symbol"), Fi = ms(16384, "void"), ui = ms(131072, "never"), Bt = ms(131072, "never"), wt = ms(131072, "never", 262144), na = ms(131072, "never"), Ai = ms(131072, "never"), Oi = ms(67108864, "object"), ji = Pa([Li, nt]), Vi = Pa([Li, nt, Ki]), at = Ge ? Li : Vi, At = Pa([nt, Mt]), ba = Pa([Li, nt, Ii, Mt, Wi, Tr]), $a = Dg(["", ""], [nt]), Qa = Gp(function(r2) {
                return r2.flags & 262144 ? RI(r2) : r2;
              }), ai = Gp(function(r2) {
                return r2.flags & 262144 ? Mr : r2;
              }), Dn = ms(131072, "never"), ka = Gp(function(r2) {
                return r2.flags & 262144 ? Dn : r2;
              }), Ba = rs(void 0, we, e2.emptyArray, e2.emptyArray, e2.emptyArray), pn = rs(void 0, we, e2.emptyArray, e2.emptyArray, e2.emptyArray);
              pn.objectFlags |= 2048;
              var Cn = oo(2048, "__type");
              Cn.members = e2.createSymbolTable();
              var Bi = rs(Cn, we, e2.emptyArray, e2.emptyArray, e2.emptyArray), kn = rs(void 0, we, e2.emptyArray, e2.emptyArray, e2.emptyArray);
              kn.instantiations = new e2.Map();
              var xn = rs(void 0, we, e2.emptyArray, e2.emptyArray, e2.emptyArray);
              xn.objectFlags |= 262144;
              var Kn = rs(void 0, we, e2.emptyArray, e2.emptyArray, e2.emptyArray), Pn = rs(void 0, we, e2.emptyArray, e2.emptyArray, e2.emptyArray), eo = rs(void 0, we, e2.emptyArray, e2.emptyArray, e2.emptyArray), Rn = Hc(), Da = Hc();
              Da.constraint = Rn;
              var bo = Hc(), Ro = vg(1, "<<unresolved>>", 0, Oe), En = Fu(void 0, void 0, void 0, e2.emptyArray, Oe, void 0, 0, 0), Wn = Fu(void 0, void 0, void 0, e2.emptyArray, Pe, void 0, 0, 0), to = Fu(void 0, void 0, void 0, e2.emptyArray, Oe, void 0, 0, 0), Co = Fu(void 0, void 0, void 0, e2.emptyArray, Bt, void 0, 0, 0), Ko = zl(nt, Li, true), Oo = new e2.Map(), no = { get yieldType() {
                return e2.Debug.fail("Not supported");
              }, get returnType() {
                return e2.Debug.fail("Not supported");
              }, get nextType() {
                return e2.Debug.fail("Not supported");
              } }, $o = a_(Oe, Oe, Oe), Pr = a_(Oe, Oe, gr), xi = a_(ui, Oe, Tr), St = { iterableCacheKey: "iterationTypesOfAsyncIterable", iteratorCacheKey: "iterationTypesOfAsyncIterator", iteratorSymbolName: "asyncIterator", getGlobalIteratorType: k3, getGlobalIterableType: C3, getGlobalIterableIteratorType: A3, getGlobalGeneratorType: N3, resolveIterationType: ag, mustHaveANextMethodDiagnostic: e2.Diagnostics.An_async_iterator_must_have_a_next_method, mustBeAMethodDiagnostic: e2.Diagnostics.The_0_property_of_an_async_iterator_must_be_a_method, mustHaveAValueDiagnostic: e2.Diagnostics.The_type_returned_by_the_0_method_of_an_async_iterator_must_be_a_promise_for_a_type_with_a_value_property }, pa = { iterableCacheKey: "iterationTypesOfIterable", iteratorCacheKey: "iterationTypesOfIterator", iteratorSymbolName: "iterator", getGlobalIteratorType: P3, getGlobalIterableType: Ax, getGlobalIterableIteratorType: I3, getGlobalGeneratorType: w3, resolveIterationType: function(r2, i2) {
                return r2;
              }, mustHaveANextMethodDiagnostic: e2.Diagnostics.An_iterator_must_have_a_next_method, mustBeAMethodDiagnostic: e2.Diagnostics.The_0_property_of_an_iterator_must_be_a_method, mustHaveAValueDiagnostic: e2.Diagnostics.The_type_returned_by_the_0_method_of_an_iterator_must_have_a_value_property }, dn, Jn = new e2.Map(), Qe = false, Gr, S2, Ce, qe, br, Zr, Si, Pi, Qi, Ct, sa, en, Wa, qn, mo, So, Go, ys, Pc, Vc, Kc, Xs, pc, hs, tc, ps, Qs, js, ds, Ji, ce, Rr, yi, qi, je, Hr, pt, Pt, ga, ua, Xn, jr, fo, xs, Fo = new e2.Map(), ko = 0, Ao = 0, Ms = 0, Bs = false, xc = 0, su, tl, Zc, Rf = Bu(""), al = If(0), Jo = ED({ negative: false, base10Value: "0" }), eu = [], Ws = [], pu = [], Uu = 0, Ql = 10, xl = [], Ya = [], du = [], vc = [], Kr = [], _i = [], Ei = [], tt = [], kt = [], bt = [], ia = [], Xt = [], Za = [], bn = [], _a4 = [], qa = [], rn = e2.createDiagnosticCollection(), jn = e2.createDiagnosticCollection(), Mo = new e2.Map(e2.getEntries({ string: Li, number: nt, bigint: Mt, boolean: Ii, symbol: Ki, undefined: Tr })), ho = wp(), gs, Se, hr, Or = new e2.Map(), ki = new e2.Map(), dt = new e2.Map(), la = new e2.Map(), wa = new e2.Map(), On = new e2.Map(), No = e2.createSymbolTable();
              No.set(mi.escapedName, mi);
              var jo = [[".mts", ".mjs"], [".ts", ".js"], [".cts", ".cjs"], [".mjs", ".mjs"], [".js", ".js"], [".cjs", ".cjs"], [".tsx", ye.jsx === 1 ? ".jsx" : ".js"], [".jsx", ".jsx"], [".json", ".json"]];
              return L9(), Di;
              function po(r2) {
                if (r2) {
                  var i2 = e2.getSourceFileOfNode(r2);
                  if (i2)
                    if (e2.isJsxOpeningFragment(r2)) {
                      if (i2.localJsxFragmentNamespace)
                        return i2.localJsxFragmentNamespace;
                      var t2 = i2.pragmas.get("jsxfrag");
                      if (t2) {
                        var o = e2.isArray(t2) ? t2[0] : t2;
                        if (i2.localJsxFragmentFactory = e2.parseIsolatedEntityName(o.arguments.factory, Ae), e2.visitNode(i2.localJsxFragmentFactory, $n), i2.localJsxFragmentFactory)
                          return i2.localJsxFragmentNamespace = e2.getFirstIdentifier(i2.localJsxFragmentFactory).escapedText;
                      }
                      var s2 = jS(r2);
                      if (s2)
                        return i2.localJsxFragmentFactory = s2, i2.localJsxFragmentNamespace = e2.getFirstIdentifier(s2).escapedText;
                    } else {
                      var u = Gn(i2);
                      if (u)
                        return i2.localJsxNamespace = u;
                    }
                }
                return gs || (gs = "React", ye.jsxFactory ? (Se = e2.parseIsolatedEntityName(ye.jsxFactory, Ae), e2.visitNode(Se, $n), Se && (gs = e2.getFirstIdentifier(Se).escapedText)) : ye.reactNamespace && (gs = e2.escapeLeadingUnderscores(ye.reactNamespace))), Se || (Se = e2.factory.createQualifiedName(e2.factory.createIdentifier(e2.unescapeLeadingUnderscores(gs)), "createElement")), gs;
              }
              function Gn(r2) {
                if (r2.localJsxNamespace)
                  return r2.localJsxNamespace;
                var i2 = r2.pragmas.get("jsx");
                if (i2) {
                  var t2 = e2.isArray(i2) ? i2[0] : i2;
                  if (r2.localJsxFactory = e2.parseIsolatedEntityName(t2.arguments.factory, Ae), e2.visitNode(r2.localJsxFactory, $n), r2.localJsxFactory)
                    return r2.localJsxNamespace = e2.getFirstIdentifier(r2.localJsxFactory).escapedText;
                }
              }
              function $n(r2) {
                return e2.setTextRangePosEnd(r2, -1, -1), e2.visitEachChild(r2, $n, e2.nullTransformationContext);
              }
              function Ho(r2, i2) {
                return X6(r2, i2), wr;
              }
              function Zo(r2, i2, t2, o, s2, u) {
                var h2 = r2 ? e2.createDiagnosticForNode(r2, i2, t2, o, s2, u) : e2.createCompilerDiagnostic(i2, t2, o, s2, u), z = rn.lookup(h2);
                return z || (rn.add(h2), h2);
              }
              function Es(r2, i2, t2, o, s2, u, h2) {
                var z = Xr(i2, t2, o, s2, u, h2);
                return z.skippedOn = r2, z;
              }
              function yc(r2, i2, t2, o, s2, u) {
                return r2 ? e2.createDiagnosticForNode(r2, i2, t2, o, s2, u) : e2.createCompilerDiagnostic(i2, t2, o, s2, u);
              }
              function Xr(r2, i2, t2, o, s2, u) {
                var h2 = yc(r2, i2, t2, o, s2, u);
                return rn.add(h2), h2;
              }
              function Ls(r2, i2) {
                r2 ? rn.add(i2) : jn.add(Ke(Ke({}, i2), { category: e2.DiagnosticCategory.Suggestion }));
              }
              function Ic(r2, i2, t2, o, s2, u, h2) {
                if (i2.pos < 0 || i2.end < 0) {
                  if (!r2)
                    return;
                  var z = e2.getSourceFileOfNode(i2);
                  Ls(r2, "message" in t2 ? e2.createFileDiagnostic(z, 0, 0, t2, o, s2, u, h2) : e2.createDiagnosticForFileFromMessageChain(z, t2));
                  return;
                }
                Ls(r2, "message" in t2 ? e2.createDiagnosticForNode(i2, t2, o, s2, u, h2) : e2.createDiagnosticForNodeFromMessageChain(i2, t2));
              }
              function zu(r2, i2, t2, o, s2, u, h2) {
                var z = Xr(r2, t2, o, s2, u, h2);
                if (i2) {
                  var me = e2.createDiagnosticForNode(r2, e2.Diagnostics.Did_you_forget_to_use_await);
                  e2.addRelatedInfo(z, me);
                }
                return z;
              }
              function vf(r2, i2) {
                var t2 = Array.isArray(r2) ? e2.forEach(r2, e2.getJSDocDeprecatedTag) : e2.getJSDocDeprecatedTag(r2);
                return t2 && e2.addRelatedInfo(i2, e2.createDiagnosticForNode(t2, e2.Diagnostics.The_declaration_was_marked_as_deprecated_here)), jn.add(i2), i2;
              }
              function P_(r2) {
                return !!(p0(r2) & 268435456);
              }
              function El(r2, i2, t2) {
                var o = e2.createDiagnosticForNode(r2, e2.Diagnostics._0_is_deprecated, t2);
                return vf(i2, o);
              }
              function vp(r2, i2, t2, o) {
                var s2 = t2 ? e2.createDiagnosticForNode(r2, e2.Diagnostics.The_signature_0_of_1_is_deprecated, o, t2) : e2.createDiagnosticForNode(r2, e2.Diagnostics._0_is_deprecated, o);
                return vf(i2, s2);
              }
              function oo(r2, i2, t2) {
                ge++;
                var o = new We(r2 | 33554432, i2);
                return o.checkFlags = t2 || 0, o;
              }
              function I_(r2) {
                var i2 = 0;
                return r2 & 2 && (i2 |= 111551), r2 & 1 && (i2 |= 111550), r2 & 4 && (i2 |= 0), r2 & 8 && (i2 |= 900095), r2 & 16 && (i2 |= 110991), r2 & 32 && (i2 |= 899503), r2 & 64 && (i2 |= 788872), r2 & 256 && (i2 |= 899327), r2 & 128 && (i2 |= 899967), r2 & 512 && (i2 |= 110735), r2 & 8192 && (i2 |= 103359), r2 & 32768 && (i2 |= 46015), r2 & 65536 && (i2 |= 78783), r2 & 262144 && (i2 |= 526824), r2 & 524288 && (i2 |= 788968), r2 & 2097152 && (i2 |= 2097152), i2;
              }
              function yp(r2, i2) {
                i2.mergeId || (i2.mergeId = E, E++), xl[i2.mergeId] = r2;
              }
              function Yl(r2) {
                var i2 = oo(r2.flags, r2.escapedName);
                return i2.declarations = r2.declarations ? r2.declarations.slice() : [], i2.parent = r2.parent, r2.valueDeclaration && (i2.valueDeclaration = r2.valueDeclaration), r2.constEnumOnlyModule && (i2.constEnumOnlyModule = true), r2.members && (i2.members = new e2.Map(r2.members)), r2.exports && (i2.exports = new e2.Map(r2.exports)), yp(i2, r2), i2;
              }
              function Bf(r2, i2, t2) {
                if (t2 === void 0 && (t2 = false), !(r2.flags & I_(i2.flags)) || (i2.flags | r2.flags) & 67108864) {
                  if (i2 === r2)
                    return r2;
                  if (!(r2.flags & 33554432)) {
                    var o = os(r2);
                    if (o === xe)
                      return i2;
                    r2 = Yl(o);
                  }
                  i2.flags & 512 && r2.flags & 512 && r2.constEnumOnlyModule && !i2.constEnumOnlyModule && (r2.constEnumOnlyModule = false), r2.flags |= i2.flags, i2.valueDeclaration && e2.setValueDeclaration(r2, i2.valueDeclaration), e2.addRange(r2.declarations, i2.declarations), i2.members && (r2.members || (r2.members = e2.createSymbolTable()), gu(r2.members, i2.members, t2)), i2.exports && (r2.exports || (r2.exports = e2.createSymbolTable()), gu(r2.exports, i2.exports, t2)), t2 || yp(r2, i2);
                } else if (r2.flags & 1024)
                  r2 !== pe && Xr(i2.declarations && e2.getNameOfDeclaration(i2.declarations[0]), e2.Diagnostics.Cannot_augment_module_0_with_value_exports_because_it_resolves_to_a_non_module_entity, tn(r2));
                else {
                  var s2 = !!(r2.flags & 384 || i2.flags & 384), u = !!(r2.flags & 2 || i2.flags & 2), h2 = s2 ? e2.Diagnostics.Enum_declarations_can_only_merge_with_namespace_or_other_enum_declarations : u ? e2.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : e2.Diagnostics.Duplicate_identifier_0, z = i2.declarations && e2.getSourceFileOfNode(i2.declarations[0]), me = r2.declarations && e2.getSourceFileOfNode(r2.declarations[0]), Me = e2.isPlainJsFile(z, ye.checkJs), $e = e2.isPlainJsFile(me, ye.checkJs), tr = tn(i2);
                  if (z && me && dn && !s2 && z !== me) {
                    var dr = e2.comparePaths(z.path, me.path) === -1 ? z : me, Dr = dr === z ? me : z, Qr = e2.getOrUpdate(dn, "".concat(dr.path, "|").concat(Dr.path), function() {
                      return { firstFile: dr, secondFile: Dr, conflictingSymbols: new e2.Map() };
                    }), li = e2.getOrUpdate(Qr.conflictingSymbols, tr, function() {
                      return { isBlockScoped: u, firstFileLocations: [], secondFileLocations: [] };
                    });
                    Me || Ti(li.firstFileLocations, i2), $e || Ti(li.secondFileLocations, r2);
                  } else
                    Me || Cl(i2, h2, tr, r2), $e || Cl(r2, h2, tr, i2);
                }
                return r2;
                function Ti(Ci, $i) {
                  if ($i.declarations)
                    for (var Zi = 0, qt = $i.declarations; Zi < qt.length; Zi++) {
                      var Nt = qt[Zi];
                      e2.pushIfUnique(Ci, Nt);
                    }
                }
              }
              function Cl(r2, i2, t2, o) {
                e2.forEach(r2.declarations, function(s2) {
                  c_(s2, i2, t2, o.declarations);
                });
              }
              function c_(r2, i2, t2, o) {
                for (var s2 = (e2.getExpandoInitializer(r2, false) ? e2.getNameOfExpando(r2) : e2.getNameOfDeclaration(r2)) || r2, u = Zo(s2, i2, t2), h2 = function($e) {
                  var tr = (e2.getExpandoInitializer($e, false) ? e2.getNameOfExpando($e) : e2.getNameOfDeclaration($e)) || $e;
                  if (tr === s2)
                    return "continue";
                  u.relatedInformation = u.relatedInformation || [];
                  var dr = e2.createDiagnosticForNode(tr, e2.Diagnostics._0_was_also_declared_here, t2), Dr = e2.createDiagnosticForNode(tr, e2.Diagnostics.and_here);
                  if (e2.length(u.relatedInformation) >= 5 || e2.some(u.relatedInformation, function(Qr) {
                    return e2.compareDiagnostics(Qr, Dr) === 0 || e2.compareDiagnostics(Qr, dr) === 0;
                  }))
                    return "continue";
                  e2.addRelatedInfo(u, e2.length(u.relatedInformation) ? Dr : dr);
                }, z = 0, me = o || e2.emptyArray; z < me.length; z++) {
                  var Me = me[z];
                  h2(Me);
                }
              }
              function hp(r2, i2) {
                if (!(r2 != null && r2.size))
                  return i2;
                if (!(i2 != null && i2.size))
                  return r2;
                var t2 = e2.createSymbolTable();
                return gu(t2, r2), gu(t2, i2), t2;
              }
              function gu(r2, i2, t2) {
                t2 === void 0 && (t2 = false), i2.forEach(function(o, s2) {
                  var u = r2.get(s2);
                  r2.set(s2, u ? Bf(u, o, t2) : o);
                });
              }
              function Dp(r2) {
                var i2, t2, o, s2 = r2.parent;
                if (((i2 = s2.symbol.declarations) === null || i2 === void 0 ? void 0 : i2[0]) !== s2) {
                  e2.Debug.assert(s2.symbol.declarations.length > 1);
                  return;
                }
                if (e2.isGlobalScopeAugmentation(s2))
                  gu(ii, s2.symbol.exports);
                else {
                  var u = r2.parent.parent.flags & 16777216 ? void 0 : e2.Diagnostics.Invalid_module_name_in_augmentation_module_0_cannot_be_found, h2 = Pl(r2, r2, u, true);
                  if (!h2)
                    return;
                  if (h2 = Us(h2), h2.flags & 1920)
                    if (e2.some(S2, function(Qr) {
                      return h2 === Qr.symbol;
                    })) {
                      var z = Bf(s2.symbol, h2, true);
                      Ce || (Ce = new e2.Map()), Ce.set(r2.text, z);
                    } else {
                      if (((t2 = h2.exports) === null || t2 === void 0 ? void 0 : t2.get("__export")) && ((o = s2.symbol.exports) === null || o === void 0 ? void 0 : o.size))
                        for (var me = Jv(h2, "resolvedExports"), Me = 0, $e = e2.arrayFrom(s2.symbol.exports.entries()); Me < $e.length; Me++) {
                          var tr = $e[Me], dr = tr[0], Dr = tr[1];
                          me.has(dr) && !h2.exports.has(dr) && Bf(me.get(dr), Dr);
                        }
                      Bf(h2, s2.symbol);
                    }
                  else
                    Xr(r2, e2.Diagnostics.Cannot_augment_module_0_because_it_resolves_to_a_non_module_entity, r2.text);
                }
              }
              function sd(r2, i2, t2) {
                i2.forEach(function(s2, u) {
                  var h2 = r2.get(u);
                  h2 ? e2.forEach(h2.declarations, o(e2.unescapeLeadingUnderscores(u), t2)) : r2.set(u, s2);
                });
                function o(s2, u) {
                  return function(h2) {
                    return rn.add(e2.createDiagnosticForNode(h2, u, s2));
                  };
                }
              }
              function Aa(r2) {
                if (r2.flags & 33554432)
                  return r2;
                var i2 = y(r2);
                return Ya[i2] || (Ya[i2] = new X());
              }
              function va(r2) {
                var i2 = A2(r2);
                return du[i2] || (du[i2] = new $());
              }
              function Cu(r2) {
                return r2.kind === 305 && !e2.isExternalOrCommonJsModule(r2);
              }
              function qs(r2, i2, t2) {
                if (t2) {
                  var o = so(r2.get(i2));
                  if (o) {
                    if (e2.Debug.assert((e2.getCheckFlags(o) & 1) === 0, "Should never get an instantiated symbol here."), o.flags & t2)
                      return o;
                    if (o.flags & 2097152) {
                      var s2 = Ps(o);
                      if (s2 === xe || s2.flags & t2)
                        return o;
                    }
                  }
                }
              }
              function cd(r2, i2) {
                var t2 = r2.parent, o = r2.parent.parent, s2 = qs(t2.locals, i2, 111551), u = qs(Nf(o.symbol), i2, 111551);
                return s2 && u ? [s2, u] : e2.Debug.fail("There should exist two symbols, one as property declaration and one as parameter declaration");
              }
              function ns(r2, i2) {
                var t2 = e2.getSourceFileOfNode(r2), o = e2.getSourceFileOfNode(i2), s2 = e2.getEnclosingBlockScopeContainer(r2);
                if (t2 !== o) {
                  if (er && (t2.externalModuleIndicator || o.externalModuleIndicator) || !e2.outFile(ye) || _m(i2) || r2.flags & 16777216 || Me(i2, r2))
                    return true;
                  var u = l.getSourceFiles();
                  return u.indexOf(t2) <= u.indexOf(o);
                }
                if (r2.pos <= i2.pos && !(e2.isPropertyDeclaration(r2) && e2.isThisProperty(i2.parent) && !r2.initializer && !r2.exclamationToken)) {
                  if (r2.kind === 203) {
                    var h2 = e2.getAncestor(i2, 203);
                    return h2 ? e2.findAncestor(h2, e2.isBindingElement) !== e2.findAncestor(r2, e2.isBindingElement) || r2.pos < h2.pos : ns(e2.getAncestor(r2, 254), i2);
                  } else {
                    if (r2.kind === 254)
                      return !me(r2, i2);
                    if (e2.isClassDeclaration(r2))
                      return !e2.findAncestor(i2, function(tr) {
                        return e2.isComputedPropertyName(tr) && tr.parent.parent === r2;
                      });
                    if (e2.isPropertyDeclaration(r2))
                      return !$e(r2, i2, false);
                    if (e2.isParameterPropertyDeclaration(r2, r2.parent))
                      return !(e2.getEmitScriptTarget(ye) === 99 && ir && e2.getContainingClass(r2) === e2.getContainingClass(i2) && Me(i2, r2));
                  }
                  return true;
                }
                if (i2.parent.kind === 275 || i2.parent.kind === 271 && i2.parent.isExportEquals || i2.kind === 271 && i2.isExportEquals || !!(i2.flags & 8388608) || _m(i2) || z())
                  return true;
                if (Me(i2, r2))
                  return e2.getEmitScriptTarget(ye) === 99 && ir && e2.getContainingClass(r2) && (e2.isPropertyDeclaration(r2) || e2.isParameterPropertyDeclaration(r2, r2.parent)) ? !$e(r2, i2, true) : true;
                return false;
                function z() {
                  return !!e2.findAncestor(i2, function(tr) {
                    return e2.isInterfaceDeclaration(tr) || e2.isTypeAliasDeclaration(tr);
                  });
                }
                function me(tr, dr) {
                  switch (tr.parent.parent.kind) {
                    case 237:
                    case 242:
                    case 244:
                      if (ol(dr, tr, s2))
                        return true;
                      break;
                  }
                  var Dr = tr.parent.parent;
                  return e2.isForInOrOfStatement(Dr) && ol(dr, Dr.expression, s2);
                }
                function Me(tr, dr) {
                  return !!e2.findAncestor(tr, function(Dr) {
                    if (Dr === s2)
                      return "quit";
                    if (e2.isFunctionLike(Dr))
                      return true;
                    if (e2.isClassStaticBlockDeclaration(Dr))
                      return dr.pos < tr.pos;
                    var Qr = e2.tryCast(Dr.parent, e2.isPropertyDeclaration);
                    if (Qr) {
                      var li = Qr.initializer === Dr;
                      if (li)
                        if (e2.isStatic(Dr.parent)) {
                          if (dr.kind === 169)
                            return true;
                          if (e2.isPropertyDeclaration(dr) && e2.getContainingClass(tr) === e2.getContainingClass(dr)) {
                            var Ti = dr.name;
                            if (e2.isIdentifier(Ti) || e2.isPrivateIdentifier(Ti)) {
                              var Ci = Jt(Et(dr)), $i = e2.filter(dr.parent.members, e2.isClassStaticBlockDeclaration);
                              if (DM(Ti, Ci, $i, dr.parent.pos, Dr.pos))
                                return true;
                            }
                          }
                        } else {
                          var Zi = dr.kind === 167 && !e2.isStatic(dr);
                          if (!Zi || e2.getContainingClass(tr) !== e2.getContainingClass(dr))
                            return true;
                        }
                    }
                    return false;
                  });
                }
                function $e(tr, dr, Dr) {
                  if (dr.end > tr.end)
                    return false;
                  var Qr = e2.findAncestor(dr, function(li) {
                    if (li === tr)
                      return "quit";
                    switch (li.kind) {
                      case 214:
                        return true;
                      case 167:
                        return Dr && (e2.isPropertyDeclaration(tr) && li.parent === tr.parent || e2.isParameterPropertyDeclaration(tr, tr.parent) && li.parent === tr.parent.parent) ? "quit" : true;
                      case 235:
                        switch (li.parent.kind) {
                          case 172:
                          case 169:
                          case 173:
                            return true;
                          default:
                            return false;
                        }
                      default:
                        return false;
                    }
                  });
                  return Qr === void 0;
                }
              }
              function nl(r2, i2, t2) {
                var o = e2.getEmitScriptTarget(ye), s2 = i2;
                if (e2.isParameter(t2) && s2.body && r2.valueDeclaration && r2.valueDeclaration.pos >= s2.body.pos && r2.valueDeclaration.end <= s2.body.end && o >= 2) {
                  var u = va(s2);
                  return u.declarationRequiresScopeChange === void 0 && (u.declarationRequiresScopeChange = e2.forEach(s2.parameters, h2) || false), !u.declarationRequiresScopeChange;
                }
                return false;
                function h2(me) {
                  return z(me.name) || !!me.initializer && z(me.initializer);
                }
                function z(me) {
                  switch (me.kind) {
                    case 214:
                    case 213:
                    case 256:
                    case 171:
                      return false;
                    case 169:
                    case 172:
                    case 173:
                    case 296:
                      return z(me.name);
                    case 167:
                      return e2.hasStaticModifier(me) ? o < 99 || !ir : z(me.name);
                    default:
                      return e2.isNullishCoalesce(me) || e2.isOptionalChain(me) ? o < 7 : e2.isBindingElement(me) && me.dotDotDotToken && e2.isObjectBindingPattern(me.parent) ? o < 4 : e2.isTypeNode(me) ? false : e2.forEachChild(me, z) || false;
                  }
                }
              }
              function hc(r2) {
                return e2.isAssertionExpression(r2) && e2.isConstTypeReference(r2.type) || e2.isJSDocTypeTag(r2) && e2.isConstTypeReference(r2.typeExpression);
              }
              function es(r2, i2, t2, o, s2, u, h2, z) {
                return h2 === void 0 && (h2 = false), z === void 0 && (z = true), u_(r2, i2, t2, o, s2, u, h2, z, qs);
              }
              function u_(r2, i2, t2, o, s2, u, h2, z, me) {
                var Me, $e, tr, dr = r2, Dr, Qr, li, Ti, Ci, $i = false, Zi = r2, qt, Nt = false;
                e:
                  for (; r2; ) {
                    if (i2 === "const" && hc(r2))
                      return;
                    if (r2.locals && !Cu(r2) && (Dr = me(r2.locals, i2, t2))) {
                      var Ra = true;
                      if (e2.isFunctionLike(r2) && Qr && Qr !== r2.body ? (t2 & Dr.flags & 788968 && Qr.kind !== 320 && (Ra = Dr.flags & 262144 ? Qr === r2.type || Qr.kind === 164 || Qr.kind === 340 || Qr.kind === 341 || Qr.kind === 163 : false), t2 & Dr.flags & 3 && (nl(Dr, r2, Qr) ? Ra = false : Dr.flags & 1 && (Ra = Qr.kind === 164 || Qr === r2.type && !!e2.findAncestor(Dr.valueDeclaration, e2.isParameter)))) : r2.kind === 189 && (Ra = Qr === r2.trueType), Ra)
                        break e;
                      Dr = void 0;
                    }
                    switch ($i = $i || w_(r2, Qr), r2.kind) {
                      case 305:
                        if (!e2.isExternalOrCommonJsModule(r2))
                          break;
                        Nt = true;
                      case 261:
                        var ca = ((Me = Et(r2)) === null || Me === void 0 ? void 0 : Me.exports) || we;
                        if (r2.kind === 305 || e2.isModuleDeclaration(r2) && r2.flags & 16777216 && !e2.isGlobalScopeAugmentation(r2)) {
                          if (Dr = ca.get("default")) {
                            var Sn = e2.getLocalSymbolForExportDefault(Dr);
                            if (Sn && Dr.flags & t2 && Sn.escapedName === i2)
                              break e;
                            Dr = void 0;
                          }
                          var ja = ca.get(i2);
                          if (ja && ja.flags === 2097152 && (e2.getDeclarationOfKind(ja, 275) || e2.getDeclarationOfKind(ja, 274)))
                            break;
                        }
                        if (i2 !== "default" && (Dr = me(ca, i2, t2 & 2623475)))
                          if (e2.isSourceFile(r2) && r2.commonJsModuleIndicator && !(!(($e = Dr.declarations) === null || $e === void 0) && $e.some(e2.isJSDocTypeAlias)))
                            Dr = void 0;
                          else
                            break e;
                        break;
                      case 260:
                        if (Dr = me(((tr = Et(r2)) === null || tr === void 0 ? void 0 : tr.exports) || we, i2, t2 & 8))
                          break e;
                        break;
                      case 167:
                        if (!e2.isStatic(r2)) {
                          var Fn = Tf(r2.parent);
                          Fn && Fn.locals && me(Fn.locals, i2, t2 & 111551) && (Ti = r2);
                        }
                        break;
                      case 257:
                      case 226:
                      case 258:
                        if (Dr = me(Et(r2).members || we, i2, t2 & 788968)) {
                          if (!ld(Dr, r2)) {
                            Dr = void 0;
                            break;
                          }
                          if (Qr && e2.isStatic(Qr)) {
                            Xr(Zi, e2.Diagnostics.Static_members_cannot_reference_class_type_parameters);
                            return;
                          }
                          break e;
                        }
                        if (r2.kind === 226 && t2 & 32) {
                          var wn = r2.name;
                          if (wn && i2 === wn.escapedText) {
                            Dr = r2.symbol;
                            break e;
                          }
                        }
                        break;
                      case 228:
                        if (Qr === r2.expression && r2.parent.token === 94) {
                          var Tn = r2.parent.parent;
                          if (e2.isClassLike(Tn) && (Dr = me(Et(Tn).members, i2, t2 & 788968))) {
                            o && Xr(Zi, e2.Diagnostics.Base_class_expressions_cannot_reference_class_type_parameters);
                            return;
                          }
                        }
                        break;
                      case 162:
                        if (qt = r2.parent.parent, (e2.isClassLike(qt) || qt.kind === 258) && (Dr = me(Et(qt).members, i2, t2 & 788968))) {
                          Xr(Zi, e2.Diagnostics.A_computed_property_name_cannot_reference_a_type_parameter_from_its_containing_type);
                          return;
                        }
                        break;
                      case 214:
                        if (e2.getEmitScriptTarget(ye) >= 2)
                          break;
                      case 169:
                      case 171:
                      case 172:
                      case 173:
                      case 256:
                        if (t2 & 3 && i2 === "arguments") {
                          Dr = or;
                          break e;
                        }
                        break;
                      case 213:
                        if (t2 & 3 && i2 === "arguments") {
                          Dr = or;
                          break e;
                        }
                        if (t2 & 16) {
                          var Eo = r2.name;
                          if (Eo && i2 === Eo.escapedText) {
                            Dr = r2.symbol;
                            break e;
                          }
                        }
                        break;
                      case 165:
                        r2.parent && r2.parent.kind === 164 && (r2 = r2.parent), r2.parent && (e2.isClassElement(r2.parent) || r2.parent.kind === 257) && (r2 = r2.parent);
                        break;
                      case 345:
                      case 338:
                      case 339:
                        var lt = e2.getJSDocRoot(r2);
                        lt && (r2 = lt.parent);
                        break;
                      case 164:
                        Qr && (Qr === r2.initializer || Qr === r2.name && e2.isBindingPattern(Qr)) && (Ci || (Ci = r2));
                        break;
                      case 203:
                        Qr && (Qr === r2.initializer || Qr === r2.name && e2.isBindingPattern(Qr)) && e2.isParameterDeclaration(r2) && !Ci && (Ci = r2);
                        break;
                      case 190:
                        if (t2 & 262144) {
                          var it = r2.typeParameter.name;
                          if (it && i2 === it.escapedText) {
                            Dr = r2.typeParameter.symbol;
                            break e;
                          }
                        }
                        break;
                    }
                    ud(r2) && (li = r2), Qr = r2, r2 = e2.isJSDocTemplateTag(r2) ? e2.getEffectiveContainerForJSDocTemplateTag(r2) || r2.parent : (e2.isJSDocParameterTag(r2) || e2.isJSDocReturnTag(r2)) && e2.getHostSignatureFromJSDoc(r2) || r2.parent;
                  }
                if (u && Dr && (!li || Dr !== li.symbol) && (Dr.isReferenced |= t2), !Dr) {
                  if (Qr && (e2.Debug.assert(Qr.kind === 305), Qr.commonJsModuleIndicator && i2 === "exports" && t2 & Qr.symbol.flags))
                    return Qr.symbol;
                  h2 || (Dr = me(ii, i2, t2));
                }
                if (!Dr && dr && e2.isInJSFile(dr) && dr.parent && e2.isRequireCall(dr.parent, false))
                  return qr;
                if (!Dr) {
                  o && fe(function() {
                    if (!Zi || !fd(Zi, i2, s2) && !bp(Zi) && !Tp(Zi, i2, t2) && !O_(Zi, i2) && !F_(Zi, i2, t2) && !M_(Zi, i2, t2) && !_d2(Zi, i2, t2)) {
                      var Ia = void 0;
                      if (z && Uu < Ql) {
                        Ia = Kb(dr, i2, t2);
                        var Qt = (Ia == null ? void 0 : Ia.valueDeclaration) && e2.isAmbientModule(Ia.valueDeclaration) && e2.isGlobalScopeAugmentation(Ia.valueDeclaration);
                        if (Qt && (Ia = void 0), Ia) {
                          var Ka = tn(Ia), cn = Wb(dr, Ia, false), Un = t2 === 1920 || s2 && typeof s2 != "string" && e2.nodeIsSynthesized(s2) ? e2.Diagnostics.Cannot_find_namespace_0_Did_you_mean_1 : cn ? e2.Diagnostics.Could_not_find_name_0_Did_you_mean_1 : e2.Diagnostics.Cannot_find_name_0_Did_you_mean_1, oa = yc(Zi, Un, ku(s2), Ka);
                          Ls(!cn, oa), Ia.valueDeclaration && e2.addRelatedInfo(oa, e2.createDiagnosticForNode(Ia.valueDeclaration, e2.Diagnostics._0_is_declared_here, Ka));
                        }
                      }
                      if (!Ia && s2) {
                        var Mn = $5(s2);
                        Mn ? Xr(Zi, o, ku(s2), Mn) : Xr(Zi, o, ku(s2));
                      }
                      Uu++;
                    }
                  });
                  return;
                }
                if (Ti && !(e2.getEmitScriptTarget(ye) === 99 && ir)) {
                  var Yt = Ti.name;
                  Xr(Zi, e2.Diagnostics.Initializer_of_instance_member_variable_0_cannot_reference_identifier_1_declared_in_the_constructor, e2.declarationNameToString(Yt), ku(s2));
                  return;
                }
                return o && fe(function() {
                  if (Zi && (t2 & 2 || (t2 & 32 || t2 & 384) && (t2 & 111551) === 111551)) {
                    var Ia = cu(Dr);
                    (Ia.flags & 2 || Ia.flags & 32 || Ia.flags & 384) && Ep(Ia, Zi);
                  }
                  if (Dr && Nt && (t2 & 111551) === 111551 && !(dr.flags & 8388608)) {
                    var Qt = so(Dr);
                    e2.length(Qt.declarations) && e2.every(Qt.declarations, function(Ln) {
                      return e2.isNamespaceExportDeclaration(Ln) || e2.isSourceFile(Ln) && !!Ln.symbol.globalExports;
                    }) && Ic(!ye.allowUmdGlobalAccess, Zi, e2.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead, e2.unescapeLeadingUnderscores(i2));
                  }
                  if (Dr && Ci && !$i && (t2 & 111551) === 111551) {
                    var Ka = so(dg(Dr)), cn = e2.getRootDeclaration(Ci);
                    Ka === Et(Ci) ? Xr(Zi, e2.Diagnostics.Parameter_0_cannot_reference_itself, e2.declarationNameToString(Ci.name)) : Ka.valueDeclaration && Ka.valueDeclaration.pos > Ci.pos && cn.parent.locals && me(cn.parent.locals, Ka.escapedName, t2) === Ka && Xr(Zi, e2.Diagnostics.Parameter_0_cannot_reference_identifier_1_declared_after_it, e2.declarationNameToString(Ci.name), e2.declarationNameToString(Zi));
                  }
                  if (Dr && Zi && t2 & 111551 && Dr.flags & 2097152 && !(Dr.flags & 111551) && !e2.isValidTypeOnlyAliasUseSite(Zi)) {
                    var Un = vu(Dr);
                    if (Un) {
                      var oa = Un.kind === 275 ? e2.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_exported_using_export_type : e2.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type, Mn = e2.unescapeLeadingUnderscores(i2);
                      Jf(Xr(Zi, oa, Mn), Un, Mn);
                    }
                  }
                }), Dr;
              }
              function Jf(r2, i2, t2) {
                return i2 ? e2.addRelatedInfo(r2, e2.createDiagnosticForNode(i2, i2.kind === 275 ? e2.Diagnostics._0_was_exported_here : e2.Diagnostics._0_was_imported_here, t2)) : r2;
              }
              function w_(r2, i2) {
                return r2.kind !== 214 && r2.kind !== 213 ? e2.isTypeQueryNode(r2) || (e2.isFunctionLikeDeclaration(r2) || r2.kind === 167 && !e2.isStatic(r2)) && (!i2 || i2 !== r2.name) : i2 && i2 === r2.name ? false : r2.asteriskToken || e2.hasSyntacticModifier(r2, 256) ? true : !e2.getImmediatelyInvokedFunctionExpression(r2);
              }
              function ud(r2) {
                switch (r2.kind) {
                  case 256:
                  case 257:
                  case 258:
                  case 260:
                  case 259:
                  case 261:
                    return true;
                  default:
                    return false;
                }
              }
              function ku(r2) {
                return e2.isString(r2) ? e2.unescapeLeadingUnderscores(r2) : e2.declarationNameToString(r2);
              }
              function ld(r2, i2) {
                if (r2.declarations)
                  for (var t2 = 0, o = r2.declarations; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (s2.kind === 163) {
                      var u = e2.isJSDocTemplateTag(s2.parent) ? e2.getJSDocHost(s2.parent) : s2.parent;
                      if (u === i2)
                        return !(e2.isJSDocTemplateTag(s2.parent) && e2.find(s2.parent.parent.tags, e2.isJSDocTypeAlias));
                    }
                  }
                return false;
              }
              function fd(r2, i2, t2) {
                if (!e2.isIdentifier(r2) || r2.escapedText !== i2 || Q6(r2) || _m(r2))
                  return false;
                for (var o = e2.getThisContainer(r2, false), s2 = o; s2; ) {
                  if (e2.isClassLike(s2.parent)) {
                    var u = Et(s2.parent);
                    if (!u)
                      break;
                    var h2 = Jt(u);
                    if (bi(h2, i2))
                      return Xr(r2, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0, ku(t2), tn(u)), true;
                    if (s2 === o && !e2.isStatic(s2)) {
                      var z = go(u).thisType;
                      if (bi(z, i2))
                        return Xr(r2, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0, ku(t2)), true;
                    }
                  }
                  s2 = s2.parent;
                }
                return false;
              }
              function bp(r2) {
                var i2 = Sp(r2);
                return i2 && Ds(i2, 64, true) ? (Xr(r2, e2.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements, e2.getTextOfNode(i2)), true) : false;
              }
              function Sp(r2) {
                switch (r2.kind) {
                  case 79:
                  case 206:
                    return r2.parent ? Sp(r2.parent) : void 0;
                  case 228:
                    if (e2.isEntityNameExpression(r2.expression))
                      return r2.expression;
                  default:
                    return;
                }
              }
              function Tp(r2, i2, t2) {
                var o = 1920 | (e2.isInJSFile(r2) ? 111551 : 0);
                if (t2 === o) {
                  var s2 = os(es(r2, i2, 788968 & ~o, void 0, void 0, false)), u = r2.parent;
                  if (s2) {
                    if (e2.isQualifiedName(u)) {
                      e2.Debug.assert(u.left === r2, "Should only be resolving left side of qualified name as a namespace");
                      var h2 = u.right.escapedText, z = bi(go(s2), h2);
                      if (z)
                        return Xr(u, e2.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1, e2.unescapeLeadingUnderscores(i2), e2.unescapeLeadingUnderscores(h2)), true;
                    }
                    return Xr(r2, e2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_namespace_here, e2.unescapeLeadingUnderscores(i2)), true;
                  }
                }
                return false;
              }
              function _d2(r2, i2, t2) {
                if (t2 & 788584) {
                  var o = os(es(r2, i2, 111127, void 0, void 0, false));
                  if (o && !(o.flags & 1920))
                    return Xr(r2, e2.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, e2.unescapeLeadingUnderscores(i2)), true;
                }
                return false;
              }
              function jf(r2) {
                return r2 === "any" || r2 === "string" || r2 === "number" || r2 === "boolean" || r2 === "never" || r2 === "unknown";
              }
              function O_(r2, i2) {
                return jf(i2) && r2.parent.kind === 275 ? (Xr(r2, e2.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, i2), true) : false;
              }
              function F_(r2, i2, t2) {
                if (t2 & 111551) {
                  if (jf(i2))
                    return Xr(r2, e2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, e2.unescapeLeadingUnderscores(i2)), true;
                  var o = os(es(r2, i2, 788544, void 0, void 0, false));
                  if (o && !(o.flags & 1024)) {
                    var s2 = e2.unescapeLeadingUnderscores(i2);
                    return xp(i2) ? Xr(r2, e2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_es2015_or_later, s2) : pd(r2, o) ? Xr(r2, e2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0, s2, s2 === "K" ? "P" : "K") : Xr(r2, e2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here, s2), true;
                  }
                }
                return false;
              }
              function pd(r2, i2) {
                var t2 = e2.findAncestor(r2.parent, function(s2) {
                  return e2.isComputedPropertyName(s2) || e2.isPropertySignature(s2) ? false : e2.isTypeLiteralNode(s2) || "quit";
                });
                if (t2 && t2.members.length === 1) {
                  var o = go(i2);
                  return !!(o.flags & 1048576) && Lg(o, 384, true);
                }
                return false;
              }
              function xp(r2) {
                switch (r2) {
                  case "Promise":
                  case "Symbol":
                  case "Map":
                  case "WeakMap":
                  case "Set":
                  case "WeakSet":
                    return true;
                }
                return false;
              }
              function M_(r2, i2, t2) {
                if (t2 & 111127) {
                  var o = os(es(r2, i2, 1024, void 0, void 0, false));
                  if (o)
                    return Xr(r2, e2.Diagnostics.Cannot_use_namespace_0_as_a_value, e2.unescapeLeadingUnderscores(i2)), true;
                } else if (t2 & 788544) {
                  var o = os(es(r2, i2, 1536, void 0, void 0, false));
                  if (o)
                    return Xr(r2, e2.Diagnostics.Cannot_use_namespace_0_as_a_type, e2.unescapeLeadingUnderscores(i2)), true;
                }
                return false;
              }
              function Ep(r2, i2) {
                var t2;
                if (e2.Debug.assert(!!(r2.flags & 2 || r2.flags & 32 || r2.flags & 384)), !(r2.flags & 67108881 && r2.flags & 32)) {
                  var o = (t2 = r2.declarations) === null || t2 === void 0 ? void 0 : t2.find(function(h2) {
                    return e2.isBlockOrCatchScoped(h2) || e2.isClassLike(h2) || h2.kind === 260;
                  });
                  if (o === void 0)
                    return e2.Debug.fail("checkResolvedBlockScopedVariable could not find block-scoped declaration");
                  if (!(o.flags & 16777216) && !ns(o, i2)) {
                    var s2 = void 0, u = e2.declarationNameToString(e2.getNameOfDeclaration(o));
                    r2.flags & 2 ? s2 = Xr(i2, e2.Diagnostics.Block_scoped_variable_0_used_before_its_declaration, u) : r2.flags & 32 ? s2 = Xr(i2, e2.Diagnostics.Class_0_used_before_its_declaration, u) : r2.flags & 256 ? s2 = Xr(i2, e2.Diagnostics.Enum_0_used_before_its_declaration, u) : (e2.Debug.assert(!!(r2.flags & 128)), e2.shouldPreserveConstEnums(ye) && (s2 = Xr(i2, e2.Diagnostics.Enum_0_used_before_its_declaration, u))), s2 && e2.addRelatedInfo(s2, e2.createDiagnosticForNode(o, e2.Diagnostics._0_is_declared_here, u));
                  }
                }
              }
              function ol(r2, i2, t2) {
                return !!i2 && !!e2.findAncestor(r2, function(o) {
                  return o === i2 || (o === t2 || e2.isFunctionLike(o) && !e2.getImmediatelyInvokedFunctionExpression(o) ? "quit" : false);
                });
              }
              function Au(r2) {
                switch (r2.kind) {
                  case 265:
                    return r2;
                  case 267:
                    return r2.parent;
                  case 268:
                    return r2.parent.parent;
                  case 270:
                    return r2.parent.parent.parent;
                  default:
                    return;
                }
              }
              function ru(r2) {
                return r2.declarations && e2.findLast(r2.declarations, yf);
              }
              function yf(r2) {
                return r2.kind === 265 || r2.kind === 264 || r2.kind === 267 && !!r2.name || r2.kind === 268 || r2.kind === 274 || r2.kind === 270 || r2.kind === 275 || r2.kind === 271 && e2.exportAssignmentIsAlias(r2) || e2.isBinaryExpression(r2) && e2.getAssignmentDeclarationKind(r2) === 2 && e2.exportAssignmentIsAlias(r2) || e2.isAccessExpression(r2) && e2.isBinaryExpression(r2.parent) && r2.parent.left === r2 && r2.parent.operatorToken.kind === 63 && Cp(r2.parent.right) || r2.kind === 297 || r2.kind === 296 && Cp(r2.initializer) || e2.isVariableDeclarationInitializedToBareOrAccessedRequire(r2);
              }
              function Cp(r2) {
                return e2.isAliasableExpression(r2) || e2.isFunctionExpression(r2) && Sl(r2);
              }
              function dd(r2, i2) {
                var t2 = wc(r2);
                if (t2) {
                  var o = e2.getLeftmostAccessExpression(t2.expression).arguments[0];
                  return e2.isIdentifier(t2.name) ? os(bi(Hm(o), t2.name.escapedText)) : void 0;
                }
                if (e2.isVariableDeclaration(r2) || r2.moduleReference.kind === 277) {
                  var s2 = ac(r2, e2.getExternalModuleRequireArgument(r2) || e2.getExternalModuleImportEqualsDeclarationExpression(r2)), u = Us(s2);
                  return Gc(r2, s2, u, false), u;
                }
                var h2 = Nl(r2.moduleReference, i2);
                return kp(r2, h2), h2;
              }
              function kp(r2, i2) {
                if (Gc(r2, void 0, i2, false) && !r2.isTypeOnly) {
                  var t2 = vu(Et(r2)), o = t2.kind === 275, s2 = o ? e2.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_exported_using_export_type : e2.Diagnostics.An_import_alias_cannot_reference_a_declaration_that_was_imported_using_import_type, u = o ? e2.Diagnostics._0_was_exported_here : e2.Diagnostics._0_was_imported_here, h2 = e2.unescapeLeadingUnderscores(t2.name.escapedText);
                  e2.addRelatedInfo(Xr(r2.moduleReference, s2), e2.createDiagnosticForNode(t2, u, h2));
                }
              }
              function mu(r2, i2, t2, o) {
                var s2 = r2.exports.get("export="), u = s2 ? bi(Jt(s2), i2) : r2.exports.get(i2), h2 = os(u, o);
                return Gc(t2, u, h2, false), h2;
              }
              function gd(r2) {
                return e2.isExportAssignment(r2) && !r2.isExportEquals || e2.hasSyntacticModifier(r2, 512) || e2.isExportSpecifier(r2);
              }
              function hf(r2) {
                return e2.isStringLiteralLike(r2) ? e2.getModeForUsageLocation(e2.getSourceFileOfNode(r2), r2) : void 0;
              }
              function $l(r2, i2) {
                return r2 === e2.ModuleKind.ESNext && i2 === e2.ModuleKind.CommonJS;
              }
              function Uf(r2) {
                var i2 = hf(r2);
                return i2 === e2.ModuleKind.ESNext && e2.endsWith(r2.text, ".json");
              }
              function L_(r2, i2, t2, o) {
                var s2 = r2 && hf(o);
                if (r2 && s2 !== void 0) {
                  var u = $l(s2, r2.impliedNodeFormat);
                  if (s2 === e2.ModuleKind.ESNext || u)
                    return u;
                }
                if (!Cr)
                  return false;
                if (!r2 || r2.isDeclarationFile) {
                  var h2 = mu(i2, "default", void 0, true);
                  return !(h2 && e2.some(h2.declarations, gd) || mu(i2, e2.escapeLeadingUnderscores("__esModule"), void 0, t2));
                }
                return e2.isSourceFileJS(r2) ? !r2.externalModuleIndicator && !mu(i2, e2.escapeLeadingUnderscores("__esModule"), void 0, t2) : ll(i2);
              }
              function l_(r2, i2) {
                var t2, o = ac(r2, r2.parent.moduleSpecifier);
                if (o) {
                  var s2 = void 0;
                  e2.isShorthandAmbientModuleSymbol(o) ? s2 = o : s2 = mu(o, "default", r2, i2);
                  var u = (t2 = o.declarations) === null || t2 === void 0 ? void 0 : t2.find(e2.isSourceFile), h2 = Uf(r2.parent.moduleSpecifier), z = L_(u, o, i2, r2.parent.moduleSpecifier);
                  if (!s2 && !z && !h2)
                    if (ll(o)) {
                      var me = er >= e2.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop", Me = o.exports.get("export="), $e = Me.valueDeclaration, tr = Xr(r2.name, e2.Diagnostics.Module_0_can_only_be_default_imported_using_the_1_flag, tn(o), me);
                      $e && e2.addRelatedInfo(tr, e2.createDiagnosticForNode($e, e2.Diagnostics.This_module_is_declared_with_using_export_and_can_only_be_used_with_a_default_import_when_using_the_0_flag, me));
                    } else
                      f_(o, r2);
                  else if (z || h2) {
                    var dr = Us(o, i2) || os(o, i2);
                    return Gc(r2, o, dr, false), dr;
                  }
                  return Gc(r2, s2, void 0, false), s2;
                }
              }
              function f_(r2, i2) {
                var t2, o, s2;
                if (!((t2 = r2.exports) === null || t2 === void 0) && t2.has(i2.symbol.escapedName))
                  Xr(i2.name, e2.Diagnostics.Module_0_has_no_default_export_Did_you_mean_to_use_import_1_from_0_instead, tn(r2), tn(i2.symbol));
                else {
                  var u = Xr(i2.name, e2.Diagnostics.Module_0_has_no_default_export, tn(r2)), h2 = (o = r2.exports) === null || o === void 0 ? void 0 : o.get("__export");
                  if (h2) {
                    var z = (s2 = h2.declarations) === null || s2 === void 0 ? void 0 : s2.find(function(me) {
                      var Me, $e;
                      return !!(e2.isExportDeclaration(me) && me.moduleSpecifier && (($e = (Me = ac(me, me.moduleSpecifier)) === null || Me === void 0 ? void 0 : Me.exports) === null || $e === void 0 ? void 0 : $e.has("default")));
                    });
                    z && e2.addRelatedInfo(u, e2.createDiagnosticForNode(z, e2.Diagnostics.export_Asterisk_does_not_re_export_a_default));
                  }
                }
              }
              function md(r2, i2) {
                var t2 = r2.parent.parent.moduleSpecifier, o = ac(r2, t2), s2 = Wf(o, t2, i2, false);
                return Gc(r2, o, s2, false), s2;
              }
              function ks(r2, i2) {
                var t2 = r2.parent.moduleSpecifier, o = t2 && ac(r2, t2), s2 = t2 && Wf(o, t2, i2, false);
                return Gc(r2, o, s2, false), s2;
              }
              function Wu(r2, i2) {
                if (r2 === xe && i2 === xe)
                  return xe;
                if (r2.flags & 790504)
                  return r2;
                var t2 = oo(r2.flags | i2.flags, r2.escapedName);
                return t2.declarations = e2.deduplicate(e2.concatenate(r2.declarations, i2.declarations), e2.equateValues), t2.parent = r2.parent || i2.parent, r2.valueDeclaration && (t2.valueDeclaration = r2.valueDeclaration), i2.members && (t2.members = new e2.Map(i2.members)), r2.exports && (t2.exports = new e2.Map(r2.exports)), t2;
              }
              function Zl(r2, i2, t2, o) {
                if (r2.flags & 1536) {
                  var s2 = dc(r2).get(i2.escapedText), u = os(s2, o);
                  return Gc(t2, s2, u, false), u;
                }
              }
              function R_(r2, i2) {
                if (r2.flags & 3) {
                  var t2 = r2.valueDeclaration.type;
                  if (t2)
                    return os(bi(Va(t2), i2));
                }
              }
              function kl(r2, i2, t2) {
                var o, s2;
                t2 === void 0 && (t2 = false);
                var u = e2.getExternalModuleRequireArgument(r2) || r2.moduleSpecifier, h2 = ac(r2, u), z = !e2.isPropertyAccessExpression(i2) && i2.propertyName || i2.name;
                if (!!e2.isIdentifier(z)) {
                  var me = z.escapedText === "default" && !!(ye.allowSyntheticDefaultImports || e2.getESModuleInterop(ye)), Me = Wf(h2, u, false, me);
                  if (Me && z.escapedText) {
                    if (e2.isShorthandAmbientModuleSymbol(h2))
                      return h2;
                    var $e = void 0;
                    h2 && h2.exports && h2.exports.get("export=") ? $e = bi(Jt(Me), z.escapedText, true) : $e = R_(Me, z.escapedText), $e = os($e, t2);
                    var tr = Zl(Me, z, i2, t2);
                    if (tr === void 0 && z.escapedText === "default") {
                      var dr = (o = h2.declarations) === null || o === void 0 ? void 0 : o.find(e2.isSourceFile);
                      (Uf(u) || L_(dr, h2, t2, u)) && (tr = Us(h2, t2) || os(h2, t2));
                    }
                    var Dr = tr && $e && tr !== $e ? Wu($e, tr) : tr || $e;
                    if (!Dr) {
                      var Qr = cl(h2, r2), li = e2.declarationNameToString(z), Ti = v0(z, Me);
                      if (Ti !== void 0) {
                        var Ci = tn(Ti), $i = Xr(z, e2.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, Qr, li, Ci);
                        Ti.valueDeclaration && e2.addRelatedInfo($i, e2.createDiagnosticForNode(Ti.valueDeclaration, e2.Diagnostics._0_is_declared_here, Ci));
                      } else
                        !((s2 = h2.exports) === null || s2 === void 0) && s2.has("default") ? Xr(z, e2.Diagnostics.Module_0_has_no_exported_member_1_Did_you_mean_to_use_import_1_from_0_instead, Qr, li) : __(r2, z, li, h2, Qr);
                    }
                    return Dr;
                  }
                }
              }
              function __(r2, i2, t2, o, s2) {
                var u, h2, z = (h2 = (u = o.valueDeclaration) === null || u === void 0 ? void 0 : u.locals) === null || h2 === void 0 ? void 0 : h2.get(i2.escapedText), me = o.exports;
                if (z) {
                  var Me = me == null ? void 0 : me.get("export=");
                  if (Me)
                    _l(Me, z) ? zd(r2, i2, t2, s2) : Xr(i2, e2.Diagnostics.Module_0_has_no_exported_member_1, s2, t2);
                  else {
                    var $e = me ? e2.find(Y_(me), function(dr) {
                      return !!_l(dr, z);
                    }) : void 0, tr = $e ? Xr(i2, e2.Diagnostics.Module_0_declares_1_locally_but_it_is_exported_as_2, s2, t2, tn($e)) : Xr(i2, e2.Diagnostics.Module_0_declares_1_locally_but_it_is_not_exported, s2, t2);
                    z.declarations && e2.addRelatedInfo.apply(void 0, Ve([tr], e2.map(z.declarations, function(dr, Dr) {
                      return e2.createDiagnosticForNode(dr, Dr === 0 ? e2.Diagnostics._0_is_declared_here : e2.Diagnostics.and_here, t2);
                    }), false));
                  }
                } else
                  Xr(i2, e2.Diagnostics.Module_0_has_no_exported_member_1, s2, t2);
              }
              function zd(r2, i2, t2, o) {
                if (er >= e2.ModuleKind.ES2015) {
                  var s2 = e2.getESModuleInterop(ye) ? e2.Diagnostics._0_can_only_be_imported_by_using_a_default_import : e2.Diagnostics._0_can_only_be_imported_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
                  Xr(i2, s2, t2);
                } else if (e2.isInJSFile(r2)) {
                  var s2 = e2.getESModuleInterop(ye) ? e2.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_using_a_default_import : e2.Diagnostics._0_can_only_be_imported_by_using_a_require_call_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
                  Xr(i2, s2, t2);
                } else {
                  var s2 = e2.getESModuleInterop(ye) ? e2.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_a_default_import : e2.Diagnostics._0_can_only_be_imported_by_using_import_1_require_2_or_by_turning_on_the_esModuleInterop_flag_and_using_a_default_import;
                  Xr(i2, s2, t2, t2, o);
                }
              }
              function Al(r2, i2) {
                var t2 = e2.isBindingElement(r2) ? e2.getRootDeclaration(r2) : r2.parent.parent.parent, o = wc(t2), s2 = kl(t2, o || r2, i2), u = r2.propertyName || r2.name;
                return o && s2 && e2.isIdentifier(u) ? os(bi(Jt(s2), u.escapedText), i2) : (Gc(r2, void 0, s2, false), s2);
              }
              function wc(r2) {
                if (e2.isVariableDeclaration(r2) && r2.initializer && e2.isPropertyAccessExpression(r2.initializer))
                  return r2.initializer;
              }
              function qu(r2, i2) {
                var t2 = Us(r2.parent.symbol, i2);
                return Gc(r2, void 0, t2, false), t2;
              }
              function Vu(r2, i2, t2) {
                var o = r2.parent.parent.moduleSpecifier ? kl(r2.parent.parent, r2, t2) : Ds(r2.propertyName || r2.name, i2, false, t2);
                return Gc(r2, void 0, o, false), o;
              }
              function ef(r2, i2) {
                var t2 = e2.isExportAssignment(r2) ? r2.expression : r2.right, o = sl(t2, i2);
                return Gc(r2, void 0, o, false), o;
              }
              function sl(r2, i2) {
                if (e2.isClassExpression(r2))
                  return Os(r2).symbol;
                if (!(!e2.isEntityName(r2) && !e2.isEntityNameExpression(r2))) {
                  var t2 = Ds(r2, 901119, true, i2);
                  return t2 || (Os(r2), va(r2).resolvedSymbol);
                }
              }
              function p_(r2, i2) {
                var t2 = r2.initializer;
                return sl(t2, i2);
              }
              function Df(r2, i2) {
                if (!!(e2.isBinaryExpression(r2.parent) && r2.parent.left === r2 && r2.parent.operatorToken.kind === 63))
                  return sl(r2.parent.right, i2);
              }
              function Ec(r2, i2) {
                switch (i2 === void 0 && (i2 = false), r2.kind) {
                  case 265:
                  case 254:
                    return dd(r2, i2);
                  case 267:
                    return l_(r2, i2);
                  case 268:
                    return md(r2, i2);
                  case 274:
                    return ks(r2, i2);
                  case 270:
                  case 203:
                    return Al(r2, i2);
                  case 275:
                    return Vu(r2, 901119, i2);
                  case 271:
                  case 221:
                    return ef(r2, i2);
                  case 264:
                    return qu(r2, i2);
                  case 297:
                    return Ds(r2.name, 901119, true, i2);
                  case 296:
                    return p_(r2, i2);
                  case 207:
                  case 206:
                    return Df(r2, i2);
                  default:
                    return e2.Debug.fail();
                }
              }
              function Zn(r2, i2) {
                return i2 === void 0 && (i2 = 901119), r2 ? (r2.flags & (2097152 | i2)) === 2097152 || !!(r2.flags & 2097152 && r2.flags & 67108864) : false;
              }
              function os(r2, i2) {
                return !i2 && Zn(r2) ? Ps(r2) : r2;
              }
              function Ps(r2) {
                e2.Debug.assert((r2.flags & 2097152) !== 0, "Should only get Alias here.");
                var i2 = Aa(r2);
                if (i2.aliasTarget)
                  i2.aliasTarget === vr && (i2.aliasTarget = xe);
                else {
                  i2.aliasTarget = vr;
                  var t2 = ru(r2);
                  if (!t2)
                    return e2.Debug.fail();
                  var o = Ec(t2);
                  i2.aliasTarget === vr ? i2.aliasTarget = o || xe : Xr(t2, e2.Diagnostics.Circular_definition_of_import_alias_0, tn(r2));
                }
                return i2.aliasTarget;
              }
              function d_(r2) {
                var i2 = Aa(r2);
                if (i2.aliasTarget !== vr)
                  return Ps(r2);
              }
              function Gc(r2, i2, t2, o) {
                if (!r2 || e2.isPropertyAccessExpression(r2))
                  return false;
                var s2 = Et(r2);
                if (e2.isTypeOnlyImportOrExportDeclaration(r2)) {
                  var u = Aa(s2);
                  return u.typeOnlyDeclaration = r2, true;
                }
                var h2 = Aa(s2);
                return B_(h2, i2, o) || B_(h2, t2, o);
              }
              function B_(r2, i2, t2) {
                var o, s2, u;
                if (i2 && (r2.typeOnlyDeclaration === void 0 || t2 && r2.typeOnlyDeclaration === false)) {
                  var h2 = (s2 = (o = i2.exports) === null || o === void 0 ? void 0 : o.get("export=")) !== null && s2 !== void 0 ? s2 : i2, z = h2.declarations && e2.find(h2.declarations, e2.isTypeOnlyImportOrExportDeclaration);
                  r2.typeOnlyDeclaration = (u = z != null ? z : Aa(h2).typeOnlyDeclaration) !== null && u !== void 0 ? u : false;
                }
                return !!r2.typeOnlyDeclaration;
              }
              function vu(r2) {
                if (!!(r2.flags & 2097152)) {
                  var i2 = Aa(r2);
                  return i2.typeOnlyDeclaration || void 0;
                }
              }
              function Gt(r2) {
                var i2 = Et(r2), t2 = Ps(i2);
                if (t2) {
                  var o = t2 === xe || t2.flags & 111551 && !Av(t2) && !vu(i2);
                  o && As(i2);
                }
              }
              function As(r2) {
                var i2 = Aa(r2);
                if (!i2.referenced) {
                  i2.referenced = true;
                  var t2 = ru(r2);
                  if (!t2)
                    return e2.Debug.fail();
                  if (e2.isInternalModuleImportEqualsDeclaration(t2)) {
                    var o = os(r2);
                    (o === xe || o.flags & 111551) && Os(t2.moduleReference);
                  }
                }
              }
              function vn(r2) {
                var i2 = Aa(r2);
                i2.constEnumReferenced || (i2.constEnumReferenced = true);
              }
              function Nl(r2, i2) {
                return r2.kind === 79 && e2.isRightSideOfQualifiedNameOrPropertyAccess(r2) && (r2 = r2.parent), r2.kind === 79 || r2.parent.kind === 161 ? Ds(r2, 1920, false, i2) : (e2.Debug.assert(r2.parent.kind === 265), Ds(r2, 901119, false, i2));
              }
              function cl(r2, i2) {
                return r2.parent ? cl(r2.parent, i2) + "." + tn(r2) : tn(r2, i2, void 0, 20);
              }
              function rf(r2) {
                for (; e2.isQualifiedName(r2.parent); )
                  r2 = r2.parent;
                return r2;
              }
              function Ut(r2) {
                var i2 = e2.getFirstIdentifier(r2), t2 = es(i2, i2.escapedText, 111551, void 0, i2, true);
                if (!!t2) {
                  for (; e2.isQualifiedName(i2.parent); ) {
                    var o = Jt(t2);
                    if (t2 = bi(o, i2.parent.right.escapedText), !t2)
                      return;
                    i2 = i2.parent;
                  }
                  return t2;
                }
              }
              function Ds(r2, i2, t2, o, s2) {
                if (!e2.nodeIsMissing(r2)) {
                  var u = 1920 | (e2.isInJSFile(r2) ? i2 & 111551 : 0), h2;
                  if (r2.kind === 79) {
                    var z = i2 === u || e2.nodeIsSynthesized(r2) ? e2.Diagnostics.Cannot_find_namespace_0 : HE(e2.getFirstIdentifier(r2)), me = e2.isInJSFile(r2) && !e2.nodeIsSynthesized(r2) ? bf(r2, i2) : void 0;
                    if (h2 = so(es(s2 || r2, r2.escapedText, i2, t2 || me ? void 0 : z, r2, true, false)), !h2)
                      return so(me);
                  } else if (r2.kind === 161 || r2.kind === 206) {
                    var Me = r2.kind === 161 ? r2.left : r2.expression, $e = r2.kind === 161 ? r2.right : r2.name, tr = Ds(Me, u, t2, false, s2);
                    if (!tr || e2.nodeIsMissing($e))
                      return;
                    if (tr === xe)
                      return tr;
                    if (tr.valueDeclaration && e2.isInJSFile(tr.valueDeclaration) && e2.isVariableDeclaration(tr.valueDeclaration) && tr.valueDeclaration.initializer && xk(tr.valueDeclaration.initializer)) {
                      var dr = tr.valueDeclaration.initializer.arguments[0], Dr = ac(dr, dr);
                      if (Dr) {
                        var Qr = Us(Dr);
                        Qr && (tr = Qr);
                      }
                    }
                    if (h2 = so(qs(dc(tr), $e.escapedText, i2)), !h2) {
                      if (!t2) {
                        var li = cl(tr), Ti = e2.declarationNameToString($e), Ci = v0($e, tr);
                        if (Ci) {
                          Xr($e, e2.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2, li, Ti, tn(Ci));
                          return;
                        }
                        var $i = e2.isQualifiedName(r2) && rf(r2), Zi = qe && i2 & 788968 && $i && !e2.isTypeOfExpression($i.parent) && Ut($i);
                        if (Zi) {
                          Xr($i, e2.Diagnostics._0_refers_to_a_value_but_is_being_used_as_a_type_here_Did_you_mean_typeof_0, e2.entityNameToString($i));
                          return;
                        }
                        if (i2 & 1920 && e2.isQualifiedName(r2.parent)) {
                          var qt = so(qs(dc(tr), $e.escapedText, 788968));
                          if (qt) {
                            Xr(r2.parent.right, e2.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1, tn(qt), e2.unescapeLeadingUnderscores(r2.parent.right.escapedText));
                            return;
                          }
                        }
                        Xr($e, e2.Diagnostics.Namespace_0_has_no_exported_member_1, li, Ti);
                      }
                      return;
                    }
                  } else
                    throw e2.Debug.assertNever(r2, "Unknown entity name kind.");
                  return e2.Debug.assert((e2.getCheckFlags(h2) & 1) === 0, "Should never get an instantiated symbol here."), !e2.nodeIsSynthesized(r2) && e2.isEntityName(r2) && (h2.flags & 2097152 || r2.parent.kind === 271) && Gc(e2.getAliasDeclarationFromName(r2), h2, void 0, true), h2.flags & i2 || o ? h2 : Ps(h2);
                }
              }
              function bf(r2, i2) {
                if (Dh(r2.parent)) {
                  var t2 = bs(r2.parent);
                  if (t2)
                    return es(t2, r2.escapedText, i2, void 0, r2, true);
                }
              }
              function bs(r2) {
                var i2 = e2.findAncestor(r2, function(u) {
                  return e2.isJSDocNode(u) || u.flags & 8388608 ? e2.isJSDocTypeAlias(u) : "quit";
                });
                if (!i2) {
                  var t2 = e2.getJSDocHost(r2);
                  if (t2 && e2.isExpressionStatement(t2) && e2.isPrototypePropertyAssignment(t2.expression)) {
                    var o = Et(t2.expression.left);
                    if (o)
                      return Dc(o);
                  }
                  if (t2 && e2.isFunctionExpression(t2) && e2.isPrototypePropertyAssignment(t2.parent) && e2.isExpressionStatement(t2.parent.parent)) {
                    var o = Et(t2.parent.left);
                    if (o)
                      return Dc(o);
                  }
                  if (t2 && (e2.isObjectLiteralMethod(t2) || e2.isPropertyAssignment(t2)) && e2.isBinaryExpression(t2.parent.parent) && e2.getAssignmentDeclarationKind(t2.parent.parent) === 6) {
                    var o = Et(t2.parent.parent.left);
                    if (o)
                      return Dc(o);
                  }
                  var s2 = e2.getEffectiveJSDocHost(r2);
                  if (s2 && e2.isFunctionLike(s2)) {
                    var o = Et(s2);
                    return o && o.valueDeclaration;
                  }
                }
              }
              function Dc(r2) {
                var i2 = r2.parent.valueDeclaration;
                if (!!i2) {
                  var t2 = e2.isAssignmentDeclaration(i2) ? e2.getAssignedExpandoInitializer(i2) : e2.hasOnlyExpressionInitializer(i2) ? e2.getDeclaredExpandoInitializer(i2) : void 0;
                  return t2 || i2;
                }
              }
              function Cc(r2) {
                var i2 = r2.valueDeclaration;
                if (!(!i2 || !e2.isInJSFile(i2) || r2.flags & 524288 || e2.getExpandoInitializer(i2, false))) {
                  var t2 = e2.isVariableDeclaration(i2) ? e2.getDeclaredExpandoInitializer(i2) : e2.getAssignedExpandoInitializer(i2);
                  if (t2) {
                    var o = Et(t2);
                    if (o)
                      return iS(o, r2);
                  }
                }
              }
              function ac(r2, i2, t2) {
                var o = e2.getEmitModuleResolutionKind(ye) === e2.ModuleResolutionKind.Classic, s2 = o ? e2.Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option : e2.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations;
                return Pl(r2, i2, t2 ? void 0 : s2);
              }
              function Pl(r2, i2, t2, o) {
                return o === void 0 && (o = false), e2.isStringLiteralLike(i2) ? Il(r2, i2.text, t2, i2, o) : void 0;
              }
              function Il(r2, i2, t2, o, s2) {
                var u, h2, z, me, Me, $e, tr, dr;
                if (s2 === void 0 && (s2 = false), e2.startsWith(i2, "@types/")) {
                  var Dr = e2.Diagnostics.Cannot_import_type_declaration_files_Consider_importing_0_instead_of_1, Qr = e2.removePrefix(i2, "@types/");
                  Xr(o, Dr, Qr, i2);
                }
                var li = b_(i2, true);
                if (li)
                  return li;
                var Ti = e2.getSourceFileOfNode(r2), Ci = e2.isStringLiteralLike(r2) ? r2 : ((u = e2.findAncestor(r2, e2.isImportCall)) === null || u === void 0 ? void 0 : u.arguments[0]) || ((h2 = e2.findAncestor(r2, e2.isImportDeclaration)) === null || h2 === void 0 ? void 0 : h2.moduleSpecifier) || ((z = e2.findAncestor(r2, e2.isExternalModuleImportEqualsDeclaration)) === null || z === void 0 ? void 0 : z.moduleReference.expression) || ((me = e2.findAncestor(r2, e2.isExportDeclaration)) === null || me === void 0 ? void 0 : me.moduleSpecifier) || ((Me = e2.isModuleDeclaration(r2) ? r2 : r2.parent && e2.isModuleDeclaration(r2.parent) && r2.parent.name === r2 ? r2.parent : void 0) === null || Me === void 0 ? void 0 : Me.name) || (($e = e2.isLiteralImportTypeNode(r2) ? r2 : void 0) === null || $e === void 0 ? void 0 : $e.argument.literal), $i = Ci && e2.isStringLiteralLike(Ci) ? e2.getModeForUsageLocation(Ti, Ci) : Ti.impliedNodeFormat, Zi = e2.getResolvedModule(Ti, i2, $i), qt = Zi && e2.getResolutionDiagnostic(ye, Zi), Nt = Zi && (!qt || qt === e2.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set) && l.getSourceFile(Zi.resolvedFileName);
                if (Nt) {
                  if (qt && Xr(o, qt, i2, Zi.resolvedFileName), Nt.symbol) {
                    if (Zi.isExternalLibraryImport && !e2.resolutionExtensionIsTSOrJson(Zi.extension) && zf(false, o, Zi, i2), e2.getEmitModuleResolutionKind(ye) === e2.ModuleResolutionKind.Node16 || e2.getEmitModuleResolutionKind(ye) === e2.ModuleResolutionKind.NodeNext) {
                      var Ra = Ti.impliedNodeFormat === e2.ModuleKind.CommonJS && !e2.findAncestor(r2, e2.isImportCall) || !!e2.findAncestor(r2, e2.isImportEqualsDeclaration), ca = e2.findAncestor(r2, function(cn) {
                        return e2.isImportTypeNode(cn) || e2.isExportDeclaration(cn) || e2.isImportDeclaration(cn);
                      }), Sn = ca && e2.isImportTypeNode(ca) ? (tr = ca.assertions) === null || tr === void 0 ? void 0 : tr.assertClause : ca == null ? void 0 : ca.assertClause;
                      Ra && Nt.impliedNodeFormat === e2.ModuleKind.ESNext && !e2.getResolutionModeOverrideForClause(Sn) && Xr(o, e2.Diagnostics.Module_0_cannot_be_imported_using_this_construct_The_specifier_only_resolves_to_an_ES_module_which_cannot_be_imported_synchronously_Use_dynamic_import_instead, i2);
                    }
                    return so(Nt.symbol);
                  }
                  t2 && Xr(o, e2.Diagnostics.File_0_is_not_a_module, Nt.fileName);
                  return;
                }
                if (S2) {
                  var ja = e2.findBestPatternMatch(S2, function(cn) {
                    return cn.pattern;
                  }, i2);
                  if (ja) {
                    var Fn = Ce && Ce.get(i2);
                    return so(Fn || ja.symbol);
                  }
                }
                if (Zi && !e2.resolutionExtensionIsTSOrJson(Zi.extension) && qt === void 0 || qt === e2.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type) {
                  if (s2) {
                    var Dr = e2.Diagnostics.Invalid_module_name_in_augmentation_Module_0_resolves_to_an_untyped_module_at_1_which_cannot_be_augmented;
                    Xr(o, Dr, i2, Zi.resolvedFileName);
                  } else
                    zf(n && !!t2, o, Zi, i2);
                  return;
                }
                if (t2) {
                  if (Zi) {
                    var wn = l.getProjectReferenceRedirect(Zi.resolvedFileName);
                    if (wn) {
                      Xr(o, e2.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, wn, Zi.resolvedFileName);
                      return;
                    }
                  }
                  if (qt)
                    Xr(o, qt, i2, Zi.resolvedFileName);
                  else {
                    var Tn = e2.tryExtractTSExtension(i2), Eo = e2.pathIsRelative(i2) && !e2.hasExtension(i2), lt = e2.getEmitModuleResolutionKind(ye), it = lt === e2.ModuleResolutionKind.Node16 || lt === e2.ModuleResolutionKind.NodeNext;
                    if (Tn) {
                      var Dr = e2.Diagnostics.An_import_path_cannot_end_with_a_0_extension_Consider_importing_1_instead, Yt = e2.removeExtension(i2, Tn), Ia = Yt;
                      er >= e2.ModuleKind.ES2015 && (Ia += Tn === ".mts" ? ".mjs" : Tn === ".cts" ? ".cjs" : ".js"), Xr(o, Dr, Tn, Ia);
                    } else if (!ye.resolveJsonModule && e2.fileExtensionIs(i2, ".json") && e2.getEmitModuleResolutionKind(ye) !== e2.ModuleResolutionKind.Classic && e2.hasJsonModuleEmitEnabled(ye))
                      Xr(o, e2.Diagnostics.Cannot_find_module_0_Consider_using_resolveJsonModule_to_import_module_with_json_extension, i2);
                    else if ($i === e2.ModuleKind.ESNext && it && Eo) {
                      var Qt = e2.getNormalizedAbsolutePath(i2, e2.getDirectoryPath(Ti.path)), Ka = (dr = jo.find(function(cn) {
                        var Un = cn[0], oa = cn[1];
                        return l.fileExists(Qt + Un);
                      })) === null || dr === void 0 ? void 0 : dr[1];
                      Ka ? Xr(o, e2.Diagnostics.Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Did_you_mean_0, i2 + Ka) : Xr(o, e2.Diagnostics.Relative_import_paths_need_explicit_file_extensions_in_EcmaScript_imports_when_moduleResolution_is_node16_or_nodenext_Consider_adding_an_extension_to_the_import_path);
                    } else
                      Xr(o, t2, i2);
                  }
                }
              }
              function zf(r2, i2, t2, o) {
                var s2 = t2.packageId, u = t2.resolvedFileName, h2 = !e2.isExternalModuleNameRelative(o) && s2 ? ul(s2.name) ? e2.chainDiagnosticMessages(void 0, e2.Diagnostics.If_the_0_package_actually_exposes_this_module_consider_sending_a_pull_request_to_amend_https_Colon_Slash_Slashgithub_com_SlashDefinitelyTyped_SlashDefinitelyTyped_Slashtree_Slashmaster_Slashtypes_Slash_1, s2.name, e2.mangleScopedPackageName(s2.name)) : Nu(s2.name) ? e2.chainDiagnosticMessages(void 0, e2.Diagnostics.If_the_0_package_actually_exposes_this_module_try_adding_a_new_declaration_d_ts_file_containing_declare_module_1, s2.name, o) : e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Try_npm_i_save_dev_types_Slash_1_if_it_exists_or_add_a_new_declaration_d_ts_file_containing_declare_module_0, o, e2.mangleScopedPackageName(s2.name)) : void 0;
                Ic(r2, i2, e2.chainDiagnosticMessages(h2, e2.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type, o, u));
              }
              function ul(r2) {
                return d().has(e2.getTypesPackageName(r2));
              }
              function Nu(r2) {
                return !!d().get(r2);
              }
              function Us(r2, i2) {
                if (r2 != null && r2.exports) {
                  var t2 = os(r2.exports.get("export="), i2), o = Ap(so(t2), so(r2));
                  return so(o) || r2;
                }
              }
              function Ap(r2, i2) {
                if (!r2 || r2 === xe || r2 === i2 || i2.exports.size === 1 || r2.flags & 2097152)
                  return r2;
                var t2 = Aa(r2);
                if (t2.cjsExportMerged)
                  return t2.cjsExportMerged;
                var o = r2.flags & 33554432 ? r2 : Yl(r2);
                return o.flags = o.flags | 512, o.exports === void 0 && (o.exports = e2.createSymbolTable()), i2.exports.forEach(function(s2, u) {
                  u !== "export=" && o.exports.set(u, o.exports.has(u) ? Bf(o.exports.get(u), s2) : s2);
                }), Aa(o).cjsExportMerged = o, t2.cjsExportMerged = o;
              }
              function Wf(r2, i2, t2, o) {
                var s2, u = Us(r2, t2);
                if (!t2 && u) {
                  if (!o && !(u.flags & 1539) && !e2.getDeclarationOfKind(u, 305)) {
                    var h2 = er >= e2.ModuleKind.ES2015 ? "allowSyntheticDefaultImports" : "esModuleInterop";
                    return Xr(i2, e2.Diagnostics.This_module_can_only_be_referenced_with_ECMAScript_imports_Slashexports_by_turning_on_the_0_flag_and_referencing_its_default_export, h2), u;
                  }
                  var z = i2.parent;
                  if (e2.isImportDeclaration(z) && e2.getNamespaceDeclarationNode(z) || e2.isImportCall(z)) {
                    var me = e2.isImportCall(z) ? z.arguments[0] : z.moduleSpecifier, Me = Jt(u), $e = Sk(Me, u, r2, me);
                    if ($e)
                      return Sf(u, $e, z);
                    var tr = (s2 = r2 == null ? void 0 : r2.declarations) === null || s2 === void 0 ? void 0 : s2.find(e2.isSourceFile), dr = tr && $l(hf(me), tr.impliedNodeFormat);
                    if (e2.getESModuleInterop(ye) || dr) {
                      var Dr = Ft(Me, 0);
                      if ((!Dr || !Dr.length) && (Dr = Ft(Me, 1)), Dr && Dr.length || bi(Me, "default", true) || dr) {
                        var Qr = Tk(Me, u, r2, me);
                        return Sf(u, Qr, z);
                      }
                    }
                  }
                }
                return u;
              }
              function Sf(r2, i2, t2) {
                var o = oo(r2.flags, r2.escapedName);
                o.declarations = r2.declarations ? r2.declarations.slice() : [], o.parent = r2.parent, o.target = r2, o.originatingImport = t2, r2.valueDeclaration && (o.valueDeclaration = r2.valueDeclaration), r2.constEnumOnlyModule && (o.constEnumOnlyModule = true), r2.members && (o.members = new e2.Map(r2.members)), r2.exports && (o.exports = new e2.Map(r2.exports));
                var s2 = Ru(i2);
                return o.type = rs(o, s2.members, e2.emptyArray, e2.emptyArray, s2.indexInfos), o;
              }
              function ll(r2) {
                return r2.exports.get("export=") !== void 0;
              }
              function J_(r2) {
                return Y_(Pu(r2));
              }
              function j_(r2) {
                var i2 = J_(r2), t2 = Us(r2);
                if (t2 !== r2) {
                  var o = Jt(t2);
                  qf(o) && e2.addRange(i2, uo(o));
                }
                return i2;
              }
              function U_(r2, i2) {
                var t2 = Pu(r2);
                t2.forEach(function(u, h2) {
                  Ol(h2) || i2(u, h2);
                });
                var o = Us(r2);
                if (o !== r2) {
                  var s2 = Jt(o);
                  qf(s2) && U1(s2, function(u, h2) {
                    i2(u, h2);
                  });
                }
              }
              function iu(r2, i2) {
                var t2 = Pu(i2);
                if (t2)
                  return t2.get(r2);
              }
              function vd(r2, i2) {
                var t2 = iu(r2, i2);
                if (t2)
                  return t2;
                var o = Us(i2);
                if (o !== i2) {
                  var s2 = Jt(o);
                  return qf(s2) ? bi(s2, r2) : void 0;
                }
              }
              function qf(r2) {
                return !(r2.flags & 131068 || e2.getObjectFlags(r2) & 1 || Tu(r2) || Yn(r2));
              }
              function dc(r2) {
                return r2.flags & 6256 ? Jv(r2, "resolvedExports") : r2.flags & 1536 ? Pu(r2) : r2.exports || we;
              }
              function Pu(r2) {
                var i2 = Aa(r2);
                return i2.resolvedExports || (i2.resolvedExports = Iu(r2));
              }
              function wl(r2, i2, t2, o) {
                !i2 || i2.forEach(function(s2, u) {
                  if (u !== "default") {
                    var h2 = r2.get(u);
                    if (!h2)
                      r2.set(u, s2), t2 && o && t2.set(u, { specifierText: e2.getTextOfNode(o.moduleSpecifier) });
                    else if (t2 && o && h2 && os(h2) !== os(s2)) {
                      var z = t2.get(u);
                      z.exportsWithDuplicate ? z.exportsWithDuplicate.push(o) : z.exportsWithDuplicate = [o];
                    }
                  }
                });
              }
              function Iu(r2) {
                var i2 = [];
                return r2 = Us(r2), t2(r2) || we;
                function t2(o) {
                  if (!!(o && o.exports && e2.pushIfUnique(i2, o))) {
                    var s2 = new e2.Map(o.exports), u = o.exports.get("__export");
                    if (u) {
                      var h2 = e2.createSymbolTable(), z = new e2.Map();
                      if (u.declarations)
                        for (var me = 0, Me = u.declarations; me < Me.length; me++) {
                          var $e = Me[me], tr = ac($e, $e.moduleSpecifier), dr = t2(tr);
                          wl(h2, dr, z, $e);
                        }
                      z.forEach(function(Dr, Qr) {
                        var li = Dr.exportsWithDuplicate;
                        if (!(Qr === "export=" || !(li && li.length) || s2.has(Qr)))
                          for (var Ti = 0, Ci = li; Ti < Ci.length; Ti++) {
                            var $i = Ci[Ti];
                            rn.add(e2.createDiagnosticForNode($i, e2.Diagnostics.Module_0_has_already_exported_a_member_named_1_Consider_explicitly_re_exporting_to_resolve_the_ambiguity, z.get(Qr).specifierText, e2.unescapeLeadingUnderscores(Qr)));
                          }
                      }), wl(s2, h2);
                    }
                    return s2;
                  }
                }
              }
              function so(r2) {
                var i2;
                return r2 && r2.mergeId && (i2 = xl[r2.mergeId]) ? i2 : r2;
              }
              function Et(r2) {
                return so(r2.symbol && dg(r2.symbol));
              }
              function Ys(r2) {
                return so(r2.parent && dg(r2.parent));
              }
              function Ku(r2, i2) {
                var t2 = e2.getSourceFileOfNode(i2), o = A2(t2), s2 = Aa(r2), u;
                if (s2.extendedContainersByFile && (u = s2.extendedContainersByFile.get(o)))
                  return u;
                if (t2 && t2.imports) {
                  for (var h2 = 0, z = t2.imports; h2 < z.length; h2++) {
                    var me = z[h2];
                    if (!e2.nodeIsSynthesized(me)) {
                      var Me = ac(i2, me, true);
                      if (!!Me) {
                        var $e = fl(Me, r2);
                        !$e || (u = e2.append(u, Me));
                      }
                    }
                  }
                  if (e2.length(u))
                    return (s2.extendedContainersByFile || (s2.extendedContainersByFile = new e2.Map())).set(o, u), u;
                }
                if (s2.extendedContainers)
                  return s2.extendedContainers;
                for (var tr = l.getSourceFiles(), dr = 0, Dr = tr; dr < Dr.length; dr++) {
                  var Qr = Dr[dr];
                  if (!!e2.isExternalModule(Qr)) {
                    var li = Et(Qr), $e = fl(li, r2);
                    !$e || (u = e2.append(u, li));
                  }
                }
                return s2.extendedContainers = u || e2.emptyArray;
              }
              function Np(r2, i2, t2) {
                var o = Ys(r2);
                if (o && !(r2.flags & 262144)) {
                  var s2 = e2.mapDefined(o.declarations, $e), u = i2 && Ku(r2, i2), h2 = Pp(o, t2);
                  if (i2 && o.flags & Fl(t2) && pl(o, i2, 1920, false))
                    return e2.append(e2.concatenate(e2.concatenate([o], s2), u), h2);
                  var z = !(o.flags & Fl(t2)) && o.flags & 788968 && go(o).flags & 524288 && t2 === 111551 ? Ef(i2, function(tr) {
                    return e2.forEachEntry(tr, function(dr) {
                      if (dr.flags & Fl(t2) && Jt(dr) === go(o))
                        return dr;
                    });
                  }) : void 0, me = z ? Ve(Ve([z], s2, true), [o], false) : Ve(Ve([], s2, true), [o], false);
                  return me = e2.append(me, h2), me = e2.addRange(me, u), me;
                }
                var Me = e2.mapDefined(r2.declarations, function(tr) {
                  if (!e2.isAmbientModule(tr) && tr.parent) {
                    if (Fc(tr.parent))
                      return Et(tr.parent);
                    if (e2.isModuleBlock(tr.parent) && tr.parent.parent && Us(Et(tr.parent.parent)) === r2)
                      return Et(tr.parent.parent);
                  }
                  if (e2.isClassExpression(tr) && e2.isBinaryExpression(tr.parent) && tr.parent.operatorToken.kind === 63 && e2.isAccessExpression(tr.parent.left) && e2.isEntityNameExpression(tr.parent.left.expression))
                    return e2.isModuleExportsAccessExpression(tr.parent.left) || e2.isExportsIdentifier(tr.parent.left.expression) ? Et(e2.getSourceFileOfNode(tr)) : (Os(tr.parent.left.expression), va(tr.parent.left.expression).resolvedSymbol);
                });
                if (!e2.length(Me))
                  return;
                return e2.mapDefined(Me, function(tr) {
                  return fl(tr, r2) ? tr : void 0;
                });
                function $e(tr) {
                  return o && nc(tr, o);
                }
              }
              function Pp(r2, i2) {
                var t2 = !!e2.length(r2.declarations) && e2.first(r2.declarations);
                if (i2 & 111551 && t2 && t2.parent && e2.isVariableDeclaration(t2.parent) && (e2.isObjectLiteralExpression(t2) && t2 === t2.parent.initializer || e2.isTypeLiteralNode(t2) && t2 === t2.parent.type))
                  return Et(t2.parent);
              }
              function nc(r2, i2) {
                var t2 = gl(r2), o = t2 && t2.exports && t2.exports.get("export=");
                return o && _l(o, i2) ? t2 : void 0;
              }
              function fl(r2, i2) {
                if (r2 === Ys(i2))
                  return i2;
                var t2 = r2.exports && r2.exports.get("export=");
                if (t2 && _l(t2, i2))
                  return r2;
                var o = dc(r2), s2 = o.get(i2.escapedName);
                return s2 && _l(s2, i2) ? s2 : e2.forEachEntry(o, function(u) {
                  if (_l(u, i2))
                    return u;
                });
              }
              function _l(r2, i2) {
                if (so(os(so(r2))) === so(os(so(i2))))
                  return r2;
              }
              function cu(r2) {
                return so(r2 && (r2.flags & 1048576) !== 0 && r2.exportSymbol || r2);
              }
              function gc(r2) {
                return !!(r2.flags & 111551 || r2.flags & 2097152 && Ps(r2).flags & 111551 && !vu(r2));
              }
              function Tf(r2) {
                for (var i2 = r2.members, t2 = 0, o = i2; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  if (s2.kind === 171 && e2.nodeIsPresent(s2.body))
                    return s2;
                }
              }
              function mc(r2) {
                var i2 = new Fe(Di, r2);
                return Be++, i2.id = Be, e2.tracing === null || e2.tracing === void 0 || e2.tracing.recordType(i2), i2;
              }
              function Ip(r2) {
                return new Fe(Di, r2);
              }
              function ms(r2, i2, t2) {
                t2 === void 0 && (t2 = 0);
                var o = mc(r2);
                return o.intrinsicName = i2, o.objectFlags = t2, o;
              }
              function tu(r2, i2) {
                var t2 = mc(524288);
                return t2.objectFlags = r2, t2.symbol = i2, t2.members = void 0, t2.properties = void 0, t2.callSignatures = void 0, t2.constructSignatures = void 0, t2.indexInfos = void 0, t2;
              }
              function wp() {
                return Pa(e2.arrayFrom(G.keys(), Bu));
              }
              function Hc(r2) {
                var i2 = mc(262144);
                return r2 && (i2.symbol = r2), i2;
              }
              function Ol(r2) {
                return r2.charCodeAt(0) === 95 && r2.charCodeAt(1) === 95 && r2.charCodeAt(2) !== 95 && r2.charCodeAt(2) !== 64 && r2.charCodeAt(2) !== 35;
              }
              function tf(r2) {
                var i2;
                return r2.forEach(function(t2, o) {
                  xf(t2, o) && (i2 || (i2 = [])).push(t2);
                }), i2 || e2.emptyArray;
              }
              function xf(r2, i2) {
                return !Ol(i2) && gc(r2);
              }
              function z_(r2) {
                var i2 = tf(r2), t2 = rD(r2);
                return t2 ? e2.concatenate(i2, [t2]) : i2;
              }
              function Oc(r2, i2, t2, o, s2) {
                var u = r2;
                return u.members = i2, u.properties = e2.emptyArray, u.callSignatures = t2, u.constructSignatures = o, u.indexInfos = s2, i2 !== we && (u.properties = tf(i2)), u;
              }
              function rs(r2, i2, t2, o, s2) {
                return Oc(tu(16, r2), i2, t2, o, s2);
              }
              function Op(r2) {
                if (r2.constructSignatures.length === 0)
                  return r2;
                if (r2.objectTypeWithoutAbstractConstructSignatures)
                  return r2.objectTypeWithoutAbstractConstructSignatures;
                var i2 = e2.filter(r2.constructSignatures, function(o) {
                  return !(o.flags & 4);
                });
                if (r2.constructSignatures === i2)
                  return r2;
                var t2 = rs(r2.symbol, r2.members, r2.callSignatures, e2.some(i2) ? i2 : e2.emptyArray, r2.indexInfos);
                return r2.objectTypeWithoutAbstractConstructSignatures = t2, t2.objectTypeWithoutAbstractConstructSignatures = t2, t2;
              }
              function Ef(r2, i2) {
                for (var t2, o = function(h2) {
                  if (h2.locals && !Cu(h2) && (t2 = i2(h2.locals, void 0, true, h2)))
                    return { value: t2 };
                  switch (h2.kind) {
                    case 305:
                      if (!e2.isExternalOrCommonJsModule(h2))
                        break;
                    case 261:
                      var z = Et(h2);
                      if (t2 = i2((z == null ? void 0 : z.exports) || we, void 0, true, h2))
                        return { value: t2 };
                      break;
                    case 257:
                    case 226:
                    case 258:
                      var me;
                      if ((Et(h2).members || we).forEach(function(Me, $e) {
                        Me.flags & 788968 && (me || (me = e2.createSymbolTable())).set($e, Me);
                      }), me && (t2 = i2(me, void 0, false, h2)))
                        return { value: t2 };
                      break;
                  }
                }, s2 = r2; s2; s2 = s2.parent) {
                  var u = o(s2);
                  if (typeof u == "object")
                    return u.value;
                }
                return i2(ii, void 0, true);
              }
              function Fl(r2) {
                return r2 === 111551 ? 111551 : 1920;
              }
              function pl(r2, i2, t2, o, s2) {
                if (s2 === void 0 && (s2 = new e2.Map()), !(r2 && !Mp(r2)))
                  return;
                var u = Aa(r2), h2 = u.accessibleChainCache || (u.accessibleChainCache = new e2.Map()), z = Ef(i2, function(Ci, $i, Zi, qt) {
                  return qt;
                }), me = "".concat(o ? 0 : 1, "|").concat(z && A2(z), "|").concat(t2);
                if (h2.has(me))
                  return h2.get(me);
                var Me = y(r2), $e = s2.get(Me);
                $e || s2.set(Me, $e = []);
                var tr = Ef(i2, dr);
                return h2.set(me, tr), tr;
                function dr(Ci, $i, Zi) {
                  if (!!e2.pushIfUnique($e, Ci)) {
                    var qt = li(Ci, $i, Zi);
                    return $e.pop(), qt;
                  }
                }
                function Dr(Ci, $i) {
                  return !Fp(Ci, i2, $i) || !!pl(Ci.parent, i2, Fl($i), o, s2);
                }
                function Qr(Ci, $i, Zi) {
                  return (r2 === ($i || Ci) || so(r2) === so($i || Ci)) && !e2.some(Ci.declarations, Fc) && (Zi || Dr(so(Ci), t2));
                }
                function li(Ci, $i, Zi) {
                  if (Qr(Ci.get(r2.escapedName), void 0, $i))
                    return [r2];
                  var qt = e2.forEachEntry(Ci, function(Nt) {
                    if (Nt.flags & 2097152 && Nt.escapedName !== "export=" && Nt.escapedName !== "default" && !(e2.isUMDExportSymbol(Nt) && i2 && e2.isExternalModule(e2.getSourceFileOfNode(i2))) && (!o || e2.some(Nt.declarations, e2.isExternalModuleImportEqualsDeclaration)) && (Zi ? !e2.some(Nt.declarations, e2.isNamespaceReexportDeclaration) : true) && ($i || !e2.getDeclarationOfKind(Nt, 275))) {
                      var Ra = Ps(Nt), ca = Ti(Nt, Ra, $i);
                      if (ca)
                        return ca;
                    }
                    if (Nt.escapedName === r2.escapedName && Nt.exportSymbol && Qr(so(Nt.exportSymbol), void 0, $i))
                      return [r2];
                  });
                  return qt || (Ci === ii ? Ti(pe, pe, $i) : void 0);
                }
                function Ti(Ci, $i, Zi) {
                  if (Qr(Ci, $i, Zi))
                    return [Ci];
                  var qt = dc($i), Nt = qt && dr(qt, true);
                  if (Nt && Dr(Ci, Fl(t2)))
                    return [Ci].concat(Nt);
                }
              }
              function Fp(r2, i2, t2) {
                var o = false;
                return Ef(i2, function(s2) {
                  var u = so(s2.get(r2.escapedName));
                  return u ? u === r2 ? true : (u = u.flags & 2097152 && !e2.getDeclarationOfKind(u, 275) ? Ps(u) : u, u.flags & t2 ? (o = true, true) : false) : false;
                }), o;
              }
              function Mp(r2) {
                if (r2.declarations && r2.declarations.length) {
                  for (var i2 = 0, t2 = r2.declarations; i2 < t2.length; i2++) {
                    var o = t2[i2];
                    switch (o.kind) {
                      case 167:
                      case 169:
                      case 172:
                      case 173:
                        continue;
                      default:
                        return false;
                    }
                  }
                  return true;
                }
                return false;
              }
              function Gu(r2, i2) {
                var t2 = dl(r2, i2, 788968, false, true);
                return t2.accessibility === 0;
              }
              function Lp(r2, i2) {
                var t2 = dl(r2, i2, 111551, false, true);
                return t2.accessibility === 0;
              }
              function Cf(r2, i2, t2) {
                var o = dl(r2, i2, t2, false, false);
                return o.accessibility === 0;
              }
              function W_(r2, i2, t2, o, s2, u) {
                if (!!e2.length(r2)) {
                  for (var h2, z = false, me = 0, Me = r2; me < Me.length; me++) {
                    var $e = Me[me], tr = pl($e, i2, o, false);
                    if (tr) {
                      h2 = $e;
                      var dr = Hu(tr[0], s2);
                      if (dr)
                        return dr;
                    }
                    if (u && e2.some($e.declarations, Fc)) {
                      if (s2) {
                        z = true;
                        continue;
                      }
                      return { accessibility: 0 };
                    }
                    var Dr = Np($e, i2, o), Qr = W_(Dr, i2, t2, t2 === $e ? Fl(o) : o, s2, u);
                    if (Qr)
                      return Qr;
                  }
                  if (z)
                    return { accessibility: 0 };
                  if (h2)
                    return { accessibility: 1, errorSymbolName: tn(t2, i2, o), errorModuleName: h2 !== t2 ? tn(h2, i2, 1920) : void 0 };
                }
              }
              function g_(r2, i2, t2, o) {
                return dl(r2, i2, t2, o, true);
              }
              function dl(r2, i2, t2, o, s2) {
                if (r2 && i2) {
                  var u = W_([r2], i2, r2, t2, o, s2);
                  if (u)
                    return u;
                  var h2 = e2.forEach(r2.declarations, gl);
                  if (h2) {
                    var z = gl(i2);
                    if (h2 !== z)
                      return { accessibility: 2, errorSymbolName: tn(r2, i2, t2), errorModuleName: tn(h2), errorNode: e2.isInJSFile(i2) ? i2 : void 0 };
                  }
                  return { accessibility: 1, errorSymbolName: tn(r2, i2, t2) };
                }
                return { accessibility: 0 };
              }
              function gl(r2) {
                var i2 = e2.findAncestor(r2, Vf);
                return i2 && Et(i2);
              }
              function Vf(r2) {
                return e2.isAmbientModule(r2) || r2.kind === 305 && e2.isExternalOrCommonJsModule(r2);
              }
              function Fc(r2) {
                return e2.isModuleWithStringLiteralName(r2) || r2.kind === 305 && e2.isExternalOrCommonJsModule(r2);
              }
              function Hu(r2, i2) {
                var t2;
                if (!e2.every(e2.filter(r2.declarations, function(u) {
                  return u.kind !== 79;
                }), o))
                  return;
                return { accessibility: 0, aliasesToMakeVisible: t2 };
                function o(u) {
                  var h2, z;
                  if (!wu(u)) {
                    var me = Au(u);
                    return me && !e2.hasSyntacticModifier(me, 1) && wu(me.parent) ? s2(u, me) : e2.isVariableDeclaration(u) && e2.isVariableStatement(u.parent.parent) && !e2.hasSyntacticModifier(u.parent.parent, 1) && wu(u.parent.parent.parent) ? s2(u, u.parent.parent) : e2.isLateVisibilityPaintedStatement(u) && !e2.hasSyntacticModifier(u, 1) && wu(u.parent) ? s2(u, u) : r2.flags & 2097152 && e2.isBindingElement(u) && e2.isInJSFile(u) && ((h2 = u.parent) === null || h2 === void 0 ? void 0 : h2.parent) && e2.isVariableDeclaration(u.parent.parent) && ((z = u.parent.parent.parent) === null || z === void 0 ? void 0 : z.parent) && e2.isVariableStatement(u.parent.parent.parent.parent) && !e2.hasSyntacticModifier(u.parent.parent.parent.parent, 1) && u.parent.parent.parent.parent.parent && wu(u.parent.parent.parent.parent.parent) ? s2(u, u.parent.parent.parent.parent) : false;
                  }
                  return true;
                }
                function s2(u, h2) {
                  return i2 && (va(u).isVisible = true, t2 = e2.appendIfUnique(t2, h2)), true;
                }
              }
              function af(r2, i2) {
                var t2;
                r2.parent.kind === 181 || r2.parent.kind === 228 && !e2.isPartOfTypeNode(r2.parent) || r2.parent.kind === 162 ? t2 = 1160127 : r2.kind === 161 || r2.kind === 206 || r2.parent.kind === 265 ? t2 = 1920 : t2 = 788968;
                var o = e2.getFirstIdentifier(r2), s2 = es(i2, o.escapedText, t2, void 0, void 0, false);
                return s2 && s2.flags & 262144 && t2 & 788968 ? { accessibility: 0 } : s2 && Hu(s2, true) || { accessibility: 1, errorSymbolName: e2.getTextOfNode(o), errorNode: o };
              }
              function tn(r2, i2, t2, o, s2) {
                o === void 0 && (o = 4);
                var u = 70221824;
                o & 2 && (u |= 128), o & 1 && (u |= 512), o & 8 && (u |= 16384), o & 16 && (u |= 134217728);
                var h2 = o & 4 ? Ur.symbolToExpression : Ur.symbolToEntityName;
                return s2 ? z(s2).getText() : e2.usingSingleLineStringWriter(z);
                function z(me) {
                  var Me = h2(r2, t2, i2, u), $e = (i2 == null ? void 0 : i2.kind) === 305 ? e2.createPrinter({ removeComments: true, neverAsciiEscape: true }) : e2.createPrinter({ removeComments: true }), tr = i2 && e2.getSourceFileOfNode(i2);
                  return $e.writeNode(4, Me, tr, me), me;
                }
              }
              function Ml(r2, i2, t2, o, s2) {
                return t2 === void 0 && (t2 = 0), s2 ? u(s2).getText() : e2.usingSingleLineStringWriter(u);
                function u(h2) {
                  var z;
                  t2 & 262144 ? z = o === 1 ? 180 : 179 : z = o === 1 ? 175 : 174;
                  var me = Ur.signatureToSignatureDeclaration(r2, z, i2, Rp(t2) | 70221824 | 512), Me = e2.createPrinter({ removeComments: true, omitTrailingSemicolon: true }), $e = i2 && e2.getSourceFileOfNode(i2);
                  return Me.writeNode(4, me, $e, e2.getTrailingSemicolonDeferringWriter(h2)), h2;
                }
              }
              function Ot(r2, i2, t2, o) {
                t2 === void 0 && (t2 = 1064960), o === void 0 && (o = e2.createTextWriter(""));
                var s2 = ye.noErrorTruncation || t2 & 1, u = Ur.typeToTypeNode(r2, i2, Rp(t2) | 70221824 | (s2 ? 1 : 0), o);
                if (u === void 0)
                  return e2.Debug.fail("should always get typenode");
                var h2 = { removeComments: r2 !== Ue }, z = e2.createPrinter(h2), me = i2 && e2.getSourceFileOfNode(i2);
                z.writeNode(4, u, me, o);
                var Me = o.getText(), $e = s2 ? e2.noTruncationMaximumTruncationLength * 2 : e2.defaultMaximumTruncationLength * 2;
                return $e && Me && Me.length >= $e ? Me.substr(0, $e - 3) + "..." : Me;
              }
              function nf(r2, i2) {
                var t2 = Kf(r2.symbol) ? Ot(r2, r2.symbol.valueDeclaration) : Ot(r2), o = Kf(i2.symbol) ? Ot(i2, i2.symbol.valueDeclaration) : Ot(i2);
                return t2 === o && (t2 = q_(r2), o = q_(i2)), [t2, o];
              }
              function q_(r2) {
                return Ot(r2, void 0, 64);
              }
              function Kf(r2) {
                return r2 && !!r2.valueDeclaration && e2.isExpression(r2.valueDeclaration) && !Ju(r2.valueDeclaration);
              }
              function Rp(r2) {
                return r2 === void 0 && (r2 = 0), r2 & 814775659;
              }
              function yd(r2) {
                return !!r2.symbol && !!(r2.symbol.flags & 32) && (r2 === aa(r2.symbol) || !!(r2.flags & 524288) && !!(e2.getObjectFlags(r2) & 16777216));
              }
              function m_() {
                return { typeToTypeNode: function(ci, Fr, jt, Lt) {
                  return r2(Fr, jt, Lt, function(ea) {
                    return o(ci, ea);
                  });
                }, indexInfoToIndexSignatureDeclaration: function(ci, Fr, jt, Lt) {
                  return r2(Fr, jt, Lt, function(ea) {
                    return Me(ci, ea, void 0);
                  });
                }, signatureToSignatureDeclaration: function(ci, Fr, jt, Lt, ea) {
                  return r2(jt, Lt, ea, function(Kt) {
                    return $e(ci, Fr, Kt);
                  });
                }, symbolToEntityName: function(ci, Fr, jt, Lt, ea) {
                  return r2(jt, Lt, ea, function(Kt) {
                    return Fn(ci, Kt, Fr, false);
                  });
                }, symbolToExpression: function(ci, Fr, jt, Lt, ea) {
                  return r2(jt, Lt, ea, function(Kt) {
                    return wn(ci, Kt, Fr);
                  });
                }, symbolToTypeParameterDeclarations: function(ci, Fr, jt, Lt) {
                  return r2(Fr, jt, Lt, function(ea) {
                    return $i(ci, ea);
                  });
                }, symbolToParameterDeclaration: function(ci, Fr, jt, Lt) {
                  return r2(Fr, jt, Lt, function(ea) {
                    return Qr(ci, ea);
                  });
                }, typeParameterToDeclaration: function(ci, Fr, jt, Lt) {
                  return r2(Fr, jt, Lt, function(ea) {
                    return Dr(ci, ea);
                  });
                }, symbolTableToDeclarationStatements: function(ci, Fr, jt, Lt, ea) {
                  return r2(Fr, jt, Lt, function(Kt) {
                    return Ln(ci, Kt, ea);
                  });
                } };
                function r2(ci, Fr, jt, Lt) {
                  var ea, Kt;
                  e2.Debug.assert(ci === void 0 || (ci.flags & 8) === 0);
                  var $t = { enclosingDeclaration: ci, flags: Fr || 0, tracker: jt && jt.trackSymbol ? jt : { trackSymbol: function() {
                    return false;
                  }, moduleResolverHost: Fr & 134217728 ? { getCommonSourceDirectory: l.getCommonSourceDirectory ? function() {
                    return l.getCommonSourceDirectory();
                  } : function() {
                    return "";
                  }, getCurrentDirectory: function() {
                    return l.getCurrentDirectory();
                  }, getSymlinkCache: e2.maybeBind(l, l.getSymlinkCache), getPackageJsonInfoCache: function() {
                    var Yr;
                    return (Yr = l.getPackageJsonInfoCache) === null || Yr === void 0 ? void 0 : Yr.call(l);
                  }, useCaseSensitiveFileNames: e2.maybeBind(l, l.useCaseSensitiveFileNames), redirectTargetsMap: l.redirectTargetsMap, getProjectReferenceRedirect: function(Yr) {
                    return l.getProjectReferenceRedirect(Yr);
                  }, isSourceOfProjectReferenceRedirect: function(Yr) {
                    return l.isSourceOfProjectReferenceRedirect(Yr);
                  }, fileExists: function(Yr) {
                    return l.fileExists(Yr);
                  }, getFileIncludeReasons: function() {
                    return l.getFileIncludeReasons();
                  }, readFile: l.readFile ? function(Yr) {
                    return l.readFile(Yr);
                  } : void 0 } : void 0 }, encounteredError: false, reportedDiagnostic: false, visitedTypes: void 0, symbolDepth: void 0, inferTypeParameters: void 0, approximateLength: 0 };
                  $t.tracker = i2($t, $t.tracker);
                  var Ua = Lt($t);
                  return $t.truncating && $t.flags & 1 && ((Kt = (ea = $t.tracker) === null || ea === void 0 ? void 0 : ea.reportTruncationError) === null || Kt === void 0 || Kt.call(ea)), $t.encounteredError ? void 0 : Ua;
                }
                function i2(ci, Fr) {
                  var jt = Fr.trackSymbol;
                  return Ke(Ke({}, Fr), { reportCyclicStructureError: Lt(Fr.reportCyclicStructureError), reportInaccessibleThisError: Lt(Fr.reportInaccessibleThisError), reportInaccessibleUniqueSymbolError: Lt(Fr.reportInaccessibleUniqueSymbolError), reportLikelyUnsafeImportRequiredError: Lt(Fr.reportLikelyUnsafeImportRequiredError), reportNonlocalAugmentation: Lt(Fr.reportNonlocalAugmentation), reportPrivateInBaseOfClassExpression: Lt(Fr.reportPrivateInBaseOfClassExpression), reportNonSerializableProperty: Lt(Fr.reportNonSerializableProperty), trackSymbol: jt && function() {
                    for (var ea = [], Kt = 0; Kt < arguments.length; Kt++)
                      ea[Kt] = arguments[Kt];
                    var $t = jt.apply(void 0, ea);
                    return $t && (ci.reportedDiagnostic = true), $t;
                  } });
                  function Lt(ea) {
                    return ea && function() {
                      for (var Kt = [], $t = 0; $t < arguments.length; $t++)
                        Kt[$t] = arguments[$t];
                      return ci.reportedDiagnostic = true, ea.apply(void 0, Kt);
                    };
                  }
                }
                function t2(ci) {
                  return ci.truncating ? ci.truncating : ci.truncating = ci.approximateLength > (ci.flags & 1 ? e2.noTruncationMaximumTruncationLength : e2.defaultMaximumTruncationLength);
                }
                function o(ci, Fr) {
                  g && g.throwIfCancellationRequested && g.throwIfCancellationRequested();
                  var jt = Fr.flags & 8388608;
                  if (Fr.flags &= -8388609, !ci) {
                    if (!(Fr.flags & 262144)) {
                      Fr.encounteredError = true;
                      return;
                    }
                    return Fr.approximateLength += 3, e2.factory.createKeywordTypeNode(130);
                  }
                  if (Fr.flags & 536870912 || (ci = bu(ci)), ci.flags & 1)
                    return ci.aliasSymbol ? e2.factory.createTypeReferenceNode(Ra(ci.aliasSymbol), z(ci.aliasTypeArguments, Fr)) : ci === Ue ? e2.addSyntheticLeadingComment(e2.factory.createKeywordTypeNode(130), 3, "unresolved") : (Fr.approximateLength += 3, e2.factory.createKeywordTypeNode(ci === De ? 138 : 130));
                  if (ci.flags & 2)
                    return e2.factory.createKeywordTypeNode(155);
                  if (ci.flags & 4)
                    return Fr.approximateLength += 6, e2.factory.createKeywordTypeNode(150);
                  if (ci.flags & 8)
                    return Fr.approximateLength += 6, e2.factory.createKeywordTypeNode(147);
                  if (ci.flags & 64)
                    return Fr.approximateLength += 6, e2.factory.createKeywordTypeNode(158);
                  if (ci.flags & 16 && !ci.aliasSymbol)
                    return Fr.approximateLength += 7, e2.factory.createKeywordTypeNode(133);
                  if (ci.flags & 1024 && !(ci.flags & 1048576)) {
                    var Lt = Ys(ci.symbol), ea = ca(Lt, Fr, 788968);
                    if (go(Lt) === ci)
                      return ea;
                    var Kt = e2.symbolName(ci.symbol);
                    return e2.isIdentifierText(Kt, 0) ? fp(ea, e2.factory.createTypeReferenceNode(Kt, void 0)) : e2.isImportTypeNode(ea) ? (ea.isTypeOf = true, e2.factory.createIndexedAccessTypeNode(ea, e2.factory.createLiteralTypeNode(e2.factory.createStringLiteral(Kt)))) : e2.isTypeReferenceNode(ea) ? e2.factory.createIndexedAccessTypeNode(e2.factory.createTypeQueryNode(ea.typeName), e2.factory.createLiteralTypeNode(e2.factory.createStringLiteral(Kt))) : e2.Debug.fail("Unhandled type node kind returned from `symbolToTypeNode`.");
                  }
                  if (ci.flags & 1056)
                    return ca(ci.symbol, Fr, 788968);
                  if (ci.flags & 128)
                    return Fr.approximateLength += ci.value.length + 2, e2.factory.createLiteralTypeNode(e2.setEmitFlags(e2.factory.createStringLiteral(ci.value, !!(Fr.flags & 268435456)), 16777216));
                  if (ci.flags & 256) {
                    var $t = ci.value;
                    return Fr.approximateLength += ("" + $t).length, e2.factory.createLiteralTypeNode($t < 0 ? e2.factory.createPrefixUnaryExpression(40, e2.factory.createNumericLiteral(-$t)) : e2.factory.createNumericLiteral($t));
                  }
                  if (ci.flags & 2048)
                    return Fr.approximateLength += e2.pseudoBigIntToString(ci.value).length + 1, e2.factory.createLiteralTypeNode(e2.factory.createBigIntLiteral(ci.value));
                  if (ci.flags & 512)
                    return Fr.approximateLength += ci.intrinsicName.length, e2.factory.createLiteralTypeNode(ci.intrinsicName === "true" ? e2.factory.createTrue() : e2.factory.createFalse());
                  if (ci.flags & 8192) {
                    if (!(Fr.flags & 1048576)) {
                      if (Lp(ci.symbol, Fr.enclosingDeclaration))
                        return Fr.approximateLength += 6, ca(ci.symbol, Fr, 111551);
                      Fr.tracker.reportInaccessibleUniqueSymbolError && Fr.tracker.reportInaccessibleUniqueSymbolError();
                    }
                    return Fr.approximateLength += 13, e2.factory.createTypeOperatorNode(154, e2.factory.createKeywordTypeNode(151));
                  }
                  if (ci.flags & 16384)
                    return Fr.approximateLength += 4, e2.factory.createKeywordTypeNode(114);
                  if (ci.flags & 32768)
                    return Fr.approximateLength += 9, e2.factory.createKeywordTypeNode(153);
                  if (ci.flags & 65536)
                    return Fr.approximateLength += 4, e2.factory.createLiteralTypeNode(e2.factory.createNull());
                  if (ci.flags & 131072)
                    return Fr.approximateLength += 5, e2.factory.createKeywordTypeNode(143);
                  if (ci.flags & 4096)
                    return Fr.approximateLength += 6, e2.factory.createKeywordTypeNode(151);
                  if (ci.flags & 67108864)
                    return Fr.approximateLength += 6, e2.factory.createKeywordTypeNode(148);
                  if (e2.isThisTypeParameter(ci))
                    return Fr.flags & 4194304 && (!Fr.encounteredError && !(Fr.flags & 32768) && (Fr.encounteredError = true), Fr.tracker.reportInaccessibleThisError && Fr.tracker.reportInaccessibleThisError()), Fr.approximateLength += 4, e2.factory.createThisTypeNode();
                  if (!jt && ci.aliasSymbol && (Fr.flags & 16384 || Gu(ci.aliasSymbol, Fr.enclosingDeclaration))) {
                    var Ua = z(ci.aliasTypeArguments, Fr);
                    return Ol(ci.aliasSymbol.escapedName) && !(ci.aliasSymbol.flags & 32) ? e2.factory.createTypeReferenceNode(e2.factory.createIdentifier(""), Ua) : ca(ci.aliasSymbol, Fr, 788968, Ua);
                  }
                  var Yr = e2.getObjectFlags(ci);
                  if (Yr & 4)
                    return e2.Debug.assert(!!(ci.flags & 524288)), ci.node ? jd(ci, Tl) : Tl(ci);
                  if (ci.flags & 262144 || Yr & 3) {
                    if (ci.flags & 262144 && e2.contains(Fr.inferTypeParameters, ci)) {
                      Fr.approximateLength += e2.symbolName(ci.symbol).length + 6;
                      var Ni = void 0, Hi = Tc(ci);
                      if (Hi) {
                        var _t = sx(ci, true);
                        _t && wf(Hi, _t) || (Fr.approximateLength += 9, Ni = Hi && o(Hi, Fr));
                      }
                      return e2.factory.createInferTypeNode(dr(ci, Fr, Ni));
                    }
                    if (Fr.flags & 4 && ci.flags & 262144 && !Gu(ci.symbol, Fr.enclosingDeclaration)) {
                      var gt = ja(ci, Fr);
                      return Fr.approximateLength += e2.idText(gt).length, e2.factory.createTypeReferenceNode(e2.factory.createIdentifier(e2.idText(gt)), void 0);
                    }
                    if (ci.symbol)
                      return ca(ci.symbol, Fr, 788968);
                    var Vt = (ci === Rn || ci === Da) && _e && _e.symbol ? (ci === Da ? "sub-" : "super-") + e2.symbolName(_e.symbol) : "?";
                    return e2.factory.createTypeReferenceNode(e2.factory.createIdentifier(Vt), void 0);
                  }
                  if (ci.flags & 1048576 && ci.origin && (ci = ci.origin), ci.flags & 3145728) {
                    var Fa = ci.flags & 1048576 ? hd(ci.types) : ci.types;
                    if (e2.length(Fa) === 1)
                      return o(Fa[0], Fr);
                    var on = z(Fa, Fr, true);
                    if (on && on.length > 0)
                      return ci.flags & 1048576 ? e2.factory.createUnionTypeNode(on) : e2.factory.createIntersectionTypeNode(on);
                    !Fr.encounteredError && !(Fr.flags & 262144) && (Fr.encounteredError = true);
                    return;
                  }
                  if (Yr & 48)
                    return e2.Debug.assert(!!(ci.flags & 524288)), rl(ci);
                  if (ci.flags & 4194304) {
                    var zn = ci.type;
                    Fr.approximateLength += 6;
                    var Ga = o(zn, Fr);
                    return e2.factory.createTypeOperatorNode(140, Ga);
                  }
                  if (ci.flags & 134217728) {
                    var Qn = ci.texts, wo = ci.types, Po = e2.factory.createTemplateHead(Qn[0]), Uo = e2.factory.createNodeArray(e2.map(wo, function(za, $r) {
                      return e2.factory.createTemplateLiteralTypeSpan(o(za, Fr), ($r < wo.length - 1 ? e2.factory.createTemplateMiddle : e2.factory.createTemplateTail)(Qn[$r + 1]));
                    }));
                    return Fr.approximateLength += 2, e2.factory.createTemplateLiteralType(Po, Uo);
                  }
                  if (ci.flags & 268435456) {
                    var Rs = o(ci.type, Fr);
                    return ca(ci.symbol, Fr, 788968, [Rs]);
                  }
                  if (ci.flags & 8388608) {
                    var Fs = o(ci.objectType, Fr), Ga = o(ci.indexType, Fr);
                    return Fr.approximateLength += 2, e2.factory.createIndexedAccessTypeNode(Fs, Ga);
                  }
                  if (ci.flags & 16777216)
                    return jd(ci, function(za) {
                      return rc(za);
                    });
                  if (ci.flags & 33554432)
                    return o(ci.baseType, Fr);
                  return e2.Debug.fail("Should be unreachable.");
                  function rc(za) {
                    var $r = o(za.checkType, Fr);
                    if (Fr.approximateLength += 15, Fr.flags & 4 && za.root.isDistributive && !(za.checkType.flags & 262144)) {
                      var hi = Hc(oo(262144, "T")), Ri = ja(hi, Fr), mt = e2.factory.createTypeReferenceNode(Ri);
                      Fr.approximateLength += 37;
                      var ft = $d(za.root.checkType, hi, za.combinedMapper || za.mapper), Ht = Fr.inferTypeParameters;
                      Fr.inferTypeParameters = za.root.inferTypeParameters;
                      var vt = o(un(za.root.extendsType, ft), Fr);
                      Fr.inferTypeParameters = Ht;
                      var ht = xu(un(Va(za.root.node.trueType), ft)), ma = xu(un(Va(za.root.node.falseType), ft));
                      return e2.factory.createConditionalTypeNode($r, e2.factory.createInferTypeNode(e2.factory.createTypeParameterDeclaration(void 0, e2.factory.cloneNode(mt.typeName))), e2.factory.createConditionalTypeNode(e2.factory.createTypeReferenceNode(e2.factory.cloneNode(Ri)), o(za.checkType, Fr), e2.factory.createConditionalTypeNode(mt, vt, ht, ma), e2.factory.createKeywordTypeNode(143)), e2.factory.createKeywordTypeNode(143));
                    }
                    var Ca = Fr.inferTypeParameters;
                    Fr.inferTypeParameters = za.root.inferTypeParameters;
                    var An = o(za.extendsType, Fr);
                    Fr.inferTypeParameters = Ca;
                    var gn = xu(ip(za)), Vn = xu(tp(za));
                    return e2.factory.createConditionalTypeNode($r, An, gn, Vn);
                  }
                  function xu(za) {
                    var $r, hi, Ri;
                    return za.flags & 1048576 ? !(($r = Fr.visitedTypes) === null || $r === void 0) && $r.has(fu(za)) ? (Fr.flags & 131072 || (Fr.encounteredError = true, (Ri = (hi = Fr.tracker) === null || hi === void 0 ? void 0 : hi.reportCyclicStructureError) === null || Ri === void 0 || Ri.call(hi)), s2(Fr)) : jd(za, function(mt) {
                      return o(mt, Fr);
                    }) : o(za, Fr);
                  }
                  function Ts(za) {
                    e2.Debug.assert(!!(za.flags & 524288));
                    var $r = za.declaration.readonlyToken ? e2.factory.createToken(za.declaration.readonlyToken.kind) : void 0, hi = za.declaration.questionToken ? e2.factory.createToken(za.declaration.questionToken.kind) : void 0, Ri, mt;
                    if (mg(za)) {
                      if (!(Ed(za).flags & 262144) && Fr.flags & 4) {
                        var ft = Hc(oo(262144, "T")), Ht = ja(ft, Fr);
                        mt = e2.factory.createTypeReferenceNode(Ht);
                      }
                      Ri = e2.factory.createTypeOperatorNode(140, mt || o(Ed(za), Fr));
                    } else
                      Ri = o(Mu(za), Fr);
                    var vt = dr(Du(za), Fr, Ri), ht = za.declaration.nameType ? o(Jl(za), Fr) : void 0, ma = o(kg(vl(za), !!(Lu(za) & 4)), Fr), Ca = e2.factory.createMappedTypeNode($r, vt, ht, hi, ma, void 0);
                    Fr.approximateLength += 10;
                    var An = e2.setEmitFlags(Ca, 1);
                    return mg(za) && !(Ed(za).flags & 262144) && Fr.flags & 4 ? e2.factory.createConditionalTypeNode(o(Ed(za), Fr), e2.factory.createInferTypeNode(e2.factory.createTypeParameterDeclaration(void 0, e2.factory.cloneNode(mt.typeName))), An, e2.factory.createKeywordTypeNode(143)) : An;
                  }
                  function rl(za) {
                    var $r, hi = za.id, Ri = za.symbol;
                    if (Ri) {
                      var mt = yd(za) ? 788968 : 111551;
                      if (Sl(Ri.valueDeclaration))
                        return ca(Ri, Fr, mt);
                      if (Ri.flags & 32 && !Xa(Ri) && !(Ri.valueDeclaration && Ri.valueDeclaration.kind === 226 && Fr.flags & 2048) || Ri.flags & 896 || Ht())
                        return ca(Ri, Fr, mt);
                      if (!(($r = Fr.visitedTypes) === null || $r === void 0) && $r.has(hi)) {
                        var ft = Bp(za);
                        return ft ? ca(ft, Fr, 788968) : s2(Fr);
                      } else
                        return jd(za, lp);
                    } else
                      return lp(za);
                    function Ht() {
                      var vt, ht = !!(Ri.flags & 8192) && e2.some(Ri.declarations, function(Ca) {
                        return e2.isStatic(Ca);
                      }), ma = !!(Ri.flags & 16) && (Ri.parent || e2.forEach(Ri.declarations, function(Ca) {
                        return Ca.parent.kind === 305 || Ca.parent.kind === 262;
                      }));
                      if (ht || ma)
                        return (!!(Fr.flags & 4096) || ((vt = Fr.visitedTypes) === null || vt === void 0 ? void 0 : vt.has(hi))) && (!(Fr.flags & 8) || Lp(Ri, Fr.enclosingDeclaration));
                    }
                  }
                  function jd(za, $r) {
                    var hi, Ri, mt = za.id, ft = e2.getObjectFlags(za) & 16 && za.symbol && za.symbol.flags & 32, Ht = e2.getObjectFlags(za) & 4 && za.node ? "N" + A2(za.node) : za.flags & 16777216 ? "N" + A2(za.root.node) : za.symbol ? (ft ? "+" : "") + y(za.symbol) : void 0;
                    Fr.visitedTypes || (Fr.visitedTypes = new e2.Set()), Ht && !Fr.symbolDepth && (Fr.symbolDepth = new e2.Map());
                    var vt = Fr.enclosingDeclaration && va(Fr.enclosingDeclaration), ht = "".concat(fu(za), "|").concat(Fr.flags);
                    vt && (vt.serializedTypes || (vt.serializedTypes = new e2.Map()));
                    var ma = (hi = vt == null ? void 0 : vt.serializedTypes) === null || hi === void 0 ? void 0 : hi.get(ht);
                    if (ma)
                      return ma.truncating && (Fr.truncating = true), Fr.approximateLength += ma.addedLength, zo(ma);
                    var Ca;
                    if (Ht) {
                      if (Ca = Fr.symbolDepth.get(Ht) || 0, Ca > 10)
                        return s2(Fr);
                      Fr.symbolDepth.set(Ht, Ca + 1);
                    }
                    Fr.visitedTypes.add(mt);
                    var An = Fr.approximateLength, gn = $r(za), Vn = Fr.approximateLength - An;
                    return !Fr.reportedDiagnostic && !Fr.encounteredError && (Fr.truncating && (gn.truncating = true), gn.addedLength = Vn, (Ri = vt == null ? void 0 : vt.serializedTypes) === null || Ri === void 0 || Ri.set(ht, gn)), Fr.visitedTypes.delete(mt), Ht && Fr.symbolDepth.set(Ht, Ca), gn;
                    function zo(Bo) {
                      return !e2.nodeIsSynthesized(Bo) && e2.getParseTreeNode(Bo) === Bo ? Bo : e2.setTextRange(e2.factory.cloneNode(e2.visitEachChild(Bo, zo, e2.nullTransformationContext, us)), Bo);
                    }
                    function us(Bo, Io, Qo, ls, gi) {
                      return Bo && Bo.length === 0 ? e2.setTextRange(e2.factory.createNodeArray(void 0, Bo.hasTrailingComma), Bo) : e2.visitNodes(Bo, Io, Qo, ls, gi);
                    }
                  }
                  function lp(za) {
                    if (Bc(za) || za.containsError)
                      return Ts(za);
                    var $r = Ru(za);
                    if (!$r.properties.length && !$r.indexInfos.length) {
                      if (!$r.callSignatures.length && !$r.constructSignatures.length)
                        return Fr.approximateLength += 2, e2.setEmitFlags(e2.factory.createTypeLiteralNode(void 0), 1);
                      if ($r.callSignatures.length === 1 && !$r.constructSignatures.length) {
                        var hi = $r.callSignatures[0], Ri = $e(hi, 179, Fr);
                        return Ri;
                      }
                      if ($r.constructSignatures.length === 1 && !$r.callSignatures.length) {
                        var hi = $r.constructSignatures[0], Ri = $e(hi, 180, Fr);
                        return Ri;
                      }
                    }
                    var mt = e2.filter($r.constructSignatures, function(Ca) {
                      return !!(Ca.flags & 4);
                    });
                    if (e2.some(mt)) {
                      var ft = e2.map(mt, im), Ht = $r.callSignatures.length + ($r.constructSignatures.length - mt.length) + $r.indexInfos.length + (Fr.flags & 2048 ? e2.countWhere($r.properties, function(Ca) {
                        return !(Ca.flags & 4194304);
                      }) : e2.length($r.properties));
                      return Ht && ft.push(Op($r)), o(Do(ft), Fr);
                    }
                    var vt = Fr.flags;
                    Fr.flags |= 4194304;
                    var ht = id($r);
                    Fr.flags = vt;
                    var ma = e2.factory.createTypeLiteralNode(ht);
                    return Fr.approximateLength += 2, e2.setEmitFlags(ma, Fr.flags & 1024 ? 0 : 1), ma;
                  }
                  function Tl(za) {
                    var $r = xo(za);
                    if (za.target === Pi || za.target === Qi) {
                      if (Fr.flags & 2) {
                        var hi = o($r[0], Fr);
                        return e2.factory.createTypeReferenceNode(za.target === Pi ? "Array" : "ReadonlyArray", [hi]);
                      }
                      var Ri = o($r[0], Fr), mt = e2.factory.createArrayTypeNode(Ri);
                      return za.target === Pi ? mt : e2.factory.createTypeOperatorNode(145, mt);
                    } else if (za.target.objectFlags & 8) {
                      if ($r = e2.sameMap($r, function(zt, La) {
                        return kg(zt, !!(za.target.elementFlags[La] & 2));
                      }), $r.length > 0) {
                        var ft = $_(za), Ht = z($r.slice(0, ft), Fr);
                        if (Ht) {
                          if (za.target.labeledElementDeclarations)
                            for (var vt = 0; vt < Ht.length; vt++) {
                              var ht = za.target.elementFlags[vt];
                              Ht[vt] = e2.factory.createNamedTupleMember(ht & 12 ? e2.factory.createToken(25) : void 0, e2.factory.createIdentifier(e2.unescapeLeadingUnderscores(E0(za.target.labeledElementDeclarations[vt]))), ht & 2 ? e2.factory.createToken(57) : void 0, ht & 4 ? e2.factory.createArrayTypeNode(Ht[vt]) : Ht[vt]);
                            }
                          else
                            for (var vt = 0; vt < Math.min(ft, Ht.length); vt++) {
                              var ht = za.target.elementFlags[vt];
                              Ht[vt] = ht & 12 ? e2.factory.createRestTypeNode(ht & 4 ? e2.factory.createArrayTypeNode(Ht[vt]) : Ht[vt]) : ht & 2 ? e2.factory.createOptionalTypeNode(Ht[vt]) : Ht[vt];
                            }
                          var ma = e2.setEmitFlags(e2.factory.createTupleTypeNode(Ht), 1);
                          return za.target.readonly ? e2.factory.createTypeOperatorNode(145, ma) : ma;
                        }
                      }
                      if (Fr.encounteredError || Fr.flags & 524288) {
                        var ma = e2.setEmitFlags(e2.factory.createTupleTypeNode([]), 1);
                        return za.target.readonly ? e2.factory.createTypeOperatorNode(145, ma) : ma;
                      }
                      Fr.encounteredError = true;
                      return;
                    } else {
                      if (Fr.flags & 2048 && za.symbol.valueDeclaration && e2.isClassLike(za.symbol.valueDeclaration) && !Lp(za.symbol, Fr.enclosingDeclaration))
                        return rl(za);
                      var Ca = za.target.outerTypeParameters, vt = 0, An = void 0;
                      if (Ca)
                        for (var gn = Ca.length; vt < gn; ) {
                          var Vn = vt, zo = cx(Ca[vt]);
                          do
                            vt++;
                          while (vt < gn && cx(Ca[vt]) === zo);
                          if (!e2.rangeEquals(Ca, $r, Vn, vt)) {
                            var us = z($r.slice(Vn, vt), Fr), Bo = Fr.flags;
                            Fr.flags |= 16;
                            var Io = ca(zo, Fr, 788968, us);
                            Fr.flags = Bo, An = An ? fp(An, Io) : Io;
                          }
                        }
                      var Qo = void 0;
                      if ($r.length > 0) {
                        var ls = (za.target.typeParameters || e2.emptyArray).length;
                        Qo = z($r.slice(vt, ls), Fr);
                      }
                      var ht = Fr.flags;
                      Fr.flags |= 16;
                      var gi = ca(za.symbol, Fr, 788968, Qo);
                      return Fr.flags = ht, An ? fp(An, gi) : gi;
                    }
                  }
                  function fp(za, $r) {
                    if (e2.isImportTypeNode(za)) {
                      var hi = za.typeArguments, Ri = za.qualifier;
                      Ri && (e2.isIdentifier(Ri) ? Ri = e2.factory.updateIdentifier(Ri, hi) : Ri = e2.factory.updateQualifiedName(Ri, Ri.left, e2.factory.updateIdentifier(Ri.right, hi))), hi = $r.typeArguments;
                      for (var mt = zg($r), ft = 0, Ht = mt; ft < Ht.length; ft++) {
                        var vt = Ht[ft];
                        Ri = Ri ? e2.factory.createQualifiedName(Ri, vt) : vt;
                      }
                      return e2.factory.updateImportTypeNode(za, za.argument, Ri, hi, za.isTypeOf);
                    } else {
                      var hi = za.typeArguments, ht = za.typeName;
                      e2.isIdentifier(ht) ? ht = e2.factory.updateIdentifier(ht, hi) : ht = e2.factory.updateQualifiedName(ht, ht.left, e2.factory.updateIdentifier(ht.right, hi)), hi = $r.typeArguments;
                      for (var mt = zg($r), ma = 0, Ca = mt; ma < Ca.length; ma++) {
                        var vt = Ca[ma];
                        ht = e2.factory.createQualifiedName(ht, vt);
                      }
                      return e2.factory.updateTypeReferenceNode(za, ht, hi);
                    }
                  }
                  function zg(za) {
                    for (var $r = za.typeName, hi = []; !e2.isIdentifier($r); )
                      hi.unshift($r.right), $r = $r.left;
                    return hi.unshift($r), hi;
                  }
                  function id(za) {
                    if (t2(Fr))
                      return [e2.factory.createPropertySignature(void 0, "...", void 0, void 0)];
                    for (var $r = [], hi = 0, Ri = za.callSignatures; hi < Ri.length; hi++) {
                      var mt = Ri[hi];
                      $r.push($e(mt, 174, Fr));
                    }
                    for (var ft = 0, Ht = za.constructSignatures; ft < Ht.length; ft++) {
                      var mt = Ht[ft];
                      mt.flags & 4 || $r.push($e(mt, 175, Fr));
                    }
                    for (var vt = 0, ht = za.indexInfos; vt < ht.length; vt++) {
                      var ma = ht[vt];
                      $r.push(Me(ma, Fr, za.objectFlags & 1024 ? s2(Fr) : void 0));
                    }
                    var Ca = za.properties;
                    if (!Ca)
                      return $r;
                    for (var An = 0, gn = 0, Vn = Ca; gn < Vn.length; gn++) {
                      var zo = Vn[gn];
                      if (An++, Fr.flags & 2048) {
                        if (zo.flags & 4194304)
                          continue;
                        e2.getDeclarationModifierFlagsFromSymbol(zo) & 24 && Fr.tracker.reportPrivateInBaseOfClassExpression && Fr.tracker.reportPrivateInBaseOfClassExpression(e2.unescapeLeadingUnderscores(zo.escapedName));
                      }
                      if (t2(Fr) && An + 2 < Ca.length - 1) {
                        $r.push(e2.factory.createPropertySignature(void 0, "... ".concat(Ca.length - An, " more ..."), void 0, void 0)), h2(Ca[Ca.length - 1], Fr, $r);
                        break;
                      }
                      h2(zo, Fr, $r);
                    }
                    return $r.length ? $r : void 0;
                  }
                }
                function s2(ci) {
                  return ci.approximateLength += 3, ci.flags & 1 ? e2.factory.createKeywordTypeNode(130) : e2.factory.createTypeReferenceNode(e2.factory.createIdentifier("..."), void 0);
                }
                function u(ci, Fr) {
                  var jt;
                  return !!(e2.getCheckFlags(ci) & 8192) && (e2.contains(Fr.reverseMappedStack, ci) || ((jt = Fr.reverseMappedStack) === null || jt === void 0 ? void 0 : jt[0]) && !(e2.getObjectFlags(e2.last(Fr.reverseMappedStack).propertyType) & 16));
                }
                function h2(ci, Fr, jt) {
                  var Lt, ea, Kt = !!(e2.getCheckFlags(ci) & 8192), $t = u(ci, Fr) ? Oe : ml(ci), Ua = Fr.enclosingDeclaration;
                  if (Fr.enclosingDeclaration = void 0, Fr.tracker.trackSymbol && e2.getCheckFlags(ci) & 4096 && pg(ci.escapedName))
                    if (ci.declarations) {
                      var Yr = e2.first(ci.declarations);
                      if ($g(Yr))
                        if (e2.isBinaryExpression(Yr)) {
                          var Ni = e2.getNameOfDeclaration(Yr);
                          Ni && e2.isElementAccessExpression(Ni) && e2.isPropertyAccessEntityNameExpression(Ni.argumentExpression) && li(Ni.argumentExpression, Ua, Fr);
                        } else
                          li(Yr.name.expression, Ua, Fr);
                    } else
                      !((Lt = Fr.tracker) === null || Lt === void 0) && Lt.reportNonSerializableProperty && Fr.tracker.reportNonSerializableProperty(tn(ci));
                  Fr.enclosingDeclaration = ci.valueDeclaration || ((ea = ci.declarations) === null || ea === void 0 ? void 0 : ea[0]) || Ua;
                  var Hi = lt(ci, Fr);
                  Fr.enclosingDeclaration = Ua, Fr.approximateLength += e2.symbolName(ci).length + 1;
                  var _t = ci.flags & 16777216 ? e2.factory.createToken(57) : void 0;
                  if (ci.flags & 8208 && !Pf($t).length && !Zu(ci))
                    for (var gt = ot(ec($t, function(Uo) {
                      return !(Uo.flags & 32768);
                    }), 0), Vt = 0, Fa = gt; Vt < Fa.length; Vt++) {
                      var on = Fa[Vt], zn = $e(on, 168, Fr, { name: Hi, questionToken: _t });
                      jt.push(Po(zn));
                    }
                  else {
                    var Ga = void 0;
                    u(ci, Fr) ? Ga = s2(Fr) : (Kt && (Fr.reverseMappedStack || (Fr.reverseMappedStack = []), Fr.reverseMappedStack.push(ci)), Ga = $t ? Ka(Fr, $t, ci, Ua) : e2.factory.createKeywordTypeNode(130), Kt && Fr.reverseMappedStack.pop());
                    var Qn = Zu(ci) ? [e2.factory.createToken(145)] : void 0;
                    Qn && (Fr.approximateLength += 9);
                    var wo = e2.factory.createPropertySignature(Qn, Hi, _t, Ga);
                    jt.push(Po(wo));
                  }
                  function Po(Uo) {
                    var Rs;
                    if (e2.some(ci.declarations, function(xu) {
                      return xu.kind === 347;
                    })) {
                      var Fs = (Rs = ci.declarations) === null || Rs === void 0 ? void 0 : Rs.find(function(xu) {
                        return xu.kind === 347;
                      }), rc = e2.getTextOfJSDocComment(Fs.comment);
                      rc && e2.setSyntheticLeadingComments(Uo, [{ kind: 3, text: `*
 * ` + rc.replace(/\n/g, `
 * `) + `
 `, pos: -1, end: -1, hasTrailingNewLine: true }]);
                    } else
                      ci.valueDeclaration && e2.setCommentRange(Uo, ci.valueDeclaration);
                    return Uo;
                  }
                }
                function z(ci, Fr, jt) {
                  if (e2.some(ci)) {
                    if (t2(Fr))
                      if (jt) {
                        if (ci.length > 2)
                          return [o(ci[0], Fr), e2.factory.createTypeReferenceNode("... ".concat(ci.length - 2, " more ..."), void 0), o(ci[ci.length - 1], Fr)];
                      } else
                        return [e2.factory.createTypeReferenceNode("...", void 0)];
                    for (var Lt = !(Fr.flags & 64), ea = Lt ? e2.createUnderscoreEscapedMultiMap() : void 0, Kt = [], $t = 0, Ua = 0, Yr = ci; Ua < Yr.length; Ua++) {
                      var Ni = Yr[Ua];
                      if ($t++, t2(Fr) && $t + 2 < ci.length - 1) {
                        Kt.push(e2.factory.createTypeReferenceNode("... ".concat(ci.length - $t, " more ..."), void 0));
                        var Hi = o(ci[ci.length - 1], Fr);
                        Hi && Kt.push(Hi);
                        break;
                      }
                      Fr.approximateLength += 2;
                      var _t = o(Ni, Fr);
                      _t && (Kt.push(_t), ea && e2.isIdentifierTypeReference(_t) && ea.add(_t.typeName.escapedText, [Ni, Kt.length - 1]));
                    }
                    if (ea) {
                      var gt = Fr.flags;
                      Fr.flags |= 64, ea.forEach(function(Vt) {
                        if (!e2.arrayIsHomogeneous(Vt, function(wo, Po) {
                          var Uo = wo[0], Rs = Po[0];
                          return me(Uo, Rs);
                        }))
                          for (var Fa = 0, on = Vt; Fa < on.length; Fa++) {
                            var zn = on[Fa], Ga = zn[0], Qn = zn[1];
                            Kt[Qn] = o(Ga, Fr);
                          }
                      }), Fr.flags = gt;
                    }
                    return Kt;
                  }
                }
                function me(ci, Fr) {
                  return ci === Fr || !!ci.symbol && ci.symbol === Fr.symbol || !!ci.aliasSymbol && ci.aliasSymbol === Fr.aliasSymbol;
                }
                function Me(ci, Fr, jt) {
                  var Lt = e2.getNameFromIndexInfo(ci) || "x", ea = o(ci.keyType, Fr), Kt = e2.factory.createParameterDeclaration(void 0, void 0, void 0, Lt, void 0, ea, void 0);
                  return jt || (jt = o(ci.type || Oe, Fr)), !ci.type && !(Fr.flags & 2097152) && (Fr.encounteredError = true), Fr.approximateLength += Lt.length + 4, e2.factory.createIndexSignature(void 0, ci.isReadonly ? [e2.factory.createToken(145)] : void 0, [Kt], jt);
                }
                function $e(ci, Fr, jt, Lt) {
                  var ea, Kt, $t, Ua, Yr = jt.flags & 256;
                  Yr && (jt.flags &= -257), jt.approximateLength += 3;
                  var Ni, Hi;
                  jt.flags & 32 && ci.target && ci.mapper && ci.target.typeParameters ? Hi = ci.target.typeParameters.map(function(Fs) {
                    return o(un(Fs, ci.mapper), jt);
                  }) : Ni = ci.typeParameters && ci.typeParameters.map(function(Fs) {
                    return Dr(Fs, jt);
                  });
                  var _t = Jm(ci, true)[0], gt = (e2.some(_t, function(Fs) {
                    return Fs !== _t[_t.length - 1] && !!(e2.getCheckFlags(Fs) & 32768);
                  }) ? ci.parameters : _t).map(function(Fs) {
                    return Qr(Fs, jt, Fr === 171, Lt == null ? void 0 : Lt.privateSymbolVisitor, Lt == null ? void 0 : Lt.bundledImports);
                  }), Vt = tr(ci, jt);
                  Vt && gt.unshift(Vt);
                  var Fa, on = Yc(ci);
                  if (on) {
                    var zn = on.kind === 2 || on.kind === 3 ? e2.factory.createToken(128) : void 0, Ga = on.kind === 1 || on.kind === 3 ? e2.setEmitFlags(e2.factory.createIdentifier(on.parameterName), 16777216) : e2.factory.createThisTypeNode(), Qn = on.type && o(on.type, jt);
                    Fa = e2.factory.createTypePredicateNode(zn, Ga, Qn);
                  } else {
                    var wo = yo(ci);
                    wo && !(Yr && ta(wo)) ? Fa = Un(jt, wo, ci, Lt == null ? void 0 : Lt.privateSymbolVisitor, Lt == null ? void 0 : Lt.bundledImports) : Yr || (Fa = e2.factory.createKeywordTypeNode(130));
                  }
                  var Po = Lt == null ? void 0 : Lt.modifiers;
                  if (Fr === 180 && ci.flags & 4) {
                    var Uo = e2.modifiersToFlags(Po);
                    Po = e2.factory.createModifiersFromModifierFlags(Uo | 128);
                  }
                  var Rs = Fr === 174 ? e2.factory.createCallSignature(Ni, gt, Fa) : Fr === 175 ? e2.factory.createConstructSignature(Ni, gt, Fa) : Fr === 168 ? e2.factory.createMethodSignature(Po, (ea = Lt == null ? void 0 : Lt.name) !== null && ea !== void 0 ? ea : e2.factory.createIdentifier(""), Lt == null ? void 0 : Lt.questionToken, Ni, gt, Fa) : Fr === 169 ? e2.factory.createMethodDeclaration(void 0, Po, void 0, (Kt = Lt == null ? void 0 : Lt.name) !== null && Kt !== void 0 ? Kt : e2.factory.createIdentifier(""), void 0, Ni, gt, Fa, void 0) : Fr === 171 ? e2.factory.createConstructorDeclaration(void 0, Po, gt, void 0) : Fr === 172 ? e2.factory.createGetAccessorDeclaration(void 0, Po, ($t = Lt == null ? void 0 : Lt.name) !== null && $t !== void 0 ? $t : e2.factory.createIdentifier(""), gt, Fa, void 0) : Fr === 173 ? e2.factory.createSetAccessorDeclaration(void 0, Po, (Ua = Lt == null ? void 0 : Lt.name) !== null && Ua !== void 0 ? Ua : e2.factory.createIdentifier(""), gt, void 0) : Fr === 176 ? e2.factory.createIndexSignature(void 0, Po, gt, Fa) : Fr === 317 ? e2.factory.createJSDocFunctionType(gt, Fa) : Fr === 179 ? e2.factory.createFunctionTypeNode(Ni, gt, Fa != null ? Fa : e2.factory.createTypeReferenceNode(e2.factory.createIdentifier(""))) : Fr === 180 ? e2.factory.createConstructorTypeNode(Po, Ni, gt, Fa != null ? Fa : e2.factory.createTypeReferenceNode(e2.factory.createIdentifier(""))) : Fr === 256 ? e2.factory.createFunctionDeclaration(void 0, Po, void 0, Lt != null && Lt.name ? e2.cast(Lt.name, e2.isIdentifier) : e2.factory.createIdentifier(""), Ni, gt, Fa, void 0) : Fr === 213 ? e2.factory.createFunctionExpression(Po, void 0, Lt != null && Lt.name ? e2.cast(Lt.name, e2.isIdentifier) : e2.factory.createIdentifier(""), Ni, gt, Fa, e2.factory.createBlock([])) : Fr === 214 ? e2.factory.createArrowFunction(Po, Ni, gt, Fa, void 0, e2.factory.createBlock([])) : e2.Debug.assertNever(Fr);
                  return Hi && (Rs.typeArguments = e2.factory.createNodeArray(Hi)), Rs;
                }
                function tr(ci, Fr) {
                  if (ci.thisParameter)
                    return Qr(ci.thisParameter, Fr);
                  if (ci.declaration) {
                    var jt = e2.getJSDocThisTag(ci.declaration);
                    if (jt && jt.typeExpression)
                      return e2.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, o(Va(jt.typeExpression), Fr));
                  }
                }
                function dr(ci, Fr, jt) {
                  var Lt = Fr.flags;
                  Fr.flags &= -513;
                  var ea = e2.factory.createModifiersFromModifierFlags(WD(ci)), Kt = ja(ci, Fr), $t = D_(ci), Ua = $t && o($t, Fr);
                  return Fr.flags = Lt, e2.factory.createTypeParameterDeclaration(ea, Kt, jt, Ua);
                }
                function Dr(ci, Fr, jt) {
                  jt === void 0 && (jt = Tc(ci));
                  var Lt = jt && o(jt, Fr);
                  return dr(ci, Fr, Lt);
                }
                function Qr(ci, Fr, jt, Lt, ea) {
                  var Kt = e2.getDeclarationOfKind(ci, 164);
                  !Kt && !e2.isTransientSymbol(ci) && (Kt = e2.getDeclarationOfKind(ci, 340));
                  var $t = Jt(ci);
                  Kt && aA(Kt) && ($t = i_($t));
                  var Ua = Ka(Fr, $t, ci, Fr.enclosingDeclaration, Lt, ea), Yr = !(Fr.flags & 8192) && jt && Kt && Kt.modifiers ? Kt.modifiers.map(e2.factory.cloneNode) : void 0, Ni = Kt && e2.isRestParameter(Kt) || e2.getCheckFlags(ci) & 32768, Hi = Ni ? e2.factory.createToken(25) : void 0, _t = Kt && Kt.name ? Kt.name.kind === 79 ? e2.setEmitFlags(e2.factory.cloneNode(Kt.name), 16777216) : Kt.name.kind === 161 ? e2.setEmitFlags(e2.factory.cloneNode(Kt.name.right), 16777216) : on(Kt.name) : e2.symbolName(ci), gt = Kt && kd(Kt) || e2.getCheckFlags(ci) & 16384, Vt = gt ? e2.factory.createToken(57) : void 0, Fa = e2.factory.createParameterDeclaration(void 0, Yr, Hi, _t, Vt, Ua, void 0);
                  return Fr.approximateLength += e2.symbolName(ci).length + 3, Fa;
                  function on(zn) {
                    return Ga(zn);
                    function Ga(Qn) {
                      Fr.tracker.trackSymbol && e2.isComputedPropertyName(Qn) && Rv(Qn) && li(Qn.expression, Fr.enclosingDeclaration, Fr);
                      var wo = e2.visitEachChild(Qn, Ga, e2.nullTransformationContext, void 0, Ga);
                      return e2.isBindingElement(wo) && (wo = e2.factory.updateBindingElement(wo, wo.dotDotDotToken, wo.propertyName, wo.name, void 0)), e2.nodeIsSynthesized(wo) || (wo = e2.factory.cloneNode(wo)), e2.setEmitFlags(wo, 16777217);
                    }
                  }
                }
                function li(ci, Fr, jt) {
                  if (!!jt.tracker.trackSymbol) {
                    var Lt = e2.getFirstIdentifier(ci), ea = es(Lt, Lt.escapedText, 1160127, void 0, void 0, true);
                    ea && jt.tracker.trackSymbol(ea, Fr, 111551);
                  }
                }
                function Ti(ci, Fr, jt, Lt) {
                  return Fr.tracker.trackSymbol(ci, Fr.enclosingDeclaration, jt), Ci(ci, Fr, jt, Lt);
                }
                function Ci(ci, Fr, jt, Lt) {
                  var ea, Kt = ci.flags & 262144;
                  return !Kt && (Fr.enclosingDeclaration || Fr.flags & 64) && !(Fr.flags & 134217728) ? (ea = e2.Debug.checkDefined($t(ci, jt, true)), e2.Debug.assert(ea && ea.length > 0)) : ea = [ci], ea;
                  function $t(Ua, Yr, Ni) {
                    var Hi = pl(Ua, Fr.enclosingDeclaration, Yr, !!(Fr.flags & 128)), _t;
                    if (!Hi || Fp(Hi[0], Fr.enclosingDeclaration, Hi.length === 1 ? Yr : Fl(Yr))) {
                      var gt = Np(Hi ? Hi[0] : Ua, Fr.enclosingDeclaration, Yr);
                      if (e2.length(gt)) {
                        _t = gt.map(function(Po) {
                          return e2.some(Po.declarations, Fc) ? Nt(Po, Fr) : void 0;
                        });
                        var Vt = gt.map(function(Po, Uo) {
                          return Uo;
                        });
                        Vt.sort(wo);
                        for (var Fa = Vt.map(function(Po) {
                          return gt[Po];
                        }), on = 0, zn = Fa; on < zn.length; on++) {
                          var Ga = zn[on], Qn = $t(Ga, Fl(Yr), false);
                          if (Qn) {
                            if (Ga.exports && Ga.exports.get("export=") && _l(Ga.exports.get("export="), Ua)) {
                              Hi = Qn;
                              break;
                            }
                            Hi = Qn.concat(Hi || [fl(Ga, Ua) || Ua]);
                            break;
                          }
                        }
                      }
                    }
                    if (Hi)
                      return Hi;
                    if (Ni || !(Ua.flags & 6144))
                      return !Ni && !Lt && !!e2.forEach(Ua.declarations, Fc) ? void 0 : [Ua];
                    function wo(Po, Uo) {
                      var Rs = _t[Po], Fs = _t[Uo];
                      if (Rs && Fs) {
                        var rc = e2.pathIsRelative(Fs);
                        return e2.pathIsRelative(Rs) === rc ? e2.moduleSpecifiers.countPathComponents(Rs) - e2.moduleSpecifiers.countPathComponents(Fs) : rc ? -1 : 1;
                      }
                      return 0;
                    }
                  }
                }
                function $i(ci, Fr) {
                  var jt, Lt = jg(ci);
                  return Lt.flags & 524384 && (jt = e2.factory.createNodeArray(e2.map(Af(ci), function(ea) {
                    return Dr(ea, Fr);
                  }))), jt;
                }
                function Zi(ci, Fr, jt) {
                  var Lt;
                  e2.Debug.assert(ci && 0 <= Fr && Fr < ci.length);
                  var ea = ci[Fr], Kt = y(ea);
                  if (!(!((Lt = jt.typeParameterSymbolList) === null || Lt === void 0) && Lt.has(Kt))) {
                    (jt.typeParameterSymbolList || (jt.typeParameterSymbolList = new e2.Set())).add(Kt);
                    var $t;
                    if (jt.flags & 512 && Fr < ci.length - 1) {
                      var Ua = ea, Yr = ci[Fr + 1];
                      if (e2.getCheckFlags(Yr) & 1) {
                        var Ni = Hg(Ua.flags & 2097152 ? Ps(Ua) : Ua);
                        $t = z(e2.map(Ni, function(Hi) {
                          return ap(Hi, Yr.mapper);
                        }), jt);
                      } else
                        $t = $i(ea, jt);
                    }
                    return $t;
                  }
                }
                function qt(ci) {
                  return e2.isIndexedAccessTypeNode(ci.objectType) ? qt(ci.objectType) : ci;
                }
                function Nt(ci, Fr, jt) {
                  var Lt, ea = e2.getDeclarationOfKind(ci, 305);
                  if (!ea) {
                    var Kt = e2.firstDefined(ci.declarations, function(wo) {
                      return nc(wo, ci);
                    });
                    Kt && (ea = e2.getDeclarationOfKind(Kt, 305));
                  }
                  if (ea && ea.moduleName !== void 0)
                    return ea.moduleName;
                  if (!ea) {
                    if (Fr.tracker.trackReferencedAmbientModule) {
                      var $t = e2.filter(ci.declarations, e2.isAmbientModule);
                      if (e2.length($t))
                        for (var Ua = 0, Yr = $t; Ua < Yr.length; Ua++) {
                          var Ni = Yr[Ua];
                          Fr.tracker.trackReferencedAmbientModule(Ni, ci);
                        }
                    }
                    if (a.test(ci.escapedName))
                      return ci.escapedName.substring(1, ci.escapedName.length - 1);
                  }
                  if (!Fr.enclosingDeclaration || !Fr.tracker.moduleResolverHost)
                    return a.test(ci.escapedName) ? ci.escapedName.substring(1, ci.escapedName.length - 1) : e2.getSourceFileOfNode(e2.getNonAugmentationDeclaration(ci)).fileName;
                  var Hi = e2.getSourceFileOfNode(e2.getOriginalNode(Fr.enclosingDeclaration)), _t = jt || (Hi == null ? void 0 : Hi.impliedNodeFormat), gt = Qn(Hi.path, _t), Vt = Aa(ci), Fa = Vt.specifierCache && Vt.specifierCache.get(gt);
                  if (!Fa) {
                    var on = !!e2.outFile(ye), zn = Fr.tracker.moduleResolverHost, Ga = on ? Ke(Ke({}, ye), { baseUrl: zn.getCommonSourceDirectory() }) : ye;
                    Fa = e2.first(e2.moduleSpecifiers.getModuleSpecifiers(ci, Di, Ga, Hi, zn, { importModuleSpecifierPreference: on ? "non-relative" : "project-relative", importModuleSpecifierEnding: on ? "minimal" : _t === e2.ModuleKind.ESNext ? "js" : void 0 }, { overrideImportMode: jt })), (Lt = Vt.specifierCache) !== null && Lt !== void 0 || (Vt.specifierCache = new e2.Map()), Vt.specifierCache.set(gt, Fa);
                  }
                  return Fa;
                  function Qn(wo, Po) {
                    return Po === void 0 ? wo : "".concat(Po, "|").concat(wo);
                  }
                }
                function Ra(ci) {
                  var Fr = e2.factory.createIdentifier(e2.unescapeLeadingUnderscores(ci.escapedName));
                  return ci.parent ? e2.factory.createQualifiedName(Ra(ci.parent), Fr) : Fr;
                }
                function ca(ci, Fr, jt, Lt) {
                  var ea = Ti(ci, Fr, jt, !(Fr.flags & 16384)), Kt = jt === 111551;
                  if (e2.some(ea[0].declarations, Fc)) {
                    var $t = ea.length > 1 ? Po(ea, ea.length - 1, 1) : void 0, Ua = Lt || Zi(ea, 0, Fr), Yr = e2.getSourceFileOfNode(e2.getOriginalNode(Fr.enclosingDeclaration)), Ni = e2.getSourceFileOfModule(ea[0]), Hi = void 0, _t = void 0;
                    if ((e2.getEmitModuleResolutionKind(ye) === e2.ModuleResolutionKind.Node16 || e2.getEmitModuleResolutionKind(ye) === e2.ModuleResolutionKind.NodeNext) && (Ni == null ? void 0 : Ni.impliedNodeFormat) === e2.ModuleKind.ESNext && Ni.impliedNodeFormat !== (Yr == null ? void 0 : Yr.impliedNodeFormat) && (Hi = Nt(ea[0], Fr, e2.ModuleKind.ESNext), _t = e2.factory.createImportTypeAssertionContainer(e2.factory.createAssertClause(e2.factory.createNodeArray([e2.factory.createAssertEntry(e2.factory.createStringLiteral("resolution-mode"), e2.factory.createStringLiteral("import"))])))), Hi || (Hi = Nt(ea[0], Fr)), !(Fr.flags & 67108864) && e2.getEmitModuleResolutionKind(ye) !== e2.ModuleResolutionKind.Classic && Hi.indexOf("/node_modules/") >= 0) {
                      var gt = Hi;
                      if (e2.getEmitModuleResolutionKind(ye) === e2.ModuleResolutionKind.Node16 || e2.getEmitModuleResolutionKind(ye) === e2.ModuleResolutionKind.NodeNext) {
                        var Vt = (Yr == null ? void 0 : Yr.impliedNodeFormat) === e2.ModuleKind.ESNext ? e2.ModuleKind.CommonJS : e2.ModuleKind.ESNext;
                        Hi = Nt(ea[0], Fr, Vt), Hi.indexOf("/node_modules/") >= 0 ? Hi = gt : _t = e2.factory.createImportTypeAssertionContainer(e2.factory.createAssertClause(e2.factory.createNodeArray([e2.factory.createAssertEntry(e2.factory.createStringLiteral("resolution-mode"), e2.factory.createStringLiteral(Vt === e2.ModuleKind.ESNext ? "import" : "require"))])));
                      }
                      _t || (Fr.encounteredError = true, Fr.tracker.reportLikelyUnsafeImportRequiredError && Fr.tracker.reportLikelyUnsafeImportRequiredError(gt));
                    }
                    var Fa = e2.factory.createLiteralTypeNode(e2.factory.createStringLiteral(Hi));
                    if (Fr.tracker.trackExternalModuleSymbolOfImportTypeNode && Fr.tracker.trackExternalModuleSymbolOfImportTypeNode(ea[0]), Fr.approximateLength += Hi.length + 10, !$t || e2.isEntityName($t)) {
                      if ($t) {
                        var on = e2.isIdentifier($t) ? $t : $t.right;
                        on.typeArguments = void 0;
                      }
                      return e2.factory.createImportTypeNode(Fa, _t, $t, Ua, Kt);
                    } else {
                      var zn = qt($t), Ga = zn.objectType.typeName;
                      return e2.factory.createIndexedAccessTypeNode(e2.factory.createImportTypeNode(Fa, _t, Ga, Ua, Kt), zn.indexType);
                    }
                  }
                  var Qn = Po(ea, ea.length - 1, 0);
                  if (e2.isIndexedAccessTypeNode(Qn))
                    return Qn;
                  if (Kt)
                    return e2.factory.createTypeQueryNode(Qn);
                  var on = e2.isIdentifier(Qn) ? Qn : Qn.right, wo = on.typeArguments;
                  return on.typeArguments = void 0, e2.factory.createTypeReferenceNode(Qn, wo);
                  function Po(Uo, Rs, Fs) {
                    var rc = Rs === Uo.length - 1 ? Lt : Zi(Uo, Rs, Fr), xu = Uo[Rs], Ts = Uo[Rs - 1], rl;
                    if (Rs === 0)
                      Fr.flags |= 16777216, rl = of(xu, Fr), Fr.approximateLength += (rl ? rl.length : 0) + 1, Fr.flags ^= 16777216;
                    else if (Ts && dc(Ts)) {
                      var jd = dc(Ts);
                      e2.forEachEntry(jd, function(zg, id) {
                        if (_l(zg, xu) && !pg(id) && id !== "export=")
                          return rl = e2.unescapeLeadingUnderscores(id), true;
                      });
                    }
                    if (rl === void 0) {
                      var lp = e2.firstDefined(xu.declarations, e2.getNameOfDeclaration);
                      if (lp && e2.isComputedPropertyName(lp) && e2.isEntityName(lp.expression)) {
                        var Tl = Po(Uo, Rs - 1, Fs);
                        return e2.isEntityName(Tl) ? e2.factory.createIndexedAccessTypeNode(e2.factory.createParenthesizedType(e2.factory.createTypeQueryNode(Tl)), e2.factory.createTypeQueryNode(lp.expression)) : Tl;
                      }
                      rl = of(xu, Fr);
                    }
                    if (Fr.approximateLength += rl.length + 1, !(Fr.flags & 16) && Ts && Nf(Ts) && Nf(Ts).get(xu.escapedName) && _l(Nf(Ts).get(xu.escapedName), xu)) {
                      var Tl = Po(Uo, Rs - 1, Fs);
                      return e2.isIndexedAccessTypeNode(Tl) ? e2.factory.createIndexedAccessTypeNode(Tl, e2.factory.createLiteralTypeNode(e2.factory.createStringLiteral(rl))) : e2.factory.createIndexedAccessTypeNode(e2.factory.createTypeReferenceNode(Tl, rc), e2.factory.createLiteralTypeNode(e2.factory.createStringLiteral(rl)));
                    }
                    var fp = e2.setEmitFlags(e2.factory.createIdentifier(rl, rc), 16777216);
                    if (fp.symbol = xu, Rs > Fs) {
                      var Tl = Po(Uo, Rs - 1, Fs);
                      return e2.isEntityName(Tl) ? e2.factory.createQualifiedName(Tl, fp) : e2.Debug.fail("Impossible construct - an export of an indexed access cannot be reachable");
                    }
                    return fp;
                  }
                }
                function Sn(ci, Fr, jt) {
                  var Lt = es(Fr.enclosingDeclaration, ci, 788968, void 0, ci, false);
                  return Lt ? !(Lt.flags & 262144 && Lt === jt.symbol) : false;
                }
                function ja(ci, Fr) {
                  var jt, Lt;
                  if (Fr.flags & 4 && Fr.typeParameterNames) {
                    var ea = Fr.typeParameterNames.get(fu(ci));
                    if (ea)
                      return ea;
                  }
                  var Kt = Fn(ci.symbol, Fr, 788968, true);
                  if (!(Kt.kind & 79))
                    return e2.factory.createIdentifier("(Missing type parameter)");
                  if (Fr.flags & 4) {
                    for (var $t = Kt.escapedText, Ua = ((jt = Fr.typeParameterNamesByTextNextNameCount) === null || jt === void 0 ? void 0 : jt.get($t)) || 0, Yr = $t; ((Lt = Fr.typeParameterNamesByText) === null || Lt === void 0 ? void 0 : Lt.has(Yr)) || Sn(Yr, Fr, ci); )
                      Ua++, Yr = "".concat($t, "_").concat(Ua);
                    Yr !== $t && (Kt = e2.factory.createIdentifier(Yr, Kt.typeArguments)), (Fr.typeParameterNamesByTextNextNameCount || (Fr.typeParameterNamesByTextNextNameCount = new e2.Map())).set($t, Ua), (Fr.typeParameterNames || (Fr.typeParameterNames = new e2.Map())).set(fu(ci), Kt), (Fr.typeParameterNamesByText || (Fr.typeParameterNamesByText = new e2.Set())).add($t);
                  }
                  return Kt;
                }
                function Fn(ci, Fr, jt, Lt) {
                  var ea = Ti(ci, Fr, jt);
                  return Lt && ea.length !== 1 && !Fr.encounteredError && !(Fr.flags & 65536) && (Fr.encounteredError = true), Kt(ea, ea.length - 1);
                  function Kt($t, Ua) {
                    var Yr = Zi($t, Ua, Fr), Ni = $t[Ua];
                    Ua === 0 && (Fr.flags |= 16777216);
                    var Hi = of(Ni, Fr);
                    Ua === 0 && (Fr.flags ^= 16777216);
                    var _t = e2.setEmitFlags(e2.factory.createIdentifier(Hi, Yr), 16777216);
                    return _t.symbol = Ni, Ua > 0 ? e2.factory.createQualifiedName(Kt($t, Ua - 1), _t) : _t;
                  }
                }
                function wn(ci, Fr, jt) {
                  var Lt = Ti(ci, Fr, jt);
                  return ea(Lt, Lt.length - 1);
                  function ea(Kt, $t) {
                    var Ua = Zi(Kt, $t, Fr), Yr = Kt[$t];
                    $t === 0 && (Fr.flags |= 16777216);
                    var Ni = of(Yr, Fr);
                    $t === 0 && (Fr.flags ^= 16777216);
                    var Hi = Ni.charCodeAt(0);
                    if (e2.isSingleOrDoubleQuote(Hi) && e2.some(Yr.declarations, Fc))
                      return e2.factory.createStringLiteral(Nt(Yr, Fr));
                    var _t = Hi === 35 ? Ni.length > 1 && e2.isIdentifierStart(Ni.charCodeAt(1), Ae) : e2.isIdentifierStart(Hi, Ae);
                    if ($t === 0 || _t) {
                      var gt = e2.setEmitFlags(e2.factory.createIdentifier(Ni, Ua), 16777216);
                      return gt.symbol = Yr, $t > 0 ? e2.factory.createPropertyAccessExpression(ea(Kt, $t - 1), gt) : gt;
                    } else {
                      Hi === 91 && (Ni = Ni.substring(1, Ni.length - 1), Hi = Ni.charCodeAt(0));
                      var Vt = void 0;
                      return e2.isSingleOrDoubleQuote(Hi) && !(Yr.flags & 8) ? Vt = e2.factory.createStringLiteral(e2.stripQuotes(Ni).replace(/\\./g, function(Fa) {
                        return Fa.substring(1);
                      }), Hi === 39) : "" + +Ni === Ni && (Vt = e2.factory.createNumericLiteral(+Ni)), Vt || (Vt = e2.setEmitFlags(e2.factory.createIdentifier(Ni, Ua), 16777216), Vt.symbol = Yr), e2.factory.createElementAccessExpression(ea(Kt, $t - 1), Vt);
                    }
                  }
                }
                function Tn(ci) {
                  var Fr = e2.getNameOfDeclaration(ci);
                  return !!Fr && e2.isStringLiteral(Fr);
                }
                function Eo(ci) {
                  var Fr = e2.getNameOfDeclaration(ci);
                  return !!(Fr && e2.isStringLiteral(Fr) && (Fr.singleQuote || !e2.nodeIsSynthesized(Fr) && e2.startsWith(e2.getTextOfNode(Fr, false), "'")));
                }
                function lt(ci, Fr) {
                  var jt = !!e2.length(ci.declarations) && e2.every(ci.declarations, Eo), Lt = it(ci, Fr, jt);
                  if (Lt)
                    return Lt;
                  var ea = e2.unescapeLeadingUnderscores(ci.escapedName), Kt = !!e2.length(ci.declarations) && e2.every(ci.declarations, Tn);
                  return e2.createPropertyNameNodeForIdentifierOrLiteral(ea, e2.getEmitScriptTarget(ye), jt, Kt);
                }
                function it(ci, Fr, jt) {
                  var Lt = Aa(ci).nameType;
                  if (Lt) {
                    if (Lt.flags & 384) {
                      var ea = "" + Lt.value;
                      return !e2.isIdentifierText(ea, e2.getEmitScriptTarget(ye)) && !e2.isNumericLiteralName(ea) ? e2.factory.createStringLiteral(ea, !!jt) : e2.isNumericLiteralName(ea) && e2.startsWith(ea, "-") ? e2.factory.createComputedPropertyName(e2.factory.createNumericLiteral(+ea)) : e2.createPropertyNameNodeForIdentifierOrLiteral(ea, e2.getEmitScriptTarget(ye));
                    }
                    if (Lt.flags & 8192)
                      return e2.factory.createComputedPropertyName(wn(Lt.symbol, Fr, 111551));
                  }
                }
                function Yt(ci) {
                  var Fr = Ke({}, ci);
                  return Fr.typeParameterNames && (Fr.typeParameterNames = new e2.Map(Fr.typeParameterNames)), Fr.typeParameterNamesByText && (Fr.typeParameterNamesByText = new e2.Set(Fr.typeParameterNamesByText)), Fr.typeParameterSymbolList && (Fr.typeParameterSymbolList = new e2.Set(Fr.typeParameterSymbolList)), Fr.tracker = i2(Fr, Fr.tracker), Fr;
                }
                function Ia(ci, Fr) {
                  return ci.declarations && e2.find(ci.declarations, function(jt) {
                    return !!e2.getEffectiveTypeAnnotationNode(jt) && (!Fr || !!e2.findAncestor(jt, function(Lt) {
                      return Lt === Fr;
                    }));
                  });
                }
                function Qt(ci, Fr) {
                  return !(e2.getObjectFlags(Fr) & 4) || !e2.isTypeReferenceNode(ci) || e2.length(ci.typeArguments) >= Ul(Fr.target.typeParameters);
                }
                function Ka(ci, Fr, jt, Lt, ea, Kt) {
                  if (!nn(Fr) && Lt) {
                    var $t = Ia(jt, Lt);
                    if ($t && !e2.isFunctionLikeDeclaration($t) && !e2.isGetAccessorDeclaration($t)) {
                      var Ua = e2.getEffectiveTypeAnnotationNode($t);
                      if (cn(Ua, $t, Fr) && Qt(Ua, Fr)) {
                        var Yr = Mn(ci, Ua, ea, Kt);
                        if (Yr)
                          return Yr;
                      }
                    }
                  }
                  var Ni = ci.flags;
                  Fr.flags & 8192 && Fr.symbol === jt && (!ci.enclosingDeclaration || e2.some(jt.declarations, function(_t) {
                    return e2.getSourceFileOfNode(_t) === e2.getSourceFileOfNode(ci.enclosingDeclaration);
                  })) && (ci.flags |= 1048576);
                  var Hi = o(Fr, ci);
                  return ci.flags = Ni, Hi;
                }
                function cn(ci, Fr, jt) {
                  var Lt = Va(ci);
                  return Lt === jt ? true : e2.isParameter(Fr) && Fr.questionToken ? Ks(jt, 524288) === Lt : false;
                }
                function Un(ci, Fr, jt, Lt, ea) {
                  if (!nn(Fr) && ci.enclosingDeclaration) {
                    var Kt = jt.declaration && e2.getEffectiveReturnTypeNode(jt.declaration);
                    if (!!e2.findAncestor(Kt, function(Ni) {
                      return Ni === ci.enclosingDeclaration;
                    }) && Kt) {
                      var $t = Va(Kt), Ua = $t.flags & 262144 && $t.isThisType ? un($t, jt.mapper) : $t;
                      if (Ua === Fr && Qt(Kt, Fr)) {
                        var Yr = Mn(ci, Kt, Lt, ea);
                        if (Yr)
                          return Yr;
                      }
                    }
                  }
                  return o(Fr, ci);
                }
                function oa(ci, Fr, jt) {
                  var Lt, ea, Kt = false, $t = e2.getFirstIdentifier(ci);
                  if (e2.isInJSFile(ci) && (e2.isExportsIdentifier($t) || e2.isModuleExportsAccessExpression($t.parent) || e2.isQualifiedName($t.parent) && e2.isModuleIdentifier($t.parent.left) && e2.isExportsIdentifier($t.parent.right)))
                    return Kt = true, { introducesError: Kt, node: ci };
                  var Ua = Ds($t, 67108863, true, true);
                  if (Ua && (g_(Ua, Fr.enclosingDeclaration, 67108863, false).accessibility !== 0 ? Kt = true : ((ea = (Lt = Fr.tracker) === null || Lt === void 0 ? void 0 : Lt.trackSymbol) === null || ea === void 0 || ea.call(Lt, Ua, Fr.enclosingDeclaration, 67108863), jt == null || jt(Ua)), e2.isIdentifier(ci))) {
                    var Yr = go(Ua), Ni = Ua.flags & 262144 && !Gu(Yr.symbol, Fr.enclosingDeclaration) ? ja(Yr, Fr) : e2.factory.cloneNode(ci);
                    return Ni.symbol = Ua, { introducesError: Kt, node: e2.setEmitFlags(e2.setOriginalNode(Ni, ci), 16777216) };
                  }
                  return { introducesError: Kt, node: ci };
                }
                function Mn(ci, Fr, jt, Lt) {
                  g && g.throwIfCancellationRequested && g.throwIfCancellationRequested();
                  var ea = false, Kt = e2.getSourceFileOfNode(Fr), $t = e2.visitNode(Fr, Ua);
                  if (ea)
                    return;
                  return $t === Fr ? e2.setTextRange(e2.factory.cloneNode(Fr), Fr) : $t;
                  function Ua(Yr) {
                    if (e2.isJSDocAllType(Yr) || Yr.kind === 319)
                      return e2.factory.createKeywordTypeNode(130);
                    if (e2.isJSDocUnknownType(Yr))
                      return e2.factory.createKeywordTypeNode(155);
                    if (e2.isJSDocNullableType(Yr))
                      return e2.factory.createUnionTypeNode([e2.visitNode(Yr.type, Ua), e2.factory.createLiteralTypeNode(e2.factory.createNull())]);
                    if (e2.isJSDocOptionalType(Yr))
                      return e2.factory.createUnionTypeNode([e2.visitNode(Yr.type, Ua), e2.factory.createKeywordTypeNode(153)]);
                    if (e2.isJSDocNonNullableType(Yr))
                      return e2.visitNode(Yr.type, Ua);
                    if (e2.isJSDocVariadicType(Yr))
                      return e2.factory.createArrayTypeNode(e2.visitNode(Yr.type, Ua));
                    if (e2.isJSDocTypeLiteral(Yr))
                      return e2.factory.createTypeLiteralNode(e2.map(Yr.jsDocPropertyTags, function(Ga) {
                        var Qn = e2.isIdentifier(Ga.name) ? Ga.name : Ga.name.right, wo = da(Va(Yr), Qn.escapedText), Po = wo && Ga.typeExpression && Va(Ga.typeExpression.type) !== wo ? o(wo, ci) : void 0;
                        return e2.factory.createPropertySignature(void 0, Qn, Ga.isBracketed || Ga.typeExpression && e2.isJSDocOptionalType(Ga.typeExpression.type) ? e2.factory.createToken(57) : void 0, Po || Ga.typeExpression && e2.visitNode(Ga.typeExpression.type, Ua) || e2.factory.createKeywordTypeNode(130));
                      }));
                    if (e2.isTypeReferenceNode(Yr) && e2.isIdentifier(Yr.typeName) && Yr.typeName.escapedText === "")
                      return e2.setOriginalNode(e2.factory.createKeywordTypeNode(130), Yr);
                    if ((e2.isExpressionWithTypeArguments(Yr) || e2.isTypeReferenceNode(Yr)) && e2.isJSDocIndexSignature(Yr))
                      return e2.factory.createTypeLiteralNode([e2.factory.createIndexSignature(void 0, void 0, [e2.factory.createParameterDeclaration(void 0, void 0, void 0, "x", void 0, e2.visitNode(Yr.typeArguments[0], Ua))], e2.visitNode(Yr.typeArguments[1], Ua))]);
                    if (e2.isJSDocFunctionType(Yr))
                      if (e2.isJSDocConstructSignature(Yr)) {
                        var Ni;
                        return e2.factory.createConstructorTypeNode(Yr.modifiers, e2.visitNodes(Yr.typeParameters, Ua), e2.mapDefined(Yr.parameters, function(Ga, Qn) {
                          return Ga.name && e2.isIdentifier(Ga.name) && Ga.name.escapedText === "new" ? (Ni = Ga.type, void 0) : e2.factory.createParameterDeclaration(void 0, void 0, Fa(Ga), on(Ga, Qn), Ga.questionToken, e2.visitNode(Ga.type, Ua), void 0);
                        }), e2.visitNode(Ni || Yr.type, Ua) || e2.factory.createKeywordTypeNode(130));
                      } else
                        return e2.factory.createFunctionTypeNode(e2.visitNodes(Yr.typeParameters, Ua), e2.map(Yr.parameters, function(Ga, Qn) {
                          return e2.factory.createParameterDeclaration(void 0, void 0, Fa(Ga), on(Ga, Qn), Ga.questionToken, e2.visitNode(Ga.type, Ua), void 0);
                        }), e2.visitNode(Yr.type, Ua) || e2.factory.createKeywordTypeNode(130));
                    if (e2.isTypeReferenceNode(Yr) && e2.isInJSDoc(Yr) && (!Qt(Yr, Va(Yr)) || vx(Yr) || xe === nm(Yr, 788968, true)))
                      return e2.setOriginalNode(o(Va(Yr), ci), Yr);
                    if (e2.isLiteralImportTypeNode(Yr)) {
                      var Hi = va(Yr).resolvedSymbol;
                      return e2.isInJSDoc(Yr) && Hi && (!Yr.isTypeOf && !(Hi.flags & 788968) || !(e2.length(Yr.typeArguments) >= Ul(Af(Hi)))) ? e2.setOriginalNode(o(Va(Yr), ci), Yr) : e2.factory.updateImportTypeNode(Yr, e2.factory.updateLiteralTypeNode(Yr.argument, zn(Yr, Yr.argument.literal)), Yr.qualifier, e2.visitNodes(Yr.typeArguments, Ua, e2.isTypeNode), Yr.isTypeOf);
                    }
                    if (e2.isEntityName(Yr) || e2.isEntityNameExpression(Yr)) {
                      var _t = oa(Yr, ci, jt), gt = _t.introducesError, Vt = _t.node;
                      if (ea = ea || gt, Vt !== Yr)
                        return Vt;
                    }
                    return Kt && e2.isTupleTypeNode(Yr) && e2.getLineAndCharacterOfPosition(Kt, Yr.pos).line === e2.getLineAndCharacterOfPosition(Kt, Yr.end).line && e2.setEmitFlags(Yr, 1), e2.visitEachChild(Yr, Ua, e2.nullTransformationContext);
                    function Fa(Ga) {
                      return Ga.dotDotDotToken || (Ga.type && e2.isJSDocVariadicType(Ga.type) ? e2.factory.createToken(25) : void 0);
                    }
                    function on(Ga, Qn) {
                      return Ga.name && e2.isIdentifier(Ga.name) && Ga.name.escapedText === "this" ? "this" : Fa(Ga) ? "args" : "arg".concat(Qn);
                    }
                    function zn(Ga, Qn) {
                      if (Lt) {
                        if (ci.tracker && ci.tracker.moduleResolverHost) {
                          var wo = US(Ga);
                          if (wo) {
                            var Po = e2.createGetCanonicalFileName(!!l.useCaseSensitiveFileNames), Uo = { getCanonicalFileName: Po, getCurrentDirectory: function() {
                              return ci.tracker.moduleResolverHost.getCurrentDirectory();
                            }, getCommonSourceDirectory: function() {
                              return ci.tracker.moduleResolverHost.getCommonSourceDirectory();
                            } }, Rs = e2.getResolvedExternalModuleName(Uo, wo);
                            return e2.factory.createStringLiteral(Rs);
                          }
                        }
                      } else if (ci.tracker && ci.tracker.trackExternalModuleSymbolOfImportTypeNode) {
                        var Fs = Pl(Qn, Qn, void 0);
                        Fs && ci.tracker.trackExternalModuleSymbolOfImportTypeNode(Fs);
                      }
                      return Qn;
                    }
                  }
                }
                function Ln(ci, Fr, jt) {
                  var Lt = Ca(e2.factory.createPropertyDeclaration, 169, true), ea = Ca(function(gi, zt, La, fa, ya) {
                    return e2.factory.createPropertySignature(zt, La, fa, ya);
                  }, 168, false), Kt = Fr.enclosingDeclaration, $t = [], Ua = new e2.Set(), Yr = [], Ni = Fr;
                  Fr = Ke(Ke({}, Ni), { usedSymbolNames: new e2.Set(Ni.usedSymbolNames), remappedSymbolNames: new e2.Map(), tracker: Ke(Ke({}, Ni.tracker), { trackSymbol: function(gi, zt, La) {
                    var fa = g_(gi, zt, La, false);
                    if (fa.accessibility === 0) {
                      var ya = Ci(gi, Fr, La);
                      gi.flags & 4 || rc(ya[0]);
                    } else if (Ni.tracker && Ni.tracker.trackSymbol)
                      return Ni.tracker.trackSymbol(gi, zt, La);
                    return false;
                  } }) }), Fr.tracker = i2(Fr, Fr.tracker), e2.forEachEntry(ci, function(gi, zt) {
                    var La = e2.unescapeLeadingUnderscores(zt);
                    ls(gi, La);
                  });
                  var Hi = !jt, _t = ci.get("export=");
                  return _t && ci.size > 1 && _t.flags & 2097152 && (ci = e2.createSymbolTable(), ci.set("export=", _t)), Uo(ci), Ga($t);
                  function gt(gi) {
                    return !!gi && gi.kind === 79;
                  }
                  function Vt(gi) {
                    return e2.isVariableStatement(gi) ? e2.filter(e2.map(gi.declarationList.declarations, e2.getNameOfDeclaration), gt) : e2.filter([e2.getNameOfDeclaration(gi)], gt);
                  }
                  function Fa(gi) {
                    var zt = e2.find(gi, e2.isExportAssignment), La = e2.findIndex(gi, e2.isModuleDeclaration), fa = La !== -1 ? gi[La] : void 0;
                    if (fa && zt && zt.isExportEquals && e2.isIdentifier(zt.expression) && e2.isIdentifier(fa.name) && e2.idText(fa.name) === e2.idText(zt.expression) && fa.body && e2.isModuleBlock(fa.body)) {
                      var ya = e2.filter(gi, function(sn) {
                        return !!(e2.getEffectiveModifierFlags(sn) & 1);
                      }), Nn = fa.name, fn = fa.body;
                      if (e2.length(ya) && (fa = e2.factory.updateModuleDeclaration(fa, fa.decorators, fa.modifiers, fa.name, fn = e2.factory.updateModuleBlock(fn, e2.factory.createNodeArray(Ve(Ve([], fa.body.statements, true), [e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports(e2.map(e2.flatMap(ya, function(sn) {
                        return Vt(sn);
                      }), function(sn) {
                        return e2.factory.createExportSpecifier(false, void 0, sn);
                      })), void 0)], false)))), gi = Ve(Ve(Ve([], gi.slice(0, La), true), [fa], false), gi.slice(La + 1), true)), !e2.find(gi, function(sn) {
                        return sn !== fa && e2.nodeHasName(sn, Nn);
                      })) {
                        $t = [];
                        var hn = !e2.some(fn.statements, function(sn) {
                          return e2.hasSyntacticModifier(sn, 1) || e2.isExportAssignment(sn) || e2.isExportDeclaration(sn);
                        });
                        e2.forEach(fn.statements, function(sn) {
                          Ts(sn, hn ? 1 : 0);
                        }), gi = Ve(Ve([], e2.filter(gi, function(sn) {
                          return sn !== fa && sn !== zt;
                        }), true), $t, true);
                      }
                    }
                    return gi;
                  }
                  function on(gi) {
                    var zt = e2.filter(gi, function(ln) {
                      return e2.isExportDeclaration(ln) && !ln.moduleSpecifier && !!ln.exportClause && e2.isNamedExports(ln.exportClause);
                    });
                    if (e2.length(zt) > 1) {
                      var La = e2.filter(gi, function(ln) {
                        return !e2.isExportDeclaration(ln) || !!ln.moduleSpecifier || !ln.exportClause;
                      });
                      gi = Ve(Ve([], La, true), [e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports(e2.flatMap(zt, function(ln) {
                        return e2.cast(ln.exportClause, e2.isNamedExports).elements;
                      })), void 0)], false);
                    }
                    var fa = e2.filter(gi, function(ln) {
                      return e2.isExportDeclaration(ln) && !!ln.moduleSpecifier && !!ln.exportClause && e2.isNamedExports(ln.exportClause);
                    });
                    if (e2.length(fa) > 1) {
                      var ya = e2.group(fa, function(ln) {
                        return e2.isStringLiteral(ln.moduleSpecifier) ? ">" + ln.moduleSpecifier.text : ">";
                      });
                      if (ya.length !== fa.length)
                        for (var Nn = function(ln) {
                          ln.length > 1 && (gi = Ve(Ve([], e2.filter(gi, function(lo) {
                            return ln.indexOf(lo) === -1;
                          }), true), [e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports(e2.flatMap(ln, function(lo) {
                            return e2.cast(lo.exportClause, e2.isNamedExports).elements;
                          })), ln[0].moduleSpecifier)], false));
                        }, fn = 0, hn = ya; fn < hn.length; fn++) {
                          var sn = hn[fn];
                          Nn(sn);
                        }
                    }
                    return gi;
                  }
                  function zn(gi) {
                    var zt = e2.findIndex(gi, function(ya) {
                      return e2.isExportDeclaration(ya) && !ya.moduleSpecifier && !ya.assertClause && !!ya.exportClause && e2.isNamedExports(ya.exportClause);
                    });
                    if (zt >= 0) {
                      var La = gi[zt], fa = e2.mapDefined(La.exportClause.elements, function(ya) {
                        if (!ya.propertyName) {
                          var Nn = e2.indicesOf(gi), fn = e2.filter(Nn, function(lo) {
                            return e2.nodeHasName(gi[lo], ya.name);
                          });
                          if (e2.length(fn) && e2.every(fn, function(lo) {
                            return Qn(gi[lo]);
                          })) {
                            for (var hn = 0, sn = fn; hn < sn.length; hn++) {
                              var ln = sn[hn];
                              gi[ln] = wo(gi[ln]);
                            }
                            return;
                          }
                        }
                        return ya;
                      });
                      e2.length(fa) ? gi[zt] = e2.factory.updateExportDeclaration(La, La.decorators, La.modifiers, La.isTypeOnly, e2.factory.updateNamedExports(La.exportClause, fa), La.moduleSpecifier, La.assertClause) : e2.orderedRemoveItemAt(gi, zt);
                    }
                    return gi;
                  }
                  function Ga(gi) {
                    return gi = Fa(gi), gi = on(gi), gi = zn(gi), Kt && (e2.isSourceFile(Kt) && e2.isExternalOrCommonJsModule(Kt) || e2.isModuleDeclaration(Kt)) && (!e2.some(gi, e2.isExternalModuleIndicator) || !e2.hasScopeMarker(gi) && e2.some(gi, e2.needsScopeMarker)) && gi.push(e2.createEmptyExports(e2.factory)), gi;
                  }
                  function Qn(gi) {
                    return e2.isEnumDeclaration(gi) || e2.isVariableStatement(gi) || e2.isFunctionDeclaration(gi) || e2.isClassDeclaration(gi) || e2.isModuleDeclaration(gi) && !e2.isExternalModuleAugmentation(gi) && !e2.isGlobalScopeAugmentation(gi) || e2.isInterfaceDeclaration(gi) || zy(gi);
                  }
                  function wo(gi) {
                    var zt = (e2.getEffectiveModifierFlags(gi) | 1) & -3;
                    return e2.factory.updateModifiers(gi, zt);
                  }
                  function Po(gi) {
                    var zt = e2.getEffectiveModifierFlags(gi) & -2;
                    return e2.factory.updateModifiers(gi, zt);
                  }
                  function Uo(gi, zt, La) {
                    zt || Yr.push(new e2.Map()), gi.forEach(function(fa) {
                      Rs(fa, false, !!La);
                    }), zt || (Yr[Yr.length - 1].forEach(function(fa) {
                      Rs(fa, true, !!La);
                    }), Yr.pop());
                  }
                  function Rs(gi, zt, La) {
                    var fa = so(gi);
                    if (!Ua.has(y(fa))) {
                      Ua.add(y(fa));
                      var ya = !zt;
                      if (ya || !!e2.length(gi.declarations) && e2.some(gi.declarations, function(hn) {
                        return !!e2.findAncestor(hn, function(sn) {
                          return sn === Kt;
                        });
                      })) {
                        var Nn = Fr;
                        Fr = Yt(Fr);
                        var fn = Fs(gi, zt, La);
                        return Fr.reportedDiagnostic && (Ni.reportedDiagnostic = Fr.reportedDiagnostic), Fr = Nn, fn;
                      }
                    }
                  }
                  function Fs(gi, zt, La) {
                    var fa, ya, Nn, fn, hn = e2.unescapeLeadingUnderscores(gi.escapedName), sn = gi.escapedName === "default";
                    if (zt && !(Fr.flags & 131072) && e2.isStringANonContextualKeyword(hn) && !sn) {
                      Fr.encounteredError = true;
                      return;
                    }
                    var ln = sn && !!(gi.flags & -113 || gi.flags & 16 && e2.length(uo(Jt(gi)))) && !(gi.flags & 2097152), lo = !ln && !zt && e2.isStringANonContextualKeyword(hn) && !sn;
                    (ln || lo) && (zt = true);
                    var _o = (zt ? 0 : 1) | (sn && !ln ? 512 : 0), _s = gi.flags & 1536 && gi.flags & 7 && gi.escapedName !== "export=", Vo = _s && ma(Jt(gi), gi);
                    if ((gi.flags & 8208 || Vo) && id(Jt(gi), gi, ls(gi, hn), _o), gi.flags & 524288 && rl(gi, hn, _o), gi.flags & 7 && gi.escapedName !== "export=" && !(gi.flags & 4194304) && !(gi.flags & 32) && !Vo)
                      if (La) {
                        var Yo = ht(gi);
                        Yo && (lo = false, ln = false);
                      } else {
                        var Cs = Jt(gi), ic = ls(gi, hn);
                        if (!(gi.flags & 16) && ma(Cs, gi))
                          id(Cs, gi, ic, _o);
                        else {
                          var _c = gi.flags & 2 ? pv(gi) ? 2 : 1 : ((fa = gi.parent) === null || fa === void 0 ? void 0 : fa.valueDeclaration) && e2.isSourceFile((ya = gi.parent) === null || ya === void 0 ? void 0 : ya.valueDeclaration) ? 2 : void 0, il = ln || !(gi.flags & 4) ? ic : Io(ic, gi), n_ = gi.declarations && e2.find(gi.declarations, function(pp) {
                            return e2.isVariableDeclaration(pp);
                          });
                          n_ && e2.isVariableDeclarationList(n_.parent) && n_.parent.declarations.length === 1 && (n_ = n_.parent.parent);
                          var o_ = (Nn = gi.declarations) === null || Nn === void 0 ? void 0 : Nn.find(e2.isPropertyAccessExpression);
                          if (o_ && e2.isBinaryExpression(o_.parent) && e2.isIdentifier(o_.parent.right) && ((fn = Cs.symbol) === null || fn === void 0 ? void 0 : fn.valueDeclaration) && e2.isSourceFile(Cs.symbol.valueDeclaration)) {
                            var og = ic === o_.parent.right.escapedText ? void 0 : o_.parent.right;
                            Ts(e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports([e2.factory.createExportSpecifier(false, og, ic)])), 0), Fr.tracker.trackSymbol(Cs.symbol, Fr.enclosingDeclaration, 111551);
                          } else {
                            var _p = e2.setTextRange(e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(il, void 0, Ka(Fr, Cs, gi, Kt, rc, jt))], _c)), n_);
                            Ts(_p, il !== ic ? _o & -2 : _o), il !== ic && !zt && (Ts(e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports([e2.factory.createExportSpecifier(false, il, ic)])), 0), lo = false, ln = false);
                          }
                        }
                      }
                    if (gi.flags & 384 && zg(gi, hn, _o), gi.flags & 32 && (gi.flags & 4 && gi.valueDeclaration && e2.isBinaryExpression(gi.valueDeclaration.parent) && e2.isClassExpression(gi.valueDeclaration.parent.right) ? Ht(gi, ls(gi, hn), _o) : mt(gi, ls(gi, hn), _o)), (gi.flags & 1536 && (!_s || Tl(gi)) || Vo) && fp(gi, hn, _o), gi.flags & 64 && !(gi.flags & 32) && jd(gi, hn, _o), gi.flags & 2097152 && Ht(gi, ls(gi, hn), _o), gi.flags & 4 && gi.escapedName === "export=" && ht(gi), gi.flags & 8388608 && gi.declarations)
                      for (var td = 0, s_ = gi.declarations; td < s_.length; td++) {
                        var sg = s_[td], Nc = ac(sg, sg.moduleSpecifier);
                        !Nc || Ts(e2.factory.createExportDeclaration(void 0, void 0, false, void 0, e2.factory.createStringLiteral(Nt(Nc, Fr))), 0);
                      }
                    ln ? Ts(e2.factory.createExportAssignment(void 0, void 0, false, e2.factory.createIdentifier(ls(gi, hn))), 0) : lo && Ts(e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports([e2.factory.createExportSpecifier(false, ls(gi, hn), hn)])), 0);
                  }
                  function rc(gi) {
                    if (!e2.some(gi.declarations, e2.isParameterDeclaration)) {
                      e2.Debug.assertIsDefined(Yr[Yr.length - 1]), Io(e2.unescapeLeadingUnderscores(gi.escapedName), gi);
                      var zt = !!(gi.flags & 2097152) && !e2.some(gi.declarations, function(La) {
                        return !!e2.findAncestor(La, e2.isExportDeclaration) || e2.isNamespaceExport(La) || e2.isImportEqualsDeclaration(La) && !e2.isExternalModuleReference(La.moduleReference);
                      });
                      Yr[zt ? 0 : Yr.length - 1].set(y(gi), gi);
                    }
                  }
                  function xu(gi) {
                    return e2.isSourceFile(gi) && (e2.isExternalOrCommonJsModule(gi) || e2.isJsonSourceFile(gi)) || e2.isAmbientModule(gi) && !e2.isGlobalScopeAugmentation(gi);
                  }
                  function Ts(gi, zt) {
                    if (e2.canHaveModifiers(gi)) {
                      var La = 0, fa = Fr.enclosingDeclaration && (e2.isJSDocTypeAlias(Fr.enclosingDeclaration) ? e2.getSourceFileOfNode(Fr.enclosingDeclaration) : Fr.enclosingDeclaration);
                      zt & 1 && fa && (xu(fa) || e2.isModuleDeclaration(fa)) && Qn(gi) && (La |= 1), Hi && !(La & 1) && (!fa || !(fa.flags & 16777216)) && (e2.isEnumDeclaration(gi) || e2.isVariableStatement(gi) || e2.isFunctionDeclaration(gi) || e2.isClassDeclaration(gi) || e2.isModuleDeclaration(gi)) && (La |= 2), zt & 512 && (e2.isClassDeclaration(gi) || e2.isInterfaceDeclaration(gi) || e2.isFunctionDeclaration(gi)) && (La |= 512), La && (gi = e2.factory.updateModifiers(gi, La | e2.getEffectiveModifierFlags(gi)));
                    }
                    $t.push(gi);
                  }
                  function rl(gi, zt, La) {
                    var fa, ya = Ja(gi), Nn = Aa(gi).typeParameters, fn = e2.map(Nn, function(_s) {
                      return Dr(_s, Fr);
                    }), hn = (fa = gi.declarations) === null || fa === void 0 ? void 0 : fa.find(e2.isJSDocTypeAlias), sn = e2.getTextOfJSDocComment(hn ? hn.comment || hn.parent.comment : void 0), ln = Fr.flags;
                    Fr.flags |= 8388608;
                    var lo = Fr.enclosingDeclaration;
                    Fr.enclosingDeclaration = hn;
                    var _o = hn && hn.typeExpression && e2.isJSDocTypeExpression(hn.typeExpression) && Mn(Fr, hn.typeExpression.type, rc, jt) || o(ya, Fr);
                    Ts(e2.setSyntheticLeadingComments(e2.factory.createTypeAliasDeclaration(void 0, void 0, ls(gi, zt), fn, _o), sn ? [{ kind: 3, text: `*
 * ` + sn.replace(/\n/g, `
 * `) + `
 `, pos: -1, end: -1, hasTrailingNewLine: true }] : []), La), Fr.flags = ln, Fr.enclosingDeclaration = lo;
                  }
                  function jd(gi, zt, La) {
                    var fa = aa(gi), ya = Af(gi), Nn = e2.map(ya, function(Vo) {
                      return Dr(Vo, Fr);
                    }), fn = Qc(fa), hn = e2.length(fn) ? Do(fn) : void 0, sn = e2.flatMap(uo(fa), function(Vo) {
                      return An(Vo, hn);
                    }), ln = gn(0, fa, hn, 174), lo = gn(1, fa, hn, 175), _o = Vn(fa, hn), _s = e2.length(fn) ? [e2.factory.createHeritageClause(94, e2.mapDefined(fn, function(Vo) {
                      return us(Vo, 111551);
                    }))] : void 0;
                    Ts(e2.factory.createInterfaceDeclaration(void 0, void 0, ls(gi, zt), Nn, _s, Ve(Ve(Ve(Ve([], _o, true), lo, true), ln, true), sn, true)), La);
                  }
                  function lp(gi) {
                    return gi.exports ? e2.filter(e2.arrayFrom(gi.exports.values()), hi) : [];
                  }
                  function Tl(gi) {
                    return e2.every(lp(gi), function(zt) {
                      return !(os(zt).flags & 111551);
                    });
                  }
                  function fp(gi, zt, La) {
                    var fa = lp(gi), ya = e2.arrayToMultiMap(fa, function(lo) {
                      return lo.parent && lo.parent === gi ? "real" : "merged";
                    }), Nn = ya.get("real") || e2.emptyArray, fn = ya.get("merged") || e2.emptyArray;
                    if (e2.length(Nn)) {
                      var hn = ls(gi, zt);
                      $r(Nn, hn, La, !!(gi.flags & 67108880));
                    }
                    if (e2.length(fn)) {
                      var sn = e2.getSourceFileOfNode(Fr.enclosingDeclaration), hn = ls(gi, zt), ln = e2.factory.createModuleBlock([e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports(e2.mapDefined(e2.filter(fn, function(_o) {
                        return _o.escapedName !== "export=";
                      }), function(_o) {
                        var _s, Vo, Yo = e2.unescapeLeadingUnderscores(_o.escapedName), Cs = ls(_o, Yo), ic = _o.declarations && ru(_o);
                        if (sn && (ic ? sn !== e2.getSourceFileOfNode(ic) : !e2.some(_o.declarations, function(n_) {
                          return e2.getSourceFileOfNode(n_) === sn;
                        }))) {
                          (Vo = (_s = Fr.tracker) === null || _s === void 0 ? void 0 : _s.reportNonlocalAugmentation) === null || Vo === void 0 || Vo.call(_s, sn, gi, _o);
                          return;
                        }
                        var _c = ic && Ec(ic, true);
                        rc(_c || _o);
                        var il = _c ? ls(_c, e2.unescapeLeadingUnderscores(_c.escapedName)) : Cs;
                        return e2.factory.createExportSpecifier(false, Yo === il ? void 0 : il, Yo);
                      })))]);
                      Ts(e2.factory.createModuleDeclaration(void 0, void 0, e2.factory.createIdentifier(hn), ln, 16), 0);
                    }
                  }
                  function zg(gi, zt, La) {
                    Ts(e2.factory.createEnumDeclaration(void 0, e2.factory.createModifiersFromModifierFlags(lS(gi) ? 2048 : 0), ls(gi, zt), e2.map(e2.filter(uo(Jt(gi)), function(fa) {
                      return !!(fa.flags & 8);
                    }), function(fa) {
                      var ya = fa.declarations && fa.declarations[0] && e2.isEnumMember(fa.declarations[0]) ? BS(fa.declarations[0]) : void 0;
                      return e2.factory.createEnumMember(e2.unescapeLeadingUnderscores(fa.escapedName), ya === void 0 ? void 0 : typeof ya == "string" ? e2.factory.createStringLiteral(ya) : e2.factory.createNumericLiteral(ya));
                    })), La);
                  }
                  function id(gi, zt, La, fa) {
                    for (var ya = ot(gi, 0), Nn = 0, fn = ya; Nn < fn.length; Nn++) {
                      var hn = fn[Nn], sn = $e(hn, 256, Fr, { name: e2.factory.createIdentifier(La), privateSymbolVisitor: rc, bundledImports: jt });
                      Ts(e2.setTextRange(sn, za(hn)), fa);
                    }
                    if (!(zt.flags & 1536 && !!zt.exports && !!zt.exports.size)) {
                      var ln = e2.filter(uo(gi), hi);
                      $r(ln, La, fa, true);
                    }
                  }
                  function za(gi) {
                    if (gi.declaration && gi.declaration.parent) {
                      if (e2.isBinaryExpression(gi.declaration.parent) && e2.getAssignmentDeclarationKind(gi.declaration.parent) === 5)
                        return gi.declaration.parent;
                      if (e2.isVariableDeclaration(gi.declaration.parent) && gi.declaration.parent.parent)
                        return gi.declaration.parent.parent;
                    }
                    return gi.declaration;
                  }
                  function $r(gi, zt, La, fa) {
                    if (e2.length(gi)) {
                      var ya = e2.arrayToMultiMap(gi, function(Yo) {
                        return !e2.length(Yo.declarations) || e2.some(Yo.declarations, function(Cs) {
                          return e2.getSourceFileOfNode(Cs) === e2.getSourceFileOfNode(Fr.enclosingDeclaration);
                        }) ? "local" : "remote";
                      }), Nn = ya.get("local") || e2.emptyArray, fn = e2.parseNodeFactory.createModuleDeclaration(void 0, void 0, e2.factory.createIdentifier(zt), e2.factory.createModuleBlock([]), 16);
                      e2.setParent(fn, Kt), fn.locals = e2.createSymbolTable(gi), fn.symbol = gi[0].parent;
                      var hn = $t;
                      $t = [];
                      var sn = Hi;
                      Hi = false;
                      var ln = Ke(Ke({}, Fr), { enclosingDeclaration: fn }), lo = Fr;
                      Fr = ln, Uo(e2.createSymbolTable(Nn), fa, true), Fr = lo, Hi = sn;
                      var _o = $t;
                      $t = hn;
                      var _s = e2.map(_o, function(Yo) {
                        return e2.isExportAssignment(Yo) && !Yo.isExportEquals && e2.isIdentifier(Yo.expression) ? e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports([e2.factory.createExportSpecifier(false, Yo.expression, e2.factory.createIdentifier("default"))])) : Yo;
                      }), Vo = e2.every(_s, function(Yo) {
                        return e2.hasSyntacticModifier(Yo, 1);
                      }) ? e2.map(_s, Po) : _s;
                      fn = e2.factory.updateModuleDeclaration(fn, fn.decorators, fn.modifiers, fn.name, e2.factory.createModuleBlock(Vo)), Ts(fn, La);
                    }
                  }
                  function hi(gi) {
                    return !!(gi.flags & 2887656) || !(gi.flags & 4194304 || gi.escapedName === "prototype" || gi.valueDeclaration && e2.isStatic(gi.valueDeclaration) && e2.isClassLike(gi.valueDeclaration.parent));
                  }
                  function Ri(gi) {
                    var zt = e2.mapDefined(gi, function(La) {
                      var fa, ya = Fr.enclosingDeclaration;
                      Fr.enclosingDeclaration = La;
                      var Nn = La.expression;
                      if (e2.isEntityNameExpression(Nn)) {
                        if (e2.isIdentifier(Nn) && e2.idText(Nn) === "")
                          return hn(void 0);
                        var fn = void 0;
                        if (fa = oa(Nn, Fr, rc), fn = fa.introducesError, Nn = fa.node, fn)
                          return hn(void 0);
                      }
                      return hn(e2.factory.createExpressionWithTypeArguments(Nn, e2.map(La.typeArguments, function(sn) {
                        return Mn(Fr, sn, rc, jt) || o(Va(sn), Fr);
                      })));
                      function hn(sn) {
                        return Fr.enclosingDeclaration = ya, sn;
                      }
                    });
                    if (zt.length === gi.length)
                      return zt;
                  }
                  function mt(gi, zt, La) {
                    var fa, ya, Nn = (fa = gi.declarations) === null || fa === void 0 ? void 0 : fa.find(e2.isClassLike), fn = Fr.enclosingDeclaration;
                    Fr.enclosingDeclaration = Nn || fn;
                    var hn = Af(gi), sn = e2.map(hn, function(Nc) {
                      return Dr(Nc, Fr);
                    }), ln = aa(gi), lo = Qc(ln), _o = Nn && e2.getEffectiveImplementsTypeNodes(Nn), _s = _o && Ri(_o) || e2.mapDefined(Qg(ln), Bo), Vo = Jt(gi), Yo = !!(!((ya = Vo.symbol) === null || ya === void 0) && ya.valueDeclaration) && e2.isClassLike(Vo.symbol.valueDeclaration), Cs = Yo ? Bl(Vo) : Oe, ic = Ve(Ve([], e2.length(lo) ? [e2.factory.createHeritageClause(94, e2.map(lo, function(Nc) {
                      return zo(Nc, Cs, zt);
                    }))] : [], true), e2.length(_s) ? [e2.factory.createHeritageClause(117, _s)] : [], true), _c = vM(ln, lo, uo(ln)), il = e2.filter(_c, function(Nc) {
                      var pp = Nc.valueDeclaration;
                      return !!pp && !(e2.isNamedDeclaration(pp) && e2.isPrivateIdentifier(pp.name));
                    }), n_ = e2.some(_c, function(Nc) {
                      var pp = Nc.valueDeclaration;
                      return !!pp && e2.isNamedDeclaration(pp) && e2.isPrivateIdentifier(pp.name);
                    }), o_ = n_ ? [e2.factory.createPropertyDeclaration(void 0, void 0, e2.factory.createPrivateIdentifier("#private"), void 0, void 0, void 0)] : e2.emptyArray, og = e2.flatMap(il, function(Nc) {
                      return Lt(Nc, false, lo[0]);
                    }), _p = e2.flatMap(e2.filter(uo(Vo), function(Nc) {
                      return !(Nc.flags & 4194304) && Nc.escapedName !== "prototype" && !hi(Nc);
                    }), function(Nc) {
                      return Lt(Nc, true, Cs);
                    }), td = !Yo && !!gi.valueDeclaration && e2.isInJSFile(gi.valueDeclaration) && !e2.some(ot(Vo, 1)), s_ = td ? [e2.factory.createConstructorDeclaration(void 0, e2.factory.createModifiersFromModifierFlags(8), [], void 0)] : gn(1, Vo, Cs, 171), sg = Vn(ln, lo[0]);
                    Fr.enclosingDeclaration = fn, Ts(e2.setTextRange(e2.factory.createClassDeclaration(void 0, void 0, zt, sn, ic, Ve(Ve(Ve(Ve(Ve([], sg, true), _p, true), s_, true), og, true), o_, true)), gi.declarations && e2.filter(gi.declarations, function(Nc) {
                      return e2.isClassDeclaration(Nc) || e2.isClassExpression(Nc);
                    })[0]), La);
                  }
                  function ft(gi) {
                    return e2.firstDefined(gi, function(zt) {
                      if (e2.isImportSpecifier(zt) || e2.isExportSpecifier(zt))
                        return e2.idText(zt.propertyName || zt.name);
                      if (e2.isBinaryExpression(zt) || e2.isExportAssignment(zt)) {
                        var La = e2.isExportAssignment(zt) ? zt.expression : zt.right;
                        if (e2.isPropertyAccessExpression(La))
                          return e2.idText(La.name);
                      }
                      if (yf(zt)) {
                        var fa = e2.getNameOfDeclaration(zt);
                        if (fa && e2.isIdentifier(fa))
                          return e2.idText(fa);
                      }
                    });
                  }
                  function Ht(gi, zt, La) {
                    var fa, ya, Nn, fn, hn, sn = ru(gi);
                    if (!sn)
                      return e2.Debug.fail();
                    var ln = so(Ec(sn, true));
                    if (!!ln) {
                      var lo = e2.isShorthandAmbientModuleSymbol(ln) && ft(gi.declarations) || e2.unescapeLeadingUnderscores(ln.escapedName);
                      lo === "export=" && (e2.getESModuleInterop(ye) || ye.allowSyntheticDefaultImports) && (lo = "default");
                      var _o = ls(ln, lo);
                      switch (rc(ln), sn.kind) {
                        case 203:
                          if (((ya = (fa = sn.parent) === null || fa === void 0 ? void 0 : fa.parent) === null || ya === void 0 ? void 0 : ya.kind) === 254) {
                            var _s = Nt(ln.parent || ln, Fr), Vo = sn.propertyName;
                            Ts(e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(false, void 0, e2.factory.createNamedImports([e2.factory.createImportSpecifier(false, Vo && e2.isIdentifier(Vo) ? e2.factory.createIdentifier(e2.idText(Vo)) : void 0, e2.factory.createIdentifier(zt))])), e2.factory.createStringLiteral(_s), void 0), 0);
                            break;
                          }
                          e2.Debug.failBadSyntaxKind(((Nn = sn.parent) === null || Nn === void 0 ? void 0 : Nn.parent) || sn, "Unhandled binding element grandparent kind in declaration serialization");
                          break;
                        case 297:
                          ((hn = (fn = sn.parent) === null || fn === void 0 ? void 0 : fn.parent) === null || hn === void 0 ? void 0 : hn.kind) === 221 && vt(e2.unescapeLeadingUnderscores(gi.escapedName), _o);
                          break;
                        case 254:
                          if (e2.isPropertyAccessExpression(sn.initializer)) {
                            var Yo = sn.initializer, Cs = e2.factory.createUniqueName(zt), ic = Nt(ln.parent || ln, Fr);
                            Ts(e2.factory.createImportEqualsDeclaration(void 0, void 0, false, Cs, e2.factory.createExternalModuleReference(e2.factory.createStringLiteral(ic))), 0), Ts(e2.factory.createImportEqualsDeclaration(void 0, void 0, false, e2.factory.createIdentifier(zt), e2.factory.createQualifiedName(Cs, Yo.name)), La);
                            break;
                          }
                        case 265:
                          if (ln.escapedName === "export=" && e2.some(ln.declarations, e2.isJsonSourceFile)) {
                            ht(gi);
                            break;
                          }
                          var _c = !(ln.flags & 512) && !e2.isVariableDeclaration(sn);
                          Ts(e2.factory.createImportEqualsDeclaration(void 0, void 0, false, e2.factory.createIdentifier(zt), _c ? Fn(ln, Fr, 67108863, false) : e2.factory.createExternalModuleReference(e2.factory.createStringLiteral(Nt(ln, Fr)))), _c ? La : 0);
                          break;
                        case 264:
                          Ts(e2.factory.createNamespaceExportDeclaration(e2.idText(sn.name)), 0);
                          break;
                        case 267:
                          Ts(e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(false, e2.factory.createIdentifier(zt), void 0), e2.factory.createStringLiteral(Nt(ln.parent || ln, Fr)), void 0), 0);
                          break;
                        case 268:
                          Ts(e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(false, void 0, e2.factory.createNamespaceImport(e2.factory.createIdentifier(zt))), e2.factory.createStringLiteral(Nt(ln, Fr)), void 0), 0);
                          break;
                        case 274:
                          Ts(e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamespaceExport(e2.factory.createIdentifier(zt)), e2.factory.createStringLiteral(Nt(ln, Fr))), 0);
                          break;
                        case 270:
                          Ts(e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(false, void 0, e2.factory.createNamedImports([e2.factory.createImportSpecifier(false, zt !== lo ? e2.factory.createIdentifier(lo) : void 0, e2.factory.createIdentifier(zt))])), e2.factory.createStringLiteral(Nt(ln.parent || ln, Fr)), void 0), 0);
                          break;
                        case 275:
                          var il = sn.parent.parent.moduleSpecifier;
                          vt(e2.unescapeLeadingUnderscores(gi.escapedName), il ? lo : _o, il && e2.isStringLiteralLike(il) ? e2.factory.createStringLiteral(il.text) : void 0);
                          break;
                        case 271:
                          ht(gi);
                          break;
                        case 221:
                        case 206:
                        case 207:
                          gi.escapedName === "default" || gi.escapedName === "export=" ? ht(gi) : vt(zt, _o);
                          break;
                        default:
                          return e2.Debug.failBadSyntaxKind(sn, "Unhandled alias declaration kind in symbol serializer!");
                      }
                    }
                  }
                  function vt(gi, zt, La) {
                    Ts(e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports([e2.factory.createExportSpecifier(false, gi !== zt ? zt : void 0, gi)]), La), 0);
                  }
                  function ht(gi) {
                    if (gi.flags & 4194304)
                      return false;
                    var zt = e2.unescapeLeadingUnderscores(gi.escapedName), La = zt === "export=", fa = zt === "default", ya = La || fa, Nn = gi.declarations && ru(gi), fn = Nn && Ec(Nn, true);
                    if (fn && e2.length(fn.declarations) && e2.some(fn.declarations, function(Yo) {
                      return e2.getSourceFileOfNode(Yo) === e2.getSourceFileOfNode(Kt);
                    })) {
                      var hn = Nn && (e2.isExportAssignment(Nn) || e2.isBinaryExpression(Nn) ? e2.getExportAssignmentExpression(Nn) : e2.getPropertyAssignmentAliasLikeExpression(Nn)), sn = hn && e2.isEntityNameExpression(hn) ? IM(hn) : void 0, ln = sn && Ds(sn, 67108863, true, true, Kt);
                      (ln || fn) && rc(ln || fn);
                      var lo = Fr.tracker.trackSymbol;
                      if (Fr.tracker.trackSymbol = function() {
                        return false;
                      }, ya)
                        $t.push(e2.factory.createExportAssignment(void 0, void 0, La, wn(fn, Fr, 67108863)));
                      else if (sn === hn && sn)
                        vt(zt, e2.idText(sn));
                      else if (hn && e2.isClassExpression(hn))
                        vt(zt, ls(fn, e2.symbolName(fn)));
                      else {
                        var _o = Io(zt, gi);
                        Ts(e2.factory.createImportEqualsDeclaration(void 0, void 0, false, e2.factory.createIdentifier(_o), Fn(fn, Fr, 67108863, false)), 0), vt(zt, _o);
                      }
                      return Fr.tracker.trackSymbol = lo, true;
                    } else {
                      var _o = Io(zt, gi), _s = $c(Jt(so(gi)));
                      if (ma(_s, gi))
                        id(_s, gi, _o, ya ? 0 : 1);
                      else {
                        var Vo = e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(_o, void 0, Ka(Fr, _s, gi, Kt, rc, jt))], 2));
                        Ts(Vo, fn && fn.flags & 4 && fn.escapedName === "export=" ? 2 : zt === _o ? 1 : 0);
                      }
                      return ya ? ($t.push(e2.factory.createExportAssignment(void 0, void 0, La, e2.factory.createIdentifier(_o))), true) : zt !== _o ? (vt(zt, _o), true) : false;
                    }
                  }
                  function ma(gi, zt) {
                    var La = e2.getSourceFileOfNode(Fr.enclosingDeclaration);
                    return e2.getObjectFlags(gi) & 48 && !e2.length(Hn(gi)) && !yd(gi) && !!(e2.length(e2.filter(uo(gi), hi)) || e2.length(ot(gi, 0))) && !e2.length(ot(gi, 1)) && !Ia(zt, Kt) && !(gi.symbol && e2.some(gi.symbol.declarations, function(fa) {
                      return e2.getSourceFileOfNode(fa) !== La;
                    })) && !e2.some(uo(gi), function(fa) {
                      return pg(fa.escapedName);
                    }) && !e2.some(uo(gi), function(fa) {
                      return e2.some(fa.declarations, function(ya) {
                        return e2.getSourceFileOfNode(ya) !== La;
                      });
                    }) && e2.every(uo(gi), function(fa) {
                      return e2.isIdentifierText(e2.symbolName(fa), Ae);
                    });
                  }
                  function Ca(gi, zt, La) {
                    return function(ya, Nn, fn) {
                      var hn, sn, ln, lo, _o, _s = e2.getDeclarationModifierFlagsFromSymbol(ya), Vo = !!(_s & 8);
                      if (Nn && ya.flags & 2887656)
                        return [];
                      if (ya.flags & 4194304 || fn && bi(fn, ya.escapedName) && Zu(bi(fn, ya.escapedName)) === Zu(ya) && (ya.flags & 16777216) === (bi(fn, ya.escapedName).flags & 16777216) && wf(Jt(ya), da(fn, ya.escapedName)))
                        return [];
                      var Yo = _s & -257 | (Nn ? 32 : 0), Cs = lt(ya, Fr), ic = (hn = ya.declarations) === null || hn === void 0 ? void 0 : hn.find(e2.or(e2.isPropertyDeclaration, e2.isAccessor, e2.isVariableDeclaration, e2.isPropertySignature, e2.isBinaryExpression, e2.isPropertyAccessExpression));
                      if (ya.flags & 98304 && La) {
                        var _c = [];
                        if (ya.flags & 65536 && _c.push(e2.setTextRange(e2.factory.createSetAccessorDeclaration(void 0, e2.factory.createModifiersFromModifierFlags(Yo), Cs, [e2.factory.createParameterDeclaration(void 0, void 0, void 0, "arg", void 0, Vo ? void 0 : Ka(Fr, Jt(ya), ya, Kt, rc, jt))], void 0), ((sn = ya.declarations) === null || sn === void 0 ? void 0 : sn.find(e2.isSetAccessor)) || ic)), ya.flags & 32768) {
                          var il = _s & 8;
                          _c.push(e2.setTextRange(e2.factory.createGetAccessorDeclaration(void 0, e2.factory.createModifiersFromModifierFlags(Yo), Cs, [], il ? void 0 : Ka(Fr, Jt(ya), ya, Kt, rc, jt), void 0), ((ln = ya.declarations) === null || ln === void 0 ? void 0 : ln.find(e2.isGetAccessor)) || ic));
                        }
                        return _c;
                      } else if (ya.flags & 98311)
                        return e2.setTextRange(gi(void 0, e2.factory.createModifiersFromModifierFlags((Zu(ya) ? 64 : 0) | Yo), Cs, ya.flags & 16777216 ? e2.factory.createToken(57) : void 0, Vo ? void 0 : Ka(Fr, Jt(ya), ya, Kt, rc, jt), void 0), ((lo = ya.declarations) === null || lo === void 0 ? void 0 : lo.find(e2.or(e2.isPropertyDeclaration, e2.isVariableDeclaration))) || ic);
                      if (ya.flags & 8208) {
                        var n_ = Jt(ya), o_ = ot(n_, 0);
                        if (Yo & 8)
                          return e2.setTextRange(gi(void 0, e2.factory.createModifiersFromModifierFlags((Zu(ya) ? 64 : 0) | Yo), Cs, ya.flags & 16777216 ? e2.factory.createToken(57) : void 0, void 0, void 0), ((_o = ya.declarations) === null || _o === void 0 ? void 0 : _o.find(e2.isFunctionLikeDeclaration)) || o_[0] && o_[0].declaration || ya.declarations && ya.declarations[0]);
                        for (var og = [], _p = 0, td = o_; _p < td.length; _p++) {
                          var s_ = td[_p], sg = $e(s_, zt, Fr, { name: Cs, questionToken: ya.flags & 16777216 ? e2.factory.createToken(57) : void 0, modifiers: Yo ? e2.factory.createModifiersFromModifierFlags(Yo) : void 0 }), Nc = s_.declaration && e2.isPrototypePropertyAssignment(s_.declaration.parent) ? s_.declaration.parent : s_.declaration;
                          og.push(e2.setTextRange(sg, Nc));
                        }
                        return og;
                      }
                      return e2.Debug.fail("Unhandled class member kind! ".concat(ya.__debugFlags || ya.flags));
                    };
                  }
                  function An(gi, zt) {
                    return ea(gi, false, zt);
                  }
                  function gn(gi, zt, La, fa) {
                    var ya = ot(zt, gi);
                    if (gi === 1) {
                      if (!La && e2.every(ya, function(_c) {
                        return e2.length(_c.parameters) === 0;
                      }))
                        return [];
                      if (La) {
                        var Nn = ot(La, 1);
                        if (!e2.length(Nn) && e2.every(ya, function(_c) {
                          return e2.length(_c.parameters) === 0;
                        }))
                          return [];
                        if (Nn.length === ya.length) {
                          for (var fn = false, hn = 0; hn < Nn.length; hn++)
                            if (!_y(ya[hn], Nn[hn], false, false, true, av)) {
                              fn = true;
                              break;
                            }
                          if (!fn)
                            return [];
                        }
                      }
                      for (var sn = 0, ln = 0, lo = ya; ln < lo.length; ln++) {
                        var _o = lo[ln];
                        _o.declaration && (sn |= e2.getSelectedEffectiveModifierFlags(_o.declaration, 24));
                      }
                      if (sn)
                        return [e2.setTextRange(e2.factory.createConstructorDeclaration(void 0, e2.factory.createModifiersFromModifierFlags(sn), [], void 0), ya[0].declaration)];
                    }
                    for (var _s = [], Vo = 0, Yo = ya; Vo < Yo.length; Vo++) {
                      var Cs = Yo[Vo], ic = $e(Cs, fa, Fr);
                      _s.push(e2.setTextRange(ic, Cs.declaration));
                    }
                    return _s;
                  }
                  function Vn(gi, zt) {
                    for (var La = [], fa = 0, ya = Hn(gi); fa < ya.length; fa++) {
                      var Nn = ya[fa];
                      if (zt) {
                        var fn = ss(zt, Nn.keyType);
                        if (fn && wf(Nn.type, fn.type))
                          continue;
                      }
                      La.push(Me(Nn, Fr, void 0));
                    }
                    return La;
                  }
                  function zo(gi, zt, La) {
                    var fa = us(gi, 111551);
                    if (fa)
                      return fa;
                    var ya = Io("".concat(La, "_base")), Nn = e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(ya, void 0, o(zt, Fr))], 2));
                    return Ts(Nn, 0), e2.factory.createExpressionWithTypeArguments(e2.factory.createIdentifier(ya), void 0);
                  }
                  function us(gi, zt) {
                    var La, fa;
                    if (gi.target && Cf(gi.target.symbol, Kt, zt) ? (La = e2.map(xo(gi), function(ya) {
                      return o(ya, Fr);
                    }), fa = wn(gi.target.symbol, Fr, 788968)) : gi.symbol && Cf(gi.symbol, Kt, zt) && (fa = wn(gi.symbol, Fr, 788968)), fa)
                      return e2.factory.createExpressionWithTypeArguments(fa, La);
                  }
                  function Bo(gi) {
                    var zt = us(gi, 788968);
                    if (zt)
                      return zt;
                    if (gi.symbol)
                      return e2.factory.createExpressionWithTypeArguments(wn(gi.symbol, Fr, 788968), void 0);
                  }
                  function Io(gi, zt) {
                    var La, fa, ya = zt ? y(zt) : void 0;
                    if (ya && Fr.remappedSymbolNames.has(ya))
                      return Fr.remappedSymbolNames.get(ya);
                    zt && (gi = Qo(zt, gi));
                    for (var Nn = 0, fn = gi; !((La = Fr.usedSymbolNames) === null || La === void 0) && La.has(gi); )
                      Nn++, gi = "".concat(fn, "_").concat(Nn);
                    return (fa = Fr.usedSymbolNames) === null || fa === void 0 || fa.add(gi), ya && Fr.remappedSymbolNames.set(ya, gi), gi;
                  }
                  function Qo(gi, zt) {
                    if (zt === "default" || zt === "__class" || zt === "__function") {
                      var La = Fr.flags;
                      Fr.flags |= 16777216;
                      var fa = of(gi, Fr);
                      Fr.flags = La, zt = fa.length > 0 && e2.isSingleOrDoubleQuote(fa.charCodeAt(0)) ? e2.stripQuotes(fa) : fa;
                    }
                    return zt === "default" ? zt = "_default" : zt === "export=" && (zt = "_exports"), zt = e2.isIdentifierText(zt, Ae) && !e2.isStringANonContextualKeyword(zt) ? zt : "_" + zt.replace(/[^a-zA-Z0-9]/g, "_"), zt;
                  }
                  function ls(gi, zt) {
                    var La = y(gi);
                    return Fr.remappedSymbolNames.has(La) ? Fr.remappedSymbolNames.get(La) : (zt = Qo(gi, zt), Fr.remappedSymbolNames.set(La, zt), zt);
                  }
                }
              }
              function Ll(r2, i2, t2, o) {
                return t2 === void 0 && (t2 = 16384), o ? s2(o).getText() : e2.usingSingleLineStringWriter(s2);
                function s2(u) {
                  var h2 = e2.factory.createTypePredicateNode(r2.kind === 2 || r2.kind === 3 ? e2.factory.createToken(128) : void 0, r2.kind === 1 || r2.kind === 3 ? e2.factory.createIdentifier(r2.parameterName) : e2.factory.createThisTypeNode(), r2.type && Ur.typeToTypeNode(r2.type, i2, Rp(t2) | 70221824 | 512)), z = e2.createPrinter({ removeComments: true }), me = i2 && e2.getSourceFileOfNode(i2);
                  return z.writeNode(4, h2, me, u), u;
                }
              }
              function hd(r2) {
                for (var i2 = [], t2 = 0, o = 0; o < r2.length; o++) {
                  var s2 = r2[o];
                  if (t2 |= s2.flags, !(s2.flags & 98304)) {
                    if (s2.flags & 1536) {
                      var u = s2.flags & 512 ? Ii : cc(s2);
                      if (u.flags & 1048576) {
                        var h2 = u.types.length;
                        if (o + h2 <= r2.length && jc(r2[o + h2 - 1]) === jc(u.types[h2 - 1])) {
                          i2.push(u), o += h2 - 1;
                          continue;
                        }
                      }
                    }
                    i2.push(s2);
                  }
                }
                return t2 & 65536 && i2.push(Wi), t2 & 32768 && i2.push(Tr), i2 || r2;
              }
              function v_(r2) {
                return r2 === 8 ? "private" : r2 === 16 ? "protected" : "public";
              }
              function Bp(r2) {
                if (r2.symbol && r2.symbol.flags & 2048 && r2.symbol.declarations) {
                  var i2 = e2.walkUpParenthesizedTypes(r2.symbol.declarations[0].parent);
                  if (i2.kind === 259)
                    return Et(i2);
                }
              }
              function Xu(r2) {
                return r2 && r2.parent && r2.parent.kind === 262 && e2.isExternalModuleAugmentation(r2.parent.parent);
              }
              function Xc(r2) {
                return r2.kind === 305 || e2.isAmbientModule(r2);
              }
              function Gf(r2, i2) {
                var t2 = Aa(r2).nameType;
                if (t2) {
                  if (t2.flags & 384) {
                    var o = "" + t2.value;
                    return !e2.isIdentifierText(o, e2.getEmitScriptTarget(ye)) && !e2.isNumericLiteralName(o) ? '"'.concat(e2.escapeString(o, 34), '"') : e2.isNumericLiteralName(o) && e2.startsWith(o, "-") ? "[".concat(o, "]") : o;
                  }
                  if (t2.flags & 8192)
                    return "[".concat(of(t2.symbol, i2), "]");
                }
              }
              function of(r2, i2) {
                if (i2 && r2.escapedName === "default" && !(i2.flags & 16384) && (!(i2.flags & 16777216) || !r2.declarations || i2.enclosingDeclaration && e2.findAncestor(r2.declarations[0], Xc) !== e2.findAncestor(i2.enclosingDeclaration, Xc)))
                  return "default";
                if (r2.declarations && r2.declarations.length) {
                  var t2 = e2.firstDefined(r2.declarations, function(z) {
                    return e2.getNameOfDeclaration(z) ? z : void 0;
                  }), o = t2 && e2.getNameOfDeclaration(t2);
                  if (t2 && o) {
                    if (e2.isCallExpression(t2) && e2.isBindableObjectDefinePropertyCall(t2))
                      return e2.symbolName(r2);
                    if (e2.isComputedPropertyName(o) && !(e2.getCheckFlags(r2) & 4096)) {
                      var s2 = Aa(r2).nameType;
                      if (s2 && s2.flags & 384) {
                        var u = Gf(r2, i2);
                        if (u !== void 0)
                          return u;
                      }
                    }
                    return e2.declarationNameToString(o);
                  }
                  if (t2 || (t2 = r2.declarations[0]), t2.parent && t2.parent.kind === 254)
                    return e2.declarationNameToString(t2.parent.name);
                  switch (t2.kind) {
                    case 226:
                    case 213:
                    case 214:
                      return i2 && !i2.encounteredError && !(i2.flags & 131072) && (i2.encounteredError = true), t2.kind === 226 ? "(Anonymous class)" : "(Anonymous function)";
                  }
                }
                var h2 = Gf(r2, i2);
                return h2 !== void 0 ? h2 : e2.symbolName(r2);
              }
              function wu(r2) {
                if (r2) {
                  var i2 = va(r2);
                  return i2.isVisible === void 0 && (i2.isVisible = !!t2()), i2.isVisible;
                }
                return false;
                function t2() {
                  switch (r2.kind) {
                    case 338:
                    case 345:
                    case 339:
                      return !!(r2.parent && r2.parent.parent && r2.parent.parent.parent && e2.isSourceFile(r2.parent.parent.parent));
                    case 203:
                      return wu(r2.parent.parent);
                    case 254:
                      if (e2.isBindingPattern(r2.name) && !r2.name.elements.length)
                        return false;
                    case 261:
                    case 257:
                    case 258:
                    case 259:
                    case 256:
                    case 260:
                    case 265:
                      if (e2.isExternalModuleAugmentation(r2))
                        return true;
                      var o = zi(r2);
                      return !(e2.getCombinedModifierFlags(r2) & 1) && !(r2.kind !== 265 && o.kind !== 305 && o.flags & 16777216) ? Cu(o) : wu(o);
                    case 167:
                    case 166:
                    case 172:
                    case 173:
                    case 169:
                    case 168:
                      if (e2.hasEffectiveModifier(r2, 24))
                        return false;
                    case 171:
                    case 175:
                    case 174:
                    case 176:
                    case 164:
                    case 262:
                    case 179:
                    case 180:
                    case 182:
                    case 178:
                    case 183:
                    case 184:
                    case 187:
                    case 188:
                    case 191:
                    case 197:
                      return wu(r2.parent);
                    case 267:
                    case 268:
                    case 270:
                      return false;
                    case 163:
                    case 305:
                    case 264:
                      return true;
                    case 271:
                      return false;
                    default:
                      return false;
                  }
                }
              }
              function V_(r2, i2) {
                var t2;
                r2.parent && r2.parent.kind === 271 ? t2 = es(r2, r2.escapedText, 2998271, void 0, r2, false) : r2.parent.kind === 275 && (t2 = Vu(r2.parent, 2998271));
                var o, s2;
                return t2 && (s2 = new e2.Set(), s2.add(y(t2)), u(t2.declarations)), o;
                function u(h2) {
                  e2.forEach(h2, function(z) {
                    var me = Au(z) || z;
                    if (i2 ? va(z).isVisible = true : (o = o || [], e2.pushIfUnique(o, me)), e2.isInternalModuleImportEqualsDeclaration(z)) {
                      var Me = z.moduleReference, $e = e2.getFirstIdentifier(Me), tr = es(z, $e.escapedText, 901119, void 0, void 0, false);
                      tr && s2 && e2.tryAddToSet(s2, y(tr)) && u(tr.declarations);
                    }
                  });
                }
              }
              function yu(r2, i2) {
                var t2 = v(r2, i2);
                if (t2 >= 0) {
                  for (var o = eu.length, s2 = t2; s2 < o; s2++)
                    Ws[s2] = false;
                  return false;
                }
                return eu.push(r2), Ws.push(true), pu.push(i2), true;
              }
              function v(r2, i2) {
                for (var t2 = eu.length - 1; t2 >= 0; t2--) {
                  if (sr(eu[t2], pu[t2]))
                    return -1;
                  if (eu[t2] === r2 && pu[t2] === i2)
                    return t2;
                }
                return -1;
              }
              function sr(r2, i2) {
                switch (i2) {
                  case 0:
                    return !!Aa(r2).type;
                  case 5:
                    return !!va(r2).resolvedEnumType;
                  case 2:
                    return !!Aa(r2).declaredType;
                  case 1:
                    return !!r2.resolvedBaseConstructorType;
                  case 3:
                    return !!r2.resolvedReturnType;
                  case 4:
                    return !!r2.immediateBaseConstraint;
                  case 6:
                    return !!r2.resolvedTypeArguments;
                  case 7:
                    return !!r2.baseTypesResolved;
                  case 8:
                    return !!Aa(r2).writeType;
                }
                return e2.Debug.assertNever(i2);
              }
              function fi() {
                return eu.pop(), pu.pop(), Ws.pop();
              }
              function zi(r2) {
                return e2.findAncestor(e2.getRootDeclaration(r2), function(i2) {
                  switch (i2.kind) {
                    case 254:
                    case 255:
                    case 270:
                    case 269:
                    case 268:
                    case 267:
                      return false;
                    default:
                      return true;
                  }
                }).parent;
              }
              function Sa(r2) {
                var i2 = go(Ys(r2));
                return i2.typeParameters ? Yf(i2, e2.map(i2.typeParameters, function(t2) {
                  return Oe;
                })) : i2;
              }
              function da(r2, i2) {
                var t2 = bi(r2, i2);
                return t2 ? Jt(t2) : void 0;
              }
              function Ha(r2, i2) {
                var t2;
                return da(r2, i2) || ((t2 = Xo(r2, i2)) === null || t2 === void 0 ? void 0 : t2.type) || gr;
              }
              function ta(r2) {
                return r2 && (r2.flags & 1) !== 0;
              }
              function nn(r2) {
                return r2 === Pe || !!(r2.flags & 1 && r2.aliasSymbol);
              }
              function Wo(r2, i2) {
                if (i2 !== 0)
                  return G_(r2, false, i2);
                var t2 = Et(r2);
                return t2 && Aa(t2).type || G_(r2, false, i2);
              }
              function Lo(r2, i2, t2) {
                if (r2 = ec(r2, function(li) {
                  return !(li.flags & 98304);
                }), r2.flags & 131072)
                  return Ba;
                if (r2.flags & 1048576)
                  return Ss(r2, function(li) {
                    return Lo(li, i2, t2);
                  });
                for (var o = Pa(e2.map(i2, Z_)), s2 = [], u = [], h2 = 0, z = uo(r2); h2 < z.length; h2++) {
                  var me = z[h2], Me = om(me, 8576);
                  !ao(Me, o) && !(e2.getDeclarationModifierFlagsFromSymbol(me) & 24) && Eh(me) ? s2.push(me) : u.push(Me);
                }
                if (Ad(r2) || qp(o)) {
                  if (u.length && (o = Pa(Ve([o], u, true))), o.flags & 131072)
                    return r2;
                  var $e = L3();
                  return $e ? am($e, [r2, o]) : Pe;
                }
                for (var tr = e2.createSymbolTable(), dr = 0, Dr = s2; dr < Dr.length; dr++) {
                  var me = Dr[dr];
                  tr.set(me.escapedName, xD(me, false));
                }
                var Qr = rs(t2, tr, e2.emptyArray, e2.emptyArray, Hn(r2));
                return Qr.objectFlags |= 4194304, Qr;
              }
              function oc(r2) {
                return !!(r2.flags & 465829888) && fs4(uc(r2) || gr, 32768);
              }
              function uu(r2) {
                var i2 = rg(r2, oc) ? Ss(r2, function(t2) {
                  return t2.flags & 465829888 ? Hd(t2) : t2;
                }) : r2;
                return Ks(i2, 524288);
              }
              function is(r2, i2) {
                var t2 = au(r2);
                return t2 ? up(t2, i2) : i2;
              }
              function au(r2) {
                var i2 = Ou(r2);
                if (i2 && i2.flowNode) {
                  var t2 = sf(r2);
                  if (t2) {
                    var o = e2.setTextRange(e2.parseNodeFactory.createStringLiteral(t2), r2), s2 = e2.isLeftHandSideExpression(i2) ? i2 : e2.parseNodeFactory.createParenthesizedExpression(i2), u = e2.setTextRange(e2.parseNodeFactory.createElementAccessExpression(s2, o), r2);
                    return e2.setParent(o, u), e2.setParent(u, r2), s2 !== i2 && e2.setParent(s2, u), u.flowNode = i2.flowNode, u;
                  }
                }
              }
              function Ou(r2) {
                var i2 = r2.parent.parent;
                switch (i2.kind) {
                  case 203:
                  case 296:
                    return au(i2);
                  case 204:
                    return au(r2.parent);
                  case 254:
                    return i2.initializer;
                  case 221:
                    return i2.right;
                }
              }
              function sf(r2) {
                var i2 = r2.parent;
                return r2.kind === 203 && i2.kind === 201 ? lu(r2.propertyName || r2.name) : r2.kind === 296 || r2.kind === 297 ? lu(r2.name) : "" + i2.elements.indexOf(r2);
              }
              function lu(r2) {
                var i2 = Z_(r2);
                return i2.flags & 384 ? "" + i2.value : void 0;
              }
              function cf(r2) {
                var i2 = r2.dotDotDotToken ? 64 : 0, t2 = Wo(r2.parent.parent, i2);
                return t2 && uf(r2, t2);
              }
              function uf(r2, i2) {
                if (ta(i2))
                  return i2;
                var t2 = r2.parent;
                Ye && r2.flags & 16777216 && e2.isParameterDeclaration(r2) ? i2 = C_(i2) : Ye && t2.parent.initializer && !(cp(nC(t2.parent.initializer)) & 65536) && (i2 = Ks(i2, 524288));
                var o;
                if (t2.kind === 201)
                  if (r2.dotDotDotToken) {
                    if (i2 = bu(i2), i2.flags & 2 || !Dy(i2))
                      return Xr(r2, e2.Diagnostics.Rest_types_may_only_be_created_from_object_types), Pe;
                    for (var s2 = [], u = 0, h2 = t2.elements; u < h2.length; u++) {
                      var z = h2[u];
                      z.dotDotDotToken || s2.push(z.propertyName || z.name);
                    }
                    o = Lo(i2, s2, r2.symbol);
                  } else {
                    var me = r2.propertyName || r2.name, Me = Z_(me), $e = Jc(i2, Me, 32, me);
                    o = is(r2, $e);
                  }
                else {
                  var tr = N_(65 | (r2.dotDotDotToken ? 0 : 128), i2, Tr, t2), dr = t2.elements.indexOf(r2);
                  if (r2.dotDotDotToken)
                    o = gf(i2, Yn) ? Ss(i2, function(Qr) {
                      return Zm(Qr, dr);
                    }) : Zs(tr);
                  else if (sp(i2)) {
                    var Me = If(dr), Dr = 32 | (pm(r2) ? 16 : 0), $e = ep(i2, Me, Dr, r2.name) || Pe;
                    o = is(r2, $e);
                  } else
                    o = tr;
                }
                return r2.initializer ? e2.getEffectiveTypeAnnotationNode(e2.walkUpBindingElementsAndPatterns(r2)) ? Ye && !(ju(wy(r2, 0)) & 32768) ? uu(o) : o : _S(r2, Pa([uu(o), wy(r2, 0)], 2)) : o;
              }
              function K_(r2) {
                var i2 = e2.getJSDocType(r2);
                if (i2)
                  return Va(i2);
              }
              function Jp(r2) {
                var i2 = e2.skipParentheses(r2, true);
                return i2.kind === 104 || i2.kind === 79 && Dl(i2) === mi;
              }
              function Hf(r2) {
                var i2 = e2.skipParentheses(r2, true);
                return i2.kind === 204 && i2.elements.length === 0;
              }
              function kc(r2, i2, t2) {
                return i2 === void 0 && (i2 = false), t2 === void 0 && (t2 = true), Ye && t2 ? i_(r2, i2) : r2;
              }
              function G_(r2, i2, t2) {
                if (e2.isVariableDeclaration(r2) && r2.parent.parent.kind === 243) {
                  var o = ql(jb(yn(r2.parent.parent.expression, t2)));
                  return o.flags & 4456448 ? Vx(o) : Li;
                }
                if (e2.isVariableDeclaration(r2) && r2.parent.parent.kind === 244) {
                  var s2 = r2.parent.parent;
                  return By(s2) || Oe;
                }
                if (e2.isBindingPattern(r2.parent))
                  return cf(r2);
                var u = e2.isPropertyDeclaration(r2) || e2.isPropertySignature(r2), h2 = i2 && (u && !!r2.questionToken || e2.isParameter(r2) && (!!r2.questionToken || Cd(r2)) || Vm(r2)), z = Rl(r2);
                if (z)
                  return kc(z, u, h2);
                if ((n || e2.isInJSFile(r2)) && e2.isVariableDeclaration(r2) && !e2.isBindingPattern(r2.name) && !(e2.getCombinedModifierFlags(r2) & 1) && !(r2.flags & 16777216)) {
                  if (!(e2.getCombinedNodeFlags(r2) & 2) && (!r2.initializer || Jp(r2.initializer)))
                    return nr;
                  if (r2.initializer && Hf(r2.initializer))
                    return So;
                }
                if (e2.isParameter(r2)) {
                  var me = r2.parent;
                  if (me.kind === 173 && Td(me)) {
                    var Me = e2.getDeclarationOfKind(Et(r2.parent), 172);
                    if (Me) {
                      var $e = yl(Me), tr = qS(me);
                      return tr && r2 === tr ? (e2.Debug.assert(!tr.type), Jt($e.thisParameter)) : yo($e);
                    }
                  }
                  if (e2.isInJSFile(r2)) {
                    var dr = Km(me, r2);
                    if (dr)
                      return dr;
                  }
                  var Dr = r2.symbol.escapedName === "this" ? SC(me) : TC(r2);
                  if (Dr)
                    return kc(Dr, false, h2);
                }
                if (e2.hasOnlyExpressionInitializer(r2) && !!r2.initializer) {
                  if (e2.isInJSFile(r2) && !e2.isParameter(r2)) {
                    var Qr = ha(r2, Et(r2), e2.getDeclaredExpandoInitializer(r2));
                    if (Qr)
                      return Qr;
                  }
                  var Dr = _S(r2, wy(r2, t2));
                  return kc(Dr, u, h2);
                }
                if (e2.isPropertyDeclaration(r2) && (n || e2.isInJSFile(r2)))
                  if (e2.hasStaticModifier(r2)) {
                    var Ti = e2.filter(r2.parent.members, e2.isClassStaticBlockDeclaration), Dr = Ti.length ? Mi(r2.symbol, Ti) : e2.getEffectiveModifierFlags(r2) & 2 ? Lh(r2.symbol) : void 0;
                    return Dr && kc(Dr, true, h2);
                  } else {
                    var li = Tf(r2.parent), Dr = li ? st(r2.symbol, li) : e2.getEffectiveModifierFlags(r2) & 2 ? Lh(r2.symbol) : void 0;
                    return Dr && kc(Dr, true, h2);
                  }
                if (e2.isJsxAttribute(r2))
                  return Dt;
                if (e2.isBindingPattern(r2.name))
                  return Qu(r2.name, false, true);
              }
              function Le(r2) {
                if (r2.valueDeclaration && e2.isBinaryExpression(r2.valueDeclaration)) {
                  var i2 = Aa(r2);
                  return i2.isConstructorDeclaredProperty === void 0 && (i2.isConstructorDeclaredProperty = false, i2.isConstructorDeclaredProperty = !!ri(r2) && e2.every(r2.declarations, function(t2) {
                    return e2.isBinaryExpression(t2) && s0(t2) && (t2.left.kind !== 207 || e2.isStringOrNumericLiteralLike(t2.left.argumentExpression)) && !Na(void 0, t2, r2, t2);
                  })), i2.isConstructorDeclaredProperty;
                }
                return false;
              }
              function Nr(r2) {
                var i2 = r2.valueDeclaration;
                return i2 && e2.isPropertyDeclaration(i2) && !e2.getEffectiveTypeAnnotationNode(i2) && !i2.initializer && (n || e2.isInJSFile(i2));
              }
              function ri(r2) {
                if (!!r2.declarations)
                  for (var i2 = 0, t2 = r2.declarations; i2 < t2.length; i2++) {
                    var o = t2[i2], s2 = e2.getThisContainer(o, false);
                    if (s2 && (s2.kind === 171 || Sl(s2)))
                      return s2;
                  }
              }
              function di(r2) {
                var i2 = e2.getSourceFileOfNode(r2.declarations[0]), t2 = e2.unescapeLeadingUnderscores(r2.escapedName), o = r2.declarations.every(function(u) {
                  return e2.isInJSFile(u) && e2.isAccessExpression(u) && e2.isModuleExportsAccessExpression(u.expression);
                }), s2 = o ? e2.factory.createPropertyAccessExpression(e2.factory.createPropertyAccessExpression(e2.factory.createIdentifier("module"), e2.factory.createIdentifier("exports")), t2) : e2.factory.createPropertyAccessExpression(e2.factory.createIdentifier("exports"), t2);
                return o && e2.setParent(s2.expression.expression, s2.expression), e2.setParent(s2.expression, s2), e2.setParent(s2, i2), s2.flowNode = i2.endFlowNode, up(s2, nr, Tr);
              }
              function Mi(r2, i2) {
                for (var t2 = e2.startsWith(r2.escapedName, "__#") ? e2.factory.createPrivateIdentifier(r2.escapedName.split("@")[1]) : e2.unescapeLeadingUnderscores(r2.escapedName), o = 0, s2 = i2; o < s2.length; o++) {
                  var u = s2[o], h2 = e2.factory.createPropertyAccessExpression(e2.factory.createThis(), t2);
                  e2.setParent(h2.expression, h2), e2.setParent(h2, u), h2.flowNode = u.returnFlowNode;
                  var z = ra(h2, r2);
                  if (n && (z === nr || z === So) && Xr(r2.valueDeclaration, e2.Diagnostics.Member_0_implicitly_has_an_1_type, tn(r2), Ot(z)), !gf(z, d0))
                    return kv(z);
                }
              }
              function st(r2, i2) {
                var t2 = e2.startsWith(r2.escapedName, "__#") ? e2.factory.createPrivateIdentifier(r2.escapedName.split("@")[1]) : e2.unescapeLeadingUnderscores(r2.escapedName), o = e2.factory.createPropertyAccessExpression(e2.factory.createThis(), t2);
                e2.setParent(o.expression, o), e2.setParent(o, i2), o.flowNode = i2.returnFlowNode;
                var s2 = ra(o, r2);
                return n && (s2 === nr || s2 === So) && Xr(r2.valueDeclaration, e2.Diagnostics.Member_0_implicitly_has_an_1_type, tn(r2), Ot(s2)), gf(s2, d0) ? void 0 : kv(s2);
              }
              function ra(r2, i2) {
                var t2 = (i2 == null ? void 0 : i2.valueDeclaration) && (!Nr(i2) || e2.getEffectiveModifierFlags(i2.valueDeclaration) & 2) && Lh(i2) || Tr;
                return up(r2, nr, t2);
              }
              function Ta(r2, i2) {
                var t2 = e2.getAssignedExpandoInitializer(r2.valueDeclaration);
                if (t2) {
                  var o = e2.getJSDocTypeTag(t2);
                  if (o && o.typeExpression)
                    return Va(o.typeExpression);
                  var s2 = r2.valueDeclaration && ha(r2.valueDeclaration, r2, t2);
                  return s2 || Hp(Os(t2));
                }
                var u, h2 = false, z = false;
                if (Le(r2) && (u = st(r2, ri(r2))), !u) {
                  var me = void 0;
                  if (r2.declarations) {
                    for (var Me = void 0, $e = 0, tr = r2.declarations; $e < tr.length; $e++) {
                      var dr = tr[$e], Dr = e2.isBinaryExpression(dr) || e2.isCallExpression(dr) ? dr : e2.isAccessExpression(dr) ? e2.isBinaryExpression(dr.parent) ? dr.parent : dr : void 0;
                      if (!!Dr) {
                        var Qr = e2.isAccessExpression(Dr) ? e2.getAssignmentDeclarationPropertyAccessKind(Dr) : e2.getAssignmentDeclarationKind(Dr);
                        (Qr === 4 || e2.isBinaryExpression(Dr) && s0(Dr, Qr)) && (co(Dr) ? h2 = true : z = true), e2.isCallExpression(Dr) || (Me = Na(Me, Dr, r2, dr)), Me || (me || (me = [])).push(e2.isBinaryExpression(Dr) || e2.isCallExpression(Dr) ? In(r2, i2, Dr, Qr) : ui);
                      }
                    }
                    u = Me;
                  }
                  if (!u) {
                    if (!e2.length(me))
                      return Pe;
                    var li = h2 && r2.declarations ? ts(me, r2.declarations) : void 0;
                    if (z) {
                      var Ti = Lh(r2);
                      Ti && ((li || (li = [])).push(Ti), h2 = true);
                    }
                    var Ci = e2.some(li, function(Zi) {
                      return !!(Zi.flags & -98305);
                    }) ? li : me;
                    u = Pa(Ci);
                  }
                }
                var $i = $c(kc(u, false, z && !h2));
                return r2.valueDeclaration && ec($i, function(Zi) {
                  return !!(Zi.flags & -98305);
                }) === ui ? (Xp(r2.valueDeclaration, Oe), Oe) : $i;
              }
              function ha(r2, i2, t2) {
                var o, s2;
                if (!(!e2.isInJSFile(r2) || !t2 || !e2.isObjectLiteralExpression(t2) || t2.properties.length)) {
                  for (var u = e2.createSymbolTable(); e2.isBinaryExpression(r2) || e2.isPropertyAccessExpression(r2); ) {
                    var h2 = Et(r2);
                    !((o = h2 == null ? void 0 : h2.exports) === null || o === void 0) && o.size && gu(u, h2.exports), r2 = e2.isBinaryExpression(r2) ? r2.parent : r2.parent.parent;
                  }
                  var z = Et(r2);
                  !((s2 = z == null ? void 0 : z.exports) === null || s2 === void 0) && s2.size && gu(u, z.exports);
                  var me = rs(i2, u, e2.emptyArray, e2.emptyArray, e2.emptyArray);
                  return me.objectFlags |= 4096, me;
                }
              }
              function Na(r2, i2, t2, o) {
                var s2, u = e2.getEffectiveTypeAnnotationNode(i2.parent);
                if (u) {
                  var h2 = $c(Va(u));
                  if (r2)
                    !nn(r2) && !nn(h2) && !wf(r2, h2) && v6(void 0, r2, o, h2);
                  else
                    return h2;
                }
                if (!((s2 = t2.parent) === null || s2 === void 0) && s2.valueDeclaration) {
                  var z = e2.getEffectiveTypeAnnotationNode(t2.parent.valueDeclaration);
                  if (z) {
                    var me = bi(Va(z), t2.escapedName);
                    if (me)
                      return ml(me);
                  }
                }
                return r2;
              }
              function In(r2, i2, t2, o) {
                if (e2.isCallExpression(t2)) {
                  if (i2)
                    return Jt(i2);
                  var s2 = Os(t2.arguments[2]), u = da(s2, "value");
                  if (u)
                    return u;
                  var h2 = da(s2, "get");
                  if (h2) {
                    var z = ig(h2);
                    if (z)
                      return yo(z);
                  }
                  var me = da(s2, "set");
                  if (me) {
                    var Me = ig(me);
                    if (Me)
                      return aS(Me);
                  }
                  return Oe;
                }
                if (qo(t2.left, t2.right))
                  return Oe;
                var $e = o === 1 && (e2.isPropertyAccessExpression(t2.left) || e2.isElementAccessExpression(t2.left)) && (e2.isModuleExportsAccessExpression(t2.left.expression) || e2.isIdentifier(t2.left.expression) && e2.isExportsIdentifier(t2.left.expression)), tr = i2 ? Jt(i2) : $e ? jc(Os(t2.right)) : Hp(Os(t2.right));
                if (tr.flags & 524288 && o === 2 && r2.escapedName === "export=") {
                  var dr = Ru(tr), Dr = e2.createSymbolTable();
                  e2.copyEntries(dr.members, Dr);
                  var Qr = Dr.size;
                  i2 && !i2.exports && (i2.exports = e2.createSymbolTable()), (i2 || r2).exports.forEach(function(Ti, Ci) {
                    var $i, Zi = Dr.get(Ci);
                    if (Zi && Zi !== Ti)
                      if (Ti.flags & 111551 && Zi.flags & 111551) {
                        if (Ti.valueDeclaration && Zi.valueDeclaration && e2.getSourceFileOfNode(Ti.valueDeclaration) !== e2.getSourceFileOfNode(Zi.valueDeclaration)) {
                          var qt = e2.unescapeLeadingUnderscores(Ti.escapedName), Nt = (($i = e2.tryCast(Zi.valueDeclaration, e2.isNamedDeclaration)) === null || $i === void 0 ? void 0 : $i.name) || Zi.valueDeclaration;
                          e2.addRelatedInfo(Xr(Ti.valueDeclaration, e2.Diagnostics.Duplicate_identifier_0, qt), e2.createDiagnosticForNode(Nt, e2.Diagnostics._0_was_also_declared_here, qt)), e2.addRelatedInfo(Xr(Nt, e2.Diagnostics.Duplicate_identifier_0, qt), e2.createDiagnosticForNode(Ti.valueDeclaration, e2.Diagnostics._0_was_also_declared_here, qt));
                        }
                        var Ra = oo(Ti.flags | Zi.flags, Ci);
                        Ra.type = Pa([Jt(Ti), Jt(Zi)]), Ra.valueDeclaration = Zi.valueDeclaration, Ra.declarations = e2.concatenate(Zi.declarations, Ti.declarations), Dr.set(Ci, Ra);
                      } else
                        Dr.set(Ci, Bf(Ti, Zi));
                    else
                      Dr.set(Ci, Ti);
                  });
                  var li = rs(Qr !== Dr.size ? void 0 : dr.symbol, Dr, dr.callSignatures, dr.constructSignatures, dr.indexInfos);
                  return li.objectFlags |= e2.getObjectFlags(tr) & 4096, li.symbol && li.symbol.flags & 32 && tr === aa(li.symbol) && (li.objectFlags |= 16777216), li;
                }
                return Jh(tr) ? (Xp(t2, mo), mo) : tr;
              }
              function qo(r2, i2) {
                return e2.isPropertyAccessExpression(r2) && r2.expression.kind === 108 && e2.forEachChildRecursively(i2, function(t2) {
                  return zs(r2, t2);
                });
              }
              function co(r2) {
                var i2 = e2.getThisContainer(r2, false);
                return i2.kind === 171 || i2.kind === 256 || i2.kind === 213 && !e2.isPrototypePropertyAssignment(i2.parent);
              }
              function ts(r2, i2) {
                return e2.Debug.assert(r2.length === i2.length), r2.filter(function(t2, o) {
                  var s2 = i2[o], u = e2.isBinaryExpression(s2) ? s2 : e2.isBinaryExpression(s2.parent) ? s2.parent : void 0;
                  return u && co(u);
                });
              }
              function vs(r2, i2, t2) {
                if (r2.initializer) {
                  var o = e2.isBindingPattern(r2.name) ? Qu(r2.name, true, false) : gr;
                  return kc(_S(r2, wy(r2, 0, o)));
                }
                return e2.isBindingPattern(r2.name) ? Qu(r2.name, i2, t2) : (t2 && !Yu(r2) && Xp(r2, Oe), i2 ? fr : Oe);
              }
              function Ac(r2, i2, t2) {
                var o = e2.createSymbolTable(), s2, u = 131200;
                e2.forEach(r2.elements, function(z) {
                  var me = z.propertyName || z.name;
                  if (z.dotDotDotToken) {
                    s2 = zl(Li, Oe, false);
                    return;
                  }
                  var Me = Z_(me);
                  if (!_f(Me)) {
                    u |= 512;
                    return;
                  }
                  var $e = pf(Me), tr = 4 | (z.initializer ? 16777216 : 0), dr = oo(tr, $e);
                  dr.type = vs(z, i2, t2), dr.bindingElement = z, o.set(dr.escapedName, dr);
                });
                var h2 = rs(void 0, o, e2.emptyArray, e2.emptyArray, s2 ? [s2] : e2.emptyArray);
                return h2.objectFlags |= u, i2 && (h2.pattern = r2, h2.objectFlags |= 131072), h2;
              }
              function Is(r2, i2, t2) {
                var o = r2.elements, s2 = e2.lastOrUndefined(o), u = s2 && s2.kind === 203 && s2.dotDotDotToken ? s2 : void 0;
                if (o.length === 0 || o.length === 1 && u)
                  return Ae >= 2 ? B3(Oe) : mo;
                var h2 = e2.map(o, function($e) {
                  return e2.isOmittedExpression($e) ? Oe : vs($e, i2, t2);
                }), z = e2.findLastIndex(o, function($e) {
                  return !($e === u || e2.isOmittedExpression($e) || pm($e));
                }, o.length - 1) + 1, me = e2.map(o, function($e, tr) {
                  return $e === u ? 4 : tr >= z ? 2 : 1;
                }), Me = Wl(h2, me);
                return i2 && (Me = ux(Me), Me.pattern = r2, Me.objectFlags |= 131072), Me;
              }
              function Qu(r2, i2, t2) {
                return i2 === void 0 && (i2 = false), t2 === void 0 && (t2 = false), r2.kind === 201 ? Ac(r2, i2, t2) : Is(r2, i2, t2);
              }
              function sc(r2, i2) {
                return Mc(G_(r2, true, 0), r2, i2);
              }
              function bc(r2) {
                var i2 = Et(r2), t2 = x3(false);
                return t2 && i2 && i2 === t2;
              }
              function Mc(r2, i2, t2) {
                return r2 ? (r2.flags & 4096 && bc(i2.parent) && (r2 = CD(i2)), t2 && Kh(i2, r2), r2.flags & 8192 && (e2.isBindingElement(i2) || !i2.type) && r2.symbol !== Et(i2) && (r2 = Ki), $c(r2)) : (r2 = e2.isParameter(i2) && i2.dotDotDotToken ? mo : Oe, t2 && (Yu(i2) || Xp(i2, r2)), r2);
              }
              function Yu(r2) {
                var i2 = e2.getRootDeclaration(r2), t2 = i2.kind === 164 ? i2.parent : i2;
                return I0(t2);
              }
              function Rl(r2) {
                var i2 = e2.getEffectiveTypeAnnotationNode(r2);
                if (i2)
                  return Va(i2);
              }
              function Lc(r2) {
                var i2 = Aa(r2);
                if (!i2.type) {
                  var t2 = _(r2);
                  i2.type || (i2.type = t2);
                }
                return i2.type;
              }
              function _(r2) {
                if (r2.flags & 4194304)
                  return Sa(r2);
                if (r2 === qr)
                  return Oe;
                if (r2.flags & 134217728 && r2.valueDeclaration) {
                  var i2 = Et(e2.getSourceFileOfNode(r2.valueDeclaration)), t2 = oo(i2.flags, "exports");
                  t2.declarations = i2.declarations ? i2.declarations.slice() : [], t2.parent = r2, t2.target = i2, i2.valueDeclaration && (t2.valueDeclaration = i2.valueDeclaration), i2.members && (t2.members = new e2.Map(i2.members)), i2.exports && (t2.exports = new e2.Map(i2.exports));
                  var o = e2.createSymbolTable();
                  return o.set("exports", t2), rs(r2, o, e2.emptyArray, e2.emptyArray, e2.emptyArray);
                }
                e2.Debug.assertIsDefined(r2.valueDeclaration);
                var s2 = r2.valueDeclaration;
                if (e2.isCatchClauseVariableDeclarationOrBindingElement(s2)) {
                  var u = e2.getEffectiveTypeAnnotationNode(s2);
                  if (u === void 0)
                    return be ? gr : Oe;
                  var h2 = Bd(u);
                  return ta(h2) || h2 === gr ? h2 : Pe;
                }
                if (e2.isSourceFile(s2) && e2.isJsonSourceFile(s2))
                  return s2.statements.length ? $c(Hp(yn(s2.statements[0].expression))) : Ba;
                if (e2.isAccessor(s2))
                  return rt(r2);
                if (!yu(r2, 0))
                  return r2.flags & 512 && !(r2.flags & 67108864) ? vo(r2) : lg(r2);
                var z;
                if (s2.kind === 271)
                  z = Mc(Rl(s2) || Os(s2.expression), s2);
                else if (e2.isBinaryExpression(s2) || e2.isInJSFile(s2) && (e2.isCallExpression(s2) || (e2.isPropertyAccessExpression(s2) || e2.isBindableStaticElementAccessExpression(s2)) && e2.isBinaryExpression(s2.parent)))
                  z = Ta(r2);
                else if (e2.isPropertyAccessExpression(s2) || e2.isElementAccessExpression(s2) || e2.isIdentifier(s2) || e2.isStringLiteralLike(s2) || e2.isNumericLiteral(s2) || e2.isClassDeclaration(s2) || e2.isFunctionDeclaration(s2) || e2.isMethodDeclaration(s2) && !e2.isObjectLiteralMethod(s2) || e2.isMethodSignature(s2) || e2.isSourceFile(s2)) {
                  if (r2.flags & 9136)
                    return vo(r2);
                  z = e2.isBinaryExpression(s2.parent) ? Ta(r2) : Rl(s2) || Oe;
                } else if (e2.isPropertyAssignment(s2))
                  z = Rl(s2) || Kk(s2);
                else if (e2.isJsxAttribute(s2))
                  z = Rl(s2) || OC(s2);
                else if (e2.isShorthandPropertyAssignment(s2))
                  z = Rl(s2) || Dm(s2.name, 0);
                else if (e2.isObjectLiteralMethod(s2))
                  z = Rl(s2) || Gk(s2, 0);
                else if (e2.isParameter(s2) || e2.isPropertyDeclaration(s2) || e2.isPropertySignature(s2) || e2.isVariableDeclaration(s2) || e2.isBindingElement(s2) || e2.isJSDocPropertyLikeTag(s2))
                  z = sc(s2, true);
                else if (e2.isEnumDeclaration(s2))
                  z = vo(r2);
                else if (e2.isEnumMember(s2))
                  z = H_(r2);
                else
                  return e2.Debug.fail("Unhandled declaration kind! " + e2.Debug.formatSyntaxKind(s2.kind) + " for " + e2.Debug.formatSymbol(r2));
                return fi() ? z : r2.flags & 512 && !(r2.flags & 67108864) ? vo(r2) : lg(r2);
              }
              function W(r2) {
                if (r2)
                  if (r2.kind === 172) {
                    var i2 = e2.getEffectiveReturnTypeNode(r2);
                    return i2;
                  } else {
                    var t2 = e2.getEffectiveSetAccessorTypeAnnotationNode(r2);
                    return t2;
                  }
              }
              function Te(r2) {
                var i2 = W(r2);
                return i2 && Va(i2);
              }
              function cr(r2) {
                var i2 = qS(r2);
                return i2 && i2.symbol;
              }
              function ni(r2) {
                return T_(yl(r2));
              }
              function rt(r2) {
                var i2 = Aa(r2);
                if (!i2.type) {
                  if (!yu(r2, 0))
                    return Pe;
                  var t2 = e2.getDeclarationOfKind(r2, 172), o = e2.getDeclarationOfKind(r2, 173), s2 = t2 && e2.isInJSFile(t2) && K_(t2) || Te(t2) || Te(o) || t2 && t2.body && C0(t2);
                  s2 || (o && !I0(o) ? Ic(n, o, e2.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation, tn(r2)) : t2 && !I0(t2) && Ic(n, t2, e2.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation, tn(r2)), s2 = Oe), fi() || (W(t2) ? Xr(t2, e2.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, tn(r2)) : W(o) ? Xr(o, e2.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, tn(r2)) : t2 && n && Xr(t2, e2.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, tn(r2)), s2 = Oe), i2.type = s2;
                }
                return i2.type;
              }
              function yt(r2) {
                var i2 = Aa(r2);
                if (!i2.writeType) {
                  if (!yu(r2, 8))
                    return Pe;
                  var t2 = e2.getDeclarationOfKind(r2, 173), o = Te(t2);
                  fi() || (W(t2) && Xr(t2, e2.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, tn(r2)), o = Oe), i2.writeType = o || rt(r2);
                }
                return i2.writeType;
              }
              function Xa(r2) {
                var i2 = Bl(aa(r2));
                return i2.flags & 8650752 ? i2 : i2.flags & 2097152 ? e2.find(i2.types, function(t2) {
                  return !!(t2.flags & 8650752);
                }) : void 0;
              }
              function vo(r2) {
                var i2 = Aa(r2), t2 = i2;
                if (!i2.type) {
                  var o = r2.valueDeclaration && T0(r2.valueDeclaration, false);
                  if (o) {
                    var s2 = iS(r2, o);
                    s2 && (r2 = i2 = s2);
                  }
                  t2.type = i2.type = Vs(r2);
                }
                return i2.type;
              }
              function Vs(r2) {
                var i2 = r2.valueDeclaration;
                if (r2.flags & 1536 && e2.isShorthandAmbientModuleSymbol(r2))
                  return Oe;
                if (i2 && (i2.kind === 221 || e2.isAccessExpression(i2) && i2.parent.kind === 221))
                  return Ta(r2);
                if (r2.flags & 512 && i2 && e2.isSourceFile(i2) && i2.commonJsModuleIndicator) {
                  var t2 = Us(r2);
                  if (t2 !== r2) {
                    if (!yu(r2, 0))
                      return Pe;
                    var o = so(r2.exports.get("export=")), s2 = Ta(o, o === t2 ? void 0 : t2);
                    return fi() ? s2 : lg(r2);
                  }
                }
                var u = tu(16, r2);
                if (r2.flags & 32) {
                  var h2 = Xa(r2);
                  return h2 ? Do([u, h2]) : u;
                } else
                  return Ye && r2.flags & 16777216 ? i_(u) : u;
              }
              function H_(r2) {
                var i2 = Aa(r2);
                return i2.type || (i2.type = hu(r2));
              }
              function y_(r2) {
                var i2 = Aa(r2);
                if (!i2.type) {
                  var t2 = Ps(r2), o = r2.declarations && Ec(ru(r2), true), s2 = e2.firstDefined(o == null ? void 0 : o.declarations, function(u) {
                    return e2.isExportAssignment(u) ? Rl(u) : void 0;
                  });
                  i2.type = (o == null ? void 0 : o.declarations) && z0(o.declarations) && r2.declarations.length ? di(o) : z0(r2.declarations) ? nr : s2 || (t2.flags & 111551 ? Jt(t2) : Pe);
                }
                return i2.type;
              }
              function Dd(r2) {
                var i2 = Aa(r2);
                return i2.type || (i2.type = un(Jt(i2.target), i2.mapper));
              }
              function jp(r2) {
                var i2 = Aa(r2);
                return i2.writeType || (i2.writeType = un(Vg(i2.target), i2.mapper));
              }
              function lg(r2) {
                var i2 = r2.valueDeclaration;
                return e2.getEffectiveTypeAnnotationNode(i2) ? (Xr(r2.valueDeclaration, e2.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_type_annotation, tn(r2)), Pe) : (n && (i2.kind !== 164 || i2.initializer) && Xr(r2.valueDeclaration, e2.Diagnostics._0_implicitly_has_type_any_because_it_does_not_have_a_type_annotation_and_is_referenced_directly_or_indirectly_in_its_own_initializer, tn(r2)), Oe);
              }
              function Om(r2) {
                var i2 = Aa(r2);
                return i2.type || (e2.Debug.assertIsDefined(i2.deferralParent), e2.Debug.assertIsDefined(i2.deferralConstituents), i2.type = i2.deferralParent.flags & 1048576 ? Pa(i2.deferralConstituents) : Do(i2.deferralConstituents)), i2.type;
              }
              function Fm(r2) {
                var i2 = Aa(r2);
                return !i2.writeType && i2.deferralWriteConstituents && (e2.Debug.assertIsDefined(i2.deferralParent), e2.Debug.assertIsDefined(i2.deferralConstituents), i2.writeType = i2.deferralParent.flags & 1048576 ? Pa(i2.deferralWriteConstituents) : Do(i2.deferralWriteConstituents)), i2.writeType;
              }
              function Vg(r2) {
                var i2 = e2.getCheckFlags(r2);
                return r2.flags & 4 ? i2 & 2 ? i2 & 65536 ? Fm(r2) || Om(r2) : r2.writeType || r2.type : Jt(r2) : r2.flags & 98304 ? i2 & 1 ? jp(r2) : yt(r2) : Jt(r2);
              }
              function Jt(r2) {
                var i2 = e2.getCheckFlags(r2);
                return i2 & 65536 ? Om(r2) : i2 & 1 ? Dd(r2) : i2 & 262144 ? J1(r2) : i2 & 8192 ? qw(r2) : r2.flags & 7 ? Lc(r2) : r2.flags & 9136 ? vo(r2) : r2.flags & 8 ? H_(r2) : r2.flags & 98304 ? rt(r2) : r2.flags & 2097152 ? y_(r2) : Pe;
              }
              function ml(r2) {
                return kg(Jt(r2), !!(r2.flags & 16777216));
              }
              function Xf(r2, i2) {
                return r2 !== void 0 && i2 !== void 0 && (e2.getObjectFlags(r2) & 4) !== 0 && r2.target === i2;
              }
              function bd(r2) {
                return e2.getObjectFlags(r2) & 4 ? r2.target : r2;
              }
              function lf(r2, i2) {
                return t2(r2);
                function t2(o) {
                  if (e2.getObjectFlags(o) & 7) {
                    var s2 = bd(o);
                    return s2 === i2 || e2.some(Qc(s2), t2);
                  } else if (o.flags & 2097152)
                    return e2.some(o.types, t2);
                  return false;
                }
              }
              function Kg(r2, i2) {
                for (var t2 = 0, o = i2; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  r2 = e2.appendIfUnique(r2, Js(Et(s2)));
                }
                return r2;
              }
              function kf(r2, i2) {
                for (; ; ) {
                  if (r2 = r2.parent, r2 && e2.isBinaryExpression(r2)) {
                    var t2 = e2.getAssignmentDeclarationKind(r2);
                    if (t2 === 6 || t2 === 3) {
                      var o = Et(r2.left);
                      o && o.parent && !e2.findAncestor(o.parent.valueDeclaration, function(me) {
                        return r2 === me;
                      }) && (r2 = o.parent.valueDeclaration);
                    }
                  }
                  if (!r2)
                    return;
                  switch (r2.kind) {
                    case 257:
                    case 226:
                    case 258:
                    case 174:
                    case 175:
                    case 168:
                    case 179:
                    case 180:
                    case 317:
                    case 256:
                    case 169:
                    case 213:
                    case 214:
                    case 259:
                    case 344:
                    case 345:
                    case 339:
                    case 338:
                    case 195:
                    case 189: {
                      var s2 = kf(r2, i2);
                      if (r2.kind === 195)
                        return e2.append(s2, Js(Et(r2.typeParameter)));
                      if (r2.kind === 189)
                        return e2.concatenate(s2, eE(r2));
                      var u = Kg(s2, e2.getEffectiveTypeParameterDeclarations(r2)), h2 = i2 && (r2.kind === 257 || r2.kind === 226 || r2.kind === 258 || Sl(r2)) && aa(Et(r2)).thisType;
                      return h2 ? e2.append(u, h2) : u;
                    }
                    case 340:
                      var z = e2.getParameterSymbolFromJSDoc(r2);
                      z && (r2 = z.valueDeclaration);
                      break;
                    case 320: {
                      var s2 = kf(r2, i2);
                      return r2.tags ? Kg(s2, e2.flatMap(r2.tags, function(Me) {
                        return e2.isJSDocTemplateTag(Me) ? Me.typeParameters : void 0;
                      })) : s2;
                    }
                  }
                }
              }
              function Gg(r2) {
                var i2 = r2.flags & 32 ? r2.valueDeclaration : e2.getDeclarationOfKind(r2, 258);
                return e2.Debug.assert(!!i2, "Class was missing valueDeclaration -OR- non-class had no interface declarations"), kf(i2);
              }
              function Af(r2) {
                if (!!r2.declarations) {
                  for (var i2, t2 = 0, o = r2.declarations; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (s2.kind === 258 || s2.kind === 257 || s2.kind === 226 || Sl(s2) || e2.isTypeAlias(s2)) {
                      var u = s2;
                      i2 = Kg(i2, e2.getEffectiveTypeParameterDeclarations(u));
                    }
                  }
                  return i2;
                }
              }
              function Hg(r2) {
                return e2.concatenate(Gg(r2), Af(r2));
              }
              function Wd(r2) {
                var i2 = ot(r2, 1);
                if (i2.length === 1) {
                  var t2 = i2[0];
                  if (!t2.typeParameters && t2.parameters.length === 1 && H(t2)) {
                    var o = mv(t2.parameters[0]);
                    return ta(o) || KD(o) === Oe;
                  }
                }
                return false;
              }
              function qd(r2) {
                if (ot(r2, 1).length > 0)
                  return true;
                if (r2.flags & 8650752) {
                  var i2 = uc(r2);
                  return !!i2 && Wd(i2);
                }
                return false;
              }
              function fg(r2) {
                var i2 = e2.getClassLikeDeclarationOfSymbol(r2.symbol);
                return i2 && e2.getEffectiveBaseTypeNode(i2);
              }
              function Mm(r2, i2, t2) {
                var o = e2.length(i2), s2 = e2.isInJSFile(t2);
                return e2.filter(ot(r2, 1), function(u) {
                  return (s2 || o >= Ul(u.typeParameters)) && o <= e2.length(u.typeParameters);
                });
              }
              function Xg(r2, i2, t2) {
                var o = Mm(r2, i2, t2), s2 = e2.map(i2, Va);
                return e2.sameMap(o, function(u) {
                  return e2.some(u.typeParameters) ? Xm(u, s2, e2.isInJSFile(t2)) : u;
                });
              }
              function Bl(r2) {
                if (!r2.resolvedBaseConstructorType) {
                  var i2 = e2.getClassLikeDeclarationOfSymbol(r2.symbol), t2 = i2 && e2.getEffectiveBaseTypeNode(i2), o = fg(r2);
                  if (!o)
                    return r2.resolvedBaseConstructorType = Tr;
                  if (!yu(r2, 1))
                    return Pe;
                  var s2 = yn(o.expression);
                  if (t2 && o !== t2 && (e2.Debug.assert(!t2.typeArguments), yn(t2.expression)), s2.flags & 2621440 && Ru(s2), !fi())
                    return Xr(r2.symbol.valueDeclaration, e2.Diagnostics._0_is_referenced_directly_or_indirectly_in_its_own_base_expression, tn(r2.symbol)), r2.resolvedBaseConstructorType = Pe;
                  if (!(s2.flags & 1) && s2 !== ct && !qd(s2)) {
                    var u = Xr(o.expression, e2.Diagnostics.Type_0_is_not_a_constructor_function_type, Ot(s2));
                    if (s2.flags & 262144) {
                      var h2 = tm(s2), z = gr;
                      if (h2) {
                        var me = ot(h2, 1);
                        me[0] && (z = yo(me[0]));
                      }
                      s2.symbol.declarations && e2.addRelatedInfo(u, e2.createDiagnosticForNode(s2.symbol.declarations[0], e2.Diagnostics.Did_you_mean_for_0_to_be_constrained_to_type_new_args_Colon_any_1, tn(s2.symbol), Ot(z)));
                    }
                    return r2.resolvedBaseConstructorType = Pe;
                  }
                  r2.resolvedBaseConstructorType = s2;
                }
                return r2.resolvedBaseConstructorType;
              }
              function Qg(r2) {
                var i2 = e2.emptyArray;
                if (r2.symbol.declarations)
                  for (var t2 = 0, o = r2.symbol.declarations; t2 < o.length; t2++) {
                    var s2 = o[t2], u = e2.getEffectiveImplementsTypeNodes(s2);
                    if (!!u)
                      for (var h2 = 0, z = u; h2 < z.length; h2++) {
                        var me = z[h2], Me = Va(me);
                        nn(Me) || (i2 === e2.emptyArray ? i2 = [Me] : i2.push(Me));
                      }
                  }
                return i2;
              }
              function _g(r2, i2) {
                Xr(r2, e2.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, Ot(i2, void 0, 2));
              }
              function Qc(r2) {
                if (!r2.baseTypesResolved) {
                  if (yu(r2, 7) && (r2.objectFlags & 8 ? r2.resolvedBaseTypes = [Lm(r2)] : r2.symbol.flags & 96 ? (r2.symbol.flags & 32 && Up(r2), r2.symbol.flags & 64 && It(r2)) : e2.Debug.fail("type must be class or interface"), !fi() && r2.symbol.declarations))
                    for (var i2 = 0, t2 = r2.symbol.declarations; i2 < t2.length; i2++) {
                      var o = t2[i2];
                      (o.kind === 257 || o.kind === 258) && _g(o, r2);
                    }
                  r2.baseTypesResolved = true;
                }
                return r2.resolvedBaseTypes;
              }
              function Lm(r2) {
                var i2 = e2.sameMap(r2.typeParameters, function(t2, o) {
                  return r2.elementFlags[o] & 8 ? Jc(t2, nt) : t2;
                });
                return Zs(Pa(i2 || e2.emptyArray), r2.readonly);
              }
              function Up(r2) {
                r2.resolvedBaseTypes = e2.resolvingEmptyArray;
                var i2 = $s(Bl(r2));
                if (!(i2.flags & 2621441))
                  return r2.resolvedBaseTypes = e2.emptyArray;
                var t2 = fg(r2), o, s2 = i2.symbol ? go(i2.symbol) : void 0;
                if (i2.symbol && i2.symbol.flags & 32 && Rm(s2))
                  o = lx(t2, i2.symbol);
                else if (i2.flags & 1)
                  o = i2;
                else {
                  var u = Xg(i2, t2.typeArguments, t2);
                  if (!u.length)
                    return Xr(t2.expression, e2.Diagnostics.No_base_constructor_has_the_specified_number_of_type_arguments), r2.resolvedBaseTypes = e2.emptyArray;
                  o = yo(u[0]);
                }
                if (nn(o))
                  return r2.resolvedBaseTypes = e2.emptyArray;
                var h2 = bu(o);
                if (!ff(h2)) {
                  var z = ei(void 0, o), me = e2.chainDiagnosticMessages(z, e2.Diagnostics.Base_constructor_return_type_0_is_not_an_object_type_or_intersection_of_object_types_with_statically_known_members, Ot(h2));
                  return rn.add(e2.createDiagnosticForNodeFromMessageChain(t2.expression, me)), r2.resolvedBaseTypes = e2.emptyArray;
                }
                return r2 === h2 || lf(h2, r2) ? (Xr(r2.symbol.valueDeclaration, e2.Diagnostics.Type_0_recursively_references_itself_as_a_base_type, Ot(r2, void 0, 2)), r2.resolvedBaseTypes = e2.emptyArray) : (r2.resolvedBaseTypes === e2.resolvingEmptyArray && (r2.members = void 0), r2.resolvedBaseTypes = [h2]);
              }
              function Rm(r2) {
                var i2 = r2.outerTypeParameters;
                if (i2) {
                  var t2 = i2.length - 1, o = xo(r2);
                  return i2[t2].symbol !== o[t2].symbol;
                }
                return true;
              }
              function ff(r2) {
                if (r2.flags & 262144) {
                  var i2 = uc(r2);
                  if (i2)
                    return ff(i2);
                }
                return !!(r2.flags & 67633153 && !Bc(r2) || r2.flags & 2097152 && e2.every(r2.types, ff));
              }
              function It(r2) {
                if (r2.resolvedBaseTypes = r2.resolvedBaseTypes || e2.emptyArray, r2.symbol.declarations)
                  for (var i2 = 0, t2 = r2.symbol.declarations; i2 < t2.length; i2++) {
                    var o = t2[i2];
                    if (o.kind === 258 && e2.getInterfaceBaseTypeNodes(o))
                      for (var s2 = 0, u = e2.getInterfaceBaseTypeNodes(o); s2 < u.length; s2++) {
                        var h2 = u[s2], z = bu(Va(h2));
                        nn(z) || (ff(z) ? r2 !== z && !lf(z, r2) ? r2.resolvedBaseTypes === e2.emptyArray ? r2.resolvedBaseTypes = [z] : r2.resolvedBaseTypes.push(z) : _g(o, r2) : Xr(h2, e2.Diagnostics.An_interface_can_only_extend_an_object_type_or_intersection_of_object_types_with_statically_known_members));
                      }
                  }
              }
              function Ma(r2) {
                if (!r2.declarations)
                  return true;
                for (var i2 = 0, t2 = r2.declarations; i2 < t2.length; i2++) {
                  var o = t2[i2];
                  if (o.kind === 258) {
                    if (o.flags & 128)
                      return false;
                    var s2 = e2.getInterfaceBaseTypeNodes(o);
                    if (s2)
                      for (var u = 0, h2 = s2; u < h2.length; u++) {
                        var z = h2[u];
                        if (e2.isEntityNameExpression(z.expression)) {
                          var me = Ds(z.expression, 788968, true);
                          if (!me || !(me.flags & 64) || aa(me).thisType)
                            return false;
                        }
                      }
                  }
                }
                return true;
              }
              function aa(r2) {
                var i2 = Aa(r2), t2 = i2;
                if (!i2.declaredType) {
                  var o = r2.flags & 32 ? 1 : 2, s2 = iS(r2, r2.valueDeclaration && F7(r2.valueDeclaration));
                  s2 && (r2 = i2 = s2);
                  var u = t2.declaredType = i2.declaredType = tu(o, r2), h2 = Gg(r2), z = Af(r2);
                  (h2 || z || o === 1 || !Ma(r2)) && (u.objectFlags |= 4, u.typeParameters = e2.concatenate(h2, z), u.outerTypeParameters = h2, u.localTypeParameters = z, u.instantiations = new e2.Map(), u.instantiations.set(Su(u.typeParameters), u), u.target = u, u.resolvedTypeArguments = u.typeParameters, u.thisType = Hc(r2), u.thisType.isThisType = true, u.thisType.constraint = u);
                }
                return i2.declaredType;
              }
              function Ja(r2) {
                var i2, t2 = Aa(r2);
                if (!t2.declaredType) {
                  if (!yu(r2, 2))
                    return Pe;
                  var o = e2.Debug.checkDefined((i2 = r2.declarations) === null || i2 === void 0 ? void 0 : i2.find(e2.isTypeAlias), "Type alias symbol with no valid declaration found"), s2 = e2.isJSDocTypeAlias(o) ? o.typeExpression : o.type, u = s2 ? Va(s2) : Pe;
                  if (fi()) {
                    var h2 = Af(r2);
                    h2 && (t2.typeParameters = h2, t2.instantiations = new e2.Map(), t2.instantiations.set(Su(h2), u));
                  } else
                    u = Pe, o.kind === 339 ? Xr(o.typeExpression.type, e2.Diagnostics.Type_alias_0_circularly_references_itself, tn(r2)) : Xr(e2.isNamedDeclaration(o) ? o.name : o || o, e2.Diagnostics.Type_alias_0_circularly_references_itself, tn(r2));
                  t2.declaredType = u;
                }
                return t2.declaredType;
              }
              function _n(r2) {
                return e2.isStringLiteralLike(r2) ? true : r2.kind === 221 ? _n(r2.left) && _n(r2.right) : false;
              }
              function ro(r2) {
                var i2 = r2.initializer;
                if (!i2)
                  return !(r2.flags & 16777216);
                switch (i2.kind) {
                  case 10:
                  case 8:
                  case 14:
                    return true;
                  case 219:
                    return i2.operator === 40 && i2.operand.kind === 8;
                  case 79:
                    return e2.nodeIsMissing(i2) || !!Et(r2.parent).exports.get(i2.escapedText);
                  case 221:
                    return _n(i2);
                  default:
                    return false;
                }
              }
              function as(r2) {
                var i2 = Aa(r2);
                if (i2.enumKind !== void 0)
                  return i2.enumKind;
                var t2 = false;
                if (r2.declarations)
                  for (var o = 0, s2 = r2.declarations; o < s2.length; o++) {
                    var u = s2[o];
                    if (u.kind === 260)
                      for (var h2 = 0, z = u.members; h2 < z.length; h2++) {
                        var me = z[h2];
                        if (me.initializer && e2.isStringLiteralLike(me.initializer))
                          return i2.enumKind = 1;
                        ro(me) || (t2 = true);
                      }
                  }
                return i2.enumKind = t2 ? 0 : 1;
              }
              function cc(r2) {
                return r2.flags & 1024 && !(r2.flags & 1048576) ? go(Ys(r2.symbol)) : r2;
              }
              function Sc(r2) {
                var i2 = Aa(r2);
                if (i2.declaredType)
                  return i2.declaredType;
                if (as(r2) === 1) {
                  Re++;
                  var t2 = [];
                  if (r2.declarations)
                    for (var o = 0, s2 = r2.declarations; o < s2.length; o++) {
                      var u = s2[o];
                      if (u.kind === 260)
                        for (var h2 = 0, z = u.members; h2 < z.length; h2++) {
                          var me = z[h2], Me = H0(me), $e = Sg(NI(Me !== void 0 ? Me : 0, Re, Et(me)));
                          Aa(Et(me)).declaredType = $e, t2.push(jc($e));
                        }
                    }
                  if (t2.length) {
                    var tr = Pa(t2, 1, r2, void 0);
                    return tr.flags & 1048576 && (tr.flags |= 1024, tr.symbol = r2), i2.declaredType = tr;
                  }
                }
                var dr = mc(32);
                return dr.symbol = r2, i2.declaredType = dr;
              }
              function hu(r2) {
                var i2 = Aa(r2);
                if (!i2.declaredType) {
                  var t2 = Sc(Ys(r2));
                  i2.declaredType || (i2.declaredType = t2);
                }
                return i2.declaredType;
              }
              function Js(r2) {
                var i2 = Aa(r2);
                return i2.declaredType || (i2.declaredType = Hc(r2));
              }
              function Qf(r2) {
                var i2 = Aa(r2);
                return i2.declaredType || (i2.declaredType = go(Ps(r2)));
              }
              function go(r2) {
                return Vd(r2) || Pe;
              }
              function Vd(r2) {
                if (r2.flags & 96)
                  return aa(r2);
                if (r2.flags & 524288)
                  return Ja(r2);
                if (r2.flags & 262144)
                  return Js(r2);
                if (r2.flags & 384)
                  return Sc(r2);
                if (r2.flags & 8)
                  return hu(r2);
                if (r2.flags & 2097152)
                  return Qf(r2);
              }
              function X_(r2) {
                switch (r2.kind) {
                  case 130:
                  case 155:
                  case 150:
                  case 147:
                  case 158:
                  case 133:
                  case 151:
                  case 148:
                  case 114:
                  case 153:
                  case 143:
                  case 196:
                    return true;
                  case 183:
                    return X_(r2.elementType);
                  case 178:
                    return !r2.typeArguments || r2.typeArguments.every(X_);
                }
                return false;
              }
              function Sd(r2) {
                var i2 = e2.getEffectiveConstraintOfTypeParameter(r2);
                return !i2 || X_(i2);
              }
              function Yg(r2) {
                var i2 = e2.getEffectiveTypeAnnotationNode(r2);
                return i2 ? X_(i2) : !e2.hasInitializer(r2);
              }
              function N1(r2) {
                var i2 = e2.getEffectiveReturnTypeNode(r2), t2 = e2.getEffectiveTypeParameterDeclarations(r2);
                return (r2.kind === 171 || !!i2 && X_(i2)) && r2.parameters.every(Yg) && t2.every(Sd);
              }
              function P1(r2) {
                if (r2.declarations && r2.declarations.length === 1) {
                  var i2 = r2.declarations[0];
                  if (i2)
                    switch (i2.kind) {
                      case 167:
                      case 166:
                        return Yg(i2);
                      case 169:
                      case 168:
                      case 171:
                      case 172:
                      case 173:
                        return N1(i2);
                    }
                }
                return false;
              }
              function Yy(r2, i2, t2) {
                for (var o = e2.createSymbolTable(), s2 = 0, u = r2; s2 < u.length; s2++) {
                  var h2 = u[s2];
                  o.set(h2.escapedName, t2 && P1(h2) ? h2 : AD(h2, i2));
                }
                return o;
              }
              function Bm(r2, i2) {
                for (var t2 = 0, o = i2; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  !r2.has(s2.escapedName) && !$y(s2) && r2.set(s2.escapedName, s2);
                }
              }
              function $y(r2) {
                return !!r2.valueDeclaration && e2.isPrivateIdentifierClassElementDeclaration(r2.valueDeclaration) && e2.isStatic(r2.valueDeclaration);
              }
              function Lv(r2) {
                if (!r2.declaredProperties) {
                  var i2 = r2.symbol, t2 = Nf(i2);
                  r2.declaredProperties = tf(t2), r2.declaredCallSignatures = e2.emptyArray, r2.declaredConstructSignatures = e2.emptyArray, r2.declaredIndexInfos = e2.emptyArray, r2.declaredCallSignatures = S_(t2.get("__call")), r2.declaredConstructSignatures = S_(t2.get("__new")), r2.declaredIndexInfos = ax(i2);
                }
                return r2;
              }
              function _f(r2) {
                return !!(r2.flags & 8576);
              }
              function Rv(r2) {
                if (!e2.isComputedPropertyName(r2) && !e2.isElementAccessExpression(r2))
                  return false;
                var i2 = e2.isComputedPropertyName(r2) ? r2.expression : r2.argumentExpression;
                return e2.isEntityNameExpression(i2) && _f(e2.isComputedPropertyName(r2) ? t_(r2) : Os(i2));
              }
              function pg(r2) {
                return r2.charCodeAt(0) === 95 && r2.charCodeAt(1) === 95 && r2.charCodeAt(2) === 64;
              }
              function $g(r2) {
                var i2 = e2.getNameOfDeclaration(r2);
                return !!i2 && Rv(i2);
              }
              function Td(r2) {
                return !e2.hasDynamicName(r2) || $g(r2);
              }
              function I1(r2) {
                return e2.isDynamicName(r2) && !Rv(r2);
              }
              function pf(r2) {
                return r2.flags & 8192 ? r2.escapedName : r2.flags & 384 ? e2.escapeLeadingUnderscores("" + r2.value) : e2.Debug.fail();
              }
              function Bv(r2, i2, t2) {
                e2.Debug.assert(!!(e2.getCheckFlags(r2) & 4096), "Expected a late-bound symbol."), r2.flags |= t2, Aa(i2.symbol).lateSymbol = r2, r2.declarations ? i2.symbol.isReplaceableByMethod || r2.declarations.push(i2) : r2.declarations = [i2], t2 & 111551 && (!r2.valueDeclaration || r2.valueDeclaration.kind !== i2.kind) && (r2.valueDeclaration = i2);
              }
              function Zy(r2, i2, t2, o) {
                e2.Debug.assert(!!o.symbol, "The member is expected to have a symbol.");
                var s2 = va(o);
                if (!s2.resolvedSymbol) {
                  s2.resolvedSymbol = o.symbol;
                  var u = e2.isBinaryExpression(o) ? o.left : o.name, h2 = e2.isElementAccessExpression(u) ? Os(u.argumentExpression) : t_(u);
                  if (_f(h2)) {
                    var z = pf(h2), me = o.symbol.flags, Me = t2.get(z);
                    Me || t2.set(z, Me = oo(0, z, 4096));
                    var $e = i2 && i2.get(z);
                    if (Me.flags & I_(me) || $e) {
                      var tr = $e ? e2.concatenate($e.declarations, Me.declarations) : Me.declarations, dr = !(h2.flags & 8192) && e2.unescapeLeadingUnderscores(z) || e2.declarationNameToString(u);
                      e2.forEach(tr, function(Dr) {
                        return Xr(e2.getNameOfDeclaration(Dr) || Dr, e2.Diagnostics.Property_0_was_also_declared_here, dr);
                      }), Xr(u || o, e2.Diagnostics.Duplicate_property_0, dr), Me = oo(0, z, 4096);
                    }
                    return Me.nameType = h2, Bv(Me, o, me), Me.parent ? e2.Debug.assert(Me.parent === r2, "Existing symbol parent should match new one") : Me.parent = r2, s2.resolvedSymbol = Me;
                  }
                }
                return s2.resolvedSymbol;
              }
              function Jv(r2, i2) {
                var t2 = Aa(r2);
                if (!t2[i2]) {
                  var o = i2 === "resolvedExports", s2 = o ? r2.flags & 1536 ? Iu(r2) : r2.exports : r2.members;
                  t2[i2] = s2 || we;
                  for (var u = e2.createSymbolTable(), h2 = 0, z = r2.declarations || e2.emptyArray; h2 < z.length; h2++) {
                    var me = z[h2], Me = e2.getMembersOfDeclaration(me);
                    if (Me)
                      for (var $e = 0, tr = Me; $e < tr.length; $e++) {
                        var dr = tr[$e];
                        o === e2.hasStaticModifier(dr) && $g(dr) && Zy(r2, s2, u, dr);
                      }
                  }
                  var Dr = r2.assignmentDeclarationMembers;
                  if (Dr)
                    for (var Qr = e2.arrayFrom(Dr.values()), li = 0, Ti = Qr; li < Ti.length; li++) {
                      var dr = Ti[li], Ci = e2.getAssignmentDeclarationKind(dr), $i = Ci === 3 || e2.isBinaryExpression(dr) && s0(dr, Ci) || Ci === 9 || Ci === 6;
                      o === !$i && $g(dr) && Zy(r2, s2, u, dr);
                    }
                  t2[i2] = hp(s2, u) || we;
                }
                return t2[i2];
              }
              function Nf(r2) {
                return r2.flags & 6256 ? Jv(r2, "resolvedMembers") : r2.members || we;
              }
              function dg(r2) {
                if (r2.flags & 106500 && r2.escapedName === "__computed") {
                  var i2 = Aa(r2);
                  if (!i2.lateSymbol && e2.some(r2.declarations, $g)) {
                    var t2 = so(r2.parent);
                    e2.some(r2.declarations, e2.hasStaticModifier) ? dc(t2) : Nf(t2);
                  }
                  return i2.lateSymbol || (i2.lateSymbol = r2);
                }
                return r2;
              }
              function Rc(r2, i2, t2) {
                if (e2.getObjectFlags(r2) & 4) {
                  var o = r2.target, s2 = xo(r2);
                  if (e2.length(o.typeParameters) === e2.length(s2)) {
                    var u = Yf(o, e2.concatenate(s2, [i2 || o.thisType]));
                    return t2 ? $s(u) : u;
                  }
                } else if (r2.flags & 2097152) {
                  var h2 = e2.sameMap(r2.types, function(z) {
                    return Rc(z, i2, t2);
                  });
                  return h2 !== r2.types ? Do(h2) : r2;
                }
                return t2 ? $s(r2) : r2;
              }
              function jv(r2, i2, t2, o) {
                var s2, u, h2, z, me;
                e2.rangeEquals(t2, o, 0, t2.length) ? (u = i2.symbol ? Nf(i2.symbol) : e2.createSymbolTable(i2.declaredProperties), h2 = i2.declaredCallSignatures, z = i2.declaredConstructSignatures, me = i2.declaredIndexInfos) : (s2 = Uc(t2, o), u = Yy(i2.declaredProperties, s2, t2.length === 1), h2 = Ah(i2.declaredCallSignatures, s2), z = Ah(i2.declaredConstructSignatures, s2), me = oE(i2.declaredIndexInfos, s2));
                var Me = Qc(i2);
                if (Me.length) {
                  i2.symbol && u === Nf(i2.symbol) && (u = e2.createSymbolTable(i2.declaredProperties)), Oc(r2, u, h2, z, me);
                  for (var $e = e2.lastOrUndefined(o), tr = 0, dr = Me; tr < dr.length; tr++) {
                    var Dr = dr[tr], Qr = $e ? Rc(un(Dr, s2), $e) : Dr;
                    Bm(u, uo(Qr)), h2 = e2.concatenate(h2, ot(Qr, 0)), z = e2.concatenate(z, ot(Qr, 1));
                    var li = Qr !== Oe ? Hn(Qr) : [zl(Li, Oe, false)];
                    me = e2.concatenate(me, e2.filter(li, function(Ti) {
                      return !xa(me, Ti.keyType);
                    }));
                  }
                }
                Oc(r2, u, h2, z, me);
              }
              function eh(r2) {
                jv(r2, Lv(r2), e2.emptyArray, e2.emptyArray);
              }
              function rh(r2) {
                var i2 = Lv(r2.target), t2 = e2.concatenate(i2.typeParameters, [i2.thisType]), o = xo(r2), s2 = o.length === t2.length ? o : e2.concatenate(o, [r2]);
                jv(r2, i2, t2, s2);
              }
              function Fu(r2, i2, t2, o, s2, u, h2, z) {
                var me = new Z2(Di, z);
                return me.declaration = r2, me.typeParameters = i2, me.parameters = o, me.thisParameter = t2, me.resolvedReturnType = s2, me.resolvedTypePredicate = u, me.minArgumentCount = h2, me.resolvedMinArgumentCount = void 0, me.target = void 0, me.mapper = void 0, me.compositeSignatures = void 0, me.compositeKind = void 0, me;
              }
              function xd(r2) {
                var i2 = Fu(r2.declaration, r2.typeParameters, r2.thisParameter, r2.parameters, void 0, void 0, r2.minArgumentCount, r2.flags & 39);
                return i2.target = r2.target, i2.mapper = r2.mapper, i2.compositeSignatures = r2.compositeSignatures, i2.compositeKind = r2.compositeKind, i2;
              }
              function Uv(r2, i2) {
                var t2 = xd(r2);
                return t2.compositeSignatures = i2, t2.compositeKind = 1048576, t2.target = void 0, t2.mapper = void 0, t2;
              }
              function w1(r2, i2) {
                if ((r2.flags & 24) === i2)
                  return r2;
                r2.optionalCallSignatureCache || (r2.optionalCallSignatureCache = {});
                var t2 = i2 === 8 ? "inner" : "outer";
                return r2.optionalCallSignatureCache[t2] || (r2.optionalCallSignatureCache[t2] = ih(r2, i2));
              }
              function ih(r2, i2) {
                e2.Debug.assert(i2 === 8 || i2 === 16, "An optional call signature can either be for an inner call chain or an outer call chain, but not both.");
                var t2 = xd(r2);
                return t2.flags |= i2, t2;
              }
              function Jm(r2, i2) {
                if (H(r2)) {
                  var t2 = r2.parameters.length - 1, o = Jt(r2.parameters[t2]);
                  if (Yn(o))
                    return [s2(o, t2)];
                  if (!i2 && o.flags & 1048576 && e2.every(o.types, Yn))
                    return e2.map(o.types, function(u) {
                      return s2(u, t2);
                    });
                }
                return [r2.parameters];
                function s2(u, h2) {
                  var z = xo(u), me = u.target.labeledElementDeclarations, Me = e2.map(z, function($e, tr) {
                    var dr = !!me && E0(me[tr]), Dr = dr || vm(r2, h2 + tr, u), Qr = u.target.elementFlags[tr], li = Qr & 12 ? 32768 : Qr & 2 ? 16384 : 0, Ti = oo(1, Dr, li);
                    return Ti.type = Qr & 4 ? Zs($e) : $e, Ti;
                  });
                  return e2.concatenate(r2.parameters.slice(0, h2), Me);
                }
              }
              function th(r2) {
                var i2 = Bl(r2), t2 = ot(i2, 1), o = e2.getClassLikeDeclarationOfSymbol(r2.symbol), s2 = !!o && e2.hasSyntacticModifier(o, 128);
                if (t2.length === 0)
                  return [Fu(void 0, r2.localTypeParameters, void 0, e2.emptyArray, r2, void 0, 0, s2 ? 4 : 0)];
                for (var u = fg(r2), h2 = e2.isInJSFile(u), z = bh(u), me = e2.length(z), Me = [], $e = 0, tr = t2; $e < tr.length; $e++) {
                  var dr = tr[$e], Dr = Ul(dr.typeParameters), Qr = e2.length(dr.typeParameters);
                  if (h2 || me >= Dr && me <= Qr) {
                    var li = Qr ? mh(dr, zp(z, dr.typeParameters, Dr, h2)) : xd(dr);
                    li.typeParameters = r2.localTypeParameters, li.resolvedReturnType = r2, li.flags = s2 ? li.flags | 4 : li.flags & -5, Me.push(li);
                  }
                }
                return Me;
              }
              function gg(r2, i2, t2, o, s2) {
                for (var u = 0, h2 = r2; u < h2.length; u++) {
                  var z = h2[u];
                  if (_y(z, i2, t2, o, s2, t2 ? XI : av))
                    return z;
                }
              }
              function O1(r2, i2, t2) {
                if (i2.typeParameters) {
                  if (t2 > 0)
                    return;
                  for (var o = 1; o < r2.length; o++)
                    if (!gg(r2[o], i2, false, false, false))
                      return;
                  return [i2];
                }
                for (var s2, o = 0; o < r2.length; o++) {
                  var u = o === t2 ? i2 : gg(r2[o], i2, true, false, true);
                  if (!u)
                    return;
                  s2 = e2.appendIfUnique(s2, u);
                }
                return s2;
              }
              function zv(r2) {
                for (var i2, t2, o = 0; o < r2.length; o++) {
                  if (r2[o].length === 0)
                    return e2.emptyArray;
                  r2[o].length > 1 && (t2 = t2 === void 0 ? o : -1);
                  for (var s2 = 0, u = r2[o]; s2 < u.length; s2++) {
                    var h2 = u[s2];
                    if (!i2 || !gg(i2, h2, false, false, true)) {
                      var z = O1(r2, h2, o);
                      if (z) {
                        var me = h2;
                        if (z.length > 1) {
                          var Me = h2.thisParameter, $e = e2.forEach(z, function(Zi) {
                            return Zi.thisParameter;
                          });
                          if ($e) {
                            var tr = Do(e2.mapDefined(z, function(Zi) {
                              return Zi.thisParameter && Jt(Zi.thisParameter);
                            }));
                            Me = eg($e, tr);
                          }
                          me = Uv(h2, z), me.thisParameter = Me;
                        }
                        (i2 || (i2 = [])).push(me);
                      }
                    }
                  }
                }
                if (!e2.length(i2) && t2 !== -1) {
                  for (var dr = r2[t2 !== void 0 ? t2 : 0], Dr = dr.slice(), Qr = function(Zi) {
                    if (Zi !== dr) {
                      var qt = Zi[0];
                      if (e2.Debug.assert(!!qt, "getUnionSignatures bails early on empty signature lists and should not have empty lists on second pass"), Dr = !!qt.typeParameters && e2.some(Dr, function(Nt) {
                        return !!Nt.typeParameters && !ah(qt.typeParameters, Nt.typeParameters);
                      }) ? void 0 : e2.map(Dr, function(Nt) {
                        return M1(Nt, qt);
                      }), !Dr)
                        return "break";
                    }
                  }, li = 0, Ti = r2; li < Ti.length; li++) {
                    var Ci = Ti[li], $i = Qr(Ci);
                    if ($i === "break")
                      break;
                  }
                  i2 = Dr;
                }
                return i2 || e2.emptyArray;
              }
              function ah(r2, i2) {
                if (e2.length(r2) !== e2.length(i2))
                  return false;
                if (!r2 || !i2)
                  return true;
                for (var t2 = Uc(i2, r2), o = 0; o < r2.length; o++) {
                  var s2 = r2[o], u = i2[o];
                  if (s2 !== u && !wf(tm(s2) || gr, un(tm(u) || gr, t2)))
                    return false;
                }
                return true;
              }
              function F1(r2, i2, t2) {
                if (!r2 || !i2)
                  return r2 || i2;
                var o = Do([Jt(r2), un(Jt(i2), t2)]);
                return eg(r2, o);
              }
              function nh(r2, i2, t2) {
                for (var o = Wc(r2), s2 = Wc(i2), u = o >= s2 ? r2 : i2, h2 = u === r2 ? i2 : r2, z = u === r2 ? o : s2, me = Xl(r2) || Xl(i2), Me = me && !Xl(u), $e = new Array(z + (Me ? 1 : 0)), tr = 0; tr < z; tr++) {
                  var dr = Ld(u, tr);
                  u === i2 && (dr = un(dr, t2));
                  var Dr = Ld(h2, tr) || gr;
                  h2 === i2 && (Dr = un(Dr, t2));
                  var Qr = Do([dr, Dr]), li = me && !Me && tr === z - 1, Ti = tr >= Hl(u) && tr >= Hl(h2), Ci = tr >= o ? void 0 : vm(r2, tr), $i = tr >= s2 ? void 0 : vm(i2, tr), Zi = Ci === $i ? Ci : Ci ? $i ? void 0 : Ci : $i, qt = oo(1 | (Ti && !li ? 16777216 : 0), Zi || "arg".concat(tr));
                  qt.type = li ? Zs(Qr) : Qr, $e[tr] = qt;
                }
                if (Me) {
                  var Nt = oo(1, "args");
                  Nt.type = Zs($u(h2, z)), h2 === i2 && (Nt.type = un(Nt.type, t2)), $e[z] = Nt;
                }
                return $e;
              }
              function M1(r2, i2) {
                var t2 = r2.typeParameters || i2.typeParameters, o;
                r2.typeParameters && i2.typeParameters && (o = Uc(i2.typeParameters, r2.typeParameters));
                var s2 = r2.declaration, u = nh(r2, i2, o), h2 = F1(r2.thisParameter, i2.thisParameter, o), z = Math.max(r2.minArgumentCount, i2.minArgumentCount), me = Fu(s2, t2, h2, u, void 0, void 0, z, (r2.flags | i2.flags) & 39);
                return me.compositeKind = 1048576, me.compositeSignatures = e2.concatenate(r2.compositeKind !== 2097152 && r2.compositeSignatures || [r2], [i2]), o && (me.mapper = r2.compositeKind !== 2097152 && r2.mapper && r2.compositeSignatures ? np(r2.mapper, o) : o), me;
              }
              function oh(r2) {
                var i2 = Hn(r2[0]);
                if (i2) {
                  for (var t2 = [], o = function(z) {
                    var me = z.keyType;
                    e2.every(r2, function(Me) {
                      return !!ss(Me, me);
                    }) && t2.push(zl(me, Pa(e2.map(r2, function(Me) {
                      return cs(Me, me);
                    })), e2.some(r2, function(Me) {
                      return ss(Me, me).isReadonly;
                    })));
                  }, s2 = 0, u = i2; s2 < u.length; s2++) {
                    var h2 = u[s2];
                    o(h2);
                  }
                  return t2;
                }
                return e2.emptyArray;
              }
              function jm(r2) {
                var i2 = zv(e2.map(r2.types, function(s2) {
                  return s2 === br ? [Wn] : ot(s2, 0);
                })), t2 = zv(e2.map(r2.types, function(s2) {
                  return ot(s2, 1);
                })), o = oh(r2.types);
                Oc(r2, we, i2, t2, o);
              }
              function Zg(r2, i2) {
                return r2 ? i2 ? Do([r2, i2]) : r2 : i2;
              }
              function Wv(r2) {
                var i2 = e2.countWhere(r2, function(s2) {
                  return ot(s2, 1).length > 0;
                }), t2 = e2.map(r2, Wd);
                if (i2 > 0 && i2 === e2.countWhere(t2, function(s2) {
                  return s2;
                })) {
                  var o = t2.indexOf(true);
                  t2[o] = false;
                }
                return t2;
              }
              function sh(r2, i2, t2, o) {
                for (var s2 = [], u = 0; u < i2.length; u++)
                  u === o ? s2.push(r2) : t2[u] && s2.push(yo(ot(i2[u], 1)[0]));
                return Do(s2);
              }
              function L1(r2) {
                for (var i2, t2, o, s2 = r2.types, u = Wv(s2), h2 = e2.countWhere(u, function(Me) {
                  return Me;
                }), z = function(Me) {
                  var $e = r2.types[Me];
                  if (!u[Me]) {
                    var tr = ot($e, 1);
                    tr.length && h2 > 0 && (tr = e2.map(tr, function(dr) {
                      var Dr = xd(dr);
                      return Dr.resolvedReturnType = sh(yo(dr), s2, u, Me), Dr;
                    })), t2 = ch(t2, tr);
                  }
                  i2 = ch(i2, ot($e, 0)), o = e2.reduceLeft(Hn($e), function(dr, Dr) {
                    return uh(dr, Dr, false);
                  }, o);
                }, me = 0; me < s2.length; me++)
                  z(me);
                Oc(r2, we, i2 || e2.emptyArray, t2 || e2.emptyArray, o || e2.emptyArray);
              }
              function ch(r2, i2) {
                for (var t2 = function(h2) {
                  (!r2 || e2.every(r2, function(z) {
                    return !_y(z, h2, false, false, false, av);
                  })) && (r2 = e2.append(r2, h2));
                }, o = 0, s2 = i2; o < s2.length; o++) {
                  var u = s2[o];
                  t2(u);
                }
                return r2;
              }
              function uh(r2, i2, t2) {
                if (r2)
                  for (var o = 0; o < r2.length; o++) {
                    var s2 = r2[o];
                    if (s2.keyType === i2.keyType)
                      return r2[o] = zl(s2.keyType, t2 ? Pa([s2.type, i2.type]) : Do([s2.type, i2.type]), t2 ? s2.isReadonly || i2.isReadonly : s2.isReadonly && i2.isReadonly), r2;
                  }
                return e2.append(r2, i2);
              }
              function R1(r2) {
                if (r2.target) {
                  Oc(r2, we, e2.emptyArray, e2.emptyArray, e2.emptyArray);
                  var i2 = Yy(Pf(r2.target), r2.mapper, false), t2 = Ah(ot(r2.target, 0), r2.mapper), o = Ah(ot(r2.target, 1), r2.mapper), s2 = oE(Hn(r2.target), r2.mapper);
                  Oc(r2, i2, t2, o, s2);
                  return;
                }
                var u = so(r2.symbol);
                if (u.flags & 2048) {
                  Oc(r2, we, e2.emptyArray, e2.emptyArray, e2.emptyArray);
                  var h2 = Nf(u), t2 = S_(h2.get("__call")), o = S_(h2.get("__new")), z = ax(u);
                  Oc(r2, h2, t2, o, z);
                  return;
                }
                var me = we, Me;
                if (u.exports && (me = dc(u), u === pe)) {
                  var $e = new e2.Map();
                  me.forEach(function(Ti) {
                    var Ci;
                    !(Ti.flags & 418) && !(Ti.flags & 512 && ((Ci = Ti.declarations) === null || Ci === void 0 ? void 0 : Ci.length) && e2.every(Ti.declarations, e2.isAmbientModule)) && $e.set(Ti.escapedName, Ti);
                  }), me = $e;
                }
                var tr;
                if (Oc(r2, me, e2.emptyArray, e2.emptyArray, e2.emptyArray), u.flags & 32) {
                  var dr = aa(u), Dr = Bl(dr);
                  Dr.flags & 11272192 ? (me = e2.createSymbolTable(z_(me)), Bm(me, uo(Dr))) : Dr === Oe && (tr = zl(Li, Oe, false));
                }
                var Qr = rD(me);
                if (Qr ? Me = nx(Qr) : (tr && (Me = e2.append(Me, tr)), u.flags & 384 && (go(u).flags & 32 || e2.some(r2.properties, function(Ti) {
                  return !!(Jt(Ti).flags & 296);
                })) && (Me = e2.append(Me, Ko))), Oc(r2, me, e2.emptyArray, e2.emptyArray, Me || e2.emptyArray), u.flags & 8208 && (r2.callSignatures = S_(u)), u.flags & 32) {
                  var li = aa(u), o = u.members ? S_(u.members.get("__constructor")) : e2.emptyArray;
                  u.flags & 16 && (o = e2.addRange(o.slice(), e2.mapDefined(r2.callSignatures, function(Ci) {
                    return Sl(Ci.declaration) ? Fu(Ci.declaration, Ci.typeParameters, Ci.thisParameter, Ci.parameters, li, void 0, Ci.minArgumentCount, Ci.flags & 39) : void 0;
                  }))), o.length || (o = th(li)), r2.constructSignatures = o;
                }
              }
              function lh(r2, i2, t2) {
                return un(r2, Uc([i2.indexType, i2.objectType], [If(0), Wl([t2])]));
              }
              function B1(r2) {
                for (var i2 = ss(r2.source, Li), t2 = Lu(r2.mappedType), o = !(t2 & 1), s2 = t2 & 4 ? 0 : 16777216, u = i2 ? [zl(Li, Hh(i2.type, r2.mappedType, r2.constraintType), o && i2.isReadonly)] : e2.emptyArray, h2 = e2.createSymbolTable(), z = 0, me = uo(r2.source); z < me.length; z++) {
                  var Me = me[z], $e = 8192 | (o && Zu(Me) ? 8 : 0), tr = oo(4 | Me.flags & s2, Me.escapedName, $e);
                  if (tr.declarations = Me.declarations, tr.nameType = Aa(Me).nameType, tr.propertyType = Jt(Me), r2.constraintType.type.flags & 8388608 && r2.constraintType.type.objectType.flags & 262144 && r2.constraintType.type.indexType.flags & 262144) {
                    var dr = r2.constraintType.type.objectType, Dr = lh(r2.mappedType, r2.constraintType.type, dr);
                    tr.mappedType = Dr, tr.constraintType = ql(dr);
                  } else
                    tr.mappedType = r2.mappedType, tr.constraintType = r2.constraintType;
                  h2.set(Me.escapedName, tr);
                }
                Oc(r2, h2, e2.emptyArray, e2.emptyArray, u);
              }
              function Kd(r2) {
                if (r2.flags & 4194304) {
                  var i2 = $s(r2.type);
                  return lm(i2) ? Mx(i2) : ql(i2);
                }
                if (r2.flags & 16777216) {
                  if (r2.root.isDistributive) {
                    var t2 = r2.checkType, o = Kd(t2);
                    if (o !== t2)
                      return ID(r2, $d(r2.root.checkType, o, r2.mapper));
                  }
                  return r2;
                }
                return r2.flags & 1048576 ? Ss(r2, Kd) : r2.flags & 2097152 ? Do(e2.sameMap(r2.types, Kd)) : r2;
              }
              function Gd(r2) {
                return e2.getCheckFlags(r2) & 4096;
              }
              function Um(r2, i2, t2, o) {
                for (var s2 = 0, u = uo(r2); s2 < u.length; s2++) {
                  var h2 = u[s2];
                  o(om(h2, i2));
                }
                if (r2.flags & 1)
                  o(Li);
                else
                  for (var z = 0, me = Hn(r2); z < me.length; z++) {
                    var Me = me[z];
                    (!t2 || Me.keyType.flags & 134217732) && o(Me.keyType);
                  }
              }
              function fh(r2) {
                var i2 = e2.createSymbolTable(), t2;
                Oc(r2, we, e2.emptyArray, e2.emptyArray, e2.emptyArray);
                var o = Du(r2), s2 = Mu(r2), u = Jl(r2.target || r2), h2 = vl(r2.target || r2), z = $s(Ed(r2)), me = Lu(r2), Me = Ge ? 128 : 8576;
                mg(r2) ? Um(z, Me, Ge, $e) : Od(Kd(s2), $e), Oc(r2, i2, e2.emptyArray, e2.emptyArray, t2 || e2.emptyArray);
                function $e(dr) {
                  var Dr = u ? un(u, tv(r2.mapper, o, dr)) : dr;
                  Od(Dr, function(Qr) {
                    return tr(dr, Qr);
                  });
                }
                function tr(dr, Dr) {
                  if (_f(Dr)) {
                    var Qr = pf(Dr), li = i2.get(Qr);
                    if (li)
                      li.nameType = Pa([li.nameType, Dr]), li.keyType = Pa([li.keyType, dr]);
                    else {
                      var Ti = _f(dr) ? bi(z, pf(dr)) : void 0, Ci = !!(me & 4 || !(me & 8) && Ti && Ti.flags & 16777216), $i = !!(me & 1 || !(me & 2) && Ti && Zu(Ti)), Zi = Ye && !Ci && Ti && Ti.flags & 16777216, qt = Ti ? Gd(Ti) : 0, Nt = oo(4 | (Ci ? 16777216 : 0), Qr, qt | 262144 | ($i ? 8 : 0) | (Zi ? 524288 : 0));
                      Nt.mappedType = r2, Nt.nameType = Dr, Nt.keyType = dr, Ti && (Nt.syntheticOrigin = Ti, Nt.declarations = u ? void 0 : Ti.declarations), i2.set(Qr, Nt);
                    }
                  } else if (vh(Dr) || Dr.flags & 33) {
                    var Ra = Dr.flags & 5 ? Li : Dr.flags & 40 ? nt : Dr, ca = un(h2, tv(r2.mapper, o, dr)), Sn = zl(Ra, ca, !!(me & 1));
                    t2 = uh(t2, Sn, true);
                  }
                }
              }
              function J1(r2) {
                if (!r2.type) {
                  var i2 = r2.mappedType;
                  if (!yu(r2, 0))
                    return i2.containsError = true, Pe;
                  var t2 = vl(i2.target || i2), o = tv(i2.mapper, Du(i2), r2.keyType), s2 = un(t2, o), u = Ye && r2.flags & 16777216 && !fs4(s2, 49152) ? i_(s2, true) : r2.checkFlags & 524288 ? $D(s2) : s2;
                  fi() || (Xr(Ie, e2.Diagnostics.Type_of_property_0_circularly_references_itself_in_mapped_type_1, tn(r2), Ot(i2)), u = Pe), r2.type = u;
                }
                return r2.type;
              }
              function Du(r2) {
                return r2.typeParameter || (r2.typeParameter = Js(Et(r2.declaration.typeParameter)));
              }
              function Mu(r2) {
                return r2.constraintType || (r2.constraintType = Tc(Du(r2)) || Pe);
              }
              function Jl(r2) {
                return r2.declaration.nameType ? r2.nameType || (r2.nameType = un(Va(r2.declaration.nameType), r2.mapper)) : void 0;
              }
              function vl(r2) {
                return r2.templateType || (r2.templateType = r2.declaration.type ? un(kc(Va(r2.declaration.type), true, !!(Lu(r2) & 4)), r2.mapper) : Pe);
              }
              function _h(r2) {
                return e2.getEffectiveConstraintOfTypeParameter(r2.declaration.typeParameter);
              }
              function mg(r2) {
                var i2 = _h(r2);
                return i2.kind === 193 && i2.operator === 140;
              }
              function Ed(r2) {
                if (!r2.modifiersType)
                  if (mg(r2))
                    r2.modifiersType = un(Va(_h(r2).type), r2.mapper);
                  else {
                    var i2 = yD(r2.declaration), t2 = Mu(i2), o = t2 && t2.flags & 262144 ? Tc(t2) : t2;
                    r2.modifiersType = o && o.flags & 4194304 ? un(o.type, r2.mapper) : gr;
                  }
                return r2.modifiersType;
              }
              function Lu(r2) {
                var i2 = r2.declaration;
                return (i2.readonlyToken ? i2.readonlyToken.kind === 40 ? 2 : 1 : 0) | (i2.questionToken ? i2.questionToken.kind === 40 ? 8 : 4 : 0);
              }
              function ph(r2) {
                var i2 = Lu(r2);
                return i2 & 8 ? -1 : i2 & 4 ? 1 : 0;
              }
              function qv(r2) {
                var i2 = ph(r2), t2 = Ed(r2);
                return i2 || (Bc(t2) ? ph(t2) : 0);
              }
              function j1(r2) {
                return !!(e2.getObjectFlags(r2) & 32 && Lu(r2) & 4);
              }
              function Bc(r2) {
                return !!(e2.getObjectFlags(r2) & 32) && qp(Mu(r2));
              }
              function Ru(r2) {
                return r2.members || (r2.flags & 524288 ? r2.objectFlags & 4 ? rh(r2) : r2.objectFlags & 3 ? eh(r2) : r2.objectFlags & 1024 ? B1(r2) : r2.objectFlags & 16 ? R1(r2) : r2.objectFlags & 32 && fh(r2) : r2.flags & 1048576 ? jm(r2) : r2.flags & 2097152 && L1(r2)), r2;
              }
              function Pf(r2) {
                return r2.flags & 524288 ? Ru(r2).properties : e2.emptyArray;
              }
              function h_(r2, i2) {
                if (r2.flags & 524288) {
                  var t2 = Ru(r2), o = t2.members.get(i2);
                  if (o && gc(o))
                    return o;
                }
              }
              function em(r2) {
                if (!r2.resolvedProperties) {
                  for (var i2 = e2.createSymbolTable(), t2 = 0, o = r2.types; t2 < o.length; t2++) {
                    for (var s2 = o[t2], u = 0, h2 = uo(s2); u < h2.length; u++) {
                      var z = h2[u];
                      if (!i2.has(z.escapedName)) {
                        var me = Zv(r2, z.escapedName);
                        me && i2.set(z.escapedName, me);
                      }
                    }
                    if (r2.flags & 1048576 && Hn(s2).length === 0)
                      break;
                  }
                  r2.resolvedProperties = tf(i2);
                }
                return r2.resolvedProperties;
              }
              function uo(r2) {
                return r2 = Xd(r2), r2.flags & 3145728 ? em(r2) : Pf(r2);
              }
              function U1(r2, i2) {
                r2 = Xd(r2), r2.flags & 3670016 && Ru(r2).members.forEach(function(t2, o) {
                  xf(t2, o) && i2(t2, o);
                });
              }
              function z1(r2, i2) {
                var t2 = i2.properties;
                return t2.some(function(o) {
                  var s2 = o.name && Z_(o.name), u = s2 && _f(s2) ? pf(s2) : void 0, h2 = u === void 0 ? void 0 : da(r2, u);
                  return !!h2 && Cg(h2) && !ao(Bd(o), h2);
                });
              }
              function W1(r2) {
                var i2 = Pa(r2);
                if (!(i2.flags & 1048576))
                  return LS(i2);
                for (var t2 = e2.createSymbolTable(), o = 0, s2 = r2; o < s2.length; o++)
                  for (var u = s2[o], h2 = 0, z = LS(u); h2 < z.length; h2++) {
                    var me = z[h2].escapedName;
                    if (!t2.has(me)) {
                      var Me = Yv(i2, me);
                      Me && t2.set(me, Me);
                    }
                  }
                return e2.arrayFrom(t2.values());
              }
              function Q_(r2) {
                return r2.flags & 262144 ? Tc(r2) : r2.flags & 8388608 ? q1(r2) : r2.flags & 16777216 ? K1(r2) : uc(r2);
              }
              function Tc(r2) {
                return Wm(r2) ? tm(r2) : void 0;
              }
              function q1(r2) {
                return Wm(r2) ? V1(r2) : void 0;
              }
              function Vv(r2) {
                var i2 = Zf(r2, false);
                return i2 !== r2 ? i2 : Q_(r2);
              }
              function V1(r2) {
                if (Qv(r2))
                  return xh(r2.objectType, r2.indexType);
                var i2 = Vv(r2.indexType);
                if (i2 && i2 !== r2.indexType) {
                  var t2 = ep(r2.objectType, i2, r2.accessFlags);
                  if (t2)
                    return t2;
                }
                var o = Vv(r2.objectType);
                if (o && o !== r2.objectType)
                  return ep(o, r2.indexType, r2.accessFlags);
              }
              function zm(r2) {
                if (!r2.resolvedDefaultConstraint) {
                  var i2 = TI(r2), t2 = tp(r2);
                  r2.resolvedDefaultConstraint = ta(i2) ? t2 : ta(t2) ? i2 : Pa([i2, t2]);
                }
                return r2.resolvedDefaultConstraint;
              }
              function Kv(r2) {
                if (r2.root.isDistributive && r2.restrictiveInstantiation !== r2) {
                  var i2 = Zf(r2.checkType, false), t2 = i2 === r2.checkType ? Q_(i2) : i2;
                  if (t2 && t2 !== r2.checkType) {
                    var o = ID(r2, $d(r2.root.checkType, t2, r2.mapper));
                    if (!(o.flags & 131072))
                      return o;
                  }
                }
              }
              function Gv(r2) {
                return Kv(r2) || zm(r2);
              }
              function K1(r2) {
                return Wm(r2) ? Gv(r2) : void 0;
              }
              function G1(r2, i2) {
                for (var t2, o = false, s2 = 0, u = r2; s2 < u.length; s2++) {
                  var h2 = u[s2];
                  if (h2.flags & 465829888) {
                    for (var z = Q_(h2); z && z.flags & 21233664; )
                      z = Q_(z);
                    z && (t2 = e2.append(t2, z), i2 && (t2 = e2.append(t2, h2)));
                  } else
                    h2.flags & 469892092 && (o = true);
                }
                if (t2 && (i2 || o)) {
                  if (o)
                    for (var me = 0, Me = r2; me < Me.length; me++) {
                      var h2 = Me[me];
                      h2.flags & 469892092 && (t2 = e2.append(t2, h2));
                    }
                  return Do(t2);
                }
              }
              function uc(r2) {
                if (r2.flags & 464781312) {
                  var i2 = Hv(r2);
                  return i2 !== Kn && i2 !== Pn ? i2 : void 0;
                }
                return r2.flags & 4194304 ? at : void 0;
              }
              function Hd(r2) {
                return uc(r2) || r2;
              }
              function Wm(r2) {
                return Hv(r2) !== Pn;
              }
              function Hv(r2) {
                if (r2.resolvedBaseConstraint)
                  return r2.resolvedBaseConstraint;
                var i2 = [];
                return r2.resolvedBaseConstraint = Rc(t2(r2), r2);
                function t2(u) {
                  if (!u.immediateBaseConstraint) {
                    if (!yu(u, 4))
                      return Pn;
                    var h2 = void 0, z = ov(u);
                    if ((i2.length < 10 || i2.length < 50 && !e2.contains(i2, z)) && (i2.push(z), h2 = s2(Zf(u, false)), i2.pop()), !fi()) {
                      if (u.flags & 262144) {
                        var me = ox(u);
                        if (me) {
                          var Me = Xr(me, e2.Diagnostics.Type_parameter_0_has_a_circular_constraint, Ot(u));
                          Ie && !e2.isNodeDescendantOf(me, Ie) && !e2.isNodeDescendantOf(Ie, me) && e2.addRelatedInfo(Me, e2.createDiagnosticForNode(Ie, e2.Diagnostics.Circularity_originates_in_type_at_this_location));
                        }
                      }
                      h2 = Pn;
                    }
                    u.immediateBaseConstraint = h2 || Kn;
                  }
                  return u.immediateBaseConstraint;
                }
                function o(u) {
                  var h2 = t2(u);
                  return h2 !== Kn && h2 !== Pn ? h2 : void 0;
                }
                function s2(u) {
                  if (u.flags & 262144) {
                    var h2 = tm(u);
                    return u.isThisType || !h2 ? h2 : o(h2);
                  }
                  if (u.flags & 3145728) {
                    for (var z = u.types, me = [], Me = false, $e = 0, tr = z; $e < tr.length; $e++) {
                      var dr = tr[$e], Dr = o(dr);
                      Dr ? (Dr !== dr && (Me = true), me.push(Dr)) : Me = true;
                    }
                    return Me ? u.flags & 1048576 && me.length === z.length ? Pa(me) : u.flags & 2097152 && me.length ? Do(me) : void 0 : u;
                  }
                  if (u.flags & 4194304)
                    return at;
                  if (u.flags & 134217728) {
                    var z = u.types, Qr = e2.mapDefined(z, o);
                    return Qr.length === z.length ? Dg(u.texts, Qr) : Li;
                  }
                  if (u.flags & 268435456) {
                    var h2 = o(u.type);
                    return h2 ? Th(u.symbol, h2) : Li;
                  }
                  if (u.flags & 8388608) {
                    if (Qv(u))
                      return o(xh(u.objectType, u.indexType));
                    var li = o(u.objectType), Ti = o(u.indexType), Ci = li && Ti && ep(li, Ti, u.accessFlags);
                    return Ci && o(Ci);
                  }
                  if (u.flags & 16777216) {
                    var h2 = Gv(u);
                    return h2 && o(h2);
                  }
                  return u.flags & 33554432 ? o(u.substitute) : u;
                }
              }
              function H1(r2) {
                return r2.resolvedApparentType || (r2.resolvedApparentType = Rc(r2, r2, true));
              }
              function Xv(r2) {
                if (r2.default)
                  r2.default === eo && (r2.default = Pn);
                else if (r2.target) {
                  var i2 = Xv(r2.target);
                  r2.default = i2 ? un(i2, r2.mapper) : Kn;
                } else {
                  r2.default = eo;
                  var t2 = r2.symbol && e2.forEach(r2.symbol.declarations, function(s2) {
                    return e2.isTypeParameterDeclaration(s2) && s2.default;
                  }), o = t2 ? Va(t2) : Kn;
                  r2.default === eo && (r2.default = o);
                }
                return r2.default;
              }
              function D_(r2) {
                var i2 = Xv(r2);
                return i2 !== Kn && i2 !== Pn ? i2 : void 0;
              }
              function X1(r2) {
                return Xv(r2) !== Pn;
              }
              function Q1(r2) {
                return !!(r2.symbol && e2.forEach(r2.symbol.declarations, function(i2) {
                  return e2.isTypeParameterDeclaration(i2) && i2.default;
                }));
              }
              function Y1(r2) {
                return r2.resolvedApparentType || (r2.resolvedApparentType = dh(r2));
              }
              function dh(r2) {
                var i2 = Ih(r2);
                if (i2 && !r2.declaration.nameType) {
                  var t2 = Tc(i2);
                  if (t2 && Pd(t2))
                    return un(r2, $d(i2, t2, r2.mapper));
                }
                return r2;
              }
              function Qv(r2) {
                var i2;
                return !!(r2.flags & 8388608 && e2.getObjectFlags(i2 = r2.objectType) & 32 && !Bc(i2) && qp(r2.indexType) && !i2.declaration.questionToken && !i2.declaration.nameType);
              }
              function $s(r2) {
                var i2 = r2.flags & 465829888 ? uc(r2) || gr : r2;
                return e2.getObjectFlags(i2) & 32 ? Y1(i2) : i2.flags & 2097152 ? H1(i2) : i2.flags & 402653316 ? Ct : i2.flags & 296 ? sa : i2.flags & 2112 ? R3() : i2.flags & 528 ? en : i2.flags & 12288 ? Cx() : i2.flags & 67108864 ? Ba : i2.flags & 4194304 ? at : i2.flags & 2 && !Ye ? Ba : i2;
              }
              function Xd(r2) {
                return bu($s(bu(r2)));
              }
              function Yv(r2, i2, t2) {
                for (var o, s2, u, h2, z, me = r2.flags & 1048576, Me = me ? 0 : 16777216, $e = 4, tr = me ? 0 : 8, dr = false, Dr = 0, Qr = r2.types; Dr < Qr.length; Dr++) {
                  var li = Qr[Dr], Ti = $s(li);
                  if (!(nn(Ti) || Ti.flags & 131072)) {
                    var Ci = bi(Ti, i2, t2), $i = Ci ? e2.getDeclarationModifierFlagsFromSymbol(Ci) : 0;
                    if (Ci) {
                      if (me ? Me |= Ci.flags & 16777216 : Me &= Ci.flags, !u)
                        u = Ci;
                      else if (Ci !== u) {
                        var Zi = (jg(Ci) || Ci) === (jg(u) || u);
                        if (Zi && VD(u, Ci, function(Ka, cn) {
                          return Ka === cn ? -1 : 0;
                        }) === -1)
                          dr = !!u.parent && !!e2.length(Af(u.parent));
                        else {
                          h2 || (h2 = new e2.Map(), h2.set(y(u), u));
                          var qt = y(Ci);
                          h2.has(qt) || h2.set(qt, Ci);
                        }
                      }
                      me && Zu(Ci) ? tr |= 8 : !me && !Zu(Ci) && (tr &= -9), tr |= ($i & 24 ? 0 : 256) | ($i & 16 ? 512 : 0) | ($i & 8 ? 1024 : 0) | ($i & 32 ? 2048 : 0), Bb(Ci) || ($e = 2);
                    } else if (me) {
                      var Nt = !pg(i2) && Xo(Ti, i2);
                      Nt ? (tr |= 32 | (Nt.isReadonly ? 8 : 0), z = e2.append(z, Yn(Ti) ? sv(Ti) || Tr : Nt.type)) : Qp(Ti) && !(e2.getObjectFlags(Ti) & 2097152) ? (tr |= 32, z = e2.append(z, Tr)) : tr |= 16;
                    }
                  }
                }
                if (!(!u || me && (h2 || tr & 48) && tr & 1536)) {
                  if (!h2 && !(tr & 16) && !z)
                    if (dr) {
                      var Ra = eg(u, u.type);
                      return Ra.parent = (s2 = (o = u.valueDeclaration) === null || o === void 0 ? void 0 : o.symbol) === null || s2 === void 0 ? void 0 : s2.parent, Ra.containingType = r2, Ra.mapper = u.mapper, Ra;
                    } else
                      return u;
                  for (var ca = h2 ? e2.arrayFrom(h2.values()) : [u], Sn, ja, Fn, wn = [], Tn, Eo, lt = false, it = 0, Yt = ca; it < Yt.length; it++) {
                    var Ci = Yt[it];
                    Eo ? Ci.valueDeclaration && Ci.valueDeclaration !== Eo && (lt = true) : Eo = Ci.valueDeclaration, Sn = e2.addRange(Sn, Ci.declarations);
                    var Ti = Jt(Ci);
                    ja || (ja = Ti, Fn = Aa(Ci).nameType);
                    var Ia = Vg(Ci);
                    Tn || Ia !== Ti ? Tn = e2.append(Tn || wn.slice(), Ia) : Ti !== ja && (tr |= 64), (Cg(Ti) || sm(Ti) || Ti === Dn) && (tr |= 128), Ti.flags & 131072 && Ti !== Dn && (tr |= 131072), wn.push(Ti);
                  }
                  e2.addRange(wn, z);
                  var Qt = oo(4 | Me, i2, $e | tr);
                  return Qt.containingType = r2, !lt && Eo && (Qt.valueDeclaration = Eo, Eo.symbol.parent && (Qt.parent = Eo.symbol.parent)), Qt.declarations = Sn, Qt.nameType = Fn, wn.length > 2 ? (Qt.checkFlags |= 65536, Qt.deferralParent = r2, Qt.deferralConstituents = wn, Qt.deferralWriteConstituents = Tn) : (Qt.type = me ? Pa(wn) : Do(wn), Tn && (Qt.writeType = me ? Pa(Tn) : Do(Tn))), Qt;
                }
              }
              function $v(r2, i2, t2) {
                var o, s2, u = ((o = r2.propertyCacheWithoutObjectFunctionPropertyAugment) === null || o === void 0 ? void 0 : o.get(i2)) || !t2 ? (s2 = r2.propertyCache) === null || s2 === void 0 ? void 0 : s2.get(i2) : void 0;
                if (!u && (u = Yv(r2, i2, t2), u)) {
                  var h2 = t2 ? r2.propertyCacheWithoutObjectFunctionPropertyAugment || (r2.propertyCacheWithoutObjectFunctionPropertyAugment = e2.createSymbolTable()) : r2.propertyCache || (r2.propertyCache = e2.createSymbolTable());
                  h2.set(i2, u);
                }
                return u;
              }
              function Zv(r2, i2, t2) {
                var o = $v(r2, i2, t2);
                return o && !(e2.getCheckFlags(o) & 16) ? o : void 0;
              }
              function bu(r2) {
                return r2.flags & 1048576 && r2.objectFlags & 16777216 ? r2.resolvedReducedType || (r2.resolvedReducedType = $1(r2)) : r2.flags & 2097152 ? (r2.objectFlags & 16777216 || (r2.objectFlags |= 16777216 | (e2.some(em(r2), c) ? 33554432 : 0)), r2.objectFlags & 33554432 ? ui : r2) : r2;
              }
              function $1(r2) {
                var i2 = e2.sameMap(r2.types, bu);
                if (i2 === r2.types)
                  return r2;
                var t2 = Pa(i2);
                return t2.flags & 1048576 && (t2.resolvedReducedType = t2), t2;
              }
              function c(r2) {
                return te(r2) || xr(r2);
              }
              function te(r2) {
                return !(r2.flags & 16777216) && (e2.getCheckFlags(r2) & 131264) === 192 && !!(Jt(r2).flags & 131072);
              }
              function xr(r2) {
                return !r2.valueDeclaration && !!(e2.getCheckFlags(r2) & 1024);
              }
              function ei(r2, i2) {
                if (i2.flags & 2097152 && e2.getObjectFlags(i2) & 33554432) {
                  var t2 = e2.find(em(i2), te);
                  if (t2)
                    return e2.chainDiagnosticMessages(r2, e2.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_has_conflicting_types_in_some_constituents, Ot(i2, void 0, 536870912), tn(t2));
                  var o = e2.find(em(i2), xr);
                  if (o)
                    return e2.chainDiagnosticMessages(r2, e2.Diagnostics.The_intersection_0_was_reduced_to_never_because_property_1_exists_in_multiple_constituents_and_is_private_in_some, Ot(i2, void 0, 536870912), tn(o));
                }
                return r2;
              }
              function bi(r2, i2, t2) {
                if (r2 = Xd(r2), r2.flags & 524288) {
                  var o = Ru(r2), s2 = o.members.get(i2);
                  if (s2 && gc(s2))
                    return s2;
                  if (t2)
                    return;
                  var u = o === xn ? br : o.callSignatures.length ? Zr : o.constructSignatures.length ? Si : void 0;
                  if (u) {
                    var h2 = h_(u, i2);
                    if (h2)
                      return h2;
                  }
                  return h_(qe, i2);
                }
                if (r2.flags & 3145728)
                  return Zv(r2, i2, t2);
              }
              function Ft(r2, i2) {
                if (r2.flags & 3670016) {
                  var t2 = Ru(r2);
                  return i2 === 0 ? t2.callSignatures : t2.constructSignatures;
                }
                return e2.emptyArray;
              }
              function ot(r2, i2) {
                return Ft(Xd(r2), i2);
              }
              function xa(r2, i2) {
                return e2.find(r2, function(t2) {
                  return t2.keyType === i2;
                });
              }
              function mn(r2, i2) {
                for (var t2, o, s2, u = 0, h2 = r2; u < h2.length; u++) {
                  var z = h2[u];
                  z.keyType === Li ? t2 = z : an(i2, z.keyType) && (o ? (s2 || (s2 = [o])).push(z) : o = z);
                }
                return s2 ? zl(gr, Do(e2.map(s2, function(me) {
                  return me.type;
                })), e2.reduceLeft(s2, function(me, Me) {
                  return me && Me.isReadonly;
                }, true)) : o || (t2 && an(i2, Li) ? t2 : void 0);
              }
              function an(r2, i2) {
                return ao(r2, i2) || i2 === Li && ao(r2, nt) || i2 === nt && (r2 === $a || !!(r2.flags & 128) && e2.isNumericLiteralName(r2.value));
              }
              function To(r2) {
                if (r2.flags & 3670016) {
                  var i2 = Ru(r2);
                  return i2.indexInfos;
                }
                return e2.emptyArray;
              }
              function Hn(r2) {
                return To(Xd(r2));
              }
              function ss(r2, i2) {
                return xa(Hn(r2), i2);
              }
              function cs(r2, i2) {
                var t2;
                return (t2 = ss(r2, i2)) === null || t2 === void 0 ? void 0 : t2.type;
              }
              function ws(r2, i2) {
                return Hn(r2).filter(function(t2) {
                  return an(i2, t2.keyType);
                });
              }
              function nu(r2, i2) {
                return mn(Hn(r2), i2);
              }
              function Xo(r2, i2) {
                return nu(r2, pg(i2) ? Ki : Bu(e2.unescapeLeadingUnderscores(i2)));
              }
              function jl(r2) {
                for (var i2, t2 = 0, o = e2.getEffectiveTypeParameterDeclarations(r2); t2 < o.length; t2++) {
                  var s2 = o[t2];
                  i2 = e2.appendIfUnique(i2, Js(s2.symbol));
                }
                return i2;
              }
              function Y_(r2) {
                var i2 = [];
                return r2.forEach(function(t2, o) {
                  Ol(o) || i2.push(t2);
                }), i2;
              }
              function Cd(r2) {
                return e2.isInJSFile(r2) && (r2.type && r2.type.kind === 316 || e2.getJSDocParameterTags(r2).some(function(i2) {
                  var t2 = i2.isBracketed, o = i2.typeExpression;
                  return t2 || !!o && o.type.kind === 316;
                }));
              }
              function b_(r2, i2) {
                if (!e2.isExternalModuleNameRelative(r2)) {
                  var t2 = qs(ii, '"' + r2 + '"', 512);
                  return t2 && i2 ? so(t2) : t2;
                }
              }
              function kd(r2) {
                if (e2.hasQuestionToken(r2) || Vm(r2) || Cd(r2))
                  return true;
                if (r2.initializer) {
                  var i2 = yl(r2.parent), t2 = r2.parent.parameters.indexOf(r2);
                  return e2.Debug.assert(t2 >= 0), t2 >= Hl(i2, 3);
                }
                var o = e2.getImmediatelyInvokedFunctionExpression(r2.parent);
                return o ? !r2.type && !r2.dotDotDotToken && r2.parent.parameters.indexOf(r2) >= o.arguments.length : false;
              }
              function qm(r2) {
                return e2.isPropertyDeclaration(r2) && r2.questionToken;
              }
              function Vm(r2) {
                if (!e2.isJSDocPropertyLikeTag(r2))
                  return false;
                var i2 = r2.isBracketed, t2 = r2.typeExpression;
                return i2 || !!t2 && t2.type.kind === 316;
              }
              function vg(r2, i2, t2, o) {
                return { kind: r2, parameterName: i2, parameterIndex: t2, type: o };
              }
              function Ul(r2) {
                var i2 = 0;
                if (r2)
                  for (var t2 = 0; t2 < r2.length; t2++)
                    Q1(r2[t2]) || (i2 = t2 + 1);
                return i2;
              }
              function zp(r2, i2, t2, o) {
                var s2 = e2.length(i2);
                if (!s2)
                  return [];
                var u = e2.length(r2);
                if (o || u >= t2 && u <= s2) {
                  for (var h2 = r2 ? r2.slice() : [], z = u; z < s2; z++)
                    h2[z] = Pe;
                  for (var me = fb(o), z = u; z < s2; z++) {
                    var Me = D_(i2[z]);
                    o && Me && (wf(Me, gr) || wf(Me, Ba)) && (Me = Oe), h2[z] = Me ? un(Me, Uc(i2, h2)) : me;
                  }
                  return h2.length = i2.length, h2;
                }
                return r2 && r2.slice();
              }
              function yl(r2) {
                var i2 = va(r2);
                if (!i2.resolvedSignature) {
                  var t2 = [], o = 0, s2 = 0, u = void 0, h2 = false, z = e2.getImmediatelyInvokedFunctionExpression(r2), me = e2.isJSDocConstructSignature(r2), Me = !z && e2.isInJSFile(r2) && e2.isValueSignatureDeclaration(r2) && !e2.hasJSDocParameterTags(r2) && !e2.getJSDocType(r2);
                  Me && (o |= 32);
                  for (var $e = me ? 1 : 0; $e < r2.parameters.length; $e++) {
                    var tr = r2.parameters[$e], dr = tr.symbol, Dr = e2.isJSDocParameterTag(tr) ? tr.typeExpression && tr.typeExpression.type : tr.type;
                    if (dr && !!(dr.flags & 4) && !e2.isBindingPattern(tr.name)) {
                      var Qr = es(tr, dr.escapedName, 111551, void 0, void 0, false);
                      dr = Qr;
                    }
                    $e === 0 && dr.escapedName === "this" ? (h2 = true, u = tr.symbol) : t2.push(dr), Dr && Dr.kind === 196 && (o |= 2);
                    var li = Vm(tr) || tr.initializer || tr.questionToken || e2.isRestParameter(tr) || z && t2.length > z.arguments.length && !Dr || Cd(tr);
                    li || (s2 = t2.length);
                  }
                  if ((r2.kind === 172 || r2.kind === 173) && Td(r2) && (!h2 || !u)) {
                    var Ti = r2.kind === 172 ? 173 : 172, Ci = e2.getDeclarationOfKind(Et(r2), Ti);
                    Ci && (u = cr(Ci));
                  }
                  var $i = r2.kind === 171 ? aa(so(r2.parent.symbol)) : void 0, Zi = $i ? $i.localTypeParameters : jl(r2);
                  (e2.hasRestParameter(r2) || e2.isInJSFile(r2) && ey(r2, t2)) && (o |= 1), (e2.isConstructorTypeNode(r2) && e2.hasSyntacticModifier(r2, 128) || e2.isConstructorDeclaration(r2) && e2.hasSyntacticModifier(r2.parent, 128)) && (o |= 4), i2.resolvedSignature = Fu(r2, Zi, u, t2, void 0, void 0, s2, o);
                }
                return i2.resolvedSignature;
              }
              function ey(r2, i2) {
                if (e2.isJSDocSignature(r2) || !Gm(r2))
                  return false;
                var t2 = e2.lastOrUndefined(r2.parameters), o = t2 ? e2.getJSDocParameterTags(t2) : e2.getJSDocTags(r2).filter(e2.isJSDocParameterTag), s2 = e2.firstDefined(o, function(h2) {
                  return h2.typeExpression && e2.isJSDocVariadicType(h2.typeExpression.type) ? h2.typeExpression.type : void 0;
                }), u = oo(3, "args", 32768);
                return s2 ? u.type = Zs(Va(s2.type)) : (u.checkFlags |= 65536, u.deferralParent = ui, u.deferralConstituents = [mo], u.deferralWriteConstituents = [mo]), s2 && i2.pop(), i2.push(u), true;
              }
              function rm(r2) {
                if (!!(e2.isInJSFile(r2) && e2.isFunctionLikeDeclaration(r2))) {
                  var i2 = e2.getJSDocTypeTag(r2);
                  return (i2 == null ? void 0 : i2.typeExpression) && ig(Va(i2.typeExpression));
                }
              }
              function Km(r2, i2) {
                var t2 = rm(r2);
                if (!!t2) {
                  var o = r2.parameters.indexOf(i2);
                  return i2.dotDotDotToken ? ym(t2, o) : $u(t2, o);
                }
              }
              function ry(r2) {
                var i2 = rm(r2);
                return i2 && yo(i2);
              }
              function Gm(r2) {
                var i2 = va(r2);
                return i2.containsArgumentsReference === void 0 && (i2.flags & 8192 ? i2.containsArgumentsReference = true : i2.containsArgumentsReference = t2(r2.body)), i2.containsArgumentsReference;
                function t2(o) {
                  if (!o)
                    return false;
                  switch (o.kind) {
                    case 79:
                      return o.escapedText === or.escapedName && Nv(o) === or;
                    case 167:
                    case 169:
                    case 172:
                    case 173:
                      return o.name.kind === 162 && t2(o.name);
                    case 206:
                    case 207:
                      return t2(o.expression);
                    case 296:
                      return t2(o.initializer);
                    default:
                      return !e2.nodeStartsNewLexicalEnvironment(o) && !e2.isPartOfTypeNode(o) && !!e2.forEachChild(o, t2);
                  }
                }
              }
              function S_(r2) {
                if (!r2 || !r2.declarations)
                  return e2.emptyArray;
                for (var i2 = [], t2 = 0; t2 < r2.declarations.length; t2++) {
                  var o = r2.declarations[t2];
                  if (!!e2.isFunctionLike(o)) {
                    if (t2 > 0 && o.body) {
                      var s2 = r2.declarations[t2 - 1];
                      if (o.parent === s2.parent && o.kind === s2.kind && o.pos === s2.end)
                        continue;
                    }
                    i2.push(yl(o));
                  }
                }
                return i2;
              }
              function Hm(r2) {
                var i2 = ac(r2, r2);
                if (i2) {
                  var t2 = Us(i2);
                  if (t2)
                    return Jt(t2);
                }
                return Oe;
              }
              function T_(r2) {
                if (r2.thisParameter)
                  return Jt(r2.thisParameter);
              }
              function Yc(r2) {
                if (!r2.resolvedTypePredicate) {
                  if (r2.target) {
                    var i2 = Yc(r2.target);
                    r2.resolvedTypePredicate = i2 ? BI(i2, r2.mapper) : Ro;
                  } else if (r2.compositeSignatures)
                    r2.resolvedTypePredicate = X3(r2.compositeSignatures, r2.compositeKind) || Ro;
                  else {
                    var t2 = r2.declaration && e2.getEffectiveReturnTypeNode(r2.declaration), o = void 0;
                    if (!t2 && e2.isInJSFile(r2.declaration)) {
                      var s2 = rm(r2.declaration);
                      s2 && r2 !== s2 && (o = Yc(s2));
                    }
                    r2.resolvedTypePredicate = t2 && e2.isTypePredicateNode(t2) ? gh(t2, r2) : o || Ro;
                  }
                  e2.Debug.assert(!!r2.resolvedTypePredicate);
                }
                return r2.resolvedTypePredicate === Ro ? void 0 : r2.resolvedTypePredicate;
              }
              function gh(r2, i2) {
                var t2 = r2.parameterName, o = r2.type && Va(r2.type);
                return t2.kind === 192 ? vg(r2.assertsModifier ? 2 : 0, void 0, void 0, o) : vg(r2.assertsModifier ? 3 : 1, t2.escapedText, e2.findIndex(i2.parameters, function(s2) {
                  return s2.escapedName === t2.escapedText;
                }), o);
              }
              function iy(r2, i2, t2) {
                return i2 !== 2097152 ? Pa(r2, t2) : Do(r2);
              }
              function yo(r2) {
                if (!r2.resolvedReturnType) {
                  if (!yu(r2, 3))
                    return Pe;
                  var i2 = r2.target ? un(yo(r2.target), r2.mapper) : r2.compositeSignatures ? un(iy(e2.map(r2.compositeSignatures, yo), r2.compositeKind, 2), r2.mapper) : yg(r2.declaration) || (e2.nodeIsMissing(r2.declaration.body) ? Oe : C0(r2.declaration));
                  if (r2.flags & 8 ? i2 = FE(i2) : r2.flags & 16 && (i2 = i_(i2)), !fi()) {
                    if (r2.declaration) {
                      var t2 = e2.getEffectiveReturnTypeNode(r2.declaration);
                      if (t2)
                        Xr(t2, e2.Diagnostics.Return_type_annotation_circularly_references_itself);
                      else if (n) {
                        var o = r2.declaration, s2 = e2.getNameOfDeclaration(o);
                        s2 ? Xr(s2, e2.Diagnostics._0_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions, e2.declarationNameToString(s2)) : Xr(o, e2.Diagnostics.Function_implicitly_has_return_type_any_because_it_does_not_have_a_return_type_annotation_and_is_referenced_directly_or_indirectly_in_one_of_its_return_expressions);
                      }
                    }
                    i2 = Oe;
                  }
                  r2.resolvedReturnType = i2;
                }
                return r2.resolvedReturnType;
              }
              function yg(r2) {
                if (r2.kind === 171)
                  return aa(so(r2.parent.symbol));
                if (e2.isJSDocConstructSignature(r2))
                  return Va(r2.parameters[0].type);
                var i2 = e2.getEffectiveReturnTypeNode(r2);
                if (i2)
                  return Va(i2);
                if (r2.kind === 172 && Td(r2)) {
                  var t2 = e2.isInJSFile(r2) && K_(r2);
                  if (t2)
                    return t2;
                  var o = e2.getDeclarationOfKind(Et(r2), 173), s2 = Te(o);
                  if (s2)
                    return s2;
                }
                return ry(r2);
              }
              function Z1(r2) {
                return !r2.resolvedReturnType && v(r2, 3) >= 0;
              }
              function _3(r2) {
                return ix(r2) || Oe;
              }
              function ix(r2) {
                if (H(r2)) {
                  var i2 = Jt(r2.parameters[r2.parameters.length - 1]), t2 = Yn(i2) ? sv(i2) : i2;
                  return t2 && cs(t2, nt);
                }
              }
              function Xm(r2, i2, t2, o) {
                var s2 = eD(r2, zp(i2, r2.typeParameters, Ul(r2.typeParameters), t2));
                if (o) {
                  var u = ok(yo(s2));
                  if (u) {
                    var h2 = xd(u);
                    h2.typeParameters = o;
                    var z = xd(s2);
                    return z.resolvedReturnType = im(h2), z;
                  }
                }
                return s2;
              }
              function eD(r2, i2) {
                var t2 = r2.instantiations || (r2.instantiations = new e2.Map()), o = Su(i2), s2 = t2.get(o);
                return s2 || t2.set(o, s2 = mh(r2, i2)), s2;
              }
              function mh(r2, i2) {
                return Tg(r2, p3(r2, i2), true);
              }
              function p3(r2, i2) {
                return Uc(r2.typeParameters, i2);
              }
              function Qm(r2) {
                return r2.typeParameters ? r2.erasedSignatureCache || (r2.erasedSignatureCache = d3(r2)) : r2;
              }
              function d3(r2) {
                return Tg(r2, sE(r2.typeParameters), true);
              }
              function g3(r2) {
                return r2.typeParameters ? r2.canonicalSignatureCache || (r2.canonicalSignatureCache = m3(r2)) : r2;
              }
              function m3(r2) {
                return Xm(r2, e2.map(r2.typeParameters, function(i2) {
                  return i2.target && !Tc(i2.target) ? i2.target : i2;
                }), e2.isInJSFile(r2.declaration));
              }
              function v3(r2) {
                var i2 = r2.typeParameters;
                if (i2) {
                  if (r2.baseSignatureCache)
                    return r2.baseSignatureCache;
                  for (var t2 = sE(i2), o = Uc(i2, e2.map(i2, function(h2) {
                    return Tc(h2) || gr;
                  })), s2 = e2.map(i2, function(h2) {
                    return un(h2, o) || gr;
                  }), u = 0; u < i2.length - 1; u++)
                    s2 = e_(s2, o);
                  return s2 = e_(s2, t2), r2.baseSignatureCache = Tg(r2, Uc(i2, s2), true);
                }
                return r2;
              }
              function im(r2) {
                var i2;
                if (!r2.isolatedSignatureType) {
                  var t2 = (i2 = r2.declaration) === null || i2 === void 0 ? void 0 : i2.kind, o = t2 === void 0 || t2 === 171 || t2 === 175 || t2 === 180, s2 = tu(16);
                  s2.members = we, s2.properties = e2.emptyArray, s2.callSignatures = o ? e2.emptyArray : [r2], s2.constructSignatures = o ? [r2] : e2.emptyArray, s2.indexInfos = e2.emptyArray, r2.isolatedSignatureType = s2;
                }
                return r2.isolatedSignatureType;
              }
              function tx(r2) {
                return r2.members ? rD(r2.members) : void 0;
              }
              function rD(r2) {
                return r2.get("__index");
              }
              function zl(r2, i2, t2, o) {
                return { keyType: r2, type: i2, isReadonly: t2, declaration: o };
              }
              function ax(r2) {
                var i2 = tx(r2);
                return i2 ? nx(i2) : e2.emptyArray;
              }
              function nx(r2) {
                if (r2.declarations) {
                  for (var i2 = [], t2 = function(h2) {
                    if (h2.parameters.length === 1) {
                      var z = h2.parameters[0];
                      z.type && Od(Va(z.type), function(me) {
                        vh(me) && !xa(i2, me) && i2.push(zl(me, h2.type ? Va(h2.type) : Oe, e2.hasEffectiveModifier(h2, 64), h2));
                      });
                    }
                  }, o = 0, s2 = r2.declarations; o < s2.length; o++) {
                    var u = s2[o];
                    t2(u);
                  }
                  return i2;
                }
                return e2.emptyArray;
              }
              function vh(r2) {
                return !!(r2.flags & 4108) || sm(r2) || !!(r2.flags & 2097152) && !rv(r2) && e2.some(r2.types, vh);
              }
              function ox(r2) {
                return e2.mapDefined(e2.filter(r2.symbol && r2.symbol.declarations, e2.isTypeParameterDeclaration), e2.getEffectiveConstraintOfTypeParameter)[0];
              }
              function sx(r2, i2) {
                var t2, o;
                if (!((t2 = r2.symbol) === null || t2 === void 0) && t2.declarations)
                  for (var s2 = 0, u = r2.symbol.declarations; s2 < u.length; s2++) {
                    var h2 = u[s2];
                    if (h2.parent.kind === 190) {
                      var z = e2.walkUpParenthesizedTypesAndGetParentAndChild(h2.parent.parent), me = z[0], Me = me === void 0 ? h2.parent : me, $e = z[1];
                      if ($e.kind === 178 && !i2) {
                        var tr = $e, dr = mS(tr);
                        if (dr) {
                          var Dr = tr.typeArguments.indexOf(Me);
                          if (Dr < dr.length) {
                            var Qr = Tc(dr[Dr]);
                            if (Qr) {
                              var li = Uc(dr, P0(tr, dr)), Ti = un(Qr, li);
                              Ti !== r2 && (o = e2.append(o, Ti));
                            }
                          }
                        }
                      } else if ($e.kind === 164 && $e.dotDotDotToken || $e.kind === 186 || $e.kind === 197 && $e.dotDotDotToken)
                        o = e2.append(o, Zs(gr));
                      else if ($e.kind === 199)
                        o = e2.append(o, Li);
                      else if ($e.kind === 163 && $e.parent.kind === 195)
                        o = e2.append(o, at);
                      else if ($e.kind === 195 && $e.type && e2.skipParentheses($e.type) === h2.parent && $e.parent.kind === 189 && $e.parent.extendsType === $e && $e.parent.checkType.kind === 195 && $e.parent.checkType.type) {
                        var Ci = $e.parent.checkType, $i = Va(Ci.type);
                        o = e2.append(o, un($i, Yd(Js(Et(Ci.typeParameter)), Ci.typeParameter.constraint ? Va(Ci.typeParameter.constraint) : at)));
                      }
                    }
                  }
                return o && Do(o);
              }
              function tm(r2) {
                if (!r2.constraint)
                  if (r2.target) {
                    var i2 = Tc(r2.target);
                    r2.constraint = i2 ? un(i2, r2.mapper) : Kn;
                  } else {
                    var t2 = ox(r2);
                    if (!t2)
                      r2.constraint = sx(r2) || Kn;
                    else {
                      var o = Va(t2);
                      o.flags & 1 && !nn(o) && (o = t2.parent.parent.kind === 195 ? at : gr), r2.constraint = o;
                    }
                  }
                return r2.constraint === Kn ? void 0 : r2.constraint;
              }
              function cx(r2) {
                var i2 = e2.getDeclarationOfKind(r2.symbol, 163), t2 = e2.isJSDocTemplateTag(i2.parent) ? e2.getEffectiveContainerForJSDocTemplateTag(i2.parent) : i2.parent;
                return t2 && Et(t2);
              }
              function Su(r2) {
                var i2 = "";
                if (r2)
                  for (var t2 = r2.length, o = 0; o < t2; ) {
                    for (var s2 = r2[o].id, u = 1; o + u < t2 && r2[o + u].id === s2 + u; )
                      u++;
                    i2.length && (i2 += ","), i2 += s2, u > 1 && (i2 += ":" + u), o += u;
                  }
                return i2;
              }
              function hg(r2, i2) {
                return r2 ? "@".concat(y(r2)) + (i2 ? ":".concat(Su(i2)) : "") : "";
              }
              function iD(r2, i2) {
                for (var t2 = 0, o = 0, s2 = r2; o < s2.length; o++) {
                  var u = s2[o];
                  u.flags & i2 || (t2 |= e2.getObjectFlags(u));
                }
                return t2 & 458752;
              }
              function Yf(r2, i2) {
                var t2 = Su(i2), o = r2.instantiations.get(t2);
                return o || (o = tu(4, r2.symbol), r2.instantiations.set(t2, o), o.objectFlags |= i2 ? iD(i2, 0) : 0, o.target = r2, o.resolvedTypeArguments = i2), o;
              }
              function ux(r2) {
                var i2 = mc(r2.flags);
                return i2.symbol = r2.symbol, i2.objectFlags = r2.objectFlags, i2.target = r2.target, i2.resolvedTypeArguments = r2.resolvedTypeArguments, i2;
              }
              function tD(r2, i2, t2, o, s2) {
                if (!o) {
                  o = Qd(i2);
                  var u = bg(o);
                  s2 = t2 ? e_(u, t2) : u;
                }
                var h2 = tu(4, r2.symbol);
                return h2.target = r2, h2.node = i2, h2.mapper = t2, h2.aliasSymbol = o, h2.aliasTypeArguments = s2, h2;
              }
              function xo(r2) {
                var i2, t2;
                if (!r2.resolvedTypeArguments) {
                  if (!yu(r2, 6))
                    return ((i2 = r2.target.localTypeParameters) === null || i2 === void 0 ? void 0 : i2.map(function() {
                      return Pe;
                    })) || e2.emptyArray;
                  var o = r2.node, s2 = o ? o.kind === 178 ? e2.concatenate(r2.target.outerTypeParameters, P0(o, r2.target.localTypeParameters)) : o.kind === 183 ? [Va(o.elementType)] : e2.map(o.elements, Va) : e2.emptyArray;
                  fi() ? r2.resolvedTypeArguments = r2.mapper ? e_(s2, r2.mapper) : s2 : (r2.resolvedTypeArguments = ((t2 = r2.target.localTypeParameters) === null || t2 === void 0 ? void 0 : t2.map(function() {
                    return Pe;
                  })) || e2.emptyArray, Xr(r2.node || Ie, r2.target.symbol ? e2.Diagnostics.Type_arguments_for_0_circularly_reference_themselves : e2.Diagnostics.Tuple_type_arguments_circularly_reference_themselves, r2.target.symbol && tn(r2.target.symbol)));
                }
                return r2.resolvedTypeArguments;
              }
              function $_(r2) {
                return e2.length(r2.target.typeParameters);
              }
              function lx(r2, i2) {
                var t2 = go(so(i2)), o = t2.localTypeParameters;
                if (o) {
                  var s2 = e2.length(r2.typeArguments), u = Ul(o), h2 = e2.isInJSFile(r2), z = !n && h2;
                  if (!z && (s2 < u || s2 > o.length)) {
                    var me = h2 && e2.isExpressionWithTypeArguments(r2) && !e2.isJSDocAugmentsTag(r2.parent), Me = u === o.length ? me ? e2.Diagnostics.Expected_0_type_arguments_provide_these_with_an_extends_tag : e2.Diagnostics.Generic_type_0_requires_1_type_argument_s : me ? e2.Diagnostics.Expected_0_1_type_arguments_provide_these_with_an_extends_tag : e2.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments, $e = Ot(t2, void 0, 2);
                    if (Xr(r2, Me, $e, u, o.length), !h2)
                      return Pe;
                  }
                  if (r2.kind === 178 && wx(r2, e2.length(r2.typeArguments) !== o.length))
                    return tD(t2, r2, void 0);
                  var tr = e2.concatenate(t2.outerTypeParameters, zp(bh(r2), o, u, h2));
                  return Yf(t2, tr);
                }
                return Wp(r2, i2) ? t2 : Pe;
              }
              function am(r2, i2, t2, o) {
                var s2 = go(r2);
                if (s2 === De && x2.has(r2.escapedName) && i2 && i2.length === 1)
                  return Th(r2, i2[0]);
                var u = Aa(r2), h2 = u.typeParameters, z = Su(i2) + hg(t2, o), me = u.instantiations.get(z);
                return me || u.instantiations.set(z, me = lE(s2, Uc(h2, zp(i2, h2, Ul(h2), e2.isInJSFile(r2.valueDeclaration))), t2, o)), me;
              }
              function y3(r2, i2) {
                if (e2.getCheckFlags(i2) & 1048576) {
                  var t2 = bh(r2), o = hg(i2, t2), s2 = Ar.get(o);
                  return s2 || (s2 = ms(1, "error"), s2.aliasSymbol = i2, s2.aliasTypeArguments = t2, Ar.set(o, s2)), s2;
                }
                var u = go(i2), h2 = Aa(i2).typeParameters;
                if (h2) {
                  var z = e2.length(r2.typeArguments), me = Ul(h2);
                  if (z < me || z > h2.length)
                    return Xr(r2, me === h2.length ? e2.Diagnostics.Generic_type_0_requires_1_type_argument_s : e2.Diagnostics.Generic_type_0_requires_between_1_and_2_type_arguments, tn(i2), me, h2.length), Pe;
                  var Me = Qd(r2), $e = Me && (fx(i2) || !fx(Me)) ? Me : void 0;
                  return am(i2, bh(r2), $e, bg($e));
                }
                return Wp(r2, i2) ? u : Pe;
              }
              function fx(r2) {
                var i2, t2 = (i2 = r2.declarations) === null || i2 === void 0 ? void 0 : i2.find(e2.isTypeAlias);
                return !!(t2 && e2.getContainingFunction(t2));
              }
              function h3(r2) {
                switch (r2.kind) {
                  case 178:
                    return r2.typeName;
                  case 228:
                    var i2 = r2.expression;
                    if (e2.isEntityNameExpression(i2))
                      return i2;
                }
              }
              function _x(r2) {
                return r2.parent ? "".concat(_x(r2.parent), ".").concat(r2.escapedName) : r2.escapedName;
              }
              function yh(r2) {
                var i2 = r2.kind === 161 ? r2.right : r2.kind === 206 ? r2.name : r2, t2 = i2.escapedText;
                if (t2) {
                  var o = r2.kind === 161 ? yh(r2.left) : r2.kind === 206 ? yh(r2.expression) : void 0, s2 = o ? "".concat(_x(o), ".").concat(t2) : t2, u = mr.get(s2);
                  return u || (mr.set(s2, u = oo(524288, t2, 1048576)), u.parent = o, u.declaredType = Ue), u;
                }
                return xe;
              }
              function nm(r2, i2, t2) {
                var o = h3(r2);
                if (!o)
                  return xe;
                var s2 = Ds(o, i2, t2);
                return s2 && s2 !== xe ? s2 : t2 ? xe : yh(o);
              }
              function hh(r2, i2) {
                if (i2 === xe)
                  return Pe;
                if (i2 = Cc(i2) || i2, i2.flags & 96)
                  return lx(r2, i2);
                if (i2.flags & 524288)
                  return y3(r2, i2);
                var t2 = Vd(i2);
                if (t2)
                  return Wp(r2, i2) ? jc(t2) : Pe;
                if (i2.flags & 111551 && Dh(r2)) {
                  var o = D3(r2, i2);
                  return o || (nm(r2, 788968), Jt(i2));
                }
                return Pe;
              }
              function D3(r2, i2) {
                var t2 = va(r2);
                if (!t2.resolvedJSDocType) {
                  var o = Jt(i2), s2 = o;
                  if (i2.valueDeclaration) {
                    var u = r2.kind === 200 && r2.qualifier;
                    o.symbol && o.symbol !== i2 && u && (s2 = hh(r2, o.symbol));
                  }
                  t2.resolvedJSDocType = s2;
                }
                return t2.resolvedJSDocType;
              }
              function px(r2, i2) {
                if (i2.flags & 3 || i2 === r2)
                  return r2;
                var t2 = "".concat(fu(r2), ">").concat(fu(i2)), o = Ze.get(t2);
                if (o)
                  return o;
                var s2 = mc(33554432);
                return s2.baseType = r2, s2.substitute = i2, Ze.set(t2, s2), s2;
              }
              function dx(r2) {
                return r2.kind === 184 && r2.elements.length === 1;
              }
              function gx(r2, i2, t2) {
                return dx(i2) && dx(t2) ? gx(r2, i2.elements[0], t2.elements[0]) : rp(Va(i2)) === rp(r2) ? Va(t2) : void 0;
              }
              function mx(r2, i2) {
                for (var t2, o = true; i2 && !e2.isStatement(i2) && i2.kind !== 320; ) {
                  var s2 = i2.parent;
                  if (s2.kind === 164 && (o = !o), (o || r2.flags & 8650752) && s2.kind === 189 && i2 === s2.trueType) {
                    var u = gx(r2, s2.checkType, s2.extendsType);
                    u && (t2 = e2.append(t2, u));
                  } else if (r2.flags & 262144 && s2.kind === 195 && i2 === s2.type) {
                    var h2 = Va(s2);
                    if (Du(h2) === rp(r2)) {
                      var z = Ih(h2);
                      if (z) {
                        var u = Tc(z);
                        u && gf(u, Pd) && (t2 = e2.append(t2, Pa([nt, $a])));
                      }
                    }
                  }
                  i2 = s2;
                }
                return t2 ? px(r2, Do(e2.append(t2, r2))) : r2;
              }
              function Dh(r2) {
                return !!(r2.flags & 8388608) && (r2.kind === 178 || r2.kind === 200);
              }
              function Wp(r2, i2) {
                return r2.typeArguments ? (Xr(r2, e2.Diagnostics.Type_0_is_not_generic, i2 ? tn(i2) : r2.typeName ? e2.declarationNameToString(r2.typeName) : C), false) : true;
              }
              function vx(r2) {
                if (e2.isIdentifier(r2.typeName)) {
                  var i2 = r2.typeArguments;
                  switch (r2.typeName.escapedText) {
                    case "String":
                      return Wp(r2), Li;
                    case "Number":
                      return Wp(r2), nt;
                    case "Boolean":
                      return Wp(r2), Ii;
                    case "Void":
                      return Wp(r2), Fi;
                    case "Undefined":
                      return Wp(r2), Tr;
                    case "Null":
                      return Wp(r2), Wi;
                    case "Function":
                    case "function":
                      return Wp(r2), br;
                    case "array":
                      return (!i2 || !i2.length) && !n ? mo : void 0;
                    case "promise":
                      return (!i2 || !i2.length) && !n ? Ny(Oe) : void 0;
                    case "Object":
                      if (i2 && i2.length === 2) {
                        if (e2.isJSDocIndexSignature(r2)) {
                          var t2 = Va(i2[0]), o = Va(i2[1]), s2 = t2 === Li || t2 === nt ? [zl(t2, o, false)] : e2.emptyArray;
                          return rs(void 0, we, e2.emptyArray, e2.emptyArray, s2);
                        }
                        return Oe;
                      }
                      return Wp(r2), n ? void 0 : Oe;
                  }
                }
              }
              function b3(r2) {
                var i2 = Va(r2.type);
                return Ye ? Uh(i2, 65536) : i2;
              }
              function ty(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  if (e2.isConstTypeReference(r2) && e2.isAssertionExpression(r2.parent))
                    return i2.resolvedSymbol = xe, i2.resolvedType = Os(r2.parent.expression);
                  var t2 = void 0, o = void 0, s2 = 788968;
                  Dh(r2) && (o = vx(r2), o || (t2 = nm(r2, s2, true), t2 === xe ? t2 = nm(r2, s2 | 111551) : nm(r2, s2), o = hh(r2, t2))), o || (t2 = nm(r2, s2), o = hh(r2, t2)), i2.resolvedSymbol = t2, i2.resolvedType = o;
                }
                return i2.resolvedType;
              }
              function bh(r2) {
                return e2.map(r2.typeArguments, Va);
              }
              function yx(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  var t2 = kk(r2);
                  i2.resolvedType = jc($c(t2));
                }
                return i2.resolvedType;
              }
              function hx(r2, i2) {
                function t2(s2) {
                  var u = s2.declarations;
                  if (u)
                    for (var h2 = 0, z = u; h2 < z.length; h2++) {
                      var me = z[h2];
                      switch (me.kind) {
                        case 257:
                        case 258:
                        case 260:
                          return me;
                      }
                    }
                }
                if (!r2)
                  return i2 ? kn : Ba;
                var o = go(r2);
                return o.flags & 524288 ? e2.length(o.typeParameters) !== i2 ? (Xr(t2(r2), e2.Diagnostics.Global_type_0_must_have_1_type_parameter_s, e2.symbolName(r2), i2), i2 ? kn : Ba) : o : (Xr(t2(r2), e2.Diagnostics.Global_type_0_must_be_a_class_or_interface_type, e2.symbolName(r2)), i2 ? kn : Ba);
              }
              function Dx(r2, i2) {
                return Ym(r2, 111551, i2 ? e2.Diagnostics.Cannot_find_global_value_0 : void 0);
              }
              function bx(r2, i2) {
                return Ym(r2, 788968, i2 ? e2.Diagnostics.Cannot_find_global_type_0 : void 0);
              }
              function aD(r2, i2, t2) {
                var o = Ym(r2, 788968, t2 ? e2.Diagnostics.Cannot_find_global_type_0 : void 0);
                if (o && (go(o), e2.length(Aa(o).typeParameters) !== i2)) {
                  var s2 = o.declarations && e2.find(o.declarations, e2.isTypeAliasDeclaration);
                  Xr(s2, e2.Diagnostics.Global_type_0_must_have_1_type_parameter_s, e2.symbolName(o), i2);
                  return;
                }
                return o;
              }
              function Ym(r2, i2, t2) {
                return es(void 0, r2, i2, t2, r2, false, false, false);
              }
              function lc(r2, i2, t2) {
                var o = bx(r2, t2);
                return o || t2 ? hx(o, i2) : void 0;
              }
              function S3() {
                return Xs || (Xs = lc("TypedPropertyDescriptor", 1, true) || kn);
              }
              function T3() {
                return pt || (pt = lc("TemplateStringsArray", 0, true) || Ba);
              }
              function Sx() {
                return Pt || (Pt = lc("ImportMeta", 0, true) || Ba);
              }
              function Tx() {
                if (!ga) {
                  var r2 = oo(0, "ImportMetaExpression"), i2 = Sx(), t2 = oo(4, "meta", 8);
                  t2.parent = r2, t2.type = i2;
                  var o = e2.createSymbolTable([t2]);
                  r2.members = o, ga = rs(r2, o, e2.emptyArray, e2.emptyArray, e2.emptyArray);
                }
                return ga;
              }
              function xx(r2) {
                return ua || (ua = lc("ImportCallOptions", 0, r2)) || Ba;
              }
              function Ex(r2) {
                return Pc || (Pc = Dx("Symbol", r2));
              }
              function x3(r2) {
                return Vc || (Vc = bx("SymbolConstructor", r2));
              }
              function Cx() {
                return Kc || (Kc = lc("Symbol", 0, false)) || Ba;
              }
              function ay(r2) {
                return pc || (pc = lc("Promise", 1, r2)) || kn;
              }
              function kx(r2) {
                return hs || (hs = lc("PromiseLike", 1, r2)) || kn;
              }
              function nD(r2) {
                return tc || (tc = Dx("Promise", r2));
              }
              function E3(r2) {
                return ps || (ps = lc("PromiseConstructorLike", 0, r2)) || Ba;
              }
              function C3(r2) {
                return yi || (yi = lc("AsyncIterable", 1, r2)) || kn;
              }
              function k3(r2) {
                return qi || (qi = lc("AsyncIterator", 3, r2)) || kn;
              }
              function A3(r2) {
                return je || (je = lc("AsyncIterableIterator", 1, r2)) || kn;
              }
              function N3(r2) {
                return Hr || (Hr = lc("AsyncGenerator", 3, r2)) || kn;
              }
              function Ax(r2) {
                return Qs || (Qs = lc("Iterable", 1, r2)) || kn;
              }
              function P3(r2) {
                return js || (js = lc("Iterator", 3, r2)) || kn;
              }
              function I3(r2) {
                return ds || (ds = lc("IterableIterator", 1, r2)) || kn;
              }
              function w3(r2) {
                return Ji || (Ji = lc("Generator", 3, r2)) || kn;
              }
              function O3(r2) {
                return ce || (ce = lc("IteratorYieldResult", 1, r2)) || kn;
              }
              function F3(r2) {
                return Rr || (Rr = lc("IteratorReturnResult", 1, r2)) || kn;
              }
              function Nx(r2, i2) {
                i2 === void 0 && (i2 = 0);
                var t2 = Ym(r2, 788968, void 0);
                return t2 && hx(t2, i2);
              }
              function M3() {
                return Xn || (Xn = aD("Extract", 2, true) || xe), Xn === xe ? void 0 : Xn;
              }
              function L3() {
                return jr || (jr = aD("Omit", 2, true) || xe), jr === xe ? void 0 : jr;
              }
              function oD(r2) {
                return fo || (fo = aD("Awaited", 1, r2) || (r2 ? xe : void 0)), fo === xe ? void 0 : fo;
              }
              function R3() {
                return xs || (xs = lc("BigInt", 0, false)) || Ba;
              }
              function $m(r2, i2) {
                return r2 !== kn ? Yf(r2, i2) : Ba;
              }
              function Px(r2) {
                return $m(S3(), [r2]);
              }
              function B3(r2) {
                return $m(Ax(true), [r2]);
              }
              function Zs(r2, i2) {
                return $m(i2 ? Qi : Pi, [r2]);
              }
              function sD(r2) {
                switch (r2.kind) {
                  case 185:
                    return 2;
                  case 186:
                    return Ix(r2);
                  case 197:
                    return r2.questionToken ? 2 : r2.dotDotDotToken ? Ix(r2) : 1;
                  default:
                    return 1;
                }
              }
              function Ix(r2) {
                return sy(r2.type) ? 4 : 8;
              }
              function J3(r2) {
                var i2 = U3(r2.parent), t2 = sy(r2);
                if (t2)
                  return i2 ? Qi : Pi;
                var o = e2.map(r2.elements, sD), s2 = e2.some(r2.elements, function(u) {
                  return u.kind !== 197;
                });
                return cD(o, i2, s2 ? void 0 : r2.elements);
              }
              function wx(r2, i2) {
                return !!Qd(r2) || Ox(r2) && (r2.kind === 183 ? x_(r2.elementType) : r2.kind === 184 ? e2.some(r2.elements, x_) : i2 || e2.some(r2.typeArguments, x_));
              }
              function Ox(r2) {
                var i2 = r2.parent;
                switch (i2.kind) {
                  case 191:
                  case 197:
                  case 178:
                  case 187:
                  case 188:
                  case 194:
                  case 189:
                  case 193:
                  case 183:
                  case 184:
                    return Ox(i2);
                  case 259:
                    return true;
                }
                return false;
              }
              function x_(r2) {
                switch (r2.kind) {
                  case 178:
                    return Dh(r2) || !!(nm(r2, 788968).flags & 524288);
                  case 181:
                    return true;
                  case 193:
                    return r2.operator !== 154 && x_(r2.type);
                  case 191:
                  case 185:
                  case 197:
                  case 316:
                  case 314:
                  case 315:
                  case 309:
                    return x_(r2.type);
                  case 186:
                    return r2.type.kind !== 183 || x_(r2.type.elementType);
                  case 187:
                  case 188:
                    return e2.some(r2.types, x_);
                  case 194:
                    return x_(r2.objectType) || x_(r2.indexType);
                  case 189:
                    return x_(r2.checkType) || x_(r2.extendsType) || x_(r2.trueType) || x_(r2.falseType);
                }
                return false;
              }
              function j3(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  var t2 = J3(r2);
                  if (t2 === kn)
                    i2.resolvedType = Ba;
                  else if (!(r2.kind === 184 && e2.some(r2.elements, function(s2) {
                    return !!(sD(s2) & 8);
                  })) && wx(r2))
                    i2.resolvedType = r2.kind === 184 && r2.elements.length === 0 ? t2 : tD(t2, r2, void 0);
                  else {
                    var o = r2.kind === 183 ? [Va(r2.elementType)] : e2.map(r2.elements, Va);
                    i2.resolvedType = uD(t2, o);
                  }
                }
                return i2.resolvedType;
              }
              function U3(r2) {
                return e2.isTypeOperatorNode(r2) && r2.operator === 145;
              }
              function Wl(r2, i2, t2, o) {
                t2 === void 0 && (t2 = false);
                var s2 = cD(i2 || e2.map(r2, function(u) {
                  return 1;
                }), t2, o);
                return s2 === kn ? Ba : r2.length ? uD(s2, r2) : s2;
              }
              function cD(r2, i2, t2) {
                if (r2.length === 1 && r2[0] & 4)
                  return i2 ? Qi : Pi;
                var o = e2.map(r2, function(u) {
                  return u & 1 ? "#" : u & 2 ? "?" : u & 4 ? "." : "*";
                }).join() + (i2 ? "R" : "") + (t2 && t2.length ? "," + e2.map(t2, A2).join(",") : ""), s2 = et.get(o);
                return s2 || et.set(o, s2 = z3(r2, i2, t2)), s2;
              }
              function z3(r2, i2, t2) {
                var o = r2.length, s2 = e2.countWhere(r2, function(Ti) {
                  return !!(Ti & 9);
                }), u, h2 = [], z = 0;
                if (o) {
                  u = new Array(o);
                  for (var me = 0; me < o; me++) {
                    var Me = u[me] = Hc(), $e = r2[me];
                    if (z |= $e, !(z & 12)) {
                      var tr = oo(4 | ($e & 2 ? 16777216 : 0), "" + me, i2 ? 8 : 0);
                      tr.tupleLabelDeclaration = t2 == null ? void 0 : t2[me], tr.type = Me, h2.push(tr);
                    }
                  }
                }
                var dr = h2.length, Dr = oo(4, "length", i2 ? 8 : 0);
                if (z & 12)
                  Dr.type = nt;
                else {
                  for (var Qr = [], me = s2; me <= o; me++)
                    Qr.push(If(me));
                  Dr.type = Pa(Qr);
                }
                h2.push(Dr);
                var li = tu(12);
                return li.typeParameters = u, li.outerTypeParameters = void 0, li.localTypeParameters = u, li.instantiations = new e2.Map(), li.instantiations.set(Su(li.typeParameters), li), li.target = li, li.resolvedTypeArguments = li.typeParameters, li.thisType = Hc(), li.thisType.isThisType = true, li.thisType.constraint = li, li.declaredProperties = h2, li.declaredCallSignatures = e2.emptyArray, li.declaredConstructSignatures = e2.emptyArray, li.declaredIndexInfos = e2.emptyArray, li.elementFlags = r2, li.minLength = s2, li.fixedLength = dr, li.hasRestElement = !!(z & 12), li.combinedFlags = z, li.readonly = i2, li.labeledElementDeclarations = t2, li;
              }
              function uD(r2, i2) {
                return r2.objectFlags & 8 ? Fx(r2, i2) : Yf(r2, i2);
              }
              function Fx(r2, i2) {
                var t2, o, s2;
                if (!(r2.combinedFlags & 14))
                  return Yf(r2, i2);
                if (r2.combinedFlags & 8) {
                  var u = e2.findIndex(i2, function(Ci, $i) {
                    return !!(r2.elementFlags[$i] & 8 && Ci.flags & 1179648);
                  });
                  if (u >= 0)
                    return ny(e2.map(i2, function(Ci, $i) {
                      return r2.elementFlags[$i] & 8 ? Ci : gr;
                    })) ? Ss(i2[u], function(Ci) {
                      return Fx(r2, e2.replaceElement(i2, u, Ci));
                    }) : Pe;
                }
                for (var h2 = [], z = [], me = [], Me = -1, $e = -1, tr = -1, dr = function(Ci) {
                  var $i = i2[Ci], Zi = r2.elementFlags[Ci];
                  if (Zi & 8)
                    if ($i.flags & 58982400 || Bc($i))
                      Ti($i, 8, (t2 = r2.labeledElementDeclarations) === null || t2 === void 0 ? void 0 : t2[Ci]);
                    else if (Yn($i)) {
                      var qt = xo($i);
                      if (qt.length + h2.length >= 1e4)
                        return Xr(Ie, e2.isPartOfTypeNode(Ie) ? e2.Diagnostics.Type_produces_a_tuple_type_that_is_too_large_to_represent : e2.Diagnostics.Expression_produces_a_tuple_type_that_is_too_large_to_represent), { value: Pe };
                      e2.forEach(qt, function(Nt, Ra) {
                        var ca;
                        return Ti(Nt, $i.target.elementFlags[Ra], (ca = $i.target.labeledElementDeclarations) === null || ca === void 0 ? void 0 : ca[Ra]);
                      });
                    } else
                      Ti(sp($i) && cs($i, nt) || Pe, 4, (o = r2.labeledElementDeclarations) === null || o === void 0 ? void 0 : o[Ci]);
                  else
                    Ti($i, Zi, (s2 = r2.labeledElementDeclarations) === null || s2 === void 0 ? void 0 : s2[Ci]);
                }, Dr = 0; Dr < i2.length; Dr++) {
                  var Qr = dr(Dr);
                  if (typeof Qr == "object")
                    return Qr.value;
                }
                for (var Dr = 0; Dr < Me; Dr++)
                  z[Dr] & 2 && (z[Dr] = 1);
                $e >= 0 && $e < tr && (h2[$e] = Pa(e2.sameMap(h2.slice($e, tr + 1), function(Ci, $i) {
                  return z[$e + $i] & 8 ? Jc(Ci, nt) : Ci;
                })), h2.splice($e + 1, tr - $e), z.splice($e + 1, tr - $e), me == null || me.splice($e + 1, tr - $e));
                var li = cD(z, r2.readonly, me);
                return li === kn ? Ba : z.length ? Yf(li, h2) : li;
                function Ti(Ci, $i, Zi) {
                  $i & 1 && (Me = z.length), $i & 4 && $e < 0 && ($e = z.length), $i & 6 && (tr = z.length), h2.push(Ci), z.push($i), me && Zi ? me.push(Zi) : me = void 0;
                }
              }
              function Zm(r2, i2, t2) {
                t2 === void 0 && (t2 = 0);
                var o = r2.target, s2 = $_(r2) - t2;
                return i2 > o.fixedLength ? Aw(r2) || Wl(e2.emptyArray) : Wl(xo(r2).slice(i2, s2), o.elementFlags.slice(i2, s2), false, o.labeledElementDeclarations && o.labeledElementDeclarations.slice(i2, s2));
              }
              function Mx(r2) {
                return Pa(e2.append(e2.arrayOf(r2.target.fixedLength, function(i2) {
                  return Bu("" + i2);
                }), ql(r2.target.readonly ? Qi : Pi)));
              }
              function Lx(r2, i2) {
                var t2 = e2.findIndex(r2.elementFlags, function(o) {
                  return !(o & i2);
                });
                return t2 >= 0 ? t2 : r2.elementFlags.length;
              }
              function Sh(r2, i2) {
                return r2.elementFlags.length - e2.findLastIndex(r2.elementFlags, function(t2) {
                  return !(t2 & i2);
                }) - 1;
              }
              function W3(r2) {
                return kc(Va(r2.type), true);
              }
              function fu(r2) {
                return r2.id;
              }
              function $f(r2, i2) {
                return e2.binarySearch(r2, i2, fu, e2.compareValues) >= 0;
              }
              function lD(r2, i2) {
                var t2 = e2.binarySearch(r2, i2, fu, e2.compareValues);
                return t2 < 0 ? (r2.splice(~t2, 0, i2), true) : false;
              }
              function q3(r2, i2, t2) {
                var o = t2.flags;
                if (o & 1048576)
                  return Rx(r2, i2 | (H3(t2) ? 1048576 : 0), t2.types);
                if (!(o & 131072))
                  if (i2 |= o & 205258751, o & 465829888 && (i2 |= 33554432), t2 === Mr && (i2 |= 8388608), !Ye && o & 98304)
                    e2.getObjectFlags(t2) & 65536 || (i2 |= 4194304);
                  else {
                    var s2 = r2.length, u = s2 && t2.id > r2[s2 - 1].id ? ~s2 : e2.binarySearch(r2, t2, fu, e2.compareValues);
                    u < 0 && r2.splice(~u, 0, t2);
                  }
                return i2;
              }
              function Rx(r2, i2, t2) {
                for (var o = 0, s2 = t2; o < s2.length; o++) {
                  var u = s2[o];
                  i2 = q3(r2, i2, u);
                }
                return i2;
              }
              function V3(r2, i2) {
                if (r2.length < 2)
                  return r2;
                var t2 = Su(r2), o = Sr.get(t2);
                if (o)
                  return o;
                for (var s2 = i2 && e2.some(r2, function(Ti) {
                  return !!(Ti.flags & 524288) && !Bc(Ti) && LD(Ru(Ti));
                }), u = r2.length, h2 = u, z = 0; h2 > 0; ) {
                  h2--;
                  var me = r2[h2];
                  if (s2 || me.flags & 469499904)
                    for (var Me = me.flags & 61603840 ? e2.find(uo(me), function(Ti) {
                      return Vl(Jt(Ti));
                    }) : void 0, $e = Me && jc(Jt(Me)), tr = 0, dr = r2; tr < dr.length; tr++) {
                      var Dr = dr[tr];
                      if (me !== Dr) {
                        if (z === 1e5) {
                          var Qr = z / (u - h2) * u;
                          if (Qr > 1e6) {
                            e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("checkTypes", "removeSubtypes_DepthLimit", { typeIds: r2.map(function(Ti) {
                              return Ti.id;
                            }) }), Xr(Ie, e2.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent);
                            return;
                          }
                        }
                        if (z++, Me && Dr.flags & 61603840) {
                          var li = da(Dr, Me.escapedName);
                          if (li && Vl(li) && jc(li) !== $e)
                            continue;
                        }
                        if (r_(me, Dr, ki) && (!(e2.getObjectFlags(bd(me)) & 1) || !(e2.getObjectFlags(bd(Dr)) & 1) || xg(me, Dr))) {
                          e2.orderedRemoveItemAt(r2, h2);
                          break;
                        }
                      }
                    }
                }
                return Sr.set(t2, r2), r2;
              }
              function K3(r2, i2, t2) {
                for (var o = r2.length; o > 0; ) {
                  o--;
                  var s2 = r2[o], u = s2.flags, h2 = u & 402653312 && i2 & 4 || u & 256 && i2 & 8 || u & 2048 && i2 & 64 || u & 8192 && i2 & 4096 || t2 && u & 32768 && i2 & 16384 || Kp(s2) && $f(r2, s2.regularType);
                  h2 && e2.orderedRemoveItemAt(r2, o);
                }
              }
              function G3(r2) {
                var i2 = e2.filter(r2, sm);
                if (i2.length)
                  for (var t2 = r2.length, o = function() {
                    t2--;
                    var s2 = r2[t2];
                    s2.flags & 128 && e2.some(i2, function(u) {
                      return VE(s2, u);
                    }) && e2.orderedRemoveItemAt(r2, t2);
                  }; t2 > 0; )
                    o();
              }
              function H3(r2) {
                return !!(r2.flags & 1048576 && (r2.aliasSymbol || r2.origin));
              }
              function Bx(r2, i2) {
                for (var t2 = 0, o = i2; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  if (s2.flags & 1048576) {
                    var u = s2.origin;
                    s2.aliasSymbol || u && !(u.flags & 1048576) ? e2.pushIfUnique(r2, s2) : u && u.flags & 1048576 && Bx(r2, u.types);
                  }
                }
              }
              function fD(r2, i2) {
                var t2 = Ip(r2);
                return t2.types = i2, t2;
              }
              function Pa(r2, i2, t2, o, s2) {
                if (i2 === void 0 && (i2 = 1), r2.length === 0)
                  return ui;
                if (r2.length === 1)
                  return r2[0];
                var u = [], h2 = Rx(u, 0, r2);
                if (i2 !== 0) {
                  if (h2 & 3)
                    return h2 & 1 ? h2 & 8388608 ? Mr : Oe : h2 & 65536 || $f(u, gr) ? gr : Vr;
                  if (yr && h2 & 32768) {
                    var z = e2.binarySearch(u, Yi, fu, e2.compareValues);
                    z >= 0 && $f(u, Tr) && e2.orderedRemoveItemAt(u, z);
                  }
                  if ((h2 & 402664320 || h2 & 16384 && h2 & 32768) && K3(u, h2, !!(i2 & 2)), h2 & 128 && h2 & 134217728 && G3(u), i2 === 2 && (u = V3(u, !!(h2 & 524288)), !u))
                    return Pe;
                  if (u.length === 0)
                    return h2 & 65536 ? h2 & 4194304 ? Wi : ct : h2 & 32768 ? h2 & 4194304 ? Tr : vi : ui;
                }
                if (!s2 && h2 & 1048576) {
                  var me = [];
                  Bx(me, r2);
                  for (var Me = [], $e = function($i) {
                    e2.some(me, function(Zi) {
                      return $f(Zi.types, $i);
                    }) || Me.push($i);
                  }, tr = 0, dr = u; tr < dr.length; tr++) {
                    var Dr = dr[tr];
                    $e(Dr);
                  }
                  if (!t2 && me.length === 1 && Me.length === 0)
                    return me[0];
                  var Qr = e2.reduceLeft(me, function($i, Zi) {
                    return $i + Zi.types.length;
                  }, 0);
                  if (Qr + Me.length === u.length) {
                    for (var li = 0, Ti = me; li < Ti.length; li++) {
                      var Dr = Ti[li];
                      lD(Me, Dr);
                    }
                    s2 = fD(1048576, Me);
                  }
                }
                var Ci = (h2 & 36323363 ? 0 : 32768) | (h2 & 2097152 ? 16777216 : 0);
                return pD(u, Ci, t2, o, s2);
              }
              function X3(r2, i2) {
                for (var t2, o = [], s2 = 0, u = r2; s2 < u.length; s2++) {
                  var h2 = u[s2], z = Yc(h2);
                  if (!z || z.kind === 2 || z.kind === 3) {
                    if (i2 !== 2097152)
                      continue;
                    return;
                  }
                  if (t2) {
                    if (!_D(t2, z))
                      return;
                  } else
                    t2 = z;
                  o.push(z.type);
                }
                if (!!t2) {
                  var me = iy(o, i2);
                  return vg(t2.kind, t2.parameterName, t2.parameterIndex, me);
                }
              }
              function _D(r2, i2) {
                return r2.kind === i2.kind && r2.parameterIndex === i2.parameterIndex;
              }
              function pD(r2, i2, t2, o, s2) {
                if (r2.length === 0)
                  return ui;
                if (r2.length === 1)
                  return r2[0];
                var u = s2 ? s2.flags & 1048576 ? "|".concat(Su(s2.types)) : s2.flags & 2097152 ? "&".concat(Su(s2.types)) : "#".concat(s2.type.id, "|").concat(Su(r2)) : Su(r2), h2 = u + hg(t2, o), z = Gi.get(h2);
                return z || (z = mc(1048576), z.objectFlags = i2 | iD(r2, 98304), z.types = r2, z.origin = s2, z.aliasSymbol = t2, z.aliasTypeArguments = o, r2.length === 2 && r2[0].flags & 512 && r2[1].flags & 512 && (z.flags |= 16, z.intrinsicName = "boolean"), Gi.set(h2, z)), z;
              }
              function Q3(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  var t2 = Qd(r2);
                  i2.resolvedType = Pa(e2.map(r2.types, Va), 1, t2, bg(t2));
                }
                return i2.resolvedType;
              }
              function Y3(r2, i2, t2) {
                var o = t2.flags;
                return o & 2097152 ? Jx(r2, i2, t2.types) : (vE(t2) ? i2 & 16777216 || (i2 |= 16777216, r2.set(t2.id.toString(), t2)) : (o & 3 ? t2 === Mr && (i2 |= 8388608) : (Ye || !(o & 98304)) && (yr && t2 === Yi && (i2 |= 262144, t2 = Tr), r2.has(t2.id.toString()) || (t2.flags & 109440 && i2 & 109440 && (i2 |= 67108864), r2.set(t2.id.toString(), t2))), i2 |= o & 205258751), i2);
              }
              function Jx(r2, i2, t2) {
                for (var o = 0, s2 = t2; o < s2.length; o++) {
                  var u = s2[o];
                  i2 = Y3(r2, i2, jc(u));
                }
                return i2;
              }
              function $3(r2, i2) {
                for (var t2 = r2.length; t2 > 0; ) {
                  t2--;
                  var o = r2[t2], s2 = o.flags & 4 && i2 & 402653312 || o.flags & 8 && i2 & 256 || o.flags & 64 && i2 & 2048 || o.flags & 4096 && i2 & 8192;
                  s2 && e2.orderedRemoveItemAt(r2, t2);
                }
              }
              function Z3(r2, i2) {
                for (var t2 = 0, o = r2; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  if (!$f(s2.types, i2)) {
                    var u = i2.flags & 128 ? Li : i2.flags & 256 ? nt : i2.flags & 2048 ? Mt : i2.flags & 8192 ? Ki : void 0;
                    if (!u || !$f(s2.types, u))
                      return false;
                  }
                }
                return true;
              }
              function eI(r2) {
                for (var i2 = r2.length, t2 = e2.filter(r2, function(z) {
                  return !!(z.flags & 128);
                }); i2 > 0; ) {
                  i2--;
                  var o = r2[i2];
                  if (!!(o.flags & 134217728))
                    for (var s2 = 0, u = t2; s2 < u.length; s2++) {
                      var h2 = u[s2];
                      if (E_(h2, o)) {
                        e2.orderedRemoveItemAt(r2, i2);
                        break;
                      } else if (sm(o))
                        return true;
                    }
                }
                return false;
              }
              function jx(r2, i2) {
                return e2.every(r2, function(t2) {
                  return !!(t2.flags & 1048576) && e2.some(t2.types, function(o) {
                    return !!(o.flags & i2);
                  });
                });
              }
              function Ux(r2, i2) {
                for (var t2 = 0; t2 < r2.length; t2++)
                  r2[t2] = ec(r2[t2], function(o) {
                    return !(o.flags & i2);
                  });
              }
              function rI(r2) {
                var i2, t2 = e2.findIndex(r2, function(dr) {
                  return !!(e2.getObjectFlags(dr) & 32768);
                });
                if (t2 < 0)
                  return false;
                for (var o = t2 + 1; o < r2.length; ) {
                  var s2 = r2[o];
                  e2.getObjectFlags(s2) & 32768 ? ((i2 || (i2 = [r2[t2]])).push(s2), e2.orderedRemoveItemAt(r2, o)) : o++;
                }
                if (!i2)
                  return false;
                for (var u = [], h2 = [], z = 0, me = i2; z < me.length; z++)
                  for (var Me = me[z], $e = 0, tr = Me.types; $e < tr.length; $e++) {
                    var s2 = tr[$e];
                    lD(u, s2) && Z3(i2, s2) && lD(h2, s2);
                  }
                return r2[t2] = pD(h2, 32768), true;
              }
              function iI(r2, i2, t2) {
                var o = mc(2097152);
                return o.objectFlags = iD(r2, 98304), o.types = r2, o.aliasSymbol = i2, o.aliasTypeArguments = t2, o;
              }
              function Do(r2, i2, t2) {
                var o = new e2.Map(), s2 = Jx(o, 0, r2), u = e2.arrayFrom(o.values());
                if (s2 & 131072)
                  return e2.contains(u, Bt) ? Bt : ui;
                if (Ye && s2 & 98304 && s2 & 84410368 || s2 & 67108864 && s2 & 402783228 || s2 & 402653316 && s2 & 67238776 || s2 & 296 && s2 & 469891796 || s2 & 2112 && s2 & 469889980 || s2 & 12288 && s2 & 469879804 || s2 & 49152 && s2 & 469842940 || s2 & 134217728 && s2 & 128 && eI(u))
                  return ui;
                if (s2 & 1)
                  return s2 & 8388608 ? Mr : Oe;
                if (!Ye && s2 & 98304)
                  return s2 & 32768 ? Tr : Wi;
                if ((s2 & 4 && s2 & 402653312 || s2 & 8 && s2 & 256 || s2 & 64 && s2 & 2048 || s2 & 4096 && s2 & 8192) && $3(u, s2), s2 & 16777216 && s2 & 524288 && e2.orderedRemoveItemAt(u, e2.findIndex(u, vE)), s2 & 262144 && (u[u.indexOf(Tr)] = Yi), u.length === 0)
                  return gr;
                if (u.length === 1)
                  return u[0];
                var h2 = Su(u) + hg(i2, t2), z = Wt.get(h2);
                if (!z) {
                  if (s2 & 1048576)
                    if (rI(u))
                      z = Do(u, i2, t2);
                    else if (jx(u, 32768)) {
                      var me = yr && e2.some(u, function(tr) {
                        return $f(tr.types, Yi);
                      }) ? Yi : Tr;
                      Ux(u, 32768), z = Pa([Do(u), me], 1, i2, t2);
                    } else if (jx(u, 65536))
                      Ux(u, 65536), z = Pa([Do(u), Wi], 1, i2, t2);
                    else {
                      if (!ny(u))
                        return Pe;
                      var Me = tI(u), $e = e2.some(Me, function(tr) {
                        return !!(tr.flags & 2097152);
                      }) ? fD(2097152, u) : void 0;
                      z = Pa(Me, 1, i2, t2, $e);
                    }
                  else
                    z = iI(u, i2, t2);
                  Wt.set(h2, z);
                }
                return z;
              }
              function zx(r2) {
                return e2.reduceLeft(r2, function(i2, t2) {
                  return t2.flags & 1048576 ? i2 * t2.types.length : t2.flags & 131072 ? 0 : i2;
                }, 1);
              }
              function ny(r2) {
                var i2 = zx(r2);
                return i2 >= 1e5 ? (e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("checkTypes", "checkCrossProductUnion_DepthLimit", { typeIds: r2.map(function(t2) {
                  return t2.id;
                }), size: i2 }), Xr(Ie, e2.Diagnostics.Expression_produces_a_union_type_that_is_too_complex_to_represent), false) : true;
              }
              function tI(r2) {
                for (var i2 = zx(r2), t2 = [], o = 0; o < i2; o++) {
                  for (var s2 = r2.slice(), u = o, h2 = r2.length - 1; h2 >= 0; h2--)
                    if (r2[h2].flags & 1048576) {
                      var z = r2[h2].types, me = z.length;
                      s2[h2] = z[u % me], u = Math.floor(u / me);
                    }
                  var Me = Do(s2);
                  Me.flags & 131072 || t2.push(Me);
                }
                return t2;
              }
              function aI(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  var t2 = Qd(r2);
                  i2.resolvedType = Do(e2.map(r2.types, Va), t2, bg(t2));
                }
                return i2.resolvedType;
              }
              function Wx(r2, i2) {
                var t2 = mc(4194304);
                return t2.type = r2, t2.stringsOnly = i2, t2;
              }
              function nI(r2) {
                var i2 = Ip(4194304);
                return i2.type = r2, i2;
              }
              function dD(r2, i2) {
                return i2 ? r2.resolvedStringIndexType || (r2.resolvedStringIndexType = Wx(r2, true)) : r2.resolvedIndexType || (r2.resolvedIndexType = Wx(r2, false));
              }
              function oI(r2, i2, t2) {
                var o = Du(r2), s2 = Mu(r2), u = Jl(r2.target || r2);
                if (!u && !t2)
                  return s2;
                var h2 = [];
                if (mg(r2)) {
                  if (qp(s2))
                    return dD(r2, i2);
                  var z = $s(Ed(r2));
                  Um(z, 8576, i2, Me);
                } else
                  Od(Kd(s2), Me);
                qp(s2) && Od(s2, Me);
                var me = t2 ? ec(Pa(h2), function($e) {
                  return !($e.flags & 5);
                }) : Pa(h2);
                if (me.flags & 1048576 && s2.flags & 1048576 && Su(me.types) === Su(s2.types))
                  return s2;
                return me;
                function Me($e) {
                  var tr = u ? un(u, tv(r2.mapper, o, $e)) : $e;
                  h2.push(tr === Li ? ji : tr);
                }
              }
              function sI(r2) {
                var i2 = Du(r2);
                return t2(Jl(r2) || i2);
                function t2(o) {
                  return o.flags & 68157439 ? true : o.flags & 16777216 ? o.root.isDistributive && o.checkType === i2 : o.flags & 137363456 ? e2.every(o.types, t2) : o.flags & 8388608 ? t2(o.objectType) && t2(o.indexType) : o.flags & 33554432 ? t2(o.substitute) : o.flags & 268435456 ? t2(o.type) : false;
                }
              }
              function Z_(r2) {
                return e2.isPrivateIdentifier(r2) ? ui : e2.isIdentifier(r2) ? Bu(e2.unescapeLeadingUnderscores(r2.escapedText)) : jc(e2.isComputedPropertyName(r2) ? t_(r2) : yn(r2));
              }
              function om(r2, i2, t2) {
                if (t2 || !(e2.getDeclarationModifierFlagsFromSymbol(r2) & 24)) {
                  var o = Aa(dg(r2)).nameType;
                  if (!o) {
                    var s2 = e2.getNameOfDeclaration(r2.valueDeclaration);
                    o = r2.escapedName === "default" ? Bu("default") : s2 && Z_(s2) || (e2.isKnownSymbol(r2) ? void 0 : Bu(e2.symbolName(r2)));
                  }
                  if (o && o.flags & i2)
                    return o;
                }
                return ui;
              }
              function qx(r2, i2) {
                return !!(r2.flags & i2 || r2.flags & 2097152 && e2.some(r2.types, function(t2) {
                  return qx(t2, i2);
                }));
              }
              function cI(r2, i2, t2) {
                var o = t2 && (e2.getObjectFlags(r2) & 7 || r2.aliasSymbol) ? nI(r2) : void 0, s2 = e2.map(uo(r2), function(h2) {
                  return om(h2, i2);
                }), u = e2.map(Hn(r2), function(h2) {
                  return h2 !== Ko && qx(h2.keyType, i2) ? h2.keyType === Li && i2 & 8 ? ji : h2.keyType : ui;
                });
                return Pa(e2.concatenate(s2, u), 1, void 0, void 0, o);
              }
              function uI(r2) {
                return e2.some(r2.types, function(i2) {
                  var t2 = KI(i2);
                  return bu(t2) !== t2;
                });
              }
              function ql(r2, i2, t2) {
                return i2 === void 0 && (i2 = Ge), r2 = bu(r2), r2.flags & 1048576 ? uI(r2) ? dD(r2, i2) : Do(e2.map(r2.types, function(o) {
                  return ql(o, i2, t2);
                })) : r2.flags & 2097152 ? Pa(e2.map(r2.types, function(o) {
                  return ql(o, i2, t2);
                })) : r2.flags & 58982400 || lm(r2) || Bc(r2) && !sI(r2) ? dD(r2, i2) : e2.getObjectFlags(r2) & 32 ? oI(r2, i2, t2) : r2 === Mr ? Mr : r2.flags & 2 ? ui : r2.flags & 131073 ? at : cI(r2, (t2 ? 128 : 402653316) | (i2 ? 0 : 12584), i2 === Ge && !t2);
              }
              function Vx(r2) {
                if (Ge)
                  return r2;
                var i2 = M3();
                return i2 ? am(i2, [r2, Li]) : Li;
              }
              function lI(r2) {
                var i2 = Vx(ql(r2));
                return i2.flags & 131072 ? Li : i2;
              }
              function fI(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType)
                  switch (r2.operator) {
                    case 140:
                      i2.resolvedType = ql(Va(r2.type));
                      break;
                    case 154:
                      i2.resolvedType = r2.type.kind === 151 ? CD(e2.walkUpParenthesizedTypes(r2.parent)) : Pe;
                      break;
                    case 145:
                      i2.resolvedType = Va(r2.type);
                      break;
                    default:
                      throw e2.Debug.assertNever(r2.operator);
                  }
                return i2.resolvedType;
              }
              function _I(r2) {
                var i2 = va(r2);
                return i2.resolvedType || (i2.resolvedType = Dg(Ve([r2.head.text], e2.map(r2.templateSpans, function(t2) {
                  return t2.literal.text;
                }), true), e2.map(r2.templateSpans, function(t2) {
                  return Va(t2.type);
                }))), i2.resolvedType;
              }
              function Dg(r2, i2) {
                var t2 = e2.findIndex(i2, function(Me) {
                  return !!(Me.flags & 1179648);
                });
                if (t2 >= 0)
                  return ny(i2) ? Ss(i2[t2], function(Me) {
                    return Dg(r2, e2.replaceElement(i2, t2, Me));
                  }) : Pe;
                if (e2.contains(i2, Mr))
                  return Mr;
                var o = [], s2 = [], u = r2[0];
                if (!me(r2, i2))
                  return Li;
                if (o.length === 0)
                  return Bu(u);
                if (s2.push(u), e2.every(s2, function(Me) {
                  return Me === "";
                }) && e2.every(o, function(Me) {
                  return !!(Me.flags & 4);
                }))
                  return Li;
                var h2 = "".concat(Su(o), "|").concat(e2.map(s2, function(Me) {
                  return Me.length;
                }).join(","), "|").concat(s2.join("")), z = Jr.get(h2);
                return z || Jr.set(h2, z = dI(s2, o)), z;
                function me(Me, $e) {
                  for (var tr = e2.isArray(Me), dr = 0; dr < $e.length; dr++) {
                    var Dr = $e[dr], Qr = tr ? Me[dr + 1] : Me;
                    if (Dr.flags & 101248) {
                      if (u += pI(Dr) || "", u += Qr, !tr)
                        return true;
                    } else if (Dr.flags & 134217728) {
                      if (u += Dr.texts[0], !me(Dr.texts, Dr.types))
                        return false;
                      if (u += Qr, !tr)
                        return true;
                    } else if (qp(Dr) || Gx(Dr))
                      o.push(Dr), s2.push(u), u = Qr;
                    else if (Dr.flags & 2097152) {
                      var li = me(Me[dr + 1], Dr.types);
                      if (!li)
                        return false;
                    } else if (tr)
                      return false;
                  }
                  return true;
                }
              }
              function pI(r2) {
                return r2.flags & 128 ? r2.value : r2.flags & 256 ? "" + r2.value : r2.flags & 2048 ? e2.pseudoBigIntToString(r2.value) : r2.flags & 98816 ? r2.intrinsicName : void 0;
              }
              function dI(r2, i2) {
                var t2 = mc(134217728);
                return t2.texts = r2, t2.types = i2, t2;
              }
              function Th(r2, i2) {
                return i2.flags & 1179648 ? Ss(i2, function(t2) {
                  return Th(r2, t2);
                }) : qp(i2) ? mI(r2, i2) : i2.flags & 128 ? Bu(gI(r2, i2.value)) : i2;
              }
              function gI(r2, i2) {
                switch (x2.get(r2.escapedName)) {
                  case 0:
                    return i2.toUpperCase();
                  case 1:
                    return i2.toLowerCase();
                  case 2:
                    return i2.charAt(0).toUpperCase() + i2.slice(1);
                  case 3:
                    return i2.charAt(0).toLowerCase() + i2.slice(1);
                }
                return i2;
              }
              function mI(r2, i2) {
                var t2 = "".concat(y(r2), ",").concat(fu(i2)), o = ti.get(t2);
                return o || ti.set(t2, o = vI(r2, i2)), o;
              }
              function vI(r2, i2) {
                var t2 = mc(268435456);
                return t2.symbol = r2, t2.type = i2, t2;
              }
              function yI(r2, i2, t2, o, s2) {
                var u = mc(8388608);
                return u.objectType = r2, u.indexType = i2, u.accessFlags = t2, u.aliasSymbol = o, u.aliasTypeArguments = s2, u;
              }
              function ev(r2) {
                if (n)
                  return false;
                if (e2.getObjectFlags(r2) & 4096)
                  return true;
                if (r2.flags & 1048576)
                  return e2.every(r2.types, ev);
                if (r2.flags & 2097152)
                  return e2.some(r2.types, ev);
                if (r2.flags & 465829888) {
                  var i2 = Hv(r2);
                  return i2 !== r2 && ev(i2);
                }
                return false;
              }
              function gD(r2, i2) {
                return _f(r2) ? pf(r2) : i2 && e2.isPropertyName(i2) ? e2.getPropertyNameForPropertyNameNode(i2) : void 0;
              }
              function mD(r2, i2) {
                if (i2.flags & 8208) {
                  var t2 = e2.findAncestor(r2.parent, function(o) {
                    return !e2.isAccessExpression(o);
                  }) || r2.parent;
                  return e2.isCallLikeExpression(t2) ? e2.isCallOrNewExpression(t2) && e2.isIdentifier(r2) && eC(t2, r2) : e2.every(i2.declarations, function(o) {
                    return !e2.isFunctionLike(o) || !!(e2.getCombinedNodeFlags(o) & 268435456);
                  });
                }
                return true;
              }
              function Kx(r2, i2, t2, o, s2, u) {
                var h2, z = s2 && s2.kind === 207 ? s2 : void 0, me = s2 && e2.isPrivateIdentifier(s2) ? void 0 : gD(t2, s2);
                if (me !== void 0) {
                  if (u & 256)
                    return Md(i2, me) || Oe;
                  var Me = bi(i2, me);
                  if (Me) {
                    if (u & 64 && s2 && Me.declarations && P_(Me) && mD(s2, Me)) {
                      var $e = (h2 = z == null ? void 0 : z.argumentExpression) !== null && h2 !== void 0 ? h2 : e2.isIndexedAccessTypeNode(s2) ? s2.indexType : s2;
                      El($e, Me.declarations, me);
                    }
                    if (z) {
                      if (xy(Me, z, rk(z.expression, i2.symbol)), jk(z, Me, e2.getAssignmentTargetKind(z))) {
                        Xr(z.argumentExpression, e2.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, tn(Me));
                        return;
                      }
                      if (u & 8 && (va(s2).resolvedSymbol = Me), HC(z, Me))
                        return nr;
                    }
                    var tr = Jt(Me);
                    return z && e2.getAssignmentTargetKind(z) !== 1 ? up(z, tr) : tr;
                  }
                  if (gf(i2, Yn) && e2.isNumericLiteralName(me) && +me >= 0) {
                    if (s2 && gf(i2, function(Nt) {
                      return !Nt.target.hasRestElement;
                    }) && !(u & 16)) {
                      var dr = vD(s2);
                      Yn(i2) ? Xr(dr, e2.Diagnostics.Tuple_type_0_of_length_1_has_no_element_at_index_2, Ot(i2), $_(i2), e2.unescapeLeadingUnderscores(me)) : Xr(dr, e2.Diagnostics.Property_0_does_not_exist_on_type_1, e2.unescapeLeadingUnderscores(me), Ot(i2));
                    }
                    return qt(ss(i2, nt)), Ss(i2, function(Nt) {
                      var Ra = sv(Nt) || Tr;
                      return u & 1 ? Pa([Ra, Tr]) : Ra;
                    });
                  }
                }
                if (!(t2.flags & 98304) && Ns(t2, 402665900)) {
                  if (i2.flags & 131073)
                    return i2;
                  var Dr = nu(i2, t2) || ss(i2, Li);
                  if (Dr) {
                    if (u & 2 && Dr.keyType !== nt) {
                      z && Xr(z, e2.Diagnostics.Type_0_cannot_be_used_to_index_type_1, Ot(t2), Ot(r2));
                      return;
                    }
                    if (s2 && Dr.keyType === Li && !Ns(t2, 12)) {
                      var dr = vD(s2);
                      return Xr(dr, e2.Diagnostics.Type_0_cannot_be_used_as_an_index_type, Ot(t2)), u & 1 ? Pa([Dr.type, Tr]) : Dr.type;
                    }
                    return qt(Dr), u & 1 ? Pa([Dr.type, Tr]) : Dr.type;
                  }
                  if (t2.flags & 131072)
                    return ui;
                  if (ev(i2))
                    return Oe;
                  if (z && !uS(i2)) {
                    if (Qp(i2)) {
                      if (n && t2.flags & 384)
                        return rn.add(e2.createDiagnosticForNode(z, e2.Diagnostics.Property_0_does_not_exist_on_type_1, t2.value, Ot(i2))), Tr;
                      if (t2.flags & 12) {
                        var Qr = e2.map(i2.properties, function(Nt) {
                          return Jt(Nt);
                        });
                        return Pa(e2.append(Qr, Tr));
                      }
                    }
                    if (i2.symbol === pe && me !== void 0 && pe.exports.has(me) && pe.exports.get(me).flags & 418)
                      Xr(z, e2.Diagnostics.Property_0_does_not_exist_on_type_1, e2.unescapeLeadingUnderscores(me), Ot(i2));
                    else if (n && !ye.suppressImplicitAnyIndexErrors && !(u & 128))
                      if (me !== void 0 && $C(me, i2)) {
                        var li = Ot(i2);
                        Xr(z, e2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, me, li, li + "[" + e2.getTextOfNode(z.argumentExpression) + "]");
                      } else if (cs(i2, nt))
                        Xr(z.argumentExpression, e2.Diagnostics.Element_implicitly_has_an_any_type_because_index_expression_is_not_of_type_number);
                      else {
                        var Ti = void 0;
                        if (me !== void 0 && (Ti = Vb(me, i2)))
                          Ti !== void 0 && Xr(z.argumentExpression, e2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, me, Ot(i2), Ti);
                        else {
                          var Ci = i7(i2, z, t2);
                          if (Ci !== void 0)
                            Xr(z, e2.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature_Did_you_mean_to_call_1, Ot(i2), Ci);
                          else {
                            var $i = void 0;
                            if (t2.flags & 1024)
                              $i = e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + Ot(t2) + "]", Ot(i2));
                            else if (t2.flags & 8192) {
                              var Zi = cl(t2.symbol, z);
                              $i = e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Property_0_does_not_exist_on_type_1, "[" + Zi + "]", Ot(i2));
                            } else
                              t2.flags & 128 || t2.flags & 256 ? $i = e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Property_0_does_not_exist_on_type_1, t2.value, Ot(i2)) : t2.flags & 12 && ($i = e2.chainDiagnosticMessages(void 0, e2.Diagnostics.No_index_signature_with_a_parameter_of_type_0_was_found_on_type_1, Ot(t2), Ot(i2)));
                            $i = e2.chainDiagnosticMessages($i, e2.Diagnostics.Element_implicitly_has_an_any_type_because_expression_of_type_0_can_t_be_used_to_index_type_1, Ot(o), Ot(i2)), rn.add(e2.createDiagnosticForNodeFromMessageChain(z, $i));
                          }
                        }
                      }
                    return;
                  }
                }
                if (ev(i2))
                  return Oe;
                if (s2) {
                  var dr = vD(s2);
                  t2.flags & 384 ? Xr(dr, e2.Diagnostics.Property_0_does_not_exist_on_type_1, "" + t2.value, Ot(i2)) : t2.flags & 12 ? Xr(dr, e2.Diagnostics.Type_0_has_no_matching_index_signature_for_type_1, Ot(i2), Ot(t2)) : Xr(dr, e2.Diagnostics.Type_0_cannot_be_used_as_an_index_type, Ot(t2));
                }
                if (ta(t2))
                  return t2;
                return;
                function qt(Nt) {
                  Nt && Nt.isReadonly && z && (e2.isAssignmentTarget(z) || e2.isDeleteTarget(z)) && Xr(z, e2.Diagnostics.Index_signature_in_type_0_only_permits_reading, Ot(i2));
                }
              }
              function vD(r2) {
                return r2.kind === 207 ? r2.argumentExpression : r2.kind === 194 ? r2.indexType : r2.kind === 162 ? r2.expression : r2;
              }
              function Gx(r2) {
                return !!(r2.flags & 77);
              }
              function sm(r2) {
                return !!(r2.flags & 134217728) && e2.every(r2.types, Gx);
              }
              function rv(r2) {
                return !!iv(r2);
              }
              function Ad(r2) {
                return !!(iv(r2) & 4194304);
              }
              function qp(r2) {
                return !!(iv(r2) & 8388608);
              }
              function iv(r2) {
                return r2.flags & 3145728 ? (r2.objectFlags & 2097152 || (r2.objectFlags |= 2097152 | e2.reduceLeft(r2.types, function(i2, t2) {
                  return i2 | iv(t2);
                }, 0)), r2.objectFlags & 12582912) : r2.flags & 33554432 ? (r2.objectFlags & 2097152 || (r2.objectFlags |= 2097152 | iv(r2.substitute) | iv(r2.baseType)), r2.objectFlags & 12582912) : (r2.flags & 58982400 || Bc(r2) || lm(r2) ? 4194304 : 0) | (r2.flags & 465829888 && !sm(r2) ? 8388608 : 0);
              }
              function Zf(r2, i2) {
                return r2.flags & 8388608 ? DI(r2, i2) : r2.flags & 16777216 ? bI(r2, i2) : r2;
              }
              function Hx(r2, i2, t2) {
                if (r2.flags & 3145728) {
                  var o = e2.map(r2.types, function(s2) {
                    return Zf(Jc(s2, i2), t2);
                  });
                  return r2.flags & 2097152 || t2 ? Do(o) : Pa(o);
                }
              }
              function hI(r2, i2, t2) {
                if (i2.flags & 1048576) {
                  var o = e2.map(i2.types, function(s2) {
                    return Zf(Jc(r2, s2), t2);
                  });
                  return t2 ? Do(o) : Pa(o);
                }
              }
              function DI(r2, i2) {
                var t2 = i2 ? "simplifiedForWriting" : "simplifiedForReading";
                if (r2[t2])
                  return r2[t2] === Pn ? r2 : r2[t2];
                r2[t2] = Pn;
                var o = Zf(r2.objectType, i2), s2 = Zf(r2.indexType, i2), u = hI(o, s2, i2);
                if (u)
                  return r2[t2] = u;
                if (!(s2.flags & 465829888)) {
                  var h2 = Hx(o, s2, i2);
                  if (h2)
                    return r2[t2] = h2;
                }
                if (lm(o) && s2.flags & 296) {
                  var z = jh(o, s2.flags & 8 ? 0 : o.target.fixedLength, 0, i2);
                  if (z)
                    return r2[t2] = z;
                }
                if (Bc(o)) {
                  var me = Jl(o);
                  if (!me || ao(me, Du(o)))
                    return r2[t2] = Ss(xh(o, r2.indexType), function(Me) {
                      return Zf(Me, i2);
                    });
                }
                return r2[t2] = r2;
              }
              function bI(r2, i2) {
                var t2 = r2.checkType, o = r2.extendsType, s2 = ip(r2), u = tp(r2);
                if (u.flags & 131072 && rp(s2) === rp(t2)) {
                  if (t2.flags & 1 || ao(Nd(t2), Nd(o)))
                    return Zf(s2, i2);
                  if (Xx(t2, o))
                    return ui;
                } else if (s2.flags & 131072 && rp(u) === rp(t2)) {
                  if (!(t2.flags & 1) && ao(Nd(t2), Nd(o)))
                    return ui;
                  if (t2.flags & 1 || Xx(t2, o))
                    return Zf(u, i2);
                }
                return r2;
              }
              function Xx(r2, i2) {
                return !!(Pa([Zg(r2, i2), ui]).flags & 131072);
              }
              function xh(r2, i2) {
                var t2 = Uc([Du(r2)], [i2]), o = np(r2.mapper, t2);
                return un(vl(r2), o);
              }
              function Jc(r2, i2, t2, o, s2, u) {
                return t2 === void 0 && (t2 = 0), ep(r2, i2, t2, o, s2, u) || (o ? Pe : gr);
              }
              function Qx(r2, i2) {
                return gf(r2, function(t2) {
                  if (t2.flags & 384) {
                    var o = pf(t2);
                    if (e2.isNumericLiteralName(o)) {
                      var s2 = +o;
                      return s2 >= 0 && s2 < i2;
                    }
                  }
                  return false;
                });
              }
              function ep(r2, i2, t2, o, s2, u) {
                if (t2 === void 0 && (t2 = 0), r2 === Mr || i2 === Mr)
                  return Mr;
                if (yE(r2) && !(i2.flags & 98304) && Ns(i2, 12) && (i2 = Li), ye.noUncheckedIndexedAccess && t2 & 32 && (t2 |= 1), qp(i2) || (o && o.kind !== 194 ? lm(r2) && !Qx(i2, r2.target.fixedLength) : Ad(r2) && !(Yn(r2) && Qx(i2, r2.target.fixedLength)))) {
                  if (r2.flags & 3)
                    return r2;
                  var h2 = t2 & 1, z = r2.id + "," + i2.id + "," + h2 + hg(s2, u), me = Xe.get(z);
                  return me || Xe.set(z, me = yI(r2, i2, h2, s2, u)), me;
                }
                var Me = Xd(r2);
                if (i2.flags & 1048576 && !(i2.flags & 16)) {
                  for (var $e = [], tr = false, dr = 0, Dr = i2.types; dr < Dr.length; dr++) {
                    var Qr = Dr[dr], li = Kx(r2, Me, Qr, i2, o, t2 | (tr ? 128 : 0));
                    if (li)
                      $e.push(li);
                    else if (o)
                      tr = true;
                    else
                      return;
                  }
                  return tr ? void 0 : t2 & 4 ? Do($e, s2, u) : Pa($e, 1, s2, u);
                }
                return Kx(r2, Me, i2, i2, o, t2 | 8 | 64);
              }
              function Yx(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  var t2 = Va(r2.objectType), o = Va(r2.indexType), s2 = Qd(r2), u = Jc(t2, o, 0, r2, s2, bg(s2));
                  i2.resolvedType = u.flags & 8388608 && u.objectType === t2 && u.indexType === o ? mx(u, r2) : u;
                }
                return i2.resolvedType;
              }
              function yD(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  var t2 = tu(32, r2.symbol);
                  t2.declaration = r2, t2.aliasSymbol = Qd(r2), t2.aliasTypeArguments = bg(t2.aliasSymbol), i2.resolvedType = t2, Mu(t2);
                }
                return i2.resolvedType;
              }
              function rp(r2) {
                return r2.flags & 33554432 ? r2.baseType : r2.flags & 8388608 && (r2.objectType.flags & 33554432 || r2.indexType.flags & 33554432) ? Jc(rp(r2.objectType), rp(r2.indexType)) : r2;
              }
              function SI(r2) {
                var i2 = Tc(r2);
                return i2 && (Ad(i2) || qp(i2)) ? kD(r2) : r2;
              }
              function $x(r2) {
                return !r2.isDistributive && Zx(r2.node.checkType) && Zx(r2.node.extendsType);
              }
              function Zx(r2) {
                return e2.isTupleTypeNode(r2) && e2.length(r2.elements) === 1 && !e2.isOptionalTypeNode(r2.elements[0]) && !e2.isRestTypeNode(r2.elements[0]) && !(e2.isNamedTupleMember(r2.elements[0]) && (r2.elements[0].questionToken || r2.elements[0].dotDotDotToken));
              }
              function hD(r2, i2) {
                return $x(r2) && Yn(i2) ? xo(i2)[0] : i2;
              }
              function DD(r2, i2, t2, o) {
                for (var s2, u, h2 = 0, z = function() {
                  if (h2 === 1e3)
                    return Xr(Ie, e2.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite), s2 = Pe, "break";
                  var $e = $x(r2), tr = un(hD(r2, rp(r2.checkType)), i2), dr = rv(tr), Dr = un(hD(r2, r2.extendsType), i2);
                  if (tr === Mr || Dr === Mr)
                    return { value: Mr };
                  var Qr = void 0;
                  if (r2.inferTypeParameters) {
                    var li = e2.sameMap(r2.inferTypeParameters, SI), Ti = li !== r2.inferTypeParameters ? Uc(r2.inferTypeParameters, li) : void 0, Ci = uv(li, void 0, 0);
                    if (Ti)
                      for (var $i = np(i2, Ti), Zi = 0, qt = li; Zi < qt.length; Zi++) {
                        var Nt = qt[Zi];
                        r2.inferTypeParameters.indexOf(Nt) === -1 && (Nt.mapper = $i);
                      }
                    (!dr || !e2.some(r2.inferTypeParameters, function(Tn) {
                      return Tn === Dr;
                    })) && df(Ci.inferences, tr, un(Dr, Ti), 1536);
                    var Ra = np(Ti, Ci.mapper);
                    Qr = i2 ? np(Ra, i2) : Ra;
                  }
                  var ca = Qr ? un(hD(r2, r2.extendsType), Qr) : Dr;
                  if (!dr && !rv(ca)) {
                    if (!(ca.flags & 3) && (tr.flags & 1 && !$e || !ao(wh(tr), wh(ca)))) {
                      tr.flags & 1 && !$e && (u || (u = [])).push(un(Va(r2.node.trueType), Qr || i2));
                      var Sn = Va(r2.node.falseType);
                      if (Sn.flags & 16777216) {
                        var ja = Sn.root;
                        if (ja.node.parent === r2.node && (!ja.isDistributive || ja.checkType === r2.checkType))
                          return r2 = ja, "continue";
                        if (Me(Sn, i2))
                          return "continue";
                      }
                      return s2 = un(Sn, i2), "break";
                    }
                    if (ca.flags & 3 || ao(Nd(tr), Nd(ca))) {
                      var Fn = Va(r2.node.trueType), wn = Qr || i2;
                      return Me(Fn, wn) ? "continue" : (s2 = un(Fn, wn), "break");
                    }
                  }
                  return s2 = mc(16777216), s2.root = r2, s2.checkType = un(r2.checkType, i2), s2.extendsType = un(r2.extendsType, i2), s2.mapper = i2, s2.combinedMapper = Qr, s2.aliasSymbol = t2 || r2.aliasSymbol, s2.aliasTypeArguments = t2 ? o : e_(r2.aliasTypeArguments, i2), "break";
                }; ; ) {
                  var me = z();
                  if (typeof me == "object")
                    return me.value;
                  if (me === "break")
                    break;
                }
                return u ? Pa(e2.append(u, s2)) : s2;
                function Me($e, tr) {
                  if ($e.flags & 16777216 && tr) {
                    var dr = $e.root;
                    if (dr.outerTypeParameters) {
                      var Dr = np($e.mapper, tr), Qr = e2.map(dr.outerTypeParameters, function(Ci) {
                        return ap(Ci, Dr);
                      }), li = Uc(dr.outerTypeParameters, Qr), Ti = dr.isDistributive ? ap(dr.checkType, li) : void 0;
                      if (!Ti || Ti === dr.checkType || !(Ti.flags & 1179648))
                        return r2 = dr, i2 = li, t2 = void 0, o = void 0, dr.aliasSymbol && h2++, true;
                    }
                  }
                  return false;
                }
              }
              function ip(r2) {
                return r2.resolvedTrueType || (r2.resolvedTrueType = un(Va(r2.root.node.trueType), r2.mapper));
              }
              function tp(r2) {
                return r2.resolvedFalseType || (r2.resolvedFalseType = un(Va(r2.root.node.falseType), r2.mapper));
              }
              function TI(r2) {
                return r2.resolvedInferredTrueType || (r2.resolvedInferredTrueType = r2.combinedMapper ? un(Va(r2.root.node.trueType), r2.combinedMapper) : ip(r2));
              }
              function eE(r2) {
                var i2;
                return r2.locals && r2.locals.forEach(function(t2) {
                  t2.flags & 262144 && (i2 = e2.append(i2, go(t2)));
                }), i2;
              }
              function xI(r2) {
                return r2.isDistributive && (Ph(r2.checkType, r2.node.trueType) || Ph(r2.checkType, r2.node.falseType));
              }
              function EI(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  var t2 = Va(r2.checkType), o = Qd(r2), s2 = bg(o), u = kf(r2, true), h2 = s2 ? u : e2.filter(u, function(me) {
                    return Ph(me, r2);
                  }), z = { node: r2, checkType: t2, extendsType: Va(r2.extendsType), isDistributive: !!(t2.flags & 262144), inferTypeParameters: eE(r2), outerTypeParameters: h2, instantiations: void 0, aliasSymbol: o, aliasTypeArguments: s2 };
                  i2.resolvedType = DD(z, void 0), h2 && (z.instantiations = new e2.Map(), z.instantiations.set(Su(h2), i2.resolvedType));
                }
                return i2.resolvedType;
              }
              function CI(r2) {
                var i2 = va(r2);
                return i2.resolvedType || (i2.resolvedType = Js(Et(r2.typeParameter))), i2.resolvedType;
              }
              function rE(r2) {
                return e2.isIdentifier(r2) ? [r2] : e2.append(rE(r2.left), r2.right);
              }
              function kI(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  if (r2.isTypeOf && r2.typeArguments)
                    return Xr(r2, e2.Diagnostics.Type_arguments_cannot_be_used_here), i2.resolvedSymbol = xe, i2.resolvedType = Pe;
                  if (!e2.isLiteralImportTypeNode(r2))
                    return Xr(r2.argument, e2.Diagnostics.String_literal_expected), i2.resolvedSymbol = xe, i2.resolvedType = Pe;
                  var t2 = r2.isTypeOf ? 111551 : r2.flags & 8388608 ? 900095 : 788968, o = ac(r2, r2.argument.literal);
                  if (!o)
                    return i2.resolvedSymbol = xe, i2.resolvedType = Pe;
                  var s2 = Us(o, false);
                  if (e2.nodeIsMissing(r2.qualifier))
                    if (s2.flags & t2)
                      i2.resolvedType = iE(r2, i2, s2, t2);
                    else {
                      var tr = t2 === 111551 ? e2.Diagnostics.Module_0_does_not_refer_to_a_value_but_is_used_as_a_value_here : e2.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0;
                      Xr(r2, tr, r2.argument.literal.text), i2.resolvedSymbol = xe, i2.resolvedType = Pe;
                    }
                  else {
                    for (var u = rE(r2.qualifier), h2 = s2, z = void 0; z = u.shift(); ) {
                      var me = u.length ? 1920 : t2, Me = so(os(h2)), $e = r2.isTypeOf ? bi(Jt(Me), z.escapedText) : qs(dc(Me), z.escapedText, me);
                      if (!$e)
                        return Xr(z, e2.Diagnostics.Namespace_0_has_no_exported_member_1, cl(h2), e2.declarationNameToString(z)), i2.resolvedType = Pe;
                      va(z).resolvedSymbol = $e, va(z.parent).resolvedSymbol = $e, h2 = $e;
                    }
                    i2.resolvedType = iE(r2, i2, h2, t2);
                  }
                }
                return i2.resolvedType;
              }
              function iE(r2, i2, t2, o) {
                var s2 = os(t2);
                return i2.resolvedSymbol = s2, o === 111551 ? Jt(t2) : hh(r2, s2);
              }
              function tE(r2) {
                var i2 = va(r2);
                if (!i2.resolvedType) {
                  var t2 = Qd(r2);
                  if (Nf(r2.symbol).size === 0 && !t2)
                    i2.resolvedType = Bi;
                  else {
                    var o = tu(16, r2.symbol);
                    o.aliasSymbol = t2, o.aliasTypeArguments = bg(t2), e2.isJSDocTypeLiteral(r2) && r2.isArrayType && (o = Zs(o)), i2.resolvedType = o;
                  }
                }
                return i2.resolvedType;
              }
              function Qd(r2) {
                for (var i2 = r2.parent; e2.isParenthesizedTypeNode(i2) || e2.isJSDocTypeExpression(i2) || e2.isTypeOperatorNode(i2) && i2.operator === 145; )
                  i2 = i2.parent;
                return e2.isTypeAlias(i2) ? Et(i2) : void 0;
              }
              function bg(r2) {
                return r2 ? Af(r2) : void 0;
              }
              function bD(r2) {
                return !!(r2.flags & 524288) && !Bc(r2);
              }
              function SD(r2) {
                return Of(r2) || !!(r2.flags & 474058748);
              }
              function TD(r2, i2) {
                if (!(r2.flags & 1048576))
                  return r2;
                if (e2.every(r2.types, SD))
                  return e2.find(r2.types, Of) || Ba;
                var t2 = e2.find(r2.types, function(u) {
                  return !SD(u);
                });
                if (!t2)
                  return r2;
                var o = e2.find(r2.types, function(u) {
                  return u !== t2 && !SD(u);
                });
                if (o)
                  return r2;
                return s2(t2);
                function s2(u) {
                  for (var h2 = e2.createSymbolTable(), z = 0, me = uo(u); z < me.length; z++) {
                    var Me = me[z];
                    if (!(e2.getDeclarationModifierFlagsFromSymbol(Me) & 24)) {
                      if (Eh(Me)) {
                        var $e = Me.flags & 65536 && !(Me.flags & 32768), tr = 16777220, dr = oo(tr, Me.escapedName, Gd(Me) | (i2 ? 8 : 0));
                        dr.type = $e ? Tr : kc(Jt(Me), true), dr.declarations = Me.declarations, dr.nameType = Aa(Me).nameType, dr.syntheticOrigin = Me, h2.set(Me.escapedName, dr);
                      }
                    }
                  }
                  var Dr = rs(u.symbol, h2, e2.emptyArray, e2.emptyArray, Hn(u));
                  return Dr.objectFlags |= 131200, Dr;
                }
              }
              function Vp(r2, i2, t2, o, s2) {
                if (r2.flags & 1 || i2.flags & 1)
                  return Oe;
                if (r2.flags & 2 || i2.flags & 2)
                  return gr;
                if (r2.flags & 131072)
                  return i2;
                if (i2.flags & 131072)
                  return r2;
                if (r2 = TD(r2, s2), r2.flags & 1048576)
                  return ny([r2, i2]) ? Ss(r2, function(Nt) {
                    return Vp(Nt, i2, t2, o, s2);
                  }) : Pe;
                if (i2 = TD(i2, s2), i2.flags & 1048576)
                  return ny([r2, i2]) ? Ss(i2, function(Nt) {
                    return Vp(r2, Nt, t2, o, s2);
                  }) : Pe;
                if (i2.flags & 473960444)
                  return r2;
                if (Ad(r2) || Ad(i2)) {
                  if (Of(r2))
                    return i2;
                  if (r2.flags & 2097152) {
                    var u = r2.types, h2 = u[u.length - 1];
                    if (bD(h2) && bD(i2))
                      return Do(e2.concatenate(u.slice(0, u.length - 1), [Vp(h2, i2, t2, o, s2)]));
                  }
                  return Do([r2, i2]);
                }
                for (var z = e2.createSymbolTable(), me = new e2.Set(), Me = r2 === Ba ? Hn(i2) : oh([r2, i2]), $e = 0, tr = uo(i2); $e < tr.length; $e++) {
                  var dr = tr[$e];
                  e2.getDeclarationModifierFlagsFromSymbol(dr) & 24 ? me.add(dr.escapedName) : Eh(dr) && z.set(dr.escapedName, xD(dr, s2));
                }
                for (var Dr = 0, Qr = uo(r2); Dr < Qr.length; Dr++) {
                  var li = Qr[Dr];
                  if (!(me.has(li.escapedName) || !Eh(li)))
                    if (z.has(li.escapedName)) {
                      var dr = z.get(li.escapedName), Ti = Jt(dr);
                      if (dr.flags & 16777216) {
                        var Ci = e2.concatenate(li.declarations, dr.declarations), $i = 4 | li.flags & 16777216, Zi = oo($i, li.escapedName);
                        Zi.type = Pa([Jt(li), $D(Ti)], 2), Zi.leftSpread = li, Zi.rightSpread = dr, Zi.declarations = Ci, Zi.nameType = Aa(li).nameType, z.set(li.escapedName, Zi);
                      }
                    } else
                      z.set(li.escapedName, xD(li, s2));
                }
                var qt = rs(t2, z, e2.emptyArray, e2.emptyArray, e2.sameMap(Me, function(Nt) {
                  return AI(Nt, s2);
                }));
                return qt.objectFlags |= 2228352 | o, qt;
              }
              function Eh(r2) {
                var i2;
                return !e2.some(r2.declarations, e2.isPrivateIdentifierClassElementDeclaration) && (!(r2.flags & 106496) || !(!((i2 = r2.declarations) === null || i2 === void 0) && i2.some(function(t2) {
                  return e2.isClassLike(t2.parent);
                })));
              }
              function xD(r2, i2) {
                var t2 = r2.flags & 65536 && !(r2.flags & 32768);
                if (!t2 && i2 === Zu(r2))
                  return r2;
                var o = 4 | r2.flags & 16777216, s2 = oo(o, r2.escapedName, Gd(r2) | (i2 ? 8 : 0));
                return s2.type = t2 ? Tr : Jt(r2), s2.declarations = r2.declarations, s2.nameType = Aa(r2).nameType, s2.syntheticOrigin = r2, s2;
              }
              function AI(r2, i2) {
                return r2.isReadonly !== i2 ? zl(r2.keyType, r2.type, i2, r2.declaration) : r2;
              }
              function oy(r2, i2, t2, o) {
                var s2 = mc(r2);
                return s2.symbol = t2, s2.value = i2, s2.regularType = o || s2, s2;
              }
              function Sg(r2) {
                if (r2.flags & 2944) {
                  if (!r2.freshType) {
                    var i2 = oy(r2.flags, r2.value, r2.symbol, r2);
                    i2.freshType = i2, r2.freshType = i2;
                  }
                  return r2.freshType;
                }
                return r2;
              }
              function jc(r2) {
                return r2.flags & 2944 ? r2.regularType : r2.flags & 1048576 ? r2.regularType || (r2.regularType = Ss(r2, jc)) : r2;
              }
              function Kp(r2) {
                return !!(r2.flags & 2944) && r2.freshType === r2;
              }
              function Bu(r2) {
                var i2;
                return Zt.get(r2) || (Zt.set(r2, i2 = oy(128, r2)), i2);
              }
              function If(r2) {
                var i2;
                return _r.get(r2) || (_r.set(r2, i2 = oy(256, r2)), i2);
              }
              function ED(r2) {
                var i2, t2 = e2.pseudoBigIntToString(r2);
                return pi.get(t2) || (pi.set(t2, i2 = oy(2048, r2)), i2);
              }
              function NI(r2, i2, t2) {
                var o, s2 = typeof r2 == "string" ? "@" : "#", u = i2 + s2 + r2, h2 = 1024 | (typeof r2 == "string" ? 128 : 256);
                return ae.get(u) || (ae.set(u, o = oy(h2, r2, t2)), o);
              }
              function PI(r2) {
                if (r2.literal.kind === 104)
                  return Wi;
                var i2 = va(r2);
                return i2.resolvedType || (i2.resolvedType = jc(yn(r2.literal))), i2.resolvedType;
              }
              function II(r2) {
                var i2 = mc(8192);
                return i2.symbol = r2, i2.escapedName = "__@".concat(i2.symbol.escapedName, "@").concat(y(i2.symbol)), i2;
              }
              function CD(r2) {
                if (e2.isValidESSymbolDeclaration(r2)) {
                  var i2 = e2.isCommonJsExportPropertyAssignment(r2) ? Et(r2.left) : Et(r2);
                  if (i2) {
                    var t2 = Aa(i2);
                    return t2.uniqueESSymbolType || (t2.uniqueESSymbolType = II(i2));
                  }
                }
                return Ki;
              }
              function wI(r2) {
                var i2 = e2.getThisContainer(r2, false), t2 = i2 && i2.parent;
                if (t2 && (e2.isClassLike(t2) || t2.kind === 258) && !e2.isStatic(i2) && (!e2.isConstructorDeclaration(i2) || e2.isNodeDescendantOf(r2, i2.body)))
                  return aa(Et(t2)).thisType;
                if (t2 && e2.isObjectLiteralExpression(t2) && e2.isBinaryExpression(t2.parent) && e2.getAssignmentDeclarationKind(t2.parent) === 6)
                  return aa(Et(t2.parent.left).parent).thisType;
                var o = r2.flags & 8388608 ? e2.getHostSignatureFromJSDoc(r2) : void 0;
                return o && e2.isFunctionExpression(o) && e2.isBinaryExpression(o.parent) && e2.getAssignmentDeclarationKind(o.parent) === 3 ? aa(Et(o.parent.left).parent).thisType : Sl(i2) && e2.isNodeDescendantOf(r2, i2.body) ? aa(Et(i2)).thisType : (Xr(r2, e2.Diagnostics.A_this_type_is_available_only_in_a_non_static_member_of_a_class_or_interface), Pe);
              }
              function Ch(r2) {
                var i2 = va(r2);
                return i2.resolvedType || (i2.resolvedType = wI(r2)), i2.resolvedType;
              }
              function aE(r2) {
                return Va(sy(r2.type) || r2.type);
              }
              function sy(r2) {
                switch (r2.kind) {
                  case 191:
                    return sy(r2.type);
                  case 184:
                    if (r2.elements.length === 1 && (r2 = r2.elements[0], r2.kind === 186 || r2.kind === 197 && r2.dotDotDotToken))
                      return sy(r2.type);
                    break;
                  case 183:
                    return r2.elementType;
                }
              }
              function OI(r2) {
                var i2 = va(r2);
                return i2.resolvedType || (i2.resolvedType = r2.dotDotDotToken ? aE(r2) : kc(Va(r2.type), true, !!r2.questionToken));
              }
              function Va(r2) {
                return mx(nE(r2), r2);
              }
              function nE(r2) {
                switch (r2.kind) {
                  case 130:
                  case 312:
                  case 313:
                    return Oe;
                  case 155:
                    return gr;
                  case 150:
                    return Li;
                  case 147:
                    return nt;
                  case 158:
                    return Mt;
                  case 133:
                    return Ii;
                  case 151:
                    return Ki;
                  case 114:
                    return Fi;
                  case 153:
                    return Tr;
                  case 104:
                    return Wi;
                  case 143:
                    return ui;
                  case 148:
                    return r2.flags & 262144 && !n ? Oe : Oi;
                  case 138:
                    return De;
                  case 192:
                  case 108:
                    return Ch(r2);
                  case 196:
                    return PI(r2);
                  case 178:
                    return ty(r2);
                  case 177:
                    return r2.assertsModifier ? Fi : Ii;
                  case 228:
                    return ty(r2);
                  case 181:
                    return yx(r2);
                  case 183:
                  case 184:
                    return j3(r2);
                  case 185:
                    return W3(r2);
                  case 187:
                    return Q3(r2);
                  case 188:
                    return aI(r2);
                  case 314:
                    return b3(r2);
                  case 316:
                    return kc(Va(r2.type));
                  case 197:
                    return OI(r2);
                  case 191:
                  case 315:
                  case 309:
                    return Va(r2.type);
                  case 186:
                    return aE(r2);
                  case 318:
                    return KM(r2);
                  case 179:
                  case 180:
                  case 182:
                  case 322:
                  case 317:
                  case 323:
                    return tE(r2);
                  case 193:
                    return fI(r2);
                  case 194:
                    return Yx(r2);
                  case 195:
                    return yD(r2);
                  case 189:
                    return EI(r2);
                  case 190:
                    return CI(r2);
                  case 198:
                    return _I(r2);
                  case 200:
                    return kI(r2);
                  case 79:
                  case 161:
                  case 206:
                    var i2 = el(r2);
                    return i2 ? go(i2) : Pe;
                  default:
                    return Pe;
                }
              }
              function kh(r2, i2, t2) {
                if (r2 && r2.length)
                  for (var o = 0; o < r2.length; o++) {
                    var s2 = r2[o], u = t2(s2, i2);
                    if (s2 !== u) {
                      var h2 = o === 0 ? [] : r2.slice(0, o);
                      for (h2.push(u), o++; o < r2.length; o++)
                        h2.push(t2(r2[o], i2));
                      return h2;
                    }
                  }
                return r2;
              }
              function e_(r2, i2) {
                return kh(r2, i2, un);
              }
              function Ah(r2, i2) {
                return kh(r2, i2, Tg);
              }
              function oE(r2, i2) {
                return kh(r2, i2, GI);
              }
              function Uc(r2, i2) {
                return r2.length === 1 ? Yd(r2[0], i2 ? i2[0] : Oe) : FI(r2, i2);
              }
              function ap(r2, i2) {
                switch (i2.kind) {
                  case 0:
                    return r2 === i2.source ? i2.target : r2;
                  case 1:
                    for (var t2 = i2.sources, o = i2.targets, s2 = 0; s2 < t2.length; s2++)
                      if (r2 === t2[s2])
                        return o ? o[s2] : Oe;
                    return r2;
                  case 2:
                    return i2.func(r2);
                  case 3:
                  case 4:
                    var u = ap(r2, i2.mapper1);
                    return u !== r2 && i2.kind === 3 ? un(u, i2.mapper2) : ap(u, i2.mapper2);
                }
              }
              function Yd(r2, i2) {
                return { kind: 0, source: r2, target: i2 };
              }
              function FI(r2, i2) {
                return { kind: 1, sources: r2, targets: i2 };
              }
              function Gp(r2) {
                return { kind: 2, func: r2 };
              }
              function Nh(r2, i2, t2) {
                return { kind: r2, mapper1: i2, mapper2: t2 };
              }
              function sE(r2) {
                return Uc(r2, void 0);
              }
              function MI(r2, i2) {
                return Gp(function(t2) {
                  return e2.findIndex(r2.inferences, function(o) {
                    return o.typeParameter === t2;
                  }) >= i2 ? gr : t2;
                });
              }
              function np(r2, i2) {
                return r2 ? Nh(3, r2, i2) : i2;
              }
              function LI(r2, i2) {
                return r2 ? Nh(4, r2, i2) : i2;
              }
              function $d(r2, i2, t2) {
                return t2 ? Nh(4, Yd(r2, i2), t2) : Yd(r2, i2);
              }
              function tv(r2, i2, t2) {
                return r2 ? Nh(4, r2, Yd(i2, t2)) : Yd(i2, t2);
              }
              function RI(r2) {
                return r2.constraint === gr ? r2 : r2.restrictiveInstantiation || (r2.restrictiveInstantiation = Hc(r2.symbol), r2.restrictiveInstantiation.constraint = gr, r2.restrictiveInstantiation);
              }
              function kD(r2) {
                var i2 = Hc(r2.symbol);
                return i2.target = r2, i2;
              }
              function BI(r2, i2) {
                return vg(r2.kind, r2.parameterName, r2.parameterIndex, un(r2.type, i2));
              }
              function Tg(r2, i2, t2) {
                var o;
                if (r2.typeParameters && !t2) {
                  o = e2.map(r2.typeParameters, kD), i2 = np(Uc(r2.typeParameters, o), i2);
                  for (var s2 = 0, u = o; s2 < u.length; s2++) {
                    var h2 = u[s2];
                    h2.mapper = i2;
                  }
                }
                var z = Fu(r2.declaration, o, r2.thisParameter && AD(r2.thisParameter, i2), kh(r2.parameters, i2, AD), void 0, void 0, r2.minArgumentCount, r2.flags & 39);
                return z.target = r2, z.mapper = i2, z;
              }
              function AD(r2, i2) {
                var t2 = Aa(r2);
                if (t2.type && !Id(t2.type))
                  return r2;
                e2.getCheckFlags(r2) & 1 && (r2 = t2.target, i2 = np(t2.mapper, i2));
                var o = oo(r2.flags, r2.escapedName, 1 | e2.getCheckFlags(r2) & 53256);
                return o.declarations = r2.declarations, o.parent = r2.parent, o.target = r2, o.mapper = i2, r2.valueDeclaration && (o.valueDeclaration = r2.valueDeclaration), t2.nameType && (o.nameType = t2.nameType), o;
              }
              function JI(r2, i2, t2, o) {
                var s2 = r2.objectFlags & 4 || r2.objectFlags & 8388608 ? r2.node : r2.symbol.declarations[0], u = va(s2), h2 = r2.objectFlags & 4 ? u.resolvedType : r2.objectFlags & 64 ? r2.target : r2, z = u.outerTypeParameters;
                if (!z) {
                  var me = kf(s2, true);
                  if (Sl(s2)) {
                    var Me = jl(s2);
                    me = e2.addRange(me, Me);
                  }
                  z = me || e2.emptyArray;
                  var $e = r2.objectFlags & 8388612 ? [s2] : r2.symbol.declarations;
                  z = (h2.objectFlags & 8388612 || h2.symbol.flags & 8192 || h2.symbol.flags & 2048) && !h2.aliasTypeArguments ? e2.filter(z, function($i) {
                    return e2.some($e, function(Zi) {
                      return Ph($i, Zi);
                    });
                  }) : z, u.outerTypeParameters = z;
                }
                if (z.length) {
                  var tr = np(r2.mapper, i2), dr = e2.map(z, function($i) {
                    return ap($i, tr);
                  }), Dr = t2 || r2.aliasSymbol, Qr = t2 ? o : e_(r2.aliasTypeArguments, i2), li = Su(dr) + hg(Dr, Qr);
                  h2.instantiations || (h2.instantiations = new e2.Map(), h2.instantiations.set(Su(z) + hg(h2.aliasSymbol, h2.aliasTypeArguments), h2));
                  var Ti = h2.instantiations.get(li);
                  if (!Ti) {
                    var Ci = Uc(z, dr);
                    Ti = h2.objectFlags & 4 ? tD(r2.target, r2.node, Ci, Dr, Qr) : h2.objectFlags & 32 ? cE(h2, Ci, Dr, Qr) : PD(h2, Ci, Dr, Qr), h2.instantiations.set(li, Ti);
                  }
                  return Ti;
                }
                return r2;
              }
              function jI(r2) {
                return !(r2.parent.kind === 178 && r2.parent.typeArguments && r2 === r2.parent.typeName || r2.parent.kind === 200 && r2.parent.typeArguments && r2 === r2.parent.qualifier);
              }
              function Ph(r2, i2) {
                if (r2.symbol && r2.symbol.declarations && r2.symbol.declarations.length === 1) {
                  for (var t2 = r2.symbol.declarations[0].parent, o = i2; o !== t2; o = o.parent)
                    if (!o || o.kind === 235 || o.kind === 189 && e2.forEachChild(o.extendsType, s2))
                      return true;
                  return s2(i2);
                }
                return true;
                function s2(u) {
                  switch (u.kind) {
                    case 192:
                      return !!r2.isThisType;
                    case 79:
                      return !r2.isThisType && e2.isPartOfTypeNode(u) && jI(u) && nE(u) === r2;
                    case 181:
                      return true;
                    case 169:
                    case 168:
                      return !u.type && !!u.body || e2.some(u.typeParameters, s2) || e2.some(u.parameters, s2) || !!u.type && s2(u.type);
                  }
                  return !!e2.forEachChild(u, s2);
                }
              }
              function Ih(r2) {
                var i2 = Mu(r2);
                if (i2.flags & 4194304) {
                  var t2 = rp(i2.type);
                  if (t2.flags & 262144)
                    return t2;
                }
              }
              function cE(r2, i2, t2, o) {
                var s2 = Ih(r2);
                if (s2) {
                  var u = un(s2, i2);
                  if (s2 !== u)
                    return uC(bu(u), function(h2) {
                      if (h2.flags & 61603843 && h2 !== Mr && !nn(h2)) {
                        if (!r2.declaration.nameType) {
                          var z = void 0;
                          if (Tu(h2) || h2.flags & 1 && v(s2, 4) < 0 && (z = Tc(s2)) && gf(z, Pd))
                            return zI(h2, r2, $d(s2, h2, i2));
                          if (lm(h2))
                            return UI(h2, r2, s2, i2);
                          if (Yn(h2))
                            return WI(h2, r2, $d(s2, h2, i2));
                        }
                        return PD(r2, $d(s2, h2, i2));
                      }
                      return h2;
                    }, t2, o);
                }
                return un(Mu(r2), i2) === Mr ? Mr : PD(r2, i2, t2, o);
              }
              function ND(r2, i2) {
                return i2 & 1 ? true : i2 & 2 ? false : r2;
              }
              function UI(r2, i2, t2, o) {
                var s2 = r2.target.elementFlags, u = e2.map(xo(r2), function(z, me) {
                  var Me = s2[me] & 8 ? z : s2[me] & 4 ? Zs(z) : Wl([z], [s2[me]]);
                  return cE(i2, $d(t2, Me, o));
                }), h2 = ND(r2.target.readonly, Lu(i2));
                return Wl(u, e2.map(u, function(z) {
                  return 8;
                }), h2);
              }
              function zI(r2, i2, t2) {
                var o = uE(i2, nt, true, t2);
                return nn(o) ? Pe : Zs(o, ND(um(r2), Lu(i2)));
              }
              function WI(r2, i2, t2) {
                var o = r2.target.elementFlags, s2 = e2.map(xo(r2), function(me, Me) {
                  return uE(i2, Bu("" + Me), !!(o[Me] & 2), t2);
                }), u = Lu(i2), h2 = u & 4 ? e2.map(o, function(me) {
                  return me & 1 ? 2 : me;
                }) : u & 8 ? e2.map(o, function(me) {
                  return me & 2 ? 1 : me;
                }) : o, z = ND(r2.target.readonly, u);
                return e2.contains(s2, Pe) ? Pe : Wl(s2, h2, z, r2.target.labeledElementDeclarations);
              }
              function uE(r2, i2, t2, o) {
                var s2 = tv(o, Du(r2), i2), u = un(vl(r2.target || r2), s2), h2 = Lu(r2);
                return Ye && h2 & 4 && !fs4(u, 49152) ? i_(u, true) : Ye && h2 & 8 && t2 ? Ks(u, 524288) : u;
              }
              function PD(r2, i2, t2, o) {
                var s2 = tu(r2.objectFlags | 64, r2.symbol);
                if (r2.objectFlags & 32) {
                  s2.declaration = r2.declaration;
                  var u = Du(r2), h2 = kD(u);
                  s2.typeParameter = h2, i2 = np(Yd(u, h2), i2), h2.mapper = i2;
                }
                return r2.objectFlags & 8388608 && (s2.node = r2.node), s2.target = r2, s2.mapper = i2, s2.aliasSymbol = t2 || r2.aliasSymbol, s2.aliasTypeArguments = t2 ? o : e_(r2.aliasTypeArguments, i2), s2;
              }
              function ID(r2, i2, t2, o) {
                var s2 = r2.root;
                if (s2.outerTypeParameters) {
                  var u = e2.map(s2.outerTypeParameters, function(tr) {
                    return ap(tr, i2);
                  }), h2 = Su(u) + hg(t2, o), z = s2.instantiations.get(h2);
                  if (!z) {
                    var me = Uc(s2.outerTypeParameters, u), Me = s2.checkType, $e = s2.isDistributive ? ap(Me, me) : void 0;
                    z = $e && Me !== $e && $e.flags & 1179648 ? uC(bu($e), function(tr) {
                      return DD(s2, $d(Me, tr, me));
                    }, t2, o) : DD(s2, me, t2, o), s2.instantiations.set(h2, z);
                  }
                  return z;
                }
                return r2;
              }
              function un(r2, i2) {
                return r2 && i2 ? lE(r2, i2, void 0, void 0) : r2;
              }
              function lE(r2, i2, t2, o) {
                if (!Id(r2))
                  return r2;
                if (He === 100 || Ee >= 5e6)
                  return e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("checkTypes", "instantiateType_DepthLimit", { typeId: r2.id, instantiationDepth: He, instantiationCount: Ee }), Xr(Ie, e2.Diagnostics.Type_instantiation_is_excessively_deep_and_possibly_infinite), Pe;
                ze++, Ee++, He++;
                var s2 = qI(r2, i2, t2, o);
                return He--, s2;
              }
              function qI(r2, i2, t2, o) {
                var s2 = r2.flags;
                if (s2 & 262144)
                  return ap(r2, i2);
                if (s2 & 524288) {
                  var u = r2.objectFlags;
                  if (u & 52) {
                    if (u & 4 && !r2.node) {
                      var h2 = r2.resolvedTypeArguments, z = e_(h2, i2);
                      return z !== h2 ? uD(r2.target, z) : r2;
                    }
                    return u & 1024 ? VI(r2, i2) : JI(r2, i2, t2, o);
                  }
                  return r2;
                }
                if (s2 & 3145728) {
                  var me = r2.flags & 1048576 ? r2.origin : void 0, Me = me && me.flags & 3145728 ? me.types : r2.types, $e = e_(Me, i2);
                  if ($e === Me && t2 === r2.aliasSymbol)
                    return r2;
                  var tr = t2 || r2.aliasSymbol, dr = t2 ? o : e_(r2.aliasTypeArguments, i2);
                  return s2 & 2097152 || me && me.flags & 2097152 ? Do($e, tr, dr) : Pa($e, 1, tr, dr);
                }
                if (s2 & 4194304)
                  return ql(un(r2.type, i2));
                if (s2 & 134217728)
                  return Dg(r2.texts, e_(r2.types, i2));
                if (s2 & 268435456)
                  return Th(r2.symbol, un(r2.type, i2));
                if (s2 & 8388608) {
                  var tr = t2 || r2.aliasSymbol, dr = t2 ? o : e_(r2.aliasTypeArguments, i2);
                  return Jc(un(r2.objectType, i2), un(r2.indexType, i2), r2.accessFlags, void 0, tr, dr);
                }
                if (s2 & 16777216)
                  return ID(r2, np(r2.mapper, i2), t2, o);
                if (s2 & 33554432) {
                  var Dr = un(r2.baseType, i2);
                  if (Dr.flags & 8650752)
                    return px(Dr, un(r2.substitute, i2));
                  var Qr = un(r2.substitute, i2);
                  return Qr.flags & 3 || ao(Nd(Dr), Nd(Qr)) ? Dr : Qr;
                }
                return r2;
              }
              function VI(r2, i2) {
                var t2 = un(r2.mappedType, i2);
                if (!(e2.getObjectFlags(t2) & 32))
                  return r2;
                var o = un(r2.constraintType, i2);
                if (!(o.flags & 4194304))
                  return r2;
                var s2 = UE(un(r2.source, i2), t2, o);
                return s2 || r2;
              }
              function KI(r2) {
                return r2.flags & 262143 ? r2 : r2.uniqueLiteralFilledInstantiation || (r2.uniqueLiteralFilledInstantiation = un(r2, ka));
              }
              function wh(r2) {
                return r2.flags & 262143 ? r2 : r2.permissiveInstantiation || (r2.permissiveInstantiation = un(r2, ai));
              }
              function Nd(r2) {
                return r2.flags & 262143 ? r2 : (r2.restrictiveInstantiation || (r2.restrictiveInstantiation = un(r2, Qa), r2.restrictiveInstantiation.restrictiveInstantiation = r2.restrictiveInstantiation), r2.restrictiveInstantiation);
              }
              function GI(r2, i2) {
                return zl(r2.keyType, un(r2.type, i2), r2.isReadonly, r2.declaration);
              }
              function Ju(r2) {
                switch (e2.Debug.assert(r2.kind !== 169 || e2.isObjectLiteralMethod(r2)), r2.kind) {
                  case 213:
                  case 214:
                  case 169:
                  case 256:
                    return fE(r2);
                  case 205:
                    return e2.some(r2.properties, Ju);
                  case 204:
                    return e2.some(r2.elements, Ju);
                  case 222:
                    return Ju(r2.whenTrue) || Ju(r2.whenFalse);
                  case 221:
                    return (r2.operatorToken.kind === 56 || r2.operatorToken.kind === 60) && (Ju(r2.left) || Ju(r2.right));
                  case 296:
                    return Ju(r2.initializer);
                  case 212:
                    return Ju(r2.expression);
                  case 286:
                    return e2.some(r2.properties, Ju) || e2.isJsxOpeningElement(r2.parent) && e2.some(r2.parent.parent.children, Ju);
                  case 285: {
                    var i2 = r2.initializer;
                    return !!i2 && Ju(i2);
                  }
                  case 288: {
                    var t2 = r2.expression;
                    return !!t2 && Ju(t2);
                  }
                }
                return false;
              }
              function fE(r2) {
                return (!e2.isFunctionDeclaration(r2) || e2.isInJSFile(r2) && !!K_(r2)) && (e2.hasContextSensitiveParameters(r2) || HI(r2));
              }
              function HI(r2) {
                return !r2.typeParameters && !e2.getEffectiveReturnTypeNode(r2) && !!r2.body && r2.body.kind !== 235 && Ju(r2.body);
              }
              function wD(r2) {
                return (e2.isInJSFile(r2) && e2.isFunctionDeclaration(r2) || e2.isFunctionExpressionOrArrowFunction(r2) || e2.isObjectLiteralMethod(r2)) && fE(r2);
              }
              function _E(r2) {
                if (r2.flags & 524288) {
                  var i2 = Ru(r2);
                  if (i2.constructSignatures.length || i2.callSignatures.length) {
                    var t2 = tu(16, r2.symbol);
                    return t2.members = i2.members, t2.properties = i2.properties, t2.callSignatures = e2.emptyArray, t2.constructSignatures = e2.emptyArray, t2.indexInfos = e2.emptyArray, t2;
                  }
                } else if (r2.flags & 2097152)
                  return Do(e2.map(r2.types, _E));
                return r2;
              }
              function wf(r2, i2) {
                return r_(r2, i2, wa);
              }
              function av(r2, i2) {
                return r_(r2, i2, wa) ? -1 : 0;
              }
              function OD(r2, i2) {
                return r_(r2, i2, dt) ? -1 : 0;
              }
              function XI(r2, i2) {
                return r_(r2, i2, Or) ? -1 : 0;
              }
              function E_(r2, i2) {
                return r_(r2, i2, Or);
              }
              function ao(r2, i2) {
                return r_(r2, i2, dt);
              }
              function xg(r2, i2) {
                return r2.flags & 1048576 ? e2.every(r2.types, function(t2) {
                  return xg(t2, i2);
                }) : i2.flags & 1048576 ? e2.some(i2.types, function(t2) {
                  return xg(r2, t2);
                }) : r2.flags & 58982400 ? xg(uc(r2) || gr, i2) : i2 === qe ? !!(r2.flags & 67633152) : i2 === br ? !!(r2.flags & 524288) && db(r2) : lf(r2, bd(i2)) || Tu(i2) && !um(i2) && xg(r2, Qi);
              }
              function cm(r2, i2) {
                return r_(r2, i2, la);
              }
              function Oh(r2, i2) {
                return cm(r2, i2) || cm(i2, r2);
              }
              function zc(r2, i2, t2, o, s2, u) {
                return hl(r2, i2, dt, t2, o, s2, u);
              }
              function op(r2, i2, t2, o, s2, u) {
                return FD(r2, i2, dt, t2, o, s2, u, void 0);
              }
              function FD(r2, i2, t2, o, s2, u, h2, z) {
                return r_(r2, i2, t2) ? true : !o || !cy(s2, r2, i2, t2, u, h2, z) ? hl(r2, i2, t2, o, u, h2, z) : false;
              }
              function pE(r2) {
                return !!(r2.flags & 16777216 || r2.flags & 2097152 && e2.some(r2.types, pE));
              }
              function cy(r2, i2, t2, o, s2, u, h2) {
                if (!r2 || pE(t2))
                  return false;
                if (!hl(i2, t2, o, void 0) && QI(r2, i2, t2, o, s2, u, h2))
                  return true;
                switch (r2.kind) {
                  case 288:
                  case 212:
                    return cy(r2.expression, i2, t2, o, s2, u, h2);
                  case 221:
                    switch (r2.operatorToken.kind) {
                      case 63:
                      case 27:
                        return cy(r2.right, i2, t2, o, s2, u, h2);
                    }
                    break;
                  case 205:
                    return nw(r2, i2, t2, o, u, h2);
                  case 204:
                    return tw(r2, i2, t2, o, u, h2);
                  case 286:
                    return iw(r2, i2, t2, o, u, h2);
                  case 214:
                    return YI(r2, i2, t2, o, u, h2);
                }
                return false;
              }
              function QI(r2, i2, t2, o, s2, u, h2) {
                for (var z = ot(i2, 0), me = ot(i2, 1), Me = 0, $e = [me, z]; Me < $e.length; Me++) {
                  var tr = $e[Me];
                  if (e2.some(tr, function(Qr) {
                    var li = yo(Qr);
                    return !(li.flags & 131073) && hl(li, t2, o, void 0);
                  })) {
                    var dr = h2 || {};
                    zc(i2, t2, r2, s2, u, dr);
                    var Dr = dr.errors[dr.errors.length - 1];
                    return e2.addRelatedInfo(Dr, e2.createDiagnosticForNode(r2, tr === me ? e2.Diagnostics.Did_you_mean_to_use_new_with_this_expression : e2.Diagnostics.Did_you_mean_to_call_this_expression)), true;
                  }
                }
                return false;
              }
              function YI(r2, i2, t2, o, s2, u) {
                if (e2.isBlock(r2.body) || e2.some(r2.parameters, e2.hasType))
                  return false;
                var h2 = ig(i2);
                if (!h2)
                  return false;
                var z = ot(t2, 0);
                if (!e2.length(z))
                  return false;
                var me = r2.body, Me = yo(h2), $e = Pa(e2.map(z, yo));
                if (!hl(Me, $e, o, void 0)) {
                  var tr = me && cy(me, Me, $e, o, void 0, s2, u);
                  if (tr)
                    return tr;
                  var dr = u || {};
                  if (hl(Me, $e, o, me, void 0, s2, dr), dr.errors)
                    return t2.symbol && e2.length(t2.symbol.declarations) && e2.addRelatedInfo(dr.errors[dr.errors.length - 1], e2.createDiagnosticForNode(t2.symbol.declarations[0], e2.Diagnostics.The_expected_type_comes_from_the_return_type_of_this_signature)), (e2.getFunctionFlags(r2) & 2) === 0 && !da(Me, "then") && hl(Ny(Me), $e, o, void 0) && e2.addRelatedInfo(dr.errors[dr.errors.length - 1], e2.createDiagnosticForNode(r2, e2.Diagnostics.Did_you_mean_to_mark_this_function_as_async)), true;
                }
                return false;
              }
              function $I(r2, i2, t2) {
                var o = ep(i2, t2);
                if (o)
                  return o;
                if (i2.flags & 1048576) {
                  var s2 = bE(r2, i2);
                  if (s2)
                    return ep(s2, t2);
                }
              }
              function ZI(r2, i2) {
                r2.contextualType = i2;
                try {
                  return Dm(r2, 1, i2);
                } finally {
                  r2.contextualType = void 0;
                }
              }
              function nv(r2, i2, t2, o, s2, u) {
                for (var h2 = false, z = r2.next(); !z.done; z = r2.next()) {
                  var me = z.value, Me = me.errorNode, $e = me.innerExpression, tr = me.nameType, dr = me.errorMessage, Dr = $I(i2, t2, tr);
                  if (!(!Dr || Dr.flags & 8388608)) {
                    var Qr = ep(i2, tr);
                    if (!!Qr) {
                      var li = gD(tr, void 0);
                      if (!hl(Qr, Dr, o, void 0)) {
                        var Ti = $e && cy($e, Qr, Dr, o, void 0, s2, u);
                        if (h2 = true, !Ti) {
                          var Ci = u || {}, $i = $e ? ZI($e, Qr) : Qr;
                          if (yr && jD($i, Dr)) {
                            var Zi = e2.createDiagnosticForNode(Me, e2.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target, Ot($i), Ot(Dr));
                            rn.add(Zi), Ci.errors = [Zi];
                          } else {
                            var qt = !!(li && (bi(t2, li) || xe).flags & 16777216), Nt = !!(li && (bi(i2, li) || xe).flags & 16777216);
                            Dr = kg(Dr, qt), Qr = kg(Qr, qt && Nt);
                            var Ra = hl($i, Dr, o, Me, dr, s2, Ci);
                            Ra && $i !== Qr && hl(Qr, Dr, o, Me, dr, s2, Ci);
                          }
                          if (Ci.errors) {
                            var ca = Ci.errors[Ci.errors.length - 1], Sn = _f(tr) ? pf(tr) : void 0, ja = Sn !== void 0 ? bi(t2, Sn) : void 0, Fn = false;
                            if (!ja) {
                              var wn = nu(t2, tr);
                              wn && wn.declaration && !e2.getSourceFileOfNode(wn.declaration).hasNoDefaultLib && (Fn = true, e2.addRelatedInfo(ca, e2.createDiagnosticForNode(wn.declaration, e2.Diagnostics.The_expected_type_comes_from_this_index_signature)));
                            }
                            if (!Fn && (ja && e2.length(ja.declarations) || t2.symbol && e2.length(t2.symbol.declarations))) {
                              var Tn = ja && e2.length(ja.declarations) ? ja.declarations[0] : t2.symbol.declarations[0];
                              e2.getSourceFileOfNode(Tn).hasNoDefaultLib || e2.addRelatedInfo(ca, e2.createDiagnosticForNode(Tn, e2.Diagnostics.The_expected_type_comes_from_property_0_which_is_declared_here_on_type_1, Sn && !(tr.flags & 8192) ? e2.unescapeLeadingUnderscores(Sn) : Ot(tr), Ot(t2)));
                            }
                          }
                        }
                      }
                    }
                  }
                }
                return h2;
              }
              function ew(r2) {
                var i2, t2, o;
                return kr(this, function(s2) {
                  switch (s2.label) {
                    case 0:
                      if (!e2.length(r2.properties))
                        return [2];
                      i2 = 0, t2 = r2.properties, s2.label = 1;
                    case 1:
                      return i2 < t2.length ? (o = t2[i2], e2.isJsxSpreadAttribute(o) || Ob(e2.idText(o.name)) ? [3, 3] : [4, { errorNode: o.name, innerExpression: o.initializer, nameType: Bu(e2.idText(o.name)) }]) : [3, 4];
                    case 2:
                      s2.sent(), s2.label = 3;
                    case 3:
                      return i2++, [3, 1];
                    case 4:
                      return [2];
                  }
                });
              }
              function rw(r2, i2) {
                var t2, o, s2, u, h2;
                return kr(this, function(z) {
                  switch (z.label) {
                    case 0:
                      if (!e2.length(r2.children))
                        return [2];
                      t2 = 0, o = 0, z.label = 1;
                    case 1:
                      return o < r2.children.length ? (s2 = r2.children[o], u = If(o - t2), h2 = dE(s2, u, i2), h2 ? [4, h2] : [3, 3]) : [3, 5];
                    case 2:
                      return z.sent(), [3, 4];
                    case 3:
                      t2++, z.label = 4;
                    case 4:
                      return o++, [3, 1];
                    case 5:
                      return [2];
                  }
                });
              }
              function dE(r2, i2, t2) {
                switch (r2.kind) {
                  case 288:
                    return { errorNode: r2, innerExpression: r2.expression, nameType: i2 };
                  case 11:
                    if (r2.containsOnlyTriviaWhiteSpaces)
                      break;
                    return { errorNode: r2, innerExpression: void 0, nameType: i2, errorMessage: t2() };
                  case 278:
                  case 279:
                  case 282:
                    return { errorNode: r2, innerExpression: r2, nameType: i2 };
                  default:
                    return e2.Debug.assertNever(r2, "Found invalid jsx child");
                }
              }
              function iw(r2, i2, t2, o, s2, u) {
                var h2 = nv(ew(r2), i2, t2, o, s2, u), z;
                if (e2.isJsxOpeningElement(r2.parent) && e2.isJsxElement(r2.parent.parent)) {
                  var me = r2.parent.parent, Me = _0(Og(r2)), $e = Me === void 0 ? "children" : e2.unescapeLeadingUnderscores(Me), tr = Bu($e), dr = Jc(t2, tr), Dr = e2.getSemanticJsxChildren(me.children);
                  if (!e2.length(Dr))
                    return h2;
                  var Qr = e2.length(Dr) > 1, li = ec(dr, AE), Ti = ec(dr, function(ca) {
                    return !AE(ca);
                  });
                  if (Qr) {
                    if (li !== ui) {
                      var Ci = Wl(f0(me, 0)), $i = rw(me, Ra);
                      h2 = nv($i, Ci, li, o, s2, u) || h2;
                    } else if (!r_(Jc(i2, tr), dr, o)) {
                      h2 = true;
                      var Zi = Xr(me.openingElement.tagName, e2.Diagnostics.This_JSX_tag_s_0_prop_expects_a_single_child_of_type_1_but_multiple_children_were_provided, $e, Ot(dr));
                      u && u.skipLogging && (u.errors || (u.errors = [])).push(Zi);
                    }
                  } else if (Ti !== ui) {
                    var qt = Dr[0], Nt = dE(qt, tr, Ra);
                    Nt && (h2 = nv(function() {
                      return kr(this, function(ca) {
                        switch (ca.label) {
                          case 0:
                            return [4, Nt];
                          case 1:
                            return ca.sent(), [2];
                        }
                      });
                    }(), i2, t2, o, s2, u) || h2);
                  } else if (!r_(Jc(i2, tr), dr, o)) {
                    h2 = true;
                    var Zi = Xr(me.openingElement.tagName, e2.Diagnostics.This_JSX_tag_s_0_prop_expects_type_1_which_requires_multiple_children_but_only_a_single_child_was_provided, $e, Ot(dr));
                    u && u.skipLogging && (u.errors || (u.errors = [])).push(Zi);
                  }
                }
                return h2;
                function Ra() {
                  if (!z) {
                    var ca = e2.getTextOfNode(r2.parent.tagName), Sn = _0(Og(r2)), ja = Sn === void 0 ? "children" : e2.unescapeLeadingUnderscores(Sn), Fn = Jc(t2, Bu(ja)), wn = e2.Diagnostics._0_components_don_t_accept_text_as_child_elements_Text_in_JSX_has_the_type_string_but_the_expected_type_of_1_is_2;
                    z = Ke(Ke({}, wn), { key: "!!ALREADY FORMATTED!!", message: e2.formatMessage(void 0, wn, ca, ja, Ot(Fn)) });
                  }
                  return z;
                }
              }
              function gE(r2, i2) {
                var t2, o, s2, u;
                return kr(this, function(h2) {
                  switch (h2.label) {
                    case 0:
                      if (t2 = e2.length(r2.elements), !t2)
                        return [2];
                      o = 0, h2.label = 1;
                    case 1:
                      return o < t2 ? Eg(i2) && !bi(i2, "" + o) ? [3, 3] : (s2 = r2.elements[o], e2.isOmittedExpression(s2) ? [3, 3] : (u = If(o), [4, { errorNode: s2, innerExpression: s2, nameType: u }])) : [3, 4];
                    case 2:
                      h2.sent(), h2.label = 3;
                    case 3:
                      return o++, [3, 1];
                    case 4:
                      return [2];
                  }
                });
              }
              function tw(r2, i2, t2, o, s2, u) {
                if (t2.flags & 131068)
                  return false;
                if (Eg(i2))
                  return nv(gE(r2, t2), i2, t2, o, s2, u);
                var h2 = r2.contextualType;
                r2.contextualType = t2;
                try {
                  var z = PC(r2, 1, true);
                  return r2.contextualType = h2, Eg(z) ? nv(gE(r2, t2), z, t2, o, s2, u) : false;
                } finally {
                  r2.contextualType = h2;
                }
              }
              function aw(r2) {
                var i2, t2, o, s2, u;
                return kr(this, function(h2) {
                  switch (h2.label) {
                    case 0:
                      if (!e2.length(r2.properties))
                        return [2];
                      i2 = 0, t2 = r2.properties, h2.label = 1;
                    case 1:
                      if (!(i2 < t2.length))
                        return [3, 8];
                      if (o = t2[i2], e2.isSpreadAssignment(o))
                        return [3, 7];
                      if (s2 = om(Et(o), 8576), !s2 || s2.flags & 131072)
                        return [3, 7];
                      switch (u = o.kind, u) {
                        case 173:
                          return [3, 2];
                        case 172:
                          return [3, 2];
                        case 169:
                          return [3, 2];
                        case 297:
                          return [3, 2];
                        case 296:
                          return [3, 4];
                      }
                      return [3, 6];
                    case 2:
                      return [4, { errorNode: o.name, innerExpression: void 0, nameType: s2 }];
                    case 3:
                      return h2.sent(), [3, 7];
                    case 4:
                      return [4, { errorNode: o.name, innerExpression: o.initializer, nameType: s2, errorMessage: e2.isComputedNonLiteralName(o.name) ? e2.Diagnostics.Type_of_computed_property_s_value_is_0_which_is_not_assignable_to_type_1 : void 0 }];
                    case 5:
                      return h2.sent(), [3, 7];
                    case 6:
                      e2.Debug.assertNever(o), h2.label = 7;
                    case 7:
                      return i2++, [3, 1];
                    case 8:
                      return [2];
                  }
                });
              }
              function nw(r2, i2, t2, o, s2, u) {
                return t2.flags & 131068 ? false : nv(aw(r2), i2, t2, o, s2, u);
              }
              function mE(r2, i2, t2, o, s2) {
                return hl(r2, i2, la, t2, o, s2);
              }
              function ow(r2, i2, t2) {
                return MD(r2, i2, t2 ? 4 : 0, false, void 0, void 0, OD, void 0) !== 0;
              }
              function sw(r2) {
                return !r2.typeParameters && (!r2.thisParameter || ta(mv(r2.thisParameter))) && r2.parameters.length === 1 && H(r2) && (mv(r2.parameters[0]) === mo || ta(mv(r2.parameters[0]))) && ta(yo(r2));
              }
              function MD(r2, i2, t2, o, s2, u, h2, z) {
                if (r2 === i2 || sw(i2))
                  return -1;
                var me = Wc(i2), Me = !Xl(i2) && (t2 & 8 ? Xl(r2) || Wc(r2) > me : Hl(r2) > me);
                if (Me)
                  return 0;
                r2.typeParameters && r2.typeParameters !== i2.typeParameters && (i2 = g3(i2), r2 = sk(r2, i2, void 0, h2));
                var $e = Wc(r2), tr = yv(r2), dr = yv(i2);
                (tr || dr) && un(tr || dr, z);
                var Dr = i2.declaration ? i2.declaration.kind : 0, Qr = !(t2 & 3) && Br && Dr !== 169 && Dr !== 168 && Dr !== 171, li = -1, Ti = T_(r2);
                if (Ti && Ti !== Fi) {
                  var Ci = T_(i2);
                  if (Ci) {
                    var $i = !Qr && h2(Ti, Ci, false) || h2(Ci, Ti, o);
                    if (!$i)
                      return o && s2(e2.Diagnostics.The_this_types_of_each_signature_are_incompatible), 0;
                    li &= $i;
                  }
                }
                for (var Zi = tr || dr ? Math.min($e, me) : Math.max($e, me), qt = tr || dr ? Zi - 1 : -1, Nt = 0; Nt < Zi; Nt++) {
                  var Ra = Nt === qt ? ym(r2, Nt) : Ld(r2, Nt), ca = Nt === qt ? ym(i2, Nt) : Ld(i2, Nt);
                  if (Ra && ca) {
                    var Sn = t2 & 3 ? void 0 : ig(C_(Ra)), ja = t2 & 3 ? void 0 : ig(C_(ca)), Fn = Sn && ja && !Yc(Sn) && !Yc(ja) && (ju(Ra) & 98304) === (ju(ca) & 98304), $i = Fn ? MD(ja, Sn, t2 & 8 | (Qr ? 2 : 1), o, s2, u, h2, z) : !(t2 & 3) && !Qr && h2(Ra, ca, false) || h2(ca, Ra, o);
                    if ($i && t2 & 8 && Nt >= Hl(r2) && Nt < Hl(i2) && h2(Ra, ca, false) && ($i = 0), !$i)
                      return o && s2(e2.Diagnostics.Types_of_parameters_0_and_1_are_incompatible, e2.unescapeLeadingUnderscores(vm(r2, Nt)), e2.unescapeLeadingUnderscores(vm(i2, Nt))), 0;
                    li &= $i;
                  }
                }
                if (!(t2 & 4)) {
                  var wn = Z1(i2) ? Oe : i2.declaration && Sl(i2.declaration) ? aa(so(i2.declaration.symbol)) : yo(i2);
                  if (wn === Fi || wn === Oe)
                    return li;
                  var Tn = Z1(r2) ? Oe : r2.declaration && Sl(r2.declaration) ? aa(so(r2.declaration.symbol)) : yo(r2), Eo = Yc(i2);
                  if (Eo) {
                    var lt = Yc(r2);
                    if (lt)
                      li &= cw(lt, Eo, o, s2, h2);
                    else if (e2.isIdentifierTypePredicate(Eo))
                      return o && s2(e2.Diagnostics.Signature_0_must_be_a_type_predicate, Ml(r2)), 0;
                  } else
                    li &= t2 & 1 && h2(wn, Tn, false) || h2(Tn, wn, o), !li && o && u && u(Tn, wn);
                }
                return li;
              }
              function cw(r2, i2, t2, o, s2) {
                if (r2.kind !== i2.kind)
                  return t2 && (o(e2.Diagnostics.A_this_based_type_guard_is_not_compatible_with_a_parameter_based_type_guard), o(e2.Diagnostics.Type_predicate_0_is_not_assignable_to_1, Ll(r2), Ll(i2))), 0;
                if ((r2.kind === 1 || r2.kind === 3) && r2.parameterIndex !== i2.parameterIndex)
                  return t2 && (o(e2.Diagnostics.Parameter_0_is_not_in_the_same_position_as_parameter_1, r2.parameterName, i2.parameterName), o(e2.Diagnostics.Type_predicate_0_is_not_assignable_to_1, Ll(r2), Ll(i2))), 0;
                var u = r2.type === i2.type ? -1 : r2.type && i2.type ? s2(r2.type, i2.type, t2) : 0;
                return u === 0 && t2 && o(e2.Diagnostics.Type_predicate_0_is_not_assignable_to_1, Ll(r2), Ll(i2)), u;
              }
              function uw(r2, i2) {
                var t2 = Qm(r2), o = Qm(i2), s2 = yo(t2), u = yo(o);
                return u === Fi || r_(u, s2, dt) || r_(s2, u, dt) ? ow(t2, o, true) : false;
              }
              function LD(r2) {
                return r2 !== xn && r2.properties.length === 0 && r2.callSignatures.length === 0 && r2.constructSignatures.length === 0 && r2.indexInfos.length === 0;
              }
              function Of(r2) {
                return r2.flags & 524288 ? !Bc(r2) && LD(Ru(r2)) : r2.flags & 67108864 ? true : r2.flags & 1048576 ? e2.some(r2.types, Of) : r2.flags & 2097152 ? e2.every(r2.types, Of) : false;
              }
              function vE(r2) {
                return !!(e2.getObjectFlags(r2) & 16 && (r2.members && LD(r2) || r2.symbol && r2.symbol.flags & 2048 && Nf(r2.symbol).size === 0));
              }
              function yE(r2) {
                return r2.flags & 524288 && !Bc(r2) && uo(r2).length === 0 && Hn(r2).length === 1 && !!ss(r2, Li) || r2.flags & 3145728 && e2.every(r2.types, yE) || false;
              }
              function RD(r2, i2, t2) {
                if (r2 === i2)
                  return true;
                var o = y(r2) + "," + y(i2), s2 = On.get(o);
                if (s2 !== void 0 && !(!(s2 & 4) && s2 & 2 && t2))
                  return !!(s2 & 1);
                if (r2.escapedName !== i2.escapedName || !(r2.flags & 256) || !(i2.flags & 256))
                  return On.set(o, 6), false;
                for (var u = Jt(i2), h2 = 0, z = uo(Jt(r2)); h2 < z.length; h2++) {
                  var me = z[h2];
                  if (me.flags & 8) {
                    var Me = bi(u, me.escapedName);
                    if (!Me || !(Me.flags & 8))
                      return t2 ? (t2(e2.Diagnostics.Property_0_is_missing_in_type_1, e2.symbolName(me), Ot(go(i2), void 0, 64)), On.set(o, 6)) : On.set(o, 2), false;
                  }
                }
                return On.set(o, 1), true;
              }
              function uy(r2, i2, t2, o) {
                var s2 = r2.flags, u = i2.flags;
                return u & 3 || s2 & 131072 || r2 === Mr ? true : u & 131072 ? false : !!(s2 & 402653316 && u & 4 || s2 & 128 && s2 & 1024 && u & 128 && !(u & 1024) && r2.value === i2.value || s2 & 296 && u & 8 || s2 & 256 && s2 & 1024 && u & 256 && !(u & 1024) && r2.value === i2.value || s2 & 2112 && u & 64 || s2 & 528 && u & 16 || s2 & 12288 && u & 4096 || s2 & 32 && u & 32 && RD(r2.symbol, i2.symbol, o) || s2 & 1024 && u & 1024 && (s2 & 1048576 && u & 1048576 && RD(r2.symbol, i2.symbol, o) || s2 & 2944 && u & 2944 && r2.value === i2.value && RD(Ys(r2.symbol), Ys(i2.symbol), o)) || s2 & 32768 && (!Ye && !(u & 3145728) || u & 49152) || s2 & 65536 && (!Ye && !(u & 3145728) || u & 65536) || s2 & 524288 && u & 67108864 || (t2 === dt || t2 === la) && (s2 & 1 || s2 & 264 && !(s2 & 1024) && (u & 32 || t2 === dt && u & 256 && u & 1024)));
              }
              function r_(r2, i2, t2) {
                if (Kp(r2) && (r2 = r2.regularType), Kp(i2) && (i2 = i2.regularType), r2 === i2)
                  return true;
                if (t2 !== wa) {
                  if (t2 === la && !(i2.flags & 131072) && uy(i2, r2, t2) || uy(r2, i2, t2))
                    return true;
                } else if (!((r2.flags | i2.flags) & 61865984)) {
                  if (r2.flags !== i2.flags)
                    return false;
                  if (r2.flags & 67358815)
                    return true;
                }
                if (r2.flags & 524288 && i2.flags & 524288) {
                  var o = t2.get(qD(r2, i2, 0, t2, false));
                  if (o !== void 0)
                    return !!(o & 1);
                }
                return r2.flags & 469499904 || i2.flags & 469499904 ? hl(r2, i2, t2, void 0) : false;
              }
              function hE(r2, i2) {
                return e2.getObjectFlags(r2) & 2048 && Ob(i2.escapedName);
              }
              function BD(r2, i2) {
                for (; ; ) {
                  var t2 = Kp(r2) ? r2.regularType : e2.getObjectFlags(r2) & 4 && r2.node ? Yf(r2.target, xo(r2)) : r2.flags & 3145728 ? bu(r2) : r2.flags & 33554432 ? i2 ? r2.baseType : r2.substitute : r2.flags & 25165824 ? Zf(r2, i2) : r2;
                  if (t2 = GD(t2) || t2, t2 === r2)
                    break;
                  r2 = t2;
                }
                return r2;
              }
              function hl(r2, i2, t2, o, s2, u, h2) {
                var z, me, Me, $e, tr, dr = 0, Dr = 0, Qr = 0, li = 0, Ti = false, Ci = 0, $i, Zi, qt = false;
                e2.Debug.assert(t2 !== wa || !o, "no error reporting in identity checking");
                var Nt = oa(r2, i2, 3, !!o, s2);
                if (Zi && it(), Ti) {
                  e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("checkTypes", "checkTypeRelatedTo_DepthLimit", { sourceId: r2.id, targetId: i2.id, depth: Dr, targetDepth: Qr });
                  var Ra = Xr(o || Ie, e2.Diagnostics.Excessive_stack_depth_comparing_types_0_and_1, Ot(r2), Ot(i2));
                  h2 && (h2.errors || (h2.errors = [])).push(Ra);
                } else if (z) {
                  if (u) {
                    var ca = u();
                    ca && (e2.concatenateDiagnosticMessageChains(ca, z), z = ca);
                  }
                  var Sn = void 0;
                  if (s2 && o && !Nt && r2.symbol) {
                    var ja = Aa(r2.symbol);
                    if (ja.originatingImport && !e2.isImportCall(ja.originatingImport)) {
                      var Fn = hl(Jt(ja.target), i2, t2, void 0);
                      if (Fn) {
                        var wn = e2.createDiagnosticForNode(ja.originatingImport, e2.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead);
                        Sn = e2.append(Sn, wn);
                      }
                    }
                  }
                  var Ra = e2.createDiagnosticForNodeFromMessageChain(o, z, Sn);
                  me && e2.addRelatedInfo.apply(void 0, Ve([Ra], me, false)), h2 && (h2.errors || (h2.errors = [])).push(Ra), (!h2 || !h2.skipLogging) && rn.add(Ra);
                }
                return o && h2 && h2.skipLogging && Nt === 0 && e2.Debug.assert(!!h2.errors, "missed opportunity to interact with error."), Nt !== 0;
                function Tn($r) {
                  z = $r.errorInfo, $i = $r.lastSkippedInfo, Zi = $r.incompatibleStack, Ci = $r.overrideNextErrorInfo, me = $r.relatedInfo;
                }
                function Eo() {
                  return { errorInfo: z, lastSkippedInfo: $i, incompatibleStack: Zi == null ? void 0 : Zi.slice(), overrideNextErrorInfo: Ci, relatedInfo: me == null ? void 0 : me.slice() };
                }
                function lt($r, hi, Ri, mt, ft) {
                  Ci++, $i = void 0, (Zi || (Zi = [])).push([$r, hi, Ri, mt, ft]);
                }
                function it() {
                  var $r = Zi || [];
                  Zi = void 0;
                  var hi = $i;
                  if ($i = void 0, $r.length === 1) {
                    Yt.apply(void 0, $r[0]), hi && Qt.apply(void 0, Ve([void 0], hi, false));
                    return;
                  }
                  for (var Ri = "", mt = []; $r.length; ) {
                    var ft = $r.pop(), Ht = ft[0], vt = ft.slice(1);
                    switch (Ht.code) {
                      case e2.Diagnostics.Types_of_property_0_are_incompatible.code: {
                        Ri.indexOf("new ") === 0 && (Ri = "(".concat(Ri, ")"));
                        var ht = "" + vt[0];
                        Ri.length === 0 ? Ri = "".concat(ht) : e2.isIdentifierText(ht, e2.getEmitScriptTarget(ye)) ? Ri = "".concat(Ri, ".").concat(ht) : ht[0] === "[" && ht[ht.length - 1] === "]" ? Ri = "".concat(Ri).concat(ht) : Ri = "".concat(Ri, "[").concat(ht, "]");
                        break;
                      }
                      case e2.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible.code:
                      case e2.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code:
                      case e2.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code:
                      case e2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code: {
                        if (Ri.length === 0) {
                          var ma = Ht;
                          Ht.code === e2.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? ma = e2.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible : Ht.code === e2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code && (ma = e2.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible), mt.unshift([ma, vt[0], vt[1]]);
                        } else {
                          var Ca = Ht.code === e2.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible.code || Ht.code === e2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "new " : "", An = Ht.code === e2.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code || Ht.code === e2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1.code ? "" : "...";
                          Ri = "".concat(Ca).concat(Ri, "(").concat(An, ")");
                        }
                        break;
                      }
                      case e2.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target.code: {
                        mt.unshift([e2.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, vt[0], vt[1]]);
                        break;
                      }
                      case e2.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target.code: {
                        mt.unshift([e2.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, vt[0], vt[1], vt[2]]);
                        break;
                      }
                      default:
                        return e2.Debug.fail("Unhandled Diagnostic: ".concat(Ht.code));
                    }
                  }
                  Ri ? Yt(Ri[Ri.length - 1] === ")" ? e2.Diagnostics.The_types_returned_by_0_are_incompatible_between_these_types : e2.Diagnostics.The_types_of_0_are_incompatible_between_these_types, Ri) : mt.shift();
                  for (var gn = 0, Vn = mt; gn < Vn.length; gn++) {
                    var zo = Vn[gn], Ht = zo[0], vt = zo.slice(1), us = Ht.elidedInCompatabilityPyramid;
                    Ht.elidedInCompatabilityPyramid = false, Yt.apply(void 0, Ve([Ht], vt, false)), Ht.elidedInCompatabilityPyramid = us;
                  }
                  hi && Qt.apply(void 0, Ve([void 0], hi, false));
                }
                function Yt($r, hi, Ri, mt, ft) {
                  e2.Debug.assert(!!o), Zi && it(), !$r.elidedInCompatabilityPyramid && (z = e2.chainDiagnosticMessages(z, $r, hi, Ri, mt, ft));
                }
                function Ia($r) {
                  e2.Debug.assert(!!z), me ? me.push($r) : me = [$r];
                }
                function Qt($r, hi, Ri) {
                  Zi && it();
                  var mt = nf(hi, Ri), ft = mt[0], Ht = mt[1], vt = hi, ht = ft;
                  if (Cg(hi) && !JD(Ri) && (vt = Kl(hi), e2.Debug.assert(!ao(vt, Ri), "generalized source shouldn't be assignable"), ht = q_(vt)), Ri.flags & 262144 && Ri !== Rn && Ri !== Da) {
                    var ma = uc(Ri), Ca = void 0;
                    ma && (ao(vt, ma) || (Ca = ao(hi, ma))) ? Yt(e2.Diagnostics._0_is_assignable_to_the_constraint_of_type_1_but_1_could_be_instantiated_with_a_different_subtype_of_constraint_2, Ca ? ft : ht, Ht, Ot(ma)) : (z = void 0, Yt(e2.Diagnostics._0_could_be_instantiated_with_an_arbitrary_type_which_could_be_unrelated_to_1, Ht, ht));
                  }
                  if ($r)
                    $r === e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1 && yr && DE(hi, Ri).length && ($r = e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties);
                  else if (t2 === la)
                    $r = e2.Diagnostics.Type_0_is_not_comparable_to_type_1;
                  else if (ft === Ht)
                    $r = e2.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated;
                  else if (yr && DE(hi, Ri).length)
                    $r = e2.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties;
                  else {
                    if (hi.flags & 128 && Ri.flags & 1048576) {
                      var An = t7(hi, Ri);
                      if (An) {
                        Yt(e2.Diagnostics.Type_0_is_not_assignable_to_type_1_Did_you_mean_2, ht, Ht, Ot(An));
                        return;
                      }
                    }
                    $r = e2.Diagnostics.Type_0_is_not_assignable_to_type_1;
                  }
                  Yt($r, ht, Ht);
                }
                function Ka($r, hi) {
                  var Ri = Kf($r.symbol) ? Ot($r, $r.symbol.valueDeclaration) : Ot($r), mt = Kf(hi.symbol) ? Ot(hi, hi.symbol.valueDeclaration) : Ot(hi);
                  (Ct === $r && Li === hi || sa === $r && nt === hi || en === $r && Ii === hi || Cx() === $r && Ki === hi) && Yt(e2.Diagnostics._0_is_a_primitive_but_1_is_a_wrapper_object_Prefer_using_0_when_possible, mt, Ri);
                }
                function cn($r, hi, Ri) {
                  return Yn($r) ? $r.target.readonly && Bh(hi) ? (Ri && Yt(e2.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, Ot($r), Ot(hi)), false) : Pd(hi) : um($r) && Bh(hi) ? (Ri && Yt(e2.Diagnostics.The_type_0_is_readonly_and_cannot_be_assigned_to_the_mutable_type_1, Ot($r), Ot(hi)), false) : Yn(hi) ? Tu($r) : true;
                }
                function Un($r, hi, Ri) {
                  return oa($r, hi, 3, Ri);
                }
                function oa($r, hi, Ri, mt, ft, Ht) {
                  if (Ri === void 0 && (Ri = 3), mt === void 0 && (mt = false), Ht === void 0 && (Ht = 0), $r.flags & 524288 && hi.flags & 131068)
                    return uy($r, hi, t2, mt ? Yt : void 0) ? -1 : (mt && Mn($r, hi, $r, hi, ft), 0);
                  var vt = BD($r, false), ht = BD(hi, true);
                  if (vt === ht)
                    return -1;
                  if (t2 === wa)
                    return vt.flags !== ht.flags ? 0 : vt.flags & 67358815 ? -1 : (Ln(vt, ht), _t(vt, ht, false, 0, Ri));
                  if (vt.flags & 262144 && Q_(vt) === ht)
                    return -1;
                  if (vt.flags & 470302716 && ht.flags & 1048576) {
                    var ma = ht.types, Ca = ma.length === 2 && ma[0].flags & 98304 ? ma[1] : ma.length === 3 && ma[0].flags & 98304 && ma[1].flags & 98304 ? ma[2] : void 0;
                    if (Ca && !(Ca.flags & 98304) && (ht = BD(Ca, true), vt === ht))
                      return -1;
                  }
                  if (t2 === la && !(ht.flags & 131072) && uy(ht, vt, t2) || uy(vt, ht, t2, mt ? Yt : void 0))
                    return -1;
                  if (vt.flags & 469499904 || ht.flags & 469499904) {
                    var An = !(Ht & 2) && Qp(vt) && e2.getObjectFlags(vt) & 8192;
                    if (An && Fr(vt, ht, mt))
                      return mt && Qt(ft, vt, hi.aliasSymbol ? hi : ht), 0;
                    var gn = t2 !== la && !(Ht & 2) && vt.flags & 2752508 && vt !== qe && ht.flags & 2621440 && SE(ht) && (uo(vt).length > 0 || RS(vt)), Vn = !!(e2.getObjectFlags(vt) & 2048);
                    if (gn && !fw(vt, ht, Vn)) {
                      if (mt) {
                        var zo = Ot($r.aliasSymbol ? $r : vt), us = Ot(hi.aliasSymbol ? hi : ht), Bo = ot(vt, 0), Io = ot(vt, 1);
                        Bo.length > 0 && oa(yo(Bo[0]), ht, 1, false) || Io.length > 0 && oa(yo(Io[0]), ht, 1, false) ? Yt(e2.Diagnostics.Value_of_type_0_has_no_properties_in_common_with_type_1_Did_you_mean_to_call_it, zo, us) : Yt(e2.Diagnostics.Type_0_has_no_properties_in_common_with_type_1, zo, us);
                      }
                      return 0;
                    }
                    Ln(vt, ht);
                    var Qo = vt.flags & 1048576 && vt.types.length < 4 && !(ht.flags & 1048576) || ht.flags & 1048576 && ht.types.length < 4 && !(vt.flags & 469499904), ls = Qo ? Lt(vt, ht, mt, Ht) : _t(vt, ht, mt, Ht, Ri);
                    if (ls && !qt && (ht.flags & 2097152 && (An || gn) || bD(ht) && !Pd(ht) && vt.flags & 2097152 && $s(vt).flags & 3670016 && !e2.some(vt.types, function(gi) {
                      return !!(e2.getObjectFlags(gi) & 262144);
                    })) && (qt = true, ls &= _t(vt, ht, mt, 4, Ri), qt = false), ls)
                      return ls;
                  }
                  return mt && Mn($r, hi, vt, ht, ft), 0;
                }
                function Mn($r, hi, Ri, mt, ft) {
                  var Ht = !!GD($r), vt = !!GD(hi);
                  Ri = $r.aliasSymbol || Ht ? $r : Ri, mt = hi.aliasSymbol || vt ? hi : mt;
                  var ht = Ci > 0;
                  if (ht && Ci--, Ri.flags & 524288 && mt.flags & 524288) {
                    var ma = z;
                    cn(Ri, mt, true), z !== ma && (ht = !!z);
                  }
                  if (Ri.flags & 524288 && mt.flags & 131068)
                    Ka(Ri, mt);
                  else if (Ri.symbol && Ri.flags & 524288 && qe === Ri)
                    Yt(e2.Diagnostics.The_Object_type_is_assignable_to_very_few_other_types_Did_you_mean_to_use_the_any_type_instead);
                  else if (e2.getObjectFlags(Ri) & 2048 && mt.flags & 2097152) {
                    var Ca = mt.types, An = Zp(U.IntrinsicAttributes, o), gn = Zp(U.IntrinsicClassAttributes, o);
                    if (!nn(An) && !nn(gn) && (e2.contains(Ca, An) || e2.contains(Ca, gn)))
                      return;
                  } else
                    z = ei(z, hi);
                  if (!ft && ht) {
                    $i = [Ri, mt];
                    return;
                  }
                  Qt(ft, Ri, mt);
                }
                function Ln($r, hi) {
                  if (!!e2.tracing && $r.flags & 3145728 && hi.flags & 3145728) {
                    var Ri = $r, mt = hi;
                    if (Ri.objectFlags & mt.objectFlags & 32768)
                      return;
                    var ft = Ri.types.length, Ht = mt.types.length;
                    ft * Ht > 1e6 && e2.tracing.instant("checkTypes", "traceUnionsOrIntersectionsTooLarge_DepthLimit", { sourceId: $r.id, sourceSize: ft, targetId: hi.id, targetSize: Ht, pos: o == null ? void 0 : o.pos, end: o == null ? void 0 : o.end });
                  }
                }
                function ci($r, hi) {
                  var Ri = function(mt, ft) {
                    var Ht;
                    ft = $s(ft);
                    var vt = ft.flags & 3145728 ? Zv(ft, hi) : h_(ft, hi), ht = vt && Jt(vt) || ((Ht = Xo(ft, hi)) === null || Ht === void 0 ? void 0 : Ht.type) || Tr;
                    return e2.append(mt, ht);
                  };
                  return Pa(e2.reduceLeft($r, Ri, void 0) || e2.emptyArray);
                }
                function Fr($r, hi, Ri) {
                  var mt;
                  if (!Sy(hi) || !n && e2.getObjectFlags(hi) & 4096)
                    return false;
                  var ft = !!(e2.getObjectFlags($r) & 2048);
                  if ((t2 === dt || t2 === la) && (dy(qe, hi) || !ft && Of(hi)))
                    return false;
                  var Ht = hi, vt;
                  hi.flags & 1048576 && (Ht = bA($r, hi, oa) || IL(hi), vt = Ht.flags & 1048576 ? Ht.types : [Ht]);
                  for (var ht = function(Vn) {
                    if (jt(Vn, $r.symbol) && !hE($r, Vn)) {
                      if (!Rb(Ht, Vn.escapedName, ft)) {
                        if (Ri) {
                          var zo = ec(Ht, Sy);
                          if (!o)
                            return { value: e2.Debug.fail() };
                          if (e2.isJsxAttributes(o) || e2.isJsxOpeningLikeElement(o) || e2.isJsxOpeningLikeElement(o.parent)) {
                            Vn.valueDeclaration && e2.isJsxAttribute(Vn.valueDeclaration) && e2.getSourceFileOfNode(o) === e2.getSourceFileOfNode(Vn.valueDeclaration.name) && (o = Vn.valueDeclaration.name);
                            var us = tn(Vn), Bo = ek(us, zo), Io = Bo ? tn(Bo) : void 0;
                            Io ? Yt(e2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2, us, Ot(zo), Io) : Yt(e2.Diagnostics.Property_0_does_not_exist_on_type_1, us, Ot(zo));
                          } else {
                            var Qo = ((mt = $r.symbol) === null || mt === void 0 ? void 0 : mt.declarations) && e2.firstOrUndefined($r.symbol.declarations), Io = void 0;
                            if (Vn.valueDeclaration && e2.findAncestor(Vn.valueDeclaration, function(La) {
                              return La === Qo;
                            }) && e2.getSourceFileOfNode(Qo) === e2.getSourceFileOfNode(o)) {
                              var ls = Vn.valueDeclaration;
                              e2.Debug.assertNode(ls, e2.isObjectLiteralElementLike), o = ls;
                              var gi = ls.name;
                              e2.isIdentifier(gi) && (Io = Vb(gi, zo));
                            }
                            Io !== void 0 ? Yt(e2.Diagnostics.Object_literal_may_only_specify_known_properties_but_0_does_not_exist_in_type_1_Did_you_mean_to_write_2, tn(Vn), Ot(zo), Io) : Yt(e2.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, tn(Vn), Ot(zo));
                          }
                        }
                        return { value: true };
                      }
                      if (vt && !oa(Jt(Vn), ci(vt, Vn.escapedName), 3, Ri))
                        return Ri && lt(e2.Diagnostics.Types_of_property_0_are_incompatible, tn(Vn)), { value: true };
                    }
                  }, ma = 0, Ca = uo($r); ma < Ca.length; ma++) {
                    var An = Ca[ma], gn = ht(An);
                    if (typeof gn == "object")
                      return gn.value;
                  }
                  return false;
                }
                function jt($r, hi) {
                  return $r.valueDeclaration && hi.valueDeclaration && $r.valueDeclaration.parent === hi.valueDeclaration;
                }
                function Lt($r, hi, Ri, mt) {
                  if ($r.flags & 1048576)
                    return t2 === la ? Ua($r, hi, Ri && !($r.flags & 131068), mt) : Ni($r, hi, Ri && !($r.flags & 131068), mt);
                  if (hi.flags & 1048576)
                    return Kt(fm($r), hi, Ri && !($r.flags & 131068) && !(hi.flags & 131068));
                  if (hi.flags & 2097152)
                    return $t(fm($r), hi, Ri, 2);
                  if (t2 === la && hi.flags & 131068) {
                    var ft = e2.sameMap($r.types, Hd);
                    if (ft !== $r.types && ($r = Do(ft), !($r.flags & 2097152)))
                      return oa($r, hi, 1, false);
                  }
                  return Ua($r, hi, false, 1);
                }
                function ea($r, hi) {
                  for (var Ri = -1, mt = $r.types, ft = 0, Ht = mt; ft < Ht.length; ft++) {
                    var vt = Ht[ft], ht = Kt(vt, hi, false);
                    if (!ht)
                      return 0;
                    Ri &= ht;
                  }
                  return Ri;
                }
                function Kt($r, hi, Ri) {
                  var mt = hi.types;
                  if (hi.flags & 1048576) {
                    if ($f(mt, $r))
                      return -1;
                    var ft = $E(hi, $r);
                    if (ft) {
                      var Ht = oa($r, ft, 2, false);
                      if (Ht)
                        return Ht;
                    }
                  }
                  for (var vt = 0, ht = mt; vt < ht.length; vt++) {
                    var ma = ht[vt], Ht = oa($r, ma, 2, false);
                    if (Ht)
                      return Ht;
                  }
                  if (Ri) {
                    var Ca = bE($r, hi, oa);
                    Ca && oa($r, Ca, 2, true);
                  }
                  return 0;
                }
                function $t($r, hi, Ri, mt) {
                  for (var ft = -1, Ht = hi.types, vt = 0, ht = Ht; vt < ht.length; vt++) {
                    var ma = ht[vt], Ca = oa($r, ma, 2, Ri, void 0, mt);
                    if (!Ca)
                      return 0;
                    ft &= Ca;
                  }
                  return ft;
                }
                function Ua($r, hi, Ri, mt) {
                  var ft = $r.types;
                  if ($r.flags & 1048576 && $f(ft, hi))
                    return -1;
                  for (var Ht = ft.length, vt = 0; vt < Ht; vt++) {
                    var ht = oa(ft[vt], hi, 1, Ri && vt === Ht - 1, void 0, mt);
                    if (ht)
                      return ht;
                  }
                  return 0;
                }
                function Yr($r, hi) {
                  return $r.flags & 1048576 && hi.flags & 1048576 && !($r.types[0].flags & 32768) && hi.types[0].flags & 32768 ? Ng(hi, -32769) : hi;
                }
                function Ni($r, hi, Ri, mt) {
                  for (var ft = -1, Ht = $r.types, vt = Yr($r, hi), ht = 0; ht < Ht.length; ht++) {
                    var ma = Ht[ht];
                    if (vt.flags & 1048576 && Ht.length >= vt.types.length && Ht.length % vt.types.length === 0) {
                      var Ca = oa(ma, vt.types[ht % vt.types.length], 3, false, void 0, mt);
                      if (Ca) {
                        ft &= Ca;
                        continue;
                      }
                    }
                    var An = oa(ma, hi, 1, Ri, void 0, mt);
                    if (!An)
                      return 0;
                    ft &= An;
                  }
                  return ft;
                }
                function Hi($r, hi, Ri, mt, ft) {
                  if ($r === void 0 && ($r = e2.emptyArray), hi === void 0 && (hi = e2.emptyArray), Ri === void 0 && (Ri = e2.emptyArray), $r.length !== hi.length && t2 === wa)
                    return 0;
                  for (var Ht = $r.length <= hi.length ? $r.length : hi.length, vt = -1, ht = 0; ht < Ht; ht++) {
                    var ma = ht < Ri.length ? Ri[ht] : 1, Ca = ma & 7;
                    if (Ca !== 4) {
                      var An = $r[ht], gn = hi[ht], Vn = -1;
                      if (ma & 8 ? Vn = t2 === wa ? oa(An, gn, 3, false) : av(An, gn) : Ca === 1 ? Vn = oa(An, gn, 3, mt, void 0, ft) : Ca === 2 ? Vn = oa(gn, An, 3, mt, void 0, ft) : Ca === 3 ? (Vn = oa(gn, An, 3, false), Vn || (Vn = oa(An, gn, 3, mt, void 0, ft))) : (Vn = oa(An, gn, 3, mt, void 0, ft), Vn && (Vn &= oa(gn, An, 3, mt, void 0, ft))), !Vn)
                        return 0;
                      vt &= Vn;
                    }
                  }
                  return vt;
                }
                function _t($r, hi, Ri, mt, ft) {
                  if (Ti)
                    return 0;
                  var Ht = mt | (qt ? 8 : 0), vt = qD($r, hi, Ht, t2, false), ht = t2.get(vt);
                  if (ht !== void 0 && !(Ri && ht & 2 && !(ht & 4))) {
                    if (hr) {
                      var ma = ht & 24;
                      ma & 8 && un($r, Gp(Vt)), ma & 16 && un($r, Gp(Fa));
                    }
                    return ht & 1 ? -1 : 0;
                  }
                  if (!Me)
                    Me = [], $e = [], tr = [];
                  else {
                    for (var Ca = vt.startsWith("*") ? qD($r, hi, Ht, t2, true) : void 0, An = 0; An < dr; An++)
                      if (vt === Me[An] || Ca && Ca === Me[An])
                        return 3;
                    if (Dr === 100 || Qr === 100)
                      return Ti = true, 0;
                  }
                  var gn = dr;
                  Me[dr] = vt, dr++;
                  var Vn = li;
                  ft & 1 && ($e[Dr] = $r, Dr++, !(li & 1) && Rh($r, $e, Dr) && (li |= 1)), ft & 2 && (tr[Qr] = hi, Qr++, !(li & 2) && Rh(hi, tr, Qr) && (li |= 2));
                  var zo, us = 0;
                  hr && (zo = hr, hr = function(Io) {
                    return us |= Io ? 16 : 8, zo(Io);
                  });
                  var Bo;
                  if (li === 3 ? (e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("checkTypes", "recursiveTypeRelatedTo_DepthLimit", { sourceId: $r.id, sourceIdStack: $e.map(function(Io) {
                    return Io.id;
                  }), targetId: hi.id, targetIdStack: tr.map(function(Io) {
                    return Io.id;
                  }), depth: Dr, targetDepth: Qr }), Bo = 3) : (e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("checkTypes", "structuredTypeRelatedTo", { sourceId: $r.id, targetId: hi.id }), Bo = gt($r, hi, Ri, mt), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop()), hr && (hr = zo), ft & 1 && Dr--, ft & 2 && Qr--, li = Vn, Bo) {
                    if (Bo === -1 || Dr === 0 && Qr === 0) {
                      if (Bo === -1 || Bo === 3)
                        for (var An = gn; An < dr; An++)
                          t2.set(Me[An], 1 | us);
                      dr = gn;
                    }
                  } else
                    t2.set(vt, (Ri ? 4 : 0) | 2 | us), dr = gn;
                  return Bo;
                }
                function gt($r, hi, Ri, mt) {
                  if (mt & 4)
                    return Uo($r, hi, Ri, void 0, 0);
                  var ft, Ht, vt = false, ht = Eo(), ma = $r.flags, Ca = hi.flags;
                  if (t2 === wa) {
                    if (ma & 3145728) {
                      var An = ea($r, hi);
                      return An && (An &= ea(hi, $r)), An;
                    }
                    if (ma & 4194304)
                      return oa($r.type, hi.type, 3, false);
                    if (ma & 8388608 && (ft = oa($r.objectType, hi.objectType, 3, false)) && (ft &= oa($r.indexType, hi.indexType, 3, false)) || ma & 16777216 && $r.root.isDistributive === hi.root.isDistributive && (ft = oa($r.checkType, hi.checkType, 3, false)) && (ft &= oa($r.extendsType, hi.extendsType, 3, false)) && (ft &= oa(ip($r), ip(hi), 3, false)) && (ft &= oa(tp($r), tp(hi), 3, false)))
                      return ft;
                    if (ma & 33554432)
                      return oa($r.substitute, hi.substitute, 3, false);
                    if (!(ma & 524288))
                      return 0;
                  } else if (ma & 3145728 || Ca & 3145728) {
                    if (ft = Lt($r, hi, Ri, mt))
                      return ft;
                    if ($r.flags & 2097152 || $r.flags & 262144 && hi.flags & 1048576) {
                      var gn = G1($r.flags & 2097152 ? $r.types : [$r], !!(hi.flags & 1048576));
                      if (gn && gf(gn, function(Pv) {
                        return Pv !== $r;
                      }) && (ft = oa(gn, hi, 1, false, void 0, mt)))
                        return Tn(ht), ft;
                    }
                    if (!(ma & 465829888 || ma & 524288 && Ca & 1048576 || ma & 2097152 && Ca & 467402752))
                      return 0;
                  }
                  if (ma & 17301504 && $r.aliasSymbol && $r.aliasTypeArguments && $r.aliasSymbol === hi.aliasSymbol && !(Fh($r) || Fh(hi))) {
                    var Vn = TE($r.aliasSymbol);
                    if (Vn === e2.emptyArray)
                      return 1;
                    var zo = xA($r.aliasTypeArguments, hi.aliasTypeArguments, Vn, mt);
                    if (zo !== void 0)
                      return zo;
                  }
                  if (IE($r) && !$r.target.readonly && (ft = oa(xo($r)[0], hi, 1)) || IE(hi) && (hi.target.readonly || Bh(uc($r) || $r)) && (ft = oa($r, xo(hi)[0], 2)))
                    return ft;
                  if (Ca & 262144) {
                    if (e2.getObjectFlags($r) & 32 && !$r.declaration.nameType && oa(ql(hi), Mu($r), 3) && !(Lu($r) & 4)) {
                      var us = vl($r), Bo = Jc(hi, Du($r));
                      if (ft = oa(us, Bo, 3, Ri))
                        return ft;
                    }
                  } else if (Ca & 4194304) {
                    var Io = hi.type;
                    if (ma & 4194304 && (ft = oa(Io, $r.type, 3, false)))
                      return ft;
                    if (Yn(Io)) {
                      if (ft = oa($r, Mx(Io), 2, Ri))
                        return ft;
                    } else {
                      var gn = Vv(Io);
                      if (gn) {
                        if (oa($r, ql(gn, hi.stringsOnly), 2, Ri) === -1)
                          return -1;
                      } else if (Bc(Io)) {
                        var Qo = Jl(Io), ls = Mu(Io), gi = void 0;
                        if (Qo && mg(Io)) {
                          var zt = $s(Ed(Io)), La = [];
                          Um(zt, 8576, false, function(Cm) {
                            return void La.push(un(Qo, tv(Io.mapper, Du(Io), Cm)));
                          }), gi = Pa(Ve(Ve([], La, true), [Qo], false));
                        } else
                          gi = Qo || ls;
                        if (oa($r, gi, 2, Ri) === -1)
                          return -1;
                      }
                    }
                  } else if (Ca & 8388608) {
                    if (ma & 8388608) {
                      if ((ft = oa($r.objectType, hi.objectType, 3, Ri)) && (ft &= oa($r.indexType, hi.indexType, 3, Ri)), ft)
                        return Tn(ht), ft;
                      Ri && (Ht = z);
                    }
                    if (t2 === dt || t2 === la) {
                      var fa = hi.objectType, ya = hi.indexType, Nn = uc(fa) || fa, fn = uc(ya) || ya;
                      if (!Ad(Nn) && !qp(fn)) {
                        var hn = 4 | (Nn !== fa ? 2 : 0), gn = ep(Nn, fn, hn);
                        if (gn) {
                          if (Ri && Ht && Tn(ht), ft = oa($r, gn, 2, Ri))
                            return ft;
                          Ri && Ht && z && (z = GS([Ht]) <= GS([z]) ? Ht : z);
                        }
                      }
                    }
                    Ri && (Ht = void 0);
                  } else if (Bc(hi) && t2 !== wa) {
                    var sn = !!hi.declaration.nameType, us = vl(hi), ln = Lu(hi);
                    if (!(ln & 8)) {
                      if (!sn && us.flags & 8388608 && us.objectType === $r && us.indexType === Du(hi))
                        return -1;
                      if (!Bc($r)) {
                        var gi = sn ? Jl(hi) : Mu(hi), lo = ql($r, void 0, true), _o = ln & 4, _s = _o ? Zg(gi, lo) : void 0;
                        if (_o ? !(_s.flags & 131072) : oa(gi, lo, 3)) {
                          var Vo = vl(hi), Yo = Du(hi), Cs = Ng(Vo, -98305);
                          if (!sn && Cs.flags & 8388608 && Cs.indexType === Yo) {
                            if (ft = oa($r, Cs.objectType, 2, Ri))
                              return ft;
                          } else {
                            var ic = sn ? _s || gi : _s ? Do([_s, Yo]) : Yo, Bo = Jc($r, ic);
                            if (ft = oa(Bo, Vo, 3, Ri))
                              return ft;
                          }
                        }
                        Ht = z, Tn(ht);
                      }
                    }
                  } else if (Ca & 16777216) {
                    if (Rh(hi, tr, Qr, 10))
                      return Tn(ht), 3;
                    var _c = hi;
                    if (!_c.root.inferTypeParameters && !xI(_c.root)) {
                      var il = !ao(wh(_c.checkType), wh(_c.extendsType)), n_ = !il && ao(Nd(_c.checkType), Nd(_c.extendsType));
                      if ((ft = il ? -1 : oa($r, ip(_c), 2, false)) && (ft &= n_ ? -1 : oa($r, tp(_c), 2, false), ft))
                        return Tn(ht), ft;
                    }
                  } else if (Ca & 134217728) {
                    if (ma & 134217728) {
                      if (t2 === la)
                        return Gw($r, hi) ? 0 : -1;
                      un($r, Gp(Fa));
                    }
                    if (VE($r, hi))
                      return -1;
                  }
                  if (ma & 8650752) {
                    if (!(ma & 8388608 && Ca & 8388608)) {
                      var gn = Q_($r);
                      if (!gn || ma & 262144 && gn.flags & 1) {
                        if (ft = oa(Ba, Ng(hi, -67108865), 3))
                          return Tn(ht), ft;
                      } else {
                        if (ft = oa(gn, hi, 1, false, void 0, mt))
                          return Tn(ht), ft;
                        if (ft = oa(Rc(gn, $r), hi, 1, Ri && !(Ca & ma & 262144), void 0, mt))
                          return Tn(ht), ft;
                      }
                      if (Qv($r)) {
                        var o_ = Q_($r.indexType);
                        if (o_ && (ft = oa(Jc($r.objectType, o_), hi, 1, Ri)))
                          return Tn(ht), ft;
                      }
                    }
                  } else if (ma & 4194304) {
                    if (ft = oa(at, hi, 1, Ri))
                      return Tn(ht), ft;
                  } else if (ma & 134217728 && !(Ca & 524288)) {
                    if (!(Ca & 134217728)) {
                      var gn = uc($r);
                      if (gn && gn !== $r && (ft = oa(gn, hi, 1, Ri)))
                        return Tn(ht), ft;
                    }
                  } else if (ma & 268435456)
                    if (Ca & 268435456 && $r.symbol === hi.symbol) {
                      if (ft = oa($r.type, hi.type, 3, Ri))
                        return Tn(ht), ft;
                    } else {
                      var gn = uc($r);
                      if (gn && (ft = oa(gn, hi, 1, Ri)))
                        return Tn(ht), ft;
                    }
                  else if (ma & 16777216) {
                    if (Rh($r, $e, Dr, 10))
                      return Tn(ht), 3;
                    if (Ca & 16777216) {
                      var og = $r.root.inferTypeParameters, _p = $r.extendsType, td = void 0;
                      if (og) {
                        var s_ = uv(og, void 0, 0, Un);
                        df(s_.inferences, hi.extendsType, _p, 1536), _p = un(_p, s_.mapper), td = s_.mapper;
                      }
                      if (wf(_p, hi.extendsType) && (oa($r.checkType, hi.checkType, 3) || oa(hi.checkType, $r.checkType, 3)) && ((ft = oa(un(ip($r), td), ip(hi), 3, Ri)) && (ft &= oa(tp($r), tp(hi), 3, Ri)), ft))
                        return Tn(ht), ft;
                    } else {
                      var sg = Wm($r) ? Kv($r) : void 0;
                      if (sg && (ft = oa(sg, hi, 1, Ri)))
                        return Tn(ht), ft;
                    }
                    var Nc = zm($r);
                    if (Nc && (ft = oa(Nc, hi, 1, Ri)))
                      return Tn(ht), ft;
                  } else {
                    if (t2 !== Or && t2 !== ki && j1(hi) && Of($r))
                      return -1;
                    if (Bc(hi))
                      return Bc($r) && (ft = on($r, hi, Ri)) ? (Tn(ht), ft) : 0;
                    var pp = !!(ma & 131068);
                    if (t2 !== wa)
                      $r = $s($r), ma = $r.flags;
                    else if (Bc($r))
                      return 0;
                    if (e2.getObjectFlags($r) & 4 && e2.getObjectFlags(hi) & 4 && $r.target === hi.target && !Yn($r) && !(Fh($r) || Fh(hi))) {
                      if (Jh($r))
                        return -1;
                      var Vn = zD($r.target);
                      if (Vn === e2.emptyArray)
                        return 1;
                      var zo = xA(xo($r), xo(hi), Vn, mt);
                      if (zo !== void 0)
                        return zo;
                    } else {
                      if (um(hi) ? Pd($r) : Tu(hi) && Yn($r) && !$r.target.readonly)
                        return t2 !== wa ? oa(cs($r, nt) || Oe, cs(hi, nt) || Oe, 3, Ri) : 0;
                      if ((t2 === Or || t2 === ki) && Of(hi) && e2.getObjectFlags(hi) & 8192 && !Of($r))
                        return 0;
                    }
                    if (ma & 2621440 && Ca & 524288) {
                      var Y0 = Ri && z === ht.errorInfo && !pp;
                      if (ft = Uo($r, hi, Y0, void 0, mt), ft && (ft &= Fs($r, hi, 0, Y0), ft && (ft &= Fs($r, hi, 1, Y0), ft && (ft &= fp($r, hi, pp, Y0, mt)))), vt && ft)
                        z = Ht || z || ht.errorInfo;
                      else if (ft)
                        return ft;
                    }
                    if (ma & 2621440 && Ca & 1048576) {
                      var SA = Ng(hi, 36175872);
                      if (SA.flags & 1048576) {
                        var TA = zn($r, SA);
                        if (TA)
                          return TA;
                      }
                    }
                  }
                  return 0;
                  function GS(Pv) {
                    return Pv ? e2.reduceLeft(Pv, function(Cm, km) {
                      return Cm + 1 + GS(km.next);
                    }, 0) : 0;
                  }
                  function xA(Pv, Cm, km, wL) {
                    if (ft = Hi(Pv, Cm, km, Ri, wL))
                      return ft;
                    if (e2.some(km, function(HS) {
                      return !!(HS & 24);
                    })) {
                      Ht = void 0, Tn(ht);
                      return;
                    }
                    var EA = Cm && _w(Cm, km);
                    if (vt = !EA, km !== e2.emptyArray && !EA) {
                      if (vt && !(Ri && e2.some(km, function(HS) {
                        return (HS & 7) === 0;
                      })))
                        return 0;
                      Ht = z, Tn(ht);
                    }
                  }
                }
                function Vt($r) {
                  return hr && ($r === Rn || $r === Da || $r === bo) && hr(false), $r;
                }
                function Fa($r) {
                  return hr && ($r === Rn || $r === Da || $r === bo) && hr(true), $r;
                }
                function on($r, hi, Ri) {
                  var mt = t2 === la || (t2 === wa ? Lu($r) === Lu(hi) : qv($r) <= qv(hi));
                  if (mt) {
                    var ft, Ht = Mu(hi), vt = un(Mu($r), Gp(qv($r) < 0 ? Vt : Fa));
                    if (ft = oa(Ht, vt, 3, Ri)) {
                      var ht = Uc([Du($r)], [Du(hi)]);
                      if (un(Jl($r), ht) === un(Jl(hi), ht))
                        return ft & oa(un(vl($r), ht), vl(hi), 3, Ri);
                    }
                  }
                  return 0;
                }
                function zn($r, hi) {
                  var Ri = uo($r), mt = YE(Ri, hi);
                  if (!mt)
                    return 0;
                  for (var ft = 1, Ht = 0, vt = mt; Ht < vt.length; Ht++) {
                    var ht = vt[Ht];
                    if (ft *= D8(ml(ht)), ft > 25)
                      return e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("checkTypes", "typeRelatedToDiscriminatedType_DepthLimit", { sourceId: $r.id, targetId: hi.id, numCombinations: ft }), 0;
                  }
                  for (var ma = new Array(mt.length), Ca = new e2.Set(), An = 0; An < mt.length; An++) {
                    var ht = mt[An], gn = ml(ht);
                    ma[An] = gn.flags & 1048576 ? gn.types : [gn], Ca.add(ht.escapedName);
                  }
                  for (var Vn = e2.cartesianProduct(ma), zo = [], us = function(ya) {
                    var Nn = false;
                    e:
                      for (var fn = 0, hn = hi.types; fn < hn.length; fn++) {
                        for (var sn = hn[fn], ln = function(_s) {
                          var Vo = mt[_s], Yo = bi(sn, Vo.escapedName);
                          if (!Yo)
                            return "continue-outer";
                          if (Vo === Yo)
                            return "continue";
                          var Cs = wo($r, hi, Vo, Yo, function(ic) {
                            return ya[_s];
                          }, false, 0, Ye || t2 === la);
                          if (!Cs)
                            return "continue-outer";
                        }, lo = 0; lo < mt.length; lo++) {
                          var _o = ln(lo);
                          switch (_o) {
                            case "continue-outer":
                              continue e;
                          }
                        }
                        e2.pushIfUnique(zo, sn, e2.equateValues), Nn = true;
                      }
                    if (!Nn)
                      return { value: 0 };
                  }, Bo = 0, Io = Vn; Bo < Io.length; Bo++) {
                    var Qo = Io[Bo], ls = us(Qo);
                    if (typeof ls == "object")
                      return ls.value;
                  }
                  for (var gi = -1, zt = 0, La = zo; zt < La.length; zt++) {
                    var fa = La[zt];
                    if (gi &= Uo($r, fa, false, Ca, 0), gi && (gi &= Fs($r, fa, 0, false), gi && (gi &= Fs($r, fa, 1, false), gi && !(Yn($r) && Yn(fa)) && (gi &= fp($r, fa, false, false, 0)))), !gi)
                      return gi;
                  }
                  return gi;
                }
                function Ga($r, hi) {
                  if (!hi || $r.length === 0)
                    return $r;
                  for (var Ri, mt = 0; mt < $r.length; mt++)
                    hi.has($r[mt].escapedName) ? Ri || (Ri = $r.slice(0, mt)) : Ri && Ri.push($r[mt]);
                  return Ri || $r;
                }
                function Qn($r, hi, Ri, mt, ft) {
                  var Ht = Ye && !!(e2.getCheckFlags(hi) & 48), vt = kc(ml(hi), false, Ht), ht = Ri($r);
                  return oa(ht, vt, 3, mt, void 0, ft);
                }
                function wo($r, hi, Ri, mt, ft, Ht, vt, ht) {
                  var ma = e2.getDeclarationModifierFlagsFromSymbol(Ri), Ca = e2.getDeclarationModifierFlagsFromSymbol(mt);
                  if (ma & 8 || Ca & 8) {
                    if (Ri.valueDeclaration !== mt.valueDeclaration)
                      return Ht && (ma & 8 && Ca & 8 ? Yt(e2.Diagnostics.Types_have_separate_declarations_of_a_private_property_0, tn(mt)) : Yt(e2.Diagnostics.Property_0_is_private_in_type_1_but_not_in_type_2, tn(mt), Ot(ma & 8 ? $r : hi), Ot(ma & 8 ? hi : $r))), 0;
                  } else if (Ca & 16) {
                    if (!vw(Ri, mt))
                      return Ht && Yt(e2.Diagnostics.Property_0_is_protected_but_type_1_is_not_a_class_derived_from_2, tn(mt), Ot(Zd(Ri) || $r), Ot(Zd(mt) || hi)), 0;
                  } else if (ma & 16)
                    return Ht && Yt(e2.Diagnostics.Property_0_is_protected_in_type_1_but_public_in_type_2, tn(mt), Ot($r), Ot(hi)), 0;
                  if (t2 === ki && Zu(Ri) && !Zu(mt))
                    return 0;
                  var An = Qn(Ri, mt, ft, Ht, vt);
                  return An ? !ht && Ri.flags & 16777216 && !(mt.flags & 16777216) ? (Ht && Yt(e2.Diagnostics.Property_0_is_optional_in_type_1_but_required_in_type_2, tn(mt), Ot($r), Ot(hi)), 0) : An : (Ht && lt(e2.Diagnostics.Types_of_property_0_are_incompatible, tn(mt)), 0);
                }
                function Po($r, hi, Ri, mt) {
                  var ft = false;
                  if (Ri.valueDeclaration && e2.isNamedDeclaration(Ri.valueDeclaration) && e2.isPrivateIdentifier(Ri.valueDeclaration.name) && $r.symbol && $r.symbol.flags & 32) {
                    var Ht = Ri.valueDeclaration.name.escapedText, vt = e2.getSymbolNameForPrivateIdentifier($r.symbol, Ht);
                    if (vt && bi($r, vt)) {
                      var ht = e2.factory.getDeclarationName($r.symbol.valueDeclaration), ma = e2.factory.getDeclarationName(hi.symbol.valueDeclaration);
                      Yt(e2.Diagnostics.Property_0_in_type_1_refers_to_a_different_member_that_cannot_be_accessed_from_within_type_2, ku(Ht), ku(ht.escapedText === "" ? C : ht), ku(ma.escapedText === "" ? C : ma));
                      return;
                    }
                  }
                  var Ca = e2.arrayFrom(sb($r, hi, mt, false));
                  if ((!s2 || s2.code !== e2.Diagnostics.Class_0_incorrectly_implements_interface_1.code && s2.code !== e2.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code) && (ft = true), Ca.length === 1) {
                    var An = tn(Ri);
                    Yt.apply(void 0, Ve([e2.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2, An], nf($r, hi), false)), e2.length(Ri.declarations) && Ia(e2.createDiagnosticForNode(Ri.declarations[0], e2.Diagnostics._0_is_declared_here, An)), ft && z && Ci++;
                  } else
                    cn($r, hi, false) && (Ca.length > 5 ? Yt(e2.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more, Ot($r), Ot(hi), e2.map(Ca.slice(0, 4), function(gn) {
                      return tn(gn);
                    }).join(", "), Ca.length - 4) : Yt(e2.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2, Ot($r), Ot(hi), e2.map(Ca, function(gn) {
                      return tn(gn);
                    }).join(", ")), ft && z && Ci++);
                }
                function Uo($r, hi, Ri, mt, ft) {
                  if (t2 === wa)
                    return Rs($r, hi, mt);
                  var Ht = -1;
                  if (Yn(hi)) {
                    if (Pd($r)) {
                      if (!hi.target.readonly && (um($r) || Yn($r) && $r.target.readonly))
                        return 0;
                      var vt = $_($r), ht = $_(hi), ma = Yn($r) ? $r.target.combinedFlags & 4 : 4, Ca = hi.target.combinedFlags & 4, An = Yn($r) ? $r.target.minLength : 0, gn = hi.target.minLength;
                      if (!ma && vt < gn)
                        return Ri && Yt(e2.Diagnostics.Source_has_0_element_s_but_target_requires_1, vt, gn), 0;
                      if (!Ca && ht < An)
                        return Ri && Yt(e2.Diagnostics.Source_has_0_element_s_but_target_allows_only_1, An, ht), 0;
                      if (!Ca && (ma || ht < vt))
                        return Ri && (An < gn ? Yt(e2.Diagnostics.Target_requires_0_element_s_but_source_may_have_fewer, gn) : Yt(e2.Diagnostics.Target_allows_only_0_element_s_but_source_may_have_more, ht)), 0;
                      for (var Vn = xo($r), zo = xo(hi), us = Math.min(Yn($r) ? Lx($r.target, 11) : 0, Lx(hi.target, 11)), Bo = Math.min(Yn($r) ? Sh($r.target, 11) : 0, Ca ? Sh(hi.target, 11) : 0), Io = !!mt, Qo = 0; Qo < ht; Qo++) {
                        var ls = Qo < ht - Bo ? Qo : Qo + vt - ht, gi = Yn($r) && (Qo < us || Qo >= ht - Bo) ? $r.target.elementFlags[ls] : 4, zt = hi.target.elementFlags[Qo];
                        if (zt & 8 && !(gi & 8))
                          return Ri && Yt(e2.Diagnostics.Source_provides_no_match_for_variadic_element_at_position_0_in_target, Qo), 0;
                        if (gi & 8 && !(zt & 12))
                          return Ri && Yt(e2.Diagnostics.Variadic_element_at_position_0_in_source_does_not_match_element_at_position_1_in_target, ls, Qo), 0;
                        if (zt & 1 && !(gi & 1))
                          return Ri && Yt(e2.Diagnostics.Source_provides_no_match_for_required_element_at_position_0_in_target, Qo), 0;
                        if (!(Io && ((gi & 12 || zt & 12) && (Io = false), Io && (mt == null ? void 0 : mt.has("" + Qo))))) {
                          var La = Yn($r) ? Qo < us || Qo >= ht - Bo ? kg(Vn[ls], !!(gi & zt & 2)) : jh($r, us, Bo) || ui : Vn[0], fa = zo[Qo], ya = gi & 8 && zt & 4 ? Zs(fa) : kg(fa, !!(zt & 2)), Nn = oa(La, ya, 3, Ri, void 0, ft);
                          if (!Nn)
                            return Ri && (ht > 1 || vt > 1) && (Qo < us || Qo >= ht - Bo || vt - us - Bo === 1 ? lt(e2.Diagnostics.Type_at_position_0_in_source_is_not_compatible_with_type_at_position_1_in_target, ls, Qo) : lt(e2.Diagnostics.Type_at_positions_0_through_1_in_source_is_not_compatible_with_type_at_position_2_in_target, us, vt - Bo - 1, Qo)), 0;
                          Ht &= Nn;
                        }
                      }
                      return Ht;
                    }
                    if (hi.target.combinedFlags & 12)
                      return 0;
                  }
                  var fn = (t2 === Or || t2 === ki) && !Qp($r) && !Jh($r) && !Yn($r), hn = cb($r, hi, fn, false);
                  if (hn)
                    return Ri && rc($r, hi) && Po($r, hi, hn, fn), 0;
                  if (Qp(hi))
                    for (var sn = 0, ln = Ga(uo($r), mt); sn < ln.length; sn++) {
                      var lo = ln[sn];
                      if (!h_(hi, lo.escapedName)) {
                        var La = Jt(lo);
                        if (!(La.flags & 32768))
                          return Ri && Yt(e2.Diagnostics.Property_0_does_not_exist_on_type_1, tn(lo), Ot(hi)), 0;
                      }
                    }
                  for (var _o = uo(hi), _s = Yn($r) && Yn(hi), Vo = 0, Yo = Ga(_o, mt); Vo < Yo.length; Vo++) {
                    var Cs = Yo[Vo], ic = Cs.escapedName;
                    if (!(Cs.flags & 4194304) && (!_s || e2.isNumericLiteralName(ic) || ic === "length")) {
                      var lo = bi($r, ic);
                      if (lo && lo !== Cs) {
                        var Nn = wo($r, hi, lo, Cs, ml, Ri, ft, t2 === la);
                        if (!Nn)
                          return 0;
                        Ht &= Nn;
                      }
                    }
                  }
                  return Ht;
                }
                function Rs($r, hi, Ri) {
                  if (!($r.flags & 524288 && hi.flags & 524288))
                    return 0;
                  var mt = Ga(Pf($r), Ri), ft = Ga(Pf(hi), Ri);
                  if (mt.length !== ft.length)
                    return 0;
                  for (var Ht = -1, vt = 0, ht = mt; vt < ht.length; vt++) {
                    var ma = ht[vt], Ca = h_(hi, ma.escapedName);
                    if (!Ca)
                      return 0;
                    var An = VD(ma, Ca, oa);
                    if (!An)
                      return 0;
                    Ht &= An;
                  }
                  return Ht;
                }
                function Fs($r, hi, Ri, mt) {
                  var ft, Ht;
                  if (t2 === wa)
                    return jd($r, hi, Ri);
                  if (hi === xn || $r === xn)
                    return -1;
                  var vt = $r.symbol && Sl($r.symbol.valueDeclaration), ht = hi.symbol && Sl(hi.symbol.valueDeclaration), ma = ot($r, vt && Ri === 1 ? 0 : Ri), Ca = ot(hi, ht && Ri === 1 ? 0 : Ri);
                  if (Ri === 1 && ma.length && Ca.length) {
                    var An = !!(ma[0].flags & 4), gn = !!(Ca[0].flags & 4);
                    if (An && !gn)
                      return mt && Yt(e2.Diagnostics.Cannot_assign_an_abstract_constructor_type_to_a_non_abstract_constructor_type), 0;
                    if (!za(ma[0], Ca[0], mt))
                      return 0;
                  }
                  var Vn = -1, zo = Ri === 1 ? Ts : xu, us = e2.getObjectFlags($r), Bo = e2.getObjectFlags(hi);
                  if (us & 64 && Bo & 64 && $r.symbol === hi.symbol || us & 4 && Bo & 4 && $r.target === hi.target)
                    for (var Io = 0; Io < Ca.length; Io++) {
                      var Qo = rl(ma[Io], Ca[Io], true, mt, zo(ma[Io], Ca[Io]));
                      if (!Qo)
                        return 0;
                      Vn &= Qo;
                    }
                  else if (ma.length === 1 && Ca.length === 1) {
                    var ls = t2 === la || !!ye.noStrictGenericChecks, gi = e2.first(ma), zt = e2.first(Ca);
                    if (Vn = rl(gi, zt, ls, mt, zo(gi, zt)), !Vn && mt && Ri === 1 && us & Bo && (((ft = zt.declaration) === null || ft === void 0 ? void 0 : ft.kind) === 171 || ((Ht = gi.declaration) === null || Ht === void 0 ? void 0 : Ht.kind) === 171)) {
                      var La = function(_o) {
                        return Ml(_o, void 0, 262144, Ri);
                      };
                      return Yt(e2.Diagnostics.Type_0_is_not_assignable_to_type_1, La(gi), La(zt)), Yt(e2.Diagnostics.Types_of_construct_signatures_are_incompatible), Vn;
                    }
                  } else {
                    e:
                      for (var fa = 0, ya = Ca; fa < ya.length; fa++) {
                        for (var Nn = ya[fa], fn = Eo(), hn = mt, sn = 0, ln = ma; sn < ln.length; sn++) {
                          var lo = ln[sn], Qo = rl(lo, Nn, true, hn, zo(lo, Nn));
                          if (Qo) {
                            Vn &= Qo, Tn(fn);
                            continue e;
                          }
                          hn = false;
                        }
                        return hn && Yt(e2.Diagnostics.Type_0_provides_no_match_for_the_signature_1, Ot($r), Ml(Nn, void 0, void 0, Ri)), 0;
                      }
                  }
                  return Vn;
                }
                function rc($r, hi) {
                  var Ri = Ft($r, 0), mt = Ft($r, 1), ft = Pf($r);
                  return (Ri.length || mt.length) && !ft.length ? !!(ot(hi, 0).length && Ri.length || ot(hi, 1).length && mt.length) : true;
                }
                function xu($r, hi) {
                  return $r.parameters.length === 0 && hi.parameters.length === 0 ? function(Ri, mt) {
                    return lt(e2.Diagnostics.Call_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, Ot(Ri), Ot(mt));
                  } : function(Ri, mt) {
                    return lt(e2.Diagnostics.Call_signature_return_types_0_and_1_are_incompatible, Ot(Ri), Ot(mt));
                  };
                }
                function Ts($r, hi) {
                  return $r.parameters.length === 0 && hi.parameters.length === 0 ? function(Ri, mt) {
                    return lt(e2.Diagnostics.Construct_signatures_with_no_arguments_have_incompatible_return_types_0_and_1, Ot(Ri), Ot(mt));
                  } : function(Ri, mt) {
                    return lt(e2.Diagnostics.Construct_signature_return_types_0_and_1_are_incompatible, Ot(Ri), Ot(mt));
                  };
                }
                function rl($r, hi, Ri, mt, ft) {
                  return MD(Ri ? Qm($r) : $r, Ri ? Qm(hi) : hi, t2 === ki ? 8 : 0, mt, Yt, ft, Un, Gp(Fa));
                }
                function jd($r, hi, Ri) {
                  var mt = ot($r, Ri), ft = ot(hi, Ri);
                  if (mt.length !== ft.length)
                    return 0;
                  for (var Ht = -1, vt = 0; vt < mt.length; vt++) {
                    var ht = _y(mt[vt], ft[vt], false, false, false, oa);
                    if (!ht)
                      return 0;
                    Ht &= ht;
                  }
                  return Ht;
                }
                function lp($r, hi, Ri) {
                  for (var mt = -1, ft = hi.keyType, Ht = $r.flags & 2097152 ? em($r) : Pf($r), vt = 0, ht = Ht; vt < ht.length; vt++) {
                    var ma = ht[vt];
                    if (!hE($r, ma) && an(om(ma, 8576), ft)) {
                      var Ca = ml(ma), An = yr || Ca.flags & 32768 || ft === nt || !(ma.flags & 16777216) ? Ca : Ks(Ca, 524288), gn = oa(An, hi.type, 3, Ri);
                      if (!gn)
                        return Ri && Yt(e2.Diagnostics.Property_0_is_incompatible_with_index_signature, tn(ma)), 0;
                      mt &= gn;
                    }
                  }
                  for (var Vn = 0, zo = Hn($r); Vn < zo.length; Vn++) {
                    var us = zo[Vn];
                    if (an(us.keyType, ft)) {
                      var gn = Tl(us, hi, Ri);
                      if (!gn)
                        return 0;
                      mt &= gn;
                    }
                  }
                  return mt;
                }
                function Tl($r, hi, Ri) {
                  var mt = oa($r.type, hi.type, 3, Ri);
                  return !mt && Ri && ($r.keyType === hi.keyType ? Yt(e2.Diagnostics._0_index_signatures_are_incompatible, Ot($r.keyType)) : Yt(e2.Diagnostics._0_and_1_index_signatures_are_incompatible, Ot($r.keyType), Ot(hi.keyType))), mt;
                }
                function fp($r, hi, Ri, mt, ft) {
                  if (t2 === wa)
                    return id($r, hi);
                  for (var Ht = Hn(hi), vt = e2.some(Ht, function(Vn) {
                    return Vn.keyType === Li;
                  }), ht = -1, ma = 0, Ca = Ht; ma < Ca.length; ma++) {
                    var An = Ca[ma], gn = !Ri && vt && An.type.flags & 1 ? -1 : Bc($r) && vt ? oa(vl($r), An.type, 3, mt) : zg($r, An, mt, ft);
                    if (!gn)
                      return 0;
                    ht &= gn;
                  }
                  return ht;
                }
                function zg($r, hi, Ri, mt) {
                  var ft = nu($r, hi.keyType);
                  return ft ? Tl(ft, hi, Ri) : !(mt & 1) && qh($r) ? lp($r, hi, Ri) : (Ri && Yt(e2.Diagnostics.Index_signature_for_type_0_is_missing_in_type_1, Ot(hi.keyType), Ot($r)), 0);
                }
                function id($r, hi) {
                  var Ri = Hn($r), mt = Hn(hi);
                  if (Ri.length !== mt.length)
                    return 0;
                  for (var ft = 0, Ht = mt; ft < Ht.length; ft++) {
                    var vt = Ht[ft], ht = ss($r, vt.keyType);
                    if (!(ht && oa(ht.type, vt.type, 3) && ht.isReadonly === vt.isReadonly))
                      return 0;
                  }
                  return -1;
                }
                function za($r, hi, Ri) {
                  if (!$r.declaration || !hi.declaration)
                    return true;
                  var mt = e2.getSelectedEffectiveModifierFlags($r.declaration, 24), ft = e2.getSelectedEffectiveModifierFlags(hi.declaration, 24);
                  return ft === 8 || ft === 16 && mt !== 8 || ft !== 16 && !mt ? true : (Ri && Yt(e2.Diagnostics.Cannot_assign_a_0_constructor_type_to_a_1_constructor_type, v_(mt), v_(ft)), false);
                }
              }
              function JD(r2) {
                if (r2.flags & 16)
                  return false;
                if (r2.flags & 3145728)
                  return !!e2.forEach(r2.types, JD);
                if (r2.flags & 465829888) {
                  var i2 = Q_(r2);
                  if (i2 && i2 !== r2)
                    return JD(i2);
                }
                return Vl(r2) || !!(r2.flags & 134217728);
              }
              function DE(r2, i2) {
                return Yn(r2) && Yn(i2) ? e2.emptyArray : uo(i2).filter(function(t2) {
                  return jD(da(r2, t2.escapedName), Jt(t2));
                });
              }
              function jD(r2, i2) {
                return !!r2 && !!i2 && fs4(r2, 32768) && !!Wh(i2);
              }
              function lw(r2) {
                return uo(r2).filter(function(i2) {
                  return Wh(Jt(i2));
                });
              }
              function bE(r2, i2, t2) {
                return t2 === void 0 && (t2 = OD), bA(r2, i2, t2, true) || kL(r2, i2) || AL(r2, i2) || NL(r2, i2) || PL(r2, i2);
              }
              function UD(r2, i2, t2, o, s2) {
                for (var u = r2.types.map(function(Zi) {
                }), h2 = 0, z = i2; h2 < z.length; h2++) {
                  var me = z[h2], Me = me[0], $e = me[1], tr = $v(r2, $e);
                  if (!(s2 && tr && e2.getCheckFlags(tr) & 16))
                    for (var dr = 0, Dr = 0, Qr = r2.types; Dr < Qr.length; Dr++) {
                      var li = Qr[Dr], Ti = da(li, $e);
                      Ti && t2(Me(), Ti) ? u[dr] = u[dr] === void 0 ? true : u[dr] : u[dr] = false, dr++;
                    }
                }
                var Ci = u.indexOf(true);
                if (Ci === -1)
                  return o;
                for (var $i = u.indexOf(true, Ci + 1); $i !== -1; ) {
                  if (!wf(r2.types[Ci], r2.types[$i]))
                    return o;
                  $i = u.indexOf(true, $i + 1);
                }
                return r2.types[Ci];
              }
              function SE(r2) {
                if (r2.flags & 524288) {
                  var i2 = Ru(r2);
                  return i2.callSignatures.length === 0 && i2.constructSignatures.length === 0 && i2.indexInfos.length === 0 && i2.properties.length > 0 && e2.every(i2.properties, function(t2) {
                    return !!(t2.flags & 16777216);
                  });
                }
                return r2.flags & 2097152 ? e2.every(r2.types, SE) : false;
              }
              function fw(r2, i2, t2) {
                for (var o = 0, s2 = uo(r2); o < s2.length; o++) {
                  var u = s2[o];
                  if (Rb(i2, u.escapedName, t2))
                    return true;
                }
                return false;
              }
              function zD(r2) {
                return r2 === Pi || r2 === Qi || r2.objectFlags & 8 ? de : xE(r2.symbol, r2.typeParameters);
              }
              function TE(r2) {
                return xE(r2, Aa(r2).typeParameters);
              }
              function xE(r2, i2) {
                i2 === void 0 && (i2 = e2.emptyArray);
                var t2 = Aa(r2);
                if (!t2.variances) {
                  e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("checkTypes", "getVariancesWorker", { arity: i2.length, id: fu(go(r2)) }), t2.variances = e2.emptyArray;
                  for (var o = [], s2 = function(me) {
                    var Me = WD(me), $e = Me & 65536 ? Me & 32768 ? 0 : 1 : Me & 32768 ? 2 : void 0;
                    if ($e === void 0) {
                      var tr = false, dr = false, Dr = hr;
                      hr = function(Ti) {
                        return Ti ? dr = true : tr = true;
                      };
                      var Qr = ly(r2, me, Rn), li = ly(r2, me, Da);
                      $e = (ao(li, Qr) ? 1 : 0) | (ao(Qr, li) ? 2 : 0), $e === 3 && ao(ly(r2, me, bo), Qr) && ($e = 4), hr = Dr, (tr || dr) && (tr && ($e |= 8), dr && ($e |= 16));
                    }
                    o.push($e);
                  }, u = 0, h2 = i2; u < h2.length; u++) {
                    var z = h2[u];
                    s2(z);
                  }
                  t2.variances = o, e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
                }
                return t2.variances;
              }
              function ly(r2, i2, t2) {
                var o = Yd(i2, t2), s2 = go(r2);
                if (nn(s2))
                  return s2;
                var u = r2.flags & 524288 ? am(r2, e_(Aa(r2).typeParameters, o)) : Yf(s2, e_(s2.typeParameters, o));
                return Je.add(fu(u)), u;
              }
              function Fh(r2) {
                return Je.has(fu(r2));
              }
              function WD(r2) {
                var i2, t2;
                return (e2.some((i2 = r2.symbol) === null || i2 === void 0 ? void 0 : i2.declarations, function(o) {
                  return e2.hasSyntacticModifier(o, 32768);
                }) ? 32768 : 0) | (e2.some((t2 = r2.symbol) === null || t2 === void 0 ? void 0 : t2.declarations, function(o) {
                  return e2.hasSyntacticModifier(o, 65536);
                }) ? 65536 : 0);
              }
              function _w(r2, i2) {
                for (var t2 = 0; t2 < i2.length; t2++)
                  if ((i2[t2] & 7) === 1 && r2[t2].flags & 16384)
                    return true;
                return false;
              }
              function pw(r2) {
                return r2.flags & 262144 && !Tc(r2);
              }
              function dw(r2) {
                return !!(e2.getObjectFlags(r2) & 4) && !r2.node;
              }
              function Mh(r2) {
                return dw(r2) && e2.some(xo(r2), function(i2) {
                  return !!(i2.flags & 262144) || Mh(i2);
                });
              }
              function gw(r2, i2, t2, o) {
                var s2 = [], u = "", h2 = me(r2, 0), z = me(i2, 0);
                return "".concat(u).concat(h2, ",").concat(z).concat(t2);
                function me(Me, $e) {
                  $e === void 0 && ($e = 0);
                  for (var tr = "" + Me.target.id, dr = 0, Dr = xo(Me); dr < Dr.length; dr++) {
                    var Qr = Dr[dr];
                    if (Qr.flags & 262144) {
                      if (o || pw(Qr)) {
                        var li = s2.indexOf(Qr);
                        li < 0 && (li = s2.length, s2.push(Qr)), tr += "=" + li;
                        continue;
                      }
                      u = "*";
                    } else if ($e < 4 && Mh(Qr)) {
                      tr += "<" + me(Qr, $e + 1) + ">";
                      continue;
                    }
                    tr += "-" + Qr.id;
                  }
                  return tr;
                }
              }
              function qD(r2, i2, t2, o, s2) {
                if (o === wa && r2.id > i2.id) {
                  var u = r2;
                  r2 = i2, i2 = u;
                }
                var h2 = t2 ? ":" + t2 : "";
                return Mh(r2) && Mh(i2) ? gw(r2, i2, h2, s2) : "".concat(r2.id, ",").concat(i2.id).concat(h2);
              }
              function fy(r2, i2) {
                if (e2.getCheckFlags(r2) & 6) {
                  for (var t2 = 0, o = r2.containingType.types; t2 < o.length; t2++) {
                    var s2 = o[t2], u = bi(s2, r2.escapedName), h2 = u && fy(u, i2);
                    if (h2)
                      return h2;
                  }
                  return;
                }
                return i2(r2);
              }
              function Zd(r2) {
                return r2.parent && r2.parent.flags & 32 ? go(Ys(r2)) : void 0;
              }
              function Lh(r2) {
                var i2 = Zd(r2), t2 = i2 && Qc(i2)[0];
                return t2 && da(t2, r2.escapedName);
              }
              function mw(r2, i2) {
                return fy(r2, function(t2) {
                  var o = Zd(t2);
                  return o ? lf(o, i2) : false;
                });
              }
              function vw(r2, i2) {
                return !fy(i2, function(t2) {
                  return e2.getDeclarationModifierFlagsFromSymbol(t2) & 16 ? !mw(r2, Zd(t2)) : false;
                });
              }
              function EE(r2, i2, t2) {
                return fy(i2, function(o) {
                  return e2.getDeclarationModifierFlagsFromSymbol(o, t2) & 16 ? !lf(r2, Zd(o)) : false;
                }) ? void 0 : r2;
              }
              function Rh(r2, i2, t2, o) {
                if (o === void 0 && (o = 3), t2 >= o)
                  for (var s2 = ov(r2), u = 0, h2 = 0, z = 0; z < t2; z++) {
                    var me = i2[z];
                    if (ov(me) === s2) {
                      if (me.id >= h2 && (u++, u >= o))
                        return true;
                      h2 = me.id;
                    }
                  }
                return false;
              }
              function ov(r2) {
                if (r2.flags & 524288 && !lb(r2)) {
                  if (e2.getObjectFlags(r2) && 4 && r2.node)
                    return r2.node;
                  if (r2.symbol && !(e2.getObjectFlags(r2) & 16 && r2.symbol.flags & 32))
                    return r2.symbol;
                  if (Yn(r2))
                    return r2.target;
                }
                if (r2.flags & 262144)
                  return r2.symbol;
                if (r2.flags & 8388608) {
                  do
                    r2 = r2.objectType;
                  while (r2.flags & 8388608);
                  return r2;
                }
                return r2.flags & 16777216 ? r2.root : r2;
              }
              function yw(r2, i2) {
                return VD(r2, i2, av) !== 0;
              }
              function VD(r2, i2, t2) {
                if (r2 === i2)
                  return -1;
                var o = e2.getDeclarationModifierFlagsFromSymbol(r2) & 24, s2 = e2.getDeclarationModifierFlagsFromSymbol(i2) & 24;
                if (o !== s2)
                  return 0;
                if (o) {
                  if (jg(r2) !== jg(i2))
                    return 0;
                } else if ((r2.flags & 16777216) !== (i2.flags & 16777216))
                  return 0;
                return Zu(r2) !== Zu(i2) ? 0 : t2(Jt(r2), Jt(i2));
              }
              function hw(r2, i2, t2) {
                var o = Wc(r2), s2 = Wc(i2), u = Hl(r2), h2 = Hl(i2), z = Xl(r2), me = Xl(i2);
                return !!(o === s2 && u === h2 && z === me || t2 && u <= h2);
              }
              function _y(r2, i2, t2, o, s2, u) {
                if (r2 === i2)
                  return -1;
                if (!hw(r2, i2, t2) || e2.length(r2.typeParameters) !== e2.length(i2.typeParameters))
                  return 0;
                if (i2.typeParameters) {
                  for (var h2 = Uc(r2.typeParameters, i2.typeParameters), z = 0; z < i2.typeParameters.length; z++) {
                    var me = r2.typeParameters[z], Me = i2.typeParameters[z];
                    if (!(me === Me || u(un(tm(me), h2) || gr, tm(Me) || gr) && u(un(D_(me), h2) || gr, D_(Me) || gr)))
                      return 0;
                  }
                  r2 = Tg(r2, h2, true);
                }
                var $e = -1;
                if (!o) {
                  var tr = T_(r2);
                  if (tr) {
                    var dr = T_(i2);
                    if (dr) {
                      var Dr = u(tr, dr);
                      if (!Dr)
                        return 0;
                      $e &= Dr;
                    }
                  }
                }
                for (var Qr = Wc(i2), z = 0; z < Qr; z++) {
                  var me = $u(r2, z), Me = $u(i2, z), Dr = u(Me, me);
                  if (!Dr)
                    return 0;
                  $e &= Dr;
                }
                if (!s2) {
                  var li = Yc(r2), Ti = Yc(i2);
                  $e &= li || Ti ? Dw(li, Ti, u) : u(yo(r2), yo(i2));
                }
                return $e;
              }
              function Dw(r2, i2, t2) {
                return r2 && i2 && _D(r2, i2) ? r2.type === i2.type ? -1 : r2.type && i2.type ? t2(r2.type, i2.type) : 0 : 0;
              }
              function bw(r2) {
                for (var i2, t2 = 0, o = r2; t2 < o.length; t2++) {
                  var s2 = o[t2], u = Kl(s2);
                  if (i2 || (i2 = u), u === s2 || u !== i2)
                    return false;
                }
                return true;
              }
              function CE(r2) {
                return r2.length === 1 ? r2[0] : bw(r2) ? Pa(r2) : e2.reduceLeft(r2, function(i2, t2) {
                  return E_(i2, t2) ? t2 : i2;
                });
              }
              function Sw(r2) {
                if (!Ye)
                  return CE(r2);
                var i2 = e2.filter(r2, function(t2) {
                  return !(t2.flags & 98304);
                });
                return i2.length ? Uh(CE(i2), wE(r2) & 98304) : Pa(r2, 2);
              }
              function Tw(r2) {
                return e2.reduceLeft(r2, function(i2, t2) {
                  return E_(t2, i2) ? t2 : i2;
                });
              }
              function Tu(r2) {
                return !!(e2.getObjectFlags(r2) & 4) && (r2.target === Pi || r2.target === Qi);
              }
              function um(r2) {
                return !!(e2.getObjectFlags(r2) & 4) && r2.target === Qi;
              }
              function Pd(r2) {
                return Tu(r2) || Yn(r2);
              }
              function Bh(r2) {
                return Tu(r2) && !um(r2) || Yn(r2) && !r2.target.readonly;
              }
              function KD(r2) {
                return Tu(r2) ? xo(r2)[0] : void 0;
              }
              function sp(r2) {
                return Tu(r2) || !(r2.flags & 98304) && ao(r2, Go);
              }
              function GD(r2) {
                if (!(!(e2.getObjectFlags(r2) & 4) || !(e2.getObjectFlags(r2.target) & 3))) {
                  if (e2.getObjectFlags(r2) & 33554432)
                    return e2.getObjectFlags(r2) & 67108864 ? r2.cachedEquivalentBaseType : void 0;
                  r2.objectFlags |= 33554432;
                  var i2 = r2.target;
                  if (e2.getObjectFlags(i2) & 1) {
                    var t2 = fg(i2);
                    if (t2 && t2.expression.kind !== 79 && t2.expression.kind !== 206)
                      return;
                  }
                  var o = Qc(i2);
                  if (o.length === 1 && !Nf(r2.symbol).size) {
                    var s2 = e2.length(i2.typeParameters) ? un(o[0], Uc(i2.typeParameters, xo(r2).slice(0, i2.typeParameters.length))) : o[0];
                    return e2.length(xo(r2)) > e2.length(i2.typeParameters) && (s2 = Rc(s2, e2.last(xo(r2)))), r2.objectFlags |= 67108864, r2.cachedEquivalentBaseType = s2;
                  }
                }
              }
              function kE(r2) {
                return Ye ? r2 === na : r2 === vi;
              }
              function Jh(r2) {
                var i2 = KD(r2);
                return !!i2 && kE(i2);
              }
              function Eg(r2) {
                return Yn(r2) || !!bi(r2, "0");
              }
              function AE(r2) {
                return sp(r2) || Eg(r2);
              }
              function xw(r2, i2) {
                var t2 = da(r2, "" + i2);
                if (t2)
                  return t2;
                if (gf(r2, Yn))
                  return Ss(r2, function(o) {
                    return sv(o) || Tr;
                  });
              }
              function Ew(r2) {
                return !(r2.flags & 240512);
              }
              function Vl(r2) {
                return !!(r2.flags & 109440);
              }
              function NE(r2) {
                return r2.flags & 2097152 ? e2.some(r2.types, Vl) : !!(r2.flags & 109440);
              }
              function Cw(r2) {
                return r2.flags & 2097152 && e2.find(r2.types, Vl) || r2;
              }
              function Cg(r2) {
                return r2.flags & 16 ? true : r2.flags & 1048576 ? r2.flags & 1024 ? true : e2.every(r2.types, Vl) : Vl(r2);
              }
              function Kl(r2) {
                return r2.flags & 1024 ? cc(r2) : r2.flags & 402653312 ? Li : r2.flags & 256 ? nt : r2.flags & 2048 ? Mt : r2.flags & 512 ? Ii : r2.flags & 1048576 ? Ss(r2, Kl) : r2;
              }
              function Hp(r2) {
                return r2.flags & 1024 && Kp(r2) ? cc(r2) : r2.flags & 128 && Kp(r2) ? Li : r2.flags & 256 && Kp(r2) ? nt : r2.flags & 2048 && Kp(r2) ? Mt : r2.flags & 512 && Kp(r2) ? Ii : r2.flags & 1048576 ? Ss(r2, Hp) : r2;
              }
              function PE(r2) {
                return r2.flags & 8192 ? Ki : r2.flags & 1048576 ? Ss(r2, PE) : r2;
              }
              function HD(r2, i2) {
                return N0(r2, i2) || (r2 = PE(Hp(r2))), r2;
              }
              function kw(r2, i2, t2) {
                if (r2 && Vl(r2)) {
                  var o = i2 ? t2 ? Tv(i2) : i2 : void 0;
                  r2 = HD(r2, o);
                }
                return r2;
              }
              function XD(r2, i2, t2, o) {
                if (r2 && Vl(r2)) {
                  var s2 = i2 ? Jg(t2, i2, o) : void 0;
                  r2 = HD(r2, s2);
                }
                return r2;
              }
              function Yn(r2) {
                return !!(e2.getObjectFlags(r2) & 4 && r2.target.objectFlags & 8);
              }
              function lm(r2) {
                return Yn(r2) && !!(r2.target.combinedFlags & 8);
              }
              function IE(r2) {
                return lm(r2) && r2.target.elementFlags.length === 1;
              }
              function sv(r2) {
                return jh(r2, r2.target.fixedLength);
              }
              function Aw(r2) {
                var i2 = sv(r2);
                return i2 && Zs(i2);
              }
              function jh(r2, i2, t2, o) {
                t2 === void 0 && (t2 = 0), o === void 0 && (o = false);
                var s2 = $_(r2) - t2;
                if (i2 < s2) {
                  for (var u = xo(r2), h2 = [], z = i2; z < s2; z++) {
                    var me = u[z];
                    h2.push(r2.target.elementFlags[z] & 8 ? Jc(me, nt) : me);
                  }
                  return o ? Do(h2) : Pa(h2);
                }
              }
              function Nw(r2, i2) {
                return $_(r2) === $_(i2) && e2.every(r2.target.elementFlags, function(t2, o) {
                  return (t2 & 12) === (i2.target.elementFlags[o] & 12);
                });
              }
              function QD(r2) {
                var i2 = r2.value;
                return i2.base10Value === "0";
              }
              function wE(r2) {
                for (var i2 = 0, t2 = 0, o = r2; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  i2 |= ju(s2);
                }
                return i2;
              }
              function ju(r2) {
                return r2.flags & 1048576 ? wE(r2.types) : r2.flags & 128 ? r2.value === "" ? 128 : 0 : r2.flags & 256 ? r2.value === 0 ? 256 : 0 : r2.flags & 2048 ? QD(r2) ? 2048 : 0 : r2.flags & 512 ? r2 === xt || r2 === ut ? 512 : 0 : r2.flags & 117724;
              }
              function OE(r2) {
                return ju(r2) & 117632 ? ec(r2, function(i2) {
                  return !(ju(i2) & 117632);
                }) : r2;
              }
              function Pw(r2) {
                return Ss(r2, Iw);
              }
              function Iw(r2) {
                return r2.flags & 4 ? Rf : r2.flags & 8 ? al : r2.flags & 64 ? Jo : r2 === ut || r2 === xt || r2.flags & 114691 || r2.flags & 128 && r2.value === "" || r2.flags & 256 && r2.value === 0 || r2.flags & 2048 && QD(r2) ? r2 : ui;
              }
              function Uh(r2, i2) {
                var t2 = i2 & ~r2.flags & 98304;
                return t2 === 0 ? r2 : Pa(t2 === 32768 ? [r2, Tr] : t2 === 65536 ? [r2, Wi] : [r2, Tr, Wi]);
              }
              function i_(r2, i2) {
                return i2 === void 0 && (i2 = false), e2.Debug.assert(Ye), r2.flags & 32768 ? r2 : Pa([r2, i2 ? Yi : Tr]);
              }
              function ww(r2) {
                var i2 = Ks(r2, 2097152);
                return ys || (ys = Ym("NonNullable", 524288, void 0) || xe), ys !== xe ? am(ys, [i2]) : i2;
              }
              function C_(r2) {
                return Ye ? ww(r2) : r2;
              }
              function FE(r2) {
                return Ye ? Pa([r2, Ui]) : r2;
              }
              function YD(r2) {
                return Ye ? Zh(r2, Ui) : r2;
              }
              function zh(r2, i2, t2) {
                return t2 ? e2.isOutermostOptionalChain(i2) ? i_(r2) : FE(r2) : r2;
              }
              function cv(r2, i2) {
                return e2.isExpressionOfOptionalChainRoot(i2) ? C_(r2) : e2.isOptionalChain(i2) ? YD(r2) : r2;
              }
              function kg(r2, i2) {
                return yr && i2 ? Zh(r2, Yi) : r2;
              }
              function Wh(r2) {
                return yr && (r2 === Yi || r2.flags & 1048576 && $f(r2.types, Yi));
              }
              function $D(r2) {
                return yr ? Zh(r2, Yi) : Ks(r2, 524288);
              }
              function Ow(r2, i2) {
                return (r2.flags & 524) !== 0 && (i2.flags & 28) !== 0;
              }
              function qh(r2) {
                return r2.flags & 2097152 ? e2.every(r2.types, qh) : !!(r2.symbol && (r2.symbol.flags & 7040) !== 0 && !(r2.symbol.flags & 32) && !RS(r2)) || !!(e2.getObjectFlags(r2) & 1024 && qh(r2.source));
              }
              function eg(r2, i2) {
                var t2 = oo(r2.flags, r2.escapedName, e2.getCheckFlags(r2) & 8);
                t2.declarations = r2.declarations, t2.parent = r2.parent, t2.type = i2, t2.target = r2, r2.valueDeclaration && (t2.valueDeclaration = r2.valueDeclaration);
                var o = Aa(r2).nameType;
                return o && (t2.nameType = o), t2;
              }
              function Fw(r2, i2) {
                for (var t2 = e2.createSymbolTable(), o = 0, s2 = Pf(r2); o < s2.length; o++) {
                  var u = s2[o], h2 = Jt(u), z = i2(h2);
                  t2.set(u.escapedName, z === h2 ? u : eg(u, z));
                }
                return t2;
              }
              function fm(r2) {
                if (!(Qp(r2) && e2.getObjectFlags(r2) & 8192))
                  return r2;
                var i2 = r2.regularType;
                if (i2)
                  return i2;
                var t2 = r2, o = Fw(r2, fm), s2 = rs(t2.symbol, o, t2.callSignatures, t2.constructSignatures, t2.indexInfos);
                return s2.flags = t2.flags, s2.objectFlags |= t2.objectFlags & -8193, r2.regularType = s2, s2;
              }
              function ME(r2, i2, t2) {
                return { parent: r2, propertyName: i2, siblings: t2, resolvedProperties: void 0 };
              }
              function LE(r2) {
                if (!r2.siblings) {
                  for (var i2 = [], t2 = 0, o = LE(r2.parent); t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (Qp(s2)) {
                      var u = h_(s2, r2.propertyName);
                      u && Od(Jt(u), function(h2) {
                        i2.push(h2);
                      });
                    }
                  }
                  r2.siblings = i2;
                }
                return r2.siblings;
              }
              function Mw(r2) {
                if (!r2.resolvedProperties) {
                  for (var i2 = new e2.Map(), t2 = 0, o = LE(r2); t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (Qp(s2) && !(e2.getObjectFlags(s2) & 2097152))
                      for (var u = 0, h2 = uo(s2); u < h2.length; u++) {
                        var z = h2[u];
                        i2.set(z.escapedName, z);
                      }
                  }
                  r2.resolvedProperties = e2.arrayFrom(i2.values());
                }
                return r2.resolvedProperties;
              }
              function Lw(r2, i2) {
                if (!(r2.flags & 4))
                  return r2;
                var t2 = Jt(r2), o = i2 && ME(i2, r2.escapedName, void 0), s2 = ZD(t2, o);
                return s2 === t2 ? r2 : eg(r2, s2);
              }
              function Rw(r2) {
                var i2 = Wr.get(r2.escapedName);
                if (i2)
                  return i2;
                var t2 = eg(r2, Yi);
                return t2.flags |= 16777216, Wr.set(r2.escapedName, t2), t2;
              }
              function Bw(r2, i2) {
                for (var t2 = e2.createSymbolTable(), o = 0, s2 = Pf(r2); o < s2.length; o++) {
                  var u = s2[o];
                  t2.set(u.escapedName, Lw(u, i2));
                }
                if (i2)
                  for (var h2 = 0, z = Mw(i2); h2 < z.length; h2++) {
                    var u = z[h2];
                    t2.has(u.escapedName) || t2.set(u.escapedName, Rw(u));
                  }
                var me = rs(r2.symbol, t2, e2.emptyArray, e2.emptyArray, e2.sameMap(Hn(r2), function(Me) {
                  return zl(Me.keyType, $c(Me.type), Me.isReadonly);
                }));
                return me.objectFlags |= e2.getObjectFlags(r2) & 266240, me;
              }
              function $c(r2) {
                return ZD(r2, void 0);
              }
              function ZD(r2, i2) {
                if (e2.getObjectFlags(r2) & 196608) {
                  if (i2 === void 0 && r2.widened)
                    return r2.widened;
                  var t2 = void 0;
                  if (r2.flags & 98305)
                    t2 = Oe;
                  else if (Qp(r2))
                    t2 = Bw(r2, i2);
                  else if (r2.flags & 1048576) {
                    var o = i2 || ME(void 0, void 0, r2.types), s2 = e2.sameMap(r2.types, function(u) {
                      return u.flags & 98304 ? u : ZD(u, o);
                    });
                    t2 = Pa(s2, e2.some(s2, Of) ? 2 : 1);
                  } else
                    r2.flags & 2097152 ? t2 = Do(e2.sameMap(r2.types, $c)) : Pd(r2) && (t2 = Yf(r2.target, e2.sameMap(xo(r2), $c)));
                  return t2 && i2 === void 0 && (r2.widened = t2), t2 || r2;
                }
                return r2;
              }
              function Vh(r2) {
                var i2 = false;
                if (e2.getObjectFlags(r2) & 65536) {
                  if (r2.flags & 1048576)
                    if (e2.some(r2.types, Of))
                      i2 = true;
                    else
                      for (var t2 = 0, o = r2.types; t2 < o.length; t2++) {
                        var s2 = o[t2];
                        Vh(s2) && (i2 = true);
                      }
                  if (Pd(r2))
                    for (var u = 0, h2 = xo(r2); u < h2.length; u++) {
                      var s2 = h2[u];
                      Vh(s2) && (i2 = true);
                    }
                  if (Qp(r2))
                    for (var z = 0, me = Pf(r2); z < me.length; z++) {
                      var Me = me[z], s2 = Jt(Me);
                      e2.getObjectFlags(s2) & 65536 && (Vh(s2) || Xr(Me.valueDeclaration, e2.Diagnostics.Object_literal_s_property_0_implicitly_has_an_1_type, tn(Me), Ot($c(s2))), i2 = true);
                    }
                }
                return i2;
              }
              function Xp(r2, i2, t2) {
                var o = Ot($c(i2));
                if (!(e2.isInJSFile(r2) && !e2.isCheckJsEnabledForFile(e2.getSourceFileOfNode(r2), ye))) {
                  var s2;
                  switch (r2.kind) {
                    case 221:
                    case 167:
                    case 166:
                      s2 = n ? e2.Diagnostics.Member_0_implicitly_has_an_1_type : e2.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
                      break;
                    case 164:
                      var u = r2;
                      if (e2.isIdentifier(u.name) && (e2.isCallSignatureDeclaration(u.parent) || e2.isMethodSignature(u.parent) || e2.isFunctionTypeNode(u.parent)) && u.parent.parameters.indexOf(u) > -1 && (es(u, u.name.escapedText, 788968, void 0, u.name.escapedText, true) || u.name.originalKeywordKind && e2.isTypeNodeKind(u.name.originalKeywordKind))) {
                        var h2 = "arg" + u.parent.parameters.indexOf(u), z = e2.declarationNameToString(u.name) + (u.dotDotDotToken ? "[]" : "");
                        Ic(n, r2, e2.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1, h2, z);
                        return;
                      }
                      s2 = r2.dotDotDotToken ? n ? e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type : e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage : n ? e2.Diagnostics.Parameter_0_implicitly_has_an_1_type : e2.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
                      break;
                    case 203:
                      if (s2 = e2.Diagnostics.Binding_element_0_implicitly_has_an_1_type, !n)
                        return;
                      break;
                    case 317:
                      Xr(r2, e2.Diagnostics.Function_type_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, o);
                      return;
                    case 256:
                    case 169:
                    case 168:
                    case 172:
                    case 173:
                    case 213:
                    case 214:
                      if (n && !r2.name) {
                        t2 === 3 ? Xr(r2, e2.Diagnostics.Generator_implicitly_has_yield_type_0_because_it_does_not_yield_any_values_Consider_supplying_a_return_type_annotation, o) : Xr(r2, e2.Diagnostics.Function_expression_which_lacks_return_type_annotation_implicitly_has_an_0_return_type, o);
                        return;
                      }
                      s2 = n ? t2 === 3 ? e2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_yield_type : e2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type : e2.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage;
                      break;
                    case 195:
                      n && Xr(r2, e2.Diagnostics.Mapped_object_type_implicitly_has_an_any_template_type);
                      return;
                    default:
                      s2 = n ? e2.Diagnostics.Variable_0_implicitly_has_an_1_type : e2.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage;
                  }
                  Ic(n, r2, s2, e2.declarationNameToString(e2.getNameOfDeclaration(r2)), o);
                }
              }
              function Kh(r2, i2, t2) {
                fe(function() {
                  n && e2.getObjectFlags(i2) & 65536 && (!t2 || !Pb(r2)) && (Vh(i2) || Xp(r2, i2, t2));
                });
              }
              function eb(r2, i2, t2) {
                var o = Wc(r2), s2 = Wc(i2), u = vv(r2), h2 = vv(i2), z = h2 ? s2 - 1 : s2, me = u ? z : Math.min(o, z), Me = T_(r2);
                if (Me) {
                  var $e = T_(i2);
                  $e && t2(Me, $e);
                }
                for (var tr = 0; tr < me; tr++)
                  t2($u(r2, tr), $u(i2, tr));
                h2 && t2(ym(r2, me), h2);
              }
              function rb(r2, i2, t2) {
                var o = Yc(r2), s2 = Yc(i2);
                o && s2 && _D(o, s2) && o.type && s2.type ? t2(o.type, s2.type) : t2(yo(r2), yo(i2));
              }
              function uv(r2, i2, t2, o) {
                return ib(r2.map(tb), i2, t2, o || OD);
              }
              function Jw(r2, i2) {
                return i2 === void 0 && (i2 = 0), r2 && ib(e2.map(r2.inferences, JE), r2.signature, r2.flags | i2, r2.compareTypes);
              }
              function ib(r2, i2, t2, o) {
                var s2 = { inferences: r2, signature: i2, flags: t2, compareTypes: o, mapper: Gp(function(u) {
                  return RE(s2, u, true);
                }), nonFixingMapper: Gp(function(u) {
                  return RE(s2, u, false);
                }) };
                return s2;
              }
              function RE(r2, i2, t2) {
                for (var o = r2.inferences, s2 = 0; s2 < o.length; s2++) {
                  var u = o[s2];
                  if (i2 === u.typeParameter)
                    return t2 && !u.isFixed && (jw(r2), Gh(o), u.isFixed = true), GE(r2, s2);
                }
                return i2;
              }
              function Gh(r2) {
                for (var i2 = 0, t2 = r2; i2 < t2.length; i2++) {
                  var o = t2[i2];
                  o.isFixed || (o.inferredType = void 0);
                }
              }
              function BE(r2, i2, t2) {
                var o;
                ((o = r2.intraExpressionInferenceSites) !== null && o !== void 0 ? o : r2.intraExpressionInferenceSites = []).push({ node: i2, type: t2 });
              }
              function jw(r2) {
                if (r2.intraExpressionInferenceSites) {
                  for (var i2 = 0, t2 = r2.intraExpressionInferenceSites; i2 < t2.length; i2++) {
                    var o = t2[i2], s2 = o.node, u = o.type, h2 = s2.kind === 169 ? kC(s2, 2) : ou(s2, 2);
                    h2 && df(r2.inferences, u, h2);
                  }
                  r2.intraExpressionInferenceSites = void 0;
                }
              }
              function tb(r2) {
                return { typeParameter: r2, candidates: void 0, contraCandidates: void 0, inferredType: void 0, priority: void 0, topLevel: true, isFixed: false, impliedArity: void 0 };
              }
              function JE(r2) {
                return { typeParameter: r2.typeParameter, candidates: r2.candidates && r2.candidates.slice(), contraCandidates: r2.contraCandidates && r2.contraCandidates.slice(), inferredType: r2.inferredType, priority: r2.priority, topLevel: r2.topLevel, isFixed: r2.isFixed, impliedArity: r2.impliedArity };
              }
              function Uw(r2) {
                var i2 = e2.filter(r2.inferences, tg);
                return i2.length ? ib(e2.map(i2, JE), r2.signature, r2.flags, r2.compareTypes) : void 0;
              }
              function ab(r2) {
                return r2 && r2.mapper;
              }
              function Id(r2) {
                var i2 = e2.getObjectFlags(r2);
                if (i2 & 524288)
                  return !!(i2 & 1048576);
                var t2 = !!(r2.flags & 465829888 || r2.flags & 524288 && !jE(r2) && (i2 & 4 && (r2.node || e2.forEach(xo(r2), Id)) || i2 & 16 && r2.symbol && r2.symbol.flags & 14384 && r2.symbol.declarations || i2 & 12583968) || r2.flags & 3145728 && !(r2.flags & 1024) && !jE(r2) && e2.some(r2.types, Id));
                return r2.flags & 3899393 && (r2.objectFlags |= 524288 | (t2 ? 1048576 : 0)), t2;
              }
              function jE(r2) {
                if (r2.aliasSymbol && !r2.aliasTypeArguments) {
                  var i2 = e2.getDeclarationOfKind(r2.aliasSymbol, 259);
                  return !!(i2 && e2.findAncestor(i2.parent, function(t2) {
                    return t2.kind === 305 ? true : t2.kind === 261 ? false : "quit";
                  }));
                }
                return false;
              }
              function nb(r2, i2) {
                return !!(r2 === i2 || r2.flags & 3145728 && e2.some(r2.types, function(t2) {
                  return nb(t2, i2);
                }) || r2.flags & 16777216 && (ip(r2) === i2 || tp(r2) === i2));
              }
              function zw(r2) {
                var i2 = e2.createSymbolTable();
                Od(r2, function(o) {
                  if (!!(o.flags & 128)) {
                    var s2 = e2.escapeLeadingUnderscores(o.value), u = oo(4, s2);
                    u.type = Oe, o.symbol && (u.declarations = o.symbol.declarations, u.valueDeclaration = o.symbol.valueDeclaration), i2.set(s2, u);
                  }
                });
                var t2 = r2.flags & 4 ? [zl(Li, Ba, false)] : e2.emptyArray;
                return rs(void 0, i2, e2.emptyArray, e2.emptyArray, t2);
              }
              function UE(r2, i2, t2) {
                if (!Qe) {
                  var o = r2.id + "," + i2.id + "," + t2.id;
                  if (Jn.has(o))
                    return Jn.get(o);
                  Qe = true;
                  var s2 = Ww(r2, i2, t2);
                  return Qe = false, Jn.set(o, s2), s2;
                }
              }
              function ob(r2) {
                return !(e2.getObjectFlags(r2) & 262144) || Qp(r2) && e2.some(uo(r2), function(i2) {
                  return ob(Jt(i2));
                }) || Yn(r2) && e2.some(xo(r2), ob);
              }
              function Ww(r2, i2, t2) {
                if (!!(ss(r2, Li) || uo(r2).length !== 0 && ob(r2))) {
                  if (Tu(r2))
                    return Zs(Hh(xo(r2)[0], i2, t2), um(r2));
                  if (Yn(r2)) {
                    var o = e2.map(xo(r2), function(h2) {
                      return Hh(h2, i2, t2);
                    }), s2 = Lu(i2) & 4 ? e2.sameMap(r2.target.elementFlags, function(h2) {
                      return h2 & 2 ? 1 : h2;
                    }) : r2.target.elementFlags;
                    return Wl(o, s2, r2.target.readonly, r2.target.labeledElementDeclarations);
                  }
                  var u = tu(1040, void 0);
                  return u.source = r2, u.mappedType = i2, u.constraintType = t2, u;
                }
              }
              function qw(r2) {
                var i2 = Aa(r2);
                return i2.type || (i2.type = Hh(r2.propertyType, r2.mappedType, r2.constraintType)), i2.type;
              }
              function Hh(r2, i2, t2) {
                var o = Jc(t2.type, Du(i2)), s2 = vl(i2), u = tb(o);
                return df([u], r2, s2), zE(u) || gr;
              }
              function sb(r2, i2, t2, o) {
                var s2, u, h2, z, me, Me, $e;
                return kr(this, function(tr) {
                  switch (tr.label) {
                    case 0:
                      s2 = uo(i2), u = 0, h2 = s2, tr.label = 1;
                    case 1:
                      return u < h2.length ? (z = h2[u], $y(z) ? [3, 5] : t2 || !(z.flags & 16777216 || e2.getCheckFlags(z) & 48) ? (me = bi(r2, z.escapedName), me ? [3, 3] : [4, z]) : [3, 5]) : [3, 6];
                    case 2:
                      return tr.sent(), [3, 5];
                    case 3:
                      return o ? (Me = Jt(z), Me.flags & 109440 ? ($e = Jt(me), $e.flags & 1 || jc($e) === jc(Me) ? [3, 5] : [4, z]) : [3, 5]) : [3, 5];
                    case 4:
                      tr.sent(), tr.label = 5;
                    case 5:
                      return u++, [3, 1];
                    case 6:
                      return [2];
                  }
                });
              }
              function cb(r2, i2, t2, o) {
                var s2 = sb(r2, i2, t2, o).next();
                if (!s2.done)
                  return s2.value;
              }
              function Vw(r2, i2) {
                return !(i2.target.combinedFlags & 8) && i2.target.minLength > r2.target.minLength || !i2.target.hasRestElement && (r2.target.hasRestElement || i2.target.fixedLength < r2.target.fixedLength);
              }
              function Kw(r2, i2) {
                return Yn(r2) && Yn(i2) ? Vw(r2, i2) : !!cb(r2, i2, false, true) && !!cb(i2, r2, false, false);
              }
              function zE(r2) {
                return r2.candidates ? Pa(r2.candidates, 2) : r2.contraCandidates ? Do(r2.contraCandidates) : void 0;
              }
              function ub(r2) {
                return !!va(r2).skipDirectInference;
              }
              function WE(r2) {
                return !!(r2.symbol && e2.some(r2.symbol.declarations, ub));
              }
              function Gw(r2, i2) {
                var t2 = r2.texts[0], o = i2.texts[0], s2 = r2.texts[r2.texts.length - 1], u = i2.texts[i2.texts.length - 1], h2 = Math.min(t2.length, o.length), z = Math.min(s2.length, u.length);
                return t2.slice(0, h2) !== o.slice(0, h2) || s2.slice(s2.length - z) !== u.slice(u.length - z);
              }
              function Hw(r2) {
                var i2 = e2.createScanner(99, false), t2 = true;
                i2.setOnError(function() {
                  return t2 = false;
                }), i2.setText(r2 + "n");
                var o = i2.scan();
                o === 40 && (o = i2.scan());
                var s2 = i2.getTokenFlags();
                return t2 && o === 9 && i2.getTextPos() === r2.length + 1 && !(s2 & 512);
              }
              function Xw(r2, i2) {
                if (r2 === i2 || i2.flags & 5)
                  return true;
                if (r2.flags & 128) {
                  var t2 = r2.value;
                  return !!(i2.flags & 8 && t2 !== "" && isFinite(+t2) || i2.flags & 64 && t2 !== "" && Hw(t2) || i2.flags & 98816 && t2 === i2.intrinsicName);
                }
                if (r2.flags & 134217728) {
                  var o = r2.texts;
                  return o.length === 2 && o[0] === "" && o[1] === "" && ao(r2.types[0], i2);
                }
                return ao(r2, i2);
              }
              function qE(r2, i2) {
                return r2.flags & 128 ? KE([r2.value], e2.emptyArray, i2) : r2.flags & 134217728 ? e2.arraysEqual(r2.texts, i2.texts) ? e2.map(r2.types, Qw) : KE(r2.texts, r2.types, i2) : void 0;
              }
              function VE(r2, i2) {
                var t2 = qE(r2, i2);
                return !!t2 && e2.every(t2, function(o, s2) {
                  return Xw(o, i2.types[s2]);
                });
              }
              function Qw(r2) {
                return r2.flags & 402653317 ? r2 : Dg(["", ""], [r2]);
              }
              function KE(r2, i2, t2) {
                var o = r2.length - 1, s2 = r2[0], u = r2[o], h2 = t2.texts, z = h2.length - 1, me = h2[0], Me = h2[z];
                if (o === 0 && s2.length < me.length + Me.length || !s2.startsWith(me) || !u.endsWith(Me))
                  return;
                for (var $e = u.slice(0, u.length - Me.length), tr = [], dr = 0, Dr = me.length, Qr = 1; Qr < z; Qr++) {
                  var li = h2[Qr];
                  if (li.length > 0) {
                    for (var Ti = dr, Ci = Dr; Ci = $i(Ti).indexOf(li, Ci), !(Ci >= 0); ) {
                      if (Ti++, Ti === r2.length)
                        return;
                      Ci = 0;
                    }
                    Zi(Ti, Ci), Dr += li.length;
                  } else if (Dr < $i(dr).length)
                    Zi(dr, Dr + 1);
                  else if (dr < o)
                    Zi(dr + 1, 0);
                  else
                    return;
                }
                return Zi(o, $i(o).length), tr;
                function $i(qt) {
                  return qt < o ? r2[qt] : $e;
                }
                function Zi(qt, Nt) {
                  var Ra = qt === dr ? Bu($i(qt).slice(Dr, Nt)) : Dg(Ve(Ve([r2[dr].slice(Dr)], r2.slice(dr + 1, qt), true), [$i(qt).slice(0, Nt)], false), i2.slice(dr, qt));
                  tr.push(Ra), dr = qt, Dr = Nt;
                }
              }
              function df(r2, i2, t2, o, s2) {
                o === void 0 && (o = 0), s2 === void 0 && (s2 = false);
                var u = false, h2, z = 2048, me = true, Me, $e, tr, dr = 0;
                Dr(i2, t2);
                function Dr(lt, it) {
                  if (!!Id(it)) {
                    if (lt === Mr) {
                      var Yt = h2;
                      h2 = lt, Dr(it, it), h2 = Yt;
                      return;
                    }
                    if (lt.aliasSymbol && lt.aliasTypeArguments && lt.aliasSymbol === it.aliasSymbol) {
                      Ci(lt.aliasTypeArguments, it.aliasTypeArguments, TE(lt.aliasSymbol));
                      return;
                    }
                    if (lt === it && lt.flags & 3145728) {
                      for (var Ia = 0, Qt = lt.types; Ia < Qt.length; Ia++) {
                        var Ka = Qt[Ia];
                        Dr(Ka, Ka);
                      }
                      return;
                    }
                    if (it.flags & 1048576) {
                      var cn = Ti(lt.flags & 1048576 ? lt.types : [lt], it.types, Yw), Un = cn[0], oa = cn[1], Mn = Ti(Un, oa, $w), Ln = Mn[0], ci = Mn[1];
                      if (ci.length === 0)
                        return;
                      if (it = Pa(ci), Ln.length === 0) {
                        Qr(lt, it, 1);
                        return;
                      }
                      lt = Pa(Ln);
                    } else if (it.flags & 2097152 && e2.some(it.types, function(Fa) {
                      return !!Zi(Fa) || Bc(Fa) && !!Zi(Ih(Fa) || ui);
                    })) {
                      if (!(lt.flags & 1048576)) {
                        var Fr = Ti(lt.flags & 2097152 ? lt.types : [lt], it.types, wf), Ln = Fr[0], ci = Fr[1];
                        if (Ln.length === 0 || ci.length === 0)
                          return;
                        lt = Do(Ln), it = Do(ci);
                      }
                    } else
                      it.flags & 41943040 && (it = rp(it));
                    if (it.flags & 8650752) {
                      if (lt === fr || lt === Bt || o & 128 && (lt === nr || lt === So) || WE(lt))
                        return;
                      var jt = Zi(it);
                      if (jt) {
                        if (e2.getObjectFlags(lt) & 262144)
                          return;
                        if (!jt.isFixed) {
                          if ((jt.priority === void 0 || o < jt.priority) && (jt.candidates = void 0, jt.contraCandidates = void 0, jt.topLevel = true, jt.priority = o), o === jt.priority) {
                            var Lt = h2 || lt;
                            s2 && !u ? e2.contains(jt.contraCandidates, Lt) || (jt.contraCandidates = e2.append(jt.contraCandidates, Lt), Gh(r2)) : e2.contains(jt.candidates, Lt) || (jt.candidates = e2.append(jt.candidates, Lt), Gh(r2));
                          }
                          !(o & 128) && it.flags & 262144 && jt.topLevel && !nb(t2, it) && (jt.topLevel = false, Gh(r2));
                        }
                        z = Math.min(z, o);
                        return;
                      }
                      var ea = Zf(it, false);
                      if (ea !== it)
                        Dr(lt, ea);
                      else if (it.flags & 8388608) {
                        var Kt = Zf(it.indexType, false);
                        if (Kt.flags & 465829888) {
                          var $t = Hx(Zf(it.objectType, false), Kt, false);
                          $t && $t !== it && Dr(lt, $t);
                        }
                      }
                    }
                    if (e2.getObjectFlags(lt) & 4 && e2.getObjectFlags(it) & 4 && (lt.target === it.target || Tu(lt) && Tu(it)) && !(lt.node && it.node))
                      Ci(xo(lt), xo(it), zD(lt.target));
                    else if (lt.flags & 4194304 && it.flags & 4194304)
                      s2 = !s2, Dr(lt.type, it.type), s2 = !s2;
                    else if ((Cg(lt) || lt.flags & 4) && it.flags & 4194304) {
                      var Ua = zw(lt);
                      s2 = !s2, Qr(Ua, it.type, 256), s2 = !s2;
                    } else if (lt.flags & 8388608 && it.flags & 8388608)
                      Dr(lt.objectType, it.objectType), Dr(lt.indexType, it.indexType);
                    else if (lt.flags & 268435456 && it.flags & 268435456)
                      lt.symbol === it.symbol && Dr(lt.type, it.type);
                    else if (lt.flags & 33554432) {
                      Dr(lt.baseType, it);
                      var Yr = o;
                      o |= 4, Dr(lt.substitute, it), o = Yr;
                    } else if (it.flags & 16777216)
                      li(lt, it, ca);
                    else if (it.flags & 3145728)
                      Nt(lt, it.types, it.flags);
                    else if (lt.flags & 1048576)
                      for (var Ni = lt.types, Hi = 0, _t = Ni; Hi < _t.length; Hi++) {
                        var gt = _t[Hi];
                        Dr(gt, it);
                      }
                    else if (it.flags & 134217728)
                      Sn(lt, it);
                    else {
                      if (lt = bu(lt), !(o & 512 && lt.flags & 467927040)) {
                        var Vt = $s(lt);
                        if (Vt !== lt && me && !(Vt.flags & 2621440))
                          return me = false, Dr(Vt, it);
                        lt = Vt;
                      }
                      lt.flags & 2621440 && li(lt, it, ja);
                    }
                  }
                }
                function Qr(lt, it, Yt) {
                  var Ia = o;
                  o |= Yt, Dr(lt, it), o = Ia;
                }
                function li(lt, it, Yt) {
                  var Ia = lt.id + "," + it.id, Qt = Me && Me.get(Ia);
                  if (Qt !== void 0) {
                    z = Math.min(z, Qt);
                    return;
                  }
                  (Me || (Me = new e2.Map())).set(Ia, -1);
                  var Ka = z;
                  z = 2048;
                  var cn = dr, Un = ov(lt), oa = ov(it);
                  e2.contains($e, Un) && (dr |= 1), e2.contains(tr, oa) && (dr |= 2), dr !== 3 ? (($e || ($e = [])).push(Un), (tr || (tr = [])).push(oa), Yt(lt, it), tr.pop(), $e.pop()) : z = -1, dr = cn, Me.set(Ia, z), z = Math.min(z, Ka);
                }
                function Ti(lt, it, Yt) {
                  for (var Ia, Qt, Ka = 0, cn = it; Ka < cn.length; Ka++)
                    for (var Un = cn[Ka], oa = 0, Mn = lt; oa < Mn.length; oa++) {
                      var Ln = Mn[oa];
                      Yt(Ln, Un) && (Dr(Ln, Un), Ia = e2.appendIfUnique(Ia, Ln), Qt = e2.appendIfUnique(Qt, Un));
                    }
                  return [Ia ? e2.filter(lt, function(ci) {
                    return !e2.contains(Ia, ci);
                  }) : lt, Qt ? e2.filter(it, function(ci) {
                    return !e2.contains(Qt, ci);
                  }) : it];
                }
                function Ci(lt, it, Yt) {
                  for (var Ia = lt.length < it.length ? lt.length : it.length, Qt = 0; Qt < Ia; Qt++)
                    Qt < Yt.length && (Yt[Qt] & 7) === 2 ? $i(lt[Qt], it[Qt]) : Dr(lt[Qt], it[Qt]);
                }
                function $i(lt, it) {
                  Br || o & 1024 ? (s2 = !s2, Dr(lt, it), s2 = !s2) : Dr(lt, it);
                }
                function Zi(lt) {
                  if (lt.flags & 8650752)
                    for (var it = 0, Yt = r2; it < Yt.length; it++) {
                      var Ia = Yt[it];
                      if (lt === Ia.typeParameter)
                        return Ia;
                    }
                }
                function qt(lt) {
                  for (var it, Yt = 0, Ia = lt; Yt < Ia.length; Yt++) {
                    var Qt = Ia[Yt], Ka = Qt.flags & 2097152 && e2.find(Qt.types, function(cn) {
                      return !!Zi(cn);
                    });
                    if (!Ka || it && Ka !== it)
                      return;
                    it = Ka;
                  }
                  return it;
                }
                function Nt(lt, it, Yt) {
                  var Ia = 0;
                  if (Yt & 1048576) {
                    for (var Qt = void 0, Ka = lt.flags & 1048576 ? lt.types : [lt], cn = new Array(Ka.length), Un = false, oa = 0, Mn = it; oa < Mn.length; oa++) {
                      var Ln = Mn[oa];
                      if (Zi(Ln))
                        Qt = Ln, Ia++;
                      else
                        for (var ci = 0; ci < Ka.length; ci++) {
                          var Fr = z;
                          z = 2048, Dr(Ka[ci], Ln), z === o && (cn[ci] = true), Un = Un || z === -1, z = Math.min(z, Fr);
                        }
                    }
                    if (Ia === 0) {
                      var jt = qt(it);
                      jt && Qr(lt, jt, 1);
                      return;
                    }
                    if (Ia === 1 && !Un) {
                      var Lt = e2.flatMap(Ka, function(Yr, Ni) {
                        return cn[Ni] ? void 0 : Yr;
                      });
                      if (Lt.length) {
                        Dr(Pa(Lt), Qt);
                        return;
                      }
                    }
                  } else
                    for (var ea = 0, Kt = it; ea < Kt.length; ea++) {
                      var Ln = Kt[ea];
                      Zi(Ln) ? Ia++ : Dr(lt, Ln);
                    }
                  if (Yt & 2097152 ? Ia === 1 : Ia > 0)
                    for (var $t = 0, Ua = it; $t < Ua.length; $t++) {
                      var Ln = Ua[$t];
                      Zi(Ln) && Qr(lt, Ln, 1);
                    }
                }
                function Ra(lt, it, Yt) {
                  if (Yt.flags & 1048576) {
                    for (var Ia = false, Qt = 0, Ka = Yt.types; Qt < Ka.length; Qt++) {
                      var cn = Ka[Qt];
                      Ia = Ra(lt, it, cn) || Ia;
                    }
                    return Ia;
                  }
                  if (Yt.flags & 4194304) {
                    var Un = Zi(Yt.type);
                    if (Un && !Un.isFixed && !WE(lt)) {
                      var oa = UE(lt, it, Yt);
                      oa && Qr(oa, Un.typeParameter, e2.getObjectFlags(lt) & 262144 ? 16 : 8);
                    }
                    return true;
                  }
                  if (Yt.flags & 262144) {
                    Qr(ql(lt), Yt, 32);
                    var Mn = Q_(Yt);
                    if (Mn && Ra(lt, it, Mn))
                      return true;
                    var Ln = e2.map(uo(lt), Jt), ci = e2.map(Hn(lt), function(Fr) {
                      return Fr !== Ko ? Fr.type : ui;
                    });
                    return Dr(Pa(e2.concatenate(Ln, ci)), vl(it)), true;
                  }
                  return false;
                }
                function ca(lt, it) {
                  if (lt.flags & 16777216)
                    Dr(lt.checkType, it.checkType), Dr(lt.extendsType, it.extendsType), Dr(ip(lt), ip(it)), Dr(tp(lt), tp(it));
                  else {
                    var Yt = o;
                    o |= s2 ? 64 : 0;
                    var Ia = [ip(it), tp(it)];
                    Nt(lt, Ia, it.flags), o = Yt;
                  }
                }
                function Sn(lt, it) {
                  var Yt = qE(lt, it), Ia = it.types;
                  if (Yt || e2.every(it.texts, function(Ka) {
                    return Ka.length === 0;
                  }))
                    for (var Qt = 0; Qt < Ia.length; Qt++)
                      Dr(Yt ? Yt[Qt] : ui, Ia[Qt]);
                }
                function ja(lt, it) {
                  if (e2.getObjectFlags(lt) & 4 && e2.getObjectFlags(it) & 4 && (lt.target === it.target || Tu(lt) && Tu(it))) {
                    Ci(xo(lt), xo(it), zD(lt.target));
                    return;
                  }
                  if (Bc(lt) && Bc(it)) {
                    Dr(Mu(lt), Mu(it)), Dr(vl(lt), vl(it));
                    var Yt = Jl(lt), Ia = Jl(it);
                    Yt && Ia && Dr(Yt, Ia);
                  }
                  if (e2.getObjectFlags(it) & 32 && !it.declaration.nameType) {
                    var Qt = Mu(it);
                    if (Ra(lt, it, Qt))
                      return;
                  }
                  if (!Kw(lt, it)) {
                    if (Pd(lt)) {
                      if (Yn(it)) {
                        var Ka = $_(lt), cn = $_(it), Un = xo(it), oa = it.target.elementFlags;
                        if (Yn(lt) && Nw(lt, it)) {
                          for (var Mn = 0; Mn < cn; Mn++)
                            Dr(xo(lt)[Mn], Un[Mn]);
                          return;
                        }
                        for (var Ln = Yn(lt) ? Math.min(lt.target.fixedLength, it.target.fixedLength) : 0, ci = Math.min(Yn(lt) ? Sh(lt.target, 3) : 0, it.target.hasRestElement ? Sh(it.target, 3) : 0), Mn = 0; Mn < Ln; Mn++)
                          Dr(xo(lt)[Mn], Un[Mn]);
                        if (!Yn(lt) || Ka - Ln - ci === 1 && lt.target.elementFlags[Ln] & 4)
                          for (var Fr = xo(lt)[Ln], Mn = Ln; Mn < cn - ci; Mn++)
                            Dr(oa[Mn] & 8 ? Zs(Fr) : Fr, Un[Mn]);
                        else {
                          var jt = cn - Ln - ci;
                          if (jt === 2 && oa[Ln] & oa[Ln + 1] & 8 && Yn(lt)) {
                            var Lt = Zi(Un[Ln]);
                            Lt && Lt.impliedArity !== void 0 && (Dr(Zm(lt, Ln, ci + Ka - Lt.impliedArity), Un[Ln]), Dr(Zm(lt, Ln + Lt.impliedArity, ci), Un[Ln + 1]));
                          } else if (jt === 1 && oa[Ln] & 8) {
                            var ea = it.target.elementFlags[cn - 1] & 2, Kt = Yn(lt) ? Zm(lt, Ln, ci) : Zs(xo(lt)[0]);
                            Qr(Kt, Un[Ln], ea ? 2 : 0);
                          } else if (jt === 1 && oa[Ln] & 4) {
                            var Fr = Yn(lt) ? jh(lt, Ln, ci) : xo(lt)[0];
                            Fr && Dr(Fr, Un[Ln]);
                          }
                        }
                        for (var Mn = 0; Mn < ci; Mn++)
                          Dr(xo(lt)[Ka - Mn - 1], Un[cn - Mn - 1]);
                        return;
                      }
                      if (Tu(it)) {
                        Eo(lt, it);
                        return;
                      }
                    }
                    Fn(lt, it), wn(lt, it, 0), wn(lt, it, 1), Eo(lt, it);
                  }
                }
                function Fn(lt, it) {
                  for (var Yt = Pf(it), Ia = 0, Qt = Yt; Ia < Qt.length; Ia++) {
                    var Ka = Qt[Ia], cn = bi(lt, Ka.escapedName);
                    cn && !e2.some(cn.declarations, ub) && Dr(Jt(cn), Jt(Ka));
                  }
                }
                function wn(lt, it, Yt) {
                  for (var Ia = ot(lt, Yt), Qt = ot(it, Yt), Ka = Ia.length, cn = Qt.length, Un = Ka < cn ? Ka : cn, oa = !!(e2.getObjectFlags(lt) & 262144), Mn = 0; Mn < Un; Mn++)
                    Tn(v3(Ia[Ka - Un + Mn]), Qm(Qt[cn - Un + Mn]), oa);
                }
                function Tn(lt, it, Yt) {
                  if (!Yt) {
                    var Ia = u, Qt = it.declaration ? it.declaration.kind : 0;
                    u = u || Qt === 169 || Qt === 168 || Qt === 171, eb(lt, it, $i), u = Ia;
                  }
                  rb(lt, it, Dr);
                }
                function Eo(lt, it) {
                  var Yt = e2.getObjectFlags(lt) & e2.getObjectFlags(it) & 32 ? 8 : 0, Ia = Hn(it);
                  if (qh(lt))
                    for (var Qt = 0, Ka = Ia; Qt < Ka.length; Qt++) {
                      for (var cn = Ka[Qt], Un = [], oa = 0, Mn = uo(lt); oa < Mn.length; oa++) {
                        var Ln = Mn[oa];
                        if (an(om(Ln, 8576), cn.keyType)) {
                          var ci = Jt(Ln);
                          Un.push(Ln.flags & 16777216 ? $D(ci) : ci);
                        }
                      }
                      for (var Fr = 0, jt = Hn(lt); Fr < jt.length; Fr++) {
                        var Lt = jt[Fr];
                        an(Lt.keyType, cn.keyType) && Un.push(Lt.type);
                      }
                      Un.length && Qr(Pa(Un), cn.type, Yt);
                    }
                  for (var ea = 0, Kt = Ia; ea < Kt.length; ea++) {
                    var cn = Kt[ea], $t = nu(lt, cn.keyType);
                    $t && Qr($t.type, cn.type, Yt);
                  }
                }
              }
              function Yw(r2, i2) {
                return yr && i2 === Yi ? r2 === i2 : wf(r2, i2) || !!(i2.flags & 4 && r2.flags & 128 || i2.flags & 8 && r2.flags & 256);
              }
              function $w(r2, i2) {
                return !!(r2.flags & 524288 && i2.flags & 524288 && r2.symbol && r2.symbol === i2.symbol || r2.aliasSymbol && r2.aliasTypeArguments && r2.aliasSymbol === i2.aliasSymbol);
              }
              function Zw(r2) {
                var i2 = Tc(r2);
                return !!i2 && fs4(i2.flags & 16777216 ? zm(i2) : i2, 406978556);
              }
              function Qp(r2) {
                return !!(e2.getObjectFlags(r2) & 128);
              }
              function lb(r2) {
                return !!(e2.getObjectFlags(r2) & 16512);
              }
              function e8(r2) {
                if (r2.length > 1) {
                  var i2 = e2.filter(r2, lb);
                  if (i2.length) {
                    var t2 = Pa(i2, 2);
                    return e2.concatenate(e2.filter(r2, function(o) {
                      return !lb(o);
                    }), [t2]);
                  }
                }
                return r2;
              }
              function r8(r2) {
                return r2.priority & 416 ? Do(r2.contraCandidates) : Tw(r2.contraCandidates);
              }
              function i8(r2, i2) {
                var t2 = e8(r2.candidates), o = Zw(r2.typeParameter), s2 = !o && r2.topLevel && (r2.isFixed || !nb(yo(i2), r2.typeParameter)), u = o ? e2.sameMap(t2, jc) : s2 ? e2.sameMap(t2, Hp) : t2, h2 = r2.priority & 416 ? Pa(u, 2) : Sw(u);
                return $c(h2);
              }
              function GE(r2, i2) {
                var t2 = r2.inferences[i2];
                if (!t2.inferredType) {
                  var o = void 0, s2 = r2.signature;
                  if (s2) {
                    var u = t2.candidates ? i8(t2, s2) : void 0;
                    if (t2.contraCandidates)
                      o = u && !(u.flags & 131072) && e2.some(t2.contraCandidates, function(Me) {
                        return E_(u, Me);
                      }) ? u : r8(t2);
                    else if (u)
                      o = u;
                    else if (r2.flags & 1)
                      o = Bt;
                    else {
                      var h2 = D_(t2.typeParameter);
                      h2 && (o = un(h2, LI(MI(r2, i2), r2.nonFixingMapper)));
                    }
                  } else
                    o = zE(t2);
                  t2.inferredType = o || fb(!!(r2.flags & 2));
                  var z = Tc(t2.typeParameter);
                  if (z) {
                    var me = un(z, r2.nonFixingMapper);
                    (!o || !r2.compareTypes(o, Rc(me, o))) && (t2.inferredType = o = me);
                  }
                }
                return t2.inferredType;
              }
              function fb(r2) {
                return r2 ? Oe : gr;
              }
              function _b(r2) {
                for (var i2 = [], t2 = 0; t2 < r2.inferences.length; t2++)
                  i2.push(GE(r2, t2));
                return i2;
              }
              function HE(r2) {
                switch (r2.escapedText) {
                  case "document":
                  case "console":
                    return e2.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_include_dom;
                  case "$":
                    return ye.types ? e2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery_and_then_add_jquery_to_the_types_field_in_your_tsconfig : e2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_jQuery_Try_npm_i_save_dev_types_Slashjquery;
                  case "describe":
                  case "suite":
                  case "it":
                  case "test":
                    return ye.types ? e2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha_and_then_add_jest_or_mocha_to_the_types_field_in_your_tsconfig : e2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_a_test_runner_Try_npm_i_save_dev_types_Slashjest_or_npm_i_save_dev_types_Slashmocha;
                  case "process":
                  case "require":
                  case "Buffer":
                  case "module":
                    return ye.types ? e2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode_and_then_add_node_to_the_types_field_in_your_tsconfig : e2.Diagnostics.Cannot_find_name_0_Do_you_need_to_install_type_definitions_for_node_Try_npm_i_save_dev_types_Slashnode;
                  case "Map":
                  case "Set":
                  case "Promise":
                  case "Symbol":
                  case "WeakMap":
                  case "WeakSet":
                  case "Iterator":
                  case "AsyncIterator":
                  case "SharedArrayBuffer":
                  case "Atomics":
                  case "AsyncIterable":
                  case "AsyncIterableIterator":
                  case "AsyncGenerator":
                  case "AsyncGeneratorFunction":
                  case "BigInt":
                  case "Reflect":
                  case "BigInt64Array":
                  case "BigUint64Array":
                    return e2.Diagnostics.Cannot_find_name_0_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_1_or_later;
                  case "await":
                    if (e2.isCallExpression(r2.parent))
                      return e2.Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function;
                  default:
                    return r2.parent.kind === 297 ? e2.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer : e2.Diagnostics.Cannot_find_name_0;
                }
              }
              function Dl(r2) {
                var i2 = va(r2);
                return i2.resolvedSymbol || (i2.resolvedSymbol = !e2.nodeIsMissing(r2) && es(r2, r2.escapedText, 1160127, HE(r2), r2, !e2.isWriteOnlyAccess(r2), false) || xe), i2.resolvedSymbol;
              }
              function _m(r2) {
                return !!e2.findAncestor(r2, function(i2) {
                  return i2.kind === 181 ? true : i2.kind === 79 || i2.kind === 161 ? false : "quit";
                });
              }
              function Xh(r2, i2, t2, o) {
                switch (r2.kind) {
                  case 79:
                    if (!e2.isThisInTypeQuery(r2)) {
                      var s2 = Dl(r2);
                      return s2 !== xe ? "".concat(o ? A2(o) : "-1", "|").concat(fu(i2), "|").concat(fu(t2), "|").concat(y(s2)) : void 0;
                    }
                  case 108:
                    return "0|".concat(o ? A2(o) : "-1", "|").concat(fu(i2), "|").concat(fu(t2));
                  case 230:
                  case 212:
                    return Xh(r2.expression, i2, t2, o);
                  case 161:
                    var u = Xh(r2.left, i2, t2, o);
                    return u && u + "." + r2.right.escapedText;
                  case 206:
                  case 207:
                    var h2 = wd(r2);
                    if (h2 !== void 0) {
                      var z = Xh(r2.expression, i2, t2, o);
                      return z && z + "." + h2;
                    }
                }
              }
              function zs(r2, i2) {
                switch (i2.kind) {
                  case 212:
                  case 230:
                    return zs(r2, i2.expression);
                  case 221:
                    return e2.isAssignmentExpression(i2) && zs(r2, i2.left) || e2.isBinaryExpression(i2) && i2.operatorToken.kind === 27 && zs(r2, i2.right);
                }
                switch (r2.kind) {
                  case 231:
                    return i2.kind === 231 && r2.keywordToken === i2.keywordToken && r2.name.escapedText === i2.name.escapedText;
                  case 79:
                  case 80:
                    return e2.isThisInTypeQuery(r2) ? i2.kind === 108 : i2.kind === 79 && Dl(r2) === Dl(i2) || (i2.kind === 254 || i2.kind === 203) && cu(Dl(r2)) === Et(i2);
                  case 108:
                    return i2.kind === 108;
                  case 106:
                    return i2.kind === 106;
                  case 230:
                  case 212:
                    return zs(r2.expression, i2);
                  case 206:
                  case 207:
                    var t2 = wd(r2), o = e2.isAccessExpression(i2) ? wd(i2) : void 0;
                    return t2 !== void 0 && o !== void 0 && o === t2 && zs(r2.expression, i2.expression);
                  case 161:
                    return e2.isAccessExpression(i2) && r2.right.escapedText === wd(i2) && zs(r2.left, i2.expression);
                  case 221:
                    return e2.isBinaryExpression(r2) && r2.operatorToken.kind === 27 && zs(r2.right, i2);
                }
                return false;
              }
              function wd(r2) {
                if (e2.isPropertyAccessExpression(r2))
                  return r2.name.escapedText;
                if (e2.isElementAccessExpression(r2))
                  return t8(r2);
                if (e2.isBindingElement(r2)) {
                  var i2 = sf(r2);
                  return i2 ? e2.escapeLeadingUnderscores(i2) : void 0;
                }
                if (e2.isParameter(r2))
                  return "" + r2.parent.parameters.indexOf(r2);
              }
              function XE(r2) {
                return r2.flags & 8192 ? r2.escapedName : r2.flags & 384 ? e2.escapeLeadingUnderscores("" + r2.value) : void 0;
              }
              function t8(r2) {
                if (e2.isStringOrNumericLiteralLike(r2.argumentExpression))
                  return e2.escapeLeadingUnderscores(r2.argumentExpression.text);
                if (e2.isEntityNameExpression(r2.argumentExpression)) {
                  var i2 = Ds(r2.argumentExpression, 111551, true);
                  if (!i2 || !pv(i2))
                    return;
                  var t2 = i2.valueDeclaration;
                  if (t2 === void 0)
                    return;
                  var o = Rl(t2);
                  if (o) {
                    var s2 = XE(o);
                    if (s2 !== void 0)
                      return s2;
                  }
                  if (e2.hasOnlyExpressionInitializer(t2)) {
                    var u = e2.getEffectiveInitializer(t2);
                    return u && XE(Gs(u));
                  }
                }
              }
              function QE(r2, i2) {
                for (; e2.isAccessExpression(r2); )
                  if (r2 = r2.expression, zs(r2, i2))
                    return true;
                return false;
              }
              function Ag(r2, i2) {
                for (; e2.isOptionalChain(r2); )
                  if (r2 = r2.expression, zs(r2, i2))
                    return true;
                return false;
              }
              function lv(r2, i2) {
                if (r2 && r2.flags & 1048576) {
                  var t2 = $v(r2, i2);
                  if (t2 && e2.getCheckFlags(t2) & 2)
                    return t2.isDiscriminantProperty === void 0 && (t2.isDiscriminantProperty = (t2.checkFlags & 192) === 192 && !rv(Jt(t2))), !!t2.isDiscriminantProperty;
                }
                return false;
              }
              function YE(r2, i2) {
                for (var t2, o = 0, s2 = r2; o < s2.length; o++) {
                  var u = s2[o];
                  if (lv(i2, u.escapedName)) {
                    if (t2) {
                      t2.push(u);
                      continue;
                    }
                    t2 = [u];
                  }
                }
                return t2;
              }
              function a8(r2, i2) {
                for (var t2 = new e2.Map(), o = 0, s2 = function(Me) {
                  if (Me.flags & 61603840) {
                    var $e = da(Me, i2);
                    if ($e) {
                      if (!Cg($e))
                        return { value: void 0 };
                      var tr = false;
                      Od($e, function(dr) {
                        var Dr = fu(jc(dr)), Qr = t2.get(Dr);
                        Qr ? Qr !== gr && (t2.set(Dr, gr), tr = true) : t2.set(Dr, Me);
                      }), tr || o++;
                    }
                  }
                }, u = 0, h2 = r2; u < h2.length; u++) {
                  var z = h2[u], me = s2(z);
                  if (typeof me == "object")
                    return me.value;
                }
                return o >= 10 && o * 2 >= r2.length ? t2 : void 0;
              }
              function Qh(r2) {
                var i2 = r2.types;
                if (!(i2.length < 10 || e2.getObjectFlags(r2) & 32768 || e2.countWhere(i2, function(s2) {
                  return !!(s2.flags & 59506688);
                }) < 10)) {
                  if (r2.keyPropertyName === void 0) {
                    var t2 = e2.forEach(i2, function(s2) {
                      return s2.flags & 59506688 ? e2.forEach(uo(s2), function(u) {
                        return Vl(Jt(u)) ? u.escapedName : void 0;
                      }) : void 0;
                    }), o = t2 && a8(i2, t2);
                    r2.keyPropertyName = o ? t2 : "", r2.constituentMap = o;
                  }
                  return r2.keyPropertyName.length ? r2.keyPropertyName : void 0;
                }
              }
              function Yh(r2, i2) {
                var t2, o = (t2 = r2.constituentMap) === null || t2 === void 0 ? void 0 : t2.get(fu(jc(i2)));
                return o !== gr ? o : void 0;
              }
              function $E(r2, i2) {
                var t2 = Qh(r2), o = t2 && da(i2, t2);
                return o && Yh(r2, o);
              }
              function n8(r2, i2) {
                var t2 = Qh(r2), o = t2 && e2.find(i2.properties, function(u) {
                  return u.symbol && u.kind === 296 && u.symbol.escapedName === t2 && hy(u.initializer);
                }), s2 = o && Oy(o.initializer);
                return s2 && Yh(r2, s2);
              }
              function ZE(r2, i2) {
                return zs(r2, i2) || QE(r2, i2);
              }
              function eC(r2, i2) {
                if (r2.arguments)
                  for (var t2 = 0, o = r2.arguments; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (ZE(i2, s2))
                      return true;
                  }
                return !!(r2.expression.kind === 206 && ZE(i2, r2.expression.expression));
              }
              function pb(r2) {
                return (!r2.id || r2.id < 0) && (r2.id = Q, Q++), r2.id;
              }
              function o8(r2, i2) {
                if (!(r2.flags & 1048576))
                  return ao(r2, i2);
                for (var t2 = 0, o = r2.types; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  if (ao(s2, i2))
                    return true;
                }
                return false;
              }
              function s8(r2, i2) {
                if (r2 !== i2) {
                  if (i2.flags & 131072)
                    return i2;
                  var t2 = ec(r2, function(o) {
                    return o8(i2, o);
                  });
                  if (i2.flags & 512 && Kp(i2) && (t2 = Ss(t2, Sg)), ao(i2, t2))
                    return t2;
                }
                return r2;
              }
              function db(r2) {
                var i2 = Ru(r2);
                return !!(i2.callSignatures.length || i2.constructSignatures.length || i2.members.get("bind") && E_(r2, br));
              }
              function cp(r2, i2) {
                i2 === void 0 && (i2 = false);
                var t2 = r2.flags;
                if (t2 & 4)
                  return Ye ? 16317953 : 16776705;
                if (t2 & 128) {
                  var o = r2.value === "";
                  return Ye ? o ? 12123649 : 7929345 : o ? 12582401 : 16776705;
                }
                if (t2 & 40)
                  return Ye ? 16317698 : 16776450;
                if (t2 & 256) {
                  var s2 = r2.value === 0;
                  return Ye ? s2 ? 12123394 : 7929090 : s2 ? 12582146 : 16776450;
                }
                if (t2 & 64)
                  return Ye ? 16317188 : 16775940;
                if (t2 & 2048) {
                  var s2 = QD(r2);
                  return Ye ? s2 ? 12122884 : 7928580 : s2 ? 12581636 : 16775940;
                }
                return t2 & 16 ? Ye ? 16316168 : 16774920 : t2 & 528 ? Ye ? r2 === xt || r2 === ut ? 12121864 : 7927560 : r2 === xt || r2 === ut ? 12580616 : 16774920 : t2 & 524288 ? i2 ? 16768959 : e2.getObjectFlags(r2) & 16 && Of(r2) ? Ye ? 16318463 : 16777215 : db(r2) ? Ye ? 7880640 : 16728e3 : Ye ? 7888800 : 16736160 : t2 & 49152 ? 9830144 : t2 & 65536 ? 9363232 : t2 & 12288 ? Ye ? 7925520 : 16772880 : t2 & 67108864 ? Ye ? 7888800 : 16736160 : t2 & 131072 ? 0 : t2 & 465829888 ? sm(r2) ? Ye ? 7929345 : 16776705 : cp(uc(r2) || gr, i2) : t2 & 1048576 ? e2.reduceLeft(r2.types, function(u, h2) {
                  return u | cp(h2, i2);
                }, 0) : t2 & 2097152 ? (i2 || (i2 = fs4(r2, 131068)), c8(r2, i2)) : 16777215;
              }
              function c8(r2, i2) {
                for (var t2 = 0, o = 16777215, s2 = 0, u = r2.types; s2 < u.length; s2++) {
                  var h2 = u[s2], z = cp(h2, i2);
                  t2 |= z, o &= z;
                }
                return t2 & 8256 | o & 16768959;
              }
              function Ks(r2, i2) {
                return ec(r2, function(t2) {
                  return (cp(t2) & i2) !== 0;
                });
              }
              function gb(r2, i2) {
                return i2 ? Pa([uu(r2), Gs(i2)]) : r2;
              }
              function rC(r2, i2) {
                var t2, o = Z_(i2);
                if (!_f(o))
                  return Pe;
                var s2 = pf(o);
                return da(r2, s2) || fv((t2 = Xo(r2, s2)) === null || t2 === void 0 ? void 0 : t2.type) || Pe;
              }
              function iC(r2, i2) {
                return gf(r2, Eg) && xw(r2, i2) || fv(N_(65, r2, Tr, void 0)) || Pe;
              }
              function fv(r2) {
                return r2 && (ye.noUncheckedIndexedAccess ? Pa([r2, Tr]) : r2);
              }
              function tC(r2) {
                return Zs(N_(65, r2, Tr, void 0) || Pe);
              }
              function u8(r2) {
                var i2 = r2.parent.kind === 204 && mb(r2.parent) || r2.parent.kind === 296 && mb(r2.parent.parent);
                return i2 ? gb(py(r2), r2.right) : Gs(r2.right);
              }
              function mb(r2) {
                return r2.parent.kind === 221 && r2.parent.left === r2 || r2.parent.kind === 244 && r2.parent.initializer === r2;
              }
              function l8(r2, i2) {
                return iC(py(r2), r2.elements.indexOf(i2));
              }
              function f8(r2) {
                return tC(py(r2.parent));
              }
              function aC(r2) {
                return rC(py(r2.parent), r2.name);
              }
              function _8(r2) {
                return gb(aC(r2), r2.objectAssignmentInitializer);
              }
              function py(r2) {
                var i2 = r2.parent;
                switch (i2.kind) {
                  case 243:
                    return Li;
                  case 244:
                    return By(i2) || Pe;
                  case 221:
                    return u8(i2);
                  case 215:
                    return Tr;
                  case 204:
                    return l8(i2, r2);
                  case 225:
                    return f8(i2);
                  case 296:
                    return aC(i2);
                  case 297:
                    return _8(i2);
                }
                return Pe;
              }
              function p8(r2) {
                var i2 = r2.parent, t2 = oC(i2.parent), o = i2.kind === 201 ? rC(t2, r2.propertyName || r2.name) : r2.dotDotDotToken ? tC(t2) : iC(t2, i2.elements.indexOf(r2));
                return gb(o, r2.initializer);
              }
              function nC(r2) {
                var i2 = va(r2);
                return i2.resolvedType || Gs(r2);
              }
              function d8(r2) {
                return r2.initializer ? nC(r2.initializer) : r2.parent.parent.kind === 243 ? Li : r2.parent.parent.kind === 244 && By(r2.parent.parent) || Pe;
              }
              function oC(r2) {
                return r2.kind === 254 ? d8(r2) : p8(r2);
              }
              function g8(r2) {
                return r2.kind === 254 && r2.initializer && Hf(r2.initializer) || r2.kind !== 203 && r2.parent.kind === 221 && Hf(r2.parent.right);
              }
              function Yp(r2) {
                switch (r2.kind) {
                  case 212:
                    return Yp(r2.expression);
                  case 221:
                    switch (r2.operatorToken.kind) {
                      case 63:
                      case 75:
                      case 76:
                      case 77:
                        return Yp(r2.left);
                      case 27:
                        return Yp(r2.right);
                    }
                }
                return r2;
              }
              function sC(r2) {
                var i2 = r2.parent;
                return i2.kind === 212 || i2.kind === 221 && i2.operatorToken.kind === 63 && i2.left === r2 || i2.kind === 221 && i2.operatorToken.kind === 27 && i2.right === r2 ? sC(i2) : r2;
              }
              function m8(r2) {
                return r2.kind === 289 ? jc(Gs(r2.expression)) : ui;
              }
              function $h(r2) {
                var i2 = va(r2);
                if (!i2.switchTypes) {
                  i2.switchTypes = [];
                  for (var t2 = 0, o = r2.caseBlock.clauses; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    i2.switchTypes.push(m8(s2));
                  }
                }
                return i2.switchTypes;
              }
              function cC(r2, i2) {
                for (var t2 = [], o = 0, s2 = r2.caseBlock.clauses; o < s2.length; o++) {
                  var u = s2[o];
                  if (u.kind === 289) {
                    if (e2.isStringLiteralLike(u.expression)) {
                      t2.push(u.expression.text);
                      continue;
                    }
                    return e2.emptyArray;
                  }
                  i2 && t2.push(void 0);
                }
                return t2;
              }
              function v8(r2, i2) {
                return r2.flags & 1048576 ? !e2.forEach(r2.types, function(t2) {
                  return !e2.contains(i2, t2);
                }) : e2.contains(i2, r2);
              }
              function dy(r2, i2) {
                return r2 === i2 || i2.flags & 1048576 && y8(r2, i2);
              }
              function y8(r2, i2) {
                if (r2.flags & 1048576) {
                  for (var t2 = 0, o = r2.types; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (!$f(i2.types, s2))
                      return false;
                  }
                  return true;
                }
                return r2.flags & 1024 && cc(r2) === i2 ? true : $f(i2.types, r2);
              }
              function Od(r2, i2) {
                return r2.flags & 1048576 ? e2.forEach(r2.types, i2) : i2(r2);
              }
              function rg(r2, i2) {
                return r2.flags & 1048576 ? e2.some(r2.types, i2) : i2(r2);
              }
              function gf(r2, i2) {
                return r2.flags & 1048576 ? e2.every(r2.types, i2) : i2(r2);
              }
              function h8(r2, i2) {
                return r2.flags & 3145728 ? e2.every(r2.types, i2) : i2(r2);
              }
              function ec(r2, i2) {
                if (r2.flags & 1048576) {
                  var t2 = r2.types, o = e2.filter(t2, i2);
                  if (o === t2)
                    return r2;
                  var s2 = r2.origin, u = void 0;
                  if (s2 && s2.flags & 1048576) {
                    var h2 = s2.types, z = e2.filter(h2, function(me) {
                      return !!(me.flags & 1048576) || i2(me);
                    });
                    if (h2.length - z.length === t2.length - o.length) {
                      if (z.length === 1)
                        return z[0];
                      u = fD(1048576, z);
                    }
                  }
                  return pD(o, r2.objectFlags, void 0, void 0, u);
                }
                return r2.flags & 131072 || i2(r2) ? r2 : ui;
              }
              function Zh(r2, i2) {
                return ec(r2, function(t2) {
                  return t2 !== i2;
                });
              }
              function D8(r2) {
                return r2.flags & 1048576 ? r2.types.length : 1;
              }
              function Ss(r2, i2, t2) {
                if (r2.flags & 131072)
                  return r2;
                if (!(r2.flags & 1048576))
                  return i2(r2);
                for (var o = r2.origin, s2 = o && o.flags & 1048576 ? o.types : r2.types, u, h2 = false, z = 0, me = s2; z < me.length; z++) {
                  var Me = me[z], $e = Me.flags & 1048576 ? Ss(Me, i2, t2) : i2(Me);
                  h2 || (h2 = Me !== $e), $e && (u ? u.push($e) : u = [$e]);
                }
                return h2 ? u && Pa(u, t2 ? 0 : 1) : r2;
              }
              function uC(r2, i2, t2, o) {
                return r2.flags & 1048576 && t2 ? Pa(e2.map(r2.types, i2), 1, t2, o) : Ss(r2, i2);
              }
              function Ng(r2, i2) {
                return ec(r2, function(t2) {
                  return (t2.flags & i2) !== 0;
                });
              }
              function lC(r2, i2) {
                return fs4(r2, 134217804) && fs4(i2, 402655616) ? Ss(r2, function(t2) {
                  return t2.flags & 4 ? Ng(i2, 402653316) : sm(t2) && !fs4(i2, 402653188) ? Ng(i2, 128) : t2.flags & 8 ? Ng(i2, 264) : t2.flags & 64 ? Ng(i2, 2112) : t2;
                }) : r2;
              }
              function Pg(r2) {
                return r2.flags === 0;
              }
              function Fd(r2) {
                return r2.flags === 0 ? r2.type : r2;
              }
              function Ig(r2, i2) {
                return i2 ? { flags: 0, type: r2.flags & 131072 ? Bt : r2 } : r2;
              }
              function b8(r2) {
                var i2 = tu(256);
                return i2.elementType = r2, i2;
              }
              function vb(r2) {
                return zr[r2.id] || (zr[r2.id] = b8(r2));
              }
              function fC(r2, i2) {
                var t2 = fm(Kl(Oy(i2)));
                return dy(t2, r2.elementType) ? r2 : vb(Pa([r2.elementType, t2]));
              }
              function S8(r2) {
                return r2.flags & 131072 ? So : Zs(r2.flags & 1048576 ? Pa(r2.types, 2) : r2);
              }
              function T8(r2) {
                return r2.finalArrayType || (r2.finalArrayType = S8(r2.elementType));
              }
              function e0(r2) {
                return e2.getObjectFlags(r2) & 256 ? T8(r2) : r2;
              }
              function x8(r2) {
                return e2.getObjectFlags(r2) & 256 ? r2.elementType : ui;
              }
              function E8(r2) {
                for (var i2 = false, t2 = 0, o = r2; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  if (!(s2.flags & 131072)) {
                    if (!(e2.getObjectFlags(s2) & 256))
                      return false;
                    i2 = true;
                  }
                }
                return i2;
              }
              function _C(r2) {
                var i2 = sC(r2), t2 = i2.parent, o = e2.isPropertyAccessExpression(t2) && (t2.name.escapedText === "length" || t2.parent.kind === 208 && e2.isIdentifier(t2.name) && e2.isPushOrUnshiftIdentifier(t2.name)), s2 = t2.kind === 207 && t2.expression === i2 && t2.parent.kind === 221 && t2.parent.operatorToken.kind === 63 && t2.parent.left === t2 && !e2.isAssignmentTarget(t2.parent) && Ns(Gs(t2.argumentExpression), 296);
                return o || s2;
              }
              function C8(r2) {
                return (e2.isVariableDeclaration(r2) || e2.isPropertyDeclaration(r2) || e2.isPropertySignature(r2) || e2.isParameter(r2)) && !!(e2.getEffectiveTypeAnnotationNode(r2) || e2.isInJSFile(r2) && e2.hasInitializer(r2) && r2.initializer && e2.isFunctionExpressionOrArrowFunction(r2.initializer) && e2.getEffectiveReturnTypeNode(r2.initializer));
              }
              function r0(r2, i2) {
                if (r2.flags & 8752)
                  return Jt(r2);
                if (r2.flags & 7) {
                  if (e2.getCheckFlags(r2) & 262144) {
                    var t2 = r2.syntheticOrigin;
                    if (t2 && r0(t2))
                      return Jt(r2);
                  }
                  var o = r2.valueDeclaration;
                  if (o) {
                    if (C8(o))
                      return Jt(r2);
                    if (e2.isVariableDeclaration(o) && o.parent.parent.kind === 244) {
                      var s2 = o.parent.parent, u = gy(s2.expression, void 0);
                      if (u) {
                        var h2 = s2.awaitModifier ? 15 : 13;
                        return N_(h2, u, Tr, void 0);
                      }
                    }
                    i2 && e2.addRelatedInfo(i2, e2.createDiagnosticForNode(o, e2.Diagnostics._0_needs_an_explicit_type_annotation, tn(r2)));
                  }
                }
              }
              function gy(r2, i2) {
                if (!(r2.flags & 33554432))
                  switch (r2.kind) {
                    case 79:
                      var t2 = cu(Dl(r2));
                      return r0(t2.flags & 2097152 ? Ps(t2) : t2, i2);
                    case 108:
                      return q8(r2);
                    case 106:
                      return Sb(r2);
                    case 206: {
                      var o = gy(r2.expression, i2);
                      if (o) {
                        var s2 = r2.name, u = void 0;
                        if (e2.isPrivateIdentifier(s2)) {
                          if (!o.symbol)
                            return;
                          u = bi(o, e2.getSymbolNameForPrivateIdentifier(o.symbol, s2.escapedText));
                        } else
                          u = bi(o, s2.escapedText);
                        return u && r0(u, i2);
                      }
                      return;
                    }
                    case 212:
                      return gy(r2.expression, i2);
                  }
              }
              function i0(r2) {
                var i2 = va(r2), t2 = i2.effectsSignature;
                if (t2 === void 0) {
                  var o = void 0;
                  r2.parent.kind === 238 ? o = gy(r2.expression, void 0) : r2.expression.kind !== 106 && (e2.isOptionalChain(r2) ? o = bl(cv(yn(r2.expression), r2.expression), r2.expression) : o = gm(r2.expression));
                  var s2 = ot(o && $s(o) || gr, 0), u = s2.length === 1 && !s2[0].typeParameters ? s2[0] : e2.some(s2, pC) ? Mg(r2) : void 0;
                  t2 = i2.effectsSignature = u && pC(u) ? u : Wn;
                }
                return t2 === Wn ? void 0 : t2;
              }
              function pC(r2) {
                return !!(Yc(r2) || r2.declaration && (yg(r2.declaration) || gr).flags & 131072);
              }
              function k8(r2, i2) {
                if (r2.kind === 1 || r2.kind === 3)
                  return i2.arguments[r2.parameterIndex];
                var t2 = e2.skipParentheses(i2.expression);
                return e2.isAccessExpression(t2) ? e2.skipParentheses(t2.expression) : void 0;
              }
              function A8(r2) {
                var i2 = e2.findAncestor(r2, e2.isFunctionOrModuleBlock), t2 = e2.getSourceFileOfNode(r2), o = e2.getSpanOfTokenAtPosition(t2, i2.statements.pos);
                rn.add(e2.createFileDiagnostic(t2, o.start, o.length, e2.Diagnostics.The_containing_function_or_module_body_is_too_large_for_control_flow_analysis));
              }
              function my(r2) {
                var i2 = t0(r2, false);
                return su = r2, tl = i2, i2;
              }
              function vy(r2) {
                var i2 = e2.skipParentheses(r2, true);
                return i2.kind === 95 || i2.kind === 221 && (i2.operatorToken.kind === 55 && (vy(i2.left) || vy(i2.right)) || i2.operatorToken.kind === 56 && vy(i2.left) && vy(i2.right));
              }
              function t0(r2, i2) {
                for (; ; ) {
                  if (r2 === su)
                    return tl;
                  var t2 = r2.flags;
                  if (t2 & 4096) {
                    if (!i2) {
                      var o = pb(r2), s2 = bt[o];
                      return s2 !== void 0 ? s2 : bt[o] = t0(r2, true);
                    }
                    i2 = false;
                  }
                  if (t2 & 368)
                    r2 = r2.antecedent;
                  else if (t2 & 512) {
                    var u = i0(r2.node);
                    if (u) {
                      var h2 = Yc(u);
                      if (h2 && h2.kind === 3 && !h2.type) {
                        var z = r2.node.arguments[h2.parameterIndex];
                        if (z && vy(z))
                          return false;
                      }
                      if (yo(u).flags & 131072)
                        return false;
                    }
                    r2 = r2.antecedent;
                  } else {
                    if (t2 & 4)
                      return e2.some(r2.antecedents, function(dr) {
                        return t0(dr, false);
                      });
                    if (t2 & 8) {
                      var me = r2.antecedents;
                      if (me === void 0 || me.length === 0)
                        return false;
                      r2 = me[0];
                    } else if (t2 & 128) {
                      if (r2.clauseStart === r2.clauseEnd && Lk(r2.switchStatement))
                        return false;
                      r2 = r2.antecedent;
                    } else if (t2 & 1024) {
                      su = void 0;
                      var Me = r2.target, $e = Me.antecedents;
                      Me.antecedents = r2.antecedents;
                      var tr = t0(r2.antecedent, false);
                      return Me.antecedents = $e, tr;
                    } else
                      return !(t2 & 1);
                  }
                }
              }
              function a0(r2, i2) {
                for (; ; ) {
                  var t2 = r2.flags;
                  if (t2 & 4096) {
                    if (!i2) {
                      var o = pb(r2), s2 = ia[o];
                      return s2 !== void 0 ? s2 : ia[o] = a0(r2, true);
                    }
                    i2 = false;
                  }
                  if (t2 & 496)
                    r2 = r2.antecedent;
                  else if (t2 & 512) {
                    if (r2.node.expression.kind === 106)
                      return true;
                    r2 = r2.antecedent;
                  } else {
                    if (t2 & 4)
                      return e2.every(r2.antecedents, function(me) {
                        return a0(me, false);
                      });
                    if (t2 & 8)
                      r2 = r2.antecedents[0];
                    else if (t2 & 1024) {
                      var u = r2.target, h2 = u.antecedents;
                      u.antecedents = r2.antecedents;
                      var z = a0(r2.antecedent, false);
                      return u.antecedents = h2, z;
                    } else
                      return !!(t2 & 1);
                  }
                }
              }
              function dC(r2) {
                switch (r2.kind) {
                  case 79: {
                    var i2 = Dl(r2);
                    return pv(i2) || e2.isParameterOrCatchClauseVariable(i2) && !n0(i2);
                  }
                  case 206:
                  case 207:
                    return dC(r2.expression) && Zu(va(r2).resolvedSymbol || xe);
                }
                return false;
              }
              function up(r2, i2, t2, o, s2) {
                t2 === void 0 && (t2 = i2), s2 === void 0 && (s2 = r2.flowNode);
                var u, h2 = false, z = 0;
                if (Bs)
                  return Pe;
                if (!s2)
                  return i2;
                xc++;
                var me = Ms, Me = Fd(dr(s2));
                Ms = me;
                var $e = e2.getObjectFlags(Me) & 256 && _C(r2) ? So : e0(Me);
                if ($e === Ai || r2.parent && r2.parent.kind === 230 && !($e.flags & 131072) && Ks($e, 2097152).flags & 131072)
                  return i2;
                return $e === Vr ? gr : $e;
                function tr() {
                  return h2 ? u : (h2 = true, u = Xh(r2, i2, t2, o));
                }
                function dr(Yr) {
                  if (z === 2e3)
                    return e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("checkTypes", "getTypeAtFlowNode_DepthLimit", { flowId: Yr.id }), Bs = true, A8(r2), Pe;
                  z++;
                  for (var Ni; ; ) {
                    var Hi = Yr.flags;
                    if (Hi & 4096) {
                      for (var _t = me; _t < Ms; _t++)
                        if (tt[_t] === Yr)
                          return z--, kt[_t];
                      Ni = Yr;
                    }
                    var gt = void 0;
                    if (Hi & 16) {
                      if (gt = Qr(Yr), !gt) {
                        Yr = Yr.antecedent;
                        continue;
                      }
                    } else if (Hi & 512) {
                      if (gt = Ti(Yr), !gt) {
                        Yr = Yr.antecedent;
                        continue;
                      }
                    } else if (Hi & 96)
                      gt = $i(Yr);
                    else if (Hi & 128)
                      gt = Zi(Yr);
                    else if (Hi & 12) {
                      if (Yr.antecedents.length === 1) {
                        Yr = Yr.antecedents[0];
                        continue;
                      }
                      gt = Hi & 4 ? qt(Yr) : Nt(Yr);
                    } else if (Hi & 256) {
                      if (gt = Ci(Yr), !gt) {
                        Yr = Yr.antecedent;
                        continue;
                      }
                    } else if (Hi & 1024) {
                      var Vt = Yr.target, Fa = Vt.antecedents;
                      Vt.antecedents = Yr.antecedents, gt = dr(Yr.antecedent), Vt.antecedents = Fa;
                    } else if (Hi & 2) {
                      var on = Yr.node;
                      if (on && on !== o && r2.kind !== 206 && r2.kind !== 207 && r2.kind !== 108) {
                        Yr = on.flowNode;
                        continue;
                      }
                      gt = t2;
                    } else
                      gt = kv(i2);
                    return Ni && (tt[Ms] = Ni, kt[Ms] = gt, Ms++), z--, gt;
                  }
                }
                function Dr(Yr) {
                  var Ni = Yr.node;
                  return yb(Ni.kind === 254 || Ni.kind === 203 ? oC(Ni) : py(Ni), r2);
                }
                function Qr(Yr) {
                  var Ni = Yr.node;
                  if (zs(r2, Ni)) {
                    if (!my(Yr))
                      return Ai;
                    if (e2.getAssignmentTargetKind(Ni) === 2) {
                      var Hi = dr(Yr.antecedent);
                      return Ig(Kl(Fd(Hi)), Pg(Hi));
                    }
                    if (i2 === nr || i2 === So) {
                      if (g8(Ni))
                        return vb(ui);
                      var _t = Hp(Dr(Yr));
                      return ao(_t, i2) ? _t : mo;
                    }
                    return i2.flags & 1048576 ? s8(i2, Dr(Yr)) : i2;
                  }
                  if (QE(r2, Ni)) {
                    if (!my(Yr))
                      return Ai;
                    if (e2.isVariableDeclaration(Ni) && (e2.isInJSFile(Ni) || e2.isVarConst(Ni))) {
                      var gt = e2.getDeclaredExpandoInitializer(Ni);
                      if (gt && (gt.kind === 213 || gt.kind === 214))
                        return dr(Yr.antecedent);
                    }
                    return i2;
                  }
                  if (e2.isVariableDeclaration(Ni) && Ni.parent.parent.kind === 243 && zs(r2, Ni.parent.parent.expression))
                    return jb(Fd(dr(Yr.antecedent)));
                }
                function li(Yr, Ni) {
                  var Hi = e2.skipParentheses(Ni, true);
                  if (Hi.kind === 95)
                    return Ai;
                  if (Hi.kind === 221) {
                    if (Hi.operatorToken.kind === 55)
                      return li(li(Yr, Hi.left), Hi.right);
                    if (Hi.operatorToken.kind === 56)
                      return Pa([li(Yr, Hi.left), li(Yr, Hi.right)]);
                  }
                  return $t(Yr, Hi, true);
                }
                function Ti(Yr) {
                  var Ni = i0(Yr.node);
                  if (Ni) {
                    var Hi = Yc(Ni);
                    if (Hi && (Hi.kind === 2 || Hi.kind === 3)) {
                      var _t = dr(Yr.antecedent), gt = e0(Fd(_t)), Vt = Hi.type ? Kt(gt, Hi, Yr.node, true) : Hi.kind === 3 && Hi.parameterIndex >= 0 && Hi.parameterIndex < Yr.node.arguments.length ? li(gt, Yr.node.arguments[Hi.parameterIndex]) : gt;
                      return Vt === gt ? _t : Ig(Vt, Pg(_t));
                    }
                    if (yo(Ni).flags & 131072)
                      return Ai;
                  }
                }
                function Ci(Yr) {
                  if (i2 === nr || i2 === So) {
                    var Ni = Yr.node, Hi = Ni.kind === 208 ? Ni.expression.expression : Ni.left.expression;
                    if (zs(r2, Yp(Hi))) {
                      var _t = dr(Yr.antecedent), gt = Fd(_t);
                      if (e2.getObjectFlags(gt) & 256) {
                        var Vt = gt;
                        if (Ni.kind === 208)
                          for (var Fa = 0, on = Ni.arguments; Fa < on.length; Fa++) {
                            var zn = on[Fa];
                            Vt = fC(Vt, zn);
                          }
                        else {
                          var Ga = Oy(Ni.left.argumentExpression);
                          Ns(Ga, 296) && (Vt = fC(Vt, Ni.right));
                        }
                        return Vt === gt ? _t : Ig(Vt, Pg(_t));
                      }
                      return _t;
                    }
                  }
                }
                function $i(Yr) {
                  var Ni = dr(Yr.antecedent), Hi = Fd(Ni);
                  if (Hi.flags & 131072)
                    return Ni;
                  var _t = (Yr.flags & 32) !== 0, gt = e0(Hi), Vt = $t(gt, Yr.node, _t);
                  return Vt === gt ? Ni : Ig(Vt, Pg(Ni));
                }
                function Zi(Yr) {
                  var Ni = Yr.switchStatement.expression, Hi = dr(Yr.antecedent), _t = Fd(Hi);
                  if (zs(r2, Ni))
                    _t = Un(_t, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd);
                  else if (Ni.kind === 216 && zs(r2, Ni.expression))
                    _t = Ln(_t, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd);
                  else {
                    Ye && (Ag(Ni, r2) ? _t = cn(_t, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd, function(Vt) {
                      return !(Vt.flags & 163840);
                    }) : Ni.kind === 216 && Ag(Ni.expression, r2) && (_t = cn(_t, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd, function(Vt) {
                      return !(Vt.flags & 131072 || Vt.flags & 128 && Vt.value === "undefined");
                    })));
                    var gt = Sn(Ni, _t);
                    gt && (_t = wn(_t, gt, Yr.switchStatement, Yr.clauseStart, Yr.clauseEnd));
                  }
                  return Ig(_t, Pg(Hi));
                }
                function qt(Yr) {
                  for (var Ni = [], Hi = false, _t = false, gt, Vt = 0, Fa = Yr.antecedents; Vt < Fa.length; Vt++) {
                    var on = Fa[Vt];
                    if (!gt && on.flags & 128 && on.clauseStart === on.clauseEnd) {
                      gt = on;
                      continue;
                    }
                    var zn = dr(on), Ga = Fd(zn);
                    if (Ga === i2 && i2 === t2)
                      return Ga;
                    e2.pushIfUnique(Ni, Ga), dy(Ga, i2) || (Hi = true), Pg(zn) && (_t = true);
                  }
                  if (gt) {
                    var zn = dr(gt), Ga = Fd(zn);
                    if (!e2.contains(Ni, Ga) && !Lk(gt.switchStatement)) {
                      if (Ga === i2 && i2 === t2)
                        return Ga;
                      Ni.push(Ga), dy(Ga, i2) || (Hi = true), Pg(zn) && (_t = true);
                    }
                  }
                  return Ig(Ra(Ni, Hi ? 2 : 1), _t);
                }
                function Nt(Yr) {
                  var Ni = pb(Yr), Hi = vc[Ni] || (vc[Ni] = new e2.Map()), _t = tr();
                  if (!_t)
                    return i2;
                  var gt = Hi.get(_t);
                  if (gt)
                    return gt;
                  for (var Vt = ko; Vt < Ao; Vt++)
                    if (Kr[Vt] === Yr && _i[Vt] === _t && Ei[Vt].length)
                      return Ig(Ra(Ei[Vt], 1), true);
                  for (var Fa = [], on = false, zn, Ga = 0, Qn = Yr.antecedents; Ga < Qn.length; Ga++) {
                    var wo = Qn[Ga], Po = void 0;
                    if (!zn)
                      Po = zn = dr(wo);
                    else {
                      Kr[Ao] = Yr, _i[Ao] = _t, Ei[Ao] = Fa, Ao++;
                      var Uo = Zc;
                      Zc = void 0, Po = dr(wo), Zc = Uo, Ao--;
                      var Rs = Hi.get(_t);
                      if (Rs)
                        return Rs;
                    }
                    var Fs = Fd(Po);
                    if (e2.pushIfUnique(Fa, Fs), dy(Fs, i2) || (on = true), Fs === i2)
                      break;
                  }
                  var rc = Ra(Fa, on ? 2 : 1);
                  return Pg(zn) ? Ig(rc, true) : (Hi.set(_t, rc), rc);
                }
                function Ra(Yr, Ni) {
                  if (E8(Yr))
                    return vb(Pa(e2.map(Yr, x8)));
                  var Hi = Pa(e2.sameMap(Yr, e0), Ni);
                  return Hi !== i2 && Hi.flags & i2.flags & 1048576 && e2.arraysEqual(Hi.types, i2.types) ? i2 : Hi;
                }
                function ca(Yr) {
                  if (e2.isBindingPattern(r2) || e2.isFunctionExpressionOrArrowFunction(r2) || e2.isObjectLiteralMethod(r2)) {
                    if (e2.isIdentifier(Yr)) {
                      var Ni = Dl(Yr), Hi = Ni.valueDeclaration;
                      if (Hi && (e2.isBindingElement(Hi) || e2.isParameter(Hi)) && r2 === Hi.parent && !Hi.initializer && !Hi.dotDotDotToken)
                        return Hi;
                    }
                  } else if (e2.isAccessExpression(Yr)) {
                    if (zs(r2, Yr.expression))
                      return Yr;
                  } else if (e2.isIdentifier(Yr)) {
                    var Ni = Dl(Yr);
                    if (pv(Ni)) {
                      var Hi = Ni.valueDeclaration;
                      if (e2.isVariableDeclaration(Hi) && !Hi.type && Hi.initializer && e2.isAccessExpression(Hi.initializer) && zs(r2, Hi.initializer.expression))
                        return Hi.initializer;
                      if (e2.isBindingElement(Hi) && !Hi.initializer) {
                        var _t = Hi.parent.parent;
                        if (e2.isVariableDeclaration(_t) && !_t.type && _t.initializer && (e2.isIdentifier(_t.initializer) || e2.isAccessExpression(_t.initializer)) && zs(r2, _t.initializer))
                          return Hi;
                      }
                    }
                  }
                }
                function Sn(Yr, Ni) {
                  var Hi = i2.flags & 1048576 ? i2 : Ni;
                  if (Hi.flags & 1048576) {
                    var _t = ca(Yr);
                    if (_t) {
                      var gt = wd(_t);
                      if (gt && lv(Hi, gt))
                        return _t;
                    }
                  }
                }
                function ja(Yr, Ni, Hi) {
                  var _t = wd(Ni);
                  if (_t === void 0)
                    return Yr;
                  var gt = Ye && e2.isOptionalChain(Ni) && fs4(Yr, 98304), Vt = da(gt ? Ks(Yr, 2097152) : Yr, _t);
                  if (!Vt)
                    return Yr;
                  Vt = gt ? i_(Vt) : Vt;
                  var Fa = Hi(Vt);
                  return ec(Yr, function(on) {
                    var zn = Ha(on, _t);
                    return !(Fa.flags & 131072) && cm(Fa, zn);
                  });
                }
                function Fn(Yr, Ni, Hi, _t, gt) {
                  if ((Hi === 36 || Hi === 37) && Yr.flags & 1048576) {
                    var Vt = Qh(Yr);
                    if (Vt && Vt === wd(Ni)) {
                      var Fa = Yh(Yr, Gs(_t));
                      if (Fa)
                        return Hi === (gt ? 36 : 37) ? Fa : Vl(da(Fa, Vt) || gr) ? Zh(Yr, Fa) : Yr;
                    }
                  }
                  return ja(Yr, Ni, function(on) {
                    return Qt(on, Hi, _t, gt);
                  });
                }
                function wn(Yr, Ni, Hi, _t, gt) {
                  if (_t < gt && Yr.flags & 1048576 && Qh(Yr) === wd(Ni)) {
                    var Vt = $h(Hi).slice(_t, gt), Fa = Pa(e2.map(Vt, function(on) {
                      return Yh(Yr, on) || gr;
                    }));
                    if (Fa !== gr)
                      return Fa;
                  }
                  return ja(Yr, Ni, function(on) {
                    return Un(on, Hi, _t, gt);
                  });
                }
                function Tn(Yr, Ni, Hi) {
                  if (zs(r2, Ni))
                    return Yr.flags & 2 && Hi ? Vr : Ks(Yr, Hi ? 4194304 : 8388608);
                  Ye && Hi && Ag(Ni, r2) && (Yr = Ks(Yr, 2097152));
                  var _t = Sn(Ni, Yr);
                  return _t ? ja(Yr, _t, function(gt) {
                    return Ks(gt, Hi ? 4194304 : 8388608);
                  }) : Yr;
                }
                function Eo(Yr, Ni, Hi) {
                  var _t = bi(Yr, Ni);
                  return _t ? _t.flags & 16777216 ? true : Hi : Xo(Yr, Ni) ? true : !Hi;
                }
                function lt(Yr, Ni, Hi) {
                  return Yr.flags & 1048576 || Yr.flags & 524288 && i2 !== Yr || e2.isThisTypeParameter(Yr) || Yr.flags & 2097152 && e2.every(Yr.types, function(_t) {
                    return _t.symbol !== pe;
                  }) ? ec(Yr, function(_t) {
                    return Eo(_t, Ni, Hi);
                  }) : Yr;
                }
                function it(Yr, Ni, Hi) {
                  switch (Ni.operatorToken.kind) {
                    case 63:
                    case 75:
                    case 76:
                    case 77:
                      return Tn($t(Yr, Ni.right, Hi), Ni.left, Hi);
                    case 34:
                    case 35:
                    case 36:
                    case 37:
                      var _t = Ni.operatorToken.kind, gt = Yp(Ni.left), Vt = Yp(Ni.right);
                      if (gt.kind === 216 && e2.isStringLiteralLike(Vt))
                        return Ka(Yr, gt, _t, Vt, Hi);
                      if (Vt.kind === 216 && e2.isStringLiteralLike(gt))
                        return Ka(Yr, Vt, _t, gt, Hi);
                      if (zs(r2, gt))
                        return Qt(Yr, _t, Vt, Hi);
                      if (zs(r2, Vt))
                        return Qt(Yr, _t, gt, Hi);
                      Ye && (Ag(gt, r2) ? Yr = Ia(Yr, _t, Vt, Hi) : Ag(Vt, r2) && (Yr = Ia(Yr, _t, gt, Hi)));
                      var Fa = Sn(gt, Yr);
                      if (Fa)
                        return Fn(Yr, Fa, _t, Vt, Hi);
                      var on = Sn(Vt, Yr);
                      if (on)
                        return Fn(Yr, on, _t, gt, Hi);
                      if (ci(gt))
                        return Fr(Yr, _t, Vt, Hi);
                      if (ci(Vt))
                        return Fr(Yr, _t, gt, Hi);
                      break;
                    case 102:
                      return jt(Yr, Ni, Hi);
                    case 101:
                      if (e2.isPrivateIdentifier(Ni.left))
                        return Yt(Yr, Ni, Hi);
                      var zn = Yp(Ni.right), Ga = Bd(Ni.left);
                      if (Ga.flags & 128) {
                        var Qn = e2.escapeLeadingUnderscores(Ga.value);
                        if (Wh(Yr) && e2.isAccessExpression(r2) && zs(r2.expression, zn) && wd(r2) === Qn)
                          return Ks(Yr, Hi ? 524288 : 65536);
                        if (zs(r2, zn))
                          return lt(Yr, Qn, Hi);
                      }
                      break;
                    case 27:
                      return $t(Yr, Ni.right, Hi);
                    case 55:
                      return Hi ? $t($t(Yr, Ni.left, true), Ni.right, true) : Pa([$t(Yr, Ni.left, false), $t(Yr, Ni.right, false)]);
                    case 56:
                      return Hi ? Pa([$t(Yr, Ni.left, true), $t(Yr, Ni.right, true)]) : $t($t(Yr, Ni.left, false), Ni.right, false);
                  }
                  return Yr;
                }
                function Yt(Yr, Ni, Hi) {
                  var _t = Yp(Ni.right);
                  if (!zs(r2, _t))
                    return Yr;
                  e2.Debug.assertNode(Ni.left, e2.isPrivateIdentifier);
                  var gt = m0(Ni.left);
                  if (gt === void 0)
                    return Yr;
                  var Vt = gt.parent, Fa = e2.hasStaticModifier(e2.Debug.checkDefined(gt.valueDeclaration, "should always have a declaration")) ? Jt(Vt) : go(Vt);
                  return Lt(Yr, Fa, Hi, xg);
                }
                function Ia(Yr, Ni, Hi, _t) {
                  var gt = Ni === 34 || Ni === 36, Vt = Ni === 34 || Ni === 35 ? 98304 : 32768, Fa = Gs(Hi), on = gt !== _t && gf(Fa, function(zn) {
                    return !!(zn.flags & Vt);
                  }) || gt === _t && gf(Fa, function(zn) {
                    return !(zn.flags & (3 | Vt));
                  });
                  return on ? Ks(Yr, 2097152) : Yr;
                }
                function Qt(Yr, Ni, Hi, _t) {
                  if (Yr.flags & 1)
                    return Yr;
                  (Ni === 35 || Ni === 37) && (_t = !_t);
                  var gt = Gs(Hi);
                  if (_t && Yr.flags & 2 && (Ni === 34 || Ni === 35) && gt.flags & 65536)
                    return Pa([Wi, Tr]);
                  if (Yr.flags & 2 && _t && (Ni === 36 || Ni === 37))
                    return gt.flags & 67239932 ? gt : gt.flags & 524288 ? Oi : Yr;
                  if (gt.flags & 98304) {
                    if (!Ye)
                      return Yr;
                    var Vt = Ni === 34 || Ni === 35, Fa = Vt ? _t ? 262144 : 2097152 : gt.flags & 65536 ? _t ? 131072 : 1048576 : _t ? 65536 : 524288;
                    return Yr.flags & 2 && Fa & 3145728 ? Vr : Ks(Yr, Fa);
                  }
                  if (_t) {
                    var on = Ni === 34 ? function(zn) {
                      return Oh(zn, gt) || Ow(zn, gt);
                    } : function(zn) {
                      return Oh(zn, gt);
                    };
                    return lC(ec(Yr, on), gt);
                  }
                  return Vl(gt) ? ec(Yr, function(zn) {
                    return !(NE(zn) && Oh(zn, gt));
                  }) : Yr;
                }
                function Ka(Yr, Ni, Hi, _t, gt) {
                  (Hi === 35 || Hi === 37) && (gt = !gt);
                  var Vt = Yp(Ni.expression);
                  if (!zs(r2, Vt))
                    return Ye && Ag(Vt, r2) && gt === (_t.text !== "undefined") ? Ks(Yr, 2097152) : Yr;
                  if (Yr.flags & 1 && _t.text === "function")
                    return Yr;
                  if (gt && Yr.flags & 2 && _t.text === "object")
                    return Yr === Vr ? Oi : Pa([Oi, Wi]);
                  var Fa = gt ? G.get(_t.text) || 128 : oe.get(_t.text) || 32768, on = oa(Yr, _t.text);
                  return Ks(gt && on ? Ss(Yr, Mn(on)) : Yr, Fa);
                }
                function cn(Yr, Ni, Hi, _t, gt) {
                  var Vt = Hi !== _t && e2.every($h(Ni).slice(Hi, _t), gt);
                  return Vt ? Ks(Yr, 2097152) : Yr;
                }
                function Un(Yr, Ni, Hi, _t) {
                  var gt = $h(Ni);
                  if (!gt.length)
                    return Yr;
                  var Vt = gt.slice(Hi, _t), Fa = Hi === _t || e2.contains(Vt, ui);
                  if (Yr.flags & 2 && !Fa) {
                    for (var on = void 0, zn = 0; zn < Vt.length; zn += 1) {
                      var Ga = Vt[zn];
                      if (Ga.flags & 67239932)
                        on !== void 0 && on.push(Ga);
                      else if (Ga.flags & 524288)
                        on === void 0 && (on = Vt.slice(0, zn)), on.push(Oi);
                      else
                        return Yr;
                    }
                    return Pa(on === void 0 ? Vt : on);
                  }
                  var Qn = Pa(Vt), wo = Qn.flags & 131072 ? ui : lC(ec(Yr, function(Uo) {
                    return Oh(Qn, Uo);
                  }), Qn);
                  if (!Fa)
                    return wo;
                  var Po = ec(Yr, function(Uo) {
                    return !(NE(Uo) && e2.contains(gt, jc(Cw(Uo))));
                  });
                  return wo.flags & 131072 ? Po : Pa([wo, Po]);
                }
                function oa(Yr, Ni) {
                  switch (Ni) {
                    case "function":
                      return Yr.flags & 1 ? Yr : br;
                    case "object":
                      return Yr.flags & 2 ? Pa([Oi, Wi]) : Yr;
                    default:
                      return Mo.get(Ni);
                  }
                }
                function Mn(Yr) {
                  return function(Ni) {
                    if (E_(Ni, Yr))
                      return Ni;
                    if (E_(Yr, Ni))
                      return Yr;
                    if (Ni.flags & 465829888) {
                      var Hi = uc(Ni) || Oe;
                      if (E_(Yr, Hi))
                        return Do([Ni, Yr]);
                    }
                    return Ni;
                  };
                }
                function Ln(Yr, Ni, Hi, _t) {
                  var gt = cC(Ni, true);
                  if (!gt.length)
                    return Yr;
                  var Vt = e2.findIndex(gt, function(Uo) {
                    return Uo === void 0;
                  }), Fa = Hi === _t || Vt >= Hi && Vt < _t, on, zn;
                  if (Vt > -1) {
                    var Ga = gt.filter(function(Uo) {
                      return Uo !== void 0;
                    }), Qn = Vt < Hi ? Hi - 1 : Hi, wo = Vt < _t ? _t - 1 : _t;
                    on = Ga.slice(Qn, wo), zn = oS(Qn, wo, Ga, Fa);
                  } else
                    on = gt.slice(Hi, _t), zn = oS(Hi, _t, gt, Fa);
                  if (Fa)
                    return ec(Yr, function(Uo) {
                      return (cp(Uo) & zn) === zn;
                    });
                  var Po = Ks(Pa(on.map(function(Uo) {
                    return oa(Yr, Uo) || Yr;
                  })), zn);
                  return Ks(Ss(Yr, Mn(Po)), zn);
                }
                function ci(Yr) {
                  return (e2.isPropertyAccessExpression(Yr) && e2.idText(Yr.name) === "constructor" || e2.isElementAccessExpression(Yr) && e2.isStringLiteralLike(Yr.argumentExpression) && Yr.argumentExpression.text === "constructor") && zs(r2, Yr.expression);
                }
                function Fr(Yr, Ni, Hi, _t) {
                  if (_t ? Ni !== 34 && Ni !== 36 : Ni !== 35 && Ni !== 37)
                    return Yr;
                  var gt = Gs(Hi);
                  if (!JS(gt) && !qd(gt))
                    return Yr;
                  var Vt = bi(gt, "prototype");
                  if (!Vt)
                    return Yr;
                  var Fa = Jt(Vt), on = ta(Fa) ? void 0 : Fa;
                  if (!on || on === qe || on === br)
                    return Yr;
                  if (ta(Yr))
                    return on;
                  return ec(Yr, function(Ga) {
                    return zn(Ga, on);
                  });
                  function zn(Ga, Qn) {
                    return Ga.flags & 524288 && e2.getObjectFlags(Ga) & 1 || Qn.flags & 524288 && e2.getObjectFlags(Qn) & 1 ? Ga.symbol === Qn.symbol : E_(Ga, Qn);
                  }
                }
                function jt(Yr, Ni, Hi) {
                  var _t = Yp(Ni.left);
                  if (!zs(r2, _t))
                    return Hi && Ye && Ag(_t, r2) ? Ks(Yr, 2097152) : Yr;
                  var gt = Gs(Ni.right);
                  if (!xg(gt, br))
                    return Yr;
                  var Vt, Fa = bi(gt, "prototype");
                  if (Fa) {
                    var on = Jt(Fa);
                    ta(on) || (Vt = on);
                  }
                  if (ta(Yr) && (Vt === qe || Vt === br))
                    return Yr;
                  if (!Vt) {
                    var zn = ot(gt, 1);
                    Vt = zn.length ? Pa(e2.map(zn, function(Qn) {
                      return yo(Qm(Qn));
                    })) : Ba;
                  }
                  if (!Hi && gt.flags & 1048576) {
                    var Ga = e2.find(gt.types, function(Qn) {
                      return !qd(Qn);
                    });
                    if (!Ga)
                      return Yr;
                  }
                  return Lt(Yr, Vt, Hi, xg);
                }
                function Lt(Yr, Ni, Hi, _t) {
                  if (!Hi)
                    return ec(Yr, function(Vt) {
                      return !_t(Vt, Ni);
                    });
                  if (Yr.flags & 1048576) {
                    var gt = ec(Yr, function(Vt) {
                      return _t(Vt, Ni);
                    });
                    if (!(gt.flags & 131072))
                      return gt;
                  }
                  return E_(Ni, Yr) ? Ni : ao(Yr, Ni) ? Yr : ao(Ni, Yr) ? Ni : Do([Yr, Ni]);
                }
                function ea(Yr, Ni, Hi) {
                  if (eC(Ni, r2)) {
                    var _t = Hi || !e2.isCallChain(Ni) ? i0(Ni) : void 0, gt = _t && Yc(_t);
                    if (gt && (gt.kind === 0 || gt.kind === 1))
                      return Kt(Yr, gt, Ni, Hi);
                  }
                  if (Wh(Yr) && e2.isAccessExpression(r2) && e2.isPropertyAccessExpression(Ni.expression)) {
                    var Vt = Ni.expression;
                    if (zs(r2.expression, Yp(Vt.expression)) && e2.isIdentifier(Vt.name) && Vt.name.escapedText === "hasOwnProperty" && Ni.arguments.length === 1) {
                      var Fa = Ni.arguments[0];
                      if (e2.isStringLiteralLike(Fa) && wd(r2) === e2.escapeLeadingUnderscores(Fa.text))
                        return Ks(Yr, Hi ? 524288 : 65536);
                    }
                  }
                  return Yr;
                }
                function Kt(Yr, Ni, Hi, _t) {
                  if (Ni.type && !(ta(Yr) && (Ni.type === qe || Ni.type === br))) {
                    var gt = k8(Ni, Hi);
                    if (gt) {
                      if (zs(r2, gt))
                        return Lt(Yr, Ni.type, _t, E_);
                      Ye && _t && Ag(gt, r2) && !(cp(Ni.type) & 65536) && (Yr = Ks(Yr, 2097152));
                      var Vt = Sn(gt, Yr);
                      if (Vt)
                        return ja(Yr, Vt, function(Fa) {
                          return Lt(Fa, Ni.type, _t, E_);
                        });
                    }
                  }
                  return Yr;
                }
                function $t(Yr, Ni, Hi) {
                  if (e2.isExpressionOfOptionalChainRoot(Ni) || e2.isBinaryExpression(Ni.parent) && Ni.parent.operatorToken.kind === 60 && Ni.parent.left === Ni)
                    return Ua(Yr, Ni, Hi);
                  switch (Ni.kind) {
                    case 79:
                      if (!zs(r2, Ni) && rr < 5) {
                        var _t = Dl(Ni);
                        if (pv(_t)) {
                          var gt = _t.valueDeclaration;
                          if (gt && e2.isVariableDeclaration(gt) && !gt.type && gt.initializer && dC(r2)) {
                            rr++;
                            var Vt = $t(Yr, gt.initializer, Hi);
                            return rr--, Vt;
                          }
                        }
                      }
                    case 108:
                    case 106:
                    case 206:
                    case 207:
                      return Tn(Yr, Ni, Hi);
                    case 208:
                      return ea(Yr, Ni, Hi);
                    case 212:
                    case 230:
                      return $t(Yr, Ni.expression, Hi);
                    case 221:
                      return it(Yr, Ni, Hi);
                    case 219:
                      if (Ni.operator === 53)
                        return $t(Yr, Ni.operand, !Hi);
                      break;
                  }
                  return Yr;
                }
                function Ua(Yr, Ni, Hi) {
                  if (zs(r2, Ni))
                    return Ks(Yr, Hi ? 2097152 : 262144);
                  var _t = Sn(Ni, Yr);
                  return _t ? ja(Yr, _t, function(gt) {
                    return Ks(gt, Hi ? 2097152 : 262144);
                  }) : Yr;
                }
              }
              function N8(r2, i2) {
                if (r2 = r2.exportSymbol || r2, (i2.kind === 79 || i2.kind === 80) && (e2.isRightSideOfQualifiedNameOrPropertyAccess(i2) && (i2 = i2.parent), e2.isExpressionNode(i2) && (!e2.isAssignmentTarget(i2) || e2.isWriteAccess(i2)))) {
                  var t2 = Gs(i2);
                  if (cu(va(i2).resolvedSymbol) === r2)
                    return t2;
                }
                return e2.isDeclarationName(i2) && e2.isSetAccessor(i2.parent) && W(i2.parent) ? yt(i2.parent.symbol) : ml(r2);
              }
              function _v(r2) {
                return e2.findAncestor(r2.parent, function(i2) {
                  return e2.isFunctionLike(i2) && !e2.getImmediatelyInvokedFunctionExpression(i2) || i2.kind === 262 || i2.kind === 305 || i2.kind === 167;
                });
              }
              function n0(r2) {
                if (!r2.valueDeclaration)
                  return false;
                var i2 = e2.getRootDeclaration(r2.valueDeclaration).parent, t2 = va(i2);
                return t2.flags & 8388608 || (t2.flags |= 8388608, P8(i2) || gC(i2)), r2.isAssigned || false;
              }
              function P8(r2) {
                return !!e2.findAncestor(r2.parent, function(i2) {
                  return (e2.isFunctionLike(i2) || e2.isCatchClause(i2)) && !!(va(i2).flags & 8388608);
                });
              }
              function gC(r2) {
                if (r2.kind === 79) {
                  if (e2.isAssignmentTarget(r2)) {
                    var i2 = Dl(r2);
                    e2.isParameterOrCatchClauseVariable(i2) && (i2.isAssigned = true);
                  }
                } else
                  e2.forEachChild(r2, gC);
              }
              function pv(r2) {
                return r2.flags & 3 && (p0(r2) & 2) !== 0;
              }
              function I8(r2, i2) {
                if (yu(i2.symbol, 2)) {
                  var t2 = Ye && i2.kind === 164 && i2.initializer && ju(r2) & 32768 && !(ju(yn(i2.initializer)) & 32768);
                  return fi(), t2 ? Ks(r2, 524288) : r2;
                } else
                  return lg(i2.symbol), r2;
              }
              function w8(r2, i2) {
                var t2 = i2.parent;
                return t2.kind === 206 || t2.kind === 161 || t2.kind === 208 && t2.expression === i2 || t2.kind === 207 && t2.expression === i2 && !(rg(r2, F8) && qp(Gs(t2.argumentExpression)));
              }
              function O8(r2) {
                return !!(r2.flags & 465829888 && Hd(r2).flags & 1146880);
              }
              function F8(r2) {
                return !!(r2.flags & 465829888 && !fs4(Hd(r2), 98304));
              }
              function M8(r2, i2) {
                var t2 = (e2.isIdentifier(r2) || e2.isPropertyAccessExpression(r2) || e2.isElementAccessExpression(r2)) && !((e2.isJsxOpeningElement(r2.parent) || e2.isJsxSelfClosingElement(r2.parent)) && r2.parent.tagName === r2) && (i2 && i2 & 64 ? ou(r2, 8) : ou(r2));
                return t2 && !rv(t2);
              }
              function yb(r2, i2, t2) {
                var o = !(t2 && t2 & 2) && rg(r2, O8) && (w8(r2, i2) || M8(i2, t2));
                return o ? Ss(r2, function(s2) {
                  return s2.flags & 465829888 ? Hd(s2) : s2;
                }) : r2;
              }
              function mC(r2) {
                return !!e2.findAncestor(r2, function(i2) {
                  var t2 = i2.parent;
                  return t2 === void 0 ? "quit" : e2.isExportAssignment(t2) ? t2.expression === i2 && e2.isEntityNameExpression(i2) : e2.isExportSpecifier(t2) ? t2.name === i2 || t2.propertyName === i2 : false;
                });
              }
              function o0(r2, i2) {
                if (Zn(r2, 111551) && !_m(i2) && !vu(r2)) {
                  var t2 = Ps(r2);
                  t2.flags & 111551 && (ye.isolatedModules || e2.shouldPreserveConstEnums(ye) && mC(i2) || !Av(t2) ? As(r2) : vn(r2));
                }
              }
              function L8(r2, i2) {
                var t2 = r2.valueDeclaration;
                if (t2) {
                  if (e2.isBindingElement(t2) && !t2.initializer && !t2.dotDotDotToken && t2.parent.elements.length >= 2) {
                    var o = t2.parent.parent;
                    if (o.kind === 254 && e2.getCombinedNodeFlags(t2) & 2 || o.kind === 164) {
                      var s2 = va(o);
                      if (!(s2.flags & 268435456)) {
                        s2.flags |= 268435456;
                        var u = Wo(o, 0);
                        if (s2.flags &= -268435457, u && u.flags & 1048576 && !(o.kind === 164 && n0(r2))) {
                          var h2 = t2.parent, z = up(h2, u, u, void 0, i2.flowNode);
                          return z.flags & 131072 ? ui : uf(t2, z);
                        }
                      }
                    }
                  }
                  if (e2.isParameter(t2) && !t2.type && !t2.initializer && !t2.dotDotDotToken) {
                    var me = t2.parent;
                    if (me.parameters.length >= 2 && wD(me)) {
                      var Me = dv(me);
                      if (Me && Me.parameters.length === 1 && H(Me)) {
                        var $e = Xd(Jt(Me.parameters[0]));
                        if ($e.flags & 1048576 && gf($e, Yn) && !n0(r2)) {
                          var z = up(me, $e, $e, void 0, i2.flowNode), tr = me.parameters.indexOf(t2) - (e2.getThisParameter(me) ? 1 : 0);
                          return Jc(z, If(tr));
                        }
                      }
                    }
                  }
                }
                return Jt(r2);
              }
              function R8(r2, i2) {
                if (e2.isThisInTypeQuery(r2))
                  return yy(r2);
                var t2 = Dl(r2);
                if (t2 === xe)
                  return Pe;
                if (t2 === or) {
                  if (QC(r2))
                    return Xr(r2, e2.Diagnostics.arguments_cannot_be_referenced_in_property_initializers), Pe;
                  var o = e2.getContainingFunction(r2);
                  return Ae < 2 && (o.kind === 214 ? Xr(r2, e2.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_arrow_function_in_ES3_and_ES5_Consider_using_a_standard_function_expression) : e2.hasSyntacticModifier(o, 256) && Xr(r2, e2.Diagnostics.The_arguments_object_cannot_be_referenced_in_an_async_function_or_method_in_ES3_and_ES5_Consider_using_a_standard_function_or_method)), va(o).flags |= 8192, Jt(t2);
                }
                r2.parent && e2.isPropertyAccessExpression(r2.parent) && r2.parent.expression === r2 || o0(t2, r2);
                var s2 = cu(t2), u = W6(s2, r2);
                P_(u) && mD(r2, u) && u.declarations && El(r2, u.declarations, r2.escapedText);
                var h2 = s2.valueDeclaration;
                if (h2 && s2.flags & 32) {
                  if (h2.kind === 257 && e2.nodeIsDecorated(h2))
                    for (var o = e2.getContainingClass(r2); o !== void 0; ) {
                      if (o === h2 && o.name !== r2) {
                        va(h2).flags |= 16777216, va(r2).flags |= 33554432;
                        break;
                      }
                      o = e2.getContainingClass(o);
                    }
                  else if (h2.kind === 226)
                    for (var o = e2.getThisContainer(r2, false); o.kind !== 305; ) {
                      if (o.parent === h2) {
                        (e2.isPropertyDeclaration(o) && e2.isStatic(o) || e2.isClassStaticBlockDeclaration(o)) && (va(h2).flags |= 16777216, va(r2).flags |= 33554432);
                        break;
                      }
                      o = e2.getThisContainer(o, false);
                    }
                }
                j8(r2, t2);
                var z = L8(s2, r2), me = e2.getAssignmentTargetKind(r2);
                if (me) {
                  if (!(s2.flags & 3) && !(e2.isInJSFile(r2) && s2.flags & 512)) {
                    var Me = s2.flags & 384 ? e2.Diagnostics.Cannot_assign_to_0_because_it_is_an_enum : s2.flags & 32 ? e2.Diagnostics.Cannot_assign_to_0_because_it_is_a_class : s2.flags & 1536 ? e2.Diagnostics.Cannot_assign_to_0_because_it_is_a_namespace : s2.flags & 16 ? e2.Diagnostics.Cannot_assign_to_0_because_it_is_a_function : s2.flags & 2097152 ? e2.Diagnostics.Cannot_assign_to_0_because_it_is_an_import : e2.Diagnostics.Cannot_assign_to_0_because_it_is_not_a_variable;
                    return Xr(r2, Me, tn(t2)), Pe;
                  }
                  if (Zu(s2))
                    return s2.flags & 3 ? Xr(r2, e2.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant, tn(t2)) : Xr(r2, e2.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, tn(t2)), Pe;
                }
                var $e = s2.flags & 2097152;
                if (s2.flags & 3) {
                  if (me === 1)
                    return z;
                } else if ($e)
                  h2 = ru(t2);
                else
                  return z;
                if (!h2)
                  return z;
                z = yb(z, r2, i2);
                for (var tr = e2.getRootDeclaration(h2).kind === 164, dr = _v(h2), Dr = _v(r2), Qr = Dr !== dr, li = r2.parent && r2.parent.parent && e2.isSpreadAssignment(r2.parent) && mb(r2.parent.parent), Ti = t2.flags & 134217728; Dr !== dr && (Dr.kind === 213 || Dr.kind === 214 || e2.isObjectLiteralOrClassExpressionMethodOrAccessor(Dr)) && (pv(s2) && z !== So || tr && !n0(s2)); )
                  Dr = _v(Dr);
                var Ci = tr || $e || Qr || li || Ti || e2.isBindingElement(h2) || z !== nr && z !== So && (!Ye || (z.flags & 16387) !== 0 || _m(r2) || r2.parent.kind === 275) || r2.parent.kind === 230 || h2.kind === 254 && h2.exclamationToken || h2.flags & 16777216, $i = Ci ? tr ? I8(z, h2) : z : z === nr || z === So ? Tr : i_(z), Zi = up(r2, z, $i, Dr);
                if (!_C(r2) && (z === nr || z === So)) {
                  if (Zi === nr || Zi === So)
                    return n && (Xr(e2.getNameOfDeclaration(h2), e2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined, tn(t2), Ot(Zi)), Xr(r2, e2.Diagnostics.Variable_0_implicitly_has_an_1_type, tn(t2), Ot(Zi))), kv(Zi);
                } else if (!Ci && !(ju(z) & 32768) && ju(Zi) & 32768)
                  return Xr(r2, e2.Diagnostics.Variable_0_is_used_before_being_assigned, tn(t2)), z;
                return me ? Kl(Zi) : Zi;
              }
              function B8(r2, i2) {
                return !!e2.findAncestor(r2, function(t2) {
                  return t2 === i2 ? "quit" : e2.isFunctionLike(t2) || t2.parent && e2.isPropertyDeclaration(t2.parent) && !e2.hasStaticModifier(t2.parent) && t2.parent.initializer === t2;
                });
              }
              function J8(r2, i2) {
                return e2.findAncestor(r2, function(t2) {
                  return t2 === i2 ? "quit" : t2 === i2.initializer || t2 === i2.condition || t2 === i2.incrementor || t2 === i2.statement;
                });
              }
              function hb(r2) {
                return e2.findAncestor(r2, function(i2) {
                  return !i2 || e2.nodeStartsNewLexicalEnvironment(i2) ? "quit" : e2.isIterationStatement(i2, false);
                });
              }
              function j8(r2, i2) {
                if (!(Ae >= 2 || (i2.flags & 34) === 0 || !i2.valueDeclaration || e2.isSourceFile(i2.valueDeclaration) || i2.valueDeclaration.parent.kind === 292)) {
                  var t2 = e2.getEnclosingBlockScopeContainer(i2.valueDeclaration), o = B8(r2, t2), s2 = hb(t2);
                  if (s2) {
                    if (o) {
                      var u = true;
                      if (e2.isForStatement(t2)) {
                        var h2 = e2.getAncestor(i2.valueDeclaration, 255);
                        if (h2 && h2.parent === t2) {
                          var z = J8(r2.parent, t2);
                          if (z) {
                            var me = va(z);
                            me.flags |= 131072;
                            var Me = me.capturedBlockScopeBindings || (me.capturedBlockScopeBindings = []);
                            e2.pushIfUnique(Me, i2), z === t2.initializer && (u = false);
                          }
                        }
                      }
                      u && (va(s2).flags |= 65536);
                    }
                    if (e2.isForStatement(t2)) {
                      var h2 = e2.getAncestor(i2.valueDeclaration, 255);
                      h2 && h2.parent === t2 && z8(r2, t2) && (va(i2.valueDeclaration).flags |= 4194304);
                    }
                    va(i2.valueDeclaration).flags |= 524288;
                  }
                  o && (va(i2.valueDeclaration).flags |= 262144);
                }
              }
              function U8(r2, i2) {
                var t2 = va(r2);
                return !!t2 && e2.contains(t2.capturedBlockScopeBindings, Et(i2));
              }
              function z8(r2, i2) {
                for (var t2 = r2; t2.parent.kind === 212; )
                  t2 = t2.parent;
                var o = false;
                if (e2.isAssignmentTarget(t2))
                  o = true;
                else if (t2.parent.kind === 219 || t2.parent.kind === 220) {
                  var s2 = t2.parent;
                  o = s2.operator === 45 || s2.operator === 46;
                }
                return o ? !!e2.findAncestor(t2, function(u) {
                  return u === i2 ? "quit" : u === i2.statement;
                }) : false;
              }
              function Db(r2, i2) {
                if (va(r2).flags |= 2, i2.kind === 167 || i2.kind === 171) {
                  var t2 = i2.parent;
                  va(t2).flags |= 4;
                } else
                  va(i2).flags |= 4;
              }
              function vC(r2) {
                return e2.isSuperCall(r2) ? r2 : e2.isFunctionLike(r2) ? void 0 : e2.forEachChild(r2, vC);
              }
              function yC(r2) {
                var i2 = Et(r2), t2 = go(i2), o = Bl(t2);
                return o === ct;
              }
              function hC(r2, i2, t2) {
                var o = i2.parent, s2 = e2.getClassExtendsHeritageElement(o);
                s2 && !yC(o) && r2.flowNode && !a0(r2.flowNode, false) && Xr(r2, t2);
              }
              function W8(r2, i2) {
                e2.isPropertyDeclaration(i2) && e2.hasStaticModifier(i2) && i2.initializer && e2.textRangeContainsPositionInclusive(i2.initializer, r2.pos) && e2.length(i2.parent.decorators) && Xr(r2, e2.Diagnostics.Cannot_use_this_in_a_static_property_initializer_of_a_decorated_class);
              }
              function yy(r2) {
                var i2 = _m(r2), t2 = e2.getThisContainer(r2, true), o = false;
                switch (t2.kind === 171 && hC(r2, t2, e2.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class), t2.kind === 214 && (t2 = e2.getThisContainer(t2, false), o = true), W8(r2, t2), t2.kind) {
                  case 261:
                    Xr(r2, e2.Diagnostics.this_cannot_be_referenced_in_a_module_or_namespace_body);
                    break;
                  case 260:
                    Xr(r2, e2.Diagnostics.this_cannot_be_referenced_in_current_location);
                    break;
                  case 171:
                    DC(r2, t2) && Xr(r2, e2.Diagnostics.this_cannot_be_referenced_in_constructor_arguments);
                    break;
                  case 162:
                    Xr(r2, e2.Diagnostics.this_cannot_be_referenced_in_a_computed_property_name);
                    break;
                }
                !i2 && o && Ae < 2 && Db(r2, t2);
                var s2 = bb(r2, true, t2);
                if (lr) {
                  var u = Jt(pe);
                  if (s2 === u && o)
                    Xr(r2, e2.Diagnostics.The_containing_arrow_function_captures_the_global_value_of_this);
                  else if (!s2) {
                    var h2 = Xr(r2, e2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation);
                    if (!e2.isSourceFile(t2)) {
                      var z = bb(t2);
                      z && z !== u && e2.addRelatedInfo(h2, e2.createDiagnosticForNode(t2, e2.Diagnostics.An_outer_value_of_this_is_shadowed_by_this_container));
                    }
                  }
                }
                return s2 || Oe;
              }
              function bb(r2, i2, t2) {
                i2 === void 0 && (i2 = true), t2 === void 0 && (t2 = e2.getThisContainer(r2, false));
                var o = e2.isInJSFile(r2);
                if (e2.isFunctionLike(t2) && (!xb(r2) || e2.getThisParameter(t2))) {
                  var s2 = ni(t2) || o && K8(t2);
                  if (!s2) {
                    var u = V8(t2);
                    if (o && u) {
                      var h2 = yn(u).symbol;
                      h2 && h2.members && h2.flags & 16 && (s2 = go(h2).thisType);
                    } else
                      Sl(t2) && (s2 = go(so(t2.symbol)).thisType);
                    s2 || (s2 = SC(t2));
                  }
                  if (s2)
                    return up(r2, s2);
                }
                if (e2.isClassLike(t2.parent)) {
                  var z = Et(t2.parent), me = e2.isStatic(t2) ? Jt(z) : go(z).thisType;
                  return up(r2, me);
                }
                if (e2.isSourceFile(t2))
                  if (t2.commonJsModuleIndicator) {
                    var Me = Et(t2);
                    return Me && Jt(Me);
                  } else {
                    if (t2.externalModuleIndicator)
                      return Tr;
                    if (i2)
                      return Jt(pe);
                  }
              }
              function q8(r2) {
                var i2 = e2.getThisContainer(r2, false);
                if (e2.isFunctionLike(i2)) {
                  var t2 = yl(i2);
                  if (t2.thisParameter)
                    return r0(t2.thisParameter);
                }
                if (e2.isClassLike(i2.parent)) {
                  var o = Et(i2.parent);
                  return e2.isStatic(i2) ? Jt(o) : go(o).thisType;
                }
              }
              function V8(r2) {
                if (r2.kind === 213 && e2.isBinaryExpression(r2.parent) && e2.getAssignmentDeclarationKind(r2.parent) === 3)
                  return r2.parent.left.expression.expression;
                if (r2.kind === 169 && r2.parent.kind === 205 && e2.isBinaryExpression(r2.parent.parent) && e2.getAssignmentDeclarationKind(r2.parent.parent) === 6)
                  return r2.parent.parent.left.expression;
                if (r2.kind === 213 && r2.parent.kind === 296 && r2.parent.parent.kind === 205 && e2.isBinaryExpression(r2.parent.parent.parent) && e2.getAssignmentDeclarationKind(r2.parent.parent.parent) === 6)
                  return r2.parent.parent.parent.left.expression;
                if (r2.kind === 213 && e2.isPropertyAssignment(r2.parent) && e2.isIdentifier(r2.parent.name) && (r2.parent.name.escapedText === "value" || r2.parent.name.escapedText === "get" || r2.parent.name.escapedText === "set") && e2.isObjectLiteralExpression(r2.parent.parent) && e2.isCallExpression(r2.parent.parent.parent) && r2.parent.parent.parent.arguments[2] === r2.parent.parent && e2.getAssignmentDeclarationKind(r2.parent.parent.parent) === 9)
                  return r2.parent.parent.parent.arguments[0].expression;
                if (e2.isMethodDeclaration(r2) && e2.isIdentifier(r2.name) && (r2.name.escapedText === "value" || r2.name.escapedText === "get" || r2.name.escapedText === "set") && e2.isObjectLiteralExpression(r2.parent) && e2.isCallExpression(r2.parent.parent) && r2.parent.parent.arguments[2] === r2.parent && e2.getAssignmentDeclarationKind(r2.parent.parent) === 9)
                  return r2.parent.parent.arguments[0].expression;
              }
              function K8(r2) {
                var i2 = e2.getJSDocType(r2);
                if (i2 && i2.kind === 317) {
                  var t2 = i2;
                  if (t2.parameters.length > 0 && t2.parameters[0].name && t2.parameters[0].name.escapedText === "this")
                    return Va(t2.parameters[0].type);
                }
                var o = e2.getJSDocThisTag(r2);
                if (o && o.typeExpression)
                  return Va(o.typeExpression);
              }
              function DC(r2, i2) {
                return !!e2.findAncestor(r2, function(t2) {
                  return e2.isFunctionLikeDeclaration(t2) ? "quit" : t2.kind === 164 && t2.parent === i2;
                });
              }
              function Sb(r2) {
                var i2 = r2.parent.kind === 208 && r2.parent.expression === r2, t2 = e2.getSuperContainer(r2, true), o = t2, s2 = false;
                if (!i2)
                  for (; o && o.kind === 214; )
                    o = e2.getSuperContainer(o, true), s2 = Ae < 2;
                var u = tr(o), h2 = 0;
                if (!u) {
                  var z = e2.findAncestor(r2, function(dr) {
                    return dr === o ? "quit" : dr.kind === 162;
                  });
                  return z && z.kind === 162 ? Xr(r2, e2.Diagnostics.super_cannot_be_referenced_in_a_computed_property_name) : i2 ? Xr(r2, e2.Diagnostics.Super_calls_are_not_permitted_outside_constructors_or_in_nested_functions_inside_constructors) : !o || !o.parent || !(e2.isClassLike(o.parent) || o.parent.kind === 205) ? Xr(r2, e2.Diagnostics.super_can_only_be_referenced_in_members_of_derived_classes_or_object_literal_expressions) : Xr(r2, e2.Diagnostics.super_property_access_is_permitted_only_in_a_constructor_member_function_or_member_accessor_of_a_derived_class), Pe;
                }
                if (!i2 && t2.kind === 171 && hC(r2, o, e2.Diagnostics.super_must_be_called_before_accessing_a_property_of_super_in_the_constructor_of_a_derived_class), e2.isStatic(o) || i2 ? (h2 = 512, !i2 && Ae >= 2 && Ae <= 8 && (e2.isPropertyDeclaration(o) || e2.isClassStaticBlockDeclaration(o)) && e2.forEachEnclosingBlockScopeContainer(r2.parent, function(dr) {
                  (!e2.isSourceFile(dr) || e2.isExternalOrCommonJsModule(dr)) && (va(dr).flags |= 134217728);
                })) : h2 = 256, va(r2).flags |= h2, o.kind === 169 && e2.hasSyntacticModifier(o, 256) && (e2.isSuperProperty(r2.parent) && e2.isAssignmentTarget(r2.parent) ? va(o).flags |= 4096 : va(o).flags |= 2048), s2 && Db(r2.parent, o), o.parent.kind === 205)
                  return Ae < 2 ? (Xr(r2, e2.Diagnostics.super_is_only_allowed_in_members_of_object_literal_expressions_when_option_target_is_ES2015_or_higher), Pe) : Oe;
                var me = o.parent;
                if (!e2.getClassExtendsHeritageElement(me))
                  return Xr(r2, e2.Diagnostics.super_can_only_be_referenced_in_a_derived_class), Pe;
                var Me = go(Et(me)), $e = Me && Qc(Me)[0];
                if (!$e)
                  return Pe;
                if (o.kind === 171 && DC(r2, o))
                  return Xr(r2, e2.Diagnostics.super_cannot_be_referenced_in_constructor_arguments), Pe;
                return h2 === 512 ? Bl(Me) : Rc($e, Me.thisType);
                function tr(dr) {
                  return dr ? i2 ? dr.kind === 171 : e2.isClassLike(dr.parent) || dr.parent.kind === 205 ? e2.isStatic(dr) ? dr.kind === 169 || dr.kind === 168 || dr.kind === 172 || dr.kind === 173 || dr.kind === 167 || dr.kind === 170 : dr.kind === 169 || dr.kind === 168 || dr.kind === 172 || dr.kind === 173 || dr.kind === 167 || dr.kind === 166 || dr.kind === 171 : false : false;
                }
              }
              function G8(r2) {
                return (r2.kind === 169 || r2.kind === 172 || r2.kind === 173) && r2.parent.kind === 205 ? r2.parent : r2.kind === 213 && r2.parent.kind === 296 ? r2.parent.parent : void 0;
              }
              function bC(r2) {
                return e2.getObjectFlags(r2) & 4 && r2.target === qn ? xo(r2)[0] : void 0;
              }
              function H8(r2) {
                return Ss(r2, function(i2) {
                  return i2.flags & 2097152 ? e2.forEach(i2.types, bC) : bC(i2);
                });
              }
              function SC(r2) {
                if (r2.kind !== 214) {
                  if (wD(r2)) {
                    var i2 = dv(r2);
                    if (i2) {
                      var t2 = i2.thisParameter;
                      if (t2)
                        return Jt(t2);
                    }
                  }
                  var o = e2.isInJSFile(r2);
                  if (lr || o) {
                    var s2 = G8(r2);
                    if (s2) {
                      for (var u = $p(s2), h2 = s2, z = u; z; ) {
                        var me = H8(z);
                        if (me)
                          return un(me, ab(wg(s2)));
                        if (h2.parent.kind !== 296)
                          break;
                        h2 = h2.parent.parent, z = $p(h2);
                      }
                      return $c(u ? C_(u) : Os(s2));
                    }
                    var Me = e2.walkUpParenthesizedExpressions(r2.parent);
                    if (Me.kind === 221 && Me.operatorToken.kind === 63) {
                      var $e = Me.left;
                      if (e2.isAccessExpression($e)) {
                        var tr = $e.expression;
                        if (o && e2.isIdentifier(tr)) {
                          var dr = e2.getSourceFileOfNode(Me);
                          if (dr.commonJsModuleIndicator && Dl(tr) === dr.symbol)
                            return;
                        }
                        return $c(Os(tr));
                      }
                    }
                  }
                }
              }
              function TC(r2) {
                var i2 = r2.parent;
                if (!!wD(i2)) {
                  var t2 = e2.getImmediatelyInvokedFunctionExpression(i2);
                  if (t2 && t2.arguments) {
                    var o = Zb(t2), s2 = i2.parameters.indexOf(r2);
                    if (r2.dotDotDotToken)
                      return Yb(o, s2, o.length, Oe, void 0, 0);
                    var u = va(t2), h2 = u.resolvedSignature;
                    u.resolvedSignature = En;
                    var z = s2 < o.length ? Hp(yn(o[s2])) : r2.initializer ? void 0 : vi;
                    return u.resolvedSignature = h2, z;
                  }
                  var me = dv(i2);
                  if (me) {
                    var Me = i2.parameters.indexOf(r2) - (e2.getThisParameter(i2) ? 1 : 0);
                    return r2.dotDotDotToken && e2.lastOrUndefined(i2.parameters) === r2 ? ym(me, Me) : Ld(me, Me);
                  }
                }
              }
              function Tb(r2) {
                var i2 = e2.getEffectiveTypeAnnotationNode(r2);
                if (i2)
                  return Va(i2);
                switch (r2.kind) {
                  case 164:
                    return TC(r2);
                  case 203:
                    return X8(r2);
                  case 167:
                    if (e2.isStatic(r2))
                      return Q8(r2);
                }
              }
              function X8(r2) {
                var i2 = r2.parent.parent, t2 = r2.propertyName || r2.name, o = Tb(i2) || i2.kind !== 203 && i2.initializer && wy(i2, r2.dotDotDotToken ? 64 : 0);
                if (!(!o || e2.isBindingPattern(t2) || e2.isComputedNonLiteralName(t2))) {
                  if (i2.name.kind === 202) {
                    var s2 = e2.indexOfNode(r2.parent.elements, r2);
                    return s2 < 0 ? void 0 : Ab(o, s2);
                  }
                  var u = Z_(t2);
                  if (_f(u)) {
                    var h2 = pf(u);
                    return da(o, h2);
                  }
                }
              }
              function Q8(r2) {
                var i2 = e2.isExpression(r2.parent) && ou(r2.parent);
                if (!!i2)
                  return Md(i2, Et(r2).escapedName);
              }
              function Y8(r2, i2) {
                var t2 = r2.parent;
                if (e2.hasInitializer(t2) && r2 === t2.initializer) {
                  var o = Tb(t2);
                  if (o)
                    return o;
                  if (!(i2 & 8) && e2.isBindingPattern(t2.name))
                    return Qu(t2.name, true, false);
                }
              }
              function $8(r2) {
                var i2 = e2.getContainingFunction(r2);
                if (i2) {
                  var t2 = Eb(i2);
                  if (t2) {
                    var o = e2.getFunctionFlags(i2);
                    if (o & 1) {
                      var s2 = o & 2 ? 2 : 1, u = Jy(t2, s2, void 0);
                      if (!u)
                        return;
                      t2 = u.returnType;
                    }
                    if (o & 2) {
                      var h2 = Ss(t2, k_);
                      return h2 && Pa([h2, Ok(h2)]);
                    }
                    return t2;
                  }
                }
              }
              function Z8(r2, i2) {
                var t2 = ou(r2, i2);
                if (t2) {
                  var o = k_(t2);
                  return o && Pa([o, Ok(o)]);
                }
              }
              function e5(r2) {
                var i2 = e2.getContainingFunction(r2);
                if (i2) {
                  var t2 = e2.getFunctionFlags(i2), o = Eb(i2);
                  if (o)
                    return r2.asteriskToken ? o : Jg(0, o, (t2 & 2) !== 0);
                }
              }
              function xb(r2) {
                for (var i2 = false; r2.parent && !e2.isFunctionLike(r2.parent); ) {
                  if (e2.isParameter(r2.parent) && (i2 || r2.parent.initializer === r2))
                    return true;
                  e2.isBindingElement(r2.parent) && r2.parent.initializer === r2 && (i2 = true), r2 = r2.parent;
                }
                return false;
              }
              function xC(r2, i2) {
                var t2 = !!(e2.getFunctionFlags(i2) & 2), o = Eb(i2);
                if (o)
                  return Jg(r2, o, t2) || void 0;
              }
              function Eb(r2) {
                var i2 = yg(r2);
                if (i2)
                  return i2;
                var t2 = Pb(r2);
                if (t2 && !Z1(t2))
                  return yo(t2);
                var o = e2.getImmediatelyInvokedFunctionExpression(r2);
                if (o)
                  return ou(o);
              }
              function EC(r2, i2) {
                var t2 = Zb(r2), o = t2.indexOf(i2);
                return o === -1 ? void 0 : Cb(r2, o);
              }
              function Cb(r2, i2) {
                if (e2.isImportCall(r2))
                  return i2 === 0 ? Li : i2 === 1 ? xx(false) : Oe;
                var t2 = va(r2).resolvedSignature === to ? to : Mg(r2);
                if (e2.isJsxOpeningLikeElement(r2) && i2 === 0)
                  return l0(t2, r2);
                var o = t2.parameters.length - 1;
                return H(t2) && i2 >= o ? Jc(Jt(t2.parameters[o]), If(i2 - o), 256) : $u(t2, i2);
              }
              function r5(r2, i2) {
                if (r2.parent.kind === 210)
                  return EC(r2.parent, i2);
              }
              function i5(r2, i2) {
                var t2 = r2.parent, o = t2.left, s2 = t2.operatorToken, u = t2.right;
                switch (s2.kind) {
                  case 63:
                  case 76:
                  case 75:
                  case 77:
                    return r2 === u ? a5(t2) : void 0;
                  case 56:
                  case 60:
                    var h2 = ou(t2, i2);
                    return r2 === u && (h2 && h2.pattern || !h2 && !e2.isDefaultedExpandoInitializer(t2)) ? Gs(o) : h2;
                  case 55:
                  case 27:
                    return r2 === u ? ou(t2, i2) : void 0;
                  default:
                    return;
                }
              }
              function t5(r2) {
                if (r2.symbol)
                  return r2.symbol;
                if (e2.isIdentifier(r2))
                  return Dl(r2);
                if (e2.isPropertyAccessExpression(r2)) {
                  var i2 = Gs(r2.expression);
                  return e2.isPrivateIdentifier(r2.name) ? t2(i2, r2.name) : bi(i2, r2.name.escapedText);
                }
                return;
                function t2(o, s2) {
                  var u = g0(s2.escapedText, s2);
                  return u && Ub(o, u);
                }
              }
              function a5(r2) {
                var i2, t2, o = e2.getAssignmentDeclarationKind(r2);
                switch (o) {
                  case 0:
                  case 4:
                    var s2 = t5(r2.left), u = s2 && s2.valueDeclaration;
                    if (u && (e2.isPropertyDeclaration(u) || e2.isPropertySignature(u))) {
                      var h2 = e2.getEffectiveTypeAnnotationNode(u);
                      return h2 && un(Va(h2), Aa(s2).mapper) || u.initializer && Gs(r2.left);
                    }
                    return o === 0 ? Gs(r2.left) : CC(r2);
                  case 5:
                    if (s0(r2, o))
                      return CC(r2);
                    if (r2.left.symbol) {
                      var z = r2.left.symbol.valueDeclaration;
                      if (!z)
                        return;
                      var me = e2.cast(r2.left, e2.isAccessExpression), h2 = e2.getEffectiveTypeAnnotationNode(z);
                      if (h2)
                        return Va(h2);
                      if (e2.isIdentifier(me.expression)) {
                        var Me = me.expression, $e = es(Me, Me.escapedText, 111551, void 0, Me.escapedText, true);
                        if ($e) {
                          var tr = $e.valueDeclaration && e2.getEffectiveTypeAnnotationNode($e.valueDeclaration);
                          if (tr) {
                            var dr = e2.getElementOrPropertyAccessName(me);
                            if (dr !== void 0)
                              return Md(Va(tr), dr);
                          }
                          return;
                        }
                      }
                      return e2.isInJSFile(z) ? void 0 : Gs(r2.left);
                    } else
                      return Gs(r2.left);
                  case 1:
                  case 6:
                  case 3:
                    var Dr = (i2 = r2.left.symbol) === null || i2 === void 0 ? void 0 : i2.valueDeclaration;
                  case 2:
                    Dr || (Dr = (t2 = r2.symbol) === null || t2 === void 0 ? void 0 : t2.valueDeclaration);
                    var Qr = Dr && e2.getEffectiveTypeAnnotationNode(Dr);
                    return Qr ? Va(Qr) : void 0;
                  case 7:
                  case 8:
                  case 9:
                    return e2.Debug.fail("Does not apply");
                  default:
                    return e2.Debug.assertNever(o);
                }
              }
              function s0(r2, i2) {
                if (i2 === void 0 && (i2 = e2.getAssignmentDeclarationKind(r2)), i2 === 4)
                  return true;
                if (!e2.isInJSFile(r2) || i2 !== 5 || !e2.isIdentifier(r2.left.expression))
                  return false;
                var t2 = r2.left.expression.escapedText, o = es(r2.left, t2, 111551, void 0, void 0, true, true);
                return e2.isThisInitializedDeclaration(o == null ? void 0 : o.valueDeclaration);
              }
              function CC(r2) {
                if (!r2.symbol)
                  return Gs(r2.left);
                if (r2.symbol.valueDeclaration) {
                  var i2 = e2.getEffectiveTypeAnnotationNode(r2.symbol.valueDeclaration);
                  if (i2) {
                    var t2 = Va(i2);
                    if (t2)
                      return t2;
                  }
                }
                var o = e2.cast(r2.left, e2.isAccessExpression);
                if (!!e2.isObjectLiteralMethod(e2.getThisContainer(o.expression, false))) {
                  var s2 = yy(o.expression), u = e2.getElementOrPropertyAccessName(o);
                  return u !== void 0 && Md(s2, u) || void 0;
                }
              }
              function n5(r2) {
                return !!(e2.getCheckFlags(r2) & 262144 && !r2.type && v(r2, 0) >= 0);
              }
              function Md(r2, i2, t2) {
                return Ss(r2, function(o) {
                  var s2;
                  if (Bc(o) && !o.declaration.nameType) {
                    var u = Mu(o), h2 = uc(u) || u, z = t2 || Bu(e2.unescapeLeadingUnderscores(i2));
                    if (ao(z, h2))
                      return xh(o, z);
                  } else if (o.flags & 3670016) {
                    var me = bi(o, i2);
                    if (me)
                      return n5(me) ? void 0 : Jt(me);
                    if (Yn(o)) {
                      var Me = sv(o);
                      if (Me && e2.isNumericLiteralName(i2) && +i2 >= 0)
                        return Me;
                    }
                    return (s2 = mn(To(o), t2 || Bu(e2.unescapeLeadingUnderscores(i2)))) === null || s2 === void 0 ? void 0 : s2.type;
                  }
                }, true);
              }
              function kC(r2, i2) {
                if (e2.Debug.assert(e2.isObjectLiteralMethod(r2)), !(r2.flags & 33554432))
                  return kb(r2, i2);
              }
              function kb(r2, i2) {
                var t2 = r2.parent, o = e2.isPropertyAssignment(r2) && Tb(r2);
                if (o)
                  return o;
                var s2 = $p(t2, i2);
                if (s2) {
                  if (Td(r2)) {
                    var u = Et(r2);
                    return Md(s2, u.escapedName, Aa(u).nameType);
                  }
                  if (r2.name) {
                    var h2 = Z_(r2.name);
                    return Ss(s2, function(z) {
                      var me;
                      return (me = mn(To(z), h2)) === null || me === void 0 ? void 0 : me.type;
                    }, true);
                  }
                }
              }
              function Ab(r2, i2) {
                return r2 && (Md(r2, "" + i2) || Ss(r2, function(t2) {
                  return xS(1, t2, Tr, void 0, false);
                }, true));
              }
              function o5(r2, i2) {
                var t2 = r2.parent;
                return r2 === t2.whenTrue || r2 === t2.whenFalse ? ou(t2, i2) : void 0;
              }
              function s5(r2, i2) {
                var t2 = $p(r2.openingElement.tagName), o = _0(Og(r2));
                if (!!(t2 && !ta(t2) && o && o !== "")) {
                  var s2 = e2.getSemanticJsxChildren(r2.children), u = s2.indexOf(i2), h2 = Md(t2, o);
                  return h2 && (s2.length === 1 ? h2 : Ss(h2, function(z) {
                    return sp(z) ? Jc(z, If(u)) : z;
                  }, true));
                }
              }
              function c5(r2) {
                var i2 = r2.parent;
                return e2.isJsxAttributeLike(i2) ? ou(r2) : e2.isJsxElement(i2) ? s5(i2, r2) : void 0;
              }
              function AC(r2) {
                if (e2.isJsxAttribute(r2)) {
                  var i2 = $p(r2.parent);
                  return !i2 || ta(i2) ? void 0 : Md(i2, r2.name.escapedText);
                } else
                  return ou(r2.parent);
              }
              function hy(r2) {
                switch (r2.kind) {
                  case 10:
                  case 8:
                  case 9:
                  case 14:
                  case 110:
                  case 95:
                  case 104:
                  case 79:
                  case 153:
                    return true;
                  case 206:
                  case 212:
                    return hy(r2.expression);
                  case 288:
                    return !r2.expression || hy(r2.expression);
                }
                return false;
              }
              function u5(r2, i2) {
                return n8(i2, r2) || UD(i2, e2.concatenate(e2.map(e2.filter(r2.properties, function(t2) {
                  return !!t2.symbol && t2.kind === 296 && hy(t2.initializer) && lv(i2, t2.symbol.escapedName);
                }), function(t2) {
                  return [function() {
                    return Oy(t2.initializer);
                  }, t2.symbol.escapedName];
                }), e2.map(e2.filter(uo(i2), function(t2) {
                  var o;
                  return !!(t2.flags & 16777216) && !!(!((o = r2 == null ? void 0 : r2.symbol) === null || o === void 0) && o.members) && !r2.symbol.members.has(t2.escapedName) && lv(i2, t2.escapedName);
                }), function(t2) {
                  return [function() {
                    return Tr;
                  }, t2.escapedName];
                })), ao, i2);
              }
              function l5(r2, i2) {
                return UD(i2, e2.concatenate(e2.map(e2.filter(r2.properties, function(t2) {
                  return !!t2.symbol && t2.kind === 285 && lv(i2, t2.symbol.escapedName) && (!t2.initializer || hy(t2.initializer));
                }), function(t2) {
                  return [t2.initializer ? function() {
                    return Oy(t2.initializer);
                  } : function() {
                    return Dt;
                  }, t2.symbol.escapedName];
                }), e2.map(e2.filter(uo(i2), function(t2) {
                  var o;
                  return !!(t2.flags & 16777216) && !!(!((o = r2 == null ? void 0 : r2.symbol) === null || o === void 0) && o.members) && !r2.symbol.members.has(t2.escapedName) && lv(i2, t2.escapedName);
                }), function(t2) {
                  return [function() {
                    return Tr;
                  }, t2.escapedName];
                })), ao, i2);
              }
              function $p(r2, i2) {
                var t2 = e2.isObjectLiteralMethod(r2) ? kC(r2, i2) : ou(r2, i2), o = c0(t2, r2, i2);
                if (o && !(i2 && i2 & 2 && o.flags & 8650752)) {
                  var s2 = Ss(o, $s, true);
                  return s2.flags & 1048576 && e2.isObjectLiteralExpression(r2) ? u5(r2, s2) : s2.flags & 1048576 && e2.isJsxAttributes(r2) ? l5(r2, s2) : s2;
                }
              }
              function c0(r2, i2, t2) {
                if (r2 && fs4(r2, 465829888)) {
                  var o = wg(i2);
                  if (o && e2.some(o.inferences, tg)) {
                    if (t2 && t2 & 1)
                      return u0(r2, o.nonFixingMapper);
                    if (o.returnMapper) {
                      var s2 = u0(r2, o.returnMapper);
                      return s2.flags & 1048576 && $f(s2.types, ut) && $f(s2.types, Rt) ? ec(s2, function(u) {
                        return u !== ut && u !== Rt;
                      }) : s2;
                    }
                  }
                }
                return r2;
              }
              function u0(r2, i2) {
                return r2.flags & 465829888 ? un(r2, i2) : r2.flags & 1048576 ? Pa(e2.map(r2.types, function(t2) {
                  return u0(t2, i2);
                }), 0) : r2.flags & 2097152 ? Do(e2.map(r2.types, function(t2) {
                  return u0(t2, i2);
                })) : r2;
              }
              function ou(r2, i2) {
                if (r2.flags & 33554432)
                  return;
                if (r2.contextualType)
                  return r2.contextualType;
                var t2 = r2.parent;
                switch (t2.kind) {
                  case 254:
                  case 164:
                  case 167:
                  case 166:
                  case 203:
                    return Y8(r2, i2);
                  case 214:
                  case 247:
                    return $8(r2);
                  case 224:
                    return e5(t2);
                  case 218:
                    return Z8(t2, i2);
                  case 208:
                  case 209:
                    return EC(t2, r2);
                  case 211:
                  case 229:
                    return e2.isConstTypeReference(t2.type) ? h2(t2) : Va(t2.type);
                  case 221:
                    return i5(r2, i2);
                  case 296:
                  case 297:
                    return kb(t2, i2);
                  case 298:
                    return ou(t2.parent, i2);
                  case 204: {
                    var o = t2, s2 = $p(o, i2);
                    return Ab(s2, e2.indexOfNode(o.elements, r2));
                  }
                  case 222:
                    return o5(r2, i2);
                  case 233:
                    return e2.Debug.assert(t2.parent.kind === 223), r5(t2.parent, r2);
                  case 212: {
                    var u = e2.isInJSFile(t2) ? e2.getJSDocTypeTag(t2) : void 0;
                    return u ? e2.isJSDocTypeTag(u) && e2.isConstTypeReference(u.typeExpression.type) ? h2(t2) : Va(u.typeExpression.type) : ou(t2, i2);
                  }
                  case 230:
                    return ou(t2, i2);
                  case 271:
                    return Rl(t2);
                  case 288:
                    return c5(t2);
                  case 285:
                  case 287:
                    return AC(t2);
                  case 280:
                  case 279:
                    return f5(t2, i2);
                }
                return;
                function h2(z) {
                  return ou(z);
                }
              }
              function wg(r2) {
                var i2 = e2.findAncestor(r2, function(t2) {
                  return !!t2.inferenceContext;
                });
                return i2 && i2.inferenceContext;
              }
              function f5(r2, i2) {
                return e2.isJsxOpeningElement(r2) && r2.parent.contextualType && i2 !== 4 ? r2.parent.contextualType : Cb(r2, 0);
              }
              function l0(r2, i2) {
                return lk(i2) !== 0 ? _5(r2, i2) : g5(r2, i2);
              }
              function _5(r2, i2) {
                var t2 = nS(r2, gr);
                t2 = NC(i2, Og(i2), t2);
                var o = Zp(U.IntrinsicAttributes, i2);
                return nn(o) || (t2 = Zg(o, t2)), t2;
              }
              function p5(r2, i2) {
                if (r2.compositeSignatures) {
                  for (var t2 = [], o = 0, s2 = r2.compositeSignatures; o < s2.length; o++) {
                    var u = s2[o], h2 = yo(u);
                    if (ta(h2))
                      return h2;
                    var z = da(h2, i2);
                    if (!z)
                      return;
                    t2.push(z);
                  }
                  return Do(t2);
                }
                var me = yo(r2);
                return ta(me) ? me : da(me, i2);
              }
              function d5(r2) {
                if (dm(r2.tagName)) {
                  var i2 = BC(r2), t2 = S0(r2, i2);
                  return im(t2);
                }
                var o = Os(r2.tagName);
                if (o.flags & 128) {
                  var i2 = RC(o, r2);
                  if (!i2)
                    return Pe;
                  var t2 = S0(r2, i2);
                  return im(t2);
                }
                return o;
              }
              function NC(r2, i2, t2) {
                var o = F5(i2);
                if (o) {
                  var s2 = go(o), u = d5(r2);
                  if (o.flags & 524288) {
                    var h2 = Aa(o).typeParameters;
                    if (e2.length(h2) >= 2) {
                      var z = zp([u, t2], h2, 2, e2.isInJSFile(r2));
                      return am(o, z);
                    }
                  }
                  if (e2.length(s2.typeParameters) >= 2) {
                    var z = zp([u, t2], s2.typeParameters, 2, e2.isInJSFile(r2));
                    return Yf(s2, z);
                  }
                }
                return t2;
              }
              function g5(r2, i2) {
                var t2 = Og(i2), o = M5(t2), s2 = o === void 0 ? nS(r2, gr) : o === "" ? yo(r2) : p5(r2, o);
                if (!s2)
                  return !!o && !!e2.length(i2.attributes.properties) && Xr(i2, e2.Diagnostics.JSX_element_class_does_not_support_attributes_because_it_does_not_have_a_0_property, e2.unescapeLeadingUnderscores(o)), gr;
                if (s2 = NC(i2, t2, s2), ta(s2))
                  return s2;
                var u = s2, h2 = Zp(U.IntrinsicClassAttributes, i2);
                if (!nn(h2)) {
                  var z = Af(h2.symbol), me = yo(r2);
                  u = Zg(z ? Yf(h2, zp([me], z, Ul(z), e2.isInJSFile(i2))) : h2, u);
                }
                var Me = Zp(U.IntrinsicAttributes, i2);
                return nn(Me) || (u = Zg(Me, u)), u;
              }
              function m5(r2) {
                return e2.getStrictOptionValue(ye, "noImplicitAny") ? e2.reduceLeft(r2, function(i2, t2) {
                  return i2 === t2 || !i2 ? i2 : ah(i2.typeParameters, t2.typeParameters) ? h5(i2, t2) : void 0;
                }) : void 0;
              }
              function v5(r2, i2, t2) {
                if (!r2 || !i2)
                  return r2 || i2;
                var o = Pa([Jt(r2), un(Jt(i2), t2)]);
                return eg(r2, o);
              }
              function y5(r2, i2, t2) {
                for (var o = Wc(r2), s2 = Wc(i2), u = o >= s2 ? r2 : i2, h2 = u === r2 ? i2 : r2, z = u === r2 ? o : s2, me = Xl(r2) || Xl(i2), Me = me && !Xl(u), $e = new Array(z + (Me ? 1 : 0)), tr = 0; tr < z; tr++) {
                  var dr = Ld(u, tr);
                  u === i2 && (dr = un(dr, t2));
                  var Dr = Ld(h2, tr) || gr;
                  h2 === i2 && (Dr = un(Dr, t2));
                  var Qr = Pa([dr, Dr]), li = me && !Me && tr === z - 1, Ti = tr >= Hl(u) && tr >= Hl(h2), Ci = tr >= o ? void 0 : vm(r2, tr), $i = tr >= s2 ? void 0 : vm(i2, tr), Zi = Ci === $i ? Ci : Ci ? $i ? void 0 : Ci : $i, qt = oo(1 | (Ti && !li ? 16777216 : 0), Zi || "arg".concat(tr));
                  qt.type = li ? Zs(Qr) : Qr, $e[tr] = qt;
                }
                if (Me) {
                  var Nt = oo(1, "args");
                  Nt.type = Zs($u(h2, z)), h2 === i2 && (Nt.type = un(Nt.type, t2)), $e[z] = Nt;
                }
                return $e;
              }
              function h5(r2, i2) {
                var t2 = r2.typeParameters || i2.typeParameters, o;
                r2.typeParameters && i2.typeParameters && (o = Uc(i2.typeParameters, r2.typeParameters));
                var s2 = r2.declaration, u = y5(r2, i2, o), h2 = v5(r2.thisParameter, i2.thisParameter, o), z = Math.max(r2.minArgumentCount, i2.minArgumentCount), me = Fu(s2, t2, h2, u, void 0, void 0, z, (r2.flags | i2.flags) & 39);
                return me.compositeKind = 2097152, me.compositeSignatures = e2.concatenate(r2.compositeKind === 2097152 && r2.compositeSignatures || [r2], [i2]), o && (me.mapper = r2.compositeKind === 2097152 && r2.mapper && r2.compositeSignatures ? np(r2.mapper, o) : o), me;
              }
              function Nb(r2, i2) {
                var t2 = ot(r2, 0), o = e2.filter(t2, function(s2) {
                  return !D5(s2, i2);
                });
                return o.length === 1 ? o[0] : m5(o);
              }
              function D5(r2, i2) {
                for (var t2 = 0; t2 < i2.parameters.length; t2++) {
                  var o = i2.parameters[t2];
                  if (o.initializer || o.questionToken || o.dotDotDotToken || Cd(o))
                    break;
                }
                return i2.parameters.length && e2.parameterIsThisKeyword(i2.parameters[0]) && t2--, !Xl(r2) && Wc(r2) < t2;
              }
              function Pb(r2) {
                return e2.isFunctionExpressionOrArrowFunction(r2) || e2.isObjectLiteralMethod(r2) ? dv(r2) : void 0;
              }
              function dv(r2) {
                e2.Debug.assert(r2.kind !== 169 || e2.isObjectLiteralMethod(r2));
                var i2 = rm(r2);
                if (i2)
                  return i2;
                var t2 = $p(r2, 1);
                if (!!t2) {
                  if (!(t2.flags & 1048576))
                    return Nb(t2, r2);
                  for (var o, s2 = t2.types, u = 0, h2 = s2; u < h2.length; u++) {
                    var z = h2[u], me = Nb(z, r2);
                    if (me)
                      if (!o)
                        o = [me];
                      else if (_y(o[0], me, false, true, true, av))
                        o.push(me);
                      else
                        return;
                  }
                  if (o)
                    return o.length === 1 ? o[0] : Uv(o[0], o);
                }
              }
              function b5(r2, i2) {
                Ae < 2 && fc(r2, ye.downlevelIteration ? 1536 : 1024);
                var t2 = yn(r2.expression, i2);
                return N_(33, t2, Tr, r2.expression);
              }
              function S5(r2) {
                return r2.isSpread ? Jc(r2.type, nt) : r2.type;
              }
              function pm(r2) {
                return r2.kind === 203 && !!r2.initializer || r2.kind === 221 && r2.operatorToken.kind === 63;
              }
              function PC(r2, i2, t2) {
                for (var o = r2.elements, s2 = o.length, u = [], h2 = [], z = $p(r2), me = e2.isAssignmentTarget(r2), Me = hm(r2), $e = false, tr = 0; tr < s2; tr++) {
                  var dr = o[tr];
                  if (dr.kind === 225) {
                    Ae < 2 && fc(dr, ye.downlevelIteration ? 1536 : 1024);
                    var Dr = yn(dr.expression, i2, t2);
                    if (sp(Dr))
                      u.push(Dr), h2.push(8);
                    else if (me) {
                      var Qr = cs(Dr, nt) || xS(65, Dr, Tr, void 0, false) || gr;
                      u.push(Qr), h2.push(4);
                    } else
                      u.push(N_(33, Dr, Tr, dr.expression)), h2.push(4);
                  } else if (yr && dr.kind === 227)
                    $e = true, u.push(Yi), h2.push(2);
                  else {
                    var li = Ab(z, u.length), Ti = Dm(dr, i2, li, t2);
                    if (u.push(kc(Ti, true, $e)), h2.push($e ? 2 : 1), z && rg(z, Eg) && i2 && i2 & 2 && !(i2 & 4) && Ju(dr)) {
                      var Ci = wg(r2);
                      e2.Debug.assert(Ci), BE(Ci, dr, Ti);
                    }
                  }
                }
                return me ? Wl(u, h2) : t2 || Me || z && rg(z, Eg) ? IC(Wl(u, h2, Me)) : IC(Zs(u.length ? Pa(e2.sameMap(u, function($i, Zi) {
                  return h2[Zi] & 8 ? ep($i, nt) || Oe : $i;
                }), 2) : Ye ? na : vi, Me));
              }
              function IC(r2) {
                if (!(e2.getObjectFlags(r2) & 4))
                  return r2;
                var i2 = r2.literalType;
                return i2 || (i2 = r2.literalType = ux(r2), i2.objectFlags |= 147456), i2;
              }
              function T5(r2) {
                switch (r2.kind) {
                  case 162:
                    return x5(r2);
                  case 79:
                    return e2.isNumericLiteralName(r2.escapedText);
                  case 8:
                  case 10:
                    return e2.isNumericLiteralName(r2.text);
                  default:
                    return false;
                }
              }
              function x5(r2) {
                return Ns(t_(r2), 296);
              }
              function t_(r2) {
                var i2 = va(r2.expression);
                if (!i2.resolvedType) {
                  if ((e2.isTypeLiteralNode(r2.parent.parent) || e2.isClassLike(r2.parent.parent) || e2.isInterfaceDeclaration(r2.parent.parent)) && e2.isBinaryExpression(r2.expression) && r2.expression.operatorToken.kind === 101 && r2.parent.kind !== 172 && r2.parent.kind !== 173)
                    return i2.resolvedType = Pe;
                  if (i2.resolvedType = yn(r2.expression), e2.isPropertyDeclaration(r2.parent) && !e2.hasStaticModifier(r2.parent) && e2.isClassExpression(r2.parent.parent)) {
                    var t2 = e2.getEnclosingBlockScopeContainer(r2.parent.parent), o = hb(t2);
                    o && (va(o).flags |= 65536, va(r2).flags |= 524288, va(r2.parent.parent).flags |= 524288);
                  }
                  (i2.resolvedType.flags & 98304 || !Ns(i2.resolvedType, 402665900) && !ao(i2.resolvedType, Vi)) && Xr(r2, e2.Diagnostics.A_computed_property_name_must_be_of_type_string_number_symbol_or_any);
                }
                return i2.resolvedType;
              }
              function E5(r2) {
                var i2, t2 = (i2 = r2.declarations) === null || i2 === void 0 ? void 0 : i2[0];
                return e2.isNumericLiteralName(r2.escapedName) || t2 && e2.isNamedDeclaration(t2) && T5(t2.name);
              }
              function wC(r2) {
                var i2, t2 = (i2 = r2.declarations) === null || i2 === void 0 ? void 0 : i2[0];
                return e2.isKnownSymbol(r2) || t2 && e2.isNamedDeclaration(t2) && e2.isComputedPropertyName(t2.name) && Ns(t_(t2.name), 4096);
              }
              function Ib(r2, i2, t2, o) {
                for (var s2 = [], u = i2; u < t2.length; u++) {
                  var h2 = t2[u];
                  (o === Li && !wC(h2) || o === nt && E5(h2) || o === Ki && wC(h2)) && s2.push(Jt(t2[u]));
                }
                var z = s2.length ? Pa(s2, 2) : Tr;
                return zl(o, z, hm(r2));
              }
              function wb(r2) {
                e2.Debug.assert((r2.flags & 2097152) !== 0, "Should only get Alias here.");
                var i2 = Aa(r2);
                if (!i2.immediateTarget) {
                  var t2 = ru(r2);
                  if (!t2)
                    return e2.Debug.fail();
                  i2.immediateTarget = Ec(t2, true);
                }
                return i2.immediateTarget;
              }
              function C5(r2, i2) {
                var t2 = e2.isAssignmentTarget(r2);
                eL(r2, t2);
                for (var o = Ye ? e2.createSymbolTable() : void 0, s2 = e2.createSymbolTable(), u = [], h2 = Ba, z = $p(r2), me = z && z.pattern && (z.pattern.kind === 201 || z.pattern.kind === 205), Me = hm(r2), $e = Me ? 8 : 0, tr = e2.isInJSFile(r2) && !e2.isInJsonFile(r2), dr = e2.getJSDocEnumTag(r2), Dr = !z && tr && !dr, Qr = ur, li = false, Ti = false, Ci = false, $i = false, Zi = 0, qt = r2.properties; Zi < qt.length; Zi++) {
                  var Nt = qt[Zi];
                  Nt.name && e2.isComputedPropertyName(Nt.name) && t_(Nt.name);
                }
                for (var Ra = 0, ca = 0, Sn = r2.properties; ca < Sn.length; ca++) {
                  var ja = Sn[ca], Fn = Et(ja), wn = ja.name && ja.name.kind === 162 ? t_(ja.name) : void 0;
                  if (ja.kind === 296 || ja.kind === 297 || e2.isObjectLiteralMethod(ja)) {
                    var Tn = ja.kind === 296 ? Kk(ja, i2) : ja.kind === 297 ? Dm(!t2 && ja.objectAssignmentInitializer ? ja.objectAssignmentInitializer : ja.name, i2) : Gk(ja, i2);
                    if (tr) {
                      var Eo = K_(ja);
                      Eo ? (zc(Tn, Eo, ja), Tn = Eo) : dr && dr.typeExpression && zc(Tn, Va(dr.typeExpression), ja);
                    }
                    Qr |= e2.getObjectFlags(Tn) & 458752;
                    var lt = wn && _f(wn) ? wn : void 0, it = lt ? oo(4 | Fn.flags, pf(lt), $e | 4096) : oo(4 | Fn.flags, Fn.escapedName, $e);
                    if (lt && (it.nameType = lt), t2) {
                      var Yt = ja.kind === 296 && pm(ja.initializer) || ja.kind === 297 && ja.objectAssignmentInitializer;
                      Yt && (it.flags |= 16777216);
                    } else if (me && !(e2.getObjectFlags(z) & 512)) {
                      var Ia = bi(z, Fn.escapedName);
                      Ia ? it.flags |= Ia.flags & 16777216 : !ye.suppressExcessPropertyErrors && !ss(z, Li) && Xr(ja.name, e2.Diagnostics.Object_literal_may_only_specify_known_properties_and_0_does_not_exist_in_type_1, tn(Fn), Ot(z));
                    }
                    if (it.declarations = Fn.declarations, it.parent = Fn.parent, Fn.valueDeclaration && (it.valueDeclaration = Fn.valueDeclaration), it.type = Tn, it.target = Fn, Fn = it, o == null || o.set(it.escapedName, it), z && i2 && i2 & 2 && !(i2 & 4) && (ja.kind === 296 || ja.kind === 169) && Ju(ja)) {
                      var Qt = wg(r2);
                      e2.Debug.assert(Qt);
                      var Ka = ja.kind === 296 ? ja.initializer : ja;
                      BE(Qt, Ka, Tn);
                    }
                  } else if (ja.kind === 298) {
                    Ae < 2 && fc(ja, 2), u.length > 0 && (h2 = Vp(h2, Mn(), r2.symbol, Qr, Me), u = [], s2 = e2.createSymbolTable(), Ti = false, Ci = false, $i = false);
                    var Tn = bu(yn(ja.expression));
                    if (Dy(Tn)) {
                      var cn = TD(Tn, Me);
                      if (o && FC(cn, o, ja), Ra = u.length, nn(h2))
                        continue;
                      h2 = Vp(h2, cn, r2.symbol, Qr, Me);
                    } else
                      Xr(ja, e2.Diagnostics.Spread_types_may_only_be_created_from_object_types), h2 = Pe;
                    continue;
                  } else
                    e2.Debug.assert(ja.kind === 172 || ja.kind === 173), xm(ja);
                  wn && !(wn.flags & 8576) ? ao(wn, Vi) && (ao(wn, nt) ? Ci = true : ao(wn, Ki) ? $i = true : Ti = true, t2 && (li = true)) : s2.set(Fn.escapedName, Fn), u.push(Fn);
                }
                if (me && r2.parent.kind !== 298)
                  for (var Un = 0, oa = uo(z); Un < oa.length; Un++) {
                    var it = oa[Un];
                    !s2.get(it.escapedName) && !bi(h2, it.escapedName) && (it.flags & 16777216 || Xr(it.valueDeclaration || it.bindingElement, e2.Diagnostics.Initializer_provides_no_value_for_this_binding_element_and_the_binding_element_has_no_default_value), s2.set(it.escapedName, it), u.push(it));
                  }
                if (nn(h2))
                  return Pe;
                if (h2 !== Ba)
                  return u.length > 0 && (h2 = Vp(h2, Mn(), r2.symbol, Qr, Me), u = [], s2 = e2.createSymbolTable(), Ti = false, Ci = false), Ss(h2, function(Ln) {
                    return Ln === Ba ? Mn() : Ln;
                  });
                return Mn();
                function Mn() {
                  var Ln = [];
                  Ti && Ln.push(Ib(r2, Ra, u, Li)), Ci && Ln.push(Ib(r2, Ra, u, nt)), $i && Ln.push(Ib(r2, Ra, u, Ki));
                  var ci = rs(r2.symbol, s2, e2.emptyArray, e2.emptyArray, Ln);
                  return ci.objectFlags |= Qr | 128 | 131072, Dr && (ci.objectFlags |= 4096), li && (ci.objectFlags |= 512), t2 && (ci.pattern = r2), ci;
                }
              }
              function Dy(r2) {
                var i2 = OE(Ss(r2, Hd));
                return !!(i2.flags & 126615553 || i2.flags & 3145728 && e2.every(i2.types, Dy));
              }
              function k5(r2) {
                Lb(r2);
              }
              function A5(r2, i2) {
                return xm(r2), by(r2) || Oe;
              }
              function N5(r2) {
                Lb(r2.openingElement), dm(r2.closingElement.tagName) ? Fb(r2.closingElement) : yn(r2.closingElement.tagName), f0(r2);
              }
              function P5(r2, i2) {
                return xm(r2), by(r2) || Oe;
              }
              function I5(r2) {
                Lb(r2.openingFragment);
                var i2 = e2.getSourceFileOfNode(r2);
                return e2.getJSXTransformEnabled(ye) && (ye.jsxFactory || i2.pragmas.has("jsx")) && !ye.jsxFragmentFactory && !i2.pragmas.has("jsxfrag") && Xr(r2, ye.jsxFactory ? e2.Diagnostics.The_jsxFragmentFactory_compiler_option_must_be_provided_to_use_JSX_fragments_with_the_jsxFactory_compiler_option : e2.Diagnostics.An_jsxFrag_pragma_is_required_when_using_an_jsx_pragma_with_JSX_fragments), f0(r2), by(r2) || Oe;
              }
              function Ob(r2) {
                return e2.stringContains(r2, "-");
              }
              function dm(r2) {
                return r2.kind === 79 && e2.isIntrinsicJsxName(r2.escapedText);
              }
              function OC(r2, i2) {
                return r2.initializer ? Dm(r2.initializer, i2) : Dt;
              }
              function w5(r2, i2) {
                for (var t2 = r2.attributes, o = Ye ? e2.createSymbolTable() : void 0, s2 = e2.createSymbolTable(), u = pn, h2 = false, z, me = false, Me = 2048, $e = _0(Og(r2)), tr = 0, dr = t2.properties; tr < dr.length; tr++) {
                  var Dr = dr[tr], Qr = Dr.symbol;
                  if (e2.isJsxAttribute(Dr)) {
                    var li = OC(Dr, i2);
                    Me |= e2.getObjectFlags(li) & 458752;
                    var Ti = oo(4 | Qr.flags, Qr.escapedName);
                    Ti.declarations = Qr.declarations, Ti.parent = Qr.parent, Qr.valueDeclaration && (Ti.valueDeclaration = Qr.valueDeclaration), Ti.type = li, Ti.target = Qr, s2.set(Ti.escapedName, Ti), o == null || o.set(Ti.escapedName, Ti), Dr.name.escapedText === $e && (me = true);
                  } else {
                    e2.Debug.assert(Dr.kind === 287), s2.size > 0 && (u = Vp(u, ca(), t2.symbol, Me, false), s2 = e2.createSymbolTable());
                    var li = bu(Os(Dr.expression, i2));
                    ta(li) && (h2 = true), Dy(li) ? (u = Vp(u, li, t2.symbol, Me, false), o && FC(li, o, Dr)) : (Xr(Dr.expression, e2.Diagnostics.Spread_types_may_only_be_created_from_object_types), z = z ? Do([z, li]) : li);
                  }
                }
                h2 || s2.size > 0 && (u = Vp(u, ca(), t2.symbol, Me, false));
                var Ci = r2.parent.kind === 278 ? r2.parent : void 0;
                if (Ci && Ci.openingElement === r2 && Ci.children.length > 0) {
                  var $i = f0(Ci, i2);
                  if (!h2 && $e && $e !== "") {
                    me && Xr(t2, e2.Diagnostics._0_are_specified_twice_The_attribute_named_0_will_be_overwritten, e2.unescapeLeadingUnderscores($e));
                    var Zi = $p(r2.attributes), qt = Zi && Md(Zi, $e), Nt = oo(4, $e);
                    Nt.type = $i.length === 1 ? $i[0] : qt && rg(qt, Eg) ? Wl($i) : Zs(Pa($i)), Nt.valueDeclaration = e2.factory.createPropertySignature(void 0, e2.unescapeLeadingUnderscores($e), void 0, void 0), e2.setParent(Nt.valueDeclaration, t2), Nt.valueDeclaration.symbol = Nt;
                    var Ra = e2.createSymbolTable();
                    Ra.set($e, Nt), u = Vp(u, rs(t2.symbol, Ra, e2.emptyArray, e2.emptyArray, e2.emptyArray), t2.symbol, Me, false);
                  }
                }
                if (h2)
                  return Oe;
                if (z && u !== pn)
                  return Do([z, u]);
                return z || (u === pn ? ca() : u);
                function ca() {
                  Me |= ur;
                  var Sn = rs(t2.symbol, s2, e2.emptyArray, e2.emptyArray, e2.emptyArray);
                  return Sn.objectFlags |= Me | 128 | 131072, Sn;
                }
              }
              function f0(r2, i2) {
                for (var t2 = [], o = 0, s2 = r2.children; o < s2.length; o++) {
                  var u = s2[o];
                  if (u.kind === 11)
                    u.containsOnlyTriviaWhiteSpaces || t2.push(Li);
                  else {
                    if (u.kind === 288 && !u.expression)
                      continue;
                    t2.push(Dm(u, i2));
                  }
                }
                return t2;
              }
              function FC(r2, i2, t2) {
                for (var o = 0, s2 = uo(r2); o < s2.length; o++) {
                  var u = s2[o];
                  if (!(u.flags & 16777216)) {
                    var h2 = i2.get(u.escapedName);
                    if (h2) {
                      var z = Xr(h2.valueDeclaration, e2.Diagnostics._0_is_specified_more_than_once_so_this_usage_will_be_overwritten, e2.unescapeLeadingUnderscores(h2.escapedName));
                      e2.addRelatedInfo(z, e2.createDiagnosticForNode(t2, e2.Diagnostics.This_spread_always_overwrites_this_property));
                    }
                  }
                }
              }
              function O5(r2, i2) {
                return w5(r2.parent, i2);
              }
              function Zp(r2, i2) {
                var t2 = Og(i2), o = t2 && dc(t2), s2 = o && qs(o, r2, 788968);
                return s2 ? go(s2) : Pe;
              }
              function Fb(r2) {
                var i2 = va(r2);
                if (!i2.resolvedSymbol) {
                  var t2 = Zp(U.IntrinsicElements, r2);
                  if (nn(t2))
                    return n && Xr(r2, e2.Diagnostics.JSX_element_implicitly_has_type_any_because_no_interface_JSX_0_exists, e2.unescapeLeadingUnderscores(U.IntrinsicElements)), i2.resolvedSymbol = xe;
                  if (!e2.isIdentifier(r2.tagName))
                    return e2.Debug.fail();
                  var o = bi(t2, r2.tagName.escapedText);
                  if (o)
                    return i2.jsxFlags |= 1, i2.resolvedSymbol = o;
                  var s2 = cs(t2, Li);
                  return s2 ? (i2.jsxFlags |= 2, i2.resolvedSymbol = t2.symbol) : (Xr(r2, e2.Diagnostics.Property_0_does_not_exist_on_type_1, e2.idText(r2.tagName), "JSX." + U.IntrinsicElements), i2.resolvedSymbol = xe);
                }
                return i2.resolvedSymbol;
              }
              function Mb(r2) {
                var i2 = r2 && e2.getSourceFileOfNode(r2), t2 = i2 && va(i2);
                if (!(t2 && t2.jsxImplicitImportContainer === false)) {
                  if (t2 && t2.jsxImplicitImportContainer)
                    return t2.jsxImplicitImportContainer;
                  var o = e2.getJSXRuntimeImport(e2.getJSXImplicitImportBase(ye, i2), ye);
                  if (!!o) {
                    var s2 = e2.getEmitModuleResolutionKind(ye) === e2.ModuleResolutionKind.Classic, u = s2 ? e2.Diagnostics.Cannot_find_module_0_Did_you_mean_to_set_the_moduleResolution_option_to_node_or_to_add_aliases_to_the_paths_option : e2.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations, h2 = Il(r2, o, u, r2), z = h2 && h2 !== xe ? so(os(h2)) : void 0;
                    return t2 && (t2.jsxImplicitImportContainer = z || false), z;
                  }
                }
              }
              function Og(r2) {
                var i2 = r2 && va(r2);
                if (i2 && i2.jsxNamespace)
                  return i2.jsxNamespace;
                if (!i2 || i2.jsxNamespace !== false) {
                  var t2 = Mb(r2);
                  if (!t2 || t2 === xe) {
                    var o = po(r2);
                    t2 = es(r2, o, 1920, void 0, o, false);
                  }
                  if (t2) {
                    var s2 = os(qs(dc(os(t2)), U.JSX, 1920));
                    if (s2 && s2 !== xe)
                      return i2 && (i2.jsxNamespace = s2), s2;
                  }
                  i2 && (i2.jsxNamespace = false);
                }
                var u = os(Ym(U.JSX, 1920, void 0));
                if (u !== xe)
                  return u;
              }
              function MC(r2, i2) {
                var t2 = i2 && qs(i2.exports, r2, 788968), o = t2 && go(t2), s2 = o && uo(o);
                if (s2) {
                  if (s2.length === 0)
                    return "";
                  if (s2.length === 1)
                    return s2[0].escapedName;
                  s2.length > 1 && t2.declarations && Xr(t2.declarations[0], e2.Diagnostics.The_global_type_JSX_0_may_not_have_more_than_one_property, e2.unescapeLeadingUnderscores(r2));
                }
              }
              function F5(r2) {
                return r2 && qs(r2.exports, U.LibraryManagedAttributes, 788968);
              }
              function M5(r2) {
                return MC(U.ElementAttributesPropertyNameContainer, r2);
              }
              function _0(r2) {
                return MC(U.ElementChildrenAttributeNameContainer, r2);
              }
              function LC(r2, i2) {
                if (r2.flags & 4)
                  return [En];
                if (r2.flags & 128) {
                  var t2 = RC(r2, i2);
                  if (t2) {
                    var o = S0(i2, t2);
                    return [o];
                  } else
                    return Xr(i2, e2.Diagnostics.Property_0_does_not_exist_on_type_1, r2.value, "JSX." + U.IntrinsicElements), e2.emptyArray;
                }
                var s2 = $s(r2), u = ot(s2, 1);
                return u.length === 0 && (u = ot(s2, 0)), u.length === 0 && s2.flags & 1048576 && (u = zv(e2.map(s2.types, function(h2) {
                  return LC(h2, i2);
                }))), u;
              }
              function RC(r2, i2) {
                var t2 = Zp(U.IntrinsicElements, i2);
                if (!nn(t2)) {
                  var o = r2.value, s2 = bi(t2, e2.escapeLeadingUnderscores(o));
                  if (s2)
                    return Jt(s2);
                  var u = cs(t2, Li);
                  return u || void 0;
                }
                return Oe;
              }
              function L5(r2, i2, t2) {
                if (r2 === 1) {
                  var o = jC(t2);
                  o && hl(i2, o, dt, t2.tagName, e2.Diagnostics.Its_return_type_0_is_not_a_valid_JSX_element, h2);
                } else if (r2 === 0) {
                  var s2 = JC(t2);
                  s2 && hl(i2, s2, dt, t2.tagName, e2.Diagnostics.Its_instance_type_0_is_not_a_valid_JSX_element, h2);
                } else {
                  var o = jC(t2), s2 = JC(t2);
                  if (!o || !s2)
                    return;
                  var u = Pa([o, s2]);
                  hl(i2, u, dt, t2.tagName, e2.Diagnostics.Its_element_type_0_is_not_a_valid_JSX_element, h2);
                }
                function h2() {
                  var z = e2.getTextOfNode(t2.tagName);
                  return e2.chainDiagnosticMessages(void 0, e2.Diagnostics._0_cannot_be_used_as_a_JSX_component, z);
                }
              }
              function BC(r2) {
                e2.Debug.assert(dm(r2.tagName));
                var i2 = va(r2);
                if (!i2.resolvedJsxElementAttributesType) {
                  var t2 = Fb(r2);
                  return i2.jsxFlags & 1 ? i2.resolvedJsxElementAttributesType = Jt(t2) || Pe : i2.jsxFlags & 2 ? i2.resolvedJsxElementAttributesType = cs(Zp(U.IntrinsicElements, r2), Li) || Pe : i2.resolvedJsxElementAttributesType = Pe;
                }
                return i2.resolvedJsxElementAttributesType;
              }
              function JC(r2) {
                var i2 = Zp(U.ElementClass, r2);
                if (!nn(i2))
                  return i2;
              }
              function by(r2) {
                return Zp(U.Element, r2);
              }
              function jC(r2) {
                var i2 = by(r2);
                if (i2)
                  return Pa([i2, Wi]);
              }
              function R5(r2) {
                var i2 = Zp(U.IntrinsicElements, r2);
                return i2 ? uo(i2) : e2.emptyArray;
              }
              function B5(r2) {
                (ye.jsx || 0) === 0 && Xr(r2, e2.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided), by(r2) === void 0 && n && Xr(r2, e2.Diagnostics.JSX_element_implicitly_has_type_any_because_the_global_type_JSX_Element_does_not_exist);
              }
              function Lb(r2) {
                var i2 = e2.isJsxOpeningLikeElement(r2);
                if (i2 && rL(r2), B5(r2), !Mb(r2)) {
                  var t2 = rn && ye.jsx === 2 ? e2.Diagnostics.Cannot_find_name_0 : void 0, o = po(r2), s2 = i2 ? r2.tagName : r2, u = void 0;
                  if (e2.isJsxOpeningFragment(r2) && o === "null" || (u = es(s2, o, 111551, t2, o, true)), u && (u.isReferenced = 67108863, u.flags & 2097152 && !vu(u) && As(u)), e2.isJsxOpeningFragment(r2)) {
                    var h2 = e2.getSourceFileOfNode(r2), z = Gn(h2);
                    z && es(s2, z, 111551, t2, z, true);
                  }
                }
                if (i2) {
                  var me = r2, Me = Mg(me);
                  x0(Me, r2), L5(lk(me), yo(Me), me);
                }
              }
              function Rb(r2, i2, t2) {
                if (r2.flags & 524288) {
                  if (h_(r2, i2) || Xo(r2, i2) || pg(i2) && ss(r2, Li) || t2 && Ob(i2))
                    return true;
                } else if (r2.flags & 3145728 && Sy(r2))
                  for (var o = 0, s2 = r2.types; o < s2.length; o++) {
                    var u = s2[o];
                    if (Rb(u, i2, t2))
                      return true;
                  }
                return false;
              }
              function Sy(r2) {
                return !!(r2.flags & 524288 && !(e2.getObjectFlags(r2) & 512) || r2.flags & 67108864 || r2.flags & 1048576 && e2.some(r2.types, Sy) || r2.flags & 2097152 && e2.every(r2.types, Sy));
              }
              function J5(r2, i2) {
                if (tL(r2), r2.expression) {
                  var t2 = yn(r2.expression, i2);
                  return r2.dotDotDotToken && t2 !== Oe && !Tu(t2) && Xr(r2, e2.Diagnostics.JSX_spread_child_must_be_an_array_type), t2;
                } else
                  return Pe;
              }
              function p0(r2) {
                return r2.valueDeclaration ? e2.getCombinedNodeFlags(r2.valueDeclaration) : 0;
              }
              function Bb(r2) {
                if (r2.flags & 8192 || e2.getCheckFlags(r2) & 4)
                  return true;
                if (e2.isInJSFile(r2.valueDeclaration)) {
                  var i2 = r2.valueDeclaration.parent;
                  return i2 && e2.isBinaryExpression(i2) && e2.getAssignmentDeclarationKind(i2) === 3;
                }
              }
              function Jb(r2, i2, t2, o, s2, u) {
                u === void 0 && (u = true);
                var h2 = u ? r2.kind === 161 ? r2.right : r2.kind === 200 ? r2 : r2.kind === 203 && r2.propertyName ? r2.propertyName : r2.name : void 0;
                return UC(r2, i2, t2, o, s2, h2);
              }
              function UC(r2, i2, t2, o, s2, u) {
                var h2 = e2.getDeclarationModifierFlagsFromSymbol(s2, t2);
                if (i2) {
                  if (Ae < 2 && zC(s2))
                    return u && Xr(u, e2.Diagnostics.Only_public_and_protected_methods_of_the_base_class_are_accessible_via_the_super_keyword), false;
                  if (h2 & 128)
                    return u && Xr(u, e2.Diagnostics.Abstract_method_0_in_class_1_cannot_be_accessed_via_super_expression, tn(s2), Ot(Zd(s2))), false;
                }
                if (h2 & 128 && zC(s2) && (e2.isThisProperty(r2) || e2.isThisInitializedObjectBindingExpression(r2) || e2.isObjectBindingPattern(r2.parent) && e2.isThisInitializedDeclaration(r2.parent.parent))) {
                  var z = e2.getClassLikeDeclarationOfSymbol(Ys(s2));
                  if (z && i9(r2))
                    return u && Xr(u, e2.Diagnostics.Abstract_property_0_in_class_1_cannot_be_accessed_in_the_constructor, tn(s2), e2.getTextOfIdentifierOrLiteral(z.name)), false;
                }
                if (!(h2 & 24))
                  return true;
                if (h2 & 8) {
                  var z = e2.getClassLikeDeclarationOfSymbol(Ys(s2));
                  return MS(r2, z) ? true : (u && Xr(u, e2.Diagnostics.Property_0_is_private_and_only_accessible_within_class_1, tn(s2), Ot(Zd(s2))), false);
                }
                if (i2)
                  return true;
                var me = Y6(r2, function(Me) {
                  var $e = go(Et(Me));
                  return EE($e, s2, t2);
                });
                return !me && (me = j5(r2), me = me && EE(me, s2, t2), h2 & 32 || !me) ? (u && Xr(u, e2.Diagnostics.Property_0_is_protected_and_only_accessible_within_class_1_and_its_subclasses, tn(s2), Ot(Zd(s2) || o)), false) : h2 & 32 ? true : (o.flags & 262144 && (o = o.isThisType ? Tc(o) : uc(o)), !o || !lf(o, me) ? (u && Xr(u, e2.Diagnostics.Property_0_is_protected_and_only_accessible_through_an_instance_of_class_1_This_is_an_instance_of_class_2, tn(s2), Ot(me), Ot(o)), false) : true);
              }
              function j5(r2) {
                var i2 = U5(r2), t2 = (i2 == null ? void 0 : i2.type) && Va(i2.type);
                if (t2 && t2.flags & 262144 && (t2 = Tc(t2)), t2 && e2.getObjectFlags(t2) & 7)
                  return bd(t2);
              }
              function U5(r2) {
                var i2 = e2.getThisContainer(r2, false);
                return i2 && e2.isFunctionLike(i2) ? e2.getThisParameter(i2) : void 0;
              }
              function zC(r2) {
                return !!fy(r2, function(i2) {
                  return !(i2.flags & 8192);
                });
              }
              function gm(r2) {
                return bl(yn(r2), r2);
              }
              function d0(r2) {
                return !!((Ye ? ju(r2) : r2.flags) & 98304);
              }
              function jb(r2) {
                return d0(r2) ? C_(r2) : r2;
              }
              function z5(r2, i2) {
                Xr(r2, i2 & 32768 ? i2 & 65536 ? e2.Diagnostics.Object_is_possibly_null_or_undefined : e2.Diagnostics.Object_is_possibly_undefined : e2.Diagnostics.Object_is_possibly_null);
              }
              function W5(r2, i2) {
                Xr(r2, i2 & 32768 ? i2 & 65536 ? e2.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null_or_undefined : e2.Diagnostics.Cannot_invoke_an_object_which_is_possibly_undefined : e2.Diagnostics.Cannot_invoke_an_object_which_is_possibly_null);
              }
              function WC(r2, i2, t2) {
                if (Ye && r2.flags & 2)
                  return Xr(i2, e2.Diagnostics.Object_is_of_type_unknown), Pe;
                var o = (Ye ? ju(r2) : r2.flags) & 98304;
                if (o) {
                  t2(i2, o);
                  var s2 = C_(r2);
                  return s2.flags & 229376 ? Pe : s2;
                }
                return r2;
              }
              function bl(r2, i2) {
                return WC(r2, i2, z5);
              }
              function qC(r2, i2) {
                var t2 = bl(r2, i2);
                return t2.flags & 16384 && Xr(i2, e2.Diagnostics.Object_is_possibly_undefined), t2;
              }
              function VC(r2, i2) {
                return r2.flags & 32 ? q5(r2, i2) : zb(r2, r2.expression, gm(r2.expression), r2.name, i2);
              }
              function q5(r2, i2) {
                var t2 = yn(r2.expression), o = cv(t2, r2.expression);
                return zh(zb(r2, r2.expression, bl(o, r2.expression), r2.name, i2), r2, o !== t2);
              }
              function KC(r2, i2) {
                var t2 = e2.isPartOfTypeQuery(r2) && e2.isThisIdentifier(r2.left) ? bl(yy(r2.left), r2.left) : gm(r2.left);
                return zb(r2, r2.left, t2, r2.right, i2);
              }
              function GC(r2) {
                for (; r2.parent.kind === 212; )
                  r2 = r2.parent;
                return e2.isCallOrNewExpression(r2.parent) && r2.parent.expression === r2;
              }
              function g0(r2, i2) {
                for (var t2 = e2.getContainingClass(i2); t2; t2 = e2.getContainingClass(t2)) {
                  var o = t2.symbol, s2 = e2.getSymbolNameForPrivateIdentifier(o, r2), u = o.members && o.members.get(s2) || o.exports && o.exports.get(s2);
                  if (u)
                    return u;
                }
              }
              function V5(r2) {
                if (!e2.getContainingClass(r2))
                  return Tt(r2, e2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies);
                if (!e2.isForInStatement(r2.parent)) {
                  if (!e2.isExpressionNode(r2))
                    return Tt(r2, e2.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression);
                  var i2 = e2.isBinaryExpression(r2.parent) && r2.parent.operatorToken.kind === 101;
                  if (!m0(r2) && !i2)
                    return Tt(r2, e2.Diagnostics.Cannot_find_name_0, e2.idText(r2));
                }
                return false;
              }
              function K5(r2) {
                V5(r2);
                var i2 = m0(r2);
                return i2 && xy(i2, void 0, false), Oe;
              }
              function m0(r2) {
                if (!!e2.isExpressionNode(r2)) {
                  var i2 = va(r2);
                  return i2.resolvedSymbol === void 0 && (i2.resolvedSymbol = g0(r2.escapedText, r2)), i2.resolvedSymbol;
                }
              }
              function Ub(r2, i2) {
                return bi(r2, i2.escapedName);
              }
              function G5(r2, i2, t2) {
                var o, s2 = uo(r2);
                s2 && e2.forEach(s2, function(tr) {
                  var dr = tr.valueDeclaration;
                  if (dr && e2.isNamedDeclaration(dr) && e2.isPrivateIdentifier(dr.name) && dr.name.escapedText === i2.escapedText)
                    return o = tr, true;
                });
                var u = ku(i2);
                if (o) {
                  var h2 = e2.Debug.checkDefined(o.valueDeclaration), z = e2.Debug.checkDefined(e2.getContainingClass(h2));
                  if (t2 != null && t2.valueDeclaration) {
                    var me = t2.valueDeclaration, Me = e2.getContainingClass(me);
                    if (e2.Debug.assert(!!Me), e2.findAncestor(Me, function(tr) {
                      return z === tr;
                    })) {
                      var $e = Xr(i2, e2.Diagnostics.The_property_0_cannot_be_accessed_on_type_1_within_this_class_because_it_is_shadowed_by_another_private_identifier_with_the_same_spelling, u, Ot(r2));
                      return e2.addRelatedInfo($e, e2.createDiagnosticForNode(me, e2.Diagnostics.The_shadowing_declaration_of_0_is_defined_here, u), e2.createDiagnosticForNode(h2, e2.Diagnostics.The_declaration_of_0_that_you_probably_intended_to_use_is_defined_here, u)), true;
                    }
                  }
                  return Xr(i2, e2.Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier, u, ku(z.name || C)), true;
                }
                return false;
              }
              function HC(r2, i2) {
                return (Le(i2) || e2.isThisProperty(r2) && Nr(i2)) && e2.getThisContainer(r2, true) === ri(i2);
              }
              function zb(r2, i2, t2, o, s2) {
                var u = va(i2).resolvedSymbol, h2 = e2.getAssignmentTargetKind(r2), z = $s(h2 !== 0 || GC(r2) ? $c(t2) : t2), me = ta(z) || z === Bt, Me;
                if (e2.isPrivateIdentifier(o)) {
                  Ae < 99 && (h2 !== 0 && fc(r2, 1048576), h2 !== 1 && fc(r2, 524288));
                  var $e = g0(o.escapedText, o);
                  if (h2 && $e && $e.valueDeclaration && e2.isMethodDeclaration($e.valueDeclaration) && Tt(o, e2.Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable, e2.idText(o)), me) {
                    if ($e)
                      return nn(z) ? Pe : z;
                    if (!e2.getContainingClass(o))
                      return Tt(o, e2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), Oe;
                  }
                  if (Me = $e ? Ub(t2, $e) : void 0, !Me && G5(t2, o, $e))
                    return Pe;
                  var tr = Me && Me.flags & 65536 && !(Me.flags & 32768);
                  tr && h2 !== 1 && Xr(r2, e2.Diagnostics.Private_accessor_was_defined_without_a_getter);
                } else {
                  if (me)
                    return e2.isIdentifier(i2) && u && o0(u, r2), nn(z) ? Pe : z;
                  Me = bi(z, o.escapedText);
                }
                e2.isIdentifier(i2) && u && (ye.isolatedModules || !(Me && (Av(Me) || Me.flags & 8 && r2.parent.kind === 299)) || e2.shouldPreserveConstEnums(ye) && mC(r2)) && o0(u, r2);
                var dr;
                if (Me) {
                  P_(Me) && mD(r2, Me) && Me.declarations && El(o, Me.declarations, o.escapedText), H5(Me, r2, o), xy(Me, r2, rk(i2, u)), va(r2).resolvedSymbol = Me;
                  var li = e2.isWriteAccess(r2);
                  if (Jb(r2, i2.kind === 106, li, z, Me), jk(r2, Me, h2))
                    return Xr(o, e2.Diagnostics.Cannot_assign_to_0_because_it_is_a_read_only_property, e2.idText(o)), Pe;
                  dr = HC(r2, Me) ? nr : li ? Vg(Me) : Jt(Me);
                } else {
                  var Dr = !e2.isPrivateIdentifier(o) && (h2 === 0 || !Ad(t2) || e2.isThisTypeParameter(t2)) ? Xo(z, o.escapedText) : void 0;
                  if (!(Dr && Dr.type)) {
                    var Qr = Wb(r2, t2.symbol, true);
                    return !Qr && ev(t2) ? Oe : t2.symbol === pe ? (pe.exports.has(o.escapedText) && pe.exports.get(o.escapedText).flags & 418 ? Xr(o, e2.Diagnostics.Property_0_does_not_exist_on_type_1, e2.unescapeLeadingUnderscores(o.escapedText), Ot(t2)) : n && Xr(o, e2.Diagnostics.Element_implicitly_has_an_any_type_because_type_0_has_no_index_signature, Ot(t2)), Oe) : (o.escapedText && !bp(r2) && YC(o, e2.isThisTypeParameter(t2) ? z : t2, Qr), Pe);
                  }
                  Dr.isReadonly && (e2.isAssignmentTarget(r2) || e2.isDeleteTarget(r2)) && Xr(r2, e2.Diagnostics.Index_signature_in_type_0_only_permits_reading, Ot(z)), dr = ye.noUncheckedIndexedAccess && !e2.isAssignmentTarget(r2) ? Pa([Dr.type, Tr]) : Dr.type, ye.noPropertyAccessFromIndexSignature && e2.isPropertyAccessExpression(r2) && Xr(o, e2.Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0, e2.unescapeLeadingUnderscores(o.escapedText)), Dr.declaration && e2.getCombinedNodeFlags(Dr.declaration) & 268435456 && El(o, [Dr.declaration], o.escapedText);
                }
                return XC(r2, Me, dr, o, s2);
              }
              function Wb(r2, i2, t2) {
                var o = e2.getSourceFileOfNode(r2);
                if (o && ye.checkJs === void 0 && o.checkJsDirective === void 0 && (o.scriptKind === 1 || o.scriptKind === 2)) {
                  var s2 = e2.forEach(i2 == null ? void 0 : i2.declarations, e2.getSourceFileOfNode);
                  return !(o !== s2 && !!s2 && Cu(s2)) && !(t2 && i2 && i2.flags & 32) && !(!!r2 && t2 && e2.isPropertyAccessExpression(r2) && r2.expression.kind === 108);
                }
                return false;
              }
              function XC(r2, i2, t2, o, s2) {
                var u = e2.getAssignmentTargetKind(r2);
                if (u === 1)
                  return kg(t2, !!(i2 && i2.flags & 16777216));
                if (i2 && !(i2.flags & 98311) && !(i2.flags & 8192 && t2.flags & 1048576) && !z0(i2.declarations))
                  return t2;
                if (t2 === nr)
                  return ra(r2, i2);
                t2 = yb(t2, r2, s2);
                var h2 = false;
                if (Ye && Ne && e2.isAccessExpression(r2) && r2.expression.kind === 108) {
                  var z = i2 && i2.valueDeclaration;
                  if (z && J6(z) && !e2.isStatic(z)) {
                    var me = _v(r2);
                    me.kind === 171 && me.parent === z.parent && !(z.flags & 16777216) && (h2 = true);
                  }
                } else
                  Ye && i2 && i2.valueDeclaration && e2.isPropertyAccessExpression(i2.valueDeclaration) && e2.getAssignmentDeclarationPropertyAccessKind(i2.valueDeclaration) && _v(r2) === _v(i2.valueDeclaration) && (h2 = true);
                var Me = up(r2, t2, h2 ? i_(t2) : t2);
                return h2 && !(ju(t2) & 32768) && ju(Me) & 32768 ? (Xr(o, e2.Diagnostics.Property_0_is_used_before_being_assigned, tn(i2)), t2) : u ? Kl(Me) : Me;
              }
              function H5(r2, i2, t2) {
                var o = r2.valueDeclaration;
                if (!(!o || e2.getSourceFileOfNode(i2).isDeclarationFile)) {
                  var s2, u = e2.idText(t2);
                  QC(i2) && !qm(o) && !(e2.isAccessExpression(i2) && e2.isAccessExpression(i2.expression)) && !ns(o, t2) && !(e2.isMethodDeclaration(o) && e2.getCombinedModifierFlags(o) & 32) && (ye.useDefineForClassFields || !X5(r2)) ? s2 = Xr(t2, e2.Diagnostics.Property_0_is_used_before_its_initialization, u) : o.kind === 257 && i2.parent.kind !== 178 && !(o.flags & 16777216) && !ns(o, t2) && (s2 = Xr(t2, e2.Diagnostics.Class_0_used_before_its_declaration, u)), s2 && e2.addRelatedInfo(s2, e2.createDiagnosticForNode(o, e2.Diagnostics._0_is_declared_here, u));
                }
              }
              function QC(r2) {
                return !!e2.findAncestor(r2, function(i2) {
                  switch (i2.kind) {
                    case 167:
                      return true;
                    case 296:
                    case 169:
                    case 172:
                    case 173:
                    case 298:
                    case 162:
                    case 233:
                    case 288:
                    case 285:
                    case 286:
                    case 287:
                    case 280:
                    case 228:
                    case 291:
                      return false;
                    case 214:
                    case 238:
                      return e2.isBlock(i2.parent) && e2.isClassStaticBlockDeclaration(i2.parent.parent) ? true : "quit";
                    default:
                      return e2.isExpressionNode(i2) ? false : "quit";
                  }
                });
              }
              function X5(r2) {
                if (!(r2.parent.flags & 32))
                  return false;
                for (var i2 = Jt(r2.parent); ; ) {
                  if (i2 = i2.symbol && Q5(i2), !i2)
                    return false;
                  var t2 = bi(i2, r2.escapedName);
                  if (t2 && t2.valueDeclaration)
                    return true;
                }
              }
              function Q5(r2) {
                var i2 = Qc(r2);
                if (i2.length !== 0)
                  return Do(i2);
              }
              function YC(r2, i2, t2) {
                var o, s2;
                if (!e2.isPrivateIdentifier(r2) && i2.flags & 1048576 && !(i2.flags & 131068))
                  for (var u = 0, h2 = i2.types; u < h2.length; u++) {
                    var z = h2[u];
                    if (!bi(z, r2.escapedText) && !Xo(z, r2.escapedText)) {
                      o = e2.chainDiagnosticMessages(o, e2.Diagnostics.Property_0_does_not_exist_on_type_1, e2.declarationNameToString(r2), Ot(z));
                      break;
                    }
                  }
                if ($C(r2.escapedText, i2)) {
                  var me = e2.declarationNameToString(r2), Me = Ot(i2);
                  o = e2.chainDiagnosticMessages(o, e2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_to_access_the_static_member_2_instead, me, Me, Me + "." + me);
                } else {
                  var $e = Tv(i2);
                  if ($e && bi($e, r2.escapedText))
                    o = e2.chainDiagnosticMessages(o, e2.Diagnostics.Property_0_does_not_exist_on_type_1, e2.declarationNameToString(r2), Ot(i2)), s2 = e2.createDiagnosticForNode(r2, e2.Diagnostics.Did_you_forget_to_use_await);
                  else {
                    var tr = e2.declarationNameToString(r2), dr = Ot(i2), Dr = Z5(tr, i2);
                    if (Dr !== void 0)
                      o = e2.chainDiagnosticMessages(o, e2.Diagnostics.Property_0_does_not_exist_on_type_1_Do_you_need_to_change_your_target_library_Try_changing_the_lib_compiler_option_to_2_or_later, tr, dr, Dr);
                    else {
                      var Qr = qb(r2, i2);
                      if (Qr !== void 0) {
                        var li = e2.symbolName(Qr), Ti = t2 ? e2.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2 : e2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2;
                        o = e2.chainDiagnosticMessages(o, Ti, tr, dr, li), s2 = Qr.valueDeclaration && e2.createDiagnosticForNode(Qr.valueDeclaration, e2.Diagnostics._0_is_declared_here, li);
                      } else {
                        var Ci = Y5(i2) ? e2.Diagnostics.Property_0_does_not_exist_on_type_1_Try_changing_the_lib_compiler_option_to_include_dom : e2.Diagnostics.Property_0_does_not_exist_on_type_1;
                        o = e2.chainDiagnosticMessages(ei(o, i2), Ci, tr, dr);
                      }
                    }
                  }
                }
                var $i = e2.createDiagnosticForNodeFromMessageChain(r2, o);
                s2 && e2.addRelatedInfo($i, s2), Ls(!t2 || o.code !== e2.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code, $i);
              }
              function Y5(r2) {
                return ye.lib && !ye.lib.includes("dom") && h8(r2, function(i2) {
                  return i2.symbol && /^(EventTarget|Node|((HTML[a-zA-Z]*)?Element))$/.test(e2.unescapeLeadingUnderscores(i2.symbol.escapedName));
                }) && Of(r2);
              }
              function $C(r2, i2) {
                var t2 = i2.symbol && bi(Jt(i2.symbol), r2);
                return t2 !== void 0 && !!t2.valueDeclaration && e2.isStatic(t2.valueDeclaration);
              }
              function $5(r2) {
                for (var i2 = ku(r2), t2 = e2.getScriptTargetFeatures(), o = e2.getOwnKeys(t2), s2 = 0, u = o; s2 < u.length; s2++) {
                  var h2 = u[s2], z = e2.getOwnKeys(t2[h2]);
                  if (z !== void 0 && e2.contains(z, i2))
                    return h2;
                }
              }
              function Z5(r2, i2) {
                var t2 = $s(i2).symbol;
                if (!!t2)
                  for (var o = e2.getScriptTargetFeatures(), s2 = e2.getOwnKeys(o), u = 0, h2 = s2; u < h2.length; u++) {
                    var z = h2[u], me = o[z], Me = me[e2.symbolName(t2)];
                    if (Me !== void 0 && e2.contains(Me, r2))
                      return z;
                  }
              }
              function ZC(r2, i2) {
                return Ty(r2, uo(i2), 106500);
              }
              function qb(r2, i2) {
                var t2 = uo(i2);
                if (typeof r2 != "string") {
                  var o = r2.parent;
                  e2.isPropertyAccessExpression(o) && (t2 = e2.filter(t2, function(s2) {
                    return ik(o, i2, s2);
                  })), r2 = e2.idText(r2);
                }
                return Ty(r2, t2, 111551);
              }
              function ek(r2, i2) {
                var t2 = e2.isString(r2) ? r2 : e2.idText(r2), o = uo(i2), s2 = t2 === "for" ? e2.find(o, function(u) {
                  return e2.symbolName(u) === "htmlFor";
                }) : t2 === "class" ? e2.find(o, function(u) {
                  return e2.symbolName(u) === "className";
                }) : void 0;
                return s2 != null ? s2 : Ty(t2, o, 111551);
              }
              function Vb(r2, i2) {
                var t2 = qb(r2, i2);
                return t2 && e2.symbolName(t2);
              }
              function Kb(r2, i2, t2) {
                e2.Debug.assert(i2 !== void 0, "outername should always be defined");
                var o = u_(r2, i2, t2, void 0, i2, false, false, true, function(s2, u, h2) {
                  e2.Debug.assertEqual(i2, u, "name should equal outerName");
                  var z = qs(s2, u, h2);
                  if (z)
                    return z;
                  var me;
                  if (s2 === ii) {
                    var Me = e2.mapDefined(["string", "number", "boolean", "object", "bigint", "symbol"], function($e) {
                      return s2.has($e.charAt(0).toUpperCase() + $e.slice(1)) ? oo(524288, $e) : void 0;
                    });
                    me = Me.concat(e2.arrayFrom(s2.values()));
                  } else
                    me = e2.arrayFrom(s2.values());
                  return Ty(e2.unescapeLeadingUnderscores(u), me, h2);
                });
                return o;
              }
              function e7(r2, i2, t2) {
                var o = Kb(r2, i2, t2);
                return o && e2.symbolName(o);
              }
              function v0(r2, i2) {
                return i2.exports && Ty(e2.idText(r2), J_(i2), 2623475);
              }
              function r7(r2, i2) {
                var t2 = v0(r2, i2);
                return t2 && e2.symbolName(t2);
              }
              function i7(r2, i2, t2) {
                function o(h2) {
                  var z = h_(r2, h2);
                  if (z) {
                    var me = ig(Jt(z));
                    return !!me && Hl(me) >= 1 && ao(t2, $u(me, 0));
                  }
                  return false;
                }
                var s2 = e2.isAssignmentTarget(i2) ? "set" : "get";
                if (!!o(s2)) {
                  var u = e2.tryGetPropertyAccessOrIdentifierToString(i2.expression);
                  return u === void 0 ? u = s2 : u += "." + s2, u;
                }
              }
              function t7(r2, i2) {
                var t2 = i2.types.filter(function(o) {
                  return !!(o.flags & 128);
                });
                return e2.getSpellingSuggestion(r2.value, t2, function(o) {
                  return o.value;
                });
              }
              function Ty(r2, i2, t2) {
                return e2.getSpellingSuggestion(r2, i2, o);
                function o(s2) {
                  var u = e2.symbolName(s2);
                  if (!e2.startsWith(u, '"')) {
                    if (s2.flags & t2)
                      return u;
                    if (s2.flags & 2097152) {
                      var h2 = d_(s2);
                      if (h2 && h2.flags & t2)
                        return u;
                    }
                  }
                }
              }
              function xy(r2, i2, t2) {
                var o = r2 && r2.flags & 106500 && r2.valueDeclaration;
                if (!!o) {
                  var s2 = e2.hasEffectiveModifier(o, 8), u = r2.valueDeclaration && e2.isNamedDeclaration(r2.valueDeclaration) && e2.isPrivateIdentifier(r2.valueDeclaration.name);
                  if (!(!s2 && !u) && !(i2 && e2.isWriteOnlyAccess(i2) && !(r2.flags & 65536))) {
                    if (t2) {
                      var h2 = e2.findAncestor(i2, e2.isFunctionLikeDeclaration);
                      if (h2 && h2.symbol === r2)
                        return;
                    }
                    (e2.getCheckFlags(r2) & 1 ? Aa(r2).target : r2).isReferenced = 67108863;
                  }
                }
              }
              function rk(r2, i2) {
                return r2.kind === 108 || !!i2 && e2.isEntityNameExpression(r2) && i2 === Dl(e2.getFirstIdentifier(r2));
              }
              function a7(r2, i2) {
                switch (r2.kind) {
                  case 206:
                    return Gb(r2, r2.expression.kind === 106, i2, $c(yn(r2.expression)));
                  case 161:
                    return Gb(r2, false, i2, $c(yn(r2.left)));
                  case 200:
                    return Gb(r2, false, i2, Va(r2));
                }
              }
              function ik(r2, i2, t2) {
                return Hb(r2, r2.kind === 206 && r2.expression.kind === 106, false, i2, t2);
              }
              function Gb(r2, i2, t2, o) {
                if (ta(o))
                  return true;
                var s2 = bi(o, t2);
                return !!s2 && Hb(r2, i2, false, o, s2);
              }
              function Hb(r2, i2, t2, o, s2) {
                if (ta(o))
                  return true;
                if (s2.valueDeclaration && e2.isPrivateIdentifierClassElementDeclaration(s2.valueDeclaration)) {
                  var u = e2.getContainingClass(s2.valueDeclaration);
                  return !e2.isOptionalChain(r2) && !!e2.findAncestor(r2, function(h2) {
                    return h2 === u;
                  });
                }
                return UC(r2, i2, t2, o, s2);
              }
              function n7(r2) {
                var i2 = r2.initializer;
                if (i2.kind === 255) {
                  var t2 = i2.declarations[0];
                  if (t2 && !e2.isBindingPattern(t2.name))
                    return Et(t2);
                } else if (i2.kind === 79)
                  return Dl(i2);
              }
              function o7(r2) {
                return Hn(r2).length === 1 && !!ss(r2, nt);
              }
              function s7(r2) {
                var i2 = e2.skipParentheses(r2);
                if (i2.kind === 79) {
                  var t2 = Dl(i2);
                  if (t2.flags & 3)
                    for (var o = r2, s2 = r2.parent; s2; ) {
                      if (s2.kind === 243 && o === s2.statement && n7(s2) === t2 && o7(Gs(s2.expression)))
                        return true;
                      o = s2, s2 = s2.parent;
                    }
                }
                return false;
              }
              function c7(r2, i2) {
                return r2.flags & 32 ? u7(r2, i2) : tk(r2, gm(r2.expression), i2);
              }
              function u7(r2, i2) {
                var t2 = yn(r2.expression), o = cv(t2, r2.expression);
                return zh(tk(r2, bl(o, r2.expression), i2), r2, o !== t2);
              }
              function tk(r2, i2, t2) {
                var o = e2.getAssignmentTargetKind(r2) !== 0 || GC(r2) ? $c(i2) : i2, s2 = r2.argumentExpression, u = yn(s2);
                if (nn(o) || o === Bt)
                  return o;
                if (uS(o) && !e2.isStringLiteralLike(s2))
                  return Xr(s2, e2.Diagnostics.A_const_enum_member_can_only_be_accessed_using_a_string_literal), Pe;
                var h2 = s7(s2) ? nt : u, z = e2.isAssignmentTarget(r2) ? 4 | (Ad(o) && !e2.isThisTypeParameter(o) ? 2 : 0) : 32, me = ep(o, h2, z, r2) || Pe;
                return o6(XC(r2, va(r2).resolvedSymbol, me, s2, t2), r2);
              }
              function ak(r2) {
                return e2.isCallOrNewExpression(r2) || e2.isTaggedTemplateExpression(r2) || e2.isJsxOpeningLikeElement(r2);
              }
              function Fg(r2) {
                return ak(r2) && e2.forEach(r2.typeArguments, io), r2.kind === 210 ? yn(r2.template) : e2.isJsxOpeningLikeElement(r2) ? yn(r2.attributes) : r2.kind !== 165 && e2.forEach(r2.arguments, function(i2) {
                  yn(i2);
                }), En;
              }
              function Gl(r2) {
                return Fg(r2), Wn;
              }
              function l7(r2, i2, t2) {
                var o, s2, u = 0, h2, z = -1, me;
                e2.Debug.assert(!i2.length);
                for (var Me = 0, $e = r2; Me < $e.length; Me++) {
                  var tr = $e[Me], dr = tr.declaration && Et(tr.declaration), Dr = tr.declaration && tr.declaration.parent;
                  !s2 || dr === s2 ? o && Dr === o ? h2 = h2 + 1 : (o = Dr, h2 = u) : (h2 = u = i2.length, o = Dr), s2 = dr, I(tr) ? (z++, me = z, u++) : me = h2, i2.splice(me, 0, t2 ? w1(tr, t2) : tr);
                }
              }
              function y0(r2) {
                return !!r2 && (r2.kind === 225 || r2.kind === 232 && r2.isSpread);
              }
              function h0(r2) {
                return e2.findIndex(r2, y0);
              }
              function nk(r2) {
                return !!(r2.flags & 16384);
              }
              function f7(r2) {
                return !!(r2.flags & 49155);
              }
              function D0(r2, i2, t2, o) {
                o === void 0 && (o = false);
                var s2, u = false, h2 = Wc(t2), z = Hl(t2);
                if (r2.kind === 210)
                  if (s2 = i2.length, r2.template.kind === 223) {
                    var me = e2.last(r2.template.templateSpans);
                    u = e2.nodeIsMissing(me.literal) || !!me.literal.isUnterminated;
                  } else {
                    var Me = r2.template;
                    e2.Debug.assert(Me.kind === 14), u = !!Me.isUnterminated;
                  }
                else if (r2.kind === 165)
                  s2 = _k(r2, t2);
                else if (e2.isJsxOpeningLikeElement(r2)) {
                  if (u = r2.attributes.end === r2.end, u)
                    return true;
                  s2 = z === 0 ? i2.length : 1, h2 = i2.length === 0 ? h2 : 1, z = Math.min(z, 1);
                } else if (r2.arguments) {
                  s2 = o ? i2.length + 1 : i2.length, u = r2.arguments.end === r2.end;
                  var $e = h0(i2);
                  if ($e >= 0)
                    return $e >= Hl(t2) && (Xl(t2) || $e < Wc(t2));
                } else
                  return e2.Debug.assert(r2.kind === 209), Hl(t2) === 0;
                if (!Xl(t2) && s2 > h2)
                  return false;
                if (u || s2 >= z)
                  return true;
                for (var tr = s2; tr < z; tr++) {
                  var dr = $u(t2, tr);
                  if (ec(dr, e2.isInJSFile(r2) && !Ye ? f7 : nk).flags & 131072)
                    return false;
                }
                return true;
              }
              function Xb(r2, i2) {
                var t2 = e2.length(r2.typeParameters), o = Ul(r2.typeParameters);
                return !e2.some(i2) || i2.length >= o && i2.length <= t2;
              }
              function ig(r2) {
                return gv(r2, 0, false);
              }
              function ok(r2) {
                return gv(r2, 0, false) || gv(r2, 1, false);
              }
              function gv(r2, i2, t2) {
                if (r2.flags & 524288) {
                  var o = Ru(r2);
                  if (t2 || o.properties.length === 0 && o.indexInfos.length === 0) {
                    if (i2 === 0 && o.callSignatures.length === 1 && o.constructSignatures.length === 0)
                      return o.callSignatures[0];
                    if (i2 === 1 && o.constructSignatures.length === 1 && o.callSignatures.length === 0)
                      return o.constructSignatures[0];
                  }
                }
              }
              function sk(r2, i2, t2, o) {
                var s2 = uv(r2.typeParameters, r2, 0, o), u = vv(i2), h2 = t2 && (u && u.flags & 262144 ? t2.nonFixingMapper : t2.mapper), z = h2 ? Tg(i2, h2) : i2;
                return eb(z, r2, function(me, Me) {
                  df(s2.inferences, me, Me);
                }), t2 || rb(i2, r2, function(me, Me) {
                  df(s2.inferences, me, Me, 128);
                }), Xm(r2, _b(s2), e2.isInJSFile(i2.declaration));
              }
              function _7(r2, i2, t2, o) {
                var s2 = l0(i2, r2), u = Rg(r2.attributes, s2, o, t2);
                return df(o.inferences, u, s2), _b(o);
              }
              function ck(r2) {
                if (!r2)
                  return Fi;
                var i2 = yn(r2);
                return e2.isOptionalChainRoot(r2.parent) ? C_(i2) : e2.isOptionalChain(r2.parent) ? YD(i2) : i2;
              }
              function Qb(r2, i2, t2, o, s2) {
                if (e2.isJsxOpeningLikeElement(r2))
                  return _7(r2, i2, o, s2);
                if (r2.kind !== 165) {
                  var u = ou(r2, e2.every(i2.typeParameters, function(Sn) {
                    return !!D_(Sn);
                  }) ? 8 : 0);
                  if (u) {
                    var h2 = yo(i2);
                    if (Id(h2)) {
                      var z = wg(r2), me = ab(Jw(z, 1)), Me = un(u, me), $e = ig(Me), tr = $e && $e.typeParameters ? im(eD($e, $e.typeParameters)) : Me;
                      df(s2.inferences, tr, h2, 128);
                      var dr = uv(i2.typeParameters, i2, s2.flags), Dr = un(u, z && z.returnMapper);
                      df(dr.inferences, Dr, h2), s2.returnMapper = e2.some(dr.inferences, tg) ? ab(Uw(dr)) : void 0;
                    }
                  }
                }
                var Qr = yv(i2), li = Qr ? Math.min(Wc(i2) - 1, t2.length) : t2.length;
                if (Qr && Qr.flags & 262144) {
                  var Ti = e2.find(s2.inferences, function(Sn) {
                    return Sn.typeParameter === Qr;
                  });
                  Ti && (Ti.impliedArity = e2.findIndex(t2, y0, li) < 0 ? t2.length - li : void 0);
                }
                var Ci = T_(i2);
                if (Ci && Id(Ci)) {
                  var $i = fk(r2);
                  df(s2.inferences, ck($i), Ci);
                }
                for (var Zi = 0; Zi < li; Zi++) {
                  var qt = t2[Zi];
                  if (qt.kind !== 227 && !(o & 32 && ub(qt))) {
                    var Nt = $u(i2, Zi);
                    if (Id(Nt)) {
                      var Ra = Rg(qt, Nt, s2, o);
                      df(s2.inferences, Ra, Nt);
                    }
                  }
                }
                if (Qr && Id(Qr)) {
                  var ca = Yb(t2, li, t2.length, Qr, s2, o);
                  df(s2.inferences, ca, Qr);
                }
                return _b(s2);
              }
              function uk(r2) {
                return r2.flags & 1048576 ? Ss(r2, uk) : r2.flags & 1 || Bh(uc(r2) || r2) ? r2 : Yn(r2) ? Wl(xo(r2), r2.target.elementFlags, false, r2.target.labeledElementDeclarations) : Wl([r2], [8]);
              }
              function Yb(r2, i2, t2, o, s2, u) {
                if (i2 >= t2 - 1) {
                  var h2 = r2[t2 - 1];
                  if (y0(h2))
                    return uk(h2.kind === 232 ? h2.type : Rg(h2.expression, o, s2, u));
                }
                for (var z = [], me = [], Me = [], $e = i2; $e < t2; $e++) {
                  var h2 = r2[$e];
                  if (y0(h2)) {
                    var tr = h2.kind === 232 ? h2.type : yn(h2.expression);
                    sp(tr) ? (z.push(tr), me.push(8)) : (z.push(N_(33, tr, Tr, h2.kind === 225 ? h2.expression : h2)), me.push(4));
                  } else {
                    var dr = Jc(o, If($e - i2), 256), Dr = Rg(h2, dr, s2, u), Qr = fs4(dr, 406978556);
                    z.push(Qr ? jc(Dr) : Hp(Dr)), me.push(1);
                  }
                  h2.kind === 232 && h2.tupleNameSource && Me.push(h2.tupleNameSource);
                }
                return Wl(z, me, false, e2.length(Me) === e2.length(z) ? Me : void 0);
              }
              function $b(r2, i2, t2, o) {
                for (var s2 = e2.isInJSFile(r2.declaration), u = r2.typeParameters, h2 = zp(e2.map(i2, Va), u, Ul(u), s2), z, me = 0; me < i2.length; me++) {
                  e2.Debug.assert(u[me] !== void 0, "Should not call checkTypeArguments with too many type arguments");
                  var Me = Tc(u[me]);
                  if (Me) {
                    var $e = t2 && o ? function() {
                      return e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1);
                    } : void 0, tr = o || e2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1;
                    z || (z = Uc(u, h2));
                    var dr = h2[me];
                    if (!zc(dr, Rc(un(Me, z), dr), t2 ? i2[me] : void 0, tr, $e))
                      return;
                  }
                }
                return h2;
              }
              function lk(r2) {
                if (dm(r2.tagName))
                  return 2;
                var i2 = $s(yn(r2.tagName));
                return e2.length(ot(i2, 1)) ? 0 : e2.length(ot(i2, 0)) ? 1 : 2;
              }
              function p7(r2, i2, t2, o, s2, u, h2) {
                var z = l0(i2, r2), me = Rg(r2.attributes, z, void 0, o);
                return Me() && FD(me, z, t2, s2 ? r2.tagName : void 0, r2.attributes, void 0, u, h2);
                function Me() {
                  var $e;
                  if (Mb(r2))
                    return true;
                  var tr = e2.isJsxOpeningElement(r2) || e2.isJsxSelfClosingElement(r2) && !dm(r2.tagName) ? yn(r2.tagName) : void 0;
                  if (!tr)
                    return true;
                  var dr = ot(tr, 0);
                  if (!e2.length(dr))
                    return true;
                  var Dr = oA(r2);
                  if (!Dr)
                    return true;
                  var Qr = Ds(Dr, 111551, true, false, r2);
                  if (!Qr)
                    return true;
                  var li = Jt(Qr), Ti = ot(li, 0);
                  if (!e2.length(Ti))
                    return true;
                  for (var Ci = false, $i = 0, Zi = 0, qt = Ti; Zi < qt.length; Zi++) {
                    var Nt = qt[Zi], Ra = $u(Nt, 0), ca = ot(Ra, 0);
                    if (!!e2.length(ca))
                      for (var Sn = 0, ja = ca; Sn < ja.length; Sn++) {
                        var Fn = ja[Sn];
                        if (Ci = true, Xl(Fn))
                          return true;
                        var wn = Wc(Fn);
                        wn > $i && ($i = wn);
                      }
                  }
                  if (!Ci)
                    return true;
                  for (var Tn = 1 / 0, Eo = 0, lt = dr; Eo < lt.length; Eo++) {
                    var it = lt[Eo], Yt = Hl(it);
                    Yt < Tn && (Tn = Yt);
                  }
                  if (Tn <= $i)
                    return true;
                  if (s2) {
                    var Ia = e2.createDiagnosticForNode(r2.tagName, e2.Diagnostics.Tag_0_expects_at_least_1_arguments_but_the_JSX_factory_2_provides_at_most_3, e2.entityNameToString(r2.tagName), Tn, e2.entityNameToString(Dr), $i), Qt = ($e = el(r2.tagName)) === null || $e === void 0 ? void 0 : $e.valueDeclaration;
                    Qt && e2.addRelatedInfo(Ia, e2.createDiagnosticForNode(Qt, e2.Diagnostics._0_is_declared_here, e2.entityNameToString(r2.tagName))), h2 && h2.skipLogging && (h2.errors || (h2.errors = [])).push(Ia), h2.skipLogging || rn.add(Ia);
                  }
                  return false;
                }
              }
              function Ey(r2, i2, t2, o, s2, u, h2) {
                var z = { errors: void 0, skipLogging: true };
                if (e2.isJsxOpeningLikeElement(r2))
                  return p7(r2, t2, o, s2, u, h2, z) ? void 0 : (e2.Debug.assert(!u || !!z.errors, "jsx should have errors when reporting errors"), z.errors || e2.emptyArray);
                var me = T_(t2);
                if (me && me !== Fi && r2.kind !== 209) {
                  var Me = fk(r2), $e = ck(Me), tr = u ? Me || r2 : void 0, dr = e2.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1;
                  if (!hl($e, me, o, tr, dr, h2, z))
                    return e2.Debug.assert(!u || !!z.errors, "this parameter should have errors when reporting errors"), z.errors || e2.emptyArray;
                }
                for (var Dr = e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1, Qr = yv(t2), li = Qr ? Math.min(Wc(t2) - 1, i2.length) : i2.length, Ti = 0; Ti < li; Ti++) {
                  var Ci = i2[Ti];
                  if (Ci.kind !== 227) {
                    var $i = $u(t2, Ti), Zi = Rg(Ci, $i, void 0, s2), qt = s2 & 4 ? fm(Zi) : Zi;
                    if (!FD(qt, $i, o, u ? Ci : void 0, Ci, Dr, h2, z))
                      return e2.Debug.assert(!u || !!z.errors, "parameter should have errors when reporting errors"), ca(Ci, qt, $i), z.errors || e2.emptyArray;
                  }
                }
                if (Qr) {
                  var Nt = Yb(i2, li, i2.length, Qr, void 0, s2), Ra = i2.length - li, tr = u ? Ra === 0 ? r2 : Ra === 1 ? i2[li] : e2.setTextRangePosEnd(ed(r2, Nt), i2[li].pos, i2[i2.length - 1].end) : void 0;
                  if (!hl(Nt, Qr, o, tr, Dr, void 0, z))
                    return e2.Debug.assert(!u || !!z.errors, "rest parameter should have errors when reporting errors"), ca(tr, Nt, Qr), z.errors || e2.emptyArray;
                }
                return;
                function ca(Sn, ja, Fn) {
                  if (Sn && u && z.errors && z.errors.length) {
                    if (Sv(Fn))
                      return;
                    var wn = Sv(ja);
                    wn && r_(wn, Fn, o) && e2.addRelatedInfo(z.errors[0], e2.createDiagnosticForNode(Sn, e2.Diagnostics.Did_you_forget_to_use_await));
                  }
                }
              }
              function fk(r2) {
                var i2 = r2.kind === 208 ? r2.expression : r2.kind === 210 ? r2.tag : void 0;
                if (i2) {
                  var t2 = e2.skipOuterExpressions(i2);
                  if (e2.isAccessExpression(t2))
                    return t2.expression;
                }
              }
              function ed(r2, i2, t2, o) {
                var s2 = e2.parseNodeFactory.createSyntheticExpression(i2, t2, o);
                return e2.setTextRange(s2, r2), e2.setParent(s2, r2), s2;
              }
              function Zb(r2) {
                if (r2.kind === 210) {
                  var i2 = r2.template, t2 = [ed(i2, T3())];
                  return i2.kind === 223 && e2.forEach(i2.templateSpans, function(me) {
                    t2.push(me.expression);
                  }), t2;
                }
                if (r2.kind === 165)
                  return d7(r2);
                if (e2.isJsxOpeningLikeElement(r2))
                  return r2.attributes.properties.length > 0 || e2.isJsxOpeningElement(r2) && r2.parent.children.length > 0 ? [r2.attributes] : e2.emptyArray;
                var o = r2.arguments || e2.emptyArray, s2 = h0(o);
                if (s2 >= 0) {
                  for (var u = o.slice(0, s2), h2 = function(me) {
                    var Me = o[me], $e = Me.kind === 225 && (Ao ? yn(Me.expression) : Os(Me.expression));
                    $e && Yn($e) ? e2.forEach(xo($e), function(tr, dr) {
                      var Dr, Qr = $e.target.elementFlags[dr], li = ed(Me, Qr & 4 ? Zs(tr) : tr, !!(Qr & 12), (Dr = $e.target.labeledElementDeclarations) === null || Dr === void 0 ? void 0 : Dr[dr]);
                      u.push(li);
                    }) : u.push(Me);
                  }, z = s2; z < o.length; z++)
                    h2(z);
                  return u;
                }
                return o;
              }
              function d7(r2) {
                var i2 = r2.parent, t2 = r2.expression;
                switch (i2.kind) {
                  case 257:
                  case 226:
                    return [ed(t2, Jt(Et(i2)))];
                  case 164:
                    var o = i2.parent;
                    return [ed(t2, i2.parent.kind === 171 ? Jt(Et(o)) : Pe), ed(t2, Oe), ed(t2, nt)];
                  case 167:
                  case 169:
                  case 172:
                  case 173:
                    var s2 = i2.kind !== 167 && Ae !== 0;
                    return [ed(t2, l9(i2)), ed(t2, f9(i2)), ed(t2, s2 ? Px(Bd(i2)) : Oe)];
                }
                return e2.Debug.fail();
              }
              function _k(r2, i2) {
                switch (r2.parent.kind) {
                  case 257:
                  case 226:
                    return 1;
                  case 167:
                    return 2;
                  case 169:
                  case 172:
                  case 173:
                    return Ae === 0 || i2.parameters.length <= 2 ? 2 : 3;
                  case 164:
                    return 3;
                  default:
                    return e2.Debug.fail();
                }
              }
              function pk(r2, i2) {
                var t2, o, s2 = e2.getSourceFileOfNode(r2);
                if (e2.isPropertyAccessExpression(r2.expression)) {
                  var u = e2.getErrorSpanForNode(s2, r2.expression.name);
                  t2 = u.start, o = i2 ? u.length : r2.end - t2;
                } else {
                  var h2 = e2.getErrorSpanForNode(s2, r2.expression);
                  t2 = h2.start, o = i2 ? h2.length : r2.end - t2;
                }
                return { start: t2, length: o, sourceFile: s2 };
              }
              function Cy(r2, i2, t2, o, s2, u) {
                if (e2.isCallExpression(r2)) {
                  var h2 = pk(r2), z = h2.sourceFile, me = h2.start, Me = h2.length;
                  return e2.createFileDiagnostic(z, me, Me, i2, t2, o, s2, u);
                } else
                  return e2.createDiagnosticForNode(r2, i2, t2, o, s2, u);
              }
              function g7(r2) {
                if (!e2.isCallExpression(r2) || !e2.isIdentifier(r2.expression))
                  return false;
                var i2 = es(r2.expression, r2.expression.escapedText, 111551, void 0, void 0, false), t2 = i2 == null ? void 0 : i2.valueDeclaration;
                if (!t2 || !e2.isParameter(t2) || !e2.isFunctionExpressionOrArrowFunction(t2.parent) || !e2.isNewExpression(t2.parent.parent) || !e2.isIdentifier(t2.parent.parent.expression))
                  return false;
                var o = nD(false);
                if (!o)
                  return false;
                var s2 = el(t2.parent.parent.expression, true);
                return s2 === o;
              }
              function dk(r2, i2, t2) {
                var o, s2 = h0(t2);
                if (s2 > -1)
                  return e2.createDiagnosticForNode(t2[s2], e2.Diagnostics.A_spread_argument_must_either_have_a_tuple_type_or_be_passed_to_a_rest_parameter);
                for (var u = Number.POSITIVE_INFINITY, h2 = Number.NEGATIVE_INFINITY, z = Number.NEGATIVE_INFINITY, me = Number.POSITIVE_INFINITY, Me, $e = 0, tr = i2; $e < tr.length; $e++) {
                  var dr = tr[$e], Dr = Hl(dr), Qr = Wc(dr);
                  Dr < u && (u = Dr, Me = dr), h2 = Math.max(h2, Qr), Dr < t2.length && Dr > z && (z = Dr), t2.length < Qr && Qr < me && (me = Qr);
                }
                var li = e2.some(i2, Xl), Ti = li ? u : u < h2 ? u + "-" + h2 : u, Ci = !li && Ti === 1 && t2.length === 0 && g7(r2);
                if (Ci && e2.isInJSFile(r2))
                  return Cy(r2, e2.Diagnostics.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments);
                var $i = li ? e2.Diagnostics.Expected_at_least_0_arguments_but_got_1 : Ci ? e2.Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise : e2.Diagnostics.Expected_0_arguments_but_got_1;
                if (u < t2.length && t2.length < h2)
                  return Cy(r2, e2.Diagnostics.No_overload_expects_0_arguments_but_overloads_do_exist_that_expect_either_1_or_2_arguments, t2.length, z, me);
                if (t2.length < u) {
                  var Zi = Cy(r2, $i, Ti, t2.length), qt = (o = Me == null ? void 0 : Me.declaration) === null || o === void 0 ? void 0 : o.parameters[Me.thisParameter ? t2.length + 1 : t2.length];
                  if (qt) {
                    var Nt = e2.createDiagnosticForNode(qt, e2.isBindingPattern(qt.name) ? e2.Diagnostics.An_argument_matching_this_binding_pattern_was_not_provided : e2.isRestParameter(qt) ? e2.Diagnostics.Arguments_for_the_rest_parameter_0_were_not_provided : e2.Diagnostics.An_argument_for_0_was_not_provided, qt.name ? e2.isBindingPattern(qt.name) ? void 0 : e2.idText(e2.getFirstIdentifier(qt.name)) : t2.length);
                    return e2.addRelatedInfo(Zi, Nt);
                  }
                  return Zi;
                } else {
                  var Ra = e2.factory.createNodeArray(t2.slice(h2)), ca = e2.first(Ra).pos, Sn = e2.last(Ra).end;
                  return Sn === ca && Sn++, e2.setTextRangePosEnd(Ra, ca, Sn), e2.createDiagnosticForNodeArray(e2.getSourceFileOfNode(r2), Ra, $i, Ti, t2.length);
                }
              }
              function m7(r2, i2, t2) {
                var o = t2.length;
                if (i2.length === 1) {
                  var s2 = i2[0], u = Ul(s2.typeParameters), h2 = e2.length(s2.typeParameters);
                  return e2.createDiagnosticForNodeArray(e2.getSourceFileOfNode(r2), t2, e2.Diagnostics.Expected_0_type_arguments_but_got_1, u < h2 ? u + "-" + h2 : u, o);
                }
                for (var z = -1 / 0, me = 1 / 0, Me = 0, $e = i2; Me < $e.length; Me++) {
                  var s2 = $e[Me], tr = Ul(s2.typeParameters), h2 = e2.length(s2.typeParameters);
                  tr > o ? me = Math.min(me, tr) : h2 < o && (z = Math.max(z, h2));
                }
                return z !== -1 / 0 && me !== 1 / 0 ? e2.createDiagnosticForNodeArray(e2.getSourceFileOfNode(r2), t2, e2.Diagnostics.No_overload_expects_0_type_arguments_but_overloads_do_exist_that_expect_either_1_or_2_type_arguments, o, z, me) : e2.createDiagnosticForNodeArray(e2.getSourceFileOfNode(r2), t2, e2.Diagnostics.Expected_0_type_arguments_but_got_1, z === -1 / 0 ? me : z, o);
              }
              function mm(r2, i2, t2, o, s2, u) {
                var h2 = r2.kind === 210, z = r2.kind === 165, me = e2.isJsxOpeningLikeElement(r2), Me = !t2, $e;
                z || ($e = r2.typeArguments, (h2 || me || r2.expression.kind !== 106) && e2.forEach($e, io));
                var tr = t2 || [];
                if (l7(i2, tr, s2), !tr.length)
                  return Me && rn.add(Cy(r2, e2.Diagnostics.Call_target_does_not_contain_any_signatures)), Gl(r2);
                var dr = Zb(r2), Dr = tr.length === 1 && !tr[0].typeParameters, Qr = !z && !Dr && e2.some(dr, Ju) ? 4 : 0;
                Qr |= o & 32;
                var li, Ti, Ci, $i, Zi = !!(o & 16) && r2.kind === 208 && r2.arguments.hasTrailingComma;
                if (tr.length > 1 && ($i = ea(tr, Or, Dr, Zi)), $i || ($i = ea(tr, dt, Dr, Zi)), $i)
                  return $i;
                if (Me)
                  if (li)
                    if (li.length === 1 || li.length > 3) {
                      var qt = li[li.length - 1], Nt;
                      li.length > 3 && (Nt = e2.chainDiagnosticMessages(Nt, e2.Diagnostics.The_last_overload_gave_the_following_error), Nt = e2.chainDiagnosticMessages(Nt, e2.Diagnostics.No_overload_matches_this_call));
                      var Ra = Ey(r2, dr, qt, dt, 0, true, function() {
                        return Nt;
                      });
                      if (Ra)
                        for (var ca = 0, Sn = Ra; ca < Sn.length; ca++) {
                          var ja = Sn[ca];
                          qt.declaration && li.length > 3 && e2.addRelatedInfo(ja, e2.createDiagnosticForNode(qt.declaration, e2.Diagnostics.The_last_overload_is_declared_here)), Lt(qt, ja), rn.add(ja);
                        }
                      else
                        e2.Debug.fail("No error for last overload signature");
                    } else {
                      for (var Fn = [], wn = 0, Tn = Number.MAX_VALUE, Eo = 0, lt = 0, it = function(Kt) {
                        var $t = function() {
                          return e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Overload_0_of_1_2_gave_the_following_error, lt + 1, tr.length, Ml(Kt));
                        }, Ua = Ey(r2, dr, Kt, dt, 0, true, $t);
                        Ua ? (Ua.length <= Tn && (Tn = Ua.length, Eo = lt), wn = Math.max(wn, Ua.length), Fn.push(Ua)) : e2.Debug.fail("No error for 3 or fewer overload signatures"), lt++;
                      }, Yt = 0, Ia = li; Yt < Ia.length; Yt++) {
                        var Qt = Ia[Yt];
                        it(Qt);
                      }
                      var Ka = wn > 1 ? Fn[Eo] : e2.flatten(Fn);
                      e2.Debug.assert(Ka.length > 0, "No errors reported for 3 or fewer overload signatures");
                      var cn = e2.chainDiagnosticMessages(e2.map(Ka, e2.createDiagnosticMessageChainFromDiagnostic), e2.Diagnostics.No_overload_matches_this_call), Un = Ve([], e2.flatMap(Ka, function(Kt) {
                        return Kt.relatedInformation;
                      }), true), oa = void 0;
                      if (e2.every(Ka, function(Kt) {
                        return Kt.start === Ka[0].start && Kt.length === Ka[0].length && Kt.file === Ka[0].file;
                      })) {
                        var Mn = Ka[0], Ln = Mn.file, ci = Mn.start, Fr = Mn.length;
                        oa = { file: Ln, start: ci, length: Fr, code: cn.code, category: cn.category, messageText: cn, relatedInformation: Un };
                      } else
                        oa = e2.createDiagnosticForNodeFromMessageChain(r2, cn, Un);
                      Lt(li[0], oa), rn.add(oa);
                    }
                  else if (Ti)
                    rn.add(dk(r2, [Ti], dr));
                  else if (Ci)
                    $b(Ci, r2.typeArguments, true, u);
                  else {
                    var jt = e2.filter(i2, function(Kt) {
                      return Xb(Kt, $e);
                    });
                    jt.length === 0 ? rn.add(m7(r2, i2, $e)) : z ? u && rn.add(Cy(r2, u)) : rn.add(dk(r2, jt, dr));
                  }
                return v7(r2, tr, dr, !!t2, o);
                function Lt(Kt, $t) {
                  var Ua, Yr, Ni = li, Hi = Ti, _t = Ci, gt = ((Yr = (Ua = Kt.declaration) === null || Ua === void 0 ? void 0 : Ua.symbol) === null || Yr === void 0 ? void 0 : Yr.declarations) || e2.emptyArray, Vt = gt.length > 1, Fa = Vt ? e2.find(gt, function(Ga) {
                    return e2.isFunctionLikeDeclaration(Ga) && e2.nodeIsPresent(Ga.body);
                  }) : void 0;
                  if (Fa) {
                    var on = yl(Fa), zn = !on.typeParameters;
                    ea([on], dt, zn) && e2.addRelatedInfo($t, e2.createDiagnosticForNode(Fa, e2.Diagnostics.The_call_would_have_succeeded_against_this_implementation_but_implementation_signatures_of_overloads_are_not_externally_visible));
                  }
                  li = Ni, Ti = Hi, Ci = _t;
                }
                function ea(Kt, $t, Ua, Yr) {
                  if (Yr === void 0 && (Yr = false), li = void 0, Ti = void 0, Ci = void 0, Ua) {
                    var Ni = Kt[0];
                    if (e2.some($e) || !D0(r2, dr, Ni, Yr))
                      return;
                    if (Ey(r2, dr, Ni, $t, 0, false, void 0)) {
                      li = [Ni];
                      return;
                    }
                    return Ni;
                  }
                  for (var Hi = 0; Hi < Kt.length; Hi++) {
                    var Ni = Kt[Hi];
                    if (!(!Xb(Ni, $e) || !D0(r2, dr, Ni, Yr))) {
                      var _t = void 0, gt = void 0;
                      if (Ni.typeParameters) {
                        var Vt = void 0;
                        if (e2.some($e)) {
                          if (Vt = $b(Ni, $e, false), !Vt) {
                            Ci = Ni;
                            continue;
                          }
                        } else
                          gt = uv(Ni.typeParameters, Ni, e2.isInJSFile(r2) ? 2 : 0), Vt = Qb(r2, Ni, dr, Qr | 8, gt), Qr |= gt.flags & 4 ? 8 : 0;
                        if (_t = Xm(Ni, Vt, e2.isInJSFile(Ni.declaration), gt && gt.inferredTypeParameters), yv(Ni) && !D0(r2, dr, _t, Yr)) {
                          Ti = _t;
                          continue;
                        }
                      } else
                        _t = Ni;
                      if (Ey(r2, dr, _t, $t, Qr, false, void 0)) {
                        (li || (li = [])).push(_t);
                        continue;
                      }
                      if (Qr) {
                        if (Qr = o & 32, gt) {
                          var Vt = Qb(r2, Ni, dr, Qr, gt);
                          if (_t = Xm(Ni, Vt, e2.isInJSFile(Ni.declaration), gt && gt.inferredTypeParameters), yv(Ni) && !D0(r2, dr, _t, Yr)) {
                            Ti = _t;
                            continue;
                          }
                        }
                        if (Ey(r2, dr, _t, $t, Qr, false, void 0)) {
                          (li || (li = [])).push(_t);
                          continue;
                        }
                      }
                      return Kt[Hi] = _t, _t;
                    }
                  }
                }
              }
              function v7(r2, i2, t2, o, s2) {
                return e2.Debug.assert(i2.length > 0), xm(r2), o || i2.length === 1 || i2.some(function(u) {
                  return !!u.typeParameters;
                }) ? D7(r2, i2, t2, s2) : y7(i2);
              }
              function y7(r2) {
                var i2 = e2.mapDefined(r2, function(dr) {
                  return dr.thisParameter;
                }), t2;
                i2.length && (t2 = gk(i2, i2.map(mv)));
                for (var o = e2.minAndMax(r2, h7), s2 = o.min, u = o.max, h2 = [], z = function(dr) {
                  var Dr = e2.mapDefined(r2, function(Qr) {
                    return H(Qr) ? dr < Qr.parameters.length - 1 ? Qr.parameters[dr] : e2.last(Qr.parameters) : dr < Qr.parameters.length ? Qr.parameters[dr] : void 0;
                  });
                  e2.Debug.assert(Dr.length !== 0), h2.push(gk(Dr, e2.mapDefined(r2, function(Qr) {
                    return Ld(Qr, dr);
                  })));
                }, me = 0; me < u; me++)
                  z(me);
                var Me = e2.mapDefined(r2, function(dr) {
                  return H(dr) ? e2.last(dr.parameters) : void 0;
                }), $e = 0;
                if (Me.length !== 0) {
                  var tr = Zs(Pa(e2.mapDefined(r2, ix), 2));
                  h2.push(mk(Me, tr)), $e |= 1;
                }
                return r2.some(I) && ($e |= 2), Fu(r2[0].declaration, void 0, t2, h2, Do(r2.map(yo)), void 0, s2, $e);
              }
              function h7(r2) {
                var i2 = r2.parameters.length;
                return H(r2) ? i2 - 1 : i2;
              }
              function gk(r2, i2) {
                return mk(r2, Pa(i2, 2));
              }
              function mk(r2, i2) {
                return eg(e2.first(r2), i2);
              }
              function D7(r2, i2, t2, o) {
                var s2 = T7(i2, si === void 0 ? t2.length : si), u = i2[s2], h2 = u.typeParameters;
                if (!h2)
                  return u;
                var z = ak(r2) ? r2.typeArguments : void 0, me = z ? mh(u, b7(z, h2, e2.isInJSFile(r2))) : S7(r2, h2, u, t2, o);
                return i2[s2] = me, me;
              }
              function b7(r2, i2, t2) {
                for (var o = r2.map(Bd); o.length > i2.length; )
                  o.pop();
                for (; o.length < i2.length; )
                  o.push(D_(i2[o.length]) || Tc(i2[o.length]) || fb(t2));
                return o;
              }
              function S7(r2, i2, t2, o, s2) {
                var u = uv(i2, t2, e2.isInJSFile(r2) ? 2 : 0), h2 = Qb(r2, t2, o, s2 | 4 | 8, u);
                return mh(t2, h2);
              }
              function T7(r2, i2) {
                for (var t2 = -1, o = -1, s2 = 0; s2 < r2.length; s2++) {
                  var u = r2[s2], h2 = Wc(u);
                  if (Xl(u) || h2 >= i2)
                    return s2;
                  h2 > o && (o = h2, t2 = s2);
                }
                return t2;
              }
              function x7(r2, i2, t2) {
                if (r2.expression.kind === 106) {
                  var o = Sb(r2.expression);
                  if (ta(o)) {
                    for (var s2 = 0, u = r2.arguments; s2 < u.length; s2++) {
                      var h2 = u[s2];
                      yn(h2);
                    }
                    return En;
                  }
                  if (!nn(o)) {
                    var z = e2.getEffectiveBaseTypeNode(e2.getContainingClass(r2));
                    if (z) {
                      var me = Xg(o, z.typeArguments, z);
                      return mm(r2, me, i2, t2, 0);
                    }
                  }
                  return Fg(r2);
                }
                var Me, $e = yn(r2.expression);
                if (e2.isCallChain(r2)) {
                  var tr = cv($e, r2.expression);
                  Me = tr === $e ? 0 : e2.isOutermostOptionalChain(r2) ? 16 : 8, $e = tr;
                } else
                  Me = 0;
                if ($e = WC($e, r2.expression, W5), $e === Bt)
                  return Co;
                var dr = $s($e);
                if (nn(dr))
                  return Gl(r2);
                var Dr = ot(dr, 0), Qr = ot(dr, 1).length;
                if (b0($e, dr, Dr.length, Qr))
                  return !nn($e) && r2.typeArguments && Xr(r2, e2.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments), Fg(r2);
                if (!Dr.length) {
                  if (Qr)
                    Xr(r2, e2.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, Ot($e));
                  else {
                    var li = void 0;
                    if (r2.arguments.length === 1) {
                      var Ti = e2.getSourceFileOfNode(r2).text;
                      e2.isLineBreak(Ti.charCodeAt(e2.skipTrivia(Ti, r2.expression.end, true) - 1)) && (li = e2.createDiagnosticForNode(r2.expression, e2.Diagnostics.Are_you_missing_a_semicolon));
                    }
                    rS(r2.expression, dr, 0, li);
                  }
                  return Gl(r2);
                }
                return t2 & 8 && !r2.typeArguments && Dr.some(E7) ? (Xk(r2, t2), to) : Dr.some(function(Ci) {
                  return e2.isInJSFile(Ci.declaration) && !!e2.getJSDocClassTag(Ci.declaration);
                }) ? (Xr(r2, e2.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new, Ot($e)), Gl(r2)) : mm(r2, Dr, i2, t2, Me);
              }
              function E7(r2) {
                return !!(r2.typeParameters && JS(yo(r2)));
              }
              function b0(r2, i2, t2, o) {
                return ta(r2) || ta(i2) && !!(r2.flags & 262144) || !t2 && !o && !(i2.flags & 1048576) && !(bu(i2).flags & 131072) && ao(r2, br);
              }
              function C7(r2, i2, t2) {
                if (r2.arguments && Ae < 1) {
                  var o = h0(r2.arguments);
                  o >= 0 && Xr(r2.arguments[o], e2.Diagnostics.Spread_operator_in_new_expressions_is_only_available_when_targeting_ECMAScript_5_and_higher);
                }
                var s2 = gm(r2.expression);
                if (s2 === Bt)
                  return Co;
                if (s2 = $s(s2), nn(s2))
                  return Gl(r2);
                if (ta(s2))
                  return r2.typeArguments && Xr(r2, e2.Diagnostics.Untyped_function_calls_may_not_accept_type_arguments), Fg(r2);
                var u = ot(s2, 1);
                if (u.length) {
                  if (!k7(r2, u[0]))
                    return Gl(r2);
                  if (vk(u, function(Me) {
                    return !!(Me.flags & 4);
                  }))
                    return Xr(r2, e2.Diagnostics.Cannot_create_an_instance_of_an_abstract_class), Gl(r2);
                  var h2 = s2.symbol && e2.getClassLikeDeclarationOfSymbol(s2.symbol);
                  return h2 && e2.hasSyntacticModifier(h2, 128) ? (Xr(r2, e2.Diagnostics.Cannot_create_an_instance_of_an_abstract_class), Gl(r2)) : mm(r2, u, i2, t2, 0);
                }
                var z = ot(s2, 0);
                if (z.length) {
                  var me = mm(r2, z, i2, t2, 0);
                  return n || (me.declaration && !Sl(me.declaration) && yo(me) !== Fi && Xr(r2, e2.Diagnostics.Only_a_void_function_can_be_called_with_the_new_keyword), T_(me) === Fi && Xr(r2, e2.Diagnostics.A_function_that_is_called_with_the_new_keyword_cannot_have_a_this_type_that_is_void)), me;
                }
                return rS(r2.expression, s2, 1), Gl(r2);
              }
              function vk(r2, i2) {
                return e2.isArray(r2) ? e2.some(r2, function(t2) {
                  return vk(t2, i2);
                }) : r2.compositeKind === 1048576 ? e2.some(r2.compositeSignatures, i2) : i2(r2);
              }
              function eS(r2, i2) {
                var t2 = Qc(i2);
                if (!e2.length(t2))
                  return false;
                var o = t2[0];
                if (o.flags & 2097152) {
                  for (var s2 = o.types, u = Wv(s2), h2 = 0, z = 0, me = o.types; z < me.length; z++) {
                    var Me = me[z];
                    if (!u[h2] && e2.getObjectFlags(Me) & 3 && (Me.symbol === r2 || eS(r2, Me)))
                      return true;
                    h2++;
                  }
                  return false;
                }
                return o.symbol === r2 ? true : eS(r2, o);
              }
              function k7(r2, i2) {
                if (!i2 || !i2.declaration)
                  return true;
                var t2 = i2.declaration, o = e2.getSelectedEffectiveModifierFlags(t2, 24);
                if (!o || t2.kind !== 171)
                  return true;
                var s2 = e2.getClassLikeDeclarationOfSymbol(t2.parent.symbol), u = go(t2.parent.symbol);
                if (!MS(r2, s2)) {
                  var h2 = e2.getContainingClass(r2);
                  if (h2 && o & 16) {
                    var z = Bd(h2);
                    if (eS(t2.parent.symbol, z))
                      return true;
                  }
                  return o & 8 && Xr(r2, e2.Diagnostics.Constructor_of_class_0_is_private_and_only_accessible_within_the_class_declaration, Ot(u)), o & 16 && Xr(r2, e2.Diagnostics.Constructor_of_class_0_is_protected_and_only_accessible_within_the_class_declaration, Ot(u)), false;
                }
                return true;
              }
              function yk(r2, i2, t2) {
                var o, s2 = t2 === 0, u = ag(i2), h2 = u && ot(u, t2).length > 0;
                if (i2.flags & 1048576) {
                  for (var z = i2.types, me = false, Me = 0, $e = z; Me < $e.length; Me++) {
                    var tr = $e[Me], dr = ot(tr, t2);
                    if (dr.length !== 0) {
                      if (me = true, o)
                        break;
                    } else if (o || (o = e2.chainDiagnosticMessages(o, s2 ? e2.Diagnostics.Type_0_has_no_call_signatures : e2.Diagnostics.Type_0_has_no_construct_signatures, Ot(tr)), o = e2.chainDiagnosticMessages(o, s2 ? e2.Diagnostics.Not_all_constituents_of_type_0_are_callable : e2.Diagnostics.Not_all_constituents_of_type_0_are_constructable, Ot(i2))), me)
                      break;
                  }
                  me || (o = e2.chainDiagnosticMessages(void 0, s2 ? e2.Diagnostics.No_constituent_of_type_0_is_callable : e2.Diagnostics.No_constituent_of_type_0_is_constructable, Ot(i2))), o || (o = e2.chainDiagnosticMessages(o, s2 ? e2.Diagnostics.Each_member_of_the_union_type_0_has_signatures_but_none_of_those_signatures_are_compatible_with_each_other : e2.Diagnostics.Each_member_of_the_union_type_0_has_construct_signatures_but_none_of_those_signatures_are_compatible_with_each_other, Ot(i2)));
                } else
                  o = e2.chainDiagnosticMessages(o, s2 ? e2.Diagnostics.Type_0_has_no_call_signatures : e2.Diagnostics.Type_0_has_no_construct_signatures, Ot(i2));
                var Dr = s2 ? e2.Diagnostics.This_expression_is_not_callable : e2.Diagnostics.This_expression_is_not_constructable;
                if (e2.isCallExpression(r2.parent) && r2.parent.arguments.length === 0) {
                  var Qr = va(r2).resolvedSymbol;
                  Qr && Qr.flags & 32768 && (Dr = e2.Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without);
                }
                return { messageChain: e2.chainDiagnosticMessages(o, Dr), relatedMessage: h2 ? e2.Diagnostics.Did_you_forget_to_use_await : void 0 };
              }
              function rS(r2, i2, t2, o) {
                var s2 = yk(r2, i2, t2), u = s2.messageChain, h2 = s2.relatedMessage, z = e2.createDiagnosticForNodeFromMessageChain(r2, u);
                if (h2 && e2.addRelatedInfo(z, e2.createDiagnosticForNode(r2, h2)), e2.isCallExpression(r2.parent)) {
                  var me = pk(r2.parent, true), Me = me.start, $e = me.length;
                  z.start = Me, z.length = $e;
                }
                rn.add(z), hk(i2, t2, o ? e2.addRelatedInfo(z, o) : z);
              }
              function hk(r2, i2, t2) {
                if (!!r2.symbol) {
                  var o = Aa(r2.symbol).originatingImport;
                  if (o && !e2.isImportCall(o)) {
                    var s2 = ot(Jt(Aa(r2.symbol).target), i2);
                    if (!s2 || !s2.length)
                      return;
                    e2.addRelatedInfo(t2, e2.createDiagnosticForNode(o, e2.Diagnostics.Type_originates_at_this_import_A_namespace_style_import_cannot_be_called_or_constructed_and_will_cause_a_failure_at_runtime_Consider_using_a_default_import_or_import_require_here_instead));
                  }
                }
              }
              function A7(r2, i2, t2) {
                var o = yn(r2.tag), s2 = $s(o);
                if (nn(s2))
                  return Gl(r2);
                var u = ot(s2, 0), h2 = ot(s2, 1).length;
                if (b0(o, s2, u.length, h2))
                  return Fg(r2);
                if (!u.length) {
                  if (e2.isArrayLiteralExpression(r2.parent)) {
                    var z = e2.createDiagnosticForNode(r2.tag, e2.Diagnostics.It_is_likely_that_you_are_missing_a_comma_to_separate_these_two_template_expressions_They_form_a_tagged_template_expression_which_cannot_be_invoked);
                    return rn.add(z), Gl(r2);
                  }
                  return rS(r2.tag, s2, 0), Gl(r2);
                }
                return mm(r2, u, i2, t2, 0);
              }
              function N7(r2) {
                switch (r2.parent.kind) {
                  case 257:
                  case 226:
                    return e2.Diagnostics.Unable_to_resolve_signature_of_class_decorator_when_called_as_an_expression;
                  case 164:
                    return e2.Diagnostics.Unable_to_resolve_signature_of_parameter_decorator_when_called_as_an_expression;
                  case 167:
                    return e2.Diagnostics.Unable_to_resolve_signature_of_property_decorator_when_called_as_an_expression;
                  case 169:
                  case 172:
                  case 173:
                    return e2.Diagnostics.Unable_to_resolve_signature_of_method_decorator_when_called_as_an_expression;
                  default:
                    return e2.Debug.fail();
                }
              }
              function P7(r2, i2, t2) {
                var o = yn(r2.expression), s2 = $s(o);
                if (nn(s2))
                  return Gl(r2);
                var u = ot(s2, 0), h2 = ot(s2, 1).length;
                if (b0(o, s2, u.length, h2))
                  return Fg(r2);
                if (w7(r2, u)) {
                  var z = e2.getTextOfNode(r2.expression, false);
                  return Xr(r2, e2.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0, z), Gl(r2);
                }
                var me = N7(r2);
                if (!u.length) {
                  var Me = yk(r2.expression, s2, 0), $e = e2.chainDiagnosticMessages(Me.messageChain, me), tr = e2.createDiagnosticForNodeFromMessageChain(r2.expression, $e);
                  return Me.relatedMessage && e2.addRelatedInfo(tr, e2.createDiagnosticForNode(r2.expression, Me.relatedMessage)), rn.add(tr), hk(s2, 0, tr), Gl(r2);
                }
                return mm(r2, u, i2, t2, 0, me);
              }
              function S0(r2, i2) {
                var t2 = Og(r2), o = t2 && dc(t2), s2 = o && qs(o, U.Element, 788968), u = s2 && Ur.symbolToEntityName(s2, 788968, r2), h2 = e2.factory.createFunctionTypeNode(void 0, [e2.factory.createParameterDeclaration(void 0, void 0, void 0, "props", void 0, Ur.typeToTypeNode(i2, r2))], u ? e2.factory.createTypeReferenceNode(u, void 0) : e2.factory.createKeywordTypeNode(130)), z = oo(1, "props");
                return z.type = i2, Fu(h2, void 0, void 0, [z], s2 ? go(s2) : Pe, void 0, 1, 0);
              }
              function I7(r2, i2, t2) {
                if (dm(r2.tagName)) {
                  var o = BC(r2), s2 = S0(r2, o);
                  return op(Rg(r2.attributes, l0(s2, r2), void 0, 0), o, r2.tagName, r2.attributes), e2.length(r2.typeArguments) && (e2.forEach(r2.typeArguments, io), rn.add(e2.createDiagnosticForNodeArray(e2.getSourceFileOfNode(r2), r2.typeArguments, e2.Diagnostics.Expected_0_type_arguments_but_got_1, 0, e2.length(r2.typeArguments)))), s2;
                }
                var u = yn(r2.tagName), h2 = $s(u);
                if (nn(h2))
                  return Gl(r2);
                var z = LC(u, r2);
                return b0(u, h2, z.length, 0) ? Fg(r2) : z.length === 0 ? (Xr(r2.tagName, e2.Diagnostics.JSX_element_type_0_does_not_have_any_construct_or_call_signatures, e2.getTextOfNode(r2.tagName)), Gl(r2)) : mm(r2, z, i2, t2, 0);
              }
              function w7(r2, i2) {
                return i2.length && e2.every(i2, function(t2) {
                  return t2.minArgumentCount === 0 && !H(t2) && t2.parameters.length < _k(r2, t2);
                });
              }
              function O7(r2, i2, t2) {
                switch (r2.kind) {
                  case 208:
                    return x7(r2, i2, t2);
                  case 209:
                    return C7(r2, i2, t2);
                  case 210:
                    return A7(r2, i2, t2);
                  case 165:
                    return P7(r2, i2, t2);
                  case 280:
                  case 279:
                    return I7(r2, i2, t2);
                }
                throw e2.Debug.assertNever(r2, "Branch in 'resolveSignature' should be unreachable.");
              }
              function Mg(r2, i2, t2) {
                var o = va(r2), s2 = o.resolvedSignature;
                if (s2 && s2 !== to && !i2)
                  return s2;
                o.resolvedSignature = to;
                var u = O7(r2, i2, t2 || 0);
                return u !== to && (o.resolvedSignature = ko === Ao ? u : s2), u;
              }
              function Sl(r2) {
                var i2;
                if (!r2 || !e2.isInJSFile(r2))
                  return false;
                var t2 = e2.isFunctionDeclaration(r2) || e2.isFunctionExpression(r2) ? r2 : e2.isVariableDeclaration(r2) && r2.initializer && e2.isFunctionExpression(r2.initializer) ? r2.initializer : void 0;
                if (t2) {
                  if (e2.getJSDocClassTag(r2))
                    return true;
                  var o = Et(t2);
                  return !!(!((i2 = o == null ? void 0 : o.members) === null || i2 === void 0) && i2.size);
                }
                return false;
              }
              function iS(r2, i2) {
                var t2, o;
                if (i2) {
                  var s2 = Aa(i2);
                  if (!s2.inferredClassSymbol || !s2.inferredClassSymbol.has(y(r2))) {
                    var u = e2.isTransientSymbol(r2) ? r2 : Yl(r2);
                    return u.exports = u.exports || e2.createSymbolTable(), u.members = u.members || e2.createSymbolTable(), u.flags |= i2.flags & 32, !((t2 = i2.exports) === null || t2 === void 0) && t2.size && gu(u.exports, i2.exports), !((o = i2.members) === null || o === void 0) && o.size && gu(u.members, i2.members), (s2.inferredClassSymbol || (s2.inferredClassSymbol = new e2.Map())).set(y(u), u), u;
                  }
                  return s2.inferredClassSymbol.get(y(r2));
                }
              }
              function F7(r2) {
                var i2, t2 = r2 && T0(r2, true), o = (i2 = t2 == null ? void 0 : t2.exports) === null || i2 === void 0 ? void 0 : i2.get("prototype"), s2 = (o == null ? void 0 : o.valueDeclaration) && M7(o.valueDeclaration);
                return s2 ? Et(s2) : void 0;
              }
              function T0(r2, i2) {
                if (!!r2.parent) {
                  var t2, o;
                  if (e2.isVariableDeclaration(r2.parent) && r2.parent.initializer === r2) {
                    if (!e2.isInJSFile(r2) && !(e2.isVarConst(r2.parent) && e2.isFunctionLikeDeclaration(r2)))
                      return;
                    t2 = r2.parent.name, o = r2.parent;
                  } else if (e2.isBinaryExpression(r2.parent)) {
                    var s2 = r2.parent, u = r2.parent.operatorToken.kind;
                    if (u === 63 && (i2 || s2.right === r2))
                      t2 = s2.left, o = t2;
                    else if ((u === 56 || u === 60) && (e2.isVariableDeclaration(s2.parent) && s2.parent.initializer === s2 ? (t2 = s2.parent.name, o = s2.parent) : e2.isBinaryExpression(s2.parent) && s2.parent.operatorToken.kind === 63 && (i2 || s2.parent.right === s2) && (t2 = s2.parent.left, o = t2), !t2 || !e2.isBindableStaticNameExpression(t2) || !e2.isSameEntityName(t2, s2.left)))
                      return;
                  } else
                    i2 && e2.isFunctionDeclaration(r2) && (t2 = r2.name, o = r2);
                  if (!(!o || !t2 || !i2 && !e2.getExpandoInitializer(r2, e2.isPrototypeAccess(t2))))
                    return Et(o);
                }
              }
              function M7(r2) {
                if (!r2.parent)
                  return false;
                for (var i2 = r2.parent; i2 && i2.kind === 206; )
                  i2 = i2.parent;
                if (i2 && e2.isBinaryExpression(i2) && e2.isPrototypeAccess(i2.left) && i2.operatorToken.kind === 63) {
                  var t2 = e2.getInitializerOfBinaryExpression(i2);
                  return e2.isObjectLiteralExpression(t2) && t2;
                }
              }
              function L7(r2, i2) {
                var t2;
                Wy(r2, r2.typeArguments);
                var o = Mg(r2, void 0, i2);
                if (o === to)
                  return wt;
                if (x0(o, r2), r2.expression.kind === 106)
                  return Fi;
                if (r2.kind === 209) {
                  var s2 = o.declaration;
                  if (s2 && s2.kind !== 171 && s2.kind !== 175 && s2.kind !== 180 && !e2.isJSDocConstructSignature(s2) && !Sl(s2))
                    return n && Xr(r2, e2.Diagnostics.new_expression_whose_target_lacks_a_construct_signature_implicitly_has_an_any_type), Oe;
                }
                if (e2.isInJSFile(r2) && xk(r2))
                  return Hm(r2.arguments[0]);
                var u = yo(o);
                if (u.flags & 12288 && Dk(r2))
                  return CD(e2.walkUpParenthesizedExpressions(r2.parent));
                if (r2.kind === 208 && !r2.questionDotToken && r2.parent.kind === 238 && u.flags & 16384 && Yc(o)) {
                  if (!e2.isDottedName(r2.expression))
                    Xr(r2.expression, e2.Diagnostics.Assertions_require_the_call_target_to_be_an_identifier_or_qualified_name);
                  else if (!i0(r2)) {
                    var h2 = Xr(r2.expression, e2.Diagnostics.Assertions_require_every_name_in_the_call_target_to_be_declared_with_an_explicit_type_annotation);
                    gy(r2.expression, h2);
                  }
                }
                if (e2.isInJSFile(r2)) {
                  var z = T0(r2, false);
                  if (!((t2 = z == null ? void 0 : z.exports) === null || t2 === void 0) && t2.size) {
                    var me = rs(z, z.exports, e2.emptyArray, e2.emptyArray, e2.emptyArray);
                    return me.objectFlags |= 4096, Do([u, me]);
                  }
                }
                return u;
              }
              function x0(r2, i2) {
                if (r2.declaration && r2.declaration.flags & 268435456) {
                  var t2 = ky(i2), o = e2.tryGetPropertyAccessOrIdentifierToString(e2.getInvokedExpression(i2));
                  vp(t2, r2.declaration, o, Ml(r2));
                }
              }
              function ky(r2) {
                switch (r2 = e2.skipParentheses(r2), r2.kind) {
                  case 208:
                  case 165:
                  case 209:
                    return ky(r2.expression);
                  case 210:
                    return ky(r2.tag);
                  case 280:
                  case 279:
                    return ky(r2.tagName);
                  case 207:
                    return r2.argumentExpression;
                  case 206:
                    return r2.name;
                  case 178:
                    var i2 = r2;
                    return e2.isQualifiedName(i2.typeName) ? i2.typeName.right : i2;
                  default:
                    return r2;
                }
              }
              function Dk(r2) {
                if (!e2.isCallExpression(r2))
                  return false;
                var i2 = r2.expression;
                if (e2.isPropertyAccessExpression(i2) && i2.name.escapedText === "for" && (i2 = i2.expression), !e2.isIdentifier(i2) || i2.escapedText !== "Symbol")
                  return false;
                var t2 = Ex(false);
                return t2 ? t2 === es(i2, "Symbol", 111551, void 0, void 0, false) : false;
              }
              function R7(r2) {
                if (CL(r2), r2.arguments.length === 0)
                  return Py(r2, Oe);
                for (var i2 = r2.arguments[0], t2 = Os(i2), o = r2.arguments.length > 1 ? Os(r2.arguments[1]) : void 0, s2 = 2; s2 < r2.arguments.length; ++s2)
                  Os(r2.arguments[s2]);
                if ((t2.flags & 32768 || t2.flags & 65536 || !ao(t2, Li)) && Xr(i2, e2.Diagnostics.Dynamic_import_s_specifier_must_be_of_type_string_but_here_has_type_0, Ot(t2)), o) {
                  var u = xx(true);
                  u !== Ba && zc(o, Uh(u, 32768), r2.arguments[1]);
                }
                var h2 = ac(r2, i2);
                if (h2) {
                  var z = Wf(h2, i2, true, false);
                  if (z)
                    return Py(r2, Sk(Jt(z), z, h2, i2) || Tk(Jt(z), z, h2, i2));
                }
                return Py(r2, Oe);
              }
              function bk(r2, i2, t2) {
                var o = e2.createSymbolTable(), s2 = oo(2097152, "default");
                return s2.parent = i2, s2.nameType = Bu("default"), s2.aliasTarget = os(r2), o.set("default", s2), rs(t2, o, e2.emptyArray, e2.emptyArray, e2.emptyArray);
              }
              function Sk(r2, i2, t2, o) {
                var s2 = Uf(o);
                if (s2 && r2 && !nn(r2)) {
                  var u = r2;
                  if (!u.defaultOnlyType) {
                    var h2 = bk(i2, t2);
                    u.defaultOnlyType = h2;
                  }
                  return u.defaultOnlyType;
                }
              }
              function Tk(r2, i2, t2, o) {
                var s2;
                if (Cr && r2 && !nn(r2)) {
                  var u = r2;
                  if (!u.syntheticType) {
                    var h2 = (s2 = t2.declarations) === null || s2 === void 0 ? void 0 : s2.find(e2.isSourceFile), z = L_(h2, t2, false, o);
                    if (z) {
                      var me = oo(2048, "__type"), Me = bk(i2, t2, me);
                      me.type = Me, u.syntheticType = Dy(r2) ? Vp(r2, Me, me, 0, false) : Me;
                    } else
                      u.syntheticType = r2;
                  }
                  return u.syntheticType;
                }
                return r2;
              }
              function xk(r2) {
                if (!e2.isRequireCall(r2, true))
                  return false;
                if (!e2.isIdentifier(r2.expression))
                  return e2.Debug.fail();
                var i2 = es(r2.expression, r2.expression.escapedText, 111551, void 0, void 0, true);
                if (i2 === qr)
                  return true;
                if (i2.flags & 2097152)
                  return false;
                var t2 = i2.flags & 16 ? 256 : i2.flags & 3 ? 254 : 0;
                if (t2 !== 0) {
                  var o = e2.getDeclarationOfKind(i2, t2);
                  return !!o && !!(o.flags & 16777216);
                }
                return false;
              }
              function B7(r2) {
                Y9(r2) || Wy(r2, r2.typeArguments), Ae < 2 && fc(r2, 262144);
                var i2 = Mg(r2);
                return x0(i2, r2), yo(i2);
              }
              function J7(r2) {
                if (r2.kind === 211) {
                  var i2 = e2.getSourceFileOfNode(r2);
                  i2 && e2.fileExtensionIsOneOf(i2.fileName, [".cts", ".mts"]) && Tt(r2, e2.Diagnostics.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Use_an_as_expression_instead);
                }
                return Ck(r2, r2.type, r2.expression);
              }
              function Ek(r2) {
                switch (r2.kind) {
                  case 10:
                  case 14:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 204:
                  case 205:
                  case 223:
                    return true;
                  case 212:
                    return Ek(r2.expression);
                  case 219:
                    var i2 = r2.operator, t2 = r2.operand;
                    return i2 === 40 && (t2.kind === 8 || t2.kind === 9) || i2 === 39 && t2.kind === 8;
                  case 206:
                  case 207:
                    var o = r2.expression, s2 = Bd(o).symbol;
                    return s2 && s2.flags & 2097152 && (s2 = Ps(s2)), !!(s2 && s2.flags & 384 && as(s2) === 1);
                }
                return false;
              }
              function Ck(r2, i2, t2, o) {
                var s2 = yn(t2, o);
                if (e2.isConstTypeReference(i2))
                  return Ek(t2) || Xr(t2, e2.Diagnostics.A_const_assertions_can_only_be_applied_to_references_to_enum_members_or_string_number_boolean_array_or_object_literals), jc(s2);
                io(i2), s2 = fm(Kl(s2));
                var u = Va(i2);
                return nn(u) || fe(function() {
                  var h2 = $c(s2);
                  cm(u, h2) || mE(s2, u, r2, e2.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first);
                }), u;
              }
              function j7(r2) {
                var i2 = yn(r2.expression), t2 = cv(i2, r2.expression);
                return zh(C_(t2), r2, t2 !== i2);
              }
              function U7(r2) {
                return r2.flags & 32 ? j7(r2) : C_(yn(r2.expression));
              }
              function kk(r2) {
                lA(r2);
                var i2 = r2.kind === 228 ? yn(r2.expression) : e2.isThisIdentifier(r2.exprName) ? yy(r2.exprName) : yn(r2.exprName), t2 = r2.typeArguments;
                if (i2 === Bt || nn(i2) || !e2.some(t2))
                  return i2;
                var o = false, s2, u = z(i2), h2 = o ? s2 : i2;
                return h2 && rn.add(e2.createDiagnosticForNodeArray(e2.getSourceFileOfNode(r2), t2, e2.Diagnostics.Type_0_has_no_signatures_for_which_the_type_argument_list_is_applicable, Ot(h2))), u;
                function z(Me) {
                  var $e = false, tr = false, dr = Dr(Me);
                  return o || (o = tr), $e && !tr && (s2 != null || (s2 = Me)), dr;
                  function Dr(Qr) {
                    if (Qr.flags & 524288) {
                      var li = Ru(Qr), Ti = me(li.callSignatures), Ci = me(li.constructSignatures);
                      if ($e || ($e = li.callSignatures.length !== 0 || li.constructSignatures.length !== 0), tr || (tr = Ti.length !== 0 || Ci.length !== 0), Ti !== li.callSignatures || Ci !== li.constructSignatures) {
                        var $i = rs(void 0, li.members, Ti, Ci, li.indexInfos);
                        return $i.objectFlags |= 8388608, $i.node = r2, $i;
                      }
                    } else if (Qr.flags & 58982400) {
                      var Zi = uc(Qr);
                      if (Zi) {
                        var qt = Dr(Zi);
                        if (qt !== Zi)
                          return qt;
                      }
                    } else {
                      if (Qr.flags & 1048576)
                        return Ss(Qr, z);
                      if (Qr.flags & 2097152)
                        return Do(e2.sameMap(Qr.types, Dr));
                    }
                    return Qr;
                  }
                }
                function me(Me) {
                  var $e = e2.filter(Me, function(tr) {
                    return !!tr.typeParameters && Xb(tr, t2);
                  });
                  return e2.sameMap($e, function(tr) {
                    var dr = $b(tr, t2, true);
                    return dr ? Xm(tr, dr, e2.isInJSFile(tr.declaration)) : tr;
                  });
                }
              }
              function z7(r2) {
                return pL(r2), r2.keywordToken === 103 ? tS(r2) : r2.keywordToken === 100 ? W7(r2) : e2.Debug.assertNever(r2.keywordToken);
              }
              function Ak(r2) {
                switch (r2.keywordToken) {
                  case 100:
                    return Tx();
                  case 103:
                    var i2 = tS(r2);
                    return nn(i2) ? Pe : H7(i2);
                  default:
                    e2.Debug.assertNever(r2.keywordToken);
                }
              }
              function tS(r2) {
                var i2 = e2.getNewTargetContainer(r2);
                if (i2)
                  if (i2.kind === 171) {
                    var t2 = Et(i2.parent);
                    return Jt(t2);
                  } else {
                    var t2 = Et(i2);
                    return Jt(t2);
                  }
                else
                  return Xr(r2, e2.Diagnostics.Meta_property_0_is_only_allowed_in_the_body_of_a_function_declaration_function_expression_or_constructor, "new.target"), Pe;
              }
              function W7(r2) {
                er === e2.ModuleKind.Node16 || er === e2.ModuleKind.NodeNext ? e2.getSourceFileOfNode(r2).impliedNodeFormat !== e2.ModuleKind.ESNext && Xr(r2, e2.Diagnostics.The_import_meta_meta_property_is_not_allowed_in_files_which_will_build_into_CommonJS_output) : er < e2.ModuleKind.ES2020 && er !== e2.ModuleKind.System && Xr(r2, e2.Diagnostics.The_import_meta_meta_property_is_only_allowed_when_the_module_option_is_es2020_es2022_esnext_system_node16_or_nodenext);
                var i2 = e2.getSourceFileOfNode(r2);
                return e2.Debug.assert(!!(i2.flags & 4194304), "Containing file is missing import meta node flag."), r2.name.escapedText === "meta" ? Sx() : Pe;
              }
              function mv(r2) {
                var i2 = Jt(r2);
                if (Ye) {
                  var t2 = r2.valueDeclaration;
                  if (t2 && e2.hasInitializer(t2))
                    return i_(i2);
                }
                return i2;
              }
              function E0(r2) {
                return e2.Debug.assert(e2.isIdentifier(r2.name)), r2.name.escapedText;
              }
              function vm(r2, i2, t2) {
                var o = r2.parameters.length - (H(r2) ? 1 : 0);
                if (i2 < o)
                  return r2.parameters[i2].escapedName;
                var s2 = r2.parameters[o] || xe, u = t2 || Jt(s2);
                if (Yn(u)) {
                  var h2 = u.target.labeledElementDeclarations, z = i2 - o;
                  return h2 && E0(h2[z]) || s2.escapedName + "_" + z;
                }
                return s2.escapedName;
              }
              function q7(r2, i2) {
                var t2;
                if (((t2 = r2.declaration) === null || t2 === void 0 ? void 0 : t2.kind) !== 317) {
                  var o = r2.parameters.length - (H(r2) ? 1 : 0);
                  if (i2 < o) {
                    var s2 = r2.parameters[i2];
                    return Nk(s2) ? [s2.escapedName, false] : void 0;
                  }
                  var u = r2.parameters[o] || xe;
                  if (!!Nk(u)) {
                    var h2 = Jt(u);
                    if (Yn(h2)) {
                      var z = h2.target.labeledElementDeclarations, me = i2 - o, Me = z == null ? void 0 : z[me], $e = !!(Me != null && Me.dotDotDotToken);
                      return Me ? [E0(Me), $e] : void 0;
                    }
                    if (i2 === o)
                      return [u.escapedName, true];
                  }
                }
              }
              function Nk(r2) {
                return r2.valueDeclaration && e2.isParameter(r2.valueDeclaration) && e2.isIdentifier(r2.valueDeclaration.name);
              }
              function Pk(r2) {
                return r2.kind === 197 || e2.isParameter(r2) && r2.name && e2.isIdentifier(r2.name);
              }
              function V7(r2, i2) {
                var t2 = r2.parameters.length - (H(r2) ? 1 : 0);
                if (i2 < t2) {
                  var o = r2.parameters[i2].valueDeclaration;
                  return o && Pk(o) ? o : void 0;
                }
                var s2 = r2.parameters[t2] || xe, u = Jt(s2);
                if (Yn(u)) {
                  var h2 = u.target.labeledElementDeclarations, z = i2 - t2;
                  return h2 && h2[z];
                }
                return s2.valueDeclaration && Pk(s2.valueDeclaration) ? s2.valueDeclaration : void 0;
              }
              function $u(r2, i2) {
                return Ld(r2, i2) || Oe;
              }
              function Ld(r2, i2) {
                var t2 = r2.parameters.length - (H(r2) ? 1 : 0);
                if (i2 < t2)
                  return mv(r2.parameters[i2]);
                if (H(r2)) {
                  var o = Jt(r2.parameters[t2]), s2 = i2 - t2;
                  if (!Yn(o) || o.target.hasRestElement || s2 < o.target.fixedLength)
                    return Jc(o, If(s2));
                }
              }
              function ym(r2, i2) {
                var t2 = Wc(r2), o = Hl(r2), s2 = vv(r2);
                if (s2 && i2 >= t2 - 1)
                  return i2 === t2 - 1 ? s2 : Zs(Jc(s2, nt));
                for (var u = [], h2 = [], z = [], me = i2; me < t2; me++) {
                  !s2 || me < t2 - 1 ? (u.push($u(r2, me)), h2.push(me < o ? 1 : 2)) : (u.push(s2), h2.push(8));
                  var Me = V7(r2, me);
                  Me && z.push(Me);
                }
                return Wl(u, h2, false, e2.length(z) === e2.length(u) ? z : void 0);
              }
              function Wc(r2) {
                var i2 = r2.parameters.length;
                if (H(r2)) {
                  var t2 = Jt(r2.parameters[i2 - 1]);
                  if (Yn(t2))
                    return i2 + t2.target.fixedLength - (t2.target.hasRestElement ? 0 : 1);
                }
                return i2;
              }
              function Hl(r2, i2) {
                var t2 = i2 & 1, o = i2 & 2;
                if (o || r2.resolvedMinArgumentCount === void 0) {
                  var s2 = void 0;
                  if (H(r2)) {
                    var u = Jt(r2.parameters[r2.parameters.length - 1]);
                    if (Yn(u)) {
                      var h2 = e2.findIndex(u.target.elementFlags, function($e) {
                        return !($e & 1);
                      }), z = h2 < 0 ? u.target.fixedLength : h2;
                      z > 0 && (s2 = r2.parameters.length - 1 + z);
                    }
                  }
                  if (s2 === void 0) {
                    if (!t2 && r2.flags & 32)
                      return 0;
                    s2 = r2.minArgumentCount;
                  }
                  if (o)
                    return s2;
                  for (var me = s2 - 1; me >= 0; me--) {
                    var Me = $u(r2, me);
                    if (ec(Me, nk).flags & 131072)
                      break;
                    s2 = me;
                  }
                  r2.resolvedMinArgumentCount = s2;
                }
                return r2.resolvedMinArgumentCount;
              }
              function Xl(r2) {
                if (H(r2)) {
                  var i2 = Jt(r2.parameters[r2.parameters.length - 1]);
                  return !Yn(i2) || i2.target.hasRestElement;
                }
                return false;
              }
              function vv(r2) {
                if (H(r2)) {
                  var i2 = Jt(r2.parameters[r2.parameters.length - 1]);
                  if (!Yn(i2))
                    return i2;
                  if (i2.target.hasRestElement)
                    return Zm(i2, i2.target.fixedLength);
                }
              }
              function yv(r2) {
                var i2 = vv(r2);
                return i2 && !Tu(i2) && !ta(i2) && (bu(i2).flags & 131072) === 0 ? i2 : void 0;
              }
              function aS(r2) {
                return nS(r2, ui);
              }
              function nS(r2, i2) {
                return r2.parameters.length > 0 ? $u(r2, 0) : i2;
              }
              function K7(r2, i2, t2) {
                for (var o = r2.parameters.length - (H(r2) ? 1 : 0), s2 = 0; s2 < o; s2++) {
                  var u = r2.parameters[s2].valueDeclaration;
                  if (u.type) {
                    var h2 = e2.getEffectiveTypeAnnotationNode(u);
                    h2 && df(t2.inferences, Va(h2), $u(i2, s2));
                  }
                }
                var z = vv(i2);
                if (z && z.flags & 262144) {
                  var me = Tg(i2, t2.nonFixingMapper);
                  Ik(r2, me);
                  var Me = Wc(i2) - 1;
                  df(t2.inferences, ym(r2, Me), z);
                }
              }
              function Ik(r2, i2) {
                if (i2.typeParameters)
                  if (!r2.typeParameters)
                    r2.typeParameters = i2.typeParameters;
                  else
                    return;
                if (i2.thisParameter) {
                  var t2 = r2.thisParameter;
                  (!t2 || t2.valueDeclaration && !t2.valueDeclaration.type) && (t2 || (r2.thisParameter = eg(i2.thisParameter, void 0)), Ay(r2.thisParameter, Jt(i2.thisParameter)));
                }
                for (var o = r2.parameters.length - (H(r2) ? 1 : 0), s2 = 0; s2 < o; s2++) {
                  var t2 = r2.parameters[s2];
                  if (!e2.getEffectiveTypeAnnotationNode(t2.valueDeclaration)) {
                    var u = Ld(i2, s2);
                    Ay(t2, u);
                  }
                }
                if (H(r2)) {
                  var t2 = e2.last(r2.parameters);
                  if (t2.valueDeclaration ? !e2.getEffectiveTypeAnnotationNode(t2.valueDeclaration) : !!(e2.getCheckFlags(t2) & 65536)) {
                    var u = ym(i2, o);
                    Ay(t2, u);
                  }
                }
              }
              function G7(r2) {
                r2.thisParameter && Ay(r2.thisParameter);
                for (var i2 = 0, t2 = r2.parameters; i2 < t2.length; i2++) {
                  var o = t2[i2];
                  Ay(o);
                }
              }
              function Ay(r2, i2) {
                var t2 = Aa(r2);
                if (t2.type)
                  i2 && e2.Debug.assertEqual(t2.type, i2, "Parameter symbol already has a cached type which differs from newly assigned type");
                else {
                  var o = r2.valueDeclaration;
                  t2.type = i2 || (o ? sc(o, true) : Jt(r2)), o && o.name.kind !== 79 && (t2.type === gr && (t2.type = Qu(o.name)), wk(o.name, t2.type));
                }
              }
              function wk(r2, i2) {
                for (var t2 = 0, o = r2.elements; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  if (!e2.isOmittedExpression(s2)) {
                    var u = uf(s2, i2);
                    s2.name.kind === 79 ? Aa(Et(s2)).type = u : wk(s2.name, u);
                  }
                }
              }
              function Ny(r2) {
                var i2 = ay(true);
                return i2 !== kn ? (r2 = k_(Ev(r2)) || gr, Yf(i2, [r2])) : gr;
              }
              function Ok(r2) {
                var i2 = kx(true);
                return i2 !== kn ? (r2 = k_(Ev(r2)) || gr, Yf(i2, [r2])) : gr;
              }
              function Py(r2, i2) {
                var t2 = Ny(i2);
                return t2 === gr ? (Xr(r2, e2.isImportCall(r2) ? e2.Diagnostics.A_dynamic_import_call_returns_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option : e2.Diagnostics.An_async_function_or_method_must_return_a_Promise_Make_sure_you_have_a_declaration_for_Promise_or_include_ES2015_in_your_lib_option), Pe) : (nD(true) || Xr(r2, e2.isImportCall(r2) ? e2.Diagnostics.A_dynamic_import_call_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option : e2.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option), t2);
              }
              function H7(r2) {
                var i2 = oo(0, "NewTargetExpression"), t2 = oo(4, "target", 8);
                t2.parent = i2, t2.type = r2;
                var o = e2.createSymbolTable([t2]);
                return i2.members = o, rs(i2, o, e2.emptyArray, e2.emptyArray, e2.emptyArray);
              }
              function C0(r2, i2) {
                if (!r2.body)
                  return Pe;
                var t2 = e2.getFunctionFlags(r2), o = (t2 & 2) !== 0, s2 = (t2 & 1) !== 0, u, h2, z, me = Fi;
                if (r2.body.kind !== 235)
                  u = Os(r2.body, i2 && i2 & -9), o && (u = Ev(xv(u, false, r2, e2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member)));
                else if (s2) {
                  var Me = Bk(r2, i2);
                  Me ? Me.length > 0 && (u = Pa(Me, 2)) : me = ui;
                  var $e = X7(r2, i2), tr = $e.yieldTypes, dr = $e.nextTypes;
                  h2 = e2.some(tr) ? Pa(tr, 2) : void 0, z = e2.some(dr) ? Do(dr) : void 0;
                } else {
                  var Dr = Bk(r2, i2);
                  if (!Dr)
                    return t2 & 2 ? Py(r2, ui) : ui;
                  if (Dr.length === 0)
                    return t2 & 2 ? Py(r2, Fi) : Fi;
                  u = Pa(Dr, 2);
                }
                if (u || h2 || z) {
                  if (h2 && Kh(r2, h2, 3), u && Kh(r2, u, 1), z && Kh(r2, z, 2), u && Vl(u) || h2 && Vl(h2) || z && Vl(z)) {
                    var Qr = Pb(r2), li = Qr ? Qr === yl(r2) ? s2 ? void 0 : u : c0(yo(Qr), r2) : void 0;
                    s2 ? (h2 = XD(h2, li, 0, o), u = XD(u, li, 1, o), z = XD(z, li, 2, o)) : u = kw(u, li, o);
                  }
                  h2 && (h2 = $c(h2)), u && (u = $c(u)), z && (z = $c(z));
                }
                return s2 ? Fk(h2 || ui, u || me, z || xC(2, r2) || gr, o) : o ? Ny(u || me) : u || me;
              }
              function Fk(r2, i2, t2, o) {
                var s2 = o ? St : pa, u = s2.getGlobalGeneratorType(false);
                if (r2 = s2.resolveIterationType(r2, void 0) || gr, i2 = s2.resolveIterationType(i2, void 0) || gr, t2 = s2.resolveIterationType(t2, void 0) || gr, u === kn) {
                  var h2 = s2.getGlobalIterableIteratorType(false), z = h2 !== kn ? x6(h2, s2) : void 0, me = z ? z.returnType : Oe, Me = z ? z.nextType : Tr;
                  return ao(i2, me) && ao(Me, t2) ? h2 !== kn ? $m(h2, [r2]) : (s2.getGlobalIterableIteratorType(true), Ba) : (s2.getGlobalGeneratorType(true), Ba);
                }
                return $m(u, [r2, i2, t2]);
              }
              function X7(r2, i2) {
                var t2 = [], o = [], s2 = (e2.getFunctionFlags(r2) & 2) !== 0;
                return e2.forEachYieldExpression(r2.body, function(u) {
                  var h2 = u.expression ? yn(u.expression, i2) : vi;
                  e2.pushIfUnique(t2, Mk(u, h2, Oe, s2));
                  var z;
                  if (u.asteriskToken) {
                    var me = Jy(h2, s2 ? 19 : 17, u.expression);
                    z = me && me.nextType;
                  } else
                    z = ou(u);
                  z && e2.pushIfUnique(o, z);
                }), { yieldTypes: t2, nextTypes: o };
              }
              function Mk(r2, i2, t2, o) {
                var s2 = r2.expression || r2, u = r2.asteriskToken ? N_(o ? 19 : 17, i2, t2, s2) : i2;
                return o ? ag(u, s2, r2.asteriskToken ? e2.Diagnostics.Type_of_iterated_elements_of_a_yield_Asterisk_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member : e2.Diagnostics.Type_of_yield_operand_in_an_async_generator_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member) : u;
              }
              function oS(r2, i2, t2, o) {
                var s2 = 0;
                if (o) {
                  for (var u = i2; u < t2.length; u++)
                    s2 |= oe.get(t2[u]) || 32768;
                  for (var u = r2; u < i2; u++)
                    s2 &= ~(oe.get(t2[u]) || 0);
                  for (var u = 0; u < r2; u++)
                    s2 |= oe.get(t2[u]) || 32768;
                } else {
                  for (var u = r2; u < i2; u++)
                    s2 |= G.get(t2[u]) || 128;
                  for (var u = 0; u < r2; u++)
                    s2 &= ~(G.get(t2[u]) || 0);
                }
                return s2;
              }
              function Lk(r2) {
                var i2 = va(r2);
                return i2.isExhaustive !== void 0 ? i2.isExhaustive : i2.isExhaustive = Q7(r2);
              }
              function Q7(r2) {
                if (r2.expression.kind === 216) {
                  var i2 = Gs(r2.expression.expression), t2 = cC(r2, false), o = oS(0, 0, t2, true), s2 = uc(i2) || i2;
                  return s2.flags & 3 ? (556800 & o) === 556800 : !!(ec(s2, function(z) {
                    return (cp(z) & o) === o;
                  }).flags & 131072);
                }
                var u = Gs(r2.expression);
                if (!Cg(u))
                  return false;
                var h2 = $h(r2);
                return !h2.length || e2.some(h2, Ew) ? false : v8(Ss(u, jc), h2);
              }
              function Rk(r2) {
                return r2.endFlowNode && my(r2.endFlowNode);
              }
              function Bk(r2, i2) {
                var t2 = e2.getFunctionFlags(r2), o = [], s2 = Rk(r2), u = false;
                if (e2.forEachReturnStatement(r2.body, function(h2) {
                  var z = h2.expression;
                  if (z) {
                    var me = Os(z, i2 && i2 & -9);
                    t2 & 2 && (me = Ev(xv(me, false, r2, e2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member))), me.flags & 131072 && (u = true), e2.pushIfUnique(o, me);
                  } else
                    s2 = true;
                }), !(o.length === 0 && !s2 && (u || Y7(r2))))
                  return Ye && o.length && s2 && !(Sl(r2) && o.some(function(h2) {
                    return h2.symbol === r2.symbol;
                  })) && e2.pushIfUnique(o, Tr), o;
              }
              function Y7(r2) {
                switch (r2.kind) {
                  case 213:
                  case 214:
                    return true;
                  case 169:
                    return r2.parent.kind === 205;
                  default:
                    return false;
                }
              }
              function sS(r2, i2) {
                fe(t2);
                return;
                function t2() {
                  var o = e2.getFunctionFlags(r2), s2 = i2 && B0(i2, o);
                  if (!(s2 && fs4(s2, 16385)) && !(r2.kind === 168 || e2.nodeIsMissing(r2.body) || r2.body.kind !== 235 || !Rk(r2))) {
                    var u = r2.flags & 512, h2 = e2.getEffectiveReturnTypeNode(r2) || r2;
                    if (s2 && s2.flags & 131072)
                      Xr(h2, e2.Diagnostics.A_function_returning_never_cannot_have_a_reachable_end_point);
                    else if (s2 && !u)
                      Xr(h2, e2.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value);
                    else if (s2 && Ye && !ao(Tr, s2))
                      Xr(h2, e2.Diagnostics.Function_lacks_ending_return_statement_and_return_type_does_not_include_undefined);
                    else if (ye.noImplicitReturns) {
                      if (!s2) {
                        if (!u)
                          return;
                        var z = yo(yl(r2));
                        if (I6(r2, z))
                          return;
                      }
                      Xr(h2, e2.Diagnostics.Not_all_code_paths_return_a_value);
                    }
                  }
                }
              }
              function Jk(r2, i2) {
                if (e2.Debug.assert(r2.kind !== 169 || e2.isObjectLiteralMethod(r2)), xm(r2), e2.isFunctionExpression(r2) && Sm(r2, r2.name), i2 && i2 & 4 && Ju(r2)) {
                  if (!e2.getEffectiveReturnTypeNode(r2) && !e2.hasContextSensitiveParameters(r2)) {
                    var t2 = dv(r2);
                    if (t2 && Id(yo(t2))) {
                      var o = va(r2);
                      if (o.contextFreeType)
                        return o.contextFreeType;
                      var s2 = C0(r2, i2), u = Fu(void 0, void 0, void 0, e2.emptyArray, s2, void 0, 0, 0), h2 = rs(r2.symbol, we, [u], e2.emptyArray, e2.emptyArray);
                      return h2.objectFlags |= 262144, o.contextFreeType = h2;
                    }
                  }
                  return xn;
                }
                var z = X0(r2);
                return !z && r2.kind === 213 && WS(r2), $7(r2, i2), Jt(Et(r2));
              }
              function $7(r2, i2) {
                var t2 = va(r2);
                if (!(t2.flags & 1024)) {
                  var o = dv(r2);
                  if (!(t2.flags & 1024)) {
                    t2.flags |= 1024;
                    var s2 = e2.firstOrUndefined(ot(Jt(Et(r2)), 0));
                    if (!s2)
                      return;
                    if (Ju(r2))
                      if (o) {
                        var u = wg(r2);
                        i2 && i2 & 2 && K7(s2, o, u);
                        var h2 = u ? Tg(o, u.mapper) : o;
                        Ik(s2, h2);
                      } else
                        G7(s2);
                    if (o && !yg(r2) && !s2.resolvedReturnType) {
                      var z = C0(r2, i2);
                      s2.resolvedReturnType || (s2.resolvedReturnType = z);
                    }
                    Dv(r2);
                  }
                }
              }
              function Z7(r2) {
                e2.Debug.assert(r2.kind !== 169 || e2.isObjectLiteralMethod(r2));
                var i2 = e2.getFunctionFlags(r2), t2 = yg(r2);
                if (sS(r2, t2), r2.body)
                  if (e2.getEffectiveReturnTypeNode(r2) || yo(yl(r2)), r2.body.kind === 235)
                    io(r2.body);
                  else {
                    var o = yn(r2.body), s2 = t2 && B0(t2, i2);
                    if (s2)
                      if ((i2 & 3) === 2) {
                        var u = xv(o, false, r2.body, e2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
                        op(u, s2, r2.body, r2.body);
                      } else
                        op(o, s2, r2.body, r2.body);
                  }
              }
              function k0(r2, i2, t2, o) {
                if (o === void 0 && (o = false), !ao(i2, At)) {
                  var s2 = o && Sv(i2);
                  return zu(r2, !!s2 && ao(s2, At), t2), false;
                }
                return true;
              }
              function eO(r2) {
                if (!e2.isCallExpression(r2) || !e2.isBindableObjectDefinePropertyCall(r2))
                  return false;
                var i2 = Os(r2.arguments[2]), t2 = da(i2, "value");
                if (t2) {
                  var o = bi(i2, "writable"), s2 = o && Jt(o);
                  if (!s2 || s2 === xt || s2 === ut)
                    return true;
                  if (o && o.valueDeclaration && e2.isPropertyAssignment(o.valueDeclaration)) {
                    var u = o.valueDeclaration.initializer, h2 = yn(u);
                    if (h2 === xt || h2 === ut)
                      return true;
                  }
                  return false;
                }
                var z = bi(i2, "set");
                return !z;
              }
              function Zu(r2) {
                return !!(e2.getCheckFlags(r2) & 8 || r2.flags & 4 && e2.getDeclarationModifierFlagsFromSymbol(r2) & 64 || r2.flags & 3 && p0(r2) & 2 || r2.flags & 98304 && !(r2.flags & 65536) || r2.flags & 8 || e2.some(r2.declarations, eO));
              }
              function jk(r2, i2, t2) {
                var o, s2;
                if (t2 === 0)
                  return false;
                if (Zu(i2)) {
                  if (i2.flags & 4 && e2.isAccessExpression(r2) && r2.expression.kind === 108) {
                    var u = e2.getContainingFunction(r2);
                    if (!(u && (u.kind === 171 || Sl(u))))
                      return true;
                    if (i2.valueDeclaration) {
                      var h2 = e2.isBinaryExpression(i2.valueDeclaration), z = u.parent === i2.valueDeclaration.parent, me = u === i2.valueDeclaration.parent, Me = h2 && ((o = i2.parent) === null || o === void 0 ? void 0 : o.valueDeclaration) === u.parent, $e = h2 && ((s2 = i2.parent) === null || s2 === void 0 ? void 0 : s2.valueDeclaration) === u, tr = z || me || Me || $e;
                      return !tr;
                    }
                  }
                  return true;
                }
                if (e2.isAccessExpression(r2)) {
                  var dr = e2.skipParentheses(r2.expression);
                  if (dr.kind === 79) {
                    var Dr = va(dr).resolvedSymbol;
                    if (Dr.flags & 2097152) {
                      var Qr = ru(Dr);
                      return !!Qr && Qr.kind === 268;
                    }
                  }
                }
                return false;
              }
              function hv(r2, i2, t2) {
                var o = e2.skipOuterExpressions(r2, 7);
                return o.kind !== 79 && !e2.isAccessExpression(o) ? (Xr(r2, i2), false) : o.flags & 32 ? (Xr(r2, t2), false) : true;
              }
              function rO(r2) {
                yn(r2.expression);
                var i2 = e2.skipParentheses(r2.expression);
                if (!e2.isAccessExpression(i2))
                  return Xr(i2, e2.Diagnostics.The_operand_of_a_delete_operator_must_be_a_property_reference), Ii;
                e2.isPropertyAccessExpression(i2) && e2.isPrivateIdentifier(i2.name) && Xr(i2, e2.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_private_identifier);
                var t2 = va(i2), o = cu(t2.resolvedSymbol);
                return o && (Zu(o) && Xr(i2, e2.Diagnostics.The_operand_of_a_delete_operator_cannot_be_a_read_only_property), iO(i2, o)), Ii;
              }
              function iO(r2, i2) {
                var t2 = Jt(i2);
                Ye && !(t2.flags & 131075) && !(yr ? i2.flags & 16777216 : ju(t2) & 32768) && Xr(r2, e2.Diagnostics.The_operand_of_a_delete_operator_must_be_optional);
              }
              function tO(r2) {
                return yn(r2.expression), ho;
              }
              function aO(r2) {
                return yn(r2.expression), vi;
              }
              function nO(r2) {
                var i2 = e2.getContainingFunctionOrClassStaticBlock(r2);
                if (i2 && e2.isClassStaticBlockDeclaration(i2))
                  Xr(r2, e2.Diagnostics.Await_expression_cannot_be_used_inside_a_class_static_block);
                else if (!(r2.flags & 32768))
                  if (e2.isInTopLevelContext(r2)) {
                    var t2 = e2.getSourceFileOfNode(r2);
                    if (!Jd(t2)) {
                      var o = void 0;
                      if (!e2.isEffectiveExternalModule(t2, ye)) {
                        o != null || (o = e2.getSpanOfTokenAtPosition(t2, r2.pos));
                        var s2 = e2.createFileDiagnostic(t2, o.start, o.length, e2.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module);
                        rn.add(s2);
                      }
                      switch (er) {
                        case e2.ModuleKind.Node16:
                        case e2.ModuleKind.NodeNext:
                          if (t2.impliedNodeFormat === e2.ModuleKind.CommonJS) {
                            o != null || (o = e2.getSpanOfTokenAtPosition(t2, r2.pos)), rn.add(e2.createFileDiagnostic(t2, o.start, o.length, e2.Diagnostics.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level));
                            break;
                          }
                        case e2.ModuleKind.ES2022:
                        case e2.ModuleKind.ESNext:
                        case e2.ModuleKind.System:
                          if (Ae >= 4)
                            break;
                        default:
                          o != null || (o = e2.getSpanOfTokenAtPosition(t2, r2.pos)), rn.add(e2.createFileDiagnostic(t2, o.start, o.length, e2.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher));
                          break;
                      }
                    }
                  } else {
                    var t2 = e2.getSourceFileOfNode(r2);
                    if (!Jd(t2)) {
                      var o = e2.getSpanOfTokenAtPosition(t2, r2.pos), s2 = e2.createFileDiagnostic(t2, o.start, o.length, e2.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules);
                      if (i2 && i2.kind !== 171 && (e2.getFunctionFlags(i2) & 2) === 0) {
                        var u = e2.createDiagnosticForNode(i2, e2.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                        e2.addRelatedInfo(s2, u);
                      }
                      rn.add(s2);
                    }
                  }
                xb(r2) && Xr(r2, e2.Diagnostics.await_expressions_cannot_be_used_in_a_parameter_initializer);
              }
              function oO(r2) {
                fe(function() {
                  return nO(r2);
                });
                var i2 = yn(r2.expression), t2 = xv(i2, true, r2, e2.Diagnostics.Type_of_await_operand_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
                return t2 === i2 && !nn(t2) && !(i2.flags & 3) && Ls(false, e2.createDiagnosticForNode(r2, e2.Diagnostics.await_has_no_effect_on_the_type_of_this_expression)), t2;
              }
              function sO(r2) {
                var i2 = yn(r2.operand);
                if (i2 === Bt)
                  return Bt;
                switch (r2.operand.kind) {
                  case 8:
                    switch (r2.operator) {
                      case 40:
                        return Sg(If(-r2.operand.text));
                      case 39:
                        return Sg(If(+r2.operand.text));
                    }
                    break;
                  case 9:
                    if (r2.operator === 40)
                      return Sg(ED({ negative: true, base10Value: e2.parsePseudoBigInt(r2.operand.text) }));
                }
                switch (r2.operator) {
                  case 39:
                  case 40:
                  case 54:
                    return bl(i2, r2.operand), A0(i2, 12288) && Xr(r2.operand, e2.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, e2.tokenToString(r2.operator)), r2.operator === 39 ? (fs4(i2, 2112) && Xr(r2.operand, e2.Diagnostics.Operator_0_cannot_be_applied_to_type_1, e2.tokenToString(r2.operator), Ot(Kl(i2))), nt) : cS(i2);
                  case 53:
                    Bg(r2.operand);
                    var t2 = cp(i2) & 12582912;
                    return t2 === 4194304 ? xt : t2 === 8388608 ? Dt : Ii;
                  case 45:
                  case 46:
                    var o = k0(r2.operand, bl(i2, r2.operand), e2.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
                    return o && hv(r2.operand, e2.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, e2.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access), cS(i2);
                }
                return Pe;
              }
              function cO(r2) {
                var i2 = yn(r2.operand);
                if (i2 === Bt)
                  return Bt;
                var t2 = k0(r2.operand, bl(i2, r2.operand), e2.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type);
                return t2 && hv(r2.operand, e2.Diagnostics.The_operand_of_an_increment_or_decrement_operator_must_be_a_variable_or_a_property_access, e2.Diagnostics.The_operand_of_an_increment_or_decrement_operator_may_not_be_an_optional_property_access), cS(i2);
              }
              function cS(r2) {
                return fs4(r2, 2112) ? Ns(r2, 3) || fs4(r2, 296) ? At : Mt : nt;
              }
              function A0(r2, i2) {
                if (fs4(r2, i2))
                  return true;
                var t2 = Hd(r2);
                return !!t2 && fs4(t2, i2);
              }
              function fs4(r2, i2) {
                if (r2.flags & i2)
                  return true;
                if (r2.flags & 3145728)
                  for (var t2 = r2.types, o = 0, s2 = t2; o < s2.length; o++) {
                    var u = s2[o];
                    if (fs4(u, i2))
                      return true;
                  }
                return false;
              }
              function Ns(r2, i2, t2) {
                return r2.flags & i2 ? true : t2 && r2.flags & 114691 ? false : !!(i2 & 296) && ao(r2, nt) || !!(i2 & 2112) && ao(r2, Mt) || !!(i2 & 402653316) && ao(r2, Li) || !!(i2 & 528) && ao(r2, Ii) || !!(i2 & 16384) && ao(r2, Fi) || !!(i2 & 131072) && ao(r2, ui) || !!(i2 & 65536) && ao(r2, Wi) || !!(i2 & 32768) && ao(r2, Tr) || !!(i2 & 4096) && ao(r2, Ki) || !!(i2 & 67108864) && ao(r2, Oi);
              }
              function Lg(r2, i2, t2) {
                return r2.flags & 1048576 ? e2.every(r2.types, function(o) {
                  return Lg(o, i2, t2);
                }) : Ns(r2, i2, t2);
              }
              function uS(r2) {
                return !!(e2.getObjectFlags(r2) & 16) && !!r2.symbol && lS(r2.symbol);
              }
              function lS(r2) {
                return (r2.flags & 128) !== 0;
              }
              function uO(r2, i2, t2, o) {
                return t2 === Bt || o === Bt ? Bt : (!ta(t2) && Lg(t2, 131068) && Xr(r2, e2.Diagnostics.The_left_hand_side_of_an_instanceof_expression_must_be_of_type_any_an_object_type_or_a_type_parameter), ta(o) || RS(o) || E_(o, br) || Xr(i2, e2.Diagnostics.The_right_hand_side_of_an_instanceof_expression_must_be_of_type_any_or_of_a_type_assignable_to_the_Function_interface_type), Ii);
              }
              function lO(r2, i2, t2, o) {
                if (t2 === Bt || o === Bt)
                  return Bt;
                if (e2.isPrivateIdentifier(r2)) {
                  if (Ae < 99 && fc(r2, 2097152), !va(r2).resolvedSymbol && e2.getContainingClass(r2)) {
                    var s2 = Wb(r2, o.symbol, true);
                    YC(r2, o, s2);
                  }
                } else
                  t2 = bl(t2, r2), Lg(t2, 402665900) || Ns(t2, 407109632) || Xr(r2, e2.Diagnostics.The_left_hand_side_of_an_in_expression_must_be_a_private_identifier_or_of_type_any_string_number_or_symbol);
                o = bl(o, i2);
                var u = Q_(o);
                return (!Lg(o, 126091264) || u && (Ns(o, 3145728) && !Lg(u, 126091264) || !fs4(u, 126615552))) && Xr(i2, e2.Diagnostics.The_right_hand_side_of_an_in_expression_must_not_be_a_primitive), Ii;
              }
              function fO(r2, i2, t2) {
                var o = r2.properties;
                if (Ye && o.length === 0)
                  return bl(i2, r2);
                for (var s2 = 0; s2 < o.length; s2++)
                  Uk(r2, i2, s2, o, t2);
                return i2;
              }
              function Uk(r2, i2, t2, o, s2) {
                s2 === void 0 && (s2 = false);
                var u = r2.properties, h2 = u[t2];
                if (h2.kind === 296 || h2.kind === 297) {
                  var z = h2.name, me = Z_(z);
                  if (_f(me)) {
                    var Me = pf(me), $e = bi(i2, Me);
                    $e && (xy($e, h2, s2), Jb(h2, false, true, i2, $e));
                  }
                  var tr = Jc(i2, me, 32, z), dr = is(h2, tr);
                  return Rd(h2.kind === 297 ? h2 : h2.initializer, dr);
                } else if (h2.kind === 298)
                  if (t2 < u.length - 1)
                    Xr(h2, e2.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
                  else {
                    Ae < 99 && fc(h2, 4);
                    var Dr = [];
                    if (o)
                      for (var Qr = 0, li = o; Qr < li.length; Qr++) {
                        var Ti = li[Qr];
                        e2.isSpreadAssignment(Ti) || Dr.push(Ti.name);
                      }
                    var dr = Lo(i2, Dr, i2.symbol);
                    return ng(o, e2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma), Rd(h2.expression, dr);
                  }
                else
                  Xr(h2, e2.Diagnostics.Property_assignment_expected);
              }
              function _O(r2, i2, t2) {
                var o = r2.elements;
                Ae < 2 && ye.downlevelIteration && fc(r2, 512);
                for (var s2 = N_(193, i2, Tr, r2) || Pe, u = ye.noUncheckedIndexedAccess ? void 0 : s2, h2 = 0; h2 < o.length; h2++) {
                  var z = s2;
                  r2.elements[h2].kind === 225 && (z = u = u != null ? u : N_(65, i2, Tr, r2) || Pe), zk(r2, i2, h2, z, t2);
                }
                return i2;
              }
              function zk(r2, i2, t2, o, s2) {
                var u = r2.elements, h2 = u[t2];
                if (h2.kind !== 227) {
                  if (h2.kind !== 225) {
                    var z = If(t2);
                    if (sp(i2)) {
                      var me = 32 | (pm(h2) ? 16 : 0), Me = ep(i2, z, me, ed(h2, z)) || Pe, $e = pm(h2) ? Ks(Me, 524288) : Me, tr = is(h2, $e);
                      return Rd(h2, tr, s2);
                    }
                    return Rd(h2, o, s2);
                  }
                  if (t2 < u.length - 1)
                    Xr(h2, e2.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
                  else {
                    var dr = h2.expression;
                    if (dr.kind === 221 && dr.operatorToken.kind === 63)
                      Xr(dr.operatorToken, e2.Diagnostics.A_rest_element_cannot_have_an_initializer);
                    else {
                      ng(r2.elements, e2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma);
                      var tr = gf(i2, Yn) ? Ss(i2, function(Qr) {
                        return Zm(Qr, t2);
                      }) : Zs(o);
                      return Rd(dr, tr, s2);
                    }
                  }
                }
              }
              function Rd(r2, i2, t2, o) {
                var s2;
                if (r2.kind === 297) {
                  var u = r2;
                  u.objectAssignmentInitializer && (Ye && !(ju(yn(u.objectAssignmentInitializer)) & 32768) && (i2 = Ks(i2, 524288)), mO(u.name, u.equalsToken, u.objectAssignmentInitializer, t2)), s2 = r2.name;
                } else
                  s2 = r2;
                return s2.kind === 221 && s2.operatorToken.kind === 63 && (Ir(s2, t2), s2 = s2.left), s2.kind === 205 ? fO(s2, i2, o) : s2.kind === 204 ? _O(s2, i2, t2) : pO(s2, i2, t2);
              }
              function pO(r2, i2, t2) {
                var o = yn(r2, t2), s2 = r2.parent.kind === 298 ? e2.Diagnostics.The_target_of_an_object_rest_assignment_must_be_a_variable_or_a_property_access : e2.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access, u = r2.parent.kind === 298 ? e2.Diagnostics.The_target_of_an_object_rest_assignment_may_not_be_an_optional_property_access : e2.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access;
                return hv(r2, s2, u) && op(i2, o, r2, r2), e2.isPrivateIdentifierPropertyAccessExpression(r2) && fc(r2.parent, 1048576), i2;
              }
              function Iy(r2) {
                switch (r2 = e2.skipParentheses(r2), r2.kind) {
                  case 79:
                  case 10:
                  case 13:
                  case 210:
                  case 223:
                  case 14:
                  case 8:
                  case 9:
                  case 110:
                  case 95:
                  case 104:
                  case 153:
                  case 213:
                  case 226:
                  case 214:
                  case 204:
                  case 205:
                  case 216:
                  case 230:
                  case 279:
                  case 278:
                    return true;
                  case 222:
                    return Iy(r2.whenTrue) && Iy(r2.whenFalse);
                  case 221:
                    return e2.isAssignmentOperator(r2.operatorToken.kind) ? false : Iy(r2.left) && Iy(r2.right);
                  case 219:
                  case 220:
                    switch (r2.operator) {
                      case 53:
                      case 39:
                      case 40:
                      case 54:
                        return true;
                    }
                    return false;
                  case 217:
                  case 211:
                  case 229:
                  default:
                    return false;
                }
              }
              function fS(r2, i2) {
                return (i2.flags & 98304) !== 0 || cm(r2, i2);
              }
              function dO() {
                var r2 = e2.createBinaryExpressionTrampoline(i2, t2, o, s2, u, h2);
                return function(dr, Dr) {
                  var Qr = r2(dr, Dr);
                  return e2.Debug.assertIsDefined(Qr), Qr;
                };
                function i2(dr, Dr, Qr) {
                  if (Dr ? (Dr.stackIndex++, Dr.skip = false, Me(Dr, void 0), tr(Dr, void 0)) : Dr = { checkMode: Qr, skip: false, stackIndex: 0, typeStack: [void 0, void 0] }, e2.isInJSFile(dr) && e2.getAssignedExpandoInitializer(dr))
                    return Dr.skip = true, tr(Dr, yn(dr.right, Qr)), Dr;
                  gO(dr);
                  var li = dr.operatorToken.kind;
                  return li === 63 && (dr.left.kind === 205 || dr.left.kind === 204) && (Dr.skip = true, tr(Dr, Rd(dr.left, yn(dr.right, Qr), Qr, dr.right.kind === 108))), Dr;
                }
                function t2(dr, Dr, Qr) {
                  if (!Dr.skip)
                    return z(Dr, dr);
                }
                function o(dr, Dr, Qr) {
                  if (!Dr.skip) {
                    var li = $e(Dr);
                    e2.Debug.assertIsDefined(li), Me(Dr, li), tr(Dr, void 0);
                    var Ti = dr.kind;
                    if (Ti === 55 || Ti === 56 || Ti === 60) {
                      if (Ti === 55) {
                        var Ci = e2.walkUpParenthesizedExpressions(Qr.parent);
                        TS(Qr.left, e2.isIfStatement(Ci) ? Ci.thenStatement : void 0);
                      }
                      h6(li, Qr.left);
                    }
                  }
                }
                function s2(dr, Dr, Qr) {
                  if (!Dr.skip)
                    return z(Dr, dr);
                }
                function u(dr, Dr) {
                  var Qr;
                  if (Dr.skip)
                    Qr = $e(Dr);
                  else {
                    var li = me(Dr);
                    e2.Debug.assertIsDefined(li);
                    var Ti = $e(Dr);
                    e2.Debug.assertIsDefined(Ti), Qr = Wk(dr.left, dr.operatorToken, dr.right, li, Ti, dr);
                  }
                  return Dr.skip = false, Me(Dr, void 0), tr(Dr, void 0), Dr.stackIndex--, Qr;
                }
                function h2(dr, Dr, Qr) {
                  return tr(dr, Dr), dr;
                }
                function z(dr, Dr) {
                  if (e2.isBinaryExpression(Dr))
                    return Dr;
                  tr(dr, yn(Dr, dr.checkMode));
                }
                function me(dr) {
                  return dr.typeStack[dr.stackIndex];
                }
                function Me(dr, Dr) {
                  dr.typeStack[dr.stackIndex] = Dr;
                }
                function $e(dr) {
                  return dr.typeStack[dr.stackIndex + 1];
                }
                function tr(dr, Dr) {
                  dr.typeStack[dr.stackIndex + 1] = Dr;
                }
              }
              function gO(r2) {
                var i2 = r2.left, t2 = r2.operatorToken, o = r2.right;
                t2.kind === 60 && (e2.isBinaryExpression(i2) && (i2.operatorToken.kind === 56 || i2.operatorToken.kind === 55) && Tt(i2, e2.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, e2.tokenToString(i2.operatorToken.kind), e2.tokenToString(t2.kind)), e2.isBinaryExpression(o) && (o.operatorToken.kind === 56 || o.operatorToken.kind === 55) && Tt(o, e2.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses, e2.tokenToString(o.operatorToken.kind), e2.tokenToString(t2.kind)));
              }
              function mO(r2, i2, t2, o, s2) {
                var u = i2.kind;
                if (u === 63 && (r2.kind === 205 || r2.kind === 204))
                  return Rd(r2, yn(t2, o), o, t2.kind === 108);
                var h2;
                u === 55 || u === 56 || u === 60 ? h2 = Bg(r2, o) : h2 = yn(r2, o);
                var z = yn(t2, o);
                return Wk(r2, i2, t2, h2, z, s2);
              }
              function Wk(r2, i2, t2, o, s2, u) {
                var h2 = i2.kind;
                switch (h2) {
                  case 41:
                  case 42:
                  case 66:
                  case 67:
                  case 43:
                  case 68:
                  case 44:
                  case 69:
                  case 40:
                  case 65:
                  case 47:
                  case 70:
                  case 48:
                  case 71:
                  case 49:
                  case 72:
                  case 51:
                  case 74:
                  case 52:
                  case 78:
                  case 50:
                  case 73:
                    if (o === Bt || s2 === Bt)
                      return Bt;
                    o = bl(o, r2), s2 = bl(s2, t2);
                    var z = void 0;
                    if (o.flags & 528 && s2.flags & 528 && (z = ja(i2.kind)) !== void 0)
                      return Xr(u || i2, e2.Diagnostics.The_0_operator_is_not_allowed_for_boolean_types_Consider_using_1_instead, e2.tokenToString(i2.kind), e2.tokenToString(z)), nt;
                    var me = k0(r2, o, e2.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true), Me = k0(t2, s2, e2.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type, true), $e;
                    if (Ns(o, 3) && Ns(s2, 3) || !(fs4(o, 2112) || fs4(s2, 2112)))
                      $e = nt;
                    else if (Nt(o, s2)) {
                      switch (h2) {
                        case 49:
                        case 72:
                          Eo();
                          break;
                        case 42:
                        case 67:
                          Ae < 3 && Xr(u, e2.Diagnostics.Exponentiation_cannot_be_performed_on_bigint_values_unless_the_target_option_is_set_to_es2016_or_later);
                      }
                      $e = Mt;
                    } else
                      Eo(Nt), $e = Pe;
                    return me && Me && Fn($e), $e;
                  case 39:
                  case 64:
                    if (o === Bt || s2 === Bt)
                      return Bt;
                    !Ns(o, 402653316) && !Ns(s2, 402653316) && (o = bl(o, r2), s2 = bl(s2, t2));
                    var tr = void 0;
                    if (Ns(o, 296, true) && Ns(s2, 296, true) ? tr = nt : Ns(o, 2112, true) && Ns(s2, 2112, true) ? tr = Mt : Ns(o, 402653316, true) || Ns(s2, 402653316, true) ? tr = Li : (ta(o) || ta(s2)) && (tr = nn(o) || nn(s2) ? Pe : Oe), tr && !Sn(h2))
                      return tr;
                    if (!tr) {
                      var dr = 402655727;
                      return Eo(function(it, Yt) {
                        return Ns(it, dr) && Ns(Yt, dr);
                      }), Oe;
                    }
                    return h2 === 64 && Fn(tr), tr;
                  case 29:
                  case 31:
                  case 32:
                  case 33:
                    return Sn(h2) && (o = Kl(bl(o, r2)), s2 = Kl(bl(s2, t2)), Tn(function(it, Yt) {
                      return cm(it, Yt) || cm(Yt, it) || ao(it, At) && ao(Yt, At);
                    })), Ii;
                  case 34:
                  case 35:
                  case 36:
                  case 37:
                    return Tn(function(it, Yt) {
                      return fS(it, Yt) || fS(Yt, it);
                    }), Ii;
                  case 102:
                    return uO(r2, t2, o, s2);
                  case 101:
                    return lO(r2, t2, o, s2);
                  case 55:
                  case 76: {
                    var Dr = cp(o) & 4194304 ? Pa([Pw(Ye ? o : Kl(s2)), s2]) : o;
                    return h2 === 76 && Fn(s2), Dr;
                  }
                  case 56:
                  case 75: {
                    var Qr = cp(o) & 8388608 ? Pa([OE(o), s2], 2) : o;
                    return h2 === 75 && Fn(s2), Qr;
                  }
                  case 60:
                  case 77: {
                    var li = cp(o) & 262144 ? Pa([C_(o), s2], 2) : o;
                    return h2 === 77 && Fn(s2), li;
                  }
                  case 63:
                    var Ti = e2.isBinaryExpression(r2.parent) ? e2.getAssignmentDeclarationKind(r2.parent) : 0;
                    return Ra(Ti, s2), wn(Ti) ? ((!(s2.flags & 524288) || Ti !== 2 && Ti !== 6 && !Of(s2) && !db(s2) && !(e2.getObjectFlags(s2) & 1)) && Fn(s2), o) : (Fn(s2), fm(s2));
                  case 27:
                    if (!ye.allowUnreachableCode && Iy(r2) && !ca(t2)) {
                      var Ci = e2.getSourceFileOfNode(r2), $i = Ci.text, Zi = e2.skipTrivia($i, r2.pos), qt = Ci.parseDiagnostics.some(function(it) {
                        return it.code !== e2.Diagnostics.JSX_expressions_must_have_one_parent_element.code ? false : e2.textSpanContainsPosition(it, Zi);
                      });
                      qt || Xr(r2, e2.Diagnostics.Left_side_of_comma_operator_is_unused_and_has_no_side_effects);
                    }
                    return s2;
                  default:
                    return e2.Debug.fail();
                }
                function Nt(it, Yt) {
                  return Ns(it, 2112) && Ns(Yt, 2112);
                }
                function Ra(it, Yt) {
                  if (it === 2)
                    for (var Ia = 0, Qt = Pf(Yt); Ia < Qt.length; Ia++) {
                      var Ka = Qt[Ia], cn = Jt(Ka);
                      if (cn.symbol && cn.symbol.flags & 32) {
                        var Un = Ka.escapedName, oa = es(Ka.valueDeclaration, Un, 788968, void 0, Un, false);
                        (oa == null ? void 0 : oa.declarations) && oa.declarations.some(e2.isJSDocTypedefTag) && (Cl(oa, e2.Diagnostics.Duplicate_identifier_0, e2.unescapeLeadingUnderscores(Un), Ka), Cl(Ka, e2.Diagnostics.Duplicate_identifier_0, e2.unescapeLeadingUnderscores(Un), oa));
                      }
                    }
                }
                function ca(it) {
                  return it.kind === 79 && it.escapedText === "eval";
                }
                function Sn(it) {
                  var Yt = A0(o, 12288) ? r2 : A0(s2, 12288) ? t2 : void 0;
                  return Yt ? (Xr(Yt, e2.Diagnostics.The_0_operator_cannot_be_applied_to_type_symbol, e2.tokenToString(it)), false) : true;
                }
                function ja(it) {
                  switch (it) {
                    case 51:
                    case 74:
                      return 56;
                    case 52:
                    case 78:
                      return 37;
                    case 50:
                    case 73:
                      return 55;
                    default:
                      return;
                  }
                }
                function Fn(it) {
                  e2.isAssignmentOperator(h2) && fe(Yt);
                  function Yt() {
                    if (hv(r2, e2.Diagnostics.The_left_hand_side_of_an_assignment_expression_must_be_a_variable_or_a_property_access, e2.Diagnostics.The_left_hand_side_of_an_assignment_expression_may_not_be_an_optional_property_access) && (!e2.isIdentifier(r2) || e2.unescapeLeadingUnderscores(r2.escapedText) !== "exports")) {
                      var Ia = void 0;
                      if (yr && e2.isPropertyAccessExpression(r2) && fs4(it, 32768)) {
                        var Qt = da(Gs(r2.expression), r2.name.escapedText);
                        jD(it, Qt) && (Ia = e2.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target);
                      }
                      op(it, o, r2, t2, Ia);
                    }
                  }
                }
                function wn(it) {
                  var Yt;
                  switch (it) {
                    case 2:
                      return true;
                    case 1:
                    case 5:
                    case 6:
                    case 3:
                    case 4:
                      var Ia = Et(r2), Qt = e2.getAssignedExpandoInitializer(t2);
                      return !!Qt && e2.isObjectLiteralExpression(Qt) && !!(!((Yt = Ia == null ? void 0 : Ia.exports) === null || Yt === void 0) && Yt.size);
                    default:
                      return false;
                  }
                }
                function Tn(it) {
                  return it(o, s2) ? false : (Eo(it), true);
                }
                function Eo(it) {
                  var Yt, Ia = false, Qt = u || i2;
                  if (it) {
                    var Ka = k_(o), cn = k_(s2);
                    Ia = !(Ka === o && cn === s2) && !!(Ka && cn) && it(Ka, cn);
                  }
                  var Un = o, oa = s2;
                  !Ia && it && (Yt = vO(o, s2, it), Un = Yt[0], oa = Yt[1]);
                  var Mn = nf(Un, oa), Ln = Mn[0], ci = Mn[1];
                  lt(Qt, Ia, Ln, ci) || zu(Qt, Ia, e2.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2, e2.tokenToString(i2.kind), Ln, ci);
                }
                function lt(it, Yt, Ia, Qt) {
                  var Ka;
                  switch (i2.kind) {
                    case 36:
                    case 34:
                      Ka = "false";
                      break;
                    case 37:
                    case 35:
                      Ka = "true";
                  }
                  if (Ka)
                    return zu(it, Yt, e2.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap, Ka, Ia, Qt);
                }
              }
              function vO(r2, i2, t2) {
                var o = r2, s2 = i2, u = Kl(r2), h2 = Kl(i2);
                return t2(u, h2) || (o = u, s2 = h2), [o, s2];
              }
              function yO(r2) {
                fe(Dr);
                var i2 = e2.getContainingFunction(r2);
                if (!i2)
                  return Oe;
                var t2 = e2.getFunctionFlags(i2);
                if (!(t2 & 1))
                  return Oe;
                var o = (t2 & 2) !== 0;
                r2.asteriskToken && (o && Ae < 99 && fc(r2, 26624), !o && Ae < 2 && ye.downlevelIteration && fc(r2, 256));
                var s2 = yg(i2), u = s2 && P6(s2, o), h2 = u && u.yieldType || Oe, z = u && u.nextType || Oe, me = o ? ag(z) || Oe : z, Me = r2.expression ? yn(r2.expression) : vi, $e = Mk(r2, Me, me, o);
                if (s2 && $e && op($e, h2, r2.expression || r2, r2.expression), r2.asteriskToken) {
                  var tr = o ? 19 : 17;
                  return b6(tr, 1, Me, r2.expression) || Oe;
                } else if (s2)
                  return Jg(2, s2, o) || Oe;
                var dr = xC(2, i2);
                return dr || (dr = Oe, fe(function() {
                  if (n && !e2.expressionResultIsUnused(r2)) {
                    var Qr = ou(r2);
                    (!Qr || ta(Qr)) && Xr(r2, e2.Diagnostics.yield_expression_implicitly_results_in_an_any_type_because_its_containing_generator_lacks_a_return_type_annotation);
                  }
                })), dr;
                function Dr() {
                  r2.flags & 8192 || Hs(r2, e2.Diagnostics.A_yield_expression_is_only_allowed_in_a_generator_body), xb(r2) && Xr(r2, e2.Diagnostics.yield_expressions_cannot_be_used_in_a_parameter_initializer);
                }
              }
              function hO(r2, i2) {
                Bg(r2.condition), TS(r2.condition, r2.whenTrue);
                var t2 = yn(r2.whenTrue, i2), o = yn(r2.whenFalse, i2);
                return Pa([t2, o], 2);
              }
              function qk(r2) {
                var i2 = r2.parent;
                return e2.isParenthesizedExpression(i2) && qk(i2) || e2.isElementAccessExpression(i2) && i2.argumentExpression === r2;
              }
              function DO(r2) {
                for (var i2 = [r2.head.text], t2 = [], o = 0, s2 = r2.templateSpans; o < s2.length; o++) {
                  var u = s2[o], h2 = yn(u.expression);
                  A0(h2, 12288) && Xr(u.expression, e2.Diagnostics.Implicit_conversion_of_a_symbol_to_a_string_will_fail_at_runtime_Consider_wrapping_this_expression_in_String), i2.push(u.literal.text), t2.push(ao(h2, ba) ? h2 : Li);
                }
                return hm(r2) || qk(r2) || rg(ou(r2) || gr, bO) ? Dg(i2, t2) : Li;
              }
              function bO(r2) {
                return !!(r2.flags & 134217856 || r2.flags & 58982400 && fs4(uc(r2) || gr, 402653316));
              }
              function SO(r2) {
                return r2.kind === 286 && !e2.isJsxSelfClosingElement(r2.parent) ? r2.parent.parent : r2;
              }
              function Rg(r2, i2, t2, o) {
                var s2 = SO(r2), u = s2.contextualType, h2 = s2.inferenceContext;
                try {
                  s2.contextualType = i2, s2.inferenceContext = t2;
                  var z = yn(r2, o | 1 | (t2 ? 2 : 0));
                  t2 && t2.intraExpressionInferenceSites && (t2.intraExpressionInferenceSites = void 0);
                  var me = fs4(z, 2944) && N0(z, c0(i2, r2)) ? jc(z) : z;
                  return me;
                } finally {
                  s2.contextualType = u, s2.inferenceContext = h2;
                }
              }
              function Os(r2, i2) {
                if (i2 && i2 !== 0)
                  return yn(r2, i2);
                var t2 = va(r2);
                if (!t2.resolvedType) {
                  var o = ko, s2 = Zc;
                  ko = Ao, Zc = void 0, t2.resolvedType = yn(r2, i2), Zc = s2, ko = o;
                }
                return t2.resolvedType;
              }
              function Vk(r2) {
                return r2 = e2.skipParentheses(r2, true), r2.kind === 211 || r2.kind === 229 || e2.isJSDocTypeAssertion(r2);
              }
              function wy(r2, i2, t2) {
                var o = e2.getEffectiveInitializer(r2), s2 = Yk(o) || (t2 ? Rg(o, t2, void 0, i2 || 0) : Os(o, i2));
                return e2.isParameter(r2) && r2.name.kind === 202 && Yn(s2) && !s2.target.hasRestElement && $_(s2) < r2.name.elements.length ? TO(s2, r2.name) : s2;
              }
              function TO(r2, i2) {
                for (var t2 = i2.elements, o = xo(r2).slice(), s2 = r2.target.elementFlags.slice(), u = $_(r2); u < t2.length; u++) {
                  var h2 = t2[u];
                  (u < t2.length - 1 || !(h2.kind === 203 && h2.dotDotDotToken)) && (o.push(!e2.isOmittedExpression(h2) && pm(h2) ? vs(h2, false, false) : Oe), s2.push(2), !e2.isOmittedExpression(h2) && !pm(h2) && Xp(h2, Oe));
                }
                return Wl(o, s2, r2.target.readonly);
              }
              function _S(r2, i2) {
                var t2 = e2.getCombinedNodeFlags(r2) & 2 || e2.isDeclarationReadonly(r2) ? i2 : Hp(i2);
                if (e2.isInJSFile(r2)) {
                  if (kE(t2))
                    return Xp(r2, Oe), Oe;
                  if (Jh(t2))
                    return Xp(r2, mo), mo;
                }
                return t2;
              }
              function N0(r2, i2) {
                if (i2) {
                  if (i2.flags & 3145728) {
                    var t2 = i2.types;
                    return e2.some(t2, function(s2) {
                      return N0(r2, s2);
                    });
                  }
                  if (i2.flags & 58982400) {
                    var o = uc(i2) || gr;
                    return fs4(o, 4) && fs4(r2, 128) || fs4(o, 8) && fs4(r2, 256) || fs4(o, 64) && fs4(r2, 2048) || fs4(o, 4096) && fs4(r2, 8192) || N0(r2, o);
                  }
                  return !!(i2.flags & 406847616 && fs4(r2, 128) || i2.flags & 256 && fs4(r2, 256) || i2.flags & 2048 && fs4(r2, 2048) || i2.flags & 512 && fs4(r2, 512) || i2.flags & 8192 && fs4(r2, 8192));
                }
                return false;
              }
              function hm(r2) {
                var i2 = r2.parent;
                return e2.isAssertionExpression(i2) && e2.isConstTypeReference(i2.type) || e2.isJSDocTypeAssertion(i2) && e2.isConstTypeReference(e2.getJSDocTypeAssertionType(i2)) || (e2.isParenthesizedExpression(i2) || e2.isArrayLiteralExpression(i2) || e2.isSpreadElement(i2)) && hm(i2) || (e2.isPropertyAssignment(i2) || e2.isShorthandPropertyAssignment(i2) || e2.isTemplateSpan(i2)) && hm(i2.parent);
              }
              function Dm(r2, i2, t2, o) {
                var s2 = yn(r2, i2, o);
                return hm(r2) || e2.isCommonJsExportedExpression(r2) ? jc(s2) : Vk(r2) ? s2 : HD(s2, c0(arguments.length === 2 ? ou(r2) : t2, r2));
              }
              function Kk(r2, i2) {
                return r2.name.kind === 162 && t_(r2.name), Dm(r2.initializer, i2);
              }
              function Gk(r2, i2) {
                dA(r2), r2.name.kind === 162 && t_(r2.name);
                var t2 = Jk(r2, i2);
                return Hk(r2, t2, i2);
              }
              function Hk(r2, i2, t2) {
                if (t2 && t2 & 10) {
                  var o = gv(i2, 0, true), s2 = gv(i2, 1, true), u = o || s2;
                  if (u && u.typeParameters) {
                    var h2 = $p(r2, 2);
                    if (h2) {
                      var z = gv(C_(h2), o ? 0 : 1, false);
                      if (z && !z.typeParameters) {
                        if (t2 & 8)
                          return Xk(r2, t2), xn;
                        var me = wg(r2), Me = me.signature && yo(me.signature), $e = Me && ok(Me);
                        if ($e && !$e.typeParameters && !e2.every(me.inferences, tg)) {
                          var tr = CO(me, u.typeParameters), dr = eD(u, tr), Dr = e2.map(me.inferences, function(Qr) {
                            return tb(Qr.typeParameter);
                          });
                          if (eb(dr, z, function(Qr, li) {
                            df(Dr, Qr, li, 0, true);
                          }), e2.some(Dr, tg) && (rb(dr, z, function(Qr, li) {
                            df(Dr, Qr, li);
                          }), !xO(me.inferences, Dr)))
                            return EO(me.inferences, Dr), me.inferredTypeParameters = e2.concatenate(me.inferredTypeParameters, tr), im(dr);
                        }
                        return im(sk(u, z, me));
                      }
                    }
                  }
                }
                return i2;
              }
              function Xk(r2, i2) {
                if (i2 & 2) {
                  var t2 = wg(r2);
                  t2.flags |= 4;
                }
              }
              function tg(r2) {
                return !!(r2.candidates || r2.contraCandidates);
              }
              function xO(r2, i2) {
                for (var t2 = 0; t2 < r2.length; t2++)
                  if (tg(r2[t2]) && tg(i2[t2]))
                    return true;
                return false;
              }
              function EO(r2, i2) {
                for (var t2 = 0; t2 < r2.length; t2++)
                  !tg(r2[t2]) && tg(i2[t2]) && (r2[t2] = i2[t2]);
              }
              function CO(r2, i2) {
                for (var t2 = [], o, s2, u = 0, h2 = i2; u < h2.length; u++) {
                  var z = h2[u], me = z.symbol.escapedName;
                  if (pS(r2.inferredTypeParameters, me) || pS(t2, me)) {
                    var Me = kO(e2.concatenate(r2.inferredTypeParameters, t2), me), $e = oo(262144, Me), tr = Hc($e);
                    tr.target = z, o = e2.append(o, z), s2 = e2.append(s2, tr), t2.push(tr);
                  } else
                    t2.push(z);
                }
                if (s2)
                  for (var dr = Uc(o, s2), Dr = 0, Qr = s2; Dr < Qr.length; Dr++) {
                    var z = Qr[Dr];
                    z.mapper = dr;
                  }
                return t2;
              }
              function pS(r2, i2) {
                return e2.some(r2, function(t2) {
                  return t2.symbol.escapedName === i2;
                });
              }
              function kO(r2, i2) {
                for (var t2 = i2.length; t2 > 1 && i2.charCodeAt(t2 - 1) >= 48 && i2.charCodeAt(t2 - 1) <= 57; )
                  t2--;
                for (var o = i2.slice(0, t2), s2 = 1; ; s2++) {
                  var u = o + s2;
                  if (!pS(r2, u))
                    return u;
                }
              }
              function Qk(r2) {
                var i2 = ig(r2);
                if (i2 && !i2.typeParameters)
                  return yo(i2);
              }
              function AO(r2) {
                var i2 = yn(r2.expression), t2 = cv(i2, r2.expression), o = Qk(i2);
                return o && zh(o, r2, t2 !== i2);
              }
              function Gs(r2) {
                var i2 = Yk(r2);
                if (i2)
                  return i2;
                if (r2.flags & 134217728 && Zc) {
                  var t2 = Zc[A2(r2)];
                  if (t2)
                    return t2;
                }
                var o = xc, s2 = yn(r2);
                if (xc !== o) {
                  var u = Zc || (Zc = []);
                  u[A2(r2)] = s2, e2.setNodeFlags(r2, r2.flags | 134217728);
                }
                return s2;
              }
              function Yk(r2) {
                var i2 = e2.skipParentheses(r2, true);
                if (e2.isJSDocTypeAssertion(i2)) {
                  var t2 = e2.getJSDocTypeAssertionType(i2);
                  if (!e2.isConstTypeReference(t2))
                    return Va(t2);
                }
                if (i2 = e2.skipParentheses(r2), e2.isCallExpression(i2) && i2.expression.kind !== 106 && !e2.isRequireCall(i2, true) && !Dk(i2)) {
                  var t2 = e2.isCallChain(i2) ? AO(i2) : Qk(gm(i2.expression));
                  if (t2)
                    return t2;
                } else {
                  if (e2.isAssertionExpression(i2) && !e2.isConstTypeReference(i2.type))
                    return Va(i2.type);
                  if (r2.kind === 8 || r2.kind === 10 || r2.kind === 110 || r2.kind === 95)
                    return yn(r2);
                }
              }
              function Oy(r2) {
                var i2 = va(r2);
                if (i2.contextFreeType)
                  return i2.contextFreeType;
                var t2 = r2.contextualType;
                r2.contextualType = Oe;
                try {
                  var o = i2.contextFreeType = yn(r2, 4);
                  return o;
                } finally {
                  r2.contextualType = t2;
                }
              }
              function yn(r2, i2, t2) {
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("check", "checkExpression", { kind: r2.kind, pos: r2.pos, end: r2.end, path: r2.tracingPath });
                var o = Ie;
                Ie = r2, Ee = 0;
                var s2 = IO(r2, i2, t2), u = Hk(r2, s2, i2);
                return uS(u) && NO(r2, u), Ie = o, e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), u;
              }
              function NO(r2, i2) {
                var t2 = r2.parent.kind === 206 && r2.parent.expression === r2 || r2.parent.kind === 207 && r2.parent.expression === r2 || (r2.kind === 79 || r2.kind === 161) && W0(r2) || r2.parent.kind === 181 && r2.parent.exprName === r2 || r2.parent.kind === 275;
                if (t2 || Xr(r2, e2.Diagnostics.const_enums_can_only_be_used_in_property_or_index_access_expressions_or_the_right_hand_side_of_an_import_declaration_or_export_assignment_or_type_query), ye.isolatedModules) {
                  e2.Debug.assert(!!(i2.symbol.flags & 128));
                  var o = i2.symbol.valueDeclaration;
                  o.flags & 16777216 && Xr(r2, e2.Diagnostics.Cannot_access_ambient_const_enums_when_the_isolatedModules_flag_is_provided);
                }
              }
              function PO(r2, i2) {
                if (e2.hasJSDocNodes(r2) && e2.isJSDocTypeAssertion(r2)) {
                  var t2 = e2.getJSDocTypeAssertionType(r2);
                  return Ck(t2, t2, r2.expression, i2);
                }
                return yn(r2.expression, i2);
              }
              function IO(r2, i2, t2) {
                var o = r2.kind;
                if (g)
                  switch (o) {
                    case 226:
                    case 213:
                    case 214:
                      g.throwIfCancellationRequested();
                  }
                switch (o) {
                  case 79:
                    return R8(r2, i2);
                  case 80:
                    return K5(r2);
                  case 108:
                    return yy(r2);
                  case 106:
                    return Sb(r2);
                  case 104:
                    return ct;
                  case 14:
                  case 10:
                    return Sg(Bu(r2.text));
                  case 8:
                    return KS(r2), Sg(If(+r2.text));
                  case 9:
                    return SL(r2), Sg(ED({ negative: false, base10Value: e2.parsePseudoBigInt(r2.text) }));
                  case 110:
                    return Dt;
                  case 95:
                    return xt;
                  case 223:
                    return DO(r2);
                  case 13:
                    return Wa;
                  case 204:
                    return PC(r2, i2, t2);
                  case 205:
                    return C5(r2, i2);
                  case 206:
                    return VC(r2, i2);
                  case 161:
                    return KC(r2, i2);
                  case 207:
                    return c7(r2, i2);
                  case 208:
                    if (r2.expression.kind === 100)
                      return R7(r2);
                  case 209:
                    return L7(r2, i2);
                  case 210:
                    return B7(r2);
                  case 212:
                    return PO(r2, i2);
                  case 226:
                    return uM(r2);
                  case 213:
                  case 214:
                    return Jk(r2, i2);
                  case 216:
                    return tO(r2);
                  case 211:
                  case 229:
                    return J7(r2);
                  case 230:
                    return U7(r2);
                  case 228:
                    return kk(r2);
                  case 231:
                    return z7(r2);
                  case 215:
                    return rO(r2);
                  case 217:
                    return aO(r2);
                  case 218:
                    return oO(r2);
                  case 219:
                    return sO(r2);
                  case 220:
                    return cO(r2);
                  case 221:
                    return Ir(r2, i2);
                  case 222:
                    return hO(r2, i2);
                  case 225:
                    return b5(r2, i2);
                  case 227:
                    return vi;
                  case 224:
                    return yO(r2);
                  case 232:
                    return S5(r2);
                  case 288:
                    return J5(r2, i2);
                  case 278:
                    return P5(r2, i2);
                  case 279:
                    return A5(r2, i2);
                  case 282:
                    return I5(r2);
                  case 286:
                    return O5(r2, i2);
                  case 280:
                    e2.Debug.fail("Shouldn't ever directly check a JsxOpeningElement");
                }
                return Pe;
              }
              function $k(r2) {
                sA(r2), r2.expression && Hs(r2.expression, e2.Diagnostics.Type_expected), io(r2.constraint), io(r2.default);
                var i2 = Js(Et(r2));
                uc(i2), X1(i2) || Xr(r2.default, e2.Diagnostics.Type_parameter_0_has_a_circular_default, Ot(i2));
                var t2 = Tc(i2), o = D_(i2);
                t2 && o && zc(o, Rc(un(t2, Yd(i2, o)), o), r2.default, e2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1), xm(r2), fe(function() {
                  return Tm(r2.name, e2.Diagnostics.Type_parameter_name_cannot_be_0);
                });
              }
              function wO(r2) {
                if (e2.isInterfaceDeclaration(r2.parent) || e2.isClassLike(r2.parent) || e2.isTypeAliasDeclaration(r2.parent)) {
                  var i2 = Js(Et(r2)), t2 = WD(i2);
                  if (t2) {
                    var o = Et(r2.parent);
                    if (e2.isTypeAliasDeclaration(r2.parent) && !(e2.getObjectFlags(go(o)) & 48))
                      Xr(r2, e2.Diagnostics.Variance_annotations_are_only_supported_in_type_aliases_for_object_function_constructor_and_mapped_types);
                    else if (t2 === 32768 || t2 === 65536) {
                      var s2 = ly(o, i2, t2 === 65536 ? Da : Rn), u = ly(o, i2, t2 === 65536 ? Rn : Da), h2 = i2;
                      _e = i2, zc(s2, u, r2, e2.Diagnostics.Type_0_is_not_assignable_to_type_1_as_implied_by_variance_annotation), _e = h2;
                    }
                  }
                }
              }
              function Zk(r2) {
                Ff(r2), L0(r2);
                var i2 = e2.getContainingFunction(r2);
                e2.hasSyntacticModifier(r2, 16476) && (i2.kind === 171 && e2.nodeIsPresent(i2.body) || Xr(r2, e2.Diagnostics.A_parameter_property_is_only_allowed_in_a_constructor_implementation), i2.kind === 171 && e2.isIdentifier(r2.name) && r2.name.escapedText === "constructor" && Xr(r2.name, e2.Diagnostics.constructor_cannot_be_used_as_a_parameter_property_name)), r2.questionToken && e2.isBindingPattern(r2.name) && i2.body && Xr(r2, e2.Diagnostics.A_binding_pattern_parameter_cannot_be_optional_in_an_implementation_signature), r2.name && e2.isIdentifier(r2.name) && (r2.name.escapedText === "this" || r2.name.escapedText === "new") && (i2.parameters.indexOf(r2) !== 0 && Xr(r2, e2.Diagnostics.A_0_parameter_must_be_the_first_parameter, r2.name.escapedText), (i2.kind === 171 || i2.kind === 175 || i2.kind === 180) && Xr(r2, e2.Diagnostics.A_constructor_cannot_have_a_this_parameter), i2.kind === 214 && Xr(r2, e2.Diagnostics.An_arrow_function_cannot_have_a_this_parameter), (i2.kind === 172 || i2.kind === 173) && Xr(r2, e2.Diagnostics.get_and_set_accessors_cannot_declare_this_parameters)), r2.dotDotDotToken && !e2.isBindingPattern(r2.name) && !ao(bu(Jt(r2.symbol)), Go) && Xr(r2, e2.Diagnostics.A_rest_parameter_must_be_of_an_array_type);
              }
              function OO(r2) {
                var i2 = FO(r2);
                if (!i2) {
                  Xr(r2, e2.Diagnostics.A_type_predicate_is_only_allowed_in_return_type_position_for_functions_and_methods);
                  return;
                }
                var t2 = yl(i2), o = Yc(t2);
                if (!!o) {
                  io(r2.type);
                  var s2 = r2.parameterName;
                  if (o.kind === 0 || o.kind === 2)
                    Ch(s2);
                  else if (o.parameterIndex >= 0) {
                    if (H(t2) && o.parameterIndex === t2.parameters.length - 1)
                      Xr(s2, e2.Diagnostics.A_type_predicate_cannot_reference_a_rest_parameter);
                    else if (o.type) {
                      var u = function() {
                        return e2.chainDiagnosticMessages(void 0, e2.Diagnostics.A_type_predicate_s_type_must_be_assignable_to_its_parameter_s_type);
                      };
                      zc(o.type, Jt(t2.parameters[o.parameterIndex]), r2.type, void 0, u);
                    }
                  } else if (s2) {
                    for (var h2 = false, z = 0, me = i2.parameters; z < me.length; z++) {
                      var Me = me[z].name;
                      if (e2.isBindingPattern(Me) && e6(Me, s2, o.parameterName)) {
                        h2 = true;
                        break;
                      }
                    }
                    h2 || Xr(r2.parameterName, e2.Diagnostics.Cannot_find_parameter_0, o.parameterName);
                  }
                }
              }
              function FO(r2) {
                switch (r2.parent.kind) {
                  case 214:
                  case 174:
                  case 256:
                  case 213:
                  case 179:
                  case 169:
                  case 168:
                    var i2 = r2.parent;
                    if (r2 === i2.type)
                      return i2;
                }
              }
              function e6(r2, i2, t2) {
                for (var o = 0, s2 = r2.elements; o < s2.length; o++) {
                  var u = s2[o];
                  if (!e2.isOmittedExpression(u)) {
                    var h2 = u.name;
                    if (h2.kind === 79 && h2.escapedText === t2)
                      return Xr(i2, e2.Diagnostics.A_type_predicate_cannot_reference_element_0_in_a_binding_pattern, t2), true;
                    if ((h2.kind === 202 || h2.kind === 201) && e6(h2, i2, t2))
                      return true;
                  }
                }
              }
              function Dv(r2) {
                r2.kind === 176 ? X9(r2) : (r2.kind === 179 || r2.kind === 256 || r2.kind === 180 || r2.kind === 174 || r2.kind === 171 || r2.kind === 175) && X0(r2);
                var i2 = e2.getFunctionFlags(r2);
                i2 & 4 || ((i2 & 3) === 3 && Ae < 99 && fc(r2, 6144), (i2 & 3) === 2 && Ae < 4 && fc(r2, 64), (i2 & 3) !== 0 && Ae < 2 && fc(r2, 128)), jy(e2.getEffectiveTypeParameterDeclarations(r2)), sM(r2), e2.forEach(r2.parameters, Zk), r2.type && io(r2.type), fe(t2);
                function t2() {
                  EF(r2);
                  var o = e2.getEffectiveReturnTypeNode(r2);
                  if (n && !o)
                    switch (r2.kind) {
                      case 175:
                        Xr(r2, e2.Diagnostics.Construct_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                        break;
                      case 174:
                        Xr(r2, e2.Diagnostics.Call_signature_which_lacks_return_type_annotation_implicitly_has_an_any_return_type);
                        break;
                    }
                  if (o) {
                    var s2 = e2.getFunctionFlags(r2);
                    if ((s2 & 5) === 1) {
                      var u = Va(o);
                      if (u === Fi)
                        Xr(o, e2.Diagnostics.A_generator_cannot_have_a_void_type_annotation);
                      else {
                        var h2 = Jg(0, u, (s2 & 2) !== 0) || Oe, z = Jg(1, u, (s2 & 2) !== 0) || h2, me = Jg(2, u, (s2 & 2) !== 0) || gr, Me = Fk(h2, z, me, !!(s2 & 2));
                        zc(Me, u, o);
                      }
                    } else
                      (s2 & 3) === 2 && cF(r2, o);
                  }
                  r2.kind !== 176 && r2.kind !== 317 && A_(r2);
                }
              }
              function MO(r2) {
                for (var i2 = new e2.Map(), t2 = new e2.Map(), o = new e2.Map(), s2 = 0, u = r2.members; s2 < u.length; s2++) {
                  var h2 = u[s2];
                  if (h2.kind === 171)
                    for (var z = 0, me = h2.parameters; z < me.length; z++) {
                      var Me = me[z];
                      e2.isParameterPropertyDeclaration(Me, h2) && !e2.isBindingPattern(Me.name) && Ti(i2, Me.name, Me.name.escapedText, 3);
                    }
                  else {
                    var $e = e2.isStatic(h2), tr = h2.name;
                    if (!tr)
                      continue;
                    var dr = e2.isPrivateIdentifier(tr), Dr = dr && $e ? 16 : 0, Qr = dr ? o : $e ? t2 : i2, li = tr && e2.getPropertyNameForPropertyNameNode(tr);
                    if (li)
                      switch (h2.kind) {
                        case 172:
                          Ti(Qr, tr, li, 1 | Dr);
                          break;
                        case 173:
                          Ti(Qr, tr, li, 2 | Dr);
                          break;
                        case 167:
                          Ti(Qr, tr, li, 3 | Dr);
                          break;
                        case 169:
                          Ti(Qr, tr, li, 8 | Dr);
                          break;
                      }
                  }
                }
                function Ti(Ci, $i, Zi, qt) {
                  var Nt = Ci.get(Zi);
                  if (Nt)
                    if ((Nt & 16) !== (qt & 16))
                      Xr($i, e2.Diagnostics.Duplicate_identifier_0_Static_and_instance_elements_cannot_share_the_same_private_name, e2.getTextOfNode($i));
                    else {
                      var Ra = !!(Nt & 8), ca = !!(qt & 8);
                      Ra || ca ? Ra !== ca && Xr($i, e2.Diagnostics.Duplicate_identifier_0, e2.getTextOfNode($i)) : Nt & qt & -17 ? Xr($i, e2.Diagnostics.Duplicate_identifier_0, e2.getTextOfNode($i)) : Ci.set(Zi, Nt | qt);
                    }
                  else
                    Ci.set(Zi, qt);
                }
              }
              function LO(r2) {
                for (var i2 = 0, t2 = r2.members; i2 < t2.length; i2++) {
                  var o = t2[i2], s2 = o.name, u = e2.isStatic(o);
                  if (u && s2) {
                    var h2 = e2.getPropertyNameForPropertyNameNode(s2);
                    switch (h2) {
                      case "name":
                      case "length":
                      case "caller":
                      case "arguments":
                      case "prototype":
                        var z = e2.Diagnostics.Static_property_0_conflicts_with_built_in_property_Function_0_of_constructor_function_1, me = of(Et(r2));
                        Xr(s2, z, h2, me);
                        break;
                    }
                  }
                }
              }
              function r6(r2) {
                for (var i2 = new e2.Map(), t2 = 0, o = r2.members; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  if (s2.kind === 166) {
                    var u = void 0, h2 = s2.name;
                    switch (h2.kind) {
                      case 10:
                      case 8:
                        u = h2.text;
                        break;
                      case 79:
                        u = e2.idText(h2);
                        break;
                      default:
                        continue;
                    }
                    i2.get(u) ? (Xr(e2.getNameOfDeclaration(s2.symbol.valueDeclaration), e2.Diagnostics.Duplicate_identifier_0, u), Xr(s2.name, e2.Diagnostics.Duplicate_identifier_0, u)) : i2.set(u, true);
                  }
                }
              }
              function dS(r2) {
                if (r2.kind === 258) {
                  var i2 = Et(r2);
                  if (i2.declarations && i2.declarations.length > 0 && i2.declarations[0] !== r2)
                    return;
                }
                var t2 = tx(Et(r2));
                if (t2 != null && t2.declarations) {
                  for (var o = new e2.Map(), s2 = function(me) {
                    me.parameters.length === 1 && me.parameters[0].type && Od(Va(me.parameters[0].type), function(Me) {
                      var $e = o.get(fu(Me));
                      $e ? $e.declarations.push(me) : o.set(fu(Me), { type: Me, declarations: [me] });
                    });
                  }, u = 0, h2 = t2.declarations; u < h2.length; u++) {
                    var z = h2[u];
                    s2(z);
                  }
                  o.forEach(function(me) {
                    if (me.declarations.length > 1)
                      for (var Me = 0, $e = me.declarations; Me < $e.length; Me++) {
                        var tr = $e[Me];
                        Xr(tr, e2.Diagnostics.Duplicate_index_signature_for_type_0, Ot(me.type));
                      }
                  });
                }
              }
              function i6(r2) {
                !Ff(r2) && !vL(r2) && Q0(r2.name), L0(r2), gS(r2), e2.hasSyntacticModifier(r2, 128) && r2.kind === 167 && r2.initializer && Xr(r2, e2.Diagnostics.Property_0_cannot_have_an_initializer_because_it_is_marked_abstract, e2.declarationNameToString(r2.name));
              }
              function RO(r2) {
                return e2.isPrivateIdentifier(r2.name) && Xr(r2, e2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), i6(r2);
              }
              function BO(r2) {
                dA(r2) || Q0(r2.name), f6(r2), e2.hasSyntacticModifier(r2, 128) && r2.kind === 169 && r2.body && Xr(r2, e2.Diagnostics.Method_0_cannot_have_an_implementation_because_it_is_marked_abstract, e2.declarationNameToString(r2.name)), e2.isPrivateIdentifier(r2.name) && !e2.getContainingClass(r2) && Xr(r2, e2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), gS(r2);
              }
              function gS(r2) {
                if (e2.isPrivateIdentifier(r2.name) && Ae < 99) {
                  for (var i2 = e2.getEnclosingBlockScopeContainer(r2); i2; i2 = e2.getEnclosingBlockScopeContainer(i2))
                    va(i2).flags |= 67108864;
                  if (e2.isClassExpression(r2.parent)) {
                    var t2 = hb(r2.parent);
                    t2 && (va(r2.name).flags |= 524288, va(t2).flags |= 65536);
                  }
                }
              }
              function JO(r2) {
                Ff(r2), e2.forEachChild(r2, io);
              }
              function jO(r2) {
                Dv(r2), gL(r2) || mL(r2), io(r2.body);
                var i2 = Et(r2), t2 = e2.getDeclarationOfKind(i2, r2.kind);
                if (r2 === t2 && O0(i2), e2.nodeIsMissing(r2.body))
                  return;
                fe(s2);
                return;
                function o(u) {
                  return e2.isPrivateIdentifierClassElementDeclaration(u) ? true : u.kind === 167 && !e2.isStatic(u) && !!u.initializer;
                }
                function s2() {
                  var u = r2.parent;
                  if (e2.getClassExtendsHeritageElement(u)) {
                    Db(r2.parent, u);
                    var h2 = yC(u), z = vC(r2.body);
                    if (z) {
                      h2 && Xr(z, e2.Diagnostics.A_constructor_cannot_contain_a_super_call_when_its_class_extends_null);
                      var me = (e2.getEmitScriptTarget(ye) !== 99 || !ir) && (e2.some(r2.parent.members, o) || e2.some(r2.parameters, function(Dr) {
                        return e2.hasSyntacticModifier(Dr, 16476);
                      }));
                      if (me)
                        if (!UO(z, r2.body))
                          Xr(z, e2.Diagnostics.A_super_call_must_be_a_root_level_statement_within_a_constructor_of_a_derived_class_that_contains_initialized_properties_parameter_properties_or_private_identifiers);
                        else {
                          for (var Me = void 0, $e = 0, tr = r2.body.statements; $e < tr.length; $e++) {
                            var dr = tr[$e];
                            if (e2.isExpressionStatement(dr) && e2.isSuperCall(e2.skipOuterExpressions(dr.expression))) {
                              Me = dr;
                              break;
                            }
                            if (t6(dr))
                              break;
                          }
                          Me === void 0 && Xr(r2, e2.Diagnostics.A_super_call_must_be_the_first_statement_in_the_constructor_to_refer_to_super_or_this_when_a_derived_class_contains_initialized_properties_parameter_properties_or_private_identifiers);
                        }
                    } else
                      h2 || Xr(r2, e2.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call);
                  }
                }
              }
              function UO(r2, i2) {
                var t2 = e2.walkUpParenthesizedExpressions(r2.parent);
                return e2.isExpressionStatement(t2) && t2.parent === i2;
              }
              function t6(r2) {
                return r2.kind === 106 || r2.kind === 108 ? true : e2.isThisContainerOrFunctionBlock(r2) ? false : !!e2.forEachChild(r2, t6);
              }
              function a6(r2) {
                fe(i2), io(r2.body), gS(r2);
                function i2() {
                  if (!X0(r2) && !aL(r2) && Q0(r2.name), Fy(r2), Dv(r2), r2.kind === 172 && !(r2.flags & 16777216) && e2.nodeIsPresent(r2.body) && r2.flags & 256 && (r2.flags & 512 || Xr(r2.name, e2.Diagnostics.A_get_accessor_must_return_a_value)), r2.name.kind === 162 && t_(r2.name), Td(r2)) {
                    var t2 = Et(r2), o = e2.getDeclarationOfKind(t2, 172), s2 = e2.getDeclarationOfKind(t2, 173);
                    if (o && s2 && !(Ug(o) & 1)) {
                      va(o).flags |= 1;
                      var u = e2.getEffectiveModifierFlags(o), h2 = e2.getEffectiveModifierFlags(s2);
                      (u & 128) !== (h2 & 128) && (Xr(o.name, e2.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract), Xr(s2.name, e2.Diagnostics.Accessors_must_both_be_abstract_or_non_abstract)), (u & 16 && !(h2 & 24) || u & 8 && !(h2 & 8)) && (Xr(o.name, e2.Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter), Xr(s2.name, e2.Diagnostics.A_get_accessor_must_be_at_least_as_accessible_as_the_setter));
                      var z = Te(o), me = Te(s2);
                      z && me && zc(z, me, o, e2.Diagnostics.The_return_type_of_a_get_accessor_must_be_assignable_to_its_set_accessor_type);
                    }
                  }
                  var Me = rt(Et(r2));
                  r2.kind === 172 && sS(r2, Me);
                }
              }
              function zO(r2) {
                Fy(r2);
              }
              function P0(r2, i2) {
                return zp(e2.map(r2.typeArguments, Va), i2, Ul(i2), e2.isInJSFile(r2));
              }
              function n6(r2, i2) {
                for (var t2, o, s2 = true, u = 0; u < i2.length; u++) {
                  var h2 = Tc(i2[u]);
                  h2 && (t2 || (t2 = P0(r2, i2), o = Uc(i2, t2)), s2 = s2 && zc(t2[u], un(h2, o), r2.typeArguments[u], e2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1));
                }
                return s2;
              }
              function mS(r2) {
                var i2 = ty(r2);
                if (!nn(i2)) {
                  var t2 = va(r2).resolvedSymbol;
                  if (t2)
                    return t2.flags & 524288 && Aa(t2).typeParameters || (e2.getObjectFlags(i2) & 4 ? i2.target.localTypeParameters : void 0);
                }
              }
              function vS(r2) {
                Wy(r2, r2.typeArguments), r2.kind === 178 && r2.typeName.jsdocDotPos !== void 0 && !e2.isInJSFile(r2) && !e2.isInJSDoc(r2) && rd(r2, r2.typeName.jsdocDotPos, 1, e2.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments), e2.forEach(r2.typeArguments, io);
                var i2 = ty(r2);
                if (!nn(i2)) {
                  r2.typeArguments && fe(function() {
                    var o = mS(r2);
                    o && n6(r2, o);
                  });
                  var t2 = va(r2).resolvedSymbol;
                  t2 && (e2.some(t2.declarations, function(o) {
                    return zy(o) && !!(o.flags & 268435456);
                  }) && El(ky(r2), t2.declarations, t2.escapedName), i2.flags & 32 && t2.flags & 8 && Xr(r2, e2.Diagnostics.Enum_type_0_has_members_with_initializers_that_are_not_literals, Ot(i2)));
                }
              }
              function WO(r2) {
                var i2 = e2.tryCast(r2.parent, e2.isTypeReferenceType);
                if (!!i2) {
                  var t2 = mS(i2);
                  if (!!t2) {
                    var o = Tc(t2[i2.typeArguments.indexOf(r2)]);
                    return o && un(o, Uc(t2, P0(i2, t2)));
                  }
                }
              }
              function qO(r2) {
                yx(r2);
              }
              function VO(r2) {
                e2.forEach(r2.members, io), fe(i2);
                function i2() {
                  var t2 = tE(r2);
                  J0(t2, t2.symbol), dS(r2), r6(r2);
                }
              }
              function KO(r2) {
                io(r2.elementType);
              }
              function GO(r2) {
                for (var i2 = r2.elements, t2 = false, o = false, s2 = e2.some(i2, e2.isNamedTupleMember), u = 0, h2 = i2; u < h2.length; u++) {
                  var z = h2[u];
                  if (z.kind !== 197 && s2) {
                    Tt(z, e2.Diagnostics.Tuple_members_must_all_have_names_or_all_not_have_names);
                    break;
                  }
                  var me = sD(z);
                  if (me & 8) {
                    var Me = Va(z.type);
                    if (!sp(Me)) {
                      Xr(z, e2.Diagnostics.A_rest_element_type_must_be_an_array_type);
                      break;
                    }
                    (Tu(Me) || Yn(Me) && Me.target.combinedFlags & 4) && (o = true);
                  } else if (me & 4) {
                    if (o) {
                      Tt(z, e2.Diagnostics.A_rest_element_cannot_follow_another_rest_element);
                      break;
                    }
                    o = true;
                  } else if (me & 2) {
                    if (o) {
                      Tt(z, e2.Diagnostics.An_optional_element_cannot_follow_a_rest_element);
                      break;
                    }
                    t2 = true;
                  } else if (t2) {
                    Tt(z, e2.Diagnostics.A_required_element_cannot_follow_an_optional_element);
                    break;
                  }
                }
                e2.forEach(r2.elements, io), Va(r2);
              }
              function HO(r2) {
                e2.forEach(r2.types, io), Va(r2);
              }
              function o6(r2, i2) {
                if (!(r2.flags & 8388608))
                  return r2;
                var t2 = r2.objectType, o = r2.indexType;
                if (ao(o, ql(t2, false)))
                  return i2.kind === 207 && e2.isAssignmentTarget(i2) && e2.getObjectFlags(t2) & 32 && Lu(t2) & 1 && Xr(i2, e2.Diagnostics.Index_signature_in_type_0_only_permits_reading, Ot(t2)), r2;
                var s2 = $s(t2);
                if (ss(s2, nt) && Ns(o, 296))
                  return r2;
                if (Ad(t2)) {
                  var u = gD(o, i2);
                  if (u) {
                    var h2 = Od(s2, function(z) {
                      return bi(z, u);
                    });
                    if (h2 && e2.getDeclarationModifierFlagsFromSymbol(h2) & 24)
                      return Xr(i2, e2.Diagnostics.Private_or_protected_member_0_cannot_be_accessed_on_a_type_parameter, e2.unescapeLeadingUnderscores(u)), Pe;
                  }
                }
                return Xr(i2, e2.Diagnostics.Type_0_cannot_be_used_to_index_type_1, Ot(o), Ot(t2)), Pe;
              }
              function XO(r2) {
                io(r2.objectType), io(r2.indexType), o6(Yx(r2), r2);
              }
              function QO(r2) {
                YO(r2), io(r2.typeParameter), io(r2.nameType), io(r2.type), r2.type || Xp(r2, Oe);
                var i2 = yD(r2), t2 = Jl(i2);
                if (t2)
                  zc(t2, at, r2.nameType);
                else {
                  var o = Mu(i2);
                  zc(o, at, e2.getEffectiveConstraintOfTypeParameter(r2.typeParameter));
                }
              }
              function YO(r2) {
                var i2;
                if (!((i2 = r2.members) === null || i2 === void 0) && i2.length)
                  return Tt(r2.members[0], e2.Diagnostics.A_mapped_type_may_not_declare_properties_or_methods);
              }
              function $O(r2) {
                Ch(r2);
              }
              function ZO(r2) {
                oL(r2), io(r2.type);
              }
              function eF(r2) {
                e2.forEachChild(r2, io);
              }
              function rF(r2) {
                e2.findAncestor(r2, function(Me) {
                  return Me.parent && Me.parent.kind === 189 && Me.parent.extendsType === Me;
                }) || Tt(r2, e2.Diagnostics.infer_declarations_are_only_permitted_in_the_extends_clause_of_a_conditional_type), io(r2.typeParameter);
                var i2 = Et(r2.typeParameter);
                if (i2.declarations && i2.declarations.length > 1) {
                  var t2 = Aa(i2);
                  if (!t2.typeParametersChecked) {
                    t2.typeParametersChecked = true;
                    var o = Js(i2), s2 = e2.getDeclarationsOfKind(i2, 163);
                    if (!F6(s2, [o], function(Me) {
                      return [Me];
                    }))
                      for (var u = tn(i2), h2 = 0, z = s2; h2 < z.length; h2++) {
                        var me = z[h2];
                        Xr(me.name, e2.Diagnostics.All_declarations_of_0_must_have_identical_constraints, u);
                      }
                  }
                }
                A_(r2);
              }
              function iF(r2) {
                for (var i2 = 0, t2 = r2.templateSpans; i2 < t2.length; i2++) {
                  var o = t2[i2];
                  io(o.type);
                  var s2 = Va(o.type);
                  zc(s2, ba, o.type);
                }
                Va(r2);
              }
              function tF(r2) {
                if (io(r2.argument), r2.assertions) {
                  var i2 = e2.getResolutionModeOverrideForClause(r2.assertions.assertClause, Tt);
                  i2 && e2.getEmitModuleResolutionKind(ye) !== e2.ModuleResolutionKind.Node16 && e2.getEmitModuleResolutionKind(ye) !== e2.ModuleResolutionKind.NodeNext && Tt(r2.assertions.assertClause, e2.Diagnostics.Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext);
                }
                Va(r2);
              }
              function aF(r2) {
                r2.dotDotDotToken && r2.questionToken && Tt(r2, e2.Diagnostics.A_tuple_member_cannot_be_both_optional_and_rest), r2.type.kind === 185 && Tt(r2.type, e2.Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type), r2.type.kind === 186 && Tt(r2.type, e2.Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type), io(r2.type), Va(r2);
              }
              function I0(r2) {
                return (e2.hasEffectiveModifier(r2, 8) || e2.isPrivateIdentifierClassElementDeclaration(r2)) && !!(r2.flags & 16777216);
              }
              function w0(r2, i2) {
                var t2 = e2.getCombinedModifierFlags(r2);
                return r2.parent.kind !== 258 && r2.parent.kind !== 257 && r2.parent.kind !== 226 && r2.flags & 16777216 && (!(t2 & 2) && !(e2.isModuleBlock(r2.parent) && e2.isModuleDeclaration(r2.parent.parent) && e2.isGlobalScopeAugmentation(r2.parent.parent)) && (t2 |= 1), t2 |= 2), t2 & i2;
              }
              function O0(r2) {
                fe(function() {
                  return nF(r2);
                });
              }
              function nF(r2) {
                function i2(Qt, Ka) {
                  var cn = Ka !== void 0 && Ka.parent === Qt[0].parent;
                  return cn ? Ka : Qt[0];
                }
                function t2(Qt, Ka, cn, Un, oa) {
                  var Mn = Un ^ oa;
                  if (Mn !== 0) {
                    var Ln = w0(i2(Qt, Ka), cn);
                    e2.forEach(Qt, function(ci) {
                      var Fr = w0(ci, cn) ^ Ln;
                      Fr & 1 ? Xr(e2.getNameOfDeclaration(ci), e2.Diagnostics.Overload_signatures_must_all_be_exported_or_non_exported) : Fr & 2 ? Xr(e2.getNameOfDeclaration(ci), e2.Diagnostics.Overload_signatures_must_all_be_ambient_or_non_ambient) : Fr & 24 ? Xr(e2.getNameOfDeclaration(ci) || ci, e2.Diagnostics.Overload_signatures_must_all_be_public_private_or_protected) : Fr & 128 && Xr(e2.getNameOfDeclaration(ci), e2.Diagnostics.Overload_signatures_must_all_be_abstract_or_non_abstract);
                    });
                  }
                }
                function o(Qt, Ka, cn, Un) {
                  if (cn !== Un) {
                    var oa = e2.hasQuestionToken(i2(Qt, Ka));
                    e2.forEach(Qt, function(Mn) {
                      var Ln = e2.hasQuestionToken(Mn) !== oa;
                      Ln && Xr(e2.getNameOfDeclaration(Mn), e2.Diagnostics.Overload_signatures_must_all_be_optional_or_required);
                    });
                  }
                }
                var s2 = 155, u = 0, h2 = s2, z = false, me = true, Me = false, $e, tr, dr, Dr = r2.declarations, Qr = (r2.flags & 16384) !== 0;
                function li(Qt) {
                  if (!(Qt.name && e2.nodeIsMissing(Qt.name))) {
                    var Ka = false, cn = e2.forEachChild(Qt.parent, function(Fr) {
                      if (Ka)
                        return Fr;
                      Ka = Fr === Qt;
                    });
                    if (cn && cn.pos === Qt.end && cn.kind === Qt.kind) {
                      var Un = cn.name || cn, oa = cn.name;
                      if (Qt.name && oa && (e2.isPrivateIdentifier(Qt.name) && e2.isPrivateIdentifier(oa) && Qt.name.escapedText === oa.escapedText || e2.isComputedPropertyName(Qt.name) && e2.isComputedPropertyName(oa) || e2.isPropertyNameLiteral(Qt.name) && e2.isPropertyNameLiteral(oa) && e2.getEscapedTextOfIdentifierOrLiteral(Qt.name) === e2.getEscapedTextOfIdentifierOrLiteral(oa))) {
                        var Mn = (Qt.kind === 169 || Qt.kind === 168) && e2.isStatic(Qt) !== e2.isStatic(cn);
                        if (Mn) {
                          var Ln = e2.isStatic(Qt) ? e2.Diagnostics.Function_overload_must_be_static : e2.Diagnostics.Function_overload_must_not_be_static;
                          Xr(Un, Ln);
                        }
                        return;
                      }
                      if (e2.nodeIsPresent(cn.body)) {
                        Xr(Un, e2.Diagnostics.Function_implementation_name_must_be_0, e2.declarationNameToString(Qt.name));
                        return;
                      }
                    }
                    var ci = Qt.name || Qt;
                    Qr ? Xr(ci, e2.Diagnostics.Constructor_implementation_is_missing) : e2.hasSyntacticModifier(Qt, 128) ? Xr(ci, e2.Diagnostics.All_declarations_of_an_abstract_method_must_be_consecutive) : Xr(ci, e2.Diagnostics.Function_implementation_is_missing_or_not_immediately_following_the_declaration);
                  }
                }
                var Ti = false, Ci = false, $i = false, Zi = [];
                if (Dr)
                  for (var qt = 0, Nt = Dr; qt < Nt.length; qt++) {
                    var Ra = Nt[qt], ca = Ra, Sn = ca.flags & 16777216, ja = ca.parent && (ca.parent.kind === 258 || ca.parent.kind === 182) || Sn;
                    if (ja && (dr = void 0), (ca.kind === 257 || ca.kind === 226) && !Sn && ($i = true), ca.kind === 256 || ca.kind === 169 || ca.kind === 168 || ca.kind === 171) {
                      Zi.push(ca);
                      var Fn = w0(ca, s2);
                      u |= Fn, h2 &= Fn, z = z || e2.hasQuestionToken(ca), me = me && e2.hasQuestionToken(ca);
                      var wn = e2.nodeIsPresent(ca.body);
                      wn && $e ? Qr ? Ci = true : Ti = true : (dr == null ? void 0 : dr.parent) === ca.parent && dr.end !== ca.pos && li(dr), wn ? $e || ($e = ca) : Me = true, dr = ca, ja || (tr = ca);
                    }
                  }
                if (Ci && e2.forEach(Zi, function(Qt) {
                  Xr(Qt, e2.Diagnostics.Multiple_constructor_implementations_are_not_allowed);
                }), Ti && e2.forEach(Zi, function(Qt) {
                  Xr(e2.getNameOfDeclaration(Qt) || Qt, e2.Diagnostics.Duplicate_function_implementation);
                }), $i && !Qr && r2.flags & 16 && Dr) {
                  var Tn = e2.filter(Dr, function(Qt) {
                    return Qt.kind === 257;
                  }).map(function(Qt) {
                    return e2.createDiagnosticForNode(Qt, e2.Diagnostics.Consider_adding_a_declare_modifier_to_this_class);
                  });
                  e2.forEach(Dr, function(Qt) {
                    var Ka = Qt.kind === 257 ? e2.Diagnostics.Class_declaration_cannot_implement_overload_list_for_0 : Qt.kind === 256 ? e2.Diagnostics.Function_with_bodies_can_only_merge_with_classes_that_are_ambient : void 0;
                    Ka && e2.addRelatedInfo.apply(void 0, Ve([Xr(e2.getNameOfDeclaration(Qt) || Qt, Ka, e2.symbolName(r2))], Tn, false));
                  });
                }
                if (tr && !tr.body && !e2.hasSyntacticModifier(tr, 128) && !tr.questionToken && li(tr), Me && (Dr && (t2(Dr, $e, s2, u, h2), o(Dr, $e, z, me)), $e))
                  for (var Eo = S_(r2), lt = yl($e), it = 0, Yt = Eo; it < Yt.length; it++) {
                    var Ia = Yt[it];
                    if (!uw(lt, Ia)) {
                      e2.addRelatedInfo(Xr(Ia.declaration, e2.Diagnostics.This_overload_signature_is_not_compatible_with_its_implementation_signature), e2.createDiagnosticForNode($e, e2.Diagnostics.The_implementation_signature_is_declared_here));
                      break;
                    }
                  }
              }
              function bv(r2) {
                fe(function() {
                  return oF(r2);
                });
              }
              function oF(r2) {
                var i2 = r2.localSymbol;
                if (!i2 && (i2 = Et(r2), !i2.exportSymbol) || e2.getDeclarationOfKind(i2, r2.kind) !== r2)
                  return;
                for (var t2 = 0, o = 0, s2 = 0, u = 0, h2 = i2.declarations; u < h2.length; u++) {
                  var z = h2[u], me = Ti(z), Me = w0(z, 513);
                  Me & 1 ? Me & 512 ? s2 |= me : t2 |= me : o |= me;
                }
                var $e = t2 | o, tr = t2 & o, dr = s2 & $e;
                if (tr || dr)
                  for (var Dr = 0, Qr = i2.declarations; Dr < Qr.length; Dr++) {
                    var z = Qr[Dr], me = Ti(z), li = e2.getNameOfDeclaration(z);
                    me & dr ? Xr(li, e2.Diagnostics.Merged_declaration_0_cannot_include_a_default_export_declaration_Consider_adding_a_separate_export_default_0_declaration_instead, e2.declarationNameToString(li)) : me & tr && Xr(li, e2.Diagnostics.Individual_declarations_in_merged_declaration_0_must_be_all_exported_or_all_local, e2.declarationNameToString(li));
                  }
                function Ti(Ci) {
                  var $i = Ci;
                  switch ($i.kind) {
                    case 258:
                    case 259:
                    case 345:
                    case 338:
                    case 339:
                      return 2;
                    case 261:
                      return e2.isAmbientModule($i) || e2.getModuleInstanceState($i) !== 0 ? 5 : 4;
                    case 257:
                    case 260:
                    case 299:
                      return 3;
                    case 305:
                      return 7;
                    case 271:
                    case 221:
                      var Zi = $i, qt = e2.isExportAssignment(Zi) ? Zi.expression : Zi.right;
                      if (!e2.isEntityNameExpression(qt))
                        return 1;
                      $i = qt;
                    case 265:
                    case 268:
                    case 267:
                      var Nt = 0, Ra = Ps(Et($i));
                      return e2.forEach(Ra.declarations, function(ca) {
                        Nt |= Ti(ca);
                      }), Nt;
                    case 254:
                    case 203:
                    case 256:
                    case 270:
                    case 79:
                      return 1;
                    default:
                      return e2.Debug.failBadSyntaxKind($i);
                  }
                }
              }
              function Sv(r2, i2, t2, o) {
                var s2 = Tv(r2, i2);
                return s2 && ag(s2, i2, t2, o);
              }
              function Tv(r2, i2) {
                if (!ta(r2)) {
                  var t2 = r2;
                  if (t2.promisedTypeOfPromise)
                    return t2.promisedTypeOfPromise;
                  if (Xf(r2, ay(false)))
                    return t2.promisedTypeOfPromise = xo(r2)[0];
                  if (!Lg(r2, 262140)) {
                    var o = da(r2, "then");
                    if (!ta(o)) {
                      var s2 = o ? ot(o, 0) : e2.emptyArray;
                      if (s2.length === 0) {
                        i2 && Xr(i2, e2.Diagnostics.A_promise_must_have_a_then_method);
                        return;
                      }
                      var u = Ks(Pa(e2.map(s2, aS)), 2097152);
                      if (!ta(u)) {
                        var h2 = ot(u, 0);
                        if (h2.length === 0) {
                          i2 && Xr(i2, e2.Diagnostics.The_first_parameter_of_the_then_method_of_a_promise_must_be_a_callback);
                          return;
                        }
                        return t2.promisedTypeOfPromise = Pa(e2.map(h2, aS), 2);
                      }
                    }
                  }
                }
              }
              function xv(r2, i2, t2, o, s2) {
                var u = i2 ? ag(r2, t2, o, s2) : k_(r2, t2, o, s2);
                return u || Pe;
              }
              function s6(r2) {
                if (Lg(r2, 262140))
                  return false;
                var i2 = da(r2, "then");
                return !!i2 && ot(Ks(i2, 2097152), 0).length > 0;
              }
              function yS(r2) {
                var i2;
                if (r2.flags & 16777216) {
                  var t2 = oD(false);
                  return !!t2 && r2.aliasSymbol === t2 && ((i2 = r2.aliasTypeArguments) === null || i2 === void 0 ? void 0 : i2.length) === 1;
                }
                return false;
              }
              function Ev(r2) {
                return r2.flags & 1048576 ? Ss(r2, Ev) : yS(r2) ? r2.aliasTypeArguments[0] : r2;
              }
              function sF(r2) {
                if (ta(r2) || yS(r2))
                  return r2;
                if (Ad(r2)) {
                  var i2 = uc(r2);
                  if (!i2 || i2.flags & 3 || Of(i2) || s6(i2)) {
                    var t2 = oD(true);
                    if (t2)
                      return am(t2, [Ev(r2)]);
                  }
                }
                return e2.Debug.assert(Tv(r2) === void 0, "type provided should not be a non-generic 'promise'-like."), r2;
              }
              function ag(r2, i2, t2, o) {
                var s2 = k_(r2, i2, t2, o);
                return s2 && sF(s2);
              }
              function k_(r2, i2, t2, o) {
                if (ta(r2) || yS(r2))
                  return r2;
                var s2 = r2;
                if (s2.awaitedTypeOfType)
                  return s2.awaitedTypeOfType;
                if (r2.flags & 1048576) {
                  var u = i2 ? function(me) {
                    return k_(me, i2, t2, o);
                  } : k_;
                  return s2.awaitedTypeOfType = Ss(r2, u);
                }
                var h2 = Tv(r2);
                if (h2) {
                  if (r2.id === h2.id || qa.lastIndexOf(h2.id) >= 0) {
                    i2 && Xr(i2, e2.Diagnostics.Type_is_referenced_directly_or_indirectly_in_the_fulfillment_callback_of_its_own_then_method);
                    return;
                  }
                  qa.push(r2.id);
                  var z = k_(h2, i2, t2, o);
                  return qa.pop(), z ? s2.awaitedTypeOfType = z : void 0;
                }
                if (s6(r2)) {
                  i2 && (e2.Debug.assertIsDefined(t2), Xr(i2, t2, o));
                  return;
                }
                return s2.awaitedTypeOfType = r2;
              }
              function cF(r2, i2) {
                var t2 = Va(i2);
                if (Ae >= 2) {
                  if (nn(t2))
                    return;
                  var o = ay(true);
                  if (o !== kn && !Xf(t2, o)) {
                    Xr(i2, e2.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0, Ot(k_(t2) || Fi));
                    return;
                  }
                } else {
                  if (lF(i2), nn(t2))
                    return;
                  var s2 = e2.getEntityNameFromTypeNode(i2);
                  if (s2 === void 0) {
                    Xr(i2, e2.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, Ot(t2));
                    return;
                  }
                  var u = Ds(s2, 111551, true), h2 = u ? Jt(u) : Pe;
                  if (nn(h2)) {
                    s2.kind === 79 && s2.escapedText === "Promise" && bd(t2) === ay(false) ? Xr(i2, e2.Diagnostics.An_async_function_or_method_in_ES5_SlashES3_requires_the_Promise_constructor_Make_sure_you_have_a_declaration_for_the_Promise_constructor_or_include_ES2015_in_your_lib_option) : Xr(i2, e2.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, e2.entityNameToString(s2));
                    return;
                  }
                  var z = E3(true);
                  if (z === Ba) {
                    Xr(i2, e2.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value, e2.entityNameToString(s2));
                    return;
                  }
                  if (!zc(h2, z, i2, e2.Diagnostics.Type_0_is_not_a_valid_async_function_return_type_in_ES5_SlashES3_because_it_does_not_refer_to_a_Promise_compatible_constructor_value))
                    return;
                  var me = s2 && e2.getFirstIdentifier(s2), Me = qs(r2.locals, me.escapedText, 111551);
                  if (Me) {
                    Xr(Me.valueDeclaration, e2.Diagnostics.Duplicate_identifier_0_Compiler_uses_declaration_1_to_support_async_functions, e2.idText(me), e2.entityNameToString(s2));
                    return;
                  }
                }
                xv(t2, false, r2, e2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member);
              }
              function uF(r2) {
                var i2 = Mg(r2);
                x0(i2, r2);
                var t2 = yo(i2);
                if (!(t2.flags & 1)) {
                  var o, s2;
                  switch (r2.parent.kind) {
                    case 257:
                      o = e2.Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
                      var u = Et(r2.parent), h2 = Jt(u);
                      s2 = Pa([h2, Fi]);
                      break;
                    case 167:
                    case 164:
                      o = e2.Diagnostics.Decorator_function_return_type_is_0_but_is_expected_to_be_void_or_any, s2 = Fi;
                      break;
                    case 169:
                    case 172:
                    case 173:
                      o = e2.Diagnostics.Decorator_function_return_type_0_is_not_assignable_to_type_1;
                      var z = Bd(r2.parent), me = Px(z);
                      s2 = Pa([me, Fi]);
                      break;
                    default:
                      return e2.Debug.fail();
                  }
                  zc(t2, s2, r2, o);
                }
              }
              function lF(r2) {
                c6(r2 && e2.getEntityNameFromTypeNode(r2), false);
              }
              function c6(r2, i2) {
                if (!!r2) {
                  var t2 = e2.getFirstIdentifier(r2), o = (r2.kind === 79 ? 788968 : 1920) | 2097152, s2 = es(t2, t2.escapedText, o, void 0, void 0, true);
                  if (s2 && s2.flags & 2097152) {
                    if (gc(s2) && !Av(Ps(s2)) && !vu(s2))
                      As(s2);
                    else if (i2 && ye.isolatedModules && e2.getEmitModuleKind(ye) >= e2.ModuleKind.ES2015 && !gc(s2) && !e2.some(s2.declarations, e2.isTypeOnlyImportOrExportDeclaration)) {
                      var u = Xr(r2, e2.Diagnostics.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled), h2 = e2.find(s2.declarations || e2.emptyArray, yf);
                      h2 && e2.addRelatedInfo(u, e2.createDiagnosticForNode(h2, e2.Diagnostics._0_was_imported_here, e2.idText(t2)));
                    }
                  }
                }
              }
              function bm(r2) {
                var i2 = hS(r2);
                i2 && e2.isEntityName(i2) && c6(i2, true);
              }
              function hS(r2) {
                if (r2)
                  switch (r2.kind) {
                    case 188:
                    case 187:
                      return u6(r2.types);
                    case 189:
                      return u6([r2.trueType, r2.falseType]);
                    case 191:
                    case 197:
                      return hS(r2.type);
                    case 178:
                      return r2.typeName;
                  }
              }
              function u6(r2) {
                for (var i2, t2 = 0, o = r2; t2 < o.length; t2++) {
                  for (var s2 = o[t2]; s2.kind === 191 || s2.kind === 197; )
                    s2 = s2.type;
                  if (s2.kind !== 143 && !(!Ye && (s2.kind === 196 && s2.literal.kind === 104 || s2.kind === 153))) {
                    var u = hS(s2);
                    if (!u)
                      return;
                    if (i2) {
                      if (!e2.isIdentifier(i2) || !e2.isIdentifier(u) || i2.escapedText !== u.escapedText)
                        return;
                    } else
                      i2 = u;
                  }
                }
                return i2;
              }
              function F0(r2) {
                var i2 = e2.getEffectiveTypeAnnotationNode(r2);
                return e2.isRestParameter(r2) ? e2.getRestParameterElementType(i2) : i2;
              }
              function Fy(r2) {
                if (!!r2.decorators && !!e2.nodeCanBeDecorated(r2, r2.parent, r2.parent.parent)) {
                  ye.experimentalDecorators || Xr(r2, e2.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning);
                  var i2 = r2.decorators[0];
                  if (fc(i2, 8), r2.kind === 164 && fc(i2, 32), ye.emitDecoratorMetadata)
                    switch (fc(i2, 16), r2.kind) {
                      case 257:
                        var t2 = e2.getFirstConstructorWithBody(r2);
                        if (t2)
                          for (var o = 0, s2 = t2.parameters; o < s2.length; o++) {
                            var u = s2[o];
                            bm(F0(u));
                          }
                        break;
                      case 172:
                      case 173:
                        var h2 = r2.kind === 172 ? 173 : 172, z = e2.getDeclarationOfKind(Et(r2), h2);
                        bm(W(r2) || z && W(z));
                        break;
                      case 169:
                        for (var me = 0, Me = r2.parameters; me < Me.length; me++) {
                          var u = Me[me];
                          bm(F0(u));
                        }
                        bm(e2.getEffectiveReturnTypeNode(r2));
                        break;
                      case 167:
                        bm(e2.getEffectiveTypeAnnotationNode(r2));
                        break;
                      case 164:
                        bm(F0(r2));
                        for (var $e = r2.parent, tr = 0, dr = $e.parameters; tr < dr.length; tr++) {
                          var u = dr[tr];
                          bm(F0(u));
                        }
                        break;
                    }
                  e2.forEach(r2.decorators, uF);
                }
              }
              function fF(r2) {
                fe(i2);
                function i2() {
                  f6(r2), WS(r2), Sm(r2, r2.name);
                }
              }
              function _F(r2) {
                r2.typeExpression || Xr(r2.name, e2.Diagnostics.JSDoc_typedef_tag_should_either_have_a_type_annotation_or_be_followed_by_property_or_member_tags), r2.name && Tm(r2.name, e2.Diagnostics.Type_alias_name_cannot_be_0), io(r2.typeExpression), jy(e2.getEffectiveTypeParameterDeclarations(r2));
              }
              function pF(r2) {
                io(r2.constraint);
                for (var i2 = 0, t2 = r2.typeParameters; i2 < t2.length; i2++) {
                  var o = t2[i2];
                  io(o);
                }
              }
              function dF(r2) {
                io(r2.typeExpression);
              }
              function gF(r2) {
                io(r2.typeExpression);
              }
              function mF(r2) {
                io(r2.typeExpression);
              }
              function vF(r2) {
                fe(i2), Dv(r2);
                function i2() {
                  !r2.type && !e2.isJSDocConstructSignature(r2) && Xp(r2, Oe);
                }
              }
              function yF(r2) {
                var i2 = e2.getEffectiveJSDocHost(r2);
                (!i2 || !e2.isClassDeclaration(i2) && !e2.isClassExpression(i2)) && Xr(i2, e2.Diagnostics.JSDoc_0_is_not_attached_to_a_class, e2.idText(r2.tagName));
              }
              function hF(r2) {
                var i2 = e2.getEffectiveJSDocHost(r2);
                if (!i2 || !e2.isClassDeclaration(i2) && !e2.isClassExpression(i2)) {
                  Xr(i2, e2.Diagnostics.JSDoc_0_is_not_attached_to_a_class, e2.idText(r2.tagName));
                  return;
                }
                var t2 = e2.getJSDocTags(i2).filter(e2.isJSDocAugmentsTag);
                e2.Debug.assert(t2.length > 0), t2.length > 1 && Xr(t2[1], e2.Diagnostics.Class_declarations_cannot_have_more_than_one_augments_or_extends_tag);
                var o = l6(r2.class.expression), s2 = e2.getClassExtendsHeritageElement(i2);
                if (s2) {
                  var u = l6(s2.expression);
                  u && o.escapedText !== u.escapedText && Xr(o, e2.Diagnostics.JSDoc_0_1_does_not_match_the_extends_2_clause, e2.idText(r2.tagName), e2.idText(o), e2.idText(u));
                }
              }
              function DF(r2) {
                var i2 = e2.getJSDocHost(r2);
                i2 && e2.isPrivateIdentifierClassElementDeclaration(i2) && Xr(r2, e2.Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
              }
              function l6(r2) {
                switch (r2.kind) {
                  case 79:
                    return r2;
                  case 206:
                    return r2.name;
                  default:
                    return;
                }
              }
              function f6(r2) {
                var i2;
                Fy(r2), Dv(r2);
                var t2 = e2.getFunctionFlags(r2);
                if (r2.name && r2.name.kind === 162 && t_(r2.name), Td(r2)) {
                  var o = Et(r2), s2 = r2.localSymbol || o, u = (i2 = s2.declarations) === null || i2 === void 0 ? void 0 : i2.find(function(Me) {
                    return Me.kind === r2.kind && !(Me.flags & 262144);
                  });
                  r2 === u && O0(s2), o.parent && O0(o);
                }
                var h2 = r2.kind === 168 ? void 0 : r2.body;
                if (io(h2), sS(r2, yg(r2)), fe(me), e2.isInJSFile(r2)) {
                  var z = e2.getJSDocTypeTag(r2);
                  z && z.typeExpression && !Nb(Va(z.typeExpression), r2) && Xr(z.typeExpression.type, e2.Diagnostics.The_type_of_a_function_declaration_must_match_the_function_s_signature);
                }
                function me() {
                  e2.getEffectiveReturnTypeNode(r2) || (e2.nodeIsMissing(h2) && !I0(r2) && Xp(r2, Oe), t2 & 1 && e2.nodeIsPresent(h2) && yo(yl(r2)));
                }
              }
              function A_(r2) {
                fe(i2);
                function i2() {
                  var t2 = e2.getSourceFileOfNode(r2), o = Fo.get(t2.path);
                  o || (o = [], Fo.set(t2.path, o)), o.push(r2);
                }
              }
              function _6(r2, i2) {
                for (var t2 = 0, o = r2; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  switch (s2.kind) {
                    case 257:
                    case 226:
                      bF(s2, i2), DS(s2, i2);
                      break;
                    case 305:
                    case 261:
                    case 235:
                    case 263:
                    case 242:
                    case 243:
                    case 244:
                      g6(s2, i2);
                      break;
                    case 171:
                    case 213:
                    case 256:
                    case 214:
                    case 169:
                    case 172:
                    case 173:
                      s2.body && g6(s2, i2), DS(s2, i2);
                      break;
                    case 168:
                    case 174:
                    case 175:
                    case 179:
                    case 180:
                    case 259:
                    case 258:
                      DS(s2, i2);
                      break;
                    case 190:
                      SF(s2, i2);
                      break;
                    default:
                      e2.Debug.assertNever(s2, "Node should not have been registered for unused identifiers check");
                  }
                }
              }
              function p6(r2, i2, t2) {
                var o = e2.getNameOfDeclaration(r2) || r2, s2 = zy(r2) ? e2.Diagnostics._0_is_declared_but_never_used : e2.Diagnostics._0_is_declared_but_its_value_is_never_read;
                t2(r2, 0, e2.createDiagnosticForNode(o, s2, i2));
              }
              function My(r2) {
                return e2.isIdentifier(r2) && e2.idText(r2).charCodeAt(0) === 95;
              }
              function bF(r2, i2) {
                for (var t2 = 0, o = r2.members; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  switch (s2.kind) {
                    case 169:
                    case 167:
                    case 172:
                    case 173:
                      if (s2.kind === 173 && s2.symbol.flags & 32768)
                        break;
                      var u = Et(s2);
                      !u.isReferenced && (e2.hasEffectiveModifier(s2, 8) || e2.isNamedDeclaration(s2) && e2.isPrivateIdentifier(s2.name)) && !(s2.flags & 16777216) && i2(s2, 0, e2.createDiagnosticForNode(s2.name, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, tn(u)));
                      break;
                    case 171:
                      for (var h2 = 0, z = s2.parameters; h2 < z.length; h2++) {
                        var me = z[h2];
                        !me.symbol.isReferenced && e2.hasSyntacticModifier(me, 8) && i2(me, 0, e2.createDiagnosticForNode(me.name, e2.Diagnostics.Property_0_is_declared_but_its_value_is_never_read, e2.symbolName(me.symbol)));
                      }
                      break;
                    case 176:
                    case 234:
                    case 170:
                      break;
                    default:
                      e2.Debug.fail("Unexpected class member");
                  }
                }
              }
              function SF(r2, i2) {
                var t2 = r2.typeParameter;
                bS(t2) && i2(r2, 1, e2.createDiagnosticForNode(r2, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, e2.idText(t2.name)));
              }
              function DS(r2, i2) {
                var t2 = Et(r2).declarations;
                if (!(!t2 || e2.last(t2) !== r2))
                  for (var o = e2.getEffectiveTypeParameterDeclarations(r2), s2 = new e2.Set(), u = 0, h2 = o; u < h2.length; u++) {
                    var z = h2[u];
                    if (!!bS(z)) {
                      var me = e2.idText(z.name), Me = z.parent;
                      if (Me.kind !== 190 && Me.typeParameters.every(bS)) {
                        if (e2.tryAddToSet(s2, Me)) {
                          var $e = e2.getSourceFileOfNode(Me), tr = e2.isJSDocTemplateTag(Me) ? e2.rangeOfNode(Me) : e2.rangeOfTypeParameters($e, Me.typeParameters), dr = Me.typeParameters.length === 1, Dr = dr ? e2.Diagnostics._0_is_declared_but_its_value_is_never_read : e2.Diagnostics.All_type_parameters_are_unused, Qr = dr ? me : void 0;
                          i2(z, 1, e2.createFileDiagnostic($e, tr.pos, tr.end - tr.pos, Dr, Qr));
                        }
                      } else
                        i2(z, 1, e2.createDiagnosticForNode(z, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, me));
                    }
                  }
              }
              function bS(r2) {
                return !(so(r2.symbol).isReferenced & 262144) && !My(r2.name);
              }
              function Ly(r2, i2, t2, o) {
                var s2 = String(o(i2)), u = r2.get(s2);
                u ? u[1].push(t2) : r2.set(s2, [i2, [t2]]);
              }
              function d6(r2) {
                return e2.tryCast(e2.getRootDeclaration(r2), e2.isParameter);
              }
              function TF(r2) {
                return e2.isBindingElement(r2) ? e2.isObjectBindingPattern(r2.parent) ? !!(r2.propertyName && My(r2.name)) : My(r2.name) : e2.isAmbientModule(r2) || (e2.isVariableDeclaration(r2) && e2.isForInOrOfStatement(r2.parent.parent) || m6(r2)) && My(r2.name);
              }
              function g6(r2, i2) {
                var t2 = new e2.Map(), o = new e2.Map(), s2 = new e2.Map();
                r2.locals.forEach(function(u) {
                  if (!(u.flags & 262144 ? !(u.flags & 3 && !(u.isReferenced & 3)) : u.isReferenced || u.exportSymbol) && u.declarations)
                    for (var h2 = 0, z = u.declarations; h2 < z.length; h2++) {
                      var me = z[h2];
                      if (!TF(me))
                        if (m6(me))
                          Ly(t2, xF(me), me, A2);
                        else if (e2.isBindingElement(me) && e2.isObjectBindingPattern(me.parent)) {
                          var Me = e2.last(me.parent.elements);
                          (me === Me || !e2.last(me.parent.elements).dotDotDotToken) && Ly(o, me.parent, me, A2);
                        } else if (e2.isVariableDeclaration(me))
                          Ly(s2, me.parent, me, A2);
                        else {
                          var $e = u.valueDeclaration && d6(u.valueDeclaration), tr = u.valueDeclaration && e2.getNameOfDeclaration(u.valueDeclaration);
                          $e && tr ? !e2.isParameterPropertyDeclaration($e, $e.parent) && !e2.parameterIsThisKeyword($e) && !My(tr) && (e2.isBindingElement(me) && e2.isArrayBindingPattern(me.parent) ? Ly(o, me.parent, me, A2) : i2($e, 1, e2.createDiagnosticForNode(tr, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, e2.symbolName(u)))) : p6(me, e2.symbolName(u), i2);
                        }
                    }
                }), t2.forEach(function(u) {
                  var h2 = u[0], z = u[1], me = h2.parent, Me = (h2.name ? 1 : 0) + (h2.namedBindings ? h2.namedBindings.kind === 268 ? 1 : h2.namedBindings.elements.length : 0);
                  if (Me === z.length)
                    i2(me, 0, z.length === 1 ? e2.createDiagnosticForNode(me, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, e2.idText(e2.first(z).name)) : e2.createDiagnosticForNode(me, e2.Diagnostics.All_imports_in_import_declaration_are_unused));
                  else
                    for (var $e = 0, tr = z; $e < tr.length; $e++) {
                      var dr = tr[$e];
                      p6(dr, e2.idText(dr.name), i2);
                    }
                }), o.forEach(function(u) {
                  var h2 = u[0], z = u[1], me = d6(h2.parent) ? 1 : 0;
                  if (h2.elements.length === z.length)
                    z.length === 1 && h2.parent.kind === 254 && h2.parent.parent.kind === 255 ? Ly(s2, h2.parent.parent, h2.parent, A2) : i2(h2, me, z.length === 1 ? e2.createDiagnosticForNode(h2, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, Ry(e2.first(z).name)) : e2.createDiagnosticForNode(h2, e2.Diagnostics.All_destructured_elements_are_unused));
                  else
                    for (var Me = 0, $e = z; Me < $e.length; Me++) {
                      var tr = $e[Me];
                      i2(tr, me, e2.createDiagnosticForNode(tr, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, Ry(tr.name)));
                    }
                }), s2.forEach(function(u) {
                  var h2 = u[0], z = u[1];
                  if (h2.declarations.length === z.length)
                    i2(h2, 0, z.length === 1 ? e2.createDiagnosticForNode(e2.first(z).name, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, Ry(e2.first(z).name)) : e2.createDiagnosticForNode(h2.parent.kind === 237 ? h2.parent : h2, e2.Diagnostics.All_variables_are_unused));
                  else
                    for (var me = 0, Me = z; me < Me.length; me++) {
                      var $e = Me[me];
                      i2($e, 0, e2.createDiagnosticForNode($e, e2.Diagnostics._0_is_declared_but_its_value_is_never_read, Ry($e.name)));
                    }
                });
              }
              function Ry(r2) {
                switch (r2.kind) {
                  case 79:
                    return e2.idText(r2);
                  case 202:
                  case 201:
                    return Ry(e2.cast(e2.first(r2.elements), e2.isBindingElement).name);
                  default:
                    return e2.Debug.assertNever(r2);
                }
              }
              function m6(r2) {
                return r2.kind === 267 || r2.kind === 270 || r2.kind === 268;
              }
              function xF(r2) {
                return r2.kind === 267 ? r2 : r2.kind === 268 ? r2.parent : r2.parent.parent;
              }
              function M0(r2) {
                if (r2.kind === 235 && Mf(r2), e2.isFunctionOrModuleBlock(r2)) {
                  var i2 = Bs;
                  e2.forEach(r2.statements, io), Bs = i2;
                } else
                  e2.forEach(r2.statements, io);
                r2.locals && A_(r2);
              }
              function EF(r2) {
                Ae >= 2 || !e2.hasRestParameter(r2) || r2.flags & 16777216 || e2.nodeIsMissing(r2.body) || e2.forEach(r2.parameters, function(i2) {
                  i2.name && !e2.isBindingPattern(i2.name) && i2.name.escapedText === or.escapedName && Es("noEmit", i2, e2.Diagnostics.Duplicate_identifier_arguments_Compiler_uses_arguments_to_initialize_rest_parameters);
                });
              }
              function Cv(r2, i2, t2) {
                if ((i2 == null ? void 0 : i2.escapedText) !== t2 || r2.kind === 167 || r2.kind === 166 || r2.kind === 169 || r2.kind === 168 || r2.kind === 172 || r2.kind === 173 || r2.kind === 296 || r2.flags & 16777216 || (e2.isImportClause(r2) || e2.isImportEqualsDeclaration(r2) || e2.isImportSpecifier(r2)) && e2.isTypeOnlyImportOrExportDeclaration(r2))
                  return false;
                var o = e2.getRootDeclaration(r2);
                return !(e2.isParameter(o) && e2.nodeIsMissing(o.parent.body));
              }
              function CF(r2) {
                e2.findAncestor(r2, function(i2) {
                  if (Ug(i2) & 4) {
                    var t2 = r2.kind !== 79;
                    return t2 ? Xr(e2.getNameOfDeclaration(r2), e2.Diagnostics.Duplicate_identifier_this_Compiler_uses_variable_declaration_this_to_capture_this_reference) : Xr(r2, e2.Diagnostics.Expression_resolves_to_variable_declaration_this_that_compiler_uses_to_capture_this_reference), true;
                  }
                  return false;
                });
              }
              function kF(r2) {
                e2.findAncestor(r2, function(i2) {
                  if (Ug(i2) & 8) {
                    var t2 = r2.kind !== 79;
                    return t2 ? Xr(e2.getNameOfDeclaration(r2), e2.Diagnostics.Duplicate_identifier_newTarget_Compiler_uses_variable_declaration_newTarget_to_capture_new_target_meta_property_reference) : Xr(r2, e2.Diagnostics.Expression_resolves_to_variable_declaration_newTarget_that_compiler_uses_to_capture_new_target_meta_property_reference), true;
                  }
                  return false;
                });
              }
              function AF(r2, i2) {
                if (!(er >= e2.ModuleKind.ES2015 && !(er >= e2.ModuleKind.Node16 && e2.getSourceFileOfNode(r2).impliedNodeFormat === e2.ModuleKind.CommonJS)) && !(!i2 || !Cv(r2, i2, "require") && !Cv(r2, i2, "exports")) && !(e2.isModuleDeclaration(r2) && e2.getModuleInstanceState(r2) !== 1)) {
                  var t2 = zi(r2);
                  t2.kind === 305 && e2.isExternalOrCommonJsModule(t2) && Es("noEmit", i2, e2.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module, e2.declarationNameToString(i2), e2.declarationNameToString(i2));
                }
              }
              function NF(r2, i2) {
                if (!(!i2 || Ae >= 4 || !Cv(r2, i2, "Promise")) && !(e2.isModuleDeclaration(r2) && e2.getModuleInstanceState(r2) !== 1)) {
                  var t2 = zi(r2);
                  t2.kind === 305 && e2.isExternalOrCommonJsModule(t2) && t2.flags & 2048 && Es("noEmit", i2, e2.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_in_top_level_scope_of_a_module_containing_async_functions, e2.declarationNameToString(i2), e2.declarationNameToString(i2));
                }
              }
              function PF(r2, i2) {
                Ae <= 8 && (Cv(r2, i2, "WeakMap") || Cv(r2, i2, "WeakSet")) && bn.push(r2);
              }
              function IF(r2) {
                var i2 = e2.getEnclosingBlockScopeContainer(r2);
                Ug(i2) & 67108864 && (e2.Debug.assert(e2.isNamedDeclaration(r2) && e2.isIdentifier(r2.name) && typeof r2.name.escapedText == "string", "The target of a WeakMap/WeakSet collision check should be an identifier"), Es("noEmit", r2, e2.Diagnostics.Compiler_reserves_name_0_when_emitting_private_identifier_downlevel, r2.name.escapedText));
              }
              function wF(r2, i2) {
                i2 && Ae >= 2 && Ae <= 8 && Cv(r2, i2, "Reflect") && _a4.push(r2);
              }
              function OF(r2) {
                var i2 = false;
                if (e2.isClassExpression(r2))
                  for (var t2 = 0, o = r2.members; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (Ug(s2) & 134217728) {
                      i2 = true;
                      break;
                    }
                  }
                else if (e2.isFunctionExpression(r2))
                  Ug(r2) & 134217728 && (i2 = true);
                else {
                  var u = e2.getEnclosingBlockScopeContainer(r2);
                  u && Ug(u) & 134217728 && (i2 = true);
                }
                i2 && (e2.Debug.assert(e2.isNamedDeclaration(r2) && e2.isIdentifier(r2.name), "The target of a Reflect collision check should be an identifier"), Es("noEmit", r2, e2.Diagnostics.Duplicate_identifier_0_Compiler_reserves_name_1_when_emitting_super_references_in_static_initializers, e2.declarationNameToString(r2.name), "Reflect"));
              }
              function Sm(r2, i2) {
                !i2 || (AF(r2, i2), NF(r2, i2), PF(r2, i2), wF(r2, i2), e2.isClassLike(r2) ? (Tm(i2, e2.Diagnostics.Class_name_cannot_be_0), r2.flags & 16777216 || oM(i2)) : e2.isEnumDeclaration(r2) && Tm(i2, e2.Diagnostics.Enum_name_cannot_be_0));
              }
              function FF(r2) {
                if (!((e2.getCombinedNodeFlags(r2) & 3) !== 0 || e2.isParameterDeclaration(r2)) && !(r2.kind === 254 && !r2.initializer)) {
                  var i2 = Et(r2);
                  if (i2.flags & 1) {
                    if (!e2.isIdentifier(r2.name))
                      return e2.Debug.fail();
                    var t2 = es(r2, r2.name.escapedText, 3, void 0, void 0, false);
                    if (t2 && t2 !== i2 && t2.flags & 2 && p0(t2) & 3) {
                      var o = e2.getAncestor(t2.valueDeclaration, 255), s2 = o.parent.kind === 237 && o.parent.parent ? o.parent.parent : void 0, u = s2 && (s2.kind === 235 && e2.isFunctionLike(s2.parent) || s2.kind === 262 || s2.kind === 261 || s2.kind === 305);
                      if (!u) {
                        var h2 = tn(t2);
                        Xr(r2, e2.Diagnostics.Cannot_initialize_outer_scoped_variable_0_in_the_same_scope_as_block_scoped_declaration_1, h2, h2);
                      }
                    }
                  }
                }
              }
              function kv(r2) {
                return r2 === nr ? Oe : r2 === So ? mo : r2;
              }
              function L0(r2) {
                var i2;
                if (Fy(r2), e2.isBindingElement(r2) || io(r2.type), !!r2.name) {
                  if (r2.name.kind === 162 && (t_(r2.name), r2.initializer && Os(r2.initializer)), e2.isBindingElement(r2)) {
                    e2.isObjectBindingPattern(r2.parent) && r2.dotDotDotToken && Ae < 5 && fc(r2, 4), r2.propertyName && r2.propertyName.kind === 162 && t_(r2.propertyName);
                    var t2 = r2.parent.parent, o = r2.dotDotDotToken ? 64 : 0, s2 = Wo(t2, o), u = r2.propertyName || r2.name;
                    if (s2 && !e2.isBindingPattern(u)) {
                      var h2 = Z_(u);
                      if (_f(h2)) {
                        var z = pf(h2), me = bi(s2, z);
                        me && (xy(me, void 0, false), Jb(r2, !!t2.initializer && t2.initializer.kind === 106, false, s2, me));
                      }
                    }
                  }
                  if (e2.isBindingPattern(r2.name) && (r2.name.kind === 202 && Ae < 2 && ye.downlevelIteration && fc(r2, 512), e2.forEach(r2.name.elements, io)), r2.initializer && e2.isParameterDeclaration(r2) && e2.nodeIsMissing(e2.getContainingFunction(r2).body)) {
                    Xr(r2, e2.Diagnostics.A_parameter_initializer_is_only_allowed_in_a_function_or_constructor_implementation);
                    return;
                  }
                  if (e2.isBindingPattern(r2.name)) {
                    var Me = r2.initializer && r2.parent.parent.kind !== 243, $e = r2.name.elements.length === 0;
                    if (Me || $e) {
                      var tr = sc(r2);
                      if (Me) {
                        var dr = Os(r2.initializer);
                        Ye && $e ? qC(dr, r2) : op(dr, sc(r2), r2, r2.initializer);
                      }
                      $e && (e2.isArrayBindingPattern(r2.name) ? N_(65, tr, Tr, r2) : Ye && qC(tr, r2));
                    }
                    return;
                  }
                  var Dr = Et(r2);
                  if (Dr.flags & 2097152 && e2.isVariableDeclarationInitializedToBareOrAccessedRequire(r2)) {
                    j0(r2);
                    return;
                  }
                  var Qr = kv(Jt(Dr));
                  if (r2 === Dr.valueDeclaration) {
                    var li = e2.getEffectiveInitializer(r2);
                    if (li) {
                      var Ti = e2.isInJSFile(r2) && e2.isObjectLiteralExpression(li) && (li.properties.length === 0 || e2.isPrototypeAccess(r2.name)) && !!(!((i2 = Dr.exports) === null || i2 === void 0) && i2.size);
                      !Ti && r2.parent.parent.kind !== 243 && op(Os(li), Qr, r2, li, void 0);
                    }
                    Dr.declarations && Dr.declarations.length > 1 && e2.some(Dr.declarations, function($i) {
                      return $i !== r2 && e2.isVariableLike($i) && !y6($i, r2);
                    }) && Xr(r2.name, e2.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, e2.declarationNameToString(r2.name));
                  } else {
                    var Ci = kv(sc(r2));
                    !nn(Qr) && !nn(Ci) && !wf(Qr, Ci) && !(Dr.flags & 67108864) && v6(Dr.valueDeclaration, Qr, r2, Ci), r2.initializer && op(Os(r2.initializer), Ci, r2, r2.initializer, void 0), Dr.valueDeclaration && !y6(r2, Dr.valueDeclaration) && Xr(r2.name, e2.Diagnostics.All_declarations_of_0_must_have_identical_modifiers, e2.declarationNameToString(r2.name));
                  }
                  r2.kind !== 167 && r2.kind !== 166 && (bv(r2), (r2.kind === 254 || r2.kind === 203) && FF(r2), Sm(r2, r2.name));
                }
              }
              function v6(r2, i2, t2, o) {
                var s2 = e2.getNameOfDeclaration(t2), u = t2.kind === 167 || t2.kind === 166 ? e2.Diagnostics.Subsequent_property_declarations_must_have_the_same_type_Property_0_must_be_of_type_1_but_here_has_type_2 : e2.Diagnostics.Subsequent_variable_declarations_must_have_the_same_type_Variable_0_must_be_of_type_1_but_here_has_type_2, h2 = e2.declarationNameToString(s2), z = Xr(s2, u, h2, Ot(i2), Ot(o));
                r2 && e2.addRelatedInfo(z, e2.createDiagnosticForNode(r2, e2.Diagnostics._0_was_also_declared_here, h2));
              }
              function y6(r2, i2) {
                if (r2.kind === 164 && i2.kind === 254 || r2.kind === 254 && i2.kind === 164)
                  return true;
                if (e2.hasQuestionToken(r2) !== e2.hasQuestionToken(i2))
                  return false;
                var t2 = 504;
                return e2.getSelectedEffectiveModifierFlags(r2, t2) === e2.getSelectedEffectiveModifierFlags(i2, t2);
              }
              function SS(r2) {
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("check", "checkVariableDeclaration", { kind: r2.kind, pos: r2.pos, end: r2.end, path: r2.tracingPath }), fL(r2), L0(r2), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
              }
              function MF(r2) {
                return cL(r2), L0(r2);
              }
              function LF2(r2) {
                !Ff(r2) && !VS(r2.declarationList) && _L(r2), e2.forEach(r2.declarationList.declarations, io);
              }
              function RF(r2) {
                Mf(r2), yn(r2.expression);
              }
              function BF(r2) {
                Mf(r2), Bg(r2.expression), TS(r2.expression, r2.thenStatement), io(r2.thenStatement), r2.thenStatement.kind === 236 && Xr(r2.thenStatement, e2.Diagnostics.The_body_of_an_if_statement_cannot_be_the_empty_statement), io(r2.elseStatement);
              }
              function TS(r2, i2) {
                if (!Ye)
                  return;
                for (t2(r2, i2); e2.isBinaryExpression(r2) && r2.operatorToken.kind === 56; )
                  r2 = r2.left, t2(r2, i2);
                function t2(o, s2) {
                  var u = e2.isBinaryExpression(o) && (o.operatorToken.kind === 56 || o.operatorToken.kind === 55) ? o.right : o;
                  if (!e2.isModuleExportsAccessExpression(u)) {
                    var h2 = Bg(u), z = e2.isPropertyAccessExpression(u) && Vk(u.expression);
                    if (!(ju(h2) || z)) {
                      var me = ot(h2, 0), Me = !!Sv(h2);
                      if (!(me.length === 0 && !Me)) {
                        var $e = e2.isIdentifier(u) ? u : e2.isPropertyAccessExpression(u) ? u.name : e2.isBinaryExpression(u) && e2.isIdentifier(u.right) ? u.right : void 0, tr = $e && el($e);
                        if (!(!tr && !Me)) {
                          var dr = tr && e2.isBinaryExpression(o.parent) && jF(o.parent, tr) || tr && s2 && JF(o, s2, $e, tr);
                          dr || (Me ? zu(u, true, e2.Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined, q_(h2)) : Xr(u, e2.Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead));
                        }
                      }
                    }
                  }
                }
              }
              function JF(r2, i2, t2, o) {
                return !!e2.forEachChild(i2, function s2(u) {
                  if (e2.isIdentifier(u)) {
                    var h2 = el(u);
                    if (h2 && h2 === o) {
                      if (e2.isIdentifier(r2) || e2.isIdentifier(t2) && e2.isBinaryExpression(t2.parent))
                        return true;
                      for (var z = t2.parent, me = u.parent; z && me; ) {
                        if (e2.isIdentifier(z) && e2.isIdentifier(me) || z.kind === 108 && me.kind === 108)
                          return el(z) === el(me);
                        if (e2.isPropertyAccessExpression(z) && e2.isPropertyAccessExpression(me)) {
                          if (el(z.name) !== el(me.name))
                            return false;
                          me = me.expression, z = z.expression;
                        } else if (e2.isCallExpression(z) && e2.isCallExpression(me))
                          me = me.expression, z = z.expression;
                        else
                          return false;
                      }
                    }
                  }
                  return e2.forEachChild(u, s2);
                });
              }
              function jF(r2, i2) {
                for (; e2.isBinaryExpression(r2) && r2.operatorToken.kind === 55; ) {
                  var t2 = e2.forEachChild(r2.right, function o(s2) {
                    if (e2.isIdentifier(s2)) {
                      var u = el(s2);
                      if (u && u === i2)
                        return true;
                    }
                    return e2.forEachChild(s2, o);
                  });
                  if (t2)
                    return true;
                  r2 = r2.parent;
                }
                return false;
              }
              function UF(r2) {
                Mf(r2), io(r2.statement), Bg(r2.expression);
              }
              function zF(r2) {
                Mf(r2), Bg(r2.expression), io(r2.statement);
              }
              function h6(r2, i2) {
                return r2.flags & 16384 && Xr(i2, e2.Diagnostics.An_expression_of_type_void_cannot_be_tested_for_truthiness), r2;
              }
              function Bg(r2, i2) {
                return h6(yn(r2, i2), r2);
              }
              function WF(r2) {
                Mf(r2) || r2.initializer && r2.initializer.kind === 255 && VS(r2.initializer), r2.initializer && (r2.initializer.kind === 255 ? e2.forEach(r2.initializer.declarations, SS) : yn(r2.initializer)), r2.condition && Bg(r2.condition), r2.incrementor && yn(r2.incrementor), io(r2.statement), r2.locals && A_(r2);
              }
              function qF(r2) {
                pA(r2);
                var i2 = e2.getContainingFunctionOrClassStaticBlock(r2);
                if (r2.awaitModifier)
                  if (i2 && e2.isClassStaticBlockDeclaration(i2))
                    Tt(r2.awaitModifier, e2.Diagnostics.For_await_loops_cannot_be_used_inside_a_class_static_block);
                  else {
                    var t2 = e2.getFunctionFlags(i2);
                    (t2 & 6) === 2 && Ae < 99 && fc(r2, 16384);
                  }
                else
                  ye.downlevelIteration && Ae < 2 && fc(r2, 256);
                if (r2.initializer.kind === 255)
                  D6(r2);
                else {
                  var o = r2.initializer, s2 = By(r2);
                  if (o.kind === 204 || o.kind === 205)
                    Rd(o, s2 || Pe);
                  else {
                    var u = yn(o);
                    hv(o, e2.Diagnostics.The_left_hand_side_of_a_for_of_statement_must_be_a_variable_or_a_property_access, e2.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_an_optional_property_access), s2 && op(s2, u, o, r2.expression);
                  }
                }
                io(r2.statement), r2.locals && A_(r2);
              }
              function VF(r2) {
                pA(r2);
                var i2 = jb(yn(r2.expression));
                if (r2.initializer.kind === 255) {
                  var t2 = r2.initializer.declarations[0];
                  t2 && e2.isBindingPattern(t2.name) && Xr(t2.name, e2.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern), D6(r2);
                } else {
                  var o = r2.initializer, s2 = yn(o);
                  o.kind === 204 || o.kind === 205 ? Xr(o, e2.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_be_a_destructuring_pattern) : ao(lI(i2), s2) ? hv(o, e2.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_a_variable_or_a_property_access, e2.Diagnostics.The_left_hand_side_of_a_for_in_statement_may_not_be_an_optional_property_access) : Xr(o, e2.Diagnostics.The_left_hand_side_of_a_for_in_statement_must_be_of_type_string_or_any);
                }
                (i2 === ui || !Ns(i2, 126091264)) && Xr(r2.expression, e2.Diagnostics.The_right_hand_side_of_a_for_in_statement_must_be_of_type_any_an_object_type_or_a_type_parameter_but_here_has_type_0, Ot(i2)), io(r2.statement), r2.locals && A_(r2);
              }
              function D6(r2) {
                var i2 = r2.initializer;
                if (i2.declarations.length >= 1) {
                  var t2 = i2.declarations[0];
                  SS(t2);
                }
              }
              function By(r2) {
                var i2 = r2.awaitModifier ? 15 : 13;
                return N_(i2, gm(r2.expression), Tr, r2.expression);
              }
              function N_(r2, i2, t2, o) {
                return ta(i2) ? i2 : xS(r2, i2, t2, o, true) || Oe;
              }
              function xS(r2, i2, t2, o, s2) {
                var u = (r2 & 2) !== 0;
                if (i2 === ui) {
                  AS(o, i2, u);
                  return;
                }
                var h2 = Ae >= 2, z = !h2 && ye.downlevelIteration, me = ye.noUncheckedIndexedAccess && !!(r2 & 128);
                if (h2 || z || u) {
                  var Me = Jy(i2, r2, h2 ? o : void 0);
                  if (s2 && Me) {
                    var $e = r2 & 8 ? e2.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_for_of_will_always_send_0 : r2 & 32 ? e2.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_spread_will_always_send_0 : r2 & 64 ? e2.Diagnostics.Cannot_iterate_value_because_the_next_method_of_its_iterator_expects_type_1_but_array_destructuring_will_always_send_0 : r2 & 16 ? e2.Diagnostics.Cannot_delegate_iteration_to_value_because_the_next_method_of_its_iterator_expects_type_1_but_the_containing_generator_will_always_send_0 : void 0;
                    $e && zc(t2, Me.nextType, o, $e);
                  }
                  if (Me || h2)
                    return me ? fv(Me && Me.yieldType) : Me && Me.yieldType;
                }
                var tr = i2, dr = false, Dr = false;
                if (r2 & 4) {
                  if (tr.flags & 1048576) {
                    var Qr = i2.types, li = e2.filter(Qr, function(Ra) {
                      return !(Ra.flags & 402653316);
                    });
                    li !== Qr && (tr = Pa(li, 2));
                  } else
                    tr.flags & 402653316 && (tr = ui);
                  if (Dr = tr !== i2, Dr && (Ae < 1 && o && (Xr(o, e2.Diagnostics.Using_a_string_in_a_for_of_statement_is_only_supported_in_ECMAScript_5_and_higher), dr = true), tr.flags & 131072))
                    return me ? fv(Li) : Li;
                }
                if (!sp(tr)) {
                  if (o && !dr) {
                    var Ti = !!(r2 & 4) && !Dr, Ci = Nt(Ti, z), $i = Ci[0], Zi = Ci[1];
                    zu(o, Zi && !!Sv(tr), $i, Ot(tr));
                  }
                  return Dr ? me ? fv(Li) : Li : void 0;
                }
                var qt = cs(tr, nt);
                if (Dr && qt)
                  return qt.flags & 402653316 && !ye.noUncheckedIndexedAccess ? Li : Pa(me ? [qt, Li, Tr] : [qt, Li], 2);
                return r2 & 128 ? fv(qt) : qt;
                function Nt(Ra, ca) {
                  var Sn;
                  if (ca)
                    return Ra ? [e2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true] : [e2.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator, true];
                  var ja = b6(r2, 0, i2, void 0);
                  return ja ? [e2.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, false] : KF((Sn = i2.symbol) === null || Sn === void 0 ? void 0 : Sn.escapedName) ? [e2.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher, true] : Ra ? [e2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type, true] : [e2.Diagnostics.Type_0_is_not_an_array_type, true];
                }
              }
              function KF(r2) {
                switch (r2) {
                  case "Float32Array":
                  case "Float64Array":
                  case "Int16Array":
                  case "Int32Array":
                  case "Int8Array":
                  case "NodeList":
                  case "Uint16Array":
                  case "Uint32Array":
                  case "Uint8Array":
                  case "Uint8ClampedArray":
                    return true;
                }
                return false;
              }
              function b6(r2, i2, t2, o) {
                if (!ta(t2)) {
                  var s2 = Jy(t2, r2, o);
                  return s2 && s2[j(i2)];
                }
              }
              function a_(r2, i2, t2) {
                if (r2 === void 0 && (r2 = ui), i2 === void 0 && (i2 = ui), t2 === void 0 && (t2 = gr), r2.flags & 67359327 && i2.flags & 180227 && t2.flags & 180227) {
                  var o = Su([r2, i2, t2]), s2 = Oo.get(o);
                  return s2 || (s2 = { yieldType: r2, returnType: i2, nextType: t2 }, Oo.set(o, s2)), s2;
                }
                return { yieldType: r2, returnType: i2, nextType: t2 };
              }
              function S6(r2) {
                for (var i2, t2, o, s2 = 0, u = r2; s2 < u.length; s2++) {
                  var h2 = u[s2];
                  if (!(h2 === void 0 || h2 === no)) {
                    if (h2 === $o)
                      return $o;
                    i2 = e2.append(i2, h2.yieldType), t2 = e2.append(t2, h2.returnType), o = e2.append(o, h2.nextType);
                  }
                }
                return i2 || t2 || o ? a_(i2 && Pa(i2), t2 && Pa(t2), o && Do(o)) : no;
              }
              function R0(r2, i2) {
                return r2[i2];
              }
              function mf(r2, i2, t2) {
                return r2[i2] = t2;
              }
              function Jy(r2, i2, t2) {
                if (ta(r2))
                  return $o;
                if (!(r2.flags & 1048576)) {
                  var o = T6(r2, i2, t2);
                  if (o === no) {
                    t2 && AS(t2, r2, !!(i2 & 2));
                    return;
                  }
                  return o;
                }
                var s2 = i2 & 2 ? "iterationTypesOfAsyncIterable" : "iterationTypesOfIterable", u = R0(r2, s2);
                if (u)
                  return u === no ? void 0 : u;
                for (var h2, z = 0, me = r2.types; z < me.length; z++) {
                  var Me = me[z], $e = T6(Me, i2, t2);
                  if ($e === no) {
                    t2 && AS(t2, r2, !!(i2 & 2)), mf(r2, s2, no);
                    return;
                  } else
                    h2 = e2.append(h2, $e);
                }
                var tr = h2 ? S6(h2) : no;
                return mf(r2, s2, tr), tr === no ? void 0 : tr;
              }
              function ES(r2, i2) {
                if (r2 === no)
                  return no;
                if (r2 === $o)
                  return $o;
                var t2 = r2.yieldType, o = r2.returnType, s2 = r2.nextType;
                return i2 && oD(true), a_(ag(t2, i2) || Oe, ag(o, i2) || Oe, s2);
              }
              function T6(r2, i2, t2) {
                if (ta(r2))
                  return $o;
                if (i2 & 2) {
                  var o = CS(r2, St) || E6(r2, St);
                  if (o)
                    return i2 & 8 ? ES(o, t2) : o;
                }
                if (i2 & 1) {
                  var o = CS(r2, pa) || E6(r2, pa);
                  if (o)
                    if (i2 & 2) {
                      if (o !== no)
                        return mf(r2, "iterationTypesOfAsyncIterable", ES(o, t2));
                    } else
                      return o;
                }
                if (i2 & 2) {
                  var o = kS(r2, St, t2);
                  if (o !== no)
                    return o;
                }
                if (i2 & 1) {
                  var o = kS(r2, pa, t2);
                  if (o !== no)
                    return i2 & 2 ? mf(r2, "iterationTypesOfAsyncIterable", o ? ES(o, t2) : no) : o;
                }
                return no;
              }
              function CS(r2, i2) {
                return R0(r2, i2.iterableCacheKey);
              }
              function x6(r2, i2) {
                var t2 = CS(r2, i2) || kS(r2, i2, void 0);
                return t2 === no ? xi : t2;
              }
              function E6(r2, i2) {
                var t2;
                if (Xf(r2, t2 = i2.getGlobalIterableType(false)) || Xf(r2, t2 = i2.getGlobalIterableIteratorType(false))) {
                  var o = xo(r2)[0], s2 = x6(t2, i2), u = s2.returnType, h2 = s2.nextType;
                  return mf(r2, i2.iterableCacheKey, a_(i2.resolveIterationType(o, void 0) || o, i2.resolveIterationType(u, void 0) || u, h2));
                }
                if (Xf(r2, i2.getGlobalGeneratorType(false))) {
                  var z = xo(r2), o = z[0], u = z[1], h2 = z[2];
                  return mf(r2, i2.iterableCacheKey, a_(i2.resolveIterationType(o, void 0) || o, i2.resolveIterationType(u, void 0) || u, h2));
                }
              }
              function GF(r2) {
                var i2 = Ex(false), t2 = i2 && da(Jt(i2), e2.escapeLeadingUnderscores(r2));
                return t2 && _f(t2) ? pf(t2) : "__@".concat(r2);
              }
              function kS(r2, i2, t2) {
                var o, s2 = bi(r2, GF(i2.iteratorSymbolName)), u = s2 && !(s2.flags & 16777216) ? Jt(s2) : void 0;
                if (ta(u))
                  return mf(r2, i2.iterableCacheKey, $o);
                var h2 = u ? ot(u, 0) : void 0;
                if (!e2.some(h2))
                  return mf(r2, i2.iterableCacheKey, no);
                var z = Do(e2.map(h2, yo)), me = (o = C6(z, i2, t2)) !== null && o !== void 0 ? o : no;
                return mf(r2, i2.iterableCacheKey, me);
              }
              function AS(r2, i2, t2) {
                var o = t2 ? e2.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator : e2.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator;
                zu(r2, !!Sv(i2), o, Ot(i2));
              }
              function C6(r2, i2, t2) {
                if (ta(r2))
                  return $o;
                var o = k6(r2, i2) || HF(r2, i2) || N6(r2, i2, t2);
                return o === no ? void 0 : o;
              }
              function k6(r2, i2) {
                return R0(r2, i2.iteratorCacheKey);
              }
              function HF(r2, i2) {
                var t2 = i2.getGlobalIterableIteratorType(false);
                if (Xf(r2, t2)) {
                  var o = xo(r2)[0], s2 = k6(t2, i2) || N6(t2, i2, void 0), u = s2 === no ? xi : s2, h2 = u.returnType, z = u.nextType;
                  return mf(r2, i2.iteratorCacheKey, a_(o, h2, z));
                }
                if (Xf(r2, i2.getGlobalIteratorType(false)) || Xf(r2, i2.getGlobalGeneratorType(false))) {
                  var me = xo(r2), o = me[0], h2 = me[1], z = me[2];
                  return mf(r2, i2.iteratorCacheKey, a_(o, h2, z));
                }
              }
              function A6(r2, i2) {
                var t2 = da(r2, "done") || xt;
                return ao(i2 === 0 ? xt : Dt, t2);
              }
              function XF(r2) {
                return A6(r2, 0);
              }
              function QF(r2) {
                return A6(r2, 1);
              }
              function YF(r2) {
                if (ta(r2))
                  return $o;
                var i2 = R0(r2, "iterationTypesOfIteratorResult");
                if (i2)
                  return i2;
                if (Xf(r2, O3(false))) {
                  var t2 = xo(r2)[0];
                  return mf(r2, "iterationTypesOfIteratorResult", a_(t2, void 0, void 0));
                }
                if (Xf(r2, F3(false))) {
                  var o = xo(r2)[0];
                  return mf(r2, "iterationTypesOfIteratorResult", a_(void 0, o, void 0));
                }
                var s2 = ec(r2, XF), u = s2 !== ui ? da(s2, "value") : void 0, h2 = ec(r2, QF), z = h2 !== ui ? da(h2, "value") : void 0;
                return !u && !z ? mf(r2, "iterationTypesOfIteratorResult", no) : mf(r2, "iterationTypesOfIteratorResult", a_(u, z || Fi, void 0));
              }
              function NS(r2, i2, t2, o) {
                var s2, u, h2, z, me = bi(r2, t2);
                if (!(!me && t2 !== "next")) {
                  var Me = me && !(t2 === "next" && me.flags & 16777216) ? t2 === "next" ? Jt(me) : Ks(Jt(me), 2097152) : void 0;
                  if (ta(Me))
                    return t2 === "next" ? $o : Pr;
                  var $e = Me ? ot(Me, 0) : e2.emptyArray;
                  if ($e.length === 0) {
                    if (o) {
                      var tr = t2 === "next" ? i2.mustHaveANextMethodDiagnostic : i2.mustBeAMethodDiagnostic;
                      Xr(o, tr, t2);
                    }
                    return t2 === "next" ? $o : void 0;
                  }
                  if ((Me == null ? void 0 : Me.symbol) && $e.length === 1) {
                    var dr = i2.getGlobalGeneratorType(false), Dr = i2.getGlobalIteratorType(false), Qr = ((u = (s2 = dr.symbol) === null || s2 === void 0 ? void 0 : s2.members) === null || u === void 0 ? void 0 : u.get(t2)) === Me.symbol, li = !Qr && ((z = (h2 = Dr.symbol) === null || h2 === void 0 ? void 0 : h2.members) === null || z === void 0 ? void 0 : z.get(t2)) === Me.symbol;
                    if (Qr || li) {
                      var Ti = Qr ? dr : Dr, Ci = Me.mapper;
                      return a_(ap(Ti.typeParameters[0], Ci), ap(Ti.typeParameters[1], Ci), t2 === "next" ? ap(Ti.typeParameters[2], Ci) : void 0);
                    }
                  }
                  for (var $i, Zi, qt = 0, Nt = $e; qt < Nt.length; qt++) {
                    var Ra = Nt[qt];
                    t2 !== "throw" && e2.some(Ra.parameters) && ($i = e2.append($i, $u(Ra, 0))), Zi = e2.append(Zi, yo(Ra));
                  }
                  var ca, Sn;
                  if (t2 !== "throw") {
                    var ja = $i ? Pa($i) : gr;
                    if (t2 === "next")
                      Sn = ja;
                    else if (t2 === "return") {
                      var Fn = i2.resolveIterationType(ja, o) || Oe;
                      ca = e2.append(ca, Fn);
                    }
                  }
                  var wn, Tn = Zi ? Do(Zi) : ui, Eo = i2.resolveIterationType(Tn, o) || Oe, lt = YF(Eo);
                  return lt === no ? (o && Xr(o, i2.mustHaveAValueDiagnostic, t2), wn = Oe, ca = e2.append(ca, Oe)) : (wn = lt.yieldType, ca = e2.append(ca, lt.returnType)), a_(wn, Pa(ca), Sn);
                }
              }
              function N6(r2, i2, t2) {
                var o = S6([NS(r2, i2, "next", t2), NS(r2, i2, "return", t2), NS(r2, i2, "throw", t2)]);
                return mf(r2, i2.iteratorCacheKey, o);
              }
              function Jg(r2, i2, t2) {
                if (!ta(i2)) {
                  var o = P6(i2, t2);
                  return o && o[j(r2)];
                }
              }
              function P6(r2, i2) {
                if (ta(r2))
                  return $o;
                var t2 = i2 ? 2 : 1, o = i2 ? St : pa;
                return Jy(r2, t2, void 0) || C6(r2, o, void 0);
              }
              function $F(r2) {
                Mf(r2) || sL(r2);
              }
              function B0(r2, i2) {
                var t2 = !!(i2 & 1), o = !!(i2 & 2);
                return t2 ? Jg(1, r2, o) || Pe : o ? k_(r2) || Pe : r2;
              }
              function I6(r2, i2) {
                var t2 = B0(i2, e2.getFunctionFlags(r2));
                return !!t2 && fs4(t2, 16387);
              }
              function ZF(r2) {
                var i2;
                if (!Mf(r2)) {
                  var t2 = e2.getContainingFunctionOrClassStaticBlock(r2);
                  if (t2 && e2.isClassStaticBlockDeclaration(t2)) {
                    Hs(r2, e2.Diagnostics.A_return_statement_cannot_be_used_inside_a_class_static_block);
                    return;
                  }
                  if (!t2) {
                    Hs(r2, e2.Diagnostics.A_return_statement_can_only_be_used_within_a_function_body);
                    return;
                  }
                  var o = yl(t2), s2 = yo(o), u = e2.getFunctionFlags(t2);
                  if (Ye || r2.expression || s2.flags & 131072) {
                    var h2 = r2.expression ? Os(r2.expression) : Tr;
                    if (t2.kind === 173)
                      r2.expression && Xr(r2, e2.Diagnostics.Setters_cannot_return_a_value);
                    else if (t2.kind === 171)
                      r2.expression && !op(h2, s2, r2, r2.expression) && Xr(r2, e2.Diagnostics.Return_type_of_constructor_signature_must_be_assignable_to_the_instance_type_of_the_class);
                    else if (yg(t2)) {
                      var z = (i2 = B0(s2, u)) !== null && i2 !== void 0 ? i2 : s2, me = u & 2 ? xv(h2, false, r2, e2.Diagnostics.The_return_type_of_an_async_function_must_either_be_a_valid_promise_or_must_not_contain_a_callable_then_member) : h2;
                      z && op(me, z, r2, r2.expression);
                    }
                  } else
                    t2.kind !== 171 && ye.noImplicitReturns && !I6(t2, s2) && Xr(r2, e2.Diagnostics.Not_all_code_paths_return_a_value);
                }
              }
              function eM(r2) {
                Mf(r2) || r2.flags & 32768 && Hs(r2, e2.Diagnostics.with_statements_are_not_allowed_in_an_async_function_block), yn(r2.expression);
                var i2 = e2.getSourceFileOfNode(r2);
                if (!Jd(i2)) {
                  var t2 = e2.getSpanOfTokenAtPosition(i2, r2.pos).start, o = r2.statement.pos;
                  rd(i2, t2, o - t2, e2.Diagnostics.The_with_statement_is_not_supported_All_symbols_in_a_with_block_will_have_type_any);
                }
              }
              function rM(r2) {
                Mf(r2);
                var i2, t2 = false, o = yn(r2.expression), s2 = Cg(o);
                e2.forEach(r2.caseBlock.clauses, function(u) {
                  u.kind === 290 && !t2 && (i2 === void 0 ? i2 = u : (Tt(u, e2.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement), t2 = true)), u.kind === 289 && fe(h2(u)), e2.forEach(u.statements, io), ye.noFallthroughCasesInSwitch && u.fallthroughFlowNode && my(u.fallthroughFlowNode) && Xr(u, e2.Diagnostics.Fallthrough_case_in_switch);
                  function h2(z) {
                    return function() {
                      var me = yn(z.expression), Me = Cg(me), $e = o;
                      (!Me || !s2) && (me = Me ? Kl(me) : me, $e = Kl(o)), fS($e, me) || mE(me, $e, z.expression, void 0);
                    };
                  }
                }), r2.caseBlock.locals && A_(r2.caseBlock);
              }
              function iM(r2) {
                Mf(r2) || e2.findAncestor(r2.parent, function(i2) {
                  return e2.isFunctionLike(i2) ? "quit" : i2.kind === 250 && i2.label.escapedText === r2.label.escapedText ? (Tt(r2.label, e2.Diagnostics.Duplicate_label_0, e2.getTextOfNode(r2.label)), true) : false;
                }), io(r2.statement);
              }
              function tM(r2) {
                Mf(r2) || e2.isIdentifier(r2.expression) && !r2.expression.escapedText && TL(r2, e2.Diagnostics.Line_break_not_permitted_here), r2.expression && yn(r2.expression);
              }
              function aM(r2) {
                Mf(r2), M0(r2.tryBlock);
                var i2 = r2.catchClause;
                if (i2) {
                  if (i2.variableDeclaration) {
                    var t2 = i2.variableDeclaration, o = e2.getEffectiveTypeAnnotationNode(e2.getRootDeclaration(t2));
                    if (o) {
                      var s2 = G_(t2, false, 0);
                      s2 && !(s2.flags & 3) && Hs(o, e2.Diagnostics.Catch_clause_variable_type_annotation_must_be_any_or_unknown_if_specified);
                    } else if (t2.initializer)
                      Hs(t2.initializer, e2.Diagnostics.Catch_clause_variable_cannot_have_an_initializer);
                    else {
                      var u = i2.block.locals;
                      u && e2.forEachKey(i2.locals, function(h2) {
                        var z = u.get(h2);
                        (z == null ? void 0 : z.valueDeclaration) && (z.flags & 2) !== 0 && Tt(z.valueDeclaration, e2.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause, h2);
                      });
                    }
                  }
                  M0(i2.block);
                }
                r2.finallyBlock && M0(r2.finallyBlock);
              }
              function J0(r2, i2, t2) {
                var o = Hn(r2);
                if (o.length !== 0) {
                  for (var s2 = 0, u = Pf(r2); s2 < u.length; s2++) {
                    var h2 = u[s2];
                    t2 && h2.flags & 4194304 || w6(r2, h2, om(h2, 8576, true), ml(h2));
                  }
                  var z = i2.valueDeclaration;
                  if (z && e2.isClassLike(z))
                    for (var me = 0, Me = z.members; me < Me.length; me++) {
                      var $e = Me[me];
                      if (!e2.isStatic($e) && !Td($e)) {
                        var tr = Et($e);
                        w6(r2, tr, Gs($e.name.expression), ml(tr));
                      }
                    }
                  if (o.length > 1)
                    for (var dr = 0, Dr = o; dr < Dr.length; dr++) {
                      var Qr = Dr[dr];
                      nM(r2, Qr);
                    }
                }
              }
              function w6(r2, i2, t2, o) {
                var s2 = i2.valueDeclaration, u = e2.getNameOfDeclaration(s2);
                if (!(u && e2.isPrivateIdentifier(u)))
                  for (var h2 = ws(r2, t2), z = e2.getObjectFlags(r2) & 2 ? e2.getDeclarationOfKind(r2.symbol, 258) : void 0, me = s2 && s2.kind === 221 || u && u.kind === 162 || Ys(i2) === r2.symbol ? s2 : void 0, Me = function(Dr) {
                    var Qr = Dr.declaration && Ys(Et(Dr.declaration)) === r2.symbol ? Dr.declaration : void 0, li = me || Qr || (z && !e2.some(Qc(r2), function(Ti) {
                      return !!h_(Ti, i2.escapedName) && !!cs(Ti, Dr.keyType);
                    }) ? z : void 0);
                    li && !ao(o, Dr.type) && Xr(li, e2.Diagnostics.Property_0_of_type_1_is_not_assignable_to_2_index_type_3, tn(i2), Ot(o), Ot(Dr.keyType), Ot(Dr.type));
                  }, $e = 0, tr = h2; $e < tr.length; $e++) {
                    var dr = tr[$e];
                    Me(dr);
                  }
              }
              function nM(r2, i2) {
                for (var t2 = i2.declaration, o = ws(r2, i2.keyType), s2 = e2.getObjectFlags(r2) & 2 ? e2.getDeclarationOfKind(r2.symbol, 258) : void 0, u = t2 && Ys(Et(t2)) === r2.symbol ? t2 : void 0, h2 = function($e) {
                  if ($e === i2)
                    return "continue";
                  var tr = $e.declaration && Ys(Et($e.declaration)) === r2.symbol ? $e.declaration : void 0, dr = u || tr || (s2 && !e2.some(Qc(r2), function(Dr) {
                    return !!ss(Dr, i2.keyType) && !!cs(Dr, $e.keyType);
                  }) ? s2 : void 0);
                  dr && !ao(i2.type, $e.type) && Xr(dr, e2.Diagnostics._0_index_type_1_is_not_assignable_to_2_index_type_3, Ot(i2.keyType), Ot(i2.type), Ot($e.keyType), Ot($e.type));
                }, z = 0, me = o; z < me.length; z++) {
                  var Me = me[z];
                  h2(Me);
                }
              }
              function Tm(r2, i2) {
                switch (r2.escapedText) {
                  case "any":
                  case "unknown":
                  case "never":
                  case "number":
                  case "bigint":
                  case "boolean":
                  case "string":
                  case "symbol":
                  case "void":
                  case "object":
                    Xr(r2, i2, r2.escapedText);
                }
              }
              function oM(r2) {
                Ae >= 1 && r2.escapedText === "Object" && (er < e2.ModuleKind.ES2015 || e2.getSourceFileOfNode(r2).impliedNodeFormat === e2.ModuleKind.CommonJS) && Xr(r2, e2.Diagnostics.Class_name_cannot_be_Object_when_targeting_ES5_with_module_0, e2.ModuleKind[er]);
              }
              function sM(r2) {
                var i2 = e2.filter(e2.getJSDocTags(r2), e2.isJSDocParameterTag);
                if (!!e2.length(i2)) {
                  var t2 = e2.isInJSFile(r2), o = new e2.Set(), s2 = new e2.Set();
                  e2.forEach(r2.parameters, function(z, me) {
                    var Me = z.name;
                    e2.isIdentifier(Me) && o.add(Me.escapedText), e2.isBindingPattern(Me) && s2.add(me);
                  });
                  var u = Gm(r2);
                  if (u) {
                    var h2 = e2.lastOrUndefined(i2);
                    t2 && h2 && e2.isIdentifier(h2.name) && h2.typeExpression && h2.typeExpression.type && !o.has(h2.name.escapedText) && !Tu(Va(h2.typeExpression.type)) && Xr(h2.name, e2.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name_It_would_match_arguments_if_it_had_an_array_type, e2.idText(h2.name));
                  } else
                    e2.forEach(i2, function(z, me) {
                      var Me = z.name;
                      s2.has(me) || e2.isIdentifier(Me) && o.has(Me.escapedText) || (e2.isQualifiedName(Me) ? t2 && Xr(Me, e2.Diagnostics.Qualified_name_0_is_not_allowed_without_a_leading_param_object_1, e2.entityNameToString(Me), e2.entityNameToString(Me.left)) : Ic(t2, Me, e2.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name, e2.idText(Me)));
                    });
                }
              }
              function jy(r2) {
                var i2 = false;
                if (r2)
                  for (var t2 = 0; t2 < r2.length; t2++) {
                    var o = r2[t2];
                    $k(o), fe(s2(o, t2));
                  }
                function s2(u, h2) {
                  return function() {
                    u.default ? (i2 = true, cM(u.default, r2, h2)) : i2 && Xr(u, e2.Diagnostics.Required_type_parameters_may_not_follow_optional_type_parameters);
                    for (var z = 0; z < h2; z++)
                      r2[z].symbol === u.symbol && Xr(u.name, e2.Diagnostics.Duplicate_identifier_0, e2.declarationNameToString(u.name));
                  };
                }
              }
              function cM(r2, i2, t2) {
                o(r2);
                function o(s2) {
                  if (s2.kind === 178) {
                    var u = ty(s2);
                    if (u.flags & 262144)
                      for (var h2 = t2; h2 < i2.length; h2++)
                        u.symbol === Et(i2[h2]) && Xr(s2, e2.Diagnostics.Type_parameter_defaults_can_only_reference_previously_declared_type_parameters);
                  }
                  e2.forEachChild(s2, o);
                }
              }
              function O6(r2) {
                if (!(r2.declarations && r2.declarations.length === 1)) {
                  var i2 = Aa(r2);
                  if (!i2.typeParametersChecked) {
                    i2.typeParametersChecked = true;
                    var t2 = gM(r2);
                    if (!t2 || t2.length <= 1)
                      return;
                    var o = go(r2);
                    if (!F6(t2, o.localTypeParameters, e2.getEffectiveTypeParameterDeclarations))
                      for (var s2 = tn(r2), u = 0, h2 = t2; u < h2.length; u++) {
                        var z = h2[u];
                        Xr(z.name, e2.Diagnostics.All_declarations_of_0_must_have_identical_type_parameters, s2);
                      }
                  }
                }
              }
              function F6(r2, i2, t2) {
                for (var o = e2.length(i2), s2 = Ul(i2), u = 0, h2 = r2; u < h2.length; u++) {
                  var z = h2[u], me = t2(z), Me = me.length;
                  if (Me < s2 || Me > o)
                    return false;
                  for (var $e = 0; $e < Me; $e++) {
                    var tr = me[$e], dr = i2[$e];
                    if (tr.name.escapedText !== dr.symbol.escapedName)
                      return false;
                    var Dr = e2.getEffectiveConstraintOfTypeParameter(tr), Qr = Dr && Va(Dr), li = Tc(dr);
                    if (Qr && li && !wf(Qr, li))
                      return false;
                    var Ti = tr.default && Va(tr.default), Ci = D_(dr);
                    if (Ti && Ci && !wf(Ti, Ci))
                      return false;
                  }
                }
                return true;
              }
              function uM(r2) {
                return M6(r2), xm(r2), Jt(Et(r2));
              }
              function lM(r2) {
                e2.forEach(r2.members, io), A_(r2);
              }
              function fM(r2) {
                e2.some(r2.decorators) && e2.some(r2.members, function(i2) {
                  return e2.hasStaticModifier(i2) && e2.isPrivateIdentifierClassElementDeclaration(i2);
                }) && Tt(r2.decorators[0], e2.Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator), !r2.name && !e2.hasSyntacticModifier(r2, 512) && Hs(r2, e2.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name), M6(r2), e2.forEach(r2.members, io), A_(r2);
              }
              function M6(r2) {
                K9(r2), Fy(r2), Sm(r2, r2.name), jy(e2.getEffectiveTypeParameterDeclarations(r2)), bv(r2);
                var i2 = Et(r2), t2 = go(i2), o = Rc(t2), s2 = Jt(i2);
                O6(i2), O0(i2), MO(r2);
                var u = !!(r2.flags & 16777216);
                u || LO(r2);
                var h2 = e2.getEffectiveBaseTypeNode(r2);
                if (h2) {
                  e2.forEach(h2.typeArguments, io), Ae < 2 && fc(h2.parent, 1);
                  var z = e2.getClassExtendsHeritageElement(r2);
                  z && z !== h2 && yn(z.expression);
                  var me = Qc(t2);
                  me.length && fe(function() {
                    var Qr = me[0], li = Bl(t2), Ti = $s(li);
                    if (pM(Ti, h2), io(h2.expression), e2.some(h2.typeArguments)) {
                      e2.forEach(h2.typeArguments, io);
                      for (var Ci = 0, $i = Mm(Ti, h2.typeArguments, h2); Ci < $i.length; Ci++) {
                        var Zi = $i[Ci];
                        if (!n6(h2, Zi.typeParameters))
                          break;
                      }
                    }
                    var qt = Rc(Qr, t2.thisType);
                    if (zc(o, qt, void 0) ? zc(s2, _E(Ti), r2.name || r2, e2.Diagnostics.Class_static_side_0_incorrectly_extends_base_class_static_side_1) : B6(r2, o, qt, e2.Diagnostics.Class_0_incorrectly_extends_base_class_1), li.flags & 8650752)
                      if (!Wd(s2))
                        Xr(r2.name || r2, e2.Diagnostics.A_mixin_class_must_have_a_constructor_with_a_single_rest_parameter_of_type_any);
                      else {
                        var Nt = ot(li, 1);
                        Nt.some(function(ca) {
                          return ca.flags & 4;
                        }) && !e2.hasSyntacticModifier(r2, 128) && Xr(r2.name || r2, e2.Diagnostics.A_mixin_class_that_extends_from_a_type_variable_containing_an_abstract_construct_signature_must_also_be_declared_abstract);
                      }
                    if (!(Ti.symbol && Ti.symbol.flags & 32) && !(li.flags & 8650752)) {
                      var Ra = Xg(Ti, h2.typeArguments, h2);
                      e2.forEach(Ra, function(ca) {
                        return !Sl(ca.declaration) && !wf(yo(ca), Qr);
                      }) && Xr(h2.expression, e2.Diagnostics.Base_constructors_must_all_have_the_same_return_type);
                    }
                    mM(t2, Qr);
                  });
                }
                _M(r2, t2, o, s2);
                var Me = e2.getEffectiveImplementsTypeNodes(r2);
                if (Me)
                  for (var $e = 0, tr = Me; $e < tr.length; $e++) {
                    var dr = tr[$e];
                    (!e2.isEntityNameExpression(dr.expression) || e2.isOptionalChain(dr.expression)) && Xr(dr.expression, e2.Diagnostics.A_class_can_only_implement_an_identifier_Slashqualified_name_with_optional_type_arguments), vS(dr), fe(Dr(dr));
                  }
                fe(function() {
                  J0(t2, i2), J0(s2, i2, true), dS(r2), hM(r2);
                });
                function Dr(Qr) {
                  return function() {
                    var li = bu(Va(Qr));
                    if (!nn(li))
                      if (ff(li)) {
                        var Ti = li.symbol && li.symbol.flags & 32 ? e2.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass : e2.Diagnostics.Class_0_incorrectly_implements_interface_1, Ci = Rc(li, t2.thisType);
                        zc(o, Ci, void 0) || B6(r2, o, Ci, Ti);
                      } else
                        Xr(Qr, e2.Diagnostics.A_class_can_only_implement_an_object_type_or_intersection_of_object_types_with_statically_known_members);
                  };
                }
              }
              function _M(r2, i2, t2, o) {
                for (var s2 = e2.getEffectiveBaseTypeNode(r2), u = s2 && Qc(i2), h2 = u != null && u.length ? Rc(e2.first(u), i2.thisType) : void 0, z = Bl(i2), me = function(dr) {
                  if (e2.hasAmbientModifier(dr))
                    return "continue";
                  e2.isConstructorDeclaration(dr) && e2.forEach(dr.parameters, function(Dr) {
                    e2.isParameterPropertyDeclaration(Dr, dr) && L6(r2, o, z, h2, i2, t2, Dr, true);
                  }), L6(r2, o, z, h2, i2, t2, dr, false);
                }, Me = 0, $e = r2.members; Me < $e.length; Me++) {
                  var tr = $e[Me];
                  me(tr);
                }
              }
              function L6(r2, i2, t2, o, s2, u, h2, z, me) {
                me === void 0 && (me = true);
                var Me = h2.name && el(h2.name) || el(h2);
                return Me ? R6(r2, i2, t2, o, s2, u, e2.hasOverrideModifier(h2), e2.hasAbstractModifier(h2), e2.isStatic(h2), z, e2.symbolName(Me), me ? h2 : void 0) : 0;
              }
              function R6(r2, i2, t2, o, s2, u, h2, z, me, Me, $e, tr) {
                var dr = e2.isInJSFile(r2), Dr = !!(r2.flags & 16777216);
                if (o && (h2 || ye.noImplicitOverride)) {
                  var Qr = e2.escapeLeadingUnderscores($e), li = me ? i2 : u, Ti = me ? t2 : o, Ci = bi(li, Qr), $i = bi(Ti, Qr), Zi = Ot(o);
                  if (Ci && !$i && h2) {
                    if (tr) {
                      var qt = ZC($e, Ti);
                      qt ? Xr(tr, dr ? e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1 : e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1, Zi, tn(qt)) : Xr(tr, dr ? e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0 : e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0, Zi);
                    }
                    return 2;
                  } else if (Ci && ($i == null ? void 0 : $i.declarations) && ye.noImplicitOverride && !Dr) {
                    var Nt = e2.some($i.declarations, e2.hasAbstractModifier);
                    if (h2)
                      return 0;
                    if (Nt) {
                      if (z && Nt)
                        return tr && Xr(tr, e2.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0, Zi), 1;
                    } else {
                      if (tr) {
                        var Ra = Me ? dr ? e2.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0 : e2.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0 : dr ? e2.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0 : e2.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0;
                        Xr(tr, Ra, Zi);
                      }
                      return 1;
                    }
                  }
                } else if (h2) {
                  if (tr) {
                    var ca = Ot(s2);
                    Xr(tr, dr ? e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class : e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class, ca);
                  }
                  return 2;
                }
                return 0;
              }
              function B6(r2, i2, t2, o) {
                for (var s2 = false, u = function(Me) {
                  if (e2.isStatic(Me))
                    return "continue";
                  var $e = Me.name && el(Me.name) || el(Me);
                  if ($e) {
                    var tr = bi(i2, $e.escapedName), dr = bi(t2, $e.escapedName);
                    if (tr && dr) {
                      var Dr = function() {
                        return e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2, tn($e), Ot(i2), Ot(t2));
                      };
                      zc(Jt(tr), Jt(dr), Me.name || Me, void 0, Dr) || (s2 = true);
                    }
                  }
                }, h2 = 0, z = r2.members; h2 < z.length; h2++) {
                  var me = z[h2];
                  u(me);
                }
                s2 || zc(i2, t2, r2.name || r2, o);
              }
              function pM(r2, i2) {
                var t2 = ot(r2, 1);
                if (t2.length) {
                  var o = t2[0].declaration;
                  if (o && e2.hasEffectiveModifier(o, 8)) {
                    var s2 = e2.getClassLikeDeclarationOfSymbol(r2.symbol);
                    MS(i2, s2) || Xr(i2, e2.Diagnostics.Cannot_extend_a_class_0_Class_constructor_is_marked_as_private, cl(r2.symbol));
                  }
                }
              }
              function dM(r2, i2) {
                if (!i2.name)
                  return 0;
                var t2 = Et(r2), o = go(t2), s2 = Rc(o), u = Jt(t2), h2 = e2.getEffectiveBaseTypeNode(r2), z = h2 && Qc(o), me = z != null && z.length ? Rc(e2.first(z), o.thisType) : void 0, Me = Bl(o), $e = i2.parent ? e2.hasOverrideModifier(i2) : e2.hasSyntacticModifier(i2, 16384), tr = e2.unescapeLeadingUnderscores(e2.getTextOfPropertyName(i2.name));
                return R6(r2, u, Me, me, o, s2, $e, e2.hasAbstractModifier(i2), e2.isStatic(i2), false, tr);
              }
              function jg(r2) {
                return e2.getCheckFlags(r2) & 1 ? r2.target : r2;
              }
              function gM(r2) {
                return e2.filter(r2.declarations, function(i2) {
                  return i2.kind === 257 || i2.kind === 258;
                });
              }
              function mM(r2, i2) {
                var t2, o, s2 = uo(i2);
                e:
                  for (var u = 0, h2 = s2; u < h2.length; u++) {
                    var z = h2[u], me = jg(z);
                    if (!(me.flags & 4194304)) {
                      var Me = h_(r2, me.escapedName);
                      if (!!Me) {
                        var $e = jg(Me), tr = e2.getDeclarationModifierFlagsFromSymbol(me);
                        if (e2.Debug.assert(!!$e, "derived should point to something, even if it is the base class' declaration."), $e === me) {
                          var dr = e2.getClassLikeDeclarationOfSymbol(r2.symbol);
                          if (tr & 128 && (!dr || !e2.hasSyntacticModifier(dr, 128))) {
                            for (var Dr = 0, Qr = Qc(r2); Dr < Qr.length; Dr++) {
                              var li = Qr[Dr];
                              if (li !== i2) {
                                var Ti = h_(li, me.escapedName), Ci = Ti && jg(Ti);
                                if (Ci && Ci !== me)
                                  continue e;
                              }
                            }
                            dr.kind === 226 ? Xr(dr, e2.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1, tn(z), Ot(i2)) : Xr(dr, e2.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2, Ot(r2), tn(z), Ot(i2));
                          }
                        } else {
                          var $i = e2.getDeclarationModifierFlagsFromSymbol($e);
                          if (tr & 8 || $i & 8)
                            continue;
                          var Zi = void 0, qt = me.flags & 98308, Nt = $e.flags & 98308;
                          if (qt && Nt) {
                            if (tr & 128 && !(me.valueDeclaration && e2.isPropertyDeclaration(me.valueDeclaration) && me.valueDeclaration.initializer) || me.valueDeclaration && me.valueDeclaration.parent.kind === 258 || $e.valueDeclaration && e2.isBinaryExpression($e.valueDeclaration))
                              continue;
                            var Ra = qt !== 4 && Nt === 4, ca = qt === 4 && Nt !== 4;
                            if (Ra || ca) {
                              var Sn = Ra ? e2.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property : e2.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor;
                              Xr(e2.getNameOfDeclaration($e.valueDeclaration) || $e.valueDeclaration, Sn, tn(me), Ot(i2), Ot(r2));
                            } else if (ir) {
                              var ja = (t2 = $e.declarations) === null || t2 === void 0 ? void 0 : t2.find(function(Eo) {
                                return Eo.kind === 167 && !Eo.initializer;
                              });
                              if (ja && !($e.flags & 33554432) && !(tr & 128) && !($i & 128) && !(!((o = $e.declarations) === null || o === void 0) && o.some(function(Eo) {
                                return !!(Eo.flags & 16777216);
                              }))) {
                                var Fn = Tf(e2.getClassLikeDeclarationOfSymbol(r2.symbol)), wn = ja.name;
                                if (ja.exclamationToken || !Fn || !e2.isIdentifier(wn) || !Ye || !j6(wn, r2, Fn)) {
                                  var Tn = e2.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration;
                                  Xr(e2.getNameOfDeclaration($e.valueDeclaration) || $e.valueDeclaration, Tn, tn(me), Ot(i2));
                                }
                              }
                            }
                            continue;
                          } else if (Bb(me)) {
                            if (Bb($e) || $e.flags & 4)
                              continue;
                            e2.Debug.assert(!!($e.flags & 98304)), Zi = e2.Diagnostics.Class_0_defines_instance_member_function_1_but_extended_class_2_defines_it_as_instance_member_accessor;
                          } else
                            me.flags & 98304 ? Zi = e2.Diagnostics.Class_0_defines_instance_member_accessor_1_but_extended_class_2_defines_it_as_instance_member_function : Zi = e2.Diagnostics.Class_0_defines_instance_member_property_1_but_extended_class_2_defines_it_as_instance_member_function;
                          Xr(e2.getNameOfDeclaration($e.valueDeclaration) || $e.valueDeclaration, Zi, Ot(i2), tn(me), Ot(r2));
                        }
                      }
                    }
                  }
              }
              function vM(r2, i2, t2) {
                if (!e2.length(i2))
                  return t2;
                var o = new e2.Map();
                e2.forEach(t2, function(dr) {
                  o.set(dr.escapedName, dr);
                });
                for (var s2 = 0, u = i2; s2 < u.length; s2++)
                  for (var h2 = u[s2], z = uo(Rc(h2, r2.thisType)), me = 0, Me = z; me < Me.length; me++) {
                    var $e = Me[me], tr = o.get($e.escapedName);
                    tr && $e.parent === tr.parent && o.delete($e.escapedName);
                  }
                return e2.arrayFrom(o.values());
              }
              function yM(r2, i2) {
                var t2 = Qc(r2);
                if (t2.length < 2)
                  return true;
                var o = new e2.Map();
                e2.forEach(Lv(r2).declaredProperties, function(Ci) {
                  o.set(Ci.escapedName, { prop: Ci, containingType: r2 });
                });
                for (var s2 = true, u = 0, h2 = t2; u < h2.length; u++)
                  for (var z = h2[u], me = uo(Rc(z, r2.thisType)), Me = 0, $e = me; Me < $e.length; Me++) {
                    var tr = $e[Me], dr = o.get(tr.escapedName);
                    if (!dr)
                      o.set(tr.escapedName, { prop: tr, containingType: z });
                    else {
                      var Dr = dr.containingType !== r2;
                      if (Dr && !yw(dr.prop, tr)) {
                        s2 = false;
                        var Qr = Ot(dr.containingType), li = Ot(z), Ti = e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Named_property_0_of_types_1_and_2_are_not_identical, tn(tr), Qr, li);
                        Ti = e2.chainDiagnosticMessages(Ti, e2.Diagnostics.Interface_0_cannot_simultaneously_extend_types_1_and_2, Ot(r2), Qr, li), rn.add(e2.createDiagnosticForNodeFromMessageChain(i2, Ti));
                      }
                    }
                  }
                return s2;
              }
              function hM(r2) {
                if (!(!Ye || !Ne || r2.flags & 16777216))
                  for (var i2 = Tf(r2), t2 = 0, o = r2.members; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (!(e2.getEffectiveModifierFlags(s2) & 2) && !e2.isStatic(s2) && J6(s2)) {
                      var u = s2.name;
                      if (e2.isIdentifier(u) || e2.isPrivateIdentifier(u) || e2.isComputedPropertyName(u)) {
                        var h2 = Jt(Et(s2));
                        h2.flags & 3 || ju(h2) & 32768 || (!i2 || !j6(u, h2, i2)) && Xr(s2.name, e2.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor, e2.declarationNameToString(u));
                      }
                    }
                  }
              }
              function J6(r2) {
                return r2.kind === 167 && !e2.hasAbstractModifier(r2) && !r2.exclamationToken && !r2.initializer;
              }
              function DM(r2, i2, t2, o, s2) {
                for (var u = 0, h2 = t2; u < h2.length; u++) {
                  var z = h2[u];
                  if (z.pos >= o && z.pos <= s2) {
                    var me = e2.factory.createPropertyAccessExpression(e2.factory.createThis(), r2);
                    e2.setParent(me.expression, me), e2.setParent(me, z), me.flowNode = z.returnFlowNode;
                    var Me = up(me, i2, i_(i2));
                    if (!(ju(Me) & 32768))
                      return true;
                  }
                }
                return false;
              }
              function j6(r2, i2, t2) {
                var o = e2.isComputedPropertyName(r2) ? e2.factory.createElementAccessExpression(e2.factory.createThis(), r2.expression) : e2.factory.createPropertyAccessExpression(e2.factory.createThis(), r2);
                e2.setParent(o.expression, o), e2.setParent(o, t2), o.flowNode = t2.returnFlowNode;
                var s2 = up(o, i2, i_(i2));
                return !(ju(s2) & 32768);
              }
              function bM(r2) {
                Ff(r2) || Z9(r2), jy(r2.typeParameters), fe(function() {
                  Tm(r2.name, e2.Diagnostics.Interface_name_cannot_be_0), bv(r2);
                  var i2 = Et(r2);
                  O6(i2);
                  var t2 = e2.getDeclarationOfKind(i2, 258);
                  if (r2 === t2) {
                    var o = go(i2), s2 = Rc(o);
                    if (yM(o, r2.name)) {
                      for (var u = 0, h2 = Qc(o); u < h2.length; u++) {
                        var z = h2[u];
                        zc(s2, Rc(z, o.thisType), r2.name, e2.Diagnostics.Interface_0_incorrectly_extends_interface_1);
                      }
                      J0(o, i2);
                    }
                  }
                  r6(r2);
                }), e2.forEach(e2.getInterfaceBaseTypeNodes(r2), function(i2) {
                  (!e2.isEntityNameExpression(i2.expression) || e2.isOptionalChain(i2.expression)) && Xr(i2.expression, e2.Diagnostics.An_interface_can_only_extend_an_identifier_Slashqualified_name_with_optional_type_arguments), vS(i2);
                }), e2.forEach(r2.members, io), fe(function() {
                  dS(r2), A_(r2);
                });
              }
              function SM(r2) {
                Ff(r2), Tm(r2.name, e2.Diagnostics.Type_alias_name_cannot_be_0), bv(r2), jy(r2.typeParameters), r2.type.kind === 138 ? (!x2.has(r2.name.escapedText) || e2.length(r2.typeParameters) !== 1) && Xr(r2.type, e2.Diagnostics.The_intrinsic_keyword_can_only_be_used_to_declare_compiler_provided_intrinsic_types) : (io(r2.type), A_(r2));
              }
              function U6(r2) {
                var i2 = va(r2);
                if (!(i2.flags & 16384)) {
                  i2.flags |= 16384;
                  for (var t2 = 0, o = 0, s2 = r2.members; o < s2.length; o++) {
                    var u = s2[o], h2 = TM(u, t2);
                    va(u).enumMemberValue = h2, t2 = typeof h2 == "number" ? h2 + 1 : void 0;
                  }
                }
              }
              function TM(r2, i2) {
                if (e2.isComputedNonLiteralName(r2.name))
                  Xr(r2.name, e2.Diagnostics.Computed_property_names_are_not_allowed_in_enums);
                else {
                  var t2 = e2.getTextOfPropertyName(r2.name);
                  e2.isNumericLiteralName(t2) && !e2.isInfinityOrNaNString(t2) && Xr(r2.name, e2.Diagnostics.An_enum_member_cannot_have_a_numeric_name);
                }
                if (r2.initializer)
                  return xM(r2);
                if (!(r2.parent.flags & 16777216 && !e2.isEnumConst(r2.parent) && as(Et(r2.parent)) === 0)) {
                  if (i2 !== void 0)
                    return i2;
                  Xr(r2.name, e2.Diagnostics.Enum_member_must_have_initializer);
                }
              }
              function xM(r2) {
                var i2 = as(Et(r2.parent)), t2 = e2.isEnumConst(r2.parent), o = r2.initializer, s2 = i2 === 1 && !ro(r2) ? void 0 : h2(o);
                if (s2 !== void 0)
                  t2 && typeof s2 == "number" && !isFinite(s2) && Xr(o, isNaN(s2) ? e2.Diagnostics.const_enum_member_initializer_was_evaluated_to_disallowed_value_NaN : e2.Diagnostics.const_enum_member_initializer_was_evaluated_to_a_non_finite_value);
                else {
                  if (i2 === 1)
                    return Xr(o, e2.Diagnostics.Computed_values_are_not_permitted_in_an_enum_with_string_valued_members), 0;
                  if (t2)
                    Xr(o, e2.Diagnostics.const_enum_member_initializers_can_only_contain_literal_values_and_other_computed_enum_values);
                  else if (r2.parent.flags & 16777216)
                    Xr(o, e2.Diagnostics.In_ambient_enum_declarations_member_initializer_must_be_constant_expression);
                  else {
                    var u = yn(o);
                    Ns(u, 296) ? zc(u, go(Et(r2.parent)), o, void 0) : Xr(o, e2.Diagnostics.Only_numeric_enums_can_have_computed_members_but_this_expression_has_type_0_If_you_do_not_need_exhaustiveness_checks_consider_using_an_object_literal_instead, Ot(u));
                  }
                }
                return s2;
                function h2(me) {
                  switch (me.kind) {
                    case 219:
                      var Me = h2(me.operand);
                      if (typeof Me == "number")
                        switch (me.operator) {
                          case 39:
                            return Me;
                          case 40:
                            return -Me;
                          case 54:
                            return ~Me;
                        }
                      break;
                    case 221:
                      var $e = h2(me.left), tr = h2(me.right);
                      if (typeof $e == "number" && typeof tr == "number")
                        switch (me.operatorToken.kind) {
                          case 51:
                            return $e | tr;
                          case 50:
                            return $e & tr;
                          case 48:
                            return $e >> tr;
                          case 49:
                            return $e >>> tr;
                          case 47:
                            return $e << tr;
                          case 52:
                            return $e ^ tr;
                          case 41:
                            return $e * tr;
                          case 43:
                            return $e / tr;
                          case 39:
                            return $e + tr;
                          case 40:
                            return $e - tr;
                          case 44:
                            return $e % tr;
                          case 42:
                            return Math.pow($e, tr);
                        }
                      else if (typeof $e == "string" && typeof tr == "string" && me.operatorToken.kind === 39)
                        return $e + tr;
                      break;
                    case 10:
                    case 14:
                      return me.text;
                    case 8:
                      return KS(me), +me.text;
                    case 212:
                      return h2(me.expression);
                    case 79:
                      var dr = me;
                      return e2.isInfinityOrNaNString(dr.escapedText) ? +dr.escapedText : e2.nodeIsMissing(me) ? 0 : z(me, Et(r2.parent), dr.escapedText);
                    case 207:
                    case 206:
                      if (PS(me)) {
                        var Dr = Gs(me.expression);
                        if (Dr.symbol && Dr.symbol.flags & 384) {
                          var Qr = void 0;
                          return me.kind === 206 ? Qr = me.name.escapedText : Qr = e2.escapeLeadingUnderscores(e2.cast(me.argumentExpression, e2.isLiteralExpression).text), z(me, Dr.symbol, Qr);
                        }
                      }
                      break;
                  }
                }
                function z(me, Me, $e) {
                  var tr = Me.exports.get($e);
                  if (tr) {
                    var dr = tr.valueDeclaration;
                    if (dr !== r2)
                      return dr && ns(dr, r2) && e2.isEnumDeclaration(dr.parent) ? H0(dr) : (Xr(me, e2.Diagnostics.A_member_initializer_in_a_enum_declaration_cannot_reference_members_declared_after_it_including_members_defined_in_other_enums), 0);
                    Xr(me, e2.Diagnostics.Property_0_is_used_before_being_assigned, tn(tr));
                  }
                }
              }
              function PS(r2) {
                var i2 = Gs(r2);
                return i2 === Pe ? false : r2.kind === 79 || r2.kind === 206 && PS(r2.expression) || r2.kind === 207 && PS(r2.expression) && e2.isStringLiteralLike(r2.argumentExpression);
              }
              function EM(r2) {
                fe(function() {
                  return CM(r2);
                });
              }
              function CM(r2) {
                Ff(r2), Sm(r2, r2.name), bv(r2), r2.members.forEach(kM), U6(r2);
                var i2 = Et(r2), t2 = e2.getDeclarationOfKind(i2, r2.kind);
                if (r2 === t2) {
                  if (i2.declarations && i2.declarations.length > 1) {
                    var o = e2.isEnumConst(r2);
                    e2.forEach(i2.declarations, function(u) {
                      e2.isEnumDeclaration(u) && e2.isEnumConst(u) !== o && Xr(e2.getNameOfDeclaration(u), e2.Diagnostics.Enum_declarations_must_all_be_const_or_non_const);
                    });
                  }
                  var s2 = false;
                  e2.forEach(i2.declarations, function(u) {
                    if (u.kind !== 260)
                      return false;
                    var h2 = u;
                    if (!h2.members.length)
                      return false;
                    var z = h2.members[0];
                    z.initializer || (s2 ? Xr(z.name, e2.Diagnostics.In_an_enum_with_multiple_declarations_only_one_declaration_can_omit_an_initializer_for_its_first_enum_element) : s2 = true);
                  });
                }
              }
              function kM(r2) {
                e2.isPrivateIdentifier(r2.name) && Xr(r2, e2.Diagnostics.An_enum_member_cannot_be_named_with_a_private_identifier);
              }
              function AM(r2) {
                var i2 = r2.declarations;
                if (i2)
                  for (var t2 = 0, o = i2; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if ((s2.kind === 257 || s2.kind === 256 && e2.nodeIsPresent(s2.body)) && !(s2.flags & 16777216))
                      return s2;
                  }
              }
              function NM(r2, i2) {
                var t2 = e2.getEnclosingBlockScopeContainer(r2), o = e2.getEnclosingBlockScopeContainer(i2);
                return Cu(t2) ? Cu(o) : Cu(o) ? false : t2 === o;
              }
              function PM(r2) {
                r2.body && (io(r2.body), e2.isGlobalScopeAugmentation(r2) || A_(r2)), fe(i2);
                function i2() {
                  var t2 = e2.isGlobalScopeAugmentation(r2), o = r2.flags & 16777216;
                  t2 && !o && Xr(r2.name, e2.Diagnostics.Augmentations_for_the_global_scope_should_have_declare_modifier_unless_they_appear_in_already_ambient_context);
                  var s2 = e2.isAmbientModule(r2), u = s2 ? e2.Diagnostics.An_ambient_module_declaration_is_only_allowed_at_the_top_level_in_a_file : e2.Diagnostics.A_namespace_declaration_is_only_allowed_at_the_top_level_of_a_namespace_or_module;
                  if (!Uy(r2, u)) {
                    Ff(r2) || !o && r2.name.kind === 10 && Tt(r2.name, e2.Diagnostics.Only_ambient_modules_can_use_quoted_names), e2.isIdentifier(r2.name) && Sm(r2, r2.name), bv(r2);
                    var h2 = Et(r2);
                    if (h2.flags & 512 && !o && h2.declarations && h2.declarations.length > 1 && V(r2, e2.shouldPreserveConstEnums(ye))) {
                      var z = AM(h2);
                      z && (e2.getSourceFileOfNode(r2) !== e2.getSourceFileOfNode(z) ? Xr(r2.name, e2.Diagnostics.A_namespace_declaration_cannot_be_in_a_different_file_from_a_class_or_function_with_which_it_is_merged) : r2.pos < z.pos && Xr(r2.name, e2.Diagnostics.A_namespace_declaration_cannot_be_located_prior_to_a_class_or_function_with_which_it_is_merged));
                      var me = e2.getDeclarationOfKind(h2, 257);
                      me && NM(r2, me) && (va(r2).flags |= 32768);
                    }
                    if (s2)
                      if (e2.isExternalModuleAugmentation(r2)) {
                        var Me = t2 || Et(r2).flags & 33554432;
                        if (Me && r2.body)
                          for (var $e = 0, tr = r2.body.statements; $e < tr.length; $e++) {
                            var dr = tr[$e];
                            IS(dr, t2);
                          }
                      } else
                        Cu(r2.parent) ? t2 ? Xr(r2.name, e2.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations) : e2.isExternalModuleNameRelative(e2.getTextOfIdentifierOrLiteral(r2.name)) && Xr(r2.name, e2.Diagnostics.Ambient_module_declaration_cannot_specify_relative_module_name) : t2 ? Xr(r2.name, e2.Diagnostics.Augmentations_for_the_global_scope_can_only_be_directly_nested_in_external_modules_or_ambient_module_declarations) : Xr(r2.name, e2.Diagnostics.Ambient_modules_cannot_be_nested_in_other_modules_or_namespaces);
                  }
                }
              }
              function IS(r2, i2) {
                var t2;
                switch (r2.kind) {
                  case 237:
                    for (var o = 0, s2 = r2.declarationList.declarations; o < s2.length; o++) {
                      var u = s2[o];
                      IS(u, i2);
                    }
                    break;
                  case 271:
                  case 272:
                    Hs(r2, e2.Diagnostics.Exports_and_export_assignments_are_not_permitted_in_module_augmentations);
                    break;
                  case 265:
                  case 266:
                    Hs(r2, e2.Diagnostics.Imports_are_not_permitted_in_module_augmentations_Consider_moving_them_to_the_enclosing_external_module);
                    break;
                  case 203:
                  case 254:
                    var h2 = r2.name;
                    if (e2.isBindingPattern(h2)) {
                      for (var z = 0, me = h2.elements; z < me.length; z++) {
                        var Me = me[z];
                        IS(Me, i2);
                      }
                      break;
                    }
                  case 257:
                  case 260:
                  case 256:
                  case 258:
                  case 261:
                  case 259:
                    if (i2)
                      return;
                    var $e = Et(r2);
                    if ($e) {
                      var tr = !($e.flags & 33554432);
                      tr || (tr = !!(!((t2 = $e.parent) === null || t2 === void 0) && t2.declarations) && e2.isExternalModuleAugmentation($e.parent.declarations[0]));
                    }
                    break;
                }
              }
              function IM(r2) {
                switch (r2.kind) {
                  case 79:
                    return r2;
                  case 161:
                    do
                      r2 = r2.left;
                    while (r2.kind !== 79);
                    return r2;
                  case 206:
                    do {
                      if (e2.isModuleExportsAccessExpression(r2.expression) && !e2.isPrivateIdentifier(r2.name))
                        return r2.name;
                      r2 = r2.expression;
                    } while (r2.kind !== 79);
                    return r2;
                }
              }
              function wS(r2) {
                var i2 = e2.getExternalModuleName(r2);
                if (!i2 || e2.nodeIsMissing(i2))
                  return false;
                if (!e2.isStringLiteral(i2))
                  return Xr(i2, e2.Diagnostics.String_literal_expected), false;
                var t2 = r2.parent.kind === 262 && e2.isAmbientModule(r2.parent.parent);
                if (r2.parent.kind !== 305 && !t2)
                  return Xr(i2, r2.kind === 272 ? e2.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace : e2.Diagnostics.Import_declarations_in_a_namespace_cannot_reference_a_module), false;
                if (t2 && e2.isExternalModuleNameRelative(i2.text) && !Xu(r2))
                  return Xr(r2, e2.Diagnostics.Import_or_export_declaration_in_an_ambient_module_declaration_cannot_reference_module_through_relative_module_name), false;
                if (!e2.isImportEqualsDeclaration(r2) && r2.assertClause) {
                  for (var o = false, s2 = 0, u = r2.assertClause.elements; s2 < u.length; s2++) {
                    var h2 = u[s2];
                    e2.isStringLiteral(h2.value) || (o = true, Xr(h2.value, e2.Diagnostics.Import_assertion_values_must_be_string_literal_expressions));
                  }
                  return !o;
                }
                return true;
              }
              function j0(r2) {
                var i2 = Et(r2), t2 = Ps(i2);
                if (t2 !== xe) {
                  i2 = so(i2.exportSymbol || i2);
                  var o = (i2.flags & 1160127 ? 111551 : 0) | (i2.flags & 788968 ? 788968 : 0) | (i2.flags & 1920 ? 1920 : 0);
                  if (t2.flags & o) {
                    var s2 = r2.kind === 275 ? e2.Diagnostics.Export_declaration_conflicts_with_exported_declaration_of_0 : e2.Diagnostics.Import_declaration_conflicts_with_local_declaration_of_0;
                    Xr(r2, s2, tn(i2));
                  }
                  if (ye.isolatedModules && !e2.isTypeOnlyImportOrExportDeclaration(r2) && !(r2.flags & 16777216)) {
                    var u = vu(i2), h2 = !(t2.flags & 111551);
                    if (h2 || u)
                      switch (r2.kind) {
                        case 267:
                        case 270:
                        case 265: {
                          if (ye.preserveValueImports) {
                            e2.Debug.assertIsDefined(r2.name, "An ImportClause with a symbol should have a name");
                            var s2 = h2 ? e2.Diagnostics._0_is_a_type_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled : e2.Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_imported_using_a_type_only_import_when_preserveValueImports_and_isolatedModules_are_both_enabled, z = e2.idText(r2.kind === 270 && r2.propertyName || r2.name);
                            Jf(Xr(r2, s2, z), h2 ? void 0 : u, z);
                          }
                          h2 && r2.kind === 265 && e2.hasEffectiveModifier(r2, 1) && Xr(r2, e2.Diagnostics.Cannot_use_export_import_on_a_type_or_type_only_namespace_when_the_isolatedModules_flag_is_provided);
                          break;
                        }
                        case 275:
                          if (e2.getSourceFileOfNode(u) !== e2.getSourceFileOfNode(r2)) {
                            var s2 = h2 ? e2.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type : e2.Diagnostics._0_resolves_to_a_type_only_declaration_and_must_be_re_exported_using_a_type_only_re_export_when_isolatedModules_is_enabled, z = e2.idText(r2.propertyName || r2.name);
                            Jf(Xr(r2, s2, z), h2 ? void 0 : u, z);
                            return;
                          }
                      }
                  }
                  if (e2.isImportSpecifier(r2)) {
                    var me = W6(i2, r2);
                    z6(me) && me.declarations && El(r2, me.declarations, me.escapedName);
                  }
                }
              }
              function z6(r2) {
                return !!r2.declarations && e2.every(r2.declarations, function(i2) {
                  return !!(e2.getCombinedNodeFlags(i2) & 268435456);
                });
              }
              function W6(r2, i2) {
                if (!(r2.flags & 2097152))
                  return r2;
                var t2 = Ps(r2);
                if (t2 === xe)
                  return t2;
                for (; r2.flags & 2097152; ) {
                  var o = wb(r2);
                  if (o) {
                    if (o === t2)
                      break;
                    if (o.declarations && e2.length(o.declarations))
                      if (z6(o)) {
                        El(i2, o.declarations, o.escapedName);
                        break;
                      } else {
                        if (r2 === t2)
                          break;
                        r2 = o;
                      }
                  } else
                    break;
                }
                return t2;
              }
              function U0(r2) {
                Sm(r2, r2.name), j0(r2), r2.kind === 270 && e2.idText(r2.propertyName || r2.name) === "default" && e2.getESModuleInterop(ye) && er !== e2.ModuleKind.System && (er < e2.ModuleKind.ES2015 || e2.getSourceFileOfNode(r2).impliedNodeFormat === e2.ModuleKind.CommonJS) && fc(r2, 131072);
              }
              function q6(r2) {
                var i2;
                if (r2.assertClause) {
                  var t2 = e2.isExclusivelyTypeOnlyImportOrExport(r2), o = e2.getResolutionModeOverrideForClause(r2.assertClause, t2 ? Tt : void 0);
                  if (t2 && o)
                    return e2.isNightly() || Tt(r2.assertClause, e2.Diagnostics.Resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next), e2.getEmitModuleResolutionKind(ye) !== e2.ModuleResolutionKind.Node16 && e2.getEmitModuleResolutionKind(ye) !== e2.ModuleResolutionKind.NodeNext ? Tt(r2.assertClause, e2.Diagnostics.Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext) : void 0;
                  var s2 = er === e2.ModuleKind.NodeNext && r2.moduleSpecifier && hf(r2.moduleSpecifier);
                  if (s2 !== e2.ModuleKind.ESNext && er !== e2.ModuleKind.ESNext)
                    return Tt(r2.assertClause, er === e2.ModuleKind.NodeNext ? e2.Diagnostics.Import_assertions_are_not_allowed_on_statements_that_transpile_to_commonjs_require_calls : e2.Diagnostics.Import_assertions_are_only_supported_when_the_module_option_is_set_to_esnext_or_nodenext);
                  if (e2.isImportDeclaration(r2) ? (i2 = r2.importClause) === null || i2 === void 0 ? void 0 : i2.isTypeOnly : r2.isTypeOnly)
                    return Tt(r2.assertClause, e2.Diagnostics.Import_assertions_cannot_be_used_with_type_only_imports_or_exports);
                  if (o)
                    return Tt(r2.assertClause, e2.Diagnostics.resolution_mode_can_only_be_set_for_type_only_imports);
                }
              }
              function wM(r2) {
                if (!Uy(r2, e2.isInJSFile(r2) ? e2.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module : e2.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
                  if (!Ff(r2) && e2.hasEffectiveModifiers(r2) && Hs(r2, e2.Diagnostics.An_import_declaration_cannot_have_modifiers), wS(r2)) {
                    var i2 = r2.importClause;
                    if (i2 && !EL(i2) && (i2.name && U0(i2), i2.namedBindings))
                      if (i2.namedBindings.kind === 268)
                        U0(i2.namedBindings), er !== e2.ModuleKind.System && (er < e2.ModuleKind.ES2015 || e2.getSourceFileOfNode(r2).impliedNodeFormat === e2.ModuleKind.CommonJS) && e2.getESModuleInterop(ye) && fc(r2, 65536);
                      else {
                        var t2 = ac(r2, r2.moduleSpecifier);
                        t2 && e2.forEach(i2.namedBindings.elements, U0);
                      }
                  }
                  q6(r2);
                }
              }
              function OM(r2) {
                if (!Uy(r2, e2.isInJSFile(r2) ? e2.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module : e2.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module) && (Ff(r2), e2.isInternalModuleImportEqualsDeclaration(r2) || wS(r2)))
                  if (U0(r2), e2.hasSyntacticModifier(r2, 1) && Gt(r2), r2.moduleReference.kind !== 277) {
                    var i2 = Ps(Et(r2));
                    if (i2 !== xe) {
                      if (i2.flags & 111551) {
                        var t2 = e2.getFirstIdentifier(r2.moduleReference);
                        Ds(t2, 112575).flags & 1920 || Xr(t2, e2.Diagnostics.Module_0_is_hidden_by_a_local_declaration_with_the_same_name, e2.declarationNameToString(t2));
                      }
                      i2.flags & 788968 && Tm(r2.name, e2.Diagnostics.Import_name_cannot_be_0);
                    }
                    r2.isTypeOnly && Tt(r2, e2.Diagnostics.An_import_alias_cannot_use_import_type);
                  } else
                    er >= e2.ModuleKind.ES2015 && e2.getSourceFileOfNode(r2).impliedNodeFormat === void 0 && !r2.isTypeOnly && !(r2.flags & 16777216) && Tt(r2, e2.Diagnostics.Import_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_import_Asterisk_as_ns_from_mod_import_a_from_mod_import_d_from_mod_or_another_module_format_instead);
              }
              function FM(r2) {
                if (!Uy(r2, e2.isInJSFile(r2) ? e2.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module : e2.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_namespace_or_module)) {
                  if (!Ff(r2) && e2.hasSyntacticModifiers(r2) && Hs(r2, e2.Diagnostics.An_export_declaration_cannot_have_modifiers), r2.moduleSpecifier && r2.exportClause && e2.isNamedExports(r2.exportClause) && e2.length(r2.exportClause.elements) && Ae === 0 && fc(r2, 4194304), MM(r2), !r2.moduleSpecifier || wS(r2))
                    if (r2.exportClause && !e2.isNamespaceExport(r2.exportClause)) {
                      e2.forEach(r2.exportClause.elements, UM);
                      var i2 = r2.parent.kind === 262 && e2.isAmbientModule(r2.parent.parent), t2 = !i2 && r2.parent.kind === 262 && !r2.moduleSpecifier && r2.flags & 16777216;
                      r2.parent.kind !== 305 && !i2 && !t2 && Xr(r2, e2.Diagnostics.Export_declarations_are_not_permitted_in_a_namespace);
                    } else {
                      var o = ac(r2, r2.moduleSpecifier);
                      o && ll(o) ? Xr(r2.moduleSpecifier, e2.Diagnostics.Module_0_uses_export_and_cannot_be_used_with_export_Asterisk, tn(o)) : r2.exportClause && j0(r2.exportClause), er !== e2.ModuleKind.System && (er < e2.ModuleKind.ES2015 || e2.getSourceFileOfNode(r2).impliedNodeFormat === e2.ModuleKind.CommonJS) && (r2.exportClause ? e2.getESModuleInterop(ye) && fc(r2, 65536) : fc(r2, 32768));
                    }
                  q6(r2);
                }
              }
              function MM(r2) {
                var i2;
                return r2.isTypeOnly ? ((i2 = r2.exportClause) === null || i2 === void 0 ? void 0 : i2.kind) === 273 ? DA(r2.exportClause) : Tt(r2, e2.Diagnostics.Only_named_exports_may_use_export_type) : false;
              }
              function Uy(r2, i2) {
                var t2 = r2.parent.kind === 305 || r2.parent.kind === 262 || r2.parent.kind === 261;
                return t2 || Hs(r2, i2), !t2;
              }
              function LM(r2) {
                return e2.forEachImportClauseDeclaration(r2, function(i2) {
                  return !!Et(i2).isReferenced;
                });
              }
              function RM(r2) {
                return e2.forEachImportClauseDeclaration(r2, function(i2) {
                  return !!Aa(Et(i2)).constEnumReferenced;
                });
              }
              function BM(r2) {
                return e2.isImportDeclaration(r2) && r2.importClause && !r2.importClause.isTypeOnly && LM(r2.importClause) && !G0(r2.importClause, true) && !RM(r2.importClause);
              }
              function JM(r2) {
                return e2.isImportEqualsDeclaration(r2) && e2.isExternalModuleReference(r2.moduleReference) && !r2.isTypeOnly && Et(r2).isReferenced && !G0(r2, false) && !Aa(Et(r2)).constEnumReferenced;
              }
              function jM(r2) {
                for (var i2 = 0, t2 = r2.statements; i2 < t2.length; i2++) {
                  var o = t2[i2];
                  (BM(o) || JM(o)) && Xr(o, e2.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error);
                }
              }
              function UM(r2) {
                if (j0(r2), e2.getEmitDeclarations(ye) && V_(r2.propertyName || r2.name, true), r2.parent.parent.moduleSpecifier)
                  e2.getESModuleInterop(ye) && er !== e2.ModuleKind.System && (er < e2.ModuleKind.ES2015 || e2.getSourceFileOfNode(r2).impliedNodeFormat === e2.ModuleKind.CommonJS) && e2.idText(r2.propertyName || r2.name) === "default" && fc(r2, 131072);
                else {
                  var i2 = r2.propertyName || r2.name, t2 = es(i2, i2.escapedText, 2998271, void 0, void 0, true);
                  if (t2 && (t2 === mi || t2 === pe || t2.declarations && Cu(zi(t2.declarations[0]))))
                    Xr(i2, e2.Diagnostics.Cannot_export_0_Only_local_declarations_can_be_exported_from_a_module, e2.idText(i2));
                  else {
                    Gt(r2);
                    var o = t2 && (t2.flags & 2097152 ? Ps(t2) : t2);
                    (!o || o === xe || o.flags & 111551) && Os(r2.propertyName || r2.name);
                  }
                }
              }
              function zM(r2) {
                var i2 = r2.isExportEquals ? e2.Diagnostics.An_export_assignment_must_be_at_the_top_level_of_a_file_or_module_declaration : e2.Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration;
                if (!Uy(r2, i2)) {
                  var t2 = r2.parent.kind === 305 ? r2.parent : r2.parent.parent;
                  if (t2.kind === 261 && !e2.isAmbientModule(t2)) {
                    r2.isExportEquals ? Xr(r2, e2.Diagnostics.An_export_assignment_cannot_be_used_in_a_namespace) : Xr(r2, e2.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
                    return;
                  }
                  !Ff(r2) && e2.hasEffectiveModifiers(r2) && Hs(r2, e2.Diagnostics.An_export_assignment_cannot_have_modifiers);
                  var o = e2.getEffectiveTypeAnnotationNode(r2);
                  if (o && zc(Os(r2.expression), Va(o), r2.expression), r2.expression.kind === 79) {
                    var s2 = r2.expression, u = Ds(s2, 67108863, true, true, r2);
                    if (u) {
                      o0(u, s2);
                      var h2 = u.flags & 2097152 ? Ps(u) : u;
                      (h2 === xe || h2.flags & 111551) && Os(r2.expression);
                    } else
                      Os(r2.expression);
                    e2.getEmitDeclarations(ye) && V_(r2.expression, true);
                  } else
                    Os(r2.expression);
                  V6(t2), r2.flags & 16777216 && !e2.isEntityNameExpression(r2.expression) && Tt(r2.expression, e2.Diagnostics.The_expression_of_an_export_assignment_must_be_an_identifier_or_qualified_name_in_an_ambient_context), r2.isExportEquals && !(r2.flags & 16777216) && (er >= e2.ModuleKind.ES2015 && e2.getSourceFileOfNode(r2).impliedNodeFormat !== e2.ModuleKind.CommonJS ? Tt(r2, e2.Diagnostics.Export_assignment_cannot_be_used_when_targeting_ECMAScript_modules_Consider_using_export_default_or_another_module_format_instead) : er === e2.ModuleKind.System && Tt(r2, e2.Diagnostics.Export_assignment_is_not_supported_when_module_flag_is_system));
                }
              }
              function WM(r2) {
                return e2.forEachEntry(r2.exports, function(i2, t2) {
                  return t2 !== "export=";
                });
              }
              function V6(r2) {
                var i2 = Et(r2), t2 = Aa(i2);
                if (!t2.exportsChecked) {
                  var o = i2.exports.get("export=");
                  if (o && WM(i2)) {
                    var s2 = ru(o) || o.valueDeclaration;
                    s2 && !Xu(s2) && !e2.isInJSFile(s2) && Xr(s2, e2.Diagnostics.An_export_assignment_cannot_be_used_in_a_module_with_other_exported_elements);
                  }
                  var u = Pu(i2);
                  u && u.forEach(function(h2, z) {
                    var me = h2.declarations, Me = h2.flags;
                    if (z !== "__export" && !(Me & 1920)) {
                      var $e = e2.countWhere(me, e2.and(O, e2.not(e2.isInterfaceDeclaration)));
                      if (!(Me & 524288 && $e <= 2) && $e > 1 && !z0(me))
                        for (var tr = 0, dr = me; tr < dr.length; tr++) {
                          var Dr = dr[tr];
                          k(Dr) && rn.add(e2.createDiagnosticForNode(Dr, e2.Diagnostics.Cannot_redeclare_exported_variable_0, e2.unescapeLeadingUnderscores(z)));
                        }
                    }
                  }), t2.exportsChecked = true;
                }
              }
              function z0(r2) {
                return r2 && r2.length > 1 && r2.every(function(i2) {
                  return e2.isInJSFile(i2) && e2.isAccessExpression(i2) && (e2.isExportsIdentifier(i2.expression) || e2.isModuleExportsAccessExpression(i2.expression));
                });
              }
              function io(r2) {
                if (r2) {
                  var i2 = Ie;
                  Ie = r2, Ee = 0, qM(r2), Ie = i2;
                }
              }
              function qM(r2) {
                e2.isInJSFile(r2) && e2.forEach(r2.jsDoc, function(t2) {
                  var o = t2.tags;
                  return e2.forEach(o, io);
                });
                var i2 = r2.kind;
                if (g)
                  switch (i2) {
                    case 261:
                    case 257:
                    case 258:
                    case 256:
                      g.throwIfCancellationRequested();
                  }
                switch (i2 >= 237 && i2 <= 253 && r2.flowNode && !my(r2.flowNode) && Ic(ye.allowUnreachableCode === false, r2, e2.Diagnostics.Unreachable_code_detected), i2) {
                  case 163:
                    return $k(r2);
                  case 164:
                    return Zk(r2);
                  case 167:
                    return i6(r2);
                  case 166:
                    return RO(r2);
                  case 180:
                  case 179:
                  case 174:
                  case 175:
                  case 176:
                    return Dv(r2);
                  case 169:
                  case 168:
                    return BO(r2);
                  case 170:
                    return JO(r2);
                  case 171:
                    return jO(r2);
                  case 172:
                  case 173:
                    return a6(r2);
                  case 178:
                    return vS(r2);
                  case 177:
                    return OO(r2);
                  case 181:
                    return qO(r2);
                  case 182:
                    return VO(r2);
                  case 183:
                    return KO(r2);
                  case 184:
                    return GO(r2);
                  case 187:
                  case 188:
                    return HO(r2);
                  case 191:
                  case 185:
                  case 186:
                    return io(r2.type);
                  case 192:
                    return $O(r2);
                  case 193:
                    return ZO(r2);
                  case 189:
                    return eF(r2);
                  case 190:
                    return rF(r2);
                  case 198:
                    return iF(r2);
                  case 200:
                    return tF(r2);
                  case 197:
                    return aF(r2);
                  case 328:
                    return hF(r2);
                  case 329:
                    return yF(r2);
                  case 345:
                  case 338:
                  case 339:
                    return _F(r2);
                  case 344:
                    return pF(r2);
                  case 343:
                    return dF(r2);
                  case 340:
                    return gF(r2);
                  case 347:
                    return mF(r2);
                  case 317:
                    vF(r2);
                  case 315:
                  case 314:
                  case 312:
                  case 313:
                  case 322:
                    K6(r2), e2.forEachChild(r2, io);
                    return;
                  case 318:
                    VM(r2);
                    return;
                  case 309:
                    return io(r2.type);
                  case 333:
                  case 335:
                  case 334:
                    return DF(r2);
                  case 194:
                    return XO(r2);
                  case 195:
                    return QO(r2);
                  case 256:
                    return fF(r2);
                  case 235:
                  case 262:
                    return M0(r2);
                  case 237:
                    return LF2(r2);
                  case 238:
                    return RF(r2);
                  case 239:
                    return BF(r2);
                  case 240:
                    return UF(r2);
                  case 241:
                    return zF(r2);
                  case 242:
                    return WF(r2);
                  case 243:
                    return VF(r2);
                  case 244:
                    return qF(r2);
                  case 245:
                  case 246:
                    return $F(r2);
                  case 247:
                    return ZF(r2);
                  case 248:
                    return eM(r2);
                  case 249:
                    return rM(r2);
                  case 250:
                    return iM(r2);
                  case 251:
                    return tM(r2);
                  case 252:
                    return aM(r2);
                  case 254:
                    return SS(r2);
                  case 203:
                    return MF(r2);
                  case 257:
                    return fM(r2);
                  case 258:
                    return bM(r2);
                  case 259:
                    return SM(r2);
                  case 260:
                    return EM(r2);
                  case 261:
                    return PM(r2);
                  case 266:
                    return wM(r2);
                  case 265:
                    return OM(r2);
                  case 272:
                    return FM(r2);
                  case 271:
                    return zM(r2);
                  case 236:
                  case 253:
                    Mf(r2);
                    return;
                  case 276:
                    return zO(r2);
                }
              }
              function K6(r2) {
                e2.isInJSFile(r2) || Tt(r2, e2.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments);
              }
              function VM(r2) {
                K6(r2), io(r2.type);
                var i2 = r2.parent;
                if (e2.isParameter(i2) && e2.isJSDocFunctionType(i2.parent)) {
                  e2.last(i2.parent.parameters) !== i2 && Xr(r2, e2.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
                  return;
                }
                e2.isJSDocTypeExpression(i2) || Xr(r2, e2.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
                var t2 = r2.parent.parent;
                if (!e2.isJSDocParameterTag(t2)) {
                  Xr(r2, e2.Diagnostics.JSDoc_may_only_appear_in_the_last_parameter_of_a_signature);
                  return;
                }
                var o = e2.getParameterSymbolFromJSDoc(t2);
                if (!!o) {
                  var s2 = e2.getHostSignatureFromJSDoc(t2);
                  (!s2 || e2.last(s2.parameters).symbol !== o) && Xr(r2, e2.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
                }
              }
              function KM(r2) {
                var i2 = Va(r2.type), t2 = r2.parent, o = r2.parent.parent;
                if (e2.isJSDocTypeExpression(r2.parent) && e2.isJSDocParameterTag(o)) {
                  var s2 = e2.getHostSignatureFromJSDoc(o), u = e2.isJSDocCallbackTag(o.parent.parent);
                  if (s2 || u) {
                    var h2 = u ? e2.lastOrUndefined(o.parent.parent.typeExpression.parameters) : e2.lastOrUndefined(s2.parameters), z = e2.getParameterSymbolFromJSDoc(o);
                    if (!h2 || z && h2.symbol === z && e2.isRestParameter(h2))
                      return Zs(i2);
                  }
                }
                return e2.isParameter(t2) && e2.isJSDocFunctionType(t2.parent) ? Zs(i2) : kc(i2);
              }
              function xm(r2) {
                var i2 = e2.getSourceFileOfNode(r2), t2 = va(i2);
                t2.flags & 1 || (t2.deferredNodes || (t2.deferredNodes = new e2.Set()), t2.deferredNodes.add(r2));
              }
              function GM(r2) {
                var i2 = va(r2);
                i2.deferredNodes && i2.deferredNodes.forEach(HM);
              }
              function HM(r2) {
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("check", "checkDeferredNode", { kind: r2.kind, pos: r2.pos, end: r2.end, path: r2.tracingPath });
                var i2 = Ie;
                switch (Ie = r2, Ee = 0, r2.kind) {
                  case 208:
                  case 209:
                  case 210:
                  case 165:
                  case 280:
                    Fg(r2);
                    break;
                  case 213:
                  case 214:
                  case 169:
                  case 168:
                    Z7(r2);
                    break;
                  case 172:
                  case 173:
                    a6(r2);
                    break;
                  case 226:
                    lM(r2);
                    break;
                  case 163:
                    wO(r2);
                    break;
                  case 279:
                    k5(r2);
                    break;
                  case 278:
                    N5(r2);
                    break;
                }
                Ie = i2, e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
              }
              function XM(r2) {
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("check", "checkSourceFile", { path: r2.path }, true), e2.performance.mark("beforeCheck"), QM(r2), e2.performance.mark("afterCheck"), e2.performance.measure("Check", "beforeCheck", "afterCheck"), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
              }
              function G6(r2, i2) {
                if (i2)
                  return false;
                switch (r2) {
                  case 0:
                    return !!ye.noUnusedLocals;
                  case 1:
                    return !!ye.noUnusedParameters;
                  default:
                    return e2.Debug.assertNever(r2);
                }
              }
              function H6(r2) {
                return Fo.get(r2.path) || e2.emptyArray;
              }
              function QM(r2) {
                var i2 = va(r2);
                if (!(i2.flags & 1)) {
                  if (e2.skipTypeChecking(r2, ye, l))
                    return;
                  DL(r2), e2.clear(Xt), e2.clear(Za), e2.clear(bn), e2.clear(_a4), e2.forEach(r2.statements, io), io(r2.endOfFileToken), GM(r2), e2.isExternalOrCommonJsModule(r2) && A_(r2), fe(function() {
                    !r2.isDeclarationFile && (ye.noUnusedLocals || ye.noUnusedParameters) && _6(H6(r2), function(t2, o, s2) {
                      !e2.containsParseError(t2) && G6(o, !!(t2.flags & 16777216)) && rn.add(s2);
                    });
                  }), ye.importsNotUsedAsValues === 2 && !r2.isDeclarationFile && e2.isExternalModule(r2) && jM(r2), e2.isExternalOrCommonJsModule(r2) && V6(r2), Xt.length && (e2.forEach(Xt, CF), e2.clear(Xt)), Za.length && (e2.forEach(Za, kF), e2.clear(Za)), bn.length && (e2.forEach(bn, IF), e2.clear(bn)), _a4.length && (e2.forEach(_a4, OF), e2.clear(_a4)), i2.flags |= 1;
                }
              }
              function X6(r2, i2) {
                try {
                  return g = i2, YM(r2);
                } finally {
                  g = void 0;
                }
              }
              function OS() {
                for (var r2 = 0, i2 = D; r2 < i2.length; r2++) {
                  var t2 = i2[r2];
                  t2();
                }
                D = [];
              }
              function FS(r2) {
                OS();
                var i2 = fe;
                fe = function(t2) {
                  return t2();
                }, XM(r2), fe = i2;
              }
              function YM(r2) {
                if (r2) {
                  OS();
                  var i2 = rn.getGlobalDiagnostics(), t2 = i2.length;
                  FS(r2);
                  var o = rn.getDiagnostics(r2.fileName), s2 = rn.getGlobalDiagnostics();
                  if (s2 !== i2) {
                    var u = e2.relativeComplement(i2, s2, e2.compareDiagnostics);
                    return e2.concatenate(u, o);
                  } else if (t2 === 0 && s2.length > 0)
                    return e2.concatenate(s2, o);
                  return o;
                }
                return e2.forEach(l.getSourceFiles(), FS), rn.getDiagnostics();
              }
              function $M() {
                return OS(), rn.getGlobalDiagnostics();
              }
              function ZM(r2, i2) {
                if (r2.flags & 33554432)
                  return [];
                var t2 = e2.createSymbolTable(), o = false;
                return s2(), t2.delete("this"), Y_(t2);
                function s2() {
                  for (; r2; ) {
                    switch (r2.locals && !Cu(r2) && h2(r2.locals, i2), r2.kind) {
                      case 305:
                        if (!e2.isExternalModule(r2))
                          break;
                      case 261:
                        z(Et(r2).exports, i2 & 2623475);
                        break;
                      case 260:
                        h2(Et(r2).exports, i2 & 8);
                        break;
                      case 226:
                        var me = r2.name;
                        me && u(r2.symbol, i2);
                      case 257:
                      case 258:
                        o || h2(Nf(Et(r2)), i2 & 788968);
                        break;
                      case 213:
                        var Me = r2.name;
                        Me && u(r2.symbol, i2);
                        break;
                    }
                    e2.introducesArgumentsExoticObject(r2) && u(or, i2), o = e2.isStatic(r2), r2 = r2.parent;
                  }
                  h2(ii, i2);
                }
                function u(me, Me) {
                  if (e2.getCombinedLocalAndExportSymbolFlags(me) & Me) {
                    var $e = me.escapedName;
                    t2.has($e) || t2.set($e, me);
                  }
                }
                function h2(me, Me) {
                  Me && me.forEach(function($e) {
                    u($e, Me);
                  });
                }
                function z(me, Me) {
                  Me && me.forEach(function($e) {
                    !e2.getDeclarationOfKind($e, 275) && !e2.getDeclarationOfKind($e, 274) && u($e, Me);
                  });
                }
              }
              function e9(r2) {
                return r2.kind === 79 && zy(r2.parent) && e2.getNameOfDeclaration(r2.parent) === r2;
              }
              function zy(r2) {
                switch (r2.kind) {
                  case 163:
                  case 257:
                  case 258:
                  case 259:
                  case 260:
                  case 345:
                  case 338:
                  case 339:
                    return true;
                  case 267:
                    return r2.isTypeOnly;
                  case 270:
                  case 275:
                    return r2.parent.parent.isTypeOnly;
                  default:
                    return false;
                }
              }
              function Q6(r2) {
                for (; r2.parent.kind === 161; )
                  r2 = r2.parent;
                return r2.parent.kind === 178;
              }
              function r9(r2) {
                for (; r2.parent.kind === 206; )
                  r2 = r2.parent;
                return r2.parent.kind === 228;
              }
              function Y6(r2, i2) {
                for (var t2; r2 = e2.getContainingClass(r2), !(!r2 || (t2 = i2(r2))); )
                  ;
                return t2;
              }
              function i9(r2) {
                return !!e2.findAncestor(r2, function(i2) {
                  return e2.isConstructorDeclaration(i2) && e2.nodeIsPresent(i2.body) || e2.isPropertyDeclaration(i2) ? true : e2.isClassLike(i2) || e2.isFunctionLikeDeclaration(i2) ? "quit" : false;
                });
              }
              function MS(r2, i2) {
                return !!Y6(r2, function(t2) {
                  return t2 === i2;
                });
              }
              function t9(r2) {
                for (; r2.parent.kind === 161; )
                  r2 = r2.parent;
                if (r2.parent.kind === 265)
                  return r2.parent.moduleReference === r2 ? r2.parent : void 0;
                if (r2.parent.kind === 271)
                  return r2.parent.expression === r2 ? r2.parent : void 0;
              }
              function W0(r2) {
                return t9(r2) !== void 0;
              }
              function a9(r2) {
                var i2 = e2.getAssignmentDeclarationKind(r2.parent.parent);
                switch (i2) {
                  case 1:
                  case 3:
                    return Et(r2.parent);
                  case 4:
                  case 2:
                  case 5:
                    return Et(r2.parent.parent);
                }
              }
              function n9(r2) {
                for (var i2 = r2.parent; e2.isQualifiedName(i2); )
                  r2 = i2, i2 = i2.parent;
                if (i2 && i2.kind === 200 && i2.qualifier === r2)
                  return i2;
              }
              function $6(r2) {
                if (e2.isDeclarationName(r2))
                  return Et(r2.parent);
                if (e2.isInJSFile(r2) && r2.parent.kind === 206 && r2.parent === r2.parent.parent.left && !e2.isPrivateIdentifier(r2) && !e2.isJSDocMemberName(r2)) {
                  var i2 = a9(r2);
                  if (i2)
                    return i2;
                }
                if (r2.parent.kind === 271 && e2.isEntityNameExpression(r2)) {
                  var t2 = Ds(r2, 2998271, true);
                  if (t2 && t2 !== xe)
                    return t2;
                } else if (e2.isEntityName(r2) && W0(r2)) {
                  var o = e2.getAncestor(r2, 265);
                  return e2.Debug.assert(o !== void 0), Nl(r2, true);
                }
                if (e2.isEntityName(r2)) {
                  var s2 = n9(r2);
                  if (s2) {
                    Va(s2);
                    var u = va(r2).resolvedSymbol;
                    return u === xe ? void 0 : u;
                  }
                }
                for (; e2.isRightSideOfQualifiedNameOrPropertyAccessOrJSDocMemberName(r2); )
                  r2 = r2.parent;
                if (r9(r2)) {
                  var h2 = 0;
                  r2.parent.kind === 228 ? (h2 = 788968, e2.isExpressionWithTypeArgumentsInClassExtendsClause(r2.parent) && (h2 |= 111551)) : h2 = 1920, h2 |= 2097152;
                  var z = e2.isEntityNameExpression(r2) ? Ds(r2, h2) : void 0;
                  if (z)
                    return z;
                }
                if (r2.parent.kind === 340)
                  return e2.getParameterSymbolFromJSDoc(r2.parent);
                if (r2.parent.kind === 163 && r2.parent.parent.kind === 344) {
                  e2.Debug.assert(!e2.isInJSFile(r2));
                  var me = e2.getTypeParameterFromJsDoc(r2.parent);
                  return me && me.symbol;
                }
                if (e2.isExpressionNode(r2)) {
                  if (e2.nodeIsMissing(r2))
                    return;
                  var Me = e2.findAncestor(r2, e2.or(e2.isJSDocLinkLike, e2.isJSDocNameReference, e2.isJSDocMemberName)), h2 = Me ? 901119 : 111551;
                  if (r2.kind === 79) {
                    if (e2.isJSXTagName(r2) && dm(r2)) {
                      var $e = Fb(r2.parent);
                      return $e === xe ? void 0 : $e;
                    }
                    var tr = Ds(r2, h2, false, true, e2.getHostSignatureFromJSDoc(r2));
                    if (!tr && Me) {
                      var dr = e2.findAncestor(r2, e2.or(e2.isClassLike, e2.isInterfaceDeclaration));
                      if (dr)
                        return q0(r2, Et(dr));
                    }
                    return tr;
                  } else {
                    if (e2.isPrivateIdentifier(r2))
                      return m0(r2);
                    if (r2.kind === 206 || r2.kind === 161) {
                      var Dr = va(r2);
                      return Dr.resolvedSymbol ? Dr.resolvedSymbol : (r2.kind === 206 ? VC(r2, 0) : KC(r2, 0), !Dr.resolvedSymbol && Me && e2.isQualifiedName(r2) ? q0(r2) : Dr.resolvedSymbol);
                    } else if (e2.isJSDocMemberName(r2))
                      return q0(r2);
                  }
                } else if (Q6(r2)) {
                  var h2 = r2.parent.kind === 178 ? 788968 : 1920, $e = Ds(r2, h2, false, true);
                  return $e && $e !== xe ? $e : yh(r2);
                }
                if (r2.parent.kind === 177)
                  return Ds(r2, 1);
              }
              function q0(r2, i2) {
                if (e2.isEntityName(r2)) {
                  var t2 = 901119, o = Ds(r2, t2, false, true, e2.getHostSignatureFromJSDoc(r2));
                  if (!o && e2.isIdentifier(r2) && i2 && (o = so(qs(dc(i2), r2.escapedText, t2))), o)
                    return o;
                }
                var s2 = e2.isIdentifier(r2) ? i2 : q0(r2.left), u = e2.isIdentifier(r2) ? r2.escapedText : r2.right.escapedText;
                if (s2) {
                  var h2 = s2.flags & 111551 && bi(Jt(s2), "prototype"), z = h2 ? Jt(h2) : go(s2);
                  return bi(z, u);
                }
              }
              function el(r2, i2) {
                if (r2.kind === 305)
                  return e2.isExternalModule(r2) ? so(r2.symbol) : void 0;
                var t2 = r2.parent, o = t2.parent;
                if (!(r2.flags & 33554432)) {
                  if (Y(r2)) {
                    var s2 = Et(t2);
                    return e2.isImportOrExportSpecifier(r2.parent) && r2.parent.propertyName === r2 ? wb(s2) : s2;
                  } else if (e2.isLiteralComputedPropertyDeclarationName(r2))
                    return Et(t2.parent);
                  if (r2.kind === 79) {
                    if (W0(r2))
                      return $6(r2);
                    if (t2.kind === 203 && o.kind === 201 && r2 === t2.propertyName) {
                      var u = Bd(o), h2 = bi(u, r2.escapedText);
                      if (h2)
                        return h2;
                    } else if (e2.isMetaProperty(t2) && t2.name === r2)
                      return t2.keywordToken === 103 && e2.idText(r2) === "target" ? tS(t2).symbol : t2.keywordToken === 100 && e2.idText(r2) === "meta" ? Tx().members.get("meta") : void 0;
                  }
                  switch (r2.kind) {
                    case 79:
                    case 80:
                    case 206:
                    case 161:
                      if (!e2.isThisInTypeQuery(r2))
                        return $6(r2);
                    case 108:
                      var z = e2.getThisContainer(r2, false);
                      if (e2.isFunctionLike(z)) {
                        var me = yl(z);
                        if (me.thisParameter)
                          return me.thisParameter;
                      }
                      if (e2.isInExpressionContext(r2))
                        return yn(r2).symbol;
                    case 192:
                      return Ch(r2).symbol;
                    case 106:
                      return yn(r2).symbol;
                    case 134:
                      var Me = r2.parent;
                      return Me && Me.kind === 171 ? Me.parent.symbol : void 0;
                    case 10:
                    case 14:
                      if (e2.isExternalModuleImportEqualsDeclaration(r2.parent.parent) && e2.getExternalModuleImportEqualsDeclarationExpression(r2.parent.parent) === r2 || (r2.parent.kind === 266 || r2.parent.kind === 272) && r2.parent.moduleSpecifier === r2 || e2.isInJSFile(r2) && e2.isRequireCall(r2.parent, false) || e2.isImportCall(r2.parent) || e2.isLiteralTypeNode(r2.parent) && e2.isLiteralImportTypeNode(r2.parent.parent) && r2.parent.parent.argument === r2.parent)
                        return ac(r2, r2, i2);
                      if (e2.isCallExpression(t2) && e2.isBindableObjectDefinePropertyCall(t2) && t2.arguments[1] === r2)
                        return Et(t2);
                    case 8:
                      var $e = e2.isElementAccessExpression(t2) ? t2.argumentExpression === r2 ? Gs(t2.expression) : void 0 : e2.isLiteralTypeNode(t2) && e2.isIndexedAccessTypeNode(o) ? Va(o.objectType) : void 0;
                      return $e && bi($e, e2.escapeLeadingUnderscores(r2.text));
                    case 88:
                    case 98:
                    case 38:
                    case 84:
                      return Et(r2.parent);
                    case 200:
                      return e2.isLiteralImportTypeNode(r2) ? el(r2.argument.literal, i2) : void 0;
                    case 93:
                      return e2.isExportAssignment(r2.parent) ? e2.Debug.checkDefined(r2.parent.symbol) : void 0;
                    case 100:
                    case 103:
                      return e2.isMetaProperty(r2.parent) ? Ak(r2.parent).symbol : void 0;
                    case 231:
                      return yn(r2).symbol;
                    default:
                      return;
                  }
                }
              }
              function o9(r2) {
                if (e2.isIdentifier(r2) && e2.isPropertyAccessExpression(r2.parent) && r2.parent.name === r2) {
                  var i2 = Z_(r2), t2 = Gs(r2.parent.expression), o = t2.flags & 1048576 ? t2.types : [t2];
                  return e2.flatMap(o, function(s2) {
                    return e2.filter(Hn(s2), function(u) {
                      return an(i2, u.keyType);
                    });
                  });
                }
              }
              function s9(r2) {
                if (r2 && r2.kind === 297)
                  return Ds(r2.name, 2208703);
              }
              function c9(r2) {
                return e2.isExportSpecifier(r2) ? r2.parent.parent.moduleSpecifier ? kl(r2.parent.parent, r2) : Ds(r2.propertyName || r2.name, 2998271) : Ds(r2, 2998271);
              }
              function Bd(r2) {
                if (e2.isSourceFile(r2) && !e2.isExternalModule(r2) || r2.flags & 33554432)
                  return Pe;
                var i2 = e2.tryGetClassImplementingOrExtendingExpressionWithTypeArguments(r2), t2 = i2 && aa(Et(i2.class));
                if (e2.isPartOfTypeNode(r2)) {
                  var o = Va(r2);
                  return t2 ? Rc(o, t2.thisType) : o;
                }
                if (e2.isExpressionNode(r2))
                  return Z6(r2);
                if (t2 && !i2.isImplements) {
                  var s2 = e2.firstOrUndefined(Qc(t2));
                  return s2 ? Rc(s2, t2.thisType) : Pe;
                }
                if (zy(r2)) {
                  var u = Et(r2);
                  return go(u);
                }
                if (e9(r2)) {
                  var u = el(r2);
                  return u ? go(u) : Pe;
                }
                if (e2.isDeclaration(r2)) {
                  var u = Et(r2);
                  return u ? Jt(u) : Pe;
                }
                if (Y(r2)) {
                  var u = el(r2);
                  return u ? Jt(u) : Pe;
                }
                if (e2.isBindingPattern(r2))
                  return G_(r2.parent, true, 0) || Pe;
                if (W0(r2)) {
                  var u = el(r2);
                  if (u) {
                    var h2 = go(u);
                    return nn(h2) ? Jt(u) : h2;
                  }
                }
                return e2.isMetaProperty(r2.parent) && r2.parent.keywordToken === r2.kind ? Ak(r2.parent) : Pe;
              }
              function V0(r2) {
                if (e2.Debug.assert(r2.kind === 205 || r2.kind === 204), r2.parent.kind === 244) {
                  var i2 = By(r2.parent);
                  return Rd(r2, i2 || Pe);
                }
                if (r2.parent.kind === 221) {
                  var i2 = Gs(r2.parent.right);
                  return Rd(r2, i2 || Pe);
                }
                if (r2.parent.kind === 296) {
                  var t2 = e2.cast(r2.parent.parent, e2.isObjectLiteralExpression), o = V0(t2) || Pe, s2 = e2.indexOfNode(t2.properties, r2.parent);
                  return Uk(t2, o, s2);
                }
                var u = e2.cast(r2.parent, e2.isArrayLiteralExpression), h2 = V0(u) || Pe, z = N_(65, h2, Tr, r2.parent) || Pe;
                return zk(u, h2, u.elements.indexOf(r2), z);
              }
              function u9(r2) {
                var i2 = V0(e2.cast(r2.parent.parent, e2.isAssignmentPattern));
                return i2 && bi(i2, r2.escapedText);
              }
              function Z6(r2) {
                return e2.isRightSideOfQualifiedNameOrPropertyAccess(r2) && (r2 = r2.parent), jc(Gs(r2));
              }
              function l9(r2) {
                var i2 = Et(r2.parent);
                return e2.isStatic(r2) ? Jt(i2) : go(i2);
              }
              function f9(r2) {
                var i2 = r2.name;
                switch (i2.kind) {
                  case 79:
                    return Bu(e2.idText(i2));
                  case 8:
                  case 10:
                    return Bu(i2.text);
                  case 162:
                    var t2 = t_(i2);
                    return Ns(t2, 12288) ? t2 : Li;
                  default:
                    return e2.Debug.fail("Unsupported property name.");
                }
              }
              function LS(r2) {
                r2 = $s(r2);
                var i2 = e2.createSymbolTable(uo(r2)), t2 = ot(r2, 0).length ? Zr : ot(r2, 1).length ? Si : void 0;
                return t2 && e2.forEach(uo(t2), function(o) {
                  i2.has(o.escapedName) || i2.set(o.escapedName, o);
                }), tf(i2);
              }
              function RS(r2) {
                return e2.typeHasCallOrConstructSignatures(r2, Di);
              }
              function eA(r2) {
                var i2 = _9(r2);
                return i2 ? e2.flatMap(i2, eA) : [r2];
              }
              function _9(r2) {
                if (e2.getCheckFlags(r2) & 6)
                  return e2.mapDefined(Aa(r2).containingType.types, function(u) {
                    return bi(u, r2.escapedName);
                  });
                if (r2.flags & 33554432) {
                  var i2 = r2, t2 = i2.leftSpread, o = i2.rightSpread, s2 = i2.syntheticOrigin;
                  return t2 ? [t2, o] : s2 ? [s2] : e2.singleElementArray(p9(r2));
                }
              }
              function p9(r2) {
                for (var i2, t2 = r2; t2 = Aa(t2).target; )
                  i2 = t2;
                return i2;
              }
              function d9(r2) {
                if (e2.isGeneratedIdentifier(r2))
                  return false;
                var i2 = e2.getParseTreeNode(r2, e2.isIdentifier);
                if (!i2)
                  return false;
                var t2 = i2.parent;
                if (!t2)
                  return false;
                var o = (e2.isPropertyAccessExpression(t2) || e2.isPropertyAssignment(t2)) && t2.name === i2;
                return !o && Nv(i2) === or;
              }
              function g9(r2) {
                var i2 = ac(r2.parent, r2);
                if (!i2 || e2.isShorthandAmbientModuleSymbol(i2))
                  return true;
                var t2 = ll(i2);
                i2 = Us(i2);
                var o = Aa(i2);
                return o.exportsSomeValue === void 0 && (o.exportsSomeValue = t2 ? !!(i2.flags & 111551) : e2.forEachEntry(Pu(i2), s2)), o.exportsSomeValue;
                function s2(u) {
                  return u = os(u), u && !!(u.flags & 111551);
                }
              }
              function m9(r2) {
                return e2.isModuleOrEnumDeclaration(r2.parent) && r2 === r2.parent.name;
              }
              function v9(r2, i2) {
                var t2, o = e2.getParseTreeNode(r2, e2.isIdentifier);
                if (o) {
                  var s2 = Nv(o, m9(o));
                  if (s2) {
                    if (s2.flags & 1048576) {
                      var u = so(s2.exportSymbol);
                      if (!i2 && u.flags & 944 && !(u.flags & 3))
                        return;
                      s2 = u;
                    }
                    var h2 = Ys(s2);
                    if (h2) {
                      if (h2.flags & 512 && ((t2 = h2.valueDeclaration) === null || t2 === void 0 ? void 0 : t2.kind) === 305) {
                        var z = h2.valueDeclaration, me = e2.getSourceFileOfNode(o), Me = z !== me;
                        return Me ? void 0 : z;
                      }
                      return e2.findAncestor(o.parent, function($e) {
                        return e2.isModuleOrEnumDeclaration($e) && Et($e) === h2;
                      });
                    }
                  }
                }
              }
              function y9(r2) {
                if (r2.generatedImportReference)
                  return r2.generatedImportReference;
                var i2 = e2.getParseTreeNode(r2, e2.isIdentifier);
                if (i2) {
                  var t2 = Nv(i2);
                  if (Zn(t2, 111551) && !vu(t2))
                    return ru(t2);
                }
              }
              function h9(r2) {
                return r2.valueDeclaration && e2.isBindingElement(r2.valueDeclaration) && e2.walkUpBindingElementsAndPatterns(r2.valueDeclaration).parent.kind === 292;
              }
              function rA(r2) {
                if (r2.flags & 418 && r2.valueDeclaration && !e2.isSourceFile(r2.valueDeclaration)) {
                  var i2 = Aa(r2);
                  if (i2.isDeclarationWithCollidingName === void 0) {
                    var t2 = e2.getEnclosingBlockScopeContainer(r2.valueDeclaration);
                    if (e2.isStatementWithLocals(t2) || h9(r2)) {
                      var o = va(r2.valueDeclaration);
                      if (es(t2.parent, r2.escapedName, 111551, void 0, void 0, false))
                        i2.isDeclarationWithCollidingName = true;
                      else if (o.flags & 262144) {
                        var s2 = o.flags & 524288, u = e2.isIterationStatement(t2, false), h2 = t2.kind === 235 && e2.isIterationStatement(t2.parent, false);
                        i2.isDeclarationWithCollidingName = !e2.isBlockScopedContainerTopLevel(t2) && (!s2 || !u && !h2);
                      } else
                        i2.isDeclarationWithCollidingName = false;
                    }
                  }
                  return i2.isDeclarationWithCollidingName;
                }
                return false;
              }
              function D9(r2) {
                if (!e2.isGeneratedIdentifier(r2)) {
                  var i2 = e2.getParseTreeNode(r2, e2.isIdentifier);
                  if (i2) {
                    var t2 = Nv(i2);
                    if (t2 && rA(t2))
                      return t2.valueDeclaration;
                  }
                }
              }
              function b9(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isDeclaration);
                if (i2) {
                  var t2 = Et(i2);
                  if (t2)
                    return rA(t2);
                }
                return false;
              }
              function iA(r2) {
                switch (r2.kind) {
                  case 265:
                    return K0(Et(r2));
                  case 267:
                  case 268:
                  case 270:
                  case 275:
                    var i2 = Et(r2);
                    return !!i2 && K0(i2) && !vu(i2);
                  case 272:
                    var t2 = r2.exportClause;
                    return !!t2 && (e2.isNamespaceExport(t2) || e2.some(t2.elements, iA));
                  case 271:
                    return r2.expression && r2.expression.kind === 79 ? K0(Et(r2)) : true;
                }
                return false;
              }
              function S9(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isImportEqualsDeclaration);
                if (i2 === void 0 || i2.parent.kind !== 305 || !e2.isInternalModuleImportEqualsDeclaration(i2))
                  return false;
                var t2 = K0(Et(i2));
                return t2 && i2.moduleReference && !e2.nodeIsMissing(i2.moduleReference);
              }
              function K0(r2) {
                if (!r2)
                  return false;
                var i2 = cu(Ps(r2));
                return i2 === xe ? true : !!(i2.flags & 111551) && (e2.shouldPreserveConstEnums(ye) || !Av(i2));
              }
              function Av(r2) {
                return lS(r2) || !!r2.constEnumOnlyModule;
              }
              function G0(r2, i2) {
                if (yf(r2)) {
                  var t2 = Et(r2), o = t2 && Aa(t2);
                  if (o != null && o.referenced)
                    return true;
                  var s2 = Aa(t2).aliasTarget;
                  if (s2 && e2.getEffectiveModifierFlags(r2) & 1 && s2.flags & 111551 && (e2.shouldPreserveConstEnums(ye) || !Av(s2)))
                    return true;
                }
                return i2 ? !!e2.forEachChild(r2, function(u) {
                  return G0(u, i2);
                }) : false;
              }
              function tA(r2) {
                if (e2.nodeIsPresent(r2.body)) {
                  if (e2.isGetAccessor(r2) || e2.isSetAccessor(r2))
                    return false;
                  var i2 = Et(r2), t2 = S_(i2);
                  return t2.length > 1 || t2.length === 1 && t2[0].declaration !== r2;
                }
                return false;
              }
              function aA(r2) {
                return !!Ye && !kd(r2) && !e2.isJSDocParameterTag(r2) && !!r2.initializer && !e2.hasSyntacticModifier(r2, 16476);
              }
              function T9(r2) {
                return Ye && kd(r2) && !r2.initializer && e2.hasSyntacticModifier(r2, 16476);
              }
              function x9(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isFunctionDeclaration);
                if (!i2)
                  return false;
                var t2 = Et(i2);
                return !t2 || !(t2.flags & 16) ? false : !!e2.forEachEntry(dc(t2), function(o) {
                  return o.flags & 111551 && o.valueDeclaration && e2.isPropertyAccessExpression(o.valueDeclaration);
                });
              }
              function E9(r2) {
                var i2 = e2.getParseTreeNode(r2, e2.isFunctionDeclaration);
                if (!i2)
                  return e2.emptyArray;
                var t2 = Et(i2);
                return t2 && uo(Jt(t2)) || e2.emptyArray;
              }
              function Ug(r2) {
                var i2, t2 = r2.id || 0;
                return t2 < 0 || t2 >= du.length ? 0 : ((i2 = du[t2]) === null || i2 === void 0 ? void 0 : i2.flags) || 0;
              }
              function H0(r2) {
                return U6(r2.parent), va(r2).enumMemberValue;
              }
              function nA(r2) {
                switch (r2.kind) {
                  case 299:
                  case 206:
                  case 207:
                    return true;
                }
                return false;
              }
              function BS(r2) {
                if (r2.kind === 299)
                  return H0(r2);
                var i2 = va(r2).resolvedSymbol;
                if (i2 && i2.flags & 8) {
                  var t2 = i2.valueDeclaration;
                  if (e2.isEnumConst(t2.parent))
                    return H0(t2);
                }
              }
              function JS(r2) {
                return !!(r2.flags & 524288) && ot(r2, 0).length > 0;
              }
              function C9(r2, i2) {
                var t2, o, s2 = e2.getParseTreeNode(r2, e2.isEntityName);
                if (!s2 || i2 && (i2 = e2.getParseTreeNode(i2), !i2))
                  return e2.TypeReferenceSerializationKind.Unknown;
                var u = false;
                if (e2.isQualifiedName(s2)) {
                  var h2 = Ds(e2.getFirstIdentifier(s2), 111551, true, true, i2);
                  u = !!(!((t2 = h2 == null ? void 0 : h2.declarations) === null || t2 === void 0) && t2.every(e2.isTypeOnlyImportOrExportDeclaration));
                }
                var z = Ds(s2, 111551, true, true, i2), me = z && z.flags & 2097152 ? Ps(z) : z;
                u || (u = !!(!((o = z == null ? void 0 : z.declarations) === null || o === void 0) && o.every(e2.isTypeOnlyImportOrExportDeclaration)));
                var Me = Ds(s2, 788968, true, false, i2);
                if (me && me === Me) {
                  var $e = nD(false);
                  if ($e && me === $e)
                    return e2.TypeReferenceSerializationKind.Promise;
                  var tr = Jt(me);
                  if (tr && qd(tr))
                    return u ? e2.TypeReferenceSerializationKind.TypeWithCallSignature : e2.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue;
                }
                if (!Me)
                  return u ? e2.TypeReferenceSerializationKind.ObjectType : e2.TypeReferenceSerializationKind.Unknown;
                var dr = go(Me);
                return nn(dr) ? u ? e2.TypeReferenceSerializationKind.ObjectType : e2.TypeReferenceSerializationKind.Unknown : dr.flags & 3 ? e2.TypeReferenceSerializationKind.ObjectType : Ns(dr, 245760) ? e2.TypeReferenceSerializationKind.VoidNullableOrNeverType : Ns(dr, 528) ? e2.TypeReferenceSerializationKind.BooleanType : Ns(dr, 296) ? e2.TypeReferenceSerializationKind.NumberLikeType : Ns(dr, 2112) ? e2.TypeReferenceSerializationKind.BigIntLikeType : Ns(dr, 402653316) ? e2.TypeReferenceSerializationKind.StringLikeType : Yn(dr) ? e2.TypeReferenceSerializationKind.ArrayLikeType : Ns(dr, 12288) ? e2.TypeReferenceSerializationKind.ESSymbolType : JS(dr) ? e2.TypeReferenceSerializationKind.TypeWithCallSignature : Tu(dr) ? e2.TypeReferenceSerializationKind.ArrayLikeType : e2.TypeReferenceSerializationKind.ObjectType;
              }
              function k9(r2, i2, t2, o, s2) {
                var u = e2.getParseTreeNode(r2, e2.isVariableLikeOrAccessor);
                if (!u)
                  return e2.factory.createToken(130);
                var h2 = Et(u), z = h2 && !(h2.flags & 133120) ? Hp(Jt(h2)) : Pe;
                return z.flags & 8192 && z.symbol === h2 && (t2 |= 1048576), s2 && (z = i_(z)), Ur.typeToTypeNode(z, i2, t2 | 1024, o);
              }
              function A9(r2, i2, t2, o) {
                var s2 = e2.getParseTreeNode(r2, e2.isFunctionLike);
                if (!s2)
                  return e2.factory.createToken(130);
                var u = yl(s2);
                return Ur.typeToTypeNode(yo(u), i2, t2 | 1024, o);
              }
              function N9(r2, i2, t2, o) {
                var s2 = e2.getParseTreeNode(r2, e2.isExpression);
                if (!s2)
                  return e2.factory.createToken(130);
                var u = $c(Z6(s2));
                return Ur.typeToTypeNode(u, i2, t2 | 1024, o);
              }
              function P9(r2) {
                return ii.has(e2.escapeLeadingUnderscores(r2));
              }
              function Nv(r2, i2) {
                var t2 = va(r2).resolvedSymbol;
                if (t2)
                  return t2;
                var o = r2;
                if (i2) {
                  var s2 = r2.parent;
                  e2.isDeclaration(s2) && r2 === s2.name && (o = zi(s2));
                }
                return es(o, r2.escapedText, 3257279, void 0, void 0, true);
              }
              function I9(r2) {
                if (!e2.isGeneratedIdentifier(r2)) {
                  var i2 = e2.getParseTreeNode(r2, e2.isIdentifier);
                  if (i2) {
                    var t2 = Nv(i2);
                    if (t2)
                      return cu(t2).valueDeclaration;
                  }
                }
              }
              function w9(r2) {
                return e2.isDeclarationReadonly(r2) || e2.isVariableDeclaration(r2) && e2.isVarConst(r2) ? Kp(Jt(Et(r2))) : false;
              }
              function O9(r2, i2, t2) {
                var o = r2.flags & 1024 ? Ur.symbolToExpression(r2.symbol, 111551, i2, void 0, t2) : r2 === Dt ? e2.factory.createTrue() : r2 === xt && e2.factory.createFalse();
                if (o)
                  return o;
                var s2 = r2.value;
                return typeof s2 == "object" ? e2.factory.createBigIntLiteral(s2) : typeof s2 == "number" ? e2.factory.createNumericLiteral(s2) : e2.factory.createStringLiteral(s2);
              }
              function F9(r2, i2) {
                var t2 = Jt(Et(r2));
                return O9(t2, r2, i2);
              }
              function oA(r2) {
                return r2 ? (po(r2), e2.getSourceFileOfNode(r2).localJsxFactory || Se) : Se;
              }
              function jS(r2) {
                if (r2) {
                  var i2 = e2.getSourceFileOfNode(r2);
                  if (i2) {
                    if (i2.localJsxFragmentFactory)
                      return i2.localJsxFragmentFactory;
                    var t2 = i2.pragmas.get("jsxfrag"), o = e2.isArray(t2) ? t2[0] : t2;
                    if (o)
                      return i2.localJsxFragmentFactory = e2.parseIsolatedEntityName(o.arguments.factory, Ae), i2.localJsxFragmentFactory;
                  }
                }
                if (ye.jsxFragmentFactory)
                  return e2.parseIsolatedEntityName(ye.jsxFragmentFactory, Ae);
              }
              function M9() {
                var r2 = l.getResolvedTypeReferenceDirectives(), i2;
                return r2 && (i2 = new e2.Map(), r2.forEach(function(me, Me, $e) {
                  if (!(!me || !me.resolvedFileName)) {
                    var tr = l.getSourceFile(me.resolvedFileName);
                    tr && z(tr, Me, $e);
                  }
                })), { getReferencedExportContainer: v9, getReferencedImportDeclaration: y9, getReferencedDeclarationWithCollidingName: D9, isDeclarationWithCollidingName: b9, isValueAliasDeclaration: function(me) {
                  var Me = e2.getParseTreeNode(me);
                  return Me ? iA(Me) : true;
                }, hasGlobalName: P9, isReferencedAliasDeclaration: function(me, Me) {
                  var $e = e2.getParseTreeNode(me);
                  return $e ? G0($e, Me) : true;
                }, getNodeCheckFlags: function(me) {
                  var Me = e2.getParseTreeNode(me);
                  return Me ? Ug(Me) : 0;
                }, isTopLevelValueImportEqualsWithEntityName: S9, isDeclarationVisible: wu, isImplementationOfOverload: tA, isRequiredInitializedParameter: aA, isOptionalUninitializedParameterProperty: T9, isExpandoFunctionDeclaration: x9, getPropertiesOfContainerFunction: E9, createTypeOfDeclaration: k9, createReturnTypeOfSignatureDeclaration: A9, createTypeOfExpression: N9, createLiteralConstValue: F9, isSymbolAccessible: g_, isEntityNameVisible: af, getConstantValue: function(me) {
                  var Me = e2.getParseTreeNode(me, nA);
                  return Me ? BS(Me) : void 0;
                }, collectLinkedAliases: V_, getReferencedValueDeclaration: I9, getTypeReferenceSerializationKind: C9, isOptionalParameter: kd, moduleExportsSomeValue: g9, isArgumentsLocalBinding: d9, getExternalModuleFileFromDeclaration: function(me) {
                  var Me = e2.getParseTreeNode(me, e2.hasPossibleExternalModuleReference);
                  return Me && US(Me);
                }, getTypeReferenceDirectivesForEntityName: s2, getTypeReferenceDirectivesForSymbol: u, isLiteralConstDeclaration: w9, isLateBound: function(me) {
                  var Me = e2.getParseTreeNode(me, e2.isDeclaration), $e = Me && Et(Me);
                  return !!($e && e2.getCheckFlags($e) & 4096);
                }, getJsxFactoryEntity: oA, getJsxFragmentFactoryEntity: jS, getAllAccessorDeclarations: function(me) {
                  me = e2.getParseTreeNode(me, e2.isGetOrSetAccessorDeclaration);
                  var Me = me.kind === 173 ? 172 : 173, $e = e2.getDeclarationOfKind(Et(me), Me), tr = $e && $e.pos < me.pos ? $e : me, dr = $e && $e.pos < me.pos ? me : $e, Dr = me.kind === 173 ? me : $e, Qr = me.kind === 172 ? me : $e;
                  return { firstAccessor: tr, secondAccessor: dr, setAccessor: Dr, getAccessor: Qr };
                }, getSymbolOfExternalModuleSpecifier: function(me) {
                  return Pl(me, me, void 0);
                }, isBindingCapturedByNode: function(me, Me) {
                  var $e = e2.getParseTreeNode(me), tr = e2.getParseTreeNode(Me);
                  return !!$e && !!tr && (e2.isVariableDeclaration(tr) || e2.isBindingElement(tr)) && U8($e, tr);
                }, getDeclarationStatementsForSourceFile: function(me, Me, $e, tr) {
                  var dr = e2.getParseTreeNode(me);
                  e2.Debug.assert(dr && dr.kind === 305, "Non-sourcefile node passed into getDeclarationsForSourceFile");
                  var Dr = Et(me);
                  return Dr ? Dr.exports ? Ur.symbolTableToDeclarationStatements(Dr.exports, me, Me, $e, tr) : [] : me.locals ? Ur.symbolTableToDeclarationStatements(me.locals, me, Me, $e, tr) : [];
                }, isImportRequiredByAugmentation: t2 };
                function t2(me) {
                  var Me = e2.getSourceFileOfNode(me);
                  if (!Me.symbol)
                    return false;
                  var $e = US(me);
                  if (!$e || $e === Me)
                    return false;
                  for (var tr = Pu(Me.symbol), dr = 0, Dr = e2.arrayFrom(tr.values()); dr < Dr.length; dr++) {
                    var Qr = Dr[dr];
                    if (Qr.mergeId) {
                      var li = so(Qr);
                      if (li.declarations)
                        for (var Ti = 0, Ci = li.declarations; Ti < Ci.length; Ti++) {
                          var $i = Ci[Ti], Zi = e2.getSourceFileOfNode($i);
                          if (Zi === $e)
                            return true;
                        }
                    }
                  }
                  return false;
                }
                function o(me) {
                  return me.parent && me.parent.kind === 228 && me.parent.parent && me.parent.parent.kind === 291;
                }
                function s2(me) {
                  if (!!i2) {
                    var Me = 790504;
                    (me.kind === 79 && _m(me) || me.kind === 206 && !o(me)) && (Me = 1160127);
                    var $e = Ds(me, Me, true);
                    return $e && $e !== xe ? u($e, Me) : void 0;
                  }
                }
                function u(me, Me) {
                  if (!(!i2 || !h2(me))) {
                    for (var $e, tr = 0, dr = me.declarations; tr < dr.length; tr++) {
                      var Dr = dr[tr];
                      if (Dr.symbol && Dr.symbol.flags & Me) {
                        var Qr = e2.getSourceFileOfNode(Dr), li = i2.get(Qr.path);
                        if (li)
                          ($e || ($e = [])).push(li);
                        else
                          return;
                      }
                    }
                    return $e;
                  }
                }
                function h2(me) {
                  if (!me.declarations)
                    return false;
                  for (var Me = me; ; ) {
                    var $e = Ys(Me);
                    if ($e)
                      Me = $e;
                    else
                      break;
                  }
                  if (Me.valueDeclaration && Me.valueDeclaration.kind === 305 && Me.flags & 512)
                    return false;
                  for (var tr = 0, dr = me.declarations; tr < dr.length; tr++) {
                    var Dr = dr[tr], Qr = e2.getSourceFileOfNode(Dr);
                    if (i2.has(Qr.path))
                      return true;
                  }
                  return false;
                }
                function z(me, Me, $e) {
                  if (!i2.has(me.path)) {
                    i2.set(me.path, [Me, $e]);
                    for (var tr = 0, dr = me.referencedFiles; tr < dr.length; tr++) {
                      var Dr = dr[tr], Qr = Dr.fileName, li = Dr.resolutionMode, Ti = e2.resolveTripleslashReference(Qr, me.fileName), Ci = l.getSourceFile(Ti);
                      Ci && z(Ci, Me, li || me.impliedNodeFormat);
                    }
                  }
                }
              }
              function US(r2) {
                var i2 = r2.kind === 261 ? e2.tryCast(r2.name, e2.isStringLiteral) : e2.getExternalModuleName(r2), t2 = Pl(i2, i2, void 0);
                if (!!t2)
                  return e2.getDeclarationOfKind(t2, 305);
              }
              function L9() {
                for (var r2 = 0, i2 = l.getSourceFiles(); r2 < i2.length; r2++) {
                  var t2 = i2[r2];
                  e2.bindSourceFile(t2, ye);
                }
                dn = new e2.Map();
                for (var o, s2 = 0, u = l.getSourceFiles(); s2 < u.length; s2++) {
                  var t2 = u[s2];
                  if (!t2.redirectInfo) {
                    if (!e2.isExternalOrCommonJsModule(t2)) {
                      var h2 = t2.locals.get("globalThis");
                      if (h2 != null && h2.declarations)
                        for (var z = 0, me = h2.declarations; z < me.length; z++) {
                          var Me = me[z];
                          rn.add(e2.createDiagnosticForNode(Me, e2.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0, "globalThis"));
                        }
                      gu(ii, t2.locals);
                    }
                    if (t2.jsGlobalAugmentations && gu(ii, t2.jsGlobalAugmentations), t2.patternAmbientModules && t2.patternAmbientModules.length && (S2 = e2.concatenate(S2, t2.patternAmbientModules)), t2.moduleAugmentations.length && (o || (o = [])).push(t2.moduleAugmentations), t2.symbol && t2.symbol.globalExports) {
                      var $e = t2.symbol.globalExports;
                      $e.forEach(function(Ra, ca) {
                        ii.has(ca) || ii.set(ca, Ra);
                      });
                    }
                  }
                }
                if (o)
                  for (var tr = 0, dr = o; tr < dr.length; tr++)
                    for (var Dr = dr[tr], Qr = 0, li = Dr; Qr < li.length; Qr++) {
                      var Ti = li[Qr];
                      !e2.isGlobalScopeAugmentation(Ti.parent) || Dp(Ti);
                    }
                if (sd(ii, No, e2.Diagnostics.Declaration_name_conflicts_with_built_in_global_identifier_0), Aa(mi).type = vi, Aa(or).type = lc("IArguments", 0, true), Aa(xe).type = Pe, Aa(pe).type = tu(16, pe), Pi = lc("Array", 1, true), qe = lc("Object", 0, true), br = lc("Function", 0, true), Zr = Er && lc("CallableFunction", 0, true) || br, Si = Er && lc("NewableFunction", 0, true) || br, Ct = lc("String", 0, true), sa = lc("Number", 0, true), en = lc("Boolean", 0, true), Wa = lc("RegExp", 0, true), mo = Zs(Oe), So = Zs(nr), So === Ba && (So = rs(void 0, we, e2.emptyArray, e2.emptyArray, e2.emptyArray)), Qi = Nx("ReadonlyArray", 1) || Pi, Go = Qi ? $m(Qi, [Oe]) : mo, qn = Nx("ThisType", 1), o)
                  for (var Ci = 0, $i = o; Ci < $i.length; Ci++)
                    for (var Dr = $i[Ci], Zi = 0, qt = Dr; Zi < qt.length; Zi++) {
                      var Ti = qt[Zi];
                      e2.isGlobalScopeAugmentation(Ti.parent) || Dp(Ti);
                    }
                dn.forEach(function(Nt) {
                  var Ra = Nt.firstFile, ca = Nt.secondFile, Sn = Nt.conflictingSymbols;
                  if (Sn.size < 8)
                    Sn.forEach(function(Fn, wn) {
                      for (var Tn = Fn.isBlockScoped, Eo = Fn.firstFileLocations, lt = Fn.secondFileLocations, it = Tn ? e2.Diagnostics.Cannot_redeclare_block_scoped_variable_0 : e2.Diagnostics.Duplicate_identifier_0, Yt = 0, Ia = Eo; Yt < Ia.length; Yt++) {
                        var Qt = Ia[Yt];
                        c_(Qt, it, wn, lt);
                      }
                      for (var Ka = 0, cn = lt; Ka < cn.length; Ka++) {
                        var Qt = cn[Ka];
                        c_(Qt, it, wn, Eo);
                      }
                    });
                  else {
                    var ja = e2.arrayFrom(Sn.keys()).join(", ");
                    rn.add(e2.addRelatedInfo(e2.createDiagnosticForNode(Ra, e2.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, ja), e2.createDiagnosticForNode(ca, e2.Diagnostics.Conflicts_are_in_this_file))), rn.add(e2.addRelatedInfo(e2.createDiagnosticForNode(ca, e2.Diagnostics.Definitions_of_the_following_identifiers_conflict_with_those_in_another_file_Colon_0, ja), e2.createDiagnosticForNode(Ra, e2.Diagnostics.Conflicts_are_in_this_file)));
                  }
                }), dn = void 0;
              }
              function fc(r2, i2) {
                if ((ne & i2) !== i2 && ye.importHelpers) {
                  var t2 = e2.getSourceFileOfNode(r2);
                  if (e2.isEffectiveExternalModule(t2, ye) && !(r2.flags & 16777216)) {
                    var o = B9(t2, r2);
                    if (o !== xe) {
                      for (var s2 = i2 & ~ne, u = 1; u <= 4194304; u <<= 1)
                        if (s2 & u) {
                          var h2 = R9(u), z = qs(o.exports, e2.escapeLeadingUnderscores(h2), 111551);
                          z ? u & 524288 ? e2.some(S_(z), function(me) {
                            return Wc(me) > 3;
                          }) || Xr(r2, e2.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, e2.externalHelpersModuleNameText, h2, 4) : u & 1048576 ? e2.some(S_(z), function(me) {
                            return Wc(me) > 4;
                          }) || Xr(r2, e2.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, e2.externalHelpersModuleNameText, h2, 5) : u & 1024 && (e2.some(S_(z), function(me) {
                            return Wc(me) > 2;
                          }) || Xr(r2, e2.Diagnostics.This_syntax_requires_an_imported_helper_named_1_with_2_parameters_which_is_not_compatible_with_the_one_in_0_Consider_upgrading_your_version_of_0, e2.externalHelpersModuleNameText, h2, 3)) : Xr(r2, e2.Diagnostics.This_syntax_requires_an_imported_helper_named_1_which_does_not_exist_in_0_Consider_upgrading_your_version_of_0, e2.externalHelpersModuleNameText, h2);
                        }
                    }
                    ne |= i2;
                  }
                }
              }
              function R9(r2) {
                switch (r2) {
                  case 1:
                    return "__extends";
                  case 2:
                    return "__assign";
                  case 4:
                    return "__rest";
                  case 8:
                    return "__decorate";
                  case 16:
                    return "__metadata";
                  case 32:
                    return "__param";
                  case 64:
                    return "__awaiter";
                  case 128:
                    return "__generator";
                  case 256:
                    return "__values";
                  case 512:
                    return "__read";
                  case 1024:
                    return "__spreadArray";
                  case 2048:
                    return "__await";
                  case 4096:
                    return "__asyncGenerator";
                  case 8192:
                    return "__asyncDelegator";
                  case 16384:
                    return "__asyncValues";
                  case 32768:
                    return "__exportStar";
                  case 65536:
                    return "__importStar";
                  case 131072:
                    return "__importDefault";
                  case 262144:
                    return "__makeTemplateObject";
                  case 524288:
                    return "__classPrivateFieldGet";
                  case 1048576:
                    return "__classPrivateFieldSet";
                  case 2097152:
                    return "__classPrivateFieldIn";
                  case 4194304:
                    return "__createBinding";
                  default:
                    return e2.Debug.fail("Unrecognized helper");
                }
              }
              function B9(r2, i2) {
                return ue || (ue = Il(r2, e2.externalHelpersModuleNameText, e2.Diagnostics.This_syntax_requires_an_imported_helper_but_module_0_cannot_be_found, i2) || xe), ue;
              }
              function Ff(r2) {
                return J9(r2) || sA(r2);
              }
              function J9(r2) {
                if (!r2.decorators)
                  return false;
                if (e2.nodeCanBeDecorated(r2, r2.parent, r2.parent.parent)) {
                  if (r2.kind === 172 || r2.kind === 173) {
                    var i2 = e2.getAllAccessorDeclarations(r2.parent.members, r2);
                    if (i2.firstAccessor.decorators && r2 === i2.secondAccessor)
                      return Hs(r2, e2.Diagnostics.Decorators_cannot_be_applied_to_multiple_get_Slashset_accessors_of_the_same_name);
                  }
                } else
                  return r2.kind === 169 && !e2.nodeIsPresent(r2.body) ? Hs(r2, e2.Diagnostics.A_decorator_can_only_decorate_a_method_implementation_not_an_overload) : Hs(r2, e2.Diagnostics.Decorators_are_not_valid_here);
                return false;
              }
              function sA(r2) {
                var i2 = j9(r2);
                if (i2 !== void 0)
                  return i2;
                for (var t2, o, s2, u, h2 = 0, z = 0, me = r2.modifiers; z < me.length; z++) {
                  var Me = me[z];
                  if (Me.kind !== 145) {
                    if (r2.kind === 166 || r2.kind === 168)
                      return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_a_type_member, e2.tokenToString(Me.kind));
                    if (r2.kind === 176 && (Me.kind !== 124 || !e2.isClassLike(r2.parent)))
                      return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_an_index_signature, e2.tokenToString(Me.kind));
                  }
                  if (Me.kind !== 101 && Me.kind !== 144 && r2.kind === 163)
                    return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_a_type_parameter, e2.tokenToString(Me.kind));
                  switch (Me.kind) {
                    case 85:
                      if (r2.kind !== 260)
                        return Tt(r2, e2.Diagnostics.A_class_member_cannot_have_the_0_keyword, e2.tokenToString(85));
                      break;
                    case 159:
                      if (h2 & 16384)
                        return Tt(Me, e2.Diagnostics._0_modifier_already_seen, "override");
                      if (h2 & 2)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "override", "declare");
                      if (h2 & 64)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "override", "readonly");
                      if (h2 & 256)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "override", "async");
                      h2 |= 16384, u = Me;
                      break;
                    case 123:
                    case 122:
                    case 121:
                      var $e = v_(e2.modifierToFlag(Me.kind));
                      if (h2 & 28)
                        return Tt(Me, e2.Diagnostics.Accessibility_modifier_already_seen);
                      if (h2 & 16384)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, $e, "override");
                      if (h2 & 32)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, $e, "static");
                      if (h2 & 64)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, $e, "readonly");
                      if (h2 & 256)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, $e, "async");
                      if (r2.parent.kind === 262 || r2.parent.kind === 305)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, $e);
                      if (h2 & 128)
                        return Me.kind === 121 ? Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, $e, "abstract") : Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, $e, "abstract");
                      if (e2.isPrivateIdentifierClassElementDeclaration(r2))
                        return Tt(Me, e2.Diagnostics.An_accessibility_modifier_cannot_be_used_with_a_private_identifier);
                      h2 |= e2.modifierToFlag(Me.kind);
                      break;
                    case 124:
                      if (h2 & 32)
                        return Tt(Me, e2.Diagnostics._0_modifier_already_seen, "static");
                      if (h2 & 64)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "static", "readonly");
                      if (h2 & 256)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "static", "async");
                      if (r2.parent.kind === 262 || r2.parent.kind === 305)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element, "static");
                      if (r2.kind === 164)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "static");
                      if (h2 & 128)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                      if (h2 & 16384)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "static", "override");
                      h2 |= 32, t2 = Me;
                      break;
                    case 145:
                      if (h2 & 64)
                        return Tt(Me, e2.Diagnostics._0_modifier_already_seen, "readonly");
                      if (r2.kind !== 167 && r2.kind !== 166 && r2.kind !== 176 && r2.kind !== 164)
                        return Tt(Me, e2.Diagnostics.readonly_modifier_can_only_appear_on_a_property_declaration_or_index_signature);
                      h2 |= 64;
                      break;
                    case 93:
                      if (h2 & 1)
                        return Tt(Me, e2.Diagnostics._0_modifier_already_seen, "export");
                      if (h2 & 2)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "export", "declare");
                      if (h2 & 128)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "export", "abstract");
                      if (h2 & 256)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "export", "async");
                      if (e2.isClassLike(r2.parent))
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "export");
                      if (r2.kind === 164)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "export");
                      h2 |= 1;
                      break;
                    case 88:
                      var tr = r2.parent.kind === 305 ? r2.parent : r2.parent.parent;
                      if (tr.kind === 261 && !e2.isAmbientModule(tr))
                        return Tt(Me, e2.Diagnostics.A_default_export_can_only_be_used_in_an_ECMAScript_style_module);
                      if (!(h2 & 1))
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "export", "default");
                      h2 |= 512;
                      break;
                    case 135:
                      if (h2 & 2)
                        return Tt(Me, e2.Diagnostics._0_modifier_already_seen, "declare");
                      if (h2 & 256)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                      if (h2 & 16384)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "override");
                      if (e2.isClassLike(r2.parent) && !e2.isPropertyDeclaration(r2))
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind, "declare");
                      if (r2.kind === 164)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "declare");
                      if (r2.parent.flags & 16777216 && r2.parent.kind === 262)
                        return Tt(Me, e2.Diagnostics.A_declare_modifier_cannot_be_used_in_an_already_ambient_context);
                      if (e2.isPrivateIdentifierClassElementDeclaration(r2))
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "declare");
                      h2 |= 2, o = Me;
                      break;
                    case 126:
                      if (h2 & 128)
                        return Tt(Me, e2.Diagnostics._0_modifier_already_seen, "abstract");
                      if (r2.kind !== 257 && r2.kind !== 180) {
                        if (r2.kind !== 169 && r2.kind !== 167 && r2.kind !== 172 && r2.kind !== 173)
                          return Tt(Me, e2.Diagnostics.abstract_modifier_can_only_appear_on_a_class_method_or_property_declaration);
                        if (!(r2.parent.kind === 257 && e2.hasSyntacticModifier(r2.parent, 128)))
                          return Tt(Me, e2.Diagnostics.Abstract_methods_can_only_appear_within_an_abstract_class);
                        if (h2 & 32)
                          return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "static", "abstract");
                        if (h2 & 8)
                          return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "private", "abstract");
                        if (h2 & 256 && s2)
                          return Tt(s2, e2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
                        if (h2 & 16384)
                          return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "abstract", "override");
                      }
                      if (e2.isNamedDeclaration(r2) && r2.name.kind === 80)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_with_a_private_identifier, "abstract");
                      h2 |= 128;
                      break;
                    case 131:
                      if (h2 & 256)
                        return Tt(Me, e2.Diagnostics._0_modifier_already_seen, "async");
                      if (h2 & 2 || r2.parent.flags & 16777216)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_in_an_ambient_context, "async");
                      if (r2.kind === 164)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_appear_on_a_parameter, "async");
                      if (h2 & 128)
                        return Tt(Me, e2.Diagnostics._0_modifier_cannot_be_used_with_1_modifier, "async", "abstract");
                      h2 |= 256, s2 = Me;
                      break;
                    case 101:
                    case 144:
                      var dr = Me.kind === 101 ? 32768 : 65536, Dr = Me.kind === 101 ? "in" : "out";
                      if (r2.kind !== 163 || !(e2.isInterfaceDeclaration(r2.parent) || e2.isClassLike(r2.parent) || e2.isTypeAliasDeclaration(r2.parent)))
                        return Tt(Me, e2.Diagnostics._0_modifier_can_only_appear_on_a_type_parameter_of_a_class_interface_or_type_alias, Dr);
                      if (h2 & dr)
                        return Tt(Me, e2.Diagnostics._0_modifier_already_seen, Dr);
                      if (dr & 32768 && h2 & 65536)
                        return Tt(Me, e2.Diagnostics._0_modifier_must_precede_1_modifier, "in", "out");
                      h2 |= dr;
                      break;
                  }
                }
                return r2.kind === 171 ? h2 & 32 ? Tt(t2, e2.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "static") : h2 & 16384 ? Tt(u, e2.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "override") : h2 & 256 ? Tt(s2, e2.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration, "async") : false : (r2.kind === 266 || r2.kind === 265) && h2 & 2 ? Tt(o, e2.Diagnostics.A_0_modifier_cannot_be_used_with_an_import_declaration, "declare") : r2.kind === 164 && h2 & 16476 && e2.isBindingPattern(r2.name) ? Tt(r2, e2.Diagnostics.A_parameter_property_may_not_be_declared_using_a_binding_pattern) : r2.kind === 164 && h2 & 16476 && r2.dotDotDotToken ? Tt(r2, e2.Diagnostics.A_parameter_property_cannot_be_declared_using_a_rest_parameter) : h2 & 256 ? z9(r2, s2) : false;
              }
              function j9(r2) {
                return r2.modifiers ? U9(r2) ? Hs(r2, e2.Diagnostics.Modifiers_cannot_appear_here) : void 0 : false;
              }
              function U9(r2) {
                switch (r2.kind) {
                  case 172:
                  case 173:
                  case 171:
                  case 167:
                  case 166:
                  case 169:
                  case 168:
                  case 176:
                  case 261:
                  case 266:
                  case 265:
                  case 272:
                  case 271:
                  case 213:
                  case 214:
                  case 164:
                  case 163:
                    return false;
                  default:
                    if (r2.parent.kind === 262 || r2.parent.kind === 305)
                      return false;
                    switch (r2.kind) {
                      case 256:
                        return zS(r2, 131);
                      case 257:
                      case 180:
                        return zS(r2, 126);
                      case 258:
                      case 237:
                      case 259:
                      case 170:
                        return true;
                      case 260:
                        return zS(r2, 85);
                      default:
                        e2.Debug.fail();
                    }
                }
              }
              function zS(r2, i2) {
                return r2.modifiers.length > 1 || r2.modifiers[0].kind !== i2;
              }
              function z9(r2, i2) {
                switch (r2.kind) {
                  case 169:
                  case 256:
                  case 213:
                  case 214:
                    return false;
                }
                return Tt(i2, e2.Diagnostics._0_modifier_cannot_be_used_here, "async");
              }
              function ng(r2, i2) {
                return i2 === void 0 && (i2 = e2.Diagnostics.Trailing_comma_not_allowed), r2 && r2.hasTrailingComma ? rd(r2[0], r2.end - 1, 1, i2) : false;
              }
              function cA(r2, i2) {
                if (r2 && r2.length === 0) {
                  var t2 = r2.pos - 1, o = e2.skipTrivia(i2.text, r2.end) + 1;
                  return rd(i2, t2, o - t2, e2.Diagnostics.Type_parameter_list_cannot_be_empty);
                }
                return false;
              }
              function W9(r2) {
                for (var i2 = false, t2 = r2.length, o = 0; o < t2; o++) {
                  var s2 = r2[o];
                  if (s2.dotDotDotToken) {
                    if (o !== t2 - 1)
                      return Tt(s2.dotDotDotToken, e2.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list);
                    if (s2.flags & 16777216 || ng(r2, e2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma), s2.questionToken)
                      return Tt(s2.questionToken, e2.Diagnostics.A_rest_parameter_cannot_be_optional);
                    if (s2.initializer)
                      return Tt(s2.name, e2.Diagnostics.A_rest_parameter_cannot_have_an_initializer);
                  } else if (kd(s2)) {
                    if (i2 = true, s2.questionToken && s2.initializer)
                      return Tt(s2.name, e2.Diagnostics.Parameter_cannot_have_question_mark_and_initializer);
                  } else if (i2 && !s2.initializer)
                    return Tt(s2.name, e2.Diagnostics.A_required_parameter_cannot_follow_an_optional_parameter);
                }
              }
              function q9(r2) {
                return e2.filter(r2, function(i2) {
                  return !!i2.initializer || e2.isBindingPattern(i2.name) || e2.isRestParameter(i2);
                });
              }
              function V9(r2) {
                if (Ae >= 3) {
                  var i2 = r2.body && e2.isBlock(r2.body) && e2.findUseStrictPrologue(r2.body.statements);
                  if (i2) {
                    var t2 = q9(r2.parameters);
                    if (e2.length(t2)) {
                      e2.forEach(t2, function(s2) {
                        e2.addRelatedInfo(Xr(s2, e2.Diagnostics.This_parameter_is_not_allowed_with_use_strict_directive), e2.createDiagnosticForNode(i2, e2.Diagnostics.use_strict_directive_used_here));
                      });
                      var o = t2.map(function(s2, u) {
                        return u === 0 ? e2.createDiagnosticForNode(s2, e2.Diagnostics.Non_simple_parameter_declared_here) : e2.createDiagnosticForNode(s2, e2.Diagnostics.and_here);
                      });
                      return e2.addRelatedInfo.apply(void 0, Ve([Xr(i2, e2.Diagnostics.use_strict_directive_cannot_be_used_with_non_simple_parameter_list)], o, false)), true;
                    }
                  }
                }
                return false;
              }
              function X0(r2) {
                var i2 = e2.getSourceFileOfNode(r2);
                return Ff(r2) || cA(r2.typeParameters, i2) || W9(r2.parameters) || G9(r2, i2) || e2.isFunctionLikeDeclaration(r2) && V9(r2);
              }
              function K9(r2) {
                var i2 = e2.getSourceFileOfNode(r2);
                return $9(r2) || cA(r2.typeParameters, i2);
              }
              function G9(r2, i2) {
                if (!e2.isArrowFunction(r2))
                  return false;
                r2.typeParameters && !(e2.length(r2.typeParameters) > 1 || r2.typeParameters.hasTrailingComma || r2.typeParameters[0].constraint) && i2 && e2.fileExtensionIsOneOf(i2.fileName, [".mts", ".cts"]) && Tt(r2.typeParameters[0], e2.Diagnostics.This_syntax_is_reserved_in_files_with_the_mts_or_cts_extension_Add_a_trailing_comma_or_explicit_constraint);
                var t2 = r2.equalsGreaterThanToken, o = e2.getLineAndCharacterOfPosition(i2, t2.pos).line, s2 = e2.getLineAndCharacterOfPosition(i2, t2.end).line;
                return o !== s2 && Tt(t2, e2.Diagnostics.Line_terminator_not_permitted_before_arrow);
              }
              function H9(r2) {
                var i2 = r2.parameters[0];
                if (r2.parameters.length !== 1)
                  return Tt(i2 ? i2.name : r2, e2.Diagnostics.An_index_signature_must_have_exactly_one_parameter);
                if (ng(r2.parameters, e2.Diagnostics.An_index_signature_cannot_have_a_trailing_comma), i2.dotDotDotToken)
                  return Tt(i2.dotDotDotToken, e2.Diagnostics.An_index_signature_cannot_have_a_rest_parameter);
                if (e2.hasEffectiveModifiers(i2))
                  return Tt(i2.name, e2.Diagnostics.An_index_signature_parameter_cannot_have_an_accessibility_modifier);
                if (i2.questionToken)
                  return Tt(i2.questionToken, e2.Diagnostics.An_index_signature_parameter_cannot_have_a_question_mark);
                if (i2.initializer)
                  return Tt(i2.name, e2.Diagnostics.An_index_signature_parameter_cannot_have_an_initializer);
                if (!i2.type)
                  return Tt(i2.name, e2.Diagnostics.An_index_signature_parameter_must_have_a_type_annotation);
                var t2 = Va(i2.type);
                return rg(t2, function(o) {
                  return !!(o.flags & 8576);
                }) || rv(t2) ? Tt(i2.name, e2.Diagnostics.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead) : gf(t2, vh) ? r2.type ? false : Tt(r2, e2.Diagnostics.An_index_signature_must_have_a_type_annotation) : Tt(i2.name, e2.Diagnostics.An_index_signature_parameter_type_must_be_string_number_symbol_or_a_template_literal_type);
              }
              function X9(r2) {
                return Ff(r2) || H9(r2);
              }
              function Q9(r2, i2) {
                if (i2 && i2.length === 0) {
                  var t2 = e2.getSourceFileOfNode(r2), o = i2.pos - 1, s2 = e2.skipTrivia(t2.text, i2.end) + 1;
                  return rd(t2, o, s2 - o, e2.Diagnostics.Type_argument_list_cannot_be_empty);
                }
                return false;
              }
              function Wy(r2, i2) {
                return ng(i2) || Q9(r2, i2);
              }
              function Y9(r2) {
                return r2.questionDotToken || r2.flags & 32 ? Tt(r2.template, e2.Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain) : false;
              }
              function uA(r2) {
                var i2 = r2.types;
                if (ng(i2))
                  return true;
                if (i2 && i2.length === 0) {
                  var t2 = e2.tokenToString(r2.token);
                  return rd(r2, i2.pos, 0, e2.Diagnostics._0_list_cannot_be_empty, t2);
                }
                return e2.some(i2, lA);
              }
              function lA(r2) {
                return e2.isExpressionWithTypeArguments(r2) && e2.isImportKeyword(r2.expression) && r2.typeArguments ? Tt(r2, e2.Diagnostics.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments) : Wy(r2, r2.typeArguments);
              }
              function $9(r2) {
                var i2 = false, t2 = false;
                if (!Ff(r2) && r2.heritageClauses)
                  for (var o = 0, s2 = r2.heritageClauses; o < s2.length; o++) {
                    var u = s2[o];
                    if (u.token === 94) {
                      if (i2)
                        return Hs(u, e2.Diagnostics.extends_clause_already_seen);
                      if (t2)
                        return Hs(u, e2.Diagnostics.extends_clause_must_precede_implements_clause);
                      if (u.types.length > 1)
                        return Hs(u.types[1], e2.Diagnostics.Classes_can_only_extend_a_single_class);
                      i2 = true;
                    } else {
                      if (e2.Debug.assert(u.token === 117), t2)
                        return Hs(u, e2.Diagnostics.implements_clause_already_seen);
                      t2 = true;
                    }
                    uA(u);
                  }
              }
              function Z9(r2) {
                var i2 = false;
                if (r2.heritageClauses)
                  for (var t2 = 0, o = r2.heritageClauses; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (s2.token === 94) {
                      if (i2)
                        return Hs(s2, e2.Diagnostics.extends_clause_already_seen);
                      i2 = true;
                    } else
                      return e2.Debug.assert(s2.token === 117), Hs(s2, e2.Diagnostics.Interface_declaration_cannot_have_implements_clause);
                    uA(s2);
                  }
                return false;
              }
              function Q0(r2) {
                if (r2.kind !== 162)
                  return false;
                var i2 = r2;
                return i2.expression.kind === 221 && i2.expression.operatorToken.kind === 27 ? Tt(i2.expression, e2.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name) : false;
              }
              function WS(r2) {
                if (r2.asteriskToken) {
                  if (e2.Debug.assert(r2.kind === 256 || r2.kind === 213 || r2.kind === 169), r2.flags & 16777216)
                    return Tt(r2.asteriskToken, e2.Diagnostics.Generators_are_not_allowed_in_an_ambient_context);
                  if (!r2.body)
                    return Tt(r2.asteriskToken, e2.Diagnostics.An_overload_signature_cannot_be_declared_as_a_generator);
                }
              }
              function fA(r2, i2) {
                return !!r2 && Tt(r2, i2);
              }
              function _A(r2, i2) {
                return !!r2 && Tt(r2, i2);
              }
              function eL(r2, i2) {
                for (var t2 = new e2.Map(), o = 0, s2 = r2.properties; o < s2.length; o++) {
                  var u = s2[o];
                  if (u.kind === 298) {
                    if (i2) {
                      var h2 = e2.skipParentheses(u.expression);
                      if (e2.isArrayLiteralExpression(h2) || e2.isObjectLiteralExpression(h2))
                        return Tt(u.expression, e2.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern);
                    }
                    continue;
                  }
                  var z = u.name;
                  if (z.kind === 162 && Q0(z), u.kind === 297 && !i2 && u.objectAssignmentInitializer && Tt(u.equalsToken, e2.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern), z.kind === 80 && Tt(z, e2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies), u.modifiers)
                    for (var me = 0, Me = u.modifiers; me < Me.length; me++) {
                      var $e = Me[me];
                      ($e.kind !== 131 || u.kind !== 169) && Tt($e, e2.Diagnostics._0_modifier_cannot_be_used_here, e2.getTextOfNode($e));
                    }
                  var tr = void 0;
                  switch (u.kind) {
                    case 297:
                      _A(u.exclamationToken, e2.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context);
                    case 296:
                      fA(u.questionToken, e2.Diagnostics.An_object_member_cannot_be_declared_optional), z.kind === 8 && KS(z), tr = 4;
                      break;
                    case 169:
                      tr = 8;
                      break;
                    case 172:
                      tr = 1;
                      break;
                    case 173:
                      tr = 2;
                      break;
                    default:
                      throw e2.Debug.assertNever(u, "Unexpected syntax kind:" + u.kind);
                  }
                  if (!i2) {
                    var dr = e2.getPropertyNameForPropertyNameNode(z);
                    if (dr === void 0)
                      continue;
                    var Dr = t2.get(dr);
                    if (!Dr)
                      t2.set(dr, tr);
                    else if (tr & 8 && Dr & 8)
                      Tt(z, e2.Diagnostics.Duplicate_identifier_0, e2.getTextOfNode(z));
                    else if (tr & 4 && Dr & 4)
                      Tt(z, e2.Diagnostics.An_object_literal_cannot_have_multiple_properties_with_the_same_name, e2.getTextOfNode(z));
                    else if (tr & 3 && Dr & 3)
                      if (Dr !== 3 && tr !== Dr)
                        t2.set(dr, tr | Dr);
                      else
                        return Tt(z, e2.Diagnostics.An_object_literal_cannot_have_multiple_get_Slashset_accessors_with_the_same_name);
                    else
                      return Tt(z, e2.Diagnostics.An_object_literal_cannot_have_property_and_accessor_with_the_same_name);
                  }
                }
              }
              function rL(r2) {
                iL(r2.tagName), Wy(r2, r2.typeArguments);
                for (var i2 = new e2.Map(), t2 = 0, o = r2.attributes.properties; t2 < o.length; t2++) {
                  var s2 = o[t2];
                  if (s2.kind !== 287) {
                    var u = s2.name, h2 = s2.initializer;
                    if (!i2.get(u.escapedText))
                      i2.set(u.escapedText, true);
                    else
                      return Tt(u, e2.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name);
                    if (h2 && h2.kind === 288 && !h2.expression)
                      return Tt(h2, e2.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression);
                  }
                }
              }
              function iL(r2) {
                if (e2.isPropertyAccessExpression(r2)) {
                  var i2 = r2;
                  do {
                    var t2 = s2(i2.name);
                    if (t2)
                      return t2;
                    i2 = i2.expression;
                  } while (e2.isPropertyAccessExpression(i2));
                  var o = s2(i2);
                  if (o)
                    return o;
                }
                function s2(u) {
                  if (e2.isIdentifier(u) && e2.idText(u).indexOf(":") !== -1)
                    return Tt(u, e2.Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names);
                }
              }
              function tL(r2) {
                if (r2.expression && e2.isCommaSequence(r2.expression))
                  return Tt(r2.expression, e2.Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array);
              }
              function pA(r2) {
                if (Mf(r2))
                  return true;
                if (r2.kind === 244 && r2.awaitModifier && !(r2.flags & 32768)) {
                  var i2 = e2.getSourceFileOfNode(r2);
                  if (e2.isInTopLevelContext(r2)) {
                    if (!Jd(i2))
                      switch (e2.isEffectiveExternalModule(i2, ye) || rn.add(e2.createDiagnosticForNode(r2.awaitModifier, e2.Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module)), er) {
                        case e2.ModuleKind.Node16:
                        case e2.ModuleKind.NodeNext:
                          if (i2.impliedNodeFormat === e2.ModuleKind.CommonJS) {
                            rn.add(e2.createDiagnosticForNode(r2.awaitModifier, e2.Diagnostics.The_current_file_is_a_CommonJS_module_and_cannot_use_await_at_the_top_level));
                            break;
                          }
                        case e2.ModuleKind.ES2022:
                        case e2.ModuleKind.ESNext:
                        case e2.ModuleKind.System:
                          if (Ae >= 4)
                            break;
                        default:
                          rn.add(e2.createDiagnosticForNode(r2.awaitModifier, e2.Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher));
                          break;
                      }
                  } else if (!Jd(i2)) {
                    var t2 = e2.createDiagnosticForNode(r2.awaitModifier, e2.Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules), o = e2.getContainingFunction(r2);
                    if (o && o.kind !== 171) {
                      e2.Debug.assert((e2.getFunctionFlags(o) & 2) === 0, "Enclosing function should never be an async function.");
                      var s2 = e2.createDiagnosticForNode(o, e2.Diagnostics.Did_you_mean_to_mark_this_function_as_async);
                      e2.addRelatedInfo(t2, s2);
                    }
                    return rn.add(t2), true;
                  }
                  return false;
                }
                if (e2.isForOfStatement(r2) && !(r2.flags & 32768) && e2.isIdentifier(r2.initializer) && r2.initializer.escapedText === "async")
                  return Tt(r2.initializer, e2.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_async), false;
                if (r2.initializer.kind === 255) {
                  var u = r2.initializer;
                  if (!VS(u)) {
                    var h2 = u.declarations;
                    if (!h2.length)
                      return false;
                    if (h2.length > 1) {
                      var t2 = r2.kind === 243 ? e2.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement : e2.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement;
                      return Hs(u.declarations[1], t2);
                    }
                    var z = h2[0];
                    if (z.initializer) {
                      var t2 = r2.kind === 243 ? e2.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer : e2.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer;
                      return Tt(z.name, t2);
                    }
                    if (z.type) {
                      var t2 = r2.kind === 243 ? e2.Diagnostics.The_left_hand_side_of_a_for_in_statement_cannot_use_a_type_annotation : e2.Diagnostics.The_left_hand_side_of_a_for_of_statement_cannot_use_a_type_annotation;
                      return Tt(z, t2);
                    }
                  }
                }
                return false;
              }
              function aL(r2) {
                if (!(r2.flags & 16777216) && r2.parent.kind !== 182 && r2.parent.kind !== 258) {
                  if (Ae < 1)
                    return Tt(r2.name, e2.Diagnostics.Accessors_are_only_available_when_targeting_ECMAScript_5_and_higher);
                  if (Ae < 2 && e2.isPrivateIdentifier(r2.name))
                    return Tt(r2.name, e2.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
                  if (r2.body === void 0 && !e2.hasSyntacticModifier(r2, 128))
                    return rd(r2, r2.end - 1, 1, e2.Diagnostics._0_expected, "{");
                }
                if (r2.body) {
                  if (e2.hasSyntacticModifier(r2, 128))
                    return Tt(r2, e2.Diagnostics.An_abstract_accessor_cannot_have_an_implementation);
                  if (r2.parent.kind === 182 || r2.parent.kind === 258)
                    return Tt(r2.body, e2.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
                }
                if (r2.typeParameters)
                  return Tt(r2.name, e2.Diagnostics.An_accessor_cannot_have_type_parameters);
                if (!nL(r2))
                  return Tt(r2.name, r2.kind === 172 ? e2.Diagnostics.A_get_accessor_cannot_have_parameters : e2.Diagnostics.A_set_accessor_must_have_exactly_one_parameter);
                if (r2.kind === 173) {
                  if (r2.type)
                    return Tt(r2.name, e2.Diagnostics.A_set_accessor_cannot_have_a_return_type_annotation);
                  var i2 = e2.Debug.checkDefined(e2.getSetAccessorValueParameter(r2), "Return value does not match parameter count assertion.");
                  if (i2.dotDotDotToken)
                    return Tt(i2.dotDotDotToken, e2.Diagnostics.A_set_accessor_cannot_have_rest_parameter);
                  if (i2.questionToken)
                    return Tt(i2.questionToken, e2.Diagnostics.A_set_accessor_cannot_have_an_optional_parameter);
                  if (i2.initializer)
                    return Tt(r2.name, e2.Diagnostics.A_set_accessor_parameter_cannot_have_an_initializer);
                }
                return false;
              }
              function nL(r2) {
                return qS(r2) || r2.parameters.length === (r2.kind === 172 ? 0 : 1);
              }
              function qS(r2) {
                if (r2.parameters.length === (r2.kind === 172 ? 1 : 2))
                  return e2.getThisParameter(r2);
              }
              function oL(r2) {
                if (r2.operator === 154) {
                  if (r2.type.kind !== 151)
                    return Tt(r2.type, e2.Diagnostics._0_expected, e2.tokenToString(151));
                  var i2 = e2.walkUpParenthesizedTypes(r2.parent);
                  if (e2.isInJSFile(i2) && e2.isJSDocTypeExpression(i2)) {
                    var t2 = e2.getJSDocHost(i2);
                    t2 && (i2 = e2.getSingleVariableOfVariableStatement(t2) || t2);
                  }
                  switch (i2.kind) {
                    case 254:
                      var o = i2;
                      if (o.name.kind !== 79)
                        return Tt(r2, e2.Diagnostics.unique_symbol_types_may_not_be_used_on_a_variable_declaration_with_a_binding_name);
                      if (!e2.isVariableDeclarationInVariableStatement(o))
                        return Tt(r2, e2.Diagnostics.unique_symbol_types_are_only_allowed_on_variables_in_a_variable_statement);
                      if (!(o.parent.flags & 2))
                        return Tt(i2.name, e2.Diagnostics.A_variable_whose_type_is_a_unique_symbol_type_must_be_const);
                      break;
                    case 167:
                      if (!e2.isStatic(i2) || !e2.hasEffectiveReadonlyModifier(i2))
                        return Tt(i2.name, e2.Diagnostics.A_property_of_a_class_whose_type_is_a_unique_symbol_type_must_be_both_static_and_readonly);
                      break;
                    case 166:
                      if (!e2.hasSyntacticModifier(i2, 64))
                        return Tt(i2.name, e2.Diagnostics.A_property_of_an_interface_or_type_literal_whose_type_is_a_unique_symbol_type_must_be_readonly);
                      break;
                    default:
                      return Tt(r2, e2.Diagnostics.unique_symbol_types_are_not_allowed_here);
                  }
                } else if (r2.operator === 145 && r2.type.kind !== 183 && r2.type.kind !== 184)
                  return Hs(r2, e2.Diagnostics.readonly_type_modifier_is_only_permitted_on_array_and_tuple_literal_types, e2.tokenToString(151));
              }
              function Em(r2, i2) {
                if (I1(r2))
                  return Tt(r2, i2);
              }
              function dA(r2) {
                if (X0(r2))
                  return true;
                if (r2.kind === 169) {
                  if (r2.parent.kind === 205) {
                    if (r2.modifiers && !(r2.modifiers.length === 1 && e2.first(r2.modifiers).kind === 131))
                      return Hs(r2, e2.Diagnostics.Modifiers_cannot_appear_here);
                    if (fA(r2.questionToken, e2.Diagnostics.An_object_member_cannot_be_declared_optional))
                      return true;
                    if (_A(r2.exclamationToken, e2.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context))
                      return true;
                    if (r2.body === void 0)
                      return rd(r2, r2.end - 1, 1, e2.Diagnostics._0_expected, "{");
                  }
                  if (WS(r2))
                    return true;
                }
                if (e2.isClassLike(r2.parent)) {
                  if (Ae < 2 && e2.isPrivateIdentifier(r2.name))
                    return Tt(r2.name, e2.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
                  if (r2.flags & 16777216)
                    return Em(r2.name, e2.Diagnostics.A_computed_property_name_in_an_ambient_context_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
                  if (r2.kind === 169 && !r2.body)
                    return Em(r2.name, e2.Diagnostics.A_computed_property_name_in_a_method_overload_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
                } else {
                  if (r2.parent.kind === 258)
                    return Em(r2.name, e2.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
                  if (r2.parent.kind === 182)
                    return Em(r2.name, e2.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type);
                }
              }
              function sL(r2) {
                for (var i2 = r2; i2; ) {
                  if (e2.isFunctionLikeOrClassStaticBlockDeclaration(i2))
                    return Tt(r2, e2.Diagnostics.Jump_target_cannot_cross_function_boundary);
                  switch (i2.kind) {
                    case 250:
                      if (r2.label && i2.label.escapedText === r2.label.escapedText) {
                        var t2 = r2.kind === 245 && !e2.isIterationStatement(i2.statement, true);
                        return t2 ? Tt(r2, e2.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement) : false;
                      }
                      break;
                    case 249:
                      if (r2.kind === 246 && !r2.label)
                        return false;
                      break;
                    default:
                      if (e2.isIterationStatement(i2, false) && !r2.label)
                        return false;
                      break;
                  }
                  i2 = i2.parent;
                }
                if (r2.label) {
                  var o = r2.kind === 246 ? e2.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement : e2.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement;
                  return Tt(r2, o);
                } else {
                  var o = r2.kind === 246 ? e2.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement : e2.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement;
                  return Tt(r2, o);
                }
              }
              function cL(r2) {
                if (r2.dotDotDotToken) {
                  var i2 = r2.parent.elements;
                  if (r2 !== e2.last(i2))
                    return Tt(r2, e2.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern);
                  if (ng(i2, e2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma), r2.propertyName)
                    return Tt(r2.name, e2.Diagnostics.A_rest_element_cannot_have_a_property_name);
                }
                if (r2.dotDotDotToken && r2.initializer)
                  return rd(r2, r2.initializer.pos - 1, 1, e2.Diagnostics.A_rest_element_cannot_have_an_initializer);
              }
              function gA(r2) {
                return e2.isStringOrNumericLiteralLike(r2) || r2.kind === 219 && r2.operator === 40 && r2.operand.kind === 8;
              }
              function uL(r2) {
                return r2.kind === 9 || r2.kind === 219 && r2.operator === 40 && r2.operand.kind === 9;
              }
              function lL(r2) {
                if ((e2.isPropertyAccessExpression(r2) || e2.isElementAccessExpression(r2) && gA(r2.argumentExpression)) && e2.isEntityNameExpression(r2.expression))
                  return !!(Os(r2).flags & 1024);
              }
              function mA(r2) {
                var i2 = r2.initializer;
                if (i2) {
                  var t2 = !(gA(i2) || lL(i2) || i2.kind === 110 || i2.kind === 95 || uL(i2)), o = e2.isDeclarationReadonly(r2) || e2.isVariableDeclaration(r2) && e2.isVarConst(r2);
                  if (o && !r2.type) {
                    if (t2)
                      return Tt(i2, e2.Diagnostics.A_const_initializer_in_an_ambient_context_must_be_a_string_or_numeric_literal_or_literal_enum_reference);
                  } else
                    return Tt(i2, e2.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
                  if (!o || t2)
                    return Tt(i2, e2.Diagnostics.Initializers_are_not_allowed_in_ambient_contexts);
                }
              }
              function fL(r2) {
                if (r2.parent.parent.kind !== 243 && r2.parent.parent.kind !== 244) {
                  if (r2.flags & 16777216)
                    mA(r2);
                  else if (!r2.initializer) {
                    if (e2.isBindingPattern(r2.name) && !e2.isBindingPattern(r2.parent))
                      return Tt(r2, e2.Diagnostics.A_destructuring_declaration_must_have_an_initializer);
                    if (e2.isVarConst(r2))
                      return Tt(r2, e2.Diagnostics.const_declarations_must_be_initialized);
                  }
                }
                if (r2.exclamationToken && (r2.parent.parent.kind !== 237 || !r2.type || r2.initializer || r2.flags & 16777216)) {
                  var i2 = r2.initializer ? e2.Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : r2.type ? e2.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context : e2.Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations;
                  return Tt(r2.exclamationToken, i2);
                }
                (er < e2.ModuleKind.ES2015 || e2.getSourceFileOfNode(r2).impliedNodeFormat === e2.ModuleKind.CommonJS) && er !== e2.ModuleKind.System && !(r2.parent.parent.flags & 16777216) && e2.hasSyntacticModifier(r2.parent.parent, 1) && vA(r2.name);
                var t2 = e2.isLet(r2) || e2.isVarConst(r2);
                return t2 && yA(r2.name);
              }
              function vA(r2) {
                if (r2.kind === 79) {
                  if (e2.idText(r2) === "__esModule")
                    return dL("noEmit", r2, e2.Diagnostics.Identifier_expected_esModule_is_reserved_as_an_exported_marker_when_transforming_ECMAScript_modules);
                } else
                  for (var i2 = r2.elements, t2 = 0, o = i2; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    if (!e2.isOmittedExpression(s2))
                      return vA(s2.name);
                  }
                return false;
              }
              function yA(r2) {
                if (r2.kind === 79) {
                  if (r2.originalKeywordKind === 119)
                    return Tt(r2, e2.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations);
                } else
                  for (var i2 = r2.elements, t2 = 0, o = i2; t2 < o.length; t2++) {
                    var s2 = o[t2];
                    e2.isOmittedExpression(s2) || yA(s2.name);
                  }
                return false;
              }
              function VS(r2) {
                var i2 = r2.declarations;
                return ng(r2.declarations) ? true : r2.declarations.length ? false : rd(r2, i2.pos, i2.end - i2.pos, e2.Diagnostics.Variable_declaration_list_cannot_be_empty);
              }
              function hA(r2) {
                switch (r2.kind) {
                  case 239:
                  case 240:
                  case 241:
                  case 248:
                  case 242:
                  case 243:
                  case 244:
                    return false;
                  case 250:
                    return hA(r2.parent);
                }
                return true;
              }
              function _L(r2) {
                if (!hA(r2.parent)) {
                  if (e2.isLet(r2.declarationList))
                    return Tt(r2, e2.Diagnostics.let_declarations_can_only_be_declared_inside_a_block);
                  if (e2.isVarConst(r2.declarationList))
                    return Tt(r2, e2.Diagnostics.const_declarations_can_only_be_declared_inside_a_block);
                }
              }
              function pL(r2) {
                var i2 = r2.name.escapedText;
                switch (r2.keywordToken) {
                  case 103:
                    if (i2 !== "target")
                      return Tt(r2.name, e2.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, r2.name.escapedText, e2.tokenToString(r2.keywordToken), "target");
                    break;
                  case 100:
                    if (i2 !== "meta")
                      return Tt(r2.name, e2.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2, r2.name.escapedText, e2.tokenToString(r2.keywordToken), "meta");
                    break;
                }
              }
              function Jd(r2) {
                return r2.parseDiagnostics.length > 0;
              }
              function Hs(r2, i2, t2, o, s2) {
                var u = e2.getSourceFileOfNode(r2);
                if (!Jd(u)) {
                  var h2 = e2.getSpanOfTokenAtPosition(u, r2.pos);
                  return rn.add(e2.createFileDiagnostic(u, h2.start, h2.length, i2, t2, o, s2)), true;
                }
                return false;
              }
              function rd(r2, i2, t2, o, s2, u, h2) {
                var z = e2.getSourceFileOfNode(r2);
                return Jd(z) ? false : (rn.add(e2.createFileDiagnostic(z, i2, t2, o, s2, u, h2)), true);
              }
              function dL(r2, i2, t2, o, s2, u) {
                var h2 = e2.getSourceFileOfNode(i2);
                return Jd(h2) ? false : (Es(r2, i2, t2, o, s2, u), true);
              }
              function Tt(r2, i2, t2, o, s2) {
                var u = e2.getSourceFileOfNode(r2);
                return Jd(u) ? false : (rn.add(e2.createDiagnosticForNode(r2, i2, t2, o, s2)), true);
              }
              function gL(r2) {
                var i2 = e2.isInJSFile(r2) ? e2.getJSDocTypeParameterDeclarations(r2) : void 0, t2 = r2.typeParameters || i2 && e2.firstOrUndefined(i2);
                if (t2) {
                  var o = t2.pos === t2.end ? t2.pos : e2.skipTrivia(e2.getSourceFileOfNode(r2).text, t2.pos);
                  return rd(r2, o, t2.end - o, e2.Diagnostics.Type_parameters_cannot_appear_on_a_constructor_declaration);
                }
              }
              function mL(r2) {
                var i2 = e2.getEffectiveReturnTypeNode(r2);
                if (i2)
                  return Tt(i2, e2.Diagnostics.Type_annotation_cannot_appear_on_a_constructor_declaration);
              }
              function vL(r2) {
                if (e2.isComputedPropertyName(r2.name) && e2.isBinaryExpression(r2.name.expression) && r2.name.expression.operatorToken.kind === 101)
                  return Tt(r2.parent.members[0], e2.Diagnostics.A_mapped_type_may_not_declare_properties_or_methods);
                if (e2.isClassLike(r2.parent)) {
                  if (e2.isStringLiteral(r2.name) && r2.name.text === "constructor")
                    return Tt(r2.name, e2.Diagnostics.Classes_may_not_have_a_field_named_constructor);
                  if (Em(r2.name, e2.Diagnostics.A_computed_property_name_in_a_class_property_declaration_must_have_a_simple_literal_type_or_a_unique_symbol_type))
                    return true;
                  if (Ae < 2 && e2.isPrivateIdentifier(r2.name))
                    return Tt(r2.name, e2.Diagnostics.Private_identifiers_are_only_available_when_targeting_ECMAScript_2015_and_higher);
                } else if (r2.parent.kind === 258) {
                  if (Em(r2.name, e2.Diagnostics.A_computed_property_name_in_an_interface_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))
                    return true;
                  if (r2.initializer)
                    return Tt(r2.initializer, e2.Diagnostics.An_interface_property_cannot_have_an_initializer);
                } else if (e2.isTypeLiteralNode(r2.parent)) {
                  if (Em(r2.name, e2.Diagnostics.A_computed_property_name_in_a_type_literal_must_refer_to_an_expression_whose_type_is_a_literal_type_or_a_unique_symbol_type))
                    return true;
                  if (r2.initializer)
                    return Tt(r2.initializer, e2.Diagnostics.A_type_literal_property_cannot_have_an_initializer);
                }
                if (r2.flags & 16777216 && mA(r2), e2.isPropertyDeclaration(r2) && r2.exclamationToken && (!e2.isClassLike(r2.parent) || !r2.type || r2.initializer || r2.flags & 16777216 || e2.isStatic(r2) || e2.hasAbstractModifier(r2))) {
                  var i2 = r2.initializer ? e2.Diagnostics.Declarations_with_initializers_cannot_also_have_definite_assignment_assertions : r2.type ? e2.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context : e2.Diagnostics.Declarations_with_definite_assignment_assertions_must_also_have_type_annotations;
                  return Tt(r2.exclamationToken, i2);
                }
              }
              function yL(r2) {
                return r2.kind === 258 || r2.kind === 259 || r2.kind === 266 || r2.kind === 265 || r2.kind === 272 || r2.kind === 271 || r2.kind === 264 || e2.hasSyntacticModifier(r2, 515) ? false : Hs(r2, e2.Diagnostics.Top_level_declarations_in_d_ts_files_must_start_with_either_a_declare_or_export_modifier);
              }
              function hL(r2) {
                for (var i2 = 0, t2 = r2.statements; i2 < t2.length; i2++) {
                  var o = t2[i2];
                  if ((e2.isDeclaration(o) || o.kind === 237) && yL(o))
                    return true;
                }
                return false;
              }
              function DL(r2) {
                return !!(r2.flags & 16777216) && hL(r2);
              }
              function Mf(r2) {
                if (r2.flags & 16777216) {
                  var i2 = va(r2);
                  if (!i2.hasReportedStatementInAmbientContext && (e2.isFunctionLike(r2.parent) || e2.isAccessor(r2.parent)))
                    return va(r2).hasReportedStatementInAmbientContext = Hs(r2, e2.Diagnostics.An_implementation_cannot_be_declared_in_ambient_contexts);
                  if (r2.parent.kind === 235 || r2.parent.kind === 262 || r2.parent.kind === 305) {
                    var t2 = va(r2.parent);
                    if (!t2.hasReportedStatementInAmbientContext)
                      return t2.hasReportedStatementInAmbientContext = Hs(r2, e2.Diagnostics.Statements_are_not_allowed_in_ambient_contexts);
                  }
                }
                return false;
              }
              function KS(r2) {
                if (r2.numericLiteralFlags & 32) {
                  var i2 = void 0;
                  if (Ae >= 1 ? i2 = e2.Diagnostics.Octal_literals_are_not_available_when_targeting_ECMAScript_5_and_higher_Use_the_syntax_0 : e2.isChildOfNodeWithKind(r2, 196) ? i2 = e2.Diagnostics.Octal_literal_types_must_use_ES2015_syntax_Use_the_syntax_0 : e2.isChildOfNodeWithKind(r2, 299) && (i2 = e2.Diagnostics.Octal_literals_are_not_allowed_in_enums_members_initializer_Use_the_syntax_0), i2) {
                    var t2 = e2.isPrefixUnaryExpression(r2.parent) && r2.parent.operator === 40, o = (t2 ? "-" : "") + "0o" + r2.text;
                    return Tt(t2 ? r2.parent : r2, i2, o);
                  }
                }
                return bL(r2), false;
              }
              function bL(r2) {
                var i2 = e2.getTextOfNode(r2).indexOf(".") !== -1, t2 = r2.numericLiteralFlags & 16;
                if (!(i2 || t2)) {
                  var o = +r2.text;
                  o <= Math.pow(2, 53) - 1 || Ls(false, e2.createDiagnosticForNode(r2, e2.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers));
                }
              }
              function SL(r2) {
                var i2 = e2.isLiteralTypeNode(r2.parent) || e2.isPrefixUnaryExpression(r2.parent) && e2.isLiteralTypeNode(r2.parent.parent);
                return !!(!i2 && Ae < 7 && Tt(r2, e2.Diagnostics.BigInt_literals_are_not_available_when_targeting_lower_than_ES2020));
              }
              function TL(r2, i2, t2, o, s2) {
                var u = e2.getSourceFileOfNode(r2);
                if (!Jd(u)) {
                  var h2 = e2.getSpanOfTokenAtPosition(u, r2.pos);
                  return rn.add(e2.createFileDiagnostic(u, e2.textSpanEnd(h2), 0, i2, t2, o, s2)), true;
                }
                return false;
              }
              function xL() {
                return Gr || (Gr = [], ii.forEach(function(r2, i2) {
                  a.test(i2) && Gr.push(r2);
                })), Gr;
              }
              function EL(r2) {
                var i2;
                return r2.isTypeOnly && r2.name && r2.namedBindings ? Tt(r2, e2.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both) : r2.isTypeOnly && ((i2 = r2.namedBindings) === null || i2 === void 0 ? void 0 : i2.kind) === 269 ? DA(r2.namedBindings) : false;
              }
              function DA(r2) {
                return !!e2.forEach(r2.elements, function(i2) {
                  if (i2.isTypeOnly)
                    return Hs(i2, i2.kind === 270 ? e2.Diagnostics.The_type_modifier_cannot_be_used_on_a_named_import_when_import_type_is_used_on_its_import_statement : e2.Diagnostics.The_type_modifier_cannot_be_used_on_a_named_export_when_export_type_is_used_on_its_export_statement);
                });
              }
              function CL(r2) {
                if (er === e2.ModuleKind.ES2015)
                  return Tt(r2, e2.Diagnostics.Dynamic_imports_are_only_supported_when_the_module_flag_is_set_to_es2020_es2022_esnext_commonjs_amd_system_umd_node16_or_nodenext);
                if (r2.typeArguments)
                  return Tt(r2, e2.Diagnostics.This_use_of_import_is_invalid_import_calls_can_be_written_but_they_must_have_parentheses_and_cannot_have_type_arguments);
                var i2 = r2.arguments;
                if (er !== e2.ModuleKind.ESNext && er !== e2.ModuleKind.NodeNext && (ng(i2), i2.length > 1)) {
                  var t2 = i2[1];
                  return Tt(t2, e2.Diagnostics.Dynamic_imports_only_support_a_second_argument_when_the_module_option_is_set_to_esnext_node16_or_nodenext);
                }
                if (i2.length === 0 || i2.length > 2)
                  return Tt(r2, e2.Diagnostics.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments);
                var o = e2.find(i2, e2.isSpreadElement);
                return o ? Tt(o, e2.Diagnostics.Argument_of_dynamic_import_cannot_be_spread_element) : false;
              }
              function kL(r2, i2) {
                var t2 = e2.getObjectFlags(r2);
                if (t2 & 20 && i2.flags & 1048576)
                  return e2.find(i2.types, function(o) {
                    if (o.flags & 524288) {
                      var s2 = t2 & e2.getObjectFlags(o);
                      if (s2 & 4)
                        return r2.target === o.target;
                      if (s2 & 16)
                        return !!r2.aliasSymbol && r2.aliasSymbol === o.aliasSymbol;
                    }
                    return false;
                  });
              }
              function AL(r2, i2) {
                if (e2.getObjectFlags(r2) & 128 && rg(i2, sp))
                  return e2.find(i2.types, function(t2) {
                    return !sp(t2);
                  });
              }
              function NL(r2, i2) {
                var t2 = 0, o = ot(r2, t2).length > 0 || (t2 = 1, ot(r2, t2).length > 0);
                if (o)
                  return e2.find(i2.types, function(s2) {
                    return ot(s2, t2).length > 0;
                  });
              }
              function PL(r2, i2) {
                var t2;
                if (!(r2.flags & 406978556))
                  for (var o = 0, s2 = 0, u = i2.types; s2 < u.length; s2++) {
                    var h2 = u[s2];
                    if (!(h2.flags & 406978556)) {
                      var z = Do([ql(r2), ql(h2)]);
                      if (z.flags & 4194304)
                        return h2;
                      if (Vl(z) || z.flags & 1048576) {
                        var me = z.flags & 1048576 ? e2.countWhere(z.types, Vl) : 1;
                        me >= o && (t2 = h2, o = me);
                      }
                    }
                  }
                return t2;
              }
              function IL(r2) {
                if (fs4(r2, 67108864)) {
                  var i2 = ec(r2, function(t2) {
                    return !(t2.flags & 131068);
                  });
                  if (!(i2.flags & 131072))
                    return i2;
                }
                return r2;
              }
              function bA(r2, i2, t2, o) {
                if (i2.flags & 1048576 && r2.flags & 2621440) {
                  var s2 = $E(i2, r2);
                  if (s2)
                    return s2;
                  var u = uo(r2);
                  if (u) {
                    var h2 = YE(u, i2);
                    if (h2)
                      return UD(i2, e2.map(h2, function(z) {
                        return [function() {
                          return Jt(z);
                        }, z.escapedName];
                      }), t2, void 0, o);
                  }
                }
              }
            }
            e2.createTypeChecker = L;
            function P(l) {
              return !e2.isAccessor(l);
            }
            function k(l) {
              return l.kind !== 256 && l.kind !== 169 || !!l.body;
            }
            function Y(l) {
              switch (l.parent.kind) {
                case 270:
                case 275:
                  return e2.isIdentifier(l);
                default:
                  return e2.isDeclarationName(l);
              }
            }
            var U;
            (function(l) {
              l.JSX = "JSX", l.IntrinsicElements = "IntrinsicElements", l.ElementClass = "ElementClass", l.ElementAttributesPropertyNameContainer = "ElementAttributesProperty", l.ElementChildrenAttributeNameContainer = "ElementChildrenAttribute", l.Element = "Element", l.IntrinsicAttributes = "IntrinsicAttributes", l.IntrinsicClassAttributes = "IntrinsicClassAttributes", l.LibraryManagedAttributes = "LibraryManagedAttributes";
            })(U || (U = {}));
            function j(l) {
              switch (l) {
                case 0:
                  return "yieldType";
                case 1:
                  return "returnType";
                case 2:
                  return "nextType";
              }
            }
            function H(l) {
              return !!(l.flags & 1);
            }
            e2.signatureHasRestParameter = H;
            function I(l) {
              return !!(l.flags & 2);
            }
            e2.signatureHasLiteralTypes = I;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(f4, T, K, b) {
              if (f4 === void 0 || T === void 0)
                return f4;
              var se = T(f4);
              if (se === f4)
                return f4;
              var J;
              if (se !== void 0)
                return e2.isArray(se) ? J = (b || oe)(se) : J = se, e2.Debug.assertNode(J, K), J;
            }
            e2.visitNode = a;
            function C(f4, T, K, b, se) {
              if (f4 === void 0 || T === void 0)
                return f4;
              var J, ie = f4.length;
              (b === void 0 || b < 0) && (b = 0), (se === void 0 || se > ie - b) && (se = ie - b);
              var R, q = -1, O = -1;
              (b > 0 || se < ie) && (J = [], R = f4.hasTrailingComma && b + se === ie);
              for (var ve = 0; ve < se; ve++) {
                var ee = f4[ve + b], he = ee !== void 0 ? T(ee) : void 0;
                if ((J !== void 0 || he === void 0 || he !== ee) && (J === void 0 && (J = f4.slice(0, ve), R = f4.hasTrailingComma, q = f4.pos, O = f4.end), he))
                  if (e2.isArray(he))
                    for (var F2 = 0, x2 = he; F2 < x2.length; F2++) {
                      var X = x2[F2];
                      e2.Debug.assertNode(X, K), J.push(X);
                    }
                  else
                    e2.Debug.assertNode(he, K), J.push(he);
              }
              if (J) {
                var $ = e2.factory.createNodeArray(J, R);
                return e2.setTextRangePosEnd($, q, O), $;
              }
              return f4;
            }
            e2.visitNodes = C;
            function w(f4, T, K, b, se, J) {
              return J === void 0 && (J = C), K.startLexicalEnvironment(), f4 = J(f4, T, e2.isStatement, b), se && (f4 = K.factory.ensureUseStrict(f4)), e2.factory.mergeLexicalEnvironment(f4, K.endLexicalEnvironment());
            }
            e2.visitLexicalEnvironment = w;
            function B(f4, T, K, b) {
              b === void 0 && (b = C);
              var se;
              return K.startLexicalEnvironment(), f4 && (K.setLexicalEnvironmentFlags(1, true), se = b(f4, T, e2.isParameterDeclaration), K.getLexicalEnvironmentFlags() & 2 && e2.getEmitScriptTarget(K.getCompilerOptions()) >= 2 && (se = E(se, K)), K.setLexicalEnvironmentFlags(1, false)), K.suspendLexicalEnvironment(), se;
            }
            e2.visitParameterList = B;
            function E(f4, T) {
              for (var K, b = 0; b < f4.length; b++) {
                var se = f4[b], J = Q(se, T);
                (K || J !== se) && (K || (K = f4.slice(0, b)), K[b] = J);
              }
              return K ? e2.setTextRange(T.factory.createNodeArray(K, f4.hasTrailingComma), f4) : f4;
            }
            function Q(f4, T) {
              return f4.dotDotDotToken ? f4 : e2.isBindingPattern(f4.name) ? le(f4, T) : f4.initializer ? N(f4, f4.name, f4.initializer, T) : f4;
            }
            function le(f4, T) {
              var K = T.factory;
              return T.addInitializationStatement(K.createVariableStatement(void 0, K.createVariableDeclarationList([K.createVariableDeclaration(f4.name, void 0, f4.type, f4.initializer ? K.createConditionalExpression(K.createStrictEquality(K.getGeneratedNameForNode(f4), K.createVoidZero()), void 0, f4.initializer, void 0, K.getGeneratedNameForNode(f4)) : K.getGeneratedNameForNode(f4))]))), K.updateParameterDeclaration(f4, f4.decorators, f4.modifiers, f4.dotDotDotToken, K.getGeneratedNameForNode(f4), f4.questionToken, f4.type, void 0);
            }
            function N(f4, T, K, b) {
              var se = b.factory;
              return b.addInitializationStatement(se.createIfStatement(se.createTypeCheck(se.cloneNode(T), "undefined"), e2.setEmitFlags(e2.setTextRange(se.createBlock([se.createExpressionStatement(e2.setEmitFlags(e2.setTextRange(se.createAssignment(e2.setEmitFlags(se.cloneNode(T), 48), e2.setEmitFlags(K, 48 | e2.getEmitFlags(K) | 1536)), f4), 1536))]), f4), 1953))), se.updateParameterDeclaration(f4, f4.decorators, f4.modifiers, f4.dotDotDotToken, f4.name, f4.questionToken, f4.type, void 0);
            }
            function p(f4, T, K, b) {
              b === void 0 && (b = a), K.resumeLexicalEnvironment();
              var se = b(f4, T, e2.isConciseBody), J = K.endLexicalEnvironment();
              if (e2.some(J)) {
                if (!se)
                  return K.factory.createBlock(J);
                var ie = K.factory.converters.convertToFunctionBlock(se), R = e2.factory.mergeLexicalEnvironment(ie.statements, J);
                return K.factory.updateBlock(ie, R);
              }
              return se;
            }
            e2.visitFunctionBody = p;
            function m2(f4, T, K) {
              K.startBlockScope();
              var b = a(f4, T, e2.isStatement, K.factory.liftToBlock), se = K.endBlockScope();
              return e2.some(se) ? e2.isBlock(b) ? (se.push.apply(se, b.statements), K.factory.updateBlock(b, se)) : (se.push(b), K.factory.createBlock(se)) : b;
            }
            e2.visitIterationBody = m2;
            function G(f4, T, K, b, se, J) {
              if (b === void 0 && (b = C), J === void 0 && (J = a), f4 !== void 0) {
                var ie = f4.kind;
                if (ie > 0 && ie <= 160 || ie === 192)
                  return f4;
                var R = K.factory;
                switch (ie) {
                  case 79:
                    return e2.Debug.type(f4), R.updateIdentifier(f4, b(f4.typeArguments, T, e2.isTypeNodeOrTypeParameterDeclaration));
                  case 161:
                    return e2.Debug.type(f4), R.updateQualifiedName(f4, J(f4.left, T, e2.isEntityName), J(f4.right, T, e2.isIdentifier));
                  case 162:
                    return e2.Debug.type(f4), R.updateComputedPropertyName(f4, J(f4.expression, T, e2.isExpression));
                  case 163:
                    return e2.Debug.type(f4), R.updateTypeParameterDeclaration(f4, b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isIdentifier), J(f4.constraint, T, e2.isTypeNode), J(f4.default, T, e2.isTypeNode));
                  case 164:
                    return e2.Debug.type(f4), R.updateParameterDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.dotDotDotToken, se, e2.isDotDotDotToken), J(f4.name, T, e2.isBindingName), J(f4.questionToken, se, e2.isQuestionToken), J(f4.type, T, e2.isTypeNode), J(f4.initializer, T, e2.isExpression));
                  case 165:
                    return e2.Debug.type(f4), R.updateDecorator(f4, J(f4.expression, T, e2.isExpression));
                  case 166:
                    return e2.Debug.type(f4), R.updatePropertySignature(f4, b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isPropertyName), J(f4.questionToken, se, e2.isToken), J(f4.type, T, e2.isTypeNode));
                  case 167:
                    return e2.Debug.type(f4), R.updatePropertyDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isPropertyName), J(f4.questionToken || f4.exclamationToken, se, e2.isQuestionOrExclamationToken), J(f4.type, T, e2.isTypeNode), J(f4.initializer, T, e2.isExpression));
                  case 168:
                    return e2.Debug.type(f4), R.updateMethodSignature(f4, b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isPropertyName), J(f4.questionToken, se, e2.isQuestionToken), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), b(f4.parameters, T, e2.isParameterDeclaration), J(f4.type, T, e2.isTypeNode));
                  case 169:
                    return e2.Debug.type(f4), R.updateMethodDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.asteriskToken, se, e2.isAsteriskToken), J(f4.name, T, e2.isPropertyName), J(f4.questionToken, se, e2.isQuestionToken), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), B(f4.parameters, T, K, b), J(f4.type, T, e2.isTypeNode), p(f4.body, T, K, J));
                  case 171:
                    return e2.Debug.type(f4), R.updateConstructorDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), B(f4.parameters, T, K, b), p(f4.body, T, K, J));
                  case 172:
                    return e2.Debug.type(f4), R.updateGetAccessorDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isPropertyName), B(f4.parameters, T, K, b), J(f4.type, T, e2.isTypeNode), p(f4.body, T, K, J));
                  case 173:
                    return e2.Debug.type(f4), R.updateSetAccessorDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isPropertyName), B(f4.parameters, T, K, b), p(f4.body, T, K, J));
                  case 170:
                    return e2.Debug.type(f4), K.startLexicalEnvironment(), K.suspendLexicalEnvironment(), R.updateClassStaticBlockDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), p(f4.body, T, K, J));
                  case 174:
                    return e2.Debug.type(f4), R.updateCallSignature(f4, b(f4.typeParameters, T, e2.isTypeParameterDeclaration), b(f4.parameters, T, e2.isParameterDeclaration), J(f4.type, T, e2.isTypeNode));
                  case 175:
                    return e2.Debug.type(f4), R.updateConstructSignature(f4, b(f4.typeParameters, T, e2.isTypeParameterDeclaration), b(f4.parameters, T, e2.isParameterDeclaration), J(f4.type, T, e2.isTypeNode));
                  case 176:
                    return e2.Debug.type(f4), R.updateIndexSignature(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), b(f4.parameters, T, e2.isParameterDeclaration), J(f4.type, T, e2.isTypeNode));
                  case 177:
                    return e2.Debug.type(f4), R.updateTypePredicateNode(f4, J(f4.assertsModifier, T, e2.isAssertsKeyword), J(f4.parameterName, T, e2.isIdentifierOrThisTypeNode), J(f4.type, T, e2.isTypeNode));
                  case 178:
                    return e2.Debug.type(f4), R.updateTypeReferenceNode(f4, J(f4.typeName, T, e2.isEntityName), b(f4.typeArguments, T, e2.isTypeNode));
                  case 179:
                    return e2.Debug.type(f4), R.updateFunctionTypeNode(f4, b(f4.typeParameters, T, e2.isTypeParameterDeclaration), b(f4.parameters, T, e2.isParameterDeclaration), J(f4.type, T, e2.isTypeNode));
                  case 180:
                    return e2.Debug.type(f4), R.updateConstructorTypeNode(f4, b(f4.modifiers, T, e2.isModifier), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), b(f4.parameters, T, e2.isParameterDeclaration), J(f4.type, T, e2.isTypeNode));
                  case 181:
                    return e2.Debug.type(f4), R.updateTypeQueryNode(f4, J(f4.exprName, T, e2.isEntityName), b(f4.typeArguments, T, e2.isTypeNode));
                  case 182:
                    return e2.Debug.type(f4), R.updateTypeLiteralNode(f4, b(f4.members, T, e2.isTypeElement));
                  case 183:
                    return e2.Debug.type(f4), R.updateArrayTypeNode(f4, J(f4.elementType, T, e2.isTypeNode));
                  case 184:
                    return e2.Debug.type(f4), R.updateTupleTypeNode(f4, b(f4.elements, T, e2.isTypeNode));
                  case 185:
                    return e2.Debug.type(f4), R.updateOptionalTypeNode(f4, J(f4.type, T, e2.isTypeNode));
                  case 186:
                    return e2.Debug.type(f4), R.updateRestTypeNode(f4, J(f4.type, T, e2.isTypeNode));
                  case 187:
                    return e2.Debug.type(f4), R.updateUnionTypeNode(f4, b(f4.types, T, e2.isTypeNode));
                  case 188:
                    return e2.Debug.type(f4), R.updateIntersectionTypeNode(f4, b(f4.types, T, e2.isTypeNode));
                  case 189:
                    return e2.Debug.type(f4), R.updateConditionalTypeNode(f4, J(f4.checkType, T, e2.isTypeNode), J(f4.extendsType, T, e2.isTypeNode), J(f4.trueType, T, e2.isTypeNode), J(f4.falseType, T, e2.isTypeNode));
                  case 190:
                    return e2.Debug.type(f4), R.updateInferTypeNode(f4, J(f4.typeParameter, T, e2.isTypeParameterDeclaration));
                  case 200:
                    return e2.Debug.type(f4), R.updateImportTypeNode(f4, J(f4.argument, T, e2.isTypeNode), J(f4.assertions, T, e2.isNode), J(f4.qualifier, T, e2.isEntityName), C(f4.typeArguments, T, e2.isTypeNode), f4.isTypeOf);
                  case 295:
                    return e2.Debug.type(f4), R.updateImportTypeAssertionContainer(f4, J(f4.assertClause, T, e2.isNode), f4.multiLine);
                  case 197:
                    return e2.Debug.type(f4), R.updateNamedTupleMember(f4, a(f4.dotDotDotToken, T, e2.isDotDotDotToken), a(f4.name, T, e2.isIdentifier), a(f4.questionToken, T, e2.isQuestionToken), a(f4.type, T, e2.isTypeNode));
                  case 191:
                    return e2.Debug.type(f4), R.updateParenthesizedType(f4, J(f4.type, T, e2.isTypeNode));
                  case 193:
                    return e2.Debug.type(f4), R.updateTypeOperatorNode(f4, J(f4.type, T, e2.isTypeNode));
                  case 194:
                    return e2.Debug.type(f4), R.updateIndexedAccessTypeNode(f4, J(f4.objectType, T, e2.isTypeNode), J(f4.indexType, T, e2.isTypeNode));
                  case 195:
                    return e2.Debug.type(f4), R.updateMappedTypeNode(f4, J(f4.readonlyToken, se, e2.isReadonlyKeywordOrPlusOrMinusToken), J(f4.typeParameter, T, e2.isTypeParameterDeclaration), J(f4.nameType, T, e2.isTypeNode), J(f4.questionToken, se, e2.isQuestionOrPlusOrMinusToken), J(f4.type, T, e2.isTypeNode), b(f4.members, T, e2.isTypeElement));
                  case 196:
                    return e2.Debug.type(f4), R.updateLiteralTypeNode(f4, J(f4.literal, T, e2.isExpression));
                  case 198:
                    return e2.Debug.type(f4), R.updateTemplateLiteralType(f4, J(f4.head, T, e2.isTemplateHead), b(f4.templateSpans, T, e2.isTemplateLiteralTypeSpan));
                  case 199:
                    return e2.Debug.type(f4), R.updateTemplateLiteralTypeSpan(f4, J(f4.type, T, e2.isTypeNode), J(f4.literal, T, e2.isTemplateMiddleOrTemplateTail));
                  case 201:
                    return e2.Debug.type(f4), R.updateObjectBindingPattern(f4, b(f4.elements, T, e2.isBindingElement));
                  case 202:
                    return e2.Debug.type(f4), R.updateArrayBindingPattern(f4, b(f4.elements, T, e2.isArrayBindingElement));
                  case 203:
                    return e2.Debug.type(f4), R.updateBindingElement(f4, J(f4.dotDotDotToken, se, e2.isDotDotDotToken), J(f4.propertyName, T, e2.isPropertyName), J(f4.name, T, e2.isBindingName), J(f4.initializer, T, e2.isExpression));
                  case 204:
                    return e2.Debug.type(f4), R.updateArrayLiteralExpression(f4, b(f4.elements, T, e2.isExpression));
                  case 205:
                    return e2.Debug.type(f4), R.updateObjectLiteralExpression(f4, b(f4.properties, T, e2.isObjectLiteralElementLike));
                  case 206:
                    return f4.flags & 32 ? (e2.Debug.type(f4), R.updatePropertyAccessChain(f4, J(f4.expression, T, e2.isExpression), J(f4.questionDotToken, se, e2.isQuestionDotToken), J(f4.name, T, e2.isMemberName))) : (e2.Debug.type(f4), R.updatePropertyAccessExpression(f4, J(f4.expression, T, e2.isExpression), J(f4.name, T, e2.isMemberName)));
                  case 207:
                    return f4.flags & 32 ? (e2.Debug.type(f4), R.updateElementAccessChain(f4, J(f4.expression, T, e2.isExpression), J(f4.questionDotToken, se, e2.isQuestionDotToken), J(f4.argumentExpression, T, e2.isExpression))) : (e2.Debug.type(f4), R.updateElementAccessExpression(f4, J(f4.expression, T, e2.isExpression), J(f4.argumentExpression, T, e2.isExpression)));
                  case 208:
                    return f4.flags & 32 ? (e2.Debug.type(f4), R.updateCallChain(f4, J(f4.expression, T, e2.isExpression), J(f4.questionDotToken, se, e2.isQuestionDotToken), b(f4.typeArguments, T, e2.isTypeNode), b(f4.arguments, T, e2.isExpression))) : (e2.Debug.type(f4), R.updateCallExpression(f4, J(f4.expression, T, e2.isExpression), b(f4.typeArguments, T, e2.isTypeNode), b(f4.arguments, T, e2.isExpression)));
                  case 209:
                    return e2.Debug.type(f4), R.updateNewExpression(f4, J(f4.expression, T, e2.isExpression), b(f4.typeArguments, T, e2.isTypeNode), b(f4.arguments, T, e2.isExpression));
                  case 210:
                    return e2.Debug.type(f4), R.updateTaggedTemplateExpression(f4, J(f4.tag, T, e2.isExpression), C(f4.typeArguments, T, e2.isTypeNode), J(f4.template, T, e2.isTemplateLiteral));
                  case 211:
                    return e2.Debug.type(f4), R.updateTypeAssertion(f4, J(f4.type, T, e2.isTypeNode), J(f4.expression, T, e2.isExpression));
                  case 212:
                    return e2.Debug.type(f4), R.updateParenthesizedExpression(f4, J(f4.expression, T, e2.isExpression));
                  case 213:
                    return e2.Debug.type(f4), R.updateFunctionExpression(f4, b(f4.modifiers, T, e2.isModifier), J(f4.asteriskToken, se, e2.isAsteriskToken), J(f4.name, T, e2.isIdentifier), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), B(f4.parameters, T, K, b), J(f4.type, T, e2.isTypeNode), p(f4.body, T, K, J));
                  case 214:
                    return e2.Debug.type(f4), R.updateArrowFunction(f4, b(f4.modifiers, T, e2.isModifier), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), B(f4.parameters, T, K, b), J(f4.type, T, e2.isTypeNode), J(f4.equalsGreaterThanToken, se, e2.isEqualsGreaterThanToken), p(f4.body, T, K, J));
                  case 215:
                    return e2.Debug.type(f4), R.updateDeleteExpression(f4, J(f4.expression, T, e2.isExpression));
                  case 216:
                    return e2.Debug.type(f4), R.updateTypeOfExpression(f4, J(f4.expression, T, e2.isExpression));
                  case 217:
                    return e2.Debug.type(f4), R.updateVoidExpression(f4, J(f4.expression, T, e2.isExpression));
                  case 218:
                    return e2.Debug.type(f4), R.updateAwaitExpression(f4, J(f4.expression, T, e2.isExpression));
                  case 219:
                    return e2.Debug.type(f4), R.updatePrefixUnaryExpression(f4, J(f4.operand, T, e2.isExpression));
                  case 220:
                    return e2.Debug.type(f4), R.updatePostfixUnaryExpression(f4, J(f4.operand, T, e2.isExpression));
                  case 221:
                    return e2.Debug.type(f4), R.updateBinaryExpression(f4, J(f4.left, T, e2.isExpression), J(f4.operatorToken, se, e2.isBinaryOperatorToken), J(f4.right, T, e2.isExpression));
                  case 222:
                    return e2.Debug.type(f4), R.updateConditionalExpression(f4, J(f4.condition, T, e2.isExpression), J(f4.questionToken, se, e2.isQuestionToken), J(f4.whenTrue, T, e2.isExpression), J(f4.colonToken, se, e2.isColonToken), J(f4.whenFalse, T, e2.isExpression));
                  case 223:
                    return e2.Debug.type(f4), R.updateTemplateExpression(f4, J(f4.head, T, e2.isTemplateHead), b(f4.templateSpans, T, e2.isTemplateSpan));
                  case 224:
                    return e2.Debug.type(f4), R.updateYieldExpression(f4, J(f4.asteriskToken, se, e2.isAsteriskToken), J(f4.expression, T, e2.isExpression));
                  case 225:
                    return e2.Debug.type(f4), R.updateSpreadElement(f4, J(f4.expression, T, e2.isExpression));
                  case 226:
                    return e2.Debug.type(f4), R.updateClassExpression(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isIdentifier), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), b(f4.heritageClauses, T, e2.isHeritageClause), b(f4.members, T, e2.isClassElement));
                  case 228:
                    return e2.Debug.type(f4), R.updateExpressionWithTypeArguments(f4, J(f4.expression, T, e2.isExpression), b(f4.typeArguments, T, e2.isTypeNode));
                  case 229:
                    return e2.Debug.type(f4), R.updateAsExpression(f4, J(f4.expression, T, e2.isExpression), J(f4.type, T, e2.isTypeNode));
                  case 230:
                    return f4.flags & 32 ? (e2.Debug.type(f4), R.updateNonNullChain(f4, J(f4.expression, T, e2.isExpression))) : (e2.Debug.type(f4), R.updateNonNullExpression(f4, J(f4.expression, T, e2.isExpression)));
                  case 231:
                    return e2.Debug.type(f4), R.updateMetaProperty(f4, J(f4.name, T, e2.isIdentifier));
                  case 233:
                    return e2.Debug.type(f4), R.updateTemplateSpan(f4, J(f4.expression, T, e2.isExpression), J(f4.literal, T, e2.isTemplateMiddleOrTemplateTail));
                  case 235:
                    return e2.Debug.type(f4), R.updateBlock(f4, b(f4.statements, T, e2.isStatement));
                  case 237:
                    return e2.Debug.type(f4), R.updateVariableStatement(f4, b(f4.modifiers, T, e2.isModifier), J(f4.declarationList, T, e2.isVariableDeclarationList));
                  case 238:
                    return e2.Debug.type(f4), R.updateExpressionStatement(f4, J(f4.expression, T, e2.isExpression));
                  case 239:
                    return e2.Debug.type(f4), R.updateIfStatement(f4, J(f4.expression, T, e2.isExpression), J(f4.thenStatement, T, e2.isStatement, R.liftToBlock), J(f4.elseStatement, T, e2.isStatement, R.liftToBlock));
                  case 240:
                    return e2.Debug.type(f4), R.updateDoStatement(f4, m2(f4.statement, T, K), J(f4.expression, T, e2.isExpression));
                  case 241:
                    return e2.Debug.type(f4), R.updateWhileStatement(f4, J(f4.expression, T, e2.isExpression), m2(f4.statement, T, K));
                  case 242:
                    return e2.Debug.type(f4), R.updateForStatement(f4, J(f4.initializer, T, e2.isForInitializer), J(f4.condition, T, e2.isExpression), J(f4.incrementor, T, e2.isExpression), m2(f4.statement, T, K));
                  case 243:
                    return e2.Debug.type(f4), R.updateForInStatement(f4, J(f4.initializer, T, e2.isForInitializer), J(f4.expression, T, e2.isExpression), m2(f4.statement, T, K));
                  case 244:
                    return e2.Debug.type(f4), R.updateForOfStatement(f4, J(f4.awaitModifier, se, e2.isAwaitKeyword), J(f4.initializer, T, e2.isForInitializer), J(f4.expression, T, e2.isExpression), m2(f4.statement, T, K));
                  case 245:
                    return e2.Debug.type(f4), R.updateContinueStatement(f4, J(f4.label, T, e2.isIdentifier));
                  case 246:
                    return e2.Debug.type(f4), R.updateBreakStatement(f4, J(f4.label, T, e2.isIdentifier));
                  case 247:
                    return e2.Debug.type(f4), R.updateReturnStatement(f4, J(f4.expression, T, e2.isExpression));
                  case 248:
                    return e2.Debug.type(f4), R.updateWithStatement(f4, J(f4.expression, T, e2.isExpression), J(f4.statement, T, e2.isStatement, R.liftToBlock));
                  case 249:
                    return e2.Debug.type(f4), R.updateSwitchStatement(f4, J(f4.expression, T, e2.isExpression), J(f4.caseBlock, T, e2.isCaseBlock));
                  case 250:
                    return e2.Debug.type(f4), R.updateLabeledStatement(f4, J(f4.label, T, e2.isIdentifier), J(f4.statement, T, e2.isStatement, R.liftToBlock));
                  case 251:
                    return e2.Debug.type(f4), R.updateThrowStatement(f4, J(f4.expression, T, e2.isExpression));
                  case 252:
                    return e2.Debug.type(f4), R.updateTryStatement(f4, J(f4.tryBlock, T, e2.isBlock), J(f4.catchClause, T, e2.isCatchClause), J(f4.finallyBlock, T, e2.isBlock));
                  case 254:
                    return e2.Debug.type(f4), R.updateVariableDeclaration(f4, J(f4.name, T, e2.isBindingName), J(f4.exclamationToken, se, e2.isExclamationToken), J(f4.type, T, e2.isTypeNode), J(f4.initializer, T, e2.isExpression));
                  case 255:
                    return e2.Debug.type(f4), R.updateVariableDeclarationList(f4, b(f4.declarations, T, e2.isVariableDeclaration));
                  case 256:
                    return e2.Debug.type(f4), R.updateFunctionDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.asteriskToken, se, e2.isAsteriskToken), J(f4.name, T, e2.isIdentifier), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), B(f4.parameters, T, K, b), J(f4.type, T, e2.isTypeNode), p(f4.body, T, K, J));
                  case 257:
                    return e2.Debug.type(f4), R.updateClassDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isIdentifier), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), b(f4.heritageClauses, T, e2.isHeritageClause), b(f4.members, T, e2.isClassElement));
                  case 258:
                    return e2.Debug.type(f4), R.updateInterfaceDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isIdentifier), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), b(f4.heritageClauses, T, e2.isHeritageClause), b(f4.members, T, e2.isTypeElement));
                  case 259:
                    return e2.Debug.type(f4), R.updateTypeAliasDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isIdentifier), b(f4.typeParameters, T, e2.isTypeParameterDeclaration), J(f4.type, T, e2.isTypeNode));
                  case 260:
                    return e2.Debug.type(f4), R.updateEnumDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isIdentifier), b(f4.members, T, e2.isEnumMember));
                  case 261:
                    return e2.Debug.type(f4), R.updateModuleDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.name, T, e2.isModuleName), J(f4.body, T, e2.isModuleBody));
                  case 262:
                    return e2.Debug.type(f4), R.updateModuleBlock(f4, b(f4.statements, T, e2.isStatement));
                  case 263:
                    return e2.Debug.type(f4), R.updateCaseBlock(f4, b(f4.clauses, T, e2.isCaseOrDefaultClause));
                  case 264:
                    return e2.Debug.type(f4), R.updateNamespaceExportDeclaration(f4, J(f4.name, T, e2.isIdentifier));
                  case 265:
                    return e2.Debug.type(f4), R.updateImportEqualsDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), f4.isTypeOnly, J(f4.name, T, e2.isIdentifier), J(f4.moduleReference, T, e2.isModuleReference));
                  case 266:
                    return e2.Debug.type(f4), R.updateImportDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.importClause, T, e2.isImportClause), J(f4.moduleSpecifier, T, e2.isExpression), J(f4.assertClause, T, e2.isAssertClause));
                  case 293:
                    return e2.Debug.type(f4), R.updateAssertClause(f4, b(f4.elements, T, e2.isAssertEntry), f4.multiLine);
                  case 294:
                    return e2.Debug.type(f4), R.updateAssertEntry(f4, J(f4.name, T, e2.isAssertionKey), J(f4.value, T, e2.isExpressionNode));
                  case 267:
                    return e2.Debug.type(f4), R.updateImportClause(f4, f4.isTypeOnly, J(f4.name, T, e2.isIdentifier), J(f4.namedBindings, T, e2.isNamedImportBindings));
                  case 268:
                    return e2.Debug.type(f4), R.updateNamespaceImport(f4, J(f4.name, T, e2.isIdentifier));
                  case 274:
                    return e2.Debug.type(f4), R.updateNamespaceExport(f4, J(f4.name, T, e2.isIdentifier));
                  case 269:
                    return e2.Debug.type(f4), R.updateNamedImports(f4, b(f4.elements, T, e2.isImportSpecifier));
                  case 270:
                    return e2.Debug.type(f4), R.updateImportSpecifier(f4, f4.isTypeOnly, J(f4.propertyName, T, e2.isIdentifier), J(f4.name, T, e2.isIdentifier));
                  case 271:
                    return e2.Debug.type(f4), R.updateExportAssignment(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), J(f4.expression, T, e2.isExpression));
                  case 272:
                    return e2.Debug.type(f4), R.updateExportDeclaration(f4, b(f4.decorators, T, e2.isDecorator), b(f4.modifiers, T, e2.isModifier), f4.isTypeOnly, J(f4.exportClause, T, e2.isNamedExportBindings), J(f4.moduleSpecifier, T, e2.isExpression), J(f4.assertClause, T, e2.isAssertClause));
                  case 273:
                    return e2.Debug.type(f4), R.updateNamedExports(f4, b(f4.elements, T, e2.isExportSpecifier));
                  case 275:
                    return e2.Debug.type(f4), R.updateExportSpecifier(f4, f4.isTypeOnly, J(f4.propertyName, T, e2.isIdentifier), J(f4.name, T, e2.isIdentifier));
                  case 277:
                    return e2.Debug.type(f4), R.updateExternalModuleReference(f4, J(f4.expression, T, e2.isExpression));
                  case 278:
                    return e2.Debug.type(f4), R.updateJsxElement(f4, J(f4.openingElement, T, e2.isJsxOpeningElement), b(f4.children, T, e2.isJsxChild), J(f4.closingElement, T, e2.isJsxClosingElement));
                  case 279:
                    return e2.Debug.type(f4), R.updateJsxSelfClosingElement(f4, J(f4.tagName, T, e2.isJsxTagNameExpression), b(f4.typeArguments, T, e2.isTypeNode), J(f4.attributes, T, e2.isJsxAttributes));
                  case 280:
                    return e2.Debug.type(f4), R.updateJsxOpeningElement(f4, J(f4.tagName, T, e2.isJsxTagNameExpression), b(f4.typeArguments, T, e2.isTypeNode), J(f4.attributes, T, e2.isJsxAttributes));
                  case 281:
                    return e2.Debug.type(f4), R.updateJsxClosingElement(f4, J(f4.tagName, T, e2.isJsxTagNameExpression));
                  case 282:
                    return e2.Debug.type(f4), R.updateJsxFragment(f4, J(f4.openingFragment, T, e2.isJsxOpeningFragment), b(f4.children, T, e2.isJsxChild), J(f4.closingFragment, T, e2.isJsxClosingFragment));
                  case 285:
                    return e2.Debug.type(f4), R.updateJsxAttribute(f4, J(f4.name, T, e2.isIdentifier), J(f4.initializer, T, e2.isStringLiteralOrJsxExpression));
                  case 286:
                    return e2.Debug.type(f4), R.updateJsxAttributes(f4, b(f4.properties, T, e2.isJsxAttributeLike));
                  case 287:
                    return e2.Debug.type(f4), R.updateJsxSpreadAttribute(f4, J(f4.expression, T, e2.isExpression));
                  case 288:
                    return e2.Debug.type(f4), R.updateJsxExpression(f4, J(f4.expression, T, e2.isExpression));
                  case 289:
                    return e2.Debug.type(f4), R.updateCaseClause(f4, J(f4.expression, T, e2.isExpression), b(f4.statements, T, e2.isStatement));
                  case 290:
                    return e2.Debug.type(f4), R.updateDefaultClause(f4, b(f4.statements, T, e2.isStatement));
                  case 291:
                    return e2.Debug.type(f4), R.updateHeritageClause(f4, b(f4.types, T, e2.isExpressionWithTypeArguments));
                  case 292:
                    return e2.Debug.type(f4), R.updateCatchClause(f4, J(f4.variableDeclaration, T, e2.isVariableDeclaration), J(f4.block, T, e2.isBlock));
                  case 296:
                    return e2.Debug.type(f4), R.updatePropertyAssignment(f4, J(f4.name, T, e2.isPropertyName), J(f4.initializer, T, e2.isExpression));
                  case 297:
                    return e2.Debug.type(f4), R.updateShorthandPropertyAssignment(f4, J(f4.name, T, e2.isIdentifier), J(f4.objectAssignmentInitializer, T, e2.isExpression));
                  case 298:
                    return e2.Debug.type(f4), R.updateSpreadAssignment(f4, J(f4.expression, T, e2.isExpression));
                  case 299:
                    return e2.Debug.type(f4), R.updateEnumMember(f4, J(f4.name, T, e2.isPropertyName), J(f4.initializer, T, e2.isExpression));
                  case 305:
                    return e2.Debug.type(f4), R.updateSourceFile(f4, w(f4.statements, T, K));
                  case 350:
                    return e2.Debug.type(f4), R.updatePartiallyEmittedExpression(f4, J(f4.expression, T, e2.isExpression));
                  case 351:
                    return e2.Debug.type(f4), R.updateCommaListExpression(f4, b(f4.elements, T, e2.isExpression));
                  default:
                    return f4;
                }
              }
            }
            e2.visitEachChild = G;
            function oe(f4) {
              return e2.Debug.assert(f4.length <= 1, "Too many nodes written to output."), e2.singleOrUndefined(f4);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(q, O, ve, ee, he) {
              var F2 = he.extendedDiagnostics ? e2.performance.createTimer("Source Map", "beforeSourcemap", "afterSourcemap") : e2.performance.nullTimer, x2 = F2.enter, X = F2.exit, $ = [], A2 = [], y = new e2.Map(), V, L = [], P, k = [], Y = "", U = 0, j = 0, H = 0, I = 0, l = 0, d = 0, D = false, fe = 0, g = 0, ne = 0, ue = 0, We = 0, Fe = 0, Z2 = false, Be = false, ge = false;
              return { getSources: function() {
                return $;
              }, addSource: Re, setSourceContent: ze, addName: Ee, addMapping: Ie, appendSourceMap: _e, toJSON: er, toString: function() {
                return JSON.stringify(er());
              } };
              function Re(Cr) {
                x2();
                var Ye = e2.getRelativePathToDirectoryOrUrl(ee, Cr, q.getCurrentDirectory(), q.getCanonicalFileName, true), Br = y.get(Ye);
                return Br === void 0 && (Br = A2.length, A2.push(Ye), $.push(Cr), y.set(Ye, Br)), X(), Br;
              }
              function ze(Cr, Ye) {
                if (x2(), Ye !== null) {
                  for (V || (V = []); V.length < Cr; )
                    V.push(null);
                  V[Cr] = Ye;
                }
                X();
              }
              function Ee(Cr) {
                x2(), P || (P = new e2.Map());
                var Ye = P.get(Cr);
                return Ye === void 0 && (Ye = L.length, L.push(Cr), P.set(Cr, Ye)), X(), Ye;
              }
              function He(Cr, Ye) {
                return !Z2 || fe !== Cr || g !== Ye;
              }
              function rr(Cr, Ye, Br) {
                return Cr !== void 0 && Ye !== void 0 && Br !== void 0 && ne === Cr && (ue > Ye || ue === Ye && We > Br);
              }
              function Ie(Cr, Ye, Br, Er, Ne, n) {
                e2.Debug.assert(Cr >= fe, "generatedLine cannot backtrack"), e2.Debug.assert(Ye >= 0, "generatedCharacter cannot be negative"), e2.Debug.assert(Br === void 0 || Br >= 0, "sourceIndex cannot be negative"), e2.Debug.assert(Er === void 0 || Er >= 0, "sourceLine cannot be negative"), e2.Debug.assert(Ne === void 0 || Ne >= 0, "sourceCharacter cannot be negative"), x2(), (He(Cr, Ye) || rr(Br, Er, Ne)) && (ye(), fe = Cr, g = Ye, Be = false, ge = false, Z2 = true), Br !== void 0 && Er !== void 0 && Ne !== void 0 && (ne = Br, ue = Er, We = Ne, Be = true, n !== void 0 && (Fe = n, ge = true)), X();
              }
              function _e(Cr, Ye, Br, Er, Ne, n) {
                e2.Debug.assert(Cr >= fe, "generatedLine cannot backtrack"), e2.Debug.assert(Ye >= 0, "generatedCharacter cannot be negative"), x2();
                for (var lr = [], be, Ge = p(Br.mappings), ur = Ge.next(); !ur.done; ur = Ge.next()) {
                  var yr = ur.value;
                  if (n && (yr.generatedLine > n.line || yr.generatedLine === n.line && yr.generatedCharacter > n.character))
                    break;
                  if (!(Ne && (yr.generatedLine < Ne.line || Ne.line === yr.generatedLine && yr.generatedCharacter < Ne.character))) {
                    var Ir = void 0, wr = void 0, Ur = void 0, ii = void 0;
                    if (yr.sourceIndex !== void 0) {
                      if (Ir = lr[yr.sourceIndex], Ir === void 0) {
                        var mi = Br.sources[yr.sourceIndex], pe = Br.sourceRoot ? e2.combinePaths(Br.sourceRoot, mi) : mi, or = e2.combinePaths(e2.getDirectoryPath(Er), pe);
                        lr[yr.sourceIndex] = Ir = Re(or), Br.sourcesContent && typeof Br.sourcesContent[yr.sourceIndex] == "string" && ze(Ir, Br.sourcesContent[yr.sourceIndex]);
                      }
                      wr = yr.sourceLine, Ur = yr.sourceCharacter, Br.names && yr.nameIndex !== void 0 && (be || (be = []), ii = be[yr.nameIndex], ii === void 0 && (be[yr.nameIndex] = ii = Ee(Br.names[yr.nameIndex])));
                    }
                    var qr = yr.generatedLine - (Ne ? Ne.line : 0), si = qr + Cr, Di = Ne && Ne.line === yr.generatedLine ? yr.generatedCharacter - Ne.character : yr.generatedCharacter, wi = qr === 0 ? Di + Ye : Di;
                    Ie(si, wi, Ir, wr, Ur, ii);
                  }
                }
                X();
              }
              function we() {
                return !D || U !== fe || j !== g || H !== ne || I !== ue || l !== We || d !== Fe;
              }
              function de(Cr) {
                k.push(Cr), k.length >= 1024 && Ae();
              }
              function ye() {
                if (!(!Z2 || !we())) {
                  if (x2(), U < fe) {
                    do
                      de(59), U++;
                    while (U < fe);
                    j = 0;
                  } else
                    e2.Debug.assertEqual(U, fe, "generatedLine cannot backtrack"), D && de(44);
                  ir(g - j), j = g, Be && (ir(ne - H), H = ne, ir(ue - I), I = ue, ir(We - l), l = We, ge && (ir(Fe - d), d = Fe)), D = true, X();
                }
              }
              function Ae() {
                k.length > 0 && (Y += String.fromCharCode.apply(void 0, k), k.length = 0);
              }
              function er() {
                return ye(), Ae(), { version: 3, file: O, sourceRoot: ve, sources: A2, names: L, mappings: Y, sourcesContent: V };
              }
              function ir(Cr) {
                Cr < 0 ? Cr = (-Cr << 1) + 1 : Cr = Cr << 1;
                do {
                  var Ye = Cr & 31;
                  Cr = Cr >> 5, Cr > 0 && (Ye = Ye | 32), de(oe(Ye));
                } while (Cr > 0);
              }
            }
            e2.createSourceMapGenerator = a;
            var C = /^\/\/[@#] source[M]appingURL=(.+)\r?\n?$/, w = /^\s*(\/\/[@#] .*)?$/;
            function B(q, O) {
              return { getLineCount: function() {
                return O.length;
              }, getLineText: function(ve) {
                return q.substring(O[ve], O[ve + 1]);
              } };
            }
            e2.getLineInfo = B;
            function E(q) {
              for (var O = q.getLineCount() - 1; O >= 0; O--) {
                var ve = q.getLineText(O), ee = C.exec(ve);
                if (ee)
                  return e2.trimStringEnd(ee[1]);
                if (!ve.match(w))
                  break;
              }
            }
            e2.tryGetSourceMappingURL = E;
            function Q(q) {
              return typeof q == "string" || q === null;
            }
            function le(q) {
              return q !== null && typeof q == "object" && q.version === 3 && typeof q.file == "string" && typeof q.mappings == "string" && e2.isArray(q.sources) && e2.every(q.sources, e2.isString) && (q.sourceRoot === void 0 || q.sourceRoot === null || typeof q.sourceRoot == "string") && (q.sourcesContent === void 0 || q.sourcesContent === null || e2.isArray(q.sourcesContent) && e2.every(q.sourcesContent, Q)) && (q.names === void 0 || q.names === null || e2.isArray(q.names) && e2.every(q.names, e2.isString));
            }
            e2.isRawSourceMap = le;
            function N(q) {
              try {
                var O = JSON.parse(q);
                if (le(O))
                  return O;
              } catch {
              }
            }
            e2.tryParseRawSourceMap = N;
            function p(q) {
              var O = false, ve = 0, ee = 0, he = 0, F2 = 0, x2 = 0, X = 0, $ = 0, A2;
              return { get pos() {
                return ve;
              }, get error() {
                return A2;
              }, get state() {
                return y(true, true);
              }, next: function() {
                for (; !O && ve < q.length; ) {
                  var j = q.charCodeAt(ve);
                  if (j === 59) {
                    ee++, he = 0, ve++;
                    continue;
                  }
                  if (j === 44) {
                    ve++;
                    continue;
                  }
                  var H = false, I = false;
                  if (he += U(), k())
                    return V();
                  if (he < 0)
                    return P("Invalid generatedCharacter found");
                  if (!Y()) {
                    if (H = true, F2 += U(), k())
                      return V();
                    if (F2 < 0)
                      return P("Invalid sourceIndex found");
                    if (Y())
                      return P("Unsupported Format: No entries after sourceIndex");
                    if (x2 += U(), k())
                      return V();
                    if (x2 < 0)
                      return P("Invalid sourceLine found");
                    if (Y())
                      return P("Unsupported Format: No entries after sourceLine");
                    if (X += U(), k())
                      return V();
                    if (X < 0)
                      return P("Invalid sourceCharacter found");
                    if (!Y()) {
                      if (I = true, $ += U(), k())
                        return V();
                      if ($ < 0)
                        return P("Invalid nameIndex found");
                      if (!Y())
                        return P("Unsupported Error Format: Entries after nameIndex");
                    }
                  }
                  return { value: y(H, I), done: O };
                }
                return V();
              } };
              function y(j, H) {
                return { generatedLine: ee, generatedCharacter: he, sourceIndex: j ? F2 : void 0, sourceLine: j ? x2 : void 0, sourceCharacter: j ? X : void 0, nameIndex: H ? $ : void 0 };
              }
              function V() {
                return O = true, { value: void 0, done: true };
              }
              function L(j) {
                A2 === void 0 && (A2 = j);
              }
              function P(j) {
                return L(j), V();
              }
              function k() {
                return A2 !== void 0;
              }
              function Y() {
                return ve === q.length || q.charCodeAt(ve) === 44 || q.charCodeAt(ve) === 59;
              }
              function U() {
                for (var j = true, H = 0, I = 0; j; ve++) {
                  if (ve >= q.length)
                    return L("Error in decoding base64VLQFormatDecode, past the mapping string"), -1;
                  var l = f4(q.charCodeAt(ve));
                  if (l === -1)
                    return L("Invalid character in VLQ"), -1;
                  j = (l & 32) !== 0, I = I | (l & 31) << H, H += 5;
                }
                return (I & 1) === 0 ? I = I >> 1 : (I = I >> 1, I = -I), I;
              }
            }
            e2.decodeMappings = p;
            function m2(q, O) {
              return q === O || q.generatedLine === O.generatedLine && q.generatedCharacter === O.generatedCharacter && q.sourceIndex === O.sourceIndex && q.sourceLine === O.sourceLine && q.sourceCharacter === O.sourceCharacter && q.nameIndex === O.nameIndex;
            }
            e2.sameMapping = m2;
            function G(q) {
              return q.sourceIndex !== void 0 && q.sourceLine !== void 0 && q.sourceCharacter !== void 0;
            }
            e2.isSourceMapping = G;
            function oe(q) {
              return q >= 0 && q < 26 ? 65 + q : q >= 26 && q < 52 ? 97 + q - 26 : q >= 52 && q < 62 ? 48 + q - 52 : q === 62 ? 43 : q === 63 ? 47 : e2.Debug.fail("".concat(q, ": not a base64 value"));
            }
            function f4(q) {
              return q >= 65 && q <= 90 ? q - 65 : q >= 97 && q <= 122 ? q - 97 + 26 : q >= 48 && q <= 57 ? q - 48 + 52 : q === 43 ? 62 : q === 47 ? 63 : -1;
            }
            function T(q) {
              return q.sourceIndex !== void 0 && q.sourcePosition !== void 0;
            }
            function K(q, O) {
              return q.generatedPosition === O.generatedPosition && q.sourceIndex === O.sourceIndex && q.sourcePosition === O.sourcePosition;
            }
            function b(q, O) {
              return e2.Debug.assert(q.sourceIndex === O.sourceIndex), e2.compareValues(q.sourcePosition, O.sourcePosition);
            }
            function se(q, O) {
              return e2.compareValues(q.generatedPosition, O.generatedPosition);
            }
            function J(q) {
              return q.sourcePosition;
            }
            function ie(q) {
              return q.generatedPosition;
            }
            function R(q, O, ve) {
              var ee = e2.getDirectoryPath(ve), he = O.sourceRoot ? e2.getNormalizedAbsolutePath(O.sourceRoot, ee) : ee, F2 = e2.getNormalizedAbsolutePath(O.file, ee), x2 = q.getSourceFileLike(F2), X = O.sources.map(function(H) {
                return e2.getNormalizedAbsolutePath(H, he);
              }), $ = new e2.Map(X.map(function(H, I) {
                return [q.getCanonicalFileName(H), I];
              })), A2, y, V;
              return { getSourcePosition: j, getGeneratedPosition: U };
              function L(H) {
                var I = x2 !== void 0 ? e2.getPositionOfLineAndCharacter(x2, H.generatedLine, H.generatedCharacter, true) : -1, l, d;
                if (G(H)) {
                  var D = q.getSourceFileLike(X[H.sourceIndex]);
                  l = O.sources[H.sourceIndex], d = D !== void 0 ? e2.getPositionOfLineAndCharacter(D, H.sourceLine, H.sourceCharacter, true) : -1;
                }
                return { generatedPosition: I, source: l, sourceIndex: H.sourceIndex, sourcePosition: d, nameIndex: H.nameIndex };
              }
              function P() {
                if (A2 === void 0) {
                  var H = p(O.mappings), I = e2.arrayFrom(H, L);
                  H.error !== void 0 ? (q.log && q.log("Encountered error while decoding sourcemap: ".concat(H.error)), A2 = e2.emptyArray) : A2 = I;
                }
                return A2;
              }
              function k(H) {
                if (V === void 0) {
                  for (var I = [], l = 0, d = P(); l < d.length; l++) {
                    var D = d[l];
                    if (!!T(D)) {
                      var fe = I[D.sourceIndex];
                      fe || (I[D.sourceIndex] = fe = []), fe.push(D);
                    }
                  }
                  V = I.map(function(g) {
                    return e2.sortAndDeduplicate(g, b, K);
                  });
                }
                return V[H];
              }
              function Y() {
                if (y === void 0) {
                  for (var H = [], I = 0, l = P(); I < l.length; I++) {
                    var d = l[I];
                    H.push(d);
                  }
                  y = e2.sortAndDeduplicate(H, se, K);
                }
                return y;
              }
              function U(H) {
                var I = $.get(q.getCanonicalFileName(H.fileName));
                if (I === void 0)
                  return H;
                var l = k(I);
                if (!e2.some(l))
                  return H;
                var d = e2.binarySearchKey(l, H.pos, J, e2.compareValues);
                d < 0 && (d = ~d);
                var D = l[d];
                return D === void 0 || D.sourceIndex !== I ? H : { fileName: F2, pos: D.generatedPosition };
              }
              function j(H) {
                var I = Y();
                if (!e2.some(I))
                  return H;
                var l = e2.binarySearchKey(I, H.pos, ie, e2.compareValues);
                l < 0 && (l = ~l);
                var d = I[l];
                return d === void 0 || !T(d) ? H : { fileName: X[d.sourceIndex], pos: d.sourcePosition };
              }
            }
            e2.createDocumentPositionMapper = R, e2.identitySourceMapConsumer = { getSourcePosition: e2.identity, getGeneratedPosition: e2.identity };
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(ee) {
              return ee = e2.getOriginalNode(ee), ee ? e2.getNodeId(ee) : 0;
            }
            e2.getOriginalNodeId = a;
            function C(ee) {
              return !ee || !e2.isNamedImports(ee) ? false : e2.some(ee.elements, w);
            }
            function w(ee) {
              return ee.propertyName !== void 0 && ee.propertyName.escapedText === "default";
            }
            function B(ee, he) {
              return F2;
              function F2(X) {
                return X.kind === 305 ? he(X) : x2(X);
              }
              function x2(X) {
                return ee.factory.createBundle(e2.map(X.sourceFiles, he), X.prepends);
              }
            }
            e2.chainBundle = B;
            function E(ee) {
              return !!e2.getNamespaceDeclarationNode(ee);
            }
            e2.getExportNeedsImportStarHelper = E;
            function Q(ee) {
              if (e2.getNamespaceDeclarationNode(ee))
                return true;
              var he = ee.importClause && ee.importClause.namedBindings;
              if (!he || !e2.isNamedImports(he))
                return false;
              for (var F2 = 0, x2 = 0, X = he.elements; x2 < X.length; x2++) {
                var $ = X[x2];
                w($) && F2++;
              }
              return F2 > 0 && F2 !== he.elements.length || !!(he.elements.length - F2) && e2.isDefaultImport(ee);
            }
            e2.getImportNeedsImportStarHelper = Q;
            function le(ee) {
              return !Q(ee) && (e2.isDefaultImport(ee) || !!ee.importClause && e2.isNamedImports(ee.importClause.namedBindings) && C(ee.importClause.namedBindings));
            }
            e2.getImportNeedsImportDefaultHelper = le;
            function N(ee, he, F2, x2) {
              for (var X = [], $ = e2.createMultiMap(), A2 = [], y = new e2.Map(), V, L = false, P, k = false, Y = false, U = false, j = 0, H = he.statements; j < H.length; j++) {
                var I = H[j];
                switch (I.kind) {
                  case 266:
                    X.push(I), !Y && Q(I) && (Y = true), !U && le(I) && (U = true);
                    break;
                  case 265:
                    I.moduleReference.kind === 277 && X.push(I);
                    break;
                  case 272:
                    if (I.moduleSpecifier)
                      if (!I.exportClause)
                        X.push(I), k = true;
                      else if (X.push(I), e2.isNamedExports(I.exportClause))
                        ne(I);
                      else {
                        var l = I.exportClause.name;
                        y.get(e2.idText(l)) || (m2(A2, a(I), l), y.set(e2.idText(l), true), V = e2.append(V, l)), Y = true;
                      }
                    else
                      ne(I);
                    break;
                  case 271:
                    I.isExportEquals && !P && (P = I);
                    break;
                  case 237:
                    if (e2.hasSyntacticModifier(I, 1))
                      for (var d = 0, D = I.declarationList.declarations; d < D.length; d++) {
                        var fe = D[d];
                        V = p(fe, y, V);
                      }
                    break;
                  case 256:
                    if (e2.hasSyntacticModifier(I, 1))
                      if (e2.hasSyntacticModifier(I, 512))
                        L || (m2(A2, a(I), ee.factory.getDeclarationName(I)), L = true);
                      else {
                        var l = I.name;
                        y.get(e2.idText(l)) || (m2(A2, a(I), l), y.set(e2.idText(l), true), V = e2.append(V, l));
                      }
                    break;
                  case 257:
                    if (e2.hasSyntacticModifier(I, 1))
                      if (e2.hasSyntacticModifier(I, 512))
                        L || (m2(A2, a(I), ee.factory.getDeclarationName(I)), L = true);
                      else {
                        var l = I.name;
                        l && !y.get(e2.idText(l)) && (m2(A2, a(I), l), y.set(e2.idText(l), true), V = e2.append(V, l));
                      }
                    break;
                }
              }
              var g = e2.createExternalHelpersImportDeclarationIfNeeded(ee.factory, ee.getEmitHelperFactory(), he, x2, k, Y, U);
              return g && X.unshift(g), { externalImports: X, exportSpecifiers: $, exportEquals: P, hasExportStarsToExportValues: k, exportedBindings: A2, exportedNames: V, externalHelpersImportDeclaration: g };
              function ne(ue) {
                for (var We = 0, Fe = e2.cast(ue.exportClause, e2.isNamedExports).elements; We < Fe.length; We++) {
                  var Z2 = Fe[We];
                  if (!y.get(e2.idText(Z2.name))) {
                    var Be = Z2.propertyName || Z2.name;
                    ue.moduleSpecifier || $.add(e2.idText(Be), Z2);
                    var ge = F2.getReferencedImportDeclaration(Be) || F2.getReferencedValueDeclaration(Be);
                    ge && m2(A2, a(ge), Z2.name), y.set(e2.idText(Z2.name), true), V = e2.append(V, Z2.name);
                  }
                }
              }
            }
            e2.collectExternalModuleInfo = N;
            function p(ee, he, F2) {
              if (e2.isBindingPattern(ee.name))
                for (var x2 = 0, X = ee.name.elements; x2 < X.length; x2++) {
                  var $ = X[x2];
                  e2.isOmittedExpression($) || (F2 = p($, he, F2));
                }
              else if (!e2.isGeneratedIdentifier(ee.name)) {
                var A2 = e2.idText(ee.name);
                he.get(A2) || (he.set(A2, true), F2 = e2.append(F2, ee.name));
              }
              return F2;
            }
            function m2(ee, he, F2) {
              var x2 = ee[he];
              return x2 ? x2.push(F2) : ee[he] = x2 = [F2], x2;
            }
            function G(ee) {
              return e2.isStringLiteralLike(ee) || ee.kind === 8 || e2.isKeyword(ee.kind) || e2.isIdentifier(ee);
            }
            e2.isSimpleCopiableExpression = G;
            function oe(ee) {
              return !e2.isIdentifier(ee) && G(ee);
            }
            e2.isSimpleInlineableExpression = oe;
            function f4(ee) {
              return ee >= 64 && ee <= 78;
            }
            e2.isCompoundAssignment = f4;
            function T(ee) {
              switch (ee) {
                case 64:
                  return 39;
                case 65:
                  return 40;
                case 66:
                  return 41;
                case 67:
                  return 42;
                case 68:
                  return 43;
                case 69:
                  return 44;
                case 70:
                  return 47;
                case 71:
                  return 48;
                case 72:
                  return 49;
                case 73:
                  return 50;
                case 74:
                  return 51;
                case 78:
                  return 52;
                case 75:
                  return 56;
                case 76:
                  return 55;
                case 77:
                  return 60;
              }
            }
            e2.getNonAssignmentOperatorForCompoundAssignment = T;
            function K(ee) {
              if (!!e2.isExpressionStatement(ee)) {
                var he = e2.skipParentheses(ee.expression);
                return e2.isSuperCall(he) ? he : void 0;
              }
            }
            e2.getSuperCallFromStatement = K;
            function b(ee, he) {
              for (var F2 = he; F2 < ee.length; F2 += 1) {
                var x2 = ee[F2];
                if (K(x2))
                  return F2;
              }
              return -1;
            }
            e2.findSuperStatementIndex = b;
            function se(ee, he, F2) {
              return e2.filter(ee.members, function(x2) {
                return R(x2, he, F2);
              });
            }
            e2.getProperties = se;
            function J(ee) {
              return q(ee) || e2.isClassStaticBlockDeclaration(ee);
            }
            function ie(ee) {
              return e2.filter(ee.members, J);
            }
            e2.getStaticPropertiesAndClassStaticBlock = ie;
            function R(ee, he, F2) {
              return e2.isPropertyDeclaration(ee) && (!!ee.initializer || !he) && e2.hasStaticModifier(ee) === F2;
            }
            function q(ee) {
              return e2.isPropertyDeclaration(ee) && e2.hasStaticModifier(ee);
            }
            function O(ee) {
              return ee.kind === 167 && ee.initializer !== void 0;
            }
            e2.isInitializedProperty = O;
            function ve(ee) {
              return !e2.isStatic(ee) && e2.isMethodOrAccessor(ee) && e2.isPrivateIdentifier(ee.name);
            }
            e2.isNonStaticMethodOrAccessorWithPrivateName = ve;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(q) {
              q[q.All = 0] = "All", q[q.ObjectRest = 1] = "ObjectRest";
            })(a = e2.FlattenLevel || (e2.FlattenLevel = {}));
            function C(q, O, ve, ee, he, F2) {
              var x2 = q, X;
              if (e2.isDestructuringAssignment(q))
                for (X = q.right; e2.isEmptyArrayLiteral(q.left) || e2.isEmptyObjectLiteral(q.left); )
                  if (e2.isDestructuringAssignment(X))
                    x2 = q = X, X = q.right;
                  else
                    return e2.visitNode(X, O, e2.isExpression);
              var $, A2 = { context: ve, level: ee, downlevelIteration: !!ve.getCompilerOptions().downlevelIteration, hoistTempVariables: true, emitExpression: y, emitBindingOrAssignment: V, createArrayBindingOrAssignmentPattern: function(L) {
                return b(ve.factory, L);
              }, createObjectBindingOrAssignmentPattern: function(L) {
                return J(ve.factory, L);
              }, createArrayBindingOrAssignmentElement: R, visitor: O };
              if (X && (X = e2.visitNode(X, O, e2.isExpression), e2.isIdentifier(X) && w(q, X.escapedText) || E(q) ? X = T(A2, X, false, x2) : he ? X = T(A2, X, true, x2) : e2.nodeIsSynthesized(q) && (x2 = X)), N(A2, q, X, x2, e2.isDestructuringAssignment(q)), X && he) {
                if (!e2.some($))
                  return X;
                $.push(X);
              }
              return ve.factory.inlineExpressions($) || ve.factory.createOmittedExpression();
              function y(L) {
                $ = e2.append($, L);
              }
              function V(L, P, k, Y) {
                e2.Debug.assertNode(L, F2 ? e2.isIdentifier : e2.isExpression);
                var U = F2 ? F2(L, P, k) : e2.setTextRange(ve.factory.createAssignment(e2.visitNode(L, O, e2.isExpression), P), k);
                U.original = Y, y(U);
              }
            }
            e2.flattenDestructuringAssignment = C;
            function w(q, O) {
              var ve = e2.getTargetOfBindingOrAssignmentElement(q);
              return e2.isBindingOrAssignmentPattern(ve) ? B(ve, O) : e2.isIdentifier(ve) ? ve.escapedText === O : false;
            }
            function B(q, O) {
              for (var ve = e2.getElementsOfBindingOrAssignmentPattern(q), ee = 0, he = ve; ee < he.length; ee++) {
                var F2 = he[ee];
                if (w(F2, O))
                  return true;
              }
              return false;
            }
            function E(q) {
              var O = e2.tryGetPropertyNameOfBindingOrAssignmentElement(q);
              if (O && e2.isComputedPropertyName(O) && !e2.isLiteralExpression(O.expression))
                return true;
              var ve = e2.getTargetOfBindingOrAssignmentElement(q);
              return !!ve && e2.isBindingOrAssignmentPattern(ve) && Q(ve);
            }
            function Q(q) {
              return !!e2.forEach(e2.getElementsOfBindingOrAssignmentPattern(q), E);
            }
            function le(q, O, ve, ee, he, F2, x2) {
              F2 === void 0 && (F2 = false);
              var X, $ = [], A2 = [], y = { context: ve, level: ee, downlevelIteration: !!ve.getCompilerOptions().downlevelIteration, hoistTempVariables: F2, emitExpression: fe, emitBindingOrAssignment: g, createArrayBindingOrAssignmentPattern: function(ne) {
                return K(ve.factory, ne);
              }, createObjectBindingOrAssignmentPattern: function(ne) {
                return se(ve.factory, ne);
              }, createArrayBindingOrAssignmentElement: function(ne) {
                return ie(ve.factory, ne);
              }, visitor: O };
              if (e2.isVariableDeclaration(q)) {
                var V = e2.getInitializerOfBindingOrAssignmentElement(q);
                V && (e2.isIdentifier(V) && w(q, V.escapedText) || E(q)) && (V = T(y, e2.visitNode(V, y.visitor), false, V), q = ve.factory.updateVariableDeclaration(q, q.name, void 0, void 0, V));
              }
              if (N(y, q, he, q, x2), X) {
                var L = ve.factory.createTempVariable(void 0);
                if (F2) {
                  var P = ve.factory.inlineExpressions(X);
                  X = void 0, g(L, P, void 0, void 0);
                } else {
                  ve.hoistVariableDeclaration(L);
                  var k = e2.last($);
                  k.pendingExpressions = e2.append(k.pendingExpressions, ve.factory.createAssignment(L, k.value)), e2.addRange(k.pendingExpressions, X), k.value = L;
                }
              }
              for (var Y = 0, U = $; Y < U.length; Y++) {
                var j = U[Y], H = j.pendingExpressions, I = j.name, P = j.value, l = j.location, d = j.original, D = ve.factory.createVariableDeclaration(I, void 0, void 0, H ? ve.factory.inlineExpressions(e2.append(H, P)) : P);
                D.original = d, e2.setTextRange(D, l), A2.push(D);
              }
              return A2;
              function fe(ne) {
                X = e2.append(X, ne);
              }
              function g(ne, ue, We, Fe) {
                e2.Debug.assertNode(ne, e2.isBindingName), X && (ue = ve.factory.inlineExpressions(e2.append(X, ue)), X = void 0), $.push({ pendingExpressions: X, name: ne, value: ue, location: We, original: Fe });
              }
            }
            e2.flattenDestructuringBinding = le;
            function N(q, O, ve, ee, he) {
              var F2 = e2.getTargetOfBindingOrAssignmentElement(O);
              if (!he) {
                var x2 = e2.visitNode(e2.getInitializerOfBindingOrAssignmentElement(O), q.visitor, e2.isExpression);
                x2 ? ve ? (ve = oe(q, ve, x2, ee), !e2.isSimpleInlineableExpression(x2) && e2.isBindingOrAssignmentPattern(F2) && (ve = T(q, ve, true, ee))) : ve = x2 : ve || (ve = q.context.factory.createVoidZero());
              }
              e2.isObjectBindingOrAssignmentPattern(F2) ? p(q, O, F2, ve, ee) : e2.isArrayBindingOrAssignmentPattern(F2) ? m2(q, O, F2, ve, ee) : q.emitBindingOrAssignment(F2, ve, ee, O);
            }
            function p(q, O, ve, ee, he) {
              var F2 = e2.getElementsOfBindingOrAssignmentPattern(ve), x2 = F2.length;
              if (x2 !== 1) {
                var X = !e2.isDeclarationBindingElement(O) || x2 !== 0;
                ee = T(q, ee, X, he);
              }
              for (var $, A2, y = 0; y < x2; y++) {
                var V = F2[y];
                if (e2.getRestIndicatorOfBindingOrAssignmentElement(V)) {
                  if (y === x2 - 1) {
                    $ && (q.emitBindingOrAssignment(q.createObjectBindingOrAssignmentPattern($), ee, he, ve), $ = void 0);
                    var P = q.context.getEmitHelperFactory().createRestHelper(ee, F2, A2, ve);
                    N(q, V, P, V);
                  }
                } else {
                  var L = e2.getPropertyNameOfBindingOrAssignmentElement(V);
                  if (q.level >= 1 && !(V.transformFlags & 49152) && !(e2.getTargetOfBindingOrAssignmentElement(V).transformFlags & 49152) && !e2.isComputedPropertyName(L))
                    $ = e2.append($, e2.visitNode(V, q.visitor));
                  else {
                    $ && (q.emitBindingOrAssignment(q.createObjectBindingOrAssignmentPattern($), ee, he, ve), $ = void 0);
                    var P = f4(q, ee, L);
                    e2.isComputedPropertyName(L) && (A2 = e2.append(A2, P.argumentExpression)), N(q, V, P, V);
                  }
                }
              }
              $ && q.emitBindingOrAssignment(q.createObjectBindingOrAssignmentPattern($), ee, he, ve);
            }
            function m2(q, O, ve, ee, he) {
              var F2 = e2.getElementsOfBindingOrAssignmentPattern(ve), x2 = F2.length;
              if (q.level < 1 && q.downlevelIteration)
                ee = T(q, e2.setTextRange(q.context.getEmitHelperFactory().createReadHelper(ee, x2 > 0 && e2.getRestIndicatorOfBindingOrAssignmentElement(F2[x2 - 1]) ? void 0 : x2), he), false, he);
              else if (x2 !== 1 && (q.level < 1 || x2 === 0) || e2.every(F2, e2.isOmittedExpression)) {
                var X = !e2.isDeclarationBindingElement(O) || x2 !== 0;
                ee = T(q, ee, X, he);
              }
              for (var $, A2, y = 0; y < x2; y++) {
                var V = F2[y];
                if (q.level >= 1)
                  if (V.transformFlags & 32768 || q.hasTransformedPriorElement && !G(V)) {
                    q.hasTransformedPriorElement = true;
                    var L = q.context.factory.createTempVariable(void 0);
                    q.hoistTempVariables && q.context.hoistVariableDeclaration(L), A2 = e2.append(A2, [L, V]), $ = e2.append($, q.createArrayBindingOrAssignmentElement(L));
                  } else
                    $ = e2.append($, V);
                else {
                  if (e2.isOmittedExpression(V))
                    continue;
                  if (e2.getRestIndicatorOfBindingOrAssignmentElement(V)) {
                    if (y === x2 - 1) {
                      var P = q.context.factory.createArraySliceCall(ee, y);
                      N(q, V, P, V);
                    }
                  } else {
                    var P = q.context.factory.createElementAccessExpression(ee, y);
                    N(q, V, P, V);
                  }
                }
              }
              if ($ && q.emitBindingOrAssignment(q.createArrayBindingOrAssignmentPattern($), ee, he, ve), A2)
                for (var k = 0, Y = A2; k < Y.length; k++) {
                  var U = Y[k], j = U[0], V = U[1];
                  N(q, V, j, V);
                }
            }
            function G(q) {
              var O = e2.getTargetOfBindingOrAssignmentElement(q);
              if (!O || e2.isOmittedExpression(O))
                return true;
              var ve = e2.tryGetPropertyNameOfBindingOrAssignmentElement(q);
              if (ve && !e2.isPropertyNameLiteral(ve))
                return false;
              var ee = e2.getInitializerOfBindingOrAssignmentElement(q);
              return ee && !e2.isSimpleInlineableExpression(ee) ? false : e2.isBindingOrAssignmentPattern(O) ? e2.every(e2.getElementsOfBindingOrAssignmentPattern(O), G) : e2.isIdentifier(O);
            }
            function oe(q, O, ve, ee) {
              return O = T(q, O, true, ee), q.context.factory.createConditionalExpression(q.context.factory.createTypeCheck(O, "undefined"), void 0, ve, void 0, O);
            }
            function f4(q, O, ve) {
              if (e2.isComputedPropertyName(ve)) {
                var ee = T(q, e2.visitNode(ve.expression, q.visitor), false, ve);
                return q.context.factory.createElementAccessExpression(O, ee);
              } else if (e2.isStringOrNumericLiteralLike(ve)) {
                var ee = e2.factory.cloneNode(ve);
                return q.context.factory.createElementAccessExpression(O, ee);
              } else {
                var he = q.context.factory.createIdentifier(e2.idText(ve));
                return q.context.factory.createPropertyAccessExpression(O, he);
              }
            }
            function T(q, O, ve, ee) {
              if (e2.isIdentifier(O) && ve)
                return O;
              var he = q.context.factory.createTempVariable(void 0);
              return q.hoistTempVariables ? (q.context.hoistVariableDeclaration(he), q.emitExpression(e2.setTextRange(q.context.factory.createAssignment(he, O), ee))) : q.emitBindingOrAssignment(he, O, ee, void 0), he;
            }
            function K(q, O) {
              return e2.Debug.assertEachNode(O, e2.isArrayBindingElement), q.createArrayBindingPattern(O);
            }
            function b(q, O) {
              return q.createArrayLiteralExpression(e2.map(O, q.converters.convertToArrayAssignmentElement));
            }
            function se(q, O) {
              return e2.Debug.assertEachNode(O, e2.isBindingElement), q.createObjectBindingPattern(O);
            }
            function J(q, O) {
              return q.createObjectLiteralExpression(e2.map(O, q.converters.convertToObjectAssignmentElement));
            }
            function ie(q, O) {
              return q.createBindingElement(void 0, void 0, O);
            }
            function R(q) {
              return q;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(E) {
              E[E.LiftRestriction = 0] = "LiftRestriction", E[E.All = 1] = "All";
            })(a = e2.ProcessLevel || (e2.ProcessLevel = {}));
            function C(E, Q, le, N, p, m2) {
              var G = e2.visitNode(Q.tag, le, e2.isExpression), oe = [void 0], f4 = [], T = [], K = Q.template;
              if (m2 === a.LiftRestriction && !e2.hasInvalidEscape(K))
                return e2.visitEachChild(Q, le, E);
              if (e2.isNoSubstitutionTemplateLiteral(K))
                f4.push(w(K)), T.push(B(K, N));
              else {
                f4.push(w(K.head)), T.push(B(K.head, N));
                for (var b = 0, se = K.templateSpans; b < se.length; b++) {
                  var J = se[b];
                  f4.push(w(J.literal)), T.push(B(J.literal, N)), oe.push(e2.visitNode(J.expression, le, e2.isExpression));
                }
              }
              var ie = E.getEmitHelperFactory().createTemplateObjectHelper(e2.factory.createArrayLiteralExpression(f4), e2.factory.createArrayLiteralExpression(T));
              if (e2.isExternalModule(N)) {
                var R = e2.factory.createUniqueName("templateObject");
                p(R), oe[0] = e2.factory.createLogicalOr(R, e2.factory.createAssignment(R, ie));
              } else
                oe[0] = ie;
              return e2.factory.createCallExpression(G, void 0, oe);
            }
            e2.processTaggedTemplateExpression = C;
            function w(E) {
              return E.templateFlags ? e2.factory.createVoidZero() : e2.factory.createStringLiteral(E.text);
            }
            function B(E, Q) {
              var le = E.rawText;
              if (le === void 0) {
                e2.Debug.assertIsDefined(Q, "Template literal node is missing 'rawText' and does not have a source file. Possibly bad transform."), le = e2.getSourceTextOfNodeFromSourceFile(Q, E);
                var N = E.kind === 14 || E.kind === 17;
                le = le.substring(1, le.length - (N ? 1 : 2));
              }
              return le = le.replace(/\r\n?/g, `
`), e2.setTextRange(e2.factory.createStringLiteral(le), E);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = false, C;
            (function(E) {
              E[E.ClassAliases = 1] = "ClassAliases", E[E.NamespaceExports = 2] = "NamespaceExports", E[E.NonQualifiedEnumMembers = 8] = "NonQualifiedEnumMembers";
            })(C || (C = {}));
            var w;
            (function(E) {
              E[E.None = 0] = "None", E[E.HasStaticInitializedProperties = 1] = "HasStaticInitializedProperties", E[E.HasConstructorDecorators = 2] = "HasConstructorDecorators", E[E.HasMemberDecorators = 4] = "HasMemberDecorators", E[E.IsExportOfNamespace = 8] = "IsExportOfNamespace", E[E.IsNamedExternalExport = 16] = "IsNamedExternalExport", E[E.IsDefaultExternalExport = 32] = "IsDefaultExternalExport", E[E.IsDerivedClass = 64] = "IsDerivedClass", E[E.UseImmediatelyInvokedFunctionExpression = 128] = "UseImmediatelyInvokedFunctionExpression", E[E.HasAnyDecorators = 6] = "HasAnyDecorators", E[E.NeedsName = 5] = "NeedsName", E[E.MayNeedImmediatelyInvokedFunctionExpression = 7] = "MayNeedImmediatelyInvokedFunctionExpression", E[E.IsExported = 56] = "IsExported";
            })(w || (w = {}));
            function B(E) {
              var Q = E.factory, le = E.getEmitHelperFactory, N = E.startLexicalEnvironment, p = E.resumeLexicalEnvironment, m2 = E.endLexicalEnvironment, G = E.hoistVariableDeclaration, oe = E.getEmitResolver(), f4 = E.getCompilerOptions(), T = e2.getStrictOptionValue(f4, "strictNullChecks"), K = e2.getEmitScriptTarget(f4), b = e2.getEmitModuleKind(f4), se = E.onEmitNode, J = E.onSubstituteNode;
              E.onEmitNode = Co, E.onSubstituteNode = Ko, E.enableSubstitution(206), E.enableSubstitution(207);
              var ie, R, q, O, ve, ee, he, F2, x2, X;
              return $;
              function $(S2) {
                return S2.kind === 306 ? A2(S2) : y(S2);
              }
              function A2(S2) {
                return Q.createBundle(S2.sourceFiles.map(y), e2.mapDefined(S2.prepends, function(Ce) {
                  return Ce.kind === 308 ? e2.createUnparsedSourceFile(Ce, "js") : Ce;
                }));
              }
              function y(S2) {
                if (S2.isDeclarationFile)
                  return S2;
                ie = S2;
                var Ce = V(S2, g);
                return e2.addEmitHelpers(Ce, E.readEmitHelpers()), ie = void 0, Ce;
              }
              function V(S2, Ce) {
                var qe = O, br = ve, Zr = ee, Si = he;
                L(S2);
                var Pi = Ce(S2);
                return O !== qe && (ee = Zr), O = qe, ve = br, he = Si, Pi;
              }
              function L(S2) {
                switch (S2.kind) {
                  case 305:
                  case 263:
                  case 262:
                  case 235:
                    O = S2, ve = void 0, ee = void 0;
                    break;
                  case 257:
                  case 256:
                    if (e2.hasSyntacticModifier(S2, 2))
                      break;
                    S2.name ? ut(S2) : e2.Debug.assert(S2.kind === 257 || e2.hasSyntacticModifier(S2, 512)), e2.isClassDeclaration(S2) && (ve = S2);
                    break;
                }
              }
              function P(S2) {
                return V(S2, k);
              }
              function k(S2) {
                return S2.transformFlags & 1 ? fe(S2) : S2;
              }
              function Y(S2) {
                return V(S2, U);
              }
              function U(S2) {
                switch (S2.kind) {
                  case 266:
                  case 265:
                  case 271:
                  case 272:
                    return j(S2);
                  default:
                    return k(S2);
                }
              }
              function j(S2) {
                var Ce = e2.getParseTreeNode(S2);
                if (Ce !== S2)
                  return S2.transformFlags & 1 ? e2.visitEachChild(S2, P, E) : S2;
                switch (S2.kind) {
                  case 266:
                    return Bt(S2);
                  case 265:
                    return Qa(S2);
                  case 271:
                    return Oi(S2);
                  case 272:
                    return ji(S2);
                  default:
                    e2.Debug.fail("Unhandled ellided statement");
                }
              }
              function H(S2) {
                return V(S2, I);
              }
              function I(S2) {
                if (!(S2.kind === 272 || S2.kind === 266 || S2.kind === 267 || S2.kind === 265 && S2.moduleReference.kind === 277))
                  return S2.transformFlags & 1 || e2.hasSyntacticModifier(S2, 1) ? fe(S2) : S2;
              }
              function l(S2) {
                return V(S2, d);
              }
              function d(S2) {
                switch (S2.kind) {
                  case 171:
                    return ti(S2);
                  case 167:
                    return Jr(S2);
                  case 176:
                  case 172:
                  case 173:
                  case 169:
                  case 170:
                    return k(S2);
                  case 234:
                    return S2;
                  default:
                    return e2.Debug.failBadSyntaxKind(S2);
                }
              }
              function D(S2) {
                if (!(e2.modifierToFlag(S2.kind) & 116958) && !(R && S2.kind === 93))
                  return S2;
              }
              function fe(S2) {
                if (e2.isStatement(S2) && e2.hasSyntacticModifier(S2, 2))
                  return Q.createNotEmittedStatement(S2);
                switch (S2.kind) {
                  case 93:
                  case 88:
                    return R ? void 0 : S2;
                  case 123:
                  case 121:
                  case 122:
                  case 126:
                  case 159:
                  case 85:
                  case 135:
                  case 145:
                  case 101:
                  case 144:
                  case 183:
                  case 184:
                  case 185:
                  case 186:
                  case 182:
                  case 177:
                  case 163:
                  case 130:
                  case 155:
                  case 133:
                  case 150:
                  case 147:
                  case 143:
                  case 114:
                  case 151:
                  case 180:
                  case 179:
                  case 181:
                  case 178:
                  case 187:
                  case 188:
                  case 189:
                  case 191:
                  case 192:
                  case 193:
                  case 194:
                  case 195:
                  case 196:
                  case 176:
                  case 165:
                    return;
                  case 259:
                    return Q.createNotEmittedStatement(S2);
                  case 167:
                    return Jr(S2);
                  case 264:
                    return;
                  case 171:
                    return ti(S2);
                  case 258:
                    return Q.createNotEmittedStatement(S2);
                  case 257:
                    return Fe(S2);
                  case 226:
                    return ge(S2);
                  case 291:
                    return pi(S2);
                  case 228:
                    return ae(S2);
                  case 169:
                    return zr(S2);
                  case 172:
                    return Je(S2);
                  case 173:
                    return xe(S2);
                  case 256:
                    return vr(S2);
                  case 213:
                    return mr(S2);
                  case 214:
                    return Ar(S2);
                  case 164:
                    return Oe(S2);
                  case 212:
                    return Ue(S2);
                  case 211:
                  case 229:
                    return fr(S2);
                  case 208:
                    return gr(S2);
                  case 209:
                    return Vr(S2);
                  case 210:
                    return Tr(S2);
                  case 230:
                    return De(S2);
                  case 260:
                    return Wi(S2);
                  case 237:
                    return nr(S2);
                  case 254:
                    return Pe(S2);
                  case 261:
                    return Ki(S2);
                  case 265:
                    return Qa(S2);
                  case 279:
                    return vi(S2);
                  case 280:
                    return Ui(S2);
                  default:
                    return e2.visitEachChild(S2, P, E);
                }
              }
              function g(S2) {
                var Ce = e2.getStrictOptionValue(f4, "alwaysStrict") && !(e2.isExternalModule(S2) && b >= e2.ModuleKind.ES2015) && !e2.isJsonSourceFile(S2);
                return Q.updateSourceFile(S2, e2.visitLexicalEnvironment(S2.statements, Y, E, 0, Ce));
              }
              function ne(S2, Ce) {
                var qe = 0;
                e2.some(Ce) && (qe |= 1);
                var br = e2.getEffectiveBaseTypeNode(S2);
                return br && e2.skipOuterExpressions(br.expression).kind !== 104 && (qe |= 64), e2.classOrConstructorParameterIsDecorated(S2) && (qe |= 2), e2.childIsDecorated(S2) && (qe |= 4), ai(S2) ? qe |= 8 : Ba(S2) ? qe |= 32 : ka(S2) && (qe |= 16), K <= 1 && qe & 7 && (qe |= 128), qe;
              }
              function ue(S2) {
                return !!(S2.transformFlags & 4096);
              }
              function We(S2) {
                return e2.some(S2.decorators) || e2.some(S2.typeParameters) || e2.some(S2.heritageClauses, ue) || e2.some(S2.members, ue);
              }
              function Fe(S2) {
                if (!We(S2) && !(R && e2.hasSyntacticModifier(S2, 1)))
                  return e2.visitEachChild(S2, P, E);
                var Ce = e2.getProperties(S2, true, true), qe = ne(S2, Ce);
                qe & 128 && E.startLexicalEnvironment();
                var br = S2.name || (qe & 5 ? Q.getGeneratedNameForNode(S2) : void 0), Zr = qe & 2 ? Be(S2, br) : Z2(S2, br, qe), Si = [Zr];
                if (ir(Si, S2, false), ir(Si, S2, true), Br(Si, S2), qe & 128) {
                  var Pi = e2.createTokenRange(e2.skipTrivia(ie.text, S2.members.end), 19), Qi = Q.getInternalName(S2), Ct = Q.createPartiallyEmittedExpression(Qi);
                  e2.setTextRangeEnd(Ct, Pi.end), e2.setEmitFlags(Ct, 1536);
                  var sa = Q.createReturnStatement(Ct);
                  e2.setTextRangePos(sa, Pi.pos), e2.setEmitFlags(sa, 1920), Si.push(sa), e2.insertStatementsAfterStandardPrologue(Si, E.endLexicalEnvironment());
                  var en = Q.createImmediatelyInvokedArrowFunction(Si);
                  e2.setEmitFlags(en, 33554432);
                  var Wa = Q.createVariableStatement(void 0, Q.createVariableDeclarationList([Q.createVariableDeclaration(Q.getLocalName(S2, false, false), void 0, void 0, en)]));
                  e2.setOriginalNode(Wa, S2), e2.setCommentRange(Wa, S2), e2.setSourceMapRange(Wa, e2.moveRangePastDecorators(S2)), e2.startOnNewLine(Wa), Si = [Wa];
                }
                return qe & 8 ? Cn(Si, S2) : (qe & 128 || qe & 2) && (qe & 32 ? Si.push(Q.createExportDefault(Q.getLocalName(S2, false, true))) : qe & 16 && Si.push(Q.createExternalModuleExport(Q.getLocalName(S2, false, true)))), Si.length > 1 && (Si.push(Q.createEndOfDeclarationMarker(S2)), e2.setEmitFlags(Zr, e2.getEmitFlags(Zr) | 4194304)), e2.singleOrMany(Si);
              }
              function Z2(S2, Ce, qe) {
                var br = qe & 128 ? void 0 : e2.visitNodes(S2.modifiers, D, e2.isModifier), Zr = Q.createClassDeclaration(void 0, br, Ce, void 0, e2.visitNodes(S2.heritageClauses, P, e2.isHeritageClause), Re(S2)), Si = e2.getEmitFlags(S2);
                return qe & 1 && (Si |= 32), e2.setTextRange(Zr, S2), e2.setOriginalNode(Zr, S2), e2.setEmitFlags(Zr, Si), Zr;
              }
              function Be(S2, Ce) {
                var qe = e2.moveRangePastDecorators(S2), br = eo(S2), Zr = K <= 2 ? Q.getInternalName(S2, false, true) : Q.getLocalName(S2, false, true), Si = e2.visitNodes(S2.heritageClauses, P, e2.isHeritageClause), Pi = Re(S2), Qi = Q.createClassExpression(void 0, void 0, Ce, void 0, Si, Pi);
                e2.setOriginalNode(Qi, S2), e2.setTextRange(Qi, qe);
                var Ct = Q.createVariableStatement(void 0, Q.createVariableDeclarationList([Q.createVariableDeclaration(Zr, void 0, void 0, br ? Q.createAssignment(br, Qi) : Qi)], 1));
                return e2.setOriginalNode(Ct, S2), e2.setTextRange(Ct, qe), e2.setCommentRange(Ct, S2), Ct;
              }
              function ge(S2) {
                if (!We(S2))
                  return e2.visitEachChild(S2, P, E);
                var Ce = Q.createClassExpression(void 0, void 0, S2.name, void 0, e2.visitNodes(S2.heritageClauses, P, e2.isHeritageClause), Re(S2));
                return e2.setOriginalNode(Ce, S2), e2.setTextRange(Ce, S2), Ce;
              }
              function Re(S2) {
                var Ce = [], qe = e2.getFirstConstructorWithBody(S2), br = qe && e2.filter(qe.parameters, function(Qi) {
                  return e2.isParameterPropertyDeclaration(Qi, qe);
                });
                if (br)
                  for (var Zr = 0, Si = br; Zr < Si.length; Zr++) {
                    var Pi = Si[Zr];
                    e2.isIdentifier(Pi.name) && Ce.push(e2.setOriginalNode(Q.createPropertyDeclaration(void 0, void 0, Pi.name, void 0, void 0, void 0), Pi));
                  }
                return e2.addRange(Ce, e2.visitNodes(S2.members, l, e2.isClassElement)), e2.setTextRange(Q.createNodeArray(Ce), S2.members);
              }
              function ze(S2, Ce) {
                return e2.filter(S2.members, Ce ? function(qe) {
                  return Ee(qe, S2);
                } : function(qe) {
                  return He(qe, S2);
                });
              }
              function Ee(S2, Ce) {
                return rr(S2, true, Ce);
              }
              function He(S2, Ce) {
                return rr(S2, false, Ce);
              }
              function rr(S2, Ce, qe) {
                return e2.nodeOrChildIsDecorated(S2, qe) && Ce === e2.isStatic(S2);
              }
              function Ie(S2) {
                var Ce;
                if (S2)
                  for (var qe = S2.parameters, br = qe.length > 0 && e2.parameterIsThisKeyword(qe[0]), Zr = br ? 1 : 0, Si = br ? qe.length - 1 : qe.length, Pi = 0; Pi < Si; Pi++) {
                    var Qi = qe[Pi + Zr];
                    (Ce || Qi.decorators) && (Ce || (Ce = new Array(Si)), Ce[Pi] = Qi.decorators);
                  }
                return Ce;
              }
              function _e(S2) {
                var Ce = S2.decorators, qe = Ie(e2.getFirstConstructorWithBody(S2));
                if (!(!Ce && !qe))
                  return { decorators: Ce, parameters: qe };
              }
              function we(S2, Ce) {
                switch (Ce.kind) {
                  case 172:
                  case 173:
                    return de(S2, Ce);
                  case 169:
                    return ye(Ce);
                  case 167:
                    return Ae(Ce);
                  default:
                    return;
                }
              }
              function de(S2, Ce) {
                if (!!Ce.body) {
                  var qe = e2.getAllAccessorDeclarations(S2.members, Ce), br = qe.firstAccessor, Zr = qe.secondAccessor, Si = qe.setAccessor, Pi = br.decorators ? br : Zr && Zr.decorators ? Zr : void 0;
                  if (!(!Pi || Ce !== Pi)) {
                    var Qi = Pi.decorators, Ct = Ie(Si);
                    if (!(!Qi && !Ct))
                      return { decorators: Qi, parameters: Ct };
                  }
                }
              }
              function ye(S2) {
                if (!!S2.body) {
                  var Ce = S2.decorators, qe = Ie(S2);
                  if (!(!Ce && !qe))
                    return { decorators: Ce, parameters: qe };
                }
              }
              function Ae(S2) {
                var Ce = S2.decorators;
                if (!!Ce)
                  return { decorators: Ce };
              }
              function er(S2, Ce, qe) {
                if (!!qe) {
                  var br = [];
                  return e2.addRange(br, e2.map(qe.decorators, Ne)), e2.addRange(br, e2.flatMap(qe.parameters, n)), lr(S2, Ce, br), br;
                }
              }
              function ir(S2, Ce, qe) {
                e2.addRange(S2, e2.map(Cr(Ce, qe), pn));
              }
              function Cr(S2, Ce) {
                for (var qe = ze(S2, Ce), br, Zr = 0, Si = qe; Zr < Si.length; Zr++) {
                  var Pi = Si[Zr], Qi = Ye(S2, Pi);
                  Qi && (br ? br.push(Qi) : br = [Qi]);
                }
                return br;
              }
              function Ye(S2, Ce) {
                var qe = we(S2, Ce), br = er(Ce, S2, qe);
                if (!!br) {
                  var Zr = Da(S2, Ce), Si = Zt(Ce, !e2.hasSyntacticModifier(Ce, 2)), Pi = K > 0 ? Ce.kind === 167 ? Q.createVoidZero() : Q.createNull() : void 0, Qi = le().createDecorateHelper(br, Zr, Si, Pi);
                  return e2.setTextRange(Qi, e2.moveRangePastDecorators(Ce)), e2.setEmitFlags(Qi, 1536), Qi;
                }
              }
              function Br(S2, Ce) {
                var qe = Er(Ce);
                qe && S2.push(e2.setOriginalNode(Q.createExpressionStatement(qe), Ce));
              }
              function Er(S2) {
                var Ce = _e(S2), qe = er(S2, S2, Ce);
                if (!!qe) {
                  var br = x2 && x2[e2.getOriginalNodeId(S2)], Zr = K <= 2 ? Q.getInternalName(S2, false, true) : Q.getLocalName(S2, false, true), Si = le().createDecorateHelper(qe, Zr), Pi = Q.createAssignment(Zr, br ? Q.createAssignment(br, Si) : Si);
                  return e2.setEmitFlags(Pi, 1536), e2.setSourceMapRange(Pi, e2.moveRangePastDecorators(S2)), Pi;
                }
              }
              function Ne(S2) {
                return e2.visitNode(S2.expression, P, e2.isExpression);
              }
              function n(S2, Ce) {
                var qe;
                if (S2) {
                  qe = [];
                  for (var br = 0, Zr = S2; br < Zr.length; br++) {
                    var Si = Zr[br], Pi = le().createParamHelper(Ne(Si), Ce);
                    e2.setTextRange(Pi, Si.expression), e2.setEmitFlags(Pi, 1536), qe.push(Pi);
                  }
                }
                return qe;
              }
              function lr(S2, Ce, qe) {
                a ? Ge(S2, Ce, qe) : be(S2, Ce, qe);
              }
              function be(S2, Ce, qe) {
                f4.emitDecoratorMetadata && (ur(S2) && qe.push(le().createMetadataHelper("design:type", Ur(S2))), Ir(S2) && qe.push(le().createMetadataHelper("design:paramtypes", ii(S2, Ce))), yr(S2) && qe.push(le().createMetadataHelper("design:returntype", pe(S2))));
              }
              function Ge(S2, Ce, qe) {
                if (f4.emitDecoratorMetadata) {
                  var br = void 0;
                  ur(S2) && (br || (br = [])).push(Q.createPropertyAssignment("type", Q.createArrowFunction(void 0, void 0, [], void 0, Q.createToken(38), Ur(S2)))), Ir(S2) && (br || (br = [])).push(Q.createPropertyAssignment("paramTypes", Q.createArrowFunction(void 0, void 0, [], void 0, Q.createToken(38), ii(S2, Ce)))), yr(S2) && (br || (br = [])).push(Q.createPropertyAssignment("returnType", Q.createArrowFunction(void 0, void 0, [], void 0, Q.createToken(38), pe(S2)))), br && qe.push(le().createMetadataHelper("design:typeinfo", Q.createObjectLiteralExpression(br, true)));
                }
              }
              function ur(S2) {
                var Ce = S2.kind;
                return Ce === 169 || Ce === 172 || Ce === 173 || Ce === 167;
              }
              function yr(S2) {
                return S2.kind === 169;
              }
              function Ir(S2) {
                switch (S2.kind) {
                  case 257:
                  case 226:
                    return e2.getFirstConstructorWithBody(S2) !== void 0;
                  case 169:
                  case 172:
                  case 173:
                    return true;
                }
                return false;
              }
              function wr(S2) {
                var Ce = oe.getAllAccessorDeclarations(S2);
                return Ce.setAccessor && e2.getSetAccessorTypeAnnotationNode(Ce.setAccessor) || Ce.getAccessor && e2.getEffectiveReturnTypeNode(Ce.getAccessor);
              }
              function Ur(S2) {
                switch (S2.kind) {
                  case 167:
                  case 164:
                    return or(S2.type);
                  case 173:
                  case 172:
                    return or(wr(S2));
                  case 257:
                  case 226:
                  case 169:
                    return Q.createIdentifier("Function");
                  default:
                    return Q.createVoidZero();
                }
              }
              function ii(S2, Ce) {
                var qe = e2.isClassLike(S2) ? e2.getFirstConstructorWithBody(S2) : e2.isFunctionLike(S2) && e2.nodeIsPresent(S2.body) ? S2 : void 0, br = [];
                if (qe)
                  for (var Zr = mi(qe, Ce), Si = Zr.length, Pi = 0; Pi < Si; Pi++) {
                    var Qi = Zr[Pi];
                    Pi === 0 && e2.isIdentifier(Qi.name) && Qi.name.escapedText === "this" || (Qi.dotDotDotToken ? br.push(or(e2.getRestParameterElementType(Qi.type))) : br.push(Ur(Qi)));
                  }
                return Q.createArrayLiteralExpression(br);
              }
              function mi(S2, Ce) {
                if (Ce && S2.kind === 172) {
                  var qe = e2.getAllAccessorDeclarations(Ce.members, S2).setAccessor;
                  if (qe)
                    return qe.parameters;
                }
                return S2.parameters;
              }
              function pe(S2) {
                return e2.isFunctionLike(S2) && S2.type ? or(S2.type) : e2.isAsyncFunction(S2) ? Q.createIdentifier("Promise") : Q.createVoidZero();
              }
              function or(S2) {
                if (S2 === void 0)
                  return Q.createIdentifier("Object");
                switch (S2.kind) {
                  case 114:
                  case 153:
                  case 143:
                    return Q.createVoidZero();
                  case 191:
                    return or(S2.type);
                  case 179:
                  case 180:
                    return Q.createIdentifier("Function");
                  case 183:
                  case 184:
                    return Q.createIdentifier("Array");
                  case 177:
                  case 133:
                    return Q.createIdentifier("Boolean");
                  case 198:
                  case 150:
                    return Q.createIdentifier("String");
                  case 148:
                    return Q.createIdentifier("Object");
                  case 196:
                    switch (S2.literal.kind) {
                      case 10:
                      case 14:
                        return Q.createIdentifier("String");
                      case 219:
                      case 8:
                        return Q.createIdentifier("Number");
                      case 9:
                        return Wt();
                      case 110:
                      case 95:
                        return Q.createIdentifier("Boolean");
                      case 104:
                        return Q.createVoidZero();
                      default:
                        return e2.Debug.failBadSyntaxKind(S2.literal);
                    }
                  case 147:
                    return Q.createIdentifier("Number");
                  case 158:
                    return Wt();
                  case 151:
                    return K < 2 ? Gi() : Q.createIdentifier("Symbol");
                  case 178:
                    return si(S2);
                  case 188:
                  case 187:
                    return qr(S2.types);
                  case 189:
                    return qr([S2.trueType, S2.falseType]);
                  case 193:
                    if (S2.operator === 145)
                      return or(S2.type);
                    break;
                  case 181:
                  case 194:
                  case 195:
                  case 182:
                  case 130:
                  case 155:
                  case 192:
                  case 200:
                    break;
                  case 312:
                  case 313:
                  case 317:
                  case 318:
                  case 319:
                    break;
                  case 314:
                  case 315:
                  case 316:
                    return or(S2.type);
                  default:
                    return e2.Debug.failBadSyntaxKind(S2);
                }
                return Q.createIdentifier("Object");
              }
              function qr(S2) {
                for (var Ce, qe = 0, br = S2; qe < br.length; qe++) {
                  for (var Zr = br[qe]; Zr.kind === 191; )
                    Zr = Zr.type;
                  if (Zr.kind !== 143 && !(!T && (Zr.kind === 196 && Zr.literal.kind === 104 || Zr.kind === 153))) {
                    var Si = or(Zr);
                    if (e2.isIdentifier(Si) && Si.escapedText === "Object")
                      return Si;
                    if (Ce) {
                      if (!e2.isIdentifier(Ce) || !e2.isIdentifier(Si) || Ce.escapedText !== Si.escapedText)
                        return Q.createIdentifier("Object");
                    } else
                      Ce = Si;
                  }
                }
                return Ce || Q.createVoidZero();
              }
              function si(S2) {
                var Ce = oe.getTypeReferenceSerializationKind(S2.typeName, ve || O);
                switch (Ce) {
                  case e2.TypeReferenceSerializationKind.Unknown:
                    if (e2.findAncestor(S2, function(Zr) {
                      return Zr.parent && e2.isConditionalTypeNode(Zr.parent) && (Zr.parent.trueType === Zr || Zr.parent.falseType === Zr);
                    }))
                      return Q.createIdentifier("Object");
                    var qe = wi(S2.typeName), br = Q.createTempVariable(G);
                    return Q.createConditionalExpression(Q.createTypeCheck(Q.createAssignment(br, qe), "function"), void 0, br, void 0, Q.createIdentifier("Object"));
                  case e2.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue:
                    return Xi(S2.typeName);
                  case e2.TypeReferenceSerializationKind.VoidNullableOrNeverType:
                    return Q.createVoidZero();
                  case e2.TypeReferenceSerializationKind.BigIntLikeType:
                    return Wt();
                  case e2.TypeReferenceSerializationKind.BooleanType:
                    return Q.createIdentifier("Boolean");
                  case e2.TypeReferenceSerializationKind.NumberLikeType:
                    return Q.createIdentifier("Number");
                  case e2.TypeReferenceSerializationKind.StringLikeType:
                    return Q.createIdentifier("String");
                  case e2.TypeReferenceSerializationKind.ArrayLikeType:
                    return Q.createIdentifier("Array");
                  case e2.TypeReferenceSerializationKind.ESSymbolType:
                    return K < 2 ? Gi() : Q.createIdentifier("Symbol");
                  case e2.TypeReferenceSerializationKind.TypeWithCallSignature:
                    return Q.createIdentifier("Function");
                  case e2.TypeReferenceSerializationKind.Promise:
                    return Q.createIdentifier("Promise");
                  case e2.TypeReferenceSerializationKind.ObjectType:
                    return Q.createIdentifier("Object");
                  default:
                    return e2.Debug.assertNever(Ce);
                }
              }
              function Di(S2, Ce) {
                return Q.createLogicalAnd(Q.createStrictInequality(Q.createTypeOfExpression(S2), Q.createStringLiteral("undefined")), Ce);
              }
              function wi(S2) {
                if (S2.kind === 79) {
                  var Ce = Xi(S2);
                  return Di(Ce, Ce);
                }
                if (S2.left.kind === 79)
                  return Di(Xi(S2.left), Xi(S2));
                var qe = wi(S2.left), br = Q.createTempVariable(G);
                return Q.createLogicalAnd(Q.createLogicalAnd(qe.left, Q.createStrictInequality(Q.createAssignment(br, qe.right), Q.createVoidZero())), Q.createPropertyAccessExpression(br, S2.right));
              }
              function Xi(S2) {
                switch (S2.kind) {
                  case 79:
                    var Ce = e2.setParent(e2.setTextRange(e2.parseNodeFactory.cloneNode(S2), S2), S2.parent);
                    return Ce.original = void 0, e2.setParent(Ce, e2.getParseTreeNode(O)), Ce;
                  case 161:
                    return et(S2);
                }
              }
              function et(S2) {
                return Q.createPropertyAccessExpression(Xi(S2.left), S2.right);
              }
              function Gi() {
                return Q.createConditionalExpression(Q.createTypeCheck(Q.createIdentifier("Symbol"), "function"), void 0, Q.createIdentifier("Symbol"), void 0, Q.createIdentifier("Object"));
              }
              function Wt() {
                return K < 99 ? Q.createConditionalExpression(Q.createTypeCheck(Q.createIdentifier("BigInt"), "function"), void 0, Q.createIdentifier("BigInt"), void 0, Q.createIdentifier("Object")) : Q.createIdentifier("BigInt");
              }
              function Zt(S2, Ce) {
                var qe = S2.name;
                return e2.isPrivateIdentifier(qe) ? Q.createIdentifier("") : e2.isComputedPropertyName(qe) ? Ce && !e2.isSimpleInlineableExpression(qe.expression) ? Q.getGeneratedNameForNode(qe) : qe.expression : e2.isIdentifier(qe) ? Q.createStringLiteral(e2.idText(qe)) : Q.cloneNode(qe);
              }
              function _r(S2) {
                var Ce = S2.name;
                if (e2.isComputedPropertyName(Ce) && (!e2.hasStaticModifier(S2) && he || e2.some(S2.decorators))) {
                  var qe = e2.visitNode(Ce.expression, P, e2.isExpression), br = e2.skipPartiallyEmittedExpressions(qe);
                  if (!e2.isSimpleInlineableExpression(br)) {
                    var Zr = Q.getGeneratedNameForNode(Ce);
                    return G(Zr), Q.updateComputedPropertyName(Ce, Q.createAssignment(Zr, qe));
                  }
                }
                return e2.visitNode(Ce, P, e2.isPropertyName);
              }
              function pi(S2) {
                if (S2.token !== 117)
                  return e2.visitEachChild(S2, P, E);
              }
              function ae(S2) {
                return Q.updateExpressionWithTypeArguments(S2, e2.visitNode(S2.expression, P, e2.isLeftHandSideExpression), void 0);
              }
              function Xe(S2) {
                return !e2.nodeIsMissing(S2.body);
              }
              function Jr(S2) {
                if (!(S2.flags & 16777216 || e2.hasSyntacticModifier(S2, 128))) {
                  var Ce = Q.updatePropertyDeclaration(S2, void 0, e2.visitNodes(S2.modifiers, P, e2.isModifier), _r(S2), void 0, void 0, e2.visitNode(S2.initializer, P));
                  return Ce !== S2 && (e2.setCommentRange(Ce, S2), e2.setSourceMapRange(Ce, e2.moveRangePastDecorators(S2))), Ce;
                }
              }
              function ti(S2) {
                if (!!Xe(S2))
                  return Q.updateConstructorDeclaration(S2, void 0, void 0, e2.visitParameterList(S2.parameters, P, E), Ze(S2.body, S2));
              }
              function Ze(S2, Ce) {
                var qe = Ce && e2.filter(Ce.parameters, function(Ct) {
                  return e2.isParameterPropertyDeclaration(Ct, Ce);
                });
                if (!e2.some(qe))
                  return e2.visitFunctionBody(S2, P, E);
                var br = [];
                p();
                var Zr = Q.copyPrologue(S2.statements, br, false, P), Si = e2.findSuperStatementIndex(S2.statements, Zr);
                Si >= 0 && e2.addRange(br, e2.visitNodes(S2.statements, P, e2.isStatement, Zr, Si + 1 - Zr));
                var Pi = e2.mapDefined(qe, Sr);
                Si >= 0 ? e2.addRange(br, Pi) : br = Ve(Ve(Ve([], br.slice(0, Zr), true), Pi, true), br.slice(Zr), true), e2.addRange(br, e2.visitNodes(S2.statements, P, e2.isStatement, Si + 1 + Zr)), br = Q.mergeLexicalEnvironment(br, m2());
                var Qi = Q.createBlock(e2.setTextRange(Q.createNodeArray(br), S2.statements), true);
                return e2.setTextRange(Qi, S2), e2.setOriginalNode(Qi, S2), Qi;
              }
              function Sr(S2) {
                var Ce = S2.name;
                if (!!e2.isIdentifier(Ce)) {
                  var qe = e2.setParent(e2.setTextRange(Q.cloneNode(Ce), Ce), Ce.parent);
                  e2.setEmitFlags(qe, 1584);
                  var br = e2.setParent(e2.setTextRange(Q.cloneNode(Ce), Ce), Ce.parent);
                  return e2.setEmitFlags(br, 1536), e2.startOnNewLine(e2.removeAllComments(e2.setTextRange(e2.setOriginalNode(Q.createExpressionStatement(Q.createAssignment(e2.setTextRange(Q.createPropertyAccessExpression(Q.createThis(), qe), S2.name), br)), S2), e2.moveRangePos(S2, -1))));
                }
              }
              function zr(S2) {
                if (!!Xe(S2)) {
                  var Ce = Q.updateMethodDeclaration(S2, void 0, e2.visitNodes(S2.modifiers, D, e2.isModifier), S2.asteriskToken, _r(S2), void 0, void 0, e2.visitParameterList(S2.parameters, P, E), void 0, e2.visitFunctionBody(S2.body, P, E));
                  return Ce !== S2 && (e2.setCommentRange(Ce, S2), e2.setSourceMapRange(Ce, e2.moveRangePastDecorators(S2))), Ce;
                }
              }
              function Wr(S2) {
                return !(e2.nodeIsMissing(S2.body) && e2.hasSyntacticModifier(S2, 128));
              }
              function Je(S2) {
                if (!!Wr(S2)) {
                  var Ce = Q.updateGetAccessorDeclaration(S2, void 0, e2.visitNodes(S2.modifiers, D, e2.isModifier), _r(S2), e2.visitParameterList(S2.parameters, P, E), void 0, e2.visitFunctionBody(S2.body, P, E) || Q.createBlock([]));
                  return Ce !== S2 && (e2.setCommentRange(Ce, S2), e2.setSourceMapRange(Ce, e2.moveRangePastDecorators(S2))), Ce;
                }
              }
              function xe(S2) {
                if (!!Wr(S2)) {
                  var Ce = Q.updateSetAccessorDeclaration(S2, void 0, e2.visitNodes(S2.modifiers, D, e2.isModifier), _r(S2), e2.visitParameterList(S2.parameters, P, E), e2.visitFunctionBody(S2.body, P, E) || Q.createBlock([]));
                  return Ce !== S2 && (e2.setCommentRange(Ce, S2), e2.setSourceMapRange(Ce, e2.moveRangePastDecorators(S2))), Ce;
                }
              }
              function vr(S2) {
                if (!Xe(S2))
                  return Q.createNotEmittedStatement(S2);
                var Ce = Q.updateFunctionDeclaration(S2, void 0, e2.visitNodes(S2.modifiers, D, e2.isModifier), S2.asteriskToken, S2.name, void 0, e2.visitParameterList(S2.parameters, P, E), void 0, e2.visitFunctionBody(S2.body, P, E) || Q.createBlock([]));
                if (ai(S2)) {
                  var qe = [Ce];
                  return Cn(qe, S2), qe;
                }
                return Ce;
              }
              function mr(S2) {
                if (!Xe(S2))
                  return Q.createOmittedExpression();
                var Ce = Q.updateFunctionExpression(S2, e2.visitNodes(S2.modifiers, D, e2.isModifier), S2.asteriskToken, S2.name, void 0, e2.visitParameterList(S2.parameters, P, E), void 0, e2.visitFunctionBody(S2.body, P, E) || Q.createBlock([]));
                return Ce;
              }
              function Ar(S2) {
                var Ce = Q.updateArrowFunction(S2, e2.visitNodes(S2.modifiers, D, e2.isModifier), void 0, e2.visitParameterList(S2.parameters, P, E), void 0, S2.equalsGreaterThanToken, e2.visitFunctionBody(S2.body, P, E));
                return Ce;
              }
              function Oe(S2) {
                if (!e2.parameterIsThisKeyword(S2)) {
                  var Ce = Q.updateParameterDeclaration(S2, void 0, void 0, S2.dotDotDotToken, e2.visitNode(S2.name, P, e2.isBindingName), void 0, void 0, e2.visitNode(S2.initializer, P, e2.isExpression));
                  return Ce !== S2 && (e2.setCommentRange(Ce, S2), e2.setTextRange(Ce, e2.moveRangePastModifiers(S2)), e2.setSourceMapRange(Ce, e2.moveRangePastModifiers(S2)), e2.setEmitFlags(Ce.name, 32)), Ce;
                }
              }
              function nr(S2) {
                if (ai(S2)) {
                  var Ce = e2.getInitializedVariables(S2.declarationList);
                  return Ce.length === 0 ? void 0 : e2.setTextRange(Q.createExpressionStatement(Q.inlineExpressions(e2.map(Ce, Mr))), S2);
                } else
                  return e2.visitEachChild(S2, P, E);
              }
              function Mr(S2) {
                var Ce = S2.name;
                return e2.isBindingPattern(Ce) ? e2.flattenDestructuringAssignment(S2, P, E, 0, false, kn) : e2.setTextRange(Q.createAssignment(xn(Ce), e2.visitNode(S2.initializer, P, e2.isExpression)), S2);
              }
              function Pe(S2) {
                var Ce = Q.updateVariableDeclaration(S2, e2.visitNode(S2.name, P, e2.isBindingName), void 0, void 0, e2.visitNode(S2.initializer, P, e2.isExpression));
                return S2.type && e2.setTypeNode(Ce.name, S2.type), Ce;
              }
              function Ue(S2) {
                var Ce = e2.skipOuterExpressions(S2.expression, -7);
                if (e2.isAssertionExpression(Ce)) {
                  var qe = e2.visitNode(S2.expression, P, e2.isExpression);
                  return Q.createPartiallyEmittedExpression(qe, S2);
                }
                return e2.visitEachChild(S2, P, E);
              }
              function fr(S2) {
                var Ce = e2.visitNode(S2.expression, P, e2.isExpression);
                return Q.createPartiallyEmittedExpression(Ce, S2);
              }
              function De(S2) {
                var Ce = e2.visitNode(S2.expression, P, e2.isLeftHandSideExpression);
                return Q.createPartiallyEmittedExpression(Ce, S2);
              }
              function gr(S2) {
                return Q.updateCallExpression(S2, e2.visitNode(S2.expression, P, e2.isExpression), void 0, e2.visitNodes(S2.arguments, P, e2.isExpression));
              }
              function Vr(S2) {
                return Q.updateNewExpression(S2, e2.visitNode(S2.expression, P, e2.isExpression), void 0, e2.visitNodes(S2.arguments, P, e2.isExpression));
              }
              function Tr(S2) {
                return Q.updateTaggedTemplateExpression(S2, e2.visitNode(S2.tag, P, e2.isExpression), void 0, e2.visitNode(S2.template, P, e2.isExpression));
              }
              function vi(S2) {
                return Q.updateJsxSelfClosingElement(S2, e2.visitNode(S2.tagName, P, e2.isJsxTagNameExpression), void 0, e2.visitNode(S2.attributes, P, e2.isJsxAttributes));
              }
              function Ui(S2) {
                return Q.updateJsxOpeningElement(S2, e2.visitNode(S2.tagName, P, e2.isJsxTagNameExpression), void 0, e2.visitNode(S2.attributes, P, e2.isJsxAttributes));
              }
              function Yi(S2) {
                return !e2.isEnumConst(S2) || e2.shouldPreserveConstEnums(f4);
              }
              function Wi(S2) {
                if (!Yi(S2))
                  return Q.createNotEmittedStatement(S2);
                var Ce = [], qe = 2, br = Ii(Ce, S2);
                br && (b !== e2.ModuleKind.System || O !== ie) && (qe |= 512);
                var Zr = Kn(S2), Si = Pn(S2), Pi = e2.hasSyntacticModifier(S2, 1) ? Q.getExternalModuleOrNamespaceExportName(q, S2, false, true) : Q.getLocalName(S2, false, true), Qi = Q.createLogicalOr(Pi, Q.createAssignment(Pi, Q.createObjectLiteralExpression()));
                if (xt(S2)) {
                  var Ct = Q.getLocalName(S2, false, true);
                  Qi = Q.createAssignment(Ct, Qi);
                }
                var sa = Q.createExpressionStatement(Q.createCallExpression(Q.createFunctionExpression(void 0, void 0, void 0, void 0, [Q.createParameterDeclaration(void 0, void 0, void 0, Zr)], void 0, ct(S2, Si)), void 0, [Qi]));
                return e2.setOriginalNode(sa, S2), br && (e2.setSyntheticLeadingComments(sa, void 0), e2.setSyntheticTrailingComments(sa, void 0)), e2.setTextRange(sa, S2), e2.addEmitFlags(sa, qe), Ce.push(sa), Ce.push(Q.createEndOfDeclarationMarker(S2)), Ce;
              }
              function ct(S2, Ce) {
                var qe = q;
                q = Ce;
                var br = [];
                N();
                var Zr = e2.map(S2.members, Li);
                return e2.insertStatementsAfterStandardPrologue(br, m2()), e2.addRange(br, Zr), q = qe, Q.createBlock(e2.setTextRange(Q.createNodeArray(br), S2.members), true);
              }
              function Li(S2) {
                var Ce = Zt(S2, false), qe = nt(S2), br = Q.createAssignment(Q.createElementAccessExpression(q, Ce), qe), Zr = qe.kind === 10 ? br : Q.createAssignment(Q.createElementAccessExpression(q, br), Ce);
                return e2.setTextRange(Q.createExpressionStatement(e2.setTextRange(Zr, S2)), S2);
              }
              function nt(S2) {
                var Ce = oe.getConstantValue(S2);
                return Ce !== void 0 ? typeof Ce == "string" ? Q.createStringLiteral(Ce) : Q.createNumericLiteral(Ce) : (bo(), S2.initializer ? e2.visitNode(S2.initializer, P, e2.isExpression) : Q.createVoidZero());
              }
              function Mt(S2) {
                var Ce = e2.getParseTreeNode(S2, e2.isModuleDeclaration);
                return Ce ? e2.isInstantiatedModule(Ce, e2.shouldPreserveConstEnums(f4)) : true;
              }
              function xt(S2) {
                return ai(S2) || Dn(S2) && b !== e2.ModuleKind.ES2015 && b !== e2.ModuleKind.ES2020 && b !== e2.ModuleKind.ES2022 && b !== e2.ModuleKind.ESNext && b !== e2.ModuleKind.System;
              }
              function ut(S2) {
                ee || (ee = new e2.Map());
                var Ce = Rt(S2);
                ee.has(Ce) || ee.set(Ce, S2);
              }
              function Dt(S2) {
                if (ee) {
                  var Ce = Rt(S2);
                  return ee.get(Ce) === S2;
                }
                return true;
              }
              function Rt(S2) {
                return e2.Debug.assertNode(S2.name, e2.isIdentifier), S2.name.escapedText;
              }
              function Ii(S2, Ce) {
                var qe = Q.createVariableStatement(e2.visitNodes(Ce.modifiers, D, e2.isModifier), Q.createVariableDeclarationList([Q.createVariableDeclaration(Q.getLocalName(Ce, false, true))], O.kind === 305 ? 0 : 1));
                if (e2.setOriginalNode(qe, Ce), ut(Ce), Dt(Ce))
                  return Ce.kind === 260 ? e2.setSourceMapRange(qe.declarationList, Ce) : e2.setSourceMapRange(qe, Ce), e2.setCommentRange(qe, Ce), e2.addEmitFlags(qe, 4195328), S2.push(qe), true;
                var br = Q.createMergeDeclarationMarker(qe);
                return e2.setEmitFlags(br, 4195840), S2.push(br), false;
              }
              function Ki(S2) {
                if (!Mt(S2))
                  return Q.createNotEmittedStatement(S2);
                e2.Debug.assertNode(S2.name, e2.isIdentifier, "A TypeScript namespace should have an Identifier name."), En();
                var Ce = [], qe = 2, br = Ii(Ce, S2);
                br && (b !== e2.ModuleKind.System || O !== ie) && (qe |= 512);
                var Zr = Kn(S2), Si = Pn(S2), Pi = e2.hasSyntacticModifier(S2, 1) ? Q.getExternalModuleOrNamespaceExportName(q, S2, false, true) : Q.getLocalName(S2, false, true), Qi = Q.createLogicalOr(Pi, Q.createAssignment(Pi, Q.createObjectLiteralExpression()));
                if (xt(S2)) {
                  var Ct = Q.getLocalName(S2, false, true);
                  Qi = Q.createAssignment(Ct, Qi);
                }
                var sa = Q.createExpressionStatement(Q.createCallExpression(Q.createFunctionExpression(void 0, void 0, void 0, void 0, [Q.createParameterDeclaration(void 0, void 0, void 0, Zr)], void 0, Fi(S2, Si)), void 0, [Qi]));
                return e2.setOriginalNode(sa, S2), br && (e2.setSyntheticLeadingComments(sa, void 0), e2.setSyntheticTrailingComments(sa, void 0)), e2.setTextRange(sa, S2), e2.addEmitFlags(sa, qe), Ce.push(sa), Ce.push(Q.createEndOfDeclarationMarker(S2)), Ce;
              }
              function Fi(S2, Ce) {
                var qe = q, br = R, Zr = ee;
                q = Ce, R = S2, ee = void 0;
                var Si = [];
                N();
                var Pi, Qi;
                if (S2.body)
                  if (S2.body.kind === 262)
                    V(S2.body, function(Wa) {
                      return e2.addRange(Si, e2.visitNodes(Wa.statements, H, e2.isStatement));
                    }), Pi = S2.body.statements, Qi = S2.body;
                  else {
                    var Ct = Ki(S2.body);
                    Ct && (e2.isArray(Ct) ? e2.addRange(Si, Ct) : Si.push(Ct));
                    var sa = ui(S2).body;
                    Pi = e2.moveRangePos(sa.statements, -1);
                  }
                e2.insertStatementsAfterStandardPrologue(Si, m2()), q = qe, R = br, ee = Zr;
                var en = Q.createBlock(e2.setTextRange(Q.createNodeArray(Si), Pi), true);
                return e2.setTextRange(en, Qi), (!S2.body || S2.body.kind !== 262) && e2.setEmitFlags(en, e2.getEmitFlags(en) | 1536), en;
              }
              function ui(S2) {
                if (S2.body.kind === 261) {
                  var Ce = ui(S2.body);
                  return Ce || S2.body;
                }
              }
              function Bt(S2) {
                if (!S2.importClause)
                  return S2;
                if (!S2.importClause.isTypeOnly) {
                  var Ce = e2.visitNode(S2.importClause, wt, e2.isImportClause);
                  return Ce || f4.importsNotUsedAsValues === 1 || f4.importsNotUsedAsValues === 2 ? Q.updateImportDeclaration(S2, void 0, void 0, Ce, S2.moduleSpecifier, S2.assertClause) : void 0;
                }
              }
              function wt(S2) {
                e2.Debug.assert(!S2.isTypeOnly);
                var Ce = Gr(S2) ? S2.name : void 0, qe = e2.visitNode(S2.namedBindings, na, e2.isNamedImportBindings);
                return Ce || qe ? Q.updateImportClause(S2, false, Ce, qe) : void 0;
              }
              function na(S2) {
                if (S2.kind === 268)
                  return Gr(S2) ? S2 : void 0;
                var Ce = f4.preserveValueImports && (f4.importsNotUsedAsValues === 1 || f4.importsNotUsedAsValues === 2), qe = e2.visitNodes(S2.elements, Ai, e2.isImportSpecifier);
                return Ce || e2.some(qe) ? Q.updateNamedImports(S2, qe) : void 0;
              }
              function Ai(S2) {
                return !S2.isTypeOnly && Gr(S2) ? S2 : void 0;
              }
              function Oi(S2) {
                return oe.isValueAliasDeclaration(S2) ? e2.visitEachChild(S2, P, E) : void 0;
              }
              function ji(S2) {
                if (!S2.isTypeOnly) {
                  if (!S2.exportClause || e2.isNamespaceExport(S2.exportClause))
                    return S2;
                  var Ce = !!S2.moduleSpecifier && (f4.importsNotUsedAsValues === 1 || f4.importsNotUsedAsValues === 2), qe = e2.visitNode(S2.exportClause, function(br) {
                    return At(br, Ce);
                  }, e2.isNamedExportBindings);
                  return qe ? Q.updateExportDeclaration(S2, void 0, void 0, S2.isTypeOnly, qe, S2.moduleSpecifier, S2.assertClause) : void 0;
                }
              }
              function Vi(S2, Ce) {
                var qe = e2.visitNodes(S2.elements, ba, e2.isExportSpecifier);
                return Ce || e2.some(qe) ? Q.updateNamedExports(S2, qe) : void 0;
              }
              function at(S2) {
                return Q.updateNamespaceExport(S2, e2.visitNode(S2.name, P, e2.isIdentifier));
              }
              function At(S2, Ce) {
                return e2.isNamespaceExport(S2) ? at(S2) : Vi(S2, Ce);
              }
              function ba(S2) {
                return !S2.isTypeOnly && oe.isValueAliasDeclaration(S2) ? S2 : void 0;
              }
              function $a(S2) {
                return Gr(S2) || !e2.isExternalModule(ie) && oe.isTopLevelValueImportEqualsWithEntityName(S2);
              }
              function Qa(S2) {
                if (!S2.isTypeOnly) {
                  if (e2.isExternalModuleImportEqualsDeclaration(S2)) {
                    var Ce = Gr(S2);
                    return !Ce && f4.importsNotUsedAsValues === 1 ? e2.setOriginalNode(e2.setTextRange(Q.createImportDeclaration(void 0, void 0, void 0, S2.moduleReference.expression, void 0), S2), S2) : Ce ? e2.visitEachChild(S2, P, E) : void 0;
                  }
                  if (!!$a(S2)) {
                    var qe = e2.createExpressionFromEntityName(Q, S2.moduleReference);
                    return e2.setEmitFlags(qe, 3584), ka(S2) || !ai(S2) ? e2.setOriginalNode(e2.setTextRange(Q.createVariableStatement(e2.visitNodes(S2.modifiers, D, e2.isModifier), Q.createVariableDeclarationList([e2.setOriginalNode(Q.createVariableDeclaration(S2.name, void 0, void 0, qe), S2)])), S2), S2) : e2.setOriginalNode(Bi(S2.name, qe, S2), S2);
                  }
                }
              }
              function ai(S2) {
                return R !== void 0 && e2.hasSyntacticModifier(S2, 1);
              }
              function Dn(S2) {
                return R === void 0 && e2.hasSyntacticModifier(S2, 1);
              }
              function ka(S2) {
                return Dn(S2) && !e2.hasSyntacticModifier(S2, 512);
              }
              function Ba(S2) {
                return Dn(S2) && e2.hasSyntacticModifier(S2, 512);
              }
              function pn(S2) {
                return Q.createExpressionStatement(S2);
              }
              function Cn(S2, Ce) {
                var qe = Q.createAssignment(Q.getExternalModuleOrNamespaceExportName(q, Ce, false, true), Q.getLocalName(Ce));
                e2.setSourceMapRange(qe, e2.createRange(Ce.name ? Ce.name.pos : Ce.pos, Ce.end));
                var br = Q.createExpressionStatement(qe);
                e2.setSourceMapRange(br, e2.createRange(-1, Ce.end)), S2.push(br);
              }
              function Bi(S2, Ce, qe) {
                return e2.setTextRange(Q.createExpressionStatement(Q.createAssignment(Q.getNamespaceMemberName(q, S2, false, true), Ce)), qe);
              }
              function kn(S2, Ce, qe) {
                return e2.setTextRange(Q.createAssignment(xn(S2), Ce), qe);
              }
              function xn(S2) {
                return Q.getNamespaceMemberName(q, S2, false, true);
              }
              function Kn(S2) {
                var Ce = Q.getGeneratedNameForNode(S2);
                return e2.setSourceMapRange(Ce, S2.name), Ce;
              }
              function Pn(S2) {
                return Q.getGeneratedNameForNode(S2);
              }
              function eo(S2) {
                if (oe.getNodeCheckFlags(S2) & 16777216) {
                  Ro();
                  var Ce = Q.createUniqueName(S2.name && !e2.isGeneratedIdentifier(S2.name) ? e2.idText(S2.name) : "default");
                  return x2[e2.getOriginalNodeId(S2)] = Ce, G(Ce), Ce;
                }
              }
              function Rn(S2) {
                return Q.createPropertyAccessExpression(Q.getDeclarationName(S2), "prototype");
              }
              function Da(S2, Ce) {
                return e2.isStatic(Ce) ? Q.getDeclarationName(S2) : Rn(S2);
              }
              function bo() {
                (F2 & 8) === 0 && (F2 |= 8, E.enableSubstitution(79));
              }
              function Ro() {
                (F2 & 1) === 0 && (F2 |= 1, E.enableSubstitution(79), x2 = []);
              }
              function En() {
                (F2 & 2) === 0 && (F2 |= 2, E.enableSubstitution(79), E.enableSubstitution(297), E.enableEmitNotification(261));
              }
              function Wn(S2) {
                return e2.getOriginalNode(S2).kind === 261;
              }
              function to(S2) {
                return e2.getOriginalNode(S2).kind === 260;
              }
              function Co(S2, Ce, qe) {
                var br = X, Zr = ie;
                e2.isSourceFile(Ce) && (ie = Ce), F2 & 2 && Wn(Ce) && (X |= 2), F2 & 8 && to(Ce) && (X |= 8), se(S2, Ce, qe), X = br, ie = Zr;
              }
              function Ko(S2, Ce) {
                return Ce = J(S2, Ce), S2 === 1 ? no(Ce) : e2.isShorthandPropertyAssignment(Ce) ? Oo(Ce) : Ce;
              }
              function Oo(S2) {
                if (F2 & 2) {
                  var Ce = S2.name, qe = xi(Ce);
                  if (qe) {
                    if (S2.objectAssignmentInitializer) {
                      var br = Q.createAssignment(qe, S2.objectAssignmentInitializer);
                      return e2.setTextRange(Q.createPropertyAssignment(Ce, br), S2);
                    }
                    return e2.setTextRange(Q.createPropertyAssignment(Ce, qe), S2);
                  }
                }
                return S2;
              }
              function no(S2) {
                switch (S2.kind) {
                  case 79:
                    return $o(S2);
                  case 206:
                    return St(S2);
                  case 207:
                    return pa(S2);
                }
                return S2;
              }
              function $o(S2) {
                return Pr(S2) || xi(S2) || S2;
              }
              function Pr(S2) {
                if (F2 & 1 && oe.getNodeCheckFlags(S2) & 33554432) {
                  var Ce = oe.getReferencedValueDeclaration(S2);
                  if (Ce) {
                    var qe = x2[Ce.id];
                    if (qe) {
                      var br = Q.cloneNode(qe);
                      return e2.setSourceMapRange(br, S2), e2.setCommentRange(br, S2), br;
                    }
                  }
                }
              }
              function xi(S2) {
                if (F2 & X && !e2.isGeneratedIdentifier(S2) && !e2.isLocalName(S2)) {
                  var Ce = oe.getReferencedExportContainer(S2, false);
                  if (Ce && Ce.kind !== 305) {
                    var qe = X & 2 && Ce.kind === 261 || X & 8 && Ce.kind === 260;
                    if (qe)
                      return e2.setTextRange(Q.createPropertyAccessExpression(Q.getGeneratedNameForNode(Ce), S2), S2);
                  }
                }
              }
              function St(S2) {
                return Jn(S2);
              }
              function pa(S2) {
                return Jn(S2);
              }
              function dn(S2) {
                return S2.replace(/\*\//g, "*_/");
              }
              function Jn(S2) {
                var Ce = Qe(S2);
                if (Ce !== void 0) {
                  e2.setConstantValue(S2, Ce);
                  var qe = typeof Ce == "string" ? Q.createStringLiteral(Ce) : Q.createNumericLiteral(Ce);
                  if (!f4.removeComments) {
                    var br = e2.getOriginalNode(S2, e2.isAccessExpression);
                    e2.addSyntheticTrailingComment(qe, 3, " ".concat(dn(e2.getTextOfNode(br)), " "));
                  }
                  return qe;
                }
                return S2;
              }
              function Qe(S2) {
                if (!f4.isolatedModules)
                  return e2.isPropertyAccessExpression(S2) || e2.isElementAccessExpression(S2) ? oe.getConstantValue(S2) : void 0;
              }
              function Gr(S2) {
                return f4.preserveValueImports ? oe.isValueAliasDeclaration(S2) : oe.isReferencedAliasDeclaration(S2);
              }
            }
            e2.transformTypeScript = B;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(p) {
              p[p.ClassAliases = 1] = "ClassAliases", p[p.ClassStaticThisOrSuperReference = 2] = "ClassStaticThisOrSuperReference";
            })(a || (a = {}));
            var C;
            (function(p) {
              p.Field = "f", p.Method = "m", p.Accessor = "a";
            })(C = e2.PrivateIdentifierKind || (e2.PrivateIdentifierKind = {}));
            var w;
            (function(p) {
              p[p.None = 0] = "None", p[p.ClassWasDecorated = 1] = "ClassWasDecorated", p[p.NeedsClassConstructorReference = 2] = "NeedsClassConstructorReference", p[p.NeedsClassSuperReference = 4] = "NeedsClassSuperReference", p[p.NeedsSubstitutionForThisInClassStaticField = 8] = "NeedsSubstitutionForThisInClassStaticField";
            })(w || (w = {}));
            function B(p) {
              var m2 = p.factory, G = p.hoistVariableDeclaration, oe = p.endLexicalEnvironment, f4 = p.startLexicalEnvironment, T = p.resumeLexicalEnvironment, K = p.addBlockScopedVariable, b = p.getEmitResolver(), se = p.getCompilerOptions(), J = e2.getEmitScriptTarget(se), ie = e2.getUseDefineForClassFields(se), R = J < 9, q = J < 9, O = q && J >= 2, ve = p.onSubstituteNode;
              p.onSubstituteNode = qr;
              var ee = p.onEmitNode;
              p.onEmitNode = or;
              var he, F2, x2, X, $ = [], A2 = new e2.Map(), y, V, L;
              return e2.chainBundle(p, P);
              function P(Je) {
                var xe = p.getCompilerOptions();
                if (Je.isDeclarationFile || ie && e2.getEmitScriptTarget(xe) >= 9)
                  return Je;
                var vr = e2.visitEachChild(Je, U, p);
                return e2.addEmitHelpers(vr, p.readEmitHelpers()), vr;
              }
              function k(Je, xe) {
                if (Je.transformFlags & 8388608)
                  switch (Je.kind) {
                    case 226:
                    case 257:
                      return de(Je);
                    case 167:
                      return ue(Je);
                    case 237:
                      return D(Je);
                    case 80:
                      return I(Je);
                    case 170:
                      return Br(Je);
                  }
                if (Je.transformFlags & 8388608 || Je.transformFlags & 33554432 && O && L && y)
                  switch (Je.kind) {
                    case 219:
                    case 220:
                      return ge(Je, xe);
                    case 221:
                      return _e(Je, xe);
                    case 208:
                      return He(Je);
                    case 210:
                      return rr(Je);
                    case 206:
                      return Z2(Je);
                    case 207:
                      return Be(Je);
                    case 238:
                      return ze(Je);
                    case 242:
                      return Re(Je);
                    case 256:
                    case 213:
                    case 171:
                    case 169:
                    case 172:
                    case 173: {
                      var vr = L;
                      L = void 0;
                      var mr = e2.visitEachChild(Je, U, p);
                      return L = vr, mr;
                    }
                  }
                return e2.visitEachChild(Je, U, p);
              }
              function Y(Je) {
                return k(Je, true);
              }
              function U(Je) {
                return k(Je, false);
              }
              function j(Je) {
                switch (Je.kind) {
                  case 291:
                    return e2.visitEachChild(Je, j, p);
                  case 228:
                    return ir(Je);
                }
                return U(Je);
              }
              function H(Je) {
                switch (Je.kind) {
                  case 205:
                  case 204:
                    return Wr(Je);
                  default:
                    return U(Je);
                }
              }
              function I(Je) {
                return !R || e2.isStatement(Je.parent) ? Je : e2.setOriginalNode(m2.createIdentifier(""), Je);
              }
              function l(Je) {
                if (!R)
                  return Je;
                var xe = Je.left;
                e2.Debug.assertNode(xe, e2.isPrivateIdentifier), e2.Debug.assert(Je.operatorToken.kind === 101);
                var vr = ti(xe);
                if (vr) {
                  var mr = e2.visitNode(Je.right, U, e2.isExpression);
                  return e2.setOriginalNode(p.getEmitHelperFactory().createClassPrivateFieldInHelper(vr.brandCheckIdentifier, mr), Je);
                }
                return e2.visitEachChild(Je, U, p);
              }
              function d(Je) {
                switch (Je.kind) {
                  case 171:
                    return;
                  case 172:
                  case 173:
                  case 169:
                    return g(Je);
                  case 167:
                    return ue(Je);
                  case 162:
                    return fe(Je);
                  case 234:
                    return Je;
                  default:
                    return U(Je);
                }
              }
              function D(Je) {
                var xe = X;
                X = [];
                var vr = e2.visitEachChild(Je, U, p), mr = e2.some(X) ? Ve([vr], X, true) : vr;
                return X = xe, mr;
              }
              function fe(Je) {
                var xe = e2.visitEachChild(Je, U, p);
                if (e2.some(x2)) {
                  var vr = x2;
                  vr.push(xe.expression), x2 = [], xe = m2.updateComputedPropertyName(xe, m2.inlineExpressions(vr));
                }
                return xe;
              }
              function g(Je) {
                if (e2.Debug.assert(!e2.some(Je.decorators)), !R || !e2.isPrivateIdentifier(Je.name))
                  return e2.visitEachChild(Je, d, p);
                var xe = ti(Je.name);
                if (e2.Debug.assert(xe, "Undeclared private name for property declaration."), !xe.isValid)
                  return Je;
                var vr = ne(Je);
                vr && pi().push(m2.createAssignment(vr, m2.createFunctionExpression(e2.filter(Je.modifiers, function(mr) {
                  return !e2.isStaticModifier(mr);
                }), Je.asteriskToken, vr, void 0, e2.visitParameterList(Je.parameters, d, p), void 0, e2.visitFunctionBody(Je.body, d, p))));
              }
              function ne(Je) {
                e2.Debug.assert(e2.isPrivateIdentifier(Je.name));
                var xe = ti(Je.name);
                if (e2.Debug.assert(xe, "Undeclared private name for property declaration."), xe.kind === "m")
                  return xe.methodName;
                if (xe.kind === "a") {
                  if (e2.isGetAccessor(Je))
                    return xe.getterName;
                  if (e2.isSetAccessor(Je))
                    return xe.setterName;
                }
              }
              function ue(Je) {
                if (e2.Debug.assert(!e2.some(Je.decorators)), e2.isPrivateIdentifier(Je.name)) {
                  if (!R)
                    return e2.isStatic(Je) ? e2.visitEachChild(Je, U, p) : m2.updatePropertyDeclaration(Je, void 0, e2.visitNodes(Je.modifiers, U, e2.isModifier), Je.name, void 0, void 0, void 0);
                  var xe = ti(Je.name);
                  if (e2.Debug.assert(xe, "Undeclared private name for property declaration."), !xe.isValid)
                    return Je;
                }
                var vr = et(Je.name, !!Je.initializer || ie);
                if (vr && !e2.isSimpleInlineableExpression(vr) && pi().push(vr), e2.isStatic(Je) && !R && !ie) {
                  var mr = ur(Je, m2.createThis());
                  if (mr) {
                    var Ar = m2.createClassStaticBlockDeclaration(void 0, void 0, m2.createBlock([mr]));
                    return e2.setOriginalNode(Ar, Je), e2.setCommentRange(Ar, Je), e2.setCommentRange(mr, { pos: -1, end: -1 }), e2.setSyntheticLeadingComments(mr, void 0), e2.setSyntheticTrailingComments(mr, void 0), Ar;
                  }
                }
              }
              function We(Je, xe) {
                return Fe(Je, e2.visitNode(xe, U, e2.isExpression));
              }
              function Fe(Je, xe) {
                switch (e2.setCommentRange(xe, e2.moveRangePos(xe, -1)), Je.kind) {
                  case "a":
                    return p.getEmitHelperFactory().createClassPrivateFieldGetHelper(xe, Je.brandCheckIdentifier, Je.kind, Je.getterName);
                  case "m":
                    return p.getEmitHelperFactory().createClassPrivateFieldGetHelper(xe, Je.brandCheckIdentifier, Je.kind, Je.methodName);
                  case "f":
                    return p.getEmitHelperFactory().createClassPrivateFieldGetHelper(xe, Je.brandCheckIdentifier, Je.kind, Je.variableName);
                  default:
                    e2.Debug.assertNever(Je, "Unknown private element type");
                }
              }
              function Z2(Je) {
                if (R && e2.isPrivateIdentifier(Je.name)) {
                  var xe = ti(Je.name);
                  if (xe)
                    return e2.setTextRange(e2.setOriginalNode(We(xe, Je.expression), Je), Je);
                }
                if (O && e2.isSuperProperty(Je) && e2.isIdentifier(Je.name) && L && y) {
                  var vr = y.classConstructor, mr = y.superClassReference, Ar = y.facts;
                  if (Ar & 1)
                    return pe(Je);
                  if (vr && mr) {
                    var Oe = m2.createReflectGetCall(mr, m2.createStringLiteralFromNode(Je.name), vr);
                    return e2.setOriginalNode(Oe, Je.expression), e2.setTextRange(Oe, Je.expression), Oe;
                  }
                }
                return e2.visitEachChild(Je, U, p);
              }
              function Be(Je) {
                if (O && e2.isSuperProperty(Je) && L && y) {
                  var xe = y.classConstructor, vr = y.superClassReference, mr = y.facts;
                  if (mr & 1)
                    return pe(Je);
                  if (xe && vr) {
                    var Ar = m2.createReflectGetCall(vr, e2.visitNode(Je.argumentExpression, U, e2.isExpression), xe);
                    return e2.setOriginalNode(Ar, Je.expression), e2.setTextRange(Ar, Je.expression), Ar;
                  }
                }
                return e2.visitEachChild(Je, U, p);
              }
              function ge(Je, xe) {
                if (Je.operator === 45 || Je.operator === 46) {
                  if (R && e2.isPrivateIdentifierPropertyAccessExpression(Je.operand)) {
                    var vr = void 0;
                    if (vr = ti(Je.operand.name)) {
                      var mr = e2.visitNode(Je.operand.expression, U, e2.isExpression), Ar = Ee(mr), Oe = Ar.readExpression, nr = Ar.initializeExpression, Mr = We(vr, Oe), Pe = e2.isPrefixUnaryExpression(Je) || xe ? void 0 : m2.createTempVariable(G);
                      return Mr = e2.expandPreOrPostfixIncrementOrDecrementExpression(m2, Je, Mr, G, Pe), Mr = we(vr, nr || Oe, Mr, 63), e2.setOriginalNode(Mr, Je), e2.setTextRange(Mr, Je), Pe && (Mr = m2.createComma(Mr, Pe), e2.setTextRange(Mr, Je)), Mr;
                    }
                  } else if (O && e2.isSuperProperty(Je.operand) && L && y) {
                    var Ue = y.classConstructor, fr = y.superClassReference, De = y.facts;
                    if (De & 1) {
                      var gr = pe(Je.operand);
                      return e2.isPrefixUnaryExpression(Je) ? m2.updatePrefixUnaryExpression(Je, gr) : m2.updatePostfixUnaryExpression(Je, gr);
                    }
                    if (Ue && fr) {
                      var Vr = void 0, Tr = void 0;
                      if (e2.isPropertyAccessExpression(Je.operand) ? e2.isIdentifier(Je.operand.name) && (Tr = Vr = m2.createStringLiteralFromNode(Je.operand.name)) : e2.isSimpleInlineableExpression(Je.operand.argumentExpression) ? Tr = Vr = Je.operand.argumentExpression : (Tr = m2.createTempVariable(G), Vr = m2.createAssignment(Tr, e2.visitNode(Je.operand.argumentExpression, U, e2.isExpression))), Vr && Tr) {
                        var Mr = m2.createReflectGetCall(fr, Tr, Ue);
                        e2.setTextRange(Mr, Je.operand);
                        var Pe = xe ? void 0 : m2.createTempVariable(G);
                        return Mr = e2.expandPreOrPostfixIncrementOrDecrementExpression(m2, Je, Mr, G, Pe), Mr = m2.createReflectSetCall(fr, Vr, Mr, Ue), e2.setOriginalNode(Mr, Je), e2.setTextRange(Mr, Je), Pe && (Mr = m2.createComma(Mr, Pe), e2.setTextRange(Mr, Je)), Mr;
                      }
                    }
                  }
                }
                return e2.visitEachChild(Je, U, p);
              }
              function Re(Je) {
                return m2.updateForStatement(Je, e2.visitNode(Je.initializer, Y, e2.isForInitializer), e2.visitNode(Je.condition, U, e2.isExpression), e2.visitNode(Je.incrementor, Y, e2.isExpression), e2.visitIterationBody(Je.statement, U, p));
              }
              function ze(Je) {
                return m2.updateExpressionStatement(Je, e2.visitNode(Je.expression, Y, e2.isExpression));
              }
              function Ee(Je) {
                var xe = e2.nodeIsSynthesized(Je) ? Je : m2.cloneNode(Je);
                if (e2.isSimpleInlineableExpression(Je))
                  return { readExpression: xe, initializeExpression: void 0 };
                var vr = m2.createTempVariable(G), mr = m2.createAssignment(vr, xe);
                return { readExpression: vr, initializeExpression: mr };
              }
              function He(Je) {
                if (R && e2.isPrivateIdentifierPropertyAccessExpression(Je.expression)) {
                  var xe = m2.createCallBinding(Je.expression, G, J), vr = xe.thisArg, mr = xe.target;
                  return e2.isCallChain(Je) ? m2.updateCallChain(Je, m2.createPropertyAccessChain(e2.visitNode(mr, U), Je.questionDotToken, "call"), void 0, void 0, Ve([e2.visitNode(vr, U, e2.isExpression)], e2.visitNodes(Je.arguments, U, e2.isExpression), true)) : m2.updateCallExpression(Je, m2.createPropertyAccessExpression(e2.visitNode(mr, U), "call"), void 0, Ve([e2.visitNode(vr, U, e2.isExpression)], e2.visitNodes(Je.arguments, U, e2.isExpression), true));
                }
                if (O && e2.isSuperProperty(Je.expression) && L && (y == null ? void 0 : y.classConstructor)) {
                  var Ar = m2.createFunctionCallCall(e2.visitNode(Je.expression, U, e2.isExpression), y.classConstructor, e2.visitNodes(Je.arguments, U, e2.isExpression));
                  return e2.setOriginalNode(Ar, Je), e2.setTextRange(Ar, Je), Ar;
                }
                return e2.visitEachChild(Je, U, p);
              }
              function rr(Je) {
                if (R && e2.isPrivateIdentifierPropertyAccessExpression(Je.tag)) {
                  var xe = m2.createCallBinding(Je.tag, G, J), vr = xe.thisArg, mr = xe.target;
                  return m2.updateTaggedTemplateExpression(Je, m2.createCallExpression(m2.createPropertyAccessExpression(e2.visitNode(mr, U), "bind"), void 0, [e2.visitNode(vr, U, e2.isExpression)]), void 0, e2.visitNode(Je.template, U, e2.isTemplateLiteral));
                }
                if (O && e2.isSuperProperty(Je.tag) && L && (y == null ? void 0 : y.classConstructor)) {
                  var Ar = m2.createFunctionBindCall(e2.visitNode(Je.tag, U, e2.isExpression), y.classConstructor, []);
                  return e2.setOriginalNode(Ar, Je), e2.setTextRange(Ar, Je), m2.updateTaggedTemplateExpression(Je, Ar, void 0, e2.visitNode(Je.template, U, e2.isTemplateLiteral));
                }
                return e2.visitEachChild(Je, U, p);
              }
              function Ie(Je) {
                if (R) {
                  y && A2.set(e2.getOriginalNodeId(Je), y), f4();
                  var xe = L;
                  L = Je;
                  var vr = e2.visitNodes(Je.body.statements, U, e2.isStatement);
                  vr = m2.mergeLexicalEnvironment(vr, oe()), L = xe;
                  var mr = m2.createImmediatelyInvokedArrowFunction(vr);
                  return e2.setOriginalNode(mr, Je), e2.setTextRange(mr, Je), e2.addEmitFlags(mr, 2), mr;
                }
              }
              function _e(Je, xe) {
                if (e2.isDestructuringAssignment(Je)) {
                  var vr = x2;
                  x2 = void 0, Je = m2.updateBinaryExpression(Je, e2.visitNode(Je.left, H), Je.operatorToken, e2.visitNode(Je.right, U));
                  var mr = e2.some(x2) ? m2.inlineExpressions(e2.compact(Ve(Ve([], x2, true), [Je], false))) : Je;
                  return x2 = vr, mr;
                }
                if (e2.isAssignmentExpression(Je)) {
                  if (R && e2.isPrivateIdentifierPropertyAccessExpression(Je.left)) {
                    var Ar = ti(Je.left.name);
                    if (Ar)
                      return e2.setTextRange(e2.setOriginalNode(we(Ar, Je.left.expression, Je.right, Je.operatorToken.kind), Je), Je);
                  } else if (O && e2.isSuperProperty(Je.left) && L && y) {
                    var Oe = y.classConstructor, nr = y.superClassReference, Mr = y.facts;
                    if (Mr & 1)
                      return m2.updateBinaryExpression(Je, pe(Je.left), Je.operatorToken, e2.visitNode(Je.right, U, e2.isExpression));
                    if (Oe && nr) {
                      var Pe = e2.isElementAccessExpression(Je.left) ? e2.visitNode(Je.left.argumentExpression, U, e2.isExpression) : e2.isIdentifier(Je.left.name) ? m2.createStringLiteralFromNode(Je.left.name) : void 0;
                      if (Pe) {
                        var Ue = e2.visitNode(Je.right, U, e2.isExpression);
                        if (e2.isCompoundAssignment(Je.operatorToken.kind)) {
                          var fr = Pe;
                          e2.isSimpleInlineableExpression(Pe) || (fr = m2.createTempVariable(G), Pe = m2.createAssignment(fr, Pe));
                          var De = m2.createReflectGetCall(nr, fr, Oe);
                          e2.setOriginalNode(De, Je.left), e2.setTextRange(De, Je.left), Ue = m2.createBinaryExpression(De, e2.getNonAssignmentOperatorForCompoundAssignment(Je.operatorToken.kind), Ue), e2.setTextRange(Ue, Je);
                        }
                        var gr = xe ? void 0 : m2.createTempVariable(G);
                        return gr && (Ue = m2.createAssignment(gr, Ue), e2.setTextRange(gr, Je)), Ue = m2.createReflectSetCall(nr, Pe, Ue, Oe), e2.setOriginalNode(Ue, Je), e2.setTextRange(Ue, Je), gr && (Ue = m2.createComma(Ue, gr), e2.setTextRange(Ue, Je)), Ue;
                      }
                    }
                  }
                }
                return Je.operatorToken.kind === 101 && e2.isPrivateIdentifier(Je.left) ? l(Je) : e2.visitEachChild(Je, U, p);
              }
              function we(Je, xe, vr, mr) {
                if (xe = e2.visitNode(xe, U, e2.isExpression), vr = e2.visitNode(vr, U, e2.isExpression), e2.isCompoundAssignment(mr)) {
                  var Ar = Ee(xe), Oe = Ar.readExpression, nr = Ar.initializeExpression;
                  xe = nr || Oe, vr = m2.createBinaryExpression(Fe(Je, Oe), e2.getNonAssignmentOperatorForCompoundAssignment(mr), vr);
                }
                switch (e2.setCommentRange(xe, e2.moveRangePos(xe, -1)), Je.kind) {
                  case "a":
                    return p.getEmitHelperFactory().createClassPrivateFieldSetHelper(xe, Je.brandCheckIdentifier, vr, Je.kind, Je.setterName);
                  case "m":
                    return p.getEmitHelperFactory().createClassPrivateFieldSetHelper(xe, Je.brandCheckIdentifier, vr, Je.kind, void 0);
                  case "f":
                    return p.getEmitHelperFactory().createClassPrivateFieldSetHelper(xe, Je.brandCheckIdentifier, vr, Je.kind, Je.variableName);
                  default:
                    e2.Debug.assertNever(Je, "Unknown private element type");
                }
              }
              function de(Je) {
                if (!e2.forEach(Je.members, ye))
                  return e2.visitEachChild(Je, U, p);
                var xe = x2;
                if (x2 = void 0, Gi(), R) {
                  var vr = e2.getNameOfDeclaration(Je);
                  vr && e2.isIdentifier(vr) && (_r().className = e2.idText(vr));
                  var mr = Ae(Je);
                  e2.some(mr) && (_r().weakSetName = Xe("instances", mr[0].name));
                }
                var Ar = e2.isClassDeclaration(Je) ? Cr(Je) : Ye(Je);
                return Wt(), x2 = xe, Ar;
              }
              function ye(Je) {
                return e2.isPropertyDeclaration(Je) || e2.isClassStaticBlockDeclaration(Je) || R && Je.name && e2.isPrivateIdentifier(Je.name);
              }
              function Ae(Je) {
                return e2.filter(Je.members, e2.isNonStaticMethodOrAccessorWithPrivateName);
              }
              function er(Je) {
                var xe = 0, vr = e2.getOriginalNode(Je);
                e2.isClassDeclaration(vr) && e2.classOrConstructorParameterIsDecorated(vr) && (xe |= 1);
                for (var mr = 0, Ar = Je.members; mr < Ar.length; mr++) {
                  var Oe = Ar[mr];
                  !e2.isStatic(Oe) || (Oe.name && e2.isPrivateIdentifier(Oe.name) && R && (xe |= 2), (e2.isPropertyDeclaration(Oe) || e2.isClassStaticBlockDeclaration(Oe)) && (q && Oe.transformFlags & 8192 && (xe |= 8, xe & 1 || (xe |= 2)), O && Oe.transformFlags & 33554432 && (xe & 1 || (xe |= 6))));
                }
                return xe;
              }
              function ir(Je) {
                var xe = (y == null ? void 0 : y.facts) || 0;
                if (xe & 4) {
                  var vr = m2.createTempVariable(G, true);
                  return Zt().superClassReference = vr, m2.updateExpressionWithTypeArguments(Je, m2.createAssignment(vr, e2.visitNode(Je.expression, U, e2.isExpression)), void 0);
                }
                return e2.visitEachChild(Je, U, p);
              }
              function Cr(Je) {
                var xe = er(Je);
                xe && (Zt().facts = xe), xe & 8 && ii();
                var vr;
                if (xe & 2) {
                  var mr = m2.createTempVariable(G, true);
                  Zt().classConstructor = m2.cloneNode(mr), vr = m2.createAssignment(mr, m2.getInternalName(Je));
                }
                var Ar = e2.getEffectiveBaseTypeNode(Je), Oe = !!(Ar && e2.skipOuterExpressions(Ar.expression).kind !== 104), nr = [m2.updateClassDeclaration(Je, void 0, Je.modifiers, Je.name, void 0, e2.visitNodes(Je.heritageClauses, j, e2.isHeritageClause), Er(Je, Oe))];
                vr && pi().unshift(vr), e2.some(x2) && nr.push(m2.createExpressionStatement(m2.inlineExpressions(x2)));
                var Mr = e2.getStaticPropertiesAndClassStaticBlock(Je);
                return e2.some(Mr) && Ge(nr, Mr, m2.getInternalName(Je)), nr;
              }
              function Ye(Je) {
                var xe = er(Je);
                xe && (Zt().facts = xe), xe & 8 && ii();
                var vr = !!(xe & 1), mr = e2.getStaticPropertiesAndClassStaticBlock(Je), Ar = e2.getEffectiveBaseTypeNode(Je), Oe = !!(Ar && e2.skipOuterExpressions(Ar.expression).kind !== 104), nr = b.getNodeCheckFlags(Je) & 16777216, Mr;
                function Pe() {
                  var Vr = b.getNodeCheckFlags(Je), Tr = Vr & 16777216, vi = Vr & 524288;
                  return m2.createTempVariable(vi ? K : G, !!Tr);
                }
                xe & 2 && (Mr = Pe(), Zt().classConstructor = m2.cloneNode(Mr));
                var Ue = m2.updateClassExpression(Je, e2.visitNodes(Je.decorators, U, e2.isDecorator), Je.modifiers, Je.name, void 0, e2.visitNodes(Je.heritageClauses, j, e2.isHeritageClause), Er(Je, Oe)), fr = R && e2.some(mr, function(Vr) {
                  return e2.isClassStaticBlockDeclaration(Vr) || !!Vr.initializer || e2.isPrivateIdentifier(Vr.name);
                });
                if (fr || e2.some(x2)) {
                  if (vr)
                    return e2.Debug.assertIsDefined(X, "Decorated classes transformed by TypeScript are expected to be within a variable declaration."), X && x2 && e2.some(x2) && X.push(m2.createExpressionStatement(m2.inlineExpressions(x2))), X && e2.some(mr) && Ge(X, mr, m2.getInternalName(Je)), Mr ? m2.inlineExpressions([m2.createAssignment(Mr, Ue), Mr]) : Ue;
                  var De = [];
                  if (Mr || (Mr = Pe()), nr) {
                    Ur();
                    var gr = m2.cloneNode(Mr);
                    gr.autoGenerateFlags &= -9, F2[e2.getOriginalNodeId(Je)] = gr;
                  }
                  return e2.setEmitFlags(Ue, 65536 | e2.getEmitFlags(Ue)), De.push(e2.startOnNewLine(m2.createAssignment(Mr, Ue))), e2.addRange(De, e2.map(x2, e2.startOnNewLine)), e2.addRange(De, yr(mr, Mr)), De.push(e2.startOnNewLine(Mr)), m2.inlineExpressions(De);
                }
                return Ue;
              }
              function Br(Je) {
                if (!R)
                  return e2.visitEachChild(Je, d, p);
              }
              function Er(Je, xe) {
                var vr = [];
                if (R) {
                  for (var mr = 0, Ar = Je.members; mr < Ar.length; mr++) {
                    var Oe = Ar[mr];
                    e2.isPrivateIdentifierClassElementDeclaration(Oe) && ae(Oe);
                  }
                  e2.some(Ae(Je)) && Ne();
                }
                var nr = lr(Je, xe), Mr = e2.visitNodes(Je.members, d, e2.isClassElement);
                return nr && vr.push(nr), !R && e2.some(x2) && (vr.push(m2.createClassStaticBlockDeclaration(void 0, void 0, m2.createBlock([m2.createExpressionStatement(m2.inlineExpressions(x2))]))), x2 = void 0), e2.addRange(vr, Mr), e2.setTextRange(m2.createNodeArray(vr), Je.members);
              }
              function Ne() {
                var Je = _r().weakSetName;
                e2.Debug.assert(Je, "weakSetName should be set in private identifier environment"), pi().push(m2.createAssignment(Je, m2.createNewExpression(m2.createIdentifier("WeakSet"), void 0, [])));
              }
              function n(Je) {
                return e2.isStatic(Je) || e2.hasSyntacticModifier(e2.getOriginalNode(Je), 128) ? false : ie ? J < 9 : e2.isInitializedProperty(Je) || R && e2.isPrivateIdentifierClassElementDeclaration(Je);
              }
              function lr(Je, xe) {
                var vr = e2.visitNode(e2.getFirstConstructorWithBody(Je), U, e2.isConstructorDeclaration), mr = Je.members.filter(n);
                if (!e2.some(mr))
                  return vr;
                var Ar = e2.visitParameterList(vr ? vr.parameters : void 0, U, p), Oe = be(Je, vr, xe);
                if (!!Oe)
                  return e2.startOnNewLine(e2.setOriginalNode(e2.setTextRange(m2.createConstructorDeclaration(void 0, void 0, Ar != null ? Ar : [], Oe), vr || Je), vr));
              }
              function be(Je, xe, vr) {
                var mr, Ar = e2.getProperties(Je, false, false);
                ie || (Ar = e2.filter(Ar, function(Li) {
                  return !!Li.initializer || e2.isPrivateIdentifier(Li.name);
                }));
                var Oe = Ae(Je), nr = e2.some(Ar) || e2.some(Oe);
                if (!xe && !nr)
                  return e2.visitFunctionBody(void 0, U, p);
                T();
                var Mr = !xe && vr, Pe = 0, Ue = 0, fr = -1, De = [];
                !((mr = xe == null ? void 0 : xe.body) === null || mr === void 0) && mr.statements && (Ue = m2.copyPrologue(xe.body.statements, De, false, U), fr = e2.findSuperStatementIndex(xe.body.statements, Ue), fr >= 0 ? (Pe = fr + 1, De = Ve(Ve(Ve([], De.slice(0, Ue), true), e2.visitNodes(xe.body.statements, U, e2.isStatement, Ue, Pe - Ue), true), De.slice(Ue), true)) : Ue >= 0 && (Pe = Ue)), Mr && De.push(m2.createExpressionStatement(m2.createCallExpression(m2.createSuper(), void 0, [m2.createSpreadElement(m2.createIdentifier("arguments"))])));
                var gr = 0;
                if (xe != null && xe.body)
                  if (ie)
                    De = De.filter(function(Li) {
                      return !e2.isParameterPropertyDeclaration(e2.getOriginalNode(Li), xe);
                    });
                  else {
                    for (var Vr = 0, Tr = xe.body.statements; Vr < Tr.length; Vr++) {
                      var vi = Tr[Vr];
                      e2.isParameterPropertyDeclaration(e2.getOriginalNode(vi), xe) && gr++;
                    }
                    if (gr > 0) {
                      var Ui = e2.visitNodes(xe.body.statements, U, e2.isStatement, Pe, gr);
                      if (fr >= 0)
                        e2.addRange(De, Ui);
                      else {
                        var Yi = Ue;
                        Mr && Yi++, De = Ve(Ve(Ve([], De.slice(0, Yi), true), Ui, true), De.slice(Yi), true);
                      }
                      Pe += gr;
                    }
                  }
                var Wi = m2.createThis();
                return mi(De, Oe, Wi), Ge(De, Ar, Wi), xe && e2.addRange(De, e2.visitNodes(xe.body.statements, ct, e2.isStatement, Pe)), De = m2.mergeLexicalEnvironment(De, oe()), e2.setTextRange(m2.createBlock(e2.setTextRange(m2.createNodeArray(De), xe ? xe.body.statements : Je.members), true), xe ? xe.body : void 0);
                function ct(Li) {
                  if (!(ie && e2.isParameterPropertyDeclaration(e2.getOriginalNode(Li), xe)))
                    return U(Li);
                }
              }
              function Ge(Je, xe, vr) {
                for (var mr = 0, Ar = xe; mr < Ar.length; mr++) {
                  var Oe = Ar[mr];
                  if (!(e2.isStatic(Oe) && !R && !ie)) {
                    var nr = ur(Oe, vr);
                    !nr || Je.push(nr);
                  }
                }
              }
              function ur(Je, xe) {
                var vr = e2.isClassStaticBlockDeclaration(Je) ? Ie(Je) : Ir(Je, xe);
                if (!!vr) {
                  var mr = m2.createExpressionStatement(vr);
                  return e2.setSourceMapRange(mr, e2.moveRangePastModifiers(Je)), e2.setCommentRange(mr, Je), e2.setOriginalNode(mr, Je), e2.setSyntheticLeadingComments(vr, void 0), e2.setSyntheticTrailingComments(vr, void 0), mr;
                }
              }
              function yr(Je, xe) {
                for (var vr = [], mr = 0, Ar = Je; mr < Ar.length; mr++) {
                  var Oe = Ar[mr], nr = e2.isClassStaticBlockDeclaration(Oe) ? Ie(Oe) : Ir(Oe, xe);
                  !nr || (e2.startOnNewLine(nr), e2.setSourceMapRange(nr, e2.moveRangePastModifiers(Oe)), e2.setCommentRange(nr, Oe), e2.setOriginalNode(nr, Oe), vr.push(nr));
                }
                return vr;
              }
              function Ir(Je, xe) {
                var vr = L, mr = wr(Je, xe);
                return mr && e2.hasStaticModifier(Je) && (y == null ? void 0 : y.facts) && (e2.setOriginalNode(mr, Je), e2.addEmitFlags(mr, 2), A2.set(e2.getOriginalNodeId(mr), y)), L = vr, mr;
              }
              function wr(Je, xe) {
                var vr, mr = !ie, Ar = e2.isComputedPropertyName(Je.name) && !e2.isSimpleInlineableExpression(Je.name.expression) ? m2.updateComputedPropertyName(Je.name, m2.getGeneratedNameForNode(Je.name)) : Je.name;
                if (e2.hasStaticModifier(Je) && (L = Je), R && e2.isPrivateIdentifier(Ar)) {
                  var Oe = ti(Ar);
                  if (Oe)
                    return Oe.kind === "f" ? Oe.isStatic ? E(Oe.variableName, e2.visitNode(Je.initializer, U, e2.isExpression)) : Q(xe, e2.visitNode(Je.initializer, U, e2.isExpression), Oe.brandCheckIdentifier) : void 0;
                  e2.Debug.fail("Undeclared private name for property declaration.");
                }
                if (!((e2.isPrivateIdentifier(Ar) || e2.hasStaticModifier(Je)) && !Je.initializer)) {
                  var nr = e2.getOriginalNode(Je);
                  if (!e2.hasSyntacticModifier(nr, 128)) {
                    var Mr = Je.initializer || mr ? (vr = e2.visitNode(Je.initializer, U, e2.isExpression)) !== null && vr !== void 0 ? vr : m2.createVoidZero() : e2.isParameterPropertyDeclaration(nr, nr.parent) && e2.isIdentifier(Ar) ? Ar : m2.createVoidZero();
                    if (mr || e2.isPrivateIdentifier(Ar)) {
                      var Pe = e2.createMemberAccessForPropertyName(m2, xe, Ar, Ar);
                      return m2.createAssignment(Pe, Mr);
                    } else {
                      var Ue = e2.isComputedPropertyName(Ar) ? Ar.expression : e2.isIdentifier(Ar) ? m2.createStringLiteral(e2.unescapeLeadingUnderscores(Ar.escapedText)) : Ar, fr = m2.createPropertyDescriptor({ value: Mr, configurable: true, writable: true, enumerable: true });
                      return m2.createObjectDefinePropertyCall(xe, Ue, fr);
                    }
                  }
                }
              }
              function Ur() {
                (he & 1) === 0 && (he |= 1, p.enableSubstitution(79), F2 = []);
              }
              function ii() {
                (he & 2) === 0 && (he |= 2, p.enableSubstitution(108), p.enableEmitNotification(256), p.enableEmitNotification(213), p.enableEmitNotification(171), p.enableEmitNotification(172), p.enableEmitNotification(173), p.enableEmitNotification(169), p.enableEmitNotification(167), p.enableEmitNotification(162));
              }
              function mi(Je, xe, vr) {
                if (!(!R || !e2.some(xe))) {
                  var mr = _r().weakSetName;
                  e2.Debug.assert(mr, "weakSetName should be set in private identifier environment"), Je.push(m2.createExpressionStatement(le(vr, mr)));
                }
              }
              function pe(Je) {
                return e2.isPropertyAccessExpression(Je) ? m2.updatePropertyAccessExpression(Je, m2.createVoidZero(), Je.name) : m2.updateElementAccessExpression(Je, m2.createVoidZero(), e2.visitNode(Je.argumentExpression, U, e2.isExpression));
              }
              function or(Je, xe, vr) {
                var mr = e2.getOriginalNode(xe);
                if (mr.id) {
                  var Ar = A2.get(mr.id);
                  if (Ar) {
                    var Oe = y, nr = V;
                    y = Ar, V = Ar, ee(Je, xe, vr), y = Oe, V = nr;
                    return;
                  }
                }
                switch (xe.kind) {
                  case 213:
                    if (e2.isArrowFunction(mr) || e2.getEmitFlags(xe) & 262144)
                      break;
                  case 256:
                  case 171: {
                    var Oe = y, nr = V;
                    y = void 0, V = void 0, ee(Je, xe, vr), y = Oe, V = nr;
                    return;
                  }
                  case 172:
                  case 173:
                  case 169:
                  case 167: {
                    var Oe = y, nr = V;
                    V = y, y = void 0, ee(Je, xe, vr), y = Oe, V = nr;
                    return;
                  }
                  case 162: {
                    var Oe = y, nr = V;
                    y = V, V = void 0, ee(Je, xe, vr), y = Oe, V = nr;
                    return;
                  }
                }
                ee(Je, xe, vr);
              }
              function qr(Je, xe) {
                return xe = ve(Je, xe), Je === 1 ? si(xe) : xe;
              }
              function si(Je) {
                switch (Je.kind) {
                  case 79:
                    return wi(Je);
                  case 108:
                    return Di(Je);
                }
                return Je;
              }
              function Di(Je) {
                if (he & 2 && y) {
                  var xe = y.facts, vr = y.classConstructor;
                  if (xe & 1)
                    return m2.createParenthesizedExpression(m2.createVoidZero());
                  if (vr)
                    return e2.setTextRange(e2.setOriginalNode(m2.cloneNode(vr), Je), Je);
                }
                return Je;
              }
              function wi(Je) {
                return Xi(Je) || Je;
              }
              function Xi(Je) {
                if (he & 1 && b.getNodeCheckFlags(Je) & 33554432) {
                  var xe = b.getReferencedValueDeclaration(Je);
                  if (xe) {
                    var vr = F2[xe.id];
                    if (vr) {
                      var mr = m2.cloneNode(vr);
                      return e2.setSourceMapRange(mr, Je), e2.setCommentRange(mr, Je), mr;
                    }
                  }
                }
              }
              function et(Je, xe) {
                if (e2.isComputedPropertyName(Je)) {
                  var vr = e2.visitNode(Je.expression, U, e2.isExpression), mr = e2.skipPartiallyEmittedExpressions(vr), Ar = e2.isSimpleInlineableExpression(mr), Oe = e2.isAssignmentExpression(mr) && e2.isGeneratedIdentifier(mr.left);
                  if (!Oe && !Ar && xe) {
                    var nr = m2.getGeneratedNameForNode(Je);
                    return b.getNodeCheckFlags(Je) & 524288 ? K(nr) : G(nr), m2.createAssignment(nr, vr);
                  }
                  return Ar || e2.isIdentifier(mr) ? void 0 : vr;
                }
              }
              function Gi() {
                $.push(y), y = void 0;
              }
              function Wt() {
                y = $.pop();
              }
              function Zt() {
                return y || (y = { facts: 0, classConstructor: void 0, superClassReference: void 0, privateIdentifierEnvironment: void 0 });
              }
              function _r() {
                var Je = Zt();
                return Je.privateIdentifierEnvironment || (Je.privateIdentifierEnvironment = { className: "", identifiers: new e2.Map() }), Je.privateIdentifierEnvironment;
              }
              function pi() {
                return x2 || (x2 = []);
              }
              function ae(Je) {
                var xe, vr = e2.getTextOfPropertyName(Je.name), mr = Zt(), Ar = mr.classConstructor, Oe = _r(), nr = Oe.weakSetName, Mr = [], Pe = Je.name.escapedText, Ue = Oe.identifiers.get(Pe), fr = !N(Je.name) && Ue === void 0;
                if (e2.hasStaticModifier(Je))
                  if (e2.Debug.assert(Ar, "weakSetName should be set in private identifier environment"), e2.isPropertyDeclaration(Je)) {
                    var De = Jr(vr, Je);
                    Oe.identifiers.set(Pe, { kind: "f", variableName: De, brandCheckIdentifier: Ar, isStatic: true, isValid: fr });
                  } else if (e2.isMethodDeclaration(Je)) {
                    var gr = Jr(vr, Je);
                    Oe.identifiers.set(Pe, { kind: "m", methodName: gr, brandCheckIdentifier: Ar, isStatic: true, isValid: fr });
                  } else if (e2.isGetAccessorDeclaration(Je)) {
                    var Vr = Jr(vr + "_get", Je);
                    (Ue == null ? void 0 : Ue.kind) === "a" && Ue.isStatic && !Ue.getterName ? Ue.getterName = Vr : Oe.identifiers.set(Pe, { kind: "a", getterName: Vr, setterName: void 0, brandCheckIdentifier: Ar, isStatic: true, isValid: fr });
                  } else if (e2.isSetAccessorDeclaration(Je)) {
                    var Tr = Jr(vr + "_set", Je);
                    (Ue == null ? void 0 : Ue.kind) === "a" && Ue.isStatic && !Ue.setterName ? Ue.setterName = Tr : Oe.identifiers.set(Pe, { kind: "a", getterName: void 0, setterName: Tr, brandCheckIdentifier: Ar, isStatic: true, isValid: fr });
                  } else
                    e2.Debug.assertNever(Je, "Unknown class element type.");
                else if (e2.isPropertyDeclaration(Je)) {
                  var vi = Jr(vr, Je);
                  Oe.identifiers.set(Pe, { kind: "f", brandCheckIdentifier: vi, isStatic: false, variableName: void 0, isValid: fr }), Mr.push(m2.createAssignment(vi, m2.createNewExpression(m2.createIdentifier("WeakMap"), void 0, [])));
                } else if (e2.isMethodDeclaration(Je))
                  e2.Debug.assert(nr, "weakSetName should be set in private identifier environment"), Oe.identifiers.set(Pe, { kind: "m", methodName: Jr(vr, Je), brandCheckIdentifier: nr, isStatic: false, isValid: fr });
                else if (e2.isAccessor(Je))
                  if (e2.Debug.assert(nr, "weakSetName should be set in private identifier environment"), e2.isGetAccessor(Je)) {
                    var Vr = Jr(vr + "_get", Je);
                    (Ue == null ? void 0 : Ue.kind) === "a" && !Ue.isStatic && !Ue.getterName ? Ue.getterName = Vr : Oe.identifiers.set(Pe, { kind: "a", getterName: Vr, setterName: void 0, brandCheckIdentifier: nr, isStatic: false, isValid: fr });
                  } else {
                    var Tr = Jr(vr + "_set", Je);
                    (Ue == null ? void 0 : Ue.kind) === "a" && !Ue.isStatic && !Ue.setterName ? Ue.setterName = Tr : Oe.identifiers.set(Pe, { kind: "a", getterName: void 0, setterName: Tr, brandCheckIdentifier: nr, isStatic: false, isValid: fr });
                  }
                else
                  e2.Debug.assertNever(Je, "Unknown class element type.");
                (xe = pi()).push.apply(xe, Mr);
              }
              function Xe(Je, xe) {
                var vr = _r().className, mr = vr ? "_".concat(vr) : "", Ar = m2.createUniqueName("".concat(mr, "_").concat(Je), 16);
                return b.getNodeCheckFlags(xe) & 524288 ? K(Ar) : G(Ar), Ar;
              }
              function Jr(Je, xe) {
                return Xe(Je.substring(1), xe.name);
              }
              function ti(Je) {
                var xe;
                if (y != null && y.privateIdentifierEnvironment) {
                  var vr = y.privateIdentifierEnvironment.identifiers.get(Je.escapedText);
                  if (vr)
                    return vr;
                }
                for (var mr = $.length - 1; mr >= 0; --mr) {
                  var Ar = $[mr];
                  if (!!Ar) {
                    var vr = (xe = Ar.privateIdentifierEnvironment) === null || xe === void 0 ? void 0 : xe.identifiers.get(Je.escapedText);
                    if (vr)
                      return vr;
                  }
                }
              }
              function Ze(Je) {
                var xe = m2.getGeneratedNameForNode(Je), vr = ti(Je.name);
                if (!vr)
                  return e2.visitEachChild(Je, U, p);
                var mr = Je.expression;
                return (e2.isThisProperty(Je) || e2.isSuperProperty(Je) || !e2.isSimpleCopiableExpression(Je.expression)) && (mr = m2.createTempVariable(G, true), pi().push(m2.createBinaryExpression(mr, 63, e2.visitNode(Je.expression, U, e2.isExpression)))), m2.createAssignmentTargetWrapper(xe, we(vr, mr, xe, 63));
              }
              function Sr(Je) {
                var xe = e2.getTargetOfBindingOrAssignmentElement(Je);
                if (xe) {
                  var vr = void 0;
                  if (e2.isPrivateIdentifierPropertyAccessExpression(xe))
                    vr = Ze(xe);
                  else if (O && e2.isSuperProperty(xe) && L && y) {
                    var mr = y.classConstructor, Ar = y.superClassReference, Oe = y.facts;
                    if (Oe & 1)
                      vr = pe(xe);
                    else if (mr && Ar) {
                      var nr = e2.isElementAccessExpression(xe) ? e2.visitNode(xe.argumentExpression, U, e2.isExpression) : e2.isIdentifier(xe.name) ? m2.createStringLiteralFromNode(xe.name) : void 0;
                      if (nr) {
                        var Mr = m2.createTempVariable(void 0);
                        vr = m2.createAssignmentTargetWrapper(Mr, m2.createReflectSetCall(Ar, nr, Mr, mr));
                      }
                    }
                  }
                  if (vr)
                    return e2.isAssignmentExpression(Je) ? m2.updateBinaryExpression(Je, vr, Je.operatorToken, e2.visitNode(Je.right, U, e2.isExpression)) : e2.isSpreadElement(Je) ? m2.updateSpreadElement(Je, vr) : vr;
                }
                return e2.visitNode(Je, H);
              }
              function zr(Je) {
                if (e2.isObjectBindingOrAssignmentElement(Je) && !e2.isShorthandPropertyAssignment(Je)) {
                  var xe = e2.getTargetOfBindingOrAssignmentElement(Je), vr = void 0;
                  if (xe) {
                    if (e2.isPrivateIdentifierPropertyAccessExpression(xe))
                      vr = Ze(xe);
                    else if (O && e2.isSuperProperty(xe) && L && y) {
                      var mr = y.classConstructor, Ar = y.superClassReference, Oe = y.facts;
                      if (Oe & 1)
                        vr = pe(xe);
                      else if (mr && Ar) {
                        var nr = e2.isElementAccessExpression(xe) ? e2.visitNode(xe.argumentExpression, U, e2.isExpression) : e2.isIdentifier(xe.name) ? m2.createStringLiteralFromNode(xe.name) : void 0;
                        if (nr) {
                          var Mr = m2.createTempVariable(void 0);
                          vr = m2.createAssignmentTargetWrapper(Mr, m2.createReflectSetCall(Ar, nr, Mr, mr));
                        }
                      }
                    }
                  }
                  if (e2.isPropertyAssignment(Je)) {
                    var Pe = e2.getInitializerOfBindingOrAssignmentElement(Je);
                    return m2.updatePropertyAssignment(Je, e2.visitNode(Je.name, U, e2.isPropertyName), vr ? Pe ? m2.createAssignment(vr, e2.visitNode(Pe, U)) : vr : e2.visitNode(Je.initializer, H, e2.isExpression));
                  }
                  if (e2.isSpreadAssignment(Je))
                    return m2.updateSpreadAssignment(Je, vr || e2.visitNode(Je.expression, H, e2.isExpression));
                  e2.Debug.assert(vr === void 0, "Should not have generated a wrapped target");
                }
                return e2.visitNode(Je, U);
              }
              function Wr(Je) {
                return e2.isArrayLiteralExpression(Je) ? m2.updateArrayLiteralExpression(Je, e2.visitNodes(Je.elements, Sr, e2.isExpression)) : m2.updateObjectLiteralExpression(Je, e2.visitNodes(Je.properties, zr, e2.isObjectLiteralElementLike));
              }
            }
            e2.transformClassFields = B;
            function E(p, m2) {
              return e2.factory.createAssignment(p, e2.factory.createObjectLiteralExpression([e2.factory.createPropertyAssignment("value", m2 || e2.factory.createVoidZero())]));
            }
            function Q(p, m2, G) {
              return e2.factory.createCallExpression(e2.factory.createPropertyAccessExpression(G, "set"), void 0, [p, m2 || e2.factory.createVoidZero()]);
            }
            function le(p, m2) {
              return e2.factory.createCallExpression(e2.factory.createPropertyAccessExpression(m2, "add"), void 0, [p]);
            }
            function N(p) {
              return p.escapedText === "#constructor";
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(E) {
              E[E.AsyncMethodsWithSuper = 1] = "AsyncMethodsWithSuper";
            })(a || (a = {}));
            var C;
            (function(E) {
              E[E.NonTopLevel = 1] = "NonTopLevel", E[E.HasLexicalThis = 2] = "HasLexicalThis";
            })(C || (C = {}));
            function w(E) {
              var Q = E.factory, le = E.getEmitHelperFactory, N = E.resumeLexicalEnvironment, p = E.endLexicalEnvironment, m2 = E.hoistVariableDeclaration, G = E.getEmitResolver(), oe = E.getCompilerOptions(), f4 = e2.getEmitScriptTarget(oe), T, K = 0, b, se, J, ie = [], R = 0, q = E.onEmitNode, O = E.onSubstituteNode;
              return E.onEmitNode = Re, E.onSubstituteNode = ze, e2.chainBundle(E, ve);
              function ve(de) {
                if (de.isDeclarationFile)
                  return de;
                ee(1, false), ee(2, !e2.isEffectiveStrictModeSourceFile(de, oe));
                var ye = e2.visitEachChild(de, A2, E);
                return e2.addEmitHelpers(ye, E.readEmitHelpers()), ye;
              }
              function ee(de, ye) {
                R = ye ? R | de : R & ~de;
              }
              function he(de) {
                return (R & de) !== 0;
              }
              function F2() {
                return !he(1);
              }
              function x2() {
                return he(2);
              }
              function X(de, ye, Ae) {
                var er = de & ~R;
                if (er) {
                  ee(er, true);
                  var ir = ye(Ae);
                  return ee(er, false), ir;
                }
                return ye(Ae);
              }
              function $(de) {
                return e2.visitEachChild(de, A2, E);
              }
              function A2(de) {
                if ((de.transformFlags & 256) === 0)
                  return de;
                switch (de.kind) {
                  case 131:
                    return;
                  case 218:
                    return U(de);
                  case 169:
                    return X(3, j, de);
                  case 256:
                    return X(3, H, de);
                  case 213:
                    return X(3, I, de);
                  case 214:
                    return X(1, l, de);
                  case 206:
                    return se && e2.isPropertyAccessExpression(de) && de.expression.kind === 106 && se.add(de.name.escapedText), e2.visitEachChild(de, A2, E);
                  case 207:
                    return se && de.expression.kind === 106 && (J = true), e2.visitEachChild(de, A2, E);
                  case 172:
                  case 173:
                  case 171:
                  case 257:
                  case 226:
                    return X(3, $, de);
                  default:
                    return e2.visitEachChild(de, A2, E);
                }
              }
              function y(de) {
                if (e2.isNodeWithPossibleHoistedDeclaration(de))
                  switch (de.kind) {
                    case 237:
                      return L(de);
                    case 242:
                      return Y(de);
                    case 243:
                      return P(de);
                    case 244:
                      return k(de);
                    case 292:
                      return V(de);
                    case 235:
                    case 249:
                    case 263:
                    case 289:
                    case 290:
                    case 252:
                    case 240:
                    case 241:
                    case 239:
                    case 248:
                    case 250:
                      return e2.visitEachChild(de, y, E);
                    default:
                      return e2.Debug.assertNever(de, "Unhandled node.");
                  }
                return A2(de);
              }
              function V(de) {
                var ye = new e2.Set();
                d(de.variableDeclaration, ye);
                var Ae;
                if (ye.forEach(function(Cr, Ye) {
                  b.has(Ye) && (Ae || (Ae = new e2.Set(b)), Ae.delete(Ye));
                }), Ae) {
                  var er = b;
                  b = Ae;
                  var ir = e2.visitEachChild(de, y, E);
                  return b = er, ir;
                } else
                  return e2.visitEachChild(de, y, E);
              }
              function L(de) {
                if (D(de.declarationList)) {
                  var ye = fe(de.declarationList, false);
                  return ye ? Q.createExpressionStatement(ye) : void 0;
                }
                return e2.visitEachChild(de, A2, E);
              }
              function P(de) {
                return Q.updateForInStatement(de, D(de.initializer) ? fe(de.initializer, true) : e2.visitNode(de.initializer, A2, e2.isForInitializer), e2.visitNode(de.expression, A2, e2.isExpression), e2.visitIterationBody(de.statement, y, E));
              }
              function k(de) {
                return Q.updateForOfStatement(de, e2.visitNode(de.awaitModifier, A2, e2.isToken), D(de.initializer) ? fe(de.initializer, true) : e2.visitNode(de.initializer, A2, e2.isForInitializer), e2.visitNode(de.expression, A2, e2.isExpression), e2.visitIterationBody(de.statement, y, E));
              }
              function Y(de) {
                var ye = de.initializer;
                return Q.updateForStatement(de, D(ye) ? fe(ye, false) : e2.visitNode(de.initializer, A2, e2.isForInitializer), e2.visitNode(de.condition, A2, e2.isExpression), e2.visitNode(de.incrementor, A2, e2.isExpression), e2.visitIterationBody(de.statement, y, E));
              }
              function U(de) {
                return F2() ? e2.visitEachChild(de, A2, E) : e2.setOriginalNode(e2.setTextRange(Q.createYieldExpression(void 0, e2.visitNode(de.expression, A2, e2.isExpression)), de), de);
              }
              function j(de) {
                return Q.updateMethodDeclaration(de, void 0, e2.visitNodes(de.modifiers, A2, e2.isModifier), de.asteriskToken, de.name, void 0, void 0, e2.visitParameterList(de.parameters, A2, E), void 0, e2.getFunctionFlags(de) & 2 ? Fe(de) : e2.visitFunctionBody(de.body, A2, E));
              }
              function H(de) {
                return Q.updateFunctionDeclaration(de, void 0, e2.visitNodes(de.modifiers, A2, e2.isModifier), de.asteriskToken, de.name, void 0, e2.visitParameterList(de.parameters, A2, E), void 0, e2.getFunctionFlags(de) & 2 ? Fe(de) : e2.visitFunctionBody(de.body, A2, E));
              }
              function I(de) {
                return Q.updateFunctionExpression(de, e2.visitNodes(de.modifiers, A2, e2.isModifier), de.asteriskToken, de.name, void 0, e2.visitParameterList(de.parameters, A2, E), void 0, e2.getFunctionFlags(de) & 2 ? Fe(de) : e2.visitFunctionBody(de.body, A2, E));
              }
              function l(de) {
                return Q.updateArrowFunction(de, e2.visitNodes(de.modifiers, A2, e2.isModifier), void 0, e2.visitParameterList(de.parameters, A2, E), void 0, de.equalsGreaterThanToken, e2.getFunctionFlags(de) & 2 ? Fe(de) : e2.visitFunctionBody(de.body, A2, E));
              }
              function d(de, ye) {
                var Ae = de.name;
                if (e2.isIdentifier(Ae))
                  ye.add(Ae.escapedText);
                else
                  for (var er = 0, ir = Ae.elements; er < ir.length; er++) {
                    var Cr = ir[er];
                    e2.isOmittedExpression(Cr) || d(Cr, ye);
                  }
              }
              function D(de) {
                return !!de && e2.isVariableDeclarationList(de) && !(de.flags & 3) && de.declarations.some(We);
              }
              function fe(de, ye) {
                g(de);
                var Ae = e2.getInitializedVariables(de);
                return Ae.length === 0 ? ye ? e2.visitNode(Q.converters.convertToAssignmentElementTarget(de.declarations[0].name), A2, e2.isExpression) : void 0 : Q.inlineExpressions(e2.map(Ae, ue));
              }
              function g(de) {
                e2.forEach(de.declarations, ne);
              }
              function ne(de) {
                var ye = de.name;
                if (e2.isIdentifier(ye))
                  m2(ye);
                else
                  for (var Ae = 0, er = ye.elements; Ae < er.length; Ae++) {
                    var ir = er[Ae];
                    e2.isOmittedExpression(ir) || ne(ir);
                  }
              }
              function ue(de) {
                var ye = e2.setSourceMapRange(Q.createAssignment(Q.converters.convertToAssignmentElementTarget(de.name), de.initializer), de);
                return e2.visitNode(ye, A2, e2.isExpression);
              }
              function We(de) {
                var ye = de.name;
                if (e2.isIdentifier(ye))
                  return b.has(ye.escapedText);
                for (var Ae = 0, er = ye.elements; Ae < er.length; Ae++) {
                  var ir = er[Ae];
                  if (!e2.isOmittedExpression(ir) && We(ir))
                    return true;
                }
                return false;
              }
              function Fe(de) {
                N();
                var ye = e2.getOriginalNode(de, e2.isFunctionLike), Ae = ye.type, er = f4 < 2 ? Be(Ae) : void 0, ir = de.kind === 214, Cr = (G.getNodeCheckFlags(de) & 8192) !== 0, Ye = b;
                b = new e2.Set();
                for (var Br = 0, Er = de.parameters; Br < Er.length; Br++) {
                  var Ne = Er[Br];
                  d(Ne, b);
                }
                var n = se, lr = J;
                ir || (se = new e2.Set(), J = false);
                var be;
                if (ir) {
                  var Ur = le().createAwaiterHelper(x2(), Cr, er, Z2(de.body)), ii = p();
                  if (e2.some(ii)) {
                    var wr = Q.converters.convertToFunctionBlock(Ur);
                    be = Q.updateBlock(wr, e2.setTextRange(Q.createNodeArray(e2.concatenate(ii, wr.statements)), wr.statements));
                  } else
                    be = Ur;
                } else {
                  var Ge = [], ur = Q.copyPrologue(de.body.statements, Ge, false, A2);
                  Ge.push(Q.createReturnStatement(le().createAwaiterHelper(x2(), Cr, er, Z2(de.body, ur)))), e2.insertStatementsAfterStandardPrologue(Ge, p());
                  var yr = f4 >= 2 && G.getNodeCheckFlags(de) & 6144;
                  if (yr && (ge(), se.size)) {
                    var Ir = B(Q, G, de, se);
                    ie[e2.getNodeId(Ir)] = true, e2.insertStatementsAfterStandardPrologue(Ge, [Ir]);
                  }
                  var wr = Q.createBlock(Ge, true);
                  e2.setTextRange(wr, de.body), yr && J && (G.getNodeCheckFlags(de) & 4096 ? e2.addEmitHelper(wr, e2.advancedAsyncSuperHelper) : G.getNodeCheckFlags(de) & 2048 && e2.addEmitHelper(wr, e2.asyncSuperHelper)), be = wr;
                }
                return b = Ye, ir || (se = n, J = lr), be;
              }
              function Z2(de, ye) {
                return e2.isBlock(de) ? Q.updateBlock(de, e2.visitNodes(de.statements, y, e2.isStatement, ye)) : Q.converters.convertToFunctionBlock(e2.visitNode(de, y, e2.isConciseBody));
              }
              function Be(de) {
                var ye = de && e2.getEntityNameFromTypeNode(de);
                if (ye && e2.isEntityName(ye)) {
                  var Ae = G.getTypeReferenceSerializationKind(ye);
                  if (Ae === e2.TypeReferenceSerializationKind.TypeWithConstructSignatureAndValue || Ae === e2.TypeReferenceSerializationKind.Unknown)
                    return ye;
                }
              }
              function ge() {
                (T & 1) === 0 && (T |= 1, E.enableSubstitution(208), E.enableSubstitution(206), E.enableSubstitution(207), E.enableEmitNotification(257), E.enableEmitNotification(169), E.enableEmitNotification(172), E.enableEmitNotification(173), E.enableEmitNotification(171), E.enableEmitNotification(237));
              }
              function Re(de, ye, Ae) {
                if (T & 1 && _e(ye)) {
                  var er = G.getNodeCheckFlags(ye) & 6144;
                  if (er !== K) {
                    var ir = K;
                    K = er, q(de, ye, Ae), K = ir;
                    return;
                  }
                } else if (T && ie[e2.getNodeId(ye)]) {
                  var ir = K;
                  K = 0, q(de, ye, Ae), K = ir;
                  return;
                }
                q(de, ye, Ae);
              }
              function ze(de, ye) {
                return ye = O(de, ye), de === 1 && K ? Ee(ye) : ye;
              }
              function Ee(de) {
                switch (de.kind) {
                  case 206:
                    return He(de);
                  case 207:
                    return rr(de);
                  case 208:
                    return Ie(de);
                }
                return de;
              }
              function He(de) {
                return de.expression.kind === 106 ? e2.setTextRange(Q.createPropertyAccessExpression(Q.createUniqueName("_super", 48), de.name), de) : de;
              }
              function rr(de) {
                return de.expression.kind === 106 ? we(de.argumentExpression, de) : de;
              }
              function Ie(de) {
                var ye = de.expression;
                if (e2.isSuperProperty(ye)) {
                  var Ae = e2.isPropertyAccessExpression(ye) ? He(ye) : rr(ye);
                  return Q.createCallExpression(Q.createPropertyAccessExpression(Ae, "call"), void 0, Ve([Q.createThis()], de.arguments, true));
                }
                return de;
              }
              function _e(de) {
                var ye = de.kind;
                return ye === 257 || ye === 171 || ye === 169 || ye === 172 || ye === 173;
              }
              function we(de, ye) {
                return K & 4096 ? e2.setTextRange(Q.createPropertyAccessExpression(Q.createCallExpression(Q.createUniqueName("_superIndex", 48), void 0, [de]), "value"), ye) : e2.setTextRange(Q.createCallExpression(Q.createUniqueName("_superIndex", 48), void 0, [de]), ye);
              }
            }
            e2.transformES2017 = w;
            function B(E, Q, le, N) {
              var p = (Q.getNodeCheckFlags(le) & 4096) !== 0, m2 = [];
              return N.forEach(function(G, oe) {
                var f4 = e2.unescapeLeadingUnderscores(oe), T = [];
                T.push(E.createPropertyAssignment("get", E.createArrowFunction(void 0, void 0, [], void 0, void 0, e2.setEmitFlags(E.createPropertyAccessExpression(e2.setEmitFlags(E.createSuper(), 4), f4), 4)))), p && T.push(E.createPropertyAssignment("set", E.createArrowFunction(void 0, void 0, [E.createParameterDeclaration(void 0, void 0, void 0, "v", void 0, void 0, void 0)], void 0, void 0, E.createAssignment(e2.setEmitFlags(E.createPropertyAccessExpression(e2.setEmitFlags(E.createSuper(), 4), f4), 4), E.createIdentifier("v"))))), m2.push(E.createPropertyAssignment(f4, E.createObjectLiteralExpression(T)));
              }), E.createVariableStatement(void 0, E.createVariableDeclarationList([E.createVariableDeclaration(E.createUniqueName("_super", 48), void 0, void 0, E.createCallExpression(E.createPropertyAccessExpression(E.createIdentifier("Object"), "create"), void 0, [E.createNull(), E.createObjectLiteralExpression(m2, true)]))], 2));
            }
            e2.createSuperAccessVariableStatement = B;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(B) {
              B[B.AsyncMethodsWithSuper = 1] = "AsyncMethodsWithSuper";
            })(a || (a = {}));
            var C;
            (function(B) {
              B[B.None = 0] = "None", B[B.HasLexicalThis = 1] = "HasLexicalThis", B[B.IterationContainer = 2] = "IterationContainer", B[B.AncestorFactsMask = 3] = "AncestorFactsMask", B[B.SourceFileIncludes = 1] = "SourceFileIncludes", B[B.SourceFileExcludes = 2] = "SourceFileExcludes", B[B.StrictModeSourceFileIncludes = 0] = "StrictModeSourceFileIncludes", B[B.ClassOrFunctionIncludes = 1] = "ClassOrFunctionIncludes", B[B.ClassOrFunctionExcludes = 2] = "ClassOrFunctionExcludes", B[B.ArrowFunctionIncludes = 0] = "ArrowFunctionIncludes", B[B.ArrowFunctionExcludes = 2] = "ArrowFunctionExcludes", B[B.IterationStatementIncludes = 2] = "IterationStatementIncludes", B[B.IterationStatementExcludes = 0] = "IterationStatementExcludes";
            })(C || (C = {}));
            function w(B) {
              var E = B.factory, Q = B.getEmitHelperFactory, le = B.resumeLexicalEnvironment, N = B.endLexicalEnvironment, p = B.hoistVariableDeclaration, m2 = B.getEmitResolver(), G = B.getCompilerOptions(), oe = e2.getEmitScriptTarget(G), f4 = B.onEmitNode;
              B.onEmitNode = Ge;
              var T = B.onSubstituteNode;
              B.onSubstituteNode = ur;
              var K = false, b, se, J, ie = 0, R = 0, q, O, ve, ee, he = [];
              return e2.chainBundle(B, A2);
              function F2(pe, or) {
                return R !== (R & ~pe | or);
              }
              function x2(pe, or) {
                var qr = R;
                return R = (R & ~pe | or) & 3, qr;
              }
              function X(pe) {
                R = pe;
              }
              function $(pe) {
                O = e2.append(O, E.createVariableDeclaration(pe));
              }
              function A2(pe) {
                if (pe.isDeclarationFile)
                  return pe;
                q = pe;
                var or = g(pe);
                return e2.addEmitHelpers(or, B.readEmitHelpers()), q = void 0, O = void 0, or;
              }
              function y(pe) {
                return Y(pe, false);
              }
              function V(pe) {
                return Y(pe, true);
              }
              function L(pe) {
                if (pe.kind !== 131)
                  return pe;
              }
              function P(pe, or, qr, si) {
                if (F2(qr, si)) {
                  var Di = x2(qr, si), wi = pe(or);
                  return X(Di), wi;
                }
                return pe(or);
              }
              function k(pe) {
                return e2.visitEachChild(pe, y, B);
              }
              function Y(pe, or) {
                if ((pe.transformFlags & 128) === 0)
                  return pe;
                switch (pe.kind) {
                  case 218:
                    return U(pe);
                  case 224:
                    return j(pe);
                  case 247:
                    return H(pe);
                  case 250:
                    return I(pe);
                  case 205:
                    return d(pe);
                  case 221:
                    return ue(pe, or);
                  case 351:
                    return We(pe, or);
                  case 292:
                    return Fe(pe);
                  case 237:
                    return Z2(pe);
                  case 254:
                    return Be(pe);
                  case 240:
                  case 241:
                  case 243:
                    return P(k, pe, 0, 2);
                  case 244:
                    return Ee(pe, void 0);
                  case 242:
                    return P(Re, pe, 0, 2);
                  case 217:
                    return ze(pe);
                  case 171:
                    return P(Ae, pe, 2, 1);
                  case 169:
                    return P(Cr, pe, 2, 1);
                  case 172:
                    return P(er, pe, 2, 1);
                  case 173:
                    return P(ir, pe, 2, 1);
                  case 256:
                    return P(Ye, pe, 2, 1);
                  case 213:
                    return P(Er, pe, 2, 1);
                  case 214:
                    return P(Br, pe, 2, 0);
                  case 164:
                    return de(pe);
                  case 238:
                    return D(pe);
                  case 212:
                    return fe(pe, or);
                  case 210:
                    return ne(pe);
                  case 206:
                    return ve && e2.isPropertyAccessExpression(pe) && pe.expression.kind === 106 && ve.add(pe.name.escapedText), e2.visitEachChild(pe, y, B);
                  case 207:
                    return ve && pe.expression.kind === 106 && (ee = true), e2.visitEachChild(pe, y, B);
                  case 257:
                  case 226:
                    return P(k, pe, 2, 1);
                  default:
                    return e2.visitEachChild(pe, y, B);
                }
              }
              function U(pe) {
                return se & 2 && se & 1 ? e2.setOriginalNode(e2.setTextRange(E.createYieldExpression(void 0, Q().createAwaitHelper(e2.visitNode(pe.expression, y, e2.isExpression))), pe), pe) : e2.visitEachChild(pe, y, B);
              }
              function j(pe) {
                if (se & 2 && se & 1) {
                  if (pe.asteriskToken) {
                    var or = e2.visitNode(e2.Debug.checkDefined(pe.expression), y, e2.isExpression);
                    return e2.setOriginalNode(e2.setTextRange(E.createYieldExpression(void 0, Q().createAwaitHelper(E.updateYieldExpression(pe, pe.asteriskToken, e2.setTextRange(Q().createAsyncDelegatorHelper(e2.setTextRange(Q().createAsyncValuesHelper(or), or)), or)))), pe), pe);
                  }
                  return e2.setOriginalNode(e2.setTextRange(E.createYieldExpression(void 0, Ie(pe.expression ? e2.visitNode(pe.expression, y, e2.isExpression) : E.createVoidZero())), pe), pe);
                }
                return e2.visitEachChild(pe, y, B);
              }
              function H(pe) {
                return se & 2 && se & 1 ? E.updateReturnStatement(pe, Ie(pe.expression ? e2.visitNode(pe.expression, y, e2.isExpression) : E.createVoidZero())) : e2.visitEachChild(pe, y, B);
              }
              function I(pe) {
                if (se & 2) {
                  var or = e2.unwrapInnermostStatementOfLabel(pe);
                  return or.kind === 244 && or.awaitModifier ? Ee(or, pe) : E.restoreEnclosingLabel(e2.visitNode(or, y, e2.isStatement, E.liftToBlock), pe);
                }
                return e2.visitEachChild(pe, y, B);
              }
              function l(pe) {
                for (var or, qr = [], si = 0, Di = pe; si < Di.length; si++) {
                  var wi = Di[si];
                  if (wi.kind === 298) {
                    or && (qr.push(E.createObjectLiteralExpression(or)), or = void 0);
                    var Xi = wi.expression;
                    qr.push(e2.visitNode(Xi, y, e2.isExpression));
                  } else
                    or = e2.append(or, wi.kind === 296 ? E.createPropertyAssignment(wi.name, e2.visitNode(wi.initializer, y, e2.isExpression)) : e2.visitNode(wi, y, e2.isObjectLiteralElementLike));
                }
                return or && qr.push(E.createObjectLiteralExpression(or)), qr;
              }
              function d(pe) {
                if (pe.transformFlags & 32768) {
                  var or = l(pe.properties);
                  or.length && or[0].kind !== 205 && or.unshift(E.createObjectLiteralExpression());
                  var qr = or[0];
                  if (or.length > 1) {
                    for (var si = 1; si < or.length; si++)
                      qr = Q().createAssignHelper([qr, or[si]]);
                    return qr;
                  } else
                    return Q().createAssignHelper(or);
                }
                return e2.visitEachChild(pe, y, B);
              }
              function D(pe) {
                return e2.visitEachChild(pe, V, B);
              }
              function fe(pe, or) {
                return e2.visitEachChild(pe, or ? V : y, B);
              }
              function g(pe) {
                var or = x2(2, e2.isEffectiveStrictModeSourceFile(pe, G) ? 0 : 1);
                K = false;
                var qr = e2.visitEachChild(pe, y, B), si = e2.concatenate(qr.statements, O && [E.createVariableStatement(void 0, E.createVariableDeclarationList(O))]), Di = E.updateSourceFile(qr, e2.setTextRange(E.createNodeArray(si), pe.statements));
                return X(or), Di;
              }
              function ne(pe) {
                return e2.processTaggedTemplateExpression(B, pe, y, q, $, e2.ProcessLevel.LiftRestriction);
              }
              function ue(pe, or) {
                return e2.isDestructuringAssignment(pe) && pe.left.transformFlags & 32768 ? e2.flattenDestructuringAssignment(pe, y, B, 1, !or) : pe.operatorToken.kind === 27 ? E.updateBinaryExpression(pe, e2.visitNode(pe.left, V, e2.isExpression), pe.operatorToken, e2.visitNode(pe.right, or ? V : y, e2.isExpression)) : e2.visitEachChild(pe, y, B);
              }
              function We(pe, or) {
                if (or)
                  return e2.visitEachChild(pe, V, B);
                for (var qr, si = 0; si < pe.elements.length; si++) {
                  var Di = pe.elements[si], wi = e2.visitNode(Di, si < pe.elements.length - 1 ? V : y, e2.isExpression);
                  (qr || wi !== Di) && (qr || (qr = pe.elements.slice(0, si)), qr.push(wi));
                }
                var Xi = qr ? e2.setTextRange(E.createNodeArray(qr), pe.elements) : pe.elements;
                return E.updateCommaListExpression(pe, Xi);
              }
              function Fe(pe) {
                if (pe.variableDeclaration && e2.isBindingPattern(pe.variableDeclaration.name) && pe.variableDeclaration.name.transformFlags & 32768) {
                  var or = E.getGeneratedNameForNode(pe.variableDeclaration.name), qr = E.updateVariableDeclaration(pe.variableDeclaration, pe.variableDeclaration.name, void 0, void 0, or), si = e2.flattenDestructuringBinding(qr, y, B, 1), Di = e2.visitNode(pe.block, y, e2.isBlock);
                  return e2.some(si) && (Di = E.updateBlock(Di, Ve([E.createVariableStatement(void 0, si)], Di.statements, true))), E.updateCatchClause(pe, E.updateVariableDeclaration(pe.variableDeclaration, or, void 0, void 0, void 0), Di);
                }
                return e2.visitEachChild(pe, y, B);
              }
              function Z2(pe) {
                if (e2.hasSyntacticModifier(pe, 1)) {
                  var or = K;
                  K = true;
                  var qr = e2.visitEachChild(pe, y, B);
                  return K = or, qr;
                }
                return e2.visitEachChild(pe, y, B);
              }
              function Be(pe) {
                if (K) {
                  var or = K;
                  K = false;
                  var qr = ge(pe, true);
                  return K = or, qr;
                }
                return ge(pe, false);
              }
              function ge(pe, or) {
                return e2.isBindingPattern(pe.name) && pe.name.transformFlags & 32768 ? e2.flattenDestructuringBinding(pe, y, B, 1, void 0, or) : e2.visitEachChild(pe, y, B);
              }
              function Re(pe) {
                return E.updateForStatement(pe, e2.visitNode(pe.initializer, V, e2.isForInitializer), e2.visitNode(pe.condition, y, e2.isExpression), e2.visitNode(pe.incrementor, V, e2.isExpression), e2.visitIterationBody(pe.statement, y, B));
              }
              function ze(pe) {
                return e2.visitEachChild(pe, V, B);
              }
              function Ee(pe, or) {
                var qr = x2(0, 2);
                pe.initializer.transformFlags & 32768 && (pe = He(pe));
                var si = pe.awaitModifier ? _e(pe, or, qr) : E.restoreEnclosingLabel(e2.visitEachChild(pe, y, B), or);
                return X(qr), si;
              }
              function He(pe) {
                var or = e2.skipParentheses(pe.initializer);
                if (e2.isVariableDeclarationList(or) || e2.isAssignmentPattern(or)) {
                  var qr = void 0, si = void 0, Di = E.createTempVariable(void 0), wi = [e2.createForOfBindingStatement(E, or, Di)];
                  return e2.isBlock(pe.statement) ? (e2.addRange(wi, pe.statement.statements), qr = pe.statement, si = pe.statement.statements) : pe.statement && (e2.append(wi, pe.statement), qr = pe.statement, si = pe.statement), E.updateForOfStatement(pe, pe.awaitModifier, e2.setTextRange(E.createVariableDeclarationList([e2.setTextRange(E.createVariableDeclaration(Di), pe.initializer)], 1), pe.initializer), pe.expression, e2.setTextRange(E.createBlock(e2.setTextRange(E.createNodeArray(wi), si), true), qr));
                }
                return pe;
              }
              function rr(pe, or) {
                var qr = e2.createForOfBindingStatement(E, pe.initializer, or), si, Di, wi = [e2.visitNode(qr, y, e2.isStatement)], Xi = e2.visitIterationBody(pe.statement, y, B);
                return e2.isBlock(Xi) ? (e2.addRange(wi, Xi.statements), si = Xi, Di = Xi.statements) : wi.push(Xi), e2.setEmitFlags(e2.setTextRange(E.createBlock(e2.setTextRange(E.createNodeArray(wi), Di), true), si), 432);
              }
              function Ie(pe) {
                return se & 1 ? E.createYieldExpression(void 0, Q().createAwaitHelper(pe)) : E.createAwaitExpression(pe);
              }
              function _e(pe, or, qr) {
                var si = e2.visitNode(pe.expression, y, e2.isExpression), Di = e2.isIdentifier(si) ? E.getGeneratedNameForNode(si) : E.createTempVariable(void 0), wi = e2.isIdentifier(si) ? E.getGeneratedNameForNode(Di) : E.createTempVariable(void 0), Xi = E.createUniqueName("e"), et = E.getGeneratedNameForNode(Xi), Gi = E.createTempVariable(void 0), Wt = e2.setTextRange(Q().createAsyncValuesHelper(si), pe.expression), Zt = E.createCallExpression(E.createPropertyAccessExpression(Di, "next"), void 0, []), _r = E.createPropertyAccessExpression(wi, "done"), pi = E.createPropertyAccessExpression(wi, "value"), ae = E.createFunctionCallCall(Gi, Di, []);
                p(Xi), p(Gi);
                var Xe = qr & 2 ? E.inlineExpressions([E.createAssignment(Xi, E.createVoidZero()), Wt]) : Wt, Jr = e2.setEmitFlags(e2.setTextRange(E.createForStatement(e2.setEmitFlags(e2.setTextRange(E.createVariableDeclarationList([e2.setTextRange(E.createVariableDeclaration(Di, void 0, void 0, Xe), pe.expression), E.createVariableDeclaration(wi)]), pe.expression), 2097152), E.createComma(E.createAssignment(wi, Ie(Zt)), E.createLogicalNot(_r)), void 0, rr(pe, pi)), pe), 256);
                return e2.setOriginalNode(Jr, pe), E.createTryStatement(E.createBlock([E.restoreEnclosingLabel(Jr, or)]), E.createCatchClause(E.createVariableDeclaration(et), e2.setEmitFlags(E.createBlock([E.createExpressionStatement(E.createAssignment(Xi, E.createObjectLiteralExpression([E.createPropertyAssignment("error", et)])))]), 1)), E.createBlock([E.createTryStatement(E.createBlock([e2.setEmitFlags(E.createIfStatement(E.createLogicalAnd(E.createLogicalAnd(wi, E.createLogicalNot(_r)), E.createAssignment(Gi, E.createPropertyAccessExpression(Di, "return"))), E.createExpressionStatement(Ie(ae))), 1)]), void 0, e2.setEmitFlags(E.createBlock([e2.setEmitFlags(E.createIfStatement(Xi, E.createThrowStatement(E.createPropertyAccessExpression(Xi, "error"))), 1)]), 1))]));
              }
              function we(pe) {
                return e2.Debug.assertNode(pe, e2.isParameter), de(pe);
              }
              function de(pe) {
                return J != null && J.has(pe) ? E.updateParameterDeclaration(pe, void 0, void 0, pe.dotDotDotToken, e2.isBindingPattern(pe.name) ? E.getGeneratedNameForNode(pe) : pe.name, void 0, void 0, void 0) : pe.transformFlags & 32768 ? E.updateParameterDeclaration(pe, void 0, void 0, pe.dotDotDotToken, E.getGeneratedNameForNode(pe), void 0, void 0, e2.visitNode(pe.initializer, y, e2.isExpression)) : e2.visitEachChild(pe, y, B);
              }
              function ye(pe) {
                for (var or, qr = 0, si = pe.parameters; qr < si.length; qr++) {
                  var Di = si[qr];
                  or ? or.add(Di) : Di.transformFlags & 32768 && (or = new e2.Set());
                }
                return or;
              }
              function Ae(pe) {
                var or = se, qr = J;
                se = e2.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateConstructorDeclaration(pe, void 0, pe.modifiers, e2.visitParameterList(pe.parameters, we, B), n(pe));
                return se = or, J = qr, si;
              }
              function er(pe) {
                var or = se, qr = J;
                se = e2.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateGetAccessorDeclaration(pe, void 0, pe.modifiers, e2.visitNode(pe.name, y, e2.isPropertyName), e2.visitParameterList(pe.parameters, we, B), void 0, n(pe));
                return se = or, J = qr, si;
              }
              function ir(pe) {
                var or = se, qr = J;
                se = e2.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateSetAccessorDeclaration(pe, void 0, pe.modifiers, e2.visitNode(pe.name, y, e2.isPropertyName), e2.visitParameterList(pe.parameters, we, B), n(pe));
                return se = or, J = qr, si;
              }
              function Cr(pe) {
                var or = se, qr = J;
                se = e2.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateMethodDeclaration(pe, void 0, se & 1 ? e2.visitNodes(pe.modifiers, L, e2.isModifier) : pe.modifiers, se & 2 ? void 0 : pe.asteriskToken, e2.visitNode(pe.name, y, e2.isPropertyName), e2.visitNode(void 0, y, e2.isToken), void 0, e2.visitParameterList(pe.parameters, we, B), void 0, se & 2 && se & 1 ? Ne(pe) : n(pe));
                return se = or, J = qr, si;
              }
              function Ye(pe) {
                var or = se, qr = J;
                se = e2.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateFunctionDeclaration(pe, void 0, se & 1 ? e2.visitNodes(pe.modifiers, L, e2.isModifier) : pe.modifiers, se & 2 ? void 0 : pe.asteriskToken, pe.name, void 0, e2.visitParameterList(pe.parameters, we, B), void 0, se & 2 && se & 1 ? Ne(pe) : n(pe));
                return se = or, J = qr, si;
              }
              function Br(pe) {
                var or = se, qr = J;
                se = e2.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateArrowFunction(pe, pe.modifiers, void 0, e2.visitParameterList(pe.parameters, we, B), void 0, pe.equalsGreaterThanToken, n(pe));
                return se = or, J = qr, si;
              }
              function Er(pe) {
                var or = se, qr = J;
                se = e2.getFunctionFlags(pe), J = ye(pe);
                var si = E.updateFunctionExpression(pe, se & 1 ? e2.visitNodes(pe.modifiers, L, e2.isModifier) : pe.modifiers, se & 2 ? void 0 : pe.asteriskToken, pe.name, void 0, e2.visitParameterList(pe.parameters, we, B), void 0, se & 2 && se & 1 ? Ne(pe) : n(pe));
                return se = or, J = qr, si;
              }
              function Ne(pe) {
                le();
                var or = [], qr = E.copyPrologue(pe.body.statements, or, false, y);
                lr(or, pe);
                var si = ve, Di = ee;
                ve = new e2.Set(), ee = false;
                var wi = E.createReturnStatement(Q().createAsyncGeneratorHelper(E.createFunctionExpression(void 0, E.createToken(41), pe.name && E.getGeneratedNameForNode(pe.name), void 0, [], void 0, E.updateBlock(pe.body, e2.visitLexicalEnvironment(pe.body.statements, y, B, qr))), !!(R & 1))), Xi = oe >= 2 && m2.getNodeCheckFlags(pe) & 6144;
                if (Xi) {
                  be();
                  var et = e2.createSuperAccessVariableStatement(E, m2, pe, ve);
                  he[e2.getNodeId(et)] = true, e2.insertStatementsAfterStandardPrologue(or, [et]);
                }
                or.push(wi), e2.insertStatementsAfterStandardPrologue(or, N());
                var Gi = E.updateBlock(pe.body, or);
                return Xi && ee && (m2.getNodeCheckFlags(pe) & 4096 ? e2.addEmitHelper(Gi, e2.advancedAsyncSuperHelper) : m2.getNodeCheckFlags(pe) & 2048 && e2.addEmitHelper(Gi, e2.asyncSuperHelper)), ve = si, ee = Di, Gi;
              }
              function n(pe) {
                var or;
                le();
                var qr = 0, si = [], Di = (or = e2.visitNode(pe.body, y, e2.isConciseBody)) !== null && or !== void 0 ? or : E.createBlock([]);
                e2.isBlock(Di) && (qr = E.copyPrologue(Di.statements, si, false, y)), e2.addRange(si, lr(void 0, pe));
                var wi = N();
                if (qr > 0 || e2.some(si) || e2.some(wi)) {
                  var Xi = E.converters.convertToFunctionBlock(Di, true);
                  return e2.insertStatementsAfterStandardPrologue(si, wi), e2.addRange(si, Xi.statements.slice(qr)), E.updateBlock(Xi, e2.setTextRange(E.createNodeArray(si), Xi.statements));
                }
                return Di;
              }
              function lr(pe, or) {
                for (var qr = false, si = 0, Di = or.parameters; si < Di.length; si++) {
                  var wi = Di[si];
                  if (qr) {
                    if (e2.isBindingPattern(wi.name)) {
                      if (wi.name.elements.length > 0) {
                        var Xi = e2.flattenDestructuringBinding(wi, y, B, 0, E.getGeneratedNameForNode(wi));
                        if (e2.some(Xi)) {
                          var et = E.createVariableDeclarationList(Xi), Gi = E.createVariableStatement(void 0, et);
                          e2.setEmitFlags(Gi, 1048576), pe = e2.append(pe, Gi);
                        }
                      } else if (wi.initializer) {
                        var Wt = E.getGeneratedNameForNode(wi), Zt = e2.visitNode(wi.initializer, y, e2.isExpression), _r = E.createAssignment(Wt, Zt), Gi = E.createExpressionStatement(_r);
                        e2.setEmitFlags(Gi, 1048576), pe = e2.append(pe, Gi);
                      }
                    } else if (wi.initializer) {
                      var Wt = E.cloneNode(wi.name);
                      e2.setTextRange(Wt, wi.name), e2.setEmitFlags(Wt, 48);
                      var Zt = e2.visitNode(wi.initializer, y, e2.isExpression);
                      e2.addEmitFlags(Zt, 1584);
                      var _r = E.createAssignment(Wt, Zt);
                      e2.setTextRange(_r, wi), e2.setEmitFlags(_r, 1536);
                      var pi = E.createBlock([E.createExpressionStatement(_r)]);
                      e2.setTextRange(pi, wi), e2.setEmitFlags(pi, 1953);
                      var ae = E.createTypeCheck(E.cloneNode(wi.name), "undefined"), Gi = E.createIfStatement(ae, pi);
                      e2.startOnNewLine(Gi), e2.setTextRange(Gi, wi), e2.setEmitFlags(Gi, 1050528), pe = e2.append(pe, Gi);
                    }
                  } else if (wi.transformFlags & 32768) {
                    qr = true;
                    var Xi = e2.flattenDestructuringBinding(wi, y, B, 1, E.getGeneratedNameForNode(wi), false, true);
                    if (e2.some(Xi)) {
                      var et = E.createVariableDeclarationList(Xi), Gi = E.createVariableStatement(void 0, et);
                      e2.setEmitFlags(Gi, 1048576), pe = e2.append(pe, Gi);
                    }
                  }
                }
                return pe;
              }
              function be() {
                (b & 1) === 0 && (b |= 1, B.enableSubstitution(208), B.enableSubstitution(206), B.enableSubstitution(207), B.enableEmitNotification(257), B.enableEmitNotification(169), B.enableEmitNotification(172), B.enableEmitNotification(173), B.enableEmitNotification(171), B.enableEmitNotification(237));
              }
              function Ge(pe, or, qr) {
                if (b & 1 && ii(or)) {
                  var si = m2.getNodeCheckFlags(or) & 6144;
                  if (si !== ie) {
                    var Di = ie;
                    ie = si, f4(pe, or, qr), ie = Di;
                    return;
                  }
                } else if (b && he[e2.getNodeId(or)]) {
                  var Di = ie;
                  ie = 0, f4(pe, or, qr), ie = Di;
                  return;
                }
                f4(pe, or, qr);
              }
              function ur(pe, or) {
                return or = T(pe, or), pe === 1 && ie ? yr(or) : or;
              }
              function yr(pe) {
                switch (pe.kind) {
                  case 206:
                    return Ir(pe);
                  case 207:
                    return wr(pe);
                  case 208:
                    return Ur(pe);
                }
                return pe;
              }
              function Ir(pe) {
                return pe.expression.kind === 106 ? e2.setTextRange(E.createPropertyAccessExpression(E.createUniqueName("_super", 48), pe.name), pe) : pe;
              }
              function wr(pe) {
                return pe.expression.kind === 106 ? mi(pe.argumentExpression, pe) : pe;
              }
              function Ur(pe) {
                var or = pe.expression;
                if (e2.isSuperProperty(or)) {
                  var qr = e2.isPropertyAccessExpression(or) ? Ir(or) : wr(or);
                  return E.createCallExpression(E.createPropertyAccessExpression(qr, "call"), void 0, Ve([E.createThis()], pe.arguments, true));
                }
                return pe;
              }
              function ii(pe) {
                var or = pe.kind;
                return or === 257 || or === 171 || or === 169 || or === 172 || or === 173;
              }
              function mi(pe, or) {
                return ie & 4096 ? e2.setTextRange(E.createPropertyAccessExpression(E.createCallExpression(E.createIdentifier("_superIndex"), void 0, [pe]), "value"), or) : e2.setTextRange(E.createCallExpression(E.createIdentifier("_superIndex"), void 0, [pe]), or);
              }
            }
            e2.transformES2018 = w;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w = C.factory;
              return e2.chainBundle(C, B);
              function B(le) {
                return le.isDeclarationFile ? le : e2.visitEachChild(le, E, C);
              }
              function E(le) {
                if ((le.transformFlags & 64) === 0)
                  return le;
                switch (le.kind) {
                  case 292:
                    return Q(le);
                  default:
                    return e2.visitEachChild(le, E, C);
                }
              }
              function Q(le) {
                return le.variableDeclaration ? e2.visitEachChild(le, E, C) : w.updateCatchClause(le, w.createVariableDeclaration(w.createTempVariable(void 0)), e2.visitNode(le.block, E, e2.isBlock));
              }
            }
            e2.transformES2019 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w = C.factory, B = C.hoistVariableDeclaration;
              return e2.chainBundle(C, E);
              function E(b) {
                return b.isDeclarationFile ? b : e2.visitEachChild(b, Q, C);
              }
              function Q(b) {
                if ((b.transformFlags & 32) === 0)
                  return b;
                switch (b.kind) {
                  case 208: {
                    var se = m2(b, false);
                    return e2.Debug.assertNotNode(se, e2.isSyntheticReference), se;
                  }
                  case 206:
                  case 207:
                    if (e2.isOptionalChain(b)) {
                      var se = oe(b, false, false);
                      return e2.Debug.assertNotNode(se, e2.isSyntheticReference), se;
                    }
                    return e2.visitEachChild(b, Q, C);
                  case 221:
                    return b.operatorToken.kind === 60 ? T(b) : e2.visitEachChild(b, Q, C);
                  case 215:
                    return K(b);
                  default:
                    return e2.visitEachChild(b, Q, C);
                }
              }
              function le(b) {
                e2.Debug.assertNotNode(b, e2.isNonNullChain);
                for (var se = [b]; !b.questionDotToken && !e2.isTaggedTemplateExpression(b); )
                  b = e2.cast(e2.skipPartiallyEmittedExpressions(b.expression), e2.isOptionalChain), e2.Debug.assertNotNode(b, e2.isNonNullChain), se.unshift(b);
                return { expression: b.expression, chain: se };
              }
              function N(b, se, J) {
                var ie = G(b.expression, se, J);
                return e2.isSyntheticReference(ie) ? w.createSyntheticReferenceExpression(w.updateParenthesizedExpression(b, ie.expression), ie.thisArg) : w.updateParenthesizedExpression(b, ie);
              }
              function p(b, se, J) {
                if (e2.isOptionalChain(b))
                  return oe(b, se, J);
                var ie = e2.visitNode(b.expression, Q, e2.isExpression);
                e2.Debug.assertNotNode(ie, e2.isSyntheticReference);
                var R;
                return se && (e2.isSimpleCopiableExpression(ie) ? R = ie : (R = w.createTempVariable(B), ie = w.createAssignment(R, ie))), ie = b.kind === 206 ? w.updatePropertyAccessExpression(b, ie, e2.visitNode(b.name, Q, e2.isIdentifier)) : w.updateElementAccessExpression(b, ie, e2.visitNode(b.argumentExpression, Q, e2.isExpression)), R ? w.createSyntheticReferenceExpression(ie, R) : ie;
              }
              function m2(b, se) {
                if (e2.isOptionalChain(b))
                  return oe(b, se, false);
                if (e2.isParenthesizedExpression(b.expression) && e2.isOptionalChain(e2.skipParentheses(b.expression))) {
                  var J = N(b.expression, true, false), ie = e2.visitNodes(b.arguments, Q, e2.isExpression);
                  return e2.isSyntheticReference(J) ? e2.setTextRange(w.createFunctionCallCall(J.expression, J.thisArg, ie), b) : w.updateCallExpression(b, J, void 0, ie);
                }
                return e2.visitEachChild(b, Q, C);
              }
              function G(b, se, J) {
                switch (b.kind) {
                  case 212:
                    return N(b, se, J);
                  case 206:
                  case 207:
                    return p(b, se, J);
                  case 208:
                    return m2(b, se);
                  default:
                    return e2.visitNode(b, Q, e2.isExpression);
                }
              }
              function oe(b, se, J) {
                var ie = le(b), R = ie.expression, q = ie.chain, O = G(e2.skipPartiallyEmittedExpressions(R), e2.isCallChain(q[0]), false), ve = e2.isSyntheticReference(O) ? O.thisArg : void 0, ee = e2.isSyntheticReference(O) ? O.expression : O, he = w.restoreOuterExpressions(R, ee, 8);
                e2.isSimpleCopiableExpression(ee) || (ee = w.createTempVariable(B), he = w.createAssignment(ee, he));
                for (var F2 = ee, x2, X = 0; X < q.length; X++) {
                  var $ = q[X];
                  switch ($.kind) {
                    case 206:
                    case 207:
                      X === q.length - 1 && se && (e2.isSimpleCopiableExpression(F2) ? x2 = F2 : (x2 = w.createTempVariable(B), F2 = w.createAssignment(x2, F2))), F2 = $.kind === 206 ? w.createPropertyAccessExpression(F2, e2.visitNode($.name, Q, e2.isIdentifier)) : w.createElementAccessExpression(F2, e2.visitNode($.argumentExpression, Q, e2.isExpression));
                      break;
                    case 208:
                      X === 0 && ve ? (e2.isGeneratedIdentifier(ve) || (ve = w.cloneNode(ve), e2.addEmitFlags(ve, 1536)), F2 = w.createFunctionCallCall(F2, ve.kind === 106 ? w.createThis() : ve, e2.visitNodes($.arguments, Q, e2.isExpression))) : F2 = w.createCallExpression(F2, void 0, e2.visitNodes($.arguments, Q, e2.isExpression));
                      break;
                  }
                  e2.setOriginalNode(F2, $);
                }
                var A2 = J ? w.createConditionalExpression(f4(he, ee, true), void 0, w.createTrue(), void 0, w.createDeleteExpression(F2)) : w.createConditionalExpression(f4(he, ee, true), void 0, w.createVoidZero(), void 0, F2);
                return e2.setTextRange(A2, b), x2 ? w.createSyntheticReferenceExpression(A2, x2) : A2;
              }
              function f4(b, se, J) {
                return w.createBinaryExpression(w.createBinaryExpression(b, w.createToken(J ? 36 : 37), w.createNull()), w.createToken(J ? 56 : 55), w.createBinaryExpression(se, w.createToken(J ? 36 : 37), w.createVoidZero()));
              }
              function T(b) {
                var se = e2.visitNode(b.left, Q, e2.isExpression), J = se;
                return e2.isSimpleCopiableExpression(se) || (J = w.createTempVariable(B), se = w.createAssignment(J, se)), e2.setTextRange(w.createConditionalExpression(f4(se, J), void 0, J, void 0, e2.visitNode(b.right, Q, e2.isExpression)), b);
              }
              function K(b) {
                return e2.isOptionalChain(e2.skipParentheses(b.expression)) ? e2.setOriginalNode(G(b.expression, false, true), b) : w.updateDeleteExpression(b, e2.visitNode(b.expression, Q, e2.isExpression));
              }
            }
            e2.transformES2020 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w = C.hoistVariableDeclaration, B = C.factory;
              return e2.chainBundle(C, E);
              function E(N) {
                return N.isDeclarationFile ? N : e2.visitEachChild(N, Q, C);
              }
              function Q(N) {
                if ((N.transformFlags & 16) === 0)
                  return N;
                switch (N.kind) {
                  case 221:
                    var p = N;
                    if (e2.isLogicalOrCoalescingAssignmentExpression(p))
                      return le(p);
                  default:
                    return e2.visitEachChild(N, Q, C);
                }
              }
              function le(N) {
                var p = N.operatorToken, m2 = e2.getNonAssignmentOperatorForCompoundAssignment(p.kind), G = e2.skipParentheses(e2.visitNode(N.left, Q, e2.isLeftHandSideExpression)), oe = G, f4 = e2.skipParentheses(e2.visitNode(N.right, Q, e2.isExpression));
                if (e2.isAccessExpression(G)) {
                  var T = e2.isSimpleCopiableExpression(G.expression), K = T ? G.expression : B.createTempVariable(w), b = T ? G.expression : B.createAssignment(K, G.expression);
                  if (e2.isPropertyAccessExpression(G))
                    oe = B.createPropertyAccessExpression(K, G.name), G = B.createPropertyAccessExpression(b, G.name);
                  else {
                    var se = e2.isSimpleCopiableExpression(G.argumentExpression), J = se ? G.argumentExpression : B.createTempVariable(w);
                    oe = B.createElementAccessExpression(K, J), G = B.createElementAccessExpression(b, se ? G.argumentExpression : B.createAssignment(J, G.argumentExpression));
                  }
                }
                return B.createBinaryExpression(G, m2, B.createParenthesizedExpression(B.createAssignment(oe, f4)));
              }
            }
            e2.transformES2021 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              return e2.chainBundle(C, w);
              function w(E) {
                return E.isDeclarationFile ? E : e2.visitEachChild(E, B, C);
              }
              function B(E) {
                if ((E.transformFlags & 4) === 0)
                  return E;
                switch (E.kind) {
                  default:
                    return e2.visitEachChild(E, B, C);
                }
              }
            }
            e2.transformESNext = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(w) {
              var B = w.factory, E = w.getEmitHelperFactory, Q = w.getCompilerOptions(), le, N;
              return e2.chainBundle(w, T);
              function p() {
                if (N.filenameDeclaration)
                  return N.filenameDeclaration.name;
                var g = B.createVariableDeclaration(B.createUniqueName("_jsxFileName", 48), void 0, void 0, B.createStringLiteral(le.fileName));
                return N.filenameDeclaration = g, N.filenameDeclaration.name;
              }
              function m2(g) {
                return Q.jsx === 5 ? "jsxDEV" : g ? "jsxs" : "jsx";
              }
              function G(g) {
                var ne = m2(g);
                return f4(ne);
              }
              function oe() {
                return f4("Fragment");
              }
              function f4(g) {
                var ne, ue, We = g === "createElement" ? N.importSpecifier : e2.getJSXRuntimeImport(N.importSpecifier, Q), Fe = (ue = (ne = N.utilizedImplicitRuntimeImports) === null || ne === void 0 ? void 0 : ne.get(We)) === null || ue === void 0 ? void 0 : ue.get(g);
                if (Fe)
                  return Fe.name;
                N.utilizedImplicitRuntimeImports || (N.utilizedImplicitRuntimeImports = new e2.Map());
                var Z2 = N.utilizedImplicitRuntimeImports.get(We);
                Z2 || (Z2 = new e2.Map(), N.utilizedImplicitRuntimeImports.set(We, Z2));
                var Be = B.createUniqueName("_".concat(g), 112), ge = B.createImportSpecifier(false, B.createIdentifier(g), Be);
                return Be.generatedImportReference = ge, Z2.set(g, ge), Be;
              }
              function T(g) {
                if (g.isDeclarationFile)
                  return g;
                le = g, N = {}, N.importSpecifier = e2.getJSXImplicitImportBase(Q, g);
                var ne = e2.visitEachChild(g, K, w);
                e2.addEmitHelpers(ne, w.readEmitHelpers());
                var ue = ne.statements;
                if (N.filenameDeclaration && (ue = e2.insertStatementAfterCustomPrologue(ue.slice(), B.createVariableStatement(void 0, B.createVariableDeclarationList([N.filenameDeclaration], 2)))), N.utilizedImplicitRuntimeImports)
                  for (var We = 0, Fe = e2.arrayFrom(N.utilizedImplicitRuntimeImports.entries()); We < Fe.length; We++) {
                    var Z2 = Fe[We], Be = Z2[0], ge = Z2[1];
                    if (e2.isExternalModule(g)) {
                      var Re = B.createImportDeclaration(void 0, void 0, B.createImportClause(false, void 0, B.createNamedImports(e2.arrayFrom(ge.values()))), B.createStringLiteral(Be), void 0);
                      e2.setParentRecursive(Re, false), ue = e2.insertStatementAfterCustomPrologue(ue.slice(), Re);
                    } else if (e2.isExternalOrCommonJsModule(g)) {
                      var ze = B.createVariableStatement(void 0, B.createVariableDeclarationList([B.createVariableDeclaration(B.createObjectBindingPattern(e2.map(e2.arrayFrom(ge.values()), function(Ee) {
                        return B.createBindingElement(void 0, Ee.propertyName, Ee.name);
                      })), void 0, void 0, B.createCallExpression(B.createIdentifier("require"), void 0, [B.createStringLiteral(Be)]))], 2));
                      e2.setParentRecursive(ze, false), ue = e2.insertStatementAfterCustomPrologue(ue.slice(), ze);
                    }
                  }
                return ue !== ne.statements && (ne = B.updateSourceFile(ne, ue)), N = void 0, ne;
              }
              function K(g) {
                return g.transformFlags & 2 ? b(g) : g;
              }
              function b(g) {
                switch (g.kind) {
                  case 278:
                    return R(g, false);
                  case 279:
                    return q(g, false);
                  case 282:
                    return O(g, false);
                  case 288:
                    return fe(g);
                  default:
                    return e2.visitEachChild(g, K, w);
                }
              }
              function se(g) {
                switch (g.kind) {
                  case 11:
                    return U(g);
                  case 288:
                    return fe(g);
                  case 278:
                    return R(g, true);
                  case 279:
                    return q(g, true);
                  case 282:
                    return O(g, true);
                  default:
                    return e2.Debug.failBadSyntaxKind(g);
                }
              }
              function J(g) {
                for (var ne = false, ue = 0, We = g.attributes.properties; ue < We.length; ue++) {
                  var Fe = We[ue];
                  if (e2.isJsxSpreadAttribute(Fe))
                    ne = true;
                  else if (ne && e2.isJsxAttribute(Fe) && Fe.name.escapedText === "key")
                    return true;
                }
                return false;
              }
              function ie(g) {
                return N.importSpecifier === void 0 || J(g);
              }
              function R(g, ne) {
                var ue = ie(g.openingElement) ? x2 : he;
                return ue(g.openingElement, g.children, ne, g);
              }
              function q(g, ne) {
                var ue = ie(g) ? x2 : he;
                return ue(g, void 0, ne, g);
              }
              function O(g, ne) {
                var ue = N.importSpecifier === void 0 ? $ : X;
                return ue(g.openingFragment, g.children, ne, g);
              }
              function ve(g) {
                var ne = ee(g);
                return ne && B.createObjectLiteralExpression([ne]);
              }
              function ee(g) {
                var ne = e2.getSemanticJsxChildren(g);
                if (e2.length(ne) === 1 && !ne[0].dotDotDotToken) {
                  var ue = se(ne[0]);
                  return ue && B.createPropertyAssignment("children", ue);
                }
                var We = e2.mapDefined(g, se);
                return e2.length(We) ? B.createPropertyAssignment("children", B.createArrayLiteralExpression(We)) : void 0;
              }
              function he(g, ne, ue, We) {
                var Fe = d(g), Z2 = ne && ne.length ? ee(ne) : void 0, Be = e2.find(g.attributes.properties, function(ze) {
                  return !!ze.name && e2.isIdentifier(ze.name) && ze.name.escapedText === "key";
                }), ge = Be ? e2.filter(g.attributes.properties, function(ze) {
                  return ze !== Be;
                }) : g.attributes.properties, Re = e2.length(ge) ? y(ge, Z2) : B.createObjectLiteralExpression(Z2 ? [Z2] : e2.emptyArray);
                return F2(Fe, Re, Be, ne || e2.emptyArray, ue, We);
              }
              function F2(g, ne, ue, We, Fe, Z2) {
                var Be, ge = e2.getSemanticJsxChildren(We), Re = e2.length(ge) > 1 || !!(!((Be = ge[0]) === null || Be === void 0) && Be.dotDotDotToken), ze = [g, ne];
                if (ue && ze.push(Y(ue.initializer)), Q.jsx === 5) {
                  var Ee = e2.getOriginalNode(le);
                  if (Ee && e2.isSourceFile(Ee)) {
                    ue === void 0 && ze.push(B.createVoidZero()), ze.push(Re ? B.createTrue() : B.createFalse());
                    var He = e2.getLineAndCharacterOfPosition(Ee, Z2.pos);
                    ze.push(B.createObjectLiteralExpression([B.createPropertyAssignment("fileName", p()), B.createPropertyAssignment("lineNumber", B.createNumericLiteral(He.line + 1)), B.createPropertyAssignment("columnNumber", B.createNumericLiteral(He.character + 1))])), ze.push(B.createThis());
                  }
                }
                var rr = e2.setTextRange(B.createCallExpression(G(Re), void 0, ze), Z2);
                return Fe && e2.startOnNewLine(rr), rr;
              }
              function x2(g, ne, ue, We) {
                var Fe = d(g), Z2 = g.attributes.properties, Be = e2.length(Z2) ? y(Z2) : B.createNull(), ge = N.importSpecifier === void 0 ? e2.createJsxFactoryExpression(B, w.getEmitResolver().getJsxFactoryEntity(le), Q.reactNamespace, g) : f4("createElement"), Re = e2.createExpressionForJsxElement(B, ge, Fe, Be, e2.mapDefined(ne, se), We);
                return ue && e2.startOnNewLine(Re), Re;
              }
              function X(g, ne, ue, We) {
                var Fe;
                if (ne && ne.length) {
                  var Z2 = ve(ne);
                  Z2 && (Fe = Z2);
                }
                return F2(oe(), Fe || B.createObjectLiteralExpression([]), void 0, ne, ue, We);
              }
              function $(g, ne, ue, We) {
                var Fe = e2.createExpressionForJsxFragment(B, w.getEmitResolver().getJsxFactoryEntity(le), w.getEmitResolver().getJsxFragmentFactoryEntity(le), Q.reactNamespace, e2.mapDefined(ne, se), g, We);
                return ue && e2.startOnNewLine(Fe), Fe;
              }
              function A2(g) {
                return B.createSpreadAssignment(e2.visitNode(g.expression, K, e2.isExpression));
              }
              function y(g, ne) {
                var ue = e2.getEmitScriptTarget(Q);
                return ue && ue >= 5 ? B.createObjectLiteralExpression(V(g, ne)) : L(g, ne);
              }
              function V(g, ne) {
                var ue = e2.flatten(e2.spanMap(g, e2.isJsxSpreadAttribute, function(We, Fe) {
                  return e2.map(We, function(Z2) {
                    return Fe ? A2(Z2) : k(Z2);
                  });
                }));
                return ne && ue.push(ne), ue;
              }
              function L(g, ne) {
                var ue = e2.flatten(e2.spanMap(g, e2.isJsxSpreadAttribute, function(We, Fe) {
                  return Fe ? e2.map(We, P) : B.createObjectLiteralExpression(e2.map(We, k));
                }));
                return e2.isJsxSpreadAttribute(g[0]) && ue.unshift(B.createObjectLiteralExpression()), ne && ue.push(B.createObjectLiteralExpression([ne])), e2.singleOrUndefined(ue) || E().createAssignHelper(ue);
              }
              function P(g) {
                return e2.visitNode(g.expression, K, e2.isExpression);
              }
              function k(g) {
                var ne = D(g), ue = Y(g.initializer);
                return B.createPropertyAssignment(ne, ue);
              }
              function Y(g) {
                if (g === void 0)
                  return B.createTrue();
                if (g.kind === 10) {
                  var ne = g.singleQuote !== void 0 ? g.singleQuote : !e2.isStringDoubleQuoted(g, le), ue = B.createStringLiteral(l(g.text) || g.text, ne);
                  return e2.setTextRange(ue, g);
                } else
                  return g.kind === 288 ? g.expression === void 0 ? B.createTrue() : e2.visitNode(g.expression, K, e2.isExpression) : e2.Debug.failBadSyntaxKind(g);
              }
              function U(g) {
                var ne = j(g.text);
                return ne === void 0 ? void 0 : B.createStringLiteral(ne);
              }
              function j(g) {
                for (var ne, ue = 0, We = -1, Fe = 0; Fe < g.length; Fe++) {
                  var Z2 = g.charCodeAt(Fe);
                  e2.isLineBreak(Z2) ? (ue !== -1 && We !== -1 && (ne = H(ne, g.substr(ue, We - ue + 1))), ue = -1) : e2.isWhiteSpaceSingleLine(Z2) || (We = Fe, ue === -1 && (ue = Fe));
                }
                return ue !== -1 ? H(ne, g.substr(ue)) : ne;
              }
              function H(g, ne) {
                var ue = I(ne);
                return g === void 0 ? ue : g + " " + ue;
              }
              function I(g) {
                return g.replace(/&((#((\d+)|x([\da-fA-F]+)))|(\w+));/g, function(ne, ue, We, Fe, Z2, Be, ge) {
                  if (Z2)
                    return e2.utf16EncodeAsString(parseInt(Z2, 10));
                  if (Be)
                    return e2.utf16EncodeAsString(parseInt(Be, 16));
                  var Re = C.get(ge);
                  return Re ? e2.utf16EncodeAsString(Re) : ne;
                });
              }
              function l(g) {
                var ne = I(g);
                return ne === g ? void 0 : ne;
              }
              function d(g) {
                if (g.kind === 278)
                  return d(g.openingElement);
                var ne = g.tagName;
                return e2.isIdentifier(ne) && e2.isIntrinsicJsxName(ne.escapedText) ? B.createStringLiteral(e2.idText(ne)) : e2.createExpressionFromEntityName(B, ne);
              }
              function D(g) {
                var ne = g.name, ue = e2.idText(ne);
                return /^[A-Za-z_]\w*$/.test(ue) ? ne : B.createStringLiteral(ue);
              }
              function fe(g) {
                var ne = e2.visitNode(g.expression, K, e2.isExpression);
                return g.dotDotDotToken ? B.createSpreadElement(ne) : ne;
              }
            }
            e2.transformJsx = a;
            var C = new e2.Map(e2.getEntries({ quot: 34, amp: 38, apos: 39, lt: 60, gt: 62, nbsp: 160, iexcl: 161, cent: 162, pound: 163, curren: 164, yen: 165, brvbar: 166, sect: 167, uml: 168, copy: 169, ordf: 170, laquo: 171, not: 172, shy: 173, reg: 174, macr: 175, deg: 176, plusmn: 177, sup2: 178, sup3: 179, acute: 180, micro: 181, para: 182, middot: 183, cedil: 184, sup1: 185, ordm: 186, raquo: 187, frac14: 188, frac12: 189, frac34: 190, iquest: 191, Agrave: 192, Aacute: 193, Acirc: 194, Atilde: 195, Auml: 196, Aring: 197, AElig: 198, Ccedil: 199, Egrave: 200, Eacute: 201, Ecirc: 202, Euml: 203, Igrave: 204, Iacute: 205, Icirc: 206, Iuml: 207, ETH: 208, Ntilde: 209, Ograve: 210, Oacute: 211, Ocirc: 212, Otilde: 213, Ouml: 214, times: 215, Oslash: 216, Ugrave: 217, Uacute: 218, Ucirc: 219, Uuml: 220, Yacute: 221, THORN: 222, szlig: 223, agrave: 224, aacute: 225, acirc: 226, atilde: 227, auml: 228, aring: 229, aelig: 230, ccedil: 231, egrave: 232, eacute: 233, ecirc: 234, euml: 235, igrave: 236, iacute: 237, icirc: 238, iuml: 239, eth: 240, ntilde: 241, ograve: 242, oacute: 243, ocirc: 244, otilde: 245, ouml: 246, divide: 247, oslash: 248, ugrave: 249, uacute: 250, ucirc: 251, uuml: 252, yacute: 253, thorn: 254, yuml: 255, OElig: 338, oelig: 339, Scaron: 352, scaron: 353, Yuml: 376, fnof: 402, circ: 710, tilde: 732, Alpha: 913, Beta: 914, Gamma: 915, Delta: 916, Epsilon: 917, Zeta: 918, Eta: 919, Theta: 920, Iota: 921, Kappa: 922, Lambda: 923, Mu: 924, Nu: 925, Xi: 926, Omicron: 927, Pi: 928, Rho: 929, Sigma: 931, Tau: 932, Upsilon: 933, Phi: 934, Chi: 935, Psi: 936, Omega: 937, alpha: 945, beta: 946, gamma: 947, delta: 948, epsilon: 949, zeta: 950, eta: 951, theta: 952, iota: 953, kappa: 954, lambda: 955, mu: 956, nu: 957, xi: 958, omicron: 959, pi: 960, rho: 961, sigmaf: 962, sigma: 963, tau: 964, upsilon: 965, phi: 966, chi: 967, psi: 968, omega: 969, thetasym: 977, upsih: 978, piv: 982, ensp: 8194, emsp: 8195, thinsp: 8201, zwnj: 8204, zwj: 8205, lrm: 8206, rlm: 8207, ndash: 8211, mdash: 8212, lsquo: 8216, rsquo: 8217, sbquo: 8218, ldquo: 8220, rdquo: 8221, bdquo: 8222, dagger: 8224, Dagger: 8225, bull: 8226, hellip: 8230, permil: 8240, prime: 8242, Prime: 8243, lsaquo: 8249, rsaquo: 8250, oline: 8254, frasl: 8260, euro: 8364, image: 8465, weierp: 8472, real: 8476, trade: 8482, alefsym: 8501, larr: 8592, uarr: 8593, rarr: 8594, darr: 8595, harr: 8596, crarr: 8629, lArr: 8656, uArr: 8657, rArr: 8658, dArr: 8659, hArr: 8660, forall: 8704, part: 8706, exist: 8707, empty: 8709, nabla: 8711, isin: 8712, notin: 8713, ni: 8715, prod: 8719, sum: 8721, minus: 8722, lowast: 8727, radic: 8730, prop: 8733, infin: 8734, ang: 8736, and: 8743, or: 8744, cap: 8745, cup: 8746, int: 8747, there4: 8756, sim: 8764, cong: 8773, asymp: 8776, ne: 8800, equiv: 8801, le: 8804, ge: 8805, sub: 8834, sup: 8835, nsub: 8836, sube: 8838, supe: 8839, oplus: 8853, otimes: 8855, perp: 8869, sdot: 8901, lceil: 8968, rceil: 8969, lfloor: 8970, rfloor: 8971, lang: 9001, rang: 9002, loz: 9674, spades: 9824, clubs: 9827, hearts: 9829, diams: 9830 }));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w = C.factory, B = C.hoistVariableDeclaration;
              return e2.chainBundle(C, E);
              function E(m2) {
                return m2.isDeclarationFile ? m2 : e2.visitEachChild(m2, Q, C);
              }
              function Q(m2) {
                if ((m2.transformFlags & 512) === 0)
                  return m2;
                switch (m2.kind) {
                  case 221:
                    return le(m2);
                  default:
                    return e2.visitEachChild(m2, Q, C);
                }
              }
              function le(m2) {
                switch (m2.operatorToken.kind) {
                  case 67:
                    return N(m2);
                  case 42:
                    return p(m2);
                  default:
                    return e2.visitEachChild(m2, Q, C);
                }
              }
              function N(m2) {
                var G, oe, f4 = e2.visitNode(m2.left, Q, e2.isExpression), T = e2.visitNode(m2.right, Q, e2.isExpression);
                if (e2.isElementAccessExpression(f4)) {
                  var K = w.createTempVariable(B), b = w.createTempVariable(B);
                  G = e2.setTextRange(w.createElementAccessExpression(e2.setTextRange(w.createAssignment(K, f4.expression), f4.expression), e2.setTextRange(w.createAssignment(b, f4.argumentExpression), f4.argumentExpression)), f4), oe = e2.setTextRange(w.createElementAccessExpression(K, b), f4);
                } else if (e2.isPropertyAccessExpression(f4)) {
                  var K = w.createTempVariable(B);
                  G = e2.setTextRange(w.createPropertyAccessExpression(e2.setTextRange(w.createAssignment(K, f4.expression), f4.expression), f4.name), f4), oe = e2.setTextRange(w.createPropertyAccessExpression(K, f4.name), f4);
                } else
                  G = f4, oe = f4;
                return e2.setTextRange(w.createAssignment(G, e2.setTextRange(w.createGlobalMethodCall("Math", "pow", [oe, T]), m2)), m2);
              }
              function p(m2) {
                var G = e2.visitNode(m2.left, Q, e2.isExpression), oe = e2.visitNode(m2.right, Q, e2.isExpression);
                return e2.setTextRange(w.createGlobalMethodCall("Math", "pow", [G, oe]), m2);
              }
            }
            e2.transformES2016 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(p) {
              p[p.CapturedThis = 1] = "CapturedThis", p[p.BlockScopedBindings = 2] = "BlockScopedBindings";
            })(a || (a = {}));
            var C;
            (function(p) {
              p[p.Body = 1] = "Body", p[p.Initializer = 2] = "Initializer";
            })(C || (C = {}));
            var w;
            (function(p) {
              p[p.ToOriginal = 0] = "ToOriginal", p[p.ToOutParameter = 1] = "ToOutParameter";
            })(w || (w = {}));
            var B;
            (function(p) {
              p[p.Break = 2] = "Break", p[p.Continue = 4] = "Continue", p[p.Return = 8] = "Return";
            })(B || (B = {}));
            var E;
            (function(p) {
              p[p.None = 0] = "None", p[p.Function = 1] = "Function", p[p.ArrowFunction = 2] = "ArrowFunction", p[p.AsyncFunctionBody = 4] = "AsyncFunctionBody", p[p.NonStaticClassElement = 8] = "NonStaticClassElement", p[p.CapturesThis = 16] = "CapturesThis", p[p.ExportedVariableStatement = 32] = "ExportedVariableStatement", p[p.TopLevel = 64] = "TopLevel", p[p.Block = 128] = "Block", p[p.IterationStatement = 256] = "IterationStatement", p[p.IterationStatementBlock = 512] = "IterationStatementBlock", p[p.IterationContainer = 1024] = "IterationContainer", p[p.ForStatement = 2048] = "ForStatement", p[p.ForInOrForOfStatement = 4096] = "ForInOrForOfStatement", p[p.ConstructorWithCapturedSuper = 8192] = "ConstructorWithCapturedSuper", p[p.StaticInitializer = 16384] = "StaticInitializer", p[p.AncestorFactsMask = 32767] = "AncestorFactsMask", p[p.BlockScopeIncludes = 0] = "BlockScopeIncludes", p[p.BlockScopeExcludes = 7104] = "BlockScopeExcludes", p[p.SourceFileIncludes = 64] = "SourceFileIncludes", p[p.SourceFileExcludes = 8064] = "SourceFileExcludes", p[p.FunctionIncludes = 65] = "FunctionIncludes", p[p.FunctionExcludes = 32670] = "FunctionExcludes", p[p.AsyncFunctionBodyIncludes = 69] = "AsyncFunctionBodyIncludes", p[p.AsyncFunctionBodyExcludes = 32662] = "AsyncFunctionBodyExcludes", p[p.ArrowFunctionIncludes = 66] = "ArrowFunctionIncludes", p[p.ArrowFunctionExcludes = 15232] = "ArrowFunctionExcludes", p[p.ConstructorIncludes = 73] = "ConstructorIncludes", p[p.ConstructorExcludes = 32662] = "ConstructorExcludes", p[p.DoOrWhileStatementIncludes = 1280] = "DoOrWhileStatementIncludes", p[p.DoOrWhileStatementExcludes = 0] = "DoOrWhileStatementExcludes", p[p.ForStatementIncludes = 3328] = "ForStatementIncludes", p[p.ForStatementExcludes = 5056] = "ForStatementExcludes", p[p.ForInOrForOfStatementIncludes = 5376] = "ForInOrForOfStatementIncludes", p[p.ForInOrForOfStatementExcludes = 3008] = "ForInOrForOfStatementExcludes", p[p.BlockIncludes = 128] = "BlockIncludes", p[p.BlockExcludes = 6976] = "BlockExcludes", p[p.IterationStatementBlockIncludes = 512] = "IterationStatementBlockIncludes", p[p.IterationStatementBlockExcludes = 7104] = "IterationStatementBlockExcludes", p[p.StaticInitializerIncludes = 16449] = "StaticInitializerIncludes", p[p.StaticInitializerExcludes = 32670] = "StaticInitializerExcludes", p[p.NewTarget = 32768] = "NewTarget", p[p.CapturedLexicalThis = 65536] = "CapturedLexicalThis", p[p.SubtreeFactsMask = -32768] = "SubtreeFactsMask", p[p.ArrowFunctionSubtreeExcludes = 0] = "ArrowFunctionSubtreeExcludes", p[p.FunctionSubtreeExcludes = 98304] = "FunctionSubtreeExcludes";
            })(E || (E = {}));
            var Q;
            (function(p) {
              p[p.None = 0] = "None", p[p.UnpackedSpread = 1] = "UnpackedSpread", p[p.PackedSpread = 2] = "PackedSpread";
            })(Q || (Q = {}));
            function le(p, m2) {
              return { kind: p, expression: m2 };
            }
            function N(p) {
              var m2 = p.factory, G = p.getEmitHelperFactory, oe = p.startLexicalEnvironment, f4 = p.resumeLexicalEnvironment, T = p.endLexicalEnvironment, K = p.hoistVariableDeclaration, b = p.getCompilerOptions(), se = p.getEmitResolver(), J = p.onSubstituteNode, ie = p.onEmitNode;
              p.onEmitNode = to, p.onSubstituteNode = Oo;
              var R, q, O, ve;
              function ee(Qe) {
                ve = e2.append(ve, m2.createVariableDeclaration(Qe));
              }
              var he, F2;
              return e2.chainBundle(p, x2);
              function x2(Qe) {
                if (Qe.isDeclarationFile)
                  return Qe;
                R = Qe, q = Qe.text;
                var Gr = j(Qe);
                return e2.addEmitHelpers(Gr, p.readEmitHelpers()), R = void 0, q = void 0, ve = void 0, O = 0, Gr;
              }
              function X(Qe, Gr) {
                var S2 = O;
                return O = (O & ~Qe | Gr) & 32767, S2;
              }
              function $(Qe, Gr, S2) {
                O = (O & ~Gr | S2) & -32768 | Qe;
              }
              function A2(Qe) {
                return (O & 8192) !== 0 && Qe.kind === 247 && !Qe.expression;
              }
              function y(Qe) {
                return Qe.transformFlags & 2097152 && (e2.isReturnStatement(Qe) || e2.isIfStatement(Qe) || e2.isWithStatement(Qe) || e2.isSwitchStatement(Qe) || e2.isCaseBlock(Qe) || e2.isCaseClause(Qe) || e2.isDefaultClause(Qe) || e2.isTryStatement(Qe) || e2.isCatchClause(Qe) || e2.isLabeledStatement(Qe) || e2.isIterationStatement(Qe, false) || e2.isBlock(Qe));
              }
              function V(Qe) {
                return (Qe.transformFlags & 1024) !== 0 || he !== void 0 || O & 8192 && y(Qe) || e2.isIterationStatement(Qe, false) && Ue(Qe) || (e2.getEmitFlags(Qe) & 33554432) !== 0;
              }
              function L(Qe) {
                return V(Qe) ? U(Qe, false) : Qe;
              }
              function P(Qe) {
                return V(Qe) ? U(Qe, true) : Qe;
              }
              function k(Qe) {
                if (V(Qe)) {
                  var Gr = e2.getOriginalNode(Qe);
                  if (e2.isPropertyDeclaration(Gr) && e2.hasStaticModifier(Gr)) {
                    var S2 = X(32670, 16449), Ce = U(Qe, false);
                    return $(S2, 98304, 0), Ce;
                  }
                  return U(Qe, false);
                }
                return Qe;
              }
              function Y(Qe) {
                return Qe.kind === 106 ? En(true) : L(Qe);
              }
              function U(Qe, Gr) {
                switch (Qe.kind) {
                  case 124:
                    return;
                  case 257:
                    return ue(Qe);
                  case 226:
                    return We(Qe);
                  case 164:
                    return we(Qe);
                  case 256:
                    return wr(Qe);
                  case 214:
                    return yr(Qe);
                  case 213:
                    return Ir(Qe);
                  case 254:
                    return Zt(Qe);
                  case 79:
                    return g(Qe);
                  case 255:
                    return Xi(Qe);
                  case 249:
                    return H(Qe);
                  case 263:
                    return I(Qe);
                  case 235:
                    return mi(Qe, false);
                  case 246:
                  case 245:
                    return ne(Qe);
                  case 250:
                    return ae(Qe);
                  case 240:
                  case 241:
                    return ti(Qe, void 0);
                  case 242:
                    return Ze(Qe, void 0);
                  case 243:
                    return zr(Qe, void 0);
                  case 244:
                    return Wr(Qe, void 0);
                  case 238:
                    return pe(Qe);
                  case 205:
                    return Ar(Qe);
                  case 292:
                    return Oi(Qe);
                  case 297:
                    return At(Qe);
                  case 162:
                    return ba(Qe);
                  case 204:
                    return Qa(Qe);
                  case 208:
                    return ai(Qe);
                  case 209:
                    return pn(Qe);
                  case 212:
                    return or(Qe, Gr);
                  case 221:
                    return qr(Qe, Gr);
                  case 351:
                    return si(Qe, Gr);
                  case 14:
                  case 15:
                  case 16:
                  case 17:
                    return eo(Qe);
                  case 10:
                    return Rn(Qe);
                  case 8:
                    return Da(Qe);
                  case 210:
                    return bo(Qe);
                  case 223:
                    return Ro(Qe);
                  case 224:
                    return $a(Qe);
                  case 225:
                    return Pn(Qe);
                  case 106:
                    return En(false);
                  case 108:
                    return D(Qe);
                  case 231:
                    return Wn(Qe);
                  case 169:
                    return Vi(Qe);
                  case 172:
                  case 173:
                    return at(Qe);
                  case 237:
                    return wi(Qe);
                  case 247:
                    return d(Qe);
                  case 217:
                    return fe(Qe);
                  default:
                    return e2.visitEachChild(Qe, L, p);
                }
              }
              function j(Qe) {
                var Gr = X(8064, 64), S2 = [], Ce = [];
                oe();
                var qe = m2.copyPrologue(Qe.statements, S2, false, L);
                return e2.addRange(Ce, e2.visitNodes(Qe.statements, L, e2.isStatement, qe)), ve && Ce.push(m2.createVariableStatement(void 0, m2.createVariableDeclarationList(ve))), m2.mergeLexicalEnvironment(S2, T()), Ye(S2, Qe), $(Gr, 0, 0), m2.updateSourceFile(Qe, e2.setTextRange(m2.createNodeArray(e2.concatenate(S2, Ce)), Qe.statements));
              }
              function H(Qe) {
                if (he !== void 0) {
                  var Gr = he.allowedNonLabeledJumps;
                  he.allowedNonLabeledJumps |= 2;
                  var S2 = e2.visitEachChild(Qe, L, p);
                  return he.allowedNonLabeledJumps = Gr, S2;
                }
                return e2.visitEachChild(Qe, L, p);
              }
              function I(Qe) {
                var Gr = X(7104, 0), S2 = e2.visitEachChild(Qe, L, p);
                return $(Gr, 0, 0), S2;
              }
              function l(Qe) {
                return e2.setOriginalNode(m2.createReturnStatement(m2.createUniqueName("_this", 48)), Qe);
              }
              function d(Qe) {
                return he ? (he.nonLocalJumps |= 8, A2(Qe) && (Qe = l(Qe)), m2.createReturnStatement(m2.createObjectLiteralExpression([m2.createPropertyAssignment(m2.createIdentifier("value"), Qe.expression ? e2.visitNode(Qe.expression, L, e2.isExpression) : m2.createVoidZero())]))) : A2(Qe) ? l(Qe) : e2.visitEachChild(Qe, L, p);
              }
              function D(Qe) {
                return O & 2 && !(O & 16384) && (O |= 65536), he ? O & 2 ? (he.containsLexicalThis = true, Qe) : he.thisName || (he.thisName = m2.createUniqueName("this")) : Qe;
              }
              function fe(Qe) {
                return e2.visitEachChild(Qe, P, p);
              }
              function g(Qe) {
                return he && se.isArgumentsLocalBinding(Qe) ? he.argumentsName || (he.argumentsName = m2.createUniqueName("arguments")) : Qe;
              }
              function ne(Qe) {
                if (he) {
                  var Gr = Qe.kind === 246 ? 2 : 4, S2 = Qe.label && he.labels && he.labels.get(e2.idText(Qe.label)) || !Qe.label && he.allowedNonLabeledJumps & Gr;
                  if (!S2) {
                    var Ce = void 0, qe = Qe.label;
                    qe ? Qe.kind === 246 ? (Ce = "break-".concat(qe.escapedText), Ki(he, true, e2.idText(qe), Ce)) : (Ce = "continue-".concat(qe.escapedText), Ki(he, false, e2.idText(qe), Ce)) : Qe.kind === 246 ? (he.nonLocalJumps |= 2, Ce = "break") : (he.nonLocalJumps |= 4, Ce = "continue");
                    var br = m2.createStringLiteral(Ce);
                    if (he.loopOutParameters.length) {
                      for (var Zr = he.loopOutParameters, Si = void 0, Pi = 0; Pi < Zr.length; Pi++) {
                        var Qi = ut(Zr[Pi], 1);
                        Pi === 0 ? Si = Qi : Si = m2.createBinaryExpression(Si, 27, Qi);
                      }
                      br = m2.createBinaryExpression(Si, 27, br);
                    }
                    return m2.createReturnStatement(br);
                  }
                }
                return e2.visitEachChild(Qe, L, p);
              }
              function ue(Qe) {
                var Gr = m2.createVariableDeclaration(m2.getLocalName(Qe, true), void 0, void 0, Fe(Qe));
                e2.setOriginalNode(Gr, Qe);
                var S2 = [], Ce = m2.createVariableStatement(void 0, m2.createVariableDeclarationList([Gr]));
                if (e2.setOriginalNode(Ce, Qe), e2.setTextRange(Ce, Qe), e2.startOnNewLine(Ce), S2.push(Ce), e2.hasSyntacticModifier(Qe, 1)) {
                  var qe = e2.hasSyntacticModifier(Qe, 512) ? m2.createExportDefault(m2.getLocalName(Qe)) : m2.createExternalModuleExport(m2.getLocalName(Qe));
                  e2.setOriginalNode(qe, Ce), S2.push(qe);
                }
                var br = e2.getEmitFlags(Qe);
                return (br & 4194304) === 0 && (S2.push(m2.createEndOfDeclarationMarker(Qe)), e2.setEmitFlags(Ce, br | 4194304)), e2.singleOrMany(S2);
              }
              function We(Qe) {
                return Fe(Qe);
              }
              function Fe(Qe) {
                Qe.name && Co();
                var Gr = e2.getClassExtendsHeritageElement(Qe), S2 = m2.createFunctionExpression(void 0, void 0, void 0, void 0, Gr ? [m2.createParameterDeclaration(void 0, void 0, void 0, m2.createUniqueName("_super", 48))] : [], void 0, Z2(Qe, Gr));
                e2.setEmitFlags(S2, e2.getEmitFlags(Qe) & 65536 | 524288);
                var Ce = m2.createPartiallyEmittedExpression(S2);
                e2.setTextRangeEnd(Ce, Qe.end), e2.setEmitFlags(Ce, 1536);
                var qe = m2.createPartiallyEmittedExpression(Ce);
                e2.setTextRangeEnd(qe, e2.skipTrivia(q, Qe.pos)), e2.setEmitFlags(qe, 1536);
                var br = m2.createParenthesizedExpression(m2.createCallExpression(qe, void 0, Gr ? [e2.visitNode(Gr.expression, L, e2.isExpression)] : []));
                return e2.addSyntheticLeadingComment(br, 3, "* @class "), br;
              }
              function Z2(Qe, Gr) {
                var S2 = [], Ce = m2.getInternalName(Qe), qe = e2.isIdentifierANonContextualKeyword(Ce) ? m2.getGeneratedNameForNode(Ce) : Ce;
                oe(), Be(S2, Qe, Gr), ge(S2, Qe, qe, Gr), n(S2, Qe);
                var br = e2.createTokenRange(e2.skipTrivia(q, Qe.members.end), 19), Zr = m2.createPartiallyEmittedExpression(qe);
                e2.setTextRangeEnd(Zr, br.end), e2.setEmitFlags(Zr, 1536);
                var Si = m2.createReturnStatement(Zr);
                e2.setTextRangePos(Si, br.pos), e2.setEmitFlags(Si, 1920), S2.push(Si), e2.insertStatementsAfterStandardPrologue(S2, T());
                var Pi = m2.createBlock(e2.setTextRange(m2.createNodeArray(S2), Qe.members), true);
                return e2.setEmitFlags(Pi, 1536), Pi;
              }
              function Be(Qe, Gr, S2) {
                S2 && Qe.push(e2.setTextRange(m2.createExpressionStatement(G().createExtendsHelper(m2.getInternalName(Gr))), S2));
              }
              function ge(Qe, Gr, S2, Ce) {
                var qe = he;
                he = void 0;
                var br = X(32662, 73), Zr = e2.getFirstConstructorWithBody(Gr), Si = Jn(Zr, Ce !== void 0), Pi = m2.createFunctionDeclaration(void 0, void 0, void 0, S2, void 0, Re(Zr, Si), void 0, Ee(Zr, Gr, Ce, Si));
                e2.setTextRange(Pi, Zr || Gr), Ce && e2.setEmitFlags(Pi, 8), Qe.push(Pi), $(br, 98304, 0), he = qe;
              }
              function Re(Qe, Gr) {
                return e2.visitParameterList(Qe && !Gr ? Qe.parameters : void 0, L, p) || [];
              }
              function ze(Qe, Gr) {
                var S2 = [];
                f4(), m2.mergeLexicalEnvironment(S2, T()), Gr && S2.push(m2.createReturnStatement(_e()));
                var Ce = m2.createNodeArray(S2);
                e2.setTextRange(Ce, Qe.members);
                var qe = m2.createBlock(Ce, true);
                return e2.setTextRange(qe, Qe), e2.setEmitFlags(qe, 1536), qe;
              }
              function Ee(Qe, Gr, S2, Ce) {
                var qe = !!S2 && e2.skipOuterExpressions(S2.expression).kind !== 104;
                if (!Qe)
                  return ze(Gr, qe);
                var br = [], Zr = [];
                f4();
                var Si = e2.takeWhile(Qe.body.statements, e2.isPrologueDirective), Pi = He(Qe.body.statements, Si), Qi = Pi.superCall, Ct = Pi.superStatementIndex, sa = Ct === -1 ? Si.length : Ct + 1, en = sa;
                Ce || (en = m2.copyStandardPrologue(Qe.body.statements, br, en, false)), Ce || (en = m2.copyCustomPrologue(Qe.body.statements, Zr, en, L, void 0));
                var Wa;
                if (Ce ? Wa = _e() : Qi && (Wa = ka(Qi)), Wa && (O |= 8192), ye(br, Qe), Cr(br, Qe, Ce), e2.addRange(Zr, e2.visitNodes(Qe.body.statements, L, e2.isStatement, en)), m2.mergeLexicalEnvironment(br, T()), Ne(br, Qe, false), qe || Wa)
                  if (Wa && sa === Qe.body.statements.length && !(Qe.body.transformFlags & 8192)) {
                    var qn = e2.cast(e2.cast(Wa, e2.isBinaryExpression).left, e2.isCallExpression), mo = m2.createReturnStatement(Wa);
                    e2.setCommentRange(mo, e2.getCommentRange(qn)), e2.setEmitFlags(qn, 1536), Zr.push(mo);
                  } else
                    Ct <= Si.length ? Er(Zr, Qe, Wa || Ie()) : (Er(br, Qe, Ie()), Wa && Br(Zr, Wa)), rr(Qe.body) || Zr.push(m2.createReturnStatement(m2.createUniqueName("_this", 48)));
                else
                  Ye(br, Qe);
                var So = m2.createBlock(e2.setTextRange(m2.createNodeArray(Ve(Ve(Ve(Ve([], Si, true), br, true), Ct <= Si.length ? e2.emptyArray : e2.visitNodes(Qe.body.statements, L, e2.isStatement, Si.length, Ct - Si.length), true), Zr, true)), Qe.body.statements), true);
                return e2.setTextRange(So, Qe.body), So;
              }
              function He(Qe, Gr) {
                for (var S2 = Gr.length; S2 < Qe.length; S2 += 1) {
                  var Ce = e2.getSuperCallFromStatement(Qe[S2]);
                  if (Ce)
                    return { superCall: Ce, superStatementIndex: S2 };
                }
                return { superStatementIndex: -1 };
              }
              function rr(Qe) {
                if (Qe.kind === 247)
                  return true;
                if (Qe.kind === 239) {
                  var Gr = Qe;
                  if (Gr.elseStatement)
                    return rr(Gr.thenStatement) && rr(Gr.elseStatement);
                } else if (Qe.kind === 235) {
                  var S2 = e2.lastOrUndefined(Qe.statements);
                  if (S2 && rr(S2))
                    return true;
                }
                return false;
              }
              function Ie() {
                return e2.setEmitFlags(m2.createThis(), 4);
              }
              function _e() {
                return m2.createLogicalOr(m2.createLogicalAnd(m2.createStrictInequality(m2.createUniqueName("_super", 48), m2.createNull()), m2.createFunctionApplyCall(m2.createUniqueName("_super", 48), Ie(), m2.createIdentifier("arguments"))), Ie());
              }
              function we(Qe) {
                if (!Qe.dotDotDotToken)
                  return e2.isBindingPattern(Qe.name) ? e2.setOriginalNode(e2.setTextRange(m2.createParameterDeclaration(void 0, void 0, void 0, m2.getGeneratedNameForNode(Qe), void 0, void 0, void 0), Qe), Qe) : Qe.initializer ? e2.setOriginalNode(e2.setTextRange(m2.createParameterDeclaration(void 0, void 0, void 0, Qe.name, void 0, void 0, void 0), Qe), Qe) : Qe;
              }
              function de(Qe) {
                return Qe.initializer !== void 0 || e2.isBindingPattern(Qe.name);
              }
              function ye(Qe, Gr) {
                if (!e2.some(Gr.parameters, de))
                  return false;
                for (var S2 = false, Ce = 0, qe = Gr.parameters; Ce < qe.length; Ce++) {
                  var br = qe[Ce], Zr = br.name, Si = br.initializer, Pi = br.dotDotDotToken;
                  Pi || (e2.isBindingPattern(Zr) ? S2 = Ae(Qe, br, Zr, Si) || S2 : Si && (er(Qe, br, Zr, Si), S2 = true));
                }
                return S2;
              }
              function Ae(Qe, Gr, S2, Ce) {
                return S2.elements.length > 0 ? (e2.insertStatementAfterCustomPrologue(Qe, e2.setEmitFlags(m2.createVariableStatement(void 0, m2.createVariableDeclarationList(e2.flattenDestructuringBinding(Gr, L, p, 0, m2.getGeneratedNameForNode(Gr)))), 1048576)), true) : Ce ? (e2.insertStatementAfterCustomPrologue(Qe, e2.setEmitFlags(m2.createExpressionStatement(m2.createAssignment(m2.getGeneratedNameForNode(Gr), e2.visitNode(Ce, L, e2.isExpression))), 1048576)), true) : false;
              }
              function er(Qe, Gr, S2, Ce) {
                Ce = e2.visitNode(Ce, L, e2.isExpression);
                var qe = m2.createIfStatement(m2.createTypeCheck(m2.cloneNode(S2), "undefined"), e2.setEmitFlags(e2.setTextRange(m2.createBlock([m2.createExpressionStatement(e2.setEmitFlags(e2.setTextRange(m2.createAssignment(e2.setEmitFlags(e2.setParent(e2.setTextRange(m2.cloneNode(S2), S2), S2.parent), 48), e2.setEmitFlags(Ce, 48 | e2.getEmitFlags(Ce) | 1536)), Gr), 1536))]), Gr), 1953));
                e2.startOnNewLine(qe), e2.setTextRange(qe, Gr), e2.setEmitFlags(qe, 1050528), e2.insertStatementAfterCustomPrologue(Qe, qe);
              }
              function ir(Qe, Gr) {
                return !!(Qe && Qe.dotDotDotToken && !Gr);
              }
              function Cr(Qe, Gr, S2) {
                var Ce = [], qe = e2.lastOrUndefined(Gr.parameters);
                if (!ir(qe, S2))
                  return false;
                var br = qe.name.kind === 79 ? e2.setParent(e2.setTextRange(m2.cloneNode(qe.name), qe.name), qe.name.parent) : m2.createTempVariable(void 0);
                e2.setEmitFlags(br, 48);
                var Zr = qe.name.kind === 79 ? m2.cloneNode(qe.name) : br, Si = Gr.parameters.length - 1, Pi = m2.createLoopVariable();
                Ce.push(e2.setEmitFlags(e2.setTextRange(m2.createVariableStatement(void 0, m2.createVariableDeclarationList([m2.createVariableDeclaration(br, void 0, void 0, m2.createArrayLiteralExpression([]))])), qe), 1048576));
                var Qi = m2.createForStatement(e2.setTextRange(m2.createVariableDeclarationList([m2.createVariableDeclaration(Pi, void 0, void 0, m2.createNumericLiteral(Si))]), qe), e2.setTextRange(m2.createLessThan(Pi, m2.createPropertyAccessExpression(m2.createIdentifier("arguments"), "length")), qe), e2.setTextRange(m2.createPostfixIncrement(Pi), qe), m2.createBlock([e2.startOnNewLine(e2.setTextRange(m2.createExpressionStatement(m2.createAssignment(m2.createElementAccessExpression(Zr, Si === 0 ? Pi : m2.createSubtract(Pi, m2.createNumericLiteral(Si))), m2.createElementAccessExpression(m2.createIdentifier("arguments"), Pi))), qe))]));
                return e2.setEmitFlags(Qi, 1048576), e2.startOnNewLine(Qi), Ce.push(Qi), qe.name.kind !== 79 && Ce.push(e2.setEmitFlags(e2.setTextRange(m2.createVariableStatement(void 0, m2.createVariableDeclarationList(e2.flattenDestructuringBinding(qe, L, p, 0, Zr))), qe), 1048576)), e2.insertStatementsAfterCustomPrologue(Qe, Ce), true;
              }
              function Ye(Qe, Gr) {
                return O & 65536 && Gr.kind !== 214 ? (Er(Qe, Gr, m2.createThis()), true) : false;
              }
              function Br(Qe, Gr) {
                Ko();
                var S2 = m2.createExpressionStatement(m2.createBinaryExpression(m2.createThis(), 63, Gr));
                e2.insertStatementAfterCustomPrologue(Qe, S2), e2.setCommentRange(S2, e2.getOriginalNode(Gr).parent);
              }
              function Er(Qe, Gr, S2) {
                Ko();
                var Ce = m2.createVariableStatement(void 0, m2.createVariableDeclarationList([m2.createVariableDeclaration(m2.createUniqueName("_this", 48), void 0, void 0, S2)]));
                e2.setEmitFlags(Ce, 1050112), e2.setSourceMapRange(Ce, Gr), e2.insertStatementAfterCustomPrologue(Qe, Ce);
              }
              function Ne(Qe, Gr, S2) {
                if (O & 32768) {
                  var Ce = void 0;
                  switch (Gr.kind) {
                    case 214:
                      return Qe;
                    case 169:
                    case 172:
                    case 173:
                      Ce = m2.createVoidZero();
                      break;
                    case 171:
                      Ce = m2.createPropertyAccessExpression(e2.setEmitFlags(m2.createThis(), 4), "constructor");
                      break;
                    case 256:
                    case 213:
                      Ce = m2.createConditionalExpression(m2.createLogicalAnd(e2.setEmitFlags(m2.createThis(), 4), m2.createBinaryExpression(e2.setEmitFlags(m2.createThis(), 4), 102, m2.getLocalName(Gr))), void 0, m2.createPropertyAccessExpression(e2.setEmitFlags(m2.createThis(), 4), "constructor"), void 0, m2.createVoidZero());
                      break;
                    default:
                      return e2.Debug.failBadSyntaxKind(Gr);
                  }
                  var qe = m2.createVariableStatement(void 0, m2.createVariableDeclarationList([m2.createVariableDeclaration(m2.createUniqueName("_newTarget", 48), void 0, void 0, Ce)]));
                  e2.setEmitFlags(qe, 1050112), S2 && (Qe = Qe.slice()), e2.insertStatementAfterCustomPrologue(Qe, qe);
                }
                return Qe;
              }
              function n(Qe, Gr) {
                for (var S2 = 0, Ce = Gr.members; S2 < Ce.length; S2++) {
                  var qe = Ce[S2];
                  switch (qe.kind) {
                    case 234:
                      Qe.push(lr(qe));
                      break;
                    case 169:
                      Qe.push(be(dn(Gr, qe), qe, Gr));
                      break;
                    case 172:
                    case 173:
                      var br = e2.getAllAccessorDeclarations(Gr.members, qe);
                      qe === br.firstAccessor && Qe.push(Ge(dn(Gr, qe), br, Gr));
                      break;
                    case 171:
                    case 170:
                      break;
                    default:
                      e2.Debug.failBadSyntaxKind(qe, R && R.fileName);
                      break;
                  }
                }
              }
              function lr(Qe) {
                return e2.setTextRange(m2.createEmptyStatement(), Qe);
              }
              function be(Qe, Gr, S2) {
                var Ce = e2.getCommentRange(Gr), qe = e2.getSourceMapRange(Gr), br = Ur(Gr, Gr, void 0, S2), Zr = e2.visitNode(Gr.name, L, e2.isPropertyName), Si;
                if (!e2.isPrivateIdentifier(Zr) && e2.getUseDefineForClassFields(p.getCompilerOptions())) {
                  var Pi = e2.isComputedPropertyName(Zr) ? Zr.expression : e2.isIdentifier(Zr) ? m2.createStringLiteral(e2.unescapeLeadingUnderscores(Zr.escapedText)) : Zr;
                  Si = m2.createObjectDefinePropertyCall(Qe, Pi, m2.createPropertyDescriptor({ value: br, enumerable: false, writable: true, configurable: true }));
                } else {
                  var Qi = e2.createMemberAccessForPropertyName(m2, Qe, Zr, Gr.name);
                  Si = m2.createAssignment(Qi, br);
                }
                e2.setEmitFlags(br, 1536), e2.setSourceMapRange(br, qe);
                var Ct = e2.setTextRange(m2.createExpressionStatement(Si), Gr);
                return e2.setOriginalNode(Ct, Gr), e2.setCommentRange(Ct, Ce), e2.setEmitFlags(Ct, 48), Ct;
              }
              function Ge(Qe, Gr, S2) {
                var Ce = m2.createExpressionStatement(ur(Qe, Gr, S2, false));
                return e2.setEmitFlags(Ce, 1536), e2.setSourceMapRange(Ce, e2.getSourceMapRange(Gr.firstAccessor)), Ce;
              }
              function ur(Qe, Gr, S2, Ce) {
                var qe = Gr.firstAccessor, br = Gr.getAccessor, Zr = Gr.setAccessor, Si = e2.setParent(e2.setTextRange(m2.cloneNode(Qe), Qe), Qe.parent);
                e2.setEmitFlags(Si, 1568), e2.setSourceMapRange(Si, qe.name);
                var Pi = e2.visitNode(qe.name, L, e2.isPropertyName);
                if (e2.isPrivateIdentifier(Pi))
                  return e2.Debug.failBadSyntaxKind(Pi, "Encountered unhandled private identifier while transforming ES2015.");
                var Qi = e2.createExpressionForPropertyName(m2, Pi);
                e2.setEmitFlags(Qi, 1552), e2.setSourceMapRange(Qi, qe.name);
                var Ct = [];
                if (br) {
                  var sa = Ur(br, void 0, void 0, S2);
                  e2.setSourceMapRange(sa, e2.getSourceMapRange(br)), e2.setEmitFlags(sa, 512);
                  var en = m2.createPropertyAssignment("get", sa);
                  e2.setCommentRange(en, e2.getCommentRange(br)), Ct.push(en);
                }
                if (Zr) {
                  var Wa = Ur(Zr, void 0, void 0, S2);
                  e2.setSourceMapRange(Wa, e2.getSourceMapRange(Zr)), e2.setEmitFlags(Wa, 512);
                  var qn = m2.createPropertyAssignment("set", Wa);
                  e2.setCommentRange(qn, e2.getCommentRange(Zr)), Ct.push(qn);
                }
                Ct.push(m2.createPropertyAssignment("enumerable", br || Zr ? m2.createFalse() : m2.createTrue()), m2.createPropertyAssignment("configurable", m2.createTrue()));
                var mo = m2.createCallExpression(m2.createPropertyAccessExpression(m2.createIdentifier("Object"), "defineProperty"), void 0, [Si, Qi, m2.createObjectLiteralExpression(Ct, true)]);
                return Ce && e2.startOnNewLine(mo), mo;
              }
              function yr(Qe) {
                Qe.transformFlags & 8192 && !(O & 16384) && (O |= 65536);
                var Gr = he;
                he = void 0;
                var S2 = X(15232, 66), Ce = m2.createFunctionExpression(void 0, void 0, void 0, void 0, e2.visitParameterList(Qe.parameters, L, p), void 0, ii(Qe));
                return e2.setTextRange(Ce, Qe), e2.setOriginalNode(Ce, Qe), e2.setEmitFlags(Ce, 8), $(S2, 0, 0), he = Gr, Ce;
              }
              function Ir(Qe) {
                var Gr = e2.getEmitFlags(Qe) & 262144 ? X(32662, 69) : X(32670, 65), S2 = he;
                he = void 0;
                var Ce = e2.visitParameterList(Qe.parameters, L, p), qe = ii(Qe), br = O & 32768 ? m2.getLocalName(Qe) : Qe.name;
                return $(Gr, 98304, 0), he = S2, m2.updateFunctionExpression(Qe, void 0, Qe.asteriskToken, br, void 0, Ce, void 0, qe);
              }
              function wr(Qe) {
                var Gr = he;
                he = void 0;
                var S2 = X(32670, 65), Ce = e2.visitParameterList(Qe.parameters, L, p), qe = ii(Qe), br = O & 32768 ? m2.getLocalName(Qe) : Qe.name;
                return $(S2, 98304, 0), he = Gr, m2.updateFunctionDeclaration(Qe, void 0, e2.visitNodes(Qe.modifiers, L, e2.isModifier), Qe.asteriskToken, br, void 0, Ce, void 0, qe);
              }
              function Ur(Qe, Gr, S2, Ce) {
                var qe = he;
                he = void 0;
                var br = Ce && e2.isClassLike(Ce) && !e2.isStatic(Qe) ? X(32670, 73) : X(32670, 65), Zr = e2.visitParameterList(Qe.parameters, L, p), Si = ii(Qe);
                return O & 32768 && !S2 && (Qe.kind === 256 || Qe.kind === 213) && (S2 = m2.getGeneratedNameForNode(Qe)), $(br, 98304, 0), he = qe, e2.setOriginalNode(e2.setTextRange(m2.createFunctionExpression(void 0, Qe.asteriskToken, S2, void 0, Zr, void 0, Si), Gr), Qe);
              }
              function ii(Qe) {
                var Gr = false, S2 = false, Ce, qe, br = [], Zr = [], Si = Qe.body, Pi;
                if (f4(), e2.isBlock(Si) && (Pi = m2.copyStandardPrologue(Si.statements, br, 0, false), Pi = m2.copyCustomPrologue(Si.statements, Zr, Pi, L, e2.isHoistedFunction), Pi = m2.copyCustomPrologue(Si.statements, Zr, Pi, L, e2.isHoistedVariableStatement)), Gr = ye(Zr, Qe) || Gr, Gr = Cr(Zr, Qe, false) || Gr, e2.isBlock(Si))
                  Pi = m2.copyCustomPrologue(Si.statements, Zr, Pi, L), Ce = Si.statements, e2.addRange(Zr, e2.visitNodes(Si.statements, L, e2.isStatement, Pi)), !Gr && Si.multiLine && (Gr = true);
                else {
                  e2.Debug.assert(Qe.kind === 214), Ce = e2.moveRangeEnd(Si, -1);
                  var Qi = Qe.equalsGreaterThanToken;
                  !e2.nodeIsSynthesized(Qi) && !e2.nodeIsSynthesized(Si) && (e2.rangeEndIsOnSameLineAsRangeStart(Qi, Si, R) ? S2 = true : Gr = true);
                  var Ct = e2.visitNode(Si, L, e2.isExpression), sa = m2.createReturnStatement(Ct);
                  e2.setTextRange(sa, Si), e2.moveSyntheticComments(sa, Si), e2.setEmitFlags(sa, 1440), Zr.push(sa), qe = Si;
                }
                if (m2.mergeLexicalEnvironment(br, T()), Ne(br, Qe, false), Ye(br, Qe), e2.some(br) && (Gr = true), Zr.unshift.apply(Zr, br), e2.isBlock(Si) && e2.arrayIsEqualTo(Zr, Si.statements))
                  return Si;
                var en = m2.createBlock(e2.setTextRange(m2.createNodeArray(Zr), Ce), Gr);
                return e2.setTextRange(en, Qe.body), !Gr && S2 && e2.setEmitFlags(en, 1), qe && e2.setTokenSourceMapRange(en, 19, qe), e2.setOriginalNode(en, Qe.body), en;
              }
              function mi(Qe, Gr) {
                if (Gr)
                  return e2.visitEachChild(Qe, L, p);
                var S2 = O & 256 ? X(7104, 512) : X(6976, 128), Ce = e2.visitEachChild(Qe, L, p);
                return $(S2, 0, 0), Ce;
              }
              function pe(Qe) {
                return e2.visitEachChild(Qe, P, p);
              }
              function or(Qe, Gr) {
                return e2.visitEachChild(Qe, Gr ? P : L, p);
              }
              function qr(Qe, Gr) {
                return e2.isDestructuringAssignment(Qe) ? e2.flattenDestructuringAssignment(Qe, L, p, 0, !Gr) : Qe.operatorToken.kind === 27 ? m2.updateBinaryExpression(Qe, e2.visitNode(Qe.left, P, e2.isExpression), Qe.operatorToken, e2.visitNode(Qe.right, Gr ? P : L, e2.isExpression)) : e2.visitEachChild(Qe, L, p);
              }
              function si(Qe, Gr) {
                if (Gr)
                  return e2.visitEachChild(Qe, P, p);
                for (var S2, Ce = 0; Ce < Qe.elements.length; Ce++) {
                  var qe = Qe.elements[Ce], br = e2.visitNode(qe, Ce < Qe.elements.length - 1 ? P : L, e2.isExpression);
                  (S2 || br !== qe) && (S2 || (S2 = Qe.elements.slice(0, Ce)), S2.push(br));
                }
                var Zr = S2 ? e2.setTextRange(m2.createNodeArray(S2), Qe.elements) : Qe.elements;
                return m2.updateCommaListExpression(Qe, Zr);
              }
              function Di(Qe) {
                return Qe.declarationList.declarations.length === 1 && !!Qe.declarationList.declarations[0].initializer && !!(e2.getEmitFlags(Qe.declarationList.declarations[0].initializer) & 33554432);
              }
              function wi(Qe) {
                var Gr = X(0, e2.hasSyntacticModifier(Qe, 1) ? 32 : 0), S2;
                if (he && (Qe.declarationList.flags & 3) === 0 && !Di(Qe)) {
                  for (var Ce = void 0, qe = 0, br = Qe.declarationList.declarations; qe < br.length; qe++) {
                    var Zr = br[qe];
                    if (De(he, Zr), Zr.initializer) {
                      var Si = void 0;
                      e2.isBindingPattern(Zr.name) ? Si = e2.flattenDestructuringAssignment(Zr, L, p, 0) : (Si = m2.createBinaryExpression(Zr.name, 63, e2.visitNode(Zr.initializer, L, e2.isExpression)), e2.setTextRange(Si, Zr)), Ce = e2.append(Ce, Si);
                    }
                  }
                  Ce ? S2 = e2.setTextRange(m2.createExpressionStatement(m2.inlineExpressions(Ce)), Qe) : S2 = void 0;
                } else
                  S2 = e2.visitEachChild(Qe, L, p);
                return $(Gr, 0, 0), S2;
              }
              function Xi(Qe) {
                if (Qe.flags & 3 || Qe.transformFlags & 262144) {
                  Qe.flags & 3 && Co();
                  var Gr = e2.flatMap(Qe.declarations, Qe.flags & 1 ? Wt : Zt), S2 = m2.createVariableDeclarationList(Gr);
                  return e2.setOriginalNode(S2, Qe), e2.setTextRange(S2, Qe), e2.setCommentRange(S2, Qe), Qe.transformFlags & 262144 && (e2.isBindingPattern(Qe.declarations[0].name) || e2.isBindingPattern(e2.last(Qe.declarations).name)) && e2.setSourceMapRange(S2, et(Gr)), S2;
                }
                return e2.visitEachChild(Qe, L, p);
              }
              function et(Qe) {
                for (var Gr = -1, S2 = -1, Ce = 0, qe = Qe; Ce < qe.length; Ce++) {
                  var br = qe[Ce];
                  Gr = Gr === -1 ? br.pos : br.pos === -1 ? Gr : Math.min(Gr, br.pos), S2 = Math.max(S2, br.end);
                }
                return e2.createRange(Gr, S2);
              }
              function Gi(Qe) {
                var Gr = se.getNodeCheckFlags(Qe), S2 = Gr & 262144, Ce = Gr & 524288, qe = (O & 64) !== 0 || S2 && Ce && (O & 512) !== 0, br = !qe && (O & 4096) === 0 && (!se.isDeclarationWithCollidingName(Qe) || Ce && !S2 && (O & 6144) === 0);
                return br;
              }
              function Wt(Qe) {
                var Gr = Qe.name;
                return e2.isBindingPattern(Gr) ? Zt(Qe) : !Qe.initializer && Gi(Qe) ? m2.updateVariableDeclaration(Qe, Qe.name, void 0, void 0, m2.createVoidZero()) : e2.visitEachChild(Qe, L, p);
              }
              function Zt(Qe) {
                var Gr = X(32, 0), S2;
                return e2.isBindingPattern(Qe.name) ? S2 = e2.flattenDestructuringBinding(Qe, L, p, 0, void 0, (Gr & 32) !== 0) : S2 = e2.visitEachChild(Qe, L, p), $(Gr, 0, 0), S2;
              }
              function _r(Qe) {
                he.labels.set(e2.idText(Qe.label), true);
              }
              function pi(Qe) {
                he.labels.set(e2.idText(Qe.label), false);
              }
              function ae(Qe) {
                he && !he.labels && (he.labels = new e2.Map());
                var Gr = e2.unwrapInnermostStatementOfLabel(Qe, he && _r);
                return e2.isIterationStatement(Gr, false) ? Xe(Gr, Qe) : m2.restoreEnclosingLabel(e2.visitNode(Gr, L, e2.isStatement, m2.liftToBlock), Qe, he && pi);
              }
              function Xe(Qe, Gr) {
                switch (Qe.kind) {
                  case 240:
                  case 241:
                    return ti(Qe, Gr);
                  case 242:
                    return Ze(Qe, Gr);
                  case 243:
                    return zr(Qe, Gr);
                  case 244:
                    return Wr(Qe, Gr);
                }
              }
              function Jr(Qe, Gr, S2, Ce, qe) {
                var br = X(Qe, Gr), Zr = gr(S2, Ce, br, qe);
                return $(br, 0, 0), Zr;
              }
              function ti(Qe, Gr) {
                return Jr(0, 1280, Qe, Gr);
              }
              function Ze(Qe, Gr) {
                return Jr(5056, 3328, Qe, Gr);
              }
              function Sr(Qe) {
                return m2.updateForStatement(Qe, e2.visitNode(Qe.initializer, P, e2.isForInitializer), e2.visitNode(Qe.condition, L, e2.isExpression), e2.visitNode(Qe.incrementor, P, e2.isExpression), e2.visitNode(Qe.statement, L, e2.isStatement, m2.liftToBlock));
              }
              function zr(Qe, Gr) {
                return Jr(3008, 5376, Qe, Gr);
              }
              function Wr(Qe, Gr) {
                return Jr(3008, 5376, Qe, Gr, b.downlevelIteration ? mr : vr);
              }
              function Je(Qe, Gr, S2) {
                var Ce = [], qe = Qe.initializer;
                if (e2.isVariableDeclarationList(qe)) {
                  Qe.initializer.flags & 3 && Co();
                  var br = e2.firstOrUndefined(qe.declarations);
                  if (br && e2.isBindingPattern(br.name)) {
                    var Zr = e2.flattenDestructuringBinding(br, L, p, 0, Gr), Si = e2.setTextRange(m2.createVariableDeclarationList(Zr), Qe.initializer);
                    e2.setOriginalNode(Si, Qe.initializer), e2.setSourceMapRange(Si, e2.createRange(Zr[0].pos, e2.last(Zr).end)), Ce.push(m2.createVariableStatement(void 0, Si));
                  } else
                    Ce.push(e2.setTextRange(m2.createVariableStatement(void 0, e2.setOriginalNode(e2.setTextRange(m2.createVariableDeclarationList([m2.createVariableDeclaration(br ? br.name : m2.createTempVariable(void 0), void 0, void 0, Gr)]), e2.moveRangePos(qe, -1)), qe)), e2.moveRangeEnd(qe, -1)));
                } else {
                  var Pi = m2.createAssignment(qe, Gr);
                  e2.isDestructuringAssignment(Pi) ? Ce.push(m2.createExpressionStatement(qr(Pi, true))) : (e2.setTextRangeEnd(Pi, qe.end), Ce.push(e2.setTextRange(m2.createExpressionStatement(e2.visitNode(Pi, L, e2.isExpression)), e2.moveRangeEnd(qe, -1))));
                }
                if (S2)
                  return xe(e2.addRange(Ce, S2));
                var Qi = e2.visitNode(Qe.statement, L, e2.isStatement, m2.liftToBlock);
                return e2.isBlock(Qi) ? m2.updateBlock(Qi, e2.setTextRange(m2.createNodeArray(e2.concatenate(Ce, Qi.statements)), Qi.statements)) : (Ce.push(Qi), xe(Ce));
              }
              function xe(Qe) {
                return e2.setEmitFlags(m2.createBlock(m2.createNodeArray(Qe), true), 432);
              }
              function vr(Qe, Gr, S2) {
                var Ce = e2.visitNode(Qe.expression, L, e2.isExpression), qe = m2.createLoopVariable(), br = e2.isIdentifier(Ce) ? m2.getGeneratedNameForNode(Ce) : m2.createTempVariable(void 0);
                e2.setEmitFlags(Ce, 48 | e2.getEmitFlags(Ce));
                var Zr = e2.setTextRange(m2.createForStatement(e2.setEmitFlags(e2.setTextRange(m2.createVariableDeclarationList([e2.setTextRange(m2.createVariableDeclaration(qe, void 0, void 0, m2.createNumericLiteral(0)), e2.moveRangePos(Qe.expression, -1)), e2.setTextRange(m2.createVariableDeclaration(br, void 0, void 0, Ce), Qe.expression)]), Qe.expression), 2097152), e2.setTextRange(m2.createLessThan(qe, m2.createPropertyAccessExpression(br, "length")), Qe.expression), e2.setTextRange(m2.createPostfixIncrement(qe), Qe.expression), Je(Qe, m2.createElementAccessExpression(br, qe), S2)), Qe);
                return e2.setEmitFlags(Zr, 256), e2.setTextRange(Zr, Qe), m2.restoreEnclosingLabel(Zr, Gr, he && pi);
              }
              function mr(Qe, Gr, S2, Ce) {
                var qe = e2.visitNode(Qe.expression, L, e2.isExpression), br = e2.isIdentifier(qe) ? m2.getGeneratedNameForNode(qe) : m2.createTempVariable(void 0), Zr = e2.isIdentifier(qe) ? m2.getGeneratedNameForNode(br) : m2.createTempVariable(void 0), Si = m2.createUniqueName("e"), Pi = m2.getGeneratedNameForNode(Si), Qi = m2.createTempVariable(void 0), Ct = e2.setTextRange(G().createValuesHelper(qe), Qe.expression), sa = m2.createCallExpression(m2.createPropertyAccessExpression(br, "next"), void 0, []);
                K(Si), K(Qi);
                var en = Ce & 1024 ? m2.inlineExpressions([m2.createAssignment(Si, m2.createVoidZero()), Ct]) : Ct, Wa = e2.setEmitFlags(e2.setTextRange(m2.createForStatement(e2.setEmitFlags(e2.setTextRange(m2.createVariableDeclarationList([e2.setTextRange(m2.createVariableDeclaration(br, void 0, void 0, en), Qe.expression), m2.createVariableDeclaration(Zr, void 0, void 0, sa)]), Qe.expression), 2097152), m2.createLogicalNot(m2.createPropertyAccessExpression(Zr, "done")), m2.createAssignment(Zr, sa), Je(Qe, m2.createPropertyAccessExpression(Zr, "value"), S2)), Qe), 256);
                return m2.createTryStatement(m2.createBlock([m2.restoreEnclosingLabel(Wa, Gr, he && pi)]), m2.createCatchClause(m2.createVariableDeclaration(Pi), e2.setEmitFlags(m2.createBlock([m2.createExpressionStatement(m2.createAssignment(Si, m2.createObjectLiteralExpression([m2.createPropertyAssignment("error", Pi)])))]), 1)), m2.createBlock([m2.createTryStatement(m2.createBlock([e2.setEmitFlags(m2.createIfStatement(m2.createLogicalAnd(m2.createLogicalAnd(Zr, m2.createLogicalNot(m2.createPropertyAccessExpression(Zr, "done"))), m2.createAssignment(Qi, m2.createPropertyAccessExpression(br, "return"))), m2.createExpressionStatement(m2.createFunctionCallCall(Qi, br, []))), 1)]), void 0, e2.setEmitFlags(m2.createBlock([e2.setEmitFlags(m2.createIfStatement(Si, m2.createThrowStatement(m2.createPropertyAccessExpression(Si, "error"))), 1)]), 1))]));
              }
              function Ar(Qe) {
                for (var Gr = Qe.properties, S2 = -1, Ce = false, qe = 0; qe < Gr.length; qe++) {
                  var br = Gr[qe];
                  if (br.transformFlags & 524288 && O & 4 || (Ce = e2.Debug.checkDefined(br.name).kind === 162)) {
                    S2 = qe;
                    break;
                  }
                }
                if (S2 < 0)
                  return e2.visitEachChild(Qe, L, p);
                var Zr = m2.createTempVariable(K), Si = [], Pi = m2.createAssignment(Zr, e2.setEmitFlags(m2.createObjectLiteralExpression(e2.visitNodes(Gr, L, e2.isObjectLiteralElementLike, 0, S2), Qe.multiLine), Ce ? 65536 : 0));
                return Qe.multiLine && e2.startOnNewLine(Pi), Si.push(Pi), Bt(Si, Qe, Zr, S2), Si.push(Qe.multiLine ? e2.startOnNewLine(e2.setParent(e2.setTextRange(m2.cloneNode(Zr), Zr), Zr.parent)) : Zr), m2.inlineExpressions(Si);
              }
              function Oe(Qe) {
                return (se.getNodeCheckFlags(Qe) & 131072) !== 0;
              }
              function nr(Qe) {
                return e2.isForStatement(Qe) && !!Qe.initializer && Oe(Qe.initializer);
              }
              function Mr(Qe) {
                return e2.isForStatement(Qe) && !!Qe.condition && Oe(Qe.condition);
              }
              function Pe(Qe) {
                return e2.isForStatement(Qe) && !!Qe.incrementor && Oe(Qe.incrementor);
              }
              function Ue(Qe) {
                return fr(Qe) || nr(Qe);
              }
              function fr(Qe) {
                return (se.getNodeCheckFlags(Qe) & 65536) !== 0;
              }
              function De(Qe, Gr) {
                Qe.hoistedLocalVariables || (Qe.hoistedLocalVariables = []), S2(Gr.name);
                function S2(Ce) {
                  if (Ce.kind === 79)
                    Qe.hoistedLocalVariables.push(Ce);
                  else
                    for (var qe = 0, br = Ce.elements; qe < br.length; qe++) {
                      var Zr = br[qe];
                      e2.isOmittedExpression(Zr) || S2(Zr.name);
                    }
                }
              }
              function gr(Qe, Gr, S2, Ce) {
                if (!Ue(Qe)) {
                  var qe = void 0;
                  he && (qe = he.allowedNonLabeledJumps, he.allowedNonLabeledJumps = 6);
                  var br = Ce ? Ce(Qe, Gr, void 0, S2) : m2.restoreEnclosingLabel(e2.isForStatement(Qe) ? Sr(Qe) : e2.visitEachChild(Qe, L, p), Gr, he && pi);
                  return he && (he.allowedNonLabeledJumps = qe), br;
                }
                var Zr = ct(Qe), Si = [], Pi = he;
                he = Zr;
                var Qi = nr(Qe) ? Mt(Qe, Zr) : void 0, Ct = fr(Qe) ? xt(Qe, Zr, Pi) : void 0;
                he = Pi, Qi && Si.push(Qi.functionDeclaration), Ct && Si.push(Ct.functionDeclaration), Li(Si, Zr, Pi), Qi && Si.push(Rt(Qi.functionName, Qi.containsYield));
                var sa;
                if (Ct)
                  if (Ce)
                    sa = Ce(Qe, Gr, Ct.part, S2);
                  else {
                    var en = Vr(Qe, Qi, m2.createBlock(Ct.part, true));
                    sa = m2.restoreEnclosingLabel(en, Gr, he && pi);
                  }
                else {
                  var Wa = Vr(Qe, Qi, e2.visitNode(Qe.statement, L, e2.isStatement, m2.liftToBlock));
                  sa = m2.restoreEnclosingLabel(Wa, Gr, he && pi);
                }
                return Si.push(sa), Si;
              }
              function Vr(Qe, Gr, S2) {
                switch (Qe.kind) {
                  case 242:
                    return Tr(Qe, Gr, S2);
                  case 243:
                    return Ui(Qe, S2);
                  case 244:
                    return vi(Qe, S2);
                  case 240:
                    return Yi(Qe, S2);
                  case 241:
                    return Wi(Qe, S2);
                  default:
                    return e2.Debug.failBadSyntaxKind(Qe, "IterationStatement expected");
                }
              }
              function Tr(Qe, Gr, S2) {
                var Ce = Qe.condition && Oe(Qe.condition), qe = Ce || Qe.incrementor && Oe(Qe.incrementor);
                return m2.updateForStatement(Qe, e2.visitNode(Gr ? Gr.part : Qe.initializer, P, e2.isForInitializer), e2.visitNode(Ce ? void 0 : Qe.condition, L, e2.isExpression), e2.visitNode(qe ? void 0 : Qe.incrementor, P, e2.isExpression), S2);
              }
              function vi(Qe, Gr) {
                return m2.updateForOfStatement(Qe, void 0, e2.visitNode(Qe.initializer, L, e2.isForInitializer), e2.visitNode(Qe.expression, L, e2.isExpression), Gr);
              }
              function Ui(Qe, Gr) {
                return m2.updateForInStatement(Qe, e2.visitNode(Qe.initializer, L, e2.isForInitializer), e2.visitNode(Qe.expression, L, e2.isExpression), Gr);
              }
              function Yi(Qe, Gr) {
                return m2.updateDoStatement(Qe, Gr, e2.visitNode(Qe.expression, L, e2.isExpression));
              }
              function Wi(Qe, Gr) {
                return m2.updateWhileStatement(Qe, e2.visitNode(Qe.expression, L, e2.isExpression), Gr);
              }
              function ct(Qe) {
                var Gr;
                switch (Qe.kind) {
                  case 242:
                  case 243:
                  case 244:
                    var S2 = Qe.initializer;
                    S2 && S2.kind === 255 && (Gr = S2);
                    break;
                }
                var Ce = [], qe = [];
                if (Gr && e2.getCombinedNodeFlags(Gr) & 3)
                  for (var br = nr(Qe) || Mr(Qe) || Pe(Qe), Zr = 0, Si = Gr.declarations; Zr < Si.length; Zr++) {
                    var Pi = Si[Zr];
                    ui(Qe, Pi, Ce, qe, br);
                  }
                var Qi = { loopParameters: Ce, loopOutParameters: qe };
                return he && (he.argumentsName && (Qi.argumentsName = he.argumentsName), he.thisName && (Qi.thisName = he.thisName), he.hoistedLocalVariables && (Qi.hoistedLocalVariables = he.hoistedLocalVariables)), Qi;
              }
              function Li(Qe, Gr, S2) {
                var Ce;
                if (Gr.argumentsName && (S2 ? S2.argumentsName = Gr.argumentsName : (Ce || (Ce = [])).push(m2.createVariableDeclaration(Gr.argumentsName, void 0, void 0, m2.createIdentifier("arguments")))), Gr.thisName && (S2 ? S2.thisName = Gr.thisName : (Ce || (Ce = [])).push(m2.createVariableDeclaration(Gr.thisName, void 0, void 0, m2.createIdentifier("this")))), Gr.hoistedLocalVariables)
                  if (S2)
                    S2.hoistedLocalVariables = Gr.hoistedLocalVariables;
                  else {
                    Ce || (Ce = []);
                    for (var qe = 0, br = Gr.hoistedLocalVariables; qe < br.length; qe++) {
                      var Zr = br[qe];
                      Ce.push(m2.createVariableDeclaration(Zr));
                    }
                  }
                if (Gr.loopOutParameters.length) {
                  Ce || (Ce = []);
                  for (var Si = 0, Pi = Gr.loopOutParameters; Si < Pi.length; Si++) {
                    var Qi = Pi[Si];
                    Ce.push(m2.createVariableDeclaration(Qi.outParamName));
                  }
                }
                Gr.conditionVariable && (Ce || (Ce = []), Ce.push(m2.createVariableDeclaration(Gr.conditionVariable, void 0, void 0, m2.createFalse()))), Ce && Qe.push(m2.createVariableStatement(void 0, m2.createVariableDeclarationList(Ce)));
              }
              function nt(Qe) {
                return m2.createVariableDeclaration(Qe.originalName, void 0, void 0, Qe.outParamName);
              }
              function Mt(Qe, Gr) {
                var S2 = m2.createUniqueName("_loop_init"), Ce = (Qe.initializer.transformFlags & 524288) !== 0, qe = 0;
                Gr.containsLexicalThis && (qe |= 8), Ce && O & 4 && (qe |= 262144);
                var br = [];
                br.push(m2.createVariableStatement(void 0, Qe.initializer)), Dt(Gr.loopOutParameters, 2, 1, br);
                var Zr = m2.createVariableStatement(void 0, e2.setEmitFlags(m2.createVariableDeclarationList([m2.createVariableDeclaration(S2, void 0, void 0, e2.setEmitFlags(m2.createFunctionExpression(void 0, Ce ? m2.createToken(41) : void 0, void 0, void 0, void 0, void 0, e2.visitNode(m2.createBlock(br, true), L, e2.isBlock)), qe))]), 2097152)), Si = m2.createVariableDeclarationList(e2.map(Gr.loopOutParameters, nt));
                return { functionName: S2, containsYield: Ce, functionDeclaration: Zr, part: Si };
              }
              function xt(Qe, Gr, S2) {
                var Ce = m2.createUniqueName("_loop");
                oe();
                var qe = e2.visitNode(Qe.statement, L, e2.isStatement, m2.liftToBlock), br = T(), Zr = [];
                (Mr(Qe) || Pe(Qe)) && (Gr.conditionVariable = m2.createUniqueName("inc"), Qe.incrementor ? Zr.push(m2.createIfStatement(Gr.conditionVariable, m2.createExpressionStatement(e2.visitNode(Qe.incrementor, L, e2.isExpression)), m2.createExpressionStatement(m2.createAssignment(Gr.conditionVariable, m2.createTrue())))) : Zr.push(m2.createIfStatement(m2.createLogicalNot(Gr.conditionVariable), m2.createExpressionStatement(m2.createAssignment(Gr.conditionVariable, m2.createTrue())))), Mr(Qe) && Zr.push(m2.createIfStatement(m2.createPrefixUnaryExpression(53, e2.visitNode(Qe.condition, L, e2.isExpression)), e2.visitNode(m2.createBreakStatement(), L, e2.isStatement)))), e2.isBlock(qe) ? e2.addRange(Zr, qe.statements) : Zr.push(qe), Dt(Gr.loopOutParameters, 1, 1, Zr), e2.insertStatementsAfterStandardPrologue(Zr, br);
                var Si = m2.createBlock(Zr, true);
                e2.isBlock(qe) && e2.setOriginalNode(Si, qe);
                var Pi = (Qe.statement.transformFlags & 524288) !== 0, Qi = 524288;
                Gr.containsLexicalThis && (Qi |= 8), Pi && (O & 4) !== 0 && (Qi |= 262144);
                var Ct = m2.createVariableStatement(void 0, e2.setEmitFlags(m2.createVariableDeclarationList([m2.createVariableDeclaration(Ce, void 0, void 0, e2.setEmitFlags(m2.createFunctionExpression(void 0, Pi ? m2.createToken(41) : void 0, void 0, void 0, Gr.loopParameters, void 0, Si), Qi))]), 2097152)), sa = Ii(Ce, Gr, S2, Pi);
                return { functionName: Ce, containsYield: Pi, functionDeclaration: Ct, part: sa };
              }
              function ut(Qe, Gr) {
                var S2 = Gr === 0 ? Qe.outParamName : Qe.originalName, Ce = Gr === 0 ? Qe.originalName : Qe.outParamName;
                return m2.createBinaryExpression(Ce, 63, S2);
              }
              function Dt(Qe, Gr, S2, Ce) {
                for (var qe = 0, br = Qe; qe < br.length; qe++) {
                  var Zr = br[qe];
                  Zr.flags & Gr && Ce.push(m2.createExpressionStatement(ut(Zr, S2)));
                }
              }
              function Rt(Qe, Gr) {
                var S2 = m2.createCallExpression(Qe, void 0, []), Ce = Gr ? m2.createYieldExpression(m2.createToken(41), e2.setEmitFlags(S2, 8388608)) : S2;
                return m2.createExpressionStatement(Ce);
              }
              function Ii(Qe, Gr, S2, Ce) {
                var qe = [], br = !(Gr.nonLocalJumps & -5) && !Gr.labeledNonLocalBreaks && !Gr.labeledNonLocalContinues, Zr = m2.createCallExpression(Qe, void 0, e2.map(Gr.loopParameters, function(en) {
                  return en.name;
                })), Si = Ce ? m2.createYieldExpression(m2.createToken(41), e2.setEmitFlags(Zr, 8388608)) : Zr;
                if (br)
                  qe.push(m2.createExpressionStatement(Si)), Dt(Gr.loopOutParameters, 1, 0, qe);
                else {
                  var Pi = m2.createUniqueName("state"), Qi = m2.createVariableStatement(void 0, m2.createVariableDeclarationList([m2.createVariableDeclaration(Pi, void 0, void 0, Si)]));
                  if (qe.push(Qi), Dt(Gr.loopOutParameters, 1, 0, qe), Gr.nonLocalJumps & 8) {
                    var Ct = void 0;
                    S2 ? (S2.nonLocalJumps |= 8, Ct = m2.createReturnStatement(Pi)) : Ct = m2.createReturnStatement(m2.createPropertyAccessExpression(Pi, "value")), qe.push(m2.createIfStatement(m2.createTypeCheck(Pi, "object"), Ct));
                  }
                  if (Gr.nonLocalJumps & 2 && qe.push(m2.createIfStatement(m2.createStrictEquality(Pi, m2.createStringLiteral("break")), m2.createBreakStatement())), Gr.labeledNonLocalBreaks || Gr.labeledNonLocalContinues) {
                    var sa = [];
                    Fi(Gr.labeledNonLocalBreaks, true, Pi, S2, sa), Fi(Gr.labeledNonLocalContinues, false, Pi, S2, sa), qe.push(m2.createSwitchStatement(Pi, m2.createCaseBlock(sa)));
                  }
                }
                return qe;
              }
              function Ki(Qe, Gr, S2, Ce) {
                Gr ? (Qe.labeledNonLocalBreaks || (Qe.labeledNonLocalBreaks = new e2.Map()), Qe.labeledNonLocalBreaks.set(S2, Ce)) : (Qe.labeledNonLocalContinues || (Qe.labeledNonLocalContinues = new e2.Map()), Qe.labeledNonLocalContinues.set(S2, Ce));
              }
              function Fi(Qe, Gr, S2, Ce, qe) {
                !Qe || Qe.forEach(function(br, Zr) {
                  var Si = [];
                  if (!Ce || Ce.labels && Ce.labels.get(Zr)) {
                    var Pi = m2.createIdentifier(Zr);
                    Si.push(Gr ? m2.createBreakStatement(Pi) : m2.createContinueStatement(Pi));
                  } else
                    Ki(Ce, Gr, Zr, br), Si.push(m2.createReturnStatement(S2));
                  qe.push(m2.createCaseClause(m2.createStringLiteral(br), Si));
                });
              }
              function ui(Qe, Gr, S2, Ce, qe) {
                var br = Gr.name;
                if (e2.isBindingPattern(br))
                  for (var Zr = 0, Si = br.elements; Zr < Si.length; Zr++) {
                    var Pi = Si[Zr];
                    e2.isOmittedExpression(Pi) || ui(Qe, Pi, S2, Ce, qe);
                  }
                else {
                  S2.push(m2.createParameterDeclaration(void 0, void 0, void 0, br));
                  var Qi = se.getNodeCheckFlags(Gr);
                  if (Qi & 4194304 || qe) {
                    var Ct = m2.createUniqueName("out_" + e2.idText(br)), sa = 0;
                    Qi & 4194304 && (sa |= 1), e2.isForStatement(Qe) && (Qe.initializer && se.isBindingCapturedByNode(Qe.initializer, Gr) && (sa |= 2), (Qe.condition && se.isBindingCapturedByNode(Qe.condition, Gr) || Qe.incrementor && se.isBindingCapturedByNode(Qe.incrementor, Gr)) && (sa |= 1)), Ce.push({ flags: sa, originalName: br, outParamName: Ct });
                  }
                }
              }
              function Bt(Qe, Gr, S2, Ce) {
                for (var qe = Gr.properties, br = qe.length, Zr = Ce; Zr < br; Zr++) {
                  var Si = qe[Zr];
                  switch (Si.kind) {
                    case 172:
                    case 173:
                      var Pi = e2.getAllAccessorDeclarations(Gr.properties, Si);
                      Si === Pi.firstAccessor && Qe.push(ur(S2, Pi, Gr, !!Gr.multiLine));
                      break;
                    case 169:
                      Qe.push(Ai(Si, S2, Gr, Gr.multiLine));
                      break;
                    case 296:
                      Qe.push(wt(Si, S2, Gr.multiLine));
                      break;
                    case 297:
                      Qe.push(na(Si, S2, Gr.multiLine));
                      break;
                    default:
                      e2.Debug.failBadSyntaxKind(Gr);
                      break;
                  }
                }
              }
              function wt(Qe, Gr, S2) {
                var Ce = m2.createAssignment(e2.createMemberAccessForPropertyName(m2, Gr, e2.visitNode(Qe.name, L, e2.isPropertyName)), e2.visitNode(Qe.initializer, L, e2.isExpression));
                return e2.setTextRange(Ce, Qe), S2 && e2.startOnNewLine(Ce), Ce;
              }
              function na(Qe, Gr, S2) {
                var Ce = m2.createAssignment(e2.createMemberAccessForPropertyName(m2, Gr, e2.visitNode(Qe.name, L, e2.isPropertyName)), m2.cloneNode(Qe.name));
                return e2.setTextRange(Ce, Qe), S2 && e2.startOnNewLine(Ce), Ce;
              }
              function Ai(Qe, Gr, S2, Ce) {
                var qe = m2.createAssignment(e2.createMemberAccessForPropertyName(m2, Gr, e2.visitNode(Qe.name, L, e2.isPropertyName)), Ur(Qe, Qe, void 0, S2));
                return e2.setTextRange(qe, Qe), Ce && e2.startOnNewLine(qe), qe;
              }
              function Oi(Qe) {
                var Gr = X(7104, 0), S2;
                if (e2.Debug.assert(!!Qe.variableDeclaration, "Catch clause variable should always be present when downleveling ES2015."), e2.isBindingPattern(Qe.variableDeclaration.name)) {
                  var Ce = m2.createTempVariable(void 0), qe = m2.createVariableDeclaration(Ce);
                  e2.setTextRange(qe, Qe.variableDeclaration);
                  var br = e2.flattenDestructuringBinding(Qe.variableDeclaration, L, p, 0, Ce), Zr = m2.createVariableDeclarationList(br);
                  e2.setTextRange(Zr, Qe.variableDeclaration);
                  var Si = m2.createVariableStatement(void 0, Zr);
                  S2 = m2.updateCatchClause(Qe, qe, ji(Qe.block, Si));
                } else
                  S2 = e2.visitEachChild(Qe, L, p);
                return $(Gr, 0, 0), S2;
              }
              function ji(Qe, Gr) {
                var S2 = e2.visitNodes(Qe.statements, L, e2.isStatement);
                return m2.updateBlock(Qe, Ve([Gr], S2, true));
              }
              function Vi(Qe) {
                e2.Debug.assert(!e2.isComputedPropertyName(Qe.name));
                var Gr = Ur(Qe, e2.moveRangePos(Qe, -1), void 0, void 0);
                return e2.setEmitFlags(Gr, 512 | e2.getEmitFlags(Gr)), e2.setTextRange(m2.createPropertyAssignment(Qe.name, Gr), Qe);
              }
              function at(Qe) {
                e2.Debug.assert(!e2.isComputedPropertyName(Qe.name));
                var Gr = he;
                he = void 0;
                var S2 = X(32670, 65), Ce, qe = e2.visitParameterList(Qe.parameters, L, p), br = ii(Qe);
                return Qe.kind === 172 ? Ce = m2.updateGetAccessorDeclaration(Qe, Qe.decorators, Qe.modifiers, Qe.name, qe, Qe.type, br) : Ce = m2.updateSetAccessorDeclaration(Qe, Qe.decorators, Qe.modifiers, Qe.name, qe, br), $(S2, 98304, 0), he = Gr, Ce;
              }
              function At(Qe) {
                return e2.setTextRange(m2.createPropertyAssignment(Qe.name, g(m2.cloneNode(Qe.name))), Qe);
              }
              function ba(Qe) {
                return e2.visitEachChild(Qe, L, p);
              }
              function $a(Qe) {
                return e2.visitEachChild(Qe, L, p);
              }
              function Qa(Qe) {
                return e2.some(Qe.elements, e2.isSpreadElement) ? Cn(Qe.elements, false, !!Qe.multiLine, !!Qe.elements.hasTrailingComma) : e2.visitEachChild(Qe, L, p);
              }
              function ai(Qe) {
                if (e2.getEmitFlags(Qe) & 33554432)
                  return Dn(Qe);
                var Gr = e2.skipOuterExpressions(Qe.expression);
                return Gr.kind === 106 || e2.isSuperProperty(Gr) || e2.some(Qe.arguments, e2.isSpreadElement) ? Ba(Qe, true) : m2.updateCallExpression(Qe, e2.visitNode(Qe.expression, Y, e2.isExpression), void 0, e2.visitNodes(Qe.arguments, L, e2.isExpression));
              }
              function Dn(Qe) {
                var Gr = e2.cast(e2.cast(e2.skipOuterExpressions(Qe.expression), e2.isArrowFunction).body, e2.isBlock), S2 = function(ys) {
                  return e2.isVariableStatement(ys) && !!e2.first(ys.declarationList.declarations).initializer;
                }, Ce = he;
                he = void 0;
                var qe = e2.visitNodes(Gr.statements, k, e2.isStatement);
                he = Ce;
                var br = e2.filter(qe, S2), Zr = e2.filter(qe, function(ys) {
                  return !S2(ys);
                }), Si = e2.cast(e2.first(br), e2.isVariableStatement), Pi = Si.declarationList.declarations[0], Qi = e2.skipOuterExpressions(Pi.initializer), Ct = e2.tryCast(Qi, e2.isAssignmentExpression);
                !Ct && e2.isBinaryExpression(Qi) && Qi.operatorToken.kind === 27 && (Ct = e2.tryCast(Qi.left, e2.isAssignmentExpression));
                var sa = e2.cast(Ct ? e2.skipOuterExpressions(Ct.right) : Qi, e2.isCallExpression), en = e2.cast(e2.skipOuterExpressions(sa.expression), e2.isFunctionExpression), Wa = en.body.statements, qn = 0, mo = -1, So = [];
                if (Ct) {
                  var Go = e2.tryCast(Wa[qn], e2.isExpressionStatement);
                  Go && (So.push(Go), qn++), So.push(Wa[qn]), qn++, So.push(m2.createExpressionStatement(m2.createAssignment(Ct.left, e2.cast(Pi.name, e2.isIdentifier))));
                }
                for (; !e2.isReturnStatement(e2.elementAt(Wa, mo)); )
                  mo--;
                return e2.addRange(So, Wa, qn, mo), mo < -1 && e2.addRange(So, Wa, mo + 1), e2.addRange(So, Zr), e2.addRange(So, br, 1), m2.restoreOuterExpressions(Qe.expression, m2.restoreOuterExpressions(Pi.initializer, m2.restoreOuterExpressions(Ct && Ct.right, m2.updateCallExpression(sa, m2.restoreOuterExpressions(sa.expression, m2.updateFunctionExpression(en, void 0, void 0, void 0, void 0, en.parameters, void 0, m2.updateBlock(en.body, So))), void 0, sa.arguments))));
              }
              function ka(Qe) {
                return Ba(Qe, false);
              }
              function Ba(Qe, Gr) {
                if (Qe.transformFlags & 16384 || Qe.expression.kind === 106 || e2.isSuperProperty(e2.skipOuterExpressions(Qe.expression))) {
                  var S2 = m2.createCallBinding(Qe.expression, K), Ce = S2.target, qe = S2.thisArg;
                  Qe.expression.kind === 106 && e2.setEmitFlags(qe, 4);
                  var br = void 0;
                  if (Qe.transformFlags & 16384 ? br = m2.createFunctionApplyCall(e2.visitNode(Ce, Y, e2.isExpression), Qe.expression.kind === 106 ? qe : e2.visitNode(qe, L, e2.isExpression), Cn(Qe.arguments, true, false, false)) : br = e2.setTextRange(m2.createFunctionCallCall(e2.visitNode(Ce, Y, e2.isExpression), Qe.expression.kind === 106 ? qe : e2.visitNode(qe, L, e2.isExpression), e2.visitNodes(Qe.arguments, L, e2.isExpression)), Qe), Qe.expression.kind === 106) {
                    var Zr = m2.createLogicalOr(br, Ie());
                    br = Gr ? m2.createAssignment(m2.createUniqueName("_this", 48), Zr) : Zr;
                  }
                  return e2.setOriginalNode(br, Qe);
                }
                return e2.visitEachChild(Qe, L, p);
              }
              function pn(Qe) {
                if (e2.some(Qe.arguments, e2.isSpreadElement)) {
                  var Gr = m2.createCallBinding(m2.createPropertyAccessExpression(Qe.expression, "bind"), K), S2 = Gr.target, Ce = Gr.thisArg;
                  return m2.createNewExpression(m2.createFunctionApplyCall(e2.visitNode(S2, L, e2.isExpression), Ce, Cn(m2.createNodeArray(Ve([m2.createVoidZero()], Qe.arguments, true)), true, false, false)), void 0, []);
                }
                return e2.visitEachChild(Qe, L, p);
              }
              function Cn(Qe, Gr, S2, Ce) {
                var qe = Qe.length, br = e2.flatten(e2.spanMap(Qe, Bi, function(en, Wa, qn, mo) {
                  return Wa(en, S2, Ce && mo === qe);
                }));
                if (br.length === 1) {
                  var Zr = br[0];
                  if (Gr && !b.downlevelIteration || e2.isPackedArrayLiteral(Zr.expression) || e2.isCallToHelper(Zr.expression, "___spreadArray"))
                    return Zr.expression;
                }
                for (var Si = G(), Pi = br[0].kind !== 0, Qi = Pi ? m2.createArrayLiteralExpression() : br[0].expression, Ct = Pi ? 0 : 1; Ct < br.length; Ct++) {
                  var sa = br[Ct];
                  Qi = Si.createSpreadArrayHelper(Qi, sa.expression, sa.kind === 1 && !Gr);
                }
                return Qi;
              }
              function Bi(Qe) {
                return e2.isSpreadElement(Qe) ? kn : Kn;
              }
              function kn(Qe) {
                return e2.map(Qe, xn);
              }
              function xn(Qe) {
                var Gr = e2.visitNode(Qe.expression, L, e2.isExpression), S2 = e2.isCallToHelper(Gr, "___read"), Ce = S2 || e2.isPackedArrayLiteral(Gr) ? 2 : 1;
                return b.downlevelIteration && Ce === 1 && !e2.isArrayLiteralExpression(Gr) && !S2 && (Gr = G().createReadHelper(Gr, void 0), Ce = 2), le(Ce, Gr);
              }
              function Kn(Qe, Gr, S2) {
                var Ce = m2.createArrayLiteralExpression(e2.visitNodes(m2.createNodeArray(Qe, S2), L, e2.isExpression), Gr);
                return le(0, Ce);
              }
              function Pn(Qe) {
                return e2.visitNode(Qe.expression, L, e2.isExpression);
              }
              function eo(Qe) {
                return e2.setTextRange(m2.createStringLiteral(Qe.text), Qe);
              }
              function Rn(Qe) {
                return Qe.hasExtendedUnicodeEscape ? e2.setTextRange(m2.createStringLiteral(Qe.text), Qe) : Qe;
              }
              function Da(Qe) {
                return Qe.numericLiteralFlags & 384 ? e2.setTextRange(m2.createNumericLiteral(Qe.text), Qe) : Qe;
              }
              function bo(Qe) {
                return e2.processTaggedTemplateExpression(p, Qe, L, R, ee, e2.ProcessLevel.All);
              }
              function Ro(Qe) {
                for (var Gr = m2.createStringLiteral(Qe.head.text), S2 = 0, Ce = Qe.templateSpans; S2 < Ce.length; S2++) {
                  var qe = Ce[S2], br = [e2.visitNode(qe.expression, L, e2.isExpression)];
                  qe.literal.text.length > 0 && br.push(m2.createStringLiteral(qe.literal.text)), Gr = m2.createCallExpression(m2.createPropertyAccessExpression(Gr, "concat"), void 0, br);
                }
                return e2.setTextRange(Gr, Qe);
              }
              function En(Qe) {
                return O & 8 && !Qe ? m2.createPropertyAccessExpression(m2.createUniqueName("_super", 48), "prototype") : m2.createUniqueName("_super", 48);
              }
              function Wn(Qe) {
                return Qe.keywordToken === 103 && Qe.name.escapedText === "target" ? (O |= 32768, m2.createUniqueName("_newTarget", 48)) : Qe;
              }
              function to(Qe, Gr, S2) {
                if (F2 & 1 && e2.isFunctionLike(Gr)) {
                  var Ce = X(32670, e2.getEmitFlags(Gr) & 8 ? 81 : 65);
                  ie(Qe, Gr, S2), $(Ce, 0, 0);
                  return;
                }
                ie(Qe, Gr, S2);
              }
              function Co() {
                (F2 & 2) === 0 && (F2 |= 2, p.enableSubstitution(79));
              }
              function Ko() {
                (F2 & 1) === 0 && (F2 |= 1, p.enableSubstitution(108), p.enableEmitNotification(171), p.enableEmitNotification(169), p.enableEmitNotification(172), p.enableEmitNotification(173), p.enableEmitNotification(214), p.enableEmitNotification(213), p.enableEmitNotification(256));
              }
              function Oo(Qe, Gr) {
                return Gr = J(Qe, Gr), Qe === 1 ? Pr(Gr) : e2.isIdentifier(Gr) ? no(Gr) : Gr;
              }
              function no(Qe) {
                if (F2 & 2 && !e2.isInternalName(Qe)) {
                  var Gr = e2.getParseTreeNode(Qe, e2.isIdentifier);
                  if (Gr && $o(Gr))
                    return e2.setTextRange(m2.getGeneratedNameForNode(Gr), Qe);
                }
                return Qe;
              }
              function $o(Qe) {
                switch (Qe.parent.kind) {
                  case 203:
                  case 257:
                  case 260:
                  case 254:
                    return Qe.parent.name === Qe && se.isDeclarationWithCollidingName(Qe.parent);
                }
                return false;
              }
              function Pr(Qe) {
                switch (Qe.kind) {
                  case 79:
                    return xi(Qe);
                  case 108:
                    return pa(Qe);
                }
                return Qe;
              }
              function xi(Qe) {
                if (F2 & 2 && !e2.isInternalName(Qe)) {
                  var Gr = se.getReferencedDeclarationWithCollidingName(Qe);
                  if (Gr && !(e2.isClassLike(Gr) && St(Gr, Qe)))
                    return e2.setTextRange(m2.getGeneratedNameForNode(e2.getNameOfDeclaration(Gr)), Qe);
                }
                return Qe;
              }
              function St(Qe, Gr) {
                var S2 = e2.getParseTreeNode(Gr);
                if (!S2 || S2 === Qe || S2.end <= Qe.pos || S2.pos >= Qe.end)
                  return false;
                for (var Ce = e2.getEnclosingBlockScopeContainer(Qe); S2; ) {
                  if (S2 === Ce || S2 === Qe)
                    return false;
                  if (e2.isClassElement(S2) && S2.parent === Qe)
                    return true;
                  S2 = S2.parent;
                }
                return false;
              }
              function pa(Qe) {
                return F2 & 1 && O & 16 ? e2.setTextRange(m2.createUniqueName("_this", 48), Qe) : Qe;
              }
              function dn(Qe, Gr) {
                return e2.isStatic(Gr) ? m2.getInternalName(Qe) : m2.createPropertyAccessExpression(m2.getInternalName(Qe), "prototype");
              }
              function Jn(Qe, Gr) {
                if (!Qe || !Gr || e2.some(Qe.parameters))
                  return false;
                var S2 = e2.firstOrUndefined(Qe.body.statements);
                if (!S2 || !e2.nodeIsSynthesized(S2) || S2.kind !== 238)
                  return false;
                var Ce = S2.expression;
                if (!e2.nodeIsSynthesized(Ce) || Ce.kind !== 208)
                  return false;
                var qe = Ce.expression;
                if (!e2.nodeIsSynthesized(qe) || qe.kind !== 106)
                  return false;
                var br = e2.singleOrUndefined(Ce.arguments);
                if (!br || !e2.nodeIsSynthesized(br) || br.kind !== 225)
                  return false;
                var Zr = br.expression;
                return e2.isIdentifier(Zr) && Zr.escapedText === "arguments";
              }
            }
            e2.transformES2015 = N;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w = C.factory, B = C.getCompilerOptions(), E, Q;
              (B.jsx === 1 || B.jsx === 3) && (E = C.onEmitNode, C.onEmitNode = p, C.enableEmitNotification(280), C.enableEmitNotification(281), C.enableEmitNotification(279), Q = []);
              var le = C.onSubstituteNode;
              return C.onSubstituteNode = m2, C.enableSubstitution(206), C.enableSubstitution(296), e2.chainBundle(C, N);
              function N(T) {
                return T;
              }
              function p(T, K, b) {
                switch (K.kind) {
                  case 280:
                  case 281:
                  case 279:
                    var se = K.tagName;
                    Q[e2.getOriginalNodeId(se)] = true;
                    break;
                }
                E(T, K, b);
              }
              function m2(T, K) {
                return K.id && Q && Q[K.id] ? le(T, K) : (K = le(T, K), e2.isPropertyAccessExpression(K) ? G(K) : e2.isPropertyAssignment(K) ? oe(K) : K);
              }
              function G(T) {
                if (e2.isPrivateIdentifier(T.name))
                  return T;
                var K = f4(T.name);
                return K ? e2.setTextRange(w.createElementAccessExpression(T.expression, K), T) : T;
              }
              function oe(T) {
                var K = e2.isIdentifier(T.name) && f4(T.name);
                return K ? w.updatePropertyAssignment(T, K, T.initializer) : T;
              }
              function f4(T) {
                var K = T.originalKeywordKind || (e2.nodeIsSynthesized(T) ? e2.stringToToken(e2.idText(T)) : void 0);
                if (K !== void 0 && K >= 81 && K <= 116)
                  return e2.setTextRange(w.createStringLiteralFromNode(T), T);
              }
            }
            e2.transformES5 = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(N) {
              N[N.Nop = 0] = "Nop", N[N.Statement = 1] = "Statement", N[N.Assign = 2] = "Assign", N[N.Break = 3] = "Break", N[N.BreakWhenTrue = 4] = "BreakWhenTrue", N[N.BreakWhenFalse = 5] = "BreakWhenFalse", N[N.Yield = 6] = "Yield", N[N.YieldStar = 7] = "YieldStar", N[N.Return = 8] = "Return", N[N.Throw = 9] = "Throw", N[N.Endfinally = 10] = "Endfinally";
            })(a || (a = {}));
            var C;
            (function(N) {
              N[N.Open = 0] = "Open", N[N.Close = 1] = "Close";
            })(C || (C = {}));
            var w;
            (function(N) {
              N[N.Exception = 0] = "Exception", N[N.With = 1] = "With", N[N.Switch = 2] = "Switch", N[N.Loop = 3] = "Loop", N[N.Labeled = 4] = "Labeled";
            })(w || (w = {}));
            var B;
            (function(N) {
              N[N.Try = 0] = "Try", N[N.Catch = 1] = "Catch", N[N.Finally = 2] = "Finally", N[N.Done = 3] = "Done";
            })(B || (B = {}));
            var E;
            (function(N) {
              N[N.Next = 0] = "Next", N[N.Throw = 1] = "Throw", N[N.Return = 2] = "Return", N[N.Break = 3] = "Break", N[N.Yield = 4] = "Yield", N[N.YieldStar = 5] = "YieldStar", N[N.Catch = 6] = "Catch", N[N.Endfinally = 7] = "Endfinally";
            })(E || (E = {}));
            function Q(N) {
              switch (N) {
                case 2:
                  return "return";
                case 3:
                  return "break";
                case 4:
                  return "yield";
                case 5:
                  return "yield*";
                case 7:
                  return "endfinally";
                default:
                  return;
              }
            }
            function le(N) {
              var p = N.factory, m2 = N.getEmitHelperFactory, G = N.resumeLexicalEnvironment, oe = N.endLexicalEnvironment, f4 = N.hoistFunctionDeclaration, T = N.hoistVariableDeclaration, K = N.getCompilerOptions(), b = e2.getEmitScriptTarget(K), se = N.getEmitResolver(), J = N.onSubstituteNode;
              N.onSubstituteNode = zr;
              var ie, R, q, O, ve, ee, he, F2, x2, X, $ = 1, A2, y, V, L, P = 0, k = 0, Y, U, j, H, I, l, d, D;
              return e2.chainBundle(N, fe);
              function fe(Pr) {
                if (Pr.isDeclarationFile || (Pr.transformFlags & 2048) === 0)
                  return Pr;
                var xi = e2.visitEachChild(Pr, g, N);
                return e2.addEmitHelpers(xi, N.readEmitHelpers()), xi;
              }
              function g(Pr) {
                var xi = Pr.transformFlags;
                return O ? ne(Pr) : q ? ue(Pr) : e2.isFunctionLikeDeclaration(Pr) && Pr.asteriskToken ? Fe(Pr) : xi & 2048 ? e2.visitEachChild(Pr, g, N) : Pr;
              }
              function ne(Pr) {
                switch (Pr.kind) {
                  case 240:
                    return Ur(Pr);
                  case 241:
                    return mi(Pr);
                  case 249:
                    return pi(Pr);
                  case 250:
                    return Xe(Pr);
                  default:
                    return ue(Pr);
                }
              }
              function ue(Pr) {
                switch (Pr.kind) {
                  case 256:
                    return Z2(Pr);
                  case 213:
                    return Be(Pr);
                  case 172:
                  case 173:
                    return ge(Pr);
                  case 237:
                    return ze(Pr);
                  case 242:
                    return or(Pr);
                  case 243:
                    return si(Pr);
                  case 246:
                    return et(Pr);
                  case 245:
                    return wi(Pr);
                  case 247:
                    return Wt(Pr);
                  default:
                    return Pr.transformFlags & 524288 ? We(Pr) : Pr.transformFlags & 2099200 ? e2.visitEachChild(Pr, g, N) : Pr;
                }
              }
              function We(Pr) {
                switch (Pr.kind) {
                  case 221:
                    return Ee(Pr);
                  case 351:
                    return _e(Pr);
                  case 222:
                    return de(Pr);
                  case 224:
                    return ye(Pr);
                  case 204:
                    return Ae(Pr);
                  case 205:
                    return ir(Pr);
                  case 207:
                    return Cr(Pr);
                  case 208:
                    return Ye(Pr);
                  case 209:
                    return Br(Pr);
                  default:
                    return e2.visitEachChild(Pr, g, N);
                }
              }
              function Fe(Pr) {
                switch (Pr.kind) {
                  case 256:
                    return Z2(Pr);
                  case 213:
                    return Be(Pr);
                  default:
                    return e2.Debug.failBadSyntaxKind(Pr);
                }
              }
              function Z2(Pr) {
                if (Pr.asteriskToken)
                  Pr = e2.setOriginalNode(e2.setTextRange(p.createFunctionDeclaration(void 0, Pr.modifiers, void 0, Pr.name, void 0, e2.visitParameterList(Pr.parameters, g, N), void 0, Re(Pr.body)), Pr), Pr);
                else {
                  var xi = q, St = O;
                  q = false, O = false, Pr = e2.visitEachChild(Pr, g, N), q = xi, O = St;
                }
                if (q) {
                  f4(Pr);
                  return;
                } else
                  return Pr;
              }
              function Be(Pr) {
                if (Pr.asteriskToken)
                  Pr = e2.setOriginalNode(e2.setTextRange(p.createFunctionExpression(void 0, void 0, Pr.name, void 0, e2.visitParameterList(Pr.parameters, g, N), void 0, Re(Pr.body)), Pr), Pr);
                else {
                  var xi = q, St = O;
                  q = false, O = false, Pr = e2.visitEachChild(Pr, g, N), q = xi, O = St;
                }
                return Pr;
              }
              function ge(Pr) {
                var xi = q, St = O;
                return q = false, O = false, Pr = e2.visitEachChild(Pr, g, N), q = xi, O = St, Pr;
              }
              function Re(Pr) {
                var xi = [], St = q, pa = O, dn = ve, Jn = ee, Qe = he, Gr = F2, S2 = x2, Ce = X, qe = $, br = A2, Zr = y, Si = V, Pi = L;
                q = true, O = false, ve = void 0, ee = void 0, he = void 0, F2 = void 0, x2 = void 0, X = void 0, $ = 1, A2 = void 0, y = void 0, V = void 0, L = p.createTempVariable(void 0), G();
                var Qi = p.copyPrologue(Pr.statements, xi, false, g);
                Er(Pr.statements, Qi);
                var Ct = pn();
                return e2.insertStatementsAfterStandardPrologue(xi, oe()), xi.push(p.createReturnStatement(Ct)), q = St, O = pa, ve = dn, ee = Jn, he = Qe, F2 = Gr, x2 = S2, X = Ce, $ = qe, A2 = br, y = Zr, V = Si, L = Pi, e2.setTextRange(p.createBlock(xi, Pr.multiLine), Pr);
              }
              function ze(Pr) {
                if (Pr.transformFlags & 524288) {
                  ur(Pr.declarationList);
                  return;
                } else {
                  if (e2.getEmitFlags(Pr) & 1048576)
                    return Pr;
                  for (var xi = 0, St = Pr.declarationList.declarations; xi < St.length; xi++) {
                    var pa = St[xi];
                    T(pa.name);
                  }
                  var dn = e2.getInitializedVariables(Pr.declarationList);
                  return dn.length === 0 ? void 0 : e2.setSourceMapRange(p.createExpressionStatement(p.inlineExpressions(e2.map(dn, yr))), Pr);
                }
              }
              function Ee(Pr) {
                var xi = e2.getExpressionAssociativity(Pr);
                switch (xi) {
                  case 0:
                    return rr(Pr);
                  case 1:
                    return He(Pr);
                  default:
                    return e2.Debug.assertNever(xi);
                }
              }
              function He(Pr) {
                var xi = Pr.left, St = Pr.right;
                if (Ze(St)) {
                  var pa = void 0;
                  switch (xi.kind) {
                    case 206:
                      pa = p.updatePropertyAccessExpression(xi, xe(e2.visitNode(xi.expression, g, e2.isLeftHandSideExpression)), xi.name);
                      break;
                    case 207:
                      pa = p.updateElementAccessExpression(xi, xe(e2.visitNode(xi.expression, g, e2.isLeftHandSideExpression)), xe(e2.visitNode(xi.argumentExpression, g, e2.isExpression)));
                      break;
                    default:
                      pa = e2.visitNode(xi, g, e2.isExpression);
                      break;
                  }
                  var dn = Pr.operatorToken.kind;
                  return e2.isCompoundAssignment(dn) ? e2.setTextRange(p.createAssignment(pa, e2.setTextRange(p.createBinaryExpression(xe(pa), e2.getNonAssignmentOperatorForCompoundAssignment(dn), e2.visitNode(St, g, e2.isExpression)), Pr)), Pr) : p.updateBinaryExpression(Pr, pa, Pr.operatorToken, e2.visitNode(St, g, e2.isExpression));
                }
                return e2.visitEachChild(Pr, g, N);
              }
              function rr(Pr) {
                return Ze(Pr.right) ? e2.isLogicalOperator(Pr.operatorToken.kind) ? we(Pr) : Pr.operatorToken.kind === 27 ? Ie(Pr) : p.updateBinaryExpression(Pr, xe(e2.visitNode(Pr.left, g, e2.isExpression)), Pr.operatorToken, e2.visitNode(Pr.right, g, e2.isExpression)) : e2.visitEachChild(Pr, g, N);
              }
              function Ie(Pr) {
                var xi = [];
                return St(Pr.left), St(Pr.right), p.inlineExpressions(xi);
                function St(pa) {
                  e2.isBinaryExpression(pa) && pa.operatorToken.kind === 27 ? (St(pa.left), St(pa.right)) : (Ze(pa) && xi.length > 0 && (Ba(1, [p.createExpressionStatement(p.inlineExpressions(xi))]), xi = []), xi.push(e2.visitNode(pa, g, e2.isExpression)));
                }
              }
              function _e(Pr) {
                for (var xi = [], St = 0, pa = Pr.elements; St < pa.length; St++) {
                  var dn = pa[St];
                  e2.isBinaryExpression(dn) && dn.operatorToken.kind === 27 ? xi.push(Ie(dn)) : (Ze(dn) && xi.length > 0 && (Ba(1, [p.createExpressionStatement(p.inlineExpressions(xi))]), xi = []), xi.push(e2.visitNode(dn, g, e2.isExpression)));
                }
                return p.inlineExpressions(xi);
              }
              function we(Pr) {
                var xi = mr(), St = vr();
                return Vi(St, e2.visitNode(Pr.left, g, e2.isExpression), Pr.left), Pr.operatorToken.kind === 55 ? ba(xi, St, Pr.left) : At(xi, St, Pr.left), Vi(St, e2.visitNode(Pr.right, g, e2.isExpression), Pr.right), Ar(xi), St;
              }
              function de(Pr) {
                if (Ze(Pr.whenTrue) || Ze(Pr.whenFalse)) {
                  var xi = mr(), St = mr(), pa = vr();
                  return ba(xi, e2.visitNode(Pr.condition, g, e2.isExpression), Pr.condition), Vi(pa, e2.visitNode(Pr.whenTrue, g, e2.isExpression), Pr.whenTrue), at(St), Ar(xi), Vi(pa, e2.visitNode(Pr.whenFalse, g, e2.isExpression), Pr.whenFalse), Ar(St), pa;
                }
                return e2.visitEachChild(Pr, g, N);
              }
              function ye(Pr) {
                var xi = mr(), St = e2.visitNode(Pr.expression, g, e2.isExpression);
                if (Pr.asteriskToken) {
                  var pa = (e2.getEmitFlags(Pr.expression) & 8388608) === 0 ? e2.setTextRange(m2().createValuesHelper(St), Pr) : St;
                  $a(pa, Pr);
                } else
                  Qa(St, Pr);
                return Ar(xi), Ai(Pr);
              }
              function Ae(Pr) {
                return er(Pr.elements, void 0, void 0, Pr.multiLine);
              }
              function er(Pr, xi, St, pa) {
                var dn = Sr(Pr), Jn;
                if (dn > 0) {
                  Jn = vr();
                  var Qe = e2.visitNodes(Pr, g, e2.isExpression, 0, dn);
                  Vi(Jn, p.createArrayLiteralExpression(xi ? Ve([xi], Qe, true) : Qe)), xi = void 0;
                }
                var Gr = e2.reduceLeft(Pr, S2, [], dn);
                return Jn ? p.createArrayConcatCall(Jn, [p.createArrayLiteralExpression(Gr, pa)]) : e2.setTextRange(p.createArrayLiteralExpression(xi ? Ve([xi], Gr, true) : Gr, pa), St);
                function S2(Ce, qe) {
                  if (Ze(qe) && Ce.length > 0) {
                    var br = Jn !== void 0;
                    Jn || (Jn = vr()), Vi(Jn, br ? p.createArrayConcatCall(Jn, [p.createArrayLiteralExpression(Ce, pa)]) : p.createArrayLiteralExpression(xi ? Ve([xi], Ce, true) : Ce, pa)), xi = void 0, Ce = [];
                  }
                  return Ce.push(e2.visitNode(qe, g, e2.isExpression)), Ce;
                }
              }
              function ir(Pr) {
                var xi = Pr.properties, St = Pr.multiLine, pa = Sr(xi), dn = vr();
                Vi(dn, p.createObjectLiteralExpression(e2.visitNodes(xi, g, e2.isObjectLiteralElementLike, 0, pa), St));
                var Jn = e2.reduceLeft(xi, Qe, [], pa);
                return Jn.push(St ? e2.startOnNewLine(e2.setParent(e2.setTextRange(p.cloneNode(dn), dn), dn.parent)) : dn), p.inlineExpressions(Jn);
                function Qe(Gr, S2) {
                  Ze(S2) && Gr.length > 0 && (ji(p.createExpressionStatement(p.inlineExpressions(Gr))), Gr = []);
                  var Ce = e2.createExpressionForObjectLiteralElementLike(p, Pr, S2, dn), qe = e2.visitNode(Ce, g, e2.isExpression);
                  return qe && (St && e2.startOnNewLine(qe), Gr.push(qe)), Gr;
                }
              }
              function Cr(Pr) {
                return Ze(Pr.argumentExpression) ? p.updateElementAccessExpression(Pr, xe(e2.visitNode(Pr.expression, g, e2.isLeftHandSideExpression)), e2.visitNode(Pr.argumentExpression, g, e2.isExpression)) : e2.visitEachChild(Pr, g, N);
              }
              function Ye(Pr) {
                if (!e2.isImportCall(Pr) && e2.forEach(Pr.arguments, Ze)) {
                  var xi = p.createCallBinding(Pr.expression, T, b, true), St = xi.target, pa = xi.thisArg;
                  return e2.setOriginalNode(e2.setTextRange(p.createFunctionApplyCall(xe(e2.visitNode(St, g, e2.isLeftHandSideExpression)), pa, er(Pr.arguments)), Pr), Pr);
                }
                return e2.visitEachChild(Pr, g, N);
              }
              function Br(Pr) {
                if (e2.forEach(Pr.arguments, Ze)) {
                  var xi = p.createCallBinding(p.createPropertyAccessExpression(Pr.expression, "bind"), T), St = xi.target, pa = xi.thisArg;
                  return e2.setOriginalNode(e2.setTextRange(p.createNewExpression(p.createFunctionApplyCall(xe(e2.visitNode(St, g, e2.isExpression)), pa, er(Pr.arguments, p.createVoidZero())), void 0, []), Pr), Pr);
                }
                return e2.visitEachChild(Pr, g, N);
              }
              function Er(Pr, xi) {
                xi === void 0 && (xi = 0);
                for (var St = Pr.length, pa = xi; pa < St; pa++)
                  n(Pr[pa]);
              }
              function Ne(Pr) {
                e2.isBlock(Pr) ? Er(Pr.statements) : n(Pr);
              }
              function n(Pr) {
                var xi = O;
                O || (O = Ze(Pr)), lr(Pr), O = xi;
              }
              function lr(Pr) {
                switch (Pr.kind) {
                  case 235:
                    return be(Pr);
                  case 238:
                    return Ge(Pr);
                  case 239:
                    return Ir(Pr);
                  case 240:
                    return wr(Pr);
                  case 241:
                    return ii(Pr);
                  case 242:
                    return pe(Pr);
                  case 243:
                    return qr(Pr);
                  case 245:
                    return Di(Pr);
                  case 246:
                    return Xi(Pr);
                  case 247:
                    return Gi(Pr);
                  case 248:
                    return Zt(Pr);
                  case 249:
                    return _r(Pr);
                  case 250:
                    return ae(Pr);
                  case 251:
                    return Jr(Pr);
                  case 252:
                    return ti(Pr);
                  default:
                    return ji(e2.visitNode(Pr, g, e2.isStatement));
                }
              }
              function be(Pr) {
                Ze(Pr) ? Er(Pr.statements) : ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function Ge(Pr) {
                ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function ur(Pr) {
                for (var xi = 0, St = Pr.declarations; xi < St.length; xi++) {
                  var pa = St[xi], dn = p.cloneNode(pa.name);
                  e2.setCommentRange(dn, pa.name), T(dn);
                }
                for (var Jn = e2.getInitializedVariables(Pr), Qe = Jn.length, Gr = 0, S2 = []; Gr < Qe; ) {
                  for (var Ce = Gr; Ce < Qe; Ce++) {
                    var pa = Jn[Ce];
                    if (Ze(pa.initializer) && S2.length > 0)
                      break;
                    S2.push(yr(pa));
                  }
                  S2.length && (ji(p.createExpressionStatement(p.inlineExpressions(S2))), Gr += S2.length, S2 = []);
                }
              }
              function yr(Pr) {
                return e2.setSourceMapRange(p.createAssignment(e2.setSourceMapRange(p.cloneNode(Pr.name), Pr.name), e2.visitNode(Pr.initializer, g, e2.isExpression)), Pr);
              }
              function Ir(Pr) {
                if (Ze(Pr))
                  if (Ze(Pr.thenStatement) || Ze(Pr.elseStatement)) {
                    var xi = mr(), St = Pr.elseStatement ? mr() : void 0;
                    ba(Pr.elseStatement ? St : xi, e2.visitNode(Pr.expression, g, e2.isExpression), Pr.expression), Ne(Pr.thenStatement), Pr.elseStatement && (at(xi), Ar(St), Ne(Pr.elseStatement)), Ar(xi);
                  } else
                    ji(e2.visitNode(Pr, g, e2.isStatement));
                else
                  ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function wr(Pr) {
                if (Ze(Pr)) {
                  var xi = mr(), St = mr();
                  Ui(xi), Ar(St), Ne(Pr.statement), Ar(xi), At(St, e2.visitNode(Pr.expression, g, e2.isExpression)), Yi();
                } else
                  ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function Ur(Pr) {
                return O ? (vi(), Pr = e2.visitEachChild(Pr, g, N), Yi(), Pr) : e2.visitEachChild(Pr, g, N);
              }
              function ii(Pr) {
                if (Ze(Pr)) {
                  var xi = mr(), St = Ui(xi);
                  Ar(xi), ba(St, e2.visitNode(Pr.expression, g, e2.isExpression)), Ne(Pr.statement), at(xi), Yi();
                } else
                  ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function mi(Pr) {
                return O ? (vi(), Pr = e2.visitEachChild(Pr, g, N), Yi(), Pr) : e2.visitEachChild(Pr, g, N);
              }
              function pe(Pr) {
                if (Ze(Pr)) {
                  var xi = mr(), St = mr(), pa = Ui(St);
                  if (Pr.initializer) {
                    var dn = Pr.initializer;
                    e2.isVariableDeclarationList(dn) ? ur(dn) : ji(e2.setTextRange(p.createExpressionStatement(e2.visitNode(dn, g, e2.isExpression)), dn));
                  }
                  Ar(xi), Pr.condition && ba(pa, e2.visitNode(Pr.condition, g, e2.isExpression)), Ne(Pr.statement), Ar(St), Pr.incrementor && ji(e2.setTextRange(p.createExpressionStatement(e2.visitNode(Pr.incrementor, g, e2.isExpression)), Pr.incrementor)), at(xi), Yi();
                } else
                  ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function or(Pr) {
                O && vi();
                var xi = Pr.initializer;
                if (xi && e2.isVariableDeclarationList(xi)) {
                  for (var St = 0, pa = xi.declarations; St < pa.length; St++) {
                    var dn = pa[St];
                    T(dn.name);
                  }
                  var Jn = e2.getInitializedVariables(xi);
                  Pr = p.updateForStatement(Pr, Jn.length > 0 ? p.inlineExpressions(e2.map(Jn, yr)) : void 0, e2.visitNode(Pr.condition, g, e2.isExpression), e2.visitNode(Pr.incrementor, g, e2.isExpression), e2.visitIterationBody(Pr.statement, g, N));
                } else
                  Pr = e2.visitEachChild(Pr, g, N);
                return O && Yi(), Pr;
              }
              function qr(Pr) {
                if (Ze(Pr)) {
                  var xi = vr(), St = vr(), pa = p.createLoopVariable(), dn = Pr.initializer;
                  T(pa), Vi(xi, p.createArrayLiteralExpression()), ji(p.createForInStatement(St, e2.visitNode(Pr.expression, g, e2.isExpression), p.createExpressionStatement(p.createCallExpression(p.createPropertyAccessExpression(xi, "push"), void 0, [St])))), Vi(pa, p.createNumericLiteral(0));
                  var Jn = mr(), Qe = mr(), Gr = Ui(Qe);
                  Ar(Jn), ba(Gr, p.createLessThan(pa, p.createPropertyAccessExpression(xi, "length")));
                  var S2 = void 0;
                  if (e2.isVariableDeclarationList(dn)) {
                    for (var Ce = 0, qe = dn.declarations; Ce < qe.length; Ce++) {
                      var br = qe[Ce];
                      T(br.name);
                    }
                    S2 = p.cloneNode(dn.declarations[0].name);
                  } else
                    S2 = e2.visitNode(dn, g, e2.isExpression), e2.Debug.assert(e2.isLeftHandSideExpression(S2));
                  Vi(S2, p.createElementAccessExpression(xi, pa)), Ne(Pr.statement), Ar(Qe), ji(p.createExpressionStatement(p.createPostfixIncrement(pa))), at(Jn), Yi();
                } else
                  ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function si(Pr) {
                O && vi();
                var xi = Pr.initializer;
                if (e2.isVariableDeclarationList(xi)) {
                  for (var St = 0, pa = xi.declarations; St < pa.length; St++) {
                    var dn = pa[St];
                    T(dn.name);
                  }
                  Pr = p.updateForInStatement(Pr, xi.declarations[0].name, e2.visitNode(Pr.expression, g, e2.isExpression), e2.visitNode(Pr.statement, g, e2.isStatement, p.liftToBlock));
                } else
                  Pr = e2.visitEachChild(Pr, g, N);
                return O && Yi(), Pr;
              }
              function Di(Pr) {
                var xi = Fi(Pr.label ? e2.idText(Pr.label) : void 0);
                xi > 0 ? at(xi, Pr) : ji(Pr);
              }
              function wi(Pr) {
                if (O) {
                  var xi = Fi(Pr.label && e2.idText(Pr.label));
                  if (xi > 0)
                    return wt(xi, Pr);
                }
                return e2.visitEachChild(Pr, g, N);
              }
              function Xi(Pr) {
                var xi = Ki(Pr.label ? e2.idText(Pr.label) : void 0);
                xi > 0 ? at(xi, Pr) : ji(Pr);
              }
              function et(Pr) {
                if (O) {
                  var xi = Ki(Pr.label && e2.idText(Pr.label));
                  if (xi > 0)
                    return wt(xi, Pr);
                }
                return e2.visitEachChild(Pr, g, N);
              }
              function Gi(Pr) {
                ai(e2.visitNode(Pr.expression, g, e2.isExpression), Pr);
              }
              function Wt(Pr) {
                return na(e2.visitNode(Pr.expression, g, e2.isExpression), Pr);
              }
              function Zt(Pr) {
                Ze(Pr) ? (Ue(xe(e2.visitNode(Pr.expression, g, e2.isExpression))), Ne(Pr.statement), fr()) : ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function _r(Pr) {
                if (Ze(Pr.caseBlock)) {
                  for (var xi = Pr.caseBlock, St = xi.clauses.length, pa = ct(), dn = xe(e2.visitNode(Pr.expression, g, e2.isExpression)), Jn = [], Qe = -1, Gr = 0; Gr < St; Gr++) {
                    var S2 = xi.clauses[Gr];
                    Jn.push(mr()), S2.kind === 290 && Qe === -1 && (Qe = Gr);
                  }
                  for (var Ce = 0, qe = []; Ce < St; ) {
                    for (var br = 0, Gr = Ce; Gr < St; Gr++) {
                      var S2 = xi.clauses[Gr];
                      if (S2.kind === 289) {
                        if (Ze(S2.expression) && qe.length > 0)
                          break;
                        qe.push(p.createCaseClause(e2.visitNode(S2.expression, g, e2.isExpression), [wt(Jn[Gr], S2.expression)]));
                      } else
                        br++;
                    }
                    qe.length && (ji(p.createSwitchStatement(dn, p.createCaseBlock(qe))), Ce += qe.length, qe = []), br > 0 && (Ce += br, br = 0);
                  }
                  Qe >= 0 ? at(Jn[Qe]) : at(pa);
                  for (var Gr = 0; Gr < St; Gr++)
                    Ar(Jn[Gr]), Er(xi.clauses[Gr].statements);
                  Li();
                } else
                  ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function pi(Pr) {
                return O && Wi(), Pr = e2.visitEachChild(Pr, g, N), O && Li(), Pr;
              }
              function ae(Pr) {
                Ze(Pr) ? (Mt(e2.idText(Pr.label)), Ne(Pr.statement), xt()) : ji(e2.visitNode(Pr, g, e2.isStatement));
              }
              function Xe(Pr) {
                return O && nt(e2.idText(Pr.label)), Pr = e2.visitEachChild(Pr, g, N), O && xt(), Pr;
              }
              function Jr(Pr) {
                var xi;
                Dn(e2.visitNode((xi = Pr.expression) !== null && xi !== void 0 ? xi : p.createVoidZero(), g, e2.isExpression), Pr);
              }
              function ti(Pr) {
                Ze(Pr) ? (De(), Ne(Pr.tryBlock), Pr.catchClause && (gr(Pr.catchClause.variableDeclaration), Ne(Pr.catchClause.block)), Pr.finallyBlock && (Vr(), Ne(Pr.finallyBlock)), Tr()) : ji(e2.visitEachChild(Pr, g, N));
              }
              function Ze(Pr) {
                return !!Pr && (Pr.transformFlags & 524288) !== 0;
              }
              function Sr(Pr) {
                for (var xi = Pr.length, St = 0; St < xi; St++)
                  if (Ze(Pr[St]))
                    return St;
                return -1;
              }
              function zr(Pr, xi) {
                return xi = J(Pr, xi), Pr === 1 ? Wr(xi) : xi;
              }
              function Wr(Pr) {
                return e2.isIdentifier(Pr) ? Je(Pr) : Pr;
              }
              function Je(Pr) {
                if (!e2.isGeneratedIdentifier(Pr) && ie && ie.has(e2.idText(Pr))) {
                  var xi = e2.getOriginalNode(Pr);
                  if (e2.isIdentifier(xi) && xi.parent) {
                    var St = se.getReferencedValueDeclaration(xi);
                    if (St) {
                      var pa = R[e2.getOriginalNodeId(St)];
                      if (pa) {
                        var dn = e2.setParent(e2.setTextRange(p.cloneNode(pa), pa), pa.parent);
                        return e2.setSourceMapRange(dn, Pr), e2.setCommentRange(dn, Pr), dn;
                      }
                    }
                  }
                }
                return Pr;
              }
              function xe(Pr) {
                if (e2.isGeneratedIdentifier(Pr) || e2.getEmitFlags(Pr) & 4096)
                  return Pr;
                var xi = p.createTempVariable(T);
                return Vi(xi, Pr, Pr), xi;
              }
              function vr(Pr) {
                var xi = Pr ? p.createUniqueName(Pr) : p.createTempVariable(void 0);
                return T(xi), xi;
              }
              function mr() {
                x2 || (x2 = []);
                var Pr = $;
                return $++, x2[Pr] = -1, Pr;
              }
              function Ar(Pr) {
                e2.Debug.assert(x2 !== void 0, "No labels were defined."), x2[Pr] = A2 ? A2.length : 0;
              }
              function Oe(Pr) {
                ve || (ve = [], he = [], ee = [], F2 = []);
                var xi = he.length;
                return he[xi] = 0, ee[xi] = A2 ? A2.length : 0, ve[xi] = Pr, F2.push(Pr), xi;
              }
              function nr() {
                var Pr = Mr();
                if (Pr === void 0)
                  return e2.Debug.fail("beginBlock was never called.");
                var xi = he.length;
                return he[xi] = 1, ee[xi] = A2 ? A2.length : 0, ve[xi] = Pr, F2.pop(), Pr;
              }
              function Mr() {
                return e2.lastOrUndefined(F2);
              }
              function Pe() {
                var Pr = Mr();
                return Pr && Pr.kind;
              }
              function Ue(Pr) {
                var xi = mr(), St = mr();
                Ar(xi), Oe({ kind: 1, expression: Pr, startLabel: xi, endLabel: St });
              }
              function fr() {
                e2.Debug.assert(Pe() === 1);
                var Pr = nr();
                Ar(Pr.endLabel);
              }
              function De() {
                var Pr = mr(), xi = mr();
                return Ar(Pr), Oe({ kind: 0, state: 0, startLabel: Pr, endLabel: xi }), Oi(), xi;
              }
              function gr(Pr) {
                e2.Debug.assert(Pe() === 0);
                var xi;
                if (e2.isGeneratedIdentifier(Pr.name))
                  xi = Pr.name, T(Pr.name);
                else {
                  var St = e2.idText(Pr.name);
                  xi = vr(St), ie || (ie = new e2.Map(), R = [], N.enableSubstitution(79)), ie.set(St, true), R[e2.getOriginalNodeId(Pr)] = xi;
                }
                var pa = Mr();
                e2.Debug.assert(pa.state < 1);
                var dn = pa.endLabel;
                at(dn);
                var Jn = mr();
                Ar(Jn), pa.state = 1, pa.catchVariable = xi, pa.catchLabel = Jn, Vi(xi, p.createCallExpression(p.createPropertyAccessExpression(L, "sent"), void 0, [])), Oi();
              }
              function Vr() {
                e2.Debug.assert(Pe() === 0);
                var Pr = Mr();
                e2.Debug.assert(Pr.state < 2);
                var xi = Pr.endLabel;
                at(xi);
                var St = mr();
                Ar(St), Pr.state = 2, Pr.finallyLabel = St;
              }
              function Tr() {
                e2.Debug.assert(Pe() === 0);
                var Pr = nr(), xi = Pr.state;
                xi < 2 ? at(Pr.endLabel) : ka(), Ar(Pr.endLabel), Oi(), Pr.state = 3;
              }
              function vi() {
                Oe({ kind: 3, isScript: true, breakLabel: -1, continueLabel: -1 });
              }
              function Ui(Pr) {
                var xi = mr();
                return Oe({ kind: 3, isScript: false, breakLabel: xi, continueLabel: Pr }), xi;
              }
              function Yi() {
                e2.Debug.assert(Pe() === 3);
                var Pr = nr(), xi = Pr.breakLabel;
                Pr.isScript || Ar(xi);
              }
              function Wi() {
                Oe({ kind: 2, isScript: true, breakLabel: -1 });
              }
              function ct() {
                var Pr = mr();
                return Oe({ kind: 2, isScript: false, breakLabel: Pr }), Pr;
              }
              function Li() {
                e2.Debug.assert(Pe() === 2);
                var Pr = nr(), xi = Pr.breakLabel;
                Pr.isScript || Ar(xi);
              }
              function nt(Pr) {
                Oe({ kind: 4, isScript: true, labelText: Pr, breakLabel: -1 });
              }
              function Mt(Pr) {
                var xi = mr();
                Oe({ kind: 4, isScript: false, labelText: Pr, breakLabel: xi });
              }
              function xt() {
                e2.Debug.assert(Pe() === 4);
                var Pr = nr();
                Pr.isScript || Ar(Pr.breakLabel);
              }
              function ut(Pr) {
                return Pr.kind === 2 || Pr.kind === 3;
              }
              function Dt(Pr) {
                return Pr.kind === 4;
              }
              function Rt(Pr) {
                return Pr.kind === 3;
              }
              function Ii(Pr, xi) {
                for (var St = xi; St >= 0; St--) {
                  var pa = F2[St];
                  if (Dt(pa)) {
                    if (pa.labelText === Pr)
                      return true;
                  } else
                    break;
                }
                return false;
              }
              function Ki(Pr) {
                if (F2)
                  if (Pr)
                    for (var xi = F2.length - 1; xi >= 0; xi--) {
                      var St = F2[xi];
                      if (Dt(St) && St.labelText === Pr)
                        return St.breakLabel;
                      if (ut(St) && Ii(Pr, xi - 1))
                        return St.breakLabel;
                    }
                  else
                    for (var xi = F2.length - 1; xi >= 0; xi--) {
                      var St = F2[xi];
                      if (ut(St))
                        return St.breakLabel;
                    }
                return 0;
              }
              function Fi(Pr) {
                if (F2)
                  if (Pr)
                    for (var xi = F2.length - 1; xi >= 0; xi--) {
                      var St = F2[xi];
                      if (Rt(St) && Ii(Pr, xi - 1))
                        return St.continueLabel;
                    }
                  else
                    for (var xi = F2.length - 1; xi >= 0; xi--) {
                      var St = F2[xi];
                      if (Rt(St))
                        return St.continueLabel;
                    }
                return 0;
              }
              function ui(Pr) {
                if (Pr !== void 0 && Pr > 0) {
                  X === void 0 && (X = []);
                  var xi = p.createNumericLiteral(-1);
                  return X[Pr] === void 0 ? X[Pr] = [xi] : X[Pr].push(xi), xi;
                }
                return p.createOmittedExpression();
              }
              function Bt(Pr) {
                var xi = p.createNumericLiteral(Pr);
                return e2.addSyntheticTrailingComment(xi, 3, Q(Pr)), xi;
              }
              function wt(Pr, xi) {
                return e2.Debug.assertLessThan(0, Pr, "Invalid label"), e2.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(3), ui(Pr)])), xi);
              }
              function na(Pr, xi) {
                return e2.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression(Pr ? [Bt(2), Pr] : [Bt(2)])), xi);
              }
              function Ai(Pr) {
                return e2.setTextRange(p.createCallExpression(p.createPropertyAccessExpression(L, "sent"), void 0, []), Pr);
              }
              function Oi() {
                Ba(0);
              }
              function ji(Pr) {
                Pr ? Ba(1, [Pr]) : Oi();
              }
              function Vi(Pr, xi, St) {
                Ba(2, [Pr, xi], St);
              }
              function at(Pr, xi) {
                Ba(3, [Pr], xi);
              }
              function At(Pr, xi, St) {
                Ba(4, [Pr, xi], St);
              }
              function ba(Pr, xi, St) {
                Ba(5, [Pr, xi], St);
              }
              function $a(Pr, xi) {
                Ba(7, [Pr], xi);
              }
              function Qa(Pr, xi) {
                Ba(6, [Pr], xi);
              }
              function ai(Pr, xi) {
                Ba(8, [Pr], xi);
              }
              function Dn(Pr, xi) {
                Ba(9, [Pr], xi);
              }
              function ka() {
                Ba(10);
              }
              function Ba(Pr, xi, St) {
                A2 === void 0 && (A2 = [], y = [], V = []), x2 === void 0 && Ar(mr());
                var pa = A2.length;
                A2[pa] = Pr, y[pa] = xi, V[pa] = St;
              }
              function pn() {
                P = 0, k = 0, Y = void 0, U = false, j = false, H = void 0, I = void 0, l = void 0, d = void 0, D = void 0;
                var Pr = Cn();
                return m2().createGeneratorHelper(e2.setEmitFlags(p.createFunctionExpression(void 0, void 0, void 0, void 0, [p.createParameterDeclaration(void 0, void 0, void 0, L)], void 0, p.createBlock(Pr, Pr.length > 0)), 524288));
              }
              function Cn() {
                if (A2) {
                  for (var Pr = 0; Pr < A2.length; Pr++)
                    Da(Pr);
                  kn(A2.length);
                } else
                  kn(0);
                if (H) {
                  var xi = p.createPropertyAccessExpression(L, "label"), St = p.createSwitchStatement(xi, p.createCaseBlock(H));
                  return [e2.startOnNewLine(St)];
                }
                return I || [];
              }
              function Bi() {
                !I || (Kn(!U), U = false, j = false, k++);
              }
              function kn(Pr) {
                xn(Pr) && (Pn(Pr), D = void 0, Wn(void 0, void 0)), I && H && Kn(false), eo();
              }
              function xn(Pr) {
                if (!j)
                  return true;
                if (!x2 || !X)
                  return false;
                for (var xi = 0; xi < x2.length; xi++)
                  if (x2[xi] === Pr && X[xi])
                    return true;
                return false;
              }
              function Kn(Pr) {
                if (H || (H = []), I) {
                  if (D)
                    for (var xi = D.length - 1; xi >= 0; xi--) {
                      var St = D[xi];
                      I = [p.createWithStatement(St.expression, p.createBlock(I))];
                    }
                  if (d) {
                    var pa = d.startLabel, dn = d.catchLabel, Jn = d.finallyLabel, Qe = d.endLabel;
                    I.unshift(p.createExpressionStatement(p.createCallExpression(p.createPropertyAccessExpression(p.createPropertyAccessExpression(L, "trys"), "push"), void 0, [p.createArrayLiteralExpression([ui(pa), ui(dn), ui(Jn), ui(Qe)])]))), d = void 0;
                  }
                  Pr && I.push(p.createExpressionStatement(p.createAssignment(p.createPropertyAccessExpression(L, "label"), p.createNumericLiteral(k + 1))));
                }
                H.push(p.createCaseClause(p.createNumericLiteral(k), I || [])), I = void 0;
              }
              function Pn(Pr) {
                if (!!x2)
                  for (var xi = 0; xi < x2.length; xi++)
                    x2[xi] === Pr && (Bi(), Y === void 0 && (Y = []), Y[k] === void 0 ? Y[k] = [xi] : Y[k].push(xi));
              }
              function eo() {
                if (X !== void 0 && Y !== void 0)
                  for (var Pr = 0; Pr < Y.length; Pr++) {
                    var xi = Y[Pr];
                    if (xi !== void 0)
                      for (var St = 0, pa = xi; St < pa.length; St++) {
                        var dn = pa[St], Jn = X[dn];
                        if (Jn !== void 0)
                          for (var Qe = 0, Gr = Jn; Qe < Gr.length; Qe++) {
                            var S2 = Gr[Qe];
                            S2.text = String(Pr);
                          }
                      }
                  }
              }
              function Rn(Pr) {
                if (ve)
                  for (; P < he.length && ee[P] <= Pr; P++) {
                    var xi = ve[P], St = he[P];
                    switch (xi.kind) {
                      case 0:
                        St === 0 ? (l || (l = []), I || (I = []), l.push(d), d = xi) : St === 1 && (d = l.pop());
                        break;
                      case 1:
                        St === 0 ? (D || (D = []), D.push(xi)) : St === 1 && D.pop();
                        break;
                    }
                  }
              }
              function Da(Pr) {
                if (Pn(Pr), Rn(Pr), !U) {
                  U = false, j = false;
                  var xi = A2[Pr];
                  if (xi !== 0) {
                    if (xi === 10)
                      return $o();
                    var St = y[Pr];
                    if (xi === 1)
                      return bo(St[0]);
                    var pa = V[Pr];
                    switch (xi) {
                      case 2:
                        return Ro(St[0], St[1], pa);
                      case 3:
                        return to(St[0], pa);
                      case 4:
                        return Co(St[0], St[1], pa);
                      case 5:
                        return Ko(St[0], St[1], pa);
                      case 6:
                        return Oo(St[0], pa);
                      case 7:
                        return no(St[0], pa);
                      case 8:
                        return Wn(St[0], pa);
                      case 9:
                        return En(St[0], pa);
                    }
                  }
                }
              }
              function bo(Pr) {
                Pr && (I ? I.push(Pr) : I = [Pr]);
              }
              function Ro(Pr, xi, St) {
                bo(e2.setTextRange(p.createExpressionStatement(p.createAssignment(Pr, xi)), St));
              }
              function En(Pr, xi) {
                U = true, j = true, bo(e2.setTextRange(p.createThrowStatement(Pr), xi));
              }
              function Wn(Pr, xi) {
                U = true, j = true, bo(e2.setEmitFlags(e2.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression(Pr ? [Bt(2), Pr] : [Bt(2)])), xi), 384));
              }
              function to(Pr, xi) {
                U = true, bo(e2.setEmitFlags(e2.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(3), ui(Pr)])), xi), 384));
              }
              function Co(Pr, xi, St) {
                bo(e2.setEmitFlags(p.createIfStatement(xi, e2.setEmitFlags(e2.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(3), ui(Pr)])), St), 384)), 1));
              }
              function Ko(Pr, xi, St) {
                bo(e2.setEmitFlags(p.createIfStatement(p.createLogicalNot(xi), e2.setEmitFlags(e2.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(3), ui(Pr)])), St), 384)), 1));
              }
              function Oo(Pr, xi) {
                U = true, bo(e2.setEmitFlags(e2.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression(Pr ? [Bt(4), Pr] : [Bt(4)])), xi), 384));
              }
              function no(Pr, xi) {
                U = true, bo(e2.setEmitFlags(e2.setTextRange(p.createReturnStatement(p.createArrayLiteralExpression([Bt(5), Pr])), xi), 384));
              }
              function $o() {
                U = true, bo(p.createReturnStatement(p.createArrayLiteralExpression([Bt(7)])));
              }
            }
            e2.transformGenerators = le;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(w) {
              function B(pe) {
                switch (pe) {
                  case e2.ModuleKind.AMD:
                    return F2;
                  case e2.ModuleKind.UMD:
                    return x2;
                  default:
                    return he;
                }
              }
              var E = w.factory, Q = w.getEmitHelperFactory, le = w.startLexicalEnvironment, N = w.endLexicalEnvironment, p = w.hoistVariableDeclaration, m2 = w.getCompilerOptions(), G = w.getEmitResolver(), oe = w.getEmitHost(), f4 = e2.getEmitScriptTarget(m2), T = e2.getEmitModuleKind(m2), K = w.onSubstituteNode, b = w.onEmitNode;
              w.onSubstituteNode = Ge, w.onEmitNode = be, w.enableSubstitution(208), w.enableSubstitution(210), w.enableSubstitution(79), w.enableSubstitution(221), w.enableSubstitution(297), w.enableEmitNotification(305);
              var se = [], J = [], ie, R, q = [], O;
              return e2.chainBundle(w, ve);
              function ve(pe) {
                if (pe.isDeclarationFile || !(e2.isEffectiveExternalModule(pe, m2) || pe.transformFlags & 4194304 || e2.isJsonSourceFile(pe) && e2.hasJsonModuleEmitEnabled(m2) && e2.outFile(m2)))
                  return pe;
                ie = pe, R = e2.collectExternalModuleInfo(w, pe, G, m2), se[e2.getOriginalNodeId(pe)] = R;
                var or = B(T), qr = or(pe);
                return ie = void 0, R = void 0, O = false, qr;
              }
              function ee() {
                return !!(!R.exportEquals && e2.isExternalModule(ie));
              }
              function he(pe) {
                le();
                var or = [], qr = e2.getStrictOptionValue(m2, "alwaysStrict") || !m2.noImplicitUseStrict && e2.isExternalModule(ie), si = E.copyPrologue(pe.statements, or, qr && !e2.isJsonSourceFile(pe), V);
                if (ee() && e2.append(or, Er()), e2.length(R.exportedNames))
                  for (var Di = 50, wi = 0; wi < R.exportedNames.length; wi += Di)
                    e2.append(or, E.createExpressionStatement(e2.reduceLeft(R.exportedNames.slice(wi, wi + Di), function(et, Gi) {
                      return E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("exports"), E.createIdentifier(e2.idText(Gi))), et);
                    }, E.createVoidZero())));
                e2.append(or, e2.visitNode(R.externalHelpersImportDeclaration, V, e2.isStatement)), e2.addRange(or, e2.visitNodes(pe.statements, V, e2.isStatement, si)), y(or, false), e2.insertStatementsAfterStandardPrologue(or, N());
                var Xi = E.updateSourceFile(pe, e2.setTextRange(E.createNodeArray(or), pe.statements));
                return e2.addEmitHelpers(Xi, w.readEmitHelpers()), Xi;
              }
              function F2(pe) {
                var or = E.createIdentifier("define"), qr = e2.tryGetModuleNameFromFile(E, pe, oe, m2), si = e2.isJsonSourceFile(pe) && pe, Di = X(pe, true), wi = Di.aliasedModuleNames, Xi = Di.unaliasedModuleNames, et = Di.importAliasNames, Gi = E.updateSourceFile(pe, e2.setTextRange(E.createNodeArray([E.createExpressionStatement(E.createCallExpression(or, void 0, Ve(Ve([], qr ? [qr] : [], true), [E.createArrayLiteralExpression(si ? e2.emptyArray : Ve(Ve([E.createStringLiteral("require"), E.createStringLiteral("exports")], wi, true), Xi, true)), si ? si.statements.length ? si.statements[0].expression : E.createObjectLiteralExpression() : E.createFunctionExpression(void 0, void 0, void 0, void 0, Ve([E.createParameterDeclaration(void 0, void 0, void 0, "require"), E.createParameterDeclaration(void 0, void 0, void 0, "exports")], et, true), void 0, A2(pe))], false)))]), pe.statements));
                return e2.addEmitHelpers(Gi, w.readEmitHelpers()), Gi;
              }
              function x2(pe) {
                var or = X(pe, false), qr = or.aliasedModuleNames, si = or.unaliasedModuleNames, Di = or.importAliasNames, wi = e2.tryGetModuleNameFromFile(E, pe, oe, m2), Xi = E.createFunctionExpression(void 0, void 0, void 0, void 0, [E.createParameterDeclaration(void 0, void 0, void 0, "factory")], void 0, e2.setTextRange(E.createBlock([E.createIfStatement(E.createLogicalAnd(E.createTypeCheck(E.createIdentifier("module"), "object"), E.createTypeCheck(E.createPropertyAccessExpression(E.createIdentifier("module"), "exports"), "object")), E.createBlock([E.createVariableStatement(void 0, [E.createVariableDeclaration("v", void 0, void 0, E.createCallExpression(E.createIdentifier("factory"), void 0, [E.createIdentifier("require"), E.createIdentifier("exports")]))]), e2.setEmitFlags(E.createIfStatement(E.createStrictInequality(E.createIdentifier("v"), E.createIdentifier("undefined")), E.createExpressionStatement(E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("module"), "exports"), E.createIdentifier("v")))), 1)]), E.createIfStatement(E.createLogicalAnd(E.createTypeCheck(E.createIdentifier("define"), "function"), E.createPropertyAccessExpression(E.createIdentifier("define"), "amd")), E.createBlock([E.createExpressionStatement(E.createCallExpression(E.createIdentifier("define"), void 0, Ve(Ve([], wi ? [wi] : [], true), [E.createArrayLiteralExpression(Ve(Ve([E.createStringLiteral("require"), E.createStringLiteral("exports")], qr, true), si, true)), E.createIdentifier("factory")], false)))])))], true), void 0)), et = E.updateSourceFile(pe, e2.setTextRange(E.createNodeArray([E.createExpressionStatement(E.createCallExpression(Xi, void 0, [E.createFunctionExpression(void 0, void 0, void 0, void 0, Ve([E.createParameterDeclaration(void 0, void 0, void 0, "require"), E.createParameterDeclaration(void 0, void 0, void 0, "exports")], Di, true), void 0, A2(pe))]))]), pe.statements));
                return e2.addEmitHelpers(et, w.readEmitHelpers()), et;
              }
              function X(pe, or) {
                for (var qr = [], si = [], Di = [], wi = 0, Xi = pe.amdDependencies; wi < Xi.length; wi++) {
                  var et = Xi[wi];
                  et.name ? (qr.push(E.createStringLiteral(et.path)), Di.push(E.createParameterDeclaration(void 0, void 0, void 0, et.name))) : si.push(E.createStringLiteral(et.path));
                }
                for (var Gi = 0, Wt = R.externalImports; Gi < Wt.length; Gi++) {
                  var Zt = Wt[Gi], _r = e2.getExternalModuleNameLiteral(E, Zt, ie, oe, G, m2), pi = e2.getLocalNameForExternalImport(E, Zt, ie);
                  _r && (or && pi ? (e2.setEmitFlags(pi, 4), qr.push(_r), Di.push(E.createParameterDeclaration(void 0, void 0, void 0, pi))) : si.push(_r));
                }
                return { aliasedModuleNames: qr, unaliasedModuleNames: si, importAliasNames: Di };
              }
              function $(pe) {
                if (!(e2.isImportEqualsDeclaration(pe) || e2.isExportDeclaration(pe) || !e2.getExternalModuleNameLiteral(E, pe, ie, oe, G, m2))) {
                  var or = e2.getLocalNameForExternalImport(E, pe, ie), qr = We(pe, or);
                  if (qr !== or)
                    return E.createExpressionStatement(E.createAssignment(or, qr));
                }
              }
              function A2(pe) {
                le();
                var or = [], qr = E.copyPrologue(pe.statements, or, !m2.noImplicitUseStrict, V);
                ee() && e2.append(or, Er()), e2.length(R.exportedNames) && e2.append(or, E.createExpressionStatement(e2.reduceLeft(R.exportedNames, function(Di, wi) {
                  return E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("exports"), E.createIdentifier(e2.idText(wi))), Di);
                }, E.createVoidZero()))), e2.append(or, e2.visitNode(R.externalHelpersImportDeclaration, V, e2.isStatement)), T === e2.ModuleKind.AMD && e2.addRange(or, e2.mapDefined(R.externalImports, $)), e2.addRange(or, e2.visitNodes(pe.statements, V, e2.isStatement, qr)), y(or, true), e2.insertStatementsAfterStandardPrologue(or, N());
                var si = E.createBlock(or, true);
                return O && e2.addEmitHelper(si, C), si;
              }
              function y(pe, or) {
                if (R.exportEquals) {
                  var qr = e2.visitNode(R.exportEquals.expression, P);
                  if (qr)
                    if (or) {
                      var si = E.createReturnStatement(qr);
                      e2.setTextRange(si, R.exportEquals), e2.setEmitFlags(si, 1920), pe.push(si);
                    } else {
                      var si = E.createExpressionStatement(E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("module"), "exports"), qr));
                      e2.setTextRange(si, R.exportEquals), e2.setEmitFlags(si, 1536), pe.push(si);
                    }
                }
              }
              function V(pe) {
                switch (pe.kind) {
                  case 266:
                    return Fe(pe);
                  case 265:
                    return Be(pe);
                  case 272:
                    return ge(pe);
                  case 271:
                    return Re(pe);
                  case 237:
                    return He(pe);
                  case 256:
                    return ze(pe);
                  case 257:
                    return Ee(pe);
                  case 352:
                    return _e(pe);
                  case 353:
                    return de(pe);
                  default:
                    return P(pe);
                }
              }
              function L(pe, or) {
                if (!(pe.transformFlags & 71307264))
                  return pe;
                switch (pe.kind) {
                  case 242:
                    return j(pe);
                  case 238:
                    return H(pe);
                  case 212:
                    return I(pe, or);
                  case 350:
                    return l(pe, or);
                  case 208:
                    if (e2.isImportCall(pe) && ie.impliedNodeFormat === void 0)
                      return D(pe);
                    break;
                  case 221:
                    if (e2.isDestructuringAssignment(pe))
                      return U(pe, or);
                    break;
                  case 219:
                  case 220:
                    return d(pe, or);
                }
                return e2.visitEachChild(pe, P, w);
              }
              function P(pe) {
                return L(pe, false);
              }
              function k(pe) {
                return L(pe, true);
              }
              function Y(pe) {
                if (e2.isObjectLiteralExpression(pe))
                  for (var or = 0, qr = pe.properties; or < qr.length; or++) {
                    var si = qr[or];
                    switch (si.kind) {
                      case 296:
                        if (Y(si.initializer))
                          return true;
                        break;
                      case 297:
                        if (Y(si.name))
                          return true;
                        break;
                      case 298:
                        if (Y(si.expression))
                          return true;
                        break;
                      case 169:
                      case 172:
                      case 173:
                        return false;
                      default:
                        e2.Debug.assertNever(si, "Unhandled object member kind");
                    }
                  }
                else if (e2.isArrayLiteralExpression(pe))
                  for (var Di = 0, wi = pe.elements; Di < wi.length; Di++) {
                    var si = wi[Di];
                    if (e2.isSpreadElement(si)) {
                      if (Y(si.expression))
                        return true;
                    } else if (Y(si))
                      return true;
                  }
                else if (e2.isIdentifier(pe))
                  return e2.length(mi(pe)) > (e2.isExportName(pe) ? 1 : 0);
                return false;
              }
              function U(pe, or) {
                return Y(pe.left) ? e2.flattenDestructuringAssignment(pe, P, w, 0, !or, rr) : e2.visitEachChild(pe, P, w);
              }
              function j(pe) {
                return E.updateForStatement(pe, e2.visitNode(pe.initializer, k, e2.isForInitializer), e2.visitNode(pe.condition, P, e2.isExpression), e2.visitNode(pe.incrementor, k, e2.isExpression), e2.visitIterationBody(pe.statement, P, w));
              }
              function H(pe) {
                return E.updateExpressionStatement(pe, e2.visitNode(pe.expression, k, e2.isExpression));
              }
              function I(pe, or) {
                return E.updateParenthesizedExpression(pe, e2.visitNode(pe.expression, or ? k : P, e2.isExpression));
              }
              function l(pe, or) {
                return E.updatePartiallyEmittedExpression(pe, e2.visitNode(pe.expression, or ? k : P, e2.isExpression));
              }
              function d(pe, or) {
                if ((pe.operator === 45 || pe.operator === 46) && e2.isIdentifier(pe.operand) && !e2.isGeneratedIdentifier(pe.operand) && !e2.isLocalName(pe.operand) && !e2.isDeclarationNameOfEnumOrNamespace(pe.operand)) {
                  var qr = mi(pe.operand);
                  if (qr) {
                    var si = void 0, Di = e2.visitNode(pe.operand, P, e2.isExpression);
                    e2.isPrefixUnaryExpression(pe) ? Di = E.updatePrefixUnaryExpression(pe, Di) : (Di = E.updatePostfixUnaryExpression(pe, Di), or || (si = E.createTempVariable(p), Di = E.createAssignment(si, Di), e2.setTextRange(Di, pe)), Di = E.createComma(Di, E.cloneNode(pe.operand)), e2.setTextRange(Di, pe));
                    for (var wi = 0, Xi = qr; wi < Xi.length; wi++) {
                      var et = Xi[wi];
                      q[e2.getNodeId(Di)] = true, Di = n(et, Di), e2.setTextRange(Di, pe);
                    }
                    return si && (q[e2.getNodeId(Di)] = true, Di = E.createComma(Di, si), e2.setTextRange(Di, pe)), Di;
                  }
                }
                return e2.visitEachChild(pe, P, w);
              }
              function D(pe) {
                var or = e2.getExternalModuleNameLiteral(E, pe, ie, oe, G, m2), qr = e2.visitNode(e2.firstOrUndefined(pe.arguments), P), si = or && (!qr || !e2.isStringLiteral(qr) || qr.text !== or.text) ? or : qr, Di = !!(pe.transformFlags & 8192);
                switch (m2.module) {
                  case e2.ModuleKind.AMD:
                    return g(si, Di);
                  case e2.ModuleKind.UMD:
                    return fe(si != null ? si : E.createVoidZero(), Di);
                  case e2.ModuleKind.CommonJS:
                  default:
                    return ne(si, Di);
                }
              }
              function fe(pe, or) {
                if (O = true, e2.isSimpleCopiableExpression(pe)) {
                  var qr = e2.isGeneratedIdentifier(pe) ? pe : e2.isStringLiteral(pe) ? E.createStringLiteralFromNode(pe) : e2.setEmitFlags(e2.setTextRange(E.cloneNode(pe), pe), 1536);
                  return E.createConditionalExpression(E.createIdentifier("__syncRequire"), void 0, ne(pe, or), void 0, g(qr, or));
                } else {
                  var si = E.createTempVariable(p);
                  return E.createComma(E.createAssignment(si, pe), E.createConditionalExpression(E.createIdentifier("__syncRequire"), void 0, ne(si, or), void 0, g(si, or)));
                }
              }
              function g(pe, or) {
                var qr = E.createUniqueName("resolve"), si = E.createUniqueName("reject"), Di = [E.createParameterDeclaration(void 0, void 0, void 0, qr), E.createParameterDeclaration(void 0, void 0, void 0, si)], wi = E.createBlock([E.createExpressionStatement(E.createCallExpression(E.createIdentifier("require"), void 0, [E.createArrayLiteralExpression([pe || E.createOmittedExpression()]), qr, si]))]), Xi;
                f4 >= 2 ? Xi = E.createArrowFunction(void 0, void 0, Di, void 0, void 0, wi) : (Xi = E.createFunctionExpression(void 0, void 0, void 0, void 0, Di, void 0, wi), or && e2.setEmitFlags(Xi, 8));
                var et = E.createNewExpression(E.createIdentifier("Promise"), void 0, [Xi]);
                return e2.getESModuleInterop(m2) ? E.createCallExpression(E.createPropertyAccessExpression(et, E.createIdentifier("then")), void 0, [Q().createImportStarCallbackHelper()]) : et;
              }
              function ne(pe, or) {
                var qr = E.createCallExpression(E.createPropertyAccessExpression(E.createIdentifier("Promise"), "resolve"), void 0, []), si = E.createCallExpression(E.createIdentifier("require"), void 0, pe ? [pe] : []);
                e2.getESModuleInterop(m2) && (si = Q().createImportStarHelper(si));
                var Di;
                return f4 >= 2 ? Di = E.createArrowFunction(void 0, void 0, [], void 0, void 0, si) : (Di = E.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, E.createBlock([E.createReturnStatement(si)])), or && e2.setEmitFlags(Di, 8)), E.createCallExpression(E.createPropertyAccessExpression(qr, "then"), void 0, [Di]);
              }
              function ue(pe, or) {
                return !e2.getESModuleInterop(m2) || e2.getEmitFlags(pe) & 67108864 ? or : e2.getExportNeedsImportStarHelper(pe) ? Q().createImportStarHelper(or) : or;
              }
              function We(pe, or) {
                return !e2.getESModuleInterop(m2) || e2.getEmitFlags(pe) & 67108864 ? or : e2.getImportNeedsImportStarHelper(pe) ? Q().createImportStarHelper(or) : e2.getImportNeedsImportDefaultHelper(pe) ? Q().createImportDefaultHelper(or) : or;
              }
              function Fe(pe) {
                var or, qr = e2.getNamespaceDeclarationNode(pe);
                if (T !== e2.ModuleKind.AMD)
                  if (pe.importClause) {
                    var si = [];
                    qr && !e2.isDefaultImport(pe) ? si.push(E.createVariableDeclaration(E.cloneNode(qr.name), void 0, void 0, We(pe, Z2(pe)))) : (si.push(E.createVariableDeclaration(E.getGeneratedNameForNode(pe), void 0, void 0, We(pe, Z2(pe)))), qr && e2.isDefaultImport(pe) && si.push(E.createVariableDeclaration(E.cloneNode(qr.name), void 0, void 0, E.getGeneratedNameForNode(pe)))), or = e2.append(or, e2.setOriginalNode(e2.setTextRange(E.createVariableStatement(void 0, E.createVariableDeclarationList(si, f4 >= 2 ? 2 : 0)), pe), pe));
                  } else
                    return e2.setOriginalNode(e2.setTextRange(E.createExpressionStatement(Z2(pe)), pe), pe);
                else
                  qr && e2.isDefaultImport(pe) && (or = e2.append(or, E.createVariableStatement(void 0, E.createVariableDeclarationList([e2.setOriginalNode(e2.setTextRange(E.createVariableDeclaration(E.cloneNode(qr.name), void 0, void 0, E.getGeneratedNameForNode(pe)), pe), pe)], f4 >= 2 ? 2 : 0))));
                if (we(pe)) {
                  var Di = e2.getOriginalNodeId(pe);
                  J[Di] = ye(J[Di], pe);
                } else
                  or = ye(or, pe);
                return e2.singleOrMany(or);
              }
              function Z2(pe) {
                var or = e2.getExternalModuleNameLiteral(E, pe, ie, oe, G, m2), qr = [];
                return or && qr.push(or), E.createCallExpression(E.createIdentifier("require"), void 0, qr);
              }
              function Be(pe) {
                e2.Debug.assert(e2.isExternalModuleImportEqualsDeclaration(pe), "import= for internal module references should be handled in an earlier transformer.");
                var or;
                if (T !== e2.ModuleKind.AMD ? e2.hasSyntacticModifier(pe, 1) ? or = e2.append(or, e2.setOriginalNode(e2.setTextRange(E.createExpressionStatement(n(pe.name, Z2(pe))), pe), pe)) : or = e2.append(or, e2.setOriginalNode(e2.setTextRange(E.createVariableStatement(void 0, E.createVariableDeclarationList([E.createVariableDeclaration(E.cloneNode(pe.name), void 0, void 0, Z2(pe))], f4 >= 2 ? 2 : 0)), pe), pe)) : e2.hasSyntacticModifier(pe, 1) && (or = e2.append(or, e2.setOriginalNode(e2.setTextRange(E.createExpressionStatement(n(E.getExportName(pe), E.getLocalName(pe))), pe), pe))), we(pe)) {
                  var qr = e2.getOriginalNodeId(pe);
                  J[qr] = Ae(J[qr], pe);
                } else
                  or = Ae(or, pe);
                return e2.singleOrMany(or);
              }
              function ge(pe) {
                if (!!pe.moduleSpecifier) {
                  var or = E.getGeneratedNameForNode(pe);
                  if (pe.exportClause && e2.isNamedExports(pe.exportClause)) {
                    var qr = [];
                    T !== e2.ModuleKind.AMD && qr.push(e2.setOriginalNode(e2.setTextRange(E.createVariableStatement(void 0, E.createVariableDeclarationList([E.createVariableDeclaration(or, void 0, void 0, Z2(pe))])), pe), pe));
                    for (var si = 0, Di = pe.exportClause.elements; si < Di.length; si++) {
                      var wi = Di[si];
                      if (f4 === 0)
                        qr.push(e2.setOriginalNode(e2.setTextRange(E.createExpressionStatement(Q().createCreateBindingHelper(or, E.createStringLiteralFromNode(wi.propertyName || wi.name), wi.propertyName ? E.createStringLiteralFromNode(wi.name) : void 0)), wi), wi));
                      else {
                        var Xi = !!e2.getESModuleInterop(m2) && !(e2.getEmitFlags(pe) & 67108864) && e2.idText(wi.propertyName || wi.name) === "default", et = E.createPropertyAccessExpression(Xi ? Q().createImportDefaultHelper(or) : or, wi.propertyName || wi.name);
                        qr.push(e2.setOriginalNode(e2.setTextRange(E.createExpressionStatement(n(E.getExportName(wi), et, void 0, true)), wi), wi));
                      }
                    }
                    return e2.singleOrMany(qr);
                  } else if (pe.exportClause) {
                    var qr = [];
                    return qr.push(e2.setOriginalNode(e2.setTextRange(E.createExpressionStatement(n(E.cloneNode(pe.exportClause.name), ue(pe, T !== e2.ModuleKind.AMD ? Z2(pe) : e2.isExportNamespaceAsDefaultDeclaration(pe) ? or : E.createIdentifier(e2.idText(pe.exportClause.name))))), pe), pe)), e2.singleOrMany(qr);
                  } else
                    return e2.setOriginalNode(e2.setTextRange(E.createExpressionStatement(Q().createExportStarHelper(T !== e2.ModuleKind.AMD ? Z2(pe) : or)), pe), pe);
                }
              }
              function Re(pe) {
                if (!pe.isExportEquals) {
                  var or, qr = pe.original;
                  if (qr && we(qr)) {
                    var si = e2.getOriginalNodeId(pe);
                    J[si] = Br(J[si], E.createIdentifier("default"), e2.visitNode(pe.expression, P), pe, true);
                  } else
                    or = Br(or, E.createIdentifier("default"), e2.visitNode(pe.expression, P), pe, true);
                  return e2.singleOrMany(or);
                }
              }
              function ze(pe) {
                var or;
                if (e2.hasSyntacticModifier(pe, 1) ? or = e2.append(or, e2.setOriginalNode(e2.setTextRange(E.createFunctionDeclaration(void 0, e2.visitNodes(pe.modifiers, lr, e2.isModifier), pe.asteriskToken, E.getDeclarationName(pe, true, true), void 0, e2.visitNodes(pe.parameters, P), void 0, e2.visitEachChild(pe.body, P, w)), pe), pe)) : or = e2.append(or, e2.visitEachChild(pe, P, w)), we(pe)) {
                  var qr = e2.getOriginalNodeId(pe);
                  J[qr] = Cr(J[qr], pe);
                } else
                  or = Cr(or, pe);
                return e2.singleOrMany(or);
              }
              function Ee(pe) {
                var or;
                if (e2.hasSyntacticModifier(pe, 1) ? or = e2.append(or, e2.setOriginalNode(e2.setTextRange(E.createClassDeclaration(void 0, e2.visitNodes(pe.modifiers, lr, e2.isModifier), E.getDeclarationName(pe, true, true), void 0, e2.visitNodes(pe.heritageClauses, P), e2.visitNodes(pe.members, P)), pe), pe)) : or = e2.append(or, e2.visitEachChild(pe, P, w)), we(pe)) {
                  var qr = e2.getOriginalNodeId(pe);
                  J[qr] = Cr(J[qr], pe);
                } else
                  or = Cr(or, pe);
                return e2.singleOrMany(or);
              }
              function He(pe) {
                var or, qr, si;
                if (e2.hasSyntacticModifier(pe, 1)) {
                  for (var Di = void 0, wi = false, Xi = 0, et = pe.declarationList.declarations; Xi < et.length; Xi++) {
                    var Gi = et[Xi];
                    if (e2.isIdentifier(Gi.name) && e2.isLocalName(Gi.name))
                      Di || (Di = e2.visitNodes(pe.modifiers, lr, e2.isModifier)), qr = e2.append(qr, Gi);
                    else if (Gi.initializer)
                      if (!e2.isBindingPattern(Gi.name) && (e2.isArrowFunction(Gi.initializer) || e2.isFunctionExpression(Gi.initializer) || e2.isClassExpression(Gi.initializer))) {
                        var Wt = E.createAssignment(e2.setTextRange(E.createPropertyAccessExpression(E.createIdentifier("exports"), Gi.name), Gi.name), E.createIdentifier(e2.getTextOfIdentifierOrLiteral(Gi.name))), Zt = E.createVariableDeclaration(Gi.name, Gi.exclamationToken, Gi.type, e2.visitNode(Gi.initializer, P));
                        qr = e2.append(qr, Zt), si = e2.append(si, Wt), wi = true;
                      } else
                        si = e2.append(si, Ie(Gi));
                  }
                  if (qr && (or = e2.append(or, E.updateVariableStatement(pe, Di, E.updateVariableDeclarationList(pe.declarationList, qr)))), si) {
                    var _r = e2.setOriginalNode(e2.setTextRange(E.createExpressionStatement(E.inlineExpressions(si)), pe), pe);
                    wi && e2.removeAllComments(_r), or = e2.append(or, _r);
                  }
                } else
                  or = e2.append(or, e2.visitEachChild(pe, P, w));
                if (we(pe)) {
                  var pi = e2.getOriginalNodeId(pe);
                  J[pi] = er(J[pi], pe);
                } else
                  or = er(or, pe);
                return e2.singleOrMany(or);
              }
              function rr(pe, or, qr) {
                var si = mi(pe);
                if (si) {
                  for (var Di = e2.isExportName(pe) ? or : E.createAssignment(pe, or), wi = 0, Xi = si; wi < Xi.length; wi++) {
                    var et = Xi[wi];
                    e2.setEmitFlags(Di, 4), Di = n(et, Di, qr);
                  }
                  return Di;
                }
                return E.createAssignment(pe, or);
              }
              function Ie(pe) {
                return e2.isBindingPattern(pe.name) ? e2.flattenDestructuringAssignment(e2.visitNode(pe, P), void 0, w, 0, false, rr) : E.createAssignment(e2.setTextRange(E.createPropertyAccessExpression(E.createIdentifier("exports"), pe.name), pe.name), pe.initializer ? e2.visitNode(pe.initializer, P) : E.createVoidZero());
              }
              function _e(pe) {
                if (we(pe) && pe.original.kind === 237) {
                  var or = e2.getOriginalNodeId(pe);
                  J[or] = er(J[or], pe.original);
                }
                return pe;
              }
              function we(pe) {
                return (e2.getEmitFlags(pe) & 4194304) !== 0;
              }
              function de(pe) {
                var or = e2.getOriginalNodeId(pe), qr = J[or];
                return qr ? (delete J[or], e2.append(qr, pe)) : pe;
              }
              function ye(pe, or) {
                if (R.exportEquals)
                  return pe;
                var qr = or.importClause;
                if (!qr)
                  return pe;
                qr.name && (pe = Ye(pe, qr));
                var si = qr.namedBindings;
                if (si)
                  switch (si.kind) {
                    case 268:
                      pe = Ye(pe, si);
                      break;
                    case 269:
                      for (var Di = 0, wi = si.elements; Di < wi.length; Di++) {
                        var Xi = wi[Di];
                        pe = Ye(pe, Xi, true);
                      }
                      break;
                  }
                return pe;
              }
              function Ae(pe, or) {
                return R.exportEquals ? pe : Ye(pe, or);
              }
              function er(pe, or) {
                if (R.exportEquals)
                  return pe;
                for (var qr = 0, si = or.declarationList.declarations; qr < si.length; qr++) {
                  var Di = si[qr];
                  pe = ir(pe, Di);
                }
                return pe;
              }
              function ir(pe, or) {
                if (R.exportEquals)
                  return pe;
                if (e2.isBindingPattern(or.name))
                  for (var qr = 0, si = or.name.elements; qr < si.length; qr++) {
                    var Di = si[qr];
                    e2.isOmittedExpression(Di) || (pe = ir(pe, Di));
                  }
                else
                  e2.isGeneratedIdentifier(or.name) || (pe = Ye(pe, or));
                return pe;
              }
              function Cr(pe, or) {
                if (R.exportEquals)
                  return pe;
                if (e2.hasSyntacticModifier(or, 1)) {
                  var qr = e2.hasSyntacticModifier(or, 512) ? E.createIdentifier("default") : E.getDeclarationName(or);
                  pe = Br(pe, qr, E.getLocalName(or), or);
                }
                return or.name && (pe = Ye(pe, or)), pe;
              }
              function Ye(pe, or, qr) {
                var si = E.getDeclarationName(or), Di = R.exportSpecifiers.get(e2.idText(si));
                if (Di)
                  for (var wi = 0, Xi = Di; wi < Xi.length; wi++) {
                    var et = Xi[wi];
                    pe = Br(pe, et.name, si, et.name, void 0, qr);
                  }
                return pe;
              }
              function Br(pe, or, qr, si, Di, wi) {
                return pe = e2.append(pe, Ne(or, qr, si, Di, wi)), pe;
              }
              function Er() {
                var pe;
                return f4 === 0 ? pe = E.createExpressionStatement(n(E.createIdentifier("__esModule"), E.createTrue())) : pe = E.createExpressionStatement(E.createCallExpression(E.createPropertyAccessExpression(E.createIdentifier("Object"), "defineProperty"), void 0, [E.createIdentifier("exports"), E.createStringLiteral("__esModule"), E.createObjectLiteralExpression([E.createPropertyAssignment("value", E.createTrue())])])), e2.setEmitFlags(pe, 1048576), pe;
              }
              function Ne(pe, or, qr, si, Di) {
                var wi = e2.setTextRange(E.createExpressionStatement(n(pe, or, void 0, Di)), qr);
                return e2.startOnNewLine(wi), si || e2.setEmitFlags(wi, 1536), wi;
              }
              function n(pe, or, qr, si) {
                return e2.setTextRange(si && f4 !== 0 ? E.createCallExpression(E.createPropertyAccessExpression(E.createIdentifier("Object"), "defineProperty"), void 0, [E.createIdentifier("exports"), E.createStringLiteralFromNode(pe), E.createObjectLiteralExpression([E.createPropertyAssignment("enumerable", E.createTrue()), E.createPropertyAssignment("get", E.createFunctionExpression(void 0, void 0, void 0, void 0, [], void 0, E.createBlock([E.createReturnStatement(or)])))])]) : E.createAssignment(E.createPropertyAccessExpression(E.createIdentifier("exports"), E.cloneNode(pe)), or), qr);
              }
              function lr(pe) {
                switch (pe.kind) {
                  case 93:
                  case 88:
                    return;
                }
                return pe;
              }
              function be(pe, or, qr) {
                or.kind === 305 ? (ie = or, R = se[e2.getOriginalNodeId(ie)], b(pe, or, qr), ie = void 0, R = void 0) : b(pe, or, qr);
              }
              function Ge(pe, or) {
                return or = K(pe, or), or.id && q[or.id] ? or : pe === 1 ? yr(or) : e2.isShorthandPropertyAssignment(or) ? ur(or) : or;
              }
              function ur(pe) {
                var or = pe.name, qr = Ur(or);
                if (qr !== or) {
                  if (pe.objectAssignmentInitializer) {
                    var si = E.createAssignment(qr, pe.objectAssignmentInitializer);
                    return e2.setTextRange(E.createPropertyAssignment(or, si), pe);
                  }
                  return e2.setTextRange(E.createPropertyAssignment(or, qr), pe);
                }
                return pe;
              }
              function yr(pe) {
                switch (pe.kind) {
                  case 79:
                    return Ur(pe);
                  case 208:
                    return Ir(pe);
                  case 210:
                    return wr(pe);
                  case 221:
                    return ii(pe);
                }
                return pe;
              }
              function Ir(pe) {
                if (e2.isIdentifier(pe.expression)) {
                  var or = Ur(pe.expression);
                  if (q[e2.getNodeId(or)] = true, !e2.isIdentifier(or) && !(e2.getEmitFlags(pe.expression) & 4096))
                    return e2.addEmitFlags(E.updateCallExpression(pe, or, void 0, pe.arguments), 536870912);
                }
                return pe;
              }
              function wr(pe) {
                if (e2.isIdentifier(pe.tag)) {
                  var or = Ur(pe.tag);
                  if (q[e2.getNodeId(or)] = true, !e2.isIdentifier(or) && !(e2.getEmitFlags(pe.tag) & 4096))
                    return e2.addEmitFlags(E.updateTaggedTemplateExpression(pe, or, void 0, pe.template), 536870912);
                }
                return pe;
              }
              function Ur(pe) {
                var or, qr;
                if (e2.getEmitFlags(pe) & 4096) {
                  var si = e2.getExternalHelpersModuleName(ie);
                  return si ? E.createPropertyAccessExpression(si, pe) : pe;
                } else if (!(e2.isGeneratedIdentifier(pe) && !(pe.autoGenerateFlags & 64)) && !e2.isLocalName(pe)) {
                  var Di = G.getReferencedExportContainer(pe, e2.isExportName(pe));
                  if (Di && Di.kind === 305)
                    return e2.setTextRange(E.createPropertyAccessExpression(E.createIdentifier("exports"), E.cloneNode(pe)), pe);
                  var wi = G.getReferencedImportDeclaration(pe);
                  if (wi) {
                    if (e2.isImportClause(wi))
                      return e2.setTextRange(E.createPropertyAccessExpression(E.getGeneratedNameForNode(wi.parent), E.createIdentifier("default")), pe);
                    if (e2.isImportSpecifier(wi)) {
                      var Xi = wi.propertyName || wi.name;
                      return e2.setTextRange(E.createPropertyAccessExpression(E.getGeneratedNameForNode(((qr = (or = wi.parent) === null || or === void 0 ? void 0 : or.parent) === null || qr === void 0 ? void 0 : qr.parent) || wi), E.cloneNode(Xi)), pe);
                    }
                  }
                }
                return pe;
              }
              function ii(pe) {
                if (e2.isAssignmentOperator(pe.operatorToken.kind) && e2.isIdentifier(pe.left) && !e2.isGeneratedIdentifier(pe.left) && !e2.isLocalName(pe.left) && !e2.isDeclarationNameOfEnumOrNamespace(pe.left)) {
                  var or = mi(pe.left);
                  if (or) {
                    for (var qr = pe, si = 0, Di = or; si < Di.length; si++) {
                      var wi = Di[si];
                      q[e2.getNodeId(qr)] = true, qr = n(wi, qr, pe);
                    }
                    return qr;
                  }
                }
                return pe;
              }
              function mi(pe) {
                if (!e2.isGeneratedIdentifier(pe)) {
                  var or = G.getReferencedImportDeclaration(pe) || G.getReferencedValueDeclaration(pe);
                  if (or)
                    return R && R.exportedBindings[e2.getOriginalNodeId(or)];
                }
              }
            }
            e2.transformModule = a;
            var C = { name: "typescript:dynamicimport-sync-require", scoped: true, text: `
            var __syncRequire = typeof module === "object" && typeof module.exports === "object";` };
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w = C.factory, B = C.startLexicalEnvironment, E = C.endLexicalEnvironment, Q = C.hoistVariableDeclaration, le = C.getCompilerOptions(), N = C.getEmitResolver(), p = C.getEmitHost(), m2 = C.onSubstituteNode, G = C.onEmitNode;
              C.onSubstituteNode = si, C.onEmitNode = qr, C.enableSubstitution(79), C.enableSubstitution(297), C.enableSubstitution(221), C.enableSubstitution(231), C.enableEmitNotification(305);
              var oe = [], f4 = [], T = [], K = [], b = [], se, J, ie, R, q, O, ve;
              return e2.chainBundle(C, ee);
              function ee(ae) {
                if (ae.isDeclarationFile || !(e2.isEffectiveExternalModule(ae, le) || ae.transformFlags & 4194304))
                  return ae;
                var Xe = e2.getOriginalNodeId(ae);
                se = ae, O = ae, J = oe[Xe] = e2.collectExternalModuleInfo(C, ae, N, le), ie = w.createUniqueName("exports"), T[Xe] = ie, R = b[Xe] = w.createUniqueName("context");
                var Jr = he(J.externalImports), ti = F2(ae, Jr), Ze = w.createFunctionExpression(void 0, void 0, void 0, void 0, [w.createParameterDeclaration(void 0, void 0, void 0, ie), w.createParameterDeclaration(void 0, void 0, void 0, R)], void 0, ti), Sr = e2.tryGetModuleNameFromFile(w, ae, p, le), zr = w.createArrayLiteralExpression(e2.map(Jr, function(Je) {
                  return Je.name;
                })), Wr = e2.setEmitFlags(w.updateSourceFile(ae, e2.setTextRange(w.createNodeArray([w.createExpressionStatement(w.createCallExpression(w.createPropertyAccessExpression(w.createIdentifier("System"), "register"), void 0, Sr ? [Sr, zr, Ze] : [zr, Ze]))]), ae.statements)), 1024);
                return e2.outFile(le) || e2.moveEmitHelpers(Wr, ti, function(Je) {
                  return !Je.scoped;
                }), ve && (K[Xe] = ve, ve = void 0), se = void 0, J = void 0, ie = void 0, R = void 0, q = void 0, O = void 0, Wr;
              }
              function he(ae) {
                for (var Xe = new e2.Map(), Jr = [], ti = 0, Ze = ae; ti < Ze.length; ti++) {
                  var Sr = Ze[ti], zr = e2.getExternalModuleNameLiteral(w, Sr, se, p, N, le);
                  if (zr) {
                    var Wr = zr.text, Je = Xe.get(Wr);
                    Je !== void 0 ? Jr[Je].externalImports.push(Sr) : (Xe.set(Wr, Jr.length), Jr.push({ name: zr, externalImports: [Sr] }));
                  }
                }
                return Jr;
              }
              function F2(ae, Xe) {
                var Jr = [];
                B();
                var ti = e2.getStrictOptionValue(le, "alwaysStrict") || !le.noImplicitUseStrict && e2.isExternalModule(se), Ze = w.copyPrologue(ae.statements, Jr, ti, A2);
                Jr.push(w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration("__moduleName", void 0, void 0, w.createLogicalAnd(R, w.createPropertyAccessExpression(R, "id")))]))), e2.visitNode(J.externalHelpersImportDeclaration, A2, e2.isStatement);
                var Sr = e2.visitNodes(ae.statements, A2, e2.isStatement, Ze);
                e2.addRange(Jr, q), e2.insertStatementsAfterStandardPrologue(Jr, E());
                var zr = x2(Jr), Wr = ae.transformFlags & 1048576 ? w.createModifiersFromModifierFlags(256) : void 0, Je = w.createObjectLiteralExpression([w.createPropertyAssignment("setters", $(zr, Xe)), w.createPropertyAssignment("execute", w.createFunctionExpression(Wr, void 0, void 0, void 0, [], void 0, w.createBlock(Sr, true)))], true);
                return Jr.push(w.createReturnStatement(Je)), w.createBlock(Jr, true);
              }
              function x2(ae) {
                if (!!J.hasExportStarsToExportValues) {
                  if (!J.exportedNames && J.exportSpecifiers.size === 0) {
                    for (var Xe = false, Jr = 0, ti = J.externalImports; Jr < ti.length; Jr++) {
                      var Ze = ti[Jr];
                      if (Ze.kind === 272 && Ze.exportClause) {
                        Xe = true;
                        break;
                      }
                    }
                    if (!Xe) {
                      var Sr = X(void 0);
                      return ae.push(Sr), Sr.name;
                    }
                  }
                  var zr = [];
                  if (J.exportedNames)
                    for (var Wr = 0, Je = J.exportedNames; Wr < Je.length; Wr++) {
                      var xe = Je[Wr];
                      xe.escapedText !== "default" && zr.push(w.createPropertyAssignment(w.createStringLiteralFromNode(xe), w.createTrue()));
                    }
                  var vr = w.createUniqueName("exportedNames");
                  ae.push(w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration(vr, void 0, void 0, w.createObjectLiteralExpression(zr, true))])));
                  var mr = X(vr);
                  return ae.push(mr), mr.name;
                }
              }
              function X(ae) {
                var Xe = w.createUniqueName("exportStar"), Jr = w.createIdentifier("m"), ti = w.createIdentifier("n"), Ze = w.createIdentifier("exports"), Sr = w.createStrictInequality(ti, w.createStringLiteral("default"));
                return ae && (Sr = w.createLogicalAnd(Sr, w.createLogicalNot(w.createCallExpression(w.createPropertyAccessExpression(ae, "hasOwnProperty"), void 0, [ti])))), w.createFunctionDeclaration(void 0, void 0, void 0, Xe, void 0, [w.createParameterDeclaration(void 0, void 0, void 0, Jr)], void 0, w.createBlock([w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration(Ze, void 0, void 0, w.createObjectLiteralExpression([]))])), w.createForInStatement(w.createVariableDeclarationList([w.createVariableDeclaration(ti)]), Jr, w.createBlock([e2.setEmitFlags(w.createIfStatement(Sr, w.createExpressionStatement(w.createAssignment(w.createElementAccessExpression(Ze, ti), w.createElementAccessExpression(Jr, ti)))), 1)])), w.createExpressionStatement(w.createCallExpression(ie, void 0, [Ze]))], true));
              }
              function $(ae, Xe) {
                for (var Jr = [], ti = 0, Ze = Xe; ti < Ze.length; ti++) {
                  for (var Sr = Ze[ti], zr = e2.forEach(Sr.externalImports, function(Ue) {
                    return e2.getLocalNameForExternalImport(w, Ue, se);
                  }), Wr = zr ? w.getGeneratedNameForNode(zr) : w.createUniqueName(""), Je = [], xe = 0, vr = Sr.externalImports; xe < vr.length; xe++) {
                    var mr = vr[xe], Ar = e2.getLocalNameForExternalImport(w, mr, se);
                    switch (mr.kind) {
                      case 266:
                        if (!mr.importClause)
                          break;
                      case 265:
                        e2.Debug.assert(Ar !== void 0), Je.push(w.createExpressionStatement(w.createAssignment(Ar, Wr)));
                        break;
                      case 272:
                        if (e2.Debug.assert(Ar !== void 0), mr.exportClause)
                          if (e2.isNamedExports(mr.exportClause)) {
                            for (var Oe = [], nr = 0, Mr = mr.exportClause.elements; nr < Mr.length; nr++) {
                              var Pe = Mr[nr];
                              Oe.push(w.createPropertyAssignment(w.createStringLiteral(e2.idText(Pe.name)), w.createElementAccessExpression(Wr, w.createStringLiteral(e2.idText(Pe.propertyName || Pe.name)))));
                            }
                            Je.push(w.createExpressionStatement(w.createCallExpression(ie, void 0, [w.createObjectLiteralExpression(Oe, true)])));
                          } else
                            Je.push(w.createExpressionStatement(w.createCallExpression(ie, void 0, [w.createStringLiteral(e2.idText(mr.exportClause.name)), Wr])));
                        else
                          Je.push(w.createExpressionStatement(w.createCallExpression(ae, void 0, [Wr])));
                        break;
                    }
                  }
                  Jr.push(w.createFunctionExpression(void 0, void 0, void 0, void 0, [w.createParameterDeclaration(void 0, void 0, void 0, Wr)], void 0, w.createBlock(Je, true)));
                }
                return w.createArrayLiteralExpression(Jr, true);
              }
              function A2(ae) {
                switch (ae.kind) {
                  case 266:
                    return y(ae);
                  case 265:
                    return L(ae);
                  case 272:
                    return V(ae);
                  case 271:
                    return P(ae);
                  default:
                    return He(ae);
                }
              }
              function y(ae) {
                var Xe;
                if (ae.importClause && Q(e2.getLocalNameForExternalImport(w, ae, se)), g(ae)) {
                  var Jr = e2.getOriginalNodeId(ae);
                  f4[Jr] = ue(f4[Jr], ae);
                } else
                  Xe = ue(Xe, ae);
                return e2.singleOrMany(Xe);
              }
              function V(ae) {
                e2.Debug.assertIsDefined(ae);
              }
              function L(ae) {
                e2.Debug.assert(e2.isExternalModuleImportEqualsDeclaration(ae), "import= for internal module references should be handled in an earlier transformer.");
                var Xe;
                if (Q(e2.getLocalNameForExternalImport(w, ae, se)), g(ae)) {
                  var Jr = e2.getOriginalNodeId(ae);
                  f4[Jr] = We(f4[Jr], ae);
                } else
                  Xe = We(Xe, ae);
                return e2.singleOrMany(Xe);
              }
              function P(ae) {
                if (!ae.isExportEquals) {
                  var Xe = e2.visitNode(ae.expression, Ge, e2.isExpression), Jr = ae.original;
                  if (Jr && g(Jr)) {
                    var ti = e2.getOriginalNodeId(ae);
                    f4[ti] = Re(f4[ti], w.createIdentifier("default"), Xe, true);
                  } else
                    return ze(w.createIdentifier("default"), Xe, true);
                }
              }
              function k(ae) {
                if (e2.hasSyntacticModifier(ae, 1) ? q = e2.append(q, w.updateFunctionDeclaration(ae, ae.decorators, e2.visitNodes(ae.modifiers, or, e2.isModifier), ae.asteriskToken, w.getDeclarationName(ae, true, true), void 0, e2.visitNodes(ae.parameters, Ge, e2.isParameterDeclaration), void 0, e2.visitNode(ae.body, Ge, e2.isBlock))) : q = e2.append(q, e2.visitEachChild(ae, Ge, C)), g(ae)) {
                  var Xe = e2.getOriginalNodeId(ae);
                  f4[Xe] = Be(f4[Xe], ae);
                } else
                  q = Be(q, ae);
              }
              function Y(ae) {
                var Xe, Jr = w.getLocalName(ae);
                if (Q(Jr), Xe = e2.append(Xe, e2.setTextRange(w.createExpressionStatement(w.createAssignment(Jr, e2.setTextRange(w.createClassExpression(e2.visitNodes(ae.decorators, Ge, e2.isDecorator), void 0, ae.name, void 0, e2.visitNodes(ae.heritageClauses, Ge, e2.isHeritageClause), e2.visitNodes(ae.members, Ge, e2.isClassElement)), ae))), ae)), g(ae)) {
                  var ti = e2.getOriginalNodeId(ae);
                  f4[ti] = Be(f4[ti], ae);
                } else
                  Xe = Be(Xe, ae);
                return e2.singleOrMany(Xe);
              }
              function U(ae) {
                if (!H(ae.declarationList))
                  return e2.visitNode(ae, Ge, e2.isStatement);
                for (var Xe, Jr = e2.hasSyntacticModifier(ae, 1), ti = g(ae), Ze = 0, Sr = ae.declarationList.declarations; Ze < Sr.length; Ze++) {
                  var zr = Sr[Ze];
                  zr.initializer ? Xe = e2.append(Xe, I(zr, Jr && !ti)) : j(zr);
                }
                var Wr;
                if (Xe && (Wr = e2.append(Wr, e2.setTextRange(w.createExpressionStatement(w.inlineExpressions(Xe)), ae))), ti) {
                  var Je = e2.getOriginalNodeId(ae);
                  f4[Je] = Fe(f4[Je], ae, Jr);
                } else
                  Wr = Fe(Wr, ae, false);
                return e2.singleOrMany(Wr);
              }
              function j(ae) {
                if (e2.isBindingPattern(ae.name))
                  for (var Xe = 0, Jr = ae.name.elements; Xe < Jr.length; Xe++) {
                    var ti = Jr[Xe];
                    e2.isOmittedExpression(ti) || j(ti);
                  }
                else
                  Q(w.cloneNode(ae.name));
              }
              function H(ae) {
                return (e2.getEmitFlags(ae) & 2097152) === 0 && (O.kind === 305 || (e2.getOriginalNode(ae).flags & 3) === 0);
              }
              function I(ae, Xe) {
                var Jr = Xe ? l : d;
                return e2.isBindingPattern(ae.name) ? e2.flattenDestructuringAssignment(ae, Ge, C, 0, false, Jr) : ae.initializer ? Jr(ae.name, e2.visitNode(ae.initializer, Ge, e2.isExpression)) : ae.name;
              }
              function l(ae, Xe, Jr) {
                return D(ae, Xe, Jr, true);
              }
              function d(ae, Xe, Jr) {
                return D(ae, Xe, Jr, false);
              }
              function D(ae, Xe, Jr, ti) {
                return Q(w.cloneNode(ae)), ti ? Ee(ae, _r(e2.setTextRange(w.createAssignment(ae, Xe), Jr))) : _r(e2.setTextRange(w.createAssignment(ae, Xe), Jr));
              }
              function fe(ae) {
                if (g(ae) && ae.original.kind === 237) {
                  var Xe = e2.getOriginalNodeId(ae), Jr = e2.hasSyntacticModifier(ae.original, 1);
                  f4[Xe] = Fe(f4[Xe], ae.original, Jr);
                }
                return ae;
              }
              function g(ae) {
                return (e2.getEmitFlags(ae) & 4194304) !== 0;
              }
              function ne(ae) {
                var Xe = e2.getOriginalNodeId(ae), Jr = f4[Xe];
                if (Jr)
                  return delete f4[Xe], e2.append(Jr, ae);
                var ti = e2.getOriginalNode(ae);
                return e2.isModuleOrEnumDeclaration(ti) ? e2.append(ge(Jr, ti), ae) : ae;
              }
              function ue(ae, Xe) {
                if (J.exportEquals)
                  return ae;
                var Jr = Xe.importClause;
                if (!Jr)
                  return ae;
                Jr.name && (ae = ge(ae, Jr));
                var ti = Jr.namedBindings;
                if (ti)
                  switch (ti.kind) {
                    case 268:
                      ae = ge(ae, ti);
                      break;
                    case 269:
                      for (var Ze = 0, Sr = ti.elements; Ze < Sr.length; Ze++) {
                        var zr = Sr[Ze];
                        ae = ge(ae, zr);
                      }
                      break;
                  }
                return ae;
              }
              function We(ae, Xe) {
                return J.exportEquals ? ae : ge(ae, Xe);
              }
              function Fe(ae, Xe, Jr) {
                if (J.exportEquals)
                  return ae;
                for (var ti = 0, Ze = Xe.declarationList.declarations; ti < Ze.length; ti++) {
                  var Sr = Ze[ti];
                  (Sr.initializer || Jr) && (ae = Z2(ae, Sr, Jr));
                }
                return ae;
              }
              function Z2(ae, Xe, Jr) {
                if (J.exportEquals)
                  return ae;
                if (e2.isBindingPattern(Xe.name))
                  for (var ti = 0, Ze = Xe.name.elements; ti < Ze.length; ti++) {
                    var Sr = Ze[ti];
                    e2.isOmittedExpression(Sr) || (ae = Z2(ae, Sr, Jr));
                  }
                else if (!e2.isGeneratedIdentifier(Xe.name)) {
                  var zr = void 0;
                  Jr && (ae = Re(ae, Xe.name, w.getLocalName(Xe)), zr = e2.idText(Xe.name)), ae = ge(ae, Xe, zr);
                }
                return ae;
              }
              function Be(ae, Xe) {
                if (J.exportEquals)
                  return ae;
                var Jr;
                if (e2.hasSyntacticModifier(Xe, 1)) {
                  var ti = e2.hasSyntacticModifier(Xe, 512) ? w.createStringLiteral("default") : Xe.name;
                  ae = Re(ae, ti, w.getLocalName(Xe)), Jr = e2.getTextOfIdentifierOrLiteral(ti);
                }
                return Xe.name && (ae = ge(ae, Xe, Jr)), ae;
              }
              function ge(ae, Xe, Jr) {
                if (J.exportEquals)
                  return ae;
                var ti = w.getDeclarationName(Xe), Ze = J.exportSpecifiers.get(e2.idText(ti));
                if (Ze)
                  for (var Sr = 0, zr = Ze; Sr < zr.length; Sr++) {
                    var Wr = zr[Sr];
                    Wr.name.escapedText !== Jr && (ae = Re(ae, Wr.name, ti));
                  }
                return ae;
              }
              function Re(ae, Xe, Jr, ti) {
                return ae = e2.append(ae, ze(Xe, Jr, ti)), ae;
              }
              function ze(ae, Xe, Jr) {
                var ti = w.createExpressionStatement(Ee(ae, Xe));
                return e2.startOnNewLine(ti), Jr || e2.setEmitFlags(ti, 1536), ti;
              }
              function Ee(ae, Xe) {
                var Jr = e2.isIdentifier(ae) ? w.createStringLiteralFromNode(ae) : ae;
                return e2.setEmitFlags(Xe, e2.getEmitFlags(Xe) | 1536), e2.setCommentRange(w.createCallExpression(ie, void 0, [Jr, Xe]), Xe);
              }
              function He(ae) {
                switch (ae.kind) {
                  case 237:
                    return U(ae);
                  case 256:
                    return k(ae);
                  case 257:
                    return Y(ae);
                  case 242:
                    return rr(ae, true);
                  case 243:
                    return Ie(ae);
                  case 244:
                    return _e(ae);
                  case 240:
                    return ye(ae);
                  case 241:
                    return Ae(ae);
                  case 250:
                    return er(ae);
                  case 248:
                    return ir(ae);
                  case 249:
                    return Cr(ae);
                  case 263:
                    return Ye(ae);
                  case 289:
                    return Br(ae);
                  case 290:
                    return Er(ae);
                  case 252:
                    return Ne(ae);
                  case 292:
                    return n(ae);
                  case 235:
                    return lr(ae);
                  case 352:
                    return fe(ae);
                  case 353:
                    return ne(ae);
                  default:
                    return Ge(ae);
                }
              }
              function rr(ae, Xe) {
                var Jr = O;
                return O = ae, ae = w.updateForStatement(ae, e2.visitNode(ae.initializer, Xe ? de : ur, e2.isForInitializer), e2.visitNode(ae.condition, Ge, e2.isExpression), e2.visitNode(ae.incrementor, ur, e2.isExpression), e2.visitIterationBody(ae.statement, Xe ? He : Ge, C)), O = Jr, ae;
              }
              function Ie(ae) {
                var Xe = O;
                return O = ae, ae = w.updateForInStatement(ae, de(ae.initializer), e2.visitNode(ae.expression, Ge, e2.isExpression), e2.visitIterationBody(ae.statement, He, C)), O = Xe, ae;
              }
              function _e(ae) {
                var Xe = O;
                return O = ae, ae = w.updateForOfStatement(ae, ae.awaitModifier, de(ae.initializer), e2.visitNode(ae.expression, Ge, e2.isExpression), e2.visitIterationBody(ae.statement, He, C)), O = Xe, ae;
              }
              function we(ae) {
                return e2.isVariableDeclarationList(ae) && H(ae);
              }
              function de(ae) {
                if (we(ae)) {
                  for (var Xe = void 0, Jr = 0, ti = ae.declarations; Jr < ti.length; Jr++) {
                    var Ze = ti[Jr];
                    Xe = e2.append(Xe, I(Ze, false)), Ze.initializer || j(Ze);
                  }
                  return Xe ? w.inlineExpressions(Xe) : w.createOmittedExpression();
                } else
                  return e2.visitNode(ae, ur, e2.isExpression);
              }
              function ye(ae) {
                return w.updateDoStatement(ae, e2.visitIterationBody(ae.statement, He, C), e2.visitNode(ae.expression, Ge, e2.isExpression));
              }
              function Ae(ae) {
                return w.updateWhileStatement(ae, e2.visitNode(ae.expression, Ge, e2.isExpression), e2.visitIterationBody(ae.statement, He, C));
              }
              function er(ae) {
                return w.updateLabeledStatement(ae, ae.label, e2.visitNode(ae.statement, He, e2.isStatement, w.liftToBlock));
              }
              function ir(ae) {
                return w.updateWithStatement(ae, e2.visitNode(ae.expression, Ge, e2.isExpression), e2.visitNode(ae.statement, He, e2.isStatement, w.liftToBlock));
              }
              function Cr(ae) {
                return w.updateSwitchStatement(ae, e2.visitNode(ae.expression, Ge, e2.isExpression), e2.visitNode(ae.caseBlock, He, e2.isCaseBlock));
              }
              function Ye(ae) {
                var Xe = O;
                return O = ae, ae = w.updateCaseBlock(ae, e2.visitNodes(ae.clauses, He, e2.isCaseOrDefaultClause)), O = Xe, ae;
              }
              function Br(ae) {
                return w.updateCaseClause(ae, e2.visitNode(ae.expression, Ge, e2.isExpression), e2.visitNodes(ae.statements, He, e2.isStatement));
              }
              function Er(ae) {
                return e2.visitEachChild(ae, He, C);
              }
              function Ne(ae) {
                return e2.visitEachChild(ae, He, C);
              }
              function n(ae) {
                var Xe = O;
                return O = ae, ae = w.updateCatchClause(ae, ae.variableDeclaration, e2.visitNode(ae.block, He, e2.isBlock)), O = Xe, ae;
              }
              function lr(ae) {
                var Xe = O;
                return O = ae, ae = e2.visitEachChild(ae, He, C), O = Xe, ae;
              }
              function be(ae, Xe) {
                if (!(ae.transformFlags & 71307264))
                  return ae;
                switch (ae.kind) {
                  case 242:
                    return rr(ae, false);
                  case 238:
                    return yr(ae);
                  case 212:
                    return Ir(ae, Xe);
                  case 350:
                    return wr(ae, Xe);
                  case 221:
                    if (e2.isDestructuringAssignment(ae))
                      return ii(ae, Xe);
                    break;
                  case 208:
                    if (e2.isImportCall(ae))
                      return Ur(ae);
                    break;
                  case 219:
                  case 220:
                    return pe(ae, Xe);
                }
                return e2.visitEachChild(ae, Ge, C);
              }
              function Ge(ae) {
                return be(ae, false);
              }
              function ur(ae) {
                return be(ae, true);
              }
              function yr(ae) {
                return w.updateExpressionStatement(ae, e2.visitNode(ae.expression, ur, e2.isExpression));
              }
              function Ir(ae, Xe) {
                return w.updateParenthesizedExpression(ae, e2.visitNode(ae.expression, Xe ? ur : Ge, e2.isExpression));
              }
              function wr(ae, Xe) {
                return w.updatePartiallyEmittedExpression(ae, e2.visitNode(ae.expression, Xe ? ur : Ge, e2.isExpression));
              }
              function Ur(ae) {
                var Xe = e2.getExternalModuleNameLiteral(w, ae, se, p, N, le), Jr = e2.visitNode(e2.firstOrUndefined(ae.arguments), Ge), ti = Xe && (!Jr || !e2.isStringLiteral(Jr) || Jr.text !== Xe.text) ? Xe : Jr;
                return w.createCallExpression(w.createPropertyAccessExpression(R, w.createIdentifier("import")), void 0, ti ? [ti] : []);
              }
              function ii(ae, Xe) {
                return mi(ae.left) ? e2.flattenDestructuringAssignment(ae, Ge, C, 0, !Xe) : e2.visitEachChild(ae, Ge, C);
              }
              function mi(ae) {
                if (e2.isAssignmentExpression(ae, true))
                  return mi(ae.left);
                if (e2.isSpreadElement(ae))
                  return mi(ae.expression);
                if (e2.isObjectLiteralExpression(ae))
                  return e2.some(ae.properties, mi);
                if (e2.isArrayLiteralExpression(ae))
                  return e2.some(ae.elements, mi);
                if (e2.isShorthandPropertyAssignment(ae))
                  return mi(ae.name);
                if (e2.isPropertyAssignment(ae))
                  return mi(ae.initializer);
                if (e2.isIdentifier(ae)) {
                  var Xe = N.getReferencedExportContainer(ae);
                  return Xe !== void 0 && Xe.kind === 305;
                } else
                  return false;
              }
              function pe(ae, Xe) {
                if ((ae.operator === 45 || ae.operator === 46) && e2.isIdentifier(ae.operand) && !e2.isGeneratedIdentifier(ae.operand) && !e2.isLocalName(ae.operand) && !e2.isDeclarationNameOfEnumOrNamespace(ae.operand)) {
                  var Jr = Zt(ae.operand);
                  if (Jr) {
                    var ti = void 0, Ze = e2.visitNode(ae.operand, Ge, e2.isExpression);
                    e2.isPrefixUnaryExpression(ae) ? Ze = w.updatePrefixUnaryExpression(ae, Ze) : (Ze = w.updatePostfixUnaryExpression(ae, Ze), Xe || (ti = w.createTempVariable(Q), Ze = w.createAssignment(ti, Ze), e2.setTextRange(Ze, ae)), Ze = w.createComma(Ze, w.cloneNode(ae.operand)), e2.setTextRange(Ze, ae));
                    for (var Sr = 0, zr = Jr; Sr < zr.length; Sr++) {
                      var Wr = zr[Sr];
                      Ze = Ee(Wr, _r(Ze));
                    }
                    return ti && (Ze = w.createComma(Ze, ti), e2.setTextRange(Ze, ae)), Ze;
                  }
                }
                return e2.visitEachChild(ae, Ge, C);
              }
              function or(ae) {
                switch (ae.kind) {
                  case 93:
                  case 88:
                    return;
                }
                return ae;
              }
              function qr(ae, Xe, Jr) {
                if (Xe.kind === 305) {
                  var ti = e2.getOriginalNodeId(Xe);
                  se = Xe, J = oe[ti], ie = T[ti], ve = K[ti], R = b[ti], ve && delete K[ti], G(ae, Xe, Jr), se = void 0, J = void 0, ie = void 0, R = void 0, ve = void 0;
                } else
                  G(ae, Xe, Jr);
              }
              function si(ae, Xe) {
                return Xe = m2(ae, Xe), pi(Xe) ? Xe : ae === 1 ? Xi(Xe) : ae === 4 ? Di(Xe) : Xe;
              }
              function Di(ae) {
                switch (ae.kind) {
                  case 297:
                    return wi(ae);
                }
                return ae;
              }
              function wi(ae) {
                var Xe, Jr, ti = ae.name;
                if (!e2.isGeneratedIdentifier(ti) && !e2.isLocalName(ti)) {
                  var Ze = N.getReferencedImportDeclaration(ti);
                  if (Ze) {
                    if (e2.isImportClause(Ze))
                      return e2.setTextRange(w.createPropertyAssignment(w.cloneNode(ti), w.createPropertyAccessExpression(w.getGeneratedNameForNode(Ze.parent), w.createIdentifier("default"))), ae);
                    if (e2.isImportSpecifier(Ze))
                      return e2.setTextRange(w.createPropertyAssignment(w.cloneNode(ti), w.createPropertyAccessExpression(w.getGeneratedNameForNode(((Jr = (Xe = Ze.parent) === null || Xe === void 0 ? void 0 : Xe.parent) === null || Jr === void 0 ? void 0 : Jr.parent) || Ze), w.cloneNode(Ze.propertyName || Ze.name))), ae);
                  }
                }
                return ae;
              }
              function Xi(ae) {
                switch (ae.kind) {
                  case 79:
                    return et(ae);
                  case 221:
                    return Gi(ae);
                  case 231:
                    return Wt(ae);
                }
                return ae;
              }
              function et(ae) {
                var Xe, Jr;
                if (e2.getEmitFlags(ae) & 4096) {
                  var ti = e2.getExternalHelpersModuleName(se);
                  return ti ? w.createPropertyAccessExpression(ti, ae) : ae;
                }
                if (!e2.isGeneratedIdentifier(ae) && !e2.isLocalName(ae)) {
                  var Ze = N.getReferencedImportDeclaration(ae);
                  if (Ze) {
                    if (e2.isImportClause(Ze))
                      return e2.setTextRange(w.createPropertyAccessExpression(w.getGeneratedNameForNode(Ze.parent), w.createIdentifier("default")), ae);
                    if (e2.isImportSpecifier(Ze))
                      return e2.setTextRange(w.createPropertyAccessExpression(w.getGeneratedNameForNode(((Jr = (Xe = Ze.parent) === null || Xe === void 0 ? void 0 : Xe.parent) === null || Jr === void 0 ? void 0 : Jr.parent) || Ze), w.cloneNode(Ze.propertyName || Ze.name)), ae);
                  }
                }
                return ae;
              }
              function Gi(ae) {
                if (e2.isAssignmentOperator(ae.operatorToken.kind) && e2.isIdentifier(ae.left) && !e2.isGeneratedIdentifier(ae.left) && !e2.isLocalName(ae.left) && !e2.isDeclarationNameOfEnumOrNamespace(ae.left)) {
                  var Xe = Zt(ae.left);
                  if (Xe) {
                    for (var Jr = ae, ti = 0, Ze = Xe; ti < Ze.length; ti++) {
                      var Sr = Ze[ti];
                      Jr = Ee(Sr, _r(Jr));
                    }
                    return Jr;
                  }
                }
                return ae;
              }
              function Wt(ae) {
                return e2.isImportMeta(ae) ? w.createPropertyAccessExpression(R, w.createIdentifier("meta")) : ae;
              }
              function Zt(ae) {
                var Xe;
                if (!e2.isGeneratedIdentifier(ae)) {
                  var Jr = N.getReferencedImportDeclaration(ae) || N.getReferencedValueDeclaration(ae);
                  if (Jr) {
                    var ti = N.getReferencedExportContainer(ae, false);
                    ti && ti.kind === 305 && (Xe = e2.append(Xe, w.getDeclarationName(Jr))), Xe = e2.addRange(Xe, J && J.exportedBindings[e2.getOriginalNodeId(Jr)]);
                  }
                }
                return Xe;
              }
              function _r(ae) {
                return ve === void 0 && (ve = []), ve[e2.getNodeId(ae)] = true, ae;
              }
              function pi(ae) {
                return ve && ae.id && ve[ae.id];
              }
            }
            e2.transformSystemModule = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w = C.factory, B = C.getEmitHelperFactory, E = C.getEmitHost(), Q = C.getEmitResolver(), le = C.getCompilerOptions(), N = e2.getEmitScriptTarget(le), p = C.onEmitNode, m2 = C.onSubstituteNode;
              C.onEmitNode = O, C.onSubstituteNode = ve, C.enableEmitNotification(305), C.enableSubstitution(79);
              var G, oe, f4;
              return e2.chainBundle(C, T);
              function T(he) {
                if (he.isDeclarationFile)
                  return he;
                if (e2.isExternalModule(he) || le.isolatedModules) {
                  oe = he, f4 = void 0;
                  var F2 = K(he);
                  return oe = void 0, f4 && (F2 = w.updateSourceFile(F2, e2.setTextRange(w.createNodeArray(e2.insertStatementsAfterCustomPrologue(F2.statements.slice(), f4)), F2.statements))), !e2.isExternalModule(he) || e2.some(F2.statements, e2.isExternalModuleIndicator) ? F2 : w.updateSourceFile(F2, e2.setTextRange(w.createNodeArray(Ve(Ve([], F2.statements, true), [e2.createEmptyExports(w)], false)), F2.statements));
                }
                return he;
              }
              function K(he) {
                var F2 = e2.createExternalHelpersImportDeclarationIfNeeded(w, B(), he, le);
                if (F2) {
                  var x2 = [], X = w.copyPrologue(he.statements, x2);
                  return e2.append(x2, F2), e2.addRange(x2, e2.visitNodes(he.statements, b, e2.isStatement, X)), w.updateSourceFile(he, e2.setTextRange(w.createNodeArray(x2), he.statements));
                } else
                  return e2.visitEachChild(he, b, C);
              }
              function b(he) {
                switch (he.kind) {
                  case 265:
                    return e2.getEmitScriptTarget(le) >= e2.ModuleKind.ES2020 ? J(he) : void 0;
                  case 271:
                    return R(he);
                  case 272:
                    var F2 = he;
                    return q(F2);
                }
                return he;
              }
              function se(he) {
                var F2 = e2.getExternalModuleNameLiteral(w, he, e2.Debug.checkDefined(oe), E, Q, le), x2 = [];
                if (F2 && x2.push(F2), !f4) {
                  var X = w.createUniqueName("_createRequire", 48), $ = w.createImportDeclaration(void 0, void 0, w.createImportClause(false, void 0, w.createNamedImports([w.createImportSpecifier(false, w.createIdentifier("createRequire"), X)])), w.createStringLiteral("module")), A2 = w.createUniqueName("__require", 48), y = w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration(A2, void 0, void 0, w.createCallExpression(w.cloneNode(X), void 0, [w.createPropertyAccessExpression(w.createMetaProperty(100, w.createIdentifier("meta")), w.createIdentifier("url"))]))], N >= 2 ? 2 : 0));
                  f4 = [$, y];
                }
                var V = f4[1].declarationList.declarations[0].name;
                return e2.Debug.assertNode(V, e2.isIdentifier), w.createCallExpression(w.cloneNode(V), void 0, x2);
              }
              function J(he) {
                e2.Debug.assert(e2.isExternalModuleImportEqualsDeclaration(he), "import= for internal module references should be handled in an earlier transformer.");
                var F2;
                return F2 = e2.append(F2, e2.setOriginalNode(e2.setTextRange(w.createVariableStatement(void 0, w.createVariableDeclarationList([w.createVariableDeclaration(w.cloneNode(he.name), void 0, void 0, se(he))], N >= 2 ? 2 : 0)), he), he)), F2 = ie(F2, he), e2.singleOrMany(F2);
              }
              function ie(he, F2) {
                return e2.hasSyntacticModifier(F2, 1) && (he = e2.append(he, w.createExportDeclaration(void 0, void 0, F2.isTypeOnly, w.createNamedExports([w.createExportSpecifier(false, void 0, e2.idText(F2.name))])))), he;
              }
              function R(he) {
                return he.isExportEquals ? void 0 : he;
              }
              function q(he) {
                if (le.module !== void 0 && le.module > e2.ModuleKind.ES2015 || !he.exportClause || !e2.isNamespaceExport(he.exportClause) || !he.moduleSpecifier)
                  return he;
                var F2 = he.exportClause.name, x2 = w.getGeneratedNameForNode(F2), X = w.createImportDeclaration(void 0, void 0, w.createImportClause(false, void 0, w.createNamespaceImport(x2)), he.moduleSpecifier, he.assertClause);
                e2.setOriginalNode(X, he.exportClause);
                var $ = e2.isExportNamespaceAsDefaultDeclaration(he) ? w.createExportDefault(x2) : w.createExportDeclaration(void 0, void 0, false, w.createNamedExports([w.createExportSpecifier(false, x2, F2)]));
                return e2.setOriginalNode($, he), [X, $];
              }
              function O(he, F2, x2) {
                e2.isSourceFile(F2) ? ((e2.isExternalModule(F2) || le.isolatedModules) && le.importHelpers && (G = new e2.Map()), p(he, F2, x2), G = void 0) : p(he, F2, x2);
              }
              function ve(he, F2) {
                return F2 = m2(he, F2), G && e2.isIdentifier(F2) && e2.getEmitFlags(F2) & 4096 ? ee(F2) : F2;
              }
              function ee(he) {
                var F2 = e2.idText(he), x2 = G.get(F2);
                return x2 || G.set(F2, x2 = w.createUniqueName(F2, 48)), x2;
              }
            }
            e2.transformECMAScriptModule = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C) {
              var w = C.onSubstituteNode, B = C.onEmitNode, E = e2.transformECMAScriptModule(C), Q = C.onSubstituteNode, le = C.onEmitNode;
              C.onSubstituteNode = w, C.onEmitNode = B;
              var N = e2.transformModule(C), p = C.onSubstituteNode, m2 = C.onEmitNode;
              C.onSubstituteNode = oe, C.onEmitNode = f4, C.enableSubstitution(305), C.enableEmitNotification(305);
              var G;
              return b;
              function oe(J, ie) {
                return e2.isSourceFile(ie) ? (G = ie, w(J, ie)) : G ? G.impliedNodeFormat === e2.ModuleKind.ESNext ? Q(J, ie) : p(J, ie) : w(J, ie);
              }
              function f4(J, ie, R) {
                return e2.isSourceFile(ie) && (G = ie), G ? G.impliedNodeFormat === e2.ModuleKind.ESNext ? le(J, ie, R) : m2(J, ie, R) : B(J, ie, R);
              }
              function T(J) {
                return J.impliedNodeFormat === e2.ModuleKind.ESNext ? E : N;
              }
              function K(J) {
                if (J.isDeclarationFile)
                  return J;
                G = J;
                var ie = T(J)(J);
                return G = void 0, e2.Debug.assert(e2.isSourceFile(ie)), ie;
              }
              function b(J) {
                return J.kind === 305 ? K(J) : se(J);
              }
              function se(J) {
                return C.factory.createBundle(e2.map(J.sourceFiles, K), J.prepends);
              }
            }
            e2.transformNodeModule = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(B) {
              return e2.isVariableDeclaration(B) || e2.isPropertyDeclaration(B) || e2.isPropertySignature(B) || e2.isBindingElement(B) || e2.isSetAccessor(B) || e2.isGetAccessor(B) || e2.isConstructSignatureDeclaration(B) || e2.isCallSignatureDeclaration(B) || e2.isMethodDeclaration(B) || e2.isMethodSignature(B) || e2.isFunctionDeclaration(B) || e2.isParameter(B) || e2.isTypeParameterDeclaration(B) || e2.isExpressionWithTypeArguments(B) || e2.isImportEqualsDeclaration(B) || e2.isTypeAliasDeclaration(B) || e2.isConstructorDeclaration(B) || e2.isIndexSignatureDeclaration(B) || e2.isPropertyAccessExpression(B) || e2.isJSDocTypeAlias(B);
            }
            e2.canProduceDiagnostics = a;
            function C(B) {
              if (e2.isSetAccessor(B) || e2.isGetAccessor(B))
                return E;
              return e2.isMethodSignature(B) || e2.isMethodDeclaration(B) ? le : w(B);
              function E(p) {
                var m2 = Q(p);
                return m2 !== void 0 ? { diagnosticMessage: m2, errorNode: B, typeName: B.name } : void 0;
              }
              function Q(p) {
                return e2.isStatic(B) ? p.errorModuleName ? p.accessibility === 2 ? e2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1 : B.parent.kind === 257 ? p.errorModuleName ? p.accessibility === 2 ? e2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1 : p.errorModuleName ? e2.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
              }
              function le(p) {
                var m2 = N(p);
                return m2 !== void 0 ? { diagnosticMessage: m2, errorNode: B, typeName: B.name } : void 0;
              }
              function N(p) {
                return e2.isStatic(B) ? p.errorModuleName ? p.accessibility === 2 ? e2.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Public_static_method_0_of_exported_class_has_or_is_using_private_name_1 : B.parent.kind === 257 ? p.errorModuleName ? p.accessibility === 2 ? e2.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Public_method_0_of_exported_class_has_or_is_using_private_name_1 : p.errorModuleName ? e2.Diagnostics.Method_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Method_0_of_exported_interface_has_or_is_using_private_name_1;
              }
            }
            e2.createGetSymbolAccessibilityDiagnosticForNodeName = C;
            function w(B) {
              if (e2.isVariableDeclaration(B) || e2.isPropertyDeclaration(B) || e2.isPropertySignature(B) || e2.isPropertyAccessExpression(B) || e2.isBindingElement(B) || e2.isConstructorDeclaration(B))
                return Q;
              return e2.isSetAccessor(B) || e2.isGetAccessor(B) ? le : e2.isConstructSignatureDeclaration(B) || e2.isCallSignatureDeclaration(B) || e2.isMethodDeclaration(B) || e2.isMethodSignature(B) || e2.isFunctionDeclaration(B) || e2.isIndexSignatureDeclaration(B) ? N : e2.isParameter(B) ? e2.isParameterPropertyDeclaration(B, B.parent) && e2.hasSyntacticModifier(B.parent, 8) ? Q : p : e2.isTypeParameterDeclaration(B) ? G : e2.isExpressionWithTypeArguments(B) ? oe : e2.isImportEqualsDeclaration(B) ? f4 : e2.isTypeAliasDeclaration(B) || e2.isJSDocTypeAlias(B) ? T : e2.Debug.assertNever(B, "Attempted to set a declaration diagnostic context for unhandled node kind: ".concat(e2.SyntaxKind[B.kind]));
              function E(K) {
                if (B.kind === 254 || B.kind === 203)
                  return K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Exported_variable_0_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Exported_variable_0_has_or_is_using_private_name_1;
                if (B.kind === 167 || B.kind === 206 || B.kind === 166 || B.kind === 164 && e2.hasSyntacticModifier(B.parent, 8))
                  return e2.isStatic(B) ? K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Public_static_property_0_of_exported_class_has_or_is_using_private_name_1 : B.parent.kind === 257 || B.kind === 164 ? K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Public_property_0_of_exported_class_has_or_is_using_private_name_1 : K.errorModuleName ? e2.Diagnostics.Property_0_of_exported_interface_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Property_0_of_exported_interface_has_or_is_using_private_name_1;
              }
              function Q(K) {
                var b = E(K);
                return b !== void 0 ? { diagnosticMessage: b, errorNode: B, typeName: B.name } : void 0;
              }
              function le(K) {
                var b;
                return B.kind === 173 ? e2.isStatic(B) ? b = K.errorModuleName ? e2.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_type_of_public_static_setter_0_from_exported_class_has_or_is_using_private_name_1 : b = K.errorModuleName ? e2.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_type_of_public_setter_0_from_exported_class_has_or_is_using_private_name_1 : e2.isStatic(B) ? b = K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Return_type_of_public_static_getter_0_from_exported_class_has_or_is_using_private_name_1 : b = K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Return_type_of_public_getter_0_from_exported_class_has_or_is_using_private_name_1, { diagnosticMessage: b, errorNode: B.name, typeName: B.name };
              }
              function N(K) {
                var b;
                switch (B.kind) {
                  case 175:
                    b = K.errorModuleName ? e2.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : e2.Diagnostics.Return_type_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_0;
                    break;
                  case 174:
                    b = K.errorModuleName ? e2.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : e2.Diagnostics.Return_type_of_call_signature_from_exported_interface_has_or_is_using_private_name_0;
                    break;
                  case 176:
                    b = K.errorModuleName ? e2.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : e2.Diagnostics.Return_type_of_index_signature_from_exported_interface_has_or_is_using_private_name_0;
                    break;
                  case 169:
                  case 168:
                    e2.isStatic(B) ? b = K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : e2.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : e2.Diagnostics.Return_type_of_public_static_method_from_exported_class_has_or_is_using_private_name_0 : B.parent.kind === 257 ? b = K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : e2.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_name_0_from_private_module_1 : e2.Diagnostics.Return_type_of_public_method_from_exported_class_has_or_is_using_private_name_0 : b = K.errorModuleName ? e2.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_name_0_from_private_module_1 : e2.Diagnostics.Return_type_of_method_from_exported_interface_has_or_is_using_private_name_0;
                    break;
                  case 256:
                    b = K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_external_module_1_but_cannot_be_named : e2.Diagnostics.Return_type_of_exported_function_has_or_is_using_name_0_from_private_module_1 : e2.Diagnostics.Return_type_of_exported_function_has_or_is_using_private_name_0;
                    break;
                  default:
                    return e2.Debug.fail("This is unknown kind for signature: " + B.kind);
                }
                return { diagnosticMessage: b, errorNode: B.name || B };
              }
              function p(K) {
                var b = m2(K);
                return b !== void 0 ? { diagnosticMessage: b, errorNode: B, typeName: B.name } : void 0;
              }
              function m2(K) {
                switch (B.parent.kind) {
                  case 171:
                    return K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_constructor_from_exported_class_has_or_is_using_private_name_1;
                  case 175:
                  case 180:
                    return K.errorModuleName ? e2.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
                  case 174:
                    return K.errorModuleName ? e2.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
                  case 176:
                    return K.errorModuleName ? e2.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_index_signature_from_exported_interface_has_or_is_using_private_name_1;
                  case 169:
                  case 168:
                    return e2.isStatic(B.parent) ? K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1 : B.parent.parent.kind === 257 ? K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1 : K.errorModuleName ? e2.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
                  case 256:
                  case 179:
                    return K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_exported_function_has_or_is_using_private_name_1;
                  case 173:
                  case 172:
                    return K.errorModuleName ? K.accessibility === 2 ? e2.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_external_module_2_but_cannot_be_named : e2.Diagnostics.Parameter_0_of_accessor_has_or_is_using_name_1_from_private_module_2 : e2.Diagnostics.Parameter_0_of_accessor_has_or_is_using_private_name_1;
                  default:
                    return e2.Debug.fail("Unknown parent for parameter: ".concat(e2.SyntaxKind[B.parent.kind]));
                }
              }
              function G() {
                var K;
                switch (B.parent.kind) {
                  case 257:
                    K = e2.Diagnostics.Type_parameter_0_of_exported_class_has_or_is_using_private_name_1;
                    break;
                  case 258:
                    K = e2.Diagnostics.Type_parameter_0_of_exported_interface_has_or_is_using_private_name_1;
                    break;
                  case 195:
                    K = e2.Diagnostics.Type_parameter_0_of_exported_mapped_object_type_is_using_private_name_1;
                    break;
                  case 180:
                  case 175:
                    K = e2.Diagnostics.Type_parameter_0_of_constructor_signature_from_exported_interface_has_or_is_using_private_name_1;
                    break;
                  case 174:
                    K = e2.Diagnostics.Type_parameter_0_of_call_signature_from_exported_interface_has_or_is_using_private_name_1;
                    break;
                  case 169:
                  case 168:
                    e2.isStatic(B.parent) ? K = e2.Diagnostics.Type_parameter_0_of_public_static_method_from_exported_class_has_or_is_using_private_name_1 : B.parent.parent.kind === 257 ? K = e2.Diagnostics.Type_parameter_0_of_public_method_from_exported_class_has_or_is_using_private_name_1 : K = e2.Diagnostics.Type_parameter_0_of_method_from_exported_interface_has_or_is_using_private_name_1;
                    break;
                  case 179:
                  case 256:
                    K = e2.Diagnostics.Type_parameter_0_of_exported_function_has_or_is_using_private_name_1;
                    break;
                  case 259:
                    K = e2.Diagnostics.Type_parameter_0_of_exported_type_alias_has_or_is_using_private_name_1;
                    break;
                  default:
                    return e2.Debug.fail("This is unknown parent for type parameter: " + B.parent.kind);
                }
                return { diagnosticMessage: K, errorNode: B, typeName: B.name };
              }
              function oe() {
                var K;
                return e2.isClassDeclaration(B.parent.parent) ? K = e2.isHeritageClause(B.parent) && B.parent.token === 117 ? e2.Diagnostics.Implements_clause_of_exported_class_0_has_or_is_using_private_name_1 : B.parent.parent.name ? e2.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1 : e2.Diagnostics.extends_clause_of_exported_class_has_or_is_using_private_name_0 : K = e2.Diagnostics.extends_clause_of_exported_interface_0_has_or_is_using_private_name_1, { diagnosticMessage: K, errorNode: B, typeName: e2.getNameOfDeclaration(B.parent.parent) };
              }
              function f4() {
                return { diagnosticMessage: e2.Diagnostics.Import_declaration_0_is_using_private_name_1, errorNode: B, typeName: B.name };
              }
              function T(K) {
                return { diagnosticMessage: K.errorModuleName ? e2.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1_from_module_2 : e2.Diagnostics.Exported_type_alias_0_has_or_is_using_private_name_1, errorNode: e2.isJSDocTypeAlias(B) ? e2.Debug.checkDefined(B.typeExpression) : B.type, typeName: e2.isJSDocTypeAlias(B) ? e2.getNameOfDeclaration(B) : B.name };
              }
            }
            e2.createGetSymbolAccessibilityDiagnosticForNode = w;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(f4, T, K) {
              var b = f4.getCompilerOptions(), se = e2.transformNodes(T, f4, e2.factory, b, K ? [K] : e2.filter(f4.getSourceFiles(), e2.isSourceFileNotJson), [E], false);
              return se.diagnostics;
            }
            e2.getDeclarationDiagnostics = a;
            function C(f4, T) {
              var K = T.text.substring(f4.pos, f4.end);
              return e2.stringContains(K, "@internal");
            }
            function w(f4, T) {
              var K = e2.getParseTreeNode(f4);
              if (K && K.kind === 164) {
                var b = K.parent.parameters.indexOf(K), se = b > 0 ? K.parent.parameters[b - 1] : void 0, J = T.text, ie = se ? e2.concatenate(e2.getTrailingCommentRanges(J, e2.skipTrivia(J, se.end + 1, false, true)), e2.getLeadingCommentRanges(J, f4.pos)) : e2.getTrailingCommentRanges(J, e2.skipTrivia(J, f4.pos, false, true));
                return ie && ie.length && C(e2.last(ie), T);
              }
              var R = K && e2.getLeadingCommentRangesOfNode(K, T);
              return !!e2.forEach(R, function(q) {
                return C(q, T);
              });
            }
            e2.isInternalDeclaration = w;
            var B = 531469;
            function E(f4) {
              var T = function() {
                return e2.Debug.fail("Diagnostic emitted without context");
              }, K = T, b = true, se = false, J = false, ie = false, R = false, q, O, ve, ee, he, F2, x2 = f4.factory, X = f4.getEmitHost(), $ = { trackSymbol: fe, reportInaccessibleThisError: Fe, reportInaccessibleUniqueSymbolError: ue, reportCyclicStructureError: We, reportPrivateInBaseOfClassExpression: g, reportLikelyUnsafeImportRequiredError: Z2, reportTruncationError: Be, moduleResolverHost: X, trackReferencedAmbientModule: l, trackExternalModuleSymbolOfImportTypeNode: D, reportNonlocalAugmentation: ge, reportNonSerializableProperty: Re }, A2, y, V, L, P, k, Y = f4.getEmitResolver(), U = f4.getCompilerOptions(), j = U.noResolve, H = U.stripInternal;
              return Ee;
              function I(_r) {
                if (!!_r) {
                  O = O || new e2.Set();
                  for (var pi = 0, ae = _r; pi < ae.length; pi++) {
                    var Xe = ae[pi];
                    O.add(Xe);
                  }
                }
              }
              function l(_r, pi) {
                var ae = Y.getTypeReferenceDirectivesForSymbol(pi, 67108863);
                if (e2.length(ae))
                  return I(ae);
                var Xe = e2.getSourceFileOfNode(_r);
                L.set(e2.getOriginalNodeId(Xe), Xe);
              }
              function d(_r) {
                if (_r.accessibility === 0) {
                  if (_r && _r.aliasesToMakeVisible)
                    if (!ve)
                      ve = _r.aliasesToMakeVisible;
                    else
                      for (var pi = 0, ae = _r.aliasesToMakeVisible; pi < ae.length; pi++) {
                        var Xe = ae[pi];
                        e2.pushIfUnique(ve, Xe);
                      }
                } else {
                  var Jr = K(_r);
                  if (Jr)
                    return Jr.typeName ? f4.addDiagnostic(e2.createDiagnosticForNode(_r.errorNode || Jr.errorNode, Jr.diagnosticMessage, e2.getTextOfNode(Jr.typeName), _r.errorSymbolName, _r.errorModuleName)) : f4.addDiagnostic(e2.createDiagnosticForNode(_r.errorNode || Jr.errorNode, Jr.diagnosticMessage, _r.errorSymbolName, _r.errorModuleName)), true;
                }
                return false;
              }
              function D(_r) {
                se || (F2 || (F2 = [])).push(_r);
              }
              function fe(_r, pi, ae) {
                if (_r.flags & 262144)
                  return false;
                var Xe = d(Y.isSymbolAccessible(_r, pi, ae, true));
                return I(Y.getTypeReferenceDirectivesForSymbol(_r, ae)), Xe;
              }
              function g(_r) {
                (A2 || y) && f4.addDiagnostic(e2.createDiagnosticForNode(A2 || y, e2.Diagnostics.Property_0_of_exported_class_expression_may_not_be_private_or_protected, _r));
              }
              function ne() {
                return A2 ? e2.declarationNameToString(A2) : y && e2.getNameOfDeclaration(y) ? e2.declarationNameToString(e2.getNameOfDeclaration(y)) : y && e2.isExportAssignment(y) ? y.isExportEquals ? "export=" : "default" : "(Missing)";
              }
              function ue() {
                (A2 || y) && f4.addDiagnostic(e2.createDiagnosticForNode(A2 || y, e2.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, ne(), "unique symbol"));
              }
              function We() {
                (A2 || y) && f4.addDiagnostic(e2.createDiagnosticForNode(A2 || y, e2.Diagnostics.The_inferred_type_of_0_references_a_type_with_a_cyclic_structure_which_cannot_be_trivially_serialized_A_type_annotation_is_necessary, ne()));
              }
              function Fe() {
                (A2 || y) && f4.addDiagnostic(e2.createDiagnosticForNode(A2 || y, e2.Diagnostics.The_inferred_type_of_0_references_an_inaccessible_1_type_A_type_annotation_is_necessary, ne(), "this"));
              }
              function Z2(_r) {
                (A2 || y) && f4.addDiagnostic(e2.createDiagnosticForNode(A2 || y, e2.Diagnostics.The_inferred_type_of_0_cannot_be_named_without_a_reference_to_1_This_is_likely_not_portable_A_type_annotation_is_necessary, ne(), _r));
              }
              function Be() {
                (A2 || y) && f4.addDiagnostic(e2.createDiagnosticForNode(A2 || y, e2.Diagnostics.The_inferred_type_of_this_node_exceeds_the_maximum_length_the_compiler_will_serialize_An_explicit_type_annotation_is_needed));
              }
              function ge(_r, pi, ae) {
                var Xe, Jr = (Xe = pi.declarations) === null || Xe === void 0 ? void 0 : Xe.find(function(Wr) {
                  return e2.getSourceFileOfNode(Wr) === _r;
                }), ti = e2.filter(ae.declarations, function(Wr) {
                  return e2.getSourceFileOfNode(Wr) !== _r;
                });
                if (ti)
                  for (var Ze = 0, Sr = ti; Ze < Sr.length; Ze++) {
                    var zr = Sr[Ze];
                    f4.addDiagnostic(e2.addRelatedInfo(e2.createDiagnosticForNode(zr, e2.Diagnostics.Declaration_augments_declaration_in_another_file_This_cannot_be_serialized), e2.createDiagnosticForNode(Jr, e2.Diagnostics.This_is_the_declaration_being_augmented_Consider_moving_the_augmenting_declaration_into_the_same_file)));
                  }
              }
              function Re(_r) {
                (A2 || y) && f4.addDiagnostic(e2.createDiagnosticForNode(A2 || y, e2.Diagnostics.The_type_of_this_node_cannot_be_serialized_because_its_property_0_cannot_be_serialized, _r));
              }
              function ze(_r, pi) {
                var ae = K;
                K = function(Jr) {
                  return Jr.errorNode && e2.canProduceDiagnostics(Jr.errorNode) ? e2.createGetSymbolAccessibilityDiagnosticForNode(Jr.errorNode)(Jr) : { diagnosticMessage: Jr.errorModuleName ? e2.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_from_module_1_An_explicit_type_annotation_may_unblock_declaration_emit : e2.Diagnostics.Declaration_emit_for_this_file_requires_using_private_name_0_An_explicit_type_annotation_may_unblock_declaration_emit, errorNode: Jr.errorNode || _r };
                };
                var Xe = Y.getDeclarationStatementsForSourceFile(_r, B, $, pi);
                return K = ae, Xe;
              }
              function Ee(_r) {
                if (_r.kind === 305 && _r.isDeclarationFile)
                  return _r;
                if (_r.kind === 306) {
                  se = true, L = new e2.Map(), P = new e2.Map();
                  var pi = false, ae = x2.createBundle(e2.map(_r.sourceFiles, function(Oe) {
                    if (!Oe.isDeclarationFile) {
                      if (pi = pi || Oe.hasNoDefaultLib, V = Oe, q = Oe, ve = void 0, he = false, ee = new e2.Map(), K = T, ie = false, R = false, He(Oe, L), rr(Oe, P), e2.isExternalOrCommonJsModule(Oe) || e2.isJsonSourceFile(Oe)) {
                        J = false, b = false;
                        var nr = e2.isSourceFileJS(Oe) ? x2.createNodeArray(ze(Oe, true)) : e2.visitNodes(Oe.statements, Ur), Mr = x2.updateSourceFile(Oe, [x2.createModuleDeclaration([], [x2.createModifier(135)], x2.createStringLiteral(e2.getResolvedExternalModuleName(f4.getEmitHost(), Oe)), x2.createModuleBlock(e2.setTextRange(x2.createNodeArray(yr(nr)), Oe.statements)))], true, [], [], false, []);
                        return Mr;
                      }
                      b = true;
                      var Pe = e2.isSourceFileJS(Oe) ? x2.createNodeArray(ze(Oe)) : e2.visitNodes(Oe.statements, Ur);
                      return x2.updateSourceFile(Oe, yr(Pe), true, [], [], false, []);
                    }
                  }), e2.mapDefined(_r.prepends, function(Oe) {
                    if (Oe.kind === 308) {
                      var nr = e2.createUnparsedSourceFile(Oe, "dts", H);
                      return pi = pi || !!nr.hasNoDefaultLib, He(nr, L), I(e2.map(nr.typeReferenceDirectives, function(Mr) {
                        return [Mr.fileName, Mr.resolutionMode];
                      })), rr(nr, P), nr;
                    }
                    return Oe;
                  }));
                  ae.syntheticFileReferences = [], ae.syntheticTypeReferences = vr(), ae.syntheticLibReferences = xe(), ae.hasNoDefaultLib = pi;
                  var Xe = e2.getDirectoryPath(e2.normalizeSlashes(e2.getOutputPathsFor(_r, X, true).declarationFilePath)), Jr = Ar(ae.syntheticFileReferences, Xe);
                  return L.forEach(Jr), ae;
                }
                b = true, ie = false, R = false, q = _r, V = _r, K = T, se = false, J = false, he = false, ve = void 0, ee = new e2.Map(), O = void 0, L = He(V, new e2.Map()), P = rr(V, new e2.Map());
                var ti = [], Ze = e2.getDirectoryPath(e2.normalizeSlashes(e2.getOutputPathsFor(_r, X, true).declarationFilePath)), Sr = Ar(ti, Ze), zr;
                if (e2.isSourceFileJS(V))
                  zr = x2.createNodeArray(ze(_r)), L.forEach(Sr), k = e2.filter(zr, e2.isAnyImportSyntax);
                else {
                  var Wr = e2.visitNodes(_r.statements, Ur);
                  zr = e2.setTextRange(x2.createNodeArray(yr(Wr)), _r.statements), L.forEach(Sr), k = e2.filter(zr, e2.isAnyImportSyntax), e2.isExternalModule(_r) && (!J || ie && !R) && (zr = e2.setTextRange(x2.createNodeArray(Ve(Ve([], zr, true), [e2.createEmptyExports(x2)], false)), zr));
                }
                var Je = x2.updateSourceFile(_r, zr, true, ti, vr(), _r.hasNoDefaultLib, xe());
                return Je.exportedModulesFromDeclarationEmit = F2, Je;
                function xe() {
                  return e2.map(e2.arrayFrom(P.keys()), function(Oe) {
                    return { fileName: Oe, pos: -1, end: -1 };
                  });
                }
                function vr() {
                  return O ? e2.mapDefined(e2.arrayFrom(O.keys()), mr) : [];
                }
                function mr(Oe) {
                  var nr = Oe[0], Mr = Oe[1];
                  if (k)
                    for (var Pe = 0, Ue = k; Pe < Ue.length; Pe++) {
                      var fr = Ue[Pe];
                      if (e2.isImportEqualsDeclaration(fr) && e2.isExternalModuleReference(fr.moduleReference)) {
                        var De = fr.moduleReference.expression;
                        if (e2.isStringLiteralLike(De) && De.text === nr)
                          return;
                      } else if (e2.isImportDeclaration(fr) && e2.isStringLiteral(fr.moduleSpecifier) && fr.moduleSpecifier.text === nr)
                        return;
                    }
                  return Ke({ fileName: nr, pos: -1, end: -1 }, Mr ? { resolutionMode: Mr } : void 0);
                }
                function Ar(Oe, nr) {
                  return function(Mr) {
                    var Pe;
                    if (Mr.isDeclarationFile)
                      Pe = Mr.fileName;
                    else {
                      if (se && e2.contains(_r.sourceFiles, Mr))
                        return;
                      var Ue = e2.getOutputPathsFor(Mr, X, true);
                      Pe = Ue.declarationFilePath || Ue.jsFilePath || Mr.fileName;
                    }
                    if (Pe) {
                      var fr = e2.moduleSpecifiers.getModuleSpecifier(U, V, e2.toPath(nr, X.getCurrentDirectory(), X.getCanonicalFileName), e2.toPath(Pe, X.getCurrentDirectory(), X.getCanonicalFileName), X);
                      if (!e2.pathIsRelative(fr)) {
                        I([[fr, void 0]]);
                        return;
                      }
                      var De = e2.getRelativePathToDirectoryOrUrl(nr, Pe, X.getCurrentDirectory(), X.getCanonicalFileName, false);
                      if (e2.startsWith(De, "./") && e2.hasExtension(De) && (De = De.substring(2)), e2.startsWith(De, "node_modules/") || e2.pathContainsNodeModules(De))
                        return;
                      Oe.push({ pos: -1, end: -1, fileName: De });
                    }
                  };
                }
              }
              function He(_r, pi) {
                return j || !e2.isUnparsedSource(_r) && e2.isSourceFileJS(_r) || e2.forEach(_r.referencedFiles, function(ae) {
                  var Xe = X.getSourceFileFromReference(_r, ae);
                  Xe && pi.set(e2.getOriginalNodeId(Xe), Xe);
                }), pi;
              }
              function rr(_r, pi) {
                return e2.forEach(_r.libReferenceDirectives, function(ae) {
                  var Xe = X.getLibFileFromReference(ae);
                  Xe && pi.set(e2.toFileNameLowerCase(ae.fileName), true);
                }), pi;
              }
              function Ie(_r) {
                if (_r.kind === 79)
                  return _r;
                return _r.kind === 202 ? x2.updateArrayBindingPattern(_r, e2.visitNodes(_r.elements, pi)) : x2.updateObjectBindingPattern(_r, e2.visitNodes(_r.elements, pi));
                function pi(ae) {
                  return ae.kind === 227 ? ae : x2.updateBindingElement(ae, ae.dotDotDotToken, ae.propertyName, Ie(ae.name), we(ae) ? ae.initializer : void 0);
                }
              }
              function _e(_r, pi, ae) {
                var Xe;
                he || (Xe = K, K = e2.createGetSymbolAccessibilityDiagnosticForNode(_r));
                var Jr = x2.updateParameterDeclaration(_r, void 0, le(_r, pi), _r.dotDotDotToken, Ie(_r.name), Y.isOptionalParameter(_r) ? _r.questionToken || x2.createToken(57) : void 0, ye(_r, ae || _r.type, true), de(_r));
                return he || (K = Xe), Jr;
              }
              function we(_r) {
                return m2(_r) && Y.isLiteralConstDeclaration(e2.getParseTreeNode(_r));
              }
              function de(_r) {
                if (we(_r))
                  return Y.createLiteralConstValue(e2.getParseTreeNode(_r), $);
              }
              function ye(_r, pi, ae) {
                if (!ae && e2.hasEffectiveModifier(_r, 8) || we(_r))
                  return;
                var Xe = _r.kind === 164 && (Y.isRequiredInitializedParameter(_r) || Y.isOptionalUninitializedParameterProperty(_r));
                if (pi && !Xe)
                  return e2.visitNode(pi, Ir);
                if (!e2.getParseTreeNode(_r))
                  return pi ? e2.visitNode(pi, Ir) : x2.createKeywordTypeNode(130);
                if (_r.kind === 173)
                  return x2.createKeywordTypeNode(130);
                A2 = _r.name;
                var Jr;
                if (he || (Jr = K, K = e2.createGetSymbolAccessibilityDiagnosticForNode(_r)), _r.kind === 254 || _r.kind === 203)
                  return ti(Y.createTypeOfDeclaration(_r, q, B, $));
                if (_r.kind === 164 || _r.kind === 167 || _r.kind === 166)
                  return _r.initializer ? ti(Y.createTypeOfDeclaration(_r, q, B, $, Xe) || Y.createTypeOfExpression(_r.initializer, q, B, $)) : ti(Y.createTypeOfDeclaration(_r, q, B, $, Xe));
                return ti(Y.createReturnTypeOfSignatureDeclaration(_r, q, B, $));
                function ti(Ze) {
                  return A2 = void 0, he || (K = Jr), Ze || x2.createKeywordTypeNode(130);
                }
              }
              function Ae(_r) {
                switch (_r = e2.getParseTreeNode(_r), _r.kind) {
                  case 256:
                  case 261:
                  case 258:
                  case 257:
                  case 259:
                  case 260:
                    return !Y.isDeclarationVisible(_r);
                  case 254:
                    return !ir(_r);
                  case 265:
                  case 266:
                  case 272:
                  case 271:
                    return false;
                  case 170:
                    return true;
                }
                return false;
              }
              function er(_r) {
                var pi;
                if (_r.body)
                  return true;
                var ae = (pi = _r.symbol.declarations) === null || pi === void 0 ? void 0 : pi.filter(function(Xe) {
                  return e2.isFunctionDeclaration(Xe) && !Xe.body;
                });
                return !ae || ae.indexOf(_r) === ae.length - 1;
              }
              function ir(_r) {
                return e2.isOmittedExpression(_r) ? false : e2.isBindingPattern(_r.name) ? e2.some(_r.name.elements, ir) : Y.isDeclarationVisible(_r);
              }
              function Cr(_r, pi, ae) {
                if (!e2.hasEffectiveModifier(_r, 8)) {
                  var Xe = e2.map(pi, function(Jr) {
                    return _e(Jr, ae);
                  });
                  if (!!Xe)
                    return x2.createNodeArray(Xe, pi.hasTrailingComma);
                }
              }
              function Ye(_r, pi) {
                var ae;
                if (!pi) {
                  var Xe = e2.getThisParameter(_r);
                  Xe && (ae = [_e(Xe)]);
                }
                if (e2.isSetAccessorDeclaration(_r)) {
                  var Jr = void 0;
                  if (!pi) {
                    var ti = e2.getSetAccessorValueParameter(_r);
                    if (ti) {
                      var Ze = Wt(_r, Y.getAllAccessorDeclarations(_r));
                      Jr = _e(ti, void 0, Ze);
                    }
                  }
                  Jr || (Jr = x2.createParameterDeclaration(void 0, void 0, void 0, "value")), ae = e2.append(ae, Jr);
                }
                return x2.createNodeArray(ae || e2.emptyArray);
              }
              function Br(_r, pi) {
                return e2.hasEffectiveModifier(_r, 8) ? void 0 : e2.visitNodes(pi, Ir);
              }
              function Er(_r) {
                return e2.isSourceFile(_r) || e2.isTypeAliasDeclaration(_r) || e2.isModuleDeclaration(_r) || e2.isClassDeclaration(_r) || e2.isInterfaceDeclaration(_r) || e2.isFunctionLike(_r) || e2.isIndexSignatureDeclaration(_r) || e2.isMappedTypeNode(_r);
              }
              function Ne(_r, pi) {
                var ae = Y.isEntityNameVisible(_r, pi);
                d(ae), I(Y.getTypeReferenceDirectivesForEntityName(_r));
              }
              function n(_r, pi) {
                return e2.hasJSDocNodes(_r) && e2.hasJSDocNodes(pi) && (_r.jsDoc = pi.jsDoc), e2.setCommentRange(_r, e2.getCommentRange(pi));
              }
              function lr(_r, pi) {
                if (!!pi) {
                  if (J = J || _r.kind !== 261 && _r.kind !== 200, e2.isStringLiteralLike(pi))
                    if (se) {
                      var ae = e2.getExternalModuleNameFromDeclaration(f4.getEmitHost(), Y, _r);
                      if (ae)
                        return x2.createStringLiteral(ae);
                    } else {
                      var Xe = Y.getSymbolOfExternalModuleSpecifier(pi);
                      Xe && (F2 || (F2 = [])).push(Xe);
                    }
                  return pi;
                }
              }
              function be(_r) {
                if (!!Y.isDeclarationVisible(_r))
                  if (_r.moduleReference.kind === 277) {
                    var pi = e2.getExternalModuleImportEqualsDeclarationExpression(_r);
                    return x2.updateImportEqualsDeclaration(_r, void 0, _r.modifiers, _r.isTypeOnly, _r.name, x2.updateExternalModuleReference(_r.moduleReference, lr(_r, pi)));
                  } else {
                    var ae = K;
                    return K = e2.createGetSymbolAccessibilityDiagnosticForNode(_r), Ne(_r.moduleReference, q), K = ae, _r;
                  }
              }
              function Ge(_r) {
                if (!_r.importClause)
                  return x2.updateImportDeclaration(_r, void 0, _r.modifiers, _r.importClause, lr(_r, _r.moduleSpecifier), ur(_r.assertClause));
                var pi = _r.importClause && _r.importClause.name && Y.isDeclarationVisible(_r.importClause) ? _r.importClause.name : void 0;
                if (!_r.importClause.namedBindings)
                  return pi && x2.updateImportDeclaration(_r, void 0, _r.modifiers, x2.updateImportClause(_r.importClause, _r.importClause.isTypeOnly, pi, void 0), lr(_r, _r.moduleSpecifier), ur(_r.assertClause));
                if (_r.importClause.namedBindings.kind === 268) {
                  var ae = Y.isDeclarationVisible(_r.importClause.namedBindings) ? _r.importClause.namedBindings : void 0;
                  return pi || ae ? x2.updateImportDeclaration(_r, void 0, _r.modifiers, x2.updateImportClause(_r.importClause, _r.importClause.isTypeOnly, pi, ae), lr(_r, _r.moduleSpecifier), ur(_r.assertClause)) : void 0;
                }
                var Xe = e2.mapDefined(_r.importClause.namedBindings.elements, function(Jr) {
                  return Y.isDeclarationVisible(Jr) ? Jr : void 0;
                });
                if (Xe && Xe.length || pi)
                  return x2.updateImportDeclaration(_r, void 0, _r.modifiers, x2.updateImportClause(_r.importClause, _r.importClause.isTypeOnly, pi, Xe && Xe.length ? x2.updateNamedImports(_r.importClause.namedBindings, Xe) : void 0), lr(_r, _r.moduleSpecifier), ur(_r.assertClause));
                if (Y.isImportRequiredByAugmentation(_r))
                  return x2.updateImportDeclaration(_r, void 0, _r.modifiers, void 0, lr(_r, _r.moduleSpecifier), ur(_r.assertClause));
              }
              function ur(_r) {
                var pi = e2.getResolutionModeOverrideForClause(_r);
                if (pi !== void 0)
                  return e2.isNightly() || f4.addDiagnostic(e2.createDiagnosticForNode(_r, e2.Diagnostics.Resolution_mode_assertions_are_unstable_Use_nightly_TypeScript_to_silence_this_error_Try_updating_with_npm_install_D_typescript_next)), _r;
              }
              function yr(_r) {
                for (; e2.length(ve); ) {
                  var pi = ve.shift();
                  if (!e2.isLateVisibilityPaintedStatement(pi))
                    return e2.Debug.fail("Late replaced statement was found which is not handled by the declaration transformer!: ".concat(e2.SyntaxKind ? e2.SyntaxKind[pi.kind] : pi.kind));
                  var ae = b;
                  b = pi.parent && e2.isSourceFile(pi.parent) && !(e2.isExternalModule(pi.parent) && se);
                  var Xe = mi(pi);
                  b = ae, ee.set(e2.getOriginalNodeId(pi), Xe);
                }
                return e2.visitNodes(_r, Jr);
                function Jr(ti) {
                  if (e2.isLateVisibilityPaintedStatement(ti)) {
                    var Ze = e2.getOriginalNodeId(ti);
                    if (ee.has(Ze)) {
                      var Sr = ee.get(Ze);
                      return ee.delete(Ze), Sr && ((e2.isArray(Sr) ? e2.some(Sr, e2.needsScopeMarker) : e2.needsScopeMarker(Sr)) && (ie = true), e2.isSourceFile(ti.parent) && (e2.isArray(Sr) ? e2.some(Sr, e2.isExternalModuleIndicator) : e2.isExternalModuleIndicator(Sr)) && (J = true)), Sr;
                    }
                  }
                  return ti;
                }
              }
              function Ir(_r) {
                if (Di(_r) || e2.isDeclaration(_r) && (Ae(_r) || e2.hasDynamicName(_r) && !Y.isLateBound(e2.getParseTreeNode(_r))) || e2.isFunctionLike(_r) && Y.isImplementationOfOverload(_r) || e2.isSemicolonClassElement(_r))
                  return;
                var pi;
                Er(_r) && (pi = q, q = _r);
                var ae = K, Xe = e2.canProduceDiagnostics(_r), Jr = he, ti = (_r.kind === 182 || _r.kind === 195) && _r.parent.kind !== 259;
                if ((e2.isMethodDeclaration(_r) || e2.isMethodSignature(_r)) && e2.hasEffectiveModifier(_r, 8))
                  return _r.symbol && _r.symbol.declarations && _r.symbol.declarations[0] !== _r ? void 0 : Oe(x2.createPropertyDeclaration(void 0, et(_r), _r.name, void 0, void 0, void 0));
                if (Xe && !he && (K = e2.createGetSymbolAccessibilityDiagnosticForNode(_r)), e2.isTypeQueryNode(_r) && Ne(_r.exprName, q), ti && (he = true), oe(_r))
                  switch (_r.kind) {
                    case 228: {
                      (e2.isEntityName(_r.expression) || e2.isEntityNameExpression(_r.expression)) && Ne(_r.expression, q);
                      var Ze = e2.visitEachChild(_r, Ir, f4);
                      return Oe(x2.updateExpressionWithTypeArguments(Ze, Ze.expression, Ze.typeArguments));
                    }
                    case 178: {
                      Ne(_r.typeName, q);
                      var Ze = e2.visitEachChild(_r, Ir, f4);
                      return Oe(x2.updateTypeReferenceNode(Ze, Ze.typeName, Ze.typeArguments));
                    }
                    case 175:
                      return Oe(x2.updateConstructSignature(_r, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type)));
                    case 171: {
                      var Sr = x2.createConstructorDeclaration(void 0, et(_r), Cr(_r, _r.parameters, 0), void 0);
                      return Oe(Sr);
                    }
                    case 169: {
                      if (e2.isPrivateIdentifier(_r.name))
                        return Oe(void 0);
                      var zr = x2.createMethodDeclaration(void 0, et(_r), void 0, _r.name, _r.questionToken, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type), void 0);
                      return Oe(zr);
                    }
                    case 172: {
                      if (e2.isPrivateIdentifier(_r.name))
                        return Oe(void 0);
                      var Wr = Wt(_r, Y.getAllAccessorDeclarations(_r));
                      return Oe(x2.updateGetAccessorDeclaration(_r, void 0, et(_r), _r.name, Ye(_r, e2.hasEffectiveModifier(_r, 8)), ye(_r, Wr), void 0));
                    }
                    case 173:
                      return e2.isPrivateIdentifier(_r.name) ? Oe(void 0) : Oe(x2.updateSetAccessorDeclaration(_r, void 0, et(_r), _r.name, Ye(_r, e2.hasEffectiveModifier(_r, 8)), void 0));
                    case 167:
                      return e2.isPrivateIdentifier(_r.name) ? Oe(void 0) : Oe(x2.updatePropertyDeclaration(_r, void 0, et(_r), _r.name, _r.questionToken, ye(_r, _r.type), de(_r)));
                    case 166:
                      return e2.isPrivateIdentifier(_r.name) ? Oe(void 0) : Oe(x2.updatePropertySignature(_r, et(_r), _r.name, _r.questionToken, ye(_r, _r.type)));
                    case 168:
                      return e2.isPrivateIdentifier(_r.name) ? Oe(void 0) : Oe(x2.updateMethodSignature(_r, et(_r), _r.name, _r.questionToken, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type)));
                    case 174:
                      return Oe(x2.updateCallSignature(_r, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type)));
                    case 176:
                      return Oe(x2.updateIndexSignature(_r, void 0, et(_r), Cr(_r, _r.parameters), e2.visitNode(_r.type, Ir) || x2.createKeywordTypeNode(130)));
                    case 254:
                      return e2.isBindingPattern(_r.name) ? or(_r.name) : (ti = true, he = true, Oe(x2.updateVariableDeclaration(_r, _r.name, void 0, ye(_r, _r.type), de(_r))));
                    case 163:
                      return wr(_r) && (_r.default || _r.constraint) ? Oe(x2.updateTypeParameterDeclaration(_r, _r.modifiers, _r.name, void 0, void 0)) : Oe(e2.visitEachChild(_r, Ir, f4));
                    case 189: {
                      var Je = e2.visitNode(_r.checkType, Ir), xe = e2.visitNode(_r.extendsType, Ir), vr = q;
                      q = _r.trueType;
                      var mr = e2.visitNode(_r.trueType, Ir);
                      q = vr;
                      var Ar = e2.visitNode(_r.falseType, Ir);
                      return Oe(x2.updateConditionalTypeNode(_r, Je, xe, mr, Ar));
                    }
                    case 179:
                      return Oe(x2.updateFunctionTypeNode(_r, e2.visitNodes(_r.typeParameters, Ir), Cr(_r, _r.parameters), e2.visitNode(_r.type, Ir)));
                    case 180:
                      return Oe(x2.updateConstructorTypeNode(_r, et(_r), e2.visitNodes(_r.typeParameters, Ir), Cr(_r, _r.parameters), e2.visitNode(_r.type, Ir)));
                    case 200:
                      return e2.isLiteralImportTypeNode(_r) ? Oe(x2.updateImportTypeNode(_r, x2.updateLiteralTypeNode(_r.argument, lr(_r, _r.argument.literal)), _r.assertions, _r.qualifier, e2.visitNodes(_r.typeArguments, Ir, e2.isTypeNode), _r.isTypeOf)) : Oe(_r);
                    default:
                      e2.Debug.assertNever(_r, "Attempted to process unhandled node kind: ".concat(e2.SyntaxKind[_r.kind]));
                  }
                return e2.isTupleTypeNode(_r) && e2.getLineAndCharacterOfPosition(V, _r.pos).line === e2.getLineAndCharacterOfPosition(V, _r.end).line && e2.setEmitFlags(_r, 1), Oe(e2.visitEachChild(_r, Ir, f4));
                function Oe(nr) {
                  return nr && Xe && e2.hasDynamicName(_r) && si(_r), Er(_r) && (q = pi), Xe && !he && (K = ae), ti && (he = Jr), nr === _r ? nr : nr && e2.setOriginalNode(n(nr, _r), _r);
                }
              }
              function wr(_r) {
                return _r.parent.kind === 169 && e2.hasEffectiveModifier(_r.parent, 8);
              }
              function Ur(_r) {
                if (!!G(_r) && !Di(_r)) {
                  switch (_r.kind) {
                    case 272:
                      return e2.isSourceFile(_r.parent) && (J = true), R = true, x2.updateExportDeclaration(_r, void 0, _r.modifiers, _r.isTypeOnly, _r.exportClause, lr(_r, _r.moduleSpecifier), e2.getResolutionModeOverrideForClause(_r.assertClause) ? _r.assertClause : void 0);
                    case 271: {
                      if (e2.isSourceFile(_r.parent) && (J = true), R = true, _r.expression.kind === 79)
                        return _r;
                      var pi = x2.createUniqueName("_default", 16);
                      K = function() {
                        return { diagnosticMessage: e2.Diagnostics.Default_export_of_the_module_has_or_is_using_private_name_0, errorNode: _r };
                      }, y = _r;
                      var ae = x2.createVariableDeclaration(pi, void 0, Y.createTypeOfExpression(_r.expression, _r, B, $), void 0);
                      y = void 0;
                      var Xe = x2.createVariableStatement(b ? [x2.createModifier(135)] : [], x2.createVariableDeclarationList([ae], 2));
                      return n(Xe, _r), e2.removeAllComments(_r), [Xe, x2.updateExportAssignment(_r, _r.decorators, _r.modifiers, pi)];
                    }
                  }
                  var Jr = mi(_r);
                  return ee.set(e2.getOriginalNodeId(_r), Jr), _r;
                }
              }
              function ii(_r) {
                if (e2.isImportEqualsDeclaration(_r) || e2.hasEffectiveModifier(_r, 512) || !e2.canHaveModifiers(_r))
                  return _r;
                var pi = x2.createModifiersFromModifierFlags(e2.getEffectiveModifierFlags(_r) & 125950);
                return x2.updateModifiers(_r, pi);
              }
              function mi(_r) {
                if (ve)
                  for (; e2.orderedRemoveItem(ve, _r); )
                    ;
                if (Di(_r))
                  return;
                switch (_r.kind) {
                  case 265:
                    return be(_r);
                  case 266:
                    return Ge(_r);
                }
                if (e2.isDeclaration(_r) && Ae(_r) || e2.isFunctionLike(_r) && Y.isImplementationOfOverload(_r))
                  return;
                var pi;
                Er(_r) && (pi = q, q = _r);
                var ae = e2.canProduceDiagnostics(_r), Xe = K;
                ae && (K = e2.createGetSymbolAccessibilityDiagnosticForNode(_r));
                var Jr = b;
                switch (_r.kind) {
                  case 259:
                    return Ii(x2.updateTypeAliasDeclaration(_r, void 0, et(_r), _r.name, e2.visitNodes(_r.typeParameters, Ir, e2.isTypeParameterDeclaration), e2.visitNode(_r.type, Ir, e2.isTypeNode)));
                  case 258:
                    return Ii(x2.updateInterfaceDeclaration(_r, void 0, et(_r), _r.name, Br(_r, _r.typeParameters), Zt(_r.heritageClauses), e2.visitNodes(_r.members, Ir)));
                  case 256: {
                    var ti = Ii(x2.updateFunctionDeclaration(_r, void 0, et(_r), void 0, _r.name, Br(_r, _r.typeParameters), Cr(_r, _r.parameters), ye(_r, _r.type), void 0));
                    if (ti && Y.isExpandoFunctionDeclaration(_r) && er(_r)) {
                      var Ze = Y.getPropertiesOfContainerFunction(_r), Sr = e2.parseNodeFactory.createModuleDeclaration(void 0, void 0, ti.name || x2.createIdentifier("_default"), x2.createModuleBlock([]), 16);
                      e2.setParent(Sr, q), Sr.locals = e2.createSymbolTable(Ze), Sr.symbol = Ze[0].parent;
                      var zr = [], Wr = e2.mapDefined(Ze, function(Ki) {
                        if (!(!Ki.valueDeclaration || !e2.isPropertyAccessExpression(Ki.valueDeclaration))) {
                          K = e2.createGetSymbolAccessibilityDiagnosticForNode(Ki.valueDeclaration);
                          var Fi = Y.createTypeOfDeclaration(Ki.valueDeclaration, Sr, B, $);
                          K = Xe;
                          var ui = e2.unescapeLeadingUnderscores(Ki.escapedName), Bt = e2.isStringANonContextualKeyword(ui), wt = Bt ? x2.getGeneratedNameForNode(Ki.valueDeclaration) : x2.createIdentifier(ui);
                          Bt && zr.push([wt, ui]);
                          var na = x2.createVariableDeclaration(wt, void 0, Fi, void 0);
                          return x2.createVariableStatement(Bt ? void 0 : [x2.createToken(93)], x2.createVariableDeclarationList([na]));
                        }
                      });
                      zr.length ? Wr.push(x2.createExportDeclaration(void 0, void 0, false, x2.createNamedExports(e2.map(zr, function(Ki) {
                        var Fi = Ki[0], ui = Ki[1];
                        return x2.createExportSpecifier(false, Fi, ui);
                      })))) : Wr = e2.mapDefined(Wr, function(Ki) {
                        return x2.updateModifiers(Ki, 0);
                      });
                      var Je = x2.createModuleDeclaration(void 0, et(_r), _r.name, x2.createModuleBlock(Wr), 16);
                      if (!e2.hasEffectiveModifier(ti, 512))
                        return [ti, Je];
                      var xe = x2.createModifiersFromModifierFlags(e2.getEffectiveModifierFlags(ti) & -514 | 2), vr = x2.updateFunctionDeclaration(ti, void 0, xe, void 0, ti.name, ti.typeParameters, ti.parameters, ti.type, void 0), mr = x2.updateModuleDeclaration(Je, void 0, xe, Je.name, Je.body), Ar = x2.createExportAssignment(void 0, void 0, false, Je.name);
                      return e2.isSourceFile(_r.parent) && (J = true), R = true, [vr, mr, Ar];
                    } else
                      return ti;
                  }
                  case 261: {
                    b = false;
                    var Oe = _r.body;
                    if (Oe && Oe.kind === 262) {
                      var nr = ie, Mr = R;
                      R = false, ie = false;
                      var Pe = e2.visitNodes(Oe.statements, Ur), Ue = yr(Pe);
                      _r.flags & 16777216 && (ie = false), !e2.isGlobalScopeAugmentation(_r) && !Xi(Ue) && !R && (ie ? Ue = x2.createNodeArray(Ve(Ve([], Ue, true), [e2.createEmptyExports(x2)], false)) : Ue = e2.visitNodes(Ue, ii));
                      var fr = x2.updateModuleBlock(Oe, Ue);
                      b = Jr, ie = nr, R = Mr;
                      var De = et(_r);
                      return Ii(x2.updateModuleDeclaration(_r, void 0, De, e2.isExternalModuleAugmentation(_r) ? lr(_r, _r.name) : _r.name, fr));
                    } else {
                      b = Jr;
                      var De = et(_r);
                      b = false, e2.visitNode(Oe, Ur);
                      var gr = e2.getOriginalNodeId(Oe), fr = ee.get(gr);
                      return ee.delete(gr), Ii(x2.updateModuleDeclaration(_r, void 0, De, _r.name, fr));
                    }
                  }
                  case 257: {
                    A2 = _r.name, y = _r;
                    var xe = x2.createNodeArray(et(_r)), Vr = Br(_r, _r.typeParameters), Tr = e2.getFirstConstructorWithBody(_r), vi = void 0;
                    if (Tr) {
                      var Ui = K;
                      vi = e2.compact(e2.flatMap(Tr.parameters, function(Fi) {
                        if (!e2.hasSyntacticModifier(Fi, 16476) || Di(Fi))
                          return;
                        if (K = e2.createGetSymbolAccessibilityDiagnosticForNode(Fi), Fi.name.kind === 79)
                          return n(x2.createPropertyDeclaration(void 0, et(Fi), Fi.name, Fi.questionToken, ye(Fi, Fi.type), de(Fi)), Fi);
                        return ui(Fi.name);
                        function ui(Bt) {
                          for (var wt, na = 0, Ai = Bt.elements; na < Ai.length; na++) {
                            var Oi = Ai[na];
                            e2.isOmittedExpression(Oi) || (e2.isBindingPattern(Oi.name) && (wt = e2.concatenate(wt, ui(Oi.name))), wt = wt || [], wt.push(x2.createPropertyDeclaration(void 0, et(Fi), Oi.name, void 0, ye(Oi, void 0), void 0)));
                          }
                          return wt;
                        }
                      })), K = Ui;
                    }
                    var Yi = e2.some(_r.members, function(Fi) {
                      return !!Fi.name && e2.isPrivateIdentifier(Fi.name);
                    }), Wi = Yi ? [x2.createPropertyDeclaration(void 0, void 0, x2.createPrivateIdentifier("#private"), void 0, void 0, void 0)] : void 0, ct = e2.concatenate(e2.concatenate(Wi, vi), e2.visitNodes(_r.members, Ir)), Li = x2.createNodeArray(ct), nt = e2.getEffectiveBaseTypeNode(_r);
                    if (nt && !e2.isEntityNameExpression(nt.expression) && nt.expression.kind !== 104) {
                      var Mt = _r.name ? e2.unescapeLeadingUnderscores(_r.name.escapedText) : "default", xt = x2.createUniqueName("".concat(Mt, "_base"), 16);
                      K = function() {
                        return { diagnosticMessage: e2.Diagnostics.extends_clause_of_exported_class_0_has_or_is_using_private_name_1, errorNode: nt, typeName: _r.name };
                      };
                      var ut = x2.createVariableDeclaration(xt, void 0, Y.createTypeOfExpression(nt.expression, _r, B, $), void 0), Dt = x2.createVariableStatement(b ? [x2.createModifier(135)] : [], x2.createVariableDeclarationList([ut], 2)), Rt = x2.createNodeArray(e2.map(_r.heritageClauses, function(Fi) {
                        if (Fi.token === 94) {
                          var ui = K;
                          K = e2.createGetSymbolAccessibilityDiagnosticForNode(Fi.types[0]);
                          var Bt = x2.updateHeritageClause(Fi, e2.map(Fi.types, function(wt) {
                            return x2.updateExpressionWithTypeArguments(wt, xt, e2.visitNodes(wt.typeArguments, Ir));
                          }));
                          return K = ui, Bt;
                        }
                        return x2.updateHeritageClause(Fi, e2.visitNodes(x2.createNodeArray(e2.filter(Fi.types, function(wt) {
                          return e2.isEntityNameExpression(wt.expression) || wt.expression.kind === 104;
                        })), Ir));
                      }));
                      return [Dt, Ii(x2.updateClassDeclaration(_r, void 0, xe, _r.name, Vr, Rt, Li))];
                    } else {
                      var Rt = Zt(_r.heritageClauses);
                      return Ii(x2.updateClassDeclaration(_r, void 0, xe, _r.name, Vr, Rt, Li));
                    }
                  }
                  case 237:
                    return Ii(pe(_r));
                  case 260:
                    return Ii(x2.updateEnumDeclaration(_r, void 0, x2.createNodeArray(et(_r)), _r.name, x2.createNodeArray(e2.mapDefined(_r.members, function(Ki) {
                      if (!Di(Ki)) {
                        var Fi = Y.getConstantValue(Ki);
                        return n(x2.updateEnumMember(Ki, Ki.name, Fi !== void 0 ? typeof Fi == "string" ? x2.createStringLiteral(Fi) : x2.createNumericLiteral(Fi) : void 0), Ki);
                      }
                    }))));
                }
                return e2.Debug.assertNever(_r, "Unhandled top-level node in declaration emit: ".concat(e2.SyntaxKind[_r.kind]));
                function Ii(Ki) {
                  return Er(_r) && (q = pi), ae && (K = Xe), _r.kind === 261 && (b = Jr), Ki === _r ? Ki : (y = void 0, A2 = void 0, Ki && e2.setOriginalNode(n(Ki, _r), _r));
                }
              }
              function pe(_r) {
                if (!!e2.forEach(_r.declarationList.declarations, ir)) {
                  var pi = e2.visitNodes(_r.declarationList.declarations, Ir);
                  if (!!e2.length(pi))
                    return x2.updateVariableStatement(_r, x2.createNodeArray(et(_r)), x2.updateVariableDeclarationList(_r.declarationList, pi));
                }
              }
              function or(_r) {
                return e2.flatten(e2.mapDefined(_r.elements, function(pi) {
                  return qr(pi);
                }));
              }
              function qr(_r) {
                if (_r.kind !== 227 && _r.name)
                  return ir(_r) ? e2.isBindingPattern(_r.name) ? or(_r.name) : x2.createVariableDeclaration(_r.name, void 0, ye(_r, void 0), void 0) : void 0;
              }
              function si(_r) {
                var pi;
                he || (pi = K, K = e2.createGetSymbolAccessibilityDiagnosticForNodeName(_r)), A2 = _r.name, e2.Debug.assert(Y.isLateBound(e2.getParseTreeNode(_r)));
                var ae = _r, Xe = ae.name.expression;
                Ne(Xe, q), he || (K = pi), A2 = void 0;
              }
              function Di(_r) {
                return !!H && !!_r && w(_r, V);
              }
              function wi(_r) {
                return e2.isExportAssignment(_r) || e2.isExportDeclaration(_r);
              }
              function Xi(_r) {
                return e2.some(_r, wi);
              }
              function et(_r) {
                var pi = e2.getEffectiveModifierFlags(_r), ae = Gi(_r);
                return pi === ae ? _r.modifiers : x2.createModifiersFromModifierFlags(ae);
              }
              function Gi(_r) {
                var pi = 109307, ae = b && !Q(_r) ? 2 : 0, Xe = _r.parent.kind === 305;
                return (!Xe || se && Xe && e2.isExternalModule(_r.parent)) && (pi ^= 2, ae = 0), N(_r, pi, ae);
              }
              function Wt(_r, pi) {
                var ae = p(_r);
                return !ae && _r !== pi.firstAccessor && (ae = p(pi.firstAccessor), K = e2.createGetSymbolAccessibilityDiagnosticForNode(pi.firstAccessor)), !ae && pi.secondAccessor && _r !== pi.secondAccessor && (ae = p(pi.secondAccessor), K = e2.createGetSymbolAccessibilityDiagnosticForNode(pi.secondAccessor)), ae;
              }
              function Zt(_r) {
                return x2.createNodeArray(e2.filter(e2.map(_r, function(pi) {
                  return x2.updateHeritageClause(pi, e2.visitNodes(x2.createNodeArray(e2.filter(pi.types, function(ae) {
                    return e2.isEntityNameExpression(ae.expression) || pi.token === 94 && ae.expression.kind === 104;
                  })), Ir));
                }), function(pi) {
                  return pi.types && !!pi.types.length;
                }));
              }
            }
            e2.transformDeclarations = E;
            function Q(f4) {
              return f4.kind === 258;
            }
            function le(f4, T, K) {
              return e2.factory.createModifiersFromModifierFlags(N(f4, T, K));
            }
            function N(f4, T, K) {
              T === void 0 && (T = 125947), K === void 0 && (K = 0);
              var b = e2.getEffectiveModifierFlags(f4) & T | K;
              return b & 512 && !(b & 1) && (b ^= 1), b & 512 && b & 2 && (b ^= 2), b;
            }
            function p(f4) {
              if (f4)
                return f4.kind === 172 ? f4.type : f4.parameters.length > 0 ? f4.parameters[0].type : void 0;
            }
            function m2(f4) {
              switch (f4.kind) {
                case 167:
                case 166:
                  return !e2.hasEffectiveModifier(f4, 8);
                case 164:
                case 254:
                  return true;
              }
              return false;
            }
            function G(f4) {
              switch (f4.kind) {
                case 256:
                case 261:
                case 265:
                case 258:
                case 257:
                case 259:
                case 260:
                case 237:
                case 266:
                case 272:
                case 271:
                  return true;
              }
              return false;
            }
            function oe(f4) {
              switch (f4.kind) {
                case 175:
                case 171:
                case 169:
                case 172:
                case 173:
                case 167:
                case 166:
                case 168:
                case 174:
                case 176:
                case 254:
                case 163:
                case 228:
                case 178:
                case 189:
                case 179:
                case 180:
                case 200:
                  return true;
              }
              return false;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(T) {
              switch (T) {
                case e2.ModuleKind.ESNext:
                case e2.ModuleKind.ES2022:
                case e2.ModuleKind.ES2020:
                case e2.ModuleKind.ES2015:
                  return e2.transformECMAScriptModule;
                case e2.ModuleKind.System:
                  return e2.transformSystemModule;
                case e2.ModuleKind.Node16:
                case e2.ModuleKind.NodeNext:
                  return e2.transformNodeModule;
                default:
                  return e2.transformModule;
              }
            }
            var C;
            (function(T) {
              T[T.Uninitialized = 0] = "Uninitialized", T[T.Initialized = 1] = "Initialized", T[T.Completed = 2] = "Completed", T[T.Disposed = 3] = "Disposed";
            })(C || (C = {}));
            var w;
            (function(T) {
              T[T.Substitution = 1] = "Substitution", T[T.EmitNotifications = 2] = "EmitNotifications";
            })(w || (w = {})), e2.noTransformers = { scriptTransformers: e2.emptyArray, declarationTransformers: e2.emptyArray };
            function B(T, K, b) {
              return { scriptTransformers: E(T, K, b), declarationTransformers: Q(K) };
            }
            e2.getTransformers = B;
            function E(T, K, b) {
              if (b)
                return e2.emptyArray;
              var se = e2.getEmitScriptTarget(T), J = e2.getEmitModuleKind(T), ie = [];
              return e2.addRange(ie, K && e2.map(K.before, p)), ie.push(e2.transformTypeScript), ie.push(e2.transformClassFields), e2.getJSXTransformEnabled(T) && ie.push(e2.transformJsx), se < 99 && ie.push(e2.transformESNext), se < 8 && ie.push(e2.transformES2021), se < 7 && ie.push(e2.transformES2020), se < 6 && ie.push(e2.transformES2019), se < 5 && ie.push(e2.transformES2018), se < 4 && ie.push(e2.transformES2017), se < 3 && ie.push(e2.transformES2016), se < 2 && (ie.push(e2.transformES2015), ie.push(e2.transformGenerators)), ie.push(a(J)), se < 1 && ie.push(e2.transformES5), e2.addRange(ie, K && e2.map(K.after, p)), ie;
            }
            function Q(T) {
              var K = [];
              return K.push(e2.transformDeclarations), e2.addRange(K, T && e2.map(T.afterDeclarations, m2)), K;
            }
            function le(T) {
              return function(K) {
                return e2.isBundle(K) ? T.transformBundle(K) : T.transformSourceFile(K);
              };
            }
            function N(T, K) {
              return function(b) {
                var se = T(b);
                return typeof se == "function" ? K(b, se) : le(se);
              };
            }
            function p(T) {
              return N(T, e2.chainBundle);
            }
            function m2(T) {
              return N(T, function(K, b) {
                return b;
              });
            }
            function G(T, K) {
              return K;
            }
            e2.noEmitSubstitution = G;
            function oe(T, K, b) {
              b(T, K);
            }
            e2.noEmitNotification = oe;
            function f4(T, K, b, se, J, ie, R) {
              for (var q = new Array(355), O, ve, ee, he = 0, F2 = [], x2 = [], X = [], $ = [], A2 = 0, y = false, V = [], L = 0, P, k, Y = G, U = oe, j = 0, H = [], I = { factory: b, getCompilerOptions: function() {
                return se;
              }, getEmitResolver: function() {
                return T;
              }, getEmitHost: function() {
                return K;
              }, getEmitHelperFactory: e2.memoize(function() {
                return e2.createEmitHelperFactory(I);
              }), startLexicalEnvironment: _e, suspendLexicalEnvironment: we, resumeLexicalEnvironment: de, endLexicalEnvironment: ye, setLexicalEnvironmentFlags: Ae, getLexicalEnvironmentFlags: er, hoistVariableDeclaration: He, hoistFunctionDeclaration: rr, addInitializationStatement: Ie, startBlockScope: ir, endBlockScope: Cr, addBlockScopedVariable: Ye, requestEmitHelper: Br, readEmitHelpers: Er, enableSubstitution: Z2, enableEmitNotification: Re, isSubstitutionEnabled: Be, isEmitNotificationEnabled: ze, get onSubstituteNode() {
                return Y;
              }, set onSubstituteNode(n) {
                e2.Debug.assert(j < 1, "Cannot modify transformation hooks after initialization has completed."), e2.Debug.assert(n !== void 0, "Value must not be 'undefined'"), Y = n;
              }, get onEmitNode() {
                return U;
              }, set onEmitNode(n) {
                e2.Debug.assert(j < 1, "Cannot modify transformation hooks after initialization has completed."), e2.Debug.assert(n !== void 0, "Value must not be 'undefined'"), U = n;
              }, addDiagnostic: function(n) {
                H.push(n);
              } }, l = 0, d = J; l < d.length; l++) {
                var D = d[l];
                e2.disposeEmitNodes(e2.getSourceFileOfNode(e2.getParseTreeNode(D)));
              }
              e2.performance.mark("beforeTransform");
              var fe = ie.map(function(n) {
                return n(I);
              }), g = function(n) {
                for (var lr = 0, be = fe; lr < be.length; lr++) {
                  var Ge = be[lr];
                  n = Ge(n);
                }
                return n;
              };
              j = 1;
              for (var ne = [], ue = 0, We = J; ue < We.length; ue++) {
                var D = We[ue];
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("emit", "transformNodes", D.kind === 305 ? { path: D.path } : { kind: D.kind, pos: D.pos, end: D.end }), ne.push((R ? g : Fe)(D)), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
              }
              return j = 2, e2.performance.mark("afterTransform"), e2.performance.measure("transformTime", "beforeTransform", "afterTransform"), { transformed: ne, substituteNode: ge, emitNodeWithNotification: Ee, isEmitNotificationEnabled: ze, dispose: Ne, diagnostics: H };
              function Fe(n) {
                return n && (!e2.isSourceFile(n) || !n.isDeclarationFile) ? g(n) : n;
              }
              function Z2(n) {
                e2.Debug.assert(j < 2, "Cannot modify the transformation context after transformation has completed."), q[n] |= 1;
              }
              function Be(n) {
                return (q[n.kind] & 1) !== 0 && (e2.getEmitFlags(n) & 4) === 0;
              }
              function ge(n, lr) {
                return e2.Debug.assert(j < 3, "Cannot substitute a node after the result is disposed."), lr && Be(lr) && Y(n, lr) || lr;
              }
              function Re(n) {
                e2.Debug.assert(j < 2, "Cannot modify the transformation context after transformation has completed."), q[n] |= 2;
              }
              function ze(n) {
                return (q[n.kind] & 2) !== 0 || (e2.getEmitFlags(n) & 2) !== 0;
              }
              function Ee(n, lr, be) {
                e2.Debug.assert(j < 3, "Cannot invoke TransformationResult callbacks after the result is disposed."), lr && (ze(lr) ? U(n, lr, be) : be(n, lr));
              }
              function He(n) {
                e2.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e2.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed.");
                var lr = e2.setEmitFlags(b.createVariableDeclaration(n), 64);
                O ? O.push(lr) : O = [lr], he & 1 && (he |= 2);
              }
              function rr(n) {
                e2.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e2.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e2.setEmitFlags(n, 1048576), ve ? ve.push(n) : ve = [n];
              }
              function Ie(n) {
                e2.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e2.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e2.setEmitFlags(n, 1048576), ee ? ee.push(n) : ee = [n];
              }
              function _e() {
                e2.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e2.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e2.Debug.assert(!y, "Lexical environment is suspended."), F2[A2] = O, x2[A2] = ve, X[A2] = ee, $[A2] = he, A2++, O = void 0, ve = void 0, ee = void 0, he = 0;
              }
              function we() {
                e2.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e2.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e2.Debug.assert(!y, "Lexical environment is already suspended."), y = true;
              }
              function de() {
                e2.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e2.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e2.Debug.assert(y, "Lexical environment is not suspended."), y = false;
              }
              function ye() {
                e2.Debug.assert(j > 0, "Cannot modify the lexical environment during initialization."), e2.Debug.assert(j < 2, "Cannot modify the lexical environment after transformation has completed."), e2.Debug.assert(!y, "Lexical environment is suspended.");
                var n;
                if (O || ve || ee) {
                  if (ve && (n = Ve([], ve, true)), O) {
                    var lr = b.createVariableStatement(void 0, b.createVariableDeclarationList(O));
                    e2.setEmitFlags(lr, 1048576), n ? n.push(lr) : n = [lr];
                  }
                  ee && (n ? n = Ve(Ve([], n, true), ee, true) : n = Ve([], ee, true));
                }
                return A2--, O = F2[A2], ve = x2[A2], ee = X[A2], he = $[A2], A2 === 0 && (F2 = [], x2 = [], X = [], $ = []), n;
              }
              function Ae(n, lr) {
                he = lr ? he | n : he & ~n;
              }
              function er() {
                return he;
              }
              function ir() {
                e2.Debug.assert(j > 0, "Cannot start a block scope during initialization."), e2.Debug.assert(j < 2, "Cannot start a block scope after transformation has completed."), V[L] = P, L++, P = void 0;
              }
              function Cr() {
                e2.Debug.assert(j > 0, "Cannot end a block scope during initialization."), e2.Debug.assert(j < 2, "Cannot end a block scope after transformation has completed.");
                var n = e2.some(P) ? [b.createVariableStatement(void 0, b.createVariableDeclarationList(P.map(function(lr) {
                  return b.createVariableDeclaration(lr);
                }), 1))] : void 0;
                return L--, P = V[L], L === 0 && (V = []), n;
              }
              function Ye(n) {
                e2.Debug.assert(L > 0, "Cannot add a block scoped variable outside of an iteration body."), (P || (P = [])).push(n);
              }
              function Br(n) {
                if (e2.Debug.assert(j > 0, "Cannot modify the transformation context during initialization."), e2.Debug.assert(j < 2, "Cannot modify the transformation context after transformation has completed."), e2.Debug.assert(!n.scoped, "Cannot request a scoped emit helper."), n.dependencies)
                  for (var lr = 0, be = n.dependencies; lr < be.length; lr++) {
                    var Ge = be[lr];
                    Br(Ge);
                  }
                k = e2.append(k, n);
              }
              function Er() {
                e2.Debug.assert(j > 0, "Cannot modify the transformation context during initialization."), e2.Debug.assert(j < 2, "Cannot modify the transformation context after transformation has completed.");
                var n = k;
                return k = void 0, n;
              }
              function Ne() {
                if (j < 3) {
                  for (var n = 0, lr = J; n < lr.length; n++) {
                    var be = lr[n];
                    e2.disposeEmitNodes(e2.getSourceFileOfNode(e2.getParseTreeNode(be)));
                  }
                  O = void 0, F2 = void 0, ve = void 0, x2 = void 0, Y = void 0, U = void 0, k = void 0, j = 3;
                }
              }
            }
            e2.transformNodes = f4, e2.nullTransformationContext = { factory: e2.factory, getCompilerOptions: function() {
              return {};
            }, getEmitResolver: e2.notImplemented, getEmitHost: e2.notImplemented, getEmitHelperFactory: e2.notImplemented, startLexicalEnvironment: e2.noop, resumeLexicalEnvironment: e2.noop, suspendLexicalEnvironment: e2.noop, endLexicalEnvironment: e2.returnUndefined, setLexicalEnvironmentFlags: e2.noop, getLexicalEnvironmentFlags: function() {
              return 0;
            }, hoistVariableDeclaration: e2.noop, hoistFunctionDeclaration: e2.noop, addInitializationStatement: e2.noop, startBlockScope: e2.noop, endBlockScope: e2.returnUndefined, addBlockScopedVariable: e2.noop, requestEmitHelper: e2.noop, readEmitHelpers: e2.notImplemented, enableSubstitution: e2.noop, enableEmitNotification: e2.noop, isSubstitutionEnabled: e2.notImplemented, isEmitNotificationEnabled: e2.notImplemented, onSubstituteNode: G, onEmitNode: oe, addDiagnostic: e2.noop };
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = x2();
            function C(k) {
              return e2.fileExtensionIs(k, ".tsbuildinfo");
            }
            e2.isBuildInfoFile = C;
            function w(k, Y, U, j, H, I) {
              j === void 0 && (j = false);
              var l = e2.isArray(U) ? U : e2.getSourceFilesToEmit(k, U, j), d = k.getCompilerOptions();
              if (e2.outFile(d)) {
                var D = k.getPrependNodes();
                if (l.length || D.length) {
                  var fe = e2.factory.createBundle(l, D), g = Y(Q(fe, k, j), fe);
                  if (g)
                    return g;
                }
              } else {
                if (!H)
                  for (var ne = 0, ue = l; ne < ue.length; ne++) {
                    var We = ue[ne], g = Y(Q(We, k, j), We);
                    if (g)
                      return g;
                  }
                if (I) {
                  var Fe = B(d);
                  if (Fe)
                    return Y({ buildInfoPath: Fe }, void 0);
                }
              }
            }
            e2.forEachEmittedFile = w;
            function B(k) {
              var Y = k.configFilePath;
              if (!!e2.isIncrementalCompilation(k)) {
                if (k.tsBuildInfoFile)
                  return k.tsBuildInfoFile;
                var U = e2.outFile(k), j;
                if (U)
                  j = e2.removeFileExtension(U);
                else {
                  if (!Y)
                    return;
                  var H = e2.removeFileExtension(Y);
                  j = k.outDir ? k.rootDir ? e2.resolvePath(k.outDir, e2.getRelativePathFromDirectory(k.rootDir, H, true)) : e2.combinePaths(k.outDir, e2.getBaseFileName(H)) : H;
                }
                return j + ".tsbuildinfo";
              }
            }
            e2.getTsBuildInfoEmitOutputFilePath = B;
            function E(k, Y) {
              var U = e2.outFile(k), j = k.emitDeclarationOnly ? void 0 : U, H = j && le(j, k), I = Y || e2.getEmitDeclarations(k) ? e2.removeFileExtension(U) + ".d.ts" : void 0, l = I && e2.getAreDeclarationMapsEnabled(k) ? I + ".map" : void 0, d = B(k);
              return { jsFilePath: j, sourceMapFilePath: H, declarationFilePath: I, declarationMapPath: l, buildInfoPath: d };
            }
            e2.getOutputPathsForBundle = E;
            function Q(k, Y, U) {
              var j = Y.getCompilerOptions();
              if (k.kind === 306)
                return E(j, U);
              var H = e2.getOwnEmitOutputFilePath(k.fileName, Y, N(k.fileName, j)), I = e2.isJsonSourceFile(k), l = I && e2.comparePaths(k.fileName, H, Y.getCurrentDirectory(), !Y.useCaseSensitiveFileNames()) === 0, d = j.emitDeclarationOnly || l ? void 0 : H, D = !d || e2.isJsonSourceFile(k) ? void 0 : le(d, j), fe = U || e2.getEmitDeclarations(j) && !I ? e2.getDeclarationEmitOutputFilePath(k.fileName, Y) : void 0, g = fe && e2.getAreDeclarationMapsEnabled(j) ? fe + ".map" : void 0;
              return { jsFilePath: d, sourceMapFilePath: D, declarationFilePath: fe, declarationMapPath: g, buildInfoPath: void 0 };
            }
            e2.getOutputPathsFor = Q;
            function le(k, Y) {
              return Y.sourceMap && !Y.inlineSourceMap ? k + ".map" : void 0;
            }
            function N(k, Y) {
              return e2.fileExtensionIs(k, ".json") ? ".json" : Y.jsx === 1 && e2.fileExtensionIsOneOf(k, [".jsx", ".tsx"]) ? ".jsx" : e2.fileExtensionIsOneOf(k, [".mts", ".mjs"]) ? ".mjs" : e2.fileExtensionIsOneOf(k, [".cts", ".cjs"]) ? ".cjs" : ".js";
            }
            e2.getOutputExtension = N;
            function p(k, Y, U, j, H) {
              return j ? e2.resolvePath(j, e2.getRelativePathFromDirectory(H ? H() : b(Y, U), k, U)) : k;
            }
            function m2(k, Y, U, j) {
              return e2.changeExtension(p(k, Y, U, Y.options.declarationDir || Y.options.outDir, j), e2.getDeclarationEmitExtensionForPath(k));
            }
            e2.getOutputDeclarationFileName = m2;
            function G(k, Y, U, j) {
              if (!Y.options.emitDeclarationOnly) {
                var H = e2.fileExtensionIs(k, ".json"), I = e2.changeExtension(p(k, Y, U, Y.options.outDir, j), N(k, Y.options));
                return !H || e2.comparePaths(k, I, e2.Debug.checkDefined(Y.options.configFilePath), U) !== 0 ? I : void 0;
              }
            }
            function oe() {
              var k;
              return { addOutput: Y, getOutputs: U };
              function Y(j) {
                j && (k || (k = [])).push(j);
              }
              function U() {
                return k || e2.emptyArray;
              }
            }
            function f4(k, Y) {
              var U = E(k.options, false), j = U.jsFilePath, H = U.sourceMapFilePath, I = U.declarationFilePath, l = U.declarationMapPath, d = U.buildInfoPath;
              Y(j), Y(H), Y(I), Y(l), Y(d);
            }
            function T(k, Y, U, j, H) {
              if (!e2.isDeclarationFileName(Y)) {
                var I = G(Y, k, U, H);
                if (j(I), !e2.fileExtensionIs(Y, ".json") && (I && k.options.sourceMap && j("".concat(I, ".map")), e2.getEmitDeclarations(k.options))) {
                  var l = m2(Y, k, U, H);
                  j(l), k.options.declarationMap && j("".concat(l, ".map"));
                }
              }
            }
            function K(k, Y, U, j, H) {
              var I;
              return k.rootDir ? (I = e2.getNormalizedAbsolutePath(k.rootDir, U), H == null || H(k.rootDir)) : k.composite && k.configFilePath ? (I = e2.getDirectoryPath(e2.normalizeSlashes(k.configFilePath)), H == null || H(I)) : I = e2.computeCommonSourceDirectoryOfFilenames(Y(), U, j), I && I[I.length - 1] !== e2.directorySeparator && (I += e2.directorySeparator), I;
            }
            e2.getCommonSourceDirectory = K;
            function b(k, Y) {
              var U = k.options, j = k.fileNames;
              return K(U, function() {
                return e2.filter(j, function(H) {
                  return !(U.noEmitForJsFiles && e2.fileExtensionIsOneOf(H, e2.supportedJSExtensionsFlat)) && !e2.isDeclarationFileName(H);
                });
              }, e2.getDirectoryPath(e2.normalizeSlashes(e2.Debug.checkDefined(U.configFilePath))), e2.createGetCanonicalFileName(!Y));
            }
            e2.getCommonSourceDirectoryOfConfig = b;
            function se(k, Y) {
              var U = oe(), j = U.addOutput, H = U.getOutputs;
              if (e2.outFile(k.options))
                f4(k, j);
              else {
                for (var I = e2.memoize(function() {
                  return b(k, Y);
                }), l = 0, d = k.fileNames; l < d.length; l++) {
                  var D = d[l];
                  T(k, D, Y, j, I);
                }
                j(B(k.options));
              }
              return H();
            }
            e2.getAllProjectOutputs = se;
            function J(k, Y, U) {
              Y = e2.normalizePath(Y), e2.Debug.assert(e2.contains(k.fileNames, Y), "Expected fileName to be present in command line");
              var j = oe(), H = j.addOutput, I = j.getOutputs;
              return e2.outFile(k.options) ? f4(k, H) : T(k, Y, U, H), I();
            }
            e2.getOutputFileNames = J;
            function ie(k, Y) {
              if (e2.outFile(k.options)) {
                var U = E(k.options, false).jsFilePath;
                return e2.Debug.checkDefined(U, "project ".concat(k.options.configFilePath, " expected to have at least one output"));
              }
              for (var j = e2.memoize(function() {
                return b(k, Y);
              }), H = 0, I = k.fileNames; H < I.length; H++) {
                var l = I[H];
                if (!e2.isDeclarationFileName(l)) {
                  var U = G(l, k, Y, j);
                  if (U)
                    return U;
                  if (!e2.fileExtensionIs(l, ".json") && e2.getEmitDeclarations(k.options))
                    return m2(l, k, Y, j);
                }
              }
              var d = B(k.options);
              return d || e2.Debug.fail("project ".concat(k.options.configFilePath, " expected to have at least one output"));
            }
            e2.getFirstProjectOutput = ie;
            function R(k, Y, U, j, H, I, l) {
              var d = j.scriptTransformers, D = j.declarationTransformers, fe = Y.getCompilerOptions(), g = fe.sourceMap || fe.inlineSourceMap || e2.getAreDeclarationMapsEnabled(fe) ? [] : void 0, ne = fe.listEmittedFiles ? [] : void 0, ue = e2.createDiagnosticCollection(), We = e2.getNewLineCharacter(fe, function() {
                return Y.getNewLine();
              }), Fe = e2.createTextWriter(We), Z2 = e2.performance.createTimer("printTime", "beforePrint", "afterPrint"), Be = Z2.enter, ge = Z2.exit, Re, ze = false, Ee;
              return Be(), w(Y, He, e2.getSourceFilesToEmit(Y, U, l), l, I, !U), ge(), { emitSkipped: ze, diagnostics: ue.getDiagnostics(), emittedFiles: ne, sourceMaps: g, exportedModulesFromDeclarationEmit: Ee };
              function He(Cr, Ye) {
                var Br = Cr.jsFilePath, Er = Cr.sourceMapFilePath, Ne = Cr.declarationFilePath, n = Cr.declarationMapPath, lr = Cr.buildInfoPath, be;
                lr && Ye && e2.isBundle(Ye) && (be = e2.getDirectoryPath(e2.getNormalizedAbsolutePath(lr, Y.getCurrentDirectory())), Re = { commonSourceDirectory: Ge(Y.getCommonSourceDirectory()), sourceFiles: Ye.sourceFiles.map(function(ur) {
                  return Ge(e2.getNormalizedAbsolutePath(ur.fileName, Y.getCurrentDirectory()));
                }) }), e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("emit", "emitJsFileOrBundle", { jsFilePath: Br }), Ie(Ye, Br, Er, Ge), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("emit", "emitDeclarationFileOrBundle", { declarationFilePath: Ne }), _e(Ye, Ne, n, Ge), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("emit", "emitBuildInfo", { buildInfoPath: lr }), rr(Re, lr), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), !ze && ne && (H || (Br && ne.push(Br), Er && ne.push(Er), lr && ne.push(lr)), Ne && ne.push(Ne), n && ne.push(n));
                function Ge(ur) {
                  return e2.ensurePathIsNonModuleName(e2.getRelativePathFromDirectory(be, ur, Y.getCanonicalFileName));
                }
              }
              function rr(Cr, Ye) {
                if (!(!Ye || U || ze)) {
                  var Br = Y.getProgramBuildInfo();
                  if (Y.isEmitBlocked(Ye)) {
                    ze = true;
                    return;
                  }
                  var Er = e2.version;
                  e2.writeFile(Y, ue, Ye, q({ bundle: Cr, program: Br, version: Er }), false);
                }
              }
              function Ie(Cr, Ye, Br, Er) {
                if (!(!Cr || H || !Ye)) {
                  if (Ye && Y.isEmitBlocked(Ye) || fe.noEmit) {
                    ze = true;
                    return;
                  }
                  var Ne = e2.transformNodes(k, Y, e2.factory, fe, [Cr], d, false), n = { removeComments: fe.removeComments, newLine: fe.newLine, noEmitHelpers: fe.noEmitHelpers, module: fe.module, target: fe.target, sourceMap: fe.sourceMap, inlineSourceMap: fe.inlineSourceMap, inlineSources: fe.inlineSources, extendedDiagnostics: fe.extendedDiagnostics, writeBundleFileInfo: !!Re, relativeToBuildInfo: Er }, lr = F2(n, { hasGlobalName: k.hasGlobalName, onEmitNode: Ne.emitNodeWithNotification, isEmitNotificationEnabled: Ne.isEmitNotificationEnabled, substituteNode: Ne.substituteNode });
                  e2.Debug.assert(Ne.transformed.length === 1, "Should only see one output from the transform"), de(Ye, Br, Ne.transformed[0], lr, fe), Ne.dispose(), Re && (Re.js = lr.bundleFileInfo);
                }
              }
              function _e(Cr, Ye, Br, Er) {
                if (!!Cr) {
                  if (!Ye) {
                    (H || fe.emitDeclarationOnly) && (ze = true);
                    return;
                  }
                  var Ne = e2.isSourceFile(Cr) ? [Cr] : Cr.sourceFiles, n = l ? Ne : e2.filter(Ne, e2.isSourceFileNotJson), lr = e2.outFile(fe) ? [e2.factory.createBundle(n, e2.isSourceFile(Cr) ? void 0 : Cr.prepends)] : n;
                  H && !e2.getEmitDeclarations(fe) && n.forEach(we);
                  var be = e2.transformNodes(k, Y, e2.factory, fe, lr, D, false);
                  if (e2.length(be.diagnostics))
                    for (var Ge = 0, ur = be.diagnostics; Ge < ur.length; Ge++) {
                      var yr = ur[Ge];
                      ue.add(yr);
                    }
                  var Ir = { removeComments: fe.removeComments, newLine: fe.newLine, noEmitHelpers: true, module: fe.module, target: fe.target, sourceMap: fe.sourceMap, inlineSourceMap: fe.inlineSourceMap, extendedDiagnostics: fe.extendedDiagnostics, onlyPrintJsDocStyle: true, writeBundleFileInfo: !!Re, recordInternalSection: !!Re, relativeToBuildInfo: Er }, wr = F2(Ir, { hasGlobalName: k.hasGlobalName, onEmitNode: be.emitNodeWithNotification, isEmitNotificationEnabled: be.isEmitNotificationEnabled, substituteNode: be.substituteNode }), Ur = !!be.diagnostics && !!be.diagnostics.length || !!Y.isEmitBlocked(Ye) || !!fe.noEmit;
                  if (ze = ze || Ur, (!Ur || l) && (e2.Debug.assert(be.transformed.length === 1, "Should only see one output from the decl transform"), de(Ye, Br, be.transformed[0], wr, { sourceMap: !l && fe.declarationMap, sourceRoot: fe.sourceRoot, mapRoot: fe.mapRoot, extendedDiagnostics: fe.extendedDiagnostics }), l && be.transformed[0].kind === 305)) {
                    var ii = be.transformed[0];
                    Ee = ii.exportedModulesFromDeclarationEmit;
                  }
                  be.dispose(), Re && (Re.dts = wr.bundleFileInfo);
                }
              }
              function we(Cr) {
                if (e2.isExportAssignment(Cr)) {
                  Cr.expression.kind === 79 && k.collectLinkedAliases(Cr.expression, true);
                  return;
                } else if (e2.isExportSpecifier(Cr)) {
                  k.collectLinkedAliases(Cr.propertyName || Cr.name, true);
                  return;
                }
                e2.forEachChild(Cr, we);
              }
              function de(Cr, Ye, Br, Er, Ne) {
                var n = Br.kind === 306 ? Br : void 0, lr = Br.kind === 305 ? Br : void 0, be = n ? n.sourceFiles : [lr], Ge;
                ye(Ne, Br) && (Ge = e2.createSourceMapGenerator(Y, e2.getBaseFileName(e2.normalizeSlashes(Cr)), Ae(Ne), er(Ne, Cr, lr), Ne)), n ? Er.writeBundle(n, Fe, Ge) : Er.writeFile(lr, Fe, Ge);
                var ur;
                if (Ge) {
                  g && g.push({ inputSourceFileNames: Ge.getSources(), sourceMap: Ge.toJSON() });
                  var yr = ir(Ne, Ge, Cr, Ye, lr);
                  if (yr && (Fe.isAtStartOfLine() || Fe.rawWrite(We), ur = Fe.getTextPos(), Fe.writeComment("//# ".concat("sourceMappingURL", "=").concat(yr))), Ye) {
                    var Ir = Ge.toString();
                    e2.writeFile(Y, ue, Ye, Ir, false, be);
                  }
                } else
                  Fe.writeLine();
                e2.writeFile(Y, ue, Cr, Fe.getText(), !!fe.emitBOM, be, { sourceMapUrlPos: ur }), Fe.clear();
              }
              function ye(Cr, Ye) {
                return (Cr.sourceMap || Cr.inlineSourceMap) && (Ye.kind !== 305 || !e2.fileExtensionIs(Ye.fileName, ".json"));
              }
              function Ae(Cr) {
                var Ye = e2.normalizeSlashes(Cr.sourceRoot || "");
                return Ye && e2.ensureTrailingDirectorySeparator(Ye);
              }
              function er(Cr, Ye, Br) {
                if (Cr.sourceRoot)
                  return Y.getCommonSourceDirectory();
                if (Cr.mapRoot) {
                  var Er = e2.normalizeSlashes(Cr.mapRoot);
                  return Br && (Er = e2.getDirectoryPath(e2.getSourceFilePathInNewDir(Br.fileName, Y, Er))), e2.getRootLength(Er) === 0 && (Er = e2.combinePaths(Y.getCommonSourceDirectory(), Er)), Er;
                }
                return e2.getDirectoryPath(e2.normalizePath(Ye));
              }
              function ir(Cr, Ye, Br, Er, Ne) {
                if (Cr.inlineSourceMap) {
                  var n = Ye.toString(), lr = e2.base64encode(e2.sys, n);
                  return "data:application/json;base64,".concat(lr);
                }
                var be = e2.getBaseFileName(e2.normalizeSlashes(e2.Debug.checkDefined(Er)));
                if (Cr.mapRoot) {
                  var Ge = e2.normalizeSlashes(Cr.mapRoot);
                  return Ne && (Ge = e2.getDirectoryPath(e2.getSourceFilePathInNewDir(Ne.fileName, Y, Ge))), e2.getRootLength(Ge) === 0 ? (Ge = e2.combinePaths(Y.getCommonSourceDirectory(), Ge), encodeURI(e2.getRelativePathToDirectoryOrUrl(e2.getDirectoryPath(e2.normalizePath(Br)), e2.combinePaths(Ge, be), Y.getCurrentDirectory(), Y.getCanonicalFileName, true))) : encodeURI(e2.combinePaths(Ge, be));
                }
                return encodeURI(be);
              }
            }
            e2.emitFiles = R;
            function q(k) {
              return JSON.stringify(k);
            }
            e2.getBuildInfoText = q;
            function O(k) {
              return JSON.parse(k);
            }
            e2.getBuildInfo = O, e2.notImplementedResolver = { hasGlobalName: e2.notImplemented, getReferencedExportContainer: e2.notImplemented, getReferencedImportDeclaration: e2.notImplemented, getReferencedDeclarationWithCollidingName: e2.notImplemented, isDeclarationWithCollidingName: e2.notImplemented, isValueAliasDeclaration: e2.notImplemented, isReferencedAliasDeclaration: e2.notImplemented, isTopLevelValueImportEqualsWithEntityName: e2.notImplemented, getNodeCheckFlags: e2.notImplemented, isDeclarationVisible: e2.notImplemented, isLateBound: function(k) {
              return false;
            }, collectLinkedAliases: e2.notImplemented, isImplementationOfOverload: e2.notImplemented, isRequiredInitializedParameter: e2.notImplemented, isOptionalUninitializedParameterProperty: e2.notImplemented, isExpandoFunctionDeclaration: e2.notImplemented, getPropertiesOfContainerFunction: e2.notImplemented, createTypeOfDeclaration: e2.notImplemented, createReturnTypeOfSignatureDeclaration: e2.notImplemented, createTypeOfExpression: e2.notImplemented, createLiteralConstValue: e2.notImplemented, isSymbolAccessible: e2.notImplemented, isEntityNameVisible: e2.notImplemented, getConstantValue: e2.notImplemented, getReferencedValueDeclaration: e2.notImplemented, getTypeReferenceSerializationKind: e2.notImplemented, isOptionalParameter: e2.notImplemented, moduleExportsSomeValue: e2.notImplemented, isArgumentsLocalBinding: e2.notImplemented, getExternalModuleFileFromDeclaration: e2.notImplemented, getTypeReferenceDirectivesForEntityName: e2.notImplemented, getTypeReferenceDirectivesForSymbol: e2.notImplemented, isLiteralConstDeclaration: e2.notImplemented, getJsxFactoryEntity: e2.notImplemented, getJsxFragmentFactoryEntity: e2.notImplemented, getAllAccessorDeclarations: e2.notImplemented, getSymbolOfExternalModuleSpecifier: e2.notImplemented, isBindingCapturedByNode: e2.notImplemented, getDeclarationStatementsForSourceFile: e2.notImplemented, isImportRequiredByAugmentation: e2.notImplemented };
            function ve(k, Y, U) {
              var j, H = e2.Debug.checkDefined(k.js), I = ((j = H.sources) === null || j === void 0 ? void 0 : j.prologues) && e2.arrayToMap(H.sources.prologues, function(l) {
                return l.file;
              });
              return k.sourceFiles.map(function(l, d) {
                var D, fe, g = I == null ? void 0 : I.get(d), ne = g == null ? void 0 : g.directives.map(function(Fe) {
                  var Z2 = e2.setTextRange(e2.factory.createStringLiteral(Fe.expression.text), Fe.expression), Be = e2.setTextRange(e2.factory.createExpressionStatement(Z2), Fe);
                  return e2.setParent(Z2, Be), Be;
                }), ue = e2.factory.createToken(1), We = e2.factory.createSourceFile(ne != null ? ne : [], ue, 0);
                return We.fileName = e2.getRelativePathFromDirectory(U.getCurrentDirectory(), e2.getNormalizedAbsolutePath(l, Y), !U.useCaseSensitiveFileNames()), We.text = (D = g == null ? void 0 : g.text) !== null && D !== void 0 ? D : "", e2.setTextRangePosWidth(We, 0, (fe = g == null ? void 0 : g.text.length) !== null && fe !== void 0 ? fe : 0), e2.setEachParent(We.statements, We), e2.setTextRangePosWidth(ue, We.end, 0), e2.setParent(ue, We), We;
              });
            }
            function ee(k, Y, U, j) {
              var H = E(k.options, false), I = H.buildInfoPath, l = H.jsFilePath, d = H.sourceMapFilePath, D = H.declarationFilePath, fe = H.declarationMapPath, g = Y.readFile(e2.Debug.checkDefined(I));
              if (!g)
                return I;
              var ne = Y.readFile(e2.Debug.checkDefined(l));
              if (!ne)
                return l;
              var ue = d && Y.readFile(d);
              if (d && !ue || k.options.inlineSourceMap)
                return d || "inline sourcemap decoding";
              var We = D && Y.readFile(D);
              if (D && !We)
                return D;
              var Fe = fe && Y.readFile(fe);
              if (fe && !Fe || k.options.inlineSourceMap)
                return fe || "inline sourcemap decoding";
              var Z2 = O(g);
              if (!Z2.bundle || !Z2.bundle.js || We && !Z2.bundle.dts)
                return I;
              var Be = e2.getDirectoryPath(e2.getNormalizedAbsolutePath(I, Y.getCurrentDirectory())), ge = e2.createInputFiles(ne, We, d, ue, fe, Fe, l, D, I, Z2, true), Re = [], ze = e2.createPrependNodes(k.projectReferences, U, function(rr) {
                return Y.readFile(rr);
              }), Ee = ve(Z2.bundle, Be, Y), He = { getPrependNodes: e2.memoize(function() {
                return Ve(Ve([], ze, true), [ge], false);
              }), getCanonicalFileName: Y.getCanonicalFileName, getCommonSourceDirectory: function() {
                return e2.getNormalizedAbsolutePath(Z2.bundle.commonSourceDirectory, Be);
              }, getCompilerOptions: function() {
                return k.options;
              }, getCurrentDirectory: function() {
                return Y.getCurrentDirectory();
              }, getNewLine: function() {
                return Y.getNewLine();
              }, getSourceFile: e2.returnUndefined, getSourceFileByPath: e2.returnUndefined, getSourceFiles: function() {
                return Ee;
              }, getLibFileFromReference: e2.notImplemented, isSourceFileFromExternalLibrary: e2.returnFalse, getResolvedProjectReferenceToRedirect: e2.returnUndefined, getProjectReferenceRedirect: e2.returnUndefined, isSourceOfProjectReferenceRedirect: e2.returnFalse, writeFile: function(rr, Ie, _e) {
                switch (rr) {
                  case l:
                    if (ne === Ie)
                      return;
                    break;
                  case d:
                    if (ue === Ie)
                      return;
                    break;
                  case I:
                    var we = O(Ie);
                    we.program = Z2.program;
                    var de = Z2.bundle, ye = de.js, Ae = de.dts, er = de.sourceFiles;
                    we.bundle.js.sources = ye.sources, Ae && (we.bundle.dts.sources = Ae.sources), we.bundle.sourceFiles = er, Re.push({ name: rr, text: q(we), writeByteOrderMark: _e });
                    return;
                  case D:
                    if (We === Ie)
                      return;
                    break;
                  case fe:
                    if (Fe === Ie)
                      return;
                    break;
                  default:
                    e2.Debug.fail("Unexpected path: ".concat(rr));
                }
                Re.push({ name: rr, text: Ie, writeByteOrderMark: _e });
              }, isEmitBlocked: e2.returnFalse, readFile: function(rr) {
                return Y.readFile(rr);
              }, fileExists: function(rr) {
                return Y.fileExists(rr);
              }, useCaseSensitiveFileNames: function() {
                return Y.useCaseSensitiveFileNames();
              }, getProgramBuildInfo: e2.returnUndefined, getSourceFileFromReference: e2.returnUndefined, redirectTargetsMap: e2.createMultiMap(), getFileIncludeReasons: e2.notImplemented };
              return R(e2.notImplementedResolver, He, void 0, e2.getTransformers(k.options, j)), Re;
            }
            e2.emitUsingBuildInfo = ee;
            var he;
            (function(k) {
              k[k.Notification = 0] = "Notification", k[k.Substitution = 1] = "Substitution", k[k.Comments = 2] = "Comments", k[k.SourceMaps = 3] = "SourceMaps", k[k.Emit = 4] = "Emit";
            })(he || (he = {}));
            function F2(k, Y) {
              k === void 0 && (k = {}), Y === void 0 && (Y = {});
              var U = Y.hasGlobalName, j = Y.onEmitNode, H = j === void 0 ? e2.noEmitNotification : j, I = Y.isEmitNotificationEnabled, l = Y.substituteNode, d = l === void 0 ? e2.noEmitSubstitution : l, D = Y.onBeforeEmitNode, fe = Y.onAfterEmitNode, g = Y.onBeforeEmitNodeArray, ne = Y.onAfterEmitNodeArray, ue = Y.onBeforeEmitToken, We = Y.onAfterEmitToken, Fe = !!k.extendedDiagnostics, Z2 = e2.getNewLineCharacter(k), Be = e2.getEmitModuleKind(k), ge = new e2.Map(), Re, ze, Ee, He, rr, Ie, _e, we, de = k.preserveSourceNewlines, ye, Ae, er, ir = B_, Cr, Ye = k.writeBundleFileInfo ? { sections: [] } : void 0, Br = Ye ? e2.Debug.checkDefined(k.relativeToBuildInfo) : void 0, Er = k.recordInternalSection, Ne = 0, n = "text", lr = true, be, Ge, ur = -1, yr, Ir = -1, wr = -1, Ur = -1, ii = -1, mi, pe, or = false, qr = !!k.removeComments, si, Di, wi = e2.performance.createTimerIf(Fe, "commentTime", "beforeComment", "afterComment"), Xi = wi.enter, et = wi.exit, Gi = e2.factory.parenthesizer, Wt = { select: function(v) {
                return v === 0 ? Gi.parenthesizeLeadingTypeArgument : void 0;
              } }, Zt = pt();
              return fr(), { printNode: _r, printList: pi, printFile: Xe, printBundle: ae, writeNode: ti, writeList: Ze, writeFile: Ar, writeBundle: vr, bundleFileInfo: Ye };
              function _r(v, sr, fi) {
                switch (v) {
                  case 0:
                    e2.Debug.assert(e2.isSourceFile(sr), "Expected a SourceFile node.");
                    break;
                  case 2:
                    e2.Debug.assert(e2.isIdentifier(sr), "Expected an Identifier node.");
                    break;
                  case 1:
                    e2.Debug.assert(e2.isExpression(sr), "Expected an Expression node.");
                    break;
                }
                switch (sr.kind) {
                  case 305:
                    return Xe(sr);
                  case 306:
                    return ae(sr);
                  case 307:
                    return Jr(sr);
                }
                return ti(v, sr, fi, Oe()), nr();
              }
              function pi(v, sr, fi) {
                return Ze(v, sr, fi, Oe()), nr();
              }
              function ae(v) {
                return vr(v, Oe(), void 0), nr();
              }
              function Xe(v) {
                return Ar(v, Oe(), void 0), nr();
              }
              function Jr(v) {
                return mr(v, Oe()), nr();
              }
              function ti(v, sr, fi, zi) {
                var Sa = Ae;
                Ue(zi, void 0), Mr(v, sr, fi), fr(), Ae = Sa;
              }
              function Ze(v, sr, fi, zi) {
                var Sa = Ae;
                Ue(zi, void 0), fi && Pe(fi), Zn(void 0, sr, v), fr(), Ae = Sa;
              }
              function Sr() {
                return Ae.getTextPosWithWriteLine ? Ae.getTextPosWithWriteLine() : Ae.getTextPos();
              }
              function zr(v, sr, fi) {
                var zi = e2.lastOrUndefined(Ye.sections);
                zi && zi.kind === fi ? zi.end = sr : Ye.sections.push({ pos: v, end: sr, kind: fi });
              }
              function Wr(v) {
                if (Er && Ye && Re && (e2.isDeclaration(v) || e2.isVariableStatement(v)) && e2.isInternalDeclaration(v, Re) && n !== "internal") {
                  var sr = n;
                  return xe(Ae.getTextPos()), Ne = Sr(), n = "internal", sr;
                }
              }
              function Je(v) {
                v && (xe(Ae.getTextPos()), Ne = Sr(), n = v);
              }
              function xe(v) {
                return Ne < v ? (zr(Ne, v, n), true) : false;
              }
              function vr(v, sr, fi) {
                var zi;
                Cr = false;
                var Sa = Ae;
                Ue(sr, fi), f_(v), L_(v), Fi(v), Cp(v);
                for (var da = 0, Ha = v.prepends; da < Ha.length; da++) {
                  var ta = Ha[da];
                  bs();
                  var nn = Ae.getTextPos(), Wo = Ye && Ye.sections;
                  if (Wo && (Ye.sections = []), Mr(4, ta, void 0), Ye) {
                    var Lo = Ye.sections;
                    Ye.sections = Wo, ta.oldFileOfCurrentEmit ? (zi = Ye.sections).push.apply(zi, Lo) : (Lo.forEach(function(lu) {
                      return e2.Debug.assert(e2.isBundleFileTextLike(lu));
                    }), Ye.sections.push({ pos: nn, end: Ae.getTextPos(), kind: "prepend", data: Br(ta.fileName), texts: Lo }));
                  }
                }
                Ne = Sr();
                for (var oc = 0, uu = v.sourceFiles; oc < uu.length; oc++) {
                  var is = uu[oc];
                  Mr(0, is, is);
                }
                if (Ye && v.sourceFiles.length) {
                  var au = Ae.getTextPos();
                  if (xe(au)) {
                    var Ou = l_(v);
                    Ou && (Ye.sources || (Ye.sources = {}), Ye.sources.prologues = Ou);
                    var sf = Ki(v);
                    sf && (Ye.sources || (Ye.sources = {}), Ye.sources.helpers = sf);
                  }
                }
                fr(), Ae = Sa;
              }
              function mr(v, sr) {
                var fi = Ae;
                Ue(sr, void 0), Mr(4, v, void 0), fr(), Ae = fi;
              }
              function Ar(v, sr, fi) {
                Cr = true;
                var zi = Ae;
                Ue(sr, fi), f_(v), L_(v), Mr(0, v, v), fr(), Ae = zi;
              }
              function Oe() {
                return er || (er = e2.createTextWriter(Z2));
              }
              function nr() {
                var v = er.getText();
                return er.clear(), v;
              }
              function Mr(v, sr, fi) {
                fi && Pe(fi), Wi(v, sr, void 0);
              }
              function Pe(v) {
                Re = v, mi = void 0, pe = void 0, v && wu(v);
              }
              function Ue(v, sr) {
                v && k.omitTrailingSemicolon && (v = e2.getTrailingSemicolonDeferringWriter(v)), Ae = v, be = sr, lr = !Ae || !be;
              }
              function fr() {
                ze = [], Ee = [], He = new e2.Set(), rr = [], Ie = 0, _e = [], Re = void 0, mi = void 0, pe = void 0, Ue(void 0, void 0);
              }
              function De() {
                return mi || (mi = e2.getLineStarts(e2.Debug.checkDefined(Re)));
              }
              function gr(v, sr) {
                if (v !== void 0) {
                  var fi = Wr(v);
                  Wi(4, v, sr), Je(fi);
                }
              }
              function Vr(v) {
                v !== void 0 && Wi(2, v, void 0);
              }
              function Tr(v, sr) {
                v !== void 0 && Wi(1, v, sr);
              }
              function vi(v) {
                Wi(e2.isStringLiteral(v) ? 6 : 4, v);
              }
              function Ui(v) {
                de && e2.getEmitFlags(v) & 134217728 && (de = false);
              }
              function Yi(v) {
                de = v;
              }
              function Wi(v, sr, fi) {
                Di = fi;
                var zi = nt(0, v, sr);
                zi(v, sr), Di = void 0;
              }
              function ct(v) {
                return !qr && !e2.isSourceFile(v);
              }
              function Li(v) {
                return !lr && !e2.isSourceFile(v) && !e2.isInJsonFile(v) && !e2.isUnparsedSource(v) && !e2.isUnparsedPrepend(v);
              }
              function nt(v, sr, fi) {
                switch (v) {
                  case 0:
                    if (H !== e2.noEmitNotification && (!I || I(fi)))
                      return xt;
                  case 1:
                    if (d !== e2.noEmitSubstitution && (si = d(sr, fi) || fi) !== fi)
                      return Di && (si = Di(si)), Ii;
                  case 2:
                    if (ct(fi))
                      return xf;
                  case 3:
                    if (Li(fi))
                      return hd;
                  case 4:
                    return ut;
                  default:
                    return e2.Debug.assertNever(v);
                }
              }
              function Mt(v, sr, fi) {
                return nt(v + 1, sr, fi);
              }
              function xt(v, sr) {
                var fi = Mt(0, v, sr);
                H(v, sr, fi);
              }
              function ut(v, sr) {
                if (D == null || D(sr), de) {
                  var fi = de;
                  Ui(sr), Dt(v, sr), Yi(fi);
                } else
                  Dt(v, sr);
                fe == null || fe(sr), Di = void 0;
              }
              function Dt(v, sr, fi) {
                if (fi === void 0 && (fi = true), fi) {
                  var zi = e2.getSnippetElement(sr);
                  if (zi)
                    return Vi(v, sr, zi);
                }
                if (v === 0)
                  return yf(e2.cast(sr, e2.isSourceFile));
                if (v === 2)
                  return ba(e2.cast(sr, e2.isIdentifier));
                if (v === 6)
                  return wt(e2.cast(sr, e2.isStringLiteral), true);
                if (v === 3)
                  return Rt(e2.cast(sr, e2.isTypeParameterDeclaration));
                if (v === 5)
                  return e2.Debug.assertNode(sr, e2.isEmptyStatement), su(true);
                if (v === 4) {
                  switch (sr.kind) {
                    case 15:
                    case 16:
                    case 17:
                      return wt(sr, false);
                    case 79:
                      return ba(sr);
                    case 80:
                      return $a(sr);
                    case 161:
                      return Qa(sr);
                    case 162:
                      return Dn(sr);
                    case 163:
                      return ka(sr);
                    case 164:
                      return Ba(sr);
                    case 165:
                      return pn(sr);
                    case 166:
                      return Cn(sr);
                    case 167:
                      return Bi(sr);
                    case 168:
                      return kn(sr);
                    case 169:
                      return xn(sr);
                    case 170:
                      return Kn(sr);
                    case 171:
                      return Pn(sr);
                    case 172:
                    case 173:
                      return eo(sr);
                    case 174:
                      return Rn(sr);
                    case 175:
                      return Da(sr);
                    case 176:
                      return bo(sr);
                    case 177:
                      return Wn(sr);
                    case 178:
                      return to(sr);
                    case 179:
                      return Co(sr);
                    case 180:
                      return Pr(sr);
                    case 181:
                      return xi(sr);
                    case 182:
                      return St(sr);
                    case 183:
                      return pa(sr);
                    case 184:
                      return Jn(sr);
                    case 185:
                      return Gr(sr);
                    case 187:
                      return S2(sr);
                    case 188:
                      return Ce(sr);
                    case 189:
                      return qe(sr);
                    case 190:
                      return br(sr);
                    case 191:
                      return Zr(sr);
                    case 228:
                      return fo(sr);
                    case 192:
                      return Si();
                    case 193:
                      return Pi(sr);
                    case 194:
                      return Qi(sr);
                    case 195:
                      return Ct(sr);
                    case 196:
                      return sa(sr);
                    case 197:
                      return Qe(sr);
                    case 198:
                      return en(sr);
                    case 199:
                      return Ro(sr);
                    case 200:
                      return Wa(sr);
                    case 201:
                      return qn(sr);
                    case 202:
                      return mo(sr);
                    case 203:
                      return So(sr);
                    case 233:
                      return Ao(sr);
                    case 234:
                      return En();
                    case 235:
                      return Ms(sr);
                    case 237:
                      return xc(sr);
                    case 236:
                      return su(false);
                    case 238:
                      return tl(sr);
                    case 239:
                      return Zc(sr);
                    case 240:
                      return al(sr);
                    case 241:
                      return Jo(sr);
                    case 242:
                      return eu(sr);
                    case 243:
                      return Ws(sr);
                    case 244:
                      return pu(sr);
                    case 245:
                      return Ql(sr);
                    case 246:
                      return xl(sr);
                    case 247:
                      return Ei(sr);
                    case 248:
                      return tt(sr);
                    case 249:
                      return kt(sr);
                    case 250:
                      return bt(sr);
                    case 251:
                      return ia(sr);
                    case 252:
                      return Xt(sr);
                    case 253:
                      return Za(sr);
                    case 254:
                      return bn(sr);
                    case 255:
                      return _a4(sr);
                    case 256:
                      return qa(sr);
                    case 257:
                      return Or(sr);
                    case 258:
                      return dt(sr);
                    case 259:
                      return la(sr);
                    case 260:
                      return wa(sr);
                    case 261:
                      return On(sr);
                    case 262:
                      return No(sr);
                    case 263:
                      return jo(sr);
                    case 264:
                      return vf(sr);
                    case 265:
                      return po(sr);
                    case 266:
                      return $n(sr);
                    case 267:
                      return Ho(sr);
                    case 268:
                      return Zo(sr);
                    case 274:
                      return P_(sr);
                    case 269:
                      return Es(sr);
                    case 270:
                      return yc(sr);
                    case 271:
                      return Xr(sr);
                    case 272:
                      return Ls(sr);
                    case 273:
                      return El(sr);
                    case 275:
                      return vp(sr);
                    case 293:
                      return Ic(sr);
                    case 294:
                      return zu(sr);
                    case 276:
                      return;
                    case 277:
                      return yp(sr);
                    case 11:
                      return hp(sr);
                    case 280:
                    case 283:
                      return c_(sr);
                    case 281:
                    case 284:
                      return gu(sr);
                    case 285:
                      return sd(sr);
                    case 286:
                      return Dp(sr);
                    case 287:
                      return Aa(sr);
                    case 288:
                      return cd(sr);
                    case 289:
                      return nl(sr);
                    case 290:
                      return hc(sr);
                    case 291:
                      return u_(sr);
                    case 292:
                      return Jf(sr);
                    case 296:
                      return w_(sr);
                    case 297:
                      return ud(sr);
                    case 298:
                      return ku(sr);
                    case 299:
                      return ld(sr);
                    case 300:
                      return Ai(sr);
                    case 307:
                    case 301:
                      return na(sr);
                    case 302:
                    case 303:
                      return Oi(sr);
                    case 304:
                      return ji(sr);
                    case 305:
                      return yf(sr);
                    case 306:
                      return e2.Debug.fail("Bundles should be printed using printBundle");
                    case 308:
                      return e2.Debug.fail("InputFiles should not be printed");
                    case 309:
                      return ru(sr);
                    case 310:
                      return Tp(sr);
                    case 312:
                      return Gt("*");
                    case 313:
                      return Gt("?");
                    case 314:
                      return Oo(sr);
                    case 315:
                      return no(sr);
                    case 316:
                      return $o(sr);
                    case 317:
                      return Ko(sr);
                    case 186:
                    case 318:
                      return dn(sr);
                    case 319:
                      return;
                    case 320:
                      return fd(sr);
                    case 322:
                      return xp(sr);
                    case 323:
                      return M_(sr);
                    case 327:
                    case 332:
                    case 337:
                      return pd(sr);
                    case 328:
                    case 329:
                      return _d2(sr);
                    case 330:
                    case 331:
                      return;
                    case 333:
                    case 334:
                    case 335:
                    case 336:
                      return;
                    case 338:
                      return F_(sr);
                    case 340:
                    case 347:
                      return Ep(sr);
                    case 339:
                    case 341:
                    case 342:
                    case 343:
                      return bp(sr);
                    case 344:
                      return jf(sr);
                    case 345:
                      return O_(sr);
                    case 346:
                      return Sp(sr);
                    case 349:
                    case 353:
                    case 352:
                      return;
                  }
                  if (e2.isExpression(sr) && (v = 1, d !== e2.noEmitSubstitution)) {
                    var Sa = d(v, sr) || sr;
                    Sa !== sr && (sr = Sa, Di && (sr = Di(sr)));
                  }
                }
                if (v === 1)
                  switch (sr.kind) {
                    case 8:
                    case 9:
                      return Bt(sr);
                    case 10:
                    case 13:
                    case 14:
                      return wt(sr, false);
                    case 79:
                      return ba(sr);
                    case 80:
                      return $a(sr);
                    case 204:
                      return Go(sr);
                    case 205:
                      return ys(sr);
                    case 206:
                      return Pc(sr);
                    case 207:
                      return Kc(sr);
                    case 208:
                      return Xs(sr);
                    case 209:
                      return pc(sr);
                    case 210:
                      return hs(sr);
                    case 211:
                      return tc(sr);
                    case 212:
                      return ps(sr);
                    case 213:
                      return Qs(sr);
                    case 214:
                      return js(sr);
                    case 215:
                      return Ji(sr);
                    case 216:
                      return ce(sr);
                    case 217:
                      return Rr(sr);
                    case 218:
                      return yi(sr);
                    case 219:
                      return qi(sr);
                    case 220:
                      return Hr(sr);
                    case 221:
                      return Zt(sr);
                    case 222:
                      return Pt(sr);
                    case 223:
                      return ga(sr);
                    case 224:
                      return ua(sr);
                    case 225:
                      return Xn(sr);
                    case 226:
                      return jr(sr);
                    case 227:
                      return;
                    case 229:
                      return xs(sr);
                    case 230:
                      return Fo(sr);
                    case 228:
                      return fo(sr);
                    case 231:
                      return ko(sr);
                    case 232:
                      return e2.Debug.fail("SyntheticExpression should never be printed.");
                    case 278:
                      return Yl(sr);
                    case 279:
                      return Bf(sr);
                    case 282:
                      return Cl(sr);
                    case 348:
                      return e2.Debug.fail("SyntaxList should not be printed");
                    case 349:
                      return;
                    case 350:
                      return gd(sr);
                    case 351:
                      return hf(sr);
                    case 352:
                    case 353:
                      return;
                    case 354:
                      return e2.Debug.fail("SyntheticReferenceExpression should not be printed");
                  }
                if (e2.isKeyword(sr.kind))
                  return Pl(sr, vn);
                if (e2.isTokenKind(sr.kind))
                  return Pl(sr, Gt);
                e2.Debug.fail("Unhandled SyntaxKind: ".concat(e2.Debug.formatSyntaxKind(sr.kind), "."));
              }
              function Rt(v) {
                gr(v.name), Ut(), vn("in"), Ut(), gr(v.constraint);
              }
              function Ii(v, sr) {
                var fi = Mt(1, v, sr);
                e2.Debug.assertIsDefined(si), sr = si, si = void 0, fi(v, sr);
              }
              function Ki(v) {
                var sr;
                if (!(Be === e2.ModuleKind.None || k.noEmitHelpers)) {
                  for (var fi = new e2.Map(), zi = 0, Sa = v.sourceFiles; zi < Sa.length; zi++) {
                    var da = Sa[zi], Ha = e2.getExternalHelpersModuleName(da) !== void 0, ta = ui(da);
                    if (!!ta)
                      for (var nn = 0, Wo = ta; nn < Wo.length; nn++) {
                        var Lo = Wo[nn];
                        !Lo.scoped && !Ha && !fi.get(Lo.name) && (fi.set(Lo.name, true), (sr || (sr = [])).push(Lo.name));
                      }
                  }
                  return sr;
                }
              }
              function Fi(v) {
                var sr = false, fi = v.kind === 306 ? v : void 0;
                if (!(fi && Be === e2.ModuleKind.None)) {
                  for (var zi = fi ? fi.prepends.length : 0, Sa = fi ? fi.sourceFiles.length + zi : 1, da = 0; da < Sa; da++) {
                    var Ha = fi ? da < zi ? fi.prepends[da] : fi.sourceFiles[da - zi] : v, ta = e2.isSourceFile(Ha) ? Ha : e2.isUnparsedSource(Ha) ? void 0 : Re, nn = k.noEmitHelpers || !!ta && e2.hasRecordedExternalHelpers(ta), Wo = (e2.isSourceFile(Ha) || e2.isUnparsedSource(Ha)) && !Cr, Lo = e2.isUnparsedSource(Ha) ? Ha.helpers : ui(Ha);
                    if (Lo)
                      for (var oc = 0, uu = Lo; oc < uu.length; oc++) {
                        var is = uu[oc];
                        if (is.scoped) {
                          if (fi)
                            continue;
                        } else {
                          if (nn)
                            continue;
                          if (Wo) {
                            if (ge.get(is.name))
                              continue;
                            ge.set(is.name, true);
                          }
                        }
                        var au = Sr();
                        typeof is.text == "string" ? ul(is.text) : ul(is.text(Tf)), Ye && Ye.sections.push({ pos: au, end: Ae.getTextPos(), kind: "emitHelpers", data: is.name }), sr = true;
                      }
                  }
                  return sr;
                }
              }
              function ui(v) {
                var sr = e2.getEmitHelpers(v);
                return sr && e2.stableSort(sr, e2.compareEmitHelpers);
              }
              function Bt(v) {
                wt(v, false);
              }
              function wt(v, sr) {
                var fi = Pu(v, k.neverAsciiEscape, sr);
                (k.sourceMap || k.inlineSourceMap) && (v.kind === 10 || e2.isTemplateLiteralKind(v.kind)) ? d_(fi) : Gc(fi);
              }
              function na(v) {
                for (var sr = 0, fi = v.texts; sr < fi.length; sr++) {
                  var zi = fi[sr];
                  bs(), gr(zi);
                }
              }
              function Ai(v) {
                Ae.rawWrite(v.parent.text.substring(v.pos, v.end));
              }
              function Oi(v) {
                var sr = Sr();
                Ai(v), Ye && zr(sr, Ae.getTextPos(), v.kind === 302 ? "text" : "internal");
              }
              function ji(v) {
                var sr = Sr();
                if (Ai(v), Ye) {
                  var fi = e2.clone(v.section);
                  fi.pos = sr, fi.end = Ae.getTextPos(), Ye.sections.push(fi);
                }
              }
              function Vi(v, sr, fi) {
                switch (fi.kind) {
                  case 1:
                    at(v, sr, fi);
                    break;
                  case 0:
                    At(v, sr, fi);
                    break;
                }
              }
              function at(v, sr, fi) {
                bf("${".concat(fi.order, ":")), Dt(v, sr, false), bf("}");
              }
              function At(v, sr, fi) {
                e2.Debug.assert(sr.kind === 236, "A tab stop cannot be attached to a node of kind ".concat(e2.Debug.formatSyntaxKind(sr.kind), ".")), e2.Debug.assert(v !== 5, "A tab stop cannot be attached to an embedded statement."), bf("$".concat(fi.order));
              }
              function ba(v) {
                var sr = v.symbol ? vu : ir;
                sr(dc(v, false), v.symbol), Zn(v, v.typeArguments, 53776);
              }
              function $a(v) {
                var sr = v.symbol ? vu : ir;
                sr(dc(v, false), v.symbol);
              }
              function Qa(v) {
                ai(v.left), Gt("."), gr(v.right);
              }
              function ai(v) {
                v.kind === 79 ? Tr(v) : gr(v);
              }
              function Dn(v) {
                Gt("["), Tr(v.expression, Gi.parenthesizeExpressionOfComputedPropertyName), Gt("]");
              }
              function ka(v) {
                ks(v, v.modifiers), gr(v.name), v.constraint && (Ut(), vn("extends"), Ut(), gr(v.constraint)), v.default && (Ut(), Nl("="), Ut(), gr(v.default));
              }
              function Ba(v) {
                wc(v, v.decorators), ks(v, v.modifiers), gr(v.dotDotDotToken), md(v.name, cl), gr(v.questionToken), v.parent && v.parent.kind === 317 && !v.name ? gr(v.type) : Wu(v.type), Zl(v.initializer, v.type ? v.type.end : v.questionToken ? v.questionToken.end : v.name ? v.name.end : v.modifiers ? v.modifiers.end : v.decorators ? v.decorators.end : v.pos, v, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function pn(v) {
                Gt("@"), Tr(v.expression, Gi.parenthesizeLeftSideOfAccess);
              }
              function Cn(v) {
                wc(v, v.decorators), ks(v, v.modifiers), md(v.name, Ds), gr(v.questionToken), Wu(v.type), As();
              }
              function Bi(v) {
                wc(v, v.decorators), ks(v, v.modifiers), gr(v.name), gr(v.questionToken), gr(v.exclamationToken), Wu(v.type), Zl(v.initializer, v.type ? v.type.end : v.questionToken ? v.questionToken.end : v.name.end, v), As();
              }
              function kn(v) {
                wl(v), wc(v, v.decorators), ks(v, v.modifiers), gr(v.name), gr(v.questionToken), Vu(v, v.typeParameters), ef(v, v.parameters), Wu(v.type), As(), Iu(v);
              }
              function xn(v) {
                wc(v, v.decorators), ks(v, v.modifiers), gr(v.asteriskToken), gr(v.name), gr(v.questionToken), jn(v, Mo);
              }
              function Kn(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn("static"), gs(v.body);
              }
              function Pn(v) {
                ks(v, v.modifiers), vn("constructor"), jn(v, Mo);
              }
              function eo(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn(v.kind === 172 ? "get" : "set"), Ut(), gr(v.name), jn(v, Mo);
              }
              function Rn(v) {
                wl(v), wc(v, v.decorators), ks(v, v.modifiers), Vu(v, v.typeParameters), ef(v, v.parameters), Wu(v.type), As(), Iu(v);
              }
              function Da(v) {
                wl(v), wc(v, v.decorators), ks(v, v.modifiers), vn("new"), Ut(), Vu(v, v.typeParameters), ef(v, v.parameters), Wu(v.type), As(), Iu(v);
              }
              function bo(v) {
                wc(v, v.decorators), ks(v, v.modifiers), Df(v, v.parameters), Wu(v.type), As();
              }
              function Ro(v) {
                gr(v.type), gr(v.literal);
              }
              function En() {
                As();
              }
              function Wn(v) {
                v.assertsModifier && (gr(v.assertsModifier), Ut()), gr(v.parameterName), v.type && (Ut(), vn("is"), Ut(), gr(v.type));
              }
              function to(v) {
                gr(v.typeName), qu(v, v.typeArguments);
              }
              function Co(v) {
                wl(v), Vu(v, v.typeParameters), p_(v, v.parameters), Ut(), Gt("=>"), Ut(), gr(v.type), Iu(v);
              }
              function Ko(v) {
                vn("function"), ef(v, v.parameters), Gt(":"), gr(v.type);
              }
              function Oo(v) {
                Gt("?"), gr(v.type);
              }
              function no(v) {
                Gt("!"), gr(v.type);
              }
              function $o(v) {
                gr(v.type), Gt("=");
              }
              function Pr(v) {
                wl(v), ks(v, v.modifiers), vn("new"), Ut(), Vu(v, v.typeParameters), ef(v, v.parameters), Ut(), Gt("=>"), Ut(), gr(v.type), Iu(v);
              }
              function xi(v) {
                vn("typeof"), Ut(), gr(v.exprName), qu(v, v.typeArguments);
              }
              function St(v) {
                Gt("{");
                var sr = e2.getEmitFlags(v) & 1 ? 768 : 32897;
                Zn(v, v.members, sr | 524288), Gt("}");
              }
              function pa(v) {
                gr(v.elementType, Gi.parenthesizeNonArrayTypeOfPostfixType), Gt("["), Gt("]");
              }
              function dn(v) {
                Gt("..."), gr(v.type);
              }
              function Jn(v) {
                Ya(22, v.pos, Gt, v);
                var sr = e2.getEmitFlags(v) & 1 ? 528 : 657;
                Zn(v, v.elements, sr | 524288, Gi.parenthesizeElementTypeOfTupleType), Ya(23, v.elements.end, Gt, v);
              }
              function Qe(v) {
                gr(v.dotDotDotToken), gr(v.name), gr(v.questionToken), Ya(58, v.name.end, Gt, v), Ut(), gr(v.type);
              }
              function Gr(v) {
                gr(v.type, Gi.parenthesizeTypeOfOptionalType), Gt("?");
              }
              function S2(v) {
                Zn(v, v.types, 516, Gi.parenthesizeConstituentTypeOfUnionType);
              }
              function Ce(v) {
                Zn(v, v.types, 520, Gi.parenthesizeConstituentTypeOfIntersectionType);
              }
              function qe(v) {
                gr(v.checkType, Gi.parenthesizeCheckTypeOfConditionalType), Ut(), vn("extends"), Ut(), gr(v.extendsType, Gi.parenthesizeExtendsTypeOfConditionalType), Ut(), Gt("?"), Ut(), gr(v.trueType), Ut(), Gt(":"), Ut(), gr(v.falseType);
              }
              function br(v) {
                vn("infer"), Ut(), gr(v.typeParameter);
              }
              function Zr(v) {
                Gt("("), gr(v.type), Gt(")");
              }
              function Si() {
                vn("this");
              }
              function Pi(v) {
                Il(v.operator, vn), Ut();
                var sr = v.operator === 145 ? Gi.parenthesizeOperandOfReadonlyTypeOperator : Gi.parenthesizeOperandOfTypeOperator;
                gr(v.type, sr);
              }
              function Qi(v) {
                gr(v.objectType, Gi.parenthesizeNonArrayTypeOfPostfixType), Gt("["), gr(v.indexType), Gt("]");
              }
              function Ct(v) {
                var sr = e2.getEmitFlags(v);
                Gt("{"), sr & 1 ? Ut() : (bs(), Dc()), v.readonlyToken && (gr(v.readonlyToken), v.readonlyToken.kind !== 145 && vn("readonly"), Ut()), Gt("["), Wi(3, v.typeParameter), v.nameType && (Ut(), vn("as"), Ut(), gr(v.nameType)), Gt("]"), v.questionToken && (gr(v.questionToken), v.questionToken.kind !== 57 && Gt("?")), Gt(":"), Ut(), gr(v.type), As(), sr & 1 ? Ut() : (bs(), Cc()), Zn(v, v.members, 2), Gt("}");
              }
              function sa(v) {
                Tr(v.literal);
              }
              function en(v) {
                gr(v.head), Zn(v, v.templateSpans, 262144);
              }
              function Wa(v) {
                if (v.isTypeOf && (vn("typeof"), Ut()), vn("import"), Gt("("), gr(v.argument), v.assertions) {
                  Gt(","), Ut(), Gt("{"), Ut(), vn("assert"), Gt(":"), Ut();
                  var sr = v.assertions.assertClause.elements;
                  Zn(v.assertions.assertClause, sr, 526226), Ut(), Gt("}");
                }
                Gt(")"), v.qualifier && (Gt("."), gr(v.qualifier)), qu(v, v.typeArguments);
              }
              function qn(v) {
                Gt("{"), Zn(v, v.elements, 525136), Gt("}");
              }
              function mo(v) {
                Gt("["), Zn(v, v.elements, 524880), Gt("]");
              }
              function So(v) {
                gr(v.dotDotDotToken), v.propertyName && (gr(v.propertyName), Gt(":"), Ut()), gr(v.name), Zl(v.initializer, v.name.end, v, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function Go(v) {
                var sr = v.elements, fi = v.multiLine ? 65536 : 0;
                os(v, sr, 8914 | fi, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function ys(v) {
                e2.forEach(v.properties, Ys);
                var sr = e2.getEmitFlags(v) & 65536;
                sr && Dc();
                var fi = v.multiLine ? 65536 : 0, zi = Re && Re.languageVersion >= 1 && !e2.isJsonSourceFile(Re) ? 64 : 0;
                Zn(v, v.properties, 526226 | zi | fi), sr && Cc();
              }
              function Pc(v) {
                Tr(v.expression, Gi.parenthesizeLeftSideOfAccess);
                var sr = v.questionDotToken || e2.setTextRangePosEnd(e2.factory.createToken(24), v.expression.end, v.name.pos), fi = iu(v, v.expression, sr), zi = iu(v, sr, v.name);
                Nu(fi, false);
                var Sa = sr.kind !== 28 && Vc(v.expression) && !Ae.hasTrailingComment() && !Ae.hasTrailingWhitespace();
                Sa && Gt("."), v.questionDotToken ? gr(sr) : Ya(sr.kind, v.expression.end, Gt, v), Nu(zi, false), gr(v.name), Us(fi, zi);
              }
              function Vc(v) {
                if (v = e2.skipPartiallyEmittedExpressions(v), e2.isNumericLiteral(v)) {
                  var sr = Pu(v, true, false);
                  return !v.numericLiteralFlags && !e2.stringContains(sr, e2.tokenToString(24));
                } else if (e2.isAccessExpression(v)) {
                  var fi = e2.getConstantValue(v);
                  return typeof fi == "number" && isFinite(fi) && Math.floor(fi) === fi;
                }
              }
              function Kc(v) {
                Tr(v.expression, Gi.parenthesizeLeftSideOfAccess), gr(v.questionDotToken), Ya(22, v.expression.end, Gt, v), Tr(v.argumentExpression), Ya(23, v.argumentExpression.end, Gt, v);
              }
              function Xs(v) {
                var sr = e2.getEmitFlags(v) & 536870912;
                sr && (Gt("("), d_("0"), Gt(","), Ut()), Tr(v.expression, Gi.parenthesizeLeftSideOfAccess), sr && Gt(")"), gr(v.questionDotToken), qu(v, v.typeArguments), os(v, v.arguments, 2576, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function pc(v) {
                Ya(103, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeExpressionOfNew), qu(v, v.typeArguments), os(v, v.arguments, 18960, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function hs(v) {
                var sr = e2.getEmitFlags(v) & 536870912;
                sr && (Gt("("), d_("0"), Gt(","), Ut()), Tr(v.tag, Gi.parenthesizeLeftSideOfAccess), sr && Gt(")"), qu(v, v.typeArguments), Ut(), Tr(v.template);
              }
              function tc(v) {
                Gt("<"), gr(v.type), Gt(">"), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function ps(v) {
                var sr = Ya(20, v.pos, Gt, v), fi = J_(v.expression, v);
                Tr(v.expression, void 0), j_(v.expression, v), Us(fi), Ya(21, v.expression ? v.expression.end : sr, Gt, v);
              }
              function Qs(v) {
                Ku(v.name), rn(v);
              }
              function js(v) {
                wc(v, v.decorators), ks(v, v.modifiers), jn(v, ds);
              }
              function ds(v) {
                Vu(v, v.typeParameters), p_(v, v.parameters), Wu(v.type), Ut(), gr(v.equalsGreaterThanToken);
              }
              function Ji(v) {
                Ya(89, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function ce(v) {
                Ya(112, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function Rr(v) {
                Ya(114, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function yi(v) {
                Ya(132, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function qi(v) {
                Il(v.operator, Nl), je(v) && Ut(), Tr(v.operand, Gi.parenthesizeOperandOfPrefixUnary);
              }
              function je(v) {
                var sr = v.operand;
                return sr.kind === 219 && (v.operator === 39 && (sr.operator === 39 || sr.operator === 45) || v.operator === 40 && (sr.operator === 40 || sr.operator === 46));
              }
              function Hr(v) {
                Tr(v.operand, Gi.parenthesizeOperandOfPostfixUnary), Il(v.operator, Nl);
              }
              function pt() {
                return e2.createBinaryExpressionTrampoline(v, sr, fi, zi, Sa, void 0);
                function v(Ha, ta) {
                  if (ta) {
                    ta.stackIndex++, ta.preserveSourceNewlinesStack[ta.stackIndex] = de, ta.containerPosStack[ta.stackIndex] = wr, ta.containerEndStack[ta.stackIndex] = Ur, ta.declarationListContainerEndStack[ta.stackIndex] = ii;
                    var nn = ta.shouldEmitCommentsStack[ta.stackIndex] = ct(Ha), Wo = ta.shouldEmitSourceMapsStack[ta.stackIndex] = Li(Ha);
                    D == null || D(Ha), nn && z_(Ha), Wo && v_(Ha), Ui(Ha);
                  } else
                    ta = { stackIndex: 0, preserveSourceNewlinesStack: [void 0], containerPosStack: [-1], containerEndStack: [-1], declarationListContainerEndStack: [-1], shouldEmitCommentsStack: [false], shouldEmitSourceMapsStack: [false] };
                  return ta;
                }
                function sr(Ha, ta, nn) {
                  return da(Ha, nn, "left");
                }
                function fi(Ha, ta, nn) {
                  var Wo = Ha.kind !== 27, Lo = iu(nn, nn.left, Ha), oc = iu(nn, Ha, nn.right);
                  Nu(Lo, Wo), Vf(Ha.pos), Pl(Ha, Ha.kind === 101 ? vn : Nl), af(Ha.end, true), Nu(oc, true);
                }
                function zi(Ha, ta, nn) {
                  return da(Ha, nn, "right");
                }
                function Sa(Ha, ta) {
                  var nn = iu(Ha, Ha.left, Ha.operatorToken), Wo = iu(Ha, Ha.operatorToken, Ha.right);
                  if (Us(nn, Wo), ta.stackIndex > 0) {
                    var Lo = ta.preserveSourceNewlinesStack[ta.stackIndex], oc = ta.containerPosStack[ta.stackIndex], uu = ta.containerEndStack[ta.stackIndex], is = ta.declarationListContainerEndStack[ta.stackIndex], au = ta.shouldEmitCommentsStack[ta.stackIndex], Ou = ta.shouldEmitSourceMapsStack[ta.stackIndex];
                    Yi(Lo), Ou && Bp(Ha), au && Oc(Ha, oc, uu, is), fe == null || fe(Ha), ta.stackIndex--;
                  }
                }
                function da(Ha, ta, nn) {
                  var Wo = nn === "left" ? Gi.getParenthesizeLeftSideOfBinaryForOperator(ta.operatorToken.kind) : Gi.getParenthesizeRightSideOfBinaryForOperator(ta.operatorToken.kind), Lo = nt(0, 1, Ha);
                  if (Lo === Ii && (e2.Debug.assertIsDefined(si), Ha = Wo(e2.cast(si, e2.isExpression)), Lo = Mt(1, 1, Ha), si = void 0), (Lo === xf || Lo === hd || Lo === ut) && e2.isBinaryExpression(Ha))
                    return Ha;
                  Di = Wo, Lo(1, Ha);
                }
              }
              function Pt(v) {
                var sr = iu(v, v.condition, v.questionToken), fi = iu(v, v.questionToken, v.whenTrue), zi = iu(v, v.whenTrue, v.colonToken), Sa = iu(v, v.colonToken, v.whenFalse);
                Tr(v.condition, Gi.parenthesizeConditionOfConditionalExpression), Nu(sr, true), gr(v.questionToken), Nu(fi, true), Tr(v.whenTrue, Gi.parenthesizeBranchOfConditionalExpression), Us(sr, fi), Nu(zi, true), gr(v.colonToken), Nu(Sa, true), Tr(v.whenFalse, Gi.parenthesizeBranchOfConditionalExpression), Us(zi, Sa);
              }
              function ga(v) {
                gr(v.head), Zn(v, v.templateSpans, 262144);
              }
              function ua(v) {
                Ya(125, v.pos, vn, v), gr(v.asteriskToken), __(v.expression && Kr(v.expression), _i);
              }
              function Xn(v) {
                Ya(25, v.pos, Gt, v), Tr(v.expression, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function jr(v) {
                Ku(v.name), ki(v);
              }
              function fo(v) {
                Tr(v.expression, Gi.parenthesizeLeftSideOfAccess), qu(v, v.typeArguments);
              }
              function xs(v) {
                Tr(v.expression, void 0), v.type && (Ut(), vn("as"), Ut(), gr(v.type));
              }
              function Fo(v) {
                Tr(v.expression, Gi.parenthesizeLeftSideOfAccess), Nl("!");
              }
              function ko(v) {
                ac(v.keywordToken, v.pos, Gt), Gt("."), gr(v.name);
              }
              function Ao(v) {
                Tr(v.expression), gr(v.literal);
              }
              function Ms(v) {
                Bs(v, !v.multiLine && vd(v));
              }
              function Bs(v, sr) {
                Ya(18, v.pos, Gt, v);
                var fi = sr || e2.getEmitFlags(v) & 1 ? 768 : 129;
                Zn(v, v.statements, fi), Ya(19, v.statements.end, Gt, v, !!(fi & 1));
              }
              function xc(v) {
                ks(v, v.modifiers), gr(v.declarationList), As();
              }
              function su(v) {
                v ? Gt(";") : As();
              }
              function tl(v) {
                Tr(v.expression, Gi.parenthesizeExpressionOfExpressionStatement), (!Re || !e2.isJsonSourceFile(Re) || e2.nodeIsSynthesized(v.expression)) && As();
              }
              function Zc(v) {
                var sr = Ya(99, v.pos, vn, v);
                Ut(), Ya(20, sr, Gt, v), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Al(v, v.thenStatement), v.elseStatement && (zf(v, v.thenStatement, v.elseStatement), Ya(91, v.thenStatement.end, vn, v), v.elseStatement.kind === 239 ? (Ut(), gr(v.elseStatement)) : Al(v, v.elseStatement));
              }
              function Rf(v, sr) {
                var fi = Ya(115, sr, vn, v);
                Ut(), Ya(20, fi, Gt, v), Tr(v.expression), Ya(21, v.expression.end, Gt, v);
              }
              function al(v) {
                Ya(90, v.pos, vn, v), Al(v, v.statement), e2.isBlock(v.statement) && !de ? Ut() : zf(v, v.statement, v.expression), Rf(v, v.statement.end), As();
              }
              function Jo(v) {
                Rf(v, v.pos), Al(v, v.statement);
              }
              function eu(v) {
                var sr = Ya(97, v.pos, vn, v);
                Ut();
                var fi = Ya(20, sr, Gt, v);
                Uu(v.initializer), fi = Ya(26, v.initializer ? v.initializer.end : fi, Gt, v), __(v.condition), fi = Ya(26, v.condition ? v.condition.end : fi, Gt, v), __(v.incrementor), Ya(21, v.incrementor ? v.incrementor.end : fi, Gt, v), Al(v, v.statement);
              }
              function Ws(v) {
                var sr = Ya(97, v.pos, vn, v);
                Ut(), Ya(20, sr, Gt, v), Uu(v.initializer), Ut(), Ya(101, v.initializer.end, vn, v), Ut(), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Al(v, v.statement);
              }
              function pu(v) {
                var sr = Ya(97, v.pos, vn, v);
                Ut(), zd(v.awaitModifier), Ya(20, sr, Gt, v), Uu(v.initializer), Ut(), Ya(160, v.initializer.end, vn, v), Ut(), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Al(v, v.statement);
              }
              function Uu(v) {
                v !== void 0 && (v.kind === 255 ? gr(v) : Tr(v));
              }
              function Ql(v) {
                Ya(86, v.pos, vn, v), kl(v.label), As();
              }
              function xl(v) {
                Ya(81, v.pos, vn, v), kl(v.label), As();
              }
              function Ya(v, sr, fi, zi, Sa) {
                var da = e2.getParseTreeNode(zi), Ha = da && da.kind === zi.kind, ta = sr;
                if (Ha && Re && (sr = e2.skipTrivia(Re.text, sr)), Ha && zi.pos !== ta) {
                  var nn = Sa && Re && !e2.positionsAreOnSameLine(ta, sr, Re);
                  nn && Dc(), Vf(ta), nn && Cc();
                }
                if (sr = Il(v, fi, sr), Ha && zi.end !== sr) {
                  var Wo = zi.kind === 288;
                  af(sr, !Wo, Wo);
                }
                return sr;
              }
              function du(v) {
                return v.kind === 2 || !!v.hasTrailingNewLine;
              }
              function vc(v) {
                return Re ? e2.some(e2.getLeadingCommentRanges(Re.text, v.pos), du) || e2.some(e2.getSyntheticLeadingComments(v), du) ? true : e2.isPartiallyEmittedExpression(v) ? v.pos !== v.expression.pos && e2.some(e2.getTrailingCommentRanges(Re.text, v.expression.pos), du) ? true : vc(v.expression) : false : false;
              }
              function Kr(v) {
                if (!qr && e2.isPartiallyEmittedExpression(v) && vc(v)) {
                  var sr = e2.getParseTreeNode(v);
                  if (sr && e2.isParenthesizedExpression(sr)) {
                    var fi = e2.factory.createParenthesizedExpression(v.expression);
                    return e2.setOriginalNode(fi, v), e2.setTextRange(fi, sr), fi;
                  }
                  return e2.factory.createParenthesizedExpression(v);
                }
                return v;
              }
              function _i(v) {
                return Kr(Gi.parenthesizeExpressionForDisallowedComma(v));
              }
              function Ei(v) {
                Ya(105, v.pos, vn, v), __(v.expression && Kr(v.expression), Kr), As();
              }
              function tt(v) {
                var sr = Ya(116, v.pos, vn, v);
                Ut(), Ya(20, sr, Gt, v), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Al(v, v.statement);
              }
              function kt(v) {
                var sr = Ya(107, v.pos, vn, v);
                Ut(), Ya(20, sr, Gt, v), Tr(v.expression), Ya(21, v.expression.end, Gt, v), Ut(), gr(v.caseBlock);
              }
              function bt(v) {
                gr(v.label), Ya(58, v.label.end, Gt, v), Ut(), gr(v.statement);
              }
              function ia(v) {
                Ya(109, v.pos, vn, v), __(Kr(v.expression), Kr), As();
              }
              function Xt(v) {
                Ya(111, v.pos, vn, v), Ut(), gr(v.tryBlock), v.catchClause && (zf(v, v.tryBlock, v.catchClause), gr(v.catchClause)), v.finallyBlock && (zf(v, v.catchClause || v.tryBlock, v.finallyBlock), Ya(96, (v.catchClause || v.tryBlock).end, vn, v), Ut(), gr(v.finallyBlock));
              }
              function Za(v) {
                ac(87, v.pos, vn), As();
              }
              function bn(v) {
                var sr, fi, zi, Sa, da;
                gr(v.name), gr(v.exclamationToken), Wu(v.type), Zl(v.initializer, (da = (fi = (sr = v.type) === null || sr === void 0 ? void 0 : sr.end) !== null && fi !== void 0 ? fi : (Sa = (zi = v.name.emitNode) === null || zi === void 0 ? void 0 : zi.typeNode) === null || Sa === void 0 ? void 0 : Sa.end) !== null && da !== void 0 ? da : v.name.end, v, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function _a4(v) {
                vn(e2.isLet(v) ? "let" : e2.isVarConst(v) ? "const" : "var"), Ut(), Zn(v, v.declarations, 528);
              }
              function qa(v) {
                rn(v);
              }
              function rn(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn("function"), gr(v.asteriskToken), Ut(), Vr(v.name), jn(v, Mo);
              }
              function jn(v, sr) {
                var fi = v.body;
                if (fi)
                  if (e2.isBlock(fi)) {
                    var zi = e2.getEmitFlags(v) & 65536;
                    zi && Dc(), wl(v), e2.forEach(v.parameters, Et), Et(v.body), sr(v), gs(fi), Iu(v), zi && Cc();
                  } else
                    sr(v), Ut(), Tr(fi, Gi.parenthesizeConciseBodyOfArrowFunction);
                else
                  sr(v), As();
              }
              function Mo(v) {
                Vu(v, v.typeParameters), ef(v, v.parameters), Wu(v.type);
              }
              function ho(v) {
                if (e2.getEmitFlags(v) & 1)
                  return true;
                if (v.multiLine || !e2.nodeIsSynthesized(v) && Re && !e2.rangeIsOnSingleLine(v, Re) || Ap(v, v.statements, 2) || Sf(v, v.statements, 2))
                  return false;
                for (var sr, fi = 0, zi = v.statements; fi < zi.length; fi++) {
                  var Sa = zi[fi];
                  if (Wf(sr, Sa, 2) > 0)
                    return false;
                  sr = Sa;
                }
                return true;
              }
              function gs(v) {
                D == null || D(v), Ut(), Gt("{"), Dc();
                var sr = ho(v) ? Se : hr;
                Mp(v, v.statements, sr), Cc(), ac(19, v.statements.end, Gt, v), fe == null || fe(v);
              }
              function Se(v) {
                hr(v, true);
              }
              function hr(v, sr) {
                var fi = $l(v.statements), zi = Ae.getTextPos();
                Fi(v), fi === 0 && zi === Ae.getTextPos() && sr ? (Cc(), Zn(v, v.statements, 768), Dc()) : Zn(v, v.statements, 1, void 0, fi);
              }
              function Or(v) {
                ki(v);
              }
              function ki(v) {
                e2.forEach(v.members, Ys), wc(v, v.decorators), ks(v, v.modifiers), vn("class"), v.name && (Ut(), Vr(v.name));
                var sr = e2.getEmitFlags(v) & 65536;
                sr && Dc(), Vu(v, v.typeParameters), Zn(v, v.heritageClauses, 0), Ut(), Gt("{"), Zn(v, v.members, 129), Gt("}"), sr && Cc();
              }
              function dt(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn("interface"), Ut(), gr(v.name), Vu(v, v.typeParameters), Zn(v, v.heritageClauses, 512), Ut(), Gt("{"), Zn(v, v.members, 129), Gt("}");
              }
              function la(v) {
                wc(v, v.decorators), ks(v, v.modifiers), vn("type"), Ut(), gr(v.name), Vu(v, v.typeParameters), Ut(), Gt("="), Ut(), gr(v.type), As();
              }
              function wa(v) {
                ks(v, v.modifiers), vn("enum"), Ut(), gr(v.name), Ut(), Gt("{"), Zn(v, v.members, 145), Gt("}");
              }
              function On(v) {
                ks(v, v.modifiers), ~v.flags & 1024 && (vn(v.flags & 16 ? "namespace" : "module"), Ut()), gr(v.name);
                var sr = v.body;
                if (!sr)
                  return As();
                for (; sr && e2.isModuleDeclaration(sr); )
                  Gt("."), gr(sr.name), sr = sr.body;
                Ut(), gr(sr);
              }
              function No(v) {
                wl(v), e2.forEach(v.statements, Et), Bs(v, vd(v)), Iu(v);
              }
              function jo(v) {
                Ya(18, v.pos, Gt, v), Zn(v, v.clauses, 129), Ya(19, v.clauses.end, Gt, v, true);
              }
              function po(v) {
                ks(v, v.modifiers), Ya(100, v.modifiers ? v.modifiers.end : v.pos, vn, v), Ut(), v.isTypeOnly && (Ya(152, v.pos, vn, v), Ut()), gr(v.name), Ut(), Ya(63, v.name.end, Gt, v), Ut(), Gn(v.moduleReference), As();
              }
              function Gn(v) {
                v.kind === 79 ? Tr(v) : gr(v);
              }
              function $n(v) {
                ks(v, v.modifiers), Ya(100, v.modifiers ? v.modifiers.end : v.pos, vn, v), Ut(), v.importClause && (gr(v.importClause), Ut(), Ya(156, v.importClause.end, vn, v), Ut()), Tr(v.moduleSpecifier), v.assertClause && kl(v.assertClause), As();
              }
              function Ho(v) {
                v.isTypeOnly && (Ya(152, v.pos, vn, v), Ut()), gr(v.name), v.name && v.namedBindings && (Ya(27, v.name.end, Gt, v), Ut()), gr(v.namedBindings);
              }
              function Zo(v) {
                var sr = Ya(41, v.pos, Gt, v);
                Ut(), Ya(127, sr, vn, v), Ut(), gr(v.name);
              }
              function Es(v) {
                oo(v);
              }
              function yc(v) {
                I_(v);
              }
              function Xr(v) {
                var sr = Ya(93, v.pos, vn, v);
                Ut(), v.isExportEquals ? Ya(63, sr, Nl, v) : Ya(88, sr, vn, v), Ut(), Tr(v.expression, v.isExportEquals ? Gi.getParenthesizeRightSideOfBinaryForOperator(63) : Gi.parenthesizeExpressionOfExportDefault), As();
              }
              function Ls(v) {
                var sr = Ya(93, v.pos, vn, v);
                if (Ut(), v.isTypeOnly && (sr = Ya(152, sr, vn, v), Ut()), v.exportClause ? gr(v.exportClause) : sr = Ya(41, sr, Gt, v), v.moduleSpecifier) {
                  Ut();
                  var fi = v.exportClause ? v.exportClause.end : sr;
                  Ya(156, fi, vn, v), Ut(), Tr(v.moduleSpecifier);
                }
                v.assertClause && kl(v.assertClause), As();
              }
              function Ic(v) {
                Ya(129, v.pos, vn, v), Ut();
                var sr = v.elements;
                Zn(v, sr, 526226);
              }
              function zu(v) {
                gr(v.name), Gt(":"), Ut();
                var sr = v.value;
                if ((e2.getEmitFlags(sr) & 512) === 0) {
                  var fi = e2.getCommentRange(sr);
                  af(fi.pos);
                }
                gr(sr);
              }
              function vf(v) {
                var sr = Ya(93, v.pos, vn, v);
                Ut(), sr = Ya(127, sr, vn, v), Ut(), sr = Ya(142, sr, vn, v), Ut(), gr(v.name), As();
              }
              function P_(v) {
                var sr = Ya(41, v.pos, Gt, v);
                Ut(), Ya(127, sr, vn, v), Ut(), gr(v.name);
              }
              function El(v) {
                oo(v);
              }
              function vp(v) {
                I_(v);
              }
              function oo(v) {
                Gt("{"), Zn(v, v.elements, 525136), Gt("}");
              }
              function I_(v) {
                v.isTypeOnly && (vn("type"), Ut()), v.propertyName && (gr(v.propertyName), Ut(), Ya(127, v.propertyName.end, vn, v), Ut()), gr(v.name);
              }
              function yp(v) {
                vn("require"), Gt("("), Tr(v.expression), Gt(")");
              }
              function Yl(v) {
                gr(v.openingElement), Zn(v, v.children, 262144), gr(v.closingElement);
              }
              function Bf(v) {
                Gt("<"), ns(v.tagName), qu(v, v.typeArguments), Ut(), gr(v.attributes), Gt("/>");
              }
              function Cl(v) {
                gr(v.openingFragment), Zn(v, v.children, 262144), gr(v.closingFragment);
              }
              function c_(v) {
                if (Gt("<"), e2.isJsxOpeningElement(v)) {
                  var sr = J_(v.tagName, v);
                  ns(v.tagName), qu(v, v.typeArguments), v.attributes.properties && v.attributes.properties.length > 0 && Ut(), gr(v.attributes), j_(v.attributes, v), Us(sr);
                }
                Gt(">");
              }
              function hp(v) {
                Ae.writeLiteral(v.text);
              }
              function gu(v) {
                Gt("</"), e2.isJsxClosingElement(v) && ns(v.tagName), Gt(">");
              }
              function Dp(v) {
                Zn(v, v.properties, 262656);
              }
              function sd(v) {
                gr(v.name), R_("=", Gt, v.initializer, vi);
              }
              function Aa(v) {
                Gt("{..."), Tr(v.expression), Gt("}");
              }
              function va(v) {
                var sr = false;
                return e2.forEachTrailingCommentRange((Re == null ? void 0 : Re.text) || "", v + 1, function() {
                  return sr = true;
                }), sr;
              }
              function Cu(v) {
                var sr = false;
                return e2.forEachLeadingCommentRange((Re == null ? void 0 : Re.text) || "", v + 1, function() {
                  return sr = true;
                }), sr;
              }
              function qs(v) {
                return va(v) || Cu(v);
              }
              function cd(v) {
                var sr;
                if (v.expression || !qr && !e2.nodeIsSynthesized(v) && qs(v.pos)) {
                  var fi = Re && !e2.nodeIsSynthesized(v) && e2.getLineAndCharacterOfPosition(Re, v.pos).line !== e2.getLineAndCharacterOfPosition(Re, v.end).line;
                  fi && Ae.increaseIndent();
                  var zi = Ya(18, v.pos, Gt, v);
                  gr(v.dotDotDotToken), Tr(v.expression), Ya(19, ((sr = v.expression) === null || sr === void 0 ? void 0 : sr.end) || zi, Gt, v), fi && Ae.decreaseIndent();
                }
              }
              function ns(v) {
                v.kind === 79 ? Tr(v) : gr(v);
              }
              function nl(v) {
                Ya(82, v.pos, vn, v), Ut(), Tr(v.expression, Gi.parenthesizeExpressionForDisallowedComma), es(v, v.statements, v.expression.end);
              }
              function hc(v) {
                var sr = Ya(88, v.pos, vn, v);
                es(v, v.statements, sr);
              }
              function es(v, sr, fi) {
                var zi = sr.length === 1 && (!Re || e2.nodeIsSynthesized(v) || e2.nodeIsSynthesized(sr[0]) || e2.rangeStartPositionsAreOnSameLine(v, sr[0], Re)), Sa = 163969;
                zi ? (ac(58, fi, Gt, v), Ut(), Sa &= -130) : Ya(58, fi, Gt, v), Zn(v, sr, Sa);
              }
              function u_(v) {
                Ut(), Il(v.token, vn), Ut(), Zn(v, v.types, 528);
              }
              function Jf(v) {
                var sr = Ya(83, v.pos, vn, v);
                Ut(), v.variableDeclaration && (Ya(20, sr, Gt, v), gr(v.variableDeclaration), Ya(21, v.variableDeclaration.end, Gt, v), Ut()), gr(v.block);
              }
              function w_(v) {
                gr(v.name), Gt(":"), Ut();
                var sr = v.initializer;
                if ((e2.getEmitFlags(sr) & 512) === 0) {
                  var fi = e2.getCommentRange(sr);
                  af(fi.pos);
                }
                Tr(sr, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function ud(v) {
                gr(v.name), v.objectAssignmentInitializer && (Ut(), Gt("="), Ut(), Tr(v.objectAssignmentInitializer, Gi.parenthesizeExpressionForDisallowedComma));
              }
              function ku(v) {
                v.expression && (Ya(25, v.pos, Gt, v), Tr(v.expression, Gi.parenthesizeExpressionForDisallowedComma));
              }
              function ld(v) {
                gr(v.name), Zl(v.initializer, v.name.end, v, Gi.parenthesizeExpressionForDisallowedComma);
              }
              function fd(v) {
                if (ir("/**"), v.comment) {
                  var sr = e2.getTextOfJSDocComment(v.comment);
                  if (sr)
                    for (var fi = sr.split(/\r\n?|\n/g), zi = 0, Sa = fi; zi < Sa.length; zi++) {
                      var da = Sa[zi];
                      bs(), Ut(), Gt("*"), Ut(), ir(da);
                    }
                }
                v.tags && (v.tags.length === 1 && v.tags[0].kind === 343 && !v.comment ? (Ut(), gr(v.tags[0])) : Zn(v, v.tags, 33)), Ut(), ir("*/");
              }
              function bp(v) {
                ol(v.tagName), ru(v.typeExpression), Au(v.comment);
              }
              function Sp(v) {
                ol(v.tagName), gr(v.name), Au(v.comment);
              }
              function Tp(v) {
                Ut(), Gt("{"), gr(v.name), Gt("}");
              }
              function _d2(v) {
                ol(v.tagName), Ut(), Gt("{"), gr(v.class), Gt("}"), Au(v.comment);
              }
              function jf(v) {
                ol(v.tagName), ru(v.constraint), Ut(), Zn(v, v.typeParameters, 528), Au(v.comment);
              }
              function O_(v) {
                ol(v.tagName), v.typeExpression && (v.typeExpression.kind === 309 ? ru(v.typeExpression) : (Ut(), Gt("{"), ir("Object"), v.typeExpression.isArrayType && (Gt("["), Gt("]")), Gt("}"))), v.fullName && (Ut(), gr(v.fullName)), Au(v.comment), v.typeExpression && v.typeExpression.kind === 322 && xp(v.typeExpression);
              }
              function F_(v) {
                ol(v.tagName), v.name && (Ut(), gr(v.name)), Au(v.comment), M_(v.typeExpression);
              }
              function pd(v) {
                ol(v.tagName), Au(v.comment);
              }
              function xp(v) {
                Zn(v, e2.factory.createNodeArray(v.jsDocPropertyTags), 33);
              }
              function M_(v) {
                v.typeParameters && Zn(v, e2.factory.createNodeArray(v.typeParameters), 33), v.parameters && Zn(v, e2.factory.createNodeArray(v.parameters), 33), v.type && (bs(), Ut(), Gt("*"), Ut(), gr(v.type));
              }
              function Ep(v) {
                ol(v.tagName), ru(v.typeExpression), Ut(), v.isBracketed && Gt("["), gr(v.name), v.isBracketed && Gt("]"), Au(v.comment);
              }
              function ol(v) {
                Gt("@"), gr(v);
              }
              function Au(v) {
                var sr = e2.getTextOfJSDocComment(v);
                sr && (Ut(), ir(sr));
              }
              function ru(v) {
                v && (Ut(), Gt("{"), gr(v.type), Gt("}"));
              }
              function yf(v) {
                bs();
                var sr = v.statements, fi = sr.length === 0 || !e2.isPrologueDirective(sr[0]) || e2.nodeIsSynthesized(sr[0]);
                if (fi) {
                  Mp(v, sr, mu);
                  return;
                }
                mu(v);
              }
              function Cp(v) {
                kp(!!v.hasNoDefaultLib, v.syntheticFileReferences || [], v.syntheticTypeReferences || [], v.syntheticLibReferences || []);
                for (var sr = 0, fi = v.prepends; sr < fi.length; sr++) {
                  var zi = fi[sr];
                  if (e2.isUnparsedSource(zi) && zi.syntheticReferences)
                    for (var Sa = 0, da = zi.syntheticReferences; Sa < da.length; Sa++) {
                      var Ha = da[Sa];
                      gr(Ha), bs();
                    }
                }
              }
              function dd(v) {
                v.isDeclarationFile && kp(v.hasNoDefaultLib, v.referencedFiles, v.typeReferenceDirectives, v.libReferenceDirectives);
              }
              function kp(v, sr, fi, zi) {
                if (v) {
                  var Sa = Ae.getTextPos();
                  rf('/// <reference no-default-lib="true"/>'), Ye && Ye.sections.push({ pos: Sa, end: Ae.getTextPos(), kind: "no-default-lib" }), bs();
                }
                if (Re && Re.moduleName && (rf('/// <amd-module name="'.concat(Re.moduleName, '" />')), bs()), Re && Re.amdDependencies)
                  for (var da = 0, Ha = Re.amdDependencies; da < Ha.length; da++) {
                    var ta = Ha[da];
                    ta.name ? rf('/// <amd-dependency name="'.concat(ta.name, '" path="').concat(ta.path, '" />')) : rf('/// <amd-dependency path="'.concat(ta.path, '" />')), bs();
                  }
                for (var nn = 0, Wo = sr; nn < Wo.length; nn++) {
                  var Lo = Wo[nn], Sa = Ae.getTextPos();
                  rf('/// <reference path="'.concat(Lo.fileName, '" />')), Ye && Ye.sections.push({ pos: Sa, end: Ae.getTextPos(), kind: "reference", data: Lo.fileName }), bs();
                }
                for (var oc = 0, uu = fi; oc < uu.length; oc++) {
                  var Lo = uu[oc], Sa = Ae.getTextPos(), is = Lo.resolutionMode && Lo.resolutionMode !== (Re == null ? void 0 : Re.impliedNodeFormat) ? 'resolution-mode="'.concat(Lo.resolutionMode === e2.ModuleKind.ESNext ? "import" : "require", '"') : "";
                  rf('/// <reference types="'.concat(Lo.fileName, '" ').concat(is, "/>")), Ye && Ye.sections.push({ pos: Sa, end: Ae.getTextPos(), kind: Lo.resolutionMode ? Lo.resolutionMode === e2.ModuleKind.ESNext ? "type-import" : "type-require" : "type", data: Lo.fileName }), bs();
                }
                for (var au = 0, Ou = zi; au < Ou.length; au++) {
                  var Lo = Ou[au], Sa = Ae.getTextPos();
                  rf('/// <reference lib="'.concat(Lo.fileName, '" />')), Ye && Ye.sections.push({ pos: Sa, end: Ae.getTextPos(), kind: "lib", data: Lo.fileName }), bs();
                }
              }
              function mu(v) {
                var sr = v.statements;
                wl(v), e2.forEach(v.statements, Et), Fi(v);
                var fi = e2.findIndex(sr, function(zi) {
                  return !e2.isPrologueDirective(zi);
                });
                dd(v), Zn(v, sr, 1, void 0, fi === -1 ? sr.length : fi), Iu(v);
              }
              function gd(v) {
                var sr = e2.getEmitFlags(v);
                !(sr & 512) && v.pos !== v.expression.pos && af(v.expression.pos), Tr(v.expression), !(sr & 1024) && v.end !== v.expression.end && Vf(v.expression.end);
              }
              function hf(v) {
                os(v, v.elements, 528, void 0);
              }
              function $l(v, sr, fi, zi) {
                for (var Sa = !!sr, da = 0; da < v.length; da++) {
                  var Ha = v[da];
                  if (e2.isPrologueDirective(Ha)) {
                    var ta = fi ? !fi.has(Ha.expression.text) : true;
                    if (ta) {
                      Sa && (Sa = false, Pe(sr)), bs();
                      var nn = Ae.getTextPos();
                      gr(Ha), zi && Ye && Ye.sections.push({ pos: nn, end: Ae.getTextPos(), kind: "prologue", data: Ha.expression.text }), fi && fi.add(Ha.expression.text);
                    }
                  } else
                    return da;
                }
                return v.length;
              }
              function Uf(v, sr) {
                for (var fi = 0, zi = v; fi < zi.length; fi++) {
                  var Sa = zi[fi];
                  if (!sr.has(Sa.data)) {
                    bs();
                    var da = Ae.getTextPos();
                    gr(Sa), Ye && Ye.sections.push({ pos: da, end: Ae.getTextPos(), kind: "prologue", data: Sa.data }), sr && sr.add(Sa.data);
                  }
                }
              }
              function L_(v) {
                if (e2.isSourceFile(v))
                  $l(v.statements, v);
                else {
                  for (var sr = new e2.Set(), fi = 0, zi = v.prepends; fi < zi.length; fi++) {
                    var Sa = zi[fi];
                    Uf(Sa.prologues, sr);
                  }
                  for (var da = 0, Ha = v.sourceFiles; da < Ha.length; da++) {
                    var ta = Ha[da];
                    $l(ta.statements, ta, sr, true);
                  }
                  Pe(void 0);
                }
              }
              function l_(v) {
                for (var sr = new e2.Set(), fi, zi = 0; zi < v.sourceFiles.length; zi++) {
                  for (var Sa = v.sourceFiles[zi], da = void 0, Ha = 0, ta = 0, nn = Sa.statements; ta < nn.length; ta++) {
                    var Wo = nn[ta];
                    if (!e2.isPrologueDirective(Wo))
                      break;
                    sr.has(Wo.expression.text) || (sr.add(Wo.expression.text), (da || (da = [])).push({ pos: Wo.pos, end: Wo.end, expression: { pos: Wo.expression.pos, end: Wo.expression.end, text: Wo.expression.text } }), Ha = Ha < Wo.end ? Wo.end : Ha);
                  }
                  da && (fi || (fi = [])).push({ file: zi, text: Sa.text.substring(0, Ha), directives: da });
                }
                return fi;
              }
              function f_(v) {
                if (e2.isSourceFile(v) || e2.isUnparsedSource(v)) {
                  var sr = e2.getShebang(v.text);
                  if (sr)
                    return rf(sr), bs(), true;
                } else {
                  for (var fi = 0, zi = v.prepends; fi < zi.length; fi++) {
                    var Sa = zi[fi];
                    if (e2.Debug.assertNode(Sa, e2.isUnparsedSource), f_(Sa))
                      return true;
                  }
                  for (var da = 0, Ha = v.sourceFiles; da < Ha.length; da++) {
                    var ta = Ha[da];
                    if (f_(ta))
                      return true;
                  }
                }
              }
              function md(v, sr) {
                if (!!v) {
                  var fi = ir;
                  ir = sr, gr(v), ir = fi;
                }
              }
              function ks(v, sr) {
                sr && sr.length && (Zn(v, sr, 262656), Ut());
              }
              function Wu(v) {
                v && (Gt(":"), Ut(), gr(v));
              }
              function Zl(v, sr, fi, zi) {
                v && (Ut(), Ya(63, sr, Nl, fi), Ut(), Tr(v, zi));
              }
              function R_(v, sr, fi, zi) {
                fi && (sr(v), zi(fi));
              }
              function kl(v) {
                v && (Ut(), gr(v));
              }
              function __(v, sr) {
                v && (Ut(), Tr(v, sr));
              }
              function zd(v) {
                v && (gr(v), Ut());
              }
              function Al(v, sr) {
                e2.isBlock(sr) || e2.getEmitFlags(v) & 1 ? (Ut(), gr(sr)) : (bs(), Dc(), e2.isEmptyStatement(sr) ? Wi(5, sr) : gr(sr), Cc());
              }
              function wc(v, sr) {
                Zn(v, sr, 2146305);
              }
              function qu(v, sr) {
                Zn(v, sr, 53776, Wt);
              }
              function Vu(v, sr) {
                if (e2.isFunctionLike(v) && v.typeArguments)
                  return qu(v, v.typeArguments);
                Zn(v, sr, 53776);
              }
              function ef(v, sr) {
                Zn(v, sr, 2576);
              }
              function sl(v, sr) {
                var fi = e2.singleOrUndefined(sr);
                return fi && fi.pos === v.pos && e2.isArrowFunction(v) && !v.type && !e2.some(v.decorators) && !e2.some(v.modifiers) && !e2.some(v.typeParameters) && !e2.some(fi.decorators) && !e2.some(fi.modifiers) && !fi.dotDotDotToken && !fi.questionToken && !fi.type && !fi.initializer && e2.isIdentifier(fi.name);
              }
              function p_(v, sr) {
                sl(v, sr) ? Zn(v, sr, 528) : ef(v, sr);
              }
              function Df(v, sr) {
                Zn(v, sr, 8848);
              }
              function Ec(v) {
                switch (v & 60) {
                  case 0:
                    break;
                  case 16:
                    Gt(",");
                    break;
                  case 4:
                    Ut(), Gt("|");
                    break;
                  case 32:
                    Ut(), Gt("*"), Ut();
                    break;
                  case 8:
                    Ut(), Gt("&");
                    break;
                }
              }
              function Zn(v, sr, fi, zi, Sa, da) {
                Ps(gr, v, sr, fi, zi, Sa, da);
              }
              function os(v, sr, fi, zi, Sa, da) {
                Ps(Tr, v, sr, fi, zi, Sa, da);
              }
              function Ps(v, sr, fi, zi, Sa, da, Ha) {
                da === void 0 && (da = 0), Ha === void 0 && (Ha = fi ? fi.length - da : 0);
                var ta = fi === void 0;
                if (!(ta && zi & 16384)) {
                  var nn = fi === void 0 || da >= fi.length || Ha === 0;
                  if (nn && zi & 32768) {
                    g && g(fi), ne && ne(fi);
                    return;
                  }
                  if (zi & 15360 && (Gt(X(zi)), nn && fi && af(fi.pos, true)), g && g(fi), nn)
                    zi & 1 && !(de && (!sr || Re && e2.rangeIsOnSingleLine(sr, Re))) ? bs() : zi & 256 && !(zi & 524288) && Ut();
                  else {
                    e2.Debug.type(fi);
                    var Wo = (zi & 262144) === 0, Lo = Wo, oc = Ap(sr, fi, zi);
                    oc ? (bs(oc), Lo = false) : zi & 256 && Ut(), zi & 128 && Dc();
                    for (var uu = P(v, Sa), is = void 0, au = void 0, Ou = false, sf = 0; sf < Ha; sf++) {
                      var lu = fi[da + sf];
                      if (zi & 32)
                        bs(), Ec(zi);
                      else if (is) {
                        zi & 60 && is.end !== (sr ? sr.end : -1) && Vf(is.end), Ec(zi), Je(au);
                        var cf = Wf(is, lu, zi);
                        cf > 0 ? ((zi & 131) === 0 && (Dc(), Ou = true), bs(cf), Lo = false) : is && zi & 512 && Ut();
                      }
                      if (au = Wr(lu), Lo) {
                        var uf = e2.getCommentRange(lu);
                        af(uf.pos);
                      } else
                        Lo = Wo;
                      ye = lu.pos, uu(lu, v, Sa, sf), Ou && (Cc(), Ou = false), is = lu;
                    }
                    var K_ = is ? e2.getEmitFlags(is) : 0, Jp = qr || !!(K_ & 1024), Hf = (fi == null ? void 0 : fi.hasTrailingComma) && zi & 64 && zi & 16;
                    Hf && (is && !Jp ? Ya(27, is.end, Gt, is) : Gt(",")), is && (sr ? sr.end : -1) !== is.end && zi & 60 && !Jp && Vf(Hf && (fi == null ? void 0 : fi.end) ? fi.end : is.end), zi & 128 && Cc(), Je(au);
                    var kc = Sf(sr, fi, zi);
                    kc ? bs(kc) : zi & 2097408 && Ut();
                  }
                  ne && ne(fi), zi & 15360 && (nn && fi && Vf(fi.end), Gt($(zi)));
                }
              }
              function d_(v) {
                Ae.writeLiteral(v);
              }
              function Gc(v) {
                Ae.writeStringLiteral(v);
              }
              function B_(v) {
                Ae.write(v);
              }
              function vu(v, sr) {
                Ae.writeSymbol(v, sr);
              }
              function Gt(v) {
                Ae.writePunctuation(v);
              }
              function As() {
                Ae.writeTrailingSemicolon(";");
              }
              function vn(v) {
                Ae.writeKeyword(v);
              }
              function Nl(v) {
                Ae.writeOperator(v);
              }
              function cl(v) {
                Ae.writeParameter(v);
              }
              function rf(v) {
                Ae.writeComment(v);
              }
              function Ut() {
                Ae.writeSpace(" ");
              }
              function Ds(v) {
                Ae.writeProperty(v);
              }
              function bf(v) {
                Ae.nonEscapingWrite ? Ae.nonEscapingWrite(v) : Ae.write(v);
              }
              function bs(v) {
                v === void 0 && (v = 1);
                for (var sr = 0; sr < v; sr++)
                  Ae.writeLine(sr > 0);
              }
              function Dc() {
                Ae.increaseIndent();
              }
              function Cc() {
                Ae.decreaseIndent();
              }
              function ac(v, sr, fi, zi) {
                return lr ? Il(v, fi, sr) : of(zi, v, fi, sr, Il);
              }
              function Pl(v, sr) {
                ue && ue(v), sr(e2.tokenToString(v.kind)), We && We(v);
              }
              function Il(v, sr, fi) {
                var zi = e2.tokenToString(v);
                return sr(zi), fi < 0 ? fi : fi + zi.length;
              }
              function zf(v, sr, fi) {
                if (e2.getEmitFlags(v) & 1)
                  Ut();
                else if (de) {
                  var zi = iu(v, sr, fi);
                  zi ? bs(zi) : Ut();
                } else
                  bs();
              }
              function ul(v) {
                for (var sr = v.split(/\r\n?|\n/g), fi = e2.guessIndentation(sr), zi = 0, Sa = sr; zi < Sa.length; zi++) {
                  var da = Sa[zi], Ha = fi ? da.slice(fi) : da;
                  Ha.length && (bs(), ir(Ha));
                }
              }
              function Nu(v, sr) {
                v ? (Dc(), bs(v)) : sr && Ut();
              }
              function Us(v, sr) {
                v && Cc(), sr && Cc();
              }
              function Ap(v, sr, fi) {
                if (fi & 2 || de) {
                  if (fi & 65536)
                    return 1;
                  var zi = sr[0];
                  if (zi === void 0)
                    return !v || Re && e2.rangeIsOnSingleLine(v, Re) ? 0 : 1;
                  if (zi.pos === ye || zi.kind === 11)
                    return 0;
                  if (Re && v && !e2.positionIsSynthesized(v.pos) && !e2.nodeIsSynthesized(zi) && (!zi.parent || e2.getOriginalNode(zi.parent) === e2.getOriginalNode(v)))
                    return de ? ll(function(Sa) {
                      return e2.getLinesBetweenPositionAndPrecedingNonWhitespaceCharacter(zi.pos, v.pos, Re, Sa);
                    }) : e2.rangeStartPositionsAreOnSameLine(v, zi, Re) ? 0 : 1;
                  if (U_(zi, fi))
                    return 1;
                }
                return fi & 1 ? 1 : 0;
              }
              function Wf(v, sr, fi) {
                if (fi & 2 || de) {
                  if (v === void 0 || sr === void 0 || sr.kind === 11)
                    return 0;
                  if (Re && !e2.nodeIsSynthesized(v) && !e2.nodeIsSynthesized(sr))
                    return de && Lp(v, sr) ? ll(function(zi) {
                      return e2.getLinesBetweenRangeEndAndRangeStart(v, sr, Re, zi);
                    }) : !de && Gu(v, sr) ? e2.rangeEndIsOnSameLineAsRangeStart(v, sr, Re) ? 0 : 1 : fi & 65536 ? 1 : 0;
                  if (U_(v, fi) || U_(sr, fi))
                    return 1;
                } else if (e2.getStartsOnNewLine(sr))
                  return 1;
                return fi & 1 ? 1 : 0;
              }
              function Sf(v, sr, fi) {
                if (fi & 2 || de) {
                  if (fi & 65536)
                    return 1;
                  var zi = e2.lastOrUndefined(sr);
                  if (zi === void 0)
                    return !v || Re && e2.rangeIsOnSingleLine(v, Re) ? 0 : 1;
                  if (Re && v && !e2.positionIsSynthesized(v.pos) && !e2.nodeIsSynthesized(zi) && (!zi.parent || zi.parent === v)) {
                    if (de) {
                      var Sa = e2.isNodeArray(sr) && !e2.positionIsSynthesized(sr.end) ? sr.end : zi.end;
                      return ll(function(da) {
                        return e2.getLinesBetweenPositionAndNextNonWhitespaceCharacter(Sa, v.end, Re, da);
                      });
                    }
                    return e2.rangeEndPositionsAreOnSameLine(v, zi, Re) ? 0 : 1;
                  }
                  if (U_(zi, fi))
                    return 1;
                }
                return fi & 1 && !(fi & 131072) ? 1 : 0;
              }
              function ll(v) {
                e2.Debug.assert(!!de);
                var sr = v(true);
                return sr === 0 ? v(false) : sr;
              }
              function J_(v, sr) {
                var fi = de && Ap(sr, [v], 0);
                return fi && Nu(fi, false), !!fi;
              }
              function j_(v, sr) {
                var fi = de && Sf(sr, [v], 0);
                fi && bs(fi);
              }
              function U_(v, sr) {
                if (e2.nodeIsSynthesized(v)) {
                  var fi = e2.getStartsOnNewLine(v);
                  return fi === void 0 ? (sr & 65536) !== 0 : fi;
                }
                return (sr & 65536) !== 0;
              }
              function iu(v, sr, fi) {
                return e2.getEmitFlags(v) & 131072 ? 0 : (v = qf(v), sr = qf(sr), fi = qf(fi), e2.getStartsOnNewLine(fi) ? 1 : Re && !e2.nodeIsSynthesized(v) && !e2.nodeIsSynthesized(sr) && !e2.nodeIsSynthesized(fi) ? de ? ll(function(zi) {
                  return e2.getLinesBetweenRangeEndAndRangeStart(sr, fi, Re, zi);
                }) : e2.rangeEndIsOnSameLineAsRangeStart(sr, fi, Re) ? 0 : 1 : 0);
              }
              function vd(v) {
                return v.statements.length === 0 && (!Re || e2.rangeEndIsOnSameLineAsRangeStart(v, v, Re));
              }
              function qf(v) {
                for (; v.kind === 212 && e2.nodeIsSynthesized(v); )
                  v = v.expression;
                return v;
              }
              function dc(v, sr) {
                if (e2.isGeneratedIdentifier(v))
                  return Np(v);
                if (e2.isStringLiteral(v) && v.textSourceNode)
                  return dc(v.textSourceNode, sr);
                var fi = Re, zi = !!fi && !!v.parent && !e2.nodeIsSynthesized(v);
                if (e2.isMemberName(v)) {
                  if (!zi || e2.getSourceFileOfNode(v) !== e2.getOriginalNode(fi))
                    return e2.idText(v);
                } else if (e2.Debug.assertNode(v, e2.isLiteralExpression), !zi)
                  return v.text;
                return e2.getSourceTextOfNodeFromSourceFile(fi, v, sr);
              }
              function Pu(v, sr, fi) {
                if (v.kind === 10 && v.textSourceNode) {
                  var zi = v.textSourceNode;
                  if (e2.isIdentifier(zi) || e2.isNumericLiteral(zi)) {
                    var Sa = e2.isNumericLiteral(zi) ? zi.text : dc(zi);
                    return fi ? '"'.concat(e2.escapeJsxAttributeString(Sa), '"') : sr || e2.getEmitFlags(v) & 16777216 ? '"'.concat(e2.escapeString(Sa), '"') : '"'.concat(e2.escapeNonAsciiString(Sa), '"');
                  } else
                    return Pu(zi, sr, fi);
                }
                var da = (sr ? 1 : 0) | (fi ? 2 : 0) | (k.terminateUnterminatedLiterals ? 4 : 0) | (k.target && k.target === 99 ? 8 : 0);
                return e2.getLiteralText(v, Re, da);
              }
              function wl(v) {
                v && e2.getEmitFlags(v) & 524288 || (rr.push(Ie), Ie = 0, _e.push(we));
              }
              function Iu(v) {
                v && e2.getEmitFlags(v) & 524288 || (Ie = rr.pop(), we = _e.pop());
              }
              function so(v) {
                (!we || we === e2.lastOrUndefined(_e)) && (we = new e2.Set()), we.add(v);
              }
              function Et(v) {
                if (!!v)
                  switch (v.kind) {
                    case 235:
                      e2.forEach(v.statements, Et);
                      break;
                    case 250:
                    case 248:
                    case 240:
                    case 241:
                      Et(v.statement);
                      break;
                    case 239:
                      Et(v.thenStatement), Et(v.elseStatement);
                      break;
                    case 242:
                    case 244:
                    case 243:
                      Et(v.initializer), Et(v.statement);
                      break;
                    case 249:
                      Et(v.caseBlock);
                      break;
                    case 263:
                      e2.forEach(v.clauses, Et);
                      break;
                    case 289:
                    case 290:
                      e2.forEach(v.statements, Et);
                      break;
                    case 252:
                      Et(v.tryBlock), Et(v.catchClause), Et(v.finallyBlock);
                      break;
                    case 292:
                      Et(v.variableDeclaration), Et(v.block);
                      break;
                    case 237:
                      Et(v.declarationList);
                      break;
                    case 255:
                      e2.forEach(v.declarations, Et);
                      break;
                    case 254:
                    case 164:
                    case 203:
                    case 257:
                      Ku(v.name);
                      break;
                    case 256:
                      Ku(v.name), e2.getEmitFlags(v) & 524288 && (e2.forEach(v.parameters, Et), Et(v.body));
                      break;
                    case 201:
                    case 202:
                      e2.forEach(v.elements, Et);
                      break;
                    case 266:
                      Et(v.importClause);
                      break;
                    case 267:
                      Ku(v.name), Et(v.namedBindings);
                      break;
                    case 268:
                      Ku(v.name);
                      break;
                    case 274:
                      Ku(v.name);
                      break;
                    case 269:
                      e2.forEach(v.elements, Et);
                      break;
                    case 270:
                      Ku(v.propertyName || v.name);
                      break;
                  }
              }
              function Ys(v) {
                if (!!v)
                  switch (v.kind) {
                    case 296:
                    case 297:
                    case 167:
                    case 169:
                    case 172:
                    case 173:
                      Ku(v.name);
                      break;
                  }
              }
              function Ku(v) {
                v && (e2.isGeneratedIdentifier(v) ? Np(v) : e2.isBindingPattern(v) && Et(v));
              }
              function Np(v) {
                if ((v.autoGenerateFlags & 7) === 4)
                  return Pp(tf(v), v.autoGenerateFlags);
                var sr = v.autoGenerateId;
                return Ee[sr] || (Ee[sr] = Ol(v));
              }
              function Pp(v, sr) {
                var fi = e2.getNodeId(v);
                return ze[fi] || (ze[fi] = Hc(v, sr));
              }
              function nc(v) {
                return fl(v) && !He.has(v) && !(we && we.has(v));
              }
              function fl(v) {
                return Re ? e2.isFileLevelUniqueName(Re, v, U) : true;
              }
              function _l(v, sr) {
                for (var fi = sr; e2.isNodeDescendantOf(fi, sr); fi = fi.nextContainer)
                  if (fi.locals) {
                    var zi = fi.locals.get(e2.escapeLeadingUnderscores(v));
                    if (zi && zi.flags & 3257279)
                      return false;
                  }
                return true;
              }
              function cu(v, sr) {
                if (v && !(Ie & v)) {
                  var fi = v === 268435456 ? "_i" : "_n";
                  if (nc(fi))
                    return Ie |= v, sr && so(fi), fi;
                }
                for (; ; ) {
                  var zi = Ie & 268435455;
                  if (Ie++, zi !== 8 && zi !== 13) {
                    var fi = zi < 26 ? "_" + String.fromCharCode(97 + zi) : "_" + (zi - 26);
                    if (nc(fi))
                      return sr && so(fi), fi;
                  }
                }
              }
              function gc(v, sr, fi, zi) {
                if (sr === void 0 && (sr = nc), fi && sr(v))
                  return zi ? so(v) : He.add(v), v;
                v.charCodeAt(v.length - 1) !== 95 && (v += "_");
                for (var Sa = 1; ; ) {
                  var da = v + Sa;
                  if (sr(da))
                    return zi ? so(da) : He.add(da), da;
                  Sa++;
                }
              }
              function Tf(v) {
                return gc(v, fl, true);
              }
              function mc(v) {
                var sr = dc(v.name);
                return _l(sr, v) ? sr : gc(sr);
              }
              function Ip(v) {
                var sr = e2.getExternalModuleName(v), fi = e2.isStringLiteral(sr) ? e2.makeIdentifierFromModuleName(sr.text) : "module";
                return gc(fi);
              }
              function ms() {
                return gc("default");
              }
              function tu() {
                return gc("class");
              }
              function wp(v) {
                return e2.isIdentifier(v.name) ? Pp(v.name) : cu(0);
              }
              function Hc(v, sr) {
                switch (v.kind) {
                  case 79:
                    return gc(dc(v), nc, !!(sr & 16), !!(sr & 8));
                  case 261:
                  case 260:
                    return mc(v);
                  case 266:
                  case 272:
                    return Ip(v);
                  case 256:
                  case 257:
                  case 271:
                    return ms();
                  case 226:
                    return tu();
                  case 169:
                  case 172:
                  case 173:
                    return wp(v);
                  case 162:
                    return cu(0, true);
                  default:
                    return cu(0);
                }
              }
              function Ol(v) {
                switch (v.autoGenerateFlags & 7) {
                  case 1:
                    return cu(0, !!(v.autoGenerateFlags & 8));
                  case 2:
                    return cu(268435456, !!(v.autoGenerateFlags & 8));
                  case 3:
                    return gc(e2.idText(v), v.autoGenerateFlags & 32 ? fl : nc, !!(v.autoGenerateFlags & 16), !!(v.autoGenerateFlags & 8));
                }
                return e2.Debug.fail("Unsupported GeneratedIdentifierKind.");
              }
              function tf(v) {
                for (var sr = v.autoGenerateId, fi = v, zi = fi.original; zi && (fi = zi, !(e2.isIdentifier(fi) && !!(fi.autoGenerateFlags & 4) && fi.autoGenerateId !== sr)); )
                  zi = fi.original;
                return fi;
              }
              function xf(v, sr) {
                var fi = Mt(2, v, sr), zi = wr, Sa = Ur, da = ii;
                z_(sr), fi(v, sr), Oc(sr, zi, Sa, da);
              }
              function z_(v) {
                var sr = e2.getEmitFlags(v), fi = e2.getCommentRange(v);
                rs(v, sr, fi.pos, fi.end), sr & 2048 && (qr = true);
              }
              function Oc(v, sr, fi, zi) {
                var Sa = e2.getEmitFlags(v), da = e2.getCommentRange(v);
                Sa & 2048 && (qr = false), Op(v, Sa, da.pos, da.end, sr, fi, zi);
                var Ha = e2.getTypeNode(v);
                Ha && Op(v, Sa, Ha.pos, Ha.end, sr, fi, zi);
              }
              function rs(v, sr, fi, zi) {
                Xi(), or = false;
                var Sa = fi < 0 || (sr & 512) !== 0 || v.kind === 11, da = zi < 0 || (sr & 1024) !== 0 || v.kind === 11;
                (fi > 0 || zi > 0) && fi !== zi && (Sa || Cf(fi, v.kind !== 349), (!Sa || fi >= 0 && (sr & 512) !== 0) && (wr = fi), (!da || zi >= 0 && (sr & 1024) !== 0) && (Ur = zi, v.kind === 255 && (ii = zi))), e2.forEach(e2.getSyntheticLeadingComments(v), Ef), et();
              }
              function Op(v, sr, fi, zi, Sa, da, Ha) {
                Xi();
                var ta = zi < 0 || (sr & 1024) !== 0 || v.kind === 11;
                e2.forEach(e2.getSyntheticTrailingComments(v), Fl), (fi > 0 || zi > 0) && fi !== zi && (wr = Sa, Ur = da, ii = Ha, !ta && v.kind !== 349 && Fc(zi)), et();
              }
              function Ef(v) {
                (v.hasLeadingNewline || v.kind === 2) && Ae.writeLine(), pl(v), v.hasTrailingNewLine || v.kind === 2 ? Ae.writeLine() : Ae.writeSpace(" ");
              }
              function Fl(v) {
                Ae.isAtStartOfLine() || Ae.writeSpace(" "), pl(v), v.hasTrailingNewLine && Ae.writeLine();
              }
              function pl(v) {
                var sr = Fp(v), fi = v.kind === 3 ? e2.computeLineStarts(sr) : void 0;
                e2.writeCommentRange(sr, fi, Ae, 0, sr.length, Z2);
              }
              function Fp(v) {
                return v.kind === 3 ? "/*".concat(v.text, "*/") : "//".concat(v.text);
              }
              function Mp(v, sr, fi) {
                Xi();
                var zi = sr.pos, Sa = sr.end, da = e2.getEmitFlags(v), Ha = zi < 0 || (da & 512) !== 0, ta = qr || Sa < 0 || (da & 1024) !== 0;
                Ha || Rp(sr), et(), da & 2048 && !qr ? (qr = true, fi(v), qr = false) : fi(v), Xi(), ta || (Cf(sr.end, true), or && !Ae.isAtStartOfLine() && Ae.writeLine()), et();
              }
              function Gu(v, sr) {
                return v = e2.getOriginalNode(v), v.parent && v.parent === e2.getOriginalNode(sr).parent;
              }
              function Lp(v, sr) {
                if (sr.pos < v.end)
                  return false;
                v = e2.getOriginalNode(v), sr = e2.getOriginalNode(sr);
                var fi = v.parent;
                if (!fi || fi !== sr.parent)
                  return false;
                var zi = e2.getContainingNodeArray(v), Sa = zi == null ? void 0 : zi.indexOf(v);
                return Sa !== void 0 && Sa > -1 && zi.indexOf(sr) === Sa + 1;
              }
              function Cf(v, sr) {
                or = false, sr ? v === 0 && (Re == null ? void 0 : Re.isDeclarationFile) ? Ot(v, g_) : Ot(v, gl) : v === 0 && Ot(v, W_);
              }
              function W_(v, sr, fi, zi, Sa) {
                m_(v, sr) && gl(v, sr, fi, zi, Sa);
              }
              function g_(v, sr, fi, zi, Sa) {
                m_(v, sr) || gl(v, sr, fi, zi, Sa);
              }
              function dl(v, sr) {
                return k.onlyPrintJsDocStyle ? e2.isJSDocLikeText(v, sr) || e2.isPinnedComment(v, sr) : true;
              }
              function gl(v, sr, fi, zi, Sa) {
                !Re || !dl(Re.text, v) || (or || (e2.emitNewLineBeforeLeadingCommentOfPosition(De(), Ae, Sa, v), or = true), Xc(v), e2.writeCommentRange(Re.text, De(), Ae, v, sr, Z2), Xc(sr), zi ? Ae.writeLine() : fi === 3 && Ae.writeSpace(" "));
              }
              function Vf(v) {
                qr || v === -1 || Cf(v, true);
              }
              function Fc(v) {
                nf(v, Hu);
              }
              function Hu(v, sr, fi, zi) {
                !Re || !dl(Re.text, v) || (Ae.isAtStartOfLine() || Ae.writeSpace(" "), Xc(v), e2.writeCommentRange(Re.text, De(), Ae, v, sr, Z2), Xc(sr), zi && Ae.writeLine());
              }
              function af(v, sr, fi) {
                qr || (Xi(), nf(v, sr ? Hu : fi ? tn : Ml), et());
              }
              function tn(v, sr, fi) {
                !Re || (Xc(v), e2.writeCommentRange(Re.text, De(), Ae, v, sr, Z2), Xc(sr), fi === 2 && Ae.writeLine());
              }
              function Ml(v, sr, fi, zi) {
                !Re || (Xc(v), e2.writeCommentRange(Re.text, De(), Ae, v, sr, Z2), Xc(sr), zi ? Ae.writeLine() : Ae.writeSpace(" "));
              }
              function Ot(v, sr) {
                Re && (wr === -1 || v !== wr) && (q_(v) ? Kf(sr) : e2.forEachLeadingCommentRange(Re.text, v, sr, v));
              }
              function nf(v, sr) {
                Re && (Ur === -1 || v !== Ur && v !== ii) && e2.forEachTrailingCommentRange(Re.text, v, sr);
              }
              function q_(v) {
                return pe !== void 0 && e2.last(pe).nodePos === v;
              }
              function Kf(v) {
                if (!!Re) {
                  var sr = e2.last(pe).detachedCommentEndPos;
                  pe.length - 1 ? pe.pop() : pe = void 0, e2.forEachLeadingCommentRange(Re.text, sr, v, sr);
                }
              }
              function Rp(v) {
                var sr = Re && e2.emitDetachedComments(Re.text, De(), Ae, yd, v, Z2, qr);
                sr && (pe ? pe.push(sr) : pe = [sr]);
              }
              function yd(v, sr, fi, zi, Sa, da) {
                !Re || !dl(Re.text, zi) || (Xc(zi), e2.writeCommentRange(v, sr, fi, zi, Sa, da), Xc(Sa));
              }
              function m_(v, sr) {
                return !!Re && e2.isRecognizedTripleSlashComment(Re.text, v, sr);
              }
              function Ll(v) {
                return v.parsedSourceMap === void 0 && v.sourceMapText !== void 0 && (v.parsedSourceMap = e2.tryParseRawSourceMap(v.sourceMapText) || false), v.parsedSourceMap || void 0;
              }
              function hd(v, sr) {
                var fi = Mt(3, v, sr);
                v_(sr), fi(v, sr), Bp(sr);
              }
              function v_(v) {
                var sr = e2.getEmitFlags(v), fi = e2.getSourceMapRange(v);
                if (e2.isUnparsedNode(v)) {
                  e2.Debug.assertIsDefined(v.parent, "UnparsedNodes must have parent pointers");
                  var zi = Ll(v.parent);
                  zi && be && be.appendSourceMap(Ae.getLine(), Ae.getColumn(), zi, v.parent.sourceMapPath, v.parent.getLineAndCharacterOfPosition(v.pos), v.parent.getLineAndCharacterOfPosition(v.end));
                } else {
                  var Sa = fi.source || Ge;
                  v.kind !== 349 && (sr & 16) === 0 && fi.pos >= 0 && Gf(fi.source || Ge, Xu(Sa, fi.pos)), sr & 64 && (lr = true);
                }
              }
              function Bp(v) {
                var sr = e2.getEmitFlags(v), fi = e2.getSourceMapRange(v);
                e2.isUnparsedNode(v) || (sr & 64 && (lr = false), v.kind !== 349 && (sr & 32) === 0 && fi.end >= 0 && Gf(fi.source || Ge, fi.end));
              }
              function Xu(v, sr) {
                return v.skipTrivia ? v.skipTrivia(sr) : e2.skipTrivia(v.text, sr);
              }
              function Xc(v) {
                if (!(lr || e2.positionIsSynthesized(v) || yu(Ge))) {
                  var sr = e2.getLineAndCharacterOfPosition(Ge, v), fi = sr.line, zi = sr.character;
                  be.addMapping(Ae.getLine(), Ae.getColumn(), ur, fi, zi, void 0);
                }
              }
              function Gf(v, sr) {
                if (v !== Ge) {
                  var fi = Ge, zi = ur;
                  wu(v), Xc(sr), V_(fi, zi);
                } else
                  Xc(sr);
              }
              function of(v, sr, fi, zi, Sa) {
                if (lr || v && e2.isInJsonFile(v))
                  return Sa(sr, fi, zi);
                var da = v && v.emitNode, Ha = da && da.flags || 0, ta = da && da.tokenSourceMapRanges && da.tokenSourceMapRanges[sr], nn = ta && ta.source || Ge;
                return zi = Xu(nn, ta ? ta.pos : zi), (Ha & 128) === 0 && zi >= 0 && Gf(nn, zi), zi = Sa(sr, fi, zi), ta && (zi = ta.end), (Ha & 256) === 0 && zi >= 0 && Gf(nn, zi), zi;
              }
              function wu(v) {
                if (!lr) {
                  if (Ge = v, v === yr) {
                    ur = Ir;
                    return;
                  }
                  yu(v) || (ur = be.addSource(v.fileName), k.inlineSources && be.setSourceContent(ur, v.text), yr = v, Ir = ur);
                }
              }
              function V_(v, sr) {
                Ge = v, ur = sr;
              }
              function yu(v) {
                return e2.fileExtensionIs(v.fileName, ".json");
              }
            }
            e2.createPrinter = F2;
            function x2() {
              var k = [];
              return k[1024] = ["{", "}"], k[2048] = ["(", ")"], k[4096] = ["<", ">"], k[8192] = ["[", "]"], k;
            }
            function X(k) {
              return a[k & 15360][0];
            }
            function $(k) {
              return a[k & 15360][1];
            }
            var A2;
            (function(k) {
              k[k.Auto = 0] = "Auto", k[k.CountMask = 268435455] = "CountMask", k[k._i = 268435456] = "_i";
            })(A2 || (A2 = {}));
            function y(k, Y, U, j) {
              Y(k);
            }
            function V(k, Y, U, j) {
              Y(k, U.select(j));
            }
            function L(k, Y, U, j) {
              Y(k, U);
            }
            function P(k, Y) {
              return k.length === 1 ? y : typeof Y == "object" ? V : L;
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(b, se, J) {
              if (!b.getDirectories || !b.readDirectory)
                return;
              var ie = new e2.Map(), R = e2.createGetCanonicalFileName(J);
              return { useCaseSensitiveFileNames: J, fileExists: y, readFile: function(l, d) {
                return b.readFile(l, d);
              }, directoryExists: b.directoryExists && V, getDirectories: P, readDirectory: k, createDirectory: b.createDirectory && L, writeFile: b.writeFile && A2, addOrDeleteFileOrDirectory: U, addOrDeleteFile: j, clearCache: I, realpath: b.realpath && Y };
              function q(l) {
                return e2.toPath(l, se, R);
              }
              function O(l) {
                return ie.get(e2.ensureTrailingDirectorySeparator(l));
              }
              function ve(l) {
                return O(e2.getDirectoryPath(l));
              }
              function ee(l) {
                return e2.getBaseFileName(e2.normalizePath(l));
              }
              function he(l, d) {
                var D;
                if (!b.realpath || e2.ensureTrailingDirectorySeparator(q(b.realpath(l))) === d) {
                  var fe = { files: e2.map(b.readDirectory(l, void 0, void 0, ["*.*"]), ee) || [], directories: b.getDirectories(l) || [] };
                  return ie.set(e2.ensureTrailingDirectorySeparator(d), fe), fe;
                }
                if (!((D = b.directoryExists) === null || D === void 0) && D.call(b, l))
                  return ie.set(d, false), false;
              }
              function F2(l, d) {
                d = e2.ensureTrailingDirectorySeparator(d);
                var D = O(d);
                if (D)
                  return D;
                try {
                  return he(l, d);
                } catch {
                  e2.Debug.assert(!ie.has(e2.ensureTrailingDirectorySeparator(d)));
                  return;
                }
              }
              function x2(l, d) {
                return R(l) === R(d);
              }
              function X(l, d) {
                return e2.some(l, function(D) {
                  return x2(D, d);
                });
              }
              function $(l, d, D) {
                if (X(l, d)) {
                  if (!D)
                    return e2.filterMutate(l, function(fe) {
                      return !x2(fe, d);
                    });
                } else if (D)
                  return l.push(d);
              }
              function A2(l, d, D) {
                var fe = q(l), g = ve(fe);
                return g && H(g, ee(l), true), b.writeFile(l, d, D);
              }
              function y(l) {
                var d = q(l), D = ve(d);
                return D && X(D.files, ee(l)) || b.fileExists(l);
              }
              function V(l) {
                var d = q(l);
                return ie.has(e2.ensureTrailingDirectorySeparator(d)) || b.directoryExists(l);
              }
              function L(l) {
                var d = q(l), D = ve(d), fe = ee(l);
                D && $(D.directories, fe, true), b.createDirectory(l);
              }
              function P(l) {
                var d = q(l), D = F2(l, d);
                return D ? D.directories.slice() : b.getDirectories(l);
              }
              function k(l, d, D, fe, g) {
                var ne = q(l), ue = F2(l, ne), We;
                if (ue !== void 0)
                  return e2.matchFiles(l, d, D, fe, J, se, g, Fe, Y);
                return b.readDirectory(l, d, D, fe, g);
                function Fe(Be) {
                  var ge = q(Be);
                  if (ge === ne)
                    return ue || Z2(Be, ge);
                  var Re = F2(Be, ge);
                  return Re !== void 0 ? Re || Z2(Be, ge) : e2.emptyFileSystemEntries;
                }
                function Z2(Be, ge) {
                  if (We && ge === ne)
                    return We;
                  var Re = { files: e2.map(b.readDirectory(Be, void 0, void 0, ["*.*"]), ee) || e2.emptyArray, directories: b.getDirectories(Be) || e2.emptyArray };
                  return ge === ne && (We = Re), Re;
                }
              }
              function Y(l) {
                return b.realpath ? b.realpath(l) : l;
              }
              function U(l, d) {
                var D = O(d);
                if (D !== void 0) {
                  I();
                  return;
                }
                var fe = ve(d);
                if (!!fe) {
                  if (!b.directoryExists) {
                    I();
                    return;
                  }
                  var g = ee(l), ne = { fileExists: b.fileExists(d), directoryExists: b.directoryExists(d) };
                  return ne.directoryExists || X(fe.directories, g) ? I() : H(fe, g, ne.fileExists), ne;
                }
              }
              function j(l, d, D) {
                if (D !== e2.FileWatcherEventKind.Changed) {
                  var fe = ve(d);
                  fe && H(fe, ee(l), D === e2.FileWatcherEventKind.Created);
                }
              }
              function H(l, d, D) {
                $(l.files, d, D);
              }
              function I() {
                ie.clear();
              }
            }
            e2.createCachedDirectoryStructureHost = a;
            var C;
            (function(b) {
              b[b.None = 0] = "None", b[b.Partial = 1] = "Partial", b[b.Full = 2] = "Full";
            })(C = e2.ConfigFileProgramReloadLevel || (e2.ConfigFileProgramReloadLevel = {}));
            function w(b, se, J, ie, R) {
              var q, O = e2.arrayToMap(((q = se == null ? void 0 : se.configFile) === null || q === void 0 ? void 0 : q.extendedSourceFiles) || e2.emptyArray, R);
              J.forEach(function(ve, ee) {
                O.has(ee) || (ve.projects.delete(b), ve.close());
              }), O.forEach(function(ve, ee) {
                var he = J.get(ee);
                he ? he.projects.add(b) : J.set(ee, { projects: new e2.Set([b]), watcher: ie(ve, ee), close: function() {
                  var F2 = J.get(ee);
                  !F2 || F2.projects.size !== 0 || (F2.watcher.close(), J.delete(ee));
                } });
              });
            }
            e2.updateSharedExtendedConfigFileWatcher = w;
            function B(b, se) {
              se.forEach(function(J) {
                J.projects.delete(b) && J.close();
              });
            }
            e2.clearSharedExtendedConfigFileWatcher = B;
            function E(b, se, J) {
              !b.delete(se) || b.forEach(function(ie, R) {
                var q, O = ie.extendedResult;
                !((q = O.extendedSourceFiles) === null || q === void 0) && q.some(function(ve) {
                  return J(ve) === se;
                }) && E(b, R, J);
              });
            }
            e2.cleanExtendedConfigCache = E;
            function Q(b, se, J) {
              var ie = new e2.Map(b);
              e2.mutateMap(se, ie, { createNewValue: J, onDeleteValue: e2.closeFileWatcher });
            }
            e2.updatePackageJsonWatch = Q;
            function le(b, se, J) {
              var ie = b.getMissingFilePaths(), R = e2.arrayToMap(ie, e2.identity, e2.returnTrue);
              e2.mutateMap(se, R, { createNewValue: J, onDeleteValue: e2.closeFileWatcher });
            }
            e2.updateMissingFilePathsWatch = le;
            function N(b, se, J) {
              e2.mutateMap(b, se, { createNewValue: ie, onDeleteValue: K, onExistingValue: R });
              function ie(q, O) {
                return { watcher: J(q, O), flags: O };
              }
              function R(q, O, ve) {
                q.flags !== O && (q.watcher.close(), b.set(ve, ie(ve, O)));
              }
            }
            e2.updateWatchingWildcardDirectories = N;
            function p(b) {
              var se = b.watchedDirPath, J = b.fileOrDirectory, ie = b.fileOrDirectoryPath, R = b.configFileName, q = b.options, O = b.program, ve = b.extraFileExtensions, ee = b.currentDirectory, he = b.useCaseSensitiveFileNames, F2 = b.writeLog, x2 = b.toPath, X = e2.removeIgnoredPath(ie);
              if (!X)
                return F2("Project: ".concat(R, " Detected ignored path: ").concat(J)), true;
              if (ie = X, ie === se)
                return false;
              if (e2.hasExtension(ie) && !e2.isSupportedSourceFileName(J, q, ve))
                return F2("Project: ".concat(R, " Detected file add/remove of non supported extension: ").concat(J)), true;
              if (e2.isExcludedFile(J, q.configFile.configFileSpecs, e2.getNormalizedAbsolutePath(e2.getDirectoryPath(R), ee), he, ee))
                return F2("Project: ".concat(R, " Detected excluded file: ").concat(J)), true;
              if (!O || e2.outFile(q) || q.outDir)
                return false;
              if (e2.isDeclarationFileName(ie)) {
                if (q.declarationDir)
                  return false;
              } else if (!e2.fileExtensionIsOneOf(ie, e2.supportedJSExtensionsFlat))
                return false;
              var $ = e2.removeFileExtension(ie), A2 = e2.isArray(O) ? void 0 : m2(O) ? O.getProgramOrUndefined() : O, y = !A2 && !e2.isArray(O) ? O : void 0;
              if (V($ + ".ts") || V($ + ".tsx"))
                return F2("Project: ".concat(R, " Detected output file: ").concat(J)), true;
              return false;
              function V(L) {
                return A2 ? !!A2.getSourceFileByPath(L) : y ? y.getState().fileInfos.has(L) : !!e2.find(O, function(P) {
                  return x2(P) === L;
                });
              }
            }
            e2.isIgnoredFileFromWildCardWatching = p;
            function m2(b) {
              return !!b.getState;
            }
            function G(b, se) {
              return b ? b.isEmittedFile(se) : false;
            }
            e2.isEmittedFileOfProgram = G;
            var oe;
            (function(b) {
              b[b.None = 0] = "None", b[b.TriggerOnly = 1] = "TriggerOnly", b[b.Verbose = 2] = "Verbose";
            })(oe = e2.WatchLogLevel || (e2.WatchLogLevel = {}));
            function f4(b, se, J, ie) {
              e2.setSysLog(se === oe.Verbose ? J : e2.noop);
              var R = { watchFile: function(y, V, L, P) {
                return b.watchFile(y, V, L, P);
              }, watchDirectory: function(y, V, L, P) {
                return b.watchDirectory(y, V, (L & 1) !== 0, P);
              } }, q = se !== oe.None ? { watchFile: $("watchFile"), watchDirectory: $("watchDirectory") } : void 0, O = se === oe.Verbose ? { watchFile: x2, watchDirectory: X } : q || R, ve = se === oe.Verbose ? F2 : e2.returnNoopFileWatcher;
              return { watchFile: ee("watchFile"), watchDirectory: ee("watchDirectory") };
              function ee(y) {
                return function(V, L, P, k, Y, U) {
                  var j;
                  return e2.matchesExclude(V, y === "watchFile" ? k == null ? void 0 : k.excludeFiles : k == null ? void 0 : k.excludeDirectories, he(), ((j = b.getCurrentDirectory) === null || j === void 0 ? void 0 : j.call(b)) || "") ? ve(V, P, k, Y, U) : O[y].call(void 0, V, L, P, k, Y, U);
                };
              }
              function he() {
                return typeof b.useCaseSensitiveFileNames == "boolean" ? b.useCaseSensitiveFileNames : b.useCaseSensitiveFileNames();
              }
              function F2(y, V, L, P, k) {
                return J("ExcludeWatcher:: Added:: ".concat(A2(y, V, L, P, k, ie))), { close: function() {
                  return J("ExcludeWatcher:: Close:: ".concat(A2(y, V, L, P, k, ie)));
                } };
              }
              function x2(y, V, L, P, k, Y) {
                J("FileWatcher:: Added:: ".concat(A2(y, L, P, k, Y, ie)));
                var U = q.watchFile(y, V, L, P, k, Y);
                return { close: function() {
                  J("FileWatcher:: Close:: ".concat(A2(y, L, P, k, Y, ie))), U.close();
                } };
              }
              function X(y, V, L, P, k, Y) {
                var U = "DirectoryWatcher:: Added:: ".concat(A2(y, L, P, k, Y, ie));
                J(U);
                var j = e2.timestamp(), H = q.watchDirectory(y, V, L, P, k, Y), I = e2.timestamp() - j;
                return J("Elapsed:: ".concat(I, "ms ").concat(U)), { close: function() {
                  var l = "DirectoryWatcher:: Close:: ".concat(A2(y, L, P, k, Y, ie));
                  J(l);
                  var d = e2.timestamp();
                  H.close();
                  var D = e2.timestamp() - d;
                  J("Elapsed:: ".concat(D, "ms ").concat(l));
                } };
              }
              function $(y) {
                return function(V, L, P, k, Y, U) {
                  return R[y].call(void 0, V, function() {
                    for (var j = [], H = 0; H < arguments.length; H++)
                      j[H] = arguments[H];
                    var I = "".concat(y === "watchFile" ? "FileWatcher" : "DirectoryWatcher", ":: Triggered with ").concat(j[0], " ").concat(j[1] !== void 0 ? j[1] : "", ":: ").concat(A2(V, P, k, Y, U, ie));
                    J(I);
                    var l = e2.timestamp();
                    L.call.apply(L, Ve([void 0], j, false));
                    var d = e2.timestamp() - l;
                    J("Elapsed:: ".concat(d, "ms ").concat(I));
                  }, P, k, Y, U);
                };
              }
              function A2(y, V, L, P, k, Y) {
                return "WatchInfo: ".concat(y, " ").concat(V, " ").concat(JSON.stringify(L), " ").concat(Y ? Y(P, k) : k === void 0 ? P : "".concat(P, " ").concat(k));
              }
            }
            e2.getWatchFactory = f4;
            function T(b) {
              var se = b == null ? void 0 : b.fallbackPolling;
              return { watchFile: se !== void 0 ? se : e2.WatchFileKind.PriorityPollingInterval };
            }
            e2.getFallbackOptions = T;
            function K(b) {
              b.watcher.close();
            }
            e2.closeFileWatcherOf = K;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(Z2, Be, ge) {
              return ge === void 0 && (ge = "tsconfig.json"), e2.forEachAncestorDirectory(Z2, function(Re) {
                var ze = e2.combinePaths(Re, ge);
                return Be(ze) ? ze : void 0;
              });
            }
            e2.findConfigFile = a;
            function C(Z2, Be) {
              var ge = e2.getDirectoryPath(Be), Re = e2.isRootedDiskPath(Z2) ? Z2 : e2.combinePaths(ge, Z2);
              return e2.normalizePath(Re);
            }
            e2.resolveTripleslashReference = C;
            function w(Z2, Be, ge) {
              var Re, ze = e2.forEach(Z2, function(Ee) {
                var He = e2.getNormalizedPathComponents(Ee, Be);
                if (He.pop(), !Re) {
                  Re = He;
                  return;
                }
                for (var rr = Math.min(Re.length, He.length), Ie = 0; Ie < rr; Ie++)
                  if (ge(Re[Ie]) !== ge(He[Ie])) {
                    if (Ie === 0)
                      return true;
                    Re.length = Ie;
                    break;
                  }
                He.length < Re.length && (Re.length = He.length);
              });
              return ze ? "" : Re ? e2.getPathFromPathComponents(Re) : Be;
            }
            e2.computeCommonSourceDirectoryOfFilenames = w;
            function B(Z2, Be) {
              return E(Z2, Be);
            }
            e2.createCompilerHost = B;
            function E(Z2, Be, ge) {
              ge === void 0 && (ge = e2.sys);
              var Re = new e2.Map(), ze = e2.createGetCanonicalFileName(ge.useCaseSensitiveFileNames), Ee = e2.maybeBind(ge, ge.createHash) || e2.generateDjb2Hash;
              function He(ir, Cr, Ye) {
                var Br;
                try {
                  e2.performance.mark("beforeIORead"), Br = er.readFile(ir), e2.performance.mark("afterIORead"), e2.performance.measure("I/O Read", "beforeIORead", "afterIORead");
                } catch (Er) {
                  Ye && Ye(Er.message), Br = "";
                }
                return Br !== void 0 ? e2.createSourceFile(ir, Br, Cr, Be) : void 0;
              }
              function rr(ir) {
                return Re.has(ir) ? true : (er.directoryExists || ge.directoryExists)(ir) ? (Re.set(ir, true), true) : false;
              }
              function Ie(ir, Cr, Ye, Br) {
                try {
                  e2.performance.mark("beforeIOWrite"), e2.writeFileEnsuringDirectories(ir, Cr, Ye, function(Er, Ne, n) {
                    return we(Er, Ne, n);
                  }, function(Er) {
                    return (er.createDirectory || ge.createDirectory)(Er);
                  }, function(Er) {
                    return rr(Er);
                  }), e2.performance.mark("afterIOWrite"), e2.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
                } catch (Er) {
                  Br && Br(Er.message);
                }
              }
              var _e;
              function we(ir, Cr, Ye) {
                if (!e2.isWatchSet(Z2) || !ge.getModifiedTime) {
                  ge.writeFile(ir, Cr, Ye);
                  return;
                }
                _e || (_e = new e2.Map());
                var Br = Ee(Cr), Er = ge.getModifiedTime(ir);
                if (Er) {
                  var Ne = _e.get(ir);
                  if (Ne && Ne.byteOrderMark === Ye && Ne.hash === Br && Ne.mtime.getTime() === Er.getTime())
                    return;
                }
                ge.writeFile(ir, Cr, Ye);
                var n = ge.getModifiedTime(ir) || e2.missingFileModifiedTime;
                _e.set(ir, { hash: Br, byteOrderMark: Ye, mtime: n });
              }
              function de() {
                return e2.getDirectoryPath(e2.normalizePath(ge.getExecutingFilePath()));
              }
              var ye = e2.getNewLineCharacter(Z2, function() {
                return ge.newLine;
              }), Ae = ge.realpath && function(ir) {
                return ge.realpath(ir);
              }, er = { getSourceFile: He, getDefaultLibLocation: de, getDefaultLibFileName: function(ir) {
                return e2.combinePaths(de(), e2.getDefaultLibFileName(ir));
              }, writeFile: Ie, getCurrentDirectory: e2.memoize(function() {
                return ge.getCurrentDirectory();
              }), useCaseSensitiveFileNames: function() {
                return ge.useCaseSensitiveFileNames;
              }, getCanonicalFileName: ze, getNewLine: function() {
                return ye;
              }, fileExists: function(ir) {
                return ge.fileExists(ir);
              }, readFile: function(ir) {
                return ge.readFile(ir);
              }, trace: function(ir) {
                return ge.write(ir + ye);
              }, directoryExists: function(ir) {
                return ge.directoryExists(ir);
              }, getEnvironmentVariable: function(ir) {
                return ge.getEnvironmentVariable ? ge.getEnvironmentVariable(ir) : "";
              }, getDirectories: function(ir) {
                return ge.getDirectories(ir);
              }, realpath: Ae, readDirectory: function(ir, Cr, Ye, Br, Er) {
                return ge.readDirectory(ir, Cr, Ye, Br, Er);
              }, createDirectory: function(ir) {
                return ge.createDirectory(ir);
              }, createHash: e2.maybeBind(ge, ge.createHash) };
              return er;
            }
            e2.createCompilerHostWorker = E;
            function Q(Z2, Be, ge) {
              var Re = Z2.readFile, ze = Z2.fileExists, Ee = Z2.directoryExists, He = Z2.createDirectory, rr = Z2.writeFile, Ie = new e2.Map(), _e = new e2.Map(), we = new e2.Map(), de = new e2.Map(), ye = function(ir) {
                var Cr = Be(ir), Ye = Ie.get(Cr);
                return Ye !== void 0 ? Ye !== false ? Ye : void 0 : Ae(Cr, ir);
              }, Ae = function(ir, Cr) {
                var Ye = Re.call(Z2, Cr);
                return Ie.set(ir, Ye !== void 0 ? Ye : false), Ye;
              };
              Z2.readFile = function(ir) {
                var Cr = Be(ir), Ye = Ie.get(Cr);
                return Ye !== void 0 ? Ye !== false ? Ye : void 0 : !e2.fileExtensionIs(ir, ".json") && !e2.isBuildInfoFile(ir) ? Re.call(Z2, ir) : Ae(Cr, ir);
              };
              var er = ge ? function(ir, Cr, Ye, Br) {
                var Er = Be(ir), Ne = de.get(Er);
                if (Ne)
                  return Ne;
                var n = ge(ir, Cr, Ye, Br);
                return n && (e2.isDeclarationFileName(ir) || e2.fileExtensionIs(ir, ".json")) && de.set(Er, n), n;
              } : void 0;
              return Z2.fileExists = function(ir) {
                var Cr = Be(ir), Ye = _e.get(Cr);
                if (Ye !== void 0)
                  return Ye;
                var Br = ze.call(Z2, ir);
                return _e.set(Cr, !!Br), Br;
              }, rr && (Z2.writeFile = function(ir, Cr) {
                for (var Ye = [], Br = 2; Br < arguments.length; Br++)
                  Ye[Br - 2] = arguments[Br];
                var Er = Be(ir);
                _e.delete(Er);
                var Ne = Ie.get(Er);
                if (Ne !== void 0 && Ne !== Cr)
                  Ie.delete(Er), de.delete(Er);
                else if (er) {
                  var n = de.get(Er);
                  n && n.text !== Cr && de.delete(Er);
                }
                rr.call.apply(rr, Ve([Z2, ir, Cr], Ye, false));
              }), Ee && He && (Z2.directoryExists = function(ir) {
                var Cr = Be(ir), Ye = we.get(Cr);
                if (Ye !== void 0)
                  return Ye;
                var Br = Ee.call(Z2, ir);
                return we.set(Cr, !!Br), Br;
              }, Z2.createDirectory = function(ir) {
                var Cr = Be(ir);
                we.delete(Cr), He.call(Z2, ir);
              }), { originalReadFile: Re, originalFileExists: ze, originalDirectoryExists: Ee, originalCreateDirectory: He, originalWriteFile: rr, getSourceFileWithCache: er, readFileWithCache: ye };
            }
            e2.changeCompilerHostLikeToUseCache = Q;
            function le(Z2, Be, ge) {
              var Re;
              return Re = e2.addRange(Re, Z2.getConfigFileParsingDiagnostics()), Re = e2.addRange(Re, Z2.getOptionsDiagnostics(ge)), Re = e2.addRange(Re, Z2.getSyntacticDiagnostics(Be, ge)), Re = e2.addRange(Re, Z2.getGlobalDiagnostics(ge)), Re = e2.addRange(Re, Z2.getSemanticDiagnostics(Be, ge)), e2.getEmitDeclarations(Z2.getCompilerOptions()) && (Re = e2.addRange(Re, Z2.getDeclarationDiagnostics(Be, ge))), e2.sortAndDeduplicateDiagnostics(Re || e2.emptyArray);
            }
            e2.getPreEmitDiagnostics = le;
            function N(Z2, Be) {
              for (var ge = "", Re = 0, ze = Z2; Re < ze.length; Re++) {
                var Ee = ze[Re];
                ge += p(Ee, Be);
              }
              return ge;
            }
            e2.formatDiagnostics = N;
            function p(Z2, Be) {
              var ge = "".concat(e2.diagnosticCategoryName(Z2), " TS").concat(Z2.code, ": ").concat(O(Z2.messageText, Be.getNewLine())).concat(Be.getNewLine());
              if (Z2.file) {
                var Re = e2.getLineAndCharacterOfPosition(Z2.file, Z2.start), ze = Re.line, Ee = Re.character, He = Z2.file.fileName, rr = e2.convertToRelativePath(He, Be.getCurrentDirectory(), function(Ie) {
                  return Be.getCanonicalFileName(Ie);
                });
                return "".concat(rr, "(").concat(ze + 1, ",").concat(Ee + 1, "): ") + ge;
              }
              return ge;
            }
            e2.formatDiagnostic = p;
            var m2;
            (function(Z2) {
              Z2.Grey = "\x1B[90m", Z2.Red = "\x1B[91m", Z2.Yellow = "\x1B[93m", Z2.Blue = "\x1B[94m", Z2.Cyan = "\x1B[96m";
            })(m2 = e2.ForegroundColorEscapeSequences || (e2.ForegroundColorEscapeSequences = {}));
            var G = "\x1B[7m", oe = " ", f4 = "\x1B[0m", T = "...", K = "  ", b = "    ";
            function se(Z2) {
              switch (Z2) {
                case e2.DiagnosticCategory.Error:
                  return m2.Red;
                case e2.DiagnosticCategory.Warning:
                  return m2.Yellow;
                case e2.DiagnosticCategory.Suggestion:
                  return e2.Debug.fail("Should never get an Info diagnostic on the command line.");
                case e2.DiagnosticCategory.Message:
                  return m2.Blue;
              }
            }
            function J(Z2, Be) {
              return Be + Z2 + f4;
            }
            e2.formatColorAndReset = J;
            function ie(Z2, Be, ge, Re, ze, Ee) {
              var He = e2.getLineAndCharacterOfPosition(Z2, Be), rr = He.line, Ie = He.character, _e = e2.getLineAndCharacterOfPosition(Z2, Be + ge), we = _e.line, de = _e.character, ye = e2.getLineAndCharacterOfPosition(Z2, Z2.text.length).line, Ae = we - rr >= 4, er = (we + 1 + "").length;
              Ae && (er = Math.max(T.length, er));
              for (var ir = "", Cr = rr; Cr <= we; Cr++) {
                ir += Ee.getNewLine(), Ae && rr + 1 < Cr && Cr < we - 1 && (ir += Re + J(e2.padLeft(T, er), G) + oe + Ee.getNewLine(), Cr = we - 1);
                var Ye = e2.getPositionOfLineAndCharacter(Z2, Cr, 0), Br = Cr < ye ? e2.getPositionOfLineAndCharacter(Z2, Cr + 1, 0) : Z2.text.length, Er = Z2.text.slice(Ye, Br);
                if (Er = e2.trimStringEnd(Er), Er = Er.replace(/\t/g, " "), ir += Re + J(e2.padLeft(Cr + 1 + "", er), G) + oe, ir += Er + Ee.getNewLine(), ir += Re + J(e2.padLeft("", er), G) + oe, ir += ze, Cr === rr) {
                  var Ne = Cr === we ? de : void 0;
                  ir += Er.slice(0, Ie).replace(/\S/g, " "), ir += Er.slice(Ie, Ne).replace(/./g, "~");
                } else
                  Cr === we ? ir += Er.slice(0, de).replace(/./g, "~") : ir += Er.replace(/./g, "~");
                ir += f4;
              }
              return ir;
            }
            function R(Z2, Be, ge, Re) {
              Re === void 0 && (Re = J);
              var ze = e2.getLineAndCharacterOfPosition(Z2, Be), Ee = ze.line, He = ze.character, rr = ge ? e2.convertToRelativePath(Z2.fileName, ge.getCurrentDirectory(), function(_e) {
                return ge.getCanonicalFileName(_e);
              }) : Z2.fileName, Ie = "";
              return Ie += Re(rr, m2.Cyan), Ie += ":", Ie += Re("".concat(Ee + 1), m2.Yellow), Ie += ":", Ie += Re("".concat(He + 1), m2.Yellow), Ie;
            }
            e2.formatLocation = R;
            function q(Z2, Be) {
              for (var ge = "", Re = 0, ze = Z2; Re < ze.length; Re++) {
                var Ee = ze[Re];
                if (Ee.file) {
                  var He = Ee.file, rr = Ee.start;
                  ge += R(He, rr, Be), ge += " - ";
                }
                if (ge += J(e2.diagnosticCategoryName(Ee), se(Ee.category)), ge += J(" TS".concat(Ee.code, ": "), m2.Grey), ge += O(Ee.messageText, Be.getNewLine()), Ee.file && (ge += Be.getNewLine(), ge += ie(Ee.file, Ee.start, Ee.length, "", se(Ee.category), Be)), Ee.relatedInformation) {
                  ge += Be.getNewLine();
                  for (var Ie = 0, _e = Ee.relatedInformation; Ie < _e.length; Ie++) {
                    var we = _e[Ie], He = we.file, rr = we.start, de = we.length, ye = we.messageText;
                    He && (ge += Be.getNewLine(), ge += K + R(He, rr, Be), ge += ie(He, rr, de, b, m2.Cyan, Be)), ge += Be.getNewLine(), ge += b + O(ye, Be.getNewLine());
                  }
                }
                ge += Be.getNewLine();
              }
              return ge;
            }
            e2.formatDiagnosticsWithColorAndContext = q;
            function O(Z2, Be, ge) {
              if (ge === void 0 && (ge = 0), e2.isString(Z2))
                return Z2;
              if (Z2 === void 0)
                return "";
              var Re = "";
              if (ge) {
                Re += Be;
                for (var ze = 0; ze < ge; ze++)
                  Re += "  ";
              }
              if (Re += Z2.messageText, ge++, Z2.next)
                for (var Ee = 0, He = Z2.next; Ee < He.length; Ee++) {
                  var rr = He[Ee];
                  Re += O(rr, Be, ge);
                }
              return Re;
            }
            e2.flattenDiagnosticMessageText = O;
            function ve(Z2, Be, ge, Re, ze) {
              if (Z2.length === 0)
                return [];
              for (var Ee = [], He = new e2.Map(), rr = 0, Ie = Z2; rr < Ie.length; rr++) {
                var _e = Ie[rr], we = void 0, de = ee(_e, Re), ye = e2.isString(_e) ? _e : _e.fileName.toLowerCase(), Ae = de !== void 0 ? "".concat(de, "|").concat(ye) : ye;
                He.has(Ae) ? we = He.get(Ae) : He.set(Ae, we = ze(ye, Be, ge, de)), Ee.push(we);
              }
              return Ee;
            }
            e2.loadWithTypeDirectiveCache = ve;
            function ee(Z2, Be) {
              return (e2.isString(Z2) ? Be : Z2.resolutionMode) || Be;
            }
            e2.getModeForFileReference = ee;
            function he(Z2, Be) {
              if (Z2.impliedNodeFormat !== void 0)
                return x2(Z2, Fe(Z2, Be));
            }
            e2.getModeForResolutionAtIndex = he;
            function F2(Z2) {
              var Be;
              return e2.isExportDeclaration(Z2) ? Z2.isTypeOnly : !!(!((Be = Z2.importClause) === null || Be === void 0) && Be.isTypeOnly);
            }
            e2.isExclusivelyTypeOnlyImportOrExport = F2;
            function x2(Z2, Be) {
              var ge, Re;
              if (Z2.impliedNodeFormat !== void 0) {
                if (e2.isImportDeclaration(Be.parent) || e2.isExportDeclaration(Be.parent)) {
                  var ze = F2(Be.parent);
                  if (ze) {
                    var Ee = X(Be.parent.assertClause);
                    if (Ee)
                      return Ee;
                  }
                }
                if (Be.parent.parent && e2.isImportTypeNode(Be.parent.parent)) {
                  var Ee = X((ge = Be.parent.parent.assertions) === null || ge === void 0 ? void 0 : ge.assertClause);
                  if (Ee)
                    return Ee;
                }
                if (Z2.impliedNodeFormat !== e2.ModuleKind.ESNext)
                  return e2.isImportCall(e2.walkUpParenthesizedExpressions(Be.parent)) ? e2.ModuleKind.ESNext : e2.ModuleKind.CommonJS;
                var He = (Re = e2.walkUpParenthesizedExpressions(Be.parent)) === null || Re === void 0 ? void 0 : Re.parent;
                return He && e2.isImportEqualsDeclaration(He) ? e2.ModuleKind.CommonJS : e2.ModuleKind.ESNext;
              }
            }
            e2.getModeForUsageLocation = x2;
            function X(Z2, Be) {
              if (!!Z2) {
                if (e2.length(Z2.elements) !== 1) {
                  Be == null || Be(Z2, e2.Diagnostics.Type_import_assertions_should_have_exactly_one_key_resolution_mode_with_value_import_or_require);
                  return;
                }
                var ge = Z2.elements[0];
                if (!!e2.isStringLiteralLike(ge.name)) {
                  if (ge.name.text !== "resolution-mode") {
                    Be == null || Be(ge.name, e2.Diagnostics.resolution_mode_is_the_only_valid_key_for_type_import_assertions);
                    return;
                  }
                  if (!!e2.isStringLiteralLike(ge.value)) {
                    if (ge.value.text !== "import" && ge.value.text !== "require") {
                      Be == null || Be(ge.value, e2.Diagnostics.resolution_mode_should_be_either_require_or_import);
                      return;
                    }
                    return ge.value.text === "import" ? e2.ModuleKind.ESNext : e2.ModuleKind.CommonJS;
                  }
                }
              }
            }
            e2.getResolutionModeOverrideForClause = X;
            function $(Z2, Be, ge, Re, ze) {
              if (Z2.length === 0)
                return [];
              for (var Ee = [], He = new e2.Map(), rr = 0, Ie = 0, _e = Z2; Ie < _e.length; Ie++) {
                var we = _e[Ie], de = void 0, ye = he(Be, rr);
                rr++;
                var Ae = ye !== void 0 ? "".concat(ye, "|").concat(we) : we;
                He.has(Ae) ? de = He.get(Ae) : He.set(Ae, de = ze(we, ye, ge, Re)), Ee.push(de);
              }
              return Ee;
            }
            e2.loadWithModeAwareCache = $;
            function A2(Z2, Be) {
              return y(void 0, Z2, function(ge, Re) {
                return ge && Be(ge, Re);
              });
            }
            e2.forEachResolvedProjectReference = A2;
            function y(Z2, Be, ge, Re) {
              var ze;
              return Ee(Z2, Be, void 0);
              function Ee(He, rr, Ie) {
                if (Re) {
                  var _e = Re(He, Ie);
                  if (_e)
                    return _e;
                }
                return e2.forEach(rr, function(we, de) {
                  if (!(we && (ze == null ? void 0 : ze.has(we.sourceFile.path)))) {
                    var ye = ge(we, Ie, de);
                    return ye || !we ? ye : ((ze || (ze = new e2.Set())).add(we.sourceFile.path), Ee(we.commandLine.projectReferences, we.references, we));
                  }
                });
              }
            }
            e2.inferredTypesContainingFile = "__inferred type names__.ts";
            function V(Z2) {
              switch (Z2 == null ? void 0 : Z2.kind) {
                case e2.FileIncludeKind.Import:
                case e2.FileIncludeKind.ReferenceFile:
                case e2.FileIncludeKind.TypeReferenceDirective:
                case e2.FileIncludeKind.LibReferenceDirective:
                  return true;
                default:
                  return false;
              }
            }
            e2.isReferencedFile = V;
            function L(Z2) {
              return Z2.pos !== void 0;
            }
            e2.isReferenceFileLocation = L;
            function P(Z2, Be) {
              var ge, Re, ze, Ee, He, rr, Ie, _e = e2.Debug.checkDefined(Z2(Be.file)), we = Be.kind, de = Be.index, ye, Ae, er, ir;
              switch (we) {
                case e2.FileIncludeKind.Import:
                  var Cr = Fe(_e, de);
                  if (er = (He = (Ee = _e.resolvedModules) === null || Ee === void 0 ? void 0 : Ee.get(Cr.text, he(_e, de))) === null || He === void 0 ? void 0 : He.packageId, Cr.pos === -1)
                    return { file: _e, packageId: er, text: Cr.text };
                  ye = e2.skipTrivia(_e.text, Cr.pos), Ae = Cr.end;
                  break;
                case e2.FileIncludeKind.ReferenceFile:
                  ge = _e.referencedFiles[de], ye = ge.pos, Ae = ge.end;
                  break;
                case e2.FileIncludeKind.TypeReferenceDirective:
                  Re = _e.typeReferenceDirectives[de], ye = Re.pos, Ae = Re.end, ir = Re.resolutionMode, er = (Ie = (rr = _e.resolvedTypeReferenceDirectiveNames) === null || rr === void 0 ? void 0 : rr.get(e2.toFileNameLowerCase(_e.typeReferenceDirectives[de].fileName), ir || _e.impliedNodeFormat)) === null || Ie === void 0 ? void 0 : Ie.packageId;
                  break;
                case e2.FileIncludeKind.LibReferenceDirective:
                  ze = _e.libReferenceDirectives[de], ye = ze.pos, Ae = ze.end;
                  break;
                default:
                  return e2.Debug.assertNever(we);
              }
              return { file: _e, pos: ye, end: Ae, packageId: er };
            }
            e2.getReferencedFileLocation = P;
            function k(Z2, Be, ge, Re, ze, Ee, He, rr, Ie) {
              if (!Z2 || (He == null ? void 0 : He()) || !e2.arrayIsEqualTo(Z2.getRootFileNames(), Be))
                return false;
              var _e;
              if (!e2.arrayIsEqualTo(Z2.getProjectReferences(), Ie, Ae) || Z2.getSourceFiles().some(de) || Z2.getMissingFilePaths().some(ze))
                return false;
              var we = Z2.getCompilerOptions();
              if (!e2.compareDataObjects(we, ge))
                return false;
              if (we.configFile && ge.configFile)
                return we.configFile.text === ge.configFile.text;
              return true;
              function de(ir) {
                return !ye(ir) || Ee(ir.path);
              }
              function ye(ir) {
                return ir.version === Re(ir.resolvedPath, ir.fileName);
              }
              function Ae(ir, Cr, Ye) {
                return e2.projectReferenceIsEqualTo(ir, Cr) && er(Z2.getResolvedProjectReferences()[Ye], ir);
              }
              function er(ir, Cr) {
                if (ir) {
                  if (e2.contains(_e, ir))
                    return true;
                  var Ye = ne(Cr), Br = rr(Ye);
                  return !Br || ir.commandLine.options.configFile !== Br.options.configFile || !e2.arrayIsEqualTo(ir.commandLine.fileNames, Br.fileNames) ? false : ((_e || (_e = [])).push(ir), !e2.forEach(ir.references, function(Ne, n) {
                    return !er(Ne, ir.commandLine.projectReferences[n]);
                  }));
                }
                var Er = ne(Cr);
                return !rr(Er);
              }
            }
            e2.isProgramUptoDate = k;
            function Y(Z2) {
              return Z2.options.configFile ? Ve(Ve([], Z2.options.configFile.parseDiagnostics, true), Z2.errors, true) : Z2.errors;
            }
            e2.getConfigFileParsingDiagnostics = Y;
            function U(Z2, Be, ge, Re) {
              switch (e2.getEmitModuleResolutionKind(Re)) {
                case e2.ModuleResolutionKind.Node16:
                case e2.ModuleResolutionKind.NodeNext:
                  return e2.fileExtensionIsOneOf(Z2, [".d.mts", ".mts", ".mjs"]) ? e2.ModuleKind.ESNext : e2.fileExtensionIsOneOf(Z2, [".d.cts", ".cts", ".cjs"]) ? e2.ModuleKind.CommonJS : e2.fileExtensionIsOneOf(Z2, [".d.ts", ".ts", ".tsx", ".js", ".jsx"]) ? ze() : void 0;
                default:
                  return;
              }
              function ze() {
                var Ee = e2.getPackageScopeForPath(Z2, Be, ge, Re);
                return (Ee == null ? void 0 : Ee.packageJsonContent.type) === "module" ? e2.ModuleKind.ESNext : e2.ModuleKind.CommonJS;
              }
            }
            e2.getImpliedNodeFormatForFile = U, e2.plainJSErrors = new e2.Set([e2.Diagnostics.Cannot_redeclare_block_scoped_variable_0.code, e2.Diagnostics.A_module_cannot_have_multiple_default_exports.code, e2.Diagnostics.Another_export_default_is_here.code, e2.Diagnostics.The_first_export_default_is_here.code, e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_at_the_top_level_of_a_module.code, e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_in_strict_mode_Modules_are_automatically_in_strict_mode.code, e2.Diagnostics.Identifier_expected_0_is_a_reserved_word_that_cannot_be_used_here.code, e2.Diagnostics.constructor_is_a_reserved_word.code, e2.Diagnostics.delete_cannot_be_called_on_an_identifier_in_strict_mode.code, e2.Diagnostics.Code_contained_in_a_class_is_evaluated_in_JavaScript_s_strict_mode_which_does_not_allow_this_use_of_0_For_more_information_see_https_Colon_Slash_Slashdeveloper_mozilla_org_Slashen_US_Slashdocs_SlashWeb_SlashJavaScript_SlashReference_SlashStrict_mode.code, e2.Diagnostics.Invalid_use_of_0_Modules_are_automatically_in_strict_mode.code, e2.Diagnostics.Invalid_use_of_0_in_strict_mode.code, e2.Diagnostics.A_label_is_not_allowed_here.code, e2.Diagnostics.Octal_literals_are_not_allowed_in_strict_mode.code, e2.Diagnostics.with_statements_are_not_allowed_in_strict_mode.code, e2.Diagnostics.A_break_statement_can_only_be_used_within_an_enclosing_iteration_or_switch_statement.code, e2.Diagnostics.A_break_statement_can_only_jump_to_a_label_of_an_enclosing_statement.code, e2.Diagnostics.A_class_declaration_without_the_default_modifier_must_have_a_name.code, e2.Diagnostics.A_class_member_cannot_have_the_0_keyword.code, e2.Diagnostics.A_comma_expression_is_not_allowed_in_a_computed_property_name.code, e2.Diagnostics.A_continue_statement_can_only_be_used_within_an_enclosing_iteration_statement.code, e2.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code, e2.Diagnostics.A_continue_statement_can_only_jump_to_a_label_of_an_enclosing_iteration_statement.code, e2.Diagnostics.A_default_clause_cannot_appear_more_than_once_in_a_switch_statement.code, e2.Diagnostics.A_default_export_must_be_at_the_top_level_of_a_file_or_module_declaration.code, e2.Diagnostics.A_definite_assignment_assertion_is_not_permitted_in_this_context.code, e2.Diagnostics.A_destructuring_declaration_must_have_an_initializer.code, e2.Diagnostics.A_get_accessor_cannot_have_parameters.code, e2.Diagnostics.A_rest_element_cannot_contain_a_binding_pattern.code, e2.Diagnostics.A_rest_element_cannot_have_a_property_name.code, e2.Diagnostics.A_rest_element_cannot_have_an_initializer.code, e2.Diagnostics.A_rest_element_must_be_last_in_a_destructuring_pattern.code, e2.Diagnostics.A_rest_parameter_cannot_have_an_initializer.code, e2.Diagnostics.A_rest_parameter_must_be_last_in_a_parameter_list.code, e2.Diagnostics.A_rest_parameter_or_binding_pattern_may_not_have_a_trailing_comma.code, e2.Diagnostics.A_return_statement_cannot_be_used_inside_a_class_static_block.code, e2.Diagnostics.A_set_accessor_cannot_have_rest_parameter.code, e2.Diagnostics.A_set_accessor_must_have_exactly_one_parameter.code, e2.Diagnostics.An_export_declaration_can_only_be_used_at_the_top_level_of_a_module.code, e2.Diagnostics.An_export_declaration_cannot_have_modifiers.code, e2.Diagnostics.An_import_declaration_can_only_be_used_at_the_top_level_of_a_module.code, e2.Diagnostics.An_import_declaration_cannot_have_modifiers.code, e2.Diagnostics.An_object_member_cannot_be_declared_optional.code, e2.Diagnostics.Argument_of_dynamic_import_cannot_be_spread_element.code, e2.Diagnostics.Cannot_assign_to_private_method_0_Private_methods_are_not_writable.code, e2.Diagnostics.Cannot_redeclare_identifier_0_in_catch_clause.code, e2.Diagnostics.Catch_clause_variable_cannot_have_an_initializer.code, e2.Diagnostics.Class_decorators_can_t_be_used_with_static_private_identifier_Consider_removing_the_experimental_decorator.code, e2.Diagnostics.Classes_can_only_extend_a_single_class.code, e2.Diagnostics.Classes_may_not_have_a_field_named_constructor.code, e2.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code, e2.Diagnostics.Duplicate_label_0.code, e2.Diagnostics.Dynamic_imports_can_only_accept_a_module_specifier_and_an_optional_assertion_as_arguments.code, e2.Diagnostics.For_await_loops_cannot_be_used_inside_a_class_static_block.code, e2.Diagnostics.JSX_attributes_must_only_be_assigned_a_non_empty_expression.code, e2.Diagnostics.JSX_elements_cannot_have_multiple_attributes_with_the_same_name.code, e2.Diagnostics.JSX_expressions_may_not_use_the_comma_operator_Did_you_mean_to_write_an_array.code, e2.Diagnostics.JSX_property_access_expressions_cannot_include_JSX_namespace_names.code, e2.Diagnostics.Jump_target_cannot_cross_function_boundary.code, e2.Diagnostics.Line_terminator_not_permitted_before_arrow.code, e2.Diagnostics.Modifiers_cannot_appear_here.code, e2.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_in_statement.code, e2.Diagnostics.Only_a_single_variable_declaration_is_allowed_in_a_for_of_statement.code, e2.Diagnostics.Private_identifiers_are_not_allowed_outside_class_bodies.code, e2.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code, e2.Diagnostics.Property_0_is_not_accessible_outside_class_1_because_it_has_a_private_identifier.code, e2.Diagnostics.Tagged_template_expressions_are_not_permitted_in_an_optional_chain.code, e2.Diagnostics.The_left_hand_side_of_a_for_of_statement_may_not_be_async.code, e2.Diagnostics.The_variable_declaration_of_a_for_in_statement_cannot_have_an_initializer.code, e2.Diagnostics.The_variable_declaration_of_a_for_of_statement_cannot_have_an_initializer.code, e2.Diagnostics.Trailing_comma_not_allowed.code, e2.Diagnostics.Variable_declaration_list_cannot_be_empty.code, e2.Diagnostics._0_and_1_operations_cannot_be_mixed_without_parentheses.code, e2.Diagnostics._0_expected.code, e2.Diagnostics._0_is_not_a_valid_meta_property_for_keyword_1_Did_you_mean_2.code, e2.Diagnostics._0_list_cannot_be_empty.code, e2.Diagnostics._0_modifier_already_seen.code, e2.Diagnostics._0_modifier_cannot_appear_on_a_constructor_declaration.code, e2.Diagnostics._0_modifier_cannot_appear_on_a_module_or_namespace_element.code, e2.Diagnostics._0_modifier_cannot_appear_on_a_parameter.code, e2.Diagnostics._0_modifier_cannot_appear_on_class_elements_of_this_kind.code, e2.Diagnostics._0_modifier_cannot_be_used_here.code, e2.Diagnostics._0_modifier_must_precede_1_modifier.code, e2.Diagnostics.const_declarations_can_only_be_declared_inside_a_block.code, e2.Diagnostics.const_declarations_must_be_initialized.code, e2.Diagnostics.extends_clause_already_seen.code, e2.Diagnostics.let_declarations_can_only_be_declared_inside_a_block.code, e2.Diagnostics.let_is_not_allowed_to_be_used_as_a_name_in_let_or_const_declarations.code]);
            function j(Z2, Be) {
              return Z2 ? e2.optionsHaveChanges(Z2.getCompilerOptions(), Be, e2.sourceFileAffectingCompilerOptions) : false;
            }
            function H(Z2, Be, ge, Re, ze) {
              return { rootNames: Z2, options: Be, host: ge, oldProgram: Re, configFileParsingDiagnostics: ze };
            }
            function I(Z2, Be, ge, Re, ze) {
              var Ee, He, rr, Ie, _e = e2.isArray(Z2) ? H(Z2, Be, ge, Re, ze) : Z2, we = _e.rootNames, de = _e.options, ye = _e.configFileParsingDiagnostics, Ae = _e.projectReferences, er = _e.oldProgram, ir, Cr, Ye, Br, Er, Ne, n, lr = new e2.Map(), be = e2.createMultiMap(), Ge = {}, ur = {}, yr = e2.createModeAwareCache(), Ir, wr = typeof de.maxNodeModuleJsDepth == "number" ? de.maxNodeModuleJsDepth : 0, Ur = 0, ii = new e2.Map(), mi = new e2.Map();
              e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "createProgram", { configFilePath: de.configFilePath, rootDir: de.rootDir }, true), e2.performance.mark("beforeProgram");
              var pe = _e.host || B(de), or = fe(pe), qr = de.noLib, si = e2.memoize(function() {
                return pe.getDefaultLibFileName(de);
              }), Di = pe.getDefaultLibLocation ? pe.getDefaultLibLocation() : e2.getDirectoryPath(si()), wi = e2.createDiagnosticCollection(), Xi = pe.getCurrentDirectory(), et = e2.getSupportedExtensions(de), Gi = e2.getSupportedExtensionsWithJsonIfResolveJsonModule(de, et), Wt = new e2.Map(), Zt, _r, pi, ae, Xe = pe.hasInvalidatedResolution || e2.returnFalse;
              if (pe.resolveModuleNames)
                ae = function(Kr, _i, Ei, tt, kt) {
                  return pe.resolveModuleNames(e2.Debug.checkEachDefined(Kr), Ei, tt, kt, de, _i).map(function(bt) {
                    if (!bt || bt.extension !== void 0)
                      return bt;
                    var ia = e2.clone(bt);
                    return ia.extension = e2.extensionFromPath(bt.resolvedFileName), ia;
                  });
                }, _r = (Ee = pe.getModuleResolutionCache) === null || Ee === void 0 ? void 0 : Ee.call(pe);
              else {
                _r = e2.createModuleResolutionCache(Xi, ua, de);
                var Jr = function(Kr, _i, Ei, tt) {
                  return e2.resolveModuleName(Kr, Ei, de, pe, _r, tt, _i).resolvedModule;
                };
                ae = function(Kr, _i, Ei, tt, kt) {
                  return $(e2.Debug.checkEachDefined(Kr), _i, Ei, kt, Jr);
                };
              }
              var ti;
              if (pe.resolveTypeReferenceDirectives)
                ti = function(Kr, _i, Ei, tt) {
                  return pe.resolveTypeReferenceDirectives(e2.Debug.checkEachDefined(Kr), _i, Ei, de, tt);
                };
              else {
                pi = e2.createTypeReferenceDirectiveResolutionCache(Xi, ua, void 0, _r == null ? void 0 : _r.getPackageJsonInfoCache());
                var Ze = function(Kr, _i, Ei, tt) {
                  return e2.resolveTypeReferenceDirective(Kr, _i, de, pe, Ei, pi, tt).resolvedTypeReferenceDirective;
                };
                ti = function(Kr, _i, Ei, tt) {
                  return ve(e2.Debug.checkEachDefined(Kr), _i, Ei, tt, Ze);
                };
              }
              var Sr = new e2.Map(), zr = new e2.Map(), Wr = e2.createMultiMap(), Je = false, xe = new e2.Map(), vr, mr = pe.useCaseSensitiveFileNames() ? new e2.Map() : void 0, Ar, Oe, nr, Mr, Pe = !!(!((He = pe.useSourceOfProjectReferenceRedirect) === null || He === void 0) && He.call(pe)) && !de.disableSourceOfProjectReferenceRedirect, Ue = l({ compilerHost: pe, getSymlinkCache: vc, useSourceOfProjectReferenceRedirect: Pe, toPath: Vi, getResolvedProjectReferences: Ba, getSourceOfProjectReferenceRedirect: ce, forEachResolvedProjectReference: Ji }), fr = Ue.onProgramCreateComplete, De = Ue.fileExists, gr = Ue.directoryExists, Vr = pe.readFile.bind(pe);
              e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "shouldProgramCreateNewSourceFiles", { hasOldProgram: !!er });
              var Tr = j(er, de);
              e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
              var vi;
              if (e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "tryReuseStructureFromOldProgram", {}), vi = Qa(), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), vi !== 2) {
                ir = [], Cr = [], Ae && (Ar || (Ar = Ae.map(fo)), we.length && (Ar == null || Ar.forEach(function(Kr, _i) {
                  if (!!Kr) {
                    var Ei = e2.outFile(Kr.commandLine.options);
                    if (Pe) {
                      if (Ei || e2.getEmitModuleKind(Kr.commandLine.options) === e2.ModuleKind.None)
                        for (var tt = 0, kt = Kr.commandLine.fileNames; tt < kt.length; tt++) {
                          var bt = kt[tt];
                          ys(bt, { kind: e2.FileIncludeKind.SourceFromProjectReference, index: _i });
                        }
                    } else if (Ei)
                      ys(e2.changeExtension(Ei, ".d.ts"), { kind: e2.FileIncludeKind.OutputFromProjectReference, index: _i });
                    else if (e2.getEmitModuleKind(Kr.commandLine.options) === e2.ModuleKind.None)
                      for (var ia = e2.memoize(function() {
                        return e2.getCommonSourceDirectoryOfConfig(Kr.commandLine, !pe.useCaseSensitiveFileNames());
                      }), Xt = 0, Za = Kr.commandLine.fileNames; Xt < Za.length; Xt++) {
                        var bt = Za[Xt];
                        !e2.isDeclarationFileName(bt) && !e2.fileExtensionIs(bt, ".json") && ys(e2.getOutputDeclarationFileName(bt, Kr.commandLine, !pe.useCaseSensitiveFileNames(), ia), { kind: e2.FileIncludeKind.OutputFromProjectReference, index: _i });
                      }
                  }
                }))), e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "processRootFiles", { count: we.length }), e2.forEach(we, function(Kr, _i) {
                  return Qi(Kr, false, false, { kind: e2.FileIncludeKind.RootFile, index: _i });
                }), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
                var Ui = we.length ? e2.getAutomaticTypeDirectiveNames(de, pe) : e2.emptyArray;
                if (Ui.length) {
                  e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "processTypeReferences", { count: Ui.length });
                  for (var Yi = de.configFilePath ? e2.getDirectoryPath(de.configFilePath) : pe.getCurrentDirectory(), Wi = e2.combinePaths(Yi, e2.inferredTypesContainingFile), ct = Bt(Ui, Wi), Li = 0; Li < Ui.length; Li++)
                    Hr(Ui[Li], void 0, ct[Li], { kind: e2.FileIncludeKind.AutomaticTypeDirectiveFile, typeReference: Ui[Li], packageId: (rr = ct[Li]) === null || rr === void 0 ? void 0 : rr.packageId });
                  e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
                }
                if (we.length && !qr) {
                  var nt = si();
                  !de.lib && nt ? Qi(nt, true, false, { kind: e2.FileIncludeKind.LibFile }) : e2.forEach(de.lib, function(Kr, _i) {
                    Qi(Pt(Kr), true, false, { kind: e2.FileIncludeKind.LibFile, index: _i });
                  });
                }
                vr = e2.arrayFrom(e2.mapDefinedIterator(xe.entries(), function(Kr) {
                  var _i = Kr[0], Ei = Kr[1];
                  return Ei === void 0 ? _i : void 0;
                })), Ye = e2.stableSort(ir, Ai).concat(Cr), ir = void 0, Cr = void 0;
              }
              if (e2.Debug.assert(!!vr), er && pe.onReleaseOldSourceFile) {
                for (var Mt = er.getSourceFiles(), xt = 0, ut = Mt; xt < ut.length; xt++) {
                  var Dt = ut[xt], Rt = Da(Dt.resolvedPath);
                  (Tr || !Rt || Dt.resolvedPath === Dt.path && Rt.resolvedPath !== Dt.path) && pe.onReleaseOldSourceFile(Dt, er.getCompilerOptions(), !!Da(Dt.path));
                }
                pe.getParsedCommandLine || er.forEachResolvedProjectReference(function(Kr) {
                  yi(Kr.sourceFile.path) || pe.onReleaseOldSourceFile(Kr.sourceFile, er.getCompilerOptions(), false);
                });
              }
              er && pe.onReleaseParsedCommandLine && y(er.getProjectReferences(), er.getResolvedProjectReferences(), function(Kr, _i, Ei) {
                var tt = (_i == null ? void 0 : _i.commandLine.projectReferences[Ei]) || er.getProjectReferences()[Ei], kt = ne(tt);
                Oe != null && Oe.has(Vi(kt)) || pe.onReleaseParsedCommandLine(kt, Kr, er.getCompilerOptions());
              }), pi = void 0, er = void 0;
              var Ii = { getRootFileNames: function() {
                return we;
              }, getSourceFile: Rn, getSourceFileByPath: Da, getSourceFiles: function() {
                return Ye;
              }, getMissingFilePaths: function() {
                return vr;
              }, getModuleResolutionCache: function() {
                return _r;
              }, getFilesByNameMap: function() {
                return xe;
              }, getCompilerOptions: function() {
                return de;
              }, getSyntacticDiagnostics: Ro, getOptionsDiagnostics: br, getGlobalDiagnostics: Si, getSemanticDiagnostics: En, getCachedSemanticDiagnostics: Wn, getSuggestionDiagnostics: dn, getDeclarationDiagnostics: Ko, getBindAndCheckDiagnostics: to, getProgramDiagnostics: Co, getTypeChecker: xn, getClassifiableNames: At, getCommonSourceDirectory: at, emit: Kn, getCurrentDirectory: function() {
                return Xi;
              }, getNodeCount: function() {
                return xn().getNodeCount();
              }, getIdentifierCount: function() {
                return xn().getIdentifierCount();
              }, getSymbolCount: function() {
                return xn().getSymbolCount();
              }, getTypeCount: function() {
                return xn().getTypeCount();
              }, getInstantiationCount: function() {
                return xn().getInstantiationCount();
              }, getRelationCacheSizes: function() {
                return xn().getRelationCacheSizes();
              }, getFileProcessingDiagnostics: function() {
                return Ir;
              }, getResolvedTypeReferenceDirectives: function() {
                return yr;
              }, isSourceFileFromExternalLibrary: Bi, isSourceFileDefaultLibrary: kn, getSourceFileFromReference: mo, getLibFileFromReference: qn, sourceFileToPackageName: zr, redirectTargetsMap: Wr, usesUriStyleNodeCoreModules: Je, isEmittedFile: Ya, getConfigFileParsingDiagnostics: Pi, getResolvedModuleWithFailedLookupLocationsFromCache: ji, getProjectReferences: pn, getResolvedProjectReferences: Ba, getProjectReferenceRedirect: ps, getResolvedProjectReferenceToRedirect: ds, getResolvedProjectReferenceByPath: yi, forEachResolvedProjectReference: Ji, isSourceOfProjectReferenceRedirect: Rr, emitBuildInfo: ka, fileExists: De, readFile: Vr, directoryExists: gr, getSymlinkCache: vc, realpath: (Ie = pe.realpath) === null || Ie === void 0 ? void 0 : Ie.bind(pe), useCaseSensitiveFileNames: function() {
                return pe.useCaseSensitiveFileNames();
              }, getFileIncludeReasons: function() {
                return be;
              }, structureIsReused: vi, writeFile: Dn };
              return fr(), Ir == null || Ir.forEach(function(Kr) {
                switch (Kr.kind) {
                  case 1:
                    return wi.add(Fo(Kr.file && Da(Kr.file), Kr.fileProcessingReason, Kr.diagnostic, Kr.args || e2.emptyArray));
                  case 0:
                    var _i = P(Da, Kr.reason), Ei = _i.file, tt = _i.pos, kt = _i.end;
                    return wi.add(e2.createFileDiagnostic.apply(void 0, Ve([Ei, e2.Debug.checkDefined(tt), e2.Debug.checkDefined(kt) - tt, Kr.diagnostic], Kr.args || e2.emptyArray, false)));
                  default:
                    e2.Debug.assertNever(Kr);
                }
              }), xs(), e2.performance.mark("afterProgram"), e2.performance.measure("Program", "beforeProgram", "afterProgram"), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), Ii;
              function Ki(Kr) {
                if (!!Kr)
                  for (var _i = 0, Ei = Kr; _i < Ei.length; _i++) {
                    var tt = Ei[_i];
                    wi.add(tt);
                  }
              }
              function Fi(Kr, _i) {
                var Ei;
                if (!!_r)
                  for (var tt = e2.getNormalizedAbsolutePath(_i.originalFileName, Xi), kt = e2.isString(_i) ? void 0 : _i.impliedNodeFormat, bt = e2.getDirectoryPath(tt), ia = wt(_i), Xt = 0, Za = 0, bn = Kr; Za < bn.length; Za++) {
                    var _a4 = bn[Za], qa = typeof _a4 == "string" ? he(_i, Xt) : ee(_a4, kt), rn = typeof _a4 == "string" ? _a4 : _a4.fileName;
                    if (Xt++, !e2.isExternalModuleNameRelative(rn)) {
                      var jn = (Ei = _r.getOrCreateCacheForModuleName(rn, qa, ia).get(bt)) === null || Ei === void 0 ? void 0 : Ei.resolutionDiagnostics;
                      Ki(jn);
                    }
                  }
              }
              function ui(Kr, _i, Ei) {
                if (!Kr.length)
                  return e2.emptyArray;
                var tt = e2.getNormalizedAbsolutePath(_i.originalFileName, Xi), kt = wt(_i);
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "resolveModuleNamesWorker", { containingFileName: tt }), e2.performance.mark("beforeResolveModule");
                var bt = ae(Kr, _i, tt, Ei, kt);
                return e2.performance.mark("afterResolveModule"), e2.performance.measure("ResolveModule", "beforeResolveModule", "afterResolveModule"), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), Fi(Kr, _i), bt;
              }
              function Bt(Kr, _i) {
                if (!Kr.length)
                  return [];
                var Ei = e2.isString(_i) ? _i : e2.getNormalizedAbsolutePath(_i.originalFileName, Xi), tt = e2.isString(_i) ? void 0 : wt(_i), kt = e2.isString(_i) ? void 0 : _i.impliedNodeFormat;
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "resolveTypeReferenceDirectiveNamesWorker", { containingFileName: Ei }), e2.performance.mark("beforeResolveTypeReference");
                var bt = ti(Kr, Ei, tt, kt);
                return e2.performance.mark("afterResolveTypeReference"), e2.performance.measure("ResolveTypeReference", "beforeResolveTypeReference", "afterResolveTypeReference"), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), bt;
              }
              function wt(Kr) {
                var _i = ds(Kr.originalFileName);
                if (_i || !e2.isDeclarationFileName(Kr.originalFileName))
                  return _i;
                var Ei = na(Kr.path);
                if (Ei)
                  return Ei;
                if (!(!pe.realpath || !de.preserveSymlinks || !e2.stringContains(Kr.originalFileName, e2.nodeModulesPathPart))) {
                  var tt = Vi(pe.realpath(Kr.originalFileName));
                  return tt === Kr.path ? void 0 : na(tt);
                }
              }
              function na(Kr) {
                var _i = ce(Kr);
                if (e2.isString(_i))
                  return ds(_i);
                if (!!_i)
                  return Ji(function(Ei) {
                    var tt = e2.outFile(Ei.commandLine.options);
                    if (!!tt)
                      return Vi(tt) === Kr ? Ei : void 0;
                  });
              }
              function Ai(Kr, _i) {
                return e2.compareValues(Oi(Kr), Oi(_i));
              }
              function Oi(Kr) {
                if (e2.containsPath(Di, Kr.fileName, false)) {
                  var _i = e2.getBaseFileName(Kr.fileName);
                  if (_i === "lib.d.ts" || _i === "lib.es6.d.ts")
                    return 0;
                  var Ei = e2.removeSuffix(e2.removePrefix(_i, "lib."), ".d.ts"), tt = e2.libs.indexOf(Ei);
                  if (tt !== -1)
                    return tt + 1;
                }
                return e2.libs.length + 2;
              }
              function ji(Kr, _i, Ei) {
                return _r && e2.resolveModuleNameFromCache(Kr, _i, _r, Ei);
              }
              function Vi(Kr) {
                return e2.toPath(Kr, Xi, ua);
              }
              function at() {
                if (Er === void 0) {
                  var Kr = e2.filter(Ye, function(_i) {
                    return e2.sourceFileMayBeEmitted(_i, Ii);
                  });
                  Er = e2.getCommonSourceDirectory(de, function() {
                    return e2.mapDefined(Kr, function(_i) {
                      return _i.isDeclarationFile ? void 0 : _i.fileName;
                    });
                  }, Xi, ua, function(_i) {
                    return jr(Kr, _i);
                  });
                }
                return Er;
              }
              function At() {
                var Kr;
                if (!n) {
                  xn(), n = new e2.Set();
                  for (var _i = 0, Ei = Ye; _i < Ei.length; _i++) {
                    var tt = Ei[_i];
                    (Kr = tt.classifiableNames) === null || Kr === void 0 || Kr.forEach(function(kt) {
                      return n.add(kt);
                    });
                  }
                }
                return n;
              }
              function ba(Kr, _i) {
                if (vi === 0 && !_i.ambientModuleNames.length)
                  return ui(Kr, _i, void 0);
                var Ei = er && er.getSourceFile(_i.fileName);
                if (Ei !== _i && _i.resolvedModules) {
                  for (var tt = [], kt = 0, bt = 0, ia = Kr; bt < ia.length; bt++) {
                    var Xt = ia[bt], Za = _i.resolvedModules.get(Xt, he(_i, kt));
                    kt++, tt.push(Za);
                  }
                  return tt;
                }
                for (var bn, _a4, qa, rn = {}, kt = 0; kt < Kr.length; kt++) {
                  var Xt = Kr[kt];
                  if (_i === Ei && !Xe(Ei.path)) {
                    var jn = e2.getResolvedModule(Ei, Xt, he(Ei, kt));
                    if (jn) {
                      e2.isTraceEnabled(de, pe) && e2.trace(pe, jn.packageId ? e2.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : e2.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2, Xt, e2.getNormalizedAbsolutePath(_i.originalFileName, Xi), jn.resolvedFileName, jn.packageId && e2.packageIdToString(jn.packageId)), (_a4 || (_a4 = new Array(Kr.length)))[kt] = jn, (qa || (qa = [])).push(Xt);
                      continue;
                    }
                  }
                  var Mo = false;
                  e2.contains(_i.ambientModuleNames, Xt) ? (Mo = true, e2.isTraceEnabled(de, pe) && e2.trace(pe, e2.Diagnostics.Module_0_was_resolved_as_locally_declared_ambient_module_in_file_1, Xt, e2.getNormalizedAbsolutePath(_i.originalFileName, Xi))) : Mo = Se(Xt, kt), Mo ? (_a4 || (_a4 = new Array(Kr.length)))[kt] = rn : (bn || (bn = [])).push(Xt);
                }
                var ho = bn && bn.length ? ui(bn, _i, qa) : e2.emptyArray;
                if (!_a4)
                  return e2.Debug.assert(ho.length === Kr.length), ho;
                for (var gs = 0, kt = 0; kt < _a4.length; kt++)
                  _a4[kt] ? _a4[kt] === rn && (_a4[kt] = void 0) : (_a4[kt] = ho[gs], gs++);
                return e2.Debug.assert(gs === ho.length), _a4;
                function Se(hr, Or) {
                  if (Or >= e2.length(Ei == null ? void 0 : Ei.imports) + e2.length(Ei == null ? void 0 : Ei.moduleAugmentations))
                    return false;
                  var ki = e2.getResolvedModule(Ei, hr, Ei && he(Ei, Or)), dt = ki && er.getSourceFile(ki.resolvedFileName);
                  if (ki && dt)
                    return false;
                  var la = lr.get(hr);
                  return la ? (e2.isTraceEnabled(de, pe) && e2.trace(pe, e2.Diagnostics.Module_0_was_resolved_as_ambient_module_declared_in_1_since_this_file_was_not_modified, hr, la), true) : false;
                }
              }
              function $a() {
                return !y(er.getProjectReferences(), er.getResolvedProjectReferences(), function(Kr, _i, Ei) {
                  var tt = (_i ? _i.commandLine.projectReferences : Ae)[Ei], kt = fo(tt);
                  return Kr ? !kt || kt.sourceFile !== Kr.sourceFile || !e2.arrayIsEqualTo(Kr.commandLine.fileNames, kt.commandLine.fileNames) : kt !== void 0;
                }, function(Kr, _i) {
                  var Ei = _i ? yi(_i.sourceFile.path).commandLine.projectReferences : Ae;
                  return !e2.arrayIsEqualTo(Kr, Ei, e2.projectReferenceIsEqualTo);
                });
              }
              function Qa() {
                var Kr;
                if (!er)
                  return 0;
                var _i = er.getCompilerOptions();
                if (e2.changesAffectModuleResolution(_i, de))
                  return 0;
                var Ei = er.getRootFileNames();
                if (!e2.arrayIsEqualTo(Ei, we) || !$a())
                  return 0;
                Ae && (Ar = Ae.map(fo));
                var tt = [], kt = [];
                if (vi = 2, er.getMissingFilePaths().some(function(Ls) {
                  return pe.fileExists(Ls);
                }))
                  return 0;
                var bt = er.getSourceFiles(), ia;
                (function(Ls) {
                  Ls[Ls.Exists = 0] = "Exists", Ls[Ls.Modified = 1] = "Modified";
                })(ia || (ia = {}));
                for (var Xt = new e2.Map(), Za = 0, bn = bt; Za < bn.length; Za++) {
                  var _a4 = bn[Za], qa = pe.getSourceFileByPath ? pe.getSourceFileByPath(_a4.fileName, _a4.resolvedPath, Xs(_a4.fileName, _r, pe, de), void 0, Tr) : pe.getSourceFile(_a4.fileName, Xs(_a4.fileName, _r, pe, de), void 0, Tr);
                  if (!qa)
                    return 0;
                  e2.Debug.assert(!qa.redirectInfo, "Host should not return a redirect source file from `getSourceFile`");
                  var rn = void 0;
                  if (_a4.redirectInfo) {
                    if (qa !== _a4.redirectInfo.unredirected)
                      return 0;
                    rn = false, qa = _a4;
                  } else if (er.redirectTargetsMap.has(_a4.path)) {
                    if (qa !== _a4)
                      return 0;
                    rn = false;
                  } else
                    rn = qa !== _a4;
                  qa.path = _a4.path, qa.originalFileName = _a4.originalFileName, qa.resolvedPath = _a4.resolvedPath, qa.fileName = _a4.fileName;
                  var jn = er.sourceFileToPackageName.get(_a4.path);
                  if (jn !== void 0) {
                    var Mo = Xt.get(jn), ho = rn ? 1 : 0;
                    if (Mo !== void 0 && ho === 1 || Mo === 1)
                      return 0;
                    Xt.set(jn, ho);
                  }
                  rn ? (e2.arrayIsEqualTo(_a4.libReferenceDirectives, qa.libReferenceDirectives, Ct) || (vi = 1), _a4.hasNoDefaultLib !== qa.hasNoDefaultLib && (vi = 1), e2.arrayIsEqualTo(_a4.referencedFiles, qa.referencedFiles, Ct) || (vi = 1), Wa(qa), e2.arrayIsEqualTo(_a4.imports, qa.imports, sa) || (vi = 1), e2.arrayIsEqualTo(_a4.moduleAugmentations, qa.moduleAugmentations, sa) || (vi = 1), (_a4.flags & 6291456) !== (qa.flags & 6291456) && (vi = 1), e2.arrayIsEqualTo(_a4.typeReferenceDirectives, qa.typeReferenceDirectives, Ct) || (vi = 1), kt.push({ oldFile: _a4, newFile: qa })) : Xe(_a4.path) && (vi = 1, kt.push({ oldFile: _a4, newFile: qa })), tt.push(qa);
                }
                if (vi !== 2)
                  return vi;
                for (var gs = kt.map(function(Ls) {
                  return Ls.oldFile;
                }), Se = 0, hr = bt; Se < hr.length; Se++) {
                  var Or = hr[Se];
                  if (!e2.contains(gs, Or))
                    for (var ki = 0, dt = Or.ambientModuleNames; ki < dt.length; ki++) {
                      var la = dt[ki];
                      lr.set(la, Or.fileName);
                    }
                }
                for (var wa = 0, On = kt; wa < On.length; wa++) {
                  var No = On[wa], _a4 = No.oldFile, qa = No.newFile, jo = We(qa), po = ba(jo, qa), Gn = e2.hasChangesInResolutions(jo, po, _a4.resolvedModules, _a4, e2.moduleResolutionIsEqualTo);
                  Gn ? (vi = 1, qa.resolvedModules = e2.zipToModeAwareCache(qa, jo, po)) : qa.resolvedModules = _a4.resolvedModules;
                  var $n = qa.typeReferenceDirectives, Ho = Bt($n, qa), Zo = e2.hasChangesInResolutions($n, Ho, _a4.resolvedTypeReferenceDirectiveNames, _a4, e2.typeDirectiveIsEqualTo);
                  Zo ? (vi = 1, qa.resolvedTypeReferenceDirectiveNames = e2.zipToModeAwareCache(qa, $n, Ho)) : qa.resolvedTypeReferenceDirectiveNames = _a4.resolvedTypeReferenceDirectiveNames;
                }
                if (vi !== 2)
                  return vi;
                if (e2.changesAffectingProgramStructure(_i, de) || ((Kr = pe.hasChangedAutomaticTypeDirectiveNames) === null || Kr === void 0 ? void 0 : Kr.call(pe)))
                  return 1;
                vr = er.getMissingFilePaths(), e2.Debug.assert(tt.length === er.getSourceFiles().length);
                for (var Es = 0, yc = tt; Es < yc.length; Es++) {
                  var qa = yc[Es];
                  xe.set(qa.path, qa);
                }
                var Xr = er.getFilesByNameMap();
                return Xr.forEach(function(Ls, Ic) {
                  if (!Ls) {
                    xe.set(Ic, Ls);
                    return;
                  }
                  if (Ls.path === Ic) {
                    er.isSourceFileFromExternalLibrary(Ls) && mi.set(Ls.path, true);
                    return;
                  }
                  xe.set(Ic, xe.get(Ls.path));
                }), Ye = tt, be = er.getFileIncludeReasons(), Ir = er.getFileProcessingDiagnostics(), yr = er.getResolvedTypeReferenceDirectives(), zr = er.sourceFileToPackageName, Wr = er.redirectTargetsMap, Je = er.usesUriStyleNodeCoreModules, 2;
              }
              function ai(Kr) {
                return { getPrependNodes: Cn, getCanonicalFileName: ua, getCommonSourceDirectory: Ii.getCommonSourceDirectory, getCompilerOptions: Ii.getCompilerOptions, getCurrentDirectory: function() {
                  return Xi;
                }, getNewLine: function() {
                  return pe.getNewLine();
                }, getSourceFile: Ii.getSourceFile, getSourceFileByPath: Ii.getSourceFileByPath, getSourceFiles: Ii.getSourceFiles, getLibFileFromReference: Ii.getLibFileFromReference, isSourceFileFromExternalLibrary: Bi, getResolvedProjectReferenceToRedirect: ds, getProjectReferenceRedirect: ps, isSourceOfProjectReferenceRedirect: Rr, getSymlinkCache: vc, writeFile: Kr || Dn, isEmitBlocked: Pn, readFile: function(_i) {
                  return pe.readFile(_i);
                }, fileExists: function(_i) {
                  var Ei = Vi(_i);
                  return Da(Ei) ? true : e2.contains(vr, Ei) ? false : pe.fileExists(_i);
                }, useCaseSensitiveFileNames: function() {
                  return pe.useCaseSensitiveFileNames();
                }, getProgramBuildInfo: function() {
                  return Ii.getProgramBuildInfo && Ii.getProgramBuildInfo();
                }, getSourceFileFromReference: function(_i, Ei) {
                  return Ii.getSourceFileFromReference(_i, Ei);
                }, redirectTargetsMap: Wr, getFileIncludeReasons: Ii.getFileIncludeReasons };
              }
              function Dn(Kr, _i, Ei, tt, kt, bt) {
                pe.writeFile(Kr, _i, Ei, tt, kt, bt);
              }
              function ka(Kr) {
                e2.Debug.assert(!e2.outFile(de)), e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("emit", "emitBuildInfo", {}, true), e2.performance.mark("beforeEmit");
                var _i = e2.emitFiles(e2.notImplementedResolver, ai(Kr), void 0, e2.noTransformers, false, true);
                return e2.performance.mark("afterEmit"), e2.performance.measure("Emit", "beforeEmit", "afterEmit"), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), _i;
              }
              function Ba() {
                return Ar;
              }
              function pn() {
                return Ae;
              }
              function Cn() {
                return g(Ae, function(Kr, _i) {
                  var Ei;
                  return (Ei = Ar[_i]) === null || Ei === void 0 ? void 0 : Ei.commandLine;
                }, function(Kr) {
                  var _i = Vi(Kr), Ei = Da(_i);
                  return Ei ? Ei.text : xe.has(_i) ? void 0 : pe.readFile(_i);
                });
              }
              function Bi(Kr) {
                return !!mi.get(Kr.path);
              }
              function kn(Kr) {
                if (!Kr.isDeclarationFile)
                  return false;
                if (Kr.hasNoDefaultLib)
                  return true;
                if (!de.noLib)
                  return false;
                var _i = pe.useCaseSensitiveFileNames() ? e2.equateStringsCaseSensitive : e2.equateStringsCaseInsensitive;
                return de.lib ? e2.some(de.lib, function(Ei) {
                  return _i(Kr.fileName, Pt(Ei));
                }) : _i(Kr.fileName, si());
              }
              function xn() {
                return Ne || (Ne = e2.createTypeChecker(Ii));
              }
              function Kn(Kr, _i, Ei, tt, kt, bt) {
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("emit", "emit", { path: Kr == null ? void 0 : Kr.path }, true);
                var ia = no(function() {
                  return eo(Ii, Kr, _i, Ei, tt, kt, bt);
                });
                return e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), ia;
              }
              function Pn(Kr) {
                return Wt.has(Vi(Kr));
              }
              function eo(Kr, _i, Ei, tt, kt, bt, ia) {
                if (!ia) {
                  var Xt = d(Kr, _i, Ei, tt);
                  if (Xt)
                    return Xt;
                }
                var Za = xn().getEmitResolver(e2.outFile(de) ? void 0 : _i, tt);
                e2.performance.mark("beforeEmit");
                var bn = e2.emitFiles(Za, ai(Ei), _i, e2.getTransformers(de, bt, kt), kt, false, ia);
                return e2.performance.mark("afterEmit"), e2.performance.measure("Emit", "beforeEmit", "afterEmit"), bn;
              }
              function Rn(Kr) {
                return Da(Vi(Kr));
              }
              function Da(Kr) {
                return xe.get(Kr) || void 0;
              }
              function bo(Kr, _i, Ei) {
                return Kr ? _i(Kr, Ei) : e2.sortAndDeduplicateDiagnostics(e2.flatMap(Ii.getSourceFiles(), function(tt) {
                  return Ei && Ei.throwIfCancellationRequested(), _i(tt, Ei);
                }));
              }
              function Ro(Kr, _i) {
                return bo(Kr, Oo, _i);
              }
              function En(Kr, _i) {
                return bo(Kr, $o, _i);
              }
              function Wn(Kr) {
                var _i;
                return Kr ? (_i = Ge.perFile) === null || _i === void 0 ? void 0 : _i.get(Kr.path) : Ge.allDiagnostics;
              }
              function to(Kr, _i) {
                return Pr(Kr, _i);
              }
              function Co(Kr) {
                var _i;
                if (e2.skipTypeChecking(Kr, de, Ii))
                  return e2.emptyArray;
                var Ei = wi.getDiagnostics(Kr.fileName);
                return !((_i = Kr.commentDirectives) === null || _i === void 0) && _i.length ? pa(Kr, Kr.commentDirectives, Ei).diagnostics : Ei;
              }
              function Ko(Kr, _i) {
                var Ei = Ii.getCompilerOptions();
                return !Kr || e2.outFile(Ei) ? Gr(Kr, _i) : bo(Kr, qe, _i);
              }
              function Oo(Kr) {
                return e2.isSourceFileJS(Kr) ? (Kr.additionalSyntacticDiagnostics || (Kr.additionalSyntacticDiagnostics = Qe(Kr)), e2.concatenate(Kr.additionalSyntacticDiagnostics, Kr.parseDiagnostics)) : Kr.parseDiagnostics;
              }
              function no(Kr) {
                try {
                  return Kr();
                } catch (_i) {
                  throw _i instanceof e2.OperationCanceledException && (Ne = void 0), _i;
                }
              }
              function $o(Kr, _i) {
                return e2.concatenate(D(Pr(Kr, _i), de), Co(Kr));
              }
              function Pr(Kr, _i) {
                return Ce(Kr, _i, Ge, xi);
              }
              function xi(Kr, _i) {
                return no(function() {
                  if (e2.skipTypeChecking(Kr, de, Ii))
                    return e2.emptyArray;
                  var Ei = xn();
                  e2.Debug.assert(!!Kr.bindDiagnostics);
                  var tt = Kr.scriptKind === 1 || Kr.scriptKind === 2, kt = tt && e2.isCheckJsEnabledForFile(Kr, de), bt = e2.isPlainJsFile(Kr, de.checkJs), ia = !!Kr.checkJsDirective && Kr.checkJsDirective.enabled === false, Xt = !ia && (Kr.scriptKind === 3 || Kr.scriptKind === 4 || Kr.scriptKind === 5 || bt || kt || Kr.scriptKind === 7), Za = Xt ? Kr.bindDiagnostics : e2.emptyArray, bn = Xt ? Ei.getDiagnostics(Kr, _i) : e2.emptyArray;
                  return bt && (Za = e2.filter(Za, function(_a4) {
                    return e2.plainJSErrors.has(_a4.code);
                  }), bn = e2.filter(bn, function(_a4) {
                    return e2.plainJSErrors.has(_a4.code);
                  })), St(Kr, Xt && !bt, Za, bn, kt ? Kr.jsDocDiagnostics : void 0);
                });
              }
              function St(Kr, _i) {
                for (var Ei, tt = [], kt = 2; kt < arguments.length; kt++)
                  tt[kt - 2] = arguments[kt];
                var bt = e2.flatten(tt);
                if (!_i || !(!((Ei = Kr.commentDirectives) === null || Ei === void 0) && Ei.length))
                  return bt;
                for (var ia = pa(Kr, Kr.commentDirectives, bt), Xt = ia.diagnostics, Za = ia.directives, bn = 0, _a4 = Za.getUnusedExpectations(); bn < _a4.length; bn++) {
                  var qa = _a4[bn];
                  Xt.push(e2.createDiagnosticForRange(Kr, qa.range, e2.Diagnostics.Unused_ts_expect_error_directive));
                }
                return Xt;
              }
              function pa(Kr, _i, Ei) {
                var tt = e2.createCommentDirectivesMap(Kr, _i), kt = Ei.filter(function(bt) {
                  return Jn(bt, tt) === -1;
                });
                return { diagnostics: kt, directives: tt };
              }
              function dn(Kr, _i) {
                return no(function() {
                  return xn().getSuggestionDiagnostics(Kr, _i);
                });
              }
              function Jn(Kr, _i) {
                var Ei = Kr.file, tt = Kr.start;
                if (!Ei)
                  return -1;
                for (var kt = e2.getLineStarts(Ei), bt = e2.computeLineAndCharacterOfPosition(kt, tt).line - 1; bt >= 0; ) {
                  if (_i.markUsed(bt))
                    return bt;
                  var ia = Ei.text.slice(kt[bt], kt[bt + 1]).trim();
                  if (ia !== "" && !/^(\s*)\/\/(.*)$/.test(ia))
                    return -1;
                  bt--;
                }
                return -1;
              }
              function Qe(Kr) {
                return no(function() {
                  var _i = [];
                  return Ei(Kr, Kr), e2.forEachChildRecursively(Kr, Ei, tt), _i;
                  function Ei(Xt, Za) {
                    switch (Za.kind) {
                      case 164:
                      case 167:
                      case 169:
                        if (Za.questionToken === Xt)
                          return _i.push(ia(Xt, e2.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, "?")), "skip";
                      case 168:
                      case 171:
                      case 172:
                      case 173:
                      case 213:
                      case 256:
                      case 214:
                      case 254:
                        if (Za.type === Xt)
                          return _i.push(ia(Xt, e2.Diagnostics.Type_annotations_can_only_be_used_in_TypeScript_files)), "skip";
                    }
                    switch (Xt.kind) {
                      case 267:
                        if (Xt.isTypeOnly)
                          return _i.push(ia(Za, e2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "import type")), "skip";
                        break;
                      case 272:
                        if (Xt.isTypeOnly)
                          return _i.push(ia(Xt, e2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, "export type")), "skip";
                        break;
                      case 270:
                      case 275:
                        if (Xt.isTypeOnly)
                          return _i.push(ia(Xt, e2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, e2.isImportSpecifier(Xt) ? "import...type" : "export...type")), "skip";
                        break;
                      case 265:
                        return _i.push(ia(Xt, e2.Diagnostics.import_can_only_be_used_in_TypeScript_files)), "skip";
                      case 271:
                        if (Xt.isExportEquals)
                          return _i.push(ia(Xt, e2.Diagnostics.export_can_only_be_used_in_TypeScript_files)), "skip";
                        break;
                      case 291:
                        var bn = Xt;
                        if (bn.token === 117)
                          return _i.push(ia(Xt, e2.Diagnostics.implements_clauses_can_only_be_used_in_TypeScript_files)), "skip";
                        break;
                      case 258:
                        var _a4 = e2.tokenToString(118);
                        return e2.Debug.assertIsDefined(_a4), _i.push(ia(Xt, e2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, _a4)), "skip";
                      case 261:
                        var qa = Xt.flags & 16 ? e2.tokenToString(142) : e2.tokenToString(141);
                        return e2.Debug.assertIsDefined(qa), _i.push(ia(Xt, e2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, qa)), "skip";
                      case 259:
                        return _i.push(ia(Xt, e2.Diagnostics.Type_aliases_can_only_be_used_in_TypeScript_files)), "skip";
                      case 260:
                        var rn = e2.Debug.checkDefined(e2.tokenToString(92));
                        return _i.push(ia(Xt, e2.Diagnostics._0_declarations_can_only_be_used_in_TypeScript_files, rn)), "skip";
                      case 230:
                        return _i.push(ia(Xt, e2.Diagnostics.Non_null_assertions_can_only_be_used_in_TypeScript_files)), "skip";
                      case 229:
                        return _i.push(ia(Xt.type, e2.Diagnostics.Type_assertion_expressions_can_only_be_used_in_TypeScript_files)), "skip";
                      case 211:
                        e2.Debug.fail();
                    }
                  }
                  function tt(Xt, Za) {
                    switch (Za.decorators === Xt && !de.experimentalDecorators && _i.push(ia(Za, e2.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning)), Za.kind) {
                      case 257:
                      case 226:
                      case 169:
                      case 171:
                      case 172:
                      case 173:
                      case 213:
                      case 256:
                      case 214:
                        if (Xt === Za.typeParameters)
                          return _i.push(bt(Xt, e2.Diagnostics.Type_parameter_declarations_can_only_be_used_in_TypeScript_files)), "skip";
                      case 237:
                        if (Xt === Za.modifiers)
                          return kt(Za.modifiers, Za.kind === 237), "skip";
                        break;
                      case 167:
                        if (Xt === Za.modifiers) {
                          for (var bn = 0, _a4 = Xt; bn < _a4.length; bn++) {
                            var qa = _a4[bn];
                            qa.kind !== 124 && _i.push(ia(qa, e2.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, e2.tokenToString(qa.kind)));
                          }
                          return "skip";
                        }
                        break;
                      case 164:
                        if (Xt === Za.modifiers)
                          return _i.push(bt(Xt, e2.Diagnostics.Parameter_modifiers_can_only_be_used_in_TypeScript_files)), "skip";
                        break;
                      case 208:
                      case 209:
                      case 228:
                      case 279:
                      case 280:
                      case 210:
                        if (Xt === Za.typeArguments)
                          return _i.push(bt(Xt, e2.Diagnostics.Type_arguments_can_only_be_used_in_TypeScript_files)), "skip";
                        break;
                    }
                  }
                  function kt(Xt, Za) {
                    for (var bn = 0, _a4 = Xt; bn < _a4.length; bn++) {
                      var qa = _a4[bn];
                      switch (qa.kind) {
                        case 85:
                          if (Za)
                            continue;
                        case 123:
                        case 121:
                        case 122:
                        case 145:
                        case 135:
                        case 126:
                        case 159:
                        case 101:
                        case 144:
                          _i.push(ia(qa, e2.Diagnostics.The_0_modifier_can_only_be_used_in_TypeScript_files, e2.tokenToString(qa.kind)));
                          break;
                        case 124:
                        case 93:
                        case 88:
                      }
                    }
                  }
                  function bt(Xt, Za, bn, _a4, qa) {
                    var rn = Xt.pos;
                    return e2.createFileDiagnostic(Kr, rn, Xt.end - rn, Za, bn, _a4, qa);
                  }
                  function ia(Xt, Za, bn, _a4, qa) {
                    return e2.createDiagnosticForNodeInSourceFile(Kr, Xt, Za, bn, _a4, qa);
                  }
                });
              }
              function Gr(Kr, _i) {
                return Ce(Kr, _i, ur, S2);
              }
              function S2(Kr, _i) {
                return no(function() {
                  var Ei = xn().getEmitResolver(Kr, _i);
                  return e2.getDeclarationDiagnostics(ai(e2.noop), Ei, Kr) || e2.emptyArray;
                });
              }
              function Ce(Kr, _i, Ei, tt) {
                var kt, bt = Kr ? (kt = Ei.perFile) === null || kt === void 0 ? void 0 : kt.get(Kr.path) : Ei.allDiagnostics;
                if (bt)
                  return bt;
                var ia = tt(Kr, _i);
                return Kr ? (Ei.perFile || (Ei.perFile = new e2.Map())).set(Kr.path, ia) : Ei.allDiagnostics = ia, ia;
              }
              function qe(Kr, _i) {
                return Kr.isDeclarationFile ? [] : Gr(Kr, _i);
              }
              function br() {
                return e2.sortAndDeduplicateDiagnostics(e2.concatenate(wi.getGlobalDiagnostics(), Zr()));
              }
              function Zr() {
                if (!de.configFile)
                  return e2.emptyArray;
                var Kr = wi.getDiagnostics(de.configFile.fileName);
                return Ji(function(_i) {
                  Kr = e2.concatenate(Kr, wi.getDiagnostics(_i.sourceFile.fileName));
                }), Kr;
              }
              function Si() {
                return we.length ? e2.sortAndDeduplicateDiagnostics(xn().getGlobalDiagnostics().slice()) : e2.emptyArray;
              }
              function Pi() {
                return ye || e2.emptyArray;
              }
              function Qi(Kr, _i, Ei, tt) {
                Go(e2.normalizePath(Kr), _i, Ei, void 0, tt);
              }
              function Ct(Kr, _i) {
                return Kr.fileName === _i.fileName;
              }
              function sa(Kr, _i) {
                return Kr.kind === 79 ? _i.kind === 79 && Kr.escapedText === _i.escapedText : _i.kind === 10 && Kr.text === _i.text;
              }
              function en(Kr, _i) {
                var Ei = e2.factory.createStringLiteral(Kr), tt = e2.factory.createImportDeclaration(void 0, void 0, void 0, Ei, void 0);
                return e2.addEmitFlags(tt, 67108864), e2.setParent(Ei, tt), e2.setParent(tt, _i), Ei.flags &= -9, tt.flags &= -9, Ei;
              }
              function Wa(Kr) {
                if (Kr.imports)
                  return;
                var _i = e2.isSourceFileJS(Kr), Ei = e2.isExternalModule(Kr), tt, kt, bt;
                if ((de.isolatedModules || Ei) && !Kr.isDeclarationFile) {
                  de.importHelpers && (tt = [en(e2.externalHelpersModuleNameText, Kr)]);
                  var ia = e2.getJSXRuntimeImport(e2.getJSXImplicitImportBase(de, Kr), de);
                  ia && (tt || (tt = [])).push(en(ia, Kr));
                }
                for (var Xt = 0, Za = Kr.statements; Xt < Za.length; Xt++) {
                  var bn = Za[Xt];
                  _a4(bn, false);
                }
                (Kr.flags & 2097152 || _i) && qa(Kr), Kr.imports = tt || e2.emptyArray, Kr.moduleAugmentations = kt || e2.emptyArray, Kr.ambientModuleNames = bt || e2.emptyArray;
                return;
                function _a4(jn, Mo) {
                  if (e2.isAnyImportOrReExport(jn)) {
                    var ho = e2.getExternalModuleName(jn);
                    ho && e2.isStringLiteral(ho) && ho.text && (!Mo || !e2.isExternalModuleNameRelative(ho.text)) && (e2.setParentRecursive(jn, false), tt = e2.append(tt, ho), !Je && Ur === 0 && !Kr.isDeclarationFile && (Je = e2.startsWith(ho.text, "node:")));
                  } else if (e2.isModuleDeclaration(jn) && e2.isAmbientModule(jn) && (Mo || e2.hasSyntacticModifier(jn, 2) || Kr.isDeclarationFile)) {
                    jn.name.parent = jn;
                    var gs = e2.getTextOfIdentifierOrLiteral(jn.name);
                    if (Ei || Mo && !e2.isExternalModuleNameRelative(gs))
                      (kt || (kt = [])).push(jn.name);
                    else if (!Mo) {
                      Kr.isDeclarationFile && (bt || (bt = [])).push(gs);
                      var Se = jn.body;
                      if (Se)
                        for (var hr = 0, Or = Se.statements; hr < Or.length; hr++) {
                          var ki = Or[hr];
                          _a4(ki, true);
                        }
                    }
                  }
                }
                function qa(jn) {
                  for (var Mo = /import|require/g; Mo.exec(jn.text) !== null; ) {
                    var ho = rn(jn, Mo.lastIndex);
                    _i && e2.isRequireCall(ho, true) || e2.isImportCall(ho) && ho.arguments.length >= 1 && e2.isStringLiteralLike(ho.arguments[0]) ? (e2.setParentRecursive(ho, false), tt = e2.append(tt, ho.arguments[0])) : e2.isLiteralImportTypeNode(ho) && (e2.setParentRecursive(ho, false), tt = e2.append(tt, ho.argument.literal));
                  }
                }
                function rn(jn, Mo) {
                  for (var ho = jn, gs = function(hr) {
                    if (hr.pos <= Mo && (Mo < hr.end || Mo === hr.end && hr.kind === 1))
                      return hr;
                  }; ; ) {
                    var Se = _i && e2.hasJSDocNodes(ho) && e2.forEach(ho.jsDoc, gs) || e2.forEachChild(ho, gs);
                    if (!Se)
                      return ho;
                    ho = Se;
                  }
                }
              }
              function qn(Kr) {
                var _i = e2.toFileNameLowerCase(Kr.fileName), Ei = e2.libMap.get(_i);
                if (Ei)
                  return Rn(Pt(Ei));
              }
              function mo(Kr, _i) {
                return So(C(_i.fileName, Kr.fileName), Rn);
              }
              function So(Kr, _i, Ei, tt) {
                if (e2.hasExtension(Kr)) {
                  var kt = pe.getCanonicalFileName(Kr);
                  if (!de.allowNonTsExtensions && !e2.forEach(e2.flatten(Gi), function(bn) {
                    return e2.fileExtensionIs(kt, bn);
                  })) {
                    Ei && (e2.hasJSFileExtension(kt) ? Ei(e2.Diagnostics.File_0_is_a_JavaScript_file_Did_you_mean_to_enable_the_allowJs_option, Kr) : Ei(e2.Diagnostics.File_0_has_an_unsupported_extension_The_only_supported_extensions_are_1, Kr, "'" + e2.flatten(et).join("', '") + "'"));
                    return;
                  }
                  var bt = _i(Kr);
                  if (Ei)
                    if (bt)
                      V(tt) && kt === pe.getCanonicalFileName(Da(tt.file).fileName) && Ei(e2.Diagnostics.A_file_cannot_have_a_reference_to_itself);
                    else {
                      var ia = ps(Kr);
                      ia ? Ei(e2.Diagnostics.Output_file_0_has_not_been_built_from_source_file_1, ia, Kr) : Ei(e2.Diagnostics.File_0_not_found, Kr);
                    }
                  return bt;
                } else {
                  var Xt = de.allowNonTsExtensions && _i(Kr);
                  if (Xt)
                    return Xt;
                  if (Ei && de.allowNonTsExtensions) {
                    Ei(e2.Diagnostics.File_0_not_found, Kr);
                    return;
                  }
                  var Za = e2.forEach(et[0], function(bn) {
                    return _i(Kr + bn);
                  });
                  return Ei && !Za && Ei(e2.Diagnostics.Could_not_resolve_the_path_0_with_the_extensions_Colon_1, Kr, "'" + e2.flatten(et).join("', '") + "'"), Za;
                }
              }
              function Go(Kr, _i, Ei, tt, kt) {
                So(Kr, function(bt) {
                  return Kc(bt, _i, Ei, kt, tt);
                }, function(bt) {
                  for (var ia = [], Xt = 1; Xt < arguments.length; Xt++)
                    ia[Xt - 1] = arguments[Xt];
                  return ko(void 0, kt, bt, ia);
                }, kt);
              }
              function ys(Kr, _i) {
                return Go(Kr, false, false, void 0, _i);
              }
              function Pc(Kr, _i, Ei) {
                var tt = !V(Ei) && e2.some(be.get(_i.path), V);
                tt ? ko(_i, Ei, e2.Diagnostics.Already_included_file_name_0_differs_from_file_name_1_only_in_casing, [_i.fileName, Kr]) : ko(_i, Ei, e2.Diagnostics.File_name_0_differs_from_already_included_file_name_1_only_in_casing, [Kr, _i.fileName]);
              }
              function Vc(Kr, _i, Ei, tt, kt, bt) {
                var ia = Object.create(Kr);
                return ia.fileName = Ei, ia.path = tt, ia.resolvedPath = kt, ia.originalFileName = bt, ia.redirectInfo = { redirectTarget: Kr, unredirected: _i }, mi.set(tt, Ur > 0), Object.defineProperties(ia, { id: { get: function() {
                  return this.redirectInfo.redirectTarget.id;
                }, set: function(Xt) {
                  this.redirectInfo.redirectTarget.id = Xt;
                } }, symbol: { get: function() {
                  return this.redirectInfo.redirectTarget.symbol;
                }, set: function(Xt) {
                  this.redirectInfo.redirectTarget.symbol = Xt;
                } } }), ia;
              }
              function Kc(Kr, _i, Ei, tt, kt) {
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "findSourceFile", { fileName: Kr, isDefaultLib: _i || void 0, fileIncludeKind: e2.FileIncludeKind[tt.kind] });
                var bt = pc(Kr, _i, Ei, tt, kt);
                return e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop(), bt;
              }
              function Xs(Kr, _i, Ei, tt) {
                var kt = U(Vi(Kr), _i == null ? void 0 : _i.getPackageJsonInfoCache(), Ei, tt);
                return { languageVersion: e2.getEmitScriptTarget(tt), impliedNodeFormat: kt, setExternalModuleIndicator: e2.getSetExternalModuleIndicator(tt) };
              }
              function pc(Kr, _i, Ei, tt, kt) {
                var bt = Vi(Kr);
                if (Pe) {
                  var ia = ce(bt);
                  if (!ia && pe.realpath && de.preserveSymlinks && e2.isDeclarationFileName(Kr) && e2.stringContains(Kr, e2.nodeModulesPathPart)) {
                    var Xt = Vi(pe.realpath(Kr));
                    Xt !== bt && (ia = ce(Xt));
                  }
                  if (ia) {
                    var Za = e2.isString(ia) ? Kc(ia, _i, Ei, tt, kt) : void 0;
                    return Za && tc(Za, bt, void 0), Za;
                  }
                }
                var bn = Kr;
                if (xe.has(bt)) {
                  var _a4 = xe.get(bt);
                  if (hs(_a4 || void 0, tt), _a4 && de.forceConsistentCasingInFileNames) {
                    var qa = _a4.fileName, rn = Vi(qa) !== Vi(Kr);
                    rn && (Kr = ps(Kr) || Kr);
                    var jn = e2.getNormalizedAbsolutePathWithoutRoot(qa, Xi), Mo = e2.getNormalizedAbsolutePathWithoutRoot(Kr, Xi);
                    jn !== Mo && Pc(Kr, _a4, tt);
                  }
                  return _a4 && mi.get(_a4.path) && Ur === 0 ? (mi.set(_a4.path, false), de.noResolve || (qi(_a4, _i), je(_a4)), de.noLib || ga(_a4), ii.set(_a4.path, false), Xn(_a4)) : _a4 && ii.get(_a4.path) && Ur < wr && (ii.set(_a4.path, false), Xn(_a4)), _a4 || void 0;
                }
                var ho;
                if (V(tt) && !Pe) {
                  var gs = Qs(Kr);
                  if (gs) {
                    if (e2.outFile(gs.commandLine.options))
                      return;
                    var Se = js(gs, Kr);
                    Kr = Se, ho = Vi(Se);
                  }
                }
                var hr = pe.getSourceFile(Kr, Xs(Kr, _r, pe, de), function(On) {
                  return ko(void 0, tt, e2.Diagnostics.Cannot_read_file_0_Colon_1, [Kr, On]);
                }, Tr);
                if (kt) {
                  var Or = e2.packageIdToString(kt), ki = Sr.get(Or);
                  if (ki) {
                    var dt = Vc(ki, hr, Kr, bt, Vi(Kr), bn);
                    return Wr.add(ki.path, Kr), tc(dt, bt, ho), hs(dt, tt), zr.set(bt, e2.packageIdToPackageName(kt)), Cr.push(dt), dt;
                  } else
                    hr && (Sr.set(Or, hr), zr.set(bt, e2.packageIdToPackageName(kt)));
                }
                if (tc(hr, bt, ho), hr) {
                  if (mi.set(bt, Ur > 0), hr.fileName = Kr, hr.path = bt, hr.resolvedPath = Vi(Kr), hr.originalFileName = bn, hs(hr, tt), pe.useCaseSensitiveFileNames()) {
                    var la = e2.toFileNameLowerCase(bt), wa = mr.get(la);
                    wa ? Pc(Kr, wa, tt) : mr.set(la, hr);
                  }
                  qr = qr || hr.hasNoDefaultLib && !Ei, de.noResolve || (qi(hr, _i), je(hr)), de.noLib || ga(hr), Xn(hr), _i ? ir.push(hr) : Cr.push(hr);
                }
                return hr;
              }
              function hs(Kr, _i) {
                Kr && be.add(Kr.path, _i);
              }
              function tc(Kr, _i, Ei) {
                Ei ? (xe.set(Ei, Kr), xe.set(_i, Kr || false)) : xe.set(_i, Kr);
              }
              function ps(Kr) {
                var _i = Qs(Kr);
                return _i && js(_i, Kr);
              }
              function Qs(Kr) {
                if (!(!Ar || !Ar.length || e2.isDeclarationFileName(Kr) || e2.fileExtensionIs(Kr, ".json")))
                  return ds(Kr);
              }
              function js(Kr, _i) {
                var Ei = e2.outFile(Kr.commandLine.options);
                return Ei ? e2.changeExtension(Ei, ".d.ts") : e2.getOutputDeclarationFileName(_i, Kr.commandLine, !pe.useCaseSensitiveFileNames());
              }
              function ds(Kr) {
                nr === void 0 && (nr = new e2.Map(), Ji(function(Ei) {
                  Vi(de.configFilePath) !== Ei.sourceFile.path && Ei.commandLine.fileNames.forEach(function(tt) {
                    return nr.set(Vi(tt), Ei.sourceFile.path);
                  });
                }));
                var _i = nr.get(Vi(Kr));
                return _i && yi(_i);
              }
              function Ji(Kr) {
                return e2.forEachResolvedProjectReference(Ar, Kr);
              }
              function ce(Kr) {
                if (!!e2.isDeclarationFileName(Kr))
                  return Mr === void 0 && (Mr = new e2.Map(), Ji(function(_i) {
                    var Ei = e2.outFile(_i.commandLine.options);
                    if (Ei) {
                      var tt = e2.changeExtension(Ei, ".d.ts");
                      Mr.set(Vi(tt), true);
                    } else {
                      var kt = e2.memoize(function() {
                        return e2.getCommonSourceDirectoryOfConfig(_i.commandLine, !pe.useCaseSensitiveFileNames());
                      });
                      e2.forEach(_i.commandLine.fileNames, function(bt) {
                        if (!e2.isDeclarationFileName(bt) && !e2.fileExtensionIs(bt, ".json")) {
                          var ia = e2.getOutputDeclarationFileName(bt, _i.commandLine, !pe.useCaseSensitiveFileNames(), kt);
                          Mr.set(Vi(ia), bt);
                        }
                      });
                    }
                  })), Mr.get(Kr);
              }
              function Rr(Kr) {
                return Pe && !!ds(Kr);
              }
              function yi(Kr) {
                if (!!Oe)
                  return Oe.get(Kr) || void 0;
              }
              function qi(Kr, _i) {
                e2.forEach(Kr.referencedFiles, function(Ei, tt) {
                  Go(C(Ei.fileName, Kr.fileName), _i, false, void 0, { kind: e2.FileIncludeKind.ReferenceFile, file: Kr.path, index: tt });
                });
              }
              function je(Kr) {
                var _i = Kr.typeReferenceDirectives;
                if (!!_i)
                  for (var Ei = Bt(_i, Kr), tt = 0; tt < _i.length; tt++) {
                    var kt = Kr.typeReferenceDirectives[tt], bt = Ei[tt], ia = e2.toFileNameLowerCase(kt.fileName);
                    e2.setResolvedTypeReferenceDirective(Kr, ia, bt);
                    var Xt = kt.resolutionMode || Kr.impliedNodeFormat;
                    Xt && e2.getEmitModuleResolutionKind(de) !== e2.ModuleResolutionKind.Node16 && e2.getEmitModuleResolutionKind(de) !== e2.ModuleResolutionKind.NodeNext && wi.add(e2.createDiagnosticForRange(Kr, kt, e2.Diagnostics.Resolution_modes_are_only_supported_when_moduleResolution_is_node16_or_nodenext)), Hr(ia, Xt, bt, { kind: e2.FileIncludeKind.TypeReferenceDirective, file: Kr.path, index: tt });
                  }
              }
              function Hr(Kr, _i, Ei, tt) {
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("program", "processTypeReferenceDirective", { directive: Kr, hasResolved: !!ba, refKind: tt.kind, refPath: V(tt) ? tt.file : void 0 }), pt(Kr, _i, Ei, tt), e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
              }
              function pt(Kr, _i, Ei, tt) {
                var kt = yr.get(Kr, _i);
                if (!(kt && kt.primary)) {
                  var bt = true;
                  if (Ei) {
                    if (Ei.isExternalLibraryImport && Ur++, Ei.primary)
                      Go(Ei.resolvedFileName, false, false, Ei.packageId, tt);
                    else if (kt) {
                      if (Ei.resolvedFileName !== kt.resolvedFileName) {
                        var ia = pe.readFile(Ei.resolvedFileName), Xt = Rn(kt.resolvedFileName);
                        ia !== Xt.text && ko(Xt, tt, e2.Diagnostics.Conflicting_definitions_for_0_found_at_1_and_2_Consider_installing_a_specific_version_of_this_library_to_resolve_the_conflict, [Kr, Ei.resolvedFileName, kt.resolvedFileName]);
                      }
                      bt = false;
                    } else
                      Go(Ei.resolvedFileName, false, false, Ei.packageId, tt);
                    Ei.isExternalLibraryImport && Ur--;
                  } else
                    ko(void 0, tt, e2.Diagnostics.Cannot_find_type_definition_file_for_0, [Kr]);
                  bt && yr.set(Kr, _i, Ei);
                }
              }
              function Pt(Kr) {
                for (var _i = Kr.split("."), Ei = _i[1], tt = 2; _i[tt] && _i[tt] !== "d"; )
                  Ei += (tt === 2 ? "/" : "-") + _i[tt], tt++;
                var kt = e2.combinePaths(Xi, "__lib_node_modules_lookup_".concat(Kr, "__.ts")), bt = e2.resolveModuleName("@typescript/lib-" + Ei, kt, { moduleResolution: e2.ModuleResolutionKind.NodeJs }, pe, _r);
                return bt != null && bt.resolvedModule ? bt.resolvedModule.resolvedFileName : e2.combinePaths(Di, Kr);
              }
              function ga(Kr) {
                e2.forEach(Kr.libReferenceDirectives, function(_i, Ei) {
                  var tt = e2.toFileNameLowerCase(_i.fileName), kt = e2.libMap.get(tt);
                  if (kt)
                    Qi(Pt(kt), true, true, { kind: e2.FileIncludeKind.LibReferenceDirective, file: Kr.path, index: Ei });
                  else {
                    var bt = e2.removeSuffix(e2.removePrefix(tt, "lib."), ".d.ts"), ia = e2.getSpellingSuggestion(bt, e2.libs, e2.identity), Xt = ia ? e2.Diagnostics.Cannot_find_lib_definition_for_0_Did_you_mean_1 : e2.Diagnostics.Cannot_find_lib_definition_for_0;
                    (Ir || (Ir = [])).push({ kind: 0, reason: { kind: e2.FileIncludeKind.LibReferenceDirective, file: Kr.path, index: Ei }, diagnostic: Xt, args: [tt, ia] });
                  }
                });
              }
              function ua(Kr) {
                return pe.getCanonicalFileName(Kr);
              }
              function Xn(Kr) {
                var _i;
                if (Wa(Kr), Kr.imports.length || Kr.moduleAugmentations.length) {
                  var Ei = We(Kr), tt = ba(Ei, Kr);
                  e2.Debug.assert(tt.length === Ei.length);
                  for (var kt = (Pe ? (_i = wt(Kr)) === null || _i === void 0 ? void 0 : _i.commandLine.options : void 0) || de, bt = 0; bt < Ei.length; bt++) {
                    var ia = tt[bt];
                    if (e2.setResolvedModule(Kr, Ei[bt], ia, he(Kr, bt)), !!ia) {
                      var Xt = ia.isExternalLibraryImport, Za = !e2.resolutionExtensionIsTSOrJson(ia.extension), bn = Xt && Za, _a4 = ia.resolvedFileName;
                      Xt && Ur++;
                      var qa = bn && Ur > wr, rn = _a4 && !ue(kt, ia) && !kt.noResolve && bt < Kr.imports.length && !qa && !(Za && !e2.getAllowJSCompilerOption(kt)) && (e2.isInJSFile(Kr.imports[bt]) || !(Kr.imports[bt].flags & 8388608));
                      qa ? ii.set(Kr.path, true) : rn && Kc(_a4, false, false, { kind: e2.FileIncludeKind.Import, file: Kr.path, index: bt }, ia.packageId), Xt && Ur--;
                    }
                  }
                } else
                  Kr.resolvedModules = void 0;
              }
              function jr(Kr, _i) {
                for (var Ei = true, tt = pe.getCanonicalFileName(e2.getNormalizedAbsolutePath(_i, Xi)), kt = 0, bt = Kr; kt < bt.length; kt++) {
                  var ia = bt[kt];
                  if (!ia.isDeclarationFile) {
                    var Xt = pe.getCanonicalFileName(e2.getNormalizedAbsolutePath(ia.fileName, Xi));
                    Xt.indexOf(tt) !== 0 && (Ao(ia, e2.Diagnostics.File_0_is_not_under_rootDir_1_rootDir_is_expected_to_contain_all_source_files, [ia.fileName, _i]), Ei = false);
                  }
                }
                return Ei;
              }
              function fo(Kr) {
                Oe || (Oe = new e2.Map());
                var _i = ne(Kr), Ei = Vi(_i), tt = Oe.get(Ei);
                if (tt !== void 0)
                  return tt || void 0;
                var kt, bt;
                if (pe.getParsedCommandLine) {
                  if (kt = pe.getParsedCommandLine(_i), !kt) {
                    tc(void 0, Ei, void 0), Oe.set(Ei, false);
                    return;
                  }
                  bt = e2.Debug.checkDefined(kt.options.configFile), e2.Debug.assert(!bt.path || bt.path === Ei), tc(bt, Ei, void 0);
                } else {
                  var ia = e2.getNormalizedAbsolutePath(e2.getDirectoryPath(_i), pe.getCurrentDirectory());
                  if (bt = pe.getSourceFile(_i, 100), tc(bt, Ei, void 0), bt === void 0) {
                    Oe.set(Ei, false);
                    return;
                  }
                  kt = e2.parseJsonSourceFileConfigFileContent(bt, or, ia, void 0, _i);
                }
                bt.fileName = _i, bt.path = Ei, bt.resolvedPath = Ei, bt.originalFileName = _i;
                var Xt = { commandLine: kt, sourceFile: bt };
                return Oe.set(Ei, Xt), kt.projectReferences && (Xt.references = kt.projectReferences.map(fo)), Xt;
              }
              function xs() {
                de.strictPropertyInitialization && !e2.getStrictOptionValue(de, "strictNullChecks") && Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "strictPropertyInitialization", "strictNullChecks"), de.exactOptionalPropertyTypes && !e2.getStrictOptionValue(de, "strictNullChecks") && Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "exactOptionalPropertyTypes", "strictNullChecks"), de.isolatedModules && (de.out && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "isolatedModules"), de.outFile && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "outFile", "isolatedModules")), de.inlineSourceMap && (de.sourceMap && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "sourceMap", "inlineSourceMap"), de.mapRoot && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "mapRoot", "inlineSourceMap")), de.composite && (de.declaration === false && Jo(e2.Diagnostics.Composite_projects_may_not_disable_declaration_emit, "declaration"), de.incremental === false && Jo(e2.Diagnostics.Composite_projects_may_not_disable_incremental_compilation, "declaration"));
                var Kr = e2.outFile(de);
                if (de.tsBuildInfoFile ? e2.isIncrementalCompilation(de) || Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "tsBuildInfoFile", "incremental", "composite") : de.incremental && !Kr && !de.configFilePath && wi.add(e2.createCompilerDiagnostic(e2.Diagnostics.Option_incremental_can_only_be_specified_using_tsconfig_emitting_to_single_file_or_when_option_tsBuildInfoFile_is_specified)), Bs(), de.composite)
                  for (var _i = new e2.Set(we.map(Vi)), Ei = 0, tt = Ye; Ei < tt.length; Ei++) {
                    var kt = tt[Ei];
                    e2.sourceFileMayBeEmitted(kt, Ii) && !_i.has(kt.path) && Ao(kt, e2.Diagnostics.File_0_is_not_listed_within_the_file_list_of_project_1_Projects_must_list_all_files_or_use_an_include_pattern, [kt.fileName, de.configFilePath || ""]);
                  }
                if (de.paths) {
                  for (var bt in de.paths)
                    if (!!e2.hasProperty(de.paths, bt))
                      if (e2.hasZeroOrOneAsteriskCharacter(bt) || su(true, bt, e2.Diagnostics.Pattern_0_can_have_at_most_one_Asterisk_character, bt), e2.isArray(de.paths[bt])) {
                        var ia = de.paths[bt].length;
                        ia === 0 && su(false, bt, e2.Diagnostics.Substitutions_for_pattern_0_shouldn_t_be_an_empty_array, bt);
                        for (var Xt = 0; Xt < ia; Xt++) {
                          var Za = de.paths[bt][Xt], bn = typeof Za;
                          bn === "string" ? (e2.hasZeroOrOneAsteriskCharacter(Za) || xc(bt, Xt, e2.Diagnostics.Substitution_0_in_pattern_1_can_have_at_most_one_Asterisk_character, Za, bt), !de.baseUrl && !e2.pathIsRelative(Za) && !e2.pathIsAbsolute(Za) && xc(bt, Xt, e2.Diagnostics.Non_relative_paths_are_not_allowed_when_baseUrl_is_not_set_Did_you_forget_a_leading_Slash)) : xc(bt, Xt, e2.Diagnostics.Substitution_0_for_pattern_1_has_incorrect_type_expected_string_got_2, Za, bt, bn);
                        }
                      } else
                        su(false, bt, e2.Diagnostics.Substitutions_for_pattern_0_should_be_an_array, bt);
                }
                !de.sourceMap && !de.inlineSourceMap && (de.inlineSources && Jo(e2.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "inlineSources"), de.sourceRoot && Jo(e2.Diagnostics.Option_0_can_only_be_used_when_either_option_inlineSourceMap_or_option_sourceMap_is_provided, "sourceRoot")), de.out && de.outFile && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "out", "outFile"), de.mapRoot && !(de.sourceMap || de.declarationMap) && Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "mapRoot", "sourceMap", "declarationMap"), de.declarationDir && (e2.getEmitDeclarations(de) || Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationDir", "declaration", "composite"), Kr && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "declarationDir", de.out ? "out" : "outFile")), de.declarationMap && !e2.getEmitDeclarations(de) && Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "declarationMap", "declaration", "composite"), de.lib && de.noLib && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "lib", "noLib"), de.noImplicitUseStrict && e2.getStrictOptionValue(de, "alwaysStrict") && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "noImplicitUseStrict", "alwaysStrict");
                var _a4 = e2.getEmitScriptTarget(de), qa = e2.find(Ye, function(hr) {
                  return e2.isExternalModule(hr) && !hr.isDeclarationFile;
                });
                if (de.isolatedModules) {
                  de.module === e2.ModuleKind.None && _a4 < 2 && Jo(e2.Diagnostics.Option_isolatedModules_can_only_be_used_when_either_option_module_is_provided_or_option_target_is_ES2015_or_higher, "isolatedModules", "target"), de.preserveConstEnums === false && Jo(e2.Diagnostics.Option_preserveConstEnums_cannot_be_disabled_when_isolatedModules_is_enabled, "preserveConstEnums", "isolatedModules");
                  var rn = e2.find(Ye, function(hr) {
                    return !e2.isExternalModule(hr) && !e2.isSourceFileJS(hr) && !hr.isDeclarationFile && hr.scriptKind !== 6;
                  });
                  if (rn) {
                    var jn = e2.getErrorSpanForNode(rn, rn);
                    wi.add(e2.createFileDiagnostic(rn, jn.start, jn.length, e2.Diagnostics._0_cannot_be_compiled_under_isolatedModules_because_it_is_considered_a_global_script_file_Add_an_import_export_or_an_empty_export_statement_to_make_it_a_module, e2.getBaseFileName(rn.fileName)));
                  }
                } else if (qa && _a4 < 2 && de.module === e2.ModuleKind.None) {
                  var jn = e2.getErrorSpanForNode(qa, typeof qa.externalModuleIndicator == "boolean" ? qa : qa.externalModuleIndicator);
                  wi.add(e2.createFileDiagnostic(qa, jn.start, jn.length, e2.Diagnostics.Cannot_use_imports_exports_or_module_augmentations_when_module_is_none));
                }
                if (Kr && !de.emitDeclarationOnly) {
                  if (de.module && !(de.module === e2.ModuleKind.AMD || de.module === e2.ModuleKind.System))
                    Jo(e2.Diagnostics.Only_amd_and_system_modules_are_supported_alongside_0, de.out ? "out" : "outFile", "module");
                  else if (de.module === void 0 && qa) {
                    var jn = e2.getErrorSpanForNode(qa, typeof qa.externalModuleIndicator == "boolean" ? qa : qa.externalModuleIndicator);
                    wi.add(e2.createFileDiagnostic(qa, jn.start, jn.length, e2.Diagnostics.Cannot_compile_modules_using_option_0_unless_the_module_flag_is_amd_or_system, de.out ? "out" : "outFile"));
                  }
                }
                if (de.resolveJsonModule && (e2.getEmitModuleResolutionKind(de) !== e2.ModuleResolutionKind.NodeJs && e2.getEmitModuleResolutionKind(de) !== e2.ModuleResolutionKind.Node16 && e2.getEmitModuleResolutionKind(de) !== e2.ModuleResolutionKind.NodeNext ? Jo(e2.Diagnostics.Option_resolveJsonModule_cannot_be_specified_without_node_module_resolution_strategy, "resolveJsonModule") : e2.hasJsonModuleEmitEnabled(de) || Jo(e2.Diagnostics.Option_resolveJsonModule_can_only_be_specified_when_module_code_generation_is_commonjs_amd_es2015_or_esNext, "resolveJsonModule", "module")), de.outDir || de.rootDir || de.sourceRoot || de.mapRoot) {
                  var Mo = at();
                  de.outDir && Mo === "" && Ye.some(function(hr) {
                    return e2.getRootLength(hr.fileName) > 1;
                  }) && Jo(e2.Diagnostics.Cannot_find_the_common_subdirectory_path_for_the_input_files, "outDir");
                }
                if (de.useDefineForClassFields && _a4 === 0 && Jo(e2.Diagnostics.Option_0_cannot_be_specified_when_option_target_is_ES3, "useDefineForClassFields"), de.checkJs && !e2.getAllowJSCompilerOption(de) && wi.add(e2.createCompilerDiagnostic(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "checkJs", "allowJs")), de.emitDeclarationOnly && (e2.getEmitDeclarations(de) || Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1_or_option_2, "emitDeclarationOnly", "declaration", "composite"), de.noEmit && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "emitDeclarationOnly", "noEmit")), de.emitDecoratorMetadata && !de.experimentalDecorators && Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "emitDecoratorMetadata", "experimentalDecorators"), de.jsxFactory ? (de.reactNamespace && Jo(e2.Diagnostics.Option_0_cannot_be_specified_with_option_1, "reactNamespace", "jsxFactory"), (de.jsx === 4 || de.jsx === 5) && Jo(e2.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFactory", e2.inverseJsxOptionMap.get("" + de.jsx)), e2.parseIsolatedEntityName(de.jsxFactory, _a4) || eu("jsxFactory", e2.Diagnostics.Invalid_value_for_jsxFactory_0_is_not_a_valid_identifier_or_qualified_name, de.jsxFactory)) : de.reactNamespace && !e2.isIdentifierText(de.reactNamespace, _a4) && eu("reactNamespace", e2.Diagnostics.Invalid_value_for_reactNamespace_0_is_not_a_valid_identifier, de.reactNamespace), de.jsxFragmentFactory && (de.jsxFactory || Jo(e2.Diagnostics.Option_0_cannot_be_specified_without_specifying_option_1, "jsxFragmentFactory", "jsxFactory"), (de.jsx === 4 || de.jsx === 5) && Jo(e2.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxFragmentFactory", e2.inverseJsxOptionMap.get("" + de.jsx)), e2.parseIsolatedEntityName(de.jsxFragmentFactory, _a4) || eu("jsxFragmentFactory", e2.Diagnostics.Invalid_value_for_jsxFragmentFactory_0_is_not_a_valid_identifier_or_qualified_name, de.jsxFragmentFactory)), de.reactNamespace && (de.jsx === 4 || de.jsx === 5) && Jo(e2.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "reactNamespace", e2.inverseJsxOptionMap.get("" + de.jsx)), de.jsxImportSource && de.jsx === 2 && Jo(e2.Diagnostics.Option_0_cannot_be_specified_when_option_jsx_is_1, "jsxImportSource", e2.inverseJsxOptionMap.get("" + de.jsx)), de.preserveValueImports && e2.getEmitModuleKind(de) < e2.ModuleKind.ES2015 && eu("importsNotUsedAsValues", e2.Diagnostics.Option_preserveValueImports_can_only_be_used_when_module_is_set_to_es2015_or_later), !de.noEmit && !de.suppressOutputPathCheck) {
                  var ho = ai(), gs = new e2.Set();
                  e2.forEachEmittedFile(ho, function(hr) {
                    de.emitDeclarationOnly || Se(hr.jsFilePath, gs), Se(hr.declarationFilePath, gs);
                  });
                }
                function Se(hr, Or) {
                  if (hr) {
                    var ki = Vi(hr);
                    if (xe.has(ki)) {
                      var dt = void 0;
                      de.configFilePath || (dt = e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Adding_a_tsconfig_json_file_will_help_organize_projects_that_contain_both_TypeScript_and_JavaScript_files_Learn_more_at_https_Colon_Slash_Slashaka_ms_Slashtsconfig)), dt = e2.chainDiagnosticMessages(dt, e2.Diagnostics.Cannot_write_file_0_because_it_would_overwrite_input_file, hr), xl(hr, e2.createCompilerDiagnosticFromMessageChain(dt));
                    }
                    var la = pe.useCaseSensitiveFileNames() ? ki : e2.toFileNameLowerCase(ki);
                    Or.has(la) ? xl(hr, e2.createCompilerDiagnostic(e2.Diagnostics.Cannot_write_file_0_because_it_would_be_overwritten_by_multiple_input_files, hr)) : Or.add(la);
                  }
                }
              }
              function Fo(Kr, _i, Ei, tt) {
                var kt, bt, ia, Xt = V(_i) ? _i : void 0;
                Kr && ((kt = be.get(Kr.path)) === null || kt === void 0 || kt.forEach(rn)), _i && rn(_i), Xt && (bt == null ? void 0 : bt.length) === 1 && (bt = void 0);
                var Za = Xt && P(Da, Xt), bn = bt && e2.chainDiagnosticMessages(bt, e2.Diagnostics.The_file_is_in_the_program_because_Colon), _a4 = Kr && e2.explainIfFileIsRedirect(Kr), qa = e2.chainDiagnosticMessages.apply(void 0, Ve([_a4 ? bn ? Ve([bn], _a4, true) : _a4 : bn, Ei], tt || e2.emptyArray, false));
                return Za && L(Za) ? e2.createFileDiagnosticFromMessageChain(Za.file, Za.pos, Za.end - Za.pos, qa, ia) : e2.createCompilerDiagnosticFromMessageChain(qa, ia);
                function rn(jn) {
                  (bt || (bt = [])).push(e2.fileIncludeReasonToDiagnostics(Ii, jn)), !Xt && V(jn) ? Xt = jn : Xt !== jn && (ia = e2.append(ia, Ms(jn))), jn === _i && (_i = void 0);
                }
              }
              function ko(Kr, _i, Ei, tt) {
                (Ir || (Ir = [])).push({ kind: 1, file: Kr && Kr.path, fileProcessingReason: _i, diagnostic: Ei, args: tt });
              }
              function Ao(Kr, _i, Ei) {
                wi.add(Fo(Kr, void 0, _i, Ei));
              }
              function Ms(Kr) {
                if (V(Kr)) {
                  var _i = P(Da, Kr), Ei;
                  switch (Kr.kind) {
                    case e2.FileIncludeKind.Import:
                      Ei = e2.Diagnostics.File_is_included_via_import_here;
                      break;
                    case e2.FileIncludeKind.ReferenceFile:
                      Ei = e2.Diagnostics.File_is_included_via_reference_here;
                      break;
                    case e2.FileIncludeKind.TypeReferenceDirective:
                      Ei = e2.Diagnostics.File_is_included_via_type_library_reference_here;
                      break;
                    case e2.FileIncludeKind.LibReferenceDirective:
                      Ei = e2.Diagnostics.File_is_included_via_library_reference_here;
                      break;
                    default:
                      e2.Debug.assertNever(Kr);
                  }
                  return L(_i) ? e2.createFileDiagnostic(_i.file, _i.pos, _i.end - _i.pos, Ei) : void 0;
                }
                if (!!de.configFile) {
                  var tt, kt;
                  switch (Kr.kind) {
                    case e2.FileIncludeKind.RootFile:
                      if (!de.configFile.configFileSpecs)
                        return;
                      var bt = e2.getNormalizedAbsolutePath(we[Kr.index], Xi), ia = e2.getMatchedFileSpec(Ii, bt);
                      if (ia) {
                        tt = e2.getTsConfigPropArrayElementValue(de.configFile, "files", ia), kt = e2.Diagnostics.File_is_matched_by_files_list_specified_here;
                        break;
                      }
                      var Xt = e2.getMatchedIncludeSpec(Ii, bt);
                      if (!Xt)
                        return;
                      tt = e2.getTsConfigPropArrayElementValue(de.configFile, "include", Xt), kt = e2.Diagnostics.File_is_matched_by_include_pattern_specified_here;
                      break;
                    case e2.FileIncludeKind.SourceFromProjectReference:
                    case e2.FileIncludeKind.OutputFromProjectReference:
                      var Za = e2.Debug.checkDefined(Ar == null ? void 0 : Ar[Kr.index]), bn = y(Ae, Ar, function(Mo, ho, gs) {
                        return Mo === Za ? { sourceFile: (ho == null ? void 0 : ho.sourceFile) || de.configFile, index: gs } : void 0;
                      });
                      if (!bn)
                        return;
                      var _a4 = bn.sourceFile, qa = bn.index, rn = e2.firstDefined(e2.getTsConfigPropArray(_a4, "references"), function(Mo) {
                        return e2.isArrayLiteralExpression(Mo.initializer) ? Mo.initializer : void 0;
                      });
                      return rn && rn.elements.length > qa ? e2.createDiagnosticForNodeInSourceFile(_a4, rn.elements[qa], Kr.kind === e2.FileIncludeKind.OutputFromProjectReference ? e2.Diagnostics.File_is_output_from_referenced_project_specified_here : e2.Diagnostics.File_is_source_from_referenced_project_specified_here) : void 0;
                    case e2.FileIncludeKind.AutomaticTypeDirectiveFile:
                      if (!de.types)
                        return;
                      tt = al("types", Kr.typeReference), kt = e2.Diagnostics.File_is_entry_point_of_type_library_specified_here;
                      break;
                    case e2.FileIncludeKind.LibFile:
                      if (Kr.index !== void 0) {
                        tt = al("lib", de.lib[Kr.index]), kt = e2.Diagnostics.File_is_library_specified_here;
                        break;
                      }
                      var jn = e2.forEachEntry(e2.targetOptionDeclaration.type, function(Mo, ho) {
                        return Mo === e2.getEmitScriptTarget(de) ? ho : void 0;
                      });
                      tt = jn ? Rf("target", jn) : void 0, kt = e2.Diagnostics.File_is_default_library_for_target_specified_here;
                      break;
                    default:
                      e2.Debug.assertNever(Kr);
                  }
                  return tt && e2.createDiagnosticForNodeInSourceFile(de.configFile, tt, kt);
                }
              }
              function Bs() {
                var Kr = de.suppressOutputPathCheck ? void 0 : e2.getTsBuildInfoEmitOutputFilePath(de);
                y(Ae, Ar, function(_i, Ei, tt) {
                  var kt = (Ei ? Ei.commandLine.projectReferences : Ae)[tt], bt = Ei && Ei.sourceFile;
                  if (!_i) {
                    Ws(bt, tt, e2.Diagnostics.File_0_not_found, kt.path);
                    return;
                  }
                  var ia = _i.commandLine.options;
                  if (!ia.composite || ia.noEmit) {
                    var Xt = Ei ? Ei.commandLine.fileNames : we;
                    Xt.length && (ia.composite || Ws(bt, tt, e2.Diagnostics.Referenced_project_0_must_have_setting_composite_Colon_true, kt.path), ia.noEmit && Ws(bt, tt, e2.Diagnostics.Referenced_project_0_may_not_disable_emit, kt.path));
                  }
                  if (kt.prepend) {
                    var Za = e2.outFile(ia);
                    Za ? pe.fileExists(Za) || Ws(bt, tt, e2.Diagnostics.Output_file_0_from_project_1_does_not_exist, Za, kt.path) : Ws(bt, tt, e2.Diagnostics.Cannot_prepend_project_0_because_it_does_not_have_outFile_set, kt.path);
                  }
                  !Ei && Kr && Kr === e2.getTsBuildInfoEmitOutputFilePath(ia) && (Ws(bt, tt, e2.Diagnostics.Cannot_write_file_0_because_it_will_overwrite_tsbuildinfo_file_generated_by_referenced_project_1, Kr, kt.path), Wt.set(Vi(Kr), true));
                });
              }
              function xc(Kr, _i, Ei, tt, kt, bt) {
                for (var ia = true, Xt = Zc(), Za = 0, bn = Xt; Za < bn.length; Za++) {
                  var _a4 = bn[Za];
                  if (e2.isObjectLiteralExpression(_a4.initializer))
                    for (var qa = 0, rn = e2.getPropertyAssignment(_a4.initializer, Kr); qa < rn.length; qa++) {
                      var jn = rn[qa], Mo = jn.initializer;
                      e2.isArrayLiteralExpression(Mo) && Mo.elements.length > _i && (wi.add(e2.createDiagnosticForNodeInSourceFile(de.configFile, Mo.elements[_i], Ei, tt, kt, bt)), ia = false);
                    }
                }
                ia && wi.add(e2.createCompilerDiagnostic(Ei, tt, kt, bt));
              }
              function su(Kr, _i, Ei, tt) {
                for (var kt = true, bt = Zc(), ia = 0, Xt = bt; ia < Xt.length; ia++) {
                  var Za = Xt[ia];
                  e2.isObjectLiteralExpression(Za.initializer) && Ql(Za.initializer, Kr, _i, void 0, Ei, tt) && (kt = false);
                }
                kt && wi.add(e2.createCompilerDiagnostic(Ei, tt));
              }
              function tl(Kr) {
                var _i = Uu();
                return _i && e2.getPropertyAssignment(_i, Kr);
              }
              function Zc() {
                return tl("paths") || e2.emptyArray;
              }
              function Rf(Kr, _i) {
                var Ei = tl(Kr);
                return Ei && e2.firstDefined(Ei, function(tt) {
                  return e2.isStringLiteral(tt.initializer) && tt.initializer.text === _i ? tt.initializer : void 0;
                });
              }
              function al(Kr, _i) {
                var Ei = Uu();
                return Ei && e2.getPropertyArrayElementValue(Ei, Kr, _i);
              }
              function Jo(Kr, _i, Ei, tt) {
                pu(true, _i, Ei, Kr, _i, Ei, tt);
              }
              function eu(Kr, _i, Ei, tt) {
                pu(false, Kr, void 0, _i, Ei, tt);
              }
              function Ws(Kr, _i, Ei, tt, kt) {
                var bt = e2.firstDefined(e2.getTsConfigPropArray(Kr || de.configFile, "references"), function(ia) {
                  return e2.isArrayLiteralExpression(ia.initializer) ? ia.initializer : void 0;
                });
                bt && bt.elements.length > _i ? wi.add(e2.createDiagnosticForNodeInSourceFile(Kr || de.configFile, bt.elements[_i], Ei, tt, kt)) : wi.add(e2.createCompilerDiagnostic(Ei, tt, kt));
              }
              function pu(Kr, _i, Ei, tt, kt, bt, ia) {
                var Xt = Uu(), Za = !Xt || !Ql(Xt, Kr, _i, Ei, tt, kt, bt, ia);
                Za && wi.add(e2.createCompilerDiagnostic(tt, kt, bt, ia));
              }
              function Uu() {
                if (Zt === void 0) {
                  Zt = false;
                  var Kr = e2.getTsConfigObjectLiteralExpression(de.configFile);
                  if (Kr)
                    for (var _i = 0, Ei = e2.getPropertyAssignment(Kr, "compilerOptions"); _i < Ei.length; _i++) {
                      var tt = Ei[_i];
                      if (e2.isObjectLiteralExpression(tt.initializer)) {
                        Zt = tt.initializer;
                        break;
                      }
                    }
                }
                return Zt || void 0;
              }
              function Ql(Kr, _i, Ei, tt, kt, bt, ia, Xt) {
                for (var Za = e2.getPropertyAssignment(Kr, Ei, tt), bn = 0, _a4 = Za; bn < _a4.length; bn++) {
                  var qa = _a4[bn];
                  wi.add(e2.createDiagnosticForNodeInSourceFile(de.configFile, _i ? qa.name : qa.initializer, kt, bt, ia, Xt));
                }
                return !!Za.length;
              }
              function xl(Kr, _i) {
                Wt.set(Vi(Kr), true), wi.add(_i);
              }
              function Ya(Kr) {
                if (de.noEmit)
                  return false;
                var _i = Vi(Kr);
                if (Da(_i))
                  return false;
                var Ei = e2.outFile(de);
                if (Ei)
                  return du(_i, Ei) || du(_i, e2.removeFileExtension(Ei) + ".d.ts");
                if (de.declarationDir && e2.containsPath(de.declarationDir, _i, Xi, !pe.useCaseSensitiveFileNames()))
                  return true;
                if (de.outDir)
                  return e2.containsPath(de.outDir, _i, Xi, !pe.useCaseSensitiveFileNames());
                if (e2.fileExtensionIsOneOf(_i, e2.supportedJSExtensionsFlat) || e2.isDeclarationFileName(_i)) {
                  var tt = e2.removeFileExtension(_i);
                  return !!Da(tt + ".ts") || !!Da(tt + ".tsx");
                }
                return false;
              }
              function du(Kr, _i) {
                return e2.comparePaths(Kr, _i, Xi, !pe.useCaseSensitiveFileNames()) === 0;
              }
              function vc() {
                return pe.getSymlinkCache ? pe.getSymlinkCache() : (Br || (Br = e2.createSymlinkCache(Xi, ua)), Ye && yr && !Br.hasProcessedResolutions() && Br.setSymlinksFromResolutions(Ye, yr), Br);
              }
            }
            e2.createProgram = I;
            function l(Z2) {
              var Be, ge = Z2.compilerHost.fileExists, Re = Z2.compilerHost.directoryExists, ze = Z2.compilerHost.getDirectories, Ee = Z2.compilerHost.realpath;
              if (!Z2.useSourceOfProjectReferenceRedirect)
                return { onProgramCreateComplete: e2.noop, fileExists: Ie };
              Z2.compilerHost.fileExists = Ie;
              var He;
              return Re && (He = Z2.compilerHost.directoryExists = function(Ae) {
                return Re.call(Z2.compilerHost, Ae) ? (de(Ae), true) : Z2.getResolvedProjectReferences() ? (Be || (Be = new e2.Set(), Z2.forEachResolvedProjectReference(function(er) {
                  var ir = e2.outFile(er.commandLine.options);
                  if (ir)
                    Be.add(e2.getDirectoryPath(Z2.toPath(ir)));
                  else {
                    var Cr = er.commandLine.options.declarationDir || er.commandLine.options.outDir;
                    Cr && Be.add(Z2.toPath(Cr));
                  }
                })), ye(Ae, false)) : false;
              }), ze && (Z2.compilerHost.getDirectories = function(Ae) {
                return !Z2.getResolvedProjectReferences() || Re && Re.call(Z2.compilerHost, Ae) ? ze.call(Z2.compilerHost, Ae) : [];
              }), Ee && (Z2.compilerHost.realpath = function(Ae) {
                var er;
                return ((er = Z2.getSymlinkCache().getSymlinkedFiles()) === null || er === void 0 ? void 0 : er.get(Z2.toPath(Ae))) || Ee.call(Z2.compilerHost, Ae);
              }), { onProgramCreateComplete: rr, fileExists: Ie, directoryExists: He };
              function rr() {
                Z2.compilerHost.fileExists = ge, Z2.compilerHost.directoryExists = Re, Z2.compilerHost.getDirectories = ze;
              }
              function Ie(Ae) {
                return ge.call(Z2.compilerHost, Ae) ? true : !Z2.getResolvedProjectReferences() || !e2.isDeclarationFileName(Ae) ? false : ye(Ae, true);
              }
              function _e(Ae) {
                var er = Z2.getSourceOfProjectReferenceRedirect(Z2.toPath(Ae));
                return er !== void 0 ? e2.isString(er) ? ge.call(Z2.compilerHost, er) : true : void 0;
              }
              function we(Ae) {
                var er = Z2.toPath(Ae), ir = "".concat(er).concat(e2.directorySeparator);
                return e2.forEachKey(Be, function(Cr) {
                  return er === Cr || e2.startsWith(Cr, ir) || e2.startsWith(er, "".concat(Cr, "/"));
                });
              }
              function de(Ae) {
                var er;
                if (!(!Z2.getResolvedProjectReferences() || e2.containsIgnoredPath(Ae)) && !(!Ee || !e2.stringContains(Ae, e2.nodeModulesPathPart))) {
                  var ir = Z2.getSymlinkCache(), Cr = e2.ensureTrailingDirectorySeparator(Z2.toPath(Ae));
                  if (!(!((er = ir.getSymlinkedDirectories()) === null || er === void 0) && er.has(Cr))) {
                    var Ye = e2.normalizePath(Ee.call(Z2.compilerHost, Ae)), Br;
                    if (Ye === Ae || (Br = e2.ensureTrailingDirectorySeparator(Z2.toPath(Ye))) === Cr) {
                      ir.setSymlinkedDirectory(Cr, false);
                      return;
                    }
                    ir.setSymlinkedDirectory(Ae, { real: e2.ensureTrailingDirectorySeparator(Ye), realPath: Br });
                  }
                }
              }
              function ye(Ae, er) {
                var ir, Cr = er ? function(n) {
                  return _e(n);
                } : function(n) {
                  return we(n);
                }, Ye = Cr(Ae);
                if (Ye !== void 0)
                  return Ye;
                var Br = Z2.getSymlinkCache(), Er = Br.getSymlinkedDirectories();
                if (!Er)
                  return false;
                var Ne = Z2.toPath(Ae);
                return e2.stringContains(Ne, e2.nodeModulesPathPart) ? er && ((ir = Br.getSymlinkedFiles()) === null || ir === void 0 ? void 0 : ir.has(Ne)) ? true : e2.firstDefinedIterator(Er.entries(), function(n) {
                  var lr = n[0], be = n[1];
                  if (!(!be || !e2.startsWith(Ne, lr))) {
                    var Ge = Cr(Ne.replace(lr, be.realPath));
                    if (er && Ge) {
                      var ur = e2.getNormalizedAbsolutePath(Ae, Z2.compilerHost.getCurrentDirectory());
                      Br.setSymlinkedFile(Ne, "".concat(be.real).concat(ur.replace(new RegExp(lr, "i"), "")));
                    }
                    return Ge;
                  }
                }) || false : false;
              }
            }
            e2.emitSkippedWithNoDiagnostics = { diagnostics: e2.emptyArray, sourceMaps: void 0, emittedFiles: void 0, emitSkipped: true };
            function d(Z2, Be, ge, Re) {
              var ze = Z2.getCompilerOptions();
              if (ze.noEmit)
                return Z2.getSemanticDiagnostics(Be, Re), Be || e2.outFile(ze) ? e2.emitSkippedWithNoDiagnostics : Z2.emitBuildInfo(ge, Re);
              if (!!ze.noEmitOnError) {
                var Ee = Ve(Ve(Ve(Ve([], Z2.getOptionsDiagnostics(Re), true), Z2.getSyntacticDiagnostics(Be, Re), true), Z2.getGlobalDiagnostics(Re), true), Z2.getSemanticDiagnostics(Be, Re), true);
                if (Ee.length === 0 && e2.getEmitDeclarations(Z2.getCompilerOptions()) && (Ee = Z2.getDeclarationDiagnostics(void 0, Re)), !!Ee.length) {
                  var He;
                  if (!Be && !e2.outFile(ze)) {
                    var rr = Z2.emitBuildInfo(ge, Re);
                    rr.diagnostics && (Ee = Ve(Ve([], Ee, true), rr.diagnostics, true)), He = rr.emittedFiles;
                  }
                  return { diagnostics: Ee, sourceMaps: void 0, emittedFiles: He, emitSkipped: true };
                }
              }
            }
            e2.handleNoEmitOptions = d;
            function D(Z2, Be) {
              return e2.filter(Z2, function(ge) {
                return !ge.skippedOn || !Be[ge.skippedOn];
              });
            }
            e2.filterSemanticDiagnostics = D;
            function fe(Z2, Be) {
              return Be === void 0 && (Be = Z2), { fileExists: function(ge) {
                return Be.fileExists(ge);
              }, readDirectory: function(ge, Re, ze, Ee, He) {
                return e2.Debug.assertIsDefined(Be.readDirectory, "'CompilerHost.readDirectory' must be implemented to correctly process 'projectReferences'"), Be.readDirectory(ge, Re, ze, Ee, He);
              }, readFile: function(ge) {
                return Be.readFile(ge);
              }, useCaseSensitiveFileNames: Z2.useCaseSensitiveFileNames(), getCurrentDirectory: function() {
                return Z2.getCurrentDirectory();
              }, onUnRecoverableConfigFileDiagnostic: Z2.onUnRecoverableConfigFileDiagnostic || e2.returnUndefined, trace: Z2.trace ? function(ge) {
                return Z2.trace(ge);
              } : void 0 };
            }
            e2.parseConfigHostFromCompilerHostLike = fe;
            function g(Z2, Be, ge) {
              if (!Z2)
                return e2.emptyArray;
              for (var Re, ze = 0; ze < Z2.length; ze++) {
                var Ee = Z2[ze], He = Be(Ee, ze);
                if (Ee.prepend && He && He.options) {
                  var rr = e2.outFile(He.options);
                  if (!rr)
                    continue;
                  var Ie = e2.getOutputPathsForBundle(He.options, true), _e = Ie.jsFilePath, we = Ie.sourceMapFilePath, de = Ie.declarationFilePath, ye = Ie.declarationMapPath, Ae = Ie.buildInfoPath, er = e2.createInputFiles(ge, _e, we, de, ye, Ae);
                  (Re || (Re = [])).push(er);
                }
              }
              return Re || e2.emptyArray;
            }
            e2.createPrependNodes = g;
            function ne(Z2, Be) {
              var ge = Be || Z2;
              return e2.resolveConfigFileProjectName(ge.path);
            }
            e2.resolveProjectReferencePath = ne;
            function ue(Z2, Be) {
              var ge = Be.extension;
              switch (ge) {
                case ".ts":
                case ".d.ts":
                  return;
                case ".tsx":
                  return Re();
                case ".jsx":
                  return Re() || ze();
                case ".js":
                  return ze();
                case ".json":
                  return Ee();
              }
              function Re() {
                return Z2.jsx ? void 0 : e2.Diagnostics.Module_0_was_resolved_to_1_but_jsx_is_not_set;
              }
              function ze() {
                return e2.getAllowJSCompilerOption(Z2) || !e2.getStrictOptionValue(Z2, "noImplicitAny") ? void 0 : e2.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type;
              }
              function Ee() {
                return Z2.resolveJsonModule ? void 0 : e2.Diagnostics.Module_0_was_resolved_to_1_but_resolveJsonModule_is_not_used;
              }
            }
            e2.getResolutionDiagnostic = ue;
            function We(Z2) {
              for (var Be = Z2.imports, ge = Z2.moduleAugmentations, Re = Be.map(function(rr) {
                return rr.text;
              }), ze = 0, Ee = ge; ze < Ee.length; ze++) {
                var He = Ee[ze];
                He.kind === 10 && Re.push(He.text);
              }
              return Re;
            }
            function Fe(Z2, Be) {
              var ge = Z2.imports, Re = Z2.moduleAugmentations;
              if (Be < ge.length)
                return ge[Be];
              for (var ze = ge.length, Ee = 0, He = Re; Ee < He.length; Ee++) {
                var rr = He[Ee];
                if (rr.kind === 10) {
                  if (Be === ze)
                    return rr;
                  ze++;
                }
              }
              e2.Debug.fail("should never ask for module name at index higher than possible module name");
            }
            e2.getModuleNameStringLiteralAt = Fe;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(w, B, E, Q, le, N) {
              var p = [], m2 = w.emit(B, T, Q, E, le, N), G = m2.emitSkipped, oe = m2.diagnostics, f4 = m2.exportedModulesFromDeclarationEmit;
              return { outputFiles: p, emitSkipped: G, diagnostics: oe, exportedModulesFromDeclarationEmit: f4 };
              function T(K, b, se) {
                p.push({ name: K, writeByteOrderMark: se, text: b });
              }
            }
            e2.getFileEmitOutput = a;
            var C;
            (function(w) {
              function B() {
                function A2(y, V, L) {
                  var P = { clone: function() {
                    return A2(new e2.Map(y), new e2.Map(V), L && new e2.Set(L));
                  }, forEach: function(k) {
                    return y.forEach(k);
                  }, getKeys: function(k) {
                    return V.get(k);
                  }, getValues: function(k) {
                    return y.get(k);
                  }, hasKey: function(k) {
                    return y.has(k);
                  }, keys: function() {
                    return y.keys();
                  }, deletedKeys: function() {
                    return L;
                  }, deleteKey: function(k) {
                    (L || (L = new e2.Set())).add(k);
                    var Y = y.get(k);
                    return Y ? (Y.forEach(function(U) {
                      return Q(V, U, k);
                    }), y.delete(k), true) : false;
                  }, set: function(k, Y) {
                    L == null || L.delete(k);
                    var U = y.get(k);
                    return y.set(k, Y), U == null || U.forEach(function(j) {
                      Y.has(j) || Q(V, j, k);
                    }), Y.forEach(function(j) {
                      U != null && U.has(j) || E(V, j, k);
                    }), P;
                  }, clear: function() {
                    y.clear(), V.clear(), L == null || L.clear();
                  } };
                  return P;
                }
                return A2(new e2.Map(), new e2.Map(), void 0);
              }
              w.createManyToManyPathMap = B;
              function E(A2, y, V) {
                var L = A2.get(y);
                L || (L = new e2.Set(), A2.set(y, L)), L.add(V);
              }
              function Q(A2, y, V) {
                var L = A2.get(y);
                return L != null && L.delete(V) ? (L.size || A2.delete(y), true) : false;
              }
              function le(A2) {
                return e2.mapDefined(A2.declarations, function(y) {
                  var V;
                  return (V = e2.getSourceFileOfNode(y)) === null || V === void 0 ? void 0 : V.resolvedPath;
                });
              }
              function N(A2, y) {
                var V = A2.getSymbolAtLocation(y);
                return V && le(V);
              }
              function p(A2, y, V, L) {
                return e2.toPath(A2.getProjectReferenceRedirect(y) || y, V, L);
              }
              function m2(A2, y, V) {
                var L;
                if (y.imports && y.imports.length > 0)
                  for (var P = A2.getTypeChecker(), k = 0, Y = y.imports; k < Y.length; k++) {
                    var U = Y[k], j = N(P, U);
                    j == null || j.forEach(ge);
                  }
                var H = e2.getDirectoryPath(y.resolvedPath);
                if (y.referencedFiles && y.referencedFiles.length > 0)
                  for (var I = 0, l = y.referencedFiles; I < l.length; I++) {
                    var d = l[I], D = p(A2, d.fileName, H, V);
                    ge(D);
                  }
                if (y.resolvedTypeReferenceDirectiveNames && y.resolvedTypeReferenceDirectiveNames.forEach(function(Re) {
                  if (!!Re) {
                    var ze = Re.resolvedFileName, Ee = p(A2, ze, H, V);
                    ge(Ee);
                  }
                }), y.moduleAugmentations.length)
                  for (var P = A2.getTypeChecker(), fe = 0, g = y.moduleAugmentations; fe < g.length; fe++) {
                    var ne = g[fe];
                    if (!!e2.isStringLiteral(ne)) {
                      var ue = P.getSymbolAtLocation(ne);
                      !ue || Be(ue);
                    }
                  }
                for (var We = 0, Fe = A2.getTypeChecker().getAmbientModules(); We < Fe.length; We++) {
                  var Z2 = Fe[We];
                  Z2.declarations && Z2.declarations.length > 1 && Be(Z2);
                }
                return L;
                function Be(Re) {
                  if (!!Re.declarations)
                    for (var ze = 0, Ee = Re.declarations; ze < Ee.length; ze++) {
                      var He = Ee[ze], rr = e2.getSourceFileOfNode(He);
                      rr && rr !== y && ge(rr.resolvedPath);
                    }
                }
                function ge(Re) {
                  (L || (L = new e2.Set())).add(Re);
                }
              }
              function G(A2, y) {
                return y && !y.referencedMap == !A2;
              }
              w.canReuseOldState = G;
              function oe(A2, y, V, L) {
                var P = new e2.Map(), k = A2.getCompilerOptions().module !== e2.ModuleKind.None ? B() : void 0, Y = k ? B() : void 0, U = new e2.Set(), j = G(k, V);
                A2.getTypeChecker();
                for (var H = 0, I = A2.getSourceFiles(); H < I.length; H++) {
                  var l = I[H], d = e2.Debug.checkDefined(l.version, "Program intended to be used with Builder should have source files with versions set"), D = j ? V.fileInfos.get(l.resolvedPath) : void 0;
                  if (k) {
                    var fe = m2(A2, l, y);
                    if (fe && k.set(l.resolvedPath, fe), j) {
                      var g = V.exportedModulesMap.getValues(l.resolvedPath);
                      g && Y.set(l.resolvedPath, g);
                    }
                  }
                  P.set(l.resolvedPath, { version: d, signature: D && D.signature, affectsGlobalScope: F2(l) || void 0, impliedFormat: l.impliedNodeFormat });
                }
                return { fileInfos: P, referencedMap: k, exportedModulesMap: Y, hasCalledUpdateShapeSignature: U, useFileVersionAsSignature: !L && !j };
              }
              w.create = oe;
              function f4(A2) {
                A2.allFilesExcludingDefaultLibraryFile = void 0, A2.allFileNames = void 0;
              }
              w.releaseCache = f4;
              function T(A2) {
                var y, V;
                return { fileInfos: new e2.Map(A2.fileInfos), referencedMap: (y = A2.referencedMap) === null || y === void 0 ? void 0 : y.clone(), exportedModulesMap: (V = A2.exportedModulesMap) === null || V === void 0 ? void 0 : V.clone(), hasCalledUpdateShapeSignature: new e2.Set(A2.hasCalledUpdateShapeSignature), useFileVersionAsSignature: A2.useFileVersionAsSignature };
              }
              w.clone = T;
              function K(A2, y, V, L, P, k, Y) {
                var U = k || new e2.Map(), j = y.getSourceFileByPath(V);
                if (!j)
                  return e2.emptyArray;
                if (!J(A2, y, j, U, L, P, Y))
                  return [j];
                var H = (A2.referencedMap ? $ : X)(A2, y, j, U, L, P, Y);
                return k || b(A2, U), H;
              }
              w.getFilesAffectedBy = K;
              function b(A2, y) {
                y.forEach(function(V, L) {
                  return se(A2, V, L);
                });
              }
              w.updateSignaturesFromCache = b;
              function se(A2, y, V) {
                A2.fileInfos.get(V).signature = y, A2.hasCalledUpdateShapeSignature.add(V);
              }
              w.updateSignatureOfFile = se;
              function J(A2, y, V, L, P, k, Y, U) {
                if (U === void 0 && (U = A2.useFileVersionAsSignature), e2.Debug.assert(!!V), e2.Debug.assert(!Y || !!A2.exportedModulesMap, "Compute visible to outside map only if visibleToOutsideReferencedMap present in the state"), A2.hasCalledUpdateShapeSignature.has(V.resolvedPath) || L.has(V.resolvedPath))
                  return false;
                var j = A2.fileInfos.get(V.resolvedPath);
                if (!j)
                  return e2.Debug.fail();
                var H = j.signature, I;
                if (!V.isDeclarationFile && !U) {
                  var l = a(y, V, true, P, void 0, true), d = e2.firstOrUndefined(l.outputFiles);
                  d && (e2.Debug.assert(e2.isDeclarationFileName(d.name), "File extension for signature expected to be dts", function() {
                    return "Found: ".concat(e2.getAnyExtensionFromPath(d.name), " for ").concat(d.name, ":: All output files: ").concat(JSON.stringify(l.outputFiles.map(function(fe) {
                      return fe.name;
                    })));
                  }), I = (k || e2.generateDjb2Hash)(d.text), Y && I !== H && ie(V, l.exportedModulesFromDeclarationEmit, Y));
                }
                if (I === void 0 && (I = V.version, Y && I !== H)) {
                  var D = A2.referencedMap ? A2.referencedMap.getValues(V.resolvedPath) : void 0;
                  D ? Y.set(V.resolvedPath, D) : Y.deleteKey(V.resolvedPath);
                }
                return L.set(V.resolvedPath, I), I !== H;
              }
              w.updateShapeSignature = J;
              function ie(A2, y, V) {
                if (!y) {
                  V.deleteKey(A2.resolvedPath);
                  return;
                }
                var L;
                y.forEach(function(k) {
                  return P(le(k));
                }), L ? V.set(A2.resolvedPath, L) : V.deleteKey(A2.resolvedPath);
                function P(k) {
                  k != null && k.length && (L || (L = new e2.Set()), k.forEach(function(Y) {
                    return L.add(Y);
                  }));
                }
              }
              w.updateExportedModules = ie;
              function R(A2, y) {
                var V;
                y && (e2.Debug.assert(!!A2.exportedModulesMap), (V = y.deletedKeys()) === null || V === void 0 || V.forEach(function(L) {
                  return A2.exportedModulesMap.deleteKey(L);
                }), y.forEach(function(L, P) {
                  return A2.exportedModulesMap.set(P, L);
                }));
              }
              w.updateExportedFilesMapFromCache = R;
              function q(A2, y, V) {
                var L = y.getCompilerOptions();
                if (e2.outFile(L) || !A2.referencedMap || F2(V))
                  return O(A2, y);
                for (var P = new e2.Set(), k = [V.resolvedPath]; k.length; ) {
                  var Y = k.pop();
                  if (!P.has(Y)) {
                    P.add(Y);
                    var U = A2.referencedMap.getValues(Y);
                    if (U)
                      for (var j = U.keys(), H = j.next(); !H.done; H = j.next())
                        k.push(H.value);
                  }
                }
                return e2.arrayFrom(e2.mapDefinedIterator(P.keys(), function(I) {
                  var l, d;
                  return (d = (l = y.getSourceFileByPath(I)) === null || l === void 0 ? void 0 : l.fileName) !== null && d !== void 0 ? d : I;
                }));
              }
              w.getAllDependencies = q;
              function O(A2, y) {
                if (!A2.allFileNames) {
                  var V = y.getSourceFiles();
                  A2.allFileNames = V === e2.emptyArray ? e2.emptyArray : V.map(function(L) {
                    return L.fileName;
                  });
                }
                return A2.allFileNames;
              }
              function ve(A2, y) {
                var V = A2.referencedMap.getKeys(y);
                return V ? e2.arrayFrom(V.keys()) : [];
              }
              w.getReferencedByPaths = ve;
              function ee(A2) {
                for (var y = 0, V = A2.statements; y < V.length; y++) {
                  var L = V[y];
                  if (!e2.isModuleWithStringLiteralName(L))
                    return false;
                }
                return true;
              }
              function he(A2) {
                return e2.some(A2.moduleAugmentations, function(y) {
                  return e2.isGlobalScopeAugmentation(y.parent);
                });
              }
              function F2(A2) {
                return he(A2) || !e2.isExternalOrCommonJsModule(A2) && !e2.isJsonSourceFile(A2) && !ee(A2);
              }
              function x2(A2, y, V) {
                if (A2.allFilesExcludingDefaultLibraryFile)
                  return A2.allFilesExcludingDefaultLibraryFile;
                var L;
                V && U(V);
                for (var P = 0, k = y.getSourceFiles(); P < k.length; P++) {
                  var Y = k[P];
                  Y !== V && U(Y);
                }
                return A2.allFilesExcludingDefaultLibraryFile = L || e2.emptyArray, A2.allFilesExcludingDefaultLibraryFile;
                function U(j) {
                  y.isSourceFileDefaultLibrary(j) || (L || (L = [])).push(j);
                }
              }
              w.getAllFilesExcludingDefaultLibraryFile = x2;
              function X(A2, y, V) {
                var L = y.getCompilerOptions();
                return L && e2.outFile(L) ? [V] : x2(A2, y, V);
              }
              function $(A2, y, V, L, P, k, Y) {
                if (F2(V))
                  return x2(A2, y, V);
                var U = y.getCompilerOptions();
                if (U && (U.isolatedModules || e2.outFile(U)))
                  return [V];
                var j = new e2.Map();
                j.set(V.resolvedPath, V);
                for (var H = ve(A2, V.resolvedPath); H.length > 0; ) {
                  var I = H.pop();
                  if (!j.has(I)) {
                    var l = y.getSourceFileByPath(I);
                    j.set(I, l), l && J(A2, y, l, L, P, k, Y) && H.push.apply(H, ve(A2, l.resolvedPath));
                  }
                }
                return e2.arrayFrom(e2.mapDefinedIterator(j.values(), function(d) {
                  return d;
                }));
              }
            })(C = e2.BuilderState || (e2.BuilderState = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(j) {
              j[j.DtsOnly = 0] = "DtsOnly", j[j.Full = 1] = "Full";
            })(a = e2.BuilderFileEmit || (e2.BuilderFileEmit = {}));
            function C(j, H) {
              return j === H || j !== void 0 && H !== void 0 && j.size === H.size && !e2.forEachKey(j, function(I) {
                return !H.has(I);
              });
            }
            function w(j, H, I, l) {
              var d = e2.BuilderState.create(j, H, I, l);
              d.program = j;
              var D = j.getCompilerOptions();
              d.compilerOptions = D, e2.outFile(D) || (d.semanticDiagnosticsPerFile = new e2.Map()), d.changedFilesSet = new e2.Set();
              var fe = e2.BuilderState.canReuseOldState(d.referencedMap, I), g = fe ? I.compilerOptions : void 0, ne = fe && I.semanticDiagnosticsPerFile && !!d.semanticDiagnosticsPerFile && !e2.compilerOptionsAffectSemanticDiagnostics(D, g);
              if (fe) {
                if (!I.currentChangedFilePath) {
                  var ue = I.currentAffectedFilesSignatures;
                  e2.Debug.assert(!I.affectedFiles && (!ue || !ue.size), "Cannot reuse if only few affected files of currentChangedFile were iterated");
                }
                var We = I.changedFilesSet;
                ne && e2.Debug.assert(!We || !e2.forEachKey(We, function(Re) {
                  return I.semanticDiagnosticsPerFile.has(Re);
                }), "Semantic diagnostics shouldnt be available for changed files"), We == null || We.forEach(function(Re) {
                  return d.changedFilesSet.add(Re);
                }), !e2.outFile(D) && I.affectedFilesPendingEmit && (d.affectedFilesPendingEmit = I.affectedFilesPendingEmit.slice(), d.affectedFilesPendingEmitKind = I.affectedFilesPendingEmitKind && new e2.Map(I.affectedFilesPendingEmitKind), d.affectedFilesPendingEmitIndex = I.affectedFilesPendingEmitIndex, d.seenAffectedFiles = new e2.Set());
              }
              var Fe = d.referencedMap, Z2 = fe ? I.referencedMap : void 0, Be = ne && !D.skipLibCheck == !g.skipLibCheck, ge = Be && !D.skipDefaultLibCheck == !g.skipDefaultLibCheck;
              return d.fileInfos.forEach(function(Re, ze) {
                var Ee, He;
                if (!fe || !(Ee = I.fileInfos.get(ze)) || Ee.version !== Re.version || !C(He = Fe && Fe.getValues(ze), Z2 && Z2.getValues(ze)) || He && e2.forEachKey(He, function(_e) {
                  return !d.fileInfos.has(_e) && I.fileInfos.has(_e);
                }))
                  d.changedFilesSet.add(ze);
                else if (ne) {
                  var rr = j.getSourceFileByPath(ze);
                  if (rr.isDeclarationFile && !Be || rr.hasNoDefaultLib && !ge)
                    return;
                  var Ie = I.semanticDiagnosticsPerFile.get(ze);
                  Ie && (d.semanticDiagnosticsPerFile.set(ze, I.hasReusableDiagnostic ? B(Ie, j, H) : Ie), d.semanticDiagnosticsFromOldState || (d.semanticDiagnosticsFromOldState = new e2.Set()), d.semanticDiagnosticsFromOldState.add(ze));
                }
              }), fe && e2.forEachEntry(I.fileInfos, function(Re, ze) {
                return Re.affectsGlobalScope && !d.fileInfos.has(ze);
              }) ? e2.BuilderState.getAllFilesExcludingDefaultLibraryFile(d, j, void 0).forEach(function(Re) {
                return d.changedFilesSet.add(Re.resolvedPath);
              }) : g && !e2.outFile(D) && e2.compilerOptionsAffectEmit(D, g) && (j.getSourceFiles().forEach(function(Re) {
                return P(d, Re.resolvedPath, 1);
              }), e2.Debug.assert(!d.seenAffectedFiles || !d.seenAffectedFiles.size), d.seenAffectedFiles = d.seenAffectedFiles || new e2.Set()), fe && e2.forEachEntry(I.fileInfos, function(Re, ze) {
                d.fileInfos.has(ze) && d.fileInfos.get(ze).impliedFormat !== Re.impliedFormat && d.changedFilesSet.add(ze);
              }), d.buildInfoEmitPending = !!d.changedFilesSet.size, d;
            }
            function B(j, H, I) {
              if (!j.length)
                return e2.emptyArray;
              var l = e2.getDirectoryPath(e2.getNormalizedAbsolutePath(e2.getTsBuildInfoEmitOutputFilePath(H.getCompilerOptions()), H.getCurrentDirectory()));
              return j.map(function(D) {
                var fe = E(D, H, d);
                fe.reportsUnnecessary = D.reportsUnnecessary, fe.reportsDeprecated = D.reportDeprecated, fe.source = D.source, fe.skippedOn = D.skippedOn;
                var g = D.relatedInformation;
                return fe.relatedInformation = g ? g.length ? g.map(function(ne) {
                  return E(ne, H, d);
                }) : [] : void 0, fe;
              });
              function d(D) {
                return e2.toPath(D, l, I);
              }
            }
            function E(j, H, I) {
              var l = j.file;
              return Ke(Ke({}, j), { file: l ? H.getSourceFileByPath(I(l)) : void 0 });
            }
            function Q(j) {
              e2.BuilderState.releaseCache(j), j.program = void 0;
            }
            function le(j) {
              var H, I = e2.BuilderState.clone(j);
              return I.semanticDiagnosticsPerFile = j.semanticDiagnosticsPerFile && new e2.Map(j.semanticDiagnosticsPerFile), I.changedFilesSet = new e2.Set(j.changedFilesSet), I.affectedFiles = j.affectedFiles, I.affectedFilesIndex = j.affectedFilesIndex, I.currentChangedFilePath = j.currentChangedFilePath, I.currentAffectedFilesSignatures = j.currentAffectedFilesSignatures && new e2.Map(j.currentAffectedFilesSignatures), I.currentAffectedFilesExportedModulesMap = (H = j.currentAffectedFilesExportedModulesMap) === null || H === void 0 ? void 0 : H.clone(), I.seenAffectedFiles = j.seenAffectedFiles && new e2.Set(j.seenAffectedFiles), I.cleanedDiagnosticsOfLibFiles = j.cleanedDiagnosticsOfLibFiles, I.semanticDiagnosticsFromOldState = j.semanticDiagnosticsFromOldState && new e2.Set(j.semanticDiagnosticsFromOldState), I.program = j.program, I.compilerOptions = j.compilerOptions, I.affectedFilesPendingEmit = j.affectedFilesPendingEmit && j.affectedFilesPendingEmit.slice(), I.affectedFilesPendingEmitKind = j.affectedFilesPendingEmitKind && new e2.Map(j.affectedFilesPendingEmitKind), I.affectedFilesPendingEmitIndex = j.affectedFilesPendingEmitIndex, I.seenEmittedFiles = j.seenEmittedFiles && new e2.Map(j.seenEmittedFiles), I.programEmitComplete = j.programEmitComplete, I;
            }
            function N(j, H) {
              e2.Debug.assert(!H || !j.affectedFiles || j.affectedFiles[j.affectedFilesIndex - 1] !== H || !j.semanticDiagnosticsPerFile.has(H.resolvedPath));
            }
            function p(j, H, I, l) {
              for (var d; ; ) {
                var D = j.affectedFiles;
                if (D) {
                  for (var fe = j.seenAffectedFiles, g = j.affectedFilesIndex; g < D.length; ) {
                    var ne = D[g];
                    if (!fe.has(ne.resolvedPath))
                      return j.affectedFilesIndex = g, f4(j, ne, H, I, l), ne;
                    g++;
                  }
                  j.changedFilesSet.delete(j.currentChangedFilePath), j.currentChangedFilePath = void 0, e2.BuilderState.updateSignaturesFromCache(j, j.currentAffectedFilesSignatures), j.currentAffectedFilesSignatures.clear(), e2.BuilderState.updateExportedFilesMapFromCache(j, j.currentAffectedFilesExportedModulesMap), (d = j.currentAffectedFilesExportedModulesMap) === null || d === void 0 || d.clear(), j.affectedFiles = void 0;
                }
                var ue = j.changedFilesSet.keys().next();
                if (ue.done)
                  return;
                var We = e2.Debug.checkDefined(j.program), Fe = We.getCompilerOptions();
                if (e2.outFile(Fe))
                  return e2.Debug.assert(!j.semanticDiagnosticsPerFile), We;
                j.currentAffectedFilesSignatures || (j.currentAffectedFilesSignatures = new e2.Map()), j.exportedModulesMap && (j.currentAffectedFilesExportedModulesMap || (j.currentAffectedFilesExportedModulesMap = e2.BuilderState.createManyToManyPathMap())), j.affectedFiles = e2.BuilderState.getFilesAffectedBy(j, We, ue.value, H, I, j.currentAffectedFilesSignatures, j.currentAffectedFilesExportedModulesMap), j.currentChangedFilePath = ue.value, j.affectedFilesIndex = 0, j.seenAffectedFiles || (j.seenAffectedFiles = new e2.Set());
              }
            }
            function m2(j) {
              j.affectedFilesPendingEmit = void 0, j.affectedFilesPendingEmitKind = void 0, j.affectedFilesPendingEmitIndex = void 0;
            }
            function G(j) {
              var H = j.affectedFilesPendingEmit;
              if (H) {
                for (var I = j.seenEmittedFiles || (j.seenEmittedFiles = new e2.Map()), l = j.affectedFilesPendingEmitIndex; l < H.length; l++) {
                  var d = e2.Debug.checkDefined(j.program).getSourceFileByPath(H[l]);
                  if (d) {
                    var D = I.get(d.resolvedPath), fe = e2.Debug.checkDefined(e2.Debug.checkDefined(j.affectedFilesPendingEmitKind).get(d.resolvedPath));
                    if (D === void 0 || D < fe)
                      return j.affectedFilesPendingEmitIndex = l, { affectedFile: d, emitKind: fe };
                  }
                }
                m2(j);
              }
            }
            function oe(j) {
              if (!j.cleanedDiagnosticsOfLibFiles) {
                j.cleanedDiagnosticsOfLibFiles = true;
                var H = e2.Debug.checkDefined(j.program), I = H.getCompilerOptions();
                e2.forEach(H.getSourceFiles(), function(l) {
                  return H.isSourceFileDefaultLibrary(l) && !e2.skipTypeChecking(l, I, H) && K(j, l.resolvedPath);
                });
              }
            }
            function f4(j, H, I, l, d) {
              var D;
              if (K(j, H.resolvedPath), j.allFilesExcludingDefaultLibraryFile === j.affectedFiles) {
                oe(j), e2.BuilderState.updateShapeSignature(j, e2.Debug.checkDefined(j.program), H, e2.Debug.checkDefined(j.currentAffectedFilesSignatures), I, l, j.currentAffectedFilesExportedModulesMap);
                return;
              }
              e2.Debug.assert(j.hasCalledUpdateShapeSignature.has(H.resolvedPath) || ((D = j.currentAffectedFilesSignatures) === null || D === void 0 ? void 0 : D.has(H.resolvedPath)), "Signature not updated for affected file: ".concat(H.fileName)), !j.compilerOptions.assumeChangesOnlyAffectDirectDependencies && ie(j, H, I, l, d);
            }
            function T(j, H, I, l, d) {
              if (K(j, H), !j.changedFilesSet.has(H)) {
                var D = e2.Debug.checkDefined(j.program), fe = D.getSourceFileByPath(H);
                fe && (e2.BuilderState.updateShapeSignature(j, D, fe, e2.Debug.checkDefined(j.currentAffectedFilesSignatures), I, l, j.currentAffectedFilesExportedModulesMap, !d.disableUseFileVersionAsSignature), e2.getEmitDeclarations(j.compilerOptions) && P(j, H, 0));
              }
            }
            function K(j, H) {
              return j.semanticDiagnosticsFromOldState ? (j.semanticDiagnosticsFromOldState.delete(H), j.semanticDiagnosticsPerFile.delete(H), !j.semanticDiagnosticsFromOldState.size) : true;
            }
            function b(j, H) {
              var I = e2.Debug.checkDefined(j.currentAffectedFilesSignatures).get(H), l = e2.Debug.checkDefined(j.fileInfos.get(H)).signature;
              return I !== l;
            }
            function se(j, H, I) {
              var l = j.currentAffectedFilesExportedModulesMap.getKeys(H), d = l && e2.forEachKey(l, I);
              return d || (l = j.exportedModulesMap.getKeys(H), l && e2.forEachKey(l, function(D) {
                var fe;
                return !j.currentAffectedFilesExportedModulesMap.hasKey(D) && !(!((fe = j.currentAffectedFilesExportedModulesMap.deletedKeys()) === null || fe === void 0) && fe.has(D)) ? I(D) : void 0;
              }));
            }
            function J(j, H, I, l, d) {
              var D;
              return !((D = j.fileInfos.get(H)) === null || D === void 0) && D.affectsGlobalScope ? (e2.BuilderState.getAllFilesExcludingDefaultLibraryFile(j, j.program, void 0).forEach(function(fe) {
                return T(j, fe.resolvedPath, I, l, d);
              }), oe(j), true) : false;
            }
            function ie(j, H, I, l, d) {
              if (!(!j.exportedModulesMap || !j.changedFilesSet.has(H.resolvedPath)) && !!b(j, H.resolvedPath)) {
                if (j.compilerOptions.isolatedModules) {
                  var D = new e2.Map();
                  D.set(H.resolvedPath, true);
                  for (var fe = e2.BuilderState.getReferencedByPaths(j, H.resolvedPath); fe.length > 0; ) {
                    var g = fe.pop();
                    if (!D.has(g)) {
                      if (D.set(g, true), J(j, g, I, l, d))
                        return;
                      if (T(j, g, I, l, d), b(j, g)) {
                        var ne = e2.Debug.checkDefined(j.program).getSourceFileByPath(g);
                        fe.push.apply(fe, e2.BuilderState.getReferencedByPaths(j, ne.resolvedPath));
                      }
                    }
                  }
                }
                e2.Debug.assert(!!j.currentAffectedFilesExportedModulesMap);
                var ue = new e2.Set();
                se(j, H.resolvedPath, function(We) {
                  if (J(j, We, I, l, d))
                    return true;
                  var Fe = j.referencedMap.getKeys(We);
                  return Fe && e2.forEachKey(Fe, function(Z2) {
                    return R(j, Z2, ue, I, l, d);
                  });
                });
              }
            }
            function R(j, H, I, l, d, D) {
              var fe;
              if (!!e2.tryAddToSet(I, H)) {
                if (J(j, H, l, d, D))
                  return true;
                T(j, H, l, d, D), e2.Debug.assert(!!j.currentAffectedFilesExportedModulesMap), se(j, H, function(g) {
                  return R(j, g, I, l, d, D);
                }), (fe = j.referencedMap.getKeys(H)) === null || fe === void 0 || fe.forEach(function(g) {
                  return !I.has(g) && T(j, g, l, d, D);
                });
              }
            }
            function q(j, H, I, l, d) {
              d ? j.buildInfoEmitPending = false : H === j.program ? (j.changedFilesSet.clear(), j.programEmitComplete = true) : (j.seenAffectedFiles.add(H.resolvedPath), I !== void 0 && (j.seenEmittedFiles || (j.seenEmittedFiles = new e2.Map())).set(H.resolvedPath, I), l ? (j.affectedFilesPendingEmitIndex++, j.buildInfoEmitPending = true) : j.affectedFilesIndex++);
            }
            function O(j, H, I) {
              return q(j, I), { result: H, affected: I };
            }
            function ve(j, H, I, l, d, D) {
              return q(j, I, l, d, D), { result: H, affected: I };
            }
            function ee(j, H, I) {
              return e2.concatenate(he(j, H, I), e2.Debug.checkDefined(j.program).getProgramDiagnostics(H));
            }
            function he(j, H, I) {
              var l = H.resolvedPath;
              if (j.semanticDiagnosticsPerFile) {
                var d = j.semanticDiagnosticsPerFile.get(l);
                if (d)
                  return e2.filterSemanticDiagnostics(d, j.compilerOptions);
              }
              var D = e2.Debug.checkDefined(j.program).getBindAndCheckDiagnostics(H, I);
              return j.semanticDiagnosticsPerFile && j.semanticDiagnosticsPerFile.set(l, D), e2.filterSemanticDiagnostics(D, j.compilerOptions);
            }
            function F2(j, H) {
              if (e2.outFile(j.compilerOptions))
                return;
              var I = e2.Debug.checkDefined(j.program).getCurrentDirectory(), l = e2.getDirectoryPath(e2.getNormalizedAbsolutePath(e2.getTsBuildInfoEmitOutputFilePath(j.compilerOptions), I)), d = [], D = new e2.Map(), fe, g, ne = e2.arrayFrom(j.fileInfos.entries(), function(Ae) {
                var er = Ae[0], ir = Ae[1], Cr = de(er);
                e2.Debug.assert(d[Cr - 1] === we(er));
                var Ye = j.currentAffectedFilesSignatures && j.currentAffectedFilesSignatures.get(er), Br = Ye != null ? Ye : ir.signature;
                return ir.version === Br ? ir.affectsGlobalScope || ir.impliedFormat ? { version: ir.version, signature: void 0, affectsGlobalScope: ir.affectsGlobalScope, impliedFormat: ir.impliedFormat } : ir.version : Br !== void 0 ? Ye === void 0 ? ir : { version: ir.version, signature: Ye, affectsGlobalScope: ir.affectsGlobalScope, impliedFormat: ir.impliedFormat } : { version: ir.version, signature: false, affectsGlobalScope: ir.affectsGlobalScope, impliedFormat: ir.impliedFormat };
              }), ue;
              j.referencedMap && (ue = e2.arrayFrom(j.referencedMap.keys()).sort(e2.compareStringsCaseSensitive).map(function(Ae) {
                return [de(Ae), ye(j.referencedMap.getValues(Ae))];
              }));
              var We;
              j.exportedModulesMap && (We = e2.mapDefined(e2.arrayFrom(j.exportedModulesMap.keys()).sort(e2.compareStringsCaseSensitive), function(Ae) {
                var er;
                if (j.currentAffectedFilesExportedModulesMap) {
                  if (!((er = j.currentAffectedFilesExportedModulesMap.deletedKeys()) === null || er === void 0) && er.has(Ae))
                    return;
                  var ir = j.currentAffectedFilesExportedModulesMap.getValues(Ae);
                  if (ir)
                    return [de(Ae), ye(ir)];
                }
                return [de(Ae), ye(j.exportedModulesMap.getValues(Ae))];
              }));
              var Fe;
              if (j.semanticDiagnosticsPerFile)
                for (var Z2 = 0, Be = e2.arrayFrom(j.semanticDiagnosticsPerFile.keys()).sort(e2.compareStringsCaseSensitive); Z2 < Be.length; Z2++) {
                  var ge = Be[Z2], Re = j.semanticDiagnosticsPerFile.get(ge);
                  (Fe || (Fe = [])).push(Re.length ? [de(ge), j.hasReusableDiagnostic ? Re : $(Re, we)] : de(ge));
                }
              var ze;
              if (j.affectedFilesPendingEmit)
                for (var Ee = new e2.Set(), He = 0, rr = j.affectedFilesPendingEmit.slice(j.affectedFilesPendingEmitIndex).sort(e2.compareStringsCaseSensitive); He < rr.length; He++) {
                  var Ie = rr[He];
                  e2.tryAddToSet(Ee, Ie) && (ze || (ze = [])).push([de(Ie), j.affectedFilesPendingEmitKind.get(Ie)]);
                }
              return { fileNames: d, fileInfos: ne, options: x2(j.compilerOptions, _e), fileIdsList: fe, referencedMap: ue, exportedModulesMap: We, semanticDiagnosticsPerFile: Fe, affectedFilesPendingEmit: ze };
              function _e(Ae) {
                return we(e2.getNormalizedAbsolutePath(Ae, I));
              }
              function we(Ae) {
                return e2.ensurePathIsNonModuleName(e2.getRelativePathFromDirectory(l, Ae, H));
              }
              function de(Ae) {
                var er = D.get(Ae);
                return er === void 0 && (d.push(we(Ae)), D.set(Ae, er = d.length)), er;
              }
              function ye(Ae) {
                var er = e2.arrayFrom(Ae.keys(), de).sort(e2.compareValues), ir = er.join(), Cr = g == null ? void 0 : g.get(ir);
                return Cr === void 0 && ((fe || (fe = [])).push(er), (g || (g = new e2.Map())).set(ir, Cr = fe.length)), Cr;
              }
            }
            function x2(j, H) {
              for (var I, l = e2.getOptionsNameMap().optionsNameMap, d = 0, D = e2.getOwnKeys(j).sort(e2.compareStringsCaseSensitive); d < D.length; d++) {
                var fe = D[d], g = fe.toLowerCase(), ne = l.get(g);
                ((ne == null ? void 0 : ne.affectsEmit) || (ne == null ? void 0 : ne.affectsSemanticDiagnostics) || g === "strict" || g === "skiplibcheck" || g === "skipdefaultlibcheck") && ((I || (I = {}))[fe] = X(ne, j[fe], H));
              }
              return I;
            }
            function X(j, H, I) {
              if (j) {
                if (j.type === "list") {
                  var l = H;
                  if (j.element.isFilePath && l.length)
                    return l.map(I);
                } else if (j.isFilePath)
                  return I(H);
              }
              return H;
            }
            function $(j, H) {
              return e2.Debug.assert(!!j.length), j.map(function(I) {
                var l = A2(I, H);
                l.reportsUnnecessary = I.reportsUnnecessary, l.reportDeprecated = I.reportsDeprecated, l.source = I.source, l.skippedOn = I.skippedOn;
                var d = I.relatedInformation;
                return l.relatedInformation = d ? d.length ? d.map(function(D) {
                  return A2(D, H);
                }) : [] : void 0, l;
              });
            }
            function A2(j, H) {
              var I = j.file;
              return Ke(Ke({}, j), { file: I ? H(I.resolvedPath) : void 0 });
            }
            var y;
            (function(j) {
              j[j.SemanticDiagnosticsBuilderProgram = 0] = "SemanticDiagnosticsBuilderProgram", j[j.EmitAndSemanticDiagnosticsBuilderProgram = 1] = "EmitAndSemanticDiagnosticsBuilderProgram";
            })(y = e2.BuilderProgramKind || (e2.BuilderProgramKind = {}));
            function V(j, H, I, l, d, D) {
              var fe, g, ne;
              return j === void 0 ? (e2.Debug.assert(H === void 0), fe = I, ne = l, e2.Debug.assert(!!ne), g = ne.getProgram()) : e2.isArray(j) ? (ne = l, g = e2.createProgram({ rootNames: j, options: H, host: I, oldProgram: ne && ne.getProgramOrUndefined(), configFileParsingDiagnostics: d, projectReferences: D }), fe = I) : (g = j, fe = H, ne = I, d = l), { host: fe, newProgram: g, oldProgram: ne, configFileParsingDiagnostics: d || e2.emptyArray };
            }
            e2.getBuilderCreationParameters = V;
            function L(j, H) {
              var I = H.newProgram, l = H.host, d = H.oldProgram, D = H.configFileParsingDiagnostics, fe = d && d.getState();
              if (fe && I === fe.program && D === I.getConfigFileParsingDiagnostics())
                return I = void 0, fe = void 0, d;
              var g = e2.createGetCanonicalFileName(l.useCaseSensitiveFileNames()), ne = e2.maybeBind(l, l.createHash), ue = w(I, g, fe, l.disableUseFileVersionAsSignature), We;
              I.getProgramBuildInfo = function() {
                return F2(ue, g);
              }, I = void 0, d = void 0, fe = void 0;
              var Fe = function() {
                return ue;
              }, Z2 = U(Fe, D);
              return Z2.getState = Fe, Z2.backupState = function() {
                e2.Debug.assert(We === void 0), We = le(ue);
              }, Z2.restoreState = function() {
                ue = e2.Debug.checkDefined(We), We = void 0;
              }, Z2.getAllDependencies = function(rr) {
                return e2.BuilderState.getAllDependencies(ue, e2.Debug.checkDefined(ue.program), rr);
              }, Z2.getSemanticDiagnostics = He, Z2.emit = ze, Z2.releaseProgram = function() {
                Q(ue), We = void 0;
              }, j === y.SemanticDiagnosticsBuilderProgram ? Z2.getSemanticDiagnosticsOfNextAffectedFile = Ee : j === y.EmitAndSemanticDiagnosticsBuilderProgram ? (Z2.getSemanticDiagnosticsOfNextAffectedFile = Ee, Z2.emitNextAffectedFile = ge, Z2.emitBuildInfo = Be) : e2.notImplemented(), Z2;
              function Be(rr, Ie) {
                if (ue.buildInfoEmitPending) {
                  var _e = e2.Debug.checkDefined(ue.program).emitBuildInfo(rr || e2.maybeBind(l, l.writeFile), Ie);
                  return ue.buildInfoEmitPending = false, _e;
                }
                return e2.emitSkippedWithNoDiagnostics;
              }
              function ge(rr, Ie, _e, we) {
                var de = p(ue, Ie, ne, l), ye = 1, Ae = false;
                if (!de)
                  if (e2.outFile(ue.compilerOptions)) {
                    var Cr = e2.Debug.checkDefined(ue.program);
                    if (ue.programEmitComplete)
                      return;
                    de = Cr;
                  } else {
                    var er = G(ue);
                    if (!er) {
                      if (!ue.buildInfoEmitPending)
                        return;
                      var ir = e2.Debug.checkDefined(ue.program);
                      return ve(ue, ir.emitBuildInfo(rr || e2.maybeBind(l, l.writeFile), Ie), ir, 1, false, true);
                    }
                    de = er.affectedFile, ye = er.emitKind, Ae = true;
                  }
                return ve(ue, e2.Debug.checkDefined(ue.program).emit(de === ue.program ? void 0 : de, de !== ue.program && e2.getEmitDeclarations(ue.compilerOptions) && !we ? Re(rr) : rr || e2.maybeBind(l, l.writeFile), Ie, _e || ye === 0, we), de, ye, Ae);
              }
              function Re(rr) {
                return function(Ie, _e, we, de, ye, Ae) {
                  var er;
                  if (e2.isDeclarationFileName(Ie)) {
                    e2.Debug.assert((ye == null ? void 0 : ye.length) === 1);
                    var ir = ye[0], Cr = ue.fileInfos.get(ir.resolvedPath), Ye = ((er = ue.currentAffectedFilesSignatures) === null || er === void 0 ? void 0 : er.get(ir.resolvedPath)) || Cr.signature;
                    if (Ye === ir.version) {
                      var Br = (ne || e2.generateDjb2Hash)((Ae == null ? void 0 : Ae.sourceMapUrlPos) !== void 0 ? _e.substring(0, Ae.sourceMapUrlPos) : _e);
                      Br !== ir.version && (l.storeFilesChangingSignatureDuringEmit && (ue.filesChangingSignature || (ue.filesChangingSignature = new e2.Set())).add(ir.resolvedPath), ue.exportedModulesMap && e2.BuilderState.updateExportedModules(ir, ir.exportedModulesFromDeclarationEmit, ue.currentAffectedFilesExportedModulesMap || (ue.currentAffectedFilesExportedModulesMap = e2.BuilderState.createManyToManyPathMap())), ue.affectedFiles && ue.affectedFilesIndex < ue.affectedFiles.length ? ue.currentAffectedFilesSignatures.set(ir.resolvedPath, Br) : (Cr.signature = Br, ue.exportedModulesMap && e2.BuilderState.updateExportedFilesMapFromCache(ue, ue.currentAffectedFilesExportedModulesMap)));
                    }
                  }
                  rr ? rr(Ie, _e, we, de, ye, Ae) : l.writeFile ? l.writeFile(Ie, _e, we, de, ye, Ae) : ue.program.writeFile(Ie, _e, we, de, ye, Ae);
                };
              }
              function ze(rr, Ie, _e, we, de) {
                var ye;
                j === y.EmitAndSemanticDiagnosticsBuilderProgram && N(ue, rr);
                var Ae = e2.handleNoEmitOptions(Z2, rr, Ie, _e);
                if (Ae)
                  return Ae;
                if (!rr)
                  if (j === y.EmitAndSemanticDiagnosticsBuilderProgram) {
                    for (var er = [], ir = false, Cr = void 0, Ye = [], Br = void 0; Br = ge(Ie, _e, we, de); )
                      ir = ir || Br.result.emitSkipped, Cr = e2.addRange(Cr, Br.result.diagnostics), Ye = e2.addRange(Ye, Br.result.emittedFiles), er = e2.addRange(er, Br.result.sourceMaps);
                    return { emitSkipped: ir, diagnostics: Cr || e2.emptyArray, emittedFiles: Ye, sourceMaps: er };
                  } else
                    !((ye = ue.affectedFilesPendingEmitKind) === null || ye === void 0) && ye.size && (e2.Debug.assert(j === y.SemanticDiagnosticsBuilderProgram), (!we || e2.every(ue.affectedFilesPendingEmit, function(Er, Ne) {
                      return Ne < ue.affectedFilesPendingEmitIndex || ue.affectedFilesPendingEmitKind.get(Er) === 0;
                    })) && m2(ue));
                return e2.Debug.checkDefined(ue.program).emit(rr, !e2.outFile(ue.compilerOptions) && e2.getEmitDeclarations(ue.compilerOptions) && !de ? Re(Ie) : Ie || e2.maybeBind(l, l.writeFile), _e, we, de);
              }
              function Ee(rr, Ie) {
                for (; ; ) {
                  var _e = p(ue, rr, ne, l);
                  if (_e) {
                    if (_e === ue.program)
                      return O(ue, ue.program.getSemanticDiagnostics(void 0, rr), _e);
                  } else
                    return;
                  if ((j === y.EmitAndSemanticDiagnosticsBuilderProgram || ue.compilerOptions.noEmit || ue.compilerOptions.noEmitOnError) && P(ue, _e.resolvedPath, 1), Ie && Ie(_e)) {
                    q(ue, _e);
                    continue;
                  }
                  return O(ue, ee(ue, _e, rr), _e);
                }
              }
              function He(rr, Ie) {
                N(ue, rr);
                var _e = e2.Debug.checkDefined(ue.program).getCompilerOptions();
                if (e2.outFile(_e))
                  return e2.Debug.assert(!ue.semanticDiagnosticsPerFile), e2.Debug.checkDefined(ue.program).getSemanticDiagnostics(rr, Ie);
                if (rr)
                  return ee(ue, rr, Ie);
                for (; Ee(Ie); )
                  ;
                for (var we, de = 0, ye = e2.Debug.checkDefined(ue.program).getSourceFiles(); de < ye.length; de++) {
                  var Ae = ye[de];
                  we = e2.addRange(we, ee(ue, Ae, Ie));
                }
                return we || e2.emptyArray;
              }
            }
            e2.createBuilderProgram = L;
            function P(j, H, I) {
              j.affectedFilesPendingEmit || (j.affectedFilesPendingEmit = []), j.affectedFilesPendingEmitKind || (j.affectedFilesPendingEmitKind = new e2.Map());
              var l = j.affectedFilesPendingEmitKind.get(H);
              j.affectedFilesPendingEmit.push(H), j.affectedFilesPendingEmitKind.set(H, l || I), j.affectedFilesPendingEmitIndex === void 0 && (j.affectedFilesPendingEmitIndex = 0);
            }
            function k(j) {
              return e2.isString(j) ? { version: j, signature: j, affectsGlobalScope: void 0, impliedFormat: void 0 } : e2.isString(j.signature) ? j : { version: j.version, signature: j.signature === false ? void 0 : j.version, affectsGlobalScope: j.affectsGlobalScope, impliedFormat: j.impliedFormat };
            }
            e2.toBuilderStateFileInfo = k;
            function Y(j, H, I) {
              var l, d = e2.getDirectoryPath(e2.getNormalizedAbsolutePath(H, I.getCurrentDirectory())), D = e2.createGetCanonicalFileName(I.useCaseSensitiveFileNames()), fe = j.fileNames.map(We), g = (l = j.fileIdsList) === null || l === void 0 ? void 0 : l.map(function(Re) {
                return new e2.Set(Re.map(Z2));
              }), ne = new e2.Map();
              j.fileInfos.forEach(function(Re, ze) {
                return ne.set(Z2(ze + 1), k(Re));
              });
              var ue = { fileInfos: ne, compilerOptions: j.options ? e2.convertToOptionsWithAbsolutePaths(j.options, Fe) : {}, referencedMap: ge(j.referencedMap), exportedModulesMap: ge(j.exportedModulesMap), semanticDiagnosticsPerFile: j.semanticDiagnosticsPerFile && e2.arrayToMap(j.semanticDiagnosticsPerFile, function(Re) {
                return Z2(e2.isNumber(Re) ? Re : Re[0]);
              }, function(Re) {
                return e2.isNumber(Re) ? e2.emptyArray : Re[1];
              }), hasReusableDiagnostic: true, affectedFilesPendingEmit: e2.map(j.affectedFilesPendingEmit, function(Re) {
                return Z2(Re[0]);
              }), affectedFilesPendingEmitKind: j.affectedFilesPendingEmit && e2.arrayToMap(j.affectedFilesPendingEmit, function(Re) {
                return Z2(Re[0]);
              }, function(Re) {
                return Re[1];
              }), affectedFilesPendingEmitIndex: j.affectedFilesPendingEmit && 0 };
              return { getState: function() {
                return ue;
              }, backupState: e2.noop, restoreState: e2.noop, getProgram: e2.notImplemented, getProgramOrUndefined: e2.returnUndefined, releaseProgram: e2.noop, getCompilerOptions: function() {
                return ue.compilerOptions;
              }, getSourceFile: e2.notImplemented, getSourceFiles: e2.notImplemented, getOptionsDiagnostics: e2.notImplemented, getGlobalDiagnostics: e2.notImplemented, getConfigFileParsingDiagnostics: e2.notImplemented, getSyntacticDiagnostics: e2.notImplemented, getDeclarationDiagnostics: e2.notImplemented, getSemanticDiagnostics: e2.notImplemented, emit: e2.notImplemented, getAllDependencies: e2.notImplemented, getCurrentDirectory: e2.notImplemented, emitNextAffectedFile: e2.notImplemented, getSemanticDiagnosticsOfNextAffectedFile: e2.notImplemented, emitBuildInfo: e2.notImplemented, close: e2.noop };
              function We(Re) {
                return e2.toPath(Re, d, D);
              }
              function Fe(Re) {
                return e2.getNormalizedAbsolutePath(Re, d);
              }
              function Z2(Re) {
                return fe[Re - 1];
              }
              function Be(Re) {
                return g[Re - 1];
              }
              function ge(Re) {
                if (!!Re) {
                  var ze = e2.BuilderState.createManyToManyPathMap();
                  return Re.forEach(function(Ee) {
                    var He = Ee[0], rr = Ee[1];
                    return ze.set(Z2(He), Be(rr));
                  }), ze;
                }
              }
            }
            e2.createBuildProgramUsingProgramBuildInfo = Y;
            function U(j, H) {
              return { getState: e2.notImplemented, backupState: e2.noop, restoreState: e2.noop, getProgram: I, getProgramOrUndefined: function() {
                return j().program;
              }, releaseProgram: function() {
                return j().program = void 0;
              }, getCompilerOptions: function() {
                return j().compilerOptions;
              }, getSourceFile: function(l) {
                return I().getSourceFile(l);
              }, getSourceFiles: function() {
                return I().getSourceFiles();
              }, getOptionsDiagnostics: function(l) {
                return I().getOptionsDiagnostics(l);
              }, getGlobalDiagnostics: function(l) {
                return I().getGlobalDiagnostics(l);
              }, getConfigFileParsingDiagnostics: function() {
                return H;
              }, getSyntacticDiagnostics: function(l, d) {
                return I().getSyntacticDiagnostics(l, d);
              }, getDeclarationDiagnostics: function(l, d) {
                return I().getDeclarationDiagnostics(l, d);
              }, getSemanticDiagnostics: function(l, d) {
                return I().getSemanticDiagnostics(l, d);
              }, emit: function(l, d, D, fe, g) {
                return I().emit(l, d, D, fe, g);
              }, emitBuildInfo: function(l, d) {
                return I().emitBuildInfo(l, d);
              }, getAllDependencies: e2.notImplemented, getCurrentDirectory: function() {
                return I().getCurrentDirectory();
              }, close: e2.noop };
              function I() {
                return e2.Debug.checkDefined(j().program);
              }
            }
            e2.createRedirectedBuilderProgram = U;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(B, E, Q, le, N, p) {
              return e2.createBuilderProgram(e2.BuilderProgramKind.SemanticDiagnosticsBuilderProgram, e2.getBuilderCreationParameters(B, E, Q, le, N, p));
            }
            e2.createSemanticDiagnosticsBuilderProgram = a;
            function C(B, E, Q, le, N, p) {
              return e2.createBuilderProgram(e2.BuilderProgramKind.EmitAndSemanticDiagnosticsBuilderProgram, e2.getBuilderCreationParameters(B, E, Q, le, N, p));
            }
            e2.createEmitAndSemanticDiagnosticsBuilderProgram = C;
            function w(B, E, Q, le, N, p) {
              var m2 = e2.getBuilderCreationParameters(B, E, Q, le, N, p), G = m2.newProgram, oe = m2.configFileParsingDiagnostics;
              return e2.createRedirectedBuilderProgram(function() {
                return { program: G, compilerOptions: G.getCompilerOptions() };
              }, oe);
            }
            e2.createAbstractBuilder = w;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(E) {
              return e2.endsWith(E, "/node_modules/.staging") ? e2.removeSuffix(E, "/.staging") : e2.some(e2.ignoredPaths, function(Q) {
                return e2.stringContains(E, Q);
              }) ? void 0 : E;
            }
            e2.removeIgnoredPath = a;
            function C(E) {
              var Q = e2.getRootLength(E);
              if (E.length === Q)
                return false;
              var le = E.indexOf(e2.directorySeparator, Q);
              if (le === -1)
                return false;
              var N = E.substring(Q, le + 1), p = Q > 1 || E.charCodeAt(0) !== 47;
              if (p && E.search(/[a-zA-Z]:/) !== 0 && N.search(/[a-zA-z]\$\//) === 0) {
                if (le = E.indexOf(e2.directorySeparator, le + 1), le === -1)
                  return false;
                N = E.substring(Q + N.length, le + 1);
              }
              if (p && N.search(/users\//i) !== 0)
                return true;
              for (var m2 = le + 1, G = 2; G > 0; G--)
                if (m2 = E.indexOf(e2.directorySeparator, m2) + 1, m2 === 0)
                  return false;
              return true;
            }
            e2.canWatchDirectory = C;
            function w(E, Q, le) {
              var N, p, m2, G = e2.createMultiMap(), oe = [], f4 = e2.createMultiMap(), T = false, K, b, se, J = e2.memoize(function() {
                return E.getCurrentDirectory();
              }), ie = E.getCachedDirectoryStructureHost(), R = new e2.Map(), q = e2.createCacheWithRedirects(), O = e2.createCacheWithRedirects(), ve = e2.createModuleResolutionCache(J(), E.getCanonicalFileName, void 0, q, O), ee = new e2.Map(), he = e2.createCacheWithRedirects(), F2 = e2.createTypeReferenceDirectiveResolutionCache(J(), E.getCanonicalFileName, void 0, ve.getPackageJsonInfoCache(), he), x2 = [".ts", ".tsx", ".js", ".jsx", ".json"], X = new e2.Map(), $ = new e2.Map(), A2 = Q && e2.removeTrailingDirectorySeparator(e2.getNormalizedAbsolutePath(Q, J())), y = A2 && E.toPath(A2), V = y !== void 0 ? y.split(e2.directorySeparator).length : 0, L = new e2.Map();
              return { getModuleResolutionCache: function() {
                return ve;
              }, startRecordingFilesWithChangedResolutions: j, finishRecordingFilesWithChangedResolutions: H, startCachingPerDirectoryResolution: d, finishCachingPerDirectoryResolution: D, resolveModuleNames: We, getResolvedModuleWithFailedLookupLocationsFromCache: Fe, resolveTypeReferenceDirectives: ue, removeResolutionsFromProjectReferenceRedirects: ye, removeResolutionsOfFile: Ae, hasChangedAutomaticTypeDirectiveNames: function() {
                return T;
              }, invalidateResolutionOfFile: ir, invalidateResolutionsOfFailedLookupLocations: Br, setFilesWithInvalidatedNonRelativeUnresolvedImports: Cr, createHasInvalidatedResolution: l, isFileWithInvalidatedNonRelativeUnresolvedImports: I, updateTypeRootsWatch: be, closeTypeRootsWatch: Ne, clear: U };
              function P(ur) {
                return ur.resolvedModule;
              }
              function k(ur) {
                return ur.resolvedTypeReferenceDirective;
              }
              function Y(ur, yr) {
                return ur === void 0 || yr.length <= ur.length ? false : e2.startsWith(yr, ur) && yr[ur.length] === e2.directorySeparator;
              }
              function U() {
                e2.clearMap($, e2.closeFileWatcherOf), X.clear(), G.clear(), Ne(), R.clear(), ee.clear(), f4.clear(), oe.length = 0, K = void 0, b = void 0, se = void 0, d(), T = false;
              }
              function j() {
                N = [];
              }
              function H() {
                var ur = N;
                return N = void 0, ur;
              }
              function I(ur) {
                if (!m2)
                  return false;
                var yr = m2.get(ur);
                return !!yr && !!yr.length;
              }
              function l(ur) {
                if (Br(), ur)
                  return p = void 0, e2.returnTrue;
                var yr = p;
                return p = void 0, function(Ir) {
                  return !!yr && yr.has(Ir) || I(Ir);
                };
              }
              function d() {
                ve.clear(), F2.clear(), G.forEach(He), G.clear();
              }
              function D() {
                m2 = void 0, d(), $.forEach(function(ur, yr) {
                  ur.refCount === 0 && ($.delete(yr), ur.watcher.close());
                }), T = false;
              }
              function fe(ur, yr, Ir, wr, Ur, ii, mi) {
                var pe, or = e2.resolveModuleName(ur, yr, Ir, wr, ve, Ur, mi);
                if (!E.getGlobalCache)
                  return or;
                var qr = E.getGlobalCache();
                if (qr !== void 0 && !e2.isExternalModuleNameRelative(ur) && !(or.resolvedModule && e2.extensionIsTS(or.resolvedModule.extension))) {
                  var si = e2.loadModuleFromGlobalCache(e2.Debug.checkDefined(E.globalCacheResolutionModuleName)(ur), E.projectName, Ir, wr, qr, ve), Di = si.resolvedModule, wi = si.failedLookupLocations;
                  if (Di)
                    return or.resolvedModule = Di, (pe = or.failedLookupLocations).push.apply(pe, wi), or;
                }
                return or;
              }
              function g(ur, yr, Ir, wr, Ur, ii, mi) {
                return e2.resolveTypeReferenceDirective(ur, yr, Ir, wr, Ur, F2, mi);
              }
              function ne(ur) {
                var yr, Ir, wr, Ur = ur.names, ii = ur.containingFile, mi = ur.redirectedReference, pe = ur.cache, or = ur.perDirectoryCacheWithRedirects, qr = ur.loader, si = ur.getResolutionWithResolvedFileName, Di = ur.shouldRetryResolution, wi = ur.reusedNames, Xi = ur.logChanges, et = ur.containingSourceFile, Gi = ur.containingSourceFileMode, Wt = E.toPath(ii), Zt = pe.get(Wt) || pe.set(Wt, e2.createModeAwareCache()).get(Wt), _r = e2.getDirectoryPath(Wt), pi = or.getOrCreateMapOfCacheRedirects(mi), ae = pi.get(_r);
                ae || (ae = e2.createModeAwareCache(), pi.set(_r, ae));
                for (var Xe = [], Jr = E.getCompilationSettings(), ti = Xi && I(Wt), Ze = E.getCurrentProgram(), Sr = Ze && Ze.getResolvedProjectReferenceToRedirect(ii), zr = Sr ? !mi || mi.sourceFile.path !== Sr.sourceFile.path : !!mi, Wr = e2.createModeAwareCache(), Je = 0, xe = 0, vr = Ur; xe < vr.length; xe++) {
                  var mr = vr[xe], Ar = e2.isString(mr) ? mr : mr.fileName.toLowerCase(), Oe = e2.isString(mr) ? et ? e2.getModeForResolutionAtIndex(et, Je) : void 0 : e2.getModeForFileReference(mr, Gi);
                  Je++;
                  var nr = Zt.get(Ar, Oe);
                  if (!Wr.has(Ar, Oe) && zr || !nr || nr.isInvalidated || ti && !e2.isExternalModuleNameRelative(Ar) && Di(nr)) {
                    var Mr = nr, Pe = ae.get(Ar, Oe);
                    if (Pe) {
                      nr = Pe;
                      var Ue = ((yr = E.getCompilerHost) === null || yr === void 0 ? void 0 : yr.call(E)) || E;
                      if (e2.isTraceEnabled(Jr, Ue)) {
                        var fr = si(nr);
                        e2.trace(Ue, qr === fe ? fr != null && fr.resolvedFileName ? fr.packagetId ? e2.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4 : e2.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3 : e2.Diagnostics.Reusing_resolution_of_module_0_from_1_found_in_cache_from_location_2_it_was_not_resolved : fr != null && fr.resolvedFileName ? fr.packagetId ? e2.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3_with_Package_ID_4 : e2.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_successfully_resolved_to_3 : e2.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_found_in_cache_from_location_2_it_was_not_resolved, Ar, ii, e2.getDirectoryPath(ii), fr == null ? void 0 : fr.resolvedFileName, (fr == null ? void 0 : fr.packagetId) && e2.packageIdToString(fr.packagetId));
                      }
                    } else
                      nr = qr(Ar, ii, Jr, ((Ir = E.getCompilerHost) === null || Ir === void 0 ? void 0 : Ir.call(E)) || E, mi, et, Oe), ae.set(Ar, Oe, nr), E.onDiscoveredSymlink && B(nr) && E.onDiscoveredSymlink();
                    Zt.set(Ar, Oe, nr), ze(Ar, nr, Wt, si), Mr && Ie(Mr, Wt, si), Xi && N && !De(Mr, nr) && (N.push(Wt), Xi = false);
                  } else {
                    var Ue = ((wr = E.getCompilerHost) === null || wr === void 0 ? void 0 : wr.call(E)) || E;
                    if (e2.isTraceEnabled(Jr, Ue) && !Wr.has(Ar, Oe)) {
                      var fr = si(nr);
                      e2.trace(Ue, qr === fe ? fr != null && fr.resolvedFileName ? fr.packagetId ? e2.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : e2.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : e2.Diagnostics.Reusing_resolution_of_module_0_from_1_of_old_program_it_was_not_resolved : fr != null && fr.resolvedFileName ? fr.packagetId ? e2.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2_with_Package_ID_3 : e2.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_successfully_resolved_to_2 : e2.Diagnostics.Reusing_resolution_of_type_reference_directive_0_from_1_of_old_program_it_was_not_resolved, Ar, ii, fr == null ? void 0 : fr.resolvedFileName, (fr == null ? void 0 : fr.packagetId) && e2.packageIdToString(fr.packagetId));
                    }
                  }
                  e2.Debug.assert(nr !== void 0 && !nr.isInvalidated), Wr.set(Ar, Oe, true), Xe.push(si(nr));
                }
                return Zt.forEach(function(gr, Vr, Tr) {
                  !Wr.has(Vr, Tr) && !e2.contains(wi, Vr) && (Ie(gr, Wt, si), Zt.delete(Vr, Tr));
                }), Xe;
                function De(gr, Vr) {
                  if (gr === Vr)
                    return true;
                  if (!gr || !Vr)
                    return false;
                  var Tr = si(gr), vi = si(Vr);
                  return Tr === vi ? true : !Tr || !vi ? false : Tr.resolvedFileName === vi.resolvedFileName;
                }
              }
              function ue(ur, yr, Ir, wr) {
                return ne({ names: ur, containingFile: yr, redirectedReference: Ir, cache: ee, perDirectoryCacheWithRedirects: he, loader: g, getResolutionWithResolvedFileName: k, shouldRetryResolution: function(Ur) {
                  return Ur.resolvedTypeReferenceDirective === void 0;
                }, containingSourceFileMode: wr });
              }
              function We(ur, yr, Ir, wr, Ur) {
                return ne({ names: ur, containingFile: yr, redirectedReference: wr, cache: R, perDirectoryCacheWithRedirects: q, loader: fe, getResolutionWithResolvedFileName: P, shouldRetryResolution: function(ii) {
                  return !ii.resolvedModule || !e2.resolutionExtensionIsTSOrJson(ii.resolvedModule.extension);
                }, reusedNames: Ir, logChanges: le, containingSourceFile: Ur });
              }
              function Fe(ur, yr, Ir) {
                var wr = R.get(E.toPath(yr));
                if (!!wr)
                  return wr.get(ur, Ir);
              }
              function Z2(ur) {
                return e2.endsWith(ur, "/node_modules/@types");
              }
              function Be(ur, yr) {
                if (Y(y, yr)) {
                  ur = e2.isRootedDiskPath(ur) ? e2.normalizePath(ur) : e2.getNormalizedAbsolutePath(ur, J());
                  var Ir = yr.split(e2.directorySeparator), wr = ur.split(e2.directorySeparator);
                  return e2.Debug.assert(wr.length === Ir.length, "FailedLookup: ".concat(ur, " failedLookupLocationPath: ").concat(yr)), Ir.length > V + 1 ? { dir: wr.slice(0, V + 1).join(e2.directorySeparator), dirPath: Ir.slice(0, V + 1).join(e2.directorySeparator) } : { dir: A2, dirPath: y, nonRecursive: false };
                }
                return ge(e2.getDirectoryPath(e2.getNormalizedAbsolutePath(ur, J())), e2.getDirectoryPath(yr));
              }
              function ge(ur, yr) {
                for (; e2.pathContainsNodeModules(yr); )
                  ur = e2.getDirectoryPath(ur), yr = e2.getDirectoryPath(yr);
                if (e2.isNodeModulesDirectory(yr))
                  return C(e2.getDirectoryPath(yr)) ? { dir: ur, dirPath: yr } : void 0;
                var Ir = true, wr, Ur;
                if (y !== void 0)
                  for (; !Y(yr, y); ) {
                    var ii = e2.getDirectoryPath(yr);
                    if (ii === yr)
                      break;
                    Ir = false, wr = yr, Ur = ur, yr = ii, ur = e2.getDirectoryPath(ur);
                  }
                return C(yr) ? { dir: Ur || ur, dirPath: wr || yr, nonRecursive: Ir } : void 0;
              }
              function Re(ur) {
                return e2.fileExtensionIsOneOf(ur, x2);
              }
              function ze(ur, yr, Ir, wr) {
                if (yr.refCount)
                  yr.refCount++, e2.Debug.assertIsDefined(yr.files);
                else {
                  yr.refCount = 1, e2.Debug.assert(e2.length(yr.files) === 0), e2.isExternalModuleNameRelative(ur) ? Ee(yr) : G.add(ur, yr);
                  var Ur = wr(yr);
                  Ur && Ur.resolvedFileName && f4.add(E.toPath(Ur.resolvedFileName), yr);
                }
                (yr.files || (yr.files = [])).push(Ir);
              }
              function Ee(ur) {
                e2.Debug.assert(!!ur.refCount);
                var yr = ur.failedLookupLocations;
                if (!!yr.length) {
                  oe.push(ur);
                  for (var Ir = false, wr = 0, Ur = yr; wr < Ur.length; wr++) {
                    var ii = Ur[wr], mi = E.toPath(ii), pe = Be(ii, mi);
                    if (pe) {
                      var or = pe.dir, qr = pe.dirPath, si = pe.nonRecursive;
                      if (!Re(mi)) {
                        var Di = X.get(mi) || 0;
                        X.set(mi, Di + 1);
                      }
                      qr === y ? (e2.Debug.assert(!si), Ir = true) : rr(or, qr, si);
                    }
                  }
                  Ir && rr(A2, y, true);
                }
              }
              function He(ur, yr) {
                var Ir = E.getCurrentProgram();
                (!Ir || !Ir.getTypeChecker().tryFindAmbientModuleWithoutAugmentations(yr)) && ur.forEach(Ee);
              }
              function rr(ur, yr, Ir) {
                var wr = $.get(yr);
                wr ? (e2.Debug.assert(!!Ir == !!wr.nonRecursive), wr.refCount++) : $.set(yr, { watcher: we(ur, yr, Ir), refCount: 1, nonRecursive: Ir });
              }
              function Ie(ur, yr, Ir) {
                if (e2.unorderedRemoveItem(e2.Debug.checkDefined(ur.files), yr), ur.refCount--, !ur.refCount) {
                  var wr = Ir(ur);
                  if (wr && wr.resolvedFileName && f4.remove(E.toPath(wr.resolvedFileName), ur), !!e2.unorderedRemoveItem(oe, ur)) {
                    for (var Ur = ur.failedLookupLocations, ii = false, mi = 0, pe = Ur; mi < pe.length; mi++) {
                      var or = pe[mi], qr = E.toPath(or), si = Be(or, qr);
                      if (si) {
                        var Di = si.dirPath, wi = X.get(qr);
                        wi && (wi === 1 ? X.delete(qr) : (e2.Debug.assert(wi > 1), X.set(qr, wi - 1))), Di === y ? ii = true : _e(Di);
                      }
                    }
                    ii && _e(y);
                  }
                }
              }
              function _e(ur) {
                var yr = $.get(ur);
                yr.refCount--;
              }
              function we(ur, yr, Ir) {
                return E.watchDirectoryOfFailedLookupLocation(ur, function(wr) {
                  var Ur = E.toPath(wr);
                  ie && ie.addOrDeleteFileOrDirectory(wr, Ur), Ye(Ur, yr === Ur);
                }, Ir ? 0 : 1);
              }
              function de(ur, yr, Ir) {
                var wr = ur.get(yr);
                wr && (wr.forEach(function(Ur) {
                  return Ie(Ur, yr, Ir);
                }), ur.delete(yr));
              }
              function ye(ur) {
                if (!!e2.fileExtensionIs(ur, ".json")) {
                  var yr = E.getCurrentProgram();
                  if (!!yr) {
                    var Ir = yr.getResolvedProjectReferenceByPath(ur);
                    !Ir || Ir.commandLine.fileNames.forEach(function(wr) {
                      return Ae(E.toPath(wr));
                    });
                  }
                }
              }
              function Ae(ur) {
                de(R, ur, P), de(ee, ur, k);
              }
              function er(ur, yr) {
                if (!ur)
                  return false;
                for (var Ir = false, wr = 0, Ur = ur; wr < Ur.length; wr++) {
                  var ii = Ur[wr];
                  if (!(ii.isInvalidated || !yr(ii))) {
                    ii.isInvalidated = Ir = true;
                    for (var mi = 0, pe = e2.Debug.checkDefined(ii.files); mi < pe.length; mi++) {
                      var or = pe[mi];
                      (p || (p = new e2.Set())).add(or), T = T || e2.endsWith(or, e2.inferredTypesContainingFile);
                    }
                  }
                }
                return Ir;
              }
              function ir(ur) {
                Ae(ur);
                var yr = T;
                er(f4.get(ur), e2.returnTrue) && T && !yr && E.onChangedAutomaticTypeDirectiveNames();
              }
              function Cr(ur) {
                e2.Debug.assert(m2 === ur || m2 === void 0), m2 = ur;
              }
              function Ye(ur, yr) {
                if (yr)
                  (se || (se = [])).push(ur);
                else {
                  var Ir = a(ur);
                  if (!Ir || (ur = Ir, E.fileIsOpen(ur)))
                    return false;
                  var wr = e2.getDirectoryPath(ur);
                  if (Z2(ur) || e2.isNodeModulesDirectory(ur) || Z2(wr) || e2.isNodeModulesDirectory(wr))
                    (K || (K = [])).push(ur), (b || (b = new e2.Set())).add(ur);
                  else {
                    if (!Re(ur) && !X.has(ur) || e2.isEmittedFileOfProgram(E.getCurrentProgram(), ur))
                      return false;
                    (K || (K = [])).push(ur);
                    var Ur = e2.parseNodeModuleFromPath(ur);
                    Ur && (b || (b = new e2.Set())).add(Ur);
                  }
                }
                E.scheduleInvalidateResolutionsOfFailedLookupLocations();
              }
              function Br() {
                if (!K && !b && !se)
                  return false;
                var ur = er(oe, Er);
                return K = void 0, b = void 0, se = void 0, ur;
              }
              function Er(ur) {
                return ur.failedLookupLocations.some(function(yr) {
                  var Ir = E.toPath(yr);
                  return e2.contains(K, Ir) || e2.firstDefinedIterator((b == null ? void 0 : b.keys()) || e2.emptyIterator, function(wr) {
                    return e2.startsWith(Ir, wr) ? true : void 0;
                  }) || (se == null ? void 0 : se.some(function(wr) {
                    return Y(wr, Ir);
                  }));
                });
              }
              function Ne() {
                e2.clearMap(L, e2.closeFileWatcher);
              }
              function n(ur, yr) {
                if (Y(y, yr))
                  return y;
                var Ir = ge(ur, yr);
                return Ir && $.has(Ir.dirPath) ? Ir.dirPath : void 0;
              }
              function lr(ur, yr) {
                return E.watchTypeRootsDirectory(yr, function(Ir) {
                  var wr = E.toPath(Ir);
                  ie && ie.addOrDeleteFileOrDirectory(Ir, wr), T = true, E.onChangedAutomaticTypeDirectiveNames();
                  var Ur = n(yr, ur);
                  Ur && Ye(wr, Ur === wr);
                }, 1);
              }
              function be() {
                var ur = E.getCompilationSettings();
                if (ur.types) {
                  Ne();
                  return;
                }
                var yr = e2.getEffectiveTypeRoots(ur, { directoryExists: Ge, getCurrentDirectory: J });
                yr ? e2.mutateMap(L, e2.arrayToMap(yr, function(Ir) {
                  return E.toPath(Ir);
                }), { createNewValue: lr, onDeleteValue: e2.closeFileWatcher }) : Ne();
              }
              function Ge(ur) {
                var yr = e2.getDirectoryPath(e2.getDirectoryPath(ur)), Ir = E.toPath(yr);
                return Ir === y || C(Ir);
              }
            }
            e2.createResolutionCache = w;
            function B(E) {
              var Q, le;
              return !!(((Q = E.resolvedModule) === null || Q === void 0 ? void 0 : Q.originalPath) || ((le = E.resolvedTypeReferenceDirective) === null || le === void 0 ? void 0 : le.originalPath));
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(I) {
                I[I.Relative = 0] = "Relative", I[I.NonRelative = 1] = "NonRelative", I[I.Shortest = 2] = "Shortest", I[I.ExternalNonRelative = 3] = "ExternalNonRelative";
              })(w || (w = {}));
              var B;
              (function(I) {
                I[I.Minimal = 0] = "Minimal", I[I.Index = 1] = "Index", I[I.JsExtension = 2] = "JsExtension";
              })(B || (B = {}));
              function E(I, l, d, D) {
                var fe = l.importModuleSpecifierPreference, g = l.importModuleSpecifierEnding;
                return { relativePreference: fe === "relative" ? 0 : fe === "non-relative" ? 1 : fe === "project-relative" ? 3 : 2, ending: ne() };
                function ne() {
                  switch (g) {
                    case "minimal":
                      return 0;
                    case "index":
                      return 1;
                    case "js":
                      return 2;
                    default:
                      return q(D) || le(d, D.path, I) ? 2 : e2.getEmitModuleResolutionKind(d) !== e2.ModuleResolutionKind.NodeJs ? 1 : 0;
                  }
                }
              }
              function Q(I, l, d, D) {
                return { relativePreference: e2.isExternalModuleNameRelative(l) ? 0 : 1, ending: e2.hasJSFileExtension(l) || le(I, d, D) ? 2 : e2.getEmitModuleResolutionKind(I) !== e2.ModuleResolutionKind.NodeJs || e2.endsWith(l, "index") ? 1 : 0 };
              }
              function le(I, l, d) {
                var D;
                return e2.getEmitModuleResolutionKind(I) !== e2.ModuleResolutionKind.Node16 && e2.getEmitModuleResolutionKind(I) !== e2.ModuleResolutionKind.NodeNext ? false : e2.getImpliedNodeFormatForFile(l, (D = d.getPackageJsonInfoCache) === null || D === void 0 ? void 0 : D.call(d), N(d), I) !== e2.ModuleKind.CommonJS;
              }
              function N(I) {
                var l;
                return { fileExists: I.fileExists, readFile: e2.Debug.checkDefined(I.readFile), directoryExists: I.directoryExists, getCurrentDirectory: I.getCurrentDirectory, realpath: I.realpath, useCaseSensitiveFileNames: (l = I.useCaseSensitiveFileNames) === null || l === void 0 ? void 0 : l.call(I) };
              }
              function p(I, l, d, D, fe, g, ne) {
                ne === void 0 && (ne = {});
                var ue = oe(I, l, d, D, fe, Q(I, g, d, fe), {}, ne);
                if (ue !== g)
                  return ue;
              }
              C.updateModuleSpecifier = p;
              function m2(I, l, d, D, fe, g) {
                return g === void 0 && (g = {}), oe(I, l, d, D, fe, E(fe, {}, I, l), {}, g);
              }
              C.getModuleSpecifier = m2;
              function G(I, l, d, D, fe, g) {
                g === void 0 && (g = {});
                var ne = J(l.path, D), ue = he(l.path, d, D, fe, g);
                return e2.firstDefined(ue, function(We) {
                  return V(We, ne, l, D, I, fe, true, g.overrideImportMode);
                });
              }
              C.getNodeModulesPackageName = G;
              function oe(I, l, d, D, fe, g, ne, ue) {
                ue === void 0 && (ue = {});
                var We = J(d, fe), Fe = he(d, D, fe, ne, ue);
                return e2.firstDefined(Fe, function(Z2) {
                  return V(Z2, We, l, fe, I, ne, void 0, ue.overrideImportMode);
                }) || ie(D, We, I, fe, g);
              }
              function f4(I, l, d, D, fe) {
                return fe === void 0 && (fe = {}), T(I, l, d, D, fe)[0];
              }
              C.tryGetModuleSpecifiersFromCache = f4;
              function T(I, l, d, D, fe) {
                var g;
                fe === void 0 && (fe = {});
                var ne = e2.getSourceFileOfModule(I);
                if (!ne)
                  return e2.emptyArray;
                var ue = (g = d.getModuleSpecifierCache) === null || g === void 0 ? void 0 : g.call(d), We = ue == null ? void 0 : ue.get(l.path, ne.path, D, fe);
                return [We == null ? void 0 : We.moduleSpecifiers, ne, We == null ? void 0 : We.modulePaths, ue];
              }
              function K(I, l, d, D, fe, g, ne) {
                return ne === void 0 && (ne = {}), b(I, l, d, D, fe, g, ne).moduleSpecifiers;
              }
              C.getModuleSpecifiers = K;
              function b(I, l, d, D, fe, g, ne) {
                ne === void 0 && (ne = {});
                var ue = false, We = x2(I, l);
                if (We)
                  return { moduleSpecifiers: [We], computedWithoutCache: ue };
                var Fe = T(I, D, fe, g, ne), Z2 = Fe[0], Be = Fe[1], ge = Fe[2], Re = Fe[3];
                if (Z2)
                  return { moduleSpecifiers: Z2, computedWithoutCache: ue };
                if (!Be)
                  return { moduleSpecifiers: e2.emptyArray, computedWithoutCache: ue };
                ue = true, ge || (ge = F2(D.path, Be.originalFileName, fe));
                var ze = se(ge, d, D, fe, g, ne);
                return Re == null || Re.set(D.path, Be.path, g, ne, ge, ze), { moduleSpecifiers: ze, computedWithoutCache: ue };
              }
              C.getModuleSpecifiersWithCacheInfo = b;
              function se(I, l, d, D, fe, g) {
                g === void 0 && (g = {});
                var ne = J(d.path, D), ue = E(D, fe, l, d), We = e2.forEach(I, function(_e) {
                  return e2.forEach(D.getFileIncludeReasons().get(e2.toPath(_e.path, D.getCurrentDirectory(), ne.getCanonicalFileName)), function(we) {
                    if (!(we.kind !== e2.FileIncludeKind.Import || we.file !== d.path) && !(d.impliedNodeFormat && d.impliedNodeFormat !== e2.getModeForResolutionAtIndex(d, we.index))) {
                      var de = e2.getModuleNameStringLiteralAt(d, we.index).text;
                      return ue.relativePreference !== 1 || !e2.pathIsRelative(de) ? de : void 0;
                    }
                  });
                });
                if (We) {
                  var Fe = [We];
                  return Fe;
                }
                for (var Z2 = e2.some(I, function(_e) {
                  return _e.isInNodeModules;
                }), Be, ge, Re, ze = 0, Ee = I; ze < Ee.length; ze++) {
                  var He = Ee[ze], rr = V(He, ne, d, D, l, fe, void 0, g.overrideImportMode);
                  if (Be = e2.append(Be, rr), rr && He.isRedirect)
                    return Be;
                  if (!rr && !He.isRedirect) {
                    var Ie = ie(He.path, ne, l, D, ue);
                    e2.pathIsBareSpecifier(Ie) ? ge = e2.append(ge, Ie) : (!Z2 || He.isInNodeModules) && (Re = e2.append(Re, Ie));
                  }
                }
                return ge != null && ge.length ? ge : Be != null && Be.length ? Be : e2.Debug.checkDefined(Re);
              }
              function J(I, l) {
                var d = e2.createGetCanonicalFileName(l.useCaseSensitiveFileNames ? l.useCaseSensitiveFileNames() : true), D = e2.getDirectoryPath(I);
                return { getCanonicalFileName: d, importingSourceFileName: I, sourceDirectory: D };
              }
              function ie(I, l, d, D, fe) {
                var g = fe.ending, ne = fe.relativePreference, ue = d.baseUrl, We = d.paths, Fe = d.rootDirs, Z2 = l.sourceDirectory, Be = l.getCanonicalFileName, ge = Fe && y(Fe, I, Z2, Be, g, d) || k(e2.ensurePathIsNonModuleName(e2.getRelativePathFromDirectory(Z2, I, Be)), g, d);
                if (!ue && !We || ne === 0)
                  return ge;
                var Re = e2.getNormalizedAbsolutePath(e2.getPathsBasePath(d, D) || ue, D.getCurrentDirectory()), ze = j(I, Re, Be);
                if (!ze)
                  return ge;
                var Ee = k(ze, g, d), He = We && X(e2.removeFileExtension(ze), Ee, We), rr = He === void 0 && ue !== void 0 ? Ee : He;
                if (!rr)
                  return ge;
                if (ne === 1)
                  return rr;
                if (ne === 3) {
                  var Ie = d.configFilePath ? e2.toPath(e2.getDirectoryPath(d.configFilePath), D.getCurrentDirectory(), l.getCanonicalFileName) : l.getCanonicalFileName(D.getCurrentDirectory()), _e = e2.toPath(I, Ie, Be), we = e2.startsWith(Z2, Ie), de = e2.startsWith(_e, Ie);
                  if (we && !de || !we && de)
                    return rr;
                  var ye = ve(D, e2.getDirectoryPath(_e)), Ae = ve(D, Z2);
                  return Ae !== ye ? rr : ge;
                }
                return ne !== 2 && e2.Debug.assertNever(ne), H(rr) || R(ge) < R(rr) ? ge : rr;
              }
              function R(I) {
                for (var l = 0, d = e2.startsWith(I, "./") ? 2 : 0; d < I.length; d++)
                  I.charCodeAt(d) === 47 && l++;
                return l;
              }
              C.countPathComponents = R;
              function q(I) {
                var l = I.imports;
                return e2.firstDefined(l, function(d) {
                  var D = d.text;
                  return e2.pathIsRelative(D) ? e2.hasJSFileExtension(D) : void 0;
                }) || false;
              }
              function O(I, l) {
                return e2.compareBooleans(l.isRedirect, I.isRedirect) || e2.compareNumberOfDirectorySeparators(I.path, l.path);
              }
              function ve(I, l) {
                return I.getNearestAncestorDirectoryWithPackageJson ? I.getNearestAncestorDirectoryWithPackageJson(l) : !!e2.forEachAncestorDirectory(l, function(d) {
                  return I.fileExists(e2.combinePaths(d, "package.json")) ? true : void 0;
                });
              }
              function ee(I, l, d, D, fe) {
                var g, ne = e2.hostGetCanonicalFileName(d), ue = d.getCurrentDirectory(), We = d.isSourceOfProjectReferenceRedirect(l) ? d.getProjectReferenceRedirect(l) : void 0, Fe = e2.toPath(l, ue, ne), Z2 = d.redirectTargetsMap.get(Fe) || e2.emptyArray, Be = Ve(Ve(Ve([], We ? [We] : e2.emptyArray, true), [l], false), Z2, true), ge = Be.map(function(Ie) {
                  return e2.getNormalizedAbsolutePath(Ie, ue);
                }), Re = !e2.every(ge, e2.containsIgnoredPath);
                if (!D) {
                  var ze = e2.forEach(ge, function(Ie) {
                    return !(Re && e2.containsIgnoredPath(Ie)) && fe(Ie, We === Ie);
                  });
                  if (ze)
                    return ze;
                }
                var Ee = (g = d.getSymlinkCache) === null || g === void 0 ? void 0 : g.call(d).getSymlinkedDirectoriesByRealpath(), He = e2.getNormalizedAbsolutePath(l, ue), rr = Ee && e2.forEachAncestorDirectory(e2.getDirectoryPath(He), function(Ie) {
                  var _e = Ee.get(e2.ensureTrailingDirectorySeparator(e2.toPath(Ie, ue, ne)));
                  if (!!_e)
                    return e2.startsWithDirectory(I, Ie, ne) ? false : e2.forEach(ge, function(we) {
                      if (!!e2.startsWithDirectory(we, Ie, ne))
                        for (var de = e2.getRelativePathFromDirectory(Ie, we, ne), ye = 0, Ae = _e; ye < Ae.length; ye++) {
                          var er = Ae[ye], ir = e2.resolvePath(er, de), Cr = fe(ir, we === We);
                          if (Re = true, Cr)
                            return Cr;
                        }
                    });
                });
                return rr || (D ? e2.forEach(ge, function(Ie) {
                  return Re && e2.containsIgnoredPath(Ie) ? void 0 : fe(Ie, Ie === We);
                }) : void 0);
              }
              C.forEachFileNameOfModule = ee;
              function he(I, l, d, D, fe) {
                var g;
                fe === void 0 && (fe = {});
                var ne = e2.toPath(l, d.getCurrentDirectory(), e2.hostGetCanonicalFileName(d)), ue = (g = d.getModuleSpecifierCache) === null || g === void 0 ? void 0 : g.call(d);
                if (ue) {
                  var We = ue.get(I, ne, D, fe);
                  if (We != null && We.modulePaths)
                    return We.modulePaths;
                }
                var Fe = F2(I, l, d);
                return ue && ue.setModulePaths(I, ne, D, fe, Fe), Fe;
              }
              function F2(I, l, d) {
                var D = e2.hostGetCanonicalFileName(d), fe = new e2.Map(), g = false;
                ee(I, l, d, true, function(ge, Re) {
                  var ze = e2.pathContainsNodeModules(ge);
                  fe.set(ge, { path: D(ge), isRedirect: Re, isInNodeModules: ze }), g = g || ze;
                });
                for (var ne = [], ue = function(ge) {
                  var Re = e2.ensureTrailingDirectorySeparator(ge), ze;
                  fe.forEach(function(He, rr) {
                    var Ie = He.path, _e = He.isRedirect, we = He.isInNodeModules;
                    e2.startsWith(Ie, Re) && ((ze || (ze = [])).push({ path: rr, isRedirect: _e, isInNodeModules: we }), fe.delete(rr));
                  }), ze && (ze.length > 1 && ze.sort(O), ne.push.apply(ne, ze));
                  var Ee = e2.getDirectoryPath(ge);
                  if (Ee === ge)
                    return We = ge, "break";
                  ge = Ee, We = ge;
                }, We, Fe = e2.getDirectoryPath(I); fe.size !== 0; ) {
                  var Z2 = ue(Fe);
                  if (Fe = We, Z2 === "break")
                    break;
                }
                if (fe.size) {
                  var Be = e2.arrayFrom(fe.values());
                  Be.length > 1 && Be.sort(O), ne.push.apply(ne, Be);
                }
                return ne;
              }
              function x2(I, l) {
                var d, D = (d = I.declarations) === null || d === void 0 ? void 0 : d.find(function(ne) {
                  return e2.isNonGlobalAmbientModule(ne) && (!e2.isExternalModuleAugmentation(ne) || !e2.isExternalModuleNameRelative(e2.getTextOfIdentifierOrLiteral(ne.name)));
                });
                if (D)
                  return D.name.text;
                var fe = e2.mapDefined(I.declarations, function(ne) {
                  var ue, We, Fe, Z2;
                  if (!e2.isModuleDeclaration(ne))
                    return;
                  var Be = Ee(ne);
                  if (!(((ue = Be == null ? void 0 : Be.parent) === null || ue === void 0 ? void 0 : ue.parent) && e2.isModuleBlock(Be.parent) && e2.isAmbientModule(Be.parent.parent) && e2.isSourceFile(Be.parent.parent.parent)))
                    return;
                  var ge = (Z2 = (Fe = (We = Be.parent.parent.symbol.exports) === null || We === void 0 ? void 0 : We.get("export=")) === null || Fe === void 0 ? void 0 : Fe.valueDeclaration) === null || Z2 === void 0 ? void 0 : Z2.expression;
                  if (!ge)
                    return;
                  var Re = l.getSymbolAtLocation(ge);
                  if (!Re)
                    return;
                  var ze = (Re == null ? void 0 : Re.flags) & 2097152 ? l.getAliasedSymbol(Re) : Re;
                  if (ze === ne.symbol)
                    return Be.parent.parent;
                  function Ee(He) {
                    for (; He.flags & 4; )
                      He = He.parent;
                    return He;
                  }
                }), g = fe[0];
                if (g)
                  return g.name.text;
              }
              function X(I, l, d) {
                for (var D in d)
                  for (var fe = 0, g = d[D]; fe < g.length; fe++) {
                    var ne = g[fe], ue = e2.removeFileExtension(e2.normalizePath(ne)), We = ue.indexOf("*");
                    if (We !== -1) {
                      var Fe = ue.substr(0, We), Z2 = ue.substr(We + 1);
                      if (l.length >= Fe.length + Z2.length && e2.startsWith(l, Fe) && e2.endsWith(l, Z2) || !Z2 && l === e2.removeTrailingDirectorySeparator(Fe)) {
                        var Be = l.substr(Fe.length, l.length - Z2.length - Fe.length);
                        return D.replace("*", Be);
                      }
                    } else if (ue === l || ue === I)
                      return D;
                  }
              }
              var $;
              (function(I) {
                I[I.Exact = 0] = "Exact", I[I.Directory = 1] = "Directory", I[I.Pattern = 2] = "Pattern";
              })($ || ($ = {}));
              function A2(I, l, d, D, fe, g, ne) {
                if (ne === void 0 && (ne = 0), typeof fe == "string") {
                  var ue = e2.getNormalizedAbsolutePath(e2.combinePaths(d, fe), void 0), We = e2.hasTSFileExtension(l) ? e2.removeFileExtension(l) + U(l, I) : void 0;
                  switch (ne) {
                    case 0:
                      if (e2.comparePaths(l, ue) === 0 || We && e2.comparePaths(We, ue) === 0)
                        return { moduleFileToTry: D };
                      break;
                    case 1:
                      if (e2.containsPath(ue, l)) {
                        var Fe = e2.getRelativePathFromDirectory(ue, l, false);
                        return { moduleFileToTry: e2.getNormalizedAbsolutePath(e2.combinePaths(e2.combinePaths(D, fe), Fe), void 0) };
                      }
                      break;
                    case 2:
                      var Z2 = ue.indexOf("*"), Be = ue.slice(0, Z2), ge = ue.slice(Z2 + 1);
                      if (e2.startsWith(l, Be) && e2.endsWith(l, ge)) {
                        var Re = l.slice(Be.length, l.length - ge.length);
                        return { moduleFileToTry: D.replace("*", Re) };
                      }
                      if (We && e2.startsWith(We, Be) && e2.endsWith(We, ge)) {
                        var Re = We.slice(Be.length, We.length - ge.length);
                        return { moduleFileToTry: D.replace("*", Re) };
                      }
                      break;
                  }
                } else {
                  if (Array.isArray(fe))
                    return e2.forEach(fe, function(_e) {
                      return A2(I, l, d, D, _e, g);
                    });
                  if (typeof fe == "object" && fe !== null) {
                    if (e2.allKeysStartWithDot(fe))
                      return e2.forEach(e2.getOwnKeys(fe), function(_e) {
                        var we = e2.getNormalizedAbsolutePath(e2.combinePaths(D, _e), void 0), de = e2.endsWith(_e, "/") ? 1 : e2.stringContains(_e, "*") ? 2 : 0;
                        return A2(I, l, d, we, fe[_e], g, de);
                      });
                    for (var ze = 0, Ee = e2.getOwnKeys(fe); ze < Ee.length; ze++) {
                      var He = Ee[ze];
                      if (He === "default" || g.indexOf(He) >= 0 || e2.isApplicableVersionedTypesKey(g, He)) {
                        var rr = fe[He], Ie = A2(I, l, d, D, rr, g);
                        if (Ie)
                          return Ie;
                      }
                    }
                  }
                }
              }
              function y(I, l, d, D, fe, g) {
                var ne = P(l, I, D);
                if (ne !== void 0) {
                  var ue = P(d, I, D), We = ue !== void 0 ? e2.ensurePathIsNonModuleName(e2.getRelativePathFromDirectory(ue, ne, D)) : ne;
                  return e2.getEmitModuleResolutionKind(g) === e2.ModuleResolutionKind.NodeJs ? k(We, fe, g) : e2.removeFileExtension(We);
                }
              }
              function V(I, l, d, D, fe, g, ne, ue) {
                var We = I.path, Fe = I.isRedirect, Z2 = l.getCanonicalFileName, Be = l.sourceDirectory;
                if (!D.fileExists || !D.readFile)
                  return;
                var ge = e2.getNodeModulePathParts(We);
                if (!ge)
                  return;
                var Re = We, ze = false;
                if (!ne)
                  for (var Ee = E(D, g, fe, d), He = ge.packageRootIndex, rr = void 0; ; ) {
                    var Ie = Ye(He), _e = Ie.moduleFileToTry, we = Ie.packageRootPath, de = Ie.blockedByExports, ye = Ie.verbatimFromExports;
                    if (e2.getEmitModuleResolutionKind(fe) !== e2.ModuleResolutionKind.Classic) {
                      if (de)
                        return;
                      if (ye)
                        return _e;
                    }
                    if (we) {
                      Re = we, ze = true;
                      break;
                    }
                    if (rr || (rr = _e), He = We.indexOf(e2.directorySeparator, He + 1), He === -1) {
                      Re = k(rr, Ee.ending, fe, D);
                      break;
                    }
                  }
                if (Fe && !ze)
                  return;
                var Ae = D.getGlobalTypingsCacheLocation && D.getGlobalTypingsCacheLocation(), er = Z2(Re.substring(0, ge.topLevelNodeModulesIndex));
                if (!(e2.startsWith(Be, er) || Ae && e2.startsWith(Z2(Ae), er)))
                  return;
                var ir = Re.substring(ge.topLevelPackageNameIndex + 1), Cr = e2.getPackageNameFromTypesPackageName(ir);
                return e2.getEmitModuleResolutionKind(fe) === e2.ModuleResolutionKind.Classic && Cr === ir ? void 0 : Cr;
                function Ye(Br) {
                  var Er, Ne, n = We.substring(0, Br), lr = e2.combinePaths(n, "package.json"), be = We, Ge = (Ne = (Er = D.getPackageJsonInfoCache) === null || Er === void 0 ? void 0 : Er.call(D)) === null || Ne === void 0 ? void 0 : Ne.getPackageJsonInfo(lr);
                  if (typeof Ge == "object" || Ge === void 0 && D.fileExists(lr)) {
                    var ur = (Ge == null ? void 0 : Ge.packageJsonContent) || JSON.parse(D.readFile(lr));
                    if (e2.getEmitModuleResolutionKind(fe) === e2.ModuleResolutionKind.Node16 || e2.getEmitModuleResolutionKind(fe) === e2.ModuleResolutionKind.NodeNext) {
                      var yr = ["node", ue || d.impliedNodeFormat === e2.ModuleKind.ESNext ? "import" : "require", "types"], Ir = ur.exports && typeof ur.name == "string" ? A2(fe, We, n, e2.getPackageNameFromTypesPackageName(ur.name), ur.exports, yr) : void 0;
                      if (Ir) {
                        var wr = e2.hasTSFileExtension(Ir.moduleFileToTry) ? { moduleFileToTry: e2.removeFileExtension(Ir.moduleFileToTry) + U(Ir.moduleFileToTry, fe) } : Ir;
                        return Ke(Ke({}, wr), { verbatimFromExports: true });
                      }
                      if (ur.exports)
                        return { moduleFileToTry: We, blockedByExports: true };
                    }
                    var Ur = ur.typesVersions ? e2.getPackageJsonTypesVersionsPaths(ur.typesVersions) : void 0;
                    if (Ur) {
                      var ii = We.slice(n.length + 1), mi = X(e2.removeFileExtension(ii), k(ii, 0, fe), Ur.paths);
                      mi !== void 0 && (be = e2.combinePaths(n, mi));
                    }
                    var pe = ur.typings || ur.types || ur.main || "index.js";
                    if (e2.isString(pe)) {
                      var or = e2.toPath(pe, n, Z2);
                      if (e2.removeFileExtension(or) === e2.removeFileExtension(Z2(be)))
                        return { packageRootPath: n, moduleFileToTry: be };
                    }
                  } else {
                    var qr = Z2(be.substring(ge.packageRootIndex + 1));
                    if (qr === "index.d.ts" || qr === "index.js" || qr === "index.ts" || qr === "index.tsx")
                      return { moduleFileToTry: be, packageRootPath: n };
                  }
                  return { moduleFileToTry: be };
                }
              }
              function L(I, l) {
                if (!!I.fileExists)
                  for (var d = e2.flatten(e2.getSupportedExtensions({ allowJs: true }, [{ extension: "node", isMixedContent: false }, { extension: "json", isMixedContent: false, scriptKind: 6 }])), D = 0, fe = d; D < fe.length; D++) {
                    var g = fe[D], ne = l + g;
                    if (I.fileExists(ne))
                      return ne;
                  }
              }
              function P(I, l, d) {
                return e2.firstDefined(l, function(D) {
                  var fe = j(I, D, d);
                  return fe !== void 0 && H(fe) ? void 0 : fe;
                });
              }
              function k(I, l, d, D) {
                if (e2.fileExtensionIsOneOf(I, [".json", ".mjs", ".cjs"]))
                  return I;
                var fe = e2.removeFileExtension(I);
                if (I === fe)
                  return I;
                if (e2.fileExtensionIsOneOf(I, [".d.mts", ".mts", ".d.cts", ".cts"]))
                  return fe + Y(I, d);
                switch (l) {
                  case 0:
                    var g = e2.removeSuffix(fe, "/index");
                    return D && g !== fe && L(D, g) ? fe : g;
                  case 1:
                    return fe;
                  case 2:
                    return fe + Y(I, d);
                  default:
                    return e2.Debug.assertNever(l);
                }
              }
              function Y(I, l) {
                var d;
                return (d = U(I, l)) !== null && d !== void 0 ? d : e2.Debug.fail("Extension ".concat(e2.extensionFromPath(I), " is unsupported:: FileName:: ").concat(I));
              }
              function U(I, l) {
                var d = e2.tryGetExtensionFromPath(I);
                switch (d) {
                  case ".ts":
                  case ".d.ts":
                    return ".js";
                  case ".tsx":
                    return l.jsx === 1 ? ".jsx" : ".js";
                  case ".js":
                  case ".jsx":
                  case ".json":
                    return d;
                  case ".d.mts":
                  case ".mts":
                  case ".mjs":
                    return ".mjs";
                  case ".d.cts":
                  case ".cts":
                  case ".cjs":
                    return ".cjs";
                  default:
                    return;
                }
              }
              C.tryGetJSExtensionForFile = U;
              function j(I, l, d) {
                var D = e2.getRelativePathToDirectoryOrUrl(l, I, l, d, false);
                return e2.isRootedDiskPath(D) ? void 0 : D;
              }
              function H(I) {
                return e2.startsWith(I, "..");
              }
            })(a = e2.moduleSpecifiers || (e2.moduleSpecifiers = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = e2.sys ? { getCurrentDirectory: function() {
              return e2.sys.getCurrentDirectory();
            }, getNewLine: function() {
              return e2.sys.newLine;
            }, getCanonicalFileName: e2.createGetCanonicalFileName(e2.sys.useCaseSensitiveFileNames) } : void 0;
            function C(P, k) {
              var Y = P === e2.sys && a ? a : { getCurrentDirectory: function() {
                return P.getCurrentDirectory();
              }, getNewLine: function() {
                return P.newLine;
              }, getCanonicalFileName: e2.createGetCanonicalFileName(P.useCaseSensitiveFileNames) };
              if (!k)
                return function(j) {
                  return P.write(e2.formatDiagnostic(j, Y));
                };
              var U = new Array(1);
              return function(j) {
                U[0] = j, P.write(e2.formatDiagnosticsWithColorAndContext(U, Y) + Y.getNewLine()), U[0] = void 0;
              };
            }
            e2.createDiagnosticReporter = C;
            function w(P, k, Y) {
              return P.clearScreen && !Y.preserveWatchOutput && !Y.extendedDiagnostics && !Y.diagnostics && e2.contains(e2.screenStartingMessageCodes, k.code) ? (P.clearScreen(), true) : false;
            }
            e2.screenStartingMessageCodes = [e2.Diagnostics.Starting_compilation_in_watch_mode.code, e2.Diagnostics.File_change_detected_Starting_incremental_compilation.code];
            function B(P, k) {
              return e2.contains(e2.screenStartingMessageCodes, P.code) ? k + k : k;
            }
            function E(P) {
              return P.now ? P.now().toLocaleTimeString("en-US", { timeZone: "UTC" }) : new Date().toLocaleTimeString();
            }
            e2.getLocaleTimeString = E;
            function Q(P, k) {
              return k ? function(Y, U, j) {
                w(P, Y, j);
                var H = "[".concat(e2.formatColorAndReset(E(P), e2.ForegroundColorEscapeSequences.Grey), "] ");
                H += "".concat(e2.flattenDiagnosticMessageText(Y.messageText, P.newLine)).concat(U + U), P.write(H);
              } : function(Y, U, j) {
                var H = "";
                w(P, Y, j) || (H += U), H += "".concat(E(P), " - "), H += "".concat(e2.flattenDiagnosticMessageText(Y.messageText, P.newLine)).concat(B(Y, U)), P.write(H);
              };
            }
            e2.createWatchStatusReporter = Q;
            function le(P, k, Y, U, j, H) {
              var I = j;
              I.onUnRecoverableConfigFileDiagnostic = function(d) {
                return A2(j, H, d);
              };
              var l = e2.getParsedCommandLineOfConfigFile(P, k, I, Y, U);
              return I.onUnRecoverableConfigFileDiagnostic = void 0, l;
            }
            e2.parseConfigFileWithSystem = le;
            function N(P) {
              return e2.countWhere(P, function(k) {
                return k.category === e2.DiagnosticCategory.Error;
              });
            }
            e2.getErrorCountForSummary = N;
            function p(P) {
              var k = e2.filter(P, function(Y) {
                return Y.category === e2.DiagnosticCategory.Error;
              }).map(function(Y) {
                if (Y.file !== void 0)
                  return "".concat(Y.file.fileName);
              });
              return k.map(function(Y) {
                var U = e2.find(P, function(H) {
                  return H.file !== void 0 && H.file.fileName === Y;
                });
                if (U !== void 0) {
                  var j = e2.getLineAndCharacterOfPosition(U.file, U.start).line;
                  return { fileName: Y, line: j + 1 };
                }
              });
            }
            e2.getFilesInErrorForSummary = p;
            function m2(P) {
              return P === 1 ? e2.Diagnostics.Found_1_error_Watching_for_file_changes : e2.Diagnostics.Found_0_errors_Watching_for_file_changes;
            }
            e2.getWatchErrorSummaryDiagnosticMessage = m2;
            function G(P, k) {
              var Y = e2.formatColorAndReset(":" + P.line, e2.ForegroundColorEscapeSequences.Grey);
              return e2.pathIsAbsolute(P.fileName) && e2.pathIsAbsolute(k) ? e2.getRelativePathFromDirectory(k, P.fileName, false) + Y : P.fileName + Y;
            }
            function oe(P, k, Y, U) {
              if (P === 0)
                return "";
              var j = k.filter(function(D) {
                return D !== void 0;
              }), H = j.map(function(D) {
                return "".concat(D.fileName, ":").concat(D.line);
              }).filter(function(D, fe, g) {
                return g.indexOf(D) === fe;
              }), I = j[0] && G(j[0], U.getCurrentDirectory()), l = P === 1 ? e2.createCompilerDiagnostic(k[0] !== void 0 ? e2.Diagnostics.Found_1_error_in_1 : e2.Diagnostics.Found_1_error, P, I) : e2.createCompilerDiagnostic(H.length === 0 ? e2.Diagnostics.Found_0_errors : H.length === 1 ? e2.Diagnostics.Found_0_errors_in_the_same_file_starting_at_Colon_1 : e2.Diagnostics.Found_0_errors_in_1_files, P, H.length === 1 ? I : H.length), d = H.length > 1 ? f4(j, U) : "";
              return "".concat(Y).concat(e2.flattenDiagnosticMessageText(l.messageText, Y)).concat(Y).concat(Y).concat(d);
            }
            e2.getErrorSummaryText = oe;
            function f4(P, k) {
              var Y = P.filter(function(g, ne, ue) {
                return ne === ue.findIndex(function(We) {
                  return (We == null ? void 0 : We.fileName) === (g == null ? void 0 : g.fileName);
                });
              });
              if (Y.length === 0)
                return "";
              var U = function(g) {
                return Math.log(g) * Math.LOG10E + 1;
              }, j = Y.map(function(g) {
                return [g, e2.countWhere(P, function(ne) {
                  return ne.fileName === g.fileName;
                })];
              }), H = j.reduce(function(g, ne) {
                return Math.max(g, ne[1] || 0);
              }, 0), I = e2.Diagnostics.Errors_Files.message, l = I.split(" ")[0].length, d = Math.max(l, U(H)), D = Math.max(U(H) - l, 0), fe = "";
              return fe += " ".repeat(D) + I + `
`, j.forEach(function(g) {
                var ne = g[0], ue = g[1], We = Math.log(ue) * Math.LOG10E + 1 | 0, Fe = We < d ? " ".repeat(d - We) : "", Z2 = G(ne, k.getCurrentDirectory());
                fe += "".concat(Fe).concat(ue, "  ").concat(Z2, `
`);
              }), fe;
            }
            function T(P) {
              return !!P.getState;
            }
            e2.isBuilderProgram = T;
            function K(P, k) {
              var Y = P.getCompilerOptions();
              Y.explainFiles ? b(T(P) ? P.getProgram() : P, k) : (Y.listFiles || Y.listFilesOnly) && e2.forEach(P.getSourceFiles(), function(U) {
                k(U.fileName);
              });
            }
            e2.listFiles = K;
            function b(P, k) {
              for (var Y, U, j = P.getFileIncludeReasons(), H = e2.createGetCanonicalFileName(P.useCaseSensitiveFileNames()), I = function(fe) {
                return e2.convertToRelativePath(fe, P.getCurrentDirectory(), H);
              }, l = 0, d = P.getSourceFiles(); l < d.length; l++) {
                var D = d[l];
                k("".concat(q(D, I))), (Y = j.get(D.path)) === null || Y === void 0 || Y.forEach(function(fe) {
                  return k("  ".concat(R(P, fe, I).messageText));
                }), (U = se(D, I)) === null || U === void 0 || U.forEach(function(fe) {
                  return k("  ".concat(fe.messageText));
                });
              }
            }
            e2.explainFiles = b;
            function se(P, k) {
              var Y;
              return P.path !== P.resolvedPath && (Y || (Y = [])).push(e2.chainDiagnosticMessages(void 0, e2.Diagnostics.File_is_output_of_project_reference_source_0, q(P.originalFileName, k))), P.redirectInfo && (Y || (Y = [])).push(e2.chainDiagnosticMessages(void 0, e2.Diagnostics.File_redirects_to_file_0, q(P.redirectInfo.redirectTarget, k))), Y;
            }
            e2.explainIfFileIsRedirect = se;
            function J(P, k) {
              var Y, U = P.getCompilerOptions().configFile;
              if (!!(!((Y = U == null ? void 0 : U.configFileSpecs) === null || Y === void 0) && Y.validatedFilesSpec)) {
                var j = e2.createGetCanonicalFileName(P.useCaseSensitiveFileNames()), H = j(k), I = e2.getDirectoryPath(e2.getNormalizedAbsolutePath(U.fileName, P.getCurrentDirectory()));
                return e2.find(U.configFileSpecs.validatedFilesSpec, function(l) {
                  return j(e2.getNormalizedAbsolutePath(l, I)) === H;
                });
              }
            }
            e2.getMatchedFileSpec = J;
            function ie(P, k) {
              var Y, U, j = P.getCompilerOptions().configFile;
              if (!!(!((Y = j == null ? void 0 : j.configFileSpecs) === null || Y === void 0) && Y.validatedIncludeSpecs)) {
                var H = e2.fileExtensionIs(k, ".json"), I = e2.getDirectoryPath(e2.getNormalizedAbsolutePath(j.fileName, P.getCurrentDirectory())), l = P.useCaseSensitiveFileNames();
                return e2.find((U = j == null ? void 0 : j.configFileSpecs) === null || U === void 0 ? void 0 : U.validatedIncludeSpecs, function(d) {
                  if (H && !e2.endsWith(d, ".json"))
                    return false;
                  var D = e2.getPatternFromSpec(d, I, "files");
                  return !!D && e2.getRegexFromPattern("(".concat(D, ")$"), l).test(k);
                });
              }
            }
            e2.getMatchedIncludeSpec = ie;
            function R(P, k, Y) {
              var U, j, H = P.getCompilerOptions();
              if (e2.isReferencedFile(k)) {
                var I = e2.getReferencedFileLocation(function(Fe) {
                  return P.getSourceFileByPath(Fe);
                }, k), l = e2.isReferenceFileLocation(I) ? I.file.text.substring(I.pos, I.end) : '"'.concat(I.text, '"'), d = void 0;
                switch (e2.Debug.assert(e2.isReferenceFileLocation(I) || k.kind === e2.FileIncludeKind.Import, "Only synthetic references are imports"), k.kind) {
                  case e2.FileIncludeKind.Import:
                    e2.isReferenceFileLocation(I) ? d = I.packageId ? e2.Diagnostics.Imported_via_0_from_file_1_with_packageId_2 : e2.Diagnostics.Imported_via_0_from_file_1 : I.text === e2.externalHelpersModuleNameText ? d = I.packageId ? e2.Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_importHelpers_as_specified_in_compilerOptions : e2.Diagnostics.Imported_via_0_from_file_1_to_import_importHelpers_as_specified_in_compilerOptions : d = I.packageId ? e2.Diagnostics.Imported_via_0_from_file_1_with_packageId_2_to_import_jsx_and_jsxs_factory_functions : e2.Diagnostics.Imported_via_0_from_file_1_to_import_jsx_and_jsxs_factory_functions;
                    break;
                  case e2.FileIncludeKind.ReferenceFile:
                    e2.Debug.assert(!I.packageId), d = e2.Diagnostics.Referenced_via_0_from_file_1;
                    break;
                  case e2.FileIncludeKind.TypeReferenceDirective:
                    d = I.packageId ? e2.Diagnostics.Type_library_referenced_via_0_from_file_1_with_packageId_2 : e2.Diagnostics.Type_library_referenced_via_0_from_file_1;
                    break;
                  case e2.FileIncludeKind.LibReferenceDirective:
                    e2.Debug.assert(!I.packageId), d = e2.Diagnostics.Library_referenced_via_0_from_file_1;
                    break;
                  default:
                    e2.Debug.assertNever(k);
                }
                return e2.chainDiagnosticMessages(void 0, d, l, q(I.file, Y), I.packageId && e2.packageIdToString(I.packageId));
              }
              switch (k.kind) {
                case e2.FileIncludeKind.RootFile:
                  if (!(!((U = H.configFile) === null || U === void 0) && U.configFileSpecs))
                    return e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Root_file_specified_for_compilation);
                  var D = e2.getNormalizedAbsolutePath(P.getRootFileNames()[k.index], P.getCurrentDirectory()), fe = J(P, D);
                  if (fe)
                    return e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Part_of_files_list_in_tsconfig_json);
                  var g = ie(P, D);
                  return g ? e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Matched_by_include_pattern_0_in_1, g, q(H.configFile, Y)) : e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Root_file_specified_for_compilation);
                case e2.FileIncludeKind.SourceFromProjectReference:
                case e2.FileIncludeKind.OutputFromProjectReference:
                  var ne = k.kind === e2.FileIncludeKind.OutputFromProjectReference, ue = e2.Debug.checkDefined((j = P.getResolvedProjectReferences()) === null || j === void 0 ? void 0 : j[k.index]);
                  return e2.chainDiagnosticMessages(void 0, e2.outFile(H) ? ne ? e2.Diagnostics.Output_from_referenced_project_0_included_because_1_specified : e2.Diagnostics.Source_from_referenced_project_0_included_because_1_specified : ne ? e2.Diagnostics.Output_from_referenced_project_0_included_because_module_is_specified_as_none : e2.Diagnostics.Source_from_referenced_project_0_included_because_module_is_specified_as_none, q(ue.sourceFile.fileName, Y), H.outFile ? "--outFile" : "--out");
                case e2.FileIncludeKind.AutomaticTypeDirectiveFile:
                  return e2.chainDiagnosticMessages(void 0, H.types ? k.packageId ? e2.Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions_with_packageId_1 : e2.Diagnostics.Entry_point_of_type_library_0_specified_in_compilerOptions : k.packageId ? e2.Diagnostics.Entry_point_for_implicit_type_library_0_with_packageId_1 : e2.Diagnostics.Entry_point_for_implicit_type_library_0, k.typeReference, k.packageId && e2.packageIdToString(k.packageId));
                case e2.FileIncludeKind.LibFile:
                  if (k.index !== void 0)
                    return e2.chainDiagnosticMessages(void 0, e2.Diagnostics.Library_0_specified_in_compilerOptions, H.lib[k.index]);
                  var We = e2.forEachEntry(e2.targetOptionDeclaration.type, function(Fe, Z2) {
                    return Fe === e2.getEmitScriptTarget(H) ? Z2 : void 0;
                  });
                  return e2.chainDiagnosticMessages(void 0, We ? e2.Diagnostics.Default_library_for_target_0 : e2.Diagnostics.Default_library, We);
                default:
                  e2.Debug.assertNever(k);
              }
            }
            e2.fileIncludeReasonToDiagnostics = R;
            function q(P, k) {
              var Y = e2.isString(P) ? P : P.fileName;
              return k ? k(Y) : Y;
            }
            function O(P, k, Y, U, j, H, I, l) {
              var d = !!P.getCompilerOptions().listFilesOnly, D = P.getConfigFileParsingDiagnostics().slice(), fe = D.length;
              e2.addRange(D, P.getSyntacticDiagnostics(void 0, H)), D.length === fe && (e2.addRange(D, P.getOptionsDiagnostics(H)), d || (e2.addRange(D, P.getGlobalDiagnostics(H)), D.length === fe && e2.addRange(D, P.getSemanticDiagnostics(void 0, H))));
              var g = d ? { emitSkipped: true, diagnostics: e2.emptyArray } : P.emit(void 0, j, H, I, l), ne = g.emittedFiles, ue = g.diagnostics;
              e2.addRange(D, ue);
              var We = e2.sortAndDeduplicateDiagnostics(D);
              if (We.forEach(k), Y) {
                var Fe = P.getCurrentDirectory();
                e2.forEach(ne, function(Z2) {
                  var Be = e2.getNormalizedAbsolutePath(Z2, Fe);
                  Y("TSFILE: ".concat(Be));
                }), K(P, Y);
              }
              return U && U(N(We), p(We)), { emitResult: g, diagnostics: We };
            }
            e2.emitFilesAndReportErrors = O;
            function ve(P, k, Y, U, j, H, I, l) {
              var d = O(P, k, Y, U, j, H, I, l), D = d.emitResult, fe = d.diagnostics;
              return D.emitSkipped && fe.length > 0 ? e2.ExitStatus.DiagnosticsPresent_OutputsSkipped : fe.length > 0 ? e2.ExitStatus.DiagnosticsPresent_OutputsGenerated : e2.ExitStatus.Success;
            }
            e2.emitFilesAndReportErrorsAndGetExitStatus = ve, e2.noopFileWatcher = { close: e2.noop }, e2.returnNoopFileWatcher = function() {
              return e2.noopFileWatcher;
            };
            function ee(P, k) {
              P === void 0 && (P = e2.sys);
              var Y = k || Q(P);
              return { onWatchStatusChange: Y, watchFile: e2.maybeBind(P, P.watchFile) || e2.returnNoopFileWatcher, watchDirectory: e2.maybeBind(P, P.watchDirectory) || e2.returnNoopFileWatcher, setTimeout: e2.maybeBind(P, P.setTimeout) || e2.noop, clearTimeout: e2.maybeBind(P, P.clearTimeout) || e2.noop };
            }
            e2.createWatchHost = ee, e2.WatchType = { ConfigFile: "Config file", ExtendedConfigFile: "Extended config file", SourceFile: "Source file", MissingFile: "Missing file", WildcardDirectory: "Wild card directory", FailedLookupLocations: "Failed Lookup Locations", TypeRoots: "Type roots", ConfigFileOfReferencedProject: "Config file of referened project", ExtendedConfigOfReferencedProject: "Extended config file of referenced project", WildcardDirectoryOfReferencedProject: "Wild card directory of referenced project", PackageJson: "package.json file" };
            function he(P, k) {
              var Y = P.trace ? k.extendedDiagnostics ? e2.WatchLogLevel.Verbose : k.diagnostics ? e2.WatchLogLevel.TriggerOnly : e2.WatchLogLevel.None : e2.WatchLogLevel.None, U = Y !== e2.WatchLogLevel.None ? function(H) {
                return P.trace(H);
              } : e2.noop, j = e2.getWatchFactory(P, Y, U);
              return j.writeLog = U, j;
            }
            e2.createWatchFactory = he;
            function F2(P, k, Y) {
              Y === void 0 && (Y = P);
              var U = P.useCaseSensitiveFileNames(), j = e2.memoize(function() {
                return P.getNewLine();
              });
              return { getSourceFile: function(I, l, d) {
                var D;
                try {
                  e2.performance.mark("beforeIORead"), D = P.readFile(I, k().charset), e2.performance.mark("afterIORead"), e2.performance.measure("I/O Read", "beforeIORead", "afterIORead");
                } catch (fe) {
                  d && d(fe.message), D = "";
                }
                return D !== void 0 ? e2.createSourceFile(I, D, l) : void 0;
              }, getDefaultLibLocation: e2.maybeBind(P, P.getDefaultLibLocation), getDefaultLibFileName: function(I) {
                return P.getDefaultLibFileName(I);
              }, writeFile: H, getCurrentDirectory: e2.memoize(function() {
                return P.getCurrentDirectory();
              }), useCaseSensitiveFileNames: function() {
                return U;
              }, getCanonicalFileName: e2.createGetCanonicalFileName(U), getNewLine: function() {
                return e2.getNewLineCharacter(k(), j);
              }, fileExists: function(I) {
                return P.fileExists(I);
              }, readFile: function(I) {
                return P.readFile(I);
              }, trace: e2.maybeBind(P, P.trace), directoryExists: e2.maybeBind(Y, Y.directoryExists), getDirectories: e2.maybeBind(Y, Y.getDirectories), realpath: e2.maybeBind(P, P.realpath), getEnvironmentVariable: e2.maybeBind(P, P.getEnvironmentVariable) || function() {
                return "";
              }, createHash: e2.maybeBind(P, P.createHash), readDirectory: e2.maybeBind(P, P.readDirectory), disableUseFileVersionAsSignature: P.disableUseFileVersionAsSignature, storeFilesChangingSignatureDuringEmit: P.storeFilesChangingSignatureDuringEmit };
              function H(I, l, d, D) {
                try {
                  e2.performance.mark("beforeIOWrite"), e2.writeFileEnsuringDirectories(I, l, d, function(fe, g, ne) {
                    return P.writeFile(fe, g, ne);
                  }, function(fe) {
                    return P.createDirectory(fe);
                  }, function(fe) {
                    return P.directoryExists(fe);
                  }), e2.performance.mark("afterIOWrite"), e2.performance.measure("I/O Write", "beforeIOWrite", "afterIOWrite");
                } catch (fe) {
                  D && D(fe.message);
                }
              }
            }
            e2.createCompilerHostFromProgramHost = F2;
            function x2(P, k) {
              var Y = P.getSourceFile, U = e2.maybeBind(k, k.createHash) || e2.generateDjb2Hash;
              P.getSourceFile = function() {
                for (var j = [], H = 0; H < arguments.length; H++)
                  j[H] = arguments[H];
                var I = Y.call.apply(Y, Ve([P], j, false));
                return I && (I.version = U(I.text)), I;
              };
            }
            e2.setGetSourceFileAsHashVersioned = x2;
            function X(P, k) {
              var Y = e2.memoize(function() {
                return e2.getDirectoryPath(e2.normalizePath(P.getExecutingFilePath()));
              });
              return { useCaseSensitiveFileNames: function() {
                return P.useCaseSensitiveFileNames;
              }, getNewLine: function() {
                return P.newLine;
              }, getCurrentDirectory: e2.memoize(function() {
                return P.getCurrentDirectory();
              }), getDefaultLibLocation: Y, getDefaultLibFileName: function(U) {
                return e2.combinePaths(Y(), e2.getDefaultLibFileName(U));
              }, fileExists: function(U) {
                return P.fileExists(U);
              }, readFile: function(U, j) {
                return P.readFile(U, j);
              }, directoryExists: function(U) {
                return P.directoryExists(U);
              }, getDirectories: function(U) {
                return P.getDirectories(U);
              }, readDirectory: function(U, j, H, I, l) {
                return P.readDirectory(U, j, H, I, l);
              }, realpath: e2.maybeBind(P, P.realpath), getEnvironmentVariable: e2.maybeBind(P, P.getEnvironmentVariable), trace: function(U) {
                return P.write(U + P.newLine);
              }, createDirectory: function(U) {
                return P.createDirectory(U);
              }, writeFile: function(U, j, H) {
                return P.writeFile(U, j, H);
              }, createHash: e2.maybeBind(P, P.createHash), createProgram: k || e2.createEmitAndSemanticDiagnosticsBuilderProgram, disableUseFileVersionAsSignature: P.disableUseFileVersionAsSignature, storeFilesChangingSignatureDuringEmit: P.storeFilesChangingSignatureDuringEmit };
            }
            e2.createProgramHost = X;
            function $(P, k, Y, U) {
              P === void 0 && (P = e2.sys);
              var j = function(I) {
                return P.write(I + P.newLine);
              }, H = X(P, k);
              return e2.copyProperties(H, ee(P, U)), H.afterProgramCreate = function(I) {
                var l = I.getCompilerOptions(), d = e2.getNewLineCharacter(l, function() {
                  return P.newLine;
                });
                O(I, Y, j, function(D) {
                  return H.onWatchStatusChange(e2.createCompilerDiagnostic(m2(D), D), d, l, D);
                });
              }, H;
            }
            function A2(P, k, Y) {
              k(Y), P.exit(e2.ExitStatus.DiagnosticsPresent_OutputsSkipped);
            }
            function y(P) {
              var k = P.configFileName, Y = P.optionsToExtend, U = P.watchOptionsToExtend, j = P.extraFileExtensions, H = P.system, I = P.createProgram, l = P.reportDiagnostic, d = P.reportWatchStatus, D = l || C(H), fe = $(H, I, D, d);
              return fe.onUnRecoverableConfigFileDiagnostic = function(g) {
                return A2(H, D, g);
              }, fe.configFileName = k, fe.optionsToExtend = Y, fe.watchOptionsToExtend = U, fe.extraFileExtensions = j, fe;
            }
            e2.createWatchCompilerHostOfConfigFile = y;
            function V(P) {
              var k = P.rootFiles, Y = P.options, U = P.watchOptions, j = P.projectReferences, H = P.system, I = P.createProgram, l = P.reportDiagnostic, d = P.reportWatchStatus, D = $(H, I, l || C(H), d);
              return D.rootFiles = k, D.options = Y, D.watchOptions = U, D.projectReferences = j, D;
            }
            e2.createWatchCompilerHostOfFilesAndCompilerOptions = V;
            function L(P) {
              var k = P.system || e2.sys, Y = P.host || (P.host = e2.createIncrementalCompilerHost(P.options, k)), U = e2.createIncrementalProgram(P), j = ve(U, P.reportDiagnostic || C(k), function(H) {
                return Y.trace && Y.trace(H);
              }, P.reportErrorSummary || P.options.pretty ? function(H, I) {
                return k.write(oe(H, I, k.newLine, Y));
              } : void 0);
              return P.afterProgramEmitAndDiagnostics && P.afterProgramEmitAndDiagnostics(U), j;
            }
            e2.performIncrementalCompilation = L;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(Q, le) {
              if (!e2.outFile(Q)) {
                var N = e2.getTsBuildInfoEmitOutputFilePath(Q);
                if (!!N) {
                  var p = le.readFile(N);
                  if (!!p) {
                    var m2 = e2.getBuildInfo(p);
                    if (m2.version === e2.version && !!m2.program)
                      return e2.createBuildProgramUsingProgramBuildInfo(m2.program, N, le);
                  }
                }
              }
            }
            e2.readBuilderProgram = a;
            function C(Q, le) {
              le === void 0 && (le = e2.sys);
              var N = e2.createCompilerHostWorker(Q, void 0, le);
              return N.createHash = e2.maybeBind(le, le.createHash), N.disableUseFileVersionAsSignature = le.disableUseFileVersionAsSignature, N.storeFilesChangingSignatureDuringEmit = le.storeFilesChangingSignatureDuringEmit, e2.setGetSourceFileAsHashVersioned(N, le), e2.changeCompilerHostLikeToUseCache(N, function(p) {
                return e2.toPath(p, N.getCurrentDirectory(), N.getCanonicalFileName);
              }), N;
            }
            e2.createIncrementalCompilerHost = C;
            function w(Q) {
              var le = Q.rootNames, N = Q.options, p = Q.configFileParsingDiagnostics, m2 = Q.projectReferences, G = Q.host, oe = Q.createProgram;
              G = G || C(N), oe = oe || e2.createEmitAndSemanticDiagnosticsBuilderProgram;
              var f4 = a(N, G);
              return oe(le, N, G, f4, p, m2);
            }
            e2.createIncrementalProgram = w;
            function B(Q, le, N, p, m2, G, oe, f4) {
              return e2.isArray(Q) ? e2.createWatchCompilerHostOfFilesAndCompilerOptions({ rootFiles: Q, options: le, watchOptions: f4, projectReferences: oe, system: N, createProgram: p, reportDiagnostic: m2, reportWatchStatus: G }) : e2.createWatchCompilerHostOfConfigFile({ configFileName: Q, optionsToExtend: le, watchOptionsToExtend: oe, extraFileExtensions: f4, system: N, createProgram: p, reportDiagnostic: m2, reportWatchStatus: G });
            }
            e2.createWatchCompilerHost = B;
            function E(Q) {
              var le, N, p, m2, G, oe, f4, T, K, b = Q.extendedConfigCache, se = false, J = false, ie = new e2.Map(), R, q = false, O = Q.useCaseSensitiveFileNames(), ve = Q.getCurrentDirectory(), ee = Q.configFileName, he = Q.optionsToExtend, F2 = he === void 0 ? {} : he, x2 = Q.watchOptionsToExtend, X = Q.extraFileExtensions, $ = Q.createProgram, A2 = Q.rootFiles, y = Q.options, V = Q.watchOptions, L = Q.projectReferences, P, k, Y = false, U = false, j = ee === void 0 ? void 0 : e2.createCachedDirectoryStructureHost(Q, ve, O), H = j || Q, I = e2.parseConfigHostFromCompilerHostLike(Q, H), l = Ie();
              ee && Q.configFileParsingResult && (Ur(Q.configFileParsingResult), l = Ie()), Ye(e2.Diagnostics.Starting_compilation_in_watch_mode), ee && !Q.configFileParsingResult && (l = e2.getNewLineCharacter(F2, function() {
                return Q.getNewLine();
              }), e2.Debug.assert(!A2), wr(), l = Ie());
              var d = e2.createWatchFactory(Q, y), D = d.watchFile, fe = d.watchDirectory, g = d.writeLog, ne = e2.createGetCanonicalFileName(O);
              g("Current directory: ".concat(ve, " CaseSensitiveFileNames: ").concat(O));
              var ue;
              ee && (ue = D(ee, be, e2.PollingInterval.High, V, e2.WatchType.ConfigFile));
              var We = e2.createCompilerHostFromProgramHost(Q, function() {
                return y;
              }, H);
              e2.setGetSourceFileAsHashVersioned(We, Q);
              var Fe = We.getSourceFile;
              We.getSourceFile = function(pi) {
                for (var ae = [], Xe = 1; Xe < arguments.length; Xe++)
                  ae[Xe - 1] = arguments[Xe];
                return Ae.apply(void 0, Ve([pi, _e(pi)], ae, false));
              }, We.getSourceFileByPath = Ae, We.getNewLine = function() {
                return l;
              }, We.fileExists = ye, We.onReleaseOldSourceFile = Cr, We.onReleaseParsedCommandLine = pe, We.toPath = _e, We.getCompilationSettings = function() {
                return y;
              }, We.useSourceOfProjectReferenceRedirect = e2.maybeBind(Q, Q.useSourceOfProjectReferenceRedirect), We.watchDirectoryOfFailedLookupLocation = function(pi, ae, Xe) {
                return fe(pi, ae, Xe, V, e2.WatchType.FailedLookupLocations);
              }, We.watchTypeRootsDirectory = function(pi, ae, Xe) {
                return fe(pi, ae, Xe, V, e2.WatchType.TypeRoots);
              }, We.getCachedDirectoryStructureHost = function() {
                return j;
              }, We.scheduleInvalidateResolutionsOfFailedLookupLocations = Ne, We.onInvalidatedResolution = lr, We.onChangedAutomaticTypeDirectiveNames = lr, We.fileIsOpen = e2.returnFalse, We.getCurrentProgram = ze, We.writeLog = g, We.getParsedCommandLine = ii;
              var Z2 = e2.createResolutionCache(We, ee ? e2.getDirectoryPath(e2.getNormalizedAbsolutePath(ee, ve)) : ve, false);
              We.resolveModuleNames = Q.resolveModuleNames ? function() {
                for (var pi = [], ae = 0; ae < arguments.length; ae++)
                  pi[ae] = arguments[ae];
                return Q.resolveModuleNames.apply(Q, pi);
              } : function(pi, ae, Xe, Jr, ti, Ze) {
                return Z2.resolveModuleNames(pi, ae, Xe, Jr, Ze);
              }, We.resolveTypeReferenceDirectives = Q.resolveTypeReferenceDirectives ? function() {
                for (var pi = [], ae = 0; ae < arguments.length; ae++)
                  pi[ae] = arguments[ae];
                return Q.resolveTypeReferenceDirectives.apply(Q, pi);
              } : function(pi, ae, Xe, Jr, ti) {
                return Z2.resolveTypeReferenceDirectives(pi, ae, Xe, ti);
              };
              var Be = !!Q.resolveModuleNames || !!Q.resolveTypeReferenceDirectives;
              return le = a(y, We), Ee(), Gi(), ee && Zt(_e(ee), y, V, e2.WatchType.ExtendedConfigFile), ee ? { getCurrentProgram: Re, getProgram: ur, close: ge } : { getCurrentProgram: Re, getProgram: ur, updateRootFileNames: rr, close: ge };
              function ge() {
                Er(), Z2.clear(), e2.clearMap(ie, function(pi) {
                  pi && pi.fileWatcher && (pi.fileWatcher.close(), pi.fileWatcher = void 0);
                }), ue && (ue.close(), ue = void 0), b == null || b.clear(), b = void 0, K && (e2.clearMap(K, e2.closeFileWatcherOf), K = void 0), G && (e2.clearMap(G, e2.closeFileWatcherOf), G = void 0), p && (e2.clearMap(p, e2.closeFileWatcher), p = void 0), T && (e2.clearMap(T, function(pi) {
                  var ae;
                  (ae = pi.watcher) === null || ae === void 0 || ae.close(), pi.watcher = void 0, pi.watchedDirectories && e2.clearMap(pi.watchedDirectories, e2.closeFileWatcherOf), pi.watchedDirectories = void 0;
                }), T = void 0), m2 && (e2.clearMap(m2, e2.closeFileWatcher), m2 = void 0);
              }
              function Re() {
                return le;
              }
              function ze() {
                return le && le.getProgramOrUndefined();
              }
              function Ee() {
                g("Synchronizing program"), Er();
                var pi = Re();
                q && (l = Ie(), pi && (se || e2.changesAffectModuleResolution(pi.getCompilerOptions(), y)) && Z2.clear());
                var ae = Z2.createHasInvalidatedResolution(Be || se);
                return e2.isProgramUptoDate(ze(), A2, y, ir, ye, ae, Br, ii, L) ? U && (J && Ye(e2.Diagnostics.File_change_detected_Starting_incremental_compilation), le = $(void 0, void 0, We, le, k, L), U = false) : (J && Ye(e2.Diagnostics.File_change_detected_Starting_incremental_compilation), He(ae)), se = false, J = false, Q.afterProgramCreate && pi !== le && Q.afterProgramCreate(le), le;
              }
              function He(pi) {
                g("CreatingProgramWith::"), g("  roots: ".concat(JSON.stringify(A2))), g("  options: ".concat(JSON.stringify(y))), L && g("  projectReferences: ".concat(JSON.stringify(L)));
                var ae = q || !ze();
                q = false, U = false, Z2.startCachingPerDirectoryResolution(), We.hasInvalidatedResolution = pi, We.hasChangedAutomaticTypeDirectiveNames = Br, le = $(A2, y, We, le, k, L);
                var Xe = e2.map(Z2.getModuleResolutionCache().getPackageJsonInfoCache().entries(), function(Sr) {
                  var zr = Sr[0], Wr = Sr[1];
                  return [We.realpath ? _e(We.realpath(zr)) : zr, Wr];
                });
                if (Z2.finishCachingPerDirectoryResolution(), e2.updateMissingFilePathsWatch(le.getProgram(), p || (p = new e2.Map()), Di), e2.updatePackageJsonWatch(Xe, m2 || (m2 = new e2.Map()), wi), ae && Z2.updateTypeRootsWatch(), R) {
                  for (var Jr = 0, ti = R; Jr < ti.length; Jr++) {
                    var Ze = ti[Jr];
                    p.has(Ze) || ie.delete(Ze);
                  }
                  R = void 0;
                }
              }
              function rr(pi) {
                e2.Debug.assert(!ee, "Cannot update root file names with config file watch mode"), A2 = pi, lr();
              }
              function Ie() {
                return e2.getNewLineCharacter(y || F2, function() {
                  return Q.getNewLine();
                });
              }
              function _e(pi) {
                return e2.toPath(pi, ve, ne);
              }
              function we(pi) {
                return typeof pi == "boolean";
              }
              function de(pi) {
                return typeof pi.version == "boolean";
              }
              function ye(pi) {
                var ae = _e(pi);
                return we(ie.get(ae)) ? false : H.fileExists(pi);
              }
              function Ae(pi, ae, Xe, Jr, ti) {
                var Ze = ie.get(ae);
                if (!we(Ze)) {
                  if (Ze === void 0 || ti || de(Ze)) {
                    var Sr = Fe(pi, Xe, Jr);
                    if (Ze)
                      Sr ? (Ze.sourceFile = Sr, Ze.version = Sr.version, Ze.fileWatcher || (Ze.fileWatcher = or(ae, pi, qr, e2.PollingInterval.Low, V, e2.WatchType.SourceFile))) : (Ze.fileWatcher && Ze.fileWatcher.close(), ie.set(ae, false));
                    else if (Sr) {
                      var zr = or(ae, pi, qr, e2.PollingInterval.Low, V, e2.WatchType.SourceFile);
                      ie.set(ae, { sourceFile: Sr, version: Sr.version, fileWatcher: zr });
                    } else
                      ie.set(ae, false);
                    return Sr && (Sr.impliedNodeFormat = e2.getImpliedNodeFormatForFile(ae, Z2.getModuleResolutionCache().getPackageJsonInfoCache(), We, We.getCompilationSettings())), Sr;
                  }
                  return Ze.sourceFile;
                }
              }
              function er(pi) {
                var ae = ie.get(pi);
                ae !== void 0 && (we(ae) ? ie.set(pi, { version: false }) : ae.version = false);
              }
              function ir(pi) {
                var ae = ie.get(pi);
                return !ae || !ae.version ? void 0 : ae.version;
              }
              function Cr(pi, ae, Xe) {
                var Jr = ie.get(pi.resolvedPath);
                Jr !== void 0 && (we(Jr) ? (R || (R = [])).push(pi.path) : Jr.sourceFile === pi && (Jr.fileWatcher && Jr.fileWatcher.close(), ie.delete(pi.resolvedPath), Xe || Z2.removeResolutionsOfFile(pi.path)));
              }
              function Ye(pi) {
                Q.onWatchStatusChange && Q.onWatchStatusChange(e2.createCompilerDiagnostic(pi), l, y || F2);
              }
              function Br() {
                return Z2.hasChangedAutomaticTypeDirectiveNames();
              }
              function Er() {
                return f4 ? (Q.clearTimeout(f4), f4 = void 0, true) : false;
              }
              function Ne() {
                if (!Q.setTimeout || !Q.clearTimeout)
                  return Z2.invalidateResolutionsOfFailedLookupLocations();
                var pi = Er();
                g("Scheduling invalidateFailedLookup".concat(pi ? ", Cancelled earlier one" : "")), f4 = Q.setTimeout(n, 250);
              }
              function n() {
                f4 = void 0, Z2.invalidateResolutionsOfFailedLookupLocations() && lr();
              }
              function lr() {
                !Q.setTimeout || !Q.clearTimeout || (oe && Q.clearTimeout(oe), g("Scheduling update"), oe = Q.setTimeout(Ge, 250));
              }
              function be() {
                e2.Debug.assert(!!ee), N = e2.ConfigFileProgramReloadLevel.Full, lr();
              }
              function Ge() {
                oe = void 0, J = true, ur();
              }
              function ur() {
                switch (N) {
                  case e2.ConfigFileProgramReloadLevel.Partial:
                    e2.perfLogger.logStartUpdateProgram("PartialConfigReload"), yr();
                    break;
                  case e2.ConfigFileProgramReloadLevel.Full:
                    e2.perfLogger.logStartUpdateProgram("FullConfigReload"), Ir();
                    break;
                  default:
                    e2.perfLogger.logStartUpdateProgram("SynchronizeProgram"), Ee();
                    break;
                }
                return e2.perfLogger.logStopUpdateProgram("Done"), Re();
              }
              function yr() {
                g("Reloading new file names and options"), A2 = e2.getFileNamesFromConfigSpecs(y.configFile.configFileSpecs, e2.getNormalizedAbsolutePath(e2.getDirectoryPath(ee), ve), y, I, X), e2.updateErrorForNoInputFiles(A2, e2.getNormalizedAbsolutePath(ee, ve), y.configFile.configFileSpecs, k, Y) && (U = true), Ee();
              }
              function Ir() {
                g("Reloading config file: ".concat(ee)), N = e2.ConfigFileProgramReloadLevel.None, j && j.clearCache(), wr(), q = true, Ee(), Gi(), Zt(_e(ee), y, V, e2.WatchType.ExtendedConfigFile);
              }
              function wr() {
                Ur(e2.getParsedCommandLineOfConfigFile(ee, F2, I, b || (b = new e2.Map()), x2, X));
              }
              function Ur(pi) {
                A2 = pi.fileNames, y = pi.options, V = pi.watchOptions, L = pi.projectReferences, P = pi.wildcardDirectories, k = e2.getConfigFileParsingDiagnostics(pi).slice(), Y = e2.canJsonReportNoInputFiles(pi.raw), U = true;
              }
              function ii(pi) {
                var ae = _e(pi), Xe = T == null ? void 0 : T.get(ae);
                if (Xe) {
                  if (!Xe.reloadLevel)
                    return Xe.parsedCommandLine;
                  if (Xe.parsedCommandLine && Xe.reloadLevel === e2.ConfigFileProgramReloadLevel.Partial && !Q.getParsedCommandLine) {
                    g("Reloading new file names and options");
                    var Jr = e2.getFileNamesFromConfigSpecs(Xe.parsedCommandLine.options.configFile.configFileSpecs, e2.getNormalizedAbsolutePath(e2.getDirectoryPath(pi), ve), y, I);
                    return Xe.parsedCommandLine = Ke(Ke({}, Xe.parsedCommandLine), { fileNames: Jr }), Xe.reloadLevel = void 0, Xe.parsedCommandLine;
                  }
                }
                g("Loading config file: ".concat(pi));
                var ti = Q.getParsedCommandLine ? Q.getParsedCommandLine(pi) : mi(pi);
                return Xe ? (Xe.parsedCommandLine = ti, Xe.reloadLevel = void 0) : (T || (T = new e2.Map())).set(ae, Xe = { parsedCommandLine: ti }), _r(pi, ae, Xe), ti;
              }
              function mi(pi) {
                var ae = I.onUnRecoverableConfigFileDiagnostic;
                I.onUnRecoverableConfigFileDiagnostic = e2.noop;
                var Xe = e2.getParsedCommandLineOfConfigFile(pi, void 0, I, b || (b = new e2.Map()), x2);
                return I.onUnRecoverableConfigFileDiagnostic = ae, Xe;
              }
              function pe(pi) {
                var ae, Xe = _e(pi), Jr = T == null ? void 0 : T.get(Xe);
                !Jr || (T.delete(Xe), Jr.watchedDirectories && e2.clearMap(Jr.watchedDirectories, e2.closeFileWatcherOf), (ae = Jr.watcher) === null || ae === void 0 || ae.close(), e2.clearSharedExtendedConfigFileWatcher(Xe, K));
              }
              function or(pi, ae, Xe, Jr, ti, Ze) {
                return D(ae, function(Sr, zr) {
                  return Xe(Sr, zr, pi);
                }, Jr, ti, Ze);
              }
              function qr(pi, ae, Xe) {
                si(pi, Xe, ae), ae === e2.FileWatcherEventKind.Deleted && ie.has(Xe) && Z2.invalidateResolutionOfFile(Xe), er(Xe), lr();
              }
              function si(pi, ae, Xe) {
                j && j.addOrDeleteFile(pi, ae, Xe);
              }
              function Di(pi) {
                return T != null && T.has(pi) ? e2.noopFileWatcher : or(pi, pi, et, e2.PollingInterval.Medium, V, e2.WatchType.MissingFile);
              }
              function wi(pi) {
                return ie.has(pi) ? e2.noopFileWatcher : or(pi, pi, Xi, e2.PollingInterval.High, V, e2.WatchType.PackageJson);
              }
              function Xi(pi, ae, Xe) {
                si(pi, Xe, ae), N = e2.ConfigFileProgramReloadLevel.Full, se = true, lr();
              }
              function et(pi, ae, Xe) {
                si(pi, Xe, ae), ae === e2.FileWatcherEventKind.Created && p.has(Xe) && (p.get(Xe).close(), p.delete(Xe), er(Xe), lr());
              }
              function Gi() {
                P ? e2.updateWatchingWildcardDirectories(G || (G = new e2.Map()), new e2.Map(e2.getEntries(P)), Wt) : G && e2.clearMap(G, e2.closeFileWatcherOf);
              }
              function Wt(pi, ae) {
                return fe(pi, function(Xe) {
                  e2.Debug.assert(!!ee);
                  var Jr = _e(Xe);
                  j && j.addOrDeleteFileOrDirectory(Xe, Jr), er(Jr), !e2.isIgnoredFileFromWildCardWatching({ watchedDirPath: _e(pi), fileOrDirectory: Xe, fileOrDirectoryPath: Jr, configFileName: ee, extraFileExtensions: X, options: y, program: Re() || A2, currentDirectory: ve, useCaseSensitiveFileNames: O, writeLog: g, toPath: _e }) && N !== e2.ConfigFileProgramReloadLevel.Full && (N = e2.ConfigFileProgramReloadLevel.Partial, lr());
                }, ae, V, e2.WatchType.WildcardDirectory);
              }
              function Zt(pi, ae, Xe, Jr) {
                e2.updateSharedExtendedConfigFileWatcher(pi, ae, K || (K = new e2.Map()), function(ti, Ze) {
                  return D(ti, function(Sr, zr) {
                    var Wr;
                    si(ti, Ze, zr), b && e2.cleanExtendedConfigCache(b, Ze, _e);
                    var Je = (Wr = K.get(Ze)) === null || Wr === void 0 ? void 0 : Wr.projects;
                    !(Je != null && Je.size) || Je.forEach(function(xe) {
                      if (_e(ee) === xe)
                        N = e2.ConfigFileProgramReloadLevel.Full;
                      else {
                        var vr = T == null ? void 0 : T.get(xe);
                        vr && (vr.reloadLevel = e2.ConfigFileProgramReloadLevel.Full), Z2.removeResolutionsFromProjectReferenceRedirects(xe);
                      }
                      lr();
                    });
                  }, e2.PollingInterval.High, Xe, Jr);
                }, _e);
              }
              function _r(pi, ae, Xe) {
                var Jr, ti, Ze, Sr, zr;
                Xe.watcher || (Xe.watcher = D(pi, function(Wr, Je) {
                  si(pi, ae, Je);
                  var xe = T == null ? void 0 : T.get(ae);
                  xe && (xe.reloadLevel = e2.ConfigFileProgramReloadLevel.Full), Z2.removeResolutionsFromProjectReferenceRedirects(ae), lr();
                }, e2.PollingInterval.High, ((Jr = Xe.parsedCommandLine) === null || Jr === void 0 ? void 0 : Jr.watchOptions) || V, e2.WatchType.ConfigFileOfReferencedProject)), !((ti = Xe.parsedCommandLine) === null || ti === void 0) && ti.wildcardDirectories ? e2.updateWatchingWildcardDirectories(Xe.watchedDirectories || (Xe.watchedDirectories = new e2.Map()), new e2.Map(e2.getEntries((Ze = Xe.parsedCommandLine) === null || Ze === void 0 ? void 0 : Ze.wildcardDirectories)), function(Wr, Je) {
                  var xe;
                  return fe(Wr, function(vr) {
                    var mr = _e(vr);
                    j && j.addOrDeleteFileOrDirectory(vr, mr), er(mr);
                    var Ar = T == null ? void 0 : T.get(ae);
                    !(Ar != null && Ar.parsedCommandLine) || e2.isIgnoredFileFromWildCardWatching({ watchedDirPath: _e(Wr), fileOrDirectory: vr, fileOrDirectoryPath: mr, configFileName: pi, options: Ar.parsedCommandLine.options, program: Ar.parsedCommandLine.fileNames, currentDirectory: ve, useCaseSensitiveFileNames: O, writeLog: g, toPath: _e }) || Ar.reloadLevel !== e2.ConfigFileProgramReloadLevel.Full && (Ar.reloadLevel = e2.ConfigFileProgramReloadLevel.Partial, lr());
                  }, Je, ((xe = Xe.parsedCommandLine) === null || xe === void 0 ? void 0 : xe.watchOptions) || V, e2.WatchType.WildcardDirectoryOfReferencedProject);
                }) : Xe.watchedDirectories && (e2.clearMap(Xe.watchedDirectories, e2.closeFileWatcherOf), Xe.watchedDirectories = void 0), Zt(ae, (Sr = Xe.parsedCommandLine) === null || Sr === void 0 ? void 0 : Sr.options, ((zr = Xe.parsedCommandLine) === null || zr === void 0 ? void 0 : zr.watchOptions) || V, e2.WatchType.ExtendedConfigOfReferencedProject);
              }
            }
            e2.createWatchProgram = E;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(w) {
              w[w.Unbuildable = 0] = "Unbuildable", w[w.UpToDate = 1] = "UpToDate", w[w.UpToDateWithUpstreamTypes = 2] = "UpToDateWithUpstreamTypes", w[w.OutOfDateWithPrepend = 3] = "OutOfDateWithPrepend", w[w.OutputMissing = 4] = "OutputMissing", w[w.OutOfDateWithSelf = 5] = "OutOfDateWithSelf", w[w.OutOfDateWithUpstream = 6] = "OutOfDateWithUpstream", w[w.UpstreamOutOfDate = 7] = "UpstreamOutOfDate", w[w.UpstreamBlocked = 8] = "UpstreamBlocked", w[w.ComputingUpstream = 9] = "ComputingUpstream", w[w.TsVersionOutputOfDate = 10] = "TsVersionOutputOfDate", w[w.ContainerOnly = 11] = "ContainerOnly";
            })(a = e2.UpToDateStatusType || (e2.UpToDateStatusType = {}));
            function C(w) {
              return e2.fileExtensionIs(w, ".json") ? w : e2.combinePaths(w, "tsconfig.json");
            }
            e2.resolveConfigFileProjectName = C;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = new Date(-864e13), C = new Date(864e13), w;
            (function(be) {
              be[be.None = 0] = "None", be[be.Success = 1] = "Success", be[be.DeclarationOutputUnchanged = 2] = "DeclarationOutputUnchanged", be[be.ConfigFileErrors = 4] = "ConfigFileErrors", be[be.SyntaxErrors = 8] = "SyntaxErrors", be[be.TypeErrors = 16] = "TypeErrors", be[be.DeclarationEmitErrors = 32] = "DeclarationEmitErrors", be[be.EmitErrors = 64] = "EmitErrors", be[be.AnyErrors = 124] = "AnyErrors";
            })(w || (w = {}));
            function B(be, Ge, ur) {
              var yr = be.get(Ge), Ir;
              return yr || (Ir = ur(), be.set(Ge, Ir)), yr || Ir;
            }
            function E(be, Ge) {
              return B(be, Ge, function() {
                return new e2.Map();
              });
            }
            function Q(be, Ge) {
              return Ge > be ? Ge : be;
            }
            function le(be) {
              return !!be && !!be.buildOrder;
            }
            e2.isCircularBuildOrder = le;
            function N(be) {
              return le(be) ? be.buildOrder : be;
            }
            e2.getBuildOrderFromAnyBuildOrder = N;
            function p(be, Ge) {
              return function(ur) {
                var yr = Ge ? "[".concat(e2.formatColorAndReset(e2.getLocaleTimeString(be), e2.ForegroundColorEscapeSequences.Grey), "] ") : "".concat(e2.getLocaleTimeString(be), " - ");
                yr += "".concat(e2.flattenDiagnosticMessageText(ur.messageText, be.newLine)).concat(be.newLine + be.newLine), be.write(yr);
              };
            }
            e2.createBuilderStatusReporter = p;
            function m2(be, Ge, ur, yr) {
              var Ir = e2.createProgramHost(be, Ge);
              return Ir.getModifiedTime = be.getModifiedTime ? function(wr) {
                return be.getModifiedTime(wr);
              } : e2.returnUndefined, Ir.setModifiedTime = be.setModifiedTime ? function(wr, Ur) {
                return be.setModifiedTime(wr, Ur);
              } : e2.noop, Ir.deleteFile = be.deleteFile ? function(wr) {
                return be.deleteFile(wr);
              } : e2.noop, Ir.reportDiagnostic = ur || e2.createDiagnosticReporter(be), Ir.reportSolutionBuilderStatus = yr || p(be), Ir.now = e2.maybeBind(be, be.now), Ir;
            }
            function G(be, Ge, ur, yr, Ir) {
              be === void 0 && (be = e2.sys);
              var wr = m2(be, Ge, ur, yr);
              return wr.reportErrorSummary = Ir, wr;
            }
            e2.createSolutionBuilderHost = G;
            function oe(be, Ge, ur, yr, Ir) {
              be === void 0 && (be = e2.sys);
              var wr = m2(be, Ge, ur, yr), Ur = e2.createWatchHost(be, Ir);
              return e2.copyProperties(wr, Ur), wr;
            }
            e2.createSolutionBuilderWithWatchHost = oe;
            function f4(be) {
              var Ge = {};
              return e2.commonOptionsWithBuild.forEach(function(ur) {
                e2.hasProperty(be, ur.name) && (Ge[ur.name] = be[ur.name]);
              }), Ge;
            }
            function T(be, Ge, ur) {
              return ye(false, be, Ge, ur);
            }
            e2.createSolutionBuilder = T;
            function K(be, Ge, ur, yr) {
              return ye(true, be, Ge, ur, yr);
            }
            e2.createSolutionBuilderWithWatch = K;
            function b(be, Ge, ur, yr, Ir) {
              var wr = Ge, Ur = Ge, ii = wr.getCurrentDirectory(), mi = e2.createGetCanonicalFileName(wr.useCaseSensitiveFileNames()), pe = f4(yr), or = e2.createCompilerHostFromProgramHost(wr, function() {
                return Zt.projectCompilerOptions;
              });
              e2.setGetSourceFileAsHashVersioned(or, wr), or.getParsedCommandLine = function(_r) {
                return q(Zt, _r, J(Zt, _r));
              }, or.resolveModuleNames = e2.maybeBind(wr, wr.resolveModuleNames), or.resolveTypeReferenceDirectives = e2.maybeBind(wr, wr.resolveTypeReferenceDirectives);
              var qr = or.resolveModuleNames ? void 0 : e2.createModuleResolutionCache(ii, mi), si = or.resolveTypeReferenceDirectives ? void 0 : e2.createTypeReferenceDirectiveResolutionCache(ii, mi, void 0, qr == null ? void 0 : qr.getPackageJsonInfoCache());
              if (!or.resolveModuleNames) {
                var Di = function(_r, pi, ae, Xe) {
                  return e2.resolveModuleName(_r, ae, Zt.projectCompilerOptions, or, qr, Xe, pi).resolvedModule;
                };
                or.resolveModuleNames = function(_r, pi, ae, Xe, Jr, ti) {
                  return e2.loadWithModeAwareCache(e2.Debug.checkEachDefined(_r), e2.Debug.checkDefined(ti), pi, Xe, Di);
                }, or.getModuleResolutionCache = function() {
                  return qr;
                };
              }
              if (!or.resolveTypeReferenceDirectives) {
                var wi = function(_r, pi, ae, Xe) {
                  return e2.resolveTypeReferenceDirective(_r, pi, Zt.projectCompilerOptions, or, ae, Zt.typeReferenceDirectiveResolutionCache, Xe).resolvedTypeReferenceDirective;
                };
                or.resolveTypeReferenceDirectives = function(_r, pi, ae, Xe, Jr) {
                  return e2.loadWithTypeDirectiveCache(e2.Debug.checkEachDefined(_r), pi, ae, Jr, wi);
                };
              }
              var Xi = e2.createWatchFactory(Ur, yr), et = Xi.watchFile, Gi = Xi.watchDirectory, Wt = Xi.writeLog, Zt = { host: wr, hostWithWatch: Ur, currentDirectory: ii, getCanonicalFileName: mi, parseConfigFileHost: e2.parseConfigHostFromCompilerHostLike(wr), write: e2.maybeBind(wr, wr.trace), options: yr, baseCompilerOptions: pe, rootNames: ur, baseWatchOptions: Ir, resolvedConfigFilePaths: new e2.Map(), configFileCache: new e2.Map(), projectStatus: new e2.Map(), buildInfoChecked: new e2.Map(), extendedConfigCache: new e2.Map(), builderPrograms: new e2.Map(), diagnostics: new e2.Map(), projectPendingBuild: new e2.Map(), projectErrorsReported: new e2.Map(), compilerHost: or, moduleResolutionCache: qr, typeReferenceDirectiveResolutionCache: si, buildOrder: void 0, readFileWithCache: function(_r) {
                return wr.readFile(_r);
              }, projectCompilerOptions: pe, cache: void 0, allProjectBuildPending: true, needsSummary: true, watchAllProjectsPending: be, currentInvalidatedProject: void 0, watch: be, allWatchedWildcardDirectories: new e2.Map(), allWatchedInputFiles: new e2.Map(), allWatchedConfigFiles: new e2.Map(), allWatchedExtendedConfigFiles: new e2.Map(), allWatchedPackageJsonFiles: new e2.Map(), lastCachedPackageJsonLookups: new e2.Map(), timerToBuildInvalidatedProject: void 0, reportFileChangeDetected: false, watchFile: et, watchDirectory: Gi, writeLog: Wt };
              return Zt;
            }
            function se(be, Ge) {
              return e2.toPath(Ge, be.currentDirectory, be.getCanonicalFileName);
            }
            function J(be, Ge) {
              var ur = be.resolvedConfigFilePaths, yr = ur.get(Ge);
              if (yr !== void 0)
                return yr;
              var Ir = se(be, Ge);
              return ur.set(Ge, Ir), Ir;
            }
            function ie(be) {
              return !!be.options;
            }
            function R(be, Ge) {
              var ur = be.configFileCache.get(Ge);
              return ur && ie(ur) ? ur : void 0;
            }
            function q(be, Ge, ur) {
              var yr = be.configFileCache, Ir = yr.get(ur);
              if (Ir)
                return ie(Ir) ? Ir : void 0;
              var wr, Ur = be.parseConfigFileHost, ii = be.baseCompilerOptions, mi = be.baseWatchOptions, pe = be.extendedConfigCache, or = be.host, qr;
              return or.getParsedCommandLine ? (qr = or.getParsedCommandLine(Ge), qr || (wr = e2.createCompilerDiagnostic(e2.Diagnostics.File_0_not_found, Ge))) : (Ur.onUnRecoverableConfigFileDiagnostic = function(si) {
                return wr = si;
              }, qr = e2.getParsedCommandLineOfConfigFile(Ge, ii, Ur, pe, mi), Ur.onUnRecoverableConfigFileDiagnostic = e2.noop), yr.set(ur, qr || wr), qr;
            }
            function O(be, Ge) {
              return e2.resolveConfigFileProjectName(e2.resolvePath(be.currentDirectory, Ge));
            }
            function ve(be, Ge) {
              for (var ur = new e2.Map(), yr = new e2.Map(), Ir = [], wr, Ur, ii = 0, mi = Ge; ii < mi.length; ii++) {
                var pe = mi[ii];
                or(pe);
              }
              return Ur ? { buildOrder: wr || e2.emptyArray, circularDiagnostics: Ur } : wr || e2.emptyArray;
              function or(qr, si) {
                var Di = J(be, qr);
                if (!yr.has(Di)) {
                  if (ur.has(Di)) {
                    si || (Ur || (Ur = [])).push(e2.createCompilerDiagnostic(e2.Diagnostics.Project_references_may_not_form_a_circular_graph_Cycle_detected_Colon_0, Ir.join(`\r
`)));
                    return;
                  }
                  ur.set(Di, true), Ir.push(qr);
                  var wi = q(be, qr, Di);
                  if (wi && wi.projectReferences)
                    for (var Xi = 0, et = wi.projectReferences; Xi < et.length; Xi++) {
                      var Gi = et[Xi], Wt = O(be, Gi.path);
                      or(Wt, si || Gi.circular);
                    }
                  Ir.pop(), yr.set(Di, true), (wr || (wr = [])).push(qr);
                }
              }
            }
            function ee(be) {
              return be.buildOrder || he(be);
            }
            function he(be) {
              var Ge = ve(be, be.rootNames.map(function(Ir) {
                return O(be, Ir);
              }));
              be.resolvedConfigFilePaths.clear();
              var ur = new e2.Map(N(Ge).map(function(Ir) {
                return [J(be, Ir), true];
              })), yr = { onDeleteValue: e2.noop };
              return e2.mutateMapSkippingNewValues(be.configFileCache, ur, yr), e2.mutateMapSkippingNewValues(be.projectStatus, ur, yr), e2.mutateMapSkippingNewValues(be.buildInfoChecked, ur, yr), e2.mutateMapSkippingNewValues(be.builderPrograms, ur, yr), e2.mutateMapSkippingNewValues(be.diagnostics, ur, yr), e2.mutateMapSkippingNewValues(be.projectPendingBuild, ur, yr), e2.mutateMapSkippingNewValues(be.projectErrorsReported, ur, yr), be.watch && (e2.mutateMapSkippingNewValues(be.allWatchedConfigFiles, ur, { onDeleteValue: e2.closeFileWatcher }), be.allWatchedExtendedConfigFiles.forEach(function(Ir) {
                Ir.projects.forEach(function(wr) {
                  ur.has(wr) || Ir.projects.delete(wr);
                }), Ir.close();
              }), e2.mutateMapSkippingNewValues(be.allWatchedWildcardDirectories, ur, { onDeleteValue: function(Ir) {
                return Ir.forEach(e2.closeFileWatcherOf);
              } }), e2.mutateMapSkippingNewValues(be.allWatchedInputFiles, ur, { onDeleteValue: function(Ir) {
                return Ir.forEach(e2.closeFileWatcher);
              } }), e2.mutateMapSkippingNewValues(be.allWatchedPackageJsonFiles, ur, { onDeleteValue: function(Ir) {
                return Ir.forEach(e2.closeFileWatcher);
              } })), be.buildOrder = Ge;
            }
            function F2(be, Ge, ur) {
              var yr = Ge && O(be, Ge), Ir = ee(be);
              if (le(Ir))
                return Ir;
              if (yr) {
                var wr = J(be, yr), Ur = e2.findIndex(Ir, function(mi) {
                  return J(be, mi) === wr;
                });
                if (Ur === -1)
                  return;
              }
              var ii = yr ? ve(be, [yr]) : Ir;
              return e2.Debug.assert(!le(ii)), e2.Debug.assert(!ur || yr !== void 0), e2.Debug.assert(!ur || ii[ii.length - 1] === yr), ur ? ii.slice(0, ii.length - 1) : ii;
            }
            function x2(be) {
              be.cache && X(be);
              var Ge = be.compilerHost, ur = be.host, yr = be.readFileWithCache, Ir = Ge.getSourceFile, wr = e2.changeCompilerHostLikeToUseCache(ur, function(Di) {
                return se(be, Di);
              }, function() {
                for (var Di = [], wi = 0; wi < arguments.length; wi++)
                  Di[wi] = arguments[wi];
                return Ir.call.apply(Ir, Ve([Ge], Di, false));
              }), Ur = wr.originalReadFile, ii = wr.originalFileExists, mi = wr.originalDirectoryExists, pe = wr.originalCreateDirectory, or = wr.originalWriteFile, qr = wr.getSourceFileWithCache, si = wr.readFileWithCache;
              be.readFileWithCache = si, Ge.getSourceFile = qr, be.cache = { originalReadFile: Ur, originalFileExists: ii, originalDirectoryExists: mi, originalCreateDirectory: pe, originalWriteFile: or, originalReadFileWithCache: yr, originalGetSourceFile: Ir };
            }
            function X(be) {
              if (!!be.cache) {
                var Ge = be.cache, ur = be.host, yr = be.compilerHost, Ir = be.extendedConfigCache, wr = be.moduleResolutionCache, Ur = be.typeReferenceDirectiveResolutionCache;
                ur.readFile = Ge.originalReadFile, ur.fileExists = Ge.originalFileExists, ur.directoryExists = Ge.originalDirectoryExists, ur.createDirectory = Ge.originalCreateDirectory, ur.writeFile = Ge.originalWriteFile, yr.getSourceFile = Ge.originalGetSourceFile, be.readFileWithCache = Ge.originalReadFileWithCache, Ir.clear(), wr == null || wr.clear(), Ur == null || Ur.clear(), be.cache = void 0;
              }
            }
            function $(be, Ge) {
              be.projectStatus.delete(Ge), be.diagnostics.delete(Ge);
            }
            function A2(be, Ge, ur) {
              var yr = be.projectPendingBuild, Ir = yr.get(Ge);
              (Ir === void 0 || Ir < ur) && yr.set(Ge, ur);
            }
            function y(be, Ge) {
              if (!!be.allProjectBuildPending) {
                be.allProjectBuildPending = false, be.options.watch && ir(be, e2.Diagnostics.Starting_compilation_in_watch_mode), x2(be);
                var ur = N(ee(be));
                ur.forEach(function(yr) {
                  return be.projectPendingBuild.set(J(be, yr), e2.ConfigFileProgramReloadLevel.None);
                }), Ge && Ge.throwIfCancellationRequested();
              }
            }
            var V;
            (function(be) {
              be[be.Build = 0] = "Build", be[be.UpdateBundle = 1] = "UpdateBundle", be[be.UpdateOutputFileStamps = 2] = "UpdateOutputFileStamps";
            })(V = e2.InvalidatedProjectKind || (e2.InvalidatedProjectKind = {}));
            function L(be, Ge) {
              return be.projectPendingBuild.delete(Ge), be.currentInvalidatedProject = void 0, be.diagnostics.has(Ge) ? e2.ExitStatus.DiagnosticsPresent_OutputsSkipped : e2.ExitStatus.Success;
            }
            function P(be, Ge, ur, yr, Ir) {
              var wr = true;
              return { kind: V.UpdateOutputFileStamps, project: Ge, projectPath: ur, buildOrder: Ir, getCompilerOptions: function() {
                return yr.options;
              }, getCurrentDirectory: function() {
                return be.currentDirectory;
              }, updateOutputFileStatmps: function() {
                ue(be, yr, ur), wr = false;
              }, done: function() {
                return wr && ue(be, yr, ur), L(be, ur);
              } };
            }
            var k;
            (function(be) {
              be[be.CreateProgram = 0] = "CreateProgram", be[be.SyntaxDiagnostics = 1] = "SyntaxDiagnostics", be[be.SemanticDiagnostics = 2] = "SemanticDiagnostics", be[be.Emit = 3] = "Emit", be[be.EmitBundle = 4] = "EmitBundle", be[be.EmitBuildInfo = 5] = "EmitBuildInfo", be[be.BuildInvalidatedProjectOfBundle = 6] = "BuildInvalidatedProjectOfBundle", be[be.QueueReferencingProjects = 7] = "QueueReferencingProjects", be[be.Done = 8] = "Done";
            })(k || (k = {}));
            function Y(be, Ge, ur, yr, Ir, wr, Ur) {
              var ii = be === V.Build ? k.CreateProgram : k.EmitBundle, mi, pe, or;
              return be === V.Build ? { kind: be, project: ur, projectPath: yr, buildOrder: Ur, getCompilerOptions: function() {
                return wr.options;
              }, getCurrentDirectory: function() {
                return Ge.currentDirectory;
              }, getBuilderProgram: function() {
                return si(e2.identity);
              }, getProgram: function() {
                return si(function(Xe) {
                  return Xe.getProgramOrUndefined();
                });
              }, getSourceFile: function(Xe) {
                return si(function(Jr) {
                  return Jr.getSourceFile(Xe);
                });
              }, getSourceFiles: function() {
                return Di(function(Xe) {
                  return Xe.getSourceFiles();
                });
              }, getOptionsDiagnostics: function(Xe) {
                return Di(function(Jr) {
                  return Jr.getOptionsDiagnostics(Xe);
                });
              }, getGlobalDiagnostics: function(Xe) {
                return Di(function(Jr) {
                  return Jr.getGlobalDiagnostics(Xe);
                });
              }, getConfigFileParsingDiagnostics: function() {
                return Di(function(Xe) {
                  return Xe.getConfigFileParsingDiagnostics();
                });
              }, getSyntacticDiagnostics: function(Xe, Jr) {
                return Di(function(ti) {
                  return ti.getSyntacticDiagnostics(Xe, Jr);
                });
              }, getAllDependencies: function(Xe) {
                return Di(function(Jr) {
                  return Jr.getAllDependencies(Xe);
                });
              }, getSemanticDiagnostics: function(Xe, Jr) {
                return Di(function(ti) {
                  return ti.getSemanticDiagnostics(Xe, Jr);
                });
              }, getSemanticDiagnosticsOfNextAffectedFile: function(Xe, Jr) {
                return si(function(ti) {
                  return ti.getSemanticDiagnosticsOfNextAffectedFile && ti.getSemanticDiagnosticsOfNextAffectedFile(Xe, Jr);
                });
              }, emit: function(Xe, Jr, ti, Ze, Sr) {
                if (Xe || Ze)
                  return si(function(zr) {
                    var Wr, Je;
                    return zr.emit(Xe, Jr, ti, Ze, Sr || ((Je = (Wr = Ge.host).getCustomTransformers) === null || Je === void 0 ? void 0 : Je.call(Wr, ur)));
                  });
                if (ae(k.SemanticDiagnostics, ti), ii === k.EmitBuildInfo)
                  return Zt(Jr, ti);
                if (ii === k.Emit)
                  return Wt(Jr, ti, Sr);
              }, done: qr } : { kind: be, project: ur, projectPath: yr, buildOrder: Ur, getCompilerOptions: function() {
                return wr.options;
              }, getCurrentDirectory: function() {
                return Ge.currentDirectory;
              }, emit: function(Xe, Jr) {
                return ii !== k.EmitBundle ? or : pi(Xe, Jr);
              }, done: qr };
              function qr(Xe, Jr, ti) {
                return ae(k.Done, Xe, Jr, ti), L(Ge, yr);
              }
              function si(Xe) {
                return ae(k.CreateProgram), mi && Xe(mi);
              }
              function Di(Xe) {
                return si(Xe) || e2.emptyArray;
              }
              function wi() {
                var Xe, Jr;
                if (e2.Debug.assert(mi === void 0), Ge.options.dry) {
                  er(Ge, e2.Diagnostics.A_non_dry_build_would_build_project_0, ur), pe = w.Success, ii = k.QueueReferencingProjects;
                  return;
                }
                if (Ge.options.verbose && er(Ge, e2.Diagnostics.Building_project_0, ur), wr.fileNames.length === 0) {
                  Ye(Ge, yr, e2.getConfigFileParsingDiagnostics(wr)), pe = w.None, ii = k.QueueReferencingProjects;
                  return;
                }
                var ti = Ge.host, Ze = Ge.compilerHost;
                Ge.projectCompilerOptions = wr.options, (Xe = Ge.moduleResolutionCache) === null || Xe === void 0 || Xe.update(wr.options), (Jr = Ge.typeReferenceDirectiveResolutionCache) === null || Jr === void 0 || Jr.update(wr.options), mi = ti.createProgram(wr.fileNames, wr.options, Ze, I(Ge, yr, wr), e2.getConfigFileParsingDiagnostics(wr), wr.projectReferences), Ge.watch && (Ge.lastCachedPackageJsonLookups.set(yr, Ge.moduleResolutionCache && e2.map(Ge.moduleResolutionCache.getPackageJsonInfoCache().entries(), function(Sr) {
                  var zr = Sr[0], Wr = Sr[1];
                  return [Ge.host.realpath && Wr ? se(Ge, Ge.host.realpath(zr)) : zr, Wr];
                })), Ge.builderPrograms.set(yr, mi)), ii++;
              }
              function Xi(Xe, Jr, ti) {
                var Ze;
                Xe.length ? (Ze = d(Ge, yr, mi, wr, Xe, Jr, ti), pe = Ze.buildResult, ii = Ze.step) : ii++;
              }
              function et(Xe) {
                e2.Debug.assertIsDefined(mi), Xi(Ve(Ve(Ve(Ve([], mi.getConfigFileParsingDiagnostics(), true), mi.getOptionsDiagnostics(Xe), true), mi.getGlobalDiagnostics(Xe), true), mi.getSyntacticDiagnostics(void 0, Xe), true), w.SyntaxErrors, "Syntactic");
              }
              function Gi(Xe) {
                Xi(e2.Debug.checkDefined(mi).getSemanticDiagnostics(void 0, Xe), w.TypeErrors, "Semantic");
              }
              function Wt(Xe, Jr, ti) {
                var Ze, Sr, zr;
                e2.Debug.assertIsDefined(mi), e2.Debug.assert(ii === k.Emit), mi.backupState();
                var Wr, Je = function(fr) {
                  return (Wr || (Wr = [])).push(fr);
                }, xe = [], vr = e2.emitFilesAndReportErrors(mi, Je, void 0, void 0, function(fr, De, gr) {
                  return xe.push({ name: fr, text: De, writeByteOrderMark: gr });
                }, Jr, false, ti || ((zr = (Sr = Ge.host).getCustomTransformers) === null || zr === void 0 ? void 0 : zr.call(Sr, ur))).emitResult;
                if (Wr)
                  return mi.restoreState(), Ze = d(Ge, yr, mi, wr, Wr, w.DeclarationEmitErrors, "Declaration file"), pe = Ze.buildResult, ii = Ze.step, { emitSkipped: true, diagnostics: vr.diagnostics };
                var mr = Ge.host, Ar = Ge.compilerHost, Oe = w.DeclarationOutputUnchanged, nr = a, Mr = false, Pe = e2.createDiagnosticCollection(), Ue = new e2.Map();
                return xe.forEach(function(fr) {
                  var De = fr.name, gr = fr.text, Vr = fr.writeByteOrderMark, Tr;
                  !Mr && e2.isDeclarationFileName(De) && (mr.fileExists(De) && Ge.readFileWithCache(De) === gr ? Tr = mr.getModifiedTime(De) : (Oe &= ~w.DeclarationOutputUnchanged, Mr = true)), Ue.set(se(Ge, De), De), e2.writeFile(Xe ? { writeFile: Xe } : Ar, Pe, De, gr, Vr), Tr !== void 0 && (nr = Q(Tr, nr));
                }), _r(Pe, Ue, nr, Mr, xe.length ? xe[0].name : e2.getFirstProjectOutput(wr, !mr.useCaseSensitiveFileNames()), Oe), vr;
              }
              function Zt(Xe, Jr) {
                e2.Debug.assertIsDefined(mi), e2.Debug.assert(ii === k.EmitBuildInfo);
                var ti = mi.emitBuildInfo(Xe, Jr);
                return ti.diagnostics.length && (Cr(Ge, ti.diagnostics), Ge.diagnostics.set(yr, Ve(Ve([], Ge.diagnostics.get(yr), true), ti.diagnostics, true)), pe = w.EmitErrors & pe), ti.emittedFiles && Ge.write && ti.emittedFiles.forEach(function(Ze) {
                  return H(Ge, wr, Ze);
                }), l(Ge, mi, wr), ii = k.QueueReferencingProjects, ti;
              }
              function _r(Xe, Jr, ti, Ze, Sr, zr) {
                var Wr, Je = Xe.getDiagnostics();
                if (Je.length)
                  return Wr = d(Ge, yr, mi, wr, Je, w.EmitErrors, "Emit"), pe = Wr.buildResult, ii = Wr.step, Je;
                Ge.write && Jr.forEach(function(vr) {
                  return H(Ge, wr, vr);
                });
                var xe = ne(Ge, wr, ti, e2.Diagnostics.Updating_unchanged_output_timestamps_of_project_0, Jr);
                return Ge.diagnostics.delete(yr), Ge.projectStatus.set(yr, { type: e2.UpToDateStatusType.UpToDate, newestDeclarationFileContentChangedTime: Ze ? C : xe, oldestOutputFileName: Sr }), l(Ge, mi, wr), ii = k.QueueReferencingProjects, pe = zr, Je;
              }
              function pi(Xe, Jr) {
                var ti, Ze;
                if (e2.Debug.assert(be === V.UpdateBundle), Ge.options.dry) {
                  er(Ge, e2.Diagnostics.A_non_dry_build_would_update_output_of_project_0, ur), pe = w.Success, ii = k.QueueReferencingProjects;
                  return;
                }
                Ge.options.verbose && er(Ge, e2.Diagnostics.Updating_output_of_project_0, ur);
                var Sr = Ge.compilerHost;
                Ge.projectCompilerOptions = wr.options;
                var zr = e2.emitUsingBuildInfo(wr, Sr, function(vr) {
                  var mr = O(Ge, vr.path);
                  return q(Ge, mr, J(Ge, mr));
                }, Jr || ((Ze = (ti = Ge.host).getCustomTransformers) === null || Ze === void 0 ? void 0 : Ze.call(ti, ur)));
                if (e2.isString(zr))
                  return er(Ge, e2.Diagnostics.Cannot_update_output_of_project_0_because_there_was_error_reading_file_1, ur, Ae(Ge, zr)), ii = k.BuildInvalidatedProjectOfBundle, or = Y(V.Build, Ge, ur, yr, Ir, wr, Ur);
                e2.Debug.assert(!!zr.length);
                var Wr = e2.createDiagnosticCollection(), Je = new e2.Map();
                zr.forEach(function(vr) {
                  var mr = vr.name, Ar = vr.text, Oe = vr.writeByteOrderMark;
                  Je.set(se(Ge, mr), mr), e2.writeFile(Xe ? { writeFile: Xe } : Sr, Wr, mr, Ar, Oe);
                });
                var xe = _r(Wr, Je, a, false, zr[0].name, w.DeclarationOutputUnchanged);
                return { emitSkipped: false, diagnostics: xe };
              }
              function ae(Xe, Jr, ti, Ze) {
                for (; ii <= Xe && ii < k.Done; ) {
                  var Sr = ii;
                  switch (ii) {
                    case k.CreateProgram:
                      wi();
                      break;
                    case k.SyntaxDiagnostics:
                      et(Jr);
                      break;
                    case k.SemanticDiagnostics:
                      Gi(Jr);
                      break;
                    case k.Emit:
                      Wt(ti, Jr, Ze);
                      break;
                    case k.EmitBuildInfo:
                      Zt(ti, Jr);
                      break;
                    case k.EmitBundle:
                      pi(ti, Ze);
                      break;
                    case k.BuildInvalidatedProjectOfBundle:
                      e2.Debug.checkDefined(or).done(Jr, ti, Ze), ii = k.Done;
                      break;
                    case k.QueueReferencingProjects:
                      We(Ge, ur, yr, Ir, wr, Ur, e2.Debug.checkDefined(pe)), ii++;
                      break;
                    case k.Done:
                    default:
                      e2.assertType(ii);
                  }
                  e2.Debug.assert(ii > Sr);
                }
              }
            }
            function U(be, Ge, ur) {
              var yr = be.options;
              return Ge.type !== e2.UpToDateStatusType.OutOfDateWithPrepend || yr.force ? true : ur.fileNames.length === 0 || !!e2.getConfigFileParsingDiagnostics(ur).length || !e2.isIncrementalCompilation(ur.options);
            }
            function j(be, Ge, ur) {
              if (!!be.projectPendingBuild.size && !le(Ge)) {
                if (be.currentInvalidatedProject)
                  return e2.arrayIsEqualTo(be.currentInvalidatedProject.buildOrder, Ge) ? be.currentInvalidatedProject : void 0;
                for (var yr = be.options, Ir = be.projectPendingBuild, wr = 0; wr < Ge.length; wr++) {
                  var Ur = Ge[wr], ii = J(be, Ur), mi = be.projectPendingBuild.get(ii);
                  if (mi !== void 0) {
                    ur && (ur = false, Ne(be, Ge));
                    var pe = q(be, Ur, ii);
                    if (!pe) {
                      Br(be, ii), Ir.delete(ii);
                      continue;
                    }
                    mi === e2.ConfigFileProgramReloadLevel.Full ? (Ee(be, Ur, ii, pe), He(be, ii, pe), rr(be, Ur, ii, pe), Ie(be, Ur, ii, pe), _e(be, Ur, ii, pe)) : mi === e2.ConfigFileProgramReloadLevel.Partial && (pe.fileNames = e2.getFileNamesFromConfigSpecs(pe.options.configFile.configFileSpecs, e2.getDirectoryPath(Ur), pe.options, be.parseConfigFileHost), e2.updateErrorForNoInputFiles(pe.fileNames, Ur, pe.options.configFile.configFileSpecs, pe.errors, e2.canJsonReportNoInputFiles(pe.raw)), Ie(be, Ur, ii, pe), _e(be, Ur, ii, pe));
                    var or = g(be, pe, ii);
                    if (lr(be, Ur, or), !yr.force) {
                      if (or.type === e2.UpToDateStatusType.UpToDate) {
                        Ye(be, ii, e2.getConfigFileParsingDiagnostics(pe)), Ir.delete(ii), yr.dry && er(be, e2.Diagnostics.Project_0_is_up_to_date, Ur);
                        continue;
                      }
                      if (or.type === e2.UpToDateStatusType.UpToDateWithUpstreamTypes)
                        return Ye(be, ii, e2.getConfigFileParsingDiagnostics(pe)), P(be, Ur, ii, pe, Ge);
                    }
                    if (or.type === e2.UpToDateStatusType.UpstreamBlocked) {
                      Ye(be, ii, e2.getConfigFileParsingDiagnostics(pe)), Ir.delete(ii), yr.verbose && er(be, or.upstreamProjectBlocked ? e2.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_was_not_built : e2.Diagnostics.Skipping_build_of_project_0_because_its_dependency_1_has_errors, Ur, or.upstreamProjectName);
                      continue;
                    }
                    if (or.type === e2.UpToDateStatusType.ContainerOnly) {
                      Ye(be, ii, e2.getConfigFileParsingDiagnostics(pe)), Ir.delete(ii);
                      continue;
                    }
                    return Y(U(be, or, pe) ? V.Build : V.UpdateBundle, be, Ur, ii, wr, pe, Ge);
                  }
                }
              }
            }
            function H(be, Ge, ur) {
              var yr = be.write;
              yr && Ge.options.listEmittedFiles && yr("TSFILE: ".concat(ur));
            }
            function I(be, Ge, ur) {
              var yr = be.options, Ir = be.builderPrograms, wr = be.compilerHost;
              if (!yr.force) {
                var Ur = Ir.get(Ge);
                return Ur || e2.readBuilderProgram(ur.options, wr);
              }
            }
            function l(be, Ge, ur) {
              Ge ? (Ge && be.write && e2.listFiles(Ge, be.write), be.host.afterProgramEmitAndDiagnostics && be.host.afterProgramEmitAndDiagnostics(Ge), Ge.releaseProgram()) : be.host.afterEmitBundle && be.host.afterEmitBundle(ur), be.projectCompilerOptions = be.baseCompilerOptions;
            }
            function d(be, Ge, ur, yr, Ir, wr, Ur) {
              var ii = !(wr & w.SyntaxErrors) && ur && !e2.outFile(ur.getCompilerOptions());
              return Ye(be, Ge, Ir), be.projectStatus.set(Ge, { type: e2.UpToDateStatusType.Unbuildable, reason: "".concat(Ur, " errors") }), ii ? { buildResult: wr, step: k.EmitBuildInfo } : (l(be, ur, yr), { buildResult: wr, step: k.QueueReferencingProjects });
            }
            function D(be, Ge, ur, yr) {
              var Ir = e2.getModifiedTime(be.host, Ge);
              if (ur < Ir)
                return { type: e2.UpToDateStatusType.OutOfDateWithSelf, outOfDateOutputFileName: yr, newerInputFileName: Ge };
            }
            function fe(be, Ge, ur) {
              for (var yr = !!be.options.force, Ir = void 0, wr = a, Ur = be.host, ii = 0, mi = Ge.fileNames; ii < mi.length; ii++) {
                var pe = mi[ii];
                if (!Ur.fileExists(pe))
                  return { type: e2.UpToDateStatusType.Unbuildable, reason: "".concat(pe, " does not exist") };
                if (!yr) {
                  var or = e2.getModifiedTime(Ur, pe);
                  or > wr && (Ir = pe, wr = or);
                }
              }
              if (!Ge.fileNames.length && !e2.canJsonReportNoInputFiles(Ge.raw))
                return { type: e2.UpToDateStatusType.ContainerOnly };
              var qr = e2.getAllProjectOutputs(Ge, !Ur.useCaseSensitiveFileNames()), si = "(none)", Di = C, wi = "(none)", Xi = a, et, Gi = a, Wt = false;
              if (!yr)
                for (var Zt = 0, _r = qr; Zt < _r.length; Zt++) {
                  var pi = _r[Zt];
                  if (!Ur.fileExists(pi)) {
                    et = pi;
                    break;
                  }
                  var ae = e2.getModifiedTime(Ur, pi);
                  if (ae < Di && (Di = ae, si = pi), ae < wr) {
                    Wt = true;
                    break;
                  }
                  if (ae > Xi && (Xi = ae, wi = pi), e2.isDeclarationFileName(pi)) {
                    var Xe = e2.getModifiedTime(Ur, pi);
                    Gi = Q(Gi, Xe);
                  }
                }
              var Jr = false, ti = false, Ze;
              if (Ge.projectReferences) {
                be.projectStatus.set(ur, { type: e2.UpToDateStatusType.ComputingUpstream });
                for (var Sr = 0, zr = Ge.projectReferences; Sr < zr.length; Sr++) {
                  var Wr = zr[Sr];
                  ti = ti || !!Wr.prepend;
                  var Je = e2.resolveProjectReferencePath(Wr), xe = J(be, Je), vr = g(be, q(be, Je, xe), xe);
                  if (!(vr.type === e2.UpToDateStatusType.ComputingUpstream || vr.type === e2.UpToDateStatusType.ContainerOnly)) {
                    if (vr.type === e2.UpToDateStatusType.Unbuildable || vr.type === e2.UpToDateStatusType.UpstreamBlocked)
                      return { type: e2.UpToDateStatusType.UpstreamBlocked, upstreamProjectName: Wr.path, upstreamProjectBlocked: vr.type === e2.UpToDateStatusType.UpstreamBlocked };
                    if (vr.type !== e2.UpToDateStatusType.UpToDate)
                      return { type: e2.UpToDateStatusType.UpstreamOutOfDate, upstreamProjectName: Wr.path };
                    if (!yr && !et) {
                      if (vr.newestInputFileTime && vr.newestInputFileTime <= Di)
                        continue;
                      if (vr.newestDeclarationFileContentChangedTime && vr.newestDeclarationFileContentChangedTime <= Di) {
                        Jr = true, Ze = Wr.path;
                        continue;
                      }
                      return e2.Debug.assert(si !== void 0, "Should have an oldest output filename here"), { type: e2.UpToDateStatusType.OutOfDateWithUpstream, outOfDateOutputFileName: si, newerProjectName: Wr.path };
                    }
                  }
                }
              }
              if (et !== void 0)
                return { type: e2.UpToDateStatusType.OutputMissing, missingOutputFileName: et };
              if (Wt)
                return { type: e2.UpToDateStatusType.OutOfDateWithSelf, outOfDateOutputFileName: si, newerInputFileName: Ir };
              var mr = D(be, Ge.options.configFilePath, Di, si);
              if (mr)
                return mr;
              var Ar = e2.forEach(Ge.options.configFile.extendedSourceFiles || e2.emptyArray, function(Ue) {
                return D(be, Ue, Di, si);
              });
              if (Ar)
                return Ar;
              var Oe = e2.forEach(be.lastCachedPackageJsonLookups.get(ur) || e2.emptyArray, function(Ue) {
                var fr = Ue[0];
                return D(be, fr, Di, si);
              });
              if (Oe)
                return Oe;
              if (!yr && !be.buildInfoChecked.has(ur)) {
                be.buildInfoChecked.set(ur, true);
                var nr = e2.getTsBuildInfoEmitOutputFilePath(Ge.options);
                if (nr) {
                  var Mr = be.readFileWithCache(nr), Pe = Mr && e2.getBuildInfo(Mr);
                  if (Pe && (Pe.bundle || Pe.program) && Pe.version !== e2.version)
                    return { type: e2.UpToDateStatusType.TsVersionOutputOfDate, version: Pe.version };
                }
              }
              return ti && Jr ? { type: e2.UpToDateStatusType.OutOfDateWithPrepend, outOfDateOutputFileName: si, newerProjectName: Ze } : { type: Jr ? e2.UpToDateStatusType.UpToDateWithUpstreamTypes : e2.UpToDateStatusType.UpToDate, newestDeclarationFileContentChangedTime: Gi, newestInputFileTime: wr, newestOutputFileTime: Xi, newestInputFileName: Ir, newestOutputFileName: wi, oldestOutputFileName: si };
            }
            function g(be, Ge, ur) {
              if (Ge === void 0)
                return { type: e2.UpToDateStatusType.Unbuildable, reason: "File deleted mid-build" };
              var yr = be.projectStatus.get(ur);
              if (yr !== void 0)
                return yr;
              var Ir = fe(be, Ge, ur);
              return be.projectStatus.set(ur, Ir), Ir;
            }
            function ne(be, Ge, ur, yr, Ir) {
              if (Ge.options.noEmit)
                return ur;
              var wr = be.host, Ur = e2.getAllProjectOutputs(Ge, !wr.useCaseSensitiveFileNames());
              if (!Ir || Ur.length !== Ir.size)
                for (var ii = !!be.options.verbose, mi = wr.now ? wr.now() : new Date(), pe = 0, or = Ur; pe < or.length; pe++) {
                  var qr = or[pe];
                  Ir && Ir.has(se(be, qr)) || (ii && (ii = false, er(be, yr, Ge.options.configFilePath)), e2.isDeclarationFileName(qr) && (ur = Q(ur, e2.getModifiedTime(wr, qr))), wr.setModifiedTime(qr, mi));
                }
              return ur;
            }
            function ue(be, Ge, ur) {
              if (be.options.dry)
                return er(be, e2.Diagnostics.A_non_dry_build_would_update_timestamps_for_output_of_project_0, Ge.options.configFilePath);
              var yr = ne(be, Ge, a, e2.Diagnostics.Updating_output_timestamps_of_project_0);
              be.projectStatus.set(ur, { type: e2.UpToDateStatusType.UpToDate, newestDeclarationFileContentChangedTime: yr, oldestOutputFileName: e2.getFirstProjectOutput(Ge, !be.host.useCaseSensitiveFileNames()) });
            }
            function We(be, Ge, ur, yr, Ir, wr, Ur) {
              if (!(Ur & w.AnyErrors) && !!Ir.options.composite)
                for (var ii = yr + 1; ii < wr.length; ii++) {
                  var mi = wr[ii], pe = J(be, mi);
                  if (!be.projectPendingBuild.has(pe)) {
                    var or = q(be, mi, pe);
                    if (!(!or || !or.projectReferences))
                      for (var qr = 0, si = or.projectReferences; qr < si.length; qr++) {
                        var Di = si[qr], wi = O(be, Di.path);
                        if (J(be, wi) === ur) {
                          var Xi = be.projectStatus.get(pe);
                          if (Xi)
                            switch (Xi.type) {
                              case e2.UpToDateStatusType.UpToDate:
                                if (Ur & w.DeclarationOutputUnchanged) {
                                  Di.prepend ? be.projectStatus.set(pe, { type: e2.UpToDateStatusType.OutOfDateWithPrepend, outOfDateOutputFileName: Xi.oldestOutputFileName, newerProjectName: Ge }) : Xi.type = e2.UpToDateStatusType.UpToDateWithUpstreamTypes;
                                  break;
                                }
                              case e2.UpToDateStatusType.UpToDateWithUpstreamTypes:
                              case e2.UpToDateStatusType.OutOfDateWithPrepend:
                                Ur & w.DeclarationOutputUnchanged || be.projectStatus.set(pe, { type: e2.UpToDateStatusType.OutOfDateWithUpstream, outOfDateOutputFileName: Xi.type === e2.UpToDateStatusType.OutOfDateWithPrepend ? Xi.outOfDateOutputFileName : Xi.oldestOutputFileName, newerProjectName: Ge });
                                break;
                              case e2.UpToDateStatusType.UpstreamBlocked:
                                J(be, O(be, Xi.upstreamProjectName)) === ur && $(be, pe);
                                break;
                            }
                          A2(be, pe, e2.ConfigFileProgramReloadLevel.None);
                          break;
                        }
                      }
                  }
                }
            }
            function Fe(be, Ge, ur, yr, Ir, wr) {
              var Ur = F2(be, Ge, wr);
              if (!Ur)
                return e2.ExitStatus.InvalidProject_OutputsSkipped;
              y(be, ur);
              for (var ii = true, mi = 0; ; ) {
                var pe = j(be, Ur, ii);
                if (!pe)
                  break;
                ii = false, pe.done(ur, yr, Ir == null ? void 0 : Ir(pe.project)), be.diagnostics.has(pe.projectPath) || mi++;
              }
              return X(be), Er(be, Ur), we(be, Ur), le(Ur) ? e2.ExitStatus.ProjectReferenceCycle_OutputsSkipped : Ur.some(function(or) {
                return be.diagnostics.has(J(be, or));
              }) ? mi ? e2.ExitStatus.DiagnosticsPresent_OutputsGenerated : e2.ExitStatus.DiagnosticsPresent_OutputsSkipped : e2.ExitStatus.Success;
            }
            function Z2(be, Ge, ur) {
              var yr = F2(be, Ge, ur);
              if (!yr)
                return e2.ExitStatus.InvalidProject_OutputsSkipped;
              if (le(yr))
                return Cr(be, yr.circularDiagnostics), e2.ExitStatus.ProjectReferenceCycle_OutputsSkipped;
              for (var Ir = be.options, wr = be.host, Ur = Ir.dry ? [] : void 0, ii = 0, mi = yr; ii < mi.length; ii++) {
                var pe = mi[ii], or = J(be, pe), qr = q(be, pe, or);
                if (qr === void 0) {
                  Br(be, or);
                  continue;
                }
                var si = e2.getAllProjectOutputs(qr, !wr.useCaseSensitiveFileNames());
                if (!!si.length)
                  for (var Di = new e2.Set(qr.fileNames.map(function(Gi) {
                    return se(be, Gi);
                  })), wi = 0, Xi = si; wi < Xi.length; wi++) {
                    var et = Xi[wi];
                    Di.has(se(be, et)) || wr.fileExists(et) && (Ur ? Ur.push(et) : (wr.deleteFile(et), Be(be, or, e2.ConfigFileProgramReloadLevel.None)));
                  }
              }
              return Ur && er(be, e2.Diagnostics.A_non_dry_build_would_delete_the_following_files_Colon_0, Ur.map(function(Gi) {
                return `\r
 * `.concat(Gi);
              }).join("")), e2.ExitStatus.Success;
            }
            function Be(be, Ge, ur) {
              be.host.getParsedCommandLine && ur === e2.ConfigFileProgramReloadLevel.Partial && (ur = e2.ConfigFileProgramReloadLevel.Full), ur === e2.ConfigFileProgramReloadLevel.Full && (be.configFileCache.delete(Ge), be.buildOrder = void 0), be.needsSummary = true, $(be, Ge), A2(be, Ge, ur), x2(be);
            }
            function ge(be, Ge, ur) {
              be.reportFileChangeDetected = true, Be(be, Ge, ur), Re(be);
            }
            function Re(be) {
              var Ge = be.hostWithWatch;
              !Ge.setTimeout || !Ge.clearTimeout || (be.timerToBuildInvalidatedProject && Ge.clearTimeout(be.timerToBuildInvalidatedProject), be.timerToBuildInvalidatedProject = Ge.setTimeout(ze, 250, be));
            }
            function ze(be) {
              be.timerToBuildInvalidatedProject = void 0, be.reportFileChangeDetected && (be.reportFileChangeDetected = false, be.projectErrorsReported.clear(), ir(be, e2.Diagnostics.File_change_detected_Starting_incremental_compilation));
              var Ge = ee(be), ur = j(be, Ge, false);
              if (ur && (ur.done(), be.projectPendingBuild.size)) {
                be.watch && !be.timerToBuildInvalidatedProject && Re(be);
                return;
              }
              X(be), Er(be, Ge);
            }
            function Ee(be, Ge, ur, yr) {
              !be.watch || be.allWatchedConfigFiles.has(ur) || be.allWatchedConfigFiles.set(ur, be.watchFile(Ge, function() {
                ge(be, ur, e2.ConfigFileProgramReloadLevel.Full);
              }, e2.PollingInterval.High, yr == null ? void 0 : yr.watchOptions, e2.WatchType.ConfigFile, Ge));
            }
            function He(be, Ge, ur) {
              e2.updateSharedExtendedConfigFileWatcher(Ge, ur == null ? void 0 : ur.options, be.allWatchedExtendedConfigFiles, function(yr, Ir) {
                return be.watchFile(yr, function() {
                  var wr;
                  return (wr = be.allWatchedExtendedConfigFiles.get(Ir)) === null || wr === void 0 ? void 0 : wr.projects.forEach(function(Ur) {
                    return ge(be, Ur, e2.ConfigFileProgramReloadLevel.Full);
                  });
                }, e2.PollingInterval.High, ur == null ? void 0 : ur.watchOptions, e2.WatchType.ExtendedConfigFile);
              }, function(yr) {
                return se(be, yr);
              });
            }
            function rr(be, Ge, ur, yr) {
              !be.watch || e2.updateWatchingWildcardDirectories(E(be.allWatchedWildcardDirectories, ur), new e2.Map(e2.getEntries(yr.wildcardDirectories)), function(Ir, wr) {
                return be.watchDirectory(Ir, function(Ur) {
                  var ii;
                  e2.isIgnoredFileFromWildCardWatching({ watchedDirPath: se(be, Ir), fileOrDirectory: Ur, fileOrDirectoryPath: se(be, Ur), configFileName: Ge, currentDirectory: be.currentDirectory, options: yr.options, program: be.builderPrograms.get(ur) || ((ii = R(be, ur)) === null || ii === void 0 ? void 0 : ii.fileNames), useCaseSensitiveFileNames: be.parseConfigFileHost.useCaseSensitiveFileNames, writeLog: function(mi) {
                    return be.writeLog(mi);
                  }, toPath: function(mi) {
                    return se(be, mi);
                  } }) || ge(be, ur, e2.ConfigFileProgramReloadLevel.Partial);
                }, wr, yr == null ? void 0 : yr.watchOptions, e2.WatchType.WildcardDirectory, Ge);
              });
            }
            function Ie(be, Ge, ur, yr) {
              !be.watch || e2.mutateMap(E(be.allWatchedInputFiles, ur), e2.arrayToMap(yr.fileNames, function(Ir) {
                return se(be, Ir);
              }), { createNewValue: function(Ir, wr) {
                return be.watchFile(wr, function() {
                  return ge(be, ur, e2.ConfigFileProgramReloadLevel.None);
                }, e2.PollingInterval.Low, yr == null ? void 0 : yr.watchOptions, e2.WatchType.SourceFile, Ge);
              }, onDeleteValue: e2.closeFileWatcher });
            }
            function _e(be, Ge, ur, yr) {
              !be.watch || !be.lastCachedPackageJsonLookups || e2.mutateMap(E(be.allWatchedPackageJsonFiles, ur), new e2.Map(be.lastCachedPackageJsonLookups.get(ur)), { createNewValue: function(Ir, wr) {
                return be.watchFile(Ir, function() {
                  return ge(be, ur, e2.ConfigFileProgramReloadLevel.None);
                }, e2.PollingInterval.High, yr == null ? void 0 : yr.watchOptions, e2.WatchType.PackageJson, Ge);
              }, onDeleteValue: e2.closeFileWatcher });
            }
            function we(be, Ge) {
              if (!!be.watchAllProjectsPending) {
                be.watchAllProjectsPending = false;
                for (var ur = 0, yr = N(Ge); ur < yr.length; ur++) {
                  var Ir = yr[ur], wr = J(be, Ir), Ur = q(be, Ir, wr);
                  Ee(be, Ir, wr, Ur), He(be, wr, Ur), Ur && (rr(be, Ir, wr, Ur), Ie(be, Ir, wr, Ur), _e(be, Ir, wr, Ur));
                }
              }
            }
            function de(be) {
              e2.clearMap(be.allWatchedConfigFiles, e2.closeFileWatcher), e2.clearMap(be.allWatchedExtendedConfigFiles, e2.closeFileWatcherOf), e2.clearMap(be.allWatchedWildcardDirectories, function(Ge) {
                return e2.clearMap(Ge, e2.closeFileWatcherOf);
              }), e2.clearMap(be.allWatchedInputFiles, function(Ge) {
                return e2.clearMap(Ge, e2.closeFileWatcher);
              }), e2.clearMap(be.allWatchedPackageJsonFiles, function(Ge) {
                return e2.clearMap(Ge, e2.closeFileWatcher);
              });
            }
            function ye(be, Ge, ur, yr, Ir) {
              var wr = b(be, Ge, ur, yr, Ir);
              return { build: function(Ur, ii, mi, pe) {
                return Fe(wr, Ur, ii, mi, pe);
              }, clean: function(Ur) {
                return Z2(wr, Ur);
              }, buildReferences: function(Ur, ii, mi, pe) {
                return Fe(wr, Ur, ii, mi, pe, true);
              }, cleanReferences: function(Ur) {
                return Z2(wr, Ur, true);
              }, getNextInvalidatedProject: function(Ur) {
                return y(wr, Ur), j(wr, ee(wr), false);
              }, getBuildOrder: function() {
                return ee(wr);
              }, getUpToDateStatusOfProject: function(Ur) {
                var ii = O(wr, Ur), mi = J(wr, ii);
                return g(wr, q(wr, ii, mi), mi);
              }, invalidateProject: function(Ur, ii) {
                return Be(wr, Ur, ii || e2.ConfigFileProgramReloadLevel.None);
              }, buildNextInvalidatedProject: function() {
                return ze(wr);
              }, getAllParsedConfigs: function() {
                return e2.arrayFrom(e2.mapDefinedIterator(wr.configFileCache.values(), function(Ur) {
                  return ie(Ur) ? Ur : void 0;
                }));
              }, close: function() {
                return de(wr);
              } };
            }
            function Ae(be, Ge) {
              return e2.convertToRelativePath(Ge, be.currentDirectory, function(ur) {
                return be.getCanonicalFileName(ur);
              });
            }
            function er(be, Ge) {
              for (var ur = [], yr = 2; yr < arguments.length; yr++)
                ur[yr - 2] = arguments[yr];
              be.host.reportSolutionBuilderStatus(e2.createCompilerDiagnostic.apply(void 0, Ve([Ge], ur, false)));
            }
            function ir(be, Ge) {
              for (var ur, yr, Ir = [], wr = 2; wr < arguments.length; wr++)
                Ir[wr - 2] = arguments[wr];
              (yr = (ur = be.hostWithWatch).onWatchStatusChange) === null || yr === void 0 || yr.call(ur, e2.createCompilerDiagnostic.apply(void 0, Ve([Ge], Ir, false)), be.host.getNewLine(), be.baseCompilerOptions);
            }
            function Cr(be, Ge) {
              var ur = be.host;
              Ge.forEach(function(yr) {
                return ur.reportDiagnostic(yr);
              });
            }
            function Ye(be, Ge, ur) {
              Cr(be, ur), be.projectErrorsReported.set(Ge, true), ur.length && be.diagnostics.set(Ge, ur);
            }
            function Br(be, Ge) {
              Ye(be, Ge, [be.configFileCache.get(Ge)]);
            }
            function Er(be, Ge) {
              if (!!be.needsSummary) {
                be.needsSummary = false;
                var ur = be.watch || !!be.host.reportErrorSummary, yr = be.diagnostics, Ir = 0, wr = [];
                le(Ge) ? (Ne(be, Ge.buildOrder), Cr(be, Ge.circularDiagnostics), ur && (Ir += e2.getErrorCountForSummary(Ge.circularDiagnostics)), ur && (wr = Ve(Ve([], wr, true), e2.getFilesInErrorForSummary(Ge.circularDiagnostics), true))) : (Ge.forEach(function(Ur) {
                  var ii = J(be, Ur);
                  be.projectErrorsReported.has(ii) || Cr(be, yr.get(ii) || e2.emptyArray);
                }), ur && yr.forEach(function(Ur) {
                  return Ir += e2.getErrorCountForSummary(Ur);
                }), ur && yr.forEach(function(Ur) {
                  return Ve(Ve([], wr, true), e2.getFilesInErrorForSummary(Ur), true);
                })), be.watch ? ir(be, e2.getWatchErrorSummaryDiagnosticMessage(Ir), Ir) : be.host.reportErrorSummary && be.host.reportErrorSummary(Ir, wr);
              }
            }
            function Ne(be, Ge) {
              be.options.verbose && er(be, e2.Diagnostics.Projects_in_this_build_Colon_0, Ge.map(function(ur) {
                return `\r
    * ` + Ae(be, ur);
              }).join(""));
            }
            function n(be, Ge, ur) {
              if (be.options.force && (ur.type === e2.UpToDateStatusType.UpToDate || ur.type === e2.UpToDateStatusType.UpToDateWithUpstreamTypes))
                return er(be, e2.Diagnostics.Project_0_is_being_forcibly_rebuilt, Ae(be, Ge));
              switch (ur.type) {
                case e2.UpToDateStatusType.OutOfDateWithSelf:
                  return er(be, e2.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, Ae(be, Ge), Ae(be, ur.outOfDateOutputFileName), Ae(be, ur.newerInputFileName));
                case e2.UpToDateStatusType.OutOfDateWithUpstream:
                  return er(be, e2.Diagnostics.Project_0_is_out_of_date_because_oldest_output_1_is_older_than_newest_input_2, Ae(be, Ge), Ae(be, ur.outOfDateOutputFileName), Ae(be, ur.newerProjectName));
                case e2.UpToDateStatusType.OutputMissing:
                  return er(be, e2.Diagnostics.Project_0_is_out_of_date_because_output_file_1_does_not_exist, Ae(be, Ge), Ae(be, ur.missingOutputFileName));
                case e2.UpToDateStatusType.UpToDate:
                  if (ur.newestInputFileTime !== void 0)
                    return er(be, e2.Diagnostics.Project_0_is_up_to_date_because_newest_input_1_is_older_than_oldest_output_2, Ae(be, Ge), Ae(be, ur.newestInputFileName || ""), Ae(be, ur.oldestOutputFileName || ""));
                  break;
                case e2.UpToDateStatusType.OutOfDateWithPrepend:
                  return er(be, e2.Diagnostics.Project_0_is_out_of_date_because_output_of_its_dependency_1_has_changed, Ae(be, Ge), Ae(be, ur.newerProjectName));
                case e2.UpToDateStatusType.UpToDateWithUpstreamTypes:
                  return er(be, e2.Diagnostics.Project_0_is_up_to_date_with_d_ts_files_from_its_dependencies, Ae(be, Ge));
                case e2.UpToDateStatusType.UpstreamOutOfDate:
                  return er(be, e2.Diagnostics.Project_0_is_out_of_date_because_its_dependency_1_is_out_of_date, Ae(be, Ge), Ae(be, ur.upstreamProjectName));
                case e2.UpToDateStatusType.UpstreamBlocked:
                  return er(be, ur.upstreamProjectBlocked ? e2.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_was_not_built : e2.Diagnostics.Project_0_can_t_be_built_because_its_dependency_1_has_errors, Ae(be, Ge), Ae(be, ur.upstreamProjectName));
                case e2.UpToDateStatusType.Unbuildable:
                  return er(be, e2.Diagnostics.Failed_to_parse_file_0_Colon_1, Ae(be, Ge), ur.reason);
                case e2.UpToDateStatusType.TsVersionOutputOfDate:
                  return er(be, e2.Diagnostics.Project_0_is_out_of_date_because_output_for_it_was_generated_with_version_1_that_differs_with_current_version_2, Ae(be, Ge), ur.version, e2.version);
                case e2.UpToDateStatusType.ContainerOnly:
                case e2.UpToDateStatusType.ComputingUpstream:
                  break;
                default:
                  e2.assertType(ur);
              }
            }
            function lr(be, Ge, ur) {
              be.options.verbose && n(be, Ge, ur);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              C.ActionSet = "action::set", C.ActionInvalidate = "action::invalidate", C.ActionPackageInstalled = "action::packageInstalled", C.EventTypesRegistry = "event::typesRegistry", C.EventBeginInstallTypes = "event::beginInstallTypes", C.EventEndInstallTypes = "event::endInstallTypes", C.EventInitializationFailed = "event::initializationFailed";
              var w;
              (function(le) {
                le.GlobalCacheLocation = "--globalTypingsCacheLocation", le.LogFile = "--logFile", le.EnableTelemetry = "--enableTelemetry", le.TypingSafeListLocation = "--typingSafeListLocation", le.TypesMapLocation = "--typesMapLocation", le.NpmLocation = "--npmLocation", le.ValidateDefaultNpmLocation = "--validateDefaultNpmLocation";
              })(w = C.Arguments || (C.Arguments = {}));
              function B(le) {
                return e2.sys.args.indexOf(le) >= 0;
              }
              C.hasArgument = B;
              function E(le) {
                var N = e2.sys.args.indexOf(le);
                return N >= 0 && N < e2.sys.args.length - 1 ? e2.sys.args[N + 1] : void 0;
              }
              C.findArgument = E;
              function Q() {
                var le = new Date();
                return "".concat(e2.padLeft(le.getHours().toString(), 2, "0"), ":").concat(e2.padLeft(le.getMinutes().toString(), 2, "0"), ":").concat(e2.padLeft(le.getSeconds().toString(), 2, "0"), ".").concat(e2.padLeft(le.getMilliseconds().toString(), 3, "0"));
              }
              C.nowString = Q;
            })(a = e2.server || (e2.server = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(K, b) {
                var se = new e2.Version(e2.getProperty(b, "ts".concat(e2.versionMajorMinor)) || e2.getProperty(b, "latest"));
                return se.compareTo(K.version) <= 0;
              }
              C.isTypingUpToDate = w;
              var B = ["assert", "assert/strict", "async_hooks", "buffer", "child_process", "cluster", "console", "constants", "crypto", "dgram", "diagnostics_channel", "dns", "dns/promises", "domain", "events", "fs", "fs/promises", "http", "https", "http2", "inspector", "module", "net", "os", "path", "perf_hooks", "process", "punycode", "querystring", "readline", "repl", "stream", "stream/promises", "string_decoder", "timers", "timers/promises", "tls", "trace_events", "tty", "url", "util", "util/types", "v8", "vm", "wasi", "worker_threads", "zlib"];
              C.prefixedNodeCoreModuleList = B.map(function(K) {
                return "node:".concat(K);
              }), C.nodeCoreModuleList = Ve(Ve([], B, true), C.prefixedNodeCoreModuleList, true), C.nodeCoreModules = new e2.Set(C.nodeCoreModuleList);
              function E(K) {
                return C.nodeCoreModules.has(K) ? "node" : K;
              }
              C.nonRelativeModuleNameForTypingCache = E;
              function Q(K, b) {
                var se = e2.readConfigFile(b, function(J) {
                  return K.readFile(J);
                });
                return new e2.Map(e2.getEntries(se.config));
              }
              C.loadSafeList = Q;
              function le(K, b) {
                var se = e2.readConfigFile(b, function(J) {
                  return K.readFile(J);
                });
                if (se.config)
                  return new e2.Map(e2.getEntries(se.config.simpleMap));
              }
              C.loadTypesMap = le;
              function N(K, b, se, J, ie, R, q, O, ve) {
                if (!q || !q.enable)
                  return { cachedTypingPaths: [], newTypingNames: [], filesToWatch: [] };
                var ee = new e2.Map();
                se = e2.mapDefined(se, function(I) {
                  var l = e2.normalizePath(I);
                  if (e2.hasJSFileExtension(l))
                    return l;
                });
                var he = [];
                q.include && U(q.include, "Explicitly included types");
                var F2 = q.exclude || [], x2 = new e2.Set(se.map(e2.getDirectoryPath));
                if (x2.add(J), x2.forEach(function(I) {
                  j(I, "bower.json", "bower_components", he), j(I, "package.json", "node_modules", he);
                }), q.disableFilenameBasedTypeAcquisition || H(se), O) {
                  var X = e2.deduplicate(O.map(E), e2.equateStringsCaseSensitive, e2.compareStringsCaseSensitive);
                  U(X, "Inferred typings from unresolved imports");
                }
                R.forEach(function(I, l) {
                  var d = ve.get(l);
                  ee.has(l) && ee.get(l) === void 0 && d !== void 0 && w(I, d) && ee.set(l, I.typingLocation);
                });
                for (var $ = 0, A2 = F2; $ < A2.length; $++) {
                  var y = A2[$], V = ee.delete(y);
                  V && b && b("Typing for ".concat(y, " is in exclude list, will be ignored."));
                }
                var L = [], P = [];
                ee.forEach(function(I, l) {
                  I !== void 0 ? P.push(I) : L.push(l);
                });
                var k = { cachedTypingPaths: P, newTypingNames: L, filesToWatch: he };
                return b && b("Result: ".concat(JSON.stringify(k))), k;
                function Y(I) {
                  ee.has(I) || ee.set(I, void 0);
                }
                function U(I, l) {
                  b && b("".concat(l, ": ").concat(JSON.stringify(I))), e2.forEach(I, Y);
                }
                function j(I, l, d, D) {
                  var fe = e2.combinePaths(I, l), g, ne;
                  K.fileExists(fe) && (D.push(fe), g = e2.readConfigFile(fe, function(Ie) {
                    return K.readFile(Ie);
                  }).config, ne = e2.flatMap([g.dependencies, g.devDependencies, g.optionalDependencies, g.peerDependencies], e2.getOwnKeys), U(ne, "Typing names in '".concat(fe, "' dependencies")));
                  var ue = e2.combinePaths(I, d);
                  if (D.push(ue), !!K.directoryExists(ue)) {
                    var We = [], Fe = ne ? ne.map(function(Ie) {
                      return e2.combinePaths(ue, Ie, l);
                    }) : K.readDirectory(ue, [".json"], void 0, void 0, 3).filter(function(Ie) {
                      if (e2.getBaseFileName(Ie) !== l)
                        return false;
                      var _e = e2.getPathComponents(e2.normalizePath(Ie)), we = _e[_e.length - 3][0] === "@";
                      return we && _e[_e.length - 4].toLowerCase() === d || !we && _e[_e.length - 3].toLowerCase() === d;
                    });
                    b && b("Searching for typing names in ".concat(ue, "; all files: ").concat(JSON.stringify(Fe)));
                    for (var Z2 = 0, Be = Fe; Z2 < Be.length; Z2++) {
                      var ge = Be[Z2], Re = e2.normalizePath(ge), ze = e2.readConfigFile(Re, function(Ie) {
                        return K.readFile(Ie);
                      }), Ee = ze.config;
                      if (!!Ee.name) {
                        var He = Ee.types || Ee.typings;
                        if (He) {
                          var rr = e2.getNormalizedAbsolutePath(He, e2.getDirectoryPath(Re));
                          K.fileExists(rr) ? (b && b("    Package '".concat(Ee.name, "' provides its own types.")), ee.set(Ee.name, rr)) : b && b("    Package '".concat(Ee.name, "' provides its own types but they are missing."));
                        } else
                          We.push(Ee.name);
                      }
                    }
                    U(We, "    Found package names");
                  }
                }
                function H(I) {
                  var l = e2.mapDefined(I, function(D) {
                    if (!!e2.hasJSFileExtension(D)) {
                      var fe = e2.removeFileExtension(e2.getBaseFileName(D.toLowerCase())), g = e2.removeMinAndVersionNumbers(fe);
                      return ie.get(g);
                    }
                  });
                  l.length && U(l, "Inferred typings from file names");
                  var d = e2.some(I, function(D) {
                    return e2.fileExtensionIs(D, ".jsx");
                  });
                  d && (b && b("Inferred 'react' typings due to presence of '.jsx' extension"), Y("react"));
                }
              }
              C.discoverTypings = N;
              var p;
              (function(K) {
                K[K.Ok = 0] = "Ok", K[K.EmptyName = 1] = "EmptyName", K[K.NameTooLong = 2] = "NameTooLong", K[K.NameStartsWithDot = 3] = "NameStartsWithDot", K[K.NameStartsWithUnderscore = 4] = "NameStartsWithUnderscore", K[K.NameContainsNonURISafeCharacters = 5] = "NameContainsNonURISafeCharacters";
              })(p = C.NameValidationResult || (C.NameValidationResult = {}));
              var m2 = 214;
              function G(K) {
                return oe(K, true);
              }
              C.validatePackageName = G;
              function oe(K, b) {
                if (!K)
                  return 1;
                if (K.length > m2)
                  return 2;
                if (K.charCodeAt(0) === 46)
                  return 3;
                if (K.charCodeAt(0) === 95)
                  return 4;
                if (b) {
                  var se = /^@([^/]+)\/([^/]+)$/.exec(K);
                  if (se) {
                    var J = oe(se[1], false);
                    if (J !== 0)
                      return { name: se[1], isScopeName: true, result: J };
                    var ie = oe(se[2], false);
                    return ie !== 0 ? { name: se[2], isScopeName: false, result: ie } : 0;
                  }
                }
                return encodeURIComponent(K) !== K ? 5 : 0;
              }
              function f4(K, b) {
                return typeof K == "object" ? T(b, K.result, K.name, K.isScopeName) : T(b, K, b, false);
              }
              C.renderPackageNameValidationFailure = f4;
              function T(K, b, se, J) {
                var ie = J ? "Scope" : "Package";
                switch (b) {
                  case 1:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' cannot be empty");
                  case 2:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' should be less than ").concat(m2, " characters");
                  case 3:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' cannot start with '.'");
                  case 4:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' cannot start with '_'");
                  case 5:
                    return "'".concat(K, "':: ").concat(ie, " name '").concat(se, "' contains non URI safe characters");
                  case 0:
                    return e2.Debug.fail();
                  default:
                    throw e2.Debug.assertNever(b);
                }
              }
            })(a = e2.JsTyping || (e2.JsTyping = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(O) {
              var ve = function() {
                function he(F2) {
                  this.text = F2;
                }
                return he.prototype.getText = function(F2, x2) {
                  return F2 === 0 && x2 === this.text.length ? this.text : this.text.substring(F2, x2);
                }, he.prototype.getLength = function() {
                  return this.text.length;
                }, he.prototype.getChangeRange = function() {
                }, he;
              }();
              function ee(he) {
                return new ve(he);
              }
              O.fromString = ee;
            })(a = e2.ScriptSnapshot || (e2.ScriptSnapshot = {}));
            var C;
            (function(O) {
              O[O.Dependencies = 1] = "Dependencies", O[O.DevDependencies = 2] = "DevDependencies", O[O.PeerDependencies = 4] = "PeerDependencies", O[O.OptionalDependencies = 8] = "OptionalDependencies", O[O.All = 15] = "All";
            })(C = e2.PackageJsonDependencyGroup || (e2.PackageJsonDependencyGroup = {}));
            var w;
            (function(O) {
              O[O.Off = 0] = "Off", O[O.On = 1] = "On", O[O.Auto = 2] = "Auto";
            })(w = e2.PackageJsonAutoImportPreference || (e2.PackageJsonAutoImportPreference = {}));
            var B;
            (function(O) {
              O[O.Semantic = 0] = "Semantic", O[O.PartialSemantic = 1] = "PartialSemantic", O[O.Syntactic = 2] = "Syntactic";
            })(B = e2.LanguageServiceMode || (e2.LanguageServiceMode = {})), e2.emptyOptions = {};
            var E;
            (function(O) {
              O.Original = "original", O.TwentyTwenty = "2020";
            })(E = e2.SemanticClassificationFormat || (e2.SemanticClassificationFormat = {}));
            var Q;
            (function(O) {
              O[O.Invoked = 1] = "Invoked", O[O.TriggerCharacter = 2] = "TriggerCharacter", O[O.TriggerForIncompleteCompletions = 3] = "TriggerForIncompleteCompletions";
            })(Q = e2.CompletionTriggerKind || (e2.CompletionTriggerKind = {}));
            var le;
            (function(O) {
              O.Type = "Type", O.Parameter = "Parameter", O.Enum = "Enum";
            })(le = e2.InlayHintKind || (e2.InlayHintKind = {}));
            var N;
            (function(O) {
              O.none = "none", O.definition = "definition", O.reference = "reference", O.writtenReference = "writtenReference";
            })(N = e2.HighlightSpanKind || (e2.HighlightSpanKind = {}));
            var p;
            (function(O) {
              O[O.None = 0] = "None", O[O.Block = 1] = "Block", O[O.Smart = 2] = "Smart";
            })(p = e2.IndentStyle || (e2.IndentStyle = {}));
            var m2;
            (function(O) {
              O.Ignore = "ignore", O.Insert = "insert", O.Remove = "remove";
            })(m2 = e2.SemicolonPreference || (e2.SemicolonPreference = {}));
            function G(O) {
              return { indentSize: 4, tabSize: 4, newLineCharacter: O || `
`, convertTabsToSpaces: true, indentStyle: p.Smart, insertSpaceAfterConstructor: false, insertSpaceAfterCommaDelimiter: true, insertSpaceAfterSemicolonInForStatements: true, insertSpaceBeforeAndAfterBinaryOperators: true, insertSpaceAfterKeywordsInControlFlowStatements: true, insertSpaceAfterFunctionKeywordForAnonymousFunctions: false, insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis: false, insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets: false, insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces: true, insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces: false, insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces: false, insertSpaceBeforeFunctionParenthesis: false, placeOpenBraceOnNewLineForFunctions: false, placeOpenBraceOnNewLineForControlBlocks: false, semicolons: m2.Ignore, trimTrailingWhitespace: true };
            }
            e2.getDefaultFormatCodeSettings = G, e2.testFormatSettings = G(`
`);
            var oe;
            (function(O) {
              O[O.aliasName = 0] = "aliasName", O[O.className = 1] = "className", O[O.enumName = 2] = "enumName", O[O.fieldName = 3] = "fieldName", O[O.interfaceName = 4] = "interfaceName", O[O.keyword = 5] = "keyword", O[O.lineBreak = 6] = "lineBreak", O[O.numericLiteral = 7] = "numericLiteral", O[O.stringLiteral = 8] = "stringLiteral", O[O.localName = 9] = "localName", O[O.methodName = 10] = "methodName", O[O.moduleName = 11] = "moduleName", O[O.operator = 12] = "operator", O[O.parameterName = 13] = "parameterName", O[O.propertyName = 14] = "propertyName", O[O.punctuation = 15] = "punctuation", O[O.space = 16] = "space", O[O.text = 17] = "text", O[O.typeParameterName = 18] = "typeParameterName", O[O.enumMemberName = 19] = "enumMemberName", O[O.functionName = 20] = "functionName", O[O.regularExpressionLiteral = 21] = "regularExpressionLiteral", O[O.link = 22] = "link", O[O.linkName = 23] = "linkName", O[O.linkText = 24] = "linkText";
            })(oe = e2.SymbolDisplayPartKind || (e2.SymbolDisplayPartKind = {}));
            var f4;
            (function(O) {
              O[O.None = 0] = "None", O[O.MayIncludeAutoImports = 1] = "MayIncludeAutoImports", O[O.IsImportStatementCompletion = 2] = "IsImportStatementCompletion", O[O.IsContinuation = 4] = "IsContinuation", O[O.ResolvedModuleSpecifiers = 8] = "ResolvedModuleSpecifiers", O[O.ResolvedModuleSpecifiersBeyondLimit = 16] = "ResolvedModuleSpecifiersBeyondLimit", O[O.MayIncludeMethodSnippets = 32] = "MayIncludeMethodSnippets";
            })(f4 = e2.CompletionInfoFlags || (e2.CompletionInfoFlags = {}));
            var T;
            (function(O) {
              O.Comment = "comment", O.Region = "region", O.Code = "code", O.Imports = "imports";
            })(T = e2.OutliningSpanKind || (e2.OutliningSpanKind = {}));
            var K;
            (function(O) {
              O[O.JavaScript = 0] = "JavaScript", O[O.SourceMap = 1] = "SourceMap", O[O.Declaration = 2] = "Declaration";
            })(K = e2.OutputFileType || (e2.OutputFileType = {}));
            var b;
            (function(O) {
              O[O.None = 0] = "None", O[O.InMultiLineCommentTrivia = 1] = "InMultiLineCommentTrivia", O[O.InSingleQuoteStringLiteral = 2] = "InSingleQuoteStringLiteral", O[O.InDoubleQuoteStringLiteral = 3] = "InDoubleQuoteStringLiteral", O[O.InTemplateHeadOrNoSubstitutionTemplate = 4] = "InTemplateHeadOrNoSubstitutionTemplate", O[O.InTemplateMiddleOrTail = 5] = "InTemplateMiddleOrTail", O[O.InTemplateSubstitutionPosition = 6] = "InTemplateSubstitutionPosition";
            })(b = e2.EndOfLineState || (e2.EndOfLineState = {}));
            var se;
            (function(O) {
              O[O.Punctuation = 0] = "Punctuation", O[O.Keyword = 1] = "Keyword", O[O.Operator = 2] = "Operator", O[O.Comment = 3] = "Comment", O[O.Whitespace = 4] = "Whitespace", O[O.Identifier = 5] = "Identifier", O[O.NumberLiteral = 6] = "NumberLiteral", O[O.BigIntLiteral = 7] = "BigIntLiteral", O[O.StringLiteral = 8] = "StringLiteral", O[O.RegExpLiteral = 9] = "RegExpLiteral";
            })(se = e2.TokenClass || (e2.TokenClass = {}));
            var J;
            (function(O) {
              O.unknown = "", O.warning = "warning", O.keyword = "keyword", O.scriptElement = "script", O.moduleElement = "module", O.classElement = "class", O.localClassElement = "local class", O.interfaceElement = "interface", O.typeElement = "type", O.enumElement = "enum", O.enumMemberElement = "enum member", O.variableElement = "var", O.localVariableElement = "local var", O.functionElement = "function", O.localFunctionElement = "local function", O.memberFunctionElement = "method", O.memberGetAccessorElement = "getter", O.memberSetAccessorElement = "setter", O.memberVariableElement = "property", O.constructorImplementationElement = "constructor", O.callSignatureElement = "call", O.indexSignatureElement = "index", O.constructSignatureElement = "construct", O.parameterElement = "parameter", O.typeParameterElement = "type parameter", O.primitiveType = "primitive type", O.label = "label", O.alias = "alias", O.constElement = "const", O.letElement = "let", O.directory = "directory", O.externalModuleName = "external module name", O.jsxAttribute = "JSX attribute", O.string = "string", O.link = "link", O.linkName = "link name", O.linkText = "link text";
            })(J = e2.ScriptElementKind || (e2.ScriptElementKind = {}));
            var ie;
            (function(O) {
              O.none = "", O.publicMemberModifier = "public", O.privateMemberModifier = "private", O.protectedMemberModifier = "protected", O.exportedModifier = "export", O.ambientModifier = "declare", O.staticModifier = "static", O.abstractModifier = "abstract", O.optionalModifier = "optional", O.deprecatedModifier = "deprecated", O.dtsModifier = ".d.ts", O.tsModifier = ".ts", O.tsxModifier = ".tsx", O.jsModifier = ".js", O.jsxModifier = ".jsx", O.jsonModifier = ".json", O.dmtsModifier = ".d.mts", O.mtsModifier = ".mts", O.mjsModifier = ".mjs", O.dctsModifier = ".d.cts", O.ctsModifier = ".cts", O.cjsModifier = ".cjs";
            })(ie = e2.ScriptElementKindModifier || (e2.ScriptElementKindModifier = {}));
            var R;
            (function(O) {
              O.comment = "comment", O.identifier = "identifier", O.keyword = "keyword", O.numericLiteral = "number", O.bigintLiteral = "bigint", O.operator = "operator", O.stringLiteral = "string", O.whiteSpace = "whitespace", O.text = "text", O.punctuation = "punctuation", O.className = "class name", O.enumName = "enum name", O.interfaceName = "interface name", O.moduleName = "module name", O.typeParameterName = "type parameter name", O.typeAliasName = "type alias name", O.parameterName = "parameter name", O.docCommentTagName = "doc comment tag name", O.jsxOpenTagName = "jsx open tag name", O.jsxCloseTagName = "jsx close tag name", O.jsxSelfClosingTagName = "jsx self closing tag name", O.jsxAttribute = "jsx attribute", O.jsxText = "jsx text", O.jsxAttributeStringLiteralValue = "jsx attribute string literal value";
            })(R = e2.ClassificationTypeNames || (e2.ClassificationTypeNames = {}));
            var q;
            (function(O) {
              O[O.comment = 1] = "comment", O[O.identifier = 2] = "identifier", O[O.keyword = 3] = "keyword", O[O.numericLiteral = 4] = "numericLiteral", O[O.operator = 5] = "operator", O[O.stringLiteral = 6] = "stringLiteral", O[O.regularExpressionLiteral = 7] = "regularExpressionLiteral", O[O.whiteSpace = 8] = "whiteSpace", O[O.text = 9] = "text", O[O.punctuation = 10] = "punctuation", O[O.className = 11] = "className", O[O.enumName = 12] = "enumName", O[O.interfaceName = 13] = "interfaceName", O[O.moduleName = 14] = "moduleName", O[O.typeParameterName = 15] = "typeParameterName", O[O.typeAliasName = 16] = "typeAliasName", O[O.parameterName = 17] = "parameterName", O[O.docCommentTagName = 18] = "docCommentTagName", O[O.jsxOpenTagName = 19] = "jsxOpenTagName", O[O.jsxCloseTagName = 20] = "jsxCloseTagName", O[O.jsxSelfClosingTagName = 21] = "jsxSelfClosingTagName", O[O.jsxAttribute = 22] = "jsxAttribute", O[O.jsxText = 23] = "jsxText", O[O.jsxAttributeStringLiteralValue = 24] = "jsxAttributeStringLiteralValue", O[O.bigintLiteral = 25] = "bigintLiteral";
            })(q = e2.ClassificationType || (e2.ClassificationType = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            e2.scanner = e2.createScanner(99, true);
            var a;
            (function(Se) {
              Se[Se.None = 0] = "None", Se[Se.Value = 1] = "Value", Se[Se.Type = 2] = "Type", Se[Se.Namespace = 4] = "Namespace", Se[Se.All = 7] = "All";
            })(a = e2.SemanticMeaning || (e2.SemanticMeaning = {}));
            function C(Se) {
              switch (Se.kind) {
                case 254:
                  return e2.isInJSFile(Se) && e2.getJSDocEnumTag(Se) ? 7 : 1;
                case 164:
                case 203:
                case 167:
                case 166:
                case 296:
                case 297:
                case 169:
                case 168:
                case 171:
                case 172:
                case 173:
                case 256:
                case 213:
                case 214:
                case 292:
                case 285:
                  return 1;
                case 163:
                case 258:
                case 259:
                case 182:
                  return 2;
                case 345:
                  return Se.name === void 0 ? 3 : 2;
                case 299:
                case 257:
                  return 3;
                case 261:
                  return e2.isAmbientModule(Se) || e2.getModuleInstanceState(Se) === 1 ? 5 : 4;
                case 260:
                case 269:
                case 270:
                case 265:
                case 266:
                case 271:
                case 272:
                  return 7;
                case 305:
                  return 5;
              }
              return 7;
            }
            e2.getMeaningFromDeclaration = C;
            function w(Se) {
              Se = Br(Se);
              var hr = Se.parent;
              return Se.kind === 305 ? 1 : e2.isExportAssignment(hr) || e2.isExportSpecifier(hr) || e2.isExternalModuleReference(hr) || e2.isImportSpecifier(hr) || e2.isImportClause(hr) || e2.isImportEqualsDeclaration(hr) && Se === hr.name ? 7 : E(Se) ? B(Se) : e2.isDeclarationName(Se) ? C(hr) : e2.isEntityName(Se) && e2.findAncestor(Se, e2.or(e2.isJSDocNameReference, e2.isJSDocLinkLike, e2.isJSDocMemberName)) ? 7 : p(Se) ? 2 : Q(Se) ? 4 : e2.isTypeParameterDeclaration(hr) ? (e2.Debug.assert(e2.isJSDocTemplateTag(hr.parent)), 2) : e2.isLiteralTypeNode(hr) ? 3 : 1;
            }
            e2.getMeaningFromLocation = w;
            function B(Se) {
              var hr = Se.kind === 161 ? Se : e2.isQualifiedName(Se.parent) && Se.parent.right === Se ? Se.parent : void 0;
              return hr && hr.parent.kind === 265 ? 7 : 4;
            }
            function E(Se) {
              for (; Se.parent.kind === 161; )
                Se = Se.parent;
              return e2.isInternalModuleImportEqualsDeclaration(Se.parent) && Se.parent.moduleReference === Se;
            }
            e2.isInRightSideOfInternalImportEqualsDeclaration = E;
            function Q(Se) {
              return le(Se) || N(Se);
            }
            function le(Se) {
              var hr = Se, Or = true;
              if (hr.parent.kind === 161) {
                for (; hr.parent && hr.parent.kind === 161; )
                  hr = hr.parent;
                Or = hr.right === Se;
              }
              return hr.parent.kind === 178 && !Or;
            }
            function N(Se) {
              var hr = Se, Or = true;
              if (hr.parent.kind === 206) {
                for (; hr.parent && hr.parent.kind === 206; )
                  hr = hr.parent;
                Or = hr.name === Se;
              }
              if (!Or && hr.parent.kind === 228 && hr.parent.parent.kind === 291) {
                var ki = hr.parent.parent.parent;
                return ki.kind === 257 && hr.parent.parent.token === 117 || ki.kind === 258 && hr.parent.parent.token === 94;
              }
              return false;
            }
            function p(Se) {
              switch (e2.isRightSideOfQualifiedNameOrPropertyAccess(Se) && (Se = Se.parent), Se.kind) {
                case 108:
                  return !e2.isExpressionNode(Se);
                case 192:
                  return true;
              }
              switch (Se.parent.kind) {
                case 178:
                  return true;
                case 200:
                  return !Se.parent.isTypeOf;
                case 228:
                  return e2.isPartOfTypeNode(Se.parent);
              }
              return false;
            }
            function m2(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e2.isCallExpression, b, hr, Or);
            }
            e2.isCallExpressionTarget = m2;
            function G(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e2.isNewExpression, b, hr, Or);
            }
            e2.isNewExpressionTarget = G;
            function oe(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e2.isCallOrNewExpression, b, hr, Or);
            }
            e2.isCallOrNewExpressionTarget = oe;
            function f4(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e2.isTaggedTemplateExpression, se, hr, Or);
            }
            e2.isTaggedTemplateTag = f4;
            function T(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e2.isDecorator, b, hr, Or);
            }
            e2.isDecoratorTarget = T;
            function K(Se, hr, Or) {
              return hr === void 0 && (hr = false), Or === void 0 && (Or = false), ie(Se, e2.isJsxOpeningLikeElement, J, hr, Or);
            }
            e2.isJsxOpeningLikeElementTagName = K;
            function b(Se) {
              return Se.expression;
            }
            function se(Se) {
              return Se.tag;
            }
            function J(Se) {
              return Se.tagName;
            }
            function ie(Se, hr, Or, ki, dt) {
              var la = ki ? q(Se) : R(Se);
              return dt && (la = e2.skipOuterExpressions(la)), !!la && !!la.parent && hr(la.parent) && Or(la.parent) === la;
            }
            function R(Se) {
              return $(Se) ? Se.parent : Se;
            }
            e2.climbPastPropertyAccess = R;
            function q(Se) {
              return $(Se) || A2(Se) ? Se.parent : Se;
            }
            e2.climbPastPropertyOrElementAccess = q;
            function O(Se, hr) {
              for (; Se; ) {
                if (Se.kind === 250 && Se.label.escapedText === hr)
                  return Se.label;
                Se = Se.parent;
              }
            }
            e2.getTargetLabel = O;
            function ve(Se, hr) {
              return e2.isPropertyAccessExpression(Se.expression) ? Se.expression.name.text === hr : false;
            }
            e2.hasPropertyAccessExpressionWithName = ve;
            function ee(Se) {
              var hr;
              return e2.isIdentifier(Se) && ((hr = e2.tryCast(Se.parent, e2.isBreakOrContinueStatement)) === null || hr === void 0 ? void 0 : hr.label) === Se;
            }
            e2.isJumpStatementTarget = ee;
            function he(Se) {
              var hr;
              return e2.isIdentifier(Se) && ((hr = e2.tryCast(Se.parent, e2.isLabeledStatement)) === null || hr === void 0 ? void 0 : hr.label) === Se;
            }
            e2.isLabelOfLabeledStatement = he;
            function F2(Se) {
              return he(Se) || ee(Se);
            }
            e2.isLabelName = F2;
            function x2(Se) {
              var hr;
              return ((hr = e2.tryCast(Se.parent, e2.isJSDocTag)) === null || hr === void 0 ? void 0 : hr.tagName) === Se;
            }
            e2.isTagName = x2;
            function X(Se) {
              var hr;
              return ((hr = e2.tryCast(Se.parent, e2.isQualifiedName)) === null || hr === void 0 ? void 0 : hr.right) === Se;
            }
            e2.isRightSideOfQualifiedName = X;
            function $(Se) {
              var hr;
              return ((hr = e2.tryCast(Se.parent, e2.isPropertyAccessExpression)) === null || hr === void 0 ? void 0 : hr.name) === Se;
            }
            e2.isRightSideOfPropertyAccess = $;
            function A2(Se) {
              var hr;
              return ((hr = e2.tryCast(Se.parent, e2.isElementAccessExpression)) === null || hr === void 0 ? void 0 : hr.argumentExpression) === Se;
            }
            e2.isArgumentExpressionOfElementAccess = A2;
            function y(Se) {
              var hr;
              return ((hr = e2.tryCast(Se.parent, e2.isModuleDeclaration)) === null || hr === void 0 ? void 0 : hr.name) === Se;
            }
            e2.isNameOfModuleDeclaration = y;
            function V(Se) {
              var hr;
              return e2.isIdentifier(Se) && ((hr = e2.tryCast(Se.parent, e2.isFunctionLike)) === null || hr === void 0 ? void 0 : hr.name) === Se;
            }
            e2.isNameOfFunctionDeclaration = V;
            function L(Se) {
              switch (Se.parent.kind) {
                case 167:
                case 166:
                case 296:
                case 299:
                case 169:
                case 168:
                case 172:
                case 173:
                case 261:
                  return e2.getNameOfDeclaration(Se.parent) === Se;
                case 207:
                  return Se.parent.argumentExpression === Se;
                case 162:
                  return true;
                case 196:
                  return Se.parent.parent.kind === 194;
                default:
                  return false;
              }
            }
            e2.isLiteralNameOfPropertyDeclarationOrIndexAccess = L;
            function P(Se) {
              return e2.isExternalModuleImportEqualsDeclaration(Se.parent.parent) && e2.getExternalModuleImportEqualsDeclarationExpression(Se.parent.parent) === Se;
            }
            e2.isExpressionOfExternalModuleImportEqualsDeclaration = P;
            function k(Se) {
              for (e2.isJSDocTypeAlias(Se) && (Se = Se.parent.parent); ; ) {
                if (Se = Se.parent, !Se)
                  return;
                switch (Se.kind) {
                  case 305:
                  case 169:
                  case 168:
                  case 256:
                  case 213:
                  case 172:
                  case 173:
                  case 257:
                  case 258:
                  case 260:
                  case 261:
                    return Se;
                }
              }
            }
            e2.getContainerNode = k;
            function Y(Se) {
              switch (Se.kind) {
                case 305:
                  return e2.isExternalModule(Se) ? "module" : "script";
                case 261:
                  return "module";
                case 257:
                case 226:
                  return "class";
                case 258:
                  return "interface";
                case 259:
                case 338:
                case 345:
                  return "type";
                case 260:
                  return "enum";
                case 254:
                  return wa(Se);
                case 203:
                  return wa(e2.getRootDeclaration(Se));
                case 214:
                case 256:
                case 213:
                  return "function";
                case 172:
                  return "getter";
                case 173:
                  return "setter";
                case 169:
                case 168:
                  return "method";
                case 296:
                  var hr = Se.initializer;
                  return e2.isFunctionLike(hr) ? "method" : "property";
                case 167:
                case 166:
                case 297:
                case 298:
                  return "property";
                case 176:
                  return "index";
                case 175:
                  return "construct";
                case 174:
                  return "call";
                case 171:
                case 170:
                  return "constructor";
                case 163:
                  return "type parameter";
                case 299:
                  return "enum member";
                case 164:
                  return e2.hasSyntacticModifier(Se, 16476) ? "property" : "parameter";
                case 265:
                case 270:
                case 275:
                case 268:
                case 274:
                  return "alias";
                case 221:
                  var Or = e2.getAssignmentDeclarationKind(Se), ki = Se.right;
                  switch (Or) {
                    case 7:
                    case 8:
                    case 9:
                    case 0:
                      return "";
                    case 1:
                    case 2:
                      var dt = Y(ki);
                      return dt === "" ? "const" : dt;
                    case 3:
                      return e2.isFunctionExpression(ki) ? "method" : "property";
                    case 4:
                      return "property";
                    case 5:
                      return e2.isFunctionExpression(ki) ? "method" : "property";
                    case 6:
                      return "local class";
                    default:
                      return e2.assertType(Or), "";
                  }
                case 79:
                  return e2.isImportClause(Se.parent) ? "alias" : "";
                case 271:
                  var la = Y(Se.expression);
                  return la === "" ? "const" : la;
                default:
                  return "";
              }
              function wa(On) {
                return e2.isVarConst(On) ? "const" : e2.isLet(On) ? "let" : "var";
              }
            }
            e2.getNodeKind = Y;
            function U(Se) {
              switch (Se.kind) {
                case 108:
                  return true;
                case 79:
                  return e2.identifierIsThisKeyword(Se) && Se.parent.kind === 164;
                default:
                  return false;
              }
            }
            e2.isThis = U;
            var j = /^\/\/\/\s*</;
            function H(Se, hr) {
              var Or = e2.getLineStarts(hr), ki = hr.getLineAndCharacterOfPosition(Se).line;
              return Or[ki];
            }
            e2.getLineStartPositionForPosition = H;
            function I(Se, hr) {
              return fe(Se.pos, Se.end, hr);
            }
            e2.rangeContainsRange = I;
            function l(Se, hr) {
              return D(Se, hr.pos) && D(Se, hr.end);
            }
            e2.rangeContainsRangeExclusive = l;
            function d(Se, hr) {
              return Se.pos <= hr && hr <= Se.end;
            }
            e2.rangeContainsPosition = d;
            function D(Se, hr) {
              return Se.pos < hr && hr < Se.end;
            }
            e2.rangeContainsPositionExclusive = D;
            function fe(Se, hr, Or) {
              return Se <= Or.pos && hr >= Or.end;
            }
            e2.startEndContainsRange = fe;
            function g(Se, hr, Or) {
              return Se.pos <= hr && Se.end >= Or;
            }
            e2.rangeContainsStartEnd = g;
            function ne(Se, hr, Or) {
              return We(Se.pos, Se.end, hr, Or);
            }
            e2.rangeOverlapsWithStartEnd = ne;
            function ue(Se, hr, Or, ki) {
              return We(Se.getStart(hr), Se.end, Or, ki);
            }
            e2.nodeOverlapsWithStartEnd = ue;
            function We(Se, hr, Or, ki) {
              var dt = Math.max(Se, Or), la = Math.min(hr, ki);
              return dt < la;
            }
            e2.startEndOverlapsWithStartEnd = We;
            function Fe(Se, hr, Or) {
              return e2.Debug.assert(Se.pos <= hr), hr < Se.end || !Z2(Se, Or);
            }
            e2.positionBelongsToNode = Fe;
            function Z2(Se, hr) {
              if (Se === void 0 || e2.nodeIsMissing(Se))
                return false;
              switch (Se.kind) {
                case 257:
                case 258:
                case 260:
                case 205:
                case 201:
                case 182:
                case 235:
                case 262:
                case 263:
                case 269:
                case 273:
                  return Be(Se, 19, hr);
                case 292:
                  return Z2(Se.block, hr);
                case 209:
                  if (!Se.arguments)
                    return true;
                case 208:
                case 212:
                case 191:
                  return Be(Se, 21, hr);
                case 179:
                case 180:
                  return Z2(Se.type, hr);
                case 171:
                case 172:
                case 173:
                case 256:
                case 213:
                case 169:
                case 168:
                case 175:
                case 174:
                case 214:
                  return Se.body ? Z2(Se.body, hr) : Se.type ? Z2(Se.type, hr) : Re(Se, 21, hr);
                case 261:
                  return !!Se.body && Z2(Se.body, hr);
                case 239:
                  return Se.elseStatement ? Z2(Se.elseStatement, hr) : Z2(Se.thenStatement, hr);
                case 238:
                  return Z2(Se.expression, hr) || Re(Se, 26, hr);
                case 204:
                case 202:
                case 207:
                case 162:
                case 184:
                  return Be(Se, 23, hr);
                case 176:
                  return Se.type ? Z2(Se.type, hr) : Re(Se, 23, hr);
                case 289:
                case 290:
                  return false;
                case 242:
                case 243:
                case 244:
                case 241:
                  return Z2(Se.statement, hr);
                case 240:
                  return Re(Se, 115, hr) ? Be(Se, 21, hr) : Z2(Se.statement, hr);
                case 181:
                  return Z2(Se.exprName, hr);
                case 216:
                case 215:
                case 217:
                case 224:
                case 225:
                  var Or = Se;
                  return Z2(Or.expression, hr);
                case 210:
                  return Z2(Se.template, hr);
                case 223:
                  var ki = e2.lastOrUndefined(Se.templateSpans);
                  return Z2(ki, hr);
                case 233:
                  return e2.nodeIsPresent(Se.literal);
                case 272:
                case 266:
                  return e2.nodeIsPresent(Se.moduleSpecifier);
                case 219:
                  return Z2(Se.operand, hr);
                case 221:
                  return Z2(Se.right, hr);
                case 222:
                  return Z2(Se.whenFalse, hr);
                default:
                  return true;
              }
            }
            function Be(Se, hr, Or) {
              var ki = Se.getChildren(Or);
              if (ki.length) {
                var dt = e2.last(ki);
                if (dt.kind === hr)
                  return true;
                if (dt.kind === 26 && ki.length !== 1)
                  return ki[ki.length - 2].kind === hr;
              }
              return false;
            }
            function ge(Se) {
              var hr = Ee(Se);
              if (!!hr) {
                var Or = hr.getChildren(), ki = e2.indexOfNode(Or, Se);
                return { listItemIndex: ki, list: hr };
              }
            }
            e2.findListItemInfo = ge;
            function Re(Se, hr, Or) {
              return !!ze(Se, hr, Or);
            }
            e2.hasChildOfKind = Re;
            function ze(Se, hr, Or) {
              return e2.find(Se.getChildren(Or), function(ki) {
                return ki.kind === hr;
              });
            }
            e2.findChildOfKind = ze;
            function Ee(Se) {
              var hr = e2.find(Se.parent.getChildren(), function(Or) {
                return e2.isSyntaxList(Or) && I(Or, Se);
              });
              return e2.Debug.assert(!hr || e2.contains(hr.getChildren(), Se)), hr;
            }
            e2.findContainingList = Ee;
            function He(Se) {
              return Se.kind === 88;
            }
            function rr(Se) {
              return Se.kind === 84;
            }
            function Ie(Se) {
              return Se.kind === 98;
            }
            function _e(Se) {
              if (e2.isNamedDeclaration(Se))
                return Se.name;
              if (e2.isClassDeclaration(Se)) {
                var hr = Se.modifiers && e2.find(Se.modifiers, He);
                if (hr)
                  return hr;
              }
              if (e2.isClassExpression(Se)) {
                var Or = e2.find(Se.getChildren(), rr);
                if (Or)
                  return Or;
              }
            }
            function we(Se) {
              if (e2.isNamedDeclaration(Se))
                return Se.name;
              if (e2.isFunctionDeclaration(Se)) {
                var hr = e2.find(Se.modifiers, He);
                if (hr)
                  return hr;
              }
              if (e2.isFunctionExpression(Se)) {
                var Or = e2.find(Se.getChildren(), Ie);
                if (Or)
                  return Or;
              }
            }
            function de(Se) {
              var hr;
              return e2.findAncestor(Se, function(Or) {
                return e2.isTypeNode(Or) && (hr = Or), !e2.isQualifiedName(Or.parent) && !e2.isTypeNode(Or.parent) && !e2.isTypeElement(Or.parent);
              }), hr;
            }
            function ye(Se, hr) {
              var Or = yi(Se, hr);
              if (Or)
                return Or;
              var ki = de(Se);
              return ki && hr.getTypeAtLocation(ki);
            }
            e2.getContextualTypeFromParentOrAncestorTypeNode = ye;
            function Ae(Se, hr) {
              if (!hr)
                switch (Se.kind) {
                  case 257:
                  case 226:
                    return _e(Se);
                  case 256:
                  case 213:
                    return we(Se);
                }
              if (e2.isNamedDeclaration(Se))
                return Se.name;
            }
            function er(Se, hr) {
              if (Se.importClause) {
                if (Se.importClause.name && Se.importClause.namedBindings)
                  return;
                if (Se.importClause.name)
                  return Se.importClause.name;
                if (Se.importClause.namedBindings) {
                  if (e2.isNamedImports(Se.importClause.namedBindings)) {
                    var Or = e2.singleOrUndefined(Se.importClause.namedBindings.elements);
                    return Or ? Or.name : void 0;
                  } else if (e2.isNamespaceImport(Se.importClause.namedBindings))
                    return Se.importClause.namedBindings.name;
                }
              }
              if (!hr)
                return Se.moduleSpecifier;
            }
            function ir(Se, hr) {
              if (Se.exportClause) {
                if (e2.isNamedExports(Se.exportClause)) {
                  var Or = e2.singleOrUndefined(Se.exportClause.elements);
                  return Or ? Se.exportClause.elements[0].name : void 0;
                } else if (e2.isNamespaceExport(Se.exportClause))
                  return Se.exportClause.name;
              }
              if (!hr)
                return Se.moduleSpecifier;
            }
            function Cr(Se) {
              if (Se.types.length === 1)
                return Se.types[0].expression;
            }
            function Ye(Se, hr) {
              var Or = Se.parent;
              if (e2.isModifier(Se) && (hr || Se.kind !== 88) ? e2.contains(Or.modifiers, Se) : Se.kind === 84 ? e2.isClassDeclaration(Or) || e2.isClassExpression(Se) : Se.kind === 98 ? e2.isFunctionDeclaration(Or) || e2.isFunctionExpression(Se) : Se.kind === 118 ? e2.isInterfaceDeclaration(Or) : Se.kind === 92 ? e2.isEnumDeclaration(Or) : Se.kind === 152 ? e2.isTypeAliasDeclaration(Or) : Se.kind === 142 || Se.kind === 141 ? e2.isModuleDeclaration(Or) : Se.kind === 100 ? e2.isImportEqualsDeclaration(Or) : Se.kind === 136 ? e2.isGetAccessorDeclaration(Or) : Se.kind === 149 && e2.isSetAccessorDeclaration(Or)) {
                var ki = Ae(Or, hr);
                if (ki)
                  return ki;
              }
              if ((Se.kind === 113 || Se.kind === 85 || Se.kind === 119) && e2.isVariableDeclarationList(Or) && Or.declarations.length === 1) {
                var dt = Or.declarations[0];
                if (e2.isIdentifier(dt.name))
                  return dt.name;
              }
              if (Se.kind === 152) {
                if (e2.isImportClause(Or) && Or.isTypeOnly) {
                  var ki = er(Or.parent, hr);
                  if (ki)
                    return ki;
                }
                if (e2.isExportDeclaration(Or) && Or.isTypeOnly) {
                  var ki = ir(Or, hr);
                  if (ki)
                    return ki;
                }
              }
              if (Se.kind === 127) {
                if (e2.isImportSpecifier(Or) && Or.propertyName || e2.isExportSpecifier(Or) && Or.propertyName || e2.isNamespaceImport(Or) || e2.isNamespaceExport(Or))
                  return Or.name;
                if (e2.isExportDeclaration(Or) && Or.exportClause && e2.isNamespaceExport(Or.exportClause))
                  return Or.exportClause.name;
              }
              if (Se.kind === 100 && e2.isImportDeclaration(Or)) {
                var ki = er(Or, hr);
                if (ki)
                  return ki;
              }
              if (Se.kind === 93) {
                if (e2.isExportDeclaration(Or)) {
                  var ki = ir(Or, hr);
                  if (ki)
                    return ki;
                }
                if (e2.isExportAssignment(Or))
                  return e2.skipOuterExpressions(Or.expression);
              }
              if (Se.kind === 146 && e2.isExternalModuleReference(Or))
                return Or.expression;
              if (Se.kind === 156 && (e2.isImportDeclaration(Or) || e2.isExportDeclaration(Or)) && Or.moduleSpecifier)
                return Or.moduleSpecifier;
              if ((Se.kind === 94 || Se.kind === 117) && e2.isHeritageClause(Or) && Or.token === Se.kind) {
                var ki = Cr(Or);
                if (ki)
                  return ki;
              }
              if (Se.kind === 94) {
                if (e2.isTypeParameterDeclaration(Or) && Or.constraint && e2.isTypeReferenceNode(Or.constraint))
                  return Or.constraint.typeName;
                if (e2.isConditionalTypeNode(Or) && e2.isTypeReferenceNode(Or.extendsType))
                  return Or.extendsType.typeName;
              }
              if (Se.kind === 137 && e2.isInferTypeNode(Or))
                return Or.typeParameter.name;
              if (Se.kind === 101 && e2.isTypeParameterDeclaration(Or) && e2.isMappedTypeNode(Or.parent))
                return Or.name;
              if (Se.kind === 140 && e2.isTypeOperatorNode(Or) && Or.operator === 140 && e2.isTypeReferenceNode(Or.type))
                return Or.type.typeName;
              if (Se.kind === 145 && e2.isTypeOperatorNode(Or) && Or.operator === 145 && e2.isArrayTypeNode(Or.type) && e2.isTypeReferenceNode(Or.type.elementType))
                return Or.type.elementType.typeName;
              if (!hr) {
                if ((Se.kind === 103 && e2.isNewExpression(Or) || Se.kind === 114 && e2.isVoidExpression(Or) || Se.kind === 112 && e2.isTypeOfExpression(Or) || Se.kind === 132 && e2.isAwaitExpression(Or) || Se.kind === 125 && e2.isYieldExpression(Or) || Se.kind === 89 && e2.isDeleteExpression(Or)) && Or.expression)
                  return e2.skipOuterExpressions(Or.expression);
                if ((Se.kind === 101 || Se.kind === 102) && e2.isBinaryExpression(Or) && Or.operatorToken === Se)
                  return e2.skipOuterExpressions(Or.right);
                if (Se.kind === 127 && e2.isAsExpression(Or) && e2.isTypeReferenceNode(Or.type))
                  return Or.type.typeName;
                if (Se.kind === 101 && e2.isForInStatement(Or) || Se.kind === 160 && e2.isForOfStatement(Or))
                  return e2.skipOuterExpressions(Or.expression);
              }
              return Se;
            }
            function Br(Se) {
              return Ye(Se, false);
            }
            e2.getAdjustedReferenceLocation = Br;
            function Er(Se) {
              return Ye(Se, true);
            }
            e2.getAdjustedRenameLocation = Er;
            function Ne(Se, hr) {
              return n(Se, hr, function(Or) {
                return e2.isPropertyNameLiteral(Or) || e2.isKeyword(Or.kind) || e2.isPrivateIdentifier(Or);
              });
            }
            e2.getTouchingPropertyName = Ne;
            function n(Se, hr, Or) {
              return be(Se, hr, false, Or, false);
            }
            e2.getTouchingToken = n;
            function lr(Se, hr) {
              return be(Se, hr, true, void 0, false);
            }
            e2.getTokenAtPosition = lr;
            function be(Se, hr, Or, ki, dt) {
              var la = Se, wa, On = function() {
                var po = la.getChildren(Se), Gn = e2.binarySearchKey(po, hr, function($n, Ho) {
                  return Ho;
                }, function($n, Ho) {
                  var Zo = Or ? po[$n].getFullStart() : po[$n].getStart(Se, true);
                  return Zo > hr ? 1 : jo(po[$n]) ? po[$n - 1] && jo(po[$n - 1]) ? 1 : 0 : ki && Zo === hr && po[$n - 1] && po[$n - 1].getEnd() === hr && jo(po[$n - 1]) ? 1 : -1;
                });
                return wa ? { value: wa } : Gn >= 0 && po[Gn] ? (la = po[Gn], "continue-outer") : { value: la };
              };
              e:
                for (; ; ) {
                  var No = On();
                  if (typeof No == "object")
                    return No.value;
                  switch (No) {
                    case "continue-outer":
                      continue e;
                  }
                }
              function jo(po) {
                var Gn = Or ? po.getFullStart() : po.getStart(Se, true);
                if (Gn > hr)
                  return false;
                var $n = po.getEnd();
                if (hr < $n || hr === $n && (po.kind === 1 || dt))
                  return true;
                if (ki && $n === hr) {
                  var Ho = Ir(hr, Se, po);
                  if (Ho && ki(Ho))
                    return wa = Ho, true;
                }
                return false;
              }
            }
            function Ge(Se, hr) {
              for (var Or = lr(Se, hr); or(Or); ) {
                var ki = yr(Or, Or.parent, Se);
                if (!ki)
                  return;
                Or = ki;
              }
              return Or;
            }
            e2.findFirstNonJsxWhitespaceToken = Ge;
            function ur(Se, hr) {
              var Or = lr(Se, hr);
              return e2.isToken(Or) && hr > Or.getStart(Se) && hr < Or.getEnd() ? Or : Ir(hr, Se);
            }
            e2.findTokenOnLeftOfPosition = ur;
            function yr(Se, hr, Or) {
              return ki(hr);
              function ki(dt) {
                return e2.isToken(dt) && dt.pos === Se.end ? dt : e2.firstDefined(dt.getChildren(Or), function(la) {
                  var wa = la.pos <= Se.pos && la.end > Se.end || la.pos === Se.end;
                  return wa && pi(la, Or) ? ki(la) : void 0;
                });
              }
            }
            e2.findNextToken = yr;
            function Ir(Se, hr, Or, ki) {
              var dt = la(Or || hr);
              return e2.Debug.assert(!(dt && or(dt))), dt;
              function la(wa) {
                if (wr(wa) && wa.kind !== 1)
                  return wa;
                var On = wa.getChildren(hr), No = e2.binarySearchKey(On, Se, function(Zo, Es) {
                  return Es;
                }, function(Zo, Es) {
                  return Se < On[Zo].end ? !On[Zo - 1] || Se >= On[Zo - 1].end ? 0 : 1 : -1;
                });
                if (No >= 0 && On[No]) {
                  var jo = On[No];
                  if (Se < jo.end) {
                    var po = jo.getStart(hr, !ki), Gn = po >= Se || !pi(jo, hr) || or(jo);
                    if (Gn) {
                      var $n = ii(On, No, hr, wa.kind);
                      return $n && Ur($n, hr);
                    } else
                      return la(jo);
                  }
                }
                e2.Debug.assert(Or !== void 0 || wa.kind === 305 || wa.kind === 1 || e2.isJSDocCommentContainingNode(wa));
                var Ho = ii(On, On.length, hr, wa.kind);
                return Ho && Ur(Ho, hr);
              }
            }
            e2.findPrecedingToken = Ir;
            function wr(Se) {
              return e2.isToken(Se) && !or(Se);
            }
            function Ur(Se, hr) {
              if (wr(Se))
                return Se;
              var Or = Se.getChildren(hr);
              if (Or.length === 0)
                return Se;
              var ki = ii(Or, Or.length, hr, Se.kind);
              return ki && Ur(ki, hr);
            }
            function ii(Se, hr, Or, ki) {
              for (var dt = hr - 1; dt >= 0; dt--) {
                var la = Se[dt];
                if (or(la))
                  dt === 0 && (ki === 11 || ki === 279) && e2.Debug.fail("`JsxText` tokens should not be the first child of `JsxElement | JsxSelfClosingElement`");
                else if (pi(Se[dt], Or))
                  return Se[dt];
              }
            }
            function mi(Se, hr, Or) {
              if (Or === void 0 && (Or = Ir(hr, Se)), Or && e2.isStringTextContainingNode(Or)) {
                var ki = Or.getStart(Se), dt = Or.getEnd();
                if (ki < hr && hr < dt)
                  return true;
                if (hr === dt)
                  return !!Or.isUnterminated;
              }
              return false;
            }
            e2.isInString = mi;
            function pe(Se, hr) {
              var Or = lr(Se, hr);
              return Or ? !!(Or.kind === 11 || Or.kind === 29 && Or.parent.kind === 11 || Or.kind === 29 && Or.parent.kind === 288 || Or && Or.kind === 19 && Or.parent.kind === 288 || Or.kind === 29 && Or.parent.kind === 281) : false;
            }
            e2.isInsideJsxElementOrAttribute = pe;
            function or(Se) {
              return e2.isJsxText(Se) && Se.containsOnlyTriviaWhiteSpaces;
            }
            function qr(Se, hr) {
              var Or = lr(Se, hr);
              return e2.isTemplateLiteralKind(Or.kind) && hr > Or.getStart(Se);
            }
            e2.isInTemplateString = qr;
            function si(Se, hr) {
              var Or = lr(Se, hr);
              return !!(e2.isJsxText(Or) || Or.kind === 18 && e2.isJsxExpression(Or.parent) && e2.isJsxElement(Or.parent.parent) || Or.kind === 29 && e2.isJsxOpeningLikeElement(Or.parent) && e2.isJsxElement(Or.parent.parent));
            }
            e2.isInJSXText = si;
            function Di(Se, hr) {
              function Or(ki) {
                for (; ki; )
                  if (ki.kind >= 279 && ki.kind <= 288 || ki.kind === 11 || ki.kind === 29 || ki.kind === 31 || ki.kind === 79 || ki.kind === 19 || ki.kind === 18 || ki.kind === 43)
                    ki = ki.parent;
                  else if (ki.kind === 278) {
                    if (hr > ki.getStart(Se))
                      return true;
                    ki = ki.parent;
                  } else
                    return false;
                return false;
              }
              return Or(lr(Se, hr));
            }
            e2.isInsideJsxElement = Di;
            function wi(Se, hr, Or) {
              var ki = e2.tokenToString(Se.kind), dt = e2.tokenToString(hr), la = Se.getFullStart(), wa = Or.text.lastIndexOf(dt, la);
              if (wa !== -1) {
                if (Or.text.lastIndexOf(ki, la - 1) < wa) {
                  var On = Ir(wa + 1, Or);
                  if (On && On.kind === hr)
                    return On;
                }
                for (var No = Se.kind, jo = 0; ; ) {
                  var po = Ir(Se.getFullStart(), Or);
                  if (!po)
                    return;
                  if (Se = po, Se.kind === hr) {
                    if (jo === 0)
                      return Se;
                    jo--;
                  } else
                    Se.kind === No && jo++;
                }
              }
            }
            e2.findPrecedingMatchingToken = wi;
            function Xi(Se, hr, Or) {
              return hr ? Se.getNonNullableType() : Or ? Se.getNonOptionalType() : Se;
            }
            e2.removeOptionality = Xi;
            function et(Se, hr, Or) {
              var ki = Wt(Se, hr);
              return ki !== void 0 && (e2.isPartOfTypeNode(ki.called) || Gi(ki.called, ki.nTypeArguments, Or).length !== 0 || et(ki.called, hr, Or));
            }
            e2.isPossiblyTypeArgumentPosition = et;
            function Gi(Se, hr, Or) {
              var ki = Or.getTypeAtLocation(Se);
              e2.isOptionalChain(Se.parent) && (ki = Xi(ki, e2.isOptionalChainRoot(Se.parent), true));
              var dt = e2.isNewExpression(Se.parent) ? ki.getConstructSignatures() : ki.getCallSignatures();
              return dt.filter(function(la) {
                return !!la.typeParameters && la.typeParameters.length >= hr;
              });
            }
            e2.getPossibleGenericSignatures = Gi;
            function Wt(Se, hr) {
              if (hr.text.lastIndexOf("<", Se ? Se.pos : hr.text.length) !== -1)
                for (var Or = Se, ki = 0, dt = 0; Or; ) {
                  switch (Or.kind) {
                    case 29:
                      if (Or = Ir(Or.getFullStart(), hr), Or && Or.kind === 28 && (Or = Ir(Or.getFullStart(), hr)), !Or || !e2.isIdentifier(Or))
                        return;
                      if (!ki)
                        return e2.isDeclarationName(Or) ? void 0 : { called: Or, nTypeArguments: dt };
                      ki--;
                      break;
                    case 49:
                      ki = 3;
                      break;
                    case 48:
                      ki = 2;
                      break;
                    case 31:
                      ki++;
                      break;
                    case 19:
                      if (Or = wi(Or, 18, hr), !Or)
                        return;
                      break;
                    case 21:
                      if (Or = wi(Or, 20, hr), !Or)
                        return;
                      break;
                    case 23:
                      if (Or = wi(Or, 22, hr), !Or)
                        return;
                      break;
                    case 27:
                      dt++;
                      break;
                    case 38:
                    case 79:
                    case 10:
                    case 8:
                    case 9:
                    case 110:
                    case 95:
                    case 112:
                    case 94:
                    case 140:
                    case 24:
                    case 51:
                    case 57:
                    case 58:
                      break;
                    default:
                      if (e2.isTypeNode(Or))
                        break;
                      return;
                  }
                  Or = Ir(Or.getFullStart(), hr);
                }
            }
            e2.getPossibleTypeArgumentsInfo = Wt;
            function Zt(Se, hr, Or) {
              return e2.formatting.getRangeOfEnclosingComment(Se, hr, void 0, Or);
            }
            e2.isInComment = Zt;
            function _r(Se, hr) {
              var Or = lr(Se, hr);
              return !!e2.findAncestor(Or, e2.isJSDoc);
            }
            e2.hasDocComment = _r;
            function pi(Se, hr) {
              return Se.kind === 1 ? !!Se.jsDoc : Se.getWidth(hr) !== 0;
            }
            function ae(Se, hr) {
              hr === void 0 && (hr = 0);
              var Or = [], ki = e2.isDeclaration(Se) ? e2.getCombinedNodeFlagsAlwaysIncludeJSDoc(Se) & ~hr : 0;
              return ki & 8 && Or.push("private"), ki & 16 && Or.push("protected"), ki & 4 && Or.push("public"), (ki & 32 || e2.isClassStaticBlockDeclaration(Se)) && Or.push("static"), ki & 128 && Or.push("abstract"), ki & 1 && Or.push("export"), ki & 8192 && Or.push("deprecated"), Se.flags & 16777216 && Or.push("declare"), Se.kind === 271 && Or.push("export"), Or.length > 0 ? Or.join(",") : "";
            }
            e2.getNodeModifiers = ae;
            function Xe(Se) {
              if (Se.kind === 178 || Se.kind === 208)
                return Se.typeArguments;
              if (e2.isFunctionLike(Se) || Se.kind === 257 || Se.kind === 258)
                return Se.typeParameters;
            }
            e2.getTypeArgumentOrTypeParameterList = Xe;
            function Jr(Se) {
              return Se === 2 || Se === 3;
            }
            e2.isComment = Jr;
            function ti(Se) {
              return !!(Se === 10 || Se === 13 || e2.isTemplateLiteralKind(Se));
            }
            e2.isStringOrRegularExpressionOrTemplateLiteral = ti;
            function Ze(Se) {
              return 18 <= Se && Se <= 78;
            }
            e2.isPunctuation = Ze;
            function Sr(Se, hr, Or) {
              return e2.isTemplateLiteralKind(Se.kind) && Se.getStart(Or) < hr && hr < Se.end || !!Se.isUnterminated && hr === Se.end;
            }
            e2.isInsideTemplateLiteral = Sr;
            function zr(Se) {
              switch (Se) {
                case 123:
                case 121:
                case 122:
                  return true;
              }
              return false;
            }
            e2.isAccessibilityModifier = zr;
            function Wr(Se) {
              var hr = e2.clone(Se);
              return e2.setConfigFileInOptions(hr, Se && Se.configFile), hr;
            }
            e2.cloneCompilerOptions = Wr;
            function Je(Se) {
              return !!((Se.kind === 204 || Se.kind === 205) && (Se.parent.kind === 221 && Se.parent.left === Se && Se.parent.operatorToken.kind === 63 || Se.parent.kind === 244 && Se.parent.initializer === Se || Je(Se.parent.kind === 296 ? Se.parent.parent : Se.parent)));
            }
            e2.isArrayLiteralOrObjectLiteralDestructuringPattern = Je;
            function xe(Se, hr) {
              return mr(Se, hr, true);
            }
            e2.isInReferenceComment = xe;
            function vr(Se, hr) {
              return mr(Se, hr, false);
            }
            e2.isInNonReferenceComment = vr;
            function mr(Se, hr, Or) {
              var ki = Zt(Se, hr, void 0);
              return !!ki && Or === j.test(Se.text.substring(ki.pos, ki.end));
            }
            function Ar(Se) {
              if (!!Se)
                switch (Se.kind) {
                  case 10:
                  case 14:
                    return nr(Se);
                  default:
                    return Oe(Se);
                }
            }
            e2.getReplacementSpanForContextToken = Ar;
            function Oe(Se, hr, Or) {
              return e2.createTextSpanFromBounds(Se.getStart(hr), (Or || Se).getEnd());
            }
            e2.createTextSpanFromNode = Oe;
            function nr(Se) {
              if (!Se.isUnterminated)
                return e2.createTextSpanFromBounds(Se.getStart() + 1, Se.getEnd() - 1);
            }
            e2.createTextSpanFromStringLiteralLikeContent = nr;
            function Mr(Se, hr) {
              return e2.createRange(Se.getStart(hr), Se.end);
            }
            e2.createTextRangeFromNode = Mr;
            function Pe(Se) {
              return e2.createTextSpanFromBounds(Se.pos, Se.end);
            }
            e2.createTextSpanFromRange = Pe;
            function Ue(Se) {
              return e2.createRange(Se.start, Se.start + Se.length);
            }
            e2.createTextRangeFromSpan = Ue;
            function fr(Se, hr, Or) {
              return De(e2.createTextSpan(Se, hr), Or);
            }
            e2.createTextChangeFromStartLength = fr;
            function De(Se, hr) {
              return { span: Se, newText: hr };
            }
            e2.createTextChange = De, e2.typeKeywords = [130, 128, 158, 133, 95, 137, 140, 143, 104, 147, 148, 145, 150, 151, 110, 114, 153, 154, 155];
            function gr(Se) {
              return e2.contains(e2.typeKeywords, Se);
            }
            e2.isTypeKeyword = gr;
            function Vr(Se) {
              return Se.kind === 152;
            }
            e2.isTypeKeywordToken = Vr;
            function Tr(Se) {
              return Vr(Se) || e2.isIdentifier(Se) && Se.text === "type";
            }
            e2.isTypeKeywordTokenOrIdentifier = Tr;
            function vi(Se) {
              return !!(Se.flags & 1536) && Se.name.charCodeAt(0) === 34;
            }
            e2.isExternalModuleSymbol = vi;
            function Ui() {
              var Se = [];
              return function(hr) {
                var Or = e2.getNodeId(hr);
                return !Se[Or] && (Se[Or] = true);
              };
            }
            e2.nodeSeenTracker = Ui;
            function Yi(Se) {
              return Se.getText(0, Se.getLength());
            }
            e2.getSnapshotText = Yi;
            function Wi(Se, hr) {
              for (var Or = "", ki = 0; ki < hr; ki++)
                Or += Se;
              return Or;
            }
            e2.repeatString = Wi;
            function ct(Se) {
              return Se.isTypeParameter() && Se.getConstraint() || Se;
            }
            e2.skipConstraint = ct;
            function Li(Se) {
              return Se.kind === 162 ? e2.isStringOrNumericLiteralLike(Se.expression) ? Se.expression.text : void 0 : e2.isPrivateIdentifier(Se) ? e2.idText(Se) : e2.getTextOfIdentifierOrLiteral(Se);
            }
            e2.getNameFromPropertyName = Li;
            function nt(Se) {
              return Se.getSourceFiles().some(function(hr) {
                return !hr.isDeclarationFile && !Se.isSourceFileFromExternalLibrary(hr) && !!(hr.externalModuleIndicator || hr.commonJsModuleIndicator);
              });
            }
            e2.programContainsModules = nt;
            function Mt(Se) {
              return Se.getSourceFiles().some(function(hr) {
                return !hr.isDeclarationFile && !Se.isSourceFileFromExternalLibrary(hr) && !!hr.externalModuleIndicator;
              });
            }
            e2.programContainsEsModules = Mt;
            function xt(Se) {
              return !!Se.module || e2.getEmitScriptTarget(Se) >= 2 || !!Se.noEmit;
            }
            e2.compilerOptionsIndicateEsModules = xt;
            function ut(Se, hr) {
              return { fileExists: function(Or) {
                return Se.fileExists(Or);
              }, getCurrentDirectory: function() {
                return hr.getCurrentDirectory();
              }, readFile: e2.maybeBind(hr, hr.readFile), useCaseSensitiveFileNames: e2.maybeBind(hr, hr.useCaseSensitiveFileNames), getSymlinkCache: e2.maybeBind(hr, hr.getSymlinkCache) || Se.getSymlinkCache, getModuleSpecifierCache: e2.maybeBind(hr, hr.getModuleSpecifierCache), getPackageJsonInfoCache: function() {
                var Or;
                return (Or = Se.getModuleResolutionCache()) === null || Or === void 0 ? void 0 : Or.getPackageJsonInfoCache();
              }, getGlobalTypingsCacheLocation: e2.maybeBind(hr, hr.getGlobalTypingsCacheLocation), redirectTargetsMap: Se.redirectTargetsMap, getProjectReferenceRedirect: function(Or) {
                return Se.getProjectReferenceRedirect(Or);
              }, isSourceOfProjectReferenceRedirect: function(Or) {
                return Se.isSourceOfProjectReferenceRedirect(Or);
              }, getNearestAncestorDirectoryWithPackageJson: e2.maybeBind(hr, hr.getNearestAncestorDirectoryWithPackageJson), getFileIncludeReasons: function() {
                return Se.getFileIncludeReasons();
              } };
            }
            e2.createModuleSpecifierResolutionHost = ut;
            function Dt(Se, hr) {
              return Ke(Ke({}, ut(Se, hr)), { getCommonSourceDirectory: function() {
                return Se.getCommonSourceDirectory();
              } });
            }
            e2.getModuleSpecifierResolverHost = Dt;
            function Rt(Se) {
              return Se >= e2.ModuleResolutionKind.Node16 && Se <= e2.ModuleResolutionKind.NodeNext;
            }
            e2.moduleResolutionRespectsExports = Rt;
            function Ii(Se) {
              return Se === e2.ModuleResolutionKind.NodeJs || Se >= e2.ModuleResolutionKind.Node16 && Se <= e2.ModuleResolutionKind.NodeNext;
            }
            e2.moduleResolutionUsesNodeModules = Ii;
            function Ki(Se, hr, Or, ki) {
              return Se || hr && hr.length ? Fi(Se, hr, Or, ki) : void 0;
            }
            e2.makeImportIfNecessary = Ki;
            function Fi(Se, hr, Or, ki, dt) {
              return e2.factory.createImportDeclaration(void 0, void 0, Se || hr ? e2.factory.createImportClause(!!dt, Se, hr && hr.length ? e2.factory.createNamedImports(hr) : void 0) : void 0, typeof Or == "string" ? ui(Or, ki) : Or, void 0);
            }
            e2.makeImport = Fi;
            function ui(Se, hr) {
              return e2.factory.createStringLiteral(Se, hr === 0);
            }
            e2.makeStringLiteral = ui;
            var Bt;
            (function(Se) {
              Se[Se.Single = 0] = "Single", Se[Se.Double = 1] = "Double";
            })(Bt = e2.QuotePreference || (e2.QuotePreference = {}));
            function wt(Se, hr) {
              return e2.isStringDoubleQuoted(Se, hr) ? 1 : 0;
            }
            e2.quotePreferenceFromString = wt;
            function na(Se, hr) {
              if (hr.quotePreference && hr.quotePreference !== "auto")
                return hr.quotePreference === "single" ? 0 : 1;
              var Or = Se.imports && e2.find(Se.imports, function(ki) {
                return e2.isStringLiteral(ki) && !e2.nodeIsSynthesized(ki.parent);
              });
              return Or ? wt(Or, Se) : 1;
            }
            e2.getQuotePreference = na;
            function Ai(Se) {
              switch (Se) {
                case 0:
                  return "'";
                case 1:
                  return '"';
                default:
                  return e2.Debug.assertNever(Se);
              }
            }
            e2.getQuoteFromPreference = Ai;
            function Oi(Se) {
              var hr = ji(Se);
              return hr === void 0 ? void 0 : e2.unescapeLeadingUnderscores(hr);
            }
            e2.symbolNameNoDefault = Oi;
            function ji(Se) {
              return Se.escapedName !== "default" ? Se.escapedName : e2.firstDefined(Se.declarations, function(hr) {
                var Or = e2.getNameOfDeclaration(hr);
                return Or && Or.kind === 79 ? Or.escapedText : void 0;
              });
            }
            e2.symbolEscapedNameNoDefault = ji;
            function Vi(Se) {
              return e2.isStringLiteralLike(Se) && (e2.isExternalModuleReference(Se.parent) || e2.isImportDeclaration(Se.parent) || e2.isRequireCall(Se.parent, false) && Se.parent.arguments[0] === Se || e2.isImportCall(Se.parent) && Se.parent.arguments[0] === Se);
            }
            e2.isModuleSpecifierLike = Vi;
            function at(Se) {
              return e2.isBindingElement(Se) && e2.isObjectBindingPattern(Se.parent) && e2.isIdentifier(Se.name) && !Se.propertyName;
            }
            e2.isObjectBindingElementWithoutPropertyName = at;
            function At(Se, hr) {
              var Or = Se.getTypeAtLocation(hr.parent);
              return Or && Se.getPropertyOfType(Or, hr.name.text);
            }
            e2.getPropertySymbolFromBindingElement = At;
            function ba(Se, hr, Or) {
              if (!!Se)
                for (; Se.parent; ) {
                  if (e2.isSourceFile(Se.parent) || !$a(Or, Se.parent, hr))
                    return Se;
                  Se = Se.parent;
                }
            }
            e2.getParentNodeInSpan = ba;
            function $a(Se, hr, Or) {
              return e2.textSpanContainsPosition(Se, hr.getStart(Or)) && hr.getEnd() <= e2.textSpanEnd(Se);
            }
            function Qa(Se, hr) {
              return Se.modifiers && e2.find(Se.modifiers, function(Or) {
                return Or.kind === hr;
              });
            }
            e2.findModifier = Qa;
            function ai(Se, hr, Or, ki) {
              var dt = e2.isArray(Or) ? Or[0] : Or, la = dt.kind === 237 ? e2.isRequireVariableStatement : e2.isAnyImportSyntax, wa = e2.filter(hr.statements, la), On = e2.isArray(Or) ? e2.stableSort(Or, e2.OrganizeImports.compareImportsOrRequireStatements) : [Or];
              if (!wa.length)
                Se.insertNodesAtTopOfFile(hr, On, ki);
              else if (wa && e2.OrganizeImports.importsAreSorted(wa))
                for (var No = 0, jo = On; No < jo.length; No++) {
                  var po = jo[No], Gn = e2.OrganizeImports.getImportDeclarationInsertionIndex(wa, po);
                  if (Gn === 0) {
                    var $n = wa[0] === hr.statements[0] ? { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.Exclude } : {};
                    Se.insertNodeBefore(hr, wa[0], po, false, $n);
                  } else {
                    var Ho = wa[Gn - 1];
                    Se.insertNodeAfter(hr, Ho, po);
                  }
                }
              else {
                var Zo = e2.lastOrUndefined(wa);
                Zo ? Se.insertNodesAfter(hr, Zo, On) : Se.insertNodesAtTopOfFile(hr, On, ki);
              }
            }
            e2.insertImports = ai;
            function Dn(Se, hr) {
              return e2.Debug.assert(Se.isTypeOnly), e2.cast(Se.getChildAt(0, hr), Vr);
            }
            e2.getTypeKeywordOfTypeOnlyImport = Dn;
            function ka(Se, hr) {
              return !!Se && !!hr && Se.start === hr.start && Se.length === hr.length;
            }
            e2.textSpansEqual = ka;
            function Ba(Se, hr) {
              return Se.fileName === hr.fileName && ka(Se.textSpan, hr.textSpan);
            }
            e2.documentSpansEqual = Ba;
            function pn(Se, hr) {
              if (Se) {
                for (var Or = 0; Or < Se.length; Or++)
                  if (Se.indexOf(Se[Or]) === Or) {
                    var ki = hr(Se[Or], Or);
                    if (ki)
                      return ki;
                  }
              }
            }
            e2.forEachUnique = pn;
            function Cn(Se, hr, Or) {
              for (var ki = hr; ki < Or; ki++)
                if (!e2.isWhiteSpaceLike(Se.charCodeAt(ki)))
                  return false;
              return true;
            }
            e2.isTextWhiteSpaceLike = Cn;
            function Bi(Se) {
              var hr = Se.declarations ? e2.firstOrUndefined(Se.declarations) : void 0;
              return !!e2.findAncestor(hr, function(Or) {
                return e2.isParameter(Or) ? true : e2.isBindingElement(Or) || e2.isObjectBindingPattern(Or) || e2.isArrayBindingPattern(Or) ? false : "quit";
              });
            }
            e2.isFirstDeclarationOfSymbolParameter = Bi;
            var kn = xn();
            function xn() {
              var Se = e2.defaultMaximumTruncationLength * 10, hr, Or, ki, dt;
              po();
              var la = function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.text);
              };
              return { displayParts: function() {
                var Gn = hr.length && hr[hr.length - 1].text;
                return dt > Se && Gn && Gn !== "..." && (e2.isWhiteSpaceLike(Gn.charCodeAt(Gn.length - 1)) || hr.push(Pn(" ", e2.SymbolDisplayPartKind.space)), hr.push(Pn("...", e2.SymbolDisplayPartKind.punctuation))), hr;
              }, writeKeyword: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.keyword);
              }, writeOperator: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.operator);
              }, writePunctuation: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.punctuation);
              }, writeTrailingSemicolon: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.punctuation);
              }, writeSpace: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.space);
              }, writeStringLiteral: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.stringLiteral);
              }, writeParameter: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.parameterName);
              }, writeProperty: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.propertyName);
              }, writeLiteral: function(Gn) {
                return On(Gn, e2.SymbolDisplayPartKind.stringLiteral);
              }, writeSymbol: No, writeLine: jo, write: la, writeComment: la, getText: function() {
                return "";
              }, getTextPos: function() {
                return 0;
              }, getColumn: function() {
                return 0;
              }, getLine: function() {
                return 0;
              }, isAtStartOfLine: function() {
                return false;
              }, hasTrailingWhitespace: function() {
                return false;
              }, hasTrailingComment: function() {
                return false;
              }, rawWrite: e2.notImplemented, getIndent: function() {
                return ki;
              }, increaseIndent: function() {
                ki++;
              }, decreaseIndent: function() {
                ki--;
              }, clear: po, trackSymbol: function() {
                return false;
              }, reportInaccessibleThisError: e2.noop, reportInaccessibleUniqueSymbolError: e2.noop, reportPrivateInBaseOfClassExpression: e2.noop };
              function wa() {
                if (!(dt > Se) && Or) {
                  var Gn = e2.getIndentString(ki);
                  Gn && (dt += Gn.length, hr.push(Pn(Gn, e2.SymbolDisplayPartKind.space))), Or = false;
                }
              }
              function On(Gn, $n) {
                dt > Se || (wa(), dt += Gn.length, hr.push(Pn(Gn, $n)));
              }
              function No(Gn, $n) {
                dt > Se || (wa(), dt += Gn.length, hr.push(Kn(Gn, $n)));
              }
              function jo() {
                dt > Se || (dt += 1, hr.push(Jn()), Or = true);
              }
              function po() {
                hr = [], Or = true, ki = 0, dt = 0;
              }
            }
            function Kn(Se, hr) {
              return Pn(Se, Or(hr));
              function Or(ki) {
                var dt = ki.flags;
                return dt & 3 ? Bi(ki) ? e2.SymbolDisplayPartKind.parameterName : e2.SymbolDisplayPartKind.localName : dt & 4 || dt & 32768 || dt & 65536 ? e2.SymbolDisplayPartKind.propertyName : dt & 8 ? e2.SymbolDisplayPartKind.enumMemberName : dt & 16 ? e2.SymbolDisplayPartKind.functionName : dt & 32 ? e2.SymbolDisplayPartKind.className : dt & 64 ? e2.SymbolDisplayPartKind.interfaceName : dt & 384 ? e2.SymbolDisplayPartKind.enumName : dt & 1536 ? e2.SymbolDisplayPartKind.moduleName : dt & 8192 ? e2.SymbolDisplayPartKind.methodName : dt & 262144 ? e2.SymbolDisplayPartKind.typeParameterName : dt & 524288 || dt & 2097152 ? e2.SymbolDisplayPartKind.aliasName : e2.SymbolDisplayPartKind.text;
              }
            }
            e2.symbolPart = Kn;
            function Pn(Se, hr) {
              return { text: Se, kind: e2.SymbolDisplayPartKind[hr] };
            }
            e2.displayPart = Pn;
            function eo() {
              return Pn(" ", e2.SymbolDisplayPartKind.space);
            }
            e2.spacePart = eo;
            function Rn(Se) {
              return Pn(e2.tokenToString(Se), e2.SymbolDisplayPartKind.keyword);
            }
            e2.keywordPart = Rn;
            function Da(Se) {
              return Pn(e2.tokenToString(Se), e2.SymbolDisplayPartKind.punctuation);
            }
            e2.punctuationPart = Da;
            function bo(Se) {
              return Pn(e2.tokenToString(Se), e2.SymbolDisplayPartKind.operator);
            }
            e2.operatorPart = bo;
            function Ro(Se) {
              return Pn(Se, e2.SymbolDisplayPartKind.parameterName);
            }
            e2.parameterNamePart = Ro;
            function En(Se) {
              return Pn(Se, e2.SymbolDisplayPartKind.propertyName);
            }
            e2.propertyNamePart = En;
            function Wn(Se) {
              var hr = e2.stringToToken(Se);
              return hr === void 0 ? to(Se) : Rn(hr);
            }
            e2.textOrKeywordPart = Wn;
            function to(Se) {
              return Pn(Se, e2.SymbolDisplayPartKind.text);
            }
            e2.textPart = to;
            function Co(Se) {
              return Pn(Se, e2.SymbolDisplayPartKind.aliasName);
            }
            e2.typeAliasNamePart = Co;
            function Ko(Se) {
              return Pn(Se, e2.SymbolDisplayPartKind.typeParameterName);
            }
            e2.typeParameterNamePart = Ko;
            function Oo(Se) {
              return Pn(Se, e2.SymbolDisplayPartKind.linkText);
            }
            e2.linkTextPart = Oo;
            function no(Se, hr) {
              return { text: Se, kind: e2.SymbolDisplayPartKind[e2.SymbolDisplayPartKind.linkName], target: { fileName: e2.getSourceFileOfNode(hr).fileName, textSpan: Oe(hr) } };
            }
            e2.linkNamePart = no;
            function $o(Se) {
              return Pn(Se, e2.SymbolDisplayPartKind.link);
            }
            e2.linkPart = $o;
            function Pr(Se, hr) {
              var Or, ki = e2.isJSDocLink(Se) ? "link" : e2.isJSDocLinkCode(Se) ? "linkcode" : "linkplain", dt = [$o("{@".concat(ki, " "))];
              if (!Se.name)
                Se.text && dt.push(Oo(Se.text));
              else {
                var la = hr == null ? void 0 : hr.getSymbolAtLocation(Se.name), wa = St(Se.text), On = e2.getTextOfNode(Se.name) + Se.text.slice(0, wa), No = xi(Se.text.slice(wa)), jo = (la == null ? void 0 : la.valueDeclaration) || ((Or = la == null ? void 0 : la.declarations) === null || Or === void 0 ? void 0 : Or[0]);
                jo ? (dt.push(no(On, jo)), No && dt.push(Oo(No))) : dt.push(Oo(On + (wa || No.indexOf("://") === 0 ? "" : " ") + No));
              }
              return dt.push($o("}")), dt;
            }
            e2.buildLinkParts = Pr;
            function xi(Se) {
              var hr = 0;
              if (Se.charCodeAt(hr++) === 124) {
                for (; hr < Se.length && Se.charCodeAt(hr) === 32; )
                  hr++;
                return Se.slice(hr);
              }
              return Se;
            }
            function St(Se) {
              if (Se.indexOf("()") === 0)
                return 2;
              if (Se[0] !== "<")
                return 0;
              for (var hr = 0, Or = 0; Or < Se.length; )
                if (Se[Or] === "<" && hr++, Se[Or] === ">" && hr--, Or++, !hr)
                  return Or;
              return 0;
            }
            var pa = `\r
`;
            function dn(Se, hr) {
              var Or;
              return (hr == null ? void 0 : hr.newLineCharacter) || ((Or = Se.getNewLine) === null || Or === void 0 ? void 0 : Or.call(Se)) || pa;
            }
            e2.getNewLineOrDefaultFromHost = dn;
            function Jn() {
              return Pn(`
`, e2.SymbolDisplayPartKind.lineBreak);
            }
            e2.lineBreakPart = Jn;
            function Qe(Se) {
              try {
                return Se(kn), kn.displayParts();
              } finally {
                kn.clear();
              }
            }
            e2.mapToDisplayParts = Qe;
            function Gr(Se, hr, Or, ki) {
              return ki === void 0 && (ki = 0), Qe(function(dt) {
                Se.writeType(hr, Or, ki | 1024 | 16384, dt);
              });
            }
            e2.typeToDisplayParts = Gr;
            function S2(Se, hr, Or, ki, dt) {
              return dt === void 0 && (dt = 0), Qe(function(la) {
                Se.writeSymbol(hr, Or, ki, dt | 8, la);
              });
            }
            e2.symbolToDisplayParts = S2;
            function Ce(Se, hr, Or, ki) {
              return ki === void 0 && (ki = 0), ki |= 25632, Qe(function(dt) {
                Se.writeSignature(hr, Or, ki, void 0, dt);
              });
            }
            e2.signatureToDisplayParts = Ce;
            function qe(Se, hr) {
              var Or = hr.getSourceFile();
              return Qe(function(ki) {
                var dt = e2.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
                dt.writeNode(4, Se, Or, ki);
              });
            }
            e2.nodeToDisplayParts = qe;
            function br(Se) {
              return !!Se.parent && e2.isImportOrExportSpecifier(Se.parent) && Se.parent.propertyName === Se;
            }
            e2.isImportOrExportSpecifierName = br;
            function Zr(Se, hr) {
              return e2.ensureScriptKind(Se, hr.getScriptKind && hr.getScriptKind(Se));
            }
            e2.getScriptKind = Zr;
            function Si(Se, hr) {
              for (var Or = Se; Qi(Or) || Pi(Or) && Or.target; )
                Pi(Or) && Or.target ? Or = Or.target : Or = e2.skipAlias(Or, hr);
              return Or;
            }
            e2.getSymbolTarget = Si;
            function Pi(Se) {
              return (Se.flags & 33554432) !== 0;
            }
            function Qi(Se) {
              return (Se.flags & 2097152) !== 0;
            }
            function Ct(Se, hr) {
              return e2.getSymbolId(e2.skipAlias(Se, hr));
            }
            e2.getUniqueSymbolId = Ct;
            function sa(Se, hr) {
              for (; e2.isWhiteSpaceLike(Se.charCodeAt(hr)); )
                hr += 1;
              return hr;
            }
            e2.getFirstNonSpaceCharacterPosition = sa;
            function en(Se, hr) {
              for (; hr > -1 && e2.isWhiteSpaceSingleLine(Se.charCodeAt(hr)); )
                hr -= 1;
              return hr + 1;
            }
            e2.getPrecedingNonSpaceCharacterPosition = en;
            function Wa(Se, hr) {
              hr === void 0 && (hr = true);
              var Or = Se && mo(Se);
              return Or && !hr && ys(Or), Or;
            }
            e2.getSynthesizedDeepClone = Wa;
            function qn(Se, hr, Or) {
              var ki = Or(Se);
              return ki ? e2.setOriginalNode(ki, Se) : ki = mo(Se, Or), ki && !hr && ys(ki), ki;
            }
            e2.getSynthesizedDeepCloneWithReplacements = qn;
            function mo(Se, hr) {
              var Or = hr ? function(wa) {
                return qn(wa, true, hr);
              } : Wa, ki = hr ? function(wa) {
                return wa && Go(wa, true, hr);
              } : function(wa) {
                return wa && So(wa);
              }, dt = e2.visitEachChild(Se, Or, e2.nullTransformationContext, ki, Or);
              if (dt === Se) {
                var la = e2.isStringLiteral(Se) ? e2.setOriginalNode(e2.factory.createStringLiteralFromNode(Se), Se) : e2.isNumericLiteral(Se) ? e2.setOriginalNode(e2.factory.createNumericLiteral(Se.text, Se.numericLiteralFlags), Se) : e2.factory.cloneNode(Se);
                return e2.setTextRange(la, Se);
              }
              return dt.parent = void 0, dt;
            }
            function So(Se, hr) {
              return hr === void 0 && (hr = true), Se && e2.factory.createNodeArray(Se.map(function(Or) {
                return Wa(Or, hr);
              }), Se.hasTrailingComma);
            }
            e2.getSynthesizedDeepClones = So;
            function Go(Se, hr, Or) {
              return e2.factory.createNodeArray(Se.map(function(ki) {
                return qn(ki, hr, Or);
              }), Se.hasTrailingComma);
            }
            e2.getSynthesizedDeepClonesWithReplacements = Go;
            function ys(Se) {
              Pc(Se), Vc(Se);
            }
            e2.suppressLeadingAndTrailingTrivia = ys;
            function Pc(Se) {
              pc(Se, 512, hs);
            }
            e2.suppressLeadingTrivia = Pc;
            function Vc(Se) {
              pc(Se, 1024, e2.getLastChild);
            }
            e2.suppressTrailingTrivia = Vc;
            function Kc(Se, hr) {
              var Or = Se.getSourceFile(), ki = Or.text;
              Xs(Se, ki) ? Qs(Se, hr, Or) : ds(Se, hr, Or), js(Se, hr, Or);
            }
            e2.copyComments = Kc;
            function Xs(Se, hr) {
              for (var Or = Se.getFullStart(), ki = Se.getStart(), dt = Or; dt < ki; dt++)
                if (hr.charCodeAt(dt) === 10)
                  return true;
              return false;
            }
            function pc(Se, hr, Or) {
              e2.addEmitFlags(Se, hr);
              var ki = Or(Se);
              ki && pc(ki, hr, Or);
            }
            function hs(Se) {
              return Se.forEachChild(function(hr) {
                return hr;
              });
            }
            function tc(Se, hr) {
              for (var Or = Se, ki = 1; !e2.isFileLevelUniqueName(hr, Or); ki++)
                Or = "".concat(Se, "_").concat(ki);
              return Or;
            }
            e2.getUniqueName = tc;
            function ps(Se, hr, Or, ki) {
              for (var dt = 0, la = -1, wa = 0, On = Se; wa < On.length; wa++) {
                var No = On[wa], jo = No.fileName, po = No.textChanges;
                e2.Debug.assert(jo === hr);
                for (var Gn = 0, $n = po; Gn < $n.length; Gn++) {
                  var Ho = $n[Gn], Zo = Ho.span, Es = Ho.newText, yc = ce(Es, Or);
                  if (yc !== -1 && (la = Zo.start + dt + yc, !ki))
                    return la;
                  dt += Es.length - Zo.length;
                }
              }
              return e2.Debug.assert(ki), e2.Debug.assert(la >= 0), la;
            }
            e2.getRenameLocation = ps;
            function Qs(Se, hr, Or, ki, dt) {
              e2.forEachLeadingCommentRange(Or.text, Se.pos, Ji(hr, Or, ki, dt, e2.addSyntheticLeadingComment));
            }
            e2.copyLeadingComments = Qs;
            function js(Se, hr, Or, ki, dt) {
              e2.forEachTrailingCommentRange(Or.text, Se.end, Ji(hr, Or, ki, dt, e2.addSyntheticTrailingComment));
            }
            e2.copyTrailingComments = js;
            function ds(Se, hr, Or, ki, dt) {
              e2.forEachTrailingCommentRange(Or.text, Se.pos, Ji(hr, Or, ki, dt, e2.addSyntheticLeadingComment));
            }
            e2.copyTrailingAsLeadingComments = ds;
            function Ji(Se, hr, Or, ki, dt) {
              return function(la, wa, On, No) {
                On === 3 ? (la += 2, wa -= 2) : la += 2, dt(Se, Or || On, hr.text.slice(la, wa), ki !== void 0 ? ki : No);
              };
            }
            function ce(Se, hr) {
              if (e2.startsWith(Se, hr))
                return 0;
              var Or = Se.indexOf(" " + hr);
              return Or === -1 && (Or = Se.indexOf("." + hr)), Or === -1 && (Or = Se.indexOf('"' + hr)), Or === -1 ? -1 : Or + 1;
            }
            function Rr(Se) {
              return e2.isBinaryExpression(Se) && Se.operatorToken.kind === 27 || e2.isObjectLiteralExpression(Se) || e2.isAsExpression(Se) && e2.isObjectLiteralExpression(Se.expression);
            }
            e2.needsParentheses = Rr;
            function yi(Se, hr) {
              var Or = Se.parent;
              switch (Or.kind) {
                case 209:
                  return hr.getContextualType(Or);
                case 221: {
                  var ki = Or, dt = ki.left, la = ki.operatorToken, wa = ki.right;
                  return je(la.kind) ? hr.getTypeAtLocation(Se === wa ? dt : wa) : hr.getContextualType(Se);
                }
                case 289:
                  return Or.expression === Se ? Pt(Or, hr) : void 0;
                default:
                  return hr.getContextualType(Se);
              }
            }
            e2.getContextualTypeFromParent = yi;
            function qi(Se, hr, Or) {
              var ki = na(Se, hr), dt = JSON.stringify(Or);
              return ki === 0 ? "'".concat(e2.stripQuotes(dt).replace(/'/g, "\\'").replace(/\\"/g, '"'), "'") : dt;
            }
            e2.quote = qi;
            function je(Se) {
              switch (Se) {
                case 36:
                case 34:
                case 37:
                case 35:
                  return true;
                default:
                  return false;
              }
            }
            e2.isEqualityOperatorKind = je;
            function Hr(Se) {
              switch (Se.kind) {
                case 10:
                case 14:
                case 223:
                case 210:
                  return true;
                default:
                  return false;
              }
            }
            e2.isStringLiteralOrTemplate = Hr;
            function pt(Se) {
              return !!Se.getStringIndexType() || !!Se.getNumberIndexType();
            }
            e2.hasIndexSignature = pt;
            function Pt(Se, hr) {
              return hr.getTypeAtLocation(Se.parent.parent.expression);
            }
            e2.getSwitchedType = Pt, e2.ANONYMOUS = "anonymous function";
            function ga(Se, hr, Or, ki) {
              var dt = Or.getTypeChecker(), la = true, wa = function() {
                return la = false;
              }, On = dt.typeToTypeNode(Se, hr, 1, { trackSymbol: function(No, jo, po) {
                return la = la && dt.isSymbolAccessible(No, jo, po, false).accessibility === 0, !la;
              }, reportInaccessibleThisError: wa, reportPrivateInBaseOfClassExpression: wa, reportInaccessibleUniqueSymbolError: wa, moduleResolverHost: Dt(Or, ki) });
              return la ? On : void 0;
            }
            e2.getTypeNodeIfAccessible = ga;
            function ua(Se) {
              return Se === 174 || Se === 175 || Se === 176 || Se === 166 || Se === 168;
            }
            function Xn(Se) {
              return Se === 256 || Se === 171 || Se === 169 || Se === 172 || Se === 173;
            }
            function jr(Se) {
              return Se === 261;
            }
            function fo(Se) {
              return Se === 237 || Se === 238 || Se === 240 || Se === 245 || Se === 246 || Se === 247 || Se === 251 || Se === 253 || Se === 167 || Se === 259 || Se === 266 || Se === 265 || Se === 272 || Se === 264 || Se === 271;
            }
            e2.syntaxRequiresTrailingSemicolonOrASI = fo, e2.syntaxMayBeASICandidate = e2.or(ua, Xn, jr, fo);
            function xs(Se, hr) {
              var Or = Se.getLastToken(hr);
              if (Or && Or.kind === 26)
                return false;
              if (ua(Se.kind)) {
                if (Or && Or.kind === 27)
                  return false;
              } else if (jr(Se.kind)) {
                var ki = e2.last(Se.getChildren(hr));
                if (ki && e2.isModuleBlock(ki))
                  return false;
              } else if (Xn(Se.kind)) {
                var ki = e2.last(Se.getChildren(hr));
                if (ki && e2.isFunctionBlock(ki))
                  return false;
              } else if (!fo(Se.kind))
                return false;
              if (Se.kind === 240)
                return true;
              var dt = e2.findAncestor(Se, function(No) {
                return !No.parent;
              }), la = yr(Se, dt, hr);
              if (!la || la.kind === 19)
                return true;
              var wa = hr.getLineAndCharacterOfPosition(Se.getEnd()).line, On = hr.getLineAndCharacterOfPosition(la.getStart(hr)).line;
              return wa !== On;
            }
            function Fo(Se, hr, Or) {
              var ki = e2.findAncestor(hr, function(dt) {
                return dt.end !== Se ? "quit" : e2.syntaxMayBeASICandidate(dt.kind);
              });
              return !!ki && xs(ki, Or);
            }
            e2.positionIsASICandidate = Fo;
            function ko(Se) {
              var hr = 0, Or = 0, ki = 5;
              return e2.forEachChild(Se, function dt(la) {
                if (fo(la.kind)) {
                  var wa = la.getLastToken(Se);
                  (wa == null ? void 0 : wa.kind) === 26 ? hr++ : Or++;
                } else if (ua(la.kind)) {
                  var wa = la.getLastToken(Se);
                  if ((wa == null ? void 0 : wa.kind) === 26)
                    hr++;
                  else if (wa && wa.kind !== 27) {
                    var On = e2.getLineAndCharacterOfPosition(Se, wa.getStart(Se)).line, No = e2.getLineAndCharacterOfPosition(Se, e2.getSpanOfTokenAtPosition(Se, wa.end).start).line;
                    On !== No && Or++;
                  }
                }
                return hr + Or >= ki ? true : e2.forEachChild(la, dt);
              }), hr === 0 && Or <= 1 ? true : hr / Or > 1 / ki;
            }
            e2.probablyUsesSemicolons = ko;
            function Ao(Se, hr) {
              return tl(Se, Se.getDirectories, hr) || [];
            }
            e2.tryGetDirectories = Ao;
            function Ms(Se, hr, Or, ki, dt) {
              return tl(Se, Se.readDirectory, hr, Or, ki, dt) || e2.emptyArray;
            }
            e2.tryReadDirectory = Ms;
            function Bs(Se, hr) {
              return tl(Se, Se.fileExists, hr);
            }
            e2.tryFileExists = Bs;
            function xc(Se, hr) {
              return su(function() {
                return e2.directoryProbablyExists(hr, Se);
              }) || false;
            }
            e2.tryDirectoryExists = xc;
            function su(Se) {
              try {
                return Se();
              } catch {
                return;
              }
            }
            e2.tryAndIgnoreErrors = su;
            function tl(Se, hr) {
              for (var Or = [], ki = 2; ki < arguments.length; ki++)
                Or[ki - 2] = arguments[ki];
              return su(function() {
                return hr && hr.apply(Se, Or);
              });
            }
            e2.tryIOAndConsumeErrors = tl;
            function Zc(Se, hr, Or) {
              var ki = [];
              return e2.forEachAncestorDirectory(Se, function(dt) {
                if (dt === Or)
                  return true;
                var la = e2.combinePaths(dt, "package.json");
                Bs(hr, la) && ki.push(la);
              }), ki;
            }
            e2.findPackageJsons = Zc;
            function Rf(Se, hr) {
              var Or;
              return e2.forEachAncestorDirectory(Se, function(ki) {
                if (ki === "node_modules" || (Or = e2.findConfigFile(ki, function(dt) {
                  return Bs(hr, dt);
                }, "package.json"), Or))
                  return true;
              }), Or;
            }
            e2.findPackageJson = Rf;
            function al(Se, hr) {
              if (!hr.fileExists)
                return [];
              var Or = [];
              return e2.forEachAncestorDirectory(e2.getDirectoryPath(Se), function(ki) {
                var dt = e2.combinePaths(ki, "package.json");
                if (hr.fileExists(dt)) {
                  var la = Jo(dt, hr);
                  la && Or.push(la);
                }
              }), Or;
            }
            e2.getPackageJsonsVisibleToFile = al;
            function Jo(Se, hr) {
              if (!hr.readFile)
                return;
              var Or = ["dependencies", "devDependencies", "optionalDependencies", "peerDependencies"], ki = hr.readFile(Se) || "", dt = Ws(ki), la = {};
              if (dt)
                for (var wa = 0, On = Or; wa < On.length; wa++) {
                  var No = On[wa], jo = dt[No];
                  if (!!jo) {
                    var po = new e2.Map();
                    for (var Gn in jo)
                      po.set(Gn, jo[Gn]);
                    la[No] = po;
                  }
                }
              var $n = [[1, la.dependencies], [2, la.devDependencies], [8, la.optionalDependencies], [4, la.peerDependencies]];
              return Ke(Ke({}, la), { parseable: !!dt, fileName: Se, get: Ho, has: function(Zo, Es) {
                return !!Ho(Zo, Es);
              } });
              function Ho(Zo, Es) {
                Es === void 0 && (Es = 15);
                for (var yc = 0, Xr = $n; yc < Xr.length; yc++) {
                  var Ls = Xr[yc], Ic = Ls[0], zu = Ls[1];
                  if (zu && Es & Ic) {
                    var vf = zu.get(Zo);
                    if (vf !== void 0)
                      return vf;
                  }
                }
              }
            }
            e2.createPackageJsonInfo = Jo;
            function eu(Se, hr, Or) {
              var ki = (Or.getPackageJsonsVisibleToFile && Or.getPackageJsonsVisibleToFile(Se.fileName) || al(Se.fileName, Or)).filter(function($n) {
                return $n.parseable;
              }), dt;
              return { allowsImportingAmbientModule: wa, allowsImportingSourceFile: On, allowsImportingSpecifier: No };
              function la($n) {
                for (var Ho = Gn($n), Zo = 0, Es = ki; Zo < Es.length; Zo++) {
                  var yc = Es[Zo];
                  if (yc.has(Ho) || yc.has(e2.getTypesPackageName(Ho)))
                    return true;
                }
                return false;
              }
              function wa($n, Ho) {
                if (!ki.length || !$n.valueDeclaration)
                  return true;
                var Zo = $n.valueDeclaration.getSourceFile(), Es = po(Zo.fileName, Ho);
                if (typeof Es > "u")
                  return true;
                var yc = e2.stripQuotes($n.getName());
                return jo(yc) ? true : la(Es) || la(yc);
              }
              function On($n, Ho) {
                if (!ki.length)
                  return true;
                var Zo = po($n.fileName, Ho);
                return Zo ? la(Zo) : true;
              }
              function No($n) {
                return !ki.length || jo($n) || e2.pathIsRelative($n) || e2.isRootedDiskPath($n) ? true : la($n);
              }
              function jo($n) {
                return !!(e2.isSourceFileJS(Se) && e2.JsTyping.nodeCoreModules.has($n) && (dt === void 0 && (dt = pu(Se)), dt));
              }
              function po($n, Ho) {
                if (!!e2.stringContains($n, "node_modules")) {
                  var Zo = e2.moduleSpecifiers.getNodeModulesPackageName(Or.getCompilationSettings(), Se, $n, Ho, hr);
                  if (!!Zo && !e2.pathIsRelative(Zo) && !e2.isRootedDiskPath(Zo))
                    return Gn(Zo);
                }
              }
              function Gn($n) {
                var Ho = e2.getPathComponents(e2.getPackageNameFromTypesPackageName($n)).slice(1);
                return e2.startsWith(Ho[0], "@") ? "".concat(Ho[0], "/").concat(Ho[1]) : Ho[0];
              }
            }
            e2.createPackageJsonImportFilter = eu;
            function Ws(Se) {
              try {
                return JSON.parse(Se);
              } catch {
                return;
              }
            }
            function pu(Se) {
              return e2.some(Se.imports, function(hr) {
                var Or = hr.text;
                return e2.JsTyping.nodeCoreModules.has(Or);
              });
            }
            e2.consumesNodeCoreModules = pu;
            function Uu(Se) {
              return e2.contains(e2.getPathComponents(Se), "node_modules");
            }
            e2.isInsideNodeModules = Uu;
            function Ql(Se) {
              return Se.file !== void 0 && Se.start !== void 0 && Se.length !== void 0;
            }
            e2.isDiagnosticWithLocation = Ql;
            function xl(Se, hr) {
              var Or = Oe(Se), ki = e2.binarySearchKey(hr, Or, e2.identity, e2.compareTextSpans);
              if (ki >= 0) {
                var dt = hr[ki];
                return e2.Debug.assertEqual(dt.file, Se.getSourceFile(), "Diagnostics proided to 'findDiagnosticForNode' must be from a single SourceFile"), e2.cast(dt, Ql);
              }
            }
            e2.findDiagnosticForNode = xl;
            function Ya(Se, hr) {
              var Or, ki = e2.binarySearchKey(hr, Se.start, function(On) {
                return On.start;
              }, e2.compareValues);
              for (ki < 0 && (ki = ~ki); ((Or = hr[ki - 1]) === null || Or === void 0 ? void 0 : Or.start) === Se.start; )
                ki--;
              for (var dt = [], la = e2.textSpanEnd(Se); ; ) {
                var wa = e2.tryCast(hr[ki], Ql);
                if (!wa || wa.start > la)
                  break;
                e2.textSpanContainsTextSpan(Se, wa) && dt.push(wa), ki++;
              }
              return dt;
            }
            e2.getDiagnosticsWithinSpan = Ya;
            function du(Se) {
              var hr = Se.startPosition, Or = Se.endPosition;
              return e2.createTextSpanFromBounds(hr, Or === void 0 ? hr : Or);
            }
            e2.getRefactorContextSpan = du;
            function vc(Se, hr) {
              var Or = lr(Se, hr.start), ki = e2.findAncestor(Or, function(dt) {
                return dt.getStart(Se) < hr.start || dt.getEnd() > e2.textSpanEnd(hr) ? "quit" : e2.isExpression(dt) && ka(hr, Oe(dt, Se));
              });
              return ki;
            }
            e2.getFixableErrorSpanExpression = vc;
            function Kr(Se, hr, Or) {
              return Or === void 0 && (Or = e2.identity), Se ? e2.isArray(Se) ? Or(e2.map(Se, hr)) : hr(Se, 0) : void 0;
            }
            e2.mapOneOrMany = Kr;
            function _i(Se) {
              return e2.isArray(Se) ? e2.first(Se) : Se;
            }
            e2.firstOrOnly = _i;
            function Ei(Se, hr) {
              if (kt(Se)) {
                var Or = bt(Se);
                if (Or)
                  return Or;
                var ki = e2.codefix.moduleSymbolToValidIdentifier(ia(Se), hr, false), dt = e2.codefix.moduleSymbolToValidIdentifier(ia(Se), hr, true);
                return ki === dt ? ki : [ki, dt];
              }
              return Se.name;
            }
            e2.getNamesForExportedSymbol = Ei;
            function tt(Se, hr, Or) {
              return kt(Se) ? bt(Se) || e2.codefix.moduleSymbolToValidIdentifier(ia(Se), hr, !!Or) : Se.name;
            }
            e2.getNameForExportedSymbol = tt;
            function kt(Se) {
              return !(Se.flags & 33554432) && (Se.escapedName === "export=" || Se.escapedName === "default");
            }
            function bt(Se) {
              return e2.firstDefined(Se.declarations, function(hr) {
                var Or;
                return e2.isExportAssignment(hr) ? (Or = e2.tryCast(e2.skipOuterExpressions(hr.expression), e2.isIdentifier)) === null || Or === void 0 ? void 0 : Or.text : void 0;
              });
            }
            function ia(Se) {
              var hr;
              return e2.Debug.checkDefined(Se.parent, "Symbol parent was undefined. Flags: ".concat(e2.Debug.formatSymbolFlags(Se.flags), ". ") + "Declarations: ".concat((hr = Se.declarations) === null || hr === void 0 ? void 0 : hr.map(function(Or) {
                var ki = e2.Debug.formatSyntaxKind(Or.kind), dt = e2.isInJSFile(Or), la = Or.expression;
                return (dt ? "[JS]" : "") + ki + (la ? " (expression: ".concat(e2.Debug.formatSyntaxKind(la.kind), ")") : "");
              }).join(", "), "."));
            }
            function Xt(Se, hr, Or) {
              var ki = hr.length;
              if (ki + Or > Se.length)
                return false;
              for (var dt = 0; dt < ki; dt++)
                if (hr.charCodeAt(dt) !== Se.charCodeAt(dt + Or))
                  return false;
              return true;
            }
            e2.stringContainsAt = Xt;
            function Za(Se) {
              return Se.charCodeAt(0) === 95;
            }
            e2.startsWithUnderscore = Za;
            function bn(Se) {
              return !_a4(Se);
            }
            e2.isGlobalDeclaration = bn;
            function _a4(Se) {
              var hr = Se.getSourceFile();
              return !hr.externalModuleIndicator && !hr.commonJsModuleIndicator ? false : e2.isInJSFile(Se) || !e2.findAncestor(Se, e2.isGlobalScopeAugmentation);
            }
            e2.isNonGlobalDeclaration = _a4;
            function qa(Se) {
              return !!(e2.getCombinedNodeFlagsAlwaysIncludeJSDoc(Se) & 8192);
            }
            e2.isDeprecatedDeclaration = qa;
            function rn(Se, hr) {
              var Or = e2.firstDefined(Se.imports, function(ki) {
                if (e2.JsTyping.nodeCoreModules.has(ki.text))
                  return e2.startsWith(ki.text, "node:");
              });
              return Or != null ? Or : hr.usesUriStyleNodeCoreModules;
            }
            e2.shouldUseUriStyleNodeCoreModules = rn;
            function jn(Se) {
              return Se === `
` ? 1 : 0;
            }
            e2.getNewLineKind = jn;
            function Mo(Se) {
              return e2.isArray(Se) ? e2.formatStringFromArgs(e2.getLocaleSpecificMessage(Se[0]), Se.slice(1)) : e2.getLocaleSpecificMessage(Se);
            }
            e2.diagnosticToString = Mo;
            function ho(Se, hr) {
              var Or = Se.options, ki = !Or.semicolons || Or.semicolons === e2.SemicolonPreference.Ignore, dt = Or.semicolons === e2.SemicolonPreference.Remove || ki && !ko(hr);
              return Ke(Ke({}, Or), { semicolons: dt ? e2.SemicolonPreference.Remove : e2.SemicolonPreference.Ignore });
            }
            e2.getFormatCodeSettingsForWriting = ho;
            function gs(Se) {
              return Se === 2 || Se === 3;
            }
            e2.jsxModeNeedsExplicitImport = gs;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(T) {
              T[T.Named = 0] = "Named", T[T.Default = 1] = "Default", T[T.Namespace = 2] = "Namespace", T[T.CommonJS = 3] = "CommonJS";
            })(a = e2.ImportKind || (e2.ImportKind = {}));
            var C;
            (function(T) {
              T[T.Named = 0] = "Named", T[T.Default = 1] = "Default", T[T.ExportEquals = 2] = "ExportEquals", T[T.UMD = 3] = "UMD";
            })(C = e2.ExportKind || (e2.ExportKind = {}));
            function w(T) {
              var K = 1, b = e2.createMultiMap(), se = new e2.Map(), J = new e2.Map(), ie, R = { isUsableByFile: function(x2) {
                return x2 === ie;
              }, isEmpty: function() {
                return !b.size;
              }, clear: function() {
                b.clear(), se.clear(), ie = void 0;
              }, add: function(x2, X, $, A2, y, V, L, P) {
                x2 !== ie && (R.clear(), ie = x2);
                var k;
                if (y) {
                  var Y = e2.getNodeModulePathParts(y.fileName);
                  if (Y) {
                    var U = Y.topLevelNodeModulesIndex, j = Y.topLevelPackageNameIndex, H = Y.packageRootIndex;
                    if (k = e2.unmangleScopedPackageName(e2.getPackageNameFromTypesPackageName(y.fileName.substring(j + 1, H))), e2.startsWith(x2, y.path.substring(0, U))) {
                      var I = J.get(k), l = y.fileName.substring(0, j + 1);
                      if (I) {
                        var d = I.indexOf(e2.nodeModulesPathPart);
                        U > d && J.set(k, l);
                      } else
                        J.set(k, l);
                    }
                  }
                }
                var D = V === 1, fe = D && e2.getLocalSymbolForExportDefault(X) || X, g = V === 0 || e2.isExternalModuleSymbol(fe) ? e2.unescapeLeadingUnderscores($) : e2.getNamesForExportedSymbol(fe, void 0), ne = typeof g == "string" ? g : g[0], ue = typeof g == "string" ? void 0 : g[1], We = e2.stripQuotes(A2.name), Fe = K++, Z2 = e2.skipAlias(X, P), Be = X.flags & 33554432 ? void 0 : X, ge = A2.flags & 33554432 ? void 0 : A2;
                (!Be || !ge) && se.set(Fe, [X, A2]), b.add(O(ne, X, e2.isExternalModuleNameRelative(We) ? void 0 : We, P), { id: Fe, symbolTableKey: $, symbolName: ne, capitalizedSymbolName: ue, moduleName: We, moduleFile: y, moduleFileName: y == null ? void 0 : y.fileName, packageName: k, exportKind: V, targetFlags: Z2.flags, isFromPackageJson: L, symbol: Be, moduleSymbol: ge });
              }, get: function(x2, X) {
                if (x2 === ie) {
                  var $ = b.get(X);
                  return $ == null ? void 0 : $.map(q);
                }
              }, search: function(x2, X, $, A2) {
                x2 === ie && b.forEach(function(y, V) {
                  var L = ve(V), P = L.symbolName, k = L.ambientModuleName, Y = X && y[0].capitalizedSymbolName || P;
                  if ($(Y, y[0].targetFlags)) {
                    var U = y.map(q), j = U.filter(function(H, I) {
                      return F2(H, y[I].packageName);
                    });
                    j.length && A2(j, Y, !!k, V);
                  }
                });
              }, releaseSymbols: function() {
                se.clear();
              }, onFileChanged: function(x2, X, $) {
                return ee(x2) && ee(X) ? false : ie && ie !== X.path || $ && e2.consumesNodeCoreModules(x2) !== e2.consumesNodeCoreModules(X) || !e2.arrayIsEqualTo(x2.moduleAugmentations, X.moduleAugmentations) || !he(x2, X) ? (R.clear(), true) : (ie = X.path, false);
              } };
              return e2.Debug.isDebugging && Object.defineProperty(R, "__cache", { get: function() {
                return b;
              } }), R;
              function q(x2) {
                if (x2.symbol && x2.moduleSymbol)
                  return x2;
                var X = x2.id, $ = x2.exportKind, A2 = x2.targetFlags, y = x2.isFromPackageJson, V = x2.moduleFileName, L = se.get(X) || e2.emptyArray, P = L[0], k = L[1];
                if (P && k)
                  return { symbol: P, moduleSymbol: k, moduleFileName: V, exportKind: $, targetFlags: A2, isFromPackageJson: y };
                var Y = (y ? T.getPackageJsonAutoImportProvider() : T.getCurrentProgram()).getTypeChecker(), U = x2.moduleSymbol || k || e2.Debug.checkDefined(x2.moduleFile ? Y.getMergedSymbol(x2.moduleFile.symbol) : Y.tryFindAmbientModule(x2.moduleName)), j = x2.symbol || P || e2.Debug.checkDefined($ === 2 ? Y.resolveExternalModuleSymbol(U) : Y.tryGetMemberInModuleExportsAndProperties(e2.unescapeLeadingUnderscores(x2.symbolTableKey), U), "Could not find symbol '".concat(x2.symbolName, "' by key '").concat(x2.symbolTableKey, "' in module ").concat(U.name));
                return se.set(X, [j, U]), { symbol: j, moduleSymbol: U, moduleFileName: V, exportKind: $, targetFlags: A2, isFromPackageJson: y };
              }
              function O(x2, X, $, A2) {
                var y = $ || "";
                return "".concat(x2, "|").concat(e2.getSymbolId(e2.skipAlias(X, A2)), "|").concat(y);
              }
              function ve(x2) {
                var X = x2.substring(0, x2.indexOf("|")), $ = x2.substring(x2.lastIndexOf("|") + 1), A2 = $ === "" ? void 0 : $;
                return { symbolName: X, ambientModuleName: A2 };
              }
              function ee(x2) {
                return !x2.commonJsModuleIndicator && !x2.externalModuleIndicator && !x2.moduleAugmentations && !x2.ambientModuleNames;
              }
              function he(x2, X) {
                if (!e2.arrayIsEqualTo(x2.ambientModuleNames, X.ambientModuleNames))
                  return false;
                for (var $ = -1, A2 = -1, y = function(Y) {
                  var U = function(j) {
                    return e2.isNonGlobalAmbientModule(j) && j.name.text === Y;
                  };
                  if ($ = e2.findIndex(x2.statements, U, $ + 1), A2 = e2.findIndex(X.statements, U, A2 + 1), x2.statements[$] !== X.statements[A2])
                    return { value: false };
                }, V = 0, L = X.ambientModuleNames; V < L.length; V++) {
                  var P = L[V], k = y(P);
                  if (typeof k == "object")
                    return k.value;
                }
                return true;
              }
              function F2(x2, X) {
                if (!X || !x2.moduleFileName)
                  return true;
                var $ = T.getGlobalTypingsCacheLocation();
                if ($ && e2.startsWith(x2.moduleFileName, $))
                  return true;
                var A2 = J.get(X);
                return !A2 || e2.startsWith(x2.moduleFileName, A2);
              }
            }
            e2.createCacheableExportInfoMap = w;
            function B(T, K, b, se, J, ie, R) {
              var q;
              if (K === b)
                return false;
              var O = R == null ? void 0 : R.get(K.path, b.path, se, {});
              if ((O == null ? void 0 : O.isBlockedByPackageJsonDependencies) !== void 0)
                return !O.isBlockedByPackageJsonDependencies;
              var ve = e2.hostGetCanonicalFileName(ie), ee = (q = ie.getGlobalTypingsCacheLocation) === null || q === void 0 ? void 0 : q.call(ie), he = !!e2.moduleSpecifiers.forEachFileNameOfModule(K.fileName, b.fileName, ie, false, function(x2) {
                var X = T.getSourceFile(x2);
                return (X === b || !X) && E(K.fileName, x2, ve, ee);
              });
              if (J) {
                var F2 = he && J.allowsImportingSourceFile(b, ie);
                return R == null || R.setBlockedByPackageJsonDependencies(K.path, b.path, se, {}, !F2), F2;
              }
              return he;
            }
            e2.isImportableFile = B;
            function E(T, K, b, se) {
              var J = e2.forEachAncestorDirectory(K, function(R) {
                return e2.getBaseFileName(R) === "node_modules" ? R : void 0;
              }), ie = J && e2.getDirectoryPath(b(J));
              return ie === void 0 || e2.startsWith(b(T), ie) || !!se && e2.startsWith(b(se), ie);
            }
            function Q(T, K, b, se) {
              var J, ie;
              le(T.getTypeChecker(), T.getSourceFiles(), function(O, ve) {
                return se(O, ve, T, false);
              });
              var R = b && ((J = K.getPackageJsonAutoImportProvider) === null || J === void 0 ? void 0 : J.call(K));
              if (R) {
                var q = e2.timestamp();
                le(R.getTypeChecker(), R.getSourceFiles(), function(O, ve) {
                  return se(O, ve, R, true);
                }), (ie = K.log) === null || ie === void 0 || ie.call(K, "forEachExternalModuleToImportFrom autoImportProvider: ".concat(e2.timestamp() - q));
              }
            }
            e2.forEachExternalModuleToImportFrom = Q;
            function le(T, K, b) {
              for (var se = 0, J = T.getAmbientModules(); se < J.length; se++) {
                var ie = J[se];
                e2.stringContains(ie.name, "*") || b(ie, void 0);
              }
              for (var R = 0, q = K; R < q.length; R++) {
                var O = q[R];
                e2.isExternalOrCommonJsModule(O) && b(T.getMergedSymbol(O.symbol), O);
              }
            }
            function N(T, K, b, se) {
              var J, ie, R, q, O, ve = e2.timestamp();
              (J = K.getPackageJsonAutoImportProvider) === null || J === void 0 || J.call(K);
              var ee = ((ie = K.getCachedExportInfoMap) === null || ie === void 0 ? void 0 : ie.call(K)) || w({ getCurrentProgram: function() {
                return b;
              }, getPackageJsonAutoImportProvider: function() {
                var x2;
                return (x2 = K.getPackageJsonAutoImportProvider) === null || x2 === void 0 ? void 0 : x2.call(K);
              }, getGlobalTypingsCacheLocation: function() {
                var x2;
                return (x2 = K.getGlobalTypingsCacheLocation) === null || x2 === void 0 ? void 0 : x2.call(K);
              } });
              if (ee.isUsableByFile(T.path))
                return (R = K.log) === null || R === void 0 || R.call(K, "getExportInfoMap: cache hit"), ee;
              (q = K.log) === null || q === void 0 || q.call(K, "getExportInfoMap: cache miss or empty; calculating new results");
              var he = b.getCompilerOptions(), F2 = 0;
              try {
                Q(b, K, true, function(x2, X, $, A2) {
                  ++F2 % 100 === 0 && (se == null || se.throwIfCancellationRequested());
                  var y = new e2.Map(), V = $.getTypeChecker(), L = p(x2, V, he);
                  L && m2(L.symbol, V) && ee.add(T.path, L.symbol, L.exportKind === 1 ? "default" : "export=", x2, X, L.exportKind, A2, V), V.forEachExportAndPropertyOfModule(x2, function(P, k) {
                    P !== (L == null ? void 0 : L.symbol) && m2(P, V) && e2.addToSeen(y, k) && ee.add(T.path, P, k, x2, X, 0, A2, V);
                  });
                });
              } catch (x2) {
                throw ee.clear(), x2;
              }
              return (O = K.log) === null || O === void 0 || O.call(K, "getExportInfoMap: done in ".concat(e2.timestamp() - ve, " ms")), ee;
            }
            e2.getExportInfoMap = N;
            function p(T, K, b) {
              var se = G(T, K);
              if (!!se) {
                var J = se.symbol, ie = se.exportKind, R = oe(J, K, b);
                return R && Ke({ symbol: J, exportKind: ie }, R);
              }
            }
            e2.getDefaultLikeExportInfo = p;
            function m2(T, K) {
              return !K.isUndefinedSymbol(T) && !K.isUnknownSymbol(T) && !e2.isKnownSymbol(T) && !e2.isPrivateIdentifierSymbol(T);
            }
            function G(T, K) {
              var b = K.resolveExternalModuleSymbol(T);
              if (b !== T)
                return { symbol: b, exportKind: 2 };
              var se = K.tryGetMemberInModuleExports("default", T);
              if (se)
                return { symbol: se, exportKind: 1 };
            }
            function oe(T, K, b) {
              var se = e2.getLocalSymbolForExportDefault(T);
              if (se)
                return { symbolForMeaning: se, name: se.name };
              var J = f4(T);
              if (J !== void 0)
                return { symbolForMeaning: T, name: J };
              if (T.flags & 2097152) {
                var ie = K.getImmediateAliasedSymbol(T);
                if (ie && ie.parent)
                  return oe(ie, K, b);
              }
              return T.escapedName !== "default" && T.escapedName !== "export=" ? { symbolForMeaning: T, name: T.getName() } : { symbolForMeaning: T, name: e2.getNameForExportedSymbol(T, b.target) };
            }
            function f4(T) {
              return T.declarations && e2.firstDefined(T.declarations, function(K) {
                var b;
                if (e2.isExportAssignment(K))
                  return (b = e2.tryCast(e2.skipOuterExpressions(K.expression), e2.isIdentifier)) === null || b === void 0 ? void 0 : b.text;
                if (e2.isExportSpecifier(K))
                  return e2.Debug.assert(K.name.text === "default", "Expected the specifier to be a default export"), K.propertyName && K.propertyName.text;
              });
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a() {
              var q = e2.createScanner(99, false);
              function O(ee, he, F2) {
                return E(ve(ee, he, F2), ee);
              }
              function ve(ee, he, F2) {
                var x2 = 0, X = 0, $ = [], A2 = N(he), y = A2.prefix, V = A2.pushTemplate;
                ee = y + ee;
                var L = y.length;
                V && $.push(15), q.setText(ee);
                var P = 0, k = [], Y = 0;
                do {
                  x2 = q.scan(), e2.isTrivia(x2) || (H(), X = x2);
                  var U = q.getTextPos();
                  if (B(q.getTokenPos(), U, L, G(x2), k), U >= ee.length) {
                    var j = w(q, x2, e2.lastOrUndefined($));
                    j !== void 0 && (P = j);
                  }
                } while (x2 !== 1);
                function H() {
                  switch (x2) {
                    case 43:
                    case 68:
                      !C[X] && q.reScanSlashToken() === 13 && (x2 = 13);
                      break;
                    case 29:
                      X === 79 && Y++;
                      break;
                    case 31:
                      Y > 0 && Y--;
                      break;
                    case 130:
                    case 150:
                    case 147:
                    case 133:
                    case 151:
                      Y > 0 && !F2 && (x2 = 79);
                      break;
                    case 15:
                      $.push(x2);
                      break;
                    case 18:
                      $.length > 0 && $.push(x2);
                      break;
                    case 19:
                      if ($.length > 0) {
                        var I = e2.lastOrUndefined($);
                        I === 15 ? (x2 = q.reScanTemplateToken(false), x2 === 17 ? $.pop() : e2.Debug.assertEqual(x2, 16, "Should have been a template middle.")) : (e2.Debug.assertEqual(I, 18, "Should have been an open brace"), $.pop());
                      }
                      break;
                    default:
                      if (!e2.isKeyword(x2))
                        break;
                      (X === 24 || e2.isKeyword(X) && e2.isKeyword(x2) && !le(X, x2)) && (x2 = 79);
                  }
                }
                return { endOfLineState: P, spans: k };
              }
              return { getClassificationsForLine: O, getEncodedLexicalClassifications: ve };
            }
            e2.createClassifier = a;
            var C = e2.arrayToNumericMap([79, 10, 8, 9, 13, 108, 45, 46, 21, 23, 19, 110, 95], function(q) {
              return q;
            }, function() {
              return true;
            });
            function w(q, O, ve) {
              switch (O) {
                case 10: {
                  if (!q.isUnterminated())
                    return;
                  for (var ee = q.getTokenText(), he = ee.length - 1, F2 = 0; ee.charCodeAt(he - F2) === 92; )
                    F2++;
                  return (F2 & 1) === 0 ? void 0 : ee.charCodeAt(0) === 34 ? 3 : 2;
                }
                case 3:
                  return q.isUnterminated() ? 1 : void 0;
                default:
                  if (e2.isTemplateLiteralKind(O)) {
                    if (!q.isUnterminated())
                      return;
                    switch (O) {
                      case 17:
                        return 5;
                      case 14:
                        return 4;
                      default:
                        return e2.Debug.fail("Only 'NoSubstitutionTemplateLiteral's and 'TemplateTail's can be unterminated; got SyntaxKind #" + O);
                    }
                  }
                  return ve === 15 ? 6 : void 0;
              }
            }
            function B(q, O, ve, ee, he) {
              if (ee !== 8) {
                q === 0 && ve > 0 && (q += ve);
                var F2 = O - q;
                F2 > 0 && he.push(q - ve, F2, ee);
              }
            }
            function E(q, O) {
              for (var ve = [], ee = q.spans, he = 0, F2 = 0; F2 < ee.length; F2 += 3) {
                var x2 = ee[F2], X = ee[F2 + 1], $ = ee[F2 + 2];
                if (he >= 0) {
                  var A2 = x2 - he;
                  A2 > 0 && ve.push({ length: A2, classification: e2.TokenClass.Whitespace });
                }
                ve.push({ length: X, classification: Q($) }), he = x2 + X;
              }
              var y = O.length - he;
              return y > 0 && ve.push({ length: y, classification: e2.TokenClass.Whitespace }), { entries: ve, finalLexState: q.endOfLineState };
            }
            function Q(q) {
              switch (q) {
                case 1:
                  return e2.TokenClass.Comment;
                case 3:
                  return e2.TokenClass.Keyword;
                case 4:
                  return e2.TokenClass.NumberLiteral;
                case 25:
                  return e2.TokenClass.BigIntLiteral;
                case 5:
                  return e2.TokenClass.Operator;
                case 6:
                  return e2.TokenClass.StringLiteral;
                case 8:
                  return e2.TokenClass.Whitespace;
                case 10:
                  return e2.TokenClass.Punctuation;
                case 2:
                case 11:
                case 12:
                case 13:
                case 14:
                case 15:
                case 16:
                case 9:
                case 17:
                  return e2.TokenClass.Identifier;
                default:
                  return;
              }
            }
            function le(q, O) {
              if (!e2.isAccessibilityModifier(q))
                return true;
              switch (O) {
                case 136:
                case 149:
                case 134:
                case 124:
                  return true;
                default:
                  return false;
              }
            }
            function N(q) {
              switch (q) {
                case 3:
                  return { prefix: `"\\
` };
                case 2:
                  return { prefix: `'\\
` };
                case 1:
                  return { prefix: `/*
` };
                case 4:
                  return { prefix: "`\n" };
                case 5:
                  return { prefix: `}
`, pushTemplate: true };
                case 6:
                  return { prefix: "", pushTemplate: true };
                case 0:
                  return { prefix: "" };
                default:
                  return e2.Debug.assertNever(q);
              }
            }
            function p(q) {
              switch (q) {
                case 41:
                case 43:
                case 44:
                case 39:
                case 40:
                case 47:
                case 48:
                case 49:
                case 29:
                case 31:
                case 32:
                case 33:
                case 102:
                case 101:
                case 127:
                case 34:
                case 35:
                case 36:
                case 37:
                case 50:
                case 52:
                case 51:
                case 55:
                case 56:
                case 74:
                case 73:
                case 78:
                case 70:
                case 71:
                case 72:
                case 64:
                case 65:
                case 66:
                case 68:
                case 69:
                case 63:
                case 27:
                case 60:
                case 75:
                case 76:
                case 77:
                  return true;
                default:
                  return false;
              }
            }
            function m2(q) {
              switch (q) {
                case 39:
                case 40:
                case 54:
                case 53:
                case 45:
                case 46:
                  return true;
                default:
                  return false;
              }
            }
            function G(q) {
              if (e2.isKeyword(q))
                return 3;
              if (p(q) || m2(q))
                return 5;
              if (q >= 18 && q <= 78)
                return 10;
              switch (q) {
                case 8:
                  return 4;
                case 9:
                  return 25;
                case 10:
                  return 6;
                case 13:
                  return 7;
                case 7:
                case 3:
                case 2:
                  return 1;
                case 5:
                case 4:
                  return 8;
                case 79:
                default:
                  return e2.isTemplateLiteralKind(q) ? 6 : 2;
              }
            }
            function oe(q, O, ve, ee, he) {
              return J(T(q, O, ve, ee, he));
            }
            e2.getSemanticClassifications = oe;
            function f4(q, O) {
              switch (O) {
                case 261:
                case 257:
                case 258:
                case 256:
                case 226:
                case 213:
                case 214:
                  q.throwIfCancellationRequested();
              }
            }
            function T(q, O, ve, ee, he) {
              var F2 = [];
              return ve.forEachChild(function X($) {
                if (!(!$ || !e2.textSpanIntersectsWith(he, $.pos, $.getFullWidth()))) {
                  if (f4(O, $.kind), e2.isIdentifier($) && !e2.nodeIsMissing($) && ee.has($.escapedText)) {
                    var A2 = q.getSymbolAtLocation($), y = A2 && K(A2, e2.getMeaningFromLocation($), q);
                    y && x2($.getStart(ve), $.getEnd(), y);
                  }
                  $.forEachChild(X);
                }
              }), { spans: F2, endOfLineState: 0 };
              function x2(X, $, A2) {
                var y = $ - X;
                e2.Debug.assert(y > 0, "Classification had non-positive length of ".concat(y)), F2.push(X), F2.push(y), F2.push(A2);
              }
            }
            e2.getEncodedSemanticClassifications = T;
            function K(q, O, ve) {
              var ee = q.getFlags();
              if ((ee & 2885600) !== 0)
                return ee & 32 ? 11 : ee & 384 ? 12 : ee & 524288 ? 16 : ee & 1536 ? O & 4 || O & 1 && b(q) ? 14 : void 0 : ee & 2097152 ? K(ve.getAliasedSymbol(q), O, ve) : O & 2 ? ee & 64 ? 13 : ee & 262144 ? 15 : void 0 : void 0;
            }
            function b(q) {
              return e2.some(q.declarations, function(O) {
                return e2.isModuleDeclaration(O) && e2.getModuleInstanceState(O) === 1;
              });
            }
            function se(q) {
              switch (q) {
                case 1:
                  return "comment";
                case 2:
                  return "identifier";
                case 3:
                  return "keyword";
                case 4:
                  return "number";
                case 25:
                  return "bigint";
                case 5:
                  return "operator";
                case 6:
                  return "string";
                case 8:
                  return "whitespace";
                case 9:
                  return "text";
                case 10:
                  return "punctuation";
                case 11:
                  return "class name";
                case 12:
                  return "enum name";
                case 13:
                  return "interface name";
                case 14:
                  return "module name";
                case 15:
                  return "type parameter name";
                case 16:
                  return "type alias name";
                case 17:
                  return "parameter name";
                case 18:
                  return "doc comment tag name";
                case 19:
                  return "jsx open tag name";
                case 20:
                  return "jsx close tag name";
                case 21:
                  return "jsx self closing tag name";
                case 22:
                  return "jsx attribute";
                case 23:
                  return "jsx text";
                case 24:
                  return "jsx attribute string literal value";
                default:
                  return;
              }
            }
            function J(q) {
              e2.Debug.assert(q.spans.length % 3 === 0);
              for (var O = q.spans, ve = [], ee = 0; ee < O.length; ee += 3)
                ve.push({ textSpan: e2.createTextSpan(O[ee], O[ee + 1]), classificationType: se(O[ee + 2]) });
              return ve;
            }
            function ie(q, O, ve) {
              return J(R(q, O, ve));
            }
            e2.getSyntacticClassifications = ie;
            function R(q, O, ve) {
              var ee = ve.start, he = ve.length, F2 = e2.createScanner(99, false, O.languageVariant, O.text), x2 = e2.createScanner(99, false, O.languageVariant, O.text), X = [];
              return l(O), { spans: X, endOfLineState: 0 };
              function $(d, D, fe) {
                X.push(d), X.push(D), X.push(fe);
              }
              function A2(d) {
                for (F2.setTextPos(d.pos); ; ) {
                  var D = F2.getTextPos();
                  if (!e2.couldStartTrivia(O.text, D))
                    return D;
                  var fe = F2.scan(), g = F2.getTextPos(), ne = g - D;
                  if (!e2.isTrivia(fe))
                    return D;
                  switch (fe) {
                    case 4:
                    case 5:
                      continue;
                    case 2:
                    case 3:
                      y(d, fe, D, ne), F2.setTextPos(g);
                      continue;
                    case 7:
                      var ue = O.text, We = ue.charCodeAt(D);
                      if (We === 60 || We === 62) {
                        $(D, ne, 1);
                        continue;
                      }
                      e2.Debug.assert(We === 124 || We === 61), Y(ue, D, g);
                      break;
                    case 6:
                      break;
                    default:
                      e2.Debug.assertNever(fe);
                  }
                }
              }
              function y(d, D, fe, g) {
                if (D === 3) {
                  var ne = e2.parseIsolatedJSDocComment(O.text, fe, g);
                  if (ne && ne.jsDoc) {
                    e2.setParent(ne.jsDoc, d), L(ne.jsDoc);
                    return;
                  }
                } else if (D === 2 && P(fe, g))
                  return;
                V(fe, g);
              }
              function V(d, D) {
                $(d, D, 1);
              }
              function L(d) {
                var D, fe, g, ne, ue, We, Fe, Z2 = d.pos;
                if (d.tags)
                  for (var Be = 0, ge = d.tags; Be < ge.length; Be++) {
                    var Re = ge[Be];
                    Re.pos !== Z2 && V(Z2, Re.pos - Z2), $(Re.pos, 1, 10), $(Re.tagName.pos, Re.tagName.end - Re.tagName.pos, 18), Z2 = Re.tagName.end;
                    var ze = Re.tagName.end;
                    switch (Re.kind) {
                      case 340:
                        var Ee = Re;
                        Ie(Ee), ze = Ee.isNameFirst && ((D = Ee.typeExpression) === null || D === void 0 ? void 0 : D.end) || Ee.name.end;
                        break;
                      case 347:
                        var He = Re;
                        ze = He.isNameFirst && ((fe = He.typeExpression) === null || fe === void 0 ? void 0 : fe.end) || He.name.end;
                        break;
                      case 344:
                        k(Re), Z2 = Re.end, ze = Re.typeParameters.end;
                        break;
                      case 345:
                        var rr = Re;
                        ze = ((g = rr.typeExpression) === null || g === void 0 ? void 0 : g.kind) === 309 && ((ne = rr.fullName) === null || ne === void 0 ? void 0 : ne.end) || ((ue = rr.typeExpression) === null || ue === void 0 ? void 0 : ue.end) || ze;
                        break;
                      case 338:
                        ze = Re.typeExpression.end;
                        break;
                      case 343:
                        l(Re.typeExpression), Z2 = Re.end, ze = Re.typeExpression.end;
                        break;
                      case 342:
                      case 339:
                        ze = Re.typeExpression.end;
                        break;
                      case 341:
                        l(Re.typeExpression), Z2 = Re.end, ze = ((We = Re.typeExpression) === null || We === void 0 ? void 0 : We.end) || ze;
                        break;
                      case 346:
                        ze = ((Fe = Re.name) === null || Fe === void 0 ? void 0 : Fe.end) || ze;
                        break;
                      case 328:
                      case 329:
                        ze = Re.class.end;
                        break;
                    }
                    typeof Re.comment == "object" ? V(Re.comment.pos, Re.comment.end - Re.comment.pos) : typeof Re.comment == "string" && V(ze, Re.end - ze);
                  }
                Z2 !== d.end && V(Z2, d.end - Z2);
                return;
                function Ie(_e) {
                  _e.isNameFirst && (V(Z2, _e.name.pos - Z2), $(_e.name.pos, _e.name.end - _e.name.pos, 17), Z2 = _e.name.end), _e.typeExpression && (V(Z2, _e.typeExpression.pos - Z2), l(_e.typeExpression), Z2 = _e.typeExpression.end), _e.isNameFirst || (V(Z2, _e.name.pos - Z2), $(_e.name.pos, _e.name.end - _e.name.pos, 17), Z2 = _e.name.end);
                }
              }
              function P(d, D) {
                var fe = /^(\/\/\/\s*)(<)(?:(\S+)((?:[^/]|\/[^>])*)(\/>)?)?/im, g = /(\s)(\S+)(\s*)(=)(\s*)('[^']+'|"[^"]+")/img, ne = O.text.substr(d, D), ue = fe.exec(ne);
                if (!ue || !ue[3] || !(ue[3] in e2.commentPragmas))
                  return false;
                var We = d;
                V(We, ue[1].length), We += ue[1].length, $(We, ue[2].length, 10), We += ue[2].length, $(We, ue[3].length, 21), We += ue[3].length;
                for (var Fe = ue[4], Z2 = We; ; ) {
                  var Be = g.exec(Fe);
                  if (!Be)
                    break;
                  var ge = We + Be.index + Be[1].length;
                  ge > Z2 && (V(Z2, ge - Z2), Z2 = ge), $(Z2, Be[2].length, 22), Z2 += Be[2].length, Be[3].length && (V(Z2, Be[3].length), Z2 += Be[3].length), $(Z2, Be[4].length, 5), Z2 += Be[4].length, Be[5].length && (V(Z2, Be[5].length), Z2 += Be[5].length), $(Z2, Be[6].length, 24), Z2 += Be[6].length;
                }
                We += ue[4].length, We > Z2 && V(Z2, We - Z2), ue[5] && ($(We, ue[5].length, 10), We += ue[5].length);
                var Re = d + D;
                return We < Re && V(We, Re - We), true;
              }
              function k(d) {
                for (var D = 0, fe = d.getChildren(); D < fe.length; D++) {
                  var g = fe[D];
                  l(g);
                }
              }
              function Y(d, D, fe) {
                var g;
                for (g = D; g < fe && !e2.isLineBreak(d.charCodeAt(g)); g++)
                  ;
                for ($(D, g - D, 1), x2.setTextPos(g); x2.getTextPos() < fe; )
                  U();
              }
              function U() {
                var d = x2.getTextPos(), D = x2.scan(), fe = x2.getTextPos(), g = I(D);
                g && $(d, fe - d, g);
              }
              function j(d) {
                if (e2.isJSDoc(d) || e2.nodeIsMissing(d))
                  return true;
                var D = H(d);
                if (!e2.isToken(d) && d.kind !== 11 && D === void 0)
                  return false;
                var fe = d.kind === 11 ? d.pos : A2(d), g = d.end - fe;
                if (e2.Debug.assert(g >= 0), g > 0) {
                  var ne = D || I(d.kind, d);
                  ne && $(fe, g, ne);
                }
                return true;
              }
              function H(d) {
                switch (d.parent && d.parent.kind) {
                  case 280:
                    if (d.parent.tagName === d)
                      return 19;
                    break;
                  case 281:
                    if (d.parent.tagName === d)
                      return 20;
                    break;
                  case 279:
                    if (d.parent.tagName === d)
                      return 21;
                    break;
                  case 285:
                    if (d.parent.name === d)
                      return 22;
                    break;
                }
              }
              function I(d, D) {
                if (e2.isKeyword(d))
                  return 3;
                if ((d === 29 || d === 31) && D && e2.getTypeArgumentOrTypeParameterList(D.parent))
                  return 10;
                if (e2.isPunctuation(d)) {
                  if (D) {
                    var fe = D.parent;
                    if (d === 63 && (fe.kind === 254 || fe.kind === 167 || fe.kind === 164 || fe.kind === 285) || fe.kind === 221 || fe.kind === 219 || fe.kind === 220 || fe.kind === 222)
                      return 5;
                  }
                  return 10;
                } else {
                  if (d === 8)
                    return 4;
                  if (d === 9)
                    return 25;
                  if (d === 10)
                    return D && D.parent.kind === 285 ? 24 : 6;
                  if (d === 13)
                    return 6;
                  if (e2.isTemplateLiteralKind(d))
                    return 6;
                  if (d === 11)
                    return 23;
                  if (d === 79) {
                    if (D) {
                      switch (D.parent.kind) {
                        case 257:
                          return D.parent.name === D ? 11 : void 0;
                        case 163:
                          return D.parent.name === D ? 15 : void 0;
                        case 258:
                          return D.parent.name === D ? 13 : void 0;
                        case 260:
                          return D.parent.name === D ? 12 : void 0;
                        case 261:
                          return D.parent.name === D ? 14 : void 0;
                        case 164:
                          return D.parent.name === D ? e2.isThisIdentifier(D) ? 3 : 17 : void 0;
                      }
                      if (e2.isConstTypeReference(D.parent))
                        return 3;
                    }
                    return 2;
                  }
                }
              }
              function l(d) {
                if (!!d && e2.decodedTextSpanIntersectsWith(ee, he, d.pos, d.getFullWidth())) {
                  f4(q, d.kind);
                  for (var D = 0, fe = d.getChildren(O); D < fe.length; D++) {
                    var g = fe[D];
                    j(g) || l(g);
                  }
                }
              }
            }
            e2.getEncodedSyntacticClassifications = R;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E;
                (function(R) {
                  R[R.typeOffset = 8] = "typeOffset", R[R.modifierMask = 255] = "modifierMask";
                })(E = B.TokenEncodingConsts || (B.TokenEncodingConsts = {}));
                var Q;
                (function(R) {
                  R[R.class = 0] = "class", R[R.enum = 1] = "enum", R[R.interface = 2] = "interface", R[R.namespace = 3] = "namespace", R[R.typeParameter = 4] = "typeParameter", R[R.type = 5] = "type", R[R.parameter = 6] = "parameter", R[R.variable = 7] = "variable", R[R.enumMember = 8] = "enumMember", R[R.property = 9] = "property", R[R.function = 10] = "function", R[R.member = 11] = "member";
                })(Q = B.TokenType || (B.TokenType = {}));
                var le;
                (function(R) {
                  R[R.declaration = 0] = "declaration", R[R.static = 1] = "static", R[R.async = 2] = "async", R[R.readonly = 3] = "readonly", R[R.defaultLibrary = 4] = "defaultLibrary", R[R.local = 5] = "local";
                })(le = B.TokenModifier || (B.TokenModifier = {}));
                function N(R, q, O, ve) {
                  var ee = p(R, q, O, ve);
                  e2.Debug.assert(ee.spans.length % 3 === 0);
                  for (var he = ee.spans, F2 = [], x2 = 0; x2 < he.length; x2 += 3)
                    F2.push({ textSpan: e2.createTextSpan(he[x2], he[x2 + 1]), classificationType: he[x2 + 2] });
                  return F2;
                }
                B.getSemanticClassifications = N;
                function p(R, q, O, ve) {
                  return { spans: m2(R, O, ve, q), endOfLineState: 0 };
                }
                B.getEncodedSemanticClassifications = p;
                function m2(R, q, O, ve) {
                  var ee = [], he = function(F2, x2, X) {
                    ee.push(F2.getStart(q), F2.getWidth(q), (x2 + 1 << 8) + X);
                  };
                  return R && q && G(R, q, O, he, ve), ee;
                }
                function G(R, q, O, ve, ee) {
                  var he = R.getTypeChecker(), F2 = false;
                  function x2(X) {
                    switch (X.kind) {
                      case 261:
                      case 257:
                      case 258:
                      case 256:
                      case 226:
                      case 213:
                      case 214:
                        ee.throwIfCancellationRequested();
                    }
                    if (!(!X || !e2.textSpanIntersectsWith(O, X.pos, X.getFullWidth()) || X.getFullWidth() === 0)) {
                      var $ = F2;
                      if ((e2.isJsxElement(X) || e2.isJsxSelfClosingElement(X)) && (F2 = true), e2.isJsxExpression(X) && (F2 = false), e2.isIdentifier(X) && !F2 && !b(X) && !e2.isInfinityOrNaNString(X.escapedText)) {
                        var A2 = he.getSymbolAtLocation(X);
                        if (A2) {
                          A2.flags & 2097152 && (A2 = he.getAliasedSymbol(A2));
                          var y = oe(A2, e2.getMeaningFromLocation(X));
                          if (y !== void 0) {
                            var V = 0;
                            if (X.parent) {
                              var L = e2.isBindingElement(X.parent) || ie.get(X.parent.kind) === y;
                              L && X.parent.name === X && (V = 1 << 0);
                            }
                            y === 6 && J(X) && (y = 9), y = f4(he, X, y);
                            var P = A2.valueDeclaration;
                            if (P) {
                              var k = e2.getCombinedModifierFlags(P), Y = e2.getCombinedNodeFlags(P);
                              k & 32 && (V |= 1 << 1), k & 256 && (V |= 1 << 2), y !== 0 && y !== 2 && (k & 64 || Y & 2 || A2.getFlags() & 8) && (V |= 1 << 3), (y === 7 || y === 10) && T(P, q) && (V |= 1 << 5), R.isSourceFileDefaultLibrary(P.getSourceFile()) && (V |= 1 << 4);
                            } else
                              A2.declarations && A2.declarations.some(function(U) {
                                return R.isSourceFileDefaultLibrary(U.getSourceFile());
                              }) && (V |= 1 << 4);
                            ve(X, y, V);
                          }
                        }
                      }
                      e2.forEachChild(X, x2), F2 = $;
                    }
                  }
                  x2(q);
                }
                function oe(R, q) {
                  var O = R.getFlags();
                  if (O & 32)
                    return 0;
                  if (O & 384)
                    return 1;
                  if (O & 524288)
                    return 5;
                  if (O & 64) {
                    if (q & 2)
                      return 2;
                  } else if (O & 262144)
                    return 4;
                  var ve = R.valueDeclaration || R.declarations && R.declarations[0];
                  return ve && e2.isBindingElement(ve) && (ve = K(ve)), ve && ie.get(ve.kind);
                }
                function f4(R, q, O) {
                  if (O === 7 || O === 9 || O === 6) {
                    var ve = R.getTypeAtLocation(q);
                    if (ve) {
                      var ee = function(he) {
                        return he(ve) || ve.isUnion() && ve.types.some(he);
                      };
                      if (O !== 6 && ee(function(he) {
                        return he.getConstructSignatures().length > 0;
                      }))
                        return 0;
                      if (ee(function(he) {
                        return he.getCallSignatures().length > 0;
                      }) && !ee(function(he) {
                        return he.getProperties().length > 0;
                      }) || se(q))
                        return O === 9 ? 11 : 10;
                    }
                  }
                  return O;
                }
                function T(R, q) {
                  return e2.isBindingElement(R) && (R = K(R)), e2.isVariableDeclaration(R) ? (!e2.isSourceFile(R.parent.parent.parent) || e2.isCatchClause(R.parent)) && R.getSourceFile() === q : e2.isFunctionDeclaration(R) ? !e2.isSourceFile(R.parent) && R.getSourceFile() === q : false;
                }
                function K(R) {
                  for (; ; )
                    if (e2.isBindingElement(R.parent.parent))
                      R = R.parent.parent;
                    else
                      return R.parent.parent;
                }
                function b(R) {
                  var q = R.parent;
                  return q && (e2.isImportClause(q) || e2.isImportSpecifier(q) || e2.isNamespaceImport(q));
                }
                function se(R) {
                  for (; J(R); )
                    R = R.parent;
                  return e2.isCallExpression(R.parent) && R.parent.expression === R;
                }
                function J(R) {
                  return e2.isQualifiedName(R.parent) && R.parent.right === R || e2.isPropertyAccessExpression(R.parent) && R.parent.name === R;
                }
                var ie = new e2.Map([[254, 7], [164, 6], [167, 9], [261, 3], [260, 1], [299, 8], [257, 0], [169, 11], [256, 10], [213, 10], [168, 11], [172, 9], [173, 9], [166, 9], [258, 2], [259, 5], [163, 4], [296, 9], [297, 9]]);
              })(w = C.v2020 || (C.v2020 = {}));
            })(a = e2.classifier || (e2.classifier = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                function E(Z2, Be, ge, Re, ze, Ee, He, rr) {
                  if (e2.isInReferenceComment(Z2, Be)) {
                    var Ie = l(Z2, Be, Re, ze);
                    return Ie && p(Ie);
                  }
                  if (e2.isInString(Z2, Be, ge)) {
                    if (!ge || !e2.isStringLiteralLike(ge))
                      return;
                    var Ie = oe(Z2, ge, Be, Ee.getTypeChecker(), Re, ze, rr);
                    return Q(Ie, ge, Z2, ze, Ee, He, Re, rr);
                  }
                }
                B.getStringLiteralCompletions = E;
                function Q(Z2, Be, ge, Re, ze, Ee, He, rr) {
                  if (Z2 !== void 0) {
                    var Ie = e2.createTextSpanFromStringLiteralLikeContent(Be);
                    switch (Z2.kind) {
                      case 0:
                        return p(Z2.paths);
                      case 1: {
                        var _e = e2.createSortedArray();
                        return C.getCompletionEntriesFromSymbols(Z2.symbols, _e, Be, Be, ge, ge, Re, ze, 99, Ee, 4, rr, He, void 0), { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: Z2.hasIndexSignature, optionalReplacementSpan: Ie, entries: _e };
                      }
                      case 2: {
                        var _e = Z2.types.map(function(de) {
                          return { name: de.value, kindModifiers: "", kind: "string", sortText: C.SortText.LocationPriority, replacementSpan: e2.getReplacementSpanForContextToken(Be) };
                        });
                        return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: Z2.isNewIdentifier, optionalReplacementSpan: Ie, entries: _e };
                      }
                      default:
                        return e2.Debug.assertNever(Z2);
                    }
                  }
                }
                function le(Z2, Be, ge, Re, ze, Ee, He, rr, Ie) {
                  if (!(!Re || !e2.isStringLiteralLike(Re))) {
                    var _e = oe(Be, Re, ge, ze, Ee, He, Ie);
                    return _e && N(Z2, Re, _e, Be, ze, rr);
                  }
                }
                B.getStringLiteralCompletionDetails = le;
                function N(Z2, Be, ge, Re, ze, Ee) {
                  switch (ge.kind) {
                    case 0: {
                      var He = e2.find(ge.paths, function(rr) {
                        return rr.name === Z2;
                      });
                      return He && C.createCompletionDetails(Z2, m2(He.extension), He.kind, [e2.textPart(Z2)]);
                    }
                    case 1: {
                      var He = e2.find(ge.symbols, function(Ie) {
                        return Ie.name === Z2;
                      });
                      return He && C.createCompletionDetailsForSymbol(He, ze, Re, Be, Ee);
                    }
                    case 2:
                      return e2.find(ge.types, function(rr) {
                        return rr.value === Z2;
                      }) ? C.createCompletionDetails(Z2, "", "type", [e2.textPart(Z2)]) : void 0;
                    default:
                      return e2.Debug.assertNever(ge);
                  }
                }
                function p(Z2) {
                  var Be = false, ge = true, Re = Z2.map(function(ze) {
                    var Ee = ze.name, He = ze.kind, rr = ze.span, Ie = ze.extension;
                    return { name: Ee, kind: He, kindModifiers: m2(Ie), sortText: C.SortText.LocationPriority, replacementSpan: rr };
                  });
                  return { isGlobalCompletion: Be, isMemberCompletion: false, isNewIdentifierLocation: ge, entries: Re };
                }
                function m2(Z2) {
                  switch (Z2) {
                    case ".d.ts":
                      return ".d.ts";
                    case ".js":
                      return ".js";
                    case ".json":
                      return ".json";
                    case ".jsx":
                      return ".jsx";
                    case ".ts":
                      return ".ts";
                    case ".tsx":
                      return ".tsx";
                    case ".d.mts":
                      return ".d.mts";
                    case ".mjs":
                      return ".mjs";
                    case ".mts":
                      return ".mts";
                    case ".d.cts":
                      return ".d.cts";
                    case ".cjs":
                      return ".cjs";
                    case ".cts":
                      return ".cts";
                    case ".tsbuildinfo":
                      return e2.Debug.fail("Extension ".concat(".tsbuildinfo", " is unsupported."));
                    case void 0:
                      return "";
                    default:
                      return e2.Debug.assertNever(Z2);
                  }
                }
                var G;
                (function(Z2) {
                  Z2[Z2.Paths = 0] = "Paths", Z2[Z2.Properties = 1] = "Properties", Z2[Z2.Types = 2] = "Types";
                })(G || (G = {}));
                function oe(Z2, Be, ge, Re, ze, Ee, He) {
                  var rr = f4(Be.parent);
                  switch (rr.kind) {
                    case 196: {
                      var Ie = f4(rr.parent);
                      switch (Ie.kind) {
                        case 178: {
                          var _e = Ie, we = e2.findAncestor(rr, function(n) {
                            return n.parent === _e;
                          });
                          return we ? { kind: 2, types: J(Re.getTypeArgumentConstraint(we)), isNewIdentifier: false } : void 0;
                        }
                        case 194:
                          var de = Ie, ye = de.indexType, Ae = de.objectType;
                          return e2.rangeContainsPosition(ye, ge) ? b(Re.getTypeFromTypeNode(Ae)) : void 0;
                        case 200:
                          return { kind: 0, paths: O(Z2, Be, ze, Ee, Re, He) };
                        case 187: {
                          if (!e2.isTypeReferenceNode(Ie.parent))
                            return;
                          var er = T(Ie, rr), ir = J(Re.getTypeArgumentConstraint(Ie)).filter(function(n) {
                            return !e2.contains(er, n.value);
                          });
                          return { kind: 2, types: ir, isNewIdentifier: false };
                        }
                        default:
                          return;
                      }
                    }
                    case 296:
                      return e2.isObjectLiteralExpression(rr.parent) && rr.name === Be ? se(Re, rr.parent) : Ne();
                    case 207: {
                      var Cr = rr, Ye = Cr.expression, Br = Cr.argumentExpression;
                      return Be === e2.skipParentheses(Br) ? b(Re.getTypeAtLocation(Ye)) : void 0;
                    }
                    case 208:
                    case 209:
                    case 285:
                      if (!Fe(Be) && !e2.isImportCall(rr)) {
                        var Er = e2.SignatureHelp.getArgumentInfoForCompletions(rr.kind === 285 ? rr.parent : Be, ge, Z2);
                        return Er ? K(Er.invocation, Be, Er, Re) : Ne();
                      }
                    case 266:
                    case 272:
                    case 277:
                      return { kind: 0, paths: O(Z2, Be, ze, Ee, Re, He) };
                    default:
                      return Ne();
                  }
                  function Ne() {
                    return { kind: 2, types: J(e2.getContextualTypeFromParent(Be, Re)), isNewIdentifier: false };
                  }
                }
                function f4(Z2) {
                  switch (Z2.kind) {
                    case 191:
                      return e2.walkUpParenthesizedTypes(Z2);
                    case 212:
                      return e2.walkUpParenthesizedExpressions(Z2);
                    default:
                      return Z2;
                  }
                }
                function T(Z2, Be) {
                  return e2.mapDefined(Z2.types, function(ge) {
                    return ge !== Be && e2.isLiteralTypeNode(ge) && e2.isStringLiteral(ge.literal) ? ge.literal.text : void 0;
                  });
                }
                function K(Z2, Be, ge, Re) {
                  var ze = false, Ee = new e2.Map(), He = [], rr = e2.isJsxOpeningLikeElement(Z2) ? e2.Debug.checkDefined(e2.findAncestor(Be.parent, e2.isJsxAttribute)) : Be;
                  Re.getResolvedSignatureForStringLiteralCompletions(Z2, rr, He);
                  var Ie = e2.flatMap(He, function(_e) {
                    if (!(!e2.signatureHasRestParameter(_e) && ge.argumentCount > _e.parameters.length)) {
                      var we = _e.getTypeParameterAtPosition(ge.argumentIndex);
                      if (e2.isJsxOpeningLikeElement(Z2)) {
                        var de = Re.getTypeOfPropertyOfType(we, rr.name.text);
                        de && (we = de);
                      }
                      return ze = ze || !!(we.flags & 4), J(we, Ee);
                    }
                  });
                  return { kind: 2, types: Ie, isNewIdentifier: ze };
                }
                function b(Z2) {
                  return Z2 && { kind: 1, symbols: e2.filter(Z2.getApparentProperties(), function(Be) {
                    return !(Be.valueDeclaration && e2.isPrivateIdentifierClassElementDeclaration(Be.valueDeclaration));
                  }), hasIndexSignature: e2.hasIndexSignature(Z2) };
                }
                function se(Z2, Be) {
                  var ge = Z2.getContextualType(Be);
                  if (!!ge) {
                    var Re = Z2.getContextualType(Be, 4), ze = C.getPropertiesForObjectExpression(ge, Re, Be, Z2);
                    return { kind: 1, symbols: ze, hasIndexSignature: e2.hasIndexSignature(ge) };
                  }
                }
                function J(Z2, Be) {
                  return Be === void 0 && (Be = new e2.Map()), Z2 ? (Z2 = e2.skipConstraint(Z2), Z2.isUnion() ? e2.flatMap(Z2.types, function(ge) {
                    return J(ge, Be);
                  }) : Z2.isStringLiteral() && !(Z2.flags & 1024) && e2.addToSeen(Be, Z2.value) ? [Z2] : e2.emptyArray) : e2.emptyArray;
                }
                function ie(Z2, Be, ge) {
                  return { name: Z2, kind: Be, extension: ge };
                }
                function R(Z2) {
                  return ie(Z2, "directory", void 0);
                }
                function q(Z2, Be, ge) {
                  var Re = fe(Z2, Be), ze = Z2.length === 0 ? void 0 : e2.createTextSpan(Be, Z2.length);
                  return ge.map(function(Ee) {
                    var He = Ee.name, rr = Ee.kind, Ie = Ee.extension;
                    return Math.max(He.indexOf(e2.directorySeparator), He.indexOf(e2.altDirectorySeparator)) !== -1 ? { name: He, kind: rr, extension: Ie, span: ze } : { name: He, kind: rr, extension: Ie, span: Re };
                  });
                }
                function O(Z2, Be, ge, Re, ze, Ee) {
                  return q(Be.text, Be.getStart(Z2) + 1, ve(Z2, Be, ge, Re, ze, Ee));
                }
                function ve(Z2, Be, ge, Re, ze, Ee) {
                  var He = e2.normalizeSlashes(Be.text), rr = Z2.path, Ie = e2.getDirectoryPath(rr);
                  return g(He) || !ge.baseUrl && (e2.isRootedDiskPath(He) || e2.isUrl(He)) ? he(He, Ie, ge, Re, rr, _e()) : P(He, Ie, ge, Re, ze);
                  function _e() {
                    var we = e2.isStringLiteralLike(Be) ? e2.getModeForUsageLocation(Z2, Be) : void 0;
                    return Ee.importModuleSpecifierEnding === "js" || we === e2.ModuleKind.ESNext ? 2 : 0;
                  }
                }
                function ee(Z2, Be) {
                  return Be === void 0 && (Be = 0), { extensions: e2.flatten(X(Z2)), includeExtensionsOption: Be };
                }
                function he(Z2, Be, ge, Re, ze, Ee) {
                  var He = ee(ge, Ee);
                  return ge.rootDirs ? A2(ge.rootDirs, Z2, Be, He, ge, Re, ze) : V(Z2, Be, He, Re, ze);
                }
                function F2(Z2) {
                  return e2.getEmitModuleResolutionKind(Z2) === e2.ModuleResolutionKind.NodeJs || e2.getEmitModuleResolutionKind(Z2) === e2.ModuleResolutionKind.Node16 || e2.getEmitModuleResolutionKind(Z2) === e2.ModuleResolutionKind.NodeNext;
                }
                function x2(Z2) {
                  return e2.getEmitModuleResolutionKind(Z2) === e2.ModuleResolutionKind.Node16 || e2.getEmitModuleResolutionKind(Z2) === e2.ModuleResolutionKind.NodeNext;
                }
                function X(Z2) {
                  var Be = e2.getSupportedExtensions(Z2);
                  return F2(Z2) ? e2.getSupportedExtensionsWithJsonIfResolveJsonModule(Z2, Be) : Be;
                }
                function $(Z2, Be, ge, Re) {
                  Z2 = Z2.map(function(Ee) {
                    return e2.normalizePath(e2.isRootedDiskPath(Ee) ? Ee : e2.combinePaths(Be, Ee));
                  });
                  var ze = e2.firstDefined(Z2, function(Ee) {
                    return e2.containsPath(Ee, ge, Be, Re) ? ge.substr(Ee.length) : void 0;
                  });
                  return e2.deduplicate(Ve(Ve([], Z2.map(function(Ee) {
                    return e2.combinePaths(Ee, ze);
                  }), true), [ge], false), e2.equateStringsCaseSensitive, e2.compareStringsCaseSensitive);
                }
                function A2(Z2, Be, ge, Re, ze, Ee, He) {
                  var rr = ze.project || Ee.getCurrentDirectory(), Ie = !(Ee.useCaseSensitiveFileNames && Ee.useCaseSensitiveFileNames()), _e = $(Z2, rr, ge, Ie);
                  return e2.flatMap(_e, function(we) {
                    return V(Be, we, Re, Ee, He);
                  });
                }
                var y;
                (function(Z2) {
                  Z2[Z2.Exclude = 0] = "Exclude", Z2[Z2.Include = 1] = "Include", Z2[Z2.ModuleSpecifierCompletion = 2] = "ModuleSpecifierCompletion";
                })(y || (y = {}));
                function V(Z2, Be, ge, Re, ze, Ee) {
                  var He = ge.extensions, rr = ge.includeExtensionsOption;
                  Ee === void 0 && (Ee = []), Z2 === void 0 && (Z2 = ""), Z2 = e2.normalizeSlashes(Z2), e2.hasTrailingDirectorySeparator(Z2) || (Z2 = e2.getDirectoryPath(Z2)), Z2 === "" && (Z2 = "." + e2.directorySeparator), Z2 = e2.ensureTrailingDirectorySeparator(Z2);
                  var Ie = e2.resolvePath(Be, Z2), _e = e2.hasTrailingDirectorySeparator(Ie) ? Ie : e2.getDirectoryPath(Ie), we = !(Re.useCaseSensitiveFileNames && Re.useCaseSensitiveFileNames());
                  if (!e2.tryDirectoryExists(Re, _e))
                    return Ee;
                  var de = e2.tryReadDirectory(Re, _e, He, void 0, ["./*"]);
                  if (de) {
                    for (var ye = new e2.Map(), Ae = 0, er = de; Ae < er.length; Ae++) {
                      var ir = er[Ae];
                      if (ir = e2.normalizePath(ir), !(ze && e2.comparePaths(ir, ze, Be, we) === 0)) {
                        var Cr = void 0, Ye = e2.moduleSpecifiers.tryGetJSExtensionForFile(ir, Re.getCompilationSettings());
                        rr === 0 && !e2.fileExtensionIsOneOf(ir, [".json", ".mts", ".cts", ".d.mts", ".d.cts", ".mjs", ".cjs"]) ? (Cr = e2.removeFileExtension(e2.getBaseFileName(ir)), ye.set(Cr, e2.tryGetExtensionFromPath(ir))) : (e2.fileExtensionIsOneOf(ir, [".mts", ".cts", ".d.mts", ".d.cts", ".mjs", ".cjs"]) || rr === 2) && Ye ? (Cr = e2.changeExtension(e2.getBaseFileName(ir), Ye), ye.set(Cr, Ye)) : (Cr = e2.getBaseFileName(ir), ye.set(Cr, e2.tryGetExtensionFromPath(ir)));
                      }
                    }
                    ye.forEach(function(Ur, ii) {
                      Ee.push(ie(ii, "script", Ur));
                    });
                  }
                  var Br = e2.tryGetDirectories(Re, _e);
                  if (Br)
                    for (var Er = 0, Ne = Br; Er < Ne.length; Er++) {
                      var n = Ne[Er], lr = e2.getBaseFileName(e2.normalizePath(n));
                      lr !== "@types" && Ee.push(R(lr));
                    }
                  var be = e2.findPackageJson(_e, Re);
                  if (be) {
                    var Ge = e2.readJson(be, Re), ur = Ge.typesVersions;
                    if (typeof ur == "object") {
                      var yr = e2.getPackageJsonTypesVersionsPaths(ur), Ir = yr && yr.paths, wr = Ie.slice(e2.ensureTrailingDirectorySeparator(_e).length);
                      Ir && L(Ee, wr, _e, He, Ir, Re);
                    }
                  }
                  return Ee;
                }
                function L(Z2, Be, ge, Re, ze, Ee) {
                  for (var He in ze)
                    if (!!e2.hasProperty(ze, He)) {
                      var rr = ze[He];
                      if (rr)
                        for (var Ie = function(ir, Cr, Ye) {
                          Z2.some(function(Br) {
                            return Br.name === ir;
                          }) || Z2.push(ie(ir, Cr, Ye));
                        }, _e = 0, we = Y(He, rr, Be, ge, Re, Ee); _e < we.length; _e++) {
                          var de = we[_e], ye = de.name, Ae = de.kind, er = de.extension;
                          Ie(ye, Ae, er);
                        }
                    }
                }
                function P(Z2, Be, ge, Re, ze) {
                  var Ee = ge.baseUrl, He = ge.paths, rr = [], Ie = ee(ge);
                  if (Ee) {
                    var _e = ge.project || Re.getCurrentDirectory(), we = e2.normalizePath(e2.combinePaths(_e, Ee));
                    V(Z2, we, Ie, Re, void 0, rr), He && L(rr, Z2, we, Ie.extensions, He, Re);
                  }
                  for (var de = k(Z2), ye = 0, Ae = I(Z2, de, ze); ye < Ae.length; ye++) {
                    var er = Ae[ye];
                    rr.push(ie(er, "external module name", void 0));
                  }
                  if (d(Re, ge, Be, de, Ie, rr), F2(ge)) {
                    var ir = false;
                    if (de === void 0)
                      for (var Cr = function(lr) {
                        rr.some(function(be) {
                          return be.name === lr;
                        }) || (ir = true, rr.push(ie(lr, "external module name", void 0)));
                      }, Ye = 0, Br = D(Re, Be); Ye < Br.length; Ye++) {
                        var Er = Br[Ye];
                        Cr(Er);
                      }
                    if (!ir) {
                      var Ne = function(lr) {
                        var be = e2.combinePaths(lr, "node_modules");
                        e2.tryDirectoryExists(Re, be) && V(Z2, be, Ie, Re, void 0, rr);
                      };
                      if (de && x2(ge)) {
                        var n = Ne;
                        Ne = function(lr) {
                          var be = e2.getPathComponents(Z2);
                          be.shift();
                          var Ge = be.shift();
                          if (!Ge)
                            return n(lr);
                          if (e2.startsWith(Ge, "@")) {
                            var ur = be.shift();
                            if (!ur)
                              return n(lr);
                            Ge = e2.combinePaths(Ge, ur);
                          }
                          var yr = e2.combinePaths(lr, "node_modules", Ge, "package.json");
                          if (e2.tryFileExists(Re, yr)) {
                            var Ir = e2.readJson(yr, Re), wr = Ir.exports;
                            if (wr) {
                              if (typeof wr != "object" || wr === null)
                                return;
                              var Ur = e2.getOwnKeys(wr), ii = be.join("/"), mi = e2.mapDefined(Ur, function(pe) {
                                if (pe !== "." && !!e2.startsWith(pe, "./")) {
                                  var or = pe.substring(2);
                                  if (!!e2.startsWith(or, ii))
                                    return e2.stringContains(or, "*") ? or.slice(0, or.indexOf("*")) : or;
                                }
                              });
                              e2.forEach(mi, function(pe) {
                                pe && rr.push(ie(pe, "external module name", void 0));
                              });
                              return;
                            }
                          }
                          return n(lr);
                        };
                      }
                      e2.forEachAncestorDirectory(Be, Ne);
                    }
                  }
                  return rr;
                }
                function k(Z2) {
                  return We(Z2) ? e2.hasTrailingDirectorySeparator(Z2) ? Z2 : e2.getDirectoryPath(Z2) : void 0;
                }
                function Y(Z2, Be, ge, Re, ze, Ee) {
                  if (!e2.endsWith(Z2, "*"))
                    return e2.stringContains(Z2, "*") ? e2.emptyArray : Ie(Z2);
                  var He = Z2.slice(0, Z2.length - 1), rr = e2.tryRemovePrefix(ge, He);
                  return rr === void 0 ? Ie(He) : e2.flatMap(Be, function(_e) {
                    return U(rr, Re, _e, ze, Ee);
                  });
                  function Ie(_e) {
                    return e2.startsWith(_e, ge) ? [R(_e)] : e2.emptyArray;
                  }
                }
                function U(Z2, Be, ge, Re, ze) {
                  if (!ze.readDirectory)
                    return;
                  var Ee = e2.tryParsePattern(ge);
                  if (Ee === void 0 || e2.isString(Ee))
                    return;
                  var He = e2.resolvePath(Ee.prefix), rr = e2.hasTrailingDirectorySeparator(Ee.prefix) ? He : e2.getDirectoryPath(He), Ie = e2.hasTrailingDirectorySeparator(Ee.prefix) ? "" : e2.getBaseFileName(He), _e = We(Z2), we = _e ? e2.hasTrailingDirectorySeparator(Z2) ? Z2 : e2.getDirectoryPath(Z2) : void 0, de = _e ? e2.combinePaths(rr, Ie + we) : rr, ye = e2.normalizePath(Ee.suffix), Ae = e2.normalizePath(e2.combinePaths(Be, de)), er = _e ? Ae : e2.ensureTrailingDirectorySeparator(Ae) + Ie, ir = ye ? "**/*" : "./*", Cr = e2.mapDefined(e2.tryReadDirectory(ze, Ae, Re, void 0, [ir]), function(Er) {
                    var Ne = e2.tryGetExtensionFromPath(Er), n = Br(Er);
                    return n === void 0 ? void 0 : ie(e2.removeFileExtension(n), "script", Ne);
                  }), Ye = e2.mapDefined(e2.tryGetDirectories(ze, Ae).map(function(Er) {
                    return e2.combinePaths(Ae, Er);
                  }), function(Er) {
                    var Ne = Br(Er);
                    return Ne === void 0 ? void 0 : R(Ne);
                  });
                  return Ve(Ve([], Cr, true), Ye, true);
                  function Br(Er) {
                    var Ne = j(e2.normalizePath(Er), er, ye);
                    return Ne === void 0 ? void 0 : H(Ne);
                  }
                }
                function j(Z2, Be, ge) {
                  return e2.startsWith(Z2, Be) && e2.endsWith(Z2, ge) ? Z2.slice(Be.length, Z2.length - ge.length) : void 0;
                }
                function H(Z2) {
                  return Z2[0] === e2.directorySeparator ? Z2.slice(1) : Z2;
                }
                function I(Z2, Be, ge) {
                  var Re = ge.getAmbientModules().map(function(He) {
                    return e2.stripQuotes(He.name);
                  }), ze = Re.filter(function(He) {
                    return e2.startsWith(He, Z2);
                  });
                  if (Be !== void 0) {
                    var Ee = e2.ensureTrailingDirectorySeparator(Be);
                    return ze.map(function(He) {
                      return e2.removePrefix(He, Ee);
                    });
                  }
                  return ze;
                }
                function l(Z2, Be, ge, Re) {
                  var ze = e2.getTokenAtPosition(Z2, Be), Ee = e2.getLeadingCommentRanges(Z2.text, ze.pos), He = Ee && e2.find(Ee, function(er) {
                    return Be >= er.pos && Be <= er.end;
                  });
                  if (!!He) {
                    var rr = Z2.text.slice(He.pos, Be), Ie = ne.exec(rr);
                    if (!!Ie) {
                      var _e = Ie[1], we = Ie[2], de = Ie[3], ye = e2.getDirectoryPath(Z2.path), Ae = we === "path" ? V(de, ye, ee(ge, 1), Re, Z2.path) : we === "types" ? d(Re, ge, ye, k(de), ee(ge)) : e2.Debug.fail();
                      return q(de, He.pos + _e.length, Ae);
                    }
                  }
                }
                function d(Z2, Be, ge, Re, ze, Ee) {
                  Ee === void 0 && (Ee = []);
                  for (var He = new e2.Map(), rr = e2.tryAndIgnoreErrors(function() {
                    return e2.getEffectiveTypeRoots(Be, Z2);
                  }) || e2.emptyArray, Ie = 0, _e = rr; Ie < _e.length; Ie++) {
                    var we = _e[Ie];
                    ir(we);
                  }
                  for (var de = 0, ye = e2.findPackageJsons(ge, Z2); de < ye.length; de++) {
                    var Ae = ye[de], er = e2.combinePaths(e2.getDirectoryPath(Ae), "node_modules/@types");
                    ir(er);
                  }
                  return Ee;
                  function ir(Cr) {
                    if (!!e2.tryDirectoryExists(Z2, Cr))
                      for (var Ye = 0, Br = e2.tryGetDirectories(Z2, Cr); Ye < Br.length; Ye++) {
                        var Er = Br[Ye], Ne = e2.unmangleScopedPackageName(Er);
                        if (!(Be.types && !e2.contains(Be.types, Ne)))
                          if (Re === void 0)
                            He.has(Ne) || (Ee.push(ie(Ne, "external module name", void 0)), He.set(Ne, true));
                          else {
                            var n = e2.combinePaths(Cr, Er), lr = e2.tryRemoveDirectoryPrefix(Re, Ne, e2.hostGetCanonicalFileName(Z2));
                            lr !== void 0 && V(lr, n, ze, Z2, void 0, Ee);
                          }
                      }
                  }
                }
                function D(Z2, Be) {
                  if (!Z2.readFile || !Z2.fileExists)
                    return e2.emptyArray;
                  for (var ge = [], Re = 0, ze = e2.findPackageJsons(Be, Z2); Re < ze.length; Re++)
                    for (var Ee = ze[Re], He = e2.readJson(Ee, Z2), rr = 0, Ie = ue; rr < Ie.length; rr++) {
                      var _e = Ie[rr], we = He[_e];
                      if (!!we)
                        for (var de in we)
                          we.hasOwnProperty(de) && !e2.startsWith(de, "@types/") && ge.push(de);
                    }
                  return ge;
                }
                function fe(Z2, Be) {
                  var ge = Math.max(Z2.lastIndexOf(e2.directorySeparator), Z2.lastIndexOf(e2.altDirectorySeparator)), Re = ge !== -1 ? ge + 1 : 0, ze = Z2.length - Re;
                  return ze === 0 || e2.isIdentifierText(Z2.substr(Re, ze), 99) ? void 0 : e2.createTextSpan(Be + Re, ze);
                }
                function g(Z2) {
                  if (Z2 && Z2.length >= 2 && Z2.charCodeAt(0) === 46) {
                    var Be = Z2.length >= 3 && Z2.charCodeAt(1) === 46 ? 2 : 1, ge = Z2.charCodeAt(Be);
                    return ge === 47 || ge === 92;
                  }
                  return false;
                }
                var ne = /^(\/\/\/\s*<reference\s+(path|types)\s*=\s*(?:'|"))([^\3"]*)$/, ue = ["dependencies", "devDependencies", "peerDependencies", "optionalDependencies"];
                function We(Z2) {
                  return e2.stringContains(Z2, e2.directorySeparator);
                }
                function Fe(Z2) {
                  return e2.isCallExpression(Z2.parent) && e2.firstOrUndefined(Z2.parent.arguments) === Z2 && e2.isIdentifier(Z2.parent.expression) && Z2.parent.expression.escapedText === "require";
                }
              })(w = C.StringCompletions || (C.StringCompletions = {}));
            })(a = e2.Completions || (e2.Completions = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              C.moduleSpecifierResolutionLimit = 100, C.moduleSpecifierResolutionCacheAttemptLimit = 1e3, C.SortText = { LocalDeclarationPriority: "10", LocationPriority: "11", OptionalMember: "12", MemberDeclaredBySpreadAssignment: "13", SuggestedClassMembers: "14", GlobalsOrKeywords: "15", AutoImportSuggestions: "16", ClassMemberSnippets: "17", JavascriptIdentifiers: "18", Deprecated: function(xe) {
                return "z" + xe;
              }, ObjectLiteralProperty: function(xe, vr) {
                return "".concat(xe, "\0").concat(vr, "\0");
              }, SortBelow: function(xe) {
                return xe + "1";
              } };
              var w;
              (function(xe) {
                xe.ThisProperty = "ThisProperty/", xe.ClassMemberSnippet = "ClassMemberSnippet/", xe.TypeOnlyAlias = "TypeOnlyAlias/", xe.ObjectLiteralMethodSnippet = "ObjectLiteralMethodSnippet/";
              })(w = C.CompletionSource || (C.CompletionSource = {}));
              var B;
              (function(xe) {
                xe[xe.ThisType = 1] = "ThisType", xe[xe.SymbolMember = 2] = "SymbolMember", xe[xe.Export = 4] = "Export", xe[xe.Promise = 8] = "Promise", xe[xe.Nullable = 16] = "Nullable", xe[xe.ResolvedExport = 32] = "ResolvedExport", xe[xe.TypeOnlyAlias = 64] = "TypeOnlyAlias", xe[xe.ObjectLiteralMethod = 128] = "ObjectLiteralMethod", xe[xe.SymbolMemberNoExport = 2] = "SymbolMemberNoExport", xe[xe.SymbolMemberExport = 6] = "SymbolMemberExport";
              })(B || (B = {}));
              function E(xe) {
                return !!(xe.kind & 1);
              }
              function Q(xe) {
                return !!(xe.kind & 2);
              }
              function le(xe) {
                return !!(xe && xe.kind & 4);
              }
              function N(xe) {
                return !!(xe && xe.kind === 32);
              }
              function p(xe) {
                return le(xe) || N(xe);
              }
              function m2(xe) {
                return (le(xe) || N(xe)) && !!xe.isFromPackageJson;
              }
              function G(xe) {
                return !!(xe.kind & 8);
              }
              function oe(xe) {
                return !!(xe.kind & 16);
              }
              function f4(xe) {
                return !!(xe && xe.kind & 64);
              }
              function T(xe) {
                return !!(xe && xe.kind & 128);
              }
              var K;
              (function(xe) {
                xe[xe.None = 0] = "None", xe[xe.All = 1] = "All", xe[xe.ClassElementKeywords = 2] = "ClassElementKeywords", xe[xe.InterfaceElementKeywords = 3] = "InterfaceElementKeywords", xe[xe.ConstructorParameterKeywords = 4] = "ConstructorParameterKeywords", xe[xe.FunctionLikeBodyKeywords = 5] = "FunctionLikeBodyKeywords", xe[xe.TypeAssertionKeywords = 6] = "TypeAssertionKeywords", xe[xe.TypeKeywords = 7] = "TypeKeywords", xe[xe.TypeKeyword = 8] = "TypeKeyword", xe[xe.Last = 8] = "Last";
              })(K || (K = {}));
              var b;
              (function(xe) {
                xe[xe.Continue = 0] = "Continue", xe[xe.Success = 1] = "Success", xe[xe.Fail = 2] = "Fail";
              })(b || (b = {}));
              function se(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue) {
                var fr, De, gr, Vr = e2.timestamp(), Tr = e2.createPackageJsonImportFilter(Ar, nr, vr), vi = Mr || e2.moduleResolutionRespectsExports(e2.getEmitModuleResolutionKind(mr.getCompilerOptions())), Ui = false, Yi = 0, Wi = 0, ct = 0, Li = 0, nt = Ue({ tryResolve: xt, skippedAny: function() {
                  return Ui;
                }, resolvedAny: function() {
                  return Wi > 0;
                }, resolvedBeyondLimit: function() {
                  return Wi > C.moduleSpecifierResolutionLimit;
                } }), Mt = Li ? " (".concat((ct / Li * 100).toFixed(1), "% hit rate)") : "";
                return (fr = vr.log) === null || fr === void 0 || fr.call(vr, "".concat(xe, ": resolved ").concat(Wi, " module specifiers, plus ").concat(Yi, " ambient and ").concat(ct, " from cache").concat(Mt)), (De = vr.log) === null || De === void 0 || De.call(vr, "".concat(xe, ": response is ").concat(Ui ? "incomplete" : "complete")), (gr = vr.log) === null || gr === void 0 || gr.call(vr, "".concat(xe, ": ").concat(e2.timestamp() - Vr)), nt;
                function xt(ut, Dt, Rt) {
                  if (Rt) {
                    var Ii = e2.codefix.getModuleSpecifierForBestExportInfo(ut, Dt, Oe, Pe, Ar, mr, vr, nr);
                    return Ii && Yi++, Ii || "failed";
                  }
                  var Ki = vi || nr.allowIncompleteCompletions && Wi < C.moduleSpecifierResolutionLimit, Fi = !Ki && nr.allowIncompleteCompletions && Li < C.moduleSpecifierResolutionCacheAttemptLimit, ui = Ki || Fi ? e2.codefix.getModuleSpecifierForBestExportInfo(ut, Dt, Oe, Pe, Ar, mr, vr, nr, Tr, Fi) : void 0;
                  return (!Ki && !Fi || Fi && !ui) && (Ui = true), Wi += (ui == null ? void 0 : ui.computedWithoutCacheCount) || 0, ct += ut.length - ((ui == null ? void 0 : ui.computedWithoutCacheCount) || 0), Fi && Li++, ui || (vi ? "failed" : "skipped");
                }
              }
              function J(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr) {
                var De, gr = Ye(Oe, Ar).previousToken;
                if (!(Mr && !e2.isInString(Ar, Oe, gr) && !et(Ar, Mr, gr, Oe))) {
                  if (Mr === " ")
                    return nr.includeCompletionsForImportStatements && nr.includeCompletionsWithInsertText ? { isGlobalCompletion: true, isMemberCompletion: false, isNewIdentifierLocation: true, isIncomplete: true, entries: [] } : void 0;
                  var Vr = vr.getCompilerOptions(), Tr = nr.allowIncompleteCompletions ? (De = xe.getIncompleteCompletionsCache) === null || De === void 0 ? void 0 : De.call(xe) : void 0;
                  if (Tr && Pe === 3 && gr && e2.isIdentifier(gr)) {
                    var vi = q(Tr, Ar, gr, vr, xe, nr, Ue);
                    if (vi)
                      return vi;
                  } else
                    Tr == null || Tr.clear();
                  var Ui = C.StringCompletions.getStringLiteralCompletions(Ar, Oe, gr, Vr, xe, vr, mr, nr);
                  if (Ui)
                    return Ui;
                  if (gr && e2.isBreakOrContinueStatement(gr.parent) && (gr.kind === 81 || gr.kind === 86 || gr.kind === 79))
                    return Z2(gr.parent);
                  var Yi = ir(vr, mr, Ar, Vr, Oe, nr, void 0, xe, fr, Ue);
                  if (!!Yi)
                    switch (Yi.kind) {
                      case 0:
                        var Wi = X(Ar, xe, vr, Vr, mr, Yi, nr, fr, Oe);
                        return Wi != null && Wi.isIncomplete && (Tr == null || Tr.set(Wi)), Wi;
                      case 1:
                        return O(e2.JsDoc.getJSDocTagNameCompletions());
                      case 2:
                        return O(e2.JsDoc.getJSDocTagCompletions());
                      case 3:
                        return O(e2.JsDoc.getJSDocParameterNameCompletions(Yi.tag));
                      case 4:
                        return ee(Yi.keywordCompletions, Yi.isNewIdentifierLocation);
                      default:
                        return e2.Debug.assertNever(Yi);
                    }
                }
              }
              C.getCompletionsAtPosition = J;
              function ie(xe, vr) {
                var mr, Ar, Oe = e2.compareStringsCaseSensitiveUI(xe.sortText, vr.sortText);
                return Oe === 0 && (Oe = e2.compareStringsCaseSensitiveUI(xe.name, vr.name)), Oe === 0 && ((mr = xe.data) === null || mr === void 0 ? void 0 : mr.moduleSpecifier) && ((Ar = vr.data) === null || Ar === void 0 ? void 0 : Ar.moduleSpecifier) && (Oe = e2.compareNumberOfDirectorySeparators(xe.data.moduleSpecifier, vr.data.moduleSpecifier)), Oe === 0 ? -1 : Oe;
              }
              function R(xe) {
                return !!(xe != null && xe.moduleSpecifier);
              }
              function q(xe, vr, mr, Ar, Oe, nr, Mr) {
                var Pe = xe.get();
                if (!!Pe) {
                  var Ue = mr.text.toLowerCase(), fr = e2.getExportInfoMap(vr, Oe, Ar, Mr), De = se("continuePreviousIncompleteResponse", Oe, Ar, vr, mr.getStart(), nr, false, e2.isValidTypeOnlyAliasUseSite(mr), function(gr) {
                    var Vr = e2.mapDefined(Pe.entries, function(Tr) {
                      var vi;
                      if (!Tr.hasAction || !Tr.source || !Tr.data || R(Tr.data))
                        return Tr;
                      if (!!Wr(Tr.name, Ue)) {
                        var Ui = e2.Debug.checkDefined(Br(Tr.name, Tr.data, Ar, Oe)).origin, Yi = fr.get(vr.path, Tr.data.exportMapKey), Wi = Yi && gr.tryResolve(Yi, Tr.name, !e2.isExternalModuleNameRelative(e2.stripQuotes(Ui.moduleSymbol.name)));
                        if (Wi === "skipped")
                          return Tr;
                        if (!Wi || Wi === "failed") {
                          (vi = Oe.log) === null || vi === void 0 || vi.call(Oe, "Unexpected failure resolving auto import for '".concat(Tr.name, "' from '").concat(Tr.source, "'"));
                          return;
                        }
                        var ct = Ke(Ke({}, Ui), { kind: 32, moduleSpecifier: Wi.moduleSpecifier });
                        return Tr.data = D(ct), Tr.source = We(ct), Tr.sourceDisplay = [e2.textPart(ct.moduleSpecifier)], Tr;
                      }
                    });
                    return gr.skippedAny() || (Pe.isIncomplete = void 0), Vr;
                  });
                  return Pe.entries = De, Pe.flags = (Pe.flags || 0) | 4, Pe;
                }
              }
              function O(xe) {
                return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries: xe };
              }
              function ve(xe) {
                return { name: e2.tokenToString(xe), kind: "keyword", kindModifiers: "", sortText: C.SortText.GlobalsOrKeywords };
              }
              function ee(xe, vr) {
                return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: vr, entries: xe.slice() };
              }
              function he(xe, vr, mr) {
                return { kind: 4, keywordCompletions: lr(xe, vr), isNewIdentifierLocation: mr };
              }
              function F2(xe) {
                switch (xe) {
                  case 152:
                    return 8;
                  default:
                    e2.Debug.fail("Unknown mapping from SyntaxKind to KeywordCompletionFilters");
                }
              }
              function x2(xe) {
                return (xe == null ? void 0 : xe.kind) === 79 ? e2.createTextSpanFromNode(xe) : void 0;
              }
              function X(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue) {
                var fr = nr.symbols, De = nr.contextToken, gr = nr.completionKind, Vr = nr.isInSnippetScope, Tr = nr.isNewIdentifierLocation, vi = nr.location, Ui = nr.propertyAccessToConvert, Yi = nr.keywordFilters, Wi = nr.literals, ct = nr.symbolToOriginInfoMap, Li = nr.recommendedCompletion, nt = nr.isJsxInitializer, Mt = nr.isTypeOnlyLocation, xt = nr.isJsxIdentifierExpected, ut = nr.isRightOfOpenTag, Dt = nr.importCompletionNode, Rt = nr.insideJsDocTagTypeExpression, Ii = nr.symbolToSortTextMap, Ki = nr.hasUnresolvedAutoImports;
                if (e2.getLanguageVariant(xe.scriptKind) === 1) {
                  var Fi = y(vi, xe);
                  if (Fi)
                    return Fi;
                }
                var ui = e2.createSortedArray();
                if ($(xe, Ar)) {
                  var Bt = Fe(fr, ui, void 0, De, vi, xe, vr, mr, e2.getEmitScriptTarget(Ar), Oe, gr, Mr, Ar, Pe, Mt, Ui, xt, nt, Dt, Li, ct, Ii, xt, ut);
                  V(xe, vi.pos, Bt, e2.getEmitScriptTarget(Ar), ui);
                } else {
                  if (!Tr && (!fr || fr.length === 0) && Yi === 0)
                    return;
                  Fe(fr, ui, void 0, De, vi, xe, vr, mr, e2.getEmitScriptTarget(Ar), Oe, gr, Mr, Ar, Pe, Mt, Ui, xt, nt, Dt, Li, ct, Ii, xt, ut);
                }
                if (Yi !== 0)
                  for (var wt = new e2.Set(ui.map(function(Qa) {
                    return Qa.name;
                  })), na = 0, Ai = lr(Yi, !Rt && e2.isSourceFileJS(xe)); na < Ai.length; na++) {
                    var Oi = Ai[na];
                    (Mt && e2.isTypeKeyword(e2.stringToToken(Oi.name)) || !wt.has(Oi.name)) && e2.insertSorted(ui, Oi, ie, true);
                  }
                for (var ji = new e2.Set(ui.map(function(Qa) {
                  return Qa.name;
                })), Vi = 0, at = Ur(De, Ue); Vi < at.length; Vi++) {
                  var Oi = at[Vi];
                  ji.has(Oi.name) || e2.insertSorted(ui, Oi, ie, true);
                }
                for (var At = 0, ba = Wi; At < ba.length; At++) {
                  var $a = ba[At];
                  e2.insertSorted(ui, P(xe, Mr, $a), ie, true);
                }
                return { flags: nr.flags, isGlobalCompletion: Vr, isIncomplete: Mr.allowIncompleteCompletions && Ki ? true : void 0, isMemberCompletion: A2(gr), isNewIdentifierLocation: Tr, optionalReplacementSpan: x2(vi), entries: ui };
              }
              function $(xe, vr) {
                return e2.isSourceFileJS(xe) && !e2.isCheckJsEnabledForFile(xe, vr);
              }
              function A2(xe) {
                switch (xe) {
                  case 0:
                  case 3:
                  case 2:
                    return true;
                  default:
                    return false;
                }
              }
              function y(xe, vr) {
                var mr = e2.findAncestor(xe, function(fr) {
                  switch (fr.kind) {
                    case 281:
                      return true;
                    case 43:
                    case 31:
                    case 79:
                    case 206:
                      return false;
                    default:
                      return "quit";
                  }
                });
                if (mr) {
                  var Ar = !!e2.findChildOfKind(mr, 31, vr), Oe = mr.parent.openingElement.tagName, nr = Oe.getText(vr), Mr = nr + (Ar ? "" : ">"), Pe = e2.createTextSpanFromNode(mr.tagName), Ue = { name: Mr, kind: "class", kindModifiers: void 0, sortText: C.SortText.LocationPriority };
                  return { isGlobalCompletion: false, isMemberCompletion: true, isNewIdentifierLocation: false, optionalReplacementSpan: Pe, entries: [Ue] };
                }
              }
              function V(xe, vr, mr, Ar, Oe) {
                e2.getNameTable(xe).forEach(function(nr, Mr) {
                  if (nr !== vr) {
                    var Pe = e2.unescapeLeadingUnderscores(Mr);
                    !mr.has(Pe) && e2.isIdentifierText(Pe, Ar) && (mr.add(Pe), e2.insertSorted(Oe, { name: Pe, kind: "warning", kindModifiers: "", sortText: C.SortText.JavascriptIdentifiers, isFromUncheckedFile: true }, ie));
                  }
                });
              }
              function L(xe, vr, mr) {
                return typeof mr == "object" ? e2.pseudoBigIntToString(mr) + "n" : e2.isString(mr) ? e2.quote(xe, vr, mr) : JSON.stringify(mr);
              }
              function P(xe, vr, mr) {
                return { name: L(xe, vr, mr), kind: "string", kindModifiers: "", sortText: C.SortText.LocationPriority };
              }
              function k(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui, Yi, Wi, ct, Li, nt, Mt) {
                var xt, ut, Dt, Rt = e2.getReplacementSpanForContextToken(mr), Ii, Ki, Fi = We(De), ui, Bt, wt, na = Pe.getTypeChecker(), Ai = De && oe(De), Oi = De && Q(De) || fr;
                if (De && E(De))
                  Dt = fr ? "this".concat(Ai ? "?." : "", "[").concat(ne(nr, Wi, Ue), "]") : "this".concat(Ai ? "?." : ".").concat(Ue);
                else if ((Oi || Ai) && Vr) {
                  Dt = Oi ? fr ? "[".concat(ne(nr, Wi, Ue), "]") : "[".concat(Ue, "]") : Ue, (Ai || Vr.questionDotToken) && (Dt = "?.".concat(Dt));
                  var ji = e2.findChildOfKind(Vr, 24, nr) || e2.findChildOfKind(Vr, 28, nr);
                  if (!ji)
                    return;
                  var Vi = e2.startsWith(Ue, Vr.name.text) ? Vr.name.end : ji.end;
                  Rt = e2.createTextSpanFromBounds(ji.getStart(nr), Vi);
                }
                if (Tr && (Dt === void 0 && (Dt = Ue), Dt = "{".concat(Dt, "}"), typeof Tr != "boolean" && (Rt = e2.createTextSpanFromNode(Tr, nr))), De && G(De) && Vr) {
                  Dt === void 0 && (Dt = Ue);
                  var at = e2.findPrecedingToken(Vr.pos, nr), At = "";
                  at && e2.positionIsASICandidate(at.end, at.parent, nr) && (At = ";"), At += "(await ".concat(Vr.expression.getText(), ")"), Dt = fr ? "".concat(At).concat(Dt) : "".concat(At).concat(Ai ? "?." : ".").concat(Dt), Rt = e2.createTextSpanFromBounds(Vr.getStart(nr), Vr.end);
                }
                if (N(De) && (ui = [e2.textPart(De.moduleSpecifier)], vi && (xt = g(Ue, vi, Ar, De, Ui, Yi, Wi), Dt = xt.insertText, Rt = xt.replacementSpan, Ki = Wi.includeCompletionsWithSnippetText ? true : void 0)), (De == null ? void 0 : De.kind) === 64 && (Bt = true), Wi.includeCompletionsWithClassMemberSnippets && Wi.includeCompletionsWithInsertText && ct === 3 && Y(xe, Oe)) {
                  var ba = void 0;
                  ut = U(Mr, Pe, Yi, Wi, Ue, xe, Oe, Ar, Li), Dt = ut.insertText, Ki = ut.isSnippet, ba = ut.importAdder, Rt = ut.replacementSpan, vr = C.SortText.ClassMemberSnippets, ba != null && ba.hasFixes() && (Bt = true, Fi = w.ClassMemberSnippet);
                }
                if (De && T(De) && (Dt = De.insertText, Ki = De.isSnippet, wt = De.labelDetails, Wi.useLabelDetailsInCompletionEntries || (Ue = Ue + wt.detail, wt = void 0), Fi = w.ObjectLiteralMethodSnippet, vr = C.SortText.SortBelow(vr)), nt && !Mt && Wi.includeCompletionsWithSnippetText && Wi.jsxAttributeCompletionStyle && Wi.jsxAttributeCompletionStyle !== "none") {
                  var $a = Wi.jsxAttributeCompletionStyle === "braces", Qa = na.getTypeOfSymbolAtLocation(xe, Oe);
                  Wi.jsxAttributeCompletionStyle === "auto" && !(Qa.flags & 528) && !(Qa.flags & 1048576 && e2.find(Qa.types, function(ai) {
                    return !!(ai.flags & 528);
                  })) && (Qa.flags & 402653316 || Qa.flags & 1048576 && e2.every(Qa.types, function(ai) {
                    return !!(ai.flags & 402686084);
                  }) ? (Dt = "".concat(e2.escapeSnippetText(Ue), "=").concat(e2.quote(nr, Wi, "$1")), Ki = true) : $a = true), $a && (Dt = "".concat(e2.escapeSnippetText(Ue), "={$1}"), Ki = true);
                }
                if (!(Dt !== void 0 && !Wi.includeCompletionsWithInsertText))
                  return (le(De) || N(De)) && (Ii = D(De), Bt = !vi), { name: Ue, kind: e2.SymbolDisplay.getSymbolKind(na, xe, Oe), kindModifiers: e2.SymbolDisplay.getSymbolModifiers(na, xe), sortText: vr, source: Fi, hasAction: Bt ? true : void 0, isRecommended: ue(xe, gr, na) || void 0, insertText: Dt, replacementSpan: Rt, sourceDisplay: ui, labelDetails: wt, isSnippet: Ki, isPackageJsonImport: m2(De) || void 0, isImportStatementCompletion: !!vi || void 0, data: Ii };
              }
              function Y(xe, vr) {
                if (e2.isInJSFile(vr))
                  return false;
                var mr = 106500;
                return !!(xe.flags & mr) && (e2.isClassLike(vr) || vr.parent && vr.parent.parent && e2.isClassElement(vr.parent) && vr === vr.parent.name && e2.isClassLike(vr.parent.parent) || vr.parent && e2.isSyntaxList(vr) && e2.isClassLike(vr.parent));
              }
              function U(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue) {
                var fr = e2.findAncestor(Mr, e2.isClassLike);
                if (!fr)
                  return { insertText: Oe };
                var De, gr, Vr = Oe, Tr = vr.getTypeChecker(), vi = Mr.getSourceFile(), Ui = d({ removeComments: true, module: mr.module, target: mr.target, omitTrailingSemicolon: false, newLine: e2.getNewLineKind(e2.getNewLineCharacter(mr, e2.maybeBind(xe, xe.getNewLine))) }), Yi = e2.codefix.createImportAdder(vi, vr, Ar, xe), Wi;
                if (Ar.includeCompletionsWithSnippetText) {
                  De = true;
                  var ct = e2.factory.createEmptyStatement();
                  Wi = e2.factory.createBlock([ct], true), e2.setSnippetElement(ct, { kind: 0, order: 0 });
                } else
                  Wi = e2.factory.createBlock([], true);
                var Li = 0, nt = j(Pe), Mt = nt.modifiers, xt = nt.span, ut = !!(Mt & 128), Dt = [];
                if (e2.codefix.addNewNodeForMemberSymbol(nr, fr, vi, { program: vr, host: xe }, Ar, Yi, function(Ii) {
                  var Ki = 0;
                  ut && (Ki |= 128), e2.isClassElement(Ii) && Tr.getMemberOverrideModifierStatus(fr, Ii) === 1 && (Ki |= 16384), Dt.length || (Li = Ii.modifierFlagsCache | Ki | Mt), Ii = e2.factory.updateModifiers(Ii, Li), Dt.push(Ii);
                }, Wi, 2, ut), Dt.length) {
                  var Rt = 131073;
                  gr = xt, Ue ? Vr = Ui.printAndFormatSnippetList(Rt, e2.factory.createNodeArray(Dt), vi, Ue) : Vr = Ui.printSnippetList(Rt, e2.factory.createNodeArray(Dt), vi);
                }
                return { insertText: Vr, isSnippet: De, importAdder: Yi, replacementSpan: gr };
              }
              function j(xe) {
                if (!xe)
                  return { modifiers: 0 };
                var vr = 0, mr, Ar;
                return (Ar = H(xe)) && (vr |= e2.modifierToFlag(Ar), mr = e2.createTextSpanFromNode(xe)), e2.isPropertyDeclaration(xe.parent) && (vr |= e2.modifiersToFlags(xe.parent.modifiers), mr = e2.createTextSpanFromNode(xe.parent)), { modifiers: vr, span: mr };
              }
              function H(xe) {
                if (e2.isModifier(xe))
                  return xe.kind;
                if (e2.isIdentifier(xe) && xe.originalKeywordKind && e2.isModifierKind(xe.originalKeywordKind))
                  return xe.originalKeywordKind;
              }
              function I(xe, vr, mr, Ar, Oe, nr, Mr, Pe) {
                var Ue = Mr.includeCompletionsWithSnippetText || void 0, fr = vr, De = mr.getSourceFile(), gr = l(xe, mr, De, Ar, Oe, Mr);
                if (!!gr) {
                  var Vr = d({ removeComments: true, module: nr.module, target: nr.target, omitTrailingSemicolon: false, newLine: e2.getNewLineKind(e2.getNewLineCharacter(nr, e2.maybeBind(Oe, Oe.getNewLine))) });
                  Pe ? fr = Vr.printAndFormatSnippetList(80, e2.factory.createNodeArray([gr], true), De, Pe) : fr = Vr.printSnippetList(80, e2.factory.createNodeArray([gr], true), De);
                  var Tr = e2.createPrinter({ removeComments: true, module: nr.module, target: nr.target, omitTrailingSemicolon: true }), vi = e2.factory.createMethodSignature(void 0, "", gr.questionToken, gr.typeParameters, gr.parameters, gr.type), Ui = { detail: Tr.printNode(4, vi, De) };
                  return { isSnippet: Ue, insertText: fr, labelDetails: Ui };
                }
              }
              function l(xe, vr, mr, Ar, Oe, nr) {
                var Mr = xe.getDeclarations();
                if (!!(Mr && Mr.length)) {
                  var Pe = Ar.getTypeChecker(), Ue = Mr[0], fr = e2.getSynthesizedDeepClone(e2.getNameOfDeclaration(Ue), false), De = Pe.getWidenedType(Pe.getTypeOfSymbolAtLocation(xe, vr)), gr = e2.getQuotePreference(mr, nr), Vr = gr === 0 ? 268435456 : void 0;
                  switch (Ue.kind) {
                    case 166:
                    case 167:
                    case 168:
                    case 169: {
                      var Tr = De.flags & 1048576 && De.types.length < 10 ? Pe.getUnionType(De.types, 2) : De;
                      if (Tr.flags & 1048576) {
                        var vi = e2.filter(Tr.types, function(nt) {
                          return Pe.getSignaturesOfType(nt, 0).length > 0;
                        });
                        if (vi.length === 1)
                          Tr = vi[0];
                        else
                          return;
                      }
                      var Ui = Pe.getSignaturesOfType(Tr, 0);
                      if (Ui.length !== 1)
                        return;
                      var Yi = Pe.typeToTypeNode(Tr, vr, Vr, e2.codefix.getNoopSymbolTrackerWithResolver({ program: Ar, host: Oe }));
                      if (!Yi || !e2.isFunctionTypeNode(Yi))
                        return;
                      var Wi = void 0;
                      if (nr.includeCompletionsWithSnippetText) {
                        var ct = e2.factory.createEmptyStatement();
                        Wi = e2.factory.createBlock([ct], true), e2.setSnippetElement(ct, { kind: 0, order: 0 });
                      } else
                        Wi = e2.factory.createBlock([], true);
                      var Li = Yi.parameters.map(function(nt) {
                        return e2.factory.createParameterDeclaration(void 0, void 0, nt.dotDotDotToken, nt.name, nt.questionToken, void 0, nt.initializer);
                      });
                      return e2.factory.createMethodDeclaration(void 0, void 0, void 0, fr, void 0, void 0, Li, void 0, Wi);
                    }
                    default:
                      return;
                  }
                }
              }
              function d(xe) {
                var vr, mr = e2.textChanges.createWriter(e2.getNewLineCharacter(xe)), Ar = e2.createPrinter(xe, mr), Oe = Ke(Ke({}, mr), { write: function(fr) {
                  return nr(fr, function() {
                    return mr.write(fr);
                  });
                }, nonEscapingWrite: mr.write, writeLiteral: function(fr) {
                  return nr(fr, function() {
                    return mr.writeLiteral(fr);
                  });
                }, writeStringLiteral: function(fr) {
                  return nr(fr, function() {
                    return mr.writeStringLiteral(fr);
                  });
                }, writeSymbol: function(fr, De) {
                  return nr(fr, function() {
                    return mr.writeSymbol(fr, De);
                  });
                }, writeParameter: function(fr) {
                  return nr(fr, function() {
                    return mr.writeParameter(fr);
                  });
                }, writeComment: function(fr) {
                  return nr(fr, function() {
                    return mr.writeComment(fr);
                  });
                }, writeProperty: function(fr) {
                  return nr(fr, function() {
                    return mr.writeProperty(fr);
                  });
                } });
                return { printSnippetList: Mr, printAndFormatSnippetList: Ue };
                function nr(fr, De) {
                  var gr = e2.escapeSnippetText(fr);
                  if (gr !== fr) {
                    var Vr = mr.getTextPos();
                    De();
                    var Tr = mr.getTextPos();
                    vr = e2.append(vr || (vr = []), { newText: gr, span: { start: Vr, length: Tr - Vr } });
                  } else
                    De();
                }
                function Mr(fr, De, gr) {
                  var Vr = Pe(fr, De, gr);
                  return vr ? e2.textChanges.applyChanges(Vr, vr) : Vr;
                }
                function Pe(fr, De, gr) {
                  return vr = void 0, Oe.clear(), Ar.writeList(fr, De, gr, Oe), Oe.getText();
                }
                function Ue(fr, De, gr, Vr) {
                  var Tr = { text: Pe(fr, De, gr), getLineAndCharacterOfPosition: function(Wi) {
                    return e2.getLineAndCharacterOfPosition(this, Wi);
                  } }, vi = e2.getFormatCodeSettingsForWriting(Vr, gr), Ui = e2.flatMap(De, function(Wi) {
                    var ct = e2.textChanges.assignPositionsToNode(Wi);
                    return e2.formatting.formatNodeGivenIndentation(ct, Tr, gr.languageVariant, 0, 0, Ke(Ke({}, Vr), { options: vi }));
                  }), Yi = vr ? e2.stableSort(e2.concatenate(Ui, vr), function(Wi, ct) {
                    return e2.compareTextSpans(Wi.span, ct.span);
                  }) : Ui;
                  return e2.textChanges.applyChanges(Tr.text, Yi);
                }
              }
              function D(xe) {
                var vr = xe.fileName ? void 0 : e2.stripQuotes(xe.moduleSymbol.name), mr = xe.isFromPackageJson ? true : void 0;
                if (N(xe)) {
                  var Ar = { exportName: xe.exportName, moduleSpecifier: xe.moduleSpecifier, ambientModuleName: vr, fileName: xe.fileName, isPackageJsonImport: mr };
                  return Ar;
                }
                var Oe = { exportName: xe.exportName, exportMapKey: xe.exportMapKey, fileName: xe.fileName, ambientModuleName: xe.fileName ? void 0 : e2.stripQuotes(xe.moduleSymbol.name), isPackageJsonImport: xe.isFromPackageJson ? true : void 0 };
                return Oe;
              }
              function fe(xe, vr, mr) {
                var Ar = xe.exportName === "default", Oe = !!xe.isPackageJsonImport;
                if (R(xe)) {
                  var nr = { kind: 32, exportName: xe.exportName, moduleSpecifier: xe.moduleSpecifier, symbolName: vr, fileName: xe.fileName, moduleSymbol: mr, isDefaultExport: Ar, isFromPackageJson: Oe };
                  return nr;
                }
                var Mr = { kind: 4, exportName: xe.exportName, exportMapKey: xe.exportMapKey, symbolName: vr, fileName: xe.fileName, moduleSymbol: mr, isDefaultExport: Ar, isFromPackageJson: Oe };
                return Mr;
              }
              function g(xe, vr, mr, Ar, Oe, nr, Mr) {
                var Pe, Ue, fr, De = vr.getSourceFile(), gr = e2.createTextSpanFromNode(e2.findAncestor(vr, e2.or(e2.isImportDeclaration, e2.isImportEqualsDeclaration)) || vr, De), Vr = e2.quote(De, Mr, Ar.moduleSpecifier), Tr = Ar.isDefaultExport ? 1 : Ar.exportName === "export=" ? 2 : 0, vi = Mr.includeCompletionsWithSnippetText ? "$1" : "", Ui = e2.codefix.getImportKind(De, Tr, nr, true), Yi = ((Ue = (Pe = e2.tryCast(vr, e2.isImportDeclaration)) === null || Pe === void 0 ? void 0 : Pe.importClause) === null || Ue === void 0 ? void 0 : Ue.isTypeOnly) || ((fr = e2.tryCast(vr, e2.isImportEqualsDeclaration)) === null || fr === void 0 ? void 0 : fr.isTypeOnly), Wi = ae(vr, mr), ct = Yi ? " ".concat(e2.tokenToString(152), " ") : " ", Li = Wi ? "".concat(e2.tokenToString(152), " ") : "", nt = Oe ? ";" : "";
                switch (Ui) {
                  case 3:
                    return { replacementSpan: gr, insertText: "import".concat(ct).concat(e2.escapeSnippetText(xe)).concat(vi, " = require(").concat(Vr, ")").concat(nt) };
                  case 1:
                    return { replacementSpan: gr, insertText: "import".concat(ct).concat(e2.escapeSnippetText(xe)).concat(vi, " from ").concat(Vr).concat(nt) };
                  case 2:
                    return { replacementSpan: gr, insertText: "import".concat(ct, "* as ").concat(e2.escapeSnippetText(xe), " from ").concat(Vr).concat(nt) };
                  case 0:
                    return { replacementSpan: gr, insertText: "import".concat(ct, "{ ").concat(Li).concat(e2.escapeSnippetText(xe)).concat(vi, " } from ").concat(Vr).concat(nt) };
                }
              }
              function ne(xe, vr, mr) {
                return /^\d+$/.test(mr) ? mr : e2.quote(xe, vr, mr);
              }
              function ue(xe, vr, mr) {
                return xe === vr || !!(xe.flags & 1048576) && mr.getExportSymbolOfSymbol(xe) === vr;
              }
              function We(xe) {
                if (le(xe))
                  return e2.stripQuotes(xe.moduleSymbol.name);
                if (N(xe))
                  return xe.moduleSpecifier;
                if ((xe == null ? void 0 : xe.kind) === 1)
                  return w.ThisProperty;
                if ((xe == null ? void 0 : xe.kind) === 64)
                  return w.TypeOnlyAlias;
              }
              function Fe(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr, De, gr, Vr, Tr, vi, Ui, Yi, Wi, ct, Li, nt, Mt, xt, ut) {
                for (var Dt, Rt = e2.timestamp(), Ii = ti(Oe), Ki = e2.probablyUsesSemicolons(nr), Fi = Pe.getTypeChecker(), ui = new e2.Map(), Bt = 0; Bt < xe.length; Bt++) {
                  var wt = xe[Bt], na = nt == null ? void 0 : nt[Bt], Ai = Er(wt, Ue, na, De, !!Yi);
                  if (!(!Ai || ui.get(Ai.name) && (!na || !T(na)) || De === 1 && Mt && !$a(wt, Mt))) {
                    var Oi = Ai.name, ji = Ai.needsConvertPropertyAccess, Vi = (Dt = Mt == null ? void 0 : Mt[e2.getSymbolId(wt)]) !== null && Dt !== void 0 ? Dt : C.SortText.LocationPriority, at = zr(wt, Fi) ? C.SortText.Deprecated(Vi) : Vi, At = k(wt, at, mr, Ar, Oe, nr, Mr, Pe, Oi, ji, na, Li, Ui, Wi, ct, Ki, Vr, gr, De, Tr, xt, ut);
                    if (!!At) {
                      var ba = (!na || f4(na)) && !(wt.parent === void 0 && !e2.some(wt.declarations, function(Qa) {
                        return Qa.getSourceFile() === Oe.getSourceFile();
                      }));
                      ui.set(Oi, ba), e2.insertSorted(vr, At, ie, true);
                    }
                  }
                }
                return fr("getCompletionsAtPosition: getCompletionEntriesFromSymbols: " + (e2.timestamp() - Rt)), { has: function(Qa) {
                  return ui.has(Qa);
                }, add: function(Qa) {
                  return ui.set(Qa, true);
                } };
                function $a(Qa, ai) {
                  var Dn = Qa.flags;
                  if (!e2.isSourceFile(Oe)) {
                    if (e2.isExportAssignment(Oe.parent))
                      return true;
                    if (Ii && Qa.valueDeclaration === Ii)
                      return false;
                    var ka = e2.skipAlias(Qa, Fi);
                    if (!!nr.externalModuleIndicator && !Vr.allowUmdGlobalAccess && ai[e2.getSymbolId(Qa)] === C.SortText.GlobalsOrKeywords && (ai[e2.getSymbolId(ka)] === C.SortText.AutoImportSuggestions || ai[e2.getSymbolId(ka)] === C.SortText.LocationPriority))
                      return false;
                    if (Dn |= e2.getCombinedLocalAndExportSymbolFlags(ka), e2.isInRightSideOfInternalImportEqualsDeclaration(Oe))
                      return !!(Dn & 1920);
                    if (vi)
                      return Sr(Qa, Fi);
                  }
                  return !!(Dn & 111551);
                }
              }
              C.getCompletionEntriesFromSymbols = Fe;
              function Z2(xe) {
                var vr = Be(xe);
                if (vr.length)
                  return { isGlobalCompletion: false, isMemberCompletion: false, isNewIdentifierLocation: false, entries: vr };
              }
              function Be(xe) {
                for (var vr = [], mr = new e2.Map(), Ar = xe; Ar && !e2.isFunctionLike(Ar); ) {
                  if (e2.isLabeledStatement(Ar)) {
                    var Oe = Ar.label.text;
                    mr.has(Oe) || (mr.set(Oe, true), vr.push({ name: Oe, kindModifiers: "", kind: "label", sortText: C.SortText.LocationPriority }));
                  }
                  Ar = Ar.parent;
                }
                return vr;
              }
              function ge(xe, vr, mr, Ar, Oe, nr, Mr) {
                if (Oe.data) {
                  var Pe = Br(Oe.name, Oe.data, xe, nr);
                  if (Pe) {
                    var Ue = Ye(Ar, mr), fr = Ue.contextToken, De = Ue.previousToken;
                    return { type: "symbol", symbol: Pe.symbol, location: e2.getTouchingPropertyName(mr, Ar), previousToken: De, contextToken: fr, isJsxInitializer: false, isTypeOnlyLocation: false, origin: Pe.origin };
                  }
                }
                var gr = xe.getCompilerOptions(), Vr = ir(xe, vr, mr, gr, Ar, { includeCompletionsForModuleExports: true, includeCompletionsWithInsertText: true }, Oe, nr, void 0);
                if (!Vr)
                  return { type: "none" };
                if (Vr.kind !== 0)
                  return { type: "request", request: Vr };
                var Tr = Vr.symbols, vi = Vr.literals, Ui = Vr.location, Yi = Vr.completionKind, Wi = Vr.symbolToOriginInfoMap, ct = Vr.contextToken, Li = Vr.previousToken, nt = Vr.isJsxInitializer, Mt = Vr.isTypeOnlyLocation, xt = e2.find(vi, function(ut) {
                  return L(mr, Mr, ut) === Oe.name;
                });
                return xt !== void 0 ? { type: "literal", literal: xt } : e2.firstDefined(Tr, function(ut, Dt) {
                  var Rt = Wi[Dt], Ii = Er(ut, e2.getEmitScriptTarget(gr), Rt, Yi, Vr.isJsxIdentifierExpected);
                  return Ii && Ii.name === Oe.name && (Oe.source === w.ClassMemberSnippet && ut.flags & 106500 || Oe.source === w.ObjectLiteralMethodSnippet && ut.flags & 8196 || We(Rt) === Oe.source) ? { type: "symbol", symbol: ut, location: Ui, origin: Rt, contextToken: ct, previousToken: Li, isJsxInitializer: nt, isTypeOnlyLocation: Mt } : void 0;
                }) || { type: "none" };
              }
              function Re(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue) {
                var fr = xe.getTypeChecker(), De = xe.getCompilerOptions(), gr = Oe.name, Vr = Oe.source, Tr = Oe.data, vi = e2.findPrecedingToken(Ar, mr);
                if (e2.isInString(mr, Ar, vi))
                  return C.StringCompletions.getStringLiteralCompletionDetails(gr, mr, Ar, vi, fr, De, nr, Ue, Pe);
                var Ui = ge(xe, vr, mr, Ar, Oe, nr, Pe);
                switch (Ui.type) {
                  case "request": {
                    var Yi = Ui.request;
                    switch (Yi.kind) {
                      case 1:
                        return e2.JsDoc.getJSDocTagNameCompletionDetails(gr);
                      case 2:
                        return e2.JsDoc.getJSDocTagCompletionDetails(gr);
                      case 3:
                        return e2.JsDoc.getJSDocParameterNameCompletionDetails(gr);
                      case 4:
                        return e2.some(Yi.keywordCompletions, function(Ii) {
                          return Ii.name === gr;
                        }) ? ze(gr, "keyword", e2.SymbolDisplayPartKind.keyword) : void 0;
                      default:
                        return e2.Debug.assertNever(Yi);
                    }
                  }
                  case "symbol": {
                    var Wi = Ui.symbol, ct = Ui.location, Li = Ui.contextToken, nt = Ui.origin, Mt = Ui.previousToken, xt = rr(gr, ct, Li, nt, Wi, xe, nr, De, mr, Ar, Mt, Mr, Pe, Tr, Vr), ut = xt.codeActions, Dt = xt.sourceDisplay;
                    return Ee(Wi, fr, mr, ct, Ue, ut, Dt);
                  }
                  case "literal": {
                    var Rt = Ui.literal;
                    return ze(L(mr, Pe, Rt), "string", typeof Rt == "string" ? e2.SymbolDisplayPartKind.stringLiteral : e2.SymbolDisplayPartKind.numericLiteral);
                  }
                  case "none":
                    return n().some(function(Ii) {
                      return Ii.name === gr;
                    }) ? ze(gr, "keyword", e2.SymbolDisplayPartKind.keyword) : void 0;
                  default:
                    e2.Debug.assertNever(Ui);
                }
              }
              C.getCompletionEntryDetails = Re;
              function ze(xe, vr, mr) {
                return He(xe, "", vr, [e2.displayPart(xe, mr)]);
              }
              function Ee(xe, vr, mr, Ar, Oe, nr, Mr) {
                var Pe = vr.runWithCancellationToken(Oe, function(Vr) {
                  return e2.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(Vr, xe, mr, Ar, Ar, 7);
                }), Ue = Pe.displayParts, fr = Pe.documentation, De = Pe.symbolKind, gr = Pe.tags;
                return He(xe.name, e2.SymbolDisplay.getSymbolModifiers(vr, xe), De, Ue, fr, gr, nr, Mr);
              }
              C.createCompletionDetailsForSymbol = Ee;
              function He(xe, vr, mr, Ar, Oe, nr, Mr, Pe) {
                return { name: xe, kindModifiers: vr, kind: mr, displayParts: Ar, documentation: Oe, tags: nr, codeActions: Mr, source: Pe, sourceDisplay: Pe };
              }
              C.createCompletionDetails = He;
              function rr(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr, De, gr, Vr, Tr, vi) {
                if (Tr != null && Tr.moduleSpecifier && De && pi(mr || De).replacementNode)
                  return { codeActions: void 0, sourceDisplay: [e2.textPart(Tr.moduleSpecifier)] };
                if (vi === w.ClassMemberSnippet) {
                  var Ui = U(Mr, nr, Pe, Vr, xe, Oe, vr, mr, gr).importAdder;
                  if (Ui) {
                    var Yi = e2.textChanges.ChangeTracker.with({ host: Mr, formatContext: gr, preferences: Vr }, Ui.writeFixes);
                    return { sourceDisplay: void 0, codeActions: [{ changes: Yi, description: e2.diagnosticToString([e2.Diagnostics.Includes_imports_of_types_referenced_by_0, xe]) }] };
                  }
                }
                if (f4(Ar)) {
                  var Wi = e2.codefix.getPromoteTypeOnlyCompletionAction(Ue, Ar.declaration.name, nr, Mr, gr, Vr);
                  return e2.Debug.assertIsDefined(Wi, "Expected to have a code action for promoting type-only alias"), { codeActions: [Wi], sourceDisplay: void 0 };
                }
                if (!Ar || !(le(Ar) || N(Ar)))
                  return { codeActions: void 0, sourceDisplay: void 0 };
                var ct = Ar.isFromPackageJson ? Mr.getPackageJsonAutoImportProvider().getTypeChecker() : nr.getTypeChecker(), Li = Ar.moduleSymbol, nt = ct.getMergedSymbol(e2.skipAlias(Oe.exportSymbol || Oe, ct)), Mt = (mr == null ? void 0 : mr.kind) === 29 && e2.isJsxOpeningLikeElement(mr.parent), xt = e2.codefix.getImportCompletionAction(nt, Li, Ue, e2.getNameForExportedSymbol(Oe, e2.getEmitScriptTarget(Pe), Mt), Mt, Mr, nr, gr, De && e2.isIdentifier(De) ? De.getStart(Ue) : fr, Vr), ut = xt.moduleSpecifier, Dt = xt.codeAction;
                return e2.Debug.assert(!(Tr != null && Tr.moduleSpecifier) || ut === Tr.moduleSpecifier), { sourceDisplay: [e2.textPart(ut)], codeActions: [Dt] };
              }
              function Ie(xe, vr, mr, Ar, Oe, nr, Mr) {
                var Pe = ge(xe, vr, mr, Ar, Oe, nr, Mr);
                return Pe.type === "symbol" ? Pe.symbol : void 0;
              }
              C.getCompletionEntrySymbol = Ie;
              var _e;
              (function(xe) {
                xe[xe.Data = 0] = "Data", xe[xe.JsDocTagName = 1] = "JsDocTagName", xe[xe.JsDocTag = 2] = "JsDocTag", xe[xe.JsDocParameterName = 3] = "JsDocParameterName", xe[xe.Keywords = 4] = "Keywords";
              })(_e || (_e = {}));
              var we;
              (function(xe) {
                xe[xe.ObjectPropertyDeclaration = 0] = "ObjectPropertyDeclaration", xe[xe.Global = 1] = "Global", xe[xe.PropertyAccess = 2] = "PropertyAccess", xe[xe.MemberLike = 3] = "MemberLike", xe[xe.String = 4] = "String", xe[xe.None = 5] = "None";
              })(we = C.CompletionKind || (C.CompletionKind = {}));
              function de(xe, vr, mr) {
                return e2.firstDefined(vr && (vr.isUnion() ? vr.types : [vr]), function(Ar) {
                  var Oe = Ar && Ar.symbol;
                  return Oe && Oe.flags & 424 && !e2.isAbstractConstructorSymbol(Oe) ? Ae(Oe, xe, mr) : void 0;
                });
              }
              function ye(xe, vr, mr, Ar) {
                var Oe = xe.parent;
                switch (xe.kind) {
                  case 79:
                    return e2.getContextualTypeFromParent(xe, Ar);
                  case 63:
                    switch (Oe.kind) {
                      case 254:
                        return Ar.getContextualType(Oe.initializer);
                      case 221:
                        return Ar.getTypeAtLocation(Oe.left);
                      case 285:
                        return Ar.getContextualTypeForJsxAttribute(Oe);
                      default:
                        return;
                    }
                  case 103:
                    return Ar.getContextualType(Oe);
                  case 82:
                    var nr = e2.tryCast(Oe, e2.isCaseClause);
                    return nr ? e2.getSwitchedType(nr, Ar) : void 0;
                  case 18:
                    return e2.isJsxExpression(Oe) && !e2.isJsxElement(Oe.parent) && !e2.isJsxFragment(Oe.parent) ? Ar.getContextualTypeForJsxAttribute(Oe.parent) : void 0;
                  default:
                    var Mr = e2.SignatureHelp.getArgumentInfoForCompletions(xe, vr, mr);
                    return Mr ? Ar.getContextualTypeForArgumentAtIndex(Mr.invocation, Mr.argumentIndex + (xe.kind === 27 ? 1 : 0)) : e2.isEqualityOperatorKind(xe.kind) && e2.isBinaryExpression(Oe) && e2.isEqualityOperatorKind(Oe.operatorToken.kind) ? Ar.getTypeAtLocation(Oe.left) : Ar.getContextualType(xe);
                }
              }
              function Ae(xe, vr, mr) {
                var Ar = mr.getAccessibleSymbolChain(xe, vr, 67108863, false);
                return Ar ? e2.first(Ar) : xe.parent && (er(xe.parent) ? xe : Ae(xe.parent, vr, mr));
              }
              function er(xe) {
                var vr;
                return !!(!((vr = xe.declarations) === null || vr === void 0) && vr.some(function(mr) {
                  return mr.kind === 305;
                }));
              }
              function ir(xe, vr, mr, Ar, Oe, nr, Mr, Pe, Ue, fr) {
                var De = xe.getTypeChecker(), gr = $(mr, Ar), Vr = e2.timestamp(), Tr = e2.getTokenAtPosition(mr, Oe);
                vr("getCompletionData: Get current token: " + (e2.timestamp() - Vr)), Vr = e2.timestamp();
                var vi = e2.isInComment(mr, Oe, Tr);
                vr("getCompletionData: Is inside comment: " + (e2.timestamp() - Vr));
                var Ui = false, Yi = false;
                if (vi) {
                  if (e2.hasDocComment(mr, Oe)) {
                    if (mr.text.charCodeAt(Oe - 1) === 64)
                      return { kind: 1 };
                    var Wi = e2.getLineStartPositionForPosition(Oe, mr);
                    if (!/[^\*|\s(/)]/.test(mr.text.substring(Wi, Oe)))
                      return { kind: 2 };
                  }
                  var ct = ii(Tr, Oe);
                  if (ct) {
                    if (ct.tagName.pos <= Oe && Oe <= ct.tagName.end)
                      return { kind: 1 };
                    var Li = bo(ct);
                    if (Li && (Tr = e2.getTokenAtPosition(mr, Oe), (!Tr || !e2.isDeclarationName(Tr) && (Tr.parent.kind !== 347 || Tr.parent.name !== Tr)) && (Ui = ds(Li))), !Ui && e2.isJSDocParameterTag(ct) && (e2.nodeIsMissing(ct.name) || ct.name.pos <= Oe && Oe <= ct.name.end))
                      return { kind: 3, tag: ct };
                  }
                  if (!Ui) {
                    vr("Returning an empty list because completion was inside a regular comment or plain text part of a JsDoc comment.");
                    return;
                  }
                }
                Vr = e2.timestamp();
                var nt = !Ui && e2.isSourceFileJS(mr), Mt = Ye(Oe, mr), xt = Mt.previousToken, ut = Mt.contextToken;
                vr("getCompletionData: Get previous token: " + (e2.timestamp() - Vr));
                var Dt = Tr, Rt, Ii = false, Ki = false, Fi = false, ui = false, Bt = false, wt = false, na, Ai = e2.getTouchingPropertyName(mr, Oe), Oi = 0, ji = false, Vi = 0;
                if (ut) {
                  var at = pi(ut);
                  if (ji = at.isNewIdentifierLocation, at.keywordCompletion) {
                    if (at.isKeywordOnlyCompletion)
                      return { kind: 4, keywordCompletions: [ve(at.keywordCompletion)], isNewIdentifierLocation: ji };
                    Oi = F2(at.keywordCompletion);
                  }
                  if (at.replacementNode && nr.includeCompletionsForImportStatements && nr.includeCompletionsWithInsertText && (na = at.replacementNode, Vi |= 2), !na && qe(ut))
                    return vr("Returning an empty list because completion was requested in an invalid position."), Oi ? he(Oi, nt, Zr()) : void 0;
                  var At = ut.parent;
                  if (ut.kind === 24 || ut.kind === 28)
                    switch (Ii = ut.kind === 24, Ki = ut.kind === 28, At.kind) {
                      case 206:
                        Rt = At, Dt = Rt.expression;
                        var ba = e2.getLeftmostAccessExpression(Rt);
                        if (e2.nodeIsMissing(ba) || (e2.isCallExpression(Dt) || e2.isFunctionLike(Dt)) && Dt.end === ut.pos && Dt.getChildCount(mr) && e2.last(Dt.getChildren(mr)).kind !== 21)
                          return;
                        break;
                      case 161:
                        Dt = At.left;
                        break;
                      case 261:
                        Dt = At.name;
                        break;
                      case 200:
                        Dt = At;
                        break;
                      case 231:
                        Dt = At.getFirstToken(mr), e2.Debug.assert(Dt.kind === 100 || Dt.kind === 103);
                        break;
                      default:
                        return;
                    }
                  else if (!na && mr.languageVariant === 1) {
                    if (At && At.kind === 206 && (ut = At, At = At.parent), Tr.parent === Ai)
                      switch (Tr.kind) {
                        case 31:
                          (Tr.parent.kind === 278 || Tr.parent.kind === 280) && (Ai = Tr);
                          break;
                        case 43:
                          Tr.parent.kind === 279 && (Ai = Tr);
                          break;
                      }
                    switch (At.kind) {
                      case 281:
                        ut.kind === 43 && (ui = true, Ai = ut);
                        break;
                      case 221:
                        if (!Gi(At))
                          break;
                      case 279:
                      case 278:
                      case 280:
                        wt = true, ut.kind === 29 && (Fi = true, Ai = ut);
                        break;
                      case 288:
                      case 287:
                        xt.kind === 19 && Tr.kind === 31 && (wt = true);
                        break;
                      case 285:
                        if (At.initializer === xt && xt.end < Oe) {
                          wt = true;
                          break;
                        }
                        switch (xt.kind) {
                          case 63:
                            Bt = true;
                            break;
                          case 79:
                            wt = true, At !== xt.parent && !At.initializer && e2.findChildOfKind(At, 63, mr) && (Bt = xt);
                        }
                        break;
                    }
                  }
                }
                var $a = e2.timestamp(), Qa = 5, ai = false, Dn = false, ka = [], Ba = [], pn = [], Cn = new e2.Map(), Bi = St(), kn = e2.memoizeOne(function(Ji) {
                  return e2.createModuleSpecifierResolutionHost(Ji ? Pe.getPackageJsonAutoImportProvider() : xe, Pe);
                });
                if (Ii || Ki)
                  Ro();
                else if (Fi)
                  ka = De.getJsxIntrinsicTagNamesAt(Ai), e2.Debug.assertEachIsDefined(ka, "getJsxIntrinsicTagNames() should all be defined"), Co(), Qa = 1, Oi = 0;
                else if (ui) {
                  var xn = ut.parent.parent.openingElement.tagName, Kn = De.getSymbolAtLocation(xn);
                  Kn && (ka = [Kn]), Qa = 1, Oi = 0;
                } else if (!Co())
                  return Oi ? he(Oi, nt, ji) : void 0;
                vr("getCompletionData: Semantic work: " + (e2.timestamp() - $a));
                var Pn = xt && ye(xt, Oe, mr, De), eo = e2.mapDefined(Pn && (Pn.isUnion() ? Pn.types : [Pn]), function(Ji) {
                  return Ji.isLiteral() && !(Ji.flags & 1024) ? Ji.value : void 0;
                }), Rn = xt && Pn && de(xt, Pn, De);
                return { kind: 0, symbols: ka, completionKind: Qa, isInSnippetScope: Yi, propertyAccessToConvert: Rt, isNewIdentifierLocation: ji, location: Ai, keywordFilters: Oi, literals: eo, symbolToOriginInfoMap: Ba, recommendedCompletion: Rn, previousToken: xt, contextToken: ut, isJsxInitializer: Bt, insideJsDocTagTypeExpression: Ui, symbolToSortTextMap: pn, isTypeOnlyLocation: Bi, isJsxIdentifierExpected: wt, isRightOfOpenTag: Fi, importCompletionNode: na, hasUnresolvedAutoImports: Dn, flags: Vi };
                function Da(Ji) {
                  switch (Ji.kind) {
                    case 340:
                    case 347:
                    case 341:
                    case 343:
                    case 345:
                      return true;
                    case 344:
                      return !!Ji.constraint;
                    default:
                      return false;
                  }
                }
                function bo(Ji) {
                  if (Da(Ji)) {
                    var ce = e2.isJSDocTemplateTag(Ji) ? Ji.constraint : Ji.typeExpression;
                    return ce && ce.kind === 309 ? ce : void 0;
                  }
                }
                function Ro() {
                  Qa = 2;
                  var Ji = e2.isLiteralImportTypeNode(Dt), ce = Ui || Ji && !Dt.isTypeOf || e2.isPartOfTypeNode(Dt.parent) || e2.isPossiblyTypeArgumentPosition(ut, mr, De), Rr = e2.isInRightSideOfInternalImportEqualsDeclaration(Dt);
                  if (e2.isEntityName(Dt) || Ji || e2.isPropertyAccessExpression(Dt)) {
                    var yi = e2.isModuleDeclaration(Dt.parent);
                    yi && (ji = true);
                    var qi = De.getSymbolAtLocation(Dt);
                    if (qi && (qi = e2.skipAlias(qi, De), qi.flags & 1920)) {
                      var je = De.getExportsOfModule(qi);
                      e2.Debug.assertEachIsDefined(je, "getExportsOfModule() should all be defined");
                      for (var Hr = function(Fo) {
                        return De.isValidPropertyAccess(Ji ? Dt : Dt.parent, Fo.name);
                      }, pt = function(Fo) {
                        return Sr(Fo, De);
                      }, Pt = yi ? function(Fo) {
                        var ko;
                        return !!(Fo.flags & 1920) && !(!((ko = Fo.declarations) === null || ko === void 0) && ko.every(function(Ao) {
                          return Ao.parent === Dt.parent;
                        }));
                      } : Rr ? function(Fo) {
                        return pt(Fo) || Hr(Fo);
                      } : ce ? pt : Hr, ga = 0, ua = je; ga < ua.length; ga++) {
                        var Xn = ua[ga];
                        Pt(Xn) && ka.push(Xn);
                      }
                      if (!ce && qi.declarations && qi.declarations.some(function(Fo) {
                        return Fo.kind !== 305 && Fo.kind !== 261 && Fo.kind !== 260;
                      })) {
                        var jr = De.getTypeOfSymbolAtLocation(qi, Dt).getNonOptionalType(), fo = false;
                        if (jr.isNullableType()) {
                          var xs = Ii && !Ki && nr.includeAutomaticOptionalChainCompletions !== false;
                          (xs || Ki) && (jr = jr.getNonNullableType(), xs && (fo = true));
                        }
                        En(jr, !!(Dt.flags & 32768), fo);
                      }
                      return;
                    }
                  }
                  if (!ce) {
                    De.tryGetThisTypeAt(Dt, false);
                    var jr = De.getTypeAtLocation(Dt).getNonOptionalType(), fo = false;
                    if (jr.isNullableType()) {
                      var xs = Ii && !Ki && nr.includeAutomaticOptionalChainCompletions !== false;
                      (xs || Ki) && (jr = jr.getNonNullableType(), xs && (fo = true));
                    }
                    En(jr, !!(Dt.flags & 32768), fo);
                  }
                }
                function En(Ji, ce, Rr) {
                  ji = !!Ji.getStringIndexType(), Ki && e2.some(Ji.getCallSignatures()) && (ji = true);
                  var yi = Dt.kind === 200 ? Dt : Dt.parent;
                  if (gr)
                    ka.push.apply(ka, e2.filter(qr(Ji, De), function(ua) {
                      return De.isValidPropertyAccessForCompletions(yi, Ji, ua);
                    }));
                  else
                    for (var qi = 0, je = Ji.getApparentProperties(); qi < je.length; qi++) {
                      var Hr = je[qi];
                      De.isValidPropertyAccessForCompletions(yi, Ji, Hr) && Wn(Hr, false, Rr);
                    }
                  if (ce && nr.includeCompletionsWithInsertText) {
                    var pt = De.getPromisedTypeOfPromise(Ji);
                    if (pt)
                      for (var Pt = 0, ga = pt.getApparentProperties(); Pt < ga.length; Pt++) {
                        var Hr = ga[Pt];
                        De.isValidPropertyAccessForCompletions(yi, pt, Hr) && Wn(Hr, true, Rr);
                      }
                  }
                }
                function Wn(Ji, ce, Rr) {
                  var yi, qi = e2.firstDefined(Ji.declarations, function(ko) {
                    return e2.tryCast(e2.getNameOfDeclaration(ko), e2.isComputedPropertyName);
                  });
                  if (qi) {
                    var je = to(qi.expression), Hr = je && De.getSymbolAtLocation(je), pt = Hr && Ae(Hr, ut, De);
                    if (pt && e2.addToSeen(Cn, e2.getSymbolId(pt))) {
                      var Pt = ka.length;
                      ka.push(pt);
                      var ga = pt.parent;
                      if (!ga || !e2.isExternalModuleSymbol(ga) || De.tryGetMemberInModuleExportsAndProperties(pt.name, ga) !== pt)
                        Ba[Pt] = { kind: Fo(2) };
                      else {
                        var ua = e2.isExternalModuleNameRelative(e2.stripQuotes(ga.name)) ? (yi = e2.getSourceFileOfModule(ga)) === null || yi === void 0 ? void 0 : yi.fileName : void 0, Xn = (e2.codefix.getModuleSpecifierForBestExportInfo([{ exportKind: 0, moduleFileName: ua, isFromPackageJson: false, moduleSymbol: ga, symbol: pt, targetFlags: e2.skipAlias(pt, De).flags }], pt.name, Oe, e2.isValidTypeOnlyAliasUseSite(Ai), mr, xe, Pe, nr) || {}).moduleSpecifier;
                        if (Xn) {
                          var jr = { kind: Fo(6), moduleSymbol: ga, isDefaultExport: false, symbolName: pt.name, exportName: pt.name, fileName: ua, moduleSpecifier: Xn };
                          Ba[Pt] = jr;
                        }
                      }
                    } else
                      nr.includeCompletionsWithInsertText && (xs(Ji), fo(Ji), ka.push(Ji));
                  } else
                    xs(Ji), fo(Ji), ka.push(Ji);
                  function fo(ko) {
                    Zt(ko) && (pn[e2.getSymbolId(ko)] = C.SortText.LocalDeclarationPriority);
                  }
                  function xs(ko) {
                    nr.includeCompletionsWithInsertText && (ce && e2.addToSeen(Cn, e2.getSymbolId(ko)) ? Ba[ka.length] = { kind: Fo(8) } : Rr && (Ba[ka.length] = { kind: 16 }));
                  }
                  function Fo(ko) {
                    return Rr ? ko | 16 : ko;
                  }
                }
                function to(Ji) {
                  return e2.isIdentifier(Ji) ? Ji : e2.isPropertyAccessExpression(Ji) ? to(Ji.expression) : void 0;
                }
                function Co() {
                  var Ji = Pi() || Qi() || no() || Ct() || sa() || Ko() || en() || Oo() || ($o(), 1);
                  return Ji === 1;
                }
                function Ko() {
                  return qn(ut) ? (Qa = 5, ji = true, Oi = 4, 1) : 0;
                }
                function Oo() {
                  var Ji = So(ut), ce = Ji && De.getContextualType(Ji.attributes);
                  if (!ce)
                    return 0;
                  var Rr = Ji && De.getContextualType(Ji.attributes, 4);
                  return ka = e2.concatenate(ka, js(mi(ce, Rr, Ji.attributes, De), Ji.attributes.properties)), hs(), Qa = 3, ji = false, 1;
                }
                function no() {
                  return na ? (ji = true, Jn(), 1) : 0;
                }
                function $o() {
                  Oi = mo(ut) ? 5 : 1, Qa = 1, ji = Zr(), xt !== ut && e2.Debug.assert(!!xt, "Expected 'contextToken' to be defined when different from 'previousToken'.");
                  var Ji = xt !== ut ? xt.getStart() : Oe, ce = Ce(ut, Ji, mr) || mr;
                  Yi = xi(ce);
                  var Rr = (Bi ? 0 : 111551) | 788968 | 1920 | 2097152, yi = xt && !e2.isValidTypeOnlyAliasUseSite(xt);
                  ka = e2.concatenate(ka, De.getSymbolsInScope(ce, Rr)), e2.Debug.assertEachIsDefined(ka, "getSymbolsInScope() should all be defined");
                  for (var qi = 0; qi < ka.length; qi++) {
                    var je = ka[qi];
                    if (!De.isArgumentsSymbol(je) && !e2.some(je.declarations, function(Xn) {
                      return Xn.getSourceFile() === mr;
                    }) && (pn[e2.getSymbolId(je)] = C.SortText.GlobalsOrKeywords), yi && !(je.flags & 111551)) {
                      var Hr = je.declarations && e2.find(je.declarations, e2.isTypeOnlyImportOrExportDeclaration);
                      if (Hr) {
                        var pt = { kind: 64, declaration: Hr };
                        Ba[qi] = pt;
                      }
                    }
                  }
                  if (nr.includeCompletionsWithInsertText && ce.kind !== 305) {
                    var Pt = De.tryGetThisTypeAt(ce, false);
                    if (Pt && !Wt(Pt, mr, De))
                      for (var ga = 0, ua = qr(Pt, De); ga < ua.length; ga++) {
                        var je = ua[ga];
                        Ba[ka.length] = { kind: 1 }, ka.push(je), pn[e2.getSymbolId(je)] = C.SortText.SuggestedClassMembers;
                      }
                  }
                  Jn(), Bi && (Oi = ut && e2.isAssertionExpression(ut.parent) ? 6 : 7);
                }
                function Pr() {
                  return na ? true : ai || !nr.includeCompletionsForModuleExports ? false : mr.externalModuleIndicator || mr.commonJsModuleIndicator || e2.compilerOptionsIndicateEsModules(xe.getCompilerOptions()) ? true : e2.programContainsModules(xe);
                }
                function xi(Ji) {
                  switch (Ji.kind) {
                    case 305:
                    case 223:
                    case 288:
                    case 235:
                      return true;
                    default:
                      return e2.isStatement(Ji);
                  }
                }
                function St() {
                  return Ui || !!na && e2.isTypeOnlyImportOrExportDeclaration(Ai.parent) || !pa(ut) && (e2.isPossiblyTypeArgumentPosition(ut, mr, De) || e2.isPartOfTypeNode(Ai) || dn(ut));
                }
                function pa(Ji) {
                  return Ji && (Ji.kind === 112 && (Ji.parent.kind === 181 || e2.isTypeOfExpression(Ji.parent)) || Ji.kind === 128 && Ji.parent.kind === 177);
                }
                function dn(Ji) {
                  if (Ji) {
                    var ce = Ji.parent.kind;
                    switch (Ji.kind) {
                      case 58:
                        return ce === 167 || ce === 166 || ce === 164 || ce === 254 || e2.isFunctionLikeKind(ce);
                      case 63:
                        return ce === 259;
                      case 127:
                        return ce === 229;
                      case 29:
                        return ce === 178 || ce === 211;
                      case 94:
                        return ce === 163;
                    }
                  }
                  return false;
                }
                function Jn() {
                  var Ji, ce;
                  if (!Pr() || (e2.Debug.assert(!(Mr != null && Mr.data), "Should not run 'collectAutoImports' when faster path is available via `data`"), Mr && !Mr.source))
                    return;
                  Vi |= 1;
                  var Rr = xt === ut && na && ae(na, ut), yi = Rr ? "" : xt && e2.isIdentifier(xt) ? xt.text.toLowerCase() : "", qi = (Ji = Pe.getModuleSpecifierCache) === null || Ji === void 0 ? void 0 : Ji.call(Pe), je = e2.getExportInfoMap(mr, Pe, xe, fr), Hr = (ce = Pe.getPackageJsonAutoImportProvider) === null || ce === void 0 ? void 0 : ce.call(Pe), pt = Mr ? void 0 : e2.createPackageJsonImportFilter(mr, nr, Pe);
                  se("collectAutoImports", Pe, xe, mr, Oe, nr, !!na, e2.isValidTypeOnlyAliasUseSite(Ai), function(ga) {
                    je.search(mr.path, Fi, function(ua, Xn) {
                      if (!e2.isIdentifierText(ua, e2.getEmitScriptTarget(Pe.getCompilationSettings())) || !Mr && e2.isStringANonContextualKeyword(ua) || !Bi && !na && !(Xn & 111551) || Bi && !(Xn & 790504))
                        return false;
                      var jr = ua.charCodeAt(0);
                      return Fi && (jr < 65 || jr > 90) ? false : Mr ? true : Wr(ua, yi);
                    }, function(ua, Xn, jr, fo) {
                      var xs;
                      if (!(Mr && !e2.some(ua, function(su) {
                        return Mr.source === e2.stripQuotes(su.moduleSymbol.name);
                      }))) {
                        var Fo = e2.find(ua, Pt);
                        if (!!Fo) {
                          var ko = ga.tryResolve(ua, Xn, jr) || {};
                          if (ko !== "failed") {
                            var Ao = Fo, Ms;
                            ko !== "skipped" && (xs = ko.exportInfo, Ao = xs === void 0 ? Fo : xs, Ms = ko.moduleSpecifier);
                            var Bs = Ao.exportKind === 1, xc = Bs && e2.getLocalSymbolForExportDefault(Ao.symbol) || Ao.symbol;
                            Qe(xc, { kind: Ms ? 32 : 4, moduleSpecifier: Ms, symbolName: Xn, exportMapKey: fo, exportName: Ao.exportKind === 2 ? "export=" : Ao.symbol.name, fileName: Ao.moduleFileName, isDefaultExport: Bs, moduleSymbol: Ao.moduleSymbol, isFromPackageJson: Ao.isFromPackageJson });
                          }
                        }
                      }
                    }), Dn = ga.skippedAny(), Vi |= ga.resolvedAny() ? 8 : 0, Vi |= ga.resolvedBeyondLimit() ? 16 : 0;
                  });
                  function Pt(ga) {
                    var ua = e2.tryCast(ga.moduleSymbol.valueDeclaration, e2.isSourceFile);
                    if (!ua) {
                      var Xn = e2.stripQuotes(ga.moduleSymbol.name);
                      return e2.JsTyping.nodeCoreModules.has(Xn) && e2.startsWith(Xn, "node:") !== e2.shouldUseUriStyleNodeCoreModules(mr, xe) ? false : pt ? pt.allowsImportingAmbientModule(ga.moduleSymbol, kn(ga.isFromPackageJson)) : true;
                    }
                    return e2.isImportableFile(ga.isFromPackageJson ? Hr : xe, mr, ua, nr, pt, kn(ga.isFromPackageJson), qi);
                  }
                }
                function Qe(Ji, ce) {
                  var Rr = e2.getSymbolId(Ji);
                  pn[Rr] !== C.SortText.GlobalsOrKeywords && (Ba[ka.length] = ce, pn[Rr] = na ? C.SortText.LocationPriority : C.SortText.AutoImportSuggestions, ka.push(Ji));
                }
                function Gr(Ji, ce) {
                  e2.isInJSFile(Ai) || Ji.forEach(function(Rr) {
                    if (!!S2(Rr)) {
                      var yi = Er(Rr, e2.getEmitScriptTarget(Ar), void 0, 0, false);
                      if (!!yi) {
                        var qi = yi.name, je = I(Rr, qi, ce, xe, Pe, Ar, nr, Ue);
                        if (!!je) {
                          var Hr = Ke({ kind: 128 }, je);
                          Vi |= 32, Ba[ka.length] = Hr, ka.push(Rr);
                        }
                      }
                    }
                  });
                }
                function S2(Ji) {
                  return !!(Ji.flags & 8196);
                }
                function Ce(Ji, ce, Rr) {
                  for (var yi = Ji; yi && !e2.positionBelongsToNode(yi, ce, Rr); )
                    yi = yi.parent;
                  return yi;
                }
                function qe(Ji) {
                  var ce = e2.timestamp(), Rr = Si(Ji) || Go(Ji) || Vc(Ji) || br(Ji) || e2.isBigIntLiteral(Ji);
                  return vr("getCompletionsAtPosition: isCompletionListBlocker: " + (e2.timestamp() - ce)), Rr;
                }
                function br(Ji) {
                  if (Ji.kind === 11)
                    return true;
                  if (Ji.kind === 31 && Ji.parent) {
                    if (Ai === Ji.parent && (Ai.kind === 280 || Ai.kind === 279))
                      return false;
                    if (Ji.parent.kind === 280)
                      return Ai.parent.kind !== 280;
                    if (Ji.parent.kind === 281 || Ji.parent.kind === 279)
                      return !!Ji.parent.parent && Ji.parent.parent.kind === 278;
                  }
                  return false;
                }
                function Zr() {
                  if (ut) {
                    var Ji = ut.parent.kind, ce = wr(ut);
                    switch (ce) {
                      case 27:
                        return Ji === 208 || Ji === 171 || Ji === 209 || Ji === 204 || Ji === 221 || Ji === 179 || Ji === 205;
                      case 20:
                        return Ji === 208 || Ji === 171 || Ji === 209 || Ji === 212 || Ji === 191;
                      case 22:
                        return Ji === 204 || Ji === 176 || Ji === 162;
                      case 141:
                      case 142:
                      case 100:
                        return true;
                      case 24:
                        return Ji === 261;
                      case 18:
                        return Ji === 257 || Ji === 205;
                      case 63:
                        return Ji === 254 || Ji === 221;
                      case 15:
                        return Ji === 223;
                      case 16:
                        return Ji === 233;
                      case 131:
                        return Ji === 169 || Ji === 297;
                      case 41:
                        return Ji === 169;
                    }
                    if (yr(ce))
                      return true;
                  }
                  return false;
                }
                function Si(Ji) {
                  return (e2.isRegularExpressionLiteral(Ji) || e2.isStringTextContainingNode(Ji)) && (e2.rangeContainsPositionExclusive(e2.createTextRangeFromSpan(e2.createTextSpanFromNode(Ji)), Oe) || Oe === Ji.end && (!!Ji.isUnterminated || e2.isRegularExpressionLiteral(Ji)));
                }
                function Pi() {
                  var Ji = Di(ut);
                  if (!Ji)
                    return 0;
                  var ce = e2.isIntersectionTypeNode(Ji.parent) ? Ji.parent : void 0, Rr = ce || Ji, yi = wi(Rr, De);
                  if (!yi)
                    return 0;
                  var qi = De.getTypeFromTypeNode(Rr), je = qr(yi, De), Hr = qr(qi, De), pt = new e2.Set();
                  return Hr.forEach(function(Pt) {
                    return pt.add(Pt.escapedName);
                  }), ka = e2.concatenate(ka, e2.filter(je, function(Pt) {
                    return !pt.has(Pt.escapedName);
                  })), Qa = 0, ji = true, 1;
                }
                function Qi() {
                  var Ji = ka.length, ce = Cr(ut);
                  if (!ce)
                    return 0;
                  Qa = 0;
                  var Rr, yi;
                  if (ce.kind === 205) {
                    var qi = _r(ce, De);
                    if (qi === void 0)
                      return ce.flags & 33554432 ? 2 : (ai = true, 0);
                    var je = De.getContextualType(ce, 4), Hr = (je || qi).getStringIndexType(), pt = (je || qi).getNumberIndexType();
                    if (ji = !!Hr || !!pt, Rr = mi(qi, je, ce, De), yi = ce.properties, Rr.length === 0 && !pt)
                      return ai = true, 0;
                  } else {
                    e2.Debug.assert(ce.kind === 201), ji = false;
                    var Pt = e2.getRootDeclaration(ce.parent);
                    if (!e2.isVariableLike(Pt))
                      return e2.Debug.fail("Root declaration is not variable-like.");
                    var ga = e2.hasInitializer(Pt) || !!e2.getEffectiveTypeAnnotationNode(Pt) || Pt.parent.parent.kind === 244;
                    if (!ga && Pt.kind === 164 && (e2.isExpression(Pt.parent) ? ga = !!De.getContextualType(Pt.parent) : (Pt.parent.kind === 169 || Pt.parent.kind === 173) && (ga = e2.isExpression(Pt.parent.parent) && !!De.getContextualType(Pt.parent.parent))), ga) {
                      var ua = De.getTypeAtLocation(ce);
                      if (!ua)
                        return 2;
                      Rr = De.getPropertiesOfType(ua).filter(function(jr) {
                        return De.isPropertyAccessible(ce, false, false, ua, jr);
                      }), yi = ce.elements;
                    }
                  }
                  if (Rr && Rr.length > 0) {
                    var Xn = Xs(Rr, e2.Debug.checkDefined(yi));
                    ka = e2.concatenate(ka, Xn), hs(), ce.kind === 205 && nr.includeCompletionsWithObjectLiteralMethodSnippets && nr.includeCompletionsWithInsertText && (ps(Ji), Gr(Xn, ce));
                  }
                  return 1;
                }
                function Ct() {
                  if (!ut)
                    return 0;
                  var Ji = ut.kind === 18 || ut.kind === 27 ? e2.tryCast(ut.parent, e2.isNamedImportsOrExports) : e2.isTypeKeywordTokenOrIdentifier(ut) ? e2.tryCast(ut.parent.parent, e2.isNamedImportsOrExports) : void 0;
                  if (!Ji)
                    return 0;
                  e2.isTypeKeywordTokenOrIdentifier(ut) || (Oi = 8);
                  var ce = (Ji.kind === 269 ? Ji.parent.parent : Ji.parent).moduleSpecifier;
                  if (!ce)
                    return ji = true, Ji.kind === 269 ? 2 : 0;
                  var Rr = De.getSymbolAtLocation(ce);
                  if (!Rr)
                    return ji = true, 2;
                  Qa = 3, ji = false;
                  var yi = De.getExportsAndPropertiesOfModule(Rr), qi = new e2.Set(Ji.elements.filter(function(Hr) {
                    return !ds(Hr);
                  }).map(function(Hr) {
                    return (Hr.propertyName || Hr.name).escapedText;
                  })), je = yi.filter(function(Hr) {
                    return Hr.escapedName !== "default" && !qi.has(Hr.escapedName);
                  });
                  return ka = e2.concatenate(ka, je), je.length || (Oi = 0), 1;
                }
                function sa() {
                  var Ji, ce = ut && (ut.kind === 18 || ut.kind === 27) ? e2.tryCast(ut.parent, e2.isNamedExports) : void 0;
                  if (!ce)
                    return 0;
                  var Rr = e2.findAncestor(ce, e2.or(e2.isSourceFile, e2.isModuleDeclaration));
                  return Qa = 5, ji = false, (Ji = Rr.locals) === null || Ji === void 0 || Ji.forEach(function(yi, qi) {
                    var je, Hr;
                    ka.push(yi), !((Hr = (je = Rr.symbol) === null || je === void 0 ? void 0 : je.exports) === null || Hr === void 0) && Hr.has(qi) && (pn[e2.getSymbolId(yi)] = C.SortText.OptionalMember);
                  }), 1;
                }
                function en() {
                  var Ji = si(mr, ut, Ai, Oe);
                  if (!Ji)
                    return 0;
                  if (Qa = 3, ji = true, Oi = ut.kind === 41 ? 0 : e2.isClassLike(Ji) ? 2 : 3, !e2.isClassLike(Ji))
                    return 1;
                  var ce = ut.kind === 26 ? ut.parent.parent : ut.parent, Rr = e2.isClassElement(ce) ? e2.getEffectiveModifierFlags(ce) : 0;
                  if (ut.kind === 79 && !ds(ut))
                    switch (ut.getText()) {
                      case "private":
                        Rr = Rr | 8;
                        break;
                      case "static":
                        Rr = Rr | 32;
                        break;
                      case "override":
                        Rr = Rr | 16384;
                        break;
                    }
                  if (e2.isClassStaticBlockDeclaration(ce) && (Rr |= 32), !(Rr & 8)) {
                    var yi = e2.isClassLike(Ji) && Rr & 16384 ? e2.singleElementArray(e2.getEffectiveBaseTypeNode(Ji)) : e2.getAllSuperTypeNodes(Ji), qi = e2.flatMap(yi, function(je) {
                      var Hr = De.getTypeAtLocation(je);
                      return Rr & 32 ? (Hr == null ? void 0 : Hr.symbol) && De.getPropertiesOfType(De.getTypeOfSymbolAtLocation(Hr.symbol, Ji)) : Hr && De.getPropertiesOfType(Hr);
                    });
                    ka = e2.concatenate(ka, Qs(qi, Ji.members, Rr));
                  }
                  return 1;
                }
                function Wa(Ji) {
                  return !!Ji.parent && e2.isParameter(Ji.parent) && e2.isConstructorDeclaration(Ji.parent.parent) && (e2.isParameterPropertyModifier(Ji.kind) || e2.isDeclarationName(Ji));
                }
                function qn(Ji) {
                  if (Ji) {
                    var ce = Ji.parent;
                    switch (Ji.kind) {
                      case 20:
                      case 27:
                        return e2.isConstructorDeclaration(Ji.parent) ? Ji.parent : void 0;
                      default:
                        if (Wa(Ji))
                          return ce.parent;
                    }
                  }
                }
                function mo(Ji) {
                  if (Ji) {
                    var ce, Rr = e2.findAncestor(Ji.parent, function(yi) {
                      return e2.isClassLike(yi) ? "quit" : e2.isFunctionLikeDeclaration(yi) && ce === yi.body ? true : (ce = yi, false);
                    });
                    return Rr && Rr;
                  }
                }
                function So(Ji) {
                  if (Ji) {
                    var ce = Ji.parent;
                    switch (Ji.kind) {
                      case 31:
                      case 30:
                      case 43:
                      case 79:
                      case 206:
                      case 286:
                      case 285:
                      case 287:
                        if (ce && (ce.kind === 279 || ce.kind === 280)) {
                          if (Ji.kind === 31) {
                            var Rr = e2.findPrecedingToken(Ji.pos, mr, void 0);
                            if (!ce.typeArguments || Rr && Rr.kind === 43)
                              break;
                          }
                          return ce;
                        } else if (ce.kind === 285)
                          return ce.parent.parent;
                        break;
                      case 10:
                        if (ce && (ce.kind === 285 || ce.kind === 287))
                          return ce.parent.parent;
                        break;
                      case 19:
                        if (ce && ce.kind === 288 && ce.parent && ce.parent.kind === 285)
                          return ce.parent.parent.parent;
                        if (ce && ce.kind === 287)
                          return ce.parent.parent;
                        break;
                    }
                  }
                }
                function Go(Ji) {
                  var ce = Ji.parent, Rr = ce.kind;
                  switch (Ji.kind) {
                    case 27:
                      return Rr === 254 || Kc(Ji) || Rr === 237 || Rr === 260 || Pc(Rr) || Rr === 258 || Rr === 202 || Rr === 259 || e2.isClassLike(ce) && !!ce.typeParameters && ce.typeParameters.end >= Ji.pos;
                    case 24:
                      return Rr === 202;
                    case 58:
                      return Rr === 203;
                    case 22:
                      return Rr === 202;
                    case 20:
                      return Rr === 292 || Pc(Rr);
                    case 18:
                      return Rr === 260;
                    case 29:
                      return Rr === 257 || Rr === 226 || Rr === 258 || Rr === 259 || e2.isFunctionLikeKind(Rr);
                    case 124:
                      return Rr === 167 && !e2.isClassLike(ce.parent);
                    case 25:
                      return Rr === 164 || !!ce.parent && ce.parent.kind === 202;
                    case 123:
                    case 121:
                    case 122:
                      return Rr === 164 && !e2.isConstructorDeclaration(ce.parent);
                    case 127:
                      return Rr === 270 || Rr === 275 || Rr === 268;
                    case 136:
                    case 149:
                      return !Xi(Ji);
                    case 79:
                      if (Rr === 270 && Ji === ce.name && Ji.text === "type")
                        return false;
                      break;
                    case 84:
                    case 92:
                    case 118:
                    case 98:
                    case 113:
                    case 100:
                    case 119:
                    case 85:
                    case 137:
                      return true;
                    case 152:
                      return Rr !== 270;
                    case 41:
                      return e2.isFunctionLike(Ji.parent) && !e2.isMethodDeclaration(Ji.parent);
                  }
                  if (yr(wr(Ji)) && Xi(Ji) || Wa(Ji) && (!e2.isIdentifier(Ji) || e2.isParameterPropertyModifier(wr(Ji)) || ds(Ji)))
                    return false;
                  switch (wr(Ji)) {
                    case 126:
                    case 84:
                    case 85:
                    case 135:
                    case 92:
                    case 98:
                    case 118:
                    case 119:
                    case 121:
                    case 122:
                    case 123:
                    case 124:
                    case 113:
                      return true;
                    case 131:
                      return e2.isPropertyDeclaration(Ji.parent);
                  }
                  var yi = e2.findAncestor(Ji.parent, e2.isClassLike);
                  if (yi && Ji === xt && ys(Ji, Oe))
                    return false;
                  var qi = e2.getAncestor(Ji.parent, 167);
                  if (qi && Ji !== xt && e2.isClassLike(xt.parent.parent) && Oe <= xt.end) {
                    if (ys(Ji, xt.end))
                      return false;
                    if (Ji.kind !== 63 && (e2.isInitializedProperty(qi) || e2.hasType(qi)))
                      return true;
                  }
                  return e2.isDeclarationName(Ji) && !e2.isShorthandPropertyAssignment(Ji.parent) && !e2.isJsxAttribute(Ji.parent) && !(e2.isClassLike(Ji.parent) && (Ji !== xt || Oe > xt.end));
                }
                function ys(Ji, ce) {
                  return Ji.kind !== 63 && (Ji.kind === 26 || !e2.positionsAreOnSameLine(Ji.end, ce, mr));
                }
                function Pc(Ji) {
                  return e2.isFunctionLikeKind(Ji) && Ji !== 171;
                }
                function Vc(Ji) {
                  if (Ji.kind === 8) {
                    var ce = Ji.getFullText();
                    return ce.charAt(ce.length - 1) === ".";
                  }
                  return false;
                }
                function Kc(Ji) {
                  return Ji.parent.kind === 255 && !e2.isPossiblyTypeArgumentPosition(Ji, mr, De);
                }
                function Xs(Ji, ce) {
                  if (ce.length === 0)
                    return Ji;
                  for (var Rr = new e2.Set(), yi = new e2.Set(), qi = 0, je = ce; qi < je.length; qi++) {
                    var Hr = je[qi];
                    if (!(Hr.kind !== 296 && Hr.kind !== 297 && Hr.kind !== 203 && Hr.kind !== 169 && Hr.kind !== 172 && Hr.kind !== 173 && Hr.kind !== 298) && !ds(Hr)) {
                      var pt = void 0;
                      if (e2.isSpreadAssignment(Hr))
                        pc(Hr, Rr);
                      else if (e2.isBindingElement(Hr) && Hr.propertyName)
                        Hr.propertyName.kind === 79 && (pt = Hr.propertyName.escapedText);
                      else {
                        var Pt = e2.getNameOfDeclaration(Hr);
                        pt = Pt && e2.isPropertyNameLiteral(Pt) ? e2.getEscapedTextOfIdentifierOrLiteral(Pt) : void 0;
                      }
                      pt !== void 0 && yi.add(pt);
                    }
                  }
                  var ga = Ji.filter(function(ua) {
                    return !yi.has(ua.escapedName);
                  });
                  return tc(Rr, ga), ga;
                }
                function pc(Ji, ce) {
                  var Rr = Ji.expression, yi = De.getSymbolAtLocation(Rr), qi = yi && De.getTypeOfSymbolAtLocation(yi, Rr), je = qi && qi.properties;
                  je && je.forEach(function(Hr) {
                    ce.add(Hr.name);
                  });
                }
                function hs() {
                  ka.forEach(function(Ji) {
                    var ce;
                    if (Ji.flags & 16777216) {
                      var Rr = e2.getSymbolId(Ji);
                      pn[Rr] = (ce = pn[Rr]) !== null && ce !== void 0 ? ce : C.SortText.OptionalMember;
                    }
                  });
                }
                function tc(Ji, ce) {
                  if (Ji.size !== 0)
                    for (var Rr = 0, yi = ce; Rr < yi.length; Rr++) {
                      var qi = yi[Rr];
                      Ji.has(qi.name) && (pn[e2.getSymbolId(qi)] = C.SortText.MemberDeclaredBySpreadAssignment);
                    }
                }
                function ps(Ji) {
                  for (var ce, Rr = Ji; Rr < ka.length; Rr++) {
                    var yi = ka[Rr], qi = e2.getSymbolId(yi), je = Ba == null ? void 0 : Ba[Rr], Hr = e2.getEmitScriptTarget(Ar), pt = Er(yi, Hr, je, 0, false);
                    if (pt) {
                      var Pt = (ce = pn[qi]) !== null && ce !== void 0 ? ce : C.SortText.LocationPriority, ga = pt.name;
                      pn[qi] = C.SortText.ObjectLiteralProperty(Pt, ga);
                    }
                  }
                }
                function Qs(Ji, ce, Rr) {
                  for (var yi = new e2.Set(), qi = 0, je = ce; qi < je.length; qi++) {
                    var Hr = je[qi];
                    if (!(Hr.kind !== 167 && Hr.kind !== 169 && Hr.kind !== 172 && Hr.kind !== 173) && !ds(Hr) && !e2.hasEffectiveModifier(Hr, 8) && e2.isStatic(Hr) === !!(Rr & 32)) {
                      var pt = e2.getPropertyNameForPropertyNameNode(Hr.name);
                      pt && yi.add(pt);
                    }
                  }
                  return Ji.filter(function(Pt) {
                    return !yi.has(Pt.escapedName) && !!Pt.declarations && !(e2.getDeclarationModifierFlagsFromSymbol(Pt) & 8) && !(Pt.valueDeclaration && e2.isPrivateIdentifierClassElementDeclaration(Pt.valueDeclaration));
                  });
                }
                function js(Ji, ce) {
                  for (var Rr = new e2.Set(), yi = new e2.Set(), qi = 0, je = ce; qi < je.length; qi++) {
                    var Hr = je[qi];
                    ds(Hr) || (Hr.kind === 285 ? Rr.add(Hr.name.escapedText) : e2.isJsxSpreadAttribute(Hr) && pc(Hr, yi));
                  }
                  var pt = Ji.filter(function(Pt) {
                    return !Rr.has(Pt.escapedName);
                  });
                  return tc(yi, pt), pt;
                }
                function ds(Ji) {
                  return Ji.getStart(mr) <= Oe && Oe <= Ji.getEnd();
                }
              }
              function Cr(xe) {
                if (xe) {
                  var vr = xe.parent;
                  switch (xe.kind) {
                    case 18:
                    case 27:
                      if (e2.isObjectLiteralExpression(vr) || e2.isObjectBindingPattern(vr))
                        return vr;
                      break;
                    case 41:
                      return e2.isMethodDeclaration(vr) ? e2.tryCast(vr.parent, e2.isObjectLiteralExpression) : void 0;
                    case 79:
                      return xe.text === "async" && e2.isShorthandPropertyAssignment(xe.parent) ? xe.parent.parent : void 0;
                  }
                }
              }
              function Ye(xe, vr) {
                var mr = e2.findPrecedingToken(xe, vr);
                if (mr && xe <= mr.end && (e2.isMemberName(mr) || e2.isKeyword(mr.kind))) {
                  var Ar = e2.findPrecedingToken(mr.getFullStart(), vr, void 0);
                  return { contextToken: Ar, previousToken: mr };
                }
                return { contextToken: mr, previousToken: mr };
              }
              function Br(xe, vr, mr, Ar) {
                var Oe = vr.isPackageJsonImport ? Ar.getPackageJsonAutoImportProvider() : mr, nr = Oe.getTypeChecker(), Mr = vr.ambientModuleName ? nr.tryFindAmbientModule(vr.ambientModuleName) : vr.fileName ? nr.getMergedSymbol(e2.Debug.checkDefined(Oe.getSourceFile(vr.fileName)).symbol) : void 0;
                if (!!Mr) {
                  var Pe = vr.exportName === "export=" ? nr.resolveExternalModuleSymbol(Mr) : nr.tryGetMemberInModuleExportsAndProperties(vr.exportName, Mr);
                  if (!!Pe) {
                    var Ue = vr.exportName === "default";
                    return Pe = Ue && e2.getLocalSymbolForExportDefault(Pe) || Pe, { symbol: Pe, origin: fe(vr, xe, Mr) };
                  }
                }
              }
              function Er(xe, vr, mr, Ar, Oe) {
                var nr = p(mr) ? mr.symbolName : xe.name;
                if (!(nr === void 0 || xe.flags & 1536 && e2.isSingleOrDoubleQuote(nr.charCodeAt(0)) || e2.isKnownSymbol(xe))) {
                  var Mr = { name: nr, needsConvertPropertyAccess: false };
                  if (e2.isIdentifierText(nr, vr, Oe ? 1 : 0) || xe.valueDeclaration && e2.isPrivateIdentifierClassElementDeclaration(xe.valueDeclaration))
                    return Mr;
                  switch (Ar) {
                    case 3:
                      return;
                    case 0:
                      return { name: JSON.stringify(nr), needsConvertPropertyAccess: false };
                    case 2:
                    case 1:
                      return nr.charCodeAt(0) === 32 ? void 0 : { name: nr, needsConvertPropertyAccess: true };
                    case 5:
                    case 4:
                      return Mr;
                    default:
                      e2.Debug.assertNever(Ar);
                  }
                }
              }
              var Ne = [], n = e2.memoize(function() {
                for (var xe = [], vr = 81; vr <= 160; vr++)
                  xe.push({ name: e2.tokenToString(vr), kind: "keyword", kindModifiers: "", sortText: C.SortText.GlobalsOrKeywords });
                return xe;
              });
              function lr(xe, vr) {
                if (!vr)
                  return be(xe);
                var mr = xe + 8 + 1;
                return Ne[mr] || (Ne[mr] = be(xe).filter(function(Ar) {
                  return !Ge(e2.stringToToken(Ar.name));
                }));
              }
              function be(xe) {
                return Ne[xe] || (Ne[xe] = n().filter(function(vr) {
                  var mr = e2.stringToToken(vr.name);
                  switch (xe) {
                    case 0:
                      return false;
                    case 1:
                      return Ir(mr) || mr === 135 || mr === 141 || mr === 152 || mr === 142 || mr === 126 || e2.isTypeKeyword(mr) && mr !== 153;
                    case 5:
                      return Ir(mr);
                    case 2:
                      return yr(mr);
                    case 3:
                      return ur(mr);
                    case 4:
                      return e2.isParameterPropertyModifier(mr);
                    case 6:
                      return e2.isTypeKeyword(mr) || mr === 85;
                    case 7:
                      return e2.isTypeKeyword(mr);
                    case 8:
                      return mr === 152;
                    default:
                      return e2.Debug.assertNever(xe);
                  }
                }));
              }
              function Ge(xe) {
                switch (xe) {
                  case 126:
                  case 130:
                  case 158:
                  case 133:
                  case 135:
                  case 92:
                  case 157:
                  case 117:
                  case 137:
                  case 118:
                  case 139:
                  case 140:
                  case 141:
                  case 142:
                  case 143:
                  case 147:
                  case 148:
                  case 159:
                  case 121:
                  case 122:
                  case 123:
                  case 145:
                  case 150:
                  case 151:
                  case 152:
                  case 154:
                  case 155:
                    return true;
                  default:
                    return false;
                }
              }
              function ur(xe) {
                return xe === 145;
              }
              function yr(xe) {
                switch (xe) {
                  case 126:
                  case 134:
                  case 136:
                  case 149:
                  case 131:
                  case 135:
                  case 159:
                    return true;
                  default:
                    return e2.isClassMemberModifier(xe);
                }
              }
              function Ir(xe) {
                return xe === 131 || xe === 132 || xe === 127 || !e2.isContextualKeyword(xe) && !yr(xe);
              }
              function wr(xe) {
                return e2.isIdentifier(xe) ? xe.originalKeywordKind || 0 : xe.kind;
              }
              function Ur(xe, vr) {
                var mr = [];
                if (xe) {
                  var Ar = xe.getSourceFile(), Oe = xe.parent, nr = Ar.getLineAndCharacterOfPosition(xe.end).line, Mr = Ar.getLineAndCharacterOfPosition(vr).line;
                  (e2.isImportDeclaration(Oe) || e2.isExportDeclaration(Oe) && Oe.moduleSpecifier) && xe === Oe.moduleSpecifier && nr === Mr && mr.push({ name: e2.tokenToString(129), kind: "keyword", kindModifiers: "", sortText: C.SortText.GlobalsOrKeywords });
                }
                return mr;
              }
              function ii(xe, vr) {
                return e2.findAncestor(xe, function(mr) {
                  return e2.isJSDocTag(mr) && e2.rangeContainsPosition(mr, vr) ? true : e2.isJSDoc(mr) ? "quit" : false;
                });
              }
              function mi(xe, vr, mr, Ar) {
                var Oe = vr && vr !== xe, nr = Oe && !(vr.flags & 3) ? Ar.getUnionType([xe, vr]) : xe, Mr = pe(nr, mr, Ar);
                return nr.isClass() && or(Mr) ? [] : Oe ? e2.filter(Mr, Pe) : Mr;
                function Pe(Ue) {
                  return e2.length(Ue.declarations) ? e2.some(Ue.declarations, function(fr) {
                    return fr.parent !== mr;
                  }) : true;
                }
              }
              C.getPropertiesForObjectExpression = mi;
              function pe(xe, vr, mr) {
                return xe.isUnion() ? mr.getAllPossiblePropertiesOfTypes(e2.filter(xe.types, function(Ar) {
                  return !(Ar.flags & 131068 || mr.isArrayLikeType(Ar) || mr.isTypeInvalidDueToUnionDiscriminant(Ar, vr) || e2.typeHasCallOrConstructSignatures(Ar, mr) || Ar.isClass() && or(Ar.getApparentProperties()));
                })) : xe.getApparentProperties();
              }
              function or(xe) {
                return e2.some(xe, function(vr) {
                  return !!(e2.getDeclarationModifierFlagsFromSymbol(vr) & 24);
                });
              }
              function qr(xe, vr) {
                return xe.isUnion() ? e2.Debug.checkEachDefined(vr.getAllPossiblePropertiesOfTypes(xe.types), "getAllPossiblePropertiesOfTypes() should all be defined") : e2.Debug.checkEachDefined(xe.getApparentProperties(), "getApparentProperties() should all be defined");
              }
              function si(xe, vr, mr, Ar) {
                switch (mr.kind) {
                  case 348:
                    return e2.tryCast(mr.parent, e2.isObjectTypeDeclaration);
                  case 1:
                    var Oe = e2.tryCast(e2.lastOrUndefined(e2.cast(mr.parent, e2.isSourceFile).statements), e2.isObjectTypeDeclaration);
                    if (Oe && !e2.findChildOfKind(Oe, 19, xe))
                      return Oe;
                    break;
                  case 79: {
                    if (e2.isPropertyDeclaration(mr.parent) && mr.parent.initializer === mr)
                      return;
                    if (Xi(mr))
                      return e2.findAncestor(mr, e2.isObjectTypeDeclaration);
                  }
                }
                if (!!vr) {
                  if (mr.kind === 134 || e2.isIdentifier(vr) && e2.isPropertyDeclaration(vr.parent) && e2.isClassLike(mr))
                    return e2.findAncestor(vr, e2.isClassLike);
                  switch (vr.kind) {
                    case 63:
                      return;
                    case 26:
                    case 19:
                      return Xi(mr) && mr.parent.name === mr ? mr.parent.parent : e2.tryCast(mr, e2.isObjectTypeDeclaration);
                    case 18:
                    case 27:
                      return e2.tryCast(vr.parent, e2.isObjectTypeDeclaration);
                    default:
                      if (!Xi(vr))
                        return e2.getLineAndCharacterOfPosition(xe, vr.getEnd()).line !== e2.getLineAndCharacterOfPosition(xe, Ar).line && e2.isObjectTypeDeclaration(mr) ? mr : void 0;
                      var nr = e2.isClassLike(vr.parent.parent) ? yr : ur;
                      return nr(vr.kind) || vr.kind === 41 || e2.isIdentifier(vr) && nr(e2.stringToToken(vr.text)) ? vr.parent.parent : void 0;
                  }
                }
              }
              function Di(xe) {
                if (!!xe) {
                  var vr = xe.parent;
                  switch (xe.kind) {
                    case 18:
                      if (e2.isTypeLiteralNode(vr))
                        return vr;
                      break;
                    case 26:
                    case 27:
                    case 79:
                      if (vr.kind === 166 && e2.isTypeLiteralNode(vr.parent))
                        return vr.parent;
                      break;
                  }
                }
              }
              function wi(xe, vr) {
                if (!!xe) {
                  if (e2.isTypeNode(xe) && e2.isTypeReferenceType(xe.parent))
                    return vr.getTypeArgumentConstraint(xe);
                  var mr = wi(xe.parent, vr);
                  if (!!mr)
                    switch (xe.kind) {
                      case 166:
                        return vr.getTypeOfPropertyOfContextualType(mr, xe.symbol.escapedName);
                      case 188:
                      case 182:
                      case 187:
                        return mr;
                    }
                }
              }
              function Xi(xe) {
                return xe.parent && e2.isClassOrTypeElement(xe.parent) && e2.isObjectTypeDeclaration(xe.parent.parent);
              }
              function et(xe, vr, mr, Ar) {
                switch (vr) {
                  case ".":
                  case "@":
                    return true;
                  case '"':
                  case "'":
                  case "`":
                    return !!mr && e2.isStringLiteralOrTemplate(mr) && Ar === mr.getStart(xe) + 1;
                  case "#":
                    return !!mr && e2.isPrivateIdentifier(mr) && !!e2.getContainingClass(mr);
                  case "<":
                    return !!mr && mr.kind === 29 && (!e2.isBinaryExpression(mr.parent) || Gi(mr.parent));
                  case "/":
                    return !!mr && (e2.isStringLiteralLike(mr) ? !!e2.tryGetImportFromModuleSpecifier(mr) : mr.kind === 43 && e2.isJsxClosingElement(mr.parent));
                  case " ":
                    return !!mr && e2.isImportKeyword(mr) && mr.parent.kind === 305;
                  default:
                    return e2.Debug.assertNever(vr);
                }
              }
              function Gi(xe) {
                var vr = xe.left;
                return e2.nodeIsMissing(vr);
              }
              function Wt(xe, vr, mr) {
                var Ar = mr.resolveName("self", void 0, 111551, false);
                if (Ar && mr.getTypeOfSymbolAtLocation(Ar, vr) === xe)
                  return true;
                var Oe = mr.resolveName("global", void 0, 111551, false);
                if (Oe && mr.getTypeOfSymbolAtLocation(Oe, vr) === xe)
                  return true;
                var nr = mr.resolveName("globalThis", void 0, 111551, false);
                return !!(nr && mr.getTypeOfSymbolAtLocation(nr, vr) === xe);
              }
              function Zt(xe) {
                return !!(xe.valueDeclaration && e2.getEffectiveModifierFlags(xe.valueDeclaration) & 32 && e2.isClassLike(xe.valueDeclaration.parent));
              }
              function _r(xe, vr) {
                var mr = vr.getContextualType(xe);
                if (mr)
                  return mr;
                var Ar = e2.walkUpParenthesizedExpressions(xe.parent);
                if (e2.isBinaryExpression(Ar) && Ar.operatorToken.kind === 63 && xe === Ar.left)
                  return vr.getTypeAtLocation(Ar);
                if (e2.isExpression(Ar))
                  return vr.getContextualType(Ar);
              }
              function pi(xe) {
                var vr, mr = false, Ar = Oe();
                return { isKeywordOnlyCompletion: mr, keywordCompletion: vr, isNewIdentifierLocation: !!(Ar || vr === 152), replacementNode: Ar && e2.rangeIsOnSingleLine(Ar, Ar.getSourceFile()) ? Ar : void 0 };
                function Oe() {
                  var nr = xe.parent;
                  if (e2.isImportEqualsDeclaration(nr))
                    return vr = xe.kind === 152 ? void 0 : 152, Jr(nr.moduleReference) ? nr : void 0;
                  if (ae(nr, xe) && Xe(nr.parent))
                    return nr;
                  if (e2.isNamedImports(nr) || e2.isNamespaceImport(nr)) {
                    if (!nr.parent.isTypeOnly && (xe.kind === 18 || xe.kind === 100 || xe.kind === 27) && (vr = 152), Xe(nr))
                      if (xe.kind === 19 || xe.kind === 79)
                        mr = true, vr = 156;
                      else
                        return nr.parent.parent;
                    return;
                  }
                  if (e2.isImportKeyword(xe) && e2.isSourceFile(nr))
                    return vr = 152, xe;
                  if (e2.isImportKeyword(xe) && e2.isImportDeclaration(nr))
                    return vr = 152, Jr(nr.moduleSpecifier) ? nr : void 0;
                }
              }
              function ae(xe, vr) {
                return e2.isImportSpecifier(xe) && (xe.isTypeOnly || vr === xe.name && e2.isTypeKeywordTokenOrIdentifier(vr));
              }
              function Xe(xe) {
                return Jr(xe.parent.parent.moduleSpecifier) && (e2.isNamespaceImport(xe) || xe.elements.length < 2) && !xe.parent.name;
              }
              function Jr(xe) {
                var vr;
                return e2.nodeIsMissing(xe) ? true : !(!((vr = e2.tryCast(e2.isExternalModuleReference(xe) ? xe.expression : xe, e2.isStringLiteralLike)) === null || vr === void 0) && vr.text);
              }
              function ti(xe) {
                var vr = e2.findAncestor(xe, function(mr) {
                  return e2.isFunctionBlock(mr) || Ze(mr) || e2.isBindingPattern(mr) ? "quit" : e2.isVariableDeclaration(mr);
                });
                return vr;
              }
              function Ze(xe) {
                return xe.parent && e2.isArrowFunction(xe.parent) && xe.parent.body === xe;
              }
              function Sr(xe, vr, mr) {
                return mr === void 0 && (mr = new e2.Map()), Ar(xe) || Ar(e2.skipAlias(xe.exportSymbol || xe, vr));
                function Ar(Oe) {
                  return !!(Oe.flags & 788968) || vr.isUnknownSymbol(Oe) || !!(Oe.flags & 1536) && e2.addToSeen(mr, e2.getSymbolId(Oe)) && vr.getExportsOfModule(Oe).some(function(nr) {
                    return Sr(nr, vr, mr);
                  });
                }
              }
              function zr(xe, vr) {
                var mr = e2.skipAlias(xe, vr).declarations;
                return !!e2.length(mr) && e2.every(mr, e2.isDeprecatedDeclaration);
              }
              function Wr(xe, vr) {
                if (vr.length === 0)
                  return true;
                for (var mr = false, Ar, Oe = 0, nr = xe.length, Mr = 0; Mr < nr; Mr++) {
                  var Pe = xe.charCodeAt(Mr), Ue = vr.charCodeAt(Oe);
                  if ((Pe === Ue || Pe === Je(Ue)) && (mr || (mr = Ar === void 0 || 97 <= Ar && Ar <= 122 && 65 <= Pe && Pe <= 90 || Ar === 95 && Pe !== 95), mr && Oe++, Oe === vr.length))
                    return true;
                  Ar = Pe;
                }
                return false;
              }
              function Je(xe) {
                return 97 <= xe && xe <= 122 ? xe - 32 : xe;
              }
            })(a = e2.Completions || (e2.Completions = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w($, A2, y, V, L) {
                var P = e2.getTouchingPropertyName(y, V);
                if (P.parent && (e2.isJsxOpeningElement(P.parent) && P.parent.tagName === P || e2.isJsxClosingElement(P.parent))) {
                  var k = P.parent.parent, Y = k.openingElement, U = k.closingElement, j = [Y, U].map(function(H) {
                    var I = H.tagName;
                    return B(I, y);
                  });
                  return [{ fileName: y.fileName, highlightSpans: j }];
                }
                return E(V, P, $, A2, L) || Q(P, y);
              }
              C.getDocumentHighlights = w;
              function B($, A2) {
                return { fileName: A2.fileName, textSpan: e2.createTextSpanFromNode($, A2), kind: "none" };
              }
              function E($, A2, y, V, L) {
                var P = new e2.Set(L.map(function(j) {
                  return j.fileName;
                })), k = e2.FindAllReferences.getReferenceEntriesForNode($, A2, y, L, V, void 0, P);
                if (!!k) {
                  var Y = e2.arrayToMultiMap(k.map(e2.FindAllReferences.toHighlightSpan), function(j) {
                    return j.fileName;
                  }, function(j) {
                    return j.span;
                  }), U = e2.createGetCanonicalFileName(y.useCaseSensitiveFileNames());
                  return e2.mapDefined(e2.arrayFrom(Y.entries()), function(j) {
                    var H = j[0], I = j[1];
                    if (!P.has(H)) {
                      if (!y.redirectTargetsMap.has(e2.toPath(H, y.getCurrentDirectory(), U)))
                        return;
                      var l = y.getSourceFile(H), d = e2.find(L, function(D) {
                        return !!D.redirectInfo && D.redirectInfo.redirectTarget === l;
                      });
                      H = d.fileName, e2.Debug.assert(P.has(H));
                    }
                    return { fileName: H, highlightSpans: I };
                  });
                }
              }
              function Q($, A2) {
                var y = le($, A2);
                return y && [{ fileName: A2.fileName, highlightSpans: y }];
              }
              function le($, A2) {
                switch ($.kind) {
                  case 99:
                  case 91:
                    return e2.isIfStatement($.parent) ? F2($.parent, A2) : void 0;
                  case 105:
                    return L($.parent, e2.isReturnStatement, O);
                  case 109:
                    return L($.parent, e2.isThrowStatement, q);
                  case 111:
                  case 83:
                  case 96:
                    var y = $.kind === 83 ? $.parent.parent : $.parent;
                    return L(y, e2.isTryStatement, R);
                  case 107:
                    return L($.parent, e2.isSwitchStatement, ie);
                  case 82:
                  case 88:
                    return e2.isDefaultClause($.parent) || e2.isCaseClause($.parent) ? L($.parent.parent.parent, e2.isSwitchStatement, ie) : void 0;
                  case 81:
                  case 86:
                    return L($.parent, e2.isBreakOrContinueStatement, J);
                  case 97:
                  case 115:
                  case 90:
                    return L($.parent, function(k) {
                      return e2.isIterationStatement(k, true);
                    }, se);
                  case 134:
                    return V(e2.isConstructorDeclaration, [134]);
                  case 136:
                  case 149:
                    return V(e2.isAccessor, [136, 149]);
                  case 132:
                    return L($.parent, e2.isAwaitExpression, ve);
                  case 131:
                    return P(ve($));
                  case 125:
                    return P(ee($));
                  case 101:
                    return;
                  default:
                    return e2.isModifierKind($.kind) && (e2.isDeclaration($.parent) || e2.isVariableStatement($.parent)) ? P(T($.kind, $.parent)) : void 0;
                }
                function V(k, Y) {
                  return L($.parent, k, function(U) {
                    return e2.mapDefined(U.symbol.declarations, function(j) {
                      return k(j) ? e2.find(j.getChildren(A2), function(H) {
                        return e2.contains(Y, H.kind);
                      }) : void 0;
                    });
                  });
                }
                function L(k, Y, U) {
                  return Y(k) ? P(U(k, A2)) : void 0;
                }
                function P(k) {
                  return k && k.map(function(Y) {
                    return B(Y, A2);
                  });
                }
              }
              function N($) {
                return e2.isThrowStatement($) ? [$] : e2.isTryStatement($) ? e2.concatenate($.catchClause ? N($.catchClause) : $.tryBlock && N($.tryBlock), $.finallyBlock && N($.finallyBlock)) : e2.isFunctionLike($) ? void 0 : G($, N);
              }
              function p($) {
                for (var A2 = $; A2.parent; ) {
                  var y = A2.parent;
                  if (e2.isFunctionBlock(y) || y.kind === 305)
                    return y;
                  if (e2.isTryStatement(y) && y.tryBlock === A2 && y.catchClause)
                    return A2;
                  A2 = y;
                }
              }
              function m2($) {
                return e2.isBreakOrContinueStatement($) ? [$] : e2.isFunctionLike($) ? void 0 : G($, m2);
              }
              function G($, A2) {
                var y = [];
                return $.forEachChild(function(V) {
                  var L = A2(V);
                  L !== void 0 && y.push.apply(y, e2.toArray(L));
                }), y;
              }
              function oe($, A2) {
                var y = f4(A2);
                return !!y && y === $;
              }
              function f4($) {
                return e2.findAncestor($, function(A2) {
                  switch (A2.kind) {
                    case 249:
                      if ($.kind === 245)
                        return false;
                    case 242:
                    case 243:
                    case 244:
                    case 241:
                    case 240:
                      return !$.label || X(A2, $.label.escapedText);
                    default:
                      return e2.isFunctionLike(A2) && "quit";
                  }
                });
              }
              function T($, A2) {
                return e2.mapDefined(K(A2, e2.modifierToFlag($)), function(y) {
                  return e2.findModifier(y, $);
                });
              }
              function K($, A2) {
                var y = $.parent;
                switch (y.kind) {
                  case 262:
                  case 305:
                  case 235:
                  case 289:
                  case 290:
                    return A2 & 128 && e2.isClassDeclaration($) ? Ve(Ve([], $.members, true), [$], false) : y.statements;
                  case 171:
                  case 169:
                  case 256:
                    return Ve(Ve([], y.parameters, true), e2.isClassLike(y.parent) ? y.parent.members : [], true);
                  case 257:
                  case 226:
                  case 258:
                  case 182:
                    var V = y.members;
                    if (A2 & 92) {
                      var L = e2.find(y.members, e2.isConstructorDeclaration);
                      if (L)
                        return Ve(Ve([], V, true), L.parameters, true);
                    } else if (A2 & 128)
                      return Ve(Ve([], V, true), [y], false);
                    return V;
                  case 205:
                    return;
                  default:
                    e2.Debug.assertNever(y, "Invalid container kind.");
                }
              }
              function b($, A2) {
                for (var y = [], V = 2; V < arguments.length; V++)
                  y[V - 2] = arguments[V];
                return A2 && e2.contains(y, A2.kind) ? ($.push(A2), true) : false;
              }
              function se($) {
                var A2 = [];
                if (b(A2, $.getFirstToken(), 97, 115, 90) && $.kind === 240)
                  for (var y = $.getChildren(), V = y.length - 1; V >= 0 && !b(A2, y[V], 115); V--)
                    ;
                return e2.forEach(m2($.statement), function(L) {
                  oe($, L) && b(A2, L.getFirstToken(), 81, 86);
                }), A2;
              }
              function J($) {
                var A2 = f4($);
                if (A2)
                  switch (A2.kind) {
                    case 242:
                    case 243:
                    case 244:
                    case 240:
                    case 241:
                      return se(A2);
                    case 249:
                      return ie(A2);
                  }
              }
              function ie($) {
                var A2 = [];
                return b(A2, $.getFirstToken(), 107), e2.forEach($.caseBlock.clauses, function(y) {
                  b(A2, y.getFirstToken(), 82, 88), e2.forEach(m2(y), function(V) {
                    oe($, V) && b(A2, V.getFirstToken(), 81);
                  });
                }), A2;
              }
              function R($, A2) {
                var y = [];
                if (b(y, $.getFirstToken(), 111), $.catchClause && b(y, $.catchClause.getFirstToken(), 83), $.finallyBlock) {
                  var V = e2.findChildOfKind($, 96, A2);
                  b(y, V, 96);
                }
                return y;
              }
              function q($, A2) {
                var y = p($);
                if (!!y) {
                  var V = [];
                  return e2.forEach(N(y), function(L) {
                    V.push(e2.findChildOfKind(L, 109, A2));
                  }), e2.isFunctionBlock(y) && e2.forEachReturnStatement(y, function(L) {
                    V.push(e2.findChildOfKind(L, 105, A2));
                  }), V;
                }
              }
              function O($, A2) {
                var y = e2.getContainingFunction($);
                if (!!y) {
                  var V = [];
                  return e2.forEachReturnStatement(e2.cast(y.body, e2.isBlock), function(L) {
                    V.push(e2.findChildOfKind(L, 105, A2));
                  }), e2.forEach(N(y.body), function(L) {
                    V.push(e2.findChildOfKind(L, 109, A2));
                  }), V;
                }
              }
              function ve($) {
                var A2 = e2.getContainingFunction($);
                if (!!A2) {
                  var y = [];
                  return A2.modifiers && A2.modifiers.forEach(function(V) {
                    b(y, V, 131);
                  }), e2.forEachChild(A2, function(V) {
                    he(V, function(L) {
                      e2.isAwaitExpression(L) && b(y, L.getFirstToken(), 132);
                    });
                  }), y;
                }
              }
              function ee($) {
                var A2 = e2.getContainingFunction($);
                if (!!A2) {
                  var y = [];
                  return e2.forEachChild(A2, function(V) {
                    he(V, function(L) {
                      e2.isYieldExpression(L) && b(y, L.getFirstToken(), 125);
                    });
                  }), y;
                }
              }
              function he($, A2) {
                A2($), !e2.isFunctionLike($) && !e2.isClassLike($) && !e2.isInterfaceDeclaration($) && !e2.isModuleDeclaration($) && !e2.isTypeAliasDeclaration($) && !e2.isTypeNode($) && e2.forEachChild($, function(y) {
                  return he(y, A2);
                });
              }
              function F2($, A2) {
                for (var y = x2($, A2), V = [], L = 0; L < y.length; L++) {
                  if (y[L].kind === 91 && L < y.length - 1) {
                    for (var P = y[L], k = y[L + 1], Y = true, U = k.getStart(A2) - 1; U >= P.end; U--)
                      if (!e2.isWhiteSpaceSingleLine(A2.text.charCodeAt(U))) {
                        Y = false;
                        break;
                      }
                    if (Y) {
                      V.push({ fileName: A2.fileName, textSpan: e2.createTextSpanFromBounds(P.getStart(), k.end), kind: "reference" }), L++;
                      continue;
                    }
                  }
                  V.push(B(y[L], A2));
                }
                return V;
              }
              function x2($, A2) {
                for (var y = []; e2.isIfStatement($.parent) && $.parent.elseStatement === $; )
                  $ = $.parent;
                for (; ; ) {
                  var V = $.getChildren(A2);
                  b(y, V[0], 99);
                  for (var L = V.length - 1; L >= 0 && !b(y, V[L], 91); L--)
                    ;
                  if (!$.elseStatement || !e2.isIfStatement($.elseStatement))
                    break;
                  $ = $.elseStatement;
                }
                return y;
              }
              function X($, A2) {
                return !!e2.findAncestor($.parent, function(y) {
                  return e2.isLabeledStatement(y) ? y.label.escapedText === A2 : "quit";
                });
              }
            })(a = e2.DocumentHighlights || (e2.DocumentHighlights = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(Q) {
              return !!Q.sourceFile;
            }
            function C(Q, le) {
              return w(Q, le);
            }
            e2.createDocumentRegistry = C;
            function w(Q, le, N) {
              le === void 0 && (le = "");
              var p = new e2.Map(), m2 = e2.createGetCanonicalFileName(!!Q);
              function G() {
                var O = e2.arrayFrom(p.keys()).filter(function(ve) {
                  return ve && ve.charAt(0) === "_";
                }).map(function(ve) {
                  var ee = p.get(ve), he = [];
                  return ee.forEach(function(F2, x2) {
                    a(F2) ? he.push({ name: x2, scriptKind: F2.sourceFile.scriptKind, refCount: F2.languageServiceRefCount }) : F2.forEach(function(X, $) {
                      return he.push({ name: x2, scriptKind: $, refCount: X.languageServiceRefCount });
                    });
                  }), he.sort(function(F2, x2) {
                    return x2.refCount - F2.refCount;
                  }), { bucket: ve, sourceFiles: he };
                });
                return JSON.stringify(O, void 0, 2);
              }
              function oe(O) {
                return typeof O.getCompilationSettings == "function" ? O.getCompilationSettings() : O;
              }
              function f4(O, ve, ee, he, F2) {
                var x2 = e2.toPath(O, le, m2), X = E(oe(ve));
                return T(O, x2, ve, X, ee, he, F2);
              }
              function T(O, ve, ee, he, F2, x2, X) {
                return J(O, ve, ee, he, F2, x2, true, X);
              }
              function K(O, ve, ee, he, F2) {
                var x2 = e2.toPath(O, le, m2), X = E(oe(ve));
                return b(O, x2, ve, X, ee, he, F2);
              }
              function b(O, ve, ee, he, F2, x2, X) {
                return J(O, ve, oe(ee), he, F2, x2, false, X);
              }
              function se(O, ve) {
                var ee = a(O) ? O : O.get(e2.Debug.checkDefined(ve, "If there are more than one scriptKind's for same document the scriptKind should be provided"));
                return e2.Debug.assert(ve === void 0 || !ee || ee.sourceFile.scriptKind === ve, "Script kind should match provided ScriptKind:".concat(ve, " and sourceFile.scriptKind: ").concat(ee == null ? void 0 : ee.sourceFile.scriptKind, ", !entry: ").concat(!ee)), ee;
              }
              function J(O, ve, ee, he, F2, x2, X, $) {
                var A2, y, V, L;
                $ = e2.ensureScriptKind(O, $);
                var P = oe(ee), k = ee === P ? void 0 : ee, Y = $ === 6 ? 100 : e2.getEmitScriptTarget(P), U = { languageVersion: Y, impliedNodeFormat: k && e2.getImpliedNodeFormatForFile(ve, (L = (V = (y = (A2 = k.getCompilerHost) === null || A2 === void 0 ? void 0 : A2.call(k)) === null || y === void 0 ? void 0 : y.getModuleResolutionCache) === null || V === void 0 ? void 0 : V.call(y)) === null || L === void 0 ? void 0 : L.getPackageJsonInfoCache(), k, P), setExternalModuleIndicator: e2.getSetExternalModuleIndicator(P) }, j = p.size, H = e2.getOrUpdate(p, he, function() {
                  return new e2.Map();
                });
                if (e2.tracing) {
                  p.size > j && e2.tracing.instant("session", "createdDocumentRegistryBucket", { configFilePath: P.configFilePath, key: he });
                  var I = !e2.isDeclarationFileName(ve) && e2.forEachEntry(p, function(g, ne) {
                    return ne !== he && g.has(ve) && ne;
                  });
                  I && e2.tracing.instant("session", "documentRegistryBucketOverlap", { path: ve, key1: I, key2: he });
                }
                var l = H.get(ve), d = l && se(l, $);
                if (!d && N) {
                  var D = N.getDocument(he, ve);
                  D && (e2.Debug.assert(X), d = { sourceFile: D, languageServiceRefCount: 0 }, fe());
                }
                if (d)
                  d.sourceFile.version !== x2 && (d.sourceFile = e2.updateLanguageServiceSourceFile(d.sourceFile, F2, x2, F2.getChangeRange(d.sourceFile.scriptSnapshot)), N && N.setDocument(he, ve, d.sourceFile)), X && d.languageServiceRefCount++;
                else {
                  var D = e2.createLanguageServiceSourceFile(O, F2, U, x2, false, $);
                  N && N.setDocument(he, ve, D), d = { sourceFile: D, languageServiceRefCount: 1 }, fe();
                }
                return e2.Debug.assert(d.languageServiceRefCount !== 0), d.sourceFile;
                function fe() {
                  if (!l)
                    H.set(ve, d);
                  else if (a(l)) {
                    var g = new e2.Map();
                    g.set(l.sourceFile.scriptKind, l), g.set($, d), H.set(ve, g);
                  } else
                    l.set($, d);
                }
              }
              function ie(O, ve, ee) {
                var he = e2.toPath(O, le, m2), F2 = E(ve);
                return R(he, F2, ee);
              }
              function R(O, ve, ee) {
                var he = e2.Debug.checkDefined(p.get(ve)), F2 = he.get(O), x2 = se(F2, ee);
                x2.languageServiceRefCount--, e2.Debug.assert(x2.languageServiceRefCount >= 0), x2.languageServiceRefCount === 0 && (a(F2) ? he.delete(O) : (F2.delete(ee), F2.size === 1 && he.set(O, e2.firstDefinedIterator(F2.values(), e2.identity))));
              }
              function q(O, ve) {
                return e2.arrayFrom(p.entries(), function(ee) {
                  var he = ee[0], F2 = ee[1], x2 = F2.get(O), X = x2 && se(x2, ve);
                  return [he, X && X.languageServiceRefCount];
                });
              }
              return { acquireDocument: f4, acquireDocumentWithKey: T, updateDocument: K, updateDocumentWithKey: b, releaseDocument: ie, releaseDocumentWithKey: R, getLanguageServiceRefCounts: q, reportStats: G, getKeyForCompilationSettings: E };
            }
            e2.createDocumentRegistryInternal = w;
            function B(Q) {
              var le;
              if (Q === null || typeof Q != "object")
                return "" + Q;
              if (e2.isArray(Q))
                return "[".concat((le = e2.map(Q, function(m2) {
                  return B(m2);
                })) === null || le === void 0 ? void 0 : le.join(","), "]");
              var N = "{";
              for (var p in Q)
                e2.hasOwnProperty.call(Q, p) && (N += "".concat(p, ": ").concat(B(Q[p])));
              return N + "}";
            }
            function E(Q) {
              return e2.sourceFileAffectingCompilerOptions.map(function(le) {
                return B(e2.getCompilerOptionValue(Q, le));
              }).join("|") + (Q.pathsBasePath ? "|".concat(Q.pathsBasePath) : void 0);
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(ve, ee, he, F2) {
                var x2 = m2(ve, he, F2);
                return function(X, $, A2) {
                  var y = Q(ve, ee, x2, $, he, F2), V = y.directImports, L = y.indirectUsers;
                  return Ke({ indirectUsers: L }, le(V, X, $.exportKind, he, A2));
                };
              }
              C.createImportTracker = w;
              var B;
              (function(ve) {
                ve[ve.Named = 0] = "Named", ve[ve.Default = 1] = "Default", ve[ve.ExportEquals = 2] = "ExportEquals";
              })(B = C.ExportKind || (C.ExportKind = {}));
              var E;
              (function(ve) {
                ve[ve.Import = 0] = "Import", ve[ve.Export = 1] = "Export";
              })(E = C.ImportExport || (C.ImportExport = {}));
              function Q(ve, ee, he, F2, x2, X) {
                var $ = F2.exportingModuleSymbol, A2 = F2.exportKind, y = e2.nodeSeenTracker(), V = e2.nodeSeenTracker(), L = [], P = !!$.globalExports, k = P ? void 0 : [];
                return U($), { directImports: L, indirectUsers: Y() };
                function Y() {
                  if (P)
                    return ve;
                  if ($.declarations)
                    for (var D = 0, fe = $.declarations; D < fe.length; D++) {
                      var g = fe[D];
                      e2.isExternalModuleAugmentation(g) && ee.has(g.getSourceFile().fileName) && l(g);
                    }
                  return k.map(e2.getSourceFileOfNode);
                }
                function U(D) {
                  var fe = d(D);
                  if (fe)
                    for (var g = 0, ne = fe; g < ne.length; g++) {
                      var ue = ne[g];
                      if (!!y(ue))
                        switch (X && X.throwIfCancellationRequested(), ue.kind) {
                          case 208:
                            if (e2.isImportCall(ue)) {
                              j(ue);
                              break;
                            }
                            if (!P) {
                              var We = ue.parent;
                              if (A2 === 2 && We.kind === 254) {
                                var Fe = We.name;
                                if (Fe.kind === 79) {
                                  L.push(Fe);
                                  break;
                                }
                              }
                            }
                            break;
                          case 79:
                            break;
                          case 265:
                            I(ue, ue.name, e2.hasSyntacticModifier(ue, 1), false);
                            break;
                          case 266:
                            L.push(ue);
                            var Z2 = ue.importClause && ue.importClause.namedBindings;
                            Z2 && Z2.kind === 268 ? I(ue, Z2.name, false, true) : !P && e2.isDefaultImport(ue) && l(R(ue));
                            break;
                          case 272:
                            ue.exportClause ? ue.exportClause.kind === 274 ? l(R(ue), true) : L.push(ue) : U(ie(ue, x2));
                            break;
                          case 200:
                            ue.isTypeOf && !ue.qualifier && H(ue) && l(ue.getSourceFile(), true), L.push(ue);
                            break;
                          default:
                            e2.Debug.failBadSyntaxKind(ue, "Unexpected import kind.");
                        }
                    }
                }
                function j(D) {
                  var fe = e2.findAncestor(D, q) || D.getSourceFile();
                  l(fe, !!H(D, true));
                }
                function H(D, fe) {
                  return fe === void 0 && (fe = false), e2.findAncestor(D, function(g) {
                    return fe && q(g) ? "quit" : e2.some(g.modifiers, function(ne) {
                      return ne.kind === 93;
                    });
                  });
                }
                function I(D, fe, g, ne) {
                  if (A2 === 2)
                    ne || L.push(D);
                  else if (!P) {
                    var ue = R(D);
                    e2.Debug.assert(ue.kind === 305 || ue.kind === 261), g || N(ue, fe, x2) ? l(ue, true) : l(ue);
                  }
                }
                function l(D, fe) {
                  fe === void 0 && (fe = false), e2.Debug.assert(!P);
                  var g = V(D);
                  if (!!g && (k.push(D), !!fe)) {
                    var ne = x2.getMergedSymbol(D.symbol);
                    if (!!ne) {
                      e2.Debug.assert(!!(ne.flags & 1536));
                      var ue = d(ne);
                      if (ue)
                        for (var We = 0, Fe = ue; We < Fe.length; We++) {
                          var Z2 = Fe[We];
                          e2.isImportTypeNode(Z2) || l(R(Z2), true);
                        }
                    }
                  }
                }
                function d(D) {
                  return he.get(e2.getSymbolId(D).toString());
                }
              }
              function le(ve, ee, he, F2, x2) {
                var X = [], $ = [];
                function A2(j, H) {
                  X.push([j, H]);
                }
                if (ve)
                  for (var y = 0, V = ve; y < V.length; y++) {
                    var L = V[y];
                    P(L);
                  }
                return { importSearches: X, singleReferences: $ };
                function P(j) {
                  if (j.kind === 265) {
                    O(j) && k(j.name);
                    return;
                  }
                  if (j.kind === 79) {
                    k(j);
                    return;
                  }
                  if (j.kind === 200) {
                    if (j.qualifier) {
                      var H = e2.getFirstIdentifier(j.qualifier);
                      H.escapedText === e2.symbolName(ee) && $.push(H);
                    } else
                      he === 2 && $.push(j.argument.literal);
                    return;
                  }
                  if (j.moduleSpecifier.kind === 10) {
                    if (j.kind === 272) {
                      j.exportClause && e2.isNamedExports(j.exportClause) && Y(j.exportClause);
                      return;
                    }
                    var I = j.importClause || { name: void 0, namedBindings: void 0 }, l = I.name, d = I.namedBindings;
                    if (d)
                      switch (d.kind) {
                        case 268:
                          k(d.name);
                          break;
                        case 269:
                          (he === 0 || he === 1) && Y(d);
                          break;
                        default:
                          e2.Debug.assertNever(d);
                      }
                    if (l && (he === 1 || he === 2) && (!x2 || l.escapedText === e2.symbolEscapedNameNoDefault(ee))) {
                      var D = F2.getSymbolAtLocation(l);
                      A2(l, D);
                    }
                  }
                }
                function k(j) {
                  he === 2 && (!x2 || U(j.escapedText)) && A2(j, F2.getSymbolAtLocation(j));
                }
                function Y(j) {
                  if (!!j)
                    for (var H = 0, I = j.elements; H < I.length; H++) {
                      var l = I[H], d = l.name, D = l.propertyName;
                      if (!!U((D || d).escapedText))
                        if (D)
                          $.push(D), (!x2 || d.escapedText === ee.escapedName) && A2(d, F2.getSymbolAtLocation(d));
                        else {
                          var fe = l.kind === 275 && l.propertyName ? F2.getExportSpecifierLocalTargetSymbol(l) : F2.getSymbolAtLocation(d);
                          A2(d, fe);
                        }
                    }
                }
                function U(j) {
                  return j === ee.escapedName || he !== 0 && j === "default";
                }
              }
              function N(ve, ee, he) {
                var F2 = he.getSymbolAtLocation(ee);
                return !!G(ve, function(x2) {
                  if (!!e2.isExportDeclaration(x2)) {
                    var X = x2.exportClause, $ = x2.moduleSpecifier;
                    return !$ && X && e2.isNamedExports(X) && X.elements.some(function(A2) {
                      return he.getExportSpecifierLocalTargetSymbol(A2) === F2;
                    });
                  }
                });
              }
              function p(ve, ee, he) {
                for (var F2 = [], x2 = ve.getTypeChecker(), X = 0, $ = ee; X < $.length; X++) {
                  var A2 = $[X], y = he.valueDeclaration;
                  if ((y == null ? void 0 : y.kind) === 305) {
                    for (var V = 0, L = A2.referencedFiles; V < L.length; V++) {
                      var P = L[V];
                      ve.getSourceFileFromReference(A2, P) === y && F2.push({ kind: "reference", referencingFile: A2, ref: P });
                    }
                    for (var k = 0, Y = A2.typeReferenceDirectives; k < Y.length; k++) {
                      var P = Y[k], U = ve.getResolvedTypeReferenceDirectives().get(P.fileName, P.resolutionMode || A2.impliedNodeFormat);
                      U !== void 0 && U.resolvedFileName === y.fileName && F2.push({ kind: "reference", referencingFile: A2, ref: P });
                    }
                  }
                  oe(A2, function(j, H) {
                    var I = x2.getSymbolAtLocation(H);
                    I === he && F2.push({ kind: "import", literal: H });
                  });
                }
                return F2;
              }
              C.findModuleReferences = p;
              function m2(ve, ee, he) {
                for (var F2 = new e2.Map(), x2 = 0, X = ve; x2 < X.length; x2++) {
                  var $ = X[x2];
                  he && he.throwIfCancellationRequested(), oe($, function(A2, y) {
                    var V = ee.getSymbolAtLocation(y);
                    if (V) {
                      var L = e2.getSymbolId(V).toString(), P = F2.get(L);
                      P || F2.set(L, P = []), P.push(A2);
                    }
                  });
                }
                return F2;
              }
              function G(ve, ee) {
                return e2.forEach(ve.kind === 305 ? ve.statements : ve.body.statements, function(he) {
                  return ee(he) || q(he) && e2.forEach(he.body && he.body.statements, ee);
                });
              }
              function oe(ve, ee) {
                if (ve.externalModuleIndicator || ve.imports !== void 0)
                  for (var he = 0, F2 = ve.imports; he < F2.length; he++) {
                    var x2 = F2[he];
                    ee(e2.importFromModuleSpecifier(x2), x2);
                  }
                else
                  G(ve, function(X) {
                    switch (X.kind) {
                      case 272:
                      case 266: {
                        var $ = X;
                        $.moduleSpecifier && e2.isStringLiteral($.moduleSpecifier) && ee($, $.moduleSpecifier);
                        break;
                      }
                      case 265: {
                        var $ = X;
                        O($) && ee($, $.moduleReference.expression);
                        break;
                      }
                    }
                  });
              }
              function f4(ve, ee, he, F2) {
                return F2 ? x2() : x2() || X();
                function x2() {
                  var y, V = ve.parent, L = V.parent;
                  if (ee.exportSymbol)
                    return V.kind === 206 ? ((y = ee.declarations) === null || y === void 0 ? void 0 : y.some(function(j) {
                      return j === V;
                    })) && e2.isBinaryExpression(L) ? U(L, false) : void 0 : $(ee.exportSymbol, A2(V));
                  var P = K(V, ve);
                  if (P && e2.hasSyntacticModifier(P, 1))
                    if (e2.isImportEqualsDeclaration(P) && P.moduleReference === ve) {
                      if (F2)
                        return;
                      var k = he.getSymbolAtLocation(P.name);
                      return { kind: 0, symbol: k };
                    } else
                      return $(ee, A2(P));
                  else {
                    if (e2.isNamespaceExport(V))
                      return $(ee, 0);
                    if (e2.isExportAssignment(V))
                      return Y(V);
                    if (e2.isExportAssignment(L))
                      return Y(L);
                    if (e2.isBinaryExpression(V))
                      return U(V, true);
                    if (e2.isBinaryExpression(L))
                      return U(L, true);
                    if (e2.isJSDocTypedefTag(V))
                      return $(ee, 0);
                  }
                  function Y(j) {
                    if (!!j.symbol.parent) {
                      var H = j.isExportEquals ? 2 : 1;
                      return { kind: 1, symbol: ee, exportInfo: { exportingModuleSymbol: j.symbol.parent, exportKind: H } };
                    }
                  }
                  function U(j, H) {
                    var I;
                    switch (e2.getAssignmentDeclarationKind(j)) {
                      case 1:
                        I = 0;
                        break;
                      case 2:
                        I = 2;
                        break;
                      default:
                        return;
                    }
                    var l = H ? he.getSymbolAtLocation(e2.getNameOfAccessExpression(e2.cast(j.left, e2.isAccessExpression))) : ee;
                    return l && $(l, I);
                  }
                }
                function X() {
                  var y = b(ve);
                  if (!!y) {
                    var V = he.getImmediateAliasedSymbol(ee);
                    if (!!V) {
                      V = J(V, he), V.escapedName === "export=" && (V = T(V, he));
                      var L = e2.symbolEscapedNameNoDefault(V);
                      if (L === void 0 || L === "default" || L === ee.escapedName)
                        return { kind: 0, symbol: V };
                    }
                  }
                }
                function $(y, V) {
                  var L = se(y, V, he);
                  return L && { kind: 1, symbol: y, exportInfo: L };
                }
                function A2(y) {
                  return e2.hasSyntacticModifier(y, 512) ? 1 : 0;
                }
              }
              C.getImportOrExportSymbol = f4;
              function T(ve, ee) {
                if (ve.flags & 2097152)
                  return e2.Debug.checkDefined(ee.getImmediateAliasedSymbol(ve));
                var he = e2.Debug.checkDefined(ve.valueDeclaration);
                return e2.isExportAssignment(he) ? e2.Debug.checkDefined(he.expression.symbol) : e2.isBinaryExpression(he) ? e2.Debug.checkDefined(he.right.symbol) : e2.isSourceFile(he) ? e2.Debug.checkDefined(he.symbol) : e2.Debug.fail();
              }
              function K(ve, ee) {
                var he = e2.isVariableDeclaration(ve) ? ve : e2.isBindingElement(ve) ? e2.walkUpBindingElementsAndPatterns(ve) : void 0;
                return he ? ve.name !== ee || e2.isCatchClause(he.parent) ? void 0 : e2.isVariableStatement(he.parent.parent) ? he.parent.parent : void 0 : ve;
              }
              function b(ve) {
                var ee = ve.parent;
                switch (ee.kind) {
                  case 265:
                    return ee.name === ve && O(ee);
                  case 270:
                    return !ee.propertyName;
                  case 267:
                  case 268:
                    return e2.Debug.assert(ee.name === ve), true;
                  case 203:
                    return e2.isInJSFile(ve) && e2.isVariableDeclarationInitializedToBareOrAccessedRequire(ee);
                  default:
                    return false;
                }
              }
              function se(ve, ee, he) {
                var F2 = ve.parent;
                if (!!F2) {
                  var x2 = he.getMergedSymbol(F2);
                  return e2.isExternalModuleSymbol(x2) ? { exportingModuleSymbol: x2, exportKind: ee } : void 0;
                }
              }
              C.getExportInfo = se;
              function J(ve, ee) {
                if (ve.declarations)
                  for (var he = 0, F2 = ve.declarations; he < F2.length; he++) {
                    var x2 = F2[he];
                    if (e2.isExportSpecifier(x2) && !x2.propertyName && !x2.parent.parent.moduleSpecifier)
                      return ee.getExportSpecifierLocalTargetSymbol(x2);
                    if (e2.isPropertyAccessExpression(x2) && e2.isModuleExportsAccessExpression(x2.expression) && !e2.isPrivateIdentifier(x2.name))
                      return ee.getSymbolAtLocation(x2);
                    if (e2.isShorthandPropertyAssignment(x2) && e2.isBinaryExpression(x2.parent.parent) && e2.getAssignmentDeclarationKind(x2.parent.parent) === 2)
                      return ee.getExportSpecifierLocalTargetSymbol(x2.name);
                  }
                return ve;
              }
              function ie(ve, ee) {
                return ee.getMergedSymbol(R(ve).symbol);
              }
              function R(ve) {
                if (ve.kind === 208)
                  return ve.getSourceFile();
                var ee = ve.parent;
                return ee.kind === 305 ? ee : (e2.Debug.assert(ee.kind === 262), e2.cast(ee.parent, q));
              }
              function q(ve) {
                return ve.kind === 261 && ve.name.kind === 10;
              }
              function O(ve) {
                return ve.moduleReference.kind === 277 && ve.moduleReference.expression.kind === 10;
              }
            })(a = e2.FindAllReferences || (e2.FindAllReferences = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(k) {
                k[k.Symbol = 0] = "Symbol", k[k.Label = 1] = "Label", k[k.Keyword = 2] = "Keyword", k[k.This = 3] = "This", k[k.String = 4] = "String", k[k.TripleSlashReference = 5] = "TripleSlashReference";
              })(w = C.DefinitionKind || (C.DefinitionKind = {}));
              var B;
              (function(k) {
                k[k.Span = 0] = "Span", k[k.Node = 1] = "Node", k[k.StringLiteral = 2] = "StringLiteral", k[k.SearchedLocalFoundProperty = 3] = "SearchedLocalFoundProperty", k[k.SearchedPropertyFoundLocal = 4] = "SearchedPropertyFoundLocal";
              })(B = C.EntryKind || (C.EntryKind = {}));
              function E(k, Y) {
                return Y === void 0 && (Y = 1), { kind: Y, node: k.name || k, context: le(k) };
              }
              C.nodeEntry = E;
              function Q(k) {
                return k && k.kind === void 0;
              }
              C.isContextWithStartAndEndNode = Q;
              function le(k) {
                if (e2.isDeclaration(k))
                  return N(k);
                if (!!k.parent) {
                  if (!e2.isDeclaration(k.parent) && !e2.isExportAssignment(k.parent)) {
                    if (e2.isInJSFile(k)) {
                      var Y = e2.isBinaryExpression(k.parent) ? k.parent : e2.isAccessExpression(k.parent) && e2.isBinaryExpression(k.parent.parent) && k.parent.parent.left === k.parent ? k.parent.parent : void 0;
                      if (Y && e2.getAssignmentDeclarationKind(Y) !== 0)
                        return N(Y);
                    }
                    if (e2.isJsxOpeningElement(k.parent) || e2.isJsxClosingElement(k.parent))
                      return k.parent.parent;
                    if (e2.isJsxSelfClosingElement(k.parent) || e2.isLabeledStatement(k.parent) || e2.isBreakOrContinueStatement(k.parent))
                      return k.parent;
                    if (e2.isStringLiteralLike(k)) {
                      var U = e2.tryGetImportFromModuleSpecifier(k);
                      if (U) {
                        var j = e2.findAncestor(U, function(I) {
                          return e2.isDeclaration(I) || e2.isStatement(I) || e2.isJSDocTag(I);
                        });
                        return e2.isDeclaration(j) ? N(j) : j;
                      }
                    }
                    var H = e2.findAncestor(k, e2.isComputedPropertyName);
                    return H ? N(H.parent) : void 0;
                  }
                  if (k.parent.name === k || e2.isConstructorDeclaration(k.parent) || e2.isExportAssignment(k.parent) || (e2.isImportOrExportSpecifier(k.parent) || e2.isBindingElement(k.parent)) && k.parent.propertyName === k || k.kind === 88 && e2.hasSyntacticModifier(k.parent, 513))
                    return N(k.parent);
                }
              }
              function N(k) {
                if (!!k)
                  switch (k.kind) {
                    case 254:
                      return !e2.isVariableDeclarationList(k.parent) || k.parent.declarations.length !== 1 ? k : e2.isVariableStatement(k.parent.parent) ? k.parent.parent : e2.isForInOrOfStatement(k.parent.parent) ? N(k.parent.parent) : k.parent;
                    case 203:
                      return N(k.parent.parent);
                    case 270:
                      return k.parent.parent.parent;
                    case 275:
                    case 268:
                      return k.parent.parent;
                    case 267:
                    case 274:
                      return k.parent;
                    case 221:
                      return e2.isExpressionStatement(k.parent) ? k.parent : k;
                    case 244:
                    case 243:
                      return { start: k.initializer, end: k.expression };
                    case 296:
                    case 297:
                      return e2.isArrayLiteralOrObjectLiteralDestructuringPattern(k.parent) ? N(e2.findAncestor(k.parent, function(Y) {
                        return e2.isBinaryExpression(Y) || e2.isForInOrOfStatement(Y);
                      })) : k;
                    default:
                      return k;
                  }
              }
              C.getContextNode = N;
              function p(k, Y, U) {
                if (!!U) {
                  var j = Q(U) ? $(U.start, Y, U.end) : $(U, Y);
                  return j.start !== k.start || j.length !== k.length ? { contextSpan: j } : void 0;
                }
              }
              C.toContextSpan = p;
              var m2;
              (function(k) {
                k[k.Other = 0] = "Other", k[k.References = 1] = "References", k[k.Rename = 2] = "Rename";
              })(m2 = C.FindReferencesUse || (C.FindReferencesUse = {}));
              function G(k, Y, U, j, H) {
                var I = e2.getTouchingPropertyName(j, H), l = { use: 1 }, d = P.getReferencedSymbolsForNode(H, I, k, U, Y, l), D = k.getTypeChecker(), fe = P.getAdjustedNode(I, l), g = oe(fe) ? D.getSymbolAtLocation(fe) : void 0;
                return !d || !d.length ? void 0 : e2.mapDefined(d, function(ne) {
                  var ue = ne.definition, We = ne.references;
                  return ue && { definition: D.runWithCancellationToken(Y, function(Fe) {
                    return J(ue, Fe, I);
                  }), references: We.map(function(Fe) {
                    return O(Fe, g);
                  }) };
                });
              }
              C.findReferencedSymbols = G;
              function oe(k) {
                return k.kind === 88 || !!e2.getDeclarationFromName(k) || e2.isLiteralComputedPropertyDeclarationName(k) || k.kind === 134 && e2.isConstructorDeclaration(k.parent);
              }
              function f4(k, Y, U, j, H) {
                var I = e2.getTouchingPropertyName(j, H), l, d = T(k, Y, U, I, H);
                if (I.parent.kind === 206 || I.parent.kind === 203 || I.parent.kind === 207 || I.kind === 106)
                  l = d && Ve([], d, true);
                else
                  for (var D = d && Ve([], d, true), fe = new e2.Map(); D && D.length; ) {
                    var g = D.shift();
                    if (!!e2.addToSeen(fe, e2.getNodeId(g.node))) {
                      l = e2.append(l, g);
                      var ne = T(k, Y, U, g.node, g.node.pos);
                      ne && D.push.apply(D, ne);
                    }
                  }
                var ue = k.getTypeChecker();
                return e2.map(l, function(We) {
                  return F2(We, ue);
                });
              }
              C.getImplementationsAtPosition = f4;
              function T(k, Y, U, j, H) {
                if (j.kind !== 305) {
                  var I = k.getTypeChecker();
                  if (j.parent.kind === 297) {
                    var l = [];
                    return P.getReferenceEntriesForShorthandPropertyAssignment(j, I, function(D) {
                      return l.push(E(D));
                    }), l;
                  } else if (j.kind === 106 || e2.isSuperProperty(j.parent)) {
                    var d = I.getSymbolAtLocation(j);
                    return d.valueDeclaration && [E(d.valueDeclaration)];
                  } else
                    return b(H, j, k, U, Y, { implementations: true, use: 1 });
                }
              }
              function K(k, Y, U, j, H, I, l) {
                return e2.map(se(P.getReferencedSymbolsForNode(H, j, k, U, Y, I)), function(d) {
                  return l(d, j, k.getTypeChecker());
                });
              }
              C.findReferenceOrRenameEntries = K;
              function b(k, Y, U, j, H, I, l) {
                return I === void 0 && (I = {}), l === void 0 && (l = new e2.Set(j.map(function(d) {
                  return d.fileName;
                }))), se(P.getReferencedSymbolsForNode(k, Y, U, j, H, I, l));
              }
              C.getReferenceEntriesForNode = b;
              function se(k) {
                return k && e2.flatMap(k, function(Y) {
                  return Y.references;
                });
              }
              function J(k, Y, U) {
                var j = function() {
                  switch (k.type) {
                    case 0: {
                      var g = k.symbol, ne = R(g, Y, U), ue = ne.displayParts, We = ne.kind, Fe = ue.map(function(ze) {
                        return ze.text;
                      }).join(""), Z2 = g.declarations && e2.firstOrUndefined(g.declarations), Be = Z2 ? e2.getNameOfDeclaration(Z2) || Z2 : U;
                      return Ke(Ke({}, ie(Be)), { name: Fe, kind: We, displayParts: ue, context: N(Z2) });
                    }
                    case 1: {
                      var Be = k.node;
                      return Ke(Ke({}, ie(Be)), { name: Be.text, kind: "label", displayParts: [e2.displayPart(Be.text, e2.SymbolDisplayPartKind.text)] });
                    }
                    case 2: {
                      var Be = k.node, ge = e2.tokenToString(Be.kind);
                      return Ke(Ke({}, ie(Be)), { name: ge, kind: "keyword", displayParts: [{ text: ge, kind: "keyword" }] });
                    }
                    case 3: {
                      var Be = k.node, g = Y.getSymbolAtLocation(Be), Re = g && e2.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(Y, g, Be.getSourceFile(), e2.getContainerNode(Be), Be).displayParts || [e2.textPart("this")];
                      return Ke(Ke({}, ie(Be)), { name: "this", kind: "var", displayParts: Re });
                    }
                    case 4: {
                      var Be = k.node;
                      return Ke(Ke({}, ie(Be)), { name: Be.text, kind: "var", displayParts: [e2.displayPart(e2.getTextOfNode(Be), e2.SymbolDisplayPartKind.stringLiteral)] });
                    }
                    case 5:
                      return { textSpan: e2.createTextSpanFromRange(k.reference), sourceFile: k.file, name: k.reference.fileName, kind: "string", displayParts: [e2.displayPart('"'.concat(k.reference.fileName, '"'), e2.SymbolDisplayPartKind.stringLiteral)] };
                    default:
                      return e2.Debug.assertNever(k);
                  }
                }(), H = j.sourceFile, I = j.textSpan, l = j.name, d = j.kind, D = j.displayParts, fe = j.context;
                return Ke({ containerKind: "", containerName: "", fileName: H.fileName, kind: d, name: l, textSpan: I, displayParts: D }, p(I, H, fe));
              }
              function ie(k) {
                var Y = k.getSourceFile();
                return { sourceFile: Y, textSpan: $(e2.isComputedPropertyName(k) ? k.expression : k, Y) };
              }
              function R(k, Y, U) {
                var j = P.getIntersectingMeaningFromDeclarations(U, k), H = k.declarations && e2.firstOrUndefined(k.declarations) || U, I = e2.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(Y, k, H.getSourceFile(), H, H, j), l = I.displayParts, d = I.symbolKind;
                return { displayParts: l, kind: d };
              }
              function q(k, Y, U, j) {
                return Ke(Ke({}, ee(k)), j && he(k, Y, U));
              }
              C.toRenameLocation = q;
              function O(k, Y) {
                var U = ve(k);
                return Y ? Ke(Ke({}, U), { isDefinition: k.kind !== 0 && V(k.node, Y) }) : U;
              }
              function ve(k) {
                var Y = ee(k);
                if (k.kind === 0)
                  return Ke(Ke({}, Y), { isWriteAccess: false });
                var U = k.kind, j = k.node;
                return Ke(Ke({}, Y), { isWriteAccess: y(j), isInString: U === 2 ? true : void 0 });
              }
              C.toReferenceEntry = ve;
              function ee(k) {
                if (k.kind === 0)
                  return { textSpan: k.textSpan, fileName: k.fileName };
                var Y = k.node.getSourceFile(), U = $(k.node, Y);
                return Ke({ textSpan: U, fileName: Y.fileName }, p(U, Y, k.context));
              }
              function he(k, Y, U) {
                if (k.kind !== 0 && e2.isIdentifier(Y)) {
                  var j = k.node, H = k.kind, I = j.parent, l = Y.text, d = e2.isShorthandPropertyAssignment(I);
                  if (d || e2.isObjectBindingElementWithoutPropertyName(I) && I.name === j && I.dotDotDotToken === void 0) {
                    var D = { prefixText: l + ": " }, fe = { suffixText: ": " + l };
                    if (H === 3)
                      return D;
                    if (H === 4)
                      return fe;
                    if (d) {
                      var g = I.parent;
                      return e2.isObjectLiteralExpression(g) && e2.isBinaryExpression(g.parent) && e2.isModuleExportsAccessExpression(g.parent.left) ? D : fe;
                    } else
                      return D;
                  } else if (e2.isImportSpecifier(I) && !I.propertyName) {
                    var ne = e2.isExportSpecifier(Y.parent) ? U.getExportSpecifierLocalTargetSymbol(Y.parent) : U.getSymbolAtLocation(Y);
                    return e2.contains(ne.declarations, I) ? { prefixText: l + " as " } : e2.emptyOptions;
                  } else if (e2.isExportSpecifier(I) && !I.propertyName)
                    return Y === k.node || U.getSymbolAtLocation(Y) === U.getSymbolAtLocation(k.node) ? { prefixText: l + " as " } : { suffixText: " as " + l };
                }
                return e2.emptyOptions;
              }
              function F2(k, Y) {
                var U = ee(k);
                if (k.kind !== 0) {
                  var j = k.node;
                  return Ke(Ke({}, U), x2(j, Y));
                } else
                  return Ke(Ke({}, U), { kind: "", displayParts: [] });
              }
              function x2(k, Y) {
                var U = Y.getSymbolAtLocation(e2.isDeclaration(k) && k.name ? k.name : k);
                return U ? R(U, Y, k) : k.kind === 205 ? { kind: "interface", displayParts: [e2.punctuationPart(20), e2.textPart("object literal"), e2.punctuationPart(21)] } : k.kind === 226 ? { kind: "local class", displayParts: [e2.punctuationPart(20), e2.textPart("anonymous local class"), e2.punctuationPart(21)] } : { kind: e2.getNodeKind(k), displayParts: [] };
              }
              function X(k) {
                var Y = ee(k);
                if (k.kind === 0)
                  return { fileName: Y.fileName, span: { textSpan: Y.textSpan, kind: "reference" } };
                var U = y(k.node), j = Ke({ textSpan: Y.textSpan, kind: U ? "writtenReference" : "reference", isInString: k.kind === 2 ? true : void 0 }, Y.contextSpan && { contextSpan: Y.contextSpan });
                return { fileName: Y.fileName, span: j };
              }
              C.toHighlightSpan = X;
              function $(k, Y, U) {
                var j = k.getStart(Y), H = (U || k).getEnd();
                return e2.isStringLiteralLike(k) && H - j > 2 && (e2.Debug.assert(U === void 0), j += 1, H -= 1), e2.createTextSpanFromBounds(j, H);
              }
              function A2(k) {
                return k.kind === 0 ? k.textSpan : $(k.node, k.node.getSourceFile());
              }
              C.getTextSpanOfEntry = A2;
              function y(k) {
                var Y = e2.getDeclarationFromName(k);
                return !!Y && L(Y) || k.kind === 88 || e2.isWriteAccess(k);
              }
              function V(k, Y) {
                var U;
                if (!Y)
                  return false;
                var j = e2.getDeclarationFromName(k) || (k.kind === 88 ? k.parent : e2.isLiteralComputedPropertyDeclarationName(k) || k.kind === 134 && e2.isConstructorDeclaration(k.parent) ? k.parent.parent : void 0), H = j && e2.isBinaryExpression(j) ? j.left : void 0;
                return !!(j && ((U = Y.declarations) === null || U === void 0 ? void 0 : U.some(function(I) {
                  return I === j || I === H;
                })));
              }
              function L(k) {
                if (k.flags & 16777216)
                  return true;
                switch (k.kind) {
                  case 221:
                  case 203:
                  case 257:
                  case 226:
                  case 88:
                  case 260:
                  case 299:
                  case 275:
                  case 267:
                  case 265:
                  case 270:
                  case 258:
                  case 338:
                  case 345:
                  case 285:
                  case 261:
                  case 264:
                  case 268:
                  case 274:
                  case 164:
                  case 297:
                  case 259:
                  case 163:
                    return true;
                  case 296:
                    return !e2.isArrayLiteralOrObjectLiteralDestructuringPattern(k.parent);
                  case 256:
                  case 213:
                  case 171:
                  case 169:
                  case 172:
                  case 173:
                    return !!k.body;
                  case 254:
                  case 167:
                    return !!k.initializer || e2.isCatchClause(k.parent);
                  case 168:
                  case 166:
                  case 347:
                  case 340:
                    return false;
                  default:
                    return e2.Debug.failBadSyntaxKind(k);
                }
              }
              var P;
              (function(k) {
                function Y(Oe, nr, Mr, Pe, Ue, fr, De) {
                  var gr, Vr;
                  if (fr === void 0 && (fr = {}), De === void 0 && (De = new e2.Set(Pe.map(function(Rt) {
                    return Rt.fileName;
                  }))), nr = U(nr, fr), e2.isSourceFile(nr)) {
                    var Tr = e2.GoToDefinition.getReferenceAtPosition(nr, Oe, Mr);
                    if (!(Tr != null && Tr.file))
                      return;
                    var vi = Mr.getTypeChecker().getMergedSymbol(Tr.file.symbol);
                    if (vi)
                      return fe(Mr, vi, false, Pe, De);
                    var Ui = Mr.getFileIncludeReasons();
                    return Ui ? [{ definition: { type: 5, reference: Tr.reference, file: nr }, references: H(Tr.file, Ui, Mr) || e2.emptyArray }] : void 0;
                  }
                  if (!fr.implementations) {
                    var Yi = ne(nr, Pe, Ue);
                    if (Yi)
                      return Yi;
                  }
                  var Wi = Mr.getTypeChecker(), ct = Wi.getSymbolAtLocation(e2.isConstructorDeclaration(nr) && nr.parent.name || nr);
                  if (!ct) {
                    if (!fr.implementations && e2.isStringLiteralLike(nr)) {
                      if (e2.isModuleSpecifierLike(nr)) {
                        var Ui = Mr.getFileIncludeReasons(), Li = (Vr = (gr = nr.getSourceFile().resolvedModules) === null || gr === void 0 ? void 0 : gr.get(nr.text, e2.getModeForUsageLocation(nr.getSourceFile(), nr))) === null || Vr === void 0 ? void 0 : Vr.resolvedFileName, nt = Li ? Mr.getSourceFile(Li) : void 0;
                        if (nt)
                          return [{ definition: { type: 4, node: nr }, references: H(nt, Ui, Mr) || e2.emptyArray }];
                      }
                      return ae(nr, Pe, Wi, Ue);
                    }
                    return;
                  }
                  if (ct.escapedName === "export=")
                    return fe(Mr, ct.parent, false, Pe, De);
                  var Mt = l(ct, Mr, Pe, Ue, fr, De);
                  if (Mt && !(ct.flags & 33554432))
                    return Mt;
                  var xt = I(nr, ct, Wi), ut = xt && l(xt, Mr, Pe, Ue, fr, De), Dt = ue(ct, nr, Pe, De, Wi, Ue, fr);
                  return d(Mr, Mt, Dt, ut);
                }
                k.getReferencedSymbolsForNode = Y;
                function U(Oe, nr) {
                  return nr.use === 1 ? Oe = e2.getAdjustedReferenceLocation(Oe) : nr.use === 2 && (Oe = e2.getAdjustedRenameLocation(Oe)), Oe;
                }
                k.getAdjustedNode = U;
                function j(Oe, nr, Mr, Pe) {
                  var Ue, fr;
                  Pe === void 0 && (Pe = new e2.Set(Mr.map(function(Tr) {
                    return Tr.fileName;
                  })));
                  var De = (Ue = nr.getSourceFile(Oe)) === null || Ue === void 0 ? void 0 : Ue.symbol;
                  if (De)
                    return ((fr = fe(nr, De, false, Mr, Pe)[0]) === null || fr === void 0 ? void 0 : fr.references) || e2.emptyArray;
                  var gr = nr.getFileIncludeReasons(), Vr = nr.getSourceFile(Oe);
                  return Vr && gr && H(Vr, gr, nr) || e2.emptyArray;
                }
                k.getReferencesForFileName = j;
                function H(Oe, nr, Mr) {
                  for (var Pe, Ue = nr.get(Oe.path) || e2.emptyArray, fr = 0, De = Ue; fr < De.length; fr++) {
                    var gr = De[fr];
                    if (e2.isReferencedFile(gr)) {
                      var Vr = Mr.getSourceFileByPath(gr.file), Tr = e2.getReferencedFileLocation(Mr.getSourceFileByPath, gr);
                      e2.isReferenceFileLocation(Tr) && (Pe = e2.append(Pe, { kind: 0, fileName: Vr.fileName, textSpan: e2.createTextSpanFromRange(Tr) }));
                    }
                  }
                  return Pe;
                }
                function I(Oe, nr, Mr) {
                  if (Oe.parent && e2.isNamespaceExportDeclaration(Oe.parent)) {
                    var Pe = Mr.getAliasedSymbol(nr), Ue = Mr.getMergedSymbol(Pe);
                    if (Pe !== Ue)
                      return Ue;
                  }
                }
                function l(Oe, nr, Mr, Pe, Ue, fr) {
                  var De = Oe.flags & 1536 && Oe.declarations && e2.find(Oe.declarations, e2.isSourceFile);
                  if (!!De) {
                    var gr = Oe.exports.get("export="), Vr = fe(nr, Oe, !!gr, Mr, fr);
                    if (!gr || !fr.has(De.fileName))
                      return Vr;
                    var Tr = nr.getTypeChecker();
                    return Oe = e2.skipAlias(gr, Tr), d(nr, Vr, ue(Oe, void 0, Mr, fr, Tr, Pe, Ue));
                  }
                }
                function d(Oe) {
                  for (var nr = [], Mr = 1; Mr < arguments.length; Mr++)
                    nr[Mr - 1] = arguments[Mr];
                  for (var Pe, Ue = 0, fr = nr; Ue < fr.length; Ue++) {
                    var De = fr[Ue];
                    if (!(!De || !De.length)) {
                      if (!Pe) {
                        Pe = De;
                        continue;
                      }
                      for (var gr = function(Ui) {
                        if (!Ui.definition || Ui.definition.type !== 0)
                          return Pe.push(Ui), "continue";
                        var Yi = Ui.definition.symbol, Wi = e2.findIndex(Pe, function(Li) {
                          return !!Li.definition && Li.definition.type === 0 && Li.definition.symbol === Yi;
                        });
                        if (Wi === -1)
                          return Pe.push(Ui), "continue";
                        var ct = Pe[Wi];
                        Pe[Wi] = { definition: ct.definition, references: ct.references.concat(Ui.references).sort(function(Li, nt) {
                          var Mt = D(Oe, Li), xt = D(Oe, nt);
                          if (Mt !== xt)
                            return e2.compareValues(Mt, xt);
                          var ut = A2(Li), Dt = A2(nt);
                          return ut.start !== Dt.start ? e2.compareValues(ut.start, Dt.start) : e2.compareValues(ut.length, Dt.length);
                        }) };
                      }, Vr = 0, Tr = De; Vr < Tr.length; Vr++) {
                        var vi = Tr[Vr];
                        gr(vi);
                      }
                    }
                  }
                  return Pe;
                }
                function D(Oe, nr) {
                  var Mr = nr.kind === 0 ? Oe.getSourceFile(nr.fileName) : nr.node.getSourceFile();
                  return Oe.getSourceFiles().indexOf(Mr);
                }
                function fe(Oe, nr, Mr, Pe, Ue) {
                  e2.Debug.assert(!!nr.valueDeclaration);
                  var fr = e2.mapDefined(C.findModuleReferences(Oe, Pe, nr), function(ct) {
                    if (ct.kind === "import") {
                      var Li = ct.literal.parent;
                      if (e2.isLiteralTypeNode(Li)) {
                        var nt = e2.cast(Li.parent, e2.isImportTypeNode);
                        if (Mr && !nt.qualifier)
                          return;
                      }
                      return E(ct.literal);
                    } else
                      return { kind: 0, fileName: ct.referencingFile.fileName, textSpan: e2.createTextSpanFromRange(ct.ref) };
                  });
                  if (nr.declarations)
                    for (var De = 0, gr = nr.declarations; De < gr.length; De++) {
                      var Vr = gr[De];
                      switch (Vr.kind) {
                        case 305:
                          break;
                        case 261:
                          Ue.has(Vr.getSourceFile().fileName) && fr.push(E(Vr.name));
                          break;
                        default:
                          e2.Debug.assert(!!(nr.flags & 33554432), "Expected a module symbol to be declared by a SourceFile or ModuleDeclaration.");
                      }
                    }
                  var Tr = nr.exports.get("export=");
                  if (Tr != null && Tr.declarations)
                    for (var vi = 0, Ui = Tr.declarations; vi < Ui.length; vi++) {
                      var Vr = Ui[vi], Yi = Vr.getSourceFile();
                      if (Ue.has(Yi.fileName)) {
                        var Wi = e2.isBinaryExpression(Vr) && e2.isPropertyAccessExpression(Vr.left) ? Vr.left.expression : e2.isExportAssignment(Vr) ? e2.Debug.checkDefined(e2.findChildOfKind(Vr, 93, Yi)) : e2.getNameOfDeclaration(Vr) || Vr;
                        fr.push(E(Wi));
                      }
                    }
                  return fr.length ? [{ definition: { type: 0, symbol: nr }, references: fr }] : e2.emptyArray;
                }
                function g(Oe) {
                  return Oe.kind === 145 && e2.isTypeOperatorNode(Oe.parent) && Oe.parent.operator === 145;
                }
                function ne(Oe, nr, Mr) {
                  if (e2.isTypeKeyword(Oe.kind))
                    return Oe.kind === 114 && e2.isVoidExpression(Oe.parent) || Oe.kind === 145 && !g(Oe) ? void 0 : Ne(nr, Oe.kind, Mr, Oe.kind === 145 ? g : void 0);
                  if (e2.isImportMeta(Oe.parent) && Oe.parent.name === Oe)
                    return Er(nr, Mr);
                  if (e2.isStaticModifier(Oe) && e2.isClassStaticBlockDeclaration(Oe.parent))
                    return [{ definition: { type: 2, node: Oe }, references: [E(Oe)] }];
                  if (e2.isJumpStatementTarget(Oe)) {
                    var Pe = e2.getTargetLabel(Oe.parent, Oe.text);
                    return Pe && Ye(Pe.parent, Pe);
                  } else if (e2.isLabelOfLabeledStatement(Oe))
                    return Ye(Oe.parent, Oe);
                  if (e2.isThis(Oe))
                    return pi(Oe, nr, Mr);
                  if (Oe.kind === 106)
                    return Zt(Oe);
                }
                function ue(Oe, nr, Mr, Pe, Ue, fr, De) {
                  var gr = nr && Z2(Oe, nr, Ue, !Ar(De)) || Oe, Vr = nr ? zr(nr, gr) : 7, Tr = [], vi = new Re(Mr, Pe, nr ? Fe(nr) : 0, Ue, fr, Vr, De, Tr), Ui = !Ar(De) || !gr.declarations ? void 0 : e2.find(gr.declarations, e2.isExportSpecifier);
                  if (Ui)
                    ur(Ui.name, gr, Ui, vi.createSearch(nr, Oe, void 0), vi, true, true);
                  else if (nr && nr.kind === 88 && gr.escapedName === "default" && gr.parent)
                    ii(nr, gr, vi), ze(nr, gr, { exportingModuleSymbol: gr.parent, exportKind: 1 }, vi);
                  else {
                    var Yi = vi.createSearch(nr, gr, void 0, { allSearchSymbols: nr ? Xe(gr, nr, Ue, De.use === 2, !!De.providePrefixAndSuffixTextForRename, !!De.implementations) : [gr] });
                    We(gr, vi, Yi);
                  }
                  return Tr;
                }
                function We(Oe, nr, Mr) {
                  var Pe = we(Oe);
                  if (Pe)
                    lr(Pe, Pe.getSourceFile(), Mr, nr, !(e2.isSourceFile(Pe) && !e2.contains(nr.sourceFiles, Pe)));
                  else
                    for (var Ue = 0, fr = nr.sourceFiles; Ue < fr.length; Ue++) {
                      var De = fr[Ue];
                      nr.cancellationToken.throwIfCancellationRequested(), Ie(De, Mr, nr);
                    }
                }
                function Fe(Oe) {
                  switch (Oe.kind) {
                    case 171:
                    case 134:
                      return 1;
                    case 79:
                      if (e2.isClassLike(Oe.parent))
                        return e2.Debug.assert(Oe.parent.name === Oe), 2;
                    default:
                      return 0;
                  }
                }
                function Z2(Oe, nr, Mr, Pe) {
                  var Ue = nr.parent;
                  return e2.isExportSpecifier(Ue) && Pe ? yr(nr, Oe, Ue, Mr) : e2.firstDefined(Oe.declarations, function(fr) {
                    if (!fr.parent) {
                      if (Oe.flags & 33554432)
                        return;
                      e2.Debug.fail("Unexpected symbol at ".concat(e2.Debug.formatSyntaxKind(nr.kind), ": ").concat(e2.Debug.formatSymbol(Oe)));
                    }
                    return e2.isTypeLiteralNode(fr.parent) && e2.isUnionTypeNode(fr.parent.parent) ? Mr.getPropertyOfType(Mr.getTypeFromTypeNode(fr.parent.parent), Oe.name) : void 0;
                  });
                }
                var Be;
                (function(Oe) {
                  Oe[Oe.None = 0] = "None", Oe[Oe.Constructor = 1] = "Constructor", Oe[Oe.Class = 2] = "Class";
                })(Be || (Be = {}));
                function ge(Oe) {
                  if (!!(Oe.flags & 33555968)) {
                    var nr = Oe.declarations && e2.find(Oe.declarations, function(Mr) {
                      return !e2.isSourceFile(Mr) && !e2.isModuleDeclaration(Mr);
                    });
                    return nr && nr.symbol;
                  }
                }
                var Re = function() {
                  function Oe(nr, Mr, Pe, Ue, fr, De, gr, Vr) {
                    this.sourceFiles = nr, this.sourceFilesSet = Mr, this.specialSearchKind = Pe, this.checker = Ue, this.cancellationToken = fr, this.searchMeaning = De, this.options = gr, this.result = Vr, this.inheritsFromCache = new e2.Map(), this.markSeenContainingTypeReference = e2.nodeSeenTracker(), this.markSeenReExportRHS = e2.nodeSeenTracker(), this.symbolIdToReferences = [], this.sourceFileToSeenSymbols = [];
                  }
                  return Oe.prototype.includesSourceFile = function(nr) {
                    return this.sourceFilesSet.has(nr.fileName);
                  }, Oe.prototype.getImportSearches = function(nr, Mr) {
                    return this.importTracker || (this.importTracker = C.createImportTracker(this.sourceFiles, this.sourceFilesSet, this.checker, this.cancellationToken)), this.importTracker(nr, Mr, this.options.use === 2);
                  }, Oe.prototype.createSearch = function(nr, Mr, Pe, Ue) {
                    Ue === void 0 && (Ue = {});
                    var fr = Ue.text, De = fr === void 0 ? e2.stripQuotes(e2.symbolName(e2.getLocalSymbolForExportDefault(Mr) || ge(Mr) || Mr)) : fr, gr = Ue.allSearchSymbols, Vr = gr === void 0 ? [Mr] : gr, Tr = e2.escapeLeadingUnderscores(De), vi = this.options.implementations && nr ? mr(nr, Mr, this.checker) : void 0;
                    return { symbol: Mr, comingFrom: Pe, text: De, escapedText: Tr, parents: vi, allSearchSymbols: Vr, includes: function(Ui) {
                      return e2.contains(Vr, Ui);
                    } };
                  }, Oe.prototype.referenceAdder = function(nr) {
                    var Mr = e2.getSymbolId(nr), Pe = this.symbolIdToReferences[Mr];
                    return Pe || (Pe = this.symbolIdToReferences[Mr] = [], this.result.push({ definition: { type: 0, symbol: nr }, references: Pe })), function(Ue, fr) {
                      return Pe.push(E(Ue, fr));
                    };
                  }, Oe.prototype.addStringOrCommentReference = function(nr, Mr) {
                    this.result.push({ definition: void 0, references: [{ kind: 0, fileName: nr, textSpan: Mr }] });
                  }, Oe.prototype.markSearchedSymbols = function(nr, Mr) {
                    for (var Pe = e2.getNodeId(nr), Ue = this.sourceFileToSeenSymbols[Pe] || (this.sourceFileToSeenSymbols[Pe] = new e2.Set()), fr = false, De = 0, gr = Mr; De < gr.length; De++) {
                      var Vr = gr[De];
                      fr = e2.tryAddToSet(Ue, e2.getSymbolId(Vr)) || fr;
                    }
                    return fr;
                  }, Oe;
                }();
                function ze(Oe, nr, Mr, Pe) {
                  var Ue = Pe.getImportSearches(nr, Mr), fr = Ue.importSearches, De = Ue.singleReferences, gr = Ue.indirectUsers;
                  if (De.length)
                    for (var Vr = Pe.referenceAdder(nr), Tr = 0, vi = De; Tr < vi.length; Tr++) {
                      var Ui = vi[Tr];
                      He(Ui, Pe) && Vr(Ui);
                    }
                  for (var Yi = 0, Wi = fr; Yi < Wi.length; Yi++) {
                    var ct = Wi[Yi], Li = ct[0], nt = ct[1];
                    n(Li.getSourceFile(), Pe.createSearch(Li, nt, 1), Pe);
                  }
                  if (gr.length) {
                    var Mt = void 0;
                    switch (Mr.exportKind) {
                      case 0:
                        Mt = Pe.createSearch(Oe, nr, 1);
                        break;
                      case 1:
                        Mt = Pe.options.use === 2 ? void 0 : Pe.createSearch(Oe, nr, 1, { text: "default" });
                        break;
                      case 2:
                        break;
                    }
                    if (Mt)
                      for (var xt = 0, ut = gr; xt < ut.length; xt++) {
                        var Dt = ut[xt];
                        Ie(Dt, Mt, Pe);
                      }
                  }
                }
                function Ee(Oe, nr, Mr, Pe, Ue, fr, De, gr) {
                  for (var Vr = C.createImportTracker(Oe, new e2.Set(Oe.map(function(wt) {
                    return wt.fileName;
                  })), nr, Mr), Tr = Vr(Pe, { exportKind: De ? 1 : 0, exportingModuleSymbol: Ue }, false), vi = Tr.importSearches, Ui = Tr.indirectUsers, Yi = Tr.singleReferences, Wi = 0, ct = vi; Wi < ct.length; Wi++) {
                    var Li = ct[Wi][0];
                    gr(Li);
                  }
                  for (var nt = 0, Mt = Yi; nt < Mt.length; nt++) {
                    var xt = Mt[nt];
                    e2.isIdentifier(xt) && e2.isImportTypeNode(xt.parent) && gr(xt);
                  }
                  for (var ut = 0, Dt = Ui; ut < Dt.length; ut++)
                    for (var Rt = Dt[ut], Ii = 0, Ki = ir(Rt, De ? "default" : fr); Ii < Ki.length; Ii++) {
                      var Fi = Ki[Ii], ui = nr.getSymbolAtLocation(Fi), Bt = e2.some(ui == null ? void 0 : ui.declarations, function(wt) {
                        return !!e2.tryCast(wt, e2.isExportAssignment);
                      });
                      e2.isIdentifier(Fi) && !e2.isImportOrExportSpecifier(Fi.parent) && (ui === Pe || Bt) && gr(Fi);
                    }
                }
                k.eachExportReference = Ee;
                function He(Oe, nr) {
                  return be(Oe, nr) ? nr.options.use !== 2 ? true : e2.isIdentifier(Oe) ? !(e2.isImportOrExportSpecifier(Oe.parent) && Oe.escapedText === "default") : false : false;
                }
                function rr(Oe, nr) {
                  if (!!Oe.declarations)
                    for (var Mr = 0, Pe = Oe.declarations; Mr < Pe.length; Mr++) {
                      var Ue = Pe[Mr], fr = Ue.getSourceFile();
                      n(fr, nr.createSearch(Ue, Oe, 0), nr, nr.includesSourceFile(fr));
                    }
                }
                function Ie(Oe, nr, Mr) {
                  e2.getNameTable(Oe).get(nr.escapedText) !== void 0 && n(Oe, nr, Mr);
                }
                function _e(Oe, nr) {
                  return e2.isArrayLiteralOrObjectLiteralDestructuringPattern(Oe.parent.parent) ? nr.getPropertySymbolOfDestructuringAssignment(Oe) : void 0;
                }
                function we(Oe) {
                  var nr = Oe.declarations, Mr = Oe.flags, Pe = Oe.parent, Ue = Oe.valueDeclaration;
                  if (Ue && (Ue.kind === 213 || Ue.kind === 226))
                    return Ue;
                  if (!!nr) {
                    if (Mr & 8196) {
                      var fr = e2.find(nr, function(Wi) {
                        return e2.hasEffectiveModifier(Wi, 8) || e2.isPrivateIdentifierClassElementDeclaration(Wi);
                      });
                      return fr ? e2.getAncestor(fr, 257) : void 0;
                    }
                    if (!nr.some(e2.isObjectBindingElementWithoutPropertyName)) {
                      var De = Pe && !(Oe.flags & 262144);
                      if (!(De && !(e2.isExternalModuleSymbol(Pe) && !Pe.globalExports))) {
                        for (var gr, Vr = 0, Tr = nr; Vr < Tr.length; Vr++) {
                          var vi = Tr[Vr], Ui = e2.getContainerNode(vi);
                          if (gr && gr !== Ui || !Ui || Ui.kind === 305 && !e2.isExternalOrCommonJsModule(Ui))
                            return;
                          if (gr = Ui, e2.isFunctionExpression(gr))
                            for (var Yi = void 0; Yi = e2.getNextJSDocCommentLocation(gr); )
                              gr = Yi;
                        }
                        return De ? gr.getSourceFile() : gr;
                      }
                    }
                  }
                }
                function de(Oe, nr, Mr, Pe) {
                  return Pe === void 0 && (Pe = Mr), ye(Oe, nr, Mr, function() {
                    return true;
                  }, Pe) || false;
                }
                k.isSymbolReferencedInFile = de;
                function ye(Oe, nr, Mr, Pe, Ue) {
                  Ue === void 0 && (Ue = Mr);
                  var fr = e2.isParameterPropertyDeclaration(Oe.parent, Oe.parent.parent) ? e2.first(nr.getSymbolsOfParameterPropertyDeclaration(Oe.parent, Oe.text)) : nr.getSymbolAtLocation(Oe);
                  if (!!fr)
                    for (var De = 0, gr = ir(Mr, fr.name, Ue); De < gr.length; De++) {
                      var Vr = gr[De];
                      if (!(!e2.isIdentifier(Vr) || Vr === Oe || Vr.escapedText !== Oe.escapedText)) {
                        var Tr = nr.getSymbolAtLocation(Vr);
                        if (Tr === fr || nr.getShorthandAssignmentValueSymbol(Vr.parent) === fr || e2.isExportSpecifier(Vr.parent) && yr(Vr, Tr, Vr.parent, nr) === fr) {
                          var vi = Pe(Vr);
                          if (vi)
                            return vi;
                        }
                      }
                    }
                }
                k.eachSymbolReferenceInFile = ye;
                function Ae(Oe, nr) {
                  var Mr = e2.filter(ir(nr, Oe), function(Ue) {
                    return !!e2.getDeclarationFromName(Ue);
                  });
                  return Mr.reduce(function(Ue, fr) {
                    var De = Pe(fr);
                    return !e2.some(Ue.declarationNames) || De === Ue.depth ? (Ue.declarationNames.push(fr), Ue.depth = De) : De < Ue.depth && (Ue.declarationNames = [fr], Ue.depth = De), Ue;
                  }, { depth: 1 / 0, declarationNames: [] }).declarationNames;
                  function Pe(Ue) {
                    for (var fr = 0; Ue; )
                      Ue = e2.getContainerNode(Ue), fr++;
                    return fr;
                  }
                }
                k.getTopMostDeclarationNamesInFile = Ae;
                function er(Oe, nr, Mr, Pe) {
                  if (!Oe.name || !e2.isIdentifier(Oe.name))
                    return false;
                  for (var Ue = e2.Debug.checkDefined(Mr.getSymbolAtLocation(Oe.name)), fr = 0, De = nr; fr < De.length; fr++)
                    for (var gr = De[fr], Vr = 0, Tr = ir(gr, Ue.name); Vr < Tr.length; Vr++) {
                      var vi = Tr[Vr];
                      if (!(!e2.isIdentifier(vi) || vi === Oe.name || vi.escapedText !== Oe.name.escapedText)) {
                        var Ui = e2.climbPastPropertyAccess(vi), Yi = e2.isCallExpression(Ui.parent) && Ui.parent.expression === Ui ? Ui.parent : void 0, Wi = Mr.getSymbolAtLocation(vi);
                        if (Wi && Mr.getRootSymbols(Wi).some(function(ct) {
                          return ct === Ue;
                        }) && Pe(vi, Yi))
                          return true;
                      }
                    }
                  return false;
                }
                k.someSignatureUsage = er;
                function ir(Oe, nr, Mr) {
                  return Mr === void 0 && (Mr = Oe), Cr(Oe, nr, Mr).map(function(Pe) {
                    return e2.getTouchingPropertyName(Oe, Pe);
                  });
                }
                function Cr(Oe, nr, Mr) {
                  Mr === void 0 && (Mr = Oe);
                  var Pe = [];
                  if (!nr || !nr.length)
                    return Pe;
                  for (var Ue = Oe.text, fr = Ue.length, De = nr.length, gr = Ue.indexOf(nr, Mr.pos); gr >= 0 && !(gr > Mr.end); ) {
                    var Vr = gr + De;
                    (gr === 0 || !e2.isIdentifierPart(Ue.charCodeAt(gr - 1), 99)) && (Vr === fr || !e2.isIdentifierPart(Ue.charCodeAt(Vr), 99)) && Pe.push(gr), gr = Ue.indexOf(nr, gr + De + 1);
                  }
                  return Pe;
                }
                function Ye(Oe, nr) {
                  var Mr = Oe.getSourceFile(), Pe = nr.text, Ue = e2.mapDefined(ir(Mr, Pe, Oe), function(fr) {
                    return fr === nr || e2.isJumpStatementTarget(fr) && e2.getTargetLabel(fr, Pe) === nr ? E(fr) : void 0;
                  });
                  return [{ definition: { type: 1, node: nr }, references: Ue }];
                }
                function Br(Oe, nr) {
                  switch (Oe.kind) {
                    case 80:
                      if (e2.isJSDocMemberName(Oe.parent))
                        return true;
                    case 79:
                      return Oe.text.length === nr.length;
                    case 14:
                    case 10: {
                      var Mr = Oe;
                      return (e2.isLiteralNameOfPropertyDeclarationOrIndexAccess(Mr) || e2.isNameOfModuleDeclaration(Oe) || e2.isExpressionOfExternalModuleImportEqualsDeclaration(Oe) || e2.isCallExpression(Oe.parent) && e2.isBindableObjectDefinePropertyCall(Oe.parent) && Oe.parent.arguments[1] === Oe) && Mr.text.length === nr.length;
                    }
                    case 8:
                      return e2.isLiteralNameOfPropertyDeclarationOrIndexAccess(Oe) && Oe.text.length === nr.length;
                    case 88:
                      return nr.length === 7;
                    default:
                      return false;
                  }
                }
                function Er(Oe, nr) {
                  var Mr = e2.flatMap(Oe, function(Pe) {
                    return nr.throwIfCancellationRequested(), e2.mapDefined(ir(Pe, "meta", Pe), function(Ue) {
                      var fr = Ue.parent;
                      if (e2.isImportMeta(fr))
                        return E(fr);
                    });
                  });
                  return Mr.length ? [{ definition: { type: 2, node: Mr[0].node }, references: Mr }] : void 0;
                }
                function Ne(Oe, nr, Mr, Pe) {
                  var Ue = e2.flatMap(Oe, function(fr) {
                    return Mr.throwIfCancellationRequested(), e2.mapDefined(ir(fr, e2.tokenToString(nr), fr), function(De) {
                      if (De.kind === nr && (!Pe || Pe(De)))
                        return E(De);
                    });
                  });
                  return Ue.length ? [{ definition: { type: 2, node: Ue[0].node }, references: Ue }] : void 0;
                }
                function n(Oe, nr, Mr, Pe) {
                  return Pe === void 0 && (Pe = true), Mr.cancellationToken.throwIfCancellationRequested(), lr(Oe, Oe, nr, Mr, Pe);
                }
                function lr(Oe, nr, Mr, Pe, Ue) {
                  if (!!Pe.markSearchedSymbols(nr, Mr.allSearchSymbols))
                    for (var fr = 0, De = Cr(nr, Mr.text, Oe); fr < De.length; fr++) {
                      var gr = De[fr];
                      Ge(nr, gr, Mr, Pe, Ue);
                    }
                }
                function be(Oe, nr) {
                  return !!(e2.getMeaningFromLocation(Oe) & nr.searchMeaning);
                }
                function Ge(Oe, nr, Mr, Pe, Ue) {
                  var fr = e2.getTouchingPropertyName(Oe, nr);
                  if (!Br(fr, Mr.text)) {
                    !Pe.options.implementations && (Pe.options.findInStrings && e2.isInString(Oe, nr) || Pe.options.findInComments && e2.isInNonReferenceComment(Oe, nr)) && Pe.addStringOrCommentReference(Oe.fileName, e2.createTextSpan(nr, Mr.text.length));
                    return;
                  }
                  if (!!be(fr, Pe)) {
                    var De = Pe.checker.getSymbolAtLocation(fr);
                    if (!!De) {
                      var gr = fr.parent;
                      if (!(e2.isImportSpecifier(gr) && gr.propertyName === fr)) {
                        if (e2.isExportSpecifier(gr)) {
                          e2.Debug.assert(fr.kind === 79), ur(fr, De, gr, Mr, Pe, Ue);
                          return;
                        }
                        var Vr = Sr(Mr, De, fr, Pe);
                        if (!Vr) {
                          Ur(De, Mr, Pe);
                          return;
                        }
                        switch (Pe.specialSearchKind) {
                          case 0:
                            Ue && ii(fr, Vr, Pe);
                            break;
                          case 1:
                            mi(fr, Oe, Mr, Pe);
                            break;
                          case 2:
                            pe(fr, Mr, Pe);
                            break;
                          default:
                            e2.Debug.assertNever(Pe.specialSearchKind);
                        }
                        e2.isInJSFile(fr) && fr.parent.kind === 203 && e2.isVariableDeclarationInitializedToBareOrAccessedRequire(fr.parent) && (De = fr.parent.symbol, !De) || wr(fr, De, Mr, Pe);
                      }
                    }
                  }
                }
                function ur(Oe, nr, Mr, Pe, Ue, fr, De) {
                  e2.Debug.assert(!De || !!Ue.options.providePrefixAndSuffixTextForRename, "If alwaysGetReferences is true, then prefix/suffix text must be enabled");
                  var gr = Mr.parent, Vr = Mr.propertyName, Tr = Mr.name, vi = gr.parent, Ui = yr(Oe, nr, Mr, Ue.checker);
                  if (!De && !Pe.includes(Ui))
                    return;
                  if (Vr ? Oe === Vr ? (vi.moduleSpecifier || Mt(), fr && Ue.options.use !== 2 && Ue.markSeenReExportRHS(Tr) && ii(Tr, e2.Debug.checkDefined(Mr.symbol), Ue)) : Ue.markSeenReExportRHS(Oe) && Mt() : Ue.options.use === 2 && Tr.escapedText === "default" || Mt(), !Ar(Ue.options) || De) {
                    var Yi = Oe.originalKeywordKind === 88 || Mr.name.originalKeywordKind === 88, Wi = Yi ? 1 : 0, ct = e2.Debug.checkDefined(Mr.symbol), Li = C.getExportInfo(ct, Wi, Ue.checker);
                    Li && ze(Oe, ct, Li, Ue);
                  }
                  if (Pe.comingFrom !== 1 && vi.moduleSpecifier && !Vr && !Ar(Ue.options)) {
                    var nt = Ue.checker.getExportSpecifierLocalTargetSymbol(Mr);
                    nt && rr(nt, Ue);
                  }
                  function Mt() {
                    fr && ii(Oe, Ui, Ue);
                  }
                }
                function yr(Oe, nr, Mr, Pe) {
                  return Ir(Oe, Mr) && Pe.getExportSpecifierLocalTargetSymbol(Mr) || nr;
                }
                function Ir(Oe, nr) {
                  var Mr = nr.parent, Pe = nr.propertyName, Ue = nr.name;
                  return e2.Debug.assert(Pe === Oe || Ue === Oe), Pe ? Pe === Oe : !Mr.parent.moduleSpecifier;
                }
                function wr(Oe, nr, Mr, Pe) {
                  var Ue = C.getImportOrExportSymbol(Oe, nr, Pe.checker, Mr.comingFrom === 1);
                  if (!!Ue) {
                    var fr = Ue.symbol;
                    Ue.kind === 0 ? Ar(Pe.options) || rr(fr, Pe) : ze(Oe, fr, Ue.exportInfo, Pe);
                  }
                }
                function Ur(Oe, nr, Mr) {
                  var Pe = Oe.flags, Ue = Oe.valueDeclaration, fr = Mr.checker.getShorthandAssignmentValueSymbol(Ue), De = Ue && e2.getNameOfDeclaration(Ue);
                  !(Pe & 33554432) && De && nr.includes(fr) && ii(De, fr, Mr);
                }
                function ii(Oe, nr, Mr) {
                  var Pe = "kind" in nr ? nr : { kind: void 0, symbol: nr }, Ue = Pe.kind, fr = Pe.symbol;
                  if (!(Mr.options.use === 2 && Oe.kind === 88)) {
                    var De = Mr.referenceAdder(fr);
                    Mr.options.implementations ? Xi(Oe, De, Mr) : De(Oe, Ue);
                  }
                }
                function mi(Oe, nr, Mr, Pe) {
                  e2.isNewExpressionTarget(Oe) && ii(Oe, Mr.symbol, Pe);
                  var Ue = function() {
                    return Pe.referenceAdder(Mr.symbol);
                  };
                  if (e2.isClassLike(Oe.parent))
                    e2.Debug.assert(Oe.kind === 88 || Oe.parent.name === Oe), or(Mr.symbol, nr, Ue());
                  else {
                    var fr = vr(Oe);
                    fr && (si(fr, Ue()), wi(fr, Pe));
                  }
                }
                function pe(Oe, nr, Mr) {
                  ii(Oe, nr.symbol, Mr);
                  var Pe = Oe.parent;
                  if (!(Mr.options.use === 2 || !e2.isClassLike(Pe))) {
                    e2.Debug.assert(Pe.name === Oe);
                    for (var Ue = Mr.referenceAdder(nr.symbol), fr = 0, De = Pe.members; fr < De.length; fr++) {
                      var gr = De[fr];
                      !(e2.isMethodOrAccessor(gr) && e2.isStatic(gr)) || gr.body && gr.body.forEachChild(function Vr(Tr) {
                        Tr.kind === 108 ? Ue(Tr) : !e2.isFunctionLike(Tr) && !e2.isClassLike(Tr) && Tr.forEachChild(Vr);
                      });
                    }
                  }
                }
                function or(Oe, nr, Mr) {
                  var Pe = qr(Oe);
                  if (Pe && Pe.declarations)
                    for (var Ue = 0, fr = Pe.declarations; Ue < fr.length; Ue++) {
                      var De = fr[Ue], gr = e2.findChildOfKind(De, 134, nr);
                      e2.Debug.assert(De.kind === 171 && !!gr), Mr(gr);
                    }
                  Oe.exports && Oe.exports.forEach(function(Vr) {
                    var Tr = Vr.valueDeclaration;
                    if (Tr && Tr.kind === 169) {
                      var vi = Tr.body;
                      vi && xe(vi, 108, function(Ui) {
                        e2.isNewExpressionTarget(Ui) && Mr(Ui);
                      });
                    }
                  });
                }
                function qr(Oe) {
                  return Oe.members && Oe.members.get("__constructor");
                }
                function si(Oe, nr) {
                  var Mr = qr(Oe.symbol);
                  if (!!(Mr && Mr.declarations))
                    for (var Pe = 0, Ue = Mr.declarations; Pe < Ue.length; Pe++) {
                      var fr = Ue[Pe];
                      e2.Debug.assert(fr.kind === 171);
                      var De = fr.body;
                      De && xe(De, 106, function(gr) {
                        e2.isCallExpressionTarget(gr) && nr(gr);
                      });
                    }
                }
                function Di(Oe) {
                  return !!qr(Oe.symbol);
                }
                function wi(Oe, nr) {
                  if (!Di(Oe)) {
                    var Mr = Oe.symbol, Pe = nr.createSearch(void 0, Mr, void 0);
                    We(Mr, nr, Pe);
                  }
                }
                function Xi(Oe, nr, Mr) {
                  if (e2.isDeclarationName(Oe) && Wr(Oe.parent)) {
                    nr(Oe);
                    return;
                  }
                  if (Oe.kind !== 79)
                    return;
                  Oe.parent.kind === 297 && Je(Oe, Mr.checker, nr);
                  var Pe = et(Oe);
                  if (Pe) {
                    nr(Pe);
                    return;
                  }
                  var Ue = e2.findAncestor(Oe, function(Vr) {
                    return !e2.isQualifiedName(Vr.parent) && !e2.isTypeNode(Vr.parent) && !e2.isTypeElement(Vr.parent);
                  }), fr = Ue.parent;
                  if (e2.hasType(fr) && fr.type === Ue && Mr.markSeenContainingTypeReference(fr))
                    if (e2.hasInitializer(fr))
                      gr(fr.initializer);
                    else if (e2.isFunctionLike(fr) && fr.body) {
                      var De = fr.body;
                      De.kind === 235 ? e2.forEachReturnStatement(De, function(Vr) {
                        Vr.expression && gr(Vr.expression);
                      }) : gr(De);
                    } else
                      e2.isAssertionExpression(fr) && gr(fr.expression);
                  function gr(Vr) {
                    Gi(Vr) && nr(Vr);
                  }
                }
                function et(Oe) {
                  return e2.isIdentifier(Oe) || e2.isPropertyAccessExpression(Oe) ? et(Oe.parent) : e2.isExpressionWithTypeArguments(Oe) ? e2.tryCast(Oe.parent.parent, e2.isClassLike) : void 0;
                }
                function Gi(Oe) {
                  switch (Oe.kind) {
                    case 212:
                      return Gi(Oe.expression);
                    case 214:
                    case 213:
                    case 205:
                    case 226:
                    case 204:
                      return true;
                    default:
                      return false;
                  }
                }
                function Wt(Oe, nr, Mr, Pe) {
                  if (Oe === nr)
                    return true;
                  var Ue = e2.getSymbolId(Oe) + "," + e2.getSymbolId(nr), fr = Mr.get(Ue);
                  if (fr !== void 0)
                    return fr;
                  Mr.set(Ue, false);
                  var De = !!Oe.declarations && Oe.declarations.some(function(gr) {
                    return e2.getAllSuperTypeNodes(gr).some(function(Vr) {
                      var Tr = Pe.getTypeAtLocation(Vr);
                      return !!Tr && !!Tr.symbol && Wt(Tr.symbol, nr, Mr, Pe);
                    });
                  });
                  return Mr.set(Ue, De), De;
                }
                function Zt(Oe) {
                  var nr = e2.getSuperContainer(Oe, false);
                  if (!!nr) {
                    var Mr = 32;
                    switch (nr.kind) {
                      case 167:
                      case 166:
                      case 169:
                      case 168:
                      case 171:
                      case 172:
                      case 173:
                        Mr &= e2.getSyntacticModifierFlags(nr), nr = nr.parent;
                        break;
                      default:
                        return;
                    }
                    var Pe = nr.getSourceFile(), Ue = e2.mapDefined(ir(Pe, "super", nr), function(fr) {
                      if (fr.kind === 106) {
                        var De = e2.getSuperContainer(fr, false);
                        return De && e2.isStatic(De) === !!Mr && De.parent.symbol === nr.symbol ? E(fr) : void 0;
                      }
                    });
                    return [{ definition: { type: 0, symbol: nr.symbol }, references: Ue }];
                  }
                }
                function _r(Oe) {
                  return Oe.kind === 79 && Oe.parent.kind === 164 && Oe.parent.name === Oe;
                }
                function pi(Oe, nr, Mr) {
                  var Pe = e2.getThisContainer(Oe, false), Ue = 32;
                  switch (Pe.kind) {
                    case 169:
                    case 168:
                      if (e2.isObjectLiteralMethod(Pe)) {
                        Ue &= e2.getSyntacticModifierFlags(Pe), Pe = Pe.parent;
                        break;
                      }
                    case 167:
                    case 166:
                    case 171:
                    case 172:
                    case 173:
                      Ue &= e2.getSyntacticModifierFlags(Pe), Pe = Pe.parent;
                      break;
                    case 305:
                      if (e2.isExternalModule(Pe) || _r(Oe))
                        return;
                    case 256:
                    case 213:
                      break;
                    default:
                      return;
                  }
                  var fr = e2.flatMap(Pe.kind === 305 ? nr : [Pe.getSourceFile()], function(gr) {
                    return Mr.throwIfCancellationRequested(), ir(gr, "this", e2.isSourceFile(Pe) ? gr : Pe).filter(function(Vr) {
                      if (!e2.isThis(Vr))
                        return false;
                      var Tr = e2.getThisContainer(Vr, false);
                      switch (Pe.kind) {
                        case 213:
                        case 256:
                          return Pe.symbol === Tr.symbol;
                        case 169:
                        case 168:
                          return e2.isObjectLiteralMethod(Pe) && Pe.symbol === Tr.symbol;
                        case 226:
                        case 257:
                        case 205:
                          return Tr.parent && Pe.symbol === Tr.parent.symbol && e2.isStatic(Tr) === !!Ue;
                        case 305:
                          return Tr.kind === 305 && !e2.isExternalModule(Tr) && !_r(Vr);
                      }
                    });
                  }).map(function(gr) {
                    return E(gr);
                  }), De = e2.firstDefined(fr, function(gr) {
                    return e2.isParameter(gr.node.parent) ? gr.node : void 0;
                  });
                  return [{ definition: { type: 3, node: De || Oe }, references: fr }];
                }
                function ae(Oe, nr, Mr, Pe) {
                  var Ue = e2.getContextualTypeFromParentOrAncestorTypeNode(Oe, Mr), fr = e2.flatMap(nr, function(De) {
                    return Pe.throwIfCancellationRequested(), e2.mapDefined(ir(De, Oe.text), function(gr) {
                      if (e2.isStringLiteralLike(gr) && gr.text === Oe.text)
                        if (Ue) {
                          var Vr = e2.getContextualTypeFromParentOrAncestorTypeNode(gr, Mr);
                          if (Ue !== Mr.getStringType() && Ue === Vr)
                            return E(gr, 2);
                        } else
                          return e2.isNoSubstitutionTemplateLiteral(gr) && !e2.rangeIsOnSingleLine(gr, De) ? void 0 : E(gr, 2);
                    });
                  });
                  return [{ definition: { type: 4, node: Oe }, references: fr }];
                }
                function Xe(Oe, nr, Mr, Pe, Ue, fr) {
                  var De = [];
                  return Jr(Oe, nr, Mr, Pe, !(Pe && Ue), function(gr, Vr, Tr) {
                    Tr && Ze(Oe) !== Ze(Tr) && (Tr = void 0), De.push(Tr || Vr || gr);
                  }, function() {
                    return !fr;
                  }), De;
                }
                function Jr(Oe, nr, Mr, Pe, Ue, fr, De) {
                  var gr = e2.getContainingObjectLiteralElement(nr);
                  if (gr) {
                    var Vr = Mr.getShorthandAssignmentValueSymbol(nr.parent);
                    if (Vr && Pe)
                      return fr(Vr, void 0, void 0, 3);
                    var Tr = Mr.getContextualType(gr.parent), vi = Tr && e2.firstDefined(e2.getPropertySymbolsFromContextualType(gr, Mr, Tr, true), function(ui) {
                      return Ki(ui, 4);
                    });
                    if (vi)
                      return vi;
                    var Ui = _e(nr, Mr), Yi = Ui && fr(Ui, void 0, void 0, 4);
                    if (Yi)
                      return Yi;
                    var Wi = Vr && fr(Vr, void 0, void 0, 3);
                    if (Wi)
                      return Wi;
                  }
                  var ct = I(nr, Oe, Mr);
                  if (ct) {
                    var Li = fr(ct, void 0, void 0, 1);
                    if (Li)
                      return Li;
                  }
                  var nt = Ki(Oe);
                  if (nt)
                    return nt;
                  if (Oe.valueDeclaration && e2.isParameterPropertyDeclaration(Oe.valueDeclaration, Oe.valueDeclaration.parent)) {
                    var Mt = Mr.getSymbolsOfParameterPropertyDeclaration(e2.cast(Oe.valueDeclaration, e2.isParameter), Oe.name);
                    return e2.Debug.assert(Mt.length === 2 && !!(Mt[0].flags & 1) && !!(Mt[1].flags & 4)), Ki(Oe.flags & 1 ? Mt[1] : Mt[0]);
                  }
                  var xt = e2.getDeclarationOfKind(Oe, 275);
                  if (!Pe || xt && !xt.propertyName) {
                    var ut = xt && Mr.getExportSpecifierLocalTargetSymbol(xt);
                    if (ut) {
                      var Dt = fr(ut, void 0, void 0, 1);
                      if (Dt)
                        return Dt;
                    }
                  }
                  if (!Pe) {
                    var Rt = void 0;
                    return Ue ? Rt = e2.isObjectBindingElementWithoutPropertyName(nr.parent) ? e2.getPropertySymbolFromBindingElement(Mr, nr.parent) : void 0 : Rt = Fi(Oe, Mr), Rt && Ki(Rt, 4);
                  }
                  e2.Debug.assert(Pe);
                  var Ii = Ue;
                  if (Ii) {
                    var Rt = Fi(Oe, Mr);
                    return Rt && Ki(Rt, 4);
                  }
                  function Ki(ui, Bt) {
                    return e2.firstDefined(Mr.getRootSymbols(ui), function(wt) {
                      return fr(ui, wt, void 0, Bt) || (wt.parent && wt.parent.flags & 96 && De(wt) ? ti(wt.parent, wt.name, Mr, function(na) {
                        return fr(ui, wt, na, Bt);
                      }) : void 0);
                    });
                  }
                  function Fi(ui, Bt) {
                    var wt = e2.getDeclarationOfKind(ui, 203);
                    if (wt && e2.isObjectBindingElementWithoutPropertyName(wt))
                      return e2.getPropertySymbolFromBindingElement(Bt, wt);
                  }
                }
                function ti(Oe, nr, Mr, Pe) {
                  var Ue = new e2.Map();
                  return fr(Oe);
                  function fr(De) {
                    if (!(!(De.flags & 96) || !e2.addToSeen(Ue, e2.getSymbolId(De))))
                      return e2.firstDefined(De.declarations, function(gr) {
                        return e2.firstDefined(e2.getAllSuperTypeNodes(gr), function(Vr) {
                          var Tr = Mr.getTypeAtLocation(Vr), vi = Tr && Tr.symbol && Mr.getPropertyOfType(Tr, nr);
                          return Tr && vi && (e2.firstDefined(Mr.getRootSymbols(vi), Pe) || fr(Tr.symbol));
                        });
                      });
                  }
                }
                function Ze(Oe) {
                  if (!Oe.valueDeclaration)
                    return false;
                  var nr = e2.getEffectiveModifierFlags(Oe.valueDeclaration);
                  return !!(nr & 32);
                }
                function Sr(Oe, nr, Mr, Pe) {
                  var Ue = Pe.checker;
                  return Jr(nr, Mr, Ue, false, Pe.options.use !== 2 || !!Pe.options.providePrefixAndSuffixTextForRename, function(fr, De, gr, Vr) {
                    return gr && Ze(nr) !== Ze(gr) && (gr = void 0), Oe.includes(gr || De || fr) ? { symbol: De && !(e2.getCheckFlags(fr) & 6) ? De : fr, kind: Vr } : void 0;
                  }, function(fr) {
                    return !(Oe.parents && !Oe.parents.some(function(De) {
                      return Wt(fr.parent, De, Pe.inheritsFromCache, Ue);
                    }));
                  });
                }
                function zr(Oe, nr) {
                  var Mr = e2.getMeaningFromLocation(Oe), Pe = nr.declarations;
                  if (Pe) {
                    var Ue = void 0;
                    do {
                      Ue = Mr;
                      for (var fr = 0, De = Pe; fr < De.length; fr++) {
                        var gr = De[fr], Vr = e2.getMeaningFromDeclaration(gr);
                        Vr & Mr && (Mr |= Vr);
                      }
                    } while (Mr !== Ue);
                  }
                  return Mr;
                }
                k.getIntersectingMeaningFromDeclarations = zr;
                function Wr(Oe) {
                  return Oe.flags & 16777216 ? !(e2.isInterfaceDeclaration(Oe) || e2.isTypeAliasDeclaration(Oe)) : e2.isVariableLike(Oe) ? e2.hasInitializer(Oe) : e2.isFunctionLikeDeclaration(Oe) ? !!Oe.body : e2.isClassLike(Oe) || e2.isModuleOrEnumDeclaration(Oe);
                }
                function Je(Oe, nr, Mr) {
                  var Pe = nr.getSymbolAtLocation(Oe), Ue = nr.getShorthandAssignmentValueSymbol(Pe.valueDeclaration);
                  if (Ue)
                    for (var fr = 0, De = Ue.getDeclarations(); fr < De.length; fr++) {
                      var gr = De[fr];
                      e2.getMeaningFromDeclaration(gr) & 1 && Mr(gr);
                    }
                }
                k.getReferenceEntriesForShorthandPropertyAssignment = Je;
                function xe(Oe, nr, Mr) {
                  e2.forEachChild(Oe, function(Pe) {
                    Pe.kind === nr && Mr(Pe), xe(Pe, nr, Mr);
                  });
                }
                function vr(Oe) {
                  return e2.tryGetClassExtendingExpressionWithTypeArguments(e2.climbPastPropertyAccess(Oe).parent);
                }
                function mr(Oe, nr, Mr) {
                  var Pe = e2.isRightSideOfPropertyAccess(Oe) ? Oe.parent : void 0, Ue = Pe && Mr.getTypeAtLocation(Pe.expression), fr = e2.mapDefined(Ue && (Ue.isUnionOrIntersection() ? Ue.types : Ue.symbol === nr.parent ? void 0 : [Ue]), function(De) {
                    return De.symbol && De.symbol.flags & 96 ? De.symbol : void 0;
                  });
                  return fr.length === 0 ? void 0 : fr;
                }
                function Ar(Oe) {
                  return Oe.use === 2 && Oe.providePrefixAndSuffixTextForRename;
                }
              })(P = C.Core || (C.Core = {}));
            })(a = e2.FindAllReferences || (e2.FindAllReferences = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(L) {
                return (e2.isFunctionExpression(L) || e2.isClassExpression(L)) && e2.isNamedDeclaration(L);
              }
              function B(L) {
                return (e2.isFunctionExpression(L) || e2.isArrowFunction(L) || e2.isClassExpression(L)) && e2.isVariableDeclaration(L.parent) && L === L.parent.initializer && e2.isIdentifier(L.parent.name) && !!(e2.getCombinedNodeFlags(L.parent) & 2);
              }
              function E(L) {
                return e2.isSourceFile(L) || e2.isModuleDeclaration(L) || e2.isFunctionDeclaration(L) || e2.isFunctionExpression(L) || e2.isClassDeclaration(L) || e2.isClassExpression(L) || e2.isClassStaticBlockDeclaration(L) || e2.isMethodDeclaration(L) || e2.isMethodSignature(L) || e2.isGetAccessorDeclaration(L) || e2.isSetAccessorDeclaration(L);
              }
              function Q(L) {
                return e2.isSourceFile(L) || e2.isModuleDeclaration(L) && e2.isIdentifier(L.name) || e2.isFunctionDeclaration(L) || e2.isClassDeclaration(L) || e2.isClassStaticBlockDeclaration(L) || e2.isMethodDeclaration(L) || e2.isMethodSignature(L) || e2.isGetAccessorDeclaration(L) || e2.isSetAccessorDeclaration(L) || w(L) || B(L);
              }
              function le(L) {
                return e2.isSourceFile(L) ? L : e2.isNamedDeclaration(L) ? L.name : B(L) ? L.parent.name : e2.Debug.checkDefined(L.modifiers && e2.find(L.modifiers, N));
              }
              function N(L) {
                return L.kind === 88;
              }
              function p(L, P) {
                var k = le(P);
                return k && L.getSymbolAtLocation(k);
              }
              function m2(L, P) {
                if (e2.isSourceFile(P))
                  return { text: P.fileName, pos: 0, end: 0 };
                if ((e2.isFunctionDeclaration(P) || e2.isClassDeclaration(P)) && !e2.isNamedDeclaration(P)) {
                  var k = P.modifiers && e2.find(P.modifiers, N);
                  if (k)
                    return { text: "default", pos: k.getStart(), end: k.getEnd() };
                }
                if (e2.isClassStaticBlockDeclaration(P)) {
                  var Y = P.getSourceFile(), U = e2.skipTrivia(Y.text, e2.moveRangePastModifiers(P).pos), j = U + 6, H = L.getTypeChecker(), I = H.getSymbolAtLocation(P.parent), l = I ? "".concat(H.symbolToString(I, P.parent), " ") : "";
                  return { text: "".concat(l, "static {}"), pos: U, end: j };
                }
                var d = B(P) ? P.parent.name : e2.Debug.checkDefined(e2.getNameOfDeclaration(P), "Expected call hierarchy item to have a name"), D = e2.isIdentifier(d) ? e2.idText(d) : e2.isStringOrNumericLiteralLike(d) ? d.text : e2.isComputedPropertyName(d) && e2.isStringOrNumericLiteralLike(d.expression) ? d.expression.text : void 0;
                if (D === void 0) {
                  var H = L.getTypeChecker(), I = H.getSymbolAtLocation(d);
                  I && (D = H.symbolToString(I, P));
                }
                if (D === void 0) {
                  var fe = e2.createPrinter({ removeComments: true, omitTrailingSemicolon: true });
                  D = e2.usingSingleLineStringWriter(function(g) {
                    return fe.writeNode(4, P, P.getSourceFile(), g);
                  });
                }
                return { text: D, pos: d.getStart(), end: d.getEnd() };
              }
              function G(L) {
                var P, k;
                if (B(L))
                  return e2.isModuleBlock(L.parent.parent.parent.parent) && e2.isIdentifier(L.parent.parent.parent.parent.parent.name) ? L.parent.parent.parent.parent.parent.name.getText() : void 0;
                switch (L.kind) {
                  case 172:
                  case 173:
                  case 169:
                    return L.parent.kind === 205 ? (P = e2.getAssignedName(L.parent)) === null || P === void 0 ? void 0 : P.getText() : (k = e2.getNameOfDeclaration(L.parent)) === null || k === void 0 ? void 0 : k.getText();
                  case 256:
                  case 257:
                  case 261:
                    if (e2.isModuleBlock(L.parent) && e2.isIdentifier(L.parent.parent.name))
                      return L.parent.parent.name.getText();
                }
              }
              function oe(L, P) {
                if (P.body)
                  return P;
                if (e2.isConstructorDeclaration(P))
                  return e2.getFirstConstructorWithBody(P.parent);
                if (e2.isFunctionDeclaration(P) || e2.isMethodDeclaration(P)) {
                  var k = p(L, P);
                  return k && k.valueDeclaration && e2.isFunctionLikeDeclaration(k.valueDeclaration) && k.valueDeclaration.body ? k.valueDeclaration : void 0;
                }
                return P;
              }
              function f4(L, P) {
                var k = p(L, P), Y;
                if (k && k.declarations) {
                  var U = e2.indicesOf(k.declarations), j = e2.map(k.declarations, function(fe) {
                    return { file: fe.getSourceFile().fileName, pos: fe.pos };
                  });
                  U.sort(function(fe, g) {
                    return e2.compareStringsCaseSensitive(j[fe].file, j[g].file) || j[fe].pos - j[g].pos;
                  });
                  for (var H = e2.map(U, function(fe) {
                    return k.declarations[fe];
                  }), I = void 0, l = 0, d = H; l < d.length; l++) {
                    var D = d[l];
                    Q(D) && ((!I || I.parent !== D.parent || I.end !== D.pos) && (Y = e2.append(Y, D)), I = D);
                  }
                }
                return Y;
              }
              function T(L, P) {
                var k, Y, U;
                return e2.isClassStaticBlockDeclaration(P) ? P : e2.isFunctionLikeDeclaration(P) ? (Y = (k = oe(L, P)) !== null && k !== void 0 ? k : f4(L, P)) !== null && Y !== void 0 ? Y : P : (U = f4(L, P)) !== null && U !== void 0 ? U : P;
              }
              function K(L, P) {
                for (var k = L.getTypeChecker(), Y = false; ; ) {
                  if (Q(P))
                    return T(k, P);
                  if (E(P)) {
                    var U = e2.findAncestor(P, Q);
                    return U && T(k, U);
                  }
                  if (e2.isDeclarationName(P)) {
                    if (Q(P.parent))
                      return T(k, P.parent);
                    if (E(P.parent)) {
                      var U = e2.findAncestor(P.parent, Q);
                      return U && T(k, U);
                    }
                    return e2.isVariableDeclaration(P.parent) && P.parent.initializer && B(P.parent.initializer) ? P.parent.initializer : void 0;
                  }
                  if (e2.isConstructorDeclaration(P))
                    return Q(P.parent) ? P.parent : void 0;
                  if (P.kind === 124 && e2.isClassStaticBlockDeclaration(P.parent)) {
                    P = P.parent;
                    continue;
                  }
                  if (e2.isVariableDeclaration(P) && P.initializer && B(P.initializer))
                    return P.initializer;
                  if (!Y) {
                    var j = k.getSymbolAtLocation(P);
                    if (j && (j.flags & 2097152 && (j = k.getAliasedSymbol(j)), j.valueDeclaration)) {
                      Y = true, P = j.valueDeclaration;
                      continue;
                    }
                  }
                  return;
                }
              }
              C.resolveCallHierarchyDeclaration = K;
              function b(L, P) {
                var k = P.getSourceFile(), Y = m2(L, P), U = G(P), j = e2.getNodeKind(P), H = e2.getNodeModifiers(P), I = e2.createTextSpanFromBounds(e2.skipTrivia(k.text, P.getFullStart(), false, true), P.getEnd()), l = e2.createTextSpanFromBounds(Y.pos, Y.end);
                return { file: k.fileName, kind: j, kindModifiers: H, name: Y.text, containerName: U, span: I, selectionSpan: l };
              }
              C.createCallHierarchyItem = b;
              function se(L) {
                return L !== void 0;
              }
              function J(L) {
                if (L.kind === 1) {
                  var P = L.node;
                  if (e2.isCallOrNewExpressionTarget(P, true, true) || e2.isTaggedTemplateTag(P, true, true) || e2.isDecoratorTarget(P, true, true) || e2.isJsxOpeningLikeElementTagName(P, true, true) || e2.isRightSideOfPropertyAccess(P) || e2.isArgumentExpressionOfElementAccess(P)) {
                    var k = P.getSourceFile(), Y = e2.findAncestor(P, Q) || k;
                    return { declaration: Y, range: e2.createTextRangeFromNode(P, k) };
                  }
                }
              }
              function ie(L) {
                return e2.getNodeId(L.declaration);
              }
              function R(L, P) {
                return { from: L, fromSpans: P };
              }
              function q(L, P) {
                return R(b(L, P[0].declaration), e2.map(P, function(k) {
                  return e2.createTextSpanFromRange(k.range);
                }));
              }
              function O(L, P, k) {
                if (e2.isSourceFile(P) || e2.isModuleDeclaration(P) || e2.isClassStaticBlockDeclaration(P))
                  return [];
                var Y = le(P), U = e2.filter(e2.FindAllReferences.findReferenceOrRenameEntries(L, k, L.getSourceFiles(), Y, 0, { use: 1 }, J), se);
                return U ? e2.group(U, ie, function(j) {
                  return q(L, j);
                }) : [];
              }
              C.getIncomingCalls = O;
              function ve(L, P) {
                function k(U) {
                  var j = e2.isTaggedTemplateExpression(U) ? U.tag : e2.isJsxOpeningLikeElement(U) ? U.tagName : e2.isAccessExpression(U) || e2.isClassStaticBlockDeclaration(U) ? U : U.expression, H = K(L, j);
                  if (H) {
                    var I = e2.createTextRangeFromNode(j, U.getSourceFile());
                    if (e2.isArray(H))
                      for (var l = 0, d = H; l < d.length; l++) {
                        var D = d[l];
                        P.push({ declaration: D, range: I });
                      }
                    else
                      P.push({ declaration: H, range: I });
                  }
                }
                function Y(U) {
                  if (!!U && !(U.flags & 16777216)) {
                    if (Q(U)) {
                      if (e2.isClassLike(U))
                        for (var j = 0, H = U.members; j < H.length; j++) {
                          var I = H[j];
                          I.name && e2.isComputedPropertyName(I.name) && Y(I.name.expression);
                        }
                      return;
                    }
                    switch (U.kind) {
                      case 79:
                      case 265:
                      case 266:
                      case 272:
                      case 258:
                      case 259:
                        return;
                      case 170:
                        k(U);
                        return;
                      case 211:
                      case 229:
                        Y(U.expression);
                        return;
                      case 254:
                      case 164:
                        Y(U.name), Y(U.initializer);
                        return;
                      case 208:
                        k(U), Y(U.expression), e2.forEach(U.arguments, Y);
                        return;
                      case 209:
                        k(U), Y(U.expression), e2.forEach(U.arguments, Y);
                        return;
                      case 210:
                        k(U), Y(U.tag), Y(U.template);
                        return;
                      case 280:
                      case 279:
                        k(U), Y(U.tagName), Y(U.attributes);
                        return;
                      case 165:
                        k(U), Y(U.expression);
                        return;
                      case 206:
                      case 207:
                        k(U), e2.forEachChild(U, Y);
                        break;
                    }
                    e2.isPartOfTypeNode(U) || e2.forEachChild(U, Y);
                  }
                }
                return Y;
              }
              function ee(L, P) {
                e2.forEach(L.statements, P);
              }
              function he(L, P) {
                !e2.hasSyntacticModifier(L, 2) && L.body && e2.isModuleBlock(L.body) && e2.forEach(L.body.statements, P);
              }
              function F2(L, P, k) {
                var Y = oe(L, P);
                Y && (e2.forEach(Y.parameters, k), k(Y.body));
              }
              function x2(L, P) {
                P(L.body);
              }
              function X(L, P) {
                e2.forEach(L.decorators, P);
                var k = e2.getClassExtendsHeritageElement(L);
                k && P(k.expression);
                for (var Y = 0, U = L.members; Y < U.length; Y++) {
                  var j = U[Y];
                  e2.forEach(j.decorators, P), e2.isPropertyDeclaration(j) ? P(j.initializer) : e2.isConstructorDeclaration(j) && j.body ? (e2.forEach(j.parameters, P), P(j.body)) : e2.isClassStaticBlockDeclaration(j) && P(j);
                }
              }
              function $(L, P) {
                var k = [], Y = ve(L, k);
                switch (P.kind) {
                  case 305:
                    ee(P, Y);
                    break;
                  case 261:
                    he(P, Y);
                    break;
                  case 256:
                  case 213:
                  case 214:
                  case 169:
                  case 172:
                  case 173:
                    F2(L.getTypeChecker(), P, Y);
                    break;
                  case 257:
                  case 226:
                    X(P, Y);
                    break;
                  case 170:
                    x2(P, Y);
                    break;
                  default:
                    e2.Debug.assertNever(P);
                }
                return k;
              }
              function A2(L, P) {
                return { to: L, fromSpans: P };
              }
              function y(L, P) {
                return A2(b(L, P[0].declaration), e2.map(P, function(k) {
                  return e2.createTextSpanFromRange(k.range);
                }));
              }
              function V(L, P) {
                return P.flags & 16777216 || e2.isMethodSignature(P) ? [] : e2.group($(L, P), ie, function(k) {
                  return y(L, k);
                });
              }
              C.getOutgoingCalls = V;
            })(a = e2.CallHierarchy || (e2.CallHierarchy = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(f4, T, K, b, se, J, ie) {
              var R = e2.hostUsesCaseSensitiveFileNames(b), q = e2.createGetCanonicalFileName(R), O = C(T, K, q, ie), ve = C(K, T, q, ie);
              return e2.textChanges.ChangeTracker.with({ host: b, formatContext: se, preferences: J }, function(ee) {
                B(f4, ee, O, T, K, b.getCurrentDirectory(), R), E(f4, ee, O, ve, b, q);
              });
            }
            e2.getEditsForFileRename = a;
            function C(f4, T, K, b) {
              var se = K(f4);
              return function(ie) {
                var R = b && b.tryGetSourcePosition({ fileName: ie, pos: 0 }), q = J(R ? R.fileName : ie);
                return R ? q === void 0 ? void 0 : w(R.fileName, q, ie, K) : q;
              };
              function J(ie) {
                if (K(ie) === se)
                  return T;
                var R = e2.tryRemoveDirectoryPrefix(ie, se, K);
                return R === void 0 ? void 0 : T + "/" + R;
              }
            }
            e2.getPathUpdater = C;
            function w(f4, T, K, b) {
              var se = e2.getRelativePathFromFile(f4, T, b);
              return le(e2.getDirectoryPath(K), se);
            }
            function B(f4, T, K, b, se, J, ie) {
              var R = f4.getCompilerOptions().configFile;
              if (!R)
                return;
              var q = e2.getDirectoryPath(R.fileName), O = e2.getTsConfigObjectLiteralExpression(R);
              if (!O)
                return;
              oe(O, function(F2, x2) {
                switch (x2) {
                  case "files":
                  case "include":
                  case "exclude": {
                    var X = ve(F2);
                    if (X || x2 !== "include" || !e2.isArrayLiteralExpression(F2.initializer))
                      return;
                    var $ = e2.mapDefined(F2.initializer.elements, function(y) {
                      return e2.isStringLiteral(y) ? y.text : void 0;
                    });
                    if ($.length === 0)
                      return;
                    var A2 = e2.getFileMatcherPatterns(q, [], $, ie, J);
                    e2.getRegexFromPattern(e2.Debug.checkDefined(A2.includeFilePattern), ie).test(b) && !e2.getRegexFromPattern(e2.Debug.checkDefined(A2.includeFilePattern), ie).test(se) && T.insertNodeAfter(R, e2.last(F2.initializer.elements), e2.factory.createStringLiteral(he(se)));
                    return;
                  }
                  case "compilerOptions":
                    oe(F2.initializer, function(y, V) {
                      var L = e2.getOptionFromName(V);
                      L && (L.isFilePath || L.type === "list" && L.element.isFilePath) ? ve(y) : V === "paths" && oe(y.initializer, function(P) {
                        if (!!e2.isArrayLiteralExpression(P.initializer))
                          for (var k = 0, Y = P.initializer.elements; k < Y.length; k++) {
                            var U = Y[k];
                            ee(U);
                          }
                      });
                    });
                    return;
                }
              });
              function ve(F2) {
                for (var x2 = e2.isArrayLiteralExpression(F2.initializer) ? F2.initializer.elements : [F2.initializer], X = false, $ = 0, A2 = x2; $ < A2.length; $++) {
                  var y = A2[$];
                  X = ee(y) || X;
                }
                return X;
              }
              function ee(F2) {
                if (!e2.isStringLiteral(F2))
                  return false;
                var x2 = le(q, F2.text), X = K(x2);
                return X !== void 0 ? (T.replaceRangeWithText(R, G(F2, R), he(X)), true) : false;
              }
              function he(F2) {
                return e2.getRelativePathFromDirectory(q, F2, !ie);
              }
            }
            function E(f4, T, K, b, se, J) {
              for (var ie = f4.getSourceFiles(), R = function(ee) {
                var he = K(ee.fileName), F2 = he != null ? he : ee.fileName, x2 = e2.getDirectoryPath(F2), X = b(ee.fileName), $ = X || ee.fileName, A2 = e2.getDirectoryPath($), y = he !== void 0 || X !== void 0;
                m2(ee, T, function(V) {
                  if (!!e2.pathIsRelative(V)) {
                    var L = le(A2, V), P = K(L);
                    return P === void 0 ? void 0 : e2.ensurePathIsNonModuleName(e2.getRelativePathFromDirectory(x2, P, J));
                  }
                }, function(V) {
                  var L = f4.getTypeChecker().getSymbolAtLocation(V);
                  if (!((L == null ? void 0 : L.declarations) && L.declarations.some(function(k) {
                    return e2.isAmbientModule(k);
                  }))) {
                    var P = X !== void 0 ? p(V, e2.resolveModuleName(V.text, $, f4.getCompilerOptions(), se), K, ie) : N(L, V, ee, f4, se, K);
                    return P !== void 0 && (P.updated || y && e2.pathIsRelative(V.text)) ? e2.moduleSpecifiers.updateModuleSpecifier(f4.getCompilerOptions(), ee, J(F2), P.newFileName, e2.createModuleSpecifierResolutionHost(f4, se), V.text) : void 0;
                  }
                });
              }, q = 0, O = ie; q < O.length; q++) {
                var ve = O[q];
                R(ve);
              }
            }
            function Q(f4, T) {
              return e2.normalizePath(e2.combinePaths(f4, T));
            }
            function le(f4, T) {
              return e2.ensurePathIsNonModuleName(Q(f4, T));
            }
            function N(f4, T, K, b, se, J) {
              if (f4) {
                var ie = e2.find(f4.declarations, e2.isSourceFile).fileName, R = J(ie);
                return R === void 0 ? { newFileName: ie, updated: false } : { newFileName: R, updated: true };
              } else {
                var q = e2.getModeForUsageLocation(K, T), O = se.resolveModuleNames ? se.getResolvedModuleWithFailedLookupLocationsFromCache && se.getResolvedModuleWithFailedLookupLocationsFromCache(T.text, K.fileName, q) : b.getResolvedModuleWithFailedLookupLocationsFromCache(T.text, K.fileName, q);
                return p(T, O, J, b.getSourceFiles());
              }
            }
            function p(f4, T, K, b) {
              if (!T)
                return;
              if (T.resolvedModule) {
                var se = q(T.resolvedModule.resolvedFileName);
                if (se)
                  return se;
              }
              var J = e2.forEach(T.failedLookupLocations, ie) || e2.pathIsRelative(f4.text) && e2.forEach(T.failedLookupLocations, R);
              if (J)
                return J;
              return T.resolvedModule && { newFileName: T.resolvedModule.resolvedFileName, updated: false };
              function ie(O) {
                var ve = K(O);
                return ve && e2.find(b, function(ee) {
                  return ee.fileName === ve;
                }) ? R(O) : void 0;
              }
              function R(O) {
                return e2.endsWith(O, "/package.json") ? void 0 : q(O);
              }
              function q(O) {
                var ve = K(O);
                return ve && { newFileName: ve, updated: true };
              }
            }
            function m2(f4, T, K, b) {
              for (var se = 0, J = f4.referencedFiles || e2.emptyArray; se < J.length; se++) {
                var ie = J[se], R = K(ie.fileName);
                R !== void 0 && R !== f4.text.slice(ie.pos, ie.end) && T.replaceRangeWithText(f4, ie, R);
              }
              for (var q = 0, O = f4.imports; q < O.length; q++) {
                var ve = O[q], R = b(ve);
                R !== void 0 && R !== ve.text && T.replaceRangeWithText(f4, G(ve, f4), R);
              }
            }
            function G(f4, T) {
              return e2.createRange(f4.getStart(T) + 1, f4.end - 1);
            }
            function oe(f4, T) {
              if (!!e2.isObjectLiteralExpression(f4))
                for (var K = 0, b = f4.properties; K < b.length; K++) {
                  var se = b[K];
                  e2.isPropertyAssignment(se) && e2.isStringLiteral(se.name) && T(se, se.name.text);
                }
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(F2, x2, X, $, A2) {
                var y, V, L = le(x2, X, F2), P = L && [O(L.reference.fileName, L.fileName, L.unverified)] || e2.emptyArray;
                if (L != null && L.file)
                  return P;
                var k = e2.getTouchingPropertyName(x2, X);
                if (k !== x2) {
                  var Y = k.parent, U = F2.getTypeChecker();
                  if (k.kind === 159 || e2.isJSDocOverrideTag(k) && e2.rangeContainsPosition(k.tagName, X))
                    return Q(U, k) || e2.emptyArray;
                  if (e2.isJumpStatementTarget(k)) {
                    var j = e2.getTargetLabel(k.parent, k.text);
                    return j ? [J(U, j, "label", k.text, void 0)] : void 0;
                  }
                  if (e2.isStaticModifier(k) && e2.isClassStaticBlockDeclaration(k.parent)) {
                    var H = k.parent.parent, I = f4(H, U, A2), l = I.symbol, d = I.failedAliasResolution, D = e2.filter(H.members, e2.isClassStaticBlockDeclaration), fe = l ? U.symbolToString(l, H) : "", g = k.getSourceFile();
                    return e2.map(D, function(we) {
                      var de = e2.moveRangePastModifiers(we).pos;
                      return de = e2.skipTrivia(g.text, de), J(U, we, "constructor", "static {}", fe, false, d, { start: de, length: 6 });
                    });
                  }
                  var ne = f4(k, U, A2), ue = ne.symbol, We = ne.failedAliasResolution, Fe = k;
                  if ($ && We) {
                    var Z2 = e2.forEach(Ve([k], (ue == null ? void 0 : ue.declarations) || e2.emptyArray, true), function(we) {
                      return e2.findAncestor(we, e2.isAnyImportOrBareOrAccessedRequire);
                    }), Be = Z2 && e2.tryGetModuleSpecifierFromDeclaration(Z2);
                    Be && (y = f4(Be, U, A2), ue = y.symbol, We = y.failedAliasResolution, Fe = Be);
                  }
                  if (!ue && e2.isModuleSpecifierLike(Fe)) {
                    var ge = (V = x2.resolvedModules) === null || V === void 0 ? void 0 : V.get(Fe.text, e2.getModeForUsageLocation(x2, Fe));
                    if (ge)
                      return [{ name: Fe.text, fileName: ge.resolvedFileName, containerName: void 0, containerKind: void 0, kind: "script", textSpan: e2.createTextSpan(0, 0), failedAliasResolution: We, isAmbient: e2.isDeclarationFileName(ge.resolvedFileName), unverified: Fe !== k }];
                  }
                  if (!ue)
                    return e2.concatenate(P, oe(k, U));
                  if (!($ && e2.every(ue.declarations, function(we) {
                    return we.getSourceFile().fileName === x2.fileName;
                  }))) {
                    var Re = ee(U, k);
                    if (Re && !(e2.isJsxOpeningLikeElement(k.parent) && he(Re))) {
                      var ze = R(U, Re, We);
                      if (U.getRootSymbols(ue).some(function(we) {
                        return B(we, Re);
                      }))
                        return [ze];
                      var Ee = b(U, ue, k, We, Re) || e2.emptyArray;
                      return k.kind === 106 ? Ve([ze], Ee, true) : Ve(Ve([], Ee, true), [ze], false);
                    }
                    if (k.parent.kind === 297) {
                      var He = U.getShorthandAssignmentValueSymbol(ue.valueDeclaration), rr = He != null && He.declarations ? He.declarations.map(function(we) {
                        return se(we, U, He, k, false, We);
                      }) : e2.emptyArray;
                      return e2.concatenate(rr, E(U, k) || e2.emptyArray);
                    }
                    if (e2.isPropertyName(k) && e2.isBindingElement(Y) && e2.isObjectBindingPattern(Y.parent) && k === (Y.propertyName || Y.name)) {
                      var Ie = e2.getNameFromPropertyName(k), _e = U.getTypeAtLocation(Y.parent);
                      return Ie === void 0 ? e2.emptyArray : e2.flatMap(_e.isUnion() ? _e.types : [_e], function(we) {
                        var de = we.getProperty(Ie);
                        return de && b(U, de, k);
                      });
                    }
                    return e2.concatenate(P, E(U, k) || b(U, ue, k, We));
                  }
                }
              }
              C.getDefinitionAtPosition = w;
              function B(F2, x2) {
                return F2 === x2.symbol || F2 === x2.symbol.parent || e2.isAssignmentExpression(x2.parent) || !e2.isCallLikeExpression(x2.parent) && F2 === x2.parent.symbol;
              }
              function E(F2, x2) {
                var X = e2.getContainingObjectLiteralElement(x2);
                if (X) {
                  var $ = X && F2.getContextualType(X.parent);
                  if ($)
                    return e2.flatMap(e2.getPropertySymbolsFromContextualType(X, F2, $, false), function(A2) {
                      return b(F2, A2, x2);
                    });
                }
              }
              function Q(F2, x2) {
                var X = e2.findAncestor(x2, e2.isClassElement);
                if (!!(X && X.name)) {
                  var $ = e2.findAncestor(X, e2.isClassLike);
                  if (!!$) {
                    var A2 = e2.getEffectiveBaseTypeNode($), y = A2 ? F2.getTypeAtLocation(A2) : void 0;
                    if (!!y) {
                      var V = e2.unescapeLeadingUnderscores(e2.getTextOfPropertyName(X.name)), L = e2.hasStaticModifier(X) ? F2.getPropertyOfType(F2.getTypeOfSymbolAtLocation(y.symbol, $), V) : F2.getPropertyOfType(y, V);
                      if (!!L)
                        return b(F2, L, x2);
                    }
                  }
                }
              }
              function le(F2, x2, X) {
                var $, A2, y = q(F2.referencedFiles, x2);
                if (y) {
                  var V = X.getSourceFileFromReference(F2, y);
                  return V && { reference: y, fileName: V.fileName, file: V, unverified: false };
                }
                var L = q(F2.typeReferenceDirectives, x2);
                if (L) {
                  var P = X.getResolvedTypeReferenceDirectives().get(L.fileName, L.resolutionMode || F2.impliedNodeFormat), V = P && X.getSourceFile(P.resolvedFileName);
                  return V && { reference: L, fileName: V.fileName, file: V, unverified: false };
                }
                var k = q(F2.libReferenceDirectives, x2);
                if (k) {
                  var V = X.getLibFileFromReference(k);
                  return V && { reference: k, fileName: V.fileName, file: V, unverified: false };
                }
                if (!(($ = F2.resolvedModules) === null || $ === void 0) && $.size()) {
                  var Y = e2.getTouchingToken(F2, x2);
                  if (e2.isModuleSpecifierLike(Y) && e2.isExternalModuleNameRelative(Y.text) && F2.resolvedModules.has(Y.text, e2.getModeForUsageLocation(F2, Y))) {
                    var U = (A2 = F2.resolvedModules.get(Y.text, e2.getModeForUsageLocation(F2, Y))) === null || A2 === void 0 ? void 0 : A2.resolvedFileName, j = U || e2.resolvePath(e2.getDirectoryPath(F2.fileName), Y.text);
                    return { file: X.getSourceFile(j), fileName: j, reference: { pos: Y.getStart(), end: Y.getEnd(), fileName: Y.text }, unverified: !U };
                  }
                }
              }
              C.getReferenceAtPosition = le;
              function N(F2, x2, X) {
                var $ = e2.getTouchingPropertyName(x2, X);
                if ($ !== x2) {
                  if (e2.isImportMeta($.parent) && $.parent.name === $)
                    return p(F2.getTypeAtLocation($.parent), F2, $.parent, false);
                  var A2 = f4($, F2, false), y = A2.symbol, V = A2.failedAliasResolution;
                  if (!!y) {
                    var L = F2.getTypeOfSymbolAtLocation(y, $), P = m2(y, L, F2), k = P && p(P, F2, $, V), Y = k && k.length !== 0 ? k : p(L, F2, $, V);
                    return Y.length ? Y : !(y.flags & 111551) && y.flags & 788968 ? b(F2, e2.skipAlias(y, F2), $, V) : void 0;
                  }
                }
              }
              C.getTypeDefinitionAtPosition = N;
              function p(F2, x2, X, $) {
                return e2.flatMap(F2.isUnion() && !(F2.flags & 32) ? F2.types : [F2], function(A2) {
                  return A2.symbol && b(x2, A2.symbol, X, $);
                });
              }
              function m2(F2, x2, X) {
                if (x2.symbol === F2 || F2.valueDeclaration && x2.symbol && e2.isVariableDeclaration(F2.valueDeclaration) && F2.valueDeclaration.initializer === x2.symbol.valueDeclaration) {
                  var $ = x2.getCallSignatures();
                  if ($.length === 1)
                    return X.getReturnTypeOfSignature(e2.first($));
                }
              }
              function G(F2, x2, X) {
                var $ = w(F2, x2, X);
                if (!(!$ || $.length === 0)) {
                  var A2 = q(x2.referencedFiles, X) || q(x2.typeReferenceDirectives, X) || q(x2.libReferenceDirectives, X);
                  if (A2)
                    return { definitions: $, textSpan: e2.createTextSpanFromRange(A2) };
                  var y = e2.getTouchingPropertyName(x2, X), V = e2.createTextSpan(y.getStart(), y.getWidth());
                  return { definitions: $, textSpan: V };
                }
              }
              C.getDefinitionAndBoundSpan = G;
              function oe(F2, x2) {
                return e2.mapDefined(x2.getIndexInfosAtLocation(F2), function(X) {
                  return X.declaration && R(x2, X.declaration);
                });
              }
              function f4(F2, x2, X) {
                var $ = x2.getSymbolAtLocation(F2), A2 = false;
                if (($ == null ? void 0 : $.declarations) && $.flags & 2097152 && !X && T(F2, $.declarations[0])) {
                  var y = x2.getAliasedSymbol($);
                  if (y.declarations)
                    return { symbol: y };
                  A2 = true;
                }
                return { symbol: $, failedAliasResolution: A2 };
              }
              function T(F2, x2) {
                return F2.kind !== 79 ? false : F2.parent === x2 ? true : x2.kind !== 268;
              }
              function K(F2) {
                if (!e2.isAssignmentDeclaration(F2))
                  return false;
                var x2 = e2.findAncestor(F2, function(X) {
                  return e2.isAssignmentExpression(X) ? true : e2.isAssignmentDeclaration(X) ? false : "quit";
                });
                return !!x2 && e2.getAssignmentDeclarationKind(x2) === 5;
              }
              function b(F2, x2, X, $, A2) {
                var y = e2.filter(x2.declarations, function(U) {
                  return U !== A2;
                }), V = e2.filter(y, function(U) {
                  return !K(U);
                }), L = e2.some(V) ? V : y;
                return P() || k() || e2.map(L, function(U) {
                  return se(U, F2, x2, X, false, $);
                });
                function P() {
                  if (x2.flags & 32 && !(x2.flags & 19) && (e2.isNewExpressionTarget(X) || X.kind === 134)) {
                    var U = e2.find(y, e2.isClassLike) || e2.Debug.fail("Expected declaration to have at least one class-like declaration");
                    return Y(U.members, true);
                  }
                }
                function k() {
                  return e2.isCallOrNewExpressionTarget(X) || e2.isNameOfFunctionDeclaration(X) ? Y(y, false) : void 0;
                }
                function Y(U, j) {
                  if (!!U) {
                    var H = U.filter(j ? e2.isConstructorDeclaration : e2.isFunctionLike), I = H.filter(function(l) {
                      return !!l.body;
                    });
                    return H.length ? I.length !== 0 ? I.map(function(l) {
                      return se(l, F2, x2, X);
                    }) : [se(e2.last(H), F2, x2, X, false, $)] : void 0;
                  }
                }
              }
              function se(F2, x2, X, $, A2, y) {
                var V = x2.symbolToString(X), L = e2.SymbolDisplay.getSymbolKind(x2, X, $), P = X.parent ? x2.symbolToString(X.parent, $) : "";
                return J(x2, F2, L, V, P, A2, y);
              }
              C.createDefinitionInfo = se;
              function J(F2, x2, X, $, A2, y, V, L) {
                var P = x2.getSourceFile();
                if (!L) {
                  var k = e2.getNameOfDeclaration(x2) || x2;
                  L = e2.createTextSpanFromNode(k, P);
                }
                return Ke(Ke({ fileName: P.fileName, textSpan: L, kind: X, name: $, containerKind: void 0, containerName: A2 }, e2.FindAllReferences.toContextSpan(L, P, e2.FindAllReferences.getContextNode(x2))), { isLocal: !ie(F2, x2), isAmbient: !!(x2.flags & 16777216), unverified: y, failedAliasResolution: V });
              }
              function ie(F2, x2) {
                if (F2.isDeclarationVisible(x2))
                  return true;
                if (!x2.parent)
                  return false;
                if (e2.hasInitializer(x2.parent) && x2.parent.initializer === x2)
                  return ie(F2, x2.parent);
                switch (x2.kind) {
                  case 167:
                  case 172:
                  case 173:
                  case 169:
                    if (e2.hasEffectiveModifier(x2, 8))
                      return false;
                  case 171:
                  case 296:
                  case 297:
                  case 205:
                  case 226:
                  case 214:
                  case 213:
                    return ie(F2, x2.parent);
                  default:
                    return false;
                }
              }
              function R(F2, x2, X) {
                return se(x2, F2, x2.symbol, x2, false, X);
              }
              function q(F2, x2) {
                return e2.find(F2, function(X) {
                  return e2.textRangeContainsPositionInclusive(X, x2);
                });
              }
              C.findReferenceInPosition = q;
              function O(F2, x2, X) {
                return { fileName: x2, textSpan: e2.createTextSpanFromBounds(0, 0), kind: "script", name: F2, containerName: void 0, containerKind: void 0, unverified: X };
              }
              function ve(F2) {
                var x2 = e2.findAncestor(F2, function($) {
                  return !e2.isRightSideOfPropertyAccess($);
                }), X = x2 == null ? void 0 : x2.parent;
                return X && e2.isCallLikeExpression(X) && e2.getInvokedExpression(X) === x2 ? X : void 0;
              }
              function ee(F2, x2) {
                var X = ve(x2), $ = X && F2.getResolvedSignature(X);
                return e2.tryCast($ && $.declaration, function(A2) {
                  return e2.isFunctionLike(A2) && !e2.isFunctionTypeNode(A2);
                });
              }
              function he(F2) {
                switch (F2.kind) {
                  case 171:
                  case 180:
                  case 175:
                    return true;
                  default:
                    return false;
                }
              }
            })(a = e2.GoToDefinition || (e2.GoToDefinition = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = ["abstract", "access", "alias", "argument", "async", "augments", "author", "borrows", "callback", "class", "classdesc", "constant", "constructor", "constructs", "copyright", "default", "deprecated", "description", "emits", "enum", "event", "example", "exports", "extends", "external", "field", "file", "fileoverview", "fires", "function", "generator", "global", "hideconstructor", "host", "ignore", "implements", "inheritdoc", "inner", "instance", "interface", "kind", "lends", "license", "link", "listens", "member", "memberof", "method", "mixes", "module", "name", "namespace", "override", "package", "param", "private", "property", "protected", "public", "readonly", "requires", "returns", "see", "since", "static", "summary", "template", "this", "throws", "todo", "tutorial", "type", "typedef", "var", "variation", "version", "virtual", "yields"], B, E;
              function Q(F2, x2) {
                var X = [];
                return e2.forEachUnique(F2, function($) {
                  for (var A2 = 0, y = N($); A2 < y.length; A2++) {
                    var V = y[A2];
                    if (!(V.comment === void 0 || e2.isJSDoc(V) && $.kind !== 345 && $.kind !== 338 && V.tags && V.tags.some(function(P) {
                      return P.kind === 345 || P.kind === 338;
                    }) && !V.tags.some(function(P) {
                      return P.kind === 340 || P.kind === 341;
                    }))) {
                      var L = m2(V.comment, x2);
                      e2.contains(X, L, le) || X.push(L);
                    }
                  }
                }), e2.flatten(e2.intersperse(X, [e2.lineBreakPart()]));
              }
              C.getJsDocCommentsFromDeclarations = Q;
              function le(F2, x2) {
                return e2.arraysEqual(F2, x2, function(X, $) {
                  return X.kind === $.kind && X.text === $.text;
                });
              }
              function N(F2) {
                switch (F2.kind) {
                  case 340:
                  case 347:
                    return [F2];
                  case 338:
                  case 345:
                    return [F2, F2.parent];
                  default:
                    return e2.getJSDocCommentsAndTags(F2);
                }
              }
              function p(F2, x2) {
                var X = [];
                return e2.forEachUnique(F2, function($) {
                  var A2 = e2.getJSDocTags($);
                  if (!(A2.some(function(P) {
                    return P.kind === 345 || P.kind === 338;
                  }) && !A2.some(function(P) {
                    return P.kind === 340 || P.kind === 341;
                  })))
                    for (var y = 0, V = A2; y < V.length; y++) {
                      var L = V[y];
                      X.push({ name: L.tagName.text, text: G(L, x2) });
                    }
                }), X;
              }
              C.getJsDocTagsFromDeclarations = p;
              function m2(F2, x2) {
                return typeof F2 == "string" ? [e2.textPart(F2)] : e2.flatMap(F2, function(X) {
                  return X.kind === 321 ? [e2.textPart(X.text)] : e2.buildLinkParts(X, x2);
                });
              }
              function G(F2, x2) {
                var X = F2.comment, $ = F2.kind, A2 = oe($);
                switch ($) {
                  case 329:
                    return k(F2.class);
                  case 328:
                    return k(F2.class);
                  case 344:
                    var y = F2, V = [];
                    if (y.constraint && V.push(e2.textPart(y.constraint.getText())), e2.length(y.typeParameters)) {
                      e2.length(V) && V.push(e2.spacePart());
                      var L = y.typeParameters[y.typeParameters.length - 1];
                      e2.forEach(y.typeParameters, function(U) {
                        V.push(A2(U.getText())), L !== U && V.push.apply(V, [e2.punctuationPart(27), e2.spacePart()]);
                      });
                    }
                    return X && V.push.apply(V, Ve([e2.spacePart()], m2(X, x2), true)), V;
                  case 343:
                    return k(F2.typeExpression);
                  case 345:
                  case 338:
                  case 347:
                  case 340:
                  case 346:
                    var P = F2.name;
                    return P ? k(P) : X === void 0 ? void 0 : m2(X, x2);
                  default:
                    return X === void 0 ? void 0 : m2(X, x2);
                }
                function k(U) {
                  return Y(U.getText());
                }
                function Y(U) {
                  return X ? U.match(/^https?$/) ? Ve([e2.textPart(U)], m2(X, x2), true) : Ve([A2(U), e2.spacePart()], m2(X, x2), true) : [e2.textPart(U)];
                }
              }
              function oe(F2) {
                switch (F2) {
                  case 340:
                    return e2.parameterNamePart;
                  case 347:
                    return e2.propertyNamePart;
                  case 344:
                    return e2.typeParameterNamePart;
                  case 345:
                  case 338:
                    return e2.typeAliasNamePart;
                  default:
                    return e2.textPart;
                }
              }
              function f4() {
                return B || (B = e2.map(w, function(F2) {
                  return { name: F2, kind: "keyword", kindModifiers: "", sortText: e2.Completions.SortText.LocationPriority };
                }));
              }
              C.getJSDocTagNameCompletions = f4, C.getJSDocTagNameCompletionDetails = K;
              function T() {
                return E || (E = e2.map(w, function(F2) {
                  return { name: "@".concat(F2), kind: "keyword", kindModifiers: "", sortText: e2.Completions.SortText.LocationPriority };
                }));
              }
              C.getJSDocTagCompletions = T;
              function K(F2) {
                return { name: F2, kind: "", kindModifiers: "", displayParts: [e2.textPart(F2)], documentation: e2.emptyArray, tags: void 0, codeActions: void 0 };
              }
              C.getJSDocTagCompletionDetails = K;
              function b(F2) {
                if (!e2.isIdentifier(F2.name))
                  return e2.emptyArray;
                var x2 = F2.name.text, X = F2.parent, $ = X.parent;
                return e2.isFunctionLike($) ? e2.mapDefined($.parameters, function(A2) {
                  if (!!e2.isIdentifier(A2.name)) {
                    var y = A2.name.text;
                    if (!(X.tags.some(function(V) {
                      return V !== F2 && e2.isJSDocParameterTag(V) && e2.isIdentifier(V.name) && V.name.escapedText === y;
                    }) || x2 !== void 0 && !e2.startsWith(y, x2)))
                      return { name: y, kind: "parameter", kindModifiers: "", sortText: e2.Completions.SortText.LocationPriority };
                  }
                }) : [];
              }
              C.getJSDocParameterNameCompletions = b;
              function se(F2) {
                return { name: F2, kind: "parameter", kindModifiers: "", displayParts: [e2.textPart(F2)], documentation: e2.emptyArray, tags: void 0, codeActions: void 0 };
              }
              C.getJSDocParameterNameCompletionDetails = se;
              function J(F2, x2, X, $) {
                var A2 = e2.getTokenAtPosition(x2, X), y = e2.findAncestor(A2, e2.isJSDoc);
                if (!(y && (y.comment !== void 0 || e2.length(y.tags)))) {
                  var V = A2.getStart(x2);
                  if (!(!y && V < X)) {
                    var L = O(A2, $);
                    if (!!L) {
                      var P = L.commentOwner, k = L.parameters, Y = L.hasReturn, U = e2.hasJSDocNodes(P) && P.jsDoc ? e2.lastOrUndefined(P.jsDoc) : void 0;
                      if (!(P.getStart(x2) < X || U && U !== y)) {
                        var j = ie(x2, X), H = e2.hasJSFileExtension(x2.fileName), I = (k ? R(k || [], H, j, F2) : "") + (Y ? q(j, F2) : ""), l = "/**", d = " */";
                        if (I) {
                          var D = l + F2 + j + " * ", fe = V === X ? F2 + j : "", g = D + F2 + I + j + d + fe;
                          return { newText: g, caretOffset: D.length };
                        }
                        return { newText: l + d, caretOffset: 3 };
                      }
                    }
                  }
                }
              }
              C.getDocCommentTemplateAtPosition = J;
              function ie(F2, x2) {
                for (var X = F2.text, $ = e2.getLineStartPositionForPosition(x2, F2), A2 = $; A2 <= x2 && e2.isWhiteSpaceSingleLine(X.charCodeAt(A2)); A2++)
                  ;
                return X.slice($, A2);
              }
              function R(F2, x2, X, $) {
                return F2.map(function(A2, y) {
                  var V = A2.name, L = A2.dotDotDotToken, P = V.kind === 79 ? V.text : "param" + y, k = x2 ? L ? "{...any} " : "{any} " : "";
                  return "".concat(X, " * @param ").concat(k).concat(P).concat($);
                }).join("");
              }
              function q(F2, x2) {
                return "".concat(F2, " * @returns").concat(x2);
              }
              function O(F2, x2) {
                return e2.forEachAncestor(F2, function(X) {
                  return ve(X, x2);
                });
              }
              function ve(F2, x2) {
                switch (F2.kind) {
                  case 256:
                  case 213:
                  case 169:
                  case 171:
                  case 168:
                  case 214:
                    var X = F2;
                    return { commentOwner: F2, parameters: X.parameters, hasReturn: ee(X, x2) };
                  case 296:
                    return ve(F2.initializer, x2);
                  case 257:
                  case 258:
                  case 166:
                  case 260:
                  case 299:
                  case 259:
                    return { commentOwner: F2 };
                  case 237: {
                    var $ = F2, A2 = $.declarationList.declarations, y = A2.length === 1 && A2[0].initializer ? he(A2[0].initializer) : void 0;
                    return y ? { commentOwner: F2, parameters: y.parameters, hasReturn: ee(y, x2) } : { commentOwner: F2 };
                  }
                  case 305:
                    return "quit";
                  case 261:
                    return F2.parent.kind === 261 ? void 0 : { commentOwner: F2 };
                  case 238:
                    return ve(F2.expression, x2);
                  case 221: {
                    var V = F2;
                    return e2.getAssignmentDeclarationKind(V) === 0 ? "quit" : e2.isFunctionLike(V.right) ? { commentOwner: F2, parameters: V.right.parameters, hasReturn: ee(V.right, x2) } : { commentOwner: F2 };
                  }
                  case 167:
                    var L = F2.initializer;
                    if (L && (e2.isFunctionExpression(L) || e2.isArrowFunction(L)))
                      return { commentOwner: F2, parameters: L.parameters, hasReturn: ee(L, x2) };
                }
              }
              function ee(F2, x2) {
                return !!(x2 != null && x2.generateReturnInDocTemplate) && (e2.isArrowFunction(F2) && e2.isExpression(F2.body) || e2.isFunctionLikeDeclaration(F2) && F2.body && e2.isBlock(F2.body) && !!e2.forEachReturnStatement(F2.body, function(X) {
                  return X;
                }));
              }
              function he(F2) {
                for (; F2.kind === 212; )
                  F2 = F2.expression;
                switch (F2.kind) {
                  case 213:
                  case 214:
                    return F2;
                  case 226:
                    return e2.find(F2.members, e2.isConstructorDeclaration);
                }
              }
            })(a = e2.JsDoc || (e2.JsDoc = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(oe, f4, T, K, b, se) {
                var J = e2.createPatternMatcher(K);
                if (!J)
                  return e2.emptyArray;
                for (var ie = [], R = function(ee) {
                  if (T.throwIfCancellationRequested(), se && ee.isDeclarationFile)
                    return "continue";
                  ee.getNamedDeclarations().forEach(function(he, F2) {
                    B(J, F2, he, f4, ee.fileName, ie);
                  });
                }, q = 0, O = oe; q < O.length; q++) {
                  var ve = O[q];
                  R(ve);
                }
                return ie.sort(m2), (b === void 0 ? ie : ie.slice(0, b)).map(G);
              }
              C.getNavigateToItems = w;
              function B(oe, f4, T, K, b, se) {
                var J = oe.getMatchForLastSegmentOfPattern(f4);
                if (!!J)
                  for (var ie = 0, R = T; ie < R.length; ie++) {
                    var q = R[ie];
                    if (!!E(q, K))
                      if (oe.patternContainsDots) {
                        var O = oe.getFullMatch(p(q), f4);
                        O && se.push({ name: f4, fileName: b, matchKind: O.kind, isCaseSensitive: O.isCaseSensitive, declaration: q });
                      } else
                        se.push({ name: f4, fileName: b, matchKind: J.kind, isCaseSensitive: J.isCaseSensitive, declaration: q });
                  }
              }
              function E(oe, f4) {
                switch (oe.kind) {
                  case 267:
                  case 270:
                  case 265:
                    var T = f4.getSymbolAtLocation(oe.name), K = f4.getAliasedSymbol(T);
                    return T.escapedName !== K.escapedName;
                  default:
                    return true;
                }
              }
              function Q(oe, f4) {
                var T = e2.getNameOfDeclaration(oe);
                return !!T && (N(T, f4) || T.kind === 162 && le(T.expression, f4));
              }
              function le(oe, f4) {
                return N(oe, f4) || e2.isPropertyAccessExpression(oe) && (f4.push(oe.name.text), true) && le(oe.expression, f4);
              }
              function N(oe, f4) {
                return e2.isPropertyNameLiteral(oe) && (f4.push(e2.getTextOfIdentifierOrLiteral(oe)), true);
              }
              function p(oe) {
                var f4 = [], T = e2.getNameOfDeclaration(oe);
                if (T && T.kind === 162 && !le(T.expression, f4))
                  return e2.emptyArray;
                f4.shift();
                for (var K = e2.getContainerNode(oe); K; ) {
                  if (!Q(K, f4))
                    return e2.emptyArray;
                  K = e2.getContainerNode(K);
                }
                return f4.reverse();
              }
              function m2(oe, f4) {
                return e2.compareValues(oe.matchKind, f4.matchKind) || e2.compareStringsCaseSensitiveUI(oe.name, f4.name);
              }
              function G(oe) {
                var f4 = oe.declaration, T = e2.getContainerNode(f4), K = T && e2.getNameOfDeclaration(T);
                return { name: oe.name, kind: e2.getNodeKind(f4), kindModifiers: e2.getNodeModifiers(f4), matchKind: e2.PatternMatchKind[oe.matchKind], isCaseSensitive: oe.isCaseSensitive, fileName: oe.fileName, textSpan: e2.createTextSpanFromNode(f4), containerName: K ? K.text : "", containerKind: K ? e2.getNodeKind(T) : "" };
              }
            })(a = e2.NavigateTo || (e2.NavigateTo = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w, B = /\s+/g, E = 150, Q, le, N = [], p, m2 = [], G, oe = [];
              function f4(Ie, _e) {
                Q = _e, le = Ie;
                try {
                  return e2.map(fe(ie(Ie)), ne);
                } finally {
                  K();
                }
              }
              C.getNavigationBarItems = f4;
              function T(Ie, _e) {
                Q = _e, le = Ie;
                try {
                  return g(ie(Ie));
                } finally {
                  K();
                }
              }
              C.getNavigationTree = T;
              function K() {
                le = void 0, Q = void 0, N = [], p = void 0, oe = [];
              }
              function b(Ie) {
                return rr(Ie.getText(le));
              }
              function se(Ie) {
                return Ie.node.kind;
              }
              function J(Ie, _e) {
                Ie.children ? Ie.children.push(_e) : Ie.children = [_e];
              }
              function ie(Ie) {
                e2.Debug.assert(!N.length);
                var _e = { node: Ie, name: void 0, additionalNodes: void 0, parent: void 0, children: void 0, indent: 0 };
                p = _e;
                for (var we = 0, de = Ie.statements; we < de.length; we++) {
                  var ye = de[we];
                  A2(ye);
                }
                return F2(), e2.Debug.assert(!p && !N.length), _e;
              }
              function R(Ie, _e) {
                J(p, q(Ie, _e));
              }
              function q(Ie, _e) {
                return { node: Ie, name: _e || (e2.isDeclaration(Ie) || e2.isExpression(Ie) ? e2.getNameOfDeclaration(Ie) : void 0), additionalNodes: void 0, parent: p, children: void 0, indent: p.indent + 1 };
              }
              function O(Ie) {
                G || (G = new e2.Map()), G.set(Ie, true);
              }
              function ve(Ie) {
                for (var _e = 0; _e < Ie; _e++)
                  F2();
              }
              function ee(Ie, _e) {
                for (var we = []; !e2.isPropertyNameLiteral(_e); ) {
                  var de = e2.getNameOrArgument(_e), ye = e2.getElementOrPropertyAccessName(_e);
                  _e = _e.expression, !(ye === "prototype" || e2.isPrivateIdentifier(de)) && we.push(de);
                }
                we.push(_e);
                for (var Ae = we.length - 1; Ae > 0; Ae--) {
                  var de = we[Ae];
                  he(Ie, de);
                }
                return [we.length - 1, we[0]];
              }
              function he(Ie, _e) {
                var we = q(Ie, _e);
                J(p, we), N.push(p), m2.push(G), G = void 0, p = we;
              }
              function F2() {
                p.children && (y(p.children, p), I(p.children)), p = N.pop(), G = m2.pop();
              }
              function x2(Ie, _e, we) {
                he(Ie, we), A2(_e), F2();
              }
              function X(Ie) {
                Ie.initializer && He(Ie.initializer) ? (he(Ie), e2.forEachChild(Ie.initializer, A2), F2()) : x2(Ie, Ie.initializer);
              }
              function $(Ie) {
                return !e2.hasDynamicName(Ie) || Ie.kind !== 221 && e2.isPropertyAccessExpression(Ie.name.expression) && e2.isIdentifier(Ie.name.expression.expression) && e2.idText(Ie.name.expression.expression) === "Symbol";
              }
              function A2(Ie) {
                var _e;
                if (Q.throwIfCancellationRequested(), !(!Ie || e2.isToken(Ie)))
                  switch (Ie.kind) {
                    case 171:
                      var we = Ie;
                      x2(we, we.body);
                      for (var de = 0, ye = we.parameters; de < ye.length; de++) {
                        var Ae = ye[de];
                        e2.isParameterPropertyDeclaration(Ae, we) && R(Ae);
                      }
                      break;
                    case 169:
                    case 172:
                    case 173:
                    case 168:
                      $(Ie) && x2(Ie, Ie.body);
                      break;
                    case 167:
                      $(Ie) && X(Ie);
                      break;
                    case 166:
                      $(Ie) && R(Ie);
                      break;
                    case 267:
                      var er = Ie;
                      er.name && R(er.name);
                      var ir = er.namedBindings;
                      if (ir)
                        if (ir.kind === 268)
                          R(ir);
                        else
                          for (var Cr = 0, Ye = ir.elements; Cr < Ye.length; Cr++) {
                            var Br = Ye[Cr];
                            R(Br);
                          }
                      break;
                    case 297:
                      x2(Ie, Ie.name);
                      break;
                    case 298:
                      var Er = Ie.expression;
                      e2.isIdentifier(Er) ? R(Ie, Er) : R(Ie);
                      break;
                    case 203:
                    case 296:
                    case 254: {
                      var Ne = Ie;
                      e2.isBindingPattern(Ne.name) ? A2(Ne.name) : X(Ne);
                      break;
                    }
                    case 256:
                      var n = Ie.name;
                      n && e2.isIdentifier(n) && O(n.text), x2(Ie, Ie.body);
                      break;
                    case 214:
                    case 213:
                      x2(Ie, Ie.body);
                      break;
                    case 260:
                      he(Ie);
                      for (var lr = 0, be = Ie.members; lr < be.length; lr++) {
                        var Ge = be[lr];
                        Be(Ge) || R(Ge);
                      }
                      F2();
                      break;
                    case 257:
                    case 226:
                    case 258:
                      he(Ie);
                      for (var ur = 0, yr = Ie.members; ur < yr.length; ur++) {
                        var Ge = yr[ur];
                        A2(Ge);
                      }
                      F2();
                      break;
                    case 261:
                      x2(Ie, Z2(Ie).body);
                      break;
                    case 271: {
                      var Ir = Ie.expression, Ne = e2.isObjectLiteralExpression(Ir) || e2.isCallExpression(Ir) ? Ir : e2.isArrowFunction(Ir) || e2.isFunctionExpression(Ir) ? Ir.body : void 0;
                      Ne ? (he(Ie), A2(Ne), F2()) : R(Ie);
                      break;
                    }
                    case 275:
                    case 265:
                    case 176:
                    case 174:
                    case 175:
                    case 259:
                      R(Ie);
                      break;
                    case 208:
                    case 221: {
                      var wr = e2.getAssignmentDeclarationKind(Ie);
                      switch (wr) {
                        case 1:
                        case 2:
                          x2(Ie, Ie.right);
                          return;
                        case 6:
                        case 3: {
                          var Ur = Ie, ii = Ur.left, mi = wr === 3 ? ii.expression : ii, pe = 0, or = void 0;
                          e2.isIdentifier(mi.expression) ? (O(mi.expression.text), or = mi.expression) : (_e = ee(Ur, mi.expression), pe = _e[0], or = _e[1]), wr === 6 ? e2.isObjectLiteralExpression(Ur.right) && Ur.right.properties.length > 0 && (he(Ur, or), e2.forEachChild(Ur.right, A2), F2()) : e2.isFunctionExpression(Ur.right) || e2.isArrowFunction(Ur.right) ? x2(Ie, Ur.right, or) : (he(Ur, or), x2(Ie, Ur.right, ii.name), F2()), ve(pe);
                          return;
                        }
                        case 7:
                        case 9: {
                          var qr = Ie, or = wr === 7 ? qr.arguments[0] : qr.arguments[0].expression, si = qr.arguments[1], Di = ee(Ie, or), pe = Di[0], wi = Di[1];
                          he(Ie, wi), he(Ie, e2.setTextRange(e2.factory.createIdentifier(si.text), si)), A2(Ie.arguments[2]), F2(), F2(), ve(pe);
                          return;
                        }
                        case 5: {
                          var Ur = Ie, ii = Ur.left, Xi = ii.expression;
                          if (e2.isIdentifier(Xi) && e2.getElementOrPropertyAccessName(ii) !== "prototype" && G && G.has(Xi.text)) {
                            e2.isFunctionExpression(Ur.right) || e2.isArrowFunction(Ur.right) ? x2(Ie, Ur.right, Xi) : e2.isBindableStaticAccessExpression(ii) && (he(Ur, Xi), x2(Ur.left, Ur.right, e2.getNameOrArgument(ii)), F2());
                            return;
                          }
                          break;
                        }
                        case 4:
                        case 0:
                        case 8:
                          break;
                        default:
                          e2.Debug.assertNever(wr);
                      }
                    }
                    default:
                      e2.hasJSDocNodes(Ie) && e2.forEach(Ie.jsDoc, function(et) {
                        e2.forEach(et.tags, function(Gi) {
                          e2.isJSDocTypeAlias(Gi) && R(Gi);
                        });
                      }), e2.forEachChild(Ie, A2);
                  }
              }
              function y(Ie, _e) {
                var we = new e2.Map();
                e2.filterMutate(Ie, function(de, ye) {
                  var Ae = de.name || e2.getNameOfDeclaration(de.node), er = Ae && b(Ae);
                  if (!er)
                    return true;
                  var ir = we.get(er);
                  if (!ir)
                    return we.set(er, de), true;
                  if (ir instanceof Array) {
                    for (var Cr = 0, Ye = ir; Cr < Ye.length; Cr++) {
                      var Br = Ye[Cr];
                      if (P(Br, de, ye, _e))
                        return false;
                    }
                    return ir.push(de), true;
                  } else {
                    var Br = ir;
                    return P(Br, de, ye, _e) ? false : (we.set(er, [Br, de]), true);
                  }
                });
              }
              var V = (w = {}, w[5] = true, w[3] = true, w[7] = true, w[9] = true, w[0] = false, w[1] = false, w[2] = false, w[8] = false, w[6] = true, w[4] = false, w);
              function L(Ie, _e, we, de) {
                function ye(Ne) {
                  return e2.isFunctionExpression(Ne) || e2.isFunctionDeclaration(Ne) || e2.isVariableDeclaration(Ne);
                }
                var Ae = e2.isBinaryExpression(_e.node) || e2.isCallExpression(_e.node) ? e2.getAssignmentDeclarationKind(_e.node) : 0, er = e2.isBinaryExpression(Ie.node) || e2.isCallExpression(Ie.node) ? e2.getAssignmentDeclarationKind(Ie.node) : 0;
                if (V[Ae] && V[er] || ye(Ie.node) && V[Ae] || ye(_e.node) && V[er] || e2.isClassDeclaration(Ie.node) && Y(Ie.node) && V[Ae] || e2.isClassDeclaration(_e.node) && V[er] || e2.isClassDeclaration(Ie.node) && Y(Ie.node) && ye(_e.node) || e2.isClassDeclaration(_e.node) && ye(Ie.node) && Y(Ie.node)) {
                  var ir = Ie.additionalNodes && e2.lastOrUndefined(Ie.additionalNodes) || Ie.node;
                  if (!e2.isClassDeclaration(Ie.node) && !e2.isClassDeclaration(_e.node) || ye(Ie.node) || ye(_e.node)) {
                    var Cr = ye(Ie.node) ? Ie.node : ye(_e.node) ? _e.node : void 0;
                    if (Cr !== void 0) {
                      var Ye = e2.setTextRange(e2.factory.createConstructorDeclaration(void 0, void 0, [], void 0), Cr), Br = q(Ye);
                      Br.indent = Ie.indent + 1, Br.children = Ie.node === Cr ? Ie.children : _e.children, Ie.children = Ie.node === Cr ? e2.concatenate([Br], _e.children || [_e]) : e2.concatenate(Ie.children || [Ke({}, Ie)], [Br]);
                    } else
                      (Ie.children || _e.children) && (Ie.children = e2.concatenate(Ie.children || [Ke({}, Ie)], _e.children || [_e]), Ie.children && (y(Ie.children, Ie), I(Ie.children)));
                    ir = Ie.node = e2.setTextRange(e2.factory.createClassDeclaration(void 0, void 0, Ie.name || e2.factory.createIdentifier("__class__"), void 0, void 0, []), Ie.node);
                  } else
                    Ie.children = e2.concatenate(Ie.children, _e.children), Ie.children && y(Ie.children, Ie);
                  var Er = _e.node;
                  return de.children[we - 1].node.end === ir.end ? e2.setTextRange(ir, { pos: ir.pos, end: Er.end }) : (Ie.additionalNodes || (Ie.additionalNodes = []), Ie.additionalNodes.push(e2.setTextRange(e2.factory.createClassDeclaration(void 0, void 0, Ie.name || e2.factory.createIdentifier("__class__"), void 0, void 0, []), _e.node))), true;
                }
                return Ae !== 0;
              }
              function P(Ie, _e, we, de) {
                return L(Ie, _e, we, de) ? true : k(Ie.node, _e.node, de) ? (H(Ie, _e), true) : false;
              }
              function k(Ie, _e, we) {
                if (Ie.kind !== _e.kind || Ie.parent !== _e.parent && !(U(Ie, we) && U(_e, we)))
                  return false;
                switch (Ie.kind) {
                  case 167:
                  case 169:
                  case 172:
                  case 173:
                    return e2.isStatic(Ie) === e2.isStatic(_e);
                  case 261:
                    return j(Ie, _e) && Fe(Ie) === Fe(_e);
                  default:
                    return true;
                }
              }
              function Y(Ie) {
                return !!(Ie.flags & 8);
              }
              function U(Ie, _e) {
                var we = e2.isModuleBlock(Ie.parent) ? Ie.parent.parent : Ie.parent;
                return we === _e.node || e2.contains(_e.additionalNodes, we);
              }
              function j(Ie, _e) {
                return !Ie.body || !_e.body ? Ie.body === _e.body : Ie.body.kind === _e.body.kind && (Ie.body.kind !== 261 || j(Ie.body, _e.body));
              }
              function H(Ie, _e) {
                var we;
                Ie.additionalNodes = Ie.additionalNodes || [], Ie.additionalNodes.push(_e.node), _e.additionalNodes && (we = Ie.additionalNodes).push.apply(we, _e.additionalNodes), Ie.children = e2.concatenate(Ie.children, _e.children), Ie.children && (y(Ie.children, Ie), I(Ie.children));
              }
              function I(Ie) {
                Ie.sort(l);
              }
              function l(Ie, _e) {
                return e2.compareStringsCaseSensitiveUI(d(Ie.node), d(_e.node)) || e2.compareValues(se(Ie), se(_e));
              }
              function d(Ie) {
                if (Ie.kind === 261)
                  return We(Ie);
                var _e = e2.getNameOfDeclaration(Ie);
                if (_e && e2.isPropertyName(_e)) {
                  var we = e2.getPropertyNameForPropertyNameNode(_e);
                  return we && e2.unescapeLeadingUnderscores(we);
                }
                switch (Ie.kind) {
                  case 213:
                  case 214:
                  case 226:
                    return ze(Ie);
                  default:
                    return;
                }
              }
              function D(Ie, _e) {
                if (Ie.kind === 261)
                  return rr(We(Ie));
                if (_e) {
                  var we = e2.isIdentifier(_e) ? _e.text : e2.isElementAccessExpression(_e) ? "[".concat(b(_e.argumentExpression), "]") : b(_e);
                  if (we.length > 0)
                    return rr(we);
                }
                switch (Ie.kind) {
                  case 305:
                    var de = Ie;
                    return e2.isExternalModule(de) ? '"'.concat(e2.escapeString(e2.getBaseFileName(e2.removeFileExtension(e2.normalizePath(de.fileName)))), '"') : "<global>";
                  case 271:
                    return e2.isExportAssignment(Ie) && Ie.isExportEquals ? "export=" : "default";
                  case 214:
                  case 256:
                  case 213:
                  case 257:
                  case 226:
                    return e2.getSyntacticModifierFlags(Ie) & 512 ? "default" : ze(Ie);
                  case 171:
                    return "constructor";
                  case 175:
                    return "new()";
                  case 174:
                    return "()";
                  case 176:
                    return "[]";
                  default:
                    return "<unknown>";
                }
              }
              function fe(Ie) {
                var _e = [];
                function we(ye) {
                  if (de(ye) && (_e.push(ye), ye.children))
                    for (var Ae = 0, er = ye.children; Ae < er.length; Ae++) {
                      var ir = er[Ae];
                      we(ir);
                    }
                }
                return we(Ie), _e;
                function de(ye) {
                  if (ye.children)
                    return true;
                  switch (se(ye)) {
                    case 257:
                    case 226:
                    case 260:
                    case 258:
                    case 261:
                    case 305:
                    case 259:
                    case 345:
                    case 338:
                      return true;
                    case 214:
                    case 256:
                    case 213:
                      return Ae(ye);
                    default:
                      return false;
                  }
                  function Ae(er) {
                    if (!er.node.body)
                      return false;
                    switch (se(er.parent)) {
                      case 262:
                      case 305:
                      case 169:
                      case 171:
                        return true;
                      default:
                        return false;
                    }
                  }
                }
              }
              function g(Ie) {
                return { text: D(Ie.node, Ie.name), kind: e2.getNodeKind(Ie.node), kindModifiers: Re(Ie.node), spans: ue(Ie), nameSpan: Ie.name && ge(Ie.name), childItems: e2.map(Ie.children, g) };
              }
              function ne(Ie) {
                return { text: D(Ie.node, Ie.name), kind: e2.getNodeKind(Ie.node), kindModifiers: Re(Ie.node), spans: ue(Ie), childItems: e2.map(Ie.children, _e) || oe, indent: Ie.indent, bolded: false, grayed: false };
                function _e(we) {
                  return { text: D(we.node, we.name), kind: e2.getNodeKind(we.node), kindModifiers: e2.getNodeModifiers(we.node), spans: ue(we), childItems: oe, indent: 0, bolded: false, grayed: false };
                }
              }
              function ue(Ie) {
                var _e = [ge(Ie.node)];
                if (Ie.additionalNodes)
                  for (var we = 0, de = Ie.additionalNodes; we < de.length; we++) {
                    var ye = de[we];
                    _e.push(ge(ye));
                  }
                return _e;
              }
              function We(Ie) {
                return e2.isAmbientModule(Ie) ? e2.getTextOfNode(Ie.name) : Fe(Ie);
              }
              function Fe(Ie) {
                for (var _e = [e2.getTextOfIdentifierOrLiteral(Ie.name)]; Ie.body && Ie.body.kind === 261; )
                  Ie = Ie.body, _e.push(e2.getTextOfIdentifierOrLiteral(Ie.name));
                return _e.join(".");
              }
              function Z2(Ie) {
                return Ie.body && e2.isModuleDeclaration(Ie.body) ? Z2(Ie.body) : Ie;
              }
              function Be(Ie) {
                return !Ie.name || Ie.name.kind === 162;
              }
              function ge(Ie) {
                return Ie.kind === 305 ? e2.createTextSpanFromRange(Ie) : e2.createTextSpanFromNode(Ie, le);
              }
              function Re(Ie) {
                return Ie.parent && Ie.parent.kind === 254 && (Ie = Ie.parent), e2.getNodeModifiers(Ie);
              }
              function ze(Ie) {
                var _e = Ie.parent;
                if (Ie.name && e2.getFullWidth(Ie.name) > 0)
                  return rr(e2.declarationNameToString(Ie.name));
                if (e2.isVariableDeclaration(_e))
                  return rr(e2.declarationNameToString(_e.name));
                if (e2.isBinaryExpression(_e) && _e.operatorToken.kind === 63)
                  return b(_e.left).replace(B, "");
                if (e2.isPropertyAssignment(_e))
                  return b(_e.name);
                if (e2.getSyntacticModifierFlags(Ie) & 512)
                  return "default";
                if (e2.isClassLike(Ie))
                  return "<class>";
                if (e2.isCallExpression(_e)) {
                  var we = Ee(_e.expression);
                  if (we !== void 0) {
                    if (we = rr(we), we.length > E)
                      return "".concat(we, " callback");
                    var de = rr(e2.mapDefined(_e.arguments, function(ye) {
                      return e2.isStringLiteralLike(ye) ? ye.getText(le) : void 0;
                    }).join(", "));
                    return "".concat(we, "(").concat(de, ") callback");
                  }
                }
                return "<function>";
              }
              function Ee(Ie) {
                if (e2.isIdentifier(Ie))
                  return Ie.text;
                if (e2.isPropertyAccessExpression(Ie)) {
                  var _e = Ee(Ie.expression), we = Ie.name.text;
                  return _e === void 0 ? we : "".concat(_e, ".").concat(we);
                } else
                  return;
              }
              function He(Ie) {
                switch (Ie.kind) {
                  case 214:
                  case 213:
                  case 226:
                    return true;
                  default:
                    return false;
                }
              }
              function rr(Ie) {
                return Ie = Ie.length > E ? Ie.substring(0, E) + "..." : Ie, Ie.replace(/\\?(\r?\n|\r|\u2028|\u2029)/g, "");
              }
            })(a = e2.NavigationBar || (e2.NavigationBar = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(x2, X, $, A2, y, V) {
                var L = e2.textChanges.ChangeTracker.fromContext({ host: $, formatContext: X, preferences: y }), P = function(D) {
                  return e2.stableSort(p(Q(D, x2, A2, V)), function(fe, g) {
                    return O(fe, g);
                  });
                }, k = B(x2, x2.statements.filter(e2.isImportDeclaration));
                k.forEach(function(D) {
                  return d(D, P);
                });
                var Y = x2.statements.filter(e2.isExportDeclaration);
                d(Y, G);
                for (var U = 0, j = x2.statements.filter(e2.isAmbientModule); U < j.length; U++) {
                  var H = j[U];
                  if (!!H.body) {
                    var I = B(x2, H.body.statements.filter(e2.isImportDeclaration));
                    I.forEach(function(D) {
                      return d(D, P);
                    });
                    var l = H.body.statements.filter(e2.isExportDeclaration);
                    d(l, G);
                  }
                }
                return L.getChanges();
                function d(D, fe) {
                  if (e2.length(D) !== 0) {
                    e2.suppressLeadingTrivia(D[0]);
                    var g = e2.group(D, function(Z2) {
                      return N(Z2.moduleSpecifier);
                    }), ne = e2.stableSort(g, function(Z2, Be) {
                      return K(Z2[0].moduleSpecifier, Be[0].moduleSpecifier);
                    }), ue = e2.flatMap(ne, function(Z2) {
                      return N(Z2[0].moduleSpecifier) ? fe(Z2) : Z2;
                    });
                    if (ue.length === 0)
                      L.deleteNodes(x2, D, { trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Include }, true);
                    else {
                      var We = { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Include, suffix: e2.getNewLineOrDefaultFromHost($, X.options) };
                      L.replaceNodeWithNodes(x2, D[0], ue, We);
                      var Fe = L.nodeHasTrailingComment(x2, D[0], We);
                      L.deleteNodes(x2, D.slice(1), { trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Include }, Fe);
                    }
                  }
                }
              }
              C.organizeImports = w;
              function B(x2, X) {
                for (var $ = e2.createScanner(x2.languageVersion, false, x2.languageVariant), A2 = [], y = 0, V = 0, L = X; V < L.length; V++) {
                  var P = L[V];
                  E(x2, P, $) && y++, A2[y] || (A2[y] = []), A2[y].push(P);
                }
                return A2;
              }
              function E(x2, X, $) {
                var A2 = X.getFullStart(), y = X.getStart();
                $.setText(x2.text, A2, y - A2);
                for (var V = 0; $.getTokenPos() < y; ) {
                  var L = $.scan();
                  if (L === 4 && (V++, V >= 2))
                    return true;
                }
                return false;
              }
              function Q(x2, X, $, A2) {
                if (A2)
                  return x2;
                for (var y = $.getTypeChecker(), V = $.getCompilerOptions(), L = y.getJsxNamespace(X), P = y.getJsxFragmentFactory(X), k = !!(X.transformFlags & 2), Y = [], U = 0, j = x2; U < j.length; U++) {
                  var H = j[U], I = H.importClause, l = H.moduleSpecifier;
                  if (!I) {
                    Y.push(H);
                    continue;
                  }
                  var d = I.name, D = I.namedBindings;
                  if (d && !g(d) && (d = void 0), D)
                    if (e2.isNamespaceImport(D))
                      g(D.name) || (D = void 0);
                    else {
                      var fe = D.elements.filter(function(ne) {
                        return g(ne.name);
                      });
                      fe.length < D.elements.length && (D = fe.length ? e2.factory.updateNamedImports(D, fe) : void 0);
                    }
                  d || D ? Y.push(oe(H, d, D)) : le(X, l) && (X.isDeclarationFile ? Y.push(e2.factory.createImportDeclaration(H.decorators, H.modifiers, void 0, l, void 0)) : Y.push(H));
                }
                return Y;
                function g(ne) {
                  return k && (ne.text === L || P && ne.text === P) && e2.jsxModeNeedsExplicitImport(V.jsx) || e2.FindAllReferences.Core.isSymbolReferencedInFile(ne, y, X);
                }
              }
              function le(x2, X) {
                var $ = e2.isStringLiteral(X) && X.text;
                return e2.isString($) && e2.some(x2.moduleAugmentations, function(A2) {
                  return e2.isStringLiteral(A2) && A2.text === $;
                });
              }
              function N(x2) {
                return x2 !== void 0 && e2.isStringLiteralLike(x2) ? x2.text : void 0;
              }
              function p(x2) {
                var X;
                if (x2.length === 0)
                  return x2;
                var $ = m2(x2), A2 = $.importWithoutClause, y = $.typeOnlyImports, V = $.regularImports, L = [];
                A2 && L.push(A2);
                for (var P = 0, k = [V, y]; P < k.length; P++) {
                  var Y = k[P], U = Y === y, j = Y.defaultImports, H = Y.namespaceImports, I = Y.namedImports;
                  if (!U && j.length === 1 && H.length === 1 && I.length === 0) {
                    var l = j[0];
                    L.push(oe(l, l.importClause.name, H[0].importClause.namedBindings));
                    continue;
                  }
                  for (var d = e2.stableSort(H, function(Re, ze) {
                    return b(Re.importClause.namedBindings.name, ze.importClause.namedBindings.name);
                  }), D = 0, fe = d; D < fe.length; D++) {
                    var g = fe[D];
                    L.push(oe(g, void 0, g.importClause.namedBindings));
                  }
                  if (!(j.length === 0 && I.length === 0)) {
                    var ne = void 0, ue = [];
                    if (j.length === 1)
                      ne = j[0].importClause.name;
                    else
                      for (var We = 0, Fe = j; We < Fe.length; We++) {
                        var l = Fe[We];
                        ue.push(e2.factory.createImportSpecifier(false, e2.factory.createIdentifier("default"), l.importClause.name));
                      }
                    ue.push.apply(ue, he(I));
                    var Z2 = f4(ue), Be = j.length > 0 ? j[0] : I[0], ge = Z2.length === 0 ? ne ? void 0 : e2.factory.createNamedImports(e2.emptyArray) : I.length === 0 ? e2.factory.createNamedImports(Z2) : e2.factory.updateNamedImports(I[0].importClause.namedBindings, Z2);
                    U && ne && ge ? (L.push(oe(Be, ne, void 0)), L.push(oe((X = I[0]) !== null && X !== void 0 ? X : Be, void 0, ge))) : L.push(oe(Be, ne, ge));
                  }
                }
                return L;
              }
              C.coalesceImports = p;
              function m2(x2) {
                for (var X, $ = { defaultImports: [], namespaceImports: [], namedImports: [] }, A2 = { defaultImports: [], namespaceImports: [], namedImports: [] }, y = 0, V = x2; y < V.length; y++) {
                  var L = V[y];
                  if (L.importClause === void 0) {
                    X = X || L;
                    continue;
                  }
                  var P = L.importClause.isTypeOnly ? $ : A2, k = L.importClause, Y = k.name, U = k.namedBindings;
                  Y && P.defaultImports.push(L), U && (e2.isNamespaceImport(U) ? P.namespaceImports.push(L) : P.namedImports.push(L));
                }
                return { importWithoutClause: X, typeOnlyImports: $, regularImports: A2 };
              }
              function G(x2) {
                if (x2.length === 0)
                  return x2;
                var X = H(x2), $ = X.exportWithoutClause, A2 = X.namedExports, y = X.typeOnlyExports, V = [];
                $ && V.push($);
                for (var L = 0, P = [A2, y]; L < P.length; L++) {
                  var k = P[L];
                  if (k.length !== 0) {
                    var Y = [];
                    Y.push.apply(Y, e2.flatMap(k, function(I) {
                      return I.exportClause && e2.isNamedExports(I.exportClause) ? I.exportClause.elements : e2.emptyArray;
                    }));
                    var U = f4(Y), j = k[0];
                    V.push(e2.factory.updateExportDeclaration(j, j.decorators, j.modifiers, j.isTypeOnly, j.exportClause && (e2.isNamedExports(j.exportClause) ? e2.factory.updateNamedExports(j.exportClause, U) : e2.factory.updateNamespaceExport(j.exportClause, j.exportClause.name)), j.moduleSpecifier, j.assertClause));
                  }
                }
                return V;
                function H(I) {
                  for (var l, d = [], D = [], fe = 0, g = I; fe < g.length; fe++) {
                    var ne = g[fe];
                    ne.exportClause === void 0 ? l = l || ne : ne.isTypeOnly ? D.push(ne) : d.push(ne);
                  }
                  return { exportWithoutClause: l, namedExports: d, typeOnlyExports: D };
                }
              }
              C.coalesceExports = G;
              function oe(x2, X, $) {
                return e2.factory.updateImportDeclaration(x2, x2.decorators, x2.modifiers, e2.factory.updateImportClause(x2.importClause, x2.importClause.isTypeOnly, X, $), x2.moduleSpecifier, x2.assertClause);
              }
              function f4(x2) {
                return e2.stableSort(x2, T);
              }
              function T(x2, X) {
                return e2.compareBooleans(x2.isTypeOnly, X.isTypeOnly) || b(x2.propertyName || x2.name, X.propertyName || X.name) || b(x2.name, X.name);
              }
              C.compareImportOrExportSpecifiers = T;
              function K(x2, X) {
                var $ = x2 === void 0 ? void 0 : N(x2), A2 = X === void 0 ? void 0 : N(X);
                return e2.compareBooleans($ === void 0, A2 === void 0) || e2.compareBooleans(e2.isExternalModuleNameRelative($), e2.isExternalModuleNameRelative(A2)) || e2.compareStringsCaseInsensitive($, A2);
              }
              C.compareModuleSpecifiers = K;
              function b(x2, X) {
                return e2.compareStringsCaseInsensitive(x2.text, X.text);
              }
              function se(x2) {
                var X;
                switch (x2.kind) {
                  case 265:
                    return (X = e2.tryCast(x2.moduleReference, e2.isExternalModuleReference)) === null || X === void 0 ? void 0 : X.expression;
                  case 266:
                    return x2.moduleSpecifier;
                  case 237:
                    return x2.declarationList.declarations[0].initializer.arguments[0];
                }
              }
              function J(x2) {
                return e2.arrayIsSorted(x2, O);
              }
              C.importsAreSorted = J;
              function ie(x2) {
                return e2.arrayIsSorted(x2, T);
              }
              C.importSpecifiersAreSorted = ie;
              function R(x2, X) {
                var $ = e2.binarySearch(x2, X, e2.identity, O);
                return $ < 0 ? ~$ : $;
              }
              C.getImportDeclarationInsertionIndex = R;
              function q(x2, X) {
                var $ = e2.binarySearch(x2, X, e2.identity, T);
                return $ < 0 ? ~$ : $;
              }
              C.getImportSpecifierInsertionIndex = q;
              function O(x2, X) {
                return K(se(x2), se(X)) || ve(x2, X);
              }
              C.compareImportsOrRequireStatements = O;
              function ve(x2, X) {
                return e2.compareValues(ee(x2), ee(X));
              }
              function ee(x2) {
                var X;
                switch (x2.kind) {
                  case 266:
                    return x2.importClause ? x2.importClause.isTypeOnly ? 1 : ((X = x2.importClause.namedBindings) === null || X === void 0 ? void 0 : X.kind) === 268 ? 2 : x2.importClause.name ? 3 : 4 : 0;
                  case 265:
                    return 5;
                  case 237:
                    return 6;
                }
              }
              function he(x2) {
                return e2.flatMap(x2, function(X) {
                  return e2.map(F2(X), function($) {
                    return $.name && $.propertyName && $.name.escapedText === $.propertyName.escapedText ? e2.factory.updateImportSpecifier($, $.isTypeOnly, void 0, $.name) : $;
                  });
                });
              }
              function F2(x2) {
                var X;
                return ((X = x2.importClause) === null || X === void 0 ? void 0 : X.namedBindings) && e2.isNamedImports(x2.importClause.namedBindings) ? x2.importClause.namedBindings.elements : void 0;
              }
            })(a = e2.OrganizeImports || (e2.OrganizeImports = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(b, se) {
                var J = [];
                return B(b, se, J), E(b, J), J.sort(function(ie, R) {
                  return ie.textSpan.start - R.textSpan.start;
                });
              }
              C.collectElements = w;
              function B(b, se, J) {
                for (var ie = 40, R = 0, q = Ve(Ve([], b.statements, true), [b.endOfFileToken], false), O = q.length; R < O; ) {
                  for (; R < O && !e2.isAnyImportSyntax(q[R]); )
                    he(q[R]), R++;
                  if (R === O)
                    break;
                  for (var ve = R; R < O && e2.isAnyImportSyntax(q[R]); )
                    p(q[R], b, se, J), R++;
                  var ee = R - 1;
                  ee !== ve && J.push(m2(e2.findChildOfKind(q[ve], 100, b).getStart(b), q[ee].getEnd(), "imports"));
                }
                function he(F2) {
                  var x2;
                  if (ie !== 0) {
                    se.throwIfCancellationRequested(), (e2.isDeclaration(F2) || e2.isVariableStatement(F2) || e2.isReturnStatement(F2) || e2.isCallOrNewExpression(F2) || F2.kind === 1) && p(F2, b, se, J), e2.isFunctionLike(F2) && e2.isBinaryExpression(F2.parent) && e2.isPropertyAccessExpression(F2.parent.left) && p(F2.parent.left, b, se, J), (e2.isBlock(F2) || e2.isModuleBlock(F2)) && N(F2.statements.end, b, se, J), (e2.isClassLike(F2) || e2.isInterfaceDeclaration(F2)) && N(F2.members.end, b, se, J);
                    var X = G(F2, b);
                    X && J.push(X), ie--, e2.isCallExpression(F2) ? (ie++, he(F2.expression), ie--, F2.arguments.forEach(he), (x2 = F2.typeArguments) === null || x2 === void 0 || x2.forEach(he)) : e2.isIfStatement(F2) && F2.elseStatement && e2.isIfStatement(F2.elseStatement) ? (he(F2.expression), he(F2.thenStatement), ie++, he(F2.elseStatement), ie--) : F2.forEachChild(he), ie++;
                  }
                }
              }
              function E(b, se) {
                for (var J = [], ie = b.getLineStarts(), R = 0, q = ie; R < q.length; R++) {
                  var O = q[R], ve = b.getLineEndOfPosition(O), ee = b.text.substring(O, ve), he = le(ee);
                  if (!(!he || e2.isInComment(b, O)))
                    if (he[1]) {
                      var x2 = J.pop();
                      x2 && (x2.textSpan.length = ve - x2.textSpan.start, x2.hintSpan.length = ve - x2.textSpan.start, se.push(x2));
                    } else {
                      var F2 = e2.createTextSpanFromBounds(b.text.indexOf("//", O), ve);
                      J.push(T(F2, "region", F2, false, he[2] || "#region"));
                    }
                }
              }
              var Q = /^#(end)?region(?:\s+(.*))?(?:\r)?$/;
              function le(b) {
                return b = e2.trimStringStart(b), e2.startsWith(b, "//") ? (b = e2.trimString(b.slice(2)), Q.exec(b)) : null;
              }
              function N(b, se, J, ie) {
                var R = e2.getLeadingCommentRanges(se.text, b);
                if (!R)
                  return;
                for (var q = -1, O = -1, ve = 0, ee = se.getFullText(), he = 0, F2 = R; he < F2.length; he++) {
                  var x2 = F2[he], X = x2.kind, $ = x2.pos, A2 = x2.end;
                  switch (J.throwIfCancellationRequested(), X) {
                    case 2:
                      var y = ee.slice($, A2);
                      if (le(y)) {
                        V(), ve = 0;
                        break;
                      }
                      ve === 0 && (q = $), O = A2, ve++;
                      break;
                    case 3:
                      V(), ie.push(m2($, A2, "comment")), ve = 0;
                      break;
                    default:
                      e2.Debug.assertNever(X);
                  }
                }
                V();
                function V() {
                  ve > 1 && ie.push(m2(q, O, "comment"));
                }
              }
              function p(b, se, J, ie) {
                e2.isJsxText(b) || N(b.pos, se, J, ie);
              }
              function m2(b, se, J) {
                return T(e2.createTextSpanFromBounds(b, se), J);
              }
              function G(b, se) {
                switch (b.kind) {
                  case 235:
                    if (e2.isFunctionLike(b.parent))
                      return oe(b.parent, b, se);
                    switch (b.parent.kind) {
                      case 240:
                      case 243:
                      case 244:
                      case 242:
                      case 239:
                      case 241:
                      case 248:
                      case 292:
                        return x2(b.parent);
                      case 252:
                        var J = b.parent;
                        if (J.tryBlock === b)
                          return x2(b.parent);
                        if (J.finallyBlock === b) {
                          var ie = e2.findChildOfKind(J, 96, se);
                          if (ie)
                            return x2(ie);
                        }
                      default:
                        return T(e2.createTextSpanFromNode(b, se), "code");
                    }
                  case 262:
                    return x2(b.parent);
                  case 257:
                  case 226:
                  case 258:
                  case 260:
                  case 263:
                  case 182:
                  case 201:
                    return x2(b);
                  case 184:
                    return x2(b, false, !e2.isTupleTypeNode(b.parent), 22);
                  case 289:
                  case 290:
                    return X(b.statements);
                  case 205:
                    return F2(b);
                  case 204:
                    return F2(b, 22);
                  case 278:
                    return O(b);
                  case 282:
                    return ve(b);
                  case 279:
                  case 280:
                    return ee(b.attributes);
                  case 223:
                  case 14:
                    return he(b);
                  case 202:
                    return x2(b, false, !e2.isBindingElement(b.parent), 22);
                  case 214:
                    return q(b);
                  case 208:
                    return R(b);
                  case 212:
                    return $(b);
                }
                function R(A2) {
                  if (!!A2.arguments.length) {
                    var y = e2.findChildOfKind(A2, 20, se), V = e2.findChildOfKind(A2, 21, se);
                    if (!(!y || !V || e2.positionsAreOnSameLine(y.pos, V.pos, se)))
                      return f4(y, V, A2, se, false, true);
                  }
                }
                function q(A2) {
                  if (!(e2.isBlock(A2.body) || e2.isParenthesizedExpression(A2.body) || e2.positionsAreOnSameLine(A2.body.getFullStart(), A2.body.getEnd(), se))) {
                    var y = e2.createTextSpanFromBounds(A2.body.getFullStart(), A2.body.getEnd());
                    return T(y, "code", e2.createTextSpanFromNode(A2));
                  }
                }
                function O(A2) {
                  var y = e2.createTextSpanFromBounds(A2.openingElement.getStart(se), A2.closingElement.getEnd()), V = A2.openingElement.tagName.getText(se), L = "<" + V + ">...</" + V + ">";
                  return T(y, "code", y, false, L);
                }
                function ve(A2) {
                  var y = e2.createTextSpanFromBounds(A2.openingFragment.getStart(se), A2.closingFragment.getEnd()), V = "<>...</>";
                  return T(y, "code", y, false, V);
                }
                function ee(A2) {
                  if (A2.properties.length !== 0)
                    return m2(A2.getStart(se), A2.getEnd(), "code");
                }
                function he(A2) {
                  if (!(A2.kind === 14 && A2.text.length === 0))
                    return m2(A2.getStart(se), A2.getEnd(), "code");
                }
                function F2(A2, y) {
                  return y === void 0 && (y = 18), x2(A2, false, !e2.isArrayLiteralExpression(A2.parent) && !e2.isCallExpression(A2.parent), y);
                }
                function x2(A2, y, V, L, P) {
                  y === void 0 && (y = false), V === void 0 && (V = true), L === void 0 && (L = 18), P === void 0 && (P = L === 18 ? 19 : 23);
                  var k = e2.findChildOfKind(b, L, se), Y = e2.findChildOfKind(b, P, se);
                  return k && Y && f4(k, Y, A2, se, y, V);
                }
                function X(A2) {
                  return A2.length ? T(e2.createTextSpanFromRange(A2), "code") : void 0;
                }
                function $(A2) {
                  if (!e2.positionsAreOnSameLine(A2.getStart(), A2.getEnd(), se)) {
                    var y = e2.createTextSpanFromBounds(A2.getStart(), A2.getEnd());
                    return T(y, "code", e2.createTextSpanFromNode(A2));
                  }
                }
              }
              function oe(b, se, J) {
                var ie = K(b, se, J), R = e2.findChildOfKind(se, 19, J);
                return ie && R && f4(ie, R, b, J, b.kind !== 214);
              }
              function f4(b, se, J, ie, R, q) {
                R === void 0 && (R = false), q === void 0 && (q = true);
                var O = e2.createTextSpanFromBounds(q ? b.getFullStart() : b.getStart(ie), se.getEnd());
                return T(O, "code", e2.createTextSpanFromNode(J, ie), R);
              }
              function T(b, se, J, ie, R) {
                return J === void 0 && (J = b), ie === void 0 && (ie = false), R === void 0 && (R = "..."), { textSpan: b, kind: se, hintSpan: J, bannerText: R, autoCollapse: ie };
              }
              function K(b, se, J) {
                if (e2.isNodeArrayMultiLine(b.parameters, J)) {
                  var ie = e2.findChildOfKind(b, 20, J);
                  if (ie)
                    return ie;
                }
                return e2.findChildOfKind(se, 18, J);
              }
            })(a = e2.OutliningElementsCollector || (e2.OutliningElementsCollector = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(y) {
              y[y.exact = 0] = "exact", y[y.prefix = 1] = "prefix", y[y.substring = 2] = "substring", y[y.camelCase = 3] = "camelCase";
            })(a = e2.PatternMatchKind || (e2.PatternMatchKind = {}));
            function C(y, V) {
              return { kind: y, isCaseSensitive: V };
            }
            function w(y) {
              var V = new e2.Map(), L = y.trim().split(".").map(function(P) {
                return f4(P.trim());
              });
              if (!L.some(function(P) {
                return !P.subWordTextChunks.length;
              }))
                return { getFullMatch: function(P, k) {
                  return B(P, k, L, V);
                }, getMatchForLastSegmentOfPattern: function(P) {
                  return le(P, e2.last(L), V);
                }, patternContainsDots: L.length > 1 };
            }
            e2.createPatternMatcher = w;
            function B(y, V, L, P) {
              var k = le(V, e2.last(L), P);
              if (!!k && !(L.length - 1 > y.length)) {
                for (var Y, U = L.length - 2, j = y.length - 1; U >= 0; U -= 1, j -= 1)
                  Y = N(Y, le(y[j], L[U], P));
                return Y;
              }
            }
            function E(y, V) {
              var L = V.get(y);
              return L || V.set(y, L = ve(y)), L;
            }
            function Q(y, V, L) {
              var P = b(y, V.textLowerCase);
              if (P === 0)
                return C(V.text.length === y.length ? a.exact : a.prefix, e2.startsWith(y, V.text));
              if (V.isLowerCase) {
                if (P === -1)
                  return;
                for (var k = E(y, L), Y = 0, U = k; Y < U.length; Y++) {
                  var j = U[Y];
                  if (m2(y, j, V.text, true))
                    return C(a.substring, m2(y, j, V.text, false));
                }
                if (V.text.length < y.length && T(y.charCodeAt(P)))
                  return C(a.substring, false);
              } else {
                if (y.indexOf(V.text) > 0)
                  return C(a.substring, true);
                if (V.characterSpans.length > 0) {
                  var H = E(y, L), I = oe(y, H, V, false) ? true : oe(y, H, V, true) ? false : void 0;
                  if (I !== void 0)
                    return C(a.camelCase, I);
                }
              }
            }
            function le(y, V, L) {
              if (A2(V.totalTextChunk.text, function(I) {
                return I !== 32 && I !== 42;
              })) {
                var P = Q(y, V.totalTextChunk, L);
                if (P)
                  return P;
              }
              for (var k = V.subWordTextChunks, Y, U = 0, j = k; U < j.length; U++) {
                var H = j[U];
                Y = N(Y, Q(y, H, L));
              }
              return Y;
            }
            function N(y, V) {
              return e2.min(y, V, p);
            }
            function p(y, V) {
              return y === void 0 ? 1 : V === void 0 ? -1 : e2.compareValues(y.kind, V.kind) || e2.compareBooleans(!y.isCaseSensitive, !V.isCaseSensitive);
            }
            function m2(y, V, L, P, k) {
              return k === void 0 && (k = { start: 0, length: L.length }), k.length <= V.length && $(0, k.length, function(Y) {
                return G(L.charCodeAt(k.start + Y), y.charCodeAt(V.start + Y), P);
              });
            }
            function G(y, V, L) {
              return L ? se(y) === se(V) : y === V;
            }
            function oe(y, V, L, P) {
              for (var k = L.characterSpans, Y = 0, U = 0, j, H; ; ) {
                if (U === k.length)
                  return true;
                if (Y === V.length)
                  return false;
                for (var I = V[Y], l = false; U < k.length; U++) {
                  var d = k[U];
                  if (l && (!T(L.text.charCodeAt(k[U - 1].start)) || !T(L.text.charCodeAt(k[U].start))) || !m2(y, I, L.text, P, d))
                    break;
                  l = true, j = j === void 0 ? Y : j, H = H === void 0 ? true : H, I = e2.createTextSpan(I.start + d.length, I.length - d.length);
                }
                !l && H !== void 0 && (H = false), Y++;
              }
            }
            function f4(y) {
              return { totalTextChunk: q(y), subWordTextChunks: R(y) };
            }
            function T(y) {
              if (y >= 65 && y <= 90)
                return true;
              if (y < 127 || !e2.isUnicodeIdentifierStart(y, 99))
                return false;
              var V = String.fromCharCode(y);
              return V === V.toUpperCase();
            }
            function K(y) {
              if (y >= 97 && y <= 122)
                return true;
              if (y < 127 || !e2.isUnicodeIdentifierStart(y, 99))
                return false;
              var V = String.fromCharCode(y);
              return V === V.toLowerCase();
            }
            function b(y, V) {
              for (var L = y.length - V.length, P = function(U) {
                if (A2(V, function(j, H) {
                  return se(y.charCodeAt(H + U)) === j;
                }))
                  return { value: U };
              }, k = 0; k <= L; k++) {
                var Y = P(k);
                if (typeof Y == "object")
                  return Y.value;
              }
              return -1;
            }
            function se(y) {
              return y >= 65 && y <= 90 ? 97 + (y - 65) : y < 127 ? y : String.fromCharCode(y).toLowerCase().charCodeAt(0);
            }
            function J(y) {
              return y >= 48 && y <= 57;
            }
            function ie(y) {
              return T(y) || K(y) || J(y) || y === 95 || y === 36;
            }
            function R(y) {
              for (var V = [], L = 0, P = 0, k = 0; k < y.length; k++) {
                var Y = y.charCodeAt(k);
                ie(Y) ? (P === 0 && (L = k), P++) : P > 0 && (V.push(q(y.substr(L, P))), P = 0);
              }
              return P > 0 && V.push(q(y.substr(L, P))), V;
            }
            function q(y) {
              var V = y.toLowerCase();
              return { text: y, textLowerCase: V, isLowerCase: y === V, characterSpans: O(y) };
            }
            function O(y) {
              return ee(y, false);
            }
            e2.breakIntoCharacterSpans = O;
            function ve(y) {
              return ee(y, true);
            }
            e2.breakIntoWordSpans = ve;
            function ee(y, V) {
              for (var L = [], P = 0, k = 1; k < y.length; k++) {
                var Y = J(y.charCodeAt(k - 1)), U = J(y.charCodeAt(k)), j = X(y, V, k), H = V && x2(y, k, P);
                (he(y.charCodeAt(k - 1)) || he(y.charCodeAt(k)) || Y !== U || j || H) && (F2(y, P, k) || L.push(e2.createTextSpan(P, k - P)), P = k);
              }
              return F2(y, P, y.length) || L.push(e2.createTextSpan(P, y.length - P)), L;
            }
            function he(y) {
              switch (y) {
                case 33:
                case 34:
                case 35:
                case 37:
                case 38:
                case 39:
                case 40:
                case 41:
                case 42:
                case 44:
                case 45:
                case 46:
                case 47:
                case 58:
                case 59:
                case 63:
                case 64:
                case 91:
                case 92:
                case 93:
                case 95:
                case 123:
                case 125:
                  return true;
              }
              return false;
            }
            function F2(y, V, L) {
              return A2(y, function(P) {
                return he(P) && P !== 95;
              }, V, L);
            }
            function x2(y, V, L) {
              return V !== L && V + 1 < y.length && T(y.charCodeAt(V)) && K(y.charCodeAt(V + 1)) && A2(y, T, L, V);
            }
            function X(y, V, L) {
              var P = T(y.charCodeAt(L - 1)), k = T(y.charCodeAt(L));
              return k && (!V || !P);
            }
            function $(y, V, L) {
              for (var P = y; P < V; P++)
                if (!L(P))
                  return false;
              return true;
            }
            function A2(y, V, L, P) {
              return L === void 0 && (L = 0), P === void 0 && (P = y.length), $(L, P, function(k) {
                return V(y.charCodeAt(k), k);
              });
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C, w, B) {
              w === void 0 && (w = true), B === void 0 && (B = false);
              var E = { languageVersion: 1, pragmas: void 0, checkJsDirective: void 0, referencedFiles: [], typeReferenceDirectives: [], libReferenceDirectives: [], amdDependencies: [], hasNoDefaultLib: void 0, moduleName: void 0 }, Q = [], le, N, p, m2 = 0, G = false;
              function oe() {
                return N = p, p = e2.scanner.scan(), p === 18 ? m2++ : p === 19 && m2--, p;
              }
              function f4() {
                var $ = e2.scanner.getTokenValue(), A2 = e2.scanner.getTokenPos();
                return { fileName: $, pos: A2, end: A2 + $.length };
              }
              function T() {
                le || (le = []), le.push({ ref: f4(), depth: m2 });
              }
              function K() {
                Q.push(f4()), b();
              }
              function b() {
                m2 === 0 && (G = true);
              }
              function se() {
                var $ = e2.scanner.getToken();
                return $ === 135 ? ($ = oe(), $ === 141 && ($ = oe(), $ === 10 && T()), true) : false;
              }
              function J() {
                if (N === 24)
                  return false;
                var $ = e2.scanner.getToken();
                if ($ === 100) {
                  if ($ = oe(), $ === 20) {
                    if ($ = oe(), $ === 10 || $ === 14)
                      return K(), true;
                  } else {
                    if ($ === 10)
                      return K(), true;
                    if ($ === 152) {
                      var A2 = e2.scanner.lookAhead(function() {
                        var y = e2.scanner.scan();
                        return y !== 156 && (y === 41 || y === 18 || y === 79 || e2.isKeyword(y));
                      });
                      A2 && ($ = oe());
                    }
                    if ($ === 79 || e2.isKeyword($))
                      if ($ = oe(), $ === 156) {
                        if ($ = oe(), $ === 10)
                          return K(), true;
                      } else if ($ === 63) {
                        if (R(true))
                          return true;
                      } else if ($ === 27)
                        $ = oe();
                      else
                        return true;
                    if ($ === 18) {
                      for ($ = oe(); $ !== 19 && $ !== 1; )
                        $ = oe();
                      $ === 19 && ($ = oe(), $ === 156 && ($ = oe(), $ === 10 && K()));
                    } else
                      $ === 41 && ($ = oe(), $ === 127 && ($ = oe(), ($ === 79 || e2.isKeyword($)) && ($ = oe(), $ === 156 && ($ = oe(), $ === 10 && K()))));
                  }
                  return true;
                }
                return false;
              }
              function ie() {
                var $ = e2.scanner.getToken();
                if ($ === 93) {
                  if (b(), $ = oe(), $ === 152) {
                    var A2 = e2.scanner.lookAhead(function() {
                      var y = e2.scanner.scan();
                      return y === 41 || y === 18;
                    });
                    A2 && ($ = oe());
                  }
                  if ($ === 18) {
                    for ($ = oe(); $ !== 19 && $ !== 1; )
                      $ = oe();
                    $ === 19 && ($ = oe(), $ === 156 && ($ = oe(), $ === 10 && K()));
                  } else if ($ === 41)
                    $ = oe(), $ === 156 && ($ = oe(), $ === 10 && K());
                  else if ($ === 100) {
                    if ($ = oe(), $ === 152) {
                      var A2 = e2.scanner.lookAhead(function() {
                        var V = e2.scanner.scan();
                        return V === 79 || e2.isKeyword(V);
                      });
                      A2 && ($ = oe());
                    }
                    if (($ === 79 || e2.isKeyword($)) && ($ = oe(), $ === 63 && R(true)))
                      return true;
                  }
                  return true;
                }
                return false;
              }
              function R($, A2) {
                A2 === void 0 && (A2 = false);
                var y = $ ? oe() : e2.scanner.getToken();
                return y === 146 ? (y = oe(), y === 20 && (y = oe(), (y === 10 || A2 && y === 14) && K()), true) : false;
              }
              function q() {
                var $ = e2.scanner.getToken();
                if ($ === 79 && e2.scanner.getTokenValue() === "define") {
                  if ($ = oe(), $ !== 20)
                    return true;
                  if ($ = oe(), $ === 10 || $ === 14)
                    if ($ = oe(), $ === 27)
                      $ = oe();
                    else
                      return true;
                  if ($ !== 22)
                    return true;
                  for ($ = oe(); $ !== 23 && $ !== 1; )
                    ($ === 10 || $ === 14) && K(), $ = oe();
                  return true;
                }
                return false;
              }
              function O() {
                for (e2.scanner.setText(C), oe(); e2.scanner.getToken() !== 1; ) {
                  if (e2.scanner.getToken() === 15) {
                    var $ = [e2.scanner.getToken()], A2 = e2.scanner.scan();
                    e:
                      for (; e2.length($); ) {
                        switch (A2) {
                          case 1:
                            break e;
                          case 100:
                            J();
                            break;
                          case 15:
                            $.push(A2);
                            break;
                          case 18:
                            e2.length($) && $.push(A2);
                            break;
                          case 19:
                            e2.length($) && (e2.lastOrUndefined($) === 15 ? e2.scanner.reScanTemplateToken(false) === 17 && $.pop() : $.pop());
                            break;
                        }
                        A2 = e2.scanner.scan();
                      }
                    oe();
                  }
                  se() || J() || ie() || B && (R(false, true) || q()) || oe();
                }
                e2.scanner.setText(void 0);
              }
              if (w && O(), e2.processCommentPragmas(E, C), e2.processPragmasIntoFields(E, e2.noop), G) {
                if (le)
                  for (var ve = 0, ee = le; ve < ee.length; ve++) {
                    var he = ee[ve];
                    Q.push(he.ref);
                  }
                return { referencedFiles: E.referencedFiles, typeReferenceDirectives: E.typeReferenceDirectives, libReferenceDirectives: E.libReferenceDirectives, importedFiles: Q, isLibFile: !!E.hasNoDefaultLib, ambientExternalModules: void 0 };
              } else {
                var F2 = void 0;
                if (le)
                  for (var x2 = 0, X = le; x2 < X.length; x2++) {
                    var he = X[x2];
                    he.depth === 0 ? (F2 || (F2 = []), F2.push(he.ref.fileName)) : Q.push(he.ref);
                  }
                return { referencedFiles: E.referencedFiles, typeReferenceDirectives: E.typeReferenceDirectives, libReferenceDirectives: E.libReferenceDirectives, importedFiles: Q, isLibFile: !!E.hasNoDefaultLib, ambientExternalModules: F2 };
              }
            }
            e2.preProcessFile = a;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(G, oe, f4, T) {
                var K = e2.getAdjustedRenameLocation(e2.getTouchingPropertyName(oe, f4));
                if (m2(K)) {
                  var b = B(K, G.getTypeChecker(), oe, G, T);
                  if (b)
                    return b;
                }
                return N(e2.Diagnostics.You_cannot_rename_this_element);
              }
              C.getRenameInfo = w;
              function B(G, oe, f4, T, K) {
                var b = oe.getSymbolAtLocation(G);
                if (!b) {
                  if (e2.isStringLiteralLike(G)) {
                    var se = e2.getContextualTypeFromParentOrAncestorTypeNode(G, oe);
                    if (se && (se.flags & 128 || se.flags & 1048576 && e2.every(se.types, function(ee) {
                      return !!(ee.flags & 128);
                    })))
                      return le(G.text, G.text, "string", "", G, f4);
                  } else if (e2.isLabelName(G)) {
                    var J = e2.getTextOfNode(G);
                    return le(J, J, "label", "", G, f4);
                  }
                  return;
                }
                var ie = b.declarations;
                if (!(!ie || ie.length === 0)) {
                  if (ie.some(function(ee) {
                    return E(T, ee);
                  }))
                    return N(e2.Diagnostics.You_cannot_rename_elements_that_are_defined_in_the_standard_TypeScript_library);
                  if (!(e2.isIdentifier(G) && G.originalKeywordKind === 88 && b.parent && b.parent.flags & 1536)) {
                    if (e2.isStringLiteralLike(G) && e2.tryGetImportFromModuleSpecifier(G))
                      return K && K.allowRenameOfImportPath ? Q(G, f4, b) : void 0;
                    var R = e2.SymbolDisplay.getSymbolKind(oe, b, G), q = e2.isImportOrExportSpecifierName(G) || e2.isStringOrNumericLiteralLike(G) && G.parent.kind === 162 ? e2.stripQuotes(e2.getTextOfIdentifierOrLiteral(G)) : void 0, O = q || oe.symbolToString(b), ve = q || oe.getFullyQualifiedName(b);
                    return le(O, ve, R, e2.SymbolDisplay.getSymbolModifiers(oe, b), G, f4);
                  }
                }
              }
              function E(G, oe) {
                var f4 = oe.getSourceFile();
                return G.isSourceFileDefaultLibrary(f4) && e2.fileExtensionIs(f4.fileName, ".d.ts");
              }
              function Q(G, oe, f4) {
                if (!e2.isExternalModuleNameRelative(G.text))
                  return N(e2.Diagnostics.You_cannot_rename_a_module_via_a_global_import);
                var T = f4.declarations && e2.find(f4.declarations, e2.isSourceFile);
                if (!!T) {
                  var K = e2.endsWith(G.text, "/index") || e2.endsWith(G.text, "/index.js") ? void 0 : e2.tryRemoveSuffix(e2.removeFileExtension(T.fileName), "/index"), b = K === void 0 ? T.fileName : K, se = K === void 0 ? "module" : "directory", J = G.text.lastIndexOf("/") + 1, ie = e2.createTextSpan(G.getStart(oe) + 1 + J, G.text.length - J);
                  return { canRename: true, fileToRename: b, kind: se, displayName: b, fullDisplayName: b, kindModifiers: "", triggerSpan: ie };
                }
              }
              function le(G, oe, f4, T, K, b) {
                return { canRename: true, fileToRename: void 0, kind: f4, displayName: G, fullDisplayName: oe, kindModifiers: T, triggerSpan: p(K, b) };
              }
              function N(G) {
                return { canRename: false, localizedErrorMessage: e2.getLocaleSpecificMessage(G) };
              }
              function p(G, oe) {
                var f4 = G.getStart(oe), T = G.getWidth(oe);
                return e2.isStringLiteralLike(G) && (f4 += 1, T -= 2), e2.createTextSpan(f4, T);
              }
              function m2(G) {
                switch (G.kind) {
                  case 79:
                  case 80:
                  case 10:
                  case 14:
                  case 108:
                    return true;
                  case 8:
                    return e2.isLiteralNameOfPropertyDeclarationOrIndexAccess(G);
                  default:
                    return false;
                }
              }
              C.nodeIsEligibleForRename = m2;
            })(a = e2.Rename || (e2.Rename = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(f4, T) {
                var K, b = { textSpan: e2.createTextSpanFromBounds(T.getFullStart(), T.getEnd()) }, se = T;
                e:
                  for (; ; ) {
                    var J = Q(se);
                    if (!J.length)
                      break;
                    for (var ie = 0; ie < J.length; ie++) {
                      var R = J[ie - 1], q = J[ie], O = J[ie + 1];
                      if (e2.getTokenPosOfNode(q, T, true) > f4)
                        break e;
                      var ve = e2.singleOrUndefined(e2.getTrailingCommentRanges(T.text, q.end));
                      if (ve && ve.kind === 2 && A2(ve.pos, ve.end), B(T, f4, q)) {
                        if (e2.isBlock(q) || e2.isTemplateSpan(q) || e2.isTemplateHead(q) || e2.isTemplateTail(q) || R && e2.isTemplateHead(R) || e2.isVariableDeclarationList(q) && e2.isVariableStatement(se) || e2.isSyntaxList(q) && e2.isVariableDeclarationList(se) || e2.isVariableDeclaration(q) && e2.isSyntaxList(se) && J.length === 1 || e2.isJSDocTypeExpression(q) || e2.isJSDocSignature(q) || e2.isJSDocTypeLiteral(q)) {
                          se = q;
                          break;
                        }
                        if (e2.isTemplateSpan(se) && O && e2.isTemplateMiddleOrTemplateTail(O)) {
                          var ee = q.getFullStart() - 2, he = O.getStart() + 1;
                          $(ee, he);
                        }
                        var F2 = e2.isSyntaxList(q) && m2(R) && G(O) && !e2.positionsAreOnSameLine(R.getStart(), O.getStart(), T), x2 = F2 ? R.getEnd() : q.getStart(), X = F2 ? O.getStart() : oe(T, q);
                        e2.hasJSDocNodes(q) && ((K = q.jsDoc) === null || K === void 0 ? void 0 : K.length) && $(e2.first(q.jsDoc).getStart(), X), $(x2, X), (e2.isStringLiteral(q) || e2.isTemplateLiteral(q)) && $(x2 + 1, X - 1), se = q;
                        break;
                      }
                      if (ie === J.length - 1)
                        break e;
                    }
                  }
                return b;
                function $(y, V) {
                  if (y !== V) {
                    var L = e2.createTextSpanFromBounds(y, V);
                    (!b || !e2.textSpansEqual(L, b.textSpan) && e2.textSpanIntersectsWithPosition(L, f4)) && (b = Ke({ textSpan: L }, b && { parent: b }));
                  }
                }
                function A2(y, V) {
                  $(y, V);
                  for (var L = y; T.text.charCodeAt(L) === 47; )
                    L++;
                  $(L, V);
                }
              }
              C.getSmartSelectionRange = w;
              function B(f4, T, K) {
                if (e2.Debug.assert(K.pos <= T), T < K.end)
                  return true;
                var b = K.getEnd();
                return b === T ? e2.getTouchingPropertyName(f4, T).pos < K.end : false;
              }
              var E = e2.or(e2.isImportDeclaration, e2.isImportEqualsDeclaration);
              function Q(f4) {
                if (e2.isSourceFile(f4))
                  return le(f4.getChildAt(0).getChildren(), E);
                if (e2.isMappedTypeNode(f4)) {
                  var T = f4.getChildren(), K = T[0], b = T.slice(1), se = e2.Debug.checkDefined(b.pop());
                  e2.Debug.assertEqual(K.kind, 18), e2.Debug.assertEqual(se.kind, 19);
                  var J = le(b, function(O) {
                    return O === f4.readonlyToken || O.kind === 145 || O === f4.questionToken || O.kind === 57;
                  }), ie = le(J, function(O) {
                    var ve = O.kind;
                    return ve === 22 || ve === 163 || ve === 23;
                  });
                  return [K, p(N(ie, function(O) {
                    var ve = O.kind;
                    return ve === 58;
                  })), se];
                }
                if (e2.isPropertySignature(f4)) {
                  var b = le(f4.getChildren(), function(ve) {
                    return ve === f4.name || e2.contains(f4.modifiers, ve);
                  });
                  return N(b, function(ve) {
                    var ee = ve.kind;
                    return ee === 58;
                  });
                }
                if (e2.isParameter(f4)) {
                  var R = le(f4.getChildren(), function(O) {
                    return O === f4.dotDotDotToken || O === f4.name;
                  }), q = le(R, function(O) {
                    return O === R[0] || O === f4.questionToken;
                  });
                  return N(q, function(O) {
                    var ve = O.kind;
                    return ve === 63;
                  });
                }
                return e2.isBindingElement(f4) ? N(f4.getChildren(), function(O) {
                  var ve = O.kind;
                  return ve === 63;
                }) : f4.getChildren();
              }
              function le(f4, T) {
                for (var K = [], b, se = 0, J = f4; se < J.length; se++) {
                  var ie = J[se];
                  T(ie) ? (b = b || [], b.push(ie)) : (b && (K.push(p(b)), b = void 0), K.push(ie));
                }
                return b && K.push(p(b)), K;
              }
              function N(f4, T, K) {
                if (K === void 0 && (K = true), f4.length < 2)
                  return f4;
                var b = e2.findIndex(f4, T);
                if (b === -1)
                  return f4;
                var se = f4.slice(0, b), J = f4[b], ie = e2.last(f4), R = K && ie.kind === 26, q = f4.slice(b + 1, R ? f4.length - 1 : void 0), O = e2.compact([se.length ? p(se) : void 0, J, q.length ? p(q) : void 0]);
                return R ? O.concat(ie) : O;
              }
              function p(f4) {
                return e2.Debug.assertGreaterThanOrEqual(f4.length, 1), e2.setTextRangePosEnd(e2.parseNodeFactory.createSyntaxList(f4), f4[0].pos, e2.last(f4).end);
              }
              function m2(f4) {
                var T = f4 && f4.kind;
                return T === 18 || T === 22 || T === 20 || T === 280;
              }
              function G(f4) {
                var T = f4 && f4.kind;
                return T === 19 || T === 23 || T === 21 || T === 281;
              }
              function oe(f4, T) {
                switch (T.kind) {
                  case 340:
                  case 338:
                  case 347:
                  case 345:
                  case 342:
                    return f4.getLineEndOfPosition(T.getStart());
                  default:
                    return T.getEnd();
                }
              }
            })(a = e2.SmartSelectionRange || (e2.SmartSelectionRange = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(l) {
                l[l.Call = 0] = "Call", l[l.TypeArgs = 1] = "TypeArgs", l[l.Contextual = 2] = "Contextual";
              })(w || (w = {}));
              function B(l, d, D, fe, g) {
                var ne = l.getTypeChecker(), ue = e2.findTokenOnLeftOfPosition(d, D);
                if (!!ue) {
                  var We = !!fe && fe.kind === "characterTyped";
                  if (!(We && (e2.isInString(d, D, ue) || e2.isInComment(d, D)))) {
                    var Fe = !!fe && fe.kind === "invoked", Z2 = F2(ue, D, d, ne, Fe);
                    if (!!Z2) {
                      g.throwIfCancellationRequested();
                      var Be = Q(Z2, ne, d, ue, We);
                      return g.throwIfCancellationRequested(), Be ? ne.runWithCancellationToken(g, function(ge) {
                        return Be.kind === 0 ? y(Be.candidates, Be.resolvedSignature, Z2, d, ge) : V(Be.symbol, Z2, d, ge);
                      }) : e2.isSourceFileJS(d) ? N(Z2, l, g) : void 0;
                    }
                  }
                }
              }
              C.getSignatureHelpItems = B;
              var E;
              (function(l) {
                l[l.Candidate = 0] = "Candidate", l[l.Type = 1] = "Type";
              })(E || (E = {}));
              function Q(l, d, D, fe, g) {
                var ne = l.invocation, ue = l.argumentCount;
                switch (ne.kind) {
                  case 0: {
                    if (g && !le(fe, ne.node, D))
                      return;
                    var We = [], Fe = d.getResolvedSignatureForSignatureHelp(ne.node, We, ue);
                    return We.length === 0 ? void 0 : { kind: 0, candidates: We, resolvedSignature: Fe };
                  }
                  case 1: {
                    var Z2 = ne.called;
                    if (g && !p(fe, D, e2.isIdentifier(Z2) ? Z2.parent : Z2))
                      return;
                    var We = e2.getPossibleGenericSignatures(Z2, ue, d);
                    if (We.length !== 0)
                      return { kind: 0, candidates: We, resolvedSignature: e2.first(We) };
                    var Be = d.getSymbolAtLocation(Z2);
                    return Be && { kind: 1, symbol: Be };
                  }
                  case 2:
                    return { kind: 0, candidates: [ne.signature], resolvedSignature: ne.signature };
                  default:
                    return e2.Debug.assertNever(ne);
                }
              }
              function le(l, d, D) {
                if (!e2.isCallOrNewExpression(d))
                  return false;
                var fe = d.getChildren(D);
                switch (l.kind) {
                  case 20:
                    return e2.contains(fe, l);
                  case 27: {
                    var g = e2.findContainingList(l);
                    return !!g && e2.contains(fe, g);
                  }
                  case 29:
                    return p(l, D, d.expression);
                  default:
                    return false;
                }
              }
              function N(l, d, D) {
                if (l.invocation.kind !== 2) {
                  var fe = X(l.invocation), g = e2.isPropertyAccessExpression(fe) ? fe.name.text : void 0, ne = d.getTypeChecker();
                  return g === void 0 ? void 0 : e2.firstDefined(d.getSourceFiles(), function(ue) {
                    return e2.firstDefined(ue.getNamedDeclarations().get(g), function(We) {
                      var Fe = We.symbol && ne.getTypeOfSymbolAtLocation(We.symbol, We), Z2 = Fe && Fe.getCallSignatures();
                      if (Z2 && Z2.length)
                        return ne.runWithCancellationToken(D, function(Be) {
                          return y(Z2, Z2[0], l, ue, Be, true);
                        });
                    });
                  });
                }
              }
              function p(l, d, D) {
                for (var fe = l.getFullStart(), g = l.parent; g; ) {
                  var ne = e2.findPrecedingToken(fe, d, g, true);
                  if (ne)
                    return e2.rangeContainsRange(D, ne);
                  g = g.parent;
                }
                return e2.Debug.fail("Could not find preceding token");
              }
              function m2(l, d, D) {
                var fe = f4(l, d, D);
                return !fe || fe.isTypeParameterList || fe.invocation.kind !== 0 ? void 0 : { invocation: fe.invocation.node, argumentCount: fe.argumentCount, argumentIndex: fe.argumentIndex };
              }
              C.getArgumentInfoForCompletions = m2;
              function G(l, d, D) {
                var fe = oe(l, D);
                if (!!fe) {
                  var g = fe.list, ne = fe.argumentIndex, ue = q(g, e2.isInString(D, d, l));
                  ne !== 0 && e2.Debug.assertLessThan(ne, ue);
                  var We = ee(g, D);
                  return { list: g, argumentIndex: ne, argumentCount: ue, argumentsSpan: We };
                }
              }
              function oe(l, d) {
                if (l.kind === 29 || l.kind === 20)
                  return { list: x2(l.parent, l, d), argumentIndex: 0 };
                var D = e2.findContainingList(l);
                return D && { list: D, argumentIndex: R(D, l) };
              }
              function f4(l, d, D) {
                var fe = l.parent;
                if (e2.isCallOrNewExpression(fe)) {
                  var g = fe, ne = G(l, d, D);
                  if (!ne)
                    return;
                  var ue = ne.list, We = ne.argumentIndex, Fe = ne.argumentCount, Z2 = ne.argumentsSpan, Be = !!fe.typeArguments && fe.typeArguments.pos === ue.pos;
                  return { isTypeParameterList: Be, invocation: { kind: 0, node: g }, argumentsSpan: Z2, argumentIndex: We, argumentCount: Fe };
                } else {
                  if (e2.isNoSubstitutionTemplateLiteral(l) && e2.isTaggedTemplateExpression(fe))
                    return e2.isInsideTemplateLiteral(l, d, D) ? ve(fe, 0, D) : void 0;
                  if (e2.isTemplateHead(l) && fe.parent.kind === 210) {
                    var ge = fe, Re = ge.parent;
                    e2.Debug.assert(ge.kind === 223);
                    var We = e2.isInsideTemplateLiteral(l, d, D) ? 0 : 1;
                    return ve(Re, We, D);
                  } else if (e2.isTemplateSpan(fe) && e2.isTaggedTemplateExpression(fe.parent.parent)) {
                    var ze = fe, Re = fe.parent.parent;
                    if (e2.isTemplateTail(l) && !e2.isInsideTemplateLiteral(l, d, D))
                      return;
                    var Ee = ze.parent.templateSpans.indexOf(ze), We = O(Ee, l, d, D);
                    return ve(Re, We, D);
                  } else if (e2.isJsxOpeningLikeElement(fe)) {
                    var He = fe.attributes.pos, rr = e2.skipTrivia(D.text, fe.attributes.end, false);
                    return { isTypeParameterList: false, invocation: { kind: 0, node: fe }, argumentsSpan: e2.createTextSpan(He, rr - He), argumentIndex: 0, argumentCount: 1 };
                  } else {
                    var Ie = e2.getPossibleTypeArgumentsInfo(l, D);
                    if (Ie) {
                      var _e = Ie.called, we = Ie.nTypeArguments, g = { kind: 1, called: _e }, Z2 = e2.createTextSpanFromBounds(_e.getStart(D), l.end);
                      return { isTypeParameterList: true, invocation: g, argumentsSpan: Z2, argumentIndex: we, argumentCount: we + 1 };
                    }
                    return;
                  }
                }
              }
              function T(l, d, D, fe) {
                return se(l, d, D, fe) || f4(l, d, D);
              }
              function K(l) {
                return e2.isBinaryExpression(l.parent) ? K(l.parent) : l;
              }
              function b(l) {
                return e2.isBinaryExpression(l.left) ? b(l.left) + 1 : 2;
              }
              function se(l, d, D, fe) {
                var g = J(l, D, d, fe);
                if (!!g) {
                  var ne = g.contextualType, ue = g.argumentIndex, We = g.argumentCount, Fe = g.argumentsSpan, Z2 = ne.getNonNullableType(), Be = Z2.symbol;
                  if (Be !== void 0) {
                    var ge = e2.lastOrUndefined(Z2.getCallSignatures());
                    if (ge !== void 0) {
                      var Re = { kind: 2, signature: ge, node: l, symbol: ie(Be) };
                      return { isTypeParameterList: false, invocation: Re, argumentsSpan: Fe, argumentIndex: ue, argumentCount: We };
                    }
                  }
                }
              }
              function J(l, d, D, fe) {
                if (!(l.kind !== 20 && l.kind !== 27)) {
                  var g = l.parent;
                  switch (g.kind) {
                    case 212:
                    case 169:
                    case 213:
                    case 214:
                      var ne = G(l, D, d);
                      if (!ne)
                        return;
                      var ue = ne.argumentIndex, We = ne.argumentCount, Fe = ne.argumentsSpan, Z2 = e2.isMethodDeclaration(g) ? fe.getContextualTypeForObjectLiteralElement(g) : fe.getContextualType(g);
                      return Z2 && { contextualType: Z2, argumentIndex: ue, argumentCount: We, argumentsSpan: Fe };
                    case 221: {
                      var Be = K(g), ge = fe.getContextualType(Be), Re = l.kind === 20 ? 0 : b(g) - 1, ze = b(Be);
                      return ge && { contextualType: ge, argumentIndex: Re, argumentCount: ze, argumentsSpan: e2.createTextSpanFromNode(g) };
                    }
                    default:
                      return;
                  }
                }
              }
              function ie(l) {
                return l.name === "__type" && e2.firstDefined(l.declarations, function(d) {
                  return e2.isFunctionTypeNode(d) ? d.parent.symbol : void 0;
                }) || l;
              }
              function R(l, d) {
                for (var D = 0, fe = 0, g = l.getChildren(); fe < g.length; fe++) {
                  var ne = g[fe];
                  if (ne === d)
                    break;
                  ne.kind !== 27 && D++;
                }
                return D;
              }
              function q(l, d) {
                var D = l.getChildren(), fe = e2.countWhere(D, function(g) {
                  return g.kind !== 27;
                });
                return !d && D.length > 0 && e2.last(D).kind === 27 && fe++, fe;
              }
              function O(l, d, D, fe) {
                return e2.Debug.assert(D >= d.getStart(), "Assumed 'position' could not occur before node."), e2.isTemplateLiteralToken(d) ? e2.isInsideTemplateLiteral(d, D, fe) ? 0 : l + 2 : l + 1;
              }
              function ve(l, d, D) {
                var fe = e2.isNoSubstitutionTemplateLiteral(l.template) ? 1 : l.template.templateSpans.length + 1;
                return d !== 0 && e2.Debug.assertLessThan(d, fe), { isTypeParameterList: false, invocation: { kind: 0, node: l }, argumentsSpan: he(l, D), argumentIndex: d, argumentCount: fe };
              }
              function ee(l, d) {
                var D = l.getFullStart(), fe = e2.skipTrivia(d.text, l.getEnd(), false);
                return e2.createTextSpan(D, fe - D);
              }
              function he(l, d) {
                var D = l.template, fe = D.getStart(), g = D.getEnd();
                if (D.kind === 223) {
                  var ne = e2.last(D.templateSpans);
                  ne.literal.getFullWidth() === 0 && (g = e2.skipTrivia(d.text, g, false));
                }
                return e2.createTextSpan(fe, g - fe);
              }
              function F2(l, d, D, fe, g) {
                for (var ne = function(Fe) {
                  e2.Debug.assert(e2.rangeContainsRange(Fe.parent, Fe), "Not a subspan", function() {
                    return "Child: ".concat(e2.Debug.formatSyntaxKind(Fe.kind), ", parent: ").concat(e2.Debug.formatSyntaxKind(Fe.parent.kind));
                  });
                  var Z2 = T(Fe, d, D, fe);
                  if (Z2)
                    return { value: Z2 };
                }, ue = l; !e2.isSourceFile(ue) && (g || !e2.isBlock(ue)); ue = ue.parent) {
                  var We = ne(ue);
                  if (typeof We == "object")
                    return We.value;
                }
              }
              function x2(l, d, D) {
                var fe = l.getChildren(D), g = fe.indexOf(d);
                return e2.Debug.assert(g >= 0 && fe.length > g + 1), fe[g + 1];
              }
              function X(l) {
                return l.kind === 0 ? e2.getInvokedExpression(l.node) : l.called;
              }
              function $(l) {
                return l.kind === 0 ? l.node : l.kind === 1 ? l.called : l.node;
              }
              var A2 = 70246400;
              function y(l, d, D, fe, g, ne) {
                var ue, We = D.isTypeParameterList, Fe = D.argumentCount, Z2 = D.argumentsSpan, Be = D.invocation, ge = D.argumentIndex, Re = $(Be), ze = Be.kind === 2 ? Be.symbol : g.getSymbolAtLocation(X(Be)) || ne && ((ue = d.declaration) === null || ue === void 0 ? void 0 : ue.symbol), Ee = ze ? e2.symbolToDisplayParts(g, ze, ne ? fe : void 0, void 0) : e2.emptyArray, He = e2.map(l, function(Br) {
                  return k(Br, Ee, We, g, Re, fe);
                });
                ge !== 0 && e2.Debug.assertLessThan(ge, Fe);
                for (var rr = 0, Ie = 0, _e = 0; _e < He.length; _e++) {
                  var we = He[_e];
                  if (l[_e] === d && (rr = Ie, we.length > 1))
                    for (var de = 0, ye = 0, Ae = we; ye < Ae.length; ye++) {
                      var er = Ae[ye];
                      if (er.isVariadic || er.parameters.length >= Fe) {
                        rr = Ie + de;
                        break;
                      }
                      de++;
                    }
                  Ie += we.length;
                }
                e2.Debug.assert(rr !== -1);
                var ir = { items: e2.flatMapToMutable(He, e2.identity), applicableSpan: Z2, selectedItemIndex: rr, argumentIndex: ge, argumentCount: Fe }, Cr = ir.items[rr];
                if (Cr.isVariadic) {
                  var Ye = e2.findIndex(Cr.parameters, function(Br) {
                    return !!Br.isRest;
                  });
                  -1 < Ye && Ye < Cr.parameters.length - 1 ? ir.argumentIndex = Cr.parameters.length : ir.argumentIndex = Math.min(ir.argumentIndex, Cr.parameters.length - 1);
                }
                return ir;
              }
              function V(l, d, D, fe) {
                var g = d.argumentCount, ne = d.argumentsSpan, ue = d.invocation, We = d.argumentIndex, Fe = fe.getLocalTypeParametersOfClassOrInterfaceOrTypeAlias(l);
                if (!!Fe) {
                  var Z2 = [L(l, Fe, fe, $(ue), D)];
                  return { items: Z2, applicableSpan: ne, selectedItemIndex: 0, argumentIndex: We, argumentCount: g };
                }
              }
              function L(l, d, D, fe, g) {
                var ne = e2.symbolToDisplayParts(D, l), ue = e2.createPrinter({ removeComments: true }), We = d.map(function(ge) {
                  return I(ge, D, fe, g, ue);
                }), Fe = l.getDocumentationComment(D), Z2 = l.getJsDocTags(D), Be = Ve(Ve([], ne, true), [e2.punctuationPart(29)], false);
                return { isVariadic: false, prefixDisplayParts: Be, suffixDisplayParts: [e2.punctuationPart(31)], separatorDisplayParts: P, parameters: We, documentation: Fe, tags: Z2 };
              }
              var P = [e2.punctuationPart(27), e2.spacePart()];
              function k(l, d, D, fe, g, ne) {
                var ue = (D ? U : j)(l, fe, g, ne);
                return e2.map(ue, function(We) {
                  var Fe = We.isVariadic, Z2 = We.parameters, Be = We.prefix, ge = We.suffix, Re = Ve(Ve([], d, true), Be, true), ze = Ve(Ve([], ge, true), Y(l, g, fe), true), Ee = l.getDocumentationComment(fe), He = l.getJsDocTags();
                  return { isVariadic: Fe, prefixDisplayParts: Re, suffixDisplayParts: ze, separatorDisplayParts: P, parameters: Z2, documentation: Ee, tags: He };
                });
              }
              function Y(l, d, D) {
                return e2.mapToDisplayParts(function(fe) {
                  fe.writePunctuation(":"), fe.writeSpace(" ");
                  var g = D.getTypePredicateOfSignature(l);
                  g ? D.writeTypePredicate(g, d, void 0, fe) : D.writeType(D.getReturnTypeOfSignature(l), d, void 0, fe);
                });
              }
              function U(l, d, D, fe) {
                var g = (l.target || l).typeParameters, ne = e2.createPrinter({ removeComments: true }), ue = (g || e2.emptyArray).map(function(Fe) {
                  return I(Fe, d, D, fe, ne);
                }), We = l.thisParameter ? [d.symbolToParameterDeclaration(l.thisParameter, D, A2)] : [];
                return d.getExpandedParameters(l).map(function(Fe) {
                  var Z2 = e2.factory.createNodeArray(Ve(Ve([], We, true), e2.map(Fe, function(ge) {
                    return d.symbolToParameterDeclaration(ge, D, A2);
                  }), true)), Be = e2.mapToDisplayParts(function(ge) {
                    ne.writeList(2576, Z2, fe, ge);
                  });
                  return { isVariadic: false, parameters: ue, prefix: [e2.punctuationPart(29)], suffix: Ve([e2.punctuationPart(31)], Be, true) };
                });
              }
              function j(l, d, D, fe) {
                var g = e2.createPrinter({ removeComments: true }), ne = e2.mapToDisplayParts(function(Fe) {
                  if (l.typeParameters && l.typeParameters.length) {
                    var Z2 = e2.factory.createNodeArray(l.typeParameters.map(function(Be) {
                      return d.typeParameterToDeclaration(Be, D, A2);
                    }));
                    g.writeList(53776, Z2, fe, Fe);
                  }
                }), ue = d.getExpandedParameters(l), We = d.hasEffectiveRestParameter(l) ? ue.length === 1 ? function(Fe) {
                  return true;
                } : function(Fe) {
                  return !!(Fe.length && Fe[Fe.length - 1].checkFlags & 32768);
                } : function(Fe) {
                  return false;
                };
                return ue.map(function(Fe) {
                  return { isVariadic: We(Fe), parameters: Fe.map(function(Z2) {
                    return H(Z2, d, D, fe, g);
                  }), prefix: Ve(Ve([], ne, true), [e2.punctuationPart(20)], false), suffix: [e2.punctuationPart(21)] };
                });
              }
              function H(l, d, D, fe, g) {
                var ne = e2.mapToDisplayParts(function(Fe) {
                  var Z2 = d.symbolToParameterDeclaration(l, D, A2);
                  g.writeNode(4, Z2, fe, Fe);
                }), ue = d.isOptionalParameter(l.valueDeclaration), We = !!(l.checkFlags & 32768);
                return { name: l.name, documentation: l.getDocumentationComment(d), displayParts: ne, isOptional: ue, isRest: We };
              }
              function I(l, d, D, fe, g) {
                var ne = e2.mapToDisplayParts(function(ue) {
                  var We = d.typeParameterToDeclaration(l, D, A2);
                  g.writeNode(4, We, fe, ue);
                });
                return { name: l.symbol.name, documentation: l.symbol.getDocumentationComment(d), displayParts: ne, isOptional: false, isRest: false };
              }
            })(a = e2.SignatureHelp || (e2.SignatureHelp = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = 30, B = function(N) {
                return new RegExp("^\\s?/\\*\\*?\\s?".concat(N, "\\s?\\*\\/\\s?$"));
              };
              function E(N) {
                return N.includeInlayParameterNameHints === "literals" || N.includeInlayParameterNameHints === "all";
              }
              function Q(N) {
                return N.includeInlayParameterNameHints === "literals";
              }
              function le(N) {
                var p = N.file, m2 = N.program, G = N.span, oe = N.cancellationToken, f4 = N.preferences, T = p.text, K = m2.getCompilerOptions(), b = m2.getTypeChecker(), se = [];
                return J(p), se;
                function J(U) {
                  if (!(!U || U.getFullWidth() === 0)) {
                    switch (U.kind) {
                      case 261:
                      case 257:
                      case 258:
                      case 256:
                      case 226:
                      case 213:
                      case 169:
                      case 214:
                        oe.throwIfCancellationRequested();
                    }
                    if (!!e2.textSpanIntersectsWith(G, U.pos, U.getFullWidth()) && !e2.isTypeNode(U))
                      return f4.includeInlayVariableTypeHints && e2.isVariableDeclaration(U) || f4.includeInlayPropertyDeclarationTypeHints && e2.isPropertyDeclaration(U) ? he(U) : f4.includeInlayEnumMemberValueHints && e2.isEnumMember(U) ? ve(U) : E(f4) && (e2.isCallExpression(U) || e2.isNewExpression(U)) ? F2(U) : (f4.includeInlayFunctionParameterTypeHints && e2.isFunctionLikeDeclaration(U) && e2.hasContextSensitiveParameters(U) && V(U), f4.includeInlayFunctionLikeReturnTypeHints && ie(U) && A2(U)), e2.forEachChild(U, J);
                  }
                }
                function ie(U) {
                  return e2.isArrowFunction(U) || e2.isFunctionExpression(U) || e2.isFunctionDeclaration(U) || e2.isMethodDeclaration(U) || e2.isGetAccessorDeclaration(U);
                }
                function R(U, j, H) {
                  se.push({ text: "".concat(H ? "..." : "").concat(P(U, w), ":"), position: j, kind: "Parameter", whitespaceAfter: true });
                }
                function q(U, j) {
                  se.push({ text: ": ".concat(P(U, w)), position: j, kind: "Type", whitespaceBefore: true });
                }
                function O(U, j) {
                  se.push({ text: "= ".concat(P(U, w)), position: j, kind: "Enum", whitespaceBefore: true });
                }
                function ve(U) {
                  if (!U.initializer) {
                    var j = b.getConstantValue(U);
                    j !== void 0 && O(j.toString(), U.end);
                  }
                }
                function ee(U) {
                  return U.symbol && U.symbol.flags & 1536;
                }
                function he(U) {
                  if (!(!U.initializer || e2.isBindingPattern(U.name))) {
                    var j = e2.getEffectiveTypeAnnotationNode(U);
                    if (!j) {
                      var H = b.getTypeAtLocation(U);
                      if (!ee(H)) {
                        var I = k(H);
                        I && q(I, U.name.end);
                      }
                    }
                  }
                }
                function F2(U) {
                  var j = U.arguments;
                  if (!(!j || !j.length)) {
                    var H = [], I = b.getResolvedSignatureForSignatureHelp(U, H);
                    if (!(!I || !H.length))
                      for (var l = 0; l < j.length; ++l) {
                        var d = j[l], D = e2.skipParentheses(d);
                        if (!(Q(f4) && !$(D))) {
                          var fe = b.getParameterIdentifierNameAtPosition(I, l);
                          if (fe) {
                            var g = fe[0], ne = fe[1], ue = f4.includeInlayParameterNameHintsWhenArgumentMatchesName || !x2(D, g);
                            if (!ue && !ne)
                              continue;
                            var We = e2.unescapeLeadingUnderscores(g);
                            if (X(D, We))
                              continue;
                            R(We, d.getStart(), ne);
                          }
                        }
                      }
                  }
                }
                function x2(U, j) {
                  return e2.isIdentifier(U) ? U.text === j : e2.isPropertyAccessExpression(U) ? U.name.text === j : false;
                }
                function X(U, j) {
                  if (!e2.isIdentifierText(j, K.target, e2.getLanguageVariant(p.scriptKind)))
                    return false;
                  var H = e2.getLeadingCommentRanges(T, U.pos);
                  if (!(H != null && H.length))
                    return false;
                  var I = B(j);
                  return e2.some(H, function(l) {
                    return I.test(T.substring(l.pos, l.end));
                  });
                }
                function $(U) {
                  switch (U.kind) {
                    case 219: {
                      var j = U.operand;
                      return e2.isLiteralExpression(j) || e2.isIdentifier(j) && e2.isInfinityOrNaNString(j.escapedText);
                    }
                    case 110:
                    case 95:
                    case 104:
                    case 14:
                    case 223:
                      return true;
                    case 79: {
                      var H = U.escapedText;
                      return Y(H) || e2.isInfinityOrNaNString(H);
                    }
                  }
                  return e2.isLiteralExpression(U);
                }
                function A2(U) {
                  if (!(e2.isArrowFunction(U) && !e2.findChildOfKind(U, 20, p))) {
                    var j = e2.getEffectiveReturnTypeNode(U);
                    if (!(j || !U.body)) {
                      var H = b.getSignatureFromDeclaration(U);
                      if (!!H) {
                        var I = b.getReturnTypeOfSignature(H);
                        if (!ee(I)) {
                          var l = k(I);
                          !l || q(l, y(U));
                        }
                      }
                    }
                  }
                }
                function y(U) {
                  var j = e2.findChildOfKind(U, 21, p);
                  return j ? j.end : U.parameters.end;
                }
                function V(U) {
                  var j = b.getSignatureFromDeclaration(U);
                  if (!!j)
                    for (var H = 0; H < U.parameters.length && H < j.parameters.length; ++H) {
                      var I = U.parameters[H], l = e2.getEffectiveTypeAnnotationNode(I);
                      if (!l) {
                        var d = L(j.parameters[H]);
                        !d || q(d, I.questionToken ? I.questionToken.end : I.name.end);
                      }
                    }
                }
                function L(U) {
                  var j = U.valueDeclaration;
                  if (!(!j || !e2.isParameter(j))) {
                    var H = b.getTypeOfSymbolAtLocation(U, j);
                    if (!ee(H))
                      return k(H);
                  }
                }
                function P(U, j) {
                  return U.length > j ? U.substr(0, j - 3) + "..." : U;
                }
                function k(U) {
                  var j = 71286784, H = { removeComments: true }, I = e2.createPrinter(H);
                  return e2.usingSingleLineStringWriter(function(l) {
                    var d = b.typeToTypeNode(U, void 0, j, l);
                    e2.Debug.assertIsDefined(d, "should always get typenode"), I.writeNode(4, d, p, l);
                  });
                }
                function Y(U) {
                  return U === "undefined";
                }
              }
              C.provideInlayHints = le;
            })(a = e2.InlayHints || (e2.InlayHints = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = /^data:(?:application\/json(?:;charset=[uU][tT][fF]-8);base64,([A-Za-z0-9+\/=]+)$)?/;
            function C(Q) {
              var le = e2.createGetCanonicalFileName(Q.useCaseSensitiveFileNames()), N = Q.getCurrentDirectory(), p = new e2.Map(), m2 = new e2.Map();
              return { tryGetSourcePosition: f4, tryGetGeneratedPosition: T, toLineColumnOffset: J, clearCache: ie };
              function G(R) {
                return e2.toPath(R, N, le);
              }
              function oe(R, q) {
                var O = G(R), ve = m2.get(O);
                if (ve)
                  return ve;
                var ee;
                if (Q.getDocumentPositionMapper)
                  ee = Q.getDocumentPositionMapper(R, q);
                else if (Q.readFile) {
                  var he = se(R);
                  ee = he && e2.getDocumentPositionMapper({ getSourceFileLike: se, getCanonicalFileName: le, log: function(F2) {
                    return Q.log(F2);
                  } }, R, e2.getLineInfo(he.text, e2.getLineStarts(he)), function(F2) {
                    return !Q.fileExists || Q.fileExists(F2) ? Q.readFile(F2) : void 0;
                  });
                }
                return m2.set(O, ee || e2.identitySourceMapConsumer), ee || e2.identitySourceMapConsumer;
              }
              function f4(R) {
                if (!!e2.isDeclarationFileName(R.fileName)) {
                  var q = K(R.fileName);
                  if (!!q) {
                    var O = oe(R.fileName).getSourcePosition(R);
                    return !O || O === R ? void 0 : f4(O) || O;
                  }
                }
              }
              function T(R) {
                if (!e2.isDeclarationFileName(R.fileName)) {
                  var q = K(R.fileName);
                  if (!!q) {
                    var O = Q.getProgram();
                    if (!O.isSourceOfProjectReferenceRedirect(q.fileName)) {
                      var ve = O.getCompilerOptions(), ee = e2.outFile(ve), he = ee ? e2.removeFileExtension(ee) + ".d.ts" : e2.getDeclarationEmitOutputFilePathWorker(R.fileName, O.getCompilerOptions(), N, O.getCommonSourceDirectory(), le);
                      if (he !== void 0) {
                        var F2 = oe(he, R.fileName).getGeneratedPosition(R);
                        return F2 === R ? void 0 : F2;
                      }
                    }
                  }
                }
              }
              function K(R) {
                var q = Q.getProgram();
                if (!!q) {
                  var O = G(R), ve = q.getSourceFileByPath(O);
                  return ve && ve.resolvedPath === O ? ve : void 0;
                }
              }
              function b(R) {
                var q = G(R), O = p.get(q);
                if (O !== void 0)
                  return O || void 0;
                if (!Q.readFile || Q.fileExists && !Q.fileExists(q)) {
                  p.set(q, false);
                  return;
                }
                var ve = Q.readFile(q), ee = ve ? E(ve) : false;
                return p.set(q, ee), ee || void 0;
              }
              function se(R) {
                return Q.getSourceFileLike ? Q.getSourceFileLike(R) : K(R) || b(R);
              }
              function J(R, q) {
                var O = se(R);
                return O.getLineAndCharacterOfPosition(q);
              }
              function ie() {
                p.clear(), m2.clear();
              }
            }
            e2.getSourceMapper = C;
            function w(Q, le, N, p) {
              var m2 = e2.tryGetSourceMappingURL(N);
              if (m2) {
                var G = a.exec(m2);
                if (G) {
                  if (G[1]) {
                    var oe = G[1];
                    return B(Q, e2.base64decode(e2.sys, oe), le);
                  }
                  m2 = void 0;
                }
              }
              var f4 = [];
              m2 && f4.push(m2), f4.push(le + ".map");
              for (var T = m2 && e2.getNormalizedAbsolutePath(m2, e2.getDirectoryPath(le)), K = 0, b = f4; K < b.length; K++) {
                var se = b[K], J = e2.getNormalizedAbsolutePath(se, e2.getDirectoryPath(le)), ie = p(J, T);
                if (e2.isString(ie))
                  return B(Q, ie, J);
                if (ie !== void 0)
                  return ie || void 0;
              }
            }
            e2.getDocumentPositionMapper = w;
            function B(Q, le, N) {
              var p = e2.tryParseRawSourceMap(le);
              if (!(!p || !p.sources || !p.file || !p.mappings) && !(p.sourcesContent && p.sourcesContent.some(e2.isString)))
                return e2.createDocumentPositionMapper(Q, p, N);
            }
            function E(Q, le) {
              return { text: Q, lineMap: le, getLineAndCharacterOfPosition: function(N) {
                return e2.computeLineAndCharacterOfPosition(e2.getLineStarts(this), N);
              } };
            }
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a = new e2.Map();
            function C(ie, R, q) {
              R.getSemanticDiagnostics(ie, q);
              var O = [], ve = R.getTypeChecker(), ee = ie.impliedNodeFormat === e2.ModuleKind.CommonJS || e2.fileExtensionIsOneOf(ie.fileName, [".cts", ".cjs"]);
              !ee && ie.commonJsModuleIndicator && (e2.programContainsEsModules(R) || e2.compilerOptionsIndicateEsModules(R.getCompilerOptions())) && w(ie) && O.push(e2.createDiagnosticForNode(p(ie.commonJsModuleIndicator), e2.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module));
              var he = e2.isSourceFileJS(ie);
              if (a.clear(), L(ie), e2.getAllowSyntheticDefaultImports(R.getCompilerOptions()))
                for (var F2 = 0, x2 = ie.imports; F2 < x2.length; F2++) {
                  var X = x2[F2], $ = e2.importFromModuleSpecifier(X), A2 = E($);
                  if (!!A2) {
                    var y = e2.getResolvedModule(ie, X.text, e2.getModeForUsageLocation(ie, X)), V = y && R.getSourceFile(y.resolvedFileName);
                    V && V.externalModuleIndicator && V.externalModuleIndicator !== true && e2.isExportAssignment(V.externalModuleIndicator) && V.externalModuleIndicator.isExportEquals && O.push(e2.createDiagnosticForNode(A2, e2.Diagnostics.Import_may_be_converted_to_a_default_import));
                  }
                }
              return e2.addRange(O, ie.bindSuggestionDiagnostics), e2.addRange(O, R.getSuggestionDiagnostics(ie, q)), O.sort(function(P, k) {
                return P.start - k.start;
              });
              function L(P) {
                if (he)
                  se(P, ve) && O.push(e2.createDiagnosticForNode(e2.isVariableDeclaration(P.parent) ? P.parent.name : P, e2.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration));
                else {
                  if (e2.isVariableStatement(P) && P.parent === ie && P.declarationList.flags & 2 && P.declarationList.declarations.length === 1) {
                    var k = P.declarationList.declarations[0].initializer;
                    k && e2.isRequireCall(k, true) && O.push(e2.createDiagnosticForNode(k, e2.Diagnostics.require_call_may_be_converted_to_an_import));
                  }
                  e2.codefix.parameterShouldGetTypeFromJSDoc(P) && O.push(e2.createDiagnosticForNode(P.name || P, e2.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types));
                }
                J(P) && Q(P, ve, O), P.forEachChild(L);
              }
            }
            e2.computeSuggestionDiagnostics = C;
            function w(ie) {
              return ie.statements.some(function(R) {
                switch (R.kind) {
                  case 237:
                    return R.declarationList.declarations.some(function(ve) {
                      return !!ve.initializer && e2.isRequireCall(B(ve.initializer), true);
                    });
                  case 238: {
                    var q = R.expression;
                    if (!e2.isBinaryExpression(q))
                      return e2.isRequireCall(q, true);
                    var O = e2.getAssignmentDeclarationKind(q);
                    return O === 1 || O === 2;
                  }
                  default:
                    return false;
                }
              });
            }
            function B(ie) {
              return e2.isPropertyAccessExpression(ie) ? B(ie.expression) : ie;
            }
            function E(ie) {
              switch (ie.kind) {
                case 266:
                  var R = ie.importClause, q = ie.moduleSpecifier;
                  return R && !R.name && R.namedBindings && R.namedBindings.kind === 268 && e2.isStringLiteral(q) ? R.namedBindings.name : void 0;
                case 265:
                  return ie.name;
                default:
                  return;
              }
            }
            function Q(ie, R, q) {
              le(ie, R) && !a.has(b(ie)) && q.push(e2.createDiagnosticForNode(!ie.name && e2.isVariableDeclaration(ie.parent) && e2.isIdentifier(ie.parent.name) ? ie.parent.name : ie, e2.Diagnostics.This_may_be_converted_to_an_async_function));
            }
            function le(ie, R) {
              return !e2.isAsyncFunction(ie) && ie.body && e2.isBlock(ie.body) && m2(ie.body, R) && N(ie, R);
            }
            function N(ie, R) {
              var q = R.getSignatureFromDeclaration(ie), O = q ? R.getReturnTypeOfSignature(q) : void 0;
              return !!O && !!R.getPromisedTypeOfPromise(O);
            }
            e2.returnsPromise = N;
            function p(ie) {
              return e2.isBinaryExpression(ie) ? ie.left : ie;
            }
            function m2(ie, R) {
              return !!e2.forEachReturnStatement(ie, function(q) {
                return G(q, R);
              });
            }
            function G(ie, R) {
              return e2.isReturnStatement(ie) && !!ie.expression && oe(ie.expression, R);
            }
            e2.isReturnStatementWithFixablePromiseHandler = G;
            function oe(ie, R) {
              if (!f4(ie) || !T(ie) || !ie.arguments.every(function(O) {
                return K(O, R);
              }))
                return false;
              for (var q = ie.expression.expression; f4(q) || e2.isPropertyAccessExpression(q); )
                if (e2.isCallExpression(q)) {
                  if (!T(q) || !q.arguments.every(function(O) {
                    return K(O, R);
                  }))
                    return false;
                  q = q.expression.expression;
                } else
                  q = q.expression;
              return true;
            }
            e2.isFixablePromiseHandler = oe;
            function f4(ie) {
              return e2.isCallExpression(ie) && (e2.hasPropertyAccessExpressionWithName(ie, "then") || e2.hasPropertyAccessExpressionWithName(ie, "catch") || e2.hasPropertyAccessExpressionWithName(ie, "finally"));
            }
            function T(ie) {
              var R = ie.expression.name.text, q = R === "then" ? 2 : R === "catch" || R === "finally" ? 1 : 0;
              return ie.arguments.length > q ? false : ie.arguments.length < q ? true : q === 1 || e2.some(ie.arguments, function(O) {
                return O.kind === 104 || e2.isIdentifier(O) && O.text === "undefined";
              });
            }
            function K(ie, R) {
              switch (ie.kind) {
                case 256:
                case 213:
                  var q = e2.getFunctionFlags(ie);
                  if (q & 1)
                    return false;
                case 214:
                  a.set(b(ie), true);
                case 104:
                  return true;
                case 79:
                case 206: {
                  var O = R.getSymbolAtLocation(ie);
                  return O ? R.isUndefinedSymbol(O) || e2.some(e2.skipAlias(O, R).declarations, function(ve) {
                    return e2.isFunctionLike(ve) || e2.hasInitializer(ve) && !!ve.initializer && e2.isFunctionLike(ve.initializer);
                  }) : false;
                }
                default:
                  return false;
              }
            }
            function b(ie) {
              return "".concat(ie.pos.toString(), ":").concat(ie.end.toString());
            }
            function se(ie, R) {
              var q, O, ve, ee;
              if (ie.kind === 213) {
                if (e2.isVariableDeclaration(ie.parent) && ((q = ie.symbol.members) === null || q === void 0 ? void 0 : q.size))
                  return true;
                var he = R.getSymbolOfExpando(ie, false);
                return !!(he && (((O = he.exports) === null || O === void 0 ? void 0 : O.size) || ((ve = he.members) === null || ve === void 0 ? void 0 : ve.size)));
              }
              return ie.kind === 256 ? !!(!((ee = ie.symbol.members) === null || ee === void 0) && ee.size) : false;
            }
            function J(ie) {
              switch (ie.kind) {
                case 256:
                case 169:
                case 213:
                case 214:
                  return true;
                default:
                  return false;
              }
            }
            e2.canBeConvertedToAsync = J;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = 70246400;
              function B(m2, G, oe) {
                var f4 = E(m2, G, oe);
                if (f4 !== "")
                  return f4;
                var T = e2.getCombinedLocalAndExportSymbolFlags(G);
                return T & 32 ? e2.getDeclarationOfKind(G, 226) ? "local class" : "class" : T & 384 ? "enum" : T & 524288 ? "type" : T & 64 ? "interface" : T & 262144 ? "type parameter" : T & 8 ? "enum member" : T & 2097152 ? "alias" : T & 1536 ? "module" : f4;
              }
              C.getSymbolKind = B;
              function E(m2, G, oe) {
                var f4 = m2.getRootSymbols(G);
                if (f4.length === 1 && e2.first(f4).flags & 8192 && m2.getTypeOfSymbolAtLocation(G, oe).getNonNullableType().getCallSignatures().length !== 0)
                  return "method";
                if (m2.isUndefinedSymbol(G))
                  return "var";
                if (m2.isArgumentsSymbol(G))
                  return "local var";
                if (oe.kind === 108 && e2.isExpression(oe) || e2.isThisInTypeQuery(oe))
                  return "parameter";
                var T = e2.getCombinedLocalAndExportSymbolFlags(G);
                if (T & 3)
                  return e2.isFirstDeclarationOfSymbolParameter(G) ? "parameter" : G.valueDeclaration && e2.isVarConst(G.valueDeclaration) ? "const" : e2.forEach(G.declarations, e2.isLet) ? "let" : p(G) ? "local var" : "var";
                if (T & 16)
                  return p(G) ? "local function" : "function";
                if (T & 32768)
                  return "getter";
                if (T & 65536)
                  return "setter";
                if (T & 8192)
                  return "method";
                if (T & 16384)
                  return "constructor";
                if (T & 4) {
                  if (T & 33554432 && G.checkFlags & 6) {
                    var K = e2.forEach(m2.getRootSymbols(G), function(se) {
                      var J = se.getFlags();
                      if (J & 98311)
                        return "property";
                    });
                    if (!K) {
                      var b = m2.getTypeOfSymbolAtLocation(G, oe);
                      return b.getCallSignatures().length ? "method" : "property";
                    }
                    return K;
                  }
                  return "property";
                }
                return "";
              }
              function Q(m2) {
                if (m2.declarations && m2.declarations.length) {
                  var G = m2.declarations, oe = G[0], f4 = G.slice(1), T = e2.length(f4) && e2.isDeprecatedDeclaration(oe) && e2.some(f4, function(b) {
                    return !e2.isDeprecatedDeclaration(b);
                  }) ? 8192 : 0, K = e2.getNodeModifiers(oe, T);
                  if (K)
                    return K.split(",");
                }
                return [];
              }
              function le(m2, G) {
                if (!G)
                  return "";
                var oe = new e2.Set(Q(G));
                if (G.flags & 2097152) {
                  var f4 = m2.getAliasedSymbol(G);
                  f4 !== G && e2.forEach(Q(f4), function(T) {
                    oe.add(T);
                  });
                }
                return G.flags & 16777216 && oe.add("optional"), oe.size > 0 ? e2.arrayFrom(oe.values()).join(",") : "";
              }
              C.getSymbolModifiers = le;
              function N(m2, G, oe, f4, T, K, b) {
                var se;
                K === void 0 && (K = e2.getMeaningFromLocation(T));
                var J = [], ie = [], R = [], q = e2.getCombinedLocalAndExportSymbolFlags(G), O = K & 1 ? E(m2, G, T) : "", ve = false, ee = T.kind === 108 && e2.isInExpressionContext(T) || e2.isThisInTypeQuery(T), he, F2, x2, X, $ = false;
                if (T.kind === 108 && !ee)
                  return { displayParts: [e2.keywordPart(108)], documentation: [], symbolKind: "primitive type", tags: void 0 };
                if (O !== "" || q & 32 || q & 2097152) {
                  if (O === "getter" || O === "setter") {
                    var A2 = e2.find(G.declarations, function(er) {
                      return er.name === T;
                    });
                    if (A2)
                      switch (A2.kind) {
                        case 172:
                          O = "getter";
                          break;
                        case 173:
                          O = "setter";
                          break;
                        default:
                          e2.Debug.assertNever(A2);
                      }
                    else
                      O = "property";
                  }
                  var y = void 0;
                  if (he = ee ? m2.getTypeAtLocation(T) : m2.getTypeOfSymbolAtLocation(G, T), T.parent && T.parent.kind === 206) {
                    var V = T.parent.name;
                    (V === T || V && V.getFullWidth() === 0) && (T = T.parent);
                  }
                  var L = void 0;
                  if (e2.isCallOrNewExpression(T) ? L = T : (e2.isCallExpressionTarget(T) || e2.isNewExpressionTarget(T) || T.parent && (e2.isJsxOpeningLikeElement(T.parent) || e2.isTaggedTemplateExpression(T.parent)) && e2.isFunctionLike(G.valueDeclaration)) && (L = T.parent), L) {
                    y = m2.getResolvedSignature(L);
                    var P = L.kind === 209 || e2.isCallExpression(L) && L.expression.kind === 106, k = P ? he.getConstructSignatures() : he.getCallSignatures();
                    if (y && !e2.contains(k, y.target) && !e2.contains(k, y) && (y = k.length ? k[0] : void 0), y) {
                      switch (P && q & 32 ? (O = "constructor", we(he.symbol, O)) : q & 2097152 ? (O = "alias", de(O), J.push(e2.spacePart()), P && (y.flags & 4 && (J.push(e2.keywordPart(126)), J.push(e2.spacePart())), J.push(e2.keywordPart(103)), J.push(e2.spacePart())), _e(G)) : we(G, O), O) {
                        case "JSX attribute":
                        case "property":
                        case "var":
                        case "const":
                        case "let":
                        case "parameter":
                        case "local var":
                          J.push(e2.punctuationPart(58)), J.push(e2.spacePart()), !(e2.getObjectFlags(he) & 16) && he.symbol && (e2.addRange(J, e2.symbolToDisplayParts(m2, he.symbol, f4, void 0, 5)), J.push(e2.lineBreakPart())), P && (y.flags & 4 && (J.push(e2.keywordPart(126)), J.push(e2.spacePart())), J.push(e2.keywordPart(103)), J.push(e2.spacePart())), ye(y, k, 262144);
                          break;
                        default:
                          ye(y, k);
                      }
                      ve = true, $ = k.length > 1;
                    }
                  } else if (e2.isNameOfFunctionDeclaration(T) && !(q & 98304) || T.kind === 134 && T.parent.kind === 171) {
                    var Y = T.parent, U = G.declarations && e2.find(G.declarations, function(er) {
                      return er === (T.kind === 134 ? Y.parent : Y);
                    });
                    if (U) {
                      var k = Y.kind === 171 ? he.getNonNullableType().getConstructSignatures() : he.getNonNullableType().getCallSignatures();
                      m2.isImplementationOfOverload(Y) ? y = k[0] : y = m2.getSignatureFromDeclaration(Y), Y.kind === 171 ? (O = "constructor", we(he.symbol, O)) : we(Y.kind === 174 && !(he.symbol.flags & 2048 || he.symbol.flags & 4096) ? he.symbol : G, O), y && ye(y, k), ve = true, $ = k.length > 1;
                    }
                  }
                }
                if (q & 32 && !ve && !ee && (rr(), e2.getDeclarationOfKind(G, 226) ? de("local class") : J.push(e2.keywordPart(84)), J.push(e2.spacePart()), _e(G), Ae(G, oe)), q & 64 && K & 2 && (He(), J.push(e2.keywordPart(118)), J.push(e2.spacePart()), _e(G), Ae(G, oe)), q & 524288 && K & 2 && (He(), J.push(e2.keywordPart(152)), J.push(e2.spacePart()), _e(G), Ae(G, oe), J.push(e2.spacePart()), J.push(e2.operatorPart(63)), J.push(e2.spacePart()), e2.addRange(J, e2.typeToDisplayParts(m2, e2.isConstTypeReference(T.parent) ? m2.getTypeAtLocation(T.parent) : m2.getDeclaredTypeOfSymbol(G), f4, 8388608))), q & 384 && (He(), e2.some(G.declarations, function(er) {
                  return e2.isEnumDeclaration(er) && e2.isEnumConst(er);
                }) && (J.push(e2.keywordPart(85)), J.push(e2.spacePart())), J.push(e2.keywordPart(92)), J.push(e2.spacePart()), _e(G)), q & 1536 && !ee) {
                  He();
                  var A2 = e2.getDeclarationOfKind(G, 261), j = A2 && A2.name && A2.name.kind === 79;
                  J.push(e2.keywordPart(j ? 142 : 141)), J.push(e2.spacePart()), _e(G);
                }
                if (q & 262144 && K & 2)
                  if (He(), J.push(e2.punctuationPart(20)), J.push(e2.textPart("type parameter")), J.push(e2.punctuationPart(21)), J.push(e2.spacePart()), _e(G), G.parent)
                    Ie(), _e(G.parent, f4), Ae(G.parent, f4);
                  else {
                    var H = e2.getDeclarationOfKind(G, 163);
                    if (H === void 0)
                      return e2.Debug.fail();
                    var A2 = H.parent;
                    if (A2)
                      if (e2.isFunctionLikeKind(A2.kind)) {
                        Ie();
                        var y = m2.getSignatureFromDeclaration(A2);
                        A2.kind === 175 ? (J.push(e2.keywordPart(103)), J.push(e2.spacePart())) : A2.kind !== 174 && A2.name && _e(A2.symbol), e2.addRange(J, e2.signatureToDisplayParts(m2, y, oe, 32));
                      } else
                        A2.kind === 259 && (Ie(), J.push(e2.keywordPart(152)), J.push(e2.spacePart()), _e(A2.symbol), Ae(A2.symbol, oe));
                  }
                if (q & 8) {
                  O = "enum member", we(G, "enum member");
                  var A2 = (se = G.declarations) === null || se === void 0 ? void 0 : se[0];
                  if ((A2 == null ? void 0 : A2.kind) === 299) {
                    var I = m2.getConstantValue(A2);
                    I !== void 0 && (J.push(e2.spacePart()), J.push(e2.operatorPart(63)), J.push(e2.spacePart()), J.push(e2.displayPart(e2.getTextOfConstantValue(I), typeof I == "number" ? e2.SymbolDisplayPartKind.numericLiteral : e2.SymbolDisplayPartKind.stringLiteral)));
                  }
                }
                if (G.flags & 2097152) {
                  if (He(), !ve) {
                    var l = m2.getAliasedSymbol(G);
                    if (l !== G && l.declarations && l.declarations.length > 0) {
                      var d = l.declarations[0], D = e2.getNameOfDeclaration(d);
                      if (D) {
                        var fe = e2.isModuleWithStringLiteralName(d) && e2.hasSyntacticModifier(d, 2), g = G.name !== "default" && !fe, ne = N(m2, l, e2.getSourceFileOfNode(d), d, D, K, g ? G : l);
                        J.push.apply(J, ne.displayParts), J.push(e2.lineBreakPart()), x2 = ne.documentation, X = ne.tags;
                      } else
                        x2 = l.getContextualDocumentationComment(d, m2), X = l.getJsDocTags(m2);
                    }
                  }
                  if (G.declarations)
                    switch (G.declarations[0].kind) {
                      case 264:
                        J.push(e2.keywordPart(93)), J.push(e2.spacePart()), J.push(e2.keywordPart(142));
                        break;
                      case 271:
                        J.push(e2.keywordPart(93)), J.push(e2.spacePart()), J.push(e2.keywordPart(G.declarations[0].isExportEquals ? 63 : 88));
                        break;
                      case 275:
                        J.push(e2.keywordPart(93));
                        break;
                      default:
                        J.push(e2.keywordPart(100));
                    }
                  J.push(e2.spacePart()), _e(G), e2.forEach(G.declarations, function(er) {
                    if (er.kind === 265) {
                      var ir = er;
                      if (e2.isExternalModuleImportEqualsDeclaration(ir))
                        J.push(e2.spacePart()), J.push(e2.operatorPart(63)), J.push(e2.spacePart()), J.push(e2.keywordPart(146)), J.push(e2.punctuationPart(20)), J.push(e2.displayPart(e2.getTextOfNode(e2.getExternalModuleImportEqualsDeclarationExpression(ir)), e2.SymbolDisplayPartKind.stringLiteral)), J.push(e2.punctuationPart(21));
                      else {
                        var Cr = m2.getSymbolAtLocation(ir.moduleReference);
                        Cr && (J.push(e2.spacePart()), J.push(e2.operatorPart(63)), J.push(e2.spacePart()), _e(Cr, f4));
                      }
                      return true;
                    }
                  });
                }
                if (!ve)
                  if (O !== "") {
                    if (he) {
                      if (ee ? (He(), J.push(e2.keywordPart(108))) : we(G, O), O === "property" || O === "getter" || O === "setter" || O === "JSX attribute" || q & 3 || O === "local var" || ee) {
                        if (J.push(e2.punctuationPart(58)), J.push(e2.spacePart()), he.symbol && he.symbol.flags & 262144) {
                          var ue = e2.mapToDisplayParts(function(er) {
                            var ir = m2.typeParameterToDeclaration(he, f4, w);
                            Ee().writeNode(4, ir, e2.getSourceFileOfNode(e2.getParseTreeNode(f4)), er);
                          });
                          e2.addRange(J, ue);
                        } else
                          e2.addRange(J, e2.typeToDisplayParts(m2, he, f4));
                        if (G.target && G.target.tupleLabelDeclaration) {
                          var We = G.target.tupleLabelDeclaration;
                          e2.Debug.assertNode(We.name, e2.isIdentifier), J.push(e2.spacePart()), J.push(e2.punctuationPart(20)), J.push(e2.textPart(e2.idText(We.name))), J.push(e2.punctuationPart(21));
                        }
                      } else if (q & 16 || q & 8192 || q & 16384 || q & 131072 || q & 98304 || O === "method") {
                        var k = he.getNonNullableType().getCallSignatures();
                        k.length && (ye(k[0], k), $ = k.length > 1);
                      }
                    }
                  } else
                    O = B(m2, G, T);
                if (ie.length === 0 && !$ && (ie = G.getContextualDocumentationComment(f4, m2)), ie.length === 0 && q & 4 && G.parent && G.declarations && e2.forEach(G.parent.declarations, function(er) {
                  return er.kind === 305;
                }))
                  for (var Fe = 0, Z2 = G.declarations; Fe < Z2.length; Fe++) {
                    var A2 = Z2[Fe];
                    if (!(!A2.parent || A2.parent.kind !== 221)) {
                      var Be = m2.getSymbolAtLocation(A2.parent.right);
                      if (!!Be && (ie = Be.getDocumentationComment(m2), R = Be.getJsDocTags(m2), ie.length > 0))
                        break;
                    }
                  }
                if (ie.length === 0 && e2.isIdentifier(T) && G.valueDeclaration && e2.isBindingElement(G.valueDeclaration)) {
                  var A2 = G.valueDeclaration, ge = A2.parent;
                  if (e2.isIdentifier(A2.name) && e2.isObjectBindingPattern(ge)) {
                    var Re = e2.getTextOfIdentifierOrLiteral(A2.name), ze = m2.getTypeAtLocation(ge);
                    ie = e2.firstDefined(ze.isUnion() ? ze.types : [ze], function(ir) {
                      var Cr = ir.getProperty(Re);
                      return Cr ? Cr.getDocumentationComment(m2) : void 0;
                    }) || e2.emptyArray;
                  }
                }
                return R.length === 0 && !$ && (R = G.getContextualJsDocTags(f4, m2)), ie.length === 0 && x2 && (ie = x2), R.length === 0 && X && (R = X), { displayParts: J, documentation: ie, symbolKind: O, tags: R.length === 0 ? void 0 : R };
                function Ee() {
                  return F2 || (F2 = e2.createPrinter({ removeComments: true })), F2;
                }
                function He() {
                  J.length && J.push(e2.lineBreakPart()), rr();
                }
                function rr() {
                  b && (de("alias"), J.push(e2.spacePart()));
                }
                function Ie() {
                  J.push(e2.spacePart()), J.push(e2.keywordPart(101)), J.push(e2.spacePart());
                }
                function _e(er, ir) {
                  b && er === G && (er = b);
                  var Cr = e2.symbolToDisplayParts(m2, er, ir || oe, void 0, 7);
                  e2.addRange(J, Cr), G.flags & 16777216 && J.push(e2.punctuationPart(57));
                }
                function we(er, ir) {
                  He(), ir && (de(ir), er && !e2.some(er.declarations, function(Cr) {
                    return e2.isArrowFunction(Cr) || (e2.isFunctionExpression(Cr) || e2.isClassExpression(Cr)) && !Cr.name;
                  }) && (J.push(e2.spacePart()), _e(er)));
                }
                function de(er) {
                  switch (er) {
                    case "var":
                    case "function":
                    case "let":
                    case "const":
                    case "constructor":
                      J.push(e2.textOrKeywordPart(er));
                      return;
                    default:
                      J.push(e2.punctuationPart(20)), J.push(e2.textOrKeywordPart(er)), J.push(e2.punctuationPart(21));
                      return;
                  }
                }
                function ye(er, ir, Cr) {
                  Cr === void 0 && (Cr = 0), e2.addRange(J, e2.signatureToDisplayParts(m2, er, f4, Cr | 32)), ir.length > 1 && (J.push(e2.spacePart()), J.push(e2.punctuationPart(20)), J.push(e2.operatorPart(39)), J.push(e2.displayPart((ir.length - 1).toString(), e2.SymbolDisplayPartKind.numericLiteral)), J.push(e2.spacePart()), J.push(e2.textPart(ir.length === 2 ? "overload" : "overloads")), J.push(e2.punctuationPart(21))), ie = er.getDocumentationComment(m2), R = er.getJsDocTags(), ir.length > 1 && ie.length === 0 && R.length === 0 && (ie = ir[0].getDocumentationComment(m2), R = ir[0].getJsDocTags());
                }
                function Ae(er, ir) {
                  var Cr = e2.mapToDisplayParts(function(Ye) {
                    var Br = m2.symbolToTypeParameterDeclarations(er, ir, w);
                    Ee().writeList(53776, Br, e2.getSourceFileOfNode(e2.getParseTreeNode(ir)), Ye);
                  });
                  e2.addRange(J, Cr);
                }
              }
              C.getSymbolDisplayPartsDocumentationAndSymbolKind = N;
              function p(m2) {
                return m2.parent ? false : e2.forEach(m2.declarations, function(G) {
                  if (G.kind === 213)
                    return true;
                  if (G.kind !== 254 && G.kind !== 256)
                    return false;
                  for (var oe = G.parent; !e2.isFunctionBlock(oe); oe = oe.parent)
                    if (oe.kind === 305 || oe.kind === 262)
                      return false;
                  return true;
                });
              }
            })(a = e2.SymbolDisplay || (e2.SymbolDisplay = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(E, Q) {
              var le = [], N = Q.compilerOptions ? B(Q.compilerOptions, le) : {}, p = e2.getDefaultCompilerOptions();
              for (var m2 in p)
                e2.hasProperty(p, m2) && N[m2] === void 0 && (N[m2] = p[m2]);
              for (var G = 0, oe = e2.transpileOptionValueCompilerOptions; G < oe.length; G++) {
                var f4 = oe[G];
                N[f4.name] = f4.transpileOptionValue;
              }
              N.suppressOutputPathCheck = true, N.allowNonTsExtensions = true;
              var T = e2.getNewLineCharacter(N), K = { getSourceFile: function(q) {
                return q === e2.normalizePath(b) ? se : void 0;
              }, writeFile: function(q, O) {
                e2.fileExtensionIs(q, ".map") ? (e2.Debug.assertEqual(ie, void 0, "Unexpected multiple source map outputs, file:", q), ie = O) : (e2.Debug.assertEqual(J, void 0, "Unexpected multiple outputs, file:", q), J = O);
              }, getDefaultLibFileName: function() {
                return "lib.d.ts";
              }, useCaseSensitiveFileNames: function() {
                return false;
              }, getCanonicalFileName: function(q) {
                return q;
              }, getCurrentDirectory: function() {
                return "";
              }, getNewLine: function() {
                return T;
              }, fileExists: function(q) {
                return q === b;
              }, readFile: function() {
                return "";
              }, directoryExists: function() {
                return true;
              }, getDirectories: function() {
                return [];
              } }, b = Q.fileName || (Q.compilerOptions && Q.compilerOptions.jsx ? "module.tsx" : "module.ts"), se = e2.createSourceFile(b, E, { languageVersion: e2.getEmitScriptTarget(N), impliedNodeFormat: e2.getImpliedNodeFormatForFile(e2.toPath(b, "", K.getCanonicalFileName), void 0, K, N), setExternalModuleIndicator: e2.getSetExternalModuleIndicator(N) });
              Q.moduleName && (se.moduleName = Q.moduleName), Q.renamedDependencies && (se.renamedDependencies = new e2.Map(e2.getEntries(Q.renamedDependencies)));
              var J, ie, R = e2.createProgram([b], N, K);
              return Q.reportDiagnostics && (e2.addRange(le, R.getSyntacticDiagnostics(se)), e2.addRange(le, R.getOptionsDiagnostics())), R.emit(void 0, void 0, void 0, void 0, Q.transformers), J === void 0 ? e2.Debug.fail("Output generation failed") : { outputText: J, diagnostics: le, sourceMapText: ie };
            }
            e2.transpileModule = a;
            function C(E, Q, le, N, p) {
              var m2 = a(E, { compilerOptions: Q, fileName: le, reportDiagnostics: !!N, moduleName: p });
              return e2.addRange(N, m2.diagnostics), m2.outputText;
            }
            e2.transpile = C;
            var w;
            function B(E, Q) {
              w = w || e2.filter(e2.optionDeclarations, function(G) {
                return typeof G.type == "object" && !e2.forEachEntry(G.type, function(oe) {
                  return typeof oe != "number";
                });
              }), E = e2.cloneCompilerOptions(E);
              for (var le = function(G) {
                if (!e2.hasProperty(E, G.name))
                  return "continue";
                var oe = E[G.name];
                e2.isString(oe) ? E[G.name] = e2.parseCustomTypeOption(G, oe, Q) : e2.forEachEntry(G.type, function(f4) {
                  return f4 === oe;
                }) || Q.push(e2.createCompilerDiagnosticForInvalidCustomType(G));
              }, N = 0, p = w; N < p.length; N++) {
                var m2 = p[N];
                le(m2);
              }
              return E;
            }
            e2.fixupCompilerOptions = B;
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(E) {
                E[E.FormatDocument = 0] = "FormatDocument", E[E.FormatSelection = 1] = "FormatSelection", E[E.FormatOnEnter = 2] = "FormatOnEnter", E[E.FormatOnSemicolon = 3] = "FormatOnSemicolon", E[E.FormatOnOpeningCurlyBrace = 4] = "FormatOnOpeningCurlyBrace", E[E.FormatOnClosingCurlyBrace = 5] = "FormatOnClosingCurlyBrace";
              })(w = C.FormattingRequestKind || (C.FormattingRequestKind = {}));
              var B = function() {
                function E(Q, le, N) {
                  this.sourceFile = Q, this.formattingRequestKind = le, this.options = N;
                }
                return E.prototype.updateContext = function(Q, le, N, p, m2) {
                  this.currentTokenSpan = e2.Debug.checkDefined(Q), this.currentTokenParent = e2.Debug.checkDefined(le), this.nextTokenSpan = e2.Debug.checkDefined(N), this.nextTokenParent = e2.Debug.checkDefined(p), this.contextNode = e2.Debug.checkDefined(m2), this.contextNodeAllOnSameLine = void 0, this.nextNodeAllOnSameLine = void 0, this.tokensAreOnSameLine = void 0, this.contextNodeBlockIsOnOneLine = void 0, this.nextNodeBlockIsOnOneLine = void 0;
                }, E.prototype.ContextNodeAllOnSameLine = function() {
                  return this.contextNodeAllOnSameLine === void 0 && (this.contextNodeAllOnSameLine = this.NodeIsOnOneLine(this.contextNode)), this.contextNodeAllOnSameLine;
                }, E.prototype.NextNodeAllOnSameLine = function() {
                  return this.nextNodeAllOnSameLine === void 0 && (this.nextNodeAllOnSameLine = this.NodeIsOnOneLine(this.nextTokenParent)), this.nextNodeAllOnSameLine;
                }, E.prototype.TokensAreOnSameLine = function() {
                  if (this.tokensAreOnSameLine === void 0) {
                    var Q = this.sourceFile.getLineAndCharacterOfPosition(this.currentTokenSpan.pos).line, le = this.sourceFile.getLineAndCharacterOfPosition(this.nextTokenSpan.pos).line;
                    this.tokensAreOnSameLine = Q === le;
                  }
                  return this.tokensAreOnSameLine;
                }, E.prototype.ContextNodeBlockIsOnOneLine = function() {
                  return this.contextNodeBlockIsOnOneLine === void 0 && (this.contextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.contextNode)), this.contextNodeBlockIsOnOneLine;
                }, E.prototype.NextNodeBlockIsOnOneLine = function() {
                  return this.nextNodeBlockIsOnOneLine === void 0 && (this.nextNodeBlockIsOnOneLine = this.BlockIsOnOneLine(this.nextTokenParent)), this.nextNodeBlockIsOnOneLine;
                }, E.prototype.NodeIsOnOneLine = function(Q) {
                  var le = this.sourceFile.getLineAndCharacterOfPosition(Q.getStart(this.sourceFile)).line, N = this.sourceFile.getLineAndCharacterOfPosition(Q.getEnd()).line;
                  return le === N;
                }, E.prototype.BlockIsOnOneLine = function(Q) {
                  var le = e2.findChildOfKind(Q, 18, this.sourceFile), N = e2.findChildOfKind(Q, 19, this.sourceFile);
                  if (le && N) {
                    var p = this.sourceFile.getLineAndCharacterOfPosition(le.getEnd()).line, m2 = this.sourceFile.getLineAndCharacterOfPosition(N.getStart(this.sourceFile)).line;
                    return p === m2;
                  }
                  return false;
                }, E;
              }();
              C.FormattingContext = B;
            })(a = e2.formatting || (e2.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = e2.createScanner(99, false, 0), B = e2.createScanner(99, false, 1), E;
              (function(le) {
                le[le.Scan = 0] = "Scan", le[le.RescanGreaterThanToken = 1] = "RescanGreaterThanToken", le[le.RescanSlashToken = 2] = "RescanSlashToken", le[le.RescanTemplateToken = 3] = "RescanTemplateToken", le[le.RescanJsxIdentifier = 4] = "RescanJsxIdentifier", le[le.RescanJsxText = 5] = "RescanJsxText", le[le.RescanJsxAttributeValue = 6] = "RescanJsxAttributeValue";
              })(E || (E = {}));
              function Q(le, N, p, m2, G) {
                var oe = N === 1 ? B : w;
                oe.setText(le), oe.setTextPos(p);
                var f4 = true, T, K, b, se, J, ie = G({ advance: R, readTokenInfo: X, readEOFTokenRange: A2, isOnToken: y, isOnEOF: V, getCurrentLeadingTrivia: function() {
                  return T;
                }, lastTrailingTriviaWasNewLine: function() {
                  return f4;
                }, skipToEndOf: P, skipToStartOf: k, getStartPos: function() {
                  var Y;
                  return (Y = J == null ? void 0 : J.token.pos) !== null && Y !== void 0 ? Y : oe.getTokenPos();
                } });
                return J = void 0, oe.setText(void 0), ie;
                function R() {
                  J = void 0;
                  var Y = oe.getStartPos() !== p;
                  Y ? f4 = !!K && e2.last(K).kind === 4 : oe.scan(), T = void 0, K = void 0;
                  for (var U = oe.getStartPos(); U < m2; ) {
                    var j = oe.getToken();
                    if (!e2.isTrivia(j))
                      break;
                    oe.scan();
                    var H = { pos: U, end: oe.getStartPos(), kind: j };
                    U = oe.getStartPos(), T = e2.append(T, H);
                  }
                  b = oe.getStartPos();
                }
                function q(Y) {
                  switch (Y.kind) {
                    case 33:
                    case 71:
                    case 72:
                    case 49:
                    case 48:
                      return true;
                  }
                  return false;
                }
                function O(Y) {
                  if (Y.parent)
                    switch (Y.parent.kind) {
                      case 285:
                      case 280:
                      case 281:
                      case 279:
                        return e2.isKeyword(Y.kind) || Y.kind === 79;
                    }
                  return false;
                }
                function ve(Y) {
                  return e2.isJsxText(Y);
                }
                function ee(Y) {
                  return Y.kind === 13;
                }
                function he(Y) {
                  return Y.kind === 16 || Y.kind === 17;
                }
                function F2(Y) {
                  return Y.parent && e2.isJsxAttribute(Y.parent) && Y.parent.initializer === Y;
                }
                function x2(Y) {
                  return Y === 43 || Y === 68;
                }
                function X(Y) {
                  e2.Debug.assert(y());
                  var U = q(Y) ? 1 : ee(Y) ? 2 : he(Y) ? 3 : O(Y) ? 4 : ve(Y) ? 5 : F2(Y) ? 6 : 0;
                  if (J && U === se)
                    return L(J, Y);
                  oe.getStartPos() !== b && (e2.Debug.assert(J !== void 0), oe.setTextPos(b), oe.scan());
                  var j = $(Y, U), H = C.createTextRangeWithKind(oe.getStartPos(), oe.getTextPos(), j);
                  for (K && (K = void 0); oe.getStartPos() < m2 && (j = oe.scan(), !!e2.isTrivia(j)); ) {
                    var I = C.createTextRangeWithKind(oe.getStartPos(), oe.getTextPos(), j);
                    if (K || (K = []), K.push(I), j === 4) {
                      oe.scan();
                      break;
                    }
                  }
                  return J = { leadingTrivia: T, trailingTrivia: K, token: H }, L(J, Y);
                }
                function $(Y, U) {
                  var j = oe.getToken();
                  switch (se = 0, U) {
                    case 1:
                      if (j === 31) {
                        se = 1;
                        var H = oe.reScanGreaterToken();
                        return e2.Debug.assert(Y.kind === H), H;
                      }
                      break;
                    case 2:
                      if (x2(j)) {
                        se = 2;
                        var H = oe.reScanSlashToken();
                        return e2.Debug.assert(Y.kind === H), H;
                      }
                      break;
                    case 3:
                      if (j === 19)
                        return se = 3, oe.reScanTemplateToken(false);
                      break;
                    case 4:
                      return se = 4, oe.scanJsxIdentifier();
                    case 5:
                      return se = 5, oe.reScanJsxToken(false);
                    case 6:
                      return se = 6, oe.reScanJsxAttributeValue();
                    case 0:
                      break;
                    default:
                      e2.Debug.assertNever(U);
                  }
                  return j;
                }
                function A2() {
                  return e2.Debug.assert(V()), C.createTextRangeWithKind(oe.getStartPos(), oe.getTextPos(), 1);
                }
                function y() {
                  var Y = J ? J.token.kind : oe.getToken();
                  return Y !== 1 && !e2.isTrivia(Y);
                }
                function V() {
                  var Y = J ? J.token.kind : oe.getToken();
                  return Y === 1;
                }
                function L(Y, U) {
                  return e2.isToken(U) && Y.token.kind !== U.kind && (Y.token.kind = U.kind), Y;
                }
                function P(Y) {
                  oe.setTextPos(Y.end), b = oe.getStartPos(), se = void 0, J = void 0, f4 = false, T = void 0, K = void 0;
                }
                function k(Y) {
                  oe.setTextPos(Y.pos), b = oe.getStartPos(), se = void 0, J = void 0, f4 = false, T = void 0, K = void 0;
                }
              }
              C.getFormattingScanner = Q;
            })(a = e2.formatting || (e2.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              C.anyContext = e2.emptyArray;
              var w;
              (function(E) {
                E[E.StopProcessingSpaceActions = 1] = "StopProcessingSpaceActions", E[E.StopProcessingTokenActions = 2] = "StopProcessingTokenActions", E[E.InsertSpace = 4] = "InsertSpace", E[E.InsertNewLine = 8] = "InsertNewLine", E[E.DeleteSpace = 16] = "DeleteSpace", E[E.DeleteToken = 32] = "DeleteToken", E[E.InsertTrailingSemicolon = 64] = "InsertTrailingSemicolon", E[E.StopAction = 3] = "StopAction", E[E.ModifySpaceAction = 28] = "ModifySpaceAction", E[E.ModifyTokenAction = 96] = "ModifyTokenAction";
              })(w = C.RuleAction || (C.RuleAction = {}));
              var B;
              (function(E) {
                E[E.None = 0] = "None", E[E.CanDeleteNewLines = 1] = "CanDeleteNewLines";
              })(B = C.RuleFlags || (C.RuleFlags = {}));
            })(a = e2.formatting || (e2.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w() {
                for (var Ne = [], n = 0; n <= 160; n++)
                  n !== 1 && Ne.push(n);
                function lr() {
                  for (var _r = [], pi = 0; pi < arguments.length; pi++)
                    _r[pi] = arguments[pi];
                  return { tokens: Ne.filter(function(ae) {
                    return !_r.some(function(Xe) {
                      return Xe === ae;
                    });
                  }), isSpecific: false };
                }
                var be = { tokens: Ne, isSpecific: false }, Ge = E(Ve(Ve([], Ne, true), [3], false)), ur = E(Ve(Ve([], Ne, true), [1], false)), yr = le(81, 160), Ir = le(29, 78), wr = [101, 102, 160, 127, 139], Ur = [45, 46, 54, 53], ii = [8, 9, 79, 20, 22, 18, 108, 103], mi = [79, 20, 108, 103], pe = [79, 21, 23, 103], or = [79, 20, 108, 103], qr = [79, 21, 23, 103], si = [2, 3], Di = Ve([79], e2.typeKeywords, true), wi = Ge, Xi = E([79, 3, 84, 93, 100]), et = E([21, 3, 90, 111, 96, 91]), Gi = [B("IgnoreBeforeComment", be, si, C.anyContext, 1), B("IgnoreAfterLineComment", 2, be, C.anyContext, 1), B("NotSpaceBeforeColon", be, 58, [g, se, J], 16), B("SpaceAfterColon", 58, be, [g, se], 4), B("NoSpaceBeforeQuestionMark", be, 57, [g, se, J], 16), B("SpaceAfterQuestionMarkInConditionalOperator", 57, be, [g, R], 4), B("NoSpaceAfterQuestionMark", 57, be, [g], 16), B("NoSpaceBeforeDot", be, [24, 28], [g], 16), B("NoSpaceAfterDot", [24, 28], be, [g], 16), B("NoSpaceBetweenImportParenInImportType", 100, 20, [g, fe], 16), B("NoSpaceAfterUnaryPrefixOperator", Ur, ii, [g, se], 16), B("NoSpaceAfterUnaryPreincrementOperator", 45, mi, [g], 16), B("NoSpaceAfterUnaryPredecrementOperator", 46, or, [g], 16), B("NoSpaceBeforeUnaryPostincrementOperator", pe, 45, [g, Cr], 16), B("NoSpaceBeforeUnaryPostdecrementOperator", qr, 46, [g, Cr], 16), B("SpaceAfterPostincrementWhenFollowedByAdd", 45, 39, [g, b], 4), B("SpaceAfterAddWhenFollowedByUnaryPlus", 39, 39, [g, b], 4), B("SpaceAfterAddWhenFollowedByPreincrement", 39, 45, [g, b], 4), B("SpaceAfterPostdecrementWhenFollowedBySubtract", 46, 40, [g, b], 4), B("SpaceAfterSubtractWhenFollowedByUnaryMinus", 40, 40, [g, b], 4), B("SpaceAfterSubtractWhenFollowedByPredecrement", 40, 46, [g, b], 4), B("NoSpaceAfterCloseBrace", 19, [27, 26], [g], 16), B("NewLineBeforeCloseBraceInBlockContext", Ge, 19, [ee], 8), B("SpaceAfterCloseBrace", 19, lr(21), [g, P], 4), B("SpaceBetweenCloseBraceAndElse", 19, 91, [g], 4), B("SpaceBetweenCloseBraceAndWhile", 19, 115, [g], 4), B("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [g, Y], 16), B("SpaceAfterConditionalClosingParen", 21, 22, [k], 4), B("NoSpaceBetweenFunctionKeywordAndStar", 98, 41, [y], 16), B("SpaceAfterStarInGeneratorDeclaration", 41, 79, [y], 4), B("SpaceAfterFunctionInFuncDecl", 98, be, [$], 4), B("NewLineAfterOpenBraceInBlockContext", 18, be, [ee], 8), B("SpaceAfterGetSetInMember", [136, 149], 79, [$], 4), B("NoSpaceBetweenYieldKeywordAndStar", 125, 41, [g, er], 16), B("SpaceBetweenYieldOrYieldStarAndOperand", [125, 41], be, [g, er], 4), B("NoSpaceBetweenReturnAndSemicolon", 105, 26, [g], 16), B("SpaceAfterCertainKeywords", [113, 109, 103, 89, 105, 112, 132], be, [g], 4), B("SpaceAfterLetConstInVariableDeclaration", [119, 85], be, [g, Ee], 4), B("NoSpaceBeforeOpenParenInFuncCall", be, 20, [g, H, I], 16), B("SpaceBeforeBinaryKeywordOperator", be, wr, [g, b], 4), B("SpaceAfterBinaryKeywordOperator", wr, be, [g, b], 4), B("SpaceAfterVoidOperator", 114, be, [g, Ae], 4), B("SpaceBetweenAsyncAndOpenParen", 131, 20, [D, g], 4), B("SpaceBetweenAsyncAndFunctionKeyword", 131, [98, 79], [g], 4), B("NoSpaceBetweenTagAndTemplateString", [79, 21], [14, 15], [g], 16), B("SpaceBeforeJsxAttribute", be, 79, [Fe, g], 4), B("SpaceBeforeSlashInJsxOpeningElement", be, 43, [Be, g], 4), B("NoSpaceBeforeGreaterThanTokenInJsxOpeningElement", 43, 31, [Be, g], 16), B("NoSpaceBeforeEqualInJsxAttribute", be, 63, [Z2, g], 16), B("NoSpaceAfterEqualInJsxAttribute", 63, be, [Z2, g], 16), B("NoSpaceAfterModuleImport", [141, 146], 20, [g], 16), B("SpaceAfterCertainTypeScriptKeywords", [126, 84, 135, 88, 92, 93, 94, 136, 117, 100, 118, 141, 142, 121, 123, 122, 145, 149, 124, 152, 156, 140, 137], be, [g], 4), B("SpaceBeforeCertainTypeScriptKeywords", be, [94, 117, 156], [g], 4), B("SpaceAfterModuleName", 10, 18, [rr], 4), B("SpaceBeforeArrow", be, 38, [g], 4), B("SpaceAfterArrow", 38, be, [g], 4), B("NoSpaceAfterEllipsis", 25, 79, [g], 16), B("NoSpaceAfterOptionalParameters", 57, [21, 27], [g, se], 16), B("NoSpaceBetweenEmptyInterfaceBraceBrackets", 18, 19, [g, Ie], 16), B("NoSpaceBeforeOpenAngularBracket", Di, 29, [g, de], 16), B("NoSpaceBetweenCloseParenAndAngularBracket", 21, 29, [g, de], 16), B("NoSpaceAfterOpenAngularBracket", 29, be, [g, de], 16), B("NoSpaceBeforeCloseAngularBracket", be, 31, [g, de], 16), B("NoSpaceAfterCloseAngularBracket", 31, [20, 22, 31, 27], [g, de, A2], 16), B("SpaceBeforeAt", [21, 79], 59, [g], 4), B("NoSpaceAfterAt", 59, be, [g], 16), B("SpaceAfterDecorator", be, [126, 79, 93, 88, 84, 124, 123, 121, 122, 136, 149, 22, 41], [Re], 4), B("NoSpaceBeforeNonNullAssertionOperator", be, 53, [g, ir], 16), B("NoSpaceAfterNewKeywordOnConstructorSignature", 103, 20, [g, _e], 16), B("SpaceLessThanAndNonJSXTypeAnnotation", 29, 29, [g], 4)], Wt = [B("SpaceAfterConstructor", 134, 20, [p("insertSpaceAfterConstructor"), g], 4), B("NoSpaceAfterConstructor", 134, 20, [G("insertSpaceAfterConstructor"), g], 16), B("SpaceAfterComma", 27, be, [p("insertSpaceAfterCommaDelimiter"), g, ue, l, d], 4), B("NoSpaceAfterComma", 27, be, [G("insertSpaceAfterCommaDelimiter"), g, ue], 16), B("SpaceAfterAnonymousFunctionKeyword", [98, 41], 20, [p("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), $], 4), B("NoSpaceAfterAnonymousFunctionKeyword", [98, 41], 20, [G("insertSpaceAfterFunctionKeywordForAnonymousFunctions"), $], 16), B("SpaceAfterKeywordInControl", yr, 20, [p("insertSpaceAfterKeywordsInControlFlowStatements"), k], 4), B("NoSpaceAfterKeywordInControl", yr, 20, [G("insertSpaceAfterKeywordsInControlFlowStatements"), k], 16), B("SpaceAfterOpenParen", 20, be, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 4), B("SpaceBeforeCloseParen", be, 21, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 4), B("SpaceBetweenOpenParens", 20, 20, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 4), B("NoSpaceBetweenParens", 20, 21, [g], 16), B("NoSpaceAfterOpenParen", 20, be, [G("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 16), B("NoSpaceBeforeCloseParen", be, 21, [G("insertSpaceAfterOpeningAndBeforeClosingNonemptyParenthesis"), g], 16), B("SpaceAfterOpenBracket", 22, be, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), g], 4), B("SpaceBeforeCloseBracket", be, 23, [p("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), g], 4), B("NoSpaceBetweenBrackets", 22, 23, [g], 16), B("NoSpaceAfterOpenBracket", 22, be, [G("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), g], 16), B("NoSpaceBeforeCloseBracket", be, 23, [G("insertSpaceAfterOpeningAndBeforeClosingNonemptyBrackets"), g], 16), B("SpaceAfterOpenBrace", 18, be, [f4("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), O], 4), B("SpaceBeforeCloseBrace", be, 19, [f4("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), O], 4), B("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [g, Y], 16), B("NoSpaceAfterOpenBrace", 18, be, [m2("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), g], 16), B("NoSpaceBeforeCloseBrace", be, 19, [m2("insertSpaceAfterOpeningAndBeforeClosingNonemptyBraces"), g], 16), B("SpaceBetweenEmptyBraceBrackets", 18, 19, [p("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces")], 4), B("NoSpaceBetweenEmptyBraceBrackets", 18, 19, [m2("insertSpaceAfterOpeningAndBeforeClosingEmptyBraces"), g], 16), B("SpaceAfterTemplateHeadAndMiddle", [15, 16], be, [p("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), ne], 4, 1), B("SpaceBeforeTemplateMiddleAndTail", be, [16, 17], [p("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), g], 4), B("NoSpaceAfterTemplateHeadAndMiddle", [15, 16], be, [G("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), ne], 16, 1), B("NoSpaceBeforeTemplateMiddleAndTail", be, [16, 17], [G("insertSpaceAfterOpeningAndBeforeClosingTemplateStringBraces"), g], 16), B("SpaceAfterOpenBraceInJsxExpression", 18, be, [p("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), g, We], 4), B("SpaceBeforeCloseBraceInJsxExpression", be, 19, [p("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), g, We], 4), B("NoSpaceAfterOpenBraceInJsxExpression", 18, be, [G("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), g, We], 16), B("NoSpaceBeforeCloseBraceInJsxExpression", be, 19, [G("insertSpaceAfterOpeningAndBeforeClosingJsxExpressionBraces"), g, We], 16), B("SpaceAfterSemicolonInFor", 26, be, [p("insertSpaceAfterSemicolonInForStatements"), g, T], 4), B("NoSpaceAfterSemicolonInFor", 26, be, [G("insertSpaceAfterSemicolonInForStatements"), g, T], 16), B("SpaceBeforeBinaryOperator", be, Ir, [p("insertSpaceBeforeAndAfterBinaryOperators"), g, b], 4), B("SpaceAfterBinaryOperator", Ir, be, [p("insertSpaceBeforeAndAfterBinaryOperators"), g, b], 4), B("NoSpaceBeforeBinaryOperator", be, Ir, [G("insertSpaceBeforeAndAfterBinaryOperators"), g, b], 16), B("NoSpaceAfterBinaryOperator", Ir, be, [G("insertSpaceBeforeAndAfterBinaryOperators"), g, b], 16), B("SpaceBeforeOpenParenInFuncDecl", be, 20, [p("insertSpaceBeforeFunctionParenthesis"), g, $], 4), B("NoSpaceBeforeOpenParenInFuncDecl", be, 20, [G("insertSpaceBeforeFunctionParenthesis"), g, $], 16), B("NewLineBeforeOpenBraceInControl", et, 18, [p("placeOpenBraceOnNewLineForControlBlocks"), k, ve], 8, 1), B("NewLineBeforeOpenBraceInFunction", wi, 18, [p("placeOpenBraceOnNewLineForFunctions"), $, ve], 8, 1), B("NewLineBeforeOpenBraceInTypeScriptDeclWithBlock", Xi, 18, [p("placeOpenBraceOnNewLineForFunctions"), V, ve], 8, 1), B("SpaceAfterTypeAssertion", 31, be, [p("insertSpaceAfterTypeAssertion"), g, ye], 4), B("NoSpaceAfterTypeAssertion", 31, be, [G("insertSpaceAfterTypeAssertion"), g, ye], 16), B("SpaceBeforeTypeAnnotation", be, [57, 58], [p("insertSpaceBeforeTypeAnnotation"), g, ie], 4), B("NoSpaceBeforeTypeAnnotation", be, [57, 58], [G("insertSpaceBeforeTypeAnnotation"), g, ie], 16), B("NoOptionalSemicolon", 26, ur, [N("semicolons", e2.SemicolonPreference.Remove), Br], 32), B("OptionalSemicolon", be, ur, [N("semicolons", e2.SemicolonPreference.Insert), Er], 64)], Zt = [B("NoSpaceBeforeSemicolon", be, 26, [g], 16), B("SpaceBeforeOpenBraceInControl", et, 18, [oe("placeOpenBraceOnNewLineForControlBlocks"), k, He, q], 4, 1), B("SpaceBeforeOpenBraceInFunction", wi, 18, [oe("placeOpenBraceOnNewLineForFunctions"), $, x2, He, q], 4, 1), B("SpaceBeforeOpenBraceInTypeScriptDeclWithBlock", Xi, 18, [oe("placeOpenBraceOnNewLineForFunctions"), V, He, q], 4, 1), B("NoSpaceBeforeComma", be, 27, [g], 16), B("NoSpaceBeforeOpenBracket", lr(131, 82), 22, [g], 16), B("NoSpaceAfterCloseBracket", 23, be, [g, ge], 16), B("SpaceAfterSemicolon", 26, be, [g], 4), B("SpaceBetweenForAndAwaitKeyword", 97, 132, [g], 4), B("SpaceBetweenStatements", [21, 90, 91, 82], be, [g, ue, K], 4), B("SpaceAfterTryCatchFinally", [111, 83, 96], 18, [g], 4)];
                return Ve(Ve(Ve([], Gi, true), Wt, true), Zt, true);
              }
              C.getAllRules = w;
              function B(Ne, n, lr, be, Ge, ur) {
                return ur === void 0 && (ur = 0), { leftTokenRange: Q(n), rightTokenRange: Q(lr), rule: { debugName: Ne, context: be, action: Ge, flags: ur } };
              }
              function E(Ne) {
                return { tokens: Ne, isSpecific: true };
              }
              function Q(Ne) {
                return typeof Ne == "number" ? E([Ne]) : e2.isArray(Ne) ? E(Ne) : Ne;
              }
              function le(Ne, n, lr) {
                lr === void 0 && (lr = []);
                for (var be = [], Ge = Ne; Ge <= n; Ge++)
                  e2.contains(lr, Ge) || be.push(Ge);
                return E(be);
              }
              function N(Ne, n) {
                return function(lr) {
                  return lr.options && lr.options[Ne] === n;
                };
              }
              function p(Ne) {
                return function(n) {
                  return n.options && n.options.hasOwnProperty(Ne) && !!n.options[Ne];
                };
              }
              function m2(Ne) {
                return function(n) {
                  return n.options && n.options.hasOwnProperty(Ne) && !n.options[Ne];
                };
              }
              function G(Ne) {
                return function(n) {
                  return !n.options || !n.options.hasOwnProperty(Ne) || !n.options[Ne];
                };
              }
              function oe(Ne) {
                return function(n) {
                  return !n.options || !n.options.hasOwnProperty(Ne) || !n.options[Ne] || n.TokensAreOnSameLine();
                };
              }
              function f4(Ne) {
                return function(n) {
                  return !n.options || !n.options.hasOwnProperty(Ne) || !!n.options[Ne];
                };
              }
              function T(Ne) {
                return Ne.contextNode.kind === 242;
              }
              function K(Ne) {
                return !T(Ne);
              }
              function b(Ne) {
                switch (Ne.contextNode.kind) {
                  case 221:
                    return Ne.contextNode.operatorToken.kind !== 27;
                  case 222:
                  case 189:
                  case 229:
                  case 275:
                  case 270:
                  case 177:
                  case 187:
                  case 188:
                    return true;
                  case 203:
                  case 259:
                  case 265:
                  case 271:
                  case 254:
                  case 164:
                  case 299:
                  case 167:
                  case 166:
                    return Ne.currentTokenSpan.kind === 63 || Ne.nextTokenSpan.kind === 63;
                  case 243:
                  case 163:
                    return Ne.currentTokenSpan.kind === 101 || Ne.nextTokenSpan.kind === 101 || Ne.currentTokenSpan.kind === 63 || Ne.nextTokenSpan.kind === 63;
                  case 244:
                    return Ne.currentTokenSpan.kind === 160 || Ne.nextTokenSpan.kind === 160;
                }
                return false;
              }
              function se(Ne) {
                return !b(Ne);
              }
              function J(Ne) {
                return !ie(Ne);
              }
              function ie(Ne) {
                var n = Ne.contextNode.kind;
                return n === 167 || n === 166 || n === 164 || n === 254 || e2.isFunctionLikeKind(n);
              }
              function R(Ne) {
                return Ne.contextNode.kind === 222 || Ne.contextNode.kind === 189;
              }
              function q(Ne) {
                return Ne.TokensAreOnSameLine() || x2(Ne);
              }
              function O(Ne) {
                return Ne.contextNode.kind === 201 || Ne.contextNode.kind === 195 || he(Ne);
              }
              function ve(Ne) {
                return x2(Ne) && !(Ne.NextNodeAllOnSameLine() || Ne.NextNodeBlockIsOnOneLine());
              }
              function ee(Ne) {
                return F2(Ne) && !(Ne.ContextNodeAllOnSameLine() || Ne.ContextNodeBlockIsOnOneLine());
              }
              function he(Ne) {
                return F2(Ne) && (Ne.ContextNodeAllOnSameLine() || Ne.ContextNodeBlockIsOnOneLine());
              }
              function F2(Ne) {
                return X(Ne.contextNode);
              }
              function x2(Ne) {
                return X(Ne.nextTokenParent);
              }
              function X(Ne) {
                if (L(Ne))
                  return true;
                switch (Ne.kind) {
                  case 235:
                  case 263:
                  case 205:
                  case 262:
                    return true;
                }
                return false;
              }
              function $(Ne) {
                switch (Ne.contextNode.kind) {
                  case 256:
                  case 169:
                  case 168:
                  case 172:
                  case 173:
                  case 174:
                  case 213:
                  case 171:
                  case 214:
                  case 258:
                    return true;
                }
                return false;
              }
              function A2(Ne) {
                return !$(Ne);
              }
              function y(Ne) {
                return Ne.contextNode.kind === 256 || Ne.contextNode.kind === 213;
              }
              function V(Ne) {
                return L(Ne.contextNode);
              }
              function L(Ne) {
                switch (Ne.kind) {
                  case 257:
                  case 226:
                  case 258:
                  case 260:
                  case 182:
                  case 261:
                  case 272:
                  case 273:
                  case 266:
                  case 269:
                    return true;
                }
                return false;
              }
              function P(Ne) {
                switch (Ne.currentTokenParent.kind) {
                  case 257:
                  case 261:
                  case 260:
                  case 292:
                  case 262:
                  case 249:
                    return true;
                  case 235: {
                    var n = Ne.currentTokenParent.parent;
                    if (!n || n.kind !== 214 && n.kind !== 213)
                      return true;
                  }
                }
                return false;
              }
              function k(Ne) {
                switch (Ne.contextNode.kind) {
                  case 239:
                  case 249:
                  case 242:
                  case 243:
                  case 244:
                  case 241:
                  case 252:
                  case 240:
                  case 248:
                  case 292:
                    return true;
                  default:
                    return false;
                }
              }
              function Y(Ne) {
                return Ne.contextNode.kind === 205;
              }
              function U(Ne) {
                return Ne.contextNode.kind === 208;
              }
              function j(Ne) {
                return Ne.contextNode.kind === 209;
              }
              function H(Ne) {
                return U(Ne) || j(Ne);
              }
              function I(Ne) {
                return Ne.currentTokenSpan.kind !== 27;
              }
              function l(Ne) {
                return Ne.nextTokenSpan.kind !== 23;
              }
              function d(Ne) {
                return Ne.nextTokenSpan.kind !== 21;
              }
              function D(Ne) {
                return Ne.contextNode.kind === 214;
              }
              function fe(Ne) {
                return Ne.contextNode.kind === 200;
              }
              function g(Ne) {
                return Ne.TokensAreOnSameLine() && Ne.contextNode.kind !== 11;
              }
              function ne(Ne) {
                return Ne.contextNode.kind !== 11;
              }
              function ue(Ne) {
                return Ne.contextNode.kind !== 278 && Ne.contextNode.kind !== 282;
              }
              function We(Ne) {
                return Ne.contextNode.kind === 288 || Ne.contextNode.kind === 287;
              }
              function Fe(Ne) {
                return Ne.nextTokenParent.kind === 285;
              }
              function Z2(Ne) {
                return Ne.contextNode.kind === 285;
              }
              function Be(Ne) {
                return Ne.contextNode.kind === 279;
              }
              function ge(Ne) {
                return !$(Ne) && !x2(Ne);
              }
              function Re(Ne) {
                return Ne.TokensAreOnSameLine() && !!Ne.contextNode.decorators && ze(Ne.currentTokenParent) && !ze(Ne.nextTokenParent);
              }
              function ze(Ne) {
                for (; e2.isExpressionNode(Ne); )
                  Ne = Ne.parent;
                return Ne.kind === 165;
              }
              function Ee(Ne) {
                return Ne.currentTokenParent.kind === 255 && Ne.currentTokenParent.getStart(Ne.sourceFile) === Ne.currentTokenSpan.pos;
              }
              function He(Ne) {
                return Ne.formattingRequestKind !== 2;
              }
              function rr(Ne) {
                return Ne.contextNode.kind === 261;
              }
              function Ie(Ne) {
                return Ne.contextNode.kind === 182;
              }
              function _e(Ne) {
                return Ne.contextNode.kind === 175;
              }
              function we(Ne, n) {
                if (Ne.kind !== 29 && Ne.kind !== 31)
                  return false;
                switch (n.kind) {
                  case 178:
                  case 211:
                  case 259:
                  case 257:
                  case 226:
                  case 258:
                  case 256:
                  case 213:
                  case 214:
                  case 169:
                  case 168:
                  case 174:
                  case 175:
                  case 208:
                  case 209:
                  case 228:
                    return true;
                  default:
                    return false;
                }
              }
              function de(Ne) {
                return we(Ne.currentTokenSpan, Ne.currentTokenParent) || we(Ne.nextTokenSpan, Ne.nextTokenParent);
              }
              function ye(Ne) {
                return Ne.contextNode.kind === 211;
              }
              function Ae(Ne) {
                return Ne.currentTokenSpan.kind === 114 && Ne.currentTokenParent.kind === 217;
              }
              function er(Ne) {
                return Ne.contextNode.kind === 224 && Ne.contextNode.expression !== void 0;
              }
              function ir(Ne) {
                return Ne.contextNode.kind === 230;
              }
              function Cr(Ne) {
                return !Ye(Ne);
              }
              function Ye(Ne) {
                switch (Ne.contextNode.kind) {
                  case 239:
                  case 242:
                  case 243:
                  case 244:
                  case 240:
                  case 241:
                    return true;
                  default:
                    return false;
                }
              }
              function Br(Ne) {
                var n = Ne.nextTokenSpan.kind, lr = Ne.nextTokenSpan.pos;
                if (e2.isTrivia(n)) {
                  var be = Ne.nextTokenParent === Ne.currentTokenParent ? e2.findNextToken(Ne.currentTokenParent, e2.findAncestor(Ne.currentTokenParent, function(yr) {
                    return !yr.parent;
                  }), Ne.sourceFile) : Ne.nextTokenParent.getFirstToken(Ne.sourceFile);
                  if (!be)
                    return true;
                  n = be.kind, lr = be.getStart(Ne.sourceFile);
                }
                var Ge = Ne.sourceFile.getLineAndCharacterOfPosition(Ne.currentTokenSpan.pos).line, ur = Ne.sourceFile.getLineAndCharacterOfPosition(lr).line;
                return Ge === ur ? n === 19 || n === 1 : n === 234 || n === 26 ? false : Ne.contextNode.kind === 258 || Ne.contextNode.kind === 259 ? !e2.isPropertySignature(Ne.currentTokenParent) || !!Ne.currentTokenParent.type || n !== 20 : e2.isPropertyDeclaration(Ne.currentTokenParent) ? !Ne.currentTokenParent.initializer : Ne.currentTokenParent.kind !== 242 && Ne.currentTokenParent.kind !== 236 && Ne.currentTokenParent.kind !== 234 && n !== 22 && n !== 20 && n !== 39 && n !== 40 && n !== 43 && n !== 13 && n !== 27 && n !== 223 && n !== 15 && n !== 14 && n !== 24;
              }
              function Er(Ne) {
                return e2.positionIsASICandidate(Ne.currentTokenSpan.end, Ne.currentTokenParent, Ne.sourceFile);
              }
            })(a = e2.formatting || (e2.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(se, J) {
                return { options: se, getRules: E(), host: J };
              }
              C.getFormatContext = w;
              var B;
              function E() {
                return B === void 0 && (B = le(C.getAllRules())), B;
              }
              function Q(se) {
                var J = 0;
                return se & 1 && (J |= 28), se & 2 && (J |= 96), se & 28 && (J |= 28), se & 96 && (J |= 96), J;
              }
              function le(se) {
                var J = N(se);
                return function(ie) {
                  var R = J[p(ie.currentTokenSpan.kind, ie.nextTokenSpan.kind)];
                  if (R) {
                    for (var q = [], O = 0, ve = 0, ee = R; ve < ee.length; ve++) {
                      var he = ee[ve], F2 = ~Q(O);
                      he.action & F2 && e2.every(he.context, function(x2) {
                        return x2(ie);
                      }) && (q.push(he), O |= he.action);
                    }
                    if (q.length)
                      return q;
                  }
                };
              }
              function N(se) {
                for (var J = new Array(oe * oe), ie = new Array(J.length), R = 0, q = se; R < q.length; R++)
                  for (var O = q[R], ve = O.leftTokenRange.isSpecific && O.rightTokenRange.isSpecific, ee = 0, he = O.leftTokenRange.tokens; ee < he.length; ee++)
                    for (var F2 = he[ee], x2 = 0, X = O.rightTokenRange.tokens; x2 < X.length; x2++) {
                      var $ = X[x2], A2 = p(F2, $), y = J[A2];
                      y === void 0 && (y = J[A2] = []), T(y, O.rule, ve, ie, A2);
                    }
                return J;
              }
              function p(se, J) {
                return e2.Debug.assert(se <= 160 && J <= 160, "Must compute formatting context from tokens"), se * oe + J;
              }
              var m2 = 5, G = 31, oe = 160 + 1, f4;
              (function(se) {
                se[se.StopRulesSpecific = 0] = "StopRulesSpecific", se[se.StopRulesAny = m2 * 1] = "StopRulesAny", se[se.ContextRulesSpecific = m2 * 2] = "ContextRulesSpecific", se[se.ContextRulesAny = m2 * 3] = "ContextRulesAny", se[se.NoContextRulesSpecific = m2 * 4] = "NoContextRulesSpecific", se[se.NoContextRulesAny = m2 * 5] = "NoContextRulesAny";
              })(f4 || (f4 = {}));
              function T(se, J, ie, R, q) {
                var O = J.action & 3 ? ie ? f4.StopRulesSpecific : f4.StopRulesAny : J.context !== C.anyContext ? ie ? f4.ContextRulesSpecific : f4.ContextRulesAny : ie ? f4.NoContextRulesSpecific : f4.NoContextRulesAny, ve = R[q] || 0;
                se.splice(K(ve, O), 0, J), R[q] = b(ve, O);
              }
              function K(se, J) {
                for (var ie = 0, R = 0; R <= J; R += m2)
                  ie += se & G, se >>= m2;
                return ie;
              }
              function b(se, J) {
                var ie = (se >> J & G) + 1;
                return e2.Debug.assert((ie & G) === ie, "Adding more rules into the sub-bucket than allowed. Maximum allowed is 32 rules."), se & ~(G << J) | ie << J;
              }
            })(a = e2.formatting || (e2.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(A2, y, V) {
                var L = { pos: A2, end: y, kind: V };
                return e2.Debug.isDebugging && Object.defineProperty(L, "__debugKind", { get: function() {
                  return e2.Debug.formatSyntaxKind(V);
                } }), L;
              }
              C.createTextRangeWithKind = w;
              var B;
              (function(A2) {
                A2[A2.Unknown = -1] = "Unknown";
              })(B || (B = {}));
              function E(A2, y, V) {
                var L = y.getLineAndCharacterOfPosition(A2).line;
                if (L === 0)
                  return [];
                for (var P = e2.getEndLinePosition(L, y); e2.isWhiteSpaceSingleLine(y.text.charCodeAt(P)); )
                  P--;
                e2.isLineBreak(y.text.charCodeAt(P)) && P--;
                var k = { pos: e2.getStartPositionOfLine(L - 1, y), end: P + 1 };
                return R(k, y, V, 2);
              }
              C.formatOnEnter = E;
              function Q(A2, y, V) {
                var L = G(A2, 26, y);
                return ie(oe(L), y, V, 3);
              }
              C.formatOnSemicolon = Q;
              function le(A2, y, V) {
                var L = G(A2, 18, y);
                if (!L)
                  return [];
                var P = L.parent, k = oe(P), Y = { pos: e2.getLineStartPositionForPosition(k.getStart(y), y), end: A2 };
                return R(Y, y, V, 4);
              }
              C.formatOnOpeningCurly = le;
              function N(A2, y, V) {
                var L = G(A2, 19, y);
                return ie(oe(L), y, V, 5);
              }
              C.formatOnClosingCurly = N;
              function p(A2, y) {
                var V = { pos: 0, end: A2.text.length };
                return R(V, A2, y, 0);
              }
              C.formatDocument = p;
              function m2(A2, y, V, L) {
                var P = { pos: e2.getLineStartPositionForPosition(A2, V), end: y };
                return R(P, V, L, 1);
              }
              C.formatSelection = m2;
              function G(A2, y, V) {
                var L = e2.findPrecedingToken(A2, V);
                return L && L.kind === y && A2 === L.getEnd() ? L : void 0;
              }
              function oe(A2) {
                for (var y = A2; y && y.parent && y.parent.end === A2.end && !f4(y.parent, y); )
                  y = y.parent;
                return y;
              }
              function f4(A2, y) {
                switch (A2.kind) {
                  case 257:
                  case 258:
                    return e2.rangeContainsRange(A2.members, y);
                  case 261:
                    var V = A2.body;
                    return !!V && V.kind === 262 && e2.rangeContainsRange(V.statements, y);
                  case 305:
                  case 235:
                  case 262:
                    return e2.rangeContainsRange(A2.statements, y);
                  case 292:
                    return e2.rangeContainsRange(A2.block.statements, y);
                }
                return false;
              }
              function T(A2, y) {
                return V(y);
                function V(L) {
                  var P = e2.forEachChild(L, function(Y) {
                    return e2.startEndContainsRange(Y.getStart(y), Y.end, A2) && Y;
                  });
                  if (P) {
                    var k = V(P);
                    if (k)
                      return k;
                  }
                  return L;
                }
              }
              function K(A2, y) {
                if (!A2.length)
                  return P;
                var V = A2.filter(function(k) {
                  return e2.rangeOverlapsWithStartEnd(y, k.start, k.start + k.length);
                }).sort(function(k, Y) {
                  return k.start - Y.start;
                });
                if (!V.length)
                  return P;
                var L = 0;
                return function(k) {
                  for (; ; ) {
                    if (L >= V.length)
                      return false;
                    var Y = V[L];
                    if (k.end <= Y.start)
                      return false;
                    if (e2.startEndOverlapsWithStartEnd(k.pos, k.end, Y.start, Y.start + Y.length))
                      return true;
                    L++;
                  }
                };
                function P() {
                  return false;
                }
              }
              function b(A2, y, V) {
                var L = A2.getStart(V);
                if (L === y.pos && A2.end === y.end)
                  return L;
                var P = e2.findPrecedingToken(y.pos, V);
                return !P || P.end >= y.pos ? A2.pos : P.end;
              }
              function se(A2, y, V) {
                for (var L = -1, P; A2; ) {
                  var k = V.getLineAndCharacterOfPosition(A2.getStart(V)).line;
                  if (L !== -1 && k !== L)
                    break;
                  if (C.SmartIndenter.shouldIndentChildNode(y, A2, P, V))
                    return y.indentSize;
                  L = k, P = A2, A2 = A2.parent;
                }
                return 0;
              }
              function J(A2, y, V, L, P, k) {
                var Y = { pos: A2.pos, end: A2.end };
                return C.getFormattingScanner(y.text, V, Y.pos, Y.end, function(U) {
                  return q(Y, A2, L, P, U, k, 1, function(j) {
                    return false;
                  }, y);
                });
              }
              C.formatNodeGivenIndentation = J;
              function ie(A2, y, V, L) {
                if (!A2)
                  return [];
                var P = { pos: e2.getLineStartPositionForPosition(A2.getStart(y), y), end: A2.end };
                return R(P, y, V, L);
              }
              function R(A2, y, V, L) {
                var P = T(A2, y);
                return C.getFormattingScanner(y.text, y.languageVariant, b(P, A2, y), A2.end, function(k) {
                  return q(A2, P, C.SmartIndenter.getIndentationForNode(P, A2, y, V.options), se(P, V.options, y), k, V, L, K(y.parseDiagnostics, A2), y);
                });
              }
              function q(A2, y, V, L, P, k, Y, U, j) {
                var H, I = k.options, l = k.getRules, d = k.host, D = new C.FormattingContext(j, Y, I), fe, g, ne, ue, We = -1, Fe = [];
                if (P.advance(), P.isOnToken()) {
                  var Z2 = j.getLineAndCharacterOfPosition(y.getStart(j)).line, Be = Z2;
                  y.decorators && (Be = j.getLineAndCharacterOfPosition(e2.getNonDecoratorTokenPosOfNode(y, j)).line), we(y, y, Z2, Be, V, L);
                }
                if (!P.isOnToken()) {
                  var ge = C.SmartIndenter.nodeWillIndentChild(I, y, void 0, j, false) ? V + I.indentSize : V, Re = P.getCurrentLeadingTrivia();
                  Re && (de(Re, ge, false, function(Ir) {
                    return Ae(Ir, j.getLineAndCharacterOfPosition(Ir.pos), y, y, void 0);
                  }), I.trimTrailingWhitespace !== false && n(Re));
                }
                if (fe && P.getStartPos() >= A2.end) {
                  var ze = P.isOnEOF() ? P.readEOFTokenRange() : P.isOnToken() ? P.readTokenInfo(y).token : void 0;
                  if (ze) {
                    var Ee = ((H = e2.findPrecedingToken(ze.end, j, y)) === null || H === void 0 ? void 0 : H.parent) || g;
                    er(ze, j.getLineAndCharacterOfPosition(ze.pos).line, Ee, fe, ne, g, Ee, void 0);
                  }
                }
                return Fe;
                function He(Ir, wr, Ur, ii, mi) {
                  if (e2.rangeOverlapsWithStartEnd(ii, Ir, wr) || e2.rangeContainsStartEnd(ii, Ir, wr)) {
                    if (mi !== -1)
                      return mi;
                  } else {
                    var pe = j.getLineAndCharacterOfPosition(Ir).line, or = e2.getLineStartPositionForPosition(Ir, j), qr = C.SmartIndenter.findFirstNonWhitespaceColumn(or, Ir, j, I);
                    if (pe !== Ur || Ir === qr) {
                      var si = C.SmartIndenter.getBaseIndentation(I);
                      return si > qr ? si : qr;
                    }
                  }
                  return -1;
                }
                function rr(Ir, wr, Ur, ii, mi, pe) {
                  var or = C.SmartIndenter.shouldIndentChildNode(I, Ir) ? I.indentSize : 0;
                  return pe === wr ? { indentation: wr === ue ? We : mi.getIndentation(), delta: Math.min(I.indentSize, mi.getDelta(Ir) + or) } : Ur === -1 ? Ir.kind === 20 && wr === ue ? { indentation: We, delta: mi.getDelta(Ir) } : C.SmartIndenter.childStartsOnTheSameLineWithElseInIfStatement(ii, Ir, wr, j) || C.SmartIndenter.childIsUnindentedBranchOfConditionalExpression(ii, Ir, wr, j) || C.SmartIndenter.argumentStartsOnSameLineAsPreviousArgument(ii, Ir, wr, j) ? { indentation: mi.getIndentation(), delta: or } : { indentation: mi.getIndentation() + mi.getDelta(Ir), delta: or } : { indentation: Ur, delta: or };
                }
                function Ie(Ir) {
                  if (Ir.modifiers && Ir.modifiers.length)
                    return Ir.modifiers[0].kind;
                  switch (Ir.kind) {
                    case 257:
                      return 84;
                    case 258:
                      return 118;
                    case 256:
                      return 98;
                    case 260:
                      return 260;
                    case 172:
                      return 136;
                    case 173:
                      return 149;
                    case 169:
                      if (Ir.asteriskToken)
                        return 41;
                    case 167:
                    case 164:
                      var wr = e2.getNameOfDeclaration(Ir);
                      if (wr)
                        return wr.kind;
                  }
                }
                function _e(Ir, wr, Ur, ii) {
                  return { getIndentationForComment: function(or, qr, si) {
                    switch (or) {
                      case 19:
                      case 23:
                      case 21:
                        return Ur + pe(si);
                    }
                    return qr !== -1 ? qr : Ur;
                  }, getIndentationForToken: function(or, qr, si, Di) {
                    return !Di && mi(or, qr, si) ? Ur + pe(si) : Ur;
                  }, getIndentation: function() {
                    return Ur;
                  }, getDelta: pe, recomputeIndentation: function(or, qr) {
                    C.SmartIndenter.shouldIndentChildNode(I, qr, Ir, j) && (Ur += or ? I.indentSize : -I.indentSize, ii = C.SmartIndenter.shouldIndentChildNode(I, Ir) ? I.indentSize : 0);
                  } };
                  function mi(or, qr, si) {
                    switch (qr) {
                      case 18:
                      case 19:
                      case 21:
                      case 91:
                      case 115:
                      case 59:
                        return false;
                      case 43:
                      case 31:
                        switch (si.kind) {
                          case 280:
                          case 281:
                          case 279:
                          case 228:
                            return false;
                        }
                        break;
                      case 22:
                      case 23:
                        if (si.kind !== 195)
                          return false;
                        break;
                    }
                    return wr !== or && !(Ir.decorators && qr === Ie(Ir));
                  }
                  function pe(or) {
                    return C.SmartIndenter.nodeWillIndentChild(I, Ir, or, j, true) ? ii : 0;
                  }
                }
                function we(Ir, wr, Ur, ii, mi, pe) {
                  if (!e2.rangeOverlapsWithStartEnd(A2, Ir.getStart(j), Ir.getEnd()))
                    return;
                  var or = _e(Ir, Ur, mi, pe), qr = wr;
                  for (e2.forEachChild(Ir, function(et) {
                    Di(et, -1, Ir, or, Ur, ii, false);
                  }, function(et) {
                    wi(et, Ir, Ur, or);
                  }); P.isOnToken() && P.getStartPos() < A2.end; ) {
                    var si = P.readTokenInfo(Ir);
                    if (si.token.end > Math.min(Ir.end, A2.end))
                      break;
                    Xi(si, Ir, or, Ir);
                  }
                  function Di(et, Gi, Wt, Zt, _r, pi, ae, Xe) {
                    if (e2.nodeIsMissing(et))
                      return Gi;
                    var Jr = et.getStart(j), ti = j.getLineAndCharacterOfPosition(Jr).line, Ze = ti;
                    et.decorators && (Ze = j.getLineAndCharacterOfPosition(e2.getNonDecoratorTokenPosOfNode(et, j)).line);
                    var Sr = -1;
                    if (ae && e2.rangeContainsRange(A2, Wt) && (Sr = He(Jr, et.end, _r, A2, Gi), Sr !== -1 && (Gi = Sr)), !e2.rangeOverlapsWithStartEnd(A2, et.pos, et.end))
                      return et.end < A2.pos && P.skipToEndOf(et), Gi;
                    if (et.getFullWidth() === 0)
                      return Gi;
                    for (; P.isOnToken() && P.getStartPos() < A2.end; ) {
                      var zr = P.readTokenInfo(Ir);
                      if (zr.token.end > A2.end)
                        return Gi;
                      if (zr.token.end > Jr) {
                        zr.token.pos > Jr && P.skipToStartOf(et);
                        break;
                      }
                      Xi(zr, Ir, Zt, Ir);
                    }
                    if (!P.isOnToken() || P.getStartPos() >= A2.end)
                      return Gi;
                    if (e2.isToken(et)) {
                      var zr = P.readTokenInfo(et);
                      if (et.kind !== 11)
                        return e2.Debug.assert(zr.token.end === et.end, "Token end is child end"), Xi(zr, Ir, Zt, et), Gi;
                    }
                    var Wr = et.kind === 165 ? ti : pi, Je = rr(et, ti, Sr, Ir, Zt, Wr);
                    return we(et, qr, ti, Ze, Je.indentation, Je.delta), qr = Ir, Xe && Wt.kind === 204 && Gi === -1 && (Gi = Je.indentation), Gi;
                  }
                  function wi(et, Gi, Wt, Zt) {
                    e2.Debug.assert(e2.isNodeArray(et));
                    var _r = ee(Gi, et), pi = Zt, ae = Wt;
                    if (!e2.rangeOverlapsWithStartEnd(A2, et.pos, et.end)) {
                      et.end < A2.pos && P.skipToEndOf(et);
                      return;
                    }
                    if (_r !== 0)
                      for (; P.isOnToken() && P.getStartPos() < A2.end; ) {
                        var Xe = P.readTokenInfo(Gi);
                        if (Xe.token.end > et.pos)
                          break;
                        if (Xe.token.kind === _r) {
                          ae = j.getLineAndCharacterOfPosition(Xe.token.pos).line, Xi(Xe, Gi, Zt, Gi);
                          var Jr = void 0;
                          if (We !== -1)
                            Jr = We;
                          else {
                            var ti = e2.getLineStartPositionForPosition(Xe.token.pos, j);
                            Jr = C.SmartIndenter.findFirstNonWhitespaceColumn(ti, Xe.token.pos, j, I);
                          }
                          pi = _e(Gi, Wt, Jr, I.indentSize);
                        } else
                          Xi(Xe, Gi, Zt, Gi);
                      }
                    for (var Ze = -1, Sr = 0; Sr < et.length; Sr++) {
                      var zr = et[Sr];
                      Ze = Di(zr, Ze, Ir, pi, ae, ae, true, Sr === 0);
                    }
                    var Wr = he(_r);
                    if (Wr !== 0 && P.isOnToken() && P.getStartPos() < A2.end) {
                      var Xe = P.readTokenInfo(Gi);
                      if (Xe.token.kind === 27 && e2.isCallLikeExpression(Gi)) {
                        var Je = j.getLineAndCharacterOfPosition(Xe.token.pos).line;
                        ae !== Je && (P.advance(), Xe = P.isOnToken() ? P.readTokenInfo(Gi) : void 0);
                      }
                      Xe && Xe.token.kind === Wr && e2.rangeContainsRange(Gi, Xe.token) && Xi(Xe, Gi, pi, Gi, true);
                    }
                  }
                  function Xi(et, Gi, Wt, Zt, _r) {
                    e2.Debug.assert(e2.rangeContainsRange(Gi, et.token));
                    var pi = P.lastTrailingTriviaWasNewLine(), ae = false;
                    et.leadingTrivia && ye(et.leadingTrivia, Gi, qr, Wt);
                    var Xe = 0, Jr = e2.rangeContainsRange(A2, et.token), ti = j.getLineAndCharacterOfPosition(et.token.pos);
                    if (Jr) {
                      var Ze = U(et.token), Sr = fe;
                      if (Xe = Ae(et.token, ti, Gi, qr, Wt), !Ze)
                        if (Xe === 0) {
                          var zr = Sr && j.getLineAndCharacterOfPosition(Sr.end).line;
                          ae = pi && ti.line !== zr;
                        } else
                          ae = Xe === 1;
                    }
                    if (et.trailingTrivia && ye(et.trailingTrivia, Gi, qr, Wt), ae) {
                      var Wr = Jr && !U(et.token) ? Wt.getIndentationForToken(ti.line, et.token.kind, Zt, !!_r) : -1, Je = true;
                      if (et.leadingTrivia) {
                        var xe = Wt.getIndentationForComment(et.token.kind, Wr, Zt);
                        Je = de(et.leadingTrivia, xe, Je, function(vr) {
                          return ir(vr.pos, xe, false);
                        });
                      }
                      Wr !== -1 && Je && (ir(et.token.pos, Wr, Xe === 1), ue = ti.line, We = Wr);
                    }
                    P.advance(), qr = Gi;
                  }
                }
                function de(Ir, wr, Ur, ii) {
                  for (var mi = 0, pe = Ir; mi < pe.length; mi++) {
                    var or = pe[mi], qr = e2.rangeContainsRange(A2, or);
                    switch (or.kind) {
                      case 3:
                        qr && Br(or, wr, !Ur), Ur = false;
                        break;
                      case 2:
                        Ur && qr && ii(or), Ur = false;
                        break;
                      case 4:
                        Ur = true;
                        break;
                    }
                  }
                  return Ur;
                }
                function ye(Ir, wr, Ur, ii) {
                  for (var mi = 0, pe = Ir; mi < pe.length; mi++) {
                    var or = pe[mi];
                    if (e2.isComment(or.kind) && e2.rangeContainsRange(A2, or)) {
                      var qr = j.getLineAndCharacterOfPosition(or.pos);
                      Ae(or, qr, wr, Ur, ii);
                    }
                  }
                }
                function Ae(Ir, wr, Ur, ii, mi) {
                  var pe = U(Ir), or = 0;
                  if (!pe)
                    if (fe)
                      or = er(Ir, wr.line, Ur, fe, ne, g, ii, mi);
                    else {
                      var qr = j.getLineAndCharacterOfPosition(A2.pos);
                      Er(qr.line, wr.line);
                    }
                  return fe = Ir, g = Ur, ne = wr.line, or;
                }
                function er(Ir, wr, Ur, ii, mi, pe, or, qr) {
                  D.updateContext(ii, pe, Ir, Ur, or);
                  var si = l(D), Di = D.options.trimTrailingWhitespace !== false, wi = 0;
                  return si ? e2.forEachRight(si, function(Xi) {
                    if (wi = yr(Xi, ii, mi, Ir, wr), qr)
                      switch (wi) {
                        case 2:
                          Ur.getStart(j) === Ir.pos && qr.recomputeIndentation(false, or);
                          break;
                        case 1:
                          Ur.getStart(j) === Ir.pos && qr.recomputeIndentation(true, or);
                          break;
                        default:
                          e2.Debug.assert(wi === 0);
                      }
                    Di = Di && !(Xi.action & 16) && Xi.flags !== 1;
                  }) : Di = Di && Ir.kind !== 1, wr !== mi && Di && Er(mi, wr, ii), wi;
                }
                function ir(Ir, wr, Ur) {
                  var ii = $(wr, I);
                  if (Ur)
                    Ge(Ir, 0, ii);
                  else {
                    var mi = j.getLineAndCharacterOfPosition(Ir), pe = e2.getStartPositionOfLine(mi.line, j);
                    (wr !== Cr(pe, mi.character) || Ye(ii, pe)) && Ge(pe, mi.character, ii);
                  }
                }
                function Cr(Ir, wr) {
                  for (var Ur = 0, ii = 0; ii < wr; ii++)
                    j.text.charCodeAt(Ir + ii) === 9 ? Ur += I.tabSize - Ur % I.tabSize : Ur++;
                  return Ur;
                }
                function Ye(Ir, wr) {
                  return Ir !== j.text.substr(wr, Ir.length);
                }
                function Br(Ir, wr, Ur, ii) {
                  ii === void 0 && (ii = true);
                  var mi = j.getLineAndCharacterOfPosition(Ir.pos).line, pe = j.getLineAndCharacterOfPosition(Ir.end).line;
                  if (mi === pe) {
                    Ur || ir(Ir.pos, wr, false);
                    return;
                  }
                  for (var or = [], qr = Ir.pos, si = mi; si < pe; si++) {
                    var Di = e2.getEndLinePosition(si, j);
                    or.push({ pos: qr, end: Di }), qr = e2.getStartPositionOfLine(si + 1, j);
                  }
                  if (ii && or.push({ pos: qr, end: Ir.end }), or.length !== 0) {
                    var wi = e2.getStartPositionOfLine(mi, j), Xi = C.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(wi, or[0].pos, j, I), et = 0;
                    Ur && (et = 1, mi++);
                    for (var Gi = wr - Xi.column, Wt = et; Wt < or.length; Wt++, mi++) {
                      var Zt = e2.getStartPositionOfLine(mi, j), _r = Wt === 0 ? Xi : C.SmartIndenter.findFirstNonWhitespaceCharacterAndColumn(or[Wt].pos, or[Wt].end, j, I), pi = _r.column + Gi;
                      if (pi > 0) {
                        var ae = $(pi, I);
                        Ge(Zt, _r.character, ae);
                      } else
                        be(Zt, _r.character);
                    }
                  }
                }
                function Er(Ir, wr, Ur) {
                  for (var ii = Ir; ii < wr; ii++) {
                    var mi = e2.getStartPositionOfLine(ii, j), pe = e2.getEndLinePosition(ii, j);
                    if (!(Ur && (e2.isComment(Ur.kind) || e2.isStringOrRegularExpressionOrTemplateLiteral(Ur.kind)) && Ur.pos <= pe && Ur.end > pe)) {
                      var or = Ne(mi, pe);
                      or !== -1 && (e2.Debug.assert(or === mi || !e2.isWhiteSpaceSingleLine(j.text.charCodeAt(or - 1))), be(or, pe + 1 - or));
                    }
                  }
                }
                function Ne(Ir, wr) {
                  for (var Ur = wr; Ur >= Ir && e2.isWhiteSpaceSingleLine(j.text.charCodeAt(Ur)); )
                    Ur--;
                  return Ur !== wr ? Ur + 1 : -1;
                }
                function n(Ir) {
                  for (var wr = fe ? fe.end : A2.pos, Ur = 0, ii = Ir; Ur < ii.length; Ur++) {
                    var mi = ii[Ur];
                    e2.isComment(mi.kind) && (wr < mi.pos && lr(wr, mi.pos - 1, fe), wr = mi.end + 1);
                  }
                  wr < A2.end && lr(wr, A2.end, fe);
                }
                function lr(Ir, wr, Ur) {
                  var ii = j.getLineAndCharacterOfPosition(Ir).line, mi = j.getLineAndCharacterOfPosition(wr).line;
                  Er(ii, mi + 1, Ur);
                }
                function be(Ir, wr) {
                  wr && Fe.push(e2.createTextChangeFromStartLength(Ir, wr, ""));
                }
                function Ge(Ir, wr, Ur) {
                  (wr || Ur) && Fe.push(e2.createTextChangeFromStartLength(Ir, wr, Ur));
                }
                function ur(Ir, wr) {
                  wr && Fe.push(e2.createTextChangeFromStartLength(Ir, 0, wr));
                }
                function yr(Ir, wr, Ur, ii, mi) {
                  var pe = mi !== Ur;
                  switch (Ir.action) {
                    case 1:
                      return 0;
                    case 16:
                      if (wr.end !== ii.pos)
                        return be(wr.end, ii.pos - wr.end), pe ? 2 : 0;
                      break;
                    case 32:
                      be(wr.pos, wr.end - wr.pos);
                      break;
                    case 8:
                      if (Ir.flags !== 1 && Ur !== mi)
                        return 0;
                      var or = mi - Ur;
                      if (or !== 1)
                        return Ge(wr.end, ii.pos - wr.end, e2.getNewLineOrDefaultFromHost(d, I)), pe ? 0 : 1;
                      break;
                    case 4:
                      if (Ir.flags !== 1 && Ur !== mi)
                        return 0;
                      var qr = ii.pos - wr.end;
                      if (qr !== 1 || j.text.charCodeAt(wr.end) !== 32)
                        return Ge(wr.end, ii.pos - wr.end, " "), pe ? 2 : 0;
                      break;
                    case 64:
                      ur(wr.end, ";");
                  }
                  return 0;
                }
              }
              var O;
              (function(A2) {
                A2[A2.None = 0] = "None", A2[A2.LineAdded = 1] = "LineAdded", A2[A2.LineRemoved = 2] = "LineRemoved";
              })(O || (O = {}));
              function ve(A2, y, V, L) {
                L === void 0 && (L = e2.getTokenAtPosition(A2, y));
                var P = e2.findAncestor(L, e2.isJSDoc);
                P && (L = P.parent);
                var k = L.getStart(A2);
                if (!(k <= y && y < L.getEnd())) {
                  V = V === null ? void 0 : V === void 0 ? e2.findPrecedingToken(y, A2) : V;
                  var Y = V && e2.getTrailingCommentRanges(A2.text, V.end), U = e2.getLeadingCommentRangesOfNode(L, A2), j = e2.concatenate(Y, U);
                  return j && e2.find(j, function(H) {
                    return e2.rangeContainsPositionExclusive(H, y) || y === H.end && (H.kind === 2 || y === A2.getFullWidth());
                  });
                }
              }
              C.getRangeOfEnclosingComment = ve;
              function ee(A2, y) {
                switch (A2.kind) {
                  case 171:
                  case 256:
                  case 213:
                  case 169:
                  case 168:
                  case 214:
                    if (A2.typeParameters === y)
                      return 29;
                    if (A2.parameters === y)
                      return 20;
                    break;
                  case 208:
                  case 209:
                    if (A2.typeArguments === y)
                      return 29;
                    if (A2.arguments === y)
                      return 20;
                    break;
                  case 178:
                    if (A2.typeArguments === y)
                      return 29;
                    break;
                  case 182:
                    return 18;
                }
                return 0;
              }
              function he(A2) {
                switch (A2) {
                  case 20:
                    return 21;
                  case 29:
                    return 31;
                  case 18:
                    return 19;
                }
                return 0;
              }
              var F2, x2, X;
              function $(A2, y) {
                var V = !F2 || F2.tabSize !== y.tabSize || F2.indentSize !== y.indentSize;
                if (V && (F2 = { tabSize: y.tabSize, indentSize: y.indentSize }, x2 = X = void 0), y.convertTabsToSpaces) {
                  var Y = void 0, U = Math.floor(A2 / y.indentSize), j = A2 % y.indentSize;
                  return X || (X = []), X[U] === void 0 ? (Y = e2.repeatString(" ", y.indentSize * U), X[U] = Y) : Y = X[U], j ? Y + e2.repeatString(" ", j) : Y;
                } else {
                  var L = Math.floor(A2 / y.tabSize), P = A2 - L * y.tabSize, k = void 0;
                  return x2 || (x2 = []), x2[L] === void 0 ? x2[L] = k = e2.repeatString("	", L) : k = x2[L], P ? k + e2.repeatString(" ", P) : k;
                }
              }
              C.getIndentationString = $;
            })(a = e2.formatting || (e2.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E;
                (function(U) {
                  U[U.Unknown = -1] = "Unknown";
                })(E || (E = {}));
                function Q(U, j, H, I) {
                  if (I === void 0 && (I = false), U > j.text.length)
                    return G(H);
                  if (H.indentStyle === e2.IndentStyle.None)
                    return 0;
                  var l = e2.findPrecedingToken(U, j, void 0, true), d = C.getRangeOfEnclosingComment(j, U, l || null);
                  if (d && d.kind === 3)
                    return le(j, U, H, d);
                  if (!l)
                    return G(H);
                  var D = e2.isStringOrRegularExpressionOrTemplateLiteral(l.kind);
                  if (D && l.getStart(j) <= U && U < l.end)
                    return 0;
                  var fe = j.getLineAndCharacterOfPosition(U).line, g = e2.getTokenAtPosition(j, U), ne = g.kind === 18 && g.parent.kind === 205;
                  if (H.indentStyle === e2.IndentStyle.Block || ne)
                    return N(j, U, H);
                  if (l.kind === 27 && l.parent.kind !== 221) {
                    var ue = T(l, j, H);
                    if (ue !== -1)
                      return ue;
                  }
                  var We = ee(U, l.parent, j);
                  if (We && !e2.rangeContainsRange(We, l)) {
                    var Fe = [213, 214].indexOf(g.parent.kind) !== -1, Z2 = Fe ? 0 : H.indentSize;
                    return x2(We, j, H) + Z2;
                  }
                  return p(j, U, l, fe, I, H);
                }
                B.getIndentation = Q;
                function le(U, j, H, I) {
                  var l = e2.getLineAndCharacterOfPosition(U, j).line - 1, d = e2.getLineAndCharacterOfPosition(U, I.pos).line;
                  if (e2.Debug.assert(d >= 0), l <= d)
                    return V(e2.getStartPositionOfLine(d, U), j, U, H);
                  var D = e2.getStartPositionOfLine(l, U), fe = y(D, j, U, H), g = fe.column, ne = fe.character;
                  if (g === 0)
                    return g;
                  var ue = U.text.charCodeAt(D + ne);
                  return ue === 42 ? g - 1 : g;
                }
                function N(U, j, H) {
                  for (var I = j; I > 0; ) {
                    var l = U.text.charCodeAt(I);
                    if (!e2.isWhiteSpaceLike(l))
                      break;
                    I--;
                  }
                  var d = e2.getLineStartPositionForPosition(I, U);
                  return V(d, I, U, H);
                }
                function p(U, j, H, I, l, d) {
                  for (var D, fe = H; fe; ) {
                    if (e2.positionBelongsToNode(fe, j, U) && k(d, fe, D, U, true)) {
                      var g = J(fe, U), ne = se(H, fe, I, U), ue = ne !== 0 ? l && ne === 2 ? d.indentSize : 0 : I !== g.line ? d.indentSize : 0;
                      return oe(fe, g, void 0, ue, U, true, d);
                    }
                    var We = X(fe, U, d, true);
                    if (We !== -1)
                      return We;
                    D = fe, fe = fe.parent;
                  }
                  return G(d);
                }
                function m2(U, j, H, I) {
                  var l = H.getLineAndCharacterOfPosition(U.getStart(H));
                  return oe(U, l, j, 0, H, false, I);
                }
                B.getIndentationForNode = m2;
                function G(U) {
                  return U.baseIndentSize || 0;
                }
                B.getBaseIndentation = G;
                function oe(U, j, H, I, l, d, D) {
                  for (var fe, g = U.parent; g; ) {
                    var ne = true;
                    if (H) {
                      var ue = U.getStart(l);
                      ne = ue < H.pos || ue > H.end;
                    }
                    var We = f4(g, U, l), Fe = We.line === j.line || R(g, U, j.line, l);
                    if (ne) {
                      var Z2 = (fe = ve(U, l)) === null || fe === void 0 ? void 0 : fe[0], Be = !!Z2 && J(Z2, l).line > We.line, ge = X(U, l, D, Be);
                      if (ge !== -1 || (ge = K(U, g, j, Fe, l, D), ge !== -1))
                        return ge + I;
                    }
                    k(D, g, U, l, d) && !Fe && (I += D.indentSize);
                    var Re = ie(g, U, j.line, l);
                    U = g, g = U.parent, j = Re ? l.getLineAndCharacterOfPosition(U.getStart(l)) : We;
                  }
                  return I + G(D);
                }
                function f4(U, j, H) {
                  var I = ve(j, H), l = I ? I.pos : U.getStart(H);
                  return H.getLineAndCharacterOfPosition(l);
                }
                function T(U, j, H) {
                  var I = e2.findListItemInfo(U);
                  return I && I.listItemIndex > 0 ? $(I.list.getChildren(), I.listItemIndex - 1, j, H) : -1;
                }
                function K(U, j, H, I, l, d) {
                  var D = (e2.isDeclaration(U) || e2.isStatementButNotDeclaration(U)) && (j.kind === 305 || !I);
                  return D ? A2(H, l, d) : -1;
                }
                var b;
                (function(U) {
                  U[U.Unknown = 0] = "Unknown", U[U.OpenBrace = 1] = "OpenBrace", U[U.CloseBrace = 2] = "CloseBrace";
                })(b || (b = {}));
                function se(U, j, H, I) {
                  var l = e2.findNextToken(U, j, I);
                  if (!l)
                    return 0;
                  if (l.kind === 18)
                    return 1;
                  if (l.kind === 19) {
                    var d = J(l, I).line;
                    return H === d ? 2 : 0;
                  }
                  return 0;
                }
                function J(U, j) {
                  return j.getLineAndCharacterOfPosition(U.getStart(j));
                }
                function ie(U, j, H, I) {
                  if (!(e2.isCallExpression(U) && e2.contains(U.arguments, j)))
                    return false;
                  var l = U.expression.getEnd(), d = e2.getLineAndCharacterOfPosition(I, l).line;
                  return d === H;
                }
                B.isArgumentAndStartLineOverlapsExpressionBeingCalled = ie;
                function R(U, j, H, I) {
                  if (U.kind === 239 && U.elseStatement === j) {
                    var l = e2.findChildOfKind(U, 91, I);
                    e2.Debug.assert(l !== void 0);
                    var d = J(l, I).line;
                    return d === H;
                  }
                  return false;
                }
                B.childStartsOnTheSameLineWithElseInIfStatement = R;
                function q(U, j, H, I) {
                  if (e2.isConditionalExpression(U) && (j === U.whenTrue || j === U.whenFalse)) {
                    var l = e2.getLineAndCharacterOfPosition(I, U.condition.end).line;
                    if (j === U.whenTrue)
                      return H === l;
                    var d = J(U.whenTrue, I).line, D = e2.getLineAndCharacterOfPosition(I, U.whenTrue.end).line;
                    return l === d && D === H;
                  }
                  return false;
                }
                B.childIsUnindentedBranchOfConditionalExpression = q;
                function O(U, j, H, I) {
                  if (e2.isCallOrNewExpression(U)) {
                    if (!U.arguments)
                      return false;
                    var l = e2.find(U.arguments, function(g) {
                      return g.pos === j.pos;
                    });
                    if (!l)
                      return false;
                    var d = U.arguments.indexOf(l);
                    if (d === 0)
                      return false;
                    var D = U.arguments[d - 1], fe = e2.getLineAndCharacterOfPosition(I, D.getEnd()).line;
                    if (H === fe)
                      return true;
                  }
                  return false;
                }
                B.argumentStartsOnSameLineAsPreviousArgument = O;
                function ve(U, j) {
                  return U.parent && he(U.getStart(j), U.getEnd(), U.parent, j);
                }
                B.getContainingList = ve;
                function ee(U, j, H) {
                  return j && he(U, U, j, H);
                }
                function he(U, j, H, I) {
                  switch (H.kind) {
                    case 178:
                      return l(H.typeArguments);
                    case 205:
                      return l(H.properties);
                    case 204:
                      return l(H.elements);
                    case 182:
                      return l(H.members);
                    case 256:
                    case 213:
                    case 214:
                    case 169:
                    case 168:
                    case 174:
                    case 171:
                    case 180:
                    case 175:
                      return l(H.typeParameters) || l(H.parameters);
                    case 172:
                      return l(H.parameters);
                    case 257:
                    case 226:
                    case 258:
                    case 259:
                    case 344:
                      return l(H.typeParameters);
                    case 209:
                    case 208:
                      return l(H.typeArguments) || l(H.arguments);
                    case 255:
                      return l(H.declarations);
                    case 269:
                    case 273:
                      return l(H.elements);
                    case 201:
                    case 202:
                      return l(H.elements);
                  }
                  function l(d) {
                    return d && e2.rangeContainsStartEnd(F2(H, d, I), U, j) ? d : void 0;
                  }
                }
                function F2(U, j, H) {
                  for (var I = U.getChildren(H), l = 1; l < I.length - 1; l++)
                    if (I[l].pos === j.pos && I[l].end === j.end)
                      return { pos: I[l - 1].end, end: I[l + 1].getStart(H) };
                  return j;
                }
                function x2(U, j, H) {
                  return U ? A2(j.getLineAndCharacterOfPosition(U.pos), j, H) : -1;
                }
                function X(U, j, H, I) {
                  if (U.parent && U.parent.kind === 255)
                    return -1;
                  var l = ve(U, j);
                  if (l) {
                    var d = l.indexOf(U);
                    if (d !== -1) {
                      var D = $(l, d, j, H);
                      if (D !== -1)
                        return D;
                    }
                    return x2(l, j, H) + (I ? H.indentSize : 0);
                  }
                  return -1;
                }
                function $(U, j, H, I) {
                  e2.Debug.assert(j >= 0 && j < U.length);
                  for (var l = U[j], d = J(l, H), D = j - 1; D >= 0; D--)
                    if (U[D].kind !== 27) {
                      var fe = H.getLineAndCharacterOfPosition(U[D].end).line;
                      if (fe !== d.line)
                        return A2(d, H, I);
                      d = J(U[D], H);
                    }
                  return -1;
                }
                function A2(U, j, H) {
                  var I = j.getPositionOfLineAndCharacter(U.line, 0);
                  return V(I, I + U.character, j, H);
                }
                function y(U, j, H, I) {
                  for (var l = 0, d = 0, D = U; D < j; D++) {
                    var fe = H.text.charCodeAt(D);
                    if (!e2.isWhiteSpaceSingleLine(fe))
                      break;
                    fe === 9 ? d += I.tabSize + d % I.tabSize : d++, l++;
                  }
                  return { column: d, character: l };
                }
                B.findFirstNonWhitespaceCharacterAndColumn = y;
                function V(U, j, H, I) {
                  return y(U, j, H, I).column;
                }
                B.findFirstNonWhitespaceColumn = V;
                function L(U, j, H, I, l) {
                  var d = H ? H.kind : 0;
                  switch (j.kind) {
                    case 238:
                    case 257:
                    case 226:
                    case 258:
                    case 260:
                    case 259:
                    case 204:
                    case 235:
                    case 262:
                    case 205:
                    case 182:
                    case 195:
                    case 184:
                    case 263:
                    case 290:
                    case 289:
                    case 212:
                    case 206:
                    case 208:
                    case 209:
                    case 237:
                    case 271:
                    case 247:
                    case 222:
                    case 202:
                    case 201:
                    case 280:
                    case 283:
                    case 279:
                    case 288:
                    case 168:
                    case 174:
                    case 175:
                    case 164:
                    case 179:
                    case 180:
                    case 191:
                    case 210:
                    case 218:
                    case 273:
                    case 269:
                    case 275:
                    case 270:
                    case 167:
                      return true;
                    case 254:
                    case 296:
                    case 221:
                      if (!U.indentMultiLineObjectLiteralBeginningOnBlankLine && I && d === 205)
                        return Y(I, H);
                      if (j.kind === 221 && I && H && d === 278) {
                        var D = I.getLineAndCharacterOfPosition(e2.skipTrivia(I.text, j.pos)).line, fe = I.getLineAndCharacterOfPosition(e2.skipTrivia(I.text, H.pos)).line;
                        return D !== fe;
                      }
                      if (j.kind !== 221)
                        return true;
                      break;
                    case 240:
                    case 241:
                    case 243:
                    case 244:
                    case 242:
                    case 239:
                    case 256:
                    case 213:
                    case 169:
                    case 171:
                    case 172:
                    case 173:
                      return d !== 235;
                    case 214:
                      return I && d === 212 ? Y(I, H) : d !== 235;
                    case 272:
                      return d !== 273;
                    case 266:
                      return d !== 267 || !!H.namedBindings && H.namedBindings.kind !== 269;
                    case 278:
                      return d !== 281;
                    case 282:
                      return d !== 284;
                    case 188:
                    case 187:
                      if (d === 182 || d === 184)
                        return false;
                      break;
                  }
                  return l;
                }
                B.nodeWillIndentChild = L;
                function P(U, j) {
                  switch (U) {
                    case 247:
                    case 251:
                    case 245:
                    case 246:
                      return j.kind !== 235;
                    default:
                      return false;
                  }
                }
                function k(U, j, H, I, l) {
                  return l === void 0 && (l = false), L(U, j, H, I, false) && !(l && H && P(H.kind, j));
                }
                B.shouldIndentChildNode = k;
                function Y(U, j) {
                  var H = e2.skipTrivia(U.text, j.pos), I = U.getLineAndCharacterOfPosition(H).line, l = U.getLineAndCharacterOfPosition(j.end).line;
                  return I === l;
                }
              })(w = C.SmartIndenter || (C.SmartIndenter = {}));
            })(a = e2.formatting || (e2.formatting = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(H) {
                var I = H.__pos;
                return e2.Debug.assert(typeof I == "number"), I;
              }
              function B(H, I) {
                e2.Debug.assert(typeof I == "number"), H.__pos = I;
              }
              function E(H) {
                var I = H.__end;
                return e2.Debug.assert(typeof I == "number"), I;
              }
              function Q(H, I) {
                e2.Debug.assert(typeof I == "number"), H.__end = I;
              }
              var le;
              (function(H) {
                H[H.Exclude = 0] = "Exclude", H[H.IncludeAll = 1] = "IncludeAll", H[H.JSDoc = 2] = "JSDoc", H[H.StartLine = 3] = "StartLine";
              })(le = C.LeadingTriviaOption || (C.LeadingTriviaOption = {}));
              var N;
              (function(H) {
                H[H.Exclude = 0] = "Exclude", H[H.ExcludeWhitespace = 1] = "ExcludeWhitespace", H[H.Include = 2] = "Include";
              })(N = C.TrailingTriviaOption || (C.TrailingTriviaOption = {}));
              function p(H, I) {
                return e2.skipTrivia(H, I, false, true);
              }
              function m2(H, I) {
                for (var l = I; l < H.length; ) {
                  var d = H.charCodeAt(l);
                  if (e2.isWhiteSpaceSingleLine(d)) {
                    l++;
                    continue;
                  }
                  return d === 47;
                }
                return false;
              }
              var G = { leadingTriviaOption: le.Exclude, trailingTriviaOption: N.Exclude }, oe;
              (function(H) {
                H[H.Remove = 0] = "Remove", H[H.ReplaceWithSingleNode = 1] = "ReplaceWithSingleNode", H[H.ReplaceWithMultipleNodes = 2] = "ReplaceWithMultipleNodes", H[H.Text = 3] = "Text";
              })(oe || (oe = {}));
              function f4(H, I, l, d) {
                return { pos: T(H, I, d), end: b(H, l, d) };
              }
              function T(H, I, l, d) {
                var D, fe;
                d === void 0 && (d = false);
                var g = l.leadingTriviaOption;
                if (g === le.Exclude)
                  return I.getStart(H);
                if (g === le.StartLine) {
                  var ne = I.getStart(H), ue = e2.getLineStartPositionForPosition(ne, H);
                  return e2.rangeContainsPosition(I, ue) ? ue : ne;
                }
                if (g === le.JSDoc) {
                  var We = e2.getJSDocCommentRanges(I, H.text);
                  if (We != null && We.length)
                    return e2.getLineStartPositionForPosition(We[0].pos, H);
                }
                var Fe = I.getFullStart(), Z2 = I.getStart(H);
                if (Fe === Z2)
                  return Z2;
                var Be = e2.getLineStartPositionForPosition(Fe, H), ge = e2.getLineStartPositionForPosition(Z2, H);
                if (ge === Be)
                  return g === le.IncludeAll ? Fe : Z2;
                if (d) {
                  var Re = ((D = e2.getLeadingCommentRanges(H.text, Fe)) === null || D === void 0 ? void 0 : D[0]) || ((fe = e2.getTrailingCommentRanges(H.text, Fe)) === null || fe === void 0 ? void 0 : fe[0]);
                  if (Re)
                    return e2.skipTrivia(H.text, Re.end, true, true);
                }
                var ze = Fe > 0 ? 1 : 0, Ee = e2.getStartPositionOfLine(e2.getLineOfLocalPosition(H, Be) + ze, H);
                return Ee = p(H.text, Ee), e2.getStartPositionOfLine(e2.getLineOfLocalPosition(H, Ee), H);
              }
              function K(H, I, l) {
                var d = I.end, D = l.trailingTriviaOption;
                if (D === N.Include) {
                  var fe = e2.getTrailingCommentRanges(H.text, d);
                  if (fe)
                    for (var g = e2.getLineOfLocalPosition(H, I.end), ne = 0, ue = fe; ne < ue.length; ne++) {
                      var We = ue[ne];
                      if (We.kind === 2 || e2.getLineOfLocalPosition(H, We.pos) > g)
                        break;
                      var Fe = e2.getLineOfLocalPosition(H, We.end);
                      if (Fe > g)
                        return e2.skipTrivia(H.text, We.end, true, true);
                    }
                }
              }
              function b(H, I, l) {
                var d, D = I.end, fe = l.trailingTriviaOption;
                if (fe === N.Exclude)
                  return D;
                if (fe === N.ExcludeWhitespace) {
                  var g = e2.concatenate(e2.getTrailingCommentRanges(H.text, D), e2.getLeadingCommentRanges(H.text, D)), ne = (d = g == null ? void 0 : g[g.length - 1]) === null || d === void 0 ? void 0 : d.end;
                  return ne || D;
                }
                var ue = K(H, I, l);
                if (ue)
                  return ue;
                var We = e2.skipTrivia(H.text, D, true);
                return We !== D && (fe === N.Include || e2.isLineBreak(H.text.charCodeAt(We - 1))) ? We : D;
              }
              function se(H, I) {
                return !!I && !!H.parent && (I.kind === 27 || I.kind === 26 && H.parent.kind === 205);
              }
              function J(H) {
                return e2.isFunctionExpression(H) || e2.isFunctionDeclaration(H);
              }
              C.isThisTypeAnnotatable = J;
              var ie = function() {
                function H(I, l) {
                  this.newLineCharacter = I, this.formatContext = l, this.changes = [], this.newFiles = [], this.classesWithNodesInsertedAtStart = new e2.Map(), this.deletedNodes = [];
                }
                return H.fromContext = function(I) {
                  return new H(e2.getNewLineOrDefaultFromHost(I.host, I.formatContext.options), I.formatContext);
                }, H.with = function(I, l) {
                  var d = H.fromContext(I);
                  return l(d), d.getChanges();
                }, H.prototype.pushRaw = function(I, l) {
                  e2.Debug.assertEqual(I.fileName, l.fileName);
                  for (var d = 0, D = l.textChanges; d < D.length; d++) {
                    var fe = D[d];
                    this.changes.push({ kind: oe.Text, sourceFile: I, text: fe.newText, range: e2.createTextRangeFromSpan(fe.span) });
                  }
                }, H.prototype.deleteRange = function(I, l) {
                  this.changes.push({ kind: oe.Remove, sourceFile: I, range: l });
                }, H.prototype.delete = function(I, l) {
                  this.deletedNodes.push({ sourceFile: I, node: l });
                }, H.prototype.deleteNode = function(I, l, d) {
                  d === void 0 && (d = { leadingTriviaOption: le.IncludeAll }), this.deleteRange(I, f4(I, l, l, d));
                }, H.prototype.deleteNodes = function(I, l, d, D) {
                  d === void 0 && (d = { leadingTriviaOption: le.IncludeAll });
                  for (var fe = 0, g = l; fe < g.length; fe++) {
                    var ne = g[fe], ue = T(I, ne, d, D), We = b(I, ne, d);
                    this.deleteRange(I, { pos: ue, end: We }), D = !!K(I, ne, d);
                  }
                }, H.prototype.deleteModifier = function(I, l) {
                  this.deleteRange(I, { pos: l.getStart(I), end: e2.skipTrivia(I.text, l.end, true) });
                }, H.prototype.deleteNodeRange = function(I, l, d, D) {
                  D === void 0 && (D = { leadingTriviaOption: le.IncludeAll });
                  var fe = T(I, l, D), g = b(I, d, D);
                  this.deleteRange(I, { pos: fe, end: g });
                }, H.prototype.deleteNodeRangeExcludingEnd = function(I, l, d, D) {
                  D === void 0 && (D = { leadingTriviaOption: le.IncludeAll });
                  var fe = T(I, l, D), g = d === void 0 ? I.text.length : T(I, d, D);
                  this.deleteRange(I, { pos: fe, end: g });
                }, H.prototype.replaceRange = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.changes.push({ kind: oe.ReplaceWithSingleNode, sourceFile: I, range: l, options: D, node: d });
                }, H.prototype.replaceNode = function(I, l, d, D) {
                  D === void 0 && (D = G), this.replaceRange(I, f4(I, l, l, D), d, D);
                }, H.prototype.replaceNodeRange = function(I, l, d, D, fe) {
                  fe === void 0 && (fe = G), this.replaceRange(I, f4(I, l, d, fe), D, fe);
                }, H.prototype.replaceRangeWithNodes = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.changes.push({ kind: oe.ReplaceWithMultipleNodes, sourceFile: I, range: l, options: D, nodes: d });
                }, H.prototype.replaceNodeWithNodes = function(I, l, d, D) {
                  D === void 0 && (D = G), this.replaceRangeWithNodes(I, f4(I, l, l, D), d, D);
                }, H.prototype.replaceNodeWithText = function(I, l, d) {
                  this.replaceRangeWithText(I, f4(I, l, l, G), d);
                }, H.prototype.replaceNodeRangeWithNodes = function(I, l, d, D, fe) {
                  fe === void 0 && (fe = G), this.replaceRangeWithNodes(I, f4(I, l, d, fe), D, fe);
                }, H.prototype.nodeHasTrailingComment = function(I, l, d) {
                  return d === void 0 && (d = G), !!K(I, l, d);
                }, H.prototype.nextCommaToken = function(I, l) {
                  var d = e2.findNextToken(l, l.parent, I);
                  return d && d.kind === 27 ? d : void 0;
                }, H.prototype.replacePropertyAssignment = function(I, l, d) {
                  var D = this.nextCommaToken(I, l) ? "" : "," + this.newLineCharacter;
                  this.replaceNode(I, l, d, { suffix: D });
                }, H.prototype.insertNodeAt = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.replaceRange(I, e2.createRange(l), d, D);
                }, H.prototype.insertNodesAt = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.replaceRangeWithNodes(I, e2.createRange(l), d, D);
                }, H.prototype.insertNodeAtTopOfFile = function(I, l, d) {
                  this.insertAtTopOfFile(I, l, d);
                }, H.prototype.insertNodesAtTopOfFile = function(I, l, d) {
                  this.insertAtTopOfFile(I, l, d);
                }, H.prototype.insertAtTopOfFile = function(I, l, d) {
                  var D = L(I), fe = { prefix: D === 0 ? void 0 : this.newLineCharacter, suffix: (e2.isLineBreak(I.text.charCodeAt(D)) ? "" : this.newLineCharacter) + (d ? this.newLineCharacter : "") };
                  e2.isArray(l) ? this.insertNodesAt(I, D, l, fe) : this.insertNodeAt(I, D, l, fe);
                }, H.prototype.insertFirstParameter = function(I, l, d) {
                  var D = e2.firstOrUndefined(l);
                  D ? this.insertNodeBefore(I, D, d) : this.insertNodeAt(I, l.pos, d);
                }, H.prototype.insertNodeBefore = function(I, l, d, D, fe) {
                  D === void 0 && (D = false), fe === void 0 && (fe = {}), this.insertNodeAt(I, T(I, l, fe), d, this.getOptionsForInsertNodeBefore(l, d, D));
                }, H.prototype.insertModifierAt = function(I, l, d, D) {
                  D === void 0 && (D = {}), this.insertNodeAt(I, l, e2.factory.createToken(d), D);
                }, H.prototype.insertModifierBefore = function(I, l, d) {
                  return this.insertModifierAt(I, d.getStart(I), l, { suffix: " " });
                }, H.prototype.insertCommentBeforeLine = function(I, l, d, D) {
                  var fe = e2.getStartPositionOfLine(l, I), g = e2.getFirstNonSpaceCharacterPosition(I.text, fe), ne = P(I, g), ue = e2.getTouchingToken(I, ne ? g : d), We = I.text.slice(fe, g), Fe = "".concat(ne ? "" : this.newLineCharacter, "//").concat(D).concat(this.newLineCharacter).concat(We);
                  this.insertText(I, ue.getStart(I), Fe);
                }, H.prototype.insertJsdocCommentBefore = function(I, l, d) {
                  var D = l.getStart(I);
                  if (l.jsDoc)
                    for (var fe = 0, g = l.jsDoc; fe < g.length; fe++) {
                      var ne = g[fe];
                      this.deleteRange(I, { pos: e2.getLineStartPositionForPosition(ne.getStart(I), I), end: b(I, ne, {}) });
                    }
                  var ue = e2.getPrecedingNonSpaceCharacterPosition(I.text, D - 1), We = I.text.slice(ue, D);
                  this.insertNodeAt(I, D, d, { suffix: this.newLineCharacter + We });
                }, H.prototype.createJSDocText = function(I, l) {
                  var d = e2.flatMap(l.jsDoc, function(fe) {
                    return e2.isString(fe.comment) ? e2.factory.createJSDocText(fe.comment) : fe.comment;
                  }), D = e2.singleOrUndefined(l.jsDoc);
                  return D && e2.positionsAreOnSameLine(D.pos, D.end, I) && e2.length(d) === 0 ? void 0 : e2.factory.createNodeArray(e2.intersperse(d, e2.factory.createJSDocText(`
`)));
                }, H.prototype.replaceJSDocComment = function(I, l, d) {
                  this.insertJsdocCommentBefore(I, R(l), e2.factory.createJSDocComment(this.createJSDocText(I, l), e2.factory.createNodeArray(d)));
                }, H.prototype.addJSDocTags = function(I, l, d) {
                  var D = e2.flatMapToMutable(l.jsDoc, function(g) {
                    return g.tags;
                  }), fe = d.filter(function(g) {
                    return !D.some(function(ne, ue) {
                      var We = q(ne, g);
                      return We && (D[ue] = We), !!We;
                    });
                  });
                  this.replaceJSDocComment(I, l, Ve(Ve([], D, true), fe, true));
                }, H.prototype.filterJSDocTags = function(I, l, d) {
                  this.replaceJSDocComment(I, l, e2.filter(e2.flatMapToMutable(l.jsDoc, function(D) {
                    return D.tags;
                  }), d));
                }, H.prototype.replaceRangeWithText = function(I, l, d) {
                  this.changes.push({ kind: oe.Text, sourceFile: I, range: l, text: d });
                }, H.prototype.insertText = function(I, l, d) {
                  this.replaceRangeWithText(I, e2.createRange(l), d);
                }, H.prototype.tryInsertTypeAnnotation = function(I, l, d) {
                  var D, fe;
                  if (e2.isFunctionLike(l)) {
                    if (fe = e2.findChildOfKind(l, 21, I), !fe) {
                      if (!e2.isArrowFunction(l))
                        return false;
                      fe = e2.first(l.parameters);
                    }
                  } else
                    fe = (D = l.kind === 254 ? l.exclamationToken : l.questionToken) !== null && D !== void 0 ? D : l.name;
                  return this.insertNodeAt(I, fe.end, d, { prefix: ": " }), true;
                }, H.prototype.tryInsertThisTypeAnnotation = function(I, l, d) {
                  var D = e2.findChildOfKind(l, 20, I).getStart(I) + 1, fe = l.parameters.length ? ", " : "";
                  this.insertNodeAt(I, D, d, { prefix: "this: ", suffix: fe });
                }, H.prototype.insertTypeParameters = function(I, l, d) {
                  var D = (e2.findChildOfKind(l, 20, I) || e2.first(l.parameters)).getStart(I);
                  this.insertNodesAt(I, D, d, { prefix: "<", suffix: ">", joiner: ", " });
                }, H.prototype.getOptionsForInsertNodeBefore = function(I, l, d) {
                  return e2.isStatement(I) || e2.isClassElement(I) ? { suffix: d ? this.newLineCharacter + this.newLineCharacter : this.newLineCharacter } : e2.isVariableDeclaration(I) ? { suffix: ", " } : e2.isParameter(I) ? e2.isParameter(l) ? { suffix: ", " } : {} : e2.isStringLiteral(I) && e2.isImportDeclaration(I.parent) || e2.isNamedImports(I) ? { suffix: ", " } : e2.isImportSpecifier(I) ? { suffix: "," + (d ? this.newLineCharacter : " ") } : e2.Debug.failBadSyntaxKind(I);
                }, H.prototype.insertNodeAtConstructorStart = function(I, l, d) {
                  var D = e2.firstOrUndefined(l.body.statements);
                  !D || !l.body.multiLine ? this.replaceConstructorBody(I, l, Ve([d], l.body.statements, true)) : this.insertNodeBefore(I, D, d);
                }, H.prototype.insertNodeAtConstructorStartAfterSuperCall = function(I, l, d) {
                  var D = e2.find(l.body.statements, function(fe) {
                    return e2.isExpressionStatement(fe) && e2.isSuperCall(fe.expression);
                  });
                  !D || !l.body.multiLine ? this.replaceConstructorBody(I, l, Ve(Ve([], l.body.statements, true), [d], false)) : this.insertNodeAfter(I, D, d);
                }, H.prototype.insertNodeAtConstructorEnd = function(I, l, d) {
                  var D = e2.lastOrUndefined(l.body.statements);
                  !D || !l.body.multiLine ? this.replaceConstructorBody(I, l, Ve(Ve([], l.body.statements, true), [d], false)) : this.insertNodeAfter(I, D, d);
                }, H.prototype.replaceConstructorBody = function(I, l, d) {
                  this.replaceNode(I, l.body, e2.factory.createBlock(d, true));
                }, H.prototype.insertNodeAtEndOfScope = function(I, l, d) {
                  var D = T(I, l.getLastToken(), {});
                  this.insertNodeAt(I, D, d, { prefix: e2.isLineBreak(I.text.charCodeAt(l.getLastToken().pos)) ? this.newLineCharacter : this.newLineCharacter + this.newLineCharacter, suffix: this.newLineCharacter });
                }, H.prototype.insertMemberAtStart = function(I, l, d) {
                  this.insertNodeAtStartWorker(I, l, d);
                }, H.prototype.insertNodeAtObjectStart = function(I, l, d) {
                  this.insertNodeAtStartWorker(I, l, d);
                }, H.prototype.insertNodeAtStartWorker = function(I, l, d) {
                  var D, fe = (D = this.guessIndentationFromExistingMembers(I, l)) !== null && D !== void 0 ? D : this.computeIndentationForNewMember(I, l);
                  this.insertNodeAt(I, ee(l).pos, d, this.getInsertNodeAtStartInsertOptions(I, l, fe));
                }, H.prototype.guessIndentationFromExistingMembers = function(I, l) {
                  for (var d, D = l, fe = 0, g = ee(l); fe < g.length; fe++) {
                    var ne = g[fe];
                    if (e2.rangeStartPositionsAreOnSameLine(D, ne, I))
                      return;
                    var ue = ne.getStart(I), We = e2.formatting.SmartIndenter.findFirstNonWhitespaceColumn(e2.getLineStartPositionForPosition(ue, I), ue, I, this.formatContext.options);
                    if (d === void 0)
                      d = We;
                    else if (We !== d)
                      return;
                    D = ne;
                  }
                  return d;
                }, H.prototype.computeIndentationForNewMember = function(I, l) {
                  var d, D = l.getStart(I);
                  return e2.formatting.SmartIndenter.findFirstNonWhitespaceColumn(e2.getLineStartPositionForPosition(D, I), D, I, this.formatContext.options) + ((d = this.formatContext.options.indentSize) !== null && d !== void 0 ? d : 4);
                }, H.prototype.getInsertNodeAtStartInsertOptions = function(I, l, d) {
                  var D = ee(l), fe = D.length === 0, g = e2.addToSeen(this.classesWithNodesInsertedAtStart, e2.getNodeId(l), { node: l, sourceFile: I }), ne = e2.isObjectLiteralExpression(l) && (!e2.isJsonSourceFile(I) || !fe), ue = e2.isObjectLiteralExpression(l) && e2.isJsonSourceFile(I) && fe && !g;
                  return { indentation: d, prefix: (ue ? "," : "") + this.newLineCharacter, suffix: ne ? "," : "" };
                }, H.prototype.insertNodeAfterComma = function(I, l, d) {
                  var D = this.insertNodeAfterWorker(I, this.nextCommaToken(I, l) || l, d);
                  this.insertNodeAt(I, D, d, this.getInsertNodeAfterOptions(I, l));
                }, H.prototype.insertNodeAfter = function(I, l, d) {
                  var D = this.insertNodeAfterWorker(I, l, d);
                  this.insertNodeAt(I, D, d, this.getInsertNodeAfterOptions(I, l));
                }, H.prototype.insertNodeAtEndOfList = function(I, l, d) {
                  this.insertNodeAt(I, l.end, d, { prefix: ", " });
                }, H.prototype.insertNodesAfter = function(I, l, d) {
                  var D = this.insertNodeAfterWorker(I, l, e2.first(d));
                  this.insertNodesAt(I, D, d, this.getInsertNodeAfterOptions(I, l));
                }, H.prototype.insertNodeAfterWorker = function(I, l, d) {
                  k(l, d) && I.text.charCodeAt(l.end - 1) !== 59 && this.replaceRange(I, e2.createRange(l.end), e2.factory.createToken(26));
                  var D = b(I, l, {});
                  return D;
                }, H.prototype.getInsertNodeAfterOptions = function(I, l) {
                  var d = this.getInsertNodeAfterOptionsWorker(l);
                  return Ke(Ke({}, d), { prefix: l.end === I.end && e2.isStatement(l) ? d.prefix ? `
`.concat(d.prefix) : `
` : d.prefix });
                }, H.prototype.getInsertNodeAfterOptionsWorker = function(I) {
                  switch (I.kind) {
                    case 257:
                    case 261:
                      return { prefix: this.newLineCharacter, suffix: this.newLineCharacter };
                    case 254:
                    case 10:
                    case 79:
                      return { prefix: ", " };
                    case 296:
                      return { suffix: "," + this.newLineCharacter };
                    case 93:
                      return { prefix: " " };
                    case 164:
                      return {};
                    default:
                      return e2.Debug.assert(e2.isStatement(I) || e2.isClassOrTypeElement(I)), { suffix: this.newLineCharacter };
                  }
                }, H.prototype.insertName = function(I, l, d) {
                  if (e2.Debug.assert(!l.name), l.kind === 214) {
                    var D = e2.findChildOfKind(l, 38, I), fe = e2.findChildOfKind(l, 20, I);
                    fe ? (this.insertNodesAt(I, fe.getStart(I), [e2.factory.createToken(98), e2.factory.createIdentifier(d)], { joiner: " " }), U(this, I, D)) : (this.insertText(I, e2.first(l.parameters).getStart(I), "function ".concat(d, "(")), this.replaceRange(I, D, e2.factory.createToken(21))), l.body.kind !== 235 && (this.insertNodesAt(I, l.body.getStart(I), [e2.factory.createToken(18), e2.factory.createToken(105)], { joiner: " ", suffix: " " }), this.insertNodesAt(I, l.body.end, [e2.factory.createToken(26), e2.factory.createToken(19)], { joiner: " " }));
                  } else {
                    var g = e2.findChildOfKind(l, l.kind === 213 ? 98 : 84, I).end;
                    this.insertNodeAt(I, g, e2.factory.createIdentifier(d), { prefix: " " });
                  }
                }, H.prototype.insertExportModifier = function(I, l) {
                  this.insertText(I, l.getStart(I), "export ");
                }, H.prototype.insertImportSpecifierAtIndex = function(I, l, d, D) {
                  var fe = d.elements[D - 1];
                  fe ? this.insertNodeInListAfter(I, fe, l) : this.insertNodeBefore(I, d.elements[0], l, !e2.positionsAreOnSameLine(d.elements[0].getStart(), d.parent.parent.getStart(), I));
                }, H.prototype.insertNodeInListAfter = function(I, l, d, D) {
                  if (D === void 0 && (D = e2.formatting.SmartIndenter.getContainingList(l, I)), !D) {
                    e2.Debug.fail("node is not a list element");
                    return;
                  }
                  var fe = e2.indexOfNode(D, l);
                  if (!(fe < 0)) {
                    var g = l.getEnd();
                    if (fe !== D.length - 1) {
                      var ne = e2.getTokenAtPosition(I, l.end);
                      if (ne && se(l, ne)) {
                        var ue = D[fe + 1], We = p(I.text, ue.getFullStart()), Fe = "".concat(e2.tokenToString(ne.kind)).concat(I.text.substring(ne.end, We));
                        this.insertNodesAt(I, We, [d], { suffix: Fe });
                      }
                    } else {
                      var Z2 = l.getStart(I), Be = e2.getLineStartPositionForPosition(Z2, I), ge = void 0, Re = false;
                      if (D.length === 1)
                        ge = 27;
                      else {
                        var ze = e2.findPrecedingToken(l.pos, I);
                        ge = se(l, ze) ? ze.kind : 27;
                        var Ee = e2.getLineStartPositionForPosition(D[fe - 1].getStart(I), I);
                        Re = Ee !== Be;
                      }
                      if (m2(I.text, l.end) && (Re = true), Re) {
                        this.replaceRange(I, e2.createRange(g), e2.factory.createToken(ge));
                        for (var He = e2.formatting.SmartIndenter.findFirstNonWhitespaceColumn(Be, Z2, I, this.formatContext.options), rr = e2.skipTrivia(I.text, g, true, false); rr !== g && e2.isLineBreak(I.text.charCodeAt(rr - 1)); )
                          rr--;
                        this.replaceRange(I, e2.createRange(rr), d, { indentation: He, prefix: this.newLineCharacter });
                      } else
                        this.replaceRange(I, e2.createRange(g), d, { prefix: "".concat(e2.tokenToString(ge), " ") });
                    }
                  }
                }, H.prototype.parenthesizeExpression = function(I, l) {
                  this.replaceRange(I, e2.rangeOfNode(l), e2.factory.createParenthesizedExpression(l));
                }, H.prototype.finishClassesWithNodesInsertedAtStart = function() {
                  var I = this;
                  this.classesWithNodesInsertedAtStart.forEach(function(l) {
                    var d = l.node, D = l.sourceFile, fe = ve(d, D), g = fe[0], ne = fe[1];
                    if (g !== void 0 && ne !== void 0) {
                      var ue = ee(d).length === 0, We = e2.positionsAreOnSameLine(g, ne, D);
                      ue && We && g !== ne - 1 && I.deleteRange(D, e2.createRange(g, ne - 1)), We && I.insertText(D, ne - 1, I.newLineCharacter);
                    }
                  });
                }, H.prototype.finishDeleteDeclarations = function() {
                  for (var I = this, l = new e2.Set(), d = function(Fe, Z2) {
                    D.deletedNodes.some(function(Be) {
                      return Be.sourceFile === Fe && e2.rangeContainsRangeExclusive(Be.node, Z2);
                    }) || (e2.isArray(Z2) ? D.deleteRange(Fe, e2.rangeOfTypeParameters(Fe, Z2)) : Y.deleteDeclaration(D, l, Fe, Z2));
                  }, D = this, fe = 0, g = this.deletedNodes; fe < g.length; fe++) {
                    var ne = g[fe], ue = ne.sourceFile, We = ne.node;
                    d(ue, We);
                  }
                  l.forEach(function(Fe) {
                    var Z2 = Fe.getSourceFile(), Be = e2.formatting.SmartIndenter.getContainingList(Fe, Z2);
                    if (Fe === e2.last(Be)) {
                      var ge = e2.findLastIndex(Be, function(Re) {
                        return !l.has(Re);
                      }, Be.length - 2);
                      ge !== -1 && I.deleteRange(Z2, { pos: Be[ge].end, end: O(Z2, Be[ge + 1]) });
                    }
                  });
                }, H.prototype.getChanges = function(I) {
                  this.finishDeleteDeclarations(), this.finishClassesWithNodesInsertedAtStart();
                  for (var l = F2.getTextChangesFromChanges(this.changes, this.newLineCharacter, this.formatContext, I), d = 0, D = this.newFiles; d < D.length; d++) {
                    var fe = D[d], g = fe.oldFile, ne = fe.fileName, ue = fe.statements;
                    l.push(F2.newFileChanges(g, ne, ue, this.newLineCharacter, this.formatContext));
                  }
                  return l;
                }, H.prototype.createNewFile = function(I, l, d) {
                  this.newFiles.push({ oldFile: I, fileName: l, statements: d });
                }, H;
              }();
              C.ChangeTracker = ie;
              function R(H) {
                if (H.kind !== 214)
                  return H;
                var I = H.parent.kind === 167 ? H.parent : H.parent.parent;
                return I.jsDoc = H.jsDoc, I.jsDocCache = H.jsDocCache, I;
              }
              function q(H, I) {
                if (H.kind === I.kind)
                  switch (H.kind) {
                    case 340: {
                      var l = H, d = I;
                      return e2.isIdentifier(l.name) && e2.isIdentifier(d.name) && l.name.escapedText === d.name.escapedText ? e2.factory.createJSDocParameterTag(void 0, d.name, false, d.typeExpression, d.isNameFirst, l.comment) : void 0;
                    }
                    case 341:
                      return e2.factory.createJSDocReturnTag(void 0, I.typeExpression, H.comment);
                    case 343:
                      return e2.factory.createJSDocTypeTag(void 0, I.typeExpression, H.comment);
                  }
              }
              function O(H, I) {
                return e2.skipTrivia(H.text, T(H, I, { leadingTriviaOption: le.IncludeAll }), false, true);
              }
              function ve(H, I) {
                var l = e2.findChildOfKind(H, 18, I), d = e2.findChildOfKind(H, 19, I);
                return [l == null ? void 0 : l.end, d == null ? void 0 : d.end];
              }
              function ee(H) {
                return e2.isObjectLiteralExpression(H) ? H.properties : H.members;
              }
              function he(H, I, l, d) {
                return F2.newFileChangesWorker(void 0, I, H, l, d);
              }
              C.getNewFileText = he;
              var F2;
              (function(H) {
                function I(ne, ue, We, Fe) {
                  return e2.mapDefined(e2.group(ne, function(Z2) {
                    return Z2.sourceFile.path;
                  }), function(Z2) {
                    for (var Be = Z2[0].sourceFile, ge = e2.stableSort(Z2, function(He, rr) {
                      return He.range.pos - rr.range.pos || He.range.end - rr.range.end;
                    }), Re = function(He) {
                      e2.Debug.assert(ge[He].range.end <= ge[He + 1].range.pos, "Changes overlap", function() {
                        return "".concat(JSON.stringify(ge[He].range), " and ").concat(JSON.stringify(ge[He + 1].range));
                      });
                    }, ze = 0; ze < ge.length - 1; ze++)
                      Re(ze);
                    var Ee = e2.mapDefined(ge, function(He) {
                      var rr = e2.createTextSpanFromRange(He.range), Ie = D(He, Be, ue, We, Fe);
                      if (!(rr.length === Ie.length && e2.stringContainsAt(Be.text, Ie, rr.start)))
                        return e2.createTextChange(rr, Ie);
                    });
                    return Ee.length > 0 ? { fileName: Be.fileName, textChanges: Ee } : void 0;
                  });
                }
                H.getTextChangesFromChanges = I;
                function l(ne, ue, We, Fe, Z2) {
                  var Be = d(ne, e2.getScriptKindFromFileName(ue), We, Fe, Z2);
                  return { fileName: ue, textChanges: [e2.createTextChange(e2.createTextSpan(0, 0), Be)], isNewFile: true };
                }
                H.newFileChanges = l;
                function d(ne, ue, We, Fe, Z2) {
                  var Be = We.map(function(ze) {
                    return ze === 4 ? "" : g(ze, ne, Fe).text;
                  }).join(Fe), ge = e2.createSourceFile("any file name", Be, 99, true, ue), Re = e2.formatting.formatDocument(ge, Z2);
                  return x2(Be, Re) + Fe;
                }
                H.newFileChangesWorker = d;
                function D(ne, ue, We, Fe, Z2) {
                  var Be;
                  if (ne.kind === oe.Remove)
                    return "";
                  if (ne.kind === oe.Text)
                    return ne.text;
                  var ge = ne.options, Re = ge === void 0 ? {} : ge, ze = ne.range.pos, Ee = function(Ie) {
                    return fe(Ie, ue, ze, Re, We, Fe, Z2);
                  }, He = ne.kind === oe.ReplaceWithMultipleNodes ? ne.nodes.map(function(Ie) {
                    return e2.removeSuffix(Ee(Ie), We);
                  }).join(((Be = ne.options) === null || Be === void 0 ? void 0 : Be.joiner) || We) : Ee(ne.node), rr = Re.indentation !== void 0 || e2.getLineStartPositionForPosition(ze, ue) === ze ? He : He.replace(/^\s+/, "");
                  return (Re.prefix || "") + rr + (!Re.suffix || e2.endsWith(rr, Re.suffix) ? "" : Re.suffix);
                }
                function fe(ne, ue, We, Fe, Z2, Be, ge) {
                  var Re = Fe.indentation, ze = Fe.prefix, Ee = Fe.delta, He = g(ne, ue, Z2), rr = He.node, Ie = He.text;
                  ge && ge(rr, Ie);
                  var _e = e2.getFormatCodeSettingsForWriting(Be, ue), we = Re !== void 0 ? Re : e2.formatting.SmartIndenter.getIndentation(We, ue, _e, ze === Z2 || e2.getLineStartPositionForPosition(We, ue) === We);
                  Ee === void 0 && (Ee = e2.formatting.SmartIndenter.shouldIndentChildNode(_e, ne) && _e.indentSize || 0);
                  var de = { text: Ie, getLineAndCharacterOfPosition: function(Ae) {
                    return e2.getLineAndCharacterOfPosition(this, Ae);
                  } }, ye = e2.formatting.formatNodeGivenIndentation(rr, de, ue.languageVariant, we, Ee, Ke(Ke({}, Be), { options: _e }));
                  return x2(Ie, ye);
                }
                function g(ne, ue, We) {
                  var Fe = V(We), Z2 = e2.getNewLineKind(We);
                  return e2.createPrinter({ newLine: Z2, neverAsciiEscape: true, preserveSourceNewlines: true, terminateUnterminatedLiterals: true }, Fe).writeNode(4, ne, ue, Fe), { text: Fe.getText(), node: A2(ne) };
                }
                H.getNonformattedText = g;
              })(F2 || (F2 = {}));
              function x2(H, I) {
                for (var l = I.length - 1; l >= 0; l--) {
                  var d = I[l], D = d.span, fe = d.newText;
                  H = "".concat(H.substring(0, D.start)).concat(fe).concat(H.substring(e2.textSpanEnd(D)));
                }
                return H;
              }
              C.applyChanges = x2;
              function X(H) {
                return e2.skipTrivia(H, 0) === H.length;
              }
              var $ = Ke(Ke({}, e2.nullTransformationContext), { factory: e2.createNodeFactory(e2.nullTransformationContext.factory.flags | 1, e2.nullTransformationContext.factory.baseFactory) });
              function A2(H) {
                var I = e2.visitEachChild(H, A2, $, y, A2), l = e2.nodeIsSynthesized(I) ? I : Object.create(I);
                return e2.setTextRangePosEnd(l, w(H), E(H)), l;
              }
              C.assignPositionsToNode = A2;
              function y(H, I, l, d, D) {
                var fe = e2.visitNodes(H, I, l, d, D);
                if (!fe)
                  return fe;
                var g = fe === H ? e2.factory.createNodeArray(fe.slice(0)) : fe;
                return e2.setTextRangePosEnd(g, w(H), E(H)), g;
              }
              function V(H) {
                var I = 0, l = e2.createTextWriter(H), d = function(lr) {
                  lr && B(lr, I);
                }, D = function(lr) {
                  lr && Q(lr, I);
                }, fe = function(lr) {
                  lr && B(lr, I);
                }, g = function(lr) {
                  lr && Q(lr, I);
                }, ne = function(lr) {
                  lr && B(lr, I);
                }, ue = function(lr) {
                  lr && Q(lr, I);
                };
                function We(lr, be) {
                  if (be || !X(lr)) {
                    I = l.getTextPos();
                    for (var Ge = 0; e2.isWhiteSpaceLike(lr.charCodeAt(lr.length - Ge - 1)); )
                      Ge++;
                    I -= Ge;
                  }
                }
                function Fe(lr) {
                  l.write(lr), We(lr, false);
                }
                function Z2(lr) {
                  l.writeComment(lr);
                }
                function Be(lr) {
                  l.writeKeyword(lr), We(lr, false);
                }
                function ge(lr) {
                  l.writeOperator(lr), We(lr, false);
                }
                function Re(lr) {
                  l.writePunctuation(lr), We(lr, false);
                }
                function ze(lr) {
                  l.writeTrailingSemicolon(lr), We(lr, false);
                }
                function Ee(lr) {
                  l.writeParameter(lr), We(lr, false);
                }
                function He(lr) {
                  l.writeProperty(lr), We(lr, false);
                }
                function rr(lr) {
                  l.writeSpace(lr), We(lr, false);
                }
                function Ie(lr) {
                  l.writeStringLiteral(lr), We(lr, false);
                }
                function _e(lr, be) {
                  l.writeSymbol(lr, be), We(lr, false);
                }
                function we(lr) {
                  l.writeLine(lr);
                }
                function de() {
                  l.increaseIndent();
                }
                function ye() {
                  l.decreaseIndent();
                }
                function Ae() {
                  return l.getText();
                }
                function er(lr) {
                  l.rawWrite(lr), We(lr, false);
                }
                function ir(lr) {
                  l.writeLiteral(lr), We(lr, true);
                }
                function Cr() {
                  return l.getTextPos();
                }
                function Ye() {
                  return l.getLine();
                }
                function Br() {
                  return l.getColumn();
                }
                function Er() {
                  return l.getIndent();
                }
                function Ne() {
                  return l.isAtStartOfLine();
                }
                function n() {
                  l.clear(), I = 0;
                }
                return { onBeforeEmitNode: d, onAfterEmitNode: D, onBeforeEmitNodeArray: fe, onAfterEmitNodeArray: g, onBeforeEmitToken: ne, onAfterEmitToken: ue, write: Fe, writeComment: Z2, writeKeyword: Be, writeOperator: ge, writePunctuation: Re, writeTrailingSemicolon: ze, writeParameter: Ee, writeProperty: He, writeSpace: rr, writeStringLiteral: Ie, writeSymbol: _e, writeLine: we, increaseIndent: de, decreaseIndent: ye, getText: Ae, rawWrite: er, writeLiteral: ir, getTextPos: Cr, getLine: Ye, getColumn: Br, getIndent: Er, isAtStartOfLine: Ne, hasTrailingComment: function() {
                  return l.hasTrailingComment();
                }, hasTrailingWhitespace: function() {
                  return l.hasTrailingWhitespace();
                }, clear: n };
              }
              C.createWriter = V;
              function L(H) {
                for (var I, l = 0, d = H.statements; l < d.length; l++) {
                  var D = d[l];
                  if (e2.isPrologueDirective(D))
                    I = D;
                  else
                    break;
                }
                var fe = 0, g = H.text;
                if (I)
                  return fe = I.end, He(), fe;
                var ne = e2.getShebang(g);
                ne !== void 0 && (fe = ne.length, He());
                var ue = e2.getLeadingCommentRanges(g, fe);
                if (!ue)
                  return fe;
                for (var We, Fe, Z2 = 0, Be = ue; Z2 < Be.length; Z2++) {
                  var ge = Be[Z2];
                  if (ge.kind === 3) {
                    if (e2.isPinnedComment(g, ge.pos)) {
                      We = { range: ge, pinnedOrTripleSlash: true };
                      continue;
                    }
                  } else if (e2.isRecognizedTripleSlashComment(g, ge.pos, ge.end)) {
                    We = { range: ge, pinnedOrTripleSlash: true };
                    continue;
                  }
                  if (We) {
                    if (We.pinnedOrTripleSlash)
                      break;
                    var Re = H.getLineAndCharacterOfPosition(ge.pos).line, ze = H.getLineAndCharacterOfPosition(We.range.end).line;
                    if (Re >= ze + 2)
                      break;
                  }
                  if (H.statements.length) {
                    Fe === void 0 && (Fe = H.getLineAndCharacterOfPosition(H.statements[0].getStart()).line);
                    var Ee = H.getLineAndCharacterOfPosition(ge.end).line;
                    if (Fe < Ee + 2)
                      break;
                  }
                  We = { range: ge, pinnedOrTripleSlash: false };
                }
                return We && (fe = We.range.end, He()), fe;
                function He() {
                  if (fe < g.length) {
                    var rr = g.charCodeAt(fe);
                    e2.isLineBreak(rr) && (fe++, fe < g.length && rr === 13 && g.charCodeAt(fe) === 10 && fe++);
                  }
                }
              }
              function P(H, I) {
                return !e2.isInComment(H, I) && !e2.isInString(H, I) && !e2.isInTemplateString(H, I) && !e2.isInJSXText(H, I);
              }
              C.isValidLocationToAddComment = P;
              function k(H, I) {
                return (e2.isPropertySignature(H) || e2.isPropertyDeclaration(H)) && e2.isClassOrTypeElement(I) && I.name.kind === 162 || e2.isStatementButNotDeclaration(H) && e2.isStatementButNotDeclaration(I);
              }
              var Y;
              (function(H) {
                function I(fe, g, ne, ue) {
                  switch (ue.kind) {
                    case 164: {
                      var We = ue.parent;
                      e2.isArrowFunction(We) && We.parameters.length === 1 && !e2.findChildOfKind(We, 20, ne) ? fe.replaceNodeWithText(ne, ue, "()") : j(fe, g, ne, ue);
                      break;
                    }
                    case 266:
                    case 265:
                      var Fe = ne.imports.length && ue === e2.first(ne.imports).parent || ue === e2.find(ne.statements, e2.isAnyImportSyntax);
                      U(fe, ne, ue, { leadingTriviaOption: Fe ? le.Exclude : e2.hasJSDocNodes(ue) ? le.JSDoc : le.StartLine });
                      break;
                    case 203:
                      var Z2 = ue.parent, Be = Z2.kind === 202 && ue !== e2.last(Z2.elements);
                      Be ? U(fe, ne, ue) : j(fe, g, ne, ue);
                      break;
                    case 254:
                      D(fe, g, ne, ue);
                      break;
                    case 163:
                      j(fe, g, ne, ue);
                      break;
                    case 270:
                      var ge = ue.parent;
                      ge.elements.length === 1 ? d(fe, ne, ge) : j(fe, g, ne, ue);
                      break;
                    case 268:
                      d(fe, ne, ue);
                      break;
                    case 26:
                      U(fe, ne, ue, { trailingTriviaOption: N.Exclude });
                      break;
                    case 98:
                      U(fe, ne, ue, { leadingTriviaOption: le.Exclude });
                      break;
                    case 257:
                    case 256:
                      U(fe, ne, ue, { leadingTriviaOption: e2.hasJSDocNodes(ue) ? le.JSDoc : le.StartLine });
                      break;
                    default:
                      ue.parent ? e2.isImportClause(ue.parent) && ue.parent.name === ue ? l(fe, ne, ue.parent) : e2.isCallExpression(ue.parent) && e2.contains(ue.parent.arguments, ue) ? j(fe, g, ne, ue) : U(fe, ne, ue) : U(fe, ne, ue);
                  }
                }
                H.deleteDeclaration = I;
                function l(fe, g, ne) {
                  if (!ne.namedBindings)
                    U(fe, g, ne.parent);
                  else {
                    var ue = ne.name.getStart(g), We = e2.getTokenAtPosition(g, ne.name.end);
                    if (We && We.kind === 27) {
                      var Fe = e2.skipTrivia(g.text, We.end, false, true);
                      fe.deleteRange(g, { pos: ue, end: Fe });
                    } else
                      U(fe, g, ne.name);
                  }
                }
                function d(fe, g, ne) {
                  if (ne.parent.name) {
                    var ue = e2.Debug.checkDefined(e2.getTokenAtPosition(g, ne.pos - 1));
                    fe.deleteRange(g, { pos: ue.getStart(g), end: ne.end });
                  } else {
                    var We = e2.getAncestor(ne, 266);
                    U(fe, g, We);
                  }
                }
                function D(fe, g, ne, ue) {
                  var We = ue.parent;
                  if (We.kind === 292) {
                    fe.deleteNodeRange(ne, e2.findChildOfKind(We, 20, ne), e2.findChildOfKind(We, 21, ne));
                    return;
                  }
                  if (We.declarations.length !== 1) {
                    j(fe, g, ne, ue);
                    return;
                  }
                  var Fe = We.parent;
                  switch (Fe.kind) {
                    case 244:
                    case 243:
                      fe.replaceNode(ne, ue, e2.factory.createObjectLiteralExpression());
                      break;
                    case 242:
                      U(fe, ne, We);
                      break;
                    case 237:
                      U(fe, ne, Fe, { leadingTriviaOption: e2.hasJSDocNodes(Fe) ? le.JSDoc : le.StartLine });
                      break;
                    default:
                      e2.Debug.assertNever(Fe);
                  }
                }
              })(Y || (Y = {}));
              function U(H, I, l, d) {
                d === void 0 && (d = { leadingTriviaOption: le.IncludeAll });
                var D = T(I, l, d), fe = b(I, l, d);
                H.deleteRange(I, { pos: D, end: fe });
              }
              C.deleteNode = U;
              function j(H, I, l, d) {
                var D = e2.Debug.checkDefined(e2.formatting.SmartIndenter.getContainingList(d, l)), fe = e2.indexOfNode(D, d);
                if (e2.Debug.assert(fe !== -1), D.length === 1) {
                  U(H, l, d);
                  return;
                }
                e2.Debug.assert(!I.has(d), "Deleting a node twice"), I.add(d), H.deleteRange(l, { pos: O(l, d), end: fe === D.length - 1 ? b(l, d, {}) : O(l, D[fe + 1]) });
              }
            })(a = e2.textChanges || (e2.textChanges = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = e2.createMultiMap(), B = new e2.Map();
              function E(ie, R, q) {
                return N(ie, e2.diagnosticToString(q), R, void 0, void 0);
              }
              C.createCodeFixActionWithoutFixAll = E;
              function Q(ie, R, q, O, ve, ee) {
                return N(ie, e2.diagnosticToString(q), R, O, e2.diagnosticToString(ve), ee);
              }
              C.createCodeFixAction = Q;
              function le(ie, R, q, O, ve, ee) {
                return N(ie, e2.diagnosticToString(q), R, O, ve && e2.diagnosticToString(ve), ee);
              }
              C.createCodeFixActionMaybeFixAll = le;
              function N(ie, R, q, O, ve, ee) {
                return { fixName: ie, description: R, changes: q, fixId: O, fixAllDescription: ve, commands: ee ? [ee] : void 0 };
              }
              function p(ie) {
                for (var R = 0, q = ie.errorCodes; R < q.length; R++) {
                  var O = q[R];
                  w.add(String(O), ie);
                }
                if (ie.fixIds)
                  for (var ve = 0, ee = ie.fixIds; ve < ee.length; ve++) {
                    var he = ee[ve];
                    e2.Debug.assert(!B.has(he)), B.set(he, ie);
                  }
              }
              C.registerCodeFix = p;
              function m2() {
                return e2.arrayFrom(w.keys());
              }
              C.getSupportedErrorCodes = m2;
              function G(ie, R) {
                for (var q = ie.errorCodes, O = 0, ve = 0, ee = R; ve < ee.length; ve++) {
                  var he = ee[ve];
                  if (e2.contains(q, he.code) && O++, O > 1)
                    break;
                }
                var F2 = O < 2;
                return function(x2) {
                  var X = x2.fixId, $ = x2.fixAllDescription, A2 = pr(x2, ["fixId", "fixAllDescription"]);
                  return F2 ? A2 : Ke(Ke({}, A2), { fixId: X, fixAllDescription: $ });
                };
              }
              function oe(ie) {
                var R = J(ie), q = w.get(String(ie.errorCode));
                return e2.flatMap(q, function(O) {
                  return e2.map(O.getCodeActions(ie), G(O, R));
                });
              }
              C.getFixes = oe;
              function f4(ie) {
                return B.get(e2.cast(ie.fixId, e2.isString)).getAllCodeActions(ie);
              }
              C.getAllFixes = f4;
              function T(ie, R) {
                return { changes: ie, commands: R };
              }
              C.createCombinedCodeActions = T;
              function K(ie, R) {
                return { fileName: ie, textChanges: R };
              }
              C.createFileTextChanges = K;
              function b(ie, R, q) {
                var O = [], ve = e2.textChanges.ChangeTracker.with(ie, function(ee) {
                  return se(ie, R, function(he) {
                    return q(ee, he, O);
                  });
                });
                return T(ve, O.length === 0 ? void 0 : O);
              }
              C.codeFixAll = b;
              function se(ie, R, q) {
                for (var O = 0, ve = J(ie); O < ve.length; O++) {
                  var ee = ve[O];
                  e2.contains(R, ee.code) && q(ee);
                }
              }
              C.eachDiagnostic = se;
              function J(ie) {
                var R = ie.program, q = ie.sourceFile, O = ie.cancellationToken;
                return Ve(Ve(Ve([], R.getSemanticDiagnostics(q, O), true), R.getSyntacticDiagnostics(q, O), true), e2.computeSuggestionDiagnostics(q, R, O), true);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = new e2.Map();
              function B(le, N) {
                w.set(le, N);
              }
              C.registerRefactor = B;
              function E(le) {
                return e2.arrayFrom(e2.flatMapIterator(w.values(), function(N) {
                  var p;
                  return le.cancellationToken && le.cancellationToken.isCancellationRequested() || !(!((p = N.kinds) === null || p === void 0) && p.some(function(m2) {
                    return C.refactorKindBeginsWith(m2, le.kind);
                  })) ? void 0 : N.getAvailableActions(le);
                }));
              }
              C.getApplicableRefactors = E;
              function Q(le, N, p) {
                var m2 = w.get(N);
                return m2 && m2.getEditsForAction(le, p);
              }
              C.getEditsForRefactor = Q;
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addConvertToUnknownForNonOverlappingTypes", B = [e2.Diagnostics.Conversion_of_type_0_to_type_1_may_be_a_mistake_because_neither_type_sufficiently_overlaps_with_the_other_If_this_was_intentional_convert_the_expression_to_unknown_first.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = Q(N.sourceFile, N.span.start);
                if (p !== void 0) {
                  var m2 = e2.textChanges.ChangeTracker.with(N, function(G) {
                    return E(G, N.sourceFile, p);
                  });
                  return [C.createCodeFixAction(w, m2, e2.Diagnostics.Add_unknown_conversion_for_non_overlapping_types, w, e2.Diagnostics.Add_unknown_to_all_conversions_of_non_overlapping_types)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m2 = Q(p.file, p.start);
                  m2 && E(N, p.file, m2);
                });
              } });
              function E(le, N, p) {
                var m2 = e2.isAsExpression(p) ? e2.factory.createAsExpression(p.expression, e2.factory.createKeywordTypeNode(155)) : e2.factory.createTypeAssertion(e2.factory.createKeywordTypeNode(155), p.expression);
                le.replaceNode(N, p.expression, m2);
              }
              function Q(le, N) {
                if (!e2.isInJSFile(le))
                  return e2.findAncestor(e2.getTokenAtPosition(le, N), function(p) {
                    return e2.isAsExpression(p) || e2.isTypeAssertionExpression(p);
                  });
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              C.registerCodeFix({ errorCodes: [e2.Diagnostics.await_expressions_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code, e2.Diagnostics.for_await_loops_are_only_allowed_at_the_top_level_of_a_file_when_that_file_is_a_module_but_this_file_has_no_imports_or_exports_Consider_adding_an_empty_export_to_make_this_file_a_module.code], getCodeActions: function(B) {
                var E = B.sourceFile, Q = e2.textChanges.ChangeTracker.with(B, function(le) {
                  var N = e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports([]), void 0);
                  le.insertNodeAtEndOfScope(E, E, N);
                });
                return [C.createCodeFixActionWithoutFixAll("addEmptyExportDeclaration", Q, e2.Diagnostics.Add_export_to_make_this_file_into_a_module)];
              } });
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addMissingAsync", B = [e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code, e2.Diagnostics.Type_0_is_not_assignable_to_type_1.code, e2.Diagnostics.Type_0_is_not_comparable_to_type_1.code];
              C.registerCodeFix({ fixIds: [w], errorCodes: B, getCodeActions: function(m2) {
                var G = m2.sourceFile, oe = m2.errorCode, f4 = m2.cancellationToken, T = m2.program, K = m2.span, b = e2.find(T.getTypeChecker().getDiagnostics(G, f4), N(K, oe)), se = b && b.relatedInformation && e2.find(b.relatedInformation, function(R) {
                  return R.code === e2.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
                }), J = le(G, se);
                if (!!J) {
                  var ie = function(R) {
                    return e2.textChanges.ChangeTracker.with(m2, R);
                  };
                  return [E(m2, J, ie)];
                }
              }, getAllCodeActions: function(p) {
                var m2 = p.sourceFile, G = new e2.Set();
                return C.codeFixAll(p, B, function(oe, f4) {
                  var T = f4.relatedInformation && e2.find(f4.relatedInformation, function(se) {
                    return se.code === e2.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
                  }), K = le(m2, T);
                  if (!!K) {
                    var b = function(se) {
                      return se(oe), [];
                    };
                    return E(p, K, b, G);
                  }
                });
              } });
              function E(p, m2, G, oe) {
                var f4 = G(function(T) {
                  return Q(T, p.sourceFile, m2, oe);
                });
                return C.createCodeFixAction(w, f4, e2.Diagnostics.Add_async_modifier_to_containing_function, w, e2.Diagnostics.Add_all_missing_async_modifiers);
              }
              function Q(p, m2, G, oe) {
                if (!(oe && oe.has(e2.getNodeId(G)))) {
                  oe == null || oe.add(e2.getNodeId(G));
                  var f4 = e2.factory.updateModifiers(e2.getSynthesizedDeepClone(G, true), e2.factory.createNodeArray(e2.factory.createModifiersFromModifierFlags(e2.getSyntacticModifierFlags(G) | 256)));
                  p.replaceNode(m2, G, f4);
                }
              }
              function le(p, m2) {
                if (!!m2) {
                  var G = e2.getTokenAtPosition(p, m2.start), oe = e2.findAncestor(G, function(f4) {
                    return f4.getStart(p) < m2.start || f4.getEnd() > e2.textSpanEnd(m2) ? "quit" : (e2.isArrowFunction(f4) || e2.isMethodDeclaration(f4) || e2.isFunctionExpression(f4) || e2.isFunctionDeclaration(f4)) && e2.textSpansEqual(m2, e2.createTextSpanFromNode(f4, p));
                  });
                  return oe;
                }
              }
              function N(p, m2) {
                return function(G) {
                  var oe = G.start, f4 = G.length, T = G.relatedInformation, K = G.code;
                  return e2.isNumber(oe) && e2.isNumber(f4) && e2.textSpansEqual({ start: oe, length: f4 }, p) && K === m2 && !!T && e2.some(T, function(b) {
                    return b.code === e2.Diagnostics.Did_you_mean_to_mark_this_function_as_async.code;
                  });
                };
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addMissingAwait", B = e2.Diagnostics.Property_0_does_not_exist_on_type_1.code, E = [e2.Diagnostics.This_expression_is_not_callable.code, e2.Diagnostics.This_expression_is_not_constructable.code], Q = Ve([e2.Diagnostics.An_arithmetic_operand_must_be_of_type_any_number_bigint_or_an_enum_type.code, e2.Diagnostics.The_left_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code, e2.Diagnostics.The_right_hand_side_of_an_arithmetic_operation_must_be_of_type_any_number_bigint_or_an_enum_type.code, e2.Diagnostics.Operator_0_cannot_be_applied_to_type_1.code, e2.Diagnostics.Operator_0_cannot_be_applied_to_types_1_and_2.code, e2.Diagnostics.This_condition_will_always_return_0_since_the_types_1_and_2_have_no_overlap.code, e2.Diagnostics.This_condition_will_always_return_true_since_this_0_is_always_defined.code, e2.Diagnostics.Type_0_is_not_an_array_type.code, e2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type.code, e2.Diagnostics.Type_0_can_only_be_iterated_through_when_using_the_downlevelIteration_flag_or_with_a_target_of_es2015_or_higher.code, e2.Diagnostics.Type_0_is_not_an_array_type_or_a_string_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code, e2.Diagnostics.Type_0_is_not_an_array_type_or_does_not_have_a_Symbol_iterator_method_that_returns_an_iterator.code, e2.Diagnostics.Type_0_must_have_a_Symbol_iterator_method_that_returns_an_iterator.code, e2.Diagnostics.Type_0_must_have_a_Symbol_asyncIterator_method_that_returns_an_async_iterator.code, e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code, B], E, true);
              C.registerCodeFix({ fixIds: [w], errorCodes: Q, getCodeActions: function(J) {
                var ie = J.sourceFile, R = J.errorCode, q = J.span, O = J.cancellationToken, ve = J.program, ee = le(ie, R, q, O, ve);
                if (!!ee) {
                  var he = J.program.getTypeChecker(), F2 = function(x2) {
                    return e2.textChanges.ChangeTracker.with(J, x2);
                  };
                  return e2.compact([N(J, ee, R, he, F2), p(J, ee, R, he, F2)]);
                }
              }, getAllCodeActions: function(se) {
                var J = se.sourceFile, ie = se.program, R = se.cancellationToken, q = se.program.getTypeChecker(), O = new e2.Set();
                return C.codeFixAll(se, Q, function(ve, ee) {
                  var he = le(J, ee.code, ee, R, ie);
                  if (!!he) {
                    var F2 = function(x2) {
                      return x2(ve), [];
                    };
                    return N(se, he, ee.code, q, F2, O) || p(se, he, ee.code, q, F2, O);
                  }
                });
              } });
              function le(se, J, ie, R, q) {
                var O = e2.getFixableErrorSpanExpression(se, ie);
                return O && m2(se, J, ie, R, q) && T(O) ? O : void 0;
              }
              function N(se, J, ie, R, q, O) {
                var ve = se.sourceFile, ee = se.program, he = se.cancellationToken, F2 = G(J, ve, he, ee, R);
                if (F2) {
                  var x2 = q(function(X) {
                    e2.forEach(F2.initializers, function($) {
                      var A2 = $.expression;
                      return K(X, ie, ve, R, A2, O);
                    }), O && F2.needsSecondPassForFixAll && K(X, ie, ve, R, J, O);
                  });
                  return C.createCodeFixActionWithoutFixAll("addMissingAwaitToInitializer", x2, F2.initializers.length === 1 ? [e2.Diagnostics.Add_await_to_initializer_for_0, F2.initializers[0].declarationSymbol.name] : e2.Diagnostics.Add_await_to_initializers);
                }
              }
              function p(se, J, ie, R, q, O) {
                var ve = q(function(ee) {
                  return K(ee, ie, se.sourceFile, R, J, O);
                });
                return C.createCodeFixAction(w, ve, e2.Diagnostics.Add_await, w, e2.Diagnostics.Fix_all_expressions_possibly_missing_await);
              }
              function m2(se, J, ie, R, q) {
                var O = q.getTypeChecker(), ve = O.getDiagnostics(se, R);
                return e2.some(ve, function(ee) {
                  var he = ee.start, F2 = ee.length, x2 = ee.relatedInformation, X = ee.code;
                  return e2.isNumber(he) && e2.isNumber(F2) && e2.textSpansEqual({ start: he, length: F2 }, ie) && X === J && !!x2 && e2.some(x2, function($) {
                    return $.code === e2.Diagnostics.Did_you_forget_to_use_await.code;
                  });
                });
              }
              function G(se, J, ie, R, q) {
                var O = oe(se, q);
                if (!!O) {
                  for (var ve = O.isCompleteFix, ee, he = function($) {
                    var A2 = q.getSymbolAtLocation($);
                    if (!A2)
                      return "continue";
                    var y = e2.tryCast(A2.valueDeclaration, e2.isVariableDeclaration), V = y && e2.tryCast(y.name, e2.isIdentifier), L = e2.getAncestor(y, 237);
                    if (!y || !L || y.type || !y.initializer || L.getSourceFile() !== J || e2.hasSyntacticModifier(L, 1) || !V || !T(y.initializer))
                      return ve = false, "continue";
                    var P = R.getSemanticDiagnostics(J, ie), k = e2.FindAllReferences.Core.eachSymbolReferenceInFile(V, q, J, function(Y) {
                      return $ !== Y && !f4(Y, P, J, q);
                    });
                    if (k)
                      return ve = false, "continue";
                    (ee || (ee = [])).push({ expression: y.initializer, declarationSymbol: A2 });
                  }, F2 = 0, x2 = O.identifiers; F2 < x2.length; F2++) {
                    var X = x2[F2];
                    he(X);
                  }
                  return ee && { initializers: ee, needsSecondPassForFixAll: !ve };
                }
              }
              function oe(se, J) {
                if (e2.isPropertyAccessExpression(se.parent) && e2.isIdentifier(se.parent.expression))
                  return { identifiers: [se.parent.expression], isCompleteFix: true };
                if (e2.isIdentifier(se))
                  return { identifiers: [se], isCompleteFix: true };
                if (e2.isBinaryExpression(se)) {
                  for (var ie = void 0, R = true, q = 0, O = [se.left, se.right]; q < O.length; q++) {
                    var ve = O[q], ee = J.getTypeAtLocation(ve);
                    if (J.getPromisedTypeOfPromise(ee)) {
                      if (!e2.isIdentifier(ve)) {
                        R = false;
                        continue;
                      }
                      (ie || (ie = [])).push(ve);
                    }
                  }
                  return ie && { identifiers: ie, isCompleteFix: R };
                }
              }
              function f4(se, J, ie, R) {
                var q = e2.isPropertyAccessExpression(se.parent) ? se.parent.name : e2.isBinaryExpression(se.parent) ? se.parent : se, O = e2.find(J, function(ve) {
                  return ve.start === q.getStart(ie) && ve.start + ve.length === q.getEnd();
                });
                return O && e2.contains(Q, O.code) || R.getTypeAtLocation(q).flags & 1;
              }
              function T(se) {
                return se.kind & 32768 || !!e2.findAncestor(se, function(J) {
                  return J.parent && e2.isArrowFunction(J.parent) && J.parent.body === J || e2.isBlock(J) && (J.parent.kind === 256 || J.parent.kind === 213 || J.parent.kind === 214 || J.parent.kind === 169);
                });
              }
              function K(se, J, ie, R, q, O) {
                if (e2.isBinaryExpression(q))
                  for (var ve = 0, ee = [q.left, q.right]; ve < ee.length; ve++) {
                    var he = ee[ve];
                    if (O && e2.isIdentifier(he)) {
                      var F2 = R.getSymbolAtLocation(he);
                      if (F2 && O.has(e2.getSymbolId(F2)))
                        continue;
                    }
                    var x2 = R.getTypeAtLocation(he), X = R.getPromisedTypeOfPromise(x2) ? e2.factory.createAwaitExpression(he) : he;
                    se.replaceNode(ie, he, X);
                  }
                else if (J === B && e2.isPropertyAccessExpression(q.parent)) {
                  if (O && e2.isIdentifier(q.parent.expression)) {
                    var F2 = R.getSymbolAtLocation(q.parent.expression);
                    if (F2 && O.has(e2.getSymbolId(F2)))
                      return;
                  }
                  se.replaceNode(ie, q.parent.expression, e2.factory.createParenthesizedExpression(e2.factory.createAwaitExpression(q.parent.expression))), b(se, q.parent.expression, ie);
                } else if (e2.contains(E, J) && e2.isCallOrNewExpression(q.parent)) {
                  if (O && e2.isIdentifier(q)) {
                    var F2 = R.getSymbolAtLocation(q);
                    if (F2 && O.has(e2.getSymbolId(F2)))
                      return;
                  }
                  se.replaceNode(ie, q, e2.factory.createParenthesizedExpression(e2.factory.createAwaitExpression(q))), b(se, q, ie);
                } else {
                  if (O && e2.isVariableDeclaration(q.parent) && e2.isIdentifier(q.parent.name)) {
                    var F2 = R.getSymbolAtLocation(q.parent.name);
                    if (F2 && !e2.tryAddToSet(O, e2.getSymbolId(F2)))
                      return;
                  }
                  se.replaceNode(ie, q, e2.factory.createAwaitExpression(q));
                }
              }
              function b(se, J, ie) {
                var R = e2.findPrecedingToken(J.pos, ie);
                R && e2.positionIsASICandidate(R.end, R.parent, ie) && se.insertText(ie, J.getStart(ie), ";");
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addMissingConst", B = [e2.Diagnostics.Cannot_find_name_0.code, e2.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(oe) {
                var f4 = e2.textChanges.ChangeTracker.with(oe, function(T) {
                  return E(T, oe.sourceFile, oe.span.start, oe.program);
                });
                if (f4.length > 0)
                  return [C.createCodeFixAction(w, f4, e2.Diagnostics.Add_const_to_unresolved_variable, w, e2.Diagnostics.Add_const_to_all_unresolved_variables)];
              }, fixIds: [w], getAllCodeActions: function(G) {
                var oe = new e2.Set();
                return C.codeFixAll(G, B, function(f4, T) {
                  return E(f4, T.file, T.start, G.program, oe);
                });
              } });
              function E(G, oe, f4, T, K) {
                var b = e2.getTokenAtPosition(oe, f4), se = e2.findAncestor(b, function(O) {
                  return e2.isForInOrOfStatement(O.parent) ? O.parent.initializer === O : le(O) ? false : "quit";
                });
                if (se)
                  return Q(G, se, oe, K);
                var J = b.parent;
                if (e2.isBinaryExpression(J) && J.operatorToken.kind === 63 && e2.isExpressionStatement(J.parent))
                  return Q(G, b, oe, K);
                if (e2.isArrayLiteralExpression(J)) {
                  var ie = T.getTypeChecker();
                  return e2.every(J.elements, function(O) {
                    return N(O, ie);
                  }) ? Q(G, J, oe, K) : void 0;
                }
                var R = e2.findAncestor(b, function(O) {
                  return e2.isExpressionStatement(O.parent) ? true : p(O) ? false : "quit";
                });
                if (R) {
                  var q = T.getTypeChecker();
                  return m2(R, q) ? Q(G, R, oe, K) : void 0;
                }
              }
              function Q(G, oe, f4, T) {
                (!T || e2.tryAddToSet(T, oe)) && G.insertModifierBefore(f4, 85, oe);
              }
              function le(G) {
                switch (G.kind) {
                  case 79:
                  case 204:
                  case 205:
                  case 296:
                  case 297:
                    return true;
                  default:
                    return false;
                }
              }
              function N(G, oe) {
                var f4 = e2.isIdentifier(G) ? G : e2.isAssignmentExpression(G, true) && e2.isIdentifier(G.left) ? G.left : void 0;
                return !!f4 && !oe.getSymbolAtLocation(f4);
              }
              function p(G) {
                switch (G.kind) {
                  case 79:
                  case 221:
                  case 27:
                    return true;
                  default:
                    return false;
                }
              }
              function m2(G, oe) {
                return e2.isBinaryExpression(G) ? G.operatorToken.kind === 27 ? e2.every([G.left, G.right], function(f4) {
                  return m2(f4, oe);
                }) : G.operatorToken.kind === 63 && e2.isIdentifier(G.left) && !oe.getSymbolAtLocation(G.left) : false;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addMissingDeclareProperty", B = [e2.Diagnostics.Property_0_will_overwrite_the_base_property_in_1_If_this_is_intentional_add_an_initializer_Otherwise_add_a_declare_modifier_or_remove_the_redundant_declaration.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e2.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span.start);
                });
                if (N.length > 0)
                  return [C.createCodeFixAction(w, N, e2.Diagnostics.Prefix_with_declare, w, e2.Diagnostics.Prefix_all_incorrect_property_declarations_with_declare)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                var le = new e2.Set();
                return C.codeFixAll(Q, B, function(N, p) {
                  return E(N, p.file, p.start, le);
                });
              } });
              function E(Q, le, N, p) {
                var m2 = e2.getTokenAtPosition(le, N);
                if (!!e2.isIdentifier(m2)) {
                  var G = m2.parent;
                  G.kind === 167 && (!p || e2.tryAddToSet(p, G)) && Q.insertModifierBefore(le, 135, G);
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addMissingInvocationForDecorator", B = [e2.Diagnostics._0_accepts_too_few_arguments_to_be_used_as_a_decorator_here_Did_you_mean_to_call_it_first_and_write_0.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e2.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span.start);
                });
                return [C.createCodeFixAction(w, N, e2.Diagnostics.Call_decorator_expression, w, e2.Diagnostics.Add_to_all_uncalled_decorators)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N.start);
                });
              } });
              function E(Q, le, N) {
                var p = e2.getTokenAtPosition(le, N), m2 = e2.findAncestor(p, e2.isDecorator);
                e2.Debug.assert(!!m2, "Expected position to be owned by a decorator.");
                var G = e2.factory.createCallExpression(m2.expression, void 0, void 0);
                Q.replaceNode(le, m2.expression, G);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addNameToNamelessParameter", B = [e2.Diagnostics.Parameter_has_a_name_but_no_type_Did_you_mean_0_Colon_1.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e2.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span.start);
                });
                return [C.createCodeFixAction(w, N, e2.Diagnostics.Add_parameter_name, w, e2.Diagnostics.Add_names_to_all_parameters_without_names)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N.start);
                });
              } });
              function E(Q, le, N) {
                var p = e2.getTokenAtPosition(le, N), m2 = p.parent;
                if (!e2.isParameter(m2))
                  return e2.Debug.fail("Tried to add a parameter name to a non-parameter: " + e2.Debug.formatSyntaxKind(p.kind));
                var G = m2.parent.parameters.indexOf(m2);
                e2.Debug.assert(!m2.type, "Tried to add a parameter name to a parameter that already had one."), e2.Debug.assert(G > -1, "Parameter not found in parent parameter list.");
                var oe = e2.factory.createTypeReferenceNode(m2.name, void 0), f4 = e2.factory.createParameterDeclaration(void 0, m2.modifiers, m2.dotDotDotToken, "arg" + G, m2.questionToken, m2.dotDotDotToken ? e2.factory.createArrayTypeNode(oe) : oe, m2.initializer);
                Q.replaceNode(le, m2, f4);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addOptionalPropertyUndefined", B = [e2.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_type_of_the_target.code, e2.Diagnostics.Type_0_is_not_assignable_to_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code, e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1_with_exactOptionalPropertyTypes_Colon_true_Consider_adding_undefined_to_the_types_of_the_target_s_properties.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m2 = p.program.getTypeChecker(), G = E(p.sourceFile, p.span, m2);
                if (!!G.length) {
                  var oe = e2.textChanges.ChangeTracker.with(p, function(f4) {
                    return N(f4, G);
                  });
                  return [C.createCodeFixActionWithoutFixAll(w, oe, e2.Diagnostics.Add_undefined_to_optional_property_type)];
                }
              }, fixIds: [w] });
              function E(p, m2, G) {
                var oe, f4, T = le(e2.getFixableErrorSpanExpression(p, m2), G);
                if (!T)
                  return e2.emptyArray;
                var K = T.source, b = T.target, se = Q(K, b, G) ? G.getTypeAtLocation(b.expression) : G.getTypeAtLocation(b);
                return !((f4 = (oe = se.symbol) === null || oe === void 0 ? void 0 : oe.declarations) === null || f4 === void 0) && f4.some(function(J) {
                  return e2.getSourceFileOfNode(J).fileName.match(/\.d\.ts$/);
                }) ? e2.emptyArray : G.getExactOptionalProperties(se);
              }
              function Q(p, m2, G) {
                return e2.isPropertyAccessExpression(m2) && !!G.getExactOptionalProperties(G.getTypeAtLocation(m2.expression)).length && G.getTypeAtLocation(p) === G.getUndefinedType();
              }
              function le(p, m2) {
                var G;
                if (p) {
                  if (e2.isBinaryExpression(p.parent) && p.parent.operatorToken.kind === 63)
                    return { source: p.parent.right, target: p.parent.left };
                  if (e2.isVariableDeclaration(p.parent) && p.parent.initializer)
                    return { source: p.parent.initializer, target: p.parent.name };
                  if (e2.isCallExpression(p.parent)) {
                    var oe = m2.getSymbolAtLocation(p.parent.expression);
                    if (!(oe != null && oe.valueDeclaration) || !e2.isFunctionLikeKind(oe.valueDeclaration.kind) || !e2.isExpression(p))
                      return;
                    var f4 = p.parent.arguments.indexOf(p);
                    if (f4 === -1)
                      return;
                    var T = oe.valueDeclaration.parameters[f4].name;
                    if (e2.isIdentifier(T))
                      return { source: p, target: T };
                  } else if (e2.isPropertyAssignment(p.parent) && e2.isIdentifier(p.parent.name) || e2.isShorthandPropertyAssignment(p.parent)) {
                    var K = le(p.parent.parent, m2);
                    if (!K)
                      return;
                    var b = m2.getPropertyOfType(m2.getTypeAtLocation(K.target), p.parent.name.text), se = (G = b == null ? void 0 : b.declarations) === null || G === void 0 ? void 0 : G[0];
                    return se ? { source: e2.isPropertyAssignment(p.parent) ? p.parent.initializer : p.parent.name, target: se } : void 0;
                  }
                } else
                  return;
              }
              function N(p, m2) {
                for (var G = 0, oe = m2; G < oe.length; G++) {
                  var f4 = oe[G], T = f4.valueDeclaration;
                  if (T && (e2.isPropertySignature(T) || e2.isPropertyDeclaration(T)) && T.type) {
                    var K = e2.factory.createUnionTypeNode(Ve(Ve([], T.type.kind === 187 ? T.type.types : [T.type], true), [e2.factory.createTypeReferenceNode("undefined")], false));
                    p.replaceNode(T.getSourceFile(), T.type, K);
                  }
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "annotateWithTypeFromJSDoc", B = [e2.Diagnostics.JSDoc_types_may_be_moved_to_TypeScript_types.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(J) {
                var ie = E(J.sourceFile, J.span.start);
                if (!!ie) {
                  var R = e2.textChanges.ChangeTracker.with(J, function(q) {
                    return N(q, J.sourceFile, ie);
                  });
                  return [C.createCodeFixAction(w, R, e2.Diagnostics.Annotate_with_type_from_JSDoc, w, e2.Diagnostics.Annotate_everything_with_types_from_JSDoc)];
                }
              }, fixIds: [w], getAllCodeActions: function(J) {
                return C.codeFixAll(J, B, function(ie, R) {
                  var q = E(R.file, R.start);
                  q && N(ie, R.file, q);
                });
              } });
              function E(J, ie) {
                var R = e2.getTokenAtPosition(J, ie);
                return e2.tryCast(e2.isParameter(R.parent) ? R.parent.parent : R.parent, Q);
              }
              function Q(J) {
                return p(J) && le(J);
              }
              C.parameterShouldGetTypeFromJSDoc = Q;
              function le(J) {
                return e2.isFunctionLikeDeclaration(J) ? J.parameters.some(le) || !J.type && !!e2.getJSDocReturnType(J) : !J.type && !!e2.getJSDocType(J);
              }
              function N(J, ie, R) {
                if (e2.isFunctionLikeDeclaration(R) && (e2.getJSDocReturnType(R) || R.parameters.some(function($) {
                  return !!e2.getJSDocType($);
                }))) {
                  if (!R.typeParameters) {
                    var q = e2.getJSDocTypeParameterDeclarations(R);
                    q.length && J.insertTypeParameters(ie, R, q);
                  }
                  var O = e2.isArrowFunction(R) && !e2.findChildOfKind(R, 20, ie);
                  O && J.insertNodeBefore(ie, e2.first(R.parameters), e2.factory.createToken(20));
                  for (var ve = 0, ee = R.parameters; ve < ee.length; ve++) {
                    var he = ee[ve];
                    if (!he.type) {
                      var F2 = e2.getJSDocType(he);
                      F2 && J.tryInsertTypeAnnotation(ie, he, m2(F2));
                    }
                  }
                  if (O && J.insertNodeAfter(ie, e2.last(R.parameters), e2.factory.createToken(21)), !R.type) {
                    var x2 = e2.getJSDocReturnType(R);
                    x2 && J.tryInsertTypeAnnotation(ie, R, m2(x2));
                  }
                } else {
                  var X = e2.Debug.checkDefined(e2.getJSDocType(R), "A JSDocType for this declaration should exist");
                  e2.Debug.assert(!R.type, "The JSDocType decl should have a type"), J.tryInsertTypeAnnotation(ie, R, m2(X));
                }
              }
              function p(J) {
                return e2.isFunctionLikeDeclaration(J) || J.kind === 254 || J.kind === 166 || J.kind === 167;
              }
              function m2(J) {
                switch (J.kind) {
                  case 312:
                  case 313:
                    return e2.factory.createTypeReferenceNode("any", e2.emptyArray);
                  case 316:
                    return G(J);
                  case 315:
                    return m2(J.type);
                  case 314:
                    return oe(J);
                  case 318:
                    return f4(J);
                  case 317:
                    return T(J);
                  case 178:
                    return b(J);
                  default:
                    var ie = e2.visitEachChild(J, m2, e2.nullTransformationContext);
                    return e2.setEmitFlags(ie, 1), ie;
                }
              }
              function G(J) {
                return e2.factory.createUnionTypeNode([e2.visitNode(J.type, m2), e2.factory.createTypeReferenceNode("undefined", e2.emptyArray)]);
              }
              function oe(J) {
                return e2.factory.createUnionTypeNode([e2.visitNode(J.type, m2), e2.factory.createTypeReferenceNode("null", e2.emptyArray)]);
              }
              function f4(J) {
                return e2.factory.createArrayTypeNode(e2.visitNode(J.type, m2));
              }
              function T(J) {
                var ie;
                return e2.factory.createFunctionTypeNode(e2.emptyArray, J.parameters.map(K), (ie = J.type) !== null && ie !== void 0 ? ie : e2.factory.createKeywordTypeNode(130));
              }
              function K(J) {
                var ie = J.parent.parameters.indexOf(J), R = J.type.kind === 318 && ie === J.parent.parameters.length - 1, q = J.name || (R ? "rest" : "arg" + ie), O = R ? e2.factory.createToken(25) : J.dotDotDotToken;
                return e2.factory.createParameterDeclaration(J.decorators, J.modifiers, O, q, J.questionToken, e2.visitNode(J.type, m2), J.initializer);
              }
              function b(J) {
                var ie = J.typeName, R = J.typeArguments;
                if (e2.isIdentifier(J.typeName)) {
                  if (e2.isJSDocIndexSignature(J))
                    return se(J);
                  var q = J.typeName.text;
                  switch (J.typeName.text) {
                    case "String":
                    case "Boolean":
                    case "Object":
                    case "Number":
                      q = q.toLowerCase();
                      break;
                    case "array":
                    case "date":
                    case "promise":
                      q = q[0].toUpperCase() + q.slice(1);
                      break;
                  }
                  ie = e2.factory.createIdentifier(q), (q === "Array" || q === "Promise") && !J.typeArguments ? R = e2.factory.createNodeArray([e2.factory.createTypeReferenceNode("any", e2.emptyArray)]) : R = e2.visitNodes(J.typeArguments, m2);
                }
                return e2.factory.createTypeReferenceNode(ie, R);
              }
              function se(J) {
                var ie = e2.factory.createParameterDeclaration(void 0, void 0, void 0, J.typeArguments[0].kind === 147 ? "n" : "s", void 0, e2.factory.createTypeReferenceNode(J.typeArguments[0].kind === 147 ? "number" : "string", []), void 0), R = e2.factory.createTypeLiteralNode([e2.factory.createIndexSignature(void 0, void 0, [ie], J.typeArguments[1])]);
                return e2.setEmitFlags(R, 1), R;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "convertFunctionToEs6Class", B = [e2.Diagnostics.This_constructor_function_may_be_converted_to_a_class_declaration.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m2 = e2.textChanges.ChangeTracker.with(p, function(G) {
                  return E(G, p.sourceFile, p.span.start, p.program.getTypeChecker(), p.preferences, p.program.getCompilerOptions());
                });
                return [C.createCodeFixAction(w, m2, e2.Diagnostics.Convert_function_to_an_ES2015_class, w, e2.Diagnostics.Convert_all_constructor_functions_to_classes)];
              }, fixIds: [w], getAllCodeActions: function(p) {
                return C.codeFixAll(p, B, function(m2, G) {
                  return E(m2, G.file, G.start, p.program.getTypeChecker(), p.preferences, p.program.getCompilerOptions());
                });
              } });
              function E(p, m2, G, oe, f4, T) {
                var K = oe.getSymbolAtLocation(e2.getTokenAtPosition(m2, G));
                if (!K || !K.valueDeclaration || !(K.flags & 19))
                  return;
                var b = K.valueDeclaration;
                if (e2.isFunctionDeclaration(b))
                  p.replaceNode(m2, b, q(b));
                else if (e2.isVariableDeclaration(b)) {
                  var se = R(b);
                  if (!se)
                    return;
                  var J = b.parent.parent;
                  e2.isVariableDeclarationList(b.parent) && b.parent.declarations.length > 1 ? (p.delete(m2, b), p.insertNodeAfter(m2, J, se)) : p.replaceNode(m2, J, se);
                }
                function ie(O) {
                  var ve = [];
                  return O.exports && O.exports.forEach(function(F2) {
                    if (F2.name === "prototype" && F2.declarations) {
                      var x2 = F2.declarations[0];
                      if (F2.declarations.length === 1 && e2.isPropertyAccessExpression(x2) && e2.isBinaryExpression(x2.parent) && x2.parent.operatorToken.kind === 63 && e2.isObjectLiteralExpression(x2.parent.right)) {
                        var X = x2.parent.right;
                        he(X.symbol, void 0, ve);
                      }
                    } else
                      he(F2, [e2.factory.createToken(124)], ve);
                  }), O.members && O.members.forEach(function(F2, x2) {
                    var X, $, A2, y;
                    if (x2 === "constructor" && F2.valueDeclaration) {
                      var V = (y = (A2 = ($ = (X = O.exports) === null || X === void 0 ? void 0 : X.get("prototype")) === null || $ === void 0 ? void 0 : $.declarations) === null || A2 === void 0 ? void 0 : A2[0]) === null || y === void 0 ? void 0 : y.parent;
                      V && e2.isBinaryExpression(V) && e2.isObjectLiteralExpression(V.right) && e2.some(V.right.properties, le) || p.delete(m2, F2.valueDeclaration.parent);
                      return;
                    }
                    he(F2, void 0, ve);
                  }), ve;
                  function ee(F2, x2) {
                    return e2.isAccessExpression(F2) ? e2.isPropertyAccessExpression(F2) && le(F2) ? true : e2.isFunctionLike(x2) : e2.every(F2.properties, function(X) {
                      return !!(e2.isMethodDeclaration(X) || e2.isGetOrSetAccessorDeclaration(X) || e2.isPropertyAssignment(X) && e2.isFunctionExpression(X.initializer) && !!X.name || le(X));
                    });
                  }
                  function he(F2, x2, X) {
                    if (!(F2.flags & 8192) && !(F2.flags & 4096))
                      return;
                    var $ = F2.valueDeclaration, A2 = $.parent, y = A2.right;
                    if (!ee($, y) || e2.some(X, function(H) {
                      var I = e2.getNameOfDeclaration(H);
                      return !!(I && e2.isIdentifier(I) && e2.idText(I) === e2.symbolName(F2));
                    }))
                      return;
                    var V = A2.parent && A2.parent.kind === 238 ? A2.parent : A2;
                    if (p.delete(m2, V), !y) {
                      X.push(e2.factory.createPropertyDeclaration([], x2, F2.name, void 0, void 0, void 0));
                      return;
                    }
                    if (e2.isAccessExpression($) && (e2.isFunctionExpression(y) || e2.isArrowFunction(y))) {
                      var L = e2.getQuotePreference(m2, f4), P = N($, T, L);
                      P && Y(X, y, P);
                      return;
                    } else if (e2.isObjectLiteralExpression(y)) {
                      e2.forEach(y.properties, function(H) {
                        (e2.isMethodDeclaration(H) || e2.isGetOrSetAccessorDeclaration(H)) && X.push(H), e2.isPropertyAssignment(H) && e2.isFunctionExpression(H.initializer) && Y(X, H.initializer, H.name), le(H);
                      });
                      return;
                    } else {
                      if (e2.isSourceFileJS(m2) || !e2.isPropertyAccessExpression($))
                        return;
                      var k = e2.factory.createPropertyDeclaration(void 0, x2, $.name, void 0, void 0, y);
                      e2.copyLeadingComments(A2.parent, k, m2), X.push(k);
                      return;
                    }
                    function Y(H, I, l) {
                      return e2.isFunctionExpression(I) ? U(H, I, l) : j(H, I, l);
                    }
                    function U(H, I, l) {
                      var d = e2.concatenate(x2, Q(I, 131)), D = e2.factory.createMethodDeclaration(void 0, d, void 0, l, void 0, void 0, I.parameters, void 0, I.body);
                      e2.copyLeadingComments(A2, D, m2), H.push(D);
                    }
                    function j(H, I, l) {
                      var d = I.body, D;
                      d.kind === 235 ? D = d : D = e2.factory.createBlock([e2.factory.createReturnStatement(d)]);
                      var fe = e2.concatenate(x2, Q(I, 131)), g = e2.factory.createMethodDeclaration(void 0, fe, void 0, l, void 0, void 0, I.parameters, void 0, D);
                      e2.copyLeadingComments(A2, g, m2), H.push(g);
                    }
                  }
                }
                function R(O) {
                  var ve = O.initializer;
                  if (!(!ve || !e2.isFunctionExpression(ve) || !e2.isIdentifier(O.name))) {
                    var ee = ie(O.symbol);
                    ve.body && ee.unshift(e2.factory.createConstructorDeclaration(void 0, void 0, ve.parameters, ve.body));
                    var he = Q(O.parent.parent, 93), F2 = e2.factory.createClassDeclaration(void 0, he, O.name, void 0, void 0, ee);
                    return F2;
                  }
                }
                function q(O) {
                  var ve = ie(K);
                  O.body && ve.unshift(e2.factory.createConstructorDeclaration(void 0, void 0, O.parameters, O.body));
                  var ee = Q(O, 93), he = e2.factory.createClassDeclaration(void 0, ee, O.name, void 0, void 0, ve);
                  return he;
                }
              }
              function Q(p, m2) {
                return e2.filter(p.modifiers, function(G) {
                  return G.kind === m2;
                });
              }
              function le(p) {
                return p.name ? !!(e2.isIdentifier(p.name) && p.name.text === "constructor") : false;
              }
              function N(p, m2, G) {
                if (e2.isPropertyAccessExpression(p))
                  return p.name;
                var oe = p.argumentExpression;
                if (e2.isNumericLiteral(oe))
                  return oe;
                if (e2.isStringLiteralLike(oe))
                  return e2.isIdentifierText(oe.text, e2.getEmitScriptTarget(m2)) ? e2.factory.createIdentifier(oe.text) : e2.isNoSubstitutionTemplateLiteral(oe) ? e2.factory.createStringLiteral(oe.text, G === 0) : oe;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "convertToAsyncFunction", B = [e2.Diagnostics.This_may_be_converted_to_an_async_function.code], E = true;
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(g) {
                E = true;
                var ne = e2.textChanges.ChangeTracker.with(g, function(ue) {
                  return le(ue, g.sourceFile, g.span.start, g.program.getTypeChecker());
                });
                return E ? [C.createCodeFixAction(w, ne, e2.Diagnostics.Convert_to_async_function, w, e2.Diagnostics.Convert_all_to_async_functions)] : [];
              }, fixIds: [w], getAllCodeActions: function(g) {
                return C.codeFixAll(g, B, function(ne, ue) {
                  return le(ne, ue.file, ue.start, g.program.getTypeChecker());
                });
              } });
              var Q;
              (function(g) {
                g[g.Identifier = 0] = "Identifier", g[g.BindingPattern = 1] = "BindingPattern";
              })(Q || (Q = {}));
              function le(g, ne, ue, We) {
                var Fe = e2.getTokenAtPosition(ne, ue), Z2;
                if (e2.isIdentifier(Fe) && e2.isVariableDeclaration(Fe.parent) && Fe.parent.initializer && e2.isFunctionLikeDeclaration(Fe.parent.initializer) ? Z2 = Fe.parent.initializer : Z2 = e2.tryCast(e2.getContainingFunction(e2.getTokenAtPosition(ne, ue)), e2.canBeConvertedToAsync), !!Z2) {
                  var Be = new e2.Map(), ge = e2.isInJSFile(Z2), Re = p(Z2, We), ze = T(Z2, We, Be);
                  if (!!e2.returnsPromise(ze, We)) {
                    var Ee = ze.body && e2.isBlock(ze.body) ? N(ze.body, We) : e2.emptyArray, He = { checker: We, synthNamesMap: Be, setOfExpressionsToReturn: Re, isInJSFile: ge };
                    if (!!Ee.length) {
                      var rr = Z2.modifiers ? Z2.modifiers.end : Z2.decorators ? e2.skipTrivia(ne.text, Z2.decorators.end) : Z2.getStart(ne), Ie = Z2.modifiers ? { prefix: " " } : { suffix: " " };
                      g.insertModifierAt(ne, rr, 131, Ie);
                      for (var _e = function(er) {
                        if (e2.forEachChild(er, function ir(Cr) {
                          if (e2.isCallExpression(Cr)) {
                            var Ye = J(Cr, Cr, He, false);
                            if (b())
                              return true;
                            g.replaceNodeWithNodes(ne, er, Ye);
                          } else if (!e2.isFunctionLike(Cr) && (e2.forEachChild(Cr, ir), b()))
                            return true;
                        }), b())
                          return { value: void 0 };
                      }, we = 0, de = Ee; we < de.length; we++) {
                        var ye = de[we], Ae = _e(ye);
                        if (typeof Ae == "object")
                          return Ae.value;
                      }
                    }
                  }
                }
              }
              function N(g, ne) {
                var ue = [];
                return e2.forEachReturnStatement(g, function(We) {
                  e2.isReturnStatementWithFixablePromiseHandler(We, ne) && ue.push(We);
                }), ue;
              }
              function p(g, ne) {
                if (!g.body)
                  return new e2.Set();
                var ue = new e2.Set();
                return e2.forEachChild(g.body, function We(Fe) {
                  m2(Fe, ne, "then") ? (ue.add(e2.getNodeId(Fe)), e2.forEach(Fe.arguments, We)) : m2(Fe, ne, "catch") || m2(Fe, ne, "finally") ? (ue.add(e2.getNodeId(Fe)), e2.forEachChild(Fe, We)) : f4(Fe, ne) ? ue.add(e2.getNodeId(Fe)) : e2.forEachChild(Fe, We);
                }), ue;
              }
              function m2(g, ne, ue) {
                if (!e2.isCallExpression(g))
                  return false;
                var We = e2.hasPropertyAccessExpressionWithName(g, ue), Fe = We && ne.getTypeAtLocation(g);
                return !!(Fe && ne.getPromisedTypeOfPromise(Fe));
              }
              function G(g, ne) {
                return (e2.getObjectFlags(g) & 4) !== 0 && g.target === ne;
              }
              function oe(g, ne, ue) {
                if (g.expression.name.escapedText !== "finally") {
                  var We = ue.getTypeAtLocation(g.expression.expression);
                  if (G(We, ue.getPromiseType()) || G(We, ue.getPromiseLikeType()))
                    if (g.expression.name.escapedText === "then") {
                      if (ne === e2.elementAt(g.arguments, 0))
                        return e2.elementAt(g.typeArguments, 0);
                      if (ne === e2.elementAt(g.arguments, 1))
                        return e2.elementAt(g.typeArguments, 1);
                    } else
                      return e2.elementAt(g.typeArguments, 0);
                }
              }
              function f4(g, ne) {
                return e2.isExpression(g) ? !!ne.getPromisedTypeOfPromise(ne.getTypeAtLocation(g)) : false;
              }
              function T(g, ne, ue) {
                var We = new e2.Map(), Fe = e2.createMultiMap();
                return e2.forEachChild(g, function Z2(Be) {
                  if (!e2.isIdentifier(Be)) {
                    e2.forEachChild(Be, Z2);
                    return;
                  }
                  var ge = ne.getSymbolAtLocation(Be);
                  if (ge) {
                    var Re = ne.getTypeAtLocation(Be), ze = y(Re, ne), Ee = e2.getSymbolId(ge).toString();
                    if (ze && !e2.isParameter(Be.parent) && !e2.isFunctionLikeDeclaration(Be.parent) && !ue.has(Ee)) {
                      var He = e2.firstOrUndefined(ze.parameters), rr = (He == null ? void 0 : He.valueDeclaration) && e2.isParameter(He.valueDeclaration) && e2.tryCast(He.valueDeclaration.name, e2.isIdentifier) || e2.factory.createUniqueName("result", 16), Ie = K(rr, Fe);
                      ue.set(Ee, Ie), Fe.add(rr.text, ge);
                    } else if (Be.parent && (e2.isParameter(Be.parent) || e2.isVariableDeclaration(Be.parent) || e2.isBindingElement(Be.parent))) {
                      var _e = Be.text, we = Fe.get(_e);
                      if (we && we.some(function(Ae) {
                        return Ae !== ge;
                      })) {
                        var de = K(Be, Fe);
                        We.set(Ee, de.identifier), ue.set(Ee, de), Fe.add(_e, ge);
                      } else {
                        var ye = e2.getSynthesizedDeepClone(Be);
                        ue.set(Ee, Y(ye)), Fe.add(_e, ge);
                      }
                    }
                  }
                }), e2.getSynthesizedDeepCloneWithReplacements(g, true, function(Z2) {
                  if (e2.isBindingElement(Z2) && e2.isIdentifier(Z2.name) && e2.isObjectBindingPattern(Z2.parent)) {
                    var Be = ne.getSymbolAtLocation(Z2.name), ge = Be && We.get(String(e2.getSymbolId(Be)));
                    if (ge && ge.text !== (Z2.name || Z2.propertyName).getText())
                      return e2.factory.createBindingElement(Z2.dotDotDotToken, Z2.propertyName || Z2.name, ge, Z2.initializer);
                  } else if (e2.isIdentifier(Z2)) {
                    var Be = ne.getSymbolAtLocation(Z2), ge = Be && We.get(String(e2.getSymbolId(Be)));
                    if (ge)
                      return e2.factory.createIdentifier(ge.text);
                  }
                });
              }
              function K(g, ne) {
                var ue = (ne.get(g.text) || e2.emptyArray).length, We = ue === 0 ? g : e2.factory.createIdentifier(g.text + "_" + ue);
                return Y(We);
              }
              function b() {
                return !E;
              }
              function se() {
                return E = false, e2.emptyArray;
              }
              function J(g, ne, ue, We, Fe) {
                if (m2(ne, ue.checker, "then"))
                  return he(ne, e2.elementAt(ne.arguments, 0), e2.elementAt(ne.arguments, 1), ue, We, Fe);
                if (m2(ne, ue.checker, "catch"))
                  return ee(ne, e2.elementAt(ne.arguments, 0), ue, We, Fe);
                if (m2(ne, ue.checker, "finally"))
                  return ve(ne, e2.elementAt(ne.arguments, 0), ue, We, Fe);
                if (e2.isPropertyAccessExpression(ne))
                  return J(g, ne.expression, ue, We, Fe);
                var Z2 = ue.checker.getTypeAtLocation(ne);
                return Z2 && ue.checker.getPromisedTypeOfPromise(Z2) ? (e2.Debug.assertNode(e2.getOriginalNode(ne).parent, e2.isPropertyAccessExpression), F2(g, ne, ue, We, Fe)) : se();
              }
              function ie(g, ne) {
                var ue = g.checker;
                if (ne.kind === 104)
                  return true;
                if (e2.isIdentifier(ne) && !e2.isGeneratedIdentifier(ne) && e2.idText(ne) === "undefined") {
                  var We = ue.getSymbolAtLocation(ne);
                  return !We || ue.isUndefinedSymbol(We);
                }
                return false;
              }
              function R(g) {
                var ne = e2.factory.createUniqueName(g.identifier.text, 16);
                return Y(ne);
              }
              function q(g, ne, ue) {
                var We;
                return ue && !fe(g, ne) && (d(ue) ? (We = ue, ne.synthNamesMap.forEach(function(Fe, Z2) {
                  if (Fe.identifier.text === ue.identifier.text) {
                    var Be = R(ue);
                    ne.synthNamesMap.set(Z2, Be);
                  }
                })) : We = Y(e2.factory.createUniqueName("result", 16), ue.types), l(We)), We;
              }
              function O(g, ne, ue, We, Fe) {
                var Z2 = [], Be;
                if (We && !fe(g, ne)) {
                  Be = e2.getSynthesizedDeepClone(l(We));
                  var ge = We.types, Re = ne.checker.getUnionType(ge, 2), ze = ne.isInJSFile ? void 0 : ne.checker.typeToTypeNode(Re, void 0, void 0), Ee = [e2.factory.createVariableDeclaration(Be, void 0, ze)], He = e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList(Ee, 1));
                  Z2.push(He);
                }
                return Z2.push(ue), Fe && Be && D(Fe) && Z2.push(e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(e2.getSynthesizedDeepClone(I(Fe)), void 0, void 0, Be)], 2))), Z2;
              }
              function ve(g, ne, ue, We, Fe) {
                if (!ne || ie(ue, ne))
                  return J(g, g.expression.expression, ue, We, Fe);
                var Z2 = q(g, ue, Fe), Be = J(g, g.expression.expression, ue, true, Z2);
                if (b())
                  return se();
                var ge = $(ne, We, void 0, void 0, g, ue);
                if (b())
                  return se();
                var Re = e2.factory.createBlock(Be), ze = e2.factory.createBlock(ge), Ee = e2.factory.createTryStatement(Re, void 0, ze);
                return O(g, ue, Ee, Z2, Fe);
              }
              function ee(g, ne, ue, We, Fe) {
                if (!ne || ie(ue, ne))
                  return J(g, g.expression.expression, ue, We, Fe);
                var Z2 = P(ne, ue), Be = q(g, ue, Fe), ge = J(g, g.expression.expression, ue, true, Be);
                if (b())
                  return se();
                var Re = $(ne, We, Be, Z2, g, ue);
                if (b())
                  return se();
                var ze = e2.factory.createBlock(ge), Ee = e2.factory.createCatchClause(Z2 && e2.getSynthesizedDeepClone(H(Z2)), e2.factory.createBlock(Re)), He = e2.factory.createTryStatement(ze, Ee, void 0);
                return O(g, ue, He, Be, Fe);
              }
              function he(g, ne, ue, We, Fe, Z2) {
                if (!ne || ie(We, ne))
                  return ee(g, ue, We, Fe, Z2);
                if (ue && !ie(We, ue))
                  return se();
                var Be = P(ne, We), ge = J(g.expression.expression, g.expression.expression, We, true, Be);
                if (b())
                  return se();
                var Re = $(ne, Fe, Z2, Be, g, We);
                return b() ? se() : e2.concatenate(ge, Re);
              }
              function F2(g, ne, ue, We, Fe) {
                if (fe(g, ue)) {
                  var Z2 = e2.getSynthesizedDeepClone(ne);
                  return We && (Z2 = e2.factory.createAwaitExpression(Z2)), [e2.factory.createReturnStatement(Z2)];
                }
                return x2(Fe, e2.factory.createAwaitExpression(ne), void 0);
              }
              function x2(g, ne, ue) {
                return !g || k(g) ? [e2.factory.createExpressionStatement(ne)] : d(g) && g.hasBeenDeclared ? [e2.factory.createExpressionStatement(e2.factory.createAssignment(e2.getSynthesizedDeepClone(j(g)), ne))] : [e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(e2.getSynthesizedDeepClone(H(g)), void 0, ue, ne)], 2))];
              }
              function X(g, ne) {
                if (ne && g) {
                  var ue = e2.factory.createUniqueName("result", 16);
                  return Ve(Ve([], x2(Y(ue), g, ne), true), [e2.factory.createReturnStatement(ue)], false);
                }
                return [e2.factory.createReturnStatement(g)];
              }
              function $(g, ne, ue, We, Fe, Z2) {
                var Be;
                switch (g.kind) {
                  case 104:
                    break;
                  case 206:
                  case 79:
                    if (!We)
                      break;
                    var ge = e2.factory.createCallExpression(e2.getSynthesizedDeepClone(g), void 0, d(We) ? [j(We)] : []);
                    if (fe(Fe, Z2))
                      return X(ge, oe(Fe, g, Z2.checker));
                    var Re = Z2.checker.getTypeAtLocation(g), ze = Z2.checker.getSignaturesOfType(Re, 0);
                    if (!ze.length)
                      return se();
                    var Ee = ze[0].getReturnType(), He = x2(ue, e2.factory.createAwaitExpression(ge), oe(Fe, g, Z2.checker));
                    return ue && ue.types.push(Z2.checker.getAwaitedType(Ee) || Ee), He;
                  case 213:
                  case 214: {
                    var rr = g.body, Ie = (Be = y(Z2.checker.getTypeAtLocation(g), Z2.checker)) === null || Be === void 0 ? void 0 : Be.getReturnType();
                    if (e2.isBlock(rr)) {
                      for (var _e = [], we = false, de = 0, ye = rr.statements; de < ye.length; de++) {
                        var Ae = ye[de];
                        if (e2.isReturnStatement(Ae))
                          if (we = true, e2.isReturnStatementWithFixablePromiseHandler(Ae, Z2.checker))
                            _e = _e.concat(L(Z2, Ae, ne, ue));
                          else {
                            var er = Ie && Ae.expression ? A2(Z2.checker, Ie, Ae.expression) : Ae.expression;
                            _e.push.apply(_e, X(er, oe(Fe, g, Z2.checker)));
                          }
                        else {
                          if (ne && e2.forEachReturnStatement(Ae, e2.returnTrue))
                            return se();
                          _e.push(Ae);
                        }
                      }
                      return fe(Fe, Z2) ? _e.map(function(Ye) {
                        return e2.getSynthesizedDeepClone(Ye);
                      }) : V(_e, ue, Z2, we);
                    } else {
                      var ir = e2.isFixablePromiseHandler(rr, Z2.checker) ? L(Z2, e2.factory.createReturnStatement(rr), ne, ue) : e2.emptyArray;
                      if (ir.length > 0)
                        return ir;
                      if (Ie) {
                        var er = A2(Z2.checker, Ie, rr);
                        if (fe(Fe, Z2))
                          return X(er, oe(Fe, g, Z2.checker));
                        var Cr = x2(ue, er, void 0);
                        return ue && ue.types.push(Z2.checker.getAwaitedType(Ie) || Ie), Cr;
                      } else
                        return se();
                    }
                  }
                  default:
                    return se();
                }
                return e2.emptyArray;
              }
              function A2(g, ne, ue) {
                var We = e2.getSynthesizedDeepClone(ue);
                return g.getPromisedTypeOfPromise(ne) ? e2.factory.createAwaitExpression(We) : We;
              }
              function y(g, ne) {
                var ue = ne.getSignaturesOfType(g, 0);
                return e2.lastOrUndefined(ue);
              }
              function V(g, ne, ue, We) {
                for (var Fe = [], Z2 = 0, Be = g; Z2 < Be.length; Z2++) {
                  var ge = Be[Z2];
                  if (e2.isReturnStatement(ge)) {
                    if (ge.expression) {
                      var Re = f4(ge.expression, ue.checker) ? e2.factory.createAwaitExpression(ge.expression) : ge.expression;
                      ne === void 0 ? Fe.push(e2.factory.createExpressionStatement(Re)) : d(ne) && ne.hasBeenDeclared ? Fe.push(e2.factory.createExpressionStatement(e2.factory.createAssignment(j(ne), Re))) : Fe.push(e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(H(ne), void 0, void 0, Re)], 2)));
                    }
                  } else
                    Fe.push(e2.getSynthesizedDeepClone(ge));
                }
                return !We && ne !== void 0 && Fe.push(e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(H(ne), void 0, void 0, e2.factory.createIdentifier("undefined"))], 2))), Fe;
              }
              function L(g, ne, ue, We) {
                var Fe = [];
                return e2.forEachChild(ne, function Z2(Be) {
                  if (e2.isCallExpression(Be)) {
                    var ge = J(Be, Be, g, ue, We);
                    if (Fe = Fe.concat(ge), Fe.length > 0)
                      return;
                  } else
                    e2.isFunctionLike(Be) || e2.forEachChild(Be, Z2);
                }), Fe;
              }
              function P(g, ne) {
                var ue = [], We;
                if (e2.isFunctionLikeDeclaration(g)) {
                  if (g.parameters.length > 0) {
                    var Fe = g.parameters[0].name;
                    We = Z2(Fe);
                  }
                } else
                  e2.isIdentifier(g) ? We = Be(g) : e2.isPropertyAccessExpression(g) && e2.isIdentifier(g.name) && (We = Be(g.name));
                if (!We || "identifier" in We && We.identifier.text === "undefined")
                  return;
                return We;
                function Z2(ze) {
                  if (e2.isIdentifier(ze))
                    return Be(ze);
                  var Ee = e2.flatMap(ze.elements, function(He) {
                    return e2.isOmittedExpression(He) ? [] : [Z2(He.name)];
                  });
                  return U(ze, Ee);
                }
                function Be(ze) {
                  var Ee = Re(ze), He = ge(Ee);
                  if (!He)
                    return Y(ze, ue);
                  var rr = ne.synthNamesMap.get(e2.getSymbolId(He).toString());
                  return rr || Y(ze, ue);
                }
                function ge(ze) {
                  return ze.symbol ? ze.symbol : ne.checker.getSymbolAtLocation(ze);
                }
                function Re(ze) {
                  return ze.original ? ze.original : ze;
                }
              }
              function k(g) {
                return g ? d(g) ? !g.identifier.text : e2.every(g.elements, k) : true;
              }
              function Y(g, ne) {
                return ne === void 0 && (ne = []), { kind: 0, identifier: g, types: ne, hasBeenDeclared: false, hasBeenReferenced: false };
              }
              function U(g, ne, ue) {
                return ne === void 0 && (ne = e2.emptyArray), ue === void 0 && (ue = []), { kind: 1, bindingPattern: g, elements: ne, types: ue };
              }
              function j(g) {
                return g.hasBeenReferenced = true, g.identifier;
              }
              function H(g) {
                return d(g) ? l(g) : I(g);
              }
              function I(g) {
                for (var ne = 0, ue = g.elements; ne < ue.length; ne++) {
                  var We = ue[ne];
                  H(We);
                }
                return g.bindingPattern;
              }
              function l(g) {
                return g.hasBeenDeclared = true, g.identifier;
              }
              function d(g) {
                return g.kind === 0;
              }
              function D(g) {
                return g.kind === 1;
              }
              function fe(g, ne) {
                return !!g.original && ne.setOfExpressionsToReturn.has(e2.getNodeId(g.original));
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              C.registerCodeFix({ errorCodes: [e2.Diagnostics.File_is_a_CommonJS_module_it_may_be_converted_to_an_ES_module.code], getCodeActions: function(L) {
                var P = L.sourceFile, k = L.program, Y = L.preferences, U = e2.textChanges.ChangeTracker.with(L, function(j) {
                  var H = B(P, k.getTypeChecker(), j, e2.getEmitScriptTarget(k.getCompilerOptions()), e2.getQuotePreference(P, Y));
                  if (H)
                    for (var I = 0, l = k.getSourceFiles(); I < l.length; I++) {
                      var d = l[I];
                      w(d, P, j, e2.getQuotePreference(d, Y));
                    }
                });
                return [C.createCodeFixActionWithoutFixAll("convertToEsModule", U, e2.Diagnostics.Convert_to_ES_module)];
              } });
              function w(L, P, k, Y) {
                for (var U = 0, j = L.imports; U < j.length; U++) {
                  var H = j[U], I = e2.getResolvedModule(L, H.text, e2.getModeForUsageLocation(L, H));
                  if (!(!I || I.resolvedFileName !== P.fileName)) {
                    var l = e2.importFromModuleSpecifier(H);
                    switch (l.kind) {
                      case 265:
                        k.replaceNode(L, l, e2.makeImport(l.name, void 0, H, Y));
                        break;
                      case 208:
                        e2.isRequireCall(l, false) && k.replaceNode(L, l, e2.factory.createPropertyAccessExpression(e2.getSynthesizedDeepClone(l), "default"));
                        break;
                    }
                  }
                }
              }
              function B(L, P, k, Y, U) {
                var j = { original: ve(L), additional: new e2.Set() }, H = E(L, P, j);
                Q(L, H, k);
                for (var I = false, l, d = 0, D = e2.filter(L.statements, e2.isVariableStatement); d < D.length; d++) {
                  var fe = D[d], g = p(L, fe, k, P, j, Y, U);
                  g && e2.copyEntries(g, l != null ? l : l = new e2.Map());
                }
                for (var ne = 0, ue = e2.filter(L.statements, function(Fe) {
                  return !e2.isVariableStatement(Fe);
                }); ne < ue.length; ne++) {
                  var fe = ue[ne], We = N(L, fe, P, k, j, Y, H, l, U);
                  I = I || We;
                }
                return l == null || l.forEach(function(Fe, Z2) {
                  k.replaceNode(L, Z2, Fe);
                }), I;
              }
              function E(L, P, k) {
                var Y = new e2.Map();
                return le(L, function(U) {
                  var j = U.name, H = j.text, I = j.originalKeywordKind;
                  !Y.has(H) && (I !== void 0 && e2.isNonContextualKeyword(I) || P.resolveName(H, U, 111551, true)) && Y.set(H, O("_".concat(H), k));
                }), Y;
              }
              function Q(L, P, k) {
                le(L, function(Y, U) {
                  if (!U) {
                    var j = Y.name.text;
                    k.replaceNode(L, Y, e2.factory.createIdentifier(P.get(j) || j));
                  }
                });
              }
              function le(L, P) {
                L.forEachChild(function k(Y) {
                  if (e2.isPropertyAccessExpression(Y) && e2.isExportsOrModuleExportsOrAlias(L, Y.expression) && e2.isIdentifier(Y.name)) {
                    var U = Y.parent;
                    P(Y, e2.isBinaryExpression(U) && U.left === Y && U.operatorToken.kind === 63);
                  }
                  Y.forEachChild(k);
                });
              }
              function N(L, P, k, Y, U, j, H, I, l) {
                switch (P.kind) {
                  case 237:
                    return p(L, P, Y, k, U, j, l), false;
                  case 238: {
                    var d = P.expression;
                    switch (d.kind) {
                      case 208:
                        return e2.isRequireCall(d, true) && Y.replaceNode(L, P, e2.makeImport(void 0, void 0, d.arguments[0], l)), false;
                      case 221: {
                        var D = d.operatorToken;
                        return D.kind === 63 && G(L, k, d, Y, H, I);
                      }
                    }
                  }
                  default:
                    return false;
                }
              }
              function p(L, P, k, Y, U, j, H) {
                var I = P.declarationList, l = false, d = e2.map(I.declarations, function(fe) {
                  var g = fe.name, ne = fe.initializer;
                  if (ne) {
                    if (e2.isExportsOrModuleExportsOrAlias(L, ne))
                      return l = true, V([]);
                    if (e2.isRequireCall(ne, true))
                      return l = true, R(g, ne.arguments[0], Y, U, j, H);
                    if (e2.isPropertyAccessExpression(ne) && e2.isRequireCall(ne.expression, true))
                      return l = true, m2(g, ne.name.text, ne.expression.arguments[0], U, H);
                  }
                  return V([e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([fe], I.flags))]);
                });
                if (l) {
                  k.replaceNodeWithNodes(L, P, e2.flatMap(d, function(fe) {
                    return fe.newImports;
                  }));
                  var D;
                  return e2.forEach(d, function(fe) {
                    fe.useSitesToUnqualify && e2.copyEntries(fe.useSitesToUnqualify, D != null ? D : D = new e2.Map());
                  }), D;
                }
              }
              function m2(L, P, k, Y, U) {
                switch (L.kind) {
                  case 201:
                  case 202: {
                    var j = O(P, Y);
                    return V([X(j, P, k, U), A2(void 0, L, e2.factory.createIdentifier(j))]);
                  }
                  case 79:
                    return V([X(L.text, P, k, U)]);
                  default:
                    return e2.Debug.assertNever(L, "Convert to ES module got invalid syntax form ".concat(L.kind));
                }
              }
              function G(L, P, k, Y, U, j) {
                var H = k.left, I = k.right;
                if (!e2.isPropertyAccessExpression(H))
                  return false;
                if (e2.isExportsOrModuleExportsOrAlias(L, H))
                  if (e2.isExportsOrModuleExportsOrAlias(L, I))
                    Y.delete(L, k.parent);
                  else {
                    var l = e2.isObjectLiteralExpression(I) ? oe(I, j) : e2.isRequireCall(I, true) ? T(I.arguments[0], P) : void 0;
                    return l ? (Y.replaceNodeWithNodes(L, k.parent, l[0]), l[1]) : (Y.replaceRangeWithText(L, e2.createRange(H.getStart(L), I.pos), "export default"), true);
                  }
                else
                  e2.isExportsOrModuleExportsOrAlias(L, H.expression) && f4(L, k, Y, U);
                return false;
              }
              function oe(L, P) {
                var k = e2.mapAllOrFail(L.properties, function(Y) {
                  switch (Y.kind) {
                    case 172:
                    case 173:
                    case 297:
                    case 298:
                      return;
                    case 296:
                      return e2.isIdentifier(Y.name) ? J(Y.name.text, Y.initializer, P) : void 0;
                    case 169:
                      return e2.isIdentifier(Y.name) ? F2(Y.name.text, [e2.factory.createToken(93)], Y, P) : void 0;
                    default:
                      e2.Debug.assertNever(Y, "Convert to ES6 got invalid prop kind ".concat(Y.kind));
                  }
                });
                return k && [k, false];
              }
              function f4(L, P, k, Y) {
                var U = P.left.name.text, j = Y.get(U);
                if (j !== void 0) {
                  var H = [A2(void 0, j, P.right), y([e2.factory.createExportSpecifier(false, j, U)])];
                  k.replaceNodeWithNodes(L, P.parent, H);
                } else
                  se(P, L, k);
              }
              function T(L, P) {
                var k = L.text, Y = P.getSymbolAtLocation(L), U = Y ? Y.exports : e2.emptyMap;
                return U.has("export=") ? [[b(k)], true] : U.has("default") ? U.size > 1 ? [[K(k), b(k)], true] : [[b(k)], true] : [[K(k)], false];
              }
              function K(L) {
                return y(void 0, L);
              }
              function b(L) {
                return y([e2.factory.createExportSpecifier(false, void 0, "default")], L);
              }
              function se(L, P, k) {
                var Y = L.left, U = L.right, j = L.parent, H = Y.name.text;
                if ((e2.isFunctionExpression(U) || e2.isArrowFunction(U) || e2.isClassExpression(U)) && (!U.name || U.name.text === H)) {
                  k.replaceRange(P, { pos: Y.getStart(P), end: U.getStart(P) }, e2.factory.createToken(93), { suffix: " " }), U.name || k.insertName(P, U, H);
                  var I = e2.findChildOfKind(j, 26, P);
                  I && k.delete(P, I);
                } else
                  k.replaceNodeRangeWithNodes(P, Y.expression, e2.findChildOfKind(Y, 24, P), [e2.factory.createToken(93), e2.factory.createToken(85)], { joiner: " ", suffix: " " });
              }
              function J(L, P, k) {
                var Y = [e2.factory.createToken(93)];
                switch (P.kind) {
                  case 213: {
                    var U = P.name;
                    if (U && U.text !== L)
                      return j();
                  }
                  case 214:
                    return F2(L, Y, P, k);
                  case 226:
                    return x2(L, Y, P, k);
                  default:
                    return j();
                }
                function j() {
                  return A2(Y, e2.factory.createIdentifier(L), ie(P, k));
                }
              }
              function ie(L, P) {
                if (!P || !e2.some(e2.arrayFrom(P.keys()), function(Y) {
                  return e2.rangeContainsRange(L, Y);
                }))
                  return L;
                return e2.isArray(L) ? e2.getSynthesizedDeepClonesWithReplacements(L, true, k) : e2.getSynthesizedDeepCloneWithReplacements(L, true, k);
                function k(Y) {
                  if (Y.kind === 206) {
                    var U = P.get(Y);
                    return P.delete(Y), U;
                  }
                }
              }
              function R(L, P, k, Y, U, j) {
                switch (L.kind) {
                  case 201: {
                    var H = e2.mapAllOrFail(L.elements, function(l) {
                      return l.dotDotDotToken || l.initializer || l.propertyName && !e2.isIdentifier(l.propertyName) || !e2.isIdentifier(l.name) ? void 0 : $(l.propertyName && l.propertyName.text, l.name.text);
                    });
                    if (H)
                      return V([e2.makeImport(void 0, H, P, j)]);
                  }
                  case 202: {
                    var I = O(C.moduleSpecifierToValidIdentifier(P.text, U), Y);
                    return V([e2.makeImport(e2.factory.createIdentifier(I), void 0, P, j), A2(void 0, e2.getSynthesizedDeepClone(L), e2.factory.createIdentifier(I))]);
                  }
                  case 79:
                    return q(L, P, k, Y, j);
                  default:
                    return e2.Debug.assertNever(L, "Convert to ES module got invalid name kind ".concat(L.kind));
                }
              }
              function q(L, P, k, Y, U) {
                for (var j = k.getSymbolAtLocation(L), H = new e2.Map(), I = false, l, d = 0, D = Y.original.get(L.text); d < D.length; d++) {
                  var fe = D[d];
                  if (!(k.getSymbolAtLocation(fe) !== j || fe === L)) {
                    var g = fe.parent;
                    if (e2.isPropertyAccessExpression(g)) {
                      var ne = g.name.text;
                      if (ne === "default") {
                        I = true;
                        var ue = fe.getText();
                        (l != null ? l : l = new e2.Map()).set(g, e2.factory.createIdentifier(ue));
                      } else {
                        e2.Debug.assert(g.expression === fe, "Didn't expect expression === use");
                        var We = H.get(ne);
                        We === void 0 && (We = O(ne, Y), H.set(ne, We)), (l != null ? l : l = new e2.Map()).set(g, e2.factory.createIdentifier(We));
                      }
                    } else
                      I = true;
                  }
                }
                var Fe = H.size === 0 ? void 0 : e2.arrayFrom(e2.mapIterator(H.entries(), function(Z2) {
                  var Be = Z2[0], ge = Z2[1];
                  return e2.factory.createImportSpecifier(false, Be === ge ? void 0 : e2.factory.createIdentifier(Be), e2.factory.createIdentifier(ge));
                }));
                return Fe || (I = true), V([e2.makeImport(I ? e2.getSynthesizedDeepClone(L) : void 0, Fe, P, U)], l);
              }
              function O(L, P) {
                for (; P.original.has(L) || P.additional.has(L); )
                  L = "_".concat(L);
                return P.additional.add(L), L;
              }
              function ve(L) {
                var P = e2.createMultiMap();
                return ee(L, function(k) {
                  return P.add(k.text, k);
                }), P;
              }
              function ee(L, P) {
                e2.isIdentifier(L) && he(L) && P(L), L.forEachChild(function(k) {
                  return ee(k, P);
                });
              }
              function he(L) {
                var P = L.parent;
                switch (P.kind) {
                  case 206:
                    return P.name !== L;
                  case 203:
                    return P.propertyName !== L;
                  case 270:
                    return P.propertyName !== L;
                  default:
                    return true;
                }
              }
              function F2(L, P, k, Y) {
                return e2.factory.createFunctionDeclaration(e2.getSynthesizedDeepClones(k.decorators), e2.concatenate(P, e2.getSynthesizedDeepClones(k.modifiers)), e2.getSynthesizedDeepClone(k.asteriskToken), L, e2.getSynthesizedDeepClones(k.typeParameters), e2.getSynthesizedDeepClones(k.parameters), e2.getSynthesizedDeepClone(k.type), e2.factory.converters.convertToFunctionBlock(ie(k.body, Y)));
              }
              function x2(L, P, k, Y) {
                return e2.factory.createClassDeclaration(e2.getSynthesizedDeepClones(k.decorators), e2.concatenate(P, e2.getSynthesizedDeepClones(k.modifiers)), L, e2.getSynthesizedDeepClones(k.typeParameters), e2.getSynthesizedDeepClones(k.heritageClauses), ie(k.members, Y));
              }
              function X(L, P, k, Y) {
                return P === "default" ? e2.makeImport(e2.factory.createIdentifier(L), void 0, k, Y) : e2.makeImport(void 0, [$(P, L)], k, Y);
              }
              function $(L, P) {
                return e2.factory.createImportSpecifier(false, L !== void 0 && L !== P ? e2.factory.createIdentifier(L) : void 0, e2.factory.createIdentifier(P));
              }
              function A2(L, P, k) {
                return e2.factory.createVariableStatement(L, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(P, void 0, void 0, k)], 2));
              }
              function y(L, P) {
                return e2.factory.createExportDeclaration(void 0, void 0, false, L && e2.factory.createNamedExports(L), P === void 0 ? void 0 : e2.factory.createStringLiteral(P));
              }
              function V(L, P) {
                return { newImports: L, useSitesToUnqualify: P };
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "correctQualifiedNameToIndexedAccessType", B = [e2.Diagnostics.Cannot_access_0_1_because_0_is_a_type_but_not_a_namespace_Did_you_mean_to_retrieve_the_type_of_the_property_1_in_0_with_0_1.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = E(le.sourceFile, le.span.start);
                if (!!N) {
                  var p = e2.textChanges.ChangeTracker.with(le, function(G) {
                    return Q(G, le.sourceFile, N);
                  }), m2 = "".concat(N.left.text, '["').concat(N.right.text, '"]');
                  return [C.createCodeFixAction(w, p, [e2.Diagnostics.Rewrite_as_the_indexed_access_type_0, m2], w, e2.Diagnostics.Rewrite_all_as_indexed_access_types)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m2 = E(p.file, p.start);
                  m2 && Q(N, p.file, m2);
                });
              } });
              function E(le, N) {
                var p = e2.findAncestor(e2.getTokenAtPosition(le, N), e2.isQualifiedName);
                return e2.Debug.assert(!!p, "Expected position to be owned by a qualified name."), e2.isIdentifier(p.left) ? p : void 0;
              }
              function Q(le, N, p) {
                var m2 = p.right.text, G = e2.factory.createIndexedAccessTypeNode(e2.factory.createTypeReferenceNode(p.left, void 0), e2.factory.createLiteralTypeNode(e2.factory.createStringLiteral(m2)));
                le.replaceNode(N, p, G);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = [e2.Diagnostics.Re_exporting_a_type_when_the_isolatedModules_flag_is_provided_requires_using_export_type.code], B = "convertToTypeOnlyExport";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(p) {
                var m2 = e2.textChanges.ChangeTracker.with(p, function(G) {
                  return Q(G, E(p.span, p.sourceFile), p);
                });
                if (m2.length)
                  return [C.createCodeFixAction(B, m2, e2.Diagnostics.Convert_to_type_only_export, B, e2.Diagnostics.Convert_all_re_exported_types_to_type_only_exports)];
              }, fixIds: [B], getAllCodeActions: function(p) {
                var m2 = new e2.Map();
                return C.codeFixAll(p, w, function(G, oe) {
                  var f4 = E(oe, p.sourceFile);
                  f4 && e2.addToSeen(m2, e2.getNodeId(f4.parent.parent)) && Q(G, f4, p);
                });
              } });
              function E(N, p) {
                return e2.tryCast(e2.getTokenAtPosition(p, N.start).parent, e2.isExportSpecifier);
              }
              function Q(N, p, m2) {
                if (!!p) {
                  var G = p.parent, oe = G.parent, f4 = le(p, m2);
                  if (f4.length === G.elements.length)
                    N.insertModifierBefore(m2.sourceFile, 152, G);
                  else {
                    var T = e2.factory.updateExportDeclaration(oe, oe.decorators, oe.modifiers, false, e2.factory.updateNamedExports(G, e2.filter(G.elements, function(b) {
                      return !e2.contains(f4, b);
                    })), oe.moduleSpecifier, void 0), K = e2.factory.createExportDeclaration(void 0, void 0, true, e2.factory.createNamedExports(f4), oe.moduleSpecifier, void 0);
                    N.replaceNode(m2.sourceFile, oe, T, { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Exclude }), N.insertNodeAfter(m2.sourceFile, oe, K);
                  }
                }
              }
              function le(N, p) {
                var m2 = N.parent;
                if (m2.elements.length === 1)
                  return m2.elements;
                var G = e2.getDiagnosticsWithinSpan(e2.createTextSpanFromNode(m2), p.program.getSemanticDiagnostics(p.sourceFile, p.cancellationToken));
                return e2.filter(m2.elements, function(oe) {
                  var f4;
                  return oe === N || ((f4 = e2.findDiagnosticForNode(oe, G)) === null || f4 === void 0 ? void 0 : f4.code) === w[0];
                });
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = [e2.Diagnostics.This_import_is_never_used_as_a_value_and_must_use_import_type_because_importsNotUsedAsValues_is_set_to_error.code], B = "convertToTypeOnlyImport";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(N) {
                var p = e2.textChanges.ChangeTracker.with(N, function(m2) {
                  var G = E(N.span, N.sourceFile);
                  Q(m2, G, N);
                });
                if (p.length)
                  return [C.createCodeFixAction(B, p, e2.Diagnostics.Convert_to_type_only_import, B, e2.Diagnostics.Convert_all_imports_not_used_as_a_value_to_type_only_imports)];
              }, fixIds: [B], getAllCodeActions: function(N) {
                return C.codeFixAll(N, w, function(p, m2) {
                  var G = E(m2, N.sourceFile);
                  Q(p, G, N);
                });
              } });
              function E(le, N) {
                return e2.tryCast(e2.getTokenAtPosition(N, le.start).parent, e2.isImportDeclaration);
              }
              function Q(le, N, p) {
                if (!!(N != null && N.importClause)) {
                  var m2 = N.importClause;
                  le.insertText(p.sourceFile, N.getStart() + 6, " type"), m2.name && m2.namedBindings && (le.deleteNodeRangeExcludingEnd(p.sourceFile, m2.name, N.importClause.namedBindings), le.insertNodeBefore(p.sourceFile, N, e2.factory.updateImportDeclaration(N, void 0, void 0, e2.factory.createImportClause(true, m2.name, void 0), N.moduleSpecifier, void 0)));
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "convertLiteralTypeToMappedType", B = [e2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here_Did_you_mean_to_use_1_in_0.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m2 = N.span, G = E(p, m2.start);
                if (!!G) {
                  var oe = G.name, f4 = G.constraint, T = e2.textChanges.ChangeTracker.with(N, function(K) {
                    return Q(K, p, G);
                  });
                  return [C.createCodeFixAction(w, T, [e2.Diagnostics.Convert_0_to_1_in_0, f4, oe], w, e2.Diagnostics.Convert_all_type_literals_to_mapped_type)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m2 = E(p.file, p.start);
                  m2 && Q(N, p.file, m2);
                });
              } });
              function E(le, N) {
                var p = e2.getTokenAtPosition(le, N);
                if (e2.isIdentifier(p)) {
                  var m2 = e2.cast(p.parent.parent, e2.isPropertySignature), G = p.getText(le);
                  return { container: e2.cast(m2.parent, e2.isTypeLiteralNode), typeNode: m2.type, constraint: G, name: G === "K" ? "P" : "K" };
                }
              }
              function Q(le, N, p) {
                var m2 = p.container, G = p.typeNode, oe = p.constraint, f4 = p.name;
                le.replaceNode(N, m2, e2.factory.createMappedTypeNode(void 0, e2.factory.createTypeParameterDeclaration(void 0, f4, e2.factory.createTypeReferenceNode(oe)), void 0, void 0, G, void 0));
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = [e2.Diagnostics.Class_0_incorrectly_implements_interface_1.code, e2.Diagnostics.Class_0_incorrectly_implements_class_1_Did_you_mean_to_extend_1_and_inherit_its_members_as_a_subclass.code], B = "fixClassIncorrectlyImplementsInterface";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(p) {
                var m2 = p.sourceFile, G = p.span, oe = E(m2, G.start);
                return e2.mapDefined(e2.getEffectiveImplementsTypeNodes(oe), function(f4) {
                  var T = e2.textChanges.ChangeTracker.with(p, function(K) {
                    return le(p, f4, m2, oe, K, p.preferences);
                  });
                  return T.length === 0 ? void 0 : C.createCodeFixAction(B, T, [e2.Diagnostics.Implement_interface_0, f4.getText(m2)], B, e2.Diagnostics.Implement_all_unimplemented_interfaces);
                });
              }, fixIds: [B], getAllCodeActions: function(p) {
                var m2 = new e2.Map();
                return C.codeFixAll(p, w, function(G, oe) {
                  var f4 = E(oe.file, oe.start);
                  if (e2.addToSeen(m2, e2.getNodeId(f4)))
                    for (var T = 0, K = e2.getEffectiveImplementsTypeNodes(f4); T < K.length; T++) {
                      var b = K[T];
                      le(p, b, oe.file, f4, G, p.preferences);
                    }
                });
              } });
              function E(p, m2) {
                return e2.Debug.checkDefined(e2.getContainingClass(e2.getTokenAtPosition(p, m2)), "There should be a containing class");
              }
              function Q(p) {
                return !p.valueDeclaration || !(e2.getEffectiveModifierFlags(p.valueDeclaration) & 8);
              }
              function le(p, m2, G, oe, f4, T) {
                var K = p.program.getTypeChecker(), b = N(oe, K), se = K.getTypeAtLocation(m2), J = K.getPropertiesOfType(se), ie = J.filter(e2.and(Q, function(he) {
                  return !b.has(he.escapedName);
                })), R = K.getTypeAtLocation(oe), q = e2.find(oe.members, function(he) {
                  return e2.isConstructorDeclaration(he);
                });
                R.getNumberIndexType() || ve(se, 1), R.getStringIndexType() || ve(se, 0);
                var O = C.createImportAdder(G, p.program, T, p.host);
                C.createMissingMemberNodes(oe, ie, G, p, T, O, function(he) {
                  return ee(G, oe, he);
                }), O.writeFixes(f4);
                function ve(he, F2) {
                  var x2 = K.getIndexInfoOfType(he, F2);
                  x2 && ee(G, oe, K.indexInfoToIndexSignatureDeclaration(x2, oe, void 0, C.getNoopSymbolTrackerWithResolver(p)));
                }
                function ee(he, F2, x2) {
                  q ? f4.insertNodeAfter(he, q, x2) : f4.insertMemberAtStart(he, F2, x2);
                }
              }
              function N(p, m2) {
                var G = e2.getEffectiveBaseTypeNode(p);
                if (!G)
                  return e2.createSymbolTable();
                var oe = m2.getTypeAtLocation(G), f4 = m2.getPropertiesOfType(oe);
                return e2.createSymbolTable(f4.filter(Q));
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              C.importFixName = "import";
              var w = "fixMissingImport", B = [e2.Diagnostics.Cannot_find_name_0.code, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code, e2.Diagnostics.Cannot_find_namespace_0.code, e2.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code, e2.Diagnostics._0_only_refers_to_a_type_but_is_being_used_as_a_value_here.code, e2.Diagnostics.No_value_exists_in_scope_for_the_shorthand_property_0_Either_declare_one_or_provide_an_initializer.code, e2.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(_e) {
                var we = _e.errorCode, de = _e.preferences, ye = _e.sourceFile, Ae = _e.span, er = _e.program, ir = x2(_e, we, Ae.start, true);
                if (!!ir) {
                  var Cr = ir.fixes, Ye = ir.symbolName, Br = ir.errorIdentifierText, Er = e2.getQuotePreference(ye, de);
                  return Cr.map(function(Ne) {
                    return fe(_e, ye, Ye, Ne, Ye !== Br, Er, er.getCompilerOptions());
                  });
                }
              }, fixIds: [w], getAllCodeActions: function(_e) {
                var we = _e.sourceFile, de = _e.program, ye = _e.preferences, Ae = _e.host, er = Q(we, de, true, ye, Ae);
                return C.eachDiagnostic(_e, B, function(ir) {
                  return er.addImportFromDiagnostic(ir, _e);
                }), C.createCombinedCodeActions(e2.textChanges.ChangeTracker.with(_e, er.writeFixes));
              } });
              function E(_e, we, de, ye) {
                return Q(_e, we, false, de, ye);
              }
              C.createImportAdder = E;
              function Q(_e, we, de, ye, Ae) {
                var er = we.getCompilerOptions(), ir = [], Cr = [], Ye = new e2.Map(), Br = new e2.Map();
                return { addImportFromDiagnostic: Er, addImportFromExportedSymbol: Ne, writeFixes: lr, hasFixes: be };
                function Er(Ge, ur) {
                  var yr = x2(ur, Ge.code, Ge.start, de);
                  !yr || !yr.fixes.length || n(yr);
                }
                function Ne(Ge, ur) {
                  var yr = e2.Debug.checkDefined(Ge.parent), Ir = e2.getNameForExportedSymbol(Ge, e2.getEmitScriptTarget(er)), wr = we.getTypeChecker(), Ur = wr.getMergedSymbol(e2.skipAlias(Ge, wr)), ii = T(_e, Ur, yr, Ir, false, Ae, we, ye, de), mi = ve(_e, we), pe = G(_e, ii, yr, we, void 0, !!ur, mi, Ae, ye);
                  pe && n({ fixes: [pe], symbolName: Ir, errorIdentifierText: void 0 });
                }
                function n(Ge) {
                  var ur, yr, Ir = Ge.fixes, wr = Ge.symbolName, Ur = e2.first(Ir);
                  switch (Ur.kind) {
                    case 0:
                      ir.push(Ur);
                      break;
                    case 1:
                      Cr.push(Ur);
                      break;
                    case 2: {
                      var ii = Ur.importClauseOrBindingPattern, mi = Ur.importKind, pe = Ur.addAsTypeOnly, or = String(e2.getNodeId(ii)), qr = Ye.get(or);
                      if (qr || Ye.set(or, qr = { importClauseOrBindingPattern: ii, defaultImport: void 0, namedImports: new e2.Map() }), mi === 0) {
                        var si = qr == null ? void 0 : qr.namedImports.get(wr);
                        qr.namedImports.set(wr, Xi(si, pe));
                      } else
                        e2.Debug.assert(qr.defaultImport === void 0 || qr.defaultImport.name === wr, "(Add to Existing) Default import should be missing or match symbolName"), qr.defaultImport = { name: wr, addAsTypeOnly: Xi((ur = qr.defaultImport) === null || ur === void 0 ? void 0 : ur.addAsTypeOnly, pe) };
                      break;
                    }
                    case 3: {
                      var Di = Ur.moduleSpecifier, mi = Ur.importKind, wi = Ur.useRequire, pe = Ur.addAsTypeOnly, qr = et(Di, mi, wi, pe);
                      switch (e2.Debug.assert(qr.useRequire === wi, "(Add new) Tried to add an `import` and a `require` for the same module"), mi) {
                        case 1:
                          e2.Debug.assert(qr.defaultImport === void 0 || qr.defaultImport.name === wr, "(Add new) Default import should be missing or match symbolName"), qr.defaultImport = { name: wr, addAsTypeOnly: Xi((yr = qr.defaultImport) === null || yr === void 0 ? void 0 : yr.addAsTypeOnly, pe) };
                          break;
                        case 0:
                          var si = (qr.namedImports || (qr.namedImports = new e2.Map())).get(wr);
                          qr.namedImports.set(wr, Xi(si, pe));
                          break;
                        case 3:
                        case 2:
                          e2.Debug.assert(qr.namespaceLikeImport === void 0 || qr.namespaceLikeImport.name === wr, "Namespacelike import shoudl be missing or match symbolName"), qr.namespaceLikeImport = { importKind: mi, name: wr, addAsTypeOnly: pe };
                          break;
                      }
                      break;
                    }
                    case 4:
                      break;
                    default:
                      e2.Debug.assertNever(Ur, "fix wasn't never - got kind ".concat(Ur.kind));
                  }
                  function Xi(Wt, Zt) {
                    return Math.max(Wt != null ? Wt : 0, Zt);
                  }
                  function et(Wt, Zt, _r, pi) {
                    var ae = Gi(Wt, true), Xe = Gi(Wt, false), Jr = Br.get(ae), ti = Br.get(Xe), Ze = { defaultImport: void 0, namedImports: void 0, namespaceLikeImport: void 0, useRequire: _r };
                    return Zt === 1 && pi === 2 ? Jr || (Br.set(ae, Ze), Ze) : pi === 1 && (Jr || ti) ? Jr || ti : ti || (Br.set(Xe, Ze), Ze);
                  }
                  function Gi(Wt, Zt) {
                    return "".concat(Zt ? 1 : 0, "|").concat(Wt);
                  }
                }
                function lr(Ge) {
                  for (var ur = e2.getQuotePreference(_e, ye), yr = 0, Ir = ir; yr < Ir.length; yr++) {
                    var wr = Ir[yr];
                    Fe(Ge, _e, wr);
                  }
                  for (var Ur = 0, ii = Cr; Ur < ii.length; Ur++) {
                    var wr = ii[Ur];
                    Z2(Ge, _e, wr, ur);
                  }
                  Ye.forEach(function(pe) {
                    var or = pe.importClauseOrBindingPattern, qr = pe.defaultImport, si = pe.namedImports;
                    We(Ge, _e, or, qr, e2.arrayFrom(si.entries(), function(Di) {
                      var wi = Di[0], Xi = Di[1];
                      return { addAsTypeOnly: Xi, name: wi };
                    }), er);
                  });
                  var mi;
                  Br.forEach(function(pe, or) {
                    var qr = pe.useRequire, si = pe.defaultImport, Di = pe.namedImports, wi = pe.namespaceLikeImport, Xi = or.slice(2), et = qr ? ze : Re, Gi = et(Xi, ur, si, Di && e2.arrayFrom(Di.entries(), function(Wt) {
                      var Zt = Wt[0], _r = Wt[1];
                      return { addAsTypeOnly: _r, name: Zt };
                    }), wi);
                    mi = e2.combine(mi, Gi);
                  }), mi && e2.insertImports(Ge, _e, mi, true);
                }
                function be() {
                  return ir.length > 0 || Cr.length > 0 || Ye.size > 0 || Br.size > 0;
                }
              }
              var le;
              (function(_e) {
                _e[_e.UseNamespace = 0] = "UseNamespace", _e[_e.JsdocTypeImport = 1] = "JsdocTypeImport", _e[_e.AddToExisting = 2] = "AddToExisting", _e[_e.AddNew = 3] = "AddNew", _e[_e.PromoteTypeOnly = 4] = "PromoteTypeOnly";
              })(le || (le = {}));
              var N;
              (function(_e) {
                _e[_e.Allowed = 1] = "Allowed", _e[_e.Required = 2] = "Required", _e[_e.NotAllowed = 4] = "NotAllowed";
              })(N || (N = {}));
              function p(_e, we, de, ye, Ae, er, ir, Cr, Ye, Br) {
                var Er = ir.getCompilerOptions(), Ne = e2.pathIsBareSpecifier(e2.stripQuotes(we.name)) ? [f4(_e, we, ir, er)] : T(de, _e, we, ye, Ae, er, ir, Br, true), n = ve(de, ir), lr = e2.isValidTypeOnlyAliasUseSite(e2.getTokenAtPosition(de, Ye)), be = e2.Debug.checkDefined(G(de, Ne, we, ir, { symbolName: ye, position: Ye }, lr, n, er, Br));
                return { moduleSpecifier: be.moduleSpecifier, codeAction: oe(fe({ host: er, formatContext: Cr, preferences: Br }, de, ye, be, false, e2.getQuotePreference(de, Br), Er)) };
              }
              C.getImportCompletionAction = p;
              function m2(_e, we, de, ye, Ae, er) {
                var ir = de.getCompilerOptions(), Cr = I(_e, de.getTypeChecker(), we, ir), Ye = H(_e, we, Cr, de), Br = Cr !== we.text;
                return Ye && oe(fe({ host: ye, formatContext: Ae, preferences: er }, _e, Cr, Ye, Br, 1, ir));
              }
              C.getPromoteTypeOnlyCompletionAction = m2;
              function G(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                e2.Debug.assert(we.some(function(Er) {
                  return Er.moduleSymbol === de || Er.symbol.parent === de;
                }), "Some exportInfo should match the specified moduleSymbol");
                var Br = e2.createPackageJsonImportFilter(_e, Ye, Cr);
                return $(b(we, Ae, er, ir, ye, _e, Cr, Ye).fixes, _e, ye, Br, Cr);
              }
              function oe(_e) {
                var we = _e.description, de = _e.changes, ye = _e.commands;
                return { description: we, changes: de, commands: ye };
              }
              function f4(_e, we, de, ye) {
                var Ae, er, ir = de.getCompilerOptions(), Cr = Br(de.getTypeChecker(), false);
                if (Cr)
                  return Cr;
                var Ye = (er = (Ae = ye.getPackageJsonAutoImportProvider) === null || Ae === void 0 ? void 0 : Ae.call(ye)) === null || er === void 0 ? void 0 : er.getTypeChecker();
                return e2.Debug.checkDefined(Ye && Br(Ye, true), "Could not find symbol in specified module for code actions");
                function Br(Er, Ne) {
                  var n = e2.getDefaultLikeExportInfo(we, Er, ir);
                  if (n && e2.skipAlias(n.symbol, Er) === _e)
                    return { symbol: n.symbol, moduleSymbol: we, moduleFileName: void 0, exportKind: n.exportKind, targetFlags: e2.skipAlias(_e, Er).flags, isFromPackageJson: Ne };
                  var lr = Er.tryGetMemberInModuleExportsAndProperties(_e.name, we);
                  if (lr && e2.skipAlias(lr, Er) === _e)
                    return { symbol: lr, moduleSymbol: we, moduleFileName: void 0, exportKind: 0, targetFlags: e2.skipAlias(_e, Er).flags, isFromPackageJson: Ne };
                }
              }
              function T(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                var Br = [], Er = ir.getCompilerOptions(), Ne = e2.memoizeOne(function(lr) {
                  return e2.createModuleSpecifierResolutionHost(lr ? er.getPackageJsonAutoImportProvider() : ir, er);
                });
                return e2.forEachExternalModuleToImportFrom(ir, er, Ye, function(lr, be, Ge, ur) {
                  var yr = Ge.getTypeChecker();
                  if (!(be && lr !== de && e2.startsWith(_e.fileName, e2.getDirectoryPath(be.fileName)))) {
                    var Ir = e2.getDefaultLikeExportInfo(lr, yr, Er);
                    Ir && (Ir.name === ye || rr(lr, e2.getEmitScriptTarget(Er), Ae) === ye) && e2.skipAlias(Ir.symbol, yr) === we && n(Ge, be, ur) && Br.push({ symbol: Ir.symbol, moduleSymbol: lr, moduleFileName: be == null ? void 0 : be.fileName, exportKind: Ir.exportKind, targetFlags: e2.skipAlias(Ir.symbol, yr).flags, isFromPackageJson: ur });
                    for (var wr = 0, Ur = yr.getExportsAndPropertiesOfModule(lr); wr < Ur.length; wr++) {
                      var ii = Ur[wr];
                      ii.name === ye && yr.getMergedSymbol(e2.skipAlias(ii, yr)) === we && n(Ge, be, ur) && Br.push({ symbol: ii, moduleSymbol: lr, moduleFileName: be == null ? void 0 : be.fileName, exportKind: 0, targetFlags: e2.skipAlias(ii, yr).flags, isFromPackageJson: ur });
                    }
                  }
                }), Br;
                function n(lr, be, Ge) {
                  var ur;
                  return !be || e2.isImportableFile(lr, _e, be, Cr, void 0, Ne(Ge), (ur = er.getModuleSpecifierCache) === null || ur === void 0 ? void 0 : ur.call(er));
                }
              }
              function K(_e, we, de, ye, Ae, er, ir, Cr, Ye, Br) {
                var Er = b(_e, { symbolName: we, position: de }, ye, false, er, Ae, ir, Cr, Br), Ne = Er.fixes, n = Er.computedWithoutCacheCount, lr = $(Ne, Ae, er, Ye || e2.createPackageJsonImportFilter(Ae, Cr, ir), ir);
                return lr && Ke(Ke({}, lr), { computedWithoutCacheCount: n });
              }
              C.getModuleSpecifierForBestExportInfo = K;
              function b(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                var Br = Ae.getTypeChecker(), Er = e2.flatMap(_e, function(yr) {
                  return O(yr, Br, er, Ae.getCompilerOptions());
                }), Ne = we && se(Er, we.symbolName, we.position, Br), n = q(Er, de, Br, Ae.getCompilerOptions());
                if (n)
                  return { computedWithoutCacheCount: 0, fixes: Ve(Ve([], Ne ? [Ne] : e2.emptyArray, true), [n], false) };
                var lr = he(_e, Er, Ae, er, we == null ? void 0 : we.position, de, ye, ir, Cr, Ye), be = lr.fixes, Ge = lr.computedWithoutCacheCount, ur = Ge === void 0 ? 0 : Ge;
                return { computedWithoutCacheCount: ur, fixes: Ve(Ve([], Ne ? [Ne] : e2.emptyArray, true), be, true) };
              }
              function se(_e, we, de, ye) {
                return e2.firstDefined(_e, function(Ae) {
                  var er, ir = Ae.declaration, Cr = ie(ir), Ye = (er = e2.tryGetModuleSpecifierFromDeclaration(ir)) === null || er === void 0 ? void 0 : er.text;
                  if (Cr && Ye) {
                    var Br = J(ir, ye);
                    if (Br && Br.exports.has(e2.escapeLeadingUnderscores(we)))
                      return { kind: 0, namespacePrefix: Cr, position: de, moduleSpecifier: Ye };
                  }
                });
              }
              function J(_e, we) {
                var de;
                switch (_e.kind) {
                  case 254:
                    return we.resolveExternalModuleName(_e.initializer.arguments[0]);
                  case 265:
                    return we.getAliasedSymbol(_e.symbol);
                  case 266:
                    var ye = e2.tryCast((de = _e.importClause) === null || de === void 0 ? void 0 : de.namedBindings, e2.isNamespaceImport);
                    return ye && we.getAliasedSymbol(ye.symbol);
                  default:
                    return e2.Debug.assertNever(_e);
                }
              }
              function ie(_e) {
                var we, de, ye;
                switch (_e.kind) {
                  case 254:
                    return (we = e2.tryCast(_e.name, e2.isIdentifier)) === null || we === void 0 ? void 0 : we.text;
                  case 265:
                    return _e.name.text;
                  case 266:
                    return (ye = e2.tryCast((de = _e.importClause) === null || de === void 0 ? void 0 : de.namedBindings, e2.isNamespaceImport)) === null || ye === void 0 ? void 0 : ye.name.text;
                  default:
                    return e2.Debug.assertNever(_e);
                }
              }
              function R(_e, we, de, ye, Ae, er) {
                return _e ? we && er.importsNotUsedAsValues === 2 || er.isolatedModules && er.preserveValueImports && (!(ye & 111551) || !!Ae.getTypeOnlyAliasDeclaration(de)) ? 2 : 1 : 4;
              }
              function q(_e, we, de, ye) {
                return e2.firstDefined(_e, function(Ae) {
                  var er = Ae.declaration, ir = Ae.importKind, Cr = Ae.symbol, Ye = Ae.targetFlags;
                  if (!(ir === 3 || ir === 2 || er.kind === 265)) {
                    if (er.kind === 254)
                      return (ir === 0 || ir === 1) && er.name.kind === 201 ? { kind: 2, importClauseOrBindingPattern: er.name, importKind: ir, moduleSpecifier: er.initializer.arguments[0].text, addAsTypeOnly: 4 } : void 0;
                    var Br = er.importClause;
                    if (!(!Br || !e2.isStringLiteralLike(er.moduleSpecifier))) {
                      var Er = Br.name, Ne = Br.namedBindings;
                      if (!(Br.isTypeOnly && !(ir === 0 && Ne))) {
                        var n = R(we, false, Cr, Ye, de, ye);
                        if (!(ir === 1 && (Er || n === 2 && Ne)) && !(ir === 0 && (Ne == null ? void 0 : Ne.kind) === 268))
                          return { kind: 2, importClauseOrBindingPattern: Br, importKind: ir, moduleSpecifier: er.moduleSpecifier.text, addAsTypeOnly: n };
                      }
                    }
                  }
                });
              }
              function O(_e, we, de, ye) {
                var Ae = _e.moduleSymbol, er = _e.exportKind, ir = _e.targetFlags, Cr = _e.symbol;
                if (!(ir & 111551) && e2.isSourceFileJS(de))
                  return e2.emptyArray;
                var Ye = Y(de, er, ye);
                return e2.mapDefined(de.imports, function(Br) {
                  var Er = e2.importFromModuleSpecifier(Br);
                  if (e2.isVariableDeclarationInitializedToRequire(Er.parent))
                    return we.resolveExternalModuleName(Br) === Ae ? { declaration: Er.parent, importKind: Ye, symbol: Cr, targetFlags: ir } : void 0;
                  if (Er.kind === 266 || Er.kind === 265)
                    return we.getSymbolAtLocation(Br) === Ae ? { declaration: Er, importKind: Ye, symbol: Cr, targetFlags: ir } : void 0;
                });
              }
              function ve(_e, we) {
                if (!e2.isSourceFileJS(_e))
                  return false;
                if (_e.commonJsModuleIndicator && !_e.externalModuleIndicator)
                  return true;
                if (_e.externalModuleIndicator && !_e.commonJsModuleIndicator)
                  return false;
                var de = we.getCompilerOptions();
                if (de.configFile)
                  return e2.getEmitModuleKind(de) < e2.ModuleKind.ES2015;
                for (var ye = 0, Ae = we.getSourceFiles(); ye < Ae.length; ye++) {
                  var er = Ae[ye];
                  if (!(er === _e || !e2.isSourceFileJS(er) || we.isSourceFileFromExternalLibrary(er))) {
                    if (er.commonJsModuleIndicator && !er.externalModuleIndicator)
                      return true;
                    if (er.externalModuleIndicator && !er.commonJsModuleIndicator)
                      return false;
                  }
                }
                return true;
              }
              function ee(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                var Br = e2.isSourceFileJS(we), Er = _e.getCompilerOptions(), Ne = e2.createModuleSpecifierResolutionHost(_e, ir), n = e2.memoizeOne(function(yr) {
                  return yr ? ir.getPackageJsonAutoImportProvider().getTypeChecker() : _e.getTypeChecker();
                }), lr = e2.moduleResolutionUsesNodeModules(e2.getEmitModuleResolutionKind(Er)), be = Ye ? function(yr) {
                  return { moduleSpecifiers: e2.moduleSpecifiers.tryGetModuleSpecifiersFromCache(yr, we, Ne, Cr), computedWithoutCache: false };
                } : function(yr, Ir) {
                  return e2.moduleSpecifiers.getModuleSpecifiersWithCacheInfo(yr, Ir, Er, we, Ne, Cr);
                }, Ge = 0, ur = e2.flatMap(er, function(yr, Ir) {
                  var wr = n(yr.isFromPackageJson), Ur = be(yr.moduleSymbol, wr), ii = Ur.computedWithoutCache, mi = Ur.moduleSpecifiers, pe = !!(yr.targetFlags & 111551), or = R(ye, true, yr.symbol, yr.targetFlags, wr, Er);
                  return Ge += ii ? 1 : 0, e2.mapDefined(mi, function(qr) {
                    return lr && e2.pathContainsNodeModules(qr) ? void 0 : !pe && Br && de !== void 0 ? { kind: 1, moduleSpecifier: qr, position: de, exportInfo: yr, isReExport: Ir > 0 } : { kind: 3, moduleSpecifier: qr, importKind: Y(we, yr.exportKind, Er), useRequire: Ae, addAsTypeOnly: or, exportInfo: yr, isReExport: Ir > 0 };
                  });
                });
                return { computedWithoutCacheCount: Ge, fixes: ur };
              }
              function he(_e, we, de, ye, Ae, er, ir, Cr, Ye, Br) {
                var Er = e2.firstDefined(we, function(Ne) {
                  return F2(Ne, er, ir, de.getTypeChecker(), de.getCompilerOptions());
                });
                return Er ? { fixes: [Er] } : ee(de, ye, Ae, er, ir, _e, Cr, Ye, Br);
              }
              function F2(_e, we, de, ye, Ae) {
                var er, ir = _e.declaration, Cr = _e.importKind, Ye = _e.symbol, Br = _e.targetFlags, Er = (er = e2.tryGetModuleSpecifierFromDeclaration(ir)) === null || er === void 0 ? void 0 : er.text;
                if (Er) {
                  var Ne = de ? 4 : R(we, true, Ye, Br, ye, Ae);
                  return { kind: 3, moduleSpecifier: Er, importKind: Cr, addAsTypeOnly: Ne, useRequire: de };
                }
              }
              function x2(_e, we, de, ye) {
                var Ae = e2.getTokenAtPosition(_e.sourceFile, de), er;
                if (we === e2.Diagnostics._0_refers_to_a_UMD_global_but_the_current_file_is_a_module_Consider_adding_an_import_instead.code)
                  er = P(_e, Ae);
                else if (e2.isIdentifier(Ae))
                  if (we === e2.Diagnostics._0_cannot_be_used_as_a_value_because_it_was_imported_using_import_type.code) {
                    var ir = I(_e.sourceFile, _e.program.getTypeChecker(), Ae, _e.program.getCompilerOptions()), Cr = H(_e.sourceFile, Ae, ir, _e.program);
                    return Cr && { fixes: [Cr], symbolName: ir, errorIdentifierText: Ae.text };
                  } else
                    er = j(_e, Ae, ye);
                else
                  return;
                var Ye = e2.createPackageJsonImportFilter(_e.sourceFile, _e.preferences, _e.host);
                return er && Ke(Ke({}, er), { fixes: X(er.fixes, _e.sourceFile, _e.program, Ye, _e.host) });
              }
              function X(_e, we, de, ye, Ae) {
                var er = function(ir) {
                  return e2.toPath(ir, Ae.getCurrentDirectory(), e2.hostGetCanonicalFileName(Ae));
                };
                return e2.sort(_e, function(ir, Cr) {
                  return e2.compareValues(ir.kind, Cr.kind) || A2(ir, Cr, we, de, ye.allowsImportingSpecifier, er);
                });
              }
              function $(_e, we, de, ye, Ae) {
                if (!!e2.some(_e))
                  return _e[0].kind === 0 || _e[0].kind === 2 ? _e[0] : _e.reduce(function(er, ir) {
                    return A2(ir, er, we, de, ye.allowsImportingSpecifier, function(Cr) {
                      return e2.toPath(Cr, Ae.getCurrentDirectory(), e2.hostGetCanonicalFileName(Ae));
                    }) === -1 ? ir : er;
                  });
              }
              function A2(_e, we, de, ye, Ae, er) {
                return _e.kind !== 0 && we.kind !== 0 ? e2.compareBooleans(Ae(we.moduleSpecifier), Ae(_e.moduleSpecifier)) || L(_e.moduleSpecifier, we.moduleSpecifier, de, ye) || e2.compareBooleans(y(_e, de, ye.getCompilerOptions(), er), y(we, de, ye.getCompilerOptions(), er)) || e2.compareNumberOfDirectorySeparators(_e.moduleSpecifier, we.moduleSpecifier) : 0;
              }
              function y(_e, we, de, ye) {
                var Ae;
                if (_e.isReExport && ((Ae = _e.exportInfo) === null || Ae === void 0 ? void 0 : Ae.moduleFileName) && e2.getEmitModuleResolutionKind(de) === e2.ModuleResolutionKind.NodeJs && V(_e.exportInfo.moduleFileName)) {
                  var er = ye(e2.getDirectoryPath(_e.exportInfo.moduleFileName));
                  return e2.startsWith(we.path, er);
                }
                return false;
              }
              function V(_e) {
                return e2.getBaseFileName(_e, [".js", ".jsx", ".d.ts", ".ts", ".tsx"], true) === "index";
              }
              function L(_e, we, de, ye) {
                return e2.startsWith(_e, "node:") && !e2.startsWith(we, "node:") ? e2.shouldUseUriStyleNodeCoreModules(de, ye) ? -1 : 1 : e2.startsWith(we, "node:") && !e2.startsWith(_e, "node:") ? e2.shouldUseUriStyleNodeCoreModules(de, ye) ? 1 : -1 : 0;
              }
              function P(_e, we) {
                var de, ye = _e.sourceFile, Ae = _e.program, er = _e.host, ir = _e.preferences, Cr = Ae.getTypeChecker(), Ye = k(we, Cr);
                if (!!Ye) {
                  var Br = Cr.getAliasedSymbol(Ye), Er = Ye.name, Ne = [{ symbol: Ye, moduleSymbol: Br, moduleFileName: void 0, exportKind: 3, targetFlags: Br.flags, isFromPackageJson: false }], n = ve(ye, Ae), lr = e2.isIdentifier(we) ? we.getStart(ye) : void 0, be = b(Ne, lr ? { position: lr, symbolName: Er } : void 0, false, n, Ae, ye, er, ir).fixes;
                  return { fixes: be, symbolName: Er, errorIdentifierText: (de = e2.tryCast(we, e2.isIdentifier)) === null || de === void 0 ? void 0 : de.text };
                }
              }
              function k(_e, we) {
                var de = e2.isIdentifier(_e) ? we.getSymbolAtLocation(_e) : void 0;
                if (e2.isUMDExportSymbol(de))
                  return de;
                var ye = _e.parent;
                return e2.isJsxOpeningLikeElement(ye) && ye.tagName === _e || e2.isJsxOpeningFragment(ye) ? e2.tryCast(we.resolveName(we.getJsxNamespace(ye), e2.isJsxOpeningLikeElement(ye) ? _e : ye, 111551, false), e2.isUMDExportSymbol) : void 0;
              }
              function Y(_e, we, de, ye) {
                switch (we) {
                  case 0:
                    return 0;
                  case 1:
                    return 1;
                  case 2:
                    return D(_e, de, !!ye);
                  case 3:
                    return U(_e, de, !!ye);
                  default:
                    return e2.Debug.assertNever(we);
                }
              }
              C.getImportKind = Y;
              function U(_e, we, de) {
                if (e2.getAllowSyntheticDefaultImports(we))
                  return 1;
                var ye = e2.getEmitModuleKind(we);
                switch (ye) {
                  case e2.ModuleKind.AMD:
                  case e2.ModuleKind.CommonJS:
                  case e2.ModuleKind.UMD:
                    return e2.isInJSFile(_e) && (e2.isExternalModule(_e) || de) ? 2 : 3;
                  case e2.ModuleKind.System:
                  case e2.ModuleKind.ES2015:
                  case e2.ModuleKind.ES2020:
                  case e2.ModuleKind.ES2022:
                  case e2.ModuleKind.ESNext:
                  case e2.ModuleKind.None:
                    return 2;
                  case e2.ModuleKind.Node16:
                  case e2.ModuleKind.NodeNext:
                    return _e.impliedNodeFormat === e2.ModuleKind.ESNext ? 2 : 3;
                  default:
                    return e2.Debug.assertNever(ye, "Unexpected moduleKind ".concat(ye));
                }
              }
              function j(_e, we, de) {
                var ye = _e.sourceFile, Ae = _e.program, er = _e.cancellationToken, ir = _e.host, Cr = _e.preferences, Ye = Ae.getTypeChecker(), Br = Ae.getCompilerOptions(), Er = I(ye, Ye, we, Br);
                if (Er !== "default") {
                  var Ne = e2.isValidTypeOnlyAliasUseSite(we), n = ve(ye, Ae), lr = d(Er, e2.isJSXTagName(we), e2.getMeaningFromLocation(we), er, ye, Ae, de, ir, Cr), be = e2.arrayFrom(e2.flatMapIterator(lr.entries(), function(Ge) {
                    var ur = Ge[0], yr = Ge[1];
                    return b(yr, { symbolName: Er, position: we.getStart(ye) }, Ne, n, Ae, ye, ir, Cr).fixes;
                  }));
                  return { fixes: be, symbolName: Er, errorIdentifierText: we.text };
                }
              }
              function H(_e, we, de, ye) {
                var Ae = ye.getTypeChecker(), er = Ae.resolveName(de, we, 111551, true);
                if (!!er) {
                  var ir = Ae.getTypeOnlyAliasDeclaration(er);
                  if (!(!ir || e2.getSourceFileOfNode(ir) !== _e))
                    return { kind: 4, typeOnlyAliasDeclaration: ir };
                }
              }
              function I(_e, we, de, ye) {
                var Ae = de.parent;
                if ((e2.isJsxOpeningLikeElement(Ae) || e2.isJsxClosingElement(Ae)) && Ae.tagName === de && e2.jsxModeNeedsExplicitImport(ye.jsx)) {
                  var er = we.getJsxNamespace(_e);
                  if (l(er, de, we))
                    return er;
                }
                return de.text;
              }
              function l(_e, we, de) {
                if (e2.isIntrinsicJsxName(we.text))
                  return true;
                var ye = de.resolveName(_e, we, 111551, true);
                return !ye || e2.some(ye.declarations, e2.isTypeOnlyImportOrExportDeclaration) && !(ye.flags & 111551);
              }
              function d(_e, we, de, ye, Ae, er, ir, Cr, Ye) {
                var Br, Er = e2.createMultiMap(), Ne = e2.createPackageJsonImportFilter(Ae, Ye, Cr), n = (Br = Cr.getModuleSpecifierCache) === null || Br === void 0 ? void 0 : Br.call(Cr), lr = e2.memoizeOne(function(Ge) {
                  return e2.createModuleSpecifierResolutionHost(Ge ? Cr.getPackageJsonAutoImportProvider() : er, Cr);
                });
                function be(Ge, ur, yr, Ir, wr, Ur) {
                  var ii = lr(Ur);
                  if (ur && e2.isImportableFile(wr, Ae, ur, Ye, Ne, ii, n) || !ur && Ne.allowsImportingAmbientModule(Ge, ii)) {
                    var mi = wr.getTypeChecker();
                    Er.add(e2.getUniqueSymbolId(yr, mi).toString(), { symbol: yr, moduleSymbol: Ge, moduleFileName: ur == null ? void 0 : ur.fileName, exportKind: Ir, targetFlags: e2.skipAlias(yr, mi).flags, isFromPackageJson: Ur });
                  }
                }
                return e2.forEachExternalModuleToImportFrom(er, Cr, ir, function(Ge, ur, yr, Ir) {
                  var wr = yr.getTypeChecker();
                  ye.throwIfCancellationRequested();
                  var Ur = yr.getCompilerOptions(), ii = e2.getDefaultLikeExportInfo(Ge, wr, Ur);
                  ii && (ii.name === _e || rr(Ge, e2.getEmitScriptTarget(Ur), we) === _e) && He(ii.symbolForMeaning, de) && be(Ge, ur, ii.symbol, ii.exportKind, yr, Ir);
                  var mi = wr.tryGetMemberInModuleExportsAndProperties(_e, Ge);
                  mi && He(mi, de) && be(Ge, ur, mi, 0, yr, Ir);
                }), Er;
              }
              function D(_e, we, de) {
                var ye = e2.getAllowSyntheticDefaultImports(we), Ae = e2.isInJSFile(_e);
                if (!Ae && e2.getEmitModuleKind(we) >= e2.ModuleKind.ES2015)
                  return ye ? 1 : 2;
                if (Ae)
                  return e2.isExternalModule(_e) || de ? ye ? 1 : 2 : 3;
                for (var er = 0, ir = _e.statements; er < ir.length; er++) {
                  var Cr = ir[er];
                  if (e2.isImportEqualsDeclaration(Cr) && !e2.nodeIsMissing(Cr.moduleReference))
                    return 3;
                }
                return ye ? 1 : 3;
              }
              function fe(_e, we, de, ye, Ae, er, ir) {
                var Cr, Ye = e2.textChanges.ChangeTracker.with(_e, function(Br) {
                  Cr = g(Br, we, de, ye, Ae, er, ir);
                });
                return C.createCodeFixAction(C.importFixName, Ye, Cr, w, e2.Diagnostics.Add_all_missing_imports);
              }
              function g(_e, we, de, ye, Ae, er, ir) {
                switch (ye.kind) {
                  case 0:
                    return Fe(_e, we, ye), [e2.Diagnostics.Change_0_to_1, de, "".concat(ye.namespacePrefix, ".").concat(de)];
                  case 1:
                    return Z2(_e, we, ye, er), [e2.Diagnostics.Change_0_to_1, de, Be(ye.moduleSpecifier, er) + de];
                  case 2: {
                    var Cr = ye.importClauseOrBindingPattern, Ye = ye.importKind, Br = ye.addAsTypeOnly, Er = ye.moduleSpecifier;
                    We(_e, we, Cr, Ye === 1 ? { name: de, addAsTypeOnly: Br } : void 0, Ye === 0 ? [{ name: de, addAsTypeOnly: Br }] : e2.emptyArray, ir);
                    var Ne = e2.stripQuotes(Er);
                    return Ae ? [e2.Diagnostics.Import_0_from_1, de, Ne] : [e2.Diagnostics.Update_import_from_0, Ne];
                  }
                  case 3: {
                    var Ye = ye.importKind, Er = ye.moduleSpecifier, Br = ye.addAsTypeOnly, n = ye.useRequire, lr = n ? ze : Re, be = Ye === 1 ? { name: de, addAsTypeOnly: Br } : void 0, Ge = Ye === 0 ? [{ name: de, addAsTypeOnly: Br }] : void 0, ur = Ye === 2 || Ye === 3 ? { importKind: Ye, name: de, addAsTypeOnly: Br } : void 0;
                    return e2.insertImports(_e, we, lr(Er, er, be, Ge, ur), true), Ae ? [e2.Diagnostics.Import_0_from_1, de, Er] : [e2.Diagnostics.Add_import_from_0, Er];
                  }
                  case 4: {
                    var yr = ye.typeOnlyAliasDeclaration, Ir = ue(_e, yr, ir, we);
                    return Ir.kind === 270 ? [e2.Diagnostics.Remove_type_from_import_of_0_from_1, de, ne(Ir.parent.parent)] : [e2.Diagnostics.Remove_type_from_import_declaration_from_0, ne(Ir)];
                  }
                  default:
                    return e2.Debug.assertNever(ye, "Unexpected fix kind ".concat(ye.kind));
                }
              }
              function ne(_e) {
                var we, de;
                return _e.kind === 265 ? ((de = e2.tryCast((we = e2.tryCast(_e.moduleReference, e2.isExternalModuleReference)) === null || we === void 0 ? void 0 : we.expression, e2.isStringLiteralLike)) === null || de === void 0 ? void 0 : de.text) || _e.moduleReference.getText() : e2.cast(_e.parent.moduleSpecifier, e2.isStringLiteral).text;
              }
              function ue(_e, we, de, ye) {
                var Ae = de.preserveValueImports && de.isolatedModules;
                switch (we.kind) {
                  case 270:
                    if (we.isTypeOnly) {
                      if (we.parent.elements.length > 1 && e2.OrganizeImports.importSpecifiersAreSorted(we.parent.elements)) {
                        _e.delete(ye, we);
                        var er = e2.factory.updateImportSpecifier(we, false, we.propertyName, we.name), ir = e2.OrganizeImports.getImportSpecifierInsertionIndex(we.parent.elements, er);
                        _e.insertImportSpecifierAtIndex(ye, er, we.parent, ir);
                      } else
                        _e.deleteRange(ye, we.getFirstToken());
                      return we;
                    } else
                      return e2.Debug.assert(we.parent.parent.isTypeOnly), Cr(we.parent.parent), we.parent.parent;
                  case 267:
                    return Cr(we), we;
                  case 268:
                    return Cr(we.parent), we.parent;
                  case 265:
                    return _e.deleteRange(ye, we.getChildAt(1)), we;
                  default:
                    e2.Debug.failBadSyntaxKind(we);
                }
                function Cr(Ye) {
                  if (_e.delete(ye, e2.getTypeKeywordOfTypeOnlyImport(Ye, ye)), Ae) {
                    var Br = e2.tryCast(Ye.namedBindings, e2.isNamedImports);
                    if (Br && Br.elements.length > 1) {
                      e2.OrganizeImports.importSpecifiersAreSorted(Br.elements) && we.kind === 270 && Br.elements.indexOf(we) !== 0 && (_e.delete(ye, we), _e.insertImportSpecifierAtIndex(ye, we, Br, 0));
                      for (var Er = 0, Ne = Br.elements; Er < Ne.length; Er++) {
                        var n = Ne[Er];
                        n !== we && !n.isTypeOnly && _e.insertModifierBefore(ye, 152, n);
                      }
                    }
                  }
                }
              }
              function We(_e, we, de, ye, Ae, er) {
                var ir;
                if (de.kind === 201) {
                  ye && pe(de, ye.name, "default");
                  for (var Cr = 0, Ye = Ae; Cr < Ye.length; Cr++) {
                    var Br = Ye[Cr];
                    pe(de, Br.name, void 0);
                  }
                  return;
                }
                var Er = de.isTypeOnly && e2.some(Ve([ye], Ae, true), function(or) {
                  return (or == null ? void 0 : or.addAsTypeOnly) === 4;
                }), Ne = de.namedBindings && ((ir = e2.tryCast(de.namedBindings, e2.isNamedImports)) === null || ir === void 0 ? void 0 : ir.elements), n = Er && er.preserveValueImports && er.isolatedModules;
                if (ye && (e2.Debug.assert(!de.name, "Cannot add a default import to an import clause that already has one"), _e.insertNodeAt(we, de.getStart(we), e2.factory.createIdentifier(ye.name), { suffix: ", " })), Ae.length) {
                  var lr = e2.stableSort(Ae.map(function(or) {
                    return e2.factory.createImportSpecifier((!de.isTypeOnly || Er) && ge(or), void 0, e2.factory.createIdentifier(or.name));
                  }), e2.OrganizeImports.compareImportOrExportSpecifiers);
                  if ((Ne == null ? void 0 : Ne.length) && e2.OrganizeImports.importSpecifiersAreSorted(Ne))
                    for (var be = 0, Ge = lr; be < Ge.length; be++) {
                      var ur = Ge[be], yr = n && !ur.isTypeOnly ? 0 : e2.OrganizeImports.getImportSpecifierInsertionIndex(Ne, ur);
                      _e.insertImportSpecifierAtIndex(we, ur, de.namedBindings, yr);
                    }
                  else if (Ne != null && Ne.length)
                    for (var Ir = 0, wr = lr; Ir < wr.length; Ir++) {
                      var ur = wr[Ir];
                      _e.insertNodeInListAfter(we, e2.last(Ne), ur, Ne);
                    }
                  else if (lr.length) {
                    var Ur = e2.factory.createNamedImports(lr);
                    de.namedBindings ? _e.replaceNode(we, de.namedBindings, Ur) : _e.insertNodeAfter(we, e2.Debug.checkDefined(de.name, "Import clause must have either named imports or a default import"), Ur);
                  }
                }
                if (Er && (_e.delete(we, e2.getTypeKeywordOfTypeOnlyImport(de, we)), n && Ne))
                  for (var ii = 0, mi = Ne; ii < mi.length; ii++) {
                    var Br = mi[ii];
                    _e.insertModifierBefore(we, 152, Br);
                  }
                function pe(or, qr, si) {
                  var Di = e2.factory.createBindingElement(void 0, si, qr);
                  or.elements.length ? _e.insertNodeInListAfter(we, e2.last(or.elements), Di) : _e.replaceNode(we, or, e2.factory.createObjectBindingPattern([Di]));
                }
              }
              function Fe(_e, we, de) {
                var ye = de.namespacePrefix, Ae = de.position;
                _e.insertText(we, Ae, ye + ".");
              }
              function Z2(_e, we, de, ye) {
                var Ae = de.moduleSpecifier, er = de.position;
                _e.insertText(we, er, Be(Ae, ye));
              }
              function Be(_e, we) {
                var de = e2.getQuoteFromPreference(we);
                return "import(".concat(de).concat(_e).concat(de, ").");
              }
              function ge(_e) {
                var we = _e.addAsTypeOnly;
                return we === 2;
              }
              function Re(_e, we, de, ye, Ae) {
                var er = e2.makeStringLiteral(_e, we), ir;
                if (de !== void 0 || (ye == null ? void 0 : ye.length)) {
                  var Cr = (!de || ge(de)) && e2.every(ye, ge);
                  ir = e2.combine(ir, e2.makeImport(de && e2.factory.createIdentifier(de.name), ye == null ? void 0 : ye.map(function(Br) {
                    var Er = Br.addAsTypeOnly, Ne = Br.name;
                    return e2.factory.createImportSpecifier(!Cr && Er === 2, void 0, e2.factory.createIdentifier(Ne));
                  }), _e, we, Cr));
                }
                if (Ae) {
                  var Ye = Ae.importKind === 3 ? e2.factory.createImportEqualsDeclaration(void 0, void 0, ge(Ae), e2.factory.createIdentifier(Ae.name), e2.factory.createExternalModuleReference(er)) : e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(ge(Ae), void 0, e2.factory.createNamespaceImport(e2.factory.createIdentifier(Ae.name))), er, void 0);
                  ir = e2.combine(ir, Ye);
                }
                return e2.Debug.checkDefined(ir);
              }
              function ze(_e, we, de, ye, Ae) {
                var er = e2.makeStringLiteral(_e, we), ir;
                if (de || (ye == null ? void 0 : ye.length)) {
                  var Cr = (ye == null ? void 0 : ye.map(function(Br) {
                    var Er = Br.name;
                    return e2.factory.createBindingElement(void 0, void 0, Er);
                  })) || [];
                  de && Cr.unshift(e2.factory.createBindingElement(void 0, "default", de.name));
                  var Ye = Ee(e2.factory.createObjectBindingPattern(Cr), er);
                  ir = e2.combine(ir, Ye);
                }
                if (Ae) {
                  var Ye = Ee(Ae.name, er);
                  ir = e2.combine(ir, Ye);
                }
                return e2.Debug.checkDefined(ir);
              }
              function Ee(_e, we) {
                return e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(typeof _e == "string" ? e2.factory.createIdentifier(_e) : _e, void 0, void 0, e2.factory.createCallExpression(e2.factory.createIdentifier("require"), void 0, [we]))], 2));
              }
              function He(_e, we) {
                var de = _e.declarations;
                return e2.some(de, function(ye) {
                  return !!(e2.getMeaningFromDeclaration(ye) & we);
                });
              }
              function rr(_e, we, de) {
                return Ie(e2.removeFileExtension(e2.stripQuotes(_e.name)), we, de);
              }
              C.moduleSymbolToValidIdentifier = rr;
              function Ie(_e, we, de) {
                var ye = e2.getBaseFileName(e2.removeSuffix(_e, "/index")), Ae = "", er = true, ir = ye.charCodeAt(0);
                e2.isIdentifierStart(ir, we) ? (Ae += String.fromCharCode(ir), de && (Ae = Ae.toUpperCase())) : er = false;
                for (var Cr = 1; Cr < ye.length; Cr++) {
                  var Ye = ye.charCodeAt(Cr), Br = e2.isIdentifierPart(Ye, we);
                  if (Br) {
                    var Er = String.fromCharCode(Ye);
                    er || (Er = Er.toUpperCase()), Ae += Er;
                  }
                  er = Br;
                }
                return e2.isStringANonContextualKeyword(Ae) ? "_".concat(Ae) : Ae || "_";
              }
              C.moduleSpecifierToValidIdentifier = Ie;
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w, B = "fixOverrideModifier", E = "fixAddOverrideModifier", Q = "fixRemoveOverrideModifier", le = [e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code, e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code, e2.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code, e2.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code, e2.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code, e2.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code, e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code, e2.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code, e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code], N = (w = {}, w[e2.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code] = { descriptions: e2.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e2.Diagnostics.Add_all_missing_override_modifiers }, w[e2.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code] = { descriptions: e2.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e2.Diagnostics.Add_all_missing_override_modifiers }, w[e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code] = { descriptions: e2.Diagnostics.Remove_override_modifier, fixId: Q, fixAllDescriptions: e2.Diagnostics.Remove_all_unnecessary_override_modifiers }, w[e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code] = { descriptions: e2.Diagnostics.Remove_override_modifier, fixId: Q, fixAllDescriptions: e2.Diagnostics.Remove_override_modifier }, w[e2.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code] = { descriptions: e2.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e2.Diagnostics.Add_all_missing_override_modifiers }, w[e2.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code] = { descriptions: e2.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e2.Diagnostics.Add_all_missing_override_modifiers }, w[e2.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code] = { descriptions: e2.Diagnostics.Add_override_modifier, fixId: E, fixAllDescriptions: e2.Diagnostics.Remove_all_unnecessary_override_modifiers }, w[e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code] = { descriptions: e2.Diagnostics.Remove_override_modifier, fixId: Q, fixAllDescriptions: e2.Diagnostics.Remove_all_unnecessary_override_modifiers }, w[e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code] = { descriptions: e2.Diagnostics.Remove_override_modifier, fixId: Q, fixAllDescriptions: e2.Diagnostics.Remove_all_unnecessary_override_modifiers }, w);
              C.registerCodeFix({ errorCodes: le, getCodeActions: function(K) {
                var b = K.errorCode, se = K.span, J = N[b];
                if (!J)
                  return e2.emptyArray;
                var ie = J.descriptions, R = J.fixId, q = J.fixAllDescriptions, O = e2.textChanges.ChangeTracker.with(K, function(ve) {
                  return p(ve, K, b, se.start);
                });
                return [C.createCodeFixActionMaybeFixAll(B, O, ie, R, q)];
              }, fixIds: [B, E, Q], getAllCodeActions: function(T) {
                return C.codeFixAll(T, le, function(K, b) {
                  var se = b.code, J = b.start, ie = N[se];
                  !ie || ie.fixId !== T.fixId || p(K, T, se, J);
                });
              } });
              function p(T, K, b, se) {
                switch (b) {
                  case e2.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_a_member_in_the_base_class_0.code:
                  case e2.Diagnostics.This_member_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:
                  case e2.Diagnostics.This_member_must_have_an_override_modifier_because_it_overrides_an_abstract_method_that_is_declared_in_the_base_class_0.code:
                  case e2.Diagnostics.This_parameter_property_must_have_an_override_modifier_because_it_overrides_a_member_in_base_class_0.code:
                  case e2.Diagnostics.This_parameter_property_must_have_a_JSDoc_comment_with_an_override_tag_because_it_overrides_a_member_in_the_base_class_0.code:
                    return m2(T, K.sourceFile, se);
                  case e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0.code:
                  case e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0.code:
                  case e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_its_containing_class_0_does_not_extend_another_class.code:
                  case e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_its_containing_class_0_does_not_extend_another_class.code:
                    return G(T, K.sourceFile, se);
                  default:
                    e2.Debug.fail("Unexpected error code: " + b);
                }
              }
              function m2(T, K, b) {
                var se = f4(K, b);
                if (e2.isSourceFileJS(K)) {
                  T.addJSDocTags(K, se, [e2.factory.createJSDocOverrideTag(e2.factory.createIdentifier("override"))]);
                  return;
                }
                var J = se.modifiers || e2.emptyArray, ie = e2.find(J, e2.isStaticModifier), R = e2.find(J, e2.isAbstractModifier), q = e2.find(J, function(ee) {
                  return e2.isAccessibilityModifier(ee.kind);
                }), O = R ? R.end : ie ? ie.end : q ? q.end : se.decorators ? e2.skipTrivia(K.text, se.decorators.end) : se.getStart(K), ve = q || ie || R ? { prefix: " " } : { suffix: " " };
                T.insertModifierAt(K, O, 159, ve);
              }
              function G(T, K, b) {
                var se = f4(K, b);
                if (e2.isSourceFileJS(K)) {
                  T.filterJSDocTags(K, se, e2.not(e2.isJSDocOverrideTag));
                  return;
                }
                var J = se.modifiers && e2.find(se.modifiers, function(ie) {
                  return ie.kind === 159;
                });
                e2.Debug.assertIsDefined(J), T.deleteModifier(K, J);
              }
              function oe(T) {
                switch (T.kind) {
                  case 171:
                  case 167:
                  case 169:
                  case 172:
                  case 173:
                    return true;
                  case 164:
                    return e2.isParameterPropertyDeclaration(T, T.parent);
                  default:
                    return false;
                }
              }
              function f4(T, K) {
                var b = e2.getTokenAtPosition(T, K), se = e2.findAncestor(b, function(J) {
                  return e2.isClassLike(J) ? "quit" : oe(J);
                });
                return e2.Debug.assert(se && oe(se)), se;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixNoPropertyAccessFromIndexSignature", B = [e2.Diagnostics.Property_0_comes_from_an_index_signature_so_it_must_be_accessed_with_0.code];
              C.registerCodeFix({ errorCodes: B, fixIds: [w], getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m2 = le.preferences, G = Q(N, p.start), oe = e2.textChanges.ChangeTracker.with(le, function(f4) {
                  return E(f4, le.sourceFile, G, m2);
                });
                return [C.createCodeFixAction(w, oe, [e2.Diagnostics.Use_element_access_for_0, G.name.text], w, e2.Diagnostics.Use_element_access_for_all_undeclared_properties)];
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return E(N, p.file, Q(p.file, p.start), le.preferences);
                });
              } });
              function E(le, N, p, m2) {
                var G = e2.getQuotePreference(N, m2), oe = e2.factory.createStringLiteral(p.name.text, G === 0);
                le.replaceNode(N, p, e2.isPropertyAccessChain(p) ? e2.factory.createElementAccessChain(p.expression, p.questionDotToken, oe) : e2.factory.createElementAccessExpression(p.expression, oe));
              }
              function Q(le, N) {
                return e2.cast(e2.getTokenAtPosition(le, N).parent, e2.isPropertyAccessExpression);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixImplicitThis", B = [e2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = le.program, m2 = le.span, G, oe = e2.textChanges.ChangeTracker.with(le, function(f4) {
                  G = E(f4, N, m2.start, p.getTypeChecker());
                });
                return G ? [C.createCodeFixAction(w, oe, G, w, e2.Diagnostics.Fix_all_implicit_this_errors)] : e2.emptyArray;
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  E(le, N.file, N.start, Q.program.getTypeChecker());
                });
              } });
              function E(Q, le, N, p) {
                var m2 = e2.getTokenAtPosition(le, N);
                if (!!e2.isThis(m2)) {
                  var G = e2.getThisContainer(m2, false);
                  if (!(!e2.isFunctionDeclaration(G) && !e2.isFunctionExpression(G)) && !e2.isSourceFile(e2.getThisContainer(G, false))) {
                    var oe = e2.Debug.checkDefined(e2.findChildOfKind(G, 98, le)), f4 = G.name, T = e2.Debug.checkDefined(G.body);
                    return e2.isFunctionExpression(G) ? f4 && e2.FindAllReferences.Core.isSymbolReferencedInFile(f4, p, le, T) ? void 0 : (Q.delete(le, oe), f4 && Q.delete(le, f4), Q.insertText(le, T.pos, " =>"), [e2.Diagnostics.Convert_function_expression_0_to_arrow_function, f4 ? f4.text : e2.ANONYMOUS]) : (Q.replaceNode(le, oe, e2.factory.createToken(85)), Q.insertText(le, f4.end, " = "), Q.insertText(le, T.pos, " =>"), [e2.Diagnostics.Convert_function_declaration_0_to_arrow_function, f4.text]);
                  }
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixIncorrectNamedTupleSyntax", B = [e2.Diagnostics.A_labeled_tuple_element_is_declared_as_optional_with_a_question_mark_after_the_name_and_before_the_colon_rather_than_after_the_type.code, e2.Diagnostics.A_labeled_tuple_element_is_declared_as_rest_with_a_before_the_name_rather_than_before_the_type.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m2 = N.span, G = E(p, m2.start), oe = e2.textChanges.ChangeTracker.with(N, function(f4) {
                  return Q(f4, p, G);
                });
                return [C.createCodeFixAction(w, oe, e2.Diagnostics.Move_labeled_tuple_element_modifiers_to_labels, w, e2.Diagnostics.Move_labeled_tuple_element_modifiers_to_labels)];
              }, fixIds: [w] });
              function E(le, N) {
                var p = e2.getTokenAtPosition(le, N);
                return e2.findAncestor(p, function(m2) {
                  return m2.kind === 197;
                });
              }
              function Q(le, N, p) {
                if (!!p) {
                  for (var m2 = p.type, G = false, oe = false; m2.kind === 185 || m2.kind === 186 || m2.kind === 191; )
                    m2.kind === 185 ? G = true : m2.kind === 186 && (oe = true), m2 = m2.type;
                  var f4 = e2.factory.updateNamedTupleMember(p, p.dotDotDotToken || (oe ? e2.factory.createToken(25) : void 0), p.name, p.questionToken || (G ? e2.factory.createToken(57) : void 0), m2);
                  f4 !== p && le.replaceNode(N, p, f4);
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixSpelling", B = [e2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code, e2.Diagnostics.Property_0_may_not_exist_on_type_1_Did_you_mean_2.code, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_1.code, e2.Diagnostics.Could_not_find_name_0_Did_you_mean_1.code, e2.Diagnostics.Cannot_find_namespace_0_Did_you_mean_1.code, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code, e2.Diagnostics._0_has_no_exported_member_named_1_Did_you_mean_2.code, e2.Diagnostics.This_member_cannot_have_an_override_modifier_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code, e2.Diagnostics.This_member_cannot_have_a_JSDoc_comment_with_an_override_tag_because_it_is_not_declared_in_the_base_class_0_Did_you_mean_1.code, e2.Diagnostics.No_overload_matches_this_call.code, e2.Diagnostics.Type_0_is_not_assignable_to_type_1.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m2 = p.sourceFile, G = p.errorCode, oe = E(m2, p.span.start, p, G);
                if (!!oe) {
                  var f4 = oe.node, T = oe.suggestedSymbol, K = e2.getEmitScriptTarget(p.host.getCompilationSettings()), b = e2.textChanges.ChangeTracker.with(p, function(se) {
                    return Q(se, m2, f4, T, K);
                  });
                  return [C.createCodeFixAction("spelling", b, [e2.Diagnostics.Change_spelling_to_0, e2.symbolName(T)], w, e2.Diagnostics.Fix_all_detected_spelling_errors)];
                }
              }, fixIds: [w], getAllCodeActions: function(p) {
                return C.codeFixAll(p, B, function(m2, G) {
                  var oe = E(G.file, G.start, p, G.code), f4 = e2.getEmitScriptTarget(p.host.getCompilationSettings());
                  oe && Q(m2, p.sourceFile, oe.node, oe.suggestedSymbol, f4);
                });
              } });
              function E(p, m2, G, oe) {
                var f4 = e2.getTokenAtPosition(p, m2), T = f4.parent;
                if (!((oe === e2.Diagnostics.No_overload_matches_this_call.code || oe === e2.Diagnostics.Type_0_is_not_assignable_to_type_1.code) && !e2.isJsxAttribute(T))) {
                  var K = G.program.getTypeChecker(), b;
                  if (e2.isPropertyAccessExpression(T) && T.name === f4) {
                    e2.Debug.assert(e2.isMemberName(f4), "Expected an identifier for spelling (property access)");
                    var se = K.getTypeAtLocation(T.expression);
                    T.flags & 32 && (se = K.getNonNullableType(se)), b = K.getSuggestedSymbolForNonexistentProperty(f4, se);
                  } else if (e2.isBinaryExpression(T) && T.operatorToken.kind === 101 && T.left === f4 && e2.isPrivateIdentifier(f4)) {
                    var J = K.getTypeAtLocation(T.right);
                    b = K.getSuggestedSymbolForNonexistentProperty(f4, J);
                  } else if (e2.isQualifiedName(T) && T.right === f4) {
                    var ie = K.getSymbolAtLocation(T.left);
                    ie && ie.flags & 1536 && (b = K.getSuggestedSymbolForNonexistentModule(T.right, ie));
                  } else if (e2.isImportSpecifier(T) && T.name === f4) {
                    e2.Debug.assertNode(f4, e2.isIdentifier, "Expected an identifier for spelling (import)");
                    var R = e2.findAncestor(f4, e2.isImportDeclaration), q = N(p, G, R);
                    q && q.symbol && (b = K.getSuggestedSymbolForNonexistentModule(f4, q.symbol));
                  } else if (e2.isJsxAttribute(T) && T.name === f4) {
                    e2.Debug.assertNode(f4, e2.isIdentifier, "Expected an identifier for JSX attribute");
                    var O = e2.findAncestor(f4, e2.isJsxOpeningLikeElement), ve = K.getContextualTypeForArgumentAtIndex(O, 0);
                    b = K.getSuggestedSymbolForNonexistentJSXAttribute(f4, ve);
                  } else if (e2.hasSyntacticModifier(T, 16384) && e2.isClassElement(T) && T.name === f4) {
                    var ee = e2.findAncestor(f4, e2.isClassLike), he = ee ? e2.getEffectiveBaseTypeNode(ee) : void 0, F2 = he ? K.getTypeAtLocation(he) : void 0;
                    F2 && (b = K.getSuggestedSymbolForNonexistentClassMember(e2.getTextOfNode(f4), F2));
                  } else {
                    var x2 = e2.getMeaningFromLocation(f4), X = e2.getTextOfNode(f4);
                    e2.Debug.assert(X !== void 0, "name should be defined"), b = K.getSuggestedSymbolForNonexistentSymbol(f4, X, le(x2));
                  }
                  return b === void 0 ? void 0 : { node: f4, suggestedSymbol: b };
                }
              }
              function Q(p, m2, G, oe, f4) {
                var T = e2.symbolName(oe);
                if (!e2.isIdentifierText(T, f4) && e2.isPropertyAccessExpression(G.parent)) {
                  var K = oe.valueDeclaration;
                  K && e2.isNamedDeclaration(K) && e2.isPrivateIdentifier(K.name) ? p.replaceNode(m2, G, e2.factory.createIdentifier(T)) : p.replaceNode(m2, G.parent, e2.factory.createElementAccessExpression(G.parent.expression, e2.factory.createStringLiteral(T)));
                } else
                  p.replaceNode(m2, G, e2.factory.createIdentifier(T));
              }
              function le(p) {
                var m2 = 0;
                return p & 4 && (m2 |= 1920), p & 2 && (m2 |= 788968), p & 1 && (m2 |= 111551), m2;
              }
              function N(p, m2, G) {
                if (!(!G || !e2.isStringLiteralLike(G.moduleSpecifier))) {
                  var oe = e2.getResolvedModule(p, G.moduleSpecifier.text, e2.getModeForUsageLocation(p, G.moduleSpecifier));
                  if (!!oe)
                    return m2.program.getSourceFile(oe.resolvedFileName);
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "returnValueCorrect", B = "fixAddReturnStatement", E = "fixRemoveBracesFromArrowFunctionBody", Q = "fixWrapTheBlockWithParen", le = [e2.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code, e2.Diagnostics.Type_0_is_not_assignable_to_type_1.code, e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code], N;
              (function(R) {
                R[R.MissingReturnStatement = 0] = "MissingReturnStatement", R[R.MissingParentheses = 1] = "MissingParentheses";
              })(N || (N = {})), C.registerCodeFix({ errorCodes: le, fixIds: [B, E, Q], getCodeActions: function(q) {
                var O = q.program, ve = q.sourceFile, ee = q.span.start, he = q.errorCode, F2 = oe(O.getTypeChecker(), ve, ee, he);
                if (!!F2)
                  return F2.kind === N.MissingReturnStatement ? e2.append([se(q, F2.expression, F2.statement)], e2.isArrowFunction(F2.declaration) ? J(q, F2.declaration, F2.expression, F2.commentSource) : void 0) : [ie(q, F2.declaration, F2.expression)];
              }, getAllCodeActions: function(R) {
                return C.codeFixAll(R, le, function(q, O) {
                  var ve = oe(R.program.getTypeChecker(), O.file, O.start, O.code);
                  if (!!ve)
                    switch (R.fixId) {
                      case B:
                        T(q, O.file, ve.expression, ve.statement);
                        break;
                      case E:
                        if (!e2.isArrowFunction(ve.declaration))
                          return;
                        K(q, O.file, ve.declaration, ve.expression, ve.commentSource, false);
                        break;
                      case Q:
                        if (!e2.isArrowFunction(ve.declaration))
                          return;
                        b(q, O.file, ve.declaration, ve.expression);
                        break;
                      default:
                        e2.Debug.fail(JSON.stringify(R.fixId));
                    }
                });
              } });
              function p(R, q, O) {
                var ve = R.createSymbol(4, q.escapedText);
                ve.type = R.getTypeAtLocation(O);
                var ee = e2.createSymbolTable([ve]);
                return R.createAnonymousType(void 0, ee, [], [], []);
              }
              function m2(R, q, O, ve) {
                if (!(!q.body || !e2.isBlock(q.body) || e2.length(q.body.statements) !== 1)) {
                  var ee = e2.first(q.body.statements);
                  if (e2.isExpressionStatement(ee) && G(R, q, R.getTypeAtLocation(ee.expression), O, ve))
                    return { declaration: q, kind: N.MissingReturnStatement, expression: ee.expression, statement: ee, commentSource: ee.expression };
                  if (e2.isLabeledStatement(ee) && e2.isExpressionStatement(ee.statement)) {
                    var he = e2.factory.createObjectLiteralExpression([e2.factory.createPropertyAssignment(ee.label, ee.statement.expression)]), F2 = p(R, ee.label, ee.statement.expression);
                    if (G(R, q, F2, O, ve))
                      return e2.isArrowFunction(q) ? { declaration: q, kind: N.MissingParentheses, expression: he, statement: ee, commentSource: ee.statement.expression } : { declaration: q, kind: N.MissingReturnStatement, expression: he, statement: ee, commentSource: ee.statement.expression };
                  } else if (e2.isBlock(ee) && e2.length(ee.statements) === 1) {
                    var x2 = e2.first(ee.statements);
                    if (e2.isLabeledStatement(x2) && e2.isExpressionStatement(x2.statement)) {
                      var he = e2.factory.createObjectLiteralExpression([e2.factory.createPropertyAssignment(x2.label, x2.statement.expression)]), F2 = p(R, x2.label, x2.statement.expression);
                      if (G(R, q, F2, O, ve))
                        return { declaration: q, kind: N.MissingReturnStatement, expression: he, statement: ee, commentSource: x2 };
                    }
                  }
                }
              }
              function G(R, q, O, ve, ee) {
                if (ee) {
                  var he = R.getSignatureFromDeclaration(q);
                  if (he) {
                    e2.hasSyntacticModifier(q, 256) && (O = R.createPromiseType(O));
                    var F2 = R.createSignature(q, he.typeParameters, he.thisParameter, he.parameters, O, void 0, he.minArgumentCount, he.flags);
                    O = R.createAnonymousType(void 0, e2.createSymbolTable(), [F2], [], []);
                  } else
                    O = R.getAnyType();
                }
                return R.isTypeAssignableTo(O, ve);
              }
              function oe(R, q, O, ve) {
                var ee = e2.getTokenAtPosition(q, O);
                if (!!ee.parent) {
                  var he = e2.findAncestor(ee.parent, e2.isFunctionLikeDeclaration);
                  switch (ve) {
                    case e2.Diagnostics.A_function_whose_declared_type_is_neither_void_nor_any_must_return_a_value.code:
                      return !he || !he.body || !he.type || !e2.rangeContainsRange(he.type, ee) ? void 0 : m2(R, he, R.getTypeFromTypeNode(he.type), false);
                    case e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code:
                      if (!he || !e2.isCallExpression(he.parent) || !he.body)
                        return;
                      var F2 = he.parent.arguments.indexOf(he), x2 = R.getContextualTypeForArgumentAtIndex(he.parent, F2);
                      return x2 ? m2(R, he, x2, true) : void 0;
                    case e2.Diagnostics.Type_0_is_not_assignable_to_type_1.code:
                      if (!e2.isDeclarationName(ee) || !e2.isVariableLike(ee.parent) && !e2.isJsxAttribute(ee.parent))
                        return;
                      var X = f4(ee.parent);
                      return !X || !e2.isFunctionLikeDeclaration(X) || !X.body ? void 0 : m2(R, X, R.getTypeAtLocation(ee.parent), true);
                  }
                }
              }
              function f4(R) {
                switch (R.kind) {
                  case 254:
                  case 164:
                  case 203:
                  case 167:
                  case 296:
                    return R.initializer;
                  case 285:
                    return R.initializer && (e2.isJsxExpression(R.initializer) ? R.initializer.expression : void 0);
                  case 297:
                  case 166:
                  case 299:
                  case 347:
                  case 340:
                    return;
                }
              }
              function T(R, q, O, ve) {
                e2.suppressLeadingAndTrailingTrivia(O);
                var ee = e2.probablyUsesSemicolons(q);
                R.replaceNode(q, ve, e2.factory.createReturnStatement(O), { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Exclude, suffix: ee ? ";" : void 0 });
              }
              function K(R, q, O, ve, ee, he) {
                var F2 = he || e2.needsParentheses(ve) ? e2.factory.createParenthesizedExpression(ve) : ve;
                e2.suppressLeadingAndTrailingTrivia(ee), e2.copyComments(ee, F2), R.replaceNode(q, O.body, F2);
              }
              function b(R, q, O, ve) {
                R.replaceNode(q, O.body, e2.factory.createParenthesizedExpression(ve));
              }
              function se(R, q, O) {
                var ve = e2.textChanges.ChangeTracker.with(R, function(ee) {
                  return T(ee, R.sourceFile, q, O);
                });
                return C.createCodeFixAction(w, ve, e2.Diagnostics.Add_a_return_statement, B, e2.Diagnostics.Add_all_missing_return_statement);
              }
              function J(R, q, O, ve) {
                var ee = e2.textChanges.ChangeTracker.with(R, function(he) {
                  return K(he, R.sourceFile, q, O, ve, false);
                });
                return C.createCodeFixAction(w, ee, e2.Diagnostics.Remove_braces_from_arrow_function_body, E, e2.Diagnostics.Remove_braces_from_all_arrow_function_bodies_with_relevant_issues);
              }
              function ie(R, q, O) {
                var ve = e2.textChanges.ChangeTracker.with(R, function(ee) {
                  return b(ee, R.sourceFile, q, O);
                });
                return C.createCodeFixAction(w, ve, e2.Diagnostics.Wrap_the_following_body_with_parentheses_which_should_be_an_object_literal, Q, e2.Diagnostics.Wrap_all_object_literal_with_parentheses);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixMissingMember", B = "fixMissingProperties", E = "fixMissingAttributes", Q = "fixMissingFunctionDeclaration", le = [e2.Diagnostics.Property_0_does_not_exist_on_type_1.code, e2.Diagnostics.Property_0_does_not_exist_on_type_1_Did_you_mean_2.code, e2.Diagnostics.Property_0_is_missing_in_type_1_but_required_in_type_2.code, e2.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2.code, e2.Diagnostics.Type_0_is_missing_the_following_properties_from_type_1_Colon_2_and_3_more.code, e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code, e2.Diagnostics.Cannot_find_name_0.code];
              C.registerCodeFix({ errorCodes: le, getCodeActions: function(y) {
                var V = y.program.getTypeChecker(), L = p(y.sourceFile, y.span.start, y.errorCode, V, y.program);
                if (!!L) {
                  if (L.kind === 3) {
                    var P = e2.textChanges.ChangeTracker.with(y, function(k) {
                      return he(k, y, L);
                    });
                    return [C.createCodeFixAction(B, P, e2.Diagnostics.Add_missing_properties, B, e2.Diagnostics.Add_all_missing_properties)];
                  }
                  if (L.kind === 4) {
                    var P = e2.textChanges.ChangeTracker.with(y, function(Y) {
                      return ee(Y, y, L);
                    });
                    return [C.createCodeFixAction(E, P, e2.Diagnostics.Add_missing_attributes, E, e2.Diagnostics.Add_all_missing_attributes)];
                  }
                  if (L.kind === 2) {
                    var P = e2.textChanges.ChangeTracker.with(y, function(Y) {
                      return ve(Y, y, L);
                    });
                    return [C.createCodeFixAction(Q, P, [e2.Diagnostics.Add_missing_function_declaration_0, L.token.text], Q, e2.Diagnostics.Add_all_missing_function_declarations)];
                  }
                  if (L.kind === 1) {
                    var P = e2.textChanges.ChangeTracker.with(y, function(Y) {
                      return O(Y, y.program.getTypeChecker(), L);
                    });
                    return [C.createCodeFixAction(w, P, [e2.Diagnostics.Add_missing_enum_member_0, L.token.text], w, e2.Diagnostics.Add_all_missing_members)];
                  }
                  return e2.concatenate(R(y, L), G(y, L));
                }
              }, fixIds: [w, Q, B, E], getAllCodeActions: function(y) {
                var V = y.program, L = y.fixId, P = V.getTypeChecker(), k = new e2.Map(), Y = new e2.Map();
                return C.createCombinedCodeActions(e2.textChanges.ChangeTracker.with(y, function(U) {
                  C.eachDiagnostic(y, le, function(j) {
                    var H = p(j.file, j.start, j.code, P, y.program);
                    if (!(!H || !e2.addToSeen(k, e2.getNodeId(H.parentDeclaration) + "#" + H.token.text))) {
                      if (L === Q && H.kind === 2)
                        ve(U, y, H);
                      else if (L === B && H.kind === 3)
                        he(U, y, H);
                      else if (L === E && H.kind === 4)
                        ee(U, y, H);
                      else if (H.kind === 1 && O(U, P, H), H.kind === 0) {
                        var I = H.parentDeclaration, l = H.token, d = e2.getOrUpdate(Y, I, function() {
                          return [];
                        });
                        d.some(function(D) {
                          return D.token.text === l.text;
                        }) || d.push(H);
                      }
                    }
                  }), Y.forEach(function(j, H) {
                    for (var I = e2.isTypeLiteralNode(H) ? void 0 : C.getAllSupers(H, P), l = function(g) {
                      if (I != null && I.some(function(Re) {
                        var ze = Y.get(Re);
                        return !!ze && ze.some(function(Ee) {
                          var He = Ee.token;
                          return He.text === g.token.text;
                        });
                      }))
                        return "continue";
                      var ne = g.parentDeclaration, ue = g.declSourceFile, We = g.modifierFlags, Fe = g.token, Z2 = g.call, Be = g.isJSFile;
                      if (Z2 && !e2.isPrivateIdentifier(Fe))
                        q(y, U, Z2, Fe, We & 32, ne, ue);
                      else if (Be && !e2.isInterfaceDeclaration(ne) && !e2.isTypeLiteralNode(ne))
                        f4(U, ue, ne, Fe, !!(We & 32));
                      else {
                        var ge = b(P, ne, Fe);
                        se(U, ue, ne, Fe.text, ge, We & 32);
                      }
                    }, d = 0, D = j; d < D.length; d++) {
                      var fe = D[d];
                      l(fe);
                    }
                  });
                }));
              } });
              var N;
              (function(y) {
                y[y.TypeLikeDeclaration = 0] = "TypeLikeDeclaration", y[y.Enum = 1] = "Enum", y[y.Function = 2] = "Function", y[y.ObjectLiteral = 3] = "ObjectLiteral", y[y.JsxAttributes = 4] = "JsxAttributes";
              })(N || (N = {}));
              function p(y, V, L, P, k) {
                var Y = e2.getTokenAtPosition(y, V), U = Y.parent;
                if (L === e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code) {
                  if (!(Y.kind === 18 && e2.isObjectLiteralExpression(U) && e2.isCallExpression(U.parent)))
                    return;
                  var j = e2.findIndex(U.parent.arguments, function(rr) {
                    return rr === U;
                  });
                  if (j < 0)
                    return;
                  var H = e2.singleOrUndefined(P.getSignaturesOfType(P.getTypeAtLocation(U.parent.expression), 0));
                  if (!(H && H.declaration && H.parameters[j]))
                    return;
                  var I = H.parameters[j].valueDeclaration;
                  if (!(I && e2.isParameter(I) && e2.isIdentifier(I.name)))
                    return;
                  var l = e2.arrayFrom(P.getUnmatchedProperties(P.getTypeAtLocation(U), P.getParameterType(H, j), false, false));
                  return e2.length(l) ? { kind: 3, token: I.name, properties: l, parentDeclaration: U } : void 0;
                }
                if (!!e2.isMemberName(Y)) {
                  if (e2.isIdentifier(Y) && e2.hasInitializer(U) && U.initializer && e2.isObjectLiteralExpression(U.initializer)) {
                    var l = e2.arrayFrom(P.getUnmatchedProperties(P.getTypeAtLocation(U.initializer), P.getTypeAtLocation(Y), false, false));
                    return e2.length(l) ? { kind: 3, token: Y, properties: l, parentDeclaration: U.initializer } : void 0;
                  }
                  if (e2.isIdentifier(Y) && e2.isJsxOpeningLikeElement(Y.parent)) {
                    var d = e2.getEmitScriptTarget(k.getCompilerOptions()), D = $(P, d, Y.parent);
                    return e2.length(D) ? { kind: 4, token: Y, attributes: D, parentDeclaration: Y.parent } : void 0;
                  }
                  if (e2.isIdentifier(Y) && e2.isCallExpression(U))
                    return { kind: 2, token: Y, call: U, sourceFile: y, modifierFlags: 0, parentDeclaration: y };
                  if (!!e2.isPropertyAccessExpression(U)) {
                    var fe = e2.skipConstraint(P.getTypeAtLocation(U.expression)), g = fe.symbol;
                    if (!(!g || !g.declarations)) {
                      if (e2.isIdentifier(Y) && e2.isCallExpression(U.parent)) {
                        var ne = e2.find(g.declarations, e2.isModuleDeclaration), ue = ne == null ? void 0 : ne.getSourceFile();
                        if (ne && ue && !m2(k, ue))
                          return { kind: 2, token: Y, call: U.parent, sourceFile: y, modifierFlags: 1, parentDeclaration: ne };
                        var We = e2.find(g.declarations, e2.isSourceFile);
                        if (y.commonJsModuleIndicator)
                          return;
                        if (We && !m2(k, We))
                          return { kind: 2, token: Y, call: U.parent, sourceFile: We, modifierFlags: 1, parentDeclaration: We };
                      }
                      var Fe = e2.find(g.declarations, e2.isClassLike);
                      if (!(!Fe && e2.isPrivateIdentifier(Y))) {
                        var Z2 = Fe || e2.find(g.declarations, function(rr) {
                          return e2.isInterfaceDeclaration(rr) || e2.isTypeLiteralNode(rr);
                        });
                        if (Z2 && !m2(k, Z2.getSourceFile())) {
                          var Be = !e2.isTypeLiteralNode(Z2) && (fe.target || fe) !== P.getDeclaredTypeOfSymbol(g);
                          if (Be && (e2.isPrivateIdentifier(Y) || e2.isInterfaceDeclaration(Z2)))
                            return;
                          var ge = Z2.getSourceFile(), Re = e2.isTypeLiteralNode(Z2) ? 0 : (Be ? 32 : 0) | (e2.startsWithUnderscore(Y.text) ? 8 : 0), ze = e2.isSourceFileJS(ge), Ee = e2.tryCast(U.parent, e2.isCallExpression);
                          return { kind: 0, token: Y, call: Ee, modifierFlags: Re, parentDeclaration: Z2, declSourceFile: ge, isJSFile: ze };
                        }
                        var He = e2.find(g.declarations, e2.isEnumDeclaration);
                        if (He && !e2.isPrivateIdentifier(Y) && !m2(k, He.getSourceFile()))
                          return { kind: 1, token: Y, parentDeclaration: He };
                      }
                    }
                  }
                }
              }
              function m2(y, V) {
                return y.isSourceFileFromExternalLibrary(V) || y.isSourceFileDefaultLibrary(V);
              }
              function G(y, V) {
                return V.isJSFile ? e2.singleElementArray(oe(y, V)) : K(y, V);
              }
              function oe(y, V) {
                var L = V.parentDeclaration, P = V.declSourceFile, k = V.modifierFlags, Y = V.token;
                if (!(e2.isInterfaceDeclaration(L) || e2.isTypeLiteralNode(L))) {
                  var U = e2.textChanges.ChangeTracker.with(y, function(H) {
                    return f4(H, P, L, Y, !!(k & 32));
                  });
                  if (U.length !== 0) {
                    var j = k & 32 ? e2.Diagnostics.Initialize_static_property_0 : e2.isPrivateIdentifier(Y) ? e2.Diagnostics.Declare_a_private_field_named_0 : e2.Diagnostics.Initialize_property_0_in_the_constructor;
                    return C.createCodeFixAction(w, U, [j, Y.text], w, e2.Diagnostics.Add_all_missing_members);
                  }
                }
              }
              function f4(y, V, L, P, k) {
                var Y = P.text;
                if (k) {
                  if (L.kind === 226)
                    return;
                  var U = L.name.getText(), j = T(e2.factory.createIdentifier(U), Y);
                  y.insertNodeAfter(V, L, j);
                } else if (e2.isPrivateIdentifier(P)) {
                  var H = e2.factory.createPropertyDeclaration(void 0, void 0, Y, void 0, void 0, void 0), I = J(L);
                  I ? y.insertNodeAfter(V, I, H) : y.insertMemberAtStart(V, L, H);
                } else {
                  var l = e2.getFirstConstructorWithBody(L);
                  if (!l)
                    return;
                  var d = T(e2.factory.createThis(), Y);
                  y.insertNodeAtConstructorEnd(V, l, d);
                }
              }
              function T(y, V) {
                return e2.factory.createExpressionStatement(e2.factory.createAssignment(e2.factory.createPropertyAccessExpression(y, V), x2()));
              }
              function K(y, V) {
                var L = V.parentDeclaration, P = V.declSourceFile, k = V.modifierFlags, Y = V.token, U = Y.text, j = k & 32, H = b(y.program.getTypeChecker(), L, Y), I = function(d) {
                  return e2.textChanges.ChangeTracker.with(y, function(D) {
                    return se(D, P, L, U, H, d);
                  });
                }, l = [C.createCodeFixAction(w, I(k & 32), [j ? e2.Diagnostics.Declare_static_property_0 : e2.Diagnostics.Declare_property_0, U], w, e2.Diagnostics.Add_all_missing_members)];
                return j || e2.isPrivateIdentifier(Y) || (k & 8 && l.unshift(C.createCodeFixActionWithoutFixAll(w, I(8), [e2.Diagnostics.Declare_private_property_0, U])), l.push(ie(y, P, L, Y.text, H))), l;
              }
              function b(y, V, L) {
                var P;
                if (L.parent.parent.kind === 221) {
                  var k = L.parent.parent, Y = L.parent === k.left ? k.right : k.left, U = y.getWidenedType(y.getBaseTypeOfLiteralType(y.getTypeAtLocation(Y)));
                  P = y.typeToTypeNode(U, V, 1);
                } else {
                  var j = y.getContextualType(L.parent);
                  P = j ? y.typeToTypeNode(j, void 0, 1) : void 0;
                }
                return P || e2.factory.createKeywordTypeNode(130);
              }
              function se(y, V, L, P, k, Y) {
                var U = Y ? e2.factory.createNodeArray(e2.factory.createModifiersFromModifierFlags(Y)) : void 0, j = e2.isClassLike(L) ? e2.factory.createPropertyDeclaration(void 0, U, P, void 0, k, void 0) : e2.factory.createPropertySignature(void 0, P, void 0, k), H = J(L);
                H ? y.insertNodeAfter(V, H, j) : y.insertMemberAtStart(V, L, j);
              }
              function J(y) {
                for (var V, L = 0, P = y.members; L < P.length; L++) {
                  var k = P[L];
                  if (!e2.isPropertyDeclaration(k))
                    break;
                  V = k;
                }
                return V;
              }
              function ie(y, V, L, P, k) {
                var Y = e2.factory.createKeywordTypeNode(150), U = e2.factory.createParameterDeclaration(void 0, void 0, void 0, "x", void 0, Y, void 0), j = e2.factory.createIndexSignature(void 0, void 0, [U], k), H = e2.textChanges.ChangeTracker.with(y, function(I) {
                  return I.insertMemberAtStart(V, L, j);
                });
                return C.createCodeFixActionWithoutFixAll(w, H, [e2.Diagnostics.Add_index_signature_for_property_0, P]);
              }
              function R(y, V) {
                var L = V.parentDeclaration, P = V.declSourceFile, k = V.modifierFlags, Y = V.token, U = V.call;
                if (U !== void 0 && !e2.isPrivateIdentifier(Y)) {
                  var j = Y.text, H = function(l) {
                    return e2.textChanges.ChangeTracker.with(y, function(d) {
                      return q(y, d, U, Y, l, L, P);
                    });
                  }, I = [C.createCodeFixAction(w, H(k & 32), [k & 32 ? e2.Diagnostics.Declare_static_method_0 : e2.Diagnostics.Declare_method_0, j], w, e2.Diagnostics.Add_all_missing_members)];
                  return k & 8 && I.unshift(C.createCodeFixActionWithoutFixAll(w, H(8), [e2.Diagnostics.Declare_private_method_0, j])), I;
                }
              }
              function q(y, V, L, P, k, Y, U) {
                var j = C.createImportAdder(U, y.program, y.preferences, y.host), H = e2.isClassLike(Y) ? 169 : 168, I = C.createSignatureDeclarationFromCallExpression(H, y, j, L, P, k, Y), l = A2(Y, L);
                l ? V.insertNodeAfter(U, l, I) : V.insertMemberAtStart(U, Y, I), j.writeFixes(V);
              }
              function O(y, V, L) {
                var P = L.token, k = L.parentDeclaration, Y = e2.some(k.members, function(j) {
                  var H = V.getTypeAtLocation(j);
                  return !!(H && H.flags & 402653316);
                }), U = e2.factory.createEnumMember(P, Y ? e2.factory.createStringLiteral(P.text) : void 0);
                y.replaceNode(k.getSourceFile(), k, e2.factory.updateEnumDeclaration(k, k.decorators, k.modifiers, k.name, e2.concatenate(k.members, e2.singleElementArray(U))), { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Exclude });
              }
              function ve(y, V, L) {
                var P = C.createImportAdder(V.sourceFile, V.program, V.preferences, V.host), k = C.createSignatureDeclarationFromCallExpression(256, V, P, L.call, e2.idText(L.token), L.modifierFlags, L.parentDeclaration);
                y.insertNodeAtEndOfScope(L.sourceFile, L.parentDeclaration, k);
              }
              function ee(y, V, L) {
                var P = C.createImportAdder(V.sourceFile, V.program, V.preferences, V.host), k = e2.getQuotePreference(V.sourceFile, V.preferences), Y = V.program.getTypeChecker(), U = L.parentDeclaration.attributes, j = e2.some(U.properties, e2.isJsxSpreadAttribute), H = e2.map(L.attributes, function(d) {
                  var D = F2(V, Y, P, k, Y.getTypeOfSymbol(d)), fe = e2.factory.createIdentifier(d.name), g = e2.factory.createJsxAttribute(fe, e2.factory.createJsxExpression(void 0, D));
                  return e2.setParent(fe, g), g;
                }), I = e2.factory.createJsxAttributes(j ? Ve(Ve([], H, true), U.properties, true) : Ve(Ve([], U.properties, true), H, true)), l = { prefix: U.pos === U.end ? " " : void 0 };
                y.replaceNode(V.sourceFile, U, I, l);
              }
              function he(y, V, L) {
                var P = C.createImportAdder(V.sourceFile, V.program, V.preferences, V.host), k = e2.getQuotePreference(V.sourceFile, V.preferences), Y = e2.getEmitScriptTarget(V.program.getCompilerOptions()), U = V.program.getTypeChecker(), j = e2.map(L.properties, function(I) {
                  var l = F2(V, U, P, k, U.getTypeOfSymbol(I));
                  return e2.factory.createPropertyAssignment(e2.createPropertyNameNodeForIdentifierOrLiteral(I.name, Y, k === 0), l);
                }), H = { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Exclude, indentation: L.indentation };
                y.replaceNode(V.sourceFile, L.parentDeclaration, e2.factory.createObjectLiteralExpression(Ve(Ve([], L.parentDeclaration.properties, true), j, true), true), H);
              }
              function F2(y, V, L, P, k) {
                if (k.flags & 3)
                  return x2();
                if (k.flags & 134217732)
                  return e2.factory.createStringLiteral("", P === 0);
                if (k.flags & 8)
                  return e2.factory.createNumericLiteral(0);
                if (k.flags & 64)
                  return e2.factory.createBigIntLiteral("0n");
                if (k.flags & 16)
                  return e2.factory.createFalse();
                if (k.flags & 1056) {
                  var Y = k.symbol.exports ? e2.firstOrUndefined(e2.arrayFrom(k.symbol.exports.values())) : k.symbol, U = V.symbolToExpression(k.symbol.parent ? k.symbol.parent : k.symbol, 111551, void 0, void 0);
                  return Y === void 0 || U === void 0 ? e2.factory.createNumericLiteral(0) : e2.factory.createPropertyAccessExpression(U, V.symbolToString(Y));
                }
                if (k.flags & 256)
                  return e2.factory.createNumericLiteral(k.value);
                if (k.flags & 2048)
                  return e2.factory.createBigIntLiteral(k.value);
                if (k.flags & 128)
                  return e2.factory.createStringLiteral(k.value, P === 0);
                if (k.flags & 512)
                  return k === V.getFalseType() || k === V.getFalseType(true) ? e2.factory.createFalse() : e2.factory.createTrue();
                if (k.flags & 65536)
                  return e2.factory.createNull();
                if (k.flags & 1048576) {
                  var j = e2.firstDefined(k.types, function(g) {
                    return F2(y, V, L, P, g);
                  });
                  return j != null ? j : x2();
                }
                if (V.isArrayLikeType(k))
                  return e2.factory.createArrayLiteralExpression();
                if (X(k)) {
                  var H = e2.map(V.getPropertiesOfType(k), function(g) {
                    var ne = g.valueDeclaration ? F2(y, V, L, P, V.getTypeAtLocation(g.valueDeclaration)) : x2();
                    return e2.factory.createPropertyAssignment(g.name, ne);
                  });
                  return e2.factory.createObjectLiteralExpression(H, true);
                }
                if (e2.getObjectFlags(k) & 16) {
                  var I = e2.find(k.symbol.declarations || e2.emptyArray, e2.or(e2.isFunctionTypeNode, e2.isMethodSignature, e2.isMethodDeclaration));
                  if (I === void 0)
                    return x2();
                  var l = V.getSignaturesOfType(k, 0);
                  if (l === void 0)
                    return x2();
                  var d = C.createSignatureDeclarationFromSignature(213, y, P, l[0], C.createStubbedBody(e2.Diagnostics.Function_not_implemented.message, P), void 0, void 0, void 0, void 0, L);
                  return d != null ? d : x2();
                }
                if (e2.getObjectFlags(k) & 1) {
                  var D = e2.getClassLikeDeclarationOfSymbol(k.symbol);
                  if (D === void 0 || e2.hasAbstractModifier(D))
                    return x2();
                  var fe = e2.getFirstConstructorWithBody(D);
                  return fe && e2.length(fe.parameters) ? x2() : e2.factory.createNewExpression(e2.factory.createIdentifier(k.symbol.name), void 0, void 0);
                }
                return x2();
              }
              function x2() {
                return e2.factory.createIdentifier("undefined");
              }
              function X(y) {
                return y.flags & 524288 && (e2.getObjectFlags(y) & 128 || y.symbol && e2.tryCast(e2.singleOrUndefined(y.symbol.declarations), e2.isTypeLiteralNode));
              }
              function $(y, V, L) {
                var P = y.getContextualType(L.attributes);
                if (P === void 0)
                  return e2.emptyArray;
                var k = P.getProperties();
                if (!e2.length(k))
                  return e2.emptyArray;
                for (var Y = new e2.Set(), U = 0, j = L.attributes.properties; U < j.length; U++) {
                  var H = j[U];
                  if (e2.isJsxAttribute(H) && Y.add(H.name.escapedText), e2.isJsxSpreadAttribute(H))
                    for (var I = y.getTypeAtLocation(H.expression), l = 0, d = I.getProperties(); l < d.length; l++) {
                      var D = d[l];
                      Y.add(D.escapedName);
                    }
                }
                return e2.filter(k, function(fe) {
                  return e2.isIdentifierText(fe.name, V, 1) && !(fe.flags & 16777216 || e2.getCheckFlags(fe) & 48 || Y.has(fe.escapedName));
                });
              }
              function A2(y, V) {
                if (!e2.isTypeLiteralNode(y)) {
                  var L = e2.findAncestor(V, function(P) {
                    return e2.isMethodDeclaration(P) || e2.isConstructorDeclaration(P);
                  });
                  return L && L.parent === y ? L : void 0;
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addMissingNewOperator", B = [e2.Diagnostics.Value_of_type_0_is_not_callable_Did_you_mean_to_include_new.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m2 = e2.textChanges.ChangeTracker.with(le, function(G) {
                  return E(G, N, p);
                });
                return [C.createCodeFixAction(w, m2, e2.Diagnostics.Add_missing_new_operator_to_call, w, e2.Diagnostics.Add_missing_new_operator_to_all_calls)];
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return E(N, le.sourceFile, p);
                });
              } });
              function E(le, N, p) {
                var m2 = e2.cast(Q(N, p), e2.isCallExpression), G = e2.factory.createNewExpression(m2.expression, m2.typeArguments, m2.arguments);
                le.replaceNode(N, m2, G);
              }
              function Q(le, N) {
                for (var p = e2.getTokenAtPosition(le, N.start), m2 = e2.textSpanEnd(N); p.end < m2; )
                  p = p.parent;
                return p;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixCannotFindModule", B = "installTypesPackage", E = e2.Diagnostics.Cannot_find_module_0_or_its_corresponding_type_declarations.code, Q = [E, e2.Diagnostics.Could_not_find_a_declaration_file_for_module_0_1_implicitly_has_an_any_type.code];
              C.registerCodeFix({ errorCodes: Q, getCodeActions: function(G) {
                var oe = G.host, f4 = G.sourceFile, T = G.span.start, K = N(f4, T);
                if (K !== void 0) {
                  var b = p(K, oe, G.errorCode);
                  return b === void 0 ? [] : [C.createCodeFixAction(w, [], [e2.Diagnostics.Install_0, b], B, e2.Diagnostics.Install_all_missing_types_packages, le(f4.fileName, b))];
                }
              }, fixIds: [B], getAllCodeActions: function(m2) {
                return C.codeFixAll(m2, Q, function(G, oe, f4) {
                  var T = N(oe.file, oe.start);
                  if (T !== void 0)
                    switch (m2.fixId) {
                      case B: {
                        var K = p(T, m2.host, oe.code);
                        K && f4.push(le(oe.file.fileName, K));
                        break;
                      }
                      default:
                        e2.Debug.fail("Bad fixId: ".concat(m2.fixId));
                    }
                });
              } });
              function le(m2, G) {
                return { type: "install package", file: m2, packageName: G };
              }
              function N(m2, G) {
                var oe = e2.tryCast(e2.getTokenAtPosition(m2, G), e2.isStringLiteral);
                if (!!oe) {
                  var f4 = oe.text, T = e2.parsePackageName(f4).packageName;
                  return e2.isExternalModuleNameRelative(T) ? void 0 : T;
                }
              }
              function p(m2, G, oe) {
                var f4;
                return oe === E ? e2.JsTyping.nodeCoreModules.has(m2) ? "@types/node" : void 0 : !((f4 = G.isKnownTypesPackageName) === null || f4 === void 0) && f4.call(G, m2) ? e2.getTypesPackageName(m2) : void 0;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = [e2.Diagnostics.Non_abstract_class_0_does_not_implement_inherited_abstract_member_1_from_class_2.code, e2.Diagnostics.Non_abstract_class_expression_does_not_implement_inherited_abstract_member_0_from_class_1.code], B = "fixClassDoesntImplementInheritedAbstractMember";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(p) {
                var m2 = p.sourceFile, G = p.span, oe = e2.textChanges.ChangeTracker.with(p, function(f4) {
                  return Q(E(m2, G.start), m2, p, f4, p.preferences);
                });
                return oe.length === 0 ? void 0 : [C.createCodeFixAction(B, oe, e2.Diagnostics.Implement_inherited_abstract_class, B, e2.Diagnostics.Implement_all_inherited_abstract_classes)];
              }, fixIds: [B], getAllCodeActions: function(p) {
                var m2 = new e2.Map();
                return C.codeFixAll(p, w, function(G, oe) {
                  var f4 = E(oe.file, oe.start);
                  e2.addToSeen(m2, e2.getNodeId(f4)) && Q(f4, p.sourceFile, p, G, p.preferences);
                });
              } });
              function E(N, p) {
                var m2 = e2.getTokenAtPosition(N, p);
                return e2.cast(m2.parent, e2.isClassLike);
              }
              function Q(N, p, m2, G, oe) {
                var f4 = e2.getEffectiveBaseTypeNode(N), T = m2.program.getTypeChecker(), K = T.getTypeAtLocation(f4), b = T.getPropertiesOfType(K).filter(le), se = C.createImportAdder(p, m2.program, oe, m2.host);
                C.createMissingMemberNodes(N, b, p, m2, oe, se, function(J) {
                  return G.insertMemberAtStart(p, N, J);
                }), se.writeFixes(G);
              }
              function le(N) {
                var p = e2.getSyntacticModifierFlags(e2.first(N.getDeclarations()));
                return !(p & 8) && !!(p & 128);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "classSuperMustPrecedeThisAccess", B = [e2.Diagnostics.super_must_be_called_before_accessing_this_in_the_constructor_of_a_derived_class.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m2 = N.span, G = Q(p, m2.start);
                if (!!G) {
                  var oe = G.constructor, f4 = G.superCall, T = e2.textChanges.ChangeTracker.with(N, function(K) {
                    return E(K, p, oe, f4);
                  });
                  return [C.createCodeFixAction(w, T, e2.Diagnostics.Make_super_call_the_first_statement_in_the_constructor, w, e2.Diagnostics.Make_all_super_calls_the_first_statement_in_their_constructor)];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                var p = N.sourceFile, m2 = new e2.Map();
                return C.codeFixAll(N, B, function(G, oe) {
                  var f4 = Q(oe.file, oe.start);
                  if (!!f4) {
                    var T = f4.constructor, K = f4.superCall;
                    e2.addToSeen(m2, e2.getNodeId(T.parent)) && E(G, p, T, K);
                  }
                });
              } });
              function E(N, p, m2, G) {
                N.insertNodeAtConstructorStart(p, m2, G), N.delete(p, G);
              }
              function Q(N, p) {
                var m2 = e2.getTokenAtPosition(N, p);
                if (m2.kind === 108) {
                  var G = e2.getContainingFunction(m2), oe = le(G.body);
                  return oe && !oe.expression.arguments.some(function(f4) {
                    return e2.isPropertyAccessExpression(f4) && f4.expression === m2;
                  }) ? { constructor: G, superCall: oe } : void 0;
                }
              }
              function le(N) {
                return e2.isExpressionStatement(N) && e2.isSuperCall(N.expression) ? N : e2.isFunctionLike(N) ? void 0 : e2.forEachChild(N, le);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "constructorForDerivedNeedSuperCall", B = [e2.Diagnostics.Constructors_for_derived_classes_must_contain_a_super_call.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m2 = E(N, p.start), G = e2.textChanges.ChangeTracker.with(le, function(oe) {
                  return Q(oe, N, m2);
                });
                return [C.createCodeFixAction(w, G, e2.Diagnostics.Add_missing_super_call, w, e2.Diagnostics.Add_all_missing_super_calls)];
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return Q(N, le.sourceFile, E(p.file, p.start));
                });
              } });
              function E(le, N) {
                var p = e2.getTokenAtPosition(le, N);
                return e2.Debug.assert(e2.isConstructorDeclaration(p.parent), "token should be at the constructor declaration"), p.parent;
              }
              function Q(le, N, p) {
                var m2 = e2.factory.createExpressionStatement(e2.factory.createCallExpression(e2.factory.createSuper(), void 0, e2.emptyArray));
                le.insertNodeAtConstructorStart(N, p, m2);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "enableExperimentalDecorators", B = [e2.Diagnostics.Experimental_support_for_decorators_is_a_feature_that_is_subject_to_change_in_a_future_release_Set_the_experimentalDecorators_option_in_your_tsconfig_or_jsconfig_to_remove_this_warning.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.program.getCompilerOptions().configFile;
                if (N !== void 0) {
                  var p = e2.textChanges.ChangeTracker.with(le, function(m2) {
                    return E(m2, N);
                  });
                  return [C.createCodeFixActionWithoutFixAll(w, p, e2.Diagnostics.Enable_the_experimentalDecorators_option_in_your_configuration_file)];
                }
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le) {
                  var N = Q.program.getCompilerOptions().configFile;
                  N !== void 0 && E(le, N);
                });
              } });
              function E(Q, le) {
                C.setJsonCompilerOptionValue(Q, le, "experimentalDecorators", e2.factory.createTrue());
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixEnableJsxFlag", B = [e2.Diagnostics.Cannot_use_JSX_unless_the_jsx_flag_is_provided.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.program.getCompilerOptions().configFile;
                if (N !== void 0) {
                  var p = e2.textChanges.ChangeTracker.with(le, function(m2) {
                    return E(m2, N);
                  });
                  return [C.createCodeFixActionWithoutFixAll(w, p, e2.Diagnostics.Enable_the_jsx_flag_in_your_configuration_file)];
                }
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le) {
                  var N = Q.program.getCompilerOptions().configFile;
                  N !== void 0 && E(le, N);
                });
              } });
              function E(Q, le) {
                C.setJsonCompilerOptionValue(Q, le, "jsx", e2.factory.createStringLiteral("react"));
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              C.registerCodeFix({ errorCodes: [e2.Diagnostics.Top_level_await_expressions_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher.code, e2.Diagnostics.Top_level_for_await_loops_are_only_allowed_when_the_module_option_is_set_to_es2022_esnext_system_node16_or_nodenext_and_the_target_option_is_set_to_es2017_or_higher.code], getCodeActions: function(B) {
                var E = B.program.getCompilerOptions(), Q = E.configFile;
                if (Q !== void 0) {
                  var le = [], N = e2.getEmitModuleKind(E), p = N >= e2.ModuleKind.ES2015 && N < e2.ModuleKind.ESNext;
                  if (p) {
                    var m2 = e2.textChanges.ChangeTracker.with(B, function(f4) {
                      C.setJsonCompilerOptionValue(f4, Q, "module", e2.factory.createStringLiteral("esnext"));
                    });
                    le.push(C.createCodeFixActionWithoutFixAll("fixModuleOption", m2, [e2.Diagnostics.Set_the_module_option_in_your_configuration_file_to_0, "esnext"]));
                  }
                  var G = e2.getEmitScriptTarget(E), oe = G < 4 || G > 99;
                  if (oe) {
                    var m2 = e2.textChanges.ChangeTracker.with(B, function(T) {
                      var K = e2.getTsConfigObjectLiteralExpression(Q);
                      if (!!K) {
                        var b = [["target", e2.factory.createStringLiteral("es2017")]];
                        N === e2.ModuleKind.CommonJS && b.push(["module", e2.factory.createStringLiteral("commonjs")]), C.setJsonCompilerOptionValues(T, Q, b);
                      }
                    });
                    le.push(C.createCodeFixActionWithoutFixAll("fixTargetOption", m2, [e2.Diagnostics.Set_the_target_option_in_your_configuration_file_to_0, "es2017"]));
                  }
                  return le.length ? le : void 0;
                }
              } });
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixPropertyAssignment", B = [e2.Diagnostics.Did_you_mean_to_use_a_Colon_An_can_only_follow_a_property_name_when_the_containing_object_literal_is_part_of_a_destructuring_pattern.code];
              C.registerCodeFix({ errorCodes: B, fixIds: [w], getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m2 = Q(N, p.start), G = e2.textChanges.ChangeTracker.with(le, function(oe) {
                  return E(oe, le.sourceFile, m2);
                });
                return [C.createCodeFixAction(w, G, [e2.Diagnostics.Change_0_to_1, "=", ":"], w, [e2.Diagnostics.Switch_each_misused_0_to_1, "=", ":"])];
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return E(N, p.file, Q(p.file, p.start));
                });
              } });
              function E(le, N, p) {
                le.replaceNode(N, p, e2.factory.createPropertyAssignment(p.name, p.objectAssignmentInitializer));
              }
              function Q(le, N) {
                return e2.cast(e2.getTokenAtPosition(le, N).parent, e2.isShorthandPropertyAssignment);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "extendsInterfaceBecomesImplements", B = [e2.Diagnostics.Cannot_extend_an_interface_0_Did_you_mean_implements.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = E(N, le.span.start);
                if (!!p) {
                  var m2 = p.extendsToken, G = p.heritageClauses, oe = e2.textChanges.ChangeTracker.with(le, function(f4) {
                    return Q(f4, N, m2, G);
                  });
                  return [C.createCodeFixAction(w, oe, e2.Diagnostics.Change_extends_to_implements, w, e2.Diagnostics.Change_all_extended_interfaces_to_implements)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m2 = E(p.file, p.start);
                  m2 && Q(N, p.file, m2.extendsToken, m2.heritageClauses);
                });
              } });
              function E(le, N) {
                var p = e2.getTokenAtPosition(le, N), m2 = e2.getContainingClass(p).heritageClauses, G = m2[0].getFirstToken();
                return G.kind === 94 ? { extendsToken: G, heritageClauses: m2 } : void 0;
              }
              function Q(le, N, p, m2) {
                if (le.replaceNode(N, p, e2.factory.createToken(117)), m2.length === 2 && m2[0].token === 94 && m2[1].token === 117) {
                  var G = m2[1].getFirstToken(), oe = G.getFullStart();
                  le.replaceRange(N, { pos: oe, end: oe }, e2.factory.createToken(27));
                  for (var f4 = N.text, T = G.end; T < f4.length && e2.isWhiteSpaceSingleLine(f4.charCodeAt(T)); )
                    T++;
                  le.deleteRange(N, { pos: G.getStart(), end: T });
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "forgottenThisPropertyAccess", B = e2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_static_member_1_0.code, E = [e2.Diagnostics.Cannot_find_name_0_Did_you_mean_the_instance_member_this_0.code, e2.Diagnostics.Private_identifiers_are_only_allowed_in_class_bodies_and_may_only_be_used_as_part_of_a_class_member_declaration_property_access_or_on_the_left_hand_side_of_an_in_expression.code, B];
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(N) {
                var p = N.sourceFile, m2 = Q(p, N.span.start, N.errorCode);
                if (!!m2) {
                  var G = e2.textChanges.ChangeTracker.with(N, function(oe) {
                    return le(oe, p, m2);
                  });
                  return [C.createCodeFixAction(w, G, [e2.Diagnostics.Add_0_to_unresolved_variable, m2.className || "this"], w, e2.Diagnostics.Add_qualifier_to_all_unresolved_variables_matching_a_member_name)];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, E, function(p, m2) {
                  var G = Q(m2.file, m2.start, m2.code);
                  G && le(p, N.sourceFile, G);
                });
              } });
              function Q(N, p, m2) {
                var G = e2.getTokenAtPosition(N, p);
                if (e2.isIdentifier(G) || e2.isPrivateIdentifier(G))
                  return { node: G, className: m2 === B ? e2.getContainingClass(G).name.text : void 0 };
              }
              function le(N, p, m2) {
                var G = m2.node, oe = m2.className;
                e2.suppressLeadingAndTrailingTrivia(G), N.replaceNode(p, G, e2.factory.createPropertyAccessExpression(oe ? e2.factory.createIdentifier(oe) : e2.factory.createThis(), G));
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixInvalidJsxCharacters_expression", B = "fixInvalidJsxCharacters_htmlEntity", E = [e2.Diagnostics.Unexpected_token_Did_you_mean_or_gt.code, e2.Diagnostics.Unexpected_token_Did_you_mean_or_rbrace.code];
              C.registerCodeFix({ errorCodes: E, fixIds: [w, B], getCodeActions: function(p) {
                var m2 = p.sourceFile, G = p.preferences, oe = p.span, f4 = e2.textChanges.ChangeTracker.with(p, function(K) {
                  return N(K, G, m2, oe.start, false);
                }), T = e2.textChanges.ChangeTracker.with(p, function(K) {
                  return N(K, G, m2, oe.start, true);
                });
                return [C.createCodeFixAction(w, f4, e2.Diagnostics.Wrap_invalid_character_in_an_expression_container, w, e2.Diagnostics.Wrap_all_invalid_characters_in_an_expression_container), C.createCodeFixAction(B, T, e2.Diagnostics.Convert_invalid_character_to_its_html_entity_code, B, e2.Diagnostics.Convert_all_invalid_characters_to_HTML_entity_code)];
              }, getAllCodeActions: function(p) {
                return C.codeFixAll(p, E, function(m2, G) {
                  return N(m2, p.preferences, G.file, G.start, p.fixId === B);
                });
              } });
              var Q = { ">": "&gt;", "}": "&rbrace;" };
              function le(p) {
                return e2.hasProperty(Q, p);
              }
              function N(p, m2, G, oe, f4) {
                var T = G.getText()[oe];
                if (!!le(T)) {
                  var K = f4 ? Q[T] : "{".concat(e2.quote(G, m2, T), "}");
                  p.replaceRangeWithText(G, { pos: oe, end: oe + 1 }, K);
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "deleteUnmatchedParameter", B = "renameUnmatchedParameter", E = [e2.Diagnostics.JSDoc_param_tag_has_name_0_but_there_is_no_parameter_with_that_name.code];
              C.registerCodeFix({ fixIds: [w, B], errorCodes: E, getCodeActions: function(m2) {
                var G = m2.sourceFile, oe = m2.span, f4 = [], T = N(G, oe.start);
                if (T)
                  return e2.append(f4, Q(m2, T)), e2.append(f4, le(m2, T)), f4;
              }, getAllCodeActions: function(m2) {
                var G = new e2.Map();
                return C.createCombinedCodeActions(e2.textChanges.ChangeTracker.with(m2, function(oe) {
                  C.eachDiagnostic(m2, E, function(f4) {
                    var T = f4.file, K = f4.start, b = N(T, K);
                    b && G.set(b.signature, e2.append(G.get(b.signature), b.jsDocParameterTag));
                  }), G.forEach(function(f4, T) {
                    if (m2.fixId === w) {
                      var K = new e2.Set(f4);
                      oe.filterJSDocTags(T.getSourceFile(), T, function(b) {
                        return !K.has(b);
                      });
                    }
                  });
                }));
              } });
              function Q(p, m2) {
                var G = m2.name, oe = m2.signature, f4 = m2.jsDocParameterTag, T = e2.textChanges.ChangeTracker.with(p, function(K) {
                  return K.filterJSDocTags(p.sourceFile, oe, function(b) {
                    return b !== f4;
                  });
                });
                return C.createCodeFixAction(w, T, [e2.Diagnostics.Delete_unused_param_tag_0, G.getText(p.sourceFile)], w, e2.Diagnostics.Delete_all_unused_param_tags);
              }
              function le(p, m2) {
                var G = m2.name, oe = m2.signature, f4 = m2.jsDocParameterTag;
                if (!!e2.length(oe.parameters)) {
                  for (var T = p.sourceFile, K = e2.getJSDocTags(oe), b = new e2.Set(), se = 0, J = K; se < J.length; se++) {
                    var ie = J[se];
                    e2.isJSDocParameterTag(ie) && e2.isIdentifier(ie.name) && b.add(ie.name.escapedText);
                  }
                  var R = e2.firstDefined(oe.parameters, function(ve) {
                    return e2.isIdentifier(ve.name) && !b.has(ve.name.escapedText) ? ve.name.getText(T) : void 0;
                  });
                  if (R !== void 0) {
                    var q = e2.factory.updateJSDocParameterTag(f4, f4.tagName, e2.factory.createIdentifier(R), f4.isBracketed, f4.typeExpression, f4.isNameFirst, f4.comment), O = e2.textChanges.ChangeTracker.with(p, function(ve) {
                      return ve.replaceJSDocComment(T, oe, e2.map(K, function(ee) {
                        return ee === f4 ? q : ee;
                      }));
                    });
                    return C.createCodeFixActionWithoutFixAll(B, O, [e2.Diagnostics.Rename_param_tag_name_0_to_1, G.getText(T), R]);
                  }
                }
              }
              function N(p, m2) {
                var G = e2.getTokenAtPosition(p, m2);
                if (G.parent && e2.isJSDocParameterTag(G.parent) && e2.isIdentifier(G.parent.name)) {
                  var oe = G.parent, f4 = e2.getHostSignatureFromJSDoc(oe);
                  if (f4)
                    return { signature: f4, name: G.parent.name, jsDocParameterTag: oe };
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixUnreferenceableDecoratorMetadata", B = [e2.Diagnostics.A_type_referenced_in_a_decorated_signature_must_be_imported_with_import_type_or_a_namespace_import_when_isolatedModules_and_emitDecoratorMetadata_are_enabled.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = E(N.sourceFile, N.program, N.span.start);
                if (!!p) {
                  var m2 = e2.textChanges.ChangeTracker.with(N, function(f4) {
                    return p.kind === 270 && le(f4, N.sourceFile, p, N.program);
                  }), G = e2.textChanges.ChangeTracker.with(N, function(f4) {
                    return Q(f4, N.sourceFile, p, N.program);
                  }), oe;
                  return m2.length && (oe = e2.append(oe, C.createCodeFixActionWithoutFixAll(w, m2, e2.Diagnostics.Convert_named_imports_to_namespace_import))), G.length && (oe = e2.append(oe, C.createCodeFixActionWithoutFixAll(w, G, e2.Diagnostics.Convert_to_type_only_import))), oe;
                }
              }, fixIds: [w] });
              function E(N, p, m2) {
                var G = e2.tryCast(e2.getTokenAtPosition(N, m2), e2.isIdentifier);
                if (!(!G || G.parent.kind !== 178)) {
                  var oe = p.getTypeChecker(), f4 = oe.getSymbolAtLocation(G);
                  return e2.find((f4 == null ? void 0 : f4.declarations) || e2.emptyArray, e2.or(e2.isImportClause, e2.isImportSpecifier, e2.isImportEqualsDeclaration));
                }
              }
              function Q(N, p, m2, G) {
                if (m2.kind === 265) {
                  N.insertModifierBefore(p, 152, m2.name);
                  return;
                }
                var oe = m2.kind === 267 ? m2 : m2.parent.parent;
                if (!(oe.name && oe.namedBindings)) {
                  var f4 = G.getTypeChecker(), T = !!e2.forEachImportClauseDeclaration(oe, function(K) {
                    if (e2.skipAlias(K.symbol, f4).flags & 111551)
                      return true;
                  });
                  T || N.insertModifierBefore(p, 152, oe);
                }
              }
              function le(N, p, m2, G) {
                e2.refactor.doChangeNamedToNamespaceOrDefault(p, G, N, m2.parent);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "unusedIdentifier", B = "unusedIdentifier_prefix", E = "unusedIdentifier_delete", Q = "unusedIdentifier_deleteImports", le = "unusedIdentifier_infer", N = [e2.Diagnostics._0_is_declared_but_its_value_is_never_read.code, e2.Diagnostics._0_is_declared_but_never_used.code, e2.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code, e2.Diagnostics.All_imports_in_import_declaration_are_unused.code, e2.Diagnostics.All_destructured_elements_are_unused.code, e2.Diagnostics.All_variables_are_unused.code, e2.Diagnostics.All_type_parameters_are_unused.code];
              C.registerCodeFix({ errorCodes: N, getCodeActions: function(x2) {
                var X = x2.errorCode, $ = x2.sourceFile, A2 = x2.program, y = x2.cancellationToken, V = A2.getTypeChecker(), L = A2.getSourceFiles(), P = e2.getTokenAtPosition($, x2.span.start);
                if (e2.isJSDocTemplateTag(P))
                  return [m2(e2.textChanges.ChangeTracker.with(x2, function(D) {
                    return D.delete($, P);
                  }), e2.Diagnostics.Remove_template_tag)];
                if (P.kind === 29) {
                  var k = e2.textChanges.ChangeTracker.with(x2, function(D) {
                    return G(D, $, P);
                  });
                  return [m2(k, e2.Diagnostics.Remove_type_parameters)];
                }
                var Y = f4(P);
                if (Y) {
                  var k = e2.textChanges.ChangeTracker.with(x2, function(fe) {
                    return fe.delete($, Y);
                  });
                  return [C.createCodeFixAction(w, k, [e2.Diagnostics.Remove_import_from_0, e2.showModuleSpecifier(Y)], Q, e2.Diagnostics.Delete_all_unused_imports)];
                } else if (oe(P)) {
                  var U = e2.textChanges.ChangeTracker.with(x2, function(D) {
                    return ie($, P, D, V, L, A2, y, false);
                  });
                  if (U.length)
                    return [C.createCodeFixAction(w, U, [e2.Diagnostics.Remove_unused_declaration_for_Colon_0, P.getText($)], Q, e2.Diagnostics.Delete_all_unused_imports)];
                }
                if (e2.isObjectBindingPattern(P.parent) || e2.isArrayBindingPattern(P.parent)) {
                  if (e2.isParameter(P.parent.parent)) {
                    var j = P.parent.elements, H = [j.length > 1 ? e2.Diagnostics.Remove_unused_declarations_for_Colon_0 : e2.Diagnostics.Remove_unused_declaration_for_Colon_0, e2.map(j, function(D) {
                      return D.getText($);
                    }).join(", ")];
                    return [m2(e2.textChanges.ChangeTracker.with(x2, function(D) {
                      return b(D, $, P.parent);
                    }), H)];
                  }
                  return [m2(e2.textChanges.ChangeTracker.with(x2, function(D) {
                    return D.delete($, P.parent.parent);
                  }), e2.Diagnostics.Remove_unused_destructuring_declaration)];
                }
                if (T($, P))
                  return [m2(e2.textChanges.ChangeTracker.with(x2, function(D) {
                    return K(D, $, P.parent);
                  }), e2.Diagnostics.Remove_variable_statement)];
                var I = [];
                if (P.kind === 137) {
                  var k = e2.textChanges.ChangeTracker.with(x2, function(fe) {
                    return p(fe, $, P);
                  }), l = e2.cast(P.parent, e2.isInferTypeNode).typeParameter.name.text;
                  I.push(C.createCodeFixAction(w, k, [e2.Diagnostics.Replace_infer_0_with_unknown, l], le, e2.Diagnostics.Replace_all_unused_infer_with_unknown));
                } else {
                  var U = e2.textChanges.ChangeTracker.with(x2, function(fe) {
                    return ie($, P, fe, V, L, A2, y, false);
                  });
                  if (U.length) {
                    var l = e2.isComputedPropertyName(P.parent) ? P.parent : P;
                    I.push(m2(U, [e2.Diagnostics.Remove_unused_declaration_for_Colon_0, l.getText($)]));
                  }
                }
                var d = e2.textChanges.ChangeTracker.with(x2, function(D) {
                  return se(D, X, $, P);
                });
                return d.length && I.push(C.createCodeFixAction(w, d, [e2.Diagnostics.Prefix_0_with_an_underscore, P.getText($)], B, e2.Diagnostics.Prefix_all_unused_declarations_with_where_possible)), I;
              }, fixIds: [B, E, Q, le], getAllCodeActions: function(x2) {
                var X = x2.sourceFile, $ = x2.program, A2 = x2.cancellationToken, y = $.getTypeChecker(), V = $.getSourceFiles();
                return C.codeFixAll(x2, N, function(L, P) {
                  var k = e2.getTokenAtPosition(X, P.start);
                  switch (x2.fixId) {
                    case B:
                      se(L, P.code, X, k);
                      break;
                    case Q: {
                      var Y = f4(k);
                      Y ? L.delete(X, Y) : oe(k) && ie(X, k, L, y, V, $, A2, true);
                      break;
                    }
                    case E: {
                      if (k.kind === 137 || oe(k))
                        break;
                      if (e2.isJSDocTemplateTag(k))
                        L.delete(X, k);
                      else if (k.kind === 29)
                        G(L, X, k);
                      else if (e2.isObjectBindingPattern(k.parent)) {
                        if (k.parent.parent.initializer)
                          break;
                        (!e2.isParameter(k.parent.parent) || O(k.parent.parent, y, V)) && L.delete(X, k.parent.parent);
                      } else {
                        if (e2.isArrayBindingPattern(k.parent.parent) && k.parent.parent.parent.initializer)
                          break;
                        T(X, k) ? K(L, X, k.parent) : ie(X, k, L, y, V, $, A2, true);
                      }
                      break;
                    }
                    case le:
                      k.kind === 137 && p(L, X, k);
                      break;
                    default:
                      e2.Debug.fail(JSON.stringify(x2.fixId));
                  }
                });
              } });
              function p(x2, X, $) {
                x2.replaceNode(X, $.parent, e2.factory.createKeywordTypeNode(155));
              }
              function m2(x2, X) {
                return C.createCodeFixAction(w, x2, X, E, e2.Diagnostics.Delete_all_unused_declarations);
              }
              function G(x2, X, $) {
                x2.delete(X, e2.Debug.checkDefined(e2.cast($.parent, e2.isDeclarationWithTypeParameterChildren).typeParameters, "The type parameter to delete should exist"));
              }
              function oe(x2) {
                return x2.kind === 100 || x2.kind === 79 && (x2.parent.kind === 270 || x2.parent.kind === 267);
              }
              function f4(x2) {
                return x2.kind === 100 ? e2.tryCast(x2.parent, e2.isImportDeclaration) : void 0;
              }
              function T(x2, X) {
                return e2.isVariableDeclarationList(X.parent) && e2.first(X.parent.getChildren(x2)) === X;
              }
              function K(x2, X, $) {
                x2.delete(X, $.parent.kind === 237 ? $.parent : $);
              }
              function b(x2, X, $) {
                e2.forEach($.elements, function(A2) {
                  return x2.delete(X, A2);
                });
              }
              function se(x2, X, $, A2) {
                X !== e2.Diagnostics.Property_0_is_declared_but_its_value_is_never_read.code && (A2.kind === 137 && (A2 = e2.cast(A2.parent, e2.isInferTypeNode).typeParameter.name), e2.isIdentifier(A2) && J(A2) && (x2.replaceNode($, A2, e2.factory.createIdentifier("_".concat(A2.text))), e2.isParameter(A2.parent) && e2.getJSDocParameterTags(A2.parent).forEach(function(y) {
                  e2.isIdentifier(y.name) && x2.replaceNode($, y.name, e2.factory.createIdentifier("_".concat(y.name.text)));
                })));
              }
              function J(x2) {
                switch (x2.parent.kind) {
                  case 164:
                  case 163:
                    return true;
                  case 254: {
                    var X = x2.parent;
                    switch (X.parent.parent.kind) {
                      case 244:
                      case 243:
                        return true;
                    }
                  }
                }
                return false;
              }
              function ie(x2, X, $, A2, y, V, L, P) {
                R(X, $, x2, A2, y, V, L, P), e2.isIdentifier(X) && e2.FindAllReferences.Core.eachSymbolReferenceInFile(X, A2, x2, function(k) {
                  e2.isPropertyAccessExpression(k.parent) && k.parent.name === k && (k = k.parent), !P && F2(k) && $.delete(x2, k.parent.parent);
                });
              }
              function R(x2, X, $, A2, y, V, L, P) {
                var k = x2.parent;
                if (e2.isParameter(k))
                  q(X, $, k, A2, y, V, L, P);
                else if (!(P && e2.isIdentifier(x2) && e2.FindAllReferences.Core.isSymbolReferencedInFile(x2, A2, $))) {
                  var Y = e2.isImportClause(k) ? x2 : e2.isComputedPropertyName(k) ? k.parent : k;
                  e2.Debug.assert(Y !== $, "should not delete whole source file"), X.delete($, Y);
                }
              }
              function q(x2, X, $, A2, y, V, L, P) {
                P === void 0 && (P = false), ve(A2, X, $, y, V, L, P) && ($.modifiers && $.modifiers.length > 0 && (!e2.isIdentifier($.name) || e2.FindAllReferences.Core.isSymbolReferencedInFile($.name, A2, X)) ? $.modifiers.forEach(function(k) {
                  return x2.deleteModifier(X, k);
                }) : !$.initializer && O($, A2, y) && x2.delete(X, $));
              }
              function O(x2, X, $) {
                var A2 = x2.parent.parameters.indexOf(x2);
                return !e2.FindAllReferences.Core.someSignatureUsage(x2.parent, $, X, function(y, V) {
                  return !V || V.arguments.length > A2;
                });
              }
              function ve(x2, X, $, A2, y, V, L) {
                var P = $.parent;
                switch (P.kind) {
                  case 169:
                  case 171:
                    var k = P.parameters.indexOf($), Y = e2.isMethodDeclaration(P) ? P.name : P, U = e2.FindAllReferences.Core.getReferencedSymbolsForNode(P.pos, Y, y, A2, V);
                    if (U)
                      for (var j = 0, H = U; j < H.length; j++)
                        for (var I = H[j], l = 0, d = I.references; l < d.length; l++) {
                          var D = d[l];
                          if (D.kind === 1) {
                            var fe = e2.isSuperKeyword(D.node) && e2.isCallExpression(D.node.parent) && D.node.parent.arguments.length > k, g = e2.isPropertyAccessExpression(D.node.parent) && e2.isSuperKeyword(D.node.parent.expression) && e2.isCallExpression(D.node.parent.parent) && D.node.parent.parent.arguments.length > k, ne = (e2.isMethodDeclaration(D.node.parent) || e2.isMethodSignature(D.node.parent)) && D.node.parent !== $.parent && D.node.parent.parameters.length > k;
                            if (fe || g || ne)
                              return false;
                          }
                        }
                    return true;
                  case 256:
                    return P.name && ee(x2, X, P.name) ? he(P, $, L) : true;
                  case 213:
                  case 214:
                    return he(P, $, L);
                  case 173:
                    return false;
                  case 172:
                    return true;
                  default:
                    return e2.Debug.failBadSyntaxKind(P);
                }
              }
              function ee(x2, X, $) {
                return !!e2.FindAllReferences.Core.eachSymbolReferenceInFile($, x2, X, function(A2) {
                  return e2.isIdentifier(A2) && e2.isCallExpression(A2.parent) && A2.parent.arguments.indexOf(A2) >= 0;
                });
              }
              function he(x2, X, $) {
                var A2 = x2.parameters, y = A2.indexOf(X);
                return e2.Debug.assert(y !== -1, "The parameter should already be in the list"), $ ? A2.slice(y + 1).every(function(V) {
                  return e2.isIdentifier(V.name) && !V.symbol.isReferenced;
                }) : y === A2.length - 1;
              }
              function F2(x2) {
                return (e2.isBinaryExpression(x2.parent) && x2.parent.left === x2 || (e2.isPostfixUnaryExpression(x2.parent) || e2.isPrefixUnaryExpression(x2.parent)) && x2.parent.operand === x2) && e2.isExpressionStatement(x2.parent.parent);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixUnreachableCode", B = [e2.Diagnostics.Unreachable_code_detected.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.program.getSyntacticDiagnostics(le.sourceFile, le.cancellationToken);
                if (!N.length) {
                  var p = e2.textChanges.ChangeTracker.with(le, function(m2) {
                    return E(m2, le.sourceFile, le.span.start, le.span.length, le.errorCode);
                  });
                  return [C.createCodeFixAction(w, p, e2.Diagnostics.Remove_unreachable_code, w, e2.Diagnostics.Remove_all_unreachable_code)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  return E(N, p.file, p.start, p.length, p.code);
                });
              } });
              function E(le, N, p, m2, G) {
                var oe = e2.getTokenAtPosition(N, p), f4 = e2.findAncestor(oe, e2.isStatement);
                if (f4.getStart(N) !== oe.getStart(N)) {
                  var T = JSON.stringify({ statementKind: e2.Debug.formatSyntaxKind(f4.kind), tokenKind: e2.Debug.formatSyntaxKind(oe.kind), errorCode: G, start: p, length: m2 });
                  e2.Debug.fail("Token and statement should start at the same point. " + T);
                }
                var K = (e2.isBlock(f4.parent) ? f4.parent : f4).parent;
                if (!e2.isBlock(f4.parent) || f4 === e2.first(f4.parent.statements))
                  switch (K.kind) {
                    case 239:
                      if (K.elseStatement) {
                        if (e2.isBlock(f4.parent))
                          break;
                        le.replaceNode(N, f4, e2.factory.createBlock(e2.emptyArray));
                        return;
                      }
                    case 241:
                    case 242:
                      le.delete(N, K);
                      return;
                  }
                if (e2.isBlock(f4.parent)) {
                  var b = p + m2, se = e2.Debug.checkDefined(Q(e2.sliceAfter(f4.parent.statements, f4), function(J) {
                    return J.pos < b;
                  }), "Some statement should be last");
                  le.deleteNodeRange(N, f4, se);
                } else
                  le.delete(N, f4);
              }
              function Q(le, N) {
                for (var p, m2 = 0, G = le; m2 < G.length; m2++) {
                  var oe = G[m2];
                  if (!N(oe))
                    break;
                  p = oe;
                }
                return p;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixUnusedLabel", B = [e2.Diagnostics.Unused_label.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(Q) {
                var le = e2.textChanges.ChangeTracker.with(Q, function(N) {
                  return E(N, Q.sourceFile, Q.span.start);
                });
                return [C.createCodeFixAction(w, le, e2.Diagnostics.Remove_unused_label, w, e2.Diagnostics.Remove_all_unused_labels)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N.start);
                });
              } });
              function E(Q, le, N) {
                var p = e2.getTokenAtPosition(le, N), m2 = e2.cast(p.parent, e2.isLabeledStatement), G = p.getStart(le), oe = m2.statement.getStart(le), f4 = e2.positionsAreOnSameLine(G, oe, le) ? oe : e2.skipTrivia(le.text, e2.findChildOfKind(m2, 58, le).end, true);
                Q.deleteRange(le, { pos: G, end: f4 });
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixJSDocTypes_plain", B = "fixJSDocTypes_nullable", E = [e2.Diagnostics.JSDoc_types_can_only_be_used_inside_documentation_comments.code];
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(p) {
                var m2 = p.sourceFile, G = p.program.getTypeChecker(), oe = le(m2, p.span.start, G);
                if (!oe)
                  return;
                var f4 = oe.typeNode, T = oe.type, K = f4.getText(m2), b = [se(T, w, e2.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript)];
                return f4.kind === 314 && b.push(se(G.getNullableType(T, 32768), B, e2.Diagnostics.Change_all_jsdoc_style_types_to_TypeScript_and_add_undefined_to_nullable_types)), b;
                function se(J, ie, R) {
                  var q = e2.textChanges.ChangeTracker.with(p, function(O) {
                    return Q(O, m2, f4, J, G);
                  });
                  return C.createCodeFixAction("jdocTypes", q, [e2.Diagnostics.Change_0_to_1, K, G.typeToString(J)], ie, R);
                }
              }, fixIds: [w, B], getAllCodeActions: function(p) {
                var m2 = p.fixId, G = p.program, oe = p.sourceFile, f4 = G.getTypeChecker();
                return C.codeFixAll(p, E, function(T, K) {
                  var b = le(K.file, K.start, f4);
                  if (!!b) {
                    var se = b.typeNode, J = b.type, ie = se.kind === 314 && m2 === B ? f4.getNullableType(J, 32768) : J;
                    Q(T, oe, se, ie, f4);
                  }
                });
              } });
              function Q(p, m2, G, oe, f4) {
                p.replaceNode(m2, G, f4.typeToTypeNode(oe, G, void 0));
              }
              function le(p, m2, G) {
                var oe = e2.findAncestor(e2.getTokenAtPosition(p, m2), N), f4 = oe && oe.type;
                return f4 && { typeNode: f4, type: G.getTypeFromTypeNode(f4) };
              }
              function N(p) {
                switch (p.kind) {
                  case 229:
                  case 174:
                  case 175:
                  case 256:
                  case 172:
                  case 176:
                  case 195:
                  case 169:
                  case 168:
                  case 164:
                  case 167:
                  case 166:
                  case 173:
                  case 259:
                  case 211:
                  case 254:
                    return true;
                  default:
                    return false;
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixMissingCallParentheses", B = [e2.Diagnostics.This_condition_will_always_return_true_since_this_function_is_always_defined_Did_you_mean_to_call_it_instead.code];
              C.registerCodeFix({ errorCodes: B, fixIds: [w], getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span, m2 = Q(N, p.start);
                if (!!m2) {
                  var G = e2.textChanges.ChangeTracker.with(le, function(oe) {
                    return E(oe, le.sourceFile, m2);
                  });
                  return [C.createCodeFixAction(w, G, e2.Diagnostics.Add_missing_call_parentheses, w, e2.Diagnostics.Add_all_missing_call_parentheses)];
                }
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m2 = Q(p.file, p.start);
                  m2 && E(N, p.file, m2);
                });
              } });
              function E(le, N, p) {
                le.replaceNodeWithText(N, p, "".concat(p.text, "()"));
              }
              function Q(le, N) {
                var p = e2.getTokenAtPosition(le, N);
                if (e2.isPropertyAccessExpression(p.parent)) {
                  for (var m2 = p.parent; e2.isPropertyAccessExpression(m2.parent); )
                    m2 = m2.parent;
                  return m2.name;
                }
                if (e2.isIdentifier(p))
                  return p;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixAwaitInSyncFunction", B = [e2.Diagnostics.await_expressions_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code, e2.Diagnostics.for_await_loops_are_only_allowed_within_async_functions_and_at_the_top_levels_of_modules.code, e2.Diagnostics.Cannot_find_name_0_Did_you_mean_to_write_this_in_an_async_function.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m2 = N.span, G = Q(p, m2.start);
                if (!!G) {
                  var oe = e2.textChanges.ChangeTracker.with(N, function(f4) {
                    return le(f4, p, G);
                  });
                  return [C.createCodeFixAction(w, oe, e2.Diagnostics.Add_async_modifier_to_containing_function, w, e2.Diagnostics.Add_all_missing_async_modifiers)];
                }
              }, fixIds: [w], getAllCodeActions: function(p) {
                var m2 = new e2.Map();
                return C.codeFixAll(p, B, function(G, oe) {
                  var f4 = Q(oe.file, oe.start);
                  !f4 || !e2.addToSeen(m2, e2.getNodeId(f4.insertBefore)) || le(G, p.sourceFile, f4);
                });
              } });
              function E(N) {
                if (N.type)
                  return N.type;
                if (e2.isVariableDeclaration(N.parent) && N.parent.type && e2.isFunctionTypeNode(N.parent.type))
                  return N.parent.type.type;
              }
              function Q(N, p) {
                var m2 = e2.getTokenAtPosition(N, p), G = e2.getContainingFunction(m2);
                if (!!G) {
                  var oe;
                  switch (G.kind) {
                    case 169:
                      oe = G.name;
                      break;
                    case 256:
                    case 213:
                      oe = e2.findChildOfKind(G, 98, N);
                      break;
                    case 214:
                      var f4 = G.typeParameters ? 29 : 20;
                      oe = e2.findChildOfKind(G, f4, N) || e2.first(G.parameters);
                      break;
                    default:
                      return;
                  }
                  return oe && { insertBefore: oe, returnType: E(G) };
                }
              }
              function le(N, p, m2) {
                var G = m2.insertBefore, oe = m2.returnType;
                if (oe) {
                  var f4 = e2.getEntityNameFromTypeNode(oe);
                  (!f4 || f4.kind !== 79 || f4.text !== "Promise") && N.replaceNode(p, oe, e2.factory.createTypeReferenceNode("Promise", e2.factory.createNodeArray([oe])));
                }
                N.insertModifierBefore(p, 131, G);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = [e2.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code, e2.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code], B = "fixPropertyOverrideAccessor";
              C.registerCodeFix({ errorCodes: w, getCodeActions: function(Q) {
                var le = E(Q.sourceFile, Q.span.start, Q.span.length, Q.errorCode, Q);
                if (le)
                  return [C.createCodeFixAction(B, le, e2.Diagnostics.Generate_get_and_set_accessors, B, e2.Diagnostics.Generate_get_and_set_accessors_for_all_overriding_properties)];
              }, fixIds: [B], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, w, function(le, N) {
                  var p = E(N.file, N.start, N.length, N.code, Q);
                  if (p)
                    for (var m2 = 0, G = p; m2 < G.length; m2++) {
                      var oe = G[m2];
                      le.pushRaw(Q.sourceFile, oe);
                    }
                });
              } });
              function E(Q, le, N, p, m2) {
                var G, oe;
                if (p === e2.Diagnostics._0_is_defined_as_an_accessor_in_class_1_but_is_overridden_here_in_2_as_an_instance_property.code)
                  G = le, oe = le + N;
                else if (p === e2.Diagnostics._0_is_defined_as_a_property_in_class_1_but_is_overridden_here_in_2_as_an_accessor.code) {
                  var f4 = m2.program.getTypeChecker(), T = e2.getTokenAtPosition(Q, le).parent;
                  e2.Debug.assert(e2.isAccessor(T), "error span of fixPropertyOverrideAccessor should only be on an accessor");
                  var K = T.parent;
                  e2.Debug.assert(e2.isClassLike(K), "erroneous accessors should only be inside classes");
                  var b = e2.singleOrUndefined(C.getAllSupers(K, f4));
                  if (!b)
                    return [];
                  var se = e2.unescapeLeadingUnderscores(e2.getTextOfPropertyName(T.name)), J = f4.getPropertyOfType(f4.getTypeAtLocation(b), se);
                  if (!J || !J.valueDeclaration)
                    return [];
                  G = J.valueDeclaration.pos, oe = J.valueDeclaration.end, Q = e2.getSourceFileOfNode(J.valueDeclaration);
                } else
                  e2.Debug.fail("fixPropertyOverrideAccessor codefix got unexpected error code " + p);
                return C.generateAccessorFromProperty(Q, m2.program, G, oe, m2, e2.Diagnostics.Generate_get_and_set_accessors.message);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "inferFromUsage", B = [e2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code, e2.Diagnostics.Variable_0_implicitly_has_an_1_type.code, e2.Diagnostics.Parameter_0_implicitly_has_an_1_type.code, e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code, e2.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code, e2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code, e2.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code, e2.Diagnostics.Member_0_implicitly_has_an_1_type.code, e2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code, e2.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code, e2.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code, e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code, e2.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code, e2.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code, e2.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code, e2.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code, e2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(q) {
                var O = q.sourceFile, ve = q.program, ee = q.span.start, he = q.errorCode, F2 = q.cancellationToken, x2 = q.host, X = q.preferences, $ = e2.getTokenAtPosition(O, ee), A2, y = e2.textChanges.ChangeTracker.with(q, function(L) {
                  A2 = le(L, O, $, he, ve, F2, e2.returnTrue, x2, X);
                }), V = A2 && e2.getNameOfDeclaration(A2);
                return !V || y.length === 0 ? void 0 : [C.createCodeFixAction(w, y, [E(he, $), e2.getTextOfNode(V)], w, e2.Diagnostics.Infer_all_types_from_usage)];
              }, fixIds: [w], getAllCodeActions: function(q) {
                var O = q.sourceFile, ve = q.program, ee = q.cancellationToken, he = q.host, F2 = q.preferences, x2 = e2.nodeSeenTracker();
                return C.codeFixAll(q, B, function(X, $) {
                  le(X, O, e2.getTokenAtPosition($.file, $.start), $.code, ve, ee, x2, he, F2);
                });
              } });
              function E(q, O) {
                switch (q) {
                  case e2.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
                  case e2.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e2.isSetAccessorDeclaration(e2.getContainingFunction(O)) ? e2.Diagnostics.Infer_type_of_0_from_usage : e2.Diagnostics.Infer_parameter_types_from_usage;
                  case e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
                  case e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e2.Diagnostics.Infer_parameter_types_from_usage;
                  case e2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
                    return e2.Diagnostics.Infer_this_type_of_0_from_usage;
                  default:
                    return e2.Diagnostics.Infer_type_of_0_from_usage;
                }
              }
              function Q(q) {
                switch (q) {
                  case e2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_but_a_better_type_may_be_inferred_from_usage.code:
                    return e2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code;
                  case e2.Diagnostics.Variable_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e2.Diagnostics.Variable_0_implicitly_has_an_1_type.code;
                  case e2.Diagnostics.Parameter_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e2.Diagnostics.Parameter_0_implicitly_has_an_1_type.code;
                  case e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code;
                  case e2.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_get_accessor_may_be_inferred_from_usage.code:
                    return e2.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code;
                  case e2.Diagnostics._0_implicitly_has_an_1_return_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code;
                  case e2.Diagnostics.Property_0_implicitly_has_type_any_but_a_better_type_for_its_set_accessor_may_be_inferred_from_usage.code:
                    return e2.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code;
                  case e2.Diagnostics.Member_0_implicitly_has_an_1_type_but_a_better_type_may_be_inferred_from_usage.code:
                    return e2.Diagnostics.Member_0_implicitly_has_an_1_type.code;
                }
                return q;
              }
              function le(q, O, ve, ee, he, F2, x2, X, $) {
                if (!(!e2.isParameterPropertyModifier(ve.kind) && ve.kind !== 79 && ve.kind !== 25 && ve.kind !== 108)) {
                  var A2 = ve.parent, y = C.createImportAdder(O, he, $, X);
                  switch (ee = Q(ee), ee) {
                    case e2.Diagnostics.Member_0_implicitly_has_an_1_type.code:
                    case e2.Diagnostics.Variable_0_implicitly_has_type_1_in_some_locations_where_its_type_cannot_be_determined.code:
                      if (e2.isVariableDeclaration(A2) && x2(A2) || e2.isPropertyDeclaration(A2) || e2.isPropertySignature(A2))
                        return N(q, y, O, A2, he, X, F2), y.writeFixes(q), A2;
                      if (e2.isPropertyAccessExpression(A2)) {
                        var V = se(A2.name, he, F2), L = e2.getTypeNodeIfAccessible(V, A2, he, X);
                        if (L) {
                          var P = e2.factory.createJSDocTypeTag(void 0, e2.factory.createJSDocTypeExpression(L), void 0);
                          q.addJSDocTags(O, e2.cast(A2.parent.parent, e2.isExpressionStatement), [P]);
                        }
                        return y.writeFixes(q), A2;
                      }
                      return;
                    case e2.Diagnostics.Variable_0_implicitly_has_an_1_type.code: {
                      var k = he.getTypeChecker().getSymbolAtLocation(ve);
                      return k && k.valueDeclaration && e2.isVariableDeclaration(k.valueDeclaration) && x2(k.valueDeclaration) ? (N(q, y, e2.getSourceFileOfNode(k.valueDeclaration), k.valueDeclaration, he, X, F2), y.writeFixes(q), k.valueDeclaration) : void 0;
                    }
                  }
                  var Y = e2.getContainingFunction(ve);
                  if (Y !== void 0) {
                    var U;
                    switch (ee) {
                      case e2.Diagnostics.Parameter_0_implicitly_has_an_1_type.code:
                        if (e2.isSetAccessorDeclaration(Y)) {
                          oe(q, y, O, Y, he, X, F2), U = Y;
                          break;
                        }
                      case e2.Diagnostics.Rest_parameter_0_implicitly_has_an_any_type.code:
                        if (x2(Y)) {
                          var j = e2.cast(A2, e2.isParameter);
                          p(q, y, O, j, Y, he, X, F2), U = j;
                        }
                        break;
                      case e2.Diagnostics.Property_0_implicitly_has_type_any_because_its_get_accessor_lacks_a_return_type_annotation.code:
                      case e2.Diagnostics._0_which_lacks_return_type_annotation_implicitly_has_an_1_return_type.code:
                        e2.isGetAccessorDeclaration(Y) && e2.isIdentifier(Y.name) && (f4(q, y, O, Y, se(Y.name, he, F2), he, X), U = Y);
                        break;
                      case e2.Diagnostics.Property_0_implicitly_has_type_any_because_its_set_accessor_lacks_a_parameter_type_annotation.code:
                        e2.isSetAccessorDeclaration(Y) && (oe(q, y, O, Y, he, X, F2), U = Y);
                        break;
                      case e2.Diagnostics.this_implicitly_has_type_any_because_it_does_not_have_a_type_annotation.code:
                        e2.textChanges.isThisTypeAnnotatable(Y) && x2(Y) && (m2(q, O, Y, he, X, F2), U = Y);
                        break;
                      default:
                        return e2.Debug.fail(String(ee));
                    }
                    return y.writeFixes(q), U;
                  }
                }
              }
              function N(q, O, ve, ee, he, F2, x2) {
                e2.isIdentifier(ee.name) && f4(q, O, ve, ee, se(ee.name, he, x2), he, F2);
              }
              function p(q, O, ve, ee, he, F2, x2, X) {
                if (!!e2.isIdentifier(ee.name)) {
                  var $ = J(he, ve, F2, X);
                  if (e2.Debug.assert(he.parameters.length === $.length, "Parameter count and inference count should match"), e2.isInJSFile(he))
                    K(q, ve, $, F2, x2);
                  else {
                    var A2 = e2.isArrowFunction(he) && !e2.findChildOfKind(he, 20, ve);
                    A2 && q.insertNodeBefore(ve, e2.first(he.parameters), e2.factory.createToken(20));
                    for (var y = 0, V = $; y < V.length; y++) {
                      var L = V[y], P = L.declaration, k = L.type;
                      P && !P.type && !P.initializer && f4(q, O, ve, P, k, F2, x2);
                    }
                    A2 && q.insertNodeAfter(ve, e2.last(he.parameters), e2.factory.createToken(21));
                  }
                }
              }
              function m2(q, O, ve, ee, he, F2) {
                var x2 = ie(ve, O, ee, F2);
                if (!(!x2 || !x2.length)) {
                  var X = R(ee, x2, F2).thisParameter(), $ = e2.getTypeNodeIfAccessible(X, ve, ee, he);
                  !$ || (e2.isInJSFile(ve) ? G(q, O, ve, $) : q.tryInsertThisTypeAnnotation(O, ve, $));
                }
              }
              function G(q, O, ve, ee) {
                q.addJSDocTags(O, ve, [e2.factory.createJSDocThisTag(void 0, e2.factory.createJSDocTypeExpression(ee))]);
              }
              function oe(q, O, ve, ee, he, F2, x2) {
                var X = e2.firstOrUndefined(ee.parameters);
                if (X && e2.isIdentifier(ee.name) && e2.isIdentifier(X.name)) {
                  var $ = se(ee.name, he, x2);
                  $ === he.getTypeChecker().getAnyType() && ($ = se(X.name, he, x2)), e2.isInJSFile(ee) ? K(q, ve, [{ declaration: X, type: $ }], he, F2) : f4(q, O, ve, X, $, he, F2);
                }
              }
              function f4(q, O, ve, ee, he, F2, x2) {
                var X = e2.getTypeNodeIfAccessible(he, ee, F2, x2);
                if (X)
                  if (e2.isInJSFile(ve) && ee.kind !== 166) {
                    var $ = e2.isVariableDeclaration(ee) ? e2.tryCast(ee.parent.parent, e2.isVariableStatement) : ee;
                    if (!$)
                      return;
                    var A2 = e2.factory.createJSDocTypeExpression(X), y = e2.isGetAccessorDeclaration(ee) ? e2.factory.createJSDocReturnTag(void 0, A2, void 0) : e2.factory.createJSDocTypeTag(void 0, A2, void 0);
                    q.addJSDocTags(ve, $, [y]);
                  } else
                    T(X, ee, ve, q, O, e2.getEmitScriptTarget(F2.getCompilerOptions())) || q.tryInsertTypeAnnotation(ve, ee, X);
              }
              function T(q, O, ve, ee, he, F2) {
                var x2 = C.tryGetAutoImportableReferenceFromTypeNode(q, F2);
                return x2 && ee.tryInsertTypeAnnotation(ve, O, x2.typeNode) ? (e2.forEach(x2.symbols, function(X) {
                  return he.addImportFromExportedSymbol(X, true);
                }), true) : false;
              }
              function K(q, O, ve, ee, he) {
                var F2 = ve.length && ve[0].declaration.parent;
                if (!!F2) {
                  var x2 = e2.mapDefined(ve, function(A2) {
                    var y = A2.declaration;
                    if (!(y.initializer || e2.getJSDocType(y) || !e2.isIdentifier(y.name))) {
                      var V = A2.type && e2.getTypeNodeIfAccessible(A2.type, y, ee, he);
                      if (V) {
                        var L = e2.factory.cloneNode(y.name);
                        return e2.setEmitFlags(L, 3584), { name: e2.factory.cloneNode(y.name), param: y, isOptional: !!A2.isOptional, typeNode: V };
                      }
                    }
                  });
                  if (!!x2.length)
                    if (e2.isArrowFunction(F2) || e2.isFunctionExpression(F2)) {
                      var X = e2.isArrowFunction(F2) && !e2.findChildOfKind(F2, 20, O);
                      X && q.insertNodeBefore(O, e2.first(F2.parameters), e2.factory.createToken(20)), e2.forEach(x2, function(A2) {
                        var y = A2.typeNode, V = A2.param, L = e2.factory.createJSDocTypeTag(void 0, e2.factory.createJSDocTypeExpression(y)), P = e2.factory.createJSDocComment(void 0, [L]);
                        q.insertNodeAt(O, V.getStart(O), P, { suffix: " " });
                      }), X && q.insertNodeAfter(O, e2.last(F2.parameters), e2.factory.createToken(21));
                    } else {
                      var $ = e2.map(x2, function(A2) {
                        var y = A2.name, V = A2.typeNode, L = A2.isOptional;
                        return e2.factory.createJSDocParameterTag(void 0, y, !!L, e2.factory.createJSDocTypeExpression(V), false, void 0);
                      });
                      q.addJSDocTags(O, F2, $);
                    }
                }
              }
              function b(q, O, ve) {
                return e2.mapDefined(e2.FindAllReferences.getReferenceEntriesForNode(-1, q, O, O.getSourceFiles(), ve), function(ee) {
                  return ee.kind !== 0 ? e2.tryCast(ee.node, e2.isIdentifier) : void 0;
                });
              }
              function se(q, O, ve) {
                var ee = b(q, O, ve);
                return R(O, ee, ve).single();
              }
              function J(q, O, ve, ee) {
                var he = ie(q, O, ve, ee);
                return he && R(ve, he, ee).parameters(q) || q.parameters.map(function(F2) {
                  return { declaration: F2, type: e2.isIdentifier(F2.name) ? se(F2.name, ve, ee) : ve.getTypeChecker().getAnyType() };
                });
              }
              function ie(q, O, ve, ee) {
                var he;
                switch (q.kind) {
                  case 171:
                    he = e2.findChildOfKind(q, 134, O);
                    break;
                  case 214:
                  case 213:
                    var F2 = q.parent;
                    he = (e2.isVariableDeclaration(F2) || e2.isPropertyDeclaration(F2)) && e2.isIdentifier(F2.name) ? F2.name : q.name;
                    break;
                  case 256:
                  case 169:
                  case 168:
                    he = q.name;
                    break;
                }
                if (!!he)
                  return b(he, ve, ee);
              }
              function R(q, O, ve) {
                var ee = q.getTypeChecker(), he = { string: function() {
                  return ee.getStringType();
                }, number: function() {
                  return ee.getNumberType();
                }, Array: function(_e) {
                  return ee.createArrayType(_e);
                }, Promise: function(_e) {
                  return ee.createPromiseType(_e);
                } }, F2 = [ee.getStringType(), ee.getNumberType(), ee.createArrayType(ee.getAnyType()), ee.createPromiseType(ee.getAnyType())];
                return { single: $, parameters: A2, thisParameter: y };
                function x2() {
                  return { isNumber: void 0, isString: void 0, isNumberOrString: void 0, candidateTypes: void 0, properties: void 0, calls: void 0, constructs: void 0, numberIndex: void 0, stringIndex: void 0, candidateThisTypes: void 0, inferredTypes: void 0 };
                }
                function X(_e) {
                  for (var we = new e2.Map(), de = 0, ye = _e; de < ye.length; de++) {
                    var Ae = ye[de];
                    Ae.properties && Ae.properties.forEach(function(ir, Cr) {
                      we.has(Cr) || we.set(Cr, []), we.get(Cr).push(ir);
                    });
                  }
                  var er = new e2.Map();
                  return we.forEach(function(ir, Cr) {
                    er.set(Cr, X(ir));
                  }), { isNumber: _e.some(function(ir) {
                    return ir.isNumber;
                  }), isString: _e.some(function(ir) {
                    return ir.isString;
                  }), isNumberOrString: _e.some(function(ir) {
                    return ir.isNumberOrString;
                  }), candidateTypes: e2.flatMap(_e, function(ir) {
                    return ir.candidateTypes;
                  }), properties: er, calls: e2.flatMap(_e, function(ir) {
                    return ir.calls;
                  }), constructs: e2.flatMap(_e, function(ir) {
                    return ir.constructs;
                  }), numberIndex: e2.forEach(_e, function(ir) {
                    return ir.numberIndex;
                  }), stringIndex: e2.forEach(_e, function(ir) {
                    return ir.stringIndex;
                  }), candidateThisTypes: e2.flatMap(_e, function(ir) {
                    return ir.candidateThisTypes;
                  }), inferredTypes: void 0 };
                }
                function $() {
                  return ne(V(O));
                }
                function A2(_e) {
                  if (!(O.length === 0 || !_e.parameters)) {
                    for (var we = x2(), de = 0, ye = O; de < ye.length; de++) {
                      var Ae = ye[de];
                      ve.throwIfCancellationRequested(), L(Ae, we);
                    }
                    var er = Ve(Ve([], we.constructs || [], true), we.calls || [], true);
                    return _e.parameters.map(function(ir, Cr) {
                      for (var Ye = [], Br = e2.isRestParameter(ir), Er = false, Ne = 0, n = er; Ne < n.length; Ne++) {
                        var lr = n[Ne];
                        if (lr.argumentTypes.length <= Cr)
                          Er = e2.isInJSFile(_e), Ye.push(ee.getUndefinedType());
                        else if (Br)
                          for (var be = Cr; be < lr.argumentTypes.length; be++)
                            Ye.push(ee.getBaseTypeOfLiteralType(lr.argumentTypes[be]));
                        else
                          Ye.push(ee.getBaseTypeOfLiteralType(lr.argumentTypes[Cr]));
                      }
                      if (e2.isIdentifier(ir.name)) {
                        var Ge = V(b(ir.name, q, ve));
                        Ye.push.apply(Ye, Br ? e2.mapDefined(Ge, ee.getElementTypeOfArrayType) : Ge);
                      }
                      var ur = ne(Ye);
                      return { type: Br ? ee.createArrayType(ur) : ur, isOptional: Er && !Br, declaration: ir };
                    });
                  }
                }
                function y() {
                  for (var _e = x2(), we = 0, de = O; we < de.length; we++) {
                    var ye = de[we];
                    ve.throwIfCancellationRequested(), L(ye, _e);
                  }
                  return ne(_e.candidateThisTypes || e2.emptyArray);
                }
                function V(_e) {
                  for (var we = x2(), de = 0, ye = _e; de < ye.length; de++) {
                    var Ae = ye[de];
                    ve.throwIfCancellationRequested(), L(Ae, we);
                  }
                  return We(we);
                }
                function L(_e, we) {
                  for (; e2.isRightSideOfQualifiedNameOrPropertyAccess(_e); )
                    _e = _e.parent;
                  switch (_e.parent.kind) {
                    case 238:
                      k(_e, we);
                      break;
                    case 220:
                      we.isNumber = true;
                      break;
                    case 219:
                      Y(_e.parent, we);
                      break;
                    case 221:
                      U(_e, _e.parent, we);
                      break;
                    case 289:
                    case 290:
                      j(_e.parent, we);
                      break;
                    case 208:
                    case 209:
                      _e.parent.expression === _e ? H(_e.parent, we) : P(_e, we);
                      break;
                    case 206:
                      I(_e.parent, we);
                      break;
                    case 207:
                      l(_e.parent, _e, we);
                      break;
                    case 296:
                    case 297:
                      d(_e.parent, we);
                      break;
                    case 167:
                      D(_e.parent, we);
                      break;
                    case 254: {
                      var de = _e.parent, ye = de.name, Ae = de.initializer;
                      if (_e === ye) {
                        Ae && rr(we, ee.getTypeAtLocation(Ae));
                        break;
                      }
                    }
                    default:
                      return P(_e, we);
                  }
                }
                function P(_e, we) {
                  e2.isExpressionNode(_e) && rr(we, ee.getContextualType(_e));
                }
                function k(_e, we) {
                  rr(we, e2.isCallExpression(_e) ? ee.getVoidType() : ee.getAnyType());
                }
                function Y(_e, we) {
                  switch (_e.operator) {
                    case 45:
                    case 46:
                    case 40:
                    case 54:
                      we.isNumber = true;
                      break;
                    case 39:
                      we.isNumberOrString = true;
                      break;
                  }
                }
                function U(_e, we, de) {
                  switch (we.operatorToken.kind) {
                    case 42:
                    case 41:
                    case 43:
                    case 44:
                    case 47:
                    case 48:
                    case 49:
                    case 50:
                    case 51:
                    case 52:
                    case 65:
                    case 67:
                    case 66:
                    case 68:
                    case 69:
                    case 73:
                    case 74:
                    case 78:
                    case 70:
                    case 72:
                    case 71:
                    case 40:
                    case 29:
                    case 32:
                    case 31:
                    case 33:
                      var ye = ee.getTypeAtLocation(we.left === _e ? we.right : we.left);
                      ye.flags & 1056 ? rr(de, ye) : de.isNumber = true;
                      break;
                    case 64:
                    case 39:
                      var Ae = ee.getTypeAtLocation(we.left === _e ? we.right : we.left);
                      Ae.flags & 1056 ? rr(de, Ae) : Ae.flags & 296 ? de.isNumber = true : Ae.flags & 402653316 ? de.isString = true : Ae.flags & 1 || (de.isNumberOrString = true);
                      break;
                    case 63:
                    case 34:
                    case 36:
                    case 37:
                    case 35:
                      rr(de, ee.getTypeAtLocation(we.left === _e ? we.right : we.left));
                      break;
                    case 101:
                      _e === we.left && (de.isString = true);
                      break;
                    case 56:
                    case 60:
                      _e === we.left && (_e.parent.parent.kind === 254 || e2.isAssignmentExpression(_e.parent.parent, true)) && rr(de, ee.getTypeAtLocation(we.right));
                      break;
                    case 55:
                    case 27:
                    case 102:
                      break;
                  }
                }
                function j(_e, we) {
                  rr(we, ee.getTypeAtLocation(_e.parent.parent.expression));
                }
                function H(_e, we) {
                  var de = { argumentTypes: [], return_: x2() };
                  if (_e.arguments)
                    for (var ye = 0, Ae = _e.arguments; ye < Ae.length; ye++) {
                      var er = Ae[ye];
                      de.argumentTypes.push(ee.getTypeAtLocation(er));
                    }
                  L(_e, de.return_), _e.kind === 208 ? (we.calls || (we.calls = [])).push(de) : (we.constructs || (we.constructs = [])).push(de);
                }
                function I(_e, we) {
                  var de = e2.escapeLeadingUnderscores(_e.name.text);
                  we.properties || (we.properties = new e2.Map());
                  var ye = we.properties.get(de) || x2();
                  L(_e, ye), we.properties.set(de, ye);
                }
                function l(_e, we, de) {
                  if (we === _e.argumentExpression) {
                    de.isNumberOrString = true;
                    return;
                  } else {
                    var ye = ee.getTypeAtLocation(_e.argumentExpression), Ae = x2();
                    L(_e, Ae), ye.flags & 296 ? de.numberIndex = Ae : de.stringIndex = Ae;
                  }
                }
                function d(_e, we) {
                  var de = e2.isVariableDeclaration(_e.parent.parent) ? _e.parent.parent : _e.parent;
                  Ie(we, ee.getTypeAtLocation(de));
                }
                function D(_e, we) {
                  Ie(we, ee.getTypeAtLocation(_e.parent));
                }
                function fe(_e, we) {
                  for (var de = [], ye = 0, Ae = _e; ye < Ae.length; ye++)
                    for (var er = Ae[ye], ir = 0, Cr = we; ir < Cr.length; ir++) {
                      var Ye = Cr[ir], Br = Ye.high, Er = Ye.low;
                      Br(er) && (e2.Debug.assert(!Er(er), "Priority can't have both low and high"), de.push(Er));
                    }
                  return _e.filter(function(Ne) {
                    return de.every(function(n) {
                      return !n(Ne);
                    });
                  });
                }
                function g(_e) {
                  return ne(We(_e));
                }
                function ne(_e) {
                  if (!_e.length)
                    return ee.getAnyType();
                  var we = ee.getUnionType([ee.getStringType(), ee.getNumberType()]), de = [{ high: function(er) {
                    return er === ee.getStringType() || er === ee.getNumberType();
                  }, low: function(er) {
                    return er === we;
                  } }, { high: function(er) {
                    return !(er.flags & 16385);
                  }, low: function(er) {
                    return !!(er.flags & 16385);
                  } }, { high: function(er) {
                    return !(er.flags & 114689) && !(e2.getObjectFlags(er) & 16);
                  }, low: function(er) {
                    return !!(e2.getObjectFlags(er) & 16);
                  } }], ye = fe(_e, de), Ae = ye.filter(function(er) {
                    return e2.getObjectFlags(er) & 16;
                  });
                  return Ae.length && (ye = ye.filter(function(er) {
                    return !(e2.getObjectFlags(er) & 16);
                  }), ye.push(ue(Ae))), ee.getWidenedType(ee.getUnionType(ye.map(ee.getBaseTypeOfLiteralType), 2));
                }
                function ue(_e) {
                  if (_e.length === 1)
                    return _e[0];
                  for (var we = [], de = [], ye = [], Ae = [], er = false, ir = false, Cr = e2.createMultiMap(), Ye = 0, Br = _e; Ye < Br.length; Ye++) {
                    for (var Er = Br[Ye], Ne = 0, n = ee.getPropertiesOfType(Er); Ne < n.length; Ne++) {
                      var lr = n[Ne];
                      Cr.add(lr.name, lr.valueDeclaration ? ee.getTypeOfSymbolAtLocation(lr, lr.valueDeclaration) : ee.getAnyType());
                    }
                    we.push.apply(we, ee.getSignaturesOfType(Er, 0)), de.push.apply(de, ee.getSignaturesOfType(Er, 1));
                    var be = ee.getIndexInfoOfType(Er, 0);
                    be && (ye.push(be.type), er = er || be.isReadonly);
                    var Ge = ee.getIndexInfoOfType(Er, 1);
                    Ge && (Ae.push(Ge.type), ir = ir || Ge.isReadonly);
                  }
                  var ur = e2.mapEntries(Cr, function(Ir, wr) {
                    var Ur = wr.length < _e.length ? 16777216 : 0, ii = ee.createSymbol(4 | Ur, Ir);
                    return ii.type = ee.getUnionType(wr), [Ir, ii];
                  }), yr = [];
                  return ye.length && yr.push(ee.createIndexInfo(ee.getStringType(), ee.getUnionType(ye), er)), Ae.length && yr.push(ee.createIndexInfo(ee.getNumberType(), ee.getUnionType(Ae), ir)), ee.createAnonymousType(_e[0].symbol, ur, we, de, yr);
                }
                function We(_e) {
                  var we, de, ye, Ae = [];
                  _e.isNumber && Ae.push(ee.getNumberType()), _e.isString && Ae.push(ee.getStringType()), _e.isNumberOrString && Ae.push(ee.getUnionType([ee.getStringType(), ee.getNumberType()])), _e.numberIndex && Ae.push(ee.createArrayType(g(_e.numberIndex))), (((we = _e.properties) === null || we === void 0 ? void 0 : we.size) || ((de = _e.constructs) === null || de === void 0 ? void 0 : de.length) || _e.stringIndex) && Ae.push(Fe(_e));
                  var er = (_e.candidateTypes || []).map(function(Cr) {
                    return ee.getBaseTypeOfLiteralType(Cr);
                  }), ir = !((ye = _e.calls) === null || ye === void 0) && ye.length ? Fe(_e) : void 0;
                  return ir && er ? Ae.push(ee.getUnionType(Ve([ir], er, true), 2)) : (ir && Ae.push(ir), e2.length(er) && Ae.push.apply(Ae, er)), Ae.push.apply(Ae, Z2(_e)), Ae;
                }
                function Fe(_e) {
                  var we = new e2.Map();
                  _e.properties && _e.properties.forEach(function(er, ir) {
                    var Cr = ee.createSymbol(4, ir);
                    Cr.type = g(er), we.set(ir, Cr);
                  });
                  var de = _e.calls ? [He(_e.calls)] : [], ye = _e.constructs ? [He(_e.constructs)] : [], Ae = _e.stringIndex ? [ee.createIndexInfo(ee.getStringType(), g(_e.stringIndex), false)] : [];
                  return ee.createAnonymousType(void 0, we, de, ye, Ae);
                }
                function Z2(_e) {
                  if (!_e.properties || !_e.properties.size)
                    return [];
                  var we = F2.filter(function(de) {
                    return Be(de, _e);
                  });
                  return 0 < we.length && we.length < 3 ? we.map(function(de) {
                    return ge(de, _e);
                  }) : [];
                }
                function Be(_e, we) {
                  return we.properties ? !e2.forEachEntry(we.properties, function(de, ye) {
                    var Ae = ee.getTypeOfPropertyOfType(_e, ye);
                    if (!Ae)
                      return true;
                    if (de.calls) {
                      var er = ee.getSignaturesOfType(Ae, 0);
                      return !er.length || !ee.isTypeAssignableTo(Ae, Ee(de.calls));
                    } else
                      return !ee.isTypeAssignableTo(Ae, g(de));
                  }) : false;
                }
                function ge(_e, we) {
                  if (!(e2.getObjectFlags(_e) & 4) || !we.properties)
                    return _e;
                  var de = _e.target, ye = e2.singleOrUndefined(de.typeParameters);
                  if (!ye)
                    return _e;
                  var Ae = [];
                  return we.properties.forEach(function(er, ir) {
                    var Cr = ee.getTypeOfPropertyOfType(de, ir);
                    e2.Debug.assert(!!Cr, "generic should have all the properties of its reference."), Ae.push.apply(Ae, Re(Cr, g(er), ye));
                  }), he[_e.symbol.escapedName](ne(Ae));
                }
                function Re(_e, we, de) {
                  if (_e === de)
                    return [we];
                  if (_e.flags & 3145728)
                    return e2.flatMap(_e.types, function(Br) {
                      return Re(Br, we, de);
                    });
                  if (e2.getObjectFlags(_e) & 4 && e2.getObjectFlags(we) & 4) {
                    var ye = ee.getTypeArguments(_e), Ae = ee.getTypeArguments(we), er = [];
                    if (ye && Ae)
                      for (var ir = 0; ir < ye.length; ir++)
                        Ae[ir] && er.push.apply(er, Re(ye[ir], Ae[ir], de));
                    return er;
                  }
                  var Cr = ee.getSignaturesOfType(_e, 0), Ye = ee.getSignaturesOfType(we, 0);
                  return Cr.length === 1 && Ye.length === 1 ? ze(Cr[0], Ye[0], de) : [];
                }
                function ze(_e, we, de) {
                  for (var ye = [], Ae = 0; Ae < _e.parameters.length; Ae++) {
                    var er = _e.parameters[Ae], ir = we.parameters[Ae], Cr = _e.declaration && e2.isRestParameter(_e.declaration.parameters[Ae]);
                    if (!ir)
                      break;
                    var Ye = er.valueDeclaration ? ee.getTypeOfSymbolAtLocation(er, er.valueDeclaration) : ee.getAnyType(), Br = Cr && ee.getElementTypeOfArrayType(Ye);
                    Br && (Ye = Br);
                    var Er = ir.type || (ir.valueDeclaration ? ee.getTypeOfSymbolAtLocation(ir, ir.valueDeclaration) : ee.getAnyType());
                    ye.push.apply(ye, Re(Ye, Er, de));
                  }
                  var Ne = ee.getReturnTypeOfSignature(_e), n = ee.getReturnTypeOfSignature(we);
                  return ye.push.apply(ye, Re(Ne, n, de)), ye;
                }
                function Ee(_e) {
                  return ee.createAnonymousType(void 0, e2.createSymbolTable(), [He(_e)], e2.emptyArray, e2.emptyArray);
                }
                function He(_e) {
                  for (var we = [], de = Math.max.apply(Math, _e.map(function(ir) {
                    return ir.argumentTypes.length;
                  })), ye = function(ir) {
                    var Cr = ee.createSymbol(1, e2.escapeLeadingUnderscores("arg".concat(ir)));
                    Cr.type = ne(_e.map(function(Ye) {
                      return Ye.argumentTypes[ir] || ee.getUndefinedType();
                    })), _e.some(function(Ye) {
                      return Ye.argumentTypes[ir] === void 0;
                    }) && (Cr.flags |= 16777216), we.push(Cr);
                  }, Ae = 0; Ae < de; Ae++)
                    ye(Ae);
                  var er = g(X(_e.map(function(ir) {
                    return ir.return_;
                  })));
                  return ee.createSignature(void 0, void 0, void 0, we, er, void 0, de, 0);
                }
                function rr(_e, we) {
                  we && !(we.flags & 1) && !(we.flags & 131072) && (_e.candidateTypes || (_e.candidateTypes = [])).push(we);
                }
                function Ie(_e, we) {
                  we && !(we.flags & 1) && !(we.flags & 131072) && (_e.candidateThisTypes || (_e.candidateThisTypes = [])).push(we);
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixReturnTypeInAsyncFunction", B = [e2.Diagnostics.The_return_type_of_an_async_function_or_method_must_be_the_global_Promise_T_type_Did_you_mean_to_write_Promise_0.code];
              C.registerCodeFix({ errorCodes: B, fixIds: [w], getCodeActions: function(N) {
                var p = N.sourceFile, m2 = N.program, G = N.span, oe = m2.getTypeChecker(), f4 = E(p, m2.getTypeChecker(), G.start);
                if (!!f4) {
                  var T = f4.returnTypeNode, K = f4.returnType, b = f4.promisedTypeNode, se = f4.promisedType, J = e2.textChanges.ChangeTracker.with(N, function(ie) {
                    return Q(ie, p, T, b);
                  });
                  return [C.createCodeFixAction(w, J, [e2.Diagnostics.Replace_0_with_Promise_1, oe.typeToString(K), oe.typeToString(se)], w, e2.Diagnostics.Fix_all_incorrect_return_type_of_an_async_functions)];
                }
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m2 = E(p.file, le.program.getTypeChecker(), p.start);
                  m2 && Q(N, p.file, m2.returnTypeNode, m2.promisedTypeNode);
                });
              } });
              function E(le, N, p) {
                if (!e2.isInJSFile(le)) {
                  var m2 = e2.getTokenAtPosition(le, p), G = e2.findAncestor(m2, e2.isFunctionLikeDeclaration), oe = G == null ? void 0 : G.type;
                  if (!!oe) {
                    var f4 = N.getTypeFromTypeNode(oe), T = N.getAwaitedType(f4) || N.getVoidType(), K = N.typeToTypeNode(T, oe, void 0);
                    if (K)
                      return { returnTypeNode: oe, returnType: f4, promisedTypeNode: K, promisedType: T };
                  }
                }
              }
              function Q(le, N, p, m2) {
                le.replaceNode(N, p, e2.factory.createTypeReferenceNode("Promise", [m2]));
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "disableJsDiagnostics", B = "disableJsDiagnostics", E = e2.mapDefined(Object.keys(e2.Diagnostics), function(le) {
                var N = e2.Diagnostics[le];
                return N.category === e2.DiagnosticCategory.Error ? N.code : void 0;
              });
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(N) {
                var p = N.sourceFile, m2 = N.program, G = N.span, oe = N.host, f4 = N.formatContext;
                if (!(!e2.isInJSFile(p) || !e2.isCheckJsEnabledForFile(p, m2.getCompilerOptions()))) {
                  var T = p.checkJsDirective ? "" : e2.getNewLineOrDefaultFromHost(oe, f4.options), K = [C.createCodeFixActionWithoutFixAll(w, [C.createFileTextChanges(p.fileName, [e2.createTextChange(p.checkJsDirective ? e2.createTextSpanFromBounds(p.checkJsDirective.pos, p.checkJsDirective.end) : e2.createTextSpan(0, 0), "// @ts-nocheck".concat(T))])], e2.Diagnostics.Disable_checking_for_this_file)];
                  return e2.textChanges.isValidLocationToAddComment(p, G.start) && K.unshift(C.createCodeFixAction(w, e2.textChanges.ChangeTracker.with(N, function(b) {
                    return Q(b, p, G.start);
                  }), e2.Diagnostics.Ignore_this_error_message, B, e2.Diagnostics.Add_ts_ignore_to_all_error_messages)), K;
                }
              }, fixIds: [B], getAllCodeActions: function(le) {
                var N = new e2.Set();
                return C.codeFixAll(le, E, function(p, m2) {
                  e2.textChanges.isValidLocationToAddComment(m2.file, m2.start) && Q(p, m2.file, m2.start, N);
                });
              } });
              function Q(le, N, p, m2) {
                var G = e2.getLineAndCharacterOfPosition(N, p).line;
                (!m2 || e2.tryAddToSet(m2, G)) && le.insertCommentBeforeLine(N, G, p, " @ts-ignore");
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(ee, he, F2, x2, X, $, A2) {
                for (var y = ee.symbol.members, V = 0, L = he; V < L.length; V++) {
                  var P = L[V];
                  y.has(P.escapedName) || Q(P, ee, F2, x2, X, $, A2, void 0);
                }
              }
              C.createMissingMemberNodes = w;
              function B(ee) {
                return { trackSymbol: function() {
                  return false;
                }, moduleResolverHost: e2.getModuleSpecifierResolverHost(ee.program, ee.host) };
              }
              C.getNoopSymbolTrackerWithResolver = B;
              var E;
              (function(ee) {
                ee[ee.Method = 1] = "Method", ee[ee.Property = 2] = "Property", ee[ee.All = 3] = "All";
              })(E = C.PreserveOptionalFlags || (C.PreserveOptionalFlags = {}));
              function Q(ee, he, F2, x2, X, $, A2, y, V, L) {
                V === void 0 && (V = 3), L === void 0 && (L = false);
                var P = ee.getDeclarations();
                if (!(P && P.length))
                  return;
                var k = x2.program.getTypeChecker(), Y = e2.getEmitScriptTarget(x2.program.getCompilerOptions()), U = P[0], j = e2.getSynthesizedDeepClone(e2.getNameOfDeclaration(U), false), H = b(e2.getEffectiveModifierFlags(U)), I = H ? e2.factory.createNodeArray([H]) : void 0, l = k.getWidenedType(k.getTypeOfSymbolAtLocation(ee, he)), d = !!(ee.flags & 16777216), D = !!(he.flags & 16777216) || L, fe = e2.getQuotePreference(F2, X);
                switch (U.kind) {
                  case 166:
                  case 167:
                    var g = fe === 0 ? 268435456 : void 0, ne = k.typeToTypeNode(l, he, g, B(x2));
                    if ($) {
                      var ue = q(ne, Y);
                      ue && (ne = ue.typeNode, ve($, ue.symbols));
                    }
                    A2(e2.factory.createPropertyDeclaration(void 0, I, j, d && V & 2 ? e2.factory.createToken(57) : void 0, ne, void 0));
                    break;
                  case 172:
                  case 173: {
                    var We = k.typeToTypeNode(l, he, void 0, B(x2)), Fe = e2.getAllAccessorDeclarations(P, U), Z2 = Fe.secondAccessor ? [Fe.firstAccessor, Fe.secondAccessor] : [Fe.firstAccessor];
                    if ($) {
                      var ue = q(We, Y);
                      ue && (We = ue.typeNode, ve($, ue.symbols));
                    }
                    for (var Be = 0, ge = Z2; Be < ge.length; Be++) {
                      var Re = ge[Be];
                      if (e2.isGetAccessorDeclaration(Re))
                        A2(e2.factory.createGetAccessorDeclaration(void 0, I, j, e2.emptyArray, We, D ? void 0 : y || T(fe)));
                      else {
                        e2.Debug.assertNode(Re, e2.isSetAccessorDeclaration, "The counterpart to a getter should be a setter");
                        var ze = e2.getSetAccessorValueParameter(Re), Ee = ze && e2.isIdentifier(ze.name) ? e2.idText(ze.name) : void 0;
                        A2(e2.factory.createSetAccessorDeclaration(void 0, I, j, m2(1, [Ee], [We], 1, false), D ? void 0 : y || T(fe)));
                      }
                    }
                    break;
                  }
                  case 168:
                  case 169:
                    var He = k.getSignaturesOfType(l, 0);
                    if (!e2.some(He))
                      break;
                    if (P.length === 1) {
                      e2.Debug.assert(He.length === 1, "One declaration implies one signature");
                      var rr = He[0];
                      we(fe, rr, I, j, D ? void 0 : y || T(fe));
                      break;
                    }
                    for (var Ie = 0, _e = He; Ie < _e.length; Ie++) {
                      var rr = _e[Ie];
                      we(fe, rr, e2.getSynthesizedDeepClones(I, false), e2.getSynthesizedDeepClone(j, false));
                    }
                    if (!D)
                      if (P.length > He.length) {
                        var rr = k.getSignatureFromDeclaration(P[P.length - 1]);
                        we(fe, rr, I, j, y || T(fe));
                      } else
                        e2.Debug.assert(P.length === He.length, "Declarations and signatures should match count"), A2(G(k, x2, he, He, j, d && !!(V & 1), I, fe, y));
                    break;
                }
                function we(de, ye, Ae, er, ir) {
                  var Cr = le(169, x2, de, ye, ir, er, Ae, d && !!(V & 1), he, $);
                  Cr && A2(Cr);
                }
              }
              C.addNewNodeForMemberSymbol = Q;
              function le(ee, he, F2, x2, X, $, A2, y, V, L) {
                var P = he.program, k = P.getTypeChecker(), Y = e2.getEmitScriptTarget(P.getCompilerOptions()), U = 524545 | (F2 === 0 ? 268435456 : 0), j = k.signatureToSignatureDeclaration(x2, ee, V, U, B(he));
                if (!!j) {
                  var H = j.typeParameters, I = j.parameters, l = j.type;
                  if (L) {
                    if (H) {
                      var d = e2.sameMap(H, function(ue) {
                        var We = ue.constraint, Fe = ue.default;
                        if (We) {
                          var Z2 = q(We, Y);
                          Z2 && (We = Z2.typeNode, ve(L, Z2.symbols));
                        }
                        if (Fe) {
                          var Z2 = q(Fe, Y);
                          Z2 && (Fe = Z2.typeNode, ve(L, Z2.symbols));
                        }
                        return e2.factory.updateTypeParameterDeclaration(ue, ue.modifiers, ue.name, We, Fe);
                      });
                      H !== d && (H = e2.setTextRange(e2.factory.createNodeArray(d, H.hasTrailingComma), H));
                    }
                    var D = e2.sameMap(I, function(ue) {
                      var We = q(ue.type, Y), Fe = ue.type;
                      return We && (Fe = We.typeNode, ve(L, We.symbols)), e2.factory.updateParameterDeclaration(ue, ue.decorators, ue.modifiers, ue.dotDotDotToken, ue.name, ue.questionToken, Fe, ue.initializer);
                    });
                    if (I !== D && (I = e2.setTextRange(e2.factory.createNodeArray(D, I.hasTrailingComma), I)), l) {
                      var fe = q(l, Y);
                      fe && (l = fe.typeNode, ve(L, fe.symbols));
                    }
                  }
                  var g = y ? e2.factory.createToken(57) : void 0, ne = j.asteriskToken;
                  if (e2.isFunctionExpression(j))
                    return e2.factory.updateFunctionExpression(j, A2, j.asteriskToken, e2.tryCast($, e2.isIdentifier), H, I, l, X != null ? X : j.body);
                  if (e2.isArrowFunction(j))
                    return e2.factory.updateArrowFunction(j, A2, H, I, l, j.equalsGreaterThanToken, X != null ? X : j.body);
                  if (e2.isMethodDeclaration(j))
                    return e2.factory.updateMethodDeclaration(j, void 0, A2, ne, $ != null ? $ : e2.factory.createIdentifier(""), g, H, I, l, X);
                }
              }
              C.createSignatureDeclarationFromSignature = le;
              function N(ee, he, F2, x2, X, $, A2) {
                var y = e2.getQuotePreference(he.sourceFile, he.preferences), V = e2.getEmitScriptTarget(he.program.getCompilerOptions()), L = B(he), P = he.program.getTypeChecker(), k = e2.isInJSFile(A2), Y = x2.typeArguments, U = x2.arguments, j = x2.parent, H = k ? void 0 : P.getContextualType(x2), I = e2.map(U, function(ue) {
                  return e2.isIdentifier(ue) ? ue.text : e2.isPropertyAccessExpression(ue) && e2.isIdentifier(ue.name) ? ue.name.text : void 0;
                }), l = k ? [] : e2.map(U, function(ue) {
                  return p(P, F2, P.getBaseTypeOfLiteralType(P.getTypeAtLocation(ue)), A2, V, void 0, L);
                }), d = $ ? e2.factory.createNodeArray(e2.factory.createModifiersFromModifierFlags($)) : void 0, D = e2.isYieldExpression(j) ? e2.factory.createToken(41) : void 0, fe = k || Y === void 0 ? void 0 : e2.map(Y, function(ue, We) {
                  return e2.factory.createTypeParameterDeclaration(void 0, 84 + Y.length - 1 <= 90 ? String.fromCharCode(84 + We) : "T".concat(We));
                }), g = m2(U.length, I, l, void 0, k), ne = k || H === void 0 ? void 0 : P.typeToTypeNode(H, A2, void 0, L);
                switch (ee) {
                  case 169:
                    return e2.factory.createMethodDeclaration(void 0, d, D, X, void 0, fe, g, ne, T(y));
                  case 168:
                    return e2.factory.createMethodSignature(d, X, void 0, fe, g, ne);
                  case 256:
                    return e2.factory.createFunctionDeclaration(void 0, d, D, X, fe, g, ne, K(e2.Diagnostics.Function_not_implemented.message, y));
                  default:
                    e2.Debug.fail("Unexpected kind");
                }
              }
              C.createSignatureDeclarationFromCallExpression = N;
              function p(ee, he, F2, x2, X, $, A2) {
                var y = ee.typeToTypeNode(F2, x2, $, A2);
                if (y && e2.isImportTypeNode(y)) {
                  var V = q(y, X);
                  V && (ve(he, V.symbols), y = V.typeNode);
                }
                return e2.getSynthesizedDeepClone(y);
              }
              C.typeToAutoImportableTypeNode = p;
              function m2(ee, he, F2, x2, X) {
                for (var $ = [], A2 = 0; A2 < ee; A2++) {
                  var y = e2.factory.createParameterDeclaration(void 0, void 0, void 0, he && he[A2] || "arg".concat(A2), x2 !== void 0 && A2 >= x2 ? e2.factory.createToken(57) : void 0, X ? void 0 : F2 && F2[A2] || e2.factory.createKeywordTypeNode(155), void 0);
                  $.push(y);
                }
                return $;
              }
              function G(ee, he, F2, x2, X, $, A2, y, V) {
                for (var L = x2[0], P = x2[0].minArgumentCount, k = false, Y = 0, U = x2; Y < U.length; Y++) {
                  var j = U[Y];
                  P = Math.min(j.minArgumentCount, P), e2.signatureHasRestParameter(j) && (k = true), j.parameters.length >= L.parameters.length && (!e2.signatureHasRestParameter(j) || e2.signatureHasRestParameter(L)) && (L = j);
                }
                var H = L.parameters.length - (e2.signatureHasRestParameter(L) ? 1 : 0), I = L.parameters.map(function(D) {
                  return D.name;
                }), l = m2(H, I, void 0, P, false);
                if (k) {
                  var d = e2.factory.createParameterDeclaration(void 0, void 0, e2.factory.createToken(25), I[H] || "rest", H >= P ? e2.factory.createToken(57) : void 0, e2.factory.createArrayTypeNode(e2.factory.createKeywordTypeNode(155)), void 0);
                  l.push(d);
                }
                return f4(A2, X, $, void 0, l, oe(x2, ee, he, F2), y, V);
              }
              function oe(ee, he, F2, x2) {
                if (e2.length(ee)) {
                  var X = he.getUnionType(e2.map(ee, he.getReturnTypeOfSignature));
                  return he.typeToTypeNode(X, x2, void 0, B(F2));
                }
              }
              function f4(ee, he, F2, x2, X, $, A2, y) {
                return e2.factory.createMethodDeclaration(void 0, ee, void 0, he, F2 ? e2.factory.createToken(57) : void 0, x2, X, $, y || T(A2));
              }
              function T(ee) {
                return K(e2.Diagnostics.Method_not_implemented.message, ee);
              }
              function K(ee, he) {
                return e2.factory.createBlock([e2.factory.createThrowStatement(e2.factory.createNewExpression(e2.factory.createIdentifier("Error"), void 0, [e2.factory.createStringLiteral(ee, he === 0)]))], true);
              }
              C.createStubbedBody = K;
              function b(ee) {
                if (ee & 4)
                  return e2.factory.createToken(123);
                if (ee & 16)
                  return e2.factory.createToken(122);
              }
              function se(ee, he, F2) {
                var x2 = e2.getTsConfigObjectLiteralExpression(he);
                if (!!x2) {
                  var X = R(x2, "compilerOptions");
                  if (X === void 0) {
                    ee.insertNodeAtObjectStart(he, x2, ie("compilerOptions", e2.factory.createObjectLiteralExpression(F2.map(function(Y) {
                      var U = Y[0], j = Y[1];
                      return ie(U, j);
                    }), true)));
                    return;
                  }
                  var $ = X.initializer;
                  if (!!e2.isObjectLiteralExpression($))
                    for (var A2 = 0, y = F2; A2 < y.length; A2++) {
                      var V = y[A2], L = V[0], P = V[1], k = R($, L);
                      k === void 0 ? ee.insertNodeAtObjectStart(he, $, ie(L, P)) : ee.replaceNode(he, k.initializer, P);
                    }
                }
              }
              C.setJsonCompilerOptionValues = se;
              function J(ee, he, F2, x2) {
                se(ee, he, [[F2, x2]]);
              }
              C.setJsonCompilerOptionValue = J;
              function ie(ee, he) {
                return e2.factory.createPropertyAssignment(e2.factory.createStringLiteral(ee), he);
              }
              C.createJsonPropertyAssignment = ie;
              function R(ee, he) {
                return e2.find(ee.properties, function(F2) {
                  return e2.isPropertyAssignment(F2) && !!F2.name && e2.isStringLiteral(F2.name) && F2.name.text === he;
                });
              }
              C.findJsonProperty = R;
              function q(ee, he) {
                var F2, x2 = e2.visitNode(ee, X);
                if (F2 && x2)
                  return { typeNode: x2, symbols: F2 };
                function X($) {
                  var A2;
                  if (e2.isLiteralImportTypeNode($) && $.qualifier) {
                    var y = e2.getFirstIdentifier($.qualifier), V = e2.getNameForExportedSymbol(y.symbol, he), L = V !== y.text ? O($.qualifier, e2.factory.createIdentifier(V)) : $.qualifier;
                    F2 = e2.append(F2, y.symbol);
                    var P = (A2 = $.typeArguments) === null || A2 === void 0 ? void 0 : A2.map(X);
                    return e2.factory.createTypeReferenceNode(L, P);
                  }
                  return e2.visitEachChild($, X, e2.nullTransformationContext);
                }
              }
              C.tryGetAutoImportableReferenceFromTypeNode = q;
              function O(ee, he) {
                return ee.kind === 79 ? he : e2.factory.createQualifiedName(O(ee.left, he), ee.right);
              }
              function ve(ee, he) {
                he.forEach(function(F2) {
                  return ee.addImportFromExportedSymbol(F2, true);
                });
              }
              C.importSymbols = ve;
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(R, q, O, ve, ee, he) {
                var F2 = m2(R, q, O, ve);
                if (!(!F2 || e2.refactor.isRefactorErrorInfo(F2))) {
                  var x2 = e2.textChanges.ChangeTracker.fromContext(ee), X = F2.isStatic, $ = F2.isReadonly, A2 = F2.fieldName, y = F2.accessorName, V = F2.originalName, L = F2.type, P = F2.container, k = F2.declaration;
                  e2.suppressLeadingAndTrailingTrivia(A2), e2.suppressLeadingAndTrailingTrivia(y), e2.suppressLeadingAndTrailingTrivia(k), e2.suppressLeadingAndTrailingTrivia(P);
                  var Y, U;
                  if (e2.isClassLike(P)) {
                    var j = e2.getEffectiveModifierFlags(k);
                    if (e2.isSourceFileJS(R)) {
                      var H = e2.createModifiers(j);
                      Y = H, U = H;
                    } else
                      Y = e2.createModifiers(N(j)), U = e2.createModifiers(p(j));
                  }
                  K(x2, R, k, L, A2, U);
                  var I = G(A2, y, L, Y, X, P);
                  if (e2.suppressLeadingAndTrailingTrivia(I), b(x2, R, I, k, P), $) {
                    var l = e2.getFirstConstructorWithBody(P);
                    l && se(x2, R, l, A2.text, V);
                  } else {
                    var d = oe(A2, y, L, Y, X, P);
                    e2.suppressLeadingAndTrailingTrivia(d), b(x2, R, d, k, P);
                  }
                  return x2.getChanges();
                }
              }
              C.generateAccessorFromProperty = w;
              function B(R) {
                return e2.isIdentifier(R) || e2.isStringLiteral(R);
              }
              function E(R) {
                return e2.isParameterPropertyDeclaration(R, R.parent) || e2.isPropertyDeclaration(R) || e2.isPropertyAssignment(R);
              }
              function Q(R, q) {
                return e2.isIdentifier(q) ? e2.factory.createIdentifier(R) : e2.factory.createStringLiteral(R);
              }
              function le(R, q, O) {
                var ve = q ? O.name : e2.factory.createThis();
                return e2.isIdentifier(R) ? e2.factory.createPropertyAccessExpression(ve, R) : e2.factory.createElementAccessExpression(ve, e2.factory.createStringLiteralFromNode(R));
              }
              function N(R) {
                return R &= -65, R &= -9, R & 16 || (R |= 4), R;
              }
              function p(R) {
                return R &= -5, R &= -17, R |= 8, R;
              }
              function m2(R, q, O, ve, ee) {
                ee === void 0 && (ee = true);
                var he = e2.getTokenAtPosition(R, O), F2 = O === ve && ee, x2 = e2.findAncestor(he.parent, E), X = 124;
                if (!x2 || !(e2.nodeOverlapsWithStartEnd(x2.name, R, O, ve) || F2))
                  return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_property_for_which_to_generate_accessor) };
                if (!B(x2.name))
                  return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Name_is_not_valid) };
                if ((e2.getEffectiveModifierFlags(x2) | X) !== X)
                  return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Can_only_convert_property_with_modifier) };
                var $ = x2.name.text, A2 = e2.startsWithUnderscore($), y = Q(A2 ? $ : e2.getUniqueName("_".concat($), R), x2.name), V = Q(A2 ? e2.getUniqueName($.substring(1), R) : $, x2.name);
                return { isStatic: e2.hasStaticModifier(x2), isReadonly: e2.hasEffectiveReadonlyModifier(x2), type: J(x2, q), container: x2.kind === 164 ? x2.parent.parent : x2.parent, originalName: x2.name.text, declaration: x2, fieldName: y, accessorName: V, renameAccessor: A2 };
              }
              C.getAccessorConvertiblePropertyAtPosition = m2;
              function G(R, q, O, ve, ee, he) {
                return e2.factory.createGetAccessorDeclaration(void 0, ve, q, void 0, O, e2.factory.createBlock([e2.factory.createReturnStatement(le(R, ee, he))], true));
              }
              function oe(R, q, O, ve, ee, he) {
                return e2.factory.createSetAccessorDeclaration(void 0, ve, q, [e2.factory.createParameterDeclaration(void 0, void 0, void 0, e2.factory.createIdentifier("value"), void 0, O)], e2.factory.createBlock([e2.factory.createExpressionStatement(e2.factory.createAssignment(le(R, ee, he), e2.factory.createIdentifier("value")))], true));
              }
              function f4(R, q, O, ve, ee, he) {
                var F2 = e2.factory.updatePropertyDeclaration(O, O.decorators, he, ee, O.questionToken || O.exclamationToken, ve, O.initializer);
                R.replaceNode(q, O, F2);
              }
              function T(R, q, O, ve) {
                var ee = e2.factory.updatePropertyAssignment(O, ve, O.initializer);
                R.replacePropertyAssignment(q, O, ee);
              }
              function K(R, q, O, ve, ee, he) {
                e2.isPropertyDeclaration(O) ? f4(R, q, O, ve, ee, he) : e2.isPropertyAssignment(O) ? T(R, q, O, ee) : R.replaceNode(q, O, e2.factory.updateParameterDeclaration(O, O.decorators, he, O.dotDotDotToken, e2.cast(ee, e2.isIdentifier), O.questionToken, O.type, O.initializer));
              }
              function b(R, q, O, ve, ee) {
                e2.isParameterPropertyDeclaration(ve, ve.parent) ? R.insertMemberAtStart(q, ee, O) : e2.isPropertyAssignment(ve) ? R.insertNodeAfterComma(q, ve, O) : R.insertNodeAfter(q, ve, O);
              }
              function se(R, q, O, ve, ee) {
                !O.body || O.body.forEachChild(function he(F2) {
                  e2.isElementAccessExpression(F2) && F2.expression.kind === 108 && e2.isStringLiteral(F2.argumentExpression) && F2.argumentExpression.text === ee && e2.isWriteAccess(F2) && R.replaceNode(q, F2.argumentExpression, e2.factory.createStringLiteral(ve)), e2.isPropertyAccessExpression(F2) && F2.expression.kind === 108 && F2.name.text === ee && e2.isWriteAccess(F2) && R.replaceNode(q, F2.name, e2.factory.createIdentifier(ve)), !e2.isFunctionLike(F2) && !e2.isClassLike(F2) && F2.forEachChild(he);
                });
              }
              function J(R, q) {
                var O = e2.getTypeAnnotationNode(R);
                if (e2.isPropertyDeclaration(R) && O && R.questionToken) {
                  var ve = q.getTypeChecker(), ee = ve.getTypeFromTypeNode(O);
                  if (!ve.isTypeAssignableTo(ve.getUndefinedType(), ee)) {
                    var he = e2.isUnionTypeNode(O) ? O.types : [O];
                    return e2.factory.createUnionTypeNode(Ve(Ve([], he, true), [e2.factory.createKeywordTypeNode(153)], false));
                  }
                }
                return O;
              }
              function ie(R, q) {
                for (var O = []; R; ) {
                  var ve = e2.getClassExtendsHeritageElement(R), ee = ve && q.getSymbolAtLocation(ve.expression);
                  if (!ee)
                    break;
                  var he = ee.flags & 2097152 ? q.getAliasedSymbol(ee) : ee, F2 = he.declarations && e2.find(he.declarations, e2.isClassLike);
                  if (!F2)
                    break;
                  O.push(F2), R = F2;
                }
                return O;
              }
              C.getAllSupers = ie;
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "invalidImportSyntax";
              function B(p, m2) {
                var G = e2.getSourceFileOfNode(m2), oe = e2.getNamespaceDeclarationNode(m2), f4 = p.program.getCompilerOptions(), T = [];
                return T.push(E(p, G, m2, e2.makeImport(oe.name, void 0, m2.moduleSpecifier, e2.getQuotePreference(G, p.preferences)))), e2.getEmitModuleKind(f4) === e2.ModuleKind.CommonJS && T.push(E(p, G, m2, e2.factory.createImportEqualsDeclaration(void 0, void 0, false, oe.name, e2.factory.createExternalModuleReference(m2.moduleSpecifier)))), T;
              }
              function E(p, m2, G, oe) {
                var f4 = e2.textChanges.ChangeTracker.with(p, function(T) {
                  return T.replaceNode(m2, G, oe);
                });
                return C.createCodeFixActionWithoutFixAll(w, f4, [e2.Diagnostics.Replace_import_with_0, f4[0].textChanges[0].newText]);
              }
              C.registerCodeFix({ errorCodes: [e2.Diagnostics.This_expression_is_not_callable.code, e2.Diagnostics.This_expression_is_not_constructable.code], getCodeActions: Q });
              function Q(p) {
                var m2 = p.sourceFile, G = e2.Diagnostics.This_expression_is_not_callable.code === p.errorCode ? 208 : 209, oe = e2.findAncestor(e2.getTokenAtPosition(m2, p.span.start), function(T) {
                  return T.kind === G;
                });
                if (!oe)
                  return [];
                var f4 = oe.expression;
                return N(p, f4);
              }
              C.registerCodeFix({ errorCodes: [e2.Diagnostics.Argument_of_type_0_is_not_assignable_to_parameter_of_type_1.code, e2.Diagnostics.Type_0_does_not_satisfy_the_constraint_1.code, e2.Diagnostics.Type_0_is_not_assignable_to_type_1.code, e2.Diagnostics.Type_0_is_not_assignable_to_type_1_Two_different_types_with_this_name_exist_but_they_are_unrelated.code, e2.Diagnostics.Type_predicate_0_is_not_assignable_to_1.code, e2.Diagnostics.Property_0_of_type_1_is_not_assignable_to_2_index_type_3.code, e2.Diagnostics._0_index_type_1_is_not_assignable_to_2_index_type_3.code, e2.Diagnostics.Property_0_in_type_1_is_not_assignable_to_the_same_property_in_base_type_2.code, e2.Diagnostics.Property_0_in_type_1_is_not_assignable_to_type_2.code, e2.Diagnostics.Property_0_of_JSX_spread_attribute_is_not_assignable_to_target_property.code, e2.Diagnostics.The_this_context_of_type_0_is_not_assignable_to_method_s_this_of_type_1.code], getCodeActions: le });
              function le(p) {
                var m2 = p.sourceFile, G = e2.findAncestor(e2.getTokenAtPosition(m2, p.span.start), function(oe) {
                  return oe.getStart() === p.span.start && oe.getEnd() === p.span.start + p.span.length;
                });
                return G ? N(p, G) : [];
              }
              function N(p, m2) {
                var G = p.program.getTypeChecker().getTypeAtLocation(m2);
                if (!(G.symbol && G.symbol.originatingImport))
                  return [];
                var oe = [], f4 = G.symbol.originatingImport;
                if (e2.isImportCall(f4) || e2.addRange(oe, B(p, f4)), e2.isExpression(m2) && !(e2.isNamedDeclaration(m2.parent) && m2.parent.name === m2)) {
                  var T = p.sourceFile, K = e2.textChanges.ChangeTracker.with(p, function(b) {
                    return b.replaceNode(T, m2, e2.factory.createPropertyAccessExpression(m2, "default"), {});
                  });
                  oe.push(C.createCodeFixActionWithoutFixAll(w, K, e2.Diagnostics.Use_synthetic_default_member));
                }
                return oe;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "strictClassInitialization", B = "addMissingPropertyDefiniteAssignmentAssertions", E = "addMissingPropertyUndefinedType", Q = "addMissingPropertyInitializer", le = [e2.Diagnostics.Property_0_has_no_initializer_and_is_not_definitely_assigned_in_the_constructor.code];
              C.registerCodeFix({ errorCodes: le, getCodeActions: function(J) {
                var ie = N(J.sourceFile, J.span.start);
                if (!!ie) {
                  var R = [];
                  return e2.append(R, G(J, ie)), e2.append(R, p(J, ie)), e2.append(R, f4(J, ie)), R;
                }
              }, fixIds: [B, E, Q], getAllCodeActions: function(se) {
                return C.codeFixAll(se, le, function(J, ie) {
                  var R = N(ie.file, ie.start);
                  if (!!R)
                    switch (se.fixId) {
                      case B:
                        m2(J, ie.file, R.prop);
                        break;
                      case E:
                        oe(J, ie.file, R);
                        break;
                      case Q:
                        var q = se.program.getTypeChecker(), O = K(q, R.prop);
                        if (!O)
                          return;
                        T(J, ie.file, R.prop, O);
                        break;
                      default:
                        e2.Debug.fail(JSON.stringify(se.fixId));
                    }
                });
              } });
              function N(se, J) {
                var ie = e2.getTokenAtPosition(se, J);
                if (e2.isIdentifier(ie) && e2.isPropertyDeclaration(ie.parent)) {
                  var R = e2.getEffectiveTypeAnnotationNode(ie.parent);
                  if (R)
                    return { type: R, prop: ie.parent, isJs: e2.isInJSFile(ie.parent) };
                }
              }
              function p(se, J) {
                if (!J.isJs) {
                  var ie = e2.textChanges.ChangeTracker.with(se, function(R) {
                    return m2(R, se.sourceFile, J.prop);
                  });
                  return C.createCodeFixAction(w, ie, [e2.Diagnostics.Add_definite_assignment_assertion_to_property_0, J.prop.getText()], B, e2.Diagnostics.Add_definite_assignment_assertions_to_all_uninitialized_properties);
                }
              }
              function m2(se, J, ie) {
                e2.suppressLeadingAndTrailingTrivia(ie);
                var R = e2.factory.updatePropertyDeclaration(ie, ie.decorators, ie.modifiers, ie.name, e2.factory.createToken(53), ie.type, ie.initializer);
                se.replaceNode(J, ie, R);
              }
              function G(se, J) {
                var ie = e2.textChanges.ChangeTracker.with(se, function(R) {
                  return oe(R, se.sourceFile, J);
                });
                return C.createCodeFixAction(w, ie, [e2.Diagnostics.Add_undefined_type_to_property_0, J.prop.name.getText()], E, e2.Diagnostics.Add_undefined_type_to_all_uninitialized_properties);
              }
              function oe(se, J, ie) {
                var R = e2.factory.createKeywordTypeNode(153), q = e2.isUnionTypeNode(ie.type) ? ie.type.types.concat(R) : [ie.type, R], O = e2.factory.createUnionTypeNode(q);
                ie.isJs ? se.addJSDocTags(J, ie.prop, [e2.factory.createJSDocTypeTag(void 0, e2.factory.createJSDocTypeExpression(O))]) : se.replaceNode(J, ie.type, O);
              }
              function f4(se, J) {
                if (!J.isJs) {
                  var ie = se.program.getTypeChecker(), R = K(ie, J.prop);
                  if (!!R) {
                    var q = e2.textChanges.ChangeTracker.with(se, function(O) {
                      return T(O, se.sourceFile, J.prop, R);
                    });
                    return C.createCodeFixAction(w, q, [e2.Diagnostics.Add_initializer_to_property_0, J.prop.name.getText()], Q, e2.Diagnostics.Add_initializers_to_all_uninitialized_properties);
                  }
                }
              }
              function T(se, J, ie, R) {
                e2.suppressLeadingAndTrailingTrivia(ie);
                var q = e2.factory.updatePropertyDeclaration(ie, ie.decorators, ie.modifiers, ie.name, ie.questionToken, ie.type, R);
                se.replaceNode(J, ie, q);
              }
              function K(se, J) {
                return b(se, se.getTypeFromTypeNode(J.type));
              }
              function b(se, J) {
                if (J.flags & 512)
                  return J === se.getFalseType() || J === se.getFalseType(true) ? e2.factory.createFalse() : e2.factory.createTrue();
                if (J.isStringLiteral())
                  return e2.factory.createStringLiteral(J.value);
                if (J.isNumberLiteral())
                  return e2.factory.createNumericLiteral(J.value);
                if (J.flags & 2048)
                  return e2.factory.createBigIntLiteral(J.value);
                if (J.isUnion())
                  return e2.firstDefined(J.types, function(q) {
                    return b(se, q);
                  });
                if (J.isClass()) {
                  var ie = e2.getClassLikeDeclarationOfSymbol(J.symbol);
                  if (!ie || e2.hasSyntacticModifier(ie, 128))
                    return;
                  var R = e2.getFirstConstructorWithBody(ie);
                  return R && R.parameters.length ? void 0 : e2.factory.createNewExpression(e2.factory.createIdentifier(J.symbol.name), void 0, void 0);
                } else if (se.isArrayLikeType(J))
                  return e2.factory.createArrayLiteralExpression();
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "requireInTs", B = [e2.Diagnostics.require_call_may_be_converted_to_an_import.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = Q(N.sourceFile, N.program, N.span.start);
                if (!!p) {
                  var m2 = e2.textChanges.ChangeTracker.with(N, function(G) {
                    return E(G, N.sourceFile, p);
                  });
                  return [C.createCodeFixAction(w, m2, e2.Diagnostics.Convert_require_to_import, w, e2.Diagnostics.Convert_all_require_to_import)];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, B, function(p, m2) {
                  var G = Q(m2.file, N.program, m2.start);
                  G && E(p, N.sourceFile, G);
                });
              } });
              function E(N, p, m2) {
                var G = m2.allowSyntheticDefaults, oe = m2.defaultImportName, f4 = m2.namedImports, T = m2.statement, K = m2.required;
                N.replaceNode(p, T, oe && !G ? e2.factory.createImportEqualsDeclaration(void 0, void 0, false, oe, e2.factory.createExternalModuleReference(K)) : e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(false, oe, f4), K, void 0));
              }
              function Q(N, p, m2) {
                var G = e2.getTokenAtPosition(N, m2).parent;
                if (!e2.isRequireCall(G, true))
                  throw e2.Debug.failBadSyntaxKind(G);
                var oe = e2.cast(G.parent, e2.isVariableDeclaration), f4 = e2.tryCast(oe.name, e2.isIdentifier), T = e2.isObjectBindingPattern(oe.name) ? le(oe.name) : void 0;
                if (f4 || T)
                  return { allowSyntheticDefaults: e2.getAllowSyntheticDefaultImports(p.getCompilerOptions()), defaultImportName: f4, namedImports: T, statement: e2.cast(oe.parent.parent, e2.isVariableStatement), required: e2.first(G.arguments) };
              }
              function le(N) {
                for (var p = [], m2 = 0, G = N.elements; m2 < G.length; m2++) {
                  var oe = G[m2];
                  if (!e2.isIdentifier(oe.name) || oe.initializer)
                    return;
                  p.push(e2.factory.createImportSpecifier(false, e2.tryCast(oe.propertyName, e2.isIdentifier), oe.name));
                }
                if (p.length)
                  return e2.factory.createNamedImports(p);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "useDefaultImport", B = [e2.Diagnostics.Import_may_be_converted_to_a_default_import.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = le.sourceFile, p = le.span.start, m2 = E(N, p);
                if (!!m2) {
                  var G = e2.textChanges.ChangeTracker.with(le, function(oe) {
                    return Q(oe, N, m2, le.preferences);
                  });
                  return [C.createCodeFixAction(w, G, e2.Diagnostics.Convert_to_default_import, w, e2.Diagnostics.Convert_all_to_default_imports)];
                }
              }, fixIds: [w], getAllCodeActions: function(le) {
                return C.codeFixAll(le, B, function(N, p) {
                  var m2 = E(p.file, p.start);
                  m2 && Q(N, p.file, m2, le.preferences);
                });
              } });
              function E(le, N) {
                var p = e2.getTokenAtPosition(le, N);
                if (!!e2.isIdentifier(p)) {
                  var m2 = p.parent;
                  if (e2.isImportEqualsDeclaration(m2) && e2.isExternalModuleReference(m2.moduleReference))
                    return { importNode: m2, name: p, moduleSpecifier: m2.moduleReference.expression };
                  if (e2.isNamespaceImport(m2)) {
                    var G = m2.parent.parent;
                    return { importNode: G, name: p, moduleSpecifier: G.moduleSpecifier };
                  }
                }
              }
              function Q(le, N, p, m2) {
                le.replaceNode(N, p.importNode, e2.makeImport(p.name, void 0, p.moduleSpecifier, e2.getQuotePreference(N, m2)));
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "useBigintLiteral", B = [e2.Diagnostics.Numeric_literals_with_absolute_values_equal_to_2_53_or_greater_are_too_large_to_be_represented_accurately_as_integers.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e2.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span);
                });
                if (N.length > 0)
                  return [C.createCodeFixAction(w, N, e2.Diagnostics.Convert_to_a_bigint_numeric_literal, w, e2.Diagnostics.Convert_all_to_bigint_numeric_literals)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N);
                });
              } });
              function E(Q, le, N) {
                var p = e2.tryCast(e2.getTokenAtPosition(le, N.start), e2.isNumericLiteral);
                if (!!p) {
                  var m2 = p.getText(le) + "n";
                  Q.replaceNode(le, p, e2.factory.createBigIntLiteral(m2));
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixAddModuleReferTypeMissingTypeof", B = w, E = [e2.Diagnostics.Module_0_does_not_refer_to_a_type_but_is_used_as_a_type_here_Did_you_mean_typeof_import_0.code];
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(p) {
                var m2 = p.sourceFile, G = p.span, oe = Q(m2, G.start), f4 = e2.textChanges.ChangeTracker.with(p, function(T) {
                  return le(T, m2, oe);
                });
                return [C.createCodeFixAction(B, f4, e2.Diagnostics.Add_missing_typeof, B, e2.Diagnostics.Add_missing_typeof)];
              }, fixIds: [B], getAllCodeActions: function(N) {
                return C.codeFixAll(N, E, function(p, m2) {
                  return le(p, N.sourceFile, Q(m2.file, m2.start));
                });
              } });
              function Q(N, p) {
                var m2 = e2.getTokenAtPosition(N, p);
                return e2.Debug.assert(m2.kind === 100, "This token should be an ImportKeyword"), e2.Debug.assert(m2.parent.kind === 200, "Token parent should be an ImportType"), m2.parent;
              }
              function le(N, p, m2) {
                var G = e2.factory.updateImportTypeNode(m2, m2.argument, m2.qualifier, m2.typeArguments, true);
                N.replaceNode(p, m2, G);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "wrapJsxInFragment", B = [e2.Diagnostics.JSX_expressions_must_have_one_parent_element.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m2 = p.sourceFile, G = p.span, oe = E(m2, G.start);
                if (!!oe) {
                  var f4 = e2.textChanges.ChangeTracker.with(p, function(T) {
                    return Q(T, m2, oe);
                  });
                  return [C.createCodeFixAction(w, f4, e2.Diagnostics.Wrap_in_JSX_fragment, w, e2.Diagnostics.Wrap_all_unparented_JSX_in_JSX_fragment)];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, B, function(p, m2) {
                  var G = E(N.sourceFile, m2.start);
                  !G || Q(p, N.sourceFile, G);
                });
              } });
              function E(N, p) {
                var m2 = e2.getTokenAtPosition(N, p), G = m2.parent, oe = G.parent;
                if (!(!e2.isBinaryExpression(oe) && (oe = oe.parent, !e2.isBinaryExpression(oe))) && !!e2.nodeIsMissing(oe.operatorToken))
                  return oe;
              }
              function Q(N, p, m2) {
                var G = le(m2);
                G && N.replaceNode(p, m2, e2.factory.createJsxFragment(e2.factory.createJsxOpeningFragment(), G, e2.factory.createJsxJsxClosingFragment()));
              }
              function le(N) {
                for (var p = [], m2 = N; ; )
                  if (e2.isBinaryExpression(m2) && e2.nodeIsMissing(m2.operatorToken) && m2.operatorToken.kind === 27) {
                    if (p.push(m2.left), e2.isJsxChild(m2.right))
                      return p.push(m2.right), p;
                    if (e2.isBinaryExpression(m2.right)) {
                      m2 = m2.right;
                      continue;
                    } else
                      return;
                  } else
                    return;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixConvertToMappedObjectType", B = [e2.Diagnostics.An_index_signature_parameter_type_cannot_be_a_literal_type_or_generic_type_Consider_using_a_mapped_object_type_instead.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(p) {
                var m2 = p.sourceFile, G = p.span, oe = E(m2, G.start);
                if (!!oe) {
                  var f4 = e2.textChanges.ChangeTracker.with(p, function(K) {
                    return le(K, m2, oe);
                  }), T = e2.idText(oe.container.name);
                  return [C.createCodeFixAction(w, f4, [e2.Diagnostics.Convert_0_to_mapped_object_type, T], w, [e2.Diagnostics.Convert_0_to_mapped_object_type, T])];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, B, function(p, m2) {
                  var G = E(m2.file, m2.start);
                  G && le(p, m2.file, G);
                });
              } });
              function E(N, p) {
                var m2 = e2.getTokenAtPosition(N, p), G = e2.tryCast(m2.parent.parent, e2.isIndexSignatureDeclaration);
                if (!!G) {
                  var oe = e2.isInterfaceDeclaration(G.parent) ? G.parent : e2.tryCast(G.parent.parent, e2.isTypeAliasDeclaration);
                  if (!!oe)
                    return { indexSignature: G, container: oe };
                }
              }
              function Q(N, p) {
                return e2.factory.createTypeAliasDeclaration(N.decorators, N.modifiers, N.name, N.typeParameters, p);
              }
              function le(N, p, m2) {
                var G = m2.indexSignature, oe = m2.container, f4 = e2.isInterfaceDeclaration(oe) ? oe.members : oe.type.members, T = f4.filter(function(ie) {
                  return !e2.isIndexSignatureDeclaration(ie);
                }), K = e2.first(G.parameters), b = e2.factory.createTypeParameterDeclaration(void 0, e2.cast(K.name, e2.isIdentifier), K.type), se = e2.factory.createMappedTypeNode(e2.hasEffectiveReadonlyModifier(G) ? e2.factory.createModifier(145) : void 0, b, void 0, G.questionToken, G.type, void 0), J = e2.factory.createIntersectionTypeNode(Ve(Ve(Ve([], e2.getAllSuperTypeNodes(oe), true), [se], false), T.length ? [e2.factory.createTypeLiteralNode(T)] : e2.emptyArray, true));
                N.replaceNode(p, oe, Q(oe, J));
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "removeAccidentalCallParentheses", B = [e2.Diagnostics.This_expression_is_not_callable_because_it_is_a_get_accessor_Did_you_mean_to_use_it_without.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(E) {
                var Q = e2.findAncestor(e2.getTokenAtPosition(E.sourceFile, E.span.start), e2.isCallExpression);
                if (!!Q) {
                  var le = e2.textChanges.ChangeTracker.with(E, function(N) {
                    N.deleteRange(E.sourceFile, { pos: Q.expression.end, end: Q.end });
                  });
                  return [C.createCodeFixActionWithoutFixAll(w, le, e2.Diagnostics.Remove_parentheses)];
                }
              }, fixIds: [w] });
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "removeUnnecessaryAwait", B = [e2.Diagnostics.await_has_no_effect_on_the_type_of_this_expression.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(le) {
                var N = e2.textChanges.ChangeTracker.with(le, function(p) {
                  return E(p, le.sourceFile, le.span);
                });
                if (N.length > 0)
                  return [C.createCodeFixAction(w, N, e2.Diagnostics.Remove_unnecessary_await, w, e2.Diagnostics.Remove_all_unnecessary_uses_of_await)];
              }, fixIds: [w], getAllCodeActions: function(Q) {
                return C.codeFixAll(Q, B, function(le, N) {
                  return E(le, N.file, N);
                });
              } });
              function E(Q, le, N) {
                var p = e2.tryCast(e2.getTokenAtPosition(le, N.start), function(K) {
                  return K.kind === 132;
                }), m2 = p && e2.tryCast(p.parent, e2.isAwaitExpression);
                if (!!m2) {
                  var G = m2, oe = e2.isParenthesizedExpression(m2.parent);
                  if (oe) {
                    var f4 = e2.getLeftmostExpression(m2.expression, false);
                    if (e2.isIdentifier(f4)) {
                      var T = e2.findPrecedingToken(m2.parent.pos, le);
                      T && T.kind !== 103 && (G = m2.parent);
                    }
                  }
                  Q.replaceNode(le, G, m2.expression);
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = [e2.Diagnostics.A_type_only_import_can_specify_a_default_import_or_named_bindings_but_not_both.code], B = "splitTypeOnlyImport";
              C.registerCodeFix({ errorCodes: w, fixIds: [B], getCodeActions: function(N) {
                var p = e2.textChanges.ChangeTracker.with(N, function(m2) {
                  return Q(m2, E(N.sourceFile, N.span), N);
                });
                if (p.length)
                  return [C.createCodeFixAction(B, p, e2.Diagnostics.Split_into_two_separate_import_declarations, B, e2.Diagnostics.Split_all_invalid_type_only_imports)];
              }, getAllCodeActions: function(le) {
                return C.codeFixAll(le, w, function(N, p) {
                  Q(N, E(le.sourceFile, p), le);
                });
              } });
              function E(le, N) {
                return e2.findAncestor(e2.getTokenAtPosition(le, N.start), e2.isImportDeclaration);
              }
              function Q(le, N, p) {
                if (!!N) {
                  var m2 = e2.Debug.checkDefined(N.importClause);
                  le.replaceNode(p.sourceFile, N, e2.factory.updateImportDeclaration(N, N.decorators, N.modifiers, e2.factory.updateImportClause(m2, m2.isTypeOnly, m2.name, void 0), N.moduleSpecifier, N.assertClause)), le.insertNodeAfter(p.sourceFile, N, e2.factory.createImportDeclaration(void 0, void 0, e2.factory.updateImportClause(m2, m2.isTypeOnly, void 0, m2.namedBindings), N.moduleSpecifier, N.assertClause));
                }
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixConvertConstToLet", B = [e2.Diagnostics.Cannot_assign_to_0_because_it_is_a_constant.code];
              C.registerCodeFix({ errorCodes: B, getCodeActions: function(N) {
                var p = N.sourceFile, m2 = N.span, G = N.program, oe = E(p, m2.start, G);
                if (oe !== void 0) {
                  var f4 = e2.textChanges.ChangeTracker.with(N, function(T) {
                    return Q(T, p, oe);
                  });
                  return [C.createCodeFixAction(w, f4, e2.Diagnostics.Convert_const_to_let, w, e2.Diagnostics.Convert_const_to_let)];
                }
              }, fixIds: [w] });
              function E(le, N, p) {
                var m2, G = p.getTypeChecker(), oe = G.getSymbolAtLocation(e2.getTokenAtPosition(le, N)), f4 = e2.tryCast((m2 = oe == null ? void 0 : oe.valueDeclaration) === null || m2 === void 0 ? void 0 : m2.parent, e2.isVariableDeclarationList);
                if (f4 !== void 0) {
                  var T = e2.findChildOfKind(f4, 85, le);
                  if (T !== void 0)
                    return e2.createRange(T.pos, T.end);
                }
              }
              function Q(le, N, p) {
                le.replaceRangeWithText(N, p, "let");
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "fixExpectedComma", B = e2.Diagnostics._0_expected.code, E = [B];
              C.registerCodeFix({ errorCodes: E, getCodeActions: function(N) {
                var p = N.sourceFile, m2 = Q(p, N.span.start, N.errorCode);
                if (!!m2) {
                  var G = e2.textChanges.ChangeTracker.with(N, function(oe) {
                    return le(oe, p, m2);
                  });
                  return [C.createCodeFixAction(w, G, [e2.Diagnostics.Change_0_to_1, ";", ","], w, [e2.Diagnostics.Change_0_to_1, ";", ","])];
                }
              }, fixIds: [w], getAllCodeActions: function(N) {
                return C.codeFixAll(N, E, function(p, m2) {
                  var G = Q(m2.file, m2.start, m2.code);
                  G && le(p, N.sourceFile, G);
                });
              } });
              function Q(N, p, m2) {
                var G = e2.getTokenAtPosition(N, p);
                return G.kind === 26 && G.parent && (e2.isObjectLiteralExpression(G.parent) || e2.isArrayLiteralExpression(G.parent)) ? { node: G } : void 0;
              }
              function le(N, p, m2) {
                var G = m2.node, oe = e2.factory.createToken(27);
                N.replaceNode(p, G, oe);
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "addVoidToPromise", B = "addVoidToPromise", E = [e2.Diagnostics.Expected_1_argument_but_got_0_new_Promise_needs_a_JSDoc_hint_to_produce_a_resolve_that_can_be_called_without_arguments.code, e2.Diagnostics.Expected_0_arguments_but_got_1_Did_you_forget_to_include_void_in_your_type_argument_to_Promise.code];
              C.registerCodeFix({ errorCodes: E, fixIds: [B], getCodeActions: function(N) {
                var p = e2.textChanges.ChangeTracker.with(N, function(m2) {
                  return Q(m2, N.sourceFile, N.span, N.program);
                });
                if (p.length > 0)
                  return [C.createCodeFixAction(w, p, e2.Diagnostics.Add_void_to_Promise_resolved_without_a_value, B, e2.Diagnostics.Add_void_to_all_Promises_resolved_without_a_value)];
              }, getAllCodeActions: function(N) {
                return C.codeFixAll(N, E, function(p, m2) {
                  return Q(p, m2.file, m2, N.program, new e2.Set());
                });
              } });
              function Q(N, p, m2, G, oe) {
                var f4 = e2.getTokenAtPosition(p, m2.start);
                if (!(!e2.isIdentifier(f4) || !e2.isCallExpression(f4.parent) || f4.parent.expression !== f4 || f4.parent.arguments.length !== 0)) {
                  var T = G.getTypeChecker(), K = T.getSymbolAtLocation(f4), b = K == null ? void 0 : K.valueDeclaration;
                  if (!(!b || !e2.isParameter(b) || !e2.isNewExpression(b.parent.parent)) && !(oe != null && oe.has(b))) {
                    oe == null || oe.add(b);
                    var se = le(b.parent.parent);
                    if (e2.some(se)) {
                      var J = se[0], ie = !e2.isUnionTypeNode(J) && !e2.isParenthesizedTypeNode(J) && e2.isParenthesizedTypeNode(e2.factory.createUnionTypeNode([J, e2.factory.createKeywordTypeNode(114)]).types[0]);
                      ie && N.insertText(p, J.pos, "("), N.insertText(p, J.end, ie ? ") | void" : " | void");
                    } else {
                      var R = T.getResolvedSignature(f4.parent), q = R == null ? void 0 : R.parameters[0], O = q && T.getTypeOfSymbolAtLocation(q, b.parent.parent);
                      e2.isInJSFile(b) ? (!O || O.flags & 3) && (N.insertText(p, b.parent.parent.end, ")"), N.insertText(p, e2.skipTrivia(p.text, b.parent.parent.pos), "/** @type {Promise<void>} */(")) : (!O || O.flags & 2) && N.insertText(p, b.parent.parent.expression.end, "<void>");
                    }
                  }
                }
              }
              function le(N) {
                var p;
                if (e2.isInJSFile(N)) {
                  if (e2.isParenthesizedExpression(N.parent)) {
                    var m2 = (p = e2.getJSDocTypeTag(N.parent)) === null || p === void 0 ? void 0 : p.typeExpression.type;
                    if (m2 && e2.isTypeReferenceNode(m2) && e2.isIdentifier(m2.typeName) && e2.idText(m2.typeName) === "Promise")
                      return m2.typeArguments;
                  }
                } else
                  return N.typeArguments;
              }
            })(a = e2.codefix || (e2.codefix = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "Convert export", B = { name: "Convert default export to named export", description: e2.Diagnostics.Convert_default_export_to_named_export.message, kind: "refactor.rewrite.export.named" }, E = { name: "Convert named export to default export", description: e2.Diagnostics.Convert_named_export_to_default_export.message, kind: "refactor.rewrite.export.default" };
              C.registerRefactor(w, { kinds: [B.kind, E.kind], getAvailableActions: function(K) {
                var b = Q(K, K.triggerReason === "invoked");
                if (!b)
                  return e2.emptyArray;
                if (!C.isRefactorErrorInfo(b)) {
                  var se = b.wasDefault ? B : E;
                  return [{ name: w, description: se.description, actions: [se] }];
                }
                return K.preferences.provideRefactorNotApplicableReason ? [{ name: w, description: e2.Diagnostics.Convert_default_export_to_named_export.message, actions: [Ke(Ke({}, B), { notApplicableReason: b.error }), Ke(Ke({}, E), { notApplicableReason: b.error })] }] : e2.emptyArray;
              }, getEditsForAction: function(K, b) {
                e2.Debug.assert(b === B.name || b === E.name, "Unexpected action name");
                var se = Q(K);
                e2.Debug.assert(se && !C.isRefactorErrorInfo(se), "Expected applicable refactor info");
                var J = e2.textChanges.ChangeTracker.with(K, function(ie) {
                  return le(K.file, K.program, se, ie, K.cancellationToken);
                });
                return { edits: J, renameFilename: void 0, renameLocation: void 0 };
              } });
              function Q(T, K) {
                K === void 0 && (K = true);
                var b = T.file, se = T.program, J = e2.getRefactorContextSpan(T), ie = e2.getTokenAtPosition(b, J.start), R = !!(ie.parent && e2.getSyntacticModifierFlags(ie.parent) & 1) && K ? ie.parent : e2.getParentNodeInSpan(ie, b, J);
                if (!R || !e2.isSourceFile(R.parent) && !(e2.isModuleBlock(R.parent) && e2.isAmbientModule(R.parent.parent)))
                  return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_export_statement) };
                var q = e2.isSourceFile(R.parent) ? R.parent.symbol : R.parent.parent.symbol, O = e2.getSyntacticModifierFlags(R) || (e2.isExportAssignment(R) && !R.isExportEquals ? 513 : 0), ve = !!(O & 512);
                if (!(O & 1) || !ve && q.exports.has("default"))
                  return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.This_file_already_has_a_default_export) };
                var ee = se.getTypeChecker(), he = function($) {
                  return e2.isIdentifier($) && ee.getSymbolAtLocation($) ? void 0 : { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Can_only_convert_named_export) };
                };
                switch (R.kind) {
                  case 256:
                  case 257:
                  case 258:
                  case 260:
                  case 259:
                  case 261: {
                    var F2 = R;
                    return F2.name ? he(F2.name) || { exportNode: F2, exportName: F2.name, wasDefault: ve, exportingModuleSymbol: q } : void 0;
                  }
                  case 237: {
                    var x2 = R;
                    if (!(x2.declarationList.flags & 2) || x2.declarationList.declarations.length !== 1)
                      return;
                    var X = e2.first(x2.declarationList.declarations);
                    return X.initializer ? (e2.Debug.assert(!ve, "Can't have a default flag here"), he(X.name) || { exportNode: x2, exportName: X.name, wasDefault: ve, exportingModuleSymbol: q }) : void 0;
                  }
                  case 271: {
                    var F2 = R;
                    return F2.isExportEquals ? void 0 : he(F2.expression) || { exportNode: F2, exportName: F2.expression, wasDefault: ve, exportingModuleSymbol: q };
                  }
                  default:
                    return;
                }
              }
              function le(T, K, b, se, J) {
                N(T, b, se, K.getTypeChecker()), p(K, b, se, J);
              }
              function N(T, K, b, se) {
                var J = K.wasDefault, ie = K.exportNode, R = K.exportName;
                if (J)
                  if (e2.isExportAssignment(ie) && !ie.isExportEquals) {
                    var q = ie.expression, O = f4(q.text, q.text);
                    b.replaceNode(T, ie, e2.factory.createExportDeclaration(void 0, void 0, false, e2.factory.createNamedExports([O])));
                  } else
                    b.delete(T, e2.Debug.checkDefined(e2.findModifier(ie, 88), "Should find a default keyword in modifier list"));
                else {
                  var ve = e2.Debug.checkDefined(e2.findModifier(ie, 93), "Should find an export keyword in modifier list");
                  switch (ie.kind) {
                    case 256:
                    case 257:
                    case 258:
                      b.insertNodeAfter(T, ve, e2.factory.createToken(88));
                      break;
                    case 237:
                      var ee = e2.first(ie.declarationList.declarations);
                      if (!e2.FindAllReferences.Core.isSymbolReferencedInFile(R, se, T) && !ee.type) {
                        b.replaceNode(T, ie, e2.factory.createExportDefault(e2.Debug.checkDefined(ee.initializer, "Initializer was previously known to be present")));
                        break;
                      }
                    case 260:
                    case 259:
                    case 261:
                      b.deleteModifier(T, ve), b.insertNodeAfter(T, ie, e2.factory.createExportDefault(e2.factory.createIdentifier(R.text)));
                      break;
                    default:
                      e2.Debug.fail("Unexpected exportNode kind ".concat(ie.kind));
                  }
                }
              }
              function p(T, K, b, se) {
                var J = K.wasDefault, ie = K.exportName, R = K.exportingModuleSymbol, q = T.getTypeChecker(), O = e2.Debug.checkDefined(q.getSymbolAtLocation(ie), "Export name should resolve to a symbol");
                e2.FindAllReferences.Core.eachExportReference(T.getSourceFiles(), q, se, O, R, ie.text, J, function(ve) {
                  var ee = ve.getSourceFile();
                  J ? m2(ee, ve, b, ie.text) : G(ee, ve, b);
                });
              }
              function m2(T, K, b, se) {
                var J = K.parent;
                switch (J.kind) {
                  case 206:
                    b.replaceNode(T, K, e2.factory.createIdentifier(se));
                    break;
                  case 270:
                  case 275: {
                    var ie = J;
                    b.replaceNode(T, ie, oe(se, ie.name.text));
                    break;
                  }
                  case 267: {
                    var R = J;
                    e2.Debug.assert(R.name === K, "Import clause name should match provided ref");
                    var ie = oe(se, K.text), q = R.namedBindings;
                    if (!q)
                      b.replaceNode(T, K, e2.factory.createNamedImports([ie]));
                    else if (q.kind === 268) {
                      b.deleteRange(T, { pos: K.getStart(T), end: q.getStart(T) });
                      var O = e2.isStringLiteral(R.parent.moduleSpecifier) ? e2.quotePreferenceFromString(R.parent.moduleSpecifier, T) : 1, ve = e2.makeImport(void 0, [oe(se, K.text)], R.parent.moduleSpecifier, O);
                      b.insertNodeAfter(T, R.parent, ve);
                    } else
                      b.delete(T, K), b.insertNodeAtEndOfList(T, q.elements, ie);
                    break;
                  }
                  case 200:
                    var ee = J;
                    b.replaceNode(T, J, e2.factory.createImportTypeNode(ee.argument, e2.factory.createIdentifier(se), ee.typeArguments, ee.isTypeOf));
                    break;
                  default:
                    e2.Debug.failBadSyntaxKind(J);
                }
              }
              function G(T, K, b) {
                var se = K.parent;
                switch (se.kind) {
                  case 206:
                    b.replaceNode(T, K, e2.factory.createIdentifier("default"));
                    break;
                  case 270: {
                    var J = e2.factory.createIdentifier(se.name.text);
                    se.parent.elements.length === 1 ? b.replaceNode(T, se.parent, J) : (b.delete(T, se), b.insertNodeBefore(T, se.parent, J));
                    break;
                  }
                  case 275: {
                    b.replaceNode(T, se, f4("default", se.name.text));
                    break;
                  }
                  default:
                    e2.Debug.assertNever(se, "Unexpected parent kind ".concat(se.kind));
                }
              }
              function oe(T, K) {
                return e2.factory.createImportSpecifier(false, T === K ? void 0 : e2.factory.createIdentifier(T), e2.factory.createIdentifier(K));
              }
              function f4(T, K) {
                return e2.factory.createExportSpecifier(false, T === K ? void 0 : e2.factory.createIdentifier(T), e2.factory.createIdentifier(K));
              }
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w, B = "Convert import", E = (w = {}, w[0] = { name: "Convert namespace import to named imports", description: e2.Diagnostics.Convert_namespace_import_to_named_imports.message, kind: "refactor.rewrite.import.named" }, w[2] = { name: "Convert named imports to namespace import", description: e2.Diagnostics.Convert_named_imports_to_namespace_import.message, kind: "refactor.rewrite.import.namespace" }, w[1] = { name: "Convert named imports to default import", description: e2.Diagnostics.Convert_named_imports_to_default_import.message, kind: "refactor.rewrite.import.default" }, w);
              C.registerRefactor(B, { kinds: e2.getOwnValues(E).map(function(K) {
                return K.kind;
              }), getAvailableActions: function(b) {
                var se = Q(b, b.triggerReason === "invoked");
                if (!se)
                  return e2.emptyArray;
                if (!C.isRefactorErrorInfo(se)) {
                  var J = E[se.convertTo];
                  return [{ name: B, description: J.description, actions: [J] }];
                }
                return b.preferences.provideRefactorNotApplicableReason ? e2.getOwnValues(E).map(function(ie) {
                  return { name: B, description: ie.description, actions: [Ke(Ke({}, ie), { notApplicableReason: se.error })] };
                }) : e2.emptyArray;
              }, getEditsForAction: function(b, se) {
                e2.Debug.assert(e2.some(e2.getOwnValues(E), function(R) {
                  return R.name === se;
                }), "Unexpected action name");
                var J = Q(b);
                e2.Debug.assert(J && !C.isRefactorErrorInfo(J), "Expected applicable refactor info");
                var ie = e2.textChanges.ChangeTracker.with(b, function(R) {
                  return N(b.file, b.program, R, J);
                });
                return { edits: ie, renameFilename: void 0, renameLocation: void 0 };
              } });
              function Q(K, b) {
                b === void 0 && (b = true);
                var se = K.file, J = e2.getRefactorContextSpan(K), ie = e2.getTokenAtPosition(se, J.start), R = b ? e2.findAncestor(ie, e2.isImportDeclaration) : e2.getParentNodeInSpan(ie, se, J);
                if (!R || !e2.isImportDeclaration(R))
                  return { error: "Selection is not an import declaration." };
                var q = J.start + J.length, O = e2.findNextToken(R, R.parent, se);
                if (!(O && q > O.getStart())) {
                  var ve = R.importClause;
                  if (!ve)
                    return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_import_clause) };
                  if (!ve.namedBindings)
                    return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_namespace_import_or_named_imports) };
                  if (ve.namedBindings.kind === 268)
                    return { convertTo: 0, import: ve.namedBindings };
                  var ee = le(K.program, ve);
                  return ee ? { convertTo: 1, import: ve.namedBindings } : { convertTo: 2, import: ve.namedBindings };
                }
              }
              function le(K, b) {
                return e2.getAllowSyntheticDefaultImports(K.getCompilerOptions()) && f4(b.parent.moduleSpecifier, K.getTypeChecker());
              }
              function N(K, b, se, J) {
                var ie = b.getTypeChecker();
                J.convertTo === 0 ? p(K, ie, se, J.import, e2.getAllowSyntheticDefaultImports(b.getCompilerOptions())) : oe(K, b, se, J.import, J.convertTo === 1);
              }
              function p(K, b, se, J, ie) {
                var R = false, q = [], O = new e2.Map();
                e2.FindAllReferences.Core.eachSymbolReferenceInFile(J.name, b, K, function(y) {
                  if (!e2.isPropertyAccessOrQualifiedName(y.parent))
                    R = true;
                  else {
                    var V = m2(y.parent).text;
                    b.resolveName(V, y, 67108863, true) && O.set(V, true), e2.Debug.assert(G(y.parent) === y, "Parent expression should match id"), q.push(y.parent);
                  }
                });
                for (var ve = new e2.Map(), ee = 0, he = q; ee < he.length; ee++) {
                  var F2 = he[ee], x2 = m2(F2).text, X = ve.get(x2);
                  X === void 0 && ve.set(x2, X = O.has(x2) ? e2.getUniqueName(x2, K) : x2), se.replaceNode(K, F2, e2.factory.createIdentifier(X));
                }
                var $ = [];
                ve.forEach(function(y, V) {
                  $.push(e2.factory.createImportSpecifier(false, y === V ? void 0 : e2.factory.createIdentifier(V), e2.factory.createIdentifier(y)));
                });
                var A2 = J.parent.parent;
                R && !ie ? se.insertNodeAfter(K, A2, T(A2, void 0, $)) : se.replaceNode(K, A2, T(A2, R ? e2.factory.createIdentifier(J.name.text) : void 0, $));
              }
              function m2(K) {
                return e2.isPropertyAccessExpression(K) ? K.name : K.right;
              }
              function G(K) {
                return e2.isPropertyAccessExpression(K) ? K.expression : K.left;
              }
              function oe(K, b, se, J, ie) {
                ie === void 0 && (ie = le(b, J.parent));
                var R = b.getTypeChecker(), q = J.parent.parent, O = q.moduleSpecifier, ve = new e2.Set();
                J.elements.forEach(function(P) {
                  var k = R.getSymbolAtLocation(P.name);
                  k && ve.add(k);
                });
                var ee = O && e2.isStringLiteral(O) ? e2.codefix.moduleSpecifierToValidIdentifier(O.text, 99) : "module";
                function he(P) {
                  return !!e2.FindAllReferences.Core.eachSymbolReferenceInFile(P.name, R, K, function(k) {
                    var Y = R.resolveName(ee, k, 67108863, true);
                    return Y ? ve.has(Y) ? e2.isExportSpecifier(k.parent) : true : false;
                  });
                }
                for (var F2 = J.elements.some(he), x2 = F2 ? e2.getUniqueName(ee, K) : ee, X = new e2.Set(), $ = function(P) {
                  var k = (P.propertyName || P.name).text;
                  e2.FindAllReferences.Core.eachSymbolReferenceInFile(P.name, R, K, function(Y) {
                    var U = e2.factory.createPropertyAccessExpression(e2.factory.createIdentifier(x2), k);
                    e2.isShorthandPropertyAssignment(Y.parent) ? se.replaceNode(K, Y.parent, e2.factory.createPropertyAssignment(Y.text, U)) : e2.isExportSpecifier(Y.parent) ? X.add(P) : se.replaceNode(K, Y, U);
                  });
                }, A2 = 0, y = J.elements; A2 < y.length; A2++) {
                  var V = y[A2];
                  $(V);
                }
                if (se.replaceNode(K, J, ie ? e2.factory.createIdentifier(x2) : e2.factory.createNamespaceImport(e2.factory.createIdentifier(x2))), X.size) {
                  var L = e2.arrayFrom(X.values()).map(function(P) {
                    return e2.factory.createImportSpecifier(P.isTypeOnly, P.propertyName && e2.factory.createIdentifier(P.propertyName.text), e2.factory.createIdentifier(P.name.text));
                  });
                  se.insertNodeAfter(K, J.parent.parent, T(q, void 0, L));
                }
              }
              C.doChangeNamedToNamespaceOrDefault = oe;
              function f4(K, b) {
                var se = b.resolveExternalModuleName(K);
                if (!se)
                  return false;
                var J = b.resolveExternalModuleSymbol(se);
                return se !== J;
              }
              function T(K, b, se) {
                return e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(false, b, se && se.length ? e2.factory.createNamedImports(se) : void 0), K.moduleSpecifier, void 0);
              }
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert to optional chain expression", Q = e2.getLocaleSpecificMessage(e2.Diagnostics.Convert_to_optional_chain_expression), le = { name: E, description: Q, kind: "refactor.rewrite.expression.optionalChain" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: p, getAvailableActions: N });
                function N(F2) {
                  var x2 = f4(F2, F2.triggerReason === "invoked");
                  return x2 ? C.isRefactorErrorInfo(x2) ? F2.preferences.provideRefactorNotApplicableReason ? [{ name: E, description: Q, actions: [Ke(Ke({}, le), { notApplicableReason: x2.error })] }] : e2.emptyArray : [{ name: E, description: Q, actions: [le] }] : e2.emptyArray;
                }
                function p(F2, x2) {
                  var X = f4(F2);
                  e2.Debug.assert(X && !C.isRefactorErrorInfo(X), "Expected applicable refactor info");
                  var $ = e2.textChanges.ChangeTracker.with(F2, function(A2) {
                    return he(F2.file, F2.program.getTypeChecker(), A2, X, x2);
                  });
                  return { edits: $, renameFilename: void 0, renameLocation: void 0 };
                }
                function m2(F2) {
                  return e2.isBinaryExpression(F2) || e2.isConditionalExpression(F2);
                }
                function G(F2) {
                  return e2.isExpressionStatement(F2) || e2.isReturnStatement(F2) || e2.isVariableStatement(F2);
                }
                function oe(F2) {
                  return m2(F2) || G(F2);
                }
                function f4(F2, x2) {
                  x2 === void 0 && (x2 = true);
                  var X = F2.file, $ = F2.program, A2 = e2.getRefactorContextSpan(F2), y = A2.length === 0;
                  if (!(y && !x2)) {
                    var V = e2.getTokenAtPosition(X, A2.start), L = e2.findTokenOnLeftOfPosition(X, A2.start + A2.length), P = e2.createTextSpanFromBounds(V.pos, L && L.end >= V.pos ? L.getEnd() : V.getEnd()), k = y ? q(V) : R(V, P), Y = k && oe(k) ? O(k) : void 0;
                    if (!Y)
                      return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_convertible_access_expression) };
                    var U = $.getTypeChecker();
                    return e2.isConditionalExpression(Y) ? T(Y, U) : K(Y);
                  }
                }
                function T(F2, x2) {
                  var X = F2.condition, $ = ve(F2.whenTrue);
                  if (!$ || x2.isNullableType(x2.getTypeAtLocation($)))
                    return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_convertible_access_expression) };
                  if ((e2.isPropertyAccessExpression(X) || e2.isIdentifier(X)) && se(X, $.expression))
                    return { finalExpression: $, occurrences: [X], expression: F2 };
                  if (e2.isBinaryExpression(X)) {
                    var A2 = b($.expression, X);
                    return A2 ? { finalExpression: $, occurrences: A2, expression: F2 } : { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_matching_access_expressions) };
                  }
                }
                function K(F2) {
                  if (F2.operatorToken.kind !== 55)
                    return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Can_only_convert_logical_AND_access_chains) };
                  var x2 = ve(F2.right);
                  if (!x2)
                    return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_convertible_access_expression) };
                  var X = b(x2.expression, F2.left);
                  return X ? { finalExpression: x2, occurrences: X, expression: F2 } : { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_matching_access_expressions) };
                }
                function b(F2, x2) {
                  for (var X = []; e2.isBinaryExpression(x2) && x2.operatorToken.kind === 55; ) {
                    var $ = se(e2.skipParentheses(F2), e2.skipParentheses(x2.right));
                    if (!$)
                      break;
                    X.push($), F2 = $, x2 = x2.left;
                  }
                  var A2 = se(F2, x2);
                  return A2 && X.push(A2), X.length > 0 ? X : void 0;
                }
                function se(F2, x2) {
                  if (!(!e2.isIdentifier(x2) && !e2.isPropertyAccessExpression(x2) && !e2.isElementAccessExpression(x2)))
                    return J(F2, x2) ? x2 : void 0;
                }
                function J(F2, x2) {
                  for (; (e2.isCallExpression(F2) || e2.isPropertyAccessExpression(F2) || e2.isElementAccessExpression(F2)) && ie(F2) !== ie(x2); )
                    F2 = F2.expression;
                  for (; e2.isPropertyAccessExpression(F2) && e2.isPropertyAccessExpression(x2) || e2.isElementAccessExpression(F2) && e2.isElementAccessExpression(x2); ) {
                    if (ie(F2) !== ie(x2))
                      return false;
                    F2 = F2.expression, x2 = x2.expression;
                  }
                  return e2.isIdentifier(F2) && e2.isIdentifier(x2) && F2.getText() === x2.getText();
                }
                function ie(F2) {
                  if (e2.isIdentifier(F2) || e2.isStringOrNumericLiteralLike(F2))
                    return F2.getText();
                  if (e2.isPropertyAccessExpression(F2))
                    return ie(F2.name);
                  if (e2.isElementAccessExpression(F2))
                    return ie(F2.argumentExpression);
                }
                function R(F2, x2) {
                  for (; F2.parent; ) {
                    if (oe(F2) && x2.length !== 0 && F2.end >= x2.start + x2.length)
                      return F2;
                    F2 = F2.parent;
                  }
                }
                function q(F2) {
                  for (; F2.parent; ) {
                    if (oe(F2) && !oe(F2.parent))
                      return F2;
                    F2 = F2.parent;
                  }
                }
                function O(F2) {
                  if (m2(F2))
                    return F2;
                  if (e2.isVariableStatement(F2)) {
                    var x2 = e2.getSingleVariableOfVariableStatement(F2), X = x2 == null ? void 0 : x2.initializer;
                    return X && m2(X) ? X : void 0;
                  }
                  return F2.expression && m2(F2.expression) ? F2.expression : void 0;
                }
                function ve(F2) {
                  if (F2 = e2.skipParentheses(F2), e2.isBinaryExpression(F2))
                    return ve(F2.left);
                  if ((e2.isPropertyAccessExpression(F2) || e2.isElementAccessExpression(F2) || e2.isCallExpression(F2)) && !e2.isOptionalChain(F2))
                    return F2;
                }
                function ee(F2, x2, X) {
                  if (e2.isPropertyAccessExpression(x2) || e2.isElementAccessExpression(x2) || e2.isCallExpression(x2)) {
                    var $ = ee(F2, x2.expression, X), A2 = X.length > 0 ? X[X.length - 1] : void 0, y = (A2 == null ? void 0 : A2.getText()) === x2.expression.getText();
                    if (y && X.pop(), e2.isCallExpression(x2))
                      return y ? e2.factory.createCallChain($, e2.factory.createToken(28), x2.typeArguments, x2.arguments) : e2.factory.createCallChain($, x2.questionDotToken, x2.typeArguments, x2.arguments);
                    if (e2.isPropertyAccessExpression(x2))
                      return y ? e2.factory.createPropertyAccessChain($, e2.factory.createToken(28), x2.name) : e2.factory.createPropertyAccessChain($, x2.questionDotToken, x2.name);
                    if (e2.isElementAccessExpression(x2))
                      return y ? e2.factory.createElementAccessChain($, e2.factory.createToken(28), x2.argumentExpression) : e2.factory.createElementAccessChain($, x2.questionDotToken, x2.argumentExpression);
                  }
                  return x2;
                }
                function he(F2, x2, X, $, A2) {
                  var y = $.finalExpression, V = $.occurrences, L = $.expression, P = V[V.length - 1], k = ee(x2, y, V);
                  k && (e2.isPropertyAccessExpression(k) || e2.isElementAccessExpression(k) || e2.isCallExpression(k)) && (e2.isBinaryExpression(L) ? X.replaceNodeRange(F2, P, y, k) : e2.isConditionalExpression(L) && X.replaceNode(F2, L, e2.factory.createBinaryExpression(k, e2.factory.createToken(60), L.whenFalse)));
                }
              })(w = C.convertToOptionalChainExpression || (C.convertToOptionalChainExpression = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert overload list to single signature", Q = e2.Diagnostics.Convert_overload_list_to_single_signature.message, le = { name: E, description: Q, kind: "refactor.rewrite.function.overloadList" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: p, getAvailableActions: N });
                function N(oe) {
                  var f4 = oe.file, T = oe.startPosition, K = oe.program, b = G(f4, T, K);
                  return b ? [{ name: E, description: Q, actions: [le] }] : e2.emptyArray;
                }
                function p(oe) {
                  var f4 = oe.file, T = oe.startPosition, K = oe.program, b = G(f4, T, K);
                  if (!b)
                    return;
                  var se = K.getTypeChecker(), J = b[b.length - 1], ie = J;
                  switch (J.kind) {
                    case 168: {
                      ie = e2.factory.updateMethodSignature(J, J.modifiers, J.name, J.questionToken, J.typeParameters, q(b), J.type);
                      break;
                    }
                    case 169: {
                      ie = e2.factory.updateMethodDeclaration(J, J.decorators, J.modifiers, J.asteriskToken, J.name, J.questionToken, J.typeParameters, q(b), J.type, J.body);
                      break;
                    }
                    case 174: {
                      ie = e2.factory.updateCallSignature(J, J.typeParameters, q(b), J.type);
                      break;
                    }
                    case 171: {
                      ie = e2.factory.updateConstructorDeclaration(J, J.decorators, J.modifiers, q(b), J.body);
                      break;
                    }
                    case 175: {
                      ie = e2.factory.updateConstructSignature(J, J.typeParameters, q(b), J.type);
                      break;
                    }
                    case 256: {
                      ie = e2.factory.updateFunctionDeclaration(J, J.decorators, J.modifiers, J.asteriskToken, J.name, J.typeParameters, q(b), J.type, J.body);
                      break;
                    }
                    default:
                      return e2.Debug.failBadSyntaxKind(J, "Unhandled signature kind in overload list conversion refactoring");
                  }
                  if (ie === J)
                    return;
                  var R = e2.textChanges.ChangeTracker.with(oe, function(ee) {
                    ee.replaceNodeRange(f4, b[0], b[b.length - 1], ie);
                  });
                  return { renameFilename: void 0, renameLocation: void 0, edits: R };
                  function q(ee) {
                    var he = ee[ee.length - 1];
                    return e2.isFunctionLikeDeclaration(he) && he.body && (ee = ee.slice(0, ee.length - 1)), e2.factory.createNodeArray([e2.factory.createParameterDeclaration(void 0, void 0, e2.factory.createToken(25), "args", void 0, e2.factory.createUnionTypeNode(e2.map(ee, O)))]);
                  }
                  function O(ee) {
                    var he = e2.map(ee.parameters, ve);
                    return e2.setEmitFlags(e2.factory.createTupleTypeNode(he), e2.some(he, function(F2) {
                      return !!e2.length(e2.getSyntheticLeadingComments(F2));
                    }) ? 0 : 1);
                  }
                  function ve(ee) {
                    e2.Debug.assert(e2.isIdentifier(ee.name));
                    var he = e2.setTextRange(e2.factory.createNamedTupleMember(ee.dotDotDotToken, ee.name, ee.questionToken, ee.type || e2.factory.createKeywordTypeNode(130)), ee), F2 = ee.symbol && ee.symbol.getDocumentationComment(se);
                    if (F2) {
                      var x2 = e2.displayPartsToString(F2);
                      x2.length && e2.setSyntheticLeadingComments(he, [{ text: `*
`.concat(x2.split(`
`).map(function(X) {
                        return " * ".concat(X);
                      }).join(`
`), `
 `), kind: 3, pos: -1, end: -1, hasTrailingNewLine: true, hasLeadingNewline: true }]);
                    }
                    return he;
                  }
                }
                function m2(oe) {
                  switch (oe.kind) {
                    case 168:
                    case 169:
                    case 174:
                    case 171:
                    case 175:
                    case 256:
                      return true;
                  }
                  return false;
                }
                function G(oe, f4, T) {
                  var K = e2.getTokenAtPosition(oe, f4), b = e2.findAncestor(K, m2);
                  if (!!b) {
                    var se = T.getTypeChecker(), J = b.symbol;
                    if (!!J) {
                      var ie = J.declarations;
                      if (!(e2.length(ie) <= 1) && !!e2.every(ie, function(ee) {
                        return e2.getSourceFileOfNode(ee) === oe;
                      }) && !!m2(ie[0])) {
                        var R = ie[0].kind;
                        if (!!e2.every(ie, function(ee) {
                          return ee.kind === R;
                        })) {
                          var q = ie;
                          if (!e2.some(q, function(ee) {
                            return !!ee.typeParameters || e2.some(ee.parameters, function(he) {
                              return !!he.decorators || !!he.modifiers || !e2.isIdentifier(he.name);
                            });
                          })) {
                            var O = e2.mapDefined(q, function(ee) {
                              return se.getSignatureFromDeclaration(ee);
                            });
                            if (e2.length(O) === e2.length(ie)) {
                              var ve = se.getReturnTypeOfSignature(O[0]);
                              if (!!e2.every(O, function(ee) {
                                return se.getReturnTypeOfSignature(ee) === ve;
                              }))
                                return q;
                            }
                          }
                        }
                      }
                    }
                  }
                }
              })(w = C.addOrRemoveBracesToArrowFunction || (C.addOrRemoveBracesToArrowFunction = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Extract Symbol", Q = { name: "Extract Constant", description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_constant), kind: "refactor.extract.constant" }, le = { name: "Extract Function", description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_function), kind: "refactor.extract.function" };
                C.registerRefactor(E, { kinds: [Q.kind, le.kind], getEditsForAction: p, getAvailableActions: N });
                function N(Fe) {
                  var Z2 = Fe.kind, Be = oe(Fe.file, e2.getRefactorContextSpan(Fe), Fe.triggerReason === "invoked"), ge = Be.targetRange;
                  if (ge === void 0) {
                    if (!Be.errors || Be.errors.length === 0 || !Fe.preferences.provideRefactorNotApplicableReason)
                      return e2.emptyArray;
                    var Re = [];
                    return C.refactorKindBeginsWith(le.kind, Z2) && Re.push({ name: E, description: le.description, actions: [Ke(Ke({}, le), { notApplicableReason: Ne(Be.errors) })] }), C.refactorKindBeginsWith(Q.kind, Z2) && Re.push({ name: E, description: Q.description, actions: [Ke(Ke({}, Q), { notApplicableReason: Ne(Be.errors) })] }), Re;
                  }
                  var ze = ie(ge, Fe);
                  if (ze === void 0)
                    return e2.emptyArray;
                  for (var Ee = [], He = new e2.Map(), rr, Ie = [], _e = new e2.Map(), we, de = 0, ye = 0, Ae = ze; ye < Ae.length; ye++) {
                    var er = Ae[ye], ir = er.functionExtraction, Cr = er.constantExtraction, Ye = ir.description;
                    if (C.refactorKindBeginsWith(le.kind, Z2) && (ir.errors.length === 0 ? He.has(Ye) || (He.set(Ye, true), Ee.push({ description: Ye, name: "function_scope_".concat(de), kind: le.kind })) : rr || (rr = { description: Ye, name: "function_scope_".concat(de), notApplicableReason: Ne(ir.errors), kind: le.kind })), C.refactorKindBeginsWith(Q.kind, Z2))
                      if (Cr.errors.length === 0) {
                        var Br = Cr.description;
                        _e.has(Br) || (_e.set(Br, true), Ie.push({ description: Br, name: "constant_scope_".concat(de), kind: Q.kind }));
                      } else
                        we || (we = { description: Ye, name: "constant_scope_".concat(de), notApplicableReason: Ne(Cr.errors), kind: Q.kind });
                    de++;
                  }
                  var Er = [];
                  return Ee.length ? Er.push({ name: E, description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_function), actions: Ee }) : Fe.preferences.provideRefactorNotApplicableReason && rr && Er.push({ name: E, description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_function), actions: [rr] }), Ie.length ? Er.push({ name: E, description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_constant), actions: Ie }) : Fe.preferences.provideRefactorNotApplicableReason && we && Er.push({ name: E, description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_constant), actions: [we] }), Er.length ? Er : e2.emptyArray;
                  function Ne(n) {
                    var lr = n[0].messageText;
                    return typeof lr != "string" && (lr = lr.messageText), lr;
                  }
                }
                B.getRefactorActionsToExtractSymbol = N;
                function p(Fe, Z2) {
                  var Be = oe(Fe.file, e2.getRefactorContextSpan(Fe)), ge = Be.targetRange, Re = /^function_scope_(\d+)$/.exec(Z2);
                  if (Re) {
                    var ze = +Re[1];
                    return e2.Debug.assert(isFinite(ze), "Expected to parse a finite number from the function scope index"), se(ge, Fe, ze);
                  }
                  var Ee = /^constant_scope_(\d+)$/.exec(Z2);
                  if (Ee) {
                    var ze = +Ee[1];
                    return e2.Debug.assert(isFinite(ze), "Expected to parse a finite number from the constant scope index"), J(ge, Fe, ze);
                  }
                  e2.Debug.fail("Unrecognized action name");
                }
                B.getRefactorEditsToExtractSymbol = p;
                var m2;
                (function(Fe) {
                  function Z2(Be) {
                    return { message: Be, code: 0, category: e2.DiagnosticCategory.Message, key: Be };
                  }
                  Fe.cannotExtractRange = Z2("Cannot extract range."), Fe.cannotExtractImport = Z2("Cannot extract import statement."), Fe.cannotExtractSuper = Z2("Cannot extract super call."), Fe.cannotExtractJSDoc = Z2("Cannot extract JSDoc."), Fe.cannotExtractEmpty = Z2("Cannot extract empty range."), Fe.expressionExpected = Z2("expression expected."), Fe.uselessConstantType = Z2("No reason to extract constant of type."), Fe.statementOrExpressionExpected = Z2("Statement or expression expected."), Fe.cannotExtractRangeContainingConditionalBreakOrContinueStatements = Z2("Cannot extract range containing conditional break or continue statements."), Fe.cannotExtractRangeContainingConditionalReturnStatement = Z2("Cannot extract range containing conditional return statement."), Fe.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange = Z2("Cannot extract range containing labeled break or continue with target outside of the range."), Fe.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators = Z2("Cannot extract range containing writes to references located outside of the target range in generators."), Fe.typeWillNotBeVisibleInTheNewScope = Z2("Type will not visible in the new scope."), Fe.functionWillNotBeVisibleInTheNewScope = Z2("Function will not visible in the new scope."), Fe.cannotExtractIdentifier = Z2("Select more than a single identifier."), Fe.cannotExtractExportedEntity = Z2("Cannot extract exported declaration"), Fe.cannotWriteInExpression = Z2("Cannot write back side-effects when extracting an expression"), Fe.cannotExtractReadonlyPropertyInitializerOutsideConstructor = Z2("Cannot move initialization of read-only class property outside of the constructor"), Fe.cannotExtractAmbientBlock = Z2("Cannot extract code from ambient contexts"), Fe.cannotAccessVariablesFromNestedScopes = Z2("Cannot access variables from nested scopes"), Fe.cannotExtractToJSClass = Z2("Cannot extract constant to a class scope in JS"), Fe.cannotExtractToExpressionArrowFunction = Z2("Cannot extract constant to an arrow function without a block"), Fe.cannotExtractFunctionsContainingThisToMethod = Z2("Cannot extract functions containing this to method");
                })(m2 = B.Messages || (B.Messages = {}));
                var G;
                (function(Fe) {
                  Fe[Fe.None = 0] = "None", Fe[Fe.HasReturn = 1] = "HasReturn", Fe[Fe.IsGenerator = 2] = "IsGenerator", Fe[Fe.IsAsyncFunction = 4] = "IsAsyncFunction", Fe[Fe.UsesThis = 8] = "UsesThis", Fe[Fe.UsesThisInFunction = 16] = "UsesThisInFunction", Fe[Fe.InStaticRegion = 32] = "InStaticRegion";
                })(G || (G = {}));
                function oe(Fe, Z2, Be) {
                  Be === void 0 && (Be = true);
                  var ge = Z2.length;
                  if (ge === 0 && !Be)
                    return { errors: [e2.createFileDiagnostic(Fe, Z2.start, ge, m2.cannotExtractEmpty)] };
                  var Re = ge === 0 && Be, ze = e2.findFirstNonJsxWhitespaceToken(Fe, Z2.start), Ee = e2.findTokenOnLeftOfPosition(Fe, e2.textSpanEnd(Z2)), He = ze && Ee && Be ? f4(ze, Ee, Fe) : Z2, rr = Re ? fe(ze) : e2.getParentNodeInSpan(ze, Fe, He), Ie = Re ? rr : e2.getParentNodeInSpan(Ee, Fe, He), _e = [], we = G.None, de;
                  if (!rr || !Ie)
                    return { errors: [e2.createFileDiagnostic(Fe, Z2.start, ge, m2.cannotExtractRange)] };
                  if (rr.flags & 8388608)
                    return { errors: [e2.createFileDiagnostic(Fe, Z2.start, ge, m2.cannotExtractJSDoc)] };
                  if (rr.parent !== Ie.parent)
                    return { errors: [e2.createFileDiagnostic(Fe, Z2.start, ge, m2.cannotExtractRange)] };
                  if (rr !== Ie) {
                    if (!ne(rr.parent))
                      return { errors: [e2.createFileDiagnostic(Fe, Z2.start, ge, m2.cannotExtractRange)] };
                    for (var ye = [], Ae = 0, er = rr.parent.statements; Ae < er.length; Ae++) {
                      var ir = er[Ae];
                      if (ir === rr || ye.length) {
                        var Cr = lr(ir);
                        if (Cr)
                          return { errors: Cr };
                        ye.push(ir);
                      }
                      if (ir === Ie)
                        break;
                    }
                    return ye.length ? { targetRange: { range: ye, facts: we, declarations: _e, thisNode: de } } : { errors: [e2.createFileDiagnostic(Fe, Z2.start, ge, m2.cannotExtractRange)] };
                  }
                  if (e2.isReturnStatement(rr) && !rr.expression)
                    return { errors: [e2.createFileDiagnostic(Fe, Z2.start, ge, m2.cannotExtractRange)] };
                  var Ye = Er(rr), Br = Ne(Ye) || lr(Ye);
                  if (Br)
                    return { errors: Br };
                  return { targetRange: { range: T(Ye), facts: we, declarations: _e, thisNode: de } };
                  function Er(be) {
                    if (e2.isReturnStatement(be)) {
                      if (be.expression)
                        return be.expression;
                    } else if (e2.isVariableStatement(be) || e2.isVariableDeclarationList(be)) {
                      for (var Ge = e2.isVariableStatement(be) ? be.declarationList.declarations : be.declarations, ur = 0, yr = void 0, Ir = 0, wr = Ge; Ir < wr.length; Ir++) {
                        var Ur = wr[Ir];
                        Ur.initializer && (ur++, yr = Ur.initializer);
                      }
                      if (ur === 1)
                        return yr;
                    } else if (e2.isVariableDeclaration(be) && be.initializer)
                      return be.initializer;
                    return be;
                  }
                  function Ne(be) {
                    if (e2.isIdentifier(e2.isExpressionStatement(be) ? be.expression : be))
                      return [e2.createDiagnosticForNode(be, m2.cannotExtractIdentifier)];
                  }
                  function n(be, Ge) {
                    for (var ur = be; ur !== Ge; ) {
                      if (ur.kind === 167) {
                        e2.isStatic(ur) && (we |= G.InStaticRegion);
                        break;
                      } else if (ur.kind === 164) {
                        var yr = e2.getContainingFunction(ur);
                        yr.kind === 171 && (we |= G.InStaticRegion);
                        break;
                      } else
                        ur.kind === 169 && e2.isStatic(ur) && (we |= G.InStaticRegion);
                      ur = ur.parent;
                    }
                  }
                  function lr(be) {
                    var Ge;
                    if (function(mi) {
                      mi[mi.None = 0] = "None", mi[mi.Break = 1] = "Break", mi[mi.Continue = 2] = "Continue", mi[mi.Return = 4] = "Return";
                    }(Ge || (Ge = {})), e2.Debug.assert(be.pos <= be.end, "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (1)"), e2.Debug.assert(!e2.positionIsSynthesized(be.pos), "This failure could trigger https://github.com/Microsoft/TypeScript/issues/20809 (2)"), !e2.isStatement(be) && !(e2.isExpressionNode(be) && g(be)) && !We(be))
                      return [e2.createDiagnosticForNode(be, m2.statementOrExpressionExpected)];
                    if (be.flags & 16777216)
                      return [e2.createDiagnosticForNode(be, m2.cannotExtractAmbientBlock)];
                    var ur = e2.getContainingClass(be);
                    ur && n(be, ur);
                    var yr, Ir = 4, wr;
                    if (ii(be), we & G.UsesThis) {
                      var Ur = e2.getThisContainer(be, false);
                      (Ur.kind === 256 || Ur.kind === 169 && Ur.parent.kind === 205 || Ur.kind === 213) && (we |= G.UsesThisInFunction);
                    }
                    return yr;
                    function ii(mi) {
                      if (yr)
                        return true;
                      if (e2.isDeclaration(mi)) {
                        var pe = mi.kind === 254 ? mi.parent.parent : mi;
                        if (e2.hasSyntacticModifier(pe, 1))
                          return (yr || (yr = [])).push(e2.createDiagnosticForNode(mi, m2.cannotExtractExportedEntity)), true;
                        _e.push(mi.symbol);
                      }
                      switch (mi.kind) {
                        case 266:
                          return (yr || (yr = [])).push(e2.createDiagnosticForNode(mi, m2.cannotExtractImport)), true;
                        case 271:
                          return (yr || (yr = [])).push(e2.createDiagnosticForNode(mi, m2.cannotExtractExportedEntity)), true;
                        case 106:
                          if (mi.parent.kind === 208) {
                            var or = e2.getContainingClass(mi);
                            if (or === void 0 || or.pos < Z2.start || or.end >= Z2.start + Z2.length)
                              return (yr || (yr = [])).push(e2.createDiagnosticForNode(mi, m2.cannotExtractSuper)), true;
                          } else
                            we |= G.UsesThis, de = mi;
                          break;
                        case 214:
                          e2.forEachChild(mi, function Di(wi) {
                            if (e2.isThis(wi))
                              we |= G.UsesThis, de = mi;
                            else {
                              if (e2.isClassLike(wi) || e2.isFunctionLike(wi) && !e2.isArrowFunction(wi))
                                return false;
                              e2.forEachChild(wi, Di);
                            }
                          });
                        case 257:
                        case 256:
                          e2.isSourceFile(mi.parent) && mi.parent.externalModuleIndicator === void 0 && (yr || (yr = [])).push(e2.createDiagnosticForNode(mi, m2.functionWillNotBeVisibleInTheNewScope));
                        case 226:
                        case 213:
                        case 169:
                        case 171:
                        case 172:
                        case 173:
                          return false;
                      }
                      var qr = Ir;
                      switch (mi.kind) {
                        case 239:
                          Ir = 0;
                          break;
                        case 252:
                          Ir = 0;
                          break;
                        case 235:
                          mi.parent && mi.parent.kind === 252 && mi.parent.finallyBlock === mi && (Ir = 4);
                          break;
                        case 290:
                        case 289:
                          Ir |= 1;
                          break;
                        default:
                          e2.isIterationStatement(mi, false) && (Ir |= 3);
                          break;
                      }
                      switch (mi.kind) {
                        case 192:
                        case 108:
                          we |= G.UsesThis, de = mi;
                          break;
                        case 250: {
                          var si = mi.label;
                          (wr || (wr = [])).push(si.escapedText), e2.forEachChild(mi, ii), wr.pop();
                          break;
                        }
                        case 246:
                        case 245: {
                          var si = mi.label;
                          si ? e2.contains(wr, si.escapedText) || (yr || (yr = [])).push(e2.createDiagnosticForNode(mi, m2.cannotExtractRangeContainingLabeledBreakOrContinueStatementWithTargetOutsideOfTheRange)) : Ir & (mi.kind === 246 ? 1 : 2) || (yr || (yr = [])).push(e2.createDiagnosticForNode(mi, m2.cannotExtractRangeContainingConditionalBreakOrContinueStatements));
                          break;
                        }
                        case 218:
                          we |= G.IsAsyncFunction;
                          break;
                        case 224:
                          we |= G.IsGenerator;
                          break;
                        case 247:
                          Ir & 4 ? we |= G.HasReturn : (yr || (yr = [])).push(e2.createDiagnosticForNode(mi, m2.cannotExtractRangeContainingConditionalReturnStatement));
                          break;
                        default:
                          e2.forEachChild(mi, ii);
                          break;
                      }
                      Ir = qr;
                    }
                  }
                }
                B.getRangeToExtract = oe;
                function f4(Fe, Z2, Be) {
                  var ge = Fe.getStart(Be), Re = Z2.getEnd();
                  return Be.text.charCodeAt(Re) === 59 && Re++, { start: ge, length: Re - ge };
                }
                function T(Fe) {
                  if (e2.isStatement(Fe))
                    return [Fe];
                  if (e2.isExpressionNode(Fe))
                    return e2.isExpressionStatement(Fe.parent) ? [Fe.parent] : Fe;
                  if (We(Fe))
                    return Fe;
                }
                function K(Fe) {
                  return e2.isArrowFunction(Fe) ? e2.isFunctionBody(Fe.body) : e2.isFunctionLikeDeclaration(Fe) || e2.isSourceFile(Fe) || e2.isModuleBlock(Fe) || e2.isClassLike(Fe);
                }
                function b(Fe) {
                  var Z2 = I(Fe.range) ? e2.first(Fe.range) : Fe.range;
                  if (Fe.facts & G.UsesThis && !(Fe.facts & G.UsesThisInFunction)) {
                    var Be = e2.getContainingClass(Z2);
                    if (Be) {
                      var ge = e2.findAncestor(Z2, e2.isFunctionLikeDeclaration);
                      return ge ? [ge, Be] : [Be];
                    }
                  }
                  for (var Re = []; ; )
                    if (Z2 = Z2.parent, Z2.kind === 164 && (Z2 = e2.findAncestor(Z2, function(ze) {
                      return e2.isFunctionLikeDeclaration(ze);
                    }).parent), K(Z2) && (Re.push(Z2), Z2.kind === 305))
                      return Re;
                }
                function se(Fe, Z2, Be) {
                  var ge = R(Fe, Z2), Re = ge.scopes, ze = ge.readsAndWrites, Ee = ze.target, He = ze.usagesPerScope, rr = ze.functionErrorsPerScope, Ie = ze.exposedVariableDeclarations;
                  return e2.Debug.assert(!rr[Be].length, "The extraction went missing? How?"), Z2.cancellationToken.throwIfCancellationRequested(), x2(Ee, Re[Be], He[Be], Ie, Fe, Z2);
                }
                function J(Fe, Z2, Be) {
                  var ge = R(Fe, Z2), Re = ge.scopes, ze = ge.readsAndWrites, Ee = ze.target, He = ze.usagesPerScope, rr = ze.constantErrorsPerScope, Ie = ze.exposedVariableDeclarations;
                  e2.Debug.assert(!rr[Be].length, "The extraction went missing? How?"), e2.Debug.assert(Ie.length === 0, "Extract constant accepted a range containing a variable declaration?"), Z2.cancellationToken.throwIfCancellationRequested();
                  var _e = e2.isExpression(Ee) ? Ee : Ee.statements[0].expression;
                  return X(_e, Re[Be], He[Be], Fe.facts, Z2);
                }
                function ie(Fe, Z2) {
                  var Be = R(Fe, Z2), ge = Be.scopes, Re = Be.readsAndWrites, ze = Re.functionErrorsPerScope, Ee = Re.constantErrorsPerScope, He = ge.map(function(rr, Ie) {
                    var _e = q(rr), we = O(rr), de = e2.isFunctionLikeDeclaration(rr) ? ve(rr) : e2.isClassLike(rr) ? ee(rr) : he(rr), ye, Ae;
                    return de === 1 ? (ye = e2.formatStringFromArgs(e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_0_in_1_scope), [_e, "global"]), Ae = e2.formatStringFromArgs(e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_0_in_1_scope), [we, "global"])) : de === 0 ? (ye = e2.formatStringFromArgs(e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_0_in_1_scope), [_e, "module"]), Ae = e2.formatStringFromArgs(e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_0_in_1_scope), [we, "module"])) : (ye = e2.formatStringFromArgs(e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_0_in_1), [_e, de]), Ae = e2.formatStringFromArgs(e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_0_in_1), [we, de])), Ie === 0 && !e2.isClassLike(rr) && (Ae = e2.formatStringFromArgs(e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_0_in_enclosing_scope), [we])), { functionExtraction: { description: ye, errors: ze[Ie] }, constantExtraction: { description: Ae, errors: Ee[Ie] } };
                  });
                  return He;
                }
                function R(Fe, Z2) {
                  var Be = Z2.file, ge = b(Fe), Re = l(Fe, Be), ze = D(Fe, ge, Re, Be, Z2.program.getTypeChecker(), Z2.cancellationToken);
                  return { scopes: ge, readsAndWrites: ze };
                }
                function q(Fe) {
                  return e2.isFunctionLikeDeclaration(Fe) ? "inner function" : e2.isClassLike(Fe) ? "method" : "function";
                }
                function O(Fe) {
                  return e2.isClassLike(Fe) ? "readonly field" : "constant";
                }
                function ve(Fe) {
                  switch (Fe.kind) {
                    case 171:
                      return "constructor";
                    case 213:
                    case 256:
                      return Fe.name ? "function '".concat(Fe.name.text, "'") : e2.ANONYMOUS;
                    case 214:
                      return "arrow function";
                    case 169:
                      return "method '".concat(Fe.name.getText(), "'");
                    case 172:
                      return "'get ".concat(Fe.name.getText(), "'");
                    case 173:
                      return "'set ".concat(Fe.name.getText(), "'");
                    default:
                      throw e2.Debug.assertNever(Fe, "Unexpected scope kind ".concat(Fe.kind));
                  }
                }
                function ee(Fe) {
                  return Fe.kind === 257 ? Fe.name ? "class '".concat(Fe.name.text, "'") : "anonymous class declaration" : Fe.name ? "class expression '".concat(Fe.name.text, "'") : "anonymous class expression";
                }
                function he(Fe) {
                  return Fe.kind === 262 ? "namespace '".concat(Fe.parent.name.getText(), "'") : Fe.externalModuleIndicator ? 0 : 1;
                }
                var F2;
                (function(Fe) {
                  Fe[Fe.Module = 0] = "Module", Fe[Fe.Global = 1] = "Global";
                })(F2 || (F2 = {}));
                function x2(Fe, Z2, Be, ge, Re, ze) {
                  var Ee = Be.usages, He = Be.typeParameterUsages, rr = Be.substitutions, Ie = ze.program.getTypeChecker(), _e = e2.getEmitScriptTarget(ze.program.getCompilerOptions()), we = e2.codefix.createImportAdder(ze.file, ze.program, ze.preferences, ze.host), de = Z2.getSourceFile(), ye = e2.getUniqueName(e2.isClassLike(Z2) ? "newMethod" : "newFunction", de), Ae = e2.isInJSFile(Z2), er = e2.factory.createIdentifier(ye), ir, Cr = [], Ye = [], Br;
                  Ee.forEach(function(xe, vr) {
                    var mr;
                    if (!Ae) {
                      var Ar = Ie.getTypeOfSymbolAtLocation(xe.symbol, xe.node);
                      Ar = Ie.getBaseTypeOfLiteralType(Ar), mr = e2.codefix.typeToAutoImportableTypeNode(Ie, we, Ar, Z2, _e, 1);
                    }
                    var Oe = e2.factory.createParameterDeclaration(void 0, void 0, void 0, vr, void 0, mr);
                    Cr.push(Oe), xe.usage === 2 && (Br || (Br = [])).push(xe), Ye.push(e2.factory.createIdentifier(vr));
                  });
                  var Er = e2.arrayFrom(He.values()).map(function(xe) {
                    return { type: xe, declaration: A2(xe) };
                  }), Ne = Er.sort(y), n = Ne.length === 0 ? void 0 : Ne.map(function(xe) {
                    return xe.declaration;
                  }), lr = n !== void 0 ? n.map(function(xe) {
                    return e2.factory.createTypeReferenceNode(xe.name, void 0);
                  }) : void 0;
                  if (e2.isExpression(Fe) && !Ae) {
                    var be = Ie.getContextualType(Fe);
                    ir = Ie.typeToTypeNode(be, Z2, 1);
                  }
                  var Ge = L(Fe, ge, Br, rr, !!(Re.facts & G.HasReturn)), ur = Ge.body, yr = Ge.returnValueProperty;
                  e2.suppressLeadingAndTrailingTrivia(ur);
                  var Ir, wr = !!(Re.facts & G.UsesThisInFunction);
                  if (e2.isClassLike(Z2)) {
                    var Ur = Ae ? [] : [e2.factory.createModifier(121)];
                    Re.facts & G.InStaticRegion && Ur.push(e2.factory.createModifier(124)), Re.facts & G.IsAsyncFunction && Ur.push(e2.factory.createModifier(131)), Ir = e2.factory.createMethodDeclaration(void 0, Ur.length ? Ur : void 0, Re.facts & G.IsGenerator ? e2.factory.createToken(41) : void 0, er, void 0, n, Cr, ir, ur);
                  } else
                    wr && Cr.unshift(e2.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, Ie.typeToTypeNode(Ie.getTypeAtLocation(Re.thisNode), Z2, 1), void 0)), Ir = e2.factory.createFunctionDeclaration(void 0, Re.facts & G.IsAsyncFunction ? [e2.factory.createToken(131)] : void 0, Re.facts & G.IsGenerator ? e2.factory.createToken(41) : void 0, er, n, Cr, ir, ur);
                  var ii = e2.textChanges.ChangeTracker.fromContext(ze), mi = (I(Re.range) ? e2.last(Re.range) : Re.range).end, pe = Y(mi, Z2);
                  pe ? ii.insertNodeBefore(ze.file, pe, Ir, true) : ii.insertNodeAtEndOfScope(ze.file, Z2, Ir), we.writeFixes(ii);
                  var or = [], qr = V(Z2, Re, ye);
                  wr && Ye.unshift(e2.factory.createIdentifier("this"));
                  var si = e2.factory.createCallExpression(wr ? e2.factory.createPropertyAccessExpression(qr, "call") : qr, lr, Ye);
                  if (Re.facts & G.IsGenerator && (si = e2.factory.createYieldExpression(e2.factory.createToken(41), si)), Re.facts & G.IsAsyncFunction && (si = e2.factory.createAwaitExpression(si)), ue(Fe) && (si = e2.factory.createJsxExpression(void 0, si)), ge.length && !Br)
                    if (e2.Debug.assert(!yr, "Expected no returnValueProperty"), e2.Debug.assert(!(Re.facts & G.HasReturn), "Expected RangeFacts.HasReturn flag to be unset"), ge.length === 1) {
                      var Di = ge[0];
                      or.push(e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(e2.getSynthesizedDeepClone(Di.name), void 0, e2.getSynthesizedDeepClone(Di.type), si)], Di.parent.flags)));
                    } else {
                      for (var wi = [], Xi = [], et = ge[0].parent.flags, Gi = false, Wt = 0, Zt = ge; Wt < Zt.length; Wt++) {
                        var Di = Zt[Wt];
                        wi.push(e2.factory.createBindingElement(void 0, void 0, e2.getSynthesizedDeepClone(Di.name)));
                        var _r = Ie.typeToTypeNode(Ie.getBaseTypeOfLiteralType(Ie.getTypeAtLocation(Di)), Z2, 1);
                        Xi.push(e2.factory.createPropertySignature(void 0, Di.symbol.name, void 0, _r)), Gi = Gi || Di.type !== void 0, et = et & Di.parent.flags;
                      }
                      var pi = Gi ? e2.factory.createTypeLiteralNode(Xi) : void 0;
                      pi && e2.setEmitFlags(pi, 1), or.push(e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(e2.factory.createObjectBindingPattern(wi), void 0, pi, si)], et)));
                    }
                  else if (ge.length || Br) {
                    if (ge.length)
                      for (var ae = 0, Xe = ge; ae < Xe.length; ae++) {
                        var Di = Xe[ae], Jr = Di.parent.flags;
                        Jr & 2 && (Jr = Jr & -3 | 1), or.push(e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(Di.symbol.name, void 0, Je(Di.type))], Jr)));
                      }
                    yr && or.push(e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(yr, void 0, Je(ir))], 1)));
                    var ti = H(ge, Br);
                    yr && ti.unshift(e2.factory.createShorthandPropertyAssignment(yr)), ti.length === 1 ? (e2.Debug.assert(!yr, "Shouldn't have returnValueProperty here"), or.push(e2.factory.createExpressionStatement(e2.factory.createAssignment(ti[0].name, si))), Re.facts & G.HasReturn && or.push(e2.factory.createReturnStatement())) : (or.push(e2.factory.createExpressionStatement(e2.factory.createAssignment(e2.factory.createObjectLiteralExpression(ti), si))), yr && or.push(e2.factory.createReturnStatement(e2.factory.createIdentifier(yr))));
                  } else
                    Re.facts & G.HasReturn ? or.push(e2.factory.createReturnStatement(si)) : I(Re.range) ? or.push(e2.factory.createExpressionStatement(si)) : or.push(si);
                  I(Re.range) ? ii.replaceNodeRangeWithNodes(ze.file, e2.first(Re.range), e2.last(Re.range), or) : ii.replaceNodeWithNodes(ze.file, Re.range, or);
                  var Ze = ii.getChanges(), Sr = I(Re.range) ? e2.first(Re.range) : Re.range, zr = Sr.getSourceFile().fileName, Wr = e2.getRenameLocation(Ze, zr, ye, false);
                  return { renameFilename: zr, renameLocation: Wr, edits: Ze };
                  function Je(xe) {
                    if (xe !== void 0) {
                      for (var vr = e2.getSynthesizedDeepClone(xe), mr = vr; e2.isParenthesizedTypeNode(mr); )
                        mr = mr.type;
                      return e2.isUnionTypeNode(mr) && e2.find(mr.types, function(Ar) {
                        return Ar.kind === 153;
                      }) ? vr : e2.factory.createUnionTypeNode([vr, e2.factory.createKeywordTypeNode(153)]);
                    }
                  }
                }
                function X(Fe, Z2, Be, ge, Re) {
                  var ze, Ee = Be.substitutions, He = Re.program.getTypeChecker(), rr = Z2.getSourceFile(), Ie = e2.isPropertyAccessExpression(Fe) && !e2.isClassLike(Z2) && !He.resolveName(Fe.name.text, Fe, 111551, false) && !e2.isPrivateIdentifier(Fe.name) && !e2.isKeyword(Fe.name.originalKeywordKind) ? Fe.name.text : e2.getUniqueName(e2.isClassLike(Z2) ? "newProperty" : "newLocal", rr), _e = e2.isInJSFile(Z2), we = _e || !He.isContextSensitive(Fe) ? void 0 : He.typeToTypeNode(He.getContextualType(Fe), Z2, 1), de = P(e2.skipParentheses(Fe), Ee);
                  ze = Ge(we, de), we = ze.variableType, de = ze.initializer, e2.suppressLeadingAndTrailingTrivia(de);
                  var ye = e2.textChanges.ChangeTracker.fromContext(Re);
                  if (e2.isClassLike(Z2)) {
                    e2.Debug.assert(!_e, "Cannot extract to a JS class");
                    var Ae = [];
                    Ae.push(e2.factory.createModifier(121)), ge & G.InStaticRegion && Ae.push(e2.factory.createModifier(124)), Ae.push(e2.factory.createModifier(145));
                    var er = e2.factory.createPropertyDeclaration(void 0, Ae, Ie, void 0, we, de), ir = e2.factory.createPropertyAccessExpression(ge & G.InStaticRegion ? e2.factory.createIdentifier(Z2.name.getText()) : e2.factory.createThis(), e2.factory.createIdentifier(Ie));
                    ue(Fe) && (ir = e2.factory.createJsxExpression(void 0, ir));
                    var Cr = Fe.pos, Ye = U(Cr, Z2);
                    ye.insertNodeBefore(Re.file, Ye, er, true), ye.replaceNode(Re.file, Fe, ir);
                  } else {
                    var Br = e2.factory.createVariableDeclaration(Ie, void 0, we, de), Er = $(Fe, Z2);
                    if (Er) {
                      ye.insertNodeBefore(Re.file, Er, Br);
                      var ir = e2.factory.createIdentifier(Ie);
                      ye.replaceNode(Re.file, Fe, ir);
                    } else if (Fe.parent.kind === 238 && Z2 === e2.findAncestor(Fe, K)) {
                      var Ne = e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([Br], 2));
                      ye.replaceNode(Re.file, Fe.parent, Ne);
                    } else {
                      var Ne = e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([Br], 2)), Ye = j(Fe, Z2);
                      if (Ye.pos === 0 ? ye.insertNodeAtTopOfFile(Re.file, Ne, false) : ye.insertNodeBefore(Re.file, Ye, Ne, false), Fe.parent.kind === 238)
                        ye.delete(Re.file, Fe.parent);
                      else {
                        var ir = e2.factory.createIdentifier(Ie);
                        ue(Fe) && (ir = e2.factory.createJsxExpression(void 0, ir)), ye.replaceNode(Re.file, Fe, ir);
                      }
                    }
                  }
                  var n = ye.getChanges(), lr = Fe.getSourceFile().fileName, be = e2.getRenameLocation(n, lr, Ie, true);
                  return { renameFilename: lr, renameLocation: be, edits: n };
                  function Ge(ur, yr) {
                    if (ur === void 0)
                      return { variableType: ur, initializer: yr };
                    if (!e2.isFunctionExpression(yr) && !e2.isArrowFunction(yr) || !!yr.typeParameters)
                      return { variableType: ur, initializer: yr };
                    var Ir = He.getTypeAtLocation(Fe), wr = e2.singleOrUndefined(He.getSignaturesOfType(Ir, 0));
                    if (!wr)
                      return { variableType: ur, initializer: yr };
                    if (wr.getTypeParameters())
                      return { variableType: ur, initializer: yr };
                    for (var Ur = [], ii = false, mi = 0, pe = yr.parameters; mi < pe.length; mi++) {
                      var or = pe[mi];
                      if (or.type)
                        Ur.push(or);
                      else {
                        var qr = He.getTypeAtLocation(or);
                        qr === He.getAnyType() && (ii = true), Ur.push(e2.factory.updateParameterDeclaration(or, or.decorators, or.modifiers, or.dotDotDotToken, or.name, or.questionToken, or.type || He.typeToTypeNode(qr, Z2, 1), or.initializer));
                      }
                    }
                    if (ii)
                      return { variableType: ur, initializer: yr };
                    if (ur = void 0, e2.isArrowFunction(yr))
                      yr = e2.factory.updateArrowFunction(yr, Fe.modifiers, yr.typeParameters, Ur, yr.type || He.typeToTypeNode(wr.getReturnType(), Z2, 1), yr.equalsGreaterThanToken, yr.body);
                    else {
                      if (wr && !!wr.thisParameter) {
                        var si = e2.firstOrUndefined(Ur);
                        if (!si || e2.isIdentifier(si.name) && si.name.escapedText !== "this") {
                          var Di = He.getTypeOfSymbolAtLocation(wr.thisParameter, Fe);
                          Ur.splice(0, 0, e2.factory.createParameterDeclaration(void 0, void 0, void 0, "this", void 0, He.typeToTypeNode(Di, Z2, 1)));
                        }
                      }
                      yr = e2.factory.updateFunctionExpression(yr, Fe.modifiers, yr.asteriskToken, yr.name, yr.typeParameters, Ur, yr.type || He.typeToTypeNode(wr.getReturnType(), Z2, 1), yr.body);
                    }
                    return { variableType: ur, initializer: yr };
                  }
                }
                function $(Fe, Z2) {
                  for (var Be; Fe !== void 0 && Fe !== Z2; ) {
                    if (e2.isVariableDeclaration(Fe) && Fe.initializer === Be && e2.isVariableDeclarationList(Fe.parent) && Fe.parent.declarations.length > 1)
                      return Fe;
                    Be = Fe, Fe = Fe.parent;
                  }
                }
                function A2(Fe) {
                  var Z2, Be = Fe.symbol;
                  if (Be && Be.declarations)
                    for (var ge = 0, Re = Be.declarations; ge < Re.length; ge++) {
                      var ze = Re[ge];
                      (Z2 === void 0 || ze.pos < Z2.pos) && (Z2 = ze);
                    }
                  return Z2;
                }
                function y(Fe, Z2) {
                  var Be = Fe.type, ge = Fe.declaration, Re = Z2.type, ze = Z2.declaration;
                  return e2.compareProperties(ge, ze, "pos", e2.compareValues) || e2.compareStringsCaseSensitive(Be.symbol ? Be.symbol.getName() : "", Re.symbol ? Re.symbol.getName() : "") || e2.compareValues(Be.id, Re.id);
                }
                function V(Fe, Z2, Be) {
                  var ge = e2.factory.createIdentifier(Be);
                  if (e2.isClassLike(Fe)) {
                    var Re = Z2.facts & G.InStaticRegion ? e2.factory.createIdentifier(Fe.name.text) : e2.factory.createThis();
                    return e2.factory.createPropertyAccessExpression(Re, ge);
                  } else
                    return ge;
                }
                function L(Fe, Z2, Be, ge, Re) {
                  var ze = Be !== void 0 || Z2.length > 0;
                  if (e2.isBlock(Fe) && !ze && ge.size === 0)
                    return { body: e2.factory.createBlock(Fe.statements, true), returnValueProperty: void 0 };
                  var Ee, He = false, rr = e2.factory.createNodeArray(e2.isBlock(Fe) ? Fe.statements.slice(0) : [e2.isStatement(Fe) ? Fe : e2.factory.createReturnStatement(e2.skipParentheses(Fe))]);
                  if (ze || ge.size) {
                    var Ie = e2.visitNodes(rr, we).slice();
                    if (ze && !Re && e2.isStatement(Fe)) {
                      var _e = H(Z2, Be);
                      _e.length === 1 ? Ie.push(e2.factory.createReturnStatement(_e[0].name)) : Ie.push(e2.factory.createReturnStatement(e2.factory.createObjectLiteralExpression(_e)));
                    }
                    return { body: e2.factory.createBlock(Ie, true), returnValueProperty: Ee };
                  } else
                    return { body: e2.factory.createBlock(rr, true), returnValueProperty: void 0 };
                  function we(de) {
                    if (!He && e2.isReturnStatement(de) && ze) {
                      var ye = H(Z2, Be);
                      return de.expression && (Ee || (Ee = "__return"), ye.unshift(e2.factory.createPropertyAssignment(Ee, e2.visitNode(de.expression, we)))), ye.length === 1 ? e2.factory.createReturnStatement(ye[0].name) : e2.factory.createReturnStatement(e2.factory.createObjectLiteralExpression(ye));
                    } else {
                      var Ae = He;
                      He = He || e2.isFunctionLikeDeclaration(de) || e2.isClassLike(de);
                      var er = ge.get(e2.getNodeId(de).toString()), ir = er ? e2.getSynthesizedDeepClone(er) : e2.visitEachChild(de, we, e2.nullTransformationContext);
                      return He = Ae, ir;
                    }
                  }
                }
                function P(Fe, Z2) {
                  return Z2.size ? Be(Fe) : Fe;
                  function Be(ge) {
                    var Re = Z2.get(e2.getNodeId(ge).toString());
                    return Re ? e2.getSynthesizedDeepClone(Re) : e2.visitEachChild(ge, Be, e2.nullTransformationContext);
                  }
                }
                function k(Fe) {
                  if (e2.isFunctionLikeDeclaration(Fe)) {
                    var Z2 = Fe.body;
                    if (e2.isBlock(Z2))
                      return Z2.statements;
                  } else {
                    if (e2.isModuleBlock(Fe) || e2.isSourceFile(Fe))
                      return Fe.statements;
                    if (e2.isClassLike(Fe))
                      return Fe.members;
                    e2.assertType(Fe);
                  }
                  return e2.emptyArray;
                }
                function Y(Fe, Z2) {
                  return e2.find(k(Z2), function(Be) {
                    return Be.pos >= Fe && e2.isFunctionLikeDeclaration(Be) && !e2.isConstructorDeclaration(Be);
                  });
                }
                function U(Fe, Z2) {
                  var Be = Z2.members;
                  e2.Debug.assert(Be.length > 0, "Found no members");
                  for (var ge, Re = true, ze = 0, Ee = Be; ze < Ee.length; ze++) {
                    var He = Ee[ze];
                    if (He.pos > Fe)
                      return ge || Be[0];
                    if (Re && !e2.isPropertyDeclaration(He)) {
                      if (ge !== void 0)
                        return He;
                      Re = false;
                    }
                    ge = He;
                  }
                  return ge === void 0 ? e2.Debug.fail() : ge;
                }
                function j(Fe, Z2) {
                  e2.Debug.assert(!e2.isClassLike(Z2));
                  for (var Be, ge = Fe; ge !== Z2; ge = ge.parent)
                    K(ge) && (Be = ge);
                  for (var ge = (Be || Fe).parent; ; ge = ge.parent) {
                    if (ne(ge)) {
                      for (var Re = void 0, ze = 0, Ee = ge.statements; ze < Ee.length; ze++) {
                        var He = Ee[ze];
                        if (He.pos > Fe.pos)
                          break;
                        Re = He;
                      }
                      return !Re && e2.isCaseClause(ge) ? (e2.Debug.assert(e2.isSwitchStatement(ge.parent.parent), "Grandparent isn't a switch statement"), ge.parent.parent) : e2.Debug.checkDefined(Re, "prevStatement failed to get set");
                    }
                    e2.Debug.assert(ge !== Z2, "Didn't encounter a block-like before encountering scope");
                  }
                }
                function H(Fe, Z2) {
                  var Be = e2.map(Fe, function(Re) {
                    return e2.factory.createShorthandPropertyAssignment(Re.symbol.name);
                  }), ge = e2.map(Z2, function(Re) {
                    return e2.factory.createShorthandPropertyAssignment(Re.symbol.name);
                  });
                  return Be === void 0 ? ge : ge === void 0 ? Be : Be.concat(ge);
                }
                function I(Fe) {
                  return e2.isArray(Fe);
                }
                function l(Fe, Z2) {
                  return I(Fe.range) ? { pos: e2.first(Fe.range).getStart(Z2), end: e2.last(Fe.range).getEnd() } : Fe.range;
                }
                var d;
                (function(Fe) {
                  Fe[Fe.Read = 1] = "Read", Fe[Fe.Write = 2] = "Write";
                })(d || (d = {}));
                function D(Fe, Z2, Be, ge, Re, ze) {
                  var Ee = new e2.Map(), He = [], rr = [], Ie = [], _e = [], we = [], de = new e2.Map(), ye = [], Ae, er = I(Fe.range) ? Fe.range.length === 1 && e2.isExpressionStatement(Fe.range[0]) ? Fe.range[0].expression : void 0 : Fe.range, ir;
                  if (er === void 0) {
                    var Cr = Fe.range, Ye = e2.first(Cr).getStart(), Br = e2.last(Cr).end;
                    ir = e2.createFileDiagnostic(ge, Ye, Br - Ye, m2.expressionExpected);
                  } else
                    Re.getTypeAtLocation(er).flags & 147456 && (ir = e2.createDiagnosticForNode(er, m2.uselessConstantType));
                  for (var Er = 0, Ne = Z2; Er < Ne.length; Er++) {
                    var n = Ne[Er];
                    He.push({ usages: new e2.Map(), typeParameterUsages: new e2.Map(), substitutions: new e2.Map() }), rr.push(new e2.Map()), Ie.push([]);
                    var lr = [];
                    ir && lr.push(ir), e2.isClassLike(n) && e2.isInJSFile(n) && lr.push(e2.createDiagnosticForNode(n, m2.cannotExtractToJSClass)), e2.isArrowFunction(n) && !e2.isBlock(n.body) && lr.push(e2.createDiagnosticForNode(n, m2.cannotExtractToExpressionArrowFunction)), _e.push(lr);
                  }
                  var be = new e2.Map(), Ge = I(Fe.range) ? e2.factory.createBlock(Fe.range) : Fe.range, ur = I(Fe.range) ? e2.first(Fe.range) : Fe.range, yr = Xi(ur);
                  if (Gi(Ge), yr && !I(Fe.range) && !e2.isJsxAttribute(Fe.range)) {
                    var Ir = Re.getContextualType(Fe.range);
                    et(Ir);
                  }
                  if (Ee.size > 0) {
                    for (var wr = new e2.Map(), Ur = 0, ii = ur; ii !== void 0 && Ur < Z2.length; ii = ii.parent)
                      if (ii === Z2[Ur] && (wr.forEach(function(Xe, Jr) {
                        He[Ur].typeParameterUsages.set(Jr, Xe);
                      }), Ur++), e2.isDeclarationWithTypeParameters(ii))
                        for (var mi = 0, pe = e2.getEffectiveTypeParameterDeclarations(ii); mi < pe.length; mi++) {
                          var or = pe[mi], qr = Re.getTypeAtLocation(or);
                          Ee.has(qr.id.toString()) && wr.set(qr.id.toString(), qr);
                        }
                    e2.Debug.assert(Ur === Z2.length, "Should have iterated all scopes");
                  }
                  if (we.length) {
                    var si = e2.isBlockScope(Z2[0], Z2[0].parent) ? Z2[0] : e2.getEnclosingBlockScopeContainer(Z2[0]);
                    e2.forEachChild(si, _r);
                  }
                  for (var Di = function(Xe) {
                    var Jr = He[Xe];
                    if (Xe > 0 && (Jr.usages.size > 0 || Jr.typeParameterUsages.size > 0)) {
                      var ti = I(Fe.range) ? Fe.range[0] : Fe.range;
                      _e[Xe].push(e2.createDiagnosticForNode(ti, m2.cannotAccessVariablesFromNestedScopes));
                    }
                    Fe.facts & G.UsesThisInFunction && e2.isClassLike(Z2[Xe]) && Ie[Xe].push(e2.createDiagnosticForNode(Fe.thisNode, m2.cannotExtractFunctionsContainingThisToMethod));
                    var Ze = false, Sr;
                    if (He[Xe].usages.forEach(function(Wr) {
                      Wr.usage === 2 && (Ze = true, Wr.symbol.flags & 106500 && Wr.symbol.valueDeclaration && e2.hasEffectiveModifier(Wr.symbol.valueDeclaration, 64) && (Sr = Wr.symbol.valueDeclaration));
                    }), e2.Debug.assert(I(Fe.range) || ye.length === 0, "No variable declarations expected if something was extracted"), Ze && !I(Fe.range)) {
                      var zr = e2.createDiagnosticForNode(Fe.range, m2.cannotWriteInExpression);
                      Ie[Xe].push(zr), _e[Xe].push(zr);
                    } else if (Sr && Xe > 0) {
                      var zr = e2.createDiagnosticForNode(Sr, m2.cannotExtractReadonlyPropertyInitializerOutsideConstructor);
                      Ie[Xe].push(zr), _e[Xe].push(zr);
                    } else if (Ae) {
                      var zr = e2.createDiagnosticForNode(Ae, m2.cannotExtractExportedEntity);
                      Ie[Xe].push(zr), _e[Xe].push(zr);
                    }
                  }, wi = 0; wi < Z2.length; wi++)
                    Di(wi);
                  return { target: Ge, usagesPerScope: He, functionErrorsPerScope: Ie, constantErrorsPerScope: _e, exposedVariableDeclarations: ye };
                  function Xi(Xe) {
                    return !!e2.findAncestor(Xe, function(Jr) {
                      return e2.isDeclarationWithTypeParameters(Jr) && e2.getEffectiveTypeParameterDeclarations(Jr).length !== 0;
                    });
                  }
                  function et(Xe) {
                    for (var Jr = Re.getSymbolWalker(function() {
                      return ze.throwIfCancellationRequested(), true;
                    }), ti = Jr.walkType(Xe).visitedTypes, Ze = 0, Sr = ti; Ze < Sr.length; Ze++) {
                      var zr = Sr[Ze];
                      zr.isTypeParameter() && Ee.set(zr.id.toString(), zr);
                    }
                  }
                  function Gi(Xe, Jr) {
                    if (Jr === void 0 && (Jr = 1), yr) {
                      var ti = Re.getTypeAtLocation(Xe);
                      et(ti);
                    }
                    if (e2.isDeclaration(Xe) && Xe.symbol && we.push(Xe), e2.isAssignmentExpression(Xe))
                      Gi(Xe.left, 2), Gi(Xe.right);
                    else if (e2.isUnaryExpressionWithWrite(Xe))
                      Gi(Xe.operand, 2);
                    else if (e2.isPropertyAccessExpression(Xe) || e2.isElementAccessExpression(Xe))
                      e2.forEachChild(Xe, Gi);
                    else if (e2.isIdentifier(Xe)) {
                      if (!Xe.parent || e2.isQualifiedName(Xe.parent) && Xe !== Xe.parent.left || e2.isPropertyAccessExpression(Xe.parent) && Xe !== Xe.parent.expression)
                        return;
                      Wt(Xe, Jr, e2.isPartOfTypeNode(Xe));
                    } else
                      e2.forEachChild(Xe, Gi);
                  }
                  function Wt(Xe, Jr, ti) {
                    var Ze = Zt(Xe, Jr, ti);
                    if (Ze)
                      for (var Sr = 0; Sr < Z2.length; Sr++) {
                        var zr = rr[Sr].get(Ze);
                        zr && He[Sr].substitutions.set(e2.getNodeId(Xe).toString(), zr);
                      }
                  }
                  function Zt(Xe, Jr, ti) {
                    var Ze = pi(Xe);
                    if (!!Ze) {
                      var Sr = e2.getSymbolId(Ze).toString(), zr = be.get(Sr);
                      if (zr && zr >= Jr)
                        return Sr;
                      if (be.set(Sr, Jr), zr) {
                        for (var Wr = 0, Je = He; Wr < Je.length; Wr++) {
                          var xe = Je[Wr], vr = xe.usages.get(Xe.text);
                          vr && xe.usages.set(Xe.text, { usage: Jr, symbol: Ze, node: Xe });
                        }
                        return Sr;
                      }
                      var mr = Ze.getDeclarations(), Ar = mr && e2.find(mr, function(vi) {
                        return vi.getSourceFile() === ge;
                      });
                      if (!!Ar && !e2.rangeContainsStartEnd(Be, Ar.getStart(), Ar.end)) {
                        if (Fe.facts & G.IsGenerator && Jr === 2) {
                          for (var Oe = e2.createDiagnosticForNode(Xe, m2.cannotExtractRangeThatContainsWritesToReferencesLocatedOutsideOfTheTargetRangeInGenerators), nr = 0, Mr = Ie; nr < Mr.length; nr++) {
                            var Pe = Mr[nr];
                            Pe.push(Oe);
                          }
                          for (var Ue = 0, fr = _e; Ue < fr.length; Ue++) {
                            var Pe = fr[Ue];
                            Pe.push(Oe);
                          }
                        }
                        for (var De = 0; De < Z2.length; De++) {
                          var gr = Z2[De], Vr = Re.resolveName(Ze.name, gr, Ze.flags, false);
                          if (Vr !== Ze && !rr[De].has(Sr)) {
                            var Tr = ae(Ze.exportSymbol || Ze, gr, ti);
                            if (Tr)
                              rr[De].set(Sr, Tr);
                            else if (ti) {
                              if (!(Ze.flags & 262144)) {
                                var Oe = e2.createDiagnosticForNode(Xe, m2.typeWillNotBeVisibleInTheNewScope);
                                Ie[De].push(Oe), _e[De].push(Oe);
                              }
                            } else
                              He[De].usages.set(Xe.text, { usage: Jr, symbol: Ze, node: Xe });
                          }
                        }
                        return Sr;
                      }
                    }
                  }
                  function _r(Xe) {
                    if (!(Xe === Fe.range || I(Fe.range) && Fe.range.indexOf(Xe) >= 0)) {
                      var Jr = e2.isIdentifier(Xe) ? pi(Xe) : Re.getSymbolAtLocation(Xe);
                      if (Jr) {
                        var ti = e2.find(we, function(Sr) {
                          return Sr.symbol === Jr;
                        });
                        if (ti)
                          if (e2.isVariableDeclaration(ti)) {
                            var Ze = ti.symbol.id.toString();
                            de.has(Ze) || (ye.push(ti), de.set(Ze, true));
                          } else
                            Ae = Ae || ti;
                      }
                      e2.forEachChild(Xe, _r);
                    }
                  }
                  function pi(Xe) {
                    return Xe.parent && e2.isShorthandPropertyAssignment(Xe.parent) && Xe.parent.name === Xe ? Re.getShorthandAssignmentValueSymbol(Xe.parent) : Re.getSymbolAtLocation(Xe);
                  }
                  function ae(Xe, Jr, ti) {
                    if (!!Xe) {
                      var Ze = Xe.getDeclarations();
                      if (Ze && Ze.some(function(zr) {
                        return zr.parent === Jr;
                      }))
                        return e2.factory.createIdentifier(Xe.name);
                      var Sr = ae(Xe.parent, Jr, ti);
                      if (Sr !== void 0)
                        return ti ? e2.factory.createQualifiedName(Sr, e2.factory.createIdentifier(Xe.name)) : e2.factory.createPropertyAccessExpression(Sr, Xe.name);
                    }
                  }
                }
                function fe(Fe) {
                  return e2.findAncestor(Fe, function(Z2) {
                    return Z2.parent && g(Z2) && !e2.isBinaryExpression(Z2.parent);
                  });
                }
                function g(Fe) {
                  var Z2 = Fe.parent;
                  switch (Z2.kind) {
                    case 299:
                      return false;
                  }
                  switch (Fe.kind) {
                    case 10:
                      return Z2.kind !== 266 && Z2.kind !== 270;
                    case 225:
                    case 201:
                    case 203:
                      return false;
                    case 79:
                      return Z2.kind !== 203 && Z2.kind !== 270 && Z2.kind !== 275;
                  }
                  return true;
                }
                function ne(Fe) {
                  switch (Fe.kind) {
                    case 235:
                    case 305:
                    case 262:
                    case 289:
                      return true;
                    default:
                      return false;
                  }
                }
                function ue(Fe) {
                  return We(Fe) || (e2.isJsxElement(Fe) || e2.isJsxSelfClosingElement(Fe) || e2.isJsxFragment(Fe)) && (e2.isJsxElement(Fe.parent) || e2.isJsxFragment(Fe.parent));
                }
                function We(Fe) {
                  return e2.isStringLiteral(Fe) && Fe.parent && e2.isJsxAttribute(Fe.parent);
                }
              })(w = C.extractSymbol || (C.extractSymbol = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "Extract type", B = { name: "Extract to type alias", description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_type_alias), kind: "refactor.extract.type" }, E = { name: "Extract to interface", description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_interface), kind: "refactor.extract.interface" }, Q = { name: "Extract to typedef", description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_to_typedef), kind: "refactor.extract.typedef" };
              C.registerRefactor(w, { kinds: [B.kind, E.kind, Q.kind], getAvailableActions: function(K) {
                var b = le(K, K.triggerReason === "invoked");
                return b ? C.isRefactorErrorInfo(b) ? K.preferences.provideRefactorNotApplicableReason ? [{ name: w, description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_type), actions: [Ke(Ke({}, Q), { notApplicableReason: b.error }), Ke(Ke({}, B), { notApplicableReason: b.error }), Ke(Ke({}, E), { notApplicableReason: b.error })] }] : e2.emptyArray : [{ name: w, description: e2.getLocaleSpecificMessage(e2.Diagnostics.Extract_type), actions: b.isJS ? [Q] : e2.append([B], b.typeElements && E) }] : e2.emptyArray;
              }, getEditsForAction: function(K, b) {
                var se = K.file, J = le(K);
                e2.Debug.assert(J && !C.isRefactorErrorInfo(J), "Expected to find a range to extract");
                var ie = e2.getUniqueName("NewType", se), R = e2.textChanges.ChangeTracker.with(K, function(ve) {
                  switch (b) {
                    case B.name:
                      return e2.Debug.assert(!J.isJS, "Invalid actionName/JS combo"), G(ve, se, ie, J);
                    case Q.name:
                      return e2.Debug.assert(J.isJS, "Invalid actionName/JS combo"), f4(ve, se, ie, J);
                    case E.name:
                      return e2.Debug.assert(!J.isJS && !!J.typeElements, "Invalid actionName/JS combo"), oe(ve, se, ie, J);
                    default:
                      e2.Debug.fail("Unexpected action name");
                  }
                }), q = se.fileName, O = e2.getRenameLocation(R, q, ie, false);
                return { edits: R, renameFilename: q, renameLocation: O };
              } });
              function le(T, K) {
                K === void 0 && (K = true);
                var b = T.file, se = T.startPosition, J = e2.isSourceFileJS(b), ie = e2.getTokenAtPosition(b, se), R = e2.createTextRangeFromSpan(e2.getRefactorContextSpan(T)), q = R.pos === R.end && K, O = e2.findAncestor(ie, function(x2) {
                  return x2.parent && e2.isTypeNode(x2) && !p(R, x2.parent, b) && (q || e2.nodeOverlapsWithStartEnd(ie, b, R.pos, R.end));
                });
                if (!O || !e2.isTypeNode(O))
                  return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Selection_is_not_a_valid_type_node) };
                var ve = T.program.getTypeChecker(), ee = e2.Debug.checkDefined(e2.findAncestor(O, e2.isStatement), "Should find a statement"), he = m2(ve, O, ee, b);
                if (!he)
                  return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.No_type_could_be_extracted_from_this_type_node) };
                var F2 = N(ve, O);
                return { isJS: J, selection: O, firstStatement: ee, typeParameters: he, typeElements: F2 };
              }
              function N(T, K) {
                if (!!K)
                  if (e2.isIntersectionTypeNode(K)) {
                    for (var b = [], se = new e2.Map(), J = 0, ie = K.types; J < ie.length; J++) {
                      var R = ie[J], q = N(T, R);
                      if (!q || !q.every(function(O) {
                        return O.name && e2.addToSeen(se, e2.getNameFromPropertyName(O.name));
                      }))
                        return;
                      e2.addRange(b, q);
                    }
                    return b;
                  } else {
                    if (e2.isParenthesizedTypeNode(K))
                      return N(T, K.type);
                    if (e2.isTypeLiteralNode(K))
                      return K.members;
                  }
              }
              function p(T, K, b) {
                return e2.rangeContainsStartEnd(T, e2.skipTrivia(b.text, K.pos), K.end);
              }
              function m2(T, K, b, se) {
                var J = [];
                return ie(K) ? void 0 : J;
                function ie(R) {
                  if (e2.isTypeReferenceNode(R)) {
                    if (e2.isIdentifier(R.typeName))
                      for (var q = R.typeName, O = T.resolveName(q.text, q, 262144, true), ve = 0, ee = (O == null ? void 0 : O.declarations) || e2.emptyArray; ve < ee.length; ve++) {
                        var he = ee[ve];
                        if (e2.isTypeParameterDeclaration(he) && he.getSourceFile() === se) {
                          if (he.name.escapedText === q.escapedText && p(he, K, se))
                            return true;
                          if (p(b, he, se) && !p(K, he, se)) {
                            e2.pushIfUnique(J, he);
                            break;
                          }
                        }
                      }
                  } else if (e2.isInferTypeNode(R)) {
                    var F2 = e2.findAncestor(R, function(X) {
                      return e2.isConditionalTypeNode(X) && p(X.extendsType, R, se);
                    });
                    if (!F2 || !p(K, F2, se))
                      return true;
                  } else if (e2.isTypePredicateNode(R) || e2.isThisTypeNode(R)) {
                    var x2 = e2.findAncestor(R.parent, e2.isFunctionLike);
                    if (x2 && x2.type && p(x2.type, R, se) && !p(K, x2, se))
                      return true;
                  } else if (e2.isTypeQueryNode(R)) {
                    if (e2.isIdentifier(R.exprName)) {
                      var O = T.resolveName(R.exprName.text, R.exprName, 111551, false);
                      if ((O == null ? void 0 : O.valueDeclaration) && p(b, O.valueDeclaration, se) && !p(K, O.valueDeclaration, se))
                        return true;
                    } else if (e2.isThisIdentifier(R.exprName.left) && !p(K, R.parent, se))
                      return true;
                  }
                  return se && e2.isTupleTypeNode(R) && e2.getLineAndCharacterOfPosition(se, R.pos).line === e2.getLineAndCharacterOfPosition(se, R.end).line && e2.setEmitFlags(R, 1), e2.forEachChild(R, ie);
                }
              }
              function G(T, K, b, se) {
                var J = se.firstStatement, ie = se.selection, R = se.typeParameters, q = e2.factory.createTypeAliasDeclaration(void 0, void 0, b, R.map(function(O) {
                  return e2.factory.updateTypeParameterDeclaration(O, O.modifiers, O.name, O.constraint, void 0);
                }), ie);
                T.insertNodeBefore(K, J, e2.ignoreSourceNewlines(q), true), T.replaceNode(K, ie, e2.factory.createTypeReferenceNode(b, R.map(function(O) {
                  return e2.factory.createTypeReferenceNode(O.name, void 0);
                })), { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.ExcludeWhitespace });
              }
              function oe(T, K, b, se) {
                var J, ie = se.firstStatement, R = se.selection, q = se.typeParameters, O = se.typeElements, ve = e2.factory.createInterfaceDeclaration(void 0, void 0, b, q, void 0, O);
                e2.setTextRange(ve, (J = O[0]) === null || J === void 0 ? void 0 : J.parent), T.insertNodeBefore(K, ie, e2.ignoreSourceNewlines(ve), true), T.replaceNode(K, R, e2.factory.createTypeReferenceNode(b, q.map(function(ee) {
                  return e2.factory.createTypeReferenceNode(ee.name, void 0);
                })), { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.Exclude, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.ExcludeWhitespace });
              }
              function f4(T, K, b, se) {
                var J = se.firstStatement, ie = se.selection, R = se.typeParameters;
                e2.setEmitFlags(ie, 3584);
                var q = e2.factory.createJSDocTypedefTag(e2.factory.createIdentifier("typedef"), e2.factory.createJSDocTypeExpression(ie), e2.factory.createIdentifier(b)), O = [];
                e2.forEach(R, function(ve) {
                  var ee = e2.getEffectiveConstraintOfTypeParameter(ve), he = e2.factory.createTypeParameterDeclaration(void 0, ve.name), F2 = e2.factory.createJSDocTemplateTag(e2.factory.createIdentifier("template"), ee && e2.cast(ee, e2.isJSDocTypeExpression), [he]);
                  O.push(F2);
                }), T.insertNodeBefore(K, J, e2.factory.createJSDocComment(void 0, e2.factory.createNodeArray(e2.concatenate(O, [q]))), true), T.replaceNode(K, ie, e2.factory.createTypeReferenceNode(b, R.map(function(ve) {
                  return e2.factory.createTypeReferenceNode(ve.name, void 0);
                })));
              }
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Generate 'get' and 'set' accessors", Q = e2.Diagnostics.Generate_get_and_set_accessors.message, le = { name: E, description: Q, kind: "refactor.rewrite.property.generateAccessors" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: function(p, m2) {
                  if (!!p.endPosition) {
                    var G = e2.codefix.getAccessorConvertiblePropertyAtPosition(p.file, p.program, p.startPosition, p.endPosition);
                    e2.Debug.assert(G && !C.isRefactorErrorInfo(G), "Expected applicable refactor info");
                    var oe = e2.codefix.generateAccessorFromProperty(p.file, p.program, p.startPosition, p.endPosition, p, m2);
                    if (!!oe) {
                      var f4 = p.file.fileName, T = G.renameAccessor ? G.accessorName : G.fieldName, K = e2.isIdentifier(T) ? 0 : -1, b = K + e2.getRenameLocation(oe, f4, T.text, e2.isParameter(G.declaration));
                      return { renameFilename: f4, renameLocation: b, edits: oe };
                    }
                  }
                }, getAvailableActions: function(N) {
                  if (!N.endPosition)
                    return e2.emptyArray;
                  var p = e2.codefix.getAccessorConvertiblePropertyAtPosition(N.file, N.program, N.startPosition, N.endPosition, N.triggerReason === "invoked");
                  return p ? C.isRefactorErrorInfo(p) ? N.preferences.provideRefactorNotApplicableReason ? [{ name: E, description: Q, actions: [Ke(Ke({}, le), { notApplicableReason: p.error })] }] : e2.emptyArray : [{ name: E, description: Q, actions: [le] }] : e2.emptyArray;
                } });
              })(w = C.generateGetAccessorAndSetAccessor || (C.generateGetAccessorAndSetAccessor = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(E) {
                return E.error !== void 0;
              }
              C.isRefactorErrorInfo = w;
              function B(E, Q) {
                return Q ? E.substr(0, Q.length) === Q : true;
              }
              C.refactorKindBeginsWith = B;
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w = "Move to a new file", B = e2.getLocaleSpecificMessage(e2.Diagnostics.Move_to_a_new_file), E = { name: w, description: B, kind: "refactor.move.newFile" };
              C.registerRefactor(w, { kinds: [E.kind], getAvailableActions: function(He) {
                var rr = N(He);
                return He.preferences.allowTextChangesInNewFiles && rr ? [{ name: w, description: B, actions: [E] }] : He.preferences.provideRefactorNotApplicableReason ? [{ name: w, description: B, actions: [Ke(Ke({}, E), { notApplicableReason: e2.getLocaleSpecificMessage(e2.Diagnostics.Selection_is_not_a_valid_statement_or_statements) })] }] : e2.emptyArray;
              }, getEditsForAction: function(He, rr) {
                e2.Debug.assert(rr === w, "Wrong refactor invoked");
                var Ie = e2.Debug.checkDefined(N(He)), _e = e2.textChanges.ChangeTracker.with(He, function(we) {
                  return le(He.file, He.program, Ie, we, He.host, He.preferences);
                });
                return { edits: _e, renameFilename: void 0, renameLocation: void 0 };
              } });
              function Q(Ee) {
                var He = Ee.file, rr = e2.createTextRangeFromSpan(e2.getRefactorContextSpan(Ee)), Ie = He.statements, _e = e2.findIndex(Ie, function(ye) {
                  return ye.end > rr.pos;
                });
                if (_e !== -1) {
                  var we = Ie[_e];
                  if (e2.isNamedDeclaration(we) && we.name && e2.rangeContainsRange(we.name, rr))
                    return { toMove: [Ie[_e]], afterLast: Ie[_e + 1] };
                  if (!(rr.pos > we.getStart(He))) {
                    var de = e2.findIndex(Ie, function(ye) {
                      return ye.end > rr.end;
                    }, _e);
                    if (!(de !== -1 && (de === 0 || Ie[de].getStart(He) < rr.end)))
                      return { toMove: Ie.slice(_e, de === -1 ? Ie.length : de), afterLast: de === -1 ? void 0 : Ie[de] };
                  }
                }
              }
              function le(Ee, He, rr, Ie, _e, we) {
                var de = He.getTypeChecker(), ye = V(Ee, rr.all, de), Ae = e2.getDirectoryPath(Ee.fileName), er = e2.extensionFromPath(Ee.fileName), ir = A2(y(ye.movedSymbols), er, Ae, _e), Cr = ir + er;
                Ie.createNewFile(Ee, e2.combinePaths(Ae, Cr), oe(Ee, ye, Ie, rr, He, ir, we)), G(He, Ie, Ee.fileName, Cr, e2.hostGetCanonicalFileName(_e));
              }
              function N(Ee) {
                var He = Q(Ee);
                if (He !== void 0) {
                  var rr = [], Ie = [], _e = He.toMove, we = He.afterLast;
                  return e2.getRangesWhere(_e, p, function(de, ye) {
                    for (var Ae = de; Ae < ye; Ae++)
                      rr.push(_e[Ae]);
                    Ie.push({ first: _e[de], afterLast: we });
                  }), rr.length === 0 ? void 0 : { all: rr, ranges: Ie };
                }
              }
              function p(Ee) {
                return !m2(Ee) && !e2.isPrologueDirective(Ee);
              }
              function m2(Ee) {
                switch (Ee.kind) {
                  case 266:
                    return true;
                  case 265:
                    return !e2.hasSyntacticModifier(Ee, 1);
                  case 237:
                    return Ee.declarationList.declarations.every(function(He) {
                      return !!He.initializer && e2.isRequireCall(He.initializer, true);
                    });
                  default:
                    return false;
                }
              }
              function G(Ee, He, rr, Ie, _e) {
                var we = Ee.getCompilerOptions().configFile;
                if (!!we) {
                  var de = e2.normalizePath(e2.combinePaths(rr, "..", Ie)), ye = e2.getRelativePathFromFile(we.fileName, de, _e), Ae = we.statements[0] && e2.tryCast(we.statements[0].expression, e2.isObjectLiteralExpression), er = Ae && e2.find(Ae.properties, function(ir) {
                    return e2.isPropertyAssignment(ir) && e2.isStringLiteral(ir.name) && ir.name.text === "files";
                  });
                  er && e2.isArrayLiteralExpression(er.initializer) && He.insertNodeInListAfter(we, e2.last(er.initializer.elements), e2.factory.createStringLiteral(ye), er.initializer.elements);
                }
              }
              function oe(Ee, He, rr, Ie, _e, we, de) {
                var ye = _e.getTypeChecker(), Ae = e2.takeWhile(Ee.statements, e2.isPrologueDirective);
                if (!Ee.externalModuleIndicator && !Ee.commonJsModuleIndicator)
                  return f4(Ee, Ie.ranges, rr), Ve(Ve([], Ae, true), Ie.all, true);
                var er = !!Ee.externalModuleIndicator, ir = e2.getQuotePreference(Ee, de), Cr = q(He.oldFileImportsFromNewFile, we, er, ir);
                Cr && e2.insertImports(rr, Ee, Cr, true), T(Ee, Ie.all, rr, He.unusedImportsFromOldFile, ye), f4(Ee, Ie.ranges, rr), K(rr, _e, Ee, He.movedSymbols, we);
                var Ye = $(Ee, He.oldImportsNeededByNewFile, He.newFileImportsFromOldFile, rr, ye, er, ir), Br = he(Ee, Ie.all, He.oldFileImportsFromNewFile, er);
                return Ye.length && Br.length ? Ve(Ve(Ve(Ve([], Ae, true), Ye, true), [4], false), Br, true) : Ve(Ve(Ve([], Ae, true), Ye, true), Br, true);
              }
              function f4(Ee, He, rr) {
                for (var Ie = 0, _e = He; Ie < _e.length; Ie++) {
                  var we = _e[Ie], de = we.first, ye = we.afterLast;
                  rr.deleteNodeRangeExcludingEnd(Ee, de, ye);
                }
              }
              function T(Ee, He, rr, Ie, _e) {
                for (var we = 0, de = Ee.statements; we < de.length; we++) {
                  var ye = de[we];
                  e2.contains(He, ye) || R(ye, function(Ae) {
                    return F2(Ee, Ae, rr, function(er) {
                      return Ie.has(_e.getSymbolAtLocation(er));
                    });
                  });
                }
              }
              function K(Ee, He, rr, Ie, _e) {
                for (var we = He.getTypeChecker(), de = function(ir) {
                  if (ir === rr)
                    return "continue";
                  for (var Cr = function(Ne) {
                    R(Ne, function(n) {
                      if (we.getSymbolAtLocation(ie(n)) === rr.symbol) {
                        var lr = function(yr) {
                          var Ir = e2.isBindingElement(yr.parent) ? e2.getPropertySymbolFromBindingElement(we, yr.parent) : e2.skipAlias(we.getSymbolAtLocation(yr), we);
                          return !!Ir && Ie.has(Ir);
                        };
                        F2(ir, n, Ee, lr);
                        var be = e2.combinePaths(e2.getDirectoryPath(ie(n).text), _e), Ge = k(n, e2.factory.createStringLiteral(be), lr);
                        Ge && Ee.insertNodeAfter(ir, Ne, Ge);
                        var ur = b(n);
                        ur && se(Ee, ir, we, Ie, _e, be, ur, n);
                      }
                    });
                  }, Ye = 0, Br = ir.statements; Ye < Br.length; Ye++) {
                    var Er = Br[Ye];
                    Cr(Er);
                  }
                }, ye = 0, Ae = He.getSourceFiles(); ye < Ae.length; ye++) {
                  var er = Ae[ye];
                  de(er);
                }
              }
              function b(Ee) {
                switch (Ee.kind) {
                  case 266:
                    return Ee.importClause && Ee.importClause.namedBindings && Ee.importClause.namedBindings.kind === 268 ? Ee.importClause.namedBindings.name : void 0;
                  case 265:
                    return Ee.name;
                  case 254:
                    return e2.tryCast(Ee.name, e2.isIdentifier);
                  default:
                    return e2.Debug.assertNever(Ee, "Unexpected node kind ".concat(Ee.kind));
                }
              }
              function se(Ee, He, rr, Ie, _e, we, de, ye) {
                var Ae = e2.codefix.moduleSpecifierToValidIdentifier(_e, 99), er = false, ir = [];
                if (e2.FindAllReferences.Core.eachSymbolReferenceInFile(de, rr, He, function(Ne) {
                  !e2.isPropertyAccessExpression(Ne.parent) || (er = er || !!rr.resolveName(Ae, Ne, 67108863, true), Ie.has(rr.getSymbolAtLocation(Ne.parent.name)) && ir.push(Ne));
                }), ir.length) {
                  for (var Cr = er ? e2.getUniqueName(Ae, He) : Ae, Ye = 0, Br = ir; Ye < Br.length; Ye++) {
                    var Er = Br[Ye];
                    Ee.replaceNode(He, Er, e2.factory.createIdentifier(Cr));
                  }
                  Ee.insertNodeAfter(He, ye, J(ye, _e, we));
                }
              }
              function J(Ee, He, rr) {
                var Ie = e2.factory.createIdentifier(He), _e = e2.factory.createStringLiteral(rr);
                switch (Ee.kind) {
                  case 266:
                    return e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(false, void 0, e2.factory.createNamespaceImport(Ie)), _e, void 0);
                  case 265:
                    return e2.factory.createImportEqualsDeclaration(void 0, void 0, false, Ie, e2.factory.createExternalModuleReference(_e));
                  case 254:
                    return e2.factory.createVariableDeclaration(Ie, void 0, void 0, ee(_e));
                  default:
                    return e2.Debug.assertNever(Ee, "Unexpected node kind ".concat(Ee.kind));
                }
              }
              function ie(Ee) {
                return Ee.kind === 266 ? Ee.moduleSpecifier : Ee.kind === 265 ? Ee.moduleReference.expression : Ee.initializer.arguments[0];
              }
              function R(Ee, He) {
                if (e2.isImportDeclaration(Ee))
                  e2.isStringLiteral(Ee.moduleSpecifier) && He(Ee);
                else if (e2.isImportEqualsDeclaration(Ee))
                  e2.isExternalModuleReference(Ee.moduleReference) && e2.isStringLiteralLike(Ee.moduleReference.expression) && He(Ee);
                else if (e2.isVariableStatement(Ee))
                  for (var rr = 0, Ie = Ee.declarationList.declarations; rr < Ie.length; rr++) {
                    var _e = Ie[rr];
                    _e.initializer && e2.isRequireCall(_e.initializer, true) && He(_e);
                  }
              }
              function q(Ee, He, rr, Ie) {
                var _e, we = [];
                return Ee.forEach(function(de) {
                  de.escapedName === "default" ? _e = e2.factory.createIdentifier(e2.symbolNameNoDefault(de)) : we.push(de.name);
                }), O(_e, we, He, rr, Ie);
              }
              function O(Ee, He, rr, Ie, _e) {
                if (rr = e2.ensurePathIsNonModuleName(rr), Ie) {
                  var we = He.map(function(ye) {
                    return e2.factory.createImportSpecifier(false, void 0, e2.factory.createIdentifier(ye));
                  });
                  return e2.makeImportIfNecessary(Ee, we, rr, _e);
                } else {
                  e2.Debug.assert(!Ee, "No default import should exist");
                  var de = He.map(function(ye) {
                    return e2.factory.createBindingElement(void 0, void 0, ye);
                  });
                  return de.length ? ve(e2.factory.createObjectBindingPattern(de), void 0, ee(e2.factory.createStringLiteral(rr))) : void 0;
                }
              }
              function ve(Ee, He, rr, Ie) {
                return Ie === void 0 && (Ie = 2), e2.factory.createVariableStatement(void 0, e2.factory.createVariableDeclarationList([e2.factory.createVariableDeclaration(Ee, void 0, He, rr)], Ie));
              }
              function ee(Ee) {
                return e2.factory.createCallExpression(e2.factory.createIdentifier("require"), void 0, [Ee]);
              }
              function he(Ee, He, rr, Ie) {
                return e2.flatMap(He, function(_e) {
                  if (d(_e) && !Fe(Ee, _e, Ie) && fe(_e, function(de) {
                    return rr.has(e2.Debug.checkDefined(de.symbol));
                  })) {
                    var we = Z2(_e, Ie);
                    if (we)
                      return we;
                  }
                  return _e;
                });
              }
              function F2(Ee, He, rr, Ie) {
                switch (He.kind) {
                  case 266:
                    x2(Ee, He, rr, Ie);
                    break;
                  case 265:
                    Ie(He.name) && rr.delete(Ee, He);
                    break;
                  case 254:
                    X(Ee, He, rr, Ie);
                    break;
                  default:
                    e2.Debug.assertNever(He, "Unexpected import decl kind ".concat(He.kind));
                }
              }
              function x2(Ee, He, rr, Ie) {
                if (!!He.importClause) {
                  var _e = He.importClause, we = _e.name, de = _e.namedBindings, ye = !we || Ie(we), Ae = !de || (de.kind === 268 ? Ie(de.name) : de.elements.length !== 0 && de.elements.every(function(Ye) {
                    return Ie(Ye.name);
                  }));
                  if (ye && Ae)
                    rr.delete(Ee, He);
                  else if (we && ye && rr.delete(Ee, we), de) {
                    if (Ae)
                      rr.replaceNode(Ee, He.importClause, e2.factory.updateImportClause(He.importClause, He.importClause.isTypeOnly, we, void 0));
                    else if (de.kind === 269)
                      for (var er = 0, ir = de.elements; er < ir.length; er++) {
                        var Cr = ir[er];
                        Ie(Cr.name) && rr.delete(Ee, Cr);
                      }
                  }
                }
              }
              function X(Ee, He, rr, Ie) {
                var _e = He.name;
                switch (_e.kind) {
                  case 79:
                    Ie(_e) && rr.delete(Ee, _e);
                    break;
                  case 202:
                    break;
                  case 201:
                    if (_e.elements.every(function(Ae) {
                      return e2.isIdentifier(Ae.name) && Ie(Ae.name);
                    }))
                      rr.delete(Ee, e2.isVariableDeclarationList(He.parent) && He.parent.declarations.length === 1 ? He.parent.parent : He);
                    else
                      for (var we = 0, de = _e.elements; we < de.length; we++) {
                        var ye = de[we];
                        e2.isIdentifier(ye.name) && Ie(ye.name) && rr.delete(Ee, ye.name);
                      }
                    break;
                }
              }
              function $(Ee, He, rr, Ie, _e, we, de) {
                for (var ye = [], Ae = 0, er = Ee.statements; Ae < er.length; Ae++) {
                  var ir = er[Ae];
                  R(ir, function(Er) {
                    e2.append(ye, k(Er, ie(Er), function(Ne) {
                      return He.has(_e.getSymbolAtLocation(Ne));
                    }));
                  });
                }
                var Cr, Ye = [], Br = e2.nodeSeenTracker();
                return rr.forEach(function(Er) {
                  if (!!Er.declarations)
                    for (var Ne = 0, n = Er.declarations; Ne < n.length; Ne++) {
                      var lr = n[Ne];
                      if (!!I(lr)) {
                        var be = ne(lr);
                        if (!!be) {
                          var Ge = ue(lr);
                          Br(Ge) && We(Ee, Ge, be, Ie, we), e2.hasSyntacticModifier(lr, 512) ? Cr = be : Ye.push(be.text);
                        }
                      }
                    }
                }), e2.append(ye, O(Cr, Ye, e2.removeFileExtension(e2.getBaseFileName(Ee.fileName)), we, de)), ye;
              }
              function A2(Ee, He, rr, Ie) {
                for (var _e = Ee, we = 1; ; we++) {
                  var de = e2.combinePaths(rr, _e + He);
                  if (!Ie.fileExists(de))
                    return _e;
                  _e = "".concat(Ee, ".").concat(we);
                }
              }
              function y(Ee) {
                return Ee.forEachEntry(e2.symbolNameNoDefault) || "newFile";
              }
              function V(Ee, He, rr) {
                var Ie = new H(), _e = new H(), we = new H(), de = e2.find(He, function(be) {
                  return !!(be.transformFlags & 2);
                }), ye = lr(de);
                ye && _e.add(ye);
                for (var Ae = 0, er = He; Ae < er.length; Ae++) {
                  var ir = er[Ae];
                  fe(ir, function(be) {
                    Ie.add(e2.Debug.checkDefined(e2.isExpressionStatement(be) ? rr.getSymbolAtLocation(be.expression.left) : be.symbol, "Need a symbol here"));
                  });
                }
                for (var Cr = 0, Ye = He; Cr < Ye.length; Cr++) {
                  var ir = Ye[Cr];
                  j(ir, rr, function(Ge) {
                    if (!!Ge.declarations)
                      for (var ur = 0, yr = Ge.declarations; ur < yr.length; ur++) {
                        var Ir = yr[ur];
                        L(Ir) ? _e.add(Ge) : I(Ir) && l(Ir) === Ee && !Ie.has(Ge) && we.add(Ge);
                      }
                  });
                }
                for (var Br = _e.clone(), Er = new H(), Ne = 0, n = Ee.statements; Ne < n.length; Ne++) {
                  var ir = n[Ne];
                  e2.contains(He, ir) || (ye && !!(ir.transformFlags & 2) && Br.delete(ye), j(ir, rr, function(Ge) {
                    Ie.has(Ge) && Er.add(Ge), Br.delete(Ge);
                  }));
                }
                return { movedSymbols: Ie, newFileImportsFromOldFile: we, oldFileImportsFromNewFile: Er, oldImportsNeededByNewFile: _e, unusedImportsFromOldFile: Br };
                function lr(be) {
                  if (be !== void 0) {
                    var Ge = rr.getJsxNamespace(be), ur = rr.resolveName(Ge, be, 1920, true);
                    return !!ur && e2.some(ur.declarations, L) ? ur : void 0;
                  }
                }
              }
              function L(Ee) {
                switch (Ee.kind) {
                  case 265:
                  case 270:
                  case 267:
                  case 268:
                    return true;
                  case 254:
                    return P(Ee);
                  case 203:
                    return e2.isVariableDeclaration(Ee.parent.parent) && P(Ee.parent.parent);
                  default:
                    return false;
                }
              }
              function P(Ee) {
                return e2.isSourceFile(Ee.parent.parent.parent) && !!Ee.initializer && e2.isRequireCall(Ee.initializer, true);
              }
              function k(Ee, He, rr) {
                switch (Ee.kind) {
                  case 266: {
                    var Ie = Ee.importClause;
                    if (!Ie)
                      return;
                    var _e = Ie.name && rr(Ie.name) ? Ie.name : void 0, we = Ie.namedBindings && Y(Ie.namedBindings, rr);
                    return _e || we ? e2.factory.createImportDeclaration(void 0, void 0, e2.factory.createImportClause(false, _e, we), He, void 0) : void 0;
                  }
                  case 265:
                    return rr(Ee.name) ? Ee : void 0;
                  case 254: {
                    var de = U(Ee.name, rr);
                    return de ? ve(de, Ee.type, ee(He), Ee.parent.flags) : void 0;
                  }
                  default:
                    return e2.Debug.assertNever(Ee, "Unexpected import kind ".concat(Ee.kind));
                }
              }
              function Y(Ee, He) {
                if (Ee.kind === 268)
                  return He(Ee.name) ? Ee : void 0;
                var rr = Ee.elements.filter(function(Ie) {
                  return He(Ie.name);
                });
                return rr.length ? e2.factory.createNamedImports(rr) : void 0;
              }
              function U(Ee, He) {
                switch (Ee.kind) {
                  case 79:
                    return He(Ee) ? Ee : void 0;
                  case 202:
                    return Ee;
                  case 201: {
                    var rr = Ee.elements.filter(function(Ie) {
                      return Ie.propertyName || !e2.isIdentifier(Ie.name) || He(Ie.name);
                    });
                    return rr.length ? e2.factory.createObjectBindingPattern(rr) : void 0;
                  }
                }
              }
              function j(Ee, He, rr) {
                Ee.forEachChild(function Ie(_e) {
                  if (e2.isIdentifier(_e) && !e2.isDeclarationName(_e)) {
                    var we = He.getSymbolAtLocation(_e);
                    we && rr(we);
                  } else
                    _e.forEachChild(Ie);
                });
              }
              var H = function() {
                function Ee() {
                  this.map = new e2.Map();
                }
                return Ee.prototype.add = function(He) {
                  this.map.set(String(e2.getSymbolId(He)), He);
                }, Ee.prototype.has = function(He) {
                  return this.map.has(String(e2.getSymbolId(He)));
                }, Ee.prototype.delete = function(He) {
                  this.map.delete(String(e2.getSymbolId(He)));
                }, Ee.prototype.forEach = function(He) {
                  this.map.forEach(He);
                }, Ee.prototype.forEachEntry = function(He) {
                  return e2.forEachEntry(this.map, He);
                }, Ee.prototype.clone = function() {
                  var He = new Ee();
                  return e2.copyEntries(this.map, He.map), He;
                }, Ee;
              }();
              function I(Ee) {
                return D(Ee) && e2.isSourceFile(Ee.parent) || e2.isVariableDeclaration(Ee) && e2.isSourceFile(Ee.parent.parent.parent);
              }
              function l(Ee) {
                return e2.isVariableDeclaration(Ee) ? Ee.parent.parent.parent : Ee.parent;
              }
              function d(Ee) {
                return e2.Debug.assert(e2.isSourceFile(Ee.parent), "Node parent should be a SourceFile"), D(Ee) || e2.isVariableStatement(Ee);
              }
              function D(Ee) {
                switch (Ee.kind) {
                  case 256:
                  case 257:
                  case 261:
                  case 260:
                  case 259:
                  case 258:
                  case 265:
                    return true;
                  default:
                    return false;
                }
              }
              function fe(Ee, He) {
                switch (Ee.kind) {
                  case 256:
                  case 257:
                  case 261:
                  case 260:
                  case 259:
                  case 258:
                  case 265:
                    return He(Ee);
                  case 237:
                    return e2.firstDefined(Ee.declarationList.declarations, function(Ie) {
                      return g(Ie.name, He);
                    });
                  case 238: {
                    var rr = Ee.expression;
                    return e2.isBinaryExpression(rr) && e2.getAssignmentDeclarationKind(rr) === 1 ? He(Ee) : void 0;
                  }
                }
              }
              function g(Ee, He) {
                switch (Ee.kind) {
                  case 79:
                    return He(e2.cast(Ee.parent, function(rr) {
                      return e2.isVariableDeclaration(rr) || e2.isBindingElement(rr);
                    }));
                  case 202:
                  case 201:
                    return e2.firstDefined(Ee.elements, function(rr) {
                      return e2.isOmittedExpression(rr) ? void 0 : g(rr.name, He);
                    });
                  default:
                    return e2.Debug.assertNever(Ee, "Unexpected name kind ".concat(Ee.kind));
                }
              }
              function ne(Ee) {
                return e2.isExpressionStatement(Ee) ? e2.tryCast(Ee.expression.left.name, e2.isIdentifier) : e2.tryCast(Ee.name, e2.isIdentifier);
              }
              function ue(Ee) {
                switch (Ee.kind) {
                  case 254:
                    return Ee.parent.parent;
                  case 203:
                    return ue(e2.cast(Ee.parent.parent, function(He) {
                      return e2.isVariableDeclaration(He) || e2.isBindingElement(He);
                    }));
                  default:
                    return Ee;
                }
              }
              function We(Ee, He, rr, Ie, _e) {
                if (!Fe(Ee, He, _e, rr))
                  if (_e)
                    e2.isExpressionStatement(He) || Ie.insertExportModifier(Ee, He);
                  else {
                    var we = Re(He);
                    we.length !== 0 && Ie.insertNodesAfter(Ee, He, we.map(ze));
                  }
              }
              function Fe(Ee, He, rr, Ie) {
                var _e;
                return rr ? !e2.isExpressionStatement(He) && e2.hasSyntacticModifier(He, 1) || !!(Ie && ((_e = Ee.symbol.exports) === null || _e === void 0 ? void 0 : _e.has(Ie.escapedText))) : Re(He).some(function(we) {
                  return Ee.symbol.exports.has(e2.escapeLeadingUnderscores(we));
                });
              }
              function Z2(Ee, He) {
                return He ? [Be(Ee)] : ge(Ee);
              }
              function Be(Ee) {
                var He = e2.concatenate([e2.factory.createModifier(93)], Ee.modifiers);
                switch (Ee.kind) {
                  case 256:
                    return e2.factory.updateFunctionDeclaration(Ee, Ee.decorators, He, Ee.asteriskToken, Ee.name, Ee.typeParameters, Ee.parameters, Ee.type, Ee.body);
                  case 257:
                    return e2.factory.updateClassDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.typeParameters, Ee.heritageClauses, Ee.members);
                  case 237:
                    return e2.factory.updateVariableStatement(Ee, He, Ee.declarationList);
                  case 261:
                    return e2.factory.updateModuleDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.body);
                  case 260:
                    return e2.factory.updateEnumDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.members);
                  case 259:
                    return e2.factory.updateTypeAliasDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.typeParameters, Ee.type);
                  case 258:
                    return e2.factory.updateInterfaceDeclaration(Ee, Ee.decorators, He, Ee.name, Ee.typeParameters, Ee.heritageClauses, Ee.members);
                  case 265:
                    return e2.factory.updateImportEqualsDeclaration(Ee, Ee.decorators, He, Ee.isTypeOnly, Ee.name, Ee.moduleReference);
                  case 238:
                    return e2.Debug.fail();
                  default:
                    return e2.Debug.assertNever(Ee, "Unexpected declaration kind ".concat(Ee.kind));
                }
              }
              function ge(Ee) {
                return Ve([Ee], Re(Ee).map(ze), true);
              }
              function Re(Ee) {
                switch (Ee.kind) {
                  case 256:
                  case 257:
                    return [Ee.name.text];
                  case 237:
                    return e2.mapDefined(Ee.declarationList.declarations, function(He) {
                      return e2.isIdentifier(He.name) ? He.name.text : void 0;
                    });
                  case 261:
                  case 260:
                  case 259:
                  case 258:
                  case 265:
                    return e2.emptyArray;
                  case 238:
                    return e2.Debug.fail("Can't export an ExpressionStatement");
                  default:
                    return e2.Debug.assertNever(Ee, "Unexpected decl kind ".concat(Ee.kind));
                }
              }
              function ze(Ee) {
                return e2.factory.createExpressionStatement(e2.factory.createBinaryExpression(e2.factory.createPropertyAccessExpression(e2.factory.createIdentifier("exports"), e2.factory.createIdentifier(Ee)), 63, e2.factory.createIdentifier(Ee)));
              }
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Add or remove braces in an arrow function", Q = e2.Diagnostics.Add_or_remove_braces_in_an_arrow_function.message, le = { name: "Add braces to arrow function", description: e2.Diagnostics.Add_braces_to_arrow_function.message, kind: "refactor.rewrite.arrow.braces.add" }, N = { name: "Remove braces from arrow function", description: e2.Diagnostics.Remove_braces_from_arrow_function.message, kind: "refactor.rewrite.arrow.braces.remove" };
                C.registerRefactor(E, { kinds: [N.kind], getEditsForAction: m2, getAvailableActions: p });
                function p(oe) {
                  var f4 = oe.file, T = oe.startPosition, K = oe.triggerReason, b = G(f4, T, K === "invoked");
                  return b ? C.isRefactorErrorInfo(b) ? oe.preferences.provideRefactorNotApplicableReason ? [{ name: E, description: Q, actions: [Ke(Ke({}, le), { notApplicableReason: b.error }), Ke(Ke({}, N), { notApplicableReason: b.error })] }] : e2.emptyArray : [{ name: E, description: Q, actions: [b.addBraces ? le : N] }] : e2.emptyArray;
                }
                function m2(oe, f4) {
                  var T = oe.file, K = oe.startPosition, b = G(T, K);
                  e2.Debug.assert(b && !C.isRefactorErrorInfo(b), "Expected applicable refactor info");
                  var se = b.expression, J = b.returnStatement, ie = b.func, R;
                  if (f4 === le.name) {
                    var q = e2.factory.createReturnStatement(se);
                    R = e2.factory.createBlock([q], true), e2.copyLeadingComments(se, q, T, 3, true);
                  } else if (f4 === N.name && J) {
                    var O = se || e2.factory.createVoidZero();
                    R = e2.needsParentheses(O) ? e2.factory.createParenthesizedExpression(O) : O, e2.copyTrailingAsLeadingComments(J, R, T, 3, false), e2.copyLeadingComments(J, R, T, 3, false), e2.copyTrailingComments(J, R, T, 3, false);
                  } else
                    e2.Debug.fail("invalid action");
                  var ve = e2.textChanges.ChangeTracker.with(oe, function(ee) {
                    ee.replaceNode(T, ie.body, R);
                  });
                  return { renameFilename: void 0, renameLocation: void 0, edits: ve };
                }
                function G(oe, f4, T, K) {
                  T === void 0 && (T = true);
                  var b = e2.getTokenAtPosition(oe, f4), se = e2.getContainingFunction(b);
                  if (!se)
                    return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_find_a_containing_arrow_function) };
                  if (!e2.isArrowFunction(se))
                    return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Containing_function_is_not_an_arrow_function) };
                  if (!(!e2.rangeContainsRange(se, b) || e2.rangeContainsRange(se.body, b) && !T)) {
                    if (C.refactorKindBeginsWith(le.kind, K) && e2.isExpression(se.body))
                      return { func: se, addBraces: true, expression: se.body };
                    if (C.refactorKindBeginsWith(N.kind, K) && e2.isBlock(se.body) && se.body.statements.length === 1) {
                      var J = e2.first(se.body.statements);
                      if (e2.isReturnStatement(J))
                        return { func: se, addBraces: false, expression: J.expression, returnStatement: J };
                    }
                  }
                }
              })(w = C.addOrRemoveBracesToArrowFunction || (C.addOrRemoveBracesToArrowFunction = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert parameters to destructured object", Q = 1, le = e2.getLocaleSpecificMessage(e2.Diagnostics.Convert_parameters_to_destructured_object), N = { name: E, description: le, kind: "refactor.rewrite.parameters.toDestructured" };
                C.registerRefactor(E, { kinds: [N.kind], getEditsForAction: m2, getAvailableActions: p });
                function p(U) {
                  var j = U.file, H = U.startPosition, I = e2.isSourceFileJS(j);
                  if (I)
                    return e2.emptyArray;
                  var l = ie(j, H, U.program.getTypeChecker());
                  return l ? [{ name: E, description: le, actions: [N] }] : e2.emptyArray;
                }
                function m2(U, j) {
                  e2.Debug.assert(j === E, "Unexpected action name");
                  var H = U.file, I = U.startPosition, l = U.program, d = U.cancellationToken, D = U.host, fe = ie(H, I, l.getTypeChecker());
                  if (!(!fe || !d)) {
                    var g = oe(fe, l, d);
                    if (g.valid) {
                      var ne = e2.textChanges.ChangeTracker.with(U, function(ue) {
                        return G(H, l, D, ue, fe, g);
                      });
                      return { renameFilename: void 0, renameLocation: void 0, edits: ne };
                    }
                    return { edits: [] };
                  }
                }
                function G(U, j, H, I, l, d) {
                  var D = d.signature, fe = e2.map(L(l, j, H), function(ge) {
                    return e2.getSynthesizedDeepClone(ge);
                  });
                  if (D) {
                    var g = e2.map(L(D, j, H), function(ge) {
                      return e2.getSynthesizedDeepClone(ge);
                    });
                    Be(D, g);
                  }
                  Be(l, fe);
                  for (var ne = e2.sortAndDeduplicate(d.functionCalls, function(ge, Re) {
                    return e2.compareValues(ge.pos, Re.pos);
                  }), ue = 0, We = ne; ue < We.length; ue++) {
                    var Fe = We[ue];
                    if (Fe.arguments && Fe.arguments.length) {
                      var Z2 = e2.getSynthesizedDeepClone(V(l, Fe.arguments), true);
                      I.replaceNodeRange(e2.getSourceFileOfNode(Fe), e2.first(Fe.arguments), e2.last(Fe.arguments), Z2, { leadingTriviaOption: e2.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Include });
                    }
                  }
                  function Be(ge, Re) {
                    I.replaceNodeRangeWithNodes(U, e2.first(ge.parameters), e2.last(ge.parameters), Re, { joiner: ", ", indentation: 0, leadingTriviaOption: e2.textChanges.LeadingTriviaOption.IncludeAll, trailingTriviaOption: e2.textChanges.TrailingTriviaOption.Include });
                  }
                }
                function oe(U, j, H) {
                  var I = Y(U), l = e2.isConstructorDeclaration(U) ? k(U) : [], d = e2.deduplicate(Ve(Ve([], I, true), l, true), e2.equateValues), D = j.getTypeChecker(), fe = e2.flatMap(d, function(We) {
                    return e2.FindAllReferences.getReferenceEntriesForNode(-1, We, j, j.getSourceFiles(), H);
                  }), g = ne(fe);
                  return e2.every(g.declarations, function(We) {
                    return e2.contains(d, We);
                  }) || (g.valid = false), g;
                  function ne(We) {
                    for (var Fe = { accessExpressions: [], typeUsages: [] }, Z2 = { functionCalls: [], declarations: [], classReferences: Fe, valid: true }, Be = e2.map(I, ue), ge = e2.map(l, ue), Re = e2.isConstructorDeclaration(U), ze = e2.map(I, function(er) {
                      return f4(er, D);
                    }), Ee = 0, He = We; Ee < He.length; Ee++) {
                      var rr = He[Ee];
                      if (rr.kind === 0) {
                        Z2.valid = false;
                        continue;
                      }
                      if (e2.contains(ze, ue(rr.node))) {
                        if (q(rr.node.parent)) {
                          Z2.signature = rr.node.parent;
                          continue;
                        }
                        var Ie = b(rr);
                        if (Ie) {
                          Z2.functionCalls.push(Ie);
                          continue;
                        }
                      }
                      var _e = f4(rr.node, D);
                      if (_e && e2.contains(ze, _e)) {
                        var we = K(rr);
                        if (we) {
                          Z2.declarations.push(we);
                          continue;
                        }
                      }
                      if (e2.contains(Be, ue(rr.node)) || e2.isNewExpressionTarget(rr.node)) {
                        var de = T(rr);
                        if (de)
                          continue;
                        var we = K(rr);
                        if (we) {
                          Z2.declarations.push(we);
                          continue;
                        }
                        var Ie = b(rr);
                        if (Ie) {
                          Z2.functionCalls.push(Ie);
                          continue;
                        }
                      }
                      if (Re && e2.contains(ge, ue(rr.node))) {
                        var de = T(rr);
                        if (de)
                          continue;
                        var we = K(rr);
                        if (we) {
                          Z2.declarations.push(we);
                          continue;
                        }
                        var ye = se(rr);
                        if (ye) {
                          Fe.accessExpressions.push(ye);
                          continue;
                        }
                        if (e2.isClassDeclaration(U.parent)) {
                          var Ae = J(rr);
                          if (Ae) {
                            Fe.typeUsages.push(Ae);
                            continue;
                          }
                        }
                      }
                      Z2.valid = false;
                    }
                    return Z2;
                  }
                  function ue(We) {
                    var Fe = D.getSymbolAtLocation(We);
                    return Fe && e2.getSymbolTarget(Fe, D);
                  }
                }
                function f4(U, j) {
                  var H = e2.getContainingObjectLiteralElement(U);
                  if (H) {
                    var I = j.getContextualTypeForObjectLiteralElement(H), l = I == null ? void 0 : I.getSymbol();
                    if (l && !(e2.getCheckFlags(l) & 6))
                      return l;
                  }
                }
                function T(U) {
                  var j = U.node;
                  if (e2.isImportSpecifier(j.parent) || e2.isImportClause(j.parent) || e2.isImportEqualsDeclaration(j.parent) || e2.isNamespaceImport(j.parent) || e2.isExportSpecifier(j.parent) || e2.isExportAssignment(j.parent))
                    return j;
                }
                function K(U) {
                  if (e2.isDeclaration(U.node.parent))
                    return U.node;
                }
                function b(U) {
                  if (U.node.parent) {
                    var j = U.node, H = j.parent;
                    switch (H.kind) {
                      case 208:
                      case 209:
                        var I = e2.tryCast(H, e2.isCallOrNewExpression);
                        if (I && I.expression === j)
                          return I;
                        break;
                      case 206:
                        var l = e2.tryCast(H, e2.isPropertyAccessExpression);
                        if (l && l.parent && l.name === j) {
                          var d = e2.tryCast(l.parent, e2.isCallOrNewExpression);
                          if (d && d.expression === l)
                            return d;
                        }
                        break;
                      case 207:
                        var D = e2.tryCast(H, e2.isElementAccessExpression);
                        if (D && D.parent && D.argumentExpression === j) {
                          var fe = e2.tryCast(D.parent, e2.isCallOrNewExpression);
                          if (fe && fe.expression === D)
                            return fe;
                        }
                        break;
                    }
                  }
                }
                function se(U) {
                  if (U.node.parent) {
                    var j = U.node, H = j.parent;
                    switch (H.kind) {
                      case 206:
                        var I = e2.tryCast(H, e2.isPropertyAccessExpression);
                        if (I && I.expression === j)
                          return I;
                        break;
                      case 207:
                        var l = e2.tryCast(H, e2.isElementAccessExpression);
                        if (l && l.expression === j)
                          return l;
                        break;
                    }
                  }
                }
                function J(U) {
                  var j = U.node;
                  if (e2.getMeaningFromLocation(j) === 2 || e2.isExpressionWithTypeArgumentsInClassExtendsClause(j.parent))
                    return j;
                }
                function ie(U, j, H) {
                  var I = e2.getTouchingToken(U, j), l = e2.getContainingFunctionDeclaration(I);
                  if (!R(I) && l && O(l, H) && e2.rangeContainsRange(l, I) && !(l.body && e2.rangeContainsRange(l.body, I)))
                    return l;
                }
                function R(U) {
                  var j = e2.findAncestor(U, e2.isJSDocNode);
                  if (j) {
                    var H = e2.findAncestor(j, function(I) {
                      return !e2.isJSDocNode(I);
                    });
                    return !!H && e2.isFunctionLikeDeclaration(H);
                  }
                  return false;
                }
                function q(U) {
                  return e2.isMethodSignature(U) && (e2.isInterfaceDeclaration(U.parent) || e2.isTypeLiteralNode(U.parent));
                }
                function O(U, j) {
                  var H;
                  if (!he(U.parameters, j))
                    return false;
                  switch (U.kind) {
                    case 256:
                      return ee(U) && ve(U, j);
                    case 169:
                      if (e2.isObjectLiteralExpression(U.parent)) {
                        var I = f4(U.name, j);
                        return ((H = I == null ? void 0 : I.declarations) === null || H === void 0 ? void 0 : H.length) === 1 && ve(U, j);
                      }
                      return ve(U, j);
                    case 171:
                      return e2.isClassDeclaration(U.parent) ? ee(U.parent) && ve(U, j) : x2(U.parent.parent) && ve(U, j);
                    case 213:
                    case 214:
                      return x2(U.parent);
                  }
                  return false;
                }
                function ve(U, j) {
                  return !!U.body && !j.isImplementationOfOverload(U);
                }
                function ee(U) {
                  if (!U.name) {
                    var j = e2.findModifier(U, 88);
                    return !!j;
                  }
                  return true;
                }
                function he(U, j) {
                  return $(U) >= Q && e2.every(U, function(H) {
                    return F2(H, j);
                  });
                }
                function F2(U, j) {
                  if (e2.isRestParameter(U)) {
                    var H = j.getTypeAtLocation(U);
                    if (!j.isArrayType(H) && !j.isTupleType(H))
                      return false;
                  }
                  return !U.modifiers && !U.decorators && e2.isIdentifier(U.name);
                }
                function x2(U) {
                  return e2.isVariableDeclaration(U) && e2.isVarConst(U) && e2.isIdentifier(U.name) && !U.type;
                }
                function X(U) {
                  return U.length > 0 && e2.isThis(U[0].name);
                }
                function $(U) {
                  return X(U) ? U.length - 1 : U.length;
                }
                function A2(U) {
                  return X(U) && (U = e2.factory.createNodeArray(U.slice(1), U.hasTrailingComma)), U;
                }
                function y(U, j) {
                  return e2.isIdentifier(j) && e2.getTextOfIdentifierOrLiteral(j) === U ? e2.factory.createShorthandPropertyAssignment(U) : e2.factory.createPropertyAssignment(U, j);
                }
                function V(U, j) {
                  var H = A2(U.parameters), I = e2.isRestParameter(e2.last(H)), l = I ? j.slice(0, H.length - 1) : j, d = e2.map(l, function(ne, ue) {
                    var We = P(H[ue]), Fe = y(We, ne);
                    return e2.suppressLeadingAndTrailingTrivia(Fe.name), e2.isPropertyAssignment(Fe) && e2.suppressLeadingAndTrailingTrivia(Fe.initializer), e2.copyComments(ne, Fe), Fe;
                  });
                  if (I && j.length >= H.length) {
                    var D = j.slice(H.length - 1), fe = e2.factory.createPropertyAssignment(P(e2.last(H)), e2.factory.createArrayLiteralExpression(D));
                    d.push(fe);
                  }
                  var g = e2.factory.createObjectLiteralExpression(d, false);
                  return g;
                }
                function L(U, j, H) {
                  var I = j.getTypeChecker(), l = A2(U.parameters), d = e2.map(l, Fe), D = e2.factory.createObjectBindingPattern(d), fe = Z2(l), g;
                  e2.every(l, Re) && (g = e2.factory.createObjectLiteralExpression());
                  var ne = e2.factory.createParameterDeclaration(void 0, void 0, void 0, D, void 0, fe, g);
                  if (X(U.parameters)) {
                    var ue = U.parameters[0], We = e2.factory.createParameterDeclaration(void 0, void 0, void 0, ue.name, void 0, ue.type);
                    return e2.suppressLeadingAndTrailingTrivia(We.name), e2.copyComments(ue.name, We.name), ue.type && (e2.suppressLeadingAndTrailingTrivia(We.type), e2.copyComments(ue.type, We.type)), e2.factory.createNodeArray([We, ne]);
                  }
                  return e2.factory.createNodeArray([ne]);
                  function Fe(ze) {
                    var Ee = e2.factory.createBindingElement(void 0, void 0, P(ze), e2.isRestParameter(ze) && Re(ze) ? e2.factory.createArrayLiteralExpression() : ze.initializer);
                    return e2.suppressLeadingAndTrailingTrivia(Ee), ze.initializer && Ee.initializer && e2.copyComments(ze.initializer, Ee.initializer), Ee;
                  }
                  function Z2(ze) {
                    var Ee = e2.map(ze, Be), He = e2.addEmitFlags(e2.factory.createTypeLiteralNode(Ee), 1);
                    return He;
                  }
                  function Be(ze) {
                    var Ee = ze.type;
                    !Ee && (ze.initializer || e2.isRestParameter(ze)) && (Ee = ge(ze));
                    var He = e2.factory.createPropertySignature(void 0, P(ze), Re(ze) ? e2.factory.createToken(57) : ze.questionToken, Ee);
                    return e2.suppressLeadingAndTrailingTrivia(He), e2.copyComments(ze.name, He.name), ze.type && He.type && e2.copyComments(ze.type, He.type), He;
                  }
                  function ge(ze) {
                    var Ee = I.getTypeAtLocation(ze);
                    return e2.getTypeNodeIfAccessible(Ee, ze, j, H);
                  }
                  function Re(ze) {
                    if (e2.isRestParameter(ze)) {
                      var Ee = I.getTypeAtLocation(ze);
                      return !I.isTupleType(Ee);
                    }
                    return I.isOptionalParameter(ze);
                  }
                }
                function P(U) {
                  return e2.getTextOfIdentifierOrLiteral(U.name);
                }
                function k(U) {
                  switch (U.parent.kind) {
                    case 257:
                      var j = U.parent;
                      if (j.name)
                        return [j.name];
                      var H = e2.Debug.checkDefined(e2.findModifier(j, 88), "Nameless class declaration should be a default export");
                      return [H];
                    case 226:
                      var I = U.parent, l = U.parent.parent, d = I.name;
                      return d ? [d, l.name] : [l.name];
                  }
                }
                function Y(U) {
                  switch (U.kind) {
                    case 256:
                      if (U.name)
                        return [U.name];
                      var j = e2.Debug.checkDefined(e2.findModifier(U, 88), "Nameless function declaration should be a default export");
                      return [j];
                    case 169:
                      return [U.name];
                    case 171:
                      var H = e2.Debug.checkDefined(e2.findChildOfKind(U, 134, U.getSourceFile()), "Constructor declaration should have constructor keyword");
                      if (U.parent.kind === 226) {
                        var I = U.parent.parent;
                        return [I.name, H];
                      }
                      return [H];
                    case 214:
                      return [U.parent.name];
                    case 213:
                      return U.name ? [U.name, U.parent.name] : [U.parent.name];
                    default:
                      return e2.Debug.assertNever(U, "Unexpected function declaration kind ".concat(U.kind));
                  }
                }
              })(w = C.convertParamsToDestructuredObject || (C.convertParamsToDestructuredObject = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert to template string", Q = e2.getLocaleSpecificMessage(e2.Diagnostics.Convert_to_template_string), le = { name: E, description: Q, kind: "refactor.rewrite.string" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: m2, getAvailableActions: N });
                function N(ve) {
                  var ee = ve.file, he = ve.startPosition, F2 = p(ee, he), x2 = f4(F2), X = { name: E, description: Q, actions: [] };
                  return e2.isBinaryExpression(x2) && T(x2).isValidConcatenation ? (X.actions.push(le), [X]) : ve.preferences.provideRefactorNotApplicableReason ? (X.actions.push(Ke(Ke({}, le), { notApplicableReason: e2.getLocaleSpecificMessage(e2.Diagnostics.Can_only_convert_string_concatenation) })), [X]) : e2.emptyArray;
                }
                function p(ve, ee) {
                  var he = e2.getTokenAtPosition(ve, ee), F2 = f4(he), x2 = !T(F2).isValidConcatenation;
                  return x2 && e2.isParenthesizedExpression(F2.parent) && e2.isBinaryExpression(F2.parent.parent) ? F2.parent.parent : he;
                }
                function m2(ve, ee) {
                  var he = ve.file, F2 = ve.startPosition, x2 = p(he, F2);
                  switch (ee) {
                    case Q:
                      return { edits: G(ve, x2) };
                    default:
                      return e2.Debug.fail("invalid action");
                  }
                }
                function G(ve, ee) {
                  var he = f4(ee), F2 = ve.file, x2 = R(T(he), F2), X = e2.getTrailingCommentRanges(F2.text, he.end);
                  if (X) {
                    var $ = X[X.length - 1], A2 = { pos: X[0].pos, end: $.end };
                    return e2.textChanges.ChangeTracker.with(ve, function(y) {
                      y.deleteRange(F2, A2), y.replaceNode(F2, he, x2);
                    });
                  } else
                    return e2.textChanges.ChangeTracker.with(ve, function(y) {
                      return y.replaceNode(F2, he, x2);
                    });
                }
                function oe(ve) {
                  return ve.operatorToken.kind !== 63;
                }
                function f4(ve) {
                  var ee = e2.findAncestor(ve.parent, function(he) {
                    switch (he.kind) {
                      case 206:
                      case 207:
                        return false;
                      case 223:
                      case 221:
                        return !(e2.isBinaryExpression(he.parent) && oe(he.parent));
                      default:
                        return "quit";
                    }
                  });
                  return ee || ve;
                }
                function T(ve) {
                  var ee = function(A2) {
                    if (!e2.isBinaryExpression(A2))
                      return { nodes: [A2], operators: [], validOperators: true, hasString: e2.isStringLiteral(A2) || e2.isNoSubstitutionTemplateLiteral(A2) };
                    var y = ee(A2.left), V = y.nodes, L = y.operators, P = y.hasString, k = y.validOperators;
                    if (!(P || e2.isStringLiteral(A2.right) || e2.isTemplateExpression(A2.right)))
                      return { nodes: [A2], operators: [], hasString: false, validOperators: true };
                    var Y = A2.operatorToken.kind === 39, U = k && Y;
                    return V.push(A2.right), L.push(A2.operatorToken), { nodes: V, operators: L, hasString: true, validOperators: U };
                  }, he = ee(ve), F2 = he.nodes, x2 = he.operators, X = he.validOperators, $ = he.hasString;
                  return { nodes: F2, operators: x2, isValidConcatenation: X && $ };
                }
                var K = function(ve, ee) {
                  return function(he, F2) {
                    he < ve.length && e2.copyTrailingComments(ve[he], F2, ee, 3, false);
                  };
                }, b = function(ve, ee, he) {
                  return function(F2, x2) {
                    for (; F2.length > 0; ) {
                      var X = F2.shift();
                      e2.copyTrailingComments(ve[X], x2, ee, 3, false), he(X, x2);
                    }
                  };
                };
                function se(ve) {
                  return ve.replace(/\\.|[$`]/g, function(ee) {
                    return ee[0] === "\\" ? ee : "\\" + ee;
                  });
                }
                function J(ve) {
                  var ee = e2.isTemplateHead(ve) || e2.isTemplateMiddle(ve) ? -2 : -1;
                  return e2.getTextOfNode(ve).slice(1, ee);
                }
                function ie(ve, ee) {
                  for (var he = [], F2 = "", x2 = ""; ve < ee.length; ) {
                    var X = ee[ve];
                    if (e2.isStringLiteralLike(X))
                      F2 += X.text, x2 += se(e2.getTextOfNode(X).slice(1, -1)), he.push(ve), ve++;
                    else if (e2.isTemplateExpression(X)) {
                      F2 += X.head.text, x2 += J(X.head);
                      break;
                    } else
                      break;
                  }
                  return [ve, F2, x2, he];
                }
                function R(ve, ee) {
                  var he = ve.nodes, F2 = ve.operators, x2 = K(F2, ee), X = b(he, ee, x2), $ = ie(0, he), A2 = $[0], y = $[1], V = $[2], L = $[3];
                  if (A2 === he.length) {
                    var P = e2.factory.createNoSubstitutionTemplateLiteral(y, V);
                    return X(L, P), P;
                  }
                  var k = [], Y = e2.factory.createTemplateHead(y, V);
                  X(L, Y);
                  for (var U = function(I) {
                    var l = O(he[I]);
                    x2(I, l);
                    var d = ie(I + 1, he), D = d[0], fe = d[1], g = d[2], ne = d[3];
                    I = D - 1;
                    var ue = I === he.length - 1;
                    if (e2.isTemplateExpression(l)) {
                      var We = e2.map(l.templateSpans, function(Z2, Be) {
                        q(Z2);
                        var ge = Be === l.templateSpans.length - 1, Re = Z2.literal.text + (ge ? fe : ""), ze = J(Z2.literal) + (ge ? g : "");
                        return e2.factory.createTemplateSpan(Z2.expression, ue && ge ? e2.factory.createTemplateTail(Re, ze) : e2.factory.createTemplateMiddle(Re, ze));
                      });
                      k.push.apply(k, We);
                    } else {
                      var Fe = ue ? e2.factory.createTemplateTail(fe, g) : e2.factory.createTemplateMiddle(fe, g);
                      X(ne, Fe), k.push(e2.factory.createTemplateSpan(l, Fe));
                    }
                    j = I;
                  }, j, H = A2; H < he.length; H++)
                    U(H), H = j;
                  return e2.factory.createTemplateExpression(Y, k);
                }
                function q(ve) {
                  var ee = ve.getSourceFile();
                  e2.copyTrailingComments(ve, ve.expression, ee, 3, false), e2.copyTrailingAsLeadingComments(ve.expression, ve.expression, ee, 3, false);
                }
                function O(ve) {
                  return e2.isParenthesizedExpression(ve) && (q(ve), ve = ve.expression), ve;
                }
              })(w = C.convertStringOrTemplateLiteral || (C.convertStringOrTemplateLiteral = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Convert arrow function or function expression", Q = e2.getLocaleSpecificMessage(e2.Diagnostics.Convert_arrow_function_or_function_expression), le = { name: "Convert to anonymous function", description: e2.getLocaleSpecificMessage(e2.Diagnostics.Convert_to_anonymous_function), kind: "refactor.rewrite.function.anonymous" }, N = { name: "Convert to named function", description: e2.getLocaleSpecificMessage(e2.Diagnostics.Convert_to_named_function), kind: "refactor.rewrite.function.named" }, p = { name: "Convert to arrow function", description: e2.getLocaleSpecificMessage(e2.Diagnostics.Convert_to_arrow_function), kind: "refactor.rewrite.function.arrow" };
                C.registerRefactor(E, { kinds: [le.kind, N.kind, p.kind], getEditsForAction: G, getAvailableActions: m2 });
                function m2(ve) {
                  var ee = ve.file, he = ve.startPosition, F2 = ve.program, x2 = ve.kind, X = f4(ee, he, F2);
                  if (!X)
                    return e2.emptyArray;
                  var $ = X.selectedVariableDeclaration, A2 = X.func, y = [], V = [];
                  if (C.refactorKindBeginsWith(N.kind, x2)) {
                    var L = $ || e2.isArrowFunction(A2) && e2.isVariableDeclaration(A2.parent) ? void 0 : e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_convert_to_named_function);
                    L ? V.push(Ke(Ke({}, N), { notApplicableReason: L })) : y.push(N);
                  }
                  if (C.refactorKindBeginsWith(le.kind, x2)) {
                    var L = !$ && e2.isArrowFunction(A2) ? void 0 : e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_convert_to_anonymous_function);
                    L ? V.push(Ke(Ke({}, le), { notApplicableReason: L })) : y.push(le);
                  }
                  if (C.refactorKindBeginsWith(p.kind, x2)) {
                    var L = e2.isFunctionExpression(A2) ? void 0 : e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_convert_to_arrow_function);
                    L ? V.push(Ke(Ke({}, p), { notApplicableReason: L })) : y.push(p);
                  }
                  return [{ name: E, description: Q, actions: y.length === 0 && ve.preferences.provideRefactorNotApplicableReason ? V : y }];
                }
                function G(ve, ee) {
                  var he = ve.file, F2 = ve.startPosition, x2 = ve.program, X = f4(he, F2, x2);
                  if (!!X) {
                    var $ = X.func, A2 = [];
                    switch (ee) {
                      case le.name:
                        A2.push.apply(A2, J(ve, $));
                        break;
                      case N.name:
                        var y = se($);
                        if (!y)
                          return;
                        A2.push.apply(A2, ie(ve, $, y));
                        break;
                      case p.name:
                        if (!e2.isFunctionExpression($))
                          return;
                        A2.push.apply(A2, R(ve, $));
                        break;
                      default:
                        return e2.Debug.fail("invalid action");
                    }
                    return { renameFilename: void 0, renameLocation: void 0, edits: A2 };
                  }
                }
                function oe(ve) {
                  var ee = false;
                  return ve.forEachChild(function he(F2) {
                    if (e2.isThis(F2)) {
                      ee = true;
                      return;
                    }
                    !e2.isClassLike(F2) && !e2.isFunctionDeclaration(F2) && !e2.isFunctionExpression(F2) && e2.forEachChild(F2, he);
                  }), ee;
                }
                function f4(ve, ee, he) {
                  var F2 = e2.getTokenAtPosition(ve, ee), x2 = he.getTypeChecker(), X = K(ve, x2, F2.parent);
                  if (X && !oe(X.body) && !x2.containsArgumentsReference(X))
                    return { selectedVariableDeclaration: true, func: X };
                  var $ = e2.getContainingFunction(F2);
                  if ($ && (e2.isFunctionExpression($) || e2.isArrowFunction($)) && !e2.rangeContainsRange($.body, F2) && !oe($.body) && !x2.containsArgumentsReference($))
                    return e2.isFunctionExpression($) && O(ve, x2, $) ? void 0 : { selectedVariableDeclaration: false, func: $ };
                }
                function T(ve) {
                  return e2.isVariableDeclaration(ve) || e2.isVariableDeclarationList(ve) && ve.declarations.length === 1;
                }
                function K(ve, ee, he) {
                  if (!!T(he)) {
                    var F2 = e2.isVariableDeclaration(he) ? he : e2.first(he.declarations), x2 = F2.initializer;
                    if (x2 && (e2.isArrowFunction(x2) || e2.isFunctionExpression(x2) && !O(ve, ee, x2)))
                      return x2;
                  }
                }
                function b(ve) {
                  if (e2.isExpression(ve)) {
                    var ee = e2.factory.createReturnStatement(ve), he = ve.getSourceFile();
                    return e2.suppressLeadingAndTrailingTrivia(ee), e2.copyTrailingAsLeadingComments(ve, ee, he, void 0, true), e2.factory.createBlock([ee], true);
                  } else
                    return ve;
                }
                function se(ve) {
                  var ee = ve.parent;
                  if (!(!e2.isVariableDeclaration(ee) || !e2.isVariableDeclarationInVariableStatement(ee))) {
                    var he = ee.parent, F2 = he.parent;
                    if (!(!e2.isVariableDeclarationList(he) || !e2.isVariableStatement(F2) || !e2.isIdentifier(ee.name)))
                      return { variableDeclaration: ee, variableDeclarationList: he, statement: F2, name: ee.name };
                  }
                }
                function J(ve, ee) {
                  var he = ve.file, F2 = b(ee.body), x2 = e2.factory.createFunctionExpression(ee.modifiers, ee.asteriskToken, void 0, ee.typeParameters, ee.parameters, ee.type, F2);
                  return e2.textChanges.ChangeTracker.with(ve, function(X) {
                    return X.replaceNode(he, ee, x2);
                  });
                }
                function ie(ve, ee, he) {
                  var F2 = ve.file, x2 = b(ee.body), X = he.variableDeclaration, $ = he.variableDeclarationList, A2 = he.statement, y = he.name;
                  e2.suppressLeadingTrivia(A2);
                  var V = e2.getCombinedModifierFlags(X) & 1 | e2.getEffectiveModifierFlags(ee), L = e2.factory.createModifiersFromModifierFlags(V), P = e2.factory.createFunctionDeclaration(ee.decorators, e2.length(L) ? L : void 0, ee.asteriskToken, y, ee.typeParameters, ee.parameters, ee.type, x2);
                  return $.declarations.length === 1 ? e2.textChanges.ChangeTracker.with(ve, function(k) {
                    return k.replaceNode(F2, A2, P);
                  }) : e2.textChanges.ChangeTracker.with(ve, function(k) {
                    k.delete(F2, X), k.insertNodeAfter(F2, A2, P);
                  });
                }
                function R(ve, ee) {
                  var he = ve.file, F2 = ee.body.statements, x2 = F2[0], X;
                  q(ee.body, x2) ? (X = x2.expression, e2.suppressLeadingAndTrailingTrivia(X), e2.copyComments(x2, X)) : X = ee.body;
                  var $ = e2.factory.createArrowFunction(ee.modifiers, ee.typeParameters, ee.parameters, ee.type, e2.factory.createToken(38), X);
                  return e2.textChanges.ChangeTracker.with(ve, function(A2) {
                    return A2.replaceNode(he, ee, $);
                  });
                }
                function q(ve, ee) {
                  return ve.statements.length === 1 && e2.isReturnStatement(ee) && !!ee.expression;
                }
                function O(ve, ee, he) {
                  return !!he.name && e2.FindAllReferences.Core.isSymbolReferencedInFile(he.name, ee, ve);
                }
              })(w = C.convertArrowFunctionOrFunctionExpression || (C.convertArrowFunctionOrFunctionExpression = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              var w;
              (function(B) {
                var E = "Infer function return type", Q = e2.Diagnostics.Infer_function_return_type.message, le = { name: E, description: Q, kind: "refactor.rewrite.function.returnType" };
                C.registerRefactor(E, { kinds: [le.kind], getEditsForAction: N, getAvailableActions: p });
                function N(T) {
                  var K = G(T);
                  if (K && !C.isRefactorErrorInfo(K)) {
                    var b = e2.textChanges.ChangeTracker.with(T, function(se) {
                      return m2(T.file, se, K.declaration, K.returnTypeNode);
                    });
                    return { renameFilename: void 0, renameLocation: void 0, edits: b };
                  }
                }
                function p(T) {
                  var K = G(T);
                  return K ? C.isRefactorErrorInfo(K) ? T.preferences.provideRefactorNotApplicableReason ? [{ name: E, description: Q, actions: [Ke(Ke({}, le), { notApplicableReason: K.error })] }] : e2.emptyArray : [{ name: E, description: Q, actions: [le] }] : e2.emptyArray;
                }
                function m2(T, K, b, se) {
                  var J = e2.findChildOfKind(b, 21, T), ie = e2.isArrowFunction(b) && J === void 0, R = ie ? e2.first(b.parameters) : J;
                  R && (ie && (K.insertNodeBefore(T, R, e2.factory.createToken(20)), K.insertNodeAfter(T, R, e2.factory.createToken(21))), K.insertNodeAt(T, R.end, se, { prefix: ": " }));
                }
                function G(T) {
                  if (!(e2.isInJSFile(T.file) || !C.refactorKindBeginsWith(le.kind, T.kind))) {
                    var K = e2.getTokenAtPosition(T.file, T.startPosition), b = e2.findAncestor(K, function(R) {
                      return e2.isBlock(R) || R.parent && e2.isArrowFunction(R.parent) && (R.kind === 38 || R.parent.body === R) ? "quit" : oe(R);
                    });
                    if (!b || !b.body || b.type)
                      return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Return_type_must_be_inferred_from_a_function) };
                    var se = T.program.getTypeChecker(), J = f4(se, b);
                    if (!J)
                      return { error: e2.getLocaleSpecificMessage(e2.Diagnostics.Could_not_determine_function_return_type) };
                    var ie = se.typeToTypeNode(J, b, 1);
                    if (ie)
                      return { declaration: b, returnTypeNode: ie };
                  }
                }
                function oe(T) {
                  switch (T.kind) {
                    case 256:
                    case 213:
                    case 214:
                    case 169:
                      return true;
                    default:
                      return false;
                  }
                }
                function f4(T, K) {
                  if (T.isImplementationOfOverload(K)) {
                    var b = T.getTypeAtLocation(K).getCallSignatures();
                    if (b.length > 1)
                      return T.getUnionType(e2.mapDefined(b, function(J) {
                        return J.getReturnType();
                      }));
                  }
                  var se = T.getSignatureFromDeclaration(K);
                  if (se)
                    return T.getReturnTypeOfSignature(se);
                }
              })(w = C.inferFunctionReturnType || (C.inferFunctionReturnType = {}));
            })(a = e2.refactor || (e2.refactor = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            e2.servicesVersion = "0.8";
            function a(g, ne, ue, We) {
              var Fe = e2.isNodeKind(g) ? new C(g, ne, ue) : g === 79 ? new p(79, ne, ue) : g === 80 ? new m2(80, ne, ue) : new N(g, ne, ue);
              return Fe.parent = We, Fe.flags = We.flags & 50720768, Fe;
            }
            var C = function() {
              function g(ne, ue, We) {
                this.pos = ue, this.end = We, this.flags = 0, this.modifierFlagsCache = 0, this.transformFlags = 0, this.parent = void 0, this.kind = ne;
              }
              return g.prototype.assertHasRealPosition = function(ne) {
                e2.Debug.assert(!e2.positionIsSynthesized(this.pos) && !e2.positionIsSynthesized(this.end), ne || "Node must have a real position for this operation");
              }, g.prototype.getSourceFile = function() {
                return e2.getSourceFileOfNode(this);
              }, g.prototype.getStart = function(ne, ue) {
                return this.assertHasRealPosition(), e2.getTokenPosOfNode(this, ne, ue);
              }, g.prototype.getFullStart = function() {
                return this.assertHasRealPosition(), this.pos;
              }, g.prototype.getEnd = function() {
                return this.assertHasRealPosition(), this.end;
              }, g.prototype.getWidth = function(ne) {
                return this.assertHasRealPosition(), this.getEnd() - this.getStart(ne);
              }, g.prototype.getFullWidth = function() {
                return this.assertHasRealPosition(), this.end - this.pos;
              }, g.prototype.getLeadingTriviaWidth = function(ne) {
                return this.assertHasRealPosition(), this.getStart(ne) - this.pos;
              }, g.prototype.getFullText = function(ne) {
                return this.assertHasRealPosition(), (ne || this.getSourceFile()).text.substring(this.pos, this.end);
              }, g.prototype.getText = function(ne) {
                return this.assertHasRealPosition(), ne || (ne = this.getSourceFile()), ne.text.substring(this.getStart(ne), this.getEnd());
              }, g.prototype.getChildCount = function(ne) {
                return this.getChildren(ne).length;
              }, g.prototype.getChildAt = function(ne, ue) {
                return this.getChildren(ue)[ne];
              }, g.prototype.getChildren = function(ne) {
                return this.assertHasRealPosition("Node without a real position cannot be scanned and thus has no token nodes - use forEachChild and collect the result if that's fine"), this._children || (this._children = w(this, ne));
              }, g.prototype.getFirstToken = function(ne) {
                this.assertHasRealPosition();
                var ue = this.getChildren(ne);
                if (!!ue.length) {
                  var We = e2.find(ue, function(Fe) {
                    return Fe.kind < 309 || Fe.kind > 347;
                  });
                  return We.kind < 161 ? We : We.getFirstToken(ne);
                }
              }, g.prototype.getLastToken = function(ne) {
                this.assertHasRealPosition();
                var ue = this.getChildren(ne), We = e2.lastOrUndefined(ue);
                if (!!We)
                  return We.kind < 161 ? We : We.getLastToken(ne);
              }, g.prototype.forEachChild = function(ne, ue) {
                return e2.forEachChild(this, ne, ue);
              }, g;
            }();
            function w(g, ne) {
              if (!e2.isNodeKind(g.kind))
                return e2.emptyArray;
              var ue = [];
              if (e2.isJSDocCommentContainingNode(g))
                return g.forEachChild(function(Be) {
                  ue.push(Be);
                }), ue;
              e2.scanner.setText((ne || g.getSourceFile()).text);
              var We = g.pos, Fe = function(Be) {
                B(ue, We, Be.pos, g), ue.push(Be), We = Be.end;
              }, Z2 = function(Be) {
                B(ue, We, Be.pos, g), ue.push(E(Be, g)), We = Be.end;
              };
              return e2.forEach(g.jsDoc, Fe), We = g.pos, g.forEachChild(Fe, Z2), B(ue, We, g.end, g), e2.scanner.setText(void 0), ue;
            }
            function B(g, ne, ue, We) {
              for (e2.scanner.setTextPos(ne); ne < ue; ) {
                var Fe = e2.scanner.scan(), Z2 = e2.scanner.getTextPos();
                if (Z2 <= ue && (Fe === 79 && e2.Debug.fail("Did not expect ".concat(e2.Debug.formatSyntaxKind(We.kind), " to have an Identifier in its trivia")), g.push(a(Fe, ne, Z2, We))), ne = Z2, Fe === 1)
                  break;
              }
            }
            function E(g, ne) {
              var ue = a(348, g.pos, g.end, ne);
              ue._children = [];
              for (var We = g.pos, Fe = 0, Z2 = g; Fe < Z2.length; Fe++) {
                var Be = Z2[Fe];
                B(ue._children, We, Be.pos, ne), ue._children.push(Be), We = Be.end;
              }
              return B(ue._children, We, g.end, ne), ue;
            }
            var Q = function() {
              function g(ne, ue) {
                this.pos = ne, this.end = ue, this.flags = 0, this.modifierFlagsCache = 0, this.transformFlags = 0, this.parent = void 0;
              }
              return g.prototype.getSourceFile = function() {
                return e2.getSourceFileOfNode(this);
              }, g.prototype.getStart = function(ne, ue) {
                return e2.getTokenPosOfNode(this, ne, ue);
              }, g.prototype.getFullStart = function() {
                return this.pos;
              }, g.prototype.getEnd = function() {
                return this.end;
              }, g.prototype.getWidth = function(ne) {
                return this.getEnd() - this.getStart(ne);
              }, g.prototype.getFullWidth = function() {
                return this.end - this.pos;
              }, g.prototype.getLeadingTriviaWidth = function(ne) {
                return this.getStart(ne) - this.pos;
              }, g.prototype.getFullText = function(ne) {
                return (ne || this.getSourceFile()).text.substring(this.pos, this.end);
              }, g.prototype.getText = function(ne) {
                return ne || (ne = this.getSourceFile()), ne.text.substring(this.getStart(ne), this.getEnd());
              }, g.prototype.getChildCount = function() {
                return this.getChildren().length;
              }, g.prototype.getChildAt = function(ne) {
                return this.getChildren()[ne];
              }, g.prototype.getChildren = function() {
                return this.kind === 1 && this.jsDoc || e2.emptyArray;
              }, g.prototype.getFirstToken = function() {
              }, g.prototype.getLastToken = function() {
              }, g.prototype.forEachChild = function() {
              }, g;
            }(), le = function() {
              function g(ne, ue) {
                this.flags = ne, this.escapedName = ue;
              }
              return g.prototype.getFlags = function() {
                return this.flags;
              }, Object.defineProperty(g.prototype, "name", { get: function() {
                return e2.symbolName(this);
              }, enumerable: false, configurable: true }), g.prototype.getEscapedName = function() {
                return this.escapedName;
              }, g.prototype.getName = function() {
                return this.name;
              }, g.prototype.getDeclarations = function() {
                return this.declarations;
              }, g.prototype.getDocumentationComment = function(ne) {
                if (!this.documentationComment)
                  if (this.documentationComment = e2.emptyArray, !this.declarations && this.target && this.target.tupleLabelDeclaration) {
                    var ue = this.target.tupleLabelDeclaration;
                    this.documentationComment = K([ue], ne);
                  } else
                    this.documentationComment = K(this.declarations, ne);
                return this.documentationComment;
              }, g.prototype.getContextualDocumentationComment = function(ne, ue) {
                switch (ne == null ? void 0 : ne.kind) {
                  case 172:
                    return this.contextualGetAccessorDocumentationComment || (this.contextualGetAccessorDocumentationComment = K(e2.filter(this.declarations, e2.isGetAccessor), ue)), this.contextualGetAccessorDocumentationComment;
                  case 173:
                    return this.contextualSetAccessorDocumentationComment || (this.contextualSetAccessorDocumentationComment = K(e2.filter(this.declarations, e2.isSetAccessor), ue)), this.contextualSetAccessorDocumentationComment;
                  default:
                    return this.getDocumentationComment(ue);
                }
              }, g.prototype.getJsDocTags = function(ne) {
                return this.tags === void 0 && (this.tags = T(this.declarations, ne)), this.tags;
              }, g.prototype.getContextualJsDocTags = function(ne, ue) {
                switch (ne == null ? void 0 : ne.kind) {
                  case 172:
                    return this.contextualGetAccessorTags || (this.contextualGetAccessorTags = T(e2.filter(this.declarations, e2.isGetAccessor), ue)), this.contextualGetAccessorTags;
                  case 173:
                    return this.contextualSetAccessorTags || (this.contextualSetAccessorTags = T(e2.filter(this.declarations, e2.isSetAccessor), ue)), this.contextualSetAccessorTags;
                  default:
                    return this.getJsDocTags(ue);
                }
              }, g;
            }(), N = function(g) {
              Lr(ne, g);
              function ne(ue, We, Fe) {
                var Z2 = g.call(this, We, Fe) || this;
                return Z2.kind = ue, Z2;
              }
              return ne;
            }(Q), p = function(g) {
              Lr(ne, g);
              function ne(ue, We, Fe) {
                var Z2 = g.call(this, We, Fe) || this;
                return Z2.kind = 79, Z2;
              }
              return Object.defineProperty(ne.prototype, "text", { get: function() {
                return e2.idText(this);
              }, enumerable: false, configurable: true }), ne;
            }(Q);
            p.prototype.kind = 79;
            var m2 = function(g) {
              Lr(ne, g);
              function ne(ue, We, Fe) {
                return g.call(this, We, Fe) || this;
              }
              return Object.defineProperty(ne.prototype, "text", { get: function() {
                return e2.idText(this);
              }, enumerable: false, configurable: true }), ne;
            }(Q);
            m2.prototype.kind = 80;
            var G = function() {
              function g(ne, ue) {
                this.checker = ne, this.flags = ue;
              }
              return g.prototype.getFlags = function() {
                return this.flags;
              }, g.prototype.getSymbol = function() {
                return this.symbol;
              }, g.prototype.getProperties = function() {
                return this.checker.getPropertiesOfType(this);
              }, g.prototype.getProperty = function(ne) {
                return this.checker.getPropertyOfType(this, ne);
              }, g.prototype.getApparentProperties = function() {
                return this.checker.getAugmentedPropertiesOfType(this);
              }, g.prototype.getCallSignatures = function() {
                return this.checker.getSignaturesOfType(this, 0);
              }, g.prototype.getConstructSignatures = function() {
                return this.checker.getSignaturesOfType(this, 1);
              }, g.prototype.getStringIndexType = function() {
                return this.checker.getIndexTypeOfType(this, 0);
              }, g.prototype.getNumberIndexType = function() {
                return this.checker.getIndexTypeOfType(this, 1);
              }, g.prototype.getBaseTypes = function() {
                return this.isClassOrInterface() ? this.checker.getBaseTypes(this) : void 0;
              }, g.prototype.isNullableType = function() {
                return this.checker.isNullableType(this);
              }, g.prototype.getNonNullableType = function() {
                return this.checker.getNonNullableType(this);
              }, g.prototype.getNonOptionalType = function() {
                return this.checker.getNonOptionalType(this);
              }, g.prototype.getConstraint = function() {
                return this.checker.getBaseConstraintOfType(this);
              }, g.prototype.getDefault = function() {
                return this.checker.getDefaultFromTypeParameter(this);
              }, g.prototype.isUnion = function() {
                return !!(this.flags & 1048576);
              }, g.prototype.isIntersection = function() {
                return !!(this.flags & 2097152);
              }, g.prototype.isUnionOrIntersection = function() {
                return !!(this.flags & 3145728);
              }, g.prototype.isLiteral = function() {
                return !!(this.flags & 384);
              }, g.prototype.isStringLiteral = function() {
                return !!(this.flags & 128);
              }, g.prototype.isNumberLiteral = function() {
                return !!(this.flags & 256);
              }, g.prototype.isTypeParameter = function() {
                return !!(this.flags & 262144);
              }, g.prototype.isClassOrInterface = function() {
                return !!(e2.getObjectFlags(this) & 3);
              }, g.prototype.isClass = function() {
                return !!(e2.getObjectFlags(this) & 1);
              }, g.prototype.isIndexType = function() {
                return !!(this.flags & 4194304);
              }, Object.defineProperty(g.prototype, "typeArguments", { get: function() {
                if (e2.getObjectFlags(this) & 4)
                  return this.checker.getTypeArguments(this);
              }, enumerable: false, configurable: true }), g;
            }(), oe = function() {
              function g(ne, ue) {
                this.checker = ne, this.flags = ue;
              }
              return g.prototype.getDeclaration = function() {
                return this.declaration;
              }, g.prototype.getTypeParameters = function() {
                return this.typeParameters;
              }, g.prototype.getParameters = function() {
                return this.parameters;
              }, g.prototype.getReturnType = function() {
                return this.checker.getReturnTypeOfSignature(this);
              }, g.prototype.getTypeParameterAtPosition = function(ne) {
                var ue = this.checker.getParameterType(this, ne);
                if (ue.isIndexType() && e2.isThisTypeParameter(ue.type)) {
                  var We = ue.type.getConstraint();
                  if (We)
                    return this.checker.getIndexType(We);
                }
                return ue;
              }, g.prototype.getDocumentationComment = function() {
                return this.documentationComment || (this.documentationComment = K(e2.singleElementArray(this.declaration), this.checker));
              }, g.prototype.getJsDocTags = function() {
                return this.jsDocTags || (this.jsDocTags = T(e2.singleElementArray(this.declaration), this.checker));
              }, g;
            }();
            function f4(g) {
              return e2.getJSDocTags(g).some(function(ne) {
                return ne.tagName.text === "inheritDoc";
              });
            }
            function T(g, ne) {
              if (!g)
                return e2.emptyArray;
              var ue = e2.JsDoc.getJsDocTagsFromDeclarations(g, ne);
              if (ne && (ue.length === 0 || g.some(f4)))
                for (var We = new e2.Set(), Fe = function(Re) {
                  var ze = b(ne, Re, function(Ee) {
                    var He;
                    if (!We.has(Ee))
                      return We.add(Ee), Re.kind === 172 || Re.kind === 173 ? Ee.getContextualJsDocTags(Re, ne) : ((He = Ee.declarations) === null || He === void 0 ? void 0 : He.length) === 1 ? Ee.getJsDocTags() : void 0;
                  });
                  ze && (ue = Ve(Ve([], ze, true), ue, true));
                }, Z2 = 0, Be = g; Z2 < Be.length; Z2++) {
                  var ge = Be[Z2];
                  Fe(ge);
                }
              return ue;
            }
            function K(g, ne) {
              if (!g)
                return e2.emptyArray;
              var ue = e2.JsDoc.getJsDocCommentsFromDeclarations(g, ne);
              if (ne && (ue.length === 0 || g.some(f4)))
                for (var We = new e2.Set(), Fe = function(Re) {
                  var ze = b(ne, Re, function(Ee) {
                    if (!We.has(Ee))
                      return We.add(Ee), Re.kind === 172 || Re.kind === 173 ? Ee.getContextualDocumentationComment(Re, ne) : Ee.getDocumentationComment(ne);
                  });
                  ze && (ue = ue.length === 0 ? ze.slice() : ze.concat(e2.lineBreakPart(), ue));
                }, Z2 = 0, Be = g; Z2 < Be.length; Z2++) {
                  var ge = Be[Z2];
                  Fe(ge);
                }
              return ue;
            }
            function b(g, ne, ue) {
              var We;
              if (!e2.hasStaticModifier(ne)) {
                var Fe = ((We = ne.parent) === null || We === void 0 ? void 0 : We.kind) === 171 ? ne.parent.parent : ne.parent;
                if (!!Fe)
                  return e2.firstDefined(e2.getAllSuperTypeNodes(Fe), function(Z2) {
                    var Be = g.getPropertyOfType(g.getTypeAtLocation(Z2), ne.symbol.name);
                    return Be ? ue(Be) : void 0;
                  });
              }
            }
            var se = function(g) {
              Lr(ne, g);
              function ne(ue, We, Fe) {
                var Z2 = g.call(this, ue, We, Fe) || this;
                return Z2.kind = 305, Z2;
              }
              return ne.prototype.update = function(ue, We) {
                return e2.updateSourceFile(this, ue, We);
              }, ne.prototype.getLineAndCharacterOfPosition = function(ue) {
                return e2.getLineAndCharacterOfPosition(this, ue);
              }, ne.prototype.getLineStarts = function() {
                return e2.getLineStarts(this);
              }, ne.prototype.getPositionOfLineAndCharacter = function(ue, We, Fe) {
                return e2.computePositionOfLineAndCharacter(e2.getLineStarts(this), ue, We, this.text, Fe);
              }, ne.prototype.getLineEndOfPosition = function(ue) {
                var We = this.getLineAndCharacterOfPosition(ue).line, Fe = this.getLineStarts(), Z2;
                We + 1 >= Fe.length && (Z2 = this.getEnd()), Z2 || (Z2 = Fe[We + 1] - 1);
                var Be = this.getFullText();
                return Be[Z2] === `
` && Be[Z2 - 1] === "\r" ? Z2 - 1 : Z2;
              }, ne.prototype.getNamedDeclarations = function() {
                return this.namedDeclarations || (this.namedDeclarations = this.computeNamedDeclarations()), this.namedDeclarations;
              }, ne.prototype.computeNamedDeclarations = function() {
                var ue = e2.createMultiMap();
                return this.forEachChild(Be), ue;
                function We(ge) {
                  var Re = Z2(ge);
                  Re && ue.add(Re, ge);
                }
                function Fe(ge) {
                  var Re = ue.get(ge);
                  return Re || ue.set(ge, Re = []), Re;
                }
                function Z2(ge) {
                  var Re = e2.getNonAssignedNameOfDeclaration(ge);
                  return Re && (e2.isComputedPropertyName(Re) && e2.isPropertyAccessExpression(Re.expression) ? Re.expression.name.text : e2.isPropertyName(Re) ? e2.getNameFromPropertyName(Re) : void 0);
                }
                function Be(ge) {
                  switch (ge.kind) {
                    case 256:
                    case 213:
                    case 169:
                    case 168:
                      var Re = ge, ze = Z2(Re);
                      if (ze) {
                        var Ee = Fe(ze), He = e2.lastOrUndefined(Ee);
                        He && Re.parent === He.parent && Re.symbol === He.symbol ? Re.body && !He.body && (Ee[Ee.length - 1] = Re) : Ee.push(Re);
                      }
                      e2.forEachChild(ge, Be);
                      break;
                    case 257:
                    case 226:
                    case 258:
                    case 259:
                    case 260:
                    case 261:
                    case 265:
                    case 275:
                    case 270:
                    case 267:
                    case 268:
                    case 172:
                    case 173:
                    case 182:
                      We(ge), e2.forEachChild(ge, Be);
                      break;
                    case 164:
                      if (!e2.hasSyntacticModifier(ge, 16476))
                        break;
                    case 254:
                    case 203: {
                      var rr = ge;
                      if (e2.isBindingPattern(rr.name)) {
                        e2.forEachChild(rr.name, Be);
                        break;
                      }
                      rr.initializer && Be(rr.initializer);
                    }
                    case 299:
                    case 167:
                    case 166:
                      We(ge);
                      break;
                    case 272:
                      var Ie = ge;
                      Ie.exportClause && (e2.isNamedExports(Ie.exportClause) ? e2.forEach(Ie.exportClause.elements, Be) : Be(Ie.exportClause.name));
                      break;
                    case 266:
                      var _e = ge.importClause;
                      _e && (_e.name && We(_e.name), _e.namedBindings && (_e.namedBindings.kind === 268 ? We(_e.namedBindings) : e2.forEach(_e.namedBindings.elements, Be)));
                      break;
                    case 221:
                      e2.getAssignmentDeclarationKind(ge) !== 0 && We(ge);
                    default:
                      e2.forEachChild(ge, Be);
                  }
                }
              }, ne;
            }(C), J = function() {
              function g(ne, ue, We) {
                this.fileName = ne, this.text = ue, this.skipTrivia = We;
              }
              return g.prototype.getLineAndCharacterOfPosition = function(ne) {
                return e2.getLineAndCharacterOfPosition(this, ne);
              }, g;
            }();
            function ie() {
              return { getNodeConstructor: function() {
                return C;
              }, getTokenConstructor: function() {
                return N;
              }, getIdentifierConstructor: function() {
                return p;
              }, getPrivateIdentifierConstructor: function() {
                return m2;
              }, getSourceFileConstructor: function() {
                return se;
              }, getSymbolConstructor: function() {
                return le;
              }, getTypeConstructor: function() {
                return G;
              }, getSignatureConstructor: function() {
                return oe;
              }, getSourceMapSourceConstructor: function() {
                return J;
              } };
            }
            function R(g) {
              var ne = true;
              for (var ue in g)
                if (e2.hasProperty(g, ue) && !q(ue)) {
                  ne = false;
                  break;
                }
              if (ne)
                return g;
              var We = {};
              for (var ue in g)
                if (e2.hasProperty(g, ue)) {
                  var Fe = q(ue) ? ue : ue.charAt(0).toLowerCase() + ue.substr(1);
                  We[Fe] = g[ue];
                }
              return We;
            }
            e2.toEditorSettings = R;
            function q(g) {
              return !g.length || g.charAt(0) === g.charAt(0).toLowerCase();
            }
            function O(g) {
              return g ? e2.map(g, function(ne) {
                return ne.text;
              }).join("") : "";
            }
            e2.displayPartsToString = O;
            function ve() {
              return { target: 1, jsx: 1 };
            }
            e2.getDefaultCompilerOptions = ve;
            function ee() {
              return e2.codefix.getSupportedErrorCodes();
            }
            e2.getSupportedCodeFixes = ee;
            var he = function() {
              function g(ne, ue) {
                this.host = ne, this.currentDirectory = ne.getCurrentDirectory(), this.fileNameToEntry = new e2.Map();
                var We = ne.getScriptFileNames();
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.push("session", "initializeHostCache", { count: We.length });
                for (var Fe = 0, Z2 = We; Fe < Z2.length; Fe++) {
                  var Be = Z2[Fe];
                  this.createEntry(Be, e2.toPath(Be, this.currentDirectory, ue));
                }
                e2.tracing === null || e2.tracing === void 0 || e2.tracing.pop();
              }
              return g.prototype.createEntry = function(ne, ue) {
                var We, Fe = this.host.getScriptSnapshot(ne);
                return Fe ? We = { hostFileName: ne, version: this.host.getScriptVersion(ne), scriptSnapshot: Fe, scriptKind: e2.getScriptKind(ne, this.host) } : We = ne, this.fileNameToEntry.set(ue, We), We;
              }, g.prototype.getEntryByPath = function(ne) {
                return this.fileNameToEntry.get(ne);
              }, g.prototype.getHostFileInformation = function(ne) {
                var ue = this.fileNameToEntry.get(ne);
                return e2.isString(ue) ? void 0 : ue;
              }, g.prototype.getOrCreateEntryByPath = function(ne, ue) {
                var We = this.getEntryByPath(ue) || this.createEntry(ne, ue);
                return e2.isString(We) ? void 0 : We;
              }, g.prototype.getRootFileNames = function() {
                var ne = [];
                return this.fileNameToEntry.forEach(function(ue) {
                  e2.isString(ue) ? ne.push(ue) : ne.push(ue.hostFileName);
                }), ne;
              }, g.prototype.getScriptSnapshot = function(ne) {
                var ue = this.getHostFileInformation(ne);
                return ue && ue.scriptSnapshot;
              }, g;
            }(), F2 = function() {
              function g(ne) {
                this.host = ne;
              }
              return g.prototype.getCurrentSourceFile = function(ne) {
                var ue, We, Fe, Z2, Be, ge, Re, ze, Ee = this.host.getScriptSnapshot(ne);
                if (!Ee)
                  throw new Error("Could not find file: '" + ne + "'.");
                var He = e2.getScriptKind(ne, this.host), rr = this.host.getScriptVersion(ne), Ie;
                if (this.currentFileName !== ne) {
                  var _e = { languageVersion: 99, impliedNodeFormat: e2.getImpliedNodeFormatForFile(e2.toPath(ne, this.host.getCurrentDirectory(), ((Fe = (We = (ue = this.host).getCompilerHost) === null || We === void 0 ? void 0 : We.call(ue)) === null || Fe === void 0 ? void 0 : Fe.getCanonicalFileName) || e2.hostGetCanonicalFileName(this.host)), (ze = (Re = (ge = (Be = (Z2 = this.host).getCompilerHost) === null || Be === void 0 ? void 0 : Be.call(Z2)) === null || ge === void 0 ? void 0 : ge.getModuleResolutionCache) === null || Re === void 0 ? void 0 : Re.call(ge)) === null || ze === void 0 ? void 0 : ze.getPackageJsonInfoCache(), this.host, this.host.getCompilationSettings()), setExternalModuleIndicator: e2.getSetExternalModuleIndicator(this.host.getCompilationSettings()) };
                  Ie = X(ne, Ee, _e, rr, true, He);
                } else if (this.currentFileVersion !== rr) {
                  var we = Ee.getChangeRange(this.currentFileScriptSnapshot);
                  Ie = $(this.currentSourceFile, Ee, rr, we);
                }
                return Ie && (this.currentFileVersion = rr, this.currentFileName = ne, this.currentFileScriptSnapshot = Ee, this.currentSourceFile = Ie), this.currentSourceFile;
              }, g;
            }();
            function x2(g, ne, ue) {
              g.version = ue, g.scriptSnapshot = ne;
            }
            function X(g, ne, ue, We, Fe, Z2) {
              var Be = e2.createSourceFile(g, e2.getSnapshotText(ne), ue, Fe, Z2);
              return x2(Be, ne, We), Be;
            }
            e2.createLanguageServiceSourceFile = X;
            function $(g, ne, ue, We, Fe) {
              if (We && ue !== g.version) {
                var Z2 = void 0, Be = We.span.start !== 0 ? g.text.substr(0, We.span.start) : "", ge = e2.textSpanEnd(We.span) !== g.text.length ? g.text.substr(e2.textSpanEnd(We.span)) : "";
                if (We.newLength === 0)
                  Z2 = Be && ge ? Be + ge : Be || ge;
                else {
                  var Re = ne.getText(We.span.start, We.span.start + We.newLength);
                  Z2 = Be && ge ? Be + Re + ge : Be ? Be + Re : Re + ge;
                }
                var ze = e2.updateSourceFile(g, Z2, We, Fe);
                return x2(ze, ne, ue), ze.nameTable = void 0, g !== ze && g.scriptSnapshot && (g.scriptSnapshot.dispose && g.scriptSnapshot.dispose(), g.scriptSnapshot = void 0), ze;
              }
              var Ee = { languageVersion: g.languageVersion, impliedNodeFormat: g.impliedNodeFormat, setExternalModuleIndicator: g.setExternalModuleIndicator };
              return X(g.fileName, ne, Ee, ue, true, g.scriptKind);
            }
            e2.updateLanguageServiceSourceFile = $;
            var A2 = { isCancellationRequested: e2.returnFalse, throwIfCancellationRequested: e2.noop }, y = function() {
              function g(ne) {
                this.cancellationToken = ne;
              }
              return g.prototype.isCancellationRequested = function() {
                return this.cancellationToken.isCancellationRequested();
              }, g.prototype.throwIfCancellationRequested = function() {
                if (this.isCancellationRequested())
                  throw e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("session", "cancellationThrown", { kind: "CancellationTokenObject" }), new e2.OperationCanceledException();
              }, g;
            }(), V = function() {
              function g(ne, ue) {
                ue === void 0 && (ue = 20), this.hostCancellationToken = ne, this.throttleWaitMilliseconds = ue, this.lastCancellationCheckTime = 0;
              }
              return g.prototype.isCancellationRequested = function() {
                var ne = e2.timestamp(), ue = Math.abs(ne - this.lastCancellationCheckTime);
                return ue >= this.throttleWaitMilliseconds ? (this.lastCancellationCheckTime = ne, this.hostCancellationToken.isCancellationRequested()) : false;
              }, g.prototype.throwIfCancellationRequested = function() {
                if (this.isCancellationRequested())
                  throw e2.tracing === null || e2.tracing === void 0 || e2.tracing.instant("session", "cancellationThrown", { kind: "ThrottledCancellationToken" }), new e2.OperationCanceledException();
              }, g;
            }();
            e2.ThrottledCancellationToken = V;
            var L = ["getSemanticDiagnostics", "getSuggestionDiagnostics", "getCompilerOptionsDiagnostics", "getSemanticClassifications", "getEncodedSemanticClassifications", "getCodeFixesAtPosition", "getCombinedCodeFix", "applyCodeActionCommand", "organizeImports", "getEditsForFileRename", "getEmitOutput", "getApplicableRefactors", "getEditsForRefactor", "prepareCallHierarchy", "provideCallHierarchyIncomingCalls", "provideCallHierarchyOutgoingCalls", "provideInlayHints"], P = Ve(Ve([], L, true), ["getCompletionsAtPosition", "getCompletionEntryDetails", "getCompletionEntrySymbol", "getSignatureHelpItems", "getQuickInfoAtPosition", "getDefinitionAtPosition", "getDefinitionAndBoundSpan", "getImplementationAtPosition", "getTypeDefinitionAtPosition", "getReferencesAtPosition", "findReferences", "getOccurrencesAtPosition", "getDocumentHighlights", "getNavigateToItems", "getRenameInfo", "findRenameLocations", "getApplicableRefactors"], false);
            function k(g, ne, ue) {
              var We, Fe;
              ne === void 0 && (ne = e2.createDocumentRegistry(g.useCaseSensitiveFileNames && g.useCaseSensitiveFileNames(), g.getCurrentDirectory()));
              var Z2;
              ue === void 0 ? Z2 = e2.LanguageServiceMode.Semantic : typeof ue == "boolean" ? Z2 = ue ? e2.LanguageServiceMode.Syntactic : e2.LanguageServiceMode.Semantic : Z2 = ue;
              var Be = new F2(g), ge, Re, ze = 0, Ee = g.getCancellationToken ? new y(g.getCancellationToken()) : A2, He = g.getCurrentDirectory();
              e2.maybeSetLocalizedDiagnosticMessages((Fe = g.getLocalizedDiagnosticMessages) === null || Fe === void 0 ? void 0 : Fe.bind(g));
              function rr(Ai) {
                g.log && g.log(Ai);
              }
              var Ie = e2.hostUsesCaseSensitiveFileNames(g), _e = e2.createGetCanonicalFileName(Ie), we = e2.getSourceMapper({ useCaseSensitiveFileNames: function() {
                return Ie;
              }, getCurrentDirectory: function() {
                return He;
              }, getProgram: Ae, fileExists: e2.maybeBind(g, g.fileExists), readFile: e2.maybeBind(g, g.readFile), getDocumentPositionMapper: e2.maybeBind(g, g.getDocumentPositionMapper), getSourceFileLike: e2.maybeBind(g, g.getSourceFileLike), log: rr });
              function de(Ai) {
                var Oi = ge.getSourceFile(Ai);
                if (!Oi) {
                  var ji = new Error("Could not find source file: '".concat(Ai, "'."));
                  throw ji.ProgramFiles = ge.getSourceFiles().map(function(Vi) {
                    return Vi.fileName;
                  }), ji;
                }
                return Oi;
              }
              function ye() {
                var Ai, Oi, ji;
                if (e2.Debug.assert(Z2 !== e2.LanguageServiceMode.Syntactic), g.getProjectVersion) {
                  var Vi = g.getProjectVersion();
                  if (Vi) {
                    if (Re === Vi && !(!((Ai = g.hasChangedAutomaticTypeDirectiveNames) === null || Ai === void 0) && Ai.call(g)))
                      return;
                    Re = Vi;
                  }
                }
                var at = g.getTypeRootsVersion ? g.getTypeRootsVersion() : 0;
                ze !== at && (rr("TypeRoots version has changed; provide new program"), ge = void 0, ze = at);
                var At = new he(g, _e), ba = At.getRootFileNames(), $a = g.getCompilationSettings() || ve(), Qa = g.hasInvalidatedResolution || e2.returnFalse, ai = e2.maybeBind(g, g.hasChangedAutomaticTypeDirectiveNames), Dn = (Oi = g.getProjectReferences) === null || Oi === void 0 ? void 0 : Oi.call(g), ka, Ba = { useCaseSensitiveFileNames: Ie, fileExists: Pn, readFile: eo, readDirectory: Rn, trace: e2.maybeBind(g, g.trace), getCurrentDirectory: function() {
                  return He;
                }, onUnRecoverableConfigFileDiagnostic: e2.noop };
                if (e2.isProgramUptoDate(ge, ba, $a, function(En, Wn) {
                  return g.getScriptVersion(Wn);
                }, Pn, Qa, ai, kn, Dn))
                  return;
                var pn = { getSourceFile: bo, getSourceFileByPath: Ro, getCancellationToken: function() {
                  return Ee;
                }, getCanonicalFileName: _e, useCaseSensitiveFileNames: function() {
                  return Ie;
                }, getNewLine: function() {
                  return e2.getNewLineCharacter($a, function() {
                    return e2.getNewLineOrDefaultFromHost(g);
                  });
                }, getDefaultLibFileName: function(En) {
                  return g.getDefaultLibFileName(En);
                }, writeFile: e2.noop, getCurrentDirectory: function() {
                  return He;
                }, fileExists: Pn, readFile: eo, getSymlinkCache: e2.maybeBind(g, g.getSymlinkCache), realpath: e2.maybeBind(g, g.realpath), directoryExists: function(En) {
                  return e2.directoryProbablyExists(En, g);
                }, getDirectories: function(En) {
                  return g.getDirectories ? g.getDirectories(En) : [];
                }, readDirectory: Rn, onReleaseOldSourceFile: Da, onReleaseParsedCommandLine: Kn, hasInvalidatedResolution: Qa, hasChangedAutomaticTypeDirectiveNames: ai, trace: Ba.trace, resolveModuleNames: e2.maybeBind(g, g.resolveModuleNames), getModuleResolutionCache: e2.maybeBind(g, g.getModuleResolutionCache), resolveTypeReferenceDirectives: e2.maybeBind(g, g.resolveTypeReferenceDirectives), useSourceOfProjectReferenceRedirect: e2.maybeBind(g, g.useSourceOfProjectReferenceRedirect), getParsedCommandLine: kn };
                (ji = g.setCompilerHost) === null || ji === void 0 || ji.call(g, pn);
                var Cn = ne.getKeyForCompilationSettings($a), Bi = { rootNames: ba, options: $a, host: pn, oldProgram: ge, projectReferences: Dn };
                ge = e2.createProgram(Bi), At = void 0, ka = void 0, we.clearCache(), ge.getTypeChecker();
                return;
                function kn(En) {
                  var Wn = e2.toPath(En, He, _e), to = ka == null ? void 0 : ka.get(Wn);
                  if (to !== void 0)
                    return to || void 0;
                  var Co = g.getParsedCommandLine ? g.getParsedCommandLine(En) : xn(En);
                  return (ka || (ka = new e2.Map())).set(Wn, Co || false), Co;
                }
                function xn(En) {
                  var Wn = bo(En, 100);
                  if (!!Wn)
                    return Wn.path = e2.toPath(En, He, _e), Wn.resolvedPath = Wn.path, Wn.originalFileName = Wn.fileName, e2.parseJsonSourceFileConfigFileContent(Wn, Ba, e2.getNormalizedAbsolutePath(e2.getDirectoryPath(En), He), void 0, e2.getNormalizedAbsolutePath(En, He));
                }
                function Kn(En, Wn, to) {
                  var Co;
                  g.getParsedCommandLine ? (Co = g.onReleaseParsedCommandLine) === null || Co === void 0 || Co.call(g, En, Wn, to) : Wn && Da(Wn.sourceFile, to);
                }
                function Pn(En) {
                  var Wn = e2.toPath(En, He, _e), to = At && At.getEntryByPath(Wn);
                  return to ? !e2.isString(to) : !!g.fileExists && g.fileExists(En);
                }
                function eo(En) {
                  var Wn = e2.toPath(En, He, _e), to = At && At.getEntryByPath(Wn);
                  return to ? e2.isString(to) ? void 0 : e2.getSnapshotText(to.scriptSnapshot) : g.readFile && g.readFile(En);
                }
                function Rn(En, Wn, to, Co, Ko) {
                  return e2.Debug.checkDefined(g.readDirectory, "'LanguageServiceHost.readDirectory' must be implemented to correctly process 'projectReferences'"), g.readDirectory(En, Wn, to, Co, Ko);
                }
                function Da(En, Wn) {
                  var to = ne.getKeyForCompilationSettings(Wn);
                  ne.releaseDocumentWithKey(En.resolvedPath, to, En.scriptKind);
                }
                function bo(En, Wn, to, Co) {
                  return Ro(En, e2.toPath(En, He, _e), Wn, to, Co);
                }
                function Ro(En, Wn, to, Co, Ko) {
                  e2.Debug.assert(At !== void 0, "getOrCreateSourceFileByPath called after typical CompilerHost lifetime, check the callstack something with a reference to an old host.");
                  var Oo = At && At.getOrCreateEntryByPath(En, Wn);
                  if (!!Oo) {
                    if (!Ko) {
                      var no = ge && ge.getSourceFileByPath(Wn);
                      if (no) {
                        if (Oo.scriptKind === no.scriptKind)
                          return ne.updateDocumentWithKey(En, Wn, g, Cn, Oo.scriptSnapshot, Oo.version, Oo.scriptKind);
                        ne.releaseDocumentWithKey(no.resolvedPath, ne.getKeyForCompilationSettings(ge.getCompilerOptions()), no.scriptKind);
                      }
                    }
                    return ne.acquireDocumentWithKey(En, Wn, g, Cn, Oo.scriptSnapshot, Oo.version, Oo.scriptKind);
                  }
                }
              }
              function Ae() {
                if (Z2 === e2.LanguageServiceMode.Syntactic) {
                  e2.Debug.assert(ge === void 0);
                  return;
                }
                return ye(), ge;
              }
              function er() {
                var Ai;
                return (Ai = g.getPackageJsonAutoImportProvider) === null || Ai === void 0 ? void 0 : Ai.call(g);
              }
              function ir() {
                ge = void 0;
              }
              function Cr() {
                if (ge) {
                  var Ai = ne.getKeyForCompilationSettings(ge.getCompilerOptions());
                  e2.forEach(ge.getSourceFiles(), function(Oi) {
                    return ne.releaseDocumentWithKey(Oi.resolvedPath, Ai, Oi.scriptKind);
                  }), ge = void 0;
                }
                g = void 0;
              }
              function Ye(Ai) {
                return ye(), ge.getSyntacticDiagnostics(de(Ai), Ee).slice();
              }
              function Br(Ai) {
                ye();
                var Oi = de(Ai), ji = ge.getSemanticDiagnostics(Oi, Ee);
                if (!e2.getEmitDeclarations(ge.getCompilerOptions()))
                  return ji.slice();
                var Vi = ge.getDeclarationDiagnostics(Oi, Ee);
                return Ve(Ve([], ji, true), Vi, true);
              }
              function Er(Ai) {
                return ye(), e2.computeSuggestionDiagnostics(de(Ai), ge, Ee);
              }
              function Ne() {
                return ye(), Ve(Ve([], ge.getOptionsDiagnostics(Ee), true), ge.getGlobalDiagnostics(Ee), true);
              }
              function n(Ai, Oi, ji, Vi) {
                ji === void 0 && (ji = e2.emptyOptions);
                var at = Ke(Ke({}, e2.identity(ji)), { includeCompletionsForModuleExports: ji.includeCompletionsForModuleExports || ji.includeExternalModuleExports, includeCompletionsWithInsertText: ji.includeCompletionsWithInsertText || ji.includeInsertTextCompletions });
                return ye(), e2.Completions.getCompletionsAtPosition(g, ge, rr, de(Ai), Oi, at, ji.triggerCharacter, ji.triggerKind, Ee, Vi && e2.formatting.getFormatContext(Vi, g));
              }
              function lr(Ai, Oi, ji, Vi, at, At, ba) {
                return At === void 0 && (At = e2.emptyOptions), ye(), e2.Completions.getCompletionEntryDetails(ge, rr, de(Ai), Oi, { name: ji, source: at, data: ba }, g, Vi && e2.formatting.getFormatContext(Vi, g), At, Ee);
              }
              function be(Ai, Oi, ji, Vi, at) {
                return at === void 0 && (at = e2.emptyOptions), ye(), e2.Completions.getCompletionEntrySymbol(ge, rr, de(Ai), Oi, { name: ji, source: Vi }, g, at);
              }
              function Ge(Ai, Oi) {
                ye();
                var ji = de(Ai), Vi = e2.getTouchingPropertyName(ji, Oi);
                if (Vi !== ji) {
                  var at = ge.getTypeChecker(), At = ur(Vi), ba = l(At, at);
                  if (!ba || at.isUnknownSymbol(ba)) {
                    var $a = yr(ji, At, Oi) ? at.getTypeAtLocation(At) : void 0;
                    return $a && { kind: "", kindModifiers: "", textSpan: e2.createTextSpanFromNode(At, ji), displayParts: at.runWithCancellationToken(Ee, function(pn) {
                      return e2.typeToDisplayParts(pn, $a, e2.getContainerNode(At));
                    }), documentation: $a.symbol ? $a.symbol.getDocumentationComment(at) : void 0, tags: $a.symbol ? $a.symbol.getJsDocTags(at) : void 0 };
                  }
                  var Qa = at.runWithCancellationToken(Ee, function(pn) {
                    return e2.SymbolDisplay.getSymbolDisplayPartsDocumentationAndSymbolKind(pn, ba, ji, e2.getContainerNode(At), At);
                  }), ai = Qa.symbolKind, Dn = Qa.displayParts, ka = Qa.documentation, Ba = Qa.tags;
                  return { kind: ai, kindModifiers: e2.SymbolDisplay.getSymbolModifiers(at, ba), textSpan: e2.createTextSpanFromNode(At, ji), displayParts: Dn, documentation: ka, tags: Ba };
                }
              }
              function ur(Ai) {
                return e2.isNewExpression(Ai.parent) && Ai.pos === Ai.parent.pos ? Ai.parent.expression : e2.isNamedTupleMember(Ai.parent) && Ai.pos === Ai.parent.pos || e2.isImportMeta(Ai.parent) && Ai.parent.name === Ai ? Ai.parent : Ai;
              }
              function yr(Ai, Oi, ji) {
                switch (Oi.kind) {
                  case 79:
                    return !e2.isLabelName(Oi) && !e2.isTagName(Oi) && !e2.isConstTypeReference(Oi.parent);
                  case 206:
                  case 161:
                    return !e2.isInComment(Ai, ji);
                  case 108:
                  case 192:
                  case 106:
                  case 197:
                    return true;
                  case 231:
                    return e2.isImportMeta(Oi);
                  default:
                    return false;
                }
              }
              function Ir(Ai, Oi, ji, Vi) {
                return ye(), e2.GoToDefinition.getDefinitionAtPosition(ge, de(Ai), Oi, ji, Vi);
              }
              function wr(Ai, Oi) {
                return ye(), e2.GoToDefinition.getDefinitionAndBoundSpan(ge, de(Ai), Oi);
              }
              function Ur(Ai, Oi) {
                return ye(), e2.GoToDefinition.getTypeDefinitionAtPosition(ge.getTypeChecker(), de(Ai), Oi);
              }
              function ii(Ai, Oi) {
                return ye(), e2.FindAllReferences.getImplementationsAtPosition(ge, Ee, ge.getSourceFiles(), de(Ai), Oi);
              }
              function mi(Ai, Oi) {
                return e2.flatMap(pe(Ai, Oi, [Ai]), function(ji) {
                  return ji.highlightSpans.map(function(Vi) {
                    return Ke(Ke({ fileName: ji.fileName, textSpan: Vi.textSpan, isWriteAccess: Vi.kind === "writtenReference" }, Vi.isInString && { isInString: true }), Vi.contextSpan && { contextSpan: Vi.contextSpan });
                  });
                });
              }
              function pe(Ai, Oi, ji) {
                var Vi = e2.normalizePath(Ai);
                e2.Debug.assert(ji.some(function(ba) {
                  return e2.normalizePath(ba) === Vi;
                })), ye();
                var at = e2.mapDefined(ji, function(ba) {
                  return ge.getSourceFile(ba);
                }), At = de(Ai);
                return e2.DocumentHighlights.getDocumentHighlights(ge, Ee, At, Oi, at);
              }
              function or(Ai, Oi, ji, Vi, at) {
                ye();
                var At = de(Ai), ba = e2.getAdjustedRenameLocation(e2.getTouchingPropertyName(At, Oi));
                if (!!e2.Rename.nodeIsEligibleForRename(ba))
                  if (e2.isIdentifier(ba) && (e2.isJsxOpeningElement(ba.parent) || e2.isJsxClosingElement(ba.parent)) && e2.isIntrinsicJsxName(ba.escapedText)) {
                    var $a = ba.parent.parent, Qa = $a.openingElement, ai = $a.closingElement;
                    return [Qa, ai].map(function(Dn) {
                      var ka = e2.createTextSpanFromNode(Dn.tagName, At);
                      return Ke({ fileName: At.fileName, textSpan: ka }, e2.FindAllReferences.toContextSpan(ka, At, Dn.parent));
                    });
                  } else
                    return si(ba, Oi, { findInStrings: ji, findInComments: Vi, providePrefixAndSuffixTextForRename: at, use: 2 }, function(Dn, ka, Ba) {
                      return e2.FindAllReferences.toRenameLocation(Dn, ka, Ba, at || false);
                    });
              }
              function qr(Ai, Oi) {
                return ye(), si(e2.getTouchingPropertyName(de(Ai), Oi), Oi, { use: 1 }, e2.FindAllReferences.toReferenceEntry);
              }
              function si(Ai, Oi, ji, Vi) {
                ye();
                var at = ji && ji.use === 2 ? ge.getSourceFiles().filter(function(At) {
                  return !ge.isSourceFileDefaultLibrary(At);
                }) : ge.getSourceFiles();
                return e2.FindAllReferences.findReferenceOrRenameEntries(ge, Ee, at, Ai, Oi, ji, Vi);
              }
              function Di(Ai, Oi) {
                return ye(), e2.FindAllReferences.findReferencedSymbols(ge, Ee, ge.getSourceFiles(), de(Ai), Oi);
              }
              function wi(Ai) {
                return ye(), e2.FindAllReferences.Core.getReferencesForFileName(Ai, ge, ge.getSourceFiles()).map(e2.FindAllReferences.toReferenceEntry);
              }
              function Xi(Ai, Oi, ji, Vi) {
                Vi === void 0 && (Vi = false), ye();
                var at = ji ? [de(ji)] : ge.getSourceFiles();
                return e2.NavigateTo.getNavigateToItems(at, ge.getTypeChecker(), Ee, Ai, Oi, Vi);
              }
              function et(Ai, Oi, ji) {
                ye();
                var Vi = de(Ai), at = g.getCustomTransformers && g.getCustomTransformers();
                return e2.getFileEmitOutput(ge, Vi, !!Oi, Ee, at, ji);
              }
              function Gi(Ai, Oi, ji) {
                var Vi = ji === void 0 ? e2.emptyOptions : ji, at = Vi.triggerReason;
                ye();
                var At = de(Ai);
                return e2.SignatureHelp.getSignatureHelpItems(ge, At, Oi, at, Ee);
              }
              function Wt(Ai) {
                return Be.getCurrentSourceFile(Ai);
              }
              function Zt(Ai, Oi, ji) {
                var Vi = Be.getCurrentSourceFile(Ai), at = e2.getTouchingPropertyName(Vi, Oi);
                if (at !== Vi) {
                  switch (at.kind) {
                    case 206:
                    case 161:
                    case 10:
                    case 95:
                    case 110:
                    case 104:
                    case 106:
                    case 108:
                    case 192:
                    case 79:
                      break;
                    default:
                      return;
                  }
                  for (var At = at; ; )
                    if (e2.isRightSideOfPropertyAccess(At) || e2.isRightSideOfQualifiedName(At))
                      At = At.parent;
                    else if (e2.isNameOfModuleDeclaration(At))
                      if (At.parent.parent.kind === 261 && At.parent.parent.body === At.parent)
                        At = At.parent.parent.name;
                      else
                        break;
                    else
                      break;
                  return e2.createTextSpanFromBounds(At.getStart(), at.getEnd());
                }
              }
              function _r(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai);
                return e2.BreakpointResolver.spanInSourceFileAtLocation(ji, Oi);
              }
              function pi(Ai) {
                return e2.NavigationBar.getNavigationBarItems(Be.getCurrentSourceFile(Ai), Ee);
              }
              function ae(Ai) {
                return e2.NavigationBar.getNavigationTree(Be.getCurrentSourceFile(Ai), Ee);
              }
              function Xe(Ai, Oi, ji) {
                ye();
                var Vi = ji || "original";
                return Vi === "2020" ? e2.classifier.v2020.getSemanticClassifications(ge, Ee, de(Ai), Oi) : e2.getSemanticClassifications(ge.getTypeChecker(), Ee, de(Ai), ge.getClassifiableNames(), Oi);
              }
              function Jr(Ai, Oi, ji) {
                ye();
                var Vi = ji || "original";
                return Vi === "original" ? e2.getEncodedSemanticClassifications(ge.getTypeChecker(), Ee, de(Ai), ge.getClassifiableNames(), Oi) : e2.classifier.v2020.getEncodedSemanticClassifications(ge, Ee, de(Ai), Oi);
              }
              function ti(Ai, Oi) {
                return e2.getSyntacticClassifications(Ee, Be.getCurrentSourceFile(Ai), Oi);
              }
              function Ze(Ai, Oi) {
                return e2.getEncodedSyntacticClassifications(Ee, Be.getCurrentSourceFile(Ai), Oi);
              }
              function Sr(Ai) {
                var Oi = Be.getCurrentSourceFile(Ai);
                return e2.OutliningElementsCollector.collectElements(Oi, Ee);
              }
              var zr = new e2.Map(e2.getEntries((We = {}, We[18] = 19, We[20] = 21, We[22] = 23, We[31] = 29, We)));
              zr.forEach(function(Ai, Oi) {
                return zr.set(Ai.toString(), Number(Oi));
              });
              function Wr(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai), Vi = e2.getTouchingToken(ji, Oi), at = Vi.getStart(ji) === Oi ? zr.get(Vi.kind.toString()) : void 0, At = at && e2.findChildOfKind(Vi.parent, at, ji);
                return At ? [e2.createTextSpanFromNode(Vi, ji), e2.createTextSpanFromNode(At, ji)].sort(function(ba, $a) {
                  return ba.start - $a.start;
                }) : e2.emptyArray;
              }
              function Je(Ai, Oi, ji) {
                var Vi = e2.timestamp(), at = R(ji), At = Be.getCurrentSourceFile(Ai);
                rr("getIndentationAtPosition: getCurrentSourceFile: " + (e2.timestamp() - Vi)), Vi = e2.timestamp();
                var ba = e2.formatting.SmartIndenter.getIndentation(Oi, At, at);
                return rr("getIndentationAtPosition: computeIndentation  : " + (e2.timestamp() - Vi)), ba;
              }
              function xe(Ai, Oi, ji, Vi) {
                var at = Be.getCurrentSourceFile(Ai);
                return e2.formatting.formatSelection(Oi, ji, at, e2.formatting.getFormatContext(R(Vi), g));
              }
              function vr(Ai, Oi) {
                return e2.formatting.formatDocument(Be.getCurrentSourceFile(Ai), e2.formatting.getFormatContext(R(Oi), g));
              }
              function mr(Ai, Oi, ji, Vi) {
                var at = Be.getCurrentSourceFile(Ai), At = e2.formatting.getFormatContext(R(Vi), g);
                if (!e2.isInComment(at, Oi))
                  switch (ji) {
                    case "{":
                      return e2.formatting.formatOnOpeningCurly(Oi, at, At);
                    case "}":
                      return e2.formatting.formatOnClosingCurly(Oi, at, At);
                    case ";":
                      return e2.formatting.formatOnSemicolon(Oi, at, At);
                    case `
`:
                      return e2.formatting.formatOnEnter(Oi, at, At);
                  }
                return [];
              }
              function Ar(Ai, Oi, ji, Vi, at, At) {
                At === void 0 && (At = e2.emptyOptions), ye();
                var ba = de(Ai), $a = e2.createTextSpanFromBounds(Oi, ji), Qa = e2.formatting.getFormatContext(at, g);
                return e2.flatMap(e2.deduplicate(Vi, e2.equateValues, e2.compareValues), function(ai) {
                  return Ee.throwIfCancellationRequested(), e2.codefix.getFixes({ errorCode: ai, sourceFile: ba, span: $a, program: ge, host: g, cancellationToken: Ee, formatContext: Qa, preferences: At });
                });
              }
              function Oe(Ai, Oi, ji, Vi) {
                Vi === void 0 && (Vi = e2.emptyOptions), ye(), e2.Debug.assert(Ai.type === "file");
                var at = de(Ai.fileName), At = e2.formatting.getFormatContext(ji, g);
                return e2.codefix.getAllFixes({ fixId: Oi, sourceFile: at, program: ge, host: g, cancellationToken: Ee, formatContext: At, preferences: Vi });
              }
              function nr(Ai, Oi, ji) {
                ji === void 0 && (ji = e2.emptyOptions), ye(), e2.Debug.assert(Ai.type === "file");
                var Vi = de(Ai.fileName), at = e2.formatting.getFormatContext(Oi, g);
                return e2.OrganizeImports.organizeImports(Vi, at, g, ge, ji, Ai.skipDestructiveCodeActions);
              }
              function Mr(Ai, Oi, ji, Vi) {
                return Vi === void 0 && (Vi = e2.emptyOptions), e2.getEditsForFileRename(Ae(), Ai, Oi, g, e2.formatting.getFormatContext(ji, g), Vi, we);
              }
              function Pe(Ai, Oi) {
                var ji = typeof Ai == "string" ? Oi : Ai;
                return e2.isArray(ji) ? Promise.all(ji.map(function(Vi) {
                  return Ue(Vi);
                })) : Ue(ji);
              }
              function Ue(Ai) {
                var Oi = function(ji) {
                  return e2.toPath(ji, He, _e);
                };
                return e2.Debug.assertEqual(Ai.type, "install package"), g.installPackage ? g.installPackage({ fileName: Oi(Ai.file), packageName: Ai.packageName }) : Promise.reject("Host does not implement `installPackage`");
              }
              function fr(Ai, Oi, ji) {
                return e2.JsDoc.getDocCommentTemplateAtPosition(e2.getNewLineOrDefaultFromHost(g), Be.getCurrentSourceFile(Ai), Oi, ji);
              }
              function De(Ai, Oi, ji) {
                if (ji === 60)
                  return false;
                var Vi = Be.getCurrentSourceFile(Ai);
                if (e2.isInString(Vi, Oi))
                  return false;
                if (e2.isInsideJsxElementOrAttribute(Vi, Oi))
                  return ji === 123;
                if (e2.isInTemplateString(Vi, Oi))
                  return false;
                switch (ji) {
                  case 39:
                  case 34:
                  case 96:
                    return !e2.isInComment(Vi, Oi);
                }
                return true;
              }
              function gr(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai), Vi = e2.findPrecedingToken(Oi, ji);
                if (!!Vi) {
                  var at = Vi.kind === 31 && e2.isJsxOpeningElement(Vi.parent) ? Vi.parent.parent : e2.isJsxText(Vi) && e2.isJsxElement(Vi.parent) ? Vi.parent : void 0;
                  if (at && Wi(at))
                    return { newText: "</".concat(at.openingElement.tagName.getText(ji), ">") };
                  var At = Vi.kind === 31 && e2.isJsxOpeningFragment(Vi.parent) ? Vi.parent.parent : e2.isJsxText(Vi) && e2.isJsxFragment(Vi.parent) ? Vi.parent : void 0;
                  if (At && ct(At))
                    return { newText: "</>" };
                }
              }
              function Vr(Ai, Oi) {
                return { lineStarts: Ai.getLineStarts(), firstLine: Ai.getLineAndCharacterOfPosition(Oi.pos).line, lastLine: Ai.getLineAndCharacterOfPosition(Oi.end).line };
              }
              function Tr(Ai, Oi, ji) {
                for (var Vi = Be.getCurrentSourceFile(Ai), at = [], At = Vr(Vi, Oi), ba = At.lineStarts, $a = At.firstLine, Qa = At.lastLine, ai = ji || false, Dn = Number.MAX_VALUE, ka = new e2.Map(), Ba = new RegExp(/\S/), pn = e2.isInsideJsxElement(Vi, ba[$a]), Cn = pn ? "{/*" : "//", Bi = $a; Bi <= Qa; Bi++) {
                  var kn = Vi.text.substring(ba[Bi], Vi.getLineEndOfPosition(ba[Bi])), xn = Ba.exec(kn);
                  xn && (Dn = Math.min(Dn, xn.index), ka.set(Bi.toString(), xn.index), kn.substr(xn.index, Cn.length) !== Cn && (ai = ji === void 0 || ji));
                }
                for (var Bi = $a; Bi <= Qa; Bi++)
                  if (!($a !== Qa && ba[Bi] === Oi.end)) {
                    var Kn = ka.get(Bi.toString());
                    Kn !== void 0 && (pn ? at.push.apply(at, vi(Ai, { pos: ba[Bi] + Dn, end: Vi.getLineEndOfPosition(ba[Bi]) }, ai, pn)) : ai ? at.push({ newText: Cn, span: { length: 0, start: ba[Bi] + Dn } }) : Vi.text.substr(ba[Bi] + Kn, Cn.length) === Cn && at.push({ newText: "", span: { length: Cn.length, start: ba[Bi] + Kn } }));
                  }
                return at;
              }
              function vi(Ai, Oi, ji, Vi) {
                for (var at, At = Be.getCurrentSourceFile(Ai), ba = [], $a = At.text, Qa = false, ai = ji || false, Dn = [], ka = Oi.pos, Ba = Vi !== void 0 ? Vi : e2.isInsideJsxElement(At, ka), pn = Ba ? "{/*" : "/*", Cn = Ba ? "*/}" : "*/", Bi = Ba ? "\\{\\/\\*" : "\\/\\*", kn = Ba ? "\\*\\/\\}" : "\\*\\/"; ka <= Oi.end; ) {
                  var xn = $a.substr(ka, pn.length) === pn ? pn.length : 0, Kn = e2.isInComment(At, ka + xn);
                  if (Kn)
                    Ba && (Kn.pos--, Kn.end++), Dn.push(Kn.pos), Kn.kind === 3 && Dn.push(Kn.end), Qa = true, ka = Kn.end + 1;
                  else {
                    var Pn = $a.substring(ka, Oi.end).search("(".concat(Bi, ")|(").concat(kn, ")"));
                    ai = ji !== void 0 ? ji : ai || !e2.isTextWhiteSpaceLike($a, ka, Pn === -1 ? Oi.end : ka + Pn), ka = Pn === -1 ? Oi.end + 1 : ka + Pn + Cn.length;
                  }
                }
                if (ai || !Qa) {
                  ((at = e2.isInComment(At, Oi.pos)) === null || at === void 0 ? void 0 : at.kind) !== 2 && e2.insertSorted(Dn, Oi.pos, e2.compareValues), e2.insertSorted(Dn, Oi.end, e2.compareValues);
                  var eo = Dn[0];
                  $a.substr(eo, pn.length) !== pn && ba.push({ newText: pn, span: { length: 0, start: eo } });
                  for (var Rn = 1; Rn < Dn.length - 1; Rn++)
                    $a.substr(Dn[Rn] - Cn.length, Cn.length) !== Cn && ba.push({ newText: Cn, span: { length: 0, start: Dn[Rn] } }), $a.substr(Dn[Rn], pn.length) !== pn && ba.push({ newText: pn, span: { length: 0, start: Dn[Rn] } });
                  ba.length % 2 !== 0 && ba.push({ newText: Cn, span: { length: 0, start: Dn[Dn.length - 1] } });
                } else
                  for (var Da = 0, bo = Dn; Da < bo.length; Da++) {
                    var Ro = bo[Da], En = Ro - Cn.length > 0 ? Ro - Cn.length : 0, xn = $a.substr(En, Cn.length) === Cn ? Cn.length : 0;
                    ba.push({ newText: "", span: { length: pn.length, start: Ro - xn } });
                  }
                return ba;
              }
              function Ui(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai), Vi = Vr(ji, Oi), at = Vi.firstLine, At = Vi.lastLine;
                return at === At && Oi.pos !== Oi.end ? vi(Ai, Oi, true) : Tr(Ai, Oi, true);
              }
              function Yi(Ai, Oi) {
                var ji = Be.getCurrentSourceFile(Ai), Vi = [], at = Oi.pos, At = Oi.end;
                at === At && (At += e2.isInsideJsxElement(ji, at) ? 2 : 1);
                for (var ba = at; ba <= At; ba++) {
                  var $a = e2.isInComment(ji, ba);
                  if ($a) {
                    switch ($a.kind) {
                      case 2:
                        Vi.push.apply(Vi, Tr(Ai, { end: $a.end, pos: $a.pos + 1 }, false));
                        break;
                      case 3:
                        Vi.push.apply(Vi, vi(Ai, { end: $a.end, pos: $a.pos + 1 }, false));
                    }
                    ba = $a.end + 1;
                  }
                }
                return Vi;
              }
              function Wi(Ai) {
                var Oi = Ai.openingElement, ji = Ai.closingElement, Vi = Ai.parent;
                return !e2.tagNamesAreEquivalent(Oi.tagName, ji.tagName) || e2.isJsxElement(Vi) && e2.tagNamesAreEquivalent(Oi.tagName, Vi.openingElement.tagName) && Wi(Vi);
              }
              function ct(Ai) {
                var Oi = Ai.closingFragment, ji = Ai.parent;
                return !!(Oi.flags & 131072) || e2.isJsxFragment(ji) && ct(ji);
              }
              function Li(Ai, Oi, ji) {
                var Vi = Be.getCurrentSourceFile(Ai), at = e2.formatting.getRangeOfEnclosingComment(Vi, Oi);
                return at && (!ji || at.kind === 3) ? e2.createTextSpanFromRange(at) : void 0;
              }
              function nt(Ai, Oi) {
                ye();
                var ji = de(Ai);
                Ee.throwIfCancellationRequested();
                var Vi = ji.text, at = [];
                if (Oi.length > 0 && !kn(ji.fileName))
                  for (var At = Cn(), ba = void 0; ba = At.exec(Vi); ) {
                    Ee.throwIfCancellationRequested();
                    var $a = 3;
                    e2.Debug.assert(ba.length === Oi.length + $a);
                    var Qa = ba[1], ai = ba.index + Qa.length;
                    if (!!e2.isInComment(ji, ai)) {
                      for (var Dn = void 0, ka = 0; ka < Oi.length; ka++)
                        ba[ka + $a] && (Dn = Oi[ka]);
                      if (Dn === void 0)
                        return e2.Debug.fail();
                      if (!Bi(Vi.charCodeAt(ai + Dn.text.length))) {
                        var Ba = ba[2];
                        at.push({ descriptor: Dn, message: Ba, position: ai });
                      }
                    }
                  }
                return at;
                function pn(xn) {
                  return xn.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
                }
                function Cn() {
                  var xn = /(?:\/\/+\s*)/.source, Kn = /(?:\/\*+\s*)/.source, Pn = /(?:^(?:\s|\*)*)/.source, eo = "(" + Pn + "|" + xn + "|" + Kn + ")", Rn = "(?:" + e2.map(Oi, function(Wn) {
                    return "(" + pn(Wn.text) + ")";
                  }).join("|") + ")", Da = /(?:$|\*\/)/.source, bo = /(?:.*?)/.source, Ro = "(" + Rn + bo + ")", En = eo + Ro + Da;
                  return new RegExp(En, "gim");
                }
                function Bi(xn) {
                  return xn >= 97 && xn <= 122 || xn >= 65 && xn <= 90 || xn >= 48 && xn <= 57;
                }
                function kn(xn) {
                  return e2.stringContains(xn, "/node_modules/");
                }
              }
              function Mt(Ai, Oi, ji) {
                return ye(), e2.Rename.getRenameInfo(ge, de(Ai), Oi, ji);
              }
              function xt(Ai, Oi, ji, Vi, at, At) {
                var ba = typeof Oi == "number" ? [Oi, void 0] : [Oi.pos, Oi.end], $a = ba[0], Qa = ba[1];
                return { file: Ai, startPosition: $a, endPosition: Qa, program: Ae(), host: g, formatContext: e2.formatting.getFormatContext(Vi, g), cancellationToken: Ee, preferences: ji, triggerReason: at, kind: At };
              }
              function ut(Ai, Oi, ji) {
                return { file: Ai, program: Ae(), host: g, span: Oi, preferences: ji, cancellationToken: Ee };
              }
              function Dt(Ai, Oi) {
                return e2.SmartSelectionRange.getSmartSelectionRange(Oi, Be.getCurrentSourceFile(Ai));
              }
              function Rt(Ai, Oi, ji, Vi, at) {
                ji === void 0 && (ji = e2.emptyOptions), ye();
                var At = de(Ai);
                return e2.refactor.getApplicableRefactors(xt(At, Oi, ji, e2.emptyOptions, Vi, at));
              }
              function Ii(Ai, Oi, ji, Vi, at, At) {
                At === void 0 && (At = e2.emptyOptions), ye();
                var ba = de(Ai);
                return e2.refactor.getEditsForRefactor(xt(ba, ji, At, Oi), Vi, at);
              }
              function Ki(Ai, Oi) {
                return Oi === 0 ? { line: 0, character: 0 } : we.toLineColumnOffset(Ai, Oi);
              }
              function Fi(Ai, Oi) {
                ye();
                var ji = e2.CallHierarchy.resolveCallHierarchyDeclaration(ge, e2.getTouchingPropertyName(de(Ai), Oi));
                return ji && e2.mapOneOrMany(ji, function(Vi) {
                  return e2.CallHierarchy.createCallHierarchyItem(ge, Vi);
                });
              }
              function ui(Ai, Oi) {
                ye();
                var ji = de(Ai), Vi = e2.firstOrOnly(e2.CallHierarchy.resolveCallHierarchyDeclaration(ge, Oi === 0 ? ji : e2.getTouchingPropertyName(ji, Oi)));
                return Vi ? e2.CallHierarchy.getIncomingCalls(ge, Vi, Ee) : [];
              }
              function Bt(Ai, Oi) {
                ye();
                var ji = de(Ai), Vi = e2.firstOrOnly(e2.CallHierarchy.resolveCallHierarchyDeclaration(ge, Oi === 0 ? ji : e2.getTouchingPropertyName(ji, Oi)));
                return Vi ? e2.CallHierarchy.getOutgoingCalls(ge, Vi) : [];
              }
              function wt(Ai, Oi, ji) {
                ji === void 0 && (ji = e2.emptyOptions), ye();
                var Vi = de(Ai);
                return e2.InlayHints.provideInlayHints(ut(Vi, Oi, ji));
              }
              var na = { dispose: Cr, cleanupSemanticCache: ir, getSyntacticDiagnostics: Ye, getSemanticDiagnostics: Br, getSuggestionDiagnostics: Er, getCompilerOptionsDiagnostics: Ne, getSyntacticClassifications: ti, getSemanticClassifications: Xe, getEncodedSyntacticClassifications: Ze, getEncodedSemanticClassifications: Jr, getCompletionsAtPosition: n, getCompletionEntryDetails: lr, getCompletionEntrySymbol: be, getSignatureHelpItems: Gi, getQuickInfoAtPosition: Ge, getDefinitionAtPosition: Ir, getDefinitionAndBoundSpan: wr, getImplementationAtPosition: ii, getTypeDefinitionAtPosition: Ur, getReferencesAtPosition: qr, findReferences: Di, getFileReferences: wi, getOccurrencesAtPosition: mi, getDocumentHighlights: pe, getNameOrDottedNameSpan: Zt, getBreakpointStatementAtPosition: _r, getNavigateToItems: Xi, getRenameInfo: Mt, getSmartSelectionRange: Dt, findRenameLocations: or, getNavigationBarItems: pi, getNavigationTree: ae, getOutliningSpans: Sr, getTodoComments: nt, getBraceMatchingAtPosition: Wr, getIndentationAtPosition: Je, getFormattingEditsForRange: xe, getFormattingEditsForDocument: vr, getFormattingEditsAfterKeystroke: mr, getDocCommentTemplateAtPosition: fr, isValidBraceCompletionAtPosition: De, getJsxClosingTagAtPosition: gr, getSpanOfEnclosingComment: Li, getCodeFixesAtPosition: Ar, getCombinedCodeFix: Oe, applyCodeActionCommand: Pe, organizeImports: nr, getEditsForFileRename: Mr, getEmitOutput: et, getNonBoundSourceFile: Wt, getProgram: Ae, getAutoImportProvider: er, getApplicableRefactors: Rt, getEditsForRefactor: Ii, toLineColumnOffset: Ki, getSourceMapper: function() {
                return we;
              }, clearSourceMapperCache: function() {
                return we.clearCache();
              }, prepareCallHierarchy: Fi, provideCallHierarchyIncomingCalls: ui, provideCallHierarchyOutgoingCalls: Bt, toggleLineComment: Tr, toggleMultilineComment: vi, commentSelection: Ui, uncommentSelection: Yi, provideInlayHints: wt };
              switch (Z2) {
                case e2.LanguageServiceMode.Semantic:
                  break;
                case e2.LanguageServiceMode.PartialSemantic:
                  L.forEach(function(Ai) {
                    return na[Ai] = function() {
                      throw new Error("LanguageService Operation: ".concat(Ai, " not allowed in LanguageServiceMode.PartialSemantic"));
                    };
                  });
                  break;
                case e2.LanguageServiceMode.Syntactic:
                  P.forEach(function(Ai) {
                    return na[Ai] = function() {
                      throw new Error("LanguageService Operation: ".concat(Ai, " not allowed in LanguageServiceMode.Syntactic"));
                    };
                  });
                  break;
                default:
                  e2.Debug.assertNever(Z2);
              }
              return na;
            }
            e2.createLanguageService = k;
            function Y(g) {
              return g.nameTable || U(g), g.nameTable;
            }
            e2.getNameTable = Y;
            function U(g) {
              var ne = g.nameTable = new e2.Map();
              g.forEachChild(function ue(We) {
                if (e2.isIdentifier(We) && !e2.isTagName(We) && We.escapedText || e2.isStringOrNumericLiteralLike(We) && j(We)) {
                  var Fe = e2.getEscapedTextOfIdentifierOrLiteral(We);
                  ne.set(Fe, ne.get(Fe) === void 0 ? We.pos : -1);
                } else if (e2.isPrivateIdentifier(We)) {
                  var Fe = We.escapedText;
                  ne.set(Fe, ne.get(Fe) === void 0 ? We.pos : -1);
                }
                if (e2.forEachChild(We, ue), e2.hasJSDocNodes(We))
                  for (var Z2 = 0, Be = We.jsDoc; Z2 < Be.length; Z2++) {
                    var ge = Be[Z2];
                    e2.forEachChild(ge, ue);
                  }
              });
            }
            function j(g) {
              return e2.isDeclarationName(g) || g.parent.kind === 277 || D(g) || e2.isLiteralComputedPropertyDeclarationName(g);
            }
            function H(g) {
              var ne = I(g);
              return ne && (e2.isObjectLiteralExpression(ne.parent) || e2.isJsxAttributes(ne.parent)) ? ne : void 0;
            }
            e2.getContainingObjectLiteralElement = H;
            function I(g) {
              switch (g.kind) {
                case 10:
                case 14:
                case 8:
                  if (g.parent.kind === 162)
                    return e2.isObjectLiteralElement(g.parent.parent) ? g.parent.parent : void 0;
                case 79:
                  return e2.isObjectLiteralElement(g.parent) && (g.parent.parent.kind === 205 || g.parent.parent.kind === 286) && g.parent.name === g ? g.parent : void 0;
              }
            }
            function l(g, ne) {
              var ue = H(g);
              if (ue) {
                var We = ne.getContextualType(ue.parent), Fe = We && d(ue, ne, We, false);
                if (Fe && Fe.length === 1)
                  return e2.first(Fe);
              }
              return ne.getSymbolAtLocation(g);
            }
            function d(g, ne, ue, We) {
              var Fe = e2.getNameFromPropertyName(g.name);
              if (!Fe)
                return e2.emptyArray;
              if (!ue.isUnion()) {
                var Z2 = ue.getProperty(Fe);
                return Z2 ? [Z2] : e2.emptyArray;
              }
              var Be = e2.mapDefined(ue.types, function(ge) {
                return (e2.isObjectLiteralExpression(g.parent) || e2.isJsxAttributes(g.parent)) && ne.isTypeInvalidDueToUnionDiscriminant(ge, g.parent) ? void 0 : ge.getProperty(Fe);
              });
              if (We && (Be.length === 0 || Be.length === ue.types.length)) {
                var Z2 = ue.getProperty(Fe);
                if (Z2)
                  return [Z2];
              }
              return Be.length === 0 ? e2.mapDefined(ue.types, function(ge) {
                return ge.getProperty(Fe);
              }) : Be;
            }
            e2.getPropertySymbolsFromContextualType = d;
            function D(g) {
              return g && g.parent && g.parent.kind === 207 && g.parent.argumentExpression === g;
            }
            function fe(g) {
              return "/prettier-security-dirname-placeholder" + e2.directorySeparator + e2.getDefaultLibFileName(g);
            }
            e2.getDefaultLibFilePath = fe, e2.setObjectAllocator(ie());
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            var a;
            (function(C) {
              function w(B, E) {
                if (B.isDeclarationFile)
                  return;
                var Q = e2.getTokenAtPosition(B, E), le = B.getLineAndCharacterOfPosition(E).line;
                if (B.getLineAndCharacterOfPosition(Q.getStart(B)).line > le) {
                  var N = e2.findPrecedingToken(Q.pos, B);
                  if (!N || B.getLineAndCharacterOfPosition(N.getEnd()).line !== le)
                    return;
                  Q = N;
                }
                if (Q.flags & 16777216)
                  return;
                return K(Q);
                function p(b, se) {
                  var J = b.decorators ? e2.skipTrivia(B.text, b.decorators.end) : b.getStart(B);
                  return e2.createTextSpanFromBounds(J, (se || b).getEnd());
                }
                function m2(b, se) {
                  return p(b, e2.findNextToken(se, se.parent, B));
                }
                function G(b, se) {
                  return b && le === B.getLineAndCharacterOfPosition(b.getStart(B)).line ? K(b) : K(se);
                }
                function oe(b) {
                  return e2.createTextSpanFromBounds(e2.skipTrivia(B.text, b.pos), b.end);
                }
                function f4(b) {
                  return K(e2.findPrecedingToken(b.pos, B));
                }
                function T(b) {
                  return K(e2.findNextToken(b, b.parent, B));
                }
                function K(b) {
                  if (b) {
                    var se = b.parent;
                    switch (b.kind) {
                      case 237:
                        return he(b.declarationList.declarations[0]);
                      case 254:
                      case 167:
                      case 166:
                        return he(b);
                      case 164:
                        return x2(b);
                      case 256:
                      case 169:
                      case 168:
                      case 172:
                      case 173:
                      case 171:
                      case 213:
                      case 214:
                        return $(b);
                      case 235:
                        if (e2.isFunctionBlock(b))
                          return A2(b);
                      case 262:
                        return y(b);
                      case 292:
                        return y(b.block);
                      case 238:
                        return p(b.expression);
                      case 247:
                        return p(b.getChildAt(0), b.expression);
                      case 241:
                        return m2(b, b.expression);
                      case 240:
                        return K(b.statement);
                      case 253:
                        return p(b.getChildAt(0));
                      case 239:
                        return m2(b, b.expression);
                      case 250:
                        return K(b.statement);
                      case 246:
                      case 245:
                        return p(b.getChildAt(0), b.label);
                      case 242:
                        return L(b);
                      case 243:
                        return m2(b, b.expression);
                      case 244:
                        return V(b);
                      case 249:
                        return m2(b, b.expression);
                      case 289:
                      case 290:
                        return K(b.statements[0]);
                      case 252:
                        return y(b.tryBlock);
                      case 251:
                        return p(b, b.expression);
                      case 271:
                        return p(b, b.expression);
                      case 265:
                        return p(b, b.moduleReference);
                      case 266:
                        return p(b, b.moduleSpecifier);
                      case 272:
                        return p(b, b.moduleSpecifier);
                      case 261:
                        if (e2.getModuleInstanceState(b) !== 1)
                          return;
                      case 257:
                      case 260:
                      case 299:
                      case 203:
                        return p(b);
                      case 248:
                        return K(b.statement);
                      case 165:
                        return oe(se.decorators);
                      case 201:
                      case 202:
                        return P(b);
                      case 258:
                      case 259:
                        return;
                      case 26:
                      case 1:
                        return G(e2.findPrecedingToken(b.pos, B));
                      case 27:
                        return f4(b);
                      case 18:
                        return Y(b);
                      case 19:
                        return U(b);
                      case 23:
                        return j(b);
                      case 20:
                        return H(b);
                      case 21:
                        return I(b);
                      case 58:
                        return l(b);
                      case 31:
                      case 29:
                        return d(b);
                      case 115:
                        return D(b);
                      case 91:
                      case 83:
                      case 96:
                        return T(b);
                      case 160:
                        return fe(b);
                      default:
                        if (e2.isArrayLiteralOrObjectLiteralDestructuringPattern(b))
                          return k(b);
                        if ((b.kind === 79 || b.kind === 225 || b.kind === 296 || b.kind === 297) && e2.isArrayLiteralOrObjectLiteralDestructuringPattern(se))
                          return p(b);
                        if (b.kind === 221) {
                          var J = b, ie = J.left, R = J.operatorToken;
                          if (e2.isArrayLiteralOrObjectLiteralDestructuringPattern(ie))
                            return k(ie);
                          if (R.kind === 63 && e2.isArrayLiteralOrObjectLiteralDestructuringPattern(b.parent))
                            return p(b);
                          if (R.kind === 27)
                            return K(ie);
                        }
                        if (e2.isExpressionNode(b))
                          switch (se.kind) {
                            case 240:
                              return f4(b);
                            case 165:
                              return K(b.parent);
                            case 242:
                            case 244:
                              return p(b);
                            case 221:
                              if (b.parent.operatorToken.kind === 27)
                                return p(b);
                              break;
                            case 214:
                              if (b.parent.body === b)
                                return p(b);
                              break;
                          }
                        switch (b.parent.kind) {
                          case 296:
                            if (b.parent.name === b && !e2.isArrayLiteralOrObjectLiteralDestructuringPattern(b.parent.parent))
                              return K(b.parent.initializer);
                            break;
                          case 211:
                            if (b.parent.type === b)
                              return T(b.parent.type);
                            break;
                          case 254:
                          case 164: {
                            var q = b.parent, O = q.initializer, ve = q.type;
                            if (O === b || ve === b || e2.isAssignmentOperator(b.kind))
                              return f4(b);
                            break;
                          }
                          case 221: {
                            var ie = b.parent.left;
                            if (e2.isArrayLiteralOrObjectLiteralDestructuringPattern(ie) && b !== ie)
                              return f4(b);
                            break;
                          }
                          default:
                            if (e2.isFunctionLike(b.parent) && b.parent.type === b)
                              return f4(b);
                        }
                        return K(b.parent);
                    }
                  }
                  function ee(g) {
                    return e2.isVariableDeclarationList(g.parent) && g.parent.declarations[0] === g ? p(e2.findPrecedingToken(g.pos, B, g.parent), g) : p(g);
                  }
                  function he(g) {
                    if (g.parent.parent.kind === 243)
                      return K(g.parent.parent);
                    var ne = g.parent;
                    if (e2.isBindingPattern(g.name))
                      return P(g.name);
                    if (g.initializer || e2.hasSyntacticModifier(g, 1) || ne.parent.kind === 244)
                      return ee(g);
                    if (e2.isVariableDeclarationList(g.parent) && g.parent.declarations[0] !== g)
                      return K(e2.findPrecedingToken(g.pos, B, g.parent));
                  }
                  function F2(g) {
                    return !!g.initializer || g.dotDotDotToken !== void 0 || e2.hasSyntacticModifier(g, 12);
                  }
                  function x2(g) {
                    if (e2.isBindingPattern(g.name))
                      return P(g.name);
                    if (F2(g))
                      return p(g);
                    var ne = g.parent, ue = ne.parameters.indexOf(g);
                    return e2.Debug.assert(ue !== -1), ue !== 0 ? x2(ne.parameters[ue - 1]) : K(ne.body);
                  }
                  function X(g) {
                    return e2.hasSyntacticModifier(g, 1) || g.parent.kind === 257 && g.kind !== 171;
                  }
                  function $(g) {
                    if (!!g.body)
                      return X(g) ? p(g) : K(g.body);
                  }
                  function A2(g) {
                    var ne = g.statements.length ? g.statements[0] : g.getLastToken();
                    return X(g.parent) ? G(g.parent, ne) : K(ne);
                  }
                  function y(g) {
                    switch (g.parent.kind) {
                      case 261:
                        if (e2.getModuleInstanceState(g.parent) !== 1)
                          return;
                      case 241:
                      case 239:
                      case 243:
                        return G(g.parent, g.statements[0]);
                      case 242:
                      case 244:
                        return G(e2.findPrecedingToken(g.pos, B, g.parent), g.statements[0]);
                    }
                    return K(g.statements[0]);
                  }
                  function V(g) {
                    if (g.initializer.kind === 255) {
                      var ne = g.initializer;
                      if (ne.declarations.length > 0)
                        return K(ne.declarations[0]);
                    } else
                      return K(g.initializer);
                  }
                  function L(g) {
                    if (g.initializer)
                      return V(g);
                    if (g.condition)
                      return p(g.condition);
                    if (g.incrementor)
                      return p(g.incrementor);
                  }
                  function P(g) {
                    var ne = e2.forEach(g.elements, function(ue) {
                      return ue.kind !== 227 ? ue : void 0;
                    });
                    return ne ? K(ne) : g.parent.kind === 203 ? p(g.parent) : ee(g.parent);
                  }
                  function k(g) {
                    e2.Debug.assert(g.kind !== 202 && g.kind !== 201);
                    var ne = g.kind === 204 ? g.elements : g.properties, ue = e2.forEach(ne, function(We) {
                      return We.kind !== 227 ? We : void 0;
                    });
                    return ue ? K(ue) : p(g.parent.kind === 221 ? g.parent : g);
                  }
                  function Y(g) {
                    switch (g.parent.kind) {
                      case 260:
                        var ne = g.parent;
                        return G(e2.findPrecedingToken(g.pos, B, g.parent), ne.members.length ? ne.members[0] : ne.getLastToken(B));
                      case 257:
                        var ue = g.parent;
                        return G(e2.findPrecedingToken(g.pos, B, g.parent), ue.members.length ? ue.members[0] : ue.getLastToken(B));
                      case 263:
                        return G(g.parent.parent, g.parent.clauses[0]);
                    }
                    return K(g.parent);
                  }
                  function U(g) {
                    switch (g.parent.kind) {
                      case 262:
                        if (e2.getModuleInstanceState(g.parent.parent) !== 1)
                          return;
                      case 260:
                      case 257:
                        return p(g);
                      case 235:
                        if (e2.isFunctionBlock(g.parent))
                          return p(g);
                      case 292:
                        return K(e2.lastOrUndefined(g.parent.statements));
                      case 263:
                        var ne = g.parent, ue = e2.lastOrUndefined(ne.clauses);
                        return ue ? K(e2.lastOrUndefined(ue.statements)) : void 0;
                      case 201:
                        var We = g.parent;
                        return K(e2.lastOrUndefined(We.elements) || We);
                      default:
                        if (e2.isArrayLiteralOrObjectLiteralDestructuringPattern(g.parent)) {
                          var Fe = g.parent;
                          return p(e2.lastOrUndefined(Fe.properties) || Fe);
                        }
                        return K(g.parent);
                    }
                  }
                  function j(g) {
                    switch (g.parent.kind) {
                      case 202:
                        var ne = g.parent;
                        return p(e2.lastOrUndefined(ne.elements) || ne);
                      default:
                        if (e2.isArrayLiteralOrObjectLiteralDestructuringPattern(g.parent)) {
                          var ue = g.parent;
                          return p(e2.lastOrUndefined(ue.elements) || ue);
                        }
                        return K(g.parent);
                    }
                  }
                  function H(g) {
                    return g.parent.kind === 240 || g.parent.kind === 208 || g.parent.kind === 209 ? f4(g) : g.parent.kind === 212 ? T(g) : K(g.parent);
                  }
                  function I(g) {
                    switch (g.parent.kind) {
                      case 213:
                      case 256:
                      case 214:
                      case 169:
                      case 168:
                      case 172:
                      case 173:
                      case 171:
                      case 241:
                      case 240:
                      case 242:
                      case 244:
                      case 208:
                      case 209:
                      case 212:
                        return f4(g);
                      default:
                        return K(g.parent);
                    }
                  }
                  function l(g) {
                    return e2.isFunctionLike(g.parent) || g.parent.kind === 296 || g.parent.kind === 164 ? f4(g) : K(g.parent);
                  }
                  function d(g) {
                    return g.parent.kind === 211 ? T(g) : K(g.parent);
                  }
                  function D(g) {
                    return g.parent.kind === 240 ? m2(g, g.parent.expression) : K(g.parent);
                  }
                  function fe(g) {
                    return g.parent.kind === 244 ? T(g) : K(g.parent);
                  }
                }
              }
              C.spanInSourceFileAtLocation = w;
            })(a = e2.BreakpointResolver || (e2.BreakpointResolver = {}));
          })(ke || (ke = {}));
          var ke;
          (function(e2) {
            function a(C, w, B) {
              var E = [];
              B = e2.fixupCompilerOptions(B, E);
              var Q = e2.isArray(C) ? C : [C], le = e2.transformNodes(void 0, void 0, e2.factory, B, Q, w, true);
              return le.diagnostics = e2.concatenate(le.diagnostics, E), le;
            }
            e2.transform = a;
          })(ke || (ke = {}));
          var ar = function() {
            return this;
          }(), ke;
          (function(e2) {
            function a(m2, G) {
              m2 && m2.log("*INTERNAL ERROR* - Exception in typescript services: " + G.message);
            }
            var C = void 0, w = void 0;
            e2.LanguageServiceShimHostAdapter = w;
            var B = void 0;
            e2.CoreServicesShimHostAdapter = B;
            var E = void 0;
            e2.realizeDiagnostics = void 0;
            var Q = void 0, le = void 0, N = void 0, p = void 0;
            e2.TypeScriptServicesFactory = void 0;
          })(ke || (ke = {})), function() {
            return;
            try {
              Object.defineProperty(Object.prototype, "__magic__", { get: function() {
                return this;
              }, configurable: true }), __magic__.globalThis = __magic__, typeof globalThis > "u" && (window.globalThis = window), delete Object.prototype.__magic__;
            } catch {
              window.globalThis = window;
            }
          }(), typeof re < "u" && re.exports && (re.exports = ke);
          var ke;
          (function(e2) {
            var a = { since: "4.0", warnAfter: "4.1", message: "Use the appropriate method on 'ts.factory' or the 'factory' supplied by your transformation context instead." };
            e2.createNodeArray = e2.Debug.deprecate(e2.factory.createNodeArray, a), e2.createNumericLiteral = e2.Debug.deprecate(e2.factory.createNumericLiteral, a), e2.createBigIntLiteral = e2.Debug.deprecate(e2.factory.createBigIntLiteral, a), e2.createStringLiteral = e2.Debug.deprecate(e2.factory.createStringLiteral, a), e2.createStringLiteralFromNode = e2.Debug.deprecate(e2.factory.createStringLiteralFromNode, a), e2.createRegularExpressionLiteral = e2.Debug.deprecate(e2.factory.createRegularExpressionLiteral, a), e2.createLoopVariable = e2.Debug.deprecate(e2.factory.createLoopVariable, a), e2.createUniqueName = e2.Debug.deprecate(e2.factory.createUniqueName, a), e2.createPrivateIdentifier = e2.Debug.deprecate(e2.factory.createPrivateIdentifier, a), e2.createSuper = e2.Debug.deprecate(e2.factory.createSuper, a), e2.createThis = e2.Debug.deprecate(e2.factory.createThis, a), e2.createNull = e2.Debug.deprecate(e2.factory.createNull, a), e2.createTrue = e2.Debug.deprecate(e2.factory.createTrue, a), e2.createFalse = e2.Debug.deprecate(e2.factory.createFalse, a), e2.createModifier = e2.Debug.deprecate(e2.factory.createModifier, a), e2.createModifiersFromModifierFlags = e2.Debug.deprecate(e2.factory.createModifiersFromModifierFlags, a), e2.createQualifiedName = e2.Debug.deprecate(e2.factory.createQualifiedName, a), e2.updateQualifiedName = e2.Debug.deprecate(e2.factory.updateQualifiedName, a), e2.createComputedPropertyName = e2.Debug.deprecate(e2.factory.createComputedPropertyName, a), e2.updateComputedPropertyName = e2.Debug.deprecate(e2.factory.updateComputedPropertyName, a), e2.createTypeParameterDeclaration = e2.Debug.deprecate(e2.factory.createTypeParameterDeclaration, a), e2.updateTypeParameterDeclaration = e2.Debug.deprecate(e2.factory.updateTypeParameterDeclaration, a), e2.createParameter = e2.Debug.deprecate(e2.factory.createParameterDeclaration, a), e2.updateParameter = e2.Debug.deprecate(e2.factory.updateParameterDeclaration, a), e2.createDecorator = e2.Debug.deprecate(e2.factory.createDecorator, a), e2.updateDecorator = e2.Debug.deprecate(e2.factory.updateDecorator, a), e2.createProperty = e2.Debug.deprecate(e2.factory.createPropertyDeclaration, a), e2.updateProperty = e2.Debug.deprecate(e2.factory.updatePropertyDeclaration, a), e2.createMethod = e2.Debug.deprecate(e2.factory.createMethodDeclaration, a), e2.updateMethod = e2.Debug.deprecate(e2.factory.updateMethodDeclaration, a), e2.createConstructor = e2.Debug.deprecate(e2.factory.createConstructorDeclaration, a), e2.updateConstructor = e2.Debug.deprecate(e2.factory.updateConstructorDeclaration, a), e2.createGetAccessor = e2.Debug.deprecate(e2.factory.createGetAccessorDeclaration, a), e2.updateGetAccessor = e2.Debug.deprecate(e2.factory.updateGetAccessorDeclaration, a), e2.createSetAccessor = e2.Debug.deprecate(e2.factory.createSetAccessorDeclaration, a), e2.updateSetAccessor = e2.Debug.deprecate(e2.factory.updateSetAccessorDeclaration, a), e2.createCallSignature = e2.Debug.deprecate(e2.factory.createCallSignature, a), e2.updateCallSignature = e2.Debug.deprecate(e2.factory.updateCallSignature, a), e2.createConstructSignature = e2.Debug.deprecate(e2.factory.createConstructSignature, a), e2.updateConstructSignature = e2.Debug.deprecate(e2.factory.updateConstructSignature, a), e2.updateIndexSignature = e2.Debug.deprecate(e2.factory.updateIndexSignature, a), e2.createKeywordTypeNode = e2.Debug.deprecate(e2.factory.createKeywordTypeNode, a), e2.createTypePredicateNodeWithModifier = e2.Debug.deprecate(e2.factory.createTypePredicateNode, a), e2.updateTypePredicateNodeWithModifier = e2.Debug.deprecate(e2.factory.updateTypePredicateNode, a), e2.createTypeReferenceNode = e2.Debug.deprecate(e2.factory.createTypeReferenceNode, a), e2.updateTypeReferenceNode = e2.Debug.deprecate(e2.factory.updateTypeReferenceNode, a), e2.createFunctionTypeNode = e2.Debug.deprecate(e2.factory.createFunctionTypeNode, a), e2.updateFunctionTypeNode = e2.Debug.deprecate(e2.factory.updateFunctionTypeNode, a), e2.createConstructorTypeNode = e2.Debug.deprecate(function(C, w, B) {
              return e2.factory.createConstructorTypeNode(void 0, C, w, B);
            }, a), e2.updateConstructorTypeNode = e2.Debug.deprecate(function(C, w, B, E) {
              return e2.factory.updateConstructorTypeNode(C, C.modifiers, w, B, E);
            }, a), e2.createTypeQueryNode = e2.Debug.deprecate(e2.factory.createTypeQueryNode, a), e2.updateTypeQueryNode = e2.Debug.deprecate(e2.factory.updateTypeQueryNode, a), e2.createTypeLiteralNode = e2.Debug.deprecate(e2.factory.createTypeLiteralNode, a), e2.updateTypeLiteralNode = e2.Debug.deprecate(e2.factory.updateTypeLiteralNode, a), e2.createArrayTypeNode = e2.Debug.deprecate(e2.factory.createArrayTypeNode, a), e2.updateArrayTypeNode = e2.Debug.deprecate(e2.factory.updateArrayTypeNode, a), e2.createTupleTypeNode = e2.Debug.deprecate(e2.factory.createTupleTypeNode, a), e2.updateTupleTypeNode = e2.Debug.deprecate(e2.factory.updateTupleTypeNode, a), e2.createOptionalTypeNode = e2.Debug.deprecate(e2.factory.createOptionalTypeNode, a), e2.updateOptionalTypeNode = e2.Debug.deprecate(e2.factory.updateOptionalTypeNode, a), e2.createRestTypeNode = e2.Debug.deprecate(e2.factory.createRestTypeNode, a), e2.updateRestTypeNode = e2.Debug.deprecate(e2.factory.updateRestTypeNode, a), e2.createUnionTypeNode = e2.Debug.deprecate(e2.factory.createUnionTypeNode, a), e2.updateUnionTypeNode = e2.Debug.deprecate(e2.factory.updateUnionTypeNode, a), e2.createIntersectionTypeNode = e2.Debug.deprecate(e2.factory.createIntersectionTypeNode, a), e2.updateIntersectionTypeNode = e2.Debug.deprecate(e2.factory.updateIntersectionTypeNode, a), e2.createConditionalTypeNode = e2.Debug.deprecate(e2.factory.createConditionalTypeNode, a), e2.updateConditionalTypeNode = e2.Debug.deprecate(e2.factory.updateConditionalTypeNode, a), e2.createInferTypeNode = e2.Debug.deprecate(e2.factory.createInferTypeNode, a), e2.updateInferTypeNode = e2.Debug.deprecate(e2.factory.updateInferTypeNode, a), e2.createImportTypeNode = e2.Debug.deprecate(e2.factory.createImportTypeNode, a), e2.updateImportTypeNode = e2.Debug.deprecate(e2.factory.updateImportTypeNode, a), e2.createParenthesizedType = e2.Debug.deprecate(e2.factory.createParenthesizedType, a), e2.updateParenthesizedType = e2.Debug.deprecate(e2.factory.updateParenthesizedType, a), e2.createThisTypeNode = e2.Debug.deprecate(e2.factory.createThisTypeNode, a), e2.updateTypeOperatorNode = e2.Debug.deprecate(e2.factory.updateTypeOperatorNode, a), e2.createIndexedAccessTypeNode = e2.Debug.deprecate(e2.factory.createIndexedAccessTypeNode, a), e2.updateIndexedAccessTypeNode = e2.Debug.deprecate(e2.factory.updateIndexedAccessTypeNode, a), e2.createMappedTypeNode = e2.Debug.deprecate(e2.factory.createMappedTypeNode, a), e2.updateMappedTypeNode = e2.Debug.deprecate(e2.factory.updateMappedTypeNode, a), e2.createLiteralTypeNode = e2.Debug.deprecate(e2.factory.createLiteralTypeNode, a), e2.updateLiteralTypeNode = e2.Debug.deprecate(e2.factory.updateLiteralTypeNode, a), e2.createObjectBindingPattern = e2.Debug.deprecate(e2.factory.createObjectBindingPattern, a), e2.updateObjectBindingPattern = e2.Debug.deprecate(e2.factory.updateObjectBindingPattern, a), e2.createArrayBindingPattern = e2.Debug.deprecate(e2.factory.createArrayBindingPattern, a), e2.updateArrayBindingPattern = e2.Debug.deprecate(e2.factory.updateArrayBindingPattern, a), e2.createBindingElement = e2.Debug.deprecate(e2.factory.createBindingElement, a), e2.updateBindingElement = e2.Debug.deprecate(e2.factory.updateBindingElement, a), e2.createArrayLiteral = e2.Debug.deprecate(e2.factory.createArrayLiteralExpression, a), e2.updateArrayLiteral = e2.Debug.deprecate(e2.factory.updateArrayLiteralExpression, a), e2.createObjectLiteral = e2.Debug.deprecate(e2.factory.createObjectLiteralExpression, a), e2.updateObjectLiteral = e2.Debug.deprecate(e2.factory.updateObjectLiteralExpression, a), e2.createPropertyAccess = e2.Debug.deprecate(e2.factory.createPropertyAccessExpression, a), e2.updatePropertyAccess = e2.Debug.deprecate(e2.factory.updatePropertyAccessExpression, a), e2.createPropertyAccessChain = e2.Debug.deprecate(e2.factory.createPropertyAccessChain, a), e2.updatePropertyAccessChain = e2.Debug.deprecate(e2.factory.updatePropertyAccessChain, a), e2.createElementAccess = e2.Debug.deprecate(e2.factory.createElementAccessExpression, a), e2.updateElementAccess = e2.Debug.deprecate(e2.factory.updateElementAccessExpression, a), e2.createElementAccessChain = e2.Debug.deprecate(e2.factory.createElementAccessChain, a), e2.updateElementAccessChain = e2.Debug.deprecate(e2.factory.updateElementAccessChain, a), e2.createCall = e2.Debug.deprecate(e2.factory.createCallExpression, a), e2.updateCall = e2.Debug.deprecate(e2.factory.updateCallExpression, a), e2.createCallChain = e2.Debug.deprecate(e2.factory.createCallChain, a), e2.updateCallChain = e2.Debug.deprecate(e2.factory.updateCallChain, a), e2.createNew = e2.Debug.deprecate(e2.factory.createNewExpression, a), e2.updateNew = e2.Debug.deprecate(e2.factory.updateNewExpression, a), e2.createTypeAssertion = e2.Debug.deprecate(e2.factory.createTypeAssertion, a), e2.updateTypeAssertion = e2.Debug.deprecate(e2.factory.updateTypeAssertion, a), e2.createParen = e2.Debug.deprecate(e2.factory.createParenthesizedExpression, a), e2.updateParen = e2.Debug.deprecate(e2.factory.updateParenthesizedExpression, a), e2.createFunctionExpression = e2.Debug.deprecate(e2.factory.createFunctionExpression, a), e2.updateFunctionExpression = e2.Debug.deprecate(e2.factory.updateFunctionExpression, a), e2.createDelete = e2.Debug.deprecate(e2.factory.createDeleteExpression, a), e2.updateDelete = e2.Debug.deprecate(e2.factory.updateDeleteExpression, a), e2.createTypeOf = e2.Debug.deprecate(e2.factory.createTypeOfExpression, a), e2.updateTypeOf = e2.Debug.deprecate(e2.factory.updateTypeOfExpression, a), e2.createVoid = e2.Debug.deprecate(e2.factory.createVoidExpression, a), e2.updateVoid = e2.Debug.deprecate(e2.factory.updateVoidExpression, a), e2.createAwait = e2.Debug.deprecate(e2.factory.createAwaitExpression, a), e2.updateAwait = e2.Debug.deprecate(e2.factory.updateAwaitExpression, a), e2.createPrefix = e2.Debug.deprecate(e2.factory.createPrefixUnaryExpression, a), e2.updatePrefix = e2.Debug.deprecate(e2.factory.updatePrefixUnaryExpression, a), e2.createPostfix = e2.Debug.deprecate(e2.factory.createPostfixUnaryExpression, a), e2.updatePostfix = e2.Debug.deprecate(e2.factory.updatePostfixUnaryExpression, a), e2.createBinary = e2.Debug.deprecate(e2.factory.createBinaryExpression, a), e2.updateConditional = e2.Debug.deprecate(e2.factory.updateConditionalExpression, a), e2.createTemplateExpression = e2.Debug.deprecate(e2.factory.createTemplateExpression, a), e2.updateTemplateExpression = e2.Debug.deprecate(e2.factory.updateTemplateExpression, a), e2.createTemplateHead = e2.Debug.deprecate(e2.factory.createTemplateHead, a), e2.createTemplateMiddle = e2.Debug.deprecate(e2.factory.createTemplateMiddle, a), e2.createTemplateTail = e2.Debug.deprecate(e2.factory.createTemplateTail, a), e2.createNoSubstitutionTemplateLiteral = e2.Debug.deprecate(e2.factory.createNoSubstitutionTemplateLiteral, a), e2.updateYield = e2.Debug.deprecate(e2.factory.updateYieldExpression, a), e2.createSpread = e2.Debug.deprecate(e2.factory.createSpreadElement, a), e2.updateSpread = e2.Debug.deprecate(e2.factory.updateSpreadElement, a), e2.createOmittedExpression = e2.Debug.deprecate(e2.factory.createOmittedExpression, a), e2.createAsExpression = e2.Debug.deprecate(e2.factory.createAsExpression, a), e2.updateAsExpression = e2.Debug.deprecate(e2.factory.updateAsExpression, a), e2.createNonNullExpression = e2.Debug.deprecate(e2.factory.createNonNullExpression, a), e2.updateNonNullExpression = e2.Debug.deprecate(e2.factory.updateNonNullExpression, a), e2.createNonNullChain = e2.Debug.deprecate(e2.factory.createNonNullChain, a), e2.updateNonNullChain = e2.Debug.deprecate(e2.factory.updateNonNullChain, a), e2.createMetaProperty = e2.Debug.deprecate(e2.factory.createMetaProperty, a), e2.updateMetaProperty = e2.Debug.deprecate(e2.factory.updateMetaProperty, a), e2.createTemplateSpan = e2.Debug.deprecate(e2.factory.createTemplateSpan, a), e2.updateTemplateSpan = e2.Debug.deprecate(e2.factory.updateTemplateSpan, a), e2.createSemicolonClassElement = e2.Debug.deprecate(e2.factory.createSemicolonClassElement, a), e2.createBlock = e2.Debug.deprecate(e2.factory.createBlock, a), e2.updateBlock = e2.Debug.deprecate(e2.factory.updateBlock, a), e2.createVariableStatement = e2.Debug.deprecate(e2.factory.createVariableStatement, a), e2.updateVariableStatement = e2.Debug.deprecate(e2.factory.updateVariableStatement, a), e2.createEmptyStatement = e2.Debug.deprecate(e2.factory.createEmptyStatement, a), e2.createExpressionStatement = e2.Debug.deprecate(e2.factory.createExpressionStatement, a), e2.updateExpressionStatement = e2.Debug.deprecate(e2.factory.updateExpressionStatement, a), e2.createStatement = e2.Debug.deprecate(e2.factory.createExpressionStatement, a), e2.updateStatement = e2.Debug.deprecate(e2.factory.updateExpressionStatement, a), e2.createIf = e2.Debug.deprecate(e2.factory.createIfStatement, a), e2.updateIf = e2.Debug.deprecate(e2.factory.updateIfStatement, a), e2.createDo = e2.Debug.deprecate(e2.factory.createDoStatement, a), e2.updateDo = e2.Debug.deprecate(e2.factory.updateDoStatement, a), e2.createWhile = e2.Debug.deprecate(e2.factory.createWhileStatement, a), e2.updateWhile = e2.Debug.deprecate(e2.factory.updateWhileStatement, a), e2.createFor = e2.Debug.deprecate(e2.factory.createForStatement, a), e2.updateFor = e2.Debug.deprecate(e2.factory.updateForStatement, a), e2.createForIn = e2.Debug.deprecate(e2.factory.createForInStatement, a), e2.updateForIn = e2.Debug.deprecate(e2.factory.updateForInStatement, a), e2.createForOf = e2.Debug.deprecate(e2.factory.createForOfStatement, a), e2.updateForOf = e2.Debug.deprecate(e2.factory.updateForOfStatement, a), e2.createContinue = e2.Debug.deprecate(e2.factory.createContinueStatement, a), e2.updateContinue = e2.Debug.deprecate(e2.factory.updateContinueStatement, a), e2.createBreak = e2.Debug.deprecate(e2.factory.createBreakStatement, a), e2.updateBreak = e2.Debug.deprecate(e2.factory.updateBreakStatement, a), e2.createReturn = e2.Debug.deprecate(e2.factory.createReturnStatement, a), e2.updateReturn = e2.Debug.deprecate(e2.factory.updateReturnStatement, a), e2.createWith = e2.Debug.deprecate(e2.factory.createWithStatement, a), e2.updateWith = e2.Debug.deprecate(e2.factory.updateWithStatement, a), e2.createSwitch = e2.Debug.deprecate(e2.factory.createSwitchStatement, a), e2.updateSwitch = e2.Debug.deprecate(e2.factory.updateSwitchStatement, a), e2.createLabel = e2.Debug.deprecate(e2.factory.createLabeledStatement, a), e2.updateLabel = e2.Debug.deprecate(e2.factory.updateLabeledStatement, a), e2.createThrow = e2.Debug.deprecate(e2.factory.createThrowStatement, a), e2.updateThrow = e2.Debug.deprecate(e2.factory.updateThrowStatement, a), e2.createTry = e2.Debug.deprecate(e2.factory.createTryStatement, a), e2.updateTry = e2.Debug.deprecate(e2.factory.updateTryStatement, a), e2.createDebuggerStatement = e2.Debug.deprecate(e2.factory.createDebuggerStatement, a), e2.createVariableDeclarationList = e2.Debug.deprecate(e2.factory.createVariableDeclarationList, a), e2.updateVariableDeclarationList = e2.Debug.deprecate(e2.factory.updateVariableDeclarationList, a), e2.createFunctionDeclaration = e2.Debug.deprecate(e2.factory.createFunctionDeclaration, a), e2.updateFunctionDeclaration = e2.Debug.deprecate(e2.factory.updateFunctionDeclaration, a), e2.createClassDeclaration = e2.Debug.deprecate(e2.factory.createClassDeclaration, a), e2.updateClassDeclaration = e2.Debug.deprecate(e2.factory.updateClassDeclaration, a), e2.createInterfaceDeclaration = e2.Debug.deprecate(e2.factory.createInterfaceDeclaration, a), e2.updateInterfaceDeclaration = e2.Debug.deprecate(e2.factory.updateInterfaceDeclaration, a), e2.createTypeAliasDeclaration = e2.Debug.deprecate(e2.factory.createTypeAliasDeclaration, a), e2.updateTypeAliasDeclaration = e2.Debug.deprecate(e2.factory.updateTypeAliasDeclaration, a), e2.createEnumDeclaration = e2.Debug.deprecate(e2.factory.createEnumDeclaration, a), e2.updateEnumDeclaration = e2.Debug.deprecate(e2.factory.updateEnumDeclaration, a), e2.createModuleDeclaration = e2.Debug.deprecate(e2.factory.createModuleDeclaration, a), e2.updateModuleDeclaration = e2.Debug.deprecate(e2.factory.updateModuleDeclaration, a), e2.createModuleBlock = e2.Debug.deprecate(e2.factory.createModuleBlock, a), e2.updateModuleBlock = e2.Debug.deprecate(e2.factory.updateModuleBlock, a), e2.createCaseBlock = e2.Debug.deprecate(e2.factory.createCaseBlock, a), e2.updateCaseBlock = e2.Debug.deprecate(e2.factory.updateCaseBlock, a), e2.createNamespaceExportDeclaration = e2.Debug.deprecate(e2.factory.createNamespaceExportDeclaration, a), e2.updateNamespaceExportDeclaration = e2.Debug.deprecate(e2.factory.updateNamespaceExportDeclaration, a), e2.createImportEqualsDeclaration = e2.Debug.deprecate(e2.factory.createImportEqualsDeclaration, a), e2.updateImportEqualsDeclaration = e2.Debug.deprecate(e2.factory.updateImportEqualsDeclaration, a), e2.createImportDeclaration = e2.Debug.deprecate(e2.factory.createImportDeclaration, a), e2.updateImportDeclaration = e2.Debug.deprecate(e2.factory.updateImportDeclaration, a), e2.createNamespaceImport = e2.Debug.deprecate(e2.factory.createNamespaceImport, a), e2.updateNamespaceImport = e2.Debug.deprecate(e2.factory.updateNamespaceImport, a), e2.createNamedImports = e2.Debug.deprecate(e2.factory.createNamedImports, a), e2.updateNamedImports = e2.Debug.deprecate(e2.factory.updateNamedImports, a), e2.createImportSpecifier = e2.Debug.deprecate(e2.factory.createImportSpecifier, a), e2.updateImportSpecifier = e2.Debug.deprecate(e2.factory.updateImportSpecifier, a), e2.createExportAssignment = e2.Debug.deprecate(e2.factory.createExportAssignment, a), e2.updateExportAssignment = e2.Debug.deprecate(e2.factory.updateExportAssignment, a), e2.createNamedExports = e2.Debug.deprecate(e2.factory.createNamedExports, a), e2.updateNamedExports = e2.Debug.deprecate(e2.factory.updateNamedExports, a), e2.createExportSpecifier = e2.Debug.deprecate(e2.factory.createExportSpecifier, a), e2.updateExportSpecifier = e2.Debug.deprecate(e2.factory.updateExportSpecifier, a), e2.createExternalModuleReference = e2.Debug.deprecate(e2.factory.createExternalModuleReference, a), e2.updateExternalModuleReference = e2.Debug.deprecate(e2.factory.updateExternalModuleReference, a), e2.createJSDocTypeExpression = e2.Debug.deprecate(e2.factory.createJSDocTypeExpression, a), e2.createJSDocTypeTag = e2.Debug.deprecate(e2.factory.createJSDocTypeTag, a), e2.createJSDocReturnTag = e2.Debug.deprecate(e2.factory.createJSDocReturnTag, a), e2.createJSDocThisTag = e2.Debug.deprecate(e2.factory.createJSDocThisTag, a), e2.createJSDocComment = e2.Debug.deprecate(e2.factory.createJSDocComment, a), e2.createJSDocParameterTag = e2.Debug.deprecate(e2.factory.createJSDocParameterTag, a), e2.createJSDocClassTag = e2.Debug.deprecate(e2.factory.createJSDocClassTag, a), e2.createJSDocAugmentsTag = e2.Debug.deprecate(e2.factory.createJSDocAugmentsTag, a), e2.createJSDocEnumTag = e2.Debug.deprecate(e2.factory.createJSDocEnumTag, a), e2.createJSDocTemplateTag = e2.Debug.deprecate(e2.factory.createJSDocTemplateTag, a), e2.createJSDocTypedefTag = e2.Debug.deprecate(e2.factory.createJSDocTypedefTag, a), e2.createJSDocCallbackTag = e2.Debug.deprecate(e2.factory.createJSDocCallbackTag, a), e2.createJSDocSignature = e2.Debug.deprecate(e2.factory.createJSDocSignature, a), e2.createJSDocPropertyTag = e2.Debug.deprecate(e2.factory.createJSDocPropertyTag, a), e2.createJSDocTypeLiteral = e2.Debug.deprecate(e2.factory.createJSDocTypeLiteral, a), e2.createJSDocImplementsTag = e2.Debug.deprecate(e2.factory.createJSDocImplementsTag, a), e2.createJSDocAuthorTag = e2.Debug.deprecate(e2.factory.createJSDocAuthorTag, a), e2.createJSDocPublicTag = e2.Debug.deprecate(e2.factory.createJSDocPublicTag, a), e2.createJSDocPrivateTag = e2.Debug.deprecate(e2.factory.createJSDocPrivateTag, a), e2.createJSDocProtectedTag = e2.Debug.deprecate(e2.factory.createJSDocProtectedTag, a), e2.createJSDocReadonlyTag = e2.Debug.deprecate(e2.factory.createJSDocReadonlyTag, a), e2.createJSDocTag = e2.Debug.deprecate(e2.factory.createJSDocUnknownTag, a), e2.createJsxElement = e2.Debug.deprecate(e2.factory.createJsxElement, a), e2.updateJsxElement = e2.Debug.deprecate(e2.factory.updateJsxElement, a), e2.createJsxSelfClosingElement = e2.Debug.deprecate(e2.factory.createJsxSelfClosingElement, a), e2.updateJsxSelfClosingElement = e2.Debug.deprecate(e2.factory.updateJsxSelfClosingElement, a), e2.createJsxOpeningElement = e2.Debug.deprecate(e2.factory.createJsxOpeningElement, a), e2.updateJsxOpeningElement = e2.Debug.deprecate(e2.factory.updateJsxOpeningElement, a), e2.createJsxClosingElement = e2.Debug.deprecate(e2.factory.createJsxClosingElement, a), e2.updateJsxClosingElement = e2.Debug.deprecate(e2.factory.updateJsxClosingElement, a), e2.createJsxFragment = e2.Debug.deprecate(e2.factory.createJsxFragment, a), e2.createJsxText = e2.Debug.deprecate(e2.factory.createJsxText, a), e2.updateJsxText = e2.Debug.deprecate(e2.factory.updateJsxText, a), e2.createJsxOpeningFragment = e2.Debug.deprecate(e2.factory.createJsxOpeningFragment, a), e2.createJsxJsxClosingFragment = e2.Debug.deprecate(e2.factory.createJsxJsxClosingFragment, a), e2.updateJsxFragment = e2.Debug.deprecate(e2.factory.updateJsxFragment, a), e2.createJsxAttribute = e2.Debug.deprecate(e2.factory.createJsxAttribute, a), e2.updateJsxAttribute = e2.Debug.deprecate(e2.factory.updateJsxAttribute, a), e2.createJsxAttributes = e2.Debug.deprecate(e2.factory.createJsxAttributes, a), e2.updateJsxAttributes = e2.Debug.deprecate(e2.factory.updateJsxAttributes, a), e2.createJsxSpreadAttribute = e2.Debug.deprecate(e2.factory.createJsxSpreadAttribute, a), e2.updateJsxSpreadAttribute = e2.Debug.deprecate(e2.factory.updateJsxSpreadAttribute, a), e2.createJsxExpression = e2.Debug.deprecate(e2.factory.createJsxExpression, a), e2.updateJsxExpression = e2.Debug.deprecate(e2.factory.updateJsxExpression, a), e2.createCaseClause = e2.Debug.deprecate(e2.factory.createCaseClause, a), e2.updateCaseClause = e2.Debug.deprecate(e2.factory.updateCaseClause, a), e2.createDefaultClause = e2.Debug.deprecate(e2.factory.createDefaultClause, a), e2.updateDefaultClause = e2.Debug.deprecate(e2.factory.updateDefaultClause, a), e2.createHeritageClause = e2.Debug.deprecate(e2.factory.createHeritageClause, a), e2.updateHeritageClause = e2.Debug.deprecate(e2.factory.updateHeritageClause, a), e2.createCatchClause = e2.Debug.deprecate(e2.factory.createCatchClause, a), e2.updateCatchClause = e2.Debug.deprecate(e2.factory.updateCatchClause, a), e2.createPropertyAssignment = e2.Debug.deprecate(e2.factory.createPropertyAssignment, a), e2.updatePropertyAssignment = e2.Debug.deprecate(e2.factory.updatePropertyAssignment, a), e2.createShorthandPropertyAssignment = e2.Debug.deprecate(e2.factory.createShorthandPropertyAssignment, a), e2.updateShorthandPropertyAssignment = e2.Debug.deprecate(e2.factory.updateShorthandPropertyAssignment, a), e2.createSpreadAssignment = e2.Debug.deprecate(e2.factory.createSpreadAssignment, a), e2.updateSpreadAssignment = e2.Debug.deprecate(e2.factory.updateSpreadAssignment, a), e2.createEnumMember = e2.Debug.deprecate(e2.factory.createEnumMember, a), e2.updateEnumMember = e2.Debug.deprecate(e2.factory.updateEnumMember, a), e2.updateSourceFileNode = e2.Debug.deprecate(e2.factory.updateSourceFile, a), e2.createNotEmittedStatement = e2.Debug.deprecate(e2.factory.createNotEmittedStatement, a), e2.createPartiallyEmittedExpression = e2.Debug.deprecate(e2.factory.createPartiallyEmittedExpression, a), e2.updatePartiallyEmittedExpression = e2.Debug.deprecate(e2.factory.updatePartiallyEmittedExpression, a), e2.createCommaList = e2.Debug.deprecate(e2.factory.createCommaListExpression, a), e2.updateCommaList = e2.Debug.deprecate(e2.factory.updateCommaListExpression, a), e2.createBundle = e2.Debug.deprecate(e2.factory.createBundle, a), e2.updateBundle = e2.Debug.deprecate(e2.factory.updateBundle, a), e2.createImmediatelyInvokedFunctionExpression = e2.Debug.deprecate(e2.factory.createImmediatelyInvokedFunctionExpression, a), e2.createImmediatelyInvokedArrowFunction = e2.Debug.deprecate(e2.factory.createImmediatelyInvokedArrowFunction, a), e2.createVoidZero = e2.Debug.deprecate(e2.factory.createVoidZero, a), e2.createExportDefault = e2.Debug.deprecate(e2.factory.createExportDefault, a), e2.createExternalModuleExport = e2.Debug.deprecate(e2.factory.createExternalModuleExport, a), e2.createNamespaceExport = e2.Debug.deprecate(e2.factory.createNamespaceExport, a), e2.updateNamespaceExport = e2.Debug.deprecate(e2.factory.updateNamespaceExport, a), e2.createToken = e2.Debug.deprecate(function(w) {
              return e2.factory.createToken(w);
            }, a), e2.createIdentifier = e2.Debug.deprecate(function(w) {
              return e2.factory.createIdentifier(w, void 0, void 0);
            }, a), e2.createTempVariable = e2.Debug.deprecate(function(w) {
              return e2.factory.createTempVariable(w, void 0);
            }, a), e2.getGeneratedNameForNode = e2.Debug.deprecate(function(w) {
              return e2.factory.getGeneratedNameForNode(w, void 0);
            }, a), e2.createOptimisticUniqueName = e2.Debug.deprecate(function(w) {
              return e2.factory.createUniqueName(w, 16);
            }, a), e2.createFileLevelUniqueName = e2.Debug.deprecate(function(w) {
              return e2.factory.createUniqueName(w, 48);
            }, a), e2.createIndexSignature = e2.Debug.deprecate(function(w, B, E, Q) {
              return e2.factory.createIndexSignature(w, B, E, Q);
            }, a), e2.createTypePredicateNode = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createTypePredicateNode(void 0, w, B);
            }, a), e2.updateTypePredicateNode = e2.Debug.deprecate(function(w, B, E) {
              return e2.factory.updateTypePredicateNode(w, void 0, B, E);
            }, a), e2.createLiteral = e2.Debug.deprecate(function(w) {
              return typeof w == "number" ? e2.factory.createNumericLiteral(w) : typeof w == "object" && "base10Value" in w ? e2.factory.createBigIntLiteral(w) : typeof w == "boolean" ? w ? e2.factory.createTrue() : e2.factory.createFalse() : typeof w == "string" ? e2.factory.createStringLiteral(w, void 0) : e2.factory.createStringLiteralFromNode(w);
            }, { since: "4.0", warnAfter: "4.1", message: "Use `factory.createStringLiteral`, `factory.createStringLiteralFromNode`, `factory.createNumericLiteral`, `factory.createBigIntLiteral`, `factory.createTrue`, `factory.createFalse`, or the factory supplied by your transformation context instead." }), e2.createMethodSignature = e2.Debug.deprecate(function(w, B, E, Q, le) {
              return e2.factory.createMethodSignature(void 0, Q, le, w, B, E);
            }, a), e2.updateMethodSignature = e2.Debug.deprecate(function(w, B, E, Q, le, N) {
              return e2.factory.updateMethodSignature(w, w.modifiers, le, N, B, E, Q);
            }, a), e2.createTypeOperatorNode = e2.Debug.deprecate(function(w, B) {
              var E;
              return B ? E = w : (B = w, E = 140), e2.factory.createTypeOperatorNode(E, B);
            }, a), e2.createTaggedTemplate = e2.Debug.deprecate(function(w, B, E) {
              var Q;
              return E ? Q = B : E = B, e2.factory.createTaggedTemplateExpression(w, Q, E);
            }, a), e2.updateTaggedTemplate = e2.Debug.deprecate(function(w, B, E, Q) {
              var le;
              return Q ? le = E : Q = E, e2.factory.updateTaggedTemplateExpression(w, B, le, Q);
            }, a), e2.updateBinary = e2.Debug.deprecate(function(w, B, E, Q) {
              return Q === void 0 && (Q = w.operatorToken), typeof Q == "number" && (Q = Q === w.operatorToken.kind ? w.operatorToken : e2.factory.createToken(Q)), e2.factory.updateBinaryExpression(w, B, Q, E);
            }, a), e2.createConditional = e2.Debug.deprecate(function(w, B, E, Q, le) {
              return arguments.length === 5 ? e2.factory.createConditionalExpression(w, B, E, Q, le) : arguments.length === 3 ? e2.factory.createConditionalExpression(w, e2.factory.createToken(57), B, e2.factory.createToken(58), E) : e2.Debug.fail("Argument count mismatch");
            }, a), e2.createYield = e2.Debug.deprecate(function(w, B) {
              var E;
              return B ? E = w : B = w, e2.factory.createYieldExpression(E, B);
            }, a), e2.createClassExpression = e2.Debug.deprecate(function(w, B, E, Q, le) {
              return e2.factory.createClassExpression(void 0, w, B, E, Q, le);
            }, a), e2.updateClassExpression = e2.Debug.deprecate(function(w, B, E, Q, le, N) {
              return e2.factory.updateClassExpression(w, void 0, B, E, Q, le, N);
            }, a), e2.createPropertySignature = e2.Debug.deprecate(function(w, B, E, Q, le) {
              var N = e2.factory.createPropertySignature(w, B, E, Q);
              return N.initializer = le, N;
            }, a), e2.updatePropertySignature = e2.Debug.deprecate(function(w, B, E, Q, le, N) {
              var p = e2.factory.updatePropertySignature(w, B, E, Q, le);
              return w.initializer !== N && (p === w && (p = e2.factory.cloneNode(w)), p.initializer = N), p;
            }, a), e2.createExpressionWithTypeArguments = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createExpressionWithTypeArguments(B, w);
            }, a), e2.updateExpressionWithTypeArguments = e2.Debug.deprecate(function(w, B, E) {
              return e2.factory.updateExpressionWithTypeArguments(w, E, B);
            }, a), e2.createArrowFunction = e2.Debug.deprecate(function(w, B, E, Q, le, N) {
              return arguments.length === 6 ? e2.factory.createArrowFunction(w, B, E, Q, le, N) : arguments.length === 5 ? e2.factory.createArrowFunction(w, B, E, Q, void 0, le) : e2.Debug.fail("Argument count mismatch");
            }, a), e2.updateArrowFunction = e2.Debug.deprecate(function(w, B, E, Q, le, N, p) {
              return arguments.length === 7 ? e2.factory.updateArrowFunction(w, B, E, Q, le, N, p) : arguments.length === 6 ? e2.factory.updateArrowFunction(w, B, E, Q, le, w.equalsGreaterThanToken, N) : e2.Debug.fail("Argument count mismatch");
            }, a), e2.createVariableDeclaration = e2.Debug.deprecate(function(w, B, E, Q) {
              return arguments.length === 4 ? e2.factory.createVariableDeclaration(w, B, E, Q) : arguments.length >= 1 && arguments.length <= 3 ? e2.factory.createVariableDeclaration(w, void 0, B, E) : e2.Debug.fail("Argument count mismatch");
            }, a), e2.updateVariableDeclaration = e2.Debug.deprecate(function(w, B, E, Q, le) {
              return arguments.length === 5 ? e2.factory.updateVariableDeclaration(w, B, E, Q, le) : arguments.length === 4 ? e2.factory.updateVariableDeclaration(w, B, w.exclamationToken, E, Q) : e2.Debug.fail("Argument count mismatch");
            }, a), e2.createImportClause = e2.Debug.deprecate(function(w, B, E) {
              return E === void 0 && (E = false), e2.factory.createImportClause(E, w, B);
            }, a), e2.updateImportClause = e2.Debug.deprecate(function(w, B, E, Q) {
              return e2.factory.updateImportClause(w, Q, B, E);
            }, a), e2.createExportDeclaration = e2.Debug.deprecate(function(w, B, E, Q, le) {
              return le === void 0 && (le = false), e2.factory.createExportDeclaration(w, B, le, E, Q);
            }, a), e2.updateExportDeclaration = e2.Debug.deprecate(function(w, B, E, Q, le, N) {
              return e2.factory.updateExportDeclaration(w, B, E, N, Q, le, w.assertClause);
            }, a), e2.createJSDocParamTag = e2.Debug.deprecate(function(w, B, E, Q) {
              return e2.factory.createJSDocParameterTag(void 0, w, B, E, false, Q ? e2.factory.createNodeArray([e2.factory.createJSDocText(Q)]) : void 0);
            }, a), e2.createComma = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createComma(w, B);
            }, a), e2.createLessThan = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createLessThan(w, B);
            }, a), e2.createAssignment = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createAssignment(w, B);
            }, a), e2.createStrictEquality = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createStrictEquality(w, B);
            }, a), e2.createStrictInequality = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createStrictInequality(w, B);
            }, a), e2.createAdd = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createAdd(w, B);
            }, a), e2.createSubtract = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createSubtract(w, B);
            }, a), e2.createLogicalAnd = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createLogicalAnd(w, B);
            }, a), e2.createLogicalOr = e2.Debug.deprecate(function(w, B) {
              return e2.factory.createLogicalOr(w, B);
            }, a), e2.createPostfixIncrement = e2.Debug.deprecate(function(w) {
              return e2.factory.createPostfixIncrement(w);
            }, a), e2.createLogicalNot = e2.Debug.deprecate(function(w) {
              return e2.factory.createLogicalNot(w);
            }, a), e2.createNode = e2.Debug.deprecate(function(w, B, E) {
              return B === void 0 && (B = 0), E === void 0 && (E = 0), e2.setTextRangePosEnd(w === 305 ? e2.parseBaseNodeFactory.createBaseSourceFileNode(w) : w === 79 ? e2.parseBaseNodeFactory.createBaseIdentifierNode(w) : w === 80 ? e2.parseBaseNodeFactory.createBasePrivateIdentifierNode(w) : e2.isNodeKind(w) ? e2.parseBaseNodeFactory.createBaseNode(w) : e2.parseBaseNodeFactory.createBaseTokenNode(w), B, E);
            }, { since: "4.0", warnAfter: "4.1", message: "Use an appropriate `factory` method instead." }), e2.getMutableClone = e2.Debug.deprecate(function(w) {
              var B = e2.factory.cloneNode(w);
              return e2.setTextRange(B, w), e2.setParent(B, w.parent), B;
            }, { since: "4.0", warnAfter: "4.1", message: "Use an appropriate `factory.update...` method instead, use `setCommentRange` or `setSourceMapRange`, and avoid setting `parent`." }), e2.isTypeAssertion = e2.Debug.deprecate(function(w) {
              return w.kind === 211;
            }, { since: "4.0", warnAfter: "4.1", message: "Use `isTypeAssertionExpression` instead." }), e2.isIdentifierOrPrivateIdentifier = e2.Debug.deprecate(function(w) {
              return e2.isMemberName(w);
            }, { since: "4.2", warnAfter: "4.3", message: "Use `isMemberName` instead." });
          })(ke || (ke = {}));
        } }), $4 = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/generated/ast-spec.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.AST_TOKEN_TYPES = M.AST_NODE_TYPES = void 0;
          var re;
          (function(Ke) {
            Ke.ArrayExpression = "ArrayExpression", Ke.ArrayPattern = "ArrayPattern", Ke.ArrowFunctionExpression = "ArrowFunctionExpression", Ke.AssignmentExpression = "AssignmentExpression", Ke.AssignmentPattern = "AssignmentPattern", Ke.AwaitExpression = "AwaitExpression", Ke.BinaryExpression = "BinaryExpression", Ke.BlockStatement = "BlockStatement", Ke.BreakStatement = "BreakStatement", Ke.CallExpression = "CallExpression", Ke.CatchClause = "CatchClause", Ke.ChainExpression = "ChainExpression", Ke.ClassBody = "ClassBody", Ke.ClassDeclaration = "ClassDeclaration", Ke.ClassExpression = "ClassExpression", Ke.ConditionalExpression = "ConditionalExpression", Ke.ContinueStatement = "ContinueStatement", Ke.DebuggerStatement = "DebuggerStatement", Ke.Decorator = "Decorator", Ke.DoWhileStatement = "DoWhileStatement", Ke.EmptyStatement = "EmptyStatement", Ke.ExportAllDeclaration = "ExportAllDeclaration", Ke.ExportDefaultDeclaration = "ExportDefaultDeclaration", Ke.ExportNamedDeclaration = "ExportNamedDeclaration", Ke.ExportSpecifier = "ExportSpecifier", Ke.ExpressionStatement = "ExpressionStatement", Ke.ForInStatement = "ForInStatement", Ke.ForOfStatement = "ForOfStatement", Ke.ForStatement = "ForStatement", Ke.FunctionDeclaration = "FunctionDeclaration", Ke.FunctionExpression = "FunctionExpression", Ke.Identifier = "Identifier", Ke.IfStatement = "IfStatement", Ke.ImportAttribute = "ImportAttribute", Ke.ImportDeclaration = "ImportDeclaration", Ke.ImportDefaultSpecifier = "ImportDefaultSpecifier", Ke.ImportExpression = "ImportExpression", Ke.ImportNamespaceSpecifier = "ImportNamespaceSpecifier", Ke.ImportSpecifier = "ImportSpecifier", Ke.JSXAttribute = "JSXAttribute", Ke.JSXClosingElement = "JSXClosingElement", Ke.JSXClosingFragment = "JSXClosingFragment", Ke.JSXElement = "JSXElement", Ke.JSXEmptyExpression = "JSXEmptyExpression", Ke.JSXExpressionContainer = "JSXExpressionContainer", Ke.JSXFragment = "JSXFragment", Ke.JSXIdentifier = "JSXIdentifier", Ke.JSXMemberExpression = "JSXMemberExpression", Ke.JSXNamespacedName = "JSXNamespacedName", Ke.JSXOpeningElement = "JSXOpeningElement", Ke.JSXOpeningFragment = "JSXOpeningFragment", Ke.JSXSpreadAttribute = "JSXSpreadAttribute", Ke.JSXSpreadChild = "JSXSpreadChild", Ke.JSXText = "JSXText", Ke.LabeledStatement = "LabeledStatement", Ke.Literal = "Literal", Ke.LogicalExpression = "LogicalExpression", Ke.MemberExpression = "MemberExpression", Ke.MetaProperty = "MetaProperty", Ke.MethodDefinition = "MethodDefinition", Ke.NewExpression = "NewExpression", Ke.ObjectExpression = "ObjectExpression", Ke.ObjectPattern = "ObjectPattern", Ke.PrivateIdentifier = "PrivateIdentifier", Ke.Program = "Program", Ke.Property = "Property", Ke.PropertyDefinition = "PropertyDefinition", Ke.RestElement = "RestElement", Ke.ReturnStatement = "ReturnStatement", Ke.SequenceExpression = "SequenceExpression", Ke.SpreadElement = "SpreadElement", Ke.StaticBlock = "StaticBlock", Ke.Super = "Super", Ke.SwitchCase = "SwitchCase", Ke.SwitchStatement = "SwitchStatement", Ke.TaggedTemplateExpression = "TaggedTemplateExpression", Ke.TemplateElement = "TemplateElement", Ke.TemplateLiteral = "TemplateLiteral", Ke.ThisExpression = "ThisExpression", Ke.ThrowStatement = "ThrowStatement", Ke.TryStatement = "TryStatement", Ke.UnaryExpression = "UnaryExpression", Ke.UpdateExpression = "UpdateExpression", Ke.VariableDeclaration = "VariableDeclaration", Ke.VariableDeclarator = "VariableDeclarator", Ke.WhileStatement = "WhileStatement", Ke.WithStatement = "WithStatement", Ke.YieldExpression = "YieldExpression", Ke.TSAbstractKeyword = "TSAbstractKeyword", Ke.TSAbstractMethodDefinition = "TSAbstractMethodDefinition", Ke.TSAbstractPropertyDefinition = "TSAbstractPropertyDefinition", Ke.TSAnyKeyword = "TSAnyKeyword", Ke.TSArrayType = "TSArrayType", Ke.TSAsExpression = "TSAsExpression", Ke.TSAsyncKeyword = "TSAsyncKeyword", Ke.TSBigIntKeyword = "TSBigIntKeyword", Ke.TSBooleanKeyword = "TSBooleanKeyword", Ke.TSCallSignatureDeclaration = "TSCallSignatureDeclaration", Ke.TSClassImplements = "TSClassImplements", Ke.TSConditionalType = "TSConditionalType", Ke.TSConstructorType = "TSConstructorType", Ke.TSConstructSignatureDeclaration = "TSConstructSignatureDeclaration", Ke.TSDeclareFunction = "TSDeclareFunction", Ke.TSDeclareKeyword = "TSDeclareKeyword", Ke.TSEmptyBodyFunctionExpression = "TSEmptyBodyFunctionExpression", Ke.TSEnumDeclaration = "TSEnumDeclaration", Ke.TSEnumMember = "TSEnumMember", Ke.TSExportAssignment = "TSExportAssignment", Ke.TSExportKeyword = "TSExportKeyword", Ke.TSExternalModuleReference = "TSExternalModuleReference", Ke.TSFunctionType = "TSFunctionType", Ke.TSInstantiationExpression = "TSInstantiationExpression", Ke.TSImportEqualsDeclaration = "TSImportEqualsDeclaration", Ke.TSImportType = "TSImportType", Ke.TSIndexedAccessType = "TSIndexedAccessType", Ke.TSIndexSignature = "TSIndexSignature", Ke.TSInferType = "TSInferType", Ke.TSInterfaceBody = "TSInterfaceBody", Ke.TSInterfaceDeclaration = "TSInterfaceDeclaration", Ke.TSInterfaceHeritage = "TSInterfaceHeritage", Ke.TSIntersectionType = "TSIntersectionType", Ke.TSIntrinsicKeyword = "TSIntrinsicKeyword", Ke.TSLiteralType = "TSLiteralType", Ke.TSMappedType = "TSMappedType", Ke.TSMethodSignature = "TSMethodSignature", Ke.TSModuleBlock = "TSModuleBlock", Ke.TSModuleDeclaration = "TSModuleDeclaration", Ke.TSNamedTupleMember = "TSNamedTupleMember", Ke.TSNamespaceExportDeclaration = "TSNamespaceExportDeclaration", Ke.TSNeverKeyword = "TSNeverKeyword", Ke.TSNonNullExpression = "TSNonNullExpression", Ke.TSNullKeyword = "TSNullKeyword", Ke.TSNumberKeyword = "TSNumberKeyword", Ke.TSObjectKeyword = "TSObjectKeyword", Ke.TSOptionalType = "TSOptionalType", Ke.TSParameterProperty = "TSParameterProperty", Ke.TSPrivateKeyword = "TSPrivateKeyword", Ke.TSPropertySignature = "TSPropertySignature", Ke.TSProtectedKeyword = "TSProtectedKeyword", Ke.TSPublicKeyword = "TSPublicKeyword", Ke.TSQualifiedName = "TSQualifiedName", Ke.TSReadonlyKeyword = "TSReadonlyKeyword", Ke.TSRestType = "TSRestType", Ke.TSStaticKeyword = "TSStaticKeyword", Ke.TSStringKeyword = "TSStringKeyword", Ke.TSSymbolKeyword = "TSSymbolKeyword", Ke.TSTemplateLiteralType = "TSTemplateLiteralType", Ke.TSThisType = "TSThisType", Ke.TSTupleType = "TSTupleType", Ke.TSTypeAliasDeclaration = "TSTypeAliasDeclaration", Ke.TSTypeAnnotation = "TSTypeAnnotation", Ke.TSTypeAssertion = "TSTypeAssertion", Ke.TSTypeLiteral = "TSTypeLiteral", Ke.TSTypeOperator = "TSTypeOperator", Ke.TSTypeParameter = "TSTypeParameter", Ke.TSTypeParameterDeclaration = "TSTypeParameterDeclaration", Ke.TSTypeParameterInstantiation = "TSTypeParameterInstantiation", Ke.TSTypePredicate = "TSTypePredicate", Ke.TSTypeQuery = "TSTypeQuery", Ke.TSTypeReference = "TSTypeReference", Ke.TSUndefinedKeyword = "TSUndefinedKeyword", Ke.TSUnionType = "TSUnionType", Ke.TSUnknownKeyword = "TSUnknownKeyword", Ke.TSVoidKeyword = "TSVoidKeyword";
          })(re = M.AST_NODE_TYPES || (M.AST_NODE_TYPES = {}));
          var Ve;
          (function(Ke) {
            Ke.Boolean = "Boolean", Ke.Identifier = "Identifier", Ke.JSXIdentifier = "JSXIdentifier", Ke.JSXText = "JSXText", Ke.Keyword = "Keyword", Ke.Null = "Null", Ke.Numeric = "Numeric", Ke.Punctuator = "Punctuator", Ke.RegularExpression = "RegularExpression", Ke.String = "String", Ke.Template = "Template", Ke.Block = "Block", Ke.Line = "Line";
          })(Ve = M.AST_TOKEN_TYPES || (M.AST_TOKEN_TYPES = {}));
        } }), DU = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/lib.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
        } }), bU = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/parser-options.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
        } }), SU = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/ts-estree.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr);
            var ar = Object.getOwnPropertyDescriptor(kr, pr);
            (!ar || ("get" in ar ? !kr.__esModule : ar.writable || ar.configurable)) && (ar = { enumerable: true, get: function() {
              return kr[pr];
            } }), Object.defineProperty(oi, Lr, ar);
          } : function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr), oi[Lr] = kr[pr];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(oi, kr) {
            Object.defineProperty(oi, "default", { enumerable: true, value: kr });
          } : function(oi, kr) {
            oi.default = kr;
          }), Ke = M && M.__importStar || function(oi) {
            if (oi && oi.__esModule)
              return oi;
            var kr = {};
            if (oi != null)
              for (var pr in oi)
                pr !== "default" && Object.prototype.hasOwnProperty.call(oi, pr) && re(kr, oi, pr);
            return Ve(kr, oi), kr;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.TSESTree = void 0, M.TSESTree = Ke($4());
        } }), Z4 = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/types/dist/index.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr);
            var ar = Object.getOwnPropertyDescriptor(kr, pr);
            (!ar || ("get" in ar ? !kr.__esModule : ar.writable || ar.configurable)) && (ar = { enumerable: true, get: function() {
              return kr[pr];
            } }), Object.defineProperty(oi, Lr, ar);
          } : function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr), oi[Lr] = kr[pr];
          }), Ve = M && M.__exportStar || function(oi, kr) {
            for (var pr in oi)
              pr !== "default" && !Object.prototype.hasOwnProperty.call(kr, pr) && re(kr, oi, pr);
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.AST_TOKEN_TYPES = M.AST_NODE_TYPES = void 0;
          var Ke = $4();
          Object.defineProperty(M, "AST_NODE_TYPES", { enumerable: true, get: function() {
            return Ke.AST_NODE_TYPES;
          } }), Object.defineProperty(M, "AST_TOKEN_TYPES", { enumerable: true, get: function() {
            return Ke.AST_TOKEN_TYPES;
          } }), Ve(DU(), M), Ve(bU(), M), Ve(SU(), M);
        } }), TU = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/ts-estree/ts-nodes.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
        } }), xU = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/ts-estree/estree-to-ts-node-types.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = Z4();
        } }), k1 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/ts-estree/index.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr);
            var ar = Object.getOwnPropertyDescriptor(kr, pr);
            (!ar || ("get" in ar ? !kr.__esModule : ar.writable || ar.configurable)) && (ar = { enumerable: true, get: function() {
              return kr[pr];
            } }), Object.defineProperty(oi, Lr, ar);
          } : function(oi, kr, pr, Lr) {
            Lr === void 0 && (Lr = pr), oi[Lr] = kr[pr];
          }), Ve = M && M.__exportStar || function(oi, kr) {
            for (var pr in oi)
              pr !== "default" && !Object.prototype.hasOwnProperty.call(kr, pr) && re(kr, oi, pr);
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.TSESTree = M.AST_TOKEN_TYPES = M.AST_NODE_TYPES = void 0;
          var Ke = Z4();
          Object.defineProperty(M, "AST_NODE_TYPES", { enumerable: true, get: function() {
            return Ke.AST_NODE_TYPES;
          } }), Object.defineProperty(M, "AST_TOKEN_TYPES", { enumerable: true, get: function() {
            return Ke.AST_TOKEN_TYPES;
          } }), Object.defineProperty(M, "TSESTree", { enumerable: true, get: function() {
            return Ke.TSESTree;
          } }), Ve(TU(), M), Ve(xU(), M);
        } }), EU = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/jsx/xhtml-entities.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.xhtmlEntities = void 0, M.xhtmlEntities = { quot: '"', amp: "&", apos: "'", lt: "<", gt: ">", nbsp: "\xA0", iexcl: "\xA1", cent: "\xA2", pound: "\xA3", curren: "\xA4", yen: "\xA5", brvbar: "\xA6", sect: "\xA7", uml: "\xA8", copy: "\xA9", ordf: "\xAA", laquo: "\xAB", not: "\xAC", shy: "\xAD", reg: "\xAE", macr: "\xAF", deg: "\xB0", plusmn: "\xB1", sup2: "\xB2", sup3: "\xB3", acute: "\xB4", micro: "\xB5", para: "\xB6", middot: "\xB7", cedil: "\xB8", sup1: "\xB9", ordm: "\xBA", raquo: "\xBB", frac14: "\xBC", frac12: "\xBD", frac34: "\xBE", iquest: "\xBF", Agrave: "\xC0", Aacute: "\xC1", Acirc: "\xC2", Atilde: "\xC3", Auml: "\xC4", Aring: "\xC5", AElig: "\xC6", Ccedil: "\xC7", Egrave: "\xC8", Eacute: "\xC9", Ecirc: "\xCA", Euml: "\xCB", Igrave: "\xCC", Iacute: "\xCD", Icirc: "\xCE", Iuml: "\xCF", ETH: "\xD0", Ntilde: "\xD1", Ograve: "\xD2", Oacute: "\xD3", Ocirc: "\xD4", Otilde: "\xD5", Ouml: "\xD6", times: "\xD7", Oslash: "\xD8", Ugrave: "\xD9", Uacute: "\xDA", Ucirc: "\xDB", Uuml: "\xDC", Yacute: "\xDD", THORN: "\xDE", szlig: "\xDF", agrave: "\xE0", aacute: "\xE1", acirc: "\xE2", atilde: "\xE3", auml: "\xE4", aring: "\xE5", aelig: "\xE6", ccedil: "\xE7", egrave: "\xE8", eacute: "\xE9", ecirc: "\xEA", euml: "\xEB", igrave: "\xEC", iacute: "\xED", icirc: "\xEE", iuml: "\xEF", eth: "\xF0", ntilde: "\xF1", ograve: "\xF2", oacute: "\xF3", ocirc: "\xF4", otilde: "\xF5", ouml: "\xF6", divide: "\xF7", oslash: "\xF8", ugrave: "\xF9", uacute: "\xFA", ucirc: "\xFB", uuml: "\xFC", yacute: "\xFD", thorn: "\xFE", yuml: "\xFF", OElig: "\u0152", oelig: "\u0153", Scaron: "\u0160", scaron: "\u0161", Yuml: "\u0178", fnof: "\u0192", circ: "\u02C6", tilde: "\u02DC", Alpha: "\u0391", Beta: "\u0392", Gamma: "\u0393", Delta: "\u0394", Epsilon: "\u0395", Zeta: "\u0396", Eta: "\u0397", Theta: "\u0398", Iota: "\u0399", Kappa: "\u039A", Lambda: "\u039B", Mu: "\u039C", Nu: "\u039D", Xi: "\u039E", Omicron: "\u039F", Pi: "\u03A0", Rho: "\u03A1", Sigma: "\u03A3", Tau: "\u03A4", Upsilon: "\u03A5", Phi: "\u03A6", Chi: "\u03A7", Psi: "\u03A8", Omega: "\u03A9", alpha: "\u03B1", beta: "\u03B2", gamma: "\u03B3", delta: "\u03B4", epsilon: "\u03B5", zeta: "\u03B6", eta: "\u03B7", theta: "\u03B8", iota: "\u03B9", kappa: "\u03BA", lambda: "\u03BB", mu: "\u03BC", nu: "\u03BD", xi: "\u03BE", omicron: "\u03BF", pi: "\u03C0", rho: "\u03C1", sigmaf: "\u03C2", sigma: "\u03C3", tau: "\u03C4", upsilon: "\u03C5", phi: "\u03C6", chi: "\u03C7", psi: "\u03C8", omega: "\u03C9", thetasym: "\u03D1", upsih: "\u03D2", piv: "\u03D6", ensp: "\u2002", emsp: "\u2003", thinsp: "\u2009", zwnj: "\u200C", zwj: "\u200D", lrm: "\u200E", rlm: "\u200F", ndash: "\u2013", mdash: "\u2014", lsquo: "\u2018", rsquo: "\u2019", sbquo: "\u201A", ldquo: "\u201C", rdquo: "\u201D", bdquo: "\u201E", dagger: "\u2020", Dagger: "\u2021", bull: "\u2022", hellip: "\u2026", permil: "\u2030", prime: "\u2032", Prime: "\u2033", lsaquo: "\u2039", rsaquo: "\u203A", oline: "\u203E", frasl: "\u2044", euro: "\u20AC", image: "\u2111", weierp: "\u2118", real: "\u211C", trade: "\u2122", alefsym: "\u2135", larr: "\u2190", uarr: "\u2191", rarr: "\u2192", darr: "\u2193", harr: "\u2194", crarr: "\u21B5", lArr: "\u21D0", uArr: "\u21D1", rArr: "\u21D2", dArr: "\u21D3", hArr: "\u21D4", forall: "\u2200", part: "\u2202", exist: "\u2203", empty: "\u2205", nabla: "\u2207", isin: "\u2208", notin: "\u2209", ni: "\u220B", prod: "\u220F", sum: "\u2211", minus: "\u2212", lowast: "\u2217", radic: "\u221A", prop: "\u221D", infin: "\u221E", ang: "\u2220", and: "\u2227", or: "\u2228", cap: "\u2229", cup: "\u222A", int: "\u222B", there4: "\u2234", sim: "\u223C", cong: "\u2245", asymp: "\u2248", ne: "\u2260", equiv: "\u2261", le: "\u2264", ge: "\u2265", sub: "\u2282", sup: "\u2283", nsub: "\u2284", sube: "\u2286", supe: "\u2287", oplus: "\u2295", otimes: "\u2297", perp: "\u22A5", sdot: "\u22C5", lceil: "\u2308", rceil: "\u2309", lfloor: "\u230A", rfloor: "\u230B", lang: "\u2329", rang: "\u232A", loz: "\u25CA", spades: "\u2660", clubs: "\u2663", hearts: "\u2665", diams: "\u2666" };
        } }), A1 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/node-utils.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(V, L, P, k) {
            k === void 0 && (k = P);
            var Y = Object.getOwnPropertyDescriptor(L, P);
            (!Y || ("get" in Y ? !L.__esModule : Y.writable || Y.configurable)) && (Y = { enumerable: true, get: function() {
              return L[P];
            } }), Object.defineProperty(V, k, Y);
          } : function(V, L, P, k) {
            k === void 0 && (k = P), V[k] = L[P];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(V, L) {
            Object.defineProperty(V, "default", { enumerable: true, value: L });
          } : function(V, L) {
            V.default = L;
          }), Ke = M && M.__importStar || function(V) {
            if (V && V.__esModule)
              return V;
            var L = {};
            if (V != null)
              for (var P in V)
                P !== "default" && Object.prototype.hasOwnProperty.call(V, P) && re(L, V, P);
            return Ve(L, V), L;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.firstDefined = M.nodeHasTokens = M.createError = M.TSError = M.convertTokens = M.convertToken = M.getTokenType = M.isChildUnwrappableOptionalChain = M.isChainExpression = M.isOptional = M.isComputedProperty = M.unescapeStringLiteralText = M.hasJSXAncestor = M.findFirstMatchingAncestor = M.findNextToken = M.getTSNodeAccessibility = M.getDeclarationKind = M.isJSXToken = M.isToken = M.getRange = M.canContainDirective = M.getLocFor = M.getLineAndCharacterFor = M.getBinaryExpressionType = M.isJSDocComment = M.isComment = M.isComma = M.getLastModifier = M.hasModifier = M.isESTreeClassMember = M.getTextForTokenKind = M.isLogicalOperator = M.isAssignmentOperator = void 0;
          var oi = Ke(_u()), kr = k1(), pr = EU(), Lr = oi.SyntaxKind, ar = [Lr.BarBarToken, Lr.AmpersandAmpersandToken, Lr.QuestionQuestionToken];
          function ke(V) {
            return V.kind >= Lr.FirstAssignment && V.kind <= Lr.LastAssignment;
          }
          M.isAssignmentOperator = ke;
          function e2(V) {
            return ar.includes(V.kind);
          }
          M.isLogicalOperator = e2;
          function a(V) {
            return oi.tokenToString(V);
          }
          M.getTextForTokenKind = a;
          function C(V) {
            return V.kind !== Lr.SemicolonClassElement;
          }
          M.isESTreeClassMember = C;
          function w(V, L) {
            return !!L.modifiers && !!L.modifiers.length && L.modifiers.some((P) => P.kind === V);
          }
          M.hasModifier = w;
          function B(V) {
            return !!V.modifiers && !!V.modifiers.length && V.modifiers[V.modifiers.length - 1] || null;
          }
          M.getLastModifier = B;
          function E(V) {
            return V.kind === Lr.CommaToken;
          }
          M.isComma = E;
          function Q(V) {
            return V.kind === Lr.SingleLineCommentTrivia || V.kind === Lr.MultiLineCommentTrivia;
          }
          M.isComment = Q;
          function le(V) {
            return V.kind === Lr.JSDocComment;
          }
          M.isJSDocComment = le;
          function N(V) {
            return ke(V) ? kr.AST_NODE_TYPES.AssignmentExpression : e2(V) ? kr.AST_NODE_TYPES.LogicalExpression : kr.AST_NODE_TYPES.BinaryExpression;
          }
          M.getBinaryExpressionType = N;
          function p(V, L) {
            let P = L.getLineAndCharacterOfPosition(V);
            return { line: P.line + 1, column: P.character };
          }
          M.getLineAndCharacterFor = p;
          function m2(V, L, P) {
            return { start: p(V, P), end: p(L, P) };
          }
          M.getLocFor = m2;
          function G(V) {
            if (V.kind === oi.SyntaxKind.Block)
              switch (V.parent.kind) {
                case oi.SyntaxKind.Constructor:
                case oi.SyntaxKind.GetAccessor:
                case oi.SyntaxKind.SetAccessor:
                case oi.SyntaxKind.ArrowFunction:
                case oi.SyntaxKind.FunctionExpression:
                case oi.SyntaxKind.FunctionDeclaration:
                case oi.SyntaxKind.MethodDeclaration:
                  return true;
                default:
                  return false;
              }
            return true;
          }
          M.canContainDirective = G;
          function oe(V, L) {
            return [V.getStart(L), V.getEnd()];
          }
          M.getRange = oe;
          function f4(V) {
            return V.kind >= Lr.FirstToken && V.kind <= Lr.LastToken;
          }
          M.isToken = f4;
          function T(V) {
            return V.kind >= Lr.JsxElement && V.kind <= Lr.JsxAttribute;
          }
          M.isJSXToken = T;
          function K(V) {
            return V.flags & oi.NodeFlags.Let ? "let" : V.flags & oi.NodeFlags.Const ? "const" : "var";
          }
          M.getDeclarationKind = K;
          function b(V) {
            let L = V.modifiers;
            if (!L)
              return null;
            for (let P of L)
              switch (P.kind) {
                case Lr.PublicKeyword:
                  return "public";
                case Lr.ProtectedKeyword:
                  return "protected";
                case Lr.PrivateKeyword:
                  return "private";
                default:
                  break;
              }
            return null;
          }
          M.getTSNodeAccessibility = b;
          function se(V, L, P) {
            return k(L);
            function k(Y) {
              return oi.isToken(Y) && Y.pos === V.end ? Y : y(Y.getChildren(P), (U) => (U.pos <= V.pos && U.end > V.end || U.pos === V.end) && A2(U, P) ? k(U) : void 0);
            }
          }
          M.findNextToken = se;
          function J(V, L) {
            for (; V; ) {
              if (L(V))
                return V;
              V = V.parent;
            }
          }
          M.findFirstMatchingAncestor = J;
          function ie(V) {
            return !!J(V, T);
          }
          M.hasJSXAncestor = ie;
          function R(V) {
            return V.replace(/&(?:#\d+|#x[\da-fA-F]+|[0-9a-zA-Z]+);/g, (L) => {
              let P = L.slice(1, -1);
              if (P[0] === "#") {
                let k = P[1] === "x" ? parseInt(P.slice(2), 16) : parseInt(P.slice(1), 10);
                return k > 1114111 ? L : String.fromCodePoint(k);
              }
              return pr.xhtmlEntities[P] || L;
            });
          }
          M.unescapeStringLiteralText = R;
          function q(V) {
            return V.kind === Lr.ComputedPropertyName;
          }
          M.isComputedProperty = q;
          function O(V) {
            return V.questionToken ? V.questionToken.kind === Lr.QuestionToken : false;
          }
          M.isOptional = O;
          function ve(V) {
            return V.type === kr.AST_NODE_TYPES.ChainExpression;
          }
          M.isChainExpression = ve;
          function ee(V, L) {
            return ve(L) && V.expression.kind !== oi.SyntaxKind.ParenthesizedExpression;
          }
          M.isChildUnwrappableOptionalChain = ee;
          function he(V) {
            if ("originalKeywordKind" in V && V.originalKeywordKind)
              return V.originalKeywordKind === Lr.NullKeyword ? kr.AST_TOKEN_TYPES.Null : V.originalKeywordKind >= Lr.FirstFutureReservedWord && V.originalKeywordKind <= Lr.LastKeyword ? kr.AST_TOKEN_TYPES.Identifier : kr.AST_TOKEN_TYPES.Keyword;
            if (V.kind >= Lr.FirstKeyword && V.kind <= Lr.LastFutureReservedWord)
              return V.kind === Lr.FalseKeyword || V.kind === Lr.TrueKeyword ? kr.AST_TOKEN_TYPES.Boolean : kr.AST_TOKEN_TYPES.Keyword;
            if (V.kind >= Lr.FirstPunctuation && V.kind <= Lr.LastPunctuation)
              return kr.AST_TOKEN_TYPES.Punctuator;
            if (V.kind >= Lr.NoSubstitutionTemplateLiteral && V.kind <= Lr.TemplateTail)
              return kr.AST_TOKEN_TYPES.Template;
            switch (V.kind) {
              case Lr.NumericLiteral:
                return kr.AST_TOKEN_TYPES.Numeric;
              case Lr.JsxText:
                return kr.AST_TOKEN_TYPES.JSXText;
              case Lr.StringLiteral:
                return V.parent && (V.parent.kind === Lr.JsxAttribute || V.parent.kind === Lr.JsxElement) ? kr.AST_TOKEN_TYPES.JSXText : kr.AST_TOKEN_TYPES.String;
              case Lr.RegularExpressionLiteral:
                return kr.AST_TOKEN_TYPES.RegularExpression;
              case Lr.Identifier:
              case Lr.ConstructorKeyword:
              case Lr.GetKeyword:
              case Lr.SetKeyword:
              default:
            }
            return V.parent && V.kind === Lr.Identifier && (T(V.parent) || V.parent.kind === Lr.PropertyAccessExpression && ie(V)) ? kr.AST_TOKEN_TYPES.JSXIdentifier : kr.AST_TOKEN_TYPES.Identifier;
          }
          M.getTokenType = he;
          function F2(V, L) {
            let P = V.kind === Lr.JsxText ? V.getFullStart() : V.getStart(L), k = V.getEnd(), Y = L.text.slice(P, k), U = he(V);
            return U === kr.AST_TOKEN_TYPES.RegularExpression ? { type: U, value: Y, range: [P, k], loc: m2(P, k, L), regex: { pattern: Y.slice(1, Y.lastIndexOf("/")), flags: Y.slice(Y.lastIndexOf("/") + 1) } } : { type: U, value: Y, range: [P, k], loc: m2(P, k, L) };
          }
          M.convertToken = F2;
          function x2(V) {
            let L = [];
            function P(k) {
              if (!(Q(k) || le(k)))
                if (f4(k) && k.kind !== Lr.EndOfFileToken) {
                  let Y = F2(k, V);
                  Y && L.push(Y);
                } else
                  k.getChildren(V).forEach(P);
            }
            return P(V), L;
          }
          M.convertTokens = x2;
          var X = class extends Error {
            constructor(V, L, P, k, Y) {
              super(V), this.fileName = L, this.index = P, this.lineNumber = k, this.column = Y, Object.defineProperty(this, "name", { value: new.target.name, enumerable: false, configurable: true });
            }
          };
          M.TSError = X;
          function $(V, L, P) {
            let k = V.getLineAndCharacterOfPosition(L);
            return new X(P, V.fileName, L, k.line + 1, k.character);
          }
          M.createError = $;
          function A2(V, L) {
            return V.kind === Lr.EndOfFileToken ? !!V.jsDoc : V.getWidth(L) !== 0;
          }
          M.nodeHasTokens = A2;
          function y(V, L) {
            if (V !== void 0)
              for (let P = 0; P < V.length; P++) {
                let k = L(V[P], P);
                if (k !== void 0)
                  return k;
              }
          }
          M.firstDefined = y;
        } }), CU = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/version-check.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(ar, ke, e2, a) {
            a === void 0 && (a = e2);
            var C = Object.getOwnPropertyDescriptor(ke, e2);
            (!C || ("get" in C ? !ke.__esModule : C.writable || C.configurable)) && (C = { enumerable: true, get: function() {
              return ke[e2];
            } }), Object.defineProperty(ar, a, C);
          } : function(ar, ke, e2, a) {
            a === void 0 && (a = e2), ar[a] = ke[e2];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(ar, ke) {
            Object.defineProperty(ar, "default", { enumerable: true, value: ke });
          } : function(ar, ke) {
            ar.default = ke;
          }), Ke = M && M.__importStar || function(ar) {
            if (ar && ar.__esModule)
              return ar;
            var ke = {};
            if (ar != null)
              for (var e2 in ar)
                e2 !== "default" && Object.prototype.hasOwnProperty.call(ar, e2) && re(ke, ar, e2);
            return Ve(ke, ar), ke;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.typescriptVersionIsAtLeast = void 0;
          var oi = Ke(QT()), kr = Ke(_u()), pr = ["3.7", "3.8", "3.9", "4.0"], Lr = {};
          M.typescriptVersionIsAtLeast = Lr;
          for (let ar of pr)
            Lr[ar] = true;
        } }), e3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/convert.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(a, C, w, B) {
            B === void 0 && (B = w);
            var E = Object.getOwnPropertyDescriptor(C, w);
            (!E || ("get" in E ? !C.__esModule : E.writable || E.configurable)) && (E = { enumerable: true, get: function() {
              return C[w];
            } }), Object.defineProperty(a, B, E);
          } : function(a, C, w, B) {
            B === void 0 && (B = w), a[B] = C[w];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(a, C) {
            Object.defineProperty(a, "default", { enumerable: true, value: C });
          } : function(a, C) {
            a.default = C;
          }), Ke = M && M.__importStar || function(a) {
            if (a && a.__esModule)
              return a;
            var C = {};
            if (a != null)
              for (var w in a)
                w !== "default" && Object.prototype.hasOwnProperty.call(a, w) && re(C, a, w);
            return Ve(C, a), C;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.Converter = M.convertError = void 0;
          var oi = Ke(_u()), kr = A1(), pr = k1(), Lr = CU(), ar = oi.SyntaxKind;
          function ke(a) {
            return (0, kr.createError)(a.file, a.start, "message" in a && a.message || a.messageText);
          }
          M.convertError = ke;
          var e2 = class {
            constructor(a, C) {
              this.esTreeNodeToTSNodeMap = /* @__PURE__ */ new WeakMap(), this.tsNodeToESTreeNodeMap = /* @__PURE__ */ new WeakMap(), this.allowPattern = false, this.inTypeMode = false, this.ast = a, this.options = Object.assign({}, C);
            }
            getASTMaps() {
              return { esTreeNodeToTSNodeMap: this.esTreeNodeToTSNodeMap, tsNodeToESTreeNodeMap: this.tsNodeToESTreeNodeMap };
            }
            convertProgram() {
              return this.converter(this.ast);
            }
            converter(a, C, w, B) {
              if (!a)
                return null;
              let E = this.inTypeMode, Q = this.allowPattern;
              w !== void 0 && (this.inTypeMode = w), B !== void 0 && (this.allowPattern = B);
              let le = this.convertNode(a, C != null ? C : a.parent);
              return this.registerTSNodeInNodeMap(a, le), this.inTypeMode = E, this.allowPattern = Q, le;
            }
            fixExports(a, C) {
              if (a.modifiers && a.modifiers[0].kind === ar.ExportKeyword) {
                this.registerTSNodeInNodeMap(a, C);
                let w = a.modifiers[0], B = a.modifiers[1], E = B && B.kind === ar.DefaultKeyword, Q = E ? (0, kr.findNextToken)(B, this.ast, this.ast) : (0, kr.findNextToken)(w, this.ast, this.ast);
                if (C.range[0] = Q.getStart(this.ast), C.loc = (0, kr.getLocFor)(C.range[0], C.range[1], this.ast), E)
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ExportDefaultDeclaration, declaration: C, range: [w.getStart(this.ast), C.range[1]], exportKind: "value" });
                {
                  let le = C.type === pr.AST_NODE_TYPES.TSInterfaceDeclaration || C.type === pr.AST_NODE_TYPES.TSTypeAliasDeclaration, N = "declare" in C && C.declare === true;
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ExportNamedDeclaration, declaration: C, specifiers: [], source: null, exportKind: le || N ? "type" : "value", range: [w.getStart(this.ast), C.range[1]], assertions: [] });
                }
              }
              return C;
            }
            registerTSNodeInNodeMap(a, C) {
              C && this.options.shouldPreserveNodeMaps && (this.tsNodeToESTreeNodeMap.has(a) || this.tsNodeToESTreeNodeMap.set(a, C));
            }
            convertPattern(a, C) {
              return this.converter(a, C, this.inTypeMode, true);
            }
            convertChild(a, C) {
              return this.converter(a, C, this.inTypeMode, false);
            }
            convertType(a, C) {
              return this.converter(a, C, true, false);
            }
            createNode(a, C) {
              let w = C;
              return w.range || (w.range = (0, kr.getRange)(a, this.ast)), w.loc || (w.loc = (0, kr.getLocFor)(w.range[0], w.range[1], this.ast)), w && this.options.shouldPreserveNodeMaps && this.esTreeNodeToTSNodeMap.set(w, a), w;
            }
            convertBindingNameWithTypeAnnotation(a, C, w) {
              let B = this.convertPattern(a);
              return C && (B.typeAnnotation = this.convertTypeAnnotation(C, w), this.fixParentLocation(B, B.typeAnnotation.range)), B;
            }
            convertTypeAnnotation(a, C) {
              let w = (C == null ? void 0 : C.kind) === ar.FunctionType || (C == null ? void 0 : C.kind) === ar.ConstructorType ? 2 : 1, B = a.getFullStart() - w, E = (0, kr.getLocFor)(B, a.end, this.ast);
              return { type: pr.AST_NODE_TYPES.TSTypeAnnotation, loc: E, range: [B, a.end], typeAnnotation: this.convertType(a) };
            }
            convertBodyExpressions(a, C) {
              let w = (0, kr.canContainDirective)(C);
              return a.map((B) => {
                let E = this.convertChild(B);
                if (w)
                  if ((E == null ? void 0 : E.expression) && oi.isExpressionStatement(B) && oi.isStringLiteral(B.expression)) {
                    let Q = E.expression.raw;
                    return E.directive = Q.slice(1, -1), E;
                  } else
                    w = false;
                return E;
              }).filter((B) => B);
            }
            convertTypeArgumentsToTypeParameters(a, C) {
              let w = (0, kr.findNextToken)(a, this.ast, this.ast);
              return this.createNode(C, { type: pr.AST_NODE_TYPES.TSTypeParameterInstantiation, range: [a.pos - 1, w.end], params: a.map((B) => this.convertType(B)) });
            }
            convertTSTypeParametersToTypeParametersDeclaration(a) {
              let C = (0, kr.findNextToken)(a, this.ast, this.ast);
              return { type: pr.AST_NODE_TYPES.TSTypeParameterDeclaration, range: [a.pos - 1, C.end], loc: (0, kr.getLocFor)(a.pos - 1, C.end, this.ast), params: a.map((w) => this.convertType(w)) };
            }
            convertParameters(a) {
              return !a || !a.length ? [] : a.map((C) => {
                var w;
                let B = this.convertChild(C);
                return !((w = C.decorators) === null || w === void 0) && w.length && (B.decorators = C.decorators.map((E) => this.convertChild(E))), B;
              });
            }
            convertChainExpression(a, C) {
              let { child: w, isOptional: B } = (() => a.type === pr.AST_NODE_TYPES.MemberExpression ? { child: a.object, isOptional: a.optional } : a.type === pr.AST_NODE_TYPES.CallExpression ? { child: a.callee, isOptional: a.optional } : { child: a.expression, isOptional: false })(), E = (0, kr.isChildUnwrappableOptionalChain)(C, w);
              if (!E && !B)
                return a;
              if (E && (0, kr.isChainExpression)(w)) {
                let Q = w.expression;
                a.type === pr.AST_NODE_TYPES.MemberExpression ? a.object = Q : a.type === pr.AST_NODE_TYPES.CallExpression ? a.callee = Q : a.expression = Q;
              }
              return this.createNode(C, { type: pr.AST_NODE_TYPES.ChainExpression, expression: a });
            }
            deeplyCopy(a) {
              if (a.kind === oi.SyntaxKind.JSDocFunctionType)
                throw (0, kr.createError)(this.ast, a.pos, "JSDoc types can only be used inside documentation comments.");
              let C = "TS".concat(ar[a.kind]);
              if (this.options.errorOnUnknownASTType && !pr.AST_NODE_TYPES[C])
                throw new Error('Unknown AST_NODE_TYPE: "'.concat(C, '"'));
              let w = this.createNode(a, { type: C });
              return "type" in a && (w.typeAnnotation = a.type && "kind" in a.type && oi.isTypeNode(a.type) ? this.convertTypeAnnotation(a.type, a) : null), "typeArguments" in a && (w.typeParameters = a.typeArguments && "pos" in a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : null), "typeParameters" in a && (w.typeParameters = a.typeParameters && "pos" in a.typeParameters ? this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters) : null), "decorators" in a && a.decorators && a.decorators.length && (w.decorators = a.decorators.map((B) => this.convertChild(B))), Object.entries(a).filter((B) => {
                let [E] = B;
                return !/^(?:_children|kind|parent|pos|end|flags|modifierFlagsCache|jsDoc|type|typeArguments|typeParameters|decorators|transformFlags)$/.test(E);
              }).forEach((B) => {
                let [E, Q] = B;
                Array.isArray(Q) ? w[E] = Q.map((le) => this.convertChild(le)) : Q && typeof Q == "object" && Q.kind ? w[E] = this.convertChild(Q) : w[E] = Q;
              }), w;
            }
            convertJSXIdentifier(a) {
              let C = this.createNode(a, { type: pr.AST_NODE_TYPES.JSXIdentifier, name: a.getText() });
              return this.registerTSNodeInNodeMap(a, C), C;
            }
            convertJSXNamespaceOrIdentifier(a) {
              let C = a.getText(), w = C.indexOf(":");
              if (w > 0) {
                let B = (0, kr.getRange)(a, this.ast), E = this.createNode(a, { type: pr.AST_NODE_TYPES.JSXNamespacedName, namespace: this.createNode(a, { type: pr.AST_NODE_TYPES.JSXIdentifier, name: C.slice(0, w), range: [B[0], B[0] + w] }), name: this.createNode(a, { type: pr.AST_NODE_TYPES.JSXIdentifier, name: C.slice(w + 1), range: [B[0] + w + 1, B[1]] }), range: B });
                return this.registerTSNodeInNodeMap(a, E), E;
              }
              return this.convertJSXIdentifier(a);
            }
            convertJSXTagName(a, C) {
              let w;
              switch (a.kind) {
                case ar.PropertyAccessExpression:
                  if (a.name.kind === ar.PrivateIdentifier)
                    throw new Error("Non-private identifier expected.");
                  w = this.createNode(a, { type: pr.AST_NODE_TYPES.JSXMemberExpression, object: this.convertJSXTagName(a.expression, C), property: this.convertJSXIdentifier(a.name) });
                  break;
                case ar.ThisKeyword:
                case ar.Identifier:
                default:
                  return this.convertJSXNamespaceOrIdentifier(a);
              }
              return this.registerTSNodeInNodeMap(a, w), w;
            }
            convertMethodSignature(a) {
              let C = this.createNode(a, { type: pr.AST_NODE_TYPES.TSMethodSignature, computed: (0, kr.isComputedProperty)(a.name), key: this.convertChild(a.name), params: this.convertParameters(a.parameters), kind: (() => {
                switch (a.kind) {
                  case ar.GetAccessor:
                    return "get";
                  case ar.SetAccessor:
                    return "set";
                  case ar.MethodSignature:
                    return "method";
                }
              })() });
              (0, kr.isOptional)(a) && (C.optional = true), a.type && (C.returnType = this.convertTypeAnnotation(a.type, a)), (0, kr.hasModifier)(ar.ReadonlyKeyword, a) && (C.readonly = true), a.typeParameters && (C.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters));
              let w = (0, kr.getTSNodeAccessibility)(a);
              return w && (C.accessibility = w), (0, kr.hasModifier)(ar.ExportKeyword, a) && (C.export = true), (0, kr.hasModifier)(ar.StaticKeyword, a) && (C.static = true), C;
            }
            convertAssertClasue(a) {
              return a === void 0 ? [] : a.elements.map((C) => this.convertChild(C));
            }
            applyModifiersToResult(a, C) {
              if (!C || !C.length)
                return;
              let w = [];
              for (let B of C)
                switch (B.kind) {
                  case ar.ExportKeyword:
                  case ar.DefaultKeyword:
                    break;
                  case ar.ConstKeyword:
                    a.const = true;
                    break;
                  case ar.DeclareKeyword:
                    a.declare = true;
                    break;
                  default:
                    w.push(this.convertChild(B));
                    break;
                }
              w.length && (a.modifiers = w);
            }
            fixParentLocation(a, C) {
              C[0] < a.range[0] && (a.range[0] = C[0], a.loc.start = (0, kr.getLineAndCharacterFor)(a.range[0], this.ast)), C[1] > a.range[1] && (a.range[1] = C[1], a.loc.end = (0, kr.getLineAndCharacterFor)(a.range[1], this.ast));
            }
            assertModuleSpecifier(a, C) {
              var w;
              if (!C && a.moduleSpecifier == null)
                throw (0, kr.createError)(this.ast, a.pos, "Module specifier must be a string literal.");
              if (a.moduleSpecifier && ((w = a.moduleSpecifier) === null || w === void 0 ? void 0 : w.kind) !== ar.StringLiteral)
                throw (0, kr.createError)(this.ast, a.moduleSpecifier.pos, "Module specifier must be a string literal.");
            }
            convertNode(a, C) {
              var w, B, E, Q, le, N, p, m2, G, oe;
              switch (a.kind) {
                case ar.SourceFile:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Program, body: this.convertBodyExpressions(a.statements, a), sourceType: a.externalModuleIndicator ? "module" : "script", range: [a.getStart(this.ast), a.endOfFileToken.end] });
                case ar.Block:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.BlockStatement, body: this.convertBodyExpressions(a.statements, a) });
                case ar.Identifier:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Identifier, name: a.text });
                case ar.PrivateIdentifier:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.PrivateIdentifier, name: a.text.slice(1) });
                case ar.WithStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.WithStatement, object: this.convertChild(a.expression), body: this.convertChild(a.statement) });
                case ar.ReturnStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ReturnStatement, argument: this.convertChild(a.expression) });
                case ar.LabeledStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.LabeledStatement, label: this.convertChild(a.label), body: this.convertChild(a.statement) });
                case ar.ContinueStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ContinueStatement, label: this.convertChild(a.label) });
                case ar.BreakStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.BreakStatement, label: this.convertChild(a.label) });
                case ar.IfStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.IfStatement, test: this.convertChild(a.expression), consequent: this.convertChild(a.thenStatement), alternate: this.convertChild(a.elseStatement) });
                case ar.SwitchStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.SwitchStatement, discriminant: this.convertChild(a.expression), cases: a.caseBlock.clauses.map((f4) => this.convertChild(f4)) });
                case ar.CaseClause:
                case ar.DefaultClause:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.SwitchCase, test: a.kind === ar.CaseClause ? this.convertChild(a.expression) : null, consequent: a.statements.map((f4) => this.convertChild(f4)) });
                case ar.ThrowStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ThrowStatement, argument: this.convertChild(a.expression) });
                case ar.TryStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TryStatement, block: this.convertChild(a.tryBlock), handler: this.convertChild(a.catchClause), finalizer: this.convertChild(a.finallyBlock) });
                case ar.CatchClause:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.CatchClause, param: a.variableDeclaration ? this.convertBindingNameWithTypeAnnotation(a.variableDeclaration.name, a.variableDeclaration.type) : null, body: this.convertChild(a.block) });
                case ar.WhileStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.WhileStatement, test: this.convertChild(a.expression), body: this.convertChild(a.statement) });
                case ar.DoStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.DoWhileStatement, test: this.convertChild(a.expression), body: this.convertChild(a.statement) });
                case ar.ForStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ForStatement, init: this.convertChild(a.initializer), test: this.convertChild(a.condition), update: this.convertChild(a.incrementor), body: this.convertChild(a.statement) });
                case ar.ForInStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ForInStatement, left: this.convertPattern(a.initializer), right: this.convertChild(a.expression), body: this.convertChild(a.statement) });
                case ar.ForOfStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ForOfStatement, left: this.convertPattern(a.initializer), right: this.convertChild(a.expression), body: this.convertChild(a.statement), await: Boolean(a.awaitModifier && a.awaitModifier.kind === ar.AwaitKeyword) });
                case ar.FunctionDeclaration: {
                  let f4 = (0, kr.hasModifier)(ar.DeclareKeyword, a), T = this.createNode(a, { type: f4 || !a.body ? pr.AST_NODE_TYPES.TSDeclareFunction : pr.AST_NODE_TYPES.FunctionDeclaration, id: this.convertChild(a.name), generator: !!a.asteriskToken, expression: false, async: (0, kr.hasModifier)(ar.AsyncKeyword, a), params: this.convertParameters(a.parameters), body: this.convertChild(a.body) || void 0 });
                  return a.type && (T.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (T.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f4 && (T.declare = true), this.fixExports(a, T);
                }
                case ar.VariableDeclaration: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.VariableDeclarator, id: this.convertBindingNameWithTypeAnnotation(a.name, a.type, a), init: this.convertChild(a.initializer) });
                  return a.exclamationToken && (f4.definite = true), f4;
                }
                case ar.VariableStatement: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.VariableDeclaration, declarations: a.declarationList.declarations.map((T) => this.convertChild(T)), kind: (0, kr.getDeclarationKind)(a.declarationList) });
                  return a.decorators && (f4.decorators = a.decorators.map((T) => this.convertChild(T))), (0, kr.hasModifier)(ar.DeclareKeyword, a) && (f4.declare = true), this.fixExports(a, f4);
                }
                case ar.VariableDeclarationList:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.VariableDeclaration, declarations: a.declarations.map((f4) => this.convertChild(f4)), kind: (0, kr.getDeclarationKind)(a) });
                case ar.ExpressionStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ExpressionStatement, expression: this.convertChild(a.expression) });
                case ar.ThisKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ThisExpression });
                case ar.ArrayLiteralExpression:
                  return this.allowPattern ? this.createNode(a, { type: pr.AST_NODE_TYPES.ArrayPattern, elements: a.elements.map((f4) => this.convertPattern(f4)) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.ArrayExpression, elements: a.elements.map((f4) => this.convertChild(f4)) });
                case ar.ObjectLiteralExpression:
                  return this.allowPattern ? this.createNode(a, { type: pr.AST_NODE_TYPES.ObjectPattern, properties: a.properties.map((f4) => this.convertPattern(f4)) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.ObjectExpression, properties: a.properties.map((f4) => this.convertChild(f4)) });
                case ar.PropertyAssignment:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild(a.name), value: this.converter(a.initializer, a, this.inTypeMode, this.allowPattern), computed: (0, kr.isComputedProperty)(a.name), method: false, shorthand: false, kind: "init" });
                case ar.ShorthandPropertyAssignment:
                  return a.objectAssignmentInitializer ? this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild(a.name), value: this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: this.convertPattern(a.name), right: this.convertChild(a.objectAssignmentInitializer) }), computed: false, method: false, shorthand: true, kind: "init" }) : this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild(a.name), value: this.convertChild(a.name), computed: false, method: false, shorthand: true, kind: "init" });
                case ar.ComputedPropertyName:
                  return this.convertChild(a.expression);
                case ar.PropertyDeclaration: {
                  let f4 = (0, kr.hasModifier)(ar.AbstractKeyword, a), T = this.createNode(a, { type: f4 ? pr.AST_NODE_TYPES.TSAbstractPropertyDefinition : pr.AST_NODE_TYPES.PropertyDefinition, key: this.convertChild(a.name), value: f4 ? null : this.convertChild(a.initializer), computed: (0, kr.isComputedProperty)(a.name), static: (0, kr.hasModifier)(ar.StaticKeyword, a), readonly: (0, kr.hasModifier)(ar.ReadonlyKeyword, a) || void 0, declare: (0, kr.hasModifier)(ar.DeclareKeyword, a), override: (0, kr.hasModifier)(ar.OverrideKeyword, a) });
                  a.type && (T.typeAnnotation = this.convertTypeAnnotation(a.type, a)), a.decorators && (T.decorators = a.decorators.map((b) => this.convertChild(b)));
                  let K = (0, kr.getTSNodeAccessibility)(a);
                  return K && (T.accessibility = K), (a.name.kind === ar.Identifier || a.name.kind === ar.ComputedPropertyName || a.name.kind === ar.PrivateIdentifier) && a.questionToken && (T.optional = true), a.exclamationToken && (T.definite = true), T.key.type === pr.AST_NODE_TYPES.Literal && a.questionToken && (T.optional = true), T;
                }
                case ar.GetAccessor:
                case ar.SetAccessor:
                  if (a.parent.kind === ar.InterfaceDeclaration || a.parent.kind === ar.TypeLiteral)
                    return this.convertMethodSignature(a);
                case ar.MethodDeclaration: {
                  let f4 = this.createNode(a, { type: a.body ? pr.AST_NODE_TYPES.FunctionExpression : pr.AST_NODE_TYPES.TSEmptyBodyFunctionExpression, id: null, generator: !!a.asteriskToken, expression: false, async: (0, kr.hasModifier)(ar.AsyncKeyword, a), body: this.convertChild(a.body), range: [a.parameters.pos - 1, a.end], params: [] });
                  a.type && (f4.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (f4.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters), this.fixParentLocation(f4, f4.typeParameters.range));
                  let T;
                  if (C.kind === ar.ObjectLiteralExpression)
                    f4.params = a.parameters.map((K) => this.convertChild(K)), T = this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild(a.name), value: f4, computed: (0, kr.isComputedProperty)(a.name), method: a.kind === ar.MethodDeclaration, shorthand: false, kind: "init" });
                  else {
                    f4.params = this.convertParameters(a.parameters);
                    let K = (0, kr.hasModifier)(ar.AbstractKeyword, a) ? pr.AST_NODE_TYPES.TSAbstractMethodDefinition : pr.AST_NODE_TYPES.MethodDefinition;
                    T = this.createNode(a, { type: K, key: this.convertChild(a.name), value: f4, computed: (0, kr.isComputedProperty)(a.name), static: (0, kr.hasModifier)(ar.StaticKeyword, a), kind: "method", override: (0, kr.hasModifier)(ar.OverrideKeyword, a) }), a.decorators && (T.decorators = a.decorators.map((se) => this.convertChild(se)));
                    let b = (0, kr.getTSNodeAccessibility)(a);
                    b && (T.accessibility = b);
                  }
                  return a.questionToken && (T.optional = true), a.kind === ar.GetAccessor ? T.kind = "get" : a.kind === ar.SetAccessor ? T.kind = "set" : !T.static && a.name.kind === ar.StringLiteral && a.name.text === "constructor" && T.type !== pr.AST_NODE_TYPES.Property && (T.kind = "constructor"), T;
                }
                case ar.Constructor: {
                  let f4 = (0, kr.getLastModifier)(a), T = f4 && (0, kr.findNextToken)(f4, a, this.ast) || a.getFirstToken(), K = this.createNode(a, { type: a.body ? pr.AST_NODE_TYPES.FunctionExpression : pr.AST_NODE_TYPES.TSEmptyBodyFunctionExpression, id: null, params: this.convertParameters(a.parameters), generator: false, expression: false, async: false, body: this.convertChild(a.body), range: [a.parameters.pos - 1, a.end] });
                  a.typeParameters && (K.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters), this.fixParentLocation(K, K.typeParameters.range)), a.type && (K.returnType = this.convertTypeAnnotation(a.type, a));
                  let b = this.createNode(a, { type: pr.AST_NODE_TYPES.Identifier, name: "constructor", range: [T.getStart(this.ast), T.end] }), se = (0, kr.hasModifier)(ar.StaticKeyword, a), J = this.createNode(a, { type: (0, kr.hasModifier)(ar.AbstractKeyword, a) ? pr.AST_NODE_TYPES.TSAbstractMethodDefinition : pr.AST_NODE_TYPES.MethodDefinition, key: b, value: K, computed: false, static: se, kind: se ? "method" : "constructor", override: false }), ie = (0, kr.getTSNodeAccessibility)(a);
                  return ie && (J.accessibility = ie), J;
                }
                case ar.FunctionExpression: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.FunctionExpression, id: this.convertChild(a.name), generator: !!a.asteriskToken, params: this.convertParameters(a.parameters), body: this.convertChild(a.body), async: (0, kr.hasModifier)(ar.AsyncKeyword, a), expression: false });
                  return a.type && (f4.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (f4.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f4;
                }
                case ar.SuperKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Super });
                case ar.ArrayBindingPattern:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ArrayPattern, elements: a.elements.map((f4) => this.convertPattern(f4)) });
                case ar.OmittedExpression:
                  return null;
                case ar.ObjectBindingPattern:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ObjectPattern, properties: a.elements.map((f4) => this.convertPattern(f4)) });
                case ar.BindingElement:
                  if (C.kind === ar.ArrayBindingPattern) {
                    let f4 = this.convertChild(a.name, C);
                    return a.initializer ? this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: f4, right: this.convertChild(a.initializer) }) : a.dotDotDotToken ? this.createNode(a, { type: pr.AST_NODE_TYPES.RestElement, argument: f4 }) : f4;
                  } else {
                    let f4;
                    return a.dotDotDotToken ? f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.RestElement, argument: this.convertChild((w = a.propertyName) !== null && w !== void 0 ? w : a.name) }) : f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.Property, key: this.convertChild((B = a.propertyName) !== null && B !== void 0 ? B : a.name), value: this.convertChild(a.name), computed: Boolean(a.propertyName && a.propertyName.kind === ar.ComputedPropertyName), method: false, shorthand: !a.propertyName, kind: "init" }), a.initializer && (f4.value = this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: this.convertChild(a.name), right: this.convertChild(a.initializer), range: [a.name.getStart(this.ast), a.initializer.end] })), f4;
                  }
                case ar.ArrowFunction: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.ArrowFunctionExpression, generator: false, id: null, params: this.convertParameters(a.parameters), body: this.convertChild(a.body), async: (0, kr.hasModifier)(ar.AsyncKeyword, a), expression: a.body.kind !== ar.Block });
                  return a.type && (f4.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (f4.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f4;
                }
                case ar.YieldExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.YieldExpression, delegate: !!a.asteriskToken, argument: this.convertChild(a.expression) });
                case ar.AwaitExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.AwaitExpression, argument: this.convertChild(a.expression) });
                case ar.NoSubstitutionTemplateLiteral:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TemplateLiteral, quasis: [this.createNode(a, { type: pr.AST_NODE_TYPES.TemplateElement, value: { raw: this.ast.text.slice(a.getStart(this.ast) + 1, a.end - 1), cooked: a.text }, tail: true })], expressions: [] });
                case ar.TemplateExpression: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TemplateLiteral, quasis: [this.convertChild(a.head)], expressions: [] });
                  return a.templateSpans.forEach((T) => {
                    f4.expressions.push(this.convertChild(T.expression)), f4.quasis.push(this.convertChild(T.literal));
                  }), f4;
                }
                case ar.TaggedTemplateExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TaggedTemplateExpression, typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : void 0, tag: this.convertChild(a.tag), quasi: this.convertChild(a.template) });
                case ar.TemplateHead:
                case ar.TemplateMiddle:
                case ar.TemplateTail: {
                  let f4 = a.kind === ar.TemplateTail;
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TemplateElement, value: { raw: this.ast.text.slice(a.getStart(this.ast) + 1, a.end - (f4 ? 1 : 2)), cooked: a.text }, tail: f4 });
                }
                case ar.SpreadAssignment:
                case ar.SpreadElement:
                  return this.allowPattern ? this.createNode(a, { type: pr.AST_NODE_TYPES.RestElement, argument: this.convertPattern(a.expression) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.SpreadElement, argument: this.convertChild(a.expression) });
                case ar.Parameter: {
                  let f4, T;
                  return a.dotDotDotToken ? f4 = T = this.createNode(a, { type: pr.AST_NODE_TYPES.RestElement, argument: this.convertChild(a.name) }) : a.initializer ? (f4 = this.convertChild(a.name), T = this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: f4, right: this.convertChild(a.initializer) }), a.modifiers && (T.range[0] = f4.range[0], T.loc = (0, kr.getLocFor)(T.range[0], T.range[1], this.ast))) : f4 = T = this.convertChild(a.name, C), a.type && (f4.typeAnnotation = this.convertTypeAnnotation(a.type, a), this.fixParentLocation(f4, f4.typeAnnotation.range)), a.questionToken && (a.questionToken.end > f4.range[1] && (f4.range[1] = a.questionToken.end, f4.loc.end = (0, kr.getLineAndCharacterFor)(f4.range[1], this.ast)), f4.optional = true), a.modifiers ? this.createNode(a, { type: pr.AST_NODE_TYPES.TSParameterProperty, accessibility: (E = (0, kr.getTSNodeAccessibility)(a)) !== null && E !== void 0 ? E : void 0, readonly: (0, kr.hasModifier)(ar.ReadonlyKeyword, a) || void 0, static: (0, kr.hasModifier)(ar.StaticKeyword, a) || void 0, export: (0, kr.hasModifier)(ar.ExportKeyword, a) || void 0, override: (0, kr.hasModifier)(ar.OverrideKeyword, a) || void 0, parameter: T }) : T;
                }
                case ar.ClassDeclaration:
                case ar.ClassExpression: {
                  let f4 = (Q = a.heritageClauses) !== null && Q !== void 0 ? Q : [], T = a.kind === ar.ClassDeclaration ? pr.AST_NODE_TYPES.ClassDeclaration : pr.AST_NODE_TYPES.ClassExpression, K = f4.find((ie) => ie.token === ar.ExtendsKeyword), b = f4.find((ie) => ie.token === ar.ImplementsKeyword), se = this.createNode(a, { type: T, id: this.convertChild(a.name), body: this.createNode(a, { type: pr.AST_NODE_TYPES.ClassBody, body: [], range: [a.members.pos - 1, a.end] }), superClass: K != null && K.types[0] ? this.convertChild(K.types[0].expression) : null });
                  if (K) {
                    if (K.types.length > 1)
                      throw (0, kr.createError)(this.ast, K.types[1].pos, "Classes can only extend a single class.");
                    !((le = K.types[0]) === null || le === void 0) && le.typeArguments && (se.superTypeParameters = this.convertTypeArgumentsToTypeParameters(K.types[0].typeArguments, K.types[0]));
                  }
                  a.typeParameters && (se.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), b && (se.implements = b.types.map((ie) => this.convertChild(ie))), (0, kr.hasModifier)(ar.AbstractKeyword, a) && (se.abstract = true), (0, kr.hasModifier)(ar.DeclareKeyword, a) && (se.declare = true), a.decorators && (se.decorators = a.decorators.map((ie) => this.convertChild(ie)));
                  let J = a.members.filter(kr.isESTreeClassMember);
                  return J.length && (se.body.body = J.map((ie) => this.convertChild(ie))), this.fixExports(a, se);
                }
                case ar.ModuleBlock:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSModuleBlock, body: this.convertBodyExpressions(a.statements, a) });
                case ar.ImportDeclaration: {
                  this.assertModuleSpecifier(a, false);
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.ImportDeclaration, source: this.convertChild(a.moduleSpecifier), specifiers: [], importKind: "value", assertions: this.convertAssertClasue(a.assertClause) });
                  if (a.importClause && (a.importClause.isTypeOnly && (f4.importKind = "type"), a.importClause.name && f4.specifiers.push(this.convertChild(a.importClause)), a.importClause.namedBindings))
                    switch (a.importClause.namedBindings.kind) {
                      case ar.NamespaceImport:
                        f4.specifiers.push(this.convertChild(a.importClause.namedBindings));
                        break;
                      case ar.NamedImports:
                        f4.specifiers = f4.specifiers.concat(a.importClause.namedBindings.elements.map((T) => this.convertChild(T)));
                        break;
                    }
                  return f4;
                }
                case ar.NamespaceImport:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportNamespaceSpecifier, local: this.convertChild(a.name) });
                case ar.ImportSpecifier:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportSpecifier, local: this.convertChild(a.name), imported: this.convertChild((N = a.propertyName) !== null && N !== void 0 ? N : a.name), importKind: a.isTypeOnly ? "type" : "value" });
                case ar.ImportClause: {
                  let f4 = this.convertChild(a.name);
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportDefaultSpecifier, local: f4, range: f4.range });
                }
                case ar.ExportDeclaration:
                  return ((p = a.exportClause) === null || p === void 0 ? void 0 : p.kind) === ar.NamedExports ? (this.assertModuleSpecifier(a, true), this.createNode(a, { type: pr.AST_NODE_TYPES.ExportNamedDeclaration, source: this.convertChild(a.moduleSpecifier), specifiers: a.exportClause.elements.map((f4) => this.convertChild(f4)), exportKind: a.isTypeOnly ? "type" : "value", declaration: null, assertions: this.convertAssertClasue(a.assertClause) })) : (this.assertModuleSpecifier(a, false), this.createNode(a, { type: pr.AST_NODE_TYPES.ExportAllDeclaration, source: this.convertChild(a.moduleSpecifier), exportKind: a.isTypeOnly ? "type" : "value", exported: a.exportClause && a.exportClause.kind === ar.NamespaceExport ? this.convertChild(a.exportClause.name) : null, assertions: this.convertAssertClasue(a.assertClause) }));
                case ar.ExportSpecifier:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ExportSpecifier, local: this.convertChild((m2 = a.propertyName) !== null && m2 !== void 0 ? m2 : a.name), exported: this.convertChild(a.name), exportKind: a.isTypeOnly ? "type" : "value" });
                case ar.ExportAssignment:
                  return a.isExportEquals ? this.createNode(a, { type: pr.AST_NODE_TYPES.TSExportAssignment, expression: this.convertChild(a.expression) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.ExportDefaultDeclaration, declaration: this.convertChild(a.expression), exportKind: "value" });
                case ar.PrefixUnaryExpression:
                case ar.PostfixUnaryExpression: {
                  let f4 = (0, kr.getTextForTokenKind)(a.operator);
                  return f4 === "++" || f4 === "--" ? this.createNode(a, { type: pr.AST_NODE_TYPES.UpdateExpression, operator: f4, prefix: a.kind === ar.PrefixUnaryExpression, argument: this.convertChild(a.operand) }) : this.createNode(a, { type: pr.AST_NODE_TYPES.UnaryExpression, operator: f4, prefix: a.kind === ar.PrefixUnaryExpression, argument: this.convertChild(a.operand) });
                }
                case ar.DeleteExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.UnaryExpression, operator: "delete", prefix: true, argument: this.convertChild(a.expression) });
                case ar.VoidExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.UnaryExpression, operator: "void", prefix: true, argument: this.convertChild(a.expression) });
                case ar.TypeOfExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.UnaryExpression, operator: "typeof", prefix: true, argument: this.convertChild(a.expression) });
                case ar.TypeOperator:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeOperator, operator: (0, kr.getTextForTokenKind)(a.operator), typeAnnotation: this.convertChild(a.type) });
                case ar.BinaryExpression:
                  if ((0, kr.isComma)(a.operatorToken)) {
                    let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.SequenceExpression, expressions: [] }), T = this.convertChild(a.left);
                    return T.type === pr.AST_NODE_TYPES.SequenceExpression && a.left.kind !== ar.ParenthesizedExpression ? f4.expressions = f4.expressions.concat(T.expressions) : f4.expressions.push(T), f4.expressions.push(this.convertChild(a.right)), f4;
                  } else {
                    let f4 = (0, kr.getBinaryExpressionType)(a.operatorToken);
                    return this.allowPattern && f4 === pr.AST_NODE_TYPES.AssignmentExpression ? this.createNode(a, { type: pr.AST_NODE_TYPES.AssignmentPattern, left: this.convertPattern(a.left, a), right: this.convertChild(a.right) }) : this.createNode(a, { type: f4, operator: (0, kr.getTextForTokenKind)(a.operatorToken.kind), left: this.converter(a.left, a, this.inTypeMode, f4 === pr.AST_NODE_TYPES.AssignmentExpression), right: this.convertChild(a.right) });
                  }
                case ar.PropertyAccessExpression: {
                  let f4 = this.convertChild(a.expression), T = this.convertChild(a.name), K = false, b = this.createNode(a, { type: pr.AST_NODE_TYPES.MemberExpression, object: f4, property: T, computed: K, optional: a.questionDotToken !== void 0 });
                  return this.convertChainExpression(b, a);
                }
                case ar.ElementAccessExpression: {
                  let f4 = this.convertChild(a.expression), T = this.convertChild(a.argumentExpression), K = true, b = this.createNode(a, { type: pr.AST_NODE_TYPES.MemberExpression, object: f4, property: T, computed: K, optional: a.questionDotToken !== void 0 });
                  return this.convertChainExpression(b, a);
                }
                case ar.CallExpression: {
                  if (a.expression.kind === ar.ImportKeyword) {
                    if (a.arguments.length !== 1 && a.arguments.length !== 2)
                      throw (0, kr.createError)(this.ast, a.arguments.pos, "Dynamic import requires exactly one or two arguments.");
                    return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportExpression, source: this.convertChild(a.arguments[0]), attributes: a.arguments[1] ? this.convertChild(a.arguments[1]) : null });
                  }
                  let f4 = this.convertChild(a.expression), T = a.arguments.map((b) => this.convertChild(b)), K = this.createNode(a, { type: pr.AST_NODE_TYPES.CallExpression, callee: f4, arguments: T, optional: a.questionDotToken !== void 0 });
                  return a.typeArguments && (K.typeParameters = this.convertTypeArgumentsToTypeParameters(a.typeArguments, a)), this.convertChainExpression(K, a);
                }
                case ar.NewExpression: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.NewExpression, callee: this.convertChild(a.expression), arguments: a.arguments ? a.arguments.map((T) => this.convertChild(T)) : [] });
                  return a.typeArguments && (f4.typeParameters = this.convertTypeArgumentsToTypeParameters(a.typeArguments, a)), f4;
                }
                case ar.ConditionalExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ConditionalExpression, test: this.convertChild(a.condition), consequent: this.convertChild(a.whenTrue), alternate: this.convertChild(a.whenFalse) });
                case ar.MetaProperty:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.MetaProperty, meta: this.createNode(a.getFirstToken(), { type: pr.AST_NODE_TYPES.Identifier, name: (0, kr.getTextForTokenKind)(a.keywordToken) }), property: this.convertChild(a.name) });
                case ar.Decorator:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Decorator, expression: this.convertChild(a.expression) });
                case ar.StringLiteral:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: C.kind === ar.JsxAttribute ? (0, kr.unescapeStringLiteralText)(a.text) : a.text, raw: a.getText() });
                case ar.NumericLiteral:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: Number(a.text), raw: a.getText() });
                case ar.BigIntLiteral: {
                  let f4 = (0, kr.getRange)(a, this.ast), T = this.ast.text.slice(f4[0], f4[1]), K = T.slice(0, -1).replace(/_/g, ""), b = typeof BigInt < "u" ? BigInt(K) : null;
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, raw: T, value: b, bigint: b === null ? K : String(b), range: f4 });
                }
                case ar.RegularExpressionLiteral: {
                  let f4 = a.text.slice(1, a.text.lastIndexOf("/")), T = a.text.slice(a.text.lastIndexOf("/") + 1), K = null;
                  try {
                    K = new RegExp(f4, T);
                  } catch {
                    K = null;
                  }
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: K, raw: a.text, regex: { pattern: f4, flags: T } });
                }
                case ar.TrueKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: true, raw: "true" });
                case ar.FalseKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: false, raw: "false" });
                case ar.NullKeyword:
                  return !Lr.typescriptVersionIsAtLeast["4.0"] && this.inTypeMode ? this.createNode(a, { type: pr.AST_NODE_TYPES.TSNullKeyword }) : this.createNode(a, { type: pr.AST_NODE_TYPES.Literal, value: null, raw: "null" });
                case ar.EmptyStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.EmptyStatement });
                case ar.DebuggerStatement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.DebuggerStatement });
                case ar.JsxElement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXElement, openingElement: this.convertChild(a.openingElement), closingElement: this.convertChild(a.closingElement), children: a.children.map((f4) => this.convertChild(f4)) });
                case ar.JsxFragment:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXFragment, openingFragment: this.convertChild(a.openingFragment), closingFragment: this.convertChild(a.closingFragment), children: a.children.map((f4) => this.convertChild(f4)) });
                case ar.JsxSelfClosingElement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXElement, openingElement: this.createNode(a, { type: pr.AST_NODE_TYPES.JSXOpeningElement, typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : void 0, selfClosing: true, name: this.convertJSXTagName(a.tagName, a), attributes: a.attributes.properties.map((f4) => this.convertChild(f4)), range: (0, kr.getRange)(a, this.ast) }), closingElement: null, children: [] });
                case ar.JsxOpeningElement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXOpeningElement, typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : void 0, selfClosing: false, name: this.convertJSXTagName(a.tagName, a), attributes: a.attributes.properties.map((f4) => this.convertChild(f4)) });
                case ar.JsxClosingElement:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXClosingElement, name: this.convertJSXTagName(a.tagName, a) });
                case ar.JsxOpeningFragment:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXOpeningFragment });
                case ar.JsxClosingFragment:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXClosingFragment });
                case ar.JsxExpression: {
                  let f4 = a.expression ? this.convertChild(a.expression) : this.createNode(a, { type: pr.AST_NODE_TYPES.JSXEmptyExpression, range: [a.getStart(this.ast) + 1, a.getEnd() - 1] });
                  return a.dotDotDotToken ? this.createNode(a, { type: pr.AST_NODE_TYPES.JSXSpreadChild, expression: f4 }) : this.createNode(a, { type: pr.AST_NODE_TYPES.JSXExpressionContainer, expression: f4 });
                }
                case ar.JsxAttribute:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXAttribute, name: this.convertJSXNamespaceOrIdentifier(a.name), value: this.convertChild(a.initializer) });
                case ar.JsxText: {
                  let f4 = a.getFullStart(), T = a.getEnd(), K = this.ast.text.slice(f4, T);
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXText, value: (0, kr.unescapeStringLiteralText)(K), raw: K, range: [f4, T] });
                }
                case ar.JsxSpreadAttribute:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.JSXSpreadAttribute, argument: this.convertChild(a.expression) });
                case ar.QualifiedName:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSQualifiedName, left: this.convertChild(a.left), right: this.convertChild(a.right) });
                case ar.TypeReference:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeReference, typeName: this.convertType(a.typeName), typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : void 0 });
                case ar.TypeParameter:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeParameter, name: this.convertType(a.name), constraint: a.constraint ? this.convertType(a.constraint) : void 0, default: a.default ? this.convertType(a.default) : void 0, in: (0, kr.hasModifier)(ar.InKeyword, a), out: (0, kr.hasModifier)(ar.OutKeyword, a) });
                case ar.ThisType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSThisType });
                case ar.AnyKeyword:
                case ar.BigIntKeyword:
                case ar.BooleanKeyword:
                case ar.NeverKeyword:
                case ar.NumberKeyword:
                case ar.ObjectKeyword:
                case ar.StringKeyword:
                case ar.SymbolKeyword:
                case ar.UnknownKeyword:
                case ar.VoidKeyword:
                case ar.UndefinedKeyword:
                case ar.IntrinsicKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES["TS".concat(ar[a.kind])] });
                case ar.NonNullExpression: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSNonNullExpression, expression: this.convertChild(a.expression) });
                  return this.convertChainExpression(f4, a);
                }
                case ar.TypeLiteral:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeLiteral, members: a.members.map((f4) => this.convertChild(f4)) });
                case ar.ArrayType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSArrayType, elementType: this.convertType(a.elementType) });
                case ar.IndexedAccessType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSIndexedAccessType, objectType: this.convertType(a.objectType), indexType: this.convertType(a.indexType) });
                case ar.ConditionalType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSConditionalType, checkType: this.convertType(a.checkType), extendsType: this.convertType(a.extendsType), trueType: this.convertType(a.trueType), falseType: this.convertType(a.falseType) });
                case ar.TypeQuery:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeQuery, exprName: this.convertType(a.exprName), typeParameters: a.typeArguments && this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) });
                case ar.MappedType: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSMappedType, typeParameter: this.convertType(a.typeParameter), nameType: (G = this.convertType(a.nameType)) !== null && G !== void 0 ? G : null });
                  return a.readonlyToken && (a.readonlyToken.kind === ar.ReadonlyKeyword ? f4.readonly = true : f4.readonly = (0, kr.getTextForTokenKind)(a.readonlyToken.kind)), a.questionToken && (a.questionToken.kind === ar.QuestionToken ? f4.optional = true : f4.optional = (0, kr.getTextForTokenKind)(a.questionToken.kind)), a.type && (f4.typeAnnotation = this.convertType(a.type)), f4;
                }
                case ar.ParenthesizedExpression:
                  return this.convertChild(a.expression, C);
                case ar.TypeAliasDeclaration: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeAliasDeclaration, id: this.convertChild(a.name), typeAnnotation: this.convertType(a.type) });
                  return (0, kr.hasModifier)(ar.DeclareKeyword, a) && (f4.declare = true), a.typeParameters && (f4.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), this.fixExports(a, f4);
                }
                case ar.MethodSignature:
                  return this.convertMethodSignature(a);
                case ar.PropertySignature: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSPropertySignature, optional: (0, kr.isOptional)(a) || void 0, computed: (0, kr.isComputedProperty)(a.name), key: this.convertChild(a.name), typeAnnotation: a.type ? this.convertTypeAnnotation(a.type, a) : void 0, initializer: this.convertChild(a.initializer) || void 0, readonly: (0, kr.hasModifier)(ar.ReadonlyKeyword, a) || void 0, static: (0, kr.hasModifier)(ar.StaticKeyword, a) || void 0, export: (0, kr.hasModifier)(ar.ExportKeyword, a) || void 0 }), T = (0, kr.getTSNodeAccessibility)(a);
                  return T && (f4.accessibility = T), f4;
                }
                case ar.IndexSignature: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSIndexSignature, parameters: a.parameters.map((K) => this.convertChild(K)) });
                  a.type && (f4.typeAnnotation = this.convertTypeAnnotation(a.type, a)), (0, kr.hasModifier)(ar.ReadonlyKeyword, a) && (f4.readonly = true);
                  let T = (0, kr.getTSNodeAccessibility)(a);
                  return T && (f4.accessibility = T), (0, kr.hasModifier)(ar.ExportKeyword, a) && (f4.export = true), (0, kr.hasModifier)(ar.StaticKeyword, a) && (f4.static = true), f4;
                }
                case ar.ConstructorType: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSConstructorType, params: this.convertParameters(a.parameters), abstract: (0, kr.hasModifier)(ar.AbstractKeyword, a) });
                  return a.type && (f4.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (f4.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f4;
                }
                case ar.FunctionType:
                case ar.ConstructSignature:
                case ar.CallSignature: {
                  let f4 = a.kind === ar.ConstructSignature ? pr.AST_NODE_TYPES.TSConstructSignatureDeclaration : a.kind === ar.CallSignature ? pr.AST_NODE_TYPES.TSCallSignatureDeclaration : pr.AST_NODE_TYPES.TSFunctionType, T = this.createNode(a, { type: f4, params: this.convertParameters(a.parameters) });
                  return a.type && (T.returnType = this.convertTypeAnnotation(a.type, a)), a.typeParameters && (T.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), T;
                }
                case ar.ExpressionWithTypeArguments: {
                  let f4 = C.kind, T = f4 === ar.InterfaceDeclaration ? pr.AST_NODE_TYPES.TSInterfaceHeritage : f4 === ar.HeritageClause ? pr.AST_NODE_TYPES.TSClassImplements : pr.AST_NODE_TYPES.TSInstantiationExpression, K = this.createNode(a, { type: T, expression: this.convertChild(a.expression) });
                  return a.typeArguments && (K.typeParameters = this.convertTypeArgumentsToTypeParameters(a.typeArguments, a)), K;
                }
                case ar.InterfaceDeclaration: {
                  let f4 = (oe = a.heritageClauses) !== null && oe !== void 0 ? oe : [], T = this.createNode(a, { type: pr.AST_NODE_TYPES.TSInterfaceDeclaration, body: this.createNode(a, { type: pr.AST_NODE_TYPES.TSInterfaceBody, body: a.members.map((K) => this.convertChild(K)), range: [a.members.pos - 1, a.end] }), id: this.convertChild(a.name) });
                  if (a.typeParameters && (T.typeParameters = this.convertTSTypeParametersToTypeParametersDeclaration(a.typeParameters)), f4.length > 0) {
                    let K = [], b = [];
                    for (let se of f4)
                      if (se.token === ar.ExtendsKeyword)
                        for (let J of se.types)
                          K.push(this.convertChild(J, a));
                      else
                        for (let J of se.types)
                          b.push(this.convertChild(J, a));
                    K.length && (T.extends = K), b.length && (T.implements = b);
                  }
                  return (0, kr.hasModifier)(ar.AbstractKeyword, a) && (T.abstract = true), (0, kr.hasModifier)(ar.DeclareKeyword, a) && (T.declare = true), this.fixExports(a, T);
                }
                case ar.TypePredicate: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypePredicate, asserts: a.assertsModifier !== void 0, parameterName: this.convertChild(a.parameterName), typeAnnotation: null });
                  return a.type && (f4.typeAnnotation = this.convertTypeAnnotation(a.type, a), f4.typeAnnotation.loc = f4.typeAnnotation.typeAnnotation.loc, f4.typeAnnotation.range = f4.typeAnnotation.typeAnnotation.range), f4;
                }
                case ar.ImportType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSImportType, isTypeOf: !!a.isTypeOf, parameter: this.convertChild(a.argument), qualifier: this.convertChild(a.qualifier), typeParameters: a.typeArguments ? this.convertTypeArgumentsToTypeParameters(a.typeArguments, a) : null });
                case ar.EnumDeclaration: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSEnumDeclaration, id: this.convertChild(a.name), members: a.members.map((T) => this.convertChild(T)) });
                  return this.applyModifiersToResult(f4, a.modifiers), this.fixExports(a, f4);
                }
                case ar.EnumMember: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSEnumMember, id: this.convertChild(a.name) });
                  return a.initializer && (f4.initializer = this.convertChild(a.initializer)), a.name.kind === oi.SyntaxKind.ComputedPropertyName && (f4.computed = true), f4;
                }
                case ar.ModuleDeclaration: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSModuleDeclaration, id: this.convertChild(a.name) });
                  return a.body && (f4.body = this.convertChild(a.body)), this.applyModifiersToResult(f4, a.modifiers), a.flags & oi.NodeFlags.GlobalAugmentation && (f4.global = true), this.fixExports(a, f4);
                }
                case ar.ParenthesizedType:
                  return this.convertType(a.type);
                case ar.UnionType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSUnionType, types: a.types.map((f4) => this.convertType(f4)) });
                case ar.IntersectionType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSIntersectionType, types: a.types.map((f4) => this.convertType(f4)) });
                case ar.AsExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSAsExpression, expression: this.convertChild(a.expression), typeAnnotation: this.convertType(a.type) });
                case ar.InferType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSInferType, typeParameter: this.convertType(a.typeParameter) });
                case ar.LiteralType:
                  return Lr.typescriptVersionIsAtLeast["4.0"] && a.literal.kind === ar.NullKeyword ? this.createNode(a.literal, { type: pr.AST_NODE_TYPES.TSNullKeyword }) : this.createNode(a, { type: pr.AST_NODE_TYPES.TSLiteralType, literal: this.convertType(a.literal) });
                case ar.TypeAssertionExpression:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTypeAssertion, typeAnnotation: this.convertType(a.type), expression: this.convertChild(a.expression) });
                case ar.ImportEqualsDeclaration:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSImportEqualsDeclaration, id: this.convertChild(a.name), moduleReference: this.convertChild(a.moduleReference), importKind: a.isTypeOnly ? "type" : "value", isExport: (0, kr.hasModifier)(ar.ExportKeyword, a) });
                case ar.ExternalModuleReference:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSExternalModuleReference, expression: this.convertChild(a.expression) });
                case ar.NamespaceExportDeclaration:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSNamespaceExportDeclaration, id: this.convertChild(a.name) });
                case ar.AbstractKeyword:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSAbstractKeyword });
                case ar.TupleType: {
                  let f4 = "elementTypes" in a ? a.elementTypes.map((T) => this.convertType(T)) : a.elements.map((T) => this.convertType(T));
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSTupleType, elementTypes: f4 });
                }
                case ar.NamedTupleMember: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSNamedTupleMember, elementType: this.convertType(a.type, a), label: this.convertChild(a.name, a), optional: a.questionToken != null });
                  return a.dotDotDotToken ? (f4.range[0] = f4.label.range[0], f4.loc.start = f4.label.loc.start, this.createNode(a, { type: pr.AST_NODE_TYPES.TSRestType, typeAnnotation: f4 })) : f4;
                }
                case ar.OptionalType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSOptionalType, typeAnnotation: this.convertType(a.type) });
                case ar.RestType:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.TSRestType, typeAnnotation: this.convertType(a.type) });
                case ar.TemplateLiteralType: {
                  let f4 = this.createNode(a, { type: pr.AST_NODE_TYPES.TSTemplateLiteralType, quasis: [this.convertChild(a.head)], types: [] });
                  return a.templateSpans.forEach((T) => {
                    f4.types.push(this.convertChild(T.type)), f4.quasis.push(this.convertChild(T.literal));
                  }), f4;
                }
                case ar.ClassStaticBlockDeclaration:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.StaticBlock, body: this.convertBodyExpressions(a.body.statements, a) });
                case ar.AssertEntry:
                  return this.createNode(a, { type: pr.AST_NODE_TYPES.ImportAttribute, key: this.convertChild(a.name), value: this.convertChild(a.value) });
                default:
                  return this.deeplyCopy(a);
              }
            }
          };
          M.Converter = e2;
        } }), Ud = {};
        h1(Ud, { __assign: () => v1, __asyncDelegator: () => JU, __asyncGenerator: () => BU, __asyncValues: () => jU, __await: () => Xy, __awaiter: () => wU, __classPrivateFieldGet: () => qU, __classPrivateFieldSet: () => VU, __createBinding: () => FU, __decorate: () => NU, __exportStar: () => MU, __extends: () => kU, __generator: () => OU, __importDefault: () => WU, __importStar: () => zU, __makeTemplateObject: () => UU, __metadata: () => IU, __param: () => PU, __read: () => r3, __rest: () => AU, __spread: () => LU, __spreadArrays: () => RU, __values: () => UT });
        function kU(M, re) {
          m1(M, re);
          function Ve() {
            this.constructor = M;
          }
          M.prototype = re === null ? Object.create(re) : (Ve.prototype = re.prototype, new Ve());
        }
        function AU(M, re) {
          var Ve = {};
          for (var Ke in M)
            Object.prototype.hasOwnProperty.call(M, Ke) && re.indexOf(Ke) < 0 && (Ve[Ke] = M[Ke]);
          if (M != null && typeof Object.getOwnPropertySymbols == "function")
            for (var oi = 0, Ke = Object.getOwnPropertySymbols(M); oi < Ke.length; oi++)
              re.indexOf(Ke[oi]) < 0 && Object.prototype.propertyIsEnumerable.call(M, Ke[oi]) && (Ve[Ke[oi]] = M[Ke[oi]]);
          return Ve;
        }
        function NU(M, re, Ve, Ke) {
          var oi = arguments.length, kr = oi < 3 ? re : Ke === null ? Ke = Object.getOwnPropertyDescriptor(re, Ve) : Ke, pr;
          if (typeof Reflect == "object" && typeof Reflect.decorate == "function")
            kr = Reflect.decorate(M, re, Ve, Ke);
          else
            for (var Lr = M.length - 1; Lr >= 0; Lr--)
              (pr = M[Lr]) && (kr = (oi < 3 ? pr(kr) : oi > 3 ? pr(re, Ve, kr) : pr(re, Ve)) || kr);
          return oi > 3 && kr && Object.defineProperty(re, Ve, kr), kr;
        }
        function PU(M, re) {
          return function(Ve, Ke) {
            re(Ve, Ke, M);
          };
        }
        function IU(M, re) {
          if (typeof Reflect == "object" && typeof Reflect.metadata == "function")
            return Reflect.metadata(M, re);
        }
        function wU(M, re, Ve, Ke) {
          function oi(kr) {
            return kr instanceof Ve ? kr : new Ve(function(pr) {
              pr(kr);
            });
          }
          return new (Ve || (Ve = Promise))(function(kr, pr) {
            function Lr(e2) {
              try {
                ke(Ke.next(e2));
              } catch (a) {
                pr(a);
              }
            }
            function ar(e2) {
              try {
                ke(Ke.throw(e2));
              } catch (a) {
                pr(a);
              }
            }
            function ke(e2) {
              e2.done ? kr(e2.value) : oi(e2.value).then(Lr, ar);
            }
            ke((Ke = Ke.apply(M, re || [])).next());
          });
        }
        function OU(M, re) {
          var Ve = { label: 0, sent: function() {
            if (kr[0] & 1)
              throw kr[1];
            return kr[1];
          }, trys: [], ops: [] }, Ke, oi, kr, pr;
          return pr = { next: Lr(0), throw: Lr(1), return: Lr(2) }, typeof Symbol == "function" && (pr[Symbol.iterator] = function() {
            return this;
          }), pr;
          function Lr(ke) {
            return function(e2) {
              return ar([ke, e2]);
            };
          }
          function ar(ke) {
            if (Ke)
              throw new TypeError("Generator is already executing.");
            for (; Ve; )
              try {
                if (Ke = 1, oi && (kr = ke[0] & 2 ? oi.return : ke[0] ? oi.throw || ((kr = oi.return) && kr.call(oi), 0) : oi.next) && !(kr = kr.call(oi, ke[1])).done)
                  return kr;
                switch (oi = 0, kr && (ke = [ke[0] & 2, kr.value]), ke[0]) {
                  case 0:
                  case 1:
                    kr = ke;
                    break;
                  case 4:
                    return Ve.label++, { value: ke[1], done: false };
                  case 5:
                    Ve.label++, oi = ke[1], ke = [0];
                    continue;
                  case 7:
                    ke = Ve.ops.pop(), Ve.trys.pop();
                    continue;
                  default:
                    if (kr = Ve.trys, !(kr = kr.length > 0 && kr[kr.length - 1]) && (ke[0] === 6 || ke[0] === 2)) {
                      Ve = 0;
                      continue;
                    }
                    if (ke[0] === 3 && (!kr || ke[1] > kr[0] && ke[1] < kr[3])) {
                      Ve.label = ke[1];
                      break;
                    }
                    if (ke[0] === 6 && Ve.label < kr[1]) {
                      Ve.label = kr[1], kr = ke;
                      break;
                    }
                    if (kr && Ve.label < kr[2]) {
                      Ve.label = kr[2], Ve.ops.push(ke);
                      break;
                    }
                    kr[2] && Ve.ops.pop(), Ve.trys.pop();
                    continue;
                }
                ke = re.call(M, Ve);
              } catch (e2) {
                ke = [6, e2], oi = 0;
              } finally {
                Ke = kr = 0;
              }
            if (ke[0] & 5)
              throw ke[1];
            return { value: ke[0] ? ke[1] : void 0, done: true };
          }
        }
        function FU(M, re, Ve, Ke) {
          Ke === void 0 && (Ke = Ve), M[Ke] = re[Ve];
        }
        function MU(M, re) {
          for (var Ve in M)
            Ve !== "default" && !re.hasOwnProperty(Ve) && (re[Ve] = M[Ve]);
        }
        function UT(M) {
          var re = typeof Symbol == "function" && Symbol.iterator, Ve = re && M[re], Ke = 0;
          if (Ve)
            return Ve.call(M);
          if (M && typeof M.length == "number")
            return { next: function() {
              return M && Ke >= M.length && (M = void 0), { value: M && M[Ke++], done: !M };
            } };
          throw new TypeError(re ? "Object is not iterable." : "Symbol.iterator is not defined.");
        }
        function r3(M, re) {
          var Ve = typeof Symbol == "function" && M[Symbol.iterator];
          if (!Ve)
            return M;
          var Ke = Ve.call(M), oi, kr = [], pr;
          try {
            for (; (re === void 0 || re-- > 0) && !(oi = Ke.next()).done; )
              kr.push(oi.value);
          } catch (Lr) {
            pr = { error: Lr };
          } finally {
            try {
              oi && !oi.done && (Ve = Ke.return) && Ve.call(Ke);
            } finally {
              if (pr)
                throw pr.error;
            }
          }
          return kr;
        }
        function LU() {
          for (var M = [], re = 0; re < arguments.length; re++)
            M = M.concat(r3(arguments[re]));
          return M;
        }
        function RU() {
          for (var M = 0, re = 0, Ve = arguments.length; re < Ve; re++)
            M += arguments[re].length;
          for (var Ke = Array(M), oi = 0, re = 0; re < Ve; re++)
            for (var kr = arguments[re], pr = 0, Lr = kr.length; pr < Lr; pr++, oi++)
              Ke[oi] = kr[pr];
          return Ke;
        }
        function Xy(M) {
          return this instanceof Xy ? (this.v = M, this) : new Xy(M);
        }
        function BU(M, re, Ve) {
          if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
          var Ke = Ve.apply(M, re || []), oi, kr = [];
          return oi = {}, pr("next"), pr("throw"), pr("return"), oi[Symbol.asyncIterator] = function() {
            return this;
          }, oi;
          function pr(C) {
            Ke[C] && (oi[C] = function(w) {
              return new Promise(function(B, E) {
                kr.push([C, w, B, E]) > 1 || Lr(C, w);
              });
            });
          }
          function Lr(C, w) {
            try {
              ar(Ke[C](w));
            } catch (B) {
              a(kr[0][3], B);
            }
          }
          function ar(C) {
            C.value instanceof Xy ? Promise.resolve(C.value.v).then(ke, e2) : a(kr[0][2], C);
          }
          function ke(C) {
            Lr("next", C);
          }
          function e2(C) {
            Lr("throw", C);
          }
          function a(C, w) {
            C(w), kr.shift(), kr.length && Lr(kr[0][0], kr[0][1]);
          }
        }
        function JU(M) {
          var re, Ve;
          return re = {}, Ke("next"), Ke("throw", function(oi) {
            throw oi;
          }), Ke("return"), re[Symbol.iterator] = function() {
            return this;
          }, re;
          function Ke(oi, kr) {
            re[oi] = M[oi] ? function(pr) {
              return (Ve = !Ve) ? { value: Xy(M[oi](pr)), done: oi === "return" } : kr ? kr(pr) : pr;
            } : kr;
          }
        }
        function jU(M) {
          if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
          var re = M[Symbol.asyncIterator], Ve;
          return re ? re.call(M) : (M = typeof UT == "function" ? UT(M) : M[Symbol.iterator](), Ve = {}, Ke("next"), Ke("throw"), Ke("return"), Ve[Symbol.asyncIterator] = function() {
            return this;
          }, Ve);
          function Ke(kr) {
            Ve[kr] = M[kr] && function(pr) {
              return new Promise(function(Lr, ar) {
                pr = M[kr](pr), oi(Lr, ar, pr.done, pr.value);
              });
            };
          }
          function oi(kr, pr, Lr, ar) {
            Promise.resolve(ar).then(function(ke) {
              kr({ value: ke, done: Lr });
            }, pr);
          }
        }
        function UU(M, re) {
          return Object.defineProperty ? Object.defineProperty(M, "raw", { value: re }) : M.raw = re, M;
        }
        function zU(M) {
          if (M && M.__esModule)
            return M;
          var re = {};
          if (M != null)
            for (var Ve in M)
              Object.hasOwnProperty.call(M, Ve) && (re[Ve] = M[Ve]);
          return re.default = M, re;
        }
        function WU(M) {
          return M && M.__esModule ? M : { default: M };
        }
        function qU(M, re) {
          if (!re.has(M))
            throw new TypeError("attempted to get private field on non-instance");
          return re.get(M);
        }
        function VU(M, re, Ve) {
          if (!re.has(M))
            throw new TypeError("attempted to set private field on non-instance");
          return re.set(M, Ve), Ve;
        }
        var m1, v1, ug = Qy({ "node_modules/tslib/tslib.es6.js"() {
          Ea(), m1 = function(M, re) {
            return m1 = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(Ve, Ke) {
              Ve.__proto__ = Ke;
            } || function(Ve, Ke) {
              for (var oi in Ke)
                Ke.hasOwnProperty(oi) && (Ve[oi] = Ke[oi]);
            }, m1(M, re);
          }, v1 = function() {
            return v1 = Object.assign || function(re) {
              for (var Ve, Ke = 1, oi = arguments.length; Ke < oi; Ke++) {
                Ve = arguments[Ke];
                for (var kr in Ve)
                  Object.prototype.hasOwnProperty.call(Ve, kr) && (re[kr] = Ve[kr]);
              }
              return re;
            }, v1.apply(this, arguments);
          };
        } }), KU = Oa({ "node_modules/tsutils/typeguard/2.8/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isExpressionStatement = M.isExpression = M.isExportSpecifier = M.isExportDeclaration = M.isExportAssignment = M.isEnumMember = M.isEnumDeclaration = M.isEntityNameExpression = M.isEntityName = M.isEmptyStatement = M.isElementAccessExpression = M.isDoStatement = M.isDeleteExpression = M.isDefaultClause = M.isDecorator = M.isDebuggerStatement = M.isComputedPropertyName = M.isContinueStatement = M.isConstructSignatureDeclaration = M.isConstructorTypeNode = M.isConstructorDeclaration = M.isConditionalTypeNode = M.isConditionalExpression = M.isCommaListExpression = M.isClassLikeDeclaration = M.isClassExpression = M.isClassDeclaration = M.isCatchClause = M.isCaseOrDefaultClause = M.isCaseClause = M.isCaseBlock = M.isCallSignatureDeclaration = M.isCallLikeExpression = M.isCallExpression = M.isBreakStatement = M.isBreakOrContinueStatement = M.isBooleanLiteral = M.isBlockLike = M.isBlock = M.isBindingPattern = M.isBindingElement = M.isBinaryExpression = M.isAwaitExpression = M.isAssertionExpression = M.isAsExpression = M.isArrowFunction = M.isArrayTypeNode = M.isArrayLiteralExpression = M.isArrayBindingPattern = M.isAccessorDeclaration = void 0, M.isNamespaceImport = M.isNamespaceDeclaration = M.isNamedImports = M.isNamedExports = M.isModuleDeclaration = M.isModuleBlock = M.isMethodSignature = M.isMethodDeclaration = M.isMetaProperty = M.isMappedTypeNode = M.isLiteralTypeNode = M.isLiteralExpression = M.isLabeledStatement = M.isJsxText = M.isJsxSpreadAttribute = M.isJsxSelfClosingElement = M.isJsxOpeningLikeElement = M.isJsxOpeningFragment = M.isJsxOpeningElement = M.isJsxFragment = M.isJsxExpression = M.isJsxElement = M.isJsxClosingFragment = M.isJsxClosingElement = M.isJsxAttributes = M.isJsxAttributeLike = M.isJsxAttribute = M.isJsDoc = M.isIterationStatement = M.isIntersectionTypeNode = M.isInterfaceDeclaration = M.isInferTypeNode = M.isIndexSignatureDeclaration = M.isIndexedAccessTypeNode = M.isImportSpecifier = M.isImportEqualsDeclaration = M.isImportDeclaration = M.isImportClause = M.isIfStatement = M.isIdentifier = M.isGetAccessorDeclaration = M.isFunctionTypeNode = M.isFunctionExpression = M.isFunctionDeclaration = M.isForStatement = M.isForOfStatement = M.isForInOrOfStatement = M.isForInStatement = M.isExternalModuleReference = M.isExpressionWithTypeArguments = void 0, M.isVariableStatement = M.isVariableDeclaration = M.isUnionTypeNode = M.isTypeQueryNode = M.isTypeReferenceNode = M.isTypePredicateNode = M.isTypeParameterDeclaration = M.isTypeOperatorNode = M.isTypeOfExpression = M.isTypeLiteralNode = M.isTypeAssertion = M.isTypeAliasDeclaration = M.isTupleTypeNode = M.isTryStatement = M.isThrowStatement = M.isTextualLiteral = M.isTemplateLiteral = M.isTemplateExpression = M.isTaggedTemplateExpression = M.isSyntaxList = M.isSwitchStatement = M.isStringLiteral = M.isSpreadElement = M.isSpreadAssignment = M.isSourceFile = M.isSignatureDeclaration = M.isShorthandPropertyAssignment = M.isSetAccessorDeclaration = M.isReturnStatement = M.isRegularExpressionLiteral = M.isQualifiedName = M.isPropertySignature = M.isPropertyDeclaration = M.isPropertyAssignment = M.isPropertyAccessExpression = M.isPrefixUnaryExpression = M.isPostfixUnaryExpression = M.isParenthesizedTypeNode = M.isParenthesizedExpression = M.isParameterDeclaration = M.isOmittedExpression = M.isObjectLiteralExpression = M.isObjectBindingPattern = M.isNumericOrStringLikeLiteral = M.isNumericLiteral = M.isNullLiteral = M.isNoSubstitutionTemplateLiteral = M.isNonNullExpression = M.isNewExpression = M.isNamespaceExportDeclaration = void 0, M.isWithStatement = M.isWhileStatement = M.isVoidExpression = M.isVariableDeclarationList = void 0;
          var re = _u();
          function Ve(ai) {
            return ai.kind === re.SyntaxKind.GetAccessor || ai.kind === re.SyntaxKind.SetAccessor;
          }
          M.isAccessorDeclaration = Ve;
          function Ke(ai) {
            return ai.kind === re.SyntaxKind.ArrayBindingPattern;
          }
          M.isArrayBindingPattern = Ke;
          function oi(ai) {
            return ai.kind === re.SyntaxKind.ArrayLiteralExpression;
          }
          M.isArrayLiteralExpression = oi;
          function kr(ai) {
            return ai.kind === re.SyntaxKind.ArrayType;
          }
          M.isArrayTypeNode = kr;
          function pr(ai) {
            return ai.kind === re.SyntaxKind.ArrowFunction;
          }
          M.isArrowFunction = pr;
          function Lr(ai) {
            return ai.kind === re.SyntaxKind.AsExpression;
          }
          M.isAsExpression = Lr;
          function ar(ai) {
            return ai.kind === re.SyntaxKind.AsExpression || ai.kind === re.SyntaxKind.TypeAssertionExpression;
          }
          M.isAssertionExpression = ar;
          function ke(ai) {
            return ai.kind === re.SyntaxKind.AwaitExpression;
          }
          M.isAwaitExpression = ke;
          function e2(ai) {
            return ai.kind === re.SyntaxKind.BinaryExpression;
          }
          M.isBinaryExpression = e2;
          function a(ai) {
            return ai.kind === re.SyntaxKind.BindingElement;
          }
          M.isBindingElement = a;
          function C(ai) {
            return ai.kind === re.SyntaxKind.ArrayBindingPattern || ai.kind === re.SyntaxKind.ObjectBindingPattern;
          }
          M.isBindingPattern = C;
          function w(ai) {
            return ai.kind === re.SyntaxKind.Block;
          }
          M.isBlock = w;
          function B(ai) {
            return ai.statements !== void 0;
          }
          M.isBlockLike = B;
          function E(ai) {
            return ai.kind === re.SyntaxKind.TrueKeyword || ai.kind === re.SyntaxKind.FalseKeyword;
          }
          M.isBooleanLiteral = E;
          function Q(ai) {
            return ai.kind === re.SyntaxKind.BreakStatement || ai.kind === re.SyntaxKind.ContinueStatement;
          }
          M.isBreakOrContinueStatement = Q;
          function le(ai) {
            return ai.kind === re.SyntaxKind.BreakStatement;
          }
          M.isBreakStatement = le;
          function N(ai) {
            return ai.kind === re.SyntaxKind.CallExpression;
          }
          M.isCallExpression = N;
          function p(ai) {
            switch (ai.kind) {
              case re.SyntaxKind.CallExpression:
              case re.SyntaxKind.Decorator:
              case re.SyntaxKind.JsxOpeningElement:
              case re.SyntaxKind.JsxSelfClosingElement:
              case re.SyntaxKind.NewExpression:
              case re.SyntaxKind.TaggedTemplateExpression:
                return true;
              default:
                return false;
            }
          }
          M.isCallLikeExpression = p;
          function m2(ai) {
            return ai.kind === re.SyntaxKind.CallSignature;
          }
          M.isCallSignatureDeclaration = m2;
          function G(ai) {
            return ai.kind === re.SyntaxKind.CaseBlock;
          }
          M.isCaseBlock = G;
          function oe(ai) {
            return ai.kind === re.SyntaxKind.CaseClause;
          }
          M.isCaseClause = oe;
          function f4(ai) {
            return ai.kind === re.SyntaxKind.CaseClause || ai.kind === re.SyntaxKind.DefaultClause;
          }
          M.isCaseOrDefaultClause = f4;
          function T(ai) {
            return ai.kind === re.SyntaxKind.CatchClause;
          }
          M.isCatchClause = T;
          function K(ai) {
            return ai.kind === re.SyntaxKind.ClassDeclaration;
          }
          M.isClassDeclaration = K;
          function b(ai) {
            return ai.kind === re.SyntaxKind.ClassExpression;
          }
          M.isClassExpression = b;
          function se(ai) {
            return ai.kind === re.SyntaxKind.ClassDeclaration || ai.kind === re.SyntaxKind.ClassExpression;
          }
          M.isClassLikeDeclaration = se;
          function J(ai) {
            return ai.kind === re.SyntaxKind.CommaListExpression;
          }
          M.isCommaListExpression = J;
          function ie(ai) {
            return ai.kind === re.SyntaxKind.ConditionalExpression;
          }
          M.isConditionalExpression = ie;
          function R(ai) {
            return ai.kind === re.SyntaxKind.ConditionalType;
          }
          M.isConditionalTypeNode = R;
          function q(ai) {
            return ai.kind === re.SyntaxKind.Constructor;
          }
          M.isConstructorDeclaration = q;
          function O(ai) {
            return ai.kind === re.SyntaxKind.ConstructorType;
          }
          M.isConstructorTypeNode = O;
          function ve(ai) {
            return ai.kind === re.SyntaxKind.ConstructSignature;
          }
          M.isConstructSignatureDeclaration = ve;
          function ee(ai) {
            return ai.kind === re.SyntaxKind.ContinueStatement;
          }
          M.isContinueStatement = ee;
          function he(ai) {
            return ai.kind === re.SyntaxKind.ComputedPropertyName;
          }
          M.isComputedPropertyName = he;
          function F2(ai) {
            return ai.kind === re.SyntaxKind.DebuggerStatement;
          }
          M.isDebuggerStatement = F2;
          function x2(ai) {
            return ai.kind === re.SyntaxKind.Decorator;
          }
          M.isDecorator = x2;
          function X(ai) {
            return ai.kind === re.SyntaxKind.DefaultClause;
          }
          M.isDefaultClause = X;
          function $(ai) {
            return ai.kind === re.SyntaxKind.DeleteExpression;
          }
          M.isDeleteExpression = $;
          function A2(ai) {
            return ai.kind === re.SyntaxKind.DoStatement;
          }
          M.isDoStatement = A2;
          function y(ai) {
            return ai.kind === re.SyntaxKind.ElementAccessExpression;
          }
          M.isElementAccessExpression = y;
          function V(ai) {
            return ai.kind === re.SyntaxKind.EmptyStatement;
          }
          M.isEmptyStatement = V;
          function L(ai) {
            return ai.kind === re.SyntaxKind.Identifier || Pe(ai);
          }
          M.isEntityName = L;
          function P(ai) {
            return ai.kind === re.SyntaxKind.Identifier || Ar(ai) && P(ai.expression);
          }
          M.isEntityNameExpression = P;
          function k(ai) {
            return ai.kind === re.SyntaxKind.EnumDeclaration;
          }
          M.isEnumDeclaration = k;
          function Y(ai) {
            return ai.kind === re.SyntaxKind.EnumMember;
          }
          M.isEnumMember = Y;
          function U(ai) {
            return ai.kind === re.SyntaxKind.ExportAssignment;
          }
          M.isExportAssignment = U;
          function j(ai) {
            return ai.kind === re.SyntaxKind.ExportDeclaration;
          }
          M.isExportDeclaration = j;
          function H(ai) {
            return ai.kind === re.SyntaxKind.ExportSpecifier;
          }
          M.isExportSpecifier = H;
          function I(ai) {
            switch (ai.kind) {
              case re.SyntaxKind.ArrayLiteralExpression:
              case re.SyntaxKind.ArrowFunction:
              case re.SyntaxKind.AsExpression:
              case re.SyntaxKind.AwaitExpression:
              case re.SyntaxKind.BinaryExpression:
              case re.SyntaxKind.CallExpression:
              case re.SyntaxKind.ClassExpression:
              case re.SyntaxKind.CommaListExpression:
              case re.SyntaxKind.ConditionalExpression:
              case re.SyntaxKind.DeleteExpression:
              case re.SyntaxKind.ElementAccessExpression:
              case re.SyntaxKind.FalseKeyword:
              case re.SyntaxKind.FunctionExpression:
              case re.SyntaxKind.Identifier:
              case re.SyntaxKind.JsxElement:
              case re.SyntaxKind.JsxFragment:
              case re.SyntaxKind.JsxExpression:
              case re.SyntaxKind.JsxOpeningElement:
              case re.SyntaxKind.JsxOpeningFragment:
              case re.SyntaxKind.JsxSelfClosingElement:
              case re.SyntaxKind.MetaProperty:
              case re.SyntaxKind.NewExpression:
              case re.SyntaxKind.NonNullExpression:
              case re.SyntaxKind.NoSubstitutionTemplateLiteral:
              case re.SyntaxKind.NullKeyword:
              case re.SyntaxKind.NumericLiteral:
              case re.SyntaxKind.ObjectLiteralExpression:
              case re.SyntaxKind.OmittedExpression:
              case re.SyntaxKind.ParenthesizedExpression:
              case re.SyntaxKind.PostfixUnaryExpression:
              case re.SyntaxKind.PrefixUnaryExpression:
              case re.SyntaxKind.PropertyAccessExpression:
              case re.SyntaxKind.RegularExpressionLiteral:
              case re.SyntaxKind.SpreadElement:
              case re.SyntaxKind.StringLiteral:
              case re.SyntaxKind.SuperKeyword:
              case re.SyntaxKind.TaggedTemplateExpression:
              case re.SyntaxKind.TemplateExpression:
              case re.SyntaxKind.ThisKeyword:
              case re.SyntaxKind.TrueKeyword:
              case re.SyntaxKind.TypeAssertionExpression:
              case re.SyntaxKind.TypeOfExpression:
              case re.SyntaxKind.VoidExpression:
              case re.SyntaxKind.YieldExpression:
                return true;
              default:
                return false;
            }
          }
          M.isExpression = I;
          function l(ai) {
            return ai.kind === re.SyntaxKind.ExpressionStatement;
          }
          M.isExpressionStatement = l;
          function d(ai) {
            return ai.kind === re.SyntaxKind.ExpressionWithTypeArguments;
          }
          M.isExpressionWithTypeArguments = d;
          function D(ai) {
            return ai.kind === re.SyntaxKind.ExternalModuleReference;
          }
          M.isExternalModuleReference = D;
          function fe(ai) {
            return ai.kind === re.SyntaxKind.ForInStatement;
          }
          M.isForInStatement = fe;
          function g(ai) {
            return ai.kind === re.SyntaxKind.ForOfStatement || ai.kind === re.SyntaxKind.ForInStatement;
          }
          M.isForInOrOfStatement = g;
          function ne(ai) {
            return ai.kind === re.SyntaxKind.ForOfStatement;
          }
          M.isForOfStatement = ne;
          function ue(ai) {
            return ai.kind === re.SyntaxKind.ForStatement;
          }
          M.isForStatement = ue;
          function We(ai) {
            return ai.kind === re.SyntaxKind.FunctionDeclaration;
          }
          M.isFunctionDeclaration = We;
          function Fe(ai) {
            return ai.kind === re.SyntaxKind.FunctionExpression;
          }
          M.isFunctionExpression = Fe;
          function Z2(ai) {
            return ai.kind === re.SyntaxKind.FunctionType;
          }
          M.isFunctionTypeNode = Z2;
          function Be(ai) {
            return ai.kind === re.SyntaxKind.GetAccessor;
          }
          M.isGetAccessorDeclaration = Be;
          function ge(ai) {
            return ai.kind === re.SyntaxKind.Identifier;
          }
          M.isIdentifier = ge;
          function Re(ai) {
            return ai.kind === re.SyntaxKind.IfStatement;
          }
          M.isIfStatement = Re;
          function ze(ai) {
            return ai.kind === re.SyntaxKind.ImportClause;
          }
          M.isImportClause = ze;
          function Ee(ai) {
            return ai.kind === re.SyntaxKind.ImportDeclaration;
          }
          M.isImportDeclaration = Ee;
          function He(ai) {
            return ai.kind === re.SyntaxKind.ImportEqualsDeclaration;
          }
          M.isImportEqualsDeclaration = He;
          function rr(ai) {
            return ai.kind === re.SyntaxKind.ImportSpecifier;
          }
          M.isImportSpecifier = rr;
          function Ie(ai) {
            return ai.kind === re.SyntaxKind.IndexedAccessType;
          }
          M.isIndexedAccessTypeNode = Ie;
          function _e(ai) {
            return ai.kind === re.SyntaxKind.IndexSignature;
          }
          M.isIndexSignatureDeclaration = _e;
          function we(ai) {
            return ai.kind === re.SyntaxKind.InferType;
          }
          M.isInferTypeNode = we;
          function de(ai) {
            return ai.kind === re.SyntaxKind.InterfaceDeclaration;
          }
          M.isInterfaceDeclaration = de;
          function ye(ai) {
            return ai.kind === re.SyntaxKind.IntersectionType;
          }
          M.isIntersectionTypeNode = ye;
          function Ae(ai) {
            switch (ai.kind) {
              case re.SyntaxKind.ForStatement:
              case re.SyntaxKind.ForOfStatement:
              case re.SyntaxKind.ForInStatement:
              case re.SyntaxKind.WhileStatement:
              case re.SyntaxKind.DoStatement:
                return true;
              default:
                return false;
            }
          }
          M.isIterationStatement = Ae;
          function er(ai) {
            return ai.kind === re.SyntaxKind.JSDocComment;
          }
          M.isJsDoc = er;
          function ir(ai) {
            return ai.kind === re.SyntaxKind.JsxAttribute;
          }
          M.isJsxAttribute = ir;
          function Cr(ai) {
            return ai.kind === re.SyntaxKind.JsxAttribute || ai.kind === re.SyntaxKind.JsxSpreadAttribute;
          }
          M.isJsxAttributeLike = Cr;
          function Ye(ai) {
            return ai.kind === re.SyntaxKind.JsxAttributes;
          }
          M.isJsxAttributes = Ye;
          function Br(ai) {
            return ai.kind === re.SyntaxKind.JsxClosingElement;
          }
          M.isJsxClosingElement = Br;
          function Er(ai) {
            return ai.kind === re.SyntaxKind.JsxClosingFragment;
          }
          M.isJsxClosingFragment = Er;
          function Ne(ai) {
            return ai.kind === re.SyntaxKind.JsxElement;
          }
          M.isJsxElement = Ne;
          function n(ai) {
            return ai.kind === re.SyntaxKind.JsxExpression;
          }
          M.isJsxExpression = n;
          function lr(ai) {
            return ai.kind === re.SyntaxKind.JsxFragment;
          }
          M.isJsxFragment = lr;
          function be(ai) {
            return ai.kind === re.SyntaxKind.JsxOpeningElement;
          }
          M.isJsxOpeningElement = be;
          function Ge(ai) {
            return ai.kind === re.SyntaxKind.JsxOpeningFragment;
          }
          M.isJsxOpeningFragment = Ge;
          function ur(ai) {
            return ai.kind === re.SyntaxKind.JsxOpeningElement || ai.kind === re.SyntaxKind.JsxSelfClosingElement;
          }
          M.isJsxOpeningLikeElement = ur;
          function yr(ai) {
            return ai.kind === re.SyntaxKind.JsxSelfClosingElement;
          }
          M.isJsxSelfClosingElement = yr;
          function Ir(ai) {
            return ai.kind === re.SyntaxKind.JsxSpreadAttribute;
          }
          M.isJsxSpreadAttribute = Ir;
          function wr(ai) {
            return ai.kind === re.SyntaxKind.JsxText;
          }
          M.isJsxText = wr;
          function Ur(ai) {
            return ai.kind === re.SyntaxKind.LabeledStatement;
          }
          M.isLabeledStatement = Ur;
          function ii(ai) {
            return ai.kind >= re.SyntaxKind.FirstLiteralToken && ai.kind <= re.SyntaxKind.LastLiteralToken;
          }
          M.isLiteralExpression = ii;
          function mi(ai) {
            return ai.kind === re.SyntaxKind.LiteralType;
          }
          M.isLiteralTypeNode = mi;
          function pe(ai) {
            return ai.kind === re.SyntaxKind.MappedType;
          }
          M.isMappedTypeNode = pe;
          function or(ai) {
            return ai.kind === re.SyntaxKind.MetaProperty;
          }
          M.isMetaProperty = or;
          function qr(ai) {
            return ai.kind === re.SyntaxKind.MethodDeclaration;
          }
          M.isMethodDeclaration = qr;
          function si(ai) {
            return ai.kind === re.SyntaxKind.MethodSignature;
          }
          M.isMethodSignature = si;
          function Di(ai) {
            return ai.kind === re.SyntaxKind.ModuleBlock;
          }
          M.isModuleBlock = Di;
          function wi(ai) {
            return ai.kind === re.SyntaxKind.ModuleDeclaration;
          }
          M.isModuleDeclaration = wi;
          function Xi(ai) {
            return ai.kind === re.SyntaxKind.NamedExports;
          }
          M.isNamedExports = Xi;
          function et(ai) {
            return ai.kind === re.SyntaxKind.NamedImports;
          }
          M.isNamedImports = et;
          function Gi(ai) {
            return wi(ai) && ai.name.kind === re.SyntaxKind.Identifier && ai.body !== void 0 && (ai.body.kind === re.SyntaxKind.ModuleBlock || Gi(ai.body));
          }
          M.isNamespaceDeclaration = Gi;
          function Wt(ai) {
            return ai.kind === re.SyntaxKind.NamespaceImport;
          }
          M.isNamespaceImport = Wt;
          function Zt(ai) {
            return ai.kind === re.SyntaxKind.NamespaceExportDeclaration;
          }
          M.isNamespaceExportDeclaration = Zt;
          function _r(ai) {
            return ai.kind === re.SyntaxKind.NewExpression;
          }
          M.isNewExpression = _r;
          function pi(ai) {
            return ai.kind === re.SyntaxKind.NonNullExpression;
          }
          M.isNonNullExpression = pi;
          function ae(ai) {
            return ai.kind === re.SyntaxKind.NoSubstitutionTemplateLiteral;
          }
          M.isNoSubstitutionTemplateLiteral = ae;
          function Xe(ai) {
            return ai.kind === re.SyntaxKind.NullKeyword;
          }
          M.isNullLiteral = Xe;
          function Jr(ai) {
            return ai.kind === re.SyntaxKind.NumericLiteral;
          }
          M.isNumericLiteral = Jr;
          function ti(ai) {
            switch (ai.kind) {
              case re.SyntaxKind.StringLiteral:
              case re.SyntaxKind.NumericLiteral:
              case re.SyntaxKind.NoSubstitutionTemplateLiteral:
                return true;
              default:
                return false;
            }
          }
          M.isNumericOrStringLikeLiteral = ti;
          function Ze(ai) {
            return ai.kind === re.SyntaxKind.ObjectBindingPattern;
          }
          M.isObjectBindingPattern = Ze;
          function Sr(ai) {
            return ai.kind === re.SyntaxKind.ObjectLiteralExpression;
          }
          M.isObjectLiteralExpression = Sr;
          function zr(ai) {
            return ai.kind === re.SyntaxKind.OmittedExpression;
          }
          M.isOmittedExpression = zr;
          function Wr(ai) {
            return ai.kind === re.SyntaxKind.Parameter;
          }
          M.isParameterDeclaration = Wr;
          function Je(ai) {
            return ai.kind === re.SyntaxKind.ParenthesizedExpression;
          }
          M.isParenthesizedExpression = Je;
          function xe(ai) {
            return ai.kind === re.SyntaxKind.ParenthesizedType;
          }
          M.isParenthesizedTypeNode = xe;
          function vr(ai) {
            return ai.kind === re.SyntaxKind.PostfixUnaryExpression;
          }
          M.isPostfixUnaryExpression = vr;
          function mr(ai) {
            return ai.kind === re.SyntaxKind.PrefixUnaryExpression;
          }
          M.isPrefixUnaryExpression = mr;
          function Ar(ai) {
            return ai.kind === re.SyntaxKind.PropertyAccessExpression;
          }
          M.isPropertyAccessExpression = Ar;
          function Oe(ai) {
            return ai.kind === re.SyntaxKind.PropertyAssignment;
          }
          M.isPropertyAssignment = Oe;
          function nr(ai) {
            return ai.kind === re.SyntaxKind.PropertyDeclaration;
          }
          M.isPropertyDeclaration = nr;
          function Mr(ai) {
            return ai.kind === re.SyntaxKind.PropertySignature;
          }
          M.isPropertySignature = Mr;
          function Pe(ai) {
            return ai.kind === re.SyntaxKind.QualifiedName;
          }
          M.isQualifiedName = Pe;
          function Ue(ai) {
            return ai.kind === re.SyntaxKind.RegularExpressionLiteral;
          }
          M.isRegularExpressionLiteral = Ue;
          function fr(ai) {
            return ai.kind === re.SyntaxKind.ReturnStatement;
          }
          M.isReturnStatement = fr;
          function De(ai) {
            return ai.kind === re.SyntaxKind.SetAccessor;
          }
          M.isSetAccessorDeclaration = De;
          function gr(ai) {
            return ai.kind === re.SyntaxKind.ShorthandPropertyAssignment;
          }
          M.isShorthandPropertyAssignment = gr;
          function Vr(ai) {
            return ai.parameters !== void 0;
          }
          M.isSignatureDeclaration = Vr;
          function Tr(ai) {
            return ai.kind === re.SyntaxKind.SourceFile;
          }
          M.isSourceFile = Tr;
          function vi(ai) {
            return ai.kind === re.SyntaxKind.SpreadAssignment;
          }
          M.isSpreadAssignment = vi;
          function Ui(ai) {
            return ai.kind === re.SyntaxKind.SpreadElement;
          }
          M.isSpreadElement = Ui;
          function Yi(ai) {
            return ai.kind === re.SyntaxKind.StringLiteral;
          }
          M.isStringLiteral = Yi;
          function Wi(ai) {
            return ai.kind === re.SyntaxKind.SwitchStatement;
          }
          M.isSwitchStatement = Wi;
          function ct(ai) {
            return ai.kind === re.SyntaxKind.SyntaxList;
          }
          M.isSyntaxList = ct;
          function Li(ai) {
            return ai.kind === re.SyntaxKind.TaggedTemplateExpression;
          }
          M.isTaggedTemplateExpression = Li;
          function nt(ai) {
            return ai.kind === re.SyntaxKind.TemplateExpression;
          }
          M.isTemplateExpression = nt;
          function Mt(ai) {
            return ai.kind === re.SyntaxKind.TemplateExpression || ai.kind === re.SyntaxKind.NoSubstitutionTemplateLiteral;
          }
          M.isTemplateLiteral = Mt;
          function xt(ai) {
            return ai.kind === re.SyntaxKind.StringLiteral || ai.kind === re.SyntaxKind.NoSubstitutionTemplateLiteral;
          }
          M.isTextualLiteral = xt;
          function ut(ai) {
            return ai.kind === re.SyntaxKind.ThrowStatement;
          }
          M.isThrowStatement = ut;
          function Dt(ai) {
            return ai.kind === re.SyntaxKind.TryStatement;
          }
          M.isTryStatement = Dt;
          function Rt(ai) {
            return ai.kind === re.SyntaxKind.TupleType;
          }
          M.isTupleTypeNode = Rt;
          function Ii(ai) {
            return ai.kind === re.SyntaxKind.TypeAliasDeclaration;
          }
          M.isTypeAliasDeclaration = Ii;
          function Ki(ai) {
            return ai.kind === re.SyntaxKind.TypeAssertionExpression;
          }
          M.isTypeAssertion = Ki;
          function Fi(ai) {
            return ai.kind === re.SyntaxKind.TypeLiteral;
          }
          M.isTypeLiteralNode = Fi;
          function ui(ai) {
            return ai.kind === re.SyntaxKind.TypeOfExpression;
          }
          M.isTypeOfExpression = ui;
          function Bt(ai) {
            return ai.kind === re.SyntaxKind.TypeOperator;
          }
          M.isTypeOperatorNode = Bt;
          function wt(ai) {
            return ai.kind === re.SyntaxKind.TypeParameter;
          }
          M.isTypeParameterDeclaration = wt;
          function na(ai) {
            return ai.kind === re.SyntaxKind.TypePredicate;
          }
          M.isTypePredicateNode = na;
          function Ai(ai) {
            return ai.kind === re.SyntaxKind.TypeReference;
          }
          M.isTypeReferenceNode = Ai;
          function Oi(ai) {
            return ai.kind === re.SyntaxKind.TypeQuery;
          }
          M.isTypeQueryNode = Oi;
          function ji(ai) {
            return ai.kind === re.SyntaxKind.UnionType;
          }
          M.isUnionTypeNode = ji;
          function Vi(ai) {
            return ai.kind === re.SyntaxKind.VariableDeclaration;
          }
          M.isVariableDeclaration = Vi;
          function at(ai) {
            return ai.kind === re.SyntaxKind.VariableStatement;
          }
          M.isVariableStatement = at;
          function At(ai) {
            return ai.kind === re.SyntaxKind.VariableDeclarationList;
          }
          M.isVariableDeclarationList = At;
          function ba(ai) {
            return ai.kind === re.SyntaxKind.VoidExpression;
          }
          M.isVoidExpression = ba;
          function $a(ai) {
            return ai.kind === re.SyntaxKind.WhileStatement;
          }
          M.isWhileStatement = $a;
          function Qa(ai) {
            return ai.kind === re.SyntaxKind.WithStatement;
          }
          M.isWithStatement = Qa;
        } }), GU = Oa({ "node_modules/tsutils/typeguard/2.9/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isImportTypeNode = void 0;
          var re = (ug(), mp(Ud));
          re.__exportStar(KU(), M);
          var Ve = _u();
          function Ke(oi) {
            return oi.kind === Ve.SyntaxKind.ImportType;
          }
          M.isImportTypeNode = Ke;
        } }), HU = Oa({ "node_modules/tsutils/typeguard/3.0/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isSyntheticExpression = M.isRestTypeNode = M.isOptionalTypeNode = void 0;
          var re = (ug(), mp(Ud));
          re.__exportStar(GU(), M);
          var Ve = _u();
          function Ke(pr) {
            return pr.kind === Ve.SyntaxKind.OptionalType;
          }
          M.isOptionalTypeNode = Ke;
          function oi(pr) {
            return pr.kind === Ve.SyntaxKind.RestType;
          }
          M.isRestTypeNode = oi;
          function kr(pr) {
            return pr.kind === Ve.SyntaxKind.SyntheticExpression;
          }
          M.isSyntheticExpression = kr;
        } }), i3 = Oa({ "node_modules/tsutils/typeguard/3.2/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isBigIntLiteral = void 0;
          var re = (ug(), mp(Ud));
          re.__exportStar(HU(), M);
          var Ve = _u();
          function Ke(oi) {
            return oi.kind === Ve.SyntaxKind.BigIntLiteral;
          }
          M.isBigIntLiteral = Ke;
        } }), t3 = Oa({ "node_modules/tsutils/typeguard/node.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(i3(), M);
        } }), XU = Oa({ "node_modules/tsutils/typeguard/2.8/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isUniqueESSymbolType = M.isUnionType = M.isUnionOrIntersectionType = M.isTypeVariable = M.isTypeReference = M.isTypeParameter = M.isSubstitutionType = M.isObjectType = M.isLiteralType = M.isIntersectionType = M.isInterfaceType = M.isInstantiableType = M.isIndexedAccessype = M.isIndexedAccessType = M.isGenericType = M.isEnumType = M.isConditionalType = void 0;
          var re = _u();
          function Ve(p) {
            return (p.flags & re.TypeFlags.Conditional) !== 0;
          }
          M.isConditionalType = Ve;
          function Ke(p) {
            return (p.flags & re.TypeFlags.Enum) !== 0;
          }
          M.isEnumType = Ke;
          function oi(p) {
            return (p.flags & re.TypeFlags.Object) !== 0 && (p.objectFlags & re.ObjectFlags.ClassOrInterface) !== 0 && (p.objectFlags & re.ObjectFlags.Reference) !== 0;
          }
          M.isGenericType = oi;
          function kr(p) {
            return (p.flags & re.TypeFlags.IndexedAccess) !== 0;
          }
          M.isIndexedAccessType = kr;
          function pr(p) {
            return (p.flags & re.TypeFlags.Index) !== 0;
          }
          M.isIndexedAccessype = pr;
          function Lr(p) {
            return (p.flags & re.TypeFlags.Instantiable) !== 0;
          }
          M.isInstantiableType = Lr;
          function ar(p) {
            return (p.flags & re.TypeFlags.Object) !== 0 && (p.objectFlags & re.ObjectFlags.ClassOrInterface) !== 0;
          }
          M.isInterfaceType = ar;
          function ke(p) {
            return (p.flags & re.TypeFlags.Intersection) !== 0;
          }
          M.isIntersectionType = ke;
          function e2(p) {
            return (p.flags & (re.TypeFlags.StringOrNumberLiteral | re.TypeFlags.BigIntLiteral)) !== 0;
          }
          M.isLiteralType = e2;
          function a(p) {
            return (p.flags & re.TypeFlags.Object) !== 0;
          }
          M.isObjectType = a;
          function C(p) {
            return (p.flags & re.TypeFlags.Substitution) !== 0;
          }
          M.isSubstitutionType = C;
          function w(p) {
            return (p.flags & re.TypeFlags.TypeParameter) !== 0;
          }
          M.isTypeParameter = w;
          function B(p) {
            return (p.flags & re.TypeFlags.Object) !== 0 && (p.objectFlags & re.ObjectFlags.Reference) !== 0;
          }
          M.isTypeReference = B;
          function E(p) {
            return (p.flags & re.TypeFlags.TypeVariable) !== 0;
          }
          M.isTypeVariable = E;
          function Q(p) {
            return (p.flags & re.TypeFlags.UnionOrIntersection) !== 0;
          }
          M.isUnionOrIntersectionType = Q;
          function le(p) {
            return (p.flags & re.TypeFlags.Union) !== 0;
          }
          M.isUnionType = le;
          function N(p) {
            return (p.flags & re.TypeFlags.UniqueESSymbol) !== 0;
          }
          M.isUniqueESSymbolType = N;
        } }), D4 = Oa({ "node_modules/tsutils/typeguard/2.9/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(XU(), M);
        } }), QU = Oa({ "node_modules/tsutils/typeguard/3.0/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isTupleTypeReference = M.isTupleType = void 0;
          var re = (ug(), mp(Ud));
          re.__exportStar(D4(), M);
          var Ve = _u(), Ke = D4();
          function oi(pr) {
            return (pr.flags & Ve.TypeFlags.Object && pr.objectFlags & Ve.ObjectFlags.Tuple) !== 0;
          }
          M.isTupleType = oi;
          function kr(pr) {
            return Ke.isTypeReference(pr) && oi(pr.target);
          }
          M.isTupleTypeReference = kr;
        } }), a3 = Oa({ "node_modules/tsutils/typeguard/3.2/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(QU(), M);
        } }), YU = Oa({ "node_modules/tsutils/typeguard/3.2/index.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(i3(), M), re.__exportStar(a3(), M);
        } }), $U = Oa({ "node_modules/tsutils/typeguard/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = (ug(), mp(Ud));
          re.__exportStar(a3(), M);
        } }), ZU = Oa({ "node_modules/tsutils/util/type.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.getBaseClassMemberOfClassElement = M.getIteratorYieldResultFromIteratorResult = M.getInstanceTypeOfClassLikeDeclaration = M.getConstructorTypeOfClassLikeDeclaration = M.getSymbolOfClassLikeDeclaration = M.getPropertyNameFromType = M.symbolHasReadonlyDeclaration = M.isPropertyReadonlyInType = M.getWellKnownSymbolPropertyOfType = M.getPropertyOfType = M.isBooleanLiteralType = M.isFalsyType = M.isThenableType = M.someTypePart = M.intersectionTypeParts = M.unionTypeParts = M.getCallSignaturesOfType = M.isTypeAssignableToString = M.isTypeAssignableToNumber = M.isOptionalChainingUndefinedMarkerType = M.removeOptionalChainingUndefinedMarkerType = M.removeOptionalityFromType = M.isEmptyObjectType = void 0;
          var re = _u(), Ve = $U(), Ke = n3(), oi = t3();
          function kr(F2) {
            if (Ve.isObjectType(F2) && F2.objectFlags & re.ObjectFlags.Anonymous && F2.getProperties().length === 0 && F2.getCallSignatures().length === 0 && F2.getConstructSignatures().length === 0 && F2.getStringIndexType() === void 0 && F2.getNumberIndexType() === void 0) {
              let x2 = F2.getBaseTypes();
              return x2 === void 0 || x2.every(kr);
            }
            return false;
          }
          M.isEmptyObjectType = kr;
          function pr(F2, x2) {
            if (!Lr(x2, re.TypeFlags.Undefined))
              return x2;
            let X = Lr(x2, re.TypeFlags.Null);
            return x2 = F2.getNonNullableType(x2), X ? F2.getNullableType(x2, re.TypeFlags.Null) : x2;
          }
          M.removeOptionalityFromType = pr;
          function Lr(F2, x2) {
            for (let X of B(F2))
              if (Ke.isTypeFlagSet(X, x2))
                return true;
            return false;
          }
          function ar(F2, x2) {
            if (!Ve.isUnionType(x2))
              return ke(F2, x2) ? x2.getNonNullableType() : x2;
            let X = 0, $ = false;
            for (let A2 of x2.types)
              ke(F2, A2) ? $ = true : X |= A2.flags;
            return $ ? F2.getNullableType(x2.getNonNullableType(), X) : x2;
          }
          M.removeOptionalChainingUndefinedMarkerType = ar;
          function ke(F2, x2) {
            return Ke.isTypeFlagSet(x2, re.TypeFlags.Undefined) && F2.getNullableType(x2.getNonNullableType(), re.TypeFlags.Undefined) !== x2;
          }
          M.isOptionalChainingUndefinedMarkerType = ke;
          function e2(F2, x2) {
            return C(F2, x2, re.TypeFlags.NumberLike);
          }
          M.isTypeAssignableToNumber = e2;
          function a(F2, x2) {
            return C(F2, x2, re.TypeFlags.StringLike);
          }
          M.isTypeAssignableToString = a;
          function C(F2, x2, X) {
            X |= re.TypeFlags.Any;
            let $;
            return function A2(y) {
              if (Ve.isTypeParameter(y) && y.symbol !== void 0 && y.symbol.declarations !== void 0) {
                if ($ === void 0)
                  $ = /* @__PURE__ */ new Set([y]);
                else if (!$.has(y))
                  $.add(y);
                else
                  return false;
                let V = y.symbol.declarations[0];
                return V.constraint === void 0 ? true : A2(F2.getTypeFromTypeNode(V.constraint));
              }
              return Ve.isUnionType(y) ? y.types.every(A2) : Ve.isIntersectionType(y) ? y.types.some(A2) : Ke.isTypeFlagSet(y, X);
            }(x2);
          }
          function w(F2) {
            if (Ve.isUnionType(F2)) {
              let x2 = [];
              for (let X of F2.types)
                x2.push(...w(X));
              return x2;
            }
            if (Ve.isIntersectionType(F2)) {
              let x2;
              for (let X of F2.types) {
                let $ = w(X);
                if ($.length !== 0) {
                  if (x2 !== void 0)
                    return [];
                  x2 = $;
                }
              }
              return x2 === void 0 ? [] : x2;
            }
            return F2.getCallSignatures();
          }
          M.getCallSignaturesOfType = w;
          function B(F2) {
            return Ve.isUnionType(F2) ? F2.types : [F2];
          }
          M.unionTypeParts = B;
          function E(F2) {
            return Ve.isIntersectionType(F2) ? F2.types : [F2];
          }
          M.intersectionTypeParts = E;
          function Q(F2, x2, X) {
            return x2(F2) ? F2.types.some(X) : X(F2);
          }
          M.someTypePart = Q;
          function le(F2, x2) {
            let X = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : F2.getTypeAtLocation(x2);
            for (let $ of B(F2.getApparentType(X))) {
              let A2 = $.getProperty("then");
              if (A2 === void 0)
                continue;
              let y = F2.getTypeOfSymbolAtLocation(A2, x2);
              for (let V of B(y))
                for (let L of V.getCallSignatures())
                  if (L.parameters.length !== 0 && N(F2, L.parameters[0], x2))
                    return true;
            }
            return false;
          }
          M.isThenableType = le;
          function N(F2, x2, X) {
            let $ = F2.getApparentType(F2.getTypeOfSymbolAtLocation(x2, X));
            if (x2.valueDeclaration.dotDotDotToken && ($ = $.getNumberIndexType(), $ === void 0))
              return false;
            for (let A2 of B($))
              if (A2.getCallSignatures().length !== 0)
                return true;
            return false;
          }
          function p(F2) {
            return F2.flags & (re.TypeFlags.Undefined | re.TypeFlags.Null | re.TypeFlags.Void) ? true : Ve.isLiteralType(F2) ? !F2.value : m2(F2, false);
          }
          M.isFalsyType = p;
          function m2(F2, x2) {
            return Ke.isTypeFlagSet(F2, re.TypeFlags.BooleanLiteral) && F2.intrinsicName === (x2 ? "true" : "false");
          }
          M.isBooleanLiteralType = m2;
          function G(F2, x2) {
            return x2.startsWith("__") ? F2.getProperties().find((X) => X.escapedName === x2) : F2.getProperty(x2);
          }
          M.getPropertyOfType = G;
          function oe(F2, x2, X) {
            let $ = "__@" + x2;
            for (let A2 of F2.getProperties()) {
              if (!A2.name.startsWith($))
                continue;
              let y = X.getApparentType(X.getTypeAtLocation(A2.valueDeclaration.name.expression)).symbol;
              if (A2.escapedName === f4(X, y, x2))
                return A2;
            }
          }
          M.getWellKnownSymbolPropertyOfType = oe;
          function f4(F2, x2, X) {
            let $ = x2 && F2.getTypeOfSymbolAtLocation(x2, x2.valueDeclaration).getProperty(X), A2 = $ && F2.getTypeOfSymbolAtLocation($, $.valueDeclaration);
            return A2 && Ve.isUniqueESSymbolType(A2) ? A2.escapedName : "__@" + X;
          }
          function T(F2, x2, X) {
            let $ = false, A2 = false;
            for (let y of B(F2))
              if (G(y, x2) === void 0) {
                let V = (Ke.isNumericPropertyName(x2) ? X.getIndexInfoOfType(y, re.IndexKind.Number) : void 0) || X.getIndexInfoOfType(y, re.IndexKind.String);
                if (V !== void 0 && V.isReadonly) {
                  if ($)
                    return true;
                  A2 = true;
                }
              } else {
                if (A2 || K(y, x2, X))
                  return true;
                $ = true;
              }
            return false;
          }
          M.isPropertyReadonlyInType = T;
          function K(F2, x2, X) {
            return Q(F2, Ve.isIntersectionType, ($) => {
              let A2 = G($, x2);
              if (A2 === void 0)
                return false;
              if (A2.flags & re.SymbolFlags.Transient) {
                if (/^(?:[1-9]\d*|0)$/.test(x2) && Ve.isTupleTypeReference($))
                  return $.target.readonly;
                switch (b($, x2, X)) {
                  case true:
                    return true;
                  case false:
                    return false;
                  default:
                }
              }
              return Ke.isSymbolFlagSet(A2, re.SymbolFlags.ValueModule) || se(A2, X);
            });
          }
          function b(F2, x2, X) {
            if (!Ve.isObjectType(F2) || !Ke.isObjectFlagSet(F2, re.ObjectFlags.Mapped))
              return;
            let $ = F2.symbol.declarations[0];
            return $.readonlyToken !== void 0 && !/^__@[^@]+$/.test(x2) ? $.readonlyToken.kind !== re.SyntaxKind.MinusToken : T(F2.modifiersType, x2, X);
          }
          function se(F2, x2) {
            return (F2.flags & re.SymbolFlags.Accessor) === re.SymbolFlags.GetAccessor || F2.declarations !== void 0 && F2.declarations.some((X) => Ke.isModifierFlagSet(X, re.ModifierFlags.Readonly) || oi.isVariableDeclaration(X) && Ke.isNodeFlagSet(X.parent, re.NodeFlags.Const) || oi.isCallExpression(X) && Ke.isReadonlyAssignmentDeclaration(X, x2) || oi.isEnumMember(X) || (oi.isPropertyAssignment(X) || oi.isShorthandPropertyAssignment(X)) && Ke.isInConstContext(X.parent));
          }
          M.symbolHasReadonlyDeclaration = se;
          function J(F2) {
            if (F2.flags & (re.TypeFlags.StringLiteral | re.TypeFlags.NumberLiteral)) {
              let x2 = String(F2.value);
              return { displayName: x2, symbolName: re.escapeLeadingUnderscores(x2) };
            }
            if (Ve.isUniqueESSymbolType(F2))
              return { displayName: "[".concat(F2.symbol ? "".concat(ie(F2.symbol) ? "Symbol." : "").concat(F2.symbol.name) : F2.escapedName.replace(/^__@|@\d+$/g, ""), "]"), symbolName: F2.escapedName };
          }
          M.getPropertyNameFromType = J;
          function ie(F2) {
            return Ke.isSymbolFlagSet(F2, re.SymbolFlags.Property) && F2.valueDeclaration !== void 0 && oi.isInterfaceDeclaration(F2.valueDeclaration.parent) && F2.valueDeclaration.parent.name.text === "SymbolConstructor" && R(F2.valueDeclaration.parent);
          }
          function R(F2) {
            return Ke.isNodeFlagSet(F2.parent, re.NodeFlags.GlobalAugmentation) || oi.isSourceFile(F2.parent) && !re.isExternalModule(F2.parent);
          }
          function q(F2, x2) {
            var X;
            return x2.getSymbolAtLocation((X = F2.name) !== null && X !== void 0 ? X : Ke.getChildOfKind(F2, re.SyntaxKind.ClassKeyword));
          }
          M.getSymbolOfClassLikeDeclaration = q;
          function O(F2, x2) {
            return F2.kind === re.SyntaxKind.ClassExpression ? x2.getTypeAtLocation(F2) : x2.getTypeOfSymbolAtLocation(q(F2, x2), F2);
          }
          M.getConstructorTypeOfClassLikeDeclaration = O;
          function ve(F2, x2) {
            return F2.kind === re.SyntaxKind.ClassDeclaration ? x2.getTypeAtLocation(F2) : x2.getDeclaredTypeOfSymbol(q(F2, x2));
          }
          M.getInstanceTypeOfClassLikeDeclaration = ve;
          function ee(F2, x2, X) {
            return Ve.isUnionType(F2) && F2.types.find(($) => {
              let A2 = $.getProperty("done");
              return A2 !== void 0 && m2(pr(X, X.getTypeOfSymbolAtLocation(A2, x2)), false);
            }) || F2;
          }
          M.getIteratorYieldResultFromIteratorResult = ee;
          function he(F2, x2) {
            if (!oi.isClassLikeDeclaration(F2.parent))
              return;
            let X = Ke.getBaseOfClassLikeExpression(F2.parent);
            if (X === void 0)
              return;
            let $ = Ke.getSingleLateBoundPropertyNameOfPropertyName(F2.name, x2);
            if ($ === void 0)
              return;
            let A2 = x2.getTypeAtLocation(Ke.hasModifier(F2.modifiers, re.SyntaxKind.StaticKeyword) ? X.expression : X);
            return G(A2, $.symbolName);
          }
          M.getBaseClassMemberOfClassElement = he;
        } }), n3 = Oa({ "node_modules/tsutils/util/util.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.isValidIdentifier = M.getLineBreakStyle = M.getLineRanges = M.forEachComment = M.forEachTokenWithTrivia = M.forEachToken = M.isFunctionWithBody = M.hasOwnThisReference = M.isBlockScopeBoundary = M.isFunctionScopeBoundary = M.isTypeScopeBoundary = M.isScopeBoundary = M.ScopeBoundarySelector = M.ScopeBoundary = M.isInSingleStatementContext = M.isBlockScopedDeclarationStatement = M.isBlockScopedVariableDeclaration = M.isBlockScopedVariableDeclarationList = M.getVariableDeclarationKind = M.VariableDeclarationKind = M.forEachDeclaredVariable = M.forEachDestructuringIdentifier = M.getPropertyName = M.getWrappedNodeAtPosition = M.getAstNodeAtPosition = M.commentText = M.isPositionInComment = M.getCommentAtPosition = M.getTokenAtPosition = M.getNextToken = M.getPreviousToken = M.getNextStatement = M.getPreviousStatement = M.isModifierFlagSet = M.isObjectFlagSet = M.isSymbolFlagSet = M.isTypeFlagSet = M.isNodeFlagSet = M.hasAccessModifier = M.isParameterProperty = M.hasModifier = M.getModifier = M.isThisParameter = M.isKeywordKind = M.isJsDocKind = M.isTypeNodeKind = M.isAssignmentKind = M.isNodeKind = M.isTokenKind = M.getChildOfKind = void 0, M.getBaseOfClassLikeExpression = M.hasExhaustiveCaseClauses = M.formatPseudoBigInt = M.unwrapParentheses = M.getSingleLateBoundPropertyNameOfPropertyName = M.getLateBoundPropertyNamesOfPropertyName = M.getLateBoundPropertyNames = M.getPropertyNameOfWellKnownSymbol = M.isWellKnownSymbolLiterally = M.isBindableObjectDefinePropertyCall = M.isReadonlyAssignmentDeclaration = M.isInConstContext = M.isConstAssertion = M.getTsCheckDirective = M.getCheckJsDirective = M.isAmbientModule = M.isCompilerOptionEnabled = M.isStrictCompilerOptionEnabled = M.getIIFE = M.isAmbientModuleBlock = M.isStatementInAmbientContext = M.findImportLikeNodes = M.findImports = M.ImportKind = M.parseJsDocOfNode = M.getJsDoc = M.canHaveJsDoc = M.isReassignmentTarget = M.getAccessKind = M.AccessKind = M.isExpressionValueUsed = M.getDeclarationOfBindingElement = M.hasSideEffects = M.SideEffectOptions = M.isSameLine = M.isNumericPropertyName = M.isValidJsxIdentifier = M.isValidNumericLiteral = M.isValidPropertyName = M.isValidPropertyAccess = void 0;
          var re = _u(), Ve = t3(), Ke = YU(), oi = ZU();
          function kr(ae, Xe, Jr) {
            for (let ti of ae.getChildren(Jr))
              if (ti.kind === Xe)
                return ti;
          }
          M.getChildOfKind = kr;
          function pr(ae) {
            return ae >= re.SyntaxKind.FirstToken && ae <= re.SyntaxKind.LastToken;
          }
          M.isTokenKind = pr;
          function Lr(ae) {
            return ae >= re.SyntaxKind.FirstNode;
          }
          M.isNodeKind = Lr;
          function ar(ae) {
            return ae >= re.SyntaxKind.FirstAssignment && ae <= re.SyntaxKind.LastAssignment;
          }
          M.isAssignmentKind = ar;
          function ke(ae) {
            return ae >= re.SyntaxKind.FirstTypeNode && ae <= re.SyntaxKind.LastTypeNode;
          }
          M.isTypeNodeKind = ke;
          function e2(ae) {
            return ae >= re.SyntaxKind.FirstJSDocNode && ae <= re.SyntaxKind.LastJSDocNode;
          }
          M.isJsDocKind = e2;
          function a(ae) {
            return ae >= re.SyntaxKind.FirstKeyword && ae <= re.SyntaxKind.LastKeyword;
          }
          M.isKeywordKind = a;
          function C(ae) {
            return ae.name.kind === re.SyntaxKind.Identifier && ae.name.originalKeywordKind === re.SyntaxKind.ThisKeyword;
          }
          M.isThisParameter = C;
          function w(ae, Xe) {
            if (ae.modifiers !== void 0) {
              for (let Jr of ae.modifiers)
                if (Jr.kind === Xe)
                  return Jr;
            }
          }
          M.getModifier = w;
          function B(ae) {
            if (ae === void 0)
              return false;
            for (var Xe = arguments.length, Jr = new Array(Xe > 1 ? Xe - 1 : 0), ti = 1; ti < Xe; ti++)
              Jr[ti - 1] = arguments[ti];
            for (let Ze of ae)
              if (Jr.includes(Ze.kind))
                return true;
            return false;
          }
          M.hasModifier = B;
          function E(ae) {
            return B(ae.modifiers, re.SyntaxKind.PublicKeyword, re.SyntaxKind.ProtectedKeyword, re.SyntaxKind.PrivateKeyword, re.SyntaxKind.ReadonlyKeyword);
          }
          M.isParameterProperty = E;
          function Q(ae) {
            return p(ae, re.ModifierFlags.AccessibilityModifier);
          }
          M.hasAccessModifier = Q;
          function le(ae, Xe) {
            return (ae.flags & Xe) !== 0;
          }
          M.isNodeFlagSet = le, M.isTypeFlagSet = le, M.isSymbolFlagSet = le;
          function N(ae, Xe) {
            return (ae.objectFlags & Xe) !== 0;
          }
          M.isObjectFlagSet = N;
          function p(ae, Xe) {
            return (re.getCombinedModifierFlags(ae) & Xe) !== 0;
          }
          M.isModifierFlagSet = p;
          function m2(ae) {
            let Xe = ae.parent;
            if (Ve.isBlockLike(Xe)) {
              let Jr = Xe.statements.indexOf(ae);
              if (Jr > 0)
                return Xe.statements[Jr - 1];
            }
          }
          M.getPreviousStatement = m2;
          function G(ae) {
            let Xe = ae.parent;
            if (Ve.isBlockLike(Xe)) {
              let Jr = Xe.statements.indexOf(ae);
              if (Jr < Xe.statements.length)
                return Xe.statements[Jr + 1];
            }
          }
          M.getNextStatement = G;
          function oe(ae, Xe) {
            let { pos: Jr } = ae;
            if (Jr !== 0) {
              do
                ae = ae.parent;
              while (ae.pos === Jr);
              return K(ae, Jr - 1, Xe != null ? Xe : ae.getSourceFile(), false);
            }
          }
          M.getPreviousToken = oe;
          function f4(ae, Xe) {
            if (ae.kind === re.SyntaxKind.SourceFile || ae.kind === re.SyntaxKind.EndOfFileToken)
              return;
            let Jr = ae.end;
            for (ae = ae.parent; ae.end === Jr; ) {
              if (ae.parent === void 0)
                return ae.endOfFileToken;
              ae = ae.parent;
            }
            return K(ae, Jr, Xe != null ? Xe : ae.getSourceFile(), false);
          }
          M.getNextToken = f4;
          function T(ae, Xe, Jr, ti) {
            if (!(Xe < ae.pos || Xe >= ae.end))
              return pr(ae.kind) ? ae : K(ae, Xe, Jr != null ? Jr : ae.getSourceFile(), ti === true);
          }
          M.getTokenAtPosition = T;
          function K(ae, Xe, Jr, ti) {
            if (!ti && (ae = R(ae, Xe), pr(ae.kind)))
              return ae;
            e:
              for (; ; ) {
                for (let Ze of ae.getChildren(Jr))
                  if (Ze.end > Xe && (ti || Ze.kind !== re.SyntaxKind.JSDocComment)) {
                    if (pr(Ze.kind))
                      return Ze;
                    ae = Ze;
                    continue e;
                  }
                return;
              }
          }
          function b(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae, ti = T(Jr, Xe, ae);
            if (ti === void 0 || ti.kind === re.SyntaxKind.JsxText || Xe >= ti.end - (re.tokenToString(ti.kind) || "").length)
              return;
            let Ze = ti.pos === 0 ? (re.getShebang(ae.text) || "").length : ti.pos;
            return Ze !== 0 && re.forEachTrailingCommentRange(ae.text, Ze, se, Xe) || re.forEachLeadingCommentRange(ae.text, Ze, se, Xe);
          }
          M.getCommentAtPosition = b;
          function se(ae, Xe, Jr, ti, Ze) {
            return Ze >= ae && Ze < Xe ? { pos: ae, end: Xe, kind: Jr } : void 0;
          }
          function J(ae, Xe, Jr) {
            return b(ae, Xe, Jr) !== void 0;
          }
          M.isPositionInComment = J;
          function ie(ae, Xe) {
            return ae.substring(Xe.pos + 2, Xe.kind === re.SyntaxKind.SingleLineCommentTrivia ? Xe.end : Xe.end - 2);
          }
          M.commentText = ie;
          function R(ae, Xe) {
            if (!(ae.pos > Xe || ae.end <= Xe)) {
              for (; Lr(ae.kind); ) {
                let Jr = re.forEachChild(ae, (ti) => ti.pos <= Xe && ti.end > Xe ? ti : void 0);
                if (Jr === void 0)
                  break;
                ae = Jr;
              }
              return ae;
            }
          }
          M.getAstNodeAtPosition = R;
          function q(ae, Xe) {
            if (ae.node.pos > Xe || ae.node.end <= Xe)
              return;
            e:
              for (; ; ) {
                for (let Jr of ae.children) {
                  if (Jr.node.pos > Xe)
                    return ae;
                  if (Jr.node.end > Xe) {
                    ae = Jr;
                    continue e;
                  }
                }
                return ae;
              }
          }
          M.getWrappedNodeAtPosition = q;
          function O(ae) {
            if (ae.kind === re.SyntaxKind.ComputedPropertyName) {
              let Xe = Gi(ae.expression);
              if (Ve.isPrefixUnaryExpression(Xe)) {
                let Jr = false;
                switch (Xe.operator) {
                  case re.SyntaxKind.MinusToken:
                    Jr = true;
                  case re.SyntaxKind.PlusToken:
                    return Ve.isNumericLiteral(Xe.operand) ? "".concat(Jr ? "-" : "").concat(Xe.operand.text) : Ke.isBigIntLiteral(Xe.operand) ? "".concat(Jr ? "-" : "").concat(Xe.operand.text.slice(0, -1)) : void 0;
                  default:
                    return;
                }
              }
              return Ke.isBigIntLiteral(Xe) ? Xe.text.slice(0, -1) : Ve.isNumericOrStringLikeLiteral(Xe) ? Xe.text : void 0;
            }
            return ae.kind === re.SyntaxKind.PrivateIdentifier ? void 0 : ae.text;
          }
          M.getPropertyName = O;
          function ve(ae, Xe) {
            for (let Jr of ae.elements) {
              if (Jr.kind !== re.SyntaxKind.BindingElement)
                continue;
              let ti;
              if (Jr.name.kind === re.SyntaxKind.Identifier ? ti = Xe(Jr) : ti = ve(Jr.name, Xe), ti)
                return ti;
            }
          }
          M.forEachDestructuringIdentifier = ve;
          function ee(ae, Xe) {
            for (let Jr of ae.declarations) {
              let ti;
              if (Jr.name.kind === re.SyntaxKind.Identifier ? ti = Xe(Jr) : ti = ve(Jr.name, Xe), ti)
                return ti;
            }
          }
          M.forEachDeclaredVariable = ee;
          var he;
          (function(ae) {
            ae[ae.Var = 0] = "Var", ae[ae.Let = 1] = "Let", ae[ae.Const = 2] = "Const";
          })(he = M.VariableDeclarationKind || (M.VariableDeclarationKind = {}));
          function F2(ae) {
            return ae.flags & re.NodeFlags.Let ? 1 : ae.flags & re.NodeFlags.Const ? 2 : 0;
          }
          M.getVariableDeclarationKind = F2;
          function x2(ae) {
            return (ae.flags & re.NodeFlags.BlockScoped) !== 0;
          }
          M.isBlockScopedVariableDeclarationList = x2;
          function X(ae) {
            let Xe = ae.parent;
            return Xe.kind === re.SyntaxKind.CatchClause || x2(Xe);
          }
          M.isBlockScopedVariableDeclaration = X;
          function $(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.VariableStatement:
                return x2(ae.declarationList);
              case re.SyntaxKind.ClassDeclaration:
              case re.SyntaxKind.EnumDeclaration:
              case re.SyntaxKind.InterfaceDeclaration:
              case re.SyntaxKind.TypeAliasDeclaration:
                return true;
              default:
                return false;
            }
          }
          M.isBlockScopedDeclarationStatement = $;
          function A2(ae) {
            switch (ae.parent.kind) {
              case re.SyntaxKind.ForStatement:
              case re.SyntaxKind.ForInStatement:
              case re.SyntaxKind.ForOfStatement:
              case re.SyntaxKind.WhileStatement:
              case re.SyntaxKind.DoStatement:
              case re.SyntaxKind.IfStatement:
              case re.SyntaxKind.WithStatement:
              case re.SyntaxKind.LabeledStatement:
                return true;
              default:
                return false;
            }
          }
          M.isInSingleStatementContext = A2;
          var y;
          (function(ae) {
            ae[ae.None = 0] = "None", ae[ae.Function = 1] = "Function", ae[ae.Block = 2] = "Block", ae[ae.Type = 4] = "Type", ae[ae.ConditionalType = 8] = "ConditionalType";
          })(y = M.ScopeBoundary || (M.ScopeBoundary = {}));
          var V;
          (function(ae) {
            ae[ae.Function = 1] = "Function", ae[ae.Block = 3] = "Block", ae[ae.Type = 7] = "Type", ae[ae.InferType = 8] = "InferType";
          })(V = M.ScopeBoundarySelector || (M.ScopeBoundarySelector = {}));
          function L(ae) {
            return k(ae) || Y(ae) || P(ae);
          }
          M.isScopeBoundary = L;
          function P(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.InterfaceDeclaration:
              case re.SyntaxKind.TypeAliasDeclaration:
              case re.SyntaxKind.MappedType:
                return 4;
              case re.SyntaxKind.ConditionalType:
                return 8;
              default:
                return 0;
            }
          }
          M.isTypeScopeBoundary = P;
          function k(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.FunctionExpression:
              case re.SyntaxKind.ArrowFunction:
              case re.SyntaxKind.Constructor:
              case re.SyntaxKind.ModuleDeclaration:
              case re.SyntaxKind.ClassDeclaration:
              case re.SyntaxKind.ClassExpression:
              case re.SyntaxKind.EnumDeclaration:
              case re.SyntaxKind.MethodDeclaration:
              case re.SyntaxKind.FunctionDeclaration:
              case re.SyntaxKind.GetAccessor:
              case re.SyntaxKind.SetAccessor:
              case re.SyntaxKind.MethodSignature:
              case re.SyntaxKind.CallSignature:
              case re.SyntaxKind.ConstructSignature:
              case re.SyntaxKind.ConstructorType:
              case re.SyntaxKind.FunctionType:
                return 1;
              case re.SyntaxKind.SourceFile:
                return re.isExternalModule(ae) ? 1 : 0;
              default:
                return 0;
            }
          }
          M.isFunctionScopeBoundary = k;
          function Y(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.Block:
                let Xe = ae.parent;
                return Xe.kind !== re.SyntaxKind.CatchClause && (Xe.kind === re.SyntaxKind.SourceFile || !k(Xe)) ? 2 : 0;
              case re.SyntaxKind.ForStatement:
              case re.SyntaxKind.ForInStatement:
              case re.SyntaxKind.ForOfStatement:
              case re.SyntaxKind.CaseBlock:
              case re.SyntaxKind.CatchClause:
              case re.SyntaxKind.WithStatement:
                return 2;
              default:
                return 0;
            }
          }
          M.isBlockScopeBoundary = Y;
          function U(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.ClassDeclaration:
              case re.SyntaxKind.ClassExpression:
              case re.SyntaxKind.FunctionExpression:
                return true;
              case re.SyntaxKind.FunctionDeclaration:
                return ae.body !== void 0;
              case re.SyntaxKind.MethodDeclaration:
              case re.SyntaxKind.GetAccessor:
              case re.SyntaxKind.SetAccessor:
                return ae.parent.kind === re.SyntaxKind.ObjectLiteralExpression;
              default:
                return false;
            }
          }
          M.hasOwnThisReference = U;
          function j(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.GetAccessor:
              case re.SyntaxKind.SetAccessor:
              case re.SyntaxKind.FunctionDeclaration:
              case re.SyntaxKind.MethodDeclaration:
              case re.SyntaxKind.Constructor:
                return ae.body !== void 0;
              case re.SyntaxKind.FunctionExpression:
              case re.SyntaxKind.ArrowFunction:
                return true;
              default:
                return false;
            }
          }
          M.isFunctionWithBody = j;
          function H(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae.getSourceFile(), ti = [];
            for (; ; ) {
              if (pr(ae.kind))
                Xe(ae);
              else if (ae.kind !== re.SyntaxKind.JSDocComment) {
                let Ze = ae.getChildren(Jr);
                if (Ze.length === 1) {
                  ae = Ze[0];
                  continue;
                }
                for (let Sr = Ze.length - 1; Sr >= 0; --Sr)
                  ti.push(Ze[Sr]);
              }
              if (ti.length === 0)
                break;
              ae = ti.pop();
            }
          }
          M.forEachToken = H;
          function I(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae.getSourceFile(), ti = Jr.text, Ze = re.createScanner(Jr.languageVersion, false, Jr.languageVariant, ti);
            return H(ae, (Sr) => {
              let zr = Sr.kind === re.SyntaxKind.JsxText || Sr.pos === Sr.end ? Sr.pos : Sr.getStart(Jr);
              if (zr !== Sr.pos) {
                Ze.setTextPos(Sr.pos);
                let Wr = Ze.scan(), Je = Ze.getTokenPos();
                for (; Je < zr; ) {
                  let xe = Ze.getTextPos();
                  if (Xe(ti, Wr, { pos: Je, end: xe }, Sr.parent), xe === zr)
                    break;
                  Wr = Ze.scan(), Je = Ze.getTokenPos();
                }
              }
              return Xe(ti, Sr.kind, { end: Sr.end, pos: zr }, Sr.parent);
            }, Jr);
          }
          M.forEachTokenWithTrivia = I;
          function l(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae.getSourceFile(), ti = Jr.text, Ze = Jr.languageVariant !== re.LanguageVariant.JSX;
            return H(ae, (zr) => {
              if (zr.pos !== zr.end && (zr.kind !== re.SyntaxKind.JsxText && re.forEachLeadingCommentRange(ti, zr.pos === 0 ? (re.getShebang(ti) || "").length : zr.pos, Sr), Ze || d(zr)))
                return re.forEachTrailingCommentRange(ti, zr.end, Sr);
            }, Jr);
            function Sr(zr, Wr, Je) {
              Xe(ti, { pos: zr, end: Wr, kind: Je });
            }
          }
          M.forEachComment = l;
          function d(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.CloseBraceToken:
                return ae.parent.kind !== re.SyntaxKind.JsxExpression || !D(ae.parent.parent);
              case re.SyntaxKind.GreaterThanToken:
                switch (ae.parent.kind) {
                  case re.SyntaxKind.JsxOpeningElement:
                    return ae.end !== ae.parent.end;
                  case re.SyntaxKind.JsxOpeningFragment:
                    return false;
                  case re.SyntaxKind.JsxSelfClosingElement:
                    return ae.end !== ae.parent.end || !D(ae.parent.parent);
                  case re.SyntaxKind.JsxClosingElement:
                  case re.SyntaxKind.JsxClosingFragment:
                    return !D(ae.parent.parent.parent);
                }
            }
            return true;
          }
          function D(ae) {
            return ae.kind === re.SyntaxKind.JsxElement || ae.kind === re.SyntaxKind.JsxFragment;
          }
          function fe(ae) {
            let Xe = ae.getLineStarts(), Jr = [], ti = Xe.length, Ze = ae.text, Sr = 0;
            for (let zr = 1; zr < ti; ++zr) {
              let Wr = Xe[zr], Je = Wr;
              for (; Je > Sr && re.isLineBreak(Ze.charCodeAt(Je - 1)); --Je)
                ;
              Jr.push({ pos: Sr, end: Wr, contentLength: Je - Sr }), Sr = Wr;
            }
            return Jr.push({ pos: Sr, end: ae.end, contentLength: ae.end - Sr }), Jr;
          }
          M.getLineRanges = fe;
          function g(ae) {
            let Xe = ae.getLineStarts();
            return Xe.length === 1 || Xe[1] < 2 || ae.text[Xe[1] - 2] !== "\r" ? `
` : `\r
`;
          }
          M.getLineBreakStyle = g;
          var ne;
          function ue(ae, Xe) {
            return ne === void 0 ? ne = re.createScanner(Xe, false, void 0, ae) : (ne.setScriptTarget(Xe), ne.setText(ae)), ne.scan(), ne;
          }
          function We(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest, Jr = ue(ae, Xe);
            return Jr.isIdentifier() && Jr.getTextPos() === ae.length && Jr.getTokenPos() === 0;
          }
          M.isValidIdentifier = We;
          function Fe(ae) {
            return ae >= 65536 ? 2 : 1;
          }
          function Z2(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest;
            if (ae.length === 0)
              return false;
            let Jr = ae.codePointAt(0);
            if (!re.isIdentifierStart(Jr, Xe))
              return false;
            for (let ti = Fe(Jr); ti < ae.length; ti += Fe(Jr))
              if (Jr = ae.codePointAt(ti), !re.isIdentifierPart(Jr, Xe))
                return false;
            return true;
          }
          M.isValidPropertyAccess = Z2;
          function Be(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest;
            if (Z2(ae, Xe))
              return true;
            let Jr = ue(ae, Xe);
            return Jr.getTextPos() === ae.length && Jr.getToken() === re.SyntaxKind.NumericLiteral && Jr.getTokenValue() === ae;
          }
          M.isValidPropertyName = Be;
          function ge(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest, Jr = ue(ae, Xe);
            return Jr.getToken() === re.SyntaxKind.NumericLiteral && Jr.getTextPos() === ae.length && Jr.getTokenPos() === 0;
          }
          M.isValidNumericLiteral = ge;
          function Re(ae) {
            let Xe = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : re.ScriptTarget.Latest;
            if (ae.length === 0)
              return false;
            let Jr = false, ti = ae.codePointAt(0);
            if (!re.isIdentifierStart(ti, Xe))
              return false;
            for (let Ze = Fe(ti); Ze < ae.length; Ze += Fe(ti))
              if (ti = ae.codePointAt(Ze), !re.isIdentifierPart(ti, Xe) && ti !== 45)
                if (!Jr && ti === 58 && Ze + Fe(ti) !== ae.length)
                  Jr = true;
                else
                  return false;
            return true;
          }
          M.isValidJsxIdentifier = Re;
          function ze(ae) {
            return String(+ae) === ae;
          }
          M.isNumericPropertyName = ze;
          function Ee(ae, Xe, Jr) {
            return re.getLineAndCharacterOfPosition(ae, Xe).line === re.getLineAndCharacterOfPosition(ae, Jr).line;
          }
          M.isSameLine = Ee;
          var He;
          (function(ae) {
            ae[ae.None = 0] = "None", ae[ae.TaggedTemplate = 1] = "TaggedTemplate", ae[ae.Constructor = 2] = "Constructor", ae[ae.JsxElement = 4] = "JsxElement";
          })(He = M.SideEffectOptions || (M.SideEffectOptions = {}));
          function rr(ae, Xe) {
            var Jr, ti;
            let Ze = [];
            for (; ; ) {
              switch (ae.kind) {
                case re.SyntaxKind.CallExpression:
                case re.SyntaxKind.PostfixUnaryExpression:
                case re.SyntaxKind.AwaitExpression:
                case re.SyntaxKind.YieldExpression:
                case re.SyntaxKind.DeleteExpression:
                  return true;
                case re.SyntaxKind.TypeAssertionExpression:
                case re.SyntaxKind.AsExpression:
                case re.SyntaxKind.ParenthesizedExpression:
                case re.SyntaxKind.NonNullExpression:
                case re.SyntaxKind.VoidExpression:
                case re.SyntaxKind.TypeOfExpression:
                case re.SyntaxKind.PropertyAccessExpression:
                case re.SyntaxKind.SpreadElement:
                case re.SyntaxKind.PartiallyEmittedExpression:
                  ae = ae.expression;
                  continue;
                case re.SyntaxKind.BinaryExpression:
                  if (ar(ae.operatorToken.kind))
                    return true;
                  Ze.push(ae.right), ae = ae.left;
                  continue;
                case re.SyntaxKind.PrefixUnaryExpression:
                  switch (ae.operator) {
                    case re.SyntaxKind.PlusPlusToken:
                    case re.SyntaxKind.MinusMinusToken:
                      return true;
                    default:
                      ae = ae.operand;
                      continue;
                  }
                case re.SyntaxKind.ElementAccessExpression:
                  ae.argumentExpression !== void 0 && Ze.push(ae.argumentExpression), ae = ae.expression;
                  continue;
                case re.SyntaxKind.ConditionalExpression:
                  Ze.push(ae.whenTrue, ae.whenFalse), ae = ae.condition;
                  continue;
                case re.SyntaxKind.NewExpression:
                  if (Xe & 2)
                    return true;
                  ae.arguments !== void 0 && Ze.push(...ae.arguments), ae = ae.expression;
                  continue;
                case re.SyntaxKind.TaggedTemplateExpression:
                  if (Xe & 1)
                    return true;
                  if (Ze.push(ae.tag), ae = ae.template, ae.kind === re.SyntaxKind.NoSubstitutionTemplateLiteral)
                    break;
                case re.SyntaxKind.TemplateExpression:
                  for (let Sr of ae.templateSpans)
                    Ze.push(Sr.expression);
                  break;
                case re.SyntaxKind.ClassExpression: {
                  if (ae.decorators !== void 0)
                    return true;
                  for (let zr of ae.members) {
                    if (zr.decorators !== void 0)
                      return true;
                    if (!B(zr.modifiers, re.SyntaxKind.DeclareKeyword))
                      if (((Jr = zr.name) === null || Jr === void 0 ? void 0 : Jr.kind) === re.SyntaxKind.ComputedPropertyName && Ze.push(zr.name.expression), Ve.isMethodDeclaration(zr)) {
                        for (let Wr of zr.parameters)
                          if (Wr.decorators !== void 0)
                            return true;
                      } else
                        Ve.isPropertyDeclaration(zr) && zr.initializer !== void 0 && B(zr.modifiers, re.SyntaxKind.StaticKeyword) && Ze.push(zr.initializer);
                  }
                  let Sr = pi(ae);
                  if (Sr === void 0)
                    break;
                  ae = Sr.expression;
                  continue;
                }
                case re.SyntaxKind.ArrayLiteralExpression:
                  Ze.push(...ae.elements);
                  break;
                case re.SyntaxKind.ObjectLiteralExpression:
                  for (let Sr of ae.properties)
                    switch (((ti = Sr.name) === null || ti === void 0 ? void 0 : ti.kind) === re.SyntaxKind.ComputedPropertyName && Ze.push(Sr.name.expression), Sr.kind) {
                      case re.SyntaxKind.PropertyAssignment:
                        Ze.push(Sr.initializer);
                        break;
                      case re.SyntaxKind.SpreadAssignment:
                        Ze.push(Sr.expression);
                    }
                  break;
                case re.SyntaxKind.JsxExpression:
                  if (ae.expression === void 0)
                    break;
                  ae = ae.expression;
                  continue;
                case re.SyntaxKind.JsxElement:
                case re.SyntaxKind.JsxFragment:
                  for (let Sr of ae.children)
                    Sr.kind !== re.SyntaxKind.JsxText && Ze.push(Sr);
                  if (ae.kind === re.SyntaxKind.JsxFragment)
                    break;
                  ae = ae.openingElement;
                case re.SyntaxKind.JsxSelfClosingElement:
                case re.SyntaxKind.JsxOpeningElement:
                  if (Xe & 4)
                    return true;
                  for (let Sr of ae.attributes.properties)
                    Sr.kind === re.SyntaxKind.JsxSpreadAttribute ? Ze.push(Sr.expression) : Sr.initializer !== void 0 && Ze.push(Sr.initializer);
                  break;
                case re.SyntaxKind.CommaListExpression:
                  Ze.push(...ae.elements);
              }
              if (Ze.length === 0)
                return false;
              ae = Ze.pop();
            }
          }
          M.hasSideEffects = rr;
          function Ie(ae) {
            let Xe = ae.parent.parent;
            for (; Xe.kind === re.SyntaxKind.BindingElement; )
              Xe = Xe.parent.parent;
            return Xe;
          }
          M.getDeclarationOfBindingElement = Ie;
          function _e(ae) {
            for (; ; ) {
              let Xe = ae.parent;
              switch (Xe.kind) {
                case re.SyntaxKind.CallExpression:
                case re.SyntaxKind.NewExpression:
                case re.SyntaxKind.ElementAccessExpression:
                case re.SyntaxKind.WhileStatement:
                case re.SyntaxKind.DoStatement:
                case re.SyntaxKind.WithStatement:
                case re.SyntaxKind.ThrowStatement:
                case re.SyntaxKind.ReturnStatement:
                case re.SyntaxKind.JsxExpression:
                case re.SyntaxKind.JsxSpreadAttribute:
                case re.SyntaxKind.JsxElement:
                case re.SyntaxKind.JsxFragment:
                case re.SyntaxKind.JsxSelfClosingElement:
                case re.SyntaxKind.ComputedPropertyName:
                case re.SyntaxKind.ArrowFunction:
                case re.SyntaxKind.ExportSpecifier:
                case re.SyntaxKind.ExportAssignment:
                case re.SyntaxKind.ImportDeclaration:
                case re.SyntaxKind.ExternalModuleReference:
                case re.SyntaxKind.Decorator:
                case re.SyntaxKind.TaggedTemplateExpression:
                case re.SyntaxKind.TemplateSpan:
                case re.SyntaxKind.ExpressionWithTypeArguments:
                case re.SyntaxKind.TypeOfExpression:
                case re.SyntaxKind.AwaitExpression:
                case re.SyntaxKind.YieldExpression:
                case re.SyntaxKind.LiteralType:
                case re.SyntaxKind.JsxAttributes:
                case re.SyntaxKind.JsxOpeningElement:
                case re.SyntaxKind.JsxClosingElement:
                case re.SyntaxKind.IfStatement:
                case re.SyntaxKind.CaseClause:
                case re.SyntaxKind.SwitchStatement:
                  return true;
                case re.SyntaxKind.PropertyAccessExpression:
                  return Xe.expression === ae;
                case re.SyntaxKind.QualifiedName:
                  return Xe.left === ae;
                case re.SyntaxKind.ShorthandPropertyAssignment:
                  return Xe.objectAssignmentInitializer === ae || !we(Xe);
                case re.SyntaxKind.PropertyAssignment:
                  return Xe.initializer === ae && !we(Xe);
                case re.SyntaxKind.SpreadAssignment:
                case re.SyntaxKind.SpreadElement:
                case re.SyntaxKind.ArrayLiteralExpression:
                  return !we(Xe);
                case re.SyntaxKind.ParenthesizedExpression:
                case re.SyntaxKind.AsExpression:
                case re.SyntaxKind.TypeAssertionExpression:
                case re.SyntaxKind.PostfixUnaryExpression:
                case re.SyntaxKind.PrefixUnaryExpression:
                case re.SyntaxKind.NonNullExpression:
                  ae = Xe;
                  continue;
                case re.SyntaxKind.ForStatement:
                  return Xe.condition === ae;
                case re.SyntaxKind.ForInStatement:
                case re.SyntaxKind.ForOfStatement:
                  return Xe.expression === ae;
                case re.SyntaxKind.ConditionalExpression:
                  if (Xe.condition === ae)
                    return true;
                  ae = Xe;
                  break;
                case re.SyntaxKind.PropertyDeclaration:
                case re.SyntaxKind.BindingElement:
                case re.SyntaxKind.VariableDeclaration:
                case re.SyntaxKind.Parameter:
                case re.SyntaxKind.EnumMember:
                  return Xe.initializer === ae;
                case re.SyntaxKind.ImportEqualsDeclaration:
                  return Xe.moduleReference === ae;
                case re.SyntaxKind.CommaListExpression:
                  if (Xe.elements[Xe.elements.length - 1] !== ae)
                    return false;
                  ae = Xe;
                  break;
                case re.SyntaxKind.BinaryExpression:
                  if (Xe.right === ae) {
                    if (Xe.operatorToken.kind === re.SyntaxKind.CommaToken) {
                      ae = Xe;
                      break;
                    }
                    return true;
                  }
                  switch (Xe.operatorToken.kind) {
                    case re.SyntaxKind.CommaToken:
                    case re.SyntaxKind.EqualsToken:
                      return false;
                    case re.SyntaxKind.EqualsEqualsEqualsToken:
                    case re.SyntaxKind.EqualsEqualsToken:
                    case re.SyntaxKind.ExclamationEqualsEqualsToken:
                    case re.SyntaxKind.ExclamationEqualsToken:
                    case re.SyntaxKind.InstanceOfKeyword:
                    case re.SyntaxKind.PlusToken:
                    case re.SyntaxKind.MinusToken:
                    case re.SyntaxKind.AsteriskToken:
                    case re.SyntaxKind.SlashToken:
                    case re.SyntaxKind.PercentToken:
                    case re.SyntaxKind.AsteriskAsteriskToken:
                    case re.SyntaxKind.GreaterThanToken:
                    case re.SyntaxKind.GreaterThanGreaterThanToken:
                    case re.SyntaxKind.GreaterThanGreaterThanGreaterThanToken:
                    case re.SyntaxKind.GreaterThanEqualsToken:
                    case re.SyntaxKind.LessThanToken:
                    case re.SyntaxKind.LessThanLessThanToken:
                    case re.SyntaxKind.LessThanEqualsToken:
                    case re.SyntaxKind.AmpersandToken:
                    case re.SyntaxKind.BarToken:
                    case re.SyntaxKind.CaretToken:
                    case re.SyntaxKind.BarBarToken:
                    case re.SyntaxKind.AmpersandAmpersandToken:
                    case re.SyntaxKind.QuestionQuestionToken:
                    case re.SyntaxKind.InKeyword:
                    case re.SyntaxKind.QuestionQuestionEqualsToken:
                    case re.SyntaxKind.AmpersandAmpersandEqualsToken:
                    case re.SyntaxKind.BarBarEqualsToken:
                      return true;
                    default:
                      ae = Xe;
                  }
                  break;
                default:
                  return false;
              }
            }
          }
          M.isExpressionValueUsed = _e;
          function we(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.ShorthandPropertyAssignment:
                if (ae.objectAssignmentInitializer !== void 0)
                  return true;
              case re.SyntaxKind.PropertyAssignment:
              case re.SyntaxKind.SpreadAssignment:
                ae = ae.parent;
                break;
              case re.SyntaxKind.SpreadElement:
                if (ae.parent.kind !== re.SyntaxKind.ArrayLiteralExpression)
                  return false;
                ae = ae.parent;
            }
            for (; ; )
              switch (ae.parent.kind) {
                case re.SyntaxKind.BinaryExpression:
                  return ae.parent.left === ae && ae.parent.operatorToken.kind === re.SyntaxKind.EqualsToken;
                case re.SyntaxKind.ForOfStatement:
                  return ae.parent.initializer === ae;
                case re.SyntaxKind.ArrayLiteralExpression:
                case re.SyntaxKind.ObjectLiteralExpression:
                  ae = ae.parent;
                  break;
                case re.SyntaxKind.SpreadAssignment:
                case re.SyntaxKind.PropertyAssignment:
                  ae = ae.parent.parent;
                  break;
                case re.SyntaxKind.SpreadElement:
                  if (ae.parent.parent.kind !== re.SyntaxKind.ArrayLiteralExpression)
                    return false;
                  ae = ae.parent.parent;
                  break;
                default:
                  return false;
              }
          }
          var de;
          (function(ae) {
            ae[ae.None = 0] = "None", ae[ae.Read = 1] = "Read", ae[ae.Write = 2] = "Write", ae[ae.Delete = 4] = "Delete", ae[ae.ReadWrite = 3] = "ReadWrite", ae[ae.Modification = 6] = "Modification";
          })(de = M.AccessKind || (M.AccessKind = {}));
          function ye(ae) {
            let Xe = ae.parent;
            switch (Xe.kind) {
              case re.SyntaxKind.DeleteExpression:
                return 4;
              case re.SyntaxKind.PostfixUnaryExpression:
                return 3;
              case re.SyntaxKind.PrefixUnaryExpression:
                return Xe.operator === re.SyntaxKind.PlusPlusToken || Xe.operator === re.SyntaxKind.MinusMinusToken ? 3 : 1;
              case re.SyntaxKind.BinaryExpression:
                return Xe.right === ae ? 1 : ar(Xe.operatorToken.kind) ? Xe.operatorToken.kind === re.SyntaxKind.EqualsToken ? 2 : 3 : 1;
              case re.SyntaxKind.ShorthandPropertyAssignment:
                return Xe.objectAssignmentInitializer === ae ? 1 : we(Xe) ? 2 : 1;
              case re.SyntaxKind.PropertyAssignment:
                return Xe.name === ae ? 0 : we(Xe) ? 2 : 1;
              case re.SyntaxKind.ArrayLiteralExpression:
              case re.SyntaxKind.SpreadElement:
              case re.SyntaxKind.SpreadAssignment:
                return we(Xe) ? 2 : 1;
              case re.SyntaxKind.ParenthesizedExpression:
              case re.SyntaxKind.NonNullExpression:
              case re.SyntaxKind.TypeAssertionExpression:
              case re.SyntaxKind.AsExpression:
                return ye(Xe);
              case re.SyntaxKind.ForOfStatement:
              case re.SyntaxKind.ForInStatement:
                return Xe.initializer === ae ? 2 : 1;
              case re.SyntaxKind.ExpressionWithTypeArguments:
                return Xe.parent.token === re.SyntaxKind.ExtendsKeyword && Xe.parent.parent.kind !== re.SyntaxKind.InterfaceDeclaration ? 1 : 0;
              case re.SyntaxKind.ComputedPropertyName:
              case re.SyntaxKind.ExpressionStatement:
              case re.SyntaxKind.TypeOfExpression:
              case re.SyntaxKind.ElementAccessExpression:
              case re.SyntaxKind.ForStatement:
              case re.SyntaxKind.IfStatement:
              case re.SyntaxKind.DoStatement:
              case re.SyntaxKind.WhileStatement:
              case re.SyntaxKind.SwitchStatement:
              case re.SyntaxKind.WithStatement:
              case re.SyntaxKind.ThrowStatement:
              case re.SyntaxKind.CallExpression:
              case re.SyntaxKind.NewExpression:
              case re.SyntaxKind.TaggedTemplateExpression:
              case re.SyntaxKind.JsxExpression:
              case re.SyntaxKind.Decorator:
              case re.SyntaxKind.TemplateSpan:
              case re.SyntaxKind.JsxOpeningElement:
              case re.SyntaxKind.JsxSelfClosingElement:
              case re.SyntaxKind.JsxSpreadAttribute:
              case re.SyntaxKind.VoidExpression:
              case re.SyntaxKind.ReturnStatement:
              case re.SyntaxKind.AwaitExpression:
              case re.SyntaxKind.YieldExpression:
              case re.SyntaxKind.ConditionalExpression:
              case re.SyntaxKind.CaseClause:
              case re.SyntaxKind.JsxElement:
                return 1;
              case re.SyntaxKind.ArrowFunction:
                return Xe.body === ae ? 1 : 2;
              case re.SyntaxKind.PropertyDeclaration:
              case re.SyntaxKind.VariableDeclaration:
              case re.SyntaxKind.Parameter:
              case re.SyntaxKind.EnumMember:
              case re.SyntaxKind.BindingElement:
              case re.SyntaxKind.JsxAttribute:
                return Xe.initializer === ae ? 1 : 0;
              case re.SyntaxKind.PropertyAccessExpression:
                return Xe.expression === ae ? 1 : 0;
              case re.SyntaxKind.ExportAssignment:
                return Xe.isExportEquals ? 1 : 0;
            }
            return 0;
          }
          M.getAccessKind = ye;
          function Ae(ae) {
            return (ye(ae) & 2) !== 0;
          }
          M.isReassignmentTarget = Ae;
          function er(ae) {
            switch (ae.kind) {
              case re.SyntaxKind.Parameter:
              case re.SyntaxKind.CallSignature:
              case re.SyntaxKind.ConstructSignature:
              case re.SyntaxKind.MethodSignature:
              case re.SyntaxKind.PropertySignature:
              case re.SyntaxKind.ArrowFunction:
              case re.SyntaxKind.ParenthesizedExpression:
              case re.SyntaxKind.SpreadAssignment:
              case re.SyntaxKind.ShorthandPropertyAssignment:
              case re.SyntaxKind.PropertyAssignment:
              case re.SyntaxKind.FunctionExpression:
              case re.SyntaxKind.LabeledStatement:
              case re.SyntaxKind.ExpressionStatement:
              case re.SyntaxKind.VariableStatement:
              case re.SyntaxKind.FunctionDeclaration:
              case re.SyntaxKind.Constructor:
              case re.SyntaxKind.MethodDeclaration:
              case re.SyntaxKind.PropertyDeclaration:
              case re.SyntaxKind.GetAccessor:
              case re.SyntaxKind.SetAccessor:
              case re.SyntaxKind.ClassDeclaration:
              case re.SyntaxKind.ClassExpression:
              case re.SyntaxKind.InterfaceDeclaration:
              case re.SyntaxKind.TypeAliasDeclaration:
              case re.SyntaxKind.EnumMember:
              case re.SyntaxKind.EnumDeclaration:
              case re.SyntaxKind.ModuleDeclaration:
              case re.SyntaxKind.ImportEqualsDeclaration:
              case re.SyntaxKind.ImportDeclaration:
              case re.SyntaxKind.NamespaceExportDeclaration:
              case re.SyntaxKind.ExportAssignment:
              case re.SyntaxKind.IndexSignature:
              case re.SyntaxKind.FunctionType:
              case re.SyntaxKind.ConstructorType:
              case re.SyntaxKind.JSDocFunctionType:
              case re.SyntaxKind.ExportDeclaration:
              case re.SyntaxKind.NamedTupleMember:
              case re.SyntaxKind.EndOfFileToken:
                return true;
              default:
                return false;
            }
          }
          M.canHaveJsDoc = er;
          function ir(ae, Xe) {
            let Jr = [];
            for (let ti of ae.getChildren(Xe)) {
              if (!Ve.isJsDoc(ti))
                break;
              Jr.push(ti);
            }
            return Jr;
          }
          M.getJsDoc = ir;
          function Cr(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : ae.getSourceFile();
            if (er(ae) && ae.kind !== re.SyntaxKind.EndOfFileToken) {
              let ti = ir(ae, Jr);
              if (ti.length !== 0 || !Xe)
                return ti;
            }
            return Ye(ae, ae.getStart(Jr), Jr, Xe);
          }
          M.parseJsDocOfNode = Cr;
          function Ye(ae, Xe, Jr, ti) {
            let Ze = re[ti && Ee(Jr, ae.pos, Xe) ? "forEachTrailingCommentRange" : "forEachLeadingCommentRange"](Jr.text, ae.pos, (vr, mr, Ar) => Ar === re.SyntaxKind.MultiLineCommentTrivia && Jr.text[vr + 2] === "*" ? { pos: vr } : void 0);
            if (Ze === void 0)
              return [];
            let Sr = Ze.pos, zr = Jr.text.slice(Sr, Xe), Wr = re.createSourceFile("jsdoc.ts", "".concat(zr, "var a;"), Jr.languageVersion), Je = ir(Wr.statements[0], Wr);
            for (let vr of Je)
              xe(vr, ae);
            return Je;
            function xe(vr, mr) {
              return vr.pos += Sr, vr.end += Sr, vr.parent = mr, re.forEachChild(vr, (Ar) => xe(Ar, vr), (Ar) => {
                Ar.pos += Sr, Ar.end += Sr;
                for (let Oe of Ar)
                  xe(Oe, vr);
              });
            }
          }
          var Br;
          (function(ae) {
            ae[ae.ImportDeclaration = 1] = "ImportDeclaration", ae[ae.ImportEquals = 2] = "ImportEquals", ae[ae.ExportFrom = 4] = "ExportFrom", ae[ae.DynamicImport = 8] = "DynamicImport", ae[ae.Require = 16] = "Require", ae[ae.ImportType = 32] = "ImportType", ae[ae.All = 63] = "All", ae[ae.AllImports = 59] = "AllImports", ae[ae.AllStaticImports = 3] = "AllStaticImports", ae[ae.AllImportExpressions = 24] = "AllImportExpressions", ae[ae.AllRequireLike = 18] = "AllRequireLike", ae[ae.AllNestedImports = 56] = "AllNestedImports", ae[ae.AllTopLevelImports = 7] = "AllTopLevelImports";
          })(Br = M.ImportKind || (M.ImportKind = {}));
          function Er(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true, ti = [];
            for (let Sr of Ne(ae, Xe, Jr))
              switch (Sr.kind) {
                case re.SyntaxKind.ImportDeclaration:
                  Ze(Sr.moduleSpecifier);
                  break;
                case re.SyntaxKind.ImportEqualsDeclaration:
                  Ze(Sr.moduleReference.expression);
                  break;
                case re.SyntaxKind.ExportDeclaration:
                  Ze(Sr.moduleSpecifier);
                  break;
                case re.SyntaxKind.CallExpression:
                  Ze(Sr.arguments[0]);
                  break;
                case re.SyntaxKind.ImportType:
                  Ve.isLiteralTypeNode(Sr.argument) && Ze(Sr.argument.literal);
                  break;
                default:
                  throw new Error("unexpected node");
              }
            return ti;
            function Ze(Sr) {
              Ve.isTextualLiteral(Sr) && ti.push(Sr);
            }
          }
          M.findImports = Er;
          function Ne(ae, Xe) {
            let Jr = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : true;
            return new n(ae, Xe, Jr).find();
          }
          M.findImportLikeNodes = Ne;
          var n = class {
            constructor(ae, Xe, Jr) {
              this._sourceFile = ae, this._options = Xe, this._ignoreFileName = Jr, this._result = [];
            }
            find() {
              return this._sourceFile.isDeclarationFile && (this._options &= -25), this._options & 7 && this._findImports(this._sourceFile.statements), this._options & 56 && this._findNestedImports(), this._result;
            }
            _findImports(ae) {
              for (let Xe of ae)
                Ve.isImportDeclaration(Xe) ? this._options & 1 && this._result.push(Xe) : Ve.isImportEqualsDeclaration(Xe) ? this._options & 2 && Xe.moduleReference.kind === re.SyntaxKind.ExternalModuleReference && this._result.push(Xe) : Ve.isExportDeclaration(Xe) ? Xe.moduleSpecifier !== void 0 && this._options & 4 && this._result.push(Xe) : Ve.isModuleDeclaration(Xe) && this._findImportsInModule(Xe);
            }
            _findImportsInModule(ae) {
              if (ae.body !== void 0) {
                if (ae.body.kind === re.SyntaxKind.ModuleDeclaration)
                  return this._findImportsInModule(ae.body);
                this._findImports(ae.body.statements);
              }
            }
            _findNestedImports() {
              let ae = this._ignoreFileName || (this._sourceFile.flags & re.NodeFlags.JavaScriptFile) !== 0, Xe, Jr;
              if ((this._options & 56) === 16) {
                if (!ae)
                  return;
                Xe = /\brequire\s*[</(]/g, Jr = false;
              } else
                this._options & 16 && ae ? (Xe = /\b(?:import|require)\s*[</(]/g, Jr = (this._options & 32) !== 0) : (Xe = /\bimport\s*[</(]/g, Jr = ae && (this._options & 32) !== 0);
              for (let ti = Xe.exec(this._sourceFile.text); ti !== null; ti = Xe.exec(this._sourceFile.text)) {
                let Ze = K(this._sourceFile, ti.index, this._sourceFile, ti[0][0] === "i" && Jr);
                if (Ze.kind === re.SyntaxKind.ImportKeyword) {
                  if (Ze.end - 6 !== ti.index)
                    continue;
                  switch (Ze.parent.kind) {
                    case re.SyntaxKind.ImportType:
                      this._result.push(Ze.parent);
                      break;
                    case re.SyntaxKind.CallExpression:
                      Ze.parent.arguments.length > 1 && this._result.push(Ze.parent);
                  }
                } else
                  Ze.kind === re.SyntaxKind.Identifier && Ze.end - 7 === ti.index && Ze.parent.kind === re.SyntaxKind.CallExpression && Ze.parent.expression === Ze && Ze.parent.arguments.length === 1 && this._result.push(Ze.parent);
              }
            }
          };
          function lr(ae) {
            for (; ae.flags & re.NodeFlags.NestedNamespace; )
              ae = ae.parent;
            return B(ae.modifiers, re.SyntaxKind.DeclareKeyword) || be(ae.parent);
          }
          M.isStatementInAmbientContext = lr;
          function be(ae) {
            for (; ae.kind === re.SyntaxKind.ModuleBlock; ) {
              do
                ae = ae.parent;
              while (ae.flags & re.NodeFlags.NestedNamespace);
              if (B(ae.modifiers, re.SyntaxKind.DeclareKeyword))
                return true;
              ae = ae.parent;
            }
            return false;
          }
          M.isAmbientModuleBlock = be;
          function Ge(ae) {
            let Xe = ae.parent;
            for (; Xe.kind === re.SyntaxKind.ParenthesizedExpression; )
              Xe = Xe.parent;
            return Ve.isCallExpression(Xe) && ae.end <= Xe.expression.end ? Xe : void 0;
          }
          M.getIIFE = Ge;
          function ur(ae, Xe) {
            return (ae.strict ? ae[Xe] !== false : ae[Xe] === true) && (Xe !== "strictPropertyInitialization" || ur(ae, "strictNullChecks"));
          }
          M.isStrictCompilerOptionEnabled = ur;
          function yr(ae, Xe) {
            switch (Xe) {
              case "stripInternal":
              case "declarationMap":
              case "emitDeclarationOnly":
                return ae[Xe] === true && yr(ae, "declaration");
              case "declaration":
                return ae.declaration || yr(ae, "composite");
              case "incremental":
                return ae.incremental === void 0 ? yr(ae, "composite") : ae.incremental;
              case "skipDefaultLibCheck":
                return ae.skipDefaultLibCheck || yr(ae, "skipLibCheck");
              case "suppressImplicitAnyIndexErrors":
                return ae.suppressImplicitAnyIndexErrors === true && yr(ae, "noImplicitAny");
              case "allowSyntheticDefaultImports":
                return ae.allowSyntheticDefaultImports !== void 0 ? ae.allowSyntheticDefaultImports : yr(ae, "esModuleInterop") || ae.module === re.ModuleKind.System;
              case "noUncheckedIndexedAccess":
                return ae.noUncheckedIndexedAccess === true && yr(ae, "strictNullChecks");
              case "allowJs":
                return ae.allowJs === void 0 ? yr(ae, "checkJs") : ae.allowJs;
              case "noImplicitAny":
              case "noImplicitThis":
              case "strictNullChecks":
              case "strictFunctionTypes":
              case "strictPropertyInitialization":
              case "alwaysStrict":
              case "strictBindCallApply":
                return ur(ae, Xe);
            }
            return ae[Xe] === true;
          }
          M.isCompilerOptionEnabled = yr;
          function Ir(ae) {
            return ae.name.kind === re.SyntaxKind.StringLiteral || (ae.flags & re.NodeFlags.GlobalAugmentation) !== 0;
          }
          M.isAmbientModule = Ir;
          function wr(ae) {
            return Ur(ae);
          }
          M.getCheckJsDirective = wr;
          function Ur(ae) {
            let Xe;
            return re.forEachLeadingCommentRange(ae, (re.getShebang(ae) || "").length, (Jr, ti, Ze) => {
              if (Ze === re.SyntaxKind.SingleLineCommentTrivia) {
                let Sr = ae.slice(Jr, ti), zr = /^\/{2,3}\s*@ts-(no)?check(?:\s|$)/i.exec(Sr);
                zr !== null && (Xe = { pos: Jr, end: ti, enabled: zr[1] === void 0 });
              }
            }), Xe;
          }
          M.getTsCheckDirective = Ur;
          function ii(ae) {
            return Ve.isTypeReferenceNode(ae.type) && ae.type.typeName.kind === re.SyntaxKind.Identifier && ae.type.typeName.escapedText === "const";
          }
          M.isConstAssertion = ii;
          function mi(ae) {
            let Xe = ae;
            for (; ; ) {
              let Jr = Xe.parent;
              e:
                switch (Jr.kind) {
                  case re.SyntaxKind.TypeAssertionExpression:
                  case re.SyntaxKind.AsExpression:
                    return ii(Jr);
                  case re.SyntaxKind.PrefixUnaryExpression:
                    if (Xe.kind !== re.SyntaxKind.NumericLiteral)
                      return false;
                    switch (Jr.operator) {
                      case re.SyntaxKind.PlusToken:
                      case re.SyntaxKind.MinusToken:
                        Xe = Jr;
                        break e;
                      default:
                        return false;
                    }
                  case re.SyntaxKind.PropertyAssignment:
                    if (Jr.initializer !== Xe)
                      return false;
                    Xe = Jr.parent;
                    break;
                  case re.SyntaxKind.ShorthandPropertyAssignment:
                    Xe = Jr.parent;
                    break;
                  case re.SyntaxKind.ParenthesizedExpression:
                  case re.SyntaxKind.ArrayLiteralExpression:
                  case re.SyntaxKind.ObjectLiteralExpression:
                  case re.SyntaxKind.TemplateExpression:
                    Xe = Jr;
                    break;
                  default:
                    return false;
                }
            }
          }
          M.isInConstContext = mi;
          function pe(ae, Xe) {
            if (!or(ae))
              return false;
            let Jr = Xe.getTypeAtLocation(ae.arguments[2]);
            if (Jr.getProperty("value") === void 0)
              return Jr.getProperty("set") === void 0;
            let ti = Jr.getProperty("writable");
            if (ti === void 0)
              return false;
            let Ze = ti.valueDeclaration !== void 0 && Ve.isPropertyAssignment(ti.valueDeclaration) ? Xe.getTypeAtLocation(ti.valueDeclaration.initializer) : Xe.getTypeOfSymbolAtLocation(ti, ae.arguments[2]);
            return oi.isBooleanLiteralType(Ze, false);
          }
          M.isReadonlyAssignmentDeclaration = pe;
          function or(ae) {
            return ae.arguments.length === 3 && Ve.isEntityNameExpression(ae.arguments[0]) && Ve.isNumericOrStringLikeLiteral(ae.arguments[1]) && Ve.isPropertyAccessExpression(ae.expression) && ae.expression.name.escapedText === "defineProperty" && Ve.isIdentifier(ae.expression.expression) && ae.expression.expression.escapedText === "Object";
          }
          M.isBindableObjectDefinePropertyCall = or;
          function qr(ae) {
            return re.isPropertyAccessExpression(ae) && re.isIdentifier(ae.expression) && ae.expression.escapedText === "Symbol";
          }
          M.isWellKnownSymbolLiterally = qr;
          function si(ae) {
            return { displayName: "[Symbol.".concat(ae.name.text, "]"), symbolName: "__@" + ae.name.text };
          }
          M.getPropertyNameOfWellKnownSymbol = si;
          var Di = ((ae) => {
            let [Xe, Jr] = ae;
            return Xe < "4" || Xe === "4" && Jr < "3";
          })(re.versionMajorMinor.split("."));
          function wi(ae, Xe) {
            let Jr = { known: true, names: [] };
            if (ae = Gi(ae), Di && qr(ae))
              Jr.names.push(si(ae));
            else {
              let ti = Xe.getTypeAtLocation(ae);
              for (let Ze of oi.unionTypeParts(Xe.getBaseConstraintOfType(ti) || ti)) {
                let Sr = oi.getPropertyNameFromType(Ze);
                Sr ? Jr.names.push(Sr) : Jr.known = false;
              }
            }
            return Jr;
          }
          M.getLateBoundPropertyNames = wi;
          function Xi(ae, Xe) {
            let Jr = O(ae);
            return Jr !== void 0 ? { known: true, names: [{ displayName: Jr, symbolName: re.escapeLeadingUnderscores(Jr) }] } : ae.kind === re.SyntaxKind.PrivateIdentifier ? { known: true, names: [{ displayName: ae.text, symbolName: Xe.getSymbolAtLocation(ae).escapedName }] } : wi(ae.expression, Xe);
          }
          M.getLateBoundPropertyNamesOfPropertyName = Xi;
          function et(ae, Xe) {
            let Jr = O(ae);
            if (Jr !== void 0)
              return { displayName: Jr, symbolName: re.escapeLeadingUnderscores(Jr) };
            if (ae.kind === re.SyntaxKind.PrivateIdentifier)
              return { displayName: ae.text, symbolName: Xe.getSymbolAtLocation(ae).escapedName };
            let { expression: ti } = ae;
            return Di && qr(ti) ? si(ti) : oi.getPropertyNameFromType(Xe.getTypeAtLocation(ti));
          }
          M.getSingleLateBoundPropertyNameOfPropertyName = et;
          function Gi(ae) {
            for (; ae.kind === re.SyntaxKind.ParenthesizedExpression; )
              ae = ae.expression;
            return ae;
          }
          M.unwrapParentheses = Gi;
          function Wt(ae) {
            return "".concat(ae.negative ? "-" : "").concat(ae.base10Value, "n");
          }
          M.formatPseudoBigInt = Wt;
          function Zt(ae, Xe) {
            let Jr = ae.caseBlock.clauses.filter(Ve.isCaseClause);
            if (Jr.length === 0)
              return false;
            let ti = oi.unionTypeParts(Xe.getTypeAtLocation(ae.expression));
            if (ti.length > Jr.length)
              return false;
            let Ze = new Set(ti.map(_r));
            if (Ze.has(void 0))
              return false;
            let Sr = /* @__PURE__ */ new Set();
            for (let zr of Jr) {
              let Wr = Xe.getTypeAtLocation(zr.expression);
              if (M.isTypeFlagSet(Wr, re.TypeFlags.Never))
                continue;
              let Je = _r(Wr);
              if (Ze.has(Je))
                Sr.add(Je);
              else if (Je !== "null" && Je !== "undefined")
                return false;
            }
            return Ze.size === Sr.size;
          }
          M.hasExhaustiveCaseClauses = Zt;
          function _r(ae) {
            if (M.isTypeFlagSet(ae, re.TypeFlags.Null))
              return "null";
            if (M.isTypeFlagSet(ae, re.TypeFlags.Undefined))
              return "undefined";
            if (M.isTypeFlagSet(ae, re.TypeFlags.NumberLiteral))
              return "".concat(M.isTypeFlagSet(ae, re.TypeFlags.EnumLiteral) ? "enum:" : "").concat(ae.value);
            if (M.isTypeFlagSet(ae, re.TypeFlags.StringLiteral))
              return "".concat(M.isTypeFlagSet(ae, re.TypeFlags.EnumLiteral) ? "enum:" : "", "string:").concat(ae.value);
            if (M.isTypeFlagSet(ae, re.TypeFlags.BigIntLiteral))
              return Wt(ae.value);
            if (Ke.isUniqueESSymbolType(ae))
              return ae.escapedName;
            if (oi.isBooleanLiteralType(ae, true))
              return "true";
            if (oi.isBooleanLiteralType(ae, false))
              return "false";
          }
          function pi(ae) {
            var Xe;
            if (((Xe = ae.heritageClauses) === null || Xe === void 0 ? void 0 : Xe[0].token) === re.SyntaxKind.ExtendsKeyword)
              return ae.heritageClauses[0].types[0];
          }
          M.getBaseOfClassLikeExpression = pi;
        } }), ez = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/convert-comments.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(ke, e2, a, C) {
            C === void 0 && (C = a);
            var w = Object.getOwnPropertyDescriptor(e2, a);
            (!w || ("get" in w ? !e2.__esModule : w.writable || w.configurable)) && (w = { enumerable: true, get: function() {
              return e2[a];
            } }), Object.defineProperty(ke, C, w);
          } : function(ke, e2, a, C) {
            C === void 0 && (C = a), ke[C] = e2[a];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(ke, e2) {
            Object.defineProperty(ke, "default", { enumerable: true, value: e2 });
          } : function(ke, e2) {
            ke.default = e2;
          }), Ke = M && M.__importStar || function(ke) {
            if (ke && ke.__esModule)
              return ke;
            var e2 = {};
            if (ke != null)
              for (var a in ke)
                a !== "default" && Object.prototype.hasOwnProperty.call(ke, a) && re(e2, ke, a);
            return Ve(e2, ke), e2;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.convertComments = void 0;
          var oi = Ke(_u()), kr = n3(), pr = A1(), Lr = k1();
          function ar(ke, e2) {
            let a = [];
            return (0, kr.forEachComment)(ke, (C, w) => {
              let B = w.kind == oi.SyntaxKind.SingleLineCommentTrivia ? Lr.AST_TOKEN_TYPES.Line : Lr.AST_TOKEN_TYPES.Block, E = [w.pos, w.end], Q = (0, pr.getLocFor)(E[0], E[1], ke), le = E[0] + 2, N = w.kind === oi.SyntaxKind.SingleLineCommentTrivia ? E[1] - le : E[1] - le - 2;
              a.push({ type: B, value: e2.slice(le, le + N), range: E, loc: Q });
            }, ke), a;
          }
          M.convertComments = ar;
        } }), o3 = Oa({ "node_modules/eslint-visitor-keys/dist/eslint-visitor-keys.cjs"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true });
          var re = { AssignmentExpression: ["left", "right"], AssignmentPattern: ["left", "right"], ArrayExpression: ["elements"], ArrayPattern: ["elements"], ArrowFunctionExpression: ["params", "body"], AwaitExpression: ["argument"], BlockStatement: ["body"], BinaryExpression: ["left", "right"], BreakStatement: ["label"], CallExpression: ["callee", "arguments"], CatchClause: ["param", "body"], ChainExpression: ["expression"], ClassBody: ["body"], ClassDeclaration: ["id", "superClass", "body"], ClassExpression: ["id", "superClass", "body"], ConditionalExpression: ["test", "consequent", "alternate"], ContinueStatement: ["label"], DebuggerStatement: [], DoWhileStatement: ["body", "test"], EmptyStatement: [], ExportAllDeclaration: ["exported", "source"], ExportDefaultDeclaration: ["declaration"], ExportNamedDeclaration: ["declaration", "specifiers", "source"], ExportSpecifier: ["exported", "local"], ExpressionStatement: ["expression"], ExperimentalRestProperty: ["argument"], ExperimentalSpreadProperty: ["argument"], ForStatement: ["init", "test", "update", "body"], ForInStatement: ["left", "right", "body"], ForOfStatement: ["left", "right", "body"], FunctionDeclaration: ["id", "params", "body"], FunctionExpression: ["id", "params", "body"], Identifier: [], IfStatement: ["test", "consequent", "alternate"], ImportDeclaration: ["specifiers", "source"], ImportDefaultSpecifier: ["local"], ImportExpression: ["source"], ImportNamespaceSpecifier: ["local"], ImportSpecifier: ["imported", "local"], JSXAttribute: ["name", "value"], JSXClosingElement: ["name"], JSXElement: ["openingElement", "children", "closingElement"], JSXEmptyExpression: [], JSXExpressionContainer: ["expression"], JSXIdentifier: [], JSXMemberExpression: ["object", "property"], JSXNamespacedName: ["namespace", "name"], JSXOpeningElement: ["name", "attributes"], JSXSpreadAttribute: ["argument"], JSXText: [], JSXFragment: ["openingFragment", "children", "closingFragment"], JSXClosingFragment: [], JSXOpeningFragment: [], Literal: [], LabeledStatement: ["label", "body"], LogicalExpression: ["left", "right"], MemberExpression: ["object", "property"], MetaProperty: ["meta", "property"], MethodDefinition: ["key", "value"], NewExpression: ["callee", "arguments"], ObjectExpression: ["properties"], ObjectPattern: ["properties"], PrivateIdentifier: [], Program: ["body"], Property: ["key", "value"], PropertyDefinition: ["key", "value"], RestElement: ["argument"], ReturnStatement: ["argument"], SequenceExpression: ["expressions"], SpreadElement: ["argument"], StaticBlock: ["body"], Super: [], SwitchStatement: ["discriminant", "cases"], SwitchCase: ["test", "consequent"], TaggedTemplateExpression: ["tag", "quasi"], TemplateElement: [], TemplateLiteral: ["quasis", "expressions"], ThisExpression: [], ThrowStatement: ["argument"], TryStatement: ["block", "handler", "finalizer"], UnaryExpression: ["argument"], UpdateExpression: ["argument"], VariableDeclaration: ["declarations"], VariableDeclarator: ["id", "init"], WhileStatement: ["test", "body"], WithStatement: ["object", "body"], YieldExpression: ["argument"] }, Ve = Object.keys(re);
          for (let Lr of Ve)
            Object.freeze(re[Lr]);
          Object.freeze(re);
          var Ke = /* @__PURE__ */ new Set(["parent", "leadingComments", "trailingComments"]);
          function oi(Lr) {
            return !Ke.has(Lr) && Lr[0] !== "_";
          }
          function kr(Lr) {
            return Object.keys(Lr).filter(oi);
          }
          function pr(Lr) {
            let ar = Object.assign({}, re);
            for (let ke of Object.keys(Lr))
              if (Object.prototype.hasOwnProperty.call(ar, ke)) {
                let e2 = new Set(Lr[ke]);
                for (let a of ar[ke])
                  e2.add(a);
                ar[ke] = Object.freeze(Array.from(e2));
              } else
                ar[ke] = Object.freeze(Array.from(Lr[ke]));
            return Object.freeze(ar);
          }
          M.KEYS = re, M.getKeys = kr, M.unionWith = pr;
        } }), rz = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/visitor-keys/dist/get-keys.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.getKeys = void 0;
          var re = o3(), Ve = re.getKeys;
          M.getKeys = Ve;
        } }), iz = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/visitor-keys/dist/visitor-keys.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(Lr, ar, ke, e2) {
            e2 === void 0 && (e2 = ke);
            var a = Object.getOwnPropertyDescriptor(ar, ke);
            (!a || ("get" in a ? !ar.__esModule : a.writable || a.configurable)) && (a = { enumerable: true, get: function() {
              return ar[ke];
            } }), Object.defineProperty(Lr, e2, a);
          } : function(Lr, ar, ke, e2) {
            e2 === void 0 && (e2 = ke), Lr[e2] = ar[ke];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(Lr, ar) {
            Object.defineProperty(Lr, "default", { enumerable: true, value: ar });
          } : function(Lr, ar) {
            Lr.default = ar;
          }), Ke = M && M.__importStar || function(Lr) {
            if (Lr && Lr.__esModule)
              return Lr;
            var ar = {};
            if (Lr != null)
              for (var ke in Lr)
                ke !== "default" && Object.prototype.hasOwnProperty.call(Lr, ke) && re(ar, Lr, ke);
            return Ve(ar, Lr), ar;
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.visitorKeys = void 0;
          var oi = Ke(o3()), kr = { ImportAttribute: ["key", "value"], ArrayPattern: ["decorators", "elements", "typeAnnotation"], ArrowFunctionExpression: ["typeParameters", "params", "returnType", "body"], AssignmentPattern: ["decorators", "left", "right", "typeAnnotation"], CallExpression: ["callee", "typeParameters", "arguments"], ClassDeclaration: ["decorators", "id", "typeParameters", "superClass", "superTypeParameters", "implements", "body"], ClassExpression: ["decorators", "id", "typeParameters", "superClass", "superTypeParameters", "implements", "body"], ExportAllDeclaration: ["exported", "source", "assertions"], ExportNamedDeclaration: ["declaration", "specifiers", "source", "assertions"], FunctionDeclaration: ["id", "typeParameters", "params", "returnType", "body"], FunctionExpression: ["id", "typeParameters", "params", "returnType", "body"], Identifier: ["decorators", "typeAnnotation"], ImportDeclaration: ["specifiers", "source", "assertions"], ImportExpression: ["source", "attributes"], MethodDefinition: ["decorators", "key", "value", "typeParameters"], NewExpression: ["callee", "typeParameters", "arguments"], ObjectPattern: ["decorators", "properties", "typeAnnotation"], PropertyDefinition: ["decorators", "key", "typeAnnotation", "value"], RestElement: ["decorators", "argument", "typeAnnotation"], TaggedTemplateExpression: ["tag", "typeParameters", "quasi"], StaticBlock: ["body"], JSXOpeningElement: ["name", "typeParameters", "attributes"], JSXClosingFragment: [], JSXOpeningFragment: [], JSXSpreadChild: ["expression"], Decorator: ["expression"], TSAbstractKeyword: [], TSAbstractMethodDefinition: ["key", "value"], TSAbstractPropertyDefinition: ["decorators", "key", "typeAnnotation"], TSAnyKeyword: [], TSArrayType: ["elementType"], TSAsExpression: ["expression", "typeAnnotation"], TSAsyncKeyword: [], TSBigIntKeyword: [], TSBooleanKeyword: [], TSCallSignatureDeclaration: ["typeParameters", "params", "returnType"], TSClassImplements: ["expression", "typeParameters"], TSConditionalType: ["checkType", "extendsType", "trueType", "falseType"], TSConstructorType: ["typeParameters", "params", "returnType"], TSConstructSignatureDeclaration: ["typeParameters", "params", "returnType"], TSDeclareFunction: ["id", "typeParameters", "params", "returnType", "body"], TSDeclareKeyword: [], TSEmptyBodyFunctionExpression: ["id", "typeParameters", "params", "returnType"], TSEnumDeclaration: ["id", "members"], TSEnumMember: ["id", "initializer"], TSExportAssignment: ["expression"], TSExportKeyword: [], TSExternalModuleReference: ["expression"], TSFunctionType: ["typeParameters", "params", "returnType"], TSImportEqualsDeclaration: ["id", "moduleReference"], TSImportType: ["parameter", "qualifier", "typeParameters"], TSIndexedAccessType: ["indexType", "objectType"], TSIndexSignature: ["parameters", "typeAnnotation"], TSInferType: ["typeParameter"], TSInstantiationExpression: ["expression", "typeParameters"], TSInterfaceBody: ["body"], TSInterfaceDeclaration: ["id", "typeParameters", "extends", "body"], TSInterfaceHeritage: ["expression", "typeParameters"], TSIntersectionType: ["types"], TSIntrinsicKeyword: [], TSLiteralType: ["literal"], TSMappedType: ["nameType", "typeParameter", "typeAnnotation"], TSMethodSignature: ["typeParameters", "key", "params", "returnType"], TSModuleBlock: ["body"], TSModuleDeclaration: ["id", "body"], TSNamedTupleMember: ["label", "elementType"], TSNamespaceExportDeclaration: ["id"], TSNeverKeyword: [], TSNonNullExpression: ["expression"], TSNullKeyword: [], TSNumberKeyword: [], TSObjectKeyword: [], TSOptionalType: ["typeAnnotation"], TSParameterProperty: ["decorators", "parameter"], TSPrivateKeyword: [], TSPropertySignature: ["typeAnnotation", "key", "initializer"], TSProtectedKeyword: [], TSPublicKeyword: [], TSQualifiedName: ["left", "right"], TSReadonlyKeyword: [], TSRestType: ["typeAnnotation"], TSStaticKeyword: [], TSStringKeyword: [], TSSymbolKeyword: [], TSTemplateLiteralType: ["quasis", "types"], TSThisType: [], TSTupleType: ["elementTypes"], TSTypeAliasDeclaration: ["id", "typeParameters", "typeAnnotation"], TSTypeAnnotation: ["typeAnnotation"], TSTypeAssertion: ["typeAnnotation", "expression"], TSTypeLiteral: ["members"], TSTypeOperator: ["typeAnnotation"], TSTypeParameter: ["name", "constraint", "default"], TSTypeParameterDeclaration: ["params"], TSTypeParameterInstantiation: ["params"], TSTypePredicate: ["typeAnnotation", "parameterName"], TSTypeQuery: ["exprName"], TSTypeReference: ["typeName", "typeParameters"], TSUndefinedKeyword: [], TSUnionType: ["types"], TSUnknownKeyword: [], TSVoidKeyword: [] }, pr = oi.unionWith(kr);
          M.visitorKeys = pr;
        } }), s3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/node_modules/@typescript-eslint/visitor-keys/dist/index.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.visitorKeys = M.getKeys = void 0;
          var re = rz();
          Object.defineProperty(M, "getKeys", { enumerable: true, get: function() {
            return re.getKeys;
          } });
          var Ve = iz();
          Object.defineProperty(M, "visitorKeys", { enumerable: true, get: function() {
            return Ve.visitorKeys;
          } });
        } }), c3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/simple-traverse.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.simpleTraverse = void 0;
          var re = s3();
          function Ve(pr) {
            return pr !== null && typeof pr == "object" && typeof pr.type == "string";
          }
          function Ke(pr, Lr) {
            let ar = pr[Lr.type];
            return ar != null ? ar : [];
          }
          var oi = class {
            constructor(pr) {
              let Lr = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              this.allVisitorKeys = re.visitorKeys, this.selectors = pr, this.setParentPointers = Lr;
            }
            traverse(pr, Lr) {
              if (!Ve(pr))
                return;
              this.setParentPointers && (pr.parent = Lr), "enter" in this.selectors ? this.selectors.enter(pr, Lr) : pr.type in this.selectors && this.selectors[pr.type](pr, Lr);
              let ar = Ke(this.allVisitorKeys, pr);
              if (!(ar.length < 1))
                for (let ke of ar) {
                  let e2 = pr[ke];
                  if (Array.isArray(e2))
                    for (let a of e2)
                      this.traverse(a, pr);
                  else
                    this.traverse(e2, pr);
                }
            }
          };
          function kr(pr, Lr) {
            let ar = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false;
            new oi(Lr, ar).traverse(pr, void 0);
          }
          M.simpleTraverse = kr;
        } }), tz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/ast-converter.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.astConverter = void 0;
          var re = e3(), Ve = ez(), Ke = A1(), oi = c3();
          function kr(pr, Lr, ar) {
            let { parseDiagnostics: ke } = pr;
            if (ke.length)
              throw (0, re.convertError)(ke[0]);
            let e2 = new re.Converter(pr, { errorOnUnknownASTType: Lr.errorOnUnknownASTType || false, shouldPreserveNodeMaps: ar }), a = e2.convertProgram();
            (!Lr.range || !Lr.loc) && (0, oi.simpleTraverse)(a, { enter: (w) => {
              Lr.range || delete w.range, Lr.loc || delete w.loc;
            } }), Lr.tokens && (a.tokens = (0, Ke.convertTokens)(pr)), Lr.comment && (a.comments = (0, Ve.convertComments)(pr, Lr.code));
            let C = e2.getASTMaps();
            return { estree: a, astMaps: C };
          }
          M.astConverter = kr;
        } }), Mv = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/shared.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(p, m2, G, oe) {
            oe === void 0 && (oe = G);
            var f4 = Object.getOwnPropertyDescriptor(m2, G);
            (!f4 || ("get" in f4 ? !m2.__esModule : f4.writable || f4.configurable)) && (f4 = { enumerable: true, get: function() {
              return m2[G];
            } }), Object.defineProperty(p, oe, f4);
          } : function(p, m2, G, oe) {
            oe === void 0 && (oe = G), p[oe] = m2[G];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(p, m2) {
            Object.defineProperty(p, "default", { enumerable: true, value: m2 });
          } : function(p, m2) {
            p.default = m2;
          }), Ke = M && M.__importStar || function(p) {
            if (p && p.__esModule)
              return p;
            var m2 = {};
            if (p != null)
              for (var G in p)
                G !== "default" && Object.prototype.hasOwnProperty.call(p, G) && re(m2, p, G);
            return Ve(m2, p), m2;
          }, oi = M && M.__importDefault || function(p) {
            return p && p.__esModule ? p : { default: p };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.getModuleResolver = M.getAstFromProgram = M.getCanonicalFileName = M.ensureAbsolutePath = M.createDefaultCompilerOptionsFromExtra = M.canonicalDirname = M.CORE_COMPILER_OPTIONS = void 0;
          var kr = oi(Fv()), pr = Ke(_u()), Lr = { noEmit: true, noUnusedLocals: true, noUnusedParameters: true };
          M.CORE_COMPILER_OPTIONS = Lr;
          var ar = Object.assign(Object.assign({}, Lr), { allowNonTsExtensions: true, allowJs: true, checkJs: true });
          function ke(p) {
            return p.debugLevel.has("typescript") ? Object.assign(Object.assign({}, ar), { extendedDiagnostics: true }) : ar;
          }
          M.createDefaultCompilerOptionsFromExtra = ke;
          var e2 = pr.sys !== void 0 ? pr.sys.useCaseSensitiveFileNames : true, a = e2 ? (p) => p : (p) => p.toLowerCase();
          function C(p) {
            let m2 = kr.default.normalize(p);
            return m2.endsWith(kr.default.sep) && (m2 = m2.slice(0, -1)), a(m2);
          }
          M.getCanonicalFileName = C;
          function w(p, m2) {
            return kr.default.isAbsolute(p) ? p : kr.default.join(m2.tsconfigRootDir || "/prettier-security-dirname-placeholder", p);
          }
          M.ensureAbsolutePath = w;
          function B(p) {
            return kr.default.dirname(p);
          }
          M.canonicalDirname = B;
          var E = [pr.Extension.Dts, pr.Extension.Dcts, pr.Extension.Dmts];
          function Q(p) {
            var m2;
            return p ? (m2 = E.find((G) => p.endsWith(G))) !== null && m2 !== void 0 ? m2 : kr.default.extname(p) : null;
          }
          function le(p, m2) {
            let G = p.getSourceFile(m2.filePath), oe = Q(m2.filePath), f4 = Q(G == null ? void 0 : G.fileName);
            if (oe === f4)
              return G && { ast: G, program: p };
          }
          M.getAstFromProgram = le;
          function N(p) {
            let m2;
            try {
              throw new Error("Dynamic require is not supported");
            } catch {
              let oe = ["Could not find the provided parserOptions.moduleResolver.", "Hint: use an absolute path if you are not in control over where the ESLint instance runs."];
              throw new Error(oe.join(`
`));
            }
            return m2;
          }
          M.getModuleResolver = N;
        } }), az = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createDefaultProgram.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(a, C, w, B) {
            B === void 0 && (B = w);
            var E = Object.getOwnPropertyDescriptor(C, w);
            (!E || ("get" in E ? !C.__esModule : E.writable || E.configurable)) && (E = { enumerable: true, get: function() {
              return C[w];
            } }), Object.defineProperty(a, B, E);
          } : function(a, C, w, B) {
            B === void 0 && (B = w), a[B] = C[w];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(a, C) {
            Object.defineProperty(a, "default", { enumerable: true, value: C });
          } : function(a, C) {
            a.default = C;
          }), Ke = M && M.__importStar || function(a) {
            if (a && a.__esModule)
              return a;
            var C = {};
            if (a != null)
              for (var w in a)
                w !== "default" && Object.prototype.hasOwnProperty.call(a, w) && re(C, a, w);
            return Ve(C, a), C;
          }, oi = M && M.__importDefault || function(a) {
            return a && a.__esModule ? a : { default: a };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createDefaultProgram = void 0;
          var kr = oi(wm()), pr = oi(Fv()), Lr = Ke(_u()), ar = Mv(), ke = (0, kr.default)("typescript-eslint:typescript-estree:createDefaultProgram");
          function e2(a, C) {
            if (ke("Getting default program for: %s", C.filePath || "unnamed file"), !C.projects || C.projects.length !== 1)
              return;
            let w = C.projects[0], B = Lr.getParsedCommandLineOfConfigFile(w, (0, ar.createDefaultCompilerOptionsFromExtra)(C), Object.assign(Object.assign({}, Lr.sys), { onUnRecoverableConfigFileDiagnostic: () => {
            } }));
            if (!B)
              return;
            let E = Lr.createCompilerHost(B.options, true);
            C.moduleResolver && (E.resolveModuleNames = (0, ar.getModuleResolver)(C.moduleResolver).resolveModuleNames);
            let Q = E.readFile;
            E.readFile = (p) => pr.default.normalize(p) === pr.default.normalize(C.filePath) ? a : Q(p);
            let le = Lr.createProgram([C.filePath], B.options, E), N = le.getSourceFile(C.filePath);
            return N && { ast: N, program: le };
          }
          M.createDefaultProgram = e2;
        } }), rx = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/getScriptKind.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(ke, e2, a, C) {
            C === void 0 && (C = a);
            var w = Object.getOwnPropertyDescriptor(e2, a);
            (!w || ("get" in w ? !e2.__esModule : w.writable || w.configurable)) && (w = { enumerable: true, get: function() {
              return e2[a];
            } }), Object.defineProperty(ke, C, w);
          } : function(ke, e2, a, C) {
            C === void 0 && (C = a), ke[C] = e2[a];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(ke, e2) {
            Object.defineProperty(ke, "default", { enumerable: true, value: e2 });
          } : function(ke, e2) {
            ke.default = e2;
          }), Ke = M && M.__importStar || function(ke) {
            if (ke && ke.__esModule)
              return ke;
            var e2 = {};
            if (ke != null)
              for (var a in ke)
                a !== "default" && Object.prototype.hasOwnProperty.call(ke, a) && re(e2, ke, a);
            return Ve(e2, ke), e2;
          }, oi = M && M.__importDefault || function(ke) {
            return ke && ke.__esModule ? ke : { default: ke };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.getLanguageVariant = M.getScriptKind = void 0;
          var kr = oi(Fv()), pr = Ke(_u());
          function Lr(ke, e2) {
            switch (kr.default.extname(ke).toLowerCase()) {
              case pr.Extension.Js:
              case pr.Extension.Cjs:
              case pr.Extension.Mjs:
                return pr.ScriptKind.JS;
              case pr.Extension.Jsx:
                return pr.ScriptKind.JSX;
              case pr.Extension.Ts:
              case pr.Extension.Cts:
              case pr.Extension.Mts:
                return pr.ScriptKind.TS;
              case pr.Extension.Tsx:
                return pr.ScriptKind.TSX;
              case pr.Extension.Json:
                return pr.ScriptKind.JSON;
              default:
                return e2 ? pr.ScriptKind.TSX : pr.ScriptKind.TS;
            }
          }
          M.getScriptKind = Lr;
          function ar(ke) {
            switch (ke) {
              case pr.ScriptKind.TSX:
              case pr.ScriptKind.JSX:
              case pr.ScriptKind.JS:
              case pr.ScriptKind.JSON:
                return pr.LanguageVariant.JSX;
              default:
                return pr.LanguageVariant.Standard;
            }
          }
          M.getLanguageVariant = ar;
        } }), nz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createIsolatedProgram.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(a, C, w, B) {
            B === void 0 && (B = w);
            var E = Object.getOwnPropertyDescriptor(C, w);
            (!E || ("get" in E ? !C.__esModule : E.writable || E.configurable)) && (E = { enumerable: true, get: function() {
              return C[w];
            } }), Object.defineProperty(a, B, E);
          } : function(a, C, w, B) {
            B === void 0 && (B = w), a[B] = C[w];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(a, C) {
            Object.defineProperty(a, "default", { enumerable: true, value: C });
          } : function(a, C) {
            a.default = C;
          }), Ke = M && M.__importStar || function(a) {
            if (a && a.__esModule)
              return a;
            var C = {};
            if (a != null)
              for (var w in a)
                w !== "default" && Object.prototype.hasOwnProperty.call(a, w) && re(C, a, w);
            return Ve(C, a), C;
          }, oi = M && M.__importDefault || function(a) {
            return a && a.__esModule ? a : { default: a };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createIsolatedProgram = void 0;
          var kr = oi(wm()), pr = Ke(_u()), Lr = Mv(), ar = rx(), ke = (0, kr.default)("typescript-eslint:typescript-estree:createIsolatedProgram");
          function e2(a, C) {
            ke("Getting isolated program in %s mode for: %s", C.jsx ? "TSX" : "TS", C.filePath);
            let w = { fileExists() {
              return true;
            }, getCanonicalFileName() {
              return C.filePath;
            }, getCurrentDirectory() {
              return "";
            }, getDirectories() {
              return [];
            }, getDefaultLibFileName() {
              return "lib.d.ts";
            }, getNewLine() {
              return `
`;
            }, getSourceFile(Q) {
              return pr.createSourceFile(Q, a, pr.ScriptTarget.Latest, true, (0, ar.getScriptKind)(C.filePath, C.jsx));
            }, readFile() {
            }, useCaseSensitiveFileNames() {
              return true;
            }, writeFile() {
              return null;
            } }, B = pr.createProgram([C.filePath], Object.assign({ noResolve: true, target: pr.ScriptTarget.Latest, jsx: C.jsx ? pr.JsxEmit.Preserve : void 0 }, (0, Lr.createDefaultCompilerOptionsFromExtra)(C)), w), E = B.getSourceFile(C.filePath);
            if (!E)
              throw new Error("Expected an ast to be returned for the single-file isolated program.");
            return { ast: E, program: B };
          }
          M.createIsolatedProgram = e2;
        } }), u3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createWatchProgram.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(J, ie, R, q) {
            q === void 0 && (q = R);
            var O = Object.getOwnPropertyDescriptor(ie, R);
            (!O || ("get" in O ? !ie.__esModule : O.writable || O.configurable)) && (O = { enumerable: true, get: function() {
              return ie[R];
            } }), Object.defineProperty(J, q, O);
          } : function(J, ie, R, q) {
            q === void 0 && (q = R), J[q] = ie[R];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(J, ie) {
            Object.defineProperty(J, "default", { enumerable: true, value: ie });
          } : function(J, ie) {
            J.default = ie;
          }), Ke = M && M.__importStar || function(J) {
            if (J && J.__esModule)
              return J;
            var ie = {};
            if (J != null)
              for (var R in J)
                R !== "default" && Object.prototype.hasOwnProperty.call(J, R) && re(ie, J, R);
            return Ve(ie, J), ie;
          }, oi = M && M.__importDefault || function(J) {
            return J && J.__esModule ? J : { default: J };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.getProgramsForProjects = M.createWatchProgram = M.clearWatchCaches = void 0;
          var kr = oi(wm()), pr = oi(ex()), Lr = oi(QT()), ar = Ke(_u()), ke = Mv(), e2 = (0, kr.default)("typescript-eslint:typescript-estree:createWatchProgram"), a = /* @__PURE__ */ new Map(), C = /* @__PURE__ */ new Map(), w = /* @__PURE__ */ new Map(), B = /* @__PURE__ */ new Map(), E = /* @__PURE__ */ new Map(), Q = /* @__PURE__ */ new Map();
          function le() {
            a.clear(), C.clear(), w.clear(), Q.clear(), B.clear(), E.clear();
          }
          M.clearWatchCaches = le;
          function N(J) {
            return (ie, R) => {
              let q = (0, ke.getCanonicalFileName)(ie), O = (() => {
                let ve = J.get(q);
                return ve || (ve = /* @__PURE__ */ new Set(), J.set(q, ve)), ve;
              })();
              return O.add(R), { close: () => {
                O.delete(R);
              } };
            };
          }
          var p = { code: "", filePath: "" };
          function m2(J) {
            throw new Error(ar.flattenDiagnosticMessageText(J.messageText, ar.sys.newLine));
          }
          function G(J) {
            var ie;
            return !((ie = ar.sys) === null || ie === void 0) && ie.createHash ? ar.sys.createHash(J) : J;
          }
          function oe(J, ie, R) {
            let q = R.EXPERIMENTAL_useSourceOfProjectReferenceRedirect ? new Set(ie.getSourceFiles().map((O) => (0, ke.getCanonicalFileName)(O.fileName))) : new Set(ie.getRootFileNames().map((O) => (0, ke.getCanonicalFileName)(O)));
            return B.set(J, q), q;
          }
          function f4(J, ie, R) {
            let q = (0, ke.getCanonicalFileName)(ie), O = [];
            p.code = J, p.filePath = q;
            let ve = C.get(q), ee = G(J);
            Q.get(q) !== ee && ve && ve.size > 0 && ve.forEach((he) => he(q, ar.FileWatcherEventKind.Changed));
            for (let [he, F2] of a.entries()) {
              let x2 = B.get(he), X = null;
              if (x2 || (X = F2.getProgram().getProgram(), x2 = oe(he, X, R)), x2.has(q))
                return e2("Found existing program for file. %s", q), X = X != null ? X : F2.getProgram().getProgram(), X.getTypeChecker(), [X];
            }
            e2("File did not belong to any existing programs, moving to create/update. %s", q);
            for (let he of R.projects) {
              let F2 = a.get(he);
              if (F2) {
                let A2 = se(F2, q, he);
                if (!A2)
                  continue;
                if (A2.getTypeChecker(), oe(he, A2, R).has(q))
                  return e2("Found updated program for file. %s", q), [A2];
                O.push(A2);
                continue;
              }
              let x2 = K(he, R);
              a.set(he, x2);
              let X = x2.getProgram().getProgram();
              if (X.getTypeChecker(), oe(he, X, R).has(q))
                return e2("Found program for file. %s", q), [X];
              O.push(X);
            }
            return O;
          }
          M.getProgramsForProjects = f4;
          var T = Lr.default.satisfies(ar.version, ">=3.9.0-beta", { includePrerelease: true });
          function K(J, ie) {
            e2("Creating watch program for %s.", J);
            let R = ar.createWatchCompilerHost(J, (0, ke.createDefaultCompilerOptionsFromExtra)(ie), ar.sys, ar.createAbstractBuilder, m2, () => {
            });
            ie.moduleResolver && (R.resolveModuleNames = (0, ke.getModuleResolver)(ie.moduleResolver).resolveModuleNames);
            let q = R.readFile;
            R.readFile = (he, F2) => {
              let x2 = (0, ke.getCanonicalFileName)(he), X = x2 === p.filePath ? p.code : q(x2, F2);
              return X !== void 0 && Q.set(x2, G(X)), X;
            }, R.onUnRecoverableConfigFileDiagnostic = m2, R.afterProgramCreate = (he) => {
              let F2 = he.getConfigFileParsingDiagnostics().filter((x2) => x2.category === ar.DiagnosticCategory.Error && x2.code !== 18003);
              F2.length > 0 && m2(F2[0]);
            }, R.watchFile = N(C), R.watchDirectory = N(w);
            let O = R.onCachedDirectoryStructureHostCreate;
            R.onCachedDirectoryStructureHostCreate = (he) => {
              let F2 = he.readDirectory;
              he.readDirectory = (x2, X, $, A2, y) => F2(x2, X ? X.concat(ie.extraFileExtensions) : void 0, $, A2, y), O(he);
            }, R.extraFileExtensions = ie.extraFileExtensions.map((he) => ({ extension: he, isMixedContent: true, scriptKind: ar.ScriptKind.Deferred })), R.trace = e2, R.useSourceOfProjectReferenceRedirect = () => ie.EXPERIMENTAL_useSourceOfProjectReferenceRedirect;
            let ve;
            T ? (R.setTimeout = void 0, R.clearTimeout = void 0) : (e2("Running without timeout fix"), R.setTimeout = function(he, F2) {
              for (var x2 = arguments.length, X = new Array(x2 > 2 ? x2 - 2 : 0), $ = 2; $ < x2; $++)
                X[$ - 2] = arguments[$];
              return ve = he.bind(void 0, ...X), ve;
            }, R.clearTimeout = () => {
              ve = void 0;
            });
            let ee = ar.createWatchProgram(R);
            if (!T) {
              let he = ee.getProgram;
              ee.getProgram = () => (ve && ve(), ve = void 0, he.call(ee));
            }
            return ee;
          }
          M.createWatchProgram = K;
          function b(J) {
            let R = pr.default.statSync(J).mtimeMs, q = E.get(J);
            return E.set(J, R), q === void 0 ? false : Math.abs(q - R) > Number.EPSILON;
          }
          function se(J, ie, R) {
            let q = J.getProgram().getProgram();
            if (Eu.env.TSESTREE_NO_INVALIDATION === "true")
              return q;
            b(R) && (e2("tsconfig has changed - triggering program update. %s", R), C.get(R).forEach((A2) => A2(R, ar.FileWatcherEventKind.Changed)), B.delete(R));
            let O = q.getSourceFile(ie);
            if (O)
              return q;
            e2("File was not found in program - triggering folder update. %s", ie);
            let ve = (0, ke.canonicalDirname)(ie), ee = null, he = ve, F2 = false;
            for (; ee !== he; ) {
              ee = he;
              let A2 = w.get(ee);
              A2 && (A2.forEach((y) => {
                ve !== ee && y(ve, ar.FileWatcherEventKind.Changed), y(ee, ar.FileWatcherEventKind.Changed);
              }), F2 = true), he = (0, ke.canonicalDirname)(ee);
            }
            if (!F2)
              return e2("No callback found for file, not part of this program. %s", ie), null;
            if (B.delete(R), q = J.getProgram().getProgram(), O = q.getSourceFile(ie), O)
              return q;
            e2("File was still not found in program after directory update - checking file deletions. %s", ie);
            let X = q.getRootFileNames().find((A2) => !pr.default.existsSync(A2));
            if (!X)
              return null;
            let $ = C.get((0, ke.getCanonicalFileName)(X));
            return $ ? (e2("Marking file as deleted. %s", X), $.forEach((A2) => A2(X, ar.FileWatcherEventKind.Deleted)), B.delete(R), q = J.getProgram().getProgram(), O = q.getSourceFile(ie), O ? q : (e2("File was still not found in program after deletion check, assuming it is not part of this program. %s", ie), null)) : (e2("Could not find watch callbacks for root file. %s", X), q);
          }
        } }), oz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createProjectProgram.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(B, E, Q, le) {
            le === void 0 && (le = Q);
            var N = Object.getOwnPropertyDescriptor(E, Q);
            (!N || ("get" in N ? !E.__esModule : N.writable || N.configurable)) && (N = { enumerable: true, get: function() {
              return E[Q];
            } }), Object.defineProperty(B, le, N);
          } : function(B, E, Q, le) {
            le === void 0 && (le = Q), B[le] = E[Q];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(B, E) {
            Object.defineProperty(B, "default", { enumerable: true, value: E });
          } : function(B, E) {
            B.default = E;
          }), Ke = M && M.__importStar || function(B) {
            if (B && B.__esModule)
              return B;
            var E = {};
            if (B != null)
              for (var Q in B)
                Q !== "default" && Object.prototype.hasOwnProperty.call(B, Q) && re(E, B, Q);
            return Ve(E, B), E;
          }, oi = M && M.__importDefault || function(B) {
            return B && B.__esModule ? B : { default: B };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createProjectProgram = void 0;
          var kr = oi(wm()), pr = oi(Fv()), Lr = Ke(_u()), ar = u3(), ke = A1(), e2 = Mv(), a = (0, kr.default)("typescript-eslint:typescript-estree:createProjectProgram"), C = [Lr.Extension.Ts, Lr.Extension.Tsx, Lr.Extension.Js, Lr.Extension.Jsx, Lr.Extension.Mjs, Lr.Extension.Mts, Lr.Extension.Cjs, Lr.Extension.Cts];
          function w(B, E, Q) {
            a("Creating project program for: %s", Q.filePath);
            let le = (0, ke.firstDefined)((0, ar.getProgramsForProjects)(B, Q.filePath, Q), (N) => (0, e2.getAstFromProgram)(N, Q));
            if (!le && !E) {
              let N = ['"parserOptions.project" has been set for @typescript-eslint/parser.', "The file does not match your project config: ".concat(pr.default.relative(Q.tsconfigRootDir || "/prettier-security-dirname-placeholder", Q.filePath), ".")], p = false, m2 = Q.extraFileExtensions || [];
              m2.forEach((oe) => {
                oe.startsWith(".") || N.push('Found unexpected extension "'.concat(oe, '" specified with the "extraFileExtensions" option. Did you mean ".').concat(oe, '"?')), C.includes(oe) && N.push('You unnecessarily included the extension "'.concat(oe, '" with the "extraFileExtensions" option. This extension is already handled by the parser by default.'));
              });
              let G = pr.default.extname(Q.filePath);
              if (!C.includes(G)) {
                let oe = "The extension for the file (".concat(G, ") is non-standard");
                m2.length > 0 ? m2.includes(G) || (N.push("".concat(oe, '. It should be added to your existing "parserOptions.extraFileExtensions".')), p = true) : (N.push("".concat(oe, '. You should add "parserOptions.extraFileExtensions" to your config.')), p = true);
              }
              throw p || N.push("The file must be included in at least one of the projects provided."), new Error(N.join(`
`));
            }
            return le;
          }
          M.createProjectProgram = w;
        } }), sz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/createSourceFile.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(e2, a, C, w) {
            w === void 0 && (w = C);
            var B = Object.getOwnPropertyDescriptor(a, C);
            (!B || ("get" in B ? !a.__esModule : B.writable || B.configurable)) && (B = { enumerable: true, get: function() {
              return a[C];
            } }), Object.defineProperty(e2, w, B);
          } : function(e2, a, C, w) {
            w === void 0 && (w = C), e2[w] = a[C];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(e2, a) {
            Object.defineProperty(e2, "default", { enumerable: true, value: a });
          } : function(e2, a) {
            e2.default = a;
          }), Ke = M && M.__importStar || function(e2) {
            if (e2 && e2.__esModule)
              return e2;
            var a = {};
            if (e2 != null)
              for (var C in e2)
                C !== "default" && Object.prototype.hasOwnProperty.call(e2, C) && re(a, e2, C);
            return Ve(a, e2), a;
          }, oi = M && M.__importDefault || function(e2) {
            return e2 && e2.__esModule ? e2 : { default: e2 };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createSourceFile = void 0;
          var kr = oi(wm()), pr = Ke(_u()), Lr = rx(), ar = (0, kr.default)("typescript-eslint:typescript-estree:createSourceFile");
          function ke(e2, a) {
            return ar("Getting AST without type information in %s mode for: %s", a.jsx ? "TSX" : "TS", a.filePath), pr.createSourceFile(a.filePath, e2, pr.ScriptTarget.Latest, true, (0, Lr.getScriptKind)(a.filePath, a.jsx));
          }
          M.createSourceFile = ke;
        } }), cz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/semantic-or-syntactic-errors.js"(M) {
          "use strict";
          Ea(), Object.defineProperty(M, "__esModule", { value: true }), M.getFirstSemanticOrSyntacticError = void 0;
          var re = _u();
          function Ve(kr, pr) {
            try {
              let Lr = Ke(kr.getSyntacticDiagnostics(pr));
              if (Lr.length)
                return oi(Lr[0]);
              let ar = Ke(kr.getSemanticDiagnostics(pr));
              return ar.length ? oi(ar[0]) : void 0;
            } catch (Lr) {
              console.warn('Warning From TSC: "'.concat(Lr.message));
              return;
            }
          }
          M.getFirstSemanticOrSyntacticError = Ve;
          function Ke(kr) {
            return kr.filter((pr) => {
              switch (pr.code) {
                case 1013:
                case 1014:
                case 1044:
                case 1045:
                case 1048:
                case 1049:
                case 1070:
                case 1071:
                case 1085:
                case 1090:
                case 1096:
                case 1097:
                case 1098:
                case 1099:
                case 1117:
                case 1121:
                case 1123:
                case 1141:
                case 1162:
                case 1164:
                case 1172:
                case 1173:
                case 1175:
                case 1176:
                case 1190:
                case 1196:
                case 1200:
                case 1206:
                case 1211:
                case 1242:
                case 1246:
                case 1255:
                case 1308:
                case 2364:
                case 2369:
                case 2452:
                case 2462:
                case 8017:
                case 17012:
                case 17013:
                  return true;
              }
              return false;
            });
          }
          function oi(kr) {
            return Object.assign(Object.assign({}, kr), { message: (0, re.flattenDiagnosticMessageText)(kr.messageText, re.sys.newLine) });
          }
        } }), l3 = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/create-program/useProvidedPrograms.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(B, E, Q, le) {
            le === void 0 && (le = Q);
            var N = Object.getOwnPropertyDescriptor(E, Q);
            (!N || ("get" in N ? !E.__esModule : N.writable || N.configurable)) && (N = { enumerable: true, get: function() {
              return E[Q];
            } }), Object.defineProperty(B, le, N);
          } : function(B, E, Q, le) {
            le === void 0 && (le = Q), B[le] = E[Q];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(B, E) {
            Object.defineProperty(B, "default", { enumerable: true, value: E });
          } : function(B, E) {
            B.default = E;
          }), Ke = M && M.__importStar || function(B) {
            if (B && B.__esModule)
              return B;
            var E = {};
            if (B != null)
              for (var Q in B)
                Q !== "default" && Object.prototype.hasOwnProperty.call(B, Q) && re(E, B, Q);
            return Ve(E, B), E;
          }, oi = M && M.__importDefault || function(B) {
            return B && B.__esModule ? B : { default: B };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.createProgramFromConfigFile = M.useProvidedPrograms = void 0;
          var kr = oi(wm()), pr = Ke(ex()), Lr = Ke(Fv()), ar = Ke(_u()), ke = Mv(), e2 = (0, kr.default)("typescript-eslint:typescript-estree:useProvidedProgram");
          function a(B, E) {
            e2("Retrieving ast for %s from provided program instance(s)", E.filePath);
            let Q;
            for (let le of B)
              if (Q = (0, ke.getAstFromProgram)(le, E), Q)
                break;
            if (!Q) {
              let le = Lr.relative(E.tsconfigRootDir || "/prettier-security-dirname-placeholder", E.filePath), N = ['"parserOptions.programs" has been provided for @typescript-eslint/parser.', "The file was not found in any of the provided program instance(s): ".concat(le)];
              throw new Error(N.join(`
`));
            }
            return Q.program.getTypeChecker(), Q;
          }
          M.useProvidedPrograms = a;
          function C(B, E) {
            if (ar.sys === void 0)
              throw new Error("`createProgramFromConfigFile` is only supported in a Node-like environment.");
            let le = ar.getParsedCommandLineOfConfigFile(B, ke.CORE_COMPILER_OPTIONS, { onUnRecoverableConfigFileDiagnostic: (p) => {
              throw new Error(w([p]));
            }, fileExists: pr.existsSync, getCurrentDirectory: () => E && Lr.resolve(E) || "/prettier-security-dirname-placeholder", readDirectory: ar.sys.readDirectory, readFile: (p) => pr.readFileSync(p, "utf-8"), useCaseSensitiveFileNames: ar.sys.useCaseSensitiveFileNames });
            if (le.errors.length)
              throw new Error(w(le.errors));
            let N = ar.createCompilerHost(le.options, true);
            return ar.createProgram(le.fileNames, le.options, N);
          }
          M.createProgramFromConfigFile = C;
          function w(B) {
            return ar.formatDiagnostics(B, { getCanonicalFileName: (E) => E, getCurrentDirectory: Eu.cwd, getNewLine: () => `
` });
          }
        } }), uz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/parser.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(y, V, L, P) {
            P === void 0 && (P = L);
            var k = Object.getOwnPropertyDescriptor(V, L);
            (!k || ("get" in k ? !V.__esModule : k.writable || k.configurable)) && (k = { enumerable: true, get: function() {
              return V[L];
            } }), Object.defineProperty(y, P, k);
          } : function(y, V, L, P) {
            P === void 0 && (P = L), y[P] = V[L];
          }), Ve = M && M.__setModuleDefault || (Object.create ? function(y, V) {
            Object.defineProperty(y, "default", { enumerable: true, value: V });
          } : function(y, V) {
            y.default = V;
          }), Ke = M && M.__importStar || function(y) {
            if (y && y.__esModule)
              return y;
            var V = {};
            if (y != null)
              for (var L in y)
                L !== "default" && Object.prototype.hasOwnProperty.call(y, L) && re(V, y, L);
            return Ve(V, y), V;
          }, oi = M && M.__importDefault || function(y) {
            return y && y.__esModule ? y : { default: y };
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.clearParseAndGenerateServicesCalls = M.clearProgramCache = M.parseWithNodeMaps = M.parseAndGenerateServices = M.parse = void 0;
          var kr = oi(wm()), pr = oi(Vj()), Lr = oi(QT()), ar = Fv(), ke = Ke(_u()), e2 = tz(), a = e3(), C = az(), w = nz(), B = oz(), E = sz(), Q = cz(), le = Mv(), N = l3(), p = (0, kr.default)("typescript-eslint:typescript-estree:parser"), m2 = ">=3.3.1 <4.8.0", G = [], oe = ke.version, f4 = Lr.default.satisfies(oe, [m2].concat(G).join(" || ")), T, K = false, b = /* @__PURE__ */ new Map();
          function se() {
            b.clear();
          }
          M.clearProgramCache = se;
          function J(y) {
            return typeof y != "string" ? String(y) : y;
          }
          function ie(y, V, L, P) {
            return V && (0, N.useProvidedPrograms)(V, T) || L && (0, B.createProjectProgram)(y, P, T) || L && P && (0, C.createDefaultProgram)(y, T) || (0, w.createIsolatedProgram)(y, T);
          }
          function R() {
            let { jsx: y } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
            return y ? "estree.tsx" : "estree.ts";
          }
          function q() {
            T = { code: "", comment: false, comments: [], createDefaultProgram: false, debugLevel: /* @__PURE__ */ new Set(), errorOnTypeScriptSyntacticAndSemanticIssues: false, errorOnUnknownASTType: false, EXPERIMENTAL_useSourceOfProjectReferenceRedirect: false, extraFileExtensions: [], filePath: R(), jsx: false, loc: false, log: console.log, preserveNodeMaps: true, programs: null, projects: [], range: false, strict: false, tokens: null, tsconfigRootDir: "/prettier-security-dirname-placeholder", singleRun: false, moduleResolver: "" };
          }
          function O(y) {
            var V;
            if (y.debugLevel === true ? T.debugLevel = /* @__PURE__ */ new Set(["typescript-eslint"]) : Array.isArray(y.debugLevel) && (T.debugLevel = new Set(y.debugLevel)), T.debugLevel.size > 0) {
              let L = [];
              T.debugLevel.has("typescript-eslint") && L.push("typescript-eslint:*"), (T.debugLevel.has("eslint") || kr.default.enabled("eslint:*,-eslint:code-path")) && L.push("eslint:*,-eslint:code-path"), kr.default.enable(L.join(","));
            }
            if (T.range = typeof y.range == "boolean" && y.range, T.loc = typeof y.loc == "boolean" && y.loc, typeof y.tokens == "boolean" && y.tokens && (T.tokens = []), typeof y.comment == "boolean" && y.comment && (T.comment = true, T.comments = []), typeof y.jsx != "boolean" ? T.jsx = false : T.jsx = y.jsx, typeof y.filePath == "string" && y.filePath !== "<input>" ? T.filePath = y.filePath : T.filePath = R(T), typeof y.errorOnUnknownASTType == "boolean" && y.errorOnUnknownASTType && (T.errorOnUnknownASTType = true), typeof y.loggerFn == "function" ? T.log = y.loggerFn : y.loggerFn === false && (T.log = () => {
            }), typeof y.tsconfigRootDir == "string" && (T.tsconfigRootDir = y.tsconfigRootDir), T.filePath = (0, le.ensureAbsolutePath)(T.filePath, T), Array.isArray(y.programs)) {
              if (!y.programs.length)
                throw new Error("You have set parserOptions.programs to an empty array. This will cause all files to not be found in existing programs. Either provide one or more existing TypeScript Program instances in the array, or remove the parserOptions.programs setting.");
              T.programs = y.programs, p("parserOptions.programs was provided, so parserOptions.project will be ignored.");
            }
            if (!T.programs) {
              let L = ((V = y.projectFolderIgnoreList) !== null && V !== void 0 ? V : ["**/node_modules/**"]).reduce((P, k) => (typeof k == "string" && P.push(k), P), []).map((P) => P.startsWith("!") ? P : "!".concat(P));
              T.projects = [];
            }
            Array.isArray(y.extraFileExtensions) && y.extraFileExtensions.every((L) => typeof L == "string") && (T.extraFileExtensions = y.extraFileExtensions), typeof y.preserveNodeMaps == "boolean" && (T.preserveNodeMaps = y.preserveNodeMaps), T.createDefaultProgram = typeof y.createDefaultProgram == "boolean" && y.createDefaultProgram, T.EXPERIMENTAL_useSourceOfProjectReferenceRedirect = typeof y.EXPERIMENTAL_useSourceOfProjectReferenceRedirect == "boolean" && y.EXPERIMENTAL_useSourceOfProjectReferenceRedirect, typeof y.moduleResolver == "string" && (T.moduleResolver = y.moduleResolver);
          }
          function ve() {
            var y;
            if (!f4 && !K) {
              if (typeof Eu > "u" ? false : (y = Eu.stdout) === null || y === void 0 ? void 0 : y.isTTY) {
                let L = "=============", P = [L, "WARNING: You are currently running a version of TypeScript which is not officially supported by @typescript-eslint/typescript-estree.", "You may find that it works just fine, or you may not.", "SUPPORTED TYPESCRIPT VERSIONS: ".concat(m2), "YOUR TYPESCRIPT VERSION: ".concat(oe), "Please only submit bug reports when using the officially supported version.", L];
                T.log(P.join(`

`));
              }
              K = true;
            }
          }
          function ee(y) {
            if (Eu.env.TSESTREE_SINGLE_RUN === "false") {
              T.singleRun = false;
              return;
            }
            if (Eu.env.TSESTREE_SINGLE_RUN === "true") {
              T.singleRun = true;
              return;
            }
            if (y != null && y.allowAutomaticSingleRunInference && (Eu.env.CI === "true" || Eu.argv[1].endsWith((0, ar.normalize)("node_modules/.bin/eslint")))) {
              T.singleRun = true;
              return;
            }
            T.singleRun = false;
          }
          function he(y, V) {
            let { ast: L } = F2(y, V, false);
            return L;
          }
          M.parse = he;
          function F2(y, V, L) {
            if (q(), V != null && V.errorOnTypeScriptSyntacticAndSemanticIssues)
              throw new Error('"errorOnTypeScriptSyntacticAndSemanticIssues" is only supported for parseAndGenerateServices()');
            y = J(y), T.code = y, typeof V < "u" && O(V), ve(), ee(V);
            let P = (0, E.createSourceFile)(y, T), { estree: k, astMaps: Y } = (0, e2.astConverter)(P, T, L);
            return { ast: k, esTreeNodeToTSNodeMap: Y.esTreeNodeToTSNodeMap, tsNodeToESTreeNodeMap: Y.tsNodeToESTreeNodeMap };
          }
          function x2(y, V) {
            return F2(y, V, true);
          }
          M.parseWithNodeMaps = x2;
          var X = {};
          function $() {
            X = {};
          }
          M.clearParseAndGenerateServicesCalls = $;
          function A2(y, V) {
            var L;
            q(), y = J(y), T.code = y, typeof V < "u" && (O(V), typeof V.errorOnTypeScriptSyntacticAndSemanticIssues == "boolean" && V.errorOnTypeScriptSyntacticAndSemanticIssues && (T.errorOnTypeScriptSyntacticAndSemanticIssues = true)), ve(), ee(V), T.singleRun && !T.programs && ((L = T.projects) === null || L === void 0 ? void 0 : L.length) > 0 && (T.programs = { *[Symbol.iterator]() {
              for (let I of T.projects) {
                let l = b.get(I);
                if (l)
                  yield l;
                else {
                  p("Detected single-run/CLI usage, creating Program once ahead of time for project: %s", I);
                  let d = (0, N.createProgramFromConfigFile)(I);
                  b.set(I, d), yield d;
                }
              }
            } });
            let P = T.programs != null || T.projects && T.projects.length > 0, k, Y;
            if (T.singleRun && V.filePath && (X[V.filePath] = (X[V.filePath] || 0) + 1), T.singleRun && V.filePath && X[V.filePath] > 1) {
              let I = (0, w.createIsolatedProgram)(y, T);
              k = I.ast, Y = I.program;
            } else {
              let I = ie(y, T.programs, P, T.createDefaultProgram);
              k = I.ast, Y = I.program;
            }
            let U = typeof T.preserveNodeMaps == "boolean" ? T.preserveNodeMaps : true, { estree: j, astMaps: H } = (0, e2.astConverter)(k, T, U);
            if (Y && T.errorOnTypeScriptSyntacticAndSemanticIssues) {
              let I = (0, Q.getFirstSemanticOrSyntacticError)(Y, k);
              if (I)
                throw (0, a.convertError)(I);
            }
            return { ast: j, services: { hasFullTypeInformation: P, program: Y, esTreeNodeToTSNodeMap: H.esTreeNodeToTSNodeMap, tsNodeToESTreeNodeMap: H.tsNodeToESTreeNodeMap } };
          }
          M.parseAndGenerateServices = A2;
        } }), lz = Oa({ "node_modules/@typescript-eslint/typescript-estree/package.json"(M, re) {
          re.exports = { name: "@typescript-eslint/typescript-estree", version: "5.27.0", description: "A parser that converts TypeScript source code into an ESTree compatible form", main: "dist/index.js", types: "dist/index.d.ts", files: ["dist", "README.md", "LICENSE"], engines: { node: "^12.22.0 || ^14.17.0 || >=16.0.0" }, repository: { type: "git", url: "https://github.com/typescript-eslint/typescript-eslint.git", directory: "packages/typescript-estree" }, bugs: { url: "https://github.com/typescript-eslint/typescript-eslint/issues" }, license: "BSD-2-Clause", keywords: ["ast", "estree", "ecmascript", "javascript", "typescript", "parser", "syntax"], scripts: { build: "tsc -b tsconfig.build.json", postbuild: "downlevel-dts dist _ts3.4/dist", clean: "tsc -b tsconfig.build.json --clean", postclean: "rimraf dist && rimraf _ts3.4 && rimraf coverage", format: 'prettier --write "./**/*.{ts,mts,cts,tsx,js,mjs,cjs,jsx,json,md,css}" --ignore-path ../../.prettierignore', lint: "eslint . --ignore-path='../../.eslintignore'", test: "jest --coverage", typecheck: "tsc -p tsconfig.json --noEmit" }, dependencies: { "@typescript-eslint/types": "5.27.0", "@typescript-eslint/visitor-keys": "5.27.0", debug: "^4.3.4", globby: "^11.1.0", "is-glob": "^4.0.3", semver: "^7.3.7", tsutils: "^3.21.0" }, devDependencies: { "@babel/code-frame": "*", "@babel/parser": "*", "@types/babel__code-frame": "*", "@types/debug": "*", "@types/glob": "*", "@types/is-glob": "*", "@types/semver": "*", "@types/tmp": "*", "@typescript-eslint/shared-fixtures": "5.27.0", glob: "*", "jest-specific-snapshot": "*", "make-dir": "*", tmp: "*", typescript: "*" }, peerDependenciesMeta: { typescript: { optional: true } }, funding: { type: "opencollective", url: "https://opencollective.com/typescript-eslint" }, typesVersions: { "<3.8": { "*": ["_ts3.4/*"] } }, gitHead: "e0db364b94158437f041db3597101d0c8b30d8bc" };
        } }), fz = Oa({ "node_modules/@typescript-eslint/typescript-estree/dist/index.js"(M) {
          "use strict";
          Ea();
          var re = M && M.__createBinding || (Object.create ? function(ar, ke, e2, a) {
            a === void 0 && (a = e2);
            var C = Object.getOwnPropertyDescriptor(ke, e2);
            (!C || ("get" in C ? !ke.__esModule : C.writable || C.configurable)) && (C = { enumerable: true, get: function() {
              return ke[e2];
            } }), Object.defineProperty(ar, a, C);
          } : function(ar, ke, e2, a) {
            a === void 0 && (a = e2), ar[a] = ke[e2];
          }), Ve = M && M.__exportStar || function(ar, ke) {
            for (var e2 in ar)
              e2 !== "default" && !Object.prototype.hasOwnProperty.call(ke, e2) && re(ke, ar, e2);
          };
          Object.defineProperty(M, "__esModule", { value: true }), M.version = M.visitorKeys = M.createProgram = M.clearCaches = M.simpleTraverse = M.clearProgramCache = M.parseWithNodeMaps = M.parseAndGenerateServices = M.parse = void 0;
          var Ke = uz();
          Object.defineProperty(M, "parse", { enumerable: true, get: function() {
            return Ke.parse;
          } }), Object.defineProperty(M, "parseAndGenerateServices", { enumerable: true, get: function() {
            return Ke.parseAndGenerateServices;
          } }), Object.defineProperty(M, "parseWithNodeMaps", { enumerable: true, get: function() {
            return Ke.parseWithNodeMaps;
          } }), Object.defineProperty(M, "clearProgramCache", { enumerable: true, get: function() {
            return Ke.clearProgramCache;
          } });
          var oi = c3();
          Object.defineProperty(M, "simpleTraverse", { enumerable: true, get: function() {
            return oi.simpleTraverse;
          } }), Ve(k1(), M);
          var kr = u3();
          Object.defineProperty(M, "clearCaches", { enumerable: true, get: function() {
            return kr.clearWatchCaches;
          } });
          var pr = l3();
          Object.defineProperty(M, "createProgram", { enumerable: true, get: function() {
            return pr.createProgramFromConfigFile;
          } }), Ve(rx(), M);
          var Lr = s3();
          Object.defineProperty(M, "visitorKeys", { enumerable: true, get: function() {
            return Lr.visitorKeys;
          } }), M.version = lz().version;
        } });
        Ea();
        var _z = S4(), pz = Tj(), dz = Fj(), gz = Mj(), mz = Uj(), b4 = { loc: true, range: true, comment: true, jsx: true, tokens: true, loggerFn: false, project: [] };
        function vz(M) {
          let { message: re, lineNumber: Ve, column: Ke } = M;
          return typeof Ve != "number" ? M : _z(re, { start: { line: Ve, column: Ke + 1 } });
        }
        function yz(M, re) {
          let Ve = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, Ke = gz(M), oi = hz(M), { parseWithNodeMaps: kr } = fz(), { result: pr, error: Lr } = pz(() => kr(Ke, Object.assign(Object.assign({}, b4), {}, { jsx: oi })), () => kr(Ke, Object.assign(Object.assign({}, b4), {}, { jsx: !oi })));
          if (!pr)
            throw vz(Lr);
          return Ve.originalText = M, Ve.tsParseResult = pr, mz(pr.ast, Ve);
        }
        function hz(M) {
          return new RegExp(["(?:^[^\"'`]*</)", "|", "(?:^[^/]{2}.*/>)"].join(""), "m").test(M);
        }
        f3.exports = { parsers: { typescript: dz(yz) } };
      });
      return Dz();
    });
  }
});

// node_modules/prettier/parser-angular.js
var require_parser_angular = __commonJS({
  "node_modules/prettier/parser-angular.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.angular = e2();
      }
    })(function() {
      "use strict";
      var un = (e2, t2) => () => (t2 || e2((t2 = { exports: {} }).exports, t2), t2.exports);
      var Mn = un((jn, on) => {
        var ze = Object.defineProperty, hn = Object.getOwnPropertyDescriptor, He = Object.getOwnPropertyNames, ln = Object.prototype.hasOwnProperty, Y = (e2, t2) => function() {
          return e2 && (t2 = (0, e2[He(e2)[0]])(e2 = 0)), t2;
        }, q = (e2, t2) => function() {
          return t2 || (0, e2[He(e2)[0]])((t2 = { exports: {} }).exports, t2), t2.exports;
        }, Xe = (e2, t2) => {
          for (var n in t2)
            ze(e2, n, { get: t2[n], enumerable: true });
        }, pn = (e2, t2, n, r2) => {
          if (t2 && typeof t2 == "object" || typeof t2 == "function")
            for (let s2 of He(t2))
              !ln.call(e2, s2) && s2 !== n && ze(e2, s2, { get: () => t2[s2], enumerable: !(r2 = hn(t2, s2)) || r2.enumerable });
          return e2;
        }, be = (e2) => pn(ze({}, "__esModule", { value: true }), e2), L = Y({ "<define:process>"() {
        } }), dn = q({ "src/utils/is-non-empty-array.js"(e2, t2) {
          "use strict";
          L();
          function n(r2) {
            return Array.isArray(r2) && r2.length > 0;
          }
          t2.exports = n;
        } }), fn = q({ "src/language-js/loc.js"(e2, t2) {
          "use strict";
          L();
          var n = dn();
          function r2(h2, P) {
            let { ignoreDecorators: p } = P || {};
            if (!p) {
              let x2 = h2.declaration && h2.declaration.decorators || h2.decorators;
              if (n(x2))
                return r2(x2[0]);
            }
            return h2.range ? h2.range[0] : h2.start;
          }
          function s2(h2) {
            return h2.range ? h2.range[1] : h2.end;
          }
          function a(h2, P) {
            let p = r2(h2);
            return Number.isInteger(p) && p === r2(P);
          }
          function i2(h2, P) {
            let p = s2(h2);
            return Number.isInteger(p) && p === s2(P);
          }
          function l(h2, P) {
            return a(h2, P) && i2(h2, P);
          }
          t2.exports = { locStart: r2, locEnd: s2, hasSameLocStart: a, hasSameLoc: l };
        } }), gn = q({ "node_modules/angular-estree-parser/node_modules/lines-and-columns/build/index.js"(e2) {
          "use strict";
          L(), e2.__esModule = true, e2.LinesAndColumns = void 0;
          var t2 = `
`, n = "\r", r2 = function() {
            function s2(a) {
              this.string = a;
              for (var i2 = [0], l = 0; l < a.length; )
                switch (a[l]) {
                  case t2:
                    l += t2.length, i2.push(l);
                    break;
                  case n:
                    l += n.length, a[l] === t2 && (l += t2.length), i2.push(l);
                    break;
                  default:
                    l++;
                    break;
                }
              this.offsets = i2;
            }
            return s2.prototype.locationForIndex = function(a) {
              if (a < 0 || a > this.string.length)
                return null;
              for (var i2 = 0, l = this.offsets; l[i2 + 1] <= a; )
                i2++;
              var h2 = a - l[i2];
              return { line: i2, column: h2 };
            }, s2.prototype.indexForLocation = function(a) {
              var i2 = a.line, l = a.column;
              return i2 < 0 || i2 >= this.offsets.length || l < 0 || l > this.lengthOfLine(i2) ? null : this.offsets[i2] + l;
            }, s2.prototype.lengthOfLine = function(a) {
              var i2 = this.offsets[a], l = a === this.offsets.length - 1 ? this.string.length : this.offsets[a + 1];
              return l - i2;
            }, s2;
          }();
          e2.LinesAndColumns = r2, e2.default = r2;
        } }), vn = q({ "node_modules/angular-estree-parser/lib/context.js"(e2) {
          "use strict";
          L(), Object.defineProperty(e2, "__esModule", { value: true }), e2.Context = void 0;
          var t2 = gn(), n = class {
            constructor(s2) {
              this.text = s2, this.locator = new r2(this.text);
            }
          };
          e2.Context = n;
          var r2 = class {
            constructor(s2) {
              this._lineAndColumn = new t2.default(s2);
            }
            locationForIndex(s2) {
              let { line: a, column: i2 } = this._lineAndColumn.locationForIndex(s2);
              return { line: a + 1, column: i2 };
            }
          };
        } }), Je = {};
        Xe(Je, { AST: () => k, ASTWithName: () => W, ASTWithSource: () => G, AbsoluteSourceSpan: () => U, AstMemoryEfficientTransformer: () => Ct, AstTransformer: () => Pt, Binary: () => K, BindingPipe: () => fe, BoundElementProperty: () => It, Chain: () => oe, Conditional: () => ce, EmptyExpr: () => M, ExpressionBinding: () => Ze, FunctionCall: () => Pe, ImplicitReceiver: () => Oe, Interpolation: () => me, KeyedRead: () => le, KeyedWrite: () => de, LiteralArray: () => ge, LiteralMap: () => ve, LiteralPrimitive: () => B, MethodCall: () => ye, NonNullAssert: () => Se, ParseSpan: () => V, ParsedEvent: () => At, ParsedProperty: () => Et, ParsedPropertyType: () => se, ParsedVariable: () => _t, ParserError: () => ae, PrefixNot: () => xe, PropertyRead: () => re, PropertyWrite: () => ue, Quote: () => Le, RecursiveAstVisitor: () => et, SafeKeyedRead: () => pe, SafeMethodCall: () => we, SafePropertyRead: () => he, ThisReceiver: () => Ye, Unary: () => F2, VariableBinding: () => Re });
        var ae, V, k, W, Le, M, Oe, Ye, oe, ce, re, ue, he, le, pe, de, fe, B, ge, ve, me, K, F2, xe, Se, ye, we, Pe, U, G, Re, Ze, et, Pt, Ct, Et, se, At, _t, It, tt = Y({ "node_modules/@angular/compiler/esm2015/src/expression_parser/ast.js"() {
          L(), ae = class {
            constructor(e2, t2, n, r2) {
              this.input = t2, this.errLocation = n, this.ctxLocation = r2, this.message = "Parser Error: ".concat(e2, " ").concat(n, " [").concat(t2, "] in ").concat(r2);
            }
          }, V = class {
            constructor(e2, t2) {
              this.start = e2, this.end = t2;
            }
            toAbsolute(e2) {
              return new U(e2 + this.start, e2 + this.end);
            }
          }, k = class {
            constructor(e2, t2) {
              this.span = e2, this.sourceSpan = t2;
            }
            toString() {
              return "AST";
            }
          }, W = class extends k {
            constructor(e2, t2, n) {
              super(e2, t2), this.nameSpan = n;
            }
          }, Le = class extends k {
            constructor(e2, t2, n, r2, s2) {
              super(e2, t2), this.prefix = n, this.uninterpretedExpression = r2, this.location = s2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitQuote(this, t2);
            }
            toString() {
              return "Quote";
            }
          }, M = class extends k {
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
            }
          }, Oe = class extends k {
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitImplicitReceiver(this, t2);
            }
          }, Ye = class extends Oe {
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              var n;
              return (n = e2.visitThisReceiver) === null || n === void 0 ? void 0 : n.call(e2, this, t2);
            }
          }, oe = class extends k {
            constructor(e2, t2, n) {
              super(e2, t2), this.expressions = n;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitChain(this, t2);
            }
          }, ce = class extends k {
            constructor(e2, t2, n, r2, s2) {
              super(e2, t2), this.condition = n, this.trueExp = r2, this.falseExp = s2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitConditional(this, t2);
            }
          }, re = class extends W {
            constructor(e2, t2, n, r2, s2) {
              super(e2, t2, n), this.receiver = r2, this.name = s2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitPropertyRead(this, t2);
            }
          }, ue = class extends W {
            constructor(e2, t2, n, r2, s2, a) {
              super(e2, t2, n), this.receiver = r2, this.name = s2, this.value = a;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitPropertyWrite(this, t2);
            }
          }, he = class extends W {
            constructor(e2, t2, n, r2, s2) {
              super(e2, t2, n), this.receiver = r2, this.name = s2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitSafePropertyRead(this, t2);
            }
          }, le = class extends k {
            constructor(e2, t2, n, r2) {
              super(e2, t2), this.receiver = n, this.key = r2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitKeyedRead(this, t2);
            }
          }, pe = class extends k {
            constructor(e2, t2, n, r2) {
              super(e2, t2), this.receiver = n, this.key = r2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitSafeKeyedRead(this, t2);
            }
          }, de = class extends k {
            constructor(e2, t2, n, r2, s2) {
              super(e2, t2), this.receiver = n, this.key = r2, this.value = s2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitKeyedWrite(this, t2);
            }
          }, fe = class extends W {
            constructor(e2, t2, n, r2, s2, a) {
              super(e2, t2, a), this.exp = n, this.name = r2, this.args = s2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitPipe(this, t2);
            }
          }, B = class extends k {
            constructor(e2, t2, n) {
              super(e2, t2), this.value = n;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitLiteralPrimitive(this, t2);
            }
          }, ge = class extends k {
            constructor(e2, t2, n) {
              super(e2, t2), this.expressions = n;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitLiteralArray(this, t2);
            }
          }, ve = class extends k {
            constructor(e2, t2, n, r2) {
              super(e2, t2), this.keys = n, this.values = r2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitLiteralMap(this, t2);
            }
          }, me = class extends k {
            constructor(e2, t2, n, r2) {
              super(e2, t2), this.strings = n, this.expressions = r2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitInterpolation(this, t2);
            }
          }, K = class extends k {
            constructor(e2, t2, n, r2, s2) {
              super(e2, t2), this.operation = n, this.left = r2, this.right = s2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitBinary(this, t2);
            }
          }, F2 = class extends K {
            constructor(e2, t2, n, r2, s2, a, i2) {
              super(e2, t2, s2, a, i2), this.operator = n, this.expr = r2;
            }
            static createMinus(e2, t2, n) {
              return new F2(e2, t2, "-", n, "-", new B(e2, t2, 0), n);
            }
            static createPlus(e2, t2, n) {
              return new F2(e2, t2, "+", n, "-", n, new B(e2, t2, 0));
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitUnary !== void 0 ? e2.visitUnary(this, t2) : e2.visitBinary(this, t2);
            }
          }, xe = class extends k {
            constructor(e2, t2, n) {
              super(e2, t2), this.expression = n;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitPrefixNot(this, t2);
            }
          }, Se = class extends k {
            constructor(e2, t2, n) {
              super(e2, t2), this.expression = n;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitNonNullAssert(this, t2);
            }
          }, ye = class extends W {
            constructor(e2, t2, n, r2, s2, a, i2) {
              super(e2, t2, n), this.receiver = r2, this.name = s2, this.args = a, this.argumentSpan = i2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitMethodCall(this, t2);
            }
          }, we = class extends W {
            constructor(e2, t2, n, r2, s2, a, i2) {
              super(e2, t2, n), this.receiver = r2, this.name = s2, this.args = a, this.argumentSpan = i2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitSafeMethodCall(this, t2);
            }
          }, Pe = class extends k {
            constructor(e2, t2, n, r2) {
              super(e2, t2), this.target = n, this.args = r2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitFunctionCall(this, t2);
            }
          }, U = class {
            constructor(e2, t2) {
              this.start = e2, this.end = t2;
            }
          }, G = class extends k {
            constructor(e2, t2, n, r2, s2) {
              super(new V(0, t2 === null ? 0 : t2.length), new U(r2, t2 === null ? r2 : r2 + t2.length)), this.ast = e2, this.source = t2, this.location = n, this.errors = s2;
            }
            visit(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              return e2.visitASTWithSource ? e2.visitASTWithSource(this, t2) : this.ast.visit(e2, t2);
            }
            toString() {
              return "".concat(this.source, " in ").concat(this.location);
            }
          }, Re = class {
            constructor(e2, t2, n) {
              this.sourceSpan = e2, this.key = t2, this.value = n;
            }
          }, Ze = class {
            constructor(e2, t2, n) {
              this.sourceSpan = e2, this.key = t2, this.value = n;
            }
          }, et = class {
            visit(e2, t2) {
              e2.visit(this, t2);
            }
            visitUnary(e2, t2) {
              this.visit(e2.expr, t2);
            }
            visitBinary(e2, t2) {
              this.visit(e2.left, t2), this.visit(e2.right, t2);
            }
            visitChain(e2, t2) {
              this.visitAll(e2.expressions, t2);
            }
            visitConditional(e2, t2) {
              this.visit(e2.condition, t2), this.visit(e2.trueExp, t2), this.visit(e2.falseExp, t2);
            }
            visitPipe(e2, t2) {
              this.visit(e2.exp, t2), this.visitAll(e2.args, t2);
            }
            visitFunctionCall(e2, t2) {
              e2.target && this.visit(e2.target, t2), this.visitAll(e2.args, t2);
            }
            visitImplicitReceiver(e2, t2) {
            }
            visitThisReceiver(e2, t2) {
            }
            visitInterpolation(e2, t2) {
              this.visitAll(e2.expressions, t2);
            }
            visitKeyedRead(e2, t2) {
              this.visit(e2.receiver, t2), this.visit(e2.key, t2);
            }
            visitKeyedWrite(e2, t2) {
              this.visit(e2.receiver, t2), this.visit(e2.key, t2), this.visit(e2.value, t2);
            }
            visitLiteralArray(e2, t2) {
              this.visitAll(e2.expressions, t2);
            }
            visitLiteralMap(e2, t2) {
              this.visitAll(e2.values, t2);
            }
            visitLiteralPrimitive(e2, t2) {
            }
            visitMethodCall(e2, t2) {
              this.visit(e2.receiver, t2), this.visitAll(e2.args, t2);
            }
            visitPrefixNot(e2, t2) {
              this.visit(e2.expression, t2);
            }
            visitNonNullAssert(e2, t2) {
              this.visit(e2.expression, t2);
            }
            visitPropertyRead(e2, t2) {
              this.visit(e2.receiver, t2);
            }
            visitPropertyWrite(e2, t2) {
              this.visit(e2.receiver, t2), this.visit(e2.value, t2);
            }
            visitSafePropertyRead(e2, t2) {
              this.visit(e2.receiver, t2);
            }
            visitSafeMethodCall(e2, t2) {
              this.visit(e2.receiver, t2), this.visitAll(e2.args, t2);
            }
            visitSafeKeyedRead(e2, t2) {
              this.visit(e2.receiver, t2), this.visit(e2.key, t2);
            }
            visitQuote(e2, t2) {
            }
            visitAll(e2, t2) {
              for (let n of e2)
                this.visit(n, t2);
            }
          }, Pt = class {
            visitImplicitReceiver(e2, t2) {
              return e2;
            }
            visitThisReceiver(e2, t2) {
              return e2;
            }
            visitInterpolation(e2, t2) {
              return new me(e2.span, e2.sourceSpan, e2.strings, this.visitAll(e2.expressions));
            }
            visitLiteralPrimitive(e2, t2) {
              return new B(e2.span, e2.sourceSpan, e2.value);
            }
            visitPropertyRead(e2, t2) {
              return new re(e2.span, e2.sourceSpan, e2.nameSpan, e2.receiver.visit(this), e2.name);
            }
            visitPropertyWrite(e2, t2) {
              return new ue(e2.span, e2.sourceSpan, e2.nameSpan, e2.receiver.visit(this), e2.name, e2.value.visit(this));
            }
            visitSafePropertyRead(e2, t2) {
              return new he(e2.span, e2.sourceSpan, e2.nameSpan, e2.receiver.visit(this), e2.name);
            }
            visitMethodCall(e2, t2) {
              return new ye(e2.span, e2.sourceSpan, e2.nameSpan, e2.receiver.visit(this), e2.name, this.visitAll(e2.args), e2.argumentSpan);
            }
            visitSafeMethodCall(e2, t2) {
              return new we(e2.span, e2.sourceSpan, e2.nameSpan, e2.receiver.visit(this), e2.name, this.visitAll(e2.args), e2.argumentSpan);
            }
            visitFunctionCall(e2, t2) {
              return new Pe(e2.span, e2.sourceSpan, e2.target.visit(this), this.visitAll(e2.args));
            }
            visitLiteralArray(e2, t2) {
              return new ge(e2.span, e2.sourceSpan, this.visitAll(e2.expressions));
            }
            visitLiteralMap(e2, t2) {
              return new ve(e2.span, e2.sourceSpan, e2.keys, this.visitAll(e2.values));
            }
            visitUnary(e2, t2) {
              switch (e2.operator) {
                case "+":
                  return F2.createPlus(e2.span, e2.sourceSpan, e2.expr.visit(this));
                case "-":
                  return F2.createMinus(e2.span, e2.sourceSpan, e2.expr.visit(this));
                default:
                  throw new Error("Unknown unary operator ".concat(e2.operator));
              }
            }
            visitBinary(e2, t2) {
              return new K(e2.span, e2.sourceSpan, e2.operation, e2.left.visit(this), e2.right.visit(this));
            }
            visitPrefixNot(e2, t2) {
              return new xe(e2.span, e2.sourceSpan, e2.expression.visit(this));
            }
            visitNonNullAssert(e2, t2) {
              return new Se(e2.span, e2.sourceSpan, e2.expression.visit(this));
            }
            visitConditional(e2, t2) {
              return new ce(e2.span, e2.sourceSpan, e2.condition.visit(this), e2.trueExp.visit(this), e2.falseExp.visit(this));
            }
            visitPipe(e2, t2) {
              return new fe(e2.span, e2.sourceSpan, e2.exp.visit(this), e2.name, this.visitAll(e2.args), e2.nameSpan);
            }
            visitKeyedRead(e2, t2) {
              return new le(e2.span, e2.sourceSpan, e2.receiver.visit(this), e2.key.visit(this));
            }
            visitKeyedWrite(e2, t2) {
              return new de(e2.span, e2.sourceSpan, e2.receiver.visit(this), e2.key.visit(this), e2.value.visit(this));
            }
            visitAll(e2) {
              let t2 = [];
              for (let n = 0; n < e2.length; ++n)
                t2[n] = e2[n].visit(this);
              return t2;
            }
            visitChain(e2, t2) {
              return new oe(e2.span, e2.sourceSpan, this.visitAll(e2.expressions));
            }
            visitQuote(e2, t2) {
              return new Le(e2.span, e2.sourceSpan, e2.prefix, e2.uninterpretedExpression, e2.location);
            }
            visitSafeKeyedRead(e2, t2) {
              return new pe(e2.span, e2.sourceSpan, e2.receiver.visit(this), e2.key.visit(this));
            }
          }, Ct = class {
            visitImplicitReceiver(e2, t2) {
              return e2;
            }
            visitThisReceiver(e2, t2) {
              return e2;
            }
            visitInterpolation(e2, t2) {
              let n = this.visitAll(e2.expressions);
              return n !== e2.expressions ? new me(e2.span, e2.sourceSpan, e2.strings, n) : e2;
            }
            visitLiteralPrimitive(e2, t2) {
              return e2;
            }
            visitPropertyRead(e2, t2) {
              let n = e2.receiver.visit(this);
              return n !== e2.receiver ? new re(e2.span, e2.sourceSpan, e2.nameSpan, n, e2.name) : e2;
            }
            visitPropertyWrite(e2, t2) {
              let n = e2.receiver.visit(this), r2 = e2.value.visit(this);
              return n !== e2.receiver || r2 !== e2.value ? new ue(e2.span, e2.sourceSpan, e2.nameSpan, n, e2.name, r2) : e2;
            }
            visitSafePropertyRead(e2, t2) {
              let n = e2.receiver.visit(this);
              return n !== e2.receiver ? new he(e2.span, e2.sourceSpan, e2.nameSpan, n, e2.name) : e2;
            }
            visitMethodCall(e2, t2) {
              let n = e2.receiver.visit(this), r2 = this.visitAll(e2.args);
              return n !== e2.receiver || r2 !== e2.args ? new ye(e2.span, e2.sourceSpan, e2.nameSpan, n, e2.name, r2, e2.argumentSpan) : e2;
            }
            visitSafeMethodCall(e2, t2) {
              let n = e2.receiver.visit(this), r2 = this.visitAll(e2.args);
              return n !== e2.receiver || r2 !== e2.args ? new we(e2.span, e2.sourceSpan, e2.nameSpan, n, e2.name, r2, e2.argumentSpan) : e2;
            }
            visitFunctionCall(e2, t2) {
              let n = e2.target && e2.target.visit(this), r2 = this.visitAll(e2.args);
              return n !== e2.target || r2 !== e2.args ? new Pe(e2.span, e2.sourceSpan, n, r2) : e2;
            }
            visitLiteralArray(e2, t2) {
              let n = this.visitAll(e2.expressions);
              return n !== e2.expressions ? new ge(e2.span, e2.sourceSpan, n) : e2;
            }
            visitLiteralMap(e2, t2) {
              let n = this.visitAll(e2.values);
              return n !== e2.values ? new ve(e2.span, e2.sourceSpan, e2.keys, n) : e2;
            }
            visitUnary(e2, t2) {
              let n = e2.expr.visit(this);
              if (n !== e2.expr)
                switch (e2.operator) {
                  case "+":
                    return F2.createPlus(e2.span, e2.sourceSpan, n);
                  case "-":
                    return F2.createMinus(e2.span, e2.sourceSpan, n);
                  default:
                    throw new Error("Unknown unary operator ".concat(e2.operator));
                }
              return e2;
            }
            visitBinary(e2, t2) {
              let n = e2.left.visit(this), r2 = e2.right.visit(this);
              return n !== e2.left || r2 !== e2.right ? new K(e2.span, e2.sourceSpan, e2.operation, n, r2) : e2;
            }
            visitPrefixNot(e2, t2) {
              let n = e2.expression.visit(this);
              return n !== e2.expression ? new xe(e2.span, e2.sourceSpan, n) : e2;
            }
            visitNonNullAssert(e2, t2) {
              let n = e2.expression.visit(this);
              return n !== e2.expression ? new Se(e2.span, e2.sourceSpan, n) : e2;
            }
            visitConditional(e2, t2) {
              let n = e2.condition.visit(this), r2 = e2.trueExp.visit(this), s2 = e2.falseExp.visit(this);
              return n !== e2.condition || r2 !== e2.trueExp || s2 !== e2.falseExp ? new ce(e2.span, e2.sourceSpan, n, r2, s2) : e2;
            }
            visitPipe(e2, t2) {
              let n = e2.exp.visit(this), r2 = this.visitAll(e2.args);
              return n !== e2.exp || r2 !== e2.args ? new fe(e2.span, e2.sourceSpan, n, e2.name, r2, e2.nameSpan) : e2;
            }
            visitKeyedRead(e2, t2) {
              let n = e2.receiver.visit(this), r2 = e2.key.visit(this);
              return n !== e2.receiver || r2 !== e2.key ? new le(e2.span, e2.sourceSpan, n, r2) : e2;
            }
            visitKeyedWrite(e2, t2) {
              let n = e2.receiver.visit(this), r2 = e2.key.visit(this), s2 = e2.value.visit(this);
              return n !== e2.receiver || r2 !== e2.key || s2 !== e2.value ? new de(e2.span, e2.sourceSpan, n, r2, s2) : e2;
            }
            visitAll(e2) {
              let t2 = [], n = false;
              for (let r2 = 0; r2 < e2.length; ++r2) {
                let s2 = e2[r2], a = s2.visit(this);
                t2[r2] = a, n = n || a !== s2;
              }
              return n ? t2 : e2;
            }
            visitChain(e2, t2) {
              let n = this.visitAll(e2.expressions);
              return n !== e2.expressions ? new oe(e2.span, e2.sourceSpan, n) : e2;
            }
            visitQuote(e2, t2) {
              return e2;
            }
            visitSafeKeyedRead(e2, t2) {
              let n = e2.receiver.visit(this), r2 = e2.key.visit(this);
              return n !== e2.receiver || r2 !== e2.key ? new pe(e2.span, e2.sourceSpan, n, r2) : e2;
            }
          }, Et = class {
            constructor(e2, t2, n, r2, s2, a) {
              this.name = e2, this.expression = t2, this.type = n, this.sourceSpan = r2, this.keySpan = s2, this.valueSpan = a, this.isLiteral = this.type === se.LITERAL_ATTR, this.isAnimation = this.type === se.ANIMATION;
            }
          }, function(e2) {
            e2[e2.DEFAULT = 0] = "DEFAULT", e2[e2.LITERAL_ATTR = 1] = "LITERAL_ATTR", e2[e2.ANIMATION = 2] = "ANIMATION";
          }(se || (se = {})), At = class {
            constructor(e2, t2, n, r2, s2, a, i2) {
              this.name = e2, this.targetOrPhase = t2, this.type = n, this.handler = r2, this.sourceSpan = s2, this.handlerSpan = a, this.keySpan = i2;
            }
          }, _t = class {
            constructor(e2, t2, n, r2, s2) {
              this.name = e2, this.value = t2, this.sourceSpan = n, this.keySpan = r2, this.valueSpan = s2;
            }
          }, It = class {
            constructor(e2, t2, n, r2, s2, a, i2, l) {
              this.name = e2, this.type = t2, this.securityContext = n, this.value = r2, this.unit = s2, this.sourceSpan = a, this.keySpan = i2, this.valueSpan = l;
            }
          };
        } });
        function mn(e2) {
          return e2 >= nt && e2 <= rt || e2 == dt;
        }
        function Q(e2) {
          return $t <= e2 && e2 <= jt;
        }
        function xn(e2) {
          return e2 >= lt && e2 <= pt || e2 >= ut && e2 <= ht;
        }
        function mt(e2) {
          return e2 === at || e2 === st || e2 === Xt;
        }
        var Ce, nt, Ot, kt, Nt, bt, rt, Lt, st, Rt, it, Tt, je, at, Ee, z, Bt, ot, ee, ct, H, Te, X, te, Kt, ie, Mt, Fe, $t, jt, ut, Ft, ht, Ae, Ut, ne, Wt, Ke, lt, Gt, Vt, qt, Qt, Dt, zt, Ht, pt, Be, Ue, _e, dt, Xt, Jt = Y({ "node_modules/@angular/compiler/esm2015/src/chars.js"() {
          L(), Ce = 0, nt = 9, Ot = 10, kt = 11, Nt = 12, bt = 13, rt = 32, Lt = 33, st = 34, Rt = 35, it = 36, Tt = 37, je = 38, at = 39, Ee = 40, z = 41, Bt = 42, ot = 43, ee = 44, ct = 45, H = 46, Te = 47, X = 58, te = 59, Kt = 60, ie = 61, Mt = 62, Fe = 63, $t = 48, jt = 57, ut = 65, Ft = 69, ht = 90, Ae = 91, Ut = 92, ne = 93, Wt = 94, Ke = 95, lt = 97, Gt = 101, Vt = 102, qt = 110, Qt = 114, Dt = 116, zt = 117, Ht = 118, pt = 122, Be = 123, Ue = 124, _e = 125, dt = 160, Xt = 96;
        } }), Yt = {};
        Xe(Yt, { EOF: () => Ie, Lexer: () => en, Token: () => $, TokenType: () => S2, isIdentifier: () => Zt });
        function xt(e2, t2, n) {
          return new $(e2, t2, S2.Character, n, String.fromCharCode(n));
        }
        function Sn(e2, t2, n) {
          return new $(e2, t2, S2.Identifier, 0, n);
        }
        function yn(e2, t2, n) {
          return new $(e2, t2, S2.PrivateIdentifier, 0, n);
        }
        function wn(e2, t2, n) {
          return new $(e2, t2, S2.Keyword, 0, n);
        }
        function Me(e2, t2, n) {
          return new $(e2, t2, S2.Operator, 0, n);
        }
        function Pn(e2, t2, n) {
          return new $(e2, t2, S2.String, 0, n);
        }
        function Cn(e2, t2, n) {
          return new $(e2, t2, S2.Number, n, "");
        }
        function En(e2, t2, n) {
          return new $(e2, t2, S2.Error, 0, n);
        }
        function We(e2) {
          return lt <= e2 && e2 <= pt || ut <= e2 && e2 <= ht || e2 == Ke || e2 == it;
        }
        function Zt(e2) {
          if (e2.length == 0)
            return false;
          let t2 = new Ve(e2);
          if (!We(t2.peek))
            return false;
          for (t2.advance(); t2.peek !== Ce; ) {
            if (!Ge(t2.peek))
              return false;
            t2.advance();
          }
          return true;
        }
        function Ge(e2) {
          return xn(e2) || Q(e2) || e2 == Ke || e2 == it;
        }
        function An(e2) {
          return e2 == Gt || e2 == Ft;
        }
        function _n(e2) {
          return e2 == ct || e2 == ot;
        }
        function In(e2) {
          switch (e2) {
            case qt:
              return Ot;
            case Vt:
              return Nt;
            case Qt:
              return bt;
            case Dt:
              return nt;
            case Ht:
              return kt;
            default:
              return e2;
          }
        }
        function On(e2) {
          let t2 = parseInt(e2);
          if (isNaN(t2))
            throw new Error("Invalid integer literal when parsing " + e2);
          return t2;
        }
        var S2, St, en, $, Ie, Ve, tn = Y({ "node_modules/@angular/compiler/esm2015/src/expression_parser/lexer.js"() {
          L(), Jt(), function(e2) {
            e2[e2.Character = 0] = "Character", e2[e2.Identifier = 1] = "Identifier", e2[e2.PrivateIdentifier = 2] = "PrivateIdentifier", e2[e2.Keyword = 3] = "Keyword", e2[e2.String = 4] = "String", e2[e2.Operator = 5] = "Operator", e2[e2.Number = 6] = "Number", e2[e2.Error = 7] = "Error";
          }(S2 || (S2 = {})), St = ["var", "let", "as", "null", "undefined", "true", "false", "if", "else", "this"], en = class {
            tokenize(e2) {
              let t2 = new Ve(e2), n = [], r2 = t2.scanToken();
              for (; r2 != null; )
                n.push(r2), r2 = t2.scanToken();
              return n;
            }
          }, $ = class {
            constructor(e2, t2, n, r2, s2) {
              this.index = e2, this.end = t2, this.type = n, this.numValue = r2, this.strValue = s2;
            }
            isCharacter(e2) {
              return this.type == S2.Character && this.numValue == e2;
            }
            isNumber() {
              return this.type == S2.Number;
            }
            isString() {
              return this.type == S2.String;
            }
            isOperator(e2) {
              return this.type == S2.Operator && this.strValue == e2;
            }
            isIdentifier() {
              return this.type == S2.Identifier;
            }
            isPrivateIdentifier() {
              return this.type == S2.PrivateIdentifier;
            }
            isKeyword() {
              return this.type == S2.Keyword;
            }
            isKeywordLet() {
              return this.type == S2.Keyword && this.strValue == "let";
            }
            isKeywordAs() {
              return this.type == S2.Keyword && this.strValue == "as";
            }
            isKeywordNull() {
              return this.type == S2.Keyword && this.strValue == "null";
            }
            isKeywordUndefined() {
              return this.type == S2.Keyword && this.strValue == "undefined";
            }
            isKeywordTrue() {
              return this.type == S2.Keyword && this.strValue == "true";
            }
            isKeywordFalse() {
              return this.type == S2.Keyword && this.strValue == "false";
            }
            isKeywordThis() {
              return this.type == S2.Keyword && this.strValue == "this";
            }
            isError() {
              return this.type == S2.Error;
            }
            toNumber() {
              return this.type == S2.Number ? this.numValue : -1;
            }
            toString() {
              switch (this.type) {
                case S2.Character:
                case S2.Identifier:
                case S2.Keyword:
                case S2.Operator:
                case S2.PrivateIdentifier:
                case S2.String:
                case S2.Error:
                  return this.strValue;
                case S2.Number:
                  return this.numValue.toString();
                default:
                  return null;
              }
            }
          }, Ie = new $(-1, -1, S2.Character, 0, ""), Ve = class {
            constructor(e2) {
              this.input = e2, this.peek = 0, this.index = -1, this.length = e2.length, this.advance();
            }
            advance() {
              this.peek = ++this.index >= this.length ? Ce : this.input.charCodeAt(this.index);
            }
            scanToken() {
              let e2 = this.input, t2 = this.length, n = this.peek, r2 = this.index;
              for (; n <= rt; )
                if (++r2 >= t2) {
                  n = Ce;
                  break;
                } else
                  n = e2.charCodeAt(r2);
              if (this.peek = n, this.index = r2, r2 >= t2)
                return null;
              if (We(n))
                return this.scanIdentifier();
              if (Q(n))
                return this.scanNumber(r2);
              let s2 = r2;
              switch (n) {
                case H:
                  return this.advance(), Q(this.peek) ? this.scanNumber(s2) : xt(s2, this.index, H);
                case Ee:
                case z:
                case Be:
                case _e:
                case Ae:
                case ne:
                case ee:
                case X:
                case te:
                  return this.scanCharacter(s2, n);
                case at:
                case st:
                  return this.scanString();
                case Rt:
                  return this.scanPrivateIdentifier();
                case ot:
                case ct:
                case Bt:
                case Te:
                case Tt:
                case Wt:
                  return this.scanOperator(s2, String.fromCharCode(n));
                case Fe:
                  return this.scanQuestion(s2);
                case Kt:
                case Mt:
                  return this.scanComplexOperator(s2, String.fromCharCode(n), ie, "=");
                case Lt:
                case ie:
                  return this.scanComplexOperator(s2, String.fromCharCode(n), ie, "=", ie, "=");
                case je:
                  return this.scanComplexOperator(s2, "&", je, "&");
                case Ue:
                  return this.scanComplexOperator(s2, "|", Ue, "|");
                case dt:
                  for (; mn(this.peek); )
                    this.advance();
                  return this.scanToken();
              }
              return this.advance(), this.error("Unexpected character [".concat(String.fromCharCode(n), "]"), 0);
            }
            scanCharacter(e2, t2) {
              return this.advance(), xt(e2, this.index, t2);
            }
            scanOperator(e2, t2) {
              return this.advance(), Me(e2, this.index, t2);
            }
            scanComplexOperator(e2, t2, n, r2, s2, a) {
              this.advance();
              let i2 = t2;
              return this.peek == n && (this.advance(), i2 += r2), s2 != null && this.peek == s2 && (this.advance(), i2 += a), Me(e2, this.index, i2);
            }
            scanIdentifier() {
              let e2 = this.index;
              for (this.advance(); Ge(this.peek); )
                this.advance();
              let t2 = this.input.substring(e2, this.index);
              return St.indexOf(t2) > -1 ? wn(e2, this.index, t2) : Sn(e2, this.index, t2);
            }
            scanPrivateIdentifier() {
              let e2 = this.index;
              if (this.advance(), !We(this.peek))
                return this.error("Invalid character [#]", -1);
              for (; Ge(this.peek); )
                this.advance();
              let t2 = this.input.substring(e2, this.index);
              return yn(e2, this.index, t2);
            }
            scanNumber(e2) {
              let t2 = this.index === e2, n = false;
              for (this.advance(); ; ) {
                if (!Q(this.peek))
                  if (this.peek === Ke) {
                    if (!Q(this.input.charCodeAt(this.index - 1)) || !Q(this.input.charCodeAt(this.index + 1)))
                      return this.error("Invalid numeric separator", 0);
                    n = true;
                  } else if (this.peek === H)
                    t2 = false;
                  else if (An(this.peek)) {
                    if (this.advance(), _n(this.peek) && this.advance(), !Q(this.peek))
                      return this.error("Invalid exponent", -1);
                    t2 = false;
                  } else
                    break;
                this.advance();
              }
              let r2 = this.input.substring(e2, this.index);
              n && (r2 = r2.replace(/_/g, ""));
              let s2 = t2 ? On(r2) : parseFloat(r2);
              return Cn(e2, this.index, s2);
            }
            scanString() {
              let e2 = this.index, t2 = this.peek;
              this.advance();
              let n = "", r2 = this.index, s2 = this.input;
              for (; this.peek != t2; )
                if (this.peek == Ut) {
                  n += s2.substring(r2, this.index), this.advance();
                  let i2;
                  if (this.peek = this.peek, this.peek == zt) {
                    let l = s2.substring(this.index + 1, this.index + 5);
                    if (/^[0-9a-f]+$/i.test(l))
                      i2 = parseInt(l, 16);
                    else
                      return this.error("Invalid unicode escape [\\u".concat(l, "]"), 0);
                    for (let h2 = 0; h2 < 5; h2++)
                      this.advance();
                  } else
                    i2 = In(this.peek), this.advance();
                  n += String.fromCharCode(i2), r2 = this.index;
                } else {
                  if (this.peek == Ce)
                    return this.error("Unterminated quote", 0);
                  this.advance();
                }
              let a = s2.substring(r2, this.index);
              return this.advance(), Pn(e2, this.index, n + a);
            }
            scanQuestion(e2) {
              this.advance();
              let t2 = "?";
              return (this.peek === Fe || this.peek === H) && (t2 += this.peek === H ? "." : "?", this.advance()), Me(e2, this.index, t2);
            }
            error(e2, t2) {
              let n = this.index + t2;
              return En(n, this.index, "Lexer Error: ".concat(e2, " at column ").concat(n, " in expression [").concat(this.input, "]"));
            }
          };
        } });
        function kn(e2, t2) {
          if (t2 != null && !(Array.isArray(t2) && t2.length == 2))
            throw new Error("Expected '".concat(e2, "' to be an array, [start, end]."));
          if (t2 != null) {
            let n = t2[0], r2 = t2[1];
            nn.forEach((s2) => {
              if (s2.test(n) || s2.test(r2))
                throw new Error("['".concat(n, "', '").concat(r2, "'] contains unusable interpolation symbol."));
            });
          }
        }
        var nn, Nn = Y({ "node_modules/@angular/compiler/esm2015/src/assertions.js"() {
          L(), nn = [/^\s*$/, /[<>]/, /^[{}]$/, /&(#|[a-z])/i, /^\/\//];
        } }), $e, J, bn = Y({ "node_modules/@angular/compiler/esm2015/src/ml_parser/interpolation_config.js"() {
          L(), Nn(), $e = class {
            constructor(e2, t2) {
              this.start = e2, this.end = t2;
            }
            static fromArray(e2) {
              return e2 ? (kn("interpolation", e2), new $e(e2[0], e2[1])) : J;
            }
          }, J = new $e("{{", "}}");
        } }), rn = {};
        Xe(rn, { IvyParser: () => sn, Parser: () => De, SplitInterpolation: () => qe, TemplateBindingParseResult: () => Qe, _ParseAST: () => D });
        var qe, Qe, De, sn, Z2, D, yt, wt, Ln = Y({ "node_modules/@angular/compiler/esm2015/src/expression_parser/parser.js"() {
          L(), Jt(), bn(), tt(), tn(), qe = class {
            constructor(e2, t2, n) {
              this.strings = e2, this.expressions = t2, this.offsets = n;
            }
          }, Qe = class {
            constructor(e2, t2, n) {
              this.templateBindings = e2, this.warnings = t2, this.errors = n;
            }
          }, De = class {
            constructor(e2) {
              this._lexer = e2, this.errors = [], this.simpleExpressionChecker = yt;
            }
            parseAction(e2, t2, n) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : J;
              this._checkNoInterpolation(e2, t2, r2);
              let s2 = this._stripComments(e2), a = this._lexer.tokenize(this._stripComments(e2)), i2 = new D(e2, t2, n, a, s2.length, true, this.errors, e2.length - s2.length).parseChain();
              return new G(i2, e2, t2, n, this.errors);
            }
            parseBinding(e2, t2, n) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : J, s2 = this._parseBindingAst(e2, t2, n, r2);
              return new G(s2, e2, t2, n, this.errors);
            }
            checkSimpleExpression(e2) {
              let t2 = new this.simpleExpressionChecker();
              return e2.visit(t2), t2.errors;
            }
            parseSimpleBinding(e2, t2, n) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : J, s2 = this._parseBindingAst(e2, t2, n, r2), a = this.checkSimpleExpression(s2);
              return a.length > 0 && this._reportError("Host binding expression cannot contain ".concat(a.join(" ")), e2, t2), new G(s2, e2, t2, n, this.errors);
            }
            _reportError(e2, t2, n, r2) {
              this.errors.push(new ae(e2, t2, n, r2));
            }
            _parseBindingAst(e2, t2, n, r2) {
              let s2 = this._parseQuote(e2, t2, n);
              if (s2 != null)
                return s2;
              this._checkNoInterpolation(e2, t2, r2);
              let a = this._stripComments(e2), i2 = this._lexer.tokenize(a);
              return new D(e2, t2, n, i2, a.length, false, this.errors, e2.length - a.length).parseChain();
            }
            _parseQuote(e2, t2, n) {
              if (e2 == null)
                return null;
              let r2 = e2.indexOf(":");
              if (r2 == -1)
                return null;
              let s2 = e2.substring(0, r2).trim();
              if (!Zt(s2))
                return null;
              let a = e2.substring(r2 + 1), i2 = new V(0, e2.length);
              return new Le(i2, i2.toAbsolute(n), s2, a, t2);
            }
            parseTemplateBindings(e2, t2, n, r2, s2) {
              let a = this._lexer.tokenize(t2);
              return new D(t2, n, s2, a, t2.length, false, this.errors, 0).parseTemplateBindings({ source: e2, span: new U(r2, r2 + e2.length) });
            }
            parseInterpolation(e2, t2, n) {
              let r2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : J, { strings: s2, expressions: a, offsets: i2 } = this.splitInterpolation(e2, t2, r2);
              if (a.length === 0)
                return null;
              let l = [];
              for (let h2 = 0; h2 < a.length; ++h2) {
                let P = a[h2].text, p = this._stripComments(P), x2 = this._lexer.tokenize(p), A2 = new D(e2, t2, n, x2, p.length, false, this.errors, i2[h2] + (P.length - p.length)).parseChain();
                l.push(A2);
              }
              return this.createInterpolationAst(s2.map((h2) => h2.text), l, e2, t2, n);
            }
            parseInterpolationExpression(e2, t2, n) {
              let r2 = this._stripComments(e2), s2 = this._lexer.tokenize(r2), a = new D(e2, t2, n, s2, r2.length, false, this.errors, 0).parseChain(), i2 = ["", ""];
              return this.createInterpolationAst(i2, [a], e2, t2, n);
            }
            createInterpolationAst(e2, t2, n, r2, s2) {
              let a = new V(0, n.length), i2 = new me(a, a.toAbsolute(s2), e2, t2);
              return new G(i2, n, r2, s2, this.errors);
            }
            splitInterpolation(e2, t2) {
              let n = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : J, r2 = [], s2 = [], a = [], i2 = 0, l = false, h2 = false, { start: P, end: p } = n;
              for (; i2 < e2.length; )
                if (l) {
                  let x2 = i2, A2 = x2 + P.length, b = this._getInterpolationEndIndex(e2, p, A2);
                  if (b === -1) {
                    l = false, h2 = true;
                    break;
                  }
                  let _ = b + p.length, R = e2.substring(A2, b);
                  R.trim().length === 0 && this._reportError("Blank expressions are not allowed in interpolated strings", e2, "at column ".concat(i2, " in"), t2), s2.push({ text: R, start: x2, end: _ }), a.push(A2), i2 = _, l = false;
                } else {
                  let x2 = i2;
                  i2 = e2.indexOf(P, i2), i2 === -1 && (i2 = e2.length);
                  let A2 = e2.substring(x2, i2);
                  r2.push({ text: A2, start: x2, end: i2 }), l = true;
                }
              if (!l)
                if (h2) {
                  let x2 = r2[r2.length - 1];
                  x2.text += e2.substring(i2), x2.end = e2.length;
                } else
                  r2.push({ text: e2.substring(i2), start: i2, end: e2.length });
              return new qe(r2, s2, a);
            }
            wrapLiteralPrimitive(e2, t2, n) {
              let r2 = new V(0, e2 == null ? 0 : e2.length);
              return new G(new B(r2, r2.toAbsolute(n), e2), e2, t2, n, this.errors);
            }
            _stripComments(e2) {
              let t2 = this._commentStart(e2);
              return t2 != null ? e2.substring(0, t2).trim() : e2;
            }
            _commentStart(e2) {
              let t2 = null;
              for (let n = 0; n < e2.length - 1; n++) {
                let r2 = e2.charCodeAt(n), s2 = e2.charCodeAt(n + 1);
                if (r2 === Te && s2 == Te && t2 == null)
                  return n;
                t2 === r2 ? t2 = null : t2 == null && mt(r2) && (t2 = r2);
              }
              return null;
            }
            _checkNoInterpolation(e2, t2, n) {
              let { start: r2, end: s2 } = n, a = -1, i2 = -1;
              for (let l of this._forEachUnquotedChar(e2, 0))
                if (a === -1)
                  e2.startsWith(r2) && (a = l);
                else if (i2 = this._getInterpolationEndIndex(e2, s2, l), i2 > -1)
                  break;
              a > -1 && i2 > -1 && this._reportError("Got interpolation (".concat(r2).concat(s2, ") where expression was expected"), e2, "at column ".concat(a, " in"), t2);
            }
            _getInterpolationEndIndex(e2, t2, n) {
              for (let r2 of this._forEachUnquotedChar(e2, n)) {
                if (e2.startsWith(t2, r2))
                  return r2;
                if (e2.startsWith("//", r2))
                  return e2.indexOf(t2, r2);
              }
              return -1;
            }
            *_forEachUnquotedChar(e2, t2) {
              let n = null, r2 = 0;
              for (let s2 = t2; s2 < e2.length; s2++) {
                let a = e2[s2];
                mt(e2.charCodeAt(s2)) && (n === null || n === a) && r2 % 2 === 0 ? n = n === null ? a : null : n === null && (yield s2), r2 = a === "\\" ? r2 + 1 : 0;
              }
            }
          }, sn = class extends De {
            constructor() {
              super(...arguments), this.simpleExpressionChecker = wt;
            }
          }, function(e2) {
            e2[e2.None = 0] = "None", e2[e2.Writable = 1] = "Writable";
          }(Z2 || (Z2 = {})), D = class {
            constructor(e2, t2, n, r2, s2, a, i2, l) {
              this.input = e2, this.location = t2, this.absoluteOffset = n, this.tokens = r2, this.inputLength = s2, this.parseAction = a, this.errors = i2, this.offset = l, this.rparensExpected = 0, this.rbracketsExpected = 0, this.rbracesExpected = 0, this.context = Z2.None, this.sourceSpanCache = /* @__PURE__ */ new Map(), this.index = 0;
            }
            peek(e2) {
              let t2 = this.index + e2;
              return t2 < this.tokens.length ? this.tokens[t2] : Ie;
            }
            get next() {
              return this.peek(0);
            }
            get atEOF() {
              return this.index >= this.tokens.length;
            }
            get inputIndex() {
              return this.atEOF ? this.currentEndIndex : this.next.index + this.offset;
            }
            get currentEndIndex() {
              return this.index > 0 ? this.peek(-1).end + this.offset : this.tokens.length === 0 ? this.inputLength + this.offset : this.next.index + this.offset;
            }
            get currentAbsoluteOffset() {
              return this.absoluteOffset + this.inputIndex;
            }
            span(e2, t2) {
              let n = this.currentEndIndex;
              if (t2 !== void 0 && t2 > this.currentEndIndex && (n = t2), e2 > n) {
                let r2 = n;
                n = e2, e2 = r2;
              }
              return new V(e2, n);
            }
            sourceSpan(e2, t2) {
              let n = "".concat(e2, "@").concat(this.inputIndex, ":").concat(t2);
              return this.sourceSpanCache.has(n) || this.sourceSpanCache.set(n, this.span(e2, t2).toAbsolute(this.absoluteOffset)), this.sourceSpanCache.get(n);
            }
            advance() {
              this.index++;
            }
            withContext(e2, t2) {
              this.context |= e2;
              let n = t2();
              return this.context ^= e2, n;
            }
            consumeOptionalCharacter(e2) {
              return this.next.isCharacter(e2) ? (this.advance(), true) : false;
            }
            peekKeywordLet() {
              return this.next.isKeywordLet();
            }
            peekKeywordAs() {
              return this.next.isKeywordAs();
            }
            expectCharacter(e2) {
              this.consumeOptionalCharacter(e2) || this.error("Missing expected ".concat(String.fromCharCode(e2)));
            }
            consumeOptionalOperator(e2) {
              return this.next.isOperator(e2) ? (this.advance(), true) : false;
            }
            expectOperator(e2) {
              this.consumeOptionalOperator(e2) || this.error("Missing expected operator ".concat(e2));
            }
            prettyPrintToken(e2) {
              return e2 === Ie ? "end of input" : "token ".concat(e2);
            }
            expectIdentifierOrKeyword() {
              let e2 = this.next;
              return !e2.isIdentifier() && !e2.isKeyword() ? (e2.isPrivateIdentifier() ? this._reportErrorForPrivateIdentifier(e2, "expected identifier or keyword") : this.error("Unexpected ".concat(this.prettyPrintToken(e2), ", expected identifier or keyword")), null) : (this.advance(), e2.toString());
            }
            expectIdentifierOrKeywordOrString() {
              let e2 = this.next;
              return !e2.isIdentifier() && !e2.isKeyword() && !e2.isString() ? (e2.isPrivateIdentifier() ? this._reportErrorForPrivateIdentifier(e2, "expected identifier, keyword or string") : this.error("Unexpected ".concat(this.prettyPrintToken(e2), ", expected identifier, keyword, or string")), "") : (this.advance(), e2.toString());
            }
            parseChain() {
              let e2 = [], t2 = this.inputIndex;
              for (; this.index < this.tokens.length; ) {
                let n = this.parsePipe();
                if (e2.push(n), this.consumeOptionalCharacter(te))
                  for (this.parseAction || this.error("Binding expression cannot contain chained expression"); this.consumeOptionalCharacter(te); )
                    ;
                else
                  this.index < this.tokens.length && this.error("Unexpected token '".concat(this.next, "'"));
              }
              if (e2.length == 0) {
                let n = this.offset, r2 = this.offset + this.inputLength;
                return new M(this.span(n, r2), this.sourceSpan(n, r2));
              }
              return e2.length == 1 ? e2[0] : new oe(this.span(t2), this.sourceSpan(t2), e2);
            }
            parsePipe() {
              let e2 = this.inputIndex, t2 = this.parseExpression();
              if (this.consumeOptionalOperator("|")) {
                this.parseAction && this.error("Cannot have a pipe in an action expression");
                do {
                  let n = this.inputIndex, r2 = this.expectIdentifierOrKeyword(), s2, a;
                  r2 !== null ? s2 = this.sourceSpan(n) : (r2 = "", a = this.next.index !== -1 ? this.next.index : this.inputLength + this.offset, s2 = new V(a, a).toAbsolute(this.absoluteOffset));
                  let i2 = [];
                  for (; this.consumeOptionalCharacter(X); )
                    i2.push(this.parseExpression());
                  t2 = new fe(this.span(e2), this.sourceSpan(e2, a), t2, r2, i2, s2);
                } while (this.consumeOptionalOperator("|"));
              }
              return t2;
            }
            parseExpression() {
              return this.parseConditional();
            }
            parseConditional() {
              let e2 = this.inputIndex, t2 = this.parseLogicalOr();
              if (this.consumeOptionalOperator("?")) {
                let n = this.parsePipe(), r2;
                if (this.consumeOptionalCharacter(X))
                  r2 = this.parsePipe();
                else {
                  let s2 = this.inputIndex, a = this.input.substring(e2, s2);
                  this.error("Conditional expression ".concat(a, " requires all 3 expressions")), r2 = new M(this.span(e2), this.sourceSpan(e2));
                }
                return new ce(this.span(e2), this.sourceSpan(e2), t2, n, r2);
              } else
                return t2;
            }
            parseLogicalOr() {
              let e2 = this.inputIndex, t2 = this.parseLogicalAnd();
              for (; this.consumeOptionalOperator("||"); ) {
                let n = this.parseLogicalAnd();
                t2 = new K(this.span(e2), this.sourceSpan(e2), "||", t2, n);
              }
              return t2;
            }
            parseLogicalAnd() {
              let e2 = this.inputIndex, t2 = this.parseNullishCoalescing();
              for (; this.consumeOptionalOperator("&&"); ) {
                let n = this.parseNullishCoalescing();
                t2 = new K(this.span(e2), this.sourceSpan(e2), "&&", t2, n);
              }
              return t2;
            }
            parseNullishCoalescing() {
              let e2 = this.inputIndex, t2 = this.parseEquality();
              for (; this.consumeOptionalOperator("??"); ) {
                let n = this.parseEquality();
                t2 = new K(this.span(e2), this.sourceSpan(e2), "??", t2, n);
              }
              return t2;
            }
            parseEquality() {
              let e2 = this.inputIndex, t2 = this.parseRelational();
              for (; this.next.type == S2.Operator; ) {
                let n = this.next.strValue;
                switch (n) {
                  case "==":
                  case "===":
                  case "!=":
                  case "!==":
                    this.advance();
                    let r2 = this.parseRelational();
                    t2 = new K(this.span(e2), this.sourceSpan(e2), n, t2, r2);
                    continue;
                }
                break;
              }
              return t2;
            }
            parseRelational() {
              let e2 = this.inputIndex, t2 = this.parseAdditive();
              for (; this.next.type == S2.Operator; ) {
                let n = this.next.strValue;
                switch (n) {
                  case "<":
                  case ">":
                  case "<=":
                  case ">=":
                    this.advance();
                    let r2 = this.parseAdditive();
                    t2 = new K(this.span(e2), this.sourceSpan(e2), n, t2, r2);
                    continue;
                }
                break;
              }
              return t2;
            }
            parseAdditive() {
              let e2 = this.inputIndex, t2 = this.parseMultiplicative();
              for (; this.next.type == S2.Operator; ) {
                let n = this.next.strValue;
                switch (n) {
                  case "+":
                  case "-":
                    this.advance();
                    let r2 = this.parseMultiplicative();
                    t2 = new K(this.span(e2), this.sourceSpan(e2), n, t2, r2);
                    continue;
                }
                break;
              }
              return t2;
            }
            parseMultiplicative() {
              let e2 = this.inputIndex, t2 = this.parsePrefix();
              for (; this.next.type == S2.Operator; ) {
                let n = this.next.strValue;
                switch (n) {
                  case "*":
                  case "%":
                  case "/":
                    this.advance();
                    let r2 = this.parsePrefix();
                    t2 = new K(this.span(e2), this.sourceSpan(e2), n, t2, r2);
                    continue;
                }
                break;
              }
              return t2;
            }
            parsePrefix() {
              if (this.next.type == S2.Operator) {
                let e2 = this.inputIndex, t2 = this.next.strValue, n;
                switch (t2) {
                  case "+":
                    return this.advance(), n = this.parsePrefix(), F2.createPlus(this.span(e2), this.sourceSpan(e2), n);
                  case "-":
                    return this.advance(), n = this.parsePrefix(), F2.createMinus(this.span(e2), this.sourceSpan(e2), n);
                  case "!":
                    return this.advance(), n = this.parsePrefix(), new xe(this.span(e2), this.sourceSpan(e2), n);
                }
              }
              return this.parseCallChain();
            }
            parseCallChain() {
              let e2 = this.inputIndex, t2 = this.parsePrimary();
              for (; ; )
                if (this.consumeOptionalCharacter(H))
                  t2 = this.parseAccessMemberOrMethodCall(t2, e2, false);
                else if (this.consumeOptionalOperator("?."))
                  t2 = this.consumeOptionalCharacter(Ae) ? this.parseKeyedReadOrWrite(t2, e2, true) : this.parseAccessMemberOrMethodCall(t2, e2, true);
                else if (this.consumeOptionalCharacter(Ae))
                  t2 = this.parseKeyedReadOrWrite(t2, e2, false);
                else if (this.consumeOptionalCharacter(Ee)) {
                  this.rparensExpected++;
                  let n = this.parseCallArguments();
                  this.rparensExpected--, this.expectCharacter(z), t2 = new Pe(this.span(e2), this.sourceSpan(e2), t2, n);
                } else if (this.consumeOptionalOperator("!"))
                  t2 = new Se(this.span(e2), this.sourceSpan(e2), t2);
                else
                  return t2;
            }
            parsePrimary() {
              let e2 = this.inputIndex;
              if (this.consumeOptionalCharacter(Ee)) {
                this.rparensExpected++;
                let t2 = this.parsePipe();
                return this.rparensExpected--, this.expectCharacter(z), t2;
              } else {
                if (this.next.isKeywordNull())
                  return this.advance(), new B(this.span(e2), this.sourceSpan(e2), null);
                if (this.next.isKeywordUndefined())
                  return this.advance(), new B(this.span(e2), this.sourceSpan(e2), void 0);
                if (this.next.isKeywordTrue())
                  return this.advance(), new B(this.span(e2), this.sourceSpan(e2), true);
                if (this.next.isKeywordFalse())
                  return this.advance(), new B(this.span(e2), this.sourceSpan(e2), false);
                if (this.next.isKeywordThis())
                  return this.advance(), new Ye(this.span(e2), this.sourceSpan(e2));
                if (this.consumeOptionalCharacter(Ae)) {
                  this.rbracketsExpected++;
                  let t2 = this.parseExpressionList(ne);
                  return this.rbracketsExpected--, this.expectCharacter(ne), new ge(this.span(e2), this.sourceSpan(e2), t2);
                } else {
                  if (this.next.isCharacter(Be))
                    return this.parseLiteralMap();
                  if (this.next.isIdentifier())
                    return this.parseAccessMemberOrMethodCall(new Oe(this.span(e2), this.sourceSpan(e2)), e2, false);
                  if (this.next.isNumber()) {
                    let t2 = this.next.toNumber();
                    return this.advance(), new B(this.span(e2), this.sourceSpan(e2), t2);
                  } else if (this.next.isString()) {
                    let t2 = this.next.toString();
                    return this.advance(), new B(this.span(e2), this.sourceSpan(e2), t2);
                  } else
                    return this.next.isPrivateIdentifier() ? (this._reportErrorForPrivateIdentifier(this.next, null), new M(this.span(e2), this.sourceSpan(e2))) : this.index >= this.tokens.length ? (this.error("Unexpected end of expression: ".concat(this.input)), new M(this.span(e2), this.sourceSpan(e2))) : (this.error("Unexpected token ".concat(this.next)), new M(this.span(e2), this.sourceSpan(e2)));
                }
              }
            }
            parseExpressionList(e2) {
              let t2 = [];
              do
                if (!this.next.isCharacter(e2))
                  t2.push(this.parsePipe());
                else
                  break;
              while (this.consumeOptionalCharacter(ee));
              return t2;
            }
            parseLiteralMap() {
              let e2 = [], t2 = [], n = this.inputIndex;
              if (this.expectCharacter(Be), !this.consumeOptionalCharacter(_e)) {
                this.rbracesExpected++;
                do {
                  let r2 = this.inputIndex, s2 = this.next.isString(), a = this.expectIdentifierOrKeywordOrString();
                  if (e2.push({ key: a, quoted: s2 }), s2)
                    this.expectCharacter(X), t2.push(this.parsePipe());
                  else if (this.consumeOptionalCharacter(X))
                    t2.push(this.parsePipe());
                  else {
                    let i2 = this.span(r2), l = this.sourceSpan(r2);
                    t2.push(new re(i2, l, l, new Oe(i2, l), a));
                  }
                } while (this.consumeOptionalCharacter(ee));
                this.rbracesExpected--, this.expectCharacter(_e);
              }
              return new ve(this.span(n), this.sourceSpan(n), e2, t2);
            }
            parseAccessMemberOrMethodCall(e2, t2, n) {
              let r2 = this.inputIndex, s2 = this.withContext(Z2.Writable, () => {
                var i2;
                let l = (i2 = this.expectIdentifierOrKeyword()) !== null && i2 !== void 0 ? i2 : "";
                return l.length === 0 && this.error("Expected identifier for property access", e2.span.end), l;
              }), a = this.sourceSpan(r2);
              if (this.consumeOptionalCharacter(Ee)) {
                let i2 = this.inputIndex;
                this.rparensExpected++;
                let l = this.parseCallArguments(), h2 = this.span(i2, this.inputIndex).toAbsolute(this.absoluteOffset);
                this.expectCharacter(z), this.rparensExpected--;
                let P = this.span(t2), p = this.sourceSpan(t2);
                return n ? new we(P, p, a, e2, s2, l, h2) : new ye(P, p, a, e2, s2, l, h2);
              } else {
                if (n)
                  return this.consumeOptionalOperator("=") ? (this.error("The '?.' operator cannot be used in the assignment"), new M(this.span(t2), this.sourceSpan(t2))) : new he(this.span(t2), this.sourceSpan(t2), a, e2, s2);
                if (this.consumeOptionalOperator("=")) {
                  if (!this.parseAction)
                    return this.error("Bindings cannot contain assignments"), new M(this.span(t2), this.sourceSpan(t2));
                  let i2 = this.parseConditional();
                  return new ue(this.span(t2), this.sourceSpan(t2), a, e2, s2, i2);
                } else
                  return new re(this.span(t2), this.sourceSpan(t2), a, e2, s2);
              }
            }
            parseCallArguments() {
              if (this.next.isCharacter(z))
                return [];
              let e2 = [];
              do
                e2.push(this.parsePipe());
              while (this.consumeOptionalCharacter(ee));
              return e2;
            }
            expectTemplateBindingKey() {
              let e2 = "", t2 = false, n = this.currentAbsoluteOffset;
              do
                e2 += this.expectIdentifierOrKeywordOrString(), t2 = this.consumeOptionalOperator("-"), t2 && (e2 += "-");
              while (t2);
              return { source: e2, span: new U(n, n + e2.length) };
            }
            parseTemplateBindings(e2) {
              let t2 = [];
              for (t2.push(...this.parseDirectiveKeywordBindings(e2)); this.index < this.tokens.length; ) {
                let n = this.parseLetBinding();
                if (n)
                  t2.push(n);
                else {
                  let r2 = this.expectTemplateBindingKey(), s2 = this.parseAsBinding(r2);
                  s2 ? t2.push(s2) : (r2.source = e2.source + r2.source.charAt(0).toUpperCase() + r2.source.substring(1), t2.push(...this.parseDirectiveKeywordBindings(r2)));
                }
                this.consumeStatementTerminator();
              }
              return new Qe(t2, [], this.errors);
            }
            parseKeyedReadOrWrite(e2, t2, n) {
              return this.withContext(Z2.Writable, () => {
                this.rbracketsExpected++;
                let r2 = this.parsePipe();
                if (r2 instanceof M && this.error("Key access cannot be empty"), this.rbracketsExpected--, this.expectCharacter(ne), this.consumeOptionalOperator("="))
                  if (n)
                    this.error("The '?.' operator cannot be used in the assignment");
                  else {
                    let s2 = this.parseConditional();
                    return new de(this.span(t2), this.sourceSpan(t2), e2, r2, s2);
                  }
                else
                  return n ? new pe(this.span(t2), this.sourceSpan(t2), e2, r2) : new le(this.span(t2), this.sourceSpan(t2), e2, r2);
                return new M(this.span(t2), this.sourceSpan(t2));
              });
            }
            parseDirectiveKeywordBindings(e2) {
              let t2 = [];
              this.consumeOptionalCharacter(X);
              let n = this.getDirectiveBoundTarget(), r2 = this.currentAbsoluteOffset, s2 = this.parseAsBinding(e2);
              s2 || (this.consumeStatementTerminator(), r2 = this.currentAbsoluteOffset);
              let a = new U(e2.span.start, r2);
              return t2.push(new Ze(a, e2, n)), s2 && t2.push(s2), t2;
            }
            getDirectiveBoundTarget() {
              if (this.next === Ie || this.peekKeywordAs() || this.peekKeywordLet())
                return null;
              let e2 = this.parsePipe(), { start: t2, end: n } = e2.span, r2 = this.input.substring(t2, n);
              return new G(e2, r2, this.location, this.absoluteOffset + t2, this.errors);
            }
            parseAsBinding(e2) {
              if (!this.peekKeywordAs())
                return null;
              this.advance();
              let t2 = this.expectTemplateBindingKey();
              this.consumeStatementTerminator();
              let n = new U(e2.span.start, this.currentAbsoluteOffset);
              return new Re(n, t2, e2);
            }
            parseLetBinding() {
              if (!this.peekKeywordLet())
                return null;
              let e2 = this.currentAbsoluteOffset;
              this.advance();
              let t2 = this.expectTemplateBindingKey(), n = null;
              this.consumeOptionalOperator("=") && (n = this.expectTemplateBindingKey()), this.consumeStatementTerminator();
              let r2 = new U(e2, this.currentAbsoluteOffset);
              return new Re(r2, t2, n);
            }
            consumeStatementTerminator() {
              this.consumeOptionalCharacter(te) || this.consumeOptionalCharacter(ee);
            }
            error(e2) {
              let t2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              this.errors.push(new ae(e2, this.input, this.locationText(t2), this.location)), this.skip();
            }
            locationText() {
              let e2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
              return e2 == null && (e2 = this.index), e2 < this.tokens.length ? "at column ".concat(this.tokens[e2].index + 1, " in") : "at the end of the expression";
            }
            _reportErrorForPrivateIdentifier(e2, t2) {
              let n = "Private identifiers are not supported. Unexpected private identifier: ".concat(e2);
              t2 !== null && (n += ", ".concat(t2)), this.error(n);
            }
            skip() {
              let e2 = this.next;
              for (; this.index < this.tokens.length && !e2.isCharacter(te) && !e2.isOperator("|") && (this.rparensExpected <= 0 || !e2.isCharacter(z)) && (this.rbracesExpected <= 0 || !e2.isCharacter(_e)) && (this.rbracketsExpected <= 0 || !e2.isCharacter(ne)) && (!(this.context & Z2.Writable) || !e2.isOperator("=")); )
                this.next.isError() && this.errors.push(new ae(this.next.toString(), this.input, this.locationText(), this.location)), this.advance(), e2 = this.next;
            }
          }, yt = class {
            constructor() {
              this.errors = [];
            }
            visitImplicitReceiver(e2, t2) {
            }
            visitThisReceiver(e2, t2) {
            }
            visitInterpolation(e2, t2) {
            }
            visitLiteralPrimitive(e2, t2) {
            }
            visitPropertyRead(e2, t2) {
            }
            visitPropertyWrite(e2, t2) {
            }
            visitSafePropertyRead(e2, t2) {
            }
            visitMethodCall(e2, t2) {
            }
            visitSafeMethodCall(e2, t2) {
            }
            visitFunctionCall(e2, t2) {
            }
            visitLiteralArray(e2, t2) {
              this.visitAll(e2.expressions, t2);
            }
            visitLiteralMap(e2, t2) {
              this.visitAll(e2.values, t2);
            }
            visitUnary(e2, t2) {
            }
            visitBinary(e2, t2) {
            }
            visitPrefixNot(e2, t2) {
            }
            visitNonNullAssert(e2, t2) {
            }
            visitConditional(e2, t2) {
            }
            visitPipe(e2, t2) {
              this.errors.push("pipes");
            }
            visitKeyedRead(e2, t2) {
            }
            visitKeyedWrite(e2, t2) {
            }
            visitAll(e2, t2) {
              return e2.map((n) => n.visit(this, t2));
            }
            visitChain(e2, t2) {
            }
            visitQuote(e2, t2) {
            }
            visitSafeKeyedRead(e2, t2) {
            }
          }, wt = class extends et {
            constructor() {
              super(...arguments), this.errors = [];
            }
            visitPipe() {
              this.errors.push("pipes");
            }
          };
        } }), ft = q({ "node_modules/angular-estree-parser/lib/utils.js"(e2) {
          "use strict";
          L(), Object.defineProperty(e2, "__esModule", { value: true }), e2.getLast = e2.toLowerCamelCase = e2.findBackChar = e2.findFrontChar = e2.fitSpans = e2.getNgType = e2.parseNgInterpolation = e2.parseNgTemplateBindings = e2.parseNgAction = e2.parseNgSimpleBinding = e2.parseNgBinding = e2.NG_PARSE_TEMPLATE_BINDINGS_FAKE_PREFIX = void 0;
          var t2 = (tt(), be(Je)), n = (tn(), be(Yt)), r2 = (Ln(), be(rn)), s2 = "angular-estree-parser";
          e2.NG_PARSE_TEMPLATE_BINDINGS_FAKE_PREFIX = "NgEstreeParser";
          var a = 0, i2 = [s2, a];
          function l() {
            return new r2.Parser(new n.Lexer());
          }
          function h2(o, d) {
            let y = l(), { astInput: C, comments: E } = T(o, y), { ast: I, errors: j } = d(C, y);
            return R(j), { ast: I, comments: E };
          }
          function P(o) {
            return h2(o, (d, y) => y.parseBinding(d, ...i2));
          }
          e2.parseNgBinding = P;
          function p(o) {
            return h2(o, (d, y) => y.parseSimpleBinding(d, ...i2));
          }
          e2.parseNgSimpleBinding = p;
          function x2(o) {
            return h2(o, (d, y) => y.parseAction(d, ...i2));
          }
          e2.parseNgAction = x2;
          function A2(o) {
            let d = l(), { templateBindings: y, errors: C } = d.parseTemplateBindings(e2.NG_PARSE_TEMPLATE_BINDINGS_FAKE_PREFIX, o, s2, a, a);
            return R(C), y;
          }
          e2.parseNgTemplateBindings = A2;
          function b(o) {
            let d = l(), { astInput: y, comments: C } = T(o, d), E = "{{", I = "}}", { ast: j, errors: cn } = d.parseInterpolation(E + y + I, ...i2);
            R(cn);
            let gt = j.expressions[0], vt = /* @__PURE__ */ new Set();
            return _(gt, (ke) => {
              vt.has(ke) || (ke.start -= E.length, ke.end -= E.length, vt.add(ke));
            }), { ast: gt, comments: C };
          }
          e2.parseNgInterpolation = b;
          function _(o, d) {
            if (!(!o || typeof o != "object")) {
              if (Array.isArray(o))
                return o.forEach((y) => _(y, d));
              for (let y of Object.keys(o)) {
                let C = o[y];
                y === "span" ? d(C) : _(C, d);
              }
            }
          }
          function R(o) {
            if (o.length !== 0) {
              let [{ message: d }] = o;
              throw new SyntaxError(d.replace(/^Parser Error: | at column \d+ in [^]*$/g, ""));
            }
          }
          function T(o, d) {
            let y = d._commentStart(o);
            return y === null ? { astInput: o, comments: [] } : { astInput: o.slice(0, y), comments: [{ type: "Comment", value: o.slice(y + 2), span: { start: y, end: o.length } }] };
          }
          function O(o) {
            return t2.Unary && o instanceof t2.Unary ? "Unary" : o instanceof t2.Binary ? "Binary" : o instanceof t2.BindingPipe ? "BindingPipe" : o instanceof t2.Chain ? "Chain" : o instanceof t2.Conditional ? "Conditional" : o instanceof t2.EmptyExpr ? "EmptyExpr" : o instanceof t2.FunctionCall ? "FunctionCall" : o instanceof t2.ImplicitReceiver ? "ImplicitReceiver" : o instanceof t2.KeyedRead ? "KeyedRead" : o instanceof t2.KeyedWrite ? "KeyedWrite" : o instanceof t2.LiteralArray ? "LiteralArray" : o instanceof t2.LiteralMap ? "LiteralMap" : o instanceof t2.LiteralPrimitive ? "LiteralPrimitive" : o instanceof t2.MethodCall ? "MethodCall" : o instanceof t2.NonNullAssert ? "NonNullAssert" : o instanceof t2.PrefixNot ? "PrefixNot" : o instanceof t2.PropertyRead ? "PropertyRead" : o instanceof t2.PropertyWrite ? "PropertyWrite" : o instanceof t2.Quote ? "Quote" : o instanceof t2.SafeMethodCall ? "SafeMethodCall" : o instanceof t2.SafePropertyRead ? "SafePropertyRead" : o.type;
          }
          e2.getNgType = O;
          function N(o, d) {
            let { start: y, end: C } = o, E = y, I = C;
            for (; I !== E && /\s/.test(d[I - 1]); )
              I--;
            for (; E !== I && /\s/.test(d[E]); )
              E++;
            return { start: E, end: I };
          }
          function c(o, d) {
            let { start: y, end: C } = o, E = y, I = C;
            for (; I !== d.length && /\s/.test(d[I]); )
              I++;
            for (; E !== 0 && /\s/.test(d[E - 1]); )
              E--;
            return { start: E, end: I };
          }
          function g(o, d) {
            return d[o.start - 1] === "(" && d[o.end] === ")" ? { start: o.start - 1, end: o.end + 1 } : o;
          }
          function u(o, d, y) {
            let C = 0, E = { start: o.start, end: o.end };
            for (; ; ) {
              let I = c(E, d), j = g(I, d);
              if (I.start === j.start && I.end === j.end)
                break;
              E.start = j.start, E.end = j.end, C++;
            }
            return { hasParens: (y ? C - 1 : C) !== 0, outerSpan: N(y ? { start: E.start + 1, end: E.end - 1 } : E, d), innerSpan: N(o, d) };
          }
          e2.fitSpans = u;
          function v(o, d, y) {
            let C = d;
            for (; !o.test(y[C]); )
              if (--C < 0)
                throw new Error("Cannot find front char ".concat(o, " from index ").concat(d, " in ").concat(JSON.stringify(y)));
            return C;
          }
          e2.findFrontChar = v;
          function m2(o, d, y) {
            let C = d;
            for (; !o.test(y[C]); )
              if (++C >= y.length)
                throw new Error("Cannot find back char ".concat(o, " from index ").concat(d, " in ").concat(JSON.stringify(y)));
            return C;
          }
          e2.findBackChar = m2;
          function f3(o) {
            return o.slice(0, 1).toLowerCase() + o.slice(1);
          }
          e2.toLowerCamelCase = f3;
          function w(o) {
            return o.length === 0 ? void 0 : o[o.length - 1];
          }
          e2.getLast = w;
        } }), an = q({ "node_modules/angular-estree-parser/lib/transform.js"(e2) {
          "use strict";
          L(), Object.defineProperty(e2, "__esModule", { value: true }), e2.transformSpan = e2.transform = void 0;
          var t2 = ft(), n = function(s2, a) {
            let i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, l = t2.getNgType(s2);
            switch (l) {
              case "Unary": {
                let { operator: c, expr: g } = s2, u = h2(g);
                return p("UnaryExpression", { prefix: true, argument: u, operator: c }, s2.span, { hasParentParens: i2 });
              }
              case "Binary": {
                let { left: c, operation: g, right: u } = s2, v = u.span.start === u.span.end, m2 = c.span.start === c.span.end;
                if (v || m2) {
                  let o = c.span.start === c.span.end ? h2(u) : h2(c);
                  return p("UnaryExpression", { prefix: true, argument: o, operator: v ? "+" : "-" }, { start: s2.span.start, end: N(o) }, { hasParentParens: i2 });
                }
                let f3 = h2(c), w = h2(u);
                return p(g === "&&" || g === "||" ? "LogicalExpression" : "BinaryExpression", { left: f3, right: w, operator: g }, { start: O(f3), end: N(w) }, { hasParentParens: i2 });
              }
              case "BindingPipe": {
                let { exp: c, name: g, args: u } = s2, v = h2(c), m2 = b(/\S/, b(/\|/, N(v)) + 1), f3 = p("Identifier", { name: g }, { start: m2, end: m2 + g.length }), w = u.map(h2);
                return p("NGPipeExpression", { left: v, right: f3, arguments: w }, { start: O(v), end: N(w.length === 0 ? f3 : t2.getLast(w)) }, { hasParentParens: i2 });
              }
              case "Chain": {
                let { expressions: c } = s2;
                return p("NGChainedExpression", { expressions: c.map(h2) }, s2.span, { hasParentParens: i2 });
              }
              case "Comment": {
                let { value: c } = s2;
                return p("CommentLine", { value: c }, s2.span, { processSpan: false });
              }
              case "Conditional": {
                let { condition: c, trueExp: g, falseExp: u } = s2, v = h2(c), m2 = h2(g), f3 = h2(u);
                return p("ConditionalExpression", { test: v, consequent: m2, alternate: f3 }, { start: O(v), end: N(f3) }, { hasParentParens: i2 });
              }
              case "EmptyExpr":
                return p("NGEmptyExpression", {}, s2.span, { hasParentParens: i2 });
              case "FunctionCall": {
                let { target: c, args: g } = s2, u = g.length === 1 ? [P(g[0])] : g.map(h2), v = h2(c);
                return p("CallExpression", { callee: v, arguments: u }, { start: O(v), end: s2.span.end }, { hasParentParens: i2 });
              }
              case "ImplicitReceiver":
                return p("ThisExpression", {}, s2.span, { hasParentParens: i2 });
              case "KeyedRead": {
                let { key: c } = s2, g = Object.prototype.hasOwnProperty.call(s2, "receiver") ? s2.receiver : s2.obj, u = h2(c);
                return x2(g, u, { computed: true, optional: false }, { end: s2.span.end, hasParentParens: i2 });
              }
              case "LiteralArray": {
                let { expressions: c } = s2;
                return p("ArrayExpression", { elements: c.map(h2) }, s2.span, { hasParentParens: i2 });
              }
              case "LiteralMap": {
                let { keys: c, values: g } = s2, u = g.map((m2) => h2(m2)), v = c.map((m2, f3) => {
                  let { key: w, quoted: o } = m2, d = u[f3], y = b(/\S/, f3 === 0 ? s2.span.start + 1 : b(/,/, N(u[f3 - 1])) + 1), C = A2(/\S/, A2(/:/, O(d) - 1) - 1) + 1, E = { start: y, end: C }, I = o ? p("StringLiteral", { value: w }, E) : p("Identifier", { name: w }, E), j = I.end < I.start;
                  return p("ObjectProperty", { key: I, value: d, method: false, shorthand: j, computed: false }, { start: O(I), end: N(d) });
                });
                return p("ObjectExpression", { properties: v }, s2.span, { hasParentParens: i2 });
              }
              case "LiteralPrimitive": {
                let { value: c } = s2;
                switch (typeof c) {
                  case "boolean":
                    return p("BooleanLiteral", { value: c }, s2.span, { hasParentParens: i2 });
                  case "number":
                    return p("NumericLiteral", { value: c }, s2.span, { hasParentParens: i2 });
                  case "object":
                    return p("NullLiteral", {}, s2.span, { hasParentParens: i2 });
                  case "string":
                    return p("StringLiteral", { value: c }, s2.span, { hasParentParens: i2 });
                  case "undefined":
                    return p("Identifier", { name: "undefined" }, s2.span, { hasParentParens: i2 });
                  default:
                    throw new Error("Unexpected LiteralPrimitive value type ".concat(typeof c));
                }
              }
              case "MethodCall":
              case "SafeMethodCall": {
                let c = l === "SafeMethodCall", { receiver: g, name: u, args: v } = s2, m2 = v.length === 1 ? [P(v[0])] : v.map(h2), f3 = A2(/\S/, A2(/\(/, (m2.length === 0 ? A2(/\)/, s2.span.end - 1) : O(m2[0])) - 1) - 1) + 1, w = p("Identifier", { name: u }, { start: f3 - u.length, end: f3 }), o = x2(g, w, { computed: false, optional: c }), d = R(o);
                return p(c || d ? "OptionalCallExpression" : "CallExpression", { callee: o, arguments: m2 }, { start: O(o), end: s2.span.end }, { hasParentParens: i2 });
              }
              case "NonNullAssert": {
                let { expression: c } = s2, g = h2(c);
                return p("TSNonNullExpression", { expression: g }, { start: O(g), end: s2.span.end }, { hasParentParens: i2 });
              }
              case "PrefixNot": {
                let { expression: c } = s2, g = h2(c);
                return p("UnaryExpression", { prefix: true, operator: "!", argument: g }, { start: s2.span.start, end: N(g) }, { hasParentParens: i2 });
              }
              case "PropertyRead":
              case "SafePropertyRead": {
                let c = l === "SafePropertyRead", { receiver: g, name: u } = s2, v = A2(/\S/, s2.span.end - 1) + 1, m2 = p("Identifier", { name: u }, { start: v - u.length, end: v }, _(g) ? { hasParentParens: i2 } : {});
                return x2(g, m2, { computed: false, optional: c }, { hasParentParens: i2 });
              }
              case "KeyedWrite": {
                let { key: c, value: g } = s2, u = Object.prototype.hasOwnProperty.call(s2, "receiver") ? s2.receiver : s2.obj, v = h2(c), m2 = h2(g), f3 = x2(u, v, { computed: true, optional: false }, { end: b(/\]/, N(v)) + 1 });
                return p("AssignmentExpression", { left: f3, operator: "=", right: m2 }, { start: O(f3), end: N(m2) }, { hasParentParens: i2 });
              }
              case "PropertyWrite": {
                let { receiver: c, name: g, value: u } = s2, v = h2(u), m2 = A2(/\S/, A2(/=/, O(v) - 1) - 1) + 1, f3 = p("Identifier", { name: g }, { start: m2 - g.length, end: m2 }), w = x2(c, f3, { computed: false, optional: false });
                return p("AssignmentExpression", { left: w, operator: "=", right: v }, { start: O(w), end: N(v) }, { hasParentParens: i2 });
              }
              case "Quote": {
                let { prefix: c, uninterpretedExpression: g } = s2;
                return p("NGQuotedExpression", { prefix: c, value: g }, s2.span, { hasParentParens: i2 });
              }
              default:
                throw new Error("Unexpected node ".concat(l));
            }
            function h2(c) {
              return e2.transform(c, a);
            }
            function P(c) {
              return e2.transform(c, a, true);
            }
            function p(c, g, u) {
              let { processSpan: v = true, hasParentParens: m2 = false } = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {}, f3 = Object.assign(Object.assign({ type: c }, r2(u, a, v, m2)), g);
              switch (c) {
                case "Identifier": {
                  let w = f3;
                  w.loc.identifierName = w.name;
                  break;
                }
                case "NumericLiteral": {
                  let w = f3;
                  w.extra = Object.assign(Object.assign({}, w.extra), { raw: a.text.slice(w.start, w.end), rawValue: w.value });
                  break;
                }
                case "StringLiteral": {
                  let w = f3;
                  w.extra = Object.assign(Object.assign({}, w.extra), { raw: a.text.slice(w.start, w.end), rawValue: w.value });
                  break;
                }
              }
              return f3;
            }
            function x2(c, g, u) {
              let { end: v = N(g), hasParentParens: m2 = false } = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {};
              if (_(c) || c.span.start === g.start)
                return g;
              let f3 = h2(c), w = R(f3);
              return p(u.optional || w ? "OptionalMemberExpression" : "MemberExpression", Object.assign({ object: f3, property: g, computed: u.computed }, u.optional ? { optional: true } : w ? { optional: false } : null), { start: O(f3), end: v }, { hasParentParens: m2 });
            }
            function A2(c, g) {
              return t2.findFrontChar(c, g, a.text);
            }
            function b(c, g) {
              return t2.findBackChar(c, g, a.text);
            }
            function _(c) {
              return c.span.start >= c.span.end || /^\s+$/.test(a.text.slice(c.span.start, c.span.end));
            }
            function R(c) {
              return (c.type === "OptionalCallExpression" || c.type === "OptionalMemberExpression") && !T(c);
            }
            function T(c) {
              return c.extra && c.extra.parenthesized;
            }
            function O(c) {
              return T(c) ? c.extra.parenStart : c.start;
            }
            function N(c) {
              return T(c) ? c.extra.parenEnd : c.end;
            }
          };
          e2.transform = n;
          function r2(s2, a) {
            let i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, l = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false;
            if (!i2) {
              let { start: x2, end: A2 } = s2;
              return { start: x2, end: A2, loc: { start: a.locator.locationForIndex(x2), end: a.locator.locationForIndex(A2) } };
            }
            let { outerSpan: h2, innerSpan: P, hasParens: p } = t2.fitSpans(s2, a.text, l);
            return Object.assign({ start: P.start, end: P.end, loc: { start: a.locator.locationForIndex(P.start), end: a.locator.locationForIndex(P.end) } }, p && { extra: { parenthesized: true, parenStart: h2.start, parenEnd: h2.end } });
          }
          e2.transformSpan = r2;
        } }), Rn = q({ "node_modules/angular-estree-parser/lib/transform-microsyntax.js"(e2) {
          "use strict";
          L(), Object.defineProperty(e2, "__esModule", { value: true }), e2.transformTemplateBindings = void 0;
          var t2 = (tt(), be(Je)), n = an(), r2 = ft();
          function s2(a, i2) {
            a.forEach(N);
            let [l] = a, { key: h2 } = l, P = i2.text.slice(l.sourceSpan.start, l.sourceSpan.end).trim().length === 0 ? a.slice(1) : a, p = [], x2 = null;
            for (let u = 0; u < P.length; u++) {
              let v = P[u];
              if (x2 && T(x2) && O(v) && v.value && v.value.source === x2.key.source) {
                let m2 = _("NGMicrosyntaxKey", { name: v.key.source }, v.key.span), f3 = (d, y) => Object.assign(Object.assign({}, d), n.transformSpan({ start: d.start, end: y }, i2)), w = (d) => Object.assign(Object.assign({}, f3(d, m2.end)), { alias: m2 }), o = p.pop();
                if (o.type === "NGMicrosyntaxExpression")
                  p.push(w(o));
                else if (o.type === "NGMicrosyntaxKeyedExpression") {
                  let d = w(o.expression);
                  p.push(f3(Object.assign(Object.assign({}, o), { expression: d }), d.end));
                } else
                  throw new Error("Unexpected type ".concat(o.type));
              } else
                p.push(A2(v, u));
              x2 = v;
            }
            return _("NGMicrosyntax", { body: p }, p.length === 0 ? a[0].sourceSpan : { start: p[0].start, end: p[p.length - 1].end });
            function A2(u, v) {
              if (T(u)) {
                let { key: m2, value: f3 } = u;
                return f3 ? v === 0 ? _("NGMicrosyntaxExpression", { expression: b(f3.ast), alias: null }, f3.sourceSpan) : _("NGMicrosyntaxKeyedExpression", { key: _("NGMicrosyntaxKey", { name: R(m2.source) }, m2.span), expression: _("NGMicrosyntaxExpression", { expression: b(f3.ast), alias: null }, f3.sourceSpan) }, { start: m2.span.start, end: f3.sourceSpan.end }) : _("NGMicrosyntaxKey", { name: R(m2.source) }, m2.span);
              } else {
                let { key: m2, sourceSpan: f3 } = u;
                if (/^let\s$/.test(i2.text.slice(f3.start, f3.start + 4))) {
                  let { value: o } = u;
                  return _("NGMicrosyntaxLet", { key: _("NGMicrosyntaxKey", { name: m2.source }, m2.span), value: o ? _("NGMicrosyntaxKey", { name: o.source }, o.span) : null }, { start: f3.start, end: o ? o.span.end : m2.span.end });
                } else {
                  let o = g(u);
                  return _("NGMicrosyntaxAs", { key: _("NGMicrosyntaxKey", { name: o.source }, o.span), alias: _("NGMicrosyntaxKey", { name: m2.source }, m2.span) }, { start: o.span.start, end: m2.span.end });
                }
              }
            }
            function b(u) {
              return n.transform(u, i2);
            }
            function _(u, v, m2) {
              let f3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true;
              return Object.assign(Object.assign({ type: u }, n.transformSpan(m2, i2, f3)), v);
            }
            function R(u) {
              return r2.toLowerCamelCase(u.slice(h2.source.length));
            }
            function T(u) {
              return u instanceof t2.ExpressionBinding;
            }
            function O(u) {
              return u instanceof t2.VariableBinding;
            }
            function N(u) {
              c(u.key.span), O(u) && u.value && c(u.value.span);
            }
            function c(u) {
              if (i2.text[u.start] !== '"' && i2.text[u.start] !== "'")
                return;
              let v = i2.text[u.start], m2 = false;
              for (let f3 = u.start + 1; f3 < i2.text.length; f3++)
                switch (i2.text[f3]) {
                  case v:
                    if (!m2) {
                      u.end = f3 + 1;
                      return;
                    }
                  default:
                    m2 = false;
                    break;
                  case "\\":
                    m2 = !m2;
                    break;
                }
            }
            function g(u) {
              if (!u.value || u.value.source !== r2.NG_PARSE_TEMPLATE_BINDINGS_FAKE_PREFIX)
                return u.value;
              let v = r2.findBackChar(/\S/, u.sourceSpan.start, i2.text);
              return { source: "$implicit", span: { start: v, end: v } };
            }
          }
          e2.transformTemplateBindings = s2;
        } }), Tn = q({ "node_modules/angular-estree-parser/lib/index.js"(e2) {
          "use strict";
          L(), Object.defineProperty(e2, "__esModule", { value: true }), e2.parseTemplateBindings = e2.parseAction = e2.parseInterpolation = e2.parseSimpleBinding = e2.parseBinding = void 0;
          var t2 = vn(), n = an(), r2 = Rn(), s2 = ft();
          function a(x2, A2) {
            let { ast: b, comments: _ } = A2(x2), R = new t2.Context(x2), T = (N) => n.transform(N, R), O = T(b);
            return O.comments = _.map(T), O;
          }
          function i2(x2) {
            return a(x2, s2.parseNgBinding);
          }
          e2.parseBinding = i2;
          function l(x2) {
            return a(x2, s2.parseNgSimpleBinding);
          }
          e2.parseSimpleBinding = l;
          function h2(x2) {
            return a(x2, s2.parseNgInterpolation);
          }
          e2.parseInterpolation = h2;
          function P(x2) {
            return a(x2, s2.parseNgAction);
          }
          e2.parseAction = P;
          function p(x2) {
            return r2.transformTemplateBindings(s2.parseNgTemplateBindings(x2), new t2.Context(x2));
          }
          e2.parseTemplateBindings = p;
        } });
        L();
        var { locStart: Bn, locEnd: Kn } = fn();
        function Ne(e2) {
          return { astFormat: "estree", parse: (n, r2, s2) => {
            let a = Tn(), i2 = e2(n, a);
            return { type: "NGRoot", node: s2.parser === "__ng_action" && i2.type !== "NGChainedExpression" ? Object.assign(Object.assign({}, i2), {}, { type: "NGChainedExpression", expressions: [i2] }) : i2 };
          }, locStart: Bn, locEnd: Kn };
        }
        on.exports = { parsers: { __ng_action: Ne((e2, t2) => t2.parseAction(e2)), __ng_binding: Ne((e2, t2) => t2.parseBinding(e2)), __ng_interpolation: Ne((e2, t2) => t2.parseInterpolation(e2)), __ng_directive: Ne((e2, t2) => t2.parseTemplateBindings(e2)) } };
      });
      return Mn();
    });
  }
});

// node_modules/prettier/parser-espree.js
var require_parser_espree = __commonJS({
  "node_modules/prettier/parser-espree.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.espree = e2();
      }
    })(function() {
      "use strict";
      var S2 = (n, o) => () => (o || n((o = { exports: {} }).exports, o), o.exports);
      var $ = S2((Dh, qr) => {
        var Ze = function(n) {
          return n && n.Math == Math && n;
        };
        qr.exports = Ze(typeof globalThis == "object" && globalThis) || Ze(typeof window == "object" && window) || Ze(typeof self == "object" && self) || Ze(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      });
      var ye = S2((Oh, Mr) => {
        Mr.exports = function(n) {
          try {
            return !!n();
          } catch {
            return true;
          }
        };
      });
      var _e = S2((Lh, Ur) => {
        var tn = ye();
        Ur.exports = !tn(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Ct = S2((Vh, zr) => {
        var rn = ye();
        zr.exports = !rn(function() {
          var n = function() {
          }.bind();
          return typeof n != "function" || n.hasOwnProperty("prototype");
        });
      });
      var et = S2((Rh, Wr) => {
        var sn = Ct(), $e = Function.prototype.call;
        Wr.exports = sn ? $e.bind($e) : function() {
          return $e.apply($e, arguments);
        };
      });
      var Hr = S2((Xr) => {
        "use strict";
        var Gr = {}.propertyIsEnumerable, Kr = Object.getOwnPropertyDescriptor, an = Kr && !Gr.call({ 1: 2 }, 1);
        Xr.f = an ? function(o) {
          var u = Kr(this, o);
          return !!u && u.enumerable;
        } : Gr;
      });
      var Et = S2((qh, Jr) => {
        Jr.exports = function(n, o) {
          return { enumerable: !(n & 1), configurable: !(n & 2), writable: !(n & 4), value: o };
        };
      });
      var ce = S2((Mh, Zr) => {
        var Yr = Ct(), Qr = Function.prototype, nn = Qr.bind, bt = Qr.call, on = Yr && nn.bind(bt, bt);
        Zr.exports = Yr ? function(n) {
          return n && on(n);
        } : function(n) {
          return n && function() {
            return bt.apply(n, arguments);
          };
        };
      });
      var ti = S2((Uh, ei) => {
        var $r = ce(), un = $r({}.toString), hn = $r("".slice);
        ei.exports = function(n) {
          return hn(un(n), 8, -1);
        };
      });
      var ii = S2((zh, ri) => {
        var ln = $(), cn = ce(), pn = ye(), fn = ti(), _t = ln.Object, dn = cn("".split);
        ri.exports = pn(function() {
          return !_t("z").propertyIsEnumerable(0);
        }) ? function(n) {
          return fn(n) == "String" ? dn(n, "") : _t(n);
        } : _t;
      });
      var St = S2((Wh, si) => {
        var mn = $(), vn = mn.TypeError;
        si.exports = function(n) {
          if (n == null)
            throw vn("Can't call method on " + n);
          return n;
        };
      });
      var tt = S2((Gh, ai) => {
        var gn = ii(), xn = St();
        ai.exports = function(n) {
          return gn(xn(n));
        };
      });
      var pe = S2((Kh, ni) => {
        ni.exports = function(n) {
          return typeof n == "function";
        };
      });
      var Ie = S2((Xh, oi) => {
        var yn = pe();
        oi.exports = function(n) {
          return typeof n == "object" ? n !== null : yn(n);
        };
      });
      var rt = S2((Hh, ui) => {
        var wt = $(), An = pe(), Cn = function(n) {
          return An(n) ? n : void 0;
        };
        ui.exports = function(n, o) {
          return arguments.length < 2 ? Cn(wt[n]) : wt[n] && wt[n][o];
        };
      });
      var li = S2((Jh, hi) => {
        var En = ce();
        hi.exports = En({}.isPrototypeOf);
      });
      var pi = S2((Yh, ci) => {
        var bn = rt();
        ci.exports = bn("navigator", "userAgent") || "";
      });
      var yi = S2((Qh, xi) => {
        var gi = $(), kt = pi(), fi = gi.process, di = gi.Deno, mi = fi && fi.versions || di && di.version, vi = mi && mi.v8, he, it;
        vi && (he = vi.split("."), it = he[0] > 0 && he[0] < 4 ? 1 : +(he[0] + he[1]));
        !it && kt && (he = kt.match(/Edge\/(\d+)/), (!he || he[1] >= 74) && (he = kt.match(/Chrome\/(\d+)/), he && (it = +he[1])));
        xi.exports = it;
      });
      var Ft = S2((Zh, Ci) => {
        var Ai = yi(), _n = ye();
        Ci.exports = !!Object.getOwnPropertySymbols && !_n(function() {
          var n = Symbol();
          return !String(n) || !(Object(n) instanceof Symbol) || !Symbol.sham && Ai && Ai < 41;
        });
      });
      var Bt = S2(($h, Ei) => {
        var Sn = Ft();
        Ei.exports = Sn && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var Tt = S2((el, bi) => {
        var wn = $(), kn = rt(), Fn = pe(), Bn = li(), Tn = Bt(), In = wn.Object;
        bi.exports = Tn ? function(n) {
          return typeof n == "symbol";
        } : function(n) {
          var o = kn("Symbol");
          return Fn(o) && Bn(o.prototype, In(n));
        };
      });
      var Si = S2((tl, _i) => {
        var Pn = $(), Nn = Pn.String;
        _i.exports = function(n) {
          try {
            return Nn(n);
          } catch {
            return "Object";
          }
        };
      });
      var ki = S2((rl, wi) => {
        var Dn = $(), On = pe(), Ln = Si(), Vn = Dn.TypeError;
        wi.exports = function(n) {
          if (On(n))
            return n;
          throw Vn(Ln(n) + " is not a function");
        };
      });
      var Bi = S2((il, Fi) => {
        var Rn = ki();
        Fi.exports = function(n, o) {
          var u = n[o];
          return u == null ? void 0 : Rn(u);
        };
      });
      var Ii = S2((sl, Ti) => {
        var jn = $(), It = et(), Pt = pe(), Nt = Ie(), qn = jn.TypeError;
        Ti.exports = function(n, o) {
          var u, l;
          if (o === "string" && Pt(u = n.toString) && !Nt(l = It(u, n)) || Pt(u = n.valueOf) && !Nt(l = It(u, n)) || o !== "string" && Pt(u = n.toString) && !Nt(l = It(u, n)))
            return l;
          throw qn("Can't convert object to primitive value");
        };
      });
      var Ni = S2((al, Pi) => {
        Pi.exports = false;
      });
      var st = S2((nl, Oi) => {
        var Di = $(), Mn = Object.defineProperty;
        Oi.exports = function(n, o) {
          try {
            Mn(Di, n, { value: o, configurable: true, writable: true });
          } catch {
            Di[n] = o;
          }
          return o;
        };
      });
      var at = S2((ol, Vi) => {
        var Un = $(), zn = st(), Li = "__core-js_shared__", Wn = Un[Li] || zn(Li, {});
        Vi.exports = Wn;
      });
      var Dt = S2((ul, ji) => {
        var Gn = Ni(), Ri = at();
        (ji.exports = function(n, o) {
          return Ri[n] || (Ri[n] = o !== void 0 ? o : {});
        })("versions", []).push({ version: "3.22.2", mode: Gn ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var Mi = S2((hl, qi) => {
        var Kn = $(), Xn = St(), Hn = Kn.Object;
        qi.exports = function(n) {
          return Hn(Xn(n));
        };
      });
      var Ae = S2((ll, Ui) => {
        var Jn = ce(), Yn = Mi(), Qn = Jn({}.hasOwnProperty);
        Ui.exports = Object.hasOwn || function(o, u) {
          return Qn(Yn(o), u);
        };
      });
      var Ot = S2((cl, zi) => {
        var Zn = ce(), $n = 0, eo = Math.random(), to = Zn(1 .toString);
        zi.exports = function(n) {
          return "Symbol(" + (n === void 0 ? "" : n) + ")_" + to(++$n + eo, 36);
        };
      });
      var Ji = S2((pl, Hi) => {
        var ro = $(), io = Dt(), Wi = Ae(), so = Ot(), Gi = Ft(), Xi = Bt(), Pe = io("wks"), Se = ro.Symbol, Ki = Se && Se.for, ao = Xi ? Se : Se && Se.withoutSetter || so;
        Hi.exports = function(n) {
          if (!Wi(Pe, n) || !(Gi || typeof Pe[n] == "string")) {
            var o = "Symbol." + n;
            Gi && Wi(Se, n) ? Pe[n] = Se[n] : Xi && Ki ? Pe[n] = Ki(o) : Pe[n] = ao(o);
          }
          return Pe[n];
        };
      });
      var $i = S2((fl, Zi) => {
        var no = $(), oo = et(), Yi = Ie(), Qi = Tt(), uo = Bi(), ho = Ii(), lo = Ji(), co = no.TypeError, po = lo("toPrimitive");
        Zi.exports = function(n, o) {
          if (!Yi(n) || Qi(n))
            return n;
          var u = uo(n, po), l;
          if (u) {
            if (o === void 0 && (o = "default"), l = oo(u, n, o), !Yi(l) || Qi(l))
              return l;
            throw co("Can't convert object to primitive value");
          }
          return o === void 0 && (o = "number"), ho(n, o);
        };
      });
      var Lt = S2((dl, es) => {
        var fo = $i(), mo = Tt();
        es.exports = function(n) {
          var o = fo(n, "string");
          return mo(o) ? o : o + "";
        };
      });
      var is = S2((ml, rs) => {
        var vo = $(), ts = Ie(), Vt = vo.document, go = ts(Vt) && ts(Vt.createElement);
        rs.exports = function(n) {
          return go ? Vt.createElement(n) : {};
        };
      });
      var Rt = S2((vl, ss) => {
        var xo = _e(), yo = ye(), Ao = is();
        ss.exports = !xo && !yo(function() {
          return Object.defineProperty(Ao("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var jt = S2((ns) => {
        var Co = _e(), Eo = et(), bo = Hr(), _o = Et(), So = tt(), wo = Lt(), ko = Ae(), Fo = Rt(), as = Object.getOwnPropertyDescriptor;
        ns.f = Co ? as : function(o, u) {
          if (o = So(o), u = wo(u), Fo)
            try {
              return as(o, u);
            } catch {
            }
          if (ko(o, u))
            return _o(!Eo(bo.f, o, u), o[u]);
        };
      });
      var us = S2((xl, os) => {
        var Bo = _e(), To = ye();
        os.exports = Bo && To(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var qt = S2((yl, ls) => {
        var hs = $(), Io = Ie(), Po = hs.String, No = hs.TypeError;
        ls.exports = function(n) {
          if (Io(n))
            return n;
          throw No(Po(n) + " is not an object");
        };
      });
      var Gt = S2((ps) => {
        var Do = $(), Oo = _e(), Lo = Rt(), Vo = us(), nt = qt(), cs = Lt(), Ro = Do.TypeError, Mt = Object.defineProperty, jo = Object.getOwnPropertyDescriptor, Ut = "enumerable", zt = "configurable", Wt = "writable";
        ps.f = Oo ? Vo ? function(o, u, l) {
          if (nt(o), u = cs(u), nt(l), typeof o == "function" && u === "prototype" && "value" in l && Wt in l && !l[Wt]) {
            var m2 = jo(o, u);
            m2 && m2[Wt] && (o[u] = l.value, l = { configurable: zt in l ? l[zt] : m2[zt], enumerable: Ut in l ? l[Ut] : m2[Ut], writable: false });
          }
          return Mt(o, u, l);
        } : Mt : function(o, u, l) {
          if (nt(o), u = cs(u), nt(l), Lo)
            try {
              return Mt(o, u, l);
            } catch {
            }
          if ("get" in l || "set" in l)
            throw Ro("Accessors not supported");
          return "value" in l && (o[u] = l.value), o;
        };
      });
      var ot = S2((Cl, fs4) => {
        var qo = _e(), Mo = Gt(), Uo = Et();
        fs4.exports = qo ? function(n, o, u) {
          return Mo.f(n, o, Uo(1, u));
        } : function(n, o, u) {
          return n[o] = u, n;
        };
      });
      var Xt = S2((El, ds) => {
        var zo = ce(), Wo = pe(), Kt = at(), Go = zo(Function.toString);
        Wo(Kt.inspectSource) || (Kt.inspectSource = function(n) {
          return Go(n);
        });
        ds.exports = Kt.inspectSource;
      });
      var gs = S2((bl, vs) => {
        var Ko = $(), Xo = pe(), Ho = Xt(), ms = Ko.WeakMap;
        vs.exports = Xo(ms) && /native code/.test(Ho(ms));
      });
      var As = S2((_l, ys) => {
        var Jo = Dt(), Yo = Ot(), xs = Jo("keys");
        ys.exports = function(n) {
          return xs[n] || (xs[n] = Yo(n));
        };
      });
      var Ht = S2((Sl, Cs) => {
        Cs.exports = {};
      });
      var ks = S2((wl, ws) => {
        var Qo = gs(), Ss = $(), Jt = ce(), Zo = Ie(), $o = ot(), Yt = Ae(), Qt = at(), eu = As(), tu = Ht(), Es = "Object already initialized", $t = Ss.TypeError, ru = Ss.WeakMap, ut, qe, ht, iu = function(n) {
          return ht(n) ? qe(n) : ut(n, {});
        }, su = function(n) {
          return function(o) {
            var u;
            if (!Zo(o) || (u = qe(o)).type !== n)
              throw $t("Incompatible receiver, " + n + " required");
            return u;
          };
        };
        Qo || Qt.state ? (Ce = Qt.state || (Qt.state = new ru()), bs = Jt(Ce.get), Zt = Jt(Ce.has), _s = Jt(Ce.set), ut = function(n, o) {
          if (Zt(Ce, n))
            throw new $t(Es);
          return o.facade = n, _s(Ce, n, o), o;
        }, qe = function(n) {
          return bs(Ce, n) || {};
        }, ht = function(n) {
          return Zt(Ce, n);
        }) : (we = eu("state"), tu[we] = true, ut = function(n, o) {
          if (Yt(n, we))
            throw new $t(Es);
          return o.facade = n, $o(n, we, o), o;
        }, qe = function(n) {
          return Yt(n, we) ? n[we] : {};
        }, ht = function(n) {
          return Yt(n, we);
        });
        var Ce, bs, Zt, _s, we;
        ws.exports = { set: ut, get: qe, has: ht, enforce: iu, getterFor: su };
      });
      var Ts = S2((kl, Bs) => {
        var er = _e(), au = Ae(), Fs = Function.prototype, nu = er && Object.getOwnPropertyDescriptor, tr = au(Fs, "name"), ou = tr && function() {
        }.name === "something", uu = tr && (!er || er && nu(Fs, "name").configurable);
        Bs.exports = { EXISTS: tr, PROPER: ou, CONFIGURABLE: uu };
      });
      var Os = S2((Fl, Ds) => {
        var hu = $(), Is = pe(), lu = Ae(), Ps = ot(), cu = st(), pu = Xt(), Ns = ks(), fu = Ts().CONFIGURABLE, du = Ns.get, mu = Ns.enforce, vu = String(String).split("String");
        (Ds.exports = function(n, o, u, l) {
          var m2 = l ? !!l.unsafe : false, E = l ? !!l.enumerable : false, y = l ? !!l.noTargetGet : false, A2 = l && l.name !== void 0 ? l.name : o, b;
          if (Is(u) && (String(A2).slice(0, 7) === "Symbol(" && (A2 = "[" + String(A2).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!lu(u, "name") || fu && u.name !== A2) && Ps(u, "name", A2), b = mu(u), b.source || (b.source = vu.join(typeof A2 == "string" ? A2 : ""))), n === hu) {
            E ? n[o] = u : cu(o, u);
            return;
          } else
            m2 ? !y && n[o] && (E = true) : delete n[o];
          E ? n[o] = u : Ps(n, o, u);
        })(Function.prototype, "toString", function() {
          return Is(this) && du(this).source || pu(this);
        });
      });
      var rr = S2((Bl, Ls) => {
        var gu = Math.ceil, xu = Math.floor;
        Ls.exports = function(n) {
          var o = +n;
          return o !== o || o === 0 ? 0 : (o > 0 ? xu : gu)(o);
        };
      });
      var Rs = S2((Tl, Vs) => {
        var yu = rr(), Au = Math.max, Cu = Math.min;
        Vs.exports = function(n, o) {
          var u = yu(n);
          return u < 0 ? Au(u + o, 0) : Cu(u, o);
        };
      });
      var qs = S2((Il, js) => {
        var Eu = rr(), bu = Math.min;
        js.exports = function(n) {
          return n > 0 ? bu(Eu(n), 9007199254740991) : 0;
        };
      });
      var Us = S2((Pl, Ms) => {
        var _u = qs();
        Ms.exports = function(n) {
          return _u(n.length);
        };
      });
      var Gs = S2((Nl, Ws) => {
        var Su = tt(), wu = Rs(), ku = Us(), zs = function(n) {
          return function(o, u, l) {
            var m2 = Su(o), E = ku(m2), y = wu(l, E), A2;
            if (n && u != u) {
              for (; E > y; )
                if (A2 = m2[y++], A2 != A2)
                  return true;
            } else
              for (; E > y; y++)
                if ((n || y in m2) && m2[y] === u)
                  return n || y || 0;
            return !n && -1;
          };
        };
        Ws.exports = { includes: zs(true), indexOf: zs(false) };
      });
      var Hs = S2((Dl, Xs) => {
        var Fu = ce(), ir = Ae(), Bu = tt(), Tu = Gs().indexOf, Iu = Ht(), Ks = Fu([].push);
        Xs.exports = function(n, o) {
          var u = Bu(n), l = 0, m2 = [], E;
          for (E in u)
            !ir(Iu, E) && ir(u, E) && Ks(m2, E);
          for (; o.length > l; )
            ir(u, E = o[l++]) && (~Tu(m2, E) || Ks(m2, E));
          return m2;
        };
      });
      var Ys = S2((Ol, Js) => {
        Js.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var Zs = S2((Qs) => {
        var Pu = Hs(), Nu = Ys(), Du = Nu.concat("length", "prototype");
        Qs.f = Object.getOwnPropertyNames || function(o) {
          return Pu(o, Du);
        };
      });
      var ea = S2(($s) => {
        $s.f = Object.getOwnPropertySymbols;
      });
      var ra = S2((Rl, ta) => {
        var Ou = rt(), Lu = ce(), Vu = Zs(), Ru = ea(), ju = qt(), qu = Lu([].concat);
        ta.exports = Ou("Reflect", "ownKeys") || function(o) {
          var u = Vu.f(ju(o)), l = Ru.f;
          return l ? qu(u, l(o)) : u;
        };
      });
      var aa = S2((jl, sa) => {
        var ia = Ae(), Mu = ra(), Uu = jt(), zu = Gt();
        sa.exports = function(n, o, u) {
          for (var l = Mu(o), m2 = zu.f, E = Uu.f, y = 0; y < l.length; y++) {
            var A2 = l[y];
            !ia(n, A2) && !(u && ia(u, A2)) && m2(n, A2, E(o, A2));
          }
        };
      });
      var oa = S2((ql, na) => {
        var Wu = ye(), Gu = pe(), Ku = /#|\.prototype\./, Me = function(n, o) {
          var u = Hu[Xu(n)];
          return u == Yu ? true : u == Ju ? false : Gu(o) ? Wu(o) : !!o;
        }, Xu = Me.normalize = function(n) {
          return String(n).replace(Ku, ".").toLowerCase();
        }, Hu = Me.data = {}, Ju = Me.NATIVE = "N", Yu = Me.POLYFILL = "P";
        na.exports = Me;
      });
      var ha = S2((Ml, ua) => {
        var sr = $(), Qu = jt().f, Zu = ot(), $u = Os(), eh = st(), th = aa(), rh = oa();
        ua.exports = function(n, o) {
          var u = n.target, l = n.global, m2 = n.stat, E, y, A2, b, g, V;
          if (l ? y = sr : m2 ? y = sr[u] || eh(u, {}) : y = (sr[u] || {}).prototype, y)
            for (A2 in o) {
              if (g = o[A2], n.noTargetGet ? (V = Qu(y, A2), b = V && V.value) : b = y[A2], E = rh(l ? A2 : u + (m2 ? "." : "#") + A2, n.forced), !E && b !== void 0) {
                if (typeof g == typeof b)
                  continue;
                th(g, b);
              }
              (n.sham || b && b.sham) && Zu(g, "sham", true), $u(y, A2, g, n);
            }
        };
      });
      var la = S2(() => {
        var ih = ha(), sh = $();
        ih({ global: true }, { globalThis: sh });
      });
      var ca = S2(() => {
        la();
      });
      var Ph = S2((Xl, Na) => {
        ca();
        var ur = Object.defineProperty, ah = Object.getOwnPropertyDescriptor, hr = Object.getOwnPropertyNames, nh = Object.prototype.hasOwnProperty, pa = (n, o) => function() {
          return n && (o = (0, n[hr(n)[0]])(n = 0)), o;
        }, Y = (n, o) => function() {
          return o || (0, n[hr(n)[0]])((o = { exports: {} }).exports, o), o.exports;
        }, oh = (n, o) => {
          for (var u in o)
            ur(n, u, { get: o[u], enumerable: true });
        }, uh = (n, o, u, l) => {
          if (o && typeof o == "object" || typeof o == "function")
            for (let m2 of hr(o))
              !nh.call(n, m2) && m2 !== u && ur(n, m2, { get: () => o[m2], enumerable: !(l = ah(o, m2)) || l.enumerable });
          return n;
        }, hh = (n) => uh(ur({}, "__esModule", { value: true }), n), J = pa({ "<define:process>"() {
        } }), lr = Y({ "src/common/parser-create-error.js"(n, o) {
          "use strict";
          J();
          function u(l, m2) {
            let E = new SyntaxError(l + " (" + m2.start.line + ":" + m2.start.column + ")");
            return E.loc = m2, E;
          }
          o.exports = u;
        } }), fa = Y({ "src/utils/try-combinations.js"(n, o) {
          "use strict";
          J();
          function u() {
            let l;
            for (var m2 = arguments.length, E = new Array(m2), y = 0; y < m2; y++)
              E[y] = arguments[y];
            for (let [A2, b] of E.entries())
              try {
                return { result: b() };
              } catch (g) {
                A2 === 0 && (l = g);
              }
            return { error: l };
          }
          o.exports = u;
        } }), da = {};
        oh(da, { EOL: () => or, arch: () => lh, cpus: () => Ca, default: () => wa, endianness: () => ma, freemem: () => ya, getNetworkInterfaces: () => Sa, hostname: () => va, loadavg: () => ga, networkInterfaces: () => _a4, platform: () => ch, release: () => ba, tmpDir: () => ar, tmpdir: () => nr, totalmem: () => Aa, type: () => Ea, uptime: () => xa });
        function ma() {
          if (typeof lt > "u") {
            var n = new ArrayBuffer(2), o = new Uint8Array(n), u = new Uint16Array(n);
            if (o[0] = 1, o[1] = 2, u[0] === 258)
              lt = "BE";
            else if (u[0] === 513)
              lt = "LE";
            else
              throw new Error("unable to figure out endianess");
          }
          return lt;
        }
        function va() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function ga() {
          return [];
        }
        function xa() {
          return 0;
        }
        function ya() {
          return Number.MAX_VALUE;
        }
        function Aa() {
          return Number.MAX_VALUE;
        }
        function Ca() {
          return [];
        }
        function Ea() {
          return "Browser";
        }
        function ba() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function _a4() {
        }
        function Sa() {
        }
        function lh() {
          return "javascript";
        }
        function ch() {
          return "browser";
        }
        function ar() {
          return "/tmp";
        }
        var lt, nr, or, wa, ph = pa({ "node-modules-polyfills:os"() {
          J(), nr = ar, or = `
`, wa = { EOL: or, tmpdir: nr, tmpDir: ar, networkInterfaces: _a4, getNetworkInterfaces: Sa, release: ba, type: Ea, cpus: Ca, totalmem: Aa, freemem: ya, uptime: xa, loadavg: ga, hostname: va, endianness: ma };
        } }), fh = Y({ "node-modules-polyfills-commonjs:os"(n, o) {
          J();
          var u = (ph(), hh(da));
          if (u && u.default) {
            o.exports = u.default;
            for (let l in u)
              o.exports[l] = u[l];
          } else
            u && (o.exports = u);
        } }), dh = Y({ "node_modules/detect-newline/index.js"(n, o) {
          "use strict";
          J();
          var u = (l) => {
            if (typeof l != "string")
              throw new TypeError("Expected a string");
            let m2 = l.match(/(?:\r?\n)/g) || [];
            if (m2.length === 0)
              return;
            let E = m2.filter((A2) => A2 === `\r
`).length, y = m2.length - E;
            return E > y ? `\r
` : `
`;
          };
          o.exports = u, o.exports.graceful = (l) => typeof l == "string" && u(l) || `
`;
        } }), mh = Y({ "node_modules/jest-docblock/build/index.js"(n) {
          "use strict";
          J(), Object.defineProperty(n, "__esModule", { value: true }), n.extract = T, n.parse = q, n.parseWithComments = B, n.print = I, n.strip = v;
          function o() {
            let C = fh();
            return o = function() {
              return C;
            }, C;
          }
          function u() {
            let C = l(dh());
            return u = function() {
              return C;
            }, C;
          }
          function l(C) {
            return C && C.__esModule ? C : { default: C };
          }
          var m2 = /\*\/$/, E = /^\/\*\*/, y = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, A2 = /(^|\s+)\/\/([^\r\n]*)/g, b = /^(\r?\n)+/, g = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, V = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, R = /(\r?\n|^) *\* ?/g, N = [];
          function T(C) {
            let H = C.match(y);
            return H ? H[0].trimLeft() : "";
          }
          function v(C) {
            let H = C.match(y);
            return H && H[0] ? C.substring(H[0].length) : C;
          }
          function q(C) {
            return B(C).pragmas;
          }
          function B(C) {
            let H = (0, u().default)(C) || o().EOL;
            C = C.replace(E, "").replace(m2, "").replace(R, "$1");
            let L = "";
            for (; L !== C; )
              L = C, C = C.replace(g, "".concat(H, "$1 $2").concat(H));
            C = C.replace(b, "").trimRight();
            let i2 = /* @__PURE__ */ Object.create(null), _ = C.replace(V, "").replace(b, "").trimRight(), P;
            for (; P = V.exec(C); ) {
              let M = P[2].replace(A2, "");
              typeof i2[P[1]] == "string" || Array.isArray(i2[P[1]]) ? i2[P[1]] = N.concat(i2[P[1]], M) : i2[P[1]] = M;
            }
            return { comments: _, pragmas: i2 };
          }
          function I(C) {
            let { comments: H = "", pragmas: L = {} } = C, i2 = (0, u().default)(H) || o().EOL, _ = "/**", P = " *", M = " */", ee = Object.keys(L), ae = ee.map((ie) => k(ie, L[ie])).reduce((ie, Ne) => ie.concat(Ne), []).map((ie) => P + " " + ie + i2).join("");
            if (!H) {
              if (ee.length === 0)
                return "";
              if (ee.length === 1 && !Array.isArray(L[ee[0]])) {
                let ie = L[ee[0]];
                return "".concat(_, " ").concat(k(ee[0], ie)[0]).concat(M);
              }
            }
            let te = H.split(i2).map((ie) => "".concat(P, " ").concat(ie)).join(i2) + i2;
            return _ + i2 + (H ? te : "") + (H && ee.length ? P + i2 : "") + ae + M;
          }
          function k(C, H) {
            return N.concat(H).map((L) => "@".concat(C, " ").concat(L).trim());
          }
        } }), vh = Y({ "src/common/end-of-line.js"(n, o) {
          "use strict";
          J();
          function u(y) {
            let A2 = y.indexOf("\r");
            return A2 >= 0 ? y.charAt(A2 + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function l(y) {
            switch (y) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function m2(y, A2) {
            let b;
            switch (A2) {
              case `
`:
                b = /\n/g;
                break;
              case "\r":
                b = /\r/g;
                break;
              case `\r
`:
                b = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(A2), "."));
            }
            let g = y.match(b);
            return g ? g.length : 0;
          }
          function E(y) {
            return y.replace(/\r\n?/g, `
`);
          }
          o.exports = { guessEndOfLine: u, convertEndOfLineToChars: l, countEndOfLineChars: m2, normalizeEndOfLine: E };
        } }), gh = Y({ "src/language-js/utils/get-shebang.js"(n, o) {
          "use strict";
          J();
          function u(l) {
            if (!l.startsWith("#!"))
              return "";
            let m2 = l.indexOf(`
`);
            return m2 === -1 ? l : l.slice(0, m2);
          }
          o.exports = u;
        } }), xh = Y({ "src/language-js/pragma.js"(n, o) {
          "use strict";
          J();
          var { parseWithComments: u, strip: l, extract: m2, print: E } = mh(), { normalizeEndOfLine: y } = vh(), A2 = gh();
          function b(R) {
            let N = A2(R);
            N && (R = R.slice(N.length + 1));
            let T = m2(R), { pragmas: v, comments: q } = u(T);
            return { shebang: N, text: R, pragmas: v, comments: q };
          }
          function g(R) {
            let N = Object.keys(b(R).pragmas);
            return N.includes("prettier") || N.includes("format");
          }
          function V(R) {
            let { shebang: N, text: T, pragmas: v, comments: q } = b(R), B = l(T), I = E({ pragmas: Object.assign({ format: "" }, v), comments: q.trimStart() });
            return (N ? "".concat(N, `
`) : "") + y(I) + (B.startsWith(`
`) ? `
` : `

`) + B;
          }
          o.exports = { hasPragma: g, insertPragma: V };
        } }), yh = Y({ "src/utils/is-non-empty-array.js"(n, o) {
          "use strict";
          J();
          function u(l) {
            return Array.isArray(l) && l.length > 0;
          }
          o.exports = u;
        } }), ka = Y({ "src/language-js/loc.js"(n, o) {
          "use strict";
          J();
          var u = yh();
          function l(b, g) {
            let { ignoreDecorators: V } = g || {};
            if (!V) {
              let R = b.declaration && b.declaration.decorators || b.decorators;
              if (u(R))
                return l(R[0]);
            }
            return b.range ? b.range[0] : b.start;
          }
          function m2(b) {
            return b.range ? b.range[1] : b.end;
          }
          function E(b, g) {
            let V = l(b);
            return Number.isInteger(V) && V === l(g);
          }
          function y(b, g) {
            let V = m2(b);
            return Number.isInteger(V) && V === m2(g);
          }
          function A2(b, g) {
            return E(b, g) && y(b, g);
          }
          o.exports = { locStart: l, locEnd: m2, hasSameLocStart: E, hasSameLoc: A2 };
        } }), Fa = Y({ "src/language-js/parse/utils/create-parser.js"(n, o) {
          "use strict";
          J();
          var { hasPragma: u } = xh(), { locStart: l, locEnd: m2 } = ka();
          function E(y) {
            return y = typeof y == "function" ? { parse: y } : y, Object.assign({ astFormat: "estree", hasPragma: u, locStart: l, locEnd: m2 }, y);
          }
          o.exports = E;
        } }), Ah = Y({ "src/language-js/utils/is-ts-keyword-type.js"(n, o) {
          "use strict";
          J();
          function u(l) {
            let { type: m2 } = l;
            return m2.startsWith("TS") && m2.endsWith("Keyword");
          }
          o.exports = u;
        } }), Ch = Y({ "src/language-js/utils/is-block-comment.js"(n, o) {
          "use strict";
          J();
          var u = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), l = (m2) => u.has(m2 == null ? void 0 : m2.type);
          o.exports = l;
        } }), Eh = Y({ "src/language-js/utils/is-type-cast-comment.js"(n, o) {
          "use strict";
          J();
          var u = Ch();
          function l(m2) {
            return u(m2) && m2.value[0] === "*" && /@type\b/.test(m2.value);
          }
          o.exports = l;
        } }), bh = Y({ "src/utils/get-last.js"(n, o) {
          "use strict";
          J();
          var u = (l) => l[l.length - 1];
          o.exports = u;
        } }), Ba = Y({ "src/language-js/parse/postprocess/visit-node.js"(n, o) {
          "use strict";
          J();
          function u(l, m2) {
            if (Array.isArray(l)) {
              for (let E = 0; E < l.length; E++)
                l[E] = u(l[E], m2);
              return l;
            }
            if (l && typeof l == "object" && typeof l.type == "string") {
              let E = Object.keys(l);
              for (let y = 0; y < E.length; y++)
                l[E[y]] = u(l[E[y]], m2);
              return m2(l) || l;
            }
            return l;
          }
          o.exports = u;
        } }), Ta = Y({ "src/language-js/parse/postprocess/throw-syntax-error.js"(n, o) {
          "use strict";
          J();
          var u = lr();
          function l(m2, E) {
            let { start: y, end: A2 } = m2.loc;
            throw u(E, { start: { line: y.line, column: y.column + 1 }, end: { line: A2.line, column: A2.column + 1 } });
          }
          o.exports = l;
        } }), _h = Y({ "src/language-js/parse/postprocess/typescript.js"(n, o) {
          "use strict";
          J();
          var u = Ba(), l = Ta();
          function m2(A2, b, g) {
            let V = A2.decorators;
            if (!Array.isArray(V))
              return;
            let R = b.decorators;
            (!Array.isArray(R) || R.length !== V.length || V.some((N) => {
              let T = g.get(N);
              return !T || !R.includes(T);
            })) && l(b, "Leading decorators must be attached to a class declaration");
          }
          function E(A2, b) {
            A2.kind !== 167 || A2.modifiers && !A2.modifiers.some((R) => R.kind === 126) || A2.initializer && b.value === null && l(b, "Abstract property cannot have an initializer");
          }
          function y(A2, b) {
            let { esTreeNodeToTSNodeMap: g, tsNodeToESTreeNodeMap: V } = b.tsParseResult;
            u(A2, (R) => {
              let N = g.get(R);
              if (!N)
                return;
              let T = V.get(N);
              T === R && (m2(N, T, V), E(N, T));
            });
          }
          o.exports = { throwErrorForInvalidNodes: y };
        } }), Ia = Y({ "src/language-js/parse/postprocess/index.js"(n, o) {
          "use strict";
          J();
          var { locStart: u, locEnd: l } = ka(), m2 = Ah(), E = Eh(), y = bh(), A2 = Ba(), { throwErrorForInvalidNodes: b } = _h(), g = Ta();
          function V(v, q) {
            if (q.parser === "typescript" && /@|abstract/.test(q.originalText) && b(v, q), q.parser !== "typescript" && q.parser !== "flow" && q.parser !== "acorn" && q.parser !== "espree" && q.parser !== "meriyah") {
              let I = /* @__PURE__ */ new Set();
              v = A2(v, (k) => {
                k.leadingComments && k.leadingComments.some(E) && I.add(u(k));
              }), v = A2(v, (k) => {
                if (k.type === "ParenthesizedExpression") {
                  let { expression: C } = k;
                  if (C.type === "TypeCastExpression")
                    return C.range = k.range, C;
                  let H = u(k);
                  if (!I.has(H))
                    return C.extra = Object.assign(Object.assign({}, C.extra), {}, { parenthesized: true }), C;
                }
              });
            }
            return v = A2(v, (I) => {
              switch (I.type) {
                case "ChainExpression":
                  return R(I.expression);
                case "LogicalExpression": {
                  if (N(I))
                    return T(I);
                  break;
                }
                case "VariableDeclaration": {
                  let k = y(I.declarations);
                  k && k.init && B(I, k);
                  break;
                }
                case "TSParenthesizedType":
                  return m2(I.typeAnnotation) || I.typeAnnotation.type === "TSThisType" || (I.typeAnnotation.range = [u(I), l(I)]), I.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof I.name == "string") {
                    let k = u(I);
                    I.name = { type: "Identifier", name: I.name, range: [k, k + I.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (q.parser === "typescript") {
                    let k = I.properties.find((C) => C.type === "Property" && C.value.type === "TSEmptyBodyFunctionExpression");
                    k && g(k.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let k = y(I.expressions);
                  I.range = [u(I), Math.min(l(k), l(I))];
                  break;
                }
                case "TopicReference":
                  q.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: k } = I;
                  if (q.parser === "meriyah" && k && k.type === "Identifier") {
                    let C = q.originalText.slice(u(k), l(k));
                    (C.startsWith('"') || C.startsWith("'")) && (I.exported = Object.assign(Object.assign({}, I.exported), {}, { type: "Literal", value: I.exported.name, raw: C }));
                  }
                  break;
                }
              }
            }), v;
            function B(I, k) {
              q.originalText[l(k)] !== ";" && (I.range = [u(I), l(k)]);
            }
          }
          function R(v) {
            switch (v.type) {
              case "CallExpression":
                v.type = "OptionalCallExpression", v.callee = R(v.callee);
                break;
              case "MemberExpression":
                v.type = "OptionalMemberExpression", v.object = R(v.object);
                break;
              case "TSNonNullExpression":
                v.expression = R(v.expression);
                break;
            }
            return v;
          }
          function N(v) {
            return v.type === "LogicalExpression" && v.right.type === "LogicalExpression" && v.operator === v.right.operator;
          }
          function T(v) {
            return N(v) ? T({ type: "LogicalExpression", operator: v.operator, left: T({ type: "LogicalExpression", operator: v.operator, left: v.left, right: v.right.left, range: [u(v.left), l(v.right.left)] }), right: v.right.right, range: [u(v), l(v)] }) : v;
          }
          o.exports = V;
        } }), ct = Y({ "node_modules/acorn/dist/acorn.js"(n, o) {
          J(), function(u, l) {
            typeof n == "object" && typeof o < "u" ? l(n) : typeof define == "function" && define.amd ? define(["exports"], l) : (u = typeof globalThis < "u" ? globalThis : u || self, l(u.acorn = {}));
          }(n, function(u) {
            "use strict";
            var l = { 3: "abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized throws transient volatile", 5: "class enum extends super const export import", 6: "enum", strict: "implements interface let package private protected public static yield", strictBind: "eval arguments" }, m2 = "break case catch continue debugger default do else finally for function if return switch throw try var while with null true false instanceof typeof void delete new in this", E = { 5: m2, "5module": m2 + " export import", 6: m2 + " const class extends export import super" }, y = /^in(stanceof)?$/, A2 = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC", b = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F", g = new RegExp("[" + A2 + "]"), V = new RegExp("[" + A2 + b + "]");
            A2 = b = null;
            var R = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938], N = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
            function T(e2, t2) {
              for (var r2 = 65536, s2 = 0; s2 < t2.length; s2 += 2) {
                if (r2 += t2[s2], r2 > e2)
                  return false;
                if (r2 += t2[s2 + 1], r2 >= e2)
                  return true;
              }
            }
            function v(e2, t2) {
              return e2 < 65 ? e2 === 36 : e2 < 91 ? true : e2 < 97 ? e2 === 95 : e2 < 123 ? true : e2 <= 65535 ? e2 >= 170 && g.test(String.fromCharCode(e2)) : t2 === false ? false : T(e2, R);
            }
            function q(e2, t2) {
              return e2 < 48 ? e2 === 36 : e2 < 58 ? true : e2 < 65 ? false : e2 < 91 ? true : e2 < 97 ? e2 === 95 : e2 < 123 ? true : e2 <= 65535 ? e2 >= 170 && V.test(String.fromCharCode(e2)) : t2 === false ? false : T(e2, R) || T(e2, N);
            }
            var B = function(t2, r2) {
              r2 === void 0 && (r2 = {}), this.label = t2, this.keyword = r2.keyword, this.beforeExpr = !!r2.beforeExpr, this.startsExpr = !!r2.startsExpr, this.isLoop = !!r2.isLoop, this.isAssign = !!r2.isAssign, this.prefix = !!r2.prefix, this.postfix = !!r2.postfix, this.binop = r2.binop || null, this.updateContext = null;
            };
            function I(e2, t2) {
              return new B(e2, { beforeExpr: true, binop: t2 });
            }
            var k = { beforeExpr: true }, C = { startsExpr: true }, H = {};
            function L(e2, t2) {
              return t2 === void 0 && (t2 = {}), t2.keyword = e2, H[e2] = new B(e2, t2);
            }
            var i2 = { num: new B("num", C), regexp: new B("regexp", C), string: new B("string", C), name: new B("name", C), privateId: new B("privateId", C), eof: new B("eof"), bracketL: new B("[", { beforeExpr: true, startsExpr: true }), bracketR: new B("]"), braceL: new B("{", { beforeExpr: true, startsExpr: true }), braceR: new B("}"), parenL: new B("(", { beforeExpr: true, startsExpr: true }), parenR: new B(")"), comma: new B(",", k), semi: new B(";", k), colon: new B(":", k), dot: new B("."), question: new B("?", k), questionDot: new B("?."), arrow: new B("=>", k), template: new B("template"), invalidTemplate: new B("invalidTemplate"), ellipsis: new B("...", k), backQuote: new B("`", C), dollarBraceL: new B("${", { beforeExpr: true, startsExpr: true }), eq: new B("=", { beforeExpr: true, isAssign: true }), assign: new B("_=", { beforeExpr: true, isAssign: true }), incDec: new B("++/--", { prefix: true, postfix: true, startsExpr: true }), prefix: new B("!/~", { beforeExpr: true, prefix: true, startsExpr: true }), logicalOR: I("||", 1), logicalAND: I("&&", 2), bitwiseOR: I("|", 3), bitwiseXOR: I("^", 4), bitwiseAND: I("&", 5), equality: I("==/!=/===/!==", 6), relational: I("</>/<=/>=", 7), bitShift: I("<</>>/>>>", 8), plusMin: new B("+/-", { beforeExpr: true, binop: 9, prefix: true, startsExpr: true }), modulo: I("%", 10), star: I("*", 10), slash: I("/", 10), starstar: new B("**", { beforeExpr: true }), coalesce: I("??", 1), _break: L("break"), _case: L("case", k), _catch: L("catch"), _continue: L("continue"), _debugger: L("debugger"), _default: L("default", k), _do: L("do", { isLoop: true, beforeExpr: true }), _else: L("else", k), _finally: L("finally"), _for: L("for", { isLoop: true }), _function: L("function", C), _if: L("if"), _return: L("return", k), _switch: L("switch"), _throw: L("throw", k), _try: L("try"), _var: L("var"), _const: L("const"), _while: L("while", { isLoop: true }), _with: L("with"), _new: L("new", { beforeExpr: true, startsExpr: true }), _this: L("this", C), _super: L("super", C), _class: L("class", C), _extends: L("extends", k), _export: L("export"), _import: L("import", C), _null: L("null", C), _true: L("true", C), _false: L("false", C), _in: L("in", { beforeExpr: true, binop: 7 }), _instanceof: L("instanceof", { beforeExpr: true, binop: 7 }), _typeof: L("typeof", { beforeExpr: true, prefix: true, startsExpr: true }), _void: L("void", { beforeExpr: true, prefix: true, startsExpr: true }), _delete: L("delete", { beforeExpr: true, prefix: true, startsExpr: true }) }, _ = /\r\n?|\n|\u2028|\u2029/, P = new RegExp(_.source, "g");
            function M(e2) {
              return e2 === 10 || e2 === 13 || e2 === 8232 || e2 === 8233;
            }
            function ee(e2, t2, r2) {
              r2 === void 0 && (r2 = e2.length);
              for (var s2 = t2; s2 < r2; s2++) {
                var a = e2.charCodeAt(s2);
                if (M(a))
                  return s2 < r2 - 1 && a === 13 && e2.charCodeAt(s2 + 1) === 10 ? s2 + 2 : s2 + 1;
              }
              return -1;
            }
            var ae = /[\u1680\u2000-\u200a\u202f\u205f\u3000\ufeff]/, te = /(?:\s|\/\/.*|\/\*[^]*?\*\/)*/g, ie = Object.prototype, Ne = ie.hasOwnProperty, p = ie.toString, D = Object.hasOwn || function(e2, t2) {
              return Ne.call(e2, t2);
            }, w = Array.isArray || function(e2) {
              return p.call(e2) === "[object Array]";
            };
            function f3(e2) {
              return new RegExp("^(?:" + e2.replace(/ /g, "|") + ")$");
            }
            var F2 = /(?:[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF])/, K = function(t2, r2) {
              this.line = t2, this.column = r2;
            };
            K.prototype.offset = function(t2) {
              return new K(this.line, this.column + t2);
            };
            var X = function(t2, r2, s2) {
              this.start = r2, this.end = s2, t2.sourceFile !== null && (this.source = t2.sourceFile);
            };
            function oe(e2, t2) {
              for (var r2 = 1, s2 = 0; ; ) {
                var a = ee(e2, s2, t2);
                if (a < 0)
                  return new K(r2, t2 - s2);
                ++r2, s2 = a;
              }
            }
            var me = { ecmaVersion: null, sourceType: "script", onInsertedSemicolon: null, onTrailingComma: null, allowReserved: null, allowReturnOutsideFunction: false, allowImportExportEverywhere: false, allowAwaitOutsideFunction: null, allowSuperOutsideMethod: null, allowHashBang: false, locations: false, onToken: null, onComment: null, ranges: false, program: null, sourceFile: null, directSourceFile: null, preserveParens: false }, ve = false;
            function pt(e2) {
              var t2 = {};
              for (var r2 in me)
                t2[r2] = e2 && D(e2, r2) ? e2[r2] : me[r2];
              if (t2.ecmaVersion === "latest" ? t2.ecmaVersion = 1e8 : t2.ecmaVersion == null ? (!ve && typeof console == "object" && console.warn && (ve = true, console.warn(`Since Acorn 8.0.0, options.ecmaVersion is required.
Defaulting to 2020, but this will stop working in the future.`)), t2.ecmaVersion = 11) : t2.ecmaVersion >= 2015 && (t2.ecmaVersion -= 2009), t2.allowReserved == null && (t2.allowReserved = t2.ecmaVersion < 5), w(t2.onToken)) {
                var s2 = t2.onToken;
                t2.onToken = function(a) {
                  return s2.push(a);
                };
              }
              return w(t2.onComment) && (t2.onComment = ft(t2, t2.onComment)), t2;
            }
            function ft(e2, t2) {
              return function(r2, s2, a, h2, c, d) {
                var x2 = { type: r2 ? "Block" : "Line", value: s2, start: a, end: h2 };
                e2.locations && (x2.loc = new X(this, c, d)), e2.ranges && (x2.range = [a, h2]), t2.push(x2);
              };
            }
            var Ee = 1, ge = 2, De = 4, Ue = 8, cr = 16, pr = 32, dt = 64, fr = 128, Oe = 256, mt = Ee | ge | Oe;
            function vt(e2, t2) {
              return ge | (e2 ? De : 0) | (t2 ? Ue : 0);
            }
            var ze = 0, gt = 1, fe = 2, dr = 3, mr = 4, vr = 5, Z2 = function(t2, r2, s2) {
              this.options = t2 = pt(t2), this.sourceFile = t2.sourceFile, this.keywords = f3(E[t2.ecmaVersion >= 6 ? 6 : t2.sourceType === "module" ? "5module" : 5]);
              var a = "";
              t2.allowReserved !== true && (a = l[t2.ecmaVersion >= 6 ? 6 : t2.ecmaVersion === 5 ? 5 : 3], t2.sourceType === "module" && (a += " await")), this.reservedWords = f3(a);
              var h2 = (a ? a + " " : "") + l.strict;
              this.reservedWordsStrict = f3(h2), this.reservedWordsStrictBind = f3(h2 + " " + l.strictBind), this.input = String(r2), this.containsEsc = false, s2 ? (this.pos = s2, this.lineStart = this.input.lastIndexOf(`
`, s2 - 1) + 1, this.curLine = this.input.slice(0, this.lineStart).split(_).length) : (this.pos = this.lineStart = 0, this.curLine = 1), this.type = i2.eof, this.value = null, this.start = this.end = this.pos, this.startLoc = this.endLoc = this.curPosition(), this.lastTokEndLoc = this.lastTokStartLoc = null, this.lastTokStart = this.lastTokEnd = this.pos, this.context = this.initialContext(), this.exprAllowed = true, this.inModule = t2.sourceType === "module", this.strict = this.inModule || this.strictDirective(this.pos), this.potentialArrowAt = -1, this.potentialArrowInForAwait = false, this.yieldPos = this.awaitPos = this.awaitIdentPos = 0, this.labels = [], this.undefinedExports = /* @__PURE__ */ Object.create(null), this.pos === 0 && t2.allowHashBang && this.input.slice(0, 2) === "#!" && this.skipLineComment(2), this.scopeStack = [], this.enterScope(Ee), this.regexpState = null, this.privateNameStack = [];
            }, le = { inFunction: { configurable: true }, inGenerator: { configurable: true }, inAsync: { configurable: true }, canAwait: { configurable: true }, allowSuper: { configurable: true }, allowDirectSuper: { configurable: true }, treatFunctionsAsVar: { configurable: true }, allowNewDotTarget: { configurable: true }, inClassStaticBlock: { configurable: true } };
            Z2.prototype.parse = function() {
              var t2 = this.options.program || this.startNode();
              return this.nextToken(), this.parseTopLevel(t2);
            }, le.inFunction.get = function() {
              return (this.currentVarScope().flags & ge) > 0;
            }, le.inGenerator.get = function() {
              return (this.currentVarScope().flags & Ue) > 0 && !this.currentVarScope().inClassFieldInit;
            }, le.inAsync.get = function() {
              return (this.currentVarScope().flags & De) > 0 && !this.currentVarScope().inClassFieldInit;
            }, le.canAwait.get = function() {
              for (var e2 = this.scopeStack.length - 1; e2 >= 0; e2--) {
                var t2 = this.scopeStack[e2];
                if (t2.inClassFieldInit || t2.flags & Oe)
                  return false;
                if (t2.flags & ge)
                  return (t2.flags & De) > 0;
              }
              return this.inModule && this.options.ecmaVersion >= 13 || this.options.allowAwaitOutsideFunction;
            }, le.allowSuper.get = function() {
              var e2 = this.currentThisScope(), t2 = e2.flags, r2 = e2.inClassFieldInit;
              return (t2 & dt) > 0 || r2 || this.options.allowSuperOutsideMethod;
            }, le.allowDirectSuper.get = function() {
              return (this.currentThisScope().flags & fr) > 0;
            }, le.treatFunctionsAsVar.get = function() {
              return this.treatFunctionsAsVarInScope(this.currentScope());
            }, le.allowNewDotTarget.get = function() {
              var e2 = this.currentThisScope(), t2 = e2.flags, r2 = e2.inClassFieldInit;
              return (t2 & (ge | Oe)) > 0 || r2;
            }, le.inClassStaticBlock.get = function() {
              return (this.currentVarScope().flags & Oe) > 0;
            }, Z2.extend = function() {
              for (var t2 = [], r2 = arguments.length; r2--; )
                t2[r2] = arguments[r2];
              for (var s2 = this, a = 0; a < t2.length; a++)
                s2 = t2[a](s2);
              return s2;
            }, Z2.parse = function(t2, r2) {
              return new this(r2, t2).parse();
            }, Z2.parseExpressionAt = function(t2, r2, s2) {
              var a = new this(s2, t2, r2);
              return a.nextToken(), a.parseExpression();
            }, Z2.tokenizer = function(t2, r2) {
              return new this(r2, t2);
            }, Object.defineProperties(Z2.prototype, le);
            var se = Z2.prototype, Da = /^(?:'((?:\\.|[^'\\])*?)'|"((?:\\.|[^"\\])*?)")/;
            se.strictDirective = function(e2) {
              for (; ; ) {
                te.lastIndex = e2, e2 += te.exec(this.input)[0].length;
                var t2 = Da.exec(this.input.slice(e2));
                if (!t2)
                  return false;
                if ((t2[1] || t2[2]) === "use strict") {
                  te.lastIndex = e2 + t2[0].length;
                  var r2 = te.exec(this.input), s2 = r2.index + r2[0].length, a = this.input.charAt(s2);
                  return a === ";" || a === "}" || _.test(r2[0]) && !(/[(`.[+\-/*%<>=,?^&]/.test(a) || a === "!" && this.input.charAt(s2 + 1) === "=");
                }
                e2 += t2[0].length, te.lastIndex = e2, e2 += te.exec(this.input)[0].length, this.input[e2] === ";" && e2++;
              }
            }, se.eat = function(e2) {
              return this.type === e2 ? (this.next(), true) : false;
            }, se.isContextual = function(e2) {
              return this.type === i2.name && this.value === e2 && !this.containsEsc;
            }, se.eatContextual = function(e2) {
              return this.isContextual(e2) ? (this.next(), true) : false;
            }, se.expectContextual = function(e2) {
              this.eatContextual(e2) || this.unexpected();
            }, se.canInsertSemicolon = function() {
              return this.type === i2.eof || this.type === i2.braceR || _.test(this.input.slice(this.lastTokEnd, this.start));
            }, se.insertSemicolon = function() {
              if (this.canInsertSemicolon())
                return this.options.onInsertedSemicolon && this.options.onInsertedSemicolon(this.lastTokEnd, this.lastTokEndLoc), true;
            }, se.semicolon = function() {
              !this.eat(i2.semi) && !this.insertSemicolon() && this.unexpected();
            }, se.afterTrailingComma = function(e2, t2) {
              if (this.type === e2)
                return this.options.onTrailingComma && this.options.onTrailingComma(this.lastTokStart, this.lastTokStartLoc), t2 || this.next(), true;
            }, se.expect = function(e2) {
              this.eat(e2) || this.unexpected();
            }, se.unexpected = function(e2) {
              this.raise(e2 != null ? e2 : this.start, "Unexpected token");
            };
            function We() {
              this.shorthandAssign = this.trailingComma = this.parenthesizedAssign = this.parenthesizedBind = this.doubleProto = -1;
            }
            se.checkPatternErrors = function(e2, t2) {
              if (!!e2) {
                e2.trailingComma > -1 && this.raiseRecoverable(e2.trailingComma, "Comma is not permitted after the rest element");
                var r2 = t2 ? e2.parenthesizedAssign : e2.parenthesizedBind;
                r2 > -1 && this.raiseRecoverable(r2, "Parenthesized pattern");
              }
            }, se.checkExpressionErrors = function(e2, t2) {
              if (!e2)
                return false;
              var r2 = e2.shorthandAssign, s2 = e2.doubleProto;
              if (!t2)
                return r2 >= 0 || s2 >= 0;
              r2 >= 0 && this.raise(r2, "Shorthand property assignments are valid only in destructuring patterns"), s2 >= 0 && this.raiseRecoverable(s2, "Redefinition of __proto__ property");
            }, se.checkYieldAwaitInDefaultParams = function() {
              this.yieldPos && (!this.awaitPos || this.yieldPos < this.awaitPos) && this.raise(this.yieldPos, "Yield expression cannot be a default value"), this.awaitPos && this.raise(this.awaitPos, "Await expression cannot be a default value");
            }, se.isSimpleAssignTarget = function(e2) {
              return e2.type === "ParenthesizedExpression" ? this.isSimpleAssignTarget(e2.expression) : e2.type === "Identifier" || e2.type === "MemberExpression";
            };
            var j = Z2.prototype;
            j.parseTopLevel = function(e2) {
              var t2 = /* @__PURE__ */ Object.create(null);
              for (e2.body || (e2.body = []); this.type !== i2.eof; ) {
                var r2 = this.parseStatement(null, true, t2);
                e2.body.push(r2);
              }
              if (this.inModule)
                for (var s2 = 0, a = Object.keys(this.undefinedExports); s2 < a.length; s2 += 1) {
                  var h2 = a[s2];
                  this.raiseRecoverable(this.undefinedExports[h2].start, "Export '" + h2 + "' is not defined");
                }
              return this.adaptDirectivePrologue(e2.body), this.next(), e2.sourceType = this.options.sourceType, this.finishNode(e2, "Program");
            };
            var xt = { kind: "loop" }, Oa = { kind: "switch" };
            j.isLet = function(e2) {
              if (this.options.ecmaVersion < 6 || !this.isContextual("let"))
                return false;
              te.lastIndex = this.pos;
              var t2 = te.exec(this.input), r2 = this.pos + t2[0].length, s2 = this.input.charCodeAt(r2);
              if (s2 === 91 || s2 === 92 || s2 > 55295 && s2 < 56320)
                return true;
              if (e2)
                return false;
              if (s2 === 123)
                return true;
              if (v(s2, true)) {
                for (var a = r2 + 1; q(s2 = this.input.charCodeAt(a), true); )
                  ++a;
                if (s2 === 92 || s2 > 55295 && s2 < 56320)
                  return true;
                var h2 = this.input.slice(r2, a);
                if (!y.test(h2))
                  return true;
              }
              return false;
            }, j.isAsyncFunction = function() {
              if (this.options.ecmaVersion < 8 || !this.isContextual("async"))
                return false;
              te.lastIndex = this.pos;
              var e2 = te.exec(this.input), t2 = this.pos + e2[0].length, r2;
              return !_.test(this.input.slice(this.pos, t2)) && this.input.slice(t2, t2 + 8) === "function" && (t2 + 8 === this.input.length || !(q(r2 = this.input.charCodeAt(t2 + 8)) || r2 > 55295 && r2 < 56320));
            }, j.parseStatement = function(e2, t2, r2) {
              var s2 = this.type, a = this.startNode(), h2;
              switch (this.isLet(e2) && (s2 = i2._var, h2 = "let"), s2) {
                case i2._break:
                case i2._continue:
                  return this.parseBreakContinueStatement(a, s2.keyword);
                case i2._debugger:
                  return this.parseDebuggerStatement(a);
                case i2._do:
                  return this.parseDoStatement(a);
                case i2._for:
                  return this.parseForStatement(a);
                case i2._function:
                  return e2 && (this.strict || e2 !== "if" && e2 !== "label") && this.options.ecmaVersion >= 6 && this.unexpected(), this.parseFunctionStatement(a, false, !e2);
                case i2._class:
                  return e2 && this.unexpected(), this.parseClass(a, true);
                case i2._if:
                  return this.parseIfStatement(a);
                case i2._return:
                  return this.parseReturnStatement(a);
                case i2._switch:
                  return this.parseSwitchStatement(a);
                case i2._throw:
                  return this.parseThrowStatement(a);
                case i2._try:
                  return this.parseTryStatement(a);
                case i2._const:
                case i2._var:
                  return h2 = h2 || this.value, e2 && h2 !== "var" && this.unexpected(), this.parseVarStatement(a, h2);
                case i2._while:
                  return this.parseWhileStatement(a);
                case i2._with:
                  return this.parseWithStatement(a);
                case i2.braceL:
                  return this.parseBlock(true, a);
                case i2.semi:
                  return this.parseEmptyStatement(a);
                case i2._export:
                case i2._import:
                  if (this.options.ecmaVersion > 10 && s2 === i2._import) {
                    te.lastIndex = this.pos;
                    var c = te.exec(this.input), d = this.pos + c[0].length, x2 = this.input.charCodeAt(d);
                    if (x2 === 40 || x2 === 46)
                      return this.parseExpressionStatement(a, this.parseExpression());
                  }
                  return this.options.allowImportExportEverywhere || (t2 || this.raise(this.start, "'import' and 'export' may only appear at the top level"), this.inModule || this.raise(this.start, "'import' and 'export' may appear only with 'sourceType: module'")), s2 === i2._import ? this.parseImport(a) : this.parseExport(a, r2);
                default:
                  if (this.isAsyncFunction())
                    return e2 && this.unexpected(), this.next(), this.parseFunctionStatement(a, true, !e2);
                  var U = this.value, W = this.parseExpression();
                  return s2 === i2.name && W.type === "Identifier" && this.eat(i2.colon) ? this.parseLabeledStatement(a, U, W, e2) : this.parseExpressionStatement(a, W);
              }
            }, j.parseBreakContinueStatement = function(e2, t2) {
              var r2 = t2 === "break";
              this.next(), this.eat(i2.semi) || this.insertSemicolon() ? e2.label = null : this.type !== i2.name ? this.unexpected() : (e2.label = this.parseIdent(), this.semicolon());
              for (var s2 = 0; s2 < this.labels.length; ++s2) {
                var a = this.labels[s2];
                if ((e2.label == null || a.name === e2.label.name) && (a.kind != null && (r2 || a.kind === "loop") || e2.label && r2))
                  break;
              }
              return s2 === this.labels.length && this.raise(e2.start, "Unsyntactic " + t2), this.finishNode(e2, r2 ? "BreakStatement" : "ContinueStatement");
            }, j.parseDebuggerStatement = function(e2) {
              return this.next(), this.semicolon(), this.finishNode(e2, "DebuggerStatement");
            }, j.parseDoStatement = function(e2) {
              return this.next(), this.labels.push(xt), e2.body = this.parseStatement("do"), this.labels.pop(), this.expect(i2._while), e2.test = this.parseParenExpression(), this.options.ecmaVersion >= 6 ? this.eat(i2.semi) : this.semicolon(), this.finishNode(e2, "DoWhileStatement");
            }, j.parseForStatement = function(e2) {
              this.next();
              var t2 = this.options.ecmaVersion >= 9 && this.canAwait && this.eatContextual("await") ? this.lastTokStart : -1;
              if (this.labels.push(xt), this.enterScope(0), this.expect(i2.parenL), this.type === i2.semi)
                return t2 > -1 && this.unexpected(t2), this.parseFor(e2, null);
              var r2 = this.isLet();
              if (this.type === i2._var || this.type === i2._const || r2) {
                var s2 = this.startNode(), a = r2 ? "let" : this.value;
                return this.next(), this.parseVar(s2, true, a), this.finishNode(s2, "VariableDeclaration"), (this.type === i2._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) && s2.declarations.length === 1 ? (this.options.ecmaVersion >= 9 && (this.type === i2._in ? t2 > -1 && this.unexpected(t2) : e2.await = t2 > -1), this.parseForIn(e2, s2)) : (t2 > -1 && this.unexpected(t2), this.parseFor(e2, s2));
              }
              var h2 = this.isContextual("let"), c = false, d = new We(), x2 = this.parseExpression(t2 > -1 ? "await" : true, d);
              return this.type === i2._in || (c = this.options.ecmaVersion >= 6 && this.isContextual("of")) ? (this.options.ecmaVersion >= 9 && (this.type === i2._in ? t2 > -1 && this.unexpected(t2) : e2.await = t2 > -1), h2 && c && this.raise(x2.start, "The left-hand side of a for-of loop may not start with 'let'."), this.toAssignable(x2, false, d), this.checkLValPattern(x2), this.parseForIn(e2, x2)) : (this.checkExpressionErrors(d, true), t2 > -1 && this.unexpected(t2), this.parseFor(e2, x2));
            }, j.parseFunctionStatement = function(e2, t2, r2) {
              return this.next(), this.parseFunction(e2, Le | (r2 ? 0 : yt), false, t2);
            }, j.parseIfStatement = function(e2) {
              return this.next(), e2.test = this.parseParenExpression(), e2.consequent = this.parseStatement("if"), e2.alternate = this.eat(i2._else) ? this.parseStatement("if") : null, this.finishNode(e2, "IfStatement");
            }, j.parseReturnStatement = function(e2) {
              return !this.inFunction && !this.options.allowReturnOutsideFunction && this.raise(this.start, "'return' outside of function"), this.next(), this.eat(i2.semi) || this.insertSemicolon() ? e2.argument = null : (e2.argument = this.parseExpression(), this.semicolon()), this.finishNode(e2, "ReturnStatement");
            }, j.parseSwitchStatement = function(e2) {
              this.next(), e2.discriminant = this.parseParenExpression(), e2.cases = [], this.expect(i2.braceL), this.labels.push(Oa), this.enterScope(0);
              for (var t2, r2 = false; this.type !== i2.braceR; )
                if (this.type === i2._case || this.type === i2._default) {
                  var s2 = this.type === i2._case;
                  t2 && this.finishNode(t2, "SwitchCase"), e2.cases.push(t2 = this.startNode()), t2.consequent = [], this.next(), s2 ? t2.test = this.parseExpression() : (r2 && this.raiseRecoverable(this.lastTokStart, "Multiple default clauses"), r2 = true, t2.test = null), this.expect(i2.colon);
                } else
                  t2 || this.unexpected(), t2.consequent.push(this.parseStatement(null));
              return this.exitScope(), t2 && this.finishNode(t2, "SwitchCase"), this.next(), this.labels.pop(), this.finishNode(e2, "SwitchStatement");
            }, j.parseThrowStatement = function(e2) {
              return this.next(), _.test(this.input.slice(this.lastTokEnd, this.start)) && this.raise(this.lastTokEnd, "Illegal newline after throw"), e2.argument = this.parseExpression(), this.semicolon(), this.finishNode(e2, "ThrowStatement");
            };
            var La = [];
            j.parseTryStatement = function(e2) {
              if (this.next(), e2.block = this.parseBlock(), e2.handler = null, this.type === i2._catch) {
                var t2 = this.startNode();
                if (this.next(), this.eat(i2.parenL)) {
                  t2.param = this.parseBindingAtom();
                  var r2 = t2.param.type === "Identifier";
                  this.enterScope(r2 ? pr : 0), this.checkLValPattern(t2.param, r2 ? mr : fe), this.expect(i2.parenR);
                } else
                  this.options.ecmaVersion < 10 && this.unexpected(), t2.param = null, this.enterScope(0);
                t2.body = this.parseBlock(false), this.exitScope(), e2.handler = this.finishNode(t2, "CatchClause");
              }
              return e2.finalizer = this.eat(i2._finally) ? this.parseBlock() : null, !e2.handler && !e2.finalizer && this.raise(e2.start, "Missing catch or finally clause"), this.finishNode(e2, "TryStatement");
            }, j.parseVarStatement = function(e2, t2) {
              return this.next(), this.parseVar(e2, false, t2), this.semicolon(), this.finishNode(e2, "VariableDeclaration");
            }, j.parseWhileStatement = function(e2) {
              return this.next(), e2.test = this.parseParenExpression(), this.labels.push(xt), e2.body = this.parseStatement("while"), this.labels.pop(), this.finishNode(e2, "WhileStatement");
            }, j.parseWithStatement = function(e2) {
              return this.strict && this.raise(this.start, "'with' in strict mode"), this.next(), e2.object = this.parseParenExpression(), e2.body = this.parseStatement("with"), this.finishNode(e2, "WithStatement");
            }, j.parseEmptyStatement = function(e2) {
              return this.next(), this.finishNode(e2, "EmptyStatement");
            }, j.parseLabeledStatement = function(e2, t2, r2, s2) {
              for (var a = 0, h2 = this.labels; a < h2.length; a += 1) {
                var c = h2[a];
                c.name === t2 && this.raise(r2.start, "Label '" + t2 + "' is already declared");
              }
              for (var d = this.type.isLoop ? "loop" : this.type === i2._switch ? "switch" : null, x2 = this.labels.length - 1; x2 >= 0; x2--) {
                var U = this.labels[x2];
                if (U.statementStart === e2.start)
                  U.statementStart = this.start, U.kind = d;
                else
                  break;
              }
              return this.labels.push({ name: t2, kind: d, statementStart: this.start }), e2.body = this.parseStatement(s2 ? s2.indexOf("label") === -1 ? s2 + "label" : s2 : "label"), this.labels.pop(), e2.label = r2, this.finishNode(e2, "LabeledStatement");
            }, j.parseExpressionStatement = function(e2, t2) {
              return e2.expression = t2, this.semicolon(), this.finishNode(e2, "ExpressionStatement");
            }, j.parseBlock = function(e2, t2, r2) {
              for (e2 === void 0 && (e2 = true), t2 === void 0 && (t2 = this.startNode()), t2.body = [], this.expect(i2.braceL), e2 && this.enterScope(0); this.type !== i2.braceR; ) {
                var s2 = this.parseStatement(null);
                t2.body.push(s2);
              }
              return r2 && (this.strict = false), this.next(), e2 && this.exitScope(), this.finishNode(t2, "BlockStatement");
            }, j.parseFor = function(e2, t2) {
              return e2.init = t2, this.expect(i2.semi), e2.test = this.type === i2.semi ? null : this.parseExpression(), this.expect(i2.semi), e2.update = this.type === i2.parenR ? null : this.parseExpression(), this.expect(i2.parenR), e2.body = this.parseStatement("for"), this.exitScope(), this.labels.pop(), this.finishNode(e2, "ForStatement");
            }, j.parseForIn = function(e2, t2) {
              var r2 = this.type === i2._in;
              return this.next(), t2.type === "VariableDeclaration" && t2.declarations[0].init != null && (!r2 || this.options.ecmaVersion < 8 || this.strict || t2.kind !== "var" || t2.declarations[0].id.type !== "Identifier") && this.raise(t2.start, (r2 ? "for-in" : "for-of") + " loop variable declaration may not have an initializer"), e2.left = t2, e2.right = r2 ? this.parseExpression() : this.parseMaybeAssign(), this.expect(i2.parenR), e2.body = this.parseStatement("for"), this.exitScope(), this.labels.pop(), this.finishNode(e2, r2 ? "ForInStatement" : "ForOfStatement");
            }, j.parseVar = function(e2, t2, r2) {
              for (e2.declarations = [], e2.kind = r2; ; ) {
                var s2 = this.startNode();
                if (this.parseVarId(s2, r2), this.eat(i2.eq) ? s2.init = this.parseMaybeAssign(t2) : r2 === "const" && !(this.type === i2._in || this.options.ecmaVersion >= 6 && this.isContextual("of")) ? this.unexpected() : s2.id.type !== "Identifier" && !(t2 && (this.type === i2._in || this.isContextual("of"))) ? this.raise(this.lastTokEnd, "Complex binding patterns require an initialization value") : s2.init = null, e2.declarations.push(this.finishNode(s2, "VariableDeclarator")), !this.eat(i2.comma))
                  break;
              }
              return e2;
            }, j.parseVarId = function(e2, t2) {
              e2.id = this.parseBindingAtom(), this.checkLValPattern(e2.id, t2 === "var" ? gt : fe, false);
            };
            var Le = 1, yt = 2, gr = 4;
            j.parseFunction = function(e2, t2, r2, s2, a) {
              this.initFunction(e2), (this.options.ecmaVersion >= 9 || this.options.ecmaVersion >= 6 && !s2) && (this.type === i2.star && t2 & yt && this.unexpected(), e2.generator = this.eat(i2.star)), this.options.ecmaVersion >= 8 && (e2.async = !!s2), t2 & Le && (e2.id = t2 & gr && this.type !== i2.name ? null : this.parseIdent(), e2.id && !(t2 & yt) && this.checkLValSimple(e2.id, this.strict || e2.generator || e2.async ? this.treatFunctionsAsVar ? gt : fe : dr));
              var h2 = this.yieldPos, c = this.awaitPos, d = this.awaitIdentPos;
              return this.yieldPos = 0, this.awaitPos = 0, this.awaitIdentPos = 0, this.enterScope(vt(e2.async, e2.generator)), t2 & Le || (e2.id = this.type === i2.name ? this.parseIdent() : null), this.parseFunctionParams(e2), this.parseFunctionBody(e2, r2, false, a), this.yieldPos = h2, this.awaitPos = c, this.awaitIdentPos = d, this.finishNode(e2, t2 & Le ? "FunctionDeclaration" : "FunctionExpression");
            }, j.parseFunctionParams = function(e2) {
              this.expect(i2.parenL), e2.params = this.parseBindingList(i2.parenR, false, this.options.ecmaVersion >= 8), this.checkYieldAwaitInDefaultParams();
            }, j.parseClass = function(e2, t2) {
              this.next();
              var r2 = this.strict;
              this.strict = true, this.parseClassId(e2, t2), this.parseClassSuper(e2);
              var s2 = this.enterClassBody(), a = this.startNode(), h2 = false;
              for (a.body = [], this.expect(i2.braceL); this.type !== i2.braceR; ) {
                var c = this.parseClassElement(e2.superClass !== null);
                c && (a.body.push(c), c.type === "MethodDefinition" && c.kind === "constructor" ? (h2 && this.raise(c.start, "Duplicate constructor in the same class"), h2 = true) : c.key && c.key.type === "PrivateIdentifier" && Va(s2, c) && this.raiseRecoverable(c.key.start, "Identifier '#" + c.key.name + "' has already been declared"));
              }
              return this.strict = r2, this.next(), e2.body = this.finishNode(a, "ClassBody"), this.exitClassBody(), this.finishNode(e2, t2 ? "ClassDeclaration" : "ClassExpression");
            }, j.parseClassElement = function(e2) {
              if (this.eat(i2.semi))
                return null;
              var t2 = this.options.ecmaVersion, r2 = this.startNode(), s2 = "", a = false, h2 = false, c = "method", d = false;
              if (this.eatContextual("static")) {
                if (t2 >= 13 && this.eat(i2.braceL))
                  return this.parseClassStaticBlock(r2), r2;
                this.isClassElementNameStart() || this.type === i2.star ? d = true : s2 = "static";
              }
              if (r2.static = d, !s2 && t2 >= 8 && this.eatContextual("async") && ((this.isClassElementNameStart() || this.type === i2.star) && !this.canInsertSemicolon() ? h2 = true : s2 = "async"), !s2 && (t2 >= 9 || !h2) && this.eat(i2.star) && (a = true), !s2 && !h2 && !a) {
                var x2 = this.value;
                (this.eatContextual("get") || this.eatContextual("set")) && (this.isClassElementNameStart() ? c = x2 : s2 = x2);
              }
              if (s2 ? (r2.computed = false, r2.key = this.startNodeAt(this.lastTokStart, this.lastTokStartLoc), r2.key.name = s2, this.finishNode(r2.key, "Identifier")) : this.parseClassElementName(r2), t2 < 13 || this.type === i2.parenL || c !== "method" || a || h2) {
                var U = !r2.static && Ge(r2, "constructor"), W = U && e2;
                U && c !== "method" && this.raise(r2.key.start, "Constructor can't have get/set modifier"), r2.kind = U ? "constructor" : c, this.parseClassMethod(r2, a, h2, W);
              } else
                this.parseClassField(r2);
              return r2;
            }, j.isClassElementNameStart = function() {
              return this.type === i2.name || this.type === i2.privateId || this.type === i2.num || this.type === i2.string || this.type === i2.bracketL || this.type.keyword;
            }, j.parseClassElementName = function(e2) {
              this.type === i2.privateId ? (this.value === "constructor" && this.raise(this.start, "Classes can't have an element named '#constructor'"), e2.computed = false, e2.key = this.parsePrivateIdent()) : this.parsePropertyName(e2);
            }, j.parseClassMethod = function(e2, t2, r2, s2) {
              var a = e2.key;
              e2.kind === "constructor" ? (t2 && this.raise(a.start, "Constructor can't be a generator"), r2 && this.raise(a.start, "Constructor can't be an async method")) : e2.static && Ge(e2, "prototype") && this.raise(a.start, "Classes may not have a static property named prototype");
              var h2 = e2.value = this.parseMethod(t2, r2, s2);
              return e2.kind === "get" && h2.params.length !== 0 && this.raiseRecoverable(h2.start, "getter should have no params"), e2.kind === "set" && h2.params.length !== 1 && this.raiseRecoverable(h2.start, "setter should have exactly one param"), e2.kind === "set" && h2.params[0].type === "RestElement" && this.raiseRecoverable(h2.params[0].start, "Setter cannot use rest params"), this.finishNode(e2, "MethodDefinition");
            }, j.parseClassField = function(e2) {
              if (Ge(e2, "constructor") ? this.raise(e2.key.start, "Classes can't have a field named 'constructor'") : e2.static && Ge(e2, "prototype") && this.raise(e2.key.start, "Classes can't have a static field named 'prototype'"), this.eat(i2.eq)) {
                var t2 = this.currentThisScope(), r2 = t2.inClassFieldInit;
                t2.inClassFieldInit = true, e2.value = this.parseMaybeAssign(), t2.inClassFieldInit = r2;
              } else
                e2.value = null;
              return this.semicolon(), this.finishNode(e2, "PropertyDefinition");
            }, j.parseClassStaticBlock = function(e2) {
              e2.body = [];
              var t2 = this.labels;
              for (this.labels = [], this.enterScope(Oe | dt); this.type !== i2.braceR; ) {
                var r2 = this.parseStatement(null);
                e2.body.push(r2);
              }
              return this.next(), this.exitScope(), this.labels = t2, this.finishNode(e2, "StaticBlock");
            }, j.parseClassId = function(e2, t2) {
              this.type === i2.name ? (e2.id = this.parseIdent(), t2 && this.checkLValSimple(e2.id, fe, false)) : (t2 === true && this.unexpected(), e2.id = null);
            }, j.parseClassSuper = function(e2) {
              e2.superClass = this.eat(i2._extends) ? this.parseExprSubscripts(false) : null;
            }, j.enterClassBody = function() {
              var e2 = { declared: /* @__PURE__ */ Object.create(null), used: [] };
              return this.privateNameStack.push(e2), e2.declared;
            }, j.exitClassBody = function() {
              for (var e2 = this.privateNameStack.pop(), t2 = e2.declared, r2 = e2.used, s2 = this.privateNameStack.length, a = s2 === 0 ? null : this.privateNameStack[s2 - 1], h2 = 0; h2 < r2.length; ++h2) {
                var c = r2[h2];
                D(t2, c.name) || (a ? a.used.push(c) : this.raiseRecoverable(c.start, "Private field '#" + c.name + "' must be declared in an enclosing class"));
              }
            };
            function Va(e2, t2) {
              var r2 = t2.key.name, s2 = e2[r2], a = "true";
              return t2.type === "MethodDefinition" && (t2.kind === "get" || t2.kind === "set") && (a = (t2.static ? "s" : "i") + t2.kind), s2 === "iget" && a === "iset" || s2 === "iset" && a === "iget" || s2 === "sget" && a === "sset" || s2 === "sset" && a === "sget" ? (e2[r2] = "true", false) : s2 ? true : (e2[r2] = a, false);
            }
            function Ge(e2, t2) {
              var r2 = e2.computed, s2 = e2.key;
              return !r2 && (s2.type === "Identifier" && s2.name === t2 || s2.type === "Literal" && s2.value === t2);
            }
            j.parseExport = function(e2, t2) {
              if (this.next(), this.eat(i2.star))
                return this.options.ecmaVersion >= 11 && (this.eatContextual("as") ? (e2.exported = this.parseModuleExportName(), this.checkExport(t2, e2.exported.name, this.lastTokStart)) : e2.exported = null), this.expectContextual("from"), this.type !== i2.string && this.unexpected(), e2.source = this.parseExprAtom(), this.semicolon(), this.finishNode(e2, "ExportAllDeclaration");
              if (this.eat(i2._default)) {
                this.checkExport(t2, "default", this.lastTokStart);
                var r2;
                if (this.type === i2._function || (r2 = this.isAsyncFunction())) {
                  var s2 = this.startNode();
                  this.next(), r2 && this.next(), e2.declaration = this.parseFunction(s2, Le | gr, false, r2);
                } else if (this.type === i2._class) {
                  var a = this.startNode();
                  e2.declaration = this.parseClass(a, "nullableID");
                } else
                  e2.declaration = this.parseMaybeAssign(), this.semicolon();
                return this.finishNode(e2, "ExportDefaultDeclaration");
              }
              if (this.shouldParseExportStatement())
                e2.declaration = this.parseStatement(null), e2.declaration.type === "VariableDeclaration" ? this.checkVariableExport(t2, e2.declaration.declarations) : this.checkExport(t2, e2.declaration.id.name, e2.declaration.id.start), e2.specifiers = [], e2.source = null;
              else {
                if (e2.declaration = null, e2.specifiers = this.parseExportSpecifiers(t2), this.eatContextual("from"))
                  this.type !== i2.string && this.unexpected(), e2.source = this.parseExprAtom();
                else {
                  for (var h2 = 0, c = e2.specifiers; h2 < c.length; h2 += 1) {
                    var d = c[h2];
                    this.checkUnreserved(d.local), this.checkLocalExport(d.local), d.local.type === "Literal" && this.raise(d.local.start, "A string literal cannot be used as an exported binding without `from`.");
                  }
                  e2.source = null;
                }
                this.semicolon();
              }
              return this.finishNode(e2, "ExportNamedDeclaration");
            }, j.checkExport = function(e2, t2, r2) {
              !e2 || (D(e2, t2) && this.raiseRecoverable(r2, "Duplicate export '" + t2 + "'"), e2[t2] = true);
            }, j.checkPatternExport = function(e2, t2) {
              var r2 = t2.type;
              if (r2 === "Identifier")
                this.checkExport(e2, t2.name, t2.start);
              else if (r2 === "ObjectPattern")
                for (var s2 = 0, a = t2.properties; s2 < a.length; s2 += 1) {
                  var h2 = a[s2];
                  this.checkPatternExport(e2, h2);
                }
              else if (r2 === "ArrayPattern")
                for (var c = 0, d = t2.elements; c < d.length; c += 1) {
                  var x2 = d[c];
                  x2 && this.checkPatternExport(e2, x2);
                }
              else
                r2 === "Property" ? this.checkPatternExport(e2, t2.value) : r2 === "AssignmentPattern" ? this.checkPatternExport(e2, t2.left) : r2 === "RestElement" ? this.checkPatternExport(e2, t2.argument) : r2 === "ParenthesizedExpression" && this.checkPatternExport(e2, t2.expression);
            }, j.checkVariableExport = function(e2, t2) {
              if (!!e2)
                for (var r2 = 0, s2 = t2; r2 < s2.length; r2 += 1) {
                  var a = s2[r2];
                  this.checkPatternExport(e2, a.id);
                }
            }, j.shouldParseExportStatement = function() {
              return this.type.keyword === "var" || this.type.keyword === "const" || this.type.keyword === "class" || this.type.keyword === "function" || this.isLet() || this.isAsyncFunction();
            }, j.parseExportSpecifiers = function(e2) {
              var t2 = [], r2 = true;
              for (this.expect(i2.braceL); !this.eat(i2.braceR); ) {
                if (r2)
                  r2 = false;
                else if (this.expect(i2.comma), this.afterTrailingComma(i2.braceR))
                  break;
                var s2 = this.startNode();
                s2.local = this.parseModuleExportName(), s2.exported = this.eatContextual("as") ? this.parseModuleExportName() : s2.local, this.checkExport(e2, s2.exported[s2.exported.type === "Identifier" ? "name" : "value"], s2.exported.start), t2.push(this.finishNode(s2, "ExportSpecifier"));
              }
              return t2;
            }, j.parseImport = function(e2) {
              return this.next(), this.type === i2.string ? (e2.specifiers = La, e2.source = this.parseExprAtom()) : (e2.specifiers = this.parseImportSpecifiers(), this.expectContextual("from"), e2.source = this.type === i2.string ? this.parseExprAtom() : this.unexpected()), this.semicolon(), this.finishNode(e2, "ImportDeclaration");
            }, j.parseImportSpecifiers = function() {
              var e2 = [], t2 = true;
              if (this.type === i2.name) {
                var r2 = this.startNode();
                if (r2.local = this.parseIdent(), this.checkLValSimple(r2.local, fe), e2.push(this.finishNode(r2, "ImportDefaultSpecifier")), !this.eat(i2.comma))
                  return e2;
              }
              if (this.type === i2.star) {
                var s2 = this.startNode();
                return this.next(), this.expectContextual("as"), s2.local = this.parseIdent(), this.checkLValSimple(s2.local, fe), e2.push(this.finishNode(s2, "ImportNamespaceSpecifier")), e2;
              }
              for (this.expect(i2.braceL); !this.eat(i2.braceR); ) {
                if (t2)
                  t2 = false;
                else if (this.expect(i2.comma), this.afterTrailingComma(i2.braceR))
                  break;
                var a = this.startNode();
                a.imported = this.parseModuleExportName(), this.eatContextual("as") ? a.local = this.parseIdent() : (this.checkUnreserved(a.imported), a.local = a.imported), this.checkLValSimple(a.local, fe), e2.push(this.finishNode(a, "ImportSpecifier"));
              }
              return e2;
            }, j.parseModuleExportName = function() {
              if (this.options.ecmaVersion >= 13 && this.type === i2.string) {
                var e2 = this.parseLiteral(this.value);
                return F2.test(e2.value) && this.raise(e2.start, "An export name cannot include a lone surrogate."), e2;
              }
              return this.parseIdent(true);
            }, j.adaptDirectivePrologue = function(e2) {
              for (var t2 = 0; t2 < e2.length && this.isDirectiveCandidate(e2[t2]); ++t2)
                e2[t2].directive = e2[t2].expression.raw.slice(1, -1);
            }, j.isDirectiveCandidate = function(e2) {
              return e2.type === "ExpressionStatement" && e2.expression.type === "Literal" && typeof e2.expression.value == "string" && (this.input[e2.start] === '"' || this.input[e2.start] === "'");
            };
            var ue = Z2.prototype;
            ue.toAssignable = function(e2, t2, r2) {
              if (this.options.ecmaVersion >= 6 && e2)
                switch (e2.type) {
                  case "Identifier":
                    this.inAsync && e2.name === "await" && this.raise(e2.start, "Cannot use 'await' as identifier inside an async function");
                    break;
                  case "ObjectPattern":
                  case "ArrayPattern":
                  case "AssignmentPattern":
                  case "RestElement":
                    break;
                  case "ObjectExpression":
                    e2.type = "ObjectPattern", r2 && this.checkPatternErrors(r2, true);
                    for (var s2 = 0, a = e2.properties; s2 < a.length; s2 += 1) {
                      var h2 = a[s2];
                      this.toAssignable(h2, t2), h2.type === "RestElement" && (h2.argument.type === "ArrayPattern" || h2.argument.type === "ObjectPattern") && this.raise(h2.argument.start, "Unexpected token");
                    }
                    break;
                  case "Property":
                    e2.kind !== "init" && this.raise(e2.key.start, "Object pattern can't contain getter or setter"), this.toAssignable(e2.value, t2);
                    break;
                  case "ArrayExpression":
                    e2.type = "ArrayPattern", r2 && this.checkPatternErrors(r2, true), this.toAssignableList(e2.elements, t2);
                    break;
                  case "SpreadElement":
                    e2.type = "RestElement", this.toAssignable(e2.argument, t2), e2.argument.type === "AssignmentPattern" && this.raise(e2.argument.start, "Rest elements cannot have a default value");
                    break;
                  case "AssignmentExpression":
                    e2.operator !== "=" && this.raise(e2.left.end, "Only '=' operator can be used for specifying default value."), e2.type = "AssignmentPattern", delete e2.operator, this.toAssignable(e2.left, t2);
                    break;
                  case "ParenthesizedExpression":
                    this.toAssignable(e2.expression, t2, r2);
                    break;
                  case "ChainExpression":
                    this.raiseRecoverable(e2.start, "Optional chaining cannot appear in left-hand side");
                    break;
                  case "MemberExpression":
                    if (!t2)
                      break;
                  default:
                    this.raise(e2.start, "Assigning to rvalue");
                }
              else
                r2 && this.checkPatternErrors(r2, true);
              return e2;
            }, ue.toAssignableList = function(e2, t2) {
              for (var r2 = e2.length, s2 = 0; s2 < r2; s2++) {
                var a = e2[s2];
                a && this.toAssignable(a, t2);
              }
              if (r2) {
                var h2 = e2[r2 - 1];
                this.options.ecmaVersion === 6 && t2 && h2 && h2.type === "RestElement" && h2.argument.type !== "Identifier" && this.unexpected(h2.argument.start);
              }
              return e2;
            }, ue.parseSpread = function(e2) {
              var t2 = this.startNode();
              return this.next(), t2.argument = this.parseMaybeAssign(false, e2), this.finishNode(t2, "SpreadElement");
            }, ue.parseRestBinding = function() {
              var e2 = this.startNode();
              return this.next(), this.options.ecmaVersion === 6 && this.type !== i2.name && this.unexpected(), e2.argument = this.parseBindingAtom(), this.finishNode(e2, "RestElement");
            }, ue.parseBindingAtom = function() {
              if (this.options.ecmaVersion >= 6)
                switch (this.type) {
                  case i2.bracketL:
                    var e2 = this.startNode();
                    return this.next(), e2.elements = this.parseBindingList(i2.bracketR, true, true), this.finishNode(e2, "ArrayPattern");
                  case i2.braceL:
                    return this.parseObj(true);
                }
              return this.parseIdent();
            }, ue.parseBindingList = function(e2, t2, r2) {
              for (var s2 = [], a = true; !this.eat(e2); )
                if (a ? a = false : this.expect(i2.comma), t2 && this.type === i2.comma)
                  s2.push(null);
                else {
                  if (r2 && this.afterTrailingComma(e2))
                    break;
                  if (this.type === i2.ellipsis) {
                    var h2 = this.parseRestBinding();
                    this.parseBindingListItem(h2), s2.push(h2), this.type === i2.comma && this.raise(this.start, "Comma is not permitted after the rest element"), this.expect(e2);
                    break;
                  } else {
                    var c = this.parseMaybeDefault(this.start, this.startLoc);
                    this.parseBindingListItem(c), s2.push(c);
                  }
                }
              return s2;
            }, ue.parseBindingListItem = function(e2) {
              return e2;
            }, ue.parseMaybeDefault = function(e2, t2, r2) {
              if (r2 = r2 || this.parseBindingAtom(), this.options.ecmaVersion < 6 || !this.eat(i2.eq))
                return r2;
              var s2 = this.startNodeAt(e2, t2);
              return s2.left = r2, s2.right = this.parseMaybeAssign(), this.finishNode(s2, "AssignmentPattern");
            }, ue.checkLValSimple = function(e2, t2, r2) {
              t2 === void 0 && (t2 = ze);
              var s2 = t2 !== ze;
              switch (e2.type) {
                case "Identifier":
                  this.strict && this.reservedWordsStrictBind.test(e2.name) && this.raiseRecoverable(e2.start, (s2 ? "Binding " : "Assigning to ") + e2.name + " in strict mode"), s2 && (t2 === fe && e2.name === "let" && this.raiseRecoverable(e2.start, "let is disallowed as a lexically bound name"), r2 && (D(r2, e2.name) && this.raiseRecoverable(e2.start, "Argument name clash"), r2[e2.name] = true), t2 !== vr && this.declareName(e2.name, t2, e2.start));
                  break;
                case "ChainExpression":
                  this.raiseRecoverable(e2.start, "Optional chaining cannot appear in left-hand side");
                  break;
                case "MemberExpression":
                  s2 && this.raiseRecoverable(e2.start, "Binding member expression");
                  break;
                case "ParenthesizedExpression":
                  return s2 && this.raiseRecoverable(e2.start, "Binding parenthesized expression"), this.checkLValSimple(e2.expression, t2, r2);
                default:
                  this.raise(e2.start, (s2 ? "Binding" : "Assigning to") + " rvalue");
              }
            }, ue.checkLValPattern = function(e2, t2, r2) {
              switch (t2 === void 0 && (t2 = ze), e2.type) {
                case "ObjectPattern":
                  for (var s2 = 0, a = e2.properties; s2 < a.length; s2 += 1) {
                    var h2 = a[s2];
                    this.checkLValInnerPattern(h2, t2, r2);
                  }
                  break;
                case "ArrayPattern":
                  for (var c = 0, d = e2.elements; c < d.length; c += 1) {
                    var x2 = d[c];
                    x2 && this.checkLValInnerPattern(x2, t2, r2);
                  }
                  break;
                default:
                  this.checkLValSimple(e2, t2, r2);
              }
            }, ue.checkLValInnerPattern = function(e2, t2, r2) {
              switch (t2 === void 0 && (t2 = ze), e2.type) {
                case "Property":
                  this.checkLValInnerPattern(e2.value, t2, r2);
                  break;
                case "AssignmentPattern":
                  this.checkLValPattern(e2.left, t2, r2);
                  break;
                case "RestElement":
                  this.checkLValPattern(e2.argument, t2, r2);
                  break;
                default:
                  this.checkLValPattern(e2, t2, r2);
              }
            };
            var ne = function(t2, r2, s2, a, h2) {
              this.token = t2, this.isExpr = !!r2, this.preserveSpace = !!s2, this.override = a, this.generator = !!h2;
            }, Q = { b_stat: new ne("{", false), b_expr: new ne("{", true), b_tmpl: new ne("${", false), p_stat: new ne("(", false), p_expr: new ne("(", true), q_tmpl: new ne("`", true, true, function(e2) {
              return e2.tryReadTemplateToken();
            }), f_stat: new ne("function", false), f_expr: new ne("function", true), f_expr_gen: new ne("function", true, false, null, true), f_gen: new ne("function", false, false, null, true) }, ke = Z2.prototype;
            ke.initialContext = function() {
              return [Q.b_stat];
            }, ke.curContext = function() {
              return this.context[this.context.length - 1];
            }, ke.braceIsBlock = function(e2) {
              var t2 = this.curContext();
              return t2 === Q.f_expr || t2 === Q.f_stat ? true : e2 === i2.colon && (t2 === Q.b_stat || t2 === Q.b_expr) ? !t2.isExpr : e2 === i2._return || e2 === i2.name && this.exprAllowed ? _.test(this.input.slice(this.lastTokEnd, this.start)) : e2 === i2._else || e2 === i2.semi || e2 === i2.eof || e2 === i2.parenR || e2 === i2.arrow ? true : e2 === i2.braceL ? t2 === Q.b_stat : e2 === i2._var || e2 === i2._const || e2 === i2.name ? false : !this.exprAllowed;
            }, ke.inGeneratorContext = function() {
              for (var e2 = this.context.length - 1; e2 >= 1; e2--) {
                var t2 = this.context[e2];
                if (t2.token === "function")
                  return t2.generator;
              }
              return false;
            }, ke.updateContext = function(e2) {
              var t2, r2 = this.type;
              r2.keyword && e2 === i2.dot ? this.exprAllowed = false : (t2 = r2.updateContext) ? t2.call(this, e2) : this.exprAllowed = r2.beforeExpr;
            }, ke.overrideContext = function(e2) {
              this.curContext() !== e2 && (this.context[this.context.length - 1] = e2);
            }, i2.parenR.updateContext = i2.braceR.updateContext = function() {
              if (this.context.length === 1) {
                this.exprAllowed = true;
                return;
              }
              var e2 = this.context.pop();
              e2 === Q.b_stat && this.curContext().token === "function" && (e2 = this.context.pop()), this.exprAllowed = !e2.isExpr;
            }, i2.braceL.updateContext = function(e2) {
              this.context.push(this.braceIsBlock(e2) ? Q.b_stat : Q.b_expr), this.exprAllowed = true;
            }, i2.dollarBraceL.updateContext = function() {
              this.context.push(Q.b_tmpl), this.exprAllowed = true;
            }, i2.parenL.updateContext = function(e2) {
              var t2 = e2 === i2._if || e2 === i2._for || e2 === i2._with || e2 === i2._while;
              this.context.push(t2 ? Q.p_stat : Q.p_expr), this.exprAllowed = true;
            }, i2.incDec.updateContext = function() {
            }, i2._function.updateContext = i2._class.updateContext = function(e2) {
              e2.beforeExpr && e2 !== i2._else && !(e2 === i2.semi && this.curContext() !== Q.p_stat) && !(e2 === i2._return && _.test(this.input.slice(this.lastTokEnd, this.start))) && !((e2 === i2.colon || e2 === i2.braceL) && this.curContext() === Q.b_stat) ? this.context.push(Q.f_expr) : this.context.push(Q.f_stat), this.exprAllowed = false;
            }, i2.backQuote.updateContext = function() {
              this.curContext() === Q.q_tmpl ? this.context.pop() : this.context.push(Q.q_tmpl), this.exprAllowed = false;
            }, i2.star.updateContext = function(e2) {
              if (e2 === i2._function) {
                var t2 = this.context.length - 1;
                this.context[t2] === Q.f_expr ? this.context[t2] = Q.f_expr_gen : this.context[t2] = Q.f_gen;
              }
              this.exprAllowed = true;
            }, i2.name.updateContext = function(e2) {
              var t2 = false;
              this.options.ecmaVersion >= 6 && e2 !== i2.dot && (this.value === "of" && !this.exprAllowed || this.value === "yield" && this.inGeneratorContext()) && (t2 = true), this.exprAllowed = t2;
            };
            var z = Z2.prototype;
            z.checkPropClash = function(e2, t2, r2) {
              if (!(this.options.ecmaVersion >= 9 && e2.type === "SpreadElement") && !(this.options.ecmaVersion >= 6 && (e2.computed || e2.method || e2.shorthand))) {
                var s2 = e2.key, a;
                switch (s2.type) {
                  case "Identifier":
                    a = s2.name;
                    break;
                  case "Literal":
                    a = String(s2.value);
                    break;
                  default:
                    return;
                }
                var h2 = e2.kind;
                if (this.options.ecmaVersion >= 6) {
                  a === "__proto__" && h2 === "init" && (t2.proto && (r2 ? r2.doubleProto < 0 && (r2.doubleProto = s2.start) : this.raiseRecoverable(s2.start, "Redefinition of __proto__ property")), t2.proto = true);
                  return;
                }
                a = "$" + a;
                var c = t2[a];
                if (c) {
                  var d;
                  h2 === "init" ? d = this.strict && c.init || c.get || c.set : d = c.init || c[h2], d && this.raiseRecoverable(s2.start, "Redefinition of property");
                } else
                  c = t2[a] = { init: false, get: false, set: false };
                c[h2] = true;
              }
            }, z.parseExpression = function(e2, t2) {
              var r2 = this.start, s2 = this.startLoc, a = this.parseMaybeAssign(e2, t2);
              if (this.type === i2.comma) {
                var h2 = this.startNodeAt(r2, s2);
                for (h2.expressions = [a]; this.eat(i2.comma); )
                  h2.expressions.push(this.parseMaybeAssign(e2, t2));
                return this.finishNode(h2, "SequenceExpression");
              }
              return a;
            }, z.parseMaybeAssign = function(e2, t2, r2) {
              if (this.isContextual("yield")) {
                if (this.inGenerator)
                  return this.parseYield(e2);
                this.exprAllowed = false;
              }
              var s2 = false, a = -1, h2 = -1, c = -1;
              t2 ? (a = t2.parenthesizedAssign, h2 = t2.trailingComma, c = t2.doubleProto, t2.parenthesizedAssign = t2.trailingComma = -1) : (t2 = new We(), s2 = true);
              var d = this.start, x2 = this.startLoc;
              (this.type === i2.parenL || this.type === i2.name) && (this.potentialArrowAt = this.start, this.potentialArrowInForAwait = e2 === "await");
              var U = this.parseMaybeConditional(e2, t2);
              if (r2 && (U = r2.call(this, U, d, x2)), this.type.isAssign) {
                var W = this.startNodeAt(d, x2);
                return W.operator = this.value, this.type === i2.eq && (U = this.toAssignable(U, false, t2)), s2 || (t2.parenthesizedAssign = t2.trailingComma = t2.doubleProto = -1), t2.shorthandAssign >= U.start && (t2.shorthandAssign = -1), this.type === i2.eq ? this.checkLValPattern(U) : this.checkLValSimple(U), W.left = U, this.next(), W.right = this.parseMaybeAssign(e2), c > -1 && (t2.doubleProto = c), this.finishNode(W, "AssignmentExpression");
              } else
                s2 && this.checkExpressionErrors(t2, true);
              return a > -1 && (t2.parenthesizedAssign = a), h2 > -1 && (t2.trailingComma = h2), U;
            }, z.parseMaybeConditional = function(e2, t2) {
              var r2 = this.start, s2 = this.startLoc, a = this.parseExprOps(e2, t2);
              if (this.checkExpressionErrors(t2))
                return a;
              if (this.eat(i2.question)) {
                var h2 = this.startNodeAt(r2, s2);
                return h2.test = a, h2.consequent = this.parseMaybeAssign(), this.expect(i2.colon), h2.alternate = this.parseMaybeAssign(e2), this.finishNode(h2, "ConditionalExpression");
              }
              return a;
            }, z.parseExprOps = function(e2, t2) {
              var r2 = this.start, s2 = this.startLoc, a = this.parseMaybeUnary(t2, false, false, e2);
              return this.checkExpressionErrors(t2) || a.start === r2 && a.type === "ArrowFunctionExpression" ? a : this.parseExprOp(a, r2, s2, -1, e2);
            }, z.parseExprOp = function(e2, t2, r2, s2, a) {
              var h2 = this.type.binop;
              if (h2 != null && (!a || this.type !== i2._in) && h2 > s2) {
                var c = this.type === i2.logicalOR || this.type === i2.logicalAND, d = this.type === i2.coalesce;
                d && (h2 = i2.logicalAND.binop);
                var x2 = this.value;
                this.next();
                var U = this.start, W = this.startLoc, re = this.parseExprOp(this.parseMaybeUnary(null, false, false, a), U, W, h2, a), be = this.buildBinary(t2, r2, e2, re, x2, c || d);
                return (c && this.type === i2.coalesce || d && (this.type === i2.logicalOR || this.type === i2.logicalAND)) && this.raiseRecoverable(this.start, "Logical expressions and coalesce expressions cannot be mixed. Wrap either by parentheses"), this.parseExprOp(be, t2, r2, s2, a);
              }
              return e2;
            }, z.buildBinary = function(e2, t2, r2, s2, a, h2) {
              s2.type === "PrivateIdentifier" && this.raise(s2.start, "Private identifier can only be left side of binary expression");
              var c = this.startNodeAt(e2, t2);
              return c.left = r2, c.operator = a, c.right = s2, this.finishNode(c, h2 ? "LogicalExpression" : "BinaryExpression");
            }, z.parseMaybeUnary = function(e2, t2, r2, s2) {
              var a = this.start, h2 = this.startLoc, c;
              if (this.isContextual("await") && this.canAwait)
                c = this.parseAwait(s2), t2 = true;
              else if (this.type.prefix) {
                var d = this.startNode(), x2 = this.type === i2.incDec;
                d.operator = this.value, d.prefix = true, this.next(), d.argument = this.parseMaybeUnary(null, true, x2, s2), this.checkExpressionErrors(e2, true), x2 ? this.checkLValSimple(d.argument) : this.strict && d.operator === "delete" && d.argument.type === "Identifier" ? this.raiseRecoverable(d.start, "Deleting local variable in strict mode") : d.operator === "delete" && xr(d.argument) ? this.raiseRecoverable(d.start, "Private fields can not be deleted") : t2 = true, c = this.finishNode(d, x2 ? "UpdateExpression" : "UnaryExpression");
              } else if (!t2 && this.type === i2.privateId)
                (s2 || this.privateNameStack.length === 0) && this.unexpected(), c = this.parsePrivateIdent(), this.type !== i2._in && this.unexpected();
              else {
                if (c = this.parseExprSubscripts(e2, s2), this.checkExpressionErrors(e2))
                  return c;
                for (; this.type.postfix && !this.canInsertSemicolon(); ) {
                  var U = this.startNodeAt(a, h2);
                  U.operator = this.value, U.prefix = false, U.argument = c, this.checkLValSimple(c), this.next(), c = this.finishNode(U, "UpdateExpression");
                }
              }
              if (!r2 && this.eat(i2.starstar))
                if (t2)
                  this.unexpected(this.lastTokStart);
                else
                  return this.buildBinary(a, h2, c, this.parseMaybeUnary(null, false, false, s2), "**", false);
              else
                return c;
            };
            function xr(e2) {
              return e2.type === "MemberExpression" && e2.property.type === "PrivateIdentifier" || e2.type === "ChainExpression" && xr(e2.expression);
            }
            z.parseExprSubscripts = function(e2, t2) {
              var r2 = this.start, s2 = this.startLoc, a = this.parseExprAtom(e2, t2);
              if (a.type === "ArrowFunctionExpression" && this.input.slice(this.lastTokStart, this.lastTokEnd) !== ")")
                return a;
              var h2 = this.parseSubscripts(a, r2, s2, false, t2);
              return e2 && h2.type === "MemberExpression" && (e2.parenthesizedAssign >= h2.start && (e2.parenthesizedAssign = -1), e2.parenthesizedBind >= h2.start && (e2.parenthesizedBind = -1), e2.trailingComma >= h2.start && (e2.trailingComma = -1)), h2;
            }, z.parseSubscripts = function(e2, t2, r2, s2, a) {
              for (var h2 = this.options.ecmaVersion >= 8 && e2.type === "Identifier" && e2.name === "async" && this.lastTokEnd === e2.end && !this.canInsertSemicolon() && e2.end - e2.start === 5 && this.potentialArrowAt === e2.start, c = false; ; ) {
                var d = this.parseSubscript(e2, t2, r2, s2, h2, c, a);
                if (d.optional && (c = true), d === e2 || d.type === "ArrowFunctionExpression") {
                  if (c) {
                    var x2 = this.startNodeAt(t2, r2);
                    x2.expression = d, d = this.finishNode(x2, "ChainExpression");
                  }
                  return d;
                }
                e2 = d;
              }
            }, z.parseSubscript = function(e2, t2, r2, s2, a, h2, c) {
              var d = this.options.ecmaVersion >= 11, x2 = d && this.eat(i2.questionDot);
              s2 && x2 && this.raise(this.lastTokStart, "Optional chaining cannot appear in the callee of new expressions");
              var U = this.eat(i2.bracketL);
              if (U || x2 && this.type !== i2.parenL && this.type !== i2.backQuote || this.eat(i2.dot)) {
                var W = this.startNodeAt(t2, r2);
                W.object = e2, U ? (W.property = this.parseExpression(), this.expect(i2.bracketR)) : this.type === i2.privateId && e2.type !== "Super" ? W.property = this.parsePrivateIdent() : W.property = this.parseIdent(this.options.allowReserved !== "never"), W.computed = !!U, d && (W.optional = x2), e2 = this.finishNode(W, "MemberExpression");
              } else if (!s2 && this.eat(i2.parenL)) {
                var re = new We(), be = this.yieldPos, je = this.awaitPos, Fe = this.awaitIdentPos;
                this.yieldPos = 0, this.awaitPos = 0, this.awaitIdentPos = 0;
                var Qe = this.parseExprList(i2.parenR, this.options.ecmaVersion >= 8, false, re);
                if (a && !x2 && !this.canInsertSemicolon() && this.eat(i2.arrow))
                  return this.checkPatternErrors(re, false), this.checkYieldAwaitInDefaultParams(), this.awaitIdentPos > 0 && this.raise(this.awaitIdentPos, "Cannot use 'await' as identifier inside an async function"), this.yieldPos = be, this.awaitPos = je, this.awaitIdentPos = Fe, this.parseArrowExpression(this.startNodeAt(t2, r2), Qe, true, c);
                this.checkExpressionErrors(re, true), this.yieldPos = be || this.yieldPos, this.awaitPos = je || this.awaitPos, this.awaitIdentPos = Fe || this.awaitIdentPos;
                var Be = this.startNodeAt(t2, r2);
                Be.callee = e2, Be.arguments = Qe, d && (Be.optional = x2), e2 = this.finishNode(Be, "CallExpression");
              } else if (this.type === i2.backQuote) {
                (x2 || h2) && this.raise(this.start, "Optional chaining cannot appear in the tag of tagged template expressions");
                var Te = this.startNodeAt(t2, r2);
                Te.tag = e2, Te.quasi = this.parseTemplate({ isTagged: true }), e2 = this.finishNode(Te, "TaggedTemplateExpression");
              }
              return e2;
            }, z.parseExprAtom = function(e2, t2) {
              this.type === i2.slash && this.readRegexp();
              var r2, s2 = this.potentialArrowAt === this.start;
              switch (this.type) {
                case i2._super:
                  return this.allowSuper || this.raise(this.start, "'super' keyword outside a method"), r2 = this.startNode(), this.next(), this.type === i2.parenL && !this.allowDirectSuper && this.raise(r2.start, "super() call outside constructor of a subclass"), this.type !== i2.dot && this.type !== i2.bracketL && this.type !== i2.parenL && this.unexpected(), this.finishNode(r2, "Super");
                case i2._this:
                  return r2 = this.startNode(), this.next(), this.finishNode(r2, "ThisExpression");
                case i2.name:
                  var a = this.start, h2 = this.startLoc, c = this.containsEsc, d = this.parseIdent(false);
                  if (this.options.ecmaVersion >= 8 && !c && d.name === "async" && !this.canInsertSemicolon() && this.eat(i2._function))
                    return this.overrideContext(Q.f_expr), this.parseFunction(this.startNodeAt(a, h2), 0, false, true, t2);
                  if (s2 && !this.canInsertSemicolon()) {
                    if (this.eat(i2.arrow))
                      return this.parseArrowExpression(this.startNodeAt(a, h2), [d], false, t2);
                    if (this.options.ecmaVersion >= 8 && d.name === "async" && this.type === i2.name && !c && (!this.potentialArrowInForAwait || this.value !== "of" || this.containsEsc))
                      return d = this.parseIdent(false), (this.canInsertSemicolon() || !this.eat(i2.arrow)) && this.unexpected(), this.parseArrowExpression(this.startNodeAt(a, h2), [d], true, t2);
                  }
                  return d;
                case i2.regexp:
                  var x2 = this.value;
                  return r2 = this.parseLiteral(x2.value), r2.regex = { pattern: x2.pattern, flags: x2.flags }, r2;
                case i2.num:
                case i2.string:
                  return this.parseLiteral(this.value);
                case i2._null:
                case i2._true:
                case i2._false:
                  return r2 = this.startNode(), r2.value = this.type === i2._null ? null : this.type === i2._true, r2.raw = this.type.keyword, this.next(), this.finishNode(r2, "Literal");
                case i2.parenL:
                  var U = this.start, W = this.parseParenAndDistinguishExpression(s2, t2);
                  return e2 && (e2.parenthesizedAssign < 0 && !this.isSimpleAssignTarget(W) && (e2.parenthesizedAssign = U), e2.parenthesizedBind < 0 && (e2.parenthesizedBind = U)), W;
                case i2.bracketL:
                  return r2 = this.startNode(), this.next(), r2.elements = this.parseExprList(i2.bracketR, true, true, e2), this.finishNode(r2, "ArrayExpression");
                case i2.braceL:
                  return this.overrideContext(Q.b_expr), this.parseObj(false, e2);
                case i2._function:
                  return r2 = this.startNode(), this.next(), this.parseFunction(r2, 0);
                case i2._class:
                  return this.parseClass(this.startNode(), false);
                case i2._new:
                  return this.parseNew();
                case i2.backQuote:
                  return this.parseTemplate();
                case i2._import:
                  return this.options.ecmaVersion >= 11 ? this.parseExprImport() : this.unexpected();
                default:
                  this.unexpected();
              }
            }, z.parseExprImport = function() {
              var e2 = this.startNode();
              this.containsEsc && this.raiseRecoverable(this.start, "Escape sequence in keyword import");
              var t2 = this.parseIdent(true);
              switch (this.type) {
                case i2.parenL:
                  return this.parseDynamicImport(e2);
                case i2.dot:
                  return e2.meta = t2, this.parseImportMeta(e2);
                default:
                  this.unexpected();
              }
            }, z.parseDynamicImport = function(e2) {
              if (this.next(), e2.source = this.parseMaybeAssign(), !this.eat(i2.parenR)) {
                var t2 = this.start;
                this.eat(i2.comma) && this.eat(i2.parenR) ? this.raiseRecoverable(t2, "Trailing comma is not allowed in import()") : this.unexpected(t2);
              }
              return this.finishNode(e2, "ImportExpression");
            }, z.parseImportMeta = function(e2) {
              this.next();
              var t2 = this.containsEsc;
              return e2.property = this.parseIdent(true), e2.property.name !== "meta" && this.raiseRecoverable(e2.property.start, "The only valid meta property for import is 'import.meta'"), t2 && this.raiseRecoverable(e2.start, "'import.meta' must not contain escaped characters"), this.options.sourceType !== "module" && !this.options.allowImportExportEverywhere && this.raiseRecoverable(e2.start, "Cannot use 'import.meta' outside a module"), this.finishNode(e2, "MetaProperty");
            }, z.parseLiteral = function(e2) {
              var t2 = this.startNode();
              return t2.value = e2, t2.raw = this.input.slice(this.start, this.end), t2.raw.charCodeAt(t2.raw.length - 1) === 110 && (t2.bigint = t2.raw.slice(0, -1).replace(/_/g, "")), this.next(), this.finishNode(t2, "Literal");
            }, z.parseParenExpression = function() {
              this.expect(i2.parenL);
              var e2 = this.parseExpression();
              return this.expect(i2.parenR), e2;
            }, z.parseParenAndDistinguishExpression = function(e2, t2) {
              var r2 = this.start, s2 = this.startLoc, a, h2 = this.options.ecmaVersion >= 8;
              if (this.options.ecmaVersion >= 6) {
                this.next();
                var c = this.start, d = this.startLoc, x2 = [], U = true, W = false, re = new We(), be = this.yieldPos, je = this.awaitPos, Fe;
                for (this.yieldPos = 0, this.awaitPos = 0; this.type !== i2.parenR; )
                  if (U ? U = false : this.expect(i2.comma), h2 && this.afterTrailingComma(i2.parenR, true)) {
                    W = true;
                    break;
                  } else if (this.type === i2.ellipsis) {
                    Fe = this.start, x2.push(this.parseParenItem(this.parseRestBinding())), this.type === i2.comma && this.raise(this.start, "Comma is not permitted after the rest element");
                    break;
                  } else
                    x2.push(this.parseMaybeAssign(false, re, this.parseParenItem));
                var Qe = this.lastTokEnd, Be = this.lastTokEndLoc;
                if (this.expect(i2.parenR), e2 && !this.canInsertSemicolon() && this.eat(i2.arrow))
                  return this.checkPatternErrors(re, false), this.checkYieldAwaitInDefaultParams(), this.yieldPos = be, this.awaitPos = je, this.parseParenArrowList(r2, s2, x2, t2);
                (!x2.length || W) && this.unexpected(this.lastTokStart), Fe && this.unexpected(Fe), this.checkExpressionErrors(re, true), this.yieldPos = be || this.yieldPos, this.awaitPos = je || this.awaitPos, x2.length > 1 ? (a = this.startNodeAt(c, d), a.expressions = x2, this.finishNodeAt(a, "SequenceExpression", Qe, Be)) : a = x2[0];
              } else
                a = this.parseParenExpression();
              if (this.options.preserveParens) {
                var Te = this.startNodeAt(r2, s2);
                return Te.expression = a, this.finishNode(Te, "ParenthesizedExpression");
              } else
                return a;
            }, z.parseParenItem = function(e2) {
              return e2;
            }, z.parseParenArrowList = function(e2, t2, r2, s2) {
              return this.parseArrowExpression(this.startNodeAt(e2, t2), r2, false, s2);
            };
            var Ra = [];
            z.parseNew = function() {
              this.containsEsc && this.raiseRecoverable(this.start, "Escape sequence in keyword new");
              var e2 = this.startNode(), t2 = this.parseIdent(true);
              if (this.options.ecmaVersion >= 6 && this.eat(i2.dot)) {
                e2.meta = t2;
                var r2 = this.containsEsc;
                return e2.property = this.parseIdent(true), e2.property.name !== "target" && this.raiseRecoverable(e2.property.start, "The only valid meta property for new is 'new.target'"), r2 && this.raiseRecoverable(e2.start, "'new.target' must not contain escaped characters"), this.allowNewDotTarget || this.raiseRecoverable(e2.start, "'new.target' can only be used in functions and class static block"), this.finishNode(e2, "MetaProperty");
              }
              var s2 = this.start, a = this.startLoc, h2 = this.type === i2._import;
              return e2.callee = this.parseSubscripts(this.parseExprAtom(), s2, a, true, false), h2 && e2.callee.type === "ImportExpression" && this.raise(s2, "Cannot use new with import()"), this.eat(i2.parenL) ? e2.arguments = this.parseExprList(i2.parenR, this.options.ecmaVersion >= 8, false) : e2.arguments = Ra, this.finishNode(e2, "NewExpression");
            }, z.parseTemplateElement = function(e2) {
              var t2 = e2.isTagged, r2 = this.startNode();
              return this.type === i2.invalidTemplate ? (t2 || this.raiseRecoverable(this.start, "Bad escape sequence in untagged template literal"), r2.value = { raw: this.value, cooked: null }) : r2.value = { raw: this.input.slice(this.start, this.end).replace(/\r\n?/g, `
`), cooked: this.value }, this.next(), r2.tail = this.type === i2.backQuote, this.finishNode(r2, "TemplateElement");
            }, z.parseTemplate = function(e2) {
              e2 === void 0 && (e2 = {});
              var t2 = e2.isTagged;
              t2 === void 0 && (t2 = false);
              var r2 = this.startNode();
              this.next(), r2.expressions = [];
              var s2 = this.parseTemplateElement({ isTagged: t2 });
              for (r2.quasis = [s2]; !s2.tail; )
                this.type === i2.eof && this.raise(this.pos, "Unterminated template literal"), this.expect(i2.dollarBraceL), r2.expressions.push(this.parseExpression()), this.expect(i2.braceR), r2.quasis.push(s2 = this.parseTemplateElement({ isTagged: t2 }));
              return this.next(), this.finishNode(r2, "TemplateLiteral");
            }, z.isAsyncProp = function(e2) {
              return !e2.computed && e2.key.type === "Identifier" && e2.key.name === "async" && (this.type === i2.name || this.type === i2.num || this.type === i2.string || this.type === i2.bracketL || this.type.keyword || this.options.ecmaVersion >= 9 && this.type === i2.star) && !_.test(this.input.slice(this.lastTokEnd, this.start));
            }, z.parseObj = function(e2, t2) {
              var r2 = this.startNode(), s2 = true, a = {};
              for (r2.properties = [], this.next(); !this.eat(i2.braceR); ) {
                if (s2)
                  s2 = false;
                else if (this.expect(i2.comma), this.options.ecmaVersion >= 5 && this.afterTrailingComma(i2.braceR))
                  break;
                var h2 = this.parseProperty(e2, t2);
                e2 || this.checkPropClash(h2, a, t2), r2.properties.push(h2);
              }
              return this.finishNode(r2, e2 ? "ObjectPattern" : "ObjectExpression");
            }, z.parseProperty = function(e2, t2) {
              var r2 = this.startNode(), s2, a, h2, c;
              if (this.options.ecmaVersion >= 9 && this.eat(i2.ellipsis))
                return e2 ? (r2.argument = this.parseIdent(false), this.type === i2.comma && this.raise(this.start, "Comma is not permitted after the rest element"), this.finishNode(r2, "RestElement")) : (this.type === i2.parenL && t2 && (t2.parenthesizedAssign < 0 && (t2.parenthesizedAssign = this.start), t2.parenthesizedBind < 0 && (t2.parenthesizedBind = this.start)), r2.argument = this.parseMaybeAssign(false, t2), this.type === i2.comma && t2 && t2.trailingComma < 0 && (t2.trailingComma = this.start), this.finishNode(r2, "SpreadElement"));
              this.options.ecmaVersion >= 6 && (r2.method = false, r2.shorthand = false, (e2 || t2) && (h2 = this.start, c = this.startLoc), e2 || (s2 = this.eat(i2.star)));
              var d = this.containsEsc;
              return this.parsePropertyName(r2), !e2 && !d && this.options.ecmaVersion >= 8 && !s2 && this.isAsyncProp(r2) ? (a = true, s2 = this.options.ecmaVersion >= 9 && this.eat(i2.star), this.parsePropertyName(r2, t2)) : a = false, this.parsePropertyValue(r2, e2, s2, a, h2, c, t2, d), this.finishNode(r2, "Property");
            }, z.parsePropertyValue = function(e2, t2, r2, s2, a, h2, c, d) {
              if ((r2 || s2) && this.type === i2.colon && this.unexpected(), this.eat(i2.colon))
                e2.value = t2 ? this.parseMaybeDefault(this.start, this.startLoc) : this.parseMaybeAssign(false, c), e2.kind = "init";
              else if (this.options.ecmaVersion >= 6 && this.type === i2.parenL)
                t2 && this.unexpected(), e2.kind = "init", e2.method = true, e2.value = this.parseMethod(r2, s2);
              else if (!t2 && !d && this.options.ecmaVersion >= 5 && !e2.computed && e2.key.type === "Identifier" && (e2.key.name === "get" || e2.key.name === "set") && this.type !== i2.comma && this.type !== i2.braceR && this.type !== i2.eq) {
                (r2 || s2) && this.unexpected(), e2.kind = e2.key.name, this.parsePropertyName(e2), e2.value = this.parseMethod(false);
                var x2 = e2.kind === "get" ? 0 : 1;
                if (e2.value.params.length !== x2) {
                  var U = e2.value.start;
                  e2.kind === "get" ? this.raiseRecoverable(U, "getter should have no params") : this.raiseRecoverable(U, "setter should have exactly one param");
                } else
                  e2.kind === "set" && e2.value.params[0].type === "RestElement" && this.raiseRecoverable(e2.value.params[0].start, "Setter cannot use rest params");
              } else
                this.options.ecmaVersion >= 6 && !e2.computed && e2.key.type === "Identifier" ? ((r2 || s2) && this.unexpected(), this.checkUnreserved(e2.key), e2.key.name === "await" && !this.awaitIdentPos && (this.awaitIdentPos = a), e2.kind = "init", t2 ? e2.value = this.parseMaybeDefault(a, h2, this.copyNode(e2.key)) : this.type === i2.eq && c ? (c.shorthandAssign < 0 && (c.shorthandAssign = this.start), e2.value = this.parseMaybeDefault(a, h2, this.copyNode(e2.key))) : e2.value = this.copyNode(e2.key), e2.shorthand = true) : this.unexpected();
            }, z.parsePropertyName = function(e2) {
              if (this.options.ecmaVersion >= 6) {
                if (this.eat(i2.bracketL))
                  return e2.computed = true, e2.key = this.parseMaybeAssign(), this.expect(i2.bracketR), e2.key;
                e2.computed = false;
              }
              return e2.key = this.type === i2.num || this.type === i2.string ? this.parseExprAtom() : this.parseIdent(this.options.allowReserved !== "never");
            }, z.initFunction = function(e2) {
              e2.id = null, this.options.ecmaVersion >= 6 && (e2.generator = e2.expression = false), this.options.ecmaVersion >= 8 && (e2.async = false);
            }, z.parseMethod = function(e2, t2, r2) {
              var s2 = this.startNode(), a = this.yieldPos, h2 = this.awaitPos, c = this.awaitIdentPos;
              return this.initFunction(s2), this.options.ecmaVersion >= 6 && (s2.generator = e2), this.options.ecmaVersion >= 8 && (s2.async = !!t2), this.yieldPos = 0, this.awaitPos = 0, this.awaitIdentPos = 0, this.enterScope(vt(t2, s2.generator) | dt | (r2 ? fr : 0)), this.expect(i2.parenL), s2.params = this.parseBindingList(i2.parenR, false, this.options.ecmaVersion >= 8), this.checkYieldAwaitInDefaultParams(), this.parseFunctionBody(s2, false, true, false), this.yieldPos = a, this.awaitPos = h2, this.awaitIdentPos = c, this.finishNode(s2, "FunctionExpression");
            }, z.parseArrowExpression = function(e2, t2, r2, s2) {
              var a = this.yieldPos, h2 = this.awaitPos, c = this.awaitIdentPos;
              return this.enterScope(vt(r2, false) | cr), this.initFunction(e2), this.options.ecmaVersion >= 8 && (e2.async = !!r2), this.yieldPos = 0, this.awaitPos = 0, this.awaitIdentPos = 0, e2.params = this.toAssignableList(t2, true), this.parseFunctionBody(e2, true, false, s2), this.yieldPos = a, this.awaitPos = h2, this.awaitIdentPos = c, this.finishNode(e2, "ArrowFunctionExpression");
            }, z.parseFunctionBody = function(e2, t2, r2, s2) {
              var a = t2 && this.type !== i2.braceL, h2 = this.strict, c = false;
              if (a)
                e2.body = this.parseMaybeAssign(s2), e2.expression = true, this.checkParams(e2, false);
              else {
                var d = this.options.ecmaVersion >= 7 && !this.isSimpleParamList(e2.params);
                (!h2 || d) && (c = this.strictDirective(this.end), c && d && this.raiseRecoverable(e2.start, "Illegal 'use strict' directive in function with non-simple parameter list"));
                var x2 = this.labels;
                this.labels = [], c && (this.strict = true), this.checkParams(e2, !h2 && !c && !t2 && !r2 && this.isSimpleParamList(e2.params)), this.strict && e2.id && this.checkLValSimple(e2.id, vr), e2.body = this.parseBlock(false, void 0, c && !h2), e2.expression = false, this.adaptDirectivePrologue(e2.body.body), this.labels = x2;
              }
              this.exitScope();
            }, z.isSimpleParamList = function(e2) {
              for (var t2 = 0, r2 = e2; t2 < r2.length; t2 += 1) {
                var s2 = r2[t2];
                if (s2.type !== "Identifier")
                  return false;
              }
              return true;
            }, z.checkParams = function(e2, t2) {
              for (var r2 = /* @__PURE__ */ Object.create(null), s2 = 0, a = e2.params; s2 < a.length; s2 += 1) {
                var h2 = a[s2];
                this.checkLValInnerPattern(h2, gt, t2 ? null : r2);
              }
            }, z.parseExprList = function(e2, t2, r2, s2) {
              for (var a = [], h2 = true; !this.eat(e2); ) {
                if (h2)
                  h2 = false;
                else if (this.expect(i2.comma), t2 && this.afterTrailingComma(e2))
                  break;
                var c = void 0;
                r2 && this.type === i2.comma ? c = null : this.type === i2.ellipsis ? (c = this.parseSpread(s2), s2 && this.type === i2.comma && s2.trailingComma < 0 && (s2.trailingComma = this.start)) : c = this.parseMaybeAssign(false, s2), a.push(c);
              }
              return a;
            }, z.checkUnreserved = function(e2) {
              var t2 = e2.start, r2 = e2.end, s2 = e2.name;
              if (this.inGenerator && s2 === "yield" && this.raiseRecoverable(t2, "Cannot use 'yield' as identifier inside a generator"), this.inAsync && s2 === "await" && this.raiseRecoverable(t2, "Cannot use 'await' as identifier inside an async function"), this.currentThisScope().inClassFieldInit && s2 === "arguments" && this.raiseRecoverable(t2, "Cannot use 'arguments' in class field initializer"), this.inClassStaticBlock && (s2 === "arguments" || s2 === "await") && this.raise(t2, "Cannot use " + s2 + " in class static initialization block"), this.keywords.test(s2) && this.raise(t2, "Unexpected keyword '" + s2 + "'"), !(this.options.ecmaVersion < 6 && this.input.slice(t2, r2).indexOf("\\") !== -1)) {
                var a = this.strict ? this.reservedWordsStrict : this.reservedWords;
                a.test(s2) && (!this.inAsync && s2 === "await" && this.raiseRecoverable(t2, "Cannot use keyword 'await' outside an async function"), this.raiseRecoverable(t2, "The keyword '" + s2 + "' is reserved"));
              }
            }, z.parseIdent = function(e2, t2) {
              var r2 = this.startNode();
              return this.type === i2.name ? r2.name = this.value : this.type.keyword ? (r2.name = this.type.keyword, (r2.name === "class" || r2.name === "function") && (this.lastTokEnd !== this.lastTokStart + 1 || this.input.charCodeAt(this.lastTokStart) !== 46) && this.context.pop()) : this.unexpected(), this.next(!!e2), this.finishNode(r2, "Identifier"), e2 || (this.checkUnreserved(r2), r2.name === "await" && !this.awaitIdentPos && (this.awaitIdentPos = r2.start)), r2;
            }, z.parsePrivateIdent = function() {
              var e2 = this.startNode();
              return this.type === i2.privateId ? e2.name = this.value : this.unexpected(), this.next(), this.finishNode(e2, "PrivateIdentifier"), this.privateNameStack.length === 0 ? this.raise(e2.start, "Private field '#" + e2.name + "' must be declared in an enclosing class") : this.privateNameStack[this.privateNameStack.length - 1].used.push(e2), e2;
            }, z.parseYield = function(e2) {
              this.yieldPos || (this.yieldPos = this.start);
              var t2 = this.startNode();
              return this.next(), this.type === i2.semi || this.canInsertSemicolon() || this.type !== i2.star && !this.type.startsExpr ? (t2.delegate = false, t2.argument = null) : (t2.delegate = this.eat(i2.star), t2.argument = this.parseMaybeAssign(e2)), this.finishNode(t2, "YieldExpression");
            }, z.parseAwait = function(e2) {
              this.awaitPos || (this.awaitPos = this.start);
              var t2 = this.startNode();
              return this.next(), t2.argument = this.parseMaybeUnary(null, true, false, e2), this.finishNode(t2, "AwaitExpression");
            };
            var Ke = Z2.prototype;
            Ke.raise = function(e2, t2) {
              var r2 = oe(this.input, e2);
              t2 += " (" + r2.line + ":" + r2.column + ")";
              var s2 = new SyntaxError(t2);
              throw s2.pos = e2, s2.loc = r2, s2.raisedAt = this.pos, s2;
            }, Ke.raiseRecoverable = Ke.raise, Ke.curPosition = function() {
              if (this.options.locations)
                return new K(this.curLine, this.pos - this.lineStart);
            };
            var xe = Z2.prototype, ja = function(t2) {
              this.flags = t2, this.var = [], this.lexical = [], this.functions = [], this.inClassFieldInit = false;
            };
            xe.enterScope = function(e2) {
              this.scopeStack.push(new ja(e2));
            }, xe.exitScope = function() {
              this.scopeStack.pop();
            }, xe.treatFunctionsAsVarInScope = function(e2) {
              return e2.flags & ge || !this.inModule && e2.flags & Ee;
            }, xe.declareName = function(e2, t2, r2) {
              var s2 = false;
              if (t2 === fe) {
                var a = this.currentScope();
                s2 = a.lexical.indexOf(e2) > -1 || a.functions.indexOf(e2) > -1 || a.var.indexOf(e2) > -1, a.lexical.push(e2), this.inModule && a.flags & Ee && delete this.undefinedExports[e2];
              } else if (t2 === mr) {
                var h2 = this.currentScope();
                h2.lexical.push(e2);
              } else if (t2 === dr) {
                var c = this.currentScope();
                this.treatFunctionsAsVar ? s2 = c.lexical.indexOf(e2) > -1 : s2 = c.lexical.indexOf(e2) > -1 || c.var.indexOf(e2) > -1, c.functions.push(e2);
              } else
                for (var d = this.scopeStack.length - 1; d >= 0; --d) {
                  var x2 = this.scopeStack[d];
                  if (x2.lexical.indexOf(e2) > -1 && !(x2.flags & pr && x2.lexical[0] === e2) || !this.treatFunctionsAsVarInScope(x2) && x2.functions.indexOf(e2) > -1) {
                    s2 = true;
                    break;
                  }
                  if (x2.var.push(e2), this.inModule && x2.flags & Ee && delete this.undefinedExports[e2], x2.flags & mt)
                    break;
                }
              s2 && this.raiseRecoverable(r2, "Identifier '" + e2 + "' has already been declared");
            }, xe.checkLocalExport = function(e2) {
              this.scopeStack[0].lexical.indexOf(e2.name) === -1 && this.scopeStack[0].var.indexOf(e2.name) === -1 && (this.undefinedExports[e2.name] = e2);
            }, xe.currentScope = function() {
              return this.scopeStack[this.scopeStack.length - 1];
            }, xe.currentVarScope = function() {
              for (var e2 = this.scopeStack.length - 1; ; e2--) {
                var t2 = this.scopeStack[e2];
                if (t2.flags & mt)
                  return t2;
              }
            }, xe.currentThisScope = function() {
              for (var e2 = this.scopeStack.length - 1; ; e2--) {
                var t2 = this.scopeStack[e2];
                if (t2.flags & mt && !(t2.flags & cr))
                  return t2;
              }
            };
            var Ve = function(t2, r2, s2) {
              this.type = "", this.start = r2, this.end = 0, t2.options.locations && (this.loc = new X(t2, s2)), t2.options.directSourceFile && (this.sourceFile = t2.options.directSourceFile), t2.options.ranges && (this.range = [r2, 0]);
            }, Re = Z2.prototype;
            Re.startNode = function() {
              return new Ve(this, this.start, this.startLoc);
            }, Re.startNodeAt = function(e2, t2) {
              return new Ve(this, e2, t2);
            };
            function yr(e2, t2, r2, s2) {
              return e2.type = t2, e2.end = r2, this.options.locations && (e2.loc.end = s2), this.options.ranges && (e2.range[1] = r2), e2;
            }
            Re.finishNode = function(e2, t2) {
              return yr.call(this, e2, t2, this.lastTokEnd, this.lastTokEndLoc);
            }, Re.finishNodeAt = function(e2, t2, r2, s2) {
              return yr.call(this, e2, t2, r2, s2);
            }, Re.copyNode = function(e2) {
              var t2 = new Ve(this, e2.start, this.startLoc);
              for (var r2 in e2)
                t2[r2] = e2[r2];
              return t2;
            };
            var Ar = "ASCII ASCII_Hex_Digit AHex Alphabetic Alpha Any Assigned Bidi_Control Bidi_C Bidi_Mirrored Bidi_M Case_Ignorable CI Cased Changes_When_Casefolded CWCF Changes_When_Casemapped CWCM Changes_When_Lowercased CWL Changes_When_NFKC_Casefolded CWKCF Changes_When_Titlecased CWT Changes_When_Uppercased CWU Dash Default_Ignorable_Code_Point DI Deprecated Dep Diacritic Dia Emoji Emoji_Component Emoji_Modifier Emoji_Modifier_Base Emoji_Presentation Extender Ext Grapheme_Base Gr_Base Grapheme_Extend Gr_Ext Hex_Digit Hex IDS_Binary_Operator IDSB IDS_Trinary_Operator IDST ID_Continue IDC ID_Start IDS Ideographic Ideo Join_Control Join_C Logical_Order_Exception LOE Lowercase Lower Math Noncharacter_Code_Point NChar Pattern_Syntax Pat_Syn Pattern_White_Space Pat_WS Quotation_Mark QMark Radical Regional_Indicator RI Sentence_Terminal STerm Soft_Dotted SD Terminal_Punctuation Term Unified_Ideograph UIdeo Uppercase Upper Variation_Selector VS White_Space space XID_Continue XIDC XID_Start XIDS", Cr = Ar + " Extended_Pictographic", Er = Cr, br = Er + " EBase EComp EMod EPres ExtPict", qa = br, Ma = { 9: Ar, 10: Cr, 11: Er, 12: br, 13: qa }, _r = "Cased_Letter LC Close_Punctuation Pe Connector_Punctuation Pc Control Cc cntrl Currency_Symbol Sc Dash_Punctuation Pd Decimal_Number Nd digit Enclosing_Mark Me Final_Punctuation Pf Format Cf Initial_Punctuation Pi Letter L Letter_Number Nl Line_Separator Zl Lowercase_Letter Ll Mark M Combining_Mark Math_Symbol Sm Modifier_Letter Lm Modifier_Symbol Sk Nonspacing_Mark Mn Number N Open_Punctuation Ps Other C Other_Letter Lo Other_Number No Other_Punctuation Po Other_Symbol So Paragraph_Separator Zp Private_Use Co Punctuation P punct Separator Z Space_Separator Zs Spacing_Mark Mc Surrogate Cs Symbol S Titlecase_Letter Lt Unassigned Cn Uppercase_Letter Lu", Sr = "Adlam Adlm Ahom Anatolian_Hieroglyphs Hluw Arabic Arab Armenian Armn Avestan Avst Balinese Bali Bamum Bamu Bassa_Vah Bass Batak Batk Bengali Beng Bhaiksuki Bhks Bopomofo Bopo Brahmi Brah Braille Brai Buginese Bugi Buhid Buhd Canadian_Aboriginal Cans Carian Cari Caucasian_Albanian Aghb Chakma Cakm Cham Cham Cherokee Cher Common Zyyy Coptic Copt Qaac Cuneiform Xsux Cypriot Cprt Cyrillic Cyrl Deseret Dsrt Devanagari Deva Duployan Dupl Egyptian_Hieroglyphs Egyp Elbasan Elba Ethiopic Ethi Georgian Geor Glagolitic Glag Gothic Goth Grantha Gran Greek Grek Gujarati Gujr Gurmukhi Guru Han Hani Hangul Hang Hanunoo Hano Hatran Hatr Hebrew Hebr Hiragana Hira Imperial_Aramaic Armi Inherited Zinh Qaai Inscriptional_Pahlavi Phli Inscriptional_Parthian Prti Javanese Java Kaithi Kthi Kannada Knda Katakana Kana Kayah_Li Kali Kharoshthi Khar Khmer Khmr Khojki Khoj Khudawadi Sind Lao Laoo Latin Latn Lepcha Lepc Limbu Limb Linear_A Lina Linear_B Linb Lisu Lisu Lycian Lyci Lydian Lydi Mahajani Mahj Malayalam Mlym Mandaic Mand Manichaean Mani Marchen Marc Masaram_Gondi Gonm Meetei_Mayek Mtei Mende_Kikakui Mend Meroitic_Cursive Merc Meroitic_Hieroglyphs Mero Miao Plrd Modi Mongolian Mong Mro Mroo Multani Mult Myanmar Mymr Nabataean Nbat New_Tai_Lue Talu Newa Newa Nko Nkoo Nushu Nshu Ogham Ogam Ol_Chiki Olck Old_Hungarian Hung Old_Italic Ital Old_North_Arabian Narb Old_Permic Perm Old_Persian Xpeo Old_South_Arabian Sarb Old_Turkic Orkh Oriya Orya Osage Osge Osmanya Osma Pahawh_Hmong Hmng Palmyrene Palm Pau_Cin_Hau Pauc Phags_Pa Phag Phoenician Phnx Psalter_Pahlavi Phlp Rejang Rjng Runic Runr Samaritan Samr Saurashtra Saur Sharada Shrd Shavian Shaw Siddham Sidd SignWriting Sgnw Sinhala Sinh Sora_Sompeng Sora Soyombo Soyo Sundanese Sund Syloti_Nagri Sylo Syriac Syrc Tagalog Tglg Tagbanwa Tagb Tai_Le Tale Tai_Tham Lana Tai_Viet Tavt Takri Takr Tamil Taml Tangut Tang Telugu Telu Thaana Thaa Thai Thai Tibetan Tibt Tifinagh Tfng Tirhuta Tirh Ugaritic Ugar Vai Vaii Warang_Citi Wara Yi Yiii Zanabazar_Square Zanb", wr = Sr + " Dogra Dogr Gunjala_Gondi Gong Hanifi_Rohingya Rohg Makasar Maka Medefaidrin Medf Old_Sogdian Sogo Sogdian Sogd", kr = wr + " Elymaic Elym Nandinagari Nand Nyiakeng_Puachue_Hmong Hmnp Wancho Wcho", Fr = kr + " Chorasmian Chrs Diak Dives_Akuru Khitan_Small_Script Kits Yezi Yezidi", Ua = Fr + " Cypro_Minoan Cpmn Old_Uyghur Ougr Tangsa Tnsa Toto Vithkuqi Vith", za = { 9: Sr, 10: wr, 11: kr, 12: Fr, 13: Ua }, Br = {};
            function Wa(e2) {
              var t2 = Br[e2] = { binary: f3(Ma[e2] + " " + _r), nonBinary: { General_Category: f3(_r), Script: f3(za[e2]) } };
              t2.nonBinary.Script_Extensions = t2.nonBinary.Script, t2.nonBinary.gc = t2.nonBinary.General_Category, t2.nonBinary.sc = t2.nonBinary.Script, t2.nonBinary.scx = t2.nonBinary.Script_Extensions;
            }
            for (var At = 0, Tr = [9, 10, 11, 12, 13]; At < Tr.length; At += 1) {
              var Ga = Tr[At];
              Wa(Ga);
            }
            var O = Z2.prototype, de = function(t2) {
              this.parser = t2, this.validFlags = "gim" + (t2.options.ecmaVersion >= 6 ? "uy" : "") + (t2.options.ecmaVersion >= 9 ? "s" : "") + (t2.options.ecmaVersion >= 13 ? "d" : ""), this.unicodeProperties = Br[t2.options.ecmaVersion >= 13 ? 13 : t2.options.ecmaVersion], this.source = "", this.flags = "", this.start = 0, this.switchU = false, this.switchN = false, this.pos = 0, this.lastIntValue = 0, this.lastStringValue = "", this.lastAssertionIsQuantifiable = false, this.numCapturingParens = 0, this.maxBackReference = 0, this.groupNames = [], this.backReferenceNames = [];
            };
            de.prototype.reset = function(t2, r2, s2) {
              var a = s2.indexOf("u") !== -1;
              this.start = t2 | 0, this.source = r2 + "", this.flags = s2, this.switchU = a && this.parser.options.ecmaVersion >= 6, this.switchN = a && this.parser.options.ecmaVersion >= 9;
            }, de.prototype.raise = function(t2) {
              this.parser.raiseRecoverable(this.start, "Invalid regular expression: /" + this.source + "/: " + t2);
            }, de.prototype.at = function(t2, r2) {
              r2 === void 0 && (r2 = false);
              var s2 = this.source, a = s2.length;
              if (t2 >= a)
                return -1;
              var h2 = s2.charCodeAt(t2);
              if (!(r2 || this.switchU) || h2 <= 55295 || h2 >= 57344 || t2 + 1 >= a)
                return h2;
              var c = s2.charCodeAt(t2 + 1);
              return c >= 56320 && c <= 57343 ? (h2 << 10) + c - 56613888 : h2;
            }, de.prototype.nextIndex = function(t2, r2) {
              r2 === void 0 && (r2 = false);
              var s2 = this.source, a = s2.length;
              if (t2 >= a)
                return a;
              var h2 = s2.charCodeAt(t2), c;
              return !(r2 || this.switchU) || h2 <= 55295 || h2 >= 57344 || t2 + 1 >= a || (c = s2.charCodeAt(t2 + 1)) < 56320 || c > 57343 ? t2 + 1 : t2 + 2;
            }, de.prototype.current = function(t2) {
              return t2 === void 0 && (t2 = false), this.at(this.pos, t2);
            }, de.prototype.lookahead = function(t2) {
              return t2 === void 0 && (t2 = false), this.at(this.nextIndex(this.pos, t2), t2);
            }, de.prototype.advance = function(t2) {
              t2 === void 0 && (t2 = false), this.pos = this.nextIndex(this.pos, t2);
            }, de.prototype.eat = function(t2, r2) {
              return r2 === void 0 && (r2 = false), this.current(r2) === t2 ? (this.advance(r2), true) : false;
            };
            function Xe(e2) {
              return e2 <= 65535 ? String.fromCharCode(e2) : (e2 -= 65536, String.fromCharCode((e2 >> 10) + 55296, (e2 & 1023) + 56320));
            }
            O.validateRegExpFlags = function(e2) {
              for (var t2 = e2.validFlags, r2 = e2.flags, s2 = 0; s2 < r2.length; s2++) {
                var a = r2.charAt(s2);
                t2.indexOf(a) === -1 && this.raise(e2.start, "Invalid regular expression flag"), r2.indexOf(a, s2 + 1) > -1 && this.raise(e2.start, "Duplicate regular expression flag");
              }
            }, O.validateRegExpPattern = function(e2) {
              this.regexp_pattern(e2), !e2.switchN && this.options.ecmaVersion >= 9 && e2.groupNames.length > 0 && (e2.switchN = true, this.regexp_pattern(e2));
            }, O.regexp_pattern = function(e2) {
              e2.pos = 0, e2.lastIntValue = 0, e2.lastStringValue = "", e2.lastAssertionIsQuantifiable = false, e2.numCapturingParens = 0, e2.maxBackReference = 0, e2.groupNames.length = 0, e2.backReferenceNames.length = 0, this.regexp_disjunction(e2), e2.pos !== e2.source.length && (e2.eat(41) && e2.raise("Unmatched ')'"), (e2.eat(93) || e2.eat(125)) && e2.raise("Lone quantifier brackets")), e2.maxBackReference > e2.numCapturingParens && e2.raise("Invalid escape");
              for (var t2 = 0, r2 = e2.backReferenceNames; t2 < r2.length; t2 += 1) {
                var s2 = r2[t2];
                e2.groupNames.indexOf(s2) === -1 && e2.raise("Invalid named capture referenced");
              }
            }, O.regexp_disjunction = function(e2) {
              for (this.regexp_alternative(e2); e2.eat(124); )
                this.regexp_alternative(e2);
              this.regexp_eatQuantifier(e2, true) && e2.raise("Nothing to repeat"), e2.eat(123) && e2.raise("Lone quantifier brackets");
            }, O.regexp_alternative = function(e2) {
              for (; e2.pos < e2.source.length && this.regexp_eatTerm(e2); )
                ;
            }, O.regexp_eatTerm = function(e2) {
              return this.regexp_eatAssertion(e2) ? (e2.lastAssertionIsQuantifiable && this.regexp_eatQuantifier(e2) && e2.switchU && e2.raise("Invalid quantifier"), true) : (e2.switchU ? this.regexp_eatAtom(e2) : this.regexp_eatExtendedAtom(e2)) ? (this.regexp_eatQuantifier(e2), true) : false;
            }, O.regexp_eatAssertion = function(e2) {
              var t2 = e2.pos;
              if (e2.lastAssertionIsQuantifiable = false, e2.eat(94) || e2.eat(36))
                return true;
              if (e2.eat(92)) {
                if (e2.eat(66) || e2.eat(98))
                  return true;
                e2.pos = t2;
              }
              if (e2.eat(40) && e2.eat(63)) {
                var r2 = false;
                if (this.options.ecmaVersion >= 9 && (r2 = e2.eat(60)), e2.eat(61) || e2.eat(33))
                  return this.regexp_disjunction(e2), e2.eat(41) || e2.raise("Unterminated group"), e2.lastAssertionIsQuantifiable = !r2, true;
              }
              return e2.pos = t2, false;
            }, O.regexp_eatQuantifier = function(e2, t2) {
              return t2 === void 0 && (t2 = false), this.regexp_eatQuantifierPrefix(e2, t2) ? (e2.eat(63), true) : false;
            }, O.regexp_eatQuantifierPrefix = function(e2, t2) {
              return e2.eat(42) || e2.eat(43) || e2.eat(63) || this.regexp_eatBracedQuantifier(e2, t2);
            }, O.regexp_eatBracedQuantifier = function(e2, t2) {
              var r2 = e2.pos;
              if (e2.eat(123)) {
                var s2 = 0, a = -1;
                if (this.regexp_eatDecimalDigits(e2) && (s2 = e2.lastIntValue, e2.eat(44) && this.regexp_eatDecimalDigits(e2) && (a = e2.lastIntValue), e2.eat(125)))
                  return a !== -1 && a < s2 && !t2 && e2.raise("numbers out of order in {} quantifier"), true;
                e2.switchU && !t2 && e2.raise("Incomplete quantifier"), e2.pos = r2;
              }
              return false;
            }, O.regexp_eatAtom = function(e2) {
              return this.regexp_eatPatternCharacters(e2) || e2.eat(46) || this.regexp_eatReverseSolidusAtomEscape(e2) || this.regexp_eatCharacterClass(e2) || this.regexp_eatUncapturingGroup(e2) || this.regexp_eatCapturingGroup(e2);
            }, O.regexp_eatReverseSolidusAtomEscape = function(e2) {
              var t2 = e2.pos;
              if (e2.eat(92)) {
                if (this.regexp_eatAtomEscape(e2))
                  return true;
                e2.pos = t2;
              }
              return false;
            }, O.regexp_eatUncapturingGroup = function(e2) {
              var t2 = e2.pos;
              if (e2.eat(40)) {
                if (e2.eat(63) && e2.eat(58)) {
                  if (this.regexp_disjunction(e2), e2.eat(41))
                    return true;
                  e2.raise("Unterminated group");
                }
                e2.pos = t2;
              }
              return false;
            }, O.regexp_eatCapturingGroup = function(e2) {
              if (e2.eat(40)) {
                if (this.options.ecmaVersion >= 9 ? this.regexp_groupSpecifier(e2) : e2.current() === 63 && e2.raise("Invalid group"), this.regexp_disjunction(e2), e2.eat(41))
                  return e2.numCapturingParens += 1, true;
                e2.raise("Unterminated group");
              }
              return false;
            }, O.regexp_eatExtendedAtom = function(e2) {
              return e2.eat(46) || this.regexp_eatReverseSolidusAtomEscape(e2) || this.regexp_eatCharacterClass(e2) || this.regexp_eatUncapturingGroup(e2) || this.regexp_eatCapturingGroup(e2) || this.regexp_eatInvalidBracedQuantifier(e2) || this.regexp_eatExtendedPatternCharacter(e2);
            }, O.regexp_eatInvalidBracedQuantifier = function(e2) {
              return this.regexp_eatBracedQuantifier(e2, true) && e2.raise("Nothing to repeat"), false;
            }, O.regexp_eatSyntaxCharacter = function(e2) {
              var t2 = e2.current();
              return Ir(t2) ? (e2.lastIntValue = t2, e2.advance(), true) : false;
            };
            function Ir(e2) {
              return e2 === 36 || e2 >= 40 && e2 <= 43 || e2 === 46 || e2 === 63 || e2 >= 91 && e2 <= 94 || e2 >= 123 && e2 <= 125;
            }
            O.regexp_eatPatternCharacters = function(e2) {
              for (var t2 = e2.pos, r2 = 0; (r2 = e2.current()) !== -1 && !Ir(r2); )
                e2.advance();
              return e2.pos !== t2;
            }, O.regexp_eatExtendedPatternCharacter = function(e2) {
              var t2 = e2.current();
              return t2 !== -1 && t2 !== 36 && !(t2 >= 40 && t2 <= 43) && t2 !== 46 && t2 !== 63 && t2 !== 91 && t2 !== 94 && t2 !== 124 ? (e2.advance(), true) : false;
            }, O.regexp_groupSpecifier = function(e2) {
              if (e2.eat(63)) {
                if (this.regexp_eatGroupName(e2)) {
                  e2.groupNames.indexOf(e2.lastStringValue) !== -1 && e2.raise("Duplicate capture group name"), e2.groupNames.push(e2.lastStringValue);
                  return;
                }
                e2.raise("Invalid group");
              }
            }, O.regexp_eatGroupName = function(e2) {
              if (e2.lastStringValue = "", e2.eat(60)) {
                if (this.regexp_eatRegExpIdentifierName(e2) && e2.eat(62))
                  return true;
                e2.raise("Invalid capture group name");
              }
              return false;
            }, O.regexp_eatRegExpIdentifierName = function(e2) {
              if (e2.lastStringValue = "", this.regexp_eatRegExpIdentifierStart(e2)) {
                for (e2.lastStringValue += Xe(e2.lastIntValue); this.regexp_eatRegExpIdentifierPart(e2); )
                  e2.lastStringValue += Xe(e2.lastIntValue);
                return true;
              }
              return false;
            }, O.regexp_eatRegExpIdentifierStart = function(e2) {
              var t2 = e2.pos, r2 = this.options.ecmaVersion >= 11, s2 = e2.current(r2);
              return e2.advance(r2), s2 === 92 && this.regexp_eatRegExpUnicodeEscapeSequence(e2, r2) && (s2 = e2.lastIntValue), Ka(s2) ? (e2.lastIntValue = s2, true) : (e2.pos = t2, false);
            };
            function Ka(e2) {
              return v(e2, true) || e2 === 36 || e2 === 95;
            }
            O.regexp_eatRegExpIdentifierPart = function(e2) {
              var t2 = e2.pos, r2 = this.options.ecmaVersion >= 11, s2 = e2.current(r2);
              return e2.advance(r2), s2 === 92 && this.regexp_eatRegExpUnicodeEscapeSequence(e2, r2) && (s2 = e2.lastIntValue), Xa(s2) ? (e2.lastIntValue = s2, true) : (e2.pos = t2, false);
            };
            function Xa(e2) {
              return q(e2, true) || e2 === 36 || e2 === 95 || e2 === 8204 || e2 === 8205;
            }
            O.regexp_eatAtomEscape = function(e2) {
              return this.regexp_eatBackReference(e2) || this.regexp_eatCharacterClassEscape(e2) || this.regexp_eatCharacterEscape(e2) || e2.switchN && this.regexp_eatKGroupName(e2) ? true : (e2.switchU && (e2.current() === 99 && e2.raise("Invalid unicode escape"), e2.raise("Invalid escape")), false);
            }, O.regexp_eatBackReference = function(e2) {
              var t2 = e2.pos;
              if (this.regexp_eatDecimalEscape(e2)) {
                var r2 = e2.lastIntValue;
                if (e2.switchU)
                  return r2 > e2.maxBackReference && (e2.maxBackReference = r2), true;
                if (r2 <= e2.numCapturingParens)
                  return true;
                e2.pos = t2;
              }
              return false;
            }, O.regexp_eatKGroupName = function(e2) {
              if (e2.eat(107)) {
                if (this.regexp_eatGroupName(e2))
                  return e2.backReferenceNames.push(e2.lastStringValue), true;
                e2.raise("Invalid named reference");
              }
              return false;
            }, O.regexp_eatCharacterEscape = function(e2) {
              return this.regexp_eatControlEscape(e2) || this.regexp_eatCControlLetter(e2) || this.regexp_eatZero(e2) || this.regexp_eatHexEscapeSequence(e2) || this.regexp_eatRegExpUnicodeEscapeSequence(e2, false) || !e2.switchU && this.regexp_eatLegacyOctalEscapeSequence(e2) || this.regexp_eatIdentityEscape(e2);
            }, O.regexp_eatCControlLetter = function(e2) {
              var t2 = e2.pos;
              if (e2.eat(99)) {
                if (this.regexp_eatControlLetter(e2))
                  return true;
                e2.pos = t2;
              }
              return false;
            }, O.regexp_eatZero = function(e2) {
              return e2.current() === 48 && !He(e2.lookahead()) ? (e2.lastIntValue = 0, e2.advance(), true) : false;
            }, O.regexp_eatControlEscape = function(e2) {
              var t2 = e2.current();
              return t2 === 116 ? (e2.lastIntValue = 9, e2.advance(), true) : t2 === 110 ? (e2.lastIntValue = 10, e2.advance(), true) : t2 === 118 ? (e2.lastIntValue = 11, e2.advance(), true) : t2 === 102 ? (e2.lastIntValue = 12, e2.advance(), true) : t2 === 114 ? (e2.lastIntValue = 13, e2.advance(), true) : false;
            }, O.regexp_eatControlLetter = function(e2) {
              var t2 = e2.current();
              return Pr(t2) ? (e2.lastIntValue = t2 % 32, e2.advance(), true) : false;
            };
            function Pr(e2) {
              return e2 >= 65 && e2 <= 90 || e2 >= 97 && e2 <= 122;
            }
            O.regexp_eatRegExpUnicodeEscapeSequence = function(e2, t2) {
              t2 === void 0 && (t2 = false);
              var r2 = e2.pos, s2 = t2 || e2.switchU;
              if (e2.eat(117)) {
                if (this.regexp_eatFixedHexDigits(e2, 4)) {
                  var a = e2.lastIntValue;
                  if (s2 && a >= 55296 && a <= 56319) {
                    var h2 = e2.pos;
                    if (e2.eat(92) && e2.eat(117) && this.regexp_eatFixedHexDigits(e2, 4)) {
                      var c = e2.lastIntValue;
                      if (c >= 56320 && c <= 57343)
                        return e2.lastIntValue = (a - 55296) * 1024 + (c - 56320) + 65536, true;
                    }
                    e2.pos = h2, e2.lastIntValue = a;
                  }
                  return true;
                }
                if (s2 && e2.eat(123) && this.regexp_eatHexDigits(e2) && e2.eat(125) && Ha(e2.lastIntValue))
                  return true;
                s2 && e2.raise("Invalid unicode escape"), e2.pos = r2;
              }
              return false;
            };
            function Ha(e2) {
              return e2 >= 0 && e2 <= 1114111;
            }
            O.regexp_eatIdentityEscape = function(e2) {
              if (e2.switchU)
                return this.regexp_eatSyntaxCharacter(e2) ? true : e2.eat(47) ? (e2.lastIntValue = 47, true) : false;
              var t2 = e2.current();
              return t2 !== 99 && (!e2.switchN || t2 !== 107) ? (e2.lastIntValue = t2, e2.advance(), true) : false;
            }, O.regexp_eatDecimalEscape = function(e2) {
              e2.lastIntValue = 0;
              var t2 = e2.current();
              if (t2 >= 49 && t2 <= 57) {
                do
                  e2.lastIntValue = 10 * e2.lastIntValue + (t2 - 48), e2.advance();
                while ((t2 = e2.current()) >= 48 && t2 <= 57);
                return true;
              }
              return false;
            }, O.regexp_eatCharacterClassEscape = function(e2) {
              var t2 = e2.current();
              if (Ja(t2))
                return e2.lastIntValue = -1, e2.advance(), true;
              if (e2.switchU && this.options.ecmaVersion >= 9 && (t2 === 80 || t2 === 112)) {
                if (e2.lastIntValue = -1, e2.advance(), e2.eat(123) && this.regexp_eatUnicodePropertyValueExpression(e2) && e2.eat(125))
                  return true;
                e2.raise("Invalid property name");
              }
              return false;
            };
            function Ja(e2) {
              return e2 === 100 || e2 === 68 || e2 === 115 || e2 === 83 || e2 === 119 || e2 === 87;
            }
            O.regexp_eatUnicodePropertyValueExpression = function(e2) {
              var t2 = e2.pos;
              if (this.regexp_eatUnicodePropertyName(e2) && e2.eat(61)) {
                var r2 = e2.lastStringValue;
                if (this.regexp_eatUnicodePropertyValue(e2)) {
                  var s2 = e2.lastStringValue;
                  return this.regexp_validateUnicodePropertyNameAndValue(e2, r2, s2), true;
                }
              }
              if (e2.pos = t2, this.regexp_eatLoneUnicodePropertyNameOrValue(e2)) {
                var a = e2.lastStringValue;
                return this.regexp_validateUnicodePropertyNameOrValue(e2, a), true;
              }
              return false;
            }, O.regexp_validateUnicodePropertyNameAndValue = function(e2, t2, r2) {
              D(e2.unicodeProperties.nonBinary, t2) || e2.raise("Invalid property name"), e2.unicodeProperties.nonBinary[t2].test(r2) || e2.raise("Invalid property value");
            }, O.regexp_validateUnicodePropertyNameOrValue = function(e2, t2) {
              e2.unicodeProperties.binary.test(t2) || e2.raise("Invalid property name");
            }, O.regexp_eatUnicodePropertyName = function(e2) {
              var t2 = 0;
              for (e2.lastStringValue = ""; Nr(t2 = e2.current()); )
                e2.lastStringValue += Xe(t2), e2.advance();
              return e2.lastStringValue !== "";
            };
            function Nr(e2) {
              return Pr(e2) || e2 === 95;
            }
            O.regexp_eatUnicodePropertyValue = function(e2) {
              var t2 = 0;
              for (e2.lastStringValue = ""; Ya(t2 = e2.current()); )
                e2.lastStringValue += Xe(t2), e2.advance();
              return e2.lastStringValue !== "";
            };
            function Ya(e2) {
              return Nr(e2) || He(e2);
            }
            O.regexp_eatLoneUnicodePropertyNameOrValue = function(e2) {
              return this.regexp_eatUnicodePropertyValue(e2);
            }, O.regexp_eatCharacterClass = function(e2) {
              if (e2.eat(91)) {
                if (e2.eat(94), this.regexp_classRanges(e2), e2.eat(93))
                  return true;
                e2.raise("Unterminated character class");
              }
              return false;
            }, O.regexp_classRanges = function(e2) {
              for (; this.regexp_eatClassAtom(e2); ) {
                var t2 = e2.lastIntValue;
                if (e2.eat(45) && this.regexp_eatClassAtom(e2)) {
                  var r2 = e2.lastIntValue;
                  e2.switchU && (t2 === -1 || r2 === -1) && e2.raise("Invalid character class"), t2 !== -1 && r2 !== -1 && t2 > r2 && e2.raise("Range out of order in character class");
                }
              }
            }, O.regexp_eatClassAtom = function(e2) {
              var t2 = e2.pos;
              if (e2.eat(92)) {
                if (this.regexp_eatClassEscape(e2))
                  return true;
                if (e2.switchU) {
                  var r2 = e2.current();
                  (r2 === 99 || Lr(r2)) && e2.raise("Invalid class escape"), e2.raise("Invalid escape");
                }
                e2.pos = t2;
              }
              var s2 = e2.current();
              return s2 !== 93 ? (e2.lastIntValue = s2, e2.advance(), true) : false;
            }, O.regexp_eatClassEscape = function(e2) {
              var t2 = e2.pos;
              if (e2.eat(98))
                return e2.lastIntValue = 8, true;
              if (e2.switchU && e2.eat(45))
                return e2.lastIntValue = 45, true;
              if (!e2.switchU && e2.eat(99)) {
                if (this.regexp_eatClassControlLetter(e2))
                  return true;
                e2.pos = t2;
              }
              return this.regexp_eatCharacterClassEscape(e2) || this.regexp_eatCharacterEscape(e2);
            }, O.regexp_eatClassControlLetter = function(e2) {
              var t2 = e2.current();
              return He(t2) || t2 === 95 ? (e2.lastIntValue = t2 % 32, e2.advance(), true) : false;
            }, O.regexp_eatHexEscapeSequence = function(e2) {
              var t2 = e2.pos;
              if (e2.eat(120)) {
                if (this.regexp_eatFixedHexDigits(e2, 2))
                  return true;
                e2.switchU && e2.raise("Invalid escape"), e2.pos = t2;
              }
              return false;
            }, O.regexp_eatDecimalDigits = function(e2) {
              var t2 = e2.pos, r2 = 0;
              for (e2.lastIntValue = 0; He(r2 = e2.current()); )
                e2.lastIntValue = 10 * e2.lastIntValue + (r2 - 48), e2.advance();
              return e2.pos !== t2;
            };
            function He(e2) {
              return e2 >= 48 && e2 <= 57;
            }
            O.regexp_eatHexDigits = function(e2) {
              var t2 = e2.pos, r2 = 0;
              for (e2.lastIntValue = 0; Dr(r2 = e2.current()); )
                e2.lastIntValue = 16 * e2.lastIntValue + Or(r2), e2.advance();
              return e2.pos !== t2;
            };
            function Dr(e2) {
              return e2 >= 48 && e2 <= 57 || e2 >= 65 && e2 <= 70 || e2 >= 97 && e2 <= 102;
            }
            function Or(e2) {
              return e2 >= 65 && e2 <= 70 ? 10 + (e2 - 65) : e2 >= 97 && e2 <= 102 ? 10 + (e2 - 97) : e2 - 48;
            }
            O.regexp_eatLegacyOctalEscapeSequence = function(e2) {
              if (this.regexp_eatOctalDigit(e2)) {
                var t2 = e2.lastIntValue;
                if (this.regexp_eatOctalDigit(e2)) {
                  var r2 = e2.lastIntValue;
                  t2 <= 3 && this.regexp_eatOctalDigit(e2) ? e2.lastIntValue = t2 * 64 + r2 * 8 + e2.lastIntValue : e2.lastIntValue = t2 * 8 + r2;
                } else
                  e2.lastIntValue = t2;
                return true;
              }
              return false;
            }, O.regexp_eatOctalDigit = function(e2) {
              var t2 = e2.current();
              return Lr(t2) ? (e2.lastIntValue = t2 - 48, e2.advance(), true) : (e2.lastIntValue = 0, false);
            };
            function Lr(e2) {
              return e2 >= 48 && e2 <= 55;
            }
            O.regexp_eatFixedHexDigits = function(e2, t2) {
              var r2 = e2.pos;
              e2.lastIntValue = 0;
              for (var s2 = 0; s2 < t2; ++s2) {
                var a = e2.current();
                if (!Dr(a))
                  return e2.pos = r2, false;
                e2.lastIntValue = 16 * e2.lastIntValue + Or(a), e2.advance();
              }
              return true;
            };
            var Je = function(t2) {
              this.type = t2.type, this.value = t2.value, this.start = t2.start, this.end = t2.end, t2.options.locations && (this.loc = new X(t2, t2.startLoc, t2.endLoc)), t2.options.ranges && (this.range = [t2.start, t2.end]);
            }, G = Z2.prototype;
            G.next = function(e2) {
              !e2 && this.type.keyword && this.containsEsc && this.raiseRecoverable(this.start, "Escape sequence in keyword " + this.type.keyword), this.options.onToken && this.options.onToken(new Je(this)), this.lastTokEnd = this.end, this.lastTokStart = this.start, this.lastTokEndLoc = this.endLoc, this.lastTokStartLoc = this.startLoc, this.nextToken();
            }, G.getToken = function() {
              return this.next(), new Je(this);
            }, typeof Symbol < "u" && (G[Symbol.iterator] = function() {
              var e2 = this;
              return { next: function() {
                var t2 = e2.getToken();
                return { done: t2.type === i2.eof, value: t2 };
              } };
            }), G.nextToken = function() {
              var e2 = this.curContext();
              if ((!e2 || !e2.preserveSpace) && this.skipSpace(), this.start = this.pos, this.options.locations && (this.startLoc = this.curPosition()), this.pos >= this.input.length)
                return this.finishToken(i2.eof);
              if (e2.override)
                return e2.override(this);
              this.readToken(this.fullCharCodeAtPos());
            }, G.readToken = function(e2) {
              return v(e2, this.options.ecmaVersion >= 6) || e2 === 92 ? this.readWord() : this.getTokenFromCode(e2);
            }, G.fullCharCodeAtPos = function() {
              var e2 = this.input.charCodeAt(this.pos);
              if (e2 <= 55295 || e2 >= 56320)
                return e2;
              var t2 = this.input.charCodeAt(this.pos + 1);
              return t2 <= 56319 || t2 >= 57344 ? e2 : (e2 << 10) + t2 - 56613888;
            }, G.skipBlockComment = function() {
              var e2 = this.options.onComment && this.curPosition(), t2 = this.pos, r2 = this.input.indexOf("*/", this.pos += 2);
              if (r2 === -1 && this.raise(this.pos - 2, "Unterminated comment"), this.pos = r2 + 2, this.options.locations)
                for (var s2 = void 0, a = t2; (s2 = ee(this.input, a, this.pos)) > -1; )
                  ++this.curLine, a = this.lineStart = s2;
              this.options.onComment && this.options.onComment(true, this.input.slice(t2 + 2, r2), t2, this.pos, e2, this.curPosition());
            }, G.skipLineComment = function(e2) {
              for (var t2 = this.pos, r2 = this.options.onComment && this.curPosition(), s2 = this.input.charCodeAt(this.pos += e2); this.pos < this.input.length && !M(s2); )
                s2 = this.input.charCodeAt(++this.pos);
              this.options.onComment && this.options.onComment(false, this.input.slice(t2 + e2, this.pos), t2, this.pos, r2, this.curPosition());
            }, G.skipSpace = function() {
              e:
                for (; this.pos < this.input.length; ) {
                  var e2 = this.input.charCodeAt(this.pos);
                  switch (e2) {
                    case 32:
                    case 160:
                      ++this.pos;
                      break;
                    case 13:
                      this.input.charCodeAt(this.pos + 1) === 10 && ++this.pos;
                    case 10:
                    case 8232:
                    case 8233:
                      ++this.pos, this.options.locations && (++this.curLine, this.lineStart = this.pos);
                      break;
                    case 47:
                      switch (this.input.charCodeAt(this.pos + 1)) {
                        case 42:
                          this.skipBlockComment();
                          break;
                        case 47:
                          this.skipLineComment(2);
                          break;
                        default:
                          break e;
                      }
                      break;
                    default:
                      if (e2 > 8 && e2 < 14 || e2 >= 5760 && ae.test(String.fromCharCode(e2)))
                        ++this.pos;
                      else
                        break e;
                  }
                }
            }, G.finishToken = function(e2, t2) {
              this.end = this.pos, this.options.locations && (this.endLoc = this.curPosition());
              var r2 = this.type;
              this.type = e2, this.value = t2, this.updateContext(r2);
            }, G.readToken_dot = function() {
              var e2 = this.input.charCodeAt(this.pos + 1);
              if (e2 >= 48 && e2 <= 57)
                return this.readNumber(true);
              var t2 = this.input.charCodeAt(this.pos + 2);
              return this.options.ecmaVersion >= 6 && e2 === 46 && t2 === 46 ? (this.pos += 3, this.finishToken(i2.ellipsis)) : (++this.pos, this.finishToken(i2.dot));
            }, G.readToken_slash = function() {
              var e2 = this.input.charCodeAt(this.pos + 1);
              return this.exprAllowed ? (++this.pos, this.readRegexp()) : e2 === 61 ? this.finishOp(i2.assign, 2) : this.finishOp(i2.slash, 1);
            }, G.readToken_mult_modulo_exp = function(e2) {
              var t2 = this.input.charCodeAt(this.pos + 1), r2 = 1, s2 = e2 === 42 ? i2.star : i2.modulo;
              return this.options.ecmaVersion >= 7 && e2 === 42 && t2 === 42 && (++r2, s2 = i2.starstar, t2 = this.input.charCodeAt(this.pos + 2)), t2 === 61 ? this.finishOp(i2.assign, r2 + 1) : this.finishOp(s2, r2);
            }, G.readToken_pipe_amp = function(e2) {
              var t2 = this.input.charCodeAt(this.pos + 1);
              if (t2 === e2) {
                if (this.options.ecmaVersion >= 12) {
                  var r2 = this.input.charCodeAt(this.pos + 2);
                  if (r2 === 61)
                    return this.finishOp(i2.assign, 3);
                }
                return this.finishOp(e2 === 124 ? i2.logicalOR : i2.logicalAND, 2);
              }
              return t2 === 61 ? this.finishOp(i2.assign, 2) : this.finishOp(e2 === 124 ? i2.bitwiseOR : i2.bitwiseAND, 1);
            }, G.readToken_caret = function() {
              var e2 = this.input.charCodeAt(this.pos + 1);
              return e2 === 61 ? this.finishOp(i2.assign, 2) : this.finishOp(i2.bitwiseXOR, 1);
            }, G.readToken_plus_min = function(e2) {
              var t2 = this.input.charCodeAt(this.pos + 1);
              return t2 === e2 ? t2 === 45 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 62 && (this.lastTokEnd === 0 || _.test(this.input.slice(this.lastTokEnd, this.pos))) ? (this.skipLineComment(3), this.skipSpace(), this.nextToken()) : this.finishOp(i2.incDec, 2) : t2 === 61 ? this.finishOp(i2.assign, 2) : this.finishOp(i2.plusMin, 1);
            }, G.readToken_lt_gt = function(e2) {
              var t2 = this.input.charCodeAt(this.pos + 1), r2 = 1;
              return t2 === e2 ? (r2 = e2 === 62 && this.input.charCodeAt(this.pos + 2) === 62 ? 3 : 2, this.input.charCodeAt(this.pos + r2) === 61 ? this.finishOp(i2.assign, r2 + 1) : this.finishOp(i2.bitShift, r2)) : t2 === 33 && e2 === 60 && !this.inModule && this.input.charCodeAt(this.pos + 2) === 45 && this.input.charCodeAt(this.pos + 3) === 45 ? (this.skipLineComment(4), this.skipSpace(), this.nextToken()) : (t2 === 61 && (r2 = 2), this.finishOp(i2.relational, r2));
            }, G.readToken_eq_excl = function(e2) {
              var t2 = this.input.charCodeAt(this.pos + 1);
              return t2 === 61 ? this.finishOp(i2.equality, this.input.charCodeAt(this.pos + 2) === 61 ? 3 : 2) : e2 === 61 && t2 === 62 && this.options.ecmaVersion >= 6 ? (this.pos += 2, this.finishToken(i2.arrow)) : this.finishOp(e2 === 61 ? i2.eq : i2.prefix, 1);
            }, G.readToken_question = function() {
              var e2 = this.options.ecmaVersion;
              if (e2 >= 11) {
                var t2 = this.input.charCodeAt(this.pos + 1);
                if (t2 === 46) {
                  var r2 = this.input.charCodeAt(this.pos + 2);
                  if (r2 < 48 || r2 > 57)
                    return this.finishOp(i2.questionDot, 2);
                }
                if (t2 === 63) {
                  if (e2 >= 12) {
                    var s2 = this.input.charCodeAt(this.pos + 2);
                    if (s2 === 61)
                      return this.finishOp(i2.assign, 3);
                  }
                  return this.finishOp(i2.coalesce, 2);
                }
              }
              return this.finishOp(i2.question, 1);
            }, G.readToken_numberSign = function() {
              var e2 = this.options.ecmaVersion, t2 = 35;
              if (e2 >= 13 && (++this.pos, t2 = this.fullCharCodeAtPos(), v(t2, true) || t2 === 92))
                return this.finishToken(i2.privateId, this.readWord1());
              this.raise(this.pos, "Unexpected character '" + Ye(t2) + "'");
            }, G.getTokenFromCode = function(e2) {
              switch (e2) {
                case 46:
                  return this.readToken_dot();
                case 40:
                  return ++this.pos, this.finishToken(i2.parenL);
                case 41:
                  return ++this.pos, this.finishToken(i2.parenR);
                case 59:
                  return ++this.pos, this.finishToken(i2.semi);
                case 44:
                  return ++this.pos, this.finishToken(i2.comma);
                case 91:
                  return ++this.pos, this.finishToken(i2.bracketL);
                case 93:
                  return ++this.pos, this.finishToken(i2.bracketR);
                case 123:
                  return ++this.pos, this.finishToken(i2.braceL);
                case 125:
                  return ++this.pos, this.finishToken(i2.braceR);
                case 58:
                  return ++this.pos, this.finishToken(i2.colon);
                case 96:
                  if (this.options.ecmaVersion < 6)
                    break;
                  return ++this.pos, this.finishToken(i2.backQuote);
                case 48:
                  var t2 = this.input.charCodeAt(this.pos + 1);
                  if (t2 === 120 || t2 === 88)
                    return this.readRadixNumber(16);
                  if (this.options.ecmaVersion >= 6) {
                    if (t2 === 111 || t2 === 79)
                      return this.readRadixNumber(8);
                    if (t2 === 98 || t2 === 66)
                      return this.readRadixNumber(2);
                  }
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                  return this.readNumber(false);
                case 34:
                case 39:
                  return this.readString(e2);
                case 47:
                  return this.readToken_slash();
                case 37:
                case 42:
                  return this.readToken_mult_modulo_exp(e2);
                case 124:
                case 38:
                  return this.readToken_pipe_amp(e2);
                case 94:
                  return this.readToken_caret();
                case 43:
                case 45:
                  return this.readToken_plus_min(e2);
                case 60:
                case 62:
                  return this.readToken_lt_gt(e2);
                case 61:
                case 33:
                  return this.readToken_eq_excl(e2);
                case 63:
                  return this.readToken_question();
                case 126:
                  return this.finishOp(i2.prefix, 1);
                case 35:
                  return this.readToken_numberSign();
              }
              this.raise(this.pos, "Unexpected character '" + Ye(e2) + "'");
            }, G.finishOp = function(e2, t2) {
              var r2 = this.input.slice(this.pos, this.pos + t2);
              return this.pos += t2, this.finishToken(e2, r2);
            }, G.readRegexp = function() {
              for (var e2, t2, r2 = this.pos; ; ) {
                this.pos >= this.input.length && this.raise(r2, "Unterminated regular expression");
                var s2 = this.input.charAt(this.pos);
                if (_.test(s2) && this.raise(r2, "Unterminated regular expression"), e2)
                  e2 = false;
                else {
                  if (s2 === "[")
                    t2 = true;
                  else if (s2 === "]" && t2)
                    t2 = false;
                  else if (s2 === "/" && !t2)
                    break;
                  e2 = s2 === "\\";
                }
                ++this.pos;
              }
              var a = this.input.slice(r2, this.pos);
              ++this.pos;
              var h2 = this.pos, c = this.readWord1();
              this.containsEsc && this.unexpected(h2);
              var d = this.regexpState || (this.regexpState = new de(this));
              d.reset(r2, a, c), this.validateRegExpFlags(d), this.validateRegExpPattern(d);
              var x2 = null;
              try {
                x2 = new RegExp(a, c);
              } catch {
              }
              return this.finishToken(i2.regexp, { pattern: a, flags: c, value: x2 });
            }, G.readInt = function(e2, t2, r2) {
              for (var s2 = this.options.ecmaVersion >= 12 && t2 === void 0, a = r2 && this.input.charCodeAt(this.pos) === 48, h2 = this.pos, c = 0, d = 0, x2 = 0, U = t2 == null ? 1 / 0 : t2; x2 < U; ++x2, ++this.pos) {
                var W = this.input.charCodeAt(this.pos), re = void 0;
                if (s2 && W === 95) {
                  a && this.raiseRecoverable(this.pos, "Numeric separator is not allowed in legacy octal numeric literals"), d === 95 && this.raiseRecoverable(this.pos, "Numeric separator must be exactly one underscore"), x2 === 0 && this.raiseRecoverable(this.pos, "Numeric separator is not allowed at the first of digits"), d = W;
                  continue;
                }
                if (W >= 97 ? re = W - 97 + 10 : W >= 65 ? re = W - 65 + 10 : W >= 48 && W <= 57 ? re = W - 48 : re = 1 / 0, re >= e2)
                  break;
                d = W, c = c * e2 + re;
              }
              return s2 && d === 95 && this.raiseRecoverable(this.pos - 1, "Numeric separator is not allowed at the last of digits"), this.pos === h2 || t2 != null && this.pos - h2 !== t2 ? null : c;
            };
            function Qa(e2, t2) {
              return t2 ? parseInt(e2, 8) : parseFloat(e2.replace(/_/g, ""));
            }
            function Vr(e2) {
              return typeof BigInt != "function" ? null : BigInt(e2.replace(/_/g, ""));
            }
            G.readRadixNumber = function(e2) {
              var t2 = this.pos;
              this.pos += 2;
              var r2 = this.readInt(e2);
              return r2 == null && this.raise(this.start + 2, "Expected number in radix " + e2), this.options.ecmaVersion >= 11 && this.input.charCodeAt(this.pos) === 110 ? (r2 = Vr(this.input.slice(t2, this.pos)), ++this.pos) : v(this.fullCharCodeAtPos()) && this.raise(this.pos, "Identifier directly after number"), this.finishToken(i2.num, r2);
            }, G.readNumber = function(e2) {
              var t2 = this.pos;
              !e2 && this.readInt(10, void 0, true) === null && this.raise(t2, "Invalid number");
              var r2 = this.pos - t2 >= 2 && this.input.charCodeAt(t2) === 48;
              r2 && this.strict && this.raise(t2, "Invalid number");
              var s2 = this.input.charCodeAt(this.pos);
              if (!r2 && !e2 && this.options.ecmaVersion >= 11 && s2 === 110) {
                var a = Vr(this.input.slice(t2, this.pos));
                return ++this.pos, v(this.fullCharCodeAtPos()) && this.raise(this.pos, "Identifier directly after number"), this.finishToken(i2.num, a);
              }
              r2 && /[89]/.test(this.input.slice(t2, this.pos)) && (r2 = false), s2 === 46 && !r2 && (++this.pos, this.readInt(10), s2 = this.input.charCodeAt(this.pos)), (s2 === 69 || s2 === 101) && !r2 && (s2 = this.input.charCodeAt(++this.pos), (s2 === 43 || s2 === 45) && ++this.pos, this.readInt(10) === null && this.raise(t2, "Invalid number")), v(this.fullCharCodeAtPos()) && this.raise(this.pos, "Identifier directly after number");
              var h2 = Qa(this.input.slice(t2, this.pos), r2);
              return this.finishToken(i2.num, h2);
            }, G.readCodePoint = function() {
              var e2 = this.input.charCodeAt(this.pos), t2;
              if (e2 === 123) {
                this.options.ecmaVersion < 6 && this.unexpected();
                var r2 = ++this.pos;
                t2 = this.readHexChar(this.input.indexOf("}", this.pos) - this.pos), ++this.pos, t2 > 1114111 && this.invalidStringToken(r2, "Code point out of bounds");
              } else
                t2 = this.readHexChar(4);
              return t2;
            };
            function Ye(e2) {
              return e2 <= 65535 ? String.fromCharCode(e2) : (e2 -= 65536, String.fromCharCode((e2 >> 10) + 55296, (e2 & 1023) + 56320));
            }
            G.readString = function(e2) {
              for (var t2 = "", r2 = ++this.pos; ; ) {
                this.pos >= this.input.length && this.raise(this.start, "Unterminated string constant");
                var s2 = this.input.charCodeAt(this.pos);
                if (s2 === e2)
                  break;
                s2 === 92 ? (t2 += this.input.slice(r2, this.pos), t2 += this.readEscapedChar(false), r2 = this.pos) : s2 === 8232 || s2 === 8233 ? (this.options.ecmaVersion < 10 && this.raise(this.start, "Unterminated string constant"), ++this.pos, this.options.locations && (this.curLine++, this.lineStart = this.pos)) : (M(s2) && this.raise(this.start, "Unterminated string constant"), ++this.pos);
              }
              return t2 += this.input.slice(r2, this.pos++), this.finishToken(i2.string, t2);
            };
            var Rr = {};
            G.tryReadTemplateToken = function() {
              this.inTemplateElement = true;
              try {
                this.readTmplToken();
              } catch (e2) {
                if (e2 === Rr)
                  this.readInvalidTemplateToken();
                else
                  throw e2;
              }
              this.inTemplateElement = false;
            }, G.invalidStringToken = function(e2, t2) {
              if (this.inTemplateElement && this.options.ecmaVersion >= 9)
                throw Rr;
              this.raise(e2, t2);
            }, G.readTmplToken = function() {
              for (var e2 = "", t2 = this.pos; ; ) {
                this.pos >= this.input.length && this.raise(this.start, "Unterminated template");
                var r2 = this.input.charCodeAt(this.pos);
                if (r2 === 96 || r2 === 36 && this.input.charCodeAt(this.pos + 1) === 123)
                  return this.pos === this.start && (this.type === i2.template || this.type === i2.invalidTemplate) ? r2 === 36 ? (this.pos += 2, this.finishToken(i2.dollarBraceL)) : (++this.pos, this.finishToken(i2.backQuote)) : (e2 += this.input.slice(t2, this.pos), this.finishToken(i2.template, e2));
                if (r2 === 92)
                  e2 += this.input.slice(t2, this.pos), e2 += this.readEscapedChar(true), t2 = this.pos;
                else if (M(r2)) {
                  switch (e2 += this.input.slice(t2, this.pos), ++this.pos, r2) {
                    case 13:
                      this.input.charCodeAt(this.pos) === 10 && ++this.pos;
                    case 10:
                      e2 += `
`;
                      break;
                    default:
                      e2 += String.fromCharCode(r2);
                      break;
                  }
                  this.options.locations && (++this.curLine, this.lineStart = this.pos), t2 = this.pos;
                } else
                  ++this.pos;
              }
            }, G.readInvalidTemplateToken = function() {
              for (; this.pos < this.input.length; this.pos++)
                switch (this.input[this.pos]) {
                  case "\\":
                    ++this.pos;
                    break;
                  case "$":
                    if (this.input[this.pos + 1] !== "{")
                      break;
                  case "`":
                    return this.finishToken(i2.invalidTemplate, this.input.slice(this.start, this.pos));
                }
              this.raise(this.start, "Unterminated template");
            }, G.readEscapedChar = function(e2) {
              var t2 = this.input.charCodeAt(++this.pos);
              switch (++this.pos, t2) {
                case 110:
                  return `
`;
                case 114:
                  return "\r";
                case 120:
                  return String.fromCharCode(this.readHexChar(2));
                case 117:
                  return Ye(this.readCodePoint());
                case 116:
                  return "	";
                case 98:
                  return "\b";
                case 118:
                  return "\v";
                case 102:
                  return "\f";
                case 13:
                  this.input.charCodeAt(this.pos) === 10 && ++this.pos;
                case 10:
                  return this.options.locations && (this.lineStart = this.pos, ++this.curLine), "";
                case 56:
                case 57:
                  if (this.strict && this.invalidStringToken(this.pos - 1, "Invalid escape sequence"), e2) {
                    var r2 = this.pos - 1;
                    return this.invalidStringToken(r2, "Invalid escape sequence in template string"), null;
                  }
                default:
                  if (t2 >= 48 && t2 <= 55) {
                    var s2 = this.input.substr(this.pos - 1, 3).match(/^[0-7]+/)[0], a = parseInt(s2, 8);
                    return a > 255 && (s2 = s2.slice(0, -1), a = parseInt(s2, 8)), this.pos += s2.length - 1, t2 = this.input.charCodeAt(this.pos), (s2 !== "0" || t2 === 56 || t2 === 57) && (this.strict || e2) && this.invalidStringToken(this.pos - 1 - s2.length, e2 ? "Octal literal in template string" : "Octal literal in strict mode"), String.fromCharCode(a);
                  }
                  return M(t2) ? "" : String.fromCharCode(t2);
              }
            }, G.readHexChar = function(e2) {
              var t2 = this.pos, r2 = this.readInt(16, e2);
              return r2 === null && this.invalidStringToken(t2, "Bad character escape sequence"), r2;
            }, G.readWord1 = function() {
              this.containsEsc = false;
              for (var e2 = "", t2 = true, r2 = this.pos, s2 = this.options.ecmaVersion >= 6; this.pos < this.input.length; ) {
                var a = this.fullCharCodeAtPos();
                if (q(a, s2))
                  this.pos += a <= 65535 ? 1 : 2;
                else if (a === 92) {
                  this.containsEsc = true, e2 += this.input.slice(r2, this.pos);
                  var h2 = this.pos;
                  this.input.charCodeAt(++this.pos) !== 117 && this.invalidStringToken(this.pos, "Expecting Unicode escape sequence \\uXXXX"), ++this.pos;
                  var c = this.readCodePoint();
                  (t2 ? v : q)(c, s2) || this.invalidStringToken(h2, "Invalid Unicode escape"), e2 += Ye(c), r2 = this.pos;
                } else
                  break;
                t2 = false;
              }
              return e2 + this.input.slice(r2, this.pos);
            }, G.readWord = function() {
              var e2 = this.readWord1(), t2 = i2.name;
              return this.keywords.test(e2) && (t2 = H[e2]), this.finishToken(t2, e2);
            };
            var jr = "8.7.0";
            Z2.acorn = { Parser: Z2, version: jr, defaultOptions: me, Position: K, SourceLocation: X, getLineInfo: oe, Node: Ve, TokenType: B, tokTypes: i2, keywordTypes: H, TokContext: ne, tokContexts: Q, isIdentifierChar: q, isIdentifierStart: v, Token: Je, isNewLine: M, lineBreak: _, lineBreakG: P, nonASCIIwhitespace: ae };
            function Za(e2, t2) {
              return Z2.parse(e2, t2);
            }
            function $a(e2, t2, r2) {
              return Z2.parseExpressionAt(e2, t2, r2);
            }
            function en(e2, t2) {
              return Z2.tokenizer(e2, t2);
            }
            u.Node = Ve, u.Parser = Z2, u.Position = K, u.SourceLocation = X, u.TokContext = ne, u.Token = Je, u.TokenType = B, u.defaultOptions = me, u.getLineInfo = oe, u.isIdentifierChar = q, u.isIdentifierStart = v, u.isNewLine = M, u.keywordTypes = H, u.lineBreak = _, u.lineBreakG = P, u.nonASCIIwhitespace = ae, u.parse = Za, u.parseExpressionAt = $a, u.tokContexts = Q, u.tokTypes = i2, u.tokenizer = en, u.version = jr, Object.defineProperty(u, "__esModule", { value: true });
          });
        } }), Sh = Y({ "node_modules/acorn-jsx/xhtml.js"(n, o) {
          J(), o.exports = { quot: '"', amp: "&", apos: "'", lt: "<", gt: ">", nbsp: "\xA0", iexcl: "\xA1", cent: "\xA2", pound: "\xA3", curren: "\xA4", yen: "\xA5", brvbar: "\xA6", sect: "\xA7", uml: "\xA8", copy: "\xA9", ordf: "\xAA", laquo: "\xAB", not: "\xAC", shy: "\xAD", reg: "\xAE", macr: "\xAF", deg: "\xB0", plusmn: "\xB1", sup2: "\xB2", sup3: "\xB3", acute: "\xB4", micro: "\xB5", para: "\xB6", middot: "\xB7", cedil: "\xB8", sup1: "\xB9", ordm: "\xBA", raquo: "\xBB", frac14: "\xBC", frac12: "\xBD", frac34: "\xBE", iquest: "\xBF", Agrave: "\xC0", Aacute: "\xC1", Acirc: "\xC2", Atilde: "\xC3", Auml: "\xC4", Aring: "\xC5", AElig: "\xC6", Ccedil: "\xC7", Egrave: "\xC8", Eacute: "\xC9", Ecirc: "\xCA", Euml: "\xCB", Igrave: "\xCC", Iacute: "\xCD", Icirc: "\xCE", Iuml: "\xCF", ETH: "\xD0", Ntilde: "\xD1", Ograve: "\xD2", Oacute: "\xD3", Ocirc: "\xD4", Otilde: "\xD5", Ouml: "\xD6", times: "\xD7", Oslash: "\xD8", Ugrave: "\xD9", Uacute: "\xDA", Ucirc: "\xDB", Uuml: "\xDC", Yacute: "\xDD", THORN: "\xDE", szlig: "\xDF", agrave: "\xE0", aacute: "\xE1", acirc: "\xE2", atilde: "\xE3", auml: "\xE4", aring: "\xE5", aelig: "\xE6", ccedil: "\xE7", egrave: "\xE8", eacute: "\xE9", ecirc: "\xEA", euml: "\xEB", igrave: "\xEC", iacute: "\xED", icirc: "\xEE", iuml: "\xEF", eth: "\xF0", ntilde: "\xF1", ograve: "\xF2", oacute: "\xF3", ocirc: "\xF4", otilde: "\xF5", ouml: "\xF6", divide: "\xF7", oslash: "\xF8", ugrave: "\xF9", uacute: "\xFA", ucirc: "\xFB", uuml: "\xFC", yacute: "\xFD", thorn: "\xFE", yuml: "\xFF", OElig: "\u0152", oelig: "\u0153", Scaron: "\u0160", scaron: "\u0161", Yuml: "\u0178", fnof: "\u0192", circ: "\u02C6", tilde: "\u02DC", Alpha: "\u0391", Beta: "\u0392", Gamma: "\u0393", Delta: "\u0394", Epsilon: "\u0395", Zeta: "\u0396", Eta: "\u0397", Theta: "\u0398", Iota: "\u0399", Kappa: "\u039A", Lambda: "\u039B", Mu: "\u039C", Nu: "\u039D", Xi: "\u039E", Omicron: "\u039F", Pi: "\u03A0", Rho: "\u03A1", Sigma: "\u03A3", Tau: "\u03A4", Upsilon: "\u03A5", Phi: "\u03A6", Chi: "\u03A7", Psi: "\u03A8", Omega: "\u03A9", alpha: "\u03B1", beta: "\u03B2", gamma: "\u03B3", delta: "\u03B4", epsilon: "\u03B5", zeta: "\u03B6", eta: "\u03B7", theta: "\u03B8", iota: "\u03B9", kappa: "\u03BA", lambda: "\u03BB", mu: "\u03BC", nu: "\u03BD", xi: "\u03BE", omicron: "\u03BF", pi: "\u03C0", rho: "\u03C1", sigmaf: "\u03C2", sigma: "\u03C3", tau: "\u03C4", upsilon: "\u03C5", phi: "\u03C6", chi: "\u03C7", psi: "\u03C8", omega: "\u03C9", thetasym: "\u03D1", upsih: "\u03D2", piv: "\u03D6", ensp: "\u2002", emsp: "\u2003", thinsp: "\u2009", zwnj: "\u200C", zwj: "\u200D", lrm: "\u200E", rlm: "\u200F", ndash: "\u2013", mdash: "\u2014", lsquo: "\u2018", rsquo: "\u2019", sbquo: "\u201A", ldquo: "\u201C", rdquo: "\u201D", bdquo: "\u201E", dagger: "\u2020", Dagger: "\u2021", bull: "\u2022", hellip: "\u2026", permil: "\u2030", prime: "\u2032", Prime: "\u2033", lsaquo: "\u2039", rsaquo: "\u203A", oline: "\u203E", frasl: "\u2044", euro: "\u20AC", image: "\u2111", weierp: "\u2118", real: "\u211C", trade: "\u2122", alefsym: "\u2135", larr: "\u2190", uarr: "\u2191", rarr: "\u2192", darr: "\u2193", harr: "\u2194", crarr: "\u21B5", lArr: "\u21D0", uArr: "\u21D1", rArr: "\u21D2", dArr: "\u21D3", hArr: "\u21D4", forall: "\u2200", part: "\u2202", exist: "\u2203", empty: "\u2205", nabla: "\u2207", isin: "\u2208", notin: "\u2209", ni: "\u220B", prod: "\u220F", sum: "\u2211", minus: "\u2212", lowast: "\u2217", radic: "\u221A", prop: "\u221D", infin: "\u221E", ang: "\u2220", and: "\u2227", or: "\u2228", cap: "\u2229", cup: "\u222A", int: "\u222B", there4: "\u2234", sim: "\u223C", cong: "\u2245", asymp: "\u2248", ne: "\u2260", equiv: "\u2261", le: "\u2264", ge: "\u2265", sub: "\u2282", sup: "\u2283", nsub: "\u2284", sube: "\u2286", supe: "\u2287", oplus: "\u2295", otimes: "\u2297", perp: "\u22A5", sdot: "\u22C5", lceil: "\u2308", rceil: "\u2309", lfloor: "\u230A", rfloor: "\u230B", lang: "\u2329", rang: "\u232A", loz: "\u25CA", spades: "\u2660", clubs: "\u2663", hearts: "\u2665", diams: "\u2666" };
        } }), Pa = Y({ "node_modules/acorn-jsx/index.js"(n, o) {
          "use strict";
          J();
          var u = Sh(), l = /^[\da-fA-F]+$/, m2 = /^\d+$/, E = /* @__PURE__ */ new WeakMap();
          function y(g) {
            g = g.Parser.acorn || g;
            let V = E.get(g);
            if (!V) {
              let R = g.tokTypes, N = g.TokContext, T = g.TokenType, v = new N("<tag", false), q = new N("</tag", false), B = new N("<tag>...</tag>", true, true), I = { tc_oTag: v, tc_cTag: q, tc_expr: B }, k = { jsxName: new T("jsxName"), jsxText: new T("jsxText", { beforeExpr: true }), jsxTagStart: new T("jsxTagStart", { startsExpr: true }), jsxTagEnd: new T("jsxTagEnd") };
              k.jsxTagStart.updateContext = function() {
                this.context.push(B), this.context.push(v), this.exprAllowed = false;
              }, k.jsxTagEnd.updateContext = function(C) {
                let H = this.context.pop();
                H === v && C === R.slash || H === q ? (this.context.pop(), this.exprAllowed = this.curContext() === B) : this.exprAllowed = true;
              }, V = { tokContexts: I, tokTypes: k }, E.set(g, V);
            }
            return V;
          }
          function A2(g) {
            if (!g)
              return g;
            if (g.type === "JSXIdentifier")
              return g.name;
            if (g.type === "JSXNamespacedName")
              return g.namespace.name + ":" + g.name.name;
            if (g.type === "JSXMemberExpression")
              return A2(g.object) + "." + A2(g.property);
          }
          o.exports = function(g) {
            return g = g || {}, function(V) {
              return b({ allowNamespaces: g.allowNamespaces !== false, allowNamespacedObjects: !!g.allowNamespacedObjects }, V);
            };
          }, Object.defineProperty(o.exports, "tokTypes", { get: function() {
            return y(ct()).tokTypes;
          }, configurable: true, enumerable: true });
          function b(g, V) {
            let R = V.acorn || ct(), N = y(R), T = R.tokTypes, v = N.tokTypes, q = R.tokContexts, B = N.tokContexts.tc_oTag, I = N.tokContexts.tc_cTag, k = N.tokContexts.tc_expr, C = R.isNewLine, H = R.isIdentifierStart, L = R.isIdentifierChar;
            return class extends V {
              static get acornJsx() {
                return N;
              }
              jsx_readToken() {
                let i2 = "", _ = this.pos;
                for (; ; ) {
                  this.pos >= this.input.length && this.raise(this.start, "Unterminated JSX contents");
                  let P = this.input.charCodeAt(this.pos);
                  switch (P) {
                    case 60:
                    case 123:
                      return this.pos === this.start ? P === 60 && this.exprAllowed ? (++this.pos, this.finishToken(v.jsxTagStart)) : this.getTokenFromCode(P) : (i2 += this.input.slice(_, this.pos), this.finishToken(v.jsxText, i2));
                    case 38:
                      i2 += this.input.slice(_, this.pos), i2 += this.jsx_readEntity(), _ = this.pos;
                      break;
                    case 62:
                    case 125:
                      this.raise(this.pos, "Unexpected token `" + this.input[this.pos] + "`. Did you mean `" + (P === 62 ? "&gt;" : "&rbrace;") + '` or `{"' + this.input[this.pos] + '"}`?');
                    default:
                      C(P) ? (i2 += this.input.slice(_, this.pos), i2 += this.jsx_readNewLine(true), _ = this.pos) : ++this.pos;
                  }
                }
              }
              jsx_readNewLine(i2) {
                let _ = this.input.charCodeAt(this.pos), P;
                return ++this.pos, _ === 13 && this.input.charCodeAt(this.pos) === 10 ? (++this.pos, P = i2 ? `
` : `\r
`) : P = String.fromCharCode(_), this.options.locations && (++this.curLine, this.lineStart = this.pos), P;
              }
              jsx_readString(i2) {
                let _ = "", P = ++this.pos;
                for (; ; ) {
                  this.pos >= this.input.length && this.raise(this.start, "Unterminated string constant");
                  let M = this.input.charCodeAt(this.pos);
                  if (M === i2)
                    break;
                  M === 38 ? (_ += this.input.slice(P, this.pos), _ += this.jsx_readEntity(), P = this.pos) : C(M) ? (_ += this.input.slice(P, this.pos), _ += this.jsx_readNewLine(false), P = this.pos) : ++this.pos;
                }
                return _ += this.input.slice(P, this.pos++), this.finishToken(T.string, _);
              }
              jsx_readEntity() {
                let i2 = "", _ = 0, P, M = this.input[this.pos];
                M !== "&" && this.raise(this.pos, "Entity must start with an ampersand");
                let ee = ++this.pos;
                for (; this.pos < this.input.length && _++ < 10; ) {
                  if (M = this.input[this.pos++], M === ";") {
                    i2[0] === "#" ? i2[1] === "x" ? (i2 = i2.substr(2), l.test(i2) && (P = String.fromCharCode(parseInt(i2, 16)))) : (i2 = i2.substr(1), m2.test(i2) && (P = String.fromCharCode(parseInt(i2, 10)))) : P = u[i2];
                    break;
                  }
                  i2 += M;
                }
                return P || (this.pos = ee, "&");
              }
              jsx_readWord() {
                let i2, _ = this.pos;
                do
                  i2 = this.input.charCodeAt(++this.pos);
                while (L(i2) || i2 === 45);
                return this.finishToken(v.jsxName, this.input.slice(_, this.pos));
              }
              jsx_parseIdentifier() {
                let i2 = this.startNode();
                return this.type === v.jsxName ? i2.name = this.value : this.type.keyword ? i2.name = this.type.keyword : this.unexpected(), this.next(), this.finishNode(i2, "JSXIdentifier");
              }
              jsx_parseNamespacedName() {
                let i2 = this.start, _ = this.startLoc, P = this.jsx_parseIdentifier();
                if (!g.allowNamespaces || !this.eat(T.colon))
                  return P;
                var M = this.startNodeAt(i2, _);
                return M.namespace = P, M.name = this.jsx_parseIdentifier(), this.finishNode(M, "JSXNamespacedName");
              }
              jsx_parseElementName() {
                if (this.type === v.jsxTagEnd)
                  return "";
                let i2 = this.start, _ = this.startLoc, P = this.jsx_parseNamespacedName();
                for (this.type === T.dot && P.type === "JSXNamespacedName" && !g.allowNamespacedObjects && this.unexpected(); this.eat(T.dot); ) {
                  let M = this.startNodeAt(i2, _);
                  M.object = P, M.property = this.jsx_parseIdentifier(), P = this.finishNode(M, "JSXMemberExpression");
                }
                return P;
              }
              jsx_parseAttributeValue() {
                switch (this.type) {
                  case T.braceL:
                    let i2 = this.jsx_parseExpressionContainer();
                    return i2.expression.type === "JSXEmptyExpression" && this.raise(i2.start, "JSX attributes must only be assigned a non-empty expression"), i2;
                  case v.jsxTagStart:
                  case T.string:
                    return this.parseExprAtom();
                  default:
                    this.raise(this.start, "JSX value should be either an expression or a quoted JSX text");
                }
              }
              jsx_parseEmptyExpression() {
                let i2 = this.startNodeAt(this.lastTokEnd, this.lastTokEndLoc);
                return this.finishNodeAt(i2, "JSXEmptyExpression", this.start, this.startLoc);
              }
              jsx_parseExpressionContainer() {
                let i2 = this.startNode();
                return this.next(), i2.expression = this.type === T.braceR ? this.jsx_parseEmptyExpression() : this.parseExpression(), this.expect(T.braceR), this.finishNode(i2, "JSXExpressionContainer");
              }
              jsx_parseAttribute() {
                let i2 = this.startNode();
                return this.eat(T.braceL) ? (this.expect(T.ellipsis), i2.argument = this.parseMaybeAssign(), this.expect(T.braceR), this.finishNode(i2, "JSXSpreadAttribute")) : (i2.name = this.jsx_parseNamespacedName(), i2.value = this.eat(T.eq) ? this.jsx_parseAttributeValue() : null, this.finishNode(i2, "JSXAttribute"));
              }
              jsx_parseOpeningElementAt(i2, _) {
                let P = this.startNodeAt(i2, _);
                P.attributes = [];
                let M = this.jsx_parseElementName();
                for (M && (P.name = M); this.type !== T.slash && this.type !== v.jsxTagEnd; )
                  P.attributes.push(this.jsx_parseAttribute());
                return P.selfClosing = this.eat(T.slash), this.expect(v.jsxTagEnd), this.finishNode(P, M ? "JSXOpeningElement" : "JSXOpeningFragment");
              }
              jsx_parseClosingElementAt(i2, _) {
                let P = this.startNodeAt(i2, _), M = this.jsx_parseElementName();
                return M && (P.name = M), this.expect(v.jsxTagEnd), this.finishNode(P, M ? "JSXClosingElement" : "JSXClosingFragment");
              }
              jsx_parseElementAt(i2, _) {
                let P = this.startNodeAt(i2, _), M = [], ee = this.jsx_parseOpeningElementAt(i2, _), ae = null;
                if (!ee.selfClosing) {
                  e:
                    for (; ; )
                      switch (this.type) {
                        case v.jsxTagStart:
                          if (i2 = this.start, _ = this.startLoc, this.next(), this.eat(T.slash)) {
                            ae = this.jsx_parseClosingElementAt(i2, _);
                            break e;
                          }
                          M.push(this.jsx_parseElementAt(i2, _));
                          break;
                        case v.jsxText:
                          M.push(this.parseExprAtom());
                          break;
                        case T.braceL:
                          M.push(this.jsx_parseExpressionContainer());
                          break;
                        default:
                          this.unexpected();
                      }
                  A2(ae.name) !== A2(ee.name) && this.raise(ae.start, "Expected corresponding JSX closing tag for <" + A2(ee.name) + ">");
                }
                let te = ee.name ? "Element" : "Fragment";
                return P["opening" + te] = ee, P["closing" + te] = ae, P.children = M, this.type === T.relational && this.value === "<" && this.raise(this.start, "Adjacent JSX elements must be wrapped in an enclosing tag"), this.finishNode(P, "JSX" + te);
              }
              jsx_parseText() {
                let i2 = this.parseLiteral(this.value);
                return i2.type = "JSXText", i2;
              }
              jsx_parseElement() {
                let i2 = this.start, _ = this.startLoc;
                return this.next(), this.jsx_parseElementAt(i2, _);
              }
              parseExprAtom(i2) {
                return this.type === v.jsxText ? this.jsx_parseText() : this.type === v.jsxTagStart ? this.jsx_parseElement() : super.parseExprAtom(i2);
              }
              readToken(i2) {
                let _ = this.curContext();
                if (_ === k)
                  return this.jsx_readToken();
                if (_ === B || _ === I) {
                  if (H(i2))
                    return this.jsx_readWord();
                  if (i2 == 62)
                    return ++this.pos, this.finishToken(v.jsxTagEnd);
                  if ((i2 === 34 || i2 === 39) && _ == B)
                    return this.jsx_readString(i2);
                }
                return i2 === 60 && this.exprAllowed && this.input.charCodeAt(this.pos + 1) !== 33 ? (++this.pos, this.finishToken(v.jsxTagStart)) : super.readToken(i2);
              }
              updateContext(i2) {
                if (this.type == T.braceL) {
                  var _ = this.curContext();
                  _ == B ? this.context.push(q.b_expr) : _ == k ? this.context.push(q.b_tmpl) : super.updateContext(i2), this.exprAllowed = true;
                } else if (this.type === T.slash && i2 === v.jsxTagStart)
                  this.context.length -= 2, this.context.push(I), this.exprAllowed = false;
                else
                  return super.updateContext(i2);
              }
            };
          }
        } }), wh = Y({ "src/language-js/parse/acorn.js"(n, o) {
          "use strict";
          J();
          var u = lr(), l = fa(), m2 = Fa(), E = Ia(), y = { ecmaVersion: "latest", sourceType: "module", allowReserved: true, allowReturnOutsideFunction: true, allowImportExportEverywhere: true, allowAwaitOutsideFunction: true, allowSuperOutsideMethod: true, allowHashBang: true, locations: true, ranges: true };
          function A2(N) {
            let { message: T, loc: v } = N;
            if (!v)
              return N;
            let { line: q, column: B } = v;
            return u(T.replace(/ \(\d+:\d+\)$/, ""), { start: { line: q, column: B + 1 } });
          }
          var b, g = () => {
            if (!b) {
              let { Parser: N } = ct(), T = Pa();
              b = N.extend(T());
            }
            return b;
          };
          function V(N, T) {
            let v = g(), q = [], B = [], I = v.parse(N, Object.assign(Object.assign({}, y), {}, { sourceType: T, onComment: q, onToken: B }));
            return I.comments = q, I.tokens = B, I;
          }
          function R(N, T) {
            let v = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { result: q, error: B } = l(() => V(N, "module"), () => V(N, "script"));
            if (!q)
              throw A2(B);
            return v.originalText = N, E(q, v);
          }
          o.exports = m2(R);
        } }), kh = Y({ "src/language-js/parse/utils/replace-hashbang.js"(n, o) {
          "use strict";
          J();
          function u(l) {
            return l.charAt(0) === "#" && l.charAt(1) === "!" ? "//" + l.slice(2) : l;
          }
          o.exports = u;
        } }), Fh = Y({ "node_modules/espree/dist/espree.cjs"(n) {
          "use strict";
          J(), Object.defineProperty(n, "__esModule", { value: true });
          var o = ct(), u = Pa(), l;
          function m2(p) {
            return p && typeof p == "object" && "default" in p ? p : { default: p };
          }
          function E(p) {
            if (p && p.__esModule)
              return p;
            var D = /* @__PURE__ */ Object.create(null);
            return p && Object.keys(p).forEach(function(w) {
              if (w !== "default") {
                var f3 = Object.getOwnPropertyDescriptor(p, w);
                Object.defineProperty(D, w, f3.get ? f3 : { enumerable: true, get: function() {
                  return p[w];
                } });
              }
            }), D.default = p, Object.freeze(D);
          }
          var y = E(o), A2 = m2(u), b = E(l), g = { Boolean: "Boolean", EOF: "<end>", Identifier: "Identifier", PrivateIdentifier: "PrivateIdentifier", Keyword: "Keyword", Null: "Null", Numeric: "Numeric", Punctuator: "Punctuator", String: "String", RegularExpression: "RegularExpression", Template: "Template", JSXIdentifier: "JSXIdentifier", JSXText: "JSXText" };
          function V(p, D) {
            let w = p[0], f3 = p[p.length - 1], F2 = { type: g.Template, value: D.slice(w.start, f3.end) };
            return w.loc && (F2.loc = { start: w.loc.start, end: f3.loc.end }), w.range && (F2.start = w.range[0], F2.end = f3.range[1], F2.range = [F2.start, F2.end]), F2;
          }
          function R(p, D) {
            this._acornTokTypes = p, this._tokens = [], this._curlyBrace = null, this._code = D;
          }
          R.prototype = { constructor: R, translate(p, D) {
            let w = p.type, f3 = this._acornTokTypes;
            if (w === f3.name)
              p.type = g.Identifier, p.value === "static" && (p.type = g.Keyword), D.ecmaVersion > 5 && (p.value === "yield" || p.value === "let") && (p.type = g.Keyword);
            else if (w === f3.privateId)
              p.type = g.PrivateIdentifier;
            else if (w === f3.semi || w === f3.comma || w === f3.parenL || w === f3.parenR || w === f3.braceL || w === f3.braceR || w === f3.dot || w === f3.bracketL || w === f3.colon || w === f3.question || w === f3.bracketR || w === f3.ellipsis || w === f3.arrow || w === f3.jsxTagStart || w === f3.incDec || w === f3.starstar || w === f3.jsxTagEnd || w === f3.prefix || w === f3.questionDot || w.binop && !w.keyword || w.isAssign)
              p.type = g.Punctuator, p.value = this._code.slice(p.start, p.end);
            else if (w === f3.jsxName)
              p.type = g.JSXIdentifier;
            else if (w.label === "jsxText" || w === f3.jsxAttrValueToken)
              p.type = g.JSXText;
            else if (w.keyword)
              w.keyword === "true" || w.keyword === "false" ? p.type = g.Boolean : w.keyword === "null" ? p.type = g.Null : p.type = g.Keyword;
            else if (w === f3.num)
              p.type = g.Numeric, p.value = this._code.slice(p.start, p.end);
            else if (w === f3.string)
              D.jsxAttrValueToken ? (D.jsxAttrValueToken = false, p.type = g.JSXText) : p.type = g.String, p.value = this._code.slice(p.start, p.end);
            else if (w === f3.regexp) {
              p.type = g.RegularExpression;
              let F2 = p.value;
              p.regex = { flags: F2.flags, pattern: F2.pattern }, p.value = "/".concat(F2.pattern, "/").concat(F2.flags);
            }
            return p;
          }, onToken(p, D) {
            let w = this, f3 = this._acornTokTypes, F2 = D.tokens, K = this._tokens;
            function X() {
              F2.push(V(w._tokens, w._code)), w._tokens = [];
            }
            if (p.type === f3.eof) {
              this._curlyBrace && F2.push(this.translate(this._curlyBrace, D));
              return;
            }
            if (p.type === f3.backQuote) {
              this._curlyBrace && (F2.push(this.translate(this._curlyBrace, D)), this._curlyBrace = null), K.push(p), K.length > 1 && X();
              return;
            }
            if (p.type === f3.dollarBraceL) {
              K.push(p), X();
              return;
            }
            if (p.type === f3.braceR) {
              this._curlyBrace && F2.push(this.translate(this._curlyBrace, D)), this._curlyBrace = p;
              return;
            }
            if (p.type === f3.template || p.type === f3.invalidTemplate) {
              this._curlyBrace && (K.push(this._curlyBrace), this._curlyBrace = null), K.push(p);
              return;
            }
            this._curlyBrace && (F2.push(this.translate(this._curlyBrace, D)), this._curlyBrace = null), F2.push(this.translate(p, D));
          } };
          var N = [3, 5, 6, 7, 8, 9, 10, 11, 12, 13];
          function T() {
            return N[N.length - 1];
          }
          function v() {
            return [...N];
          }
          function q() {
            let p = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 5, D = p === "latest" ? T() : p;
            if (typeof D != "number")
              throw new Error('ecmaVersion must be a number or "latest". Received value of type '.concat(typeof p, " instead."));
            if (D >= 2015 && (D -= 2009), !N.includes(D))
              throw new Error("Invalid ecmaVersion.");
            return D;
          }
          function B() {
            let p = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "script";
            if (p === "script" || p === "module")
              return p;
            if (p === "commonjs")
              return "script";
            throw new Error("Invalid sourceType.");
          }
          function I(p) {
            let D = q(p.ecmaVersion), w = B(p.sourceType), f3 = p.range === true, F2 = p.loc === true;
            if (D !== 3 && p.allowReserved)
              throw new Error("`allowReserved` is only supported when ecmaVersion is 3");
            if (typeof p.allowReserved < "u" && typeof p.allowReserved != "boolean")
              throw new Error("`allowReserved`, when present, must be `true` or `false`");
            let K = D === 3 ? p.allowReserved || "never" : false, X = p.ecmaFeatures || {}, oe = p.sourceType === "commonjs" || Boolean(X.globalReturn);
            if (w === "module" && D < 6)
              throw new Error("sourceType 'module' is not supported when ecmaVersion < 2015. Consider adding `{ ecmaVersion: 2015 }` to the parser options.");
            return Object.assign({}, p, { ecmaVersion: D, sourceType: w, ranges: f3, locations: F2, allowReserved: K, allowReturnOutsideFunction: oe });
          }
          var k = Symbol("espree's internal state"), C = Symbol("espree's esprimaFinishNode");
          function H(p, D, w, f3, F2, K) {
            let X = { type: p ? "Block" : "Line", value: D };
            return typeof w == "number" && (X.start = w, X.end = f3, X.range = [w, f3]), typeof F2 == "object" && (X.loc = { start: F2, end: K }), X;
          }
          var L = () => (p) => {
            let D = Object.assign({}, p.acorn.tokTypes);
            return p.acornJsx && Object.assign(D, p.acornJsx.tokTypes), class extends p {
              constructor(f3, F2) {
                (typeof f3 != "object" || f3 === null) && (f3 = {}), typeof F2 != "string" && !(F2 instanceof String) && (F2 = String(F2));
                let K = f3.sourceType, X = I(f3), oe = X.ecmaFeatures || {}, me = X.tokens === true ? new R(D, F2) : null;
                super({ ecmaVersion: X.ecmaVersion, sourceType: X.sourceType, ranges: X.ranges, locations: X.locations, allowReserved: X.allowReserved, allowReturnOutsideFunction: X.allowReturnOutsideFunction, onToken: (ve) => {
                  me && me.onToken(ve, this[k]), ve.type !== D.eof && (this[k].lastToken = ve);
                }, onComment: (ve, pt, ft, Ee, ge, De) => {
                  if (this[k].comments) {
                    let Ue = H(ve, pt, ft, Ee, ge, De);
                    this[k].comments.push(Ue);
                  }
                } }, F2), this[k] = { originalSourceType: K || X.sourceType, tokens: me ? [] : null, comments: X.comment === true ? [] : null, impliedStrict: oe.impliedStrict === true && this.options.ecmaVersion >= 5, ecmaVersion: this.options.ecmaVersion, jsxAttrValueToken: false, lastToken: null, templateElements: [] };
              }
              tokenize() {
                do
                  this.next();
                while (this.type !== D.eof);
                this.next();
                let f3 = this[k], F2 = f3.tokens;
                return f3.comments && (F2.comments = f3.comments), F2;
              }
              finishNode() {
                let f3 = super.finishNode(...arguments);
                return this[C](f3);
              }
              finishNodeAt() {
                let f3 = super.finishNodeAt(...arguments);
                return this[C](f3);
              }
              parse() {
                let f3 = this[k], F2 = super.parse();
                if (F2.sourceType = f3.originalSourceType, f3.comments && (F2.comments = f3.comments), f3.tokens && (F2.tokens = f3.tokens), F2.body.length) {
                  let [K] = F2.body;
                  F2.range && (F2.range[0] = K.range[0]), F2.loc && (F2.loc.start = K.loc.start), F2.start = K.start;
                }
                return f3.lastToken && (F2.range && (F2.range[1] = f3.lastToken.range[1]), F2.loc && (F2.loc.end = f3.lastToken.loc.end), F2.end = f3.lastToken.end), this[k].templateElements.forEach((K) => {
                  let oe = K.tail ? 1 : 2;
                  K.start += -1, K.end += oe, K.range && (K.range[0] += -1, K.range[1] += oe), K.loc && (K.loc.start.column += -1, K.loc.end.column += oe);
                }), F2;
              }
              parseTopLevel(f3) {
                return this[k].impliedStrict && (this.strict = true), super.parseTopLevel(f3);
              }
              raise(f3, F2) {
                let K = p.acorn.getLineInfo(this.input, f3), X = new SyntaxError(F2);
                throw X.index = f3, X.lineNumber = K.line, X.column = K.column + 1, X;
              }
              raiseRecoverable(f3, F2) {
                this.raise(f3, F2);
              }
              unexpected(f3) {
                let F2 = "Unexpected token";
                if (f3 != null) {
                  if (this.pos = f3, this.options.locations)
                    for (; this.pos < this.lineStart; )
                      this.lineStart = this.input.lastIndexOf(`
`, this.lineStart - 2) + 1, --this.curLine;
                  this.nextToken();
                }
                this.end > this.start && (F2 += " ".concat(this.input.slice(this.start, this.end))), this.raise(this.start, F2);
              }
              jsx_readString(f3) {
                let F2 = super.jsx_readString(f3);
                return this.type === D.string && (this[k].jsxAttrValueToken = true), F2;
              }
              [C](f3) {
                return f3.type === "TemplateElement" && this[k].templateElements.push(f3), f3.type.includes("Function") && !f3.generator && (f3.generator = false), f3;
              }
            };
          }, i2 = "9.3.1", _ = { _regular: null, _jsx: null, get regular() {
            return this._regular === null && (this._regular = y.Parser.extend(L())), this._regular;
          }, get jsx() {
            return this._jsx === null && (this._jsx = y.Parser.extend(A2.default(), L())), this._jsx;
          }, get(p) {
            return Boolean(p && p.ecmaFeatures && p.ecmaFeatures.jsx) ? this.jsx : this.regular;
          } };
          function P(p, D) {
            let w = _.get(D);
            return (!D || D.tokens !== true) && (D = Object.assign({}, D, { tokens: true })), new w(D, p).tokenize();
          }
          function M(p, D) {
            let w = _.get(D);
            return new w(D, p).parse();
          }
          var ee = i2, ae = function() {
            return b.KEYS;
          }(), te = void 0, ie = T(), Ne = v();
          n.Syntax = te, n.VisitorKeys = ae, n.latestEcmaVersion = ie, n.parse = M, n.supportedEcmaVersions = Ne, n.tokenize = P, n.version = ee;
        } }), Bh = Y({ "src/language-js/parse/espree.js"(n, o) {
          "use strict";
          J();
          var u = lr(), l = fa(), m2 = Fa(), E = kh(), y = Ia(), A2 = { ecmaVersion: "latest", range: true, loc: true, comment: true, tokens: true, sourceType: "module", ecmaFeatures: { jsx: true, globalReturn: true, impliedStrict: false } };
          function b(V) {
            let { message: R, lineNumber: N, column: T } = V;
            return typeof N != "number" ? V : u(R, { start: { line: N, column: T } });
          }
          function g(V, R) {
            let N = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { parse: T } = Fh(), v = E(V), { result: q, error: B } = l(() => T(v, Object.assign(Object.assign({}, A2), {}, { sourceType: "module" })), () => T(v, Object.assign(Object.assign({}, A2), {}, { sourceType: "script" })));
            if (!q)
              throw b(B);
            return N.originalText = V, y(q, N);
          }
          o.exports = m2(g);
        } });
        J();
        var Th = wh(), Ih = Bh();
        Na.exports = { parsers: { acorn: Th, espree: Ih } };
      });
      return Ph();
    });
  }
});

// node_modules/prettier/parser-meriyah.js
var require_parser_meriyah = __commonJS({
  "node_modules/prettier/parser-meriyah.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.meriyah = e2();
      }
    })(function() {
      "use strict";
      var F2 = (d, m2) => () => (m2 || d((m2 = { exports: {} }).exports, m2), m2.exports);
      var i2 = F2((E3, Ce) => {
        var A1 = function(d) {
          return d && d.Math == Math && d;
        };
        Ce.exports = A1(typeof globalThis == "object" && globalThis) || A1(typeof window == "object" && window) || A1(typeof self == "object" && self) || A1(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      });
      var L2 = F2((D3, we) => {
        we.exports = function(d) {
          try {
            return !!d();
          } catch {
            return true;
          }
        };
      });
      var J2 = F2((C3, qe) => {
        var Ut = L2();
        qe.exports = !Ut(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var x1 = F2((w3, Be) => {
        var Jt = L2();
        Be.exports = !Jt(function() {
          var d = function() {
          }.bind();
          return typeof d != "function" || d.hasOwnProperty("prototype");
        });
      });
      var P1 = F2((q3, Se) => {
        var Xt = x1(), y1 = Function.prototype.call;
        Se.exports = Xt ? y1.bind(y1) : function() {
          return y1.apply(y1, arguments);
        };
      });
      var Oe = F2((Le) => {
        "use strict";
        var Fe = {}.propertyIsEnumerable, Te = Object.getOwnPropertyDescriptor, zt = Te && !Fe.call({ 1: 2 }, 1);
        Le.f = zt ? function(m2) {
          var k = Te(this, m2);
          return !!k && k.enumerable;
        } : Fe;
      });
      var p1 = F2((S3, Ie) => {
        Ie.exports = function(d, m2) {
          return { enumerable: !(d & 1), configurable: !(d & 2), writable: !(d & 4), value: m2 };
        };
      });
      var D2 = F2((F3, Ve) => {
        var Re = x1(), Ne = Function.prototype, Ht = Ne.bind, uu = Ne.call, Kt = Re && Ht.bind(uu, uu);
        Ve.exports = Re ? function(d) {
          return d && Kt(d);
        } : function(d) {
          return d && function() {
            return uu.apply(d, arguments);
          };
        };
      });
      var Me = F2((T3, _e) => {
        var je = D2(), Wt = je({}.toString), Yt = je("".slice);
        _e.exports = function(d) {
          return Yt(Wt(d), 8, -1);
        };
      });
      var Je = F2((L3, Ue) => {
        var $t = i2(), Zt = D2(), Qt = L2(), Gt = Me(), eu = $t.Object, xt = Zt("".split);
        Ue.exports = Qt(function() {
          return !eu("z").propertyIsEnumerable(0);
        }) ? function(d) {
          return Gt(d) == "String" ? xt(d, "") : eu(d);
        } : eu;
      });
      var iu = F2((O3, Xe) => {
        var pt = i2(), uo = pt.TypeError;
        Xe.exports = function(d) {
          if (d == null)
            throw uo("Can't call method on " + d);
          return d;
        };
      });
      var E1 = F2((I3, ze) => {
        var eo = Je(), io = iu();
        ze.exports = function(d) {
          return eo(io(d));
        };
      });
      var C2 = F2((R3, He) => {
        He.exports = function(d) {
          return typeof d == "function";
        };
      });
      var Z2 = F2((N3, Ke) => {
        var no = C2();
        Ke.exports = function(d) {
          return typeof d == "object" ? d !== null : no(d);
        };
      });
      var D1 = F2((V3, We) => {
        var nu = i2(), to = C2(), oo = function(d) {
          return to(d) ? d : void 0;
        };
        We.exports = function(d, m2) {
          return arguments.length < 2 ? oo(nu[d]) : nu[d] && nu[d][m2];
        };
      });
      var $e = F2((j3, Ye) => {
        var lo = D2();
        Ye.exports = lo({}.isPrototypeOf);
      });
      var Qe = F2((_3, Ze) => {
        var fo = D1();
        Ze.exports = fo("navigator", "userAgent") || "";
      });
      var ni = F2((M3, ii) => {
        var ei = i2(), tu = Qe(), Ge = ei.process, xe = ei.Deno, pe = Ge && Ge.versions || xe && xe.version, ui = pe && pe.v8, P2, C1;
        ui && (P2 = ui.split("."), C1 = P2[0] > 0 && P2[0] < 4 ? 1 : +(P2[0] + P2[1]));
        !C1 && tu && (P2 = tu.match(/Edge\/(\d+)/), (!P2 || P2[1] >= 74) && (P2 = tu.match(/Chrome\/(\d+)/), P2 && (C1 = +P2[1])));
        ii.exports = C1;
      });
      var ou = F2((U3, oi) => {
        var ti = ni(), co = L2();
        oi.exports = !!Object.getOwnPropertySymbols && !co(function() {
          var d = Symbol();
          return !String(d) || !(Object(d) instanceof Symbol) || !Symbol.sham && ti && ti < 41;
        });
      });
      var lu = F2((J3, li) => {
        var so = ou();
        li.exports = so && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var fu = F2((X3, fi) => {
        var ao = i2(), go = D1(), ho = C2(), mo = $e(), bo = lu(), ko = ao.Object;
        fi.exports = bo ? function(d) {
          return typeof d == "symbol";
        } : function(d) {
          var m2 = go("Symbol");
          return ho(m2) && mo(m2.prototype, ko(d));
        };
      });
      var si = F2((z3, ci) => {
        var ro = i2(), vo = ro.String;
        ci.exports = function(d) {
          try {
            return vo(d);
          } catch {
            return "Object";
          }
        };
      });
      var di = F2((H3, ai) => {
        var Ao = i2(), yo = C2(), Po = si(), Eo = Ao.TypeError;
        ai.exports = function(d) {
          if (yo(d))
            return d;
          throw Eo(Po(d) + " is not a function");
        };
      });
      var hi = F2((K3, gi) => {
        var Do = di();
        gi.exports = function(d, m2) {
          var k = d[m2];
          return k == null ? void 0 : Do(k);
        };
      });
      var bi = F2((W3, mi) => {
        var Co = i2(), cu = P1(), su = C2(), au = Z2(), wo = Co.TypeError;
        mi.exports = function(d, m2) {
          var k, f3;
          if (m2 === "string" && su(k = d.toString) && !au(f3 = cu(k, d)) || su(k = d.valueOf) && !au(f3 = cu(k, d)) || m2 !== "string" && su(k = d.toString) && !au(f3 = cu(k, d)))
            return f3;
          throw wo("Can't convert object to primitive value");
        };
      });
      var ri = F2((Y3, ki) => {
        ki.exports = false;
      });
      var w1 = F2(($3, Ai) => {
        var vi = i2(), qo = Object.defineProperty;
        Ai.exports = function(d, m2) {
          try {
            qo(vi, d, { value: m2, configurable: true, writable: true });
          } catch {
            vi[d] = m2;
          }
          return m2;
        };
      });
      var q1 = F2((Z3, Pi) => {
        var Bo = i2(), So = w1(), yi = "__core-js_shared__", Fo = Bo[yi] || So(yi, {});
        Pi.exports = Fo;
      });
      var du = F2((Q3, Di) => {
        var To = ri(), Ei = q1();
        (Di.exports = function(d, m2) {
          return Ei[d] || (Ei[d] = m2 !== void 0 ? m2 : {});
        })("versions", []).push({ version: "3.22.2", mode: To ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var wi = F2((G3, Ci) => {
        var Lo = i2(), Oo = iu(), Io = Lo.Object;
        Ci.exports = function(d) {
          return Io(Oo(d));
        };
      });
      var O2 = F2((x3, qi) => {
        var Ro = D2(), No = wi(), Vo = Ro({}.hasOwnProperty);
        qi.exports = Object.hasOwn || function(m2, k) {
          return Vo(No(m2), k);
        };
      });
      var gu = F2((p3, Bi) => {
        var jo = D2(), _o = 0, Mo = Math.random(), Uo = jo(1 .toString);
        Bi.exports = function(d) {
          return "Symbol(" + (d === void 0 ? "" : d) + ")_" + Uo(++_o + Mo, 36);
        };
      });
      var Ii = F2((u6, Oi) => {
        var Jo = i2(), Xo = du(), Si = O2(), zo = gu(), Fi = ou(), Li = lu(), Q2 = Xo("wks"), X2 = Jo.Symbol, Ti = X2 && X2.for, Ho = Li ? X2 : X2 && X2.withoutSetter || zo;
        Oi.exports = function(d) {
          if (!Si(Q2, d) || !(Fi || typeof Q2[d] == "string")) {
            var m2 = "Symbol." + d;
            Fi && Si(X2, d) ? Q2[d] = X2[d] : Li && Ti ? Q2[d] = Ti(m2) : Q2[d] = Ho(m2);
          }
          return Q2[d];
        };
      });
      var ji = F2((e6, Vi) => {
        var Ko = i2(), Wo = P1(), Ri = Z2(), Ni = fu(), Yo = hi(), $o = bi(), Zo = Ii(), Qo = Ko.TypeError, Go = Zo("toPrimitive");
        Vi.exports = function(d, m2) {
          if (!Ri(d) || Ni(d))
            return d;
          var k = Yo(d, Go), f3;
          if (k) {
            if (m2 === void 0 && (m2 = "default"), f3 = Wo(k, d, m2), !Ri(f3) || Ni(f3))
              return f3;
            throw Qo("Can't convert object to primitive value");
          }
          return m2 === void 0 && (m2 = "number"), $o(d, m2);
        };
      });
      var hu = F2((i6, _i) => {
        var xo = ji(), po = fu();
        _i.exports = function(d) {
          var m2 = xo(d, "string");
          return po(m2) ? m2 : m2 + "";
        };
      });
      var Ji = F2((n6, Ui) => {
        var ul = i2(), Mi = Z2(), mu = ul.document, el = Mi(mu) && Mi(mu.createElement);
        Ui.exports = function(d) {
          return el ? mu.createElement(d) : {};
        };
      });
      var bu = F2((t6, Xi) => {
        var il = J2(), nl = L2(), tl = Ji();
        Xi.exports = !il && !nl(function() {
          return Object.defineProperty(tl("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var ku = F2((Hi) => {
        var ol = J2(), ll = P1(), fl = Oe(), cl = p1(), sl = E1(), al = hu(), dl = O2(), gl = bu(), zi = Object.getOwnPropertyDescriptor;
        Hi.f = ol ? zi : function(m2, k) {
          if (m2 = sl(m2), k = al(k), gl)
            try {
              return zi(m2, k);
            } catch {
            }
          if (dl(m2, k))
            return cl(!ll(fl.f, m2, k), m2[k]);
        };
      });
      var Wi = F2((l6, Ki) => {
        var hl = J2(), ml = L2();
        Ki.exports = hl && ml(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var ru = F2((f6, $i) => {
        var Yi = i2(), bl = Z2(), kl = Yi.String, rl = Yi.TypeError;
        $i.exports = function(d) {
          if (bl(d))
            return d;
          throw rl(kl(d) + " is not an object");
        };
      });
      var Eu = F2((Qi) => {
        var vl = i2(), Al = J2(), yl = bu(), Pl = Wi(), B1 = ru(), Zi = hu(), El = vl.TypeError, vu = Object.defineProperty, Dl = Object.getOwnPropertyDescriptor, Au = "enumerable", yu = "configurable", Pu = "writable";
        Qi.f = Al ? Pl ? function(m2, k, f3) {
          if (B1(m2), k = Zi(k), B1(f3), typeof m2 == "function" && k === "prototype" && "value" in f3 && Pu in f3 && !f3[Pu]) {
            var P = Dl(m2, k);
            P && P[Pu] && (m2[k] = f3.value, f3 = { configurable: yu in f3 ? f3[yu] : P[yu], enumerable: Au in f3 ? f3[Au] : P[Au], writable: false });
          }
          return vu(m2, k, f3);
        } : vu : function(m2, k, f3) {
          if (B1(m2), k = Zi(k), B1(f3), yl)
            try {
              return vu(m2, k, f3);
            } catch {
            }
          if ("get" in f3 || "set" in f3)
            throw El("Accessors not supported");
          return "value" in f3 && (m2[k] = f3.value), m2;
        };
      });
      var S1 = F2((s6, Gi) => {
        var Cl = J2(), wl = Eu(), ql = p1();
        Gi.exports = Cl ? function(d, m2, k) {
          return wl.f(d, m2, ql(1, k));
        } : function(d, m2, k) {
          return d[m2] = k, d;
        };
      });
      var Cu = F2((a6, xi) => {
        var Bl = D2(), Sl = C2(), Du = q1(), Fl = Bl(Function.toString);
        Sl(Du.inspectSource) || (Du.inspectSource = function(d) {
          return Fl(d);
        });
        xi.exports = Du.inspectSource;
      });
      var en = F2((d6, un) => {
        var Tl = i2(), Ll = C2(), Ol = Cu(), pi = Tl.WeakMap;
        un.exports = Ll(pi) && /native code/.test(Ol(pi));
      });
      var on = F2((g6, tn) => {
        var Il = du(), Rl = gu(), nn = Il("keys");
        tn.exports = function(d) {
          return nn[d] || (nn[d] = Rl(d));
        };
      });
      var wu = F2((h6, ln) => {
        ln.exports = {};
      });
      var gn = F2((m6, dn) => {
        var Nl = en(), an = i2(), qu = D2(), Vl = Z2(), jl = S1(), Bu = O2(), Su = q1(), _l = on(), Ml = wu(), fn = "Object already initialized", Tu = an.TypeError, Ul = an.WeakMap, F1, e1, T1, Jl = function(d) {
          return T1(d) ? e1(d) : F1(d, {});
        }, Xl = function(d) {
          return function(m2) {
            var k;
            if (!Vl(m2) || (k = e1(m2)).type !== d)
              throw Tu("Incompatible receiver, " + d + " required");
            return k;
          };
        };
        Nl || Su.state ? (I2 = Su.state || (Su.state = new Ul()), cn = qu(I2.get), Fu = qu(I2.has), sn = qu(I2.set), F1 = function(d, m2) {
          if (Fu(I2, d))
            throw new Tu(fn);
          return m2.facade = d, sn(I2, d, m2), m2;
        }, e1 = function(d) {
          return cn(I2, d) || {};
        }, T1 = function(d) {
          return Fu(I2, d);
        }) : (z2 = _l("state"), Ml[z2] = true, F1 = function(d, m2) {
          if (Bu(d, z2))
            throw new Tu(fn);
          return m2.facade = d, jl(d, z2, m2), m2;
        }, e1 = function(d) {
          return Bu(d, z2) ? d[z2] : {};
        }, T1 = function(d) {
          return Bu(d, z2);
        });
        var I2, cn, Fu, sn, z2;
        dn.exports = { set: F1, get: e1, has: T1, enforce: Jl, getterFor: Xl };
      });
      var bn = F2((b6, mn) => {
        var Lu = J2(), zl = O2(), hn = Function.prototype, Hl = Lu && Object.getOwnPropertyDescriptor, Ou = zl(hn, "name"), Kl = Ou && function() {
        }.name === "something", Wl = Ou && (!Lu || Lu && Hl(hn, "name").configurable);
        mn.exports = { EXISTS: Ou, PROPER: Kl, CONFIGURABLE: Wl };
      });
      var yn = F2((k6, An) => {
        var Yl = i2(), kn = C2(), $l = O2(), rn = S1(), Zl = w1(), Ql = Cu(), vn = gn(), Gl = bn().CONFIGURABLE, xl = vn.get, pl = vn.enforce, u4 = String(String).split("String");
        (An.exports = function(d, m2, k, f3) {
          var P = f3 ? !!f3.unsafe : false, S2 = f3 ? !!f3.enumerable : false, q = f3 ? !!f3.noTargetGet : false, T = f3 && f3.name !== void 0 ? f3.name : m2, r2;
          if (kn(k) && (String(T).slice(0, 7) === "Symbol(" && (T = "[" + String(T).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!$l(k, "name") || Gl && k.name !== T) && rn(k, "name", T), r2 = pl(k), r2.source || (r2.source = u4.join(typeof T == "string" ? T : ""))), d === Yl) {
            S2 ? d[m2] = k : Zl(m2, k);
            return;
          } else
            P ? !q && d[m2] && (S2 = true) : delete d[m2];
          S2 ? d[m2] = k : rn(d, m2, k);
        })(Function.prototype, "toString", function() {
          return kn(this) && xl(this).source || Ql(this);
        });
      });
      var Iu = F2((r6, Pn) => {
        var e4 = Math.ceil, i4 = Math.floor;
        Pn.exports = function(d) {
          var m2 = +d;
          return m2 !== m2 || m2 === 0 ? 0 : (m2 > 0 ? i4 : e4)(m2);
        };
      });
      var Dn = F2((v6, En) => {
        var n4 = Iu(), t4 = Math.max, o4 = Math.min;
        En.exports = function(d, m2) {
          var k = n4(d);
          return k < 0 ? t4(k + m2, 0) : o4(k, m2);
        };
      });
      var wn = F2((A6, Cn) => {
        var l4 = Iu(), f4 = Math.min;
        Cn.exports = function(d) {
          return d > 0 ? f4(l4(d), 9007199254740991) : 0;
        };
      });
      var Bn = F2((y6, qn) => {
        var c4 = wn();
        qn.exports = function(d) {
          return c4(d.length);
        };
      });
      var Tn = F2((P6, Fn) => {
        var s4 = E1(), a4 = Dn(), d4 = Bn(), Sn = function(d) {
          return function(m2, k, f3) {
            var P = s4(m2), S2 = d4(P), q = a4(f3, S2), T;
            if (d && k != k) {
              for (; S2 > q; )
                if (T = P[q++], T != T)
                  return true;
            } else
              for (; S2 > q; q++)
                if ((d || q in P) && P[q] === k)
                  return d || q || 0;
            return !d && -1;
          };
        };
        Fn.exports = { includes: Sn(true), indexOf: Sn(false) };
      });
      var In = F2((E6, On) => {
        var g4 = D2(), Ru = O2(), h4 = E1(), m4 = Tn().indexOf, b4 = wu(), Ln = g4([].push);
        On.exports = function(d, m2) {
          var k = h4(d), f3 = 0, P = [], S2;
          for (S2 in k)
            !Ru(b4, S2) && Ru(k, S2) && Ln(P, S2);
          for (; m2.length > f3; )
            Ru(k, S2 = m2[f3++]) && (~m4(P, S2) || Ln(P, S2));
          return P;
        };
      });
      var Nn = F2((D6, Rn) => {
        Rn.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var jn = F2((Vn) => {
        var k4 = In(), r4 = Nn(), v4 = r4.concat("length", "prototype");
        Vn.f = Object.getOwnPropertyNames || function(m2) {
          return k4(m2, v4);
        };
      });
      var Mn = F2((_n) => {
        _n.f = Object.getOwnPropertySymbols;
      });
      var Jn = F2((q6, Un) => {
        var A4 = D1(), y4 = D2(), P4 = jn(), E4 = Mn(), D4 = ru(), C4 = y4([].concat);
        Un.exports = A4("Reflect", "ownKeys") || function(m2) {
          var k = P4.f(D4(m2)), f3 = E4.f;
          return f3 ? C4(k, f3(m2)) : k;
        };
      });
      var Hn = F2((B6, zn) => {
        var Xn = O2(), w4 = Jn(), q4 = ku(), B4 = Eu();
        zn.exports = function(d, m2, k) {
          for (var f3 = w4(m2), P = B4.f, S2 = q4.f, q = 0; q < f3.length; q++) {
            var T = f3[q];
            !Xn(d, T) && !(k && Xn(k, T)) && P(d, T, S2(m2, T));
          }
        };
      });
      var Wn = F2((S6, Kn) => {
        var S4 = L2(), F4 = C2(), T4 = /#|\.prototype\./, i1 = function(d, m2) {
          var k = O4[L4(d)];
          return k == R4 ? true : k == I4 ? false : F4(m2) ? S4(m2) : !!m2;
        }, L4 = i1.normalize = function(d) {
          return String(d).replace(T4, ".").toLowerCase();
        }, O4 = i1.data = {}, I4 = i1.NATIVE = "N", R4 = i1.POLYFILL = "P";
        Kn.exports = i1;
      });
      var $n = F2((F6, Yn) => {
        var Nu = i2(), N4 = ku().f, V4 = S1(), j4 = yn(), _4 = w1(), M4 = Hn(), U4 = Wn();
        Yn.exports = function(d, m2) {
          var k = d.target, f3 = d.global, P = d.stat, S2, q, T, r2, K, Y;
          if (f3 ? q = Nu : P ? q = Nu[k] || _4(k, {}) : q = (Nu[k] || {}).prototype, q)
            for (T in m2) {
              if (K = m2[T], d.noTargetGet ? (Y = N4(q, T), r2 = Y && Y.value) : r2 = q[T], S2 = U4(f3 ? T : k + (P ? "." : "#") + T, d.forced), !S2 && r2 !== void 0) {
                if (typeof K == typeof r2)
                  continue;
                M4(K, r2);
              }
              (d.sham || r2 && r2.sham) && V4(K, "sham", true), j4(q, T, K, d);
            }
        };
      });
      var Zn = F2(() => {
        var J4 = $n(), X4 = i2();
        J4({ global: true }, { globalThis: X4 });
      });
      var Qn = F2(() => {
        Zn();
      });
      var y3 = F2((R6, k0) => {
        Qn();
        var Mu = Object.defineProperty, z4 = Object.getOwnPropertyDescriptor, Uu = Object.getOwnPropertyNames, H4 = Object.prototype.hasOwnProperty, xn = (d, m2) => function() {
          return d && (m2 = (0, d[Uu(d)[0]])(d = 0)), m2;
        }, l2 = (d, m2) => function() {
          return m2 || (0, d[Uu(d)[0]])((m2 = { exports: {} }).exports, m2), m2.exports;
        }, K4 = (d, m2) => {
          for (var k in m2)
            Mu(d, k, { get: m2[k], enumerable: true });
        }, W4 = (d, m2, k, f4) => {
          if (m2 && typeof m2 == "object" || typeof m2 == "function")
            for (let P of Uu(m2))
              !H4.call(d, P) && P !== k && Mu(d, P, { get: () => m2[P], enumerable: !(f4 = z4(m2, P)) || f4.enumerable });
          return d;
        }, Y4 = (d) => W4(Mu({}, "__esModule", { value: true }), d), n2 = xn({ "<define:process>"() {
        } }), pn = l2({ "src/common/parser-create-error.js"(d, m2) {
          "use strict";
          n2();
          function k(f4, P) {
            let S2 = new SyntaxError(f4 + " (" + P.start.line + ":" + P.start.column + ")");
            return S2.loc = P, S2;
          }
          m2.exports = k;
        } }), $4 = l2({ "src/utils/try-combinations.js"(d, m2) {
          "use strict";
          n2();
          function k() {
            let f4;
            for (var P = arguments.length, S2 = new Array(P), q = 0; q < P; q++)
              S2[q] = arguments[q];
            for (let [T, r2] of S2.entries())
              try {
                return { result: r2() };
              } catch (K) {
                T === 0 && (f4 = K);
              }
            return { error: f4 };
          }
          m2.exports = k;
        } }), u0 = {};
        K4(u0, { EOL: () => _u, arch: () => Z4, cpus: () => f0, default: () => g0, endianness: () => e0, freemem: () => o0, getNetworkInterfaces: () => d0, hostname: () => i0, loadavg: () => n0, networkInterfaces: () => a0, platform: () => Q4, release: () => s0, tmpDir: () => Vu, tmpdir: () => ju, totalmem: () => l0, type: () => c0, uptime: () => t0 });
        function e0() {
          if (typeof L1 > "u") {
            var d = new ArrayBuffer(2), m2 = new Uint8Array(d), k = new Uint16Array(d);
            if (m2[0] = 1, m2[1] = 2, k[0] === 258)
              L1 = "BE";
            else if (k[0] === 513)
              L1 = "LE";
            else
              throw new Error("unable to figure out endianess");
          }
          return L1;
        }
        function i0() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function n0() {
          return [];
        }
        function t0() {
          return 0;
        }
        function o0() {
          return Number.MAX_VALUE;
        }
        function l0() {
          return Number.MAX_VALUE;
        }
        function f0() {
          return [];
        }
        function c0() {
          return "Browser";
        }
        function s0() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function a0() {
        }
        function d0() {
        }
        function Z4() {
          return "javascript";
        }
        function Q4() {
          return "browser";
        }
        function Vu() {
          return "/tmp";
        }
        var L1, ju, _u, g0, G4 = xn({ "node-modules-polyfills:os"() {
          n2(), ju = Vu, _u = `
`, g0 = { EOL: _u, tmpdir: ju, tmpDir: Vu, networkInterfaces: a0, getNetworkInterfaces: d0, release: s0, type: c0, cpus: f0, totalmem: l0, freemem: o0, uptime: t0, loadavg: n0, hostname: i0, endianness: e0 };
        } }), x4 = l2({ "node-modules-polyfills-commonjs:os"(d, m2) {
          n2();
          var k = (G4(), Y4(u0));
          if (k && k.default) {
            m2.exports = k.default;
            for (let f4 in k)
              m2.exports[f4] = k[f4];
          } else
            k && (m2.exports = k);
        } }), p4 = l2({ "node_modules/detect-newline/index.js"(d, m2) {
          "use strict";
          n2();
          var k = (f4) => {
            if (typeof f4 != "string")
              throw new TypeError("Expected a string");
            let P = f4.match(/(?:\r?\n)/g) || [];
            if (P.length === 0)
              return;
            let S2 = P.filter((T) => T === `\r
`).length, q = P.length - S2;
            return S2 > q ? `\r
` : `
`;
          };
          m2.exports = k, m2.exports.graceful = (f4) => typeof f4 == "string" && k(f4) || `
`;
        } }), u3 = l2({ "node_modules/jest-docblock/build/index.js"(d) {
          "use strict";
          n2(), Object.defineProperty(d, "__esModule", { value: true }), d.extract = Z3, d.parse = t2, d.parseWithComments = V, d.print = J, d.strip = L;
          function m2() {
            let I = x4();
            return m2 = function() {
              return I;
            }, I;
          }
          function k() {
            let I = f4(p4());
            return k = function() {
              return I;
            }, I;
          }
          function f4(I) {
            return I && I.__esModule ? I : { default: I };
          }
          var P = /\*\/$/, S2 = /^\/\*\*/, q = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, T = /(^|\s+)\/\/([^\r\n]*)/g, r2 = /^(\r?\n)+/, K = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, Y = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, X = /(\r?\n|^) *\* ?/g, p = [];
          function Z3(I) {
            let u2 = I.match(q);
            return u2 ? u2[0].trimLeft() : "";
          }
          function L(I) {
            let u2 = I.match(q);
            return u2 && u2[0] ? I.substring(u2[0].length) : I;
          }
          function t2(I) {
            return V(I).pragmas;
          }
          function V(I) {
            let u2 = (0, k().default)(I) || m2().EOL;
            I = I.replace(S2, "").replace(P, "").replace(X, "$1");
            let m22 = "";
            for (; m22 !== I; )
              m22 = I, I = I.replace(K, "".concat(u2, "$1 $2").concat(u2));
            I = I.replace(r2, "").trimRight();
            let c2 = /* @__PURE__ */ Object.create(null), R2 = I.replace(Y, "").replace(r2, "").trimRight(), s2;
            for (; s2 = Y.exec(I); ) {
              let N2 = s2[2].replace(T, "");
              typeof c2[s2[1]] == "string" || Array.isArray(c2[s2[1]]) ? c2[s2[1]] = p.concat(c2[s2[1]], N2) : c2[s2[1]] = N2;
            }
            return { comments: R2, pragmas: c2 };
          }
          function J(I) {
            let { comments: u2 = "", pragmas: m22 = {} } = I, c2 = (0, k().default)(u2) || m2().EOL, R2 = "/**", s2 = " *", N2 = " */", w2 = Object.keys(m22), O1 = w2.map((g2) => H(g2, m22[g2])).reduce((g2, n1) => g2.concat(n1), []).map((g2) => s2 + " " + g2 + c2).join("");
            if (!u2) {
              if (w2.length === 0)
                return "";
              if (w2.length === 1 && !Array.isArray(m22[w2[0]])) {
                let g2 = m22[w2[0]];
                return "".concat(R2, " ").concat(H(w2[0], g2)[0]).concat(N2);
              }
            }
            let I1 = u2.split(c2).map((g2) => "".concat(s2, " ").concat(g2)).join(c2) + c2;
            return R2 + c2 + (u2 ? I1 : "") + (u2 && w2.length ? s2 + c2 : "") + O1 + N2;
          }
          function H(I, u2) {
            return p.concat(u2).map((m22) => "@".concat(I, " ").concat(m22).trim());
          }
        } }), e3 = l2({ "src/common/end-of-line.js"(d, m2) {
          "use strict";
          n2();
          function k(q) {
            let T = q.indexOf("\r");
            return T >= 0 ? q.charAt(T + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function f4(q) {
            switch (q) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function P(q, T) {
            let r2;
            switch (T) {
              case `
`:
                r2 = /\n/g;
                break;
              case "\r":
                r2 = /\r/g;
                break;
              case `\r
`:
                r2 = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(T), "."));
            }
            let K = q.match(r2);
            return K ? K.length : 0;
          }
          function S2(q) {
            return q.replace(/\r\n?/g, `
`);
          }
          m2.exports = { guessEndOfLine: k, convertEndOfLineToChars: f4, countEndOfLineChars: P, normalizeEndOfLine: S2 };
        } }), i3 = l2({ "src/language-js/utils/get-shebang.js"(d, m2) {
          "use strict";
          n2();
          function k(f4) {
            if (!f4.startsWith("#!"))
              return "";
            let P = f4.indexOf(`
`);
            return P === -1 ? f4 : f4.slice(0, P);
          }
          m2.exports = k;
        } }), n3 = l2({ "src/language-js/pragma.js"(d, m2) {
          "use strict";
          n2();
          var { parseWithComments: k, strip: f4, extract: P, print: S2 } = u3(), { normalizeEndOfLine: q } = e3(), T = i3();
          function r2(X) {
            let p = T(X);
            p && (X = X.slice(p.length + 1));
            let Z3 = P(X), { pragmas: L, comments: t2 } = k(Z3);
            return { shebang: p, text: X, pragmas: L, comments: t2 };
          }
          function K(X) {
            let p = Object.keys(r2(X).pragmas);
            return p.includes("prettier") || p.includes("format");
          }
          function Y(X) {
            let { shebang: p, text: Z3, pragmas: L, comments: t2 } = r2(X), V = f4(Z3), J = S2({ pragmas: Object.assign({ format: "" }, L), comments: t2.trimStart() });
            return (p ? "".concat(p, `
`) : "") + q(J) + (V.startsWith(`
`) ? `
` : `

`) + V;
          }
          m2.exports = { hasPragma: K, insertPragma: Y };
        } }), t3 = l2({ "src/utils/is-non-empty-array.js"(d, m2) {
          "use strict";
          n2();
          function k(f4) {
            return Array.isArray(f4) && f4.length > 0;
          }
          m2.exports = k;
        } }), h0 = l2({ "src/language-js/loc.js"(d, m2) {
          "use strict";
          n2();
          var k = t3();
          function f4(r2, K) {
            let { ignoreDecorators: Y } = K || {};
            if (!Y) {
              let X = r2.declaration && r2.declaration.decorators || r2.decorators;
              if (k(X))
                return f4(X[0]);
            }
            return r2.range ? r2.range[0] : r2.start;
          }
          function P(r2) {
            return r2.range ? r2.range[1] : r2.end;
          }
          function S2(r2, K) {
            let Y = f4(r2);
            return Number.isInteger(Y) && Y === f4(K);
          }
          function q(r2, K) {
            let Y = P(r2);
            return Number.isInteger(Y) && Y === P(K);
          }
          function T(r2, K) {
            return S2(r2, K) && q(r2, K);
          }
          m2.exports = { locStart: f4, locEnd: P, hasSameLocStart: S2, hasSameLoc: T };
        } }), o3 = l2({ "src/language-js/parse/utils/create-parser.js"(d, m2) {
          "use strict";
          n2();
          var { hasPragma: k } = n3(), { locStart: f4, locEnd: P } = h0();
          function S2(q) {
            return q = typeof q == "function" ? { parse: q } : q, Object.assign({ astFormat: "estree", hasPragma: k, locStart: f4, locEnd: P }, q);
          }
          m2.exports = S2;
        } }), l3 = l2({ "src/language-js/utils/is-ts-keyword-type.js"(d, m2) {
          "use strict";
          n2();
          function k(f4) {
            let { type: P } = f4;
            return P.startsWith("TS") && P.endsWith("Keyword");
          }
          m2.exports = k;
        } }), f3 = l2({ "src/language-js/utils/is-block-comment.js"(d, m2) {
          "use strict";
          n2();
          var k = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]), f4 = (P) => k.has(P == null ? void 0 : P.type);
          m2.exports = f4;
        } }), c3 = l2({ "src/language-js/utils/is-type-cast-comment.js"(d, m2) {
          "use strict";
          n2();
          var k = f3();
          function f4(P) {
            return k(P) && P.value[0] === "*" && /@type\b/.test(P.value);
          }
          m2.exports = f4;
        } }), s3 = l2({ "src/utils/get-last.js"(d, m2) {
          "use strict";
          n2();
          var k = (f4) => f4[f4.length - 1];
          m2.exports = k;
        } }), m0 = l2({ "src/language-js/parse/postprocess/visit-node.js"(d, m2) {
          "use strict";
          n2();
          function k(f4, P) {
            if (Array.isArray(f4)) {
              for (let S2 = 0; S2 < f4.length; S2++)
                f4[S2] = k(f4[S2], P);
              return f4;
            }
            if (f4 && typeof f4 == "object" && typeof f4.type == "string") {
              let S2 = Object.keys(f4);
              for (let q = 0; q < S2.length; q++)
                f4[S2[q]] = k(f4[S2[q]], P);
              return P(f4) || f4;
            }
            return f4;
          }
          m2.exports = k;
        } }), b0 = l2({ "src/language-js/parse/postprocess/throw-syntax-error.js"(d, m2) {
          "use strict";
          n2();
          var k = pn();
          function f4(P, S2) {
            let { start: q, end: T } = P.loc;
            throw k(S2, { start: { line: q.line, column: q.column + 1 }, end: { line: T.line, column: T.column + 1 } });
          }
          m2.exports = f4;
        } }), a3 = l2({ "src/language-js/parse/postprocess/typescript.js"(d, m2) {
          "use strict";
          n2();
          var k = m0(), f4 = b0();
          function P(T, r2, K) {
            let Y = T.decorators;
            if (!Array.isArray(Y))
              return;
            let X = r2.decorators;
            (!Array.isArray(X) || X.length !== Y.length || Y.some((p) => {
              let Z3 = K.get(p);
              return !Z3 || !X.includes(Z3);
            })) && f4(r2, "Leading decorators must be attached to a class declaration");
          }
          function S2(T, r2) {
            T.kind !== 167 || T.modifiers && !T.modifiers.some((X) => X.kind === 126) || T.initializer && r2.value === null && f4(r2, "Abstract property cannot have an initializer");
          }
          function q(T, r2) {
            let { esTreeNodeToTSNodeMap: K, tsNodeToESTreeNodeMap: Y } = r2.tsParseResult;
            k(T, (X) => {
              let p = K.get(X);
              if (!p)
                return;
              let Z3 = Y.get(p);
              Z3 === X && (P(p, Z3, Y), S2(p, Z3));
            });
          }
          m2.exports = { throwErrorForInvalidNodes: q };
        } }), d3 = l2({ "src/language-js/parse/postprocess/index.js"(d, m2) {
          "use strict";
          n2();
          var { locStart: k, locEnd: f4 } = h0(), P = l3(), S2 = c3(), q = s3(), T = m0(), { throwErrorForInvalidNodes: r2 } = a3(), K = b0();
          function Y(L, t2) {
            if (t2.parser === "typescript" && /@|abstract/.test(t2.originalText) && r2(L, t2), t2.parser !== "typescript" && t2.parser !== "flow" && t2.parser !== "acorn" && t2.parser !== "espree" && t2.parser !== "meriyah") {
              let J = /* @__PURE__ */ new Set();
              L = T(L, (H) => {
                H.leadingComments && H.leadingComments.some(S2) && J.add(k(H));
              }), L = T(L, (H) => {
                if (H.type === "ParenthesizedExpression") {
                  let { expression: I } = H;
                  if (I.type === "TypeCastExpression")
                    return I.range = H.range, I;
                  let u2 = k(H);
                  if (!J.has(u2))
                    return I.extra = Object.assign(Object.assign({}, I.extra), {}, { parenthesized: true }), I;
                }
              });
            }
            return L = T(L, (J) => {
              switch (J.type) {
                case "ChainExpression":
                  return X(J.expression);
                case "LogicalExpression": {
                  if (p(J))
                    return Z3(J);
                  break;
                }
                case "VariableDeclaration": {
                  let H = q(J.declarations);
                  H && H.init && V(J, H);
                  break;
                }
                case "TSParenthesizedType":
                  return P(J.typeAnnotation) || J.typeAnnotation.type === "TSThisType" || (J.typeAnnotation.range = [k(J), f4(J)]), J.typeAnnotation;
                case "TSTypeParameter":
                  if (typeof J.name == "string") {
                    let H = k(J);
                    J.name = { type: "Identifier", name: J.name, range: [H, H + J.name.length] };
                  }
                  break;
                case "ObjectExpression":
                  if (t2.parser === "typescript") {
                    let H = J.properties.find((I) => I.type === "Property" && I.value.type === "TSEmptyBodyFunctionExpression");
                    H && K(H.value, "Unexpected token.");
                  }
                  break;
                case "SequenceExpression": {
                  let H = q(J.expressions);
                  J.range = [k(J), Math.min(f4(H), f4(J))];
                  break;
                }
                case "TopicReference":
                  t2.__isUsingHackPipeline = true;
                  break;
                case "ExportAllDeclaration": {
                  let { exported: H } = J;
                  if (t2.parser === "meriyah" && H && H.type === "Identifier") {
                    let I = t2.originalText.slice(k(H), f4(H));
                    (I.startsWith('"') || I.startsWith("'")) && (J.exported = Object.assign(Object.assign({}, J.exported), {}, { type: "Literal", value: J.exported.name, raw: I }));
                  }
                  break;
                }
              }
            }), L;
            function V(J, H) {
              t2.originalText[f4(H)] !== ";" && (J.range = [k(J), f4(H)]);
            }
          }
          function X(L) {
            switch (L.type) {
              case "CallExpression":
                L.type = "OptionalCallExpression", L.callee = X(L.callee);
                break;
              case "MemberExpression":
                L.type = "OptionalMemberExpression", L.object = X(L.object);
                break;
              case "TSNonNullExpression":
                L.expression = X(L.expression);
                break;
            }
            return L;
          }
          function p(L) {
            return L.type === "LogicalExpression" && L.right.type === "LogicalExpression" && L.operator === L.right.operator;
          }
          function Z3(L) {
            return p(L) ? Z3({ type: "LogicalExpression", operator: L.operator, left: Z3({ type: "LogicalExpression", operator: L.operator, left: L.left, right: L.right.left, range: [k(L.left), f4(L.right.left)] }), right: L.right.right, range: [k(L), f4(L)] }) : L;
          }
          m2.exports = Y;
        } }), g3 = l2({ "node_modules/meriyah/dist/meriyah.cjs"(d) {
          "use strict";
          n2(), Object.defineProperty(d, "__esModule", { value: true });
          var m2 = { [0]: "Unexpected token", [28]: "Unexpected token: '%0'", [1]: "Octal escape sequences are not allowed in strict mode", [2]: "Octal escape sequences are not allowed in template strings", [3]: "Unexpected token `#`", [4]: "Illegal Unicode escape sequence", [5]: "Invalid code point %0", [6]: "Invalid hexadecimal escape sequence", [8]: "Octal literals are not allowed in strict mode", [7]: "Decimal integer literals with a leading zero are forbidden in strict mode", [9]: "Expected number in radix %0", [145]: "Invalid left-hand side assignment to a destructible right-hand side", [10]: "Non-number found after exponent indicator", [11]: "Invalid BigIntLiteral", [12]: "No identifiers allowed directly after numeric literal", [13]: "Escapes \\8 or \\9 are not syntactically valid escapes", [14]: "Unterminated string literal", [15]: "Unterminated template literal", [16]: "Multiline comment was not closed properly", [17]: "The identifier contained dynamic unicode escape that was not closed", [18]: "Illegal character '%0'", [19]: "Missing hexadecimal digits", [20]: "Invalid implicit octal", [21]: "Invalid line break in string literal", [22]: "Only unicode escapes are legal in identifier names", [23]: "Expected '%0'", [24]: "Invalid left-hand side in assignment", [25]: "Invalid left-hand side in async arrow", [26]: 'Calls to super must be in the "constructor" method of a class expression or class declaration that has a superclass', [27]: "Member access on super must be in a method", [29]: "Await expression not allowed in formal parameter", [30]: "Yield expression not allowed in formal parameter", [92]: "Unexpected token: 'escaped keyword'", [31]: "Unary expressions as the left operand of an exponentiation expression must be disambiguated with parentheses", [119]: "Async functions can only be declared at the top level or inside a block", [32]: "Unterminated regular expression", [33]: "Unexpected regular expression flag", [34]: "Duplicate regular expression flag '%0'", [35]: "%0 functions must have exactly %1 argument%2", [36]: "Setter function argument must not be a rest parameter", [37]: "%0 declaration must have a name in this context", [38]: "Function name may not contain any reserved words or be eval or arguments in strict mode", [39]: "The rest operator is missing an argument", [40]: "A getter cannot be a generator", [41]: "A computed property name must be followed by a colon or paren", [130]: "Object literal keys that are strings or numbers must be a method or have a colon", [43]: "Found `* async x(){}` but this should be `async * x(){}`", [42]: "Getters and setters can not be generators", [44]: "'%0' can not be generator method", [45]: "No line break is allowed after '=>'", [46]: "The left-hand side of the arrow can only be destructed through assignment", [47]: "The binding declaration is not destructible", [48]: "Async arrow can not be followed by new expression", [49]: "Classes may not have a static property named 'prototype'", [50]: "Class constructor may not be a %0", [51]: "Duplicate constructor method in class", [52]: "Invalid increment/decrement operand", [53]: "Invalid use of `new` keyword on an increment/decrement expression", [54]: "`=>` is an invalid assignment target", [55]: "Rest element may not have a trailing comma", [56]: "Missing initializer in %0 declaration", [57]: "'for-%0' loop head declarations can not have an initializer", [58]: "Invalid left-hand side in for-%0 loop: Must have a single binding", [59]: "Invalid shorthand property initializer", [60]: "Property name __proto__ appears more than once in object literal", [61]: "Let is disallowed as a lexically bound name", [62]: "Invalid use of '%0' inside new expression", [63]: "Illegal 'use strict' directive in function with non-simple parameter list", [64]: 'Identifier "let" disallowed as left-hand side expression in strict mode', [65]: "Illegal continue statement", [66]: "Illegal break statement", [67]: "Cannot have `let[...]` as a var name in strict mode", [68]: "Invalid destructuring assignment target", [69]: "Rest parameter may not have a default initializer", [70]: "The rest argument must the be last parameter", [71]: "Invalid rest argument", [73]: "In strict mode code, functions can only be declared at top level or inside a block", [74]: "In non-strict mode code, functions can only be declared at top level, inside a block, or as the body of an if statement", [75]: "Without web compatibility enabled functions can not be declared at top level, inside a block, or as the body of an if statement", [76]: "Class declaration can't appear in single-statement context", [77]: "Invalid left-hand side in for-%0", [78]: "Invalid assignment in for-%0", [79]: "for await (... of ...) is only valid in async functions and async generators", [80]: "The first token after the template expression should be a continuation of the template", [82]: "`let` declaration not allowed here and `let` cannot be a regular var name in strict mode", [81]: "`let \n [` is a restricted production at the start of a statement", [83]: "Catch clause requires exactly one parameter, not more (and no trailing comma)", [84]: "Catch clause parameter does not support default values", [85]: "Missing catch or finally after try", [86]: "More than one default clause in switch statement", [87]: "Illegal newline after throw", [88]: "Strict mode code may not include a with statement", [89]: "Illegal return statement", [90]: "The left hand side of the for-header binding declaration is not destructible", [91]: "new.target only allowed within functions", [93]: "'#' not followed by identifier", [99]: "Invalid keyword", [98]: "Can not use 'let' as a class name", [97]: "'A lexical declaration can't define a 'let' binding", [96]: "Can not use `let` as variable name in strict mode", [94]: "'%0' may not be used as an identifier in this context", [95]: "Await is only valid in async functions", [100]: "The %0 keyword can only be used with the module goal", [101]: "Unicode codepoint must not be greater than 0x10FFFF", [102]: "%0 source must be string", [103]: "Only a identifier can be used to indicate alias", [104]: "Only '*' or '{...}' can be imported after default", [105]: "Trailing decorator may be followed by method", [106]: "Decorators can't be used with a constructor", [108]: "HTML comments are only allowed with web compatibility (Annex B)", [109]: "The identifier 'let' must not be in expression position in strict mode", [110]: "Cannot assign to `eval` and `arguments` in strict mode", [111]: "The left-hand side of a for-of loop may not start with 'let'", [112]: "Block body arrows can not be immediately invoked without a group", [113]: "Block body arrows can not be immediately accessed without a group", [114]: "Unexpected strict mode reserved word", [115]: "Unexpected eval or arguments in strict mode", [116]: "Decorators must not be followed by a semicolon", [117]: "Calling delete on expression not allowed in strict mode", [118]: "Pattern can not have a tail", [120]: "Can not have a `yield` expression on the left side of a ternary", [121]: "An arrow function can not have a postfix update operator", [122]: "Invalid object literal key character after generator star", [123]: "Private fields can not be deleted", [125]: "Classes may not have a field called constructor", [124]: "Classes may not have a private element named constructor", [126]: "A class field initializer may not contain arguments", [127]: "Generators can only be declared at the top level or inside a block", [128]: "Async methods are a restricted production and cannot have a newline following it", [129]: "Unexpected character after object literal property name", [131]: "Invalid key token", [132]: "Label '%0' has already been declared", [133]: "continue statement must be nested within an iteration statement", [134]: "Undefined label '%0'", [135]: "Trailing comma is disallowed inside import(...) arguments", [136]: "import() requires exactly one argument", [137]: "Cannot use new with import(...)", [138]: "... is not allowed in import()", [139]: "Expected '=>'", [140]: "Duplicate binding '%0'", [141]: "Cannot export a duplicate name '%0'", [144]: "Duplicate %0 for-binding", [142]: "Exported binding '%0' needs to refer to a top-level declared variable", [143]: "Unexpected private field", [147]: "Numeric separators are not allowed at the end of numeric literals", [146]: "Only one underscore is allowed as numeric separator", [148]: "JSX value should be either an expression or a quoted JSX text", [149]: "Expected corresponding JSX closing tag for %0", [150]: "Adjacent JSX elements must be wrapped in an enclosing tag", [151]: "JSX attributes must only be assigned a non-empty 'expression'", [152]: "'%0' has already been declared", [153]: "'%0' shadowed a catch clause binding", [154]: "Dot property must be an identifier", [155]: "Encountered invalid input after spread/rest argument", [156]: "Catch without try", [157]: "Finally without try", [158]: "Expected corresponding closing tag for JSX fragment", [159]: "Coalescing and logical operators used together in the same expression must be disambiguated with parentheses", [160]: "Invalid tagged template on optional chain", [161]: "Invalid optional chain from super property", [162]: "Invalid optional chain from new expression", [163]: 'Cannot use "import.meta" outside a module', [164]: "Leading decorators must be attached to a class declaration" }, k = class extends SyntaxError {
            constructor(u, e2, i4, n) {
              for (var t4 = arguments.length, o = new Array(t4 > 4 ? t4 - 4 : 0), l = 4; l < t4; l++)
                o[l - 4] = arguments[l];
              let c = "[" + e2 + ":" + i4 + "]: " + m2[n].replace(/%(\d+)/g, (s4, h4) => o[h4]);
              super("".concat(c)), this.index = u, this.line = e2, this.column = i4, this.description = c, this.loc = { line: e2, column: i4 };
            }
          };
          function f4(u, e2) {
            for (var i4 = arguments.length, n = new Array(i4 > 2 ? i4 - 2 : 0), t4 = 2; t4 < i4; t4++)
              n[t4 - 2] = arguments[t4];
            throw new k(u.index, u.line, u.column, e2, ...n);
          }
          function P(u) {
            throw new k(u.index, u.line, u.column, u.type, u.params);
          }
          function S2(u, e2, i4, n) {
            for (var t4 = arguments.length, o = new Array(t4 > 4 ? t4 - 4 : 0), l = 4; l < t4; l++)
              o[l - 4] = arguments[l];
            throw new k(u, e2, i4, n, ...o);
          }
          function q(u, e2, i4, n) {
            throw new k(u, e2, i4, n);
          }
          var T = ((u, e2) => {
            let i4 = new Uint32Array(104448), n = 0, t4 = 0;
            for (; n < 3540; ) {
              let o = u[n++];
              if (o < 0)
                t4 -= o;
              else {
                let l = u[n++];
                o & 2 && (l = e2[l]), o & 1 ? i4.fill(l, t4, t4 += u[n++]) : i4[t4++] = l;
              }
            }
            return i4;
          })([-1, 2, 24, 2, 25, 2, 5, -1, 0, 77595648, 3, 44, 2, 3, 0, 14, 2, 57, 2, 58, 3, 0, 3, 0, 3168796671, 0, 4294956992, 2, 1, 2, 0, 2, 59, 3, 0, 4, 0, 4294966523, 3, 0, 4, 2, 16, 2, 60, 2, 0, 0, 4294836735, 0, 3221225471, 0, 4294901942, 2, 61, 0, 134152192, 3, 0, 2, 0, 4294951935, 3, 0, 2, 0, 2683305983, 0, 2684354047, 2, 17, 2, 0, 0, 4294961151, 3, 0, 2, 2, 19, 2, 0, 0, 608174079, 2, 0, 2, 131, 2, 6, 2, 56, -1, 2, 37, 0, 4294443263, 2, 1, 3, 0, 3, 0, 4294901711, 2, 39, 0, 4089839103, 0, 2961209759, 0, 1342439375, 0, 4294543342, 0, 3547201023, 0, 1577204103, 0, 4194240, 0, 4294688750, 2, 2, 0, 80831, 0, 4261478351, 0, 4294549486, 2, 2, 0, 2967484831, 0, 196559, 0, 3594373100, 0, 3288319768, 0, 8469959, 2, 194, 2, 3, 0, 3825204735, 0, 123747807, 0, 65487, 0, 4294828015, 0, 4092591615, 0, 1080049119, 0, 458703, 2, 3, 2, 0, 0, 2163244511, 0, 4227923919, 0, 4236247022, 2, 66, 0, 4284449919, 0, 851904, 2, 4, 2, 11, 0, 67076095, -1, 2, 67, 0, 1073741743, 0, 4093591391, -1, 0, 50331649, 0, 3265266687, 2, 32, 0, 4294844415, 0, 4278190047, 2, 18, 2, 129, -1, 3, 0, 2, 2, 21, 2, 0, 2, 9, 2, 0, 2, 14, 2, 15, 3, 0, 10, 2, 69, 2, 0, 2, 70, 2, 71, 2, 72, 2, 0, 2, 73, 2, 0, 2, 10, 0, 261632, 2, 23, 3, 0, 2, 2, 12, 2, 4, 3, 0, 18, 2, 74, 2, 5, 3, 0, 2, 2, 75, 0, 2088959, 2, 27, 2, 8, 0, 909311, 3, 0, 2, 0, 814743551, 2, 41, 0, 67057664, 3, 0, 2, 2, 40, 2, 0, 2, 28, 2, 0, 2, 29, 2, 7, 0, 268374015, 2, 26, 2, 49, 2, 0, 2, 76, 0, 134153215, -1, 2, 6, 2, 0, 2, 7, 0, 2684354559, 0, 67044351, 0, 3221160064, 0, 1, -1, 3, 0, 2, 2, 42, 0, 1046528, 3, 0, 3, 2, 8, 2, 0, 2, 51, 0, 4294960127, 2, 9, 2, 38, 2, 10, 0, 4294377472, 2, 11, 3, 0, 7, 0, 4227858431, 3, 0, 8, 2, 12, 2, 0, 2, 78, 2, 9, 2, 0, 2, 79, 2, 80, 2, 81, -1, 2, 124, 0, 1048577, 2, 82, 2, 13, -1, 2, 13, 0, 131042, 2, 83, 2, 84, 2, 85, 2, 0, 2, 33, -83, 2, 0, 2, 53, 2, 7, 3, 0, 4, 0, 1046559, 2, 0, 2, 14, 2, 0, 0, 2147516671, 2, 20, 3, 86, 2, 2, 0, -16, 2, 87, 0, 524222462, 2, 4, 2, 0, 0, 4269801471, 2, 4, 2, 0, 2, 15, 2, 77, 2, 16, 3, 0, 2, 2, 47, 2, 0, -1, 2, 17, -16, 3, 0, 206, -2, 3, 0, 655, 2, 18, 3, 0, 36, 2, 68, -1, 2, 17, 2, 9, 3, 0, 8, 2, 89, 2, 121, 2, 0, 0, 3220242431, 3, 0, 3, 2, 19, 2, 90, 2, 91, 3, 0, 2, 2, 92, 2, 0, 2, 93, 2, 94, 2, 0, 0, 4351, 2, 0, 2, 8, 3, 0, 2, 0, 67043391, 0, 3909091327, 2, 0, 2, 22, 2, 8, 2, 18, 3, 0, 2, 0, 67076097, 2, 7, 2, 0, 2, 20, 0, 67059711, 0, 4236247039, 3, 0, 2, 0, 939524103, 0, 8191999, 2, 97, 2, 98, 2, 15, 2, 21, 3, 0, 3, 0, 67057663, 3, 0, 349, 2, 99, 2, 100, 2, 6, -264, 3, 0, 11, 2, 22, 3, 0, 2, 2, 31, -1, 0, 3774349439, 2, 101, 2, 102, 3, 0, 2, 2, 19, 2, 103, 3, 0, 10, 2, 9, 2, 17, 2, 0, 2, 45, 2, 0, 2, 30, 2, 104, 2, 23, 0, 1638399, 2, 172, 2, 105, 3, 0, 3, 2, 18, 2, 24, 2, 25, 2, 5, 2, 26, 2, 0, 2, 7, 2, 106, -1, 2, 107, 2, 108, 2, 109, -1, 3, 0, 3, 2, 11, -2, 2, 0, 2, 27, -3, 2, 150, -4, 2, 18, 2, 0, 2, 35, 0, 1, 2, 0, 2, 62, 2, 28, 2, 11, 2, 9, 2, 0, 2, 110, -1, 3, 0, 4, 2, 9, 2, 21, 2, 111, 2, 6, 2, 0, 2, 112, 2, 0, 2, 48, -4, 3, 0, 9, 2, 20, 2, 29, 2, 30, -4, 2, 113, 2, 114, 2, 29, 2, 20, 2, 7, -2, 2, 115, 2, 29, 2, 31, -2, 2, 0, 2, 116, -2, 0, 4277137519, 0, 2269118463, -1, 3, 18, 2, -1, 2, 32, 2, 36, 2, 0, 3, 29, 2, 2, 34, 2, 19, -3, 3, 0, 2, 2, 33, -1, 2, 0, 2, 34, 2, 0, 2, 34, 2, 0, 2, 46, -10, 2, 0, 0, 203775, -2, 2, 18, 2, 43, 2, 35, -2, 2, 17, 2, 117, 2, 20, 3, 0, 2, 2, 36, 0, 2147549120, 2, 0, 2, 11, 2, 17, 2, 135, 2, 0, 2, 37, 2, 52, 0, 5242879, 3, 0, 2, 0, 402644511, -1, 2, 120, 0, 1090519039, -2, 2, 122, 2, 38, 2, 0, 0, 67045375, 2, 39, 0, 4226678271, 0, 3766565279, 0, 2039759, -4, 3, 0, 2, 0, 3288270847, 0, 3, 3, 0, 2, 0, 67043519, -5, 2, 0, 0, 4282384383, 0, 1056964609, -1, 3, 0, 2, 0, 67043345, -1, 2, 0, 2, 40, 2, 41, -1, 2, 10, 2, 42, -6, 2, 0, 2, 11, -3, 3, 0, 2, 0, 2147484671, 2, 125, 0, 4190109695, 2, 50, -2, 2, 126, 0, 4244635647, 0, 27, 2, 0, 2, 7, 2, 43, 2, 0, 2, 63, -1, 2, 0, 2, 40, -8, 2, 54, 2, 44, 0, 67043329, 2, 127, 2, 45, 0, 8388351, -2, 2, 128, 0, 3028287487, 2, 46, 2, 130, 0, 33259519, 2, 41, -9, 2, 20, -5, 2, 64, -2, 3, 0, 28, 2, 31, -3, 3, 0, 3, 2, 47, 3, 0, 6, 2, 48, -85, 3, 0, 33, 2, 47, -126, 3, 0, 18, 2, 36, -269, 3, 0, 17, 2, 40, 2, 7, 2, 41, -2, 2, 17, 2, 49, 2, 0, 2, 20, 2, 50, 2, 132, 2, 23, -21, 3, 0, 2, -4, 3, 0, 2, 0, 4294936575, 2, 0, 0, 4294934783, -2, 0, 196635, 3, 0, 191, 2, 51, 3, 0, 38, 2, 29, -1, 2, 33, -279, 3, 0, 8, 2, 7, -1, 2, 133, 2, 52, 3, 0, 11, 2, 6, -72, 3, 0, 3, 2, 134, 0, 1677656575, -166, 0, 4161266656, 0, 4071, 0, 15360, -4, 0, 28, -13, 3, 0, 2, 2, 37, 2, 0, 2, 136, 2, 137, 2, 55, 2, 0, 2, 138, 2, 139, 2, 140, 3, 0, 10, 2, 141, 2, 142, 2, 15, 3, 37, 2, 3, 53, 2, 3, 54, 2, 0, 4294954999, 2, 0, -16, 2, 0, 2, 88, 2, 0, 0, 2105343, 0, 4160749584, 0, 65534, -42, 0, 4194303871, 0, 2011, -6, 2, 0, 0, 1073684479, 0, 17407, -11, 2, 0, 2, 31, -40, 3, 0, 6, 0, 8323103, -1, 3, 0, 2, 2, 42, -37, 2, 55, 2, 144, 2, 145, 2, 146, 2, 147, 2, 148, -105, 2, 24, -32, 3, 0, 1334, 2, 9, -1, 3, 0, 129, 2, 27, 3, 0, 6, 2, 9, 3, 0, 180, 2, 149, 3, 0, 233, 0, 1, -96, 3, 0, 16, 2, 9, -47, 3, 0, 154, 2, 56, -22381, 3, 0, 7, 2, 23, -6130, 3, 5, 2, -1, 0, 69207040, 3, 44, 2, 3, 0, 14, 2, 57, 2, 58, -3, 0, 3168731136, 0, 4294956864, 2, 1, 2, 0, 2, 59, 3, 0, 4, 0, 4294966275, 3, 0, 4, 2, 16, 2, 60, 2, 0, 2, 33, -1, 2, 17, 2, 61, -1, 2, 0, 2, 56, 0, 4294885376, 3, 0, 2, 0, 3145727, 0, 2617294944, 0, 4294770688, 2, 23, 2, 62, 3, 0, 2, 0, 131135, 2, 95, 0, 70256639, 0, 71303167, 0, 272, 2, 40, 2, 56, -1, 2, 37, 2, 30, -1, 2, 96, 2, 63, 0, 4278255616, 0, 4294836227, 0, 4294549473, 0, 600178175, 0, 2952806400, 0, 268632067, 0, 4294543328, 0, 57540095, 0, 1577058304, 0, 1835008, 0, 4294688736, 2, 65, 2, 64, 0, 33554435, 2, 123, 2, 65, 2, 151, 0, 131075, 0, 3594373096, 0, 67094296, 2, 64, -1, 0, 4294828e3, 0, 603979263, 2, 160, 0, 3, 0, 4294828001, 0, 602930687, 2, 183, 0, 393219, 0, 4294828016, 0, 671088639, 0, 2154840064, 0, 4227858435, 0, 4236247008, 2, 66, 2, 36, -1, 2, 4, 0, 917503, 2, 36, -1, 2, 67, 0, 537788335, 0, 4026531935, -1, 0, 1, -1, 2, 32, 2, 68, 0, 7936, -3, 2, 0, 0, 2147485695, 0, 1010761728, 0, 4292984930, 0, 16387, 2, 0, 2, 14, 2, 15, 3, 0, 10, 2, 69, 2, 0, 2, 70, 2, 71, 2, 72, 2, 0, 2, 73, 2, 0, 2, 11, -1, 2, 23, 3, 0, 2, 2, 12, 2, 4, 3, 0, 18, 2, 74, 2, 5, 3, 0, 2, 2, 75, 0, 253951, 3, 19, 2, 0, 122879, 2, 0, 2, 8, 0, 276824064, -2, 3, 0, 2, 2, 40, 2, 0, 0, 4294903295, 2, 0, 2, 29, 2, 7, -1, 2, 17, 2, 49, 2, 0, 2, 76, 2, 41, -1, 2, 20, 2, 0, 2, 27, -2, 0, 128, -2, 2, 77, 2, 8, 0, 4064, -1, 2, 119, 0, 4227907585, 2, 0, 2, 118, 2, 0, 2, 48, 2, 173, 2, 9, 2, 38, 2, 10, -1, 0, 74440192, 3, 0, 6, -2, 3, 0, 8, 2, 12, 2, 0, 2, 78, 2, 9, 2, 0, 2, 79, 2, 80, 2, 81, -3, 2, 82, 2, 13, -3, 2, 83, 2, 84, 2, 85, 2, 0, 2, 33, -83, 2, 0, 2, 53, 2, 7, 3, 0, 4, 0, 817183, 2, 0, 2, 14, 2, 0, 0, 33023, 2, 20, 3, 86, 2, -17, 2, 87, 0, 524157950, 2, 4, 2, 0, 2, 88, 2, 4, 2, 0, 2, 15, 2, 77, 2, 16, 3, 0, 2, 2, 47, 2, 0, -1, 2, 17, -16, 3, 0, 206, -2, 3, 0, 655, 2, 18, 3, 0, 36, 2, 68, -1, 2, 17, 2, 9, 3, 0, 8, 2, 89, 0, 3072, 2, 0, 0, 2147516415, 2, 9, 3, 0, 2, 2, 23, 2, 90, 2, 91, 3, 0, 2, 2, 92, 2, 0, 2, 93, 2, 94, 0, 4294965179, 0, 7, 2, 0, 2, 8, 2, 91, 2, 8, -1, 0, 1761345536, 2, 95, 0, 4294901823, 2, 36, 2, 18, 2, 96, 2, 34, 2, 166, 0, 2080440287, 2, 0, 2, 33, 2, 143, 0, 3296722943, 2, 0, 0, 1046675455, 0, 939524101, 0, 1837055, 2, 97, 2, 98, 2, 15, 2, 21, 3, 0, 3, 0, 7, 3, 0, 349, 2, 99, 2, 100, 2, 6, -264, 3, 0, 11, 2, 22, 3, 0, 2, 2, 31, -1, 0, 2700607615, 2, 101, 2, 102, 3, 0, 2, 2, 19, 2, 103, 3, 0, 10, 2, 9, 2, 17, 2, 0, 2, 45, 2, 0, 2, 30, 2, 104, -3, 2, 105, 3, 0, 3, 2, 18, -1, 3, 5, 2, 2, 26, 2, 0, 2, 7, 2, 106, -1, 2, 107, 2, 108, 2, 109, -1, 3, 0, 3, 2, 11, -2, 2, 0, 2, 27, -8, 2, 18, 2, 0, 2, 35, -1, 2, 0, 2, 62, 2, 28, 2, 29, 2, 9, 2, 0, 2, 110, -1, 3, 0, 4, 2, 9, 2, 17, 2, 111, 2, 6, 2, 0, 2, 112, 2, 0, 2, 48, -4, 3, 0, 9, 2, 20, 2, 29, 2, 30, -4, 2, 113, 2, 114, 2, 29, 2, 20, 2, 7, -2, 2, 115, 2, 29, 2, 31, -2, 2, 0, 2, 116, -2, 0, 4277075969, 2, 29, -1, 3, 18, 2, -1, 2, 32, 2, 117, 2, 0, 3, 29, 2, 2, 34, 2, 19, -3, 3, 0, 2, 2, 33, -1, 2, 0, 2, 34, 2, 0, 2, 34, 2, 0, 2, 48, -10, 2, 0, 0, 197631, -2, 2, 18, 2, 43, 2, 118, -2, 2, 17, 2, 117, 2, 20, 2, 119, 2, 51, -2, 2, 119, 2, 23, 2, 17, 2, 33, 2, 119, 2, 36, 0, 4294901904, 0, 4718591, 2, 119, 2, 34, 0, 335544350, -1, 2, 120, 2, 121, -2, 2, 122, 2, 38, 2, 7, -1, 2, 123, 2, 65, 0, 3758161920, 0, 3, -4, 2, 0, 2, 27, 0, 2147485568, 0, 3, 2, 0, 2, 23, 0, 176, -5, 2, 0, 2, 47, 2, 186, -1, 2, 0, 2, 23, 2, 197, -1, 2, 0, 0, 16779263, -2, 2, 11, -7, 2, 0, 2, 121, -3, 3, 0, 2, 2, 124, 2, 125, 0, 2147549183, 0, 2, -2, 2, 126, 2, 35, 0, 10, 0, 4294965249, 0, 67633151, 0, 4026597376, 2, 0, 0, 536871935, -1, 2, 0, 2, 40, -8, 2, 54, 2, 47, 0, 1, 2, 127, 2, 23, -3, 2, 128, 2, 35, 2, 129, 2, 130, 0, 16778239, -10, 2, 34, -5, 2, 64, -2, 3, 0, 28, 2, 31, -3, 3, 0, 3, 2, 47, 3, 0, 6, 2, 48, -85, 3, 0, 33, 2, 47, -126, 3, 0, 18, 2, 36, -269, 3, 0, 17, 2, 40, 2, 7, -3, 2, 17, 2, 131, 2, 0, 2, 23, 2, 48, 2, 132, 2, 23, -21, 3, 0, 2, -4, 3, 0, 2, 0, 67583, -1, 2, 103, -2, 0, 11, 3, 0, 191, 2, 51, 3, 0, 38, 2, 29, -1, 2, 33, -279, 3, 0, 8, 2, 7, -1, 2, 133, 2, 52, 3, 0, 11, 2, 6, -72, 3, 0, 3, 2, 134, 2, 135, -187, 3, 0, 2, 2, 37, 2, 0, 2, 136, 2, 137, 2, 55, 2, 0, 2, 138, 2, 139, 2, 140, 3, 0, 10, 2, 141, 2, 142, 2, 15, 3, 37, 2, 3, 53, 2, 3, 54, 2, 2, 143, -73, 2, 0, 0, 1065361407, 0, 16384, -11, 2, 0, 2, 121, -40, 3, 0, 6, 2, 117, -1, 3, 0, 2, 0, 2063, -37, 2, 55, 2, 144, 2, 145, 2, 146, 2, 147, 2, 148, -138, 3, 0, 1334, 2, 9, -1, 3, 0, 129, 2, 27, 3, 0, 6, 2, 9, 3, 0, 180, 2, 149, 3, 0, 233, 0, 1, -96, 3, 0, 16, 2, 9, -47, 3, 0, 154, 2, 56, -28517, 2, 0, 0, 1, -1, 2, 124, 2, 0, 0, 8193, -21, 2, 193, 0, 10255, 0, 4, -11, 2, 64, 2, 171, -1, 0, 71680, -1, 2, 161, 0, 4292900864, 0, 805306431, -5, 2, 150, -1, 2, 157, -1, 0, 6144, -2, 2, 127, -1, 2, 154, -1, 0, 2147532800, 2, 151, 2, 165, 2, 0, 2, 164, 0, 524032, 0, 4, -4, 2, 190, 0, 205128192, 0, 1333757536, 0, 2147483696, 0, 423953, 0, 747766272, 0, 2717763192, 0, 4286578751, 0, 278545, 2, 152, 0, 4294886464, 0, 33292336, 0, 417809, 2, 152, 0, 1327482464, 0, 4278190128, 0, 700594195, 0, 1006647527, 0, 4286497336, 0, 4160749631, 2, 153, 0, 469762560, 0, 4171219488, 0, 8323120, 2, 153, 0, 202375680, 0, 3214918176, 0, 4294508592, 2, 153, -1, 0, 983584, 0, 48, 0, 58720273, 0, 3489923072, 0, 10517376, 0, 4293066815, 0, 1, 0, 2013265920, 2, 177, 2, 0, 0, 2089, 0, 3221225552, 0, 201375904, 2, 0, -2, 0, 256, 0, 122880, 0, 16777216, 2, 150, 0, 4160757760, 2, 0, -6, 2, 167, -11, 0, 3263218176, -1, 0, 49664, 0, 2160197632, 0, 8388802, -1, 0, 12713984, -1, 2, 154, 2, 159, 2, 178, -2, 2, 162, -20, 0, 3758096385, -2, 2, 155, 0, 4292878336, 2, 90, 2, 169, 0, 4294057984, -2, 2, 163, 2, 156, 2, 175, -2, 2, 155, -1, 2, 182, -1, 2, 170, 2, 124, 0, 4026593280, 0, 14, 0, 4292919296, -1, 2, 158, 0, 939588608, -1, 0, 805306368, -1, 2, 124, 0, 1610612736, 2, 156, 2, 157, 2, 4, 2, 0, -2, 2, 158, 2, 159, -3, 0, 267386880, -1, 2, 160, 0, 7168, -1, 0, 65024, 2, 154, 2, 161, 2, 179, -7, 2, 168, -8, 2, 162, -1, 0, 1426112704, 2, 163, -1, 2, 164, 0, 271581216, 0, 2149777408, 2, 23, 2, 161, 2, 124, 0, 851967, 2, 180, -1, 2, 23, 2, 181, -4, 2, 158, -20, 2, 195, 2, 165, -56, 0, 3145728, 2, 185, -4, 2, 166, 2, 124, -4, 0, 32505856, -1, 2, 167, -1, 0, 2147385088, 2, 90, 1, 2155905152, 2, -3, 2, 103, 2, 0, 2, 168, -2, 2, 169, -6, 2, 170, 0, 4026597375, 0, 1, -1, 0, 1, -1, 2, 171, -3, 2, 117, 2, 64, -2, 2, 166, -2, 2, 176, 2, 124, -878, 2, 159, -36, 2, 172, -1, 2, 201, -10, 2, 188, -5, 2, 174, -6, 0, 4294965251, 2, 27, -1, 2, 173, -1, 2, 174, -2, 0, 4227874752, -3, 0, 2146435072, 2, 159, -2, 0, 1006649344, 2, 124, -1, 2, 90, 0, 201375744, -3, 0, 134217720, 2, 90, 0, 4286677377, 0, 32896, -1, 2, 158, -3, 2, 175, -349, 2, 176, 0, 1920, 2, 177, 3, 0, 264, -11, 2, 157, -2, 2, 178, 2, 0, 0, 520617856, 0, 2692743168, 0, 36, -3, 0, 524284, -11, 2, 23, -1, 2, 187, -1, 2, 184, 0, 3221291007, 2, 178, -1, 2, 202, 0, 2158720, -3, 2, 159, 0, 1, -4, 2, 124, 0, 3808625411, 0, 3489628288, 2, 200, 0, 1207959680, 0, 3221274624, 2, 0, -3, 2, 179, 0, 120, 0, 7340032, -2, 2, 180, 2, 4, 2, 23, 2, 163, 3, 0, 4, 2, 159, -1, 2, 181, 2, 177, -1, 0, 8176, 2, 182, 2, 179, 2, 183, -1, 0, 4290773232, 2, 0, -4, 2, 163, 2, 189, 0, 15728640, 2, 177, -1, 2, 161, -1, 0, 4294934512, 3, 0, 4, -9, 2, 90, 2, 170, 2, 184, 3, 0, 4, 0, 704, 0, 1849688064, 2, 185, -1, 2, 124, 0, 4294901887, 2, 0, 0, 130547712, 0, 1879048192, 2, 199, 3, 0, 2, -1, 2, 186, 2, 187, -1, 0, 17829776, 0, 2025848832, 0, 4261477888, -2, 2, 0, -1, 0, 4286580608, -1, 0, 29360128, 2, 192, 0, 16252928, 0, 3791388672, 2, 38, 3, 0, 2, -2, 2, 196, 2, 0, -1, 2, 103, -1, 0, 66584576, -1, 2, 191, 3, 0, 9, 2, 124, -1, 0, 4294755328, 3, 0, 2, -1, 2, 161, 2, 178, 3, 0, 2, 2, 23, 2, 188, 2, 90, -2, 0, 245760, 0, 2147418112, -1, 2, 150, 2, 203, 0, 4227923456, -1, 2, 164, 2, 161, 2, 90, -3, 0, 4292870145, 0, 262144, 2, 124, 3, 0, 2, 0, 1073758848, 2, 189, -1, 0, 4227921920, 2, 190, 0, 68289024, 0, 528402016, 0, 4292927536, 3, 0, 4, -2, 0, 268435456, 2, 91, -2, 2, 191, 3, 0, 5, -1, 2, 192, 2, 163, 2, 0, -2, 0, 4227923936, 2, 62, -1, 2, 155, 2, 95, 2, 0, 2, 154, 2, 158, 3, 0, 6, -1, 2, 177, 3, 0, 3, -2, 0, 2146959360, 0, 9440640, 0, 104857600, 0, 4227923840, 3, 0, 2, 0, 768, 2, 193, 2, 77, -2, 2, 161, -2, 2, 119, -1, 2, 155, 3, 0, 8, 0, 512, 0, 8388608, 2, 194, 2, 172, 2, 187, 0, 4286578944, 3, 0, 2, 0, 1152, 0, 1266679808, 2, 191, 0, 576, 0, 4261707776, 2, 95, 3, 0, 9, 2, 155, 3, 0, 5, 2, 16, -1, 0, 2147221504, -28, 2, 178, 3, 0, 3, -3, 0, 4292902912, -6, 2, 96, 3, 0, 85, -33, 0, 4294934528, 3, 0, 126, -18, 2, 195, 3, 0, 269, -17, 2, 155, 2, 124, 2, 198, 3, 0, 2, 2, 23, 0, 4290822144, -2, 0, 67174336, 0, 520093700, 2, 17, 3, 0, 21, -2, 2, 179, 3, 0, 3, -2, 0, 30720, -1, 0, 32512, 3, 0, 2, 0, 4294770656, -191, 2, 174, -38, 2, 170, 2, 0, 2, 196, 3, 0, 279, -8, 2, 124, 2, 0, 0, 4294508543, 0, 65295, -11, 2, 177, 3, 0, 72, -3, 0, 3758159872, 0, 201391616, 3, 0, 155, -7, 2, 170, -1, 0, 384, -1, 0, 133693440, -3, 2, 196, -2, 2, 26, 3, 0, 4, 2, 169, -2, 2, 90, 2, 155, 3, 0, 4, -2, 2, 164, -1, 2, 150, 0, 335552923, 2, 197, -1, 0, 538974272, 0, 2214592512, 0, 132e3, -10, 0, 192, -8, 0, 12288, -21, 0, 134213632, 0, 4294901761, 3, 0, 42, 0, 100663424, 0, 4294965284, 3, 0, 6, -1, 0, 3221282816, 2, 198, 3, 0, 11, -1, 2, 199, 3, 0, 40, -6, 0, 4286578784, 2, 0, -2, 0, 1006694400, 3, 0, 24, 2, 35, -1, 2, 94, 3, 0, 2, 0, 1, 2, 163, 3, 0, 6, 2, 197, 0, 4110942569, 0, 1432950139, 0, 2701658217, 0, 4026532864, 0, 4026532881, 2, 0, 2, 45, 3, 0, 8, -1, 2, 158, -2, 2, 169, 0, 98304, 0, 65537, 2, 170, -5, 0, 4294950912, 2, 0, 2, 118, 0, 65528, 2, 177, 0, 4294770176, 2, 26, 3, 0, 4, -30, 2, 174, 0, 3758153728, -3, 2, 169, -2, 2, 155, 2, 188, 2, 158, -1, 2, 191, -1, 2, 161, 0, 4294754304, 3, 0, 2, -3, 0, 33554432, -2, 2, 200, -3, 2, 169, 0, 4175478784, 2, 201, 0, 4286643712, 0, 4286644216, 2, 0, -4, 2, 202, -1, 2, 165, 0, 4227923967, 3, 0, 32, -1334, 2, 163, 2, 0, -129, 2, 94, -6, 2, 163, -180, 2, 203, -233, 2, 4, 3, 0, 96, -16, 2, 163, 3, 0, 47, -154, 2, 165, 3, 0, 22381, -7, 2, 17, 3, 0, 6128], [4294967295, 4294967291, 4092460543, 4294828031, 4294967294, 134217726, 268435455, 2147483647, 1048575, 1073741823, 3892314111, 134217727, 1061158911, 536805376, 4294910143, 4160749567, 4294901759, 4294901760, 536870911, 262143, 8388607, 4294902783, 4294918143, 65535, 67043328, 2281701374, 4294967232, 2097151, 4294903807, 4194303, 255, 67108863, 4294967039, 511, 524287, 131071, 127, 4292870143, 4294902271, 4294549487, 33554431, 1023, 67047423, 4294901888, 4286578687, 4294770687, 67043583, 32767, 15, 2047999, 67043343, 16777215, 4294902e3, 4294934527, 4294966783, 4294967279, 2047, 262083, 20511, 4290772991, 41943039, 493567, 4294959104, 603979775, 65536, 602799615, 805044223, 4294965206, 8191, 1031749119, 4294917631, 2134769663, 4286578493, 4282253311, 4294942719, 33540095, 4294905855, 4294967264, 2868854591, 1608515583, 265232348, 534519807, 2147614720, 1060109444, 4093640016, 17376, 2139062143, 224, 4169138175, 4294909951, 4286578688, 4294967292, 4294965759, 2044, 4292870144, 4294966272, 4294967280, 8289918, 4294934399, 4294901775, 4294965375, 1602223615, 4294967259, 4294443008, 268369920, 4292804608, 486341884, 4294963199, 3087007615, 1073692671, 4128527, 4279238655, 4294902015, 4294966591, 2445279231, 3670015, 3238002687, 31, 63, 4294967288, 4294705151, 4095, 3221208447, 4294549472, 2147483648, 4285526655, 4294966527, 4294705152, 4294966143, 64, 4294966719, 16383, 3774873592, 458752, 536807423, 67043839, 3758096383, 3959414372, 3755993023, 2080374783, 4294835295, 4294967103, 4160749565, 4087, 184024726, 2862017156, 1593309078, 268434431, 268434414, 4294901763, 536870912, 2952790016, 202506752, 139264, 402653184, 4261412864, 4227922944, 49152, 61440, 3758096384, 117440512, 65280, 3233808384, 3221225472, 2097152, 4294965248, 32768, 57152, 67108864, 4293918720, 4290772992, 25165824, 57344, 4227915776, 4278190080, 4227907584, 65520, 4026531840, 4227858432, 4160749568, 3758129152, 4294836224, 63488, 1073741824, 4294967040, 4194304, 251658240, 196608, 4294963200, 64512, 417808, 4227923712, 12582912, 50331648, 65472, 4294967168, 4294966784, 16, 4294917120, 2080374784, 4096, 65408, 524288, 65532]);
          function r2(u) {
            return u.column++, u.currentChar = u.source.charCodeAt(++u.index);
          }
          function K(u, e2) {
            if ((e2 & 64512) !== 55296)
              return 0;
            let i4 = u.source.charCodeAt(u.index + 1);
            return (i4 & 64512) !== 56320 ? 0 : (e2 = u.currentChar = 65536 + ((e2 & 1023) << 10) + (i4 & 1023), (T[(e2 >>> 5) + 0] >>> e2 & 31 & 1) === 0 && f4(u, 18, Z3(e2)), u.index++, u.column++, 1);
          }
          function Y(u, e2) {
            u.currentChar = u.source.charCodeAt(++u.index), u.flags |= 1, (e2 & 4) === 0 && (u.column = 0, u.line++);
          }
          function X(u) {
            u.flags |= 1, u.currentChar = u.source.charCodeAt(++u.index), u.column = 0, u.line++;
          }
          function p(u) {
            return u === 160 || u === 65279 || u === 133 || u === 5760 || u >= 8192 && u <= 8203 || u === 8239 || u === 8287 || u === 12288 || u === 8201 || u === 65519;
          }
          function Z3(u) {
            return u <= 65535 ? String.fromCharCode(u) : String.fromCharCode(u >>> 10) + String.fromCharCode(u & 1023);
          }
          function L(u) {
            return u < 65 ? u - 48 : u - 65 + 10 & 15;
          }
          function t2(u) {
            switch (u) {
              case 134283266:
                return "NumericLiteral";
              case 134283267:
                return "StringLiteral";
              case 86021:
              case 86022:
                return "BooleanLiteral";
              case 86023:
                return "NullLiteral";
              case 65540:
                return "RegularExpression";
              case 67174408:
              case 67174409:
              case 132:
                return "TemplateLiteral";
              default:
                return (u & 143360) === 143360 ? "Identifier" : (u & 4096) === 4096 ? "Keyword" : "Punctuator";
            }
          }
          var V = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1032, 0, 0, 2056, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 8192, 0, 3, 0, 0, 8192, 0, 0, 0, 256, 0, 33024, 0, 0, 242, 242, 114, 114, 114, 114, 114, 114, 594, 594, 0, 0, 16384, 0, 0, 0, 0, 67, 67, 67, 67, 67, 67, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 1, 0, 0, 4099, 0, 71, 71, 71, 71, 71, 71, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 16384, 0, 0, 0, 0], J = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0], H = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0];
          function I(u) {
            return u <= 127 ? J[u] : T[(u >>> 5) + 34816] >>> u & 31 & 1;
          }
          function u2(u) {
            return u <= 127 ? H[u] : T[(u >>> 5) + 0] >>> u & 31 & 1 || u === 8204 || u === 8205;
          }
          var m22 = ["SingleLine", "MultiLine", "HTMLOpen", "HTMLClose", "HashbangComment"];
          function c2(u) {
            let e2 = u.source;
            u.currentChar === 35 && e2.charCodeAt(u.index + 1) === 33 && (r2(u), r2(u), s2(u, e2, 0, 4, u.tokenPos, u.linePos, u.colPos));
          }
          function R2(u, e2, i4, n, t4, o, l, c) {
            return n & 2048 && f4(u, 0), s2(u, e2, i4, t4, o, l, c);
          }
          function s2(u, e2, i4, n, t4, o, l) {
            let { index: c } = u;
            for (u.tokenPos = u.index, u.linePos = u.line, u.colPos = u.column; u.index < u.end; ) {
              if (V[u.currentChar] & 8) {
                let s4 = u.currentChar === 13;
                X(u), s4 && u.index < u.end && u.currentChar === 10 && (u.currentChar = e2.charCodeAt(++u.index));
                break;
              } else if ((u.currentChar ^ 8232) <= 1) {
                X(u);
                break;
              }
              r2(u), u.tokenPos = u.index, u.linePos = u.line, u.colPos = u.column;
            }
            if (u.onComment) {
              let s4 = { start: { line: o, column: l }, end: { line: u.linePos, column: u.colPos } };
              u.onComment(m22[n & 255], e2.slice(c, u.tokenPos), t4, u.tokenPos, s4);
            }
            return i4 | 1;
          }
          function N2(u, e2, i4) {
            let { index: n } = u;
            for (; u.index < u.end; )
              if (u.currentChar < 43) {
                let t4 = false;
                for (; u.currentChar === 42; )
                  if (t4 || (i4 &= -5, t4 = true), r2(u) === 47) {
                    if (r2(u), u.onComment) {
                      let o = { start: { line: u.linePos, column: u.colPos }, end: { line: u.line, column: u.column } };
                      u.onComment(m22[1], e2.slice(n, u.index - 2), n - 2, u.index, o);
                    }
                    return u.tokenPos = u.index, u.linePos = u.line, u.colPos = u.column, i4;
                  }
                if (t4)
                  continue;
                V[u.currentChar] & 8 ? u.currentChar === 13 ? (i4 |= 5, X(u)) : (Y(u, i4), i4 = i4 & -5 | 1) : r2(u);
              } else
                (u.currentChar ^ 8232) <= 1 ? (i4 = i4 & -5 | 1, X(u)) : (i4 &= -5, r2(u));
            f4(u, 16);
          }
          function w2(u, e2) {
            let i4 = u.index, n = 0;
            u:
              for (; ; ) {
                let b = u.currentChar;
                if (r2(u), n & 1)
                  n &= -2;
                else
                  switch (b) {
                    case 47:
                      if (n)
                        break;
                      break u;
                    case 92:
                      n |= 1;
                      break;
                    case 91:
                      n |= 2;
                      break;
                    case 93:
                      n &= 1;
                      break;
                    case 13:
                    case 10:
                    case 8232:
                    case 8233:
                      f4(u, 32);
                  }
                if (u.index >= u.source.length)
                  return f4(u, 32);
              }
            let t4 = u.index - 1, o = 0, l = u.currentChar, { index: c } = u;
            for (; u2(l); ) {
              switch (l) {
                case 103:
                  o & 2 && f4(u, 34, "g"), o |= 2;
                  break;
                case 105:
                  o & 1 && f4(u, 34, "i"), o |= 1;
                  break;
                case 109:
                  o & 4 && f4(u, 34, "m"), o |= 4;
                  break;
                case 117:
                  o & 16 && f4(u, 34, "g"), o |= 16;
                  break;
                case 121:
                  o & 8 && f4(u, 34, "y"), o |= 8;
                  break;
                case 115:
                  o & 32 && f4(u, 34, "s"), o |= 32;
                  break;
                default:
                  f4(u, 33);
              }
              l = r2(u);
            }
            let s4 = u.source.slice(c, u.index), h4 = u.source.slice(i4, t4);
            return u.tokenRegExp = { pattern: h4, flags: s4 }, e2 & 512 && (u.tokenRaw = u.source.slice(u.tokenPos, u.index)), u.tokenValue = O1(u, h4, s4), 65540;
          }
          function O1(u, e2, i4) {
            try {
              return new RegExp(e2, i4);
            } catch {
              f4(u, 32);
            }
          }
          function I1(u, e2, i4) {
            let { index: n } = u, t4 = "", o = r2(u), l = u.index;
            for (; (V[o] & 8) === 0; ) {
              if (o === i4)
                return t4 += u.source.slice(l, u.index), r2(u), e2 & 512 && (u.tokenRaw = u.source.slice(n, u.index)), u.tokenValue = t4, 134283267;
              if ((o & 8) === 8 && o === 92) {
                if (t4 += u.source.slice(l, u.index), o = r2(u), o < 127 || o === 8232 || o === 8233) {
                  let c = g2(u, e2, o);
                  c >= 0 ? t4 += Z3(c) : n1(u, c, 0);
                } else
                  t4 += Z3(o);
                l = u.index + 1;
              }
              u.index >= u.end && f4(u, 14), o = r2(u);
            }
            f4(u, 14);
          }
          function g2(u, e2, i4) {
            switch (i4) {
              case 98:
                return 8;
              case 102:
                return 12;
              case 114:
                return 13;
              case 110:
                return 10;
              case 116:
                return 9;
              case 118:
                return 11;
              case 13:
                if (u.index < u.end) {
                  let n = u.source.charCodeAt(u.index + 1);
                  n === 10 && (u.index = u.index + 1, u.currentChar = n);
                }
              case 10:
              case 8232:
              case 8233:
                return u.column = -1, u.line++, -1;
              case 48:
              case 49:
              case 50:
              case 51: {
                let n = i4 - 48, t4 = u.index + 1, o = u.column + 1;
                if (t4 < u.end) {
                  let l = u.source.charCodeAt(t4);
                  if ((V[l] & 32) === 0) {
                    if ((n !== 0 || V[l] & 512) && e2 & 1024)
                      return -2;
                  } else {
                    if (e2 & 1024)
                      return -2;
                    if (u.currentChar = l, n = n << 3 | l - 48, t4++, o++, t4 < u.end) {
                      let c = u.source.charCodeAt(t4);
                      V[c] & 32 && (u.currentChar = c, n = n << 3 | c - 48, t4++, o++);
                    }
                    u.flags |= 64, u.index = t4 - 1, u.column = o - 1;
                  }
                }
                return n;
              }
              case 52:
              case 53:
              case 54:
              case 55: {
                if (e2 & 1024)
                  return -2;
                let n = i4 - 48, t4 = u.index + 1, o = u.column + 1;
                if (t4 < u.end) {
                  let l = u.source.charCodeAt(t4);
                  V[l] & 32 && (n = n << 3 | l - 48, u.currentChar = l, u.index = t4, u.column = o);
                }
                return u.flags |= 64, n;
              }
              case 120: {
                let n = r2(u);
                if ((V[n] & 64) === 0)
                  return -4;
                let t4 = L(n), o = r2(u);
                if ((V[o] & 64) === 0)
                  return -4;
                let l = L(o);
                return t4 << 4 | l;
              }
              case 117: {
                let n = r2(u);
                if (u.currentChar === 123) {
                  let t4 = 0;
                  for (; (V[r2(u)] & 64) !== 0; )
                    if (t4 = t4 << 4 | L(u.currentChar), t4 > 1114111)
                      return -5;
                  return u.currentChar < 1 || u.currentChar !== 125 ? -4 : t4;
                } else {
                  if ((V[n] & 64) === 0)
                    return -4;
                  let t4 = u.source.charCodeAt(u.index + 1);
                  if ((V[t4] & 64) === 0)
                    return -4;
                  let o = u.source.charCodeAt(u.index + 2);
                  if ((V[o] & 64) === 0)
                    return -4;
                  let l = u.source.charCodeAt(u.index + 3);
                  return (V[l] & 64) === 0 ? -4 : (u.index += 3, u.column += 3, u.currentChar = u.source.charCodeAt(u.index), L(n) << 12 | L(t4) << 8 | L(o) << 4 | L(l));
                }
              }
              case 56:
              case 57:
                if ((e2 & 256) === 0)
                  return -3;
              default:
                return i4;
            }
          }
          function n1(u, e2, i4) {
            switch (e2) {
              case -1:
                return;
              case -2:
                f4(u, i4 ? 2 : 1);
              case -3:
                f4(u, 13);
              case -4:
                f4(u, 6);
              case -5:
                f4(u, 101);
            }
          }
          function Ju(u, e2) {
            let { index: i4 } = u, n = 67174409, t4 = "", o = r2(u);
            for (; o !== 96; ) {
              if (o === 36 && u.source.charCodeAt(u.index + 1) === 123) {
                r2(u), n = 67174408;
                break;
              } else if ((o & 8) === 8 && o === 92)
                if (o = r2(u), o > 126)
                  t4 += Z3(o);
                else {
                  let l = g2(u, e2 | 1024, o);
                  if (l >= 0)
                    t4 += Z3(l);
                  else if (l !== -1 && e2 & 65536) {
                    t4 = void 0, o = r0(u, o), o < 0 && (n = 67174408);
                    break;
                  } else
                    n1(u, l, 1);
                }
              else
                u.index < u.end && o === 13 && u.source.charCodeAt(u.index) === 10 && (t4 += Z3(o), u.currentChar = u.source.charCodeAt(++u.index)), ((o & 83) < 3 && o === 10 || (o ^ 8232) <= 1) && (u.column = -1, u.line++), t4 += Z3(o);
              u.index >= u.end && f4(u, 15), o = r2(u);
            }
            return r2(u), u.tokenValue = t4, u.tokenRaw = u.source.slice(i4 + 1, u.index - (n === 67174409 ? 1 : 2)), n;
          }
          function r0(u, e2) {
            for (; e2 !== 96; ) {
              switch (e2) {
                case 36: {
                  let i4 = u.index + 1;
                  if (i4 < u.end && u.source.charCodeAt(i4) === 123)
                    return u.index = i4, u.column++, -e2;
                  break;
                }
                case 10:
                case 8232:
                case 8233:
                  u.column = -1, u.line++;
              }
              u.index >= u.end && f4(u, 15), e2 = r2(u);
            }
            return e2;
          }
          function v0(u, e2) {
            return u.index >= u.end && f4(u, 0), u.index--, u.column--, Ju(u, e2);
          }
          function Xu(u, e2, i4) {
            let n = u.currentChar, t4 = 0, o = 9, l = i4 & 64 ? 0 : 1, c = 0, s4 = 0;
            if (i4 & 64)
              t4 = "." + t1(u, n), n = u.currentChar, n === 110 && f4(u, 11);
            else {
              if (n === 48)
                if (n = r2(u), (n | 32) === 120) {
                  for (i4 = 136, n = r2(u); V[n] & 4160; ) {
                    if (n === 95) {
                      s4 || f4(u, 146), s4 = 0, n = r2(u);
                      continue;
                    }
                    s4 = 1, t4 = t4 * 16 + L(n), c++, n = r2(u);
                  }
                  (c < 1 || !s4) && f4(u, c < 1 ? 19 : 147);
                } else if ((n | 32) === 111) {
                  for (i4 = 132, n = r2(u); V[n] & 4128; ) {
                    if (n === 95) {
                      s4 || f4(u, 146), s4 = 0, n = r2(u);
                      continue;
                    }
                    s4 = 1, t4 = t4 * 8 + (n - 48), c++, n = r2(u);
                  }
                  (c < 1 || !s4) && f4(u, c < 1 ? 0 : 147);
                } else if ((n | 32) === 98) {
                  for (i4 = 130, n = r2(u); V[n] & 4224; ) {
                    if (n === 95) {
                      s4 || f4(u, 146), s4 = 0, n = r2(u);
                      continue;
                    }
                    s4 = 1, t4 = t4 * 2 + (n - 48), c++, n = r2(u);
                  }
                  (c < 1 || !s4) && f4(u, c < 1 ? 0 : 147);
                } else if (V[n] & 32)
                  for (e2 & 1024 && f4(u, 1), i4 = 1; V[n] & 16; ) {
                    if (V[n] & 512) {
                      i4 = 32, l = 0;
                      break;
                    }
                    t4 = t4 * 8 + (n - 48), n = r2(u);
                  }
                else
                  V[n] & 512 ? (e2 & 1024 && f4(u, 1), u.flags |= 64, i4 = 32) : n === 95 && f4(u, 0);
              if (i4 & 48) {
                if (l) {
                  for (; o >= 0 && V[n] & 4112; ) {
                    if (n === 95) {
                      n = r2(u), (n === 95 || i4 & 32) && q(u.index, u.line, u.index + 1, 146), s4 = 1;
                      continue;
                    }
                    s4 = 0, t4 = 10 * t4 + (n - 48), n = r2(u), --o;
                  }
                  if (s4 && q(u.index, u.line, u.index + 1, 147), o >= 0 && !I(n) && n !== 46)
                    return u.tokenValue = t4, e2 & 512 && (u.tokenRaw = u.source.slice(u.tokenPos, u.index)), 134283266;
                }
                t4 += t1(u, n), n = u.currentChar, n === 46 && (r2(u) === 95 && f4(u, 0), i4 = 64, t4 += "." + t1(u, u.currentChar), n = u.currentChar);
              }
            }
            let h4 = u.index, b = 0;
            if (n === 110 && i4 & 128)
              b = 1, n = r2(u);
            else if ((n | 32) === 101) {
              n = r2(u), V[n] & 256 && (n = r2(u));
              let { index: g } = u;
              (V[n] & 16) < 1 && f4(u, 10), t4 += u.source.substring(h4, g) + t1(u, n), n = u.currentChar;
            }
            return (u.index < u.end && V[n] & 16 || I(n)) && f4(u, 12), b ? (u.tokenRaw = u.source.slice(u.tokenPos, u.index), u.tokenValue = BigInt(t4), 134283389) : (u.tokenValue = i4 & 15 ? t4 : i4 & 32 ? parseFloat(u.source.substring(u.tokenPos, u.index)) : +t4, e2 & 512 && (u.tokenRaw = u.source.slice(u.tokenPos, u.index)), 134283266);
          }
          function t1(u, e2) {
            let i4 = 0, n = u.index, t4 = "";
            for (; V[e2] & 4112; ) {
              if (e2 === 95) {
                let { index: o } = u;
                e2 = r2(u), e2 === 95 && q(u.index, u.line, u.index + 1, 146), i4 = 1, t4 += u.source.substring(n, o), n = u.index;
                continue;
              }
              i4 = 0, e2 = r2(u);
            }
            return i4 && q(u.index, u.line, u.index + 1, 147), t4 + u.source.substring(n, u.index);
          }
          var G = ["end of source", "identifier", "number", "string", "regular expression", "false", "true", "null", "template continuation", "template tail", "=>", "(", "{", ".", "...", "}", ")", ";", ",", "[", "]", ":", "?", "'", '"', "</", "/>", "++", "--", "=", "<<=", ">>=", ">>>=", "**=", "+=", "-=", "*=", "/=", "%=", "^=", "|=", "&=", "||=", "&&=", "??=", "typeof", "delete", "void", "!", "~", "+", "-", "in", "instanceof", "*", "%", "/", "**", "&&", "||", "===", "!==", "==", "!=", "<=", ">=", "<", ">", "<<", ">>", ">>>", "&", "|", "^", "var", "let", "const", "break", "case", "catch", "class", "continue", "debugger", "default", "do", "else", "export", "extends", "finally", "for", "function", "if", "import", "new", "return", "super", "switch", "this", "throw", "try", "while", "with", "implements", "interface", "package", "private", "protected", "public", "static", "yield", "as", "async", "await", "constructor", "get", "set", "from", "of", "enum", "eval", "arguments", "escaped keyword", "escaped future reserved keyword", "reserved if strict", "#", "BigIntLiteral", "??", "?.", "WhiteSpace", "Illegal", "LineTerminator", "PrivateField", "Template", "@", "target", "meta", "LineFeed", "Escaped", "JSXText"], zu = Object.create(null, { this: { value: 86113 }, function: { value: 86106 }, if: { value: 20571 }, return: { value: 20574 }, var: { value: 86090 }, else: { value: 20565 }, for: { value: 20569 }, new: { value: 86109 }, in: { value: 8738868 }, typeof: { value: 16863277 }, while: { value: 20580 }, case: { value: 20558 }, break: { value: 20557 }, try: { value: 20579 }, catch: { value: 20559 }, delete: { value: 16863278 }, throw: { value: 86114 }, switch: { value: 86112 }, continue: { value: 20561 }, default: { value: 20563 }, instanceof: { value: 8476725 }, do: { value: 20564 }, void: { value: 16863279 }, finally: { value: 20568 }, async: { value: 209007 }, await: { value: 209008 }, class: { value: 86096 }, const: { value: 86092 }, constructor: { value: 12401 }, debugger: { value: 20562 }, export: { value: 20566 }, extends: { value: 20567 }, false: { value: 86021 }, from: { value: 12404 }, get: { value: 12402 }, implements: { value: 36966 }, import: { value: 86108 }, interface: { value: 36967 }, let: { value: 241739 }, null: { value: 86023 }, of: { value: 274549 }, package: { value: 36968 }, private: { value: 36969 }, protected: { value: 36970 }, public: { value: 36971 }, set: { value: 12403 }, static: { value: 36972 }, super: { value: 86111 }, true: { value: 86022 }, with: { value: 20581 }, yield: { value: 241773 }, enum: { value: 86134 }, eval: { value: 537079927 }, as: { value: 77934 }, arguments: { value: 537079928 }, target: { value: 143494 }, meta: { value: 143495 } });
          function Hu(u, e2, i4) {
            for (; H[r2(u)]; )
              ;
            return u.tokenValue = u.source.slice(u.tokenPos, u.index), u.currentChar !== 92 && u.currentChar < 126 ? zu[u.tokenValue] || 208897 : R1(u, e2, 0, i4);
          }
          function A0(u, e2) {
            let i4 = Ku(u);
            return u2(i4) || f4(u, 4), u.tokenValue = Z3(i4), R1(u, e2, 1, V[i4] & 4);
          }
          function R1(u, e2, i4, n) {
            let t4 = u.index;
            for (; u.index < u.end; )
              if (u.currentChar === 92) {
                u.tokenValue += u.source.slice(t4, u.index), i4 = 1;
                let l = Ku(u);
                u2(l) || f4(u, 4), n = n && V[l] & 4, u.tokenValue += Z3(l), t4 = u.index;
              } else if (u2(u.currentChar) || K(u, u.currentChar))
                r2(u);
              else
                break;
            u.index <= u.end && (u.tokenValue += u.source.slice(t4, u.index));
            let o = u.tokenValue.length;
            if (n && o >= 2 && o <= 11) {
              let l = zu[u.tokenValue];
              return l === void 0 ? 208897 : i4 ? e2 & 1024 ? l === 209008 && (e2 & 4196352) === 0 ? l : l === 36972 || (l & 36864) === 36864 ? 122 : 121 : e2 & 1073741824 && (e2 & 8192) === 0 && (l & 20480) === 20480 ? l : l === 241773 ? e2 & 1073741824 ? 143483 : e2 & 2097152 ? 121 : l : l === 209007 && e2 & 1073741824 ? 143483 : (l & 36864) === 36864 || l === 209008 && (e2 & 4194304) === 0 ? l : 121 : l;
            }
            return 208897;
          }
          function y0(u) {
            return I(r2(u)) || f4(u, 93), 131;
          }
          function Ku(u) {
            return u.source.charCodeAt(u.index + 1) !== 117 && f4(u, 4), u.currentChar = u.source.charCodeAt(u.index += 2), P0(u);
          }
          function P0(u) {
            let e2 = 0, i4 = u.currentChar;
            if (i4 === 123) {
              let l = u.index - 2;
              for (; V[r2(u)] & 64; )
                e2 = e2 << 4 | L(u.currentChar), e2 > 1114111 && q(l, u.line, u.index + 1, 101);
              return u.currentChar !== 125 && q(l, u.line, u.index - 1, 6), r2(u), e2;
            }
            (V[i4] & 64) === 0 && f4(u, 6);
            let n = u.source.charCodeAt(u.index + 1);
            (V[n] & 64) === 0 && f4(u, 6);
            let t4 = u.source.charCodeAt(u.index + 2);
            (V[t4] & 64) === 0 && f4(u, 6);
            let o = u.source.charCodeAt(u.index + 3);
            return (V[o] & 64) === 0 && f4(u, 6), e2 = L(i4) << 12 | L(n) << 8 | L(t4) << 4 | L(o), u.currentChar = u.source.charCodeAt(u.index += 4), e2;
          }
          var Wu = [129, 129, 129, 129, 129, 129, 129, 129, 129, 128, 136, 128, 128, 130, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 129, 128, 16842800, 134283267, 131, 208897, 8457015, 8455751, 134283267, 67174411, 16, 8457014, 25233970, 18, 25233971, 67108877, 8457016, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 134283266, 21, 1074790417, 8456258, 1077936157, 8456259, 22, 133, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 208897, 69271571, 137, 20, 8455497, 208897, 132, 4096, 4096, 4096, 4096, 4096, 4096, 4096, 208897, 4096, 208897, 208897, 4096, 208897, 4096, 208897, 4096, 208897, 4096, 4096, 4096, 208897, 4096, 4096, 208897, 4096, 4096, 2162700, 8455240, 1074790415, 16842801, 129];
          function E(u, e2) {
            if (u.flags = (u.flags | 1) ^ 1, u.startPos = u.index, u.startColumn = u.column, u.startLine = u.line, u.token = Yu(u, e2, 0), u.onToken && u.token !== 1048576) {
              let i4 = { start: { line: u.linePos, column: u.colPos }, end: { line: u.line, column: u.column } };
              u.onToken(t2(u.token), u.tokenPos, u.index, i4);
            }
          }
          function Yu(u, e2, i4) {
            let n = u.index === 0, t4 = u.source, o = u.index, l = u.line, c = u.column;
            for (; u.index < u.end; ) {
              u.tokenPos = u.index, u.colPos = u.column, u.linePos = u.line;
              let s4 = u.currentChar;
              if (s4 <= 126) {
                let h4 = Wu[s4];
                switch (h4) {
                  case 67174411:
                  case 16:
                  case 2162700:
                  case 1074790415:
                  case 69271571:
                  case 20:
                  case 21:
                  case 1074790417:
                  case 18:
                  case 16842801:
                  case 133:
                  case 129:
                    return r2(u), h4;
                  case 208897:
                    return Hu(u, e2, 0);
                  case 4096:
                    return Hu(u, e2, 1);
                  case 134283266:
                    return Xu(u, e2, 144);
                  case 134283267:
                    return I1(u, e2, s4);
                  case 132:
                    return Ju(u, e2);
                  case 137:
                    return A0(u, e2);
                  case 131:
                    return y0(u);
                  case 128:
                    r2(u);
                    break;
                  case 130:
                    i4 |= 5, X(u);
                    break;
                  case 136:
                    Y(u, i4), i4 = i4 & -5 | 1;
                    break;
                  case 8456258:
                    let b = r2(u);
                    if (u.index < u.end) {
                      if (b === 60)
                        return u.index < u.end && r2(u) === 61 ? (r2(u), 4194334) : 8456516;
                      if (b === 61)
                        return r2(u), 8456256;
                      if (b === 33) {
                        let a = u.index + 1;
                        if (a + 1 < u.end && t4.charCodeAt(a) === 45 && t4.charCodeAt(a + 1) == 45) {
                          u.column += 3, u.currentChar = t4.charCodeAt(u.index += 3), i4 = R2(u, t4, i4, e2, 2, u.tokenPos, u.linePos, u.colPos), o = u.tokenPos, l = u.linePos, c = u.colPos;
                          continue;
                        }
                        return 8456258;
                      }
                      if (b === 47) {
                        if ((e2 & 16) < 1)
                          return 8456258;
                        let a = u.index + 1;
                        if (a < u.end && (b = t4.charCodeAt(a), b === 42 || b === 47))
                          break;
                        return r2(u), 25;
                      }
                    }
                    return 8456258;
                  case 1077936157: {
                    r2(u);
                    let a = u.currentChar;
                    return a === 61 ? r2(u) === 61 ? (r2(u), 8455996) : 8455998 : a === 62 ? (r2(u), 10) : 1077936157;
                  }
                  case 16842800:
                    return r2(u) !== 61 ? 16842800 : r2(u) !== 61 ? 8455999 : (r2(u), 8455997);
                  case 8457015:
                    return r2(u) !== 61 ? 8457015 : (r2(u), 4194342);
                  case 8457014: {
                    if (r2(u), u.index >= u.end)
                      return 8457014;
                    let a = u.currentChar;
                    return a === 61 ? (r2(u), 4194340) : a !== 42 ? 8457014 : r2(u) !== 61 ? 8457273 : (r2(u), 4194337);
                  }
                  case 8455497:
                    return r2(u) !== 61 ? 8455497 : (r2(u), 4194343);
                  case 25233970: {
                    r2(u);
                    let a = u.currentChar;
                    return a === 43 ? (r2(u), 33619995) : a === 61 ? (r2(u), 4194338) : 25233970;
                  }
                  case 25233971: {
                    r2(u);
                    let a = u.currentChar;
                    if (a === 45) {
                      if (r2(u), (i4 & 1 || n) && u.currentChar === 62) {
                        (e2 & 256) === 0 && f4(u, 108), r2(u), i4 = R2(u, t4, i4, e2, 3, o, l, c), o = u.tokenPos, l = u.linePos, c = u.colPos;
                        continue;
                      }
                      return 33619996;
                    }
                    return a === 61 ? (r2(u), 4194339) : 25233971;
                  }
                  case 8457016: {
                    if (r2(u), u.index < u.end) {
                      let a = u.currentChar;
                      if (a === 47) {
                        r2(u), i4 = s2(u, t4, i4, 0, u.tokenPos, u.linePos, u.colPos), o = u.tokenPos, l = u.linePos, c = u.colPos;
                        continue;
                      }
                      if (a === 42) {
                        r2(u), i4 = N2(u, t4, i4), o = u.tokenPos, l = u.linePos, c = u.colPos;
                        continue;
                      }
                      if (e2 & 32768)
                        return w2(u, e2);
                      if (a === 61)
                        return r2(u), 4259877;
                    }
                    return 8457016;
                  }
                  case 67108877:
                    let g = r2(u);
                    if (g >= 48 && g <= 57)
                      return Xu(u, e2, 80);
                    if (g === 46) {
                      let a = u.index + 1;
                      if (a < u.end && t4.charCodeAt(a) === 46)
                        return u.column += 2, u.currentChar = t4.charCodeAt(u.index += 2), 14;
                    }
                    return 67108877;
                  case 8455240: {
                    r2(u);
                    let a = u.currentChar;
                    return a === 124 ? (r2(u), u.currentChar === 61 ? (r2(u), 4194346) : 8979003) : a === 61 ? (r2(u), 4194344) : 8455240;
                  }
                  case 8456259: {
                    r2(u);
                    let a = u.currentChar;
                    if (a === 61)
                      return r2(u), 8456257;
                    if (a !== 62)
                      return 8456259;
                    if (r2(u), u.index < u.end) {
                      let A4 = u.currentChar;
                      if (A4 === 62)
                        return r2(u) === 61 ? (r2(u), 4194336) : 8456518;
                      if (A4 === 61)
                        return r2(u), 4194335;
                    }
                    return 8456517;
                  }
                  case 8455751: {
                    r2(u);
                    let a = u.currentChar;
                    return a === 38 ? (r2(u), u.currentChar === 61 ? (r2(u), 4194347) : 8979258) : a === 61 ? (r2(u), 4194345) : 8455751;
                  }
                  case 22: {
                    let a = r2(u);
                    if (a === 63)
                      return r2(u), u.currentChar === 61 ? (r2(u), 4194348) : 276889982;
                    if (a === 46) {
                      let A4 = u.index + 1;
                      if (A4 < u.end && (a = t4.charCodeAt(A4), !(a >= 48 && a <= 57)))
                        return r2(u), 67108991;
                    }
                    return 22;
                  }
                }
              } else {
                if ((s4 ^ 8232) <= 1) {
                  i4 = i4 & -5 | 1, X(u);
                  continue;
                }
                if ((s4 & 64512) === 55296 || (T[(s4 >>> 5) + 34816] >>> s4 & 31 & 1) !== 0)
                  return (s4 & 64512) === 56320 && (s4 = (s4 & 1023) << 10 | s4 & 1023 | 65536, (T[(s4 >>> 5) + 0] >>> s4 & 31 & 1) === 0 && f4(u, 18, Z3(s4)), u.index++, u.currentChar = s4), u.column++, u.tokenValue = "", R1(u, e2, 0, 0);
                if (p(s4)) {
                  r2(u);
                  continue;
                }
                f4(u, 18, Z3(s4));
              }
            }
            return 1048576;
          }
          var E0 = { AElig: "\xC6", AMP: "&", Aacute: "\xC1", Abreve: "\u0102", Acirc: "\xC2", Acy: "\u0410", Afr: "\u{1D504}", Agrave: "\xC0", Alpha: "\u0391", Amacr: "\u0100", And: "\u2A53", Aogon: "\u0104", Aopf: "\u{1D538}", ApplyFunction: "\u2061", Aring: "\xC5", Ascr: "\u{1D49C}", Assign: "\u2254", Atilde: "\xC3", Auml: "\xC4", Backslash: "\u2216", Barv: "\u2AE7", Barwed: "\u2306", Bcy: "\u0411", Because: "\u2235", Bernoullis: "\u212C", Beta: "\u0392", Bfr: "\u{1D505}", Bopf: "\u{1D539}", Breve: "\u02D8", Bscr: "\u212C", Bumpeq: "\u224E", CHcy: "\u0427", COPY: "\xA9", Cacute: "\u0106", Cap: "\u22D2", CapitalDifferentialD: "\u2145", Cayleys: "\u212D", Ccaron: "\u010C", Ccedil: "\xC7", Ccirc: "\u0108", Cconint: "\u2230", Cdot: "\u010A", Cedilla: "\xB8", CenterDot: "\xB7", Cfr: "\u212D", Chi: "\u03A7", CircleDot: "\u2299", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", Colon: "\u2237", Colone: "\u2A74", Congruent: "\u2261", Conint: "\u222F", ContourIntegral: "\u222E", Copf: "\u2102", Coproduct: "\u2210", CounterClockwiseContourIntegral: "\u2233", Cross: "\u2A2F", Cscr: "\u{1D49E}", Cup: "\u22D3", CupCap: "\u224D", DD: "\u2145", DDotrahd: "\u2911", DJcy: "\u0402", DScy: "\u0405", DZcy: "\u040F", Dagger: "\u2021", Darr: "\u21A1", Dashv: "\u2AE4", Dcaron: "\u010E", Dcy: "\u0414", Del: "\u2207", Delta: "\u0394", Dfr: "\u{1D507}", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", Diamond: "\u22C4", DifferentialD: "\u2146", Dopf: "\u{1D53B}", Dot: "\xA8", DotDot: "\u20DC", DotEqual: "\u2250", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrow: "\u2193", DownArrowBar: "\u2913", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVector: "\u21BD", DownLeftVectorBar: "\u2956", DownRightTeeVector: "\u295F", DownRightVector: "\u21C1", DownRightVectorBar: "\u2957", DownTee: "\u22A4", DownTeeArrow: "\u21A7", Downarrow: "\u21D3", Dscr: "\u{1D49F}", Dstrok: "\u0110", ENG: "\u014A", ETH: "\xD0", Eacute: "\xC9", Ecaron: "\u011A", Ecirc: "\xCA", Ecy: "\u042D", Edot: "\u0116", Efr: "\u{1D508}", Egrave: "\xC8", Element: "\u2208", Emacr: "\u0112", EmptySmallSquare: "\u25FB", EmptyVerySmallSquare: "\u25AB", Eogon: "\u0118", Eopf: "\u{1D53C}", Epsilon: "\u0395", Equal: "\u2A75", EqualTilde: "\u2242", Equilibrium: "\u21CC", Escr: "\u2130", Esim: "\u2A73", Eta: "\u0397", Euml: "\xCB", Exists: "\u2203", ExponentialE: "\u2147", Fcy: "\u0424", Ffr: "\u{1D509}", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", Fopf: "\u{1D53D}", ForAll: "\u2200", Fouriertrf: "\u2131", Fscr: "\u2131", GJcy: "\u0403", GT: ">", Gamma: "\u0393", Gammad: "\u03DC", Gbreve: "\u011E", Gcedil: "\u0122", Gcirc: "\u011C", Gcy: "\u0413", Gdot: "\u0120", Gfr: "\u{1D50A}", Gg: "\u22D9", Gopf: "\u{1D53E}", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", Gt: "\u226B", HARDcy: "\u042A", Hacek: "\u02C7", Hat: "^", Hcirc: "\u0124", Hfr: "\u210C", HilbertSpace: "\u210B", Hopf: "\u210D", HorizontalLine: "\u2500", Hscr: "\u210B", Hstrok: "\u0126", HumpDownHump: "\u224E", HumpEqual: "\u224F", IEcy: "\u0415", IJlig: "\u0132", IOcy: "\u0401", Iacute: "\xCD", Icirc: "\xCE", Icy: "\u0418", Idot: "\u0130", Ifr: "\u2111", Igrave: "\xCC", Im: "\u2111", Imacr: "\u012A", ImaginaryI: "\u2148", Implies: "\u21D2", Int: "\u222C", Integral: "\u222B", Intersection: "\u22C2", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", Iogon: "\u012E", Iopf: "\u{1D540}", Iota: "\u0399", Iscr: "\u2110", Itilde: "\u0128", Iukcy: "\u0406", Iuml: "\xCF", Jcirc: "\u0134", Jcy: "\u0419", Jfr: "\u{1D50D}", Jopf: "\u{1D541}", Jscr: "\u{1D4A5}", Jsercy: "\u0408", Jukcy: "\u0404", KHcy: "\u0425", KJcy: "\u040C", Kappa: "\u039A", Kcedil: "\u0136", Kcy: "\u041A", Kfr: "\u{1D50E}", Kopf: "\u{1D542}", Kscr: "\u{1D4A6}", LJcy: "\u0409", LT: "<", Lacute: "\u0139", Lambda: "\u039B", Lang: "\u27EA", Laplacetrf: "\u2112", Larr: "\u219E", Lcaron: "\u013D", Lcedil: "\u013B", Lcy: "\u041B", LeftAngleBracket: "\u27E8", LeftArrow: "\u2190", LeftArrowBar: "\u21E4", LeftArrowRightArrow: "\u21C6", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVector: "\u21C3", LeftDownVectorBar: "\u2959", LeftFloor: "\u230A", LeftRightArrow: "\u2194", LeftRightVector: "\u294E", LeftTee: "\u22A3", LeftTeeArrow: "\u21A4", LeftTeeVector: "\u295A", LeftTriangle: "\u22B2", LeftTriangleBar: "\u29CF", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVector: "\u21BF", LeftUpVectorBar: "\u2958", LeftVector: "\u21BC", LeftVectorBar: "\u2952", Leftarrow: "\u21D0", Leftrightarrow: "\u21D4", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", LessLess: "\u2AA1", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", Lfr: "\u{1D50F}", Ll: "\u22D8", Lleftarrow: "\u21DA", Lmidot: "\u013F", LongLeftArrow: "\u27F5", LongLeftRightArrow: "\u27F7", LongRightArrow: "\u27F6", Longleftarrow: "\u27F8", Longleftrightarrow: "\u27FA", Longrightarrow: "\u27F9", Lopf: "\u{1D543}", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", Lscr: "\u2112", Lsh: "\u21B0", Lstrok: "\u0141", Lt: "\u226A", Map: "\u2905", Mcy: "\u041C", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", MinusPlus: "\u2213", Mopf: "\u{1D544}", Mscr: "\u2133", Mu: "\u039C", NJcy: "\u040A", Nacute: "\u0143", Ncaron: "\u0147", Ncedil: "\u0145", Ncy: "\u041D", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: `
`, Nfr: "\u{1D511}", NoBreak: "\u2060", NonBreakingSpace: "\xA0", Nopf: "\u2115", Not: "\u2AEC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", NotLeftTriangle: "\u22EA", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangle: "\u22EB", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", Nscr: "\u{1D4A9}", Ntilde: "\xD1", Nu: "\u039D", OElig: "\u0152", Oacute: "\xD3", Ocirc: "\xD4", Ocy: "\u041E", Odblac: "\u0150", Ofr: "\u{1D512}", Ograve: "\xD2", Omacr: "\u014C", Omega: "\u03A9", Omicron: "\u039F", Oopf: "\u{1D546}", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", Or: "\u2A54", Oscr: "\u{1D4AA}", Oslash: "\xD8", Otilde: "\xD5", Otimes: "\u2A37", Ouml: "\xD6", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", PartialD: "\u2202", Pcy: "\u041F", Pfr: "\u{1D513}", Phi: "\u03A6", Pi: "\u03A0", PlusMinus: "\xB1", Poincareplane: "\u210C", Popf: "\u2119", Pr: "\u2ABB", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", Prime: "\u2033", Product: "\u220F", Proportion: "\u2237", Proportional: "\u221D", Pscr: "\u{1D4AB}", Psi: "\u03A8", QUOT: '"', Qfr: "\u{1D514}", Qopf: "\u211A", Qscr: "\u{1D4AC}", RBarr: "\u2910", REG: "\xAE", Racute: "\u0154", Rang: "\u27EB", Rarr: "\u21A0", Rarrtl: "\u2916", Rcaron: "\u0158", Rcedil: "\u0156", Rcy: "\u0420", Re: "\u211C", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", Rfr: "\u211C", Rho: "\u03A1", RightAngleBracket: "\u27E9", RightArrow: "\u2192", RightArrowBar: "\u21E5", RightArrowLeftArrow: "\u21C4", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVector: "\u21C2", RightDownVectorBar: "\u2955", RightFloor: "\u230B", RightTee: "\u22A2", RightTeeArrow: "\u21A6", RightTeeVector: "\u295B", RightTriangle: "\u22B3", RightTriangleBar: "\u29D0", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVector: "\u21BE", RightUpVectorBar: "\u2954", RightVector: "\u21C0", RightVectorBar: "\u2953", Rightarrow: "\u21D2", Ropf: "\u211D", RoundImplies: "\u2970", Rrightarrow: "\u21DB", Rscr: "\u211B", Rsh: "\u21B1", RuleDelayed: "\u29F4", SHCHcy: "\u0429", SHcy: "\u0428", SOFTcy: "\u042C", Sacute: "\u015A", Sc: "\u2ABC", Scaron: "\u0160", Scedil: "\u015E", Scirc: "\u015C", Scy: "\u0421", Sfr: "\u{1D516}", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", Sigma: "\u03A3", SmallCircle: "\u2218", Sopf: "\u{1D54A}", Sqrt: "\u221A", Square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", Sscr: "\u{1D4AE}", Star: "\u22C6", Sub: "\u22D0", Subset: "\u22D0", SubsetEqual: "\u2286", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", SuchThat: "\u220B", Sum: "\u2211", Sup: "\u22D1", Superset: "\u2283", SupersetEqual: "\u2287", Supset: "\u22D1", THORN: "\xDE", TRADE: "\u2122", TSHcy: "\u040B", TScy: "\u0426", Tab: "	", Tau: "\u03A4", Tcaron: "\u0164", Tcedil: "\u0162", Tcy: "\u0422", Tfr: "\u{1D517}", Therefore: "\u2234", Theta: "\u0398", ThickSpace: "\u205F\u200A", ThinSpace: "\u2009", Tilde: "\u223C", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", Topf: "\u{1D54B}", TripleDot: "\u20DB", Tscr: "\u{1D4AF}", Tstrok: "\u0166", Uacute: "\xDA", Uarr: "\u219F", Uarrocir: "\u2949", Ubrcy: "\u040E", Ubreve: "\u016C", Ucirc: "\xDB", Ucy: "\u0423", Udblac: "\u0170", Ufr: "\u{1D518}", Ugrave: "\xD9", Umacr: "\u016A", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", Uopf: "\u{1D54C}", UpArrow: "\u2191", UpArrowBar: "\u2912", UpArrowDownArrow: "\u21C5", UpDownArrow: "\u2195", UpEquilibrium: "\u296E", UpTee: "\u22A5", UpTeeArrow: "\u21A5", Uparrow: "\u21D1", Updownarrow: "\u21D5", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", Upsi: "\u03D2", Upsilon: "\u03A5", Uring: "\u016E", Uscr: "\u{1D4B0}", Utilde: "\u0168", Uuml: "\xDC", VDash: "\u22AB", Vbar: "\u2AEB", Vcy: "\u0412", Vdash: "\u22A9", Vdashl: "\u2AE6", Vee: "\u22C1", Verbar: "\u2016", Vert: "\u2016", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", Vopf: "\u{1D54D}", Vscr: "\u{1D4B1}", Vvdash: "\u22AA", Wcirc: "\u0174", Wedge: "\u22C0", Wfr: "\u{1D51A}", Wopf: "\u{1D54E}", Wscr: "\u{1D4B2}", Xfr: "\u{1D51B}", Xi: "\u039E", Xopf: "\u{1D54F}", Xscr: "\u{1D4B3}", YAcy: "\u042F", YIcy: "\u0407", YUcy: "\u042E", Yacute: "\xDD", Ycirc: "\u0176", Ycy: "\u042B", Yfr: "\u{1D51C}", Yopf: "\u{1D550}", Yscr: "\u{1D4B4}", Yuml: "\u0178", ZHcy: "\u0416", Zacute: "\u0179", Zcaron: "\u017D", Zcy: "\u0417", Zdot: "\u017B", ZeroWidthSpace: "\u200B", Zeta: "\u0396", Zfr: "\u2128", Zopf: "\u2124", Zscr: "\u{1D4B5}", aacute: "\xE1", abreve: "\u0103", ac: "\u223E", acE: "\u223E\u0333", acd: "\u223F", acirc: "\xE2", acute: "\xB4", acy: "\u0430", aelig: "\xE6", af: "\u2061", afr: "\u{1D51E}", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", alpha: "\u03B1", amacr: "\u0101", amalg: "\u2A3F", amp: "&", and: "\u2227", andand: "\u2A55", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsd: "\u2221", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", aogon: "\u0105", aopf: "\u{1D552}", ap: "\u2248", apE: "\u2A70", apacir: "\u2A6F", ape: "\u224A", apid: "\u224B", apos: "'", approx: "\u2248", approxeq: "\u224A", aring: "\xE5", ascr: "\u{1D4B6}", ast: "*", asymp: "\u2248", asympeq: "\u224D", atilde: "\xE3", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", bNot: "\u2AED", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", barvee: "\u22BD", barwed: "\u2305", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", beta: "\u03B2", beth: "\u2136", between: "\u226C", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bnot: "\u2310", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxDL: "\u2557", boxDR: "\u2554", boxDl: "\u2556", boxDr: "\u2553", boxH: "\u2550", boxHD: "\u2566", boxHU: "\u2569", boxHd: "\u2564", boxHu: "\u2567", boxUL: "\u255D", boxUR: "\u255A", boxUl: "\u255C", boxUr: "\u2559", boxV: "\u2551", boxVH: "\u256C", boxVL: "\u2563", boxVR: "\u2560", boxVh: "\u256B", boxVl: "\u2562", boxVr: "\u255F", boxbox: "\u29C9", boxdL: "\u2555", boxdR: "\u2552", boxdl: "\u2510", boxdr: "\u250C", boxh: "\u2500", boxhD: "\u2565", boxhU: "\u2568", boxhd: "\u252C", boxhu: "\u2534", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxuL: "\u255B", boxuR: "\u2558", boxul: "\u2518", boxur: "\u2514", boxv: "\u2502", boxvH: "\u256A", boxvL: "\u2561", boxvR: "\u255E", boxvh: "\u253C", boxvl: "\u2524", boxvr: "\u251C", bprime: "\u2035", breve: "\u02D8", brvbar: "\xA6", bscr: "\u{1D4B7}", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsol: "\\", bsolb: "\u29C5", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", bumpeq: "\u224F", cacute: "\u0107", cap: "\u2229", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", capcup: "\u2A47", capdot: "\u2A40", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", ccaps: "\u2A4D", ccaron: "\u010D", ccedil: "\xE7", ccirc: "\u0109", ccups: "\u2A4C", ccupssm: "\u2A50", cdot: "\u010B", cedil: "\xB8", cemptyv: "\u29B2", cent: "\xA2", centerdot: "\xB7", cfr: "\u{1D520}", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", chi: "\u03C7", cir: "\u25CB", cirE: "\u29C3", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledR: "\xAE", circledS: "\u24C8", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", clubs: "\u2663", clubsuit: "\u2663", colon: ":", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", conint: "\u222E", copf: "\u{1D554}", coprod: "\u2210", copy: "\xA9", copysr: "\u2117", crarr: "\u21B5", cross: "\u2717", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", cup: "\u222A", cupbrcap: "\u2A48", cupcap: "\u2A46", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", dArr: "\u21D3", dHar: "\u2965", dagger: "\u2020", daleth: "\u2138", darr: "\u2193", dash: "\u2010", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", dcaron: "\u010F", dcy: "\u0434", dd: "\u2146", ddagger: "\u2021", ddarr: "\u21CA", ddotseq: "\u2A77", deg: "\xB0", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", dfr: "\u{1D521}", dharl: "\u21C3", dharr: "\u21C2", diam: "\u22C4", diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", dopf: "\u{1D555}", dot: "\u02D9", doteq: "\u2250", doteqdot: "\u2251", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", downarrow: "\u2193", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", dscr: "\u{1D4B9}", dscy: "\u0455", dsol: "\u29F6", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", dzcy: "\u045F", dzigrarr: "\u27FF", eDDot: "\u2A77", eDot: "\u2251", eacute: "\xE9", easter: "\u2A6E", ecaron: "\u011B", ecir: "\u2256", ecirc: "\xEA", ecolon: "\u2255", ecy: "\u044D", edot: "\u0117", ee: "\u2147", efDot: "\u2252", efr: "\u{1D522}", eg: "\u2A9A", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", emptyv: "\u2205", emsp13: "\u2004", emsp14: "\u2005", emsp: "\u2003", eng: "\u014B", ensp: "\u2002", eogon: "\u0119", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", equals: "=", equest: "\u225F", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erDot: "\u2253", erarr: "\u2971", escr: "\u212F", esdot: "\u2250", esim: "\u2242", eta: "\u03B7", eth: "\xF0", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", expectation: "\u2130", exponentiale: "\u2147", fallingdotseq: "\u2252", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", ffr: "\u{1D523}", filig: "\uFB01", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", fopf: "\u{1D557}", forall: "\u2200", fork: "\u22D4", forkv: "\u2AD9", fpartint: "\u2A0D", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", fscr: "\u{1D4BB}", gE: "\u2267", gEl: "\u2A8C", gacute: "\u01F5", gamma: "\u03B3", gammad: "\u03DD", gap: "\u2A86", gbreve: "\u011F", gcirc: "\u011D", gcy: "\u0433", gdot: "\u0121", ge: "\u2265", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", ges: "\u2A7E", gescc: "\u2AA9", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", gfr: "\u{1D524}", gg: "\u226B", ggg: "\u22D9", gimel: "\u2137", gjcy: "\u0453", gl: "\u2277", glE: "\u2A92", gla: "\u2AA5", glj: "\u2AA4", gnE: "\u2269", gnap: "\u2A8A", gnapprox: "\u2A8A", gne: "\u2A88", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", gopf: "\u{1D558}", grave: "`", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", gt: ">", gtcc: "\u2AA7", gtcir: "\u2A7A", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", hArr: "\u21D4", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", hardcy: "\u044A", harr: "\u2194", harrcir: "\u2948", harrw: "\u21AD", hbar: "\u210F", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", hfr: "\u{1D525}", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", hopf: "\u{1D559}", horbar: "\u2015", hscr: "\u{1D4BD}", hslash: "\u210F", hstrok: "\u0127", hybull: "\u2043", hyphen: "\u2010", iacute: "\xED", ic: "\u2063", icirc: "\xEE", icy: "\u0438", iecy: "\u0435", iexcl: "\xA1", iff: "\u21D4", ifr: "\u{1D526}", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", ijlig: "\u0133", imacr: "\u012B", image: "\u2111", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", imof: "\u22B7", imped: "\u01B5", in: "\u2208", incare: "\u2105", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", int: "\u222B", intcal: "\u22BA", integers: "\u2124", intercal: "\u22BA", intlarhk: "\u2A17", intprod: "\u2A3C", iocy: "\u0451", iogon: "\u012F", iopf: "\u{1D55A}", iota: "\u03B9", iprod: "\u2A3C", iquest: "\xBF", iscr: "\u{1D4BE}", isin: "\u2208", isinE: "\u22F9", isindot: "\u22F5", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", itilde: "\u0129", iukcy: "\u0456", iuml: "\xEF", jcirc: "\u0135", jcy: "\u0439", jfr: "\u{1D527}", jmath: "\u0237", jopf: "\u{1D55B}", jscr: "\u{1D4BF}", jsercy: "\u0458", jukcy: "\u0454", kappa: "\u03BA", kappav: "\u03F0", kcedil: "\u0137", kcy: "\u043A", kfr: "\u{1D528}", kgreen: "\u0138", khcy: "\u0445", kjcy: "\u045C", kopf: "\u{1D55C}", kscr: "\u{1D4C0}", lAarr: "\u21DA", lArr: "\u21D0", lAtail: "\u291B", lBarr: "\u290E", lE: "\u2266", lEg: "\u2A8B", lHar: "\u2962", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", lambda: "\u03BB", lang: "\u27E8", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", laquo: "\xAB", larr: "\u2190", larrb: "\u21E4", larrbfs: "\u291F", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", lat: "\u2AAB", latail: "\u2919", late: "\u2AAD", lates: "\u2AAD\uFE00", lbarr: "\u290C", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", lcaron: "\u013E", lcedil: "\u013C", lceil: "\u2308", lcub: "{", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", le: "\u2264", leftarrow: "\u2190", leftarrowtail: "\u21A2", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", leftrightarrow: "\u2194", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", leftthreetimes: "\u22CB", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", les: "\u2A7D", lescc: "\u2AA8", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", lessgtr: "\u2276", lesssim: "\u2272", lfisht: "\u297C", lfloor: "\u230A", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", ljcy: "\u0459", ll: "\u226A", llarr: "\u21C7", llcorner: "\u231E", llhard: "\u296B", lltri: "\u25FA", lmidot: "\u0140", lmoust: "\u23B0", lmoustache: "\u23B0", lnE: "\u2268", lnap: "\u2A89", lnapprox: "\u2A89", lne: "\u2A87", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", longleftarrow: "\u27F5", longleftrightarrow: "\u27F7", longmapsto: "\u27FC", longrightarrow: "\u27F6", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", lscr: "\u{1D4C1}", lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", lstrok: "\u0142", lt: "<", ltcc: "\u2AA6", ltcir: "\u2A79", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltrPar: "\u2996", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", mDDot: "\u223A", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", mcy: "\u043C", mdash: "\u2014", measuredangle: "\u2221", mfr: "\u{1D52A}", mho: "\u2127", micro: "\xB5", mid: "\u2223", midast: "*", midcir: "\u2AF0", middot: "\xB7", minus: "\u2212", minusb: "\u229F", minusd: "\u2238", minusdu: "\u2A2A", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", mopf: "\u{1D55E}", mp: "\u2213", mscr: "\u{1D4C2}", mstpos: "\u223E", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nGg: "\u22D9\u0338", nGt: "\u226B\u20D2", nGtv: "\u226B\u0338", nLeftarrow: "\u21CD", nLeftrightarrow: "\u21CE", nLl: "\u22D8\u0338", nLt: "\u226A\u20D2", nLtv: "\u226A\u0338", nRightarrow: "\u21CF", nVDash: "\u22AF", nVdash: "\u22AE", nabla: "\u2207", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natur: "\u266E", natural: "\u266E", naturals: "\u2115", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", ncaron: "\u0148", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", ncy: "\u043D", ndash: "\u2013", ne: "\u2260", neArr: "\u21D7", nearhk: "\u2924", nearr: "\u2197", nearrow: "\u2197", nedot: "\u2250\u0338", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", nexist: "\u2204", nexists: "\u2204", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", ngsim: "\u2275", ngt: "\u226F", ngtr: "\u226F", nhArr: "\u21CE", nharr: "\u21AE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", njcy: "\u045A", nlArr: "\u21CD", nlE: "\u2266\u0338", nlarr: "\u219A", nldr: "\u2025", nle: "\u2270", nleftarrow: "\u219A", nleftrightarrow: "\u21AE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nlsim: "\u2274", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nmid: "\u2224", nopf: "\u{1D55F}", not: "\xAC", notin: "\u2209", notinE: "\u22F9\u0338", notindot: "\u22F5\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", npar: "\u2226", nparallel: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", npre: "\u2AAF\u0338", nprec: "\u2280", npreceq: "\u2AAF\u0338", nrArr: "\u21CF", nrarr: "\u219B", nrarrc: "\u2933\u0338", nrarrw: "\u219D\u0338", nrightarrow: "\u219B", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvDash: "\u22AD", nvHarr: "\u2904", nvap: "\u224D\u20D2", nvdash: "\u22AC", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwArr: "\u21D6", nwarhk: "\u2923", nwarr: "\u2196", nwarrow: "\u2196", nwnear: "\u2927", oS: "\u24C8", oacute: "\xF3", oast: "\u229B", ocir: "\u229A", ocirc: "\xF4", ocy: "\u043E", odash: "\u229D", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", oelig: "\u0153", ofcir: "\u29BF", ofr: "\u{1D52C}", ogon: "\u02DB", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", omacr: "\u014D", omega: "\u03C9", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", oopf: "\u{1D560}", opar: "\u29B7", operp: "\u29B9", oplus: "\u2295", or: "\u2228", orarr: "\u21BB", ord: "\u2A5D", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oscr: "\u2134", oslash: "\xF8", osol: "\u2298", otilde: "\xF5", otimes: "\u2297", otimesas: "\u2A36", ouml: "\xF6", ovbar: "\u233D", par: "\u2225", para: "\xB6", parallel: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", pfr: "\u{1D52D}", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plus: "+", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", pointint: "\u2A15", popf: "\u{1D561}", pound: "\xA3", pr: "\u227A", prE: "\u2AB3", prap: "\u2AB7", prcue: "\u227C", pre: "\u2AAF", prec: "\u227A", precapprox: "\u2AB7", preccurlyeq: "\u227C", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", precsim: "\u227E", prime: "\u2032", primes: "\u2119", prnE: "\u2AB5", prnap: "\u2AB9", prnsim: "\u22E8", prod: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", pscr: "\u{1D4C5}", psi: "\u03C8", puncsp: "\u2008", qfr: "\u{1D52E}", qint: "\u2A0C", qopf: "\u{1D562}", qprime: "\u2057", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", quot: '"', rAarr: "\u21DB", rArr: "\u21D2", rAtail: "\u291C", rBarr: "\u290F", rHar: "\u2964", race: "\u223D\u0331", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", rang: "\u27E9", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raquo: "\xBB", rarr: "\u2192", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", rarrtl: "\u21A3", rarrw: "\u219D", ratail: "\u291A", ratio: "\u2236", rationals: "\u211A", rbarr: "\u290D", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", rcaron: "\u0159", rcedil: "\u0157", rceil: "\u2309", rcub: "}", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", rect: "\u25AD", reg: "\xAE", rfisht: "\u297D", rfloor: "\u230B", rfr: "\u{1D52F}", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", rho: "\u03C1", rhov: "\u03F1", rightarrow: "\u2192", rightarrowtail: "\u21A3", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", rightthreetimes: "\u22CC", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoust: "\u23B1", rmoustache: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", ropf: "\u{1D563}", roplus: "\u2A2E", rotimes: "\u2A35", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", rsaquo: "\u203A", rscr: "\u{1D4C7}", rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", ruluhar: "\u2968", rx: "\u211E", sacute: "\u015B", sbquo: "\u201A", sc: "\u227B", scE: "\u2AB4", scap: "\u2AB8", scaron: "\u0161", sccue: "\u227D", sce: "\u2AB0", scedil: "\u015F", scirc: "\u015D", scnE: "\u2AB6", scnap: "\u2ABA", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", scy: "\u0441", sdot: "\u22C5", sdotb: "\u22A1", sdote: "\u2A66", seArr: "\u21D8", searhk: "\u2925", searr: "\u2198", searrow: "\u2198", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", shchcy: "\u0449", shcy: "\u0448", shortmid: "\u2223", shortparallel: "\u2225", shy: "\xAD", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", softcy: "\u044C", sol: "/", solb: "\u29C4", solbar: "\u233F", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", squ: "\u25A1", square: "\u25A1", squarf: "\u25AA", squf: "\u25AA", srarr: "\u2192", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", sub: "\u2282", subE: "\u2AC5", subdot: "\u2ABD", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", subset: "\u2282", subseteq: "\u2286", subseteqq: "\u2AC5", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succ: "\u227B", succapprox: "\u2AB8", succcurlyeq: "\u227D", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", sum: "\u2211", sung: "\u266A", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", sup: "\u2283", supE: "\u2AC6", supdot: "\u2ABE", supdsub: "\u2AD8", supe: "\u2287", supedot: "\u2AC4", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", supset: "\u2283", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swArr: "\u21D9", swarhk: "\u2926", swarr: "\u2199", swarrow: "\u2199", swnwar: "\u292A", szlig: "\xDF", target: "\u2316", tau: "\u03C4", tbrk: "\u23B4", tcaron: "\u0165", tcedil: "\u0163", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", tfr: "\u{1D531}", there4: "\u2234", therefore: "\u2234", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", thinsp: "\u2009", thkap: "\u2248", thksim: "\u223C", thorn: "\xFE", tilde: "\u02DC", times: "\xD7", timesb: "\u22A0", timesbar: "\u2A31", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", top: "\u22A4", topbot: "\u2336", topcir: "\u2AF1", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", trade: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", tscr: "\u{1D4C9}", tscy: "\u0446", tshcy: "\u045B", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", uArr: "\u21D1", uHar: "\u2963", uacute: "\xFA", uarr: "\u2191", ubrcy: "\u045E", ubreve: "\u016D", ucirc: "\xFB", ucy: "\u0443", udarr: "\u21C5", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", ufr: "\u{1D532}", ugrave: "\xF9", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", umacr: "\u016B", uml: "\xA8", uogon: "\u0173", uopf: "\u{1D566}", uparrow: "\u2191", updownarrow: "\u2195", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", upsi: "\u03C5", upsih: "\u03D2", upsilon: "\u03C5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", uring: "\u016F", urtri: "\u25F9", uscr: "\u{1D4CA}", utdot: "\u22F0", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", uuml: "\xFC", uwangle: "\u29A7", vArr: "\u21D5", vBar: "\u2AE8", vBarv: "\u2AE9", vDash: "\u22A8", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", varr: "\u2195", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", vcy: "\u0432", vdash: "\u22A2", vee: "\u2228", veebar: "\u22BB", veeeq: "\u225A", vellip: "\u22EE", verbar: "|", vert: "|", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", vzigzag: "\u299A", wcirc: "\u0175", wedbar: "\u2A5F", wedge: "\u2227", wedgeq: "\u2259", weierp: "\u2118", wfr: "\u{1D534}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", xfr: "\u{1D535}", xhArr: "\u27FA", xharr: "\u27F7", xi: "\u03BE", xlArr: "\u27F8", xlarr: "\u27F5", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrArr: "\u27F9", xrarr: "\u27F6", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", yacute: "\xFD", yacy: "\u044F", ycirc: "\u0177", ycy: "\u044B", yen: "\xA5", yfr: "\u{1D536}", yicy: "\u0457", yopf: "\u{1D56A}", yscr: "\u{1D4CE}", yucy: "\u044E", yuml: "\xFF", zacute: "\u017A", zcaron: "\u017E", zcy: "\u0437", zdot: "\u017C", zeetrf: "\u2128", zeta: "\u03B6", zfr: "\u{1D537}", zhcy: "\u0436", zigrarr: "\u21DD", zopf: "\u{1D56B}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" }, $u = { 0: 65533, 128: 8364, 130: 8218, 131: 402, 132: 8222, 133: 8230, 134: 8224, 135: 8225, 136: 710, 137: 8240, 138: 352, 139: 8249, 140: 338, 142: 381, 145: 8216, 146: 8217, 147: 8220, 148: 8221, 149: 8226, 150: 8211, 151: 8212, 152: 732, 153: 8482, 154: 353, 155: 8250, 156: 339, 158: 382, 159: 376 };
          function D0(u) {
            return u.replace(/&(?:[a-zA-Z]+|#[xX][\da-fA-F]+|#\d+);/g, (e2) => {
              if (e2.charAt(1) === "#") {
                let i4 = e2.charAt(2), n = i4 === "X" || i4 === "x" ? parseInt(e2.slice(3), 16) : parseInt(e2.slice(2), 10);
                return C0(n);
              }
              return E0[e2.slice(1, -1)] || e2;
            });
          }
          function C0(u) {
            return u >= 55296 && u <= 57343 || u > 1114111 ? "\uFFFD" : (u in $u && (u = $u[u]), String.fromCodePoint(u));
          }
          function w0(u, e2) {
            return u.startPos = u.tokenPos = u.index, u.startColumn = u.colPos = u.column, u.startLine = u.linePos = u.line, u.token = V[u.currentChar] & 8192 ? q0(u, e2) : Yu(u, e2, 0), u.token;
          }
          function q0(u, e2) {
            let i4 = u.currentChar, n = r2(u), t4 = u.index;
            for (; n !== i4; )
              u.index >= u.end && f4(u, 14), n = r2(u);
            return n !== i4 && f4(u, 14), u.tokenValue = u.source.slice(t4, u.index), r2(u), e2 & 512 && (u.tokenRaw = u.source.slice(u.tokenPos, u.index)), 134283267;
          }
          function V2(u, e2) {
            if (u.startPos = u.tokenPos = u.index, u.startColumn = u.colPos = u.column, u.startLine = u.linePos = u.line, u.index >= u.end)
              return u.token = 1048576;
            switch (Wu[u.source.charCodeAt(u.index)]) {
              case 8456258: {
                r2(u), u.currentChar === 47 ? (r2(u), u.token = 25) : u.token = 8456258;
                break;
              }
              case 2162700: {
                r2(u), u.token = 2162700;
                break;
              }
              default: {
                let n = 0;
                for (; u.index < u.end; ) {
                  let o = V[u.source.charCodeAt(u.index)];
                  if (o & 1024 ? (n |= 5, X(u)) : o & 2048 ? (Y(u, n), n = n & -5 | 1) : r2(u), V[u.currentChar] & 16384)
                    break;
                }
                let t4 = u.source.slice(u.tokenPos, u.index);
                e2 & 512 && (u.tokenRaw = t4), u.tokenValue = D0(t4), u.token = 138;
              }
            }
            return u.token;
          }
          function N1(u) {
            if ((u.token & 143360) === 143360) {
              let { index: e2 } = u, i4 = u.currentChar;
              for (; V[i4] & 32770; )
                i4 = r2(u);
              u.tokenValue += u.source.slice(e2, u.index);
            }
            return u.token = 208897, u.token;
          }
          function d2(u, e2, i4) {
            (u.flags & 1) === 0 && (u.token & 1048576) !== 1048576 && !i4 && f4(u, 28, G[u.token & 255]), U(u, e2, 1074790417);
          }
          function Zu(u, e2, i4, n) {
            return e2 - i4 < 13 && n === "use strict" && ((u.token & 1048576) === 1048576 || u.flags & 1) ? 1 : 0;
          }
          function V1(u, e2, i4) {
            return u.token !== i4 ? 0 : (E(u, e2), 1);
          }
          function U(u, e2, i4) {
            return u.token !== i4 ? false : (E(u, e2), true);
          }
          function w(u, e2, i4) {
            u.token !== i4 && f4(u, 23, G[i4 & 255]), E(u, e2);
          }
          function v2(u, e2) {
            switch (e2.type) {
              case "ArrayExpression":
                e2.type = "ArrayPattern";
                let i4 = e2.elements;
                for (let t4 = 0, o = i4.length; t4 < o; ++t4) {
                  let l = i4[t4];
                  l && v2(u, l);
                }
                return;
              case "ObjectExpression":
                e2.type = "ObjectPattern";
                let n = e2.properties;
                for (let t4 = 0, o = n.length; t4 < o; ++t4)
                  v2(u, n[t4]);
                return;
              case "AssignmentExpression":
                e2.type = "AssignmentPattern", e2.operator !== "=" && f4(u, 68), delete e2.operator, v2(u, e2.left);
                return;
              case "Property":
                v2(u, e2.value);
                return;
              case "SpreadElement":
                e2.type = "RestElement", v2(u, e2.argument);
            }
          }
          function o1(u, e2, i4, n, t4) {
            e2 & 1024 && ((n & 36864) === 36864 && f4(u, 114), !t4 && (n & 537079808) === 537079808 && f4(u, 115)), (n & 20480) === 20480 && f4(u, 99), i4 & 24 && n === 241739 && f4(u, 97), e2 & 4196352 && n === 209008 && f4(u, 95), e2 & 2098176 && n === 241773 && f4(u, 94, "yield");
          }
          function Qu(u, e2, i4) {
            e2 & 1024 && ((i4 & 36864) === 36864 && f4(u, 114), (i4 & 537079808) === 537079808 && f4(u, 115), i4 === 122 && f4(u, 92), i4 === 121 && f4(u, 92)), (i4 & 20480) === 20480 && f4(u, 99), e2 & 4196352 && i4 === 209008 && f4(u, 95), e2 & 2098176 && i4 === 241773 && f4(u, 94, "yield");
          }
          function Gu(u, e2, i4) {
            return i4 === 209008 && (e2 & 4196352 && f4(u, 95), u.destructible |= 128), i4 === 241773 && e2 & 2097152 && f4(u, 94, "yield"), (i4 & 20480) === 20480 || (i4 & 36864) === 36864 || i4 == 122;
          }
          function B0(u) {
            return u.property ? u.property.type === "PrivateIdentifier" : false;
          }
          function xu(u, e2, i4, n) {
            for (; e2; ) {
              if (e2["$" + i4])
                return n && f4(u, 133), 1;
              n && e2.loop && (n = 0), e2 = e2.$;
            }
            return 0;
          }
          function S0(u, e2, i4) {
            let n = e2;
            for (; n; )
              n["$" + i4] && f4(u, 132, i4), n = n.$;
            e2["$" + i4] = 1;
          }
          function v(u, e2, i4, n, t4, o) {
            return e2 & 2 && (o.start = i4, o.end = u.startPos, o.range = [i4, u.startPos]), e2 & 4 && (o.loc = { start: { line: n, column: t4 }, end: { line: u.startLine, column: u.startColumn } }, u.sourceFile && (o.loc.source = u.sourceFile)), o;
          }
          function l1(u) {
            switch (u.type) {
              case "JSXIdentifier":
                return u.name;
              case "JSXNamespacedName":
                return u.namespace + ":" + u.name;
              case "JSXMemberExpression":
                return l1(u.object) + "." + l1(u.property);
            }
          }
          function f1(u, e2, i4) {
            let n = o2(j2(), 1024);
            return B2(u, e2, n, i4, 1, 0), n;
          }
          function j1(u, e2) {
            let { index: i4, line: n, column: t4 } = u;
            for (var o = arguments.length, l = new Array(o > 2 ? o - 2 : 0), c = 2; c < o; c++)
              l[c - 2] = arguments[c];
            return { type: e2, params: l, index: i4, line: n, column: t4 };
          }
          function j2() {
            return { parent: void 0, type: 2 };
          }
          function o2(u, e2) {
            return { parent: u, type: e2, scopeError: void 0 };
          }
          function q2(u, e2, i4, n, t4, o) {
            t4 & 4 ? pu(u, e2, i4, n, t4) : B2(u, e2, i4, n, t4, o), o & 64 && _2(u, n);
          }
          function B2(u, e2, i4, n, t4, o) {
            let l = i4["#" + n];
            l && (l & 2) === 0 && (t4 & 1 ? i4.scopeError = j1(u, 140, n) : e2 & 256 && l & 64 && o & 2 || f4(u, 140, n)), i4.type & 128 && i4.parent["#" + n] && (i4.parent["#" + n] & 2) === 0 && f4(u, 140, n), i4.type & 1024 && l && (l & 2) === 0 && t4 & 1 && (i4.scopeError = j1(u, 140, n)), i4.type & 64 && i4.parent["#" + n] & 768 && f4(u, 153, n), i4["#" + n] = t4;
          }
          function pu(u, e2, i4, n, t4) {
            let o = i4;
            for (; o && (o.type & 256) === 0; ) {
              let l = o["#" + n];
              l & 248 && (e2 & 256 && (e2 & 1024) === 0 && (t4 & 128 && l & 68 || l & 128 && t4 & 68) || f4(u, 140, n)), o === i4 && l & 1 && t4 & 1 && (o.scopeError = j1(u, 140, n)), l & 768 && ((l & 512) === 0 || (e2 & 256) === 0 || e2 & 1024) && f4(u, 140, n), o["#" + n] = t4, o = o.parent;
            }
          }
          function _2(u, e2) {
            u.exportedNames !== void 0 && e2 !== "" && (u.exportedNames["#" + e2] && f4(u, 141, e2), u.exportedNames["#" + e2] = 1);
          }
          function F0(u, e2) {
            u.exportedBindings !== void 0 && e2 !== "" && (u.exportedBindings["#" + e2] = 1);
          }
          function T0(u, e2) {
            return function(i4, n, t4, o, l) {
              let c = { type: i4, value: n };
              u & 2 && (c.start = t4, c.end = o, c.range = [t4, o]), u & 4 && (c.loc = l), e2.push(c);
            };
          }
          function L0(u, e2) {
            return function(i4, n, t4, o) {
              let l = { token: i4 };
              u & 2 && (l.start = n, l.end = t4, l.range = [n, t4]), u & 4 && (l.loc = o), e2.push(l);
            };
          }
          function _1(u, e2) {
            return u & 2098176 ? u & 2048 && e2 === 209008 || u & 2097152 && e2 === 241773 ? false : (e2 & 143360) === 143360 || (e2 & 12288) === 12288 : (e2 & 143360) === 143360 || (e2 & 12288) === 12288 || (e2 & 36864) === 36864;
          }
          function M1(u, e2, i4, n) {
            (i4 & 537079808) === 537079808 && (e2 & 1024 && f4(u, 115), n && (u.flags |= 512)), _1(e2, i4) || f4(u, 0);
          }
          function O0(u, e2, i4, n) {
            return { source: u, flags: 0, index: 0, line: 1, column: 0, startPos: 0, end: u.length, tokenPos: 0, startColumn: 0, colPos: 0, linePos: 1, startLine: 1, sourceFile: e2, tokenValue: "", token: 1048576, tokenRaw: "", tokenRegExp: void 0, currentChar: u.charCodeAt(0), exportedNames: [], exportedBindings: [], assignable: 1, destructible: 0, onComment: i4, onToken: n, leadingDecorators: [] };
          }
          function U1(u, e2, i4) {
            let n = "", t4, o;
            e2 != null && (e2.module && (i4 |= 3072), e2.next && (i4 |= 1), e2.loc && (i4 |= 4), e2.ranges && (i4 |= 2), e2.uniqueKeyInPattern && (i4 |= -2147483648), e2.lexical && (i4 |= 64), e2.webcompat && (i4 |= 256), e2.directives && (i4 |= 520), e2.globalReturn && (i4 |= 32), e2.raw && (i4 |= 512), e2.preserveParens && (i4 |= 128), e2.impliedStrict && (i4 |= 1024), e2.jsx && (i4 |= 16), e2.identifierPattern && (i4 |= 268435456), e2.specDeviation && (i4 |= 536870912), e2.source && (n = e2.source), e2.onComment != null && (t4 = Array.isArray(e2.onComment) ? T0(i4, e2.onComment) : e2.onComment), e2.onToken != null && (o = Array.isArray(e2.onToken) ? L0(i4, e2.onToken) : e2.onToken));
            let l = O0(u, n, t4, o);
            i4 & 1 && c2(l);
            let c = i4 & 64 ? j2() : void 0, s4 = [], h4 = "script";
            if (i4 & 2048) {
              if (h4 = "module", s4 = R0(l, i4 | 8192, c), c)
                for (let g in l.exportedBindings)
                  g[0] === "#" && !c[g] && f4(l, 142, g.slice(1));
            } else
              s4 = I0(l, i4 | 8192, c);
            let b = { type: "Program", sourceType: h4, body: s4 };
            return i4 & 2 && (b.start = 0, b.end = u.length, b.range = [0, u.length]), i4 & 4 && (b.loc = { start: { line: 1, column: 0 }, end: { line: l.line, column: l.column } }, l.sourceFile && (b.loc.source = n)), b;
          }
          function I0(u, e2, i4) {
            E(u, e2 | 32768 | 1073741824);
            let n = [];
            for (; u.token === 134283267; ) {
              let { index: t4, tokenPos: o, tokenValue: l, linePos: c, colPos: s4, token: h4 } = u, b = a2(u, e2);
              Zu(u, t4, o, l) && (e2 |= 1024), n.push(X1(u, e2, b, h4, o, c, s4));
            }
            for (; u.token !== 1048576; )
              n.push(G2(u, e2, i4, 4, {}));
            return n;
          }
          function R0(u, e2, i4) {
            E(u, e2 | 32768);
            let n = [];
            if (e2 & 8)
              for (; u.token === 134283267; ) {
                let { tokenPos: t4, linePos: o, colPos: l, token: c } = u;
                n.push(X1(u, e2, a2(u, e2), c, t4, o, l));
              }
            for (; u.token !== 1048576; )
              n.push(N0(u, e2, i4));
            return n;
          }
          function N0(u, e2, i4) {
            u.leadingDecorators = b1(u, e2);
            let n;
            switch (u.token) {
              case 20566:
                n = ut(u, e2, i4);
                break;
              case 86108:
                n = x0(u, e2, i4);
                break;
              default:
                n = G2(u, e2, i4, 4, {});
            }
            return u.leadingDecorators.length && f4(u, 164), n;
          }
          function G2(u, e2, i4, n, t4) {
            let o = u.tokenPos, l = u.linePos, c = u.colPos;
            switch (u.token) {
              case 86106:
                return T2(u, e2, i4, n, 1, 0, 0, o, l, c);
              case 133:
              case 86096:
                return Z1(u, e2, i4, 0, o, l, c);
              case 86092:
                return z1(u, e2, i4, 16, 0, o, l, c);
              case 241739:
                return Q0(u, e2, i4, n, o, l, c);
              case 20566:
                f4(u, 100, "export");
              case 86108:
                switch (E(u, e2), u.token) {
                  case 67174411:
                    return ce(u, e2, o, l, c);
                  case 67108877:
                    return fe(u, e2, o, l, c);
                  default:
                    f4(u, 100, "import");
                }
              case 209007:
                return ue(u, e2, i4, n, t4, 1, o, l, c);
              default:
                return x2(u, e2, i4, n, t4, 1, o, l, c);
            }
          }
          function x2(u, e2, i4, n, t4, o, l, c, s4) {
            switch (u.token) {
              case 86090:
                return ie(u, e2, i4, 0, l, c, s4);
              case 20574:
                return j0(u, e2, l, c, s4);
              case 20571:
                return U0(u, e2, i4, t4, l, c, s4);
              case 20569:
                return G0(u, e2, i4, t4, l, c, s4);
              case 20564:
                return Z0(u, e2, i4, t4, l, c, s4);
              case 20580:
                return X0(u, e2, i4, t4, l, c, s4);
              case 86112:
                return J0(u, e2, i4, t4, l, c, s4);
              case 1074790417:
                return _0(u, e2, l, c, s4);
              case 2162700:
                return c1(u, e2, i4 && o2(i4, 2), t4, l, c, s4);
              case 86114:
                return M0(u, e2, l, c, s4);
              case 20557:
                return H0(u, e2, t4, l, c, s4);
              case 20561:
                return z0(u, e2, t4, l, c, s4);
              case 20579:
                return Y0(u, e2, i4, t4, l, c, s4);
              case 20581:
                return K0(u, e2, i4, t4, l, c, s4);
              case 20562:
                return W0(u, e2, l, c, s4);
              case 209007:
                return ue(u, e2, i4, n, t4, 0, l, c, s4);
              case 20559:
                f4(u, 156);
              case 20568:
                f4(u, 157);
              case 86106:
                f4(u, e2 & 1024 ? 73 : (e2 & 256) < 1 ? 75 : 74);
              case 86096:
                f4(u, 76);
              default:
                return V0(u, e2, i4, n, t4, o, l, c, s4);
            }
          }
          function V0(u, e2, i4, n, t4, o, l, c, s4) {
            let { tokenValue: h4, token: b } = u, g;
            switch (b) {
              case 241739:
                g = z(u, e2, 0), e2 & 1024 && f4(u, 82), u.token === 69271571 && f4(u, 81);
                break;
              default:
                g = h2(u, e2, 2, 0, 1, 0, 0, 1, u.tokenPos, u.linePos, u.colPos);
            }
            return b & 143360 && u.token === 21 ? J1(u, e2, i4, n, t4, h4, g, b, o, l, c, s4) : (g = W(u, e2, g, 0, 0, l, c, s4), g = x3(u, e2, 0, 0, l, c, s4, g), u.token === 18 && (g = S22(u, e2, 0, l, c, s4, g)), H2(u, e2, g, l, c, s4));
          }
          function c1(u, e2, i4, n, t4, o, l) {
            let c = [];
            for (w(u, e2 | 32768, 2162700); u.token !== 1074790415; )
              c.push(G2(u, e2, i4, 2, { $: n }));
            return w(u, e2 | 32768, 1074790415), v(u, e2, t4, o, l, { type: "BlockStatement", body: c });
          }
          function j0(u, e2, i4, n, t4) {
            (e2 & 32) < 1 && e2 & 8192 && f4(u, 89), E(u, e2 | 32768);
            let o = u.flags & 1 || u.token & 1048576 ? null : f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos);
            return d2(u, e2 | 32768), v(u, e2, i4, n, t4, { type: "ReturnStatement", argument: o });
          }
          function H2(u, e2, i4, n, t4, o) {
            return d2(u, e2 | 32768), v(u, e2, n, t4, o, { type: "ExpressionStatement", expression: i4 });
          }
          function J1(u, e2, i4, n, t4, o, l, c, s4, h4, b, g) {
            o1(u, e2, 0, c, 1), S0(u, t4, o), E(u, e2 | 32768);
            let a = s4 && (e2 & 1024) < 1 && e2 & 256 && u.token === 86106 ? T2(u, e2, o2(i4, 2), n, 0, 0, 0, u.tokenPos, u.linePos, u.colPos) : x2(u, e2, i4, n, t4, s4, u.tokenPos, u.linePos, u.colPos);
            return v(u, e2, h4, b, g, { type: "LabeledStatement", label: l, body: a });
          }
          function ue(u, e2, i4, n, t4, o, l, c, s4) {
            let { token: h4, tokenValue: b } = u, g = z(u, e2, 0);
            if (u.token === 21)
              return J1(u, e2, i4, n, t4, b, g, h4, 1, l, c, s4);
            let a = u.flags & 1;
            if (!a) {
              if (u.token === 86106)
                return o || f4(u, 119), T2(u, e2, i4, n, 1, 0, 1, l, c, s4);
              if ((u.token & 143360) === 143360)
                return g = ke(u, e2, 1, l, c, s4), u.token === 18 && (g = S22(u, e2, 0, l, c, s4, g)), H2(u, e2, g, l, c, s4);
            }
            return u.token === 67174411 ? g = $1(u, e2, g, 1, 1, 0, a, l, c, s4) : (u.token === 10 && (M1(u, e2, h4, 1), g = g1(u, e2, u.tokenValue, g, 0, 1, 0, l, c, s4)), u.assignable = 1), g = W(u, e2, g, 0, 0, l, c, s4), u.token === 18 && (g = S22(u, e2, 0, l, c, s4, g)), g = x3(u, e2, 0, 0, l, c, s4, g), u.assignable = 1, H2(u, e2, g, l, c, s4);
          }
          function X1(u, e2, i4, n, t4, o, l) {
            return n !== 1074790417 && (u.assignable = 2, i4 = W(u, e2, i4, 0, 0, t4, o, l), u.token !== 1074790417 && (i4 = x3(u, e2, 0, 0, t4, o, l, i4), u.token === 18 && (i4 = S22(u, e2, 0, t4, o, l, i4))), d2(u, e2 | 32768)), e2 & 8 && i4.type === "Literal" && typeof i4.value == "string" ? v(u, e2, t4, o, l, { type: "ExpressionStatement", expression: i4, directive: i4.raw.slice(1, -1) }) : v(u, e2, t4, o, l, { type: "ExpressionStatement", expression: i4 });
          }
          function _0(u, e2, i4, n, t4) {
            return E(u, e2 | 32768), v(u, e2, i4, n, t4, { type: "EmptyStatement" });
          }
          function M0(u, e2, i4, n, t4) {
            E(u, e2 | 32768), u.flags & 1 && f4(u, 87);
            let o = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos);
            return d2(u, e2 | 32768), v(u, e2, i4, n, t4, { type: "ThrowStatement", argument: o });
          }
          function U0(u, e2, i4, n, t4, o, l) {
            E(u, e2), w(u, e2 | 32768, 67174411), u.assignable = 1;
            let c = f22(u, e2, 0, 1, u.tokenPos, u.line, u.colPos);
            w(u, e2 | 32768, 16);
            let s4 = ee(u, e2, i4, n, u.tokenPos, u.linePos, u.colPos), h4 = null;
            return u.token === 20565 && (E(u, e2 | 32768), h4 = ee(u, e2, i4, n, u.tokenPos, u.linePos, u.colPos)), v(u, e2, t4, o, l, { type: "IfStatement", test: c, consequent: s4, alternate: h4 });
          }
          function ee(u, e2, i4, n, t4, o, l) {
            return e2 & 1024 || (e2 & 256) < 1 || u.token !== 86106 ? x2(u, e2, i4, 0, { $: n }, 0, u.tokenPos, u.linePos, u.colPos) : T2(u, e2, o2(i4, 2), 0, 0, 0, 0, t4, o, l);
          }
          function J0(u, e2, i4, n, t4, o, l) {
            E(u, e2), w(u, e2 | 32768, 67174411);
            let c = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos);
            w(u, e2, 16), w(u, e2, 2162700);
            let s4 = [], h4 = 0;
            for (i4 && (i4 = o2(i4, 8)); u.token !== 1074790415; ) {
              let { tokenPos: b, linePos: g, colPos: a } = u, A4 = null, C = [];
              for (U(u, e2 | 32768, 20558) ? A4 = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos) : (w(u, e2 | 32768, 20563), h4 && f4(u, 86), h4 = 1), w(u, e2 | 32768, 21); u.token !== 20558 && u.token !== 1074790415 && u.token !== 20563; )
                C.push(G2(u, e2 | 4096, i4, 2, { $: n }));
              s4.push(v(u, e2, b, g, a, { type: "SwitchCase", test: A4, consequent: C }));
            }
            return w(u, e2 | 32768, 1074790415), v(u, e2, t4, o, l, { type: "SwitchStatement", discriminant: c, cases: s4 });
          }
          function X0(u, e2, i4, n, t4, o, l) {
            E(u, e2), w(u, e2 | 32768, 67174411);
            let c = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos);
            w(u, e2 | 32768, 16);
            let s4 = p2(u, e2, i4, n);
            return v(u, e2, t4, o, l, { type: "WhileStatement", test: c, body: s4 });
          }
          function p2(u, e2, i4, n) {
            return x2(u, (e2 | 134217728) ^ 134217728 | 131072, i4, 0, { loop: 1, $: n }, 0, u.tokenPos, u.linePos, u.colPos);
          }
          function z0(u, e2, i4, n, t4, o) {
            (e2 & 131072) < 1 && f4(u, 65), E(u, e2);
            let l = null;
            if ((u.flags & 1) < 1 && u.token & 143360) {
              let { tokenValue: c } = u;
              l = z(u, e2 | 32768, 0), xu(u, i4, c, 1) || f4(u, 134, c);
            }
            return d2(u, e2 | 32768), v(u, e2, n, t4, o, { type: "ContinueStatement", label: l });
          }
          function H0(u, e2, i4, n, t4, o) {
            E(u, e2 | 32768);
            let l = null;
            if ((u.flags & 1) < 1 && u.token & 143360) {
              let { tokenValue: c } = u;
              l = z(u, e2 | 32768, 0), xu(u, i4, c, 0) || f4(u, 134, c);
            } else
              (e2 & 135168) < 1 && f4(u, 66);
            return d2(u, e2 | 32768), v(u, e2, n, t4, o, { type: "BreakStatement", label: l });
          }
          function K0(u, e2, i4, n, t4, o, l) {
            E(u, e2), e2 & 1024 && f4(u, 88), w(u, e2 | 32768, 67174411);
            let c = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos);
            w(u, e2 | 32768, 16);
            let s4 = x2(u, e2, i4, 2, n, 0, u.tokenPos, u.linePos, u.colPos);
            return v(u, e2, t4, o, l, { type: "WithStatement", object: c, body: s4 });
          }
          function W0(u, e2, i4, n, t4) {
            return E(u, e2 | 32768), d2(u, e2 | 32768), v(u, e2, i4, n, t4, { type: "DebuggerStatement" });
          }
          function Y0(u, e2, i4, n, t4, o, l) {
            E(u, e2 | 32768);
            let c = i4 ? o2(i4, 32) : void 0, s4 = c1(u, e2, c, { $: n }, u.tokenPos, u.linePos, u.colPos), { tokenPos: h4, linePos: b, colPos: g } = u, a = U(u, e2 | 32768, 20559) ? $0(u, e2, i4, n, h4, b, g) : null, A4 = null;
            if (u.token === 20568) {
              E(u, e2 | 32768);
              let C = c ? o2(i4, 4) : void 0;
              A4 = c1(u, e2, C, { $: n }, u.tokenPos, u.linePos, u.colPos);
            }
            return !a && !A4 && f4(u, 85), v(u, e2, t4, o, l, { type: "TryStatement", block: s4, handler: a, finalizer: A4 });
          }
          function $0(u, e2, i4, n, t4, o, l) {
            let c = null, s4 = i4;
            U(u, e2, 67174411) && (i4 && (i4 = o2(i4, 4)), c = Ae(u, e2, i4, (u.token & 2097152) === 2097152 ? 256 : 512, 0, u.tokenPos, u.linePos, u.colPos), u.token === 18 ? f4(u, 83) : u.token === 1077936157 && f4(u, 84), w(u, e2 | 32768, 16), i4 && (s4 = o2(i4, 64)));
            let h4 = c1(u, e2, s4, { $: n }, u.tokenPos, u.linePos, u.colPos);
            return v(u, e2, t4, o, l, { type: "CatchClause", param: c, body: h4 });
          }
          function Z0(u, e2, i4, n, t4, o, l) {
            E(u, e2 | 32768);
            let c = p2(u, e2, i4, n);
            w(u, e2, 20580), w(u, e2 | 32768, 67174411);
            let s4 = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos);
            return w(u, e2 | 32768, 16), U(u, e2, 1074790417), v(u, e2, t4, o, l, { type: "DoWhileStatement", body: c, test: s4 });
          }
          function Q0(u, e2, i4, n, t4, o, l) {
            let { token: c, tokenValue: s4 } = u, h4 = z(u, e2, 0);
            if (u.token & 2240512) {
              let b = K2(u, e2, i4, 8, 0);
              return d2(u, e2 | 32768), v(u, e2, t4, o, l, { type: "VariableDeclaration", kind: "let", declarations: b });
            }
            if (u.assignable = 1, e2 & 1024 && f4(u, 82), u.token === 21)
              return J1(u, e2, i4, n, {}, s4, h4, c, 0, t4, o, l);
            if (u.token === 10) {
              let b;
              e2 & 64 && (b = f1(u, e2, s4)), u.flags = (u.flags | 128) ^ 128, h4 = u1(u, e2, b, [h4], 0, t4, o, l);
            } else
              h4 = W(u, e2, h4, 0, 0, t4, o, l), h4 = x3(u, e2, 0, 0, t4, o, l, h4);
            return u.token === 18 && (h4 = S22(u, e2, 0, t4, o, l, h4)), H2(u, e2, h4, t4, o, l);
          }
          function z1(u, e2, i4, n, t4, o, l, c) {
            E(u, e2);
            let s4 = K2(u, e2, i4, n, t4);
            return d2(u, e2 | 32768), v(u, e2, o, l, c, { type: "VariableDeclaration", kind: n & 8 ? "let" : "const", declarations: s4 });
          }
          function ie(u, e2, i4, n, t4, o, l) {
            E(u, e2);
            let c = K2(u, e2, i4, 4, n);
            return d2(u, e2 | 32768), v(u, e2, t4, o, l, { type: "VariableDeclaration", kind: "var", declarations: c });
          }
          function K2(u, e2, i4, n, t4) {
            let o = 1, l = [ne(u, e2, i4, n, t4)];
            for (; U(u, e2, 18); )
              o++, l.push(ne(u, e2, i4, n, t4));
            return o > 1 && t4 & 32 && u.token & 262144 && f4(u, 58, G[u.token & 255]), l;
          }
          function ne(u, e2, i4, n, t4) {
            let { token: o, tokenPos: l, linePos: c, colPos: s4 } = u, h4 = null, b = Ae(u, e2, i4, n, t4, l, c, s4);
            return u.token === 1077936157 ? (E(u, e2 | 32768), h4 = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos), (t4 & 32 || (o & 2097152) < 1) && (u.token === 274549 || u.token === 8738868 && (o & 2097152 || (n & 4) < 1 || e2 & 1024)) && S2(l, u.line, u.index - 3, 57, u.token === 274549 ? "of" : "in")) : (n & 16 || (o & 2097152) > 0) && (u.token & 262144) !== 262144 && f4(u, 56, n & 16 ? "const" : "destructuring"), v(u, e2, l, c, s4, { type: "VariableDeclarator", id: b, init: h4 });
          }
          function G0(u, e2, i4, n, t4, o, l) {
            E(u, e2);
            let c = (e2 & 4194304) > 0 && U(u, e2, 209008);
            w(u, e2 | 32768, 67174411), i4 && (i4 = o2(i4, 1));
            let s4 = null, h4 = null, b = 0, g = null, a = u.token === 86090 || u.token === 241739 || u.token === 86092, A4, { token: C, tokenPos: D, linePos: B, colPos: O } = u;
            if (a ? C === 241739 ? (g = z(u, e2, 0), u.token & 2240512 ? (u.token === 8738868 ? e2 & 1024 && f4(u, 64) : g = v(u, e2, D, B, O, { type: "VariableDeclaration", kind: "let", declarations: K2(u, e2 | 134217728, i4, 8, 32) }), u.assignable = 1) : e2 & 1024 ? f4(u, 64) : (a = false, u.assignable = 1, g = W(u, e2, g, 0, 0, D, B, O), u.token === 274549 && f4(u, 111))) : (E(u, e2), g = v(u, e2, D, B, O, C === 86090 ? { type: "VariableDeclaration", kind: "var", declarations: K2(u, e2 | 134217728, i4, 4, 32) } : { type: "VariableDeclaration", kind: "const", declarations: K2(u, e2 | 134217728, i4, 16, 32) }), u.assignable = 1) : C === 1074790417 ? c && f4(u, 79) : (C & 2097152) === 2097152 ? (g = C === 2162700 ? r22(u, e2, void 0, 1, 0, 0, 2, 32, D, B, O) : k2(u, e2, void 0, 1, 0, 0, 2, 32, D, B, O), b = u.destructible, e2 & 256 && b & 64 && f4(u, 60), u.assignable = b & 16 ? 2 : 1, g = W(u, e2 | 134217728, g, 0, 0, u.tokenPos, u.linePos, u.colPos)) : g = b2(u, e2 | 134217728, 1, 0, 1, D, B, O), (u.token & 262144) === 262144) {
              if (u.token === 274549) {
                u.assignable & 2 && f4(u, 77, c ? "await" : "of"), v2(u, g), E(u, e2 | 32768), A4 = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos), w(u, e2 | 32768, 16);
                let R = p2(u, e2, i4, n);
                return v(u, e2, t4, o, l, { type: "ForOfStatement", left: g, right: A4, body: R, await: c });
              }
              u.assignable & 2 && f4(u, 77, "in"), v2(u, g), E(u, e2 | 32768), c && f4(u, 79), A4 = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos), w(u, e2 | 32768, 16);
              let e22 = p2(u, e2, i4, n);
              return v(u, e2, t4, o, l, { type: "ForInStatement", body: e22, left: g, right: A4 });
            }
            c && f4(u, 79), a || (b & 8 && u.token !== 1077936157 && f4(u, 77, "loop"), g = x3(u, e2 | 134217728, 0, 0, D, B, O, g)), u.token === 18 && (g = S22(u, e2, 0, u.tokenPos, u.linePos, u.colPos, g)), w(u, e2 | 32768, 1074790417), u.token !== 1074790417 && (s4 = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos)), w(u, e2 | 32768, 1074790417), u.token !== 16 && (h4 = f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos)), w(u, e2 | 32768, 16);
            let j = p2(u, e2, i4, n);
            return v(u, e2, t4, o, l, { type: "ForStatement", init: g, test: s4, update: h4, body: j });
          }
          function te(u, e2, i4) {
            return _1(e2, u.token) || f4(u, 114), (u.token & 537079808) === 537079808 && f4(u, 115), i4 && B2(u, e2, i4, u.tokenValue, 8, 0), z(u, e2, 0);
          }
          function x0(u, e2, i4) {
            let n = u.tokenPos, t4 = u.linePos, o = u.colPos;
            E(u, e2);
            let l = null, { tokenPos: c, linePos: s4, colPos: h4 } = u, b = [];
            if (u.token === 134283267)
              l = a2(u, e2);
            else {
              if (u.token & 143360) {
                let g = te(u, e2, i4);
                if (b = [v(u, e2, c, s4, h4, { type: "ImportDefaultSpecifier", local: g })], U(u, e2, 18))
                  switch (u.token) {
                    case 8457014:
                      b.push(oe(u, e2, i4));
                      break;
                    case 2162700:
                      le(u, e2, i4, b);
                      break;
                    default:
                      f4(u, 104);
                  }
              } else
                switch (u.token) {
                  case 8457014:
                    b = [oe(u, e2, i4)];
                    break;
                  case 2162700:
                    le(u, e2, i4, b);
                    break;
                  case 67174411:
                    return ce(u, e2, n, t4, o);
                  case 67108877:
                    return fe(u, e2, n, t4, o);
                  default:
                    f4(u, 28, G[u.token & 255]);
                }
              l = p0(u, e2);
            }
            return d2(u, e2 | 32768), v(u, e2, n, t4, o, { type: "ImportDeclaration", specifiers: b, source: l });
          }
          function oe(u, e2, i4) {
            let { tokenPos: n, linePos: t4, colPos: o } = u;
            return E(u, e2), w(u, e2, 77934), (u.token & 134217728) === 134217728 && S2(n, u.line, u.index, 28, G[u.token & 255]), v(u, e2, n, t4, o, { type: "ImportNamespaceSpecifier", local: te(u, e2, i4) });
          }
          function p0(u, e2) {
            return U(u, e2, 12404), u.token !== 134283267 && f4(u, 102, "Import"), a2(u, e2);
          }
          function le(u, e2, i4, n) {
            for (E(u, e2); u.token & 143360; ) {
              let { token: t4, tokenValue: o, tokenPos: l, linePos: c, colPos: s4 } = u, h4 = z(u, e2, 0), b;
              U(u, e2, 77934) ? ((u.token & 134217728) === 134217728 || u.token === 18 ? f4(u, 103) : o1(u, e2, 16, u.token, 0), o = u.tokenValue, b = z(u, e2, 0)) : (o1(u, e2, 16, t4, 0), b = h4), i4 && B2(u, e2, i4, o, 8, 0), n.push(v(u, e2, l, c, s4, { type: "ImportSpecifier", local: b, imported: h4 })), u.token !== 1074790415 && w(u, e2, 18);
            }
            return w(u, e2, 1074790415), n;
          }
          function fe(u, e2, i4, n, t4) {
            let o = ae(u, e2, v(u, e2, i4, n, t4, { type: "Identifier", name: "import" }), i4, n, t4);
            return o = W(u, e2, o, 0, 0, i4, n, t4), o = x3(u, e2, 0, 0, i4, n, t4, o), H2(u, e2, o, i4, n, t4);
          }
          function ce(u, e2, i4, n, t4) {
            let o = de(u, e2, 0, i4, n, t4);
            return o = W(u, e2, o, 0, 0, i4, n, t4), H2(u, e2, o, i4, n, t4);
          }
          function ut(u, e2, i4) {
            let n = u.tokenPos, t4 = u.linePos, o = u.colPos;
            E(u, e2 | 32768);
            let l = [], c = null, s4 = null, h4;
            if (U(u, e2 | 32768, 20563)) {
              switch (u.token) {
                case 86106: {
                  c = T2(u, e2, i4, 4, 1, 1, 0, u.tokenPos, u.linePos, u.colPos);
                  break;
                }
                case 133:
                case 86096:
                  c = Z1(u, e2, i4, 1, u.tokenPos, u.linePos, u.colPos);
                  break;
                case 209007:
                  let { tokenPos: b, linePos: g, colPos: a } = u;
                  c = z(u, e2, 0);
                  let { flags: A4 } = u;
                  (A4 & 1) < 1 && (u.token === 86106 ? c = T2(u, e2, i4, 4, 1, 1, 1, b, g, a) : u.token === 67174411 ? (c = $1(u, e2, c, 1, 1, 0, A4, b, g, a), c = W(u, e2, c, 0, 0, b, g, a), c = x3(u, e2, 0, 0, b, g, a, c)) : u.token & 143360 && (i4 && (i4 = f1(u, e2, u.tokenValue)), c = z(u, e2, 0), c = u1(u, e2, i4, [c], 1, b, g, a)));
                  break;
                default:
                  c = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos), d2(u, e2 | 32768);
              }
              return i4 && _2(u, "default"), v(u, e2, n, t4, o, { type: "ExportDefaultDeclaration", declaration: c });
            }
            switch (u.token) {
              case 8457014: {
                E(u, e2);
                let A4 = null;
                return U(u, e2, 77934) && (i4 && _2(u, u.tokenValue), A4 = z(u, e2, 0)), w(u, e2, 12404), u.token !== 134283267 && f4(u, 102, "Export"), s4 = a2(u, e2), d2(u, e2 | 32768), v(u, e2, n, t4, o, { type: "ExportAllDeclaration", source: s4, exported: A4 });
              }
              case 2162700: {
                E(u, e2);
                let A4 = [], C = [];
                for (; u.token & 143360; ) {
                  let { tokenPos: D, tokenValue: B, linePos: O, colPos: j } = u, e22 = z(u, e2, 0), R;
                  u.token === 77934 ? (E(u, e2), (u.token & 134217728) === 134217728 && f4(u, 103), i4 && (A4.push(u.tokenValue), C.push(B)), R = z(u, e2, 0)) : (i4 && (A4.push(u.tokenValue), C.push(u.tokenValue)), R = e22), l.push(v(u, e2, D, O, j, { type: "ExportSpecifier", local: e22, exported: R })), u.token !== 1074790415 && w(u, e2, 18);
                }
                if (w(u, e2, 1074790415), U(u, e2, 12404))
                  u.token !== 134283267 && f4(u, 102, "Export"), s4 = a2(u, e2);
                else if (i4) {
                  let D = 0, B = A4.length;
                  for (; D < B; D++)
                    _2(u, A4[D]);
                  for (D = 0, B = C.length; D < B; D++)
                    F0(u, C[D]);
                }
                d2(u, e2 | 32768);
                break;
              }
              case 86096:
                c = Z1(u, e2, i4, 2, u.tokenPos, u.linePos, u.colPos);
                break;
              case 86106:
                c = T2(u, e2, i4, 4, 1, 2, 0, u.tokenPos, u.linePos, u.colPos);
                break;
              case 241739:
                c = z1(u, e2, i4, 8, 64, u.tokenPos, u.linePos, u.colPos);
                break;
              case 86092:
                c = z1(u, e2, i4, 16, 64, u.tokenPos, u.linePos, u.colPos);
                break;
              case 86090:
                c = ie(u, e2, i4, 64, u.tokenPos, u.linePos, u.colPos);
                break;
              case 209007:
                let { tokenPos: b, linePos: g, colPos: a } = u;
                if (E(u, e2), (u.flags & 1) < 1 && u.token === 86106) {
                  c = T2(u, e2, i4, 4, 1, 2, 1, b, g, a), i4 && (h4 = c.id ? c.id.name : "", _2(u, h4));
                  break;
                }
              default:
                f4(u, 28, G[u.token & 255]);
            }
            return v(u, e2, n, t4, o, { type: "ExportNamedDeclaration", declaration: c, specifiers: l, source: s4 });
          }
          function Q(u, e2, i4, n, t4, o, l, c) {
            let s4 = h2(u, e2, 2, 0, i4, n, t4, 1, o, l, c);
            return s4 = W(u, e2, s4, t4, 0, o, l, c), x3(u, e2, t4, 0, o, l, c, s4);
          }
          function S22(u, e2, i4, n, t4, o, l) {
            let c = [l];
            for (; U(u, e2 | 32768, 18); )
              c.push(Q(u, e2, 1, 0, i4, u.tokenPos, u.linePos, u.colPos));
            return v(u, e2, n, t4, o, { type: "SequenceExpression", expressions: c });
          }
          function f22(u, e2, i4, n, t4, o, l) {
            let c = Q(u, e2, n, 0, i4, t4, o, l);
            return u.token === 18 ? S22(u, e2, i4, t4, o, l, c) : c;
          }
          function x3(u, e2, i4, n, t4, o, l, c) {
            let { token: s4 } = u;
            if ((s4 & 4194304) === 4194304) {
              u.assignable & 2 && f4(u, 24), (!n && s4 === 1077936157 && c.type === "ArrayExpression" || c.type === "ObjectExpression") && v2(u, c), E(u, e2 | 32768);
              let h4 = Q(u, e2, 1, 1, i4, u.tokenPos, u.linePos, u.colPos);
              return u.assignable = 2, v(u, e2, t4, o, l, n ? { type: "AssignmentPattern", left: c, right: h4 } : { type: "AssignmentExpression", left: c, operator: G[s4 & 255], right: h4 });
            }
            return (s4 & 8454144) === 8454144 && (c = F22(u, e2, i4, t4, o, l, 4, s4, c)), U(u, e2 | 32768, 22) && (c = M2(u, e2, c, t4, o, l)), c;
          }
          function s1(u, e2, i4, n, t4, o, l, c) {
            let { token: s4 } = u;
            E(u, e2 | 32768);
            let h4 = Q(u, e2, 1, 1, i4, u.tokenPos, u.linePos, u.colPos);
            return c = v(u, e2, t4, o, l, n ? { type: "AssignmentPattern", left: c, right: h4 } : { type: "AssignmentExpression", left: c, operator: G[s4 & 255], right: h4 }), u.assignable = 2, c;
          }
          function M2(u, e2, i4, n, t4, o) {
            let l = Q(u, (e2 | 134217728) ^ 134217728, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            w(u, e2 | 32768, 21), u.assignable = 1;
            let c = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            return u.assignable = 2, v(u, e2, n, t4, o, { type: "ConditionalExpression", test: i4, consequent: l, alternate: c });
          }
          function F22(u, e2, i4, n, t4, o, l, c, s4) {
            let h4 = -((e2 & 134217728) > 0) & 8738868, b, g;
            for (u.assignable = 2; u.token & 8454144 && (b = u.token, g = b & 3840, (b & 524288 && c & 268435456 || c & 524288 && b & 268435456) && f4(u, 159), !(g + ((b === 8457273) << 8) - ((h4 === b) << 12) <= l)); )
              E(u, e2 | 32768), s4 = v(u, e2, n, t4, o, { type: b & 524288 || b & 268435456 ? "LogicalExpression" : "BinaryExpression", left: s4, right: F22(u, e2, i4, u.tokenPos, u.linePos, u.colPos, g, b, b2(u, e2, 0, i4, 1, u.tokenPos, u.linePos, u.colPos)), operator: G[b & 255] });
            return u.token === 1077936157 && f4(u, 24), s4;
          }
          function et(u, e2, i4, n, t4, o, l) {
            i4 || f4(u, 0);
            let c = u.token;
            E(u, e2 | 32768);
            let s4 = b2(u, e2, 0, l, 1, u.tokenPos, u.linePos, u.colPos);
            return u.token === 8457273 && f4(u, 31), e2 & 1024 && c === 16863278 && (s4.type === "Identifier" ? f4(u, 117) : B0(s4) && f4(u, 123)), u.assignable = 2, v(u, e2, n, t4, o, { type: "UnaryExpression", operator: G[c & 255], argument: s4, prefix: true });
          }
          function it(u, e2, i4, n, t4, o, l, c, s4, h4) {
            let { token: b } = u, g = z(u, e2, o), { flags: a } = u;
            if ((a & 1) < 1) {
              if (u.token === 86106)
                return he(u, e2, 1, i4, c, s4, h4);
              if ((u.token & 143360) === 143360)
                return n || f4(u, 0), ke(u, e2, t4, c, s4, h4);
            }
            return !l && u.token === 67174411 ? $1(u, e2, g, t4, 1, 0, a, c, s4, h4) : u.token === 10 ? (M1(u, e2, b, 1), l && f4(u, 48), g1(u, e2, u.tokenValue, g, l, t4, 0, c, s4, h4)) : g;
          }
          function nt(u, e2, i4, n, t4, o, l) {
            if (i4 && (u.destructible |= 256), e2 & 2097152) {
              E(u, e2 | 32768), e2 & 8388608 && f4(u, 30), n || f4(u, 24), u.token === 22 && f4(u, 120);
              let c = null, s4 = false;
              return (u.flags & 1) < 1 && (s4 = U(u, e2 | 32768, 8457014), (u.token & 77824 || s4) && (c = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos))), u.assignable = 2, v(u, e2, t4, o, l, { type: "YieldExpression", argument: c, delegate: s4 });
            }
            return e2 & 1024 && f4(u, 94, "yield"), Y1(u, e2, t4, o, l);
          }
          function tt(u, e2, i4, n, t4, o, l) {
            if (n && (u.destructible |= 128), e2 & 4194304 || e2 & 2048 && e2 & 8192) {
              i4 && f4(u, 0), e2 & 8388608 && S2(u.index, u.line, u.index, 29), E(u, e2 | 32768);
              let c = b2(u, e2, 0, 0, 1, u.tokenPos, u.linePos, u.colPos);
              return u.token === 8457273 && f4(u, 31), u.assignable = 2, v(u, e2, t4, o, l, { type: "AwaitExpression", argument: c });
            }
            return e2 & 2048 && f4(u, 95), Y1(u, e2, t4, o, l);
          }
          function a1(u, e2, i4, n, t4, o) {
            let { tokenPos: l, linePos: c, colPos: s4 } = u;
            w(u, e2 | 32768, 2162700);
            let h4 = [], b = e2;
            if (u.token !== 1074790415) {
              for (; u.token === 134283267; ) {
                let { index: g, tokenPos: a, tokenValue: A4, token: C } = u, D = a2(u, e2);
                Zu(u, g, a, A4) && (e2 |= 1024, u.flags & 128 && S2(u.index, u.line, u.tokenPos, 63), u.flags & 64 && S2(u.index, u.line, u.tokenPos, 8)), h4.push(X1(u, e2, D, C, a, u.linePos, u.colPos));
              }
              e2 & 1024 && (t4 && ((t4 & 537079808) === 537079808 && f4(u, 115), (t4 & 36864) === 36864 && f4(u, 38)), u.flags & 512 && f4(u, 115), u.flags & 256 && f4(u, 114)), e2 & 64 && i4 && o !== void 0 && (b & 1024) < 1 && (e2 & 8192) < 1 && P(o);
            }
            for (u.flags = (u.flags | 512 | 256 | 64) ^ 832, u.destructible = (u.destructible | 256) ^ 256; u.token !== 1074790415; )
              h4.push(G2(u, e2, i4, 4, {}));
            return w(u, n & 24 ? e2 | 32768 : e2, 1074790415), u.flags &= -193, u.token === 1077936157 && f4(u, 24), v(u, e2, l, c, s4, { type: "BlockStatement", body: h4 });
          }
          function ot(u, e2, i4, n, t4) {
            switch (E(u, e2), u.token) {
              case 67108991:
                f4(u, 161);
              case 67174411: {
                (e2 & 524288) < 1 && f4(u, 26), e2 & 16384 && f4(u, 27), u.assignable = 2;
                break;
              }
              case 69271571:
              case 67108877: {
                (e2 & 262144) < 1 && f4(u, 27), e2 & 16384 && f4(u, 27), u.assignable = 1;
                break;
              }
              default:
                f4(u, 28, "super");
            }
            return v(u, e2, i4, n, t4, { type: "Super" });
          }
          function b2(u, e2, i4, n, t4, o, l, c) {
            let s4 = h2(u, e2, 2, 0, i4, 0, n, t4, o, l, c);
            return W(u, e2, s4, n, 0, o, l, c);
          }
          function lt(u, e2, i4, n, t4, o) {
            u.assignable & 2 && f4(u, 52);
            let { token: l } = u;
            return E(u, e2), u.assignable = 2, v(u, e2, n, t4, o, { type: "UpdateExpression", argument: i4, operator: G[l & 255], prefix: false });
          }
          function W(u, e2, i4, n, t4, o, l, c) {
            if ((u.token & 33619968) === 33619968 && (u.flags & 1) < 1)
              i4 = lt(u, e2, i4, o, l, c);
            else if ((u.token & 67108864) === 67108864) {
              switch (e2 = (e2 | 134217728) ^ 134217728, u.token) {
                case 67108877: {
                  E(u, (e2 | 1073741824 | 8192) ^ 8192), u.assignable = 1;
                  let s4 = se(u, e2);
                  i4 = v(u, e2, o, l, c, { type: "MemberExpression", object: i4, computed: false, property: s4 });
                  break;
                }
                case 69271571: {
                  let s4 = false;
                  (u.flags & 2048) === 2048 && (s4 = true, u.flags = (u.flags | 2048) ^ 2048), E(u, e2 | 32768);
                  let { tokenPos: h4, linePos: b, colPos: g } = u, a = f22(u, e2, n, 1, h4, b, g);
                  w(u, e2, 20), u.assignable = 1, i4 = v(u, e2, o, l, c, { type: "MemberExpression", object: i4, computed: true, property: a }), s4 && (u.flags |= 2048);
                  break;
                }
                case 67174411: {
                  if ((u.flags & 1024) === 1024)
                    return u.flags = (u.flags | 1024) ^ 1024, i4;
                  let s4 = false;
                  (u.flags & 2048) === 2048 && (s4 = true, u.flags = (u.flags | 2048) ^ 2048);
                  let h4 = W1(u, e2, n);
                  u.assignable = 2, i4 = v(u, e2, o, l, c, { type: "CallExpression", callee: i4, arguments: h4 }), s4 && (u.flags |= 2048);
                  break;
                }
                case 67108991: {
                  E(u, (e2 | 1073741824 | 8192) ^ 8192), u.flags |= 2048, u.assignable = 2, i4 = ft(u, e2, i4, o, l, c);
                  break;
                }
                default:
                  (u.flags & 2048) === 2048 && f4(u, 160), u.assignable = 2, i4 = v(u, e2, o, l, c, { type: "TaggedTemplateExpression", tag: i4, quasi: u.token === 67174408 ? K1(u, e2 | 65536) : H1(u, e2, u.tokenPos, u.linePos, u.colPos) });
              }
              i4 = W(u, e2, i4, 0, 1, o, l, c);
            }
            return t4 === 0 && (u.flags & 2048) === 2048 && (u.flags = (u.flags | 2048) ^ 2048, i4 = v(u, e2, o, l, c, { type: "ChainExpression", expression: i4 })), i4;
          }
          function ft(u, e2, i4, n, t4, o) {
            let l = false, c;
            if ((u.token === 69271571 || u.token === 67174411) && (u.flags & 2048) === 2048 && (l = true, u.flags = (u.flags | 2048) ^ 2048), u.token === 69271571) {
              E(u, e2 | 32768);
              let { tokenPos: s4, linePos: h4, colPos: b } = u, g = f22(u, e2, 0, 1, s4, h4, b);
              w(u, e2, 20), u.assignable = 2, c = v(u, e2, n, t4, o, { type: "MemberExpression", object: i4, computed: true, optional: true, property: g });
            } else if (u.token === 67174411) {
              let s4 = W1(u, e2, 0);
              u.assignable = 2, c = v(u, e2, n, t4, o, { type: "CallExpression", callee: i4, arguments: s4, optional: true });
            } else {
              (u.token & 143360) < 1 && f4(u, 154);
              let s4 = z(u, e2, 0);
              u.assignable = 2, c = v(u, e2, n, t4, o, { type: "MemberExpression", object: i4, computed: false, optional: true, property: s4 });
            }
            return l && (u.flags |= 2048), c;
          }
          function se(u, e2) {
            return (u.token & 143360) < 1 && u.token !== 131 && f4(u, 154), e2 & 1 && u.token === 131 ? k1(u, e2, u.tokenPos, u.linePos, u.colPos) : z(u, e2, 0);
          }
          function ct(u, e2, i4, n, t4, o, l) {
            i4 && f4(u, 53), n || f4(u, 0);
            let { token: c } = u;
            E(u, e2 | 32768);
            let s4 = b2(u, e2, 0, 0, 1, u.tokenPos, u.linePos, u.colPos);
            return u.assignable & 2 && f4(u, 52), u.assignable = 2, v(u, e2, t4, o, l, { type: "UpdateExpression", argument: s4, operator: G[c & 255], prefix: true });
          }
          function h2(u, e2, i4, n, t4, o, l, c, s4, h4, b) {
            if ((u.token & 143360) === 143360) {
              switch (u.token) {
                case 209008:
                  return tt(u, e2, n, l, s4, h4, b);
                case 241773:
                  return nt(u, e2, l, t4, s4, h4, b);
                case 209007:
                  return it(u, e2, l, c, t4, o, n, s4, h4, b);
              }
              let { token: g, tokenValue: a } = u, A4 = z(u, e2 | 65536, o);
              return u.token === 10 ? (c || f4(u, 0), M1(u, e2, g, 1), g1(u, e2, a, A4, n, t4, 0, s4, h4, b)) : (e2 & 16384 && g === 537079928 && f4(u, 126), g === 241739 && (e2 & 1024 && f4(u, 109), i4 & 24 && f4(u, 97)), u.assignable = e2 & 1024 && (g & 537079808) === 537079808 ? 2 : 1, A4);
            }
            if ((u.token & 134217728) === 134217728)
              return a2(u, e2);
            switch (u.token) {
              case 33619995:
              case 33619996:
                return ct(u, e2, n, c, s4, h4, b);
              case 16863278:
              case 16842800:
              case 16842801:
              case 25233970:
              case 25233971:
              case 16863277:
              case 16863279:
                return et(u, e2, c, s4, h4, b, l);
              case 86106:
                return he(u, e2, 0, l, s4, h4, b);
              case 2162700:
                return mt(u, e2, t4 ? 0 : 1, l, s4, h4, b);
              case 69271571:
                return ht(u, e2, t4 ? 0 : 1, l, s4, h4, b);
              case 67174411:
                return kt(u, e2, t4, 1, 0, s4, h4, b);
              case 86021:
              case 86022:
              case 86023:
                return dt(u, e2, s4, h4, b);
              case 86113:
                return gt(u, e2);
              case 65540:
                return At(u, e2, s4, h4, b);
              case 133:
              case 86096:
                return yt(u, e2, l, s4, h4, b);
              case 86111:
                return ot(u, e2, s4, h4, b);
              case 67174409:
                return H1(u, e2, s4, h4, b);
              case 67174408:
                return K1(u, e2);
              case 86109:
                return rt(u, e2, l, s4, h4, b);
              case 134283389:
                return ge(u, e2, s4, h4, b);
              case 131:
                return k1(u, e2, s4, h4, b);
              case 86108:
                return st(u, e2, n, l, s4, h4, b);
              case 8456258:
                if (e2 & 16)
                  return G1(u, e2, 1, s4, h4, b);
              default:
                if (_1(e2, u.token))
                  return Y1(u, e2, s4, h4, b);
                f4(u, 28, G[u.token & 255]);
            }
          }
          function st(u, e2, i4, n, t4, o, l) {
            let c = z(u, e2, 0);
            return u.token === 67108877 ? ae(u, e2, c, t4, o, l) : (i4 && f4(u, 137), c = de(u, e2, n, t4, o, l), u.assignable = 2, W(u, e2, c, n, 0, t4, o, l));
          }
          function ae(u, e2, i4, n, t4, o) {
            return (e2 & 2048) === 0 && f4(u, 163), E(u, e2), u.token !== 143495 && u.tokenValue !== "meta" && f4(u, 28, G[u.token & 255]), u.assignable = 2, v(u, e2, n, t4, o, { type: "MetaProperty", meta: i4, property: z(u, e2, 0) });
          }
          function de(u, e2, i4, n, t4, o) {
            w(u, e2 | 32768, 67174411), u.token === 14 && f4(u, 138);
            let l = Q(u, e2, 1, 0, i4, u.tokenPos, u.linePos, u.colPos);
            return w(u, e2, 16), v(u, e2, n, t4, o, { type: "ImportExpression", source: l });
          }
          function ge(u, e2, i4, n, t4) {
            let { tokenRaw: o, tokenValue: l } = u;
            return E(u, e2), u.assignable = 2, v(u, e2, i4, n, t4, e2 & 512 ? { type: "Literal", value: l, bigint: o.slice(0, -1), raw: o } : { type: "Literal", value: l, bigint: o.slice(0, -1) });
          }
          function H1(u, e2, i4, n, t4) {
            u.assignable = 2;
            let { tokenValue: o, tokenRaw: l, tokenPos: c, linePos: s4, colPos: h4 } = u;
            w(u, e2, 67174409);
            let b = [d1(u, e2, o, l, c, s4, h4, true)];
            return v(u, e2, i4, n, t4, { type: "TemplateLiteral", expressions: [], quasis: b });
          }
          function K1(u, e2) {
            e2 = (e2 | 134217728) ^ 134217728;
            let { tokenValue: i4, tokenRaw: n, tokenPos: t4, linePos: o, colPos: l } = u;
            w(u, e2 | 32768, 67174408);
            let c = [d1(u, e2, i4, n, t4, o, l, false)], s4 = [f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos)];
            for (u.token !== 1074790415 && f4(u, 80); (u.token = v0(u, e2)) !== 67174409; ) {
              let { tokenValue: h4, tokenRaw: b, tokenPos: g, linePos: a, colPos: A4 } = u;
              w(u, e2 | 32768, 67174408), c.push(d1(u, e2, h4, b, g, a, A4, false)), s4.push(f22(u, e2, 0, 1, u.tokenPos, u.linePos, u.colPos)), u.token !== 1074790415 && f4(u, 80);
            }
            {
              let { tokenValue: h4, tokenRaw: b, tokenPos: g, linePos: a, colPos: A4 } = u;
              w(u, e2, 67174409), c.push(d1(u, e2, h4, b, g, a, A4, true));
            }
            return v(u, e2, t4, o, l, { type: "TemplateLiteral", expressions: s4, quasis: c });
          }
          function d1(u, e2, i4, n, t4, o, l, c) {
            let s4 = v(u, e2, t4, o, l, { type: "TemplateElement", value: { cooked: i4, raw: n }, tail: c }), h4 = c ? 1 : 2;
            return e2 & 2 && (s4.start += 1, s4.range[0] += 1, s4.end -= h4, s4.range[1] -= h4), e2 & 4 && (s4.loc.start.column += 1, s4.loc.end.column -= h4), s4;
          }
          function at(u, e2, i4, n, t4) {
            e2 = (e2 | 134217728) ^ 134217728, w(u, e2 | 32768, 14);
            let o = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            return u.assignable = 1, v(u, e2, i4, n, t4, { type: "SpreadElement", argument: o });
          }
          function W1(u, e2, i4) {
            E(u, e2 | 32768);
            let n = [];
            if (u.token === 16)
              return E(u, e2), n;
            for (; u.token !== 16 && (u.token === 14 ? n.push(at(u, e2, u.tokenPos, u.linePos, u.colPos)) : n.push(Q(u, e2, 1, 0, i4, u.tokenPos, u.linePos, u.colPos)), !(u.token !== 18 || (E(u, e2 | 32768), u.token === 16))); )
              ;
            return w(u, e2, 16), n;
          }
          function z(u, e2, i4) {
            let { tokenValue: n, tokenPos: t4, linePos: o, colPos: l } = u;
            return E(u, e2), v(u, e2, t4, o, l, e2 & 268435456 ? { type: "Identifier", name: n, pattern: i4 === 1 } : { type: "Identifier", name: n });
          }
          function a2(u, e2) {
            let { tokenValue: i4, tokenRaw: n, tokenPos: t4, linePos: o, colPos: l } = u;
            return u.token === 134283389 ? ge(u, e2, t4, o, l) : (E(u, e2), u.assignable = 2, v(u, e2, t4, o, l, e2 & 512 ? { type: "Literal", value: i4, raw: n } : { type: "Literal", value: i4 }));
          }
          function dt(u, e2, i4, n, t4) {
            let o = G[u.token & 255], l = u.token === 86023 ? null : o === "true";
            return E(u, e2), u.assignable = 2, v(u, e2, i4, n, t4, e2 & 512 ? { type: "Literal", value: l, raw: o } : { type: "Literal", value: l });
          }
          function gt(u, e2) {
            let { tokenPos: i4, linePos: n, colPos: t4 } = u;
            return E(u, e2), u.assignable = 2, v(u, e2, i4, n, t4, { type: "ThisExpression" });
          }
          function T2(u, e2, i4, n, t4, o, l, c, s4, h4) {
            E(u, e2 | 32768);
            let b = t4 ? V1(u, e2, 8457014) : 0, g = null, a, A4 = i4 ? j2() : void 0;
            if (u.token === 67174411)
              (o & 1) < 1 && f4(u, 37, "Function");
            else {
              let B = n & 4 && ((e2 & 8192) < 1 || (e2 & 2048) < 1) ? 4 : 64;
              Qu(u, e2 | (e2 & 3072) << 11, u.token), i4 && (B & 4 ? pu(u, e2, i4, u.tokenValue, B) : B2(u, e2, i4, u.tokenValue, B, n), A4 = o2(A4, 256), o && o & 2 && _2(u, u.tokenValue)), a = u.token, u.token & 143360 ? g = z(u, e2, 0) : f4(u, 28, G[u.token & 255]);
            }
            e2 = (e2 | 32243712) ^ 32243712 | 67108864 | l * 2 + b << 21 | (b ? 0 : 1073741824), i4 && (A4 = o2(A4, 512));
            let C = be(u, e2 | 8388608, A4, 0, 1), D = a1(u, (e2 | 8192 | 4096 | 131072) ^ 143360, i4 ? o2(A4, 128) : A4, 8, a, i4 ? A4.scopeError : void 0);
            return v(u, e2, c, s4, h4, { type: "FunctionDeclaration", id: g, params: C, body: D, async: l === 1, generator: b === 1 });
          }
          function he(u, e2, i4, n, t4, o, l) {
            E(u, e2 | 32768);
            let c = V1(u, e2, 8457014), s4 = i4 * 2 + c << 21, h4 = null, b, g = e2 & 64 ? j2() : void 0;
            (u.token & 176128) > 0 && (Qu(u, (e2 | 32243712) ^ 32243712 | s4, u.token), g && (g = o2(g, 256)), b = u.token, h4 = z(u, e2, 0)), e2 = (e2 | 32243712) ^ 32243712 | 67108864 | s4 | (c ? 0 : 1073741824), g && (g = o2(g, 512));
            let a = be(u, e2 | 8388608, g, n, 1), A4 = a1(u, e2 & -134377473, g && o2(g, 128), 0, b, void 0);
            return u.assignable = 2, v(u, e2, t4, o, l, { type: "FunctionExpression", id: h4, params: a, body: A4, async: i4 === 1, generator: c === 1 });
          }
          function ht(u, e2, i4, n, t4, o, l) {
            let c = k2(u, e2, void 0, i4, n, 0, 2, 0, t4, o, l);
            return e2 & 256 && u.destructible & 64 && f4(u, 60), u.destructible & 8 && f4(u, 59), c;
          }
          function k2(u, e2, i4, n, t4, o, l, c, s4, h4, b) {
            E(u, e2 | 32768);
            let g = [], a = 0;
            for (e2 = (e2 | 134217728) ^ 134217728; u.token !== 20; )
              if (U(u, e2 | 32768, 18))
                g.push(null);
              else {
                let C, { token: D, tokenPos: B, linePos: O, colPos: j, tokenValue: e22 } = u;
                if (D & 143360)
                  if (C = h2(u, e2, l, 0, 1, 0, t4, 1, B, O, j), u.token === 1077936157) {
                    u.assignable & 2 && f4(u, 24), E(u, e2 | 32768), i4 && q2(u, e2, i4, e22, l, c);
                    let R = Q(u, e2, 1, 1, t4, u.tokenPos, u.linePos, u.colPos);
                    C = v(u, e2, B, O, j, o ? { type: "AssignmentPattern", left: C, right: R } : { type: "AssignmentExpression", operator: "=", left: C, right: R }), a |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0;
                  } else
                    u.token === 18 || u.token === 20 ? (u.assignable & 2 ? a |= 16 : i4 && q2(u, e2, i4, e22, l, c), a |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0) : (a |= l & 1 ? 32 : (l & 2) < 1 ? 16 : 0, C = W(u, e2, C, t4, 0, B, O, j), u.token !== 18 && u.token !== 20 ? (u.token !== 1077936157 && (a |= 16), C = x3(u, e2, t4, o, B, O, j, C)) : u.token !== 1077936157 && (a |= u.assignable & 2 ? 16 : 32));
                else
                  D & 2097152 ? (C = u.token === 2162700 ? r22(u, e2, i4, 0, t4, o, l, c, B, O, j) : k2(u, e2, i4, 0, t4, o, l, c, B, O, j), a |= u.destructible, u.assignable = u.destructible & 16 ? 2 : 1, u.token === 18 || u.token === 20 ? u.assignable & 2 && (a |= 16) : u.destructible & 8 ? f4(u, 68) : (C = W(u, e2, C, t4, 0, B, O, j), a = u.assignable & 2 ? 16 : 0, u.token !== 18 && u.token !== 20 ? C = x3(u, e2, t4, o, B, O, j, C) : u.token !== 1077936157 && (a |= u.assignable & 2 ? 16 : 32))) : D === 14 ? (C = W2(u, e2, i4, 20, l, c, 0, t4, o, B, O, j), a |= u.destructible, u.token !== 18 && u.token !== 20 && f4(u, 28, G[u.token & 255])) : (C = b2(u, e2, 1, 0, 1, B, O, j), u.token !== 18 && u.token !== 20 ? (C = x3(u, e2, t4, o, B, O, j, C), (l & 3) < 1 && D === 67174411 && (a |= 16)) : u.assignable & 2 ? a |= 16 : D === 67174411 && (a |= u.assignable & 1 && l & 3 ? 32 : 16));
                if (g.push(C), U(u, e2 | 32768, 18)) {
                  if (u.token === 20)
                    break;
                } else
                  break;
              }
            w(u, e2, 20);
            let A4 = v(u, e2, s4, h4, b, { type: o ? "ArrayPattern" : "ArrayExpression", elements: g });
            return !n && u.token & 4194304 ? me(u, e2, a, t4, o, s4, h4, b, A4) : (u.destructible = a, A4);
          }
          function me(u, e2, i4, n, t4, o, l, c, s4) {
            u.token !== 1077936157 && f4(u, 24), E(u, e2 | 32768), i4 & 16 && f4(u, 24), t4 || v2(u, s4);
            let { tokenPos: h4, linePos: b, colPos: g } = u, a = Q(u, e2, 1, 1, n, h4, b, g);
            return u.destructible = (i4 | 64 | 8) ^ 72 | (u.destructible & 128 ? 128 : 0) | (u.destructible & 256 ? 256 : 0), v(u, e2, o, l, c, t4 ? { type: "AssignmentPattern", left: s4, right: a } : { type: "AssignmentExpression", left: s4, operator: "=", right: a });
          }
          function W2(u, e2, i4, n, t4, o, l, c, s4, h4, b, g) {
            E(u, e2 | 32768);
            let a = null, A4 = 0, { token: C, tokenValue: D, tokenPos: B, linePos: O, colPos: j } = u;
            if (C & 143360)
              u.assignable = 1, a = h2(u, e2, t4, 0, 1, 0, c, 1, B, O, j), C = u.token, a = W(u, e2, a, c, 0, B, O, j), u.token !== 18 && u.token !== n && (u.assignable & 2 && u.token === 1077936157 && f4(u, 68), A4 |= 16, a = x3(u, e2, c, s4, B, O, j, a)), u.assignable & 2 ? A4 |= 16 : C === n || C === 18 ? i4 && q2(u, e2, i4, D, t4, o) : A4 |= 32, A4 |= u.destructible & 128 ? 128 : 0;
            else if (C === n)
              f4(u, 39);
            else if (C & 2097152)
              a = u.token === 2162700 ? r22(u, e2, i4, 1, c, s4, t4, o, B, O, j) : k2(u, e2, i4, 1, c, s4, t4, o, B, O, j), C = u.token, C !== 1077936157 && C !== n && C !== 18 ? (u.destructible & 8 && f4(u, 68), a = W(u, e2, a, c, 0, B, O, j), A4 |= u.assignable & 2 ? 16 : 0, (u.token & 4194304) === 4194304 ? (u.token !== 1077936157 && (A4 |= 16), a = x3(u, e2, c, s4, B, O, j, a)) : ((u.token & 8454144) === 8454144 && (a = F22(u, e2, 1, B, O, j, 4, C, a)), U(u, e2 | 32768, 22) && (a = M2(u, e2, a, B, O, j)), A4 |= u.assignable & 2 ? 16 : 32)) : A4 |= n === 1074790415 && C !== 1077936157 ? 16 : u.destructible;
            else {
              A4 |= 32, a = b2(u, e2, 1, c, 1, u.tokenPos, u.linePos, u.colPos);
              let { token: e22, tokenPos: R, linePos: $, colPos: y } = u;
              return e22 === 1077936157 && e22 !== n && e22 !== 18 ? (u.assignable & 2 && f4(u, 24), a = x3(u, e2, c, s4, R, $, y, a), A4 |= 16) : (e22 === 18 ? A4 |= 16 : e22 !== n && (a = x3(u, e2, c, s4, R, $, y, a)), A4 |= u.assignable & 1 ? 32 : 16), u.destructible = A4, u.token !== n && u.token !== 18 && f4(u, 155), v(u, e2, h4, b, g, { type: s4 ? "RestElement" : "SpreadElement", argument: a });
            }
            if (u.token !== n)
              if (t4 & 1 && (A4 |= l ? 16 : 32), U(u, e2 | 32768, 1077936157)) {
                A4 & 16 && f4(u, 24), v2(u, a);
                let e22 = Q(u, e2, 1, 1, c, u.tokenPos, u.linePos, u.colPos);
                a = v(u, e2, B, O, j, s4 ? { type: "AssignmentPattern", left: a, right: e22 } : { type: "AssignmentExpression", left: a, operator: "=", right: e22 }), A4 = 16;
              } else
                A4 |= 16;
            return u.destructible = A4, v(u, e2, h4, b, g, { type: s4 ? "RestElement" : "SpreadElement", argument: a });
          }
          function A2(u, e2, i4, n, t4, o, l) {
            let c = (i4 & 64) < 1 ? 31981568 : 14680064;
            e2 = (e2 | c) ^ c | (i4 & 88) << 18 | 100925440;
            let s4 = e2 & 64 ? o2(j2(), 512) : void 0, h4 = bt(u, e2 | 8388608, s4, i4, 1, n);
            s4 && (s4 = o2(s4, 128));
            let b = a1(u, e2 & -134230017, s4, 0, void 0, void 0);
            return v(u, e2, t4, o, l, { type: "FunctionExpression", params: h4, body: b, async: (i4 & 16) > 0, generator: (i4 & 8) > 0, id: null });
          }
          function mt(u, e2, i4, n, t4, o, l) {
            let c = r22(u, e2, void 0, i4, n, 0, 2, 0, t4, o, l);
            return e2 & 256 && u.destructible & 64 && f4(u, 60), u.destructible & 8 && f4(u, 59), c;
          }
          function r22(u, e2, i4, n, t4, o, l, c, s4, h4, b) {
            E(u, e2);
            let g = [], a = 0, A4 = 0;
            for (e2 = (e2 | 134217728) ^ 134217728; u.token !== 1074790415; ) {
              let { token: D, tokenValue: B, linePos: O, colPos: j, tokenPos: e22 } = u;
              if (D === 14)
                g.push(W2(u, e2, i4, 1074790415, l, c, 0, t4, o, e22, O, j));
              else {
                let R = 0, $ = null, y, y2 = u.token;
                if (u.token & 143360 || u.token === 121)
                  if ($ = z(u, e2, 0), u.token === 18 || u.token === 1074790415 || u.token === 1077936157)
                    if (R |= 4, e2 & 1024 && (D & 537079808) === 537079808 ? a |= 16 : o1(u, e2, l, D, 0), i4 && q2(u, e2, i4, B, l, c), U(u, e2 | 32768, 1077936157)) {
                      a |= 8;
                      let N = Q(u, e2, 1, 1, t4, u.tokenPos, u.linePos, u.colPos);
                      a |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0, y = v(u, e2, e22, O, j, { type: "AssignmentPattern", left: e2 & -2147483648 ? Object.assign({}, $) : $, right: N });
                    } else
                      a |= (D === 209008 ? 128 : 0) | (D === 121 ? 16 : 0), y = e2 & -2147483648 ? Object.assign({}, $) : $;
                  else if (U(u, e2 | 32768, 21)) {
                    let { tokenPos: N, linePos: M, colPos: _ } = u;
                    if (B === "__proto__" && A4++, u.token & 143360) {
                      let U2 = u.token, $2 = u.tokenValue;
                      a |= y2 === 121 ? 16 : 0, y = h2(u, e2, l, 0, 1, 0, t4, 1, N, M, _);
                      let { token: E2 } = u;
                      y = W(u, e2, y, t4, 0, N, M, _), u.token === 18 || u.token === 1074790415 ? E2 === 1077936157 || E2 === 1074790415 || E2 === 18 ? (a |= u.destructible & 128 ? 128 : 0, u.assignable & 2 ? a |= 16 : i4 && (U2 & 143360) === 143360 && q2(u, e2, i4, $2, l, c)) : a |= u.assignable & 1 ? 32 : 16 : (u.token & 4194304) === 4194304 ? (u.assignable & 2 ? a |= 16 : E2 !== 1077936157 ? a |= 32 : i4 && q2(u, e2, i4, $2, l, c), y = x3(u, e2, t4, o, N, M, _, y)) : (a |= 16, (u.token & 8454144) === 8454144 && (y = F22(u, e2, 1, N, M, _, 4, E2, y)), U(u, e2 | 32768, 22) && (y = M2(u, e2, y, N, M, _)));
                    } else
                      (u.token & 2097152) === 2097152 ? (y = u.token === 69271571 ? k2(u, e2, i4, 0, t4, o, l, c, N, M, _) : r22(u, e2, i4, 0, t4, o, l, c, N, M, _), a = u.destructible, u.assignable = a & 16 ? 2 : 1, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : u.destructible & 8 ? f4(u, 68) : (y = W(u, e2, y, t4, 0, N, M, _), a = u.assignable & 2 ? 16 : 0, (u.token & 4194304) === 4194304 ? y = s1(u, e2, t4, o, N, M, _, y) : ((u.token & 8454144) === 8454144 && (y = F22(u, e2, 1, N, M, _, 4, D, y)), U(u, e2 | 32768, 22) && (y = M2(u, e2, y, N, M, _)), a |= u.assignable & 2 ? 16 : 32))) : (y = b2(u, e2, 1, t4, 1, N, M, _), a |= u.assignable & 1 ? 32 : 16, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : (y = W(u, e2, y, t4, 0, N, M, _), a = u.assignable & 2 ? 16 : 0, u.token !== 18 && D !== 1074790415 && (u.token !== 1077936157 && (a |= 16), y = x3(u, e2, t4, o, N, M, _, y))));
                  } else
                    u.token === 69271571 ? (a |= 16, D === 209007 && (R |= 16), R |= (D === 12402 ? 256 : D === 12403 ? 512 : 1) | 2, $ = Y2(u, e2, t4), a |= u.assignable, y = A2(u, e2, R, t4, u.tokenPos, u.linePos, u.colPos)) : u.token & 143360 ? (a |= 16, D === 121 && f4(u, 92), D === 209007 && (u.flags & 1 && f4(u, 128), R |= 16), $ = z(u, e2, 0), R |= D === 12402 ? 256 : D === 12403 ? 512 : 1, y = A2(u, e2, R, t4, u.tokenPos, u.linePos, u.colPos)) : u.token === 67174411 ? (a |= 16, R |= 1, y = A2(u, e2, R, t4, u.tokenPos, u.linePos, u.colPos)) : u.token === 8457014 ? (a |= 16, D === 12402 || D === 12403 ? f4(u, 40) : D === 143483 && f4(u, 92), E(u, e2), R |= 9 | (D === 209007 ? 16 : 0), u.token & 143360 ? $ = z(u, e2, 0) : (u.token & 134217728) === 134217728 ? $ = a2(u, e2) : u.token === 69271571 ? (R |= 2, $ = Y2(u, e2, t4), a |= u.assignable) : f4(u, 28, G[u.token & 255]), y = A2(u, e2, R, t4, u.tokenPos, u.linePos, u.colPos)) : (u.token & 134217728) === 134217728 ? (D === 209007 && (R |= 16), R |= D === 12402 ? 256 : D === 12403 ? 512 : 1, a |= 16, $ = a2(u, e2), y = A2(u, e2, R, t4, u.tokenPos, u.linePos, u.colPos)) : f4(u, 129);
                else if ((u.token & 134217728) === 134217728)
                  if ($ = a2(u, e2), u.token === 21) {
                    w(u, e2 | 32768, 21);
                    let { tokenPos: N, linePos: M, colPos: _ } = u;
                    if (B === "__proto__" && A4++, u.token & 143360) {
                      y = h2(u, e2, l, 0, 1, 0, t4, 1, N, M, _);
                      let { token: U2, tokenValue: $2 } = u;
                      y = W(u, e2, y, t4, 0, N, M, _), u.token === 18 || u.token === 1074790415 ? U2 === 1077936157 || U2 === 1074790415 || U2 === 18 ? u.assignable & 2 ? a |= 16 : i4 && q2(u, e2, i4, $2, l, c) : a |= u.assignable & 1 ? 32 : 16 : u.token === 1077936157 ? (u.assignable & 2 && (a |= 16), y = x3(u, e2, t4, o, N, M, _, y)) : (a |= 16, y = x3(u, e2, t4, o, N, M, _, y));
                    } else
                      (u.token & 2097152) === 2097152 ? (y = u.token === 69271571 ? k2(u, e2, i4, 0, t4, o, l, c, N, M, _) : r22(u, e2, i4, 0, t4, o, l, c, N, M, _), a = u.destructible, u.assignable = a & 16 ? 2 : 1, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : (u.destructible & 8) !== 8 && (y = W(u, e2, y, t4, 0, N, M, _), a = u.assignable & 2 ? 16 : 0, (u.token & 4194304) === 4194304 ? y = s1(u, e2, t4, o, N, M, _, y) : ((u.token & 8454144) === 8454144 && (y = F22(u, e2, 1, N, M, _, 4, D, y)), U(u, e2 | 32768, 22) && (y = M2(u, e2, y, N, M, _)), a |= u.assignable & 2 ? 16 : 32))) : (y = b2(u, e2, 1, 0, 1, N, M, _), a |= u.assignable & 1 ? 32 : 16, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : (y = W(u, e2, y, t4, 0, N, M, _), a = u.assignable & 1 ? 0 : 16, u.token !== 18 && u.token !== 1074790415 && (u.token !== 1077936157 && (a |= 16), y = x3(u, e2, t4, o, N, M, _, y))));
                  } else
                    u.token === 67174411 ? (R |= 1, y = A2(u, e2, R, t4, u.tokenPos, u.linePos, u.colPos), a = u.assignable | 16) : f4(u, 130);
                else if (u.token === 69271571)
                  if ($ = Y2(u, e2, t4), a |= u.destructible & 256 ? 256 : 0, R |= 2, u.token === 21) {
                    E(u, e2 | 32768);
                    let { tokenPos: N, linePos: M, colPos: _, tokenValue: U2, token: $2 } = u;
                    if (u.token & 143360) {
                      y = h2(u, e2, l, 0, 1, 0, t4, 1, N, M, _);
                      let { token: E2 } = u;
                      y = W(u, e2, y, t4, 0, N, M, _), (u.token & 4194304) === 4194304 ? (a |= u.assignable & 2 ? 16 : E2 === 1077936157 ? 0 : 32, y = s1(u, e2, t4, o, N, M, _, y)) : u.token === 18 || u.token === 1074790415 ? E2 === 1077936157 || E2 === 1074790415 || E2 === 18 ? u.assignable & 2 ? a |= 16 : i4 && ($2 & 143360) === 143360 && q2(u, e2, i4, U2, l, c) : a |= u.assignable & 1 ? 32 : 16 : (a |= 16, y = x3(u, e2, t4, o, N, M, _, y));
                    } else
                      (u.token & 2097152) === 2097152 ? (y = u.token === 69271571 ? k2(u, e2, i4, 0, t4, o, l, c, N, M, _) : r22(u, e2, i4, 0, t4, o, l, c, N, M, _), a = u.destructible, u.assignable = a & 16 ? 2 : 1, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : a & 8 ? f4(u, 59) : (y = W(u, e2, y, t4, 0, N, M, _), a = u.assignable & 2 ? a | 16 : 0, (u.token & 4194304) === 4194304 ? (u.token !== 1077936157 && (a |= 16), y = s1(u, e2, t4, o, N, M, _, y)) : ((u.token & 8454144) === 8454144 && (y = F22(u, e2, 1, N, M, _, 4, D, y)), U(u, e2 | 32768, 22) && (y = M2(u, e2, y, N, M, _)), a |= u.assignable & 2 ? 16 : 32))) : (y = b2(u, e2, 1, 0, 1, N, M, _), a |= u.assignable & 1 ? 32 : 16, u.token === 18 || u.token === 1074790415 ? u.assignable & 2 && (a |= 16) : (y = W(u, e2, y, t4, 0, N, M, _), a = u.assignable & 1 ? 0 : 16, u.token !== 18 && u.token !== 1074790415 && (u.token !== 1077936157 && (a |= 16), y = x3(u, e2, t4, o, N, M, _, y))));
                  } else
                    u.token === 67174411 ? (R |= 1, y = A2(u, e2, R, t4, u.tokenPos, O, j), a = 16) : f4(u, 41);
                else if (D === 8457014)
                  if (w(u, e2 | 32768, 8457014), R |= 8, u.token & 143360) {
                    let { token: N, line: M, index: _ } = u;
                    $ = z(u, e2, 0), R |= 1, u.token === 67174411 ? (a |= 16, y = A2(u, e2, R, t4, u.tokenPos, u.linePos, u.colPos)) : S2(_, M, _, N === 209007 ? 43 : N === 12402 || u.token === 12403 ? 42 : 44, G[N & 255]);
                  } else
                    (u.token & 134217728) === 134217728 ? (a |= 16, $ = a2(u, e2), R |= 1, y = A2(u, e2, R, t4, e22, O, j)) : u.token === 69271571 ? (a |= 16, R |= 3, $ = Y2(u, e2, t4), y = A2(u, e2, R, t4, u.tokenPos, u.linePos, u.colPos)) : f4(u, 122);
                else
                  f4(u, 28, G[D & 255]);
                a |= u.destructible & 128 ? 128 : 0, u.destructible = a, g.push(v(u, e2, e22, O, j, { type: "Property", key: $, value: y, kind: R & 768 ? R & 512 ? "set" : "get" : "init", computed: (R & 2) > 0, method: (R & 1) > 0, shorthand: (R & 4) > 0 }));
              }
              if (a |= u.destructible, u.token !== 18)
                break;
              E(u, e2);
            }
            w(u, e2, 1074790415), A4 > 1 && (a |= 64);
            let C = v(u, e2, s4, h4, b, { type: o ? "ObjectPattern" : "ObjectExpression", properties: g });
            return !n && u.token & 4194304 ? me(u, e2, a, t4, o, s4, h4, b, C) : (u.destructible = a, C);
          }
          function bt(u, e2, i4, n, t4, o) {
            w(u, e2, 67174411);
            let l = [];
            if (u.flags = (u.flags | 128) ^ 128, u.token === 16)
              return n & 512 && f4(u, 35, "Setter", "one", ""), E(u, e2), l;
            n & 256 && f4(u, 35, "Getter", "no", "s"), n & 512 && u.token === 14 && f4(u, 36), e2 = (e2 | 134217728) ^ 134217728;
            let c = 0, s4 = 0;
            for (; u.token !== 18; ) {
              let h4 = null, { tokenPos: b, linePos: g, colPos: a } = u;
              if (u.token & 143360 ? ((e2 & 1024) < 1 && ((u.token & 36864) === 36864 && (u.flags |= 256), (u.token & 537079808) === 537079808 && (u.flags |= 512)), h4 = Q1(u, e2, i4, n | 1, 0, b, g, a)) : (u.token === 2162700 ? h4 = r22(u, e2, i4, 1, o, 1, t4, 0, b, g, a) : u.token === 69271571 ? h4 = k2(u, e2, i4, 1, o, 1, t4, 0, b, g, a) : u.token === 14 && (h4 = W2(u, e2, i4, 16, t4, 0, 0, o, 1, b, g, a)), s4 = 1, u.destructible & 48 && f4(u, 47)), u.token === 1077936157) {
                E(u, e2 | 32768), s4 = 1;
                let A4 = Q(u, e2, 1, 1, 0, u.tokenPos, u.linePos, u.colPos);
                h4 = v(u, e2, b, g, a, { type: "AssignmentPattern", left: h4, right: A4 });
              }
              if (c++, l.push(h4), !U(u, e2, 18) || u.token === 16)
                break;
            }
            return n & 512 && c !== 1 && f4(u, 35, "Setter", "one", ""), i4 && i4.scopeError !== void 0 && P(i4.scopeError), s4 && (u.flags |= 128), w(u, e2, 16), l;
          }
          function Y2(u, e2, i4) {
            E(u, e2 | 32768);
            let n = Q(u, (e2 | 134217728) ^ 134217728, 1, 0, i4, u.tokenPos, u.linePos, u.colPos);
            return w(u, e2, 20), n;
          }
          function kt(u, e2, i4, n, t4, o, l, c) {
            u.flags = (u.flags | 128) ^ 128;
            let { tokenPos: s4, linePos: h4, colPos: b } = u;
            E(u, e2 | 32768 | 1073741824);
            let g = e2 & 64 ? o2(j2(), 1024) : void 0;
            if (e2 = (e2 | 134217728) ^ 134217728, U(u, e2, 16))
              return h1(u, e2, g, [], i4, 0, o, l, c);
            let a = 0;
            u.destructible &= -385;
            let A4, C = [], D = 0, B = 0, { tokenPos: O, linePos: j, colPos: e22 } = u;
            for (u.assignable = 1; u.token !== 16; ) {
              let { token: R, tokenPos: $, linePos: y, colPos: y2 } = u;
              if (R & 143360)
                g && B2(u, e2, g, u.tokenValue, 1, 0), A4 = h2(u, e2, n, 0, 1, 0, 1, 1, $, y, y2), u.token === 16 || u.token === 18 ? u.assignable & 2 ? (a |= 16, B = 1) : ((R & 537079808) === 537079808 || (R & 36864) === 36864) && (B = 1) : (u.token === 1077936157 ? B = 1 : a |= 16, A4 = W(u, e2, A4, 1, 0, $, y, y2), u.token !== 16 && u.token !== 18 && (A4 = x3(u, e2, 1, 0, $, y, y2, A4)));
              else if ((R & 2097152) === 2097152)
                A4 = R === 2162700 ? r22(u, e2 | 1073741824, g, 0, 1, 0, n, t4, $, y, y2) : k2(u, e2 | 1073741824, g, 0, 1, 0, n, t4, $, y, y2), a |= u.destructible, B = 1, u.assignable = 2, u.token !== 16 && u.token !== 18 && (a & 8 && f4(u, 118), A4 = W(u, e2, A4, 0, 0, $, y, y2), a |= 16, u.token !== 16 && u.token !== 18 && (A4 = x3(u, e2, 0, 0, $, y, y2, A4)));
              else if (R === 14) {
                A4 = W2(u, e2, g, 16, n, t4, 0, 1, 0, $, y, y2), u.destructible & 16 && f4(u, 71), B = 1, D && (u.token === 16 || u.token === 18) && C.push(A4), a |= 8;
                break;
              } else {
                if (a |= 16, A4 = Q(u, e2, 1, 0, 1, $, y, y2), D && (u.token === 16 || u.token === 18) && C.push(A4), u.token === 18 && (D || (D = 1, C = [A4])), D) {
                  for (; U(u, e2 | 32768, 18); )
                    C.push(Q(u, e2, 1, 0, 1, u.tokenPos, u.linePos, u.colPos));
                  u.assignable = 2, A4 = v(u, e2, O, j, e22, { type: "SequenceExpression", expressions: C });
                }
                return w(u, e2, 16), u.destructible = a, A4;
              }
              if (D && (u.token === 16 || u.token === 18) && C.push(A4), !U(u, e2 | 32768, 18))
                break;
              if (D || (D = 1, C = [A4]), u.token === 16) {
                a |= 8;
                break;
              }
            }
            return D && (u.assignable = 2, A4 = v(u, e2, O, j, e22, { type: "SequenceExpression", expressions: C })), w(u, e2, 16), a & 16 && a & 8 && f4(u, 145), a |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0, u.token === 10 ? (a & 48 && f4(u, 46), e2 & 4196352 && a & 128 && f4(u, 29), e2 & 2098176 && a & 256 && f4(u, 30), B && (u.flags |= 128), h1(u, e2, g, D ? C : [A4], i4, 0, o, l, c)) : (a & 8 && f4(u, 139), u.destructible = (u.destructible | 256) ^ 256 | a, e2 & 128 ? v(u, e2, s4, h4, b, { type: "ParenthesizedExpression", expression: A4 }) : A4);
          }
          function Y1(u, e2, i4, n, t4) {
            let { tokenValue: o } = u, l = z(u, e2, 0);
            if (u.assignable = 1, u.token === 10) {
              let c;
              return e2 & 64 && (c = f1(u, e2, o)), u.flags = (u.flags | 128) ^ 128, u1(u, e2, c, [l], 0, i4, n, t4);
            }
            return l;
          }
          function g1(u, e2, i4, n, t4, o, l, c, s4, h4) {
            o || f4(u, 54), t4 && f4(u, 48), u.flags &= -129;
            let b = e2 & 64 ? f1(u, e2, i4) : void 0;
            return u1(u, e2, b, [n], l, c, s4, h4);
          }
          function h1(u, e2, i4, n, t4, o, l, c, s4) {
            t4 || f4(u, 54);
            for (let h4 = 0; h4 < n.length; ++h4)
              v2(u, n[h4]);
            return u1(u, e2, i4, n, o, l, c, s4);
          }
          function u1(u, e2, i4, n, t4, o, l, c) {
            u.flags & 1 && f4(u, 45), w(u, e2 | 32768, 10), e2 = (e2 | 15728640) ^ 15728640 | t4 << 22;
            let s4 = u.token !== 2162700, h4;
            if (i4 && i4.scopeError !== void 0 && P(i4.scopeError), s4)
              h4 = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            else {
              switch (i4 && (i4 = o2(i4, 128)), h4 = a1(u, (e2 | 134221824 | 8192 | 16384) ^ 134246400, i4, 16, void 0, void 0), u.token) {
                case 69271571:
                  (u.flags & 1) < 1 && f4(u, 112);
                  break;
                case 67108877:
                case 67174409:
                case 22:
                  f4(u, 113);
                case 67174411:
                  (u.flags & 1) < 1 && f4(u, 112), u.flags |= 1024;
                  break;
              }
              (u.token & 8454144) === 8454144 && (u.flags & 1) < 1 && f4(u, 28, G[u.token & 255]), (u.token & 33619968) === 33619968 && f4(u, 121);
            }
            return u.assignable = 2, v(u, e2, o, l, c, { type: "ArrowFunctionExpression", params: n, body: h4, async: t4 === 1, expression: s4 });
          }
          function be(u, e2, i4, n, t4) {
            w(u, e2, 67174411), u.flags = (u.flags | 128) ^ 128;
            let o = [];
            if (U(u, e2, 16))
              return o;
            e2 = (e2 | 134217728) ^ 134217728;
            let l = 0;
            for (; u.token !== 18; ) {
              let c, { tokenPos: s4, linePos: h4, colPos: b } = u;
              if (u.token & 143360 ? ((e2 & 1024) < 1 && ((u.token & 36864) === 36864 && (u.flags |= 256), (u.token & 537079808) === 537079808 && (u.flags |= 512)), c = Q1(u, e2, i4, t4 | 1, 0, s4, h4, b)) : (u.token === 2162700 ? c = r22(u, e2, i4, 1, n, 1, t4, 0, s4, h4, b) : u.token === 69271571 ? c = k2(u, e2, i4, 1, n, 1, t4, 0, s4, h4, b) : u.token === 14 ? c = W2(u, e2, i4, 16, t4, 0, 0, n, 1, s4, h4, b) : f4(u, 28, G[u.token & 255]), l = 1, u.destructible & 48 && f4(u, 47)), u.token === 1077936157) {
                E(u, e2 | 32768), l = 1;
                let g = Q(u, e2, 1, 1, n, u.tokenPos, u.linePos, u.colPos);
                c = v(u, e2, s4, h4, b, { type: "AssignmentPattern", left: c, right: g });
              }
              if (o.push(c), !U(u, e2, 18) || u.token === 16)
                break;
            }
            return l && (u.flags |= 128), i4 && (l || e2 & 1024) && i4.scopeError !== void 0 && P(i4.scopeError), w(u, e2, 16), o;
          }
          function m1(u, e2, i4, n, t4, o, l) {
            let { token: c } = u;
            if (c & 67108864) {
              if (c === 67108877) {
                E(u, e2 | 1073741824), u.assignable = 1;
                let s4 = se(u, e2);
                return m1(u, e2, v(u, e2, t4, o, l, { type: "MemberExpression", object: i4, computed: false, property: s4 }), 0, t4, o, l);
              } else if (c === 69271571) {
                E(u, e2 | 32768);
                let { tokenPos: s4, linePos: h4, colPos: b } = u, g = f22(u, e2, n, 1, s4, h4, b);
                return w(u, e2, 20), u.assignable = 1, m1(u, e2, v(u, e2, t4, o, l, { type: "MemberExpression", object: i4, computed: true, property: g }), 0, t4, o, l);
              } else if (c === 67174408 || c === 67174409)
                return u.assignable = 2, m1(u, e2, v(u, e2, t4, o, l, { type: "TaggedTemplateExpression", tag: i4, quasi: u.token === 67174408 ? K1(u, e2 | 65536) : H1(u, e2, u.tokenPos, u.linePos, u.colPos) }), 0, t4, o, l);
            }
            return i4;
          }
          function rt(u, e2, i4, n, t4, o) {
            let l = z(u, e2 | 32768, 0), { tokenPos: c, linePos: s4, colPos: h4 } = u;
            if (U(u, e2, 67108877)) {
              if (e2 & 67108864 && u.token === 143494)
                return u.assignable = 2, vt(u, e2, l, n, t4, o);
              f4(u, 91);
            }
            u.assignable = 2, (u.token & 16842752) === 16842752 && f4(u, 62, G[u.token & 255]);
            let b = h2(u, e2, 2, 1, 0, 0, i4, 1, c, s4, h4);
            e2 = (e2 | 134217728) ^ 134217728, u.token === 67108991 && f4(u, 162);
            let g = m1(u, e2, b, i4, c, s4, h4);
            return u.assignable = 2, v(u, e2, n, t4, o, { type: "NewExpression", callee: g, arguments: u.token === 67174411 ? W1(u, e2, i4) : [] });
          }
          function vt(u, e2, i4, n, t4, o) {
            let l = z(u, e2, 0);
            return v(u, e2, n, t4, o, { type: "MetaProperty", meta: i4, property: l });
          }
          function ke(u, e2, i4, n, t4, o) {
            return u.token === 209008 && f4(u, 29), e2 & 2098176 && u.token === 241773 && f4(u, 30), (u.token & 537079808) === 537079808 && (u.flags |= 512), g1(u, e2, u.tokenValue, z(u, e2, 0), 0, i4, 1, n, t4, o);
          }
          function $1(u, e2, i4, n, t4, o, l, c, s4, h4) {
            E(u, e2 | 32768);
            let b = e2 & 64 ? o2(j2(), 1024) : void 0;
            if (e2 = (e2 | 134217728) ^ 134217728, U(u, e2, 16))
              return u.token === 10 ? (l & 1 && f4(u, 45), h1(u, e2, b, [], n, 1, c, s4, h4)) : v(u, e2, c, s4, h4, { type: "CallExpression", callee: i4, arguments: [] });
            let g = 0, a = null, A4 = 0;
            u.destructible = (u.destructible | 256 | 128) ^ 384;
            let C = [];
            for (; u.token !== 16; ) {
              let { token: D, tokenPos: B, linePos: O, colPos: j } = u;
              if (D & 143360)
                b && B2(u, e2, b, u.tokenValue, t4, 0), a = h2(u, e2, t4, 0, 1, 0, 1, 1, B, O, j), u.token === 16 || u.token === 18 ? u.assignable & 2 ? (g |= 16, A4 = 1) : (D & 537079808) === 537079808 ? u.flags |= 512 : (D & 36864) === 36864 && (u.flags |= 256) : (u.token === 1077936157 ? A4 = 1 : g |= 16, a = W(u, e2, a, 1, 0, B, O, j), u.token !== 16 && u.token !== 18 && (a = x3(u, e2, 1, 0, B, O, j, a)));
              else if (D & 2097152)
                a = D === 2162700 ? r22(u, e2, b, 0, 1, 0, t4, o, B, O, j) : k2(u, e2, b, 0, 1, 0, t4, o, B, O, j), g |= u.destructible, A4 = 1, u.token !== 16 && u.token !== 18 && (g & 8 && f4(u, 118), a = W(u, e2, a, 0, 0, B, O, j), g |= 16, (u.token & 8454144) === 8454144 && (a = F22(u, e2, 1, c, s4, h4, 4, D, a)), U(u, e2 | 32768, 22) && (a = M2(u, e2, a, c, s4, h4)));
              else if (D === 14)
                a = W2(u, e2, b, 16, t4, o, 1, 1, 0, B, O, j), g |= (u.token === 16 ? 0 : 16) | u.destructible, A4 = 1;
              else {
                for (a = Q(u, e2, 1, 0, 0, B, O, j), g = u.assignable, C.push(a); U(u, e2 | 32768, 18); )
                  C.push(Q(u, e2, 1, 0, 0, B, O, j));
                return g |= u.assignable, w(u, e2, 16), u.destructible = g | 16, u.assignable = 2, v(u, e2, c, s4, h4, { type: "CallExpression", callee: i4, arguments: C });
              }
              if (C.push(a), !U(u, e2 | 32768, 18))
                break;
            }
            return w(u, e2, 16), g |= u.destructible & 256 ? 256 : 0 | u.destructible & 128 ? 128 : 0, u.token === 10 ? (g & 48 && f4(u, 25), (u.flags & 1 || l & 1) && f4(u, 45), g & 128 && f4(u, 29), e2 & 2098176 && g & 256 && f4(u, 30), A4 && (u.flags |= 128), h1(u, e2, b, C, n, 1, c, s4, h4)) : (g & 8 && f4(u, 59), u.assignable = 2, v(u, e2, c, s4, h4, { type: "CallExpression", callee: i4, arguments: C }));
          }
          function At(u, e2, i4, n, t4) {
            let { tokenRaw: o, tokenRegExp: l, tokenValue: c } = u;
            return E(u, e2), u.assignable = 2, e2 & 512 ? v(u, e2, i4, n, t4, { type: "Literal", value: c, regex: l, raw: o }) : v(u, e2, i4, n, t4, { type: "Literal", value: c, regex: l });
          }
          function Z1(u, e2, i4, n, t4, o, l) {
            e2 = (e2 | 16777216 | 1024) ^ 16777216;
            let c = b1(u, e2);
            c.length && (t4 = u.tokenPos, o = u.linePos, l = u.colPos), u.leadingDecorators.length && (u.leadingDecorators.push(...c), c = u.leadingDecorators, u.leadingDecorators = []), E(u, e2);
            let s4 = null, h4 = null, { tokenValue: b } = u;
            u.token & 4096 && u.token !== 20567 ? (Gu(u, e2, u.token) && f4(u, 114), (u.token & 537079808) === 537079808 && f4(u, 115), i4 && (B2(u, e2, i4, b, 32, 0), n && n & 2 && _2(u, b)), s4 = z(u, e2, 0)) : (n & 1) < 1 && f4(u, 37, "Class");
            let g = e2;
            U(u, e2 | 32768, 20567) ? (h4 = b2(u, e2, 0, 0, 0, u.tokenPos, u.linePos, u.colPos), g |= 524288) : g = (g | 524288) ^ 524288;
            let a = re(u, g, e2, i4, 2, 8, 0);
            return v(u, e2, t4, o, l, e2 & 1 ? { type: "ClassDeclaration", id: s4, superClass: h4, decorators: c, body: a } : { type: "ClassDeclaration", id: s4, superClass: h4, body: a });
          }
          function yt(u, e2, i4, n, t4, o) {
            let l = null, c = null;
            e2 = (e2 | 1024 | 16777216) ^ 16777216;
            let s4 = b1(u, e2);
            s4.length && (n = u.tokenPos, t4 = u.linePos, o = u.colPos), E(u, e2), u.token & 4096 && u.token !== 20567 && (Gu(u, e2, u.token) && f4(u, 114), (u.token & 537079808) === 537079808 && f4(u, 115), l = z(u, e2, 0));
            let h4 = e2;
            U(u, e2 | 32768, 20567) ? (c = b2(u, e2, 0, i4, 0, u.tokenPos, u.linePos, u.colPos), h4 |= 524288) : h4 = (h4 | 524288) ^ 524288;
            let b = re(u, h4, e2, void 0, 2, 0, i4);
            return u.assignable = 2, v(u, e2, n, t4, o, e2 & 1 ? { type: "ClassExpression", id: l, superClass: c, decorators: s4, body: b } : { type: "ClassExpression", id: l, superClass: c, body: b });
          }
          function b1(u, e2) {
            let i4 = [];
            if (e2 & 1)
              for (; u.token === 133; )
                i4.push(Pt(u, e2, u.tokenPos, u.linePos, u.colPos));
            return i4;
          }
          function Pt(u, e2, i4, n, t4) {
            E(u, e2 | 32768);
            let o = h2(u, e2, 2, 0, 1, 0, 0, 1, i4, n, t4);
            return o = W(u, e2, o, 0, 0, i4, n, t4), v(u, e2, i4, n, t4, { type: "Decorator", expression: o });
          }
          function re(u, e2, i4, n, t4, o, l) {
            let { tokenPos: c, linePos: s4, colPos: h4 } = u;
            w(u, e2 | 32768, 2162700), e2 = (e2 | 134217728) ^ 134217728, u.flags = (u.flags | 32) ^ 32;
            let b = [], g;
            for (; u.token !== 1074790415; ) {
              let a = 0;
              if (g = b1(u, e2), a = g.length, a > 0 && u.tokenValue === "constructor" && f4(u, 106), u.token === 1074790415 && f4(u, 105), U(u, e2, 1074790417)) {
                a > 0 && f4(u, 116);
                continue;
              }
              b.push(ve(u, e2, n, i4, t4, g, 0, l, u.tokenPos, u.linePos, u.colPos));
            }
            return w(u, o & 8 ? e2 | 32768 : e2, 1074790415), v(u, e2, c, s4, h4, { type: "ClassBody", body: b });
          }
          function ve(u, e2, i4, n, t4, o, l, c, s4, h4, b) {
            let g = l ? 32 : 0, a = null, { token: A4, tokenPos: C, linePos: D, colPos: B } = u;
            if (A4 & 176128)
              switch (a = z(u, e2, 0), A4) {
                case 36972:
                  if (!l && u.token !== 67174411)
                    return ve(u, e2, i4, n, t4, o, 1, c, s4, h4, b);
                  break;
                case 209007:
                  if (u.token !== 67174411 && (u.flags & 1) < 1) {
                    if (e2 & 1 && (u.token & 1073741824) === 1073741824)
                      return r1(u, e2, a, g, o, C, D, B);
                    g |= 16 | (V1(u, e2, 8457014) ? 8 : 0);
                  }
                  break;
                case 12402:
                  if (u.token !== 67174411) {
                    if (e2 & 1 && (u.token & 1073741824) === 1073741824)
                      return r1(u, e2, a, g, o, C, D, B);
                    g |= 256;
                  }
                  break;
                case 12403:
                  if (u.token !== 67174411) {
                    if (e2 & 1 && (u.token & 1073741824) === 1073741824)
                      return r1(u, e2, a, g, o, C, D, B);
                    g |= 512;
                  }
                  break;
              }
            else
              A4 === 69271571 ? (g |= 2, a = Y2(u, n, c)) : (A4 & 134217728) === 134217728 ? a = a2(u, e2) : A4 === 8457014 ? (g |= 8, E(u, e2)) : e2 & 1 && u.token === 131 ? (g |= 4096, a = k1(u, e2 | 16384, C, D, B)) : e2 & 1 && (u.token & 1073741824) === 1073741824 ? g |= 128 : A4 === 122 ? (a = z(u, e2, 0), u.token !== 67174411 && f4(u, 28, G[u.token & 255])) : f4(u, 28, G[u.token & 255]);
            if (g & 792 && (u.token & 143360 ? a = z(u, e2, 0) : (u.token & 134217728) === 134217728 ? a = a2(u, e2) : u.token === 69271571 ? (g |= 2, a = Y2(u, e2, 0)) : u.token === 122 ? a = z(u, e2, 0) : e2 & 1 && u.token === 131 ? (g |= 4096, a = k1(u, e2, C, D, B)) : f4(u, 131)), (g & 2) < 1 && (u.tokenValue === "constructor" ? ((u.token & 1073741824) === 1073741824 ? f4(u, 125) : (g & 32) < 1 && u.token === 67174411 && (g & 920 ? f4(u, 50, "accessor") : (e2 & 524288) < 1 && (u.flags & 32 ? f4(u, 51) : u.flags |= 32)), g |= 64) : (g & 4096) < 1 && g & 824 && u.tokenValue === "prototype" && f4(u, 49)), e2 & 1 && u.token !== 67174411)
              return r1(u, e2, a, g, o, C, D, B);
            let O = A2(u, e2, g, c, u.tokenPos, u.linePos, u.colPos);
            return v(u, e2, s4, h4, b, e2 & 1 ? { type: "MethodDefinition", kind: (g & 32) < 1 && g & 64 ? "constructor" : g & 256 ? "get" : g & 512 ? "set" : "method", static: (g & 32) > 0, computed: (g & 2) > 0, key: a, decorators: o, value: O } : { type: "MethodDefinition", kind: (g & 32) < 1 && g & 64 ? "constructor" : g & 256 ? "get" : g & 512 ? "set" : "method", static: (g & 32) > 0, computed: (g & 2) > 0, key: a, value: O });
          }
          function k1(u, e2, i4, n, t4) {
            E(u, e2);
            let { tokenValue: o } = u;
            return o === "constructor" && f4(u, 124), E(u, e2), v(u, e2, i4, n, t4, { type: "PrivateIdentifier", name: o });
          }
          function r1(u, e2, i4, n, t4, o, l, c) {
            let s4 = null;
            if (n & 8 && f4(u, 0), u.token === 1077936157) {
              E(u, e2 | 32768);
              let { tokenPos: h4, linePos: b, colPos: g } = u;
              u.token === 537079928 && f4(u, 115), s4 = h2(u, e2 | 16384, 2, 0, 1, 0, 0, 1, h4, b, g), (u.token & 1073741824) !== 1073741824 && (s4 = W(u, e2 | 16384, s4, 0, 0, h4, b, g), s4 = x3(u, e2 | 16384, 0, 0, h4, b, g, s4), u.token === 18 && (s4 = S22(u, e2, 0, o, l, c, s4)));
            }
            return v(u, e2, o, l, c, { type: "PropertyDefinition", key: i4, value: s4, static: (n & 32) > 0, computed: (n & 2) > 0, decorators: t4 });
          }
          function Ae(u, e2, i4, n, t4, o, l, c) {
            if (u.token & 143360)
              return Q1(u, e2, i4, n, t4, o, l, c);
            (u.token & 2097152) !== 2097152 && f4(u, 28, G[u.token & 255]);
            let s4 = u.token === 69271571 ? k2(u, e2, i4, 1, 0, 1, n, t4, o, l, c) : r22(u, e2, i4, 1, 0, 1, n, t4, o, l, c);
            return u.destructible & 16 && f4(u, 47), u.destructible & 32 && f4(u, 47), s4;
          }
          function Q1(u, e2, i4, n, t4, o, l, c) {
            let { tokenValue: s4, token: h4 } = u;
            return e2 & 1024 && ((h4 & 537079808) === 537079808 ? f4(u, 115) : (h4 & 36864) === 36864 && f4(u, 114)), (h4 & 20480) === 20480 && f4(u, 99), e2 & 2099200 && h4 === 241773 && f4(u, 30), h4 === 241739 && n & 24 && f4(u, 97), e2 & 4196352 && h4 === 209008 && f4(u, 95), E(u, e2), i4 && q2(u, e2, i4, s4, n, t4), v(u, e2, o, l, c, { type: "Identifier", name: s4 });
          }
          function G1(u, e2, i4, n, t4, o) {
            if (E(u, e2), u.token === 8456259)
              return v(u, e2, n, t4, o, { type: "JSXFragment", openingFragment: Et(u, e2, n, t4, o), children: ye(u, e2), closingFragment: Ct(u, e2, i4, u.tokenPos, u.linePos, u.colPos) });
            let l = null, c = [], s4 = Bt(u, e2, i4, n, t4, o);
            if (!s4.selfClosing) {
              c = ye(u, e2), l = Dt(u, e2, i4, u.tokenPos, u.linePos, u.colPos);
              let h4 = l1(l.name);
              l1(s4.name) !== h4 && f4(u, 149, h4);
            }
            return v(u, e2, n, t4, o, { type: "JSXElement", children: c, openingElement: s4, closingElement: l });
          }
          function Et(u, e2, i4, n, t4) {
            return V2(u, e2), v(u, e2, i4, n, t4, { type: "JSXOpeningFragment" });
          }
          function Dt(u, e2, i4, n, t4, o) {
            w(u, e2, 25);
            let l = Pe(u, e2, u.tokenPos, u.linePos, u.colPos);
            return i4 ? w(u, e2, 8456259) : u.token = V2(u, e2), v(u, e2, n, t4, o, { type: "JSXClosingElement", name: l });
          }
          function Ct(u, e2, i4, n, t4, o) {
            return w(u, e2, 25), w(u, e2, 8456259), v(u, e2, n, t4, o, { type: "JSXClosingFragment" });
          }
          function ye(u, e2) {
            let i4 = [];
            for (; u.token !== 25; )
              u.index = u.tokenPos = u.startPos, u.column = u.colPos = u.startColumn, u.line = u.linePos = u.startLine, V2(u, e2), i4.push(wt(u, e2, u.tokenPos, u.linePos, u.colPos));
            return i4;
          }
          function wt(u, e2, i4, n, t4) {
            if (u.token === 138)
              return qt(u, e2, i4, n, t4);
            if (u.token === 2162700)
              return De(u, e2, 0, 0, i4, n, t4);
            if (u.token === 8456258)
              return G1(u, e2, 0, i4, n, t4);
            f4(u, 0);
          }
          function qt(u, e2, i4, n, t4) {
            V2(u, e2);
            let o = { type: "JSXText", value: u.tokenValue };
            return e2 & 512 && (o.raw = u.tokenRaw), v(u, e2, i4, n, t4, o);
          }
          function Bt(u, e2, i4, n, t4, o) {
            (u.token & 143360) !== 143360 && (u.token & 4096) !== 4096 && f4(u, 0);
            let l = Pe(u, e2, u.tokenPos, u.linePos, u.colPos), c = Ft(u, e2), s4 = u.token === 8457016;
            return u.token === 8456259 ? V2(u, e2) : (w(u, e2, 8457016), i4 ? w(u, e2, 8456259) : V2(u, e2)), v(u, e2, n, t4, o, { type: "JSXOpeningElement", name: l, attributes: c, selfClosing: s4 });
          }
          function Pe(u, e2, i4, n, t4) {
            N1(u);
            let o = v1(u, e2, i4, n, t4);
            if (u.token === 21)
              return Ee(u, e2, o, i4, n, t4);
            for (; U(u, e2, 67108877); )
              N1(u), o = St(u, e2, o, i4, n, t4);
            return o;
          }
          function St(u, e2, i4, n, t4, o) {
            let l = v1(u, e2, u.tokenPos, u.linePos, u.colPos);
            return v(u, e2, n, t4, o, { type: "JSXMemberExpression", object: i4, property: l });
          }
          function Ft(u, e2) {
            let i4 = [];
            for (; u.token !== 8457016 && u.token !== 8456259 && u.token !== 1048576; )
              i4.push(Lt(u, e2, u.tokenPos, u.linePos, u.colPos));
            return i4;
          }
          function Tt(u, e2, i4, n, t4) {
            E(u, e2), w(u, e2, 14);
            let o = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            return w(u, e2, 1074790415), v(u, e2, i4, n, t4, { type: "JSXSpreadAttribute", argument: o });
          }
          function Lt(u, e2, i4, n, t4) {
            if (u.token === 2162700)
              return Tt(u, e2, i4, n, t4);
            N1(u);
            let o = null, l = v1(u, e2, i4, n, t4);
            if (u.token === 21 && (l = Ee(u, e2, l, i4, n, t4)), u.token === 1077936157) {
              let c = w0(u, e2), { tokenPos: s4, linePos: h4, colPos: b } = u;
              switch (c) {
                case 134283267:
                  o = a2(u, e2);
                  break;
                case 8456258:
                  o = G1(u, e2, 1, s4, h4, b);
                  break;
                case 2162700:
                  o = De(u, e2, 1, 1, s4, h4, b);
                  break;
                default:
                  f4(u, 148);
              }
            }
            return v(u, e2, i4, n, t4, { type: "JSXAttribute", value: o, name: l });
          }
          function Ee(u, e2, i4, n, t4, o) {
            w(u, e2, 21);
            let l = v1(u, e2, u.tokenPos, u.linePos, u.colPos);
            return v(u, e2, n, t4, o, { type: "JSXNamespacedName", namespace: i4, name: l });
          }
          function De(u, e2, i4, n, t4, o, l) {
            E(u, e2 | 32768);
            let { tokenPos: c, linePos: s4, colPos: h4 } = u;
            if (u.token === 14)
              return Ot(u, e2, c, s4, h4);
            let b = null;
            return u.token === 1074790415 ? (n && f4(u, 151), b = It(u, e2, u.startPos, u.startLine, u.startColumn)) : b = Q(u, e2, 1, 0, 0, c, s4, h4), i4 ? w(u, e2, 1074790415) : V2(u, e2), v(u, e2, t4, o, l, { type: "JSXExpressionContainer", expression: b });
          }
          function Ot(u, e2, i4, n, t4) {
            w(u, e2, 14);
            let o = Q(u, e2, 1, 0, 0, u.tokenPos, u.linePos, u.colPos);
            return w(u, e2, 1074790415), v(u, e2, i4, n, t4, { type: "JSXSpreadChild", expression: o });
          }
          function It(u, e2, i4, n, t4) {
            return u.startPos = u.tokenPos, u.startLine = u.linePos, u.startColumn = u.colPos, v(u, e2, i4, n, t4, { type: "JSXEmptyExpression" });
          }
          function v1(u, e2, i4, n, t4) {
            let { tokenValue: o } = u;
            return E(u, e2), v(u, e2, i4, n, t4, { type: "JSXIdentifier", name: o });
          }
          var Rt = Object.freeze({ __proto__: null }), Nt = "4.2.1", Vt = Nt;
          function jt(u, e2) {
            return U1(u, e2, 0);
          }
          function _t(u, e2) {
            return U1(u, e2, 3072);
          }
          function Mt(u, e2) {
            return U1(u, e2, 0);
          }
          d.ESTree = Rt, d.parse = Mt, d.parseModule = _t, d.parseScript = jt, d.version = Vt;
        } });
        n2();
        var h3 = pn(), m3 = $4(), b3 = o3(), k3 = d3(), r3 = { module: true, next: true, ranges: true, webcompat: true, loc: true, raw: true, directives: true, globalReturn: true, impliedStrict: false, preserveParens: false, lexical: false, identifierPattern: false, jsx: true, specDeviation: true, uniqueKeyInPattern: false };
        function Gn(d, m2) {
          let { parse: k } = g3(), f4 = [], P = [], S2 = k(d, Object.assign(Object.assign({}, r3), {}, { module: m2, onComment: f4, onToken: P }));
          return S2.comments = f4, S2.tokens = P, S2;
        }
        function v3(d) {
          let { message: m2, line: k, column: f4 } = d, P = (m2.match(/^\[(?<line>\d+):(?<column>\d+)]: (?<message>.*)$/) || {}).groups;
          return P && (m2 = P.message, typeof k != "number" && (k = Number(P.line), f4 = Number(P.column))), typeof k != "number" ? d : h3(m2, { start: { line: k, column: f4 } });
        }
        function A3(d, m2) {
          let k = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { result: f4, error: P } = m3(() => Gn(d, true), () => Gn(d, false));
          if (!f4)
            throw v3(P);
          return k.originalText = d, k3(f4, k);
        }
        k0.exports = { parsers: { meriyah: b3(A3) } };
      });
      return y3();
    });
  }
});

// node_modules/prettier/parser-postcss.js
var require_parser_postcss = __commonJS({
  "node_modules/prettier/parser-postcss.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.postcss = e2();
      }
    })(function() {
      "use strict";
      var V = (e2, n) => () => (n || e2((n = { exports: {} }).exports, n), n.exports);
      var ee = V((pp, Ut) => {
        var er = function(e2) {
          return e2 && e2.Math == Math && e2;
        };
        Ut.exports = er(typeof globalThis == "object" && globalThis) || er(typeof window == "object" && window) || er(typeof self == "object" && self) || er(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      });
      var ke = V((hp, Wt) => {
        Wt.exports = function(e2) {
          try {
            return !!e2();
          } catch {
            return true;
          }
        };
      });
      var Te = V((dp, $t) => {
        var fa = ke();
        $t.exports = !fa(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Sr = V((vp, Vt) => {
        var pa = ke();
        Vt.exports = !pa(function() {
          var e2 = function() {
          }.bind();
          return typeof e2 != "function" || e2.hasOwnProperty("prototype");
        });
      });
      var tr = V((mp, Gt) => {
        var ha = Sr(), rr = Function.prototype.call;
        Gt.exports = ha ? rr.bind(rr) : function() {
          return rr.apply(rr, arguments);
        };
      });
      var Qt = V((Kt) => {
        "use strict";
        var Ht = {}.propertyIsEnumerable, Jt = Object.getOwnPropertyDescriptor, da = Jt && !Ht.call({ 1: 2 }, 1);
        Kt.f = da ? function(n) {
          var i2 = Jt(this, n);
          return !!i2 && i2.enumerable;
        } : Ht;
      });
      var Or = V((yp, Yt) => {
        Yt.exports = function(e2, n) {
          return { enumerable: !(e2 & 1), configurable: !(e2 & 2), writable: !(e2 & 4), value: n };
        };
      });
      var de = V((wp, en) => {
        var Xt = Sr(), Zt = Function.prototype, va = Zt.bind, Tr = Zt.call, ma = Xt && va.bind(Tr, Tr);
        en.exports = Xt ? function(e2) {
          return e2 && ma(e2);
        } : function(e2) {
          return e2 && function() {
            return Tr.apply(e2, arguments);
          };
        };
      });
      var nn = V((_p, tn) => {
        var rn = de(), ga = rn({}.toString), ya = rn("".slice);
        tn.exports = function(e2) {
          return ya(ga(e2), 8, -1);
        };
      });
      var on = V((bp, sn) => {
        var wa = ee(), _a4 = de(), ba = ke(), xa = nn(), Er = wa.Object, ka = _a4("".split);
        sn.exports = ba(function() {
          return !Er("z").propertyIsEnumerable(0);
        }) ? function(e2) {
          return xa(e2) == "String" ? ka(e2, "") : Er(e2);
        } : Er;
      });
      var qr = V((xp, an) => {
        var Sa = ee(), Oa = Sa.TypeError;
        an.exports = function(e2) {
          if (e2 == null)
            throw Oa("Can't call method on " + e2);
          return e2;
        };
      });
      var nr = V((kp, un) => {
        var Ta = on(), Ea = qr();
        un.exports = function(e2) {
          return Ta(Ea(e2));
        };
      });
      var ve = V((Sp, cn) => {
        cn.exports = function(e2) {
          return typeof e2 == "function";
        };
      });
      var Me = V((Op, ln) => {
        var qa = ve();
        ln.exports = function(e2) {
          return typeof e2 == "object" ? e2 !== null : qa(e2);
        };
      });
      var ir = V((Tp, fn) => {
        var Ar = ee(), Aa = ve(), Pa = function(e2) {
          return Aa(e2) ? e2 : void 0;
        };
        fn.exports = function(e2, n) {
          return arguments.length < 2 ? Pa(Ar[e2]) : Ar[e2] && Ar[e2][n];
        };
      });
      var hn = V((Ep, pn) => {
        var Ra = de();
        pn.exports = Ra({}.isPrototypeOf);
      });
      var vn = V((qp, dn) => {
        var Ia = ir();
        dn.exports = Ia("navigator", "userAgent") || "";
      });
      var xn = V((Ap, bn) => {
        var _n = ee(), Pr = vn(), mn = _n.process, gn = _n.Deno, yn = mn && mn.versions || gn && gn.version, wn = yn && yn.v8, he, sr;
        wn && (he = wn.split("."), sr = he[0] > 0 && he[0] < 4 ? 1 : +(he[0] + he[1]));
        !sr && Pr && (he = Pr.match(/Edge\/(\d+)/), (!he || he[1] >= 74) && (he = Pr.match(/Chrome\/(\d+)/), he && (sr = +he[1])));
        bn.exports = sr;
      });
      var Rr = V((Pp, Sn) => {
        var kn = xn(), Ca = ke();
        Sn.exports = !!Object.getOwnPropertySymbols && !Ca(function() {
          var e2 = Symbol();
          return !String(e2) || !(Object(e2) instanceof Symbol) || !Symbol.sham && kn && kn < 41;
        });
      });
      var Ir = V((Rp, On) => {
        var Na = Rr();
        On.exports = Na && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var Cr = V((Ip, Tn) => {
        var ja = ee(), Ma = ir(), Da = ve(), La = hn(), za = Ir(), Ba = ja.Object;
        Tn.exports = za ? function(e2) {
          return typeof e2 == "symbol";
        } : function(e2) {
          var n = Ma("Symbol");
          return Da(n) && La(n.prototype, Ba(e2));
        };
      });
      var qn = V((Cp, En) => {
        var Fa = ee(), Ua = Fa.String;
        En.exports = function(e2) {
          try {
            return Ua(e2);
          } catch {
            return "Object";
          }
        };
      });
      var Pn = V((Np, An) => {
        var Wa = ee(), $a = ve(), Va = qn(), Ga = Wa.TypeError;
        An.exports = function(e2) {
          if ($a(e2))
            return e2;
          throw Ga(Va(e2) + " is not a function");
        };
      });
      var In = V((jp, Rn) => {
        var Ha = Pn();
        Rn.exports = function(e2, n) {
          var i2 = e2[n];
          return i2 == null ? void 0 : Ha(i2);
        };
      });
      var Nn = V((Mp, Cn) => {
        var Ja = ee(), Nr = tr(), jr = ve(), Mr = Me(), Ka = Ja.TypeError;
        Cn.exports = function(e2, n) {
          var i2, a;
          if (n === "string" && jr(i2 = e2.toString) && !Mr(a = Nr(i2, e2)) || jr(i2 = e2.valueOf) && !Mr(a = Nr(i2, e2)) || n !== "string" && jr(i2 = e2.toString) && !Mr(a = Nr(i2, e2)))
            return a;
          throw Ka("Can't convert object to primitive value");
        };
      });
      var Mn = V((Dp, jn) => {
        jn.exports = false;
      });
      var or = V((Lp, Ln) => {
        var Dn = ee(), Qa = Object.defineProperty;
        Ln.exports = function(e2, n) {
          try {
            Qa(Dn, e2, { value: n, configurable: true, writable: true });
          } catch {
            Dn[e2] = n;
          }
          return n;
        };
      });
      var ar = V((zp, Bn) => {
        var Ya = ee(), Xa = or(), zn = "__core-js_shared__", Za = Ya[zn] || Xa(zn, {});
        Bn.exports = Za;
      });
      var Dr = V((Bp, Un) => {
        var eu = Mn(), Fn = ar();
        (Un.exports = function(e2, n) {
          return Fn[e2] || (Fn[e2] = n !== void 0 ? n : {});
        })("versions", []).push({ version: "3.22.2", mode: eu ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var $n = V((Fp, Wn) => {
        var ru = ee(), tu = qr(), nu = ru.Object;
        Wn.exports = function(e2) {
          return nu(tu(e2));
        };
      });
      var Se = V((Up, Vn) => {
        var iu = de(), su = $n(), ou = iu({}.hasOwnProperty);
        Vn.exports = Object.hasOwn || function(n, i2) {
          return ou(su(n), i2);
        };
      });
      var Lr = V((Wp, Gn) => {
        var au = de(), uu = 0, cu = Math.random(), lu = au(1 .toString);
        Gn.exports = function(e2) {
          return "Symbol(" + (e2 === void 0 ? "" : e2) + ")_" + lu(++uu + cu, 36);
        };
      });
      var Xn = V(($p, Yn) => {
        var fu = ee(), pu = Dr(), Hn = Se(), hu = Lr(), Jn = Rr(), Qn = Ir(), De = pu("wks"), Ee = fu.Symbol, Kn = Ee && Ee.for, du = Qn ? Ee : Ee && Ee.withoutSetter || hu;
        Yn.exports = function(e2) {
          if (!Hn(De, e2) || !(Jn || typeof De[e2] == "string")) {
            var n = "Symbol." + e2;
            Jn && Hn(Ee, e2) ? De[e2] = Ee[e2] : Qn && Kn ? De[e2] = Kn(n) : De[e2] = du(n);
          }
          return De[e2];
        };
      });
      var ti = V((Vp, ri) => {
        var vu = ee(), mu = tr(), Zn = Me(), ei = Cr(), gu = In(), yu = Nn(), wu = Xn(), _u = vu.TypeError, bu = wu("toPrimitive");
        ri.exports = function(e2, n) {
          if (!Zn(e2) || ei(e2))
            return e2;
          var i2 = gu(e2, bu), a;
          if (i2) {
            if (n === void 0 && (n = "default"), a = mu(i2, e2, n), !Zn(a) || ei(a))
              return a;
            throw _u("Can't convert object to primitive value");
          }
          return n === void 0 && (n = "number"), yu(e2, n);
        };
      });
      var zr = V((Gp, ni) => {
        var xu = ti(), ku = Cr();
        ni.exports = function(e2) {
          var n = xu(e2, "string");
          return ku(n) ? n : n + "";
        };
      });
      var oi = V((Hp, si) => {
        var Su = ee(), ii = Me(), Br = Su.document, Ou = ii(Br) && ii(Br.createElement);
        si.exports = function(e2) {
          return Ou ? Br.createElement(e2) : {};
        };
      });
      var Fr = V((Jp, ai) => {
        var Tu = Te(), Eu = ke(), qu = oi();
        ai.exports = !Tu && !Eu(function() {
          return Object.defineProperty(qu("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var Ur = V((ci) => {
        var Au = Te(), Pu = tr(), Ru = Qt(), Iu = Or(), Cu = nr(), Nu = zr(), ju = Se(), Mu = Fr(), ui = Object.getOwnPropertyDescriptor;
        ci.f = Au ? ui : function(n, i2) {
          if (n = Cu(n), i2 = Nu(i2), Mu)
            try {
              return ui(n, i2);
            } catch {
            }
          if (ju(n, i2))
            return Iu(!Pu(Ru.f, n, i2), n[i2]);
        };
      });
      var fi = V((Qp, li) => {
        var Du = Te(), Lu = ke();
        li.exports = Du && Lu(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var Wr = V((Yp, hi) => {
        var pi = ee(), zu = Me(), Bu = pi.String, Fu = pi.TypeError;
        hi.exports = function(e2) {
          if (zu(e2))
            return e2;
          throw Fu(Bu(e2) + " is not an object");
        };
      });
      var Jr = V((vi) => {
        var Uu = ee(), Wu = Te(), $u = Fr(), Vu = fi(), ur = Wr(), di = zr(), Gu = Uu.TypeError, $r = Object.defineProperty, Hu = Object.getOwnPropertyDescriptor, Vr = "enumerable", Gr = "configurable", Hr = "writable";
        vi.f = Wu ? Vu ? function(n, i2, a) {
          if (ur(n), i2 = di(i2), ur(a), typeof n == "function" && i2 === "prototype" && "value" in a && Hr in a && !a[Hr]) {
            var o = Hu(n, i2);
            o && o[Hr] && (n[i2] = a.value, a = { configurable: Gr in a ? a[Gr] : o[Gr], enumerable: Vr in a ? a[Vr] : o[Vr], writable: false });
          }
          return $r(n, i2, a);
        } : $r : function(n, i2, a) {
          if (ur(n), i2 = di(i2), ur(a), $u)
            try {
              return $r(n, i2, a);
            } catch {
            }
          if ("get" in a || "set" in a)
            throw Gu("Accessors not supported");
          return "value" in a && (n[i2] = a.value), n;
        };
      });
      var cr = V((Zp, mi) => {
        var Ju = Te(), Ku = Jr(), Qu = Or();
        mi.exports = Ju ? function(e2, n, i2) {
          return Ku.f(e2, n, Qu(1, i2));
        } : function(e2, n, i2) {
          return e2[n] = i2, e2;
        };
      });
      var Qr = V((eh, gi) => {
        var Yu = de(), Xu = ve(), Kr = ar(), Zu = Yu(Function.toString);
        Xu(Kr.inspectSource) || (Kr.inspectSource = function(e2) {
          return Zu(e2);
        });
        gi.exports = Kr.inspectSource;
      });
      var _i = V((rh, wi) => {
        var ec = ee(), rc = ve(), tc = Qr(), yi = ec.WeakMap;
        wi.exports = rc(yi) && /native code/.test(tc(yi));
      });
      var ki = V((th, xi) => {
        var nc = Dr(), ic = Lr(), bi = nc("keys");
        xi.exports = function(e2) {
          return bi[e2] || (bi[e2] = ic(e2));
        };
      });
      var Yr = V((nh, Si) => {
        Si.exports = {};
      });
      var Pi = V((ih, Ai) => {
        var sc = _i(), qi = ee(), Xr = de(), oc = Me(), ac = cr(), Zr = Se(), et = ar(), uc = ki(), cc = Yr(), Oi = "Object already initialized", tt = qi.TypeError, lc = qi.WeakMap, lr, Fe, fr, fc = function(e2) {
          return fr(e2) ? Fe(e2) : lr(e2, {});
        }, pc = function(e2) {
          return function(n) {
            var i2;
            if (!oc(n) || (i2 = Fe(n)).type !== e2)
              throw tt("Incompatible receiver, " + e2 + " required");
            return i2;
          };
        };
        sc || et.state ? (Oe = et.state || (et.state = new lc()), Ti = Xr(Oe.get), rt = Xr(Oe.has), Ei = Xr(Oe.set), lr = function(e2, n) {
          if (rt(Oe, e2))
            throw new tt(Oi);
          return n.facade = e2, Ei(Oe, e2, n), n;
        }, Fe = function(e2) {
          return Ti(Oe, e2) || {};
        }, fr = function(e2) {
          return rt(Oe, e2);
        }) : (qe = uc("state"), cc[qe] = true, lr = function(e2, n) {
          if (Zr(e2, qe))
            throw new tt(Oi);
          return n.facade = e2, ac(e2, qe, n), n;
        }, Fe = function(e2) {
          return Zr(e2, qe) ? e2[qe] : {};
        }, fr = function(e2) {
          return Zr(e2, qe);
        });
        var Oe, Ti, rt, Ei, qe;
        Ai.exports = { set: lr, get: Fe, has: fr, enforce: fc, getterFor: pc };
      });
      var Ci = V((sh, Ii) => {
        var nt = Te(), hc = Se(), Ri = Function.prototype, dc = nt && Object.getOwnPropertyDescriptor, it = hc(Ri, "name"), vc = it && function() {
        }.name === "something", mc = it && (!nt || nt && dc(Ri, "name").configurable);
        Ii.exports = { EXISTS: it, PROPER: vc, CONFIGURABLE: mc };
      });
      var Li = V((oh, Di) => {
        var gc = ee(), Ni = ve(), yc = Se(), ji = cr(), wc = or(), _c = Qr(), Mi = Pi(), bc = Ci().CONFIGURABLE, xc = Mi.get, kc = Mi.enforce, Sc = String(String).split("String");
        (Di.exports = function(e2, n, i2, a) {
          var o = a ? !!a.unsafe : false, f3 = a ? !!a.enumerable : false, p = a ? !!a.noTargetGet : false, h2 = a && a.name !== void 0 ? a.name : n, g;
          if (Ni(i2) && (String(h2).slice(0, 7) === "Symbol(" && (h2 = "[" + String(h2).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!yc(i2, "name") || bc && i2.name !== h2) && ji(i2, "name", h2), g = kc(i2), g.source || (g.source = Sc.join(typeof h2 == "string" ? h2 : ""))), e2 === gc) {
            f3 ? e2[n] = i2 : wc(n, i2);
            return;
          } else
            o ? !p && e2[n] && (f3 = true) : delete e2[n];
          f3 ? e2[n] = i2 : ji(e2, n, i2);
        })(Function.prototype, "toString", function() {
          return Ni(this) && xc(this).source || _c(this);
        });
      });
      var st = V((ah, zi) => {
        var Oc = Math.ceil, Tc = Math.floor;
        zi.exports = function(e2) {
          var n = +e2;
          return n !== n || n === 0 ? 0 : (n > 0 ? Tc : Oc)(n);
        };
      });
      var Fi = V((uh, Bi) => {
        var Ec = st(), qc = Math.max, Ac = Math.min;
        Bi.exports = function(e2, n) {
          var i2 = Ec(e2);
          return i2 < 0 ? qc(i2 + n, 0) : Ac(i2, n);
        };
      });
      var Wi = V((ch, Ui) => {
        var Pc = st(), Rc = Math.min;
        Ui.exports = function(e2) {
          return e2 > 0 ? Rc(Pc(e2), 9007199254740991) : 0;
        };
      });
      var Vi = V((lh, $i) => {
        var Ic = Wi();
        $i.exports = function(e2) {
          return Ic(e2.length);
        };
      });
      var Ji = V((fh, Hi) => {
        var Cc = nr(), Nc = Fi(), jc = Vi(), Gi = function(e2) {
          return function(n, i2, a) {
            var o = Cc(n), f3 = jc(o), p = Nc(a, f3), h2;
            if (e2 && i2 != i2) {
              for (; f3 > p; )
                if (h2 = o[p++], h2 != h2)
                  return true;
            } else
              for (; f3 > p; p++)
                if ((e2 || p in o) && o[p] === i2)
                  return e2 || p || 0;
            return !e2 && -1;
          };
        };
        Hi.exports = { includes: Gi(true), indexOf: Gi(false) };
      });
      var Yi = V((ph, Qi) => {
        var Mc = de(), ot = Se(), Dc = nr(), Lc = Ji().indexOf, zc = Yr(), Ki = Mc([].push);
        Qi.exports = function(e2, n) {
          var i2 = Dc(e2), a = 0, o = [], f3;
          for (f3 in i2)
            !ot(zc, f3) && ot(i2, f3) && Ki(o, f3);
          for (; n.length > a; )
            ot(i2, f3 = n[a++]) && (~Lc(o, f3) || Ki(o, f3));
          return o;
        };
      });
      var Zi = V((hh, Xi) => {
        Xi.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var rs = V((es) => {
        var Bc = Yi(), Fc = Zi(), Uc = Fc.concat("length", "prototype");
        es.f = Object.getOwnPropertyNames || function(n) {
          return Bc(n, Uc);
        };
      });
      var ns = V((ts) => {
        ts.f = Object.getOwnPropertySymbols;
      });
      var ss = V((mh, is) => {
        var Wc = ir(), $c = de(), Vc = rs(), Gc = ns(), Hc = Wr(), Jc = $c([].concat);
        is.exports = Wc("Reflect", "ownKeys") || function(n) {
          var i2 = Vc.f(Hc(n)), a = Gc.f;
          return a ? Jc(i2, a(n)) : i2;
        };
      });
      var us = V((gh, as) => {
        var os = Se(), Kc = ss(), Qc = Ur(), Yc = Jr();
        as.exports = function(e2, n, i2) {
          for (var a = Kc(n), o = Yc.f, f3 = Qc.f, p = 0; p < a.length; p++) {
            var h2 = a[p];
            !os(e2, h2) && !(i2 && os(i2, h2)) && o(e2, h2, f3(n, h2));
          }
        };
      });
      var ls = V((yh, cs) => {
        var Xc = ke(), Zc = ve(), el = /#|\.prototype\./, Ue = function(e2, n) {
          var i2 = tl[rl(e2)];
          return i2 == il ? true : i2 == nl ? false : Zc(n) ? Xc(n) : !!n;
        }, rl = Ue.normalize = function(e2) {
          return String(e2).replace(el, ".").toLowerCase();
        }, tl = Ue.data = {}, nl = Ue.NATIVE = "N", il = Ue.POLYFILL = "P";
        cs.exports = Ue;
      });
      var ps = V((wh, fs4) => {
        var at = ee(), sl = Ur().f, ol = cr(), al = Li(), ul = or(), cl = us(), ll = ls();
        fs4.exports = function(e2, n) {
          var i2 = e2.target, a = e2.global, o = e2.stat, f3, p, h2, g, c, t2;
          if (a ? p = at : o ? p = at[i2] || ul(i2, {}) : p = (at[i2] || {}).prototype, p)
            for (h2 in n) {
              if (c = n[h2], e2.noTargetGet ? (t2 = sl(p, h2), g = t2 && t2.value) : g = p[h2], f3 = ll(a ? h2 : i2 + (o ? "." : "#") + h2, e2.forced), !f3 && g !== void 0) {
                if (typeof c == typeof g)
                  continue;
                cl(c, g);
              }
              (e2.sham || g && g.sham) && ol(c, "sham", true), al(p, h2, c, e2);
            }
        };
      });
      var hs = V(() => {
        var fl = ps(), pl = ee();
        fl({ global: true }, { globalThis: pl });
      });
      var ds = V(() => {
        hs();
      });
      var lp = V((Ph, la) => {
        ds();
        var kt = Object.defineProperty, hl = Object.getOwnPropertyDescriptor, St = Object.getOwnPropertyNames, dl = Object.prototype.hasOwnProperty, Le = (e2, n) => function() {
          return e2 && (n = (0, e2[St(e2)[0]])(e2 = 0)), n;
        }, R = (e2, n) => function() {
          return n || (0, e2[St(e2)[0]])((n = { exports: {} }).exports, n), n.exports;
        }, Ot = (e2, n) => {
          for (var i2 in n)
            kt(e2, i2, { get: n[i2], enumerable: true });
        }, vl = (e2, n, i2, a) => {
          if (n && typeof n == "object" || typeof n == "function")
            for (let o of St(n))
              !dl.call(e2, o) && o !== i2 && kt(e2, o, { get: () => n[o], enumerable: !(a = hl(n, o)) || a.enumerable });
          return e2;
        }, Tt = (e2) => vl(kt({}, "__esModule", { value: true }), e2), A2 = Le({ "<define:process>"() {
        } }), ml = R({ "src/common/parser-create-error.js"(e2, n) {
          "use strict";
          A2();
          function i2(a, o) {
            let f3 = new SyntaxError(a + " (" + o.start.line + ":" + o.start.column + ")");
            return f3.loc = o, f3;
          }
          n.exports = i2;
        } }), Cs = R({ "src/utils/get-last.js"(e2, n) {
          "use strict";
          A2();
          var i2 = (a) => a[a.length - 1];
          n.exports = i2;
        } }), Ns = R({ "src/utils/front-matter/parse.js"(e2, n) {
          "use strict";
          A2();
          var i2 = new RegExp("^(?<startDelimiter>-{3}|\\+{3})(?<language>[^\\n]*)\\n(?:|(?<value>.*?)\\n)(?<endDelimiter>\\k<startDelimiter>|\\.{3})[^\\S\\n]*(?:\\n|$)", "s");
          function a(o) {
            let f3 = o.match(i2);
            if (!f3)
              return { content: o };
            let { startDelimiter: p, language: h2, value: g = "", endDelimiter: c } = f3.groups, t2 = h2.trim() || "yaml";
            if (p === "+++" && (t2 = "toml"), t2 !== "yaml" && p !== c)
              return { content: o };
            let [r2] = f3;
            return { frontMatter: { type: "front-matter", lang: t2, value: g, startDelimiter: p, endDelimiter: c, raw: r2.replace(/\n$/, "") }, content: r2.replace(/[^\n]/g, " ") + o.slice(r2.length) };
          }
          n.exports = a;
        } }), js = {};
        Ot(js, { EOL: () => gt, arch: () => gl, cpus: () => Us, default: () => Hs, endianness: () => Ms, freemem: () => Bs, getNetworkInterfaces: () => Gs, hostname: () => Ds, loadavg: () => Ls, networkInterfaces: () => Vs, platform: () => yl, release: () => $s, tmpDir: () => vt, tmpdir: () => mt, totalmem: () => Fs, type: () => Ws, uptime: () => zs });
        function Ms() {
          if (typeof pr > "u") {
            var e2 = new ArrayBuffer(2), n = new Uint8Array(e2), i2 = new Uint16Array(e2);
            if (n[0] = 1, n[1] = 2, i2[0] === 258)
              pr = "BE";
            else if (i2[0] === 513)
              pr = "LE";
            else
              throw new Error("unable to figure out endianess");
          }
          return pr;
        }
        function Ds() {
          return typeof globalThis.location < "u" ? globalThis.location.hostname : "";
        }
        function Ls() {
          return [];
        }
        function zs() {
          return 0;
        }
        function Bs() {
          return Number.MAX_VALUE;
        }
        function Fs() {
          return Number.MAX_VALUE;
        }
        function Us() {
          return [];
        }
        function Ws() {
          return "Browser";
        }
        function $s() {
          return typeof globalThis.navigator < "u" ? globalThis.navigator.appVersion : "";
        }
        function Vs() {
        }
        function Gs() {
        }
        function gl() {
          return "javascript";
        }
        function yl() {
          return "browser";
        }
        function vt() {
          return "/tmp";
        }
        var pr, mt, gt, Hs, wl = Le({ "node-modules-polyfills:os"() {
          A2(), mt = vt, gt = `
`, Hs = { EOL: gt, tmpdir: mt, tmpDir: vt, networkInterfaces: Vs, getNetworkInterfaces: Gs, release: $s, type: Ws, cpus: Us, totalmem: Fs, freemem: Bs, uptime: zs, loadavg: Ls, hostname: Ds, endianness: Ms };
        } }), _l = R({ "node-modules-polyfills-commonjs:os"(e2, n) {
          A2();
          var i2 = (wl(), Tt(js));
          if (i2 && i2.default) {
            n.exports = i2.default;
            for (let a in i2)
              n.exports[a] = i2[a];
          } else
            i2 && (n.exports = i2);
        } }), bl = R({ "node_modules/detect-newline/index.js"(e2, n) {
          "use strict";
          A2();
          var i2 = (a) => {
            if (typeof a != "string")
              throw new TypeError("Expected a string");
            let o = a.match(/(?:\r?\n)/g) || [];
            if (o.length === 0)
              return;
            let f3 = o.filter((h2) => h2 === `\r
`).length, p = o.length - f3;
            return f3 > p ? `\r
` : `
`;
          };
          n.exports = i2, n.exports.graceful = (a) => typeof a == "string" && i2(a) || `
`;
        } }), xl = R({ "node_modules/jest-docblock/build/index.js"(e2) {
          "use strict";
          A2(), Object.defineProperty(e2, "__esModule", { value: true }), e2.extract = s2, e2.parse = m2, e2.parseWithComments = v, e2.print = y, e2.strip = l;
          function n() {
            let d = _l();
            return n = function() {
              return d;
            }, d;
          }
          function i2() {
            let d = a(bl());
            return i2 = function() {
              return d;
            }, d;
          }
          function a(d) {
            return d && d.__esModule ? d : { default: d };
          }
          var o = /\*\/$/, f3 = /^\/\*\*/, p = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/, h2 = /(^|\s+)\/\/([^\r\n]*)/g, g = /^(\r?\n)+/, c = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g, t2 = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g, r2 = /(\r?\n|^) *\* ?/g, u = [];
          function s2(d) {
            let _ = d.match(p);
            return _ ? _[0].trimLeft() : "";
          }
          function l(d) {
            let _ = d.match(p);
            return _ && _[0] ? d.substring(_[0].length) : d;
          }
          function m2(d) {
            return v(d).pragmas;
          }
          function v(d) {
            let _ = (0, i2().default)(d) || n().EOL;
            d = d.replace(f3, "").replace(o, "").replace(r2, "$1");
            let S2 = "";
            for (; S2 !== d; )
              S2 = d, d = d.replace(c, "".concat(_, "$1 $2").concat(_));
            d = d.replace(g, "").trimRight();
            let x2 = /* @__PURE__ */ Object.create(null), N = d.replace(t2, "").replace(g, "").trimRight(), P;
            for (; P = t2.exec(d); ) {
              let W = P[2].replace(h2, "");
              typeof x2[P[1]] == "string" || Array.isArray(x2[P[1]]) ? x2[P[1]] = u.concat(x2[P[1]], W) : x2[P[1]] = W;
            }
            return { comments: N, pragmas: x2 };
          }
          function y(d) {
            let { comments: _ = "", pragmas: S2 = {} } = d, x2 = (0, i2().default)(_) || n().EOL, N = "/**", P = " *", W = " */", U = Object.keys(S2), H = U.map(($) => w($, S2[$])).reduce(($, B) => $.concat(B), []).map(($) => P + " " + $ + x2).join("");
            if (!_) {
              if (U.length === 0)
                return "";
              if (U.length === 1 && !Array.isArray(S2[U[0]])) {
                let $ = S2[U[0]];
                return "".concat(N, " ").concat(w(U[0], $)[0]).concat(W);
              }
            }
            let D = _.split(x2).map(($) => "".concat(P, " ").concat($)).join(x2) + x2;
            return N + x2 + (_ ? D : "") + (_ && U.length ? P + x2 : "") + H + W;
          }
          function w(d, _) {
            return u.concat(_).map((S2) => "@".concat(d, " ").concat(S2).trim());
          }
        } }), kl = R({ "src/common/end-of-line.js"(e2, n) {
          "use strict";
          A2();
          function i2(p) {
            let h2 = p.indexOf("\r");
            return h2 >= 0 ? p.charAt(h2 + 1) === `
` ? "crlf" : "cr" : "lf";
          }
          function a(p) {
            switch (p) {
              case "cr":
                return "\r";
              case "crlf":
                return `\r
`;
              default:
                return `
`;
            }
          }
          function o(p, h2) {
            let g;
            switch (h2) {
              case `
`:
                g = /\n/g;
                break;
              case "\r":
                g = /\r/g;
                break;
              case `\r
`:
                g = /\r\n/g;
                break;
              default:
                throw new Error('Unexpected "eol" '.concat(JSON.stringify(h2), "."));
            }
            let c = p.match(g);
            return c ? c.length : 0;
          }
          function f3(p) {
            return p.replace(/\r\n?/g, `
`);
          }
          n.exports = { guessEndOfLine: i2, convertEndOfLineToChars: a, countEndOfLineChars: o, normalizeEndOfLine: f3 };
        } }), Sl = R({ "src/language-js/utils/get-shebang.js"(e2, n) {
          "use strict";
          A2();
          function i2(a) {
            if (!a.startsWith("#!"))
              return "";
            let o = a.indexOf(`
`);
            return o === -1 ? a : a.slice(0, o);
          }
          n.exports = i2;
        } }), Ol = R({ "src/language-js/pragma.js"(e2, n) {
          "use strict";
          A2();
          var { parseWithComments: i2, strip: a, extract: o, print: f3 } = xl(), { normalizeEndOfLine: p } = kl(), h2 = Sl();
          function g(r2) {
            let u = h2(r2);
            u && (r2 = r2.slice(u.length + 1));
            let s2 = o(r2), { pragmas: l, comments: m2 } = i2(s2);
            return { shebang: u, text: r2, pragmas: l, comments: m2 };
          }
          function c(r2) {
            let u = Object.keys(g(r2).pragmas);
            return u.includes("prettier") || u.includes("format");
          }
          function t2(r2) {
            let { shebang: u, text: s2, pragmas: l, comments: m2 } = g(r2), v = a(s2), y = f3({ pragmas: Object.assign({ format: "" }, l), comments: m2.trimStart() });
            return (u ? "".concat(u, `
`) : "") + p(y) + (v.startsWith(`
`) ? `
` : `

`) + v;
          }
          n.exports = { hasPragma: c, insertPragma: t2 };
        } }), Tl = R({ "src/language-css/pragma.js"(e2, n) {
          "use strict";
          A2();
          var i2 = Ol(), a = Ns();
          function o(p) {
            return i2.hasPragma(a(p).content);
          }
          function f3(p) {
            let { frontMatter: h2, content: g } = a(p);
            return (h2 ? h2.raw + `

` : "") + i2.insertPragma(g);
          }
          n.exports = { hasPragma: o, insertPragma: f3 };
        } }), El = R({ "src/utils/text/skip.js"(e2, n) {
          "use strict";
          A2();
          function i2(h2) {
            return (g, c, t2) => {
              let r2 = t2 && t2.backwards;
              if (c === false)
                return false;
              let { length: u } = g, s2 = c;
              for (; s2 >= 0 && s2 < u; ) {
                let l = g.charAt(s2);
                if (h2 instanceof RegExp) {
                  if (!h2.test(l))
                    return s2;
                } else if (!h2.includes(l))
                  return s2;
                r2 ? s2-- : s2++;
              }
              return s2 === -1 || s2 === u ? s2 : false;
            };
          }
          var a = i2(/\s/), o = i2(" 	"), f3 = i2(",; 	"), p = i2(/[^\n\r]/);
          n.exports = { skipWhitespace: a, skipSpaces: o, skipToLineEnd: f3, skipEverythingButNewLine: p };
        } }), ql = R({ "src/utils/line-column-to-index.js"(e2, n) {
          "use strict";
          A2(), n.exports = function(i2, a) {
            let o = 0;
            for (let f3 = 0; f3 < i2.line - 1; ++f3)
              o = a.indexOf(`
`, o) + 1;
            return o + i2.column;
          };
        } }), Js = R({ "src/language-css/loc.js"(e2, n) {
          "use strict";
          A2();
          var { skipEverythingButNewLine: i2 } = El(), a = Cs(), o = ql();
          function f3(s2, l) {
            return typeof s2.sourceIndex == "number" ? s2.sourceIndex : s2.source ? o(s2.source.start, l) - 1 : null;
          }
          function p(s2, l) {
            if (s2.type === "css-comment" && s2.inline)
              return i2(l, s2.source.startOffset);
            let m2 = s2.nodes && a(s2.nodes);
            return m2 && s2.source && !s2.source.end && (s2 = m2), s2.source && s2.source.end ? o(s2.source.end, l) : null;
          }
          function h2(s2, l) {
            s2.source && (s2.source.startOffset = f3(s2, l), s2.source.endOffset = p(s2, l));
            for (let m2 in s2) {
              let v = s2[m2];
              m2 === "source" || !v || typeof v != "object" || (v.type === "value-root" || v.type === "value-unknown" ? g(v, c(s2), v.text || v.value) : h2(v, l));
            }
          }
          function g(s2, l, m2) {
            s2.source && (s2.source.startOffset = f3(s2, m2) + l, s2.source.endOffset = p(s2, m2) + l);
            for (let v in s2) {
              let y = s2[v];
              v === "source" || !y || typeof y != "object" || g(y, l, m2);
            }
          }
          function c(s2) {
            let l = s2.source.startOffset;
            return typeof s2.prop == "string" && (l += s2.prop.length), s2.type === "css-atrule" && typeof s2.name == "string" && (l += 1 + s2.name.length + s2.raws.afterName.match(/^\s*:?\s*/)[0].length), s2.type !== "css-atrule" && s2.raws && typeof s2.raws.between == "string" && (l += s2.raws.between.length), l;
          }
          function t2(s2) {
            let l = "initial", m2 = "initial", v, y = false, w = [];
            for (let d = 0; d < s2.length; d++) {
              let _ = s2[d];
              switch (l) {
                case "initial":
                  if (_ === "'") {
                    l = "single-quotes";
                    continue;
                  }
                  if (_ === '"') {
                    l = "double-quotes";
                    continue;
                  }
                  if ((_ === "u" || _ === "U") && s2.slice(d, d + 4).toLowerCase() === "url(") {
                    l = "url", d += 3;
                    continue;
                  }
                  if (_ === "*" && s2[d - 1] === "/") {
                    l = "comment-block";
                    continue;
                  }
                  if (_ === "/" && s2[d - 1] === "/") {
                    l = "comment-inline", v = d - 1;
                    continue;
                  }
                  continue;
                case "single-quotes":
                  if (_ === "'" && s2[d - 1] !== "\\" && (l = m2, m2 = "initial"), _ === `
` || _ === "\r")
                    return s2;
                  continue;
                case "double-quotes":
                  if (_ === '"' && s2[d - 1] !== "\\" && (l = m2, m2 = "initial"), _ === `
` || _ === "\r")
                    return s2;
                  continue;
                case "url":
                  if (_ === ")" && (l = "initial"), _ === `
` || _ === "\r")
                    return s2;
                  if (_ === "'") {
                    l = "single-quotes", m2 = "url";
                    continue;
                  }
                  if (_ === '"') {
                    l = "double-quotes", m2 = "url";
                    continue;
                  }
                  continue;
                case "comment-block":
                  _ === "/" && s2[d - 1] === "*" && (l = "initial");
                  continue;
                case "comment-inline":
                  (_ === '"' || _ === "'" || _ === "*") && (y = true), (_ === `
` || _ === "\r") && (y && w.push([v, d]), l = "initial", y = false);
                  continue;
              }
            }
            for (let [d, _] of w)
              s2 = s2.slice(0, d) + s2.slice(d, _).replace(/["'*]/g, " ") + s2.slice(_);
            return s2;
          }
          function r2(s2) {
            return s2.source.startOffset;
          }
          function u(s2) {
            return s2.source.endOffset;
          }
          n.exports = { locStart: r2, locEnd: u, calculateLoc: h2, replaceQuotesInInlineComments: t2 };
        } }), Al = R({ "src/utils/is-non-empty-array.js"(e2, n) {
          "use strict";
          A2();
          function i2(a) {
            return Array.isArray(a) && a.length > 0;
          }
          n.exports = i2;
        } }), Pl = R({ "src/language-css/utils/has-scss-interpolation.js"(e2, n) {
          "use strict";
          A2();
          var i2 = Al();
          function a(o) {
            if (i2(o)) {
              for (let f3 = o.length - 1; f3 > 0; f3--)
                if (o[f3].type === "word" && o[f3].value === "{" && o[f3 - 1].type === "word" && o[f3 - 1].value.endsWith("#"))
                  return true;
            }
            return false;
          }
          n.exports = a;
        } }), Rl = R({ "src/language-css/utils/has-string-or-function.js"(e2, n) {
          "use strict";
          A2();
          function i2(a) {
            return a.some((o) => o.type === "string" || o.type === "func");
          }
          n.exports = i2;
        } }), Il = R({ "src/language-css/utils/is-less-parser.js"(e2, n) {
          "use strict";
          A2();
          function i2(a) {
            return a.parser === "css" || a.parser === "less";
          }
          n.exports = i2;
        } }), Cl = R({ "src/language-css/utils/is-scss.js"(e2, n) {
          "use strict";
          A2();
          function i2(a, o) {
            return a === "less" || a === "scss" ? a === "scss" : /(?:\w\s*:\s*[^:}]+|#){|@import[^\n]+(?:url|,)/.test(o);
          }
          n.exports = i2;
        } }), Nl = R({ "src/language-css/utils/is-scss-nested-property-node.js"(e2, n) {
          "use strict";
          A2();
          function i2(a) {
            return a.selector ? a.selector.replace(/\/\*.*?\*\//, "").replace(/\/\/.*\n/, "").trim().endsWith(":") : false;
          }
          n.exports = i2;
        } }), jl = R({ "src/language-css/utils/is-scss-variable.js"(e2, n) {
          "use strict";
          A2();
          function i2(a) {
            return Boolean((a == null ? void 0 : a.type) === "word" && a.value.startsWith("$"));
          }
          n.exports = i2;
        } }), Ml = R({ "src/language-css/utils/stringify-node.js"(e2, n) {
          "use strict";
          A2();
          function i2(a) {
            var o, f3, p;
            if (a.groups) {
              var h2, g, c;
              let y = ((h2 = a.open) === null || h2 === void 0 ? void 0 : h2.value) || "", w = a.groups.map((_) => i2(_)).join(((g = a.groups[0]) === null || g === void 0 ? void 0 : g.type) === "comma_group" ? "," : ""), d = ((c = a.close) === null || c === void 0 ? void 0 : c.value) || "";
              return y + w + d;
            }
            let t2 = ((o = a.raws) === null || o === void 0 ? void 0 : o.before) || "", r2 = ((f3 = a.raws) === null || f3 === void 0 ? void 0 : f3.quote) || "", u = a.type === "atword" ? "@" : "", s2 = a.value || "", l = a.unit || "", m2 = a.group ? i2(a.group) : "", v = ((p = a.raws) === null || p === void 0 ? void 0 : p.after) || "";
            return t2 + r2 + u + s2 + r2 + l + m2 + v;
          }
          n.exports = i2;
        } }), Dl = R({ "src/language-css/utils/is-module-rule-name.js"(e2, n) {
          "use strict";
          A2();
          var i2 = /* @__PURE__ */ new Set(["import", "use", "forward"]);
          function a(o) {
            return i2.has(o);
          }
          n.exports = a;
        } }), we = R({ "node_modules/postcss-values-parser/lib/node.js"(e2, n) {
          "use strict";
          A2();
          var i2 = function(a, o) {
            let f3 = new a.constructor();
            for (let p in a) {
              if (!a.hasOwnProperty(p))
                continue;
              let h2 = a[p], g = typeof h2;
              p === "parent" && g === "object" ? o && (f3[p] = o) : p === "source" ? f3[p] = h2 : h2 instanceof Array ? f3[p] = h2.map((c) => i2(c, f3)) : p !== "before" && p !== "after" && p !== "between" && p !== "semicolon" && (g === "object" && h2 !== null && (h2 = i2(h2)), f3[p] = h2);
            }
            return f3;
          };
          n.exports = class {
            constructor(o) {
              o = o || {}, this.raws = { before: "", after: "" };
              for (let f3 in o)
                this[f3] = o[f3];
            }
            remove() {
              return this.parent && this.parent.removeChild(this), this.parent = void 0, this;
            }
            toString() {
              return [this.raws.before, String(this.value), this.raws.after].join("");
            }
            clone(o) {
              o = o || {};
              let f3 = i2(this);
              for (let p in o)
                f3[p] = o[p];
              return f3;
            }
            cloneBefore(o) {
              o = o || {};
              let f3 = this.clone(o);
              return this.parent.insertBefore(this, f3), f3;
            }
            cloneAfter(o) {
              o = o || {};
              let f3 = this.clone(o);
              return this.parent.insertAfter(this, f3), f3;
            }
            replaceWith() {
              let o = Array.prototype.slice.call(arguments);
              if (this.parent) {
                for (let f3 of o)
                  this.parent.insertBefore(this, f3);
                this.remove();
              }
              return this;
            }
            moveTo(o) {
              return this.cleanRaws(this.root() === o.root()), this.remove(), o.append(this), this;
            }
            moveBefore(o) {
              return this.cleanRaws(this.root() === o.root()), this.remove(), o.parent.insertBefore(o, this), this;
            }
            moveAfter(o) {
              return this.cleanRaws(this.root() === o.root()), this.remove(), o.parent.insertAfter(o, this), this;
            }
            next() {
              let o = this.parent.index(this);
              return this.parent.nodes[o + 1];
            }
            prev() {
              let o = this.parent.index(this);
              return this.parent.nodes[o - 1];
            }
            toJSON() {
              let o = {};
              for (let f3 in this) {
                if (!this.hasOwnProperty(f3) || f3 === "parent")
                  continue;
                let p = this[f3];
                p instanceof Array ? o[f3] = p.map((h2) => typeof h2 == "object" && h2.toJSON ? h2.toJSON() : h2) : typeof p == "object" && p.toJSON ? o[f3] = p.toJSON() : o[f3] = p;
              }
              return o;
            }
            root() {
              let o = this;
              for (; o.parent; )
                o = o.parent;
              return o;
            }
            cleanRaws(o) {
              delete this.raws.before, delete this.raws.after, o || delete this.raws.between;
            }
            positionInside(o) {
              let f3 = this.toString(), p = this.source.start.column, h2 = this.source.start.line;
              for (let g = 0; g < o; g++)
                f3[g] === `
` ? (p = 1, h2 += 1) : p += 1;
              return { line: h2, column: p };
            }
            positionBy(o) {
              let f3 = this.source.start;
              if (Object(o).index)
                f3 = this.positionInside(o.index);
              else if (Object(o).word) {
                let p = this.toString().indexOf(o.word);
                p !== -1 && (f3 = this.positionInside(p));
              }
              return f3;
            }
          };
        } }), ue = R({ "node_modules/postcss-values-parser/lib/container.js"(e2, n) {
          "use strict";
          A2();
          var i2 = we(), a = class extends i2 {
            constructor(o) {
              super(o), this.nodes || (this.nodes = []);
            }
            push(o) {
              return o.parent = this, this.nodes.push(o), this;
            }
            each(o) {
              this.lastEach || (this.lastEach = 0), this.indexes || (this.indexes = {}), this.lastEach += 1;
              let f3 = this.lastEach, p, h2;
              if (this.indexes[f3] = 0, !!this.nodes) {
                for (; this.indexes[f3] < this.nodes.length && (p = this.indexes[f3], h2 = o(this.nodes[p], p), h2 !== false); )
                  this.indexes[f3] += 1;
                return delete this.indexes[f3], h2;
              }
            }
            walk(o) {
              return this.each((f3, p) => {
                let h2 = o(f3, p);
                return h2 !== false && f3.walk && (h2 = f3.walk(o)), h2;
              });
            }
            walkType(o, f3) {
              if (!o || !f3)
                throw new Error("Parameters {type} and {callback} are required.");
              let p = typeof o == "function";
              return this.walk((h2, g) => {
                if (p && h2 instanceof o || !p && h2.type === o)
                  return f3.call(this, h2, g);
              });
            }
            append(o) {
              return o.parent = this, this.nodes.push(o), this;
            }
            prepend(o) {
              return o.parent = this, this.nodes.unshift(o), this;
            }
            cleanRaws(o) {
              if (super.cleanRaws(o), this.nodes)
                for (let f3 of this.nodes)
                  f3.cleanRaws(o);
            }
            insertAfter(o, f3) {
              let p = this.index(o), h2;
              this.nodes.splice(p + 1, 0, f3);
              for (let g in this.indexes)
                h2 = this.indexes[g], p <= h2 && (this.indexes[g] = h2 + this.nodes.length);
              return this;
            }
            insertBefore(o, f3) {
              let p = this.index(o), h2;
              this.nodes.splice(p, 0, f3);
              for (let g in this.indexes)
                h2 = this.indexes[g], p <= h2 && (this.indexes[g] = h2 + this.nodes.length);
              return this;
            }
            removeChild(o) {
              o = this.index(o), this.nodes[o].parent = void 0, this.nodes.splice(o, 1);
              let f3;
              for (let p in this.indexes)
                f3 = this.indexes[p], f3 >= o && (this.indexes[p] = f3 - 1);
              return this;
            }
            removeAll() {
              for (let o of this.nodes)
                o.parent = void 0;
              return this.nodes = [], this;
            }
            every(o) {
              return this.nodes.every(o);
            }
            some(o) {
              return this.nodes.some(o);
            }
            index(o) {
              return typeof o == "number" ? o : this.nodes.indexOf(o);
            }
            get first() {
              if (!!this.nodes)
                return this.nodes[0];
            }
            get last() {
              if (!!this.nodes)
                return this.nodes[this.nodes.length - 1];
            }
            toString() {
              let o = this.nodes.map(String).join("");
              return this.value && (o = this.value + o), this.raws.before && (o = this.raws.before + o), this.raws.after && (o += this.raws.after), o;
            }
          };
          a.registerWalker = (o) => {
            let f3 = "walk" + o.name;
            f3.lastIndexOf("s") !== f3.length - 1 && (f3 += "s"), !a.prototype[f3] && (a.prototype[f3] = function(p) {
              return this.walkType(o, p);
            });
          }, n.exports = a;
        } }), Ll = R({ "node_modules/postcss-values-parser/lib/root.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue();
          n.exports = class extends i2 {
            constructor(o) {
              super(o), this.type = "root";
            }
          };
        } }), Ks = R({ "node_modules/postcss-values-parser/lib/value.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue();
          n.exports = class extends i2 {
            constructor(o) {
              super(o), this.type = "value", this.unbalanced = 0;
            }
          };
        } }), Qs = R({ "node_modules/postcss-values-parser/lib/atword.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = class extends i2 {
            constructor(o) {
              super(o), this.type = "atword";
            }
            toString() {
              let o = this.quoted ? this.raws.quote : "";
              return [this.raws.before, "@", String.prototype.toString.call(this.value), this.raws.after].join("");
            }
          };
          i2.registerWalker(a), n.exports = a;
        } }), Ys = R({ "node_modules/postcss-values-parser/lib/colon.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "colon";
            }
          };
          i2.registerWalker(o), n.exports = o;
        } }), Xs = R({ "node_modules/postcss-values-parser/lib/comma.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "comma";
            }
          };
          i2.registerWalker(o), n.exports = o;
        } }), Zs = R({ "node_modules/postcss-values-parser/lib/comment.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "comment", this.inline = Object(f3).inline || false;
            }
            toString() {
              return [this.raws.before, this.inline ? "//" : "/*", String(this.value), this.inline ? "" : "*/", this.raws.after].join("");
            }
          };
          i2.registerWalker(o), n.exports = o;
        } }), eo = R({ "node_modules/postcss-values-parser/lib/function.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = class extends i2 {
            constructor(o) {
              super(o), this.type = "func", this.unbalanced = -1;
            }
          };
          i2.registerWalker(a), n.exports = a;
        } }), ro = R({ "node_modules/postcss-values-parser/lib/number.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "number", this.unit = Object(f3).unit || "";
            }
            toString() {
              return [this.raws.before, String(this.value), this.unit, this.raws.after].join("");
            }
          };
          i2.registerWalker(o), n.exports = o;
        } }), to = R({ "node_modules/postcss-values-parser/lib/operator.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "operator";
            }
          };
          i2.registerWalker(o), n.exports = o;
        } }), no = R({ "node_modules/postcss-values-parser/lib/paren.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "paren", this.parenType = "";
            }
          };
          i2.registerWalker(o), n.exports = o;
        } }), io = R({ "node_modules/postcss-values-parser/lib/string.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "string";
            }
            toString() {
              let f3 = this.quoted ? this.raws.quote : "";
              return [this.raws.before, f3, this.value + "", f3, this.raws.after].join("");
            }
          };
          i2.registerWalker(o), n.exports = o;
        } }), so = R({ "node_modules/postcss-values-parser/lib/word.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "word";
            }
          };
          i2.registerWalker(o), n.exports = o;
        } }), oo = R({ "node_modules/postcss-values-parser/lib/unicode-range.js"(e2, n) {
          "use strict";
          A2();
          var i2 = ue(), a = we(), o = class extends a {
            constructor(f3) {
              super(f3), this.type = "unicode-range";
            }
          };
          i2.registerWalker(o), n.exports = o;
        } });
        function ao() {
          throw new Error("setTimeout has not been defined");
        }
        function uo() {
          throw new Error("clearTimeout has not been defined");
        }
        function co(e2) {
          if (be === setTimeout)
            return setTimeout(e2, 0);
          if ((be === ao || !be) && setTimeout)
            return be = setTimeout, setTimeout(e2, 0);
          try {
            return be(e2, 0);
          } catch {
            try {
              return be.call(null, e2, 0);
            } catch {
              return be.call(this, e2, 0);
            }
          }
        }
        function zl(e2) {
          if (xe === clearTimeout)
            return clearTimeout(e2);
          if ((xe === uo || !xe) && clearTimeout)
            return xe = clearTimeout, clearTimeout(e2);
          try {
            return xe(e2);
          } catch {
            try {
              return xe.call(null, e2);
            } catch {
              return xe.call(this, e2);
            }
          }
        }
        function Bl() {
          !Ne || !Ce || (Ne = false, Ce.length ? me = Ce.concat(me) : $e = -1, me.length && lo());
        }
        function lo() {
          if (!Ne) {
            var e2 = co(Bl);
            Ne = true;
            for (var n = me.length; n; ) {
              for (Ce = me, me = []; ++$e < n; )
                Ce && Ce[$e].run();
              $e = -1, n = me.length;
            }
            Ce = null, Ne = false, zl(e2);
          }
        }
        function Fl(e2) {
          var n = new Array(arguments.length - 1);
          if (arguments.length > 1)
            for (var i2 = 1; i2 < arguments.length; i2++)
              n[i2 - 1] = arguments[i2];
          me.push(new fo(e2, n)), me.length === 1 && !Ne && co(lo);
        }
        function fo(e2, n) {
          this.fun = e2, this.array = n;
        }
        function Ae() {
        }
        function Ul(e2) {
          throw new Error("process.binding is not supported");
        }
        function Wl() {
          return "/";
        }
        function $l(e2) {
          throw new Error("process.chdir is not supported");
        }
        function Vl() {
          return 0;
        }
        function Gl(e2) {
          var n = po.call(Re) * 1e-3, i2 = Math.floor(n), a = Math.floor(n % 1 * 1e9);
          return e2 && (i2 = i2 - e2[0], a = a - e2[1], a < 0 && (i2--, a += 1e9)), [i2, a];
        }
        function Hl() {
          var e2 = new Date(), n = e2 - ho;
          return n / 1e3;
        }
        var be, xe, me, Ne, Ce, $e, vs, ms, gs, ys, ws, _s, bs, xs, ks, Ss, Os, Ts, Es, qs, As, Ps, Re, po, ho, Rs, Ve, Jl = Le({ "node-modules-polyfills:process"() {
          A2(), be = ao, xe = uo, typeof globalThis.setTimeout == "function" && (be = setTimeout), typeof globalThis.clearTimeout == "function" && (xe = clearTimeout), me = [], Ne = false, $e = -1, fo.prototype.run = function() {
            this.fun.apply(null, this.array);
          }, vs = "browser", ms = "browser", gs = true, ys = {}, ws = [], _s = "", bs = {}, xs = {}, ks = {}, Ss = Ae, Os = Ae, Ts = Ae, Es = Ae, qs = Ae, As = Ae, Ps = Ae, Re = globalThis.performance || {}, po = Re.now || Re.mozNow || Re.msNow || Re.oNow || Re.webkitNow || function() {
            return new Date().getTime();
          }, ho = new Date(), Rs = { nextTick: Fl, title: vs, browser: gs, env: ys, argv: ws, version: _s, versions: bs, on: Ss, addListener: Os, once: Ts, off: Es, removeListener: qs, removeAllListeners: As, emit: Ps, binding: Ul, cwd: Wl, chdir: $l, umask: Vl, hrtime: Gl, platform: ms, release: xs, config: ks, uptime: Hl }, Ve = Rs;
        } }), ut, Et, Kl = Le({ "node_modules/rollup-plugin-node-polyfills/polyfills/inherits.js"() {
          A2(), typeof Object.create == "function" ? ut = function(n, i2) {
            n.super_ = i2, n.prototype = Object.create(i2.prototype, { constructor: { value: n, enumerable: false, writable: true, configurable: true } });
          } : ut = function(n, i2) {
            n.super_ = i2;
            var a = function() {
            };
            a.prototype = i2.prototype, n.prototype = new a(), n.prototype.constructor = n;
          }, Et = ut;
        } }), vo = {};
        Ot(vo, { _extend: () => It, debuglog: () => mo, default: () => Oo, deprecate: () => qt, format: () => gr, inherits: () => Et, inspect: () => ye, isArray: () => At, isBoolean: () => yr, isBuffer: () => _o, isDate: () => vr, isError: () => He, isFunction: () => Je, isNull: () => Ke, isNullOrUndefined: () => go, isNumber: () => Pt, isObject: () => je, isPrimitive: () => wo, isRegExp: () => Ge, isString: () => Qe, isSymbol: () => yo, isUndefined: () => ge, log: () => bo });
        function gr(e2) {
          if (!Qe(e2)) {
            for (var n = [], i2 = 0; i2 < arguments.length; i2++)
              n.push(ye(arguments[i2]));
            return n.join(" ");
          }
          for (var i2 = 1, a = arguments, o = a.length, f3 = String(e2).replace(ko, function(h2) {
            if (h2 === "%%")
              return "%";
            if (i2 >= o)
              return h2;
            switch (h2) {
              case "%s":
                return String(a[i2++]);
              case "%d":
                return Number(a[i2++]);
              case "%j":
                try {
                  return JSON.stringify(a[i2++]);
                } catch {
                  return "[Circular]";
                }
              default:
                return h2;
            }
          }), p = a[i2]; i2 < o; p = a[++i2])
            Ke(p) || !je(p) ? f3 += " " + p : f3 += " " + ye(p);
          return f3;
        }
        function qt(e2, n) {
          if (ge(globalThis.process))
            return function() {
              return qt(e2, n).apply(this, arguments);
            };
          if (Ve.noDeprecation === true)
            return e2;
          var i2 = false;
          function a() {
            if (!i2) {
              if (Ve.throwDeprecation)
                throw new Error(n);
              Ve.traceDeprecation ? console.trace(n) : console.error(n), i2 = true;
            }
            return e2.apply(this, arguments);
          }
          return a;
        }
        function mo(e2) {
          if (ge(ft) && (ft = Ve.env.NODE_DEBUG || ""), e2 = e2.toUpperCase(), !We[e2])
            if (new RegExp("\\b" + e2 + "\\b", "i").test(ft)) {
              var n = 0;
              We[e2] = function() {
                var i2 = gr.apply(null, arguments);
                console.error("%s %d: %s", e2, n, i2);
              };
            } else
              We[e2] = function() {
              };
          return We[e2];
        }
        function ye(e2, n) {
          var i2 = { seen: [], stylize: Yl };
          return arguments.length >= 3 && (i2.depth = arguments[2]), arguments.length >= 4 && (i2.colors = arguments[3]), yr(n) ? i2.showHidden = n : n && It(i2, n), ge(i2.showHidden) && (i2.showHidden = false), ge(i2.depth) && (i2.depth = 2), ge(i2.colors) && (i2.colors = false), ge(i2.customInspect) && (i2.customInspect = true), i2.colors && (i2.stylize = Ql), dr(i2, e2, i2.depth);
        }
        function Ql(e2, n) {
          var i2 = ye.styles[n];
          return i2 ? "\x1B[" + ye.colors[i2][0] + "m" + e2 + "\x1B[" + ye.colors[i2][1] + "m" : e2;
        }
        function Yl(e2, n) {
          return e2;
        }
        function Xl(e2) {
          var n = {};
          return e2.forEach(function(i2, a) {
            n[i2] = true;
          }), n;
        }
        function dr(e2, n, i2) {
          if (e2.customInspect && n && Je(n.inspect) && n.inspect !== ye && !(n.constructor && n.constructor.prototype === n)) {
            var a = n.inspect(i2, e2);
            return Qe(a) || (a = dr(e2, a, i2)), a;
          }
          var o = Zl(e2, n);
          if (o)
            return o;
          var f3 = Object.keys(n), p = Xl(f3);
          if (e2.showHidden && (f3 = Object.getOwnPropertyNames(n)), He(n) && (f3.indexOf("message") >= 0 || f3.indexOf("description") >= 0))
            return ct(n);
          if (f3.length === 0) {
            if (Je(n)) {
              var h2 = n.name ? ": " + n.name : "";
              return e2.stylize("[Function" + h2 + "]", "special");
            }
            if (Ge(n))
              return e2.stylize(RegExp.prototype.toString.call(n), "regexp");
            if (vr(n))
              return e2.stylize(Date.prototype.toString.call(n), "date");
            if (He(n))
              return ct(n);
          }
          var g = "", c = false, t2 = ["{", "}"];
          if (At(n) && (c = true, t2 = ["[", "]"]), Je(n)) {
            var r2 = n.name ? ": " + n.name : "";
            g = " [Function" + r2 + "]";
          }
          if (Ge(n) && (g = " " + RegExp.prototype.toString.call(n)), vr(n) && (g = " " + Date.prototype.toUTCString.call(n)), He(n) && (g = " " + ct(n)), f3.length === 0 && (!c || n.length == 0))
            return t2[0] + g + t2[1];
          if (i2 < 0)
            return Ge(n) ? e2.stylize(RegExp.prototype.toString.call(n), "regexp") : e2.stylize("[Object]", "special");
          e2.seen.push(n);
          var u;
          return c ? u = ef(e2, n, i2, p, f3) : u = f3.map(function(s2) {
            return yt(e2, n, i2, p, s2, c);
          }), e2.seen.pop(), rf(u, g, t2);
        }
        function Zl(e2, n) {
          if (ge(n))
            return e2.stylize("undefined", "undefined");
          if (Qe(n)) {
            var i2 = "'" + JSON.stringify(n).replace(/^"|"$/g, "").replace(/'/g, "\\'").replace(/\\"/g, '"') + "'";
            return e2.stylize(i2, "string");
          }
          if (Pt(n))
            return e2.stylize("" + n, "number");
          if (yr(n))
            return e2.stylize("" + n, "boolean");
          if (Ke(n))
            return e2.stylize("null", "null");
        }
        function ct(e2) {
          return "[" + Error.prototype.toString.call(e2) + "]";
        }
        function ef(e2, n, i2, a, o) {
          for (var f3 = [], p = 0, h2 = n.length; p < h2; ++p)
            xo(n, String(p)) ? f3.push(yt(e2, n, i2, a, String(p), true)) : f3.push("");
          return o.forEach(function(g) {
            g.match(/^\d+$/) || f3.push(yt(e2, n, i2, a, g, true));
          }), f3;
        }
        function yt(e2, n, i2, a, o, f3) {
          var p, h2, g;
          if (g = Object.getOwnPropertyDescriptor(n, o) || { value: n[o] }, g.get ? g.set ? h2 = e2.stylize("[Getter/Setter]", "special") : h2 = e2.stylize("[Getter]", "special") : g.set && (h2 = e2.stylize("[Setter]", "special")), xo(a, o) || (p = "[" + o + "]"), h2 || (e2.seen.indexOf(g.value) < 0 ? (Ke(i2) ? h2 = dr(e2, g.value, null) : h2 = dr(e2, g.value, i2 - 1), h2.indexOf(`
`) > -1 && (f3 ? h2 = h2.split(`
`).map(function(c) {
            return "  " + c;
          }).join(`
`).substr(2) : h2 = `
` + h2.split(`
`).map(function(c) {
            return "   " + c;
          }).join(`
`))) : h2 = e2.stylize("[Circular]", "special")), ge(p)) {
            if (f3 && o.match(/^\d+$/))
              return h2;
            p = JSON.stringify("" + o), p.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/) ? (p = p.substr(1, p.length - 2), p = e2.stylize(p, "name")) : (p = p.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'"), p = e2.stylize(p, "string"));
          }
          return p + ": " + h2;
        }
        function rf(e2, n, i2) {
          var a = 0, o = e2.reduce(function(f3, p) {
            return a++, p.indexOf(`
`) >= 0 && a++, f3 + p.replace(/\u001b\[\d\d?m/g, "").length + 1;
          }, 0);
          return o > 60 ? i2[0] + (n === "" ? "" : n + `
 `) + " " + e2.join(`,
  `) + " " + i2[1] : i2[0] + n + " " + e2.join(", ") + " " + i2[1];
        }
        function At(e2) {
          return Array.isArray(e2);
        }
        function yr(e2) {
          return typeof e2 == "boolean";
        }
        function Ke(e2) {
          return e2 === null;
        }
        function go(e2) {
          return e2 == null;
        }
        function Pt(e2) {
          return typeof e2 == "number";
        }
        function Qe(e2) {
          return typeof e2 == "string";
        }
        function yo(e2) {
          return typeof e2 == "symbol";
        }
        function ge(e2) {
          return e2 === void 0;
        }
        function Ge(e2) {
          return je(e2) && Rt(e2) === "[object RegExp]";
        }
        function je(e2) {
          return typeof e2 == "object" && e2 !== null;
        }
        function vr(e2) {
          return je(e2) && Rt(e2) === "[object Date]";
        }
        function He(e2) {
          return je(e2) && (Rt(e2) === "[object Error]" || e2 instanceof Error);
        }
        function Je(e2) {
          return typeof e2 == "function";
        }
        function wo(e2) {
          return e2 === null || typeof e2 == "boolean" || typeof e2 == "number" || typeof e2 == "string" || typeof e2 == "symbol" || typeof e2 > "u";
        }
        function _o(e2) {
          return Buffer.isBuffer(e2);
        }
        function Rt(e2) {
          return Object.prototype.toString.call(e2);
        }
        function lt(e2) {
          return e2 < 10 ? "0" + e2.toString(10) : e2.toString(10);
        }
        function tf() {
          var e2 = new Date(), n = [lt(e2.getHours()), lt(e2.getMinutes()), lt(e2.getSeconds())].join(":");
          return [e2.getDate(), So[e2.getMonth()], n].join(" ");
        }
        function bo() {
          console.log("%s - %s", tf(), gr.apply(null, arguments));
        }
        function It(e2, n) {
          if (!n || !je(n))
            return e2;
          for (var i2 = Object.keys(n), a = i2.length; a--; )
            e2[i2[a]] = n[i2[a]];
          return e2;
        }
        function xo(e2, n) {
          return Object.prototype.hasOwnProperty.call(e2, n);
        }
        var ko, We, ft, So, Oo, nf = Le({ "node-modules-polyfills:util"() {
          A2(), Jl(), Kl(), ko = /%[sdj%]/g, We = {}, ye.colors = { bold: [1, 22], italic: [3, 23], underline: [4, 24], inverse: [7, 27], white: [37, 39], grey: [90, 39], black: [30, 39], blue: [34, 39], cyan: [36, 39], green: [32, 39], magenta: [35, 39], red: [31, 39], yellow: [33, 39] }, ye.styles = { special: "cyan", number: "yellow", boolean: "yellow", undefined: "grey", null: "bold", string: "green", date: "magenta", regexp: "red" }, So = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"], Oo = { inherits: Et, _extend: It, log: bo, isBuffer: _o, isPrimitive: wo, isFunction: Je, isError: He, isDate: vr, isObject: je, isRegExp: Ge, isUndefined: ge, isSymbol: yo, isString: Qe, isNumber: Pt, isNullOrUndefined: go, isNull: Ke, isBoolean: yr, isArray: At, inspect: ye, deprecate: qt, format: gr, debuglog: mo };
        } }), sf = R({ "node-modules-polyfills-commonjs:util"(e2, n) {
          A2();
          var i2 = (nf(), Tt(vo));
          if (i2 && i2.default) {
            n.exports = i2.default;
            for (let a in i2)
              n.exports[a] = i2[a];
          } else
            i2 && (n.exports = i2);
        } }), of = R({ "node_modules/postcss-values-parser/lib/errors/TokenizeError.js"(e2, n) {
          "use strict";
          A2();
          var i2 = class extends Error {
            constructor(a) {
              super(a), this.name = this.constructor.name, this.message = a || "An error ocurred while tokzenizing.", typeof Error.captureStackTrace == "function" ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error(a).stack;
            }
          };
          n.exports = i2;
        } }), af = R({ "node_modules/postcss-values-parser/lib/tokenize.js"(e2, n) {
          "use strict";
          A2();
          var i2 = "{".charCodeAt(0), a = "}".charCodeAt(0), o = "(".charCodeAt(0), f3 = ")".charCodeAt(0), p = "'".charCodeAt(0), h2 = '"'.charCodeAt(0), g = "\\".charCodeAt(0), c = "/".charCodeAt(0), t2 = ".".charCodeAt(0), r2 = ",".charCodeAt(0), u = ":".charCodeAt(0), s2 = "*".charCodeAt(0), l = "-".charCodeAt(0), m2 = "+".charCodeAt(0), v = "#".charCodeAt(0), y = `
`.charCodeAt(0), w = " ".charCodeAt(0), d = "\f".charCodeAt(0), _ = "	".charCodeAt(0), S2 = "\r".charCodeAt(0), x2 = "@".charCodeAt(0), N = "e".charCodeAt(0), P = "E".charCodeAt(0), W = "0".charCodeAt(0), U = "9".charCodeAt(0), H = "u".charCodeAt(0), D = "U".charCodeAt(0), $ = /[ \n\t\r\{\(\)'"\\;,/]/g, B = /[ \n\t\r\(\)\{\}\*:;@!&'"\+\|~>,\[\]\\]|\/(?=\*)/g, O = /[ \n\t\r\(\)\{\}\*:;@!&'"\-\+\|~>,\[\]\\]|\//g, j = /^[a-z0-9]/i, C = /^[a-f0-9?\-]/i, I = sf(), X = of();
          n.exports = function(Q, K) {
            K = K || {};
            let J = [], M = Q.valueOf(), Y = M.length, G = -1, E = 1, k = 0, b = 0, L = null, q, T, F2, z, re, ne, ce, fe, te, ie, ae, se;
            function le(Ze) {
              let _e = I.format("Unclosed %s at line: %d, column: %d, token: %d", Ze, E, k - G, k);
              throw new X(_e);
            }
            function pe() {
              let Ze = I.format("Syntax error at line: %d, column: %d, token: %d", E, k - G, k);
              throw new X(Ze);
            }
            for (; k < Y; ) {
              switch (q = M.charCodeAt(k), q === y && (G = k, E += 1), q) {
                case y:
                case w:
                case _:
                case S2:
                case d:
                  T = k;
                  do
                    T += 1, q = M.charCodeAt(T), q === y && (G = T, E += 1);
                  while (q === w || q === y || q === _ || q === S2 || q === d);
                  J.push(["space", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  break;
                case u:
                  T = k + 1, J.push(["colon", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  break;
                case r2:
                  T = k + 1, J.push(["comma", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  break;
                case i2:
                  J.push(["{", "{", E, k - G, E, T - G, k]);
                  break;
                case a:
                  J.push(["}", "}", E, k - G, E, T - G, k]);
                  break;
                case o:
                  b++, L = !L && b === 1 && J.length > 0 && J[J.length - 1][0] === "word" && J[J.length - 1][1] === "url", J.push(["(", "(", E, k - G, E, T - G, k]);
                  break;
                case f3:
                  b--, L = L && b > 0, J.push([")", ")", E, k - G, E, T - G, k]);
                  break;
                case p:
                case h2:
                  F2 = q === p ? "'" : '"', T = k;
                  do
                    for (ie = false, T = M.indexOf(F2, T + 1), T === -1 && le("quote", F2), ae = T; M.charCodeAt(ae - 1) === g; )
                      ae -= 1, ie = !ie;
                  while (ie);
                  J.push(["string", M.slice(k, T + 1), E, k - G, E, T - G, k]), k = T;
                  break;
                case x2:
                  $.lastIndex = k + 1, $.test(M), $.lastIndex === 0 ? T = M.length - 1 : T = $.lastIndex - 2, J.push(["atword", M.slice(k, T + 1), E, k - G, E, T - G, k]), k = T;
                  break;
                case g:
                  T = k, q = M.charCodeAt(T + 1), ce && q !== c && q !== w && q !== y && q !== _ && q !== S2 && q !== d && (T += 1), J.push(["word", M.slice(k, T + 1), E, k - G, E, T - G, k]), k = T;
                  break;
                case m2:
                case l:
                case s2:
                  T = k + 1, se = M.slice(k + 1, T + 1);
                  let Ze = M.slice(k - 1, k);
                  if (q === l && se.charCodeAt(0) === l) {
                    T++, J.push(["word", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                    break;
                  }
                  J.push(["operator", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  break;
                default:
                  if (q === c && (M.charCodeAt(k + 1) === s2 || K.loose && !L && M.charCodeAt(k + 1) === c)) {
                    if (M.charCodeAt(k + 1) === s2)
                      T = M.indexOf("*/", k + 2) + 1, T === 0 && le("comment", "*/");
                    else {
                      let Be = M.indexOf(`
`, k + 2);
                      T = Be !== -1 ? Be - 1 : Y;
                    }
                    ne = M.slice(k, T + 1), z = ne.split(`
`), re = z.length - 1, re > 0 ? (fe = E + re, te = T - z[re].length) : (fe = E, te = G), J.push(["comment", ne, E, k - G, fe, T - te, k]), G = te, E = fe, k = T;
                  } else if (q === v && !j.test(M.slice(k + 1, k + 2)))
                    T = k + 1, J.push(["#", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  else if ((q === H || q === D) && M.charCodeAt(k + 1) === m2) {
                    T = k + 2;
                    do
                      T += 1, q = M.charCodeAt(T);
                    while (T < Y && C.test(M.slice(T, T + 1)));
                    J.push(["unicoderange", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  } else if (q === c)
                    T = k + 1, J.push(["operator", M.slice(k, T), E, k - G, E, T - G, k]), k = T - 1;
                  else {
                    let _e = B;
                    if (q >= W && q <= U && (_e = O), _e.lastIndex = k + 1, _e.test(M), _e.lastIndex === 0 ? T = M.length - 1 : T = _e.lastIndex - 2, _e === O || q === t2) {
                      let Be = M.charCodeAt(T), Bt = M.charCodeAt(T + 1), Ft = M.charCodeAt(T + 2);
                      (Be === N || Be === P) && (Bt === l || Bt === m2) && Ft >= W && Ft <= U && (O.lastIndex = T + 2, O.test(M), O.lastIndex === 0 ? T = M.length - 1 : T = O.lastIndex - 2);
                    }
                    J.push(["word", M.slice(k, T + 1), E, k - G, E, T - G, k]), k = T;
                  }
                  break;
              }
              k++;
            }
            return J;
          };
        } }), To = R({ "node_modules/flatten/index.js"(e2, n) {
          A2(), n.exports = function(a, o) {
            if (o = typeof o == "number" ? o : 1 / 0, !o)
              return Array.isArray(a) ? a.map(function(p) {
                return p;
              }) : a;
            return f3(a, 1);
            function f3(p, h2) {
              return p.reduce(function(g, c) {
                return Array.isArray(c) && h2 < o ? g.concat(f3(c, h2 + 1)) : g.concat(c);
              }, []);
            }
          };
        } }), Eo = R({ "node_modules/indexes-of/index.js"(e2, n) {
          A2(), n.exports = function(i2, a) {
            for (var o = -1, f3 = []; (o = i2.indexOf(a, o + 1)) !== -1; )
              f3.push(o);
            return f3;
          };
        } }), qo = R({ "node_modules/uniq/uniq.js"(e2, n) {
          "use strict";
          A2();
          function i2(f3, p) {
            for (var h2 = 1, g = f3.length, c = f3[0], t2 = f3[0], r2 = 1; r2 < g; ++r2)
              if (t2 = c, c = f3[r2], p(c, t2)) {
                if (r2 === h2) {
                  h2++;
                  continue;
                }
                f3[h2++] = c;
              }
            return f3.length = h2, f3;
          }
          function a(f3) {
            for (var p = 1, h2 = f3.length, g = f3[0], c = f3[0], t2 = 1; t2 < h2; ++t2, c = g)
              if (c = g, g = f3[t2], g !== c) {
                if (t2 === p) {
                  p++;
                  continue;
                }
                f3[p++] = g;
              }
            return f3.length = p, f3;
          }
          function o(f3, p, h2) {
            return f3.length === 0 ? f3 : p ? (h2 || f3.sort(p), i2(f3, p)) : (h2 || f3.sort(), a(f3));
          }
          n.exports = o;
        } }), uf = R({ "node_modules/postcss-values-parser/lib/errors/ParserError.js"(e2, n) {
          "use strict";
          A2();
          var i2 = class extends Error {
            constructor(a) {
              super(a), this.name = this.constructor.name, this.message = a || "An error ocurred while parsing.", typeof Error.captureStackTrace == "function" ? Error.captureStackTrace(this, this.constructor) : this.stack = new Error(a).stack;
            }
          };
          n.exports = i2;
        } }), cf = R({ "node_modules/postcss-values-parser/lib/parser.js"(e2, n) {
          "use strict";
          A2();
          var i2 = Ll(), a = Ks(), o = Qs(), f3 = Ys(), p = Xs(), h2 = Zs(), g = eo(), c = ro(), t2 = to(), r2 = no(), u = io(), s2 = so(), l = oo(), m2 = af(), v = To(), y = Eo(), w = qo(), d = uf();
          function _(S2) {
            return S2.sort((x2, N) => x2 - N);
          }
          n.exports = class {
            constructor(x2, N) {
              let P = { loose: false };
              this.cache = [], this.input = x2, this.options = Object.assign({}, P, N), this.position = 0, this.unbalanced = 0, this.root = new i2();
              let W = new a();
              this.root.append(W), this.current = W, this.tokens = m2(x2, this.options);
            }
            parse() {
              return this.loop();
            }
            colon() {
              let x2 = this.currToken;
              this.newNode(new f3({ value: x2[1], source: { start: { line: x2[2], column: x2[3] }, end: { line: x2[4], column: x2[5] } }, sourceIndex: x2[6] })), this.position++;
            }
            comma() {
              let x2 = this.currToken;
              this.newNode(new p({ value: x2[1], source: { start: { line: x2[2], column: x2[3] }, end: { line: x2[4], column: x2[5] } }, sourceIndex: x2[6] })), this.position++;
            }
            comment() {
              let x2 = false, N = this.currToken[1].replace(/\/\*|\*\//g, ""), P;
              this.options.loose && N.startsWith("//") && (N = N.substring(2), x2 = true), P = new h2({ value: N, inline: x2, source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[4], column: this.currToken[5] } }, sourceIndex: this.currToken[6] }), this.newNode(P), this.position++;
            }
            error(x2, N) {
              throw new d(x2 + " at line: ".concat(N[2], ", column ").concat(N[3]));
            }
            loop() {
              for (; this.position < this.tokens.length; )
                this.parseTokens();
              return !this.current.last && this.spaces ? this.current.raws.before += this.spaces : this.spaces && (this.current.last.raws.after += this.spaces), this.spaces = "", this.root;
            }
            operator() {
              let x2 = this.currToken[1], N;
              if (x2 === "+" || x2 === "-") {
                if (this.options.loose || this.position > 0 && (this.current.type === "func" && this.current.value === "calc" ? this.prevToken[0] !== "space" && this.prevToken[0] !== "(" ? this.error("Syntax Error", this.currToken) : this.nextToken[0] !== "space" && this.nextToken[0] !== "word" ? this.error("Syntax Error", this.currToken) : this.nextToken[0] === "word" && this.current.last.type !== "operator" && this.current.last.value !== "(" && this.error("Syntax Error", this.currToken) : (this.nextToken[0] === "space" || this.nextToken[0] === "operator" || this.prevToken[0] === "operator") && this.error("Syntax Error", this.currToken)), this.options.loose) {
                  if ((!this.current.nodes.length || this.current.last && this.current.last.type === "operator") && this.nextToken[0] === "word")
                    return this.word();
                } else if (this.nextToken[0] === "word")
                  return this.word();
              }
              return N = new t2({ value: this.currToken[1], source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: this.currToken[4] }), this.position++, this.newNode(N);
            }
            parseTokens() {
              switch (this.currToken[0]) {
                case "space":
                  this.space();
                  break;
                case "colon":
                  this.colon();
                  break;
                case "comma":
                  this.comma();
                  break;
                case "comment":
                  this.comment();
                  break;
                case "(":
                  this.parenOpen();
                  break;
                case ")":
                  this.parenClose();
                  break;
                case "atword":
                case "word":
                  this.word();
                  break;
                case "operator":
                  this.operator();
                  break;
                case "string":
                  this.string();
                  break;
                case "unicoderange":
                  this.unicodeRange();
                  break;
                default:
                  this.word();
                  break;
              }
            }
            parenOpen() {
              let x2 = 1, N = this.position + 1, P = this.currToken, W;
              for (; N < this.tokens.length && x2; ) {
                let U = this.tokens[N];
                U[0] === "(" && x2++, U[0] === ")" && x2--, N++;
              }
              if (x2 && this.error("Expected closing parenthesis", P), W = this.current.last, W && W.type === "func" && W.unbalanced < 0 && (W.unbalanced = 0, this.current = W), this.current.unbalanced++, this.newNode(new r2({ value: P[1], source: { start: { line: P[2], column: P[3] }, end: { line: P[4], column: P[5] } }, sourceIndex: P[6] })), this.position++, this.current.type === "func" && this.current.unbalanced && this.current.value === "url" && this.currToken[0] !== "string" && this.currToken[0] !== ")" && !this.options.loose) {
                let U = this.nextToken, H = this.currToken[1], D = { line: this.currToken[2], column: this.currToken[3] };
                for (; U && U[0] !== ")" && this.current.unbalanced; )
                  this.position++, H += this.currToken[1], U = this.nextToken;
                this.position !== this.tokens.length - 1 && (this.position++, this.newNode(new s2({ value: H, source: { start: D, end: { line: this.currToken[4], column: this.currToken[5] } }, sourceIndex: this.currToken[6] })));
              }
            }
            parenClose() {
              let x2 = this.currToken;
              this.newNode(new r2({ value: x2[1], source: { start: { line: x2[2], column: x2[3] }, end: { line: x2[4], column: x2[5] } }, sourceIndex: x2[6] })), this.position++, !(this.position >= this.tokens.length - 1 && !this.current.unbalanced) && (this.current.unbalanced--, this.current.unbalanced < 0 && this.error("Expected opening parenthesis", x2), !this.current.unbalanced && this.cache.length && (this.current = this.cache.pop()));
            }
            space() {
              let x2 = this.currToken;
              this.position === this.tokens.length - 1 || this.nextToken[0] === "," || this.nextToken[0] === ")" ? (this.current.last.raws.after += x2[1], this.position++) : (this.spaces = x2[1], this.position++);
            }
            unicodeRange() {
              let x2 = this.currToken;
              this.newNode(new l({ value: x2[1], source: { start: { line: x2[2], column: x2[3] }, end: { line: x2[4], column: x2[5] } }, sourceIndex: x2[6] })), this.position++;
            }
            splitWord() {
              let x2 = this.nextToken, N = this.currToken[1], P = /^[\+\-]?((\d+(\.\d*)?)|(\.\d+))([eE][\+\-]?\d+)?/, W = /^(?!\#([a-z0-9]+))[\#\{\}]/gi, U, H;
              if (!W.test(N))
                for (; x2 && x2[0] === "word"; )
                  this.position++, N += this.currToken[1], x2 = this.nextToken;
              U = y(N, "@"), H = _(w(v([[0], U]))), H.forEach((D, $) => {
                let B = H[$ + 1] || N.length, O = N.slice(D, B), j;
                if (~U.indexOf(D))
                  j = new o({ value: O.slice(1), source: { start: { line: this.currToken[2], column: this.currToken[3] + D }, end: { line: this.currToken[4], column: this.currToken[3] + (B - 1) } }, sourceIndex: this.currToken[6] + H[$] });
                else if (P.test(this.currToken[1])) {
                  let C = O.replace(P, "");
                  j = new c({ value: O.replace(C, ""), source: { start: { line: this.currToken[2], column: this.currToken[3] + D }, end: { line: this.currToken[4], column: this.currToken[3] + (B - 1) } }, sourceIndex: this.currToken[6] + H[$], unit: C });
                } else
                  j = new (x2 && x2[0] === "(" ? g : s2)({ value: O, source: { start: { line: this.currToken[2], column: this.currToken[3] + D }, end: { line: this.currToken[4], column: this.currToken[3] + (B - 1) } }, sourceIndex: this.currToken[6] + H[$] }), j.type === "word" ? (j.isHex = /^#(.+)/.test(O), j.isColor = /^#([0-9a-f]{3}|[0-9a-f]{4}|[0-9a-f]{6}|[0-9a-f]{8})$/i.test(O)) : this.cache.push(this.current);
                this.newNode(j);
              }), this.position++;
            }
            string() {
              let x2 = this.currToken, N = this.currToken[1], P = /^(\"|\')/, W = P.test(N), U = "", H;
              W && (U = N.match(P)[0], N = N.slice(1, N.length - 1)), H = new u({ value: N, source: { start: { line: x2[2], column: x2[3] }, end: { line: x2[4], column: x2[5] } }, sourceIndex: x2[6], quoted: W }), H.raws.quote = U, this.newNode(H), this.position++;
            }
            word() {
              return this.splitWord();
            }
            newNode(x2) {
              return this.spaces && (x2.raws.before += this.spaces, this.spaces = ""), this.current.append(x2);
            }
            get currToken() {
              return this.tokens[this.position];
            }
            get nextToken() {
              return this.tokens[this.position + 1];
            }
            get prevToken() {
              return this.tokens[this.position - 1];
            }
          };
        } }), lf = R({ "node_modules/postcss-values-parser/lib/index.js"(e2, n) {
          "use strict";
          A2();
          var i2 = cf(), a = Qs(), o = Ys(), f3 = Xs(), p = Zs(), h2 = eo(), g = ro(), c = to(), t2 = no(), r2 = io(), u = oo(), s2 = Ks(), l = so(), m2 = function(v, y) {
            return new i2(v, y);
          };
          m2.atword = function(v) {
            return new a(v);
          }, m2.colon = function(v) {
            return new o(Object.assign({ value: ":" }, v));
          }, m2.comma = function(v) {
            return new f3(Object.assign({ value: "," }, v));
          }, m2.comment = function(v) {
            return new p(v);
          }, m2.func = function(v) {
            return new h2(v);
          }, m2.number = function(v) {
            return new g(v);
          }, m2.operator = function(v) {
            return new c(v);
          }, m2.paren = function(v) {
            return new t2(Object.assign({ value: "(" }, v));
          }, m2.string = function(v) {
            return new r2(Object.assign({ quote: "'" }, v));
          }, m2.value = function(v) {
            return new s2(v);
          }, m2.word = function(v) {
            return new l(v);
          }, m2.unicodeRange = function(v) {
            return new u(v);
          }, n.exports = m2;
        } }), ze = R({ "node_modules/postcss-selector-parser/dist/selectors/node.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(p) {
            return typeof p;
          } : function(p) {
            return p && typeof Symbol == "function" && p.constructor === Symbol && p !== Symbol.prototype ? "symbol" : typeof p;
          };
          function a(p, h2) {
            if (!(p instanceof h2))
              throw new TypeError("Cannot call a class as a function");
          }
          var o = function p(h2, g) {
            if ((typeof h2 > "u" ? "undefined" : i2(h2)) !== "object")
              return h2;
            var c = new h2.constructor();
            for (var t2 in h2)
              if (!!h2.hasOwnProperty(t2)) {
                var r2 = h2[t2], u = typeof r2 > "u" ? "undefined" : i2(r2);
                t2 === "parent" && u === "object" ? g && (c[t2] = g) : r2 instanceof Array ? c[t2] = r2.map(function(s2) {
                  return p(s2, c);
                }) : c[t2] = p(r2, c);
              }
            return c;
          }, f3 = function() {
            function p() {
              var h2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              a(this, p);
              for (var g in h2)
                this[g] = h2[g];
              var c = h2.spaces;
              c = c === void 0 ? {} : c;
              var t2 = c.before, r2 = t2 === void 0 ? "" : t2, u = c.after, s2 = u === void 0 ? "" : u;
              this.spaces = { before: r2, after: s2 };
            }
            return p.prototype.remove = function() {
              return this.parent && this.parent.removeChild(this), this.parent = void 0, this;
            }, p.prototype.replaceWith = function() {
              if (this.parent) {
                for (var g in arguments)
                  this.parent.insertBefore(this, arguments[g]);
                this.remove();
              }
              return this;
            }, p.prototype.next = function() {
              return this.parent.at(this.parent.index(this) + 1);
            }, p.prototype.prev = function() {
              return this.parent.at(this.parent.index(this) - 1);
            }, p.prototype.clone = function() {
              var g = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, c = o(this);
              for (var t2 in g)
                c[t2] = g[t2];
              return c;
            }, p.prototype.toString = function() {
              return [this.spaces.before, String(this.value), this.spaces.after].join("");
            }, p;
          }();
          e2.default = f3, n.exports = e2.default;
        } }), oe = R({ "node_modules/postcss-selector-parser/dist/selectors/types.js"(e2) {
          "use strict";
          A2(), e2.__esModule = true;
          var n = e2.TAG = "tag", i2 = e2.STRING = "string", a = e2.SELECTOR = "selector", o = e2.ROOT = "root", f3 = e2.PSEUDO = "pseudo", p = e2.NESTING = "nesting", h2 = e2.ID = "id", g = e2.COMMENT = "comment", c = e2.COMBINATOR = "combinator", t2 = e2.CLASS = "class", r2 = e2.ATTRIBUTE = "attribute", u = e2.UNIVERSAL = "universal";
        } }), Ct = R({ "node_modules/postcss-selector-parser/dist/selectors/container.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = function() {
            function s2(l, m2) {
              for (var v = 0; v < m2.length; v++) {
                var y = m2[v];
                y.enumerable = y.enumerable || false, y.configurable = true, "value" in y && (y.writable = true), Object.defineProperty(l, y.key, y);
              }
            }
            return function(l, m2, v) {
              return m2 && s2(l.prototype, m2), v && s2(l, v), l;
            };
          }(), a = ze(), o = g(a), f3 = oe(), p = h2(f3);
          function h2(s2) {
            if (s2 && s2.__esModule)
              return s2;
            var l = {};
            if (s2 != null)
              for (var m2 in s2)
                Object.prototype.hasOwnProperty.call(s2, m2) && (l[m2] = s2[m2]);
            return l.default = s2, l;
          }
          function g(s2) {
            return s2 && s2.__esModule ? s2 : { default: s2 };
          }
          function c(s2, l) {
            if (!(s2 instanceof l))
              throw new TypeError("Cannot call a class as a function");
          }
          function t2(s2, l) {
            if (!s2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return l && (typeof l == "object" || typeof l == "function") ? l : s2;
          }
          function r2(s2, l) {
            if (typeof l != "function" && l !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof l);
            s2.prototype = Object.create(l && l.prototype, { constructor: { value: s2, enumerable: false, writable: true, configurable: true } }), l && (Object.setPrototypeOf ? Object.setPrototypeOf(s2, l) : s2.__proto__ = l);
          }
          var u = function(s2) {
            r2(l, s2);
            function l(m2) {
              c(this, l);
              var v = t2(this, s2.call(this, m2));
              return v.nodes || (v.nodes = []), v;
            }
            return l.prototype.append = function(v) {
              return v.parent = this, this.nodes.push(v), this;
            }, l.prototype.prepend = function(v) {
              return v.parent = this, this.nodes.unshift(v), this;
            }, l.prototype.at = function(v) {
              return this.nodes[v];
            }, l.prototype.index = function(v) {
              return typeof v == "number" ? v : this.nodes.indexOf(v);
            }, l.prototype.removeChild = function(v) {
              v = this.index(v), this.at(v).parent = void 0, this.nodes.splice(v, 1);
              var y = void 0;
              for (var w in this.indexes)
                y = this.indexes[w], y >= v && (this.indexes[w] = y - 1);
              return this;
            }, l.prototype.removeAll = function() {
              for (var w = this.nodes, v = Array.isArray(w), y = 0, w = v ? w : w[Symbol.iterator](); ; ) {
                var d;
                if (v) {
                  if (y >= w.length)
                    break;
                  d = w[y++];
                } else {
                  if (y = w.next(), y.done)
                    break;
                  d = y.value;
                }
                var _ = d;
                _.parent = void 0;
              }
              return this.nodes = [], this;
            }, l.prototype.empty = function() {
              return this.removeAll();
            }, l.prototype.insertAfter = function(v, y) {
              var w = this.index(v);
              this.nodes.splice(w + 1, 0, y);
              var d = void 0;
              for (var _ in this.indexes)
                d = this.indexes[_], w <= d && (this.indexes[_] = d + this.nodes.length);
              return this;
            }, l.prototype.insertBefore = function(v, y) {
              var w = this.index(v);
              this.nodes.splice(w, 0, y);
              var d = void 0;
              for (var _ in this.indexes)
                d = this.indexes[_], w <= d && (this.indexes[_] = d + this.nodes.length);
              return this;
            }, l.prototype.each = function(v) {
              this.lastEach || (this.lastEach = 0), this.indexes || (this.indexes = {}), this.lastEach++;
              var y = this.lastEach;
              if (this.indexes[y] = 0, !!this.length) {
                for (var w = void 0, d = void 0; this.indexes[y] < this.length && (w = this.indexes[y], d = v(this.at(w), w), d !== false); )
                  this.indexes[y] += 1;
                if (delete this.indexes[y], d === false)
                  return false;
              }
            }, l.prototype.walk = function(v) {
              return this.each(function(y, w) {
                var d = v(y, w);
                if (d !== false && y.length && (d = y.walk(v)), d === false)
                  return false;
              });
            }, l.prototype.walkAttributes = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.ATTRIBUTE)
                  return v.call(y, w);
              });
            }, l.prototype.walkClasses = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.CLASS)
                  return v.call(y, w);
              });
            }, l.prototype.walkCombinators = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.COMBINATOR)
                  return v.call(y, w);
              });
            }, l.prototype.walkComments = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.COMMENT)
                  return v.call(y, w);
              });
            }, l.prototype.walkIds = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.ID)
                  return v.call(y, w);
              });
            }, l.prototype.walkNesting = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.NESTING)
                  return v.call(y, w);
              });
            }, l.prototype.walkPseudos = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.PSEUDO)
                  return v.call(y, w);
              });
            }, l.prototype.walkTags = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.TAG)
                  return v.call(y, w);
              });
            }, l.prototype.walkUniversals = function(v) {
              var y = this;
              return this.walk(function(w) {
                if (w.type === p.UNIVERSAL)
                  return v.call(y, w);
              });
            }, l.prototype.split = function(v) {
              var y = this, w = [];
              return this.reduce(function(d, _, S2) {
                var x2 = v.call(y, _);
                return w.push(_), x2 ? (d.push(w), w = []) : S2 === y.length - 1 && d.push(w), d;
              }, []);
            }, l.prototype.map = function(v) {
              return this.nodes.map(v);
            }, l.prototype.reduce = function(v, y) {
              return this.nodes.reduce(v, y);
            }, l.prototype.every = function(v) {
              return this.nodes.every(v);
            }, l.prototype.some = function(v) {
              return this.nodes.some(v);
            }, l.prototype.filter = function(v) {
              return this.nodes.filter(v);
            }, l.prototype.sort = function(v) {
              return this.nodes.sort(v);
            }, l.prototype.toString = function() {
              return this.map(String).join("");
            }, i2(l, [{ key: "first", get: function() {
              return this.at(0);
            } }, { key: "last", get: function() {
              return this.at(this.length - 1);
            } }, { key: "length", get: function() {
              return this.nodes.length;
            } }]), l;
          }(o.default);
          e2.default = u, n.exports = e2.default;
        } }), Ao = R({ "node_modules/postcss-selector-parser/dist/selectors/root.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = Ct(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.ROOT, s2;
            }
            return r2.prototype.toString = function() {
              var s2 = this.reduce(function(l, m2) {
                var v = String(m2);
                return v ? l + v + "," : "";
              }, "").slice(0, -1);
              return this.trailingComma ? s2 + "," : s2;
            }, r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), Po = R({ "node_modules/postcss-selector-parser/dist/selectors/selector.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = Ct(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.SELECTOR, s2;
            }
            return r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), Ye = R({ "node_modules/postcss-selector-parser/dist/selectors/namespace.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = function() {
            function t2(r2, u) {
              for (var s2 = 0; s2 < u.length; s2++) {
                var l = u[s2];
                l.enumerable = l.enumerable || false, l.configurable = true, "value" in l && (l.writable = true), Object.defineProperty(r2, l.key, l);
              }
            }
            return function(r2, u, s2) {
              return u && t2(r2.prototype, u), s2 && t2(r2, s2), r2;
            };
          }(), a = ze(), o = f3(a);
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2() {
              return p(this, r2), h2(this, t2.apply(this, arguments));
            }
            return r2.prototype.toString = function() {
              return [this.spaces.before, this.ns, String(this.value), this.spaces.after].join("");
            }, i2(r2, [{ key: "ns", get: function() {
              var s2 = this.namespace;
              return s2 ? (typeof s2 == "string" ? s2 : "") + "|" : "";
            } }]), r2;
          }(o.default);
          e2.default = c, n.exports = e2.default;
        } }), Ro = R({ "node_modules/postcss-selector-parser/dist/selectors/className.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = Ye(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.CLASS, s2;
            }
            return r2.prototype.toString = function() {
              return [this.spaces.before, this.ns, String("." + this.value), this.spaces.after].join("");
            }, r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), Io = R({ "node_modules/postcss-selector-parser/dist/selectors/comment.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = ze(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.COMMENT, s2;
            }
            return r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), Co = R({ "node_modules/postcss-selector-parser/dist/selectors/id.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = Ye(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.ID, s2;
            }
            return r2.prototype.toString = function() {
              return [this.spaces.before, this.ns, String("#" + this.value), this.spaces.after].join("");
            }, r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), No = R({ "node_modules/postcss-selector-parser/dist/selectors/tag.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = Ye(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.TAG, s2;
            }
            return r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), jo = R({ "node_modules/postcss-selector-parser/dist/selectors/string.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = ze(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.STRING, s2;
            }
            return r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), Mo = R({ "node_modules/postcss-selector-parser/dist/selectors/pseudo.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = Ct(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.PSEUDO, s2;
            }
            return r2.prototype.toString = function() {
              var s2 = this.length ? "(" + this.map(String).join(",") + ")" : "";
              return [this.spaces.before, String(this.value), s2, this.spaces.after].join("");
            }, r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), Do = R({ "node_modules/postcss-selector-parser/dist/selectors/attribute.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = Ye(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.ATTRIBUTE, s2.raws = {}, s2;
            }
            return r2.prototype.toString = function() {
              var s2 = [this.spaces.before, "[", this.ns, this.attribute];
              return this.operator && s2.push(this.operator), this.value && s2.push(this.value), this.raws.insensitive ? s2.push(this.raws.insensitive) : this.insensitive && s2.push(" i"), s2.push("]"), s2.concat(this.spaces.after).join("");
            }, r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), Lo = R({ "node_modules/postcss-selector-parser/dist/selectors/universal.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = Ye(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.UNIVERSAL, s2.value = "*", s2;
            }
            return r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), zo = R({ "node_modules/postcss-selector-parser/dist/selectors/combinator.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = ze(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.COMBINATOR, s2;
            }
            return r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), Bo = R({ "node_modules/postcss-selector-parser/dist/selectors/nesting.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = ze(), a = f3(i2), o = oe();
          function f3(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function p(t2, r2) {
            if (!(t2 instanceof r2))
              throw new TypeError("Cannot call a class as a function");
          }
          function h2(t2, r2) {
            if (!t2)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return r2 && (typeof r2 == "object" || typeof r2 == "function") ? r2 : t2;
          }
          function g(t2, r2) {
            if (typeof r2 != "function" && r2 !== null)
              throw new TypeError("Super expression must either be null or a function, not " + typeof r2);
            t2.prototype = Object.create(r2 && r2.prototype, { constructor: { value: t2, enumerable: false, writable: true, configurable: true } }), r2 && (Object.setPrototypeOf ? Object.setPrototypeOf(t2, r2) : t2.__proto__ = r2);
          }
          var c = function(t2) {
            g(r2, t2);
            function r2(u) {
              p(this, r2);
              var s2 = h2(this, t2.call(this, u));
              return s2.type = o.NESTING, s2.value = "&", s2;
            }
            return r2;
          }(a.default);
          e2.default = c, n.exports = e2.default;
        } }), ff = R({ "node_modules/postcss-selector-parser/dist/sortAscending.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = i2;
          function i2(a) {
            return a.sort(function(o, f3) {
              return o - f3;
            });
          }
          n.exports = e2.default;
        } }), pf = R({ "node_modules/postcss-selector-parser/dist/tokenize.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = H;
          var i2 = 39, a = 34, o = 92, f3 = 47, p = 10, h2 = 32, g = 12, c = 9, t2 = 13, r2 = 43, u = 62, s2 = 126, l = 124, m2 = 44, v = 40, y = 41, w = 91, d = 93, _ = 59, S2 = 42, x2 = 58, N = 38, P = 64, W = /[ \n\t\r\{\(\)'"\\;/]/g, U = /[ \n\t\r\(\)\*:;@!&'"\+\|~>,\[\]\\]|\/(?=\*)/g;
          function H(D) {
            for (var $ = [], B = D.css.valueOf(), O = void 0, j = void 0, C = void 0, I = void 0, X = void 0, Z2 = void 0, Q = void 0, K = void 0, J = void 0, M = void 0, Y = void 0, G = B.length, E = -1, k = 1, b = 0, L = function(T, F2) {
              if (D.safe)
                B += F2, j = B.length - 1;
              else
                throw D.error("Unclosed " + T, k, b - E, b);
            }; b < G; ) {
              switch (O = B.charCodeAt(b), O === p && (E = b, k += 1), O) {
                case p:
                case h2:
                case c:
                case t2:
                case g:
                  j = b;
                  do
                    j += 1, O = B.charCodeAt(j), O === p && (E = j, k += 1);
                  while (O === h2 || O === p || O === c || O === t2 || O === g);
                  $.push(["space", B.slice(b, j), k, b - E, b]), b = j - 1;
                  break;
                case r2:
                case u:
                case s2:
                case l:
                  j = b;
                  do
                    j += 1, O = B.charCodeAt(j);
                  while (O === r2 || O === u || O === s2 || O === l);
                  $.push(["combinator", B.slice(b, j), k, b - E, b]), b = j - 1;
                  break;
                case S2:
                  $.push(["*", "*", k, b - E, b]);
                  break;
                case N:
                  $.push(["&", "&", k, b - E, b]);
                  break;
                case m2:
                  $.push([",", ",", k, b - E, b]);
                  break;
                case w:
                  $.push(["[", "[", k, b - E, b]);
                  break;
                case d:
                  $.push(["]", "]", k, b - E, b]);
                  break;
                case x2:
                  $.push([":", ":", k, b - E, b]);
                  break;
                case _:
                  $.push([";", ";", k, b - E, b]);
                  break;
                case v:
                  $.push(["(", "(", k, b - E, b]);
                  break;
                case y:
                  $.push([")", ")", k, b - E, b]);
                  break;
                case i2:
                case a:
                  C = O === i2 ? "'" : '"', j = b;
                  do
                    for (M = false, j = B.indexOf(C, j + 1), j === -1 && L("quote", C), Y = j; B.charCodeAt(Y - 1) === o; )
                      Y -= 1, M = !M;
                  while (M);
                  $.push(["string", B.slice(b, j + 1), k, b - E, k, j - E, b]), b = j;
                  break;
                case P:
                  W.lastIndex = b + 1, W.test(B), W.lastIndex === 0 ? j = B.length - 1 : j = W.lastIndex - 2, $.push(["at-word", B.slice(b, j + 1), k, b - E, k, j - E, b]), b = j;
                  break;
                case o:
                  for (j = b, Q = true; B.charCodeAt(j + 1) === o; )
                    j += 1, Q = !Q;
                  O = B.charCodeAt(j + 1), Q && O !== f3 && O !== h2 && O !== p && O !== c && O !== t2 && O !== g && (j += 1), $.push(["word", B.slice(b, j + 1), k, b - E, k, j - E, b]), b = j;
                  break;
                default:
                  O === f3 && B.charCodeAt(b + 1) === S2 ? (j = B.indexOf("*/", b + 2) + 1, j === 0 && L("comment", "*/"), Z2 = B.slice(b, j + 1), I = Z2.split(`
`), X = I.length - 1, X > 0 ? (K = k + X, J = j - I[X].length) : (K = k, J = E), $.push(["comment", Z2, k, b - E, K, j - J, b]), E = J, k = K, b = j) : (U.lastIndex = b + 1, U.test(B), U.lastIndex === 0 ? j = B.length - 1 : j = U.lastIndex - 2, $.push(["word", B.slice(b, j + 1), k, b - E, k, j - E, b]), b = j);
                  break;
              }
              b++;
            }
            return $;
          }
          n.exports = e2.default;
        } }), hf = R({ "node_modules/postcss-selector-parser/dist/parser.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = function() {
            function E(k, b) {
              for (var L = 0; L < b.length; L++) {
                var q = b[L];
                q.enumerable = q.enumerable || false, q.configurable = true, "value" in q && (q.writable = true), Object.defineProperty(k, q.key, q);
              }
            }
            return function(k, b, L) {
              return b && E(k.prototype, b), L && E(k, L), k;
            };
          }(), a = To(), o = M(a), f3 = Eo(), p = M(f3), h2 = qo(), g = M(h2), c = Ao(), t2 = M(c), r2 = Po(), u = M(r2), s2 = Ro(), l = M(s2), m2 = Io(), v = M(m2), y = Co(), w = M(y), d = No(), _ = M(d), S2 = jo(), x2 = M(S2), N = Mo(), P = M(N), W = Do(), U = M(W), H = Lo(), D = M(H), $ = zo(), B = M($), O = Bo(), j = M(O), C = ff(), I = M(C), X = pf(), Z2 = M(X), Q = oe(), K = J(Q);
          function J(E) {
            if (E && E.__esModule)
              return E;
            var k = {};
            if (E != null)
              for (var b in E)
                Object.prototype.hasOwnProperty.call(E, b) && (k[b] = E[b]);
            return k.default = E, k;
          }
          function M(E) {
            return E && E.__esModule ? E : { default: E };
          }
          function Y(E, k) {
            if (!(E instanceof k))
              throw new TypeError("Cannot call a class as a function");
          }
          var G = function() {
            function E(k) {
              Y(this, E), this.input = k, this.lossy = k.options.lossless === false, this.position = 0, this.root = new t2.default();
              var b = new u.default();
              return this.root.append(b), this.current = b, this.lossy ? this.tokens = (0, Z2.default)({ safe: k.safe, css: k.css.trim() }) : this.tokens = (0, Z2.default)(k), this.loop();
            }
            return E.prototype.attribute = function() {
              var b = "", L = void 0, q = this.currToken;
              for (this.position++; this.position < this.tokens.length && this.currToken[0] !== "]"; )
                b += this.tokens[this.position][1], this.position++;
              this.position === this.tokens.length && !~b.indexOf("]") && this.error("Expected a closing square bracket.");
              var T = b.split(/((?:[*~^$|]?=))([^]*)/), F2 = T[0].split(/(\|)/g), z = { operator: T[1], value: T[2], source: { start: { line: q[2], column: q[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: q[4] };
              if (F2.length > 1 ? (F2[0] === "" && (F2[0] = true), z.attribute = this.parseValue(F2[2]), z.namespace = this.parseNamespace(F2[0])) : z.attribute = this.parseValue(T[0]), L = new U.default(z), T[2]) {
                var re = T[2].split(/(\s+i\s*?)$/), ne = re[0].trim();
                L.value = this.lossy ? ne : re[0], re[1] && (L.insensitive = true, this.lossy || (L.raws.insensitive = re[1])), L.quoted = ne[0] === "'" || ne[0] === '"', L.raws.unquoted = L.quoted ? ne.slice(1, -1) : ne;
              }
              this.newNode(L), this.position++;
            }, E.prototype.combinator = function() {
              if (this.currToken[1] === "|")
                return this.namespace();
              for (var b = new B.default({ value: "", source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: this.currToken[4] }); this.position < this.tokens.length && this.currToken && (this.currToken[0] === "space" || this.currToken[0] === "combinator"); )
                this.nextToken && this.nextToken[0] === "combinator" ? (b.spaces.before = this.parseSpace(this.currToken[1]), b.source.start.line = this.nextToken[2], b.source.start.column = this.nextToken[3], b.source.end.column = this.nextToken[3], b.source.end.line = this.nextToken[2], b.sourceIndex = this.nextToken[4]) : this.prevToken && this.prevToken[0] === "combinator" ? b.spaces.after = this.parseSpace(this.currToken[1]) : this.currToken[0] === "combinator" ? b.value = this.currToken[1] : this.currToken[0] === "space" && (b.value = this.parseSpace(this.currToken[1], " ")), this.position++;
              return this.newNode(b);
            }, E.prototype.comma = function() {
              if (this.position === this.tokens.length - 1) {
                this.root.trailingComma = true, this.position++;
                return;
              }
              var b = new u.default();
              this.current.parent.append(b), this.current = b, this.position++;
            }, E.prototype.comment = function() {
              var b = new v.default({ value: this.currToken[1], source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[4], column: this.currToken[5] } }, sourceIndex: this.currToken[6] });
              this.newNode(b), this.position++;
            }, E.prototype.error = function(b) {
              throw new this.input.error(b);
            }, E.prototype.missingBackslash = function() {
              return this.error("Expected a backslash preceding the semicolon.");
            }, E.prototype.missingParenthesis = function() {
              return this.error("Expected opening parenthesis.");
            }, E.prototype.missingSquareBracket = function() {
              return this.error("Expected opening square bracket.");
            }, E.prototype.namespace = function() {
              var b = this.prevToken && this.prevToken[1] || true;
              if (this.nextToken[0] === "word")
                return this.position++, this.word(b);
              if (this.nextToken[0] === "*")
                return this.position++, this.universal(b);
            }, E.prototype.nesting = function() {
              this.newNode(new j.default({ value: this.currToken[1], source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: this.currToken[4] })), this.position++;
            }, E.prototype.parentheses = function() {
              var b = this.current.last;
              if (b && b.type === K.PSEUDO) {
                var L = new u.default(), q = this.current;
                b.append(L), this.current = L;
                var T = 1;
                for (this.position++; this.position < this.tokens.length && T; )
                  this.currToken[0] === "(" && T++, this.currToken[0] === ")" && T--, T ? this.parse() : (L.parent.source.end.line = this.currToken[2], L.parent.source.end.column = this.currToken[3], this.position++);
                T && this.error("Expected closing parenthesis."), this.current = q;
              } else {
                var F2 = 1;
                for (this.position++, b.value += "("; this.position < this.tokens.length && F2; )
                  this.currToken[0] === "(" && F2++, this.currToken[0] === ")" && F2--, b.value += this.parseParenthesisToken(this.currToken), this.position++;
                F2 && this.error("Expected closing parenthesis.");
              }
            }, E.prototype.pseudo = function() {
              for (var b = this, L = "", q = this.currToken; this.currToken && this.currToken[0] === ":"; )
                L += this.currToken[1], this.position++;
              if (!this.currToken)
                return this.error("Expected pseudo-class or pseudo-element");
              if (this.currToken[0] === "word") {
                var T = void 0;
                this.splitWord(false, function(F2, z) {
                  L += F2, T = new P.default({ value: L, source: { start: { line: q[2], column: q[3] }, end: { line: b.currToken[4], column: b.currToken[5] } }, sourceIndex: q[4] }), b.newNode(T), z > 1 && b.nextToken && b.nextToken[0] === "(" && b.error("Misplaced parenthesis.");
                });
              } else
                this.error('Unexpected "' + this.currToken[0] + '" found.');
            }, E.prototype.space = function() {
              var b = this.currToken;
              this.position === 0 || this.prevToken[0] === "," || this.prevToken[0] === "(" ? (this.spaces = this.parseSpace(b[1]), this.position++) : this.position === this.tokens.length - 1 || this.nextToken[0] === "," || this.nextToken[0] === ")" ? (this.current.last.spaces.after = this.parseSpace(b[1]), this.position++) : this.combinator();
            }, E.prototype.string = function() {
              var b = this.currToken;
              this.newNode(new x2.default({ value: this.currToken[1], source: { start: { line: b[2], column: b[3] }, end: { line: b[4], column: b[5] } }, sourceIndex: b[6] })), this.position++;
            }, E.prototype.universal = function(b) {
              var L = this.nextToken;
              if (L && L[1] === "|")
                return this.position++, this.namespace();
              this.newNode(new D.default({ value: this.currToken[1], source: { start: { line: this.currToken[2], column: this.currToken[3] }, end: { line: this.currToken[2], column: this.currToken[3] } }, sourceIndex: this.currToken[4] }), b), this.position++;
            }, E.prototype.splitWord = function(b, L) {
              for (var q = this, T = this.nextToken, F2 = this.currToken[1]; T && T[0] === "word"; ) {
                this.position++;
                var z = this.currToken[1];
                if (F2 += z, z.lastIndexOf("\\") === z.length - 1) {
                  var re = this.nextToken;
                  re && re[0] === "space" && (F2 += this.parseSpace(re[1], " "), this.position++);
                }
                T = this.nextToken;
              }
              var ne = (0, p.default)(F2, "."), ce = (0, p.default)(F2, "#"), fe = (0, p.default)(F2, "#{");
              fe.length && (ce = ce.filter(function(ie) {
                return !~fe.indexOf(ie);
              }));
              var te = (0, I.default)((0, g.default)((0, o.default)([[0], ne, ce])));
              te.forEach(function(ie, ae) {
                var se = te[ae + 1] || F2.length, le = F2.slice(ie, se);
                if (ae === 0 && L)
                  return L.call(q, le, te.length);
                var pe = void 0;
                ~ne.indexOf(ie) ? pe = new l.default({ value: le.slice(1), source: { start: { line: q.currToken[2], column: q.currToken[3] + ie }, end: { line: q.currToken[4], column: q.currToken[3] + (se - 1) } }, sourceIndex: q.currToken[6] + te[ae] }) : ~ce.indexOf(ie) ? pe = new w.default({ value: le.slice(1), source: { start: { line: q.currToken[2], column: q.currToken[3] + ie }, end: { line: q.currToken[4], column: q.currToken[3] + (se - 1) } }, sourceIndex: q.currToken[6] + te[ae] }) : pe = new _.default({ value: le, source: { start: { line: q.currToken[2], column: q.currToken[3] + ie }, end: { line: q.currToken[4], column: q.currToken[3] + (se - 1) } }, sourceIndex: q.currToken[6] + te[ae] }), q.newNode(pe, b);
              }), this.position++;
            }, E.prototype.word = function(b) {
              var L = this.nextToken;
              return L && L[1] === "|" ? (this.position++, this.namespace()) : this.splitWord(b);
            }, E.prototype.loop = function() {
              for (; this.position < this.tokens.length; )
                this.parse(true);
              return this.root;
            }, E.prototype.parse = function(b) {
              switch (this.currToken[0]) {
                case "space":
                  this.space();
                  break;
                case "comment":
                  this.comment();
                  break;
                case "(":
                  this.parentheses();
                  break;
                case ")":
                  b && this.missingParenthesis();
                  break;
                case "[":
                  this.attribute();
                  break;
                case "]":
                  this.missingSquareBracket();
                  break;
                case "at-word":
                case "word":
                  this.word();
                  break;
                case ":":
                  this.pseudo();
                  break;
                case ";":
                  this.missingBackslash();
                  break;
                case ",":
                  this.comma();
                  break;
                case "*":
                  this.universal();
                  break;
                case "&":
                  this.nesting();
                  break;
                case "combinator":
                  this.combinator();
                  break;
                case "string":
                  this.string();
                  break;
              }
            }, E.prototype.parseNamespace = function(b) {
              if (this.lossy && typeof b == "string") {
                var L = b.trim();
                return L.length ? L : true;
              }
              return b;
            }, E.prototype.parseSpace = function(b, L) {
              return this.lossy ? L || "" : b;
            }, E.prototype.parseValue = function(b) {
              return this.lossy && b && typeof b == "string" ? b.trim() : b;
            }, E.prototype.parseParenthesisToken = function(b) {
              return this.lossy ? b[0] === "space" ? this.parseSpace(b[1], " ") : this.parseValue(b[1]) : b[1];
            }, E.prototype.newNode = function(b, L) {
              return L && (b.namespace = this.parseNamespace(L)), this.spaces && (b.spaces.before = this.spaces, this.spaces = ""), this.current.append(b);
            }, i2(E, [{ key: "currToken", get: function() {
              return this.tokens[this.position];
            } }, { key: "nextToken", get: function() {
              return this.tokens[this.position + 1];
            } }, { key: "prevToken", get: function() {
              return this.tokens[this.position - 1];
            } }]), E;
          }();
          e2.default = G, n.exports = e2.default;
        } }), df = R({ "node_modules/postcss-selector-parser/dist/processor.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = function() {
            function g(c, t2) {
              for (var r2 = 0; r2 < t2.length; r2++) {
                var u = t2[r2];
                u.enumerable = u.enumerable || false, u.configurable = true, "value" in u && (u.writable = true), Object.defineProperty(c, u.key, u);
              }
            }
            return function(c, t2, r2) {
              return t2 && g(c.prototype, t2), r2 && g(c, r2), c;
            };
          }(), a = hf(), o = f3(a);
          function f3(g) {
            return g && g.__esModule ? g : { default: g };
          }
          function p(g, c) {
            if (!(g instanceof c))
              throw new TypeError("Cannot call a class as a function");
          }
          var h2 = function() {
            function g(c) {
              return p(this, g), this.func = c || function() {
              }, this;
            }
            return g.prototype.process = function(t2) {
              var r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, u = new o.default({ css: t2, error: function(l) {
                throw new Error(l);
              }, options: r2 });
              return this.res = u, this.func(u), this;
            }, i2(g, [{ key: "result", get: function() {
              return String(this.res);
            } }]), g;
          }();
          e2.default = h2, n.exports = e2.default;
        } }), vf = R({ "node_modules/postcss-selector-parser/dist/index.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true;
          var i2 = df(), a = O(i2), o = Do(), f3 = O(o), p = Ro(), h2 = O(p), g = zo(), c = O(g), t2 = Io(), r2 = O(t2), u = Co(), s2 = O(u), l = Bo(), m2 = O(l), v = Mo(), y = O(v), w = Ao(), d = O(w), _ = Po(), S2 = O(_), x2 = jo(), N = O(x2), P = No(), W = O(P), U = Lo(), H = O(U), D = oe(), $ = B(D);
          function B(C) {
            if (C && C.__esModule)
              return C;
            var I = {};
            if (C != null)
              for (var X in C)
                Object.prototype.hasOwnProperty.call(C, X) && (I[X] = C[X]);
            return I.default = C, I;
          }
          function O(C) {
            return C && C.__esModule ? C : { default: C };
          }
          var j = function(I) {
            return new a.default(I);
          };
          j.attribute = function(C) {
            return new f3.default(C);
          }, j.className = function(C) {
            return new h2.default(C);
          }, j.combinator = function(C) {
            return new c.default(C);
          }, j.comment = function(C) {
            return new r2.default(C);
          }, j.id = function(C) {
            return new s2.default(C);
          }, j.nesting = function(C) {
            return new m2.default(C);
          }, j.pseudo = function(C) {
            return new y.default(C);
          }, j.root = function(C) {
            return new d.default(C);
          }, j.selector = function(C) {
            return new S2.default(C);
          }, j.string = function(C) {
            return new N.default(C);
          }, j.tag = function(C) {
            return new W.default(C);
          }, j.universal = function(C) {
            return new H.default(C);
          }, Object.keys($).forEach(function(C) {
            C !== "__esModule" && (j[C] = $[C]);
          }), e2.default = j, n.exports = e2.default;
        } }), Fo = R({ "node_modules/postcss-media-query-parser/dist/nodes/Node.js"(e2) {
          "use strict";
          A2(), Object.defineProperty(e2, "__esModule", { value: true });
          function n(i2) {
            this.after = i2.after, this.before = i2.before, this.type = i2.type, this.value = i2.value, this.sourceIndex = i2.sourceIndex;
          }
          e2.default = n;
        } }), Uo = R({ "node_modules/postcss-media-query-parser/dist/nodes/Container.js"(e2) {
          "use strict";
          A2(), Object.defineProperty(e2, "__esModule", { value: true });
          var n = Fo(), i2 = a(n);
          function a(f3) {
            return f3 && f3.__esModule ? f3 : { default: f3 };
          }
          function o(f3) {
            var p = this;
            this.constructor(f3), this.nodes = f3.nodes, this.after === void 0 && (this.after = this.nodes.length > 0 ? this.nodes[this.nodes.length - 1].after : ""), this.before === void 0 && (this.before = this.nodes.length > 0 ? this.nodes[0].before : ""), this.sourceIndex === void 0 && (this.sourceIndex = this.before.length), this.nodes.forEach(function(h2) {
              h2.parent = p;
            });
          }
          o.prototype = Object.create(i2.default.prototype), o.constructor = i2.default, o.prototype.walk = function(p, h2) {
            for (var g = typeof p == "string" || p instanceof RegExp, c = g ? h2 : p, t2 = typeof p == "string" ? new RegExp(p) : p, r2 = 0; r2 < this.nodes.length; r2++) {
              var u = this.nodes[r2], s2 = g ? t2.test(u.type) : true;
              if (s2 && c && c(u, r2, this.nodes) === false || u.nodes && u.walk(p, h2) === false)
                return false;
            }
            return true;
          }, o.prototype.each = function() {
            for (var p = arguments.length <= 0 || arguments[0] === void 0 ? function() {
            } : arguments[0], h2 = 0; h2 < this.nodes.length; h2++) {
              var g = this.nodes[h2];
              if (p(g, h2, this.nodes) === false)
                return false;
            }
            return true;
          }, e2.default = o;
        } }), mf = R({ "node_modules/postcss-media-query-parser/dist/parsers.js"(e2) {
          "use strict";
          A2(), Object.defineProperty(e2, "__esModule", { value: true }), e2.parseMediaFeature = p, e2.parseMediaQuery = h2, e2.parseMediaList = g;
          var n = Fo(), i2 = f3(n), a = Uo(), o = f3(a);
          function f3(c) {
            return c && c.__esModule ? c : { default: c };
          }
          function p(c) {
            var t2 = arguments.length <= 1 || arguments[1] === void 0 ? 0 : arguments[1], r2 = [{ mode: "normal", character: null }], u = [], s2 = 0, l = "", m2 = null, v = null, y = t2, w = c;
            c[0] === "(" && c[c.length - 1] === ")" && (w = c.substring(1, c.length - 1), y++);
            for (var d = 0; d < w.length; d++) {
              var _ = w[d];
              if ((_ === "'" || _ === '"') && (r2[s2].isCalculationEnabled === true ? (r2.push({ mode: "string", isCalculationEnabled: false, character: _ }), s2++) : r2[s2].mode === "string" && r2[s2].character === _ && w[d - 1] !== "\\" && (r2.pop(), s2--)), _ === "{" ? (r2.push({ mode: "interpolation", isCalculationEnabled: true }), s2++) : _ === "}" && (r2.pop(), s2--), r2[s2].mode === "normal" && _ === ":") {
                var S2 = w.substring(d + 1);
                v = { type: "value", before: /^(\s*)/.exec(S2)[1], after: /(\s*)$/.exec(S2)[1], value: S2.trim() }, v.sourceIndex = v.before.length + d + 1 + y, m2 = { type: "colon", sourceIndex: d + y, after: v.before, value: ":" };
                break;
              }
              l += _;
            }
            return l = { type: "media-feature", before: /^(\s*)/.exec(l)[1], after: /(\s*)$/.exec(l)[1], value: l.trim() }, l.sourceIndex = l.before.length + y, u.push(l), m2 !== null && (m2.before = l.after, u.push(m2)), v !== null && u.push(v), u;
          }
          function h2(c) {
            var t2 = arguments.length <= 1 || arguments[1] === void 0 ? 0 : arguments[1], r2 = [], u = 0, s2 = false, l = void 0;
            function m2() {
              return { before: "", after: "", value: "" };
            }
            l = m2();
            for (var v = 0; v < c.length; v++) {
              var y = c[v];
              s2 ? (l.value += y, (y === "{" || y === "(") && u++, (y === ")" || y === "}") && u--) : y.search(/\s/) !== -1 ? l.before += y : (y === "(" && (l.type = "media-feature-expression", u++), l.value = y, l.sourceIndex = t2 + v, s2 = true), s2 && u === 0 && (y === ")" || v === c.length - 1 || c[v + 1].search(/\s/) !== -1) && (["not", "only", "and"].indexOf(l.value) !== -1 && (l.type = "keyword"), l.type === "media-feature-expression" && (l.nodes = p(l.value, l.sourceIndex)), r2.push(Array.isArray(l.nodes) ? new o.default(l) : new i2.default(l)), l = m2(), s2 = false);
            }
            for (var w = 0; w < r2.length; w++)
              if (l = r2[w], w > 0 && (r2[w - 1].after = l.before), l.type === void 0) {
                if (w > 0) {
                  if (r2[w - 1].type === "media-feature-expression") {
                    l.type = "keyword";
                    continue;
                  }
                  if (r2[w - 1].value === "not" || r2[w - 1].value === "only") {
                    l.type = "media-type";
                    continue;
                  }
                  if (r2[w - 1].value === "and") {
                    l.type = "media-feature-expression";
                    continue;
                  }
                  r2[w - 1].type === "media-type" && (r2[w + 1] ? l.type = r2[w + 1].type === "media-feature-expression" ? "keyword" : "media-feature-expression" : l.type = "media-feature-expression");
                }
                if (w === 0) {
                  if (!r2[w + 1]) {
                    l.type = "media-type";
                    continue;
                  }
                  if (r2[w + 1] && (r2[w + 1].type === "media-feature-expression" || r2[w + 1].type === "keyword")) {
                    l.type = "media-type";
                    continue;
                  }
                  if (r2[w + 2]) {
                    if (r2[w + 2].type === "media-feature-expression") {
                      l.type = "media-type", r2[w + 1].type = "keyword";
                      continue;
                    }
                    if (r2[w + 2].type === "keyword") {
                      l.type = "keyword", r2[w + 1].type = "media-type";
                      continue;
                    }
                  }
                  if (r2[w + 3] && r2[w + 3].type === "media-feature-expression") {
                    l.type = "keyword", r2[w + 1].type = "media-type", r2[w + 2].type = "keyword";
                    continue;
                  }
                }
              }
            return r2;
          }
          function g(c) {
            var t2 = [], r2 = 0, u = 0, s2 = /^(\s*)url\s*\(/.exec(c);
            if (s2 !== null) {
              for (var l = s2[0].length, m2 = 1; m2 > 0; ) {
                var v = c[l];
                v === "(" && m2++, v === ")" && m2--, l++;
              }
              t2.unshift(new i2.default({ type: "url", value: c.substring(0, l).trim(), sourceIndex: s2[1].length, before: s2[1], after: /^(\s*)/.exec(c.substring(l))[1] })), r2 = l;
            }
            for (var y = r2; y < c.length; y++) {
              var w = c[y];
              if (w === "(" && u++, w === ")" && u--, u === 0 && w === ",") {
                var d = c.substring(r2, y), _ = /^(\s*)/.exec(d)[1];
                t2.push(new o.default({ type: "media-query", value: d.trim(), sourceIndex: r2 + _.length, nodes: h2(d, r2), before: _, after: /(\s*)$/.exec(d)[1] })), r2 = y + 1;
              }
            }
            var S2 = c.substring(r2), x2 = /^(\s*)/.exec(S2)[1];
            return t2.push(new o.default({ type: "media-query", value: S2.trim(), sourceIndex: r2 + x2.length, nodes: h2(S2, r2), before: x2, after: /(\s*)$/.exec(S2)[1] })), t2;
          }
        } }), gf = R({ "node_modules/postcss-media-query-parser/dist/index.js"(e2) {
          "use strict";
          A2(), Object.defineProperty(e2, "__esModule", { value: true }), e2.default = f3;
          var n = Uo(), i2 = o(n), a = mf();
          function o(p) {
            return p && p.__esModule ? p : { default: p };
          }
          function f3(p) {
            return new i2.default({ nodes: (0, a.parseMediaList)(p), type: "media-query-list", value: p.trim() });
          }
        } }), Wo = {};
        Ot(Wo, { basename: () => Jo, default: () => Qo, delimiter: () => _t, dirname: () => Ho, extname: () => Ko, isAbsolute: () => jt, join: () => Vo, normalize: () => Nt, relative: () => Go, resolve: () => mr, sep: () => wt });
        function $o(e2, n) {
          for (var i2 = 0, a = e2.length - 1; a >= 0; a--) {
            var o = e2[a];
            o === "." ? e2.splice(a, 1) : o === ".." ? (e2.splice(a, 1), i2++) : i2 && (e2.splice(a, 1), i2--);
          }
          if (n)
            for (; i2--; i2)
              e2.unshift("..");
          return e2;
        }
        function mr() {
          for (var e2 = "", n = false, i2 = arguments.length - 1; i2 >= -1 && !n; i2--) {
            var a = i2 >= 0 ? arguments[i2] : "/";
            if (typeof a != "string")
              throw new TypeError("Arguments to path.resolve must be strings");
            if (!a)
              continue;
            e2 = a + "/" + e2, n = a.charAt(0) === "/";
          }
          return e2 = $o(Mt(e2.split("/"), function(o) {
            return !!o;
          }), !n).join("/"), (n ? "/" : "") + e2 || ".";
        }
        function Nt(e2) {
          var n = jt(e2), i2 = Yo(e2, -1) === "/";
          return e2 = $o(Mt(e2.split("/"), function(a) {
            return !!a;
          }), !n).join("/"), !e2 && !n && (e2 = "."), e2 && i2 && (e2 += "/"), (n ? "/" : "") + e2;
        }
        function jt(e2) {
          return e2.charAt(0) === "/";
        }
        function Vo() {
          var e2 = Array.prototype.slice.call(arguments, 0);
          return Nt(Mt(e2, function(n, i2) {
            if (typeof n != "string")
              throw new TypeError("Arguments to path.join must be strings");
            return n;
          }).join("/"));
        }
        function Go(e2, n) {
          e2 = mr(e2).substr(1), n = mr(n).substr(1);
          function i2(c) {
            for (var t2 = 0; t2 < c.length && c[t2] === ""; t2++)
              ;
            for (var r2 = c.length - 1; r2 >= 0 && c[r2] === ""; r2--)
              ;
            return t2 > r2 ? [] : c.slice(t2, r2 - t2 + 1);
          }
          for (var a = i2(e2.split("/")), o = i2(n.split("/")), f3 = Math.min(a.length, o.length), p = f3, h2 = 0; h2 < f3; h2++)
            if (a[h2] !== o[h2]) {
              p = h2;
              break;
            }
          for (var g = [], h2 = p; h2 < a.length; h2++)
            g.push("..");
          return g = g.concat(o.slice(p)), g.join("/");
        }
        function Ho(e2) {
          var n = wr(e2), i2 = n[0], a = n[1];
          return !i2 && !a ? "." : (a && (a = a.substr(0, a.length - 1)), i2 + a);
        }
        function Jo(e2, n) {
          var i2 = wr(e2)[2];
          return n && i2.substr(-1 * n.length) === n && (i2 = i2.substr(0, i2.length - n.length)), i2;
        }
        function Ko(e2) {
          return wr(e2)[3];
        }
        function Mt(e2, n) {
          if (e2.filter)
            return e2.filter(n);
          for (var i2 = [], a = 0; a < e2.length; a++)
            n(e2[a], a, e2) && i2.push(e2[a]);
          return i2;
        }
        var Is, wr, wt, _t, Qo, Yo, yf = Le({ "node-modules-polyfills:path"() {
          A2(), Is = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/, wr = function(e2) {
            return Is.exec(e2).slice(1);
          }, wt = "/", _t = ":", Qo = { extname: Ko, basename: Jo, dirname: Ho, sep: wt, delimiter: _t, relative: Go, join: Vo, isAbsolute: jt, normalize: Nt, resolve: mr }, Yo = "ab".substr(-1) === "b" ? function(e2, n, i2) {
            return e2.substr(n, i2);
          } : function(e2, n, i2) {
            return n < 0 && (n = e2.length + n), e2.substr(n, i2);
          };
        } }), wf = R({ "node-modules-polyfills-commonjs:path"(e2, n) {
          A2();
          var i2 = (yf(), Tt(Wo));
          if (i2 && i2.default) {
            n.exports = i2.default;
            for (let a in i2)
              n.exports[a] = i2[a];
          } else
            i2 && (n.exports = i2);
        } }), _f = R({ "node_modules/picocolors/picocolors.browser.js"(e2, n) {
          A2();
          var i2 = String, a = function() {
            return { isColorSupported: false, reset: i2, bold: i2, dim: i2, italic: i2, underline: i2, inverse: i2, hidden: i2, strikethrough: i2, black: i2, red: i2, green: i2, yellow: i2, blue: i2, magenta: i2, cyan: i2, white: i2, gray: i2, bgBlack: i2, bgRed: i2, bgGreen: i2, bgYellow: i2, bgBlue: i2, bgMagenta: i2, bgCyan: i2, bgWhite: i2 };
          };
          n.exports = a(), n.exports.createColors = a;
        } }), bf = R({ "(disabled):node_modules/postcss/lib/terminal-highlight"() {
          A2();
        } }), Xo = R({ "node_modules/postcss/lib/css-syntax-error.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = o(_f()), a = o(bf());
          function o(m2) {
            return m2 && m2.__esModule ? m2 : { default: m2 };
          }
          function f3(m2) {
            if (m2 === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return m2;
          }
          function p(m2, v) {
            m2.prototype = Object.create(v.prototype), m2.prototype.constructor = m2, m2.__proto__ = v;
          }
          function h2(m2) {
            var v = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
            return h2 = function(w) {
              if (w === null || !t2(w))
                return w;
              if (typeof w != "function")
                throw new TypeError("Super expression must either be null or a function");
              if (typeof v < "u") {
                if (v.has(w))
                  return v.get(w);
                v.set(w, d);
              }
              function d() {
                return g(w, arguments, u(this).constructor);
              }
              return d.prototype = Object.create(w.prototype, { constructor: { value: d, enumerable: false, writable: true, configurable: true } }), r2(d, w);
            }, h2(m2);
          }
          function g(m2, v, y) {
            return c() ? g = Reflect.construct : g = function(d, _, S2) {
              var x2 = [null];
              x2.push.apply(x2, _);
              var N = Function.bind.apply(d, x2), P = new N();
              return S2 && r2(P, S2.prototype), P;
            }, g.apply(null, arguments);
          }
          function c() {
            if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), true;
            } catch {
              return false;
            }
          }
          function t2(m2) {
            return Function.toString.call(m2).indexOf("[native code]") !== -1;
          }
          function r2(m2, v) {
            return r2 = Object.setPrototypeOf || function(w, d) {
              return w.__proto__ = d, w;
            }, r2(m2, v);
          }
          function u(m2) {
            return u = Object.setPrototypeOf ? Object.getPrototypeOf : function(y) {
              return y.__proto__ || Object.getPrototypeOf(y);
            }, u(m2);
          }
          var s2 = function(m2) {
            p(v, m2);
            function v(w, d, _, S2, x2, N) {
              var P;
              return P = m2.call(this, w) || this, P.name = "CssSyntaxError", P.reason = w, x2 && (P.file = x2), S2 && (P.source = S2), N && (P.plugin = N), typeof d < "u" && typeof _ < "u" && (P.line = d, P.column = _), P.setMessage(), Error.captureStackTrace && Error.captureStackTrace(f3(P), v), P;
            }
            var y = v.prototype;
            return y.setMessage = function() {
              this.message = this.plugin ? this.plugin + ": " : "", this.message += this.file ? this.file : "<css input>", typeof this.line < "u" && (this.message += ":" + this.line + ":" + this.column), this.message += ": " + this.reason;
            }, y.showSourceCode = function(d) {
              var _ = this;
              if (!this.source)
                return "";
              var S2 = this.source;
              a.default && (typeof d > "u" && (d = i2.default.isColorSupported), d && (S2 = (0, a.default)(S2)));
              var x2 = S2.split(/\r?\n/), N = Math.max(this.line - 3, 0), P = Math.min(this.line + 2, x2.length), W = String(P).length;
              function U(D) {
                return d && i2.default.red ? i2.default.red(i2.default.bold(D)) : D;
              }
              function H(D) {
                return d && i2.default.gray ? i2.default.gray(D) : D;
              }
              return x2.slice(N, P).map(function(D, $) {
                var B = N + 1 + $, O = " " + (" " + B).slice(-W) + " | ";
                if (B === _.line) {
                  var j = H(O.replace(/\d/g, " ")) + D.slice(0, _.column - 1).replace(/[^\t]/g, " ");
                  return U(">") + H(O) + D + `
 ` + j + U("^");
                }
                return " " + H(O) + D;
              }).join(`
`);
            }, y.toString = function() {
              var d = this.showSourceCode();
              return d && (d = `

` + d + `
`), this.name + ": " + this.message + d;
            }, v;
          }(h2(Error)), l = s2;
          e2.default = l, n.exports = e2.default;
        } }), xf = R({ "node_modules/postcss/lib/previous-map.js"(e2, n) {
          A2(), n.exports = class {
          };
        } }), _r = R({ "node_modules/postcss/lib/input.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = f3(wf()), a = f3(Xo()), o = f3(xf());
          function f3(r2) {
            return r2 && r2.__esModule ? r2 : { default: r2 };
          }
          function p(r2, u) {
            for (var s2 = 0; s2 < u.length; s2++) {
              var l = u[s2];
              l.enumerable = l.enumerable || false, l.configurable = true, "value" in l && (l.writable = true), Object.defineProperty(r2, l.key, l);
            }
          }
          function h2(r2, u, s2) {
            return u && p(r2.prototype, u), s2 && p(r2, s2), r2;
          }
          var g = 0, c = function() {
            function r2(s2, l) {
              if (l === void 0 && (l = {}), s2 === null || typeof s2 > "u" || typeof s2 == "object" && !s2.toString)
                throw new Error("PostCSS received " + s2 + " instead of CSS string");
              this.css = s2.toString(), this.css[0] === "\uFEFF" || this.css[0] === "\uFFFE" ? (this.hasBOM = true, this.css = this.css.slice(1)) : this.hasBOM = false, l.from && (/^\w+:\/\//.test(l.from) || i2.default.isAbsolute(l.from) ? this.file = l.from : this.file = i2.default.resolve(l.from));
              var m2 = new o.default(this.css, l);
              if (m2.text) {
                this.map = m2;
                var v = m2.consumer().file;
                !this.file && v && (this.file = this.mapResolve(v));
              }
              this.file || (g += 1, this.id = "<input css " + g + ">"), this.map && (this.map.file = this.from);
            }
            var u = r2.prototype;
            return u.error = function(l, m2, v, y) {
              y === void 0 && (y = {});
              var w, d = this.origin(m2, v);
              return d ? w = new a.default(l, d.line, d.column, d.source, d.file, y.plugin) : w = new a.default(l, m2, v, this.css, this.file, y.plugin), w.input = { line: m2, column: v, source: this.css }, this.file && (w.input.file = this.file), w;
            }, u.origin = function(l, m2) {
              if (!this.map)
                return false;
              var v = this.map.consumer(), y = v.originalPositionFor({ line: l, column: m2 });
              if (!y.source)
                return false;
              var w = { file: this.mapResolve(y.source), line: y.line, column: y.column }, d = v.sourceContentFor(y.source);
              return d && (w.source = d), w;
            }, u.mapResolve = function(l) {
              return /^\w+:\/\//.test(l) ? l : i2.default.resolve(this.map.consumer().sourceRoot || ".", l);
            }, h2(r2, [{ key: "from", get: function() {
              return this.file || this.id;
            } }]), r2;
          }(), t2 = c;
          e2.default = t2, n.exports = e2.default;
        } }), br = R({ "node_modules/postcss/lib/stringifier.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = { colon: ": ", indent: "    ", beforeDecl: `
`, beforeRule: `
`, beforeOpen: " ", beforeClose: `
`, beforeComment: `
`, after: `
`, emptyBody: "", commentLeft: " ", commentRight: " ", semicolon: false };
          function a(p) {
            return p[0].toUpperCase() + p.slice(1);
          }
          var o = function() {
            function p(g) {
              this.builder = g;
            }
            var h2 = p.prototype;
            return h2.stringify = function(c, t2) {
              this[c.type](c, t2);
            }, h2.root = function(c) {
              this.body(c), c.raws.after && this.builder(c.raws.after);
            }, h2.comment = function(c) {
              var t2 = this.raw(c, "left", "commentLeft"), r2 = this.raw(c, "right", "commentRight");
              this.builder("/*" + t2 + c.text + r2 + "*/", c);
            }, h2.decl = function(c, t2) {
              var r2 = this.raw(c, "between", "colon"), u = c.prop + r2 + this.rawValue(c, "value");
              c.important && (u += c.raws.important || " !important"), t2 && (u += ";"), this.builder(u, c);
            }, h2.rule = function(c) {
              this.block(c, this.rawValue(c, "selector")), c.raws.ownSemicolon && this.builder(c.raws.ownSemicolon, c, "end");
            }, h2.atrule = function(c, t2) {
              var r2 = "@" + c.name, u = c.params ? this.rawValue(c, "params") : "";
              if (typeof c.raws.afterName < "u" ? r2 += c.raws.afterName : u && (r2 += " "), c.nodes)
                this.block(c, r2 + u);
              else {
                var s2 = (c.raws.between || "") + (t2 ? ";" : "");
                this.builder(r2 + u + s2, c);
              }
            }, h2.body = function(c) {
              for (var t2 = c.nodes.length - 1; t2 > 0 && c.nodes[t2].type === "comment"; )
                t2 -= 1;
              for (var r2 = this.raw(c, "semicolon"), u = 0; u < c.nodes.length; u++) {
                var s2 = c.nodes[u], l = this.raw(s2, "before");
                l && this.builder(l), this.stringify(s2, t2 !== u || r2);
              }
            }, h2.block = function(c, t2) {
              var r2 = this.raw(c, "between", "beforeOpen");
              this.builder(t2 + r2 + "{", c, "start");
              var u;
              c.nodes && c.nodes.length ? (this.body(c), u = this.raw(c, "after")) : u = this.raw(c, "after", "emptyBody"), u && this.builder(u), this.builder("}", c, "end");
            }, h2.raw = function(c, t2, r2) {
              var u;
              if (r2 || (r2 = t2), t2 && (u = c.raws[t2], typeof u < "u"))
                return u;
              var s2 = c.parent;
              if (r2 === "before" && (!s2 || s2.type === "root" && s2.first === c))
                return "";
              if (!s2)
                return i2[r2];
              var l = c.root();
              if (l.rawCache || (l.rawCache = {}), typeof l.rawCache[r2] < "u")
                return l.rawCache[r2];
              if (r2 === "before" || r2 === "after")
                return this.beforeAfter(c, r2);
              var m2 = "raw" + a(r2);
              return this[m2] ? u = this[m2](l, c) : l.walk(function(v) {
                if (u = v.raws[t2], typeof u < "u")
                  return false;
              }), typeof u > "u" && (u = i2[r2]), l.rawCache[r2] = u, u;
            }, h2.rawSemicolon = function(c) {
              var t2;
              return c.walk(function(r2) {
                if (r2.nodes && r2.nodes.length && r2.last.type === "decl" && (t2 = r2.raws.semicolon, typeof t2 < "u"))
                  return false;
              }), t2;
            }, h2.rawEmptyBody = function(c) {
              var t2;
              return c.walk(function(r2) {
                if (r2.nodes && r2.nodes.length === 0 && (t2 = r2.raws.after, typeof t2 < "u"))
                  return false;
              }), t2;
            }, h2.rawIndent = function(c) {
              if (c.raws.indent)
                return c.raws.indent;
              var t2;
              return c.walk(function(r2) {
                var u = r2.parent;
                if (u && u !== c && u.parent && u.parent === c && typeof r2.raws.before < "u") {
                  var s2 = r2.raws.before.split(`
`);
                  return t2 = s2[s2.length - 1], t2 = t2.replace(/[^\s]/g, ""), false;
                }
              }), t2;
            }, h2.rawBeforeComment = function(c, t2) {
              var r2;
              return c.walkComments(function(u) {
                if (typeof u.raws.before < "u")
                  return r2 = u.raws.before, r2.indexOf(`
`) !== -1 && (r2 = r2.replace(/[^\n]+$/, "")), false;
              }), typeof r2 > "u" ? r2 = this.raw(t2, null, "beforeDecl") : r2 && (r2 = r2.replace(/[^\s]/g, "")), r2;
            }, h2.rawBeforeDecl = function(c, t2) {
              var r2;
              return c.walkDecls(function(u) {
                if (typeof u.raws.before < "u")
                  return r2 = u.raws.before, r2.indexOf(`
`) !== -1 && (r2 = r2.replace(/[^\n]+$/, "")), false;
              }), typeof r2 > "u" ? r2 = this.raw(t2, null, "beforeRule") : r2 && (r2 = r2.replace(/[^\s]/g, "")), r2;
            }, h2.rawBeforeRule = function(c) {
              var t2;
              return c.walk(function(r2) {
                if (r2.nodes && (r2.parent !== c || c.first !== r2) && typeof r2.raws.before < "u")
                  return t2 = r2.raws.before, t2.indexOf(`
`) !== -1 && (t2 = t2.replace(/[^\n]+$/, "")), false;
              }), t2 && (t2 = t2.replace(/[^\s]/g, "")), t2;
            }, h2.rawBeforeClose = function(c) {
              var t2;
              return c.walk(function(r2) {
                if (r2.nodes && r2.nodes.length > 0 && typeof r2.raws.after < "u")
                  return t2 = r2.raws.after, t2.indexOf(`
`) !== -1 && (t2 = t2.replace(/[^\n]+$/, "")), false;
              }), t2 && (t2 = t2.replace(/[^\s]/g, "")), t2;
            }, h2.rawBeforeOpen = function(c) {
              var t2;
              return c.walk(function(r2) {
                if (r2.type !== "decl" && (t2 = r2.raws.between, typeof t2 < "u"))
                  return false;
              }), t2;
            }, h2.rawColon = function(c) {
              var t2;
              return c.walkDecls(function(r2) {
                if (typeof r2.raws.between < "u")
                  return t2 = r2.raws.between.replace(/[^\s:]/g, ""), false;
              }), t2;
            }, h2.beforeAfter = function(c, t2) {
              var r2;
              c.type === "decl" ? r2 = this.raw(c, null, "beforeDecl") : c.type === "comment" ? r2 = this.raw(c, null, "beforeComment") : t2 === "before" ? r2 = this.raw(c, null, "beforeRule") : r2 = this.raw(c, null, "beforeClose");
              for (var u = c.parent, s2 = 0; u && u.type !== "root"; )
                s2 += 1, u = u.parent;
              if (r2.indexOf(`
`) !== -1) {
                var l = this.raw(c, null, "indent");
                if (l.length)
                  for (var m2 = 0; m2 < s2; m2++)
                    r2 += l;
              }
              return r2;
            }, h2.rawValue = function(c, t2) {
              var r2 = c[t2], u = c.raws[t2];
              return u && u.value === r2 ? u.raw : r2;
            }, p;
          }(), f3 = o;
          e2.default = f3, n.exports = e2.default;
        } }), Zo = R({ "node_modules/postcss/lib/stringify.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = a(br());
          function a(p) {
            return p && p.__esModule ? p : { default: p };
          }
          function o(p, h2) {
            var g = new i2.default(h2);
            g.stringify(p);
          }
          var f3 = o;
          e2.default = f3, n.exports = e2.default;
        } }), Dt = R({ "node_modules/postcss/lib/node.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = f3(Xo()), a = f3(br()), o = f3(Zo());
          function f3(c) {
            return c && c.__esModule ? c : { default: c };
          }
          function p(c, t2) {
            var r2 = new c.constructor();
            for (var u in c)
              if (!!c.hasOwnProperty(u)) {
                var s2 = c[u], l = typeof s2;
                u === "parent" && l === "object" ? t2 && (r2[u] = t2) : u === "source" ? r2[u] = s2 : s2 instanceof Array ? r2[u] = s2.map(function(m2) {
                  return p(m2, r2);
                }) : (l === "object" && s2 !== null && (s2 = p(s2)), r2[u] = s2);
              }
            return r2;
          }
          var h2 = function() {
            function c(r2) {
              r2 === void 0 && (r2 = {}), this.raws = {};
              for (var u in r2)
                this[u] = r2[u];
            }
            var t2 = c.prototype;
            return t2.error = function(u, s2) {
              if (s2 === void 0 && (s2 = {}), this.source) {
                var l = this.positionBy(s2);
                return this.source.input.error(u, l.line, l.column, s2);
              }
              return new i2.default(u);
            }, t2.warn = function(u, s2, l) {
              var m2 = { node: this };
              for (var v in l)
                m2[v] = l[v];
              return u.warn(s2, m2);
            }, t2.remove = function() {
              return this.parent && this.parent.removeChild(this), this.parent = void 0, this;
            }, t2.toString = function(u) {
              u === void 0 && (u = o.default), u.stringify && (u = u.stringify);
              var s2 = "";
              return u(this, function(l) {
                s2 += l;
              }), s2;
            }, t2.clone = function(u) {
              u === void 0 && (u = {});
              var s2 = p(this);
              for (var l in u)
                s2[l] = u[l];
              return s2;
            }, t2.cloneBefore = function(u) {
              u === void 0 && (u = {});
              var s2 = this.clone(u);
              return this.parent.insertBefore(this, s2), s2;
            }, t2.cloneAfter = function(u) {
              u === void 0 && (u = {});
              var s2 = this.clone(u);
              return this.parent.insertAfter(this, s2), s2;
            }, t2.replaceWith = function() {
              if (this.parent) {
                for (var u = arguments.length, s2 = new Array(u), l = 0; l < u; l++)
                  s2[l] = arguments[l];
                for (var m2 = 0, v = s2; m2 < v.length; m2++) {
                  var y = v[m2];
                  this.parent.insertBefore(this, y);
                }
                this.remove();
              }
              return this;
            }, t2.next = function() {
              if (!!this.parent) {
                var u = this.parent.index(this);
                return this.parent.nodes[u + 1];
              }
            }, t2.prev = function() {
              if (!!this.parent) {
                var u = this.parent.index(this);
                return this.parent.nodes[u - 1];
              }
            }, t2.before = function(u) {
              return this.parent.insertBefore(this, u), this;
            }, t2.after = function(u) {
              return this.parent.insertAfter(this, u), this;
            }, t2.toJSON = function() {
              var u = {};
              for (var s2 in this)
                if (!!this.hasOwnProperty(s2) && s2 !== "parent") {
                  var l = this[s2];
                  l instanceof Array ? u[s2] = l.map(function(m2) {
                    return typeof m2 == "object" && m2.toJSON ? m2.toJSON() : m2;
                  }) : typeof l == "object" && l.toJSON ? u[s2] = l.toJSON() : u[s2] = l;
                }
              return u;
            }, t2.raw = function(u, s2) {
              var l = new a.default();
              return l.raw(this, u, s2);
            }, t2.root = function() {
              for (var u = this; u.parent; )
                u = u.parent;
              return u;
            }, t2.cleanRaws = function(u) {
              delete this.raws.before, delete this.raws.after, u || delete this.raws.between;
            }, t2.positionInside = function(u) {
              for (var s2 = this.toString(), l = this.source.start.column, m2 = this.source.start.line, v = 0; v < u; v++)
                s2[v] === `
` ? (l = 1, m2 += 1) : l += 1;
              return { line: m2, column: l };
            }, t2.positionBy = function(u) {
              var s2 = this.source.start;
              if (u.index)
                s2 = this.positionInside(u.index);
              else if (u.word) {
                var l = this.toString().indexOf(u.word);
                l !== -1 && (s2 = this.positionInside(l));
              }
              return s2;
            }, c;
          }(), g = h2;
          e2.default = g, n.exports = e2.default;
        } }), xr = R({ "node_modules/postcss/lib/comment.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = a(Dt());
          function a(h2) {
            return h2 && h2.__esModule ? h2 : { default: h2 };
          }
          function o(h2, g) {
            h2.prototype = Object.create(g.prototype), h2.prototype.constructor = h2, h2.__proto__ = g;
          }
          var f3 = function(h2) {
            o(g, h2);
            function g(c) {
              var t2;
              return t2 = h2.call(this, c) || this, t2.type = "comment", t2;
            }
            return g;
          }(i2.default), p = f3;
          e2.default = p, n.exports = e2.default;
        } }), ea = R({ "node_modules/postcss/lib/declaration.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = a(Dt());
          function a(h2) {
            return h2 && h2.__esModule ? h2 : { default: h2 };
          }
          function o(h2, g) {
            h2.prototype = Object.create(g.prototype), h2.prototype.constructor = h2, h2.__proto__ = g;
          }
          var f3 = function(h2) {
            o(g, h2);
            function g(c) {
              var t2;
              return t2 = h2.call(this, c) || this, t2.type = "decl", t2;
            }
            return g;
          }(i2.default), p = f3;
          e2.default = p, n.exports = e2.default;
        } }), Lt = R({ "node_modules/postcss/lib/tokenize.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = W;
          var i2 = "'".charCodeAt(0), a = '"'.charCodeAt(0), o = "\\".charCodeAt(0), f3 = "/".charCodeAt(0), p = `
`.charCodeAt(0), h2 = " ".charCodeAt(0), g = "\f".charCodeAt(0), c = "	".charCodeAt(0), t2 = "\r".charCodeAt(0), r2 = "[".charCodeAt(0), u = "]".charCodeAt(0), s2 = "(".charCodeAt(0), l = ")".charCodeAt(0), m2 = "{".charCodeAt(0), v = "}".charCodeAt(0), y = ";".charCodeAt(0), w = "*".charCodeAt(0), d = ":".charCodeAt(0), _ = "@".charCodeAt(0), S2 = /[ \n\t\r\f{}()'"\\;/[\]#]/g, x2 = /[ \n\t\r\f(){}:;@!'"\\\][#]|\/(?=\*)/g, N = /.[\\/("'\n]/, P = /[a-f0-9]/i;
          function W(U, H) {
            H === void 0 && (H = {});
            var D = U.css.valueOf(), $ = H.ignoreErrors, B, O, j, C, I, X, Z2, Q, K, J, M, Y, G, E, k = D.length, b = -1, L = 1, q = 0, T = [], F2 = [];
            function z() {
              return q;
            }
            function re(te) {
              throw U.error("Unclosed " + te, L, q - b);
            }
            function ne() {
              return F2.length === 0 && q >= k;
            }
            function ce(te) {
              if (F2.length)
                return F2.pop();
              if (!(q >= k)) {
                var ie = te ? te.ignoreUnclosed : false;
                switch (B = D.charCodeAt(q), (B === p || B === g || B === t2 && D.charCodeAt(q + 1) !== p) && (b = q, L += 1), B) {
                  case p:
                  case h2:
                  case c:
                  case t2:
                  case g:
                    O = q;
                    do
                      O += 1, B = D.charCodeAt(O), B === p && (b = O, L += 1);
                    while (B === h2 || B === p || B === c || B === t2 || B === g);
                    E = ["space", D.slice(q, O)], q = O - 1;
                    break;
                  case r2:
                  case u:
                  case m2:
                  case v:
                  case d:
                  case y:
                  case l:
                    var ae = String.fromCharCode(B);
                    E = [ae, ae, L, q - b];
                    break;
                  case s2:
                    if (Y = T.length ? T.pop()[1] : "", G = D.charCodeAt(q + 1), Y === "url" && G !== i2 && G !== a && G !== h2 && G !== p && G !== c && G !== g && G !== t2) {
                      O = q;
                      do {
                        if (J = false, O = D.indexOf(")", O + 1), O === -1)
                          if ($ || ie) {
                            O = q;
                            break;
                          } else
                            re("bracket");
                        for (M = O; D.charCodeAt(M - 1) === o; )
                          M -= 1, J = !J;
                      } while (J);
                      E = ["brackets", D.slice(q, O + 1), L, q - b, L, O - b], q = O;
                    } else
                      O = D.indexOf(")", q + 1), X = D.slice(q, O + 1), O === -1 || N.test(X) ? E = ["(", "(", L, q - b] : (E = ["brackets", X, L, q - b, L, O - b], q = O);
                    break;
                  case i2:
                  case a:
                    j = B === i2 ? "'" : '"', O = q;
                    do {
                      if (J = false, O = D.indexOf(j, O + 1), O === -1)
                        if ($ || ie) {
                          O = q + 1;
                          break;
                        } else
                          re("string");
                      for (M = O; D.charCodeAt(M - 1) === o; )
                        M -= 1, J = !J;
                    } while (J);
                    X = D.slice(q, O + 1), C = X.split(`
`), I = C.length - 1, I > 0 ? (Q = L + I, K = O - C[I].length) : (Q = L, K = b), E = ["string", D.slice(q, O + 1), L, q - b, Q, O - K], b = K, L = Q, q = O;
                    break;
                  case _:
                    S2.lastIndex = q + 1, S2.test(D), S2.lastIndex === 0 ? O = D.length - 1 : O = S2.lastIndex - 2, E = ["at-word", D.slice(q, O + 1), L, q - b, L, O - b], q = O;
                    break;
                  case o:
                    for (O = q, Z2 = true; D.charCodeAt(O + 1) === o; )
                      O += 1, Z2 = !Z2;
                    if (B = D.charCodeAt(O + 1), Z2 && B !== f3 && B !== h2 && B !== p && B !== c && B !== t2 && B !== g && (O += 1, P.test(D.charAt(O)))) {
                      for (; P.test(D.charAt(O + 1)); )
                        O += 1;
                      D.charCodeAt(O + 1) === h2 && (O += 1);
                    }
                    E = ["word", D.slice(q, O + 1), L, q - b, L, O - b], q = O;
                    break;
                  default:
                    B === f3 && D.charCodeAt(q + 1) === w ? (O = D.indexOf("*/", q + 2) + 1, O === 0 && ($ || ie ? O = D.length : re("comment")), X = D.slice(q, O + 1), C = X.split(`
`), I = C.length - 1, I > 0 ? (Q = L + I, K = O - C[I].length) : (Q = L, K = b), E = ["comment", X, L, q - b, Q, O - K], b = K, L = Q, q = O) : (x2.lastIndex = q + 1, x2.test(D), x2.lastIndex === 0 ? O = D.length - 1 : O = x2.lastIndex - 2, E = ["word", D.slice(q, O + 1), L, q - b, L, O - b], T.push(E), q = O);
                    break;
                }
                return q++, E;
              }
            }
            function fe(te) {
              F2.push(te);
            }
            return { back: fe, nextToken: ce, endOfFile: ne, position: z };
          }
          n.exports = e2.default;
        } }), ra = R({ "node_modules/postcss/lib/parse.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = o(zt()), a = o(_r());
          function o(h2) {
            return h2 && h2.__esModule ? h2 : { default: h2 };
          }
          function f3(h2, g) {
            var c = new a.default(h2, g), t2 = new i2.default(c);
            try {
              t2.parse();
            } catch (r2) {
              throw r2;
            }
            return t2.root;
          }
          var p = f3;
          e2.default = p, n.exports = e2.default;
        } }), kf = R({ "node_modules/postcss/lib/list.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = { split: function(f3, p, h2) {
            for (var g = [], c = "", t2 = false, r2 = 0, u = false, s2 = false, l = 0; l < f3.length; l++) {
              var m2 = f3[l];
              u ? s2 ? s2 = false : m2 === "\\" ? s2 = true : m2 === u && (u = false) : m2 === '"' || m2 === "'" ? u = m2 : m2 === "(" ? r2 += 1 : m2 === ")" ? r2 > 0 && (r2 -= 1) : r2 === 0 && p.indexOf(m2) !== -1 && (t2 = true), t2 ? (c !== "" && g.push(c.trim()), c = "", t2 = false) : c += m2;
            }
            return (h2 || c !== "") && g.push(c.trim()), g;
          }, space: function(f3) {
            var p = [" ", `
`, "	"];
            return i2.split(f3, p);
          }, comma: function(f3) {
            return i2.split(f3, [","], true);
          } }, a = i2;
          e2.default = a, n.exports = e2.default;
        } }), ta = R({ "node_modules/postcss/lib/rule.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = o(kr()), a = o(kf());
          function o(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function f3(t2, r2) {
            for (var u = 0; u < r2.length; u++) {
              var s2 = r2[u];
              s2.enumerable = s2.enumerable || false, s2.configurable = true, "value" in s2 && (s2.writable = true), Object.defineProperty(t2, s2.key, s2);
            }
          }
          function p(t2, r2, u) {
            return r2 && f3(t2.prototype, r2), u && f3(t2, u), t2;
          }
          function h2(t2, r2) {
            t2.prototype = Object.create(r2.prototype), t2.prototype.constructor = t2, t2.__proto__ = r2;
          }
          var g = function(t2) {
            h2(r2, t2);
            function r2(u) {
              var s2;
              return s2 = t2.call(this, u) || this, s2.type = "rule", s2.nodes || (s2.nodes = []), s2;
            }
            return p(r2, [{ key: "selectors", get: function() {
              return a.default.comma(this.selector);
            }, set: function(s2) {
              var l = this.selector ? this.selector.match(/,\s*/) : null, m2 = l ? l[0] : "," + this.raw("between", "beforeOpen");
              this.selector = s2.join(m2);
            } }]), r2;
          }(i2.default), c = g;
          e2.default = c, n.exports = e2.default;
        } }), kr = R({ "node_modules/postcss/lib/container.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = f3(ea()), a = f3(xr()), o = f3(Dt());
          function f3(m2) {
            return m2 && m2.__esModule ? m2 : { default: m2 };
          }
          function p(m2, v) {
            var y;
            if (typeof Symbol > "u" || m2[Symbol.iterator] == null) {
              if (Array.isArray(m2) || (y = h2(m2)) || v && m2 && typeof m2.length == "number") {
                y && (m2 = y);
                var w = 0;
                return function() {
                  return w >= m2.length ? { done: true } : { done: false, value: m2[w++] };
                };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            return y = m2[Symbol.iterator](), y.next.bind(y);
          }
          function h2(m2, v) {
            if (!!m2) {
              if (typeof m2 == "string")
                return g(m2, v);
              var y = Object.prototype.toString.call(m2).slice(8, -1);
              if (y === "Object" && m2.constructor && (y = m2.constructor.name), y === "Map" || y === "Set")
                return Array.from(m2);
              if (y === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(y))
                return g(m2, v);
            }
          }
          function g(m2, v) {
            (v == null || v > m2.length) && (v = m2.length);
            for (var y = 0, w = new Array(v); y < v; y++)
              w[y] = m2[y];
            return w;
          }
          function c(m2, v) {
            for (var y = 0; y < v.length; y++) {
              var w = v[y];
              w.enumerable = w.enumerable || false, w.configurable = true, "value" in w && (w.writable = true), Object.defineProperty(m2, w.key, w);
            }
          }
          function t2(m2, v, y) {
            return v && c(m2.prototype, v), y && c(m2, y), m2;
          }
          function r2(m2, v) {
            m2.prototype = Object.create(v.prototype), m2.prototype.constructor = m2, m2.__proto__ = v;
          }
          function u(m2) {
            return m2.map(function(v) {
              return v.nodes && (v.nodes = u(v.nodes)), delete v.source, v;
            });
          }
          var s2 = function(m2) {
            r2(v, m2);
            function v() {
              return m2.apply(this, arguments) || this;
            }
            var y = v.prototype;
            return y.push = function(d) {
              return d.parent = this, this.nodes.push(d), this;
            }, y.each = function(d) {
              this.lastEach || (this.lastEach = 0), this.indexes || (this.indexes = {}), this.lastEach += 1;
              var _ = this.lastEach;
              if (this.indexes[_] = 0, !!this.nodes) {
                for (var S2, x2; this.indexes[_] < this.nodes.length && (S2 = this.indexes[_], x2 = d(this.nodes[S2], S2), x2 !== false); )
                  this.indexes[_] += 1;
                return delete this.indexes[_], x2;
              }
            }, y.walk = function(d) {
              return this.each(function(_, S2) {
                var x2;
                try {
                  x2 = d(_, S2);
                } catch (P) {
                  if (P.postcssNode = _, P.stack && _.source && /\n\s{4}at /.test(P.stack)) {
                    var N = _.source;
                    P.stack = P.stack.replace(/\n\s{4}at /, "$&" + N.input.from + ":" + N.start.line + ":" + N.start.column + "$&");
                  }
                  throw P;
                }
                return x2 !== false && _.walk && (x2 = _.walk(d)), x2;
              });
            }, y.walkDecls = function(d, _) {
              return _ ? d instanceof RegExp ? this.walk(function(S2, x2) {
                if (S2.type === "decl" && d.test(S2.prop))
                  return _(S2, x2);
              }) : this.walk(function(S2, x2) {
                if (S2.type === "decl" && S2.prop === d)
                  return _(S2, x2);
              }) : (_ = d, this.walk(function(S2, x2) {
                if (S2.type === "decl")
                  return _(S2, x2);
              }));
            }, y.walkRules = function(d, _) {
              return _ ? d instanceof RegExp ? this.walk(function(S2, x2) {
                if (S2.type === "rule" && d.test(S2.selector))
                  return _(S2, x2);
              }) : this.walk(function(S2, x2) {
                if (S2.type === "rule" && S2.selector === d)
                  return _(S2, x2);
              }) : (_ = d, this.walk(function(S2, x2) {
                if (S2.type === "rule")
                  return _(S2, x2);
              }));
            }, y.walkAtRules = function(d, _) {
              return _ ? d instanceof RegExp ? this.walk(function(S2, x2) {
                if (S2.type === "atrule" && d.test(S2.name))
                  return _(S2, x2);
              }) : this.walk(function(S2, x2) {
                if (S2.type === "atrule" && S2.name === d)
                  return _(S2, x2);
              }) : (_ = d, this.walk(function(S2, x2) {
                if (S2.type === "atrule")
                  return _(S2, x2);
              }));
            }, y.walkComments = function(d) {
              return this.walk(function(_, S2) {
                if (_.type === "comment")
                  return d(_, S2);
              });
            }, y.append = function() {
              for (var d = arguments.length, _ = new Array(d), S2 = 0; S2 < d; S2++)
                _[S2] = arguments[S2];
              for (var x2 = 0, N = _; x2 < N.length; x2++)
                for (var P = N[x2], W = this.normalize(P, this.last), U = p(W), H; !(H = U()).done; ) {
                  var D = H.value;
                  this.nodes.push(D);
                }
              return this;
            }, y.prepend = function() {
              for (var d = arguments.length, _ = new Array(d), S2 = 0; S2 < d; S2++)
                _[S2] = arguments[S2];
              _ = _.reverse();
              for (var x2 = p(_), N; !(N = x2()).done; ) {
                for (var P = N.value, W = this.normalize(P, this.first, "prepend").reverse(), U = p(W), H; !(H = U()).done; ) {
                  var D = H.value;
                  this.nodes.unshift(D);
                }
                for (var $ in this.indexes)
                  this.indexes[$] = this.indexes[$] + W.length;
              }
              return this;
            }, y.cleanRaws = function(d) {
              if (m2.prototype.cleanRaws.call(this, d), this.nodes)
                for (var _ = p(this.nodes), S2; !(S2 = _()).done; ) {
                  var x2 = S2.value;
                  x2.cleanRaws(d);
                }
            }, y.insertBefore = function(d, _) {
              d = this.index(d);
              for (var S2 = d === 0 ? "prepend" : false, x2 = this.normalize(_, this.nodes[d], S2).reverse(), N = p(x2), P; !(P = N()).done; ) {
                var W = P.value;
                this.nodes.splice(d, 0, W);
              }
              var U;
              for (var H in this.indexes)
                U = this.indexes[H], d <= U && (this.indexes[H] = U + x2.length);
              return this;
            }, y.insertAfter = function(d, _) {
              d = this.index(d);
              for (var S2 = this.normalize(_, this.nodes[d]).reverse(), x2 = p(S2), N; !(N = x2()).done; ) {
                var P = N.value;
                this.nodes.splice(d + 1, 0, P);
              }
              var W;
              for (var U in this.indexes)
                W = this.indexes[U], d < W && (this.indexes[U] = W + S2.length);
              return this;
            }, y.removeChild = function(d) {
              d = this.index(d), this.nodes[d].parent = void 0, this.nodes.splice(d, 1);
              var _;
              for (var S2 in this.indexes)
                _ = this.indexes[S2], _ >= d && (this.indexes[S2] = _ - 1);
              return this;
            }, y.removeAll = function() {
              for (var d = p(this.nodes), _; !(_ = d()).done; ) {
                var S2 = _.value;
                S2.parent = void 0;
              }
              return this.nodes = [], this;
            }, y.replaceValues = function(d, _, S2) {
              return S2 || (S2 = _, _ = {}), this.walkDecls(function(x2) {
                _.props && _.props.indexOf(x2.prop) === -1 || _.fast && x2.value.indexOf(_.fast) === -1 || (x2.value = x2.value.replace(d, S2));
              }), this;
            }, y.every = function(d) {
              return this.nodes.every(d);
            }, y.some = function(d) {
              return this.nodes.some(d);
            }, y.index = function(d) {
              return typeof d == "number" ? d : this.nodes.indexOf(d);
            }, y.normalize = function(d, _) {
              var S2 = this;
              if (typeof d == "string") {
                var x2 = ra();
                d = u(x2(d).nodes);
              } else if (Array.isArray(d)) {
                d = d.slice(0);
                for (var N = p(d), P; !(P = N()).done; ) {
                  var W = P.value;
                  W.parent && W.parent.removeChild(W, "ignore");
                }
              } else if (d.type === "root") {
                d = d.nodes.slice(0);
                for (var U = p(d), H; !(H = U()).done; ) {
                  var D = H.value;
                  D.parent && D.parent.removeChild(D, "ignore");
                }
              } else if (d.type)
                d = [d];
              else if (d.prop) {
                if (typeof d.value > "u")
                  throw new Error("Value field is missed in node creation");
                typeof d.value != "string" && (d.value = String(d.value)), d = [new i2.default(d)];
              } else if (d.selector) {
                var $ = ta();
                d = [new $(d)];
              } else if (d.name) {
                var B = na();
                d = [new B(d)];
              } else if (d.text)
                d = [new a.default(d)];
              else
                throw new Error("Unknown node type in node creation");
              var O = d.map(function(j) {
                return j.parent && j.parent.removeChild(j), typeof j.raws.before > "u" && _ && typeof _.raws.before < "u" && (j.raws.before = _.raws.before.replace(/[^\s]/g, "")), j.parent = S2, j;
              });
              return O;
            }, t2(v, [{ key: "first", get: function() {
              if (!!this.nodes)
                return this.nodes[0];
            } }, { key: "last", get: function() {
              if (!!this.nodes)
                return this.nodes[this.nodes.length - 1];
            } }]), v;
          }(o.default), l = s2;
          e2.default = l, n.exports = e2.default;
        } }), na = R({ "node_modules/postcss/lib/at-rule.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = a(kr());
          function a(h2) {
            return h2 && h2.__esModule ? h2 : { default: h2 };
          }
          function o(h2, g) {
            h2.prototype = Object.create(g.prototype), h2.prototype.constructor = h2, h2.__proto__ = g;
          }
          var f3 = function(h2) {
            o(g, h2);
            function g(t2) {
              var r2;
              return r2 = h2.call(this, t2) || this, r2.type = "atrule", r2;
            }
            var c = g.prototype;
            return c.append = function() {
              var r2;
              this.nodes || (this.nodes = []);
              for (var u = arguments.length, s2 = new Array(u), l = 0; l < u; l++)
                s2[l] = arguments[l];
              return (r2 = h2.prototype.append).call.apply(r2, [this].concat(s2));
            }, c.prepend = function() {
              var r2;
              this.nodes || (this.nodes = []);
              for (var u = arguments.length, s2 = new Array(u), l = 0; l < u; l++)
                s2[l] = arguments[l];
              return (r2 = h2.prototype.prepend).call.apply(r2, [this].concat(s2));
            }, g;
          }(i2.default), p = f3;
          e2.default = p, n.exports = e2.default;
        } }), Sf = R({ "node_modules/postcss/lib/map-generator.js"(e2, n) {
          A2(), n.exports = class {
            generate() {
            }
          };
        } }), Of = R({ "node_modules/postcss/lib/warn-once.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = a;
          var i2 = {};
          function a(o) {
            i2[o] || (i2[o] = true, typeof console < "u" && console.warn && console.warn(o));
          }
          n.exports = e2.default;
        } }), Tf = R({ "node_modules/postcss/lib/warning.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = function() {
            function o(p, h2) {
              if (h2 === void 0 && (h2 = {}), this.type = "warning", this.text = p, h2.node && h2.node.source) {
                var g = h2.node.positionBy(h2);
                this.line = g.line, this.column = g.column;
              }
              for (var c in h2)
                this[c] = h2[c];
            }
            var f3 = o.prototype;
            return f3.toString = function() {
              return this.node ? this.node.error(this.text, { plugin: this.plugin, index: this.index, word: this.word }).message : this.plugin ? this.plugin + ": " + this.text : this.text;
            }, o;
          }(), a = i2;
          e2.default = a, n.exports = e2.default;
        } }), Ef = R({ "node_modules/postcss/lib/result.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = a(Tf());
          function a(g) {
            return g && g.__esModule ? g : { default: g };
          }
          function o(g, c) {
            for (var t2 = 0; t2 < c.length; t2++) {
              var r2 = c[t2];
              r2.enumerable = r2.enumerable || false, r2.configurable = true, "value" in r2 && (r2.writable = true), Object.defineProperty(g, r2.key, r2);
            }
          }
          function f3(g, c, t2) {
            return c && o(g.prototype, c), t2 && o(g, t2), g;
          }
          var p = function() {
            function g(t2, r2, u) {
              this.processor = t2, this.messages = [], this.root = r2, this.opts = u, this.css = void 0, this.map = void 0;
            }
            var c = g.prototype;
            return c.toString = function() {
              return this.css;
            }, c.warn = function(r2, u) {
              u === void 0 && (u = {}), u.plugin || this.lastPlugin && this.lastPlugin.postcssPlugin && (u.plugin = this.lastPlugin.postcssPlugin);
              var s2 = new i2.default(r2, u);
              return this.messages.push(s2), s2;
            }, c.warnings = function() {
              return this.messages.filter(function(r2) {
                return r2.type === "warning";
              });
            }, f3(g, [{ key: "content", get: function() {
              return this.css;
            } }]), g;
          }(), h2 = p;
          e2.default = h2, n.exports = e2.default;
        } }), ia = R({ "node_modules/postcss/lib/lazy-result.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = h2(Sf()), a = h2(Zo()), o = h2(Of()), f3 = h2(Ef()), p = h2(ra());
          function h2(v) {
            return v && v.__esModule ? v : { default: v };
          }
          function g(v, y) {
            var w;
            if (typeof Symbol > "u" || v[Symbol.iterator] == null) {
              if (Array.isArray(v) || (w = c(v)) || y && v && typeof v.length == "number") {
                w && (v = w);
                var d = 0;
                return function() {
                  return d >= v.length ? { done: true } : { done: false, value: v[d++] };
                };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            return w = v[Symbol.iterator](), w.next.bind(w);
          }
          function c(v, y) {
            if (!!v) {
              if (typeof v == "string")
                return t2(v, y);
              var w = Object.prototype.toString.call(v).slice(8, -1);
              if (w === "Object" && v.constructor && (w = v.constructor.name), w === "Map" || w === "Set")
                return Array.from(v);
              if (w === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(w))
                return t2(v, y);
            }
          }
          function t2(v, y) {
            (y == null || y > v.length) && (y = v.length);
            for (var w = 0, d = new Array(y); w < y; w++)
              d[w] = v[w];
            return d;
          }
          function r2(v, y) {
            for (var w = 0; w < y.length; w++) {
              var d = y[w];
              d.enumerable = d.enumerable || false, d.configurable = true, "value" in d && (d.writable = true), Object.defineProperty(v, d.key, d);
            }
          }
          function u(v, y, w) {
            return y && r2(v.prototype, y), w && r2(v, w), v;
          }
          function s2(v) {
            return typeof v == "object" && typeof v.then == "function";
          }
          var l = function() {
            function v(w, d, _) {
              this.stringified = false, this.processed = false;
              var S2;
              if (typeof d == "object" && d !== null && d.type === "root")
                S2 = d;
              else if (d instanceof v || d instanceof f3.default)
                S2 = d.root, d.map && (typeof _.map > "u" && (_.map = {}), _.map.inline || (_.map.inline = false), _.map.prev = d.map);
              else {
                var x2 = p.default;
                _.syntax && (x2 = _.syntax.parse), _.parser && (x2 = _.parser), x2.parse && (x2 = x2.parse);
                try {
                  S2 = x2(d, _);
                } catch (N) {
                  this.error = N;
                }
              }
              this.result = new f3.default(w, S2, _);
            }
            var y = v.prototype;
            return y.warnings = function() {
              return this.sync().warnings();
            }, y.toString = function() {
              return this.css;
            }, y.then = function(d, _) {
              return this.async().then(d, _);
            }, y.catch = function(d) {
              return this.async().catch(d);
            }, y.finally = function(d) {
              return this.async().then(d, d);
            }, y.handleError = function(d, _) {
              try {
                if (this.error = d, d.name === "CssSyntaxError" && !d.plugin)
                  d.plugin = _.postcssPlugin, d.setMessage();
                else if (_.postcssVersion && false)
                  var S2, x2, N, P, W;
              } catch (U) {
                console && console.error && console.error(U);
              }
            }, y.asyncTick = function(d, _) {
              var S2 = this;
              if (this.plugin >= this.processor.plugins.length)
                return this.processed = true, d();
              try {
                var x2 = this.processor.plugins[this.plugin], N = this.run(x2);
                this.plugin += 1, s2(N) ? N.then(function() {
                  S2.asyncTick(d, _);
                }).catch(function(P) {
                  S2.handleError(P, x2), S2.processed = true, _(P);
                }) : this.asyncTick(d, _);
              } catch (P) {
                this.processed = true, _(P);
              }
            }, y.async = function() {
              var d = this;
              return this.processed ? new Promise(function(_, S2) {
                d.error ? S2(d.error) : _(d.stringify());
              }) : this.processing ? this.processing : (this.processing = new Promise(function(_, S2) {
                if (d.error)
                  return S2(d.error);
                d.plugin = 0, d.asyncTick(_, S2);
              }).then(function() {
                return d.processed = true, d.stringify();
              }), this.processing);
            }, y.sync = function() {
              if (this.processed)
                return this.result;
              if (this.processed = true, this.processing)
                throw new Error("Use process(css).then(cb) to work with async plugins");
              if (this.error)
                throw this.error;
              for (var d = g(this.result.processor.plugins), _; !(_ = d()).done; ) {
                var S2 = _.value, x2 = this.run(S2);
                if (s2(x2))
                  throw new Error("Use process(css).then(cb) to work with async plugins");
              }
              return this.result;
            }, y.run = function(d) {
              this.result.lastPlugin = d;
              try {
                return d(this.result.root, this.result);
              } catch (_) {
                throw this.handleError(_, d), _;
              }
            }, y.stringify = function() {
              if (this.stringified)
                return this.result;
              this.stringified = true, this.sync();
              var d = this.result.opts, _ = a.default;
              d.syntax && (_ = d.syntax.stringify), d.stringifier && (_ = d.stringifier), _.stringify && (_ = _.stringify);
              var S2 = new i2.default(_, this.result.root, this.result.opts), x2 = S2.generate();
              return this.result.css = x2[0], this.result.map = x2[1], this.result;
            }, u(v, [{ key: "processor", get: function() {
              return this.result.processor;
            } }, { key: "opts", get: function() {
              return this.result.opts;
            } }, { key: "css", get: function() {
              return this.stringify().css;
            } }, { key: "content", get: function() {
              return this.stringify().content;
            } }, { key: "map", get: function() {
              return this.stringify().map;
            } }, { key: "root", get: function() {
              return this.sync().root;
            } }, { key: "messages", get: function() {
              return this.sync().messages;
            } }]), v;
          }(), m2 = l;
          e2.default = m2, n.exports = e2.default;
        } }), qf = R({ "node_modules/postcss/lib/processor.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = a(ia());
          function a(c) {
            return c && c.__esModule ? c : { default: c };
          }
          function o(c, t2) {
            var r2;
            if (typeof Symbol > "u" || c[Symbol.iterator] == null) {
              if (Array.isArray(c) || (r2 = f3(c)) || t2 && c && typeof c.length == "number") {
                r2 && (c = r2);
                var u = 0;
                return function() {
                  return u >= c.length ? { done: true } : { done: false, value: c[u++] };
                };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            return r2 = c[Symbol.iterator](), r2.next.bind(r2);
          }
          function f3(c, t2) {
            if (!!c) {
              if (typeof c == "string")
                return p(c, t2);
              var r2 = Object.prototype.toString.call(c).slice(8, -1);
              if (r2 === "Object" && c.constructor && (r2 = c.constructor.name), r2 === "Map" || r2 === "Set")
                return Array.from(c);
              if (r2 === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r2))
                return p(c, t2);
            }
          }
          function p(c, t2) {
            (t2 == null || t2 > c.length) && (t2 = c.length);
            for (var r2 = 0, u = new Array(t2); r2 < t2; r2++)
              u[r2] = c[r2];
            return u;
          }
          var h2 = function() {
            function c(r2) {
              r2 === void 0 && (r2 = []), this.version = "7.0.39", this.plugins = this.normalize(r2);
            }
            var t2 = c.prototype;
            return t2.use = function(u) {
              return this.plugins = this.plugins.concat(this.normalize([u])), this;
            }, t2.process = function(r2) {
              function u(s2) {
                return r2.apply(this, arguments);
              }
              return u.toString = function() {
                return r2.toString();
              }, u;
            }(function(r2, u) {
              return u === void 0 && (u = {}), this.plugins.length === 0 && (u.parser, u.stringifier), new i2.default(this, r2, u);
            }), t2.normalize = function(u) {
              for (var s2 = [], l = o(u), m2; !(m2 = l()).done; ) {
                var v = m2.value;
                if (v.postcss === true) {
                  var y = v();
                  throw new Error("PostCSS plugin " + y.postcssPlugin + ` requires PostCSS 8.
Migration guide for end-users:
https://github.com/postcss/postcss/wiki/PostCSS-8-for-end-users`);
                }
                if (v.postcss && (v = v.postcss), typeof v == "object" && Array.isArray(v.plugins))
                  s2 = s2.concat(v.plugins);
                else if (typeof v == "function")
                  s2.push(v);
                else if (!(typeof v == "object" && (v.parse || v.stringify)))
                  throw typeof v == "object" && v.postcssPlugin ? new Error("PostCSS plugin " + v.postcssPlugin + ` requires PostCSS 8.
Migration guide for end-users:
https://github.com/postcss/postcss/wiki/PostCSS-8-for-end-users`) : new Error(v + " is not a PostCSS plugin");
              }
              return s2;
            }, c;
          }(), g = h2;
          e2.default = g, n.exports = e2.default;
        } }), Af = R({ "node_modules/postcss/lib/root.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = a(kr());
          function a(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          function o(t2, r2) {
            var u;
            if (typeof Symbol > "u" || t2[Symbol.iterator] == null) {
              if (Array.isArray(t2) || (u = f3(t2)) || r2 && t2 && typeof t2.length == "number") {
                u && (t2 = u);
                var s2 = 0;
                return function() {
                  return s2 >= t2.length ? { done: true } : { done: false, value: t2[s2++] };
                };
              }
              throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
            }
            return u = t2[Symbol.iterator](), u.next.bind(u);
          }
          function f3(t2, r2) {
            if (!!t2) {
              if (typeof t2 == "string")
                return p(t2, r2);
              var u = Object.prototype.toString.call(t2).slice(8, -1);
              if (u === "Object" && t2.constructor && (u = t2.constructor.name), u === "Map" || u === "Set")
                return Array.from(t2);
              if (u === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(u))
                return p(t2, r2);
            }
          }
          function p(t2, r2) {
            (r2 == null || r2 > t2.length) && (r2 = t2.length);
            for (var u = 0, s2 = new Array(r2); u < r2; u++)
              s2[u] = t2[u];
            return s2;
          }
          function h2(t2, r2) {
            t2.prototype = Object.create(r2.prototype), t2.prototype.constructor = t2, t2.__proto__ = r2;
          }
          var g = function(t2) {
            h2(r2, t2);
            function r2(s2) {
              var l;
              return l = t2.call(this, s2) || this, l.type = "root", l.nodes || (l.nodes = []), l;
            }
            var u = r2.prototype;
            return u.removeChild = function(l, m2) {
              var v = this.index(l);
              return !m2 && v === 0 && this.nodes.length > 1 && (this.nodes[1].raws.before = this.nodes[v].raws.before), t2.prototype.removeChild.call(this, l);
            }, u.normalize = function(l, m2, v) {
              var y = t2.prototype.normalize.call(this, l);
              if (m2) {
                if (v === "prepend")
                  this.nodes.length > 1 ? m2.raws.before = this.nodes[1].raws.before : delete m2.raws.before;
                else if (this.first !== m2)
                  for (var w = o(y), d; !(d = w()).done; ) {
                    var _ = d.value;
                    _.raws.before = m2.raws.before;
                  }
              }
              return y;
            }, u.toResult = function(l) {
              l === void 0 && (l = {});
              var m2 = ia(), v = qf(), y = new m2(new v(), this, l);
              return y.stringify();
            }, r2;
          }(i2.default), c = g;
          e2.default = c, n.exports = e2.default;
        } }), zt = R({ "node_modules/postcss/lib/parser.js"(e2, n) {
          "use strict";
          A2(), e2.__esModule = true, e2.default = void 0;
          var i2 = g(ea()), a = g(Lt()), o = g(xr()), f3 = g(na()), p = g(Af()), h2 = g(ta());
          function g(t2) {
            return t2 && t2.__esModule ? t2 : { default: t2 };
          }
          var c = function() {
            function t2(u) {
              this.input = u, this.root = new p.default(), this.current = this.root, this.spaces = "", this.semicolon = false, this.createTokenizer(), this.root.source = { input: u, start: { line: 1, column: 1 } };
            }
            var r2 = t2.prototype;
            return r2.createTokenizer = function() {
              this.tokenizer = (0, a.default)(this.input);
            }, r2.parse = function() {
              for (var s2; !this.tokenizer.endOfFile(); )
                switch (s2 = this.tokenizer.nextToken(), s2[0]) {
                  case "space":
                    this.spaces += s2[1];
                    break;
                  case ";":
                    this.freeSemicolon(s2);
                    break;
                  case "}":
                    this.end(s2);
                    break;
                  case "comment":
                    this.comment(s2);
                    break;
                  case "at-word":
                    this.atrule(s2);
                    break;
                  case "{":
                    this.emptyRule(s2);
                    break;
                  default:
                    this.other(s2);
                    break;
                }
              this.endFile();
            }, r2.comment = function(s2) {
              var l = new o.default();
              this.init(l, s2[2], s2[3]), l.source.end = { line: s2[4], column: s2[5] };
              var m2 = s2[1].slice(2, -2);
              if (/^\s*$/.test(m2))
                l.text = "", l.raws.left = m2, l.raws.right = "";
              else {
                var v = m2.match(/^(\s*)([^]*[^\s])(\s*)$/);
                l.text = v[2], l.raws.left = v[1], l.raws.right = v[3];
              }
            }, r2.emptyRule = function(s2) {
              var l = new h2.default();
              this.init(l, s2[2], s2[3]), l.selector = "", l.raws.between = "", this.current = l;
            }, r2.other = function(s2) {
              for (var l = false, m2 = null, v = false, y = null, w = [], d = [], _ = s2; _; ) {
                if (m2 = _[0], d.push(_), m2 === "(" || m2 === "[")
                  y || (y = _), w.push(m2 === "(" ? ")" : "]");
                else if (w.length === 0)
                  if (m2 === ";")
                    if (v) {
                      this.decl(d);
                      return;
                    } else
                      break;
                  else if (m2 === "{") {
                    this.rule(d);
                    return;
                  } else if (m2 === "}") {
                    this.tokenizer.back(d.pop()), l = true;
                    break;
                  } else
                    m2 === ":" && (v = true);
                else
                  m2 === w[w.length - 1] && (w.pop(), w.length === 0 && (y = null));
                _ = this.tokenizer.nextToken();
              }
              if (this.tokenizer.endOfFile() && (l = true), w.length > 0 && this.unclosedBracket(y), l && v) {
                for (; d.length && (_ = d[d.length - 1][0], !(_ !== "space" && _ !== "comment")); )
                  this.tokenizer.back(d.pop());
                this.decl(d);
              } else
                this.unknownWord(d);
            }, r2.rule = function(s2) {
              s2.pop();
              var l = new h2.default();
              this.init(l, s2[0][2], s2[0][3]), l.raws.between = this.spacesAndCommentsFromEnd(s2), this.raw(l, "selector", s2), this.current = l;
            }, r2.decl = function(s2) {
              var l = new i2.default();
              this.init(l);
              var m2 = s2[s2.length - 1];
              for (m2[0] === ";" && (this.semicolon = true, s2.pop()), m2[4] ? l.source.end = { line: m2[4], column: m2[5] } : l.source.end = { line: m2[2], column: m2[3] }; s2[0][0] !== "word"; )
                s2.length === 1 && this.unknownWord(s2), l.raws.before += s2.shift()[1];
              for (l.source.start = { line: s2[0][2], column: s2[0][3] }, l.prop = ""; s2.length; ) {
                var v = s2[0][0];
                if (v === ":" || v === "space" || v === "comment")
                  break;
                l.prop += s2.shift()[1];
              }
              l.raws.between = "";
              for (var y; s2.length; )
                if (y = s2.shift(), y[0] === ":") {
                  l.raws.between += y[1];
                  break;
                } else
                  y[0] === "word" && /\w/.test(y[1]) && this.unknownWord([y]), l.raws.between += y[1];
              (l.prop[0] === "_" || l.prop[0] === "*") && (l.raws.before += l.prop[0], l.prop = l.prop.slice(1)), l.raws.between += this.spacesAndCommentsFromStart(s2), this.precheckMissedSemicolon(s2);
              for (var w = s2.length - 1; w > 0; w--) {
                if (y = s2[w], y[1].toLowerCase() === "!important") {
                  l.important = true;
                  var d = this.stringFrom(s2, w);
                  d = this.spacesFromEnd(s2) + d, d !== " !important" && (l.raws.important = d);
                  break;
                } else if (y[1].toLowerCase() === "important") {
                  for (var _ = s2.slice(0), S2 = "", x2 = w; x2 > 0; x2--) {
                    var N = _[x2][0];
                    if (S2.trim().indexOf("!") === 0 && N !== "space")
                      break;
                    S2 = _.pop()[1] + S2;
                  }
                  S2.trim().indexOf("!") === 0 && (l.important = true, l.raws.important = S2, s2 = _);
                }
                if (y[0] !== "space" && y[0] !== "comment")
                  break;
              }
              this.raw(l, "value", s2), l.value.indexOf(":") !== -1 && this.checkMissedSemicolon(s2);
            }, r2.atrule = function(s2) {
              var l = new f3.default();
              l.name = s2[1].slice(1), l.name === "" && this.unnamedAtrule(l, s2), this.init(l, s2[2], s2[3]);
              for (var m2, v, y = false, w = false, d = []; !this.tokenizer.endOfFile(); ) {
                if (s2 = this.tokenizer.nextToken(), s2[0] === ";") {
                  l.source.end = { line: s2[2], column: s2[3] }, this.semicolon = true;
                  break;
                } else if (s2[0] === "{") {
                  w = true;
                  break;
                } else if (s2[0] === "}") {
                  if (d.length > 0) {
                    for (v = d.length - 1, m2 = d[v]; m2 && m2[0] === "space"; )
                      m2 = d[--v];
                    m2 && (l.source.end = { line: m2[4], column: m2[5] });
                  }
                  this.end(s2);
                  break;
                } else
                  d.push(s2);
                if (this.tokenizer.endOfFile()) {
                  y = true;
                  break;
                }
              }
              l.raws.between = this.spacesAndCommentsFromEnd(d), d.length ? (l.raws.afterName = this.spacesAndCommentsFromStart(d), this.raw(l, "params", d), y && (s2 = d[d.length - 1], l.source.end = { line: s2[4], column: s2[5] }, this.spaces = l.raws.between, l.raws.between = "")) : (l.raws.afterName = "", l.params = ""), w && (l.nodes = [], this.current = l);
            }, r2.end = function(s2) {
              this.current.nodes && this.current.nodes.length && (this.current.raws.semicolon = this.semicolon), this.semicolon = false, this.current.raws.after = (this.current.raws.after || "") + this.spaces, this.spaces = "", this.current.parent ? (this.current.source.end = { line: s2[2], column: s2[3] }, this.current = this.current.parent) : this.unexpectedClose(s2);
            }, r2.endFile = function() {
              this.current.parent && this.unclosedBlock(), this.current.nodes && this.current.nodes.length && (this.current.raws.semicolon = this.semicolon), this.current.raws.after = (this.current.raws.after || "") + this.spaces;
            }, r2.freeSemicolon = function(s2) {
              if (this.spaces += s2[1], this.current.nodes) {
                var l = this.current.nodes[this.current.nodes.length - 1];
                l && l.type === "rule" && !l.raws.ownSemicolon && (l.raws.ownSemicolon = this.spaces, this.spaces = "");
              }
            }, r2.init = function(s2, l, m2) {
              this.current.push(s2), s2.source = { start: { line: l, column: m2 }, input: this.input }, s2.raws.before = this.spaces, this.spaces = "", s2.type !== "comment" && (this.semicolon = false);
            }, r2.raw = function(s2, l, m2) {
              for (var v, y, w = m2.length, d = "", _ = true, S2, x2, N = /^([.|#])?([\w])+/i, P = 0; P < w; P += 1) {
                if (v = m2[P], y = v[0], y === "comment" && s2.type === "rule") {
                  x2 = m2[P - 1], S2 = m2[P + 1], x2[0] !== "space" && S2[0] !== "space" && N.test(x2[1]) && N.test(S2[1]) ? d += v[1] : _ = false;
                  continue;
                }
                y === "comment" || y === "space" && P === w - 1 ? _ = false : d += v[1];
              }
              if (!_) {
                var W = m2.reduce(function(U, H) {
                  return U + H[1];
                }, "");
                s2.raws[l] = { value: d, raw: W };
              }
              s2[l] = d;
            }, r2.spacesAndCommentsFromEnd = function(s2) {
              for (var l, m2 = ""; s2.length && (l = s2[s2.length - 1][0], !(l !== "space" && l !== "comment")); )
                m2 = s2.pop()[1] + m2;
              return m2;
            }, r2.spacesAndCommentsFromStart = function(s2) {
              for (var l, m2 = ""; s2.length && (l = s2[0][0], !(l !== "space" && l !== "comment")); )
                m2 += s2.shift()[1];
              return m2;
            }, r2.spacesFromEnd = function(s2) {
              for (var l, m2 = ""; s2.length && (l = s2[s2.length - 1][0], l === "space"); )
                m2 = s2.pop()[1] + m2;
              return m2;
            }, r2.stringFrom = function(s2, l) {
              for (var m2 = "", v = l; v < s2.length; v++)
                m2 += s2[v][1];
              return s2.splice(l, s2.length - l), m2;
            }, r2.colon = function(s2) {
              for (var l = 0, m2, v, y, w = 0; w < s2.length; w++) {
                if (m2 = s2[w], v = m2[0], v === "(" && (l += 1), v === ")" && (l -= 1), l === 0 && v === ":")
                  if (!y)
                    this.doubleColon(m2);
                  else {
                    if (y[0] === "word" && y[1] === "progid")
                      continue;
                    return w;
                  }
                y = m2;
              }
              return false;
            }, r2.unclosedBracket = function(s2) {
              throw this.input.error("Unclosed bracket", s2[2], s2[3]);
            }, r2.unknownWord = function(s2) {
              throw this.input.error("Unknown word", s2[0][2], s2[0][3]);
            }, r2.unexpectedClose = function(s2) {
              throw this.input.error("Unexpected }", s2[2], s2[3]);
            }, r2.unclosedBlock = function() {
              var s2 = this.current.source.start;
              throw this.input.error("Unclosed block", s2.line, s2.column);
            }, r2.doubleColon = function(s2) {
              throw this.input.error("Double colon", s2[2], s2[3]);
            }, r2.unnamedAtrule = function(s2, l) {
              throw this.input.error("At-rule without name", l[2], l[3]);
            }, r2.precheckMissedSemicolon = function() {
            }, r2.checkMissedSemicolon = function(s2) {
              var l = this.colon(s2);
              if (l !== false) {
                for (var m2 = 0, v, y = l - 1; y >= 0 && (v = s2[y], !(v[0] !== "space" && (m2 += 1, m2 === 2))); y--)
                  ;
                throw this.input.error("Missed semicolon", v[2], v[3]);
              }
            }, t2;
          }();
          e2.default = c, n.exports = e2.default;
        } }), Pf = R({ "node_modules/postcss-less/lib/nodes/inline-comment.js"(e2, n) {
          A2();
          var i2 = Lt(), a = _r();
          n.exports = { isInlineComment(o) {
            if (o[0] === "word" && o[1].slice(0, 2) === "//") {
              let f3 = o, p = [], h2;
              for (; o; ) {
                if (/\r?\n/.test(o[1])) {
                  if (/['"].*\r?\n/.test(o[1])) {
                    p.push(o[1].substring(0, o[1].indexOf(`
`)));
                    let c = o[1].substring(o[1].indexOf(`
`));
                    c += this.input.css.valueOf().substring(this.tokenizer.position()), this.input = new a(c), this.tokenizer = i2(this.input);
                  } else
                    this.tokenizer.back(o);
                  break;
                }
                p.push(o[1]), h2 = o, o = this.tokenizer.nextToken({ ignoreUnclosed: true });
              }
              let g = ["comment", p.join(""), f3[2], f3[3], h2[2], h2[3]];
              return this.inlineComment(g), true;
            } else if (o[1] === "/") {
              let f3 = this.tokenizer.nextToken({ ignoreUnclosed: true });
              if (f3[0] === "comment" && /^\/\*/.test(f3[1]))
                return f3[0] = "word", f3[1] = f3[1].slice(1), o[1] = "//", this.tokenizer.back(f3), n.exports.isInlineComment.bind(this)(o);
            }
            return false;
          } };
        } }), Rf = R({ "node_modules/postcss-less/lib/nodes/interpolation.js"(e2, n) {
          A2(), n.exports = { interpolation(i2) {
            let a = i2, o = [i2], f3 = ["word", "{", "}"];
            if (i2 = this.tokenizer.nextToken(), a[1].length > 1 || i2[0] !== "{")
              return this.tokenizer.back(i2), false;
            for (; i2 && f3.includes(i2[0]); )
              o.push(i2), i2 = this.tokenizer.nextToken();
            let p = o.map((r2) => r2[1]);
            [a] = o;
            let h2 = o.pop(), g = [a[2], a[3]], c = [h2[4] || h2[2], h2[5] || h2[3]], t2 = ["word", p.join("")].concat(g, c);
            return this.tokenizer.back(i2), this.tokenizer.back(t2), true;
          } };
        } }), If = R({ "node_modules/postcss-less/lib/nodes/mixin.js"(e2, n) {
          A2();
          var i2 = /^#[0-9a-fA-F]{6}$|^#[0-9a-fA-F]{3}$/, a = /\.[0-9]/, o = (f3) => {
            let [, p] = f3, [h2] = p;
            return (h2 === "." || h2 === "#") && i2.test(p) === false && a.test(p) === false;
          };
          n.exports = { isMixinToken: o };
        } }), Cf = R({ "node_modules/postcss-less/lib/nodes/import.js"(e2, n) {
          A2();
          var i2 = Lt(), a = /^url\((.+)\)/;
          n.exports = (o) => {
            let { name: f3, params: p = "" } = o;
            if (f3 === "import" && p.length) {
              o.import = true;
              let h2 = i2({ css: p });
              for (o.filename = p.replace(a, "$1"); !h2.endOfFile(); ) {
                let [g, c] = h2.nextToken();
                if (g === "word" && c === "url")
                  return;
                if (g === "brackets") {
                  o.options = c, o.filename = p.replace(c, "").trim();
                  break;
                }
              }
            }
          };
        } }), Nf = R({ "node_modules/postcss-less/lib/nodes/variable.js"(e2, n) {
          A2();
          var i2 = /:$/, a = /^:(\s+)?/;
          n.exports = (o) => {
            let { name: f3, params: p = "" } = o;
            if (o.name.slice(-1) === ":") {
              if (i2.test(f3)) {
                let [h2] = f3.match(i2);
                o.name = f3.replace(h2, ""), o.raws.afterName = h2 + (o.raws.afterName || ""), o.variable = true, o.value = o.params;
              }
              if (a.test(p)) {
                let [h2] = p.match(a);
                o.value = p.replace(h2, ""), o.raws.afterName = (o.raws.afterName || "") + h2, o.variable = true;
              }
            }
          };
        } }), jf = R({ "node_modules/postcss-less/lib/LessParser.js"(e2, n) {
          A2();
          var i2 = xr(), a = zt(), { isInlineComment: o } = Pf(), { interpolation: f3 } = Rf(), { isMixinToken: p } = If(), h2 = Cf(), g = Nf(), c = /(!\s*important)$/i;
          n.exports = class extends a {
            constructor() {
              super(...arguments), this.lastNode = null;
            }
            atrule(r2) {
              f3.bind(this)(r2) || (super.atrule(r2), h2(this.lastNode), g(this.lastNode));
            }
            decl() {
              super.decl(...arguments), /extend\(.+\)/i.test(this.lastNode.value) && (this.lastNode.extend = true);
            }
            each(r2) {
              r2[0][1] = " ".concat(r2[0][1]);
              let u = r2.findIndex((y) => y[0] === "("), s2 = r2.reverse().find((y) => y[0] === ")"), l = r2.reverse().indexOf(s2), v = r2.splice(u, l).map((y) => y[1]).join("");
              for (let y of r2.reverse())
                this.tokenizer.back(y);
              this.atrule(this.tokenizer.nextToken()), this.lastNode.function = true, this.lastNode.params = v;
            }
            init(r2, u, s2) {
              super.init(r2, u, s2), this.lastNode = r2;
            }
            inlineComment(r2) {
              let u = new i2(), s2 = r2[1].slice(2);
              if (this.init(u, r2[2], r2[3]), u.source.end = { line: r2[4], column: r2[5] }, u.inline = true, u.raws.begin = "//", /^\s*$/.test(s2))
                u.text = "", u.raws.left = s2, u.raws.right = "";
              else {
                let l = s2.match(/^(\s*)([^]*[^\s])(\s*)$/);
                [, u.raws.left, u.text, u.raws.right] = l;
              }
            }
            mixin(r2) {
              let [u] = r2, s2 = u[1].slice(0, 1), l = r2.findIndex((d) => d[0] === "brackets"), m2 = r2.findIndex((d) => d[0] === "("), v = "";
              if ((l < 0 || l > 3) && m2 > 0) {
                let d = r2.reduce(($, B, O) => B[0] === ")" ? O : $), S2 = r2.slice(m2, d + m2).map(($) => $[1]).join(""), [x2] = r2.slice(m2), N = [x2[2], x2[3]], [P] = r2.slice(d, d + 1), W = [P[2], P[3]], U = ["brackets", S2].concat(N, W), H = r2.slice(0, m2), D = r2.slice(d + 1);
                r2 = H, r2.push(U), r2 = r2.concat(D);
              }
              let y = [];
              for (let d of r2)
                if ((d[1] === "!" || y.length) && y.push(d), d[1] === "important")
                  break;
              if (y.length) {
                let [d] = y, _ = r2.indexOf(d), S2 = y[y.length - 1], x2 = [d[2], d[3]], N = [S2[4], S2[5]], P = y.map((U) => U[1]).join(""), W = ["word", P].concat(x2, N);
                r2.splice(_, y.length, W);
              }
              let w = r2.findIndex((d) => c.test(d[1]));
              w > 0 && ([, v] = r2[w], r2.splice(w, 1));
              for (let d of r2.reverse())
                this.tokenizer.back(d);
              this.atrule(this.tokenizer.nextToken()), this.lastNode.mixin = true, this.lastNode.raws.identifier = s2, v && (this.lastNode.important = true, this.lastNode.raws.important = v);
            }
            other(r2) {
              o.bind(this)(r2) || super.other(r2);
            }
            rule(r2) {
              let u = r2[r2.length - 1], s2 = r2[r2.length - 2];
              if (s2[0] === "at-word" && u[0] === "{" && (this.tokenizer.back(u), f3.bind(this)(s2))) {
                let m2 = this.tokenizer.nextToken();
                r2 = r2.slice(0, r2.length - 2).concat([m2]);
                for (let v of r2.reverse())
                  this.tokenizer.back(v);
                return;
              }
              super.rule(r2), /:extend\(.+\)/i.test(this.lastNode.selector) && (this.lastNode.extend = true);
            }
            unknownWord(r2) {
              let [u] = r2;
              if (r2[0][1] === "each" && r2[1][0] === "(") {
                this.each(r2);
                return;
              }
              if (p(u)) {
                this.mixin(r2);
                return;
              }
              super.unknownWord(r2);
            }
          };
        } }), Mf = R({ "node_modules/postcss-less/lib/LessStringifier.js"(e2, n) {
          A2();
          var i2 = br();
          n.exports = class extends i2 {
            atrule(o, f3) {
              if (!o.mixin && !o.variable && !o.function) {
                super.atrule(o, f3);
                return;
              }
              let p = o.function ? "" : o.raws.identifier || "@", h2 = "".concat(p).concat(o.name), g = o.params ? this.rawValue(o, "params") : "", c = o.raws.important || "";
              if (o.variable && (g = o.value), typeof o.raws.afterName < "u" ? h2 += o.raws.afterName : g && (h2 += " "), o.nodes)
                this.block(o, h2 + g + c);
              else {
                let t2 = (o.raws.between || "") + c + (f3 ? ";" : "");
                this.builder(h2 + g + t2, o);
              }
            }
            comment(o) {
              if (o.inline) {
                let f3 = this.raw(o, "left", "commentLeft"), p = this.raw(o, "right", "commentRight");
                this.builder("//".concat(f3).concat(o.text).concat(p), o);
              } else
                super.comment(o);
            }
          };
        } }), Df = R({ "node_modules/postcss-less/lib/index.js"(e2, n) {
          A2();
          var i2 = _r(), a = jf(), o = Mf();
          n.exports = { parse(f3, p) {
            let h2 = new i2(f3, p), g = new a(h2);
            return g.parse(), g.root;
          }, stringify(f3, p) {
            new o(p).stringify(f3);
          }, nodeToString(f3) {
            let p = "";
            return n.exports.stringify(f3, (h2) => {
              p += h2;
            }), p;
          } };
        } }), Lf = R({ "node_modules/postcss-scss/lib/scss-stringifier.js"(e2, n) {
          "use strict";
          A2();
          function i2(f3, p) {
            f3.prototype = Object.create(p.prototype), f3.prototype.constructor = f3, f3.__proto__ = p;
          }
          var a = br(), o = function(f3) {
            i2(p, f3);
            function p() {
              return f3.apply(this, arguments) || this;
            }
            var h2 = p.prototype;
            return h2.comment = function(c) {
              var t2 = this.raw(c, "left", "commentLeft"), r2 = this.raw(c, "right", "commentRight");
              if (c.raws.inline) {
                var u = c.raws.text || c.text;
                this.builder("//" + t2 + u + r2, c);
              } else
                this.builder("/*" + t2 + c.text + r2 + "*/", c);
            }, h2.decl = function(c, t2) {
              if (!c.isNested)
                f3.prototype.decl.call(this, c, t2);
              else {
                var r2 = this.raw(c, "between", "colon"), u = c.prop + r2 + this.rawValue(c, "value");
                c.important && (u += c.raws.important || " !important"), this.builder(u + "{", c, "start");
                var s2;
                c.nodes && c.nodes.length ? (this.body(c), s2 = this.raw(c, "after")) : s2 = this.raw(c, "after", "emptyBody"), s2 && this.builder(s2), this.builder("}", c, "end");
              }
            }, h2.rawValue = function(c, t2) {
              var r2 = c[t2], u = c.raws[t2];
              return u && u.value === r2 ? u.scss ? u.scss : u.raw : r2;
            }, p;
          }(a);
          n.exports = o;
        } }), zf = R({ "node_modules/postcss-scss/lib/scss-stringify.js"(e2, n) {
          "use strict";
          A2();
          var i2 = Lf();
          n.exports = function(o, f3) {
            var p = new i2(f3);
            p.stringify(o);
          };
        } }), Bf = R({ "node_modules/postcss-scss/lib/nested-declaration.js"(e2, n) {
          "use strict";
          A2();
          function i2(f3, p) {
            f3.prototype = Object.create(p.prototype), f3.prototype.constructor = f3, f3.__proto__ = p;
          }
          var a = kr(), o = function(f3) {
            i2(p, f3);
            function p(h2) {
              var g;
              return g = f3.call(this, h2) || this, g.type = "decl", g.isNested = true, g.nodes || (g.nodes = []), g;
            }
            return p;
          }(a);
          n.exports = o;
        } }), Ff = R({ "node_modules/postcss-scss/lib/scss-tokenize.js"(e2, n) {
          "use strict";
          A2();
          var i2 = "'".charCodeAt(0), a = '"'.charCodeAt(0), o = "\\".charCodeAt(0), f3 = "/".charCodeAt(0), p = `
`.charCodeAt(0), h2 = " ".charCodeAt(0), g = "\f".charCodeAt(0), c = "	".charCodeAt(0), t2 = "\r".charCodeAt(0), r2 = "[".charCodeAt(0), u = "]".charCodeAt(0), s2 = "(".charCodeAt(0), l = ")".charCodeAt(0), m2 = "{".charCodeAt(0), v = "}".charCodeAt(0), y = ";".charCodeAt(0), w = "*".charCodeAt(0), d = ":".charCodeAt(0), _ = "@".charCodeAt(0), S2 = ",".charCodeAt(0), x2 = "#".charCodeAt(0), N = /[ \n\t\r\f{}()'"\\;/[\]#]/g, P = /[ \n\t\r\f(){}:;@!'"\\\][#]|\/(?=\*)/g, W = /.[\\/("'\n]/, U = /[a-f0-9]/i, H = /[\r\f\n]/g;
          n.exports = function($, B) {
            B === void 0 && (B = {});
            var O = $.css.valueOf(), j = B.ignoreErrors, C, I, X, Z2, Q, K, J, M, Y, G, E, k, b, L, q = O.length, T = -1, F2 = 1, z = 0, re = [], ne = [];
            function ce(se) {
              throw $.error("Unclosed " + se, F2, z - T);
            }
            function fe() {
              return ne.length === 0 && z >= q;
            }
            function te() {
              for (var se = 1, le = false, pe = false; se > 0; )
                I += 1, O.length <= I && ce("interpolation"), C = O.charCodeAt(I), k = O.charCodeAt(I + 1), le ? !pe && C === le ? (le = false, pe = false) : C === o ? pe = !G : pe && (pe = false) : C === i2 || C === a ? le = C : C === v ? se -= 1 : C === x2 && k === m2 && (se += 1);
            }
            function ie() {
              if (ne.length)
                return ne.pop();
              if (!(z >= q)) {
                switch (C = O.charCodeAt(z), (C === p || C === g || C === t2 && O.charCodeAt(z + 1) !== p) && (T = z, F2 += 1), C) {
                  case p:
                  case h2:
                  case c:
                  case t2:
                  case g:
                    I = z;
                    do
                      I += 1, C = O.charCodeAt(I), C === p && (T = I, F2 += 1);
                    while (C === h2 || C === p || C === c || C === t2 || C === g);
                    b = ["space", O.slice(z, I)], z = I - 1;
                    break;
                  case r2:
                    b = ["[", "[", F2, z - T];
                    break;
                  case u:
                    b = ["]", "]", F2, z - T];
                    break;
                  case m2:
                    b = ["{", "{", F2, z - T];
                    break;
                  case v:
                    b = ["}", "}", F2, z - T];
                    break;
                  case S2:
                    b = ["word", ",", F2, z - T, F2, z - T + 1];
                    break;
                  case d:
                    b = [":", ":", F2, z - T];
                    break;
                  case y:
                    b = [";", ";", F2, z - T];
                    break;
                  case s2:
                    if (E = re.length ? re.pop()[1] : "", k = O.charCodeAt(z + 1), E === "url" && k !== i2 && k !== a) {
                      for (L = 1, G = false, I = z + 1; I <= O.length - 1; ) {
                        if (k = O.charCodeAt(I), k === o)
                          G = !G;
                        else if (k === s2)
                          L += 1;
                        else if (k === l && (L -= 1, L === 0))
                          break;
                        I += 1;
                      }
                      K = O.slice(z, I + 1), Z2 = K.split(`
`), Q = Z2.length - 1, Q > 0 ? (M = F2 + Q, Y = I - Z2[Q].length) : (M = F2, Y = T), b = ["brackets", K, F2, z - T, M, I - Y], T = Y, F2 = M, z = I;
                    } else
                      I = O.indexOf(")", z + 1), K = O.slice(z, I + 1), I === -1 || W.test(K) ? b = ["(", "(", F2, z - T] : (b = ["brackets", K, F2, z - T, F2, I - T], z = I);
                    break;
                  case l:
                    b = [")", ")", F2, z - T];
                    break;
                  case i2:
                  case a:
                    for (X = C, I = z, G = false; I < q && (I++, I === q && ce("string"), C = O.charCodeAt(I), k = O.charCodeAt(I + 1), !(!G && C === X)); )
                      C === o ? G = !G : G ? G = false : C === x2 && k === m2 && te();
                    K = O.slice(z, I + 1), Z2 = K.split(`
`), Q = Z2.length - 1, Q > 0 ? (M = F2 + Q, Y = I - Z2[Q].length) : (M = F2, Y = T), b = ["string", O.slice(z, I + 1), F2, z - T, M, I - Y], T = Y, F2 = M, z = I;
                    break;
                  case _:
                    N.lastIndex = z + 1, N.test(O), N.lastIndex === 0 ? I = O.length - 1 : I = N.lastIndex - 2, b = ["at-word", O.slice(z, I + 1), F2, z - T, F2, I - T], z = I;
                    break;
                  case o:
                    for (I = z, J = true; O.charCodeAt(I + 1) === o; )
                      I += 1, J = !J;
                    if (C = O.charCodeAt(I + 1), J && C !== f3 && C !== h2 && C !== p && C !== c && C !== t2 && C !== g && (I += 1, U.test(O.charAt(I)))) {
                      for (; U.test(O.charAt(I + 1)); )
                        I += 1;
                      O.charCodeAt(I + 1) === h2 && (I += 1);
                    }
                    b = ["word", O.slice(z, I + 1), F2, z - T, F2, I - T], z = I;
                    break;
                  default:
                    k = O.charCodeAt(z + 1), C === x2 && k === m2 ? (I = z, te(), K = O.slice(z, I + 1), Z2 = K.split(`
`), Q = Z2.length - 1, Q > 0 ? (M = F2 + Q, Y = I - Z2[Q].length) : (M = F2, Y = T), b = ["word", K, F2, z - T, M, I - Y], T = Y, F2 = M, z = I) : C === f3 && k === w ? (I = O.indexOf("*/", z + 2) + 1, I === 0 && (j ? I = O.length : ce("comment")), K = O.slice(z, I + 1), Z2 = K.split(`
`), Q = Z2.length - 1, Q > 0 ? (M = F2 + Q, Y = I - Z2[Q].length) : (M = F2, Y = T), b = ["comment", K, F2, z - T, M, I - Y], T = Y, F2 = M, z = I) : C === f3 && k === f3 ? (H.lastIndex = z + 1, H.test(O), H.lastIndex === 0 ? I = O.length - 1 : I = H.lastIndex - 2, K = O.slice(z, I + 1), b = ["comment", K, F2, z - T, F2, I - T, "inline"], z = I) : (P.lastIndex = z + 1, P.test(O), P.lastIndex === 0 ? I = O.length - 1 : I = P.lastIndex - 2, b = ["word", O.slice(z, I + 1), F2, z - T, F2, I - T], re.push(b), z = I);
                    break;
                }
                return z++, b;
              }
            }
            function ae(se) {
              ne.push(se);
            }
            return { back: ae, nextToken: ie, endOfFile: fe };
          };
        } }), Uf = R({ "node_modules/postcss-scss/lib/scss-parser.js"(e2, n) {
          "use strict";
          A2();
          function i2(g, c) {
            g.prototype = Object.create(c.prototype), g.prototype.constructor = g, g.__proto__ = c;
          }
          var a = xr(), o = zt(), f3 = Bf(), p = Ff(), h2 = function(g) {
            i2(c, g);
            function c() {
              return g.apply(this, arguments) || this;
            }
            var t2 = c.prototype;
            return t2.createTokenizer = function() {
              this.tokenizer = p(this.input);
            }, t2.rule = function(u) {
              for (var s2 = false, l = 0, m2 = "", w = u, v = Array.isArray(w), y = 0, w = v ? w : w[Symbol.iterator](); ; ) {
                var d;
                if (v) {
                  if (y >= w.length)
                    break;
                  d = w[y++];
                } else {
                  if (y = w.next(), y.done)
                    break;
                  d = y.value;
                }
                var _ = d;
                if (s2)
                  _[0] !== "comment" && _[0] !== "{" && (m2 += _[1]);
                else {
                  if (_[0] === "space" && _[1].indexOf(`
`) !== -1)
                    break;
                  _[0] === "(" ? l += 1 : _[0] === ")" ? l -= 1 : l === 0 && _[0] === ":" && (s2 = true);
                }
              }
              if (!s2 || m2.trim() === "" || /^[a-zA-Z-:#]/.test(m2))
                g.prototype.rule.call(this, u);
              else {
                u.pop();
                var S2 = new f3();
                this.init(S2);
                var x2 = u[u.length - 1];
                for (x2[4] ? S2.source.end = { line: x2[4], column: x2[5] } : S2.source.end = { line: x2[2], column: x2[3] }; u[0][0] !== "word"; )
                  S2.raws.before += u.shift()[1];
                for (S2.source.start = { line: u[0][2], column: u[0][3] }, S2.prop = ""; u.length; ) {
                  var N = u[0][0];
                  if (N === ":" || N === "space" || N === "comment")
                    break;
                  S2.prop += u.shift()[1];
                }
                S2.raws.between = "";
                for (var P; u.length; )
                  if (P = u.shift(), P[0] === ":") {
                    S2.raws.between += P[1];
                    break;
                  } else
                    S2.raws.between += P[1];
                (S2.prop[0] === "_" || S2.prop[0] === "*") && (S2.raws.before += S2.prop[0], S2.prop = S2.prop.slice(1)), S2.raws.between += this.spacesAndCommentsFromStart(u), this.precheckMissedSemicolon(u);
                for (var W = u.length - 1; W > 0; W--) {
                  if (P = u[W], P[1] === "!important") {
                    S2.important = true;
                    var U = this.stringFrom(u, W);
                    U = this.spacesFromEnd(u) + U, U !== " !important" && (S2.raws.important = U);
                    break;
                  } else if (P[1] === "important") {
                    for (var H = u.slice(0), D = "", $ = W; $ > 0; $--) {
                      var B = H[$][0];
                      if (D.trim().indexOf("!") === 0 && B !== "space")
                        break;
                      D = H.pop()[1] + D;
                    }
                    D.trim().indexOf("!") === 0 && (S2.important = true, S2.raws.important = D, u = H);
                  }
                  if (P[0] !== "space" && P[0] !== "comment")
                    break;
                }
                this.raw(S2, "value", u), S2.value.indexOf(":") !== -1 && this.checkMissedSemicolon(u), this.current = S2;
              }
            }, t2.comment = function(u) {
              if (u[6] === "inline") {
                var s2 = new a();
                this.init(s2, u[2], u[3]), s2.raws.inline = true, s2.source.end = { line: u[4], column: u[5] };
                var l = u[1].slice(2);
                if (/^\s*$/.test(l))
                  s2.text = "", s2.raws.left = l, s2.raws.right = "";
                else {
                  var m2 = l.match(/^(\s*)([^]*[^\s])(\s*)$/), v = m2[2].replace(/(\*\/|\/\*)/g, "*//*");
                  s2.text = v, s2.raws.left = m2[1], s2.raws.right = m2[3], s2.raws.text = m2[2];
                }
              } else
                g.prototype.comment.call(this, u);
            }, t2.raw = function(u, s2, l) {
              if (g.prototype.raw.call(this, u, s2, l), u.raws[s2]) {
                var m2 = u.raws[s2].raw;
                u.raws[s2].raw = l.reduce(function(v, y) {
                  if (y[0] === "comment" && y[6] === "inline") {
                    var w = y[1].slice(2).replace(/(\*\/|\/\*)/g, "*//*");
                    return v + "/*" + w + "*/";
                  } else
                    return v + y[1];
                }, ""), m2 !== u.raws[s2].raw && (u.raws[s2].scss = m2);
              }
            }, c;
          }(o);
          n.exports = h2;
        } }), Wf = R({ "node_modules/postcss-scss/lib/scss-parse.js"(e2, n) {
          "use strict";
          A2();
          var i2 = _r(), a = Uf();
          n.exports = function(f3, p) {
            var h2 = new i2(f3, p), g = new a(h2);
            return g.parse(), g.root;
          };
        } }), $f = R({ "node_modules/postcss-scss/lib/scss-syntax.js"(e2, n) {
          "use strict";
          A2();
          var i2 = zf(), a = Wf();
          n.exports = { parse: a, stringify: i2 };
        } });
        A2();
        var Vf = ml(), pt = Cs(), Gf = Ns(), { hasPragma: Hf } = Tl(), { locStart: Jf, locEnd: Kf } = Js(), { calculateLoc: Qf, replaceQuotesInInlineComments: Yf } = Js(), Xf = Pl(), Zf = Rl(), ht = Il(), sa = Cl(), ep = Nl(), rp = jl(), tp = Ml(), np = Dl(), ip = (e2) => {
          for (; e2.parent; )
            e2 = e2.parent;
          return e2;
        };
        function sp(e2, n) {
          let { nodes: i2 } = e2, a = { open: null, close: null, groups: [], type: "paren_group" }, o = [a], f3 = a, p = { groups: [], type: "comma_group" }, h2 = [p];
          for (let g = 0; g < i2.length; ++g) {
            let c = i2[g];
            if (sa(n.parser, c.value) && c.type === "number" && c.unit === ".." && pt(c.value) === "." && (c.value = c.value.slice(0, -1), c.unit = "..."), c.type === "func" && c.value === "selector" && (c.group.groups = [Ie(ip(e2).text.slice(c.group.open.sourceIndex + 1, c.group.close.sourceIndex))]), c.type === "func" && c.value === "url") {
              let t2 = c.group && c.group.groups || [], r2 = [];
              for (let u = 0; u < t2.length; u++) {
                let s2 = t2[u];
                s2.type === "comma_group" ? r2 = [...r2, ...s2.groups] : r2.push(s2);
              }
              if (Xf(r2) || !Zf(r2) && !rp(r2[0])) {
                let u = tp({ groups: c.group.groups });
                c.group.groups = [u.trim()];
              }
            }
            if (c.type === "paren" && c.value === "(")
              a = { open: c, close: null, groups: [], type: "paren_group" }, o.push(a), p = { groups: [], type: "comma_group" }, h2.push(p);
            else if (c.type === "paren" && c.value === ")") {
              if (p.groups.length > 0 && a.groups.push(p), a.close = c, h2.length === 1)
                throw new Error("Unbalanced parenthesis");
              h2.pop(), p = pt(h2), p.groups.push(a), o.pop(), a = pt(o);
            } else
              c.type === "comma" ? (a.groups.push(p), p = { groups: [], type: "comma_group" }, h2[h2.length - 1] = p) : p.groups.push(c);
          }
          return p.groups.length > 0 && a.groups.push(p), f3;
        }
        function hr(e2) {
          return e2.type === "paren_group" && !e2.open && !e2.close && e2.groups.length === 1 || e2.type === "comma_group" && e2.groups.length === 1 ? hr(e2.groups[0]) : e2.type === "paren_group" || e2.type === "comma_group" ? Object.assign(Object.assign({}, e2), {}, { groups: e2.groups.map(hr) }) : e2;
        }
        function Xe(e2, n, i2) {
          if (e2 && typeof e2 == "object") {
            delete e2.parent;
            for (let a in e2)
              Xe(e2[a], n, i2), a === "type" && typeof e2[a] == "string" && !e2[a].startsWith(n) && (!i2 || !i2.test(e2[a])) && (e2[a] = n + e2[a]);
          }
          return e2;
        }
        function oa(e2) {
          if (e2 && typeof e2 == "object") {
            delete e2.parent;
            for (let n in e2)
              oa(e2[n]);
            !Array.isArray(e2) && e2.value && !e2.type && (e2.type = "unknown");
          }
          return e2;
        }
        function aa(e2, n) {
          if (e2 && typeof e2 == "object") {
            for (let i2 in e2)
              i2 !== "parent" && (aa(e2[i2], n), i2 === "nodes" && (e2.group = hr(sp(e2, n)), delete e2[i2]));
            delete e2.parent;
          }
          return e2;
        }
        function Pe(e2, n) {
          let i2 = lf(), a = null;
          try {
            a = i2(e2, { loose: true }).parse();
          } catch {
            return { type: "value-unknown", value: e2 };
          }
          a.text = e2;
          let o = aa(a, n);
          return Xe(o, "value-", /^selector-/);
        }
        function Ie(e2) {
          if (/\/\/|\/\*/.test(e2))
            return { type: "selector-unknown", value: e2.trim() };
          let n = vf(), i2 = null;
          try {
            n((a) => {
              i2 = a;
            }).process(e2);
          } catch {
            return { type: "selector-unknown", value: e2 };
          }
          return Xe(i2, "selector-");
        }
        function op(e2) {
          let n = gf().default, i2 = null;
          try {
            i2 = n(e2);
          } catch {
            return { type: "selector-unknown", value: e2 };
          }
          return Xe(oa(i2), "media-");
        }
        var ap = /(\s*)(!default).*$/, up = /(\s*)(!global).*$/;
        function ua(e2, n) {
          if (e2 && typeof e2 == "object") {
            delete e2.parent;
            for (let f3 in e2)
              ua(e2[f3], n);
            if (!e2.type)
              return e2;
            e2.raws || (e2.raws = {});
            let i2 = "";
            typeof e2.selector == "string" && (i2 = e2.raws.selector ? e2.raws.selector.scss ? e2.raws.selector.scss : e2.raws.selector.raw : e2.selector, e2.raws.between && e2.raws.between.trim().length > 0 && (i2 += e2.raws.between), e2.raws.selector = i2);
            let a = "";
            typeof e2.value == "string" && (a = e2.raws.value ? e2.raws.value.scss ? e2.raws.value.scss : e2.raws.value.raw : e2.value, a = a.trim(), e2.raws.value = a);
            let o = "";
            if (typeof e2.params == "string" && (o = e2.raws.params ? e2.raws.params.scss ? e2.raws.params.scss : e2.raws.params.raw : e2.params, e2.raws.afterName && e2.raws.afterName.trim().length > 0 && (o = e2.raws.afterName + o), e2.raws.between && e2.raws.between.trim().length > 0 && (o = o + e2.raws.between), o = o.trim(), e2.raws.params = o), i2.trim().length > 0)
              return i2.startsWith("@") && i2.endsWith(":") ? e2 : e2.mixin ? (e2.selector = Pe(i2, n), e2) : (ep(e2) && (e2.isSCSSNesterProperty = true), e2.selector = Ie(i2), e2);
            if (a.length > 0) {
              let f3 = a.match(ap);
              f3 && (a = a.slice(0, f3.index), e2.scssDefault = true, f3[0].trim() !== "!default" && (e2.raws.scssDefault = f3[0]));
              let p = a.match(up);
              if (p && (a = a.slice(0, p.index), e2.scssGlobal = true, p[0].trim() !== "!global" && (e2.raws.scssGlobal = p[0])), a.startsWith("progid:"))
                return { type: "value-unknown", value: a };
              e2.value = Pe(a, n);
            }
            if (ht(n) && e2.type === "css-decl" && a.startsWith("extend(") && (e2.extend || (e2.extend = e2.raws.between === ":"), e2.extend && !e2.selector && (delete e2.value, e2.selector = Ie(a.slice(7, -1)))), e2.type === "css-atrule") {
              if (ht(n)) {
                if (e2.mixin) {
                  let f3 = e2.raws.identifier + e2.name + e2.raws.afterName + e2.raws.params;
                  return e2.selector = Ie(f3), delete e2.params, e2;
                }
                if (e2.function)
                  return e2;
              }
              if (n.parser === "css" && e2.name === "custom-selector") {
                let f3 = e2.params.match(/:--\S+\s+/)[0].trim();
                return e2.customSelector = f3, e2.selector = Ie(e2.params.slice(f3.length).trim()), delete e2.params, e2;
              }
              if (ht(n)) {
                if (e2.name.includes(":") && !e2.params) {
                  e2.variable = true;
                  let f3 = e2.name.split(":");
                  e2.name = f3[0], e2.value = Pe(f3.slice(1).join(":"), n);
                }
                if (!["page", "nest", "keyframes"].includes(e2.name) && e2.params && e2.params[0] === ":" && (e2.variable = true, e2.value = Pe(e2.params.slice(1), n), e2.raws.afterName += ":"), e2.variable)
                  return delete e2.params, e2;
              }
            }
            if (e2.type === "css-atrule" && o.length > 0) {
              let { name: f3 } = e2, p = e2.name.toLowerCase();
              return f3 === "warn" || f3 === "error" ? (e2.params = { type: "media-unknown", value: o }, e2) : f3 === "extend" || f3 === "nest" ? (e2.selector = Ie(o), delete e2.params, e2) : f3 === "at-root" ? (/^\(\s*(?:without|with)\s*:.+\)$/s.test(o) ? e2.params = Pe(o, n) : (e2.selector = Ie(o), delete e2.params), e2) : np(p) ? (e2.import = true, delete e2.filename, e2.params = Pe(o, n), e2) : ["namespace", "supports", "if", "else", "for", "each", "while", "debug", "mixin", "include", "function", "return", "define-mixin", "add-mixin"].includes(f3) ? (o = o.replace(/(\$\S+?)(\s+)?\.{3}/, "$1...$2"), o = o.replace(/^(?!if)(\S+)(\s+)\(/, "$1($2"), e2.value = Pe(o, n), delete e2.params, e2) : ["media", "custom-media"].includes(p) ? o.includes("#{") ? { type: "media-unknown", value: o } : (e2.params = op(o), e2) : (e2.params = o, e2);
            }
          }
          return e2;
        }
        function ca(e2, n, i2) {
          let a = Gf(n), { frontMatter: o } = a;
          n = a.content;
          let f3;
          try {
            f3 = e2(n);
          } catch (p) {
            let { name: h2, reason: g, line: c, column: t2 } = p;
            throw typeof c != "number" ? p : Vf("".concat(h2, ": ").concat(g), { start: { line: c, column: t2 } });
          }
          return f3 = ua(Xe(f3, "css-"), i2), Qf(f3, n), o && (o.source = { startOffset: 0, endOffset: o.raw.length }, f3.nodes.unshift(o)), f3;
        }
        function cp(e2, n) {
          let i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, o = sa(i2.parser, e2) ? [xt, bt] : [bt, xt], f3;
          for (let p of o)
            try {
              return p(e2, n, i2);
            } catch (h2) {
              f3 = f3 || h2;
            }
          if (f3)
            throw f3;
        }
        function bt(e2, n) {
          let i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, a = Df();
          return ca((o) => a.parse(Yf(o)), e2, i2);
        }
        function xt(e2, n) {
          let i2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, { parse: a } = $f();
          return ca(a, e2, i2);
        }
        var dt = { astFormat: "postcss", hasPragma: Hf, locStart: Jf, locEnd: Kf };
        la.exports = { parsers: { css: Object.assign(Object.assign({}, dt), {}, { parse: cp }), less: Object.assign(Object.assign({}, dt), {}, { parse: bt }), scss: Object.assign(Object.assign({}, dt), {}, { parse: xt }) } };
      });
      return lp();
    });
  }
});

// node_modules/prettier/parser-glimmer.js
var require_parser_glimmer = __commonJS({
  "node_modules/prettier/parser-glimmer.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.glimmer = e2();
      }
    })(function() {
      "use strict";
      var it = (t2, f3) => () => (f3 || t2((f3 = { exports: {} }).exports, f3), f3.exports);
      var Zt = it((nr, $e) => {
        var xe = Object.getOwnPropertyNames, at = (t2, f3) => function() {
          return t2 && (f3 = (0, t2[xe(t2)[0]])(t2 = 0)), f3;
        }, I = (t2, f3) => function() {
          return f3 || (0, t2[xe(t2)[0]])((f3 = { exports: {} }).exports, f3), f3.exports;
        }, F2 = at({ "<define:process>"() {
        } }), st = I({ "node_modules/lines-and-columns/build/index.cjs"(t2) {
          "use strict";
          F2(), t2.__esModule = true, t2.LinesAndColumns = void 0;
          var f3 = `
`, h2 = "\r", d = function() {
            function c(o) {
              this.length = o.length;
              for (var e2 = [0], r2 = 0; r2 < o.length; )
                switch (o[r2]) {
                  case f3:
                    r2 += f3.length, e2.push(r2);
                    break;
                  case h2:
                    r2 += h2.length, o[r2] === f3 && (r2 += f3.length), e2.push(r2);
                    break;
                  default:
                    r2++;
                    break;
                }
              this.offsets = e2;
            }
            return c.prototype.locationForIndex = function(o) {
              if (o < 0 || o > this.length)
                return null;
              for (var e2 = 0, r2 = this.offsets; r2[e2 + 1] <= o; )
                e2++;
              var s2 = o - r2[e2];
              return { line: e2, column: s2 };
            }, c.prototype.indexForLocation = function(o) {
              var e2 = o.line, r2 = o.column;
              return e2 < 0 || e2 >= this.offsets.length || r2 < 0 || r2 > this.lengthOfLine(e2) ? null : this.offsets[e2] + r2;
            }, c.prototype.lengthOfLine = function(o) {
              var e2 = this.offsets[o], r2 = o === this.offsets.length - 1 ? this.length : this.offsets[o + 1];
              return r2 - e2;
            }, c;
          }();
          t2.LinesAndColumns = d;
        } }), ut = I({ "src/common/parser-create-error.js"(t2, f3) {
          "use strict";
          F2();
          function h2(d, c) {
            let o = new SyntaxError(d + " (" + c.start.line + ":" + c.start.column + ")");
            return o.loc = c, o;
          }
          f3.exports = h2;
        } }), ot = I({ "src/language-handlebars/loc.js"(t2, f3) {
          "use strict";
          F2();
          function h2(c) {
            return c.loc.start.offset;
          }
          function d(c) {
            return c.loc.end.offset;
          }
          f3.exports = { locStart: h2, locEnd: d };
        } }), fe = I({ "node_modules/@glimmer/env/dist/commonjs/es5/index.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true });
          var f3 = t2.DEBUG = false, h2 = t2.CI = false;
        } }), lt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/array-utils.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.emptyArray = h2, t2.isEmptyArray = o, t2.EMPTY_NUMBER_ARRAY = t2.EMPTY_STRING_ARRAY = t2.EMPTY_ARRAY = void 0;
          var f3 = Object.freeze([]);
          t2.EMPTY_ARRAY = f3;
          function h2() {
            return f3;
          }
          var d = h2();
          t2.EMPTY_STRING_ARRAY = d;
          var c = h2();
          t2.EMPTY_NUMBER_ARRAY = c;
          function o(e2) {
            return e2 === f3;
          }
        } }), Pe = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/assert.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.debugAssert = h2, t2.prodAssert = d, t2.deprecate = c, t2.default = void 0;
          var f3 = X();
          function h2(e2, r2) {
            if (!e2)
              throw new Error(r2 || "assertion failure");
          }
          function d() {
          }
          function c(e2) {
            f3.LOCAL_LOGGER.warn("DEPRECATION: ".concat(e2));
          }
          var o = h2;
          t2.default = o;
        } }), ct = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/collections.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.dict = f3, t2.isDict = h2, t2.isObject = d, t2.StackImpl = void 0;
          function f3() {
            return /* @__PURE__ */ Object.create(null);
          }
          function h2(o) {
            return o != null;
          }
          function d(o) {
            return typeof o == "function" || typeof o == "object" && o !== null;
          }
          var c = class {
            constructor() {
              let o = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
              this.current = null, this.stack = o;
            }
            get size() {
              return this.stack.length;
            }
            push(o) {
              this.current = o, this.stack.push(o);
            }
            pop() {
              let o = this.stack.pop(), e2 = this.stack.length;
              return this.current = e2 === 0 ? null : this.stack[e2 - 1], o === void 0 ? null : o;
            }
            nth(o) {
              let e2 = this.stack.length;
              return e2 < o ? null : this.stack[e2 - o];
            }
            isEmpty() {
              return this.stack.length === 0;
            }
            toArray() {
              return this.stack;
            }
          };
          t2.StackImpl = c;
        } }), ht = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/dom.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.clearElement = f3;
          function f3(h2) {
            let d = h2.firstChild;
            for (; d; ) {
              let c = d.nextSibling;
              h2.removeChild(d), d = c;
            }
          }
        } }), dt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/is-serialization-first-node.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.isSerializationFirstNode = h2, t2.SERIALIZATION_FIRST_NODE_STRING = void 0;
          var f3 = "%+b:0%";
          t2.SERIALIZATION_FIRST_NODE_STRING = f3;
          function h2(d) {
            return d.nodeValue === f3;
          }
        } }), pt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/object-utils.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.fillNulls = h2, t2.values = d, t2.assign = void 0;
          var f3 = Object.assign;
          t2.assign = f3;
          function h2(c) {
            let o = new Array(c);
            for (let e2 = 0; e2 < c; e2++)
              o[e2] = null;
            return o;
          }
          function d(c) {
            let o = [];
            for (let e2 in c)
              o.push(c[e2]);
            return o;
          }
        } }), je = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/intern.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = f3;
          function f3(h2) {
            let d = {};
            d[h2] = 1;
            for (let c in d)
              if (c === h2)
                return c;
            return h2;
          }
        } }), me = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/platform-utils.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.keys = o, t2.unwrap = e2, t2.expect = r2, t2.unreachable = s2, t2.exhausted = p, t2.enumerableSymbol = a, t2.symbol = t2.tuple = t2.HAS_NATIVE_SYMBOL = t2.HAS_NATIVE_PROXY = void 0;
          var f3 = h2(je());
          function h2(i2) {
            return i2 && i2.__esModule ? i2 : { default: i2 };
          }
          var d = typeof Proxy == "function";
          t2.HAS_NATIVE_PROXY = d;
          var c = function() {
            return typeof Symbol != "function" ? false : typeof Symbol() == "symbol";
          }();
          t2.HAS_NATIVE_SYMBOL = c;
          function o(i2) {
            return Object.keys(i2);
          }
          function e2(i2) {
            if (i2 == null)
              throw new Error("Expected value to be present");
            return i2;
          }
          function r2(i2, l) {
            if (i2 == null)
              throw new Error(l);
            return i2;
          }
          function s2() {
            let i2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : "unreachable";
            return new Error(i2);
          }
          function p(i2) {
            throw new Error("Exhausted ".concat(i2));
          }
          var n = function() {
            for (var i2 = arguments.length, l = new Array(i2), b = 0; b < i2; b++)
              l[b] = arguments[b];
            return l;
          };
          t2.tuple = n;
          function a(i2) {
            return (0, f3.default)("__".concat(i2).concat(Math.floor(Math.random() * Date.now()), "__"));
          }
          var u = c ? Symbol : a;
          t2.symbol = u;
        } }), ft = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/string.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.strip = f3;
          function f3(h2) {
            let d = "";
            for (var c = arguments.length, o = new Array(c > 1 ? c - 1 : 0), e2 = 1; e2 < c; e2++)
              o[e2 - 1] = arguments[e2];
            for (let n = 0; n < h2.length; n++) {
              let a = h2[n], u = o[n] !== void 0 ? String(o[n]) : "";
              d += "".concat(a).concat(u);
            }
            let r2 = d.split(`
`);
            for (; r2.length && r2[0].match(/^\s*$/); )
              r2.shift();
            for (; r2.length && r2[r2.length - 1].match(/^\s*$/); )
              r2.pop();
            let s2 = 1 / 0;
            for (let n of r2) {
              let a = n.match(/^\s*/)[0].length;
              s2 = Math.min(s2, a);
            }
            let p = [];
            for (let n of r2)
              p.push(n.slice(s2));
            return p.join(`
`);
          }
        } }), mt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/immediate.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.isHandle = h2, t2.isNonPrimitiveHandle = d, t2.constants = c, t2.isSmallInt = o, t2.encodeNegative = e2, t2.decodeNegative = r2, t2.encodePositive = s2, t2.decodePositive = p, t2.encodeHandle = n, t2.decodeHandle = a, t2.encodeImmediate = u, t2.decodeImmediate = i2;
          var f3 = Pe();
          function h2(l) {
            return l >= 0;
          }
          function d(l) {
            return l > 3;
          }
          function c() {
            for (var l = arguments.length, b = new Array(l), P = 0; P < l; P++)
              b[P] = arguments[P];
            return [false, true, null, void 0, ...b];
          }
          function o(l) {
            return l % 1 === 0 && l <= 536870911 && l >= -536870912;
          }
          function e2(l) {
            return l & -536870913;
          }
          function r2(l) {
            return l | 536870912;
          }
          function s2(l) {
            return ~l;
          }
          function p(l) {
            return ~l;
          }
          function n(l) {
            return l;
          }
          function a(l) {
            return l;
          }
          function u(l) {
            return l |= 0, l < 0 ? e2(l) : s2(l);
          }
          function i2(l) {
            return l |= 0, l > -536870913 ? p(l) : r2(l);
          }
          [1, 2, 3].forEach((l) => l), [1, -1].forEach((l) => i2(u(l)));
        } }), gt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/template.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.unwrapHandle = f3, t2.unwrapTemplate = h2, t2.extractHandle = d, t2.isOkHandle = c, t2.isErrHandle = o;
          function f3(e2) {
            if (typeof e2 == "number")
              return e2;
            {
              let r2 = e2.errors[0];
              throw new Error("Compile Error: ".concat(r2.problem, " @ ").concat(r2.span.start, "..").concat(r2.span.end));
            }
          }
          function h2(e2) {
            if (e2.result === "error")
              throw new Error("Compile Error: ".concat(e2.problem, " @ ").concat(e2.span.start, "..").concat(e2.span.end));
            return e2;
          }
          function d(e2) {
            return typeof e2 == "number" ? e2 : e2.handle;
          }
          function c(e2) {
            return typeof e2 == "number";
          }
          function o(e2) {
            return typeof e2 == "number";
          }
        } }), bt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/weak-set.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = void 0;
          var f3 = typeof WeakSet == "function" ? WeakSet : class {
            constructor() {
              this._map = /* @__PURE__ */ new WeakMap();
            }
            add(d) {
              return this._map.set(d, true), this;
            }
            delete(d) {
              return this._map.delete(d);
            }
            has(d) {
              return this._map.has(d);
            }
          };
          t2.default = f3;
        } }), vt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/simple-cast.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.castToSimple = h2, t2.castToBrowser = d, t2.checkNode = r2;
          var f3 = me();
          function h2(p) {
            return o(p) || e2(p), p;
          }
          function d(p, n) {
            if (p == null)
              return null;
            if (typeof document === void 0)
              throw new Error("Attempted to cast to a browser node in a non-browser context");
            if (o(p))
              return p;
            if (p.ownerDocument !== document)
              throw new Error("Attempted to cast to a browser node with a node that was not created from this document");
            return r2(p, n);
          }
          function c(p, n) {
            return new Error("cannot cast a ".concat(p, " into ").concat(n));
          }
          function o(p) {
            return p.nodeType === 9;
          }
          function e2(p) {
            return p.nodeType === 1;
          }
          function r2(p, n) {
            let a = false;
            if (p !== null)
              if (typeof n == "string")
                a = s2(p, n);
              else if (Array.isArray(n))
                a = n.some((u) => s2(p, u));
              else
                throw (0, f3.unreachable)();
            if (a)
              return p;
            throw c("SimpleElement(".concat(p, ")"), n);
          }
          function s2(p, n) {
            switch (n) {
              case "NODE":
                return true;
              case "HTML":
                return p instanceof HTMLElement;
              case "SVG":
                return p instanceof SVGElement;
              case "ELEMENT":
                return p instanceof Element;
              default:
                if (n.toUpperCase() === n)
                  throw new Error("BUG: this code is missing handling for a generic node type");
                return p instanceof Element && p.tagName.toLowerCase() === n;
            }
          }
        } }), yt = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/present.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.isPresent = f3, t2.ifPresent = h2, t2.toPresentOption = d, t2.assertPresent = c, t2.mapPresent = o;
          function f3(e2) {
            return e2.length > 0;
          }
          function h2(e2, r2, s2) {
            return f3(e2) ? r2(e2) : s2();
          }
          function d(e2) {
            return f3(e2) ? e2 : null;
          }
          function c(e2) {
            let r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "unexpected empty list";
            if (!f3(e2))
              throw new Error(r2);
          }
          function o(e2, r2) {
            if (e2 === null)
              return null;
            let s2 = [];
            for (let p of e2)
              s2.push(r2(p));
            return s2;
          }
        } }), At = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/untouchable-this.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = d;
          var f3 = fe(), h2 = me();
          function d(c) {
            let o = null;
            if (f3.DEBUG && h2.HAS_NATIVE_PROXY) {
              let e2 = (r2) => {
                throw new Error("You accessed `this.".concat(String(r2), "` from a function passed to the ").concat(c, ", but the function itself was not bound to a valid `this` context. Consider updating to use a bound function (for instance, use an arrow function, `() => {}`)."));
              };
              o = new Proxy({}, { get(r2, s2) {
                e2(s2);
              }, set(r2, s2) {
                return e2(s2), false;
              }, has(r2, s2) {
                return e2(s2), false;
              } });
            }
            return o;
          }
        } }), Et = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/debug-to-string.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = void 0;
          var f3 = fe(), h2;
          if (f3.DEBUG) {
            let c = (r2) => {
              let s2 = r2.name;
              if (s2 === void 0) {
                let p = Function.prototype.toString.call(r2).match(/function (\w+)\s*\(/);
                s2 = p && p[1] || "";
              }
              return s2.replace(/^bound /, "");
            }, o = (r2) => {
              let s2, p;
              return r2.constructor && typeof r2.constructor == "function" && (p = c(r2.constructor)), "toString" in r2 && r2.toString !== Object.prototype.toString && r2.toString !== Function.prototype.toString && (s2 = r2.toString()), s2 && s2.match(/<.*:ember\d+>/) && p && p[0] !== "_" && p.length > 2 && p !== "Class" ? s2.replace(/<.*:/, "<".concat(p, ":")) : s2 || p;
            }, e2 = (r2) => String(r2);
            h2 = (r2) => typeof r2 == "function" ? c(r2) || "(unknown function)" : typeof r2 == "object" && r2 !== null ? o(r2) || "(unknown object)" : e2(r2);
          }
          var d = h2;
          t2.default = d;
        } }), _t = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/lib/debug-steps.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.logStep = t2.verifySteps = t2.endTestSteps = t2.beginTestSteps = void 0;
          var f3 = d(Pe()), h2 = me();
          function d(s2) {
            return s2 && s2.__esModule ? s2 : { default: s2 };
          }
          var c;
          t2.beginTestSteps = c;
          var o;
          t2.endTestSteps = o;
          var e2;
          t2.verifySteps = e2;
          var r2;
          t2.logStep = r2;
        } }), X = I({ "node_modules/@glimmer/util/dist/commonjs/es2017/index.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true });
          var f3 = { LOCAL_LOGGER: true, LOGGER: true, assertNever: true, assert: true, deprecate: true, dict: true, isDict: true, isObject: true, Stack: true, isSerializationFirstNode: true, SERIALIZATION_FIRST_NODE_STRING: true, assign: true, fillNulls: true, values: true, _WeakSet: true, castToSimple: true, castToBrowser: true, checkNode: true, intern: true, buildUntouchableThis: true, debugToString: true, beginTestSteps: true, endTestSteps: true, logStep: true, verifySteps: true };
          t2.assertNever = x2, Object.defineProperty(t2, "assert", { enumerable: true, get: function() {
            return d.default;
          } }), Object.defineProperty(t2, "deprecate", { enumerable: true, get: function() {
            return d.deprecate;
          } }), Object.defineProperty(t2, "dict", { enumerable: true, get: function() {
            return c.dict;
          } }), Object.defineProperty(t2, "isDict", { enumerable: true, get: function() {
            return c.isDict;
          } }), Object.defineProperty(t2, "isObject", { enumerable: true, get: function() {
            return c.isObject;
          } }), Object.defineProperty(t2, "Stack", { enumerable: true, get: function() {
            return c.StackImpl;
          } }), Object.defineProperty(t2, "isSerializationFirstNode", { enumerable: true, get: function() {
            return e2.isSerializationFirstNode;
          } }), Object.defineProperty(t2, "SERIALIZATION_FIRST_NODE_STRING", { enumerable: true, get: function() {
            return e2.SERIALIZATION_FIRST_NODE_STRING;
          } }), Object.defineProperty(t2, "assign", { enumerable: true, get: function() {
            return r2.assign;
          } }), Object.defineProperty(t2, "fillNulls", { enumerable: true, get: function() {
            return r2.fillNulls;
          } }), Object.defineProperty(t2, "values", { enumerable: true, get: function() {
            return r2.values;
          } }), Object.defineProperty(t2, "_WeakSet", { enumerable: true, get: function() {
            return u.default;
          } }), Object.defineProperty(t2, "castToSimple", { enumerable: true, get: function() {
            return i2.castToSimple;
          } }), Object.defineProperty(t2, "castToBrowser", { enumerable: true, get: function() {
            return i2.castToBrowser;
          } }), Object.defineProperty(t2, "checkNode", { enumerable: true, get: function() {
            return i2.checkNode;
          } }), Object.defineProperty(t2, "intern", { enumerable: true, get: function() {
            return b.default;
          } }), Object.defineProperty(t2, "buildUntouchableThis", { enumerable: true, get: function() {
            return P.default;
          } }), Object.defineProperty(t2, "debugToString", { enumerable: true, get: function() {
            return E.default;
          } }), Object.defineProperty(t2, "beginTestSteps", { enumerable: true, get: function() {
            return v.beginTestSteps;
          } }), Object.defineProperty(t2, "endTestSteps", { enumerable: true, get: function() {
            return v.endTestSteps;
          } }), Object.defineProperty(t2, "logStep", { enumerable: true, get: function() {
            return v.logStep;
          } }), Object.defineProperty(t2, "verifySteps", { enumerable: true, get: function() {
            return v.verifySteps;
          } }), t2.LOGGER = t2.LOCAL_LOGGER = void 0;
          var h2 = lt();
          Object.keys(h2).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f3, w) || Object.defineProperty(t2, w, { enumerable: true, get: function() {
              return h2[w];
            } });
          });
          var d = g(Pe()), c = ct(), o = ht();
          Object.keys(o).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f3, w) || Object.defineProperty(t2, w, { enumerable: true, get: function() {
              return o[w];
            } });
          });
          var e2 = dt(), r2 = pt(), s2 = me();
          Object.keys(s2).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f3, w) || Object.defineProperty(t2, w, { enumerable: true, get: function() {
              return s2[w];
            } });
          });
          var p = ft();
          Object.keys(p).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f3, w) || Object.defineProperty(t2, w, { enumerable: true, get: function() {
              return p[w];
            } });
          });
          var n = mt();
          Object.keys(n).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f3, w) || Object.defineProperty(t2, w, { enumerable: true, get: function() {
              return n[w];
            } });
          });
          var a = gt();
          Object.keys(a).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f3, w) || Object.defineProperty(t2, w, { enumerable: true, get: function() {
              return a[w];
            } });
          });
          var u = _(bt()), i2 = vt(), l = yt();
          Object.keys(l).forEach(function(w) {
            w === "default" || w === "__esModule" || Object.prototype.hasOwnProperty.call(f3, w) || Object.defineProperty(t2, w, { enumerable: true, get: function() {
              return l[w];
            } });
          });
          var b = _(je()), P = _(At()), E = _(Et()), v = _t();
          function _(w) {
            return w && w.__esModule ? w : { default: w };
          }
          function y() {
            if (typeof WeakMap != "function")
              return null;
            var w = /* @__PURE__ */ new WeakMap();
            return y = function() {
              return w;
            }, w;
          }
          function g(w) {
            if (w && w.__esModule)
              return w;
            if (w === null || typeof w != "object" && typeof w != "function")
              return { default: w };
            var H = y();
            if (H && H.has(w))
              return H.get(w);
            var m2 = {}, C = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var S2 in w)
              if (Object.prototype.hasOwnProperty.call(w, S2)) {
                var R = C ? Object.getOwnPropertyDescriptor(w, S2) : null;
                R && (R.get || R.set) ? Object.defineProperty(m2, S2, R) : m2[S2] = w[S2];
              }
            return m2.default = w, H && H.set(w, m2), m2;
          }
          var L = console;
          t2.LOCAL_LOGGER = L;
          var j = console;
          t2.LOGGER = j;
          function x2(w) {
            let H = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "unexpected unreachable branch";
            throw j.log("unreachable", w), j.log("".concat(H, " :: ").concat(JSON.stringify(w), " (").concat(w, ")")), new Error("code reached unreachable");
          }
        } }), ge = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/location.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.isLocatedWithPositionsArray = s2, t2.isLocatedWithPositions = p, t2.BROKEN_LOCATION = t2.NON_EXISTENT_LOCATION = t2.TEMPORARY_LOCATION = t2.SYNTHETIC = t2.SYNTHETIC_LOCATION = t2.UNKNOWN_POSITION = void 0;
          var f3 = X(), h2 = Object.freeze({ line: 1, column: 0 });
          t2.UNKNOWN_POSITION = h2;
          var d = Object.freeze({ source: "(synthetic)", start: h2, end: h2 });
          t2.SYNTHETIC_LOCATION = d;
          var c = d;
          t2.SYNTHETIC = c;
          var o = Object.freeze({ source: "(temporary)", start: h2, end: h2 });
          t2.TEMPORARY_LOCATION = o;
          var e2 = Object.freeze({ source: "(nonexistent)", start: h2, end: h2 });
          t2.NON_EXISTENT_LOCATION = e2;
          var r2 = Object.freeze({ source: "(broken)", start: h2, end: h2 });
          t2.BROKEN_LOCATION = r2;
          function s2(n) {
            return (0, f3.isPresent)(n) && n.every(p);
          }
          function p(n) {
            return n.loc !== void 0;
          }
        } }), le = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/slice.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.SourceSlice = void 0;
          var f3 = ue(), h2 = class {
            constructor(d) {
              this.loc = d.loc, this.chars = d.chars;
            }
            static synthetic(d) {
              let c = f3.SourceSpan.synthetic(d);
              return new h2({ loc: c, chars: d });
            }
            static load(d, c) {
              return new h2({ loc: f3.SourceSpan.load(d, c[1]), chars: c[0] });
            }
            getString() {
              return this.chars;
            }
            serialize() {
              return [this.chars, this.loc.serialize()];
            }
          };
          t2.SourceSlice = h2;
        } }), Me = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/loc/match.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.match = e2, t2.IsInvisible = t2.MatchAny = void 0;
          var f3 = X(), h2 = "MATCH_ANY";
          t2.MatchAny = h2;
          var d = "IS_INVISIBLE";
          t2.IsInvisible = d;
          var c = class {
            constructor(p) {
              this._whens = p;
            }
            first(p) {
              for (let n of this._whens) {
                let a = n.match(p);
                if ((0, f3.isPresent)(a))
                  return a[0];
              }
              return null;
            }
          }, o = class {
            constructor() {
              this._map = /* @__PURE__ */ new Map();
            }
            get(p, n) {
              let a = this._map.get(p);
              return a || (a = n(), this._map.set(p, a), a);
            }
            add(p, n) {
              this._map.set(p, n);
            }
            match(p) {
              let n = s2(p), a = [], u = this._map.get(n), i2 = this._map.get(h2);
              return u && a.push(u), i2 && a.push(i2), a;
            }
          };
          function e2(p) {
            return p(new r2()).check();
          }
          var r2 = class {
            constructor() {
              this._whens = new o();
            }
            check() {
              return (p, n) => this.matchFor(p.kind, n.kind)(p, n);
            }
            matchFor(p, n) {
              let a = this._whens.match(p);
              return new c(a).first(n);
            }
            when(p, n, a) {
              return this._whens.get(p, () => new o()).add(n, a), this;
            }
          };
          function s2(p) {
            switch (p) {
              case "Broken":
              case "InternalsSynthetic":
              case "NonExistent":
                return d;
              default:
                return p;
            }
          }
        } }), He = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/loc/offset.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.InvisiblePosition = t2.HbsPosition = t2.CharPosition = t2.SourceOffset = t2.BROKEN = void 0;
          var f3 = ge(), h2 = Me(), d = Ve(), c = "BROKEN";
          t2.BROKEN = c;
          var o = class {
            constructor(n) {
              this.data = n;
            }
            static forHbsPos(n, a) {
              return new r2(n, a, null).wrap();
            }
            static broken() {
              let n = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : f3.UNKNOWN_POSITION;
              return new s2("Broken", n).wrap();
            }
            get offset() {
              let n = this.data.toCharPos();
              return n === null ? null : n.offset;
            }
            eql(n) {
              return p(this.data, n.data);
            }
            until(n) {
              return (0, d.span)(this.data, n.data);
            }
            move(n) {
              let a = this.data.toCharPos();
              if (a === null)
                return o.broken();
              {
                let u = a.offset + n;
                return a.source.check(u) ? new e2(a.source, u).wrap() : o.broken();
              }
            }
            collapsed() {
              return (0, d.span)(this.data, this.data);
            }
            toJSON() {
              return this.data.toJSON();
            }
          };
          t2.SourceOffset = o;
          var e2 = class {
            constructor(n, a) {
              this.source = n, this.charPos = a, this.kind = "CharPosition", this._locPos = null;
            }
            toCharPos() {
              return this;
            }
            toJSON() {
              let n = this.toHbsPos();
              return n === null ? f3.UNKNOWN_POSITION : n.toJSON();
            }
            wrap() {
              return new o(this);
            }
            get offset() {
              return this.charPos;
            }
            toHbsPos() {
              let n = this._locPos;
              if (n === null) {
                let a = this.source.hbsPosFor(this.charPos);
                a === null ? this._locPos = n = c : this._locPos = n = new r2(this.source, a, this.charPos);
              }
              return n === c ? null : n;
            }
          };
          t2.CharPosition = e2;
          var r2 = class {
            constructor(n, a) {
              let u = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.source = n, this.hbsPos = a, this.kind = "HbsPosition", this._charPos = u === null ? null : new e2(n, u);
            }
            toCharPos() {
              let n = this._charPos;
              if (n === null) {
                let a = this.source.charPosFor(this.hbsPos);
                a === null ? this._charPos = n = c : this._charPos = n = new e2(this.source, a);
              }
              return n === c ? null : n;
            }
            toJSON() {
              return this.hbsPos;
            }
            wrap() {
              return new o(this);
            }
            toHbsPos() {
              return this;
            }
          };
          t2.HbsPosition = r2;
          var s2 = class {
            constructor(n, a) {
              this.kind = n, this.pos = a;
            }
            toCharPos() {
              return null;
            }
            toJSON() {
              return this.pos;
            }
            wrap() {
              return new o(this);
            }
            get offset() {
              return null;
            }
          };
          t2.InvisiblePosition = s2;
          var p = (0, h2.match)((n) => n.when("HbsPosition", "HbsPosition", (a, u) => {
            let { hbsPos: i2 } = a, { hbsPos: l } = u;
            return i2.column === l.column && i2.line === l.line;
          }).when("CharPosition", "CharPosition", (a, u) => {
            let { charPos: i2 } = a, { charPos: l } = u;
            return i2 === l;
          }).when("CharPosition", "HbsPosition", (a, u) => {
            let { offset: i2 } = a;
            var l;
            return i2 === ((l = u.toCharPos()) === null || l === void 0 ? void 0 : l.offset);
          }).when("HbsPosition", "CharPosition", (a, u) => {
            let { offset: i2 } = u;
            var l;
            return ((l = a.toCharPos()) === null || l === void 0 ? void 0 : l.offset) === i2;
          }).when(h2.MatchAny, h2.MatchAny, () => false));
        } }), Ve = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/loc/span.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.span = t2.HbsSpan = t2.SourceSpan = void 0;
          var f3 = fe(), h2 = X(), d = ge(), c = le(), o = Me(), e2 = He(), r2 = class {
            constructor(u) {
              this.data = u, this.isInvisible = u.kind !== "CharPosition" && u.kind !== "HbsPosition";
            }
            static get NON_EXISTENT() {
              return new n("NonExistent", d.NON_EXISTENT_LOCATION).wrap();
            }
            static load(u, i2) {
              if (typeof i2 == "number")
                return r2.forCharPositions(u, i2, i2);
              if (typeof i2 == "string")
                return r2.synthetic(i2);
              if (Array.isArray(i2))
                return r2.forCharPositions(u, i2[0], i2[1]);
              if (i2 === "NonExistent")
                return r2.NON_EXISTENT;
              if (i2 === "Broken")
                return r2.broken(d.BROKEN_LOCATION);
              (0, h2.assertNever)(i2);
            }
            static forHbsLoc(u, i2) {
              let l = new e2.HbsPosition(u, i2.start), b = new e2.HbsPosition(u, i2.end);
              return new p(u, { start: l, end: b }, i2).wrap();
            }
            static forCharPositions(u, i2, l) {
              let b = new e2.CharPosition(u, i2), P = new e2.CharPosition(u, l);
              return new s2(u, { start: b, end: P }).wrap();
            }
            static synthetic(u) {
              return new n("InternalsSynthetic", d.NON_EXISTENT_LOCATION, u).wrap();
            }
            static broken() {
              let u = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : d.BROKEN_LOCATION;
              return new n("Broken", u).wrap();
            }
            getStart() {
              return this.data.getStart().wrap();
            }
            getEnd() {
              return this.data.getEnd().wrap();
            }
            get loc() {
              let u = this.data.toHbsSpan();
              return u === null ? d.BROKEN_LOCATION : u.toHbsLoc();
            }
            get module() {
              return this.data.getModule();
            }
            get startPosition() {
              return this.loc.start;
            }
            get endPosition() {
              return this.loc.end;
            }
            toJSON() {
              return this.loc;
            }
            withStart(u) {
              return a(u.data, this.data.getEnd());
            }
            withEnd(u) {
              return a(this.data.getStart(), u.data);
            }
            asString() {
              return this.data.asString();
            }
            toSlice(u) {
              let i2 = this.data.asString();
              return f3.DEBUG && u !== void 0 && i2 !== u && console.warn("unexpectedly found ".concat(JSON.stringify(i2), " when slicing source, but expected ").concat(JSON.stringify(u))), new c.SourceSlice({ loc: this, chars: u || i2 });
            }
            get start() {
              return this.loc.start;
            }
            set start(u) {
              this.data.locDidUpdate({ start: u });
            }
            get end() {
              return this.loc.end;
            }
            set end(u) {
              this.data.locDidUpdate({ end: u });
            }
            get source() {
              return this.module;
            }
            collapse(u) {
              switch (u) {
                case "start":
                  return this.getStart().collapsed();
                case "end":
                  return this.getEnd().collapsed();
              }
            }
            extend(u) {
              return a(this.data.getStart(), u.data.getEnd());
            }
            serialize() {
              return this.data.serialize();
            }
            slice(u) {
              let { skipStart: i2 = 0, skipEnd: l = 0 } = u;
              return a(this.getStart().move(i2).data, this.getEnd().move(-l).data);
            }
            sliceStartChars(u) {
              let { skipStart: i2 = 0, chars: l } = u;
              return a(this.getStart().move(i2).data, this.getStart().move(i2 + l).data);
            }
            sliceEndChars(u) {
              let { skipEnd: i2 = 0, chars: l } = u;
              return a(this.getEnd().move(i2 - l).data, this.getStart().move(-i2).data);
            }
          };
          t2.SourceSpan = r2;
          var s2 = class {
            constructor(u, i2) {
              this.source = u, this.charPositions = i2, this.kind = "CharPosition", this._locPosSpan = null;
            }
            wrap() {
              return new r2(this);
            }
            asString() {
              return this.source.slice(this.charPositions.start.charPos, this.charPositions.end.charPos);
            }
            getModule() {
              return this.source.module;
            }
            getStart() {
              return this.charPositions.start;
            }
            getEnd() {
              return this.charPositions.end;
            }
            locDidUpdate() {
            }
            toHbsSpan() {
              let u = this._locPosSpan;
              if (u === null) {
                let i2 = this.charPositions.start.toHbsPos(), l = this.charPositions.end.toHbsPos();
                i2 === null || l === null ? u = this._locPosSpan = e2.BROKEN : u = this._locPosSpan = new p(this.source, { start: i2, end: l });
              }
              return u === e2.BROKEN ? null : u;
            }
            serialize() {
              let { start: { charPos: u }, end: { charPos: i2 } } = this.charPositions;
              return u === i2 ? u : [u, i2];
            }
            toCharPosSpan() {
              return this;
            }
          }, p = class {
            constructor(u, i2) {
              let l = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.source = u, this.hbsPositions = i2, this.kind = "HbsPosition", this._charPosSpan = null, this._providedHbsLoc = l;
            }
            serialize() {
              let u = this.toCharPosSpan();
              return u === null ? "Broken" : u.wrap().serialize();
            }
            wrap() {
              return new r2(this);
            }
            updateProvided(u, i2) {
              this._providedHbsLoc && (this._providedHbsLoc[i2] = u), this._charPosSpan = null, this._providedHbsLoc = { start: u, end: u };
            }
            locDidUpdate(u) {
              let { start: i2, end: l } = u;
              i2 !== void 0 && (this.updateProvided(i2, "start"), this.hbsPositions.start = new e2.HbsPosition(this.source, i2, null)), l !== void 0 && (this.updateProvided(l, "end"), this.hbsPositions.end = new e2.HbsPosition(this.source, l, null));
            }
            asString() {
              let u = this.toCharPosSpan();
              return u === null ? "" : u.asString();
            }
            getModule() {
              return this.source.module;
            }
            getStart() {
              return this.hbsPositions.start;
            }
            getEnd() {
              return this.hbsPositions.end;
            }
            toHbsLoc() {
              return { start: this.hbsPositions.start.hbsPos, end: this.hbsPositions.end.hbsPos };
            }
            toHbsSpan() {
              return this;
            }
            toCharPosSpan() {
              let u = this._charPosSpan;
              if (u === null) {
                let i2 = this.hbsPositions.start.toCharPos(), l = this.hbsPositions.end.toCharPos();
                if (i2 && l)
                  u = this._charPosSpan = new s2(this.source, { start: i2, end: l });
                else
                  return u = this._charPosSpan = e2.BROKEN, null;
              }
              return u === e2.BROKEN ? null : u;
            }
          };
          t2.HbsSpan = p;
          var n = class {
            constructor(u, i2) {
              let l = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.kind = u, this.loc = i2, this.string = l;
            }
            serialize() {
              switch (this.kind) {
                case "Broken":
                case "NonExistent":
                  return this.kind;
                case "InternalsSynthetic":
                  return this.string || "";
              }
            }
            wrap() {
              return new r2(this);
            }
            asString() {
              return this.string || "";
            }
            locDidUpdate(u) {
              let { start: i2, end: l } = u;
              i2 !== void 0 && (this.loc.start = i2), l !== void 0 && (this.loc.end = l);
            }
            getModule() {
              return "an unknown module";
            }
            getStart() {
              return new e2.InvisiblePosition(this.kind, this.loc.start);
            }
            getEnd() {
              return new e2.InvisiblePosition(this.kind, this.loc.end);
            }
            toCharPosSpan() {
              return this;
            }
            toHbsSpan() {
              return null;
            }
            toHbsLoc() {
              return d.BROKEN_LOCATION;
            }
          }, a = (0, o.match)((u) => u.when("HbsPosition", "HbsPosition", (i2, l) => new p(i2.source, { start: i2, end: l }).wrap()).when("CharPosition", "CharPosition", (i2, l) => new s2(i2.source, { start: i2, end: l }).wrap()).when("CharPosition", "HbsPosition", (i2, l) => {
            let b = l.toCharPos();
            return b === null ? new n("Broken", d.BROKEN_LOCATION).wrap() : a(i2, b);
          }).when("HbsPosition", "CharPosition", (i2, l) => {
            let b = i2.toCharPos();
            return b === null ? new n("Broken", d.BROKEN_LOCATION).wrap() : a(b, l);
          }).when(o.IsInvisible, o.MatchAny, (i2) => new n(i2.kind, d.BROKEN_LOCATION).wrap()).when(o.MatchAny, o.IsInvisible, (i2, l) => new n(l.kind, d.BROKEN_LOCATION).wrap()));
          t2.span = a;
        } }), ue = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/span.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), Object.defineProperty(t2, "SourceSpan", { enumerable: true, get: function() {
            return f3.SourceSpan;
          } }), Object.defineProperty(t2, "SourceOffset", { enumerable: true, get: function() {
            return h2.SourceOffset;
          } });
          var f3 = Ve(), h2 = He();
        } }), De = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/source.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.Source = void 0;
          var f3 = fe(), h2 = X(), d = ue(), c = class {
            constructor(o) {
              let e2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "an unknown module";
              this.source = o, this.module = e2;
            }
            check(o) {
              return o >= 0 && o <= this.source.length;
            }
            slice(o, e2) {
              return this.source.slice(o, e2);
            }
            offsetFor(o, e2) {
              return d.SourceOffset.forHbsPos(this, { line: o, column: e2 });
            }
            spanFor(o) {
              let { start: e2, end: r2 } = o;
              return d.SourceSpan.forHbsLoc(this, { start: { line: e2.line, column: e2.column }, end: { line: r2.line, column: r2.column } });
            }
            hbsPosFor(o) {
              let e2 = 0, r2 = 0;
              if (o > this.source.length)
                return null;
              for (; ; ) {
                let s2 = this.source.indexOf(`
`, r2);
                if (o <= s2 || s2 === -1)
                  return { line: e2 + 1, column: o - r2 };
                e2 += 1, r2 = s2 + 1;
              }
            }
            charPosFor(o) {
              let { line: e2, column: r2 } = o, p = this.source.length, n = 0, a = 0;
              for (; ; ) {
                if (a >= p)
                  return p;
                let u = this.source.indexOf(`
`, a);
                if (u === -1 && (u = this.source.length), n === e2 - 1) {
                  if (a + r2 > u)
                    return u;
                  if (f3.DEBUG) {
                    let i2 = this.hbsPosFor(a + r2);
                  }
                  return a + r2;
                } else {
                  if (u === -1)
                    return 0;
                  n += 1, a = u + 1;
                }
              }
            }
          };
          t2.Source = c;
        } }), we = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/legacy-interop.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.PathExpressionImplV1 = void 0;
          var f3 = h2(ke());
          function h2(c) {
            return c && c.__esModule ? c : { default: c };
          }
          var d = class {
            constructor(c, o, e2, r2) {
              this.original = c, this.loc = r2, this.type = "PathExpression", this.this = false, this.data = false, this._head = void 0;
              let s2 = e2.slice();
              o.type === "ThisHead" ? this.this = true : o.type === "AtHead" ? (this.data = true, s2.unshift(o.name.slice(1))) : s2.unshift(o.name), this.parts = s2;
            }
            get head() {
              if (this._head)
                return this._head;
              let c;
              this.this ? c = "this" : this.data ? c = "@".concat(this.parts[0]) : c = this.parts[0];
              let o = this.loc.collapse("start").sliceStartChars({ chars: c.length }).loc;
              return this._head = f3.default.head(c, o);
            }
            get tail() {
              return this.this ? this.parts : this.parts.slice(1);
            }
          };
          t2.PathExpressionImplV1 = d;
        } }), ke = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/public-builders.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = void 0;
          var f3 = X(), h2 = ge(), d = De(), c = ue(), o = we(), e2;
          function r2() {
            return e2 || (e2 = new d.Source("", "(synthetic)")), e2;
          }
          function s2(T, N, k, B, O, q) {
            return typeof T == "string" && (T = m2(T)), { type: "MustacheStatement", path: T, params: N || [], hash: k || S2([]), escaped: !B, trusting: !!B, loc: U(O || null), strip: q || { open: false, close: false } };
          }
          function p(T, N, k, B, O, q, z, A2, Q) {
            let D, $;
            return B.type === "Template" ? D = (0, f3.assign)({}, B, { type: "Block" }) : D = B, O != null && O.type === "Template" ? $ = (0, f3.assign)({}, O, { type: "Block" }) : $ = O, { type: "BlockStatement", path: m2(T), params: N || [], hash: k || S2([]), program: D || null, inverse: $ || null, loc: U(q || null), openStrip: z || { open: false, close: false }, inverseStrip: A2 || { open: false, close: false }, closeStrip: Q || { open: false, close: false } };
          }
          function n(T, N, k, B) {
            return { type: "ElementModifierStatement", path: m2(T), params: N || [], hash: k || S2([]), loc: U(B || null) };
          }
          function a(T, N, k, B, O) {
            return { type: "PartialStatement", name: T, params: N || [], hash: k || S2([]), indent: B || "", strip: { open: false, close: false }, loc: U(O || null) };
          }
          function u(T, N) {
            return { type: "CommentStatement", value: T, loc: U(N || null) };
          }
          function i2(T, N) {
            return { type: "MustacheCommentStatement", value: T, loc: U(N || null) };
          }
          function l(T, N) {
            if (!(0, f3.isPresent)(T))
              throw new Error("b.concat requires at least one part");
            return { type: "ConcatStatement", parts: T || [], loc: U(N || null) };
          }
          function b(T) {
            let N = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, { attrs: k, blockParams: B, modifiers: O, comments: q, children: z, loc: A2 } = N, Q, D = false;
            return typeof T == "object" ? (D = T.selfClosing, Q = T.name) : T.slice(-1) === "/" ? (Q = T.slice(0, -1), D = true) : Q = T, { type: "ElementNode", tag: Q, selfClosing: D, attributes: k || [], blockParams: B || [], modifiers: O || [], comments: q || [], children: z || [], loc: U(A2 || null) };
          }
          function P(T, N, k) {
            return { type: "AttrNode", name: T, value: N, loc: U(k || null) };
          }
          function E(T, N) {
            return { type: "TextNode", chars: T || "", loc: U(N || null) };
          }
          function v(T, N, k, B) {
            return { type: "SubExpression", path: m2(T), params: N || [], hash: k || S2([]), loc: U(B || null) };
          }
          function _(T) {
            switch (T.type) {
              case "AtHead":
                return { original: T.name, parts: [T.name] };
              case "ThisHead":
                return { original: "this", parts: [] };
              case "VarHead":
                return { original: T.name, parts: [T.name] };
            }
          }
          function y(T, N) {
            let [k, ...B] = T.split("."), O;
            return k === "this" ? O = { type: "ThisHead", loc: U(N || null) } : k[0] === "@" ? O = { type: "AtHead", name: k, loc: U(N || null) } : O = { type: "VarHead", name: k, loc: U(N || null) }, { head: O, tail: B };
          }
          function g(T) {
            return { type: "ThisHead", loc: U(T || null) };
          }
          function L(T, N) {
            return { type: "AtHead", name: T, loc: U(N || null) };
          }
          function j(T, N) {
            return { type: "VarHead", name: T, loc: U(N || null) };
          }
          function x2(T, N) {
            return T[0] === "@" ? L(T, N) : T === "this" ? g(N) : j(T, N);
          }
          function w(T, N) {
            return { type: "NamedBlockName", name: T, loc: U(N || null) };
          }
          function H(T, N, k) {
            let { original: B, parts: O } = _(T), q = [...O, ...N], z = [...B, ...q].join(".");
            return new o.PathExpressionImplV1(z, T, N, U(k || null));
          }
          function m2(T, N) {
            if (typeof T != "string") {
              if ("type" in T)
                return T;
              {
                let { head: O, tail: q } = y(T.head, c.SourceSpan.broken()), { original: z } = _(O);
                return new o.PathExpressionImplV1([z, ...q].join("."), O, q, U(N || null));
              }
            }
            let { head: k, tail: B } = y(T, c.SourceSpan.broken());
            return new o.PathExpressionImplV1(T, k, B, U(N || null));
          }
          function C(T, N, k) {
            return { type: T, value: N, original: N, loc: U(k || null) };
          }
          function S2(T, N) {
            return { type: "Hash", pairs: T || [], loc: U(N || null) };
          }
          function R(T, N, k) {
            return { type: "HashPair", key: T, value: N, loc: U(k || null) };
          }
          function M(T, N, k) {
            return { type: "Template", body: T || [], blockParams: N || [], loc: U(k || null) };
          }
          function V(T, N) {
            let k = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, B = arguments.length > 3 ? arguments[3] : void 0;
            return { type: "Block", body: T || [], blockParams: N || [], chained: k, loc: U(B || null) };
          }
          function G(T, N, k) {
            return { type: "Template", body: T || [], blockParams: N || [], loc: U(k || null) };
          }
          function K(T, N) {
            return { line: T, column: N };
          }
          function U() {
            for (var T = arguments.length, N = new Array(T), k = 0; k < T; k++)
              N[k] = arguments[k];
            if (N.length === 1) {
              let B = N[0];
              return B && typeof B == "object" ? c.SourceSpan.forHbsLoc(r2(), B) : c.SourceSpan.forHbsLoc(r2(), h2.SYNTHETIC_LOCATION);
            } else {
              let [B, O, q, z, A2] = N, Q = A2 ? new d.Source("", A2) : r2();
              return c.SourceSpan.forHbsLoc(Q, { start: { line: B, column: O }, end: { line: q, column: z } });
            }
          }
          var Z2 = { mustache: s2, block: p, partial: a, comment: u, mustacheComment: i2, element: b, elementModifier: n, attr: P, text: E, sexpr: v, concat: l, hash: S2, pair: R, literal: C, program: M, blockItself: V, template: G, loc: U, pos: K, path: m2, fullPath: H, head: x2, at: L, var: j, this: g, blockName: w, string: W("StringLiteral"), boolean: W("BooleanLiteral"), number: W("NumberLiteral"), undefined() {
            return C("UndefinedLiteral", void 0);
          }, null() {
            return C("NullLiteral", null);
          } };
          t2.default = Z2;
          function W(T) {
            return function(N, k) {
              return C(T, N, k);
            };
          }
        } }), St = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/nodes-v1.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true });
        } }), Ct = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/api.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true });
          var f3 = St();
          Object.keys(f3).forEach(function(h2) {
            h2 === "default" || h2 === "__esModule" || Object.defineProperty(t2, h2, { enumerable: true, get: function() {
              return f3[h2];
            } });
          });
        } }), Pt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/resolution.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.loadResolution = o, t2.ARGUMENT_RESOLUTION = t2.LooseModeResolution = t2.STRICT_RESOLUTION = t2.StrictResolution = void 0;
          var f3 = class {
            constructor() {
              this.isAngleBracket = false;
            }
            resolution() {
              return 31;
            }
            serialize() {
              return "Strict";
            }
          };
          t2.StrictResolution = f3;
          var h2 = new f3();
          t2.STRICT_RESOLUTION = h2;
          var d = class {
            constructor(e2) {
              let r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              this.ambiguity = e2, this.isAngleBracket = r2;
            }
            static namespaced(e2) {
              let r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              return new d({ namespaces: [e2], fallback: false }, r2);
            }
            static fallback() {
              return new d({ namespaces: [], fallback: true });
            }
            static append(e2) {
              let { invoke: r2 } = e2;
              return new d({ namespaces: ["Component", "Helper"], fallback: !r2 });
            }
            static trustingAppend(e2) {
              let { invoke: r2 } = e2;
              return new d({ namespaces: ["Helper"], fallback: !r2 });
            }
            static attr() {
              return new d({ namespaces: ["Helper"], fallback: true });
            }
            resolution() {
              if (this.ambiguity.namespaces.length === 0)
                return 31;
              if (this.ambiguity.namespaces.length === 1) {
                if (this.ambiguity.fallback)
                  return 36;
                switch (this.ambiguity.namespaces[0]) {
                  case "Helper":
                    return 37;
                  case "Modifier":
                    return 38;
                  case "Component":
                    return 39;
                }
              } else
                return this.ambiguity.fallback ? 34 : 35;
            }
            serialize() {
              return this.ambiguity.namespaces.length === 0 ? "Loose" : this.ambiguity.namespaces.length === 1 ? this.ambiguity.fallback ? ["ambiguous", "Attr"] : ["ns", this.ambiguity.namespaces[0]] : this.ambiguity.fallback ? ["ambiguous", "Append"] : ["ambiguous", "Invoke"];
            }
          };
          t2.LooseModeResolution = d;
          var c = d.fallback();
          t2.ARGUMENT_RESOLUTION = c;
          function o(e2) {
            if (typeof e2 == "string")
              switch (e2) {
                case "Loose":
                  return d.fallback();
                case "Strict":
                  return h2;
              }
            switch (e2[0]) {
              case "ambiguous":
                switch (e2[1]) {
                  case "Append":
                    return d.append({ invoke: false });
                  case "Attr":
                    return d.attr();
                  case "Invoke":
                    return d.append({ invoke: true });
                }
              case "ns":
                return d.namespaced(e2[1]);
            }
          }
        } }), ne = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/node.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.node = h2;
          var f3 = X();
          function h2(d) {
            if (d !== void 0) {
              let c = d;
              return { fields() {
                return class {
                  constructor(o) {
                    this.type = c, (0, f3.assign)(this, o);
                  }
                };
              } };
            } else
              return { fields() {
                return class {
                  constructor(c) {
                    (0, f3.assign)(this, c);
                  }
                };
              } };
          }
        } }), be = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/args.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.NamedArgument = t2.NamedArguments = t2.PositionalArguments = t2.Args = void 0;
          var f3 = ne(), h2 = class extends (0, f3.node)().fields() {
            static empty(e2) {
              return new h2({ loc: e2, positional: d.empty(e2), named: c.empty(e2) });
            }
            static named(e2) {
              return new h2({ loc: e2.loc, positional: d.empty(e2.loc.collapse("end")), named: e2 });
            }
            nth(e2) {
              return this.positional.nth(e2);
            }
            get(e2) {
              return this.named.get(e2);
            }
            isEmpty() {
              return this.positional.isEmpty() && this.named.isEmpty();
            }
          };
          t2.Args = h2;
          var d = class extends (0, f3.node)().fields() {
            static empty(e2) {
              return new d({ loc: e2, exprs: [] });
            }
            get size() {
              return this.exprs.length;
            }
            nth(e2) {
              return this.exprs[e2] || null;
            }
            isEmpty() {
              return this.exprs.length === 0;
            }
          };
          t2.PositionalArguments = d;
          var c = class extends (0, f3.node)().fields() {
            static empty(e2) {
              return new c({ loc: e2, entries: [] });
            }
            get size() {
              return this.entries.length;
            }
            get(e2) {
              let r2 = this.entries.filter((s2) => s2.name.chars === e2)[0];
              return r2 ? r2.value : null;
            }
            isEmpty() {
              return this.entries.length === 0;
            }
          };
          t2.NamedArguments = c;
          var o = class {
            constructor(e2) {
              this.loc = e2.name.loc.extend(e2.value.loc), this.name = e2.name, this.value = e2.value;
            }
          };
          t2.NamedArgument = o;
        } }), Dt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/attr-block.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.ElementModifier = t2.ComponentArg = t2.SplatAttr = t2.HtmlAttr = void 0;
          var f3 = be(), h2 = ne(), d = class extends (0, h2.node)("HtmlAttr").fields() {
          };
          t2.HtmlAttr = d;
          var c = class extends (0, h2.node)("SplatAttr").fields() {
          };
          t2.SplatAttr = c;
          var o = class extends (0, h2.node)().fields() {
            toNamedArgument() {
              return new f3.NamedArgument({ name: this.name, value: this.value });
            }
          };
          t2.ComponentArg = o;
          var e2 = class extends (0, h2.node)("ElementModifier").fields() {
          };
          t2.ElementModifier = e2;
        } }), wt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/base.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true });
        } }), ce = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/source/span-list.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.loc = d, t2.hasSpan = c, t2.maybeLoc = o, t2.SpanList = void 0;
          var f3 = ue(), h2 = class {
            constructor() {
              let e2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : [];
              this._span = e2;
            }
            static range(e2) {
              let r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : f3.SourceSpan.NON_EXISTENT;
              return new h2(e2.map(d)).getRangeOffset(r2);
            }
            add(e2) {
              this._span.push(e2);
            }
            getRangeOffset(e2) {
              if (this._span.length === 0)
                return e2;
              {
                let r2 = this._span[0], s2 = this._span[this._span.length - 1];
                return r2.extend(s2);
              }
            }
          };
          t2.SpanList = h2;
          function d(e2) {
            if (Array.isArray(e2)) {
              let r2 = e2[0], s2 = e2[e2.length - 1];
              return d(r2).extend(d(s2));
            } else
              return e2 instanceof f3.SourceSpan ? e2 : e2.loc;
          }
          function c(e2) {
            return !(Array.isArray(e2) && e2.length === 0);
          }
          function o(e2, r2) {
            return c(e2) ? d(e2) : r2;
          }
        } }), kt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/content.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.SimpleElement = t2.InvokeComponent = t2.InvokeBlock = t2.AppendContent = t2.HtmlComment = t2.HtmlText = t2.GlimmerComment = void 0;
          var f3 = ce(), h2 = be(), d = ne(), c = class extends (0, d.node)("GlimmerComment").fields() {
          };
          t2.GlimmerComment = c;
          var o = class extends (0, d.node)("HtmlText").fields() {
          };
          t2.HtmlText = o;
          var e2 = class extends (0, d.node)("HtmlComment").fields() {
          };
          t2.HtmlComment = e2;
          var r2 = class extends (0, d.node)("AppendContent").fields() {
            get callee() {
              return this.value.type === "Call" ? this.value.callee : this.value;
            }
            get args() {
              return this.value.type === "Call" ? this.value.args : h2.Args.empty(this.value.loc.collapse("end"));
            }
          };
          t2.AppendContent = r2;
          var s2 = class extends (0, d.node)("InvokeBlock").fields() {
          };
          t2.InvokeBlock = s2;
          var p = class extends (0, d.node)("InvokeComponent").fields() {
            get args() {
              let a = this.componentArgs.map((u) => u.toNamedArgument());
              return h2.Args.named(new h2.NamedArguments({ loc: f3.SpanList.range(a, this.callee.loc.collapse("end")), entries: a }));
            }
          };
          t2.InvokeComponent = p;
          var n = class extends (0, d.node)("SimpleElement").fields() {
            get args() {
              let a = this.componentArgs.map((u) => u.toNamedArgument());
              return h2.Args.named(new h2.NamedArguments({ loc: f3.SpanList.range(a, this.tag.loc.collapse("end")), entries: a }));
            }
          };
          t2.SimpleElement = n;
        } }), Tt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/expr.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.isLiteral = c, t2.InterpolateExpression = t2.DeprecatedCallExpression = t2.CallExpression = t2.PathExpression = t2.LiteralExpression = void 0;
          var f3 = le(), h2 = ne(), d = class extends (0, h2.node)("Literal").fields() {
            toSlice() {
              return new f3.SourceSlice({ loc: this.loc, chars: this.value });
            }
          };
          t2.LiteralExpression = d;
          function c(p, n) {
            return p.type === "Literal" ? n === void 0 ? true : n === "null" ? p.value === null : typeof p.value === n : false;
          }
          var o = class extends (0, h2.node)("Path").fields() {
          };
          t2.PathExpression = o;
          var e2 = class extends (0, h2.node)("Call").fields() {
          };
          t2.CallExpression = e2;
          var r2 = class extends (0, h2.node)("DeprecatedCall").fields() {
          };
          t2.DeprecatedCallExpression = r2;
          var s2 = class extends (0, h2.node)("Interpolate").fields() {
          };
          t2.InterpolateExpression = s2;
        } }), Bt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/refs.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.FreeVarReference = t2.LocalVarReference = t2.ArgReference = t2.ThisReference = void 0;
          var f3 = ne(), h2 = class extends (0, f3.node)("This").fields() {
          };
          t2.ThisReference = h2;
          var d = class extends (0, f3.node)("Arg").fields() {
          };
          t2.ArgReference = d;
          var c = class extends (0, f3.node)("Local").fields() {
          };
          t2.LocalVarReference = c;
          var o = class extends (0, f3.node)("Free").fields() {
          };
          t2.FreeVarReference = o;
        } }), Ot = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/objects/internal-node.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.NamedBlock = t2.NamedBlocks = t2.Block = t2.Template = void 0;
          var f3 = ce(), h2 = be(), d = ne(), c = class extends (0, d.node)().fields() {
          };
          t2.Template = c;
          var o = class extends (0, d.node)().fields() {
          };
          t2.Block = o;
          var e2 = class extends (0, d.node)().fields() {
            get(s2) {
              return this.blocks.filter((p) => p.name.chars === s2)[0] || null;
            }
          };
          t2.NamedBlocks = e2;
          var r2 = class extends (0, d.node)().fields() {
            get args() {
              let s2 = this.componentArgs.map((p) => p.toNamedArgument());
              return h2.Args.named(new h2.NamedArguments({ loc: f3.SpanList.range(s2, this.name.loc.collapse("end")), entries: s2 }));
            }
          };
          t2.NamedBlock = r2;
        } }), ve = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/api.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true });
          var f3 = Pt();
          Object.keys(f3).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return f3[n];
            } });
          });
          var h2 = ne();
          Object.keys(h2).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return h2[n];
            } });
          });
          var d = be();
          Object.keys(d).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return d[n];
            } });
          });
          var c = Dt();
          Object.keys(c).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return c[n];
            } });
          });
          var o = wt();
          Object.keys(o).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return o[n];
            } });
          });
          var e2 = kt();
          Object.keys(e2).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return e2[n];
            } });
          });
          var r2 = Tt();
          Object.keys(r2).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return r2[n];
            } });
          });
          var s2 = Bt();
          Object.keys(s2).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return s2[n];
            } });
          });
          var p = Ot();
          Object.keys(p).forEach(function(n) {
            n === "default" || n === "__esModule" || Object.defineProperty(t2, n, { enumerable: true, get: function() {
              return p[n];
            } });
          });
        } }), Ue = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/generation/util.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.escapeAttrValue = r2, t2.escapeText = s2, t2.sortByLoc = p;
          var f3 = /[\xA0"&]/, h2 = new RegExp(f3.source, "g"), d = /[\xA0&<>]/, c = new RegExp(d.source, "g");
          function o(n) {
            switch (n.charCodeAt(0)) {
              case 160:
                return "&nbsp;";
              case 34:
                return "&quot;";
              case 38:
                return "&amp;";
              default:
                return n;
            }
          }
          function e2(n) {
            switch (n.charCodeAt(0)) {
              case 160:
                return "&nbsp;";
              case 38:
                return "&amp;";
              case 60:
                return "&lt;";
              case 62:
                return "&gt;";
              default:
                return n;
            }
          }
          function r2(n) {
            return f3.test(n) ? n.replace(h2, o) : n;
          }
          function s2(n) {
            return d.test(n) ? n.replace(c, e2) : n;
          }
          function p(n, a) {
            return n.loc.isInvisible || a.loc.isInvisible ? 0 : n.loc.startPosition.line < a.loc.startPosition.line || n.loc.startPosition.line === a.loc.startPosition.line && n.loc.startPosition.column < a.loc.startPosition.column ? -1 : n.loc.startPosition.line === a.loc.startPosition.line && n.loc.startPosition.column === a.loc.startPosition.column ? 0 : 1;
          }
        } }), Te = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/generation/printer.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = t2.voidMap = void 0;
          var f3 = Ue(), h2 = /* @__PURE__ */ Object.create(null);
          t2.voidMap = h2;
          var d = "area base br col command embed hr img input keygen link meta param source track wbr";
          d.split(" ").forEach((e2) => {
            h2[e2] = true;
          });
          var c = /\S/, o = class {
            constructor(e2) {
              this.buffer = "", this.options = e2;
            }
            handledByOverride(e2) {
              let r2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : false;
              if (this.options.override !== void 0) {
                let s2 = this.options.override(e2, this.options);
                if (typeof s2 == "string")
                  return r2 && s2 !== "" && c.test(s2[0]) && (s2 = " ".concat(s2)), this.buffer += s2, true;
              }
              return false;
            }
            Node(e2) {
              switch (e2.type) {
                case "MustacheStatement":
                case "BlockStatement":
                case "PartialStatement":
                case "MustacheCommentStatement":
                case "CommentStatement":
                case "TextNode":
                case "ElementNode":
                case "AttrNode":
                case "Block":
                case "Template":
                  return this.TopLevelStatement(e2);
                case "StringLiteral":
                case "BooleanLiteral":
                case "NumberLiteral":
                case "UndefinedLiteral":
                case "NullLiteral":
                case "PathExpression":
                case "SubExpression":
                  return this.Expression(e2);
                case "Program":
                  return this.Block(e2);
                case "ConcatStatement":
                  return this.ConcatStatement(e2);
                case "Hash":
                  return this.Hash(e2);
                case "HashPair":
                  return this.HashPair(e2);
                case "ElementModifierStatement":
                  return this.ElementModifierStatement(e2);
              }
            }
            Expression(e2) {
              switch (e2.type) {
                case "StringLiteral":
                case "BooleanLiteral":
                case "NumberLiteral":
                case "UndefinedLiteral":
                case "NullLiteral":
                  return this.Literal(e2);
                case "PathExpression":
                  return this.PathExpression(e2);
                case "SubExpression":
                  return this.SubExpression(e2);
              }
            }
            Literal(e2) {
              switch (e2.type) {
                case "StringLiteral":
                  return this.StringLiteral(e2);
                case "BooleanLiteral":
                  return this.BooleanLiteral(e2);
                case "NumberLiteral":
                  return this.NumberLiteral(e2);
                case "UndefinedLiteral":
                  return this.UndefinedLiteral(e2);
                case "NullLiteral":
                  return this.NullLiteral(e2);
              }
            }
            TopLevelStatement(e2) {
              switch (e2.type) {
                case "MustacheStatement":
                  return this.MustacheStatement(e2);
                case "BlockStatement":
                  return this.BlockStatement(e2);
                case "PartialStatement":
                  return this.PartialStatement(e2);
                case "MustacheCommentStatement":
                  return this.MustacheCommentStatement(e2);
                case "CommentStatement":
                  return this.CommentStatement(e2);
                case "TextNode":
                  return this.TextNode(e2);
                case "ElementNode":
                  return this.ElementNode(e2);
                case "Block":
                case "Template":
                  return this.Block(e2);
                case "AttrNode":
                  return this.AttrNode(e2);
              }
            }
            Block(e2) {
              if (e2.chained) {
                let r2 = e2.body[0];
                r2.chained = true;
              }
              this.handledByOverride(e2) || this.TopLevelStatements(e2.body);
            }
            TopLevelStatements(e2) {
              e2.forEach((r2) => this.TopLevelStatement(r2));
            }
            ElementNode(e2) {
              this.handledByOverride(e2) || (this.OpenElementNode(e2), this.TopLevelStatements(e2.children), this.CloseElementNode(e2));
            }
            OpenElementNode(e2) {
              this.buffer += "<".concat(e2.tag);
              let r2 = [...e2.attributes, ...e2.modifiers, ...e2.comments].sort(f3.sortByLoc);
              for (let s2 of r2)
                switch (this.buffer += " ", s2.type) {
                  case "AttrNode":
                    this.AttrNode(s2);
                    break;
                  case "ElementModifierStatement":
                    this.ElementModifierStatement(s2);
                    break;
                  case "MustacheCommentStatement":
                    this.MustacheCommentStatement(s2);
                    break;
                }
              e2.blockParams.length && this.BlockParams(e2.blockParams), e2.selfClosing && (this.buffer += " /"), this.buffer += ">";
            }
            CloseElementNode(e2) {
              e2.selfClosing || h2[e2.tag.toLowerCase()] || (this.buffer += "</".concat(e2.tag, ">"));
            }
            AttrNode(e2) {
              if (this.handledByOverride(e2))
                return;
              let { name: r2, value: s2 } = e2;
              this.buffer += r2, (s2.type !== "TextNode" || s2.chars.length > 0) && (this.buffer += "=", this.AttrNodeValue(s2));
            }
            AttrNodeValue(e2) {
              e2.type === "TextNode" ? (this.buffer += '"', this.TextNode(e2, true), this.buffer += '"') : this.Node(e2);
            }
            TextNode(e2, r2) {
              this.handledByOverride(e2) || (this.options.entityEncoding === "raw" ? this.buffer += e2.chars : r2 ? this.buffer += (0, f3.escapeAttrValue)(e2.chars) : this.buffer += (0, f3.escapeText)(e2.chars));
            }
            MustacheStatement(e2) {
              this.handledByOverride(e2) || (this.buffer += e2.escaped ? "{{" : "{{{", e2.strip.open && (this.buffer += "~"), this.Expression(e2.path), this.Params(e2.params), this.Hash(e2.hash), e2.strip.close && (this.buffer += "~"), this.buffer += e2.escaped ? "}}" : "}}}");
            }
            BlockStatement(e2) {
              this.handledByOverride(e2) || (e2.chained ? (this.buffer += e2.inverseStrip.open ? "{{~" : "{{", this.buffer += "else ") : this.buffer += e2.openStrip.open ? "{{~#" : "{{#", this.Expression(e2.path), this.Params(e2.params), this.Hash(e2.hash), e2.program.blockParams.length && this.BlockParams(e2.program.blockParams), e2.chained ? this.buffer += e2.inverseStrip.close ? "~}}" : "}}" : this.buffer += e2.openStrip.close ? "~}}" : "}}", this.Block(e2.program), e2.inverse && (e2.inverse.chained || (this.buffer += e2.inverseStrip.open ? "{{~" : "{{", this.buffer += "else", this.buffer += e2.inverseStrip.close ? "~}}" : "}}"), this.Block(e2.inverse)), e2.chained || (this.buffer += e2.closeStrip.open ? "{{~/" : "{{/", this.Expression(e2.path), this.buffer += e2.closeStrip.close ? "~}}" : "}}"));
            }
            BlockParams(e2) {
              this.buffer += " as |".concat(e2.join(" "), "|");
            }
            PartialStatement(e2) {
              this.handledByOverride(e2) || (this.buffer += "{{>", this.Expression(e2.name), this.Params(e2.params), this.Hash(e2.hash), this.buffer += "}}");
            }
            ConcatStatement(e2) {
              this.handledByOverride(e2) || (this.buffer += '"', e2.parts.forEach((r2) => {
                r2.type === "TextNode" ? this.TextNode(r2, true) : this.Node(r2);
              }), this.buffer += '"');
            }
            MustacheCommentStatement(e2) {
              this.handledByOverride(e2) || (this.buffer += "{{!--".concat(e2.value, "--}}"));
            }
            ElementModifierStatement(e2) {
              this.handledByOverride(e2) || (this.buffer += "{{", this.Expression(e2.path), this.Params(e2.params), this.Hash(e2.hash), this.buffer += "}}");
            }
            CommentStatement(e2) {
              this.handledByOverride(e2) || (this.buffer += "<!--".concat(e2.value, "-->"));
            }
            PathExpression(e2) {
              this.handledByOverride(e2) || (this.buffer += e2.original);
            }
            SubExpression(e2) {
              this.handledByOverride(e2) || (this.buffer += "(", this.Expression(e2.path), this.Params(e2.params), this.Hash(e2.hash), this.buffer += ")");
            }
            Params(e2) {
              e2.length && e2.forEach((r2) => {
                this.buffer += " ", this.Expression(r2);
              });
            }
            Hash(e2) {
              this.handledByOverride(e2, true) || e2.pairs.forEach((r2) => {
                this.buffer += " ", this.HashPair(r2);
              });
            }
            HashPair(e2) {
              this.handledByOverride(e2) || (this.buffer += e2.key, this.buffer += "=", this.Node(e2.value));
            }
            StringLiteral(e2) {
              this.handledByOverride(e2) || (this.buffer += JSON.stringify(e2.value));
            }
            BooleanLiteral(e2) {
              this.handledByOverride(e2) || (this.buffer += e2.value);
            }
            NumberLiteral(e2) {
              this.handledByOverride(e2) || (this.buffer += e2.value);
            }
            UndefinedLiteral(e2) {
              this.handledByOverride(e2) || (this.buffer += "undefined");
            }
            NullLiteral(e2) {
              this.handledByOverride(e2) || (this.buffer += "null");
            }
            print(e2) {
              let { options: r2 } = this;
              if (r2.override) {
                let s2 = r2.override(e2, r2);
                if (s2 !== void 0)
                  return s2;
              }
              return this.buffer = "", this.Node(e2), this.buffer;
            }
          };
          t2.default = o;
        } }), Be = I({ "node_modules/@handlebars/parser/dist/cjs/exception.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true });
          var f3 = ["description", "fileName", "lineNumber", "endLineNumber", "message", "name", "number", "stack"];
          function h2(d, c) {
            var o = c && c.loc, e2, r2, s2, p;
            o && (e2 = o.start.line, r2 = o.end.line, s2 = o.start.column, p = o.end.column, d += " - " + e2 + ":" + s2);
            for (var n = Error.prototype.constructor.call(this, d), a = 0; a < f3.length; a++)
              this[f3[a]] = n[f3[a]];
            Error.captureStackTrace && Error.captureStackTrace(this, h2);
            try {
              o && (this.lineNumber = e2, this.endLineNumber = r2, Object.defineProperty ? (Object.defineProperty(this, "column", { value: s2, enumerable: true }), Object.defineProperty(this, "endColumn", { value: p, enumerable: true })) : (this.column = s2, this.endColumn = p));
            } catch {
            }
          }
          h2.prototype = new Error(), t2.default = h2;
        } }), Oe = I({ "node_modules/@handlebars/parser/dist/cjs/visitor.js"(t2) {
          "use strict";
          F2();
          var f3 = t2 && t2.__importDefault || function(r2) {
            return r2 && r2.__esModule ? r2 : { default: r2 };
          };
          Object.defineProperty(t2, "__esModule", { value: true });
          var h2 = f3(Be());
          function d() {
            this.parents = [];
          }
          d.prototype = { constructor: d, mutating: false, acceptKey: function(r2, s2) {
            var p = this.accept(r2[s2]);
            if (this.mutating) {
              if (p && !d.prototype[p.type])
                throw new h2.default('Unexpected node type "' + p.type + '" found when accepting ' + s2 + " on " + r2.type);
              r2[s2] = p;
            }
          }, acceptRequired: function(r2, s2) {
            if (this.acceptKey(r2, s2), !r2[s2])
              throw new h2.default(r2.type + " requires " + s2);
          }, acceptArray: function(r2) {
            for (var s2 = 0, p = r2.length; s2 < p; s2++)
              this.acceptKey(r2, s2), r2[s2] || (r2.splice(s2, 1), s2--, p--);
          }, accept: function(r2) {
            if (!!r2) {
              if (!this[r2.type])
                throw new h2.default("Unknown type: " + r2.type, r2);
              this.current && this.parents.unshift(this.current), this.current = r2;
              var s2 = this[r2.type](r2);
              if (this.current = this.parents.shift(), !this.mutating || s2)
                return s2;
              if (s2 !== false)
                return r2;
            }
          }, Program: function(r2) {
            this.acceptArray(r2.body);
          }, MustacheStatement: c, Decorator: c, BlockStatement: o, DecoratorBlock: o, PartialStatement: e2, PartialBlockStatement: function(r2) {
            e2.call(this, r2), this.acceptKey(r2, "program");
          }, ContentStatement: function() {
          }, CommentStatement: function() {
          }, SubExpression: c, PathExpression: function() {
          }, StringLiteral: function() {
          }, NumberLiteral: function() {
          }, BooleanLiteral: function() {
          }, UndefinedLiteral: function() {
          }, NullLiteral: function() {
          }, Hash: function(r2) {
            this.acceptArray(r2.pairs);
          }, HashPair: function(r2) {
            this.acceptRequired(r2, "value");
          } };
          function c(r2) {
            this.acceptRequired(r2, "path"), this.acceptArray(r2.params), this.acceptKey(r2, "hash");
          }
          function o(r2) {
            c.call(this, r2), this.acceptKey(r2, "program"), this.acceptKey(r2, "inverse");
          }
          function e2(r2) {
            this.acceptRequired(r2, "name"), this.acceptArray(r2.params), this.acceptKey(r2, "hash");
          }
          t2.default = d;
        } }), ze = I({ "node_modules/@handlebars/parser/dist/cjs/whitespace-control.js"(t2) {
          "use strict";
          F2();
          var f3 = t2 && t2.__importDefault || function(s2) {
            return s2 && s2.__esModule ? s2 : { default: s2 };
          };
          Object.defineProperty(t2, "__esModule", { value: true });
          var h2 = f3(Oe());
          function d(s2) {
            s2 === void 0 && (s2 = {}), this.options = s2;
          }
          d.prototype = new h2.default(), d.prototype.Program = function(s2) {
            var p = !this.options.ignoreStandalone, n = !this.isRootSeen;
            this.isRootSeen = true;
            for (var a = s2.body, u = 0, i2 = a.length; u < i2; u++) {
              var l = a[u], b = this.accept(l);
              if (!!b) {
                var P = c(a, u, n), E = o(a, u, n), v = b.openStandalone && P, _ = b.closeStandalone && E, y = b.inlineStandalone && P && E;
                b.close && e2(a, u, true), b.open && r2(a, u, true), p && y && (e2(a, u), r2(a, u) && l.type === "PartialStatement" && (l.indent = /([ \t]+$)/.exec(a[u - 1].original)[1])), p && v && (e2((l.program || l.inverse).body), r2(a, u)), p && _ && (e2(a, u), r2((l.inverse || l.program).body));
              }
            }
            return s2;
          }, d.prototype.BlockStatement = d.prototype.DecoratorBlock = d.prototype.PartialBlockStatement = function(s2) {
            this.accept(s2.program), this.accept(s2.inverse);
            var p = s2.program || s2.inverse, n = s2.program && s2.inverse, a = n, u = n;
            if (n && n.chained)
              for (a = n.body[0].program; u.chained; )
                u = u.body[u.body.length - 1].program;
            var i2 = { open: s2.openStrip.open, close: s2.closeStrip.close, openStandalone: o(p.body), closeStandalone: c((a || p).body) };
            if (s2.openStrip.close && e2(p.body, null, true), n) {
              var l = s2.inverseStrip;
              l.open && r2(p.body, null, true), l.close && e2(a.body, null, true), s2.closeStrip.open && r2(u.body, null, true), !this.options.ignoreStandalone && c(p.body) && o(a.body) && (r2(p.body), e2(a.body));
            } else
              s2.closeStrip.open && r2(p.body, null, true);
            return i2;
          }, d.prototype.Decorator = d.prototype.MustacheStatement = function(s2) {
            return s2.strip;
          }, d.prototype.PartialStatement = d.prototype.CommentStatement = function(s2) {
            var p = s2.strip || {};
            return { inlineStandalone: true, open: p.open, close: p.close };
          };
          function c(s2, p, n) {
            p === void 0 && (p = s2.length);
            var a = s2[p - 1], u = s2[p - 2];
            if (!a)
              return n;
            if (a.type === "ContentStatement")
              return (u || !n ? /\r?\n\s*?$/ : /(^|\r?\n)\s*?$/).test(a.original);
          }
          function o(s2, p, n) {
            p === void 0 && (p = -1);
            var a = s2[p + 1], u = s2[p + 2];
            if (!a)
              return n;
            if (a.type === "ContentStatement")
              return (u || !n ? /^\s*?\r?\n/ : /^\s*?(\r?\n|$)/).test(a.original);
          }
          function e2(s2, p, n) {
            var a = s2[p == null ? 0 : p + 1];
            if (!(!a || a.type !== "ContentStatement" || !n && a.rightStripped)) {
              var u = a.value;
              a.value = a.value.replace(n ? /^\s+/ : /^[ \t]*\r?\n?/, ""), a.rightStripped = a.value !== u;
            }
          }
          function r2(s2, p, n) {
            var a = s2[p == null ? s2.length - 1 : p - 1];
            if (!(!a || a.type !== "ContentStatement" || !n && a.leftStripped)) {
              var u = a.value;
              return a.value = a.value.replace(n ? /\s+$/ : /[ \t]+$/, ""), a.leftStripped = a.value !== u, a.leftStripped;
            }
          }
          t2.default = d;
        } }), Ge = I({ "node_modules/@handlebars/parser/dist/cjs/parser.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true });
          var f3 = function() {
            var h2 = function(N, k, B, O) {
              for (B = B || {}, O = N.length; O--; B[N[O]] = k)
                ;
              return B;
            }, d = [2, 44], c = [1, 20], o = [5, 14, 15, 19, 29, 34, 39, 44, 47, 48, 52, 56, 60], e2 = [1, 35], r2 = [1, 38], s2 = [1, 30], p = [1, 31], n = [1, 32], a = [1, 33], u = [1, 34], i2 = [1, 37], l = [14, 15, 19, 29, 34, 39, 44, 47, 48, 52, 56, 60], b = [14, 15, 19, 29, 34, 44, 47, 48, 52, 56, 60], P = [15, 18], E = [14, 15, 19, 29, 34, 47, 48, 52, 56, 60], v = [33, 64, 71, 79, 80, 81, 82, 83, 84], _ = [23, 33, 55, 64, 67, 71, 74, 79, 80, 81, 82, 83, 84], y = [1, 51], g = [23, 33, 55, 64, 67, 71, 74, 79, 80, 81, 82, 83, 84, 86], L = [2, 43], j = [55, 64, 71, 79, 80, 81, 82, 83, 84], x2 = [1, 58], w = [1, 59], H = [1, 66], m2 = [33, 64, 71, 74, 79, 80, 81, 82, 83, 84], C = [23, 64, 71, 79, 80, 81, 82, 83, 84], S2 = [1, 76], R = [64, 67, 71, 79, 80, 81, 82, 83, 84], M = [33, 74], V = [23, 33, 55, 67, 71, 74], G = [1, 106], K = [1, 118], U = [71, 76], Z2 = { trace: function() {
            }, yy: {}, symbols_: { error: 2, root: 3, program: 4, EOF: 5, program_repetition0: 6, statement: 7, mustache: 8, block: 9, rawBlock: 10, partial: 11, partialBlock: 12, content: 13, COMMENT: 14, CONTENT: 15, openRawBlock: 16, rawBlock_repetition0: 17, END_RAW_BLOCK: 18, OPEN_RAW_BLOCK: 19, helperName: 20, openRawBlock_repetition0: 21, openRawBlock_option0: 22, CLOSE_RAW_BLOCK: 23, openBlock: 24, block_option0: 25, closeBlock: 26, openInverse: 27, block_option1: 28, OPEN_BLOCK: 29, openBlock_repetition0: 30, openBlock_option0: 31, openBlock_option1: 32, CLOSE: 33, OPEN_INVERSE: 34, openInverse_repetition0: 35, openInverse_option0: 36, openInverse_option1: 37, openInverseChain: 38, OPEN_INVERSE_CHAIN: 39, openInverseChain_repetition0: 40, openInverseChain_option0: 41, openInverseChain_option1: 42, inverseAndProgram: 43, INVERSE: 44, inverseChain: 45, inverseChain_option0: 46, OPEN_ENDBLOCK: 47, OPEN: 48, expr: 49, mustache_repetition0: 50, mustache_option0: 51, OPEN_UNESCAPED: 52, mustache_repetition1: 53, mustache_option1: 54, CLOSE_UNESCAPED: 55, OPEN_PARTIAL: 56, partial_repetition0: 57, partial_option0: 58, openPartialBlock: 59, OPEN_PARTIAL_BLOCK: 60, openPartialBlock_repetition0: 61, openPartialBlock_option0: 62, sexpr: 63, OPEN_SEXPR: 64, sexpr_repetition0: 65, sexpr_option0: 66, CLOSE_SEXPR: 67, hash: 68, hash_repetition_plus0: 69, hashSegment: 70, ID: 71, EQUALS: 72, blockParams: 73, OPEN_BLOCK_PARAMS: 74, blockParams_repetition_plus0: 75, CLOSE_BLOCK_PARAMS: 76, path: 77, dataName: 78, STRING: 79, NUMBER: 80, BOOLEAN: 81, UNDEFINED: 82, NULL: 83, DATA: 84, pathSegments: 85, SEP: 86, $accept: 0, $end: 1 }, terminals_: { 2: "error", 5: "EOF", 14: "COMMENT", 15: "CONTENT", 18: "END_RAW_BLOCK", 19: "OPEN_RAW_BLOCK", 23: "CLOSE_RAW_BLOCK", 29: "OPEN_BLOCK", 33: "CLOSE", 34: "OPEN_INVERSE", 39: "OPEN_INVERSE_CHAIN", 44: "INVERSE", 47: "OPEN_ENDBLOCK", 48: "OPEN", 52: "OPEN_UNESCAPED", 55: "CLOSE_UNESCAPED", 56: "OPEN_PARTIAL", 60: "OPEN_PARTIAL_BLOCK", 64: "OPEN_SEXPR", 67: "CLOSE_SEXPR", 71: "ID", 72: "EQUALS", 74: "OPEN_BLOCK_PARAMS", 76: "CLOSE_BLOCK_PARAMS", 79: "STRING", 80: "NUMBER", 81: "BOOLEAN", 82: "UNDEFINED", 83: "NULL", 84: "DATA", 86: "SEP" }, productions_: [0, [3, 2], [4, 1], [7, 1], [7, 1], [7, 1], [7, 1], [7, 1], [7, 1], [7, 1], [13, 1], [10, 3], [16, 5], [9, 4], [9, 4], [24, 6], [27, 6], [38, 6], [43, 2], [45, 3], [45, 1], [26, 3], [8, 5], [8, 5], [11, 5], [12, 3], [59, 5], [49, 1], [49, 1], [63, 5], [68, 1], [70, 3], [73, 3], [20, 1], [20, 1], [20, 1], [20, 1], [20, 1], [20, 1], [20, 1], [78, 2], [77, 1], [85, 3], [85, 1], [6, 0], [6, 2], [17, 0], [17, 2], [21, 0], [21, 2], [22, 0], [22, 1], [25, 0], [25, 1], [28, 0], [28, 1], [30, 0], [30, 2], [31, 0], [31, 1], [32, 0], [32, 1], [35, 0], [35, 2], [36, 0], [36, 1], [37, 0], [37, 1], [40, 0], [40, 2], [41, 0], [41, 1], [42, 0], [42, 1], [46, 0], [46, 1], [50, 0], [50, 2], [51, 0], [51, 1], [53, 0], [53, 2], [54, 0], [54, 1], [57, 0], [57, 2], [58, 0], [58, 1], [61, 0], [61, 2], [62, 0], [62, 1], [65, 0], [65, 2], [66, 0], [66, 1], [69, 1], [69, 2], [75, 1], [75, 2]], performAction: function(k, B, O, q, z, A2, Q) {
              var D = A2.length - 1;
              switch (z) {
                case 1:
                  return A2[D - 1];
                case 2:
                  this.$ = q.prepareProgram(A2[D]);
                  break;
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 20:
                case 27:
                case 28:
                case 33:
                case 34:
                  this.$ = A2[D];
                  break;
                case 9:
                  this.$ = { type: "CommentStatement", value: q.stripComment(A2[D]), strip: q.stripFlags(A2[D], A2[D]), loc: q.locInfo(this._$) };
                  break;
                case 10:
                  this.$ = { type: "ContentStatement", original: A2[D], value: A2[D], loc: q.locInfo(this._$) };
                  break;
                case 11:
                  this.$ = q.prepareRawBlock(A2[D - 2], A2[D - 1], A2[D], this._$);
                  break;
                case 12:
                  this.$ = { path: A2[D - 3], params: A2[D - 2], hash: A2[D - 1] };
                  break;
                case 13:
                  this.$ = q.prepareBlock(A2[D - 3], A2[D - 2], A2[D - 1], A2[D], false, this._$);
                  break;
                case 14:
                  this.$ = q.prepareBlock(A2[D - 3], A2[D - 2], A2[D - 1], A2[D], true, this._$);
                  break;
                case 15:
                  this.$ = { open: A2[D - 5], path: A2[D - 4], params: A2[D - 3], hash: A2[D - 2], blockParams: A2[D - 1], strip: q.stripFlags(A2[D - 5], A2[D]) };
                  break;
                case 16:
                case 17:
                  this.$ = { path: A2[D - 4], params: A2[D - 3], hash: A2[D - 2], blockParams: A2[D - 1], strip: q.stripFlags(A2[D - 5], A2[D]) };
                  break;
                case 18:
                  this.$ = { strip: q.stripFlags(A2[D - 1], A2[D - 1]), program: A2[D] };
                  break;
                case 19:
                  var $ = q.prepareBlock(A2[D - 2], A2[D - 1], A2[D], A2[D], false, this._$), oe = q.prepareProgram([$], A2[D - 1].loc);
                  oe.chained = true, this.$ = { strip: A2[D - 2].strip, program: oe, chain: true };
                  break;
                case 21:
                  this.$ = { path: A2[D - 1], strip: q.stripFlags(A2[D - 2], A2[D]) };
                  break;
                case 22:
                case 23:
                  this.$ = q.prepareMustache(A2[D - 3], A2[D - 2], A2[D - 1], A2[D - 4], q.stripFlags(A2[D - 4], A2[D]), this._$);
                  break;
                case 24:
                  this.$ = { type: "PartialStatement", name: A2[D - 3], params: A2[D - 2], hash: A2[D - 1], indent: "", strip: q.stripFlags(A2[D - 4], A2[D]), loc: q.locInfo(this._$) };
                  break;
                case 25:
                  this.$ = q.preparePartialBlock(A2[D - 2], A2[D - 1], A2[D], this._$);
                  break;
                case 26:
                  this.$ = { path: A2[D - 3], params: A2[D - 2], hash: A2[D - 1], strip: q.stripFlags(A2[D - 4], A2[D]) };
                  break;
                case 29:
                  this.$ = { type: "SubExpression", path: A2[D - 3], params: A2[D - 2], hash: A2[D - 1], loc: q.locInfo(this._$) };
                  break;
                case 30:
                  this.$ = { type: "Hash", pairs: A2[D], loc: q.locInfo(this._$) };
                  break;
                case 31:
                  this.$ = { type: "HashPair", key: q.id(A2[D - 2]), value: A2[D], loc: q.locInfo(this._$) };
                  break;
                case 32:
                  this.$ = q.id(A2[D - 1]);
                  break;
                case 35:
                  this.$ = { type: "StringLiteral", value: A2[D], original: A2[D], loc: q.locInfo(this._$) };
                  break;
                case 36:
                  this.$ = { type: "NumberLiteral", value: Number(A2[D]), original: Number(A2[D]), loc: q.locInfo(this._$) };
                  break;
                case 37:
                  this.$ = { type: "BooleanLiteral", value: A2[D] === "true", original: A2[D] === "true", loc: q.locInfo(this._$) };
                  break;
                case 38:
                  this.$ = { type: "UndefinedLiteral", original: void 0, value: void 0, loc: q.locInfo(this._$) };
                  break;
                case 39:
                  this.$ = { type: "NullLiteral", original: null, value: null, loc: q.locInfo(this._$) };
                  break;
                case 40:
                  this.$ = q.preparePath(true, A2[D], this._$);
                  break;
                case 41:
                  this.$ = q.preparePath(false, A2[D], this._$);
                  break;
                case 42:
                  A2[D - 2].push({ part: q.id(A2[D]), original: A2[D], separator: A2[D - 1] }), this.$ = A2[D - 2];
                  break;
                case 43:
                  this.$ = [{ part: q.id(A2[D]), original: A2[D] }];
                  break;
                case 44:
                case 46:
                case 48:
                case 56:
                case 62:
                case 68:
                case 76:
                case 80:
                case 84:
                case 88:
                case 92:
                  this.$ = [];
                  break;
                case 45:
                case 47:
                case 49:
                case 57:
                case 63:
                case 69:
                case 77:
                case 81:
                case 85:
                case 89:
                case 93:
                case 97:
                case 99:
                  A2[D - 1].push(A2[D]);
                  break;
                case 96:
                case 98:
                  this.$ = [A2[D]];
                  break;
              }
            }, table: [h2([5, 14, 15, 19, 29, 34, 48, 52, 56, 60], d, { 3: 1, 4: 2, 6: 3 }), { 1: [3] }, { 5: [1, 4] }, h2([5, 39, 44, 47], [2, 2], { 7: 5, 8: 6, 9: 7, 10: 8, 11: 9, 12: 10, 13: 11, 24: 15, 27: 16, 16: 17, 59: 19, 14: [1, 12], 15: c, 19: [1, 23], 29: [1, 21], 34: [1, 22], 48: [1, 13], 52: [1, 14], 56: [1, 18], 60: [1, 24] }), { 1: [2, 1] }, h2(o, [2, 45]), h2(o, [2, 3]), h2(o, [2, 4]), h2(o, [2, 5]), h2(o, [2, 6]), h2(o, [2, 7]), h2(o, [2, 8]), h2(o, [2, 9]), { 20: 26, 49: 25, 63: 27, 64: e2, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, { 20: 26, 49: 39, 63: 27, 64: e2, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(l, d, { 6: 3, 4: 40 }), h2(b, d, { 6: 3, 4: 41 }), h2(P, [2, 46], { 17: 42 }), { 20: 26, 49: 43, 63: 27, 64: e2, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(E, d, { 6: 3, 4: 44 }), h2([5, 14, 15, 18, 19, 29, 34, 39, 44, 47, 48, 52, 56, 60], [2, 10]), { 20: 45, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, { 20: 46, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, { 20: 47, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, { 20: 26, 49: 48, 63: 27, 64: e2, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(v, [2, 76], { 50: 49 }), h2(_, [2, 27]), h2(_, [2, 28]), h2(_, [2, 33]), h2(_, [2, 34]), h2(_, [2, 35]), h2(_, [2, 36]), h2(_, [2, 37]), h2(_, [2, 38]), h2(_, [2, 39]), { 20: 26, 49: 50, 63: 27, 64: e2, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(_, [2, 41], { 86: y }), { 71: r2, 85: 52 }, h2(g, L), h2(j, [2, 80], { 53: 53 }), { 25: 54, 38: 56, 39: x2, 43: 57, 44: w, 45: 55, 47: [2, 52] }, { 28: 60, 43: 61, 44: w, 47: [2, 54] }, { 13: 63, 15: c, 18: [1, 62] }, h2(v, [2, 84], { 57: 64 }), { 26: 65, 47: H }, h2(m2, [2, 56], { 30: 67 }), h2(m2, [2, 62], { 35: 68 }), h2(C, [2, 48], { 21: 69 }), h2(v, [2, 88], { 61: 70 }), { 20: 26, 33: [2, 78], 49: 72, 51: 71, 63: 27, 64: e2, 68: 73, 69: 74, 70: 75, 71: S2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(R, [2, 92], { 65: 77 }), { 71: [1, 78] }, h2(_, [2, 40], { 86: y }), { 20: 26, 49: 80, 54: 79, 55: [2, 82], 63: 27, 64: e2, 68: 81, 69: 74, 70: 75, 71: S2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, { 26: 82, 47: H }, { 47: [2, 53] }, h2(l, d, { 6: 3, 4: 83 }), { 47: [2, 20] }, { 20: 84, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(E, d, { 6: 3, 4: 85 }), { 26: 86, 47: H }, { 47: [2, 55] }, h2(o, [2, 11]), h2(P, [2, 47]), { 20: 26, 33: [2, 86], 49: 88, 58: 87, 63: 27, 64: e2, 68: 89, 69: 74, 70: 75, 71: S2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(o, [2, 25]), { 20: 90, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(M, [2, 58], { 20: 26, 63: 27, 77: 28, 78: 29, 85: 36, 69: 74, 70: 75, 31: 91, 49: 92, 68: 93, 64: e2, 71: S2, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2 }), h2(M, [2, 64], { 20: 26, 63: 27, 77: 28, 78: 29, 85: 36, 69: 74, 70: 75, 36: 94, 49: 95, 68: 96, 64: e2, 71: S2, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2 }), { 20: 26, 22: 97, 23: [2, 50], 49: 98, 63: 27, 64: e2, 68: 99, 69: 74, 70: 75, 71: S2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, { 20: 26, 33: [2, 90], 49: 101, 62: 100, 63: 27, 64: e2, 68: 102, 69: 74, 70: 75, 71: S2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, { 33: [1, 103] }, h2(v, [2, 77]), { 33: [2, 79] }, h2([23, 33, 55, 67, 74], [2, 30], { 70: 104, 71: [1, 105] }), h2(V, [2, 96]), h2(g, L, { 72: G }), { 20: 26, 49: 108, 63: 27, 64: e2, 66: 107, 67: [2, 94], 68: 109, 69: 74, 70: 75, 71: S2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, h2(g, [2, 42]), { 55: [1, 110] }, h2(j, [2, 81]), { 55: [2, 83] }, h2(o, [2, 13]), { 38: 56, 39: x2, 43: 57, 44: w, 45: 112, 46: 111, 47: [2, 74] }, h2(m2, [2, 68], { 40: 113 }), { 47: [2, 18] }, h2(o, [2, 14]), { 33: [1, 114] }, h2(v, [2, 85]), { 33: [2, 87] }, { 33: [1, 115] }, { 32: 116, 33: [2, 60], 73: 117, 74: K }, h2(m2, [2, 57]), h2(M, [2, 59]), { 33: [2, 66], 37: 119, 73: 120, 74: K }, h2(m2, [2, 63]), h2(M, [2, 65]), { 23: [1, 121] }, h2(C, [2, 49]), { 23: [2, 51] }, { 33: [1, 122] }, h2(v, [2, 89]), { 33: [2, 91] }, h2(o, [2, 22]), h2(V, [2, 97]), { 72: G }, { 20: 26, 49: 123, 63: 27, 64: e2, 71: r2, 77: 28, 78: 29, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2, 85: 36 }, { 67: [1, 124] }, h2(R, [2, 93]), { 67: [2, 95] }, h2(o, [2, 23]), { 47: [2, 19] }, { 47: [2, 75] }, h2(M, [2, 70], { 20: 26, 63: 27, 77: 28, 78: 29, 85: 36, 69: 74, 70: 75, 41: 125, 49: 126, 68: 127, 64: e2, 71: S2, 79: s2, 80: p, 81: n, 82: a, 83: u, 84: i2 }), h2(o, [2, 24]), h2(o, [2, 21]), { 33: [1, 128] }, { 33: [2, 61] }, { 71: [1, 130], 75: 129 }, { 33: [1, 131] }, { 33: [2, 67] }, h2(P, [2, 12]), h2(E, [2, 26]), h2(V, [2, 31]), h2(_, [2, 29]), { 33: [2, 72], 42: 132, 73: 133, 74: K }, h2(m2, [2, 69]), h2(M, [2, 71]), h2(l, [2, 15]), { 71: [1, 135], 76: [1, 134] }, h2(U, [2, 98]), h2(b, [2, 16]), { 33: [1, 136] }, { 33: [2, 73] }, { 33: [2, 32] }, h2(U, [2, 99]), h2(l, [2, 17])], defaultActions: { 4: [2, 1], 55: [2, 53], 57: [2, 20], 61: [2, 55], 73: [2, 79], 81: [2, 83], 85: [2, 18], 89: [2, 87], 99: [2, 51], 102: [2, 91], 109: [2, 95], 111: [2, 19], 112: [2, 75], 117: [2, 61], 120: [2, 67], 133: [2, 73], 134: [2, 32] }, parseError: function(k, B) {
              if (B.recoverable)
                this.trace(k);
              else {
                var O = new Error(k);
                throw O.hash = B, O;
              }
            }, parse: function(k) {
              var B = this, O = [0], q = [], z = [null], A2 = [], Q = this.table, D = "", $ = 0, oe = 0, Ie = 0, et = 2, Re = 1, tt = A2.slice.call(arguments, 1), Y = Object.create(this.lexer), ie = { yy: {} };
              for (var Ae in this.yy)
                Object.prototype.hasOwnProperty.call(this.yy, Ae) && (ie.yy[Ae] = this.yy[Ae]);
              Y.setInput(k, ie.yy), ie.yy.lexer = Y, ie.yy.parser = this, typeof Y.yylloc > "u" && (Y.yylloc = {});
              var Ee = Y.yylloc;
              A2.push(Ee);
              var rt = Y.options && Y.options.ranges;
              typeof ie.yy.parseError == "function" ? this.parseError = ie.yy.parseError : this.parseError = Object.getPrototypeOf(this).parseError;
              function $t(te) {
                O.length = O.length - 2 * te, z.length = z.length - te, A2.length = A2.length - te;
              }
              e:
                var nt = function() {
                  var te;
                  return te = Y.lex() || Re, typeof te != "number" && (te = B.symbols_[te] || te), te;
                };
              for (var J, _e, ae, ee, er, Se, se = {}, de, re, qe, pe; ; ) {
                if (ae = O[O.length - 1], this.defaultActions[ae] ? ee = this.defaultActions[ae] : ((J === null || typeof J > "u") && (J = nt()), ee = Q[ae] && Q[ae][J]), typeof ee > "u" || !ee.length || !ee[0]) {
                  var Ce = "";
                  pe = [];
                  for (de in Q[ae])
                    this.terminals_[de] && de > et && pe.push("'" + this.terminals_[de] + "'");
                  Y.showPosition ? Ce = "Parse error on line " + ($ + 1) + `:
` + Y.showPosition() + `
Expecting ` + pe.join(", ") + ", got '" + (this.terminals_[J] || J) + "'" : Ce = "Parse error on line " + ($ + 1) + ": Unexpected " + (J == Re ? "end of input" : "'" + (this.terminals_[J] || J) + "'"), this.parseError(Ce, { text: Y.match, token: this.terminals_[J] || J, line: Y.yylineno, loc: Ee, expected: pe });
                }
                if (ee[0] instanceof Array && ee.length > 1)
                  throw new Error("Parse Error: multiple actions possible at state: " + ae + ", token: " + J);
                switch (ee[0]) {
                  case 1:
                    O.push(J), z.push(Y.yytext), A2.push(Y.yylloc), O.push(ee[1]), J = null, _e ? (J = _e, _e = null) : (oe = Y.yyleng, D = Y.yytext, $ = Y.yylineno, Ee = Y.yylloc, Ie > 0 && Ie--);
                    break;
                  case 2:
                    if (re = this.productions_[ee[1]][1], se.$ = z[z.length - re], se._$ = { first_line: A2[A2.length - (re || 1)].first_line, last_line: A2[A2.length - 1].last_line, first_column: A2[A2.length - (re || 1)].first_column, last_column: A2[A2.length - 1].last_column }, rt && (se._$.range = [A2[A2.length - (re || 1)].range[0], A2[A2.length - 1].range[1]]), Se = this.performAction.apply(se, [D, oe, $, ie.yy, ee[1], z, A2].concat(tt)), typeof Se < "u")
                      return Se;
                    re && (O = O.slice(0, -1 * re * 2), z = z.slice(0, -1 * re), A2 = A2.slice(0, -1 * re)), O.push(this.productions_[ee[1]][0]), z.push(se.$), A2.push(se._$), qe = Q[O[O.length - 2]][O[O.length - 1]], O.push(qe);
                    break;
                  case 3:
                    return true;
                }
              }
              return true;
            } }, W = function() {
              var N = { EOF: 1, parseError: function(B, O) {
                if (this.yy.parser)
                  this.yy.parser.parseError(B, O);
                else
                  throw new Error(B);
              }, setInput: function(k, B) {
                return this.yy = B || this.yy || {}, this._input = k, this._more = this._backtrack = this.done = false, this.yylineno = this.yyleng = 0, this.yytext = this.matched = this.match = "", this.conditionStack = ["INITIAL"], this.yylloc = { first_line: 1, first_column: 0, last_line: 1, last_column: 0 }, this.options.ranges && (this.yylloc.range = [0, 0]), this.offset = 0, this;
              }, input: function() {
                var k = this._input[0];
                this.yytext += k, this.yyleng++, this.offset++, this.match += k, this.matched += k;
                var B = k.match(/(?:\r\n?|\n).*/g);
                return B ? (this.yylineno++, this.yylloc.last_line++) : this.yylloc.last_column++, this.options.ranges && this.yylloc.range[1]++, this._input = this._input.slice(1), k;
              }, unput: function(k) {
                var B = k.length, O = k.split(/(?:\r\n?|\n)/g);
                this._input = k + this._input, this.yytext = this.yytext.substr(0, this.yytext.length - B), this.offset -= B;
                var q = this.match.split(/(?:\r\n?|\n)/g);
                this.match = this.match.substr(0, this.match.length - 1), this.matched = this.matched.substr(0, this.matched.length - 1), O.length - 1 && (this.yylineno -= O.length - 1);
                var z = this.yylloc.range;
                return this.yylloc = { first_line: this.yylloc.first_line, last_line: this.yylineno + 1, first_column: this.yylloc.first_column, last_column: O ? (O.length === q.length ? this.yylloc.first_column : 0) + q[q.length - O.length].length - O[0].length : this.yylloc.first_column - B }, this.options.ranges && (this.yylloc.range = [z[0], z[0] + this.yyleng - B]), this.yyleng = this.yytext.length, this;
              }, more: function() {
                return this._more = true, this;
              }, reject: function() {
                if (this.options.backtrack_lexer)
                  this._backtrack = true;
                else
                  return this.parseError("Lexical error on line " + (this.yylineno + 1) + `. You can only invoke reject() in the lexer when the lexer is of the backtracking persuasion (options.backtrack_lexer = true).
` + this.showPosition(), { text: "", token: null, line: this.yylineno });
                return this;
              }, less: function(k) {
                this.unput(this.match.slice(k));
              }, pastInput: function() {
                var k = this.matched.substr(0, this.matched.length - this.match.length);
                return (k.length > 20 ? "..." : "") + k.substr(-20).replace(/\n/g, "");
              }, upcomingInput: function() {
                var k = this.match;
                return k.length < 20 && (k += this._input.substr(0, 20 - k.length)), (k.substr(0, 20) + (k.length > 20 ? "..." : "")).replace(/\n/g, "");
              }, showPosition: function() {
                var k = this.pastInput(), B = new Array(k.length + 1).join("-");
                return k + this.upcomingInput() + `
` + B + "^";
              }, test_match: function(k, B) {
                var O, q, z;
                if (this.options.backtrack_lexer && (z = { yylineno: this.yylineno, yylloc: { first_line: this.yylloc.first_line, last_line: this.last_line, first_column: this.yylloc.first_column, last_column: this.yylloc.last_column }, yytext: this.yytext, match: this.match, matches: this.matches, matched: this.matched, yyleng: this.yyleng, offset: this.offset, _more: this._more, _input: this._input, yy: this.yy, conditionStack: this.conditionStack.slice(0), done: this.done }, this.options.ranges && (z.yylloc.range = this.yylloc.range.slice(0))), q = k[0].match(/(?:\r\n?|\n).*/g), q && (this.yylineno += q.length), this.yylloc = { first_line: this.yylloc.last_line, last_line: this.yylineno + 1, first_column: this.yylloc.last_column, last_column: q ? q[q.length - 1].length - q[q.length - 1].match(/\r?\n?/)[0].length : this.yylloc.last_column + k[0].length }, this.yytext += k[0], this.match += k[0], this.matches = k, this.yyleng = this.yytext.length, this.options.ranges && (this.yylloc.range = [this.offset, this.offset += this.yyleng]), this._more = false, this._backtrack = false, this._input = this._input.slice(k[0].length), this.matched += k[0], O = this.performAction.call(this, this.yy, this, B, this.conditionStack[this.conditionStack.length - 1]), this.done && this._input && (this.done = false), O)
                  return O;
                if (this._backtrack) {
                  for (var A2 in z)
                    this[A2] = z[A2];
                  return false;
                }
                return false;
              }, next: function() {
                if (this.done)
                  return this.EOF;
                this._input || (this.done = true);
                var k, B, O, q;
                this._more || (this.yytext = "", this.match = "");
                for (var z = this._currentRules(), A2 = 0; A2 < z.length; A2++)
                  if (O = this._input.match(this.rules[z[A2]]), O && (!B || O[0].length > B[0].length)) {
                    if (B = O, q = A2, this.options.backtrack_lexer) {
                      if (k = this.test_match(O, z[A2]), k !== false)
                        return k;
                      if (this._backtrack) {
                        B = false;
                        continue;
                      } else
                        return false;
                    } else if (!this.options.flex)
                      break;
                  }
                return B ? (k = this.test_match(B, z[q]), k !== false ? k : false) : this._input === "" ? this.EOF : this.parseError("Lexical error on line " + (this.yylineno + 1) + `. Unrecognized text.
` + this.showPosition(), { text: "", token: null, line: this.yylineno });
              }, lex: function() {
                var B = this.next();
                return B || this.lex();
              }, begin: function(B) {
                this.conditionStack.push(B);
              }, popState: function() {
                var B = this.conditionStack.length - 1;
                return B > 0 ? this.conditionStack.pop() : this.conditionStack[0];
              }, _currentRules: function() {
                return this.conditionStack.length && this.conditionStack[this.conditionStack.length - 1] ? this.conditions[this.conditionStack[this.conditionStack.length - 1]].rules : this.conditions.INITIAL.rules;
              }, topState: function(B) {
                return B = this.conditionStack.length - 1 - Math.abs(B || 0), B >= 0 ? this.conditionStack[B] : "INITIAL";
              }, pushState: function(B) {
                this.begin(B);
              }, stateStackSize: function() {
                return this.conditionStack.length;
              }, options: {}, performAction: function(B, O, q, z) {
                function A2(D, $) {
                  return O.yytext = O.yytext.substring(D, O.yyleng - $ + D);
                }
                var Q = z;
                switch (q) {
                  case 0:
                    if (O.yytext.slice(-2) === "\\\\" ? (A2(0, 1), this.begin("mu")) : O.yytext.slice(-1) === "\\" ? (A2(0, 1), this.begin("emu")) : this.begin("mu"), O.yytext)
                      return 15;
                    break;
                  case 1:
                    return 15;
                  case 2:
                    return this.popState(), 15;
                    break;
                  case 3:
                    return this.begin("raw"), 15;
                    break;
                  case 4:
                    return this.popState(), this.conditionStack[this.conditionStack.length - 1] === "raw" ? 15 : (A2(5, 9), 18);
                  case 5:
                    return 15;
                  case 6:
                    return this.popState(), 14;
                    break;
                  case 7:
                    return 64;
                  case 8:
                    return 67;
                  case 9:
                    return 19;
                  case 10:
                    return this.popState(), this.begin("raw"), 23;
                    break;
                  case 11:
                    return 56;
                  case 12:
                    return 60;
                  case 13:
                    return 29;
                  case 14:
                    return 47;
                  case 15:
                    return this.popState(), 44;
                    break;
                  case 16:
                    return this.popState(), 44;
                    break;
                  case 17:
                    return 34;
                  case 18:
                    return 39;
                  case 19:
                    return 52;
                  case 20:
                    return 48;
                  case 21:
                    this.unput(O.yytext), this.popState(), this.begin("com");
                    break;
                  case 22:
                    return this.popState(), 14;
                    break;
                  case 23:
                    return 48;
                  case 24:
                    return 72;
                  case 25:
                    return 71;
                  case 26:
                    return 71;
                  case 27:
                    return 86;
                  case 28:
                    break;
                  case 29:
                    return this.popState(), 55;
                    break;
                  case 30:
                    return this.popState(), 33;
                    break;
                  case 31:
                    return O.yytext = A2(1, 2).replace(/\\"/g, '"'), 79;
                    break;
                  case 32:
                    return O.yytext = A2(1, 2).replace(/\\'/g, "'"), 79;
                    break;
                  case 33:
                    return 84;
                  case 34:
                    return 81;
                  case 35:
                    return 81;
                  case 36:
                    return 82;
                  case 37:
                    return 83;
                  case 38:
                    return 80;
                  case 39:
                    return 74;
                  case 40:
                    return 76;
                  case 41:
                    return 71;
                  case 42:
                    return O.yytext = O.yytext.replace(/\\([\\\]])/g, "$1"), 71;
                    break;
                  case 43:
                    return "INVALID";
                  case 44:
                    return 5;
                }
              }, rules: [/^(?:[^\x00]*?(?=(\{\{)))/, /^(?:[^\x00]+)/, /^(?:[^\x00]{2,}?(?=(\{\{|\\\{\{|\\\\\{\{|$)))/, /^(?:\{\{\{\{(?=[^/]))/, /^(?:\{\{\{\{\/[^\s!"#%-,\.\/;->@\[-\^`\{-~]+(?=[=}\s\/.])\}\}\}\})/, /^(?:[^\x00]+?(?=(\{\{\{\{)))/, /^(?:[\s\S]*?--(~)?\}\})/, /^(?:\()/, /^(?:\))/, /^(?:\{\{\{\{)/, /^(?:\}\}\}\})/, /^(?:\{\{(~)?>)/, /^(?:\{\{(~)?#>)/, /^(?:\{\{(~)?#\*?)/, /^(?:\{\{(~)?\/)/, /^(?:\{\{(~)?\^\s*(~)?\}\})/, /^(?:\{\{(~)?\s*else\s*(~)?\}\})/, /^(?:\{\{(~)?\^)/, /^(?:\{\{(~)?\s*else\b)/, /^(?:\{\{(~)?\{)/, /^(?:\{\{(~)?&)/, /^(?:\{\{(~)?!--)/, /^(?:\{\{(~)?![\s\S]*?\}\})/, /^(?:\{\{(~)?\*?)/, /^(?:=)/, /^(?:\.\.)/, /^(?:\.(?=([=~}\s\/.)|])))/, /^(?:[\/.])/, /^(?:\s+)/, /^(?:\}(~)?\}\})/, /^(?:(~)?\}\})/, /^(?:"(\\["]|[^"])*")/, /^(?:'(\\[']|[^'])*')/, /^(?:@)/, /^(?:true(?=([~}\s)])))/, /^(?:false(?=([~}\s)])))/, /^(?:undefined(?=([~}\s)])))/, /^(?:null(?=([~}\s)])))/, /^(?:-?[0-9]+(?:\.[0-9]+)?(?=([~}\s)])))/, /^(?:as\s+\|)/, /^(?:\|)/, /^(?:([^\s!"#%-,\.\/;->@\[-\^`\{-~]+(?=([=~}\s\/.)|]))))/, /^(?:\[(\\\]|[^\]])*\])/, /^(?:.)/, /^(?:$)/], conditions: { mu: { rules: [7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44], inclusive: false }, emu: { rules: [2], inclusive: false }, com: { rules: [6], inclusive: false }, raw: { rules: [3, 4, 5], inclusive: false }, INITIAL: { rules: [0, 1, 44], inclusive: true } } };
              return N;
            }();
            Z2.lexer = W;
            function T() {
              this.yy = {};
            }
            return T.prototype = Z2, Z2.Parser = T, new T();
          }();
          t2.default = f3;
        } }), Nt = I({ "node_modules/@handlebars/parser/dist/cjs/printer.js"(t2) {
          "use strict";
          F2();
          var f3 = t2 && t2.__importDefault || function(o) {
            return o && o.__esModule ? o : { default: o };
          };
          Object.defineProperty(t2, "__esModule", { value: true }), t2.PrintVisitor = t2.print = void 0;
          var h2 = f3(Oe());
          function d(o) {
            return new c().accept(o);
          }
          t2.print = d;
          function c() {
            this.padding = 0;
          }
          t2.PrintVisitor = c, c.prototype = new h2.default(), c.prototype.pad = function(o) {
            for (var e2 = "", r2 = 0, s2 = this.padding; r2 < s2; r2++)
              e2 += "  ";
            return e2 += o + `
`, e2;
          }, c.prototype.Program = function(o) {
            var e2 = "", r2 = o.body, s2, p;
            if (o.blockParams) {
              var n = "BLOCK PARAMS: [";
              for (s2 = 0, p = o.blockParams.length; s2 < p; s2++)
                n += " " + o.blockParams[s2];
              n += " ]", e2 += this.pad(n);
            }
            for (s2 = 0, p = r2.length; s2 < p; s2++)
              e2 += this.accept(r2[s2]);
            return this.padding--, e2;
          }, c.prototype.MustacheStatement = function(o) {
            return this.pad("{{ " + this.SubExpression(o) + " }}");
          }, c.prototype.Decorator = function(o) {
            return this.pad("{{ DIRECTIVE " + this.SubExpression(o) + " }}");
          }, c.prototype.BlockStatement = c.prototype.DecoratorBlock = function(o) {
            var e2 = "";
            return e2 += this.pad((o.type === "DecoratorBlock" ? "DIRECTIVE " : "") + "BLOCK:"), this.padding++, e2 += this.pad(this.SubExpression(o)), o.program && (e2 += this.pad("PROGRAM:"), this.padding++, e2 += this.accept(o.program), this.padding--), o.inverse && (o.program && this.padding++, e2 += this.pad("{{^}}"), this.padding++, e2 += this.accept(o.inverse), this.padding--, o.program && this.padding--), this.padding--, e2;
          }, c.prototype.PartialStatement = function(o) {
            var e2 = "PARTIAL:" + o.name.original;
            return o.params[0] && (e2 += " " + this.accept(o.params[0])), o.hash && (e2 += " " + this.accept(o.hash)), this.pad("{{> " + e2 + " }}");
          }, c.prototype.PartialBlockStatement = function(o) {
            var e2 = "PARTIAL BLOCK:" + o.name.original;
            return o.params[0] && (e2 += " " + this.accept(o.params[0])), o.hash && (e2 += " " + this.accept(o.hash)), e2 += " " + this.pad("PROGRAM:"), this.padding++, e2 += this.accept(o.program), this.padding--, this.pad("{{> " + e2 + " }}");
          }, c.prototype.ContentStatement = function(o) {
            return this.pad("CONTENT[ '" + o.value + "' ]");
          }, c.prototype.CommentStatement = function(o) {
            return this.pad("{{! '" + o.value + "' }}");
          }, c.prototype.SubExpression = function(o) {
            for (var e2 = o.params, r2 = [], s2, p = 0, n = e2.length; p < n; p++)
              r2.push(this.accept(e2[p]));
            return e2 = "[" + r2.join(", ") + "]", s2 = o.hash ? " " + this.accept(o.hash) : "", this.accept(o.path) + " " + e2 + s2;
          }, c.prototype.PathExpression = function(o) {
            var e2 = o.parts.join("/");
            return (o.data ? "@" : "") + "PATH:" + e2;
          }, c.prototype.StringLiteral = function(o) {
            return '"' + o.value + '"';
          }, c.prototype.NumberLiteral = function(o) {
            return "NUMBER{" + o.value + "}";
          }, c.prototype.BooleanLiteral = function(o) {
            return "BOOLEAN{" + o.value + "}";
          }, c.prototype.UndefinedLiteral = function() {
            return "UNDEFINED";
          }, c.prototype.NullLiteral = function() {
            return "NULL";
          }, c.prototype.Hash = function(o) {
            for (var e2 = o.pairs, r2 = [], s2 = 0, p = e2.length; s2 < p; s2++)
              r2.push(this.accept(e2[s2]));
            return "HASH{" + r2.join(", ") + "}";
          }, c.prototype.HashPair = function(o) {
            return o.key + "=" + this.accept(o.value);
          };
        } }), Lt = I({ "node_modules/@handlebars/parser/dist/cjs/helpers.js"(t2) {
          "use strict";
          F2();
          var f3 = t2 && t2.__importDefault || function(l) {
            return l && l.__esModule ? l : { default: l };
          };
          Object.defineProperty(t2, "__esModule", { value: true }), t2.preparePartialBlock = t2.prepareProgram = t2.prepareBlock = t2.prepareRawBlock = t2.prepareMustache = t2.preparePath = t2.stripComment = t2.stripFlags = t2.id = t2.SourceLocation = void 0;
          var h2 = f3(Be());
          function d(l, b) {
            if (b = b.path ? b.path.original : b, l.path.original !== b) {
              var P = { loc: l.path.loc };
              throw new h2.default(l.path.original + " doesn't match " + b, P);
            }
          }
          function c(l, b) {
            this.source = l, this.start = { line: b.first_line, column: b.first_column }, this.end = { line: b.last_line, column: b.last_column };
          }
          t2.SourceLocation = c;
          function o(l) {
            return /^\[.*\]$/.test(l) ? l.substring(1, l.length - 1) : l;
          }
          t2.id = o;
          function e2(l, b) {
            return { open: l.charAt(2) === "~", close: b.charAt(b.length - 3) === "~" };
          }
          t2.stripFlags = e2;
          function r2(l) {
            return l.replace(/^\{\{~?!-?-?/, "").replace(/-?-?~?\}\}$/, "");
          }
          t2.stripComment = r2;
          function s2(l, b, P) {
            P = this.locInfo(P);
            for (var E = l ? "@" : "", v = [], _ = 0, y = 0, g = b.length; y < g; y++) {
              var L = b[y].part, j = b[y].original !== L;
              if (E += (b[y].separator || "") + L, !j && (L === ".." || L === "." || L === "this")) {
                if (v.length > 0)
                  throw new h2.default("Invalid path: " + E, { loc: P });
                L === ".." && _++;
              } else
                v.push(L);
            }
            return { type: "PathExpression", data: l, depth: _, parts: v, original: E, loc: P };
          }
          t2.preparePath = s2;
          function p(l, b, P, E, v, _) {
            var y = E.charAt(3) || E.charAt(2), g = y !== "{" && y !== "&", L = /\*/.test(E);
            return { type: L ? "Decorator" : "MustacheStatement", path: l, params: b, hash: P, escaped: g, strip: v, loc: this.locInfo(_) };
          }
          t2.prepareMustache = p;
          function n(l, b, P, E) {
            d(l, P), E = this.locInfo(E);
            var v = { type: "Program", body: b, strip: {}, loc: E };
            return { type: "BlockStatement", path: l.path, params: l.params, hash: l.hash, program: v, openStrip: {}, inverseStrip: {}, closeStrip: {}, loc: E };
          }
          t2.prepareRawBlock = n;
          function a(l, b, P, E, v, _) {
            E && E.path && d(l, E);
            var y = /\*/.test(l.open);
            b.blockParams = l.blockParams;
            var g, L;
            if (P) {
              if (y)
                throw new h2.default("Unexpected inverse block on decorator", P);
              P.chain && (P.program.body[0].closeStrip = E.strip), L = P.strip, g = P.program;
            }
            return v && (v = g, g = b, b = v), { type: y ? "DecoratorBlock" : "BlockStatement", path: l.path, params: l.params, hash: l.hash, program: b, inverse: g, openStrip: l.strip, inverseStrip: L, closeStrip: E && E.strip, loc: this.locInfo(_) };
          }
          t2.prepareBlock = a;
          function u(l, b) {
            if (!b && l.length) {
              var P = l[0].loc, E = l[l.length - 1].loc;
              P && E && (b = { source: P.source, start: { line: P.start.line, column: P.start.column }, end: { line: E.end.line, column: E.end.column } });
            }
            return { type: "Program", body: l, strip: {}, loc: b };
          }
          t2.prepareProgram = u;
          function i2(l, b, P, E) {
            return d(l, P), { type: "PartialBlockStatement", name: l.path, params: l.params, hash: l.hash, program: b, openStrip: l.strip, closeStrip: P && P.strip, loc: this.locInfo(E) };
          }
          t2.preparePartialBlock = i2;
        } }), Ft = I({ "node_modules/@handlebars/parser/dist/cjs/parse.js"(t2) {
          "use strict";
          F2();
          var f3 = t2 && t2.__createBinding || (Object.create ? function(u, i2, l, b) {
            b === void 0 && (b = l), Object.defineProperty(u, b, { enumerable: true, get: function() {
              return i2[l];
            } });
          } : function(u, i2, l, b) {
            b === void 0 && (b = l), u[b] = i2[l];
          }), h2 = t2 && t2.__setModuleDefault || (Object.create ? function(u, i2) {
            Object.defineProperty(u, "default", { enumerable: true, value: i2 });
          } : function(u, i2) {
            u.default = i2;
          }), d = t2 && t2.__importStar || function(u) {
            if (u && u.__esModule)
              return u;
            var i2 = {};
            if (u != null)
              for (var l in u)
                l !== "default" && Object.prototype.hasOwnProperty.call(u, l) && f3(i2, u, l);
            return h2(i2, u), i2;
          }, c = t2 && t2.__importDefault || function(u) {
            return u && u.__esModule ? u : { default: u };
          };
          Object.defineProperty(t2, "__esModule", { value: true }), t2.parse = t2.parseWithoutProcessing = void 0;
          var o = c(Ge()), e2 = c(ze()), r2 = d(Lt()), s2 = {};
          for (p in r2)
            Object.prototype.hasOwnProperty.call(r2, p) && (s2[p] = r2[p]);
          var p;
          function n(u, i2) {
            if (u.type === "Program")
              return u;
            o.default.yy = s2, o.default.yy.locInfo = function(b) {
              return new r2.SourceLocation(i2 && i2.srcName, b);
            };
            var l = o.default.parse(u);
            return l;
          }
          t2.parseWithoutProcessing = n;
          function a(u, i2) {
            var l = n(u, i2), b = new e2.default(i2);
            return b.accept(l);
          }
          t2.parse = a;
        } }), It = I({ "node_modules/@handlebars/parser/dist/cjs/index.js"(t2) {
          "use strict";
          F2();
          var f3 = t2 && t2.__importDefault || function(s2) {
            return s2 && s2.__esModule ? s2 : { default: s2 };
          };
          Object.defineProperty(t2, "__esModule", { value: true }), t2.parseWithoutProcessing = t2.parse = t2.PrintVisitor = t2.print = t2.Exception = t2.parser = t2.WhitespaceControl = t2.Visitor = void 0;
          var h2 = Oe();
          Object.defineProperty(t2, "Visitor", { enumerable: true, get: function() {
            return f3(h2).default;
          } });
          var d = ze();
          Object.defineProperty(t2, "WhitespaceControl", { enumerable: true, get: function() {
            return f3(d).default;
          } });
          var c = Ge();
          Object.defineProperty(t2, "parser", { enumerable: true, get: function() {
            return f3(c).default;
          } });
          var o = Be();
          Object.defineProperty(t2, "Exception", { enumerable: true, get: function() {
            return f3(o).default;
          } });
          var e2 = Nt();
          Object.defineProperty(t2, "print", { enumerable: true, get: function() {
            return e2.print;
          } }), Object.defineProperty(t2, "PrintVisitor", { enumerable: true, get: function() {
            return e2.PrintVisitor;
          } });
          var r2 = Ft();
          Object.defineProperty(t2, "parse", { enumerable: true, get: function() {
            return r2.parse;
          } }), Object.defineProperty(t2, "parseWithoutProcessing", { enumerable: true, get: function() {
            return r2.parseWithoutProcessing;
          } });
        } }), Ke = I({ "node_modules/simple-html-tokenizer/dist/simple-html-tokenizer.js"(t2, f3) {
          F2(), function(h2, d) {
            typeof t2 == "object" && typeof f3 < "u" ? d(t2) : typeof define == "function" && define.amd ? define(["exports"], d) : d(h2.HTML5Tokenizer = {});
          }(t2, function(h2) {
            "use strict";
            var d = { Aacute: "\xC1", aacute: "\xE1", Abreve: "\u0102", abreve: "\u0103", ac: "\u223E", acd: "\u223F", acE: "\u223E\u0333", Acirc: "\xC2", acirc: "\xE2", acute: "\xB4", Acy: "\u0410", acy: "\u0430", AElig: "\xC6", aelig: "\xE6", af: "\u2061", Afr: "\u{1D504}", afr: "\u{1D51E}", Agrave: "\xC0", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", Alpha: "\u0391", alpha: "\u03B1", Amacr: "\u0100", amacr: "\u0101", amalg: "\u2A3F", amp: "&", AMP: "&", andand: "\u2A55", And: "\u2A53", and: "\u2227", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angmsd: "\u2221", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", Aogon: "\u0104", aogon: "\u0105", Aopf: "\u{1D538}", aopf: "\u{1D552}", apacir: "\u2A6F", ap: "\u2248", apE: "\u2A70", ape: "\u224A", apid: "\u224B", apos: "'", ApplyFunction: "\u2061", approx: "\u2248", approxeq: "\u224A", Aring: "\xC5", aring: "\xE5", Ascr: "\u{1D49C}", ascr: "\u{1D4B6}", Assign: "\u2254", ast: "*", asymp: "\u2248", asympeq: "\u224D", Atilde: "\xC3", atilde: "\xE3", Auml: "\xC4", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", Backslash: "\u2216", Barv: "\u2AE7", barvee: "\u22BD", barwed: "\u2305", Barwed: "\u2306", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", Bcy: "\u0411", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", because: "\u2235", Because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", Bernoullis: "\u212C", Beta: "\u0392", beta: "\u03B2", beth: "\u2136", between: "\u226C", Bfr: "\u{1D505}", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bNot: "\u2AED", bnot: "\u2310", Bopf: "\u{1D539}", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxbox: "\u29C9", boxdl: "\u2510", boxdL: "\u2555", boxDl: "\u2556", boxDL: "\u2557", boxdr: "\u250C", boxdR: "\u2552", boxDr: "\u2553", boxDR: "\u2554", boxh: "\u2500", boxH: "\u2550", boxhd: "\u252C", boxHd: "\u2564", boxhD: "\u2565", boxHD: "\u2566", boxhu: "\u2534", boxHu: "\u2567", boxhU: "\u2568", boxHU: "\u2569", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxul: "\u2518", boxuL: "\u255B", boxUl: "\u255C", boxUL: "\u255D", boxur: "\u2514", boxuR: "\u2558", boxUr: "\u2559", boxUR: "\u255A", boxv: "\u2502", boxV: "\u2551", boxvh: "\u253C", boxvH: "\u256A", boxVh: "\u256B", boxVH: "\u256C", boxvl: "\u2524", boxvL: "\u2561", boxVl: "\u2562", boxVL: "\u2563", boxvr: "\u251C", boxvR: "\u255E", boxVr: "\u255F", boxVR: "\u2560", bprime: "\u2035", breve: "\u02D8", Breve: "\u02D8", brvbar: "\xA6", bscr: "\u{1D4B7}", Bscr: "\u212C", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsolb: "\u29C5", bsol: "\\", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", Bumpeq: "\u224E", bumpeq: "\u224F", Cacute: "\u0106", cacute: "\u0107", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", cap: "\u2229", Cap: "\u22D2", capcup: "\u2A47", capdot: "\u2A40", CapitalDifferentialD: "\u2145", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", Cayleys: "\u212D", ccaps: "\u2A4D", Ccaron: "\u010C", ccaron: "\u010D", Ccedil: "\xC7", ccedil: "\xE7", Ccirc: "\u0108", ccirc: "\u0109", Cconint: "\u2230", ccups: "\u2A4C", ccupssm: "\u2A50", Cdot: "\u010A", cdot: "\u010B", cedil: "\xB8", Cedilla: "\xB8", cemptyv: "\u29B2", cent: "\xA2", centerdot: "\xB7", CenterDot: "\xB7", cfr: "\u{1D520}", Cfr: "\u212D", CHcy: "\u0427", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", Chi: "\u03A7", chi: "\u03C7", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", CircleDot: "\u2299", circledR: "\xAE", circledS: "\u24C8", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", cir: "\u25CB", cirE: "\u29C3", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", clubs: "\u2663", clubsuit: "\u2663", colon: ":", Colon: "\u2237", Colone: "\u2A74", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", Congruent: "\u2261", conint: "\u222E", Conint: "\u222F", ContourIntegral: "\u222E", copf: "\u{1D554}", Copf: "\u2102", coprod: "\u2210", Coproduct: "\u2210", copy: "\xA9", COPY: "\xA9", copysr: "\u2117", CounterClockwiseContourIntegral: "\u2233", crarr: "\u21B5", cross: "\u2717", Cross: "\u2A2F", Cscr: "\u{1D49E}", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", cupbrcap: "\u2A48", cupcap: "\u2A46", CupCap: "\u224D", cup: "\u222A", Cup: "\u22D3", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", dagger: "\u2020", Dagger: "\u2021", daleth: "\u2138", darr: "\u2193", Darr: "\u21A1", dArr: "\u21D3", dash: "\u2010", Dashv: "\u2AE4", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", Dcaron: "\u010E", dcaron: "\u010F", Dcy: "\u0414", dcy: "\u0434", ddagger: "\u2021", ddarr: "\u21CA", DD: "\u2145", dd: "\u2146", DDotrahd: "\u2911", ddotseq: "\u2A77", deg: "\xB0", Del: "\u2207", Delta: "\u0394", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", Dfr: "\u{1D507}", dfr: "\u{1D521}", dHar: "\u2965", dharl: "\u21C3", dharr: "\u21C2", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", diam: "\u22C4", diamond: "\u22C4", Diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", DifferentialD: "\u2146", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", DJcy: "\u0402", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", Dopf: "\u{1D53B}", dopf: "\u{1D555}", Dot: "\xA8", dot: "\u02D9", DotDot: "\u20DC", doteq: "\u2250", doteqdot: "\u2251", DotEqual: "\u2250", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrowBar: "\u2913", downarrow: "\u2193", DownArrow: "\u2193", Downarrow: "\u21D3", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVectorBar: "\u2956", DownLeftVector: "\u21BD", DownRightTeeVector: "\u295F", DownRightVectorBar: "\u2957", DownRightVector: "\u21C1", DownTeeArrow: "\u21A7", DownTee: "\u22A4", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", Dscr: "\u{1D49F}", dscr: "\u{1D4B9}", DScy: "\u0405", dscy: "\u0455", dsol: "\u29F6", Dstrok: "\u0110", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", DZcy: "\u040F", dzcy: "\u045F", dzigrarr: "\u27FF", Eacute: "\xC9", eacute: "\xE9", easter: "\u2A6E", Ecaron: "\u011A", ecaron: "\u011B", Ecirc: "\xCA", ecirc: "\xEA", ecir: "\u2256", ecolon: "\u2255", Ecy: "\u042D", ecy: "\u044D", eDDot: "\u2A77", Edot: "\u0116", edot: "\u0117", eDot: "\u2251", ee: "\u2147", efDot: "\u2252", Efr: "\u{1D508}", efr: "\u{1D522}", eg: "\u2A9A", Egrave: "\xC8", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", Element: "\u2208", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", Emacr: "\u0112", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", EmptySmallSquare: "\u25FB", emptyv: "\u2205", EmptyVerySmallSquare: "\u25AB", emsp13: "\u2004", emsp14: "\u2005", emsp: "\u2003", ENG: "\u014A", eng: "\u014B", ensp: "\u2002", Eogon: "\u0118", eogon: "\u0119", Eopf: "\u{1D53C}", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", Epsilon: "\u0395", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", Equal: "\u2A75", equals: "=", EqualTilde: "\u2242", equest: "\u225F", Equilibrium: "\u21CC", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erarr: "\u2971", erDot: "\u2253", escr: "\u212F", Escr: "\u2130", esdot: "\u2250", Esim: "\u2A73", esim: "\u2242", Eta: "\u0397", eta: "\u03B7", ETH: "\xD0", eth: "\xF0", Euml: "\xCB", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", Exists: "\u2203", expectation: "\u2130", exponentiale: "\u2147", ExponentialE: "\u2147", fallingdotseq: "\u2252", Fcy: "\u0424", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", Ffr: "\u{1D509}", ffr: "\u{1D523}", filig: "\uFB01", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", Fopf: "\u{1D53D}", fopf: "\u{1D557}", forall: "\u2200", ForAll: "\u2200", fork: "\u22D4", forkv: "\u2AD9", Fouriertrf: "\u2131", fpartint: "\u2A0D", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", fscr: "\u{1D4BB}", Fscr: "\u2131", gacute: "\u01F5", Gamma: "\u0393", gamma: "\u03B3", Gammad: "\u03DC", gammad: "\u03DD", gap: "\u2A86", Gbreve: "\u011E", gbreve: "\u011F", Gcedil: "\u0122", Gcirc: "\u011C", gcirc: "\u011D", Gcy: "\u0413", gcy: "\u0433", Gdot: "\u0120", gdot: "\u0121", ge: "\u2265", gE: "\u2267", gEl: "\u2A8C", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", gescc: "\u2AA9", ges: "\u2A7E", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", Gfr: "\u{1D50A}", gfr: "\u{1D524}", gg: "\u226B", Gg: "\u22D9", ggg: "\u22D9", gimel: "\u2137", GJcy: "\u0403", gjcy: "\u0453", gla: "\u2AA5", gl: "\u2277", glE: "\u2A92", glj: "\u2AA4", gnap: "\u2A8A", gnapprox: "\u2A8A", gne: "\u2A88", gnE: "\u2269", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", Gopf: "\u{1D53E}", gopf: "\u{1D558}", grave: "`", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", gtcc: "\u2AA7", gtcir: "\u2A7A", gt: ">", GT: ">", Gt: "\u226B", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", Hacek: "\u02C7", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", HARDcy: "\u042A", hardcy: "\u044A", harrcir: "\u2948", harr: "\u2194", hArr: "\u21D4", harrw: "\u21AD", Hat: "^", hbar: "\u210F", Hcirc: "\u0124", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", hfr: "\u{1D525}", Hfr: "\u210C", HilbertSpace: "\u210B", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", hopf: "\u{1D559}", Hopf: "\u210D", horbar: "\u2015", HorizontalLine: "\u2500", hscr: "\u{1D4BD}", Hscr: "\u210B", hslash: "\u210F", Hstrok: "\u0126", hstrok: "\u0127", HumpDownHump: "\u224E", HumpEqual: "\u224F", hybull: "\u2043", hyphen: "\u2010", Iacute: "\xCD", iacute: "\xED", ic: "\u2063", Icirc: "\xCE", icirc: "\xEE", Icy: "\u0418", icy: "\u0438", Idot: "\u0130", IEcy: "\u0415", iecy: "\u0435", iexcl: "\xA1", iff: "\u21D4", ifr: "\u{1D526}", Ifr: "\u2111", Igrave: "\xCC", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", IJlig: "\u0132", ijlig: "\u0133", Imacr: "\u012A", imacr: "\u012B", image: "\u2111", ImaginaryI: "\u2148", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", Im: "\u2111", imof: "\u22B7", imped: "\u01B5", Implies: "\u21D2", incare: "\u2105", in: "\u2208", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", intcal: "\u22BA", int: "\u222B", Int: "\u222C", integers: "\u2124", Integral: "\u222B", intercal: "\u22BA", Intersection: "\u22C2", intlarhk: "\u2A17", intprod: "\u2A3C", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", IOcy: "\u0401", iocy: "\u0451", Iogon: "\u012E", iogon: "\u012F", Iopf: "\u{1D540}", iopf: "\u{1D55A}", Iota: "\u0399", iota: "\u03B9", iprod: "\u2A3C", iquest: "\xBF", iscr: "\u{1D4BE}", Iscr: "\u2110", isin: "\u2208", isindot: "\u22F5", isinE: "\u22F9", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", Itilde: "\u0128", itilde: "\u0129", Iukcy: "\u0406", iukcy: "\u0456", Iuml: "\xCF", iuml: "\xEF", Jcirc: "\u0134", jcirc: "\u0135", Jcy: "\u0419", jcy: "\u0439", Jfr: "\u{1D50D}", jfr: "\u{1D527}", jmath: "\u0237", Jopf: "\u{1D541}", jopf: "\u{1D55B}", Jscr: "\u{1D4A5}", jscr: "\u{1D4BF}", Jsercy: "\u0408", jsercy: "\u0458", Jukcy: "\u0404", jukcy: "\u0454", Kappa: "\u039A", kappa: "\u03BA", kappav: "\u03F0", Kcedil: "\u0136", kcedil: "\u0137", Kcy: "\u041A", kcy: "\u043A", Kfr: "\u{1D50E}", kfr: "\u{1D528}", kgreen: "\u0138", KHcy: "\u0425", khcy: "\u0445", KJcy: "\u040C", kjcy: "\u045C", Kopf: "\u{1D542}", kopf: "\u{1D55C}", Kscr: "\u{1D4A6}", kscr: "\u{1D4C0}", lAarr: "\u21DA", Lacute: "\u0139", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", Lambda: "\u039B", lambda: "\u03BB", lang: "\u27E8", Lang: "\u27EA", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", Laplacetrf: "\u2112", laquo: "\xAB", larrb: "\u21E4", larrbfs: "\u291F", larr: "\u2190", Larr: "\u219E", lArr: "\u21D0", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", latail: "\u2919", lAtail: "\u291B", lat: "\u2AAB", late: "\u2AAD", lates: "\u2AAD\uFE00", lbarr: "\u290C", lBarr: "\u290E", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", Lcaron: "\u013D", lcaron: "\u013E", Lcedil: "\u013B", lcedil: "\u013C", lceil: "\u2308", lcub: "{", Lcy: "\u041B", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", le: "\u2264", lE: "\u2266", LeftAngleBracket: "\u27E8", LeftArrowBar: "\u21E4", leftarrow: "\u2190", LeftArrow: "\u2190", Leftarrow: "\u21D0", LeftArrowRightArrow: "\u21C6", leftarrowtail: "\u21A2", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVectorBar: "\u2959", LeftDownVector: "\u21C3", LeftFloor: "\u230A", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", leftrightarrow: "\u2194", LeftRightArrow: "\u2194", Leftrightarrow: "\u21D4", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", LeftRightVector: "\u294E", LeftTeeArrow: "\u21A4", LeftTee: "\u22A3", LeftTeeVector: "\u295A", leftthreetimes: "\u22CB", LeftTriangleBar: "\u29CF", LeftTriangle: "\u22B2", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVectorBar: "\u2958", LeftUpVector: "\u21BF", LeftVectorBar: "\u2952", LeftVector: "\u21BC", lEg: "\u2A8B", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", lescc: "\u2AA8", les: "\u2A7D", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", lessgtr: "\u2276", LessLess: "\u2AA1", lesssim: "\u2272", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", lfisht: "\u297C", lfloor: "\u230A", Lfr: "\u{1D50F}", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lHar: "\u2962", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", LJcy: "\u0409", ljcy: "\u0459", llarr: "\u21C7", ll: "\u226A", Ll: "\u22D8", llcorner: "\u231E", Lleftarrow: "\u21DA", llhard: "\u296B", lltri: "\u25FA", Lmidot: "\u013F", lmidot: "\u0140", lmoustache: "\u23B0", lmoust: "\u23B0", lnap: "\u2A89", lnapprox: "\u2A89", lne: "\u2A87", lnE: "\u2268", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", longleftarrow: "\u27F5", LongLeftArrow: "\u27F5", Longleftarrow: "\u27F8", longleftrightarrow: "\u27F7", LongLeftRightArrow: "\u27F7", Longleftrightarrow: "\u27FA", longmapsto: "\u27FC", longrightarrow: "\u27F6", LongRightArrow: "\u27F6", Longrightarrow: "\u27F9", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", Lopf: "\u{1D543}", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", lscr: "\u{1D4C1}", Lscr: "\u2112", lsh: "\u21B0", Lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", Lstrok: "\u0141", lstrok: "\u0142", ltcc: "\u2AA6", ltcir: "\u2A79", lt: "<", LT: "<", Lt: "\u226A", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", ltrPar: "\u2996", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", Map: "\u2905", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", Mcy: "\u041C", mcy: "\u043C", mdash: "\u2014", mDDot: "\u223A", measuredangle: "\u2221", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", mfr: "\u{1D52A}", mho: "\u2127", micro: "\xB5", midast: "*", midcir: "\u2AF0", mid: "\u2223", middot: "\xB7", minusb: "\u229F", minus: "\u2212", minusd: "\u2238", minusdu: "\u2A2A", MinusPlus: "\u2213", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", Mopf: "\u{1D544}", mopf: "\u{1D55E}", mp: "\u2213", mscr: "\u{1D4C2}", Mscr: "\u2133", mstpos: "\u223E", Mu: "\u039C", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nabla: "\u2207", Nacute: "\u0143", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natural: "\u266E", naturals: "\u2115", natur: "\u266E", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", Ncaron: "\u0147", ncaron: "\u0148", Ncedil: "\u0145", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", Ncy: "\u041D", ncy: "\u043D", ndash: "\u2013", nearhk: "\u2924", nearr: "\u2197", neArr: "\u21D7", nearrow: "\u2197", ne: "\u2260", nedot: "\u2250\u0338", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: `
`, nexist: "\u2204", nexists: "\u2204", Nfr: "\u{1D511}", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", nGg: "\u22D9\u0338", ngsim: "\u2275", nGt: "\u226B\u20D2", ngt: "\u226F", ngtr: "\u226F", nGtv: "\u226B\u0338", nharr: "\u21AE", nhArr: "\u21CE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", NJcy: "\u040A", njcy: "\u045A", nlarr: "\u219A", nlArr: "\u21CD", nldr: "\u2025", nlE: "\u2266\u0338", nle: "\u2270", nleftarrow: "\u219A", nLeftarrow: "\u21CD", nleftrightarrow: "\u21AE", nLeftrightarrow: "\u21CE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nLl: "\u22D8\u0338", nlsim: "\u2274", nLt: "\u226A\u20D2", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nLtv: "\u226A\u0338", nmid: "\u2224", NoBreak: "\u2060", NonBreakingSpace: "\xA0", nopf: "\u{1D55F}", Nopf: "\u2115", Not: "\u2AEC", not: "\xAC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", notin: "\u2209", notindot: "\u22F5\u0338", notinE: "\u22F9\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangle: "\u22EA", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangle: "\u22EB", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", nparallel: "\u2226", npar: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", nprec: "\u2280", npreceq: "\u2AAF\u0338", npre: "\u2AAF\u0338", nrarrc: "\u2933\u0338", nrarr: "\u219B", nrArr: "\u21CF", nrarrw: "\u219D\u0338", nrightarrow: "\u219B", nRightarrow: "\u21CF", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", Nscr: "\u{1D4A9}", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", Ntilde: "\xD1", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", Nu: "\u039D", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvap: "\u224D\u20D2", nvdash: "\u22AC", nvDash: "\u22AD", nVdash: "\u22AE", nVDash: "\u22AF", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvHarr: "\u2904", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwarhk: "\u2923", nwarr: "\u2196", nwArr: "\u21D6", nwarrow: "\u2196", nwnear: "\u2927", Oacute: "\xD3", oacute: "\xF3", oast: "\u229B", Ocirc: "\xD4", ocirc: "\xF4", ocir: "\u229A", Ocy: "\u041E", ocy: "\u043E", odash: "\u229D", Odblac: "\u0150", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", OElig: "\u0152", oelig: "\u0153", ofcir: "\u29BF", Ofr: "\u{1D512}", ofr: "\u{1D52C}", ogon: "\u02DB", Ograve: "\xD2", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", Omacr: "\u014C", omacr: "\u014D", Omega: "\u03A9", omega: "\u03C9", Omicron: "\u039F", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", Oopf: "\u{1D546}", oopf: "\u{1D560}", opar: "\u29B7", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", operp: "\u29B9", oplus: "\u2295", orarr: "\u21BB", Or: "\u2A54", or: "\u2228", ord: "\u2A5D", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oS: "\u24C8", Oscr: "\u{1D4AA}", oscr: "\u2134", Oslash: "\xD8", oslash: "\xF8", osol: "\u2298", Otilde: "\xD5", otilde: "\xF5", otimesas: "\u2A36", Otimes: "\u2A37", otimes: "\u2297", Ouml: "\xD6", ouml: "\xF6", ovbar: "\u233D", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", para: "\xB6", parallel: "\u2225", par: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", PartialD: "\u2202", Pcy: "\u041F", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", Pfr: "\u{1D513}", pfr: "\u{1D52D}", Phi: "\u03A6", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", Pi: "\u03A0", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plus: "+", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", PlusMinus: "\xB1", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", Poincareplane: "\u210C", pointint: "\u2A15", popf: "\u{1D561}", Popf: "\u2119", pound: "\xA3", prap: "\u2AB7", Pr: "\u2ABB", pr: "\u227A", prcue: "\u227C", precapprox: "\u2AB7", prec: "\u227A", preccurlyeq: "\u227C", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", pre: "\u2AAF", prE: "\u2AB3", precsim: "\u227E", prime: "\u2032", Prime: "\u2033", primes: "\u2119", prnap: "\u2AB9", prnE: "\u2AB5", prnsim: "\u22E8", prod: "\u220F", Product: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", Proportional: "\u221D", Proportion: "\u2237", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", Pscr: "\u{1D4AB}", pscr: "\u{1D4C5}", Psi: "\u03A8", psi: "\u03C8", puncsp: "\u2008", Qfr: "\u{1D514}", qfr: "\u{1D52E}", qint: "\u2A0C", qopf: "\u{1D562}", Qopf: "\u211A", qprime: "\u2057", Qscr: "\u{1D4AC}", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", quot: '"', QUOT: '"', rAarr: "\u21DB", race: "\u223D\u0331", Racute: "\u0154", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", rang: "\u27E9", Rang: "\u27EB", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raquo: "\xBB", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarr: "\u2192", Rarr: "\u21A0", rArr: "\u21D2", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", Rarrtl: "\u2916", rarrtl: "\u21A3", rarrw: "\u219D", ratail: "\u291A", rAtail: "\u291C", ratio: "\u2236", rationals: "\u211A", rbarr: "\u290D", rBarr: "\u290F", RBarr: "\u2910", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", Rcaron: "\u0158", rcaron: "\u0159", Rcedil: "\u0156", rcedil: "\u0157", rceil: "\u2309", rcub: "}", Rcy: "\u0420", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", Re: "\u211C", rect: "\u25AD", reg: "\xAE", REG: "\xAE", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", rfisht: "\u297D", rfloor: "\u230B", rfr: "\u{1D52F}", Rfr: "\u211C", rHar: "\u2964", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", Rho: "\u03A1", rho: "\u03C1", rhov: "\u03F1", RightAngleBracket: "\u27E9", RightArrowBar: "\u21E5", rightarrow: "\u2192", RightArrow: "\u2192", Rightarrow: "\u21D2", RightArrowLeftArrow: "\u21C4", rightarrowtail: "\u21A3", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVectorBar: "\u2955", RightDownVector: "\u21C2", RightFloor: "\u230B", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", RightTeeArrow: "\u21A6", RightTee: "\u22A2", RightTeeVector: "\u295B", rightthreetimes: "\u22CC", RightTriangleBar: "\u29D0", RightTriangle: "\u22B3", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVectorBar: "\u2954", RightUpVector: "\u21BE", RightVectorBar: "\u2953", RightVector: "\u21C0", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoustache: "\u23B1", rmoust: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", ropf: "\u{1D563}", Ropf: "\u211D", roplus: "\u2A2E", rotimes: "\u2A35", RoundImplies: "\u2970", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", Rrightarrow: "\u21DB", rsaquo: "\u203A", rscr: "\u{1D4C7}", Rscr: "\u211B", rsh: "\u21B1", Rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", RuleDelayed: "\u29F4", ruluhar: "\u2968", rx: "\u211E", Sacute: "\u015A", sacute: "\u015B", sbquo: "\u201A", scap: "\u2AB8", Scaron: "\u0160", scaron: "\u0161", Sc: "\u2ABC", sc: "\u227B", sccue: "\u227D", sce: "\u2AB0", scE: "\u2AB4", Scedil: "\u015E", scedil: "\u015F", Scirc: "\u015C", scirc: "\u015D", scnap: "\u2ABA", scnE: "\u2AB6", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", Scy: "\u0421", scy: "\u0441", sdotb: "\u22A1", sdot: "\u22C5", sdote: "\u2A66", searhk: "\u2925", searr: "\u2198", seArr: "\u21D8", searrow: "\u2198", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", Sfr: "\u{1D516}", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", SHCHcy: "\u0429", shchcy: "\u0449", SHcy: "\u0428", shcy: "\u0448", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", shortmid: "\u2223", shortparallel: "\u2225", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", shy: "\xAD", Sigma: "\u03A3", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", SmallCircle: "\u2218", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", SOFTcy: "\u042C", softcy: "\u044C", solbar: "\u233F", solb: "\u29C4", sol: "/", Sopf: "\u{1D54A}", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", Sqrt: "\u221A", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", square: "\u25A1", Square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", squarf: "\u25AA", squ: "\u25A1", squf: "\u25AA", srarr: "\u2192", Sscr: "\u{1D4AE}", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", Star: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", sub: "\u2282", Sub: "\u22D0", subdot: "\u2ABD", subE: "\u2AC5", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", subset: "\u2282", Subset: "\u22D0", subseteq: "\u2286", subseteqq: "\u2AC5", SubsetEqual: "\u2286", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succapprox: "\u2AB8", succ: "\u227B", succcurlyeq: "\u227D", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", SuchThat: "\u220B", sum: "\u2211", Sum: "\u2211", sung: "\u266A", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", sup: "\u2283", Sup: "\u22D1", supdot: "\u2ABE", supdsub: "\u2AD8", supE: "\u2AC6", supe: "\u2287", supedot: "\u2AC4", Superset: "\u2283", SupersetEqual: "\u2287", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", supset: "\u2283", Supset: "\u22D1", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swarhk: "\u2926", swarr: "\u2199", swArr: "\u21D9", swarrow: "\u2199", swnwar: "\u292A", szlig: "\xDF", Tab: "	", target: "\u2316", Tau: "\u03A4", tau: "\u03C4", tbrk: "\u23B4", Tcaron: "\u0164", tcaron: "\u0165", Tcedil: "\u0162", tcedil: "\u0163", Tcy: "\u0422", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", Tfr: "\u{1D517}", tfr: "\u{1D531}", there4: "\u2234", therefore: "\u2234", Therefore: "\u2234", Theta: "\u0398", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", ThickSpace: "\u205F\u200A", ThinSpace: "\u2009", thinsp: "\u2009", thkap: "\u2248", thksim: "\u223C", THORN: "\xDE", thorn: "\xFE", tilde: "\u02DC", Tilde: "\u223C", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", timesbar: "\u2A31", timesb: "\u22A0", times: "\xD7", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", topbot: "\u2336", topcir: "\u2AF1", top: "\u22A4", Topf: "\u{1D54B}", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", trade: "\u2122", TRADE: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", TripleDot: "\u20DB", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", Tscr: "\u{1D4AF}", tscr: "\u{1D4C9}", TScy: "\u0426", tscy: "\u0446", TSHcy: "\u040B", tshcy: "\u045B", Tstrok: "\u0166", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", Uacute: "\xDA", uacute: "\xFA", uarr: "\u2191", Uarr: "\u219F", uArr: "\u21D1", Uarrocir: "\u2949", Ubrcy: "\u040E", ubrcy: "\u045E", Ubreve: "\u016C", ubreve: "\u016D", Ucirc: "\xDB", ucirc: "\xFB", Ucy: "\u0423", ucy: "\u0443", udarr: "\u21C5", Udblac: "\u0170", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", Ufr: "\u{1D518}", ufr: "\u{1D532}", Ugrave: "\xD9", ugrave: "\xF9", uHar: "\u2963", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", Umacr: "\u016A", umacr: "\u016B", uml: "\xA8", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", uogon: "\u0173", Uopf: "\u{1D54C}", uopf: "\u{1D566}", UpArrowBar: "\u2912", uparrow: "\u2191", UpArrow: "\u2191", Uparrow: "\u21D1", UpArrowDownArrow: "\u21C5", updownarrow: "\u2195", UpDownArrow: "\u2195", Updownarrow: "\u21D5", UpEquilibrium: "\u296E", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", upsi: "\u03C5", Upsi: "\u03D2", upsih: "\u03D2", Upsilon: "\u03A5", upsilon: "\u03C5", UpTeeArrow: "\u21A5", UpTee: "\u22A5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", Uring: "\u016E", uring: "\u016F", urtri: "\u25F9", Uscr: "\u{1D4B0}", uscr: "\u{1D4CA}", utdot: "\u22F0", Utilde: "\u0168", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", Uuml: "\xDC", uuml: "\xFC", uwangle: "\u29A7", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", varr: "\u2195", vArr: "\u21D5", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", vBar: "\u2AE8", Vbar: "\u2AEB", vBarv: "\u2AE9", Vcy: "\u0412", vcy: "\u0432", vdash: "\u22A2", vDash: "\u22A8", Vdash: "\u22A9", VDash: "\u22AB", Vdashl: "\u2AE6", veebar: "\u22BB", vee: "\u2228", Vee: "\u22C1", veeeq: "\u225A", vellip: "\u22EE", verbar: "|", Verbar: "\u2016", vert: "|", Vert: "\u2016", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", Vopf: "\u{1D54D}", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", Vscr: "\u{1D4B1}", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", Vvdash: "\u22AA", vzigzag: "\u299A", Wcirc: "\u0174", wcirc: "\u0175", wedbar: "\u2A5F", wedge: "\u2227", Wedge: "\u22C0", wedgeq: "\u2259", weierp: "\u2118", Wfr: "\u{1D51A}", wfr: "\u{1D534}", Wopf: "\u{1D54E}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", Wscr: "\u{1D4B2}", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", Xfr: "\u{1D51B}", xfr: "\u{1D535}", xharr: "\u27F7", xhArr: "\u27FA", Xi: "\u039E", xi: "\u03BE", xlarr: "\u27F5", xlArr: "\u27F8", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", Xopf: "\u{1D54F}", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrarr: "\u27F6", xrArr: "\u27F9", Xscr: "\u{1D4B3}", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", Yacute: "\xDD", yacute: "\xFD", YAcy: "\u042F", yacy: "\u044F", Ycirc: "\u0176", ycirc: "\u0177", Ycy: "\u042B", ycy: "\u044B", yen: "\xA5", Yfr: "\u{1D51C}", yfr: "\u{1D536}", YIcy: "\u0407", yicy: "\u0457", Yopf: "\u{1D550}", yopf: "\u{1D56A}", Yscr: "\u{1D4B4}", yscr: "\u{1D4CE}", YUcy: "\u042E", yucy: "\u044E", yuml: "\xFF", Yuml: "\u0178", Zacute: "\u0179", zacute: "\u017A", Zcaron: "\u017D", zcaron: "\u017E", Zcy: "\u0417", zcy: "\u0437", Zdot: "\u017B", zdot: "\u017C", zeetrf: "\u2128", ZeroWidthSpace: "\u200B", Zeta: "\u0396", zeta: "\u03B6", zfr: "\u{1D537}", Zfr: "\u2128", ZHcy: "\u0416", zhcy: "\u0436", zigrarr: "\u21DD", zopf: "\u{1D56B}", Zopf: "\u2124", Zscr: "\u{1D4B5}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" }, c = /^#[xX]([A-Fa-f0-9]+)$/, o = /^#([0-9]+)$/, e2 = /^([A-Za-z0-9]+)$/, r2 = function() {
              function E(v) {
                this.named = v;
              }
              return E.prototype.parse = function(v) {
                if (!!v) {
                  var _ = v.match(c);
                  if (_)
                    return String.fromCharCode(parseInt(_[1], 16));
                  if (_ = v.match(o), _)
                    return String.fromCharCode(parseInt(_[1], 10));
                  if (_ = v.match(e2), _)
                    return this.named[_[1]];
                }
              }, E;
            }(), s2 = /[\t\n\f ]/, p = /[A-Za-z]/, n = /\r\n?/g;
            function a(E) {
              return s2.test(E);
            }
            function u(E) {
              return p.test(E);
            }
            function i2(E) {
              return E.replace(n, `
`);
            }
            var l = function() {
              function E(v, _, y) {
                y === void 0 && (y = "precompile"), this.delegate = v, this.entityParser = _, this.mode = y, this.state = "beforeData", this.line = -1, this.column = -1, this.input = "", this.index = -1, this.tagNameBuffer = "", this.states = { beforeData: function() {
                  var g = this.peek();
                  if (g === "<" && !this.isIgnoredEndTag())
                    this.transitionTo("tagOpen"), this.markTagStart(), this.consume();
                  else {
                    if (this.mode === "precompile" && g === `
`) {
                      var L = this.tagNameBuffer.toLowerCase();
                      (L === "pre" || L === "textarea") && this.consume();
                    }
                    this.transitionTo("data"), this.delegate.beginData();
                  }
                }, data: function() {
                  var g = this.peek(), L = this.tagNameBuffer;
                  g === "<" && !this.isIgnoredEndTag() ? (this.delegate.finishData(), this.transitionTo("tagOpen"), this.markTagStart(), this.consume()) : g === "&" && L !== "script" && L !== "style" ? (this.consume(), this.delegate.appendToData(this.consumeCharRef() || "&")) : (this.consume(), this.delegate.appendToData(g));
                }, tagOpen: function() {
                  var g = this.consume();
                  g === "!" ? this.transitionTo("markupDeclarationOpen") : g === "/" ? this.transitionTo("endTagOpen") : (g === "@" || g === ":" || u(g)) && (this.transitionTo("tagName"), this.tagNameBuffer = "", this.delegate.beginStartTag(), this.appendToTagName(g));
                }, markupDeclarationOpen: function() {
                  var g = this.consume();
                  if (g === "-" && this.peek() === "-")
                    this.consume(), this.transitionTo("commentStart"), this.delegate.beginComment();
                  else {
                    var L = g.toUpperCase() + this.input.substring(this.index, this.index + 6).toUpperCase();
                    L === "DOCTYPE" && (this.consume(), this.consume(), this.consume(), this.consume(), this.consume(), this.consume(), this.transitionTo("doctype"), this.delegate.beginDoctype && this.delegate.beginDoctype());
                  }
                }, doctype: function() {
                  var g = this.consume();
                  a(g) && this.transitionTo("beforeDoctypeName");
                }, beforeDoctypeName: function() {
                  var g = this.consume();
                  a(g) || (this.transitionTo("doctypeName"), this.delegate.appendToDoctypeName && this.delegate.appendToDoctypeName(g.toLowerCase()));
                }, doctypeName: function() {
                  var g = this.consume();
                  a(g) ? this.transitionTo("afterDoctypeName") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypeName && this.delegate.appendToDoctypeName(g.toLowerCase());
                }, afterDoctypeName: function() {
                  var g = this.consume();
                  if (!a(g))
                    if (g === ">")
                      this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData");
                    else {
                      var L = g.toUpperCase() + this.input.substring(this.index, this.index + 5).toUpperCase(), j = L.toUpperCase() === "PUBLIC", x2 = L.toUpperCase() === "SYSTEM";
                      (j || x2) && (this.consume(), this.consume(), this.consume(), this.consume(), this.consume(), this.consume()), j ? this.transitionTo("afterDoctypePublicKeyword") : x2 && this.transitionTo("afterDoctypeSystemKeyword");
                    }
                }, afterDoctypePublicKeyword: function() {
                  var g = this.peek();
                  a(g) ? (this.transitionTo("beforeDoctypePublicIdentifier"), this.consume()) : g === '"' ? (this.transitionTo("doctypePublicIdentifierDoubleQuoted"), this.consume()) : g === "'" ? (this.transitionTo("doctypePublicIdentifierSingleQuoted"), this.consume()) : g === ">" && (this.consume(), this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData"));
                }, doctypePublicIdentifierDoubleQuoted: function() {
                  var g = this.consume();
                  g === '"' ? this.transitionTo("afterDoctypePublicIdentifier") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypePublicIdentifier && this.delegate.appendToDoctypePublicIdentifier(g);
                }, doctypePublicIdentifierSingleQuoted: function() {
                  var g = this.consume();
                  g === "'" ? this.transitionTo("afterDoctypePublicIdentifier") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypePublicIdentifier && this.delegate.appendToDoctypePublicIdentifier(g);
                }, afterDoctypePublicIdentifier: function() {
                  var g = this.consume();
                  a(g) ? this.transitionTo("betweenDoctypePublicAndSystemIdentifiers") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : g === '"' ? this.transitionTo("doctypeSystemIdentifierDoubleQuoted") : g === "'" && this.transitionTo("doctypeSystemIdentifierSingleQuoted");
                }, betweenDoctypePublicAndSystemIdentifiers: function() {
                  var g = this.consume();
                  a(g) || (g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : g === '"' ? this.transitionTo("doctypeSystemIdentifierDoubleQuoted") : g === "'" && this.transitionTo("doctypeSystemIdentifierSingleQuoted"));
                }, doctypeSystemIdentifierDoubleQuoted: function() {
                  var g = this.consume();
                  g === '"' ? this.transitionTo("afterDoctypeSystemIdentifier") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypeSystemIdentifier && this.delegate.appendToDoctypeSystemIdentifier(g);
                }, doctypeSystemIdentifierSingleQuoted: function() {
                  var g = this.consume();
                  g === "'" ? this.transitionTo("afterDoctypeSystemIdentifier") : g === ">" ? (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData")) : this.delegate.appendToDoctypeSystemIdentifier && this.delegate.appendToDoctypeSystemIdentifier(g);
                }, afterDoctypeSystemIdentifier: function() {
                  var g = this.consume();
                  a(g) || g === ">" && (this.delegate.endDoctype && this.delegate.endDoctype(), this.transitionTo("beforeData"));
                }, commentStart: function() {
                  var g = this.consume();
                  g === "-" ? this.transitionTo("commentStartDash") : g === ">" ? (this.delegate.finishComment(), this.transitionTo("beforeData")) : (this.delegate.appendToCommentData(g), this.transitionTo("comment"));
                }, commentStartDash: function() {
                  var g = this.consume();
                  g === "-" ? this.transitionTo("commentEnd") : g === ">" ? (this.delegate.finishComment(), this.transitionTo("beforeData")) : (this.delegate.appendToCommentData("-"), this.transitionTo("comment"));
                }, comment: function() {
                  var g = this.consume();
                  g === "-" ? this.transitionTo("commentEndDash") : this.delegate.appendToCommentData(g);
                }, commentEndDash: function() {
                  var g = this.consume();
                  g === "-" ? this.transitionTo("commentEnd") : (this.delegate.appendToCommentData("-" + g), this.transitionTo("comment"));
                }, commentEnd: function() {
                  var g = this.consume();
                  g === ">" ? (this.delegate.finishComment(), this.transitionTo("beforeData")) : (this.delegate.appendToCommentData("--" + g), this.transitionTo("comment"));
                }, tagName: function() {
                  var g = this.consume();
                  a(g) ? this.transitionTo("beforeAttributeName") : g === "/" ? this.transitionTo("selfClosingStartTag") : g === ">" ? (this.delegate.finishTag(), this.transitionTo("beforeData")) : this.appendToTagName(g);
                }, endTagName: function() {
                  var g = this.consume();
                  a(g) ? (this.transitionTo("beforeAttributeName"), this.tagNameBuffer = "") : g === "/" ? (this.transitionTo("selfClosingStartTag"), this.tagNameBuffer = "") : g === ">" ? (this.delegate.finishTag(), this.transitionTo("beforeData"), this.tagNameBuffer = "") : this.appendToTagName(g);
                }, beforeAttributeName: function() {
                  var g = this.peek();
                  if (a(g)) {
                    this.consume();
                    return;
                  } else
                    g === "/" ? (this.transitionTo("selfClosingStartTag"), this.consume()) : g === ">" ? (this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : g === "=" ? (this.delegate.reportSyntaxError("attribute name cannot start with equals sign"), this.transitionTo("attributeName"), this.delegate.beginAttribute(), this.consume(), this.delegate.appendToAttributeName(g)) : (this.transitionTo("attributeName"), this.delegate.beginAttribute());
                }, attributeName: function() {
                  var g = this.peek();
                  a(g) ? (this.transitionTo("afterAttributeName"), this.consume()) : g === "/" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.transitionTo("selfClosingStartTag")) : g === "=" ? (this.transitionTo("beforeAttributeValue"), this.consume()) : g === ">" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : g === '"' || g === "'" || g === "<" ? (this.delegate.reportSyntaxError(g + " is not a valid character within attribute names"), this.consume(), this.delegate.appendToAttributeName(g)) : (this.consume(), this.delegate.appendToAttributeName(g));
                }, afterAttributeName: function() {
                  var g = this.peek();
                  if (a(g)) {
                    this.consume();
                    return;
                  } else
                    g === "/" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.transitionTo("selfClosingStartTag")) : g === "=" ? (this.consume(), this.transitionTo("beforeAttributeValue")) : g === ">" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.transitionTo("attributeName"), this.delegate.beginAttribute(), this.consume(), this.delegate.appendToAttributeName(g));
                }, beforeAttributeValue: function() {
                  var g = this.peek();
                  a(g) ? this.consume() : g === '"' ? (this.transitionTo("attributeValueDoubleQuoted"), this.delegate.beginAttributeValue(true), this.consume()) : g === "'" ? (this.transitionTo("attributeValueSingleQuoted"), this.delegate.beginAttributeValue(true), this.consume()) : g === ">" ? (this.delegate.beginAttributeValue(false), this.delegate.finishAttributeValue(), this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : (this.transitionTo("attributeValueUnquoted"), this.delegate.beginAttributeValue(false), this.consume(), this.delegate.appendToAttributeValue(g));
                }, attributeValueDoubleQuoted: function() {
                  var g = this.consume();
                  g === '"' ? (this.delegate.finishAttributeValue(), this.transitionTo("afterAttributeValueQuoted")) : g === "&" ? this.delegate.appendToAttributeValue(this.consumeCharRef() || "&") : this.delegate.appendToAttributeValue(g);
                }, attributeValueSingleQuoted: function() {
                  var g = this.consume();
                  g === "'" ? (this.delegate.finishAttributeValue(), this.transitionTo("afterAttributeValueQuoted")) : g === "&" ? this.delegate.appendToAttributeValue(this.consumeCharRef() || "&") : this.delegate.appendToAttributeValue(g);
                }, attributeValueUnquoted: function() {
                  var g = this.peek();
                  a(g) ? (this.delegate.finishAttributeValue(), this.consume(), this.transitionTo("beforeAttributeName")) : g === "/" ? (this.delegate.finishAttributeValue(), this.consume(), this.transitionTo("selfClosingStartTag")) : g === "&" ? (this.consume(), this.delegate.appendToAttributeValue(this.consumeCharRef() || "&")) : g === ">" ? (this.delegate.finishAttributeValue(), this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : (this.consume(), this.delegate.appendToAttributeValue(g));
                }, afterAttributeValueQuoted: function() {
                  var g = this.peek();
                  a(g) ? (this.consume(), this.transitionTo("beforeAttributeName")) : g === "/" ? (this.consume(), this.transitionTo("selfClosingStartTag")) : g === ">" ? (this.consume(), this.delegate.finishTag(), this.transitionTo("beforeData")) : this.transitionTo("beforeAttributeName");
                }, selfClosingStartTag: function() {
                  var g = this.peek();
                  g === ">" ? (this.consume(), this.delegate.markTagAsSelfClosing(), this.delegate.finishTag(), this.transitionTo("beforeData")) : this.transitionTo("beforeAttributeName");
                }, endTagOpen: function() {
                  var g = this.consume();
                  (g === "@" || g === ":" || u(g)) && (this.transitionTo("endTagName"), this.tagNameBuffer = "", this.delegate.beginEndTag(), this.appendToTagName(g));
                } }, this.reset();
              }
              return E.prototype.reset = function() {
                this.transitionTo("beforeData"), this.input = "", this.tagNameBuffer = "", this.index = 0, this.line = 1, this.column = 0, this.delegate.reset();
              }, E.prototype.transitionTo = function(v) {
                this.state = v;
              }, E.prototype.tokenize = function(v) {
                this.reset(), this.tokenizePart(v), this.tokenizeEOF();
              }, E.prototype.tokenizePart = function(v) {
                for (this.input += i2(v); this.index < this.input.length; ) {
                  var _ = this.states[this.state];
                  if (_ !== void 0)
                    _.call(this);
                  else
                    throw new Error("unhandled state " + this.state);
                }
              }, E.prototype.tokenizeEOF = function() {
                this.flushData();
              }, E.prototype.flushData = function() {
                this.state === "data" && (this.delegate.finishData(), this.transitionTo("beforeData"));
              }, E.prototype.peek = function() {
                return this.input.charAt(this.index);
              }, E.prototype.consume = function() {
                var v = this.peek();
                return this.index++, v === `
` ? (this.line++, this.column = 0) : this.column++, v;
              }, E.prototype.consumeCharRef = function() {
                var v = this.input.indexOf(";", this.index);
                if (v !== -1) {
                  var _ = this.input.slice(this.index, v), y = this.entityParser.parse(_);
                  if (y) {
                    for (var g = _.length; g; )
                      this.consume(), g--;
                    return this.consume(), y;
                  }
                }
              }, E.prototype.markTagStart = function() {
                this.delegate.tagOpen();
              }, E.prototype.appendToTagName = function(v) {
                this.tagNameBuffer += v, this.delegate.appendToTagName(v);
              }, E.prototype.isIgnoredEndTag = function() {
                var v = this.tagNameBuffer;
                return v === "title" && this.input.substring(this.index, this.index + 8) !== "</title>" || v === "style" && this.input.substring(this.index, this.index + 8) !== "</style>" || v === "script" && this.input.substring(this.index, this.index + 9) !== "<\/script>";
              }, E;
            }(), b = function() {
              function E(v, _) {
                _ === void 0 && (_ = {}), this.options = _, this.token = null, this.startLine = 1, this.startColumn = 0, this.tokens = [], this.tokenizer = new l(this, v, _.mode), this._currentAttribute = void 0;
              }
              return E.prototype.tokenize = function(v) {
                return this.tokens = [], this.tokenizer.tokenize(v), this.tokens;
              }, E.prototype.tokenizePart = function(v) {
                return this.tokens = [], this.tokenizer.tokenizePart(v), this.tokens;
              }, E.prototype.tokenizeEOF = function() {
                return this.tokens = [], this.tokenizer.tokenizeEOF(), this.tokens[0];
              }, E.prototype.reset = function() {
                this.token = null, this.startLine = 1, this.startColumn = 0;
              }, E.prototype.current = function() {
                var v = this.token;
                if (v === null)
                  throw new Error("token was unexpectedly null");
                if (arguments.length === 0)
                  return v;
                for (var _ = 0; _ < arguments.length; _++)
                  if (v.type === arguments[_])
                    return v;
                throw new Error("token type was unexpectedly " + v.type);
              }, E.prototype.push = function(v) {
                this.token = v, this.tokens.push(v);
              }, E.prototype.currentAttribute = function() {
                return this._currentAttribute;
              }, E.prototype.addLocInfo = function() {
                this.options.loc && (this.current().loc = { start: { line: this.startLine, column: this.startColumn }, end: { line: this.tokenizer.line, column: this.tokenizer.column } }), this.startLine = this.tokenizer.line, this.startColumn = this.tokenizer.column;
              }, E.prototype.beginDoctype = function() {
                this.push({ type: "Doctype", name: "" });
              }, E.prototype.appendToDoctypeName = function(v) {
                this.current("Doctype").name += v;
              }, E.prototype.appendToDoctypePublicIdentifier = function(v) {
                var _ = this.current("Doctype");
                _.publicIdentifier === void 0 ? _.publicIdentifier = v : _.publicIdentifier += v;
              }, E.prototype.appendToDoctypeSystemIdentifier = function(v) {
                var _ = this.current("Doctype");
                _.systemIdentifier === void 0 ? _.systemIdentifier = v : _.systemIdentifier += v;
              }, E.prototype.endDoctype = function() {
                this.addLocInfo();
              }, E.prototype.beginData = function() {
                this.push({ type: "Chars", chars: "" });
              }, E.prototype.appendToData = function(v) {
                this.current("Chars").chars += v;
              }, E.prototype.finishData = function() {
                this.addLocInfo();
              }, E.prototype.beginComment = function() {
                this.push({ type: "Comment", chars: "" });
              }, E.prototype.appendToCommentData = function(v) {
                this.current("Comment").chars += v;
              }, E.prototype.finishComment = function() {
                this.addLocInfo();
              }, E.prototype.tagOpen = function() {
              }, E.prototype.beginStartTag = function() {
                this.push({ type: "StartTag", tagName: "", attributes: [], selfClosing: false });
              }, E.prototype.beginEndTag = function() {
                this.push({ type: "EndTag", tagName: "" });
              }, E.prototype.finishTag = function() {
                this.addLocInfo();
              }, E.prototype.markTagAsSelfClosing = function() {
                this.current("StartTag").selfClosing = true;
              }, E.prototype.appendToTagName = function(v) {
                this.current("StartTag", "EndTag").tagName += v;
              }, E.prototype.beginAttribute = function() {
                this._currentAttribute = ["", "", false];
              }, E.prototype.appendToAttributeName = function(v) {
                this.currentAttribute()[0] += v;
              }, E.prototype.beginAttributeValue = function(v) {
                this.currentAttribute()[2] = v;
              }, E.prototype.appendToAttributeValue = function(v) {
                this.currentAttribute()[1] += v;
              }, E.prototype.finishAttributeValue = function() {
                this.current("StartTag").attributes.push(this._currentAttribute);
              }, E.prototype.reportSyntaxError = function(v) {
                this.current().syntaxError = v;
              }, E;
            }();
            function P(E, v) {
              var _ = new b(new r2(d), v);
              return _.tokenize(E);
            }
            h2.HTML5NamedCharRefs = d, h2.EntityParser = r2, h2.EventedTokenizer = l, h2.Tokenizer = b, h2.tokenize = P, Object.defineProperty(h2, "__esModule", { value: true });
          });
        } }), We = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/generation/print.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = d;
          var f3 = h2(Te());
          function h2(c) {
            return c && c.__esModule ? c : { default: c };
          }
          function d(c) {
            let o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : { entityEncoding: "transformed" };
            return c ? new f3.default(o).print(c) : "";
          }
        } }), he = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/syntax-error.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.generateSyntaxError = f3;
          function f3(h2, d) {
            let { module: c, loc: o } = d, { line: e2, column: r2 } = o.start, s2 = d.asString(), p = s2 ? `

|
|  `.concat(s2.split(`
`).join(`
|  `), `
|

`) : "", n = new Error("".concat(h2, ": ").concat(p, "(error occurred in '").concat(c, "' @ line ").concat(e2, " : column ").concat(r2, ")"));
            return n.name = "SyntaxError", n.location = d, n.code = s2, n;
          }
        } }), Rt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/visitor-keys.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = void 0;
          var f3 = X(), h2 = { Program: (0, f3.tuple)("body"), Template: (0, f3.tuple)("body"), Block: (0, f3.tuple)("body"), MustacheStatement: (0, f3.tuple)("path", "params", "hash"), BlockStatement: (0, f3.tuple)("path", "params", "hash", "program", "inverse"), ElementModifierStatement: (0, f3.tuple)("path", "params", "hash"), PartialStatement: (0, f3.tuple)("name", "params", "hash"), CommentStatement: (0, f3.tuple)(), MustacheCommentStatement: (0, f3.tuple)(), ElementNode: (0, f3.tuple)("attributes", "modifiers", "children", "comments"), AttrNode: (0, f3.tuple)("value"), TextNode: (0, f3.tuple)(), ConcatStatement: (0, f3.tuple)("parts"), SubExpression: (0, f3.tuple)("path", "params", "hash"), PathExpression: (0, f3.tuple)(), PathHead: (0, f3.tuple)(), StringLiteral: (0, f3.tuple)(), BooleanLiteral: (0, f3.tuple)(), NumberLiteral: (0, f3.tuple)(), NullLiteral: (0, f3.tuple)(), UndefinedLiteral: (0, f3.tuple)(), Hash: (0, f3.tuple)("pairs"), HashPair: (0, f3.tuple)("value"), NamedBlock: (0, f3.tuple)("attributes", "modifiers", "children", "comments"), SimpleElement: (0, f3.tuple)("attributes", "modifiers", "children", "comments"), Component: (0, f3.tuple)("head", "attributes", "modifiers", "children", "comments") }, d = h2;
          t2.default = d;
        } }), Ye = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/traversal/errors.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.cannotRemoveNode = d, t2.cannotReplaceNode = c, t2.cannotReplaceOrRemoveInKeyHandlerYet = o, t2.default = void 0;
          var f3 = function() {
            e2.prototype = Object.create(Error.prototype), e2.prototype.constructor = e2;
            function e2(r2, s2, p, n) {
              let a = Error.call(this, r2);
              this.key = n, this.message = r2, this.node = s2, this.parent = p, this.stack = a.stack;
            }
            return e2;
          }(), h2 = f3;
          t2.default = h2;
          function d(e2, r2, s2) {
            return new f3("Cannot remove a node unless it is part of an array", e2, r2, s2);
          }
          function c(e2, r2, s2) {
            return new f3("Cannot replace a node with multiple nodes unless it is part of an array", e2, r2, s2);
          }
          function o(e2, r2) {
            return new f3("Replacing and removing in key handlers is not yet supported.", e2, null, r2);
          }
        } }), Qe = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/traversal/path.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = void 0;
          var f3 = class {
            constructor(d) {
              let c = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null, o = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.node = d, this.parent = c, this.parentKey = o;
            }
            get parentNode() {
              return this.parent ? this.parent.node : null;
            }
            parents() {
              return { [Symbol.iterator]: () => new h2(this) };
            }
          };
          t2.default = f3;
          var h2 = class {
            constructor(d) {
              this.path = d;
            }
            next() {
              return this.path.parent ? (this.path = this.path.parent, { done: false, value: this.path }) : { done: true, value: null };
            }
          };
        } }), Ne = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/traversal/traverse.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = E;
          var f3 = X(), h2 = o(Rt()), d = Ye(), c = o(Qe());
          function o(v) {
            return v && v.__esModule ? v : { default: v };
          }
          function e2(v) {
            return typeof v == "function" ? v : v.enter;
          }
          function r2(v) {
            if (typeof v != "function")
              return v.exit;
          }
          function s2(v, _) {
            let y = typeof v != "function" ? v.keys : void 0;
            if (y === void 0)
              return;
            let g = y[_];
            return g !== void 0 ? g : y.All;
          }
          function p(v, _) {
            if ((_ === "Template" || _ === "Block") && v.Program)
              return v.Program;
            let y = v[_];
            return y !== void 0 ? y : v.All;
          }
          function n(v, _) {
            let { node: y, parent: g, parentKey: L } = _, j = p(v, y.type), x2, w;
            j !== void 0 && (x2 = e2(j), w = r2(j));
            let H;
            if (x2 !== void 0 && (H = x2(y, _)), H != null)
              if (JSON.stringify(y) === JSON.stringify(H))
                H = void 0;
              else {
                if (Array.isArray(H))
                  return l(v, H, g, L), H;
                {
                  let m2 = new c.default(H, g, L);
                  return n(v, m2) || H;
                }
              }
            if (H === void 0) {
              let m2 = h2.default[y.type];
              for (let C = 0; C < m2.length; C++) {
                let S2 = m2[C];
                i2(v, j, _, S2);
              }
              w !== void 0 && (H = w(y, _));
            }
            return H;
          }
          function a(v, _) {
            return v[_];
          }
          function u(v, _, y) {
            v[_] = y;
          }
          function i2(v, _, y, g) {
            let { node: L } = y, j = a(L, g);
            if (!j)
              return;
            let x2, w;
            if (_ !== void 0) {
              let H = s2(_, g);
              H !== void 0 && (x2 = e2(H), w = r2(H));
            }
            if (x2 !== void 0 && x2(L, g) !== void 0)
              throw (0, d.cannotReplaceOrRemoveInKeyHandlerYet)(L, g);
            if (Array.isArray(j))
              l(v, j, y, g);
            else {
              let H = new c.default(j, y, g), m2 = n(v, H);
              m2 !== void 0 && b(L, g, j, m2);
            }
            if (w !== void 0 && w(L, g) !== void 0)
              throw (0, d.cannotReplaceOrRemoveInKeyHandlerYet)(L, g);
          }
          function l(v, _, y, g) {
            for (let L = 0; L < _.length; L++) {
              let j = _[L], x2 = new c.default(j, y, g), w = n(v, x2);
              w !== void 0 && (L += P(_, L, w) - 1);
            }
          }
          function b(v, _, y, g) {
            if (g === null)
              throw (0, d.cannotRemoveNode)(y, v, _);
            if (Array.isArray(g))
              if (g.length === 1)
                u(v, _, g[0]);
              else
                throw g.length === 0 ? (0, d.cannotRemoveNode)(y, v, _) : (0, d.cannotReplaceNode)(y, v, _);
            else
              u(v, _, g);
          }
          function P(v, _, y) {
            return y === null ? (v.splice(_, 1), 0) : Array.isArray(y) ? (v.splice(_, 1, ...y), y.length) : (v.splice(_, 1, y), 1);
          }
          function E(v, _) {
            let y = new c.default(v);
            n(_, y);
          }
        } }), Je = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/traversal/walker.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = void 0;
          var f3 = class {
            constructor(d) {
              this.order = d, this.stack = [];
            }
            visit(d, c) {
              !d || (this.stack.push(d), this.order === "post" ? (this.children(d, c), c(d, this)) : (c(d, this), this.children(d, c)), this.stack.pop());
            }
            children(d, c) {
              switch (d.type) {
                case "Block":
                case "Template":
                  return h2.Program(this, d, c);
                case "ElementNode":
                  return h2.ElementNode(this, d, c);
                case "BlockStatement":
                  return h2.BlockStatement(this, d, c);
                default:
                  return;
              }
            }
          };
          t2.default = f3;
          var h2 = { Program(d, c, o) {
            for (let e2 = 0; e2 < c.body.length; e2++)
              d.visit(c.body[e2], o);
          }, Template(d, c, o) {
            for (let e2 = 0; e2 < c.body.length; e2++)
              d.visit(c.body[e2], o);
          }, Block(d, c, o) {
            for (let e2 = 0; e2 < c.body.length; e2++)
              d.visit(c.body[e2], o);
          }, ElementNode(d, c, o) {
            for (let e2 = 0; e2 < c.children.length; e2++)
              d.visit(c.children[e2], o);
          }, BlockStatement(d, c, o) {
            d.visit(c.program, o), d.visit(c.inverse || null, o);
          } };
        } }), ye = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/utils.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.parseElementBlockParams = d, t2.childrenFor = o, t2.appendChild = e2, t2.isHBSLiteral = r2, t2.printLiteral = s2, t2.isUpperCase = p, t2.isLowerCase = n;
          var f3 = he(), h2 = /[!"#%-,\.\/;->@\[-\^`\{-~]/;
          function d(a) {
            let u = c(a);
            u && (a.blockParams = u);
          }
          function c(a) {
            let u = a.attributes.length, i2 = [];
            for (let b = 0; b < u; b++)
              i2.push(a.attributes[b].name);
            let l = i2.indexOf("as");
            if (l === -1 && i2.length > 0 && i2[i2.length - 1].charAt(0) === "|")
              throw (0, f3.generateSyntaxError)("Block parameters must be preceded by the `as` keyword, detected block parameters without `as`", a.loc);
            if (l !== -1 && u > l && i2[l + 1].charAt(0) === "|") {
              let b = i2.slice(l).join(" ");
              if (b.charAt(b.length - 1) !== "|" || b.match(/\|/g).length !== 2)
                throw (0, f3.generateSyntaxError)("Invalid block parameters syntax, '" + b + "'", a.loc);
              let P = [];
              for (let E = l + 1; E < u; E++) {
                let v = i2[E].replace(/\|/g, "");
                if (v !== "") {
                  if (h2.test(v))
                    throw (0, f3.generateSyntaxError)("Invalid identifier for block parameters, '" + v + "'", a.loc);
                  P.push(v);
                }
              }
              if (P.length === 0)
                throw (0, f3.generateSyntaxError)("Cannot use zero block parameters", a.loc);
              return a.attributes = a.attributes.slice(0, l), P;
            }
            return null;
          }
          function o(a) {
            switch (a.type) {
              case "Block":
              case "Template":
                return a.body;
              case "ElementNode":
                return a.children;
            }
          }
          function e2(a, u) {
            o(a).push(u);
          }
          function r2(a) {
            return a.type === "StringLiteral" || a.type === "BooleanLiteral" || a.type === "NumberLiteral" || a.type === "NullLiteral" || a.type === "UndefinedLiteral";
          }
          function s2(a) {
            return a.type === "UndefinedLiteral" ? "undefined" : JSON.stringify(a.value);
          }
          function p(a) {
            return a[0] === a[0].toUpperCase() && a[0] !== a[0].toLowerCase();
          }
          function n(a) {
            return a[0] === a[0].toLowerCase() && a[0] !== a[0].toUpperCase();
          }
        } }), Le = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v1/parser-builders.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.default = void 0;
          var f3 = X(), h2 = we(), d = { close: false, open: false }, c = class {
            pos(r2, s2) {
              return { line: r2, column: s2 };
            }
            blockItself(r2) {
              let { body: s2, blockParams: p, chained: n = false, loc: a } = r2;
              return { type: "Block", body: s2 || [], blockParams: p || [], chained: n, loc: a };
            }
            template(r2) {
              let { body: s2, blockParams: p, loc: n } = r2;
              return { type: "Template", body: s2 || [], blockParams: p || [], loc: n };
            }
            mustache(r2) {
              let { path: s2, params: p, hash: n, trusting: a, loc: u, strip: i2 = d } = r2;
              return { type: "MustacheStatement", path: s2, params: p, hash: n, escaped: !a, trusting: a, loc: u, strip: i2 || { open: false, close: false } };
            }
            block(r2) {
              let { path: s2, params: p, hash: n, defaultBlock: a, elseBlock: u = null, loc: i2, openStrip: l = d, inverseStrip: b = d, closeStrip: P = d } = r2;
              return { type: "BlockStatement", path: s2, params: p, hash: n, program: a, inverse: u, loc: i2, openStrip: l, inverseStrip: b, closeStrip: P };
            }
            comment(r2, s2) {
              return { type: "CommentStatement", value: r2, loc: s2 };
            }
            mustacheComment(r2, s2) {
              return { type: "MustacheCommentStatement", value: r2, loc: s2 };
            }
            concat(r2, s2) {
              return { type: "ConcatStatement", parts: r2, loc: s2 };
            }
            element(r2) {
              let { tag: s2, selfClosing: p, attrs: n, blockParams: a, modifiers: u, comments: i2, children: l, loc: b } = r2;
              return { type: "ElementNode", tag: s2, selfClosing: p, attributes: n || [], blockParams: a || [], modifiers: u || [], comments: i2 || [], children: l || [], loc: b };
            }
            elementModifier(r2) {
              let { path: s2, params: p, hash: n, loc: a } = r2;
              return { type: "ElementModifierStatement", path: s2, params: p, hash: n, loc: a };
            }
            attr(r2) {
              let { name: s2, value: p, loc: n } = r2;
              return { type: "AttrNode", name: s2, value: p, loc: n };
            }
            text(r2) {
              let { chars: s2, loc: p } = r2;
              return { type: "TextNode", chars: s2, loc: p };
            }
            sexpr(r2) {
              let { path: s2, params: p, hash: n, loc: a } = r2;
              return { type: "SubExpression", path: s2, params: p, hash: n, loc: a };
            }
            path(r2) {
              let { head: s2, tail: p, loc: n } = r2, { original: a } = o(s2), u = [...a, ...p].join(".");
              return new h2.PathExpressionImplV1(u, s2, p, n);
            }
            head(r2, s2) {
              return r2[0] === "@" ? this.atName(r2, s2) : r2 === "this" ? this.this(s2) : this.var(r2, s2);
            }
            this(r2) {
              return { type: "ThisHead", loc: r2 };
            }
            atName(r2, s2) {
              return { type: "AtHead", name: r2, loc: s2 };
            }
            var(r2, s2) {
              return { type: "VarHead", name: r2, loc: s2 };
            }
            hash(r2, s2) {
              return { type: "Hash", pairs: r2 || [], loc: s2 };
            }
            pair(r2) {
              let { key: s2, value: p, loc: n } = r2;
              return { type: "HashPair", key: s2, value: p, loc: n };
            }
            literal(r2) {
              let { type: s2, value: p, loc: n } = r2;
              return { type: s2, value: p, original: p, loc: n };
            }
            undefined() {
              return this.literal({ type: "UndefinedLiteral", value: void 0 });
            }
            null() {
              return this.literal({ type: "NullLiteral", value: null });
            }
            string(r2, s2) {
              return this.literal({ type: "StringLiteral", value: r2, loc: s2 });
            }
            boolean(r2, s2) {
              return this.literal({ type: "BooleanLiteral", value: r2, loc: s2 });
            }
            number(r2, s2) {
              return this.literal({ type: "NumberLiteral", value: r2, loc: s2 });
            }
          };
          function o(r2) {
            switch (r2.type) {
              case "AtHead":
                return { original: r2.name, parts: [r2.name] };
              case "ThisHead":
                return { original: "this", parts: [] };
              case "VarHead":
                return { original: r2.name, parts: [r2.name] };
            }
          }
          var e2 = new c();
          t2.default = e2;
        } }), qt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/parser.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.Parser = void 0;
          var f3 = X(), h2 = Ke(), d = class {
            constructor(c) {
              let o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : new h2.EntityParser(h2.HTML5NamedCharRefs), e2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : "precompile";
              this.elementStack = [], this.currentAttribute = null, this.currentNode = null, this.source = c, this.lines = c.source.split(/(?:\r\n?|\n)/g), this.tokenizer = new h2.EventedTokenizer(this, o, e2);
            }
            offset() {
              let { line: c, column: o } = this.tokenizer;
              return this.source.offsetFor(c, o);
            }
            pos(c) {
              let { line: o, column: e2 } = c;
              return this.source.offsetFor(o, e2);
            }
            finish(c) {
              return (0, f3.assign)({}, c, { loc: c.loc.until(this.offset()) });
            }
            get currentAttr() {
              return this.currentAttribute;
            }
            get currentTag() {
              return this.currentNode;
            }
            get currentStartTag() {
              return this.currentNode;
            }
            get currentEndTag() {
              return this.currentNode;
            }
            get currentComment() {
              return this.currentNode;
            }
            get currentData() {
              return this.currentNode;
            }
            acceptTemplate(c) {
              return this[c.type](c);
            }
            acceptNode(c) {
              return this[c.type](c);
            }
            currentElement() {
              return this.elementStack[this.elementStack.length - 1];
            }
            sourceForNode(c, o) {
              let e2 = c.loc.start.line - 1, r2 = e2 - 1, s2 = c.loc.start.column, p = [], n, a, u;
              for (o ? (a = o.loc.end.line - 1, u = o.loc.end.column) : (a = c.loc.end.line - 1, u = c.loc.end.column); r2 < a; )
                r2++, n = this.lines[r2], r2 === e2 ? e2 === a ? p.push(n.slice(s2, u)) : p.push(n.slice(s2)) : r2 === a ? p.push(n.slice(0, u)) : p.push(n);
              return p.join(`
`);
            }
          };
          t2.Parser = d;
        } }), xt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/parser/handlebars-node-visitors.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.HandlebarsNodeVisitors = void 0;
          var f3 = qt(), h2 = ge(), d = he(), c = ye(), o = we(), e2 = r2(Le());
          function r2(i2) {
            return i2 && i2.__esModule ? i2 : { default: i2 };
          }
          var s2 = class extends f3.Parser {
            get isTopLevel() {
              return this.elementStack.length === 0;
            }
            Program(i2) {
              let l = [], b;
              this.isTopLevel ? b = e2.default.template({ body: l, blockParams: i2.blockParams, loc: this.source.spanFor(i2.loc) }) : b = e2.default.blockItself({ body: l, blockParams: i2.blockParams, chained: i2.chained, loc: this.source.spanFor(i2.loc) });
              let P, E = i2.body.length;
              if (this.elementStack.push(b), E === 0)
                return this.elementStack.pop();
              for (P = 0; P < E; P++)
                this.acceptNode(i2.body[P]);
              let v = this.elementStack.pop();
              if (v !== b) {
                let _ = v;
                throw (0, d.generateSyntaxError)("Unclosed element `".concat(_.tag, "`"), _.loc);
              }
              return b;
            }
            BlockStatement(i2) {
              if (this.tokenizer.state === "comment") {
                this.appendToCommentData(this.sourceForNode(i2));
                return;
              }
              if (this.tokenizer.state !== "data" && this.tokenizer.state !== "beforeData")
                throw (0, d.generateSyntaxError)("A block may only be used inside an HTML element or another block.", this.source.spanFor(i2.loc));
              let { path: l, params: b, hash: P } = a(this, i2);
              i2.program.loc || (i2.program.loc = h2.NON_EXISTENT_LOCATION), i2.inverse && !i2.inverse.loc && (i2.inverse.loc = h2.NON_EXISTENT_LOCATION);
              let E = this.Program(i2.program), v = i2.inverse ? this.Program(i2.inverse) : null, _ = e2.default.block({ path: l, params: b, hash: P, defaultBlock: E, elseBlock: v, loc: this.source.spanFor(i2.loc), openStrip: i2.openStrip, inverseStrip: i2.inverseStrip, closeStrip: i2.closeStrip }), y = this.currentElement();
              (0, c.appendChild)(y, _);
            }
            MustacheStatement(i2) {
              let { tokenizer: l } = this;
              if (l.state === "comment") {
                this.appendToCommentData(this.sourceForNode(i2));
                return;
              }
              let b, { escaped: P, loc: E, strip: v } = i2;
              if ((0, c.isHBSLiteral)(i2.path))
                b = e2.default.mustache({ path: this.acceptNode(i2.path), params: [], hash: e2.default.hash([], this.source.spanFor(i2.path.loc).collapse("end")), trusting: !P, loc: this.source.spanFor(E), strip: v });
              else {
                let { path: _, params: y, hash: g } = a(this, i2);
                b = e2.default.mustache({ path: _, params: y, hash: g, trusting: !P, loc: this.source.spanFor(E), strip: v });
              }
              switch (l.state) {
                case "tagOpen":
                case "tagName":
                  throw (0, d.generateSyntaxError)("Cannot use mustaches in an elements tagname", b.loc);
                case "beforeAttributeName":
                  u(this.currentStartTag, b);
                  break;
                case "attributeName":
                case "afterAttributeName":
                  this.beginAttributeValue(false), this.finishAttributeValue(), u(this.currentStartTag, b), l.transitionTo("beforeAttributeName");
                  break;
                case "afterAttributeValueQuoted":
                  u(this.currentStartTag, b), l.transitionTo("beforeAttributeName");
                  break;
                case "beforeAttributeValue":
                  this.beginAttributeValue(false), this.appendDynamicAttributeValuePart(b), l.transitionTo("attributeValueUnquoted");
                  break;
                case "attributeValueDoubleQuoted":
                case "attributeValueSingleQuoted":
                case "attributeValueUnquoted":
                  this.appendDynamicAttributeValuePart(b);
                  break;
                default:
                  (0, c.appendChild)(this.currentElement(), b);
              }
              return b;
            }
            appendDynamicAttributeValuePart(i2) {
              this.finalizeTextPart();
              let l = this.currentAttr;
              l.isDynamic = true, l.parts.push(i2);
            }
            finalizeTextPart() {
              let l = this.currentAttr.currentPart;
              l !== null && (this.currentAttr.parts.push(l), this.startTextPart());
            }
            startTextPart() {
              this.currentAttr.currentPart = null;
            }
            ContentStatement(i2) {
              n(this.tokenizer, i2), this.tokenizer.tokenizePart(i2.value), this.tokenizer.flushData();
            }
            CommentStatement(i2) {
              let { tokenizer: l } = this;
              if (l.state === "comment")
                return this.appendToCommentData(this.sourceForNode(i2)), null;
              let { value: b, loc: P } = i2, E = e2.default.mustacheComment(b, this.source.spanFor(P));
              switch (l.state) {
                case "beforeAttributeName":
                case "afterAttributeName":
                  this.currentStartTag.comments.push(E);
                  break;
                case "beforeData":
                case "data":
                  (0, c.appendChild)(this.currentElement(), E);
                  break;
                default:
                  throw (0, d.generateSyntaxError)("Using a Handlebars comment when in the `".concat(l.state, "` state is not supported"), this.source.spanFor(i2.loc));
              }
              return E;
            }
            PartialStatement(i2) {
              throw (0, d.generateSyntaxError)("Handlebars partials are not supported", this.source.spanFor(i2.loc));
            }
            PartialBlockStatement(i2) {
              throw (0, d.generateSyntaxError)("Handlebars partial blocks are not supported", this.source.spanFor(i2.loc));
            }
            Decorator(i2) {
              throw (0, d.generateSyntaxError)("Handlebars decorators are not supported", this.source.spanFor(i2.loc));
            }
            DecoratorBlock(i2) {
              throw (0, d.generateSyntaxError)("Handlebars decorator blocks are not supported", this.source.spanFor(i2.loc));
            }
            SubExpression(i2) {
              let { path: l, params: b, hash: P } = a(this, i2);
              return e2.default.sexpr({ path: l, params: b, hash: P, loc: this.source.spanFor(i2.loc) });
            }
            PathExpression(i2) {
              let { original: l } = i2, b;
              if (l.indexOf("/") !== -1) {
                if (l.slice(0, 2) === "./")
                  throw (0, d.generateSyntaxError)('Using "./" is not supported in Glimmer and unnecessary', this.source.spanFor(i2.loc));
                if (l.slice(0, 3) === "../")
                  throw (0, d.generateSyntaxError)('Changing context using "../" is not supported in Glimmer', this.source.spanFor(i2.loc));
                if (l.indexOf(".") !== -1)
                  throw (0, d.generateSyntaxError)("Mixing '.' and '/' in paths is not supported in Glimmer; use only '.' to separate property paths", this.source.spanFor(i2.loc));
                b = [i2.parts.join("/")];
              } else {
                if (l === ".")
                  throw (0, d.generateSyntaxError)("'.' is not a supported path in Glimmer; check for a path with a trailing '.'", this.source.spanFor(i2.loc));
                b = i2.parts;
              }
              let P = false;
              l.match(/^this(\..+)?$/) && (P = true);
              let E;
              if (P)
                E = { type: "ThisHead", loc: { start: i2.loc.start, end: { line: i2.loc.start.line, column: i2.loc.start.column + 4 } } };
              else if (i2.data) {
                let v = b.shift();
                if (v === void 0)
                  throw (0, d.generateSyntaxError)("Attempted to parse a path expression, but it was not valid. Paths beginning with @ must start with a-z.", this.source.spanFor(i2.loc));
                E = { type: "AtHead", name: "@".concat(v), loc: { start: i2.loc.start, end: { line: i2.loc.start.line, column: i2.loc.start.column + v.length + 1 } } };
              } else {
                let v = b.shift();
                if (v === void 0)
                  throw (0, d.generateSyntaxError)("Attempted to parse a path expression, but it was not valid. Paths must start with a-z or A-Z.", this.source.spanFor(i2.loc));
                E = { type: "VarHead", name: v, loc: { start: i2.loc.start, end: { line: i2.loc.start.line, column: i2.loc.start.column + v.length } } };
              }
              return new o.PathExpressionImplV1(i2.original, E, b, this.source.spanFor(i2.loc));
            }
            Hash(i2) {
              let l = [];
              for (let b = 0; b < i2.pairs.length; b++) {
                let P = i2.pairs[b];
                l.push(e2.default.pair({ key: P.key, value: this.acceptNode(P.value), loc: this.source.spanFor(P.loc) }));
              }
              return e2.default.hash(l, this.source.spanFor(i2.loc));
            }
            StringLiteral(i2) {
              return e2.default.literal({ type: "StringLiteral", value: i2.value, loc: i2.loc });
            }
            BooleanLiteral(i2) {
              return e2.default.literal({ type: "BooleanLiteral", value: i2.value, loc: i2.loc });
            }
            NumberLiteral(i2) {
              return e2.default.literal({ type: "NumberLiteral", value: i2.value, loc: i2.loc });
            }
            UndefinedLiteral(i2) {
              return e2.default.literal({ type: "UndefinedLiteral", value: void 0, loc: i2.loc });
            }
            NullLiteral(i2) {
              return e2.default.literal({ type: "NullLiteral", value: null, loc: i2.loc });
            }
          };
          t2.HandlebarsNodeVisitors = s2;
          function p(i2, l) {
            if (l === "")
              return { lines: i2.split(`
`).length - 1, columns: 0 };
            let P = i2.split(l)[0].split(/\n/), E = P.length - 1;
            return { lines: E, columns: P[E].length };
          }
          function n(i2, l) {
            let b = l.loc.start.line, P = l.loc.start.column, E = p(l.original, l.value);
            b = b + E.lines, E.lines ? P = E.columns : P = P + E.columns, i2.line = b, i2.column = P;
          }
          function a(i2, l) {
            if (l.path.type.endsWith("Literal")) {
              let _ = l.path, y = "";
              throw _.type === "BooleanLiteral" ? y = _.original.toString() : _.type === "StringLiteral" ? y = '"'.concat(_.original, '"') : _.type === "NullLiteral" ? y = "null" : _.type === "NumberLiteral" ? y = _.value.toString() : y = "undefined", (0, d.generateSyntaxError)("".concat(_.type, ' "').concat(_.type === "StringLiteral" ? _.original : y, '" cannot be called as a sub-expression, replace (').concat(y, ") with ").concat(y), i2.source.spanFor(_.loc));
            }
            let b = l.path.type === "PathExpression" ? i2.PathExpression(l.path) : i2.SubExpression(l.path), P = l.params ? l.params.map((_) => i2.acceptNode(_)) : [], E = P.length > 0 ? P[P.length - 1].loc : b.loc, v = l.hash ? i2.Hash(l.hash) : { type: "Hash", pairs: [], loc: i2.source.spanFor(E).collapse("end") };
            return { path: b, params: P, hash: v };
          }
          function u(i2, l) {
            let { path: b, params: P, hash: E, loc: v } = l;
            if ((0, c.isHBSLiteral)(b)) {
              let y = "{{".concat((0, c.printLiteral)(b), "}}"), g = "<".concat(i2.name, " ... ").concat(y, " ...");
              throw (0, d.generateSyntaxError)("In ".concat(g, ", ").concat(y, " is not a valid modifier"), l.loc);
            }
            let _ = e2.default.elementModifier({ path: b, params: P, hash: E, loc: v });
            i2.modifiers.push(_);
          }
        } }), Fe = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/parser/tokenizer-event-handlers.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.preprocess = _, t2.TokenizerEventHandlers = void 0;
          var f3 = X(), h2 = It(), d = Ke(), c = b(We()), o = Te(), e2 = De(), r2 = ue(), s2 = he(), p = b(Ne()), n = b(Je()), a = ye(), u = b(Le()), i2 = b(ke()), l = xt();
          function b(y) {
            return y && y.__esModule ? y : { default: y };
          }
          var P = class extends l.HandlebarsNodeVisitors {
            constructor() {
              super(...arguments), this.tagOpenLine = 0, this.tagOpenColumn = 0;
            }
            reset() {
              this.currentNode = null;
            }
            beginComment() {
              this.currentNode = u.default.comment("", this.source.offsetFor(this.tagOpenLine, this.tagOpenColumn));
            }
            appendToCommentData(y) {
              this.currentComment.value += y;
            }
            finishComment() {
              (0, a.appendChild)(this.currentElement(), this.finish(this.currentComment));
            }
            beginData() {
              this.currentNode = u.default.text({ chars: "", loc: this.offset().collapsed() });
            }
            appendToData(y) {
              this.currentData.chars += y;
            }
            finishData() {
              this.currentData.loc = this.currentData.loc.withEnd(this.offset()), (0, a.appendChild)(this.currentElement(), this.currentData);
            }
            tagOpen() {
              this.tagOpenLine = this.tokenizer.line, this.tagOpenColumn = this.tokenizer.column;
            }
            beginStartTag() {
              this.currentNode = { type: "StartTag", name: "", attributes: [], modifiers: [], comments: [], selfClosing: false, loc: this.source.offsetFor(this.tagOpenLine, this.tagOpenColumn) };
            }
            beginEndTag() {
              this.currentNode = { type: "EndTag", name: "", attributes: [], modifiers: [], comments: [], selfClosing: false, loc: this.source.offsetFor(this.tagOpenLine, this.tagOpenColumn) };
            }
            finishTag() {
              let y = this.finish(this.currentTag);
              if (y.type === "StartTag") {
                if (this.finishStartTag(), y.name === ":")
                  throw (0, s2.generateSyntaxError)("Invalid named block named detected, you may have created a named block without a name, or you may have began your name with a number. Named blocks must have names that are at least one character long, and begin with a lower case letter", this.source.spanFor({ start: this.currentTag.loc.toJSON(), end: this.offset().toJSON() }));
                (o.voidMap[y.name] || y.selfClosing) && this.finishEndTag(true);
              } else
                y.type === "EndTag" && this.finishEndTag(false);
            }
            finishStartTag() {
              let { name: y, attributes: g, modifiers: L, comments: j, selfClosing: x2, loc: w } = this.finish(this.currentStartTag), H = u.default.element({ tag: y, selfClosing: x2, attrs: g, modifiers: L, comments: j, children: [], blockParams: [], loc: w });
              this.elementStack.push(H);
            }
            finishEndTag(y) {
              let g = this.finish(this.currentTag), L = this.elementStack.pop(), j = this.currentElement();
              this.validateEndTag(g, L, y), L.loc = L.loc.withEnd(this.offset()), (0, a.parseElementBlockParams)(L), (0, a.appendChild)(j, L);
            }
            markTagAsSelfClosing() {
              this.currentTag.selfClosing = true;
            }
            appendToTagName(y) {
              this.currentTag.name += y;
            }
            beginAttribute() {
              let y = this.offset();
              this.currentAttribute = { name: "", parts: [], currentPart: null, isQuoted: false, isDynamic: false, start: y, valueSpan: y.collapsed() };
            }
            appendToAttributeName(y) {
              this.currentAttr.name += y;
            }
            beginAttributeValue(y) {
              this.currentAttr.isQuoted = y, this.startTextPart(), this.currentAttr.valueSpan = this.offset().collapsed();
            }
            appendToAttributeValue(y) {
              let g = this.currentAttr.parts, L = g[g.length - 1], j = this.currentAttr.currentPart;
              if (j)
                j.chars += y, j.loc = j.loc.withEnd(this.offset());
              else {
                let x2 = this.offset();
                y === `
` ? x2 = L ? L.loc.getEnd() : this.currentAttr.valueSpan.getStart() : x2 = x2.move(-1), this.currentAttr.currentPart = u.default.text({ chars: y, loc: x2.collapsed() });
              }
            }
            finishAttributeValue() {
              this.finalizeTextPart();
              let y = this.currentTag, g = this.offset();
              if (y.type === "EndTag")
                throw (0, s2.generateSyntaxError)("Invalid end tag: closing tag must not have attributes", this.source.spanFor({ start: y.loc.toJSON(), end: g.toJSON() }));
              let { name: L, parts: j, start: x2, isQuoted: w, isDynamic: H, valueSpan: m2 } = this.currentAttr, C = this.assembleAttributeValue(j, w, H, x2.until(g));
              C.loc = m2.withEnd(g);
              let S2 = u.default.attr({ name: L, value: C, loc: x2.until(g) });
              this.currentStartTag.attributes.push(S2);
            }
            reportSyntaxError(y) {
              throw (0, s2.generateSyntaxError)(y, this.offset().collapsed());
            }
            assembleConcatenatedValue(y) {
              for (let j = 0; j < y.length; j++) {
                let x2 = y[j];
                if (x2.type !== "MustacheStatement" && x2.type !== "TextNode")
                  throw (0, s2.generateSyntaxError)("Unsupported node in quoted attribute value: " + x2.type, x2.loc);
              }
              (0, f3.assertPresent)(y, "the concatenation parts of an element should not be empty");
              let g = y[0], L = y[y.length - 1];
              return u.default.concat(y, this.source.spanFor(g.loc).extend(this.source.spanFor(L.loc)));
            }
            validateEndTag(y, g, L) {
              let j;
              if (o.voidMap[y.name] && !L ? j = "<".concat(y.name, "> elements do not need end tags. You should remove it") : g.tag === void 0 ? j = "Closing tag </".concat(y.name, "> without an open tag") : g.tag !== y.name && (j = "Closing tag </".concat(y.name, "> did not match last open tag <").concat(g.tag, "> (on line ").concat(g.loc.startPosition.line, ")")), j)
                throw (0, s2.generateSyntaxError)(j, y.loc);
            }
            assembleAttributeValue(y, g, L, j) {
              if (L) {
                if (g)
                  return this.assembleConcatenatedValue(y);
                if (y.length === 1 || y.length === 2 && y[1].type === "TextNode" && y[1].chars === "/")
                  return y[0];
                throw (0, s2.generateSyntaxError)("An unquoted attribute value must be a string or a mustache, preceded by whitespace or a '=' character, and followed by whitespace, a '>' character, or '/>'", j);
              } else
                return y.length > 0 ? y[0] : u.default.text({ chars: "", loc: j });
            }
          };
          t2.TokenizerEventHandlers = P;
          var E = { parse: _, builders: i2.default, print: c.default, traverse: p.default, Walker: n.default }, v = class extends d.EntityParser {
            constructor() {
              super({});
            }
            parse() {
            }
          };
          function _(y) {
            let g = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            var L, j, x2;
            let w = g.mode || "precompile", H, m2;
            typeof y == "string" ? (H = new e2.Source(y, (L = g.meta) === null || L === void 0 ? void 0 : L.moduleName), w === "codemod" ? m2 = (0, h2.parseWithoutProcessing)(y, g.parseOptions) : m2 = (0, h2.parse)(y, g.parseOptions)) : y instanceof e2.Source ? (H = y, w === "codemod" ? m2 = (0, h2.parseWithoutProcessing)(y.source, g.parseOptions) : m2 = (0, h2.parse)(y.source, g.parseOptions)) : (H = new e2.Source("", (j = g.meta) === null || j === void 0 ? void 0 : j.moduleName), m2 = y);
            let C;
            w === "codemod" && (C = new v());
            let S2 = r2.SourceSpan.forCharPositions(H, 0, H.source.length);
            m2.loc = { source: "(program)", start: S2.startPosition, end: S2.endPosition };
            let R = new P(H, C, w).acceptTemplate(m2);
            if (g.strictMode && (R.blockParams = (x2 = g.locals) !== null && x2 !== void 0 ? x2 : []), g && g.plugins && g.plugins.ast)
              for (let M = 0, V = g.plugins.ast.length; M < V; M++) {
                let G = g.plugins.ast[M], K = (0, f3.assign)({}, g, { syntax: E }, { plugins: void 0 }), U = G(K);
                (0, p.default)(R, U.visitor);
              }
            return R;
          }
        } }), Xe = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/symbol-table.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.BlockSymbolTable = t2.ProgramSymbolTable = t2.SymbolTable = void 0;
          var f3 = X(), h2 = ye(), d = class {
            static top(e2, r2) {
              return new c(e2, r2);
            }
            child(e2) {
              let r2 = e2.map((s2) => this.allocate(s2));
              return new o(this, e2, r2);
            }
          };
          t2.SymbolTable = d;
          var c = class extends d {
            constructor(e2, r2) {
              super(), this.templateLocals = e2, this.customizeComponentName = r2, this.symbols = [], this.upvars = [], this.size = 1, this.named = (0, f3.dict)(), this.blocks = (0, f3.dict)(), this.usedTemplateLocals = [], this._hasEval = false;
            }
            getUsedTemplateLocals() {
              return this.usedTemplateLocals;
            }
            setHasEval() {
              this._hasEval = true;
            }
            get hasEval() {
              return this._hasEval;
            }
            has(e2) {
              return this.templateLocals.indexOf(e2) !== -1;
            }
            get(e2) {
              let r2 = this.usedTemplateLocals.indexOf(e2);
              return r2 !== -1 ? [r2, true] : (r2 = this.usedTemplateLocals.length, this.usedTemplateLocals.push(e2), [r2, true]);
            }
            getLocalsMap() {
              return (0, f3.dict)();
            }
            getEvalInfo() {
              let e2 = this.getLocalsMap();
              return Object.keys(e2).map((r2) => e2[r2]);
            }
            allocateFree(e2, r2) {
              r2.resolution() === 39 && r2.isAngleBracket && (0, h2.isUpperCase)(e2) && (e2 = this.customizeComponentName(e2));
              let s2 = this.upvars.indexOf(e2);
              return s2 !== -1 || (s2 = this.upvars.length, this.upvars.push(e2)), s2;
            }
            allocateNamed(e2) {
              let r2 = this.named[e2];
              return r2 || (r2 = this.named[e2] = this.allocate(e2)), r2;
            }
            allocateBlock(e2) {
              e2 === "inverse" && (e2 = "else");
              let r2 = this.blocks[e2];
              return r2 || (r2 = this.blocks[e2] = this.allocate("&".concat(e2))), r2;
            }
            allocate(e2) {
              return this.symbols.push(e2), this.size++;
            }
          };
          t2.ProgramSymbolTable = c;
          var o = class extends d {
            constructor(e2, r2, s2) {
              super(), this.parent = e2, this.symbols = r2, this.slots = s2;
            }
            get locals() {
              return this.symbols;
            }
            has(e2) {
              return this.symbols.indexOf(e2) !== -1 || this.parent.has(e2);
            }
            get(e2) {
              let r2 = this.symbols.indexOf(e2);
              return r2 === -1 ? this.parent.get(e2) : [this.slots[r2], false];
            }
            getLocalsMap() {
              let e2 = this.parent.getLocalsMap();
              return this.symbols.forEach((r2) => e2[r2] = this.get(r2)[0]), e2;
            }
            getEvalInfo() {
              let e2 = this.getLocalsMap();
              return Object.keys(e2).map((r2) => e2[r2]);
            }
            setHasEval() {
              this.parent.setHasEval();
            }
            allocateFree(e2, r2) {
              return this.parent.allocateFree(e2, r2);
            }
            allocateNamed(e2) {
              return this.parent.allocateNamed(e2);
            }
            allocateBlock(e2) {
              return this.parent.allocateBlock(e2);
            }
            allocate(e2) {
              return this.parent.allocate(e2);
            }
          };
          t2.BlockSymbolTable = o;
        } }), jt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/builders.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.BuildElement = t2.Builder = void 0;
          var f3 = X(), h2 = le(), d = ce(), c = e2(ve());
          function o() {
            if (typeof WeakMap != "function")
              return null;
            var n = /* @__PURE__ */ new WeakMap();
            return o = function() {
              return n;
            }, n;
          }
          function e2(n) {
            if (n && n.__esModule)
              return n;
            if (n === null || typeof n != "object" && typeof n != "function")
              return { default: n };
            var a = o();
            if (a && a.has(n))
              return a.get(n);
            var u = {}, i2 = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var l in n)
              if (Object.prototype.hasOwnProperty.call(n, l)) {
                var b = i2 ? Object.getOwnPropertyDescriptor(n, l) : null;
                b && (b.get || b.set) ? Object.defineProperty(u, l, b) : u[l] = n[l];
              }
            return u.default = n, a && a.set(n, u), u;
          }
          var r2 = function(n, a) {
            var u = {};
            for (var i2 in n)
              Object.prototype.hasOwnProperty.call(n, i2) && a.indexOf(i2) < 0 && (u[i2] = n[i2]);
            if (n != null && typeof Object.getOwnPropertySymbols == "function")
              for (var l = 0, i2 = Object.getOwnPropertySymbols(n); l < i2.length; l++)
                a.indexOf(i2[l]) < 0 && Object.prototype.propertyIsEnumerable.call(n, i2[l]) && (u[i2[l]] = n[i2[l]]);
            return u;
          }, s2 = class {
            template(n, a, u) {
              return new c.Template({ table: n, body: a, loc: u });
            }
            block(n, a, u) {
              return new c.Block({ scope: n, body: a, loc: u });
            }
            namedBlock(n, a, u) {
              return new c.NamedBlock({ name: n, block: a, attrs: [], componentArgs: [], modifiers: [], loc: u });
            }
            simpleNamedBlock(n, a, u) {
              return new p({ selfClosing: false, attrs: [], componentArgs: [], modifiers: [], comments: [] }).named(n, a, u);
            }
            slice(n, a) {
              return new h2.SourceSlice({ loc: a, chars: n });
            }
            args(n, a, u) {
              return new c.Args({ loc: u, positional: n, named: a });
            }
            positional(n, a) {
              return new c.PositionalArguments({ loc: a, exprs: n });
            }
            namedArgument(n, a) {
              return new c.NamedArgument({ name: n, value: a });
            }
            named(n, a) {
              return new c.NamedArguments({ loc: a, entries: n });
            }
            attr(n, a) {
              let { name: u, value: i2, trusting: l } = n;
              return new c.HtmlAttr({ loc: a, name: u, value: i2, trusting: l });
            }
            splatAttr(n, a) {
              return new c.SplatAttr({ symbol: n, loc: a });
            }
            arg(n, a) {
              let { name: u, value: i2, trusting: l } = n;
              return new c.ComponentArg({ name: u, value: i2, trusting: l, loc: a });
            }
            path(n, a, u) {
              return new c.PathExpression({ loc: u, ref: n, tail: a });
            }
            self(n) {
              return new c.ThisReference({ loc: n });
            }
            at(n, a, u) {
              return new c.ArgReference({ loc: u, name: new h2.SourceSlice({ loc: u, chars: n }), symbol: a });
            }
            freeVar(n) {
              let { name: a, context: u, symbol: i2, loc: l } = n;
              return new c.FreeVarReference({ name: a, resolution: u, symbol: i2, loc: l });
            }
            localVar(n, a, u, i2) {
              return new c.LocalVarReference({ loc: i2, name: n, isTemplateLocal: u, symbol: a });
            }
            sexp(n, a) {
              return new c.CallExpression({ loc: a, callee: n.callee, args: n.args });
            }
            deprecatedCall(n, a, u) {
              return new c.DeprecatedCallExpression({ loc: u, arg: n, callee: a });
            }
            interpolate(n, a) {
              return (0, f3.assertPresent)(n), new c.InterpolateExpression({ loc: a, parts: n });
            }
            literal(n, a) {
              return new c.LiteralExpression({ loc: a, value: n });
            }
            append(n, a) {
              let { table: u, trusting: i2, value: l } = n;
              return new c.AppendContent({ table: u, trusting: i2, value: l, loc: a });
            }
            modifier(n, a) {
              let { callee: u, args: i2 } = n;
              return new c.ElementModifier({ loc: a, callee: u, args: i2 });
            }
            namedBlocks(n, a) {
              return new c.NamedBlocks({ loc: a, blocks: n });
            }
            blockStatement(n, a) {
              var { symbols: u, program: i2, inverse: l = null } = n, b = r2(n, ["symbols", "program", "inverse"]);
              let P = i2.loc, E = [this.namedBlock(h2.SourceSlice.synthetic("default"), i2, i2.loc)];
              return l && (P = P.extend(l.loc), E.push(this.namedBlock(h2.SourceSlice.synthetic("else"), l, l.loc))), new c.InvokeBlock({ loc: a, blocks: this.namedBlocks(E, P), callee: b.callee, args: b.args });
            }
            element(n) {
              return new p(n);
            }
          };
          t2.Builder = s2;
          var p = class {
            constructor(n) {
              this.base = n, this.builder = new s2();
            }
            simple(n, a, u) {
              return new c.SimpleElement((0, f3.assign)({ tag: n, body: a, componentArgs: [], loc: u }, this.base));
            }
            named(n, a, u) {
              return new c.NamedBlock((0, f3.assign)({ name: n, block: a, componentArgs: [], loc: u }, this.base));
            }
            selfClosingComponent(n, a) {
              return new c.InvokeComponent((0, f3.assign)({ loc: a, callee: n, blocks: new c.NamedBlocks({ blocks: [], loc: a.sliceEndChars({ skipEnd: 1, chars: 1 }) }) }, this.base));
            }
            componentWithDefaultBlock(n, a, u, i2) {
              let l = this.builder.block(u, a, i2), b = this.builder.namedBlock(h2.SourceSlice.synthetic("default"), l, i2);
              return new c.InvokeComponent((0, f3.assign)({ loc: i2, callee: n, blocks: this.builder.namedBlocks([b], b.loc) }, this.base));
            }
            componentWithNamedBlocks(n, a, u) {
              return new c.InvokeComponent((0, f3.assign)({ loc: u, callee: n, blocks: this.builder.namedBlocks(a, d.SpanList.range(a)) }, this.base));
            }
          };
          t2.BuildElement = p;
        } }), Mt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/loose-resolution.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.SexpSyntaxContext = c, t2.ModifierSyntaxContext = o, t2.BlockSyntaxContext = e2, t2.ComponentSyntaxContext = r2, t2.AttrValueSyntaxContext = s2, t2.AppendSyntaxContext = p;
          var f3 = d(ve());
          function h2() {
            if (typeof WeakMap != "function")
              return null;
            var i2 = /* @__PURE__ */ new WeakMap();
            return h2 = function() {
              return i2;
            }, i2;
          }
          function d(i2) {
            if (i2 && i2.__esModule)
              return i2;
            if (i2 === null || typeof i2 != "object" && typeof i2 != "function")
              return { default: i2 };
            var l = h2();
            if (l && l.has(i2))
              return l.get(i2);
            var b = {}, P = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var E in i2)
              if (Object.prototype.hasOwnProperty.call(i2, E)) {
                var v = P ? Object.getOwnPropertyDescriptor(i2, E) : null;
                v && (v.get || v.set) ? Object.defineProperty(b, E, v) : b[E] = i2[E];
              }
            return b.default = i2, l && l.set(i2, b), b;
          }
          function c(i2) {
            return n(i2) ? f3.LooseModeResolution.namespaced("Helper") : null;
          }
          function o(i2) {
            return n(i2) ? f3.LooseModeResolution.namespaced("Modifier") : null;
          }
          function e2(i2) {
            return n(i2) ? f3.LooseModeResolution.namespaced("Component") : f3.LooseModeResolution.fallback();
          }
          function r2(i2) {
            return a(i2) ? f3.LooseModeResolution.namespaced("Component", true) : null;
          }
          function s2(i2) {
            let l = n(i2), b = u(i2);
            return l ? b ? f3.LooseModeResolution.namespaced("Helper") : f3.LooseModeResolution.attr() : b ? f3.STRICT_RESOLUTION : f3.LooseModeResolution.fallback();
          }
          function p(i2) {
            let l = n(i2), b = u(i2), P = i2.trusting;
            return l ? P ? f3.LooseModeResolution.trustingAppend({ invoke: b }) : f3.LooseModeResolution.append({ invoke: b }) : f3.LooseModeResolution.fallback();
          }
          function n(i2) {
            let l = i2.path;
            return a(l);
          }
          function a(i2) {
            return i2.type === "PathExpression" && i2.head.type === "VarHead" ? i2.tail.length === 0 : false;
          }
          function u(i2) {
            return i2.params.length > 0 || i2.hash.pairs.length > 0;
          }
        } }), Ht = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/v2-a/normalize.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.normalize = P, t2.BlockContext = void 0;
          var f3 = X(), h2 = b(Te()), d = Fe(), c = le(), o = ce(), e2 = Xe(), r2 = he(), s2 = ye(), p = b(Le()), n = l(ve()), a = jt(), u = Mt();
          function i2() {
            if (typeof WeakMap != "function")
              return null;
            var m2 = /* @__PURE__ */ new WeakMap();
            return i2 = function() {
              return m2;
            }, m2;
          }
          function l(m2) {
            if (m2 && m2.__esModule)
              return m2;
            if (m2 === null || typeof m2 != "object" && typeof m2 != "function")
              return { default: m2 };
            var C = i2();
            if (C && C.has(m2))
              return C.get(m2);
            var S2 = {}, R = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var M in m2)
              if (Object.prototype.hasOwnProperty.call(m2, M)) {
                var V = R ? Object.getOwnPropertyDescriptor(m2, M) : null;
                V && (V.get || V.set) ? Object.defineProperty(S2, M, V) : S2[M] = m2[M];
              }
            return S2.default = m2, C && C.set(m2, S2), S2;
          }
          function b(m2) {
            return m2 && m2.__esModule ? m2 : { default: m2 };
          }
          function P(m2) {
            let C = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
            var S2;
            let R = (0, d.preprocess)(m2, C), M = (0, f3.assign)({ strictMode: false, locals: [] }, C), V = e2.SymbolTable.top(M.locals, (S2 = C.customizeComponentName) !== null && S2 !== void 0 ? S2 : (W) => W), G = new E(m2, M, V), K = new _(G), U = new L(G.loc(R.loc), R.body.map((W) => K.normalize(W)), G).assertTemplate(V), Z2 = V.getUsedTemplateLocals();
            return [U, Z2];
          }
          var E = class {
            constructor(m2, C, S2) {
              this.source = m2, this.options = C, this.table = S2, this.builder = new a.Builder();
            }
            get strict() {
              return this.options.strictMode || false;
            }
            loc(m2) {
              return this.source.spanFor(m2);
            }
            resolutionFor(m2, C) {
              if (this.strict)
                return { resolution: n.STRICT_RESOLUTION };
              if (this.isFreeVar(m2)) {
                let S2 = C(m2);
                return S2 === null ? { resolution: "error", path: w(m2), head: H(m2) } : { resolution: S2 };
              } else
                return { resolution: n.STRICT_RESOLUTION };
            }
            isFreeVar(m2) {
              return m2.type === "PathExpression" ? m2.head.type !== "VarHead" ? false : !this.table.has(m2.head.name) : m2.path.type === "PathExpression" ? this.isFreeVar(m2.path) : false;
            }
            hasBinding(m2) {
              return this.table.has(m2);
            }
            child(m2) {
              return new E(this.source, this.options, this.table.child(m2));
            }
            customizeComponentName(m2) {
              return this.options.customizeComponentName ? this.options.customizeComponentName(m2) : m2;
            }
          };
          t2.BlockContext = E;
          var v = class {
            constructor(m2) {
              this.block = m2;
            }
            normalize(m2, C) {
              switch (m2.type) {
                case "NullLiteral":
                case "BooleanLiteral":
                case "NumberLiteral":
                case "StringLiteral":
                case "UndefinedLiteral":
                  return this.block.builder.literal(m2.value, this.block.loc(m2.loc));
                case "PathExpression":
                  return this.path(m2, C);
                case "SubExpression": {
                  let S2 = this.block.resolutionFor(m2, u.SexpSyntaxContext);
                  if (S2.resolution === "error")
                    throw (0, r2.generateSyntaxError)("You attempted to invoke a path (`".concat(S2.path, "`) but ").concat(S2.head, " was not in scope"), m2.loc);
                  return this.block.builder.sexp(this.callParts(m2, S2.resolution), this.block.loc(m2.loc));
                }
              }
            }
            path(m2, C) {
              let S2 = this.block.loc(m2.head.loc), R = [], M = S2;
              for (let V of m2.tail)
                M = M.sliceStartChars({ chars: V.length, skipStart: 1 }), R.push(new c.SourceSlice({ loc: M, chars: V }));
              return this.block.builder.path(this.ref(m2.head, C), R, this.block.loc(m2.loc));
            }
            callParts(m2, C) {
              let { path: S2, params: R, hash: M } = m2, V = this.normalize(S2, C), G = R.map((N) => this.normalize(N, n.ARGUMENT_RESOLUTION)), K = o.SpanList.range(G, V.loc.collapse("end")), U = this.block.loc(M.loc), Z2 = o.SpanList.range([K, U]), W = this.block.builder.positional(R.map((N) => this.normalize(N, n.ARGUMENT_RESOLUTION)), K), T = this.block.builder.named(M.pairs.map((N) => this.namedArgument(N)), this.block.loc(M.loc));
              return { callee: V, args: this.block.builder.args(W, T, Z2) };
            }
            namedArgument(m2) {
              let S2 = this.block.loc(m2.loc).sliceStartChars({ chars: m2.key.length });
              return this.block.builder.namedArgument(new c.SourceSlice({ chars: m2.key, loc: S2 }), this.normalize(m2.value, n.ARGUMENT_RESOLUTION));
            }
            ref(m2, C) {
              let { block: S2 } = this, { builder: R, table: M } = S2, V = S2.loc(m2.loc);
              switch (m2.type) {
                case "ThisHead":
                  return R.self(V);
                case "AtHead": {
                  let G = M.allocateNamed(m2.name);
                  return R.at(m2.name, G, V);
                }
                case "VarHead":
                  if (S2.hasBinding(m2.name)) {
                    let [G, K] = M.get(m2.name);
                    return S2.builder.localVar(m2.name, G, K, V);
                  } else {
                    let G = S2.strict ? n.STRICT_RESOLUTION : C, K = S2.table.allocateFree(m2.name, G);
                    return S2.builder.freeVar({ name: m2.name, context: G, symbol: K, loc: V });
                  }
              }
            }
          }, _ = class {
            constructor(m2) {
              this.block = m2;
            }
            normalize(m2) {
              switch (m2.type) {
                case "PartialStatement":
                  throw new Error("Handlebars partial syntax ({{> ...}}) is not allowed in Glimmer");
                case "BlockStatement":
                  return this.BlockStatement(m2);
                case "ElementNode":
                  return new y(this.block).ElementNode(m2);
                case "MustacheStatement":
                  return this.MustacheStatement(m2);
                case "MustacheCommentStatement":
                  return this.MustacheCommentStatement(m2);
                case "CommentStatement": {
                  let C = this.block.loc(m2.loc);
                  return new n.HtmlComment({ loc: C, text: C.slice({ skipStart: 4, skipEnd: 3 }).toSlice(m2.value) });
                }
                case "TextNode":
                  return new n.HtmlText({ loc: this.block.loc(m2.loc), chars: m2.chars });
              }
            }
            MustacheCommentStatement(m2) {
              let C = this.block.loc(m2.loc), S2;
              return C.asString().slice(0, 5) === "{{!--" ? S2 = C.slice({ skipStart: 5, skipEnd: 4 }) : S2 = C.slice({ skipStart: 3, skipEnd: 2 }), new n.GlimmerComment({ loc: C, text: S2.toSlice(m2.value) });
            }
            MustacheStatement(m2) {
              let { escaped: C } = m2, S2 = this.block.loc(m2.loc), R = this.expr.callParts({ path: m2.path, params: m2.params, hash: m2.hash }, (0, u.AppendSyntaxContext)(m2)), M = R.args.isEmpty() ? R.callee : this.block.builder.sexp(R, S2);
              return this.block.builder.append({ table: this.block.table, trusting: !C, value: M }, S2);
            }
            BlockStatement(m2) {
              let { program: C, inverse: S2 } = m2, R = this.block.loc(m2.loc), M = this.block.resolutionFor(m2, u.BlockSyntaxContext);
              if (M.resolution === "error")
                throw (0, r2.generateSyntaxError)("You attempted to invoke a path (`{{#".concat(M.path, "}}`) but ").concat(M.head, " was not in scope"), R);
              let V = this.expr.callParts(m2, M.resolution);
              return this.block.builder.blockStatement((0, f3.assign)({ symbols: this.block.table, program: this.Block(C), inverse: S2 ? this.Block(S2) : null }, V), R);
            }
            Block(m2) {
              let { body: C, loc: S2, blockParams: R } = m2, M = this.block.child(R), V = new _(M);
              return new j(this.block.loc(S2), C.map((G) => V.normalize(G)), this.block).assertBlock(M.table);
            }
            get expr() {
              return new v(this.block);
            }
          }, y = class {
            constructor(m2) {
              this.ctx = m2;
            }
            ElementNode(m2) {
              let { tag: C, selfClosing: S2, comments: R } = m2, M = this.ctx.loc(m2.loc), [V, ...G] = C.split("."), K = this.classifyTag(V, G, m2.loc), U = m2.attributes.filter((A2) => A2.name[0] !== "@").map((A2) => this.attr(A2)), Z2 = m2.attributes.filter((A2) => A2.name[0] === "@").map((A2) => this.arg(A2)), W = m2.modifiers.map((A2) => this.modifier(A2)), T = this.ctx.child(m2.blockParams), N = new _(T), k = m2.children.map((A2) => N.normalize(A2)), B = this.ctx.builder.element({ selfClosing: S2, attrs: U, componentArgs: Z2, modifiers: W, comments: R.map((A2) => new _(this.ctx).MustacheCommentStatement(A2)) }), O = new x2(B, M, k, this.ctx), z = this.ctx.loc(m2.loc).sliceStartChars({ chars: C.length, skipStart: 1 });
              if (K === "ElementHead")
                return C[0] === ":" ? O.assertNamedBlock(z.slice({ skipStart: 1 }).toSlice(C.slice(1)), T.table) : O.assertElement(z.toSlice(C), m2.blockParams.length > 0);
              if (m2.selfClosing)
                return B.selfClosingComponent(K, M);
              {
                let A2 = O.assertComponent(C, T.table, m2.blockParams.length > 0);
                return B.componentWithNamedBlocks(K, A2, M);
              }
            }
            modifier(m2) {
              let C = this.ctx.resolutionFor(m2, u.ModifierSyntaxContext);
              if (C.resolution === "error")
                throw (0, r2.generateSyntaxError)("You attempted to invoke a path (`{{#".concat(C.path, "}}`) as a modifier, but ").concat(C.head, " was not in scope. Try adding `this` to the beginning of the path"), m2.loc);
              let S2 = this.expr.callParts(m2, C.resolution);
              return this.ctx.builder.modifier(S2, this.ctx.loc(m2.loc));
            }
            mustacheAttr(m2) {
              let C = this.ctx.builder.sexp(this.expr.callParts(m2, (0, u.AttrValueSyntaxContext)(m2)), this.ctx.loc(m2.loc));
              return C.args.isEmpty() ? C.callee : C;
            }
            attrPart(m2) {
              switch (m2.type) {
                case "MustacheStatement":
                  return { expr: this.mustacheAttr(m2), trusting: !m2.escaped };
                case "TextNode":
                  return { expr: this.ctx.builder.literal(m2.chars, this.ctx.loc(m2.loc)), trusting: true };
              }
            }
            attrValue(m2) {
              switch (m2.type) {
                case "ConcatStatement": {
                  let C = m2.parts.map((S2) => this.attrPart(S2).expr);
                  return { expr: this.ctx.builder.interpolate(C, this.ctx.loc(m2.loc)), trusting: false };
                }
                default:
                  return this.attrPart(m2);
              }
            }
            attr(m2) {
              if (m2.name === "...attributes")
                return this.ctx.builder.splatAttr(this.ctx.table.allocateBlock("attrs"), this.ctx.loc(m2.loc));
              let C = this.ctx.loc(m2.loc), S2 = C.sliceStartChars({ chars: m2.name.length }).toSlice(m2.name), R = this.attrValue(m2.value);
              return this.ctx.builder.attr({ name: S2, value: R.expr, trusting: R.trusting }, C);
            }
            maybeDeprecatedCall(m2, C) {
              if (this.ctx.strict || C.type !== "MustacheStatement")
                return null;
              let { path: S2 } = C;
              if (S2.type !== "PathExpression" || S2.head.type !== "VarHead")
                return null;
              let { name: R } = S2.head;
              if (R === "has-block" || R === "has-block-params" || this.ctx.hasBinding(R) || S2.tail.length !== 0 || C.params.length !== 0 || C.hash.pairs.length !== 0)
                return null;
              let M = n.LooseModeResolution.attr(), V = this.ctx.builder.freeVar({ name: R, context: M, symbol: this.ctx.table.allocateFree(R, M), loc: S2.loc });
              return { expr: this.ctx.builder.deprecatedCall(m2, V, C.loc), trusting: false };
            }
            arg(m2) {
              let C = this.ctx.loc(m2.loc), S2 = C.sliceStartChars({ chars: m2.name.length }).toSlice(m2.name), R = this.maybeDeprecatedCall(S2, m2.value) || this.attrValue(m2.value);
              return this.ctx.builder.arg({ name: S2, value: R.expr, trusting: R.trusting }, C);
            }
            classifyTag(m2, C, S2) {
              let R = (0, s2.isUpperCase)(m2), M = m2[0] === "@" || m2 === "this" || this.ctx.hasBinding(m2);
              if (this.ctx.strict && !M) {
                if (R)
                  throw (0, r2.generateSyntaxError)("Attempted to invoke a component that was not in scope in a strict mode template, `<".concat(m2, ">`. If you wanted to create an element with that name, convert it to lowercase - `<").concat(m2.toLowerCase(), ">`"), S2);
                return "ElementHead";
              }
              let V = M || R, G = S2.sliceStartChars({ skipStart: 1, chars: m2.length }), K = C.reduce((W, T) => W + 1 + T.length, 0), U = G.getEnd().move(K), Z2 = G.withEnd(U);
              if (V) {
                let W = p.default.path({ head: p.default.head(m2, G), tail: C, loc: Z2 }), T = this.ctx.resolutionFor(W, u.ComponentSyntaxContext);
                if (T.resolution === "error")
                  throw (0, r2.generateSyntaxError)("You attempted to invoke a path (`<".concat(T.path, ">`) but ").concat(T.head, " was not in scope"), S2);
                return new v(this.ctx).normalize(W, T.resolution);
              }
              if (C.length > 0)
                throw (0, r2.generateSyntaxError)("You used ".concat(m2, ".").concat(C.join("."), " as a tag name, but ").concat(m2, " is not in scope"), S2);
              return "ElementHead";
            }
            get expr() {
              return new v(this.ctx);
            }
          }, g = class {
            constructor(m2, C, S2) {
              this.loc = m2, this.children = C, this.block = S2, this.namedBlocks = C.filter((R) => R instanceof n.NamedBlock), this.hasSemanticContent = Boolean(C.filter((R) => {
                if (R instanceof n.NamedBlock)
                  return false;
                switch (R.type) {
                  case "GlimmerComment":
                  case "HtmlComment":
                    return false;
                  case "HtmlText":
                    return !/^\s*$/.exec(R.chars);
                  default:
                    return true;
                }
              }).length), this.nonBlockChildren = C.filter((R) => !(R instanceof n.NamedBlock));
            }
          }, L = class extends g {
            assertTemplate(m2) {
              if ((0, f3.isPresent)(this.namedBlocks))
                throw (0, r2.generateSyntaxError)("Unexpected named block at the top-level of a template", this.loc);
              return this.block.builder.template(m2, this.nonBlockChildren, this.block.loc(this.loc));
            }
          }, j = class extends g {
            assertBlock(m2) {
              if ((0, f3.isPresent)(this.namedBlocks))
                throw (0, r2.generateSyntaxError)("Unexpected named block nested in a normal block", this.loc);
              return this.block.builder.block(m2, this.nonBlockChildren, this.loc);
            }
          }, x2 = class extends g {
            constructor(m2, C, S2, R) {
              super(C, S2, R), this.el = m2;
            }
            assertNamedBlock(m2, C) {
              if (this.el.base.selfClosing)
                throw (0, r2.generateSyntaxError)("<:".concat(m2.chars, "/> is not a valid named block: named blocks cannot be self-closing"), this.loc);
              if ((0, f3.isPresent)(this.namedBlocks))
                throw (0, r2.generateSyntaxError)("Unexpected named block inside <:".concat(m2.chars, "> named block: named blocks cannot contain nested named blocks"), this.loc);
              if (!(0, s2.isLowerCase)(m2.chars))
                throw (0, r2.generateSyntaxError)("<:".concat(m2.chars, "> is not a valid named block, and named blocks must begin with a lowercase letter"), this.loc);
              if (this.el.base.attrs.length > 0 || this.el.base.componentArgs.length > 0 || this.el.base.modifiers.length > 0)
                throw (0, r2.generateSyntaxError)("named block <:".concat(m2.chars, "> cannot have attributes, arguments, or modifiers"), this.loc);
              let S2 = o.SpanList.range(this.nonBlockChildren, this.loc);
              return this.block.builder.namedBlock(m2, this.block.builder.block(C, this.nonBlockChildren, S2), this.loc);
            }
            assertElement(m2, C) {
              if (C)
                throw (0, r2.generateSyntaxError)("Unexpected block params in <".concat(m2, ">: simple elements cannot have block params"), this.loc);
              if ((0, f3.isPresent)(this.namedBlocks)) {
                let S2 = this.namedBlocks.map((R) => R.name);
                if (S2.length === 1)
                  throw (0, r2.generateSyntaxError)("Unexpected named block <:foo> inside <".concat(m2.chars, "> HTML element"), this.loc);
                {
                  let R = S2.map((M) => "<:".concat(M.chars, ">")).join(", ");
                  throw (0, r2.generateSyntaxError)("Unexpected named blocks inside <".concat(m2.chars, "> HTML element (").concat(R, ")"), this.loc);
                }
              }
              return this.el.simple(m2, this.nonBlockChildren, this.loc);
            }
            assertComponent(m2, C, S2) {
              if ((0, f3.isPresent)(this.namedBlocks) && this.hasSemanticContent)
                throw (0, r2.generateSyntaxError)("Unexpected content inside <".concat(m2, "> component invocation: when using named blocks, the tag cannot contain other content"), this.loc);
              if ((0, f3.isPresent)(this.namedBlocks)) {
                if (S2)
                  throw (0, r2.generateSyntaxError)("Unexpected block params list on <".concat(m2, "> component invocation: when passing named blocks, the invocation tag cannot take block params"), this.loc);
                let R = /* @__PURE__ */ new Set();
                for (let M of this.namedBlocks) {
                  let V = M.name.chars;
                  if (R.has(V))
                    throw (0, r2.generateSyntaxError)("Component had two named blocks with the same name, `<:".concat(V, ">`. Only one block with a given name may be passed"), this.loc);
                  if (V === "inverse" && R.has("else") || V === "else" && R.has("inverse"))
                    throw (0, r2.generateSyntaxError)("Component has both <:else> and <:inverse> block. <:inverse> is an alias for <:else>", this.loc);
                  R.add(V);
                }
                return this.namedBlocks;
              } else
                return [this.block.builder.namedBlock(c.SourceSlice.synthetic("default"), this.block.builder.block(C, this.nonBlockChildren, this.loc), this.loc)];
            }
          };
          function w(m2) {
            return m2.type !== "PathExpression" && m2.path.type === "PathExpression" ? w(m2.path) : new h2.default({ entityEncoding: "raw" }).print(m2);
          }
          function H(m2) {
            if (m2.type === "PathExpression")
              switch (m2.head.type) {
                case "AtHead":
                case "VarHead":
                  return m2.head.name;
                case "ThisHead":
                  return "this";
              }
            else
              return m2.path.type === "PathExpression" ? H(m2.path) : new h2.default({ entityEncoding: "raw" }).print(m2);
          }
        } }), Ze = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/keywords.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.isKeyword = f3, t2.KEYWORDS_TYPES = void 0;
          function f3(d) {
            return d in h2;
          }
          var h2 = { component: ["Call", "Append", "Block"], debugger: ["Append"], "each-in": ["Block"], each: ["Block"], "has-block-params": ["Call", "Append"], "has-block": ["Call", "Append"], helper: ["Call", "Append"], if: ["Call", "Append", "Block"], "in-element": ["Block"], let: ["Block"], "link-to": ["Append", "Block"], log: ["Call", "Append"], modifier: ["Call"], mount: ["Append"], mut: ["Call", "Append"], outlet: ["Append"], "query-params": ["Call"], readonly: ["Call", "Append"], unbound: ["Call", "Append"], unless: ["Call", "Append", "Block"], with: ["Block"], yield: ["Append"] };
          t2.KEYWORDS_TYPES = h2;
        } }), Vt = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/lib/get-template-locals.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), t2.getTemplateLocals = r2;
          var f3 = Ze(), h2 = Fe(), d = c(Ne());
          function c(s2) {
            return s2 && s2.__esModule ? s2 : { default: s2 };
          }
          function o(s2, p, n) {
            if (s2.type === "PathExpression") {
              if (s2.head.type === "AtHead" || s2.head.type === "ThisHead")
                return;
              let a = s2.head.name;
              if (p.indexOf(a) === -1)
                return a;
            } else if (s2.type === "ElementNode") {
              let { tag: a } = s2, u = a.charAt(0);
              return u === ":" || u === "@" || !n.includeHtmlElements && a.indexOf(".") === -1 && a.toLowerCase() === a || a.substr(0, 5) === "this." || p.indexOf(a) !== -1 ? void 0 : a;
            }
          }
          function e2(s2, p, n, a) {
            let u = o(p, n, a);
            (Array.isArray(u) ? u : [u]).forEach((i2) => {
              i2 !== void 0 && i2[0] !== "@" && s2.add(i2.split(".")[0]);
            });
          }
          function r2(s2) {
            let p = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : { includeHtmlElements: false, includeKeywords: false }, n = (0, h2.preprocess)(s2), a = /* @__PURE__ */ new Set(), u = [];
            (0, d.default)(n, { Block: { enter(l) {
              let { blockParams: b } = l;
              b.forEach((P) => {
                u.push(P);
              });
            }, exit(l) {
              let { blockParams: b } = l;
              b.forEach(() => {
                u.pop();
              });
            } }, ElementNode: { enter(l) {
              l.blockParams.forEach((b) => {
                u.push(b);
              }), e2(a, l, u, p);
            }, exit(l) {
              let { blockParams: b } = l;
              b.forEach(() => {
                u.pop();
              });
            } }, PathExpression(l) {
              e2(a, l, u, p);
            } });
            let i2 = [];
            return a.forEach((l) => i2.push(l)), p != null && p.includeKeywords || (i2 = i2.filter((l) => !(0, f3.isKeyword)(l))), i2;
          }
        } }), Ut = I({ "node_modules/@glimmer/syntax/dist/commonjs/es2017/index.js"(t2) {
          "use strict";
          F2(), Object.defineProperty(t2, "__esModule", { value: true }), Object.defineProperty(t2, "Source", { enumerable: true, get: function() {
            return f3.Source;
          } }), Object.defineProperty(t2, "builders", { enumerable: true, get: function() {
            return h2.default;
          } }), Object.defineProperty(t2, "normalize", { enumerable: true, get: function() {
            return o.normalize;
          } }), Object.defineProperty(t2, "SymbolTable", { enumerable: true, get: function() {
            return e2.SymbolTable;
          } }), Object.defineProperty(t2, "BlockSymbolTable", { enumerable: true, get: function() {
            return e2.BlockSymbolTable;
          } }), Object.defineProperty(t2, "ProgramSymbolTable", { enumerable: true, get: function() {
            return e2.ProgramSymbolTable;
          } }), Object.defineProperty(t2, "generateSyntaxError", { enumerable: true, get: function() {
            return r2.generateSyntaxError;
          } }), Object.defineProperty(t2, "preprocess", { enumerable: true, get: function() {
            return s2.preprocess;
          } }), Object.defineProperty(t2, "print", { enumerable: true, get: function() {
            return p.default;
          } }), Object.defineProperty(t2, "sortByLoc", { enumerable: true, get: function() {
            return n.sortByLoc;
          } }), Object.defineProperty(t2, "Walker", { enumerable: true, get: function() {
            return a.default;
          } }), Object.defineProperty(t2, "Path", { enumerable: true, get: function() {
            return a.default;
          } }), Object.defineProperty(t2, "traverse", { enumerable: true, get: function() {
            return u.default;
          } }), Object.defineProperty(t2, "cannotRemoveNode", { enumerable: true, get: function() {
            return i2.cannotRemoveNode;
          } }), Object.defineProperty(t2, "cannotReplaceNode", { enumerable: true, get: function() {
            return i2.cannotReplaceNode;
          } }), Object.defineProperty(t2, "WalkerPath", { enumerable: true, get: function() {
            return l.default;
          } }), Object.defineProperty(t2, "isKeyword", { enumerable: true, get: function() {
            return b.isKeyword;
          } }), Object.defineProperty(t2, "KEYWORDS_TYPES", { enumerable: true, get: function() {
            return b.KEYWORDS_TYPES;
          } }), Object.defineProperty(t2, "getTemplateLocals", { enumerable: true, get: function() {
            return P.getTemplateLocals;
          } }), Object.defineProperty(t2, "SourceSlice", { enumerable: true, get: function() {
            return E.SourceSlice;
          } }), Object.defineProperty(t2, "SourceSpan", { enumerable: true, get: function() {
            return v.SourceSpan;
          } }), Object.defineProperty(t2, "SpanList", { enumerable: true, get: function() {
            return _.SpanList;
          } }), Object.defineProperty(t2, "maybeLoc", { enumerable: true, get: function() {
            return _.maybeLoc;
          } }), Object.defineProperty(t2, "loc", { enumerable: true, get: function() {
            return _.loc;
          } }), Object.defineProperty(t2, "hasSpan", { enumerable: true, get: function() {
            return _.hasSpan;
          } }), Object.defineProperty(t2, "node", { enumerable: true, get: function() {
            return y.node;
          } }), t2.ASTv2 = t2.AST = t2.ASTv1 = void 0;
          var f3 = De(), h2 = j(ke()), d = L(Ct());
          t2.ASTv1 = d, t2.AST = d;
          var c = L(ve());
          t2.ASTv2 = c;
          var o = Ht(), e2 = Xe(), r2 = he(), s2 = Fe(), p = j(We()), n = Ue(), a = j(Je()), u = j(Ne()), i2 = Ye(), l = j(Qe()), b = Ze(), P = Vt(), E = le(), v = ue(), _ = ce(), y = ne();
          function g() {
            if (typeof WeakMap != "function")
              return null;
            var x2 = /* @__PURE__ */ new WeakMap();
            return g = function() {
              return x2;
            }, x2;
          }
          function L(x2) {
            if (x2 && x2.__esModule)
              return x2;
            if (x2 === null || typeof x2 != "object" && typeof x2 != "function")
              return { default: x2 };
            var w = g();
            if (w && w.has(x2))
              return w.get(x2);
            var H = {}, m2 = Object.defineProperty && Object.getOwnPropertyDescriptor;
            for (var C in x2)
              if (Object.prototype.hasOwnProperty.call(x2, C)) {
                var S2 = m2 ? Object.getOwnPropertyDescriptor(x2, C) : null;
                S2 && (S2.get || S2.set) ? Object.defineProperty(H, C, S2) : H[C] = x2[C];
              }
            return H.default = x2, w && w.set(x2, H), H;
          }
          function j(x2) {
            return x2 && x2.__esModule ? x2 : { default: x2 };
          }
        } });
        F2();
        var { LinesAndColumns: zt } = st(), Gt = ut(), { locStart: Kt, locEnd: Wt } = ot();
        function Yt() {
          return { name: "addBackslash", visitor: { All(t2) {
            var f3;
            let h2 = (f3 = t2.children) !== null && f3 !== void 0 ? f3 : t2.body;
            if (h2)
              for (let d = 0; d < h2.length - 1; d++)
                h2[d].type === "TextNode" && h2[d + 1].type === "MustacheStatement" && (h2[d].chars = h2[d].chars.replace(/\\$/, "\\\\"));
          } } };
        }
        function Qt(t2) {
          let f3 = new zt(t2), h2 = (d) => {
            let { line: c, column: o } = d;
            return f3.indexForLocation({ line: c - 1, column: o });
          };
          return () => ({ name: "addOffset", visitor: { All(d) {
            let { start: c, end: o } = d.loc;
            c.offset = h2(c), o.offset = h2(o);
          } } });
        }
        function Jt(t2) {
          let { preprocess: f3 } = Ut(), h2;
          try {
            h2 = f3(t2, { mode: "codemod", plugins: { ast: [Yt, Qt(t2)] } });
          } catch (d) {
            let c = Xt(d);
            throw c ? Gt(d.message, c) : d;
          }
          return h2;
        }
        function Xt(t2) {
          let { location: f3, hash: h2 } = t2;
          if (f3) {
            let { start: d, end: c } = f3;
            return typeof c.line != "number" ? { start: d } : f3;
          }
          if (h2) {
            let { loc: { last_line: d, last_column: c } } = h2;
            return { start: { line: d, column: c + 1 } };
          }
        }
        $e.exports = { parsers: { glimmer: { parse: Jt, astFormat: "glimmer", locStart: Kt, locEnd: Wt } } };
      });
      return Zt();
    });
  }
});

// node_modules/prettier/parser-graphql.js
var require_parser_graphql = __commonJS({
  "node_modules/prettier/parser-graphql.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.graphql = e2();
      }
    })(function() {
      "use strict";
      var oe = (a, d) => () => (d || a((d = { exports: {} }).exports, d), d.exports);
      var be = oe((Ce, ae) => {
        var H = Object.getOwnPropertyNames, se = (a, d) => function() {
          return a && (d = (0, a[H(a)[0]])(a = 0)), d;
        }, L = (a, d) => function() {
          return d || (0, a[H(a)[0]])((d = { exports: {} }).exports, d), d.exports;
        }, K = se({ "<define:process>"() {
        } }), ce = L({ "src/common/parser-create-error.js"(a, d) {
          "use strict";
          K();
          function i2(c, r2) {
            let _ = new SyntaxError(c + " (" + r2.start.line + ":" + r2.start.column + ")");
            return _.loc = r2, _;
          }
          d.exports = i2;
        } }), ue = L({ "src/utils/try-combinations.js"(a, d) {
          "use strict";
          K();
          function i2() {
            let c;
            for (var r2 = arguments.length, _ = new Array(r2), E = 0; E < r2; E++)
              _[E] = arguments[E];
            for (let [k, O] of _.entries())
              try {
                return { result: O() };
              } catch (A2) {
                k === 0 && (c = A2);
              }
            return { error: c };
          }
          d.exports = i2;
        } }), le = L({ "src/language-graphql/pragma.js"(a, d) {
          "use strict";
          K();
          function i2(r2) {
            return /^\s*#[^\S\n]*@(?:format|prettier)\s*(?:\n|$)/.test(r2);
          }
          function c(r2) {
            return `# @format

` + r2;
          }
          d.exports = { hasPragma: i2, insertPragma: c };
        } }), pe = L({ "src/language-graphql/loc.js"(a, d) {
          "use strict";
          K();
          function i2(r2) {
            return typeof r2.start == "number" ? r2.start : r2.loc && r2.loc.start;
          }
          function c(r2) {
            return typeof r2.end == "number" ? r2.end : r2.loc && r2.loc.end;
          }
          d.exports = { locStart: i2, locEnd: c };
        } }), fe = L({ "node_modules/graphql/jsutils/isObjectLike.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = i2;
          function d(c) {
            return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? d = function(_) {
              return typeof _;
            } : d = function(_) {
              return _ && typeof Symbol == "function" && _.constructor === Symbol && _ !== Symbol.prototype ? "symbol" : typeof _;
            }, d(c);
          }
          function i2(c) {
            return d(c) == "object" && c !== null;
          }
        } }), z = L({ "node_modules/graphql/polyfills/symbols.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.SYMBOL_TO_STRING_TAG = a.SYMBOL_ASYNC_ITERATOR = a.SYMBOL_ITERATOR = void 0;
          var d = typeof Symbol == "function" && Symbol.iterator != null ? Symbol.iterator : "@@iterator";
          a.SYMBOL_ITERATOR = d;
          var i2 = typeof Symbol == "function" && Symbol.asyncIterator != null ? Symbol.asyncIterator : "@@asyncIterator";
          a.SYMBOL_ASYNC_ITERATOR = i2;
          var c = typeof Symbol == "function" && Symbol.toStringTag != null ? Symbol.toStringTag : "@@toStringTag";
          a.SYMBOL_TO_STRING_TAG = c;
        } }), $ = L({ "node_modules/graphql/language/location.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.getLocation = d;
          function d(i2, c) {
            for (var r2 = /\r\n|[\n\r]/g, _ = 1, E = c + 1, k; (k = r2.exec(i2.body)) && k.index < c; )
              _ += 1, E = c + 1 - (k.index + k[0].length);
            return { line: _, column: E };
          }
        } }), de = L({ "node_modules/graphql/language/printLocation.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.printLocation = i2, a.printSourceLocation = c;
          var d = $();
          function i2(k) {
            return c(k.source, (0, d.getLocation)(k.source, k.start));
          }
          function c(k, O) {
            var A2 = k.locationOffset.column - 1, N = _(A2) + k.body, g = O.line - 1, D = k.locationOffset.line - 1, v = O.line + D, I = O.line === 1 ? A2 : 0, s2 = O.column + I, p = "".concat(k.name, ":").concat(v, ":").concat(s2, `
`), e2 = N.split(/\r\n|[\n\r]/g), n = e2[g];
            if (n.length > 120) {
              for (var t2 = Math.floor(s2 / 80), u = s2 % 80, y = [], f3 = 0; f3 < n.length; f3 += 80)
                y.push(n.slice(f3, f3 + 80));
              return p + r2([["".concat(v), y[0]]].concat(y.slice(1, t2 + 1).map(function(m2) {
                return ["", m2];
              }), [[" ", _(u - 1) + "^"], ["", y[t2 + 1]]]));
            }
            return p + r2([["".concat(v - 1), e2[g - 1]], ["".concat(v), n], ["", _(s2 - 1) + "^"], ["".concat(v + 1), e2[g + 1]]]);
          }
          function r2(k) {
            var O = k.filter(function(N) {
              var g = N[0], D = N[1];
              return D !== void 0;
            }), A2 = Math.max.apply(Math, O.map(function(N) {
              var g = N[0];
              return g.length;
            }));
            return O.map(function(N) {
              var g = N[0], D = N[1];
              return E(A2, g) + (D ? " | " + D : " |");
            }).join(`
`);
          }
          function _(k) {
            return Array(k + 1).join(" ");
          }
          function E(k, O) {
            return _(k - O.length) + O;
          }
        } }), W = L({ "node_modules/graphql/error/GraphQLError.js"(a) {
          "use strict";
          K();
          function d(f3) {
            return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? d = function(o) {
              return typeof o;
            } : d = function(o) {
              return o && typeof Symbol == "function" && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
            }, d(f3);
          }
          Object.defineProperty(a, "__esModule", { value: true }), a.printError = y, a.GraphQLError = void 0;
          var i2 = E(fe()), c = z(), r2 = $(), _ = de();
          function E(f3) {
            return f3 && f3.__esModule ? f3 : { default: f3 };
          }
          function k(f3, m2) {
            if (!(f3 instanceof m2))
              throw new TypeError("Cannot call a class as a function");
          }
          function O(f3, m2) {
            for (var o = 0; o < m2.length; o++) {
              var h2 = m2[o];
              h2.enumerable = h2.enumerable || false, h2.configurable = true, "value" in h2 && (h2.writable = true), Object.defineProperty(f3, h2.key, h2);
            }
          }
          function A2(f3, m2, o) {
            return m2 && O(f3.prototype, m2), o && O(f3, o), f3;
          }
          function N(f3, m2) {
            if (typeof m2 != "function" && m2 !== null)
              throw new TypeError("Super expression must either be null or a function");
            f3.prototype = Object.create(m2 && m2.prototype, { constructor: { value: f3, writable: true, configurable: true } }), m2 && n(f3, m2);
          }
          function g(f3) {
            var m2 = p();
            return function() {
              var h2 = t2(f3), l;
              if (m2) {
                var T = t2(this).constructor;
                l = Reflect.construct(h2, arguments, T);
              } else
                l = h2.apply(this, arguments);
              return D(this, l);
            };
          }
          function D(f3, m2) {
            return m2 && (d(m2) === "object" || typeof m2 == "function") ? m2 : v(f3);
          }
          function v(f3) {
            if (f3 === void 0)
              throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
            return f3;
          }
          function I(f3) {
            var m2 = typeof Map == "function" ? /* @__PURE__ */ new Map() : void 0;
            return I = function(h2) {
              if (h2 === null || !e2(h2))
                return h2;
              if (typeof h2 != "function")
                throw new TypeError("Super expression must either be null or a function");
              if (typeof m2 < "u") {
                if (m2.has(h2))
                  return m2.get(h2);
                m2.set(h2, l);
              }
              function l() {
                return s2(h2, arguments, t2(this).constructor);
              }
              return l.prototype = Object.create(h2.prototype, { constructor: { value: l, enumerable: false, writable: true, configurable: true } }), n(l, h2);
            }, I(f3);
          }
          function s2(f3, m2, o) {
            return p() ? s2 = Reflect.construct : s2 = function(l, T, S2) {
              var x2 = [null];
              x2.push.apply(x2, T);
              var b = Function.bind.apply(l, x2), M = new b();
              return S2 && n(M, S2.prototype), M;
            }, s2.apply(null, arguments);
          }
          function p() {
            if (typeof Reflect > "u" || !Reflect.construct || Reflect.construct.sham)
              return false;
            if (typeof Proxy == "function")
              return true;
            try {
              return Date.prototype.toString.call(Reflect.construct(Date, [], function() {
              })), true;
            } catch {
              return false;
            }
          }
          function e2(f3) {
            return Function.toString.call(f3).indexOf("[native code]") !== -1;
          }
          function n(f3, m2) {
            return n = Object.setPrototypeOf || function(h2, l) {
              return h2.__proto__ = l, h2;
            }, n(f3, m2);
          }
          function t2(f3) {
            return t2 = Object.setPrototypeOf ? Object.getPrototypeOf : function(o) {
              return o.__proto__ || Object.getPrototypeOf(o);
            }, t2(f3);
          }
          var u = function(f3) {
            N(o, f3);
            var m2 = g(o);
            function o(h2, l, T, S2, x2, b, M) {
              var U, V, q, G, C;
              k(this, o), C = m2.call(this, h2);
              var R = Array.isArray(l) ? l.length !== 0 ? l : void 0 : l ? [l] : void 0, Y = T;
              if (!Y && R) {
                var J;
                Y = (J = R[0].loc) === null || J === void 0 ? void 0 : J.source;
              }
              var F2 = S2;
              !F2 && R && (F2 = R.reduce(function(w, P) {
                return P.loc && w.push(P.loc.start), w;
              }, [])), F2 && F2.length === 0 && (F2 = void 0);
              var B;
              S2 && T ? B = S2.map(function(w) {
                return (0, r2.getLocation)(T, w);
              }) : R && (B = R.reduce(function(w, P) {
                return P.loc && w.push((0, r2.getLocation)(P.loc.source, P.loc.start)), w;
              }, []));
              var j = M;
              if (j == null && b != null) {
                var Q = b.extensions;
                (0, i2.default)(Q) && (j = Q);
              }
              return Object.defineProperties(v(C), { name: { value: "GraphQLError" }, message: { value: h2, enumerable: true, writable: true }, locations: { value: (U = B) !== null && U !== void 0 ? U : void 0, enumerable: B != null }, path: { value: x2 != null ? x2 : void 0, enumerable: x2 != null }, nodes: { value: R != null ? R : void 0 }, source: { value: (V = Y) !== null && V !== void 0 ? V : void 0 }, positions: { value: (q = F2) !== null && q !== void 0 ? q : void 0 }, originalError: { value: b }, extensions: { value: (G = j) !== null && G !== void 0 ? G : void 0, enumerable: j != null } }), b != null && b.stack ? (Object.defineProperty(v(C), "stack", { value: b.stack, writable: true, configurable: true }), D(C)) : (Error.captureStackTrace ? Error.captureStackTrace(v(C), o) : Object.defineProperty(v(C), "stack", { value: Error().stack, writable: true, configurable: true }), C);
            }
            return A2(o, [{ key: "toString", value: function() {
              return y(this);
            } }, { key: c.SYMBOL_TO_STRING_TAG, get: function() {
              return "Object";
            } }]), o;
          }(I(Error));
          a.GraphQLError = u;
          function y(f3) {
            var m2 = f3.message;
            if (f3.nodes)
              for (var o = 0, h2 = f3.nodes; o < h2.length; o++) {
                var l = h2[o];
                l.loc && (m2 += `

` + (0, _.printLocation)(l.loc));
              }
            else if (f3.source && f3.locations)
              for (var T = 0, S2 = f3.locations; T < S2.length; T++) {
                var x2 = S2[T];
                m2 += `

` + (0, _.printSourceLocation)(f3.source, x2);
              }
            return m2;
          }
        } }), Z2 = L({ "node_modules/graphql/error/syntaxError.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.syntaxError = i2;
          var d = W();
          function i2(c, r2, _) {
            return new d.GraphQLError("Syntax Error: ".concat(_), void 0, c, [r2]);
          }
        } }), he = L({ "node_modules/graphql/language/kinds.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.Kind = void 0;
          var d = Object.freeze({ NAME: "Name", DOCUMENT: "Document", OPERATION_DEFINITION: "OperationDefinition", VARIABLE_DEFINITION: "VariableDefinition", SELECTION_SET: "SelectionSet", FIELD: "Field", ARGUMENT: "Argument", FRAGMENT_SPREAD: "FragmentSpread", INLINE_FRAGMENT: "InlineFragment", FRAGMENT_DEFINITION: "FragmentDefinition", VARIABLE: "Variable", INT: "IntValue", FLOAT: "FloatValue", STRING: "StringValue", BOOLEAN: "BooleanValue", NULL: "NullValue", ENUM: "EnumValue", LIST: "ListValue", OBJECT: "ObjectValue", OBJECT_FIELD: "ObjectField", DIRECTIVE: "Directive", NAMED_TYPE: "NamedType", LIST_TYPE: "ListType", NON_NULL_TYPE: "NonNullType", SCHEMA_DEFINITION: "SchemaDefinition", OPERATION_TYPE_DEFINITION: "OperationTypeDefinition", SCALAR_TYPE_DEFINITION: "ScalarTypeDefinition", OBJECT_TYPE_DEFINITION: "ObjectTypeDefinition", FIELD_DEFINITION: "FieldDefinition", INPUT_VALUE_DEFINITION: "InputValueDefinition", INTERFACE_TYPE_DEFINITION: "InterfaceTypeDefinition", UNION_TYPE_DEFINITION: "UnionTypeDefinition", ENUM_TYPE_DEFINITION: "EnumTypeDefinition", ENUM_VALUE_DEFINITION: "EnumValueDefinition", INPUT_OBJECT_TYPE_DEFINITION: "InputObjectTypeDefinition", DIRECTIVE_DEFINITION: "DirectiveDefinition", SCHEMA_EXTENSION: "SchemaExtension", SCALAR_TYPE_EXTENSION: "ScalarTypeExtension", OBJECT_TYPE_EXTENSION: "ObjectTypeExtension", INTERFACE_TYPE_EXTENSION: "InterfaceTypeExtension", UNION_TYPE_EXTENSION: "UnionTypeExtension", ENUM_TYPE_EXTENSION: "EnumTypeExtension", INPUT_OBJECT_TYPE_EXTENSION: "InputObjectTypeExtension" });
          a.Kind = d;
        } }), ve = L({ "node_modules/graphql/jsutils/invariant.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = d;
          function d(i2, c) {
            var r2 = Boolean(i2);
            if (!r2)
              throw new Error(c != null ? c : "Unexpected invariant triggered.");
          }
        } }), ee = L({ "node_modules/graphql/jsutils/nodejsCustomInspectSymbol.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = void 0;
          var d = typeof Symbol == "function" && typeof Symbol.for == "function" ? Symbol.for("nodejs.util.inspect.custom") : void 0, i2 = d;
          a.default = i2;
        } }), Te = L({ "node_modules/graphql/jsutils/defineInspect.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = r2;
          var d = c(ve()), i2 = c(ee());
          function c(_) {
            return _ && _.__esModule ? _ : { default: _ };
          }
          function r2(_) {
            var E = _.prototype.toJSON;
            typeof E == "function" || (0, d.default)(0), _.prototype.inspect = E, i2.default && (_.prototype[i2.default] = E);
          }
        } }), te = L({ "node_modules/graphql/language/ast.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.isNode = _, a.Token = a.Location = void 0;
          var d = i2(Te());
          function i2(E) {
            return E && E.__esModule ? E : { default: E };
          }
          var c = function() {
            function E(O, A2, N) {
              this.start = O.start, this.end = A2.end, this.startToken = O, this.endToken = A2, this.source = N;
            }
            var k = E.prototype;
            return k.toJSON = function() {
              return { start: this.start, end: this.end };
            }, E;
          }();
          a.Location = c, (0, d.default)(c);
          var r2 = function() {
            function E(O, A2, N, g, D, v, I) {
              this.kind = O, this.start = A2, this.end = N, this.line = g, this.column = D, this.value = I, this.prev = v, this.next = null;
            }
            var k = E.prototype;
            return k.toJSON = function() {
              return { kind: this.kind, value: this.value, line: this.line, column: this.column };
            }, E;
          }();
          a.Token = r2, (0, d.default)(r2);
          function _(E) {
            return E != null && typeof E.kind == "string";
          }
        } }), ne = L({ "node_modules/graphql/language/tokenKind.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.TokenKind = void 0;
          var d = Object.freeze({ SOF: "<SOF>", EOF: "<EOF>", BANG: "!", DOLLAR: "$", AMP: "&", PAREN_L: "(", PAREN_R: ")", SPREAD: "...", COLON: ":", EQUALS: "=", AT: "@", BRACKET_L: "[", BRACKET_R: "]", BRACE_L: "{", PIPE: "|", BRACE_R: "}", NAME: "Name", INT: "Int", FLOAT: "Float", STRING: "String", BLOCK_STRING: "BlockString", COMMENT: "Comment" });
          a.TokenKind = d;
        } }), re = L({ "node_modules/graphql/jsutils/inspect.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = E;
          var d = i2(ee());
          function i2(v) {
            return v && v.__esModule ? v : { default: v };
          }
          function c(v) {
            return typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? c = function(s2) {
              return typeof s2;
            } : c = function(s2) {
              return s2 && typeof Symbol == "function" && s2.constructor === Symbol && s2 !== Symbol.prototype ? "symbol" : typeof s2;
            }, c(v);
          }
          var r2 = 10, _ = 2;
          function E(v) {
            return k(v, []);
          }
          function k(v, I) {
            switch (c(v)) {
              case "string":
                return JSON.stringify(v);
              case "function":
                return v.name ? "[function ".concat(v.name, "]") : "[function]";
              case "object":
                return v === null ? "null" : O(v, I);
              default:
                return String(v);
            }
          }
          function O(v, I) {
            if (I.indexOf(v) !== -1)
              return "[Circular]";
            var s2 = [].concat(I, [v]), p = g(v);
            if (p !== void 0) {
              var e2 = p.call(v);
              if (e2 !== v)
                return typeof e2 == "string" ? e2 : k(e2, s2);
            } else if (Array.isArray(v))
              return N(v, s2);
            return A2(v, s2);
          }
          function A2(v, I) {
            var s2 = Object.keys(v);
            if (s2.length === 0)
              return "{}";
            if (I.length > _)
              return "[" + D(v) + "]";
            var p = s2.map(function(e2) {
              var n = k(v[e2], I);
              return e2 + ": " + n;
            });
            return "{ " + p.join(", ") + " }";
          }
          function N(v, I) {
            if (v.length === 0)
              return "[]";
            if (I.length > _)
              return "[Array]";
            for (var s2 = Math.min(r2, v.length), p = v.length - s2, e2 = [], n = 0; n < s2; ++n)
              e2.push(k(v[n], I));
            return p === 1 ? e2.push("... 1 more item") : p > 1 && e2.push("... ".concat(p, " more items")), "[" + e2.join(", ") + "]";
          }
          function g(v) {
            var I = v[String(d.default)];
            if (typeof I == "function")
              return I;
            if (typeof v.inspect == "function")
              return v.inspect;
          }
          function D(v) {
            var I = Object.prototype.toString.call(v).replace(/^\[object /, "").replace(/]$/, "");
            if (I === "Object" && typeof v.constructor == "function") {
              var s2 = v.constructor.name;
              if (typeof s2 == "string" && s2 !== "")
                return s2;
            }
            return I;
          }
        } }), _e = L({ "node_modules/graphql/jsutils/devAssert.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = d;
          function d(i2, c) {
            var r2 = Boolean(i2);
            if (!r2)
              throw new Error(c);
          }
        } }), Ee = L({ "node_modules/graphql/jsutils/instanceOf.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.default = void 0;
          var d = i2(re());
          function i2(r2) {
            return r2 && r2.__esModule ? r2 : { default: r2 };
          }
          var c = function(_, E) {
            return _ instanceof E;
          };
          a.default = c;
        } }), me = L({ "node_modules/graphql/language/source.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.isSource = A2, a.Source = void 0;
          var d = z(), i2 = _(re()), c = _(_e()), r2 = _(Ee());
          function _(N) {
            return N && N.__esModule ? N : { default: N };
          }
          function E(N, g) {
            for (var D = 0; D < g.length; D++) {
              var v = g[D];
              v.enumerable = v.enumerable || false, v.configurable = true, "value" in v && (v.writable = true), Object.defineProperty(N, v.key, v);
            }
          }
          function k(N, g, D) {
            return g && E(N.prototype, g), D && E(N, D), N;
          }
          var O = function() {
            function N(g) {
              var D = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "GraphQL request", v = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : { line: 1, column: 1 };
              typeof g == "string" || (0, c.default)(0, "Body must be a string. Received: ".concat((0, i2.default)(g), ".")), this.body = g, this.name = D, this.locationOffset = v, this.locationOffset.line > 0 || (0, c.default)(0, "line in locationOffset is 1-indexed and must be positive."), this.locationOffset.column > 0 || (0, c.default)(0, "column in locationOffset is 1-indexed and must be positive.");
            }
            return k(N, [{ key: d.SYMBOL_TO_STRING_TAG, get: function() {
              return "Source";
            } }]), N;
          }();
          a.Source = O;
          function A2(N) {
            return (0, r2.default)(N, O);
          }
        } }), ye = L({ "node_modules/graphql/language/directiveLocation.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.DirectiveLocation = void 0;
          var d = Object.freeze({ QUERY: "QUERY", MUTATION: "MUTATION", SUBSCRIPTION: "SUBSCRIPTION", FIELD: "FIELD", FRAGMENT_DEFINITION: "FRAGMENT_DEFINITION", FRAGMENT_SPREAD: "FRAGMENT_SPREAD", INLINE_FRAGMENT: "INLINE_FRAGMENT", VARIABLE_DEFINITION: "VARIABLE_DEFINITION", SCHEMA: "SCHEMA", SCALAR: "SCALAR", OBJECT: "OBJECT", FIELD_DEFINITION: "FIELD_DEFINITION", ARGUMENT_DEFINITION: "ARGUMENT_DEFINITION", INTERFACE: "INTERFACE", UNION: "UNION", ENUM: "ENUM", ENUM_VALUE: "ENUM_VALUE", INPUT_OBJECT: "INPUT_OBJECT", INPUT_FIELD_DEFINITION: "INPUT_FIELD_DEFINITION" });
          a.DirectiveLocation = d;
        } }), ke = L({ "node_modules/graphql/language/blockString.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.dedentBlockStringValue = d, a.getBlockStringIndentation = c, a.printBlockString = r2;
          function d(_) {
            var E = _.split(/\r\n|[\n\r]/g), k = c(_);
            if (k !== 0)
              for (var O = 1; O < E.length; O++)
                E[O] = E[O].slice(k);
            for (var A2 = 0; A2 < E.length && i2(E[A2]); )
              ++A2;
            for (var N = E.length; N > A2 && i2(E[N - 1]); )
              --N;
            return E.slice(A2, N).join(`
`);
          }
          function i2(_) {
            for (var E = 0; E < _.length; ++E)
              if (_[E] !== " " && _[E] !== "	")
                return false;
            return true;
          }
          function c(_) {
            for (var E, k = true, O = true, A2 = 0, N = null, g = 0; g < _.length; ++g)
              switch (_.charCodeAt(g)) {
                case 13:
                  _.charCodeAt(g + 1) === 10 && ++g;
                case 10:
                  k = false, O = true, A2 = 0;
                  break;
                case 9:
                case 32:
                  ++A2;
                  break;
                default:
                  O && !k && (N === null || A2 < N) && (N = A2), O = false;
              }
            return (E = N) !== null && E !== void 0 ? E : 0;
          }
          function r2(_) {
            var E = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "", k = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : false, O = _.indexOf(`
`) === -1, A2 = _[0] === " " || _[0] === "	", N = _[_.length - 1] === '"', g = _[_.length - 1] === "\\", D = !O || N || g || k, v = "";
            return D && !(O && A2) && (v += `
` + E), v += E ? _.replace(/\n/g, `
` + E) : _, D && (v += `
`), '"""' + v.replace(/"""/g, '\\"""') + '"""';
          }
        } }), Ne = L({ "node_modules/graphql/language/lexer.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.isPunctuatorTokenKind = E, a.Lexer = void 0;
          var d = Z2(), i2 = te(), c = ne(), r2 = ke(), _ = function() {
            function t2(y) {
              var f3 = new i2.Token(c.TokenKind.SOF, 0, 0, 0, 0, null);
              this.source = y, this.lastToken = f3, this.token = f3, this.line = 1, this.lineStart = 0;
            }
            var u = t2.prototype;
            return u.advance = function() {
              this.lastToken = this.token;
              var f3 = this.token = this.lookahead();
              return f3;
            }, u.lookahead = function() {
              var f3 = this.token;
              if (f3.kind !== c.TokenKind.EOF)
                do {
                  var m2;
                  f3 = (m2 = f3.next) !== null && m2 !== void 0 ? m2 : f3.next = O(this, f3);
                } while (f3.kind === c.TokenKind.COMMENT);
              return f3;
            }, t2;
          }();
          a.Lexer = _;
          function E(t2) {
            return t2 === c.TokenKind.BANG || t2 === c.TokenKind.DOLLAR || t2 === c.TokenKind.AMP || t2 === c.TokenKind.PAREN_L || t2 === c.TokenKind.PAREN_R || t2 === c.TokenKind.SPREAD || t2 === c.TokenKind.COLON || t2 === c.TokenKind.EQUALS || t2 === c.TokenKind.AT || t2 === c.TokenKind.BRACKET_L || t2 === c.TokenKind.BRACKET_R || t2 === c.TokenKind.BRACE_L || t2 === c.TokenKind.PIPE || t2 === c.TokenKind.BRACE_R;
          }
          function k(t2) {
            return isNaN(t2) ? c.TokenKind.EOF : t2 < 127 ? JSON.stringify(String.fromCharCode(t2)) : '"\\u'.concat(("00" + t2.toString(16).toUpperCase()).slice(-4), '"');
          }
          function O(t2, u) {
            for (var y = t2.source, f3 = y.body, m2 = f3.length, o = u.end; o < m2; ) {
              var h2 = f3.charCodeAt(o), l = t2.line, T = 1 + o - t2.lineStart;
              switch (h2) {
                case 65279:
                case 9:
                case 32:
                case 44:
                  ++o;
                  continue;
                case 10:
                  ++o, ++t2.line, t2.lineStart = o;
                  continue;
                case 13:
                  f3.charCodeAt(o + 1) === 10 ? o += 2 : ++o, ++t2.line, t2.lineStart = o;
                  continue;
                case 33:
                  return new i2.Token(c.TokenKind.BANG, o, o + 1, l, T, u);
                case 35:
                  return N(y, o, l, T, u);
                case 36:
                  return new i2.Token(c.TokenKind.DOLLAR, o, o + 1, l, T, u);
                case 38:
                  return new i2.Token(c.TokenKind.AMP, o, o + 1, l, T, u);
                case 40:
                  return new i2.Token(c.TokenKind.PAREN_L, o, o + 1, l, T, u);
                case 41:
                  return new i2.Token(c.TokenKind.PAREN_R, o, o + 1, l, T, u);
                case 46:
                  if (f3.charCodeAt(o + 1) === 46 && f3.charCodeAt(o + 2) === 46)
                    return new i2.Token(c.TokenKind.SPREAD, o, o + 3, l, T, u);
                  break;
                case 58:
                  return new i2.Token(c.TokenKind.COLON, o, o + 1, l, T, u);
                case 61:
                  return new i2.Token(c.TokenKind.EQUALS, o, o + 1, l, T, u);
                case 64:
                  return new i2.Token(c.TokenKind.AT, o, o + 1, l, T, u);
                case 91:
                  return new i2.Token(c.TokenKind.BRACKET_L, o, o + 1, l, T, u);
                case 93:
                  return new i2.Token(c.TokenKind.BRACKET_R, o, o + 1, l, T, u);
                case 123:
                  return new i2.Token(c.TokenKind.BRACE_L, o, o + 1, l, T, u);
                case 124:
                  return new i2.Token(c.TokenKind.PIPE, o, o + 1, l, T, u);
                case 125:
                  return new i2.Token(c.TokenKind.BRACE_R, o, o + 1, l, T, u);
                case 34:
                  return f3.charCodeAt(o + 1) === 34 && f3.charCodeAt(o + 2) === 34 ? I(y, o, l, T, u, t2) : v(y, o, l, T, u);
                case 45:
                case 48:
                case 49:
                case 50:
                case 51:
                case 52:
                case 53:
                case 54:
                case 55:
                case 56:
                case 57:
                  return g(y, o, h2, l, T, u);
                case 65:
                case 66:
                case 67:
                case 68:
                case 69:
                case 70:
                case 71:
                case 72:
                case 73:
                case 74:
                case 75:
                case 76:
                case 77:
                case 78:
                case 79:
                case 80:
                case 81:
                case 82:
                case 83:
                case 84:
                case 85:
                case 86:
                case 87:
                case 88:
                case 89:
                case 90:
                case 95:
                case 97:
                case 98:
                case 99:
                case 100:
                case 101:
                case 102:
                case 103:
                case 104:
                case 105:
                case 106:
                case 107:
                case 108:
                case 109:
                case 110:
                case 111:
                case 112:
                case 113:
                case 114:
                case 115:
                case 116:
                case 117:
                case 118:
                case 119:
                case 120:
                case 121:
                case 122:
                  return e2(y, o, l, T, u);
              }
              throw (0, d.syntaxError)(y, o, A2(h2));
            }
            var S2 = t2.line, x2 = 1 + o - t2.lineStart;
            return new i2.Token(c.TokenKind.EOF, m2, m2, S2, x2, u);
          }
          function A2(t2) {
            return t2 < 32 && t2 !== 9 && t2 !== 10 && t2 !== 13 ? "Cannot contain the invalid character ".concat(k(t2), ".") : t2 === 39 ? `Unexpected single quote character ('), did you mean to use a double quote (")?` : "Cannot parse the unexpected character ".concat(k(t2), ".");
          }
          function N(t2, u, y, f3, m2) {
            var o = t2.body, h2, l = u;
            do
              h2 = o.charCodeAt(++l);
            while (!isNaN(h2) && (h2 > 31 || h2 === 9));
            return new i2.Token(c.TokenKind.COMMENT, u, l, y, f3, m2, o.slice(u + 1, l));
          }
          function g(t2, u, y, f3, m2, o) {
            var h2 = t2.body, l = y, T = u, S2 = false;
            if (l === 45 && (l = h2.charCodeAt(++T)), l === 48) {
              if (l = h2.charCodeAt(++T), l >= 48 && l <= 57)
                throw (0, d.syntaxError)(t2, T, "Invalid number, unexpected digit after 0: ".concat(k(l), "."));
            } else
              T = D(t2, T, l), l = h2.charCodeAt(T);
            if (l === 46 && (S2 = true, l = h2.charCodeAt(++T), T = D(t2, T, l), l = h2.charCodeAt(T)), (l === 69 || l === 101) && (S2 = true, l = h2.charCodeAt(++T), (l === 43 || l === 45) && (l = h2.charCodeAt(++T)), T = D(t2, T, l), l = h2.charCodeAt(T)), l === 46 || n(l))
              throw (0, d.syntaxError)(t2, T, "Invalid number, expected digit but got: ".concat(k(l), "."));
            return new i2.Token(S2 ? c.TokenKind.FLOAT : c.TokenKind.INT, u, T, f3, m2, o, h2.slice(u, T));
          }
          function D(t2, u, y) {
            var f3 = t2.body, m2 = u, o = y;
            if (o >= 48 && o <= 57) {
              do
                o = f3.charCodeAt(++m2);
              while (o >= 48 && o <= 57);
              return m2;
            }
            throw (0, d.syntaxError)(t2, m2, "Invalid number, expected digit but got: ".concat(k(o), "."));
          }
          function v(t2, u, y, f3, m2) {
            for (var o = t2.body, h2 = u + 1, l = h2, T = 0, S2 = ""; h2 < o.length && !isNaN(T = o.charCodeAt(h2)) && T !== 10 && T !== 13; ) {
              if (T === 34)
                return S2 += o.slice(l, h2), new i2.Token(c.TokenKind.STRING, u, h2 + 1, y, f3, m2, S2);
              if (T < 32 && T !== 9)
                throw (0, d.syntaxError)(t2, h2, "Invalid character within String: ".concat(k(T), "."));
              if (++h2, T === 92) {
                switch (S2 += o.slice(l, h2 - 1), T = o.charCodeAt(h2), T) {
                  case 34:
                    S2 += '"';
                    break;
                  case 47:
                    S2 += "/";
                    break;
                  case 92:
                    S2 += "\\";
                    break;
                  case 98:
                    S2 += "\b";
                    break;
                  case 102:
                    S2 += "\f";
                    break;
                  case 110:
                    S2 += `
`;
                    break;
                  case 114:
                    S2 += "\r";
                    break;
                  case 116:
                    S2 += "	";
                    break;
                  case 117: {
                    var x2 = s2(o.charCodeAt(h2 + 1), o.charCodeAt(h2 + 2), o.charCodeAt(h2 + 3), o.charCodeAt(h2 + 4));
                    if (x2 < 0) {
                      var b = o.slice(h2 + 1, h2 + 5);
                      throw (0, d.syntaxError)(t2, h2, "Invalid character escape sequence: \\u".concat(b, "."));
                    }
                    S2 += String.fromCharCode(x2), h2 += 4;
                    break;
                  }
                  default:
                    throw (0, d.syntaxError)(t2, h2, "Invalid character escape sequence: \\".concat(String.fromCharCode(T), "."));
                }
                ++h2, l = h2;
              }
            }
            throw (0, d.syntaxError)(t2, h2, "Unterminated string.");
          }
          function I(t2, u, y, f3, m2, o) {
            for (var h2 = t2.body, l = u + 3, T = l, S2 = 0, x2 = ""; l < h2.length && !isNaN(S2 = h2.charCodeAt(l)); ) {
              if (S2 === 34 && h2.charCodeAt(l + 1) === 34 && h2.charCodeAt(l + 2) === 34)
                return x2 += h2.slice(T, l), new i2.Token(c.TokenKind.BLOCK_STRING, u, l + 3, y, f3, m2, (0, r2.dedentBlockStringValue)(x2));
              if (S2 < 32 && S2 !== 9 && S2 !== 10 && S2 !== 13)
                throw (0, d.syntaxError)(t2, l, "Invalid character within String: ".concat(k(S2), "."));
              S2 === 10 ? (++l, ++o.line, o.lineStart = l) : S2 === 13 ? (h2.charCodeAt(l + 1) === 10 ? l += 2 : ++l, ++o.line, o.lineStart = l) : S2 === 92 && h2.charCodeAt(l + 1) === 34 && h2.charCodeAt(l + 2) === 34 && h2.charCodeAt(l + 3) === 34 ? (x2 += h2.slice(T, l) + '"""', l += 4, T = l) : ++l;
            }
            throw (0, d.syntaxError)(t2, l, "Unterminated string.");
          }
          function s2(t2, u, y, f3) {
            return p(t2) << 12 | p(u) << 8 | p(y) << 4 | p(f3);
          }
          function p(t2) {
            return t2 >= 48 && t2 <= 57 ? t2 - 48 : t2 >= 65 && t2 <= 70 ? t2 - 55 : t2 >= 97 && t2 <= 102 ? t2 - 87 : -1;
          }
          function e2(t2, u, y, f3, m2) {
            for (var o = t2.body, h2 = o.length, l = u + 1, T = 0; l !== h2 && !isNaN(T = o.charCodeAt(l)) && (T === 95 || T >= 48 && T <= 57 || T >= 65 && T <= 90 || T >= 97 && T <= 122); )
              ++l;
            return new i2.Token(c.TokenKind.NAME, u, l, y, f3, m2, o.slice(u, l));
          }
          function n(t2) {
            return t2 === 95 || t2 >= 65 && t2 <= 90 || t2 >= 97 && t2 <= 122;
          }
        } }), Oe = L({ "node_modules/graphql/language/parser.js"(a) {
          "use strict";
          K(), Object.defineProperty(a, "__esModule", { value: true }), a.parse = O, a.parseValue = A2, a.parseType = N, a.Parser = void 0;
          var d = Z2(), i2 = he(), c = te(), r2 = ne(), _ = me(), E = ye(), k = Ne();
          function O(I, s2) {
            var p = new g(I, s2);
            return p.parseDocument();
          }
          function A2(I, s2) {
            var p = new g(I, s2);
            p.expectToken(r2.TokenKind.SOF);
            var e2 = p.parseValueLiteral(false);
            return p.expectToken(r2.TokenKind.EOF), e2;
          }
          function N(I, s2) {
            var p = new g(I, s2);
            p.expectToken(r2.TokenKind.SOF);
            var e2 = p.parseTypeReference();
            return p.expectToken(r2.TokenKind.EOF), e2;
          }
          var g = function() {
            function I(p, e2) {
              var n = (0, _.isSource)(p) ? p : new _.Source(p);
              this._lexer = new k.Lexer(n), this._options = e2;
            }
            var s2 = I.prototype;
            return s2.parseName = function() {
              var e2 = this.expectToken(r2.TokenKind.NAME);
              return { kind: i2.Kind.NAME, value: e2.value, loc: this.loc(e2) };
            }, s2.parseDocument = function() {
              var e2 = this._lexer.token;
              return { kind: i2.Kind.DOCUMENT, definitions: this.many(r2.TokenKind.SOF, this.parseDefinition, r2.TokenKind.EOF), loc: this.loc(e2) };
            }, s2.parseDefinition = function() {
              if (this.peek(r2.TokenKind.NAME))
                switch (this._lexer.token.value) {
                  case "query":
                  case "mutation":
                  case "subscription":
                    return this.parseOperationDefinition();
                  case "fragment":
                    return this.parseFragmentDefinition();
                  case "schema":
                  case "scalar":
                  case "type":
                  case "interface":
                  case "union":
                  case "enum":
                  case "input":
                  case "directive":
                    return this.parseTypeSystemDefinition();
                  case "extend":
                    return this.parseTypeSystemExtension();
                }
              else {
                if (this.peek(r2.TokenKind.BRACE_L))
                  return this.parseOperationDefinition();
                if (this.peekDescription())
                  return this.parseTypeSystemDefinition();
              }
              throw this.unexpected();
            }, s2.parseOperationDefinition = function() {
              var e2 = this._lexer.token;
              if (this.peek(r2.TokenKind.BRACE_L))
                return { kind: i2.Kind.OPERATION_DEFINITION, operation: "query", name: void 0, variableDefinitions: [], directives: [], selectionSet: this.parseSelectionSet(), loc: this.loc(e2) };
              var n = this.parseOperationType(), t2;
              return this.peek(r2.TokenKind.NAME) && (t2 = this.parseName()), { kind: i2.Kind.OPERATION_DEFINITION, operation: n, name: t2, variableDefinitions: this.parseVariableDefinitions(), directives: this.parseDirectives(false), selectionSet: this.parseSelectionSet(), loc: this.loc(e2) };
            }, s2.parseOperationType = function() {
              var e2 = this.expectToken(r2.TokenKind.NAME);
              switch (e2.value) {
                case "query":
                  return "query";
                case "mutation":
                  return "mutation";
                case "subscription":
                  return "subscription";
              }
              throw this.unexpected(e2);
            }, s2.parseVariableDefinitions = function() {
              return this.optionalMany(r2.TokenKind.PAREN_L, this.parseVariableDefinition, r2.TokenKind.PAREN_R);
            }, s2.parseVariableDefinition = function() {
              var e2 = this._lexer.token;
              return { kind: i2.Kind.VARIABLE_DEFINITION, variable: this.parseVariable(), type: (this.expectToken(r2.TokenKind.COLON), this.parseTypeReference()), defaultValue: this.expectOptionalToken(r2.TokenKind.EQUALS) ? this.parseValueLiteral(true) : void 0, directives: this.parseDirectives(true), loc: this.loc(e2) };
            }, s2.parseVariable = function() {
              var e2 = this._lexer.token;
              return this.expectToken(r2.TokenKind.DOLLAR), { kind: i2.Kind.VARIABLE, name: this.parseName(), loc: this.loc(e2) };
            }, s2.parseSelectionSet = function() {
              var e2 = this._lexer.token;
              return { kind: i2.Kind.SELECTION_SET, selections: this.many(r2.TokenKind.BRACE_L, this.parseSelection, r2.TokenKind.BRACE_R), loc: this.loc(e2) };
            }, s2.parseSelection = function() {
              return this.peek(r2.TokenKind.SPREAD) ? this.parseFragment() : this.parseField();
            }, s2.parseField = function() {
              var e2 = this._lexer.token, n = this.parseName(), t2, u;
              return this.expectOptionalToken(r2.TokenKind.COLON) ? (t2 = n, u = this.parseName()) : u = n, { kind: i2.Kind.FIELD, alias: t2, name: u, arguments: this.parseArguments(false), directives: this.parseDirectives(false), selectionSet: this.peek(r2.TokenKind.BRACE_L) ? this.parseSelectionSet() : void 0, loc: this.loc(e2) };
            }, s2.parseArguments = function(e2) {
              var n = e2 ? this.parseConstArgument : this.parseArgument;
              return this.optionalMany(r2.TokenKind.PAREN_L, n, r2.TokenKind.PAREN_R);
            }, s2.parseArgument = function() {
              var e2 = this._lexer.token, n = this.parseName();
              return this.expectToken(r2.TokenKind.COLON), { kind: i2.Kind.ARGUMENT, name: n, value: this.parseValueLiteral(false), loc: this.loc(e2) };
            }, s2.parseConstArgument = function() {
              var e2 = this._lexer.token;
              return { kind: i2.Kind.ARGUMENT, name: this.parseName(), value: (this.expectToken(r2.TokenKind.COLON), this.parseValueLiteral(true)), loc: this.loc(e2) };
            }, s2.parseFragment = function() {
              var e2 = this._lexer.token;
              this.expectToken(r2.TokenKind.SPREAD);
              var n = this.expectOptionalKeyword("on");
              return !n && this.peek(r2.TokenKind.NAME) ? { kind: i2.Kind.FRAGMENT_SPREAD, name: this.parseFragmentName(), directives: this.parseDirectives(false), loc: this.loc(e2) } : { kind: i2.Kind.INLINE_FRAGMENT, typeCondition: n ? this.parseNamedType() : void 0, directives: this.parseDirectives(false), selectionSet: this.parseSelectionSet(), loc: this.loc(e2) };
            }, s2.parseFragmentDefinition = function() {
              var e2, n = this._lexer.token;
              return this.expectKeyword("fragment"), ((e2 = this._options) === null || e2 === void 0 ? void 0 : e2.experimentalFragmentVariables) === true ? { kind: i2.Kind.FRAGMENT_DEFINITION, name: this.parseFragmentName(), variableDefinitions: this.parseVariableDefinitions(), typeCondition: (this.expectKeyword("on"), this.parseNamedType()), directives: this.parseDirectives(false), selectionSet: this.parseSelectionSet(), loc: this.loc(n) } : { kind: i2.Kind.FRAGMENT_DEFINITION, name: this.parseFragmentName(), typeCondition: (this.expectKeyword("on"), this.parseNamedType()), directives: this.parseDirectives(false), selectionSet: this.parseSelectionSet(), loc: this.loc(n) };
            }, s2.parseFragmentName = function() {
              if (this._lexer.token.value === "on")
                throw this.unexpected();
              return this.parseName();
            }, s2.parseValueLiteral = function(e2) {
              var n = this._lexer.token;
              switch (n.kind) {
                case r2.TokenKind.BRACKET_L:
                  return this.parseList(e2);
                case r2.TokenKind.BRACE_L:
                  return this.parseObject(e2);
                case r2.TokenKind.INT:
                  return this._lexer.advance(), { kind: i2.Kind.INT, value: n.value, loc: this.loc(n) };
                case r2.TokenKind.FLOAT:
                  return this._lexer.advance(), { kind: i2.Kind.FLOAT, value: n.value, loc: this.loc(n) };
                case r2.TokenKind.STRING:
                case r2.TokenKind.BLOCK_STRING:
                  return this.parseStringLiteral();
                case r2.TokenKind.NAME:
                  switch (this._lexer.advance(), n.value) {
                    case "true":
                      return { kind: i2.Kind.BOOLEAN, value: true, loc: this.loc(n) };
                    case "false":
                      return { kind: i2.Kind.BOOLEAN, value: false, loc: this.loc(n) };
                    case "null":
                      return { kind: i2.Kind.NULL, loc: this.loc(n) };
                    default:
                      return { kind: i2.Kind.ENUM, value: n.value, loc: this.loc(n) };
                  }
                case r2.TokenKind.DOLLAR:
                  if (!e2)
                    return this.parseVariable();
                  break;
              }
              throw this.unexpected();
            }, s2.parseStringLiteral = function() {
              var e2 = this._lexer.token;
              return this._lexer.advance(), { kind: i2.Kind.STRING, value: e2.value, block: e2.kind === r2.TokenKind.BLOCK_STRING, loc: this.loc(e2) };
            }, s2.parseList = function(e2) {
              var n = this, t2 = this._lexer.token, u = function() {
                return n.parseValueLiteral(e2);
              };
              return { kind: i2.Kind.LIST, values: this.any(r2.TokenKind.BRACKET_L, u, r2.TokenKind.BRACKET_R), loc: this.loc(t2) };
            }, s2.parseObject = function(e2) {
              var n = this, t2 = this._lexer.token, u = function() {
                return n.parseObjectField(e2);
              };
              return { kind: i2.Kind.OBJECT, fields: this.any(r2.TokenKind.BRACE_L, u, r2.TokenKind.BRACE_R), loc: this.loc(t2) };
            }, s2.parseObjectField = function(e2) {
              var n = this._lexer.token, t2 = this.parseName();
              return this.expectToken(r2.TokenKind.COLON), { kind: i2.Kind.OBJECT_FIELD, name: t2, value: this.parseValueLiteral(e2), loc: this.loc(n) };
            }, s2.parseDirectives = function(e2) {
              for (var n = []; this.peek(r2.TokenKind.AT); )
                n.push(this.parseDirective(e2));
              return n;
            }, s2.parseDirective = function(e2) {
              var n = this._lexer.token;
              return this.expectToken(r2.TokenKind.AT), { kind: i2.Kind.DIRECTIVE, name: this.parseName(), arguments: this.parseArguments(e2), loc: this.loc(n) };
            }, s2.parseTypeReference = function() {
              var e2 = this._lexer.token, n;
              return this.expectOptionalToken(r2.TokenKind.BRACKET_L) ? (n = this.parseTypeReference(), this.expectToken(r2.TokenKind.BRACKET_R), n = { kind: i2.Kind.LIST_TYPE, type: n, loc: this.loc(e2) }) : n = this.parseNamedType(), this.expectOptionalToken(r2.TokenKind.BANG) ? { kind: i2.Kind.NON_NULL_TYPE, type: n, loc: this.loc(e2) } : n;
            }, s2.parseNamedType = function() {
              var e2 = this._lexer.token;
              return { kind: i2.Kind.NAMED_TYPE, name: this.parseName(), loc: this.loc(e2) };
            }, s2.parseTypeSystemDefinition = function() {
              var e2 = this.peekDescription() ? this._lexer.lookahead() : this._lexer.token;
              if (e2.kind === r2.TokenKind.NAME)
                switch (e2.value) {
                  case "schema":
                    return this.parseSchemaDefinition();
                  case "scalar":
                    return this.parseScalarTypeDefinition();
                  case "type":
                    return this.parseObjectTypeDefinition();
                  case "interface":
                    return this.parseInterfaceTypeDefinition();
                  case "union":
                    return this.parseUnionTypeDefinition();
                  case "enum":
                    return this.parseEnumTypeDefinition();
                  case "input":
                    return this.parseInputObjectTypeDefinition();
                  case "directive":
                    return this.parseDirectiveDefinition();
                }
              throw this.unexpected(e2);
            }, s2.peekDescription = function() {
              return this.peek(r2.TokenKind.STRING) || this.peek(r2.TokenKind.BLOCK_STRING);
            }, s2.parseDescription = function() {
              if (this.peekDescription())
                return this.parseStringLiteral();
            }, s2.parseSchemaDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("schema");
              var t2 = this.parseDirectives(true), u = this.many(r2.TokenKind.BRACE_L, this.parseOperationTypeDefinition, r2.TokenKind.BRACE_R);
              return { kind: i2.Kind.SCHEMA_DEFINITION, description: n, directives: t2, operationTypes: u, loc: this.loc(e2) };
            }, s2.parseOperationTypeDefinition = function() {
              var e2 = this._lexer.token, n = this.parseOperationType();
              this.expectToken(r2.TokenKind.COLON);
              var t2 = this.parseNamedType();
              return { kind: i2.Kind.OPERATION_TYPE_DEFINITION, operation: n, type: t2, loc: this.loc(e2) };
            }, s2.parseScalarTypeDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("scalar");
              var t2 = this.parseName(), u = this.parseDirectives(true);
              return { kind: i2.Kind.SCALAR_TYPE_DEFINITION, description: n, name: t2, directives: u, loc: this.loc(e2) };
            }, s2.parseObjectTypeDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("type");
              var t2 = this.parseName(), u = this.parseImplementsInterfaces(), y = this.parseDirectives(true), f3 = this.parseFieldsDefinition();
              return { kind: i2.Kind.OBJECT_TYPE_DEFINITION, description: n, name: t2, interfaces: u, directives: y, fields: f3, loc: this.loc(e2) };
            }, s2.parseImplementsInterfaces = function() {
              var e2;
              if (!this.expectOptionalKeyword("implements"))
                return [];
              if (((e2 = this._options) === null || e2 === void 0 ? void 0 : e2.allowLegacySDLImplementsInterfaces) === true) {
                var n = [];
                this.expectOptionalToken(r2.TokenKind.AMP);
                do
                  n.push(this.parseNamedType());
                while (this.expectOptionalToken(r2.TokenKind.AMP) || this.peek(r2.TokenKind.NAME));
                return n;
              }
              return this.delimitedMany(r2.TokenKind.AMP, this.parseNamedType);
            }, s2.parseFieldsDefinition = function() {
              var e2;
              return ((e2 = this._options) === null || e2 === void 0 ? void 0 : e2.allowLegacySDLEmptyFields) === true && this.peek(r2.TokenKind.BRACE_L) && this._lexer.lookahead().kind === r2.TokenKind.BRACE_R ? (this._lexer.advance(), this._lexer.advance(), []) : this.optionalMany(r2.TokenKind.BRACE_L, this.parseFieldDefinition, r2.TokenKind.BRACE_R);
            }, s2.parseFieldDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription(), t2 = this.parseName(), u = this.parseArgumentDefs();
              this.expectToken(r2.TokenKind.COLON);
              var y = this.parseTypeReference(), f3 = this.parseDirectives(true);
              return { kind: i2.Kind.FIELD_DEFINITION, description: n, name: t2, arguments: u, type: y, directives: f3, loc: this.loc(e2) };
            }, s2.parseArgumentDefs = function() {
              return this.optionalMany(r2.TokenKind.PAREN_L, this.parseInputValueDef, r2.TokenKind.PAREN_R);
            }, s2.parseInputValueDef = function() {
              var e2 = this._lexer.token, n = this.parseDescription(), t2 = this.parseName();
              this.expectToken(r2.TokenKind.COLON);
              var u = this.parseTypeReference(), y;
              this.expectOptionalToken(r2.TokenKind.EQUALS) && (y = this.parseValueLiteral(true));
              var f3 = this.parseDirectives(true);
              return { kind: i2.Kind.INPUT_VALUE_DEFINITION, description: n, name: t2, type: u, defaultValue: y, directives: f3, loc: this.loc(e2) };
            }, s2.parseInterfaceTypeDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("interface");
              var t2 = this.parseName(), u = this.parseImplementsInterfaces(), y = this.parseDirectives(true), f3 = this.parseFieldsDefinition();
              return { kind: i2.Kind.INTERFACE_TYPE_DEFINITION, description: n, name: t2, interfaces: u, directives: y, fields: f3, loc: this.loc(e2) };
            }, s2.parseUnionTypeDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("union");
              var t2 = this.parseName(), u = this.parseDirectives(true), y = this.parseUnionMemberTypes();
              return { kind: i2.Kind.UNION_TYPE_DEFINITION, description: n, name: t2, directives: u, types: y, loc: this.loc(e2) };
            }, s2.parseUnionMemberTypes = function() {
              return this.expectOptionalToken(r2.TokenKind.EQUALS) ? this.delimitedMany(r2.TokenKind.PIPE, this.parseNamedType) : [];
            }, s2.parseEnumTypeDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("enum");
              var t2 = this.parseName(), u = this.parseDirectives(true), y = this.parseEnumValuesDefinition();
              return { kind: i2.Kind.ENUM_TYPE_DEFINITION, description: n, name: t2, directives: u, values: y, loc: this.loc(e2) };
            }, s2.parseEnumValuesDefinition = function() {
              return this.optionalMany(r2.TokenKind.BRACE_L, this.parseEnumValueDefinition, r2.TokenKind.BRACE_R);
            }, s2.parseEnumValueDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription(), t2 = this.parseName(), u = this.parseDirectives(true);
              return { kind: i2.Kind.ENUM_VALUE_DEFINITION, description: n, name: t2, directives: u, loc: this.loc(e2) };
            }, s2.parseInputObjectTypeDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("input");
              var t2 = this.parseName(), u = this.parseDirectives(true), y = this.parseInputFieldsDefinition();
              return { kind: i2.Kind.INPUT_OBJECT_TYPE_DEFINITION, description: n, name: t2, directives: u, fields: y, loc: this.loc(e2) };
            }, s2.parseInputFieldsDefinition = function() {
              return this.optionalMany(r2.TokenKind.BRACE_L, this.parseInputValueDef, r2.TokenKind.BRACE_R);
            }, s2.parseTypeSystemExtension = function() {
              var e2 = this._lexer.lookahead();
              if (e2.kind === r2.TokenKind.NAME)
                switch (e2.value) {
                  case "schema":
                    return this.parseSchemaExtension();
                  case "scalar":
                    return this.parseScalarTypeExtension();
                  case "type":
                    return this.parseObjectTypeExtension();
                  case "interface":
                    return this.parseInterfaceTypeExtension();
                  case "union":
                    return this.parseUnionTypeExtension();
                  case "enum":
                    return this.parseEnumTypeExtension();
                  case "input":
                    return this.parseInputObjectTypeExtension();
                }
              throw this.unexpected(e2);
            }, s2.parseSchemaExtension = function() {
              var e2 = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("schema");
              var n = this.parseDirectives(true), t2 = this.optionalMany(r2.TokenKind.BRACE_L, this.parseOperationTypeDefinition, r2.TokenKind.BRACE_R);
              if (n.length === 0 && t2.length === 0)
                throw this.unexpected();
              return { kind: i2.Kind.SCHEMA_EXTENSION, directives: n, operationTypes: t2, loc: this.loc(e2) };
            }, s2.parseScalarTypeExtension = function() {
              var e2 = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("scalar");
              var n = this.parseName(), t2 = this.parseDirectives(true);
              if (t2.length === 0)
                throw this.unexpected();
              return { kind: i2.Kind.SCALAR_TYPE_EXTENSION, name: n, directives: t2, loc: this.loc(e2) };
            }, s2.parseObjectTypeExtension = function() {
              var e2 = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("type");
              var n = this.parseName(), t2 = this.parseImplementsInterfaces(), u = this.parseDirectives(true), y = this.parseFieldsDefinition();
              if (t2.length === 0 && u.length === 0 && y.length === 0)
                throw this.unexpected();
              return { kind: i2.Kind.OBJECT_TYPE_EXTENSION, name: n, interfaces: t2, directives: u, fields: y, loc: this.loc(e2) };
            }, s2.parseInterfaceTypeExtension = function() {
              var e2 = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("interface");
              var n = this.parseName(), t2 = this.parseImplementsInterfaces(), u = this.parseDirectives(true), y = this.parseFieldsDefinition();
              if (t2.length === 0 && u.length === 0 && y.length === 0)
                throw this.unexpected();
              return { kind: i2.Kind.INTERFACE_TYPE_EXTENSION, name: n, interfaces: t2, directives: u, fields: y, loc: this.loc(e2) };
            }, s2.parseUnionTypeExtension = function() {
              var e2 = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("union");
              var n = this.parseName(), t2 = this.parseDirectives(true), u = this.parseUnionMemberTypes();
              if (t2.length === 0 && u.length === 0)
                throw this.unexpected();
              return { kind: i2.Kind.UNION_TYPE_EXTENSION, name: n, directives: t2, types: u, loc: this.loc(e2) };
            }, s2.parseEnumTypeExtension = function() {
              var e2 = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("enum");
              var n = this.parseName(), t2 = this.parseDirectives(true), u = this.parseEnumValuesDefinition();
              if (t2.length === 0 && u.length === 0)
                throw this.unexpected();
              return { kind: i2.Kind.ENUM_TYPE_EXTENSION, name: n, directives: t2, values: u, loc: this.loc(e2) };
            }, s2.parseInputObjectTypeExtension = function() {
              var e2 = this._lexer.token;
              this.expectKeyword("extend"), this.expectKeyword("input");
              var n = this.parseName(), t2 = this.parseDirectives(true), u = this.parseInputFieldsDefinition();
              if (t2.length === 0 && u.length === 0)
                throw this.unexpected();
              return { kind: i2.Kind.INPUT_OBJECT_TYPE_EXTENSION, name: n, directives: t2, fields: u, loc: this.loc(e2) };
            }, s2.parseDirectiveDefinition = function() {
              var e2 = this._lexer.token, n = this.parseDescription();
              this.expectKeyword("directive"), this.expectToken(r2.TokenKind.AT);
              var t2 = this.parseName(), u = this.parseArgumentDefs(), y = this.expectOptionalKeyword("repeatable");
              this.expectKeyword("on");
              var f3 = this.parseDirectiveLocations();
              return { kind: i2.Kind.DIRECTIVE_DEFINITION, description: n, name: t2, arguments: u, repeatable: y, locations: f3, loc: this.loc(e2) };
            }, s2.parseDirectiveLocations = function() {
              return this.delimitedMany(r2.TokenKind.PIPE, this.parseDirectiveLocation);
            }, s2.parseDirectiveLocation = function() {
              var e2 = this._lexer.token, n = this.parseName();
              if (E.DirectiveLocation[n.value] !== void 0)
                return n;
              throw this.unexpected(e2);
            }, s2.loc = function(e2) {
              var n;
              if (((n = this._options) === null || n === void 0 ? void 0 : n.noLocation) !== true)
                return new c.Location(e2, this._lexer.lastToken, this._lexer.source);
            }, s2.peek = function(e2) {
              return this._lexer.token.kind === e2;
            }, s2.expectToken = function(e2) {
              var n = this._lexer.token;
              if (n.kind === e2)
                return this._lexer.advance(), n;
              throw (0, d.syntaxError)(this._lexer.source, n.start, "Expected ".concat(v(e2), ", found ").concat(D(n), "."));
            }, s2.expectOptionalToken = function(e2) {
              var n = this._lexer.token;
              if (n.kind === e2)
                return this._lexer.advance(), n;
            }, s2.expectKeyword = function(e2) {
              var n = this._lexer.token;
              if (n.kind === r2.TokenKind.NAME && n.value === e2)
                this._lexer.advance();
              else
                throw (0, d.syntaxError)(this._lexer.source, n.start, 'Expected "'.concat(e2, '", found ').concat(D(n), "."));
            }, s2.expectOptionalKeyword = function(e2) {
              var n = this._lexer.token;
              return n.kind === r2.TokenKind.NAME && n.value === e2 ? (this._lexer.advance(), true) : false;
            }, s2.unexpected = function(e2) {
              var n = e2 != null ? e2 : this._lexer.token;
              return (0, d.syntaxError)(this._lexer.source, n.start, "Unexpected ".concat(D(n), "."));
            }, s2.any = function(e2, n, t2) {
              this.expectToken(e2);
              for (var u = []; !this.expectOptionalToken(t2); )
                u.push(n.call(this));
              return u;
            }, s2.optionalMany = function(e2, n, t2) {
              if (this.expectOptionalToken(e2)) {
                var u = [];
                do
                  u.push(n.call(this));
                while (!this.expectOptionalToken(t2));
                return u;
              }
              return [];
            }, s2.many = function(e2, n, t2) {
              this.expectToken(e2);
              var u = [];
              do
                u.push(n.call(this));
              while (!this.expectOptionalToken(t2));
              return u;
            }, s2.delimitedMany = function(e2, n) {
              this.expectOptionalToken(e2);
              var t2 = [];
              do
                t2.push(n.call(this));
              while (this.expectOptionalToken(e2));
              return t2;
            }, I;
          }();
          a.Parser = g;
          function D(I) {
            var s2 = I.value;
            return v(I.kind) + (s2 != null ? ' "'.concat(s2, '"') : "");
          }
          function v(I) {
            return (0, k.isPunctuatorTokenKind)(I) ? '"'.concat(I, '"') : I;
          }
        } });
        K();
        var Ie = ce(), ge = ue(), { hasPragma: Se } = le(), { locStart: Ae, locEnd: De } = pe();
        function Ke(a) {
          let d = [], { startToken: i2 } = a.loc, { next: c } = i2;
          for (; c.kind !== "<EOF>"; )
            c.kind === "Comment" && (Object.assign(c, { column: c.column - 1 }), d.push(c)), c = c.next;
          return d;
        }
        function ie(a) {
          if (a && typeof a == "object") {
            delete a.startToken, delete a.endToken, delete a.prev, delete a.next;
            for (let d in a)
              ie(a[d]);
          }
          return a;
        }
        var X = { allowLegacySDLImplementsInterfaces: false, experimentalFragmentVariables: true };
        function Le(a) {
          let { GraphQLError: d } = W();
          if (a instanceof d) {
            let { message: i2, locations: [c] } = a;
            return Ie(i2, { start: c });
          }
          return a;
        }
        function xe(a) {
          let { parse: d } = Oe(), { result: i2, error: c } = ge(() => d(a, Object.assign({}, X)), () => d(a, Object.assign(Object.assign({}, X), {}, { allowLegacySDLImplementsInterfaces: true })));
          if (!i2)
            throw Le(c);
          return i2.comments = Ke(i2), ie(i2), i2;
        }
        ae.exports = { parsers: { graphql: { parse: xe, astFormat: "graphql", hasPragma: Se, locStart: Ae, locEnd: De } } };
      });
      return be();
    });
  }
});

// node_modules/prettier/parser-markdown.js
var require_parser_markdown = __commonJS({
  "node_modules/prettier/parser-markdown.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.markdown = e2();
      }
    })(function() {
      "use strict";
      var H = (e2, r2) => () => (r2 || e2((r2 = { exports: {} }).exports, r2), r2.exports);
      var ue = H((uf, Au) => {
        var ur = function(e2) {
          return e2 && e2.Math == Math && e2;
        };
        Au.exports = ur(typeof globalThis == "object" && globalThis) || ur(typeof window == "object" && window) || ur(typeof self == "object" && self) || ur(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      });
      var Ae = H((tf, xu) => {
        xu.exports = function(e2) {
          try {
            return !!e2();
          } catch {
            return true;
          }
        };
      });
      var _e = H((nf, bu) => {
        var ca = Ae();
        bu.exports = !ca(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var tr = H((af, yu) => {
        var la = Ae();
        yu.exports = !la(function() {
          var e2 = function() {
          }.bind();
          return typeof e2 != "function" || e2.hasOwnProperty("prototype");
        });
      });
      var Oe = H((of, Bu) => {
        var Da = tr(), nr = Function.prototype.call;
        Bu.exports = Da ? nr.bind(nr) : function() {
          return nr.apply(nr, arguments);
        };
      });
      var _u = H((qu) => {
        "use strict";
        var wu = {}.propertyIsEnumerable, ku = Object.getOwnPropertyDescriptor, fa = ku && !wu.call({ 1: 2 }, 1);
        qu.f = fa ? function(r2) {
          var u = ku(this, r2);
          return !!u && u.enumerable;
        } : wu;
      });
      var ir = H((cf, Ou) => {
        Ou.exports = function(e2, r2) {
          return { enumerable: !(e2 & 1), configurable: !(e2 & 2), writable: !(e2 & 4), value: r2 };
        };
      });
      var ve = H((lf, Tu) => {
        var Iu = tr(), Su = Function.prototype, pa = Su.bind, Br = Su.call, da = Iu && pa.bind(Br, Br);
        Tu.exports = Iu ? function(e2) {
          return e2 && da(e2);
        } : function(e2) {
          return e2 && function() {
            return Br.apply(e2, arguments);
          };
        };
      });
      var ar = H((Df, Lu) => {
        var Nu = ve(), ha = Nu({}.toString), va = Nu("".slice);
        Lu.exports = function(e2) {
          return va(ha(e2), 8, -1);
        };
      });
      var ju = H((ff, Ru) => {
        var ma = ue(), Ea = ve(), Ca = Ae(), ga = ar(), wr = ma.Object, Fa = Ea("".split);
        Ru.exports = Ca(function() {
          return !wr("z").propertyIsEnumerable(0);
        }) ? function(e2) {
          return ga(e2) == "String" ? Fa(e2, "") : wr(e2);
        } : wr;
      });
      var kr = H((pf, Pu) => {
        var Aa = ue(), xa = Aa.TypeError;
        Pu.exports = function(e2) {
          if (e2 == null)
            throw xa("Can't call method on " + e2);
          return e2;
        };
      });
      var or = H((df, Mu) => {
        var ba = ju(), ya = kr();
        Mu.exports = function(e2) {
          return ba(ya(e2));
        };
      });
      var me = H((hf, zu) => {
        zu.exports = function(e2) {
          return typeof e2 == "function";
        };
      });
      var Ie = H((vf, Gu) => {
        var Ba = me();
        Gu.exports = function(e2) {
          return typeof e2 == "object" ? e2 !== null : Ba(e2);
        };
      });
      var He = H((mf, Uu) => {
        var qr = ue(), wa = me(), ka = function(e2) {
          return wa(e2) ? e2 : void 0;
        };
        Uu.exports = function(e2, r2) {
          return arguments.length < 2 ? ka(qr[e2]) : qr[e2] && qr[e2][r2];
        };
      });
      var _r = H((Ef, Vu) => {
        var qa = ve();
        Vu.exports = qa({}.isPrototypeOf);
      });
      var Hu = H((Cf, $u) => {
        var _a4 = He();
        $u.exports = _a4("navigator", "userAgent") || "";
      });
      var Qu = H((gf, Zu) => {
        var Ju = ue(), Or = Hu(), Xu = Ju.process, Wu = Ju.Deno, Ku = Xu && Xu.versions || Wu && Wu.version, Yu = Ku && Ku.v8, Ee, sr;
        Yu && (Ee = Yu.split("."), sr = Ee[0] > 0 && Ee[0] < 4 ? 1 : +(Ee[0] + Ee[1]));
        !sr && Or && (Ee = Or.match(/Edge\/(\d+)/), (!Ee || Ee[1] >= 74) && (Ee = Or.match(/Chrome\/(\d+)/), Ee && (sr = +Ee[1])));
        Zu.exports = sr;
      });
      var Ir = H((Ff, rt) => {
        var et = Qu(), Oa = Ae();
        rt.exports = !!Object.getOwnPropertySymbols && !Oa(function() {
          var e2 = Symbol();
          return !String(e2) || !(Object(e2) instanceof Symbol) || !Symbol.sham && et && et < 41;
        });
      });
      var Sr = H((Af, ut) => {
        var Ia = Ir();
        ut.exports = Ia && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var Tr = H((xf, tt) => {
        var Sa = ue(), Ta = He(), Na = me(), La = _r(), Ra = Sr(), ja = Sa.Object;
        tt.exports = Ra ? function(e2) {
          return typeof e2 == "symbol";
        } : function(e2) {
          var r2 = Ta("Symbol");
          return Na(r2) && La(r2.prototype, ja(e2));
        };
      });
      var cr = H((bf, nt) => {
        var Pa = ue(), Ma = Pa.String;
        nt.exports = function(e2) {
          try {
            return Ma(e2);
          } catch {
            return "Object";
          }
        };
      });
      var Xe = H((yf, it) => {
        var za = ue(), Ga = me(), Ua = cr(), Va = za.TypeError;
        it.exports = function(e2) {
          if (Ga(e2))
            return e2;
          throw Va(Ua(e2) + " is not a function");
        };
      });
      var lr = H((Bf, at) => {
        var $a = Xe();
        at.exports = function(e2, r2) {
          var u = e2[r2];
          return u == null ? void 0 : $a(u);
        };
      });
      var st = H((wf, ot) => {
        var Ha = ue(), Nr = Oe(), Lr = me(), Rr = Ie(), Xa = Ha.TypeError;
        ot.exports = function(e2, r2) {
          var u, t2;
          if (r2 === "string" && Lr(u = e2.toString) && !Rr(t2 = Nr(u, e2)) || Lr(u = e2.valueOf) && !Rr(t2 = Nr(u, e2)) || r2 !== "string" && Lr(u = e2.toString) && !Rr(t2 = Nr(u, e2)))
            return t2;
          throw Xa("Can't convert object to primitive value");
        };
      });
      var lt = H((kf, ct) => {
        ct.exports = false;
      });
      var Dr = H((qf, ft) => {
        var Dt = ue(), Wa = Object.defineProperty;
        ft.exports = function(e2, r2) {
          try {
            Wa(Dt, e2, { value: r2, configurable: true, writable: true });
          } catch {
            Dt[e2] = r2;
          }
          return r2;
        };
      });
      var fr = H((_f, dt) => {
        var Ka = ue(), Ya = Dr(), pt = "__core-js_shared__", Ja = Ka[pt] || Ya(pt, {});
        dt.exports = Ja;
      });
      var jr = H((Of, vt) => {
        var Za = lt(), ht = fr();
        (vt.exports = function(e2, r2) {
          return ht[e2] || (ht[e2] = r2 !== void 0 ? r2 : {});
        })("versions", []).push({ version: "3.22.2", mode: Za ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var Pr = H((If, mt) => {
        var Qa = ue(), eo = kr(), ro = Qa.Object;
        mt.exports = function(e2) {
          return ro(eo(e2));
        };
      });
      var Be = H((Sf, Et) => {
        var uo = ve(), to = Pr(), no = uo({}.hasOwnProperty);
        Et.exports = Object.hasOwn || function(r2, u) {
          return no(to(r2), u);
        };
      });
      var Mr = H((Tf, Ct) => {
        var io = ve(), ao = 0, oo = Math.random(), so = io(1 .toString);
        Ct.exports = function(e2) {
          return "Symbol(" + (e2 === void 0 ? "" : e2) + ")_" + so(++ao + oo, 36);
        };
      });
      var Te = H((Nf, bt) => {
        var co = ue(), lo = jr(), gt = Be(), Do = Mr(), Ft = Ir(), xt = Sr(), Le = lo("wks"), Se = co.Symbol, At = Se && Se.for, fo = xt ? Se : Se && Se.withoutSetter || Do;
        bt.exports = function(e2) {
          if (!gt(Le, e2) || !(Ft || typeof Le[e2] == "string")) {
            var r2 = "Symbol." + e2;
            Ft && gt(Se, e2) ? Le[e2] = Se[e2] : xt && At ? Le[e2] = At(r2) : Le[e2] = fo(r2);
          }
          return Le[e2];
        };
      });
      var kt = H((Lf, wt) => {
        var po = ue(), ho = Oe(), yt = Ie(), Bt = Tr(), vo = lr(), mo = st(), Eo = Te(), Co = po.TypeError, go = Eo("toPrimitive");
        wt.exports = function(e2, r2) {
          if (!yt(e2) || Bt(e2))
            return e2;
          var u = vo(e2, go), t2;
          if (u) {
            if (r2 === void 0 && (r2 = "default"), t2 = ho(u, e2, r2), !yt(t2) || Bt(t2))
              return t2;
            throw Co("Can't convert object to primitive value");
          }
          return r2 === void 0 && (r2 = "number"), mo(e2, r2);
        };
      });
      var pr = H((Rf, qt) => {
        var Fo = kt(), Ao = Tr();
        qt.exports = function(e2) {
          var r2 = Fo(e2, "string");
          return Ao(r2) ? r2 : r2 + "";
        };
      });
      var It = H((jf, Ot) => {
        var xo = ue(), _t = Ie(), zr = xo.document, bo = _t(zr) && _t(zr.createElement);
        Ot.exports = function(e2) {
          return bo ? zr.createElement(e2) : {};
        };
      });
      var Gr = H((Pf, St) => {
        var yo = _e(), Bo = Ae(), wo = It();
        St.exports = !yo && !Bo(function() {
          return Object.defineProperty(wo("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var Ur = H((Nt) => {
        var ko = _e(), qo = Oe(), _o = _u(), Oo = ir(), Io = or(), So = pr(), To = Be(), No = Gr(), Tt = Object.getOwnPropertyDescriptor;
        Nt.f = ko ? Tt : function(r2, u) {
          if (r2 = Io(r2), u = So(u), No)
            try {
              return Tt(r2, u);
            } catch {
            }
          if (To(r2, u))
            return Oo(!qo(_o.f, r2, u), r2[u]);
        };
      });
      var Rt = H((zf, Lt) => {
        var Lo = _e(), Ro = Ae();
        Lt.exports = Lo && Ro(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var Re = H((Gf, Pt) => {
        var jt = ue(), jo = Ie(), Po = jt.String, Mo = jt.TypeError;
        Pt.exports = function(e2) {
          if (jo(e2))
            return e2;
          throw Mo(Po(e2) + " is not an object");
        };
      });
      var hr = H((zt) => {
        var zo = ue(), Go = _e(), Uo = Gr(), Vo = Rt(), dr = Re(), Mt = pr(), $o = zo.TypeError, Vr = Object.defineProperty, Ho = Object.getOwnPropertyDescriptor, $r = "enumerable", Hr = "configurable", Xr = "writable";
        zt.f = Go ? Vo ? function(r2, u, t2) {
          if (dr(r2), u = Mt(u), dr(t2), typeof r2 == "function" && u === "prototype" && "value" in t2 && Xr in t2 && !t2[Xr]) {
            var o = Ho(r2, u);
            o && o[Xr] && (r2[u] = t2.value, t2 = { configurable: Hr in t2 ? t2[Hr] : o[Hr], enumerable: $r in t2 ? t2[$r] : o[$r], writable: false });
          }
          return Vr(r2, u, t2);
        } : Vr : function(r2, u, t2) {
          if (dr(r2), u = Mt(u), dr(t2), Uo)
            try {
              return Vr(r2, u, t2);
            } catch {
            }
          if ("get" in t2 || "set" in t2)
            throw $o("Accessors not supported");
          return "value" in t2 && (r2[u] = t2.value), r2;
        };
      });
      var vr = H((Vf, Gt) => {
        var Xo = _e(), Wo = hr(), Ko = ir();
        Gt.exports = Xo ? function(e2, r2, u) {
          return Wo.f(e2, r2, Ko(1, u));
        } : function(e2, r2, u) {
          return e2[r2] = u, e2;
        };
      });
      var mr = H(($f, Ut) => {
        var Yo = ve(), Jo = me(), Wr = fr(), Zo = Yo(Function.toString);
        Jo(Wr.inspectSource) || (Wr.inspectSource = function(e2) {
          return Zo(e2);
        });
        Ut.exports = Wr.inspectSource;
      });
      var Ht = H((Hf, $t) => {
        var Qo = ue(), es = me(), rs = mr(), Vt = Qo.WeakMap;
        $t.exports = es(Vt) && /native code/.test(rs(Vt));
      });
      var Kt = H((Xf, Wt) => {
        var us = jr(), ts = Mr(), Xt = us("keys");
        Wt.exports = function(e2) {
          return Xt[e2] || (Xt[e2] = ts(e2));
        };
      });
      var Kr = H((Wf, Yt) => {
        Yt.exports = {};
      });
      var un = H((Kf, rn) => {
        var ns = Ht(), en = ue(), Yr = ve(), is = Ie(), as = vr(), Jr = Be(), Zr = fr(), os = Kt(), ss = Kr(), Jt = "Object already initialized", eu = en.TypeError, cs = en.WeakMap, Er, We, Cr, ls = function(e2) {
          return Cr(e2) ? We(e2) : Er(e2, {});
        }, Ds = function(e2) {
          return function(r2) {
            var u;
            if (!is(r2) || (u = We(r2)).type !== e2)
              throw eu("Incompatible receiver, " + e2 + " required");
            return u;
          };
        };
        ns || Zr.state ? (we = Zr.state || (Zr.state = new cs()), Zt = Yr(we.get), Qr = Yr(we.has), Qt = Yr(we.set), Er = function(e2, r2) {
          if (Qr(we, e2))
            throw new eu(Jt);
          return r2.facade = e2, Qt(we, e2, r2), r2;
        }, We = function(e2) {
          return Zt(we, e2) || {};
        }, Cr = function(e2) {
          return Qr(we, e2);
        }) : (Ne = os("state"), ss[Ne] = true, Er = function(e2, r2) {
          if (Jr(e2, Ne))
            throw new eu(Jt);
          return r2.facade = e2, as(e2, Ne, r2), r2;
        }, We = function(e2) {
          return Jr(e2, Ne) ? e2[Ne] : {};
        }, Cr = function(e2) {
          return Jr(e2, Ne);
        });
        var we, Zt, Qr, Qt, Ne;
        rn.exports = { set: Er, get: We, has: Cr, enforce: ls, getterFor: Ds };
      });
      var an = H((Yf, nn) => {
        var ru = _e(), fs4 = Be(), tn = Function.prototype, ps = ru && Object.getOwnPropertyDescriptor, uu = fs4(tn, "name"), ds = uu && function() {
        }.name === "something", hs = uu && (!ru || ru && ps(tn, "name").configurable);
        nn.exports = { EXISTS: uu, PROPER: ds, CONFIGURABLE: hs };
      });
      var Dn = H((Jf, ln) => {
        var vs = ue(), on = me(), ms = Be(), sn = vr(), Es = Dr(), Cs = mr(), cn = un(), gs = an().CONFIGURABLE, Fs = cn.get, As = cn.enforce, xs = String(String).split("String");
        (ln.exports = function(e2, r2, u, t2) {
          var o = t2 ? !!t2.unsafe : false, n = t2 ? !!t2.enumerable : false, s2 = t2 ? !!t2.noTargetGet : false, c = t2 && t2.name !== void 0 ? t2.name : r2, i2;
          if (on(u) && (String(c).slice(0, 7) === "Symbol(" && (c = "[" + String(c).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!ms(u, "name") || gs && u.name !== c) && sn(u, "name", c), i2 = As(u), i2.source || (i2.source = xs.join(typeof c == "string" ? c : ""))), e2 === vs) {
            n ? e2[r2] = u : Es(r2, u);
            return;
          } else
            o ? !s2 && e2[r2] && (n = true) : delete e2[r2];
          n ? e2[r2] = u : sn(e2, r2, u);
        })(Function.prototype, "toString", function() {
          return on(this) && Fs(this).source || Cs(this);
        });
      });
      var tu = H((Zf, fn) => {
        var bs = Math.ceil, ys = Math.floor;
        fn.exports = function(e2) {
          var r2 = +e2;
          return r2 !== r2 || r2 === 0 ? 0 : (r2 > 0 ? ys : bs)(r2);
        };
      });
      var dn = H((Qf, pn) => {
        var Bs = tu(), ws = Math.max, ks = Math.min;
        pn.exports = function(e2, r2) {
          var u = Bs(e2);
          return u < 0 ? ws(u + r2, 0) : ks(u, r2);
        };
      });
      var vn = H((ep, hn) => {
        var qs = tu(), _s = Math.min;
        hn.exports = function(e2) {
          return e2 > 0 ? _s(qs(e2), 9007199254740991) : 0;
        };
      });
      var Ke = H((rp, mn) => {
        var Os = vn();
        mn.exports = function(e2) {
          return Os(e2.length);
        };
      });
      var gn = H((up, Cn) => {
        var Is = or(), Ss = dn(), Ts = Ke(), En = function(e2) {
          return function(r2, u, t2) {
            var o = Is(r2), n = Ts(o), s2 = Ss(t2, n), c;
            if (e2 && u != u) {
              for (; n > s2; )
                if (c = o[s2++], c != c)
                  return true;
            } else
              for (; n > s2; s2++)
                if ((e2 || s2 in o) && o[s2] === u)
                  return e2 || s2 || 0;
            return !e2 && -1;
          };
        };
        Cn.exports = { includes: En(true), indexOf: En(false) };
      });
      var xn = H((tp, An) => {
        var Ns = ve(), nu = Be(), Ls = or(), Rs = gn().indexOf, js = Kr(), Fn = Ns([].push);
        An.exports = function(e2, r2) {
          var u = Ls(e2), t2 = 0, o = [], n;
          for (n in u)
            !nu(js, n) && nu(u, n) && Fn(o, n);
          for (; r2.length > t2; )
            nu(u, n = r2[t2++]) && (~Rs(o, n) || Fn(o, n));
          return o;
        };
      });
      var yn = H((np, bn) => {
        bn.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var wn = H((Bn) => {
        var Ps = xn(), Ms = yn(), zs = Ms.concat("length", "prototype");
        Bn.f = Object.getOwnPropertyNames || function(r2) {
          return Ps(r2, zs);
        };
      });
      var qn = H((kn) => {
        kn.f = Object.getOwnPropertySymbols;
      });
      var On = H((op, _n) => {
        var Gs = He(), Us = ve(), Vs = wn(), $s = qn(), Hs = Re(), Xs = Us([].concat);
        _n.exports = Gs("Reflect", "ownKeys") || function(r2) {
          var u = Vs.f(Hs(r2)), t2 = $s.f;
          return t2 ? Xs(u, t2(r2)) : u;
        };
      });
      var Tn = H((sp, Sn) => {
        var In = Be(), Ws = On(), Ks = Ur(), Ys = hr();
        Sn.exports = function(e2, r2, u) {
          for (var t2 = Ws(r2), o = Ys.f, n = Ks.f, s2 = 0; s2 < t2.length; s2++) {
            var c = t2[s2];
            !In(e2, c) && !(u && In(u, c)) && o(e2, c, n(r2, c));
          }
        };
      });
      var Ln = H((cp, Nn) => {
        var Js = Ae(), Zs = me(), Qs = /#|\.prototype\./, Ye = function(e2, r2) {
          var u = rc[ec(e2)];
          return u == tc ? true : u == uc ? false : Zs(r2) ? Js(r2) : !!r2;
        }, ec = Ye.normalize = function(e2) {
          return String(e2).replace(Qs, ".").toLowerCase();
        }, rc = Ye.data = {}, uc = Ye.NATIVE = "N", tc = Ye.POLYFILL = "P";
        Nn.exports = Ye;
      });
      var au = H((lp, Rn) => {
        var iu = ue(), nc = Ur().f, ic = vr(), ac = Dn(), oc = Dr(), sc = Tn(), cc = Ln();
        Rn.exports = function(e2, r2) {
          var u = e2.target, t2 = e2.global, o = e2.stat, n, s2, c, i2, D, a;
          if (t2 ? s2 = iu : o ? s2 = iu[u] || oc(u, {}) : s2 = (iu[u] || {}).prototype, s2)
            for (c in r2) {
              if (D = r2[c], e2.noTargetGet ? (a = nc(s2, c), i2 = a && a.value) : i2 = s2[c], n = cc(t2 ? c : u + (o ? "." : "#") + c, e2.forced), !n && i2 !== void 0) {
                if (typeof D == typeof i2)
                  continue;
                sc(D, i2);
              }
              (e2.sham || i2 && i2.sham) && ic(D, "sham", true), ac(s2, c, D, e2);
            }
        };
      });
      var ou = H((Dp, jn) => {
        var lc = ar();
        jn.exports = Array.isArray || function(r2) {
          return lc(r2) == "Array";
        };
      });
      var su = H((fp, Mn) => {
        var Pn = ve(), Dc = Xe(), fc = tr(), pc = Pn(Pn.bind);
        Mn.exports = function(e2, r2) {
          return Dc(e2), r2 === void 0 ? e2 : fc ? pc(e2, r2) : function() {
            return e2.apply(r2, arguments);
          };
        };
      });
      var Un = H((pp, Gn) => {
        "use strict";
        var dc = ue(), hc = ou(), vc = Ke(), mc = su(), Ec = dc.TypeError, zn = function(e2, r2, u, t2, o, n, s2, c) {
          for (var i2 = o, D = 0, a = s2 ? mc(s2, c) : false, l, p; D < t2; ) {
            if (D in u) {
              if (l = a ? a(u[D], D, r2) : u[D], n > 0 && hc(l))
                p = vc(l), i2 = zn(e2, r2, l, p, i2, n - 1) - 1;
              else {
                if (i2 >= 9007199254740991)
                  throw Ec("Exceed the acceptable array length");
                e2[i2] = l;
              }
              i2++;
            }
            D++;
          }
          return i2;
        };
        Gn.exports = zn;
      });
      var Hn = H((dp, $n) => {
        var Cc = Te(), gc = Cc("toStringTag"), Vn = {};
        Vn[gc] = "z";
        $n.exports = String(Vn) === "[object z]";
      });
      var cu = H((hp, Xn) => {
        var Fc = ue(), Ac = Hn(), xc = me(), gr = ar(), bc = Te(), yc = bc("toStringTag"), Bc = Fc.Object, wc = gr(function() {
          return arguments;
        }()) == "Arguments", kc = function(e2, r2) {
          try {
            return e2[r2];
          } catch {
          }
        };
        Xn.exports = Ac ? gr : function(e2) {
          var r2, u, t2;
          return e2 === void 0 ? "Undefined" : e2 === null ? "Null" : typeof (u = kc(r2 = Bc(e2), yc)) == "string" ? u : wc ? gr(r2) : (t2 = gr(r2)) == "Object" && xc(r2.callee) ? "Arguments" : t2;
        };
      });
      var Qn = H((vp, Zn) => {
        var qc = ve(), _c = Ae(), Wn = me(), Oc = cu(), Ic = He(), Sc = mr(), Kn = function() {
        }, Tc = [], Yn = Ic("Reflect", "construct"), lu = /^\s*(?:class|function)\b/, Nc = qc(lu.exec), Lc = !lu.exec(Kn), Je = function(r2) {
          if (!Wn(r2))
            return false;
          try {
            return Yn(Kn, Tc, r2), true;
          } catch {
            return false;
          }
        }, Jn = function(r2) {
          if (!Wn(r2))
            return false;
          switch (Oc(r2)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return Lc || !!Nc(lu, Sc(r2));
          } catch {
            return true;
          }
        };
        Jn.sham = true;
        Zn.exports = !Yn || _c(function() {
          var e2;
          return Je(Je.call) || !Je(Object) || !Je(function() {
            e2 = true;
          }) || e2;
        }) ? Jn : Je;
      });
      var ti = H((mp, ui) => {
        var Rc = ue(), ei = ou(), jc = Qn(), Pc = Ie(), Mc = Te(), zc = Mc("species"), ri = Rc.Array;
        ui.exports = function(e2) {
          var r2;
          return ei(e2) && (r2 = e2.constructor, jc(r2) && (r2 === ri || ei(r2.prototype)) ? r2 = void 0 : Pc(r2) && (r2 = r2[zc], r2 === null && (r2 = void 0))), r2 === void 0 ? ri : r2;
        };
      });
      var ii = H((Ep, ni) => {
        var Gc = ti();
        ni.exports = function(e2, r2) {
          return new (Gc(e2))(r2 === 0 ? 0 : r2);
        };
      });
      var ai = H(() => {
        "use strict";
        var Uc = au(), Vc = Un(), $c = Xe(), Hc = Pr(), Xc = Ke(), Wc = ii();
        Uc({ target: "Array", proto: true }, { flatMap: function(r2) {
          var u = Hc(this), t2 = Xc(u), o;
          return $c(r2), o = Wc(u, 0), o.length = Vc(o, u, u, t2, 0, 1, r2, arguments.length > 1 ? arguments[1] : void 0), o;
        } });
      });
      var Du = H((Fp, oi) => {
        oi.exports = {};
      });
      var ci = H((Ap, si) => {
        var Kc = Te(), Yc = Du(), Jc = Kc("iterator"), Zc = Array.prototype;
        si.exports = function(e2) {
          return e2 !== void 0 && (Yc.Array === e2 || Zc[Jc] === e2);
        };
      });
      var fu = H((xp, Di) => {
        var Qc = cu(), li = lr(), el = Du(), rl = Te(), ul = rl("iterator");
        Di.exports = function(e2) {
          if (e2 != null)
            return li(e2, ul) || li(e2, "@@iterator") || el[Qc(e2)];
        };
      });
      var pi = H((bp, fi) => {
        var tl = ue(), nl = Oe(), il = Xe(), al = Re(), ol = cr(), sl = fu(), cl = tl.TypeError;
        fi.exports = function(e2, r2) {
          var u = arguments.length < 2 ? sl(e2) : r2;
          if (il(u))
            return al(nl(u, e2));
          throw cl(ol(e2) + " is not iterable");
        };
      });
      var vi = H((yp, hi) => {
        var ll = Oe(), di = Re(), Dl = lr();
        hi.exports = function(e2, r2, u) {
          var t2, o;
          di(e2);
          try {
            if (t2 = Dl(e2, "return"), !t2) {
              if (r2 === "throw")
                throw u;
              return u;
            }
            t2 = ll(t2, e2);
          } catch (n) {
            o = true, t2 = n;
          }
          if (r2 === "throw")
            throw u;
          if (o)
            throw t2;
          return di(t2), u;
        };
      });
      var Fi = H((Bp, gi) => {
        var fl = ue(), pl = su(), dl = Oe(), hl = Re(), vl = cr(), ml = ci(), El = Ke(), mi = _r(), Cl = pi(), gl = fu(), Ei = vi(), Fl = fl.TypeError, Fr = function(e2, r2) {
          this.stopped = e2, this.result = r2;
        }, Ci = Fr.prototype;
        gi.exports = function(e2, r2, u) {
          var t2 = u && u.that, o = !!(u && u.AS_ENTRIES), n = !!(u && u.IS_ITERATOR), s2 = !!(u && u.INTERRUPTED), c = pl(r2, t2), i2, D, a, l, p, d, g, F2 = function(x2) {
            return i2 && Ei(i2, "normal", x2), new Fr(true, x2);
          }, E = function(x2) {
            return o ? (hl(x2), s2 ? c(x2[0], x2[1], F2) : c(x2[0], x2[1])) : s2 ? c(x2, F2) : c(x2);
          };
          if (n)
            i2 = e2;
          else {
            if (D = gl(e2), !D)
              throw Fl(vl(e2) + " is not iterable");
            if (ml(D)) {
              for (a = 0, l = El(e2); l > a; a++)
                if (p = E(e2[a]), p && mi(Ci, p))
                  return p;
              return new Fr(false);
            }
            i2 = Cl(e2, D);
          }
          for (d = i2.next; !(g = dl(d, i2)).done; ) {
            try {
              p = E(g.value);
            } catch (x2) {
              Ei(i2, "throw", x2);
            }
            if (typeof p == "object" && p && mi(Ci, p))
              return p;
          }
          return new Fr(false);
        };
      });
      var xi = H((wp, Ai) => {
        "use strict";
        var Al = pr(), xl = hr(), bl = ir();
        Ai.exports = function(e2, r2, u) {
          var t2 = Al(r2);
          t2 in e2 ? xl.f(e2, t2, bl(0, u)) : e2[t2] = u;
        };
      });
      var bi = H(() => {
        var yl = au(), Bl = Fi(), wl = xi();
        yl({ target: "Object", stat: true }, { fromEntries: function(r2) {
          var u = {};
          return Bl(r2, function(t2, o) {
            wl(u, t2, o);
          }, { AS_ENTRIES: true }), u;
        } });
      });
      var ef = H((_p, oa) => {
        var kl = ["cliName", "cliCategory", "cliDescription"], yi, Bi, wi, ki, qi, _i;
        function ql(e3, r3) {
          if (e3 == null)
            return {};
          var u = _l(e3, r3), t3, o;
          if (Object.getOwnPropertySymbols) {
            var n = Object.getOwnPropertySymbols(e3);
            for (o = 0; o < n.length; o++)
              t3 = n[o], !(r3.indexOf(t3) >= 0) && (!Object.prototype.propertyIsEnumerable.call(e3, t3) || (u[t3] = e3[t3]));
          }
          return u;
        }
        function _l(e3, r3) {
          if (e3 == null)
            return {};
          var u = {}, t3 = Object.keys(e3), o, n;
          for (n = 0; n < t3.length; n++)
            o = t3[n], !(r3.indexOf(o) >= 0) && (u[o] = e3[o]);
          return u;
        }
        ai();
        bi();
        function je(e3, r3) {
          return r3 || (r3 = e3.slice(0)), Object.freeze(Object.defineProperties(e3, { raw: { value: Object.freeze(r3) } }));
        }
        var Ol = Object.create, Ar = Object.defineProperty, Il = Object.getOwnPropertyDescriptor, pu = Object.getOwnPropertyNames, Sl = Object.getPrototypeOf, Tl = Object.prototype.hasOwnProperty, Pe = (e3, r3) => function() {
          return e3 && (r3 = (0, e3[pu(e3)[0]])(e3 = 0)), r3;
        }, S2 = (e3, r3) => function() {
          return r3 || (0, e3[pu(e3)[0]])((r3 = { exports: {} }).exports, r3), r3.exports;
        }, Li = (e3, r3) => {
          for (var u in r3)
            Ar(e3, u, { get: r3[u], enumerable: true });
        }, Ri = (e3, r3, u, t3) => {
          if (r3 && typeof r3 == "object" || typeof r3 == "function")
            for (let o of pu(r3))
              !Tl.call(e3, o) && o !== u && Ar(e3, o, { get: () => r3[o], enumerable: !(t3 = Il(r3, o)) || t3.enumerable });
          return e3;
        }, Nl = (e3, r3, u) => (u = e3 != null ? Ol(Sl(e3)) : {}, Ri(r3 || !e3 || !e3.__esModule ? Ar(u, "default", { value: e3, enumerable: true }) : u, e3)), ji = (e3) => Ri(Ar({}, "__esModule", { value: true }), e3), Oi, Ii, Ze, I = Pe({ "<define:process>"() {
          Oi = {}, Ii = [], Ze = { env: Oi, argv: Ii };
        } }), Me = S2({ "node_modules/xtend/immutable.js"(e3, r3) {
          I(), r3.exports = t3;
          var u = Object.prototype.hasOwnProperty;
          function t3() {
            for (var o = {}, n = 0; n < arguments.length; n++) {
              var s3 = arguments[n];
              for (var c in s3)
                u.call(s3, c) && (o[c] = s3[c]);
            }
            return o;
          }
        } }), Ll = S2({ "node_modules/inherits/inherits_browser.js"(e3, r3) {
          I(), typeof Object.create == "function" ? r3.exports = function(t3, o) {
            o && (t3.super_ = o, t3.prototype = Object.create(o.prototype, { constructor: { value: t3, enumerable: false, writable: true, configurable: true } }));
          } : r3.exports = function(t3, o) {
            if (o) {
              t3.super_ = o;
              var n = function() {
              };
              n.prototype = o.prototype, t3.prototype = new n(), t3.prototype.constructor = t3;
            }
          };
        } }), Rl = S2({ "node_modules/unherit/index.js"(e3, r3) {
          "use strict";
          I();
          var u = Me(), t3 = Ll();
          r3.exports = o;
          function o(n) {
            var s3, c, i3;
            t3(a, n), t3(D, a), s3 = a.prototype;
            for (c in s3)
              i3 = s3[c], i3 && typeof i3 == "object" && (s3[c] = "concat" in i3 ? i3.concat() : u(i3));
            return a;
            function D(l) {
              return n.apply(this, l);
            }
            function a() {
              return this instanceof a ? n.apply(this, arguments) : new D(arguments);
            }
          }
        } }), jl = S2({ "node_modules/state-toggle/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o, n) {
            return s3;
            function s3() {
              var c = n || this, i3 = c[t3];
              return c[t3] = !o, D;
              function D() {
                c[t3] = i3;
              }
            }
          }
        } }), Pl = S2({ "node_modules/vfile-location/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3) {
            for (var o = String(t3), n = [], s3 = /\r?\n|\r/g; s3.exec(o); )
              n.push(s3.lastIndex);
            return n.push(o.length + 1), { toPoint: c, toPosition: c, toOffset: i3 };
            function c(D) {
              var a = -1;
              if (D > -1 && D < n[n.length - 1]) {
                for (; ++a < n.length; )
                  if (n[a] > D)
                    return { line: a + 1, column: D - (n[a - 1] || 0) + 1, offset: D };
              }
              return {};
            }
            function i3(D) {
              var a = D && D.line, l = D && D.column, p;
              return !isNaN(a) && !isNaN(l) && a - 1 in n && (p = (n[a - 2] || 0) + l - 1 || 0), p > -1 && p < n[n.length - 1] ? p : -1;
            }
          }
        } }), Ml = S2({ "node_modules/remark-parse/lib/unescape.js"(e3, r3) {
          "use strict";
          I(), r3.exports = t3;
          var u = "\\";
          function t3(o, n) {
            return s3;
            function s3(c) {
              for (var i3 = 0, D = c.indexOf(u), a = o[n], l = [], p; D !== -1; )
                l.push(c.slice(i3, D)), i3 = D + 1, p = c.charAt(i3), (!p || a.indexOf(p) === -1) && l.push(u), D = c.indexOf(u, i3 + 1);
              return l.push(c.slice(i3)), l.join("");
            }
          }
        } }), zl = S2({ "node_modules/character-entities-legacy/index.json"(e3, r3) {
          r3.exports = { AElig: "\xC6", AMP: "&", Aacute: "\xC1", Acirc: "\xC2", Agrave: "\xC0", Aring: "\xC5", Atilde: "\xC3", Auml: "\xC4", COPY: "\xA9", Ccedil: "\xC7", ETH: "\xD0", Eacute: "\xC9", Ecirc: "\xCA", Egrave: "\xC8", Euml: "\xCB", GT: ">", Iacute: "\xCD", Icirc: "\xCE", Igrave: "\xCC", Iuml: "\xCF", LT: "<", Ntilde: "\xD1", Oacute: "\xD3", Ocirc: "\xD4", Ograve: "\xD2", Oslash: "\xD8", Otilde: "\xD5", Ouml: "\xD6", QUOT: '"', REG: "\xAE", THORN: "\xDE", Uacute: "\xDA", Ucirc: "\xDB", Ugrave: "\xD9", Uuml: "\xDC", Yacute: "\xDD", aacute: "\xE1", acirc: "\xE2", acute: "\xB4", aelig: "\xE6", agrave: "\xE0", amp: "&", aring: "\xE5", atilde: "\xE3", auml: "\xE4", brvbar: "\xA6", ccedil: "\xE7", cedil: "\xB8", cent: "\xA2", copy: "\xA9", curren: "\xA4", deg: "\xB0", divide: "\xF7", eacute: "\xE9", ecirc: "\xEA", egrave: "\xE8", eth: "\xF0", euml: "\xEB", frac12: "\xBD", frac14: "\xBC", frac34: "\xBE", gt: ">", iacute: "\xED", icirc: "\xEE", iexcl: "\xA1", igrave: "\xEC", iquest: "\xBF", iuml: "\xEF", laquo: "\xAB", lt: "<", macr: "\xAF", micro: "\xB5", middot: "\xB7", nbsp: "\xA0", not: "\xAC", ntilde: "\xF1", oacute: "\xF3", ocirc: "\xF4", ograve: "\xF2", ordf: "\xAA", ordm: "\xBA", oslash: "\xF8", otilde: "\xF5", ouml: "\xF6", para: "\xB6", plusmn: "\xB1", pound: "\xA3", quot: '"', raquo: "\xBB", reg: "\xAE", sect: "\xA7", shy: "\xAD", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", szlig: "\xDF", thorn: "\xFE", times: "\xD7", uacute: "\xFA", ucirc: "\xFB", ugrave: "\xF9", uml: "\xA8", uuml: "\xFC", yacute: "\xFD", yen: "\xA5", yuml: "\xFF" };
        } }), Gl = S2({ "node_modules/character-reference-invalid/index.json"(e3, r3) {
          r3.exports = { 0: "\uFFFD", 128: "\u20AC", 130: "\u201A", 131: "\u0192", 132: "\u201E", 133: "\u2026", 134: "\u2020", 135: "\u2021", 136: "\u02C6", 137: "\u2030", 138: "\u0160", 139: "\u2039", 140: "\u0152", 142: "\u017D", 145: "\u2018", 146: "\u2019", 147: "\u201C", 148: "\u201D", 149: "\u2022", 150: "\u2013", 151: "\u2014", 152: "\u02DC", 153: "\u2122", 154: "\u0161", 155: "\u203A", 156: "\u0153", 158: "\u017E", 159: "\u0178" };
        } }), ze = S2({ "node_modules/is-decimal/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3) {
            var o = typeof t3 == "string" ? t3.charCodeAt(0) : t3;
            return o >= 48 && o <= 57;
          }
        } }), Ul = S2({ "node_modules/is-hexadecimal/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3) {
            var o = typeof t3 == "string" ? t3.charCodeAt(0) : t3;
            return o >= 97 && o <= 102 || o >= 65 && o <= 70 || o >= 48 && o <= 57;
          }
        } }), Qe = S2({ "node_modules/is-alphabetical/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3) {
            var o = typeof t3 == "string" ? t3.charCodeAt(0) : t3;
            return o >= 97 && o <= 122 || o >= 65 && o <= 90;
          }
        } }), Vl = S2({ "node_modules/is-alphanumerical/index.js"(e3, r3) {
          "use strict";
          I();
          var u = Qe(), t3 = ze();
          r3.exports = o;
          function o(n) {
            return u(n) || t3(n);
          }
        } }), $l = S2({ "node_modules/character-entities/index.json"(e3, r3) {
          r3.exports = { AEli: "\xC6", AElig: "\xC6", AM: "&", AMP: "&", Aacut: "\xC1", Aacute: "\xC1", Abreve: "\u0102", Acir: "\xC2", Acirc: "\xC2", Acy: "\u0410", Afr: "\u{1D504}", Agrav: "\xC0", Agrave: "\xC0", Alpha: "\u0391", Amacr: "\u0100", And: "\u2A53", Aogon: "\u0104", Aopf: "\u{1D538}", ApplyFunction: "\u2061", Arin: "\xC5", Aring: "\xC5", Ascr: "\u{1D49C}", Assign: "\u2254", Atild: "\xC3", Atilde: "\xC3", Aum: "\xC4", Auml: "\xC4", Backslash: "\u2216", Barv: "\u2AE7", Barwed: "\u2306", Bcy: "\u0411", Because: "\u2235", Bernoullis: "\u212C", Beta: "\u0392", Bfr: "\u{1D505}", Bopf: "\u{1D539}", Breve: "\u02D8", Bscr: "\u212C", Bumpeq: "\u224E", CHcy: "\u0427", COP: "\xA9", COPY: "\xA9", Cacute: "\u0106", Cap: "\u22D2", CapitalDifferentialD: "\u2145", Cayleys: "\u212D", Ccaron: "\u010C", Ccedi: "\xC7", Ccedil: "\xC7", Ccirc: "\u0108", Cconint: "\u2230", Cdot: "\u010A", Cedilla: "\xB8", CenterDot: "\xB7", Cfr: "\u212D", Chi: "\u03A7", CircleDot: "\u2299", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", Colon: "\u2237", Colone: "\u2A74", Congruent: "\u2261", Conint: "\u222F", ContourIntegral: "\u222E", Copf: "\u2102", Coproduct: "\u2210", CounterClockwiseContourIntegral: "\u2233", Cross: "\u2A2F", Cscr: "\u{1D49E}", Cup: "\u22D3", CupCap: "\u224D", DD: "\u2145", DDotrahd: "\u2911", DJcy: "\u0402", DScy: "\u0405", DZcy: "\u040F", Dagger: "\u2021", Darr: "\u21A1", Dashv: "\u2AE4", Dcaron: "\u010E", Dcy: "\u0414", Del: "\u2207", Delta: "\u0394", Dfr: "\u{1D507}", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", Diamond: "\u22C4", DifferentialD: "\u2146", Dopf: "\u{1D53B}", Dot: "\xA8", DotDot: "\u20DC", DotEqual: "\u2250", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrow: "\u2193", DownArrowBar: "\u2913", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVector: "\u21BD", DownLeftVectorBar: "\u2956", DownRightTeeVector: "\u295F", DownRightVector: "\u21C1", DownRightVectorBar: "\u2957", DownTee: "\u22A4", DownTeeArrow: "\u21A7", Downarrow: "\u21D3", Dscr: "\u{1D49F}", Dstrok: "\u0110", ENG: "\u014A", ET: "\xD0", ETH: "\xD0", Eacut: "\xC9", Eacute: "\xC9", Ecaron: "\u011A", Ecir: "\xCA", Ecirc: "\xCA", Ecy: "\u042D", Edot: "\u0116", Efr: "\u{1D508}", Egrav: "\xC8", Egrave: "\xC8", Element: "\u2208", Emacr: "\u0112", EmptySmallSquare: "\u25FB", EmptyVerySmallSquare: "\u25AB", Eogon: "\u0118", Eopf: "\u{1D53C}", Epsilon: "\u0395", Equal: "\u2A75", EqualTilde: "\u2242", Equilibrium: "\u21CC", Escr: "\u2130", Esim: "\u2A73", Eta: "\u0397", Eum: "\xCB", Euml: "\xCB", Exists: "\u2203", ExponentialE: "\u2147", Fcy: "\u0424", Ffr: "\u{1D509}", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", Fopf: "\u{1D53D}", ForAll: "\u2200", Fouriertrf: "\u2131", Fscr: "\u2131", GJcy: "\u0403", G: ">", GT: ">", Gamma: "\u0393", Gammad: "\u03DC", Gbreve: "\u011E", Gcedil: "\u0122", Gcirc: "\u011C", Gcy: "\u0413", Gdot: "\u0120", Gfr: "\u{1D50A}", Gg: "\u22D9", Gopf: "\u{1D53E}", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", Gt: "\u226B", HARDcy: "\u042A", Hacek: "\u02C7", Hat: "^", Hcirc: "\u0124", Hfr: "\u210C", HilbertSpace: "\u210B", Hopf: "\u210D", HorizontalLine: "\u2500", Hscr: "\u210B", Hstrok: "\u0126", HumpDownHump: "\u224E", HumpEqual: "\u224F", IEcy: "\u0415", IJlig: "\u0132", IOcy: "\u0401", Iacut: "\xCD", Iacute: "\xCD", Icir: "\xCE", Icirc: "\xCE", Icy: "\u0418", Idot: "\u0130", Ifr: "\u2111", Igrav: "\xCC", Igrave: "\xCC", Im: "\u2111", Imacr: "\u012A", ImaginaryI: "\u2148", Implies: "\u21D2", Int: "\u222C", Integral: "\u222B", Intersection: "\u22C2", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", Iogon: "\u012E", Iopf: "\u{1D540}", Iota: "\u0399", Iscr: "\u2110", Itilde: "\u0128", Iukcy: "\u0406", Ium: "\xCF", Iuml: "\xCF", Jcirc: "\u0134", Jcy: "\u0419", Jfr: "\u{1D50D}", Jopf: "\u{1D541}", Jscr: "\u{1D4A5}", Jsercy: "\u0408", Jukcy: "\u0404", KHcy: "\u0425", KJcy: "\u040C", Kappa: "\u039A", Kcedil: "\u0136", Kcy: "\u041A", Kfr: "\u{1D50E}", Kopf: "\u{1D542}", Kscr: "\u{1D4A6}", LJcy: "\u0409", L: "<", LT: "<", Lacute: "\u0139", Lambda: "\u039B", Lang: "\u27EA", Laplacetrf: "\u2112", Larr: "\u219E", Lcaron: "\u013D", Lcedil: "\u013B", Lcy: "\u041B", LeftAngleBracket: "\u27E8", LeftArrow: "\u2190", LeftArrowBar: "\u21E4", LeftArrowRightArrow: "\u21C6", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVector: "\u21C3", LeftDownVectorBar: "\u2959", LeftFloor: "\u230A", LeftRightArrow: "\u2194", LeftRightVector: "\u294E", LeftTee: "\u22A3", LeftTeeArrow: "\u21A4", LeftTeeVector: "\u295A", LeftTriangle: "\u22B2", LeftTriangleBar: "\u29CF", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVector: "\u21BF", LeftUpVectorBar: "\u2958", LeftVector: "\u21BC", LeftVectorBar: "\u2952", Leftarrow: "\u21D0", Leftrightarrow: "\u21D4", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", LessLess: "\u2AA1", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", Lfr: "\u{1D50F}", Ll: "\u22D8", Lleftarrow: "\u21DA", Lmidot: "\u013F", LongLeftArrow: "\u27F5", LongLeftRightArrow: "\u27F7", LongRightArrow: "\u27F6", Longleftarrow: "\u27F8", Longleftrightarrow: "\u27FA", Longrightarrow: "\u27F9", Lopf: "\u{1D543}", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", Lscr: "\u2112", Lsh: "\u21B0", Lstrok: "\u0141", Lt: "\u226A", Map: "\u2905", Mcy: "\u041C", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", MinusPlus: "\u2213", Mopf: "\u{1D544}", Mscr: "\u2133", Mu: "\u039C", NJcy: "\u040A", Nacute: "\u0143", Ncaron: "\u0147", Ncedil: "\u0145", Ncy: "\u041D", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: `
`, Nfr: "\u{1D511}", NoBreak: "\u2060", NonBreakingSpace: "\xA0", Nopf: "\u2115", Not: "\u2AEC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", NotLeftTriangle: "\u22EA", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangle: "\u22EB", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", Nscr: "\u{1D4A9}", Ntild: "\xD1", Ntilde: "\xD1", Nu: "\u039D", OElig: "\u0152", Oacut: "\xD3", Oacute: "\xD3", Ocir: "\xD4", Ocirc: "\xD4", Ocy: "\u041E", Odblac: "\u0150", Ofr: "\u{1D512}", Ograv: "\xD2", Ograve: "\xD2", Omacr: "\u014C", Omega: "\u03A9", Omicron: "\u039F", Oopf: "\u{1D546}", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", Or: "\u2A54", Oscr: "\u{1D4AA}", Oslas: "\xD8", Oslash: "\xD8", Otild: "\xD5", Otilde: "\xD5", Otimes: "\u2A37", Oum: "\xD6", Ouml: "\xD6", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", PartialD: "\u2202", Pcy: "\u041F", Pfr: "\u{1D513}", Phi: "\u03A6", Pi: "\u03A0", PlusMinus: "\xB1", Poincareplane: "\u210C", Popf: "\u2119", Pr: "\u2ABB", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", Prime: "\u2033", Product: "\u220F", Proportion: "\u2237", Proportional: "\u221D", Pscr: "\u{1D4AB}", Psi: "\u03A8", QUO: '"', QUOT: '"', Qfr: "\u{1D514}", Qopf: "\u211A", Qscr: "\u{1D4AC}", RBarr: "\u2910", RE: "\xAE", REG: "\xAE", Racute: "\u0154", Rang: "\u27EB", Rarr: "\u21A0", Rarrtl: "\u2916", Rcaron: "\u0158", Rcedil: "\u0156", Rcy: "\u0420", Re: "\u211C", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", Rfr: "\u211C", Rho: "\u03A1", RightAngleBracket: "\u27E9", RightArrow: "\u2192", RightArrowBar: "\u21E5", RightArrowLeftArrow: "\u21C4", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVector: "\u21C2", RightDownVectorBar: "\u2955", RightFloor: "\u230B", RightTee: "\u22A2", RightTeeArrow: "\u21A6", RightTeeVector: "\u295B", RightTriangle: "\u22B3", RightTriangleBar: "\u29D0", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVector: "\u21BE", RightUpVectorBar: "\u2954", RightVector: "\u21C0", RightVectorBar: "\u2953", Rightarrow: "\u21D2", Ropf: "\u211D", RoundImplies: "\u2970", Rrightarrow: "\u21DB", Rscr: "\u211B", Rsh: "\u21B1", RuleDelayed: "\u29F4", SHCHcy: "\u0429", SHcy: "\u0428", SOFTcy: "\u042C", Sacute: "\u015A", Sc: "\u2ABC", Scaron: "\u0160", Scedil: "\u015E", Scirc: "\u015C", Scy: "\u0421", Sfr: "\u{1D516}", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", Sigma: "\u03A3", SmallCircle: "\u2218", Sopf: "\u{1D54A}", Sqrt: "\u221A", Square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", Sscr: "\u{1D4AE}", Star: "\u22C6", Sub: "\u22D0", Subset: "\u22D0", SubsetEqual: "\u2286", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", SuchThat: "\u220B", Sum: "\u2211", Sup: "\u22D1", Superset: "\u2283", SupersetEqual: "\u2287", Supset: "\u22D1", THOR: "\xDE", THORN: "\xDE", TRADE: "\u2122", TSHcy: "\u040B", TScy: "\u0426", Tab: "	", Tau: "\u03A4", Tcaron: "\u0164", Tcedil: "\u0162", Tcy: "\u0422", Tfr: "\u{1D517}", Therefore: "\u2234", Theta: "\u0398", ThickSpace: "\u205F\u200A", ThinSpace: "\u2009", Tilde: "\u223C", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", Topf: "\u{1D54B}", TripleDot: "\u20DB", Tscr: "\u{1D4AF}", Tstrok: "\u0166", Uacut: "\xDA", Uacute: "\xDA", Uarr: "\u219F", Uarrocir: "\u2949", Ubrcy: "\u040E", Ubreve: "\u016C", Ucir: "\xDB", Ucirc: "\xDB", Ucy: "\u0423", Udblac: "\u0170", Ufr: "\u{1D518}", Ugrav: "\xD9", Ugrave: "\xD9", Umacr: "\u016A", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", Uopf: "\u{1D54C}", UpArrow: "\u2191", UpArrowBar: "\u2912", UpArrowDownArrow: "\u21C5", UpDownArrow: "\u2195", UpEquilibrium: "\u296E", UpTee: "\u22A5", UpTeeArrow: "\u21A5", Uparrow: "\u21D1", Updownarrow: "\u21D5", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", Upsi: "\u03D2", Upsilon: "\u03A5", Uring: "\u016E", Uscr: "\u{1D4B0}", Utilde: "\u0168", Uum: "\xDC", Uuml: "\xDC", VDash: "\u22AB", Vbar: "\u2AEB", Vcy: "\u0412", Vdash: "\u22A9", Vdashl: "\u2AE6", Vee: "\u22C1", Verbar: "\u2016", Vert: "\u2016", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", Vopf: "\u{1D54D}", Vscr: "\u{1D4B1}", Vvdash: "\u22AA", Wcirc: "\u0174", Wedge: "\u22C0", Wfr: "\u{1D51A}", Wopf: "\u{1D54E}", Wscr: "\u{1D4B2}", Xfr: "\u{1D51B}", Xi: "\u039E", Xopf: "\u{1D54F}", Xscr: "\u{1D4B3}", YAcy: "\u042F", YIcy: "\u0407", YUcy: "\u042E", Yacut: "\xDD", Yacute: "\xDD", Ycirc: "\u0176", Ycy: "\u042B", Yfr: "\u{1D51C}", Yopf: "\u{1D550}", Yscr: "\u{1D4B4}", Yuml: "\u0178", ZHcy: "\u0416", Zacute: "\u0179", Zcaron: "\u017D", Zcy: "\u0417", Zdot: "\u017B", ZeroWidthSpace: "\u200B", Zeta: "\u0396", Zfr: "\u2128", Zopf: "\u2124", Zscr: "\u{1D4B5}", aacut: "\xE1", aacute: "\xE1", abreve: "\u0103", ac: "\u223E", acE: "\u223E\u0333", acd: "\u223F", acir: "\xE2", acirc: "\xE2", acut: "\xB4", acute: "\xB4", acy: "\u0430", aeli: "\xE6", aelig: "\xE6", af: "\u2061", afr: "\u{1D51E}", agrav: "\xE0", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", alpha: "\u03B1", amacr: "\u0101", amalg: "\u2A3F", am: "&", amp: "&", and: "\u2227", andand: "\u2A55", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsd: "\u2221", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", aogon: "\u0105", aopf: "\u{1D552}", ap: "\u2248", apE: "\u2A70", apacir: "\u2A6F", ape: "\u224A", apid: "\u224B", apos: "'", approx: "\u2248", approxeq: "\u224A", arin: "\xE5", aring: "\xE5", ascr: "\u{1D4B6}", ast: "*", asymp: "\u2248", asympeq: "\u224D", atild: "\xE3", atilde: "\xE3", aum: "\xE4", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", bNot: "\u2AED", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", barvee: "\u22BD", barwed: "\u2305", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", beta: "\u03B2", beth: "\u2136", between: "\u226C", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bnot: "\u2310", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxDL: "\u2557", boxDR: "\u2554", boxDl: "\u2556", boxDr: "\u2553", boxH: "\u2550", boxHD: "\u2566", boxHU: "\u2569", boxHd: "\u2564", boxHu: "\u2567", boxUL: "\u255D", boxUR: "\u255A", boxUl: "\u255C", boxUr: "\u2559", boxV: "\u2551", boxVH: "\u256C", boxVL: "\u2563", boxVR: "\u2560", boxVh: "\u256B", boxVl: "\u2562", boxVr: "\u255F", boxbox: "\u29C9", boxdL: "\u2555", boxdR: "\u2552", boxdl: "\u2510", boxdr: "\u250C", boxh: "\u2500", boxhD: "\u2565", boxhU: "\u2568", boxhd: "\u252C", boxhu: "\u2534", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxuL: "\u255B", boxuR: "\u2558", boxul: "\u2518", boxur: "\u2514", boxv: "\u2502", boxvH: "\u256A", boxvL: "\u2561", boxvR: "\u255E", boxvh: "\u253C", boxvl: "\u2524", boxvr: "\u251C", bprime: "\u2035", breve: "\u02D8", brvba: "\xA6", brvbar: "\xA6", bscr: "\u{1D4B7}", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsol: "\\", bsolb: "\u29C5", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", bumpeq: "\u224F", cacute: "\u0107", cap: "\u2229", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", capcup: "\u2A47", capdot: "\u2A40", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", ccaps: "\u2A4D", ccaron: "\u010D", ccedi: "\xE7", ccedil: "\xE7", ccirc: "\u0109", ccups: "\u2A4C", ccupssm: "\u2A50", cdot: "\u010B", cedi: "\xB8", cedil: "\xB8", cemptyv: "\u29B2", cen: "\xA2", cent: "\xA2", centerdot: "\xB7", cfr: "\u{1D520}", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", chi: "\u03C7", cir: "\u25CB", cirE: "\u29C3", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledR: "\xAE", circledS: "\u24C8", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", clubs: "\u2663", clubsuit: "\u2663", colon: ":", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", conint: "\u222E", copf: "\u{1D554}", coprod: "\u2210", cop: "\xA9", copy: "\xA9", copysr: "\u2117", crarr: "\u21B5", cross: "\u2717", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", cup: "\u222A", cupbrcap: "\u2A48", cupcap: "\u2A46", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curre: "\xA4", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", dArr: "\u21D3", dHar: "\u2965", dagger: "\u2020", daleth: "\u2138", darr: "\u2193", dash: "\u2010", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", dcaron: "\u010F", dcy: "\u0434", dd: "\u2146", ddagger: "\u2021", ddarr: "\u21CA", ddotseq: "\u2A77", de: "\xB0", deg: "\xB0", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", dfr: "\u{1D521}", dharl: "\u21C3", dharr: "\u21C2", diam: "\u22C4", diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divid: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", dopf: "\u{1D555}", dot: "\u02D9", doteq: "\u2250", doteqdot: "\u2251", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", downarrow: "\u2193", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", dscr: "\u{1D4B9}", dscy: "\u0455", dsol: "\u29F6", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", dzcy: "\u045F", dzigrarr: "\u27FF", eDDot: "\u2A77", eDot: "\u2251", eacut: "\xE9", eacute: "\xE9", easter: "\u2A6E", ecaron: "\u011B", ecir: "\xEA", ecirc: "\xEA", ecolon: "\u2255", ecy: "\u044D", edot: "\u0117", ee: "\u2147", efDot: "\u2252", efr: "\u{1D522}", eg: "\u2A9A", egrav: "\xE8", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", emptyv: "\u2205", emsp13: "\u2004", emsp14: "\u2005", emsp: "\u2003", eng: "\u014B", ensp: "\u2002", eogon: "\u0119", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", equals: "=", equest: "\u225F", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erDot: "\u2253", erarr: "\u2971", escr: "\u212F", esdot: "\u2250", esim: "\u2242", eta: "\u03B7", et: "\xF0", eth: "\xF0", eum: "\xEB", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", expectation: "\u2130", exponentiale: "\u2147", fallingdotseq: "\u2252", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", ffr: "\u{1D523}", filig: "\uFB01", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", fopf: "\u{1D557}", forall: "\u2200", fork: "\u22D4", forkv: "\u2AD9", fpartint: "\u2A0D", frac1: "\xBC", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac3: "\xBE", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", fscr: "\u{1D4BB}", gE: "\u2267", gEl: "\u2A8C", gacute: "\u01F5", gamma: "\u03B3", gammad: "\u03DD", gap: "\u2A86", gbreve: "\u011F", gcirc: "\u011D", gcy: "\u0433", gdot: "\u0121", ge: "\u2265", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", ges: "\u2A7E", gescc: "\u2AA9", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", gfr: "\u{1D524}", gg: "\u226B", ggg: "\u22D9", gimel: "\u2137", gjcy: "\u0453", gl: "\u2277", glE: "\u2A92", gla: "\u2AA5", glj: "\u2AA4", gnE: "\u2269", gnap: "\u2A8A", gnapprox: "\u2A8A", gne: "\u2A88", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", gopf: "\u{1D558}", grave: "`", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", g: ">", gt: ">", gtcc: "\u2AA7", gtcir: "\u2A7A", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", hArr: "\u21D4", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", hardcy: "\u044A", harr: "\u2194", harrcir: "\u2948", harrw: "\u21AD", hbar: "\u210F", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", hfr: "\u{1D525}", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", hopf: "\u{1D559}", horbar: "\u2015", hscr: "\u{1D4BD}", hslash: "\u210F", hstrok: "\u0127", hybull: "\u2043", hyphen: "\u2010", iacut: "\xED", iacute: "\xED", ic: "\u2063", icir: "\xEE", icirc: "\xEE", icy: "\u0438", iecy: "\u0435", iexc: "\xA1", iexcl: "\xA1", iff: "\u21D4", ifr: "\u{1D526}", igrav: "\xEC", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", ijlig: "\u0133", imacr: "\u012B", image: "\u2111", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", imof: "\u22B7", imped: "\u01B5", in: "\u2208", incare: "\u2105", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", int: "\u222B", intcal: "\u22BA", integers: "\u2124", intercal: "\u22BA", intlarhk: "\u2A17", intprod: "\u2A3C", iocy: "\u0451", iogon: "\u012F", iopf: "\u{1D55A}", iota: "\u03B9", iprod: "\u2A3C", iques: "\xBF", iquest: "\xBF", iscr: "\u{1D4BE}", isin: "\u2208", isinE: "\u22F9", isindot: "\u22F5", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", itilde: "\u0129", iukcy: "\u0456", ium: "\xEF", iuml: "\xEF", jcirc: "\u0135", jcy: "\u0439", jfr: "\u{1D527}", jmath: "\u0237", jopf: "\u{1D55B}", jscr: "\u{1D4BF}", jsercy: "\u0458", jukcy: "\u0454", kappa: "\u03BA", kappav: "\u03F0", kcedil: "\u0137", kcy: "\u043A", kfr: "\u{1D528}", kgreen: "\u0138", khcy: "\u0445", kjcy: "\u045C", kopf: "\u{1D55C}", kscr: "\u{1D4C0}", lAarr: "\u21DA", lArr: "\u21D0", lAtail: "\u291B", lBarr: "\u290E", lE: "\u2266", lEg: "\u2A8B", lHar: "\u2962", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", lambda: "\u03BB", lang: "\u27E8", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", laqu: "\xAB", laquo: "\xAB", larr: "\u2190", larrb: "\u21E4", larrbfs: "\u291F", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", lat: "\u2AAB", latail: "\u2919", late: "\u2AAD", lates: "\u2AAD\uFE00", lbarr: "\u290C", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", lcaron: "\u013E", lcedil: "\u013C", lceil: "\u2308", lcub: "{", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", le: "\u2264", leftarrow: "\u2190", leftarrowtail: "\u21A2", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", leftrightarrow: "\u2194", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", leftthreetimes: "\u22CB", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", les: "\u2A7D", lescc: "\u2AA8", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", lessgtr: "\u2276", lesssim: "\u2272", lfisht: "\u297C", lfloor: "\u230A", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", ljcy: "\u0459", ll: "\u226A", llarr: "\u21C7", llcorner: "\u231E", llhard: "\u296B", lltri: "\u25FA", lmidot: "\u0140", lmoust: "\u23B0", lmoustache: "\u23B0", lnE: "\u2268", lnap: "\u2A89", lnapprox: "\u2A89", lne: "\u2A87", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", longleftarrow: "\u27F5", longleftrightarrow: "\u27F7", longmapsto: "\u27FC", longrightarrow: "\u27F6", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", lscr: "\u{1D4C1}", lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", lstrok: "\u0142", l: "<", lt: "<", ltcc: "\u2AA6", ltcir: "\u2A79", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltrPar: "\u2996", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", mDDot: "\u223A", mac: "\xAF", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", mcy: "\u043C", mdash: "\u2014", measuredangle: "\u2221", mfr: "\u{1D52A}", mho: "\u2127", micr: "\xB5", micro: "\xB5", mid: "\u2223", midast: "*", midcir: "\u2AF0", middo: "\xB7", middot: "\xB7", minus: "\u2212", minusb: "\u229F", minusd: "\u2238", minusdu: "\u2A2A", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", mopf: "\u{1D55E}", mp: "\u2213", mscr: "\u{1D4C2}", mstpos: "\u223E", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nGg: "\u22D9\u0338", nGt: "\u226B\u20D2", nGtv: "\u226B\u0338", nLeftarrow: "\u21CD", nLeftrightarrow: "\u21CE", nLl: "\u22D8\u0338", nLt: "\u226A\u20D2", nLtv: "\u226A\u0338", nRightarrow: "\u21CF", nVDash: "\u22AF", nVdash: "\u22AE", nabla: "\u2207", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natur: "\u266E", natural: "\u266E", naturals: "\u2115", nbs: "\xA0", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", ncaron: "\u0148", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", ncy: "\u043D", ndash: "\u2013", ne: "\u2260", neArr: "\u21D7", nearhk: "\u2924", nearr: "\u2197", nearrow: "\u2197", nedot: "\u2250\u0338", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", nexist: "\u2204", nexists: "\u2204", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", ngsim: "\u2275", ngt: "\u226F", ngtr: "\u226F", nhArr: "\u21CE", nharr: "\u21AE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", njcy: "\u045A", nlArr: "\u21CD", nlE: "\u2266\u0338", nlarr: "\u219A", nldr: "\u2025", nle: "\u2270", nleftarrow: "\u219A", nleftrightarrow: "\u21AE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nlsim: "\u2274", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nmid: "\u2224", nopf: "\u{1D55F}", no: "\xAC", not: "\xAC", notin: "\u2209", notinE: "\u22F9\u0338", notindot: "\u22F5\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", npar: "\u2226", nparallel: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", npre: "\u2AAF\u0338", nprec: "\u2280", npreceq: "\u2AAF\u0338", nrArr: "\u21CF", nrarr: "\u219B", nrarrc: "\u2933\u0338", nrarrw: "\u219D\u0338", nrightarrow: "\u219B", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", ntild: "\xF1", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvDash: "\u22AD", nvHarr: "\u2904", nvap: "\u224D\u20D2", nvdash: "\u22AC", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwArr: "\u21D6", nwarhk: "\u2923", nwarr: "\u2196", nwarrow: "\u2196", nwnear: "\u2927", oS: "\u24C8", oacut: "\xF3", oacute: "\xF3", oast: "\u229B", ocir: "\xF4", ocirc: "\xF4", ocy: "\u043E", odash: "\u229D", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", oelig: "\u0153", ofcir: "\u29BF", ofr: "\u{1D52C}", ogon: "\u02DB", ograv: "\xF2", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", omacr: "\u014D", omega: "\u03C9", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", oopf: "\u{1D560}", opar: "\u29B7", operp: "\u29B9", oplus: "\u2295", or: "\u2228", orarr: "\u21BB", ord: "\xBA", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oscr: "\u2134", oslas: "\xF8", oslash: "\xF8", osol: "\u2298", otild: "\xF5", otilde: "\xF5", otimes: "\u2297", otimesas: "\u2A36", oum: "\xF6", ouml: "\xF6", ovbar: "\u233D", par: "\xB6", para: "\xB6", parallel: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", pfr: "\u{1D52D}", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plus: "+", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", plusm: "\xB1", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", pointint: "\u2A15", popf: "\u{1D561}", poun: "\xA3", pound: "\xA3", pr: "\u227A", prE: "\u2AB3", prap: "\u2AB7", prcue: "\u227C", pre: "\u2AAF", prec: "\u227A", precapprox: "\u2AB7", preccurlyeq: "\u227C", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", precsim: "\u227E", prime: "\u2032", primes: "\u2119", prnE: "\u2AB5", prnap: "\u2AB9", prnsim: "\u22E8", prod: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", pscr: "\u{1D4C5}", psi: "\u03C8", puncsp: "\u2008", qfr: "\u{1D52E}", qint: "\u2A0C", qopf: "\u{1D562}", qprime: "\u2057", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", quo: '"', quot: '"', rAarr: "\u21DB", rArr: "\u21D2", rAtail: "\u291C", rBarr: "\u290F", rHar: "\u2964", race: "\u223D\u0331", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", rang: "\u27E9", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raqu: "\xBB", raquo: "\xBB", rarr: "\u2192", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", rarrtl: "\u21A3", rarrw: "\u219D", ratail: "\u291A", ratio: "\u2236", rationals: "\u211A", rbarr: "\u290D", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", rcaron: "\u0159", rcedil: "\u0157", rceil: "\u2309", rcub: "}", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", rect: "\u25AD", re: "\xAE", reg: "\xAE", rfisht: "\u297D", rfloor: "\u230B", rfr: "\u{1D52F}", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", rho: "\u03C1", rhov: "\u03F1", rightarrow: "\u2192", rightarrowtail: "\u21A3", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", rightthreetimes: "\u22CC", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoust: "\u23B1", rmoustache: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", ropf: "\u{1D563}", roplus: "\u2A2E", rotimes: "\u2A35", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", rsaquo: "\u203A", rscr: "\u{1D4C7}", rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", ruluhar: "\u2968", rx: "\u211E", sacute: "\u015B", sbquo: "\u201A", sc: "\u227B", scE: "\u2AB4", scap: "\u2AB8", scaron: "\u0161", sccue: "\u227D", sce: "\u2AB0", scedil: "\u015F", scirc: "\u015D", scnE: "\u2AB6", scnap: "\u2ABA", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", scy: "\u0441", sdot: "\u22C5", sdotb: "\u22A1", sdote: "\u2A66", seArr: "\u21D8", searhk: "\u2925", searr: "\u2198", searrow: "\u2198", sec: "\xA7", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", shchcy: "\u0449", shcy: "\u0448", shortmid: "\u2223", shortparallel: "\u2225", sh: "\xAD", shy: "\xAD", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", softcy: "\u044C", sol: "/", solb: "\u29C4", solbar: "\u233F", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", squ: "\u25A1", square: "\u25A1", squarf: "\u25AA", squf: "\u25AA", srarr: "\u2192", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", sub: "\u2282", subE: "\u2AC5", subdot: "\u2ABD", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", subset: "\u2282", subseteq: "\u2286", subseteqq: "\u2AC5", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succ: "\u227B", succapprox: "\u2AB8", succcurlyeq: "\u227D", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", sum: "\u2211", sung: "\u266A", sup: "\u2283", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", supE: "\u2AC6", supdot: "\u2ABE", supdsub: "\u2AD8", supe: "\u2287", supedot: "\u2AC4", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", supset: "\u2283", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swArr: "\u21D9", swarhk: "\u2926", swarr: "\u2199", swarrow: "\u2199", swnwar: "\u292A", szli: "\xDF", szlig: "\xDF", target: "\u2316", tau: "\u03C4", tbrk: "\u23B4", tcaron: "\u0165", tcedil: "\u0163", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", tfr: "\u{1D531}", there4: "\u2234", therefore: "\u2234", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", thinsp: "\u2009", thkap: "\u2248", thksim: "\u223C", thor: "\xFE", thorn: "\xFE", tilde: "\u02DC", time: "\xD7", times: "\xD7", timesb: "\u22A0", timesbar: "\u2A31", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", top: "\u22A4", topbot: "\u2336", topcir: "\u2AF1", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", trade: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", tscr: "\u{1D4C9}", tscy: "\u0446", tshcy: "\u045B", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", uArr: "\u21D1", uHar: "\u2963", uacut: "\xFA", uacute: "\xFA", uarr: "\u2191", ubrcy: "\u045E", ubreve: "\u016D", ucir: "\xFB", ucirc: "\xFB", ucy: "\u0443", udarr: "\u21C5", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", ufr: "\u{1D532}", ugrav: "\xF9", ugrave: "\xF9", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", umacr: "\u016B", um: "\xA8", uml: "\xA8", uogon: "\u0173", uopf: "\u{1D566}", uparrow: "\u2191", updownarrow: "\u2195", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", upsi: "\u03C5", upsih: "\u03D2", upsilon: "\u03C5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", uring: "\u016F", urtri: "\u25F9", uscr: "\u{1D4CA}", utdot: "\u22F0", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", uum: "\xFC", uuml: "\xFC", uwangle: "\u29A7", vArr: "\u21D5", vBar: "\u2AE8", vBarv: "\u2AE9", vDash: "\u22A8", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", varr: "\u2195", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", vcy: "\u0432", vdash: "\u22A2", vee: "\u2228", veebar: "\u22BB", veeeq: "\u225A", vellip: "\u22EE", verbar: "|", vert: "|", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", vzigzag: "\u299A", wcirc: "\u0175", wedbar: "\u2A5F", wedge: "\u2227", wedgeq: "\u2259", weierp: "\u2118", wfr: "\u{1D534}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", xfr: "\u{1D535}", xhArr: "\u27FA", xharr: "\u27F7", xi: "\u03BE", xlArr: "\u27F8", xlarr: "\u27F5", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrArr: "\u27F9", xrarr: "\u27F6", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", yacut: "\xFD", yacute: "\xFD", yacy: "\u044F", ycirc: "\u0177", ycy: "\u044B", ye: "\xA5", yen: "\xA5", yfr: "\u{1D536}", yicy: "\u0457", yopf: "\u{1D56A}", yscr: "\u{1D4CE}", yucy: "\u044E", yum: "\xFF", yuml: "\xFF", zacute: "\u017A", zcaron: "\u017E", zcy: "\u0437", zdot: "\u017C", zeetrf: "\u2128", zeta: "\u03B6", zfr: "\u{1D537}", zhcy: "\u0436", zigrarr: "\u21DD", zopf: "\u{1D56B}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" };
        } }), Hl = S2({ "node_modules/parse-entities/decode-entity.js"(e3, r3) {
          "use strict";
          I();
          var u = $l();
          r3.exports = o;
          var t3 = {}.hasOwnProperty;
          function o(n) {
            return t3.call(u, n) ? u[n] : false;
          }
        } }), xr = S2({ "node_modules/parse-entities/index.js"(e3, r3) {
          "use strict";
          I();
          var u = zl(), t3 = Gl(), o = ze(), n = Ul(), s3 = Vl(), c = Hl();
          r3.exports = J;
          var i3 = {}.hasOwnProperty, D = String.fromCharCode, a = Function.prototype, l = { warning: null, reference: null, text: null, warningContext: null, referenceContext: null, textContext: null, position: {}, additional: null, attribute: false, nonTerminated: true }, p = 9, d = 10, g = 12, F3 = 32, E = 38, x3 = 59, f3 = 60, b = 61, v = 35, h3 = 88, m3 = 120, C = 65533, B = "named", q = "hexadecimal", L = "decimal", w = {};
          w[q] = 16, w[L] = 10;
          var O = {};
          O[B] = s3, O[L] = o, O[q] = n;
          var T = 1, P = 2, A3 = 3, j = 4, $ = 5, U = 6, X = 7, R = {};
          R[T] = "Named character references must be terminated by a semicolon", R[P] = "Numeric character references must be terminated by a semicolon", R[A3] = "Named character references cannot be empty", R[j] = "Numeric character references cannot be empty", R[$] = "Named character references must be known", R[U] = "Numeric character references cannot be disallowed", R[X] = "Numeric character references cannot be outside the permissible Unicode range";
          function J(k, y) {
            var _ = {}, N, V;
            y || (y = {});
            for (V in l)
              N = y[V], _[V] = N == null ? l[V] : N;
            return (_.position.indent || _.position.start) && (_.indent = _.position.indent || [], _.position = _.position.start), z(k, _);
          }
          function z(k, y) {
            var _ = y.additional, N = y.nonTerminated, V = y.text, W = y.reference, K = y.warning, ee = y.textContext, Y = y.referenceContext, te = y.warningContext, De = y.position, le = y.indent || [], ne = k.length, Z3 = 0, Q = -1, fe = De.column || 1, be = De.line || 1, pe = "", he = [], oe, de, ie, re, ye, se, ae, Ce, er, br, ke, Ue, qe, Fe, Eu, Ve, rr, ge, ce;
            for (typeof _ == "string" && (_ = _.charCodeAt(0)), Ve = $e(), Ce = K ? sa : a, Z3--, ne++; ++Z3 < ne; )
              if (ye === d && (fe = le[Q] || 1), ye = k.charCodeAt(Z3), ye === E) {
                if (ae = k.charCodeAt(Z3 + 1), ae === p || ae === d || ae === g || ae === F3 || ae === E || ae === f3 || ae !== ae || _ && ae === _) {
                  pe += D(ye), fe++;
                  continue;
                }
                for (qe = Z3 + 1, Ue = qe, ce = qe, ae === v ? (ce = ++Ue, ae = k.charCodeAt(ce), ae === h3 || ae === m3 ? (Fe = q, ce = ++Ue) : Fe = L) : Fe = B, oe = "", ke = "", re = "", Eu = O[Fe], ce--; ++ce < ne && (ae = k.charCodeAt(ce), !!Eu(ae)); )
                  re += D(ae), Fe === B && i3.call(u, re) && (oe = re, ke = u[re]);
                ie = k.charCodeAt(ce) === x3, ie && (ce++, de = Fe === B ? c(re) : false, de && (oe = re, ke = de)), ge = 1 + ce - qe, !ie && !N || (re ? Fe === B ? (ie && !ke ? Ce($, 1) : (oe !== re && (ce = Ue + oe.length, ge = 1 + ce - Ue, ie = false), ie || (er = oe ? T : A3, y.attribute ? (ae = k.charCodeAt(ce), ae === b ? (Ce(er, ge), ke = null) : s3(ae) ? ke = null : Ce(er, ge)) : Ce(er, ge))), se = ke) : (ie || Ce(P, ge), se = parseInt(re, w[Fe]), M(se) ? (Ce(X, ge), se = D(C)) : se in t3 ? (Ce(U, ge), se = t3[se]) : (br = "", G(se) && Ce(U, ge), se > 65535 && (se -= 65536, br += D(se >>> 10 | 55296), se = 56320 | se & 1023), se = br + D(se))) : Fe !== B && Ce(j, ge)), se ? (Cu(), Ve = $e(), Z3 = ce - 1, fe += ce - qe + 1, he.push(se), rr = $e(), rr.offset++, W && W.call(Y, se, { start: Ve, end: rr }, k.slice(qe - 1, ce)), Ve = rr) : (re = k.slice(qe - 1, ce), pe += re, fe += re.length, Z3 = ce - 1);
              } else
                ye === 10 && (be++, Q++, fe = 0), ye === ye ? (pe += D(ye), fe++) : Cu();
            return he.join("");
            function $e() {
              return { line: be, column: fe, offset: Z3 + (De.offset || 0) };
            }
            function sa(gu, Fu) {
              var yr = $e();
              yr.column += Fu, yr.offset += Fu, K.call(te, R[gu], yr, gu);
            }
            function Cu() {
              pe && (he.push(pe), V && V.call(ee, pe, { start: Ve, end: $e() }), pe = "");
            }
          }
          function M(k) {
            return k >= 55296 && k <= 57343 || k > 1114111;
          }
          function G(k) {
            return k >= 1 && k <= 8 || k === 11 || k >= 13 && k <= 31 || k >= 127 && k <= 159 || k >= 64976 && k <= 65007 || (k & 65535) === 65535 || (k & 65535) === 65534;
          }
        } }), Xl = S2({ "node_modules/remark-parse/lib/decode.js"(e3, r3) {
          "use strict";
          I();
          var u = Me(), t3 = xr();
          r3.exports = o;
          function o(n) {
            return c.raw = i3, c;
            function s3(a) {
              for (var l = n.offset, p = a.line, d = []; ++p && p in l; )
                d.push((l[p] || 0) + 1);
              return { start: a, indent: d };
            }
            function c(a, l, p) {
              t3(a, { position: s3(l), warning: D, text: p, reference: p, textContext: n, referenceContext: n });
            }
            function i3(a, l, p) {
              return t3(a, u(p, { position: s3(l), warning: D }));
            }
            function D(a, l, p) {
              p !== 3 && n.file.message(a, l);
            }
          }
        } }), Wl = S2({ "node_modules/remark-parse/lib/tokenizer.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(s3) {
            return c;
            function c(i3, D) {
              var a = this, l = a.offset, p = [], d = a[s3 + "Methods"], g = a[s3 + "Tokenizers"], F3 = D.line, E = D.column, x3, f3, b, v, h3, m3;
              if (!i3)
                return p;
              for (P.now = q, P.file = a.file, C(""); i3; ) {
                for (x3 = -1, f3 = d.length, h3 = false; ++x3 < f3 && (v = d[x3], b = g[v], !(b && (!b.onlyAtStart || a.atStart) && (!b.notInList || !a.inList) && (!b.notInBlock || !a.inBlock) && (!b.notInLink || !a.inLink) && (m3 = i3.length, b.apply(a, [P, i3]), h3 = m3 !== i3.length, h3))); )
                  ;
                h3 || a.file.fail(new Error("Infinite loop"), P.now());
              }
              return a.eof = q(), p;
              function C(A3) {
                for (var j = -1, $ = A3.indexOf(`
`); $ !== -1; )
                  F3++, j = $, $ = A3.indexOf(`
`, $ + 1);
                j === -1 ? E += A3.length : E = A3.length - j, F3 in l && (j !== -1 ? E += l[F3] : E <= l[F3] && (E = l[F3] + 1));
              }
              function B() {
                var A3 = [], j = F3 + 1;
                return function() {
                  for (var $ = F3 + 1; j < $; )
                    A3.push((l[j] || 0) + 1), j++;
                  return A3;
                };
              }
              function q() {
                var A3 = { line: F3, column: E };
                return A3.offset = a.toOffset(A3), A3;
              }
              function L(A3) {
                this.start = A3, this.end = q();
              }
              function w(A3) {
                i3.slice(0, A3.length) !== A3 && a.file.fail(new Error("Incorrectly eaten value: please report this warning on https://git.io/vg5Ft"), q());
              }
              function O() {
                var A3 = q();
                return j;
                function j($, U) {
                  var X = $.position, R = X ? X.start : A3, J = [], z = X && X.end.line, M = A3.line;
                  if ($.position = new L(R), X && U && X.indent) {
                    if (J = X.indent, z < M) {
                      for (; ++z < M; )
                        J.push((l[z] || 0) + 1);
                      J.push(A3.column);
                    }
                    U = J.concat(U);
                  }
                  return $.position.indent = U || [], $;
                }
              }
              function T(A3, j) {
                var $ = j ? j.children : p, U = $[$.length - 1], X;
                return U && A3.type === U.type && (A3.type === "text" || A3.type === "blockquote") && t3(U) && t3(A3) && (X = A3.type === "text" ? o : n, A3 = X.call(a, U, A3)), A3 !== U && $.push(A3), a.atStart && p.length !== 0 && a.exitStart(), A3;
              }
              function P(A3) {
                var j = B(), $ = O(), U = q();
                return w(A3), X.reset = R, R.test = J, X.test = J, i3 = i3.slice(A3.length), C(A3), j = j(), X;
                function X(z, M) {
                  return $(T($(z), M), j);
                }
                function R() {
                  var z = X.apply(null, arguments);
                  return F3 = U.line, E = U.column, i3 = A3 + i3, z;
                }
                function J() {
                  var z = $({});
                  return F3 = U.line, E = U.column, i3 = A3 + i3, z.position;
                }
              }
            }
          }
          function t3(s3) {
            var c, i3;
            return s3.type !== "text" || !s3.position ? true : (c = s3.position.start, i3 = s3.position.end, c.line !== i3.line || i3.column - c.column === s3.value.length);
          }
          function o(s3, c) {
            return s3.value += c.value, s3;
          }
          function n(s3, c) {
            return this.options.commonmark || this.options.gfm ? c : (s3.children = s3.children.concat(c.children), s3);
          }
        } }), Kl = S2({ "node_modules/markdown-escapes/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = n;
          var u = ["\\", "`", "*", "{", "}", "[", "]", "(", ")", "#", "+", "-", ".", "!", "_", ">"], t3 = u.concat(["~", "|"]), o = t3.concat([`
`, '"', "$", "%", "&", "'", ",", "/", ":", ";", "<", "=", "?", "@", "^"]);
          n.default = u, n.gfm = t3, n.commonmark = o;
          function n(s3) {
            var c = s3 || {};
            return c.commonmark ? o : c.gfm ? t3 : u;
          }
        } }), Yl = S2({ "node_modules/remark-parse/lib/block-elements.js"(e3, r3) {
          "use strict";
          I(), r3.exports = ["address", "article", "aside", "base", "basefont", "blockquote", "body", "caption", "center", "col", "colgroup", "dd", "details", "dialog", "dir", "div", "dl", "dt", "fieldset", "figcaption", "figure", "footer", "form", "frame", "frameset", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "iframe", "legend", "li", "link", "main", "menu", "menuitem", "meta", "nav", "noframes", "ol", "optgroup", "option", "p", "param", "pre", "section", "source", "title", "summary", "table", "tbody", "td", "tfoot", "th", "thead", "title", "tr", "track", "ul"];
        } }), Pi = S2({ "node_modules/remark-parse/lib/defaults.js"(e3, r3) {
          "use strict";
          I(), r3.exports = { position: true, gfm: true, commonmark: false, pedantic: false, blocks: Yl() };
        } }), Jl = S2({ "node_modules/remark-parse/lib/set-options.js"(e3, r3) {
          "use strict";
          I();
          var u = Me(), t3 = Kl(), o = Pi();
          r3.exports = n;
          function n(s3) {
            var c = this, i3 = c.options, D, a;
            if (s3 == null)
              s3 = {};
            else if (typeof s3 == "object")
              s3 = u(s3);
            else
              throw new Error("Invalid value `" + s3 + "` for setting `options`");
            for (D in o) {
              if (a = s3[D], a == null && (a = i3[D]), D !== "blocks" && typeof a != "boolean" || D === "blocks" && typeof a != "object")
                throw new Error("Invalid value `" + a + "` for setting `options." + D + "`");
              s3[D] = a;
            }
            return c.options = s3, c.escape = t3(s3), c;
          }
        } }), Zl = S2({ "node_modules/unist-util-is/convert.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(c) {
            if (c == null)
              return s3;
            if (typeof c == "string")
              return n(c);
            if (typeof c == "object")
              return "length" in c ? o(c) : t3(c);
            if (typeof c == "function")
              return c;
            throw new Error("Expected function, string, or object as test");
          }
          function t3(c) {
            return i3;
            function i3(D) {
              var a;
              for (a in c)
                if (D[a] !== c[a])
                  return false;
              return true;
            }
          }
          function o(c) {
            for (var i3 = [], D = -1; ++D < c.length; )
              i3[D] = u(c[D]);
            return a;
            function a() {
              for (var l = -1; ++l < i3.length; )
                if (i3[l].apply(this, arguments))
                  return true;
              return false;
            }
          }
          function n(c) {
            return i3;
            function i3(D) {
              return Boolean(D && D.type === c);
            }
          }
          function s3() {
            return true;
          }
        } }), Ql = S2({ "node_modules/unist-util-visit-parents/color.browser.js"(e3, r3) {
          I(), r3.exports = u;
          function u(t3) {
            return t3;
          }
        } }), eD = S2({ "node_modules/unist-util-visit-parents/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = c;
          var u = Zl(), t3 = Ql(), o = true, n = "skip", s3 = false;
          c.CONTINUE = o, c.SKIP = n, c.EXIT = s3;
          function c(D, a, l, p) {
            var d, g;
            typeof a == "function" && typeof l != "function" && (p = l, l = a, a = null), g = u(a), d = p ? -1 : 1, F3(D, null, [])();
            function F3(E, x3, f3) {
              var b = typeof E == "object" && E !== null ? E : {}, v;
              return typeof b.type == "string" && (v = typeof b.tagName == "string" ? b.tagName : typeof b.name == "string" ? b.name : void 0, h3.displayName = "node (" + t3(b.type + (v ? "<" + v + ">" : "")) + ")"), h3;
              function h3() {
                var m3 = f3.concat(E), C = [], B, q;
                if ((!a || g(E, x3, f3[f3.length - 1] || null)) && (C = i3(l(E, f3)), C[0] === s3))
                  return C;
                if (E.children && C[0] !== n)
                  for (q = (p ? E.children.length : -1) + d; q > -1 && q < E.children.length; ) {
                    if (B = F3(E.children[q], q, m3)(), B[0] === s3)
                      return B;
                    q = typeof B[1] == "number" ? B[1] : q + d;
                  }
                return C;
              }
            }
          }
          function i3(D) {
            return D !== null && typeof D == "object" && "length" in D ? D : typeof D == "number" ? [o, D] : [D];
          }
        } }), rD = S2({ "node_modules/unist-util-visit/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = s3;
          var u = eD(), t3 = u.CONTINUE, o = u.SKIP, n = u.EXIT;
          s3.CONTINUE = t3, s3.SKIP = o, s3.EXIT = n;
          function s3(c, i3, D, a) {
            typeof i3 == "function" && typeof D != "function" && (a = D, D = i3, i3 = null), u(c, i3, l, a);
            function l(p, d) {
              var g = d[d.length - 1], F3 = g ? g.children.indexOf(p) : null;
              return D(p, F3, g);
            }
          }
        } }), uD = S2({ "node_modules/unist-util-remove-position/index.js"(e3, r3) {
          "use strict";
          I();
          var u = rD();
          r3.exports = t3;
          function t3(s3, c) {
            return u(s3, c ? o : n), s3;
          }
          function o(s3) {
            delete s3.position;
          }
          function n(s3) {
            s3.position = void 0;
          }
        } }), tD = S2({ "node_modules/remark-parse/lib/parse.js"(e3, r3) {
          "use strict";
          I();
          var u = Me(), t3 = uD();
          r3.exports = s3;
          var o = `
`, n = /\r\n|\r/g;
          function s3() {
            var c = this, i3 = String(c.file), D = { line: 1, column: 1, offset: 0 }, a = u(D), l;
            return i3 = i3.replace(n, o), i3.charCodeAt(0) === 65279 && (i3 = i3.slice(1), a.column++, a.offset++), l = { type: "root", children: c.tokenizeBlock(i3, a), position: { start: D, end: c.eof || u(D) } }, c.options.position || t3(l, true), l;
          }
        } }), nD = S2({ "node_modules/remark-parse/lib/tokenize/blank-line.js"(e3, r3) {
          "use strict";
          I();
          var u = /^[ \t]*(\n|$)/;
          r3.exports = t3;
          function t3(o, n, s3) {
            for (var c, i3 = "", D = 0, a = n.length; D < a && (c = u.exec(n.slice(D)), c != null); )
              D += c[0].length, i3 += c[0];
            if (i3 !== "") {
              if (s3)
                return true;
              o(i3);
            }
          }
        } }), du = S2({ "node_modules/repeat-string/index.js"(e3, r3) {
          "use strict";
          I();
          var u = "", t3;
          r3.exports = o;
          function o(n, s3) {
            if (typeof n != "string")
              throw new TypeError("expected a string");
            if (s3 === 1)
              return n;
            if (s3 === 2)
              return n + n;
            var c = n.length * s3;
            if (t3 !== n || typeof t3 > "u")
              t3 = n, u = "";
            else if (u.length >= c)
              return u.substr(0, c);
            for (; c > u.length && s3 > 1; )
              s3 & 1 && (u += n), s3 >>= 1, n += n;
            return u += n, u = u.substr(0, c), u;
          }
        } }), Mi = S2({ "node_modules/trim-trailing-lines/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3) {
            return String(t3).replace(/\n+$/, "");
          }
        } }), iD = S2({ "node_modules/remark-parse/lib/tokenize/code-indented.js"(e3, r3) {
          "use strict";
          I();
          var u = du(), t3 = Mi();
          r3.exports = D;
          var o = `
`, n = "	", s3 = " ", c = 4, i3 = u(s3, c);
          function D(a, l, p) {
            for (var d = -1, g = l.length, F3 = "", E = "", x3 = "", f3 = "", b, v, h3; ++d < g; )
              if (b = l.charAt(d), h3)
                if (h3 = false, F3 += x3, E += f3, x3 = "", f3 = "", b === o)
                  x3 = b, f3 = b;
                else
                  for (F3 += b, E += b; ++d < g; ) {
                    if (b = l.charAt(d), !b || b === o) {
                      f3 = b, x3 = b;
                      break;
                    }
                    F3 += b, E += b;
                  }
              else if (b === s3 && l.charAt(d + 1) === b && l.charAt(d + 2) === b && l.charAt(d + 3) === b)
                x3 += i3, d += 3, h3 = true;
              else if (b === n)
                x3 += b, h3 = true;
              else {
                for (v = ""; b === n || b === s3; )
                  v += b, b = l.charAt(++d);
                if (b !== o)
                  break;
                x3 += v + b, f3 += b;
              }
            if (E)
              return p ? true : a(F3)({ type: "code", lang: null, meta: null, value: t3(E) });
          }
        } }), aD = S2({ "node_modules/remark-parse/lib/tokenize/code-fenced.js"(e3, r3) {
          "use strict";
          I(), r3.exports = D;
          var u = `
`, t3 = "	", o = " ", n = "~", s3 = "`", c = 3, i3 = 4;
          function D(a, l, p) {
            var d = this, g = d.options.gfm, F3 = l.length + 1, E = 0, x3 = "", f3, b, v, h3, m3, C, B, q, L, w, O, T, P;
            if (!!g) {
              for (; E < F3 && (v = l.charAt(E), !(v !== o && v !== t3)); )
                x3 += v, E++;
              if (T = E, v = l.charAt(E), !(v !== n && v !== s3)) {
                for (E++, b = v, f3 = 1, x3 += v; E < F3 && (v = l.charAt(E), v === b); )
                  x3 += v, f3++, E++;
                if (!(f3 < c)) {
                  for (; E < F3 && (v = l.charAt(E), !(v !== o && v !== t3)); )
                    x3 += v, E++;
                  for (h3 = "", B = ""; E < F3 && (v = l.charAt(E), !(v === u || b === s3 && v === b)); )
                    v === o || v === t3 ? B += v : (h3 += B + v, B = ""), E++;
                  if (v = l.charAt(E), !(v && v !== u)) {
                    if (p)
                      return true;
                    P = a.now(), P.column += x3.length, P.offset += x3.length, x3 += h3, h3 = d.decode.raw(d.unescape(h3), P), B && (x3 += B), B = "", w = "", O = "", q = "", L = "";
                    for (var A3 = true; E < F3; ) {
                      if (v = l.charAt(E), q += w, L += O, w = "", O = "", v !== u) {
                        q += v, O += v, E++;
                        continue;
                      }
                      for (A3 ? (x3 += v, A3 = false) : (w += v, O += v), B = "", E++; E < F3 && (v = l.charAt(E), v === o); )
                        B += v, E++;
                      if (w += B, O += B.slice(T), !(B.length >= i3)) {
                        for (B = ""; E < F3 && (v = l.charAt(E), v === b); )
                          B += v, E++;
                        if (w += B, O += B, !(B.length < f3)) {
                          for (B = ""; E < F3 && (v = l.charAt(E), !(v !== o && v !== t3)); )
                            w += v, O += v, E++;
                          if (!v || v === u)
                            break;
                        }
                      }
                    }
                    for (x3 += q + w, E = -1, F3 = h3.length; ++E < F3; )
                      if (v = h3.charAt(E), v === o || v === t3)
                        m3 || (m3 = h3.slice(0, E));
                      else if (m3) {
                        C = h3.slice(E);
                        break;
                      }
                    return a(x3)({ type: "code", lang: m3 || h3 || null, meta: C || null, value: L });
                  }
                }
              }
            }
          }
        } }), Ge = S2({ "node_modules/trim/index.js"(e3, r3) {
          I(), e3 = r3.exports = u;
          function u(t3) {
            return t3.replace(/^\s*|\s*$/g, "");
          }
          e3.left = function(t3) {
            return t3.replace(/^\s*/, "");
          }, e3.right = function(t3) {
            return t3.replace(/\s*$/, "");
          };
        } }), hu = S2({ "node_modules/remark-parse/lib/util/interrupt.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o, n, s3) {
            for (var c = t3.length, i3 = -1, D, a; ++i3 < c; )
              if (D = t3[i3], a = D[1] || {}, !(a.pedantic !== void 0 && a.pedantic !== n.options.pedantic) && !(a.commonmark !== void 0 && a.commonmark !== n.options.commonmark) && o[D[0]].apply(n, s3))
                return true;
            return false;
          }
        } }), oD = S2({ "node_modules/remark-parse/lib/tokenize/blockquote.js"(e3, r3) {
          "use strict";
          I();
          var u = Ge(), t3 = hu();
          r3.exports = i3;
          var o = `
`, n = "	", s3 = " ", c = ">";
          function i3(D, a, l) {
            for (var p = this, d = p.offset, g = p.blockTokenizers, F3 = p.interruptBlockquote, E = D.now(), x3 = E.line, f3 = a.length, b = [], v = [], h3 = [], m3, C = 0, B, q, L, w, O, T, P, A3; C < f3 && (B = a.charAt(C), !(B !== s3 && B !== n)); )
              C++;
            if (a.charAt(C) === c) {
              if (l)
                return true;
              for (C = 0; C < f3; ) {
                for (L = a.indexOf(o, C), T = C, P = false, L === -1 && (L = f3); C < f3 && (B = a.charAt(C), !(B !== s3 && B !== n)); )
                  C++;
                if (a.charAt(C) === c ? (C++, P = true, a.charAt(C) === s3 && C++) : C = T, w = a.slice(C, L), !P && !u(w)) {
                  C = T;
                  break;
                }
                if (!P && (q = a.slice(C), t3(F3, g, p, [D, q, true])))
                  break;
                O = T === C ? w : a.slice(T, L), h3.push(C - T), b.push(O), v.push(w), C = L + 1;
              }
              for (C = -1, f3 = h3.length, m3 = D(b.join(o)); ++C < f3; )
                d[x3] = (d[x3] || 0) + h3[C], x3++;
              return A3 = p.enterBlock(), v = p.tokenizeBlock(v.join(o), E), A3(), m3({ type: "blockquote", children: v });
            }
          }
        } }), sD = S2({ "node_modules/remark-parse/lib/tokenize/heading-atx.js"(e3, r3) {
          "use strict";
          I(), r3.exports = c;
          var u = `
`, t3 = "	", o = " ", n = "#", s3 = 6;
          function c(i3, D, a) {
            for (var l = this, p = l.options.pedantic, d = D.length + 1, g = -1, F3 = i3.now(), E = "", x3 = "", f3, b, v; ++g < d; ) {
              if (f3 = D.charAt(g), f3 !== o && f3 !== t3) {
                g--;
                break;
              }
              E += f3;
            }
            for (v = 0; ++g <= d; ) {
              if (f3 = D.charAt(g), f3 !== n) {
                g--;
                break;
              }
              E += f3, v++;
            }
            if (!(v > s3) && !(!v || !p && D.charAt(g + 1) === n)) {
              for (d = D.length + 1, b = ""; ++g < d; ) {
                if (f3 = D.charAt(g), f3 !== o && f3 !== t3) {
                  g--;
                  break;
                }
                b += f3;
              }
              if (!(!p && b.length === 0 && f3 && f3 !== u)) {
                if (a)
                  return true;
                for (E += b, b = "", x3 = ""; ++g < d && (f3 = D.charAt(g), !(!f3 || f3 === u)); ) {
                  if (f3 !== o && f3 !== t3 && f3 !== n) {
                    x3 += b + f3, b = "";
                    continue;
                  }
                  for (; f3 === o || f3 === t3; )
                    b += f3, f3 = D.charAt(++g);
                  if (!p && x3 && !b && f3 === n) {
                    x3 += f3;
                    continue;
                  }
                  for (; f3 === n; )
                    b += f3, f3 = D.charAt(++g);
                  for (; f3 === o || f3 === t3; )
                    b += f3, f3 = D.charAt(++g);
                  g--;
                }
                return F3.column += E.length, F3.offset += E.length, E += x3 + b, i3(E)({ type: "heading", depth: v, children: l.tokenizeInline(x3, F3) });
              }
            }
          }
        } }), cD = S2({ "node_modules/remark-parse/lib/tokenize/thematic-break.js"(e3, r3) {
          "use strict";
          I(), r3.exports = D;
          var u = "	", t3 = `
`, o = " ", n = "*", s3 = "-", c = "_", i3 = 3;
          function D(a, l, p) {
            for (var d = -1, g = l.length + 1, F3 = "", E, x3, f3, b; ++d < g && (E = l.charAt(d), !(E !== u && E !== o)); )
              F3 += E;
            if (!(E !== n && E !== s3 && E !== c))
              for (x3 = E, F3 += E, f3 = 1, b = ""; ++d < g; )
                if (E = l.charAt(d), E === x3)
                  f3++, F3 += b + x3, b = "";
                else if (E === o)
                  b += E;
                else
                  return f3 >= i3 && (!E || E === t3) ? (F3 += b, p ? true : a(F3)({ type: "thematicBreak" })) : void 0;
          }
        } }), zi = S2({ "node_modules/remark-parse/lib/util/get-indentation.js"(e3, r3) {
          "use strict";
          I(), r3.exports = s3;
          var u = "	", t3 = " ", o = 1, n = 4;
          function s3(c) {
            for (var i3 = 0, D = 0, a = c.charAt(i3), l = {}, p, d = 0; a === u || a === t3; ) {
              for (p = a === u ? n : o, D += p, p > 1 && (D = Math.floor(D / p) * p); d < D; )
                l[++d] = i3;
              a = c.charAt(++i3);
            }
            return { indent: D, stops: l };
          }
        } }), lD = S2({ "node_modules/remark-parse/lib/util/remove-indentation.js"(e3, r3) {
          "use strict";
          I();
          var u = Ge(), t3 = du(), o = zi();
          r3.exports = i3;
          var n = `
`, s3 = " ", c = "!";
          function i3(D, a) {
            var l = D.split(n), p = l.length + 1, d = 1 / 0, g = [], F3, E, x3;
            for (l.unshift(t3(s3, a) + c); p--; )
              if (E = o(l[p]), g[p] = E.stops, u(l[p]).length !== 0)
                if (E.indent)
                  E.indent > 0 && E.indent < d && (d = E.indent);
                else {
                  d = 1 / 0;
                  break;
                }
            if (d !== 1 / 0)
              for (p = l.length; p--; ) {
                for (x3 = g[p], F3 = d; F3 && !(F3 in x3); )
                  F3--;
                l[p] = l[p].slice(x3[F3] + 1);
              }
            return l.shift(), l.join(n);
          }
        } }), DD = S2({ "node_modules/remark-parse/lib/tokenize/list.js"(e3, r3) {
          "use strict";
          I();
          var u = Ge(), t3 = du(), o = ze(), n = zi(), s3 = lD(), c = hu();
          r3.exports = B;
          var i3 = "*", D = "_", a = "+", l = "-", p = ".", d = " ", g = `
`, F3 = "	", E = ")", x3 = "x", f3 = 4, b = /\n\n(?!\s*$)/, v = /^\[([ X\tx])][ \t]/, h3 = /^([ \t]*)([*+-]|\d+[.)])( {1,4}(?! )| |\t|$|(?=\n))([^\n]*)/, m3 = /^([ \t]*)([*+-]|\d+[.)])([ \t]+)/, C = /^( {1,4}|\t)?/gm;
          function B(O, T, P) {
            for (var A3 = this, j = A3.options.commonmark, $ = A3.options.pedantic, U = A3.blockTokenizers, X = A3.interruptList, R = 0, J = T.length, z = null, M, G, k, y, _, N, V, W, K, ee, Y, te, De, le, ne, Z3, Q, fe, be, pe = false, he, oe, de, ie; R < J && (y = T.charAt(R), !(y !== F3 && y !== d)); )
              R++;
            if (y = T.charAt(R), y === i3 || y === a || y === l)
              _ = y, k = false;
            else {
              for (k = true, G = ""; R < J && (y = T.charAt(R), !!o(y)); )
                G += y, R++;
              if (y = T.charAt(R), !G || !(y === p || j && y === E) || P && G !== "1")
                return;
              z = parseInt(G, 10), _ = y;
            }
            if (y = T.charAt(++R), !(y !== d && y !== F3 && ($ || y !== g && y !== ""))) {
              if (P)
                return true;
              for (R = 0, le = [], ne = [], Z3 = []; R < J; ) {
                for (N = T.indexOf(g, R), V = R, W = false, ie = false, N === -1 && (N = J), M = 0; R < J; ) {
                  if (y = T.charAt(R), y === F3)
                    M += f3 - M % f3;
                  else if (y === d)
                    M++;
                  else
                    break;
                  R++;
                }
                if (Q && M >= Q.indent && (ie = true), y = T.charAt(R), K = null, !ie) {
                  if (y === i3 || y === a || y === l)
                    K = y, R++, M++;
                  else {
                    for (G = ""; R < J && (y = T.charAt(R), !!o(y)); )
                      G += y, R++;
                    y = T.charAt(R), R++, G && (y === p || j && y === E) && (K = y, M += G.length + 1);
                  }
                  if (K)
                    if (y = T.charAt(R), y === F3)
                      M += f3 - M % f3, R++;
                    else if (y === d) {
                      for (de = R + f3; R < de && T.charAt(R) === d; )
                        R++, M++;
                      R === de && T.charAt(R) === d && (R -= f3 - 1, M -= f3 - 1);
                    } else
                      y !== g && y !== "" && (K = null);
                }
                if (K) {
                  if (!$ && _ !== K)
                    break;
                  W = true;
                } else
                  !j && !ie && T.charAt(V) === d ? ie = true : j && Q && (ie = M >= Q.indent || M > f3), W = false, R = V;
                if (Y = T.slice(V, N), ee = V === R ? Y : T.slice(R, N), (K === i3 || K === D || K === l) && U.thematicBreak.call(A3, O, Y, true))
                  break;
                if (te = De, De = !W && !u(ee).length, ie && Q)
                  Q.value = Q.value.concat(Z3, Y), ne = ne.concat(Z3, Y), Z3 = [];
                else if (W)
                  Z3.length !== 0 && (pe = true, Q.value.push(""), Q.trail = Z3.concat()), Q = { value: [Y], indent: M, trail: [] }, le.push(Q), ne = ne.concat(Z3, Y), Z3 = [];
                else if (De) {
                  if (te && !j)
                    break;
                  Z3.push(Y);
                } else {
                  if (te || c(X, U, A3, [O, Y, true]))
                    break;
                  Q.value = Q.value.concat(Z3, Y), ne = ne.concat(Z3, Y), Z3 = [];
                }
                R = N + 1;
              }
              for (he = O(ne.join(g)).reset({ type: "list", ordered: k, start: z, spread: pe, children: [] }), fe = A3.enterList(), be = A3.enterBlock(), R = -1, J = le.length; ++R < J; )
                Q = le[R].value.join(g), oe = O.now(), O(Q)(q(A3, Q, oe), he), Q = le[R].trail.join(g), R !== J - 1 && (Q += g), O(Q);
              return fe(), be(), he;
            }
          }
          function q(O, T, P) {
            var A3 = O.offset, j = O.options.pedantic ? L : w, $ = null, U, X;
            return T = j.apply(null, arguments), O.options.gfm && (U = T.match(v), U && (X = U[0].length, $ = U[1].toLowerCase() === x3, A3[P.line] += X, T = T.slice(X))), { type: "listItem", spread: b.test(T), checked: $, children: O.tokenizeBlock(T, P) };
          }
          function L(O, T, P) {
            var A3 = O.offset, j = P.line;
            return T = T.replace(m3, $), j = P.line, T.replace(C, $);
            function $(U) {
              return A3[j] = (A3[j] || 0) + U.length, j++, "";
            }
          }
          function w(O, T, P) {
            var A3 = O.offset, j = P.line, $, U, X, R, J, z, M;
            for (T = T.replace(h3, G), R = T.split(g), J = s3(T, n($).indent).split(g), J[0] = X, A3[j] = (A3[j] || 0) + U.length, j++, z = 0, M = R.length; ++z < M; )
              A3[j] = (A3[j] || 0) + R[z].length - J[z].length, j++;
            return J.join(g);
            function G(k, y, _, N, V) {
              return U = y + _ + N, X = V, Number(_) < 10 && U.length % 2 === 1 && (_ = d + _), $ = y + t3(d, _.length) + N, $ + X;
            }
          }
        } }), fD = S2({ "node_modules/remark-parse/lib/tokenize/heading-setext.js"(e3, r3) {
          "use strict";
          I(), r3.exports = a;
          var u = `
`, t3 = "	", o = " ", n = "=", s3 = "-", c = 3, i3 = 1, D = 2;
          function a(l, p, d) {
            for (var g = this, F3 = l.now(), E = p.length, x3 = -1, f3 = "", b, v, h3, m3, C; ++x3 < E; ) {
              if (h3 = p.charAt(x3), h3 !== o || x3 >= c) {
                x3--;
                break;
              }
              f3 += h3;
            }
            for (b = "", v = ""; ++x3 < E; ) {
              if (h3 = p.charAt(x3), h3 === u) {
                x3--;
                break;
              }
              h3 === o || h3 === t3 ? v += h3 : (b += v + h3, v = "");
            }
            if (F3.column += f3.length, F3.offset += f3.length, f3 += b + v, h3 = p.charAt(++x3), m3 = p.charAt(++x3), !(h3 !== u || m3 !== n && m3 !== s3)) {
              for (f3 += h3, v = m3, C = m3 === n ? i3 : D; ++x3 < E; ) {
                if (h3 = p.charAt(x3), h3 !== m3) {
                  if (h3 !== u)
                    return;
                  x3--;
                  break;
                }
                v += h3;
              }
              return d ? true : l(f3 + v)({ type: "heading", depth: C, children: g.tokenizeInline(b, F3) });
            }
          }
        } }), Gi = S2({ "node_modules/remark-parse/lib/util/html.js"(e3) {
          "use strict";
          I();
          var r3 = "[a-zA-Z_:][a-zA-Z0-9:._-]*", u = "[^\"'=<>`\\u0000-\\u0020]+", t3 = "'[^']*'", o = '"[^"]*"', n = "(?:" + u + "|" + t3 + "|" + o + ")", s3 = "(?:\\s+" + r3 + "(?:\\s*=\\s*" + n + ")?)", c = "<[A-Za-z][A-Za-z0-9\\-]*" + s3 + "*\\s*\\/?>", i3 = "<\\/[A-Za-z][A-Za-z0-9\\-]*\\s*>", D = "<!---->|<!--(?:-?[^>-])(?:-?[^-])*-->", a = "<[?].*?[?]>", l = "<![A-Za-z]+\\s+[^>]*>", p = "<!\\[CDATA\\[[\\s\\S]*?\\]\\]>";
          e3.openCloseTag = new RegExp("^(?:" + c + "|" + i3 + ")"), e3.tag = new RegExp("^(?:" + c + "|" + i3 + "|" + D + "|" + a + "|" + l + "|" + p + ")");
        } }), pD = S2({ "node_modules/remark-parse/lib/tokenize/html-block.js"(e3, r3) {
          "use strict";
          I();
          var u = Gi().openCloseTag;
          r3.exports = b;
          var t3 = "	", o = " ", n = `
`, s3 = "<", c = /^<(script|pre|style)(?=(\s|>|$))/i, i3 = /<\/(script|pre|style)>/i, D = /^<!--/, a = /-->/, l = /^<\?/, p = /\?>/, d = /^<![A-Za-z]/, g = />/, F3 = /^<!\[CDATA\[/, E = /]]>/, x3 = /^$/, f3 = new RegExp(u.source + "\\s*$");
          function b(v, h3, m3) {
            for (var C = this, B = C.options.blocks.join("|"), q = new RegExp("^</?(" + B + ")(?=(\\s|/?>|$))", "i"), L = h3.length, w = 0, O, T, P, A3, j, $, U, X = [[c, i3, true], [D, a, true], [l, p, true], [d, g, true], [F3, E, true], [q, x3, true], [f3, x3, false]]; w < L && (A3 = h3.charAt(w), !(A3 !== t3 && A3 !== o)); )
              w++;
            if (h3.charAt(w) === s3) {
              for (O = h3.indexOf(n, w + 1), O = O === -1 ? L : O, T = h3.slice(w, O), P = -1, j = X.length; ++P < j; )
                if (X[P][0].test(T)) {
                  $ = X[P];
                  break;
                }
              if (!!$) {
                if (m3)
                  return $[2];
                if (w = O, !$[1].test(T))
                  for (; w < L; ) {
                    if (O = h3.indexOf(n, w + 1), O = O === -1 ? L : O, T = h3.slice(w + 1, O), $[1].test(T)) {
                      T && (w = O);
                      break;
                    }
                    w = O;
                  }
                return U = h3.slice(0, w), v(U)({ type: "html", value: U });
              }
            }
          }
        } }), xe = S2({ "node_modules/is-whitespace-character/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = o;
          var u = String.fromCharCode, t3 = /\s/;
          function o(n) {
            return t3.test(typeof n == "number" ? u(n) : n.charAt(0));
          }
        } }), dD = S2({ "node_modules/collapse-white-space/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3) {
            return String(t3).replace(/\s+/g, " ");
          }
        } }), Ui = S2({ "node_modules/remark-parse/lib/util/normalize.js"(e3, r3) {
          "use strict";
          I();
          var u = dD();
          r3.exports = t3;
          function t3(o) {
            return u(o).toLowerCase();
          }
        } }), hD = S2({ "node_modules/remark-parse/lib/tokenize/definition.js"(e3, r3) {
          "use strict";
          I();
          var u = xe(), t3 = Ui();
          r3.exports = x3;
          var o = '"', n = "'", s3 = "\\", c = `
`, i3 = "	", D = " ", a = "[", l = "]", p = "(", d = ")", g = ":", F3 = "<", E = ">";
          function x3(v, h3, m3) {
            for (var C = this, B = C.options.commonmark, q = 0, L = h3.length, w = "", O, T, P, A3, j, $, U, X; q < L && (A3 = h3.charAt(q), !(A3 !== D && A3 !== i3)); )
              w += A3, q++;
            if (A3 = h3.charAt(q), A3 === a) {
              for (q++, w += A3, P = ""; q < L && (A3 = h3.charAt(q), A3 !== l); )
                A3 === s3 && (P += A3, q++, A3 = h3.charAt(q)), P += A3, q++;
              if (!(!P || h3.charAt(q) !== l || h3.charAt(q + 1) !== g)) {
                for ($ = P, w += P + l + g, q = w.length, P = ""; q < L && (A3 = h3.charAt(q), !(A3 !== i3 && A3 !== D && A3 !== c)); )
                  w += A3, q++;
                if (A3 = h3.charAt(q), P = "", O = w, A3 === F3) {
                  for (q++; q < L && (A3 = h3.charAt(q), !!f3(A3)); )
                    P += A3, q++;
                  if (A3 = h3.charAt(q), A3 === f3.delimiter)
                    w += F3 + P + A3, q++;
                  else {
                    if (B)
                      return;
                    q -= P.length + 1, P = "";
                  }
                }
                if (!P) {
                  for (; q < L && (A3 = h3.charAt(q), !!b(A3)); )
                    P += A3, q++;
                  w += P;
                }
                if (!!P) {
                  for (U = P, P = ""; q < L && (A3 = h3.charAt(q), !(A3 !== i3 && A3 !== D && A3 !== c)); )
                    P += A3, q++;
                  if (A3 = h3.charAt(q), j = null, A3 === o ? j = o : A3 === n ? j = n : A3 === p && (j = d), !j)
                    P = "", q = w.length;
                  else if (P) {
                    for (w += P + A3, q = w.length, P = ""; q < L && (A3 = h3.charAt(q), A3 !== j); ) {
                      if (A3 === c) {
                        if (q++, A3 = h3.charAt(q), A3 === c || A3 === j)
                          return;
                        P += c;
                      }
                      P += A3, q++;
                    }
                    if (A3 = h3.charAt(q), A3 !== j)
                      return;
                    T = w, w += P + A3, q++, X = P, P = "";
                  } else
                    return;
                  for (; q < L && (A3 = h3.charAt(q), !(A3 !== i3 && A3 !== D)); )
                    w += A3, q++;
                  if (A3 = h3.charAt(q), !A3 || A3 === c)
                    return m3 ? true : (O = v(O).test().end, U = C.decode.raw(C.unescape(U), O, { nonTerminated: false }), X && (T = v(T).test().end, X = C.decode.raw(C.unescape(X), T)), v(w)({ type: "definition", identifier: t3($), label: $, title: X || null, url: U }));
                }
              }
            }
          }
          function f3(v) {
            return v !== E && v !== a && v !== l;
          }
          f3.delimiter = E;
          function b(v) {
            return v !== a && v !== l && !u(v);
          }
        } }), vD = S2({ "node_modules/remark-parse/lib/tokenize/table.js"(e3, r3) {
          "use strict";
          I();
          var u = xe();
          r3.exports = F3;
          var t3 = "	", o = `
`, n = " ", s3 = "-", c = ":", i3 = "\\", D = "|", a = 1, l = 2, p = "left", d = "center", g = "right";
          function F3(E, x3, f3) {
            var b = this, v, h3, m3, C, B, q, L, w, O, T, P, A3, j, $, U, X, R, J, z, M, G, k;
            if (!!b.options.gfm) {
              for (v = 0, X = 0, q = x3.length + 1, L = []; v < q; ) {
                if (M = x3.indexOf(o, v), G = x3.indexOf(D, v + 1), M === -1 && (M = x3.length), G === -1 || G > M) {
                  if (X < l)
                    return;
                  break;
                }
                L.push(x3.slice(v, M)), X++, v = M + 1;
              }
              for (C = L.join(o), h3 = L.splice(1, 1)[0] || [], v = 0, q = h3.length, X--, m3 = false, P = []; v < q; ) {
                if (O = h3.charAt(v), O === D) {
                  if (T = null, m3 === false) {
                    if (k === false)
                      return;
                  } else
                    P.push(m3), m3 = false;
                  k = false;
                } else if (O === s3)
                  T = true, m3 = m3 || null;
                else if (O === c)
                  m3 === p ? m3 = d : T && m3 === null ? m3 = g : m3 = p;
                else if (!u(O))
                  return;
                v++;
              }
              if (m3 !== false && P.push(m3), !(P.length < a)) {
                if (f3)
                  return true;
                for (U = -1, J = [], z = E(C).reset({ type: "table", align: P, children: J }); ++U < X; ) {
                  for (R = L[U], B = { type: "tableRow", children: [] }, U && E(o), E(R).reset(B, z), q = R.length + 1, v = 0, w = "", A3 = "", j = true; v < q; ) {
                    if (O = R.charAt(v), O === t3 || O === n) {
                      A3 ? w += O : E(O), v++;
                      continue;
                    }
                    O === "" || O === D ? j ? E(O) : ((A3 || O) && !j && (C = A3, w.length > 1 && (O ? (C += w.slice(0, -1), w = w.charAt(w.length - 1)) : (C += w, w = "")), $ = E.now(), E(C)({ type: "tableCell", children: b.tokenizeInline(A3, $) }, B)), E(w + O), w = "", A3 = "") : (w && (A3 += w, w = ""), A3 += O, O === i3 && v !== q - 2 && (A3 += R.charAt(v + 1), v++)), j = false, v++;
                  }
                  U || E(o + h3);
                }
                return z;
              }
            }
          }
        } }), mD = S2({ "node_modules/remark-parse/lib/tokenize/paragraph.js"(e3, r3) {
          "use strict";
          I();
          var u = Ge(), t3 = Mi(), o = hu();
          r3.exports = D;
          var n = "	", s3 = `
`, c = " ", i3 = 4;
          function D(a, l, p) {
            for (var d = this, g = d.options, F3 = g.commonmark, E = d.blockTokenizers, x3 = d.interruptParagraph, f3 = l.indexOf(s3), b = l.length, v, h3, m3, C, B; f3 < b; ) {
              if (f3 === -1) {
                f3 = b;
                break;
              }
              if (l.charAt(f3 + 1) === s3)
                break;
              if (F3) {
                for (C = 0, v = f3 + 1; v < b; ) {
                  if (m3 = l.charAt(v), m3 === n) {
                    C = i3;
                    break;
                  } else if (m3 === c)
                    C++;
                  else
                    break;
                  v++;
                }
                if (C >= i3 && m3 !== s3) {
                  f3 = l.indexOf(s3, f3 + 1);
                  continue;
                }
              }
              if (h3 = l.slice(f3 + 1), o(x3, E, d, [a, h3, true]))
                break;
              if (v = f3, f3 = l.indexOf(s3, f3 + 1), f3 !== -1 && u(l.slice(v, f3)) === "") {
                f3 = v;
                break;
              }
            }
            return h3 = l.slice(0, f3), p ? true : (B = a.now(), h3 = t3(h3), a(h3)({ type: "paragraph", children: d.tokenizeInline(h3, B) }));
          }
        } }), ED = S2({ "node_modules/remark-parse/lib/locate/escape.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            return t3.indexOf("\\", o);
          }
        } }), CD = S2({ "node_modules/remark-parse/lib/tokenize/escape.js"(e3, r3) {
          "use strict";
          I();
          var u = ED();
          r3.exports = n, n.locator = u;
          var t3 = `
`, o = "\\";
          function n(s3, c, i3) {
            var D = this, a, l;
            if (c.charAt(0) === o && (a = c.charAt(1), D.escape.indexOf(a) !== -1))
              return i3 ? true : (a === t3 ? l = { type: "break" } : l = { type: "text", value: a }, s3(o + a)(l));
          }
        } }), Vi = S2({ "node_modules/remark-parse/lib/locate/tag.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            return t3.indexOf("<", o);
          }
        } }), gD = S2({ "node_modules/remark-parse/lib/tokenize/auto-link.js"(e3, r3) {
          "use strict";
          I();
          var u = xe(), t3 = xr(), o = Vi();
          r3.exports = l, l.locator = o, l.notInLink = true;
          var n = "<", s3 = ">", c = "@", i3 = "/", D = "mailto:", a = D.length;
          function l(p, d, g) {
            var F3 = this, E = "", x3 = d.length, f3 = 0, b = "", v = false, h3 = "", m3, C, B, q, L;
            if (d.charAt(0) === n) {
              for (f3++, E = n; f3 < x3 && (m3 = d.charAt(f3), !(u(m3) || m3 === s3 || m3 === c || m3 === ":" && d.charAt(f3 + 1) === i3)); )
                b += m3, f3++;
              if (!!b) {
                if (h3 += b, b = "", m3 = d.charAt(f3), h3 += m3, f3++, m3 === c)
                  v = true;
                else {
                  if (m3 !== ":" || d.charAt(f3 + 1) !== i3)
                    return;
                  h3 += i3, f3++;
                }
                for (; f3 < x3 && (m3 = d.charAt(f3), !(u(m3) || m3 === s3)); )
                  b += m3, f3++;
                if (m3 = d.charAt(f3), !(!b || m3 !== s3))
                  return g ? true : (h3 += b, B = h3, E += h3 + m3, C = p.now(), C.column++, C.offset++, v && (h3.slice(0, a).toLowerCase() === D ? (B = B.slice(a), C.column += a, C.offset += a) : h3 = D + h3), q = F3.inlineTokenizers, F3.inlineTokenizers = { text: q.text }, L = F3.enterLink(), B = F3.tokenizeInline(B, C), F3.inlineTokenizers = q, L(), p(E)({ type: "link", title: null, url: t3(h3, { nonTerminated: false }), children: B }));
              }
            }
          }
        } }), FD = S2({ "node_modules/ccount/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            var n = String(t3), s3 = 0, c;
            if (typeof o != "string")
              throw new Error("Expected character");
            for (c = n.indexOf(o); c !== -1; )
              s3++, c = n.indexOf(o, c + o.length);
            return s3;
          }
        } }), AD = S2({ "node_modules/remark-parse/lib/locate/url.js"(e3, r3) {
          "use strict";
          I(), r3.exports = t3;
          var u = ["www.", "http://", "https://"];
          function t3(o, n) {
            var s3 = -1, c, i3, D;
            if (!this.options.gfm)
              return s3;
            for (i3 = u.length, c = -1; ++c < i3; )
              D = o.indexOf(u[c], n), D !== -1 && (s3 === -1 || D < s3) && (s3 = D);
            return s3;
          }
        } }), xD = S2({ "node_modules/remark-parse/lib/tokenize/url.js"(e3, r3) {
          "use strict";
          I();
          var u = FD(), t3 = xr(), o = ze(), n = Qe(), s3 = xe(), c = AD();
          r3.exports = C, C.locator = c, C.notInLink = true;
          var i3 = 33, D = 38, a = 41, l = 42, p = 44, d = 45, g = 46, F3 = 58, E = 59, x3 = 63, f3 = 60, b = 95, v = 126, h3 = "(", m3 = ")";
          function C(B, q, L) {
            var w = this, O = w.options.gfm, T = w.inlineTokenizers, P = q.length, A3 = -1, j = false, $, U, X, R, J, z, M, G, k, y, _, N, V, W;
            if (!!O) {
              if (q.slice(0, 4) === "www.")
                j = true, R = 4;
              else if (q.slice(0, 7).toLowerCase() === "http://")
                R = 7;
              else if (q.slice(0, 8).toLowerCase() === "https://")
                R = 8;
              else
                return;
              for (A3 = R - 1, X = R, $ = []; R < P; ) {
                if (M = q.charCodeAt(R), M === g) {
                  if (A3 === R - 1)
                    break;
                  $.push(R), A3 = R, R++;
                  continue;
                }
                if (o(M) || n(M) || M === d || M === b) {
                  R++;
                  continue;
                }
                break;
              }
              if (M === g && ($.pop(), R--), $[0] !== void 0 && (U = $.length < 2 ? X : $[$.length - 2] + 1, q.slice(U, R).indexOf("_") === -1)) {
                if (L)
                  return true;
                for (G = R, J = R; R < P && (M = q.charCodeAt(R), !(s3(M) || M === f3)); )
                  R++, M === i3 || M === l || M === p || M === g || M === F3 || M === x3 || M === b || M === v || (G = R);
                if (R = G, q.charCodeAt(R - 1) === a)
                  for (z = q.slice(J, R), k = u(z, h3), y = u(z, m3); y > k; )
                    R = J + z.lastIndexOf(m3), z = q.slice(J, R), y--;
                if (q.charCodeAt(R - 1) === E && (R--, n(q.charCodeAt(R - 1)))) {
                  for (G = R - 2; n(q.charCodeAt(G)); )
                    G--;
                  q.charCodeAt(G) === D && (R = G);
                }
                return _ = q.slice(0, R), V = t3(_, { nonTerminated: false }), j && (V = "http://" + V), W = w.enterLink(), w.inlineTokenizers = { text: T.text }, N = w.tokenizeInline(_, B.now()), w.inlineTokenizers = T, W(), B(_)({ type: "link", title: null, url: V, children: N });
              }
            }
          }
        } }), bD = S2({ "node_modules/remark-parse/lib/locate/email.js"(e3, r3) {
          "use strict";
          I();
          var u = ze(), t3 = Qe(), o = 43, n = 45, s3 = 46, c = 95;
          r3.exports = i3;
          function i3(a, l) {
            var p = this, d, g;
            if (!this.options.gfm || (d = a.indexOf("@", l), d === -1))
              return -1;
            if (g = d, g === l || !D(a.charCodeAt(g - 1)))
              return i3.call(p, a, d + 1);
            for (; g > l && D(a.charCodeAt(g - 1)); )
              g--;
            return g;
          }
          function D(a) {
            return u(a) || t3(a) || a === o || a === n || a === s3 || a === c;
          }
        } }), yD = S2({ "node_modules/remark-parse/lib/tokenize/email.js"(e3, r3) {
          "use strict";
          I();
          var u = xr(), t3 = ze(), o = Qe(), n = bD();
          r3.exports = l, l.locator = n, l.notInLink = true;
          var s3 = 43, c = 45, i3 = 46, D = 64, a = 95;
          function l(p, d, g) {
            var F3 = this, E = F3.options.gfm, x3 = F3.inlineTokenizers, f3 = 0, b = d.length, v = -1, h3, m3, C, B;
            if (!!E) {
              for (h3 = d.charCodeAt(f3); t3(h3) || o(h3) || h3 === s3 || h3 === c || h3 === i3 || h3 === a; )
                h3 = d.charCodeAt(++f3);
              if (f3 !== 0 && h3 === D) {
                for (f3++; f3 < b; ) {
                  if (h3 = d.charCodeAt(f3), t3(h3) || o(h3) || h3 === c || h3 === i3 || h3 === a) {
                    f3++, v === -1 && h3 === i3 && (v = f3);
                    continue;
                  }
                  break;
                }
                if (!(v === -1 || v === f3 || h3 === c || h3 === a))
                  return h3 === i3 && f3--, m3 = d.slice(0, f3), g ? true : (B = F3.enterLink(), F3.inlineTokenizers = { text: x3.text }, C = F3.tokenizeInline(m3, p.now()), F3.inlineTokenizers = x3, B(), p(m3)({ type: "link", title: null, url: "mailto:" + u(m3, { nonTerminated: false }), children: C }));
              }
            }
          }
        } }), BD = S2({ "node_modules/remark-parse/lib/tokenize/html-inline.js"(e3, r3) {
          "use strict";
          I();
          var u = Qe(), t3 = Vi(), o = Gi().tag;
          r3.exports = l, l.locator = t3;
          var n = "<", s3 = "?", c = "!", i3 = "/", D = /^<a /i, a = /^<\/a>/i;
          function l(p, d, g) {
            var F3 = this, E = d.length, x3, f3;
            if (!(d.charAt(0) !== n || E < 3) && (x3 = d.charAt(1), !(!u(x3) && x3 !== s3 && x3 !== c && x3 !== i3) && (f3 = d.match(o), !!f3)))
              return g ? true : (f3 = f3[0], !F3.inLink && D.test(f3) ? F3.inLink = true : F3.inLink && a.test(f3) && (F3.inLink = false), p(f3)({ type: "html", value: f3 }));
          }
        } }), $i = S2({ "node_modules/remark-parse/lib/locate/link.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            var n = t3.indexOf("[", o), s3 = t3.indexOf("![", o);
            return s3 === -1 || n < s3 ? n : s3;
          }
        } }), wD = S2({ "node_modules/remark-parse/lib/tokenize/link.js"(e3, r3) {
          "use strict";
          I();
          var u = xe(), t3 = $i();
          r3.exports = E, E.locator = t3;
          var o = `
`, n = "!", s3 = '"', c = "'", i3 = "(", D = ")", a = "<", l = ">", p = "[", d = "\\", g = "]", F3 = "`";
          function E(x3, f3, b) {
            var v = this, h3 = "", m3 = 0, C = f3.charAt(0), B = v.options.pedantic, q = v.options.commonmark, L = v.options.gfm, w, O, T, P, A3, j, $, U, X, R, J, z, M, G, k, y, _, N;
            if (C === n && (U = true, h3 = C, C = f3.charAt(++m3)), C === p && !(!U && v.inLink)) {
              for (h3 += C, G = "", m3++, J = f3.length, y = x3.now(), M = 0, y.column += m3, y.offset += m3; m3 < J; ) {
                if (C = f3.charAt(m3), j = C, C === F3) {
                  for (O = 1; f3.charAt(m3 + 1) === F3; )
                    j += C, m3++, O++;
                  T ? O >= T && (T = 0) : T = O;
                } else if (C === d)
                  m3++, j += f3.charAt(m3);
                else if ((!T || L) && C === p)
                  M++;
                else if ((!T || L) && C === g)
                  if (M)
                    M--;
                  else {
                    if (f3.charAt(m3 + 1) !== i3)
                      return;
                    j += i3, w = true, m3++;
                    break;
                  }
                G += j, j = "", m3++;
              }
              if (!!w) {
                for (X = G, h3 += G + j, m3++; m3 < J && (C = f3.charAt(m3), !!u(C)); )
                  h3 += C, m3++;
                if (C = f3.charAt(m3), G = "", P = h3, C === a) {
                  for (m3++, P += a; m3 < J && (C = f3.charAt(m3), C !== l); ) {
                    if (q && C === o)
                      return;
                    G += C, m3++;
                  }
                  if (f3.charAt(m3) !== l)
                    return;
                  h3 += a + G + l, k = G, m3++;
                } else {
                  for (C = null, j = ""; m3 < J && (C = f3.charAt(m3), !(j && (C === s3 || C === c || q && C === i3))); ) {
                    if (u(C)) {
                      if (!B)
                        break;
                      j += C;
                    } else {
                      if (C === i3)
                        M++;
                      else if (C === D) {
                        if (M === 0)
                          break;
                        M--;
                      }
                      G += j, j = "", C === d && (G += d, C = f3.charAt(++m3)), G += C;
                    }
                    m3++;
                  }
                  h3 += G, k = G, m3 = h3.length;
                }
                for (G = ""; m3 < J && (C = f3.charAt(m3), !!u(C)); )
                  G += C, m3++;
                if (C = f3.charAt(m3), h3 += G, G && (C === s3 || C === c || q && C === i3))
                  if (m3++, h3 += C, G = "", R = C === i3 ? D : C, A3 = h3, q) {
                    for (; m3 < J && (C = f3.charAt(m3), C !== R); )
                      C === d && (G += d, C = f3.charAt(++m3)), m3++, G += C;
                    if (C = f3.charAt(m3), C !== R)
                      return;
                    for (z = G, h3 += G + C, m3++; m3 < J && (C = f3.charAt(m3), !!u(C)); )
                      h3 += C, m3++;
                  } else
                    for (j = ""; m3 < J; ) {
                      if (C = f3.charAt(m3), C === R)
                        $ && (G += R + j, j = ""), $ = true;
                      else if (!$)
                        G += C;
                      else if (C === D) {
                        h3 += G + R + j, z = G;
                        break;
                      } else
                        u(C) ? j += C : (G += R + j + C, j = "", $ = false);
                      m3++;
                    }
                if (f3.charAt(m3) === D)
                  return b ? true : (h3 += D, k = v.decode.raw(v.unescape(k), x3(P).test().end, { nonTerminated: false }), z && (A3 = x3(A3).test().end, z = v.decode.raw(v.unescape(z), A3)), N = { type: U ? "image" : "link", title: z || null, url: k }, U ? N.alt = v.decode.raw(v.unescape(X), y) || null : (_ = v.enterLink(), N.children = v.tokenizeInline(X, y), _()), x3(h3)(N));
              }
            }
          }
        } }), kD = S2({ "node_modules/remark-parse/lib/tokenize/reference.js"(e3, r3) {
          "use strict";
          I();
          var u = xe(), t3 = $i(), o = Ui();
          r3.exports = g, g.locator = t3;
          var n = "link", s3 = "image", c = "shortcut", i3 = "collapsed", D = "full", a = "!", l = "[", p = "\\", d = "]";
          function g(F3, E, x3) {
            var f3 = this, b = f3.options.commonmark, v = E.charAt(0), h3 = 0, m3 = E.length, C = "", B = "", q = n, L = c, w, O, T, P, A3, j, $, U;
            if (v === a && (q = s3, B = v, v = E.charAt(++h3)), v === l) {
              for (h3++, B += v, j = "", U = 0; h3 < m3; ) {
                if (v = E.charAt(h3), v === l)
                  $ = true, U++;
                else if (v === d) {
                  if (!U)
                    break;
                  U--;
                }
                v === p && (j += p, v = E.charAt(++h3)), j += v, h3++;
              }
              if (C = j, w = j, v = E.charAt(h3), v === d) {
                if (h3++, C += v, j = "", !b)
                  for (; h3 < m3 && (v = E.charAt(h3), !!u(v)); )
                    j += v, h3++;
                if (v = E.charAt(h3), v === l) {
                  for (O = "", j += v, h3++; h3 < m3 && (v = E.charAt(h3), !(v === l || v === d)); )
                    v === p && (O += p, v = E.charAt(++h3)), O += v, h3++;
                  v = E.charAt(h3), v === d ? (L = O ? D : i3, j += O + v, h3++) : O = "", C += j, j = "";
                } else {
                  if (!w)
                    return;
                  O = w;
                }
                if (!(L !== D && $))
                  return C = B + C, q === n && f3.inLink ? null : x3 ? true : (T = F3.now(), T.column += B.length, T.offset += B.length, O = L === D ? O : w, P = { type: q + "Reference", identifier: o(O), label: O, referenceType: L }, q === n ? (A3 = f3.enterLink(), P.children = f3.tokenizeInline(w, T), A3()) : P.alt = f3.decode.raw(f3.unescape(w), T) || null, F3(C)(P));
              }
            }
          }
        } }), qD = S2({ "node_modules/remark-parse/lib/locate/strong.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            var n = t3.indexOf("**", o), s3 = t3.indexOf("__", o);
            return s3 === -1 ? n : n === -1 || s3 < n ? s3 : n;
          }
        } }), _D = S2({ "node_modules/remark-parse/lib/tokenize/strong.js"(e3, r3) {
          "use strict";
          I();
          var u = Ge(), t3 = xe(), o = qD();
          r3.exports = i3, i3.locator = o;
          var n = "\\", s3 = "*", c = "_";
          function i3(D, a, l) {
            var p = this, d = 0, g = a.charAt(d), F3, E, x3, f3, b, v, h3;
            if (!(g !== s3 && g !== c || a.charAt(++d) !== g) && (E = p.options.pedantic, x3 = g, b = x3 + x3, v = a.length, d++, f3 = "", g = "", !(E && t3(a.charAt(d)))))
              for (; d < v; ) {
                if (h3 = g, g = a.charAt(d), g === x3 && a.charAt(d + 1) === x3 && (!E || !t3(h3)) && (g = a.charAt(d + 2), g !== x3))
                  return u(f3) ? l ? true : (F3 = D.now(), F3.column += 2, F3.offset += 2, D(b + f3 + b)({ type: "strong", children: p.tokenizeInline(f3, F3) })) : void 0;
                !E && g === n && (f3 += g, g = a.charAt(++d)), f3 += g, d++;
              }
          }
        } }), OD = S2({ "node_modules/is-word-character/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = o;
          var u = String.fromCharCode, t3 = /\w/;
          function o(n) {
            return t3.test(typeof n == "number" ? u(n) : n.charAt(0));
          }
        } }), ID = S2({ "node_modules/remark-parse/lib/locate/emphasis.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            var n = t3.indexOf("*", o), s3 = t3.indexOf("_", o);
            return s3 === -1 ? n : n === -1 || s3 < n ? s3 : n;
          }
        } }), SD = S2({ "node_modules/remark-parse/lib/tokenize/emphasis.js"(e3, r3) {
          "use strict";
          I();
          var u = Ge(), t3 = OD(), o = xe(), n = ID();
          r3.exports = D, D.locator = n;
          var s3 = "*", c = "_", i3 = "\\";
          function D(a, l, p) {
            var d = this, g = 0, F3 = l.charAt(g), E, x3, f3, b, v, h3, m3;
            if (!(F3 !== s3 && F3 !== c) && (x3 = d.options.pedantic, v = F3, f3 = F3, h3 = l.length, g++, b = "", F3 = "", !(x3 && o(l.charAt(g)))))
              for (; g < h3; ) {
                if (m3 = F3, F3 = l.charAt(g), F3 === f3 && (!x3 || !o(m3))) {
                  if (F3 = l.charAt(++g), F3 !== f3) {
                    if (!u(b) || m3 === f3)
                      return;
                    if (!x3 && f3 === c && t3(F3)) {
                      b += f3;
                      continue;
                    }
                    return p ? true : (E = a.now(), E.column++, E.offset++, a(v + b + f3)({ type: "emphasis", children: d.tokenizeInline(b, E) }));
                  }
                  b += f3;
                }
                !x3 && F3 === i3 && (b += F3, F3 = l.charAt(++g)), b += F3, g++;
              }
          }
        } }), TD = S2({ "node_modules/remark-parse/lib/locate/delete.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            return t3.indexOf("~~", o);
          }
        } }), ND = S2({ "node_modules/remark-parse/lib/tokenize/delete.js"(e3, r3) {
          "use strict";
          I();
          var u = xe(), t3 = TD();
          r3.exports = s3, s3.locator = t3;
          var o = "~", n = "~~";
          function s3(c, i3, D) {
            var a = this, l = "", p = "", d = "", g = "", F3, E, x3;
            if (!(!a.options.gfm || i3.charAt(0) !== o || i3.charAt(1) !== o || u(i3.charAt(2))))
              for (F3 = 1, E = i3.length, x3 = c.now(), x3.column += 2, x3.offset += 2; ++F3 < E; ) {
                if (l = i3.charAt(F3), l === o && p === o && (!d || !u(d)))
                  return D ? true : c(n + g + n)({ type: "delete", children: a.tokenizeInline(g, x3) });
                g += p, d = p, p = l;
              }
          }
        } }), LD = S2({ "node_modules/remark-parse/lib/locate/code-inline.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            return t3.indexOf("`", o);
          }
        } }), RD = S2({ "node_modules/remark-parse/lib/tokenize/code-inline.js"(e3, r3) {
          "use strict";
          I();
          var u = LD();
          r3.exports = s3, s3.locator = u;
          var t3 = 10, o = 32, n = 96;
          function s3(c, i3, D) {
            for (var a = i3.length, l = 0, p, d, g, F3, E, x3; l < a && i3.charCodeAt(l) === n; )
              l++;
            if (!(l === 0 || l === a)) {
              for (p = l, E = i3.charCodeAt(l); l < a; ) {
                if (F3 = E, E = i3.charCodeAt(l + 1), F3 === n) {
                  if (d === void 0 && (d = l), g = l + 1, E !== n && g - d === p) {
                    x3 = true;
                    break;
                  }
                } else
                  d !== void 0 && (d = void 0, g = void 0);
                l++;
              }
              if (!!x3) {
                if (D)
                  return true;
                if (l = p, a = d, F3 = i3.charCodeAt(l), E = i3.charCodeAt(a - 1), x3 = false, a - l > 2 && (F3 === o || F3 === t3) && (E === o || E === t3)) {
                  for (l++, a--; l < a; ) {
                    if (F3 = i3.charCodeAt(l), F3 !== o && F3 !== t3) {
                      x3 = true;
                      break;
                    }
                    l++;
                  }
                  x3 === true && (p++, d--);
                }
                return c(i3.slice(0, g))({ type: "inlineCode", value: i3.slice(p, d) });
              }
            }
          }
        } }), jD = S2({ "node_modules/remark-parse/lib/locate/break.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o) {
            for (var n = t3.indexOf(`
`, o); n > o && t3.charAt(n - 1) === " "; )
              n--;
            return n;
          }
        } }), PD = S2({ "node_modules/remark-parse/lib/tokenize/break.js"(e3, r3) {
          "use strict";
          I();
          var u = jD();
          r3.exports = s3, s3.locator = u;
          var t3 = " ", o = `
`, n = 2;
          function s3(c, i3, D) {
            for (var a = i3.length, l = -1, p = "", d; ++l < a; ) {
              if (d = i3.charAt(l), d === o)
                return l < n ? void 0 : D ? true : (p += d, c(p)({ type: "break" }));
              if (d !== t3)
                return;
              p += d;
            }
          }
        } }), MD = S2({ "node_modules/remark-parse/lib/tokenize/text.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3, o, n) {
            var s3 = this, c, i3, D, a, l, p, d, g, F3, E;
            if (n)
              return true;
            for (c = s3.inlineMethods, a = c.length, i3 = s3.inlineTokenizers, D = -1, F3 = o.length; ++D < a; )
              g = c[D], !(g === "text" || !i3[g]) && (d = i3[g].locator, d || t3.file.fail("Missing locator: `" + g + "`"), p = d.call(s3, o, 1), p !== -1 && p < F3 && (F3 = p));
            l = o.slice(0, F3), E = t3.now(), s3.decode(l, E, x3);
            function x3(f3, b, v) {
              t3(v || f3)({ type: "text", value: f3 });
            }
          }
        } }), zD = S2({ "node_modules/remark-parse/lib/parser.js"(e3, r3) {
          "use strict";
          I();
          var u = Me(), t3 = jl(), o = Pl(), n = Ml(), s3 = Xl(), c = Wl();
          r3.exports = i3;
          function i3(l, p) {
            this.file = p, this.offset = {}, this.options = u(this.options), this.setOptions({}), this.inList = false, this.inBlock = false, this.inLink = false, this.atStart = true, this.toOffset = o(p).toOffset, this.unescape = n(this, "escape"), this.decode = s3(this);
          }
          var D = i3.prototype;
          D.setOptions = Jl(), D.parse = tD(), D.options = Pi(), D.exitStart = t3("atStart", true), D.enterList = t3("inList", false), D.enterLink = t3("inLink", false), D.enterBlock = t3("inBlock", false), D.interruptParagraph = [["thematicBreak"], ["list"], ["atxHeading"], ["fencedCode"], ["blockquote"], ["html"], ["setextHeading", { commonmark: false }], ["definition", { commonmark: false }]], D.interruptList = [["atxHeading", { pedantic: false }], ["fencedCode", { pedantic: false }], ["thematicBreak", { pedantic: false }], ["definition", { commonmark: false }]], D.interruptBlockquote = [["indentedCode", { commonmark: true }], ["fencedCode", { commonmark: true }], ["atxHeading", { commonmark: true }], ["setextHeading", { commonmark: true }], ["thematicBreak", { commonmark: true }], ["html", { commonmark: true }], ["list", { commonmark: true }], ["definition", { commonmark: false }]], D.blockTokenizers = { blankLine: nD(), indentedCode: iD(), fencedCode: aD(), blockquote: oD(), atxHeading: sD(), thematicBreak: cD(), list: DD(), setextHeading: fD(), html: pD(), definition: hD(), table: vD(), paragraph: mD() }, D.inlineTokenizers = { escape: CD(), autoLink: gD(), url: xD(), email: yD(), html: BD(), link: wD(), reference: kD(), strong: _D(), emphasis: SD(), deletion: ND(), code: RD(), break: PD(), text: MD() }, D.blockMethods = a(D.blockTokenizers), D.inlineMethods = a(D.inlineTokenizers), D.tokenizeBlock = c("block"), D.tokenizeInline = c("inline"), D.tokenizeFactory = c;
          function a(l) {
            var p = [], d;
            for (d in l)
              p.push(d);
            return p;
          }
        } }), GD = S2({ "node_modules/remark-parse/index.js"(e3, r3) {
          "use strict";
          I();
          var u = Rl(), t3 = Me(), o = zD();
          r3.exports = n, n.Parser = o;
          function n(s3) {
            var c = this.data("settings"), i3 = u(o);
            i3.prototype.options = t3(i3.prototype.options, c, s3), this.Parser = i3;
          }
        } }), UD = S2({ "node_modules/bail/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = u;
          function u(t3) {
            if (t3)
              throw t3;
          }
        } }), Hi = S2({ "node_modules/is-buffer/index.js"(e3, r3) {
          I(), r3.exports = function(t3) {
            return t3 != null && t3.constructor != null && typeof t3.constructor.isBuffer == "function" && t3.constructor.isBuffer(t3);
          };
        } }), VD = S2({ "node_modules/extend/index.js"(e3, r3) {
          "use strict";
          I();
          var u = Object.prototype.hasOwnProperty, t3 = Object.prototype.toString, o = Object.defineProperty, n = Object.getOwnPropertyDescriptor, s3 = function(l) {
            return typeof Array.isArray == "function" ? Array.isArray(l) : t3.call(l) === "[object Array]";
          }, c = function(l) {
            if (!l || t3.call(l) !== "[object Object]")
              return false;
            var p = u.call(l, "constructor"), d = l.constructor && l.constructor.prototype && u.call(l.constructor.prototype, "isPrototypeOf");
            if (l.constructor && !p && !d)
              return false;
            var g;
            for (g in l)
              ;
            return typeof g > "u" || u.call(l, g);
          }, i3 = function(l, p) {
            o && p.name === "__proto__" ? o(l, p.name, { enumerable: true, configurable: true, value: p.newValue, writable: true }) : l[p.name] = p.newValue;
          }, D = function(l, p) {
            if (p === "__proto__")
              if (u.call(l, p)) {
                if (n)
                  return n(l, p).value;
              } else
                return;
            return l[p];
          };
          r3.exports = function a() {
            var l, p, d, g, F3, E, x3 = arguments[0], f3 = 1, b = arguments.length, v = false;
            for (typeof x3 == "boolean" && (v = x3, x3 = arguments[1] || {}, f3 = 2), (x3 == null || typeof x3 != "object" && typeof x3 != "function") && (x3 = {}); f3 < b; ++f3)
              if (l = arguments[f3], l != null)
                for (p in l)
                  d = D(x3, p), g = D(l, p), x3 !== g && (v && g && (c(g) || (F3 = s3(g))) ? (F3 ? (F3 = false, E = d && s3(d) ? d : []) : E = d && c(d) ? d : {}, i3(x3, { name: p, newValue: a(v, E, g) })) : typeof g < "u" && i3(x3, { name: p, newValue: g }));
            return x3;
          };
        } }), $D = S2({ "node_modules/is-plain-obj/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = (u) => {
            if (Object.prototype.toString.call(u) !== "[object Object]")
              return false;
            let t3 = Object.getPrototypeOf(u);
            return t3 === null || t3 === Object.prototype;
          };
        } }), HD = S2({ "node_modules/trough/wrap.js"(e3, r3) {
          "use strict";
          I();
          var u = [].slice;
          r3.exports = t3;
          function t3(o, n) {
            var s3;
            return c;
            function c() {
              var a = u.call(arguments, 0), l = o.length > a.length, p;
              l && a.push(i3);
              try {
                p = o.apply(null, a);
              } catch (d) {
                if (l && s3)
                  throw d;
                return i3(d);
              }
              l || (p && typeof p.then == "function" ? p.then(D, i3) : p instanceof Error ? i3(p) : D(p));
            }
            function i3() {
              s3 || (s3 = true, n.apply(null, arguments));
            }
            function D(a) {
              i3(null, a);
            }
          }
        } }), XD = S2({ "node_modules/trough/index.js"(e3, r3) {
          "use strict";
          I();
          var u = HD();
          r3.exports = o, o.wrap = u;
          var t3 = [].slice;
          function o() {
            var n = [], s3 = {};
            return s3.run = c, s3.use = i3, s3;
            function c() {
              var D = -1, a = t3.call(arguments, 0, -1), l = arguments[arguments.length - 1];
              if (typeof l != "function")
                throw new Error("Expected function as last argument, not " + l);
              p.apply(null, [null].concat(a));
              function p(d) {
                var g = n[++D], F3 = t3.call(arguments, 0), E = F3.slice(1), x3 = a.length, f3 = -1;
                if (d) {
                  l(d);
                  return;
                }
                for (; ++f3 < x3; )
                  (E[f3] === null || E[f3] === void 0) && (E[f3] = a[f3]);
                a = E, g ? u(g, p).apply(null, a) : l.apply(null, [null].concat(a));
              }
            }
            function i3(D) {
              if (typeof D != "function")
                throw new Error("Expected `fn` to be a function, not " + D);
              return n.push(D), s3;
            }
          }
        } }), WD = S2({ "node_modules/unist-util-stringify-position/index.js"(e3, r3) {
          "use strict";
          I();
          var u = {}.hasOwnProperty;
          r3.exports = t3;
          function t3(c) {
            return !c || typeof c != "object" ? "" : u.call(c, "position") || u.call(c, "type") ? n(c.position) : u.call(c, "start") || u.call(c, "end") ? n(c) : u.call(c, "line") || u.call(c, "column") ? o(c) : "";
          }
          function o(c) {
            return (!c || typeof c != "object") && (c = {}), s3(c.line) + ":" + s3(c.column);
          }
          function n(c) {
            return (!c || typeof c != "object") && (c = {}), o(c.start) + "-" + o(c.end);
          }
          function s3(c) {
            return c && typeof c == "number" ? c : 1;
          }
        } }), KD = S2({ "node_modules/vfile-message/index.js"(e3, r3) {
          "use strict";
          I();
          var u = WD();
          r3.exports = n;
          function t3() {
          }
          t3.prototype = Error.prototype, n.prototype = new t3();
          var o = n.prototype;
          o.file = "", o.name = "", o.reason = "", o.message = "", o.stack = "", o.fatal = null, o.column = null, o.line = null;
          function n(c, i3, D) {
            var a, l, p;
            typeof i3 == "string" && (D = i3, i3 = null), a = s3(D), l = u(i3) || "1:1", p = { start: { line: null, column: null }, end: { line: null, column: null } }, i3 && i3.position && (i3 = i3.position), i3 && (i3.start ? (p = i3, i3 = i3.start) : p.start = i3), c.stack && (this.stack = c.stack, c = c.message), this.message = c, this.name = l, this.reason = c, this.line = i3 ? i3.line : null, this.column = i3 ? i3.column : null, this.location = p, this.source = a[0], this.ruleId = a[1];
          }
          function s3(c) {
            var i3 = [null, null], D;
            return typeof c == "string" && (D = c.indexOf(":"), D === -1 ? i3[1] = c : (i3[0] = c.slice(0, D), i3[1] = c.slice(D + 1))), i3;
          }
        } }), YD = S2({ "node_modules/vfile/lib/minpath.browser.js"(e3) {
          "use strict";
          I(), e3.basename = r3, e3.dirname = u, e3.extname = t3, e3.join = o, e3.sep = "/";
          function r3(i3, D) {
            var a = 0, l = -1, p, d, g, F3;
            if (D !== void 0 && typeof D != "string")
              throw new TypeError('"ext" argument must be a string');
            if (c(i3), p = i3.length, D === void 0 || !D.length || D.length > i3.length) {
              for (; p--; )
                if (i3.charCodeAt(p) === 47) {
                  if (g) {
                    a = p + 1;
                    break;
                  }
                } else
                  l < 0 && (g = true, l = p + 1);
              return l < 0 ? "" : i3.slice(a, l);
            }
            if (D === i3)
              return "";
            for (d = -1, F3 = D.length - 1; p--; )
              if (i3.charCodeAt(p) === 47) {
                if (g) {
                  a = p + 1;
                  break;
                }
              } else
                d < 0 && (g = true, d = p + 1), F3 > -1 && (i3.charCodeAt(p) === D.charCodeAt(F3--) ? F3 < 0 && (l = p) : (F3 = -1, l = d));
            return a === l ? l = d : l < 0 && (l = i3.length), i3.slice(a, l);
          }
          function u(i3) {
            var D, a, l;
            if (c(i3), !i3.length)
              return ".";
            for (D = -1, l = i3.length; --l; )
              if (i3.charCodeAt(l) === 47) {
                if (a) {
                  D = l;
                  break;
                }
              } else
                a || (a = true);
            return D < 0 ? i3.charCodeAt(0) === 47 ? "/" : "." : D === 1 && i3.charCodeAt(0) === 47 ? "//" : i3.slice(0, D);
          }
          function t3(i3) {
            var D = -1, a = 0, l = -1, p = 0, d, g, F3;
            for (c(i3), F3 = i3.length; F3--; ) {
              if (g = i3.charCodeAt(F3), g === 47) {
                if (d) {
                  a = F3 + 1;
                  break;
                }
                continue;
              }
              l < 0 && (d = true, l = F3 + 1), g === 46 ? D < 0 ? D = F3 : p !== 1 && (p = 1) : D > -1 && (p = -1);
            }
            return D < 0 || l < 0 || p === 0 || p === 1 && D === l - 1 && D === a + 1 ? "" : i3.slice(D, l);
          }
          function o() {
            for (var i3 = -1, D; ++i3 < arguments.length; )
              c(arguments[i3]), arguments[i3] && (D = D === void 0 ? arguments[i3] : D + "/" + arguments[i3]);
            return D === void 0 ? "." : n(D);
          }
          function n(i3) {
            var D, a;
            return c(i3), D = i3.charCodeAt(0) === 47, a = s3(i3, !D), !a.length && !D && (a = "."), a.length && i3.charCodeAt(i3.length - 1) === 47 && (a += "/"), D ? "/" + a : a;
          }
          function s3(i3, D) {
            for (var a = "", l = 0, p = -1, d = 0, g = -1, F3, E; ++g <= i3.length; ) {
              if (g < i3.length)
                F3 = i3.charCodeAt(g);
              else {
                if (F3 === 47)
                  break;
                F3 = 47;
              }
              if (F3 === 47) {
                if (!(p === g - 1 || d === 1))
                  if (p !== g - 1 && d === 2) {
                    if (a.length < 2 || l !== 2 || a.charCodeAt(a.length - 1) !== 46 || a.charCodeAt(a.length - 2) !== 46) {
                      if (a.length > 2) {
                        if (E = a.lastIndexOf("/"), E !== a.length - 1) {
                          E < 0 ? (a = "", l = 0) : (a = a.slice(0, E), l = a.length - 1 - a.lastIndexOf("/")), p = g, d = 0;
                          continue;
                        }
                      } else if (a.length) {
                        a = "", l = 0, p = g, d = 0;
                        continue;
                      }
                    }
                    D && (a = a.length ? a + "/.." : "..", l = 2);
                  } else
                    a.length ? a += "/" + i3.slice(p + 1, g) : a = i3.slice(p + 1, g), l = g - p - 1;
                p = g, d = 0;
              } else
                F3 === 46 && d > -1 ? d++ : d = -1;
            }
            return a;
          }
          function c(i3) {
            if (typeof i3 != "string")
              throw new TypeError("Path must be a string. Received " + JSON.stringify(i3));
          }
        } }), JD = S2({ "node_modules/vfile/lib/minproc.browser.js"(e3) {
          "use strict";
          I(), e3.cwd = r3;
          function r3() {
            return "/";
          }
        } }), ZD = S2({ "node_modules/vfile/lib/core.js"(e3, r3) {
          "use strict";
          I();
          var u = YD(), t3 = JD(), o = Hi();
          r3.exports = c;
          var n = {}.hasOwnProperty, s3 = ["history", "path", "basename", "stem", "extname", "dirname"];
          c.prototype.toString = f3, Object.defineProperty(c.prototype, "path", { get: i3, set: D }), Object.defineProperty(c.prototype, "dirname", { get: a, set: l }), Object.defineProperty(c.prototype, "basename", { get: p, set: d }), Object.defineProperty(c.prototype, "extname", { get: g, set: F3 }), Object.defineProperty(c.prototype, "stem", { get: E, set: x3 });
          function c(m3) {
            var C, B;
            if (!m3)
              m3 = {};
            else if (typeof m3 == "string" || o(m3))
              m3 = { contents: m3 };
            else if ("message" in m3 && "messages" in m3)
              return m3;
            if (!(this instanceof c))
              return new c(m3);
            for (this.data = {}, this.messages = [], this.history = [], this.cwd = t3.cwd(), B = -1; ++B < s3.length; )
              C = s3[B], n.call(m3, C) && (this[C] = m3[C]);
            for (C in m3)
              s3.indexOf(C) < 0 && (this[C] = m3[C]);
          }
          function i3() {
            return this.history[this.history.length - 1];
          }
          function D(m3) {
            v(m3, "path"), this.path !== m3 && this.history.push(m3);
          }
          function a() {
            return typeof this.path == "string" ? u.dirname(this.path) : void 0;
          }
          function l(m3) {
            h3(this.path, "dirname"), this.path = u.join(m3 || "", this.basename);
          }
          function p() {
            return typeof this.path == "string" ? u.basename(this.path) : void 0;
          }
          function d(m3) {
            v(m3, "basename"), b(m3, "basename"), this.path = u.join(this.dirname || "", m3);
          }
          function g() {
            return typeof this.path == "string" ? u.extname(this.path) : void 0;
          }
          function F3(m3) {
            if (b(m3, "extname"), h3(this.path, "extname"), m3) {
              if (m3.charCodeAt(0) !== 46)
                throw new Error("`extname` must start with `.`");
              if (m3.indexOf(".", 1) > -1)
                throw new Error("`extname` cannot contain multiple dots");
            }
            this.path = u.join(this.dirname, this.stem + (m3 || ""));
          }
          function E() {
            return typeof this.path == "string" ? u.basename(this.path, this.extname) : void 0;
          }
          function x3(m3) {
            v(m3, "stem"), b(m3, "stem"), this.path = u.join(this.dirname || "", m3 + (this.extname || ""));
          }
          function f3(m3) {
            return (this.contents || "").toString(m3);
          }
          function b(m3, C) {
            if (m3 && m3.indexOf(u.sep) > -1)
              throw new Error("`" + C + "` cannot be a path: did not expect `" + u.sep + "`");
          }
          function v(m3, C) {
            if (!m3)
              throw new Error("`" + C + "` cannot be empty");
          }
          function h3(m3, C) {
            if (!m3)
              throw new Error("Setting `" + C + "` requires `path` to be set too");
          }
        } }), QD = S2({ "node_modules/vfile/lib/index.js"(e3, r3) {
          "use strict";
          I();
          var u = KD(), t3 = ZD();
          r3.exports = t3, t3.prototype.message = o, t3.prototype.info = s3, t3.prototype.fail = n;
          function o(c, i3, D) {
            var a = new u(c, i3, D);
            return this.path && (a.name = this.path + ":" + a.name, a.file = this.path), a.fatal = false, this.messages.push(a), a;
          }
          function n() {
            var c = this.message.apply(this, arguments);
            throw c.fatal = true, c;
          }
          function s3() {
            var c = this.message.apply(this, arguments);
            return c.fatal = null, c;
          }
        } }), e2 = S2({ "node_modules/vfile/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = QD();
        } }), r2 = S2({ "node_modules/unified/index.js"(e3, r3) {
          "use strict";
          I();
          var u = UD(), t3 = Hi(), o = VD(), n = $D(), s3 = XD(), c = e2();
          r3.exports = g().freeze();
          var i3 = [].slice, D = {}.hasOwnProperty, a = s3().use(l).use(p).use(d);
          function l(m3, C) {
            C.tree = m3.parse(C.file);
          }
          function p(m3, C, B) {
            m3.run(C.tree, C.file, q);
            function q(L, w, O) {
              L ? B(L) : (C.tree = w, C.file = O, B());
            }
          }
          function d(m3, C) {
            var B = m3.stringify(C.tree, C.file);
            B == null || (typeof B == "string" || t3(B) ? C.file.contents = B : C.file.result = B);
          }
          function g() {
            var m3 = [], C = s3(), B = {}, q = -1, L;
            return w.data = T, w.freeze = O, w.attachers = m3, w.use = P, w.parse = j, w.stringify = X, w.run = $, w.runSync = U, w.process = R, w.processSync = J, w;
            function w() {
              for (var z = g(), M = -1; ++M < m3.length; )
                z.use.apply(null, m3[M]);
              return z.data(o(true, {}, B)), z;
            }
            function O() {
              var z, M;
              if (L)
                return w;
              for (; ++q < m3.length; )
                z = m3[q], z[1] !== false && (z[1] === true && (z[1] = void 0), M = z[0].apply(w, z.slice(1)), typeof M == "function" && C.use(M));
              return L = true, q = 1 / 0, w;
            }
            function T(z, M) {
              return typeof z == "string" ? arguments.length === 2 ? (b("data", L), B[z] = M, w) : D.call(B, z) && B[z] || null : z ? (b("data", L), B = z, w) : B;
            }
            function P(z) {
              var M;
              if (b("use", L), z != null)
                if (typeof z == "function")
                  _.apply(null, arguments);
                else if (typeof z == "object")
                  "length" in z ? y(z) : G(z);
                else
                  throw new Error("Expected usable value, not `" + z + "`");
              return M && (B.settings = o(B.settings || {}, M)), w;
              function G(N) {
                y(N.plugins), N.settings && (M = o(M || {}, N.settings));
              }
              function k(N) {
                if (typeof N == "function")
                  _(N);
                else if (typeof N == "object")
                  "length" in N ? _.apply(null, N) : G(N);
                else
                  throw new Error("Expected usable value, not `" + N + "`");
              }
              function y(N) {
                var V = -1;
                if (N != null)
                  if (typeof N == "object" && "length" in N)
                    for (; ++V < N.length; )
                      k(N[V]);
                  else
                    throw new Error("Expected a list of plugins, not `" + N + "`");
              }
              function _(N, V) {
                var W = A3(N);
                W ? (n(W[1]) && n(V) && (V = o(true, W[1], V)), W[1] = V) : m3.push(i3.call(arguments));
              }
            }
            function A3(z) {
              for (var M = -1; ++M < m3.length; )
                if (m3[M][0] === z)
                  return m3[M];
            }
            function j(z) {
              var M = c(z), G;
              return O(), G = w.Parser, x3("parse", G), F3(G, "parse") ? new G(String(M), M).parse() : G(String(M), M);
            }
            function $(z, M, G) {
              if (v(z), O(), !G && typeof M == "function" && (G = M, M = null), !G)
                return new Promise(k);
              k(null, G);
              function k(y, _) {
                C.run(z, c(M), N);
                function N(V, W, K) {
                  W = W || z, V ? _(V) : y ? y(W) : G(null, W, K);
                }
              }
            }
            function U(z, M) {
              var G, k;
              return $(z, M, y), h3("runSync", "run", k), G;
              function y(_, N) {
                k = true, G = N, u(_);
              }
            }
            function X(z, M) {
              var G = c(M), k;
              return O(), k = w.Compiler, f3("stringify", k), v(z), F3(k, "compile") ? new k(z, G).compile() : k(z, G);
            }
            function R(z, M) {
              if (O(), x3("process", w.Parser), f3("process", w.Compiler), !M)
                return new Promise(G);
              G(null, M);
              function G(k, y) {
                var _ = c(z);
                a.run(w, { file: _ }, N);
                function N(V) {
                  V ? y(V) : k ? k(_) : M(null, _);
                }
              }
            }
            function J(z) {
              var M, G;
              return O(), x3("processSync", w.Parser), f3("processSync", w.Compiler), M = c(z), R(M, k), h3("processSync", "process", G), M;
              function k(y) {
                G = true, u(y);
              }
            }
          }
          function F3(m3, C) {
            return typeof m3 == "function" && m3.prototype && (E(m3.prototype) || C in m3.prototype);
          }
          function E(m3) {
            var C;
            for (C in m3)
              return true;
            return false;
          }
          function x3(m3, C) {
            if (typeof C != "function")
              throw new Error("Cannot `" + m3 + "` without `Parser`");
          }
          function f3(m3, C) {
            if (typeof C != "function")
              throw new Error("Cannot `" + m3 + "` without `Compiler`");
          }
          function b(m3, C) {
            if (C)
              throw new Error("Cannot invoke `" + m3 + "` on a frozen processor.\nCreate a new processor first, by invoking it: use `processor()` instead of `processor`.");
          }
          function v(m3) {
            if (!m3 || typeof m3.type != "string")
              throw new Error("Expected node, got `" + m3 + "`");
          }
          function h3(m3, C, B) {
            if (!B)
              throw new Error("`" + m3 + "` finished async. Use `" + C + "` instead");
          }
        } }), Xi = S2({ "node_modules/remark-math/util.js"(e3) {
          I(), e3.isRemarkParser = r3, e3.isRemarkCompiler = u;
          function r3(t3) {
            return Boolean(t3 && t3.prototype && t3.prototype.blockTokenizers);
          }
          function u(t3) {
            return Boolean(t3 && t3.prototype && t3.prototype.visitors);
          }
        } }), u2 = S2({ "node_modules/remark-math/inline.js"(e3, r3) {
          I();
          var u = Xi();
          r3.exports = l;
          var t3 = 9, o = 32, n = 36, s3 = 48, c = 57, i3 = 92, D = ["math", "math-inline"], a = "math-display";
          function l(g) {
            let F3 = this.Parser, E = this.Compiler;
            u.isRemarkParser(F3) && p(F3, g), u.isRemarkCompiler(E) && d(E, g);
          }
          function p(g, F3) {
            let E = g.prototype, x3 = E.inlineMethods;
            b.locator = f3, E.inlineTokenizers.math = b, x3.splice(x3.indexOf("text"), 0, "math");
            function f3(v, h3) {
              return v.indexOf("$", h3);
            }
            function b(v, h3, m3) {
              let C = h3.length, B = false, q = false, L = 0, w, O, T, P, A3, j, $;
              if (h3.charCodeAt(L) === i3 && (q = true, L++), h3.charCodeAt(L) === n) {
                if (L++, q)
                  return m3 ? true : v(h3.slice(0, L))({ type: "text", value: "$" });
                if (h3.charCodeAt(L) === n && (B = true, L++), T = h3.charCodeAt(L), !(T === o || T === t3)) {
                  for (P = L; L < C; ) {
                    if (O = T, T = h3.charCodeAt(L + 1), O === n) {
                      if (w = h3.charCodeAt(L - 1), w !== o && w !== t3 && (T !== T || T < s3 || T > c) && (!B || T === n)) {
                        A3 = L - 1, L++, B && L++, j = L;
                        break;
                      }
                    } else
                      O === i3 && (L++, T = h3.charCodeAt(L + 1));
                    L++;
                  }
                  if (j !== void 0)
                    return m3 ? true : ($ = h3.slice(P, A3 + 1), v(h3.slice(0, j))({ type: "inlineMath", value: $, data: { hName: "span", hProperties: { className: D.concat(B && F3.inlineMathDouble ? [a] : []) }, hChildren: [{ type: "text", value: $ }] } }));
                }
              }
            }
          }
          function d(g) {
            let F3 = g.prototype;
            F3.visitors.inlineMath = E;
            function E(x3) {
              let f3 = "$";
              return (x3.data && x3.data.hProperties && x3.data.hProperties.className || []).includes(a) && (f3 = "$$"), f3 + x3.value + f3;
            }
          }
        } }), t2 = S2({ "node_modules/remark-math/block.js"(e3, r3) {
          I();
          var u = Xi();
          r3.exports = a;
          var t3 = 10, o = 32, n = 36, s3 = `
`, c = "$", i3 = 2, D = ["math", "math-display"];
          function a() {
            let d = this.Parser, g = this.Compiler;
            u.isRemarkParser(d) && l(d), u.isRemarkCompiler(g) && p(g);
          }
          function l(d) {
            let g = d.prototype, F3 = g.blockMethods, E = g.interruptParagraph, x3 = g.interruptList, f3 = g.interruptBlockquote;
            g.blockTokenizers.math = b, F3.splice(F3.indexOf("fencedCode") + 1, 0, "math"), E.splice(E.indexOf("fencedCode") + 1, 0, ["math"]), x3.splice(x3.indexOf("fencedCode") + 1, 0, ["math"]), f3.splice(f3.indexOf("fencedCode") + 1, 0, ["math"]);
            function b(v, h3, m3) {
              var C = h3.length, B = 0;
              let q, L, w, O, T, P, A3, j, $, U, X;
              for (; B < C && h3.charCodeAt(B) === o; )
                B++;
              for (T = B; B < C && h3.charCodeAt(B) === n; )
                B++;
              if (P = B - T, !(P < i3)) {
                for (; B < C && h3.charCodeAt(B) === o; )
                  B++;
                for (A3 = B; B < C; ) {
                  if (q = h3.charCodeAt(B), q === n)
                    return;
                  if (q === t3)
                    break;
                  B++;
                }
                if (h3.charCodeAt(B) === t3) {
                  if (m3)
                    return true;
                  for (L = [], A3 !== B && L.push(h3.slice(A3, B)), B++, w = h3.indexOf(s3, B + 1), w = w === -1 ? C : w; B < C; ) {
                    for (j = false, U = B, X = w, O = w, $ = 0; O > U && h3.charCodeAt(O - 1) === o; )
                      O--;
                    for (; O > U && h3.charCodeAt(O - 1) === n; )
                      $++, O--;
                    for (P <= $ && h3.indexOf(c, U) === O && (j = true, X = O); U <= X && U - B < T && h3.charCodeAt(U) === o; )
                      U++;
                    if (j)
                      for (; X > U && h3.charCodeAt(X - 1) === o; )
                        X--;
                    if ((!j || U !== X) && L.push(h3.slice(U, X)), j)
                      break;
                    B = w + 1, w = h3.indexOf(s3, B + 1), w = w === -1 ? C : w;
                  }
                  return L = L.join(`
`), v(h3.slice(0, w))({ type: "math", value: L, data: { hName: "div", hProperties: { className: D.concat() }, hChildren: [{ type: "text", value: L }] } });
                }
              }
            }
          }
          function p(d) {
            let g = d.prototype;
            g.visitors.math = F3;
            function F3(E) {
              return `$$
` + E.value + `
$$`;
            }
          }
        } }), n2 = S2({ "node_modules/remark-math/index.js"(e3, r3) {
          I();
          var u = u2(), t3 = t2();
          r3.exports = o;
          function o(n) {
            var s3 = n || {};
            t3.call(this, s3), u.call(this, s3);
          }
        } }), i2 = S2({ "node_modules/remark-footnotes/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = g;
          var u = 9, t3 = 10, o = 32, n = 33, s3 = 58, c = 91, i3 = 92, D = 93, a = 94, l = 96, p = 4, d = 1024;
          function g(h3) {
            var m3 = this.Parser, C = this.Compiler;
            F3(m3) && x3(m3, h3), E(C) && f3(C);
          }
          function F3(h3) {
            return Boolean(h3 && h3.prototype && h3.prototype.blockTokenizers);
          }
          function E(h3) {
            return Boolean(h3 && h3.prototype && h3.prototype.visitors);
          }
          function x3(h3, m3) {
            for (var C = m3 || {}, B = h3.prototype, q = B.blockTokenizers, L = B.inlineTokenizers, w = B.blockMethods, O = B.inlineMethods, T = q.definition, P = L.reference, A3 = [], j = -1, $ = w.length, U; ++j < $; )
              U = w[j], !(U === "newline" || U === "indentedCode" || U === "paragraph" || U === "footnoteDefinition") && A3.push([U]);
            A3.push(["footnoteDefinition"]), C.inlineNotes && (b(O, "reference", "inlineNote"), L.inlineNote = J), b(w, "definition", "footnoteDefinition"), b(O, "reference", "footnoteCall"), q.definition = M, q.footnoteDefinition = X, L.footnoteCall = R, L.reference = z, B.interruptFootnoteDefinition = A3, z.locator = P.locator, R.locator = G, J.locator = k;
            function X(y, _, N) {
              for (var V = this, W = V.interruptFootnoteDefinition, K = V.offset, ee = _.length + 1, Y = 0, te = [], De, le, ne, Z3, Q, fe, be, pe, he, oe, de, ie, re; Y < ee && (Z3 = _.charCodeAt(Y), !(Z3 !== u && Z3 !== o)); )
                Y++;
              if (_.charCodeAt(Y++) === c && _.charCodeAt(Y++) === a) {
                for (le = Y; Y < ee; ) {
                  if (Z3 = _.charCodeAt(Y), Z3 !== Z3 || Z3 === t3 || Z3 === u || Z3 === o)
                    return;
                  if (Z3 === D) {
                    ne = Y, Y++;
                    break;
                  }
                  Y++;
                }
                if (!(ne === void 0 || le === ne || _.charCodeAt(Y++) !== s3)) {
                  if (N)
                    return true;
                  for (De = _.slice(le, ne), Q = y.now(), he = 0, oe = 0, de = Y, ie = []; Y < ee; ) {
                    if (Z3 = _.charCodeAt(Y), Z3 !== Z3 || Z3 === t3)
                      re = { start: he, contentStart: de || Y, contentEnd: Y, end: Y }, ie.push(re), Z3 === t3 && (he = Y + 1, oe = 0, de = void 0, re.end = he);
                    else if (oe !== void 0)
                      if (Z3 === o || Z3 === u)
                        oe += Z3 === o ? 1 : p - oe % p, oe > p && (oe = void 0, de = Y);
                      else {
                        if (oe < p && re && (re.contentStart === re.contentEnd || v(W, q, V, [y, _.slice(Y, d), true])))
                          break;
                        oe = void 0, de = Y;
                      }
                    Y++;
                  }
                  for (Y = -1, ee = ie.length; ee > 0 && (re = ie[ee - 1], re.contentStart === re.contentEnd); )
                    ee--;
                  for (fe = y(_.slice(0, re.contentEnd)); ++Y < ee; )
                    re = ie[Y], K[Q.line + Y] = (K[Q.line + Y] || 0) + (re.contentStart - re.start), te.push(_.slice(re.contentStart, re.end));
                  return be = V.enterBlock(), pe = V.tokenizeBlock(te.join(""), Q), be(), fe({ type: "footnoteDefinition", identifier: De.toLowerCase(), label: De, children: pe });
                }
              }
            }
            function R(y, _, N) {
              var V = _.length + 1, W = 0, K, ee, Y, te;
              if (_.charCodeAt(W++) === c && _.charCodeAt(W++) === a) {
                for (ee = W; W < V; ) {
                  if (te = _.charCodeAt(W), te !== te || te === t3 || te === u || te === o)
                    return;
                  if (te === D) {
                    Y = W, W++;
                    break;
                  }
                  W++;
                }
                if (!(Y === void 0 || ee === Y))
                  return N ? true : (K = _.slice(ee, Y), y(_.slice(0, W))({ type: "footnoteReference", identifier: K.toLowerCase(), label: K }));
              }
            }
            function J(y, _, N) {
              var V = this, W = _.length + 1, K = 0, ee = 0, Y, te, De, le, ne, Z3, Q;
              if (_.charCodeAt(K++) === a && _.charCodeAt(K++) === c) {
                for (De = K; K < W; ) {
                  if (te = _.charCodeAt(K), te !== te)
                    return;
                  if (Z3 === void 0)
                    if (te === i3)
                      K += 2;
                    else if (te === c)
                      ee++, K++;
                    else if (te === D)
                      if (ee === 0) {
                        le = K, K++;
                        break;
                      } else
                        ee--, K++;
                    else if (te === l) {
                      for (ne = K, Z3 = 1; _.charCodeAt(ne + Z3) === l; )
                        Z3++;
                      K += Z3;
                    } else
                      K++;
                  else if (te === l) {
                    for (ne = K, Q = 1; _.charCodeAt(ne + Q) === l; )
                      Q++;
                    K += Q, Z3 === Q && (Z3 = void 0), Q = void 0;
                  } else
                    K++;
                }
                if (le !== void 0)
                  return N ? true : (Y = y.now(), Y.column += 2, Y.offset += 2, y(_.slice(0, K))({ type: "footnote", children: V.tokenizeInline(_.slice(De, le), Y) }));
              }
            }
            function z(y, _, N) {
              var V = 0;
              if (_.charCodeAt(V) === n && V++, _.charCodeAt(V) === c && _.charCodeAt(V + 1) !== a)
                return P.call(this, y, _, N);
            }
            function M(y, _, N) {
              for (var V = 0, W = _.charCodeAt(V); W === o || W === u; )
                W = _.charCodeAt(++V);
              if (W === c && _.charCodeAt(V + 1) !== a)
                return T.call(this, y, _, N);
            }
            function G(y, _) {
              return y.indexOf("[", _);
            }
            function k(y, _) {
              return y.indexOf("^[", _);
            }
          }
          function f3(h3) {
            var m3 = h3.prototype.visitors, C = "    ";
            m3.footnote = B, m3.footnoteReference = q, m3.footnoteDefinition = L;
            function B(w) {
              return "^[" + this.all(w).join("") + "]";
            }
            function q(w) {
              return "[^" + (w.label || w.identifier) + "]";
            }
            function L(w) {
              for (var O = this.all(w).join(`

`).split(`
`), T = 0, P = O.length, A3; ++T < P; )
                A3 = O[T], A3 !== "" && (O[T] = C + A3);
              return "[^" + (w.label || w.identifier) + "]: " + O.join(`
`);
            }
          }
          function b(h3, m3, C) {
            h3.splice(h3.indexOf(m3), 0, C);
          }
          function v(h3, m3, C, B) {
            for (var q = h3.length, L = -1; ++L < q; )
              if (m3[h3[L][0]].apply(C, B))
                return true;
            return false;
          }
        } }), Wi = S2({ "src/utils/front-matter/parse.js"(e3, r3) {
          "use strict";
          I();
          var u = new RegExp("^(?<startDelimiter>-{3}|\\+{3})(?<language>[^\\n]*)\\n(?:|(?<value>.*?)\\n)(?<endDelimiter>\\k<startDelimiter>|\\.{3})[^\\S\\n]*(?:\\n|$)", "s");
          function t3(o) {
            let n = o.match(u);
            if (!n)
              return { content: o };
            let { startDelimiter: s3, language: c, value: i3 = "", endDelimiter: D } = n.groups, a = c.trim() || "yaml";
            if (s3 === "+++" && (a = "toml"), a !== "yaml" && s3 !== D)
              return { content: o };
            let [l] = n;
            return { frontMatter: { type: "front-matter", lang: a, value: i3, startDelimiter: s3, endDelimiter: D, raw: l.replace(/\n$/, "") }, content: l.replace(/[^\n]/g, " ") + o.slice(l.length) };
          }
          r3.exports = t3;
        } }), a2 = S2({ "src/language-markdown/pragma.js"(e3, r3) {
          "use strict";
          I();
          var u = Wi(), t3 = ["format", "prettier"];
          function o(n) {
            let s3 = "@(".concat(t3.join("|"), ")"), c = new RegExp(["<!--\\s*".concat(s3, "\\s*-->"), "{\\s*\\/\\*\\s*".concat(s3, "\\s*\\*\\/\\s*}"), `<!--.*\r?
[\\s\\S]*(^|
)[^\\S
]*`.concat(s3, `[^\\S
]*($|
)[\\s\\S]*
.*-->`)].join("|"), "m"), i3 = n.match(c);
            return (i3 == null ? void 0 : i3.index) === 0;
          }
          r3.exports = { startWithPragma: o, hasPragma: (n) => o(u(n).content.trimStart()), insertPragma: (n) => {
            let s3 = u(n), c = "<!-- @".concat(t3[0], " -->");
            return s3.frontMatter ? "".concat(s3.frontMatter.raw, `

`).concat(c, `

`).concat(s3.content) : "".concat(c, `

`).concat(s3.content);
          } };
        } }), Ki = S2({ "src/language-markdown/loc.js"(e3, r3) {
          "use strict";
          I();
          function u(o) {
            return o.position.start.offset;
          }
          function t3(o) {
            return o.position.end.offset;
          }
          r3.exports = { locStart: u, locEnd: t3 };
        } }), Yi = S2({ "src/language-markdown/mdx.js"(e3, r3) {
          "use strict";
          I();
          var u = /^import\s/, t3 = /^export\s/, o = "[a-z][a-z0-9]*(\\.[a-z][a-z0-9]*)*|", n = /<!---->|<!---?[^>-](?:-?[^-])*-->/, s3 = /^{\s*\/\*(.*)\*\/\s*}/, c = `

`, i3 = (d) => u.test(d), D = (d) => t3.test(d), a = (d, g) => {
            let F3 = g.indexOf(c), E = g.slice(0, F3);
            if (D(E) || i3(E))
              return d(E)({ type: D(E) ? "export" : "import", value: E });
          }, l = (d, g) => {
            let F3 = s3.exec(g);
            if (F3)
              return d(F3[0])({ type: "esComment", value: F3[1].trim() });
          };
          a.locator = (d) => D(d) || i3(d) ? -1 : 1, l.locator = (d, g) => d.indexOf("{", g);
          function p() {
            let { Parser: d } = this, { blockTokenizers: g, blockMethods: F3, inlineTokenizers: E, inlineMethods: x3 } = d.prototype;
            g.esSyntax = a, E.esComment = l, F3.splice(F3.indexOf("paragraph"), 0, "esSyntax"), x3.splice(x3.indexOf("text"), 0, "esComment");
          }
          r3.exports = { esSyntax: p, BLOCKS_REGEX: o, COMMENT_REGEX: n };
        } }), Ji = {};
        Li(Ji, { default: () => o2 });
        function o2(e3) {
          if (typeof e3 != "string")
            throw new TypeError("Expected a string");
          return e3.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
        }
        var s2 = Pe({ "node_modules/escape-string-regexp/index.js"() {
          I();
        } }), c2 = S2({ "src/utils/get-last.js"(e3, r3) {
          "use strict";
          I();
          var u = (t3) => t3[t3.length - 1];
          r3.exports = u;
        } }), Zi = S2({ "node_modules/semver/internal/debug.js"(e3, r3) {
          I();
          var u = typeof Ze == "object" && Ze.env && Ze.env.NODE_DEBUG && /\bsemver\b/i.test(Ze.env.NODE_DEBUG) ? function() {
            for (var t3 = arguments.length, o = new Array(t3), n = 0; n < t3; n++)
              o[n] = arguments[n];
            return console.error("SEMVER", ...o);
          } : () => {
          };
          r3.exports = u;
        } }), Qi = S2({ "node_modules/semver/internal/constants.js"(e3, r3) {
          I();
          var u = "2.0.0", t3 = 256, o = Number.MAX_SAFE_INTEGER || 9007199254740991, n = 16;
          r3.exports = { SEMVER_SPEC_VERSION: u, MAX_LENGTH: t3, MAX_SAFE_INTEGER: o, MAX_SAFE_COMPONENT_LENGTH: n };
        } }), l2 = S2({ "node_modules/semver/internal/re.js"(e3, r3) {
          I();
          var { MAX_SAFE_COMPONENT_LENGTH: u } = Qi(), t3 = Zi();
          e3 = r3.exports = {};
          var o = e3.re = [], n = e3.src = [], s3 = e3.t = {}, c = 0, i3 = (D, a, l) => {
            let p = c++;
            t3(D, p, a), s3[D] = p, n[p] = a, o[p] = new RegExp(a, l ? "g" : void 0);
          };
          i3("NUMERICIDENTIFIER", "0|[1-9]\\d*"), i3("NUMERICIDENTIFIERLOOSE", "[0-9]+"), i3("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*"), i3("MAINVERSION", "(".concat(n[s3.NUMERICIDENTIFIER], ")\\.(").concat(n[s3.NUMERICIDENTIFIER], ")\\.(").concat(n[s3.NUMERICIDENTIFIER], ")")), i3("MAINVERSIONLOOSE", "(".concat(n[s3.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(n[s3.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(n[s3.NUMERICIDENTIFIERLOOSE], ")")), i3("PRERELEASEIDENTIFIER", "(?:".concat(n[s3.NUMERICIDENTIFIER], "|").concat(n[s3.NONNUMERICIDENTIFIER], ")")), i3("PRERELEASEIDENTIFIERLOOSE", "(?:".concat(n[s3.NUMERICIDENTIFIERLOOSE], "|").concat(n[s3.NONNUMERICIDENTIFIER], ")")), i3("PRERELEASE", "(?:-(".concat(n[s3.PRERELEASEIDENTIFIER], "(?:\\.").concat(n[s3.PRERELEASEIDENTIFIER], ")*))")), i3("PRERELEASELOOSE", "(?:-?(".concat(n[s3.PRERELEASEIDENTIFIERLOOSE], "(?:\\.").concat(n[s3.PRERELEASEIDENTIFIERLOOSE], ")*))")), i3("BUILDIDENTIFIER", "[0-9A-Za-z-]+"), i3("BUILD", "(?:\\+(".concat(n[s3.BUILDIDENTIFIER], "(?:\\.").concat(n[s3.BUILDIDENTIFIER], ")*))")), i3("FULLPLAIN", "v?".concat(n[s3.MAINVERSION]).concat(n[s3.PRERELEASE], "?").concat(n[s3.BUILD], "?")), i3("FULL", "^".concat(n[s3.FULLPLAIN], "$")), i3("LOOSEPLAIN", "[v=\\s]*".concat(n[s3.MAINVERSIONLOOSE]).concat(n[s3.PRERELEASELOOSE], "?").concat(n[s3.BUILD], "?")), i3("LOOSE", "^".concat(n[s3.LOOSEPLAIN], "$")), i3("GTLT", "((?:<|>)?=?)"), i3("XRANGEIDENTIFIERLOOSE", "".concat(n[s3.NUMERICIDENTIFIERLOOSE], "|x|X|\\*")), i3("XRANGEIDENTIFIER", "".concat(n[s3.NUMERICIDENTIFIER], "|x|X|\\*")), i3("XRANGEPLAIN", "[v=\\s]*(".concat(n[s3.XRANGEIDENTIFIER], ")(?:\\.(").concat(n[s3.XRANGEIDENTIFIER], ")(?:\\.(").concat(n[s3.XRANGEIDENTIFIER], ")(?:").concat(n[s3.PRERELEASE], ")?").concat(n[s3.BUILD], "?)?)?")), i3("XRANGEPLAINLOOSE", "[v=\\s]*(".concat(n[s3.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(n[s3.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(n[s3.XRANGEIDENTIFIERLOOSE], ")(?:").concat(n[s3.PRERELEASELOOSE], ")?").concat(n[s3.BUILD], "?)?)?")), i3("XRANGE", "^".concat(n[s3.GTLT], "\\s*").concat(n[s3.XRANGEPLAIN], "$")), i3("XRANGELOOSE", "^".concat(n[s3.GTLT], "\\s*").concat(n[s3.XRANGEPLAINLOOSE], "$")), i3("COERCE", "(^|[^\\d])(\\d{1,".concat(u, "})(?:\\.(\\d{1,").concat(u, "}))?(?:\\.(\\d{1,").concat(u, "}))?(?:$|[^\\d])")), i3("COERCERTL", n[s3.COERCE], true), i3("LONETILDE", "(?:~>?)"), i3("TILDETRIM", "(\\s*)".concat(n[s3.LONETILDE], "\\s+"), true), e3.tildeTrimReplace = "$1~", i3("TILDE", "^".concat(n[s3.LONETILDE]).concat(n[s3.XRANGEPLAIN], "$")), i3("TILDELOOSE", "^".concat(n[s3.LONETILDE]).concat(n[s3.XRANGEPLAINLOOSE], "$")), i3("LONECARET", "(?:\\^)"), i3("CARETTRIM", "(\\s*)".concat(n[s3.LONECARET], "\\s+"), true), e3.caretTrimReplace = "$1^", i3("CARET", "^".concat(n[s3.LONECARET]).concat(n[s3.XRANGEPLAIN], "$")), i3("CARETLOOSE", "^".concat(n[s3.LONECARET]).concat(n[s3.XRANGEPLAINLOOSE], "$")), i3("COMPARATORLOOSE", "^".concat(n[s3.GTLT], "\\s*(").concat(n[s3.LOOSEPLAIN], ")$|^$")), i3("COMPARATOR", "^".concat(n[s3.GTLT], "\\s*(").concat(n[s3.FULLPLAIN], ")$|^$")), i3("COMPARATORTRIM", "(\\s*)".concat(n[s3.GTLT], "\\s*(").concat(n[s3.LOOSEPLAIN], "|").concat(n[s3.XRANGEPLAIN], ")"), true), e3.comparatorTrimReplace = "$1$2$3", i3("HYPHENRANGE", "^\\s*(".concat(n[s3.XRANGEPLAIN], ")\\s+-\\s+(").concat(n[s3.XRANGEPLAIN], ")\\s*$")), i3("HYPHENRANGELOOSE", "^\\s*(".concat(n[s3.XRANGEPLAINLOOSE], ")\\s+-\\s+(").concat(n[s3.XRANGEPLAINLOOSE], ")\\s*$")), i3("STAR", "(<|>)?=?\\s*\\*"), i3("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$"), i3("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
        } }), D2 = S2({ "node_modules/semver/internal/parse-options.js"(e3, r3) {
          I();
          var u = ["includePrerelease", "loose", "rtl"], t3 = (o) => o ? typeof o != "object" ? { loose: true } : u.filter((n) => o[n]).reduce((n, s3) => (n[s3] = true, n), {}) : {};
          r3.exports = t3;
        } }), f22 = S2({ "node_modules/semver/internal/identifiers.js"(e3, r3) {
          I();
          var u = /^[0-9]+$/, t3 = (n, s3) => {
            let c = u.test(n), i3 = u.test(s3);
            return c && i3 && (n = +n, s3 = +s3), n === s3 ? 0 : c && !i3 ? -1 : i3 && !c ? 1 : n < s3 ? -1 : 1;
          }, o = (n, s3) => t3(s3, n);
          r3.exports = { compareIdentifiers: t3, rcompareIdentifiers: o };
        } }), p2 = S2({ "node_modules/semver/classes/semver.js"(e3, r3) {
          I();
          var u = Zi(), { MAX_LENGTH: t3, MAX_SAFE_INTEGER: o } = Qi(), { re: n, t: s3 } = l2(), c = D2(), { compareIdentifiers: i3 } = f22(), D = class {
            constructor(a, l) {
              if (l = c(l), a instanceof D) {
                if (a.loose === !!l.loose && a.includePrerelease === !!l.includePrerelease)
                  return a;
                a = a.version;
              } else if (typeof a != "string")
                throw new TypeError("Invalid Version: ".concat(a));
              if (a.length > t3)
                throw new TypeError("version is longer than ".concat(t3, " characters"));
              u("SemVer", a, l), this.options = l, this.loose = !!l.loose, this.includePrerelease = !!l.includePrerelease;
              let p = a.trim().match(l.loose ? n[s3.LOOSE] : n[s3.FULL]);
              if (!p)
                throw new TypeError("Invalid Version: ".concat(a));
              if (this.raw = a, this.major = +p[1], this.minor = +p[2], this.patch = +p[3], this.major > o || this.major < 0)
                throw new TypeError("Invalid major version");
              if (this.minor > o || this.minor < 0)
                throw new TypeError("Invalid minor version");
              if (this.patch > o || this.patch < 0)
                throw new TypeError("Invalid patch version");
              p[4] ? this.prerelease = p[4].split(".").map((d) => {
                if (/^[0-9]+$/.test(d)) {
                  let g = +d;
                  if (g >= 0 && g < o)
                    return g;
                }
                return d;
              }) : this.prerelease = [], this.build = p[5] ? p[5].split(".") : [], this.format();
            }
            format() {
              return this.version = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch), this.prerelease.length && (this.version += "-".concat(this.prerelease.join("."))), this.version;
            }
            toString() {
              return this.version;
            }
            compare(a) {
              if (u("SemVer.compare", this.version, this.options, a), !(a instanceof D)) {
                if (typeof a == "string" && a === this.version)
                  return 0;
                a = new D(a, this.options);
              }
              return a.version === this.version ? 0 : this.compareMain(a) || this.comparePre(a);
            }
            compareMain(a) {
              return a instanceof D || (a = new D(a, this.options)), i3(this.major, a.major) || i3(this.minor, a.minor) || i3(this.patch, a.patch);
            }
            comparePre(a) {
              if (a instanceof D || (a = new D(a, this.options)), this.prerelease.length && !a.prerelease.length)
                return -1;
              if (!this.prerelease.length && a.prerelease.length)
                return 1;
              if (!this.prerelease.length && !a.prerelease.length)
                return 0;
              let l = 0;
              do {
                let p = this.prerelease[l], d = a.prerelease[l];
                if (u("prerelease compare", l, p, d), p === void 0 && d === void 0)
                  return 0;
                if (d === void 0)
                  return 1;
                if (p === void 0)
                  return -1;
                if (p === d)
                  continue;
                return i3(p, d);
              } while (++l);
            }
            compareBuild(a) {
              a instanceof D || (a = new D(a, this.options));
              let l = 0;
              do {
                let p = this.build[l], d = a.build[l];
                if (u("prerelease compare", l, p, d), p === void 0 && d === void 0)
                  return 0;
                if (d === void 0)
                  return 1;
                if (p === void 0)
                  return -1;
                if (p === d)
                  continue;
                return i3(p, d);
              } while (++l);
            }
            inc(a, l) {
              switch (a) {
                case "premajor":
                  this.prerelease.length = 0, this.patch = 0, this.minor = 0, this.major++, this.inc("pre", l);
                  break;
                case "preminor":
                  this.prerelease.length = 0, this.patch = 0, this.minor++, this.inc("pre", l);
                  break;
                case "prepatch":
                  this.prerelease.length = 0, this.inc("patch", l), this.inc("pre", l);
                  break;
                case "prerelease":
                  this.prerelease.length === 0 && this.inc("patch", l), this.inc("pre", l);
                  break;
                case "major":
                  (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) && this.major++, this.minor = 0, this.patch = 0, this.prerelease = [];
                  break;
                case "minor":
                  (this.patch !== 0 || this.prerelease.length === 0) && this.minor++, this.patch = 0, this.prerelease = [];
                  break;
                case "patch":
                  this.prerelease.length === 0 && this.patch++, this.prerelease = [];
                  break;
                case "pre":
                  if (this.prerelease.length === 0)
                    this.prerelease = [0];
                  else {
                    let p = this.prerelease.length;
                    for (; --p >= 0; )
                      typeof this.prerelease[p] == "number" && (this.prerelease[p]++, p = -2);
                    p === -1 && this.prerelease.push(0);
                  }
                  l && (i3(this.prerelease[0], l) === 0 ? isNaN(this.prerelease[1]) && (this.prerelease = [l, 0]) : this.prerelease = [l, 0]);
                  break;
                default:
                  throw new Error("invalid increment argument: ".concat(a));
              }
              return this.format(), this.raw = this.version, this;
            }
          };
          r3.exports = D;
        } }), vu = S2({ "node_modules/semver/functions/compare.js"(e3, r3) {
          I();
          var u = p2(), t3 = (o, n, s3) => new u(o, s3).compare(new u(n, s3));
          r3.exports = t3;
        } }), d2 = S2({ "node_modules/semver/functions/lt.js"(e3, r3) {
          I();
          var u = vu(), t3 = (o, n, s3) => u(o, n, s3) < 0;
          r3.exports = t3;
        } }), h2 = S2({ "node_modules/semver/functions/gte.js"(e3, r3) {
          I();
          var u = vu(), t3 = (o, n, s3) => u(o, n, s3) >= 0;
          r3.exports = t3;
        } }), v2 = S2({ "src/utils/arrayify.js"(e3, r3) {
          "use strict";
          I(), r3.exports = (u, t3) => Object.entries(u).map((o) => {
            let [n, s3] = o;
            return Object.assign({ [t3]: n }, s3);
          });
        } }), m2 = S2({ "package.json"(e3, r3) {
          r3.exports = { version: "2.7.1" };
        } }), E2 = S2({ "node_modules/outdent/lib/index.js"(e3, r3) {
          "use strict";
          I(), Object.defineProperty(e3, "__esModule", { value: true }), e3.outdent = void 0;
          function u() {
            for (var f3 = [], b = 0; b < arguments.length; b++)
              f3[b] = arguments[b];
          }
          function t3() {
            return typeof WeakMap < "u" ? /* @__PURE__ */ new WeakMap() : o();
          }
          function o() {
            return { add: u, delete: u, get: u, set: u, has: function(f3) {
              return false;
            } };
          }
          var n = Object.prototype.hasOwnProperty, s3 = function(f3, b) {
            return n.call(f3, b);
          };
          function c(f3, b) {
            for (var v in b)
              s3(b, v) && (f3[v] = b[v]);
            return f3;
          }
          var i3 = /^[ \t]*(?:\r\n|\r|\n)/, D = /(?:\r\n|\r|\n)[ \t]*$/, a = /^(?:[\r\n]|$)/, l = /(?:\r\n|\r|\n)([ \t]*)(?:[^ \t\r\n]|$)/, p = /^[ \t]*[\r\n][ \t\r\n]*$/;
          function d(f3, b, v) {
            var h3 = 0, m3 = f3[0].match(l);
            m3 && (h3 = m3[1].length);
            var C = "(\\r\\n|\\r|\\n).{0," + h3 + "}", B = new RegExp(C, "g");
            b && (f3 = f3.slice(1));
            var q = v.newline, L = v.trimLeadingNewline, w = v.trimTrailingNewline, O = typeof q == "string", T = f3.length, P = f3.map(function(A3, j) {
              return A3 = A3.replace(B, "$1"), j === 0 && L && (A3 = A3.replace(i3, "")), j === T - 1 && w && (A3 = A3.replace(D, "")), O && (A3 = A3.replace(/\r\n|\n|\r/g, function($) {
                return q;
              })), A3;
            });
            return P;
          }
          function g(f3, b) {
            for (var v = "", h3 = 0, m3 = f3.length; h3 < m3; h3++)
              v += f3[h3], h3 < m3 - 1 && (v += b[h3]);
            return v;
          }
          function F3(f3) {
            return s3(f3, "raw") && s3(f3, "length");
          }
          function E(f3) {
            var b = t3(), v = t3();
            function h3(C) {
              for (var B = [], q = 1; q < arguments.length; q++)
                B[q - 1] = arguments[q];
              if (F3(C)) {
                var L = C, w = (B[0] === h3 || B[0] === x3) && p.test(L[0]) && a.test(L[1]), O = w ? v : b, T = O.get(L);
                if (T || (T = d(L, w, f3), O.set(L, T)), B.length === 0)
                  return T[0];
                var P = g(T, w ? B.slice(1) : B);
                return P;
              } else
                return E(c(c({}, f3), C || {}));
            }
            var m3 = c(h3, { string: function(C) {
              return d([C], false, f3)[0];
            } });
            return m3;
          }
          var x3 = E({ trimLeadingNewline: true, trimTrailingNewline: true });
          if (e3.outdent = x3, e3.default = x3, typeof r3 < "u")
            try {
              r3.exports = x3, Object.defineProperty(x3, "__esModule", { value: true }), x3.default = x3, x3.outdent = x3;
            } catch {
            }
        } }), C2 = S2({ "src/main/core-options.js"(e3, r3) {
          "use strict";
          I();
          var { outdent: u } = E2(), t3 = "Config", o = "Editor", n = "Format", s3 = "Other", c = "Output", i3 = "Global", D = "Special", a = { cursorOffset: { since: "1.4.0", category: D, type: "int", default: -1, range: { start: -1, end: Number.POSITIVE_INFINITY, step: 1 }, description: u(yi || (yi = je([`
      Print (to stderr) where a cursor at the given position would move to after formatting.
      This option cannot be used with --range-start and --range-end.
    `]))), cliCategory: o }, endOfLine: { since: "1.15.0", category: i3, type: "choice", default: [{ since: "1.15.0", value: "auto" }, { since: "2.0.0", value: "lf" }], description: "Which end of line characters to apply.", choices: [{ value: "lf", description: "Line Feed only (\\n), common on Linux and macOS as well as inside git repos" }, { value: "crlf", description: "Carriage Return + Line Feed characters (\\r\\n), common on Windows" }, { value: "cr", description: "Carriage Return character only (\\r), used very rarely" }, { value: "auto", description: u(Bi || (Bi = je([`
          Maintain existing
          (mixed values within one file are normalised by looking at what's used after the first line)
        `]))) }] }, filepath: { since: "1.4.0", category: D, type: "path", description: "Specify the input filepath. This will be used to do parser inference.", cliName: "stdin-filepath", cliCategory: s3, cliDescription: "Path to the file to pretend that stdin comes from." }, insertPragma: { since: "1.8.0", category: D, type: "boolean", default: false, description: "Insert @format pragma into file's first docblock comment.", cliCategory: s3 }, parser: { since: "0.0.10", category: i3, type: "choice", default: [{ since: "0.0.10", value: "babylon" }, { since: "1.13.0", value: void 0 }], description: "Which parser to use.", exception: (l) => typeof l == "string" || typeof l == "function", choices: [{ value: "flow", description: "Flow" }, { value: "babel", since: "1.16.0", description: "JavaScript" }, { value: "babel-flow", since: "1.16.0", description: "Flow" }, { value: "babel-ts", since: "2.0.0", description: "TypeScript" }, { value: "typescript", since: "1.4.0", description: "TypeScript" }, { value: "acorn", since: "2.6.0", description: "JavaScript" }, { value: "espree", since: "2.2.0", description: "JavaScript" }, { value: "meriyah", since: "2.2.0", description: "JavaScript" }, { value: "css", since: "1.7.1", description: "CSS" }, { value: "less", since: "1.7.1", description: "Less" }, { value: "scss", since: "1.7.1", description: "SCSS" }, { value: "json", since: "1.5.0", description: "JSON" }, { value: "json5", since: "1.13.0", description: "JSON5" }, { value: "json-stringify", since: "1.13.0", description: "JSON.stringify" }, { value: "graphql", since: "1.5.0", description: "GraphQL" }, { value: "markdown", since: "1.8.0", description: "Markdown" }, { value: "mdx", since: "1.15.0", description: "MDX" }, { value: "vue", since: "1.10.0", description: "Vue" }, { value: "yaml", since: "1.14.0", description: "YAML" }, { value: "glimmer", since: "2.3.0", description: "Ember / Handlebars" }, { value: "html", since: "1.15.0", description: "HTML" }, { value: "angular", since: "1.15.0", description: "Angular" }, { value: "lwc", since: "1.17.0", description: "Lightning Web Components" }] }, plugins: { since: "1.10.0", type: "path", array: true, default: [{ value: [] }], category: i3, description: "Add a plugin. Multiple plugins can be passed as separate `--plugin`s.", exception: (l) => typeof l == "string" || typeof l == "object", cliName: "plugin", cliCategory: t3 }, pluginSearchDirs: { since: "1.13.0", type: "path", array: true, default: [{ value: [] }], category: i3, description: u(wi || (wi = je([`
      Custom directory that contains prettier plugins in node_modules subdirectory.
      Overrides default behavior when plugins are searched relatively to the location of Prettier.
      Multiple values are accepted.
    `]))), exception: (l) => typeof l == "string" || typeof l == "object", cliName: "plugin-search-dir", cliCategory: t3 }, printWidth: { since: "0.0.0", category: i3, type: "int", default: 80, description: "The line length where Prettier will try wrap.", range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 } }, rangeEnd: { since: "1.4.0", category: D, type: "int", default: Number.POSITIVE_INFINITY, range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 }, description: u(ki || (ki = je([`
      Format code ending at a given character offset (exclusive).
      The range will extend forwards to the end of the selected statement.
      This option cannot be used with --cursor-offset.
    `]))), cliCategory: o }, rangeStart: { since: "1.4.0", category: D, type: "int", default: 0, range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 }, description: u(qi || (qi = je([`
      Format code starting at a given character offset.
      The range will extend backwards to the start of the first line containing the selected statement.
      This option cannot be used with --cursor-offset.
    `]))), cliCategory: o }, requirePragma: { since: "1.7.0", category: D, type: "boolean", default: false, description: u(_i || (_i = je([`
      Require either '@prettier' or '@format' to be present in the file's first docblock comment
      in order for it to be formatted.
    `]))), cliCategory: s3 }, tabWidth: { type: "int", category: i3, default: 2, description: "Number of spaces per indentation level.", range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 } }, useTabs: { since: "1.0.0", category: i3, type: "boolean", default: false, description: "Indent with tabs instead of spaces." }, embeddedLanguageFormatting: { since: "2.1.0", category: i3, type: "choice", default: [{ since: "2.1.0", value: "auto" }], description: "Control how Prettier formats quoted code embedded in the file.", choices: [{ value: "auto", description: "Format embedded code if Prettier can automatically identify it." }, { value: "off", description: "Never automatically format embedded code." }] } };
          r3.exports = { CATEGORY_CONFIG: t3, CATEGORY_EDITOR: o, CATEGORY_FORMAT: n, CATEGORY_OTHER: s3, CATEGORY_OUTPUT: c, CATEGORY_GLOBAL: i3, CATEGORY_SPECIAL: D, options: a };
        } }), g2 = S2({ "src/main/support.js"(e3, r3) {
          "use strict";
          I();
          var u = { compare: vu(), lt: d2(), gte: h2() }, t3 = v2(), o = m2().version, n = C2().options;
          function s3() {
            let { plugins: i3 = [], showUnreleased: D = false, showDeprecated: a = false, showInternal: l = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, p = o.split("-", 1)[0], d = i3.flatMap((f3) => f3.languages || []).filter(F3), g = t3(Object.assign({}, ...i3.map((f3) => {
              let { options: b } = f3;
              return b;
            }), n), "name").filter((f3) => F3(f3) && E(f3)).sort((f3, b) => f3.name === b.name ? 0 : f3.name < b.name ? -1 : 1).map(x3).map((f3) => {
              f3 = Object.assign({}, f3), Array.isArray(f3.default) && (f3.default = f3.default.length === 1 ? f3.default[0].value : f3.default.filter(F3).sort((v, h3) => u.compare(h3.since, v.since))[0].value), Array.isArray(f3.choices) && (f3.choices = f3.choices.filter((v) => F3(v) && E(v)), f3.name === "parser" && c(f3, d, i3));
              let b = Object.fromEntries(i3.filter((v) => v.defaultOptions && v.defaultOptions[f3.name] !== void 0).map((v) => [v.name, v.defaultOptions[f3.name]]));
              return Object.assign(Object.assign({}, f3), {}, { pluginDefaults: b });
            });
            return { languages: d, options: g };
            function F3(f3) {
              return D || !("since" in f3) || f3.since && u.gte(p, f3.since);
            }
            function E(f3) {
              return a || !("deprecated" in f3) || f3.deprecated && u.lt(p, f3.deprecated);
            }
            function x3(f3) {
              if (l)
                return f3;
              let { cliName: b, cliCategory: v, cliDescription: h3 } = f3;
              return ql(f3, kl);
            }
          }
          function c(i3, D, a) {
            let l = new Set(i3.choices.map((p) => p.value));
            for (let p of D)
              if (p.parsers) {
                for (let d of p.parsers)
                  if (!l.has(d)) {
                    l.add(d);
                    let g = a.find((E) => E.parsers && E.parsers[d]), F3 = p.name;
                    g && g.name && (F3 += " (plugin: ".concat(g.name, ")")), i3.choices.push({ value: d, description: F3 });
                  }
              }
          }
          r3.exports = { getSupportInfo: s3 };
        } }), F2 = S2({ "src/utils/is-non-empty-array.js"(e3, r3) {
          "use strict";
          I();
          function u(t3) {
            return Array.isArray(t3) && t3.length > 0;
          }
          r3.exports = u;
        } });
        function A2() {
          let { onlyFirst: e3 = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, r3 = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
          return new RegExp(r3, e3 ? void 0 : "g");
        }
        var x2 = Pe({ "node_modules/strip-ansi/node_modules/ansi-regex/index.js"() {
          I();
        } });
        function b2(e3) {
          if (typeof e3 != "string")
            throw new TypeError("Expected a `string`, got `".concat(typeof e3, "`"));
          return e3.replace(A2(), "");
        }
        var y2 = Pe({ "node_modules/strip-ansi/index.js"() {
          I(), x2();
        } });
        function B2(e3) {
          return Number.isInteger(e3) ? e3 >= 4352 && (e3 <= 4447 || e3 === 9001 || e3 === 9002 || 11904 <= e3 && e3 <= 12871 && e3 !== 12351 || 12880 <= e3 && e3 <= 19903 || 19968 <= e3 && e3 <= 42182 || 43360 <= e3 && e3 <= 43388 || 44032 <= e3 && e3 <= 55203 || 63744 <= e3 && e3 <= 64255 || 65040 <= e3 && e3 <= 65049 || 65072 <= e3 && e3 <= 65131 || 65281 <= e3 && e3 <= 65376 || 65504 <= e3 && e3 <= 65510 || 110592 <= e3 && e3 <= 110593 || 127488 <= e3 && e3 <= 127569 || 131072 <= e3 && e3 <= 262141) : false;
        }
        var w2 = Pe({ "node_modules/is-fullwidth-code-point/index.js"() {
          I();
        } }), k2 = S2({ "node_modules/emoji-regex/index.js"(e3, r3) {
          "use strict";
          I(), r3.exports = function() {
            return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
          };
        } }), ea = {};
        Li(ea, { default: () => q2 });
        function q2(e3) {
          if (typeof e3 != "string" || e3.length === 0 || (e3 = b2(e3), e3.length === 0))
            return 0;
          e3 = e3.replace((0, ra.default)(), "  ");
          let r3 = 0;
          for (let u = 0; u < e3.length; u++) {
            let t3 = e3.codePointAt(u);
            t3 <= 31 || t3 >= 127 && t3 <= 159 || t3 >= 768 && t3 <= 879 || (t3 > 65535 && u++, r3 += B2(t3) ? 2 : 1);
          }
          return r3;
        }
        var ra, _2 = Pe({ "node_modules/string-width/index.js"() {
          I(), y2(), w2(), ra = Nl(k2());
        } }), O2 = S2({ "src/utils/get-string-width.js"(e3, r3) {
          "use strict";
          I();
          var u = (_2(), ji(ea)).default, t3 = /[^\x20-\x7F]/;
          function o(n) {
            return n ? t3.test(n) ? u(n) : n.length : 0;
          }
          r3.exports = o;
        } }), mu = S2({ "src/utils/text/skip.js"(e3, r3) {
          "use strict";
          I();
          function u(c) {
            return (i3, D, a) => {
              let l = a && a.backwards;
              if (D === false)
                return false;
              let { length: p } = i3, d = D;
              for (; d >= 0 && d < p; ) {
                let g = i3.charAt(d);
                if (c instanceof RegExp) {
                  if (!c.test(g))
                    return d;
                } else if (!c.includes(g))
                  return d;
                l ? d-- : d++;
              }
              return d === -1 || d === p ? d : false;
            };
          }
          var t3 = u(/\s/), o = u(" 	"), n = u(",; 	"), s3 = u(/[^\n\r]/);
          r3.exports = { skipWhitespace: t3, skipSpaces: o, skipToLineEnd: n, skipEverythingButNewLine: s3 };
        } }), ua = S2({ "src/utils/text/skip-inline-comment.js"(e3, r3) {
          "use strict";
          I();
          function u(t3, o) {
            if (o === false)
              return false;
            if (t3.charAt(o) === "/" && t3.charAt(o + 1) === "*") {
              for (let n = o + 2; n < t3.length; ++n)
                if (t3.charAt(n) === "*" && t3.charAt(n + 1) === "/")
                  return n + 2;
            }
            return o;
          }
          r3.exports = u;
        } }), ta = S2({ "src/utils/text/skip-trailing-comment.js"(e3, r3) {
          "use strict";
          I();
          var { skipEverythingButNewLine: u } = mu();
          function t3(o, n) {
            return n === false ? false : o.charAt(n) === "/" && o.charAt(n + 1) === "/" ? u(o, n) : n;
          }
          r3.exports = t3;
        } }), na = S2({ "src/utils/text/skip-newline.js"(e3, r3) {
          "use strict";
          I();
          function u(t3, o, n) {
            let s3 = n && n.backwards;
            if (o === false)
              return false;
            let c = t3.charAt(o);
            if (s3) {
              if (t3.charAt(o - 1) === "\r" && c === `
`)
                return o - 2;
              if (c === `
` || c === "\r" || c === "\u2028" || c === "\u2029")
                return o - 1;
            } else {
              if (c === "\r" && t3.charAt(o + 1) === `
`)
                return o + 2;
              if (c === `
` || c === "\r" || c === "\u2028" || c === "\u2029")
                return o + 1;
            }
            return o;
          }
          r3.exports = u;
        } }), I2 = S2({ "src/utils/text/get-next-non-space-non-comment-character-index-with-start-index.js"(e3, r3) {
          "use strict";
          I();
          var u = ua(), t3 = na(), o = ta(), { skipSpaces: n } = mu();
          function s3(c, i3) {
            let D = null, a = i3;
            for (; a !== D; )
              D = a, a = n(c, a), a = u(c, a), a = o(c, a), a = t3(c, a);
            return a;
          }
          r3.exports = s3;
        } }), S22 = S2({ "src/common/util.js"(e3, r3) {
          "use strict";
          I();
          var { default: u } = (s2(), ji(Ji)), t3 = c2(), { getSupportInfo: o } = g2(), n = F2(), s3 = O2(), { skipWhitespace: c, skipSpaces: i3, skipToLineEnd: D, skipEverythingButNewLine: a } = mu(), l = ua(), p = ta(), d = na(), g = I2(), F3 = (k) => k[k.length - 2];
          function E(k) {
            return (y, _, N) => {
              let V = N && N.backwards;
              if (_ === false)
                return false;
              let { length: W } = y, K = _;
              for (; K >= 0 && K < W; ) {
                let ee = y.charAt(K);
                if (k instanceof RegExp) {
                  if (!k.test(ee))
                    return K;
                } else if (!k.includes(ee))
                  return K;
                V ? K-- : K++;
              }
              return K === -1 || K === W ? K : false;
            };
          }
          function x3(k, y) {
            let _ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, N = i3(k, _.backwards ? y - 1 : y, _), V = d(k, N, _);
            return N !== V;
          }
          function f3(k, y, _) {
            for (let N = y; N < _; ++N)
              if (k.charAt(N) === `
`)
                return true;
            return false;
          }
          function b(k, y, _) {
            let N = _(y) - 1;
            N = i3(k, N, { backwards: true }), N = d(k, N, { backwards: true }), N = i3(k, N, { backwards: true });
            let V = d(k, N, { backwards: true });
            return N !== V;
          }
          function v(k, y) {
            let _ = null, N = y;
            for (; N !== _; )
              _ = N, N = D(k, N), N = l(k, N), N = i3(k, N);
            return N = p(k, N), N = d(k, N), N !== false && x3(k, N);
          }
          function h3(k, y, _) {
            return v(k, _(y));
          }
          function m3(k, y, _) {
            return g(k, _(y));
          }
          function C(k, y, _) {
            return k.charAt(m3(k, y, _));
          }
          function B(k, y) {
            let _ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            return i3(k, _.backwards ? y - 1 : y, _) !== y;
          }
          function q(k, y) {
            let _ = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, N = 0;
            for (let V = _; V < k.length; ++V)
              k[V] === "	" ? N = N + y - N % y : N++;
            return N;
          }
          function L(k, y) {
            let _ = k.lastIndexOf(`
`);
            return _ === -1 ? 0 : q(k.slice(_ + 1).match(/^[\t ]*/)[0], y);
          }
          function w(k, y) {
            let _ = { quote: '"', regex: /"/g, escaped: "&quot;" }, N = { quote: "'", regex: /'/g, escaped: "&apos;" }, V = y === "'" ? N : _, W = V === N ? _ : N, K = V;
            if (k.includes(V.quote) || k.includes(W.quote)) {
              let ee = (k.match(V.regex) || []).length, Y = (k.match(W.regex) || []).length;
              K = ee > Y ? W : V;
            }
            return K;
          }
          function O(k, y) {
            let _ = k.slice(1, -1), N = y.parser === "json" || y.parser === "json5" && y.quoteProps === "preserve" && !y.singleQuote ? '"' : y.__isInHtmlAttribute ? "'" : w(_, y.singleQuote ? "'" : '"').quote;
            return T(_, N, !(y.parser === "css" || y.parser === "less" || y.parser === "scss" || y.__embeddedInHtml));
          }
          function T(k, y, _) {
            let N = y === '"' ? "'" : '"', V = /\\(.)|(["'])/gs, W = k.replace(V, (K, ee, Y) => ee === N ? ee : Y === y ? "\\" + Y : Y || (_ && /^[^\n\r"'0-7\\bfnrt-vx\u2028\u2029]$/.test(ee) ? ee : "\\" + ee));
            return y + W + y;
          }
          function P(k) {
            return k.toLowerCase().replace(/^([+-]?[\d.]+e)(?:\+|(-))?0*(\d)/, "$1$2$3").replace(/^([+-]?[\d.]+)e[+-]?0+$/, "$1").replace(/^([+-])?\./, "$10.").replace(/(\.\d+?)0+(?=e|$)/, "$1").replace(/\.(?=e|$)/, "");
          }
          function A3(k, y) {
            let _ = k.match(new RegExp("(".concat(u(y), ")+"), "g"));
            return _ === null ? 0 : _.reduce((N, V) => Math.max(N, V.length / y.length), 0);
          }
          function j(k, y) {
            let _ = k.match(new RegExp("(".concat(u(y), ")+"), "g"));
            if (_ === null)
              return 0;
            let N = /* @__PURE__ */ new Map(), V = 0;
            for (let W of _) {
              let K = W.length / y.length;
              N.set(K, true), K > V && (V = K);
            }
            for (let W = 1; W < V; W++)
              if (!N.get(W))
                return W;
            return V + 1;
          }
          function $(k, y) {
            (k.comments || (k.comments = [])).push(y), y.printed = false, y.nodeDescription = G(k);
          }
          function U(k, y) {
            y.leading = true, y.trailing = false, $(k, y);
          }
          function X(k, y, _) {
            y.leading = false, y.trailing = false, _ && (y.marker = _), $(k, y);
          }
          function R(k, y) {
            y.leading = false, y.trailing = true, $(k, y);
          }
          function J(k, y) {
            let { languages: _ } = o({ plugins: y.plugins }), N = _.find((V) => {
              let { name: W } = V;
              return W.toLowerCase() === k;
            }) || _.find((V) => {
              let { aliases: W } = V;
              return Array.isArray(W) && W.includes(k);
            }) || _.find((V) => {
              let { extensions: W } = V;
              return Array.isArray(W) && W.includes(".".concat(k));
            });
            return N && N.parsers[0];
          }
          function z(k) {
            return k && k.type === "front-matter";
          }
          function M(k) {
            let y = /* @__PURE__ */ new WeakMap();
            return function(_) {
              return y.has(_) || y.set(_, Symbol(k)), y.get(_);
            };
          }
          function G(k) {
            let y = k.type || k.kind || "(unknown type)", _ = String(k.name || k.id && (typeof k.id == "object" ? k.id.name : k.id) || k.key && (typeof k.key == "object" ? k.key.name : k.key) || k.value && (typeof k.value == "object" ? "" : String(k.value)) || k.operator || "");
            return _.length > 20 && (_ = _.slice(0, 19) + "\u2026"), y + (_ ? " " + _ : "");
          }
          r3.exports = { inferParserByLanguage: J, getStringWidth: s3, getMaxContinuousCount: A3, getMinNotPresentContinuousCount: j, getPenultimate: F3, getLast: t3, getNextNonSpaceNonCommentCharacterIndexWithStartIndex: g, getNextNonSpaceNonCommentCharacterIndex: m3, getNextNonSpaceNonCommentCharacter: C, skip: E, skipWhitespace: c, skipSpaces: i3, skipToLineEnd: D, skipEverythingButNewLine: a, skipInlineComment: l, skipTrailingComment: p, skipNewline: d, isNextLineEmptyAfterIndex: v, isNextLineEmpty: h3, isPreviousLineEmpty: b, hasNewline: x3, hasNewlineInRange: f3, hasSpaces: B, getAlignmentSize: q, getIndentSize: L, getPreferredQuote: w, printString: O, printNumber: P, makeString: T, addLeadingComment: U, addDanglingComment: X, addTrailingComment: R, isFrontMatterNode: z, isNonEmptyArray: n, createGroupIdMapper: M };
        } }), T2 = S2({ "src/language-markdown/constants.evaluate.js"(e3, r3) {
          r3.exports = { cjkPattern: "(?:[\\u02ea-\\u02eb\\u1100-\\u11ff\\u2e80-\\u2e99\\u2e9b-\\u2ef3\\u2f00-\\u2fd5\\u2ff0-\\u303f\\u3041-\\u3096\\u3099-\\u309f\\u30a1-\\u30fa\\u30fc-\\u30ff\\u3105-\\u312f\\u3131-\\u318e\\u3190-\\u3191\\u3196-\\u31ba\\u31c0-\\u31e3\\u31f0-\\u321e\\u322a-\\u3247\\u3260-\\u327e\\u328a-\\u32b0\\u32c0-\\u32cb\\u32d0-\\u3370\\u337b-\\u337f\\u33e0-\\u33fe\\u3400-\\u4db5\\u4e00-\\u9fef\\ua960-\\ua97c\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\uf900-\\ufa6d\\ufa70-\\ufad9\\ufe10-\\ufe1f\\ufe30-\\ufe6f\\uff00-\\uffef]|[\\ud840-\\ud868\\ud86a-\\ud86c\\ud86f-\\ud872\\ud874-\\ud879][\\udc00-\\udfff]|\\ud82c[\\udc00-\\udd1e\\udd50-\\udd52\\udd64-\\udd67]|\\ud83c[\\ude00\\ude50-\\ude51]|\\ud869[\\udc00-\\uded6\\udf00-\\udfff]|\\ud86d[\\udc00-\\udf34\\udf40-\\udfff]|\\ud86e[\\udc00-\\udc1d\\udc20-\\udfff]|\\ud873[\\udc00-\\udea1\\udeb0-\\udfff]|\\ud87a[\\udc00-\\udfe0]|\\ud87e[\\udc00-\\ude1d])(?:[\\ufe00-\\ufe0f]|\\udb40[\\udd00-\\uddef])?", kPattern: "[\\u1100-\\u11ff\\u3001-\\u3003\\u3008-\\u3011\\u3013-\\u301f\\u302e-\\u3030\\u3037\\u30fb\\u3131-\\u318e\\u3200-\\u321e\\u3260-\\u327e\\ua960-\\ua97c\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\ufe45-\\ufe46\\uff61-\\uff65\\uffa0-\\uffbe\\uffc2-\\uffc7\\uffca-\\uffcf\\uffd2-\\uffd7\\uffda-\\uffdc]", punctuationPattern: "[\\u0021-\\u002f\\u003a-\\u0040\\u005b-\\u0060\\u007b-\\u007e\\u00a1\\u00a7\\u00ab\\u00b6-\\u00b7\\u00bb\\u00bf\\u037e\\u0387\\u055a-\\u055f\\u0589-\\u058a\\u05be\\u05c0\\u05c3\\u05c6\\u05f3-\\u05f4\\u0609-\\u060a\\u060c-\\u060d\\u061b\\u061e-\\u061f\\u066a-\\u066d\\u06d4\\u0700-\\u070d\\u07f7-\\u07f9\\u0830-\\u083e\\u085e\\u0964-\\u0965\\u0970\\u09fd\\u0a76\\u0af0\\u0c77\\u0c84\\u0df4\\u0e4f\\u0e5a-\\u0e5b\\u0f04-\\u0f12\\u0f14\\u0f3a-\\u0f3d\\u0f85\\u0fd0-\\u0fd4\\u0fd9-\\u0fda\\u104a-\\u104f\\u10fb\\u1360-\\u1368\\u1400\\u166e\\u169b-\\u169c\\u16eb-\\u16ed\\u1735-\\u1736\\u17d4-\\u17d6\\u17d8-\\u17da\\u1800-\\u180a\\u1944-\\u1945\\u1a1e-\\u1a1f\\u1aa0-\\u1aa6\\u1aa8-\\u1aad\\u1b5a-\\u1b60\\u1bfc-\\u1bff\\u1c3b-\\u1c3f\\u1c7e-\\u1c7f\\u1cc0-\\u1cc7\\u1cd3\\u2010-\\u2027\\u2030-\\u2043\\u2045-\\u2051\\u2053-\\u205e\\u207d-\\u207e\\u208d-\\u208e\\u2308-\\u230b\\u2329-\\u232a\\u2768-\\u2775\\u27c5-\\u27c6\\u27e6-\\u27ef\\u2983-\\u2998\\u29d8-\\u29db\\u29fc-\\u29fd\\u2cf9-\\u2cfc\\u2cfe-\\u2cff\\u2d70\\u2e00-\\u2e2e\\u2e30-\\u2e4f\\u3001-\\u3003\\u3008-\\u3011\\u3014-\\u301f\\u3030\\u303d\\u30a0\\u30fb\\ua4fe-\\ua4ff\\ua60d-\\ua60f\\ua673\\ua67e\\ua6f2-\\ua6f7\\ua874-\\ua877\\ua8ce-\\ua8cf\\ua8f8-\\ua8fa\\ua8fc\\ua92e-\\ua92f\\ua95f\\ua9c1-\\ua9cd\\ua9de-\\ua9df\\uaa5c-\\uaa5f\\uaade-\\uaadf\\uaaf0-\\uaaf1\\uabeb\\ufd3e-\\ufd3f\\ufe10-\\ufe19\\ufe30-\\ufe52\\ufe54-\\ufe61\\ufe63\\ufe68\\ufe6a-\\ufe6b\\uff01-\\uff03\\uff05-\\uff0a\\uff0c-\\uff0f\\uff1a-\\uff1b\\uff1f-\\uff20\\uff3b-\\uff3d\\uff3f\\uff5b\\uff5d\\uff5f-\\uff65]|\\ud800[\\udd00-\\udd02\\udf9f\\udfd0]|\\ud801[\\udd6f]|\\ud802[\\udc57\\udd1f\\udd3f\\ude50-\\ude58\\ude7f\\udef0-\\udef6\\udf39-\\udf3f\\udf99-\\udf9c]|\\ud803[\\udf55-\\udf59]|\\ud804[\\udc47-\\udc4d\\udcbb-\\udcbc\\udcbe-\\udcc1\\udd40-\\udd43\\udd74-\\udd75\\uddc5-\\uddc8\\uddcd\\udddb\\udddd-\\udddf\\ude38-\\ude3d\\udea9]|\\ud805[\\udc4b-\\udc4f\\udc5b\\udc5d\\udcc6\\uddc1-\\uddd7\\ude41-\\ude43\\ude60-\\ude6c\\udf3c-\\udf3e]|\\ud806[\\udc3b\\udde2\\ude3f-\\ude46\\ude9a-\\ude9c\\ude9e-\\udea2]|\\ud807[\\udc41-\\udc45\\udc70-\\udc71\\udef7-\\udef8\\udfff]|\\ud809[\\udc70-\\udc74]|\\ud81a[\\ude6e-\\ude6f\\udef5\\udf37-\\udf3b\\udf44]|\\ud81b[\\ude97-\\ude9a\\udfe2]|\\ud82f[\\udc9f]|\\ud836[\\ude87-\\ude8b]|\\ud83a[\\udd5e-\\udd5f]" };
        } }), N2 = S2({ "src/language-markdown/utils.js"(e3, r3) {
          "use strict";
          I();
          var { getLast: u } = S22(), { locStart: t3, locEnd: o } = Ki(), { cjkPattern: n, kPattern: s3, punctuationPattern: c } = T2(), i3 = ["liquidNode", "inlineCode", "emphasis", "esComment", "strong", "delete", "wikiLink", "link", "linkReference", "image", "imageReference", "footnote", "footnoteReference", "sentence", "whitespace", "word", "break", "inlineMath"], D = [...i3, "tableCell", "paragraph", "heading"], a = new RegExp(s3), l = new RegExp(c);
          function p(f3, b) {
            let v = "non-cjk", h3 = "cj-letter", m3 = "k-letter", C = "cjk-punctuation", B = [], q = (b.proseWrap === "preserve" ? f3 : f3.replace(new RegExp("(".concat(n, `)
(`).concat(n, ")"), "g"), "$1$2")).split(/([\t\n ]+)/);
            for (let [w, O] of q.entries()) {
              if (w % 2 === 1) {
                B.push({ type: "whitespace", value: /\n/.test(O) ? `
` : " " });
                continue;
              }
              if ((w === 0 || w === q.length - 1) && O === "")
                continue;
              let T = O.split(new RegExp("(".concat(n, ")")));
              for (let [P, A3] of T.entries())
                if (!((P === 0 || P === T.length - 1) && A3 === "")) {
                  if (P % 2 === 0) {
                    A3 !== "" && L({ type: "word", value: A3, kind: v, hasLeadingPunctuation: l.test(A3[0]), hasTrailingPunctuation: l.test(u(A3)) });
                    continue;
                  }
                  L(l.test(A3) ? { type: "word", value: A3, kind: C, hasLeadingPunctuation: true, hasTrailingPunctuation: true } : { type: "word", value: A3, kind: a.test(A3) ? m3 : h3, hasLeadingPunctuation: false, hasTrailingPunctuation: false });
                }
            }
            return B;
            function L(w) {
              let O = u(B);
              O && O.type === "word" && (O.kind === v && w.kind === h3 && !O.hasTrailingPunctuation || O.kind === h3 && w.kind === v && !w.hasLeadingPunctuation ? B.push({ type: "whitespace", value: " " }) : !T(v, C) && ![O.value, w.value].some((P) => /\u3000/.test(P)) && B.push({ type: "whitespace", value: "" })), B.push(w);
              function T(P, A3) {
                return O.kind === P && w.kind === A3 || O.kind === A3 && w.kind === P;
              }
            }
          }
          function d(f3, b) {
            let [, v, h3, m3] = b.slice(f3.position.start.offset, f3.position.end.offset).match(/^\s*(\d+)(\.|\))(\s*)/);
            return { numberText: v, marker: h3, leadingSpaces: m3 };
          }
          function g(f3, b) {
            if (!f3.ordered || f3.children.length < 2)
              return false;
            let v = Number(d(f3.children[0], b.originalText).numberText), h3 = Number(d(f3.children[1], b.originalText).numberText);
            if (v === 0 && f3.children.length > 2) {
              let m3 = Number(d(f3.children[2], b.originalText).numberText);
              return h3 === 1 && m3 === 1;
            }
            return h3 === 1;
          }
          function F3(f3, b) {
            let { value: v } = f3;
            return f3.position.end.offset === b.length && v.endsWith(`
`) && b.endsWith(`
`) ? v.slice(0, -1) : v;
          }
          function E(f3, b) {
            return function v(h3, m3, C) {
              let B = Object.assign({}, b(h3, m3, C));
              return B.children && (B.children = B.children.map((q, L) => v(q, L, [B, ...C]))), B;
            }(f3, null, []);
          }
          function x3(f3) {
            if ((f3 == null ? void 0 : f3.type) !== "link" || f3.children.length !== 1)
              return false;
            let [b] = f3.children;
            return t3(f3) === t3(b) && o(f3) === o(b);
          }
          r3.exports = { mapAst: E, splitText: p, punctuationPattern: c, getFencedCodeBlockValue: F3, getOrderedListItemInfo: d, hasGitDiffFriendlyOrderedList: g, INLINE_NODE_TYPES: i3, INLINE_NODE_WRAPPER_TYPES: D, isAutolink: x3 };
        } }), L2 = S2({ "src/language-markdown/unified-plugins/html-to-jsx.js"(e3, r3) {
          "use strict";
          I();
          var u = Yi(), { mapAst: t3, INLINE_NODE_WRAPPER_TYPES: o } = N2();
          function n() {
            return (s3) => t3(s3, (c, i3, D) => {
              let [a] = D;
              return c.type !== "html" || u.COMMENT_REGEX.test(c.value) || o.includes(a.type) ? c : Object.assign(Object.assign({}, c), {}, { type: "jsx" });
            });
          }
          r3.exports = n;
        } }), R2 = S2({ "src/language-markdown/unified-plugins/front-matter.js"(e3, r3) {
          "use strict";
          I();
          var u = Wi();
          function t3() {
            let o = this.Parser.prototype;
            o.blockMethods = ["frontMatter", ...o.blockMethods], o.blockTokenizers.frontMatter = n;
            function n(s3, c) {
              let i3 = u(c);
              if (i3.frontMatter)
                return s3(i3.frontMatter.raw)(i3.frontMatter);
            }
            n.onlyAtStart = true;
          }
          r3.exports = t3;
        } }), j2 = S2({ "src/language-markdown/unified-plugins/liquid.js"(e3, r3) {
          "use strict";
          I();
          function u() {
            let t3 = this.Parser.prototype, o = t3.inlineMethods;
            o.splice(o.indexOf("text"), 0, "liquid"), t3.inlineTokenizers.liquid = n;
            function n(s3, c) {
              let i3 = c.match(/^({%.*?%}|{{.*?}})/s);
              if (i3)
                return s3(i3[0])({ type: "liquidNode", value: i3[0] });
            }
            n.locator = function(s3, c) {
              return s3.indexOf("{", c);
            };
          }
          r3.exports = u;
        } }), P2 = S2({ "src/language-markdown/unified-plugins/wiki-link.js"(e3, r3) {
          "use strict";
          I();
          function u() {
            let t3 = "wikiLink", o = /^\[\[(?<linkContents>.+?)]]/s, n = this.Parser.prototype, s3 = n.inlineMethods;
            s3.splice(s3.indexOf("link"), 0, t3), n.inlineTokenizers.wikiLink = c;
            function c(i3, D) {
              let a = o.exec(D);
              if (a) {
                let l = a.groups.linkContents.trim();
                return i3(a[0])({ type: t3, value: l });
              }
            }
            c.locator = function(i3, D) {
              return i3.indexOf("[", D);
            };
          }
          r3.exports = u;
        } }), M2 = S2({ "src/language-markdown/unified-plugins/loose-items.js"(e3, r3) {
          "use strict";
          I();
          function u() {
            let t3 = this.Parser.prototype, o = t3.blockTokenizers.list;
            function n(s3, c, i3) {
              return c.type === "listItem" && (c.loose = c.spread || s3.charAt(s3.length - 1) === `
`, c.loose && (i3.loose = true)), c;
            }
            t3.blockTokenizers.list = function(c, i3, D) {
              function a(l) {
                let p = c(l);
                function d(g, F3) {
                  return p(n(l, g, F3), F3);
                }
                return d.reset = function(g, F3) {
                  return p.reset(n(l, g, F3), F3);
                }, d;
              }
              return a.now = c.now, o.call(this, a, i3, D);
            };
          }
          r3.exports = u;
        } });
        I();
        var z2 = GD(), G2 = r2(), U2 = n2(), V2 = i2(), $2 = a2(), { locStart: H2, locEnd: X2 } = Ki(), Si = Yi(), W2 = L2(), K2 = R2(), Y2 = j2(), J2 = P2(), Z2 = M2();
        function ia(e3) {
          let { isMDX: r3 } = e3;
          return (u) => {
            let t3 = G2().use(z2, Object.assign({ commonmark: true }, r3 && { blocks: [Si.BLOCKS_REGEX] })).use(V2).use(K2).use(U2).use(r3 ? Si.esSyntax : Ti).use(Y2).use(r3 ? W2 : Ti).use(J2).use(Z2);
            return t3.runSync(t3.parse(u));
          };
        }
        function Ti(e3) {
          return e3;
        }
        var aa = { astFormat: "mdast", hasPragma: $2.hasPragma, locStart: H2, locEnd: X2 }, Ni = Object.assign(Object.assign({}, aa), {}, { parse: ia({ isMDX: false }) }), Q2 = Object.assign(Object.assign({}, aa), {}, { parse: ia({ isMDX: true }) });
        oa.exports = { parsers: { remark: Ni, markdown: Ni, mdx: Q2 } };
      });
      return ef();
    });
  }
});

// node_modules/prettier/parser-html.js
var require_parser_html = __commonJS({
  "node_modules/prettier/parser-html.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.html = e2();
      }
    })(function() {
      "use strict";
      var y = (e2, r2) => () => (r2 || e2((r2 = { exports: {} }).exports, r2), r2.exports);
      var G = y((cl, zr) => {
        var we = function(e2) {
          return e2 && e2.Math == Math && e2;
        };
        zr.exports = we(typeof globalThis == "object" && globalThis) || we(typeof window == "object" && window) || we(typeof self == "object" && self) || we(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      });
      var se = y((Dl, Wr) => {
        Wr.exports = function(e2) {
          try {
            return !!e2();
          } catch {
            return true;
          }
        };
      });
      var oe = y((ll, Yr) => {
        var bs = se();
        Yr.exports = !bs(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      });
      var Ne = y((hl, Qr) => {
        var ws = se();
        Qr.exports = !ws(function() {
          var e2 = function() {
          }.bind();
          return typeof e2 != "function" || e2.hasOwnProperty("prototype");
        });
      });
      var ce = y((pl, Kr) => {
        var Ns = Ne(), Oe = Function.prototype.call;
        Kr.exports = Ns ? Oe.bind(Oe) : function() {
          return Oe.apply(Oe, arguments);
        };
      });
      var rt = y((et) => {
        "use strict";
        var Jr = {}.propertyIsEnumerable, Zr = Object.getOwnPropertyDescriptor, Os = Zr && !Jr.call({ 1: 2 }, 1);
        et.f = Os ? function(r2) {
          var t2 = Zr(this, r2);
          return !!t2 && t2.enumerable;
        } : Jr;
      });
      var qe = y((dl, tt) => {
        tt.exports = function(e2, r2) {
          return { enumerable: !(e2 & 1), configurable: !(e2 & 2), writable: !(e2 & 4), value: r2 };
        };
      });
      var Q = y((El, st) => {
        var ut = Ne(), nt = Function.prototype, qs = nt.bind, er = nt.call, Is = ut && qs.bind(er, er);
        st.exports = ut ? function(e2) {
          return e2 && Is(e2);
        } : function(e2) {
          return e2 && function() {
            return er.apply(e2, arguments);
          };
        };
      });
      var Ie = y((Cl, it) => {
        var at = Q(), Rs = at({}.toString), xs = at("".slice);
        it.exports = function(e2) {
          return xs(Rs(e2), 8, -1);
        };
      });
      var ct = y((ml, ot) => {
        var Ps = G(), ks = Q(), Ls = se(), Ms = Ie(), rr = Ps.Object, js = ks("".split);
        ot.exports = Ls(function() {
          return !rr("z").propertyIsEnumerable(0);
        }) ? function(e2) {
          return Ms(e2) == "String" ? js(e2, "") : rr(e2);
        } : rr;
      });
      var tr = y((gl, Dt) => {
        var $s = G(), Us = $s.TypeError;
        Dt.exports = function(e2) {
          if (e2 == null)
            throw Us("Can't call method on " + e2);
          return e2;
        };
      });
      var Re = y((Fl, lt) => {
        var Gs = ct(), Vs = tr();
        lt.exports = function(e2) {
          return Gs(Vs(e2));
        };
      });
      var K = y((Al, ht) => {
        ht.exports = function(e2) {
          return typeof e2 == "function";
        };
      });
      var De = y((vl, pt) => {
        var Xs = K();
        pt.exports = function(e2) {
          return typeof e2 == "object" ? e2 !== null : Xs(e2);
        };
      });
      var ge = y((_l, ft) => {
        var ur = G(), Hs = K(), zs = function(e2) {
          return Hs(e2) ? e2 : void 0;
        };
        ft.exports = function(e2, r2) {
          return arguments.length < 2 ? zs(ur[e2]) : ur[e2] && ur[e2][r2];
        };
      });
      var nr = y((Sl, dt) => {
        var Ws = Q();
        dt.exports = Ws({}.isPrototypeOf);
      });
      var Ct = y((yl, Et) => {
        var Ys = ge();
        Et.exports = Ys("navigator", "userAgent") || "";
      });
      var St = y((Tl, _t) => {
        var vt = G(), sr = Ct(), mt = vt.process, gt = vt.Deno, Ft = mt && mt.versions || gt && gt.version, At = Ft && Ft.v8, te, xe;
        At && (te = At.split("."), xe = te[0] > 0 && te[0] < 4 ? 1 : +(te[0] + te[1]));
        !xe && sr && (te = sr.match(/Edge\/(\d+)/), (!te || te[1] >= 74) && (te = sr.match(/Chrome\/(\d+)/), te && (xe = +te[1])));
        _t.exports = xe;
      });
      var ar = y((Bl, Tt) => {
        var yt = St(), Qs = se();
        Tt.exports = !!Object.getOwnPropertySymbols && !Qs(function() {
          var e2 = Symbol();
          return !String(e2) || !(Object(e2) instanceof Symbol) || !Symbol.sham && yt && yt < 41;
        });
      });
      var ir = y((bl, Bt) => {
        var Ks = ar();
        Bt.exports = Ks && !Symbol.sham && typeof Symbol.iterator == "symbol";
      });
      var or = y((wl, bt) => {
        var Js = G(), Zs = ge(), ea = K(), ra = nr(), ta = ir(), ua = Js.Object;
        bt.exports = ta ? function(e2) {
          return typeof e2 == "symbol";
        } : function(e2) {
          var r2 = Zs("Symbol");
          return ea(r2) && ra(r2.prototype, ua(e2));
        };
      });
      var Pe = y((Nl, wt) => {
        var na = G(), sa = na.String;
        wt.exports = function(e2) {
          try {
            return sa(e2);
          } catch {
            return "Object";
          }
        };
      });
      var Fe = y((Ol, Nt) => {
        var aa = G(), ia = K(), oa = Pe(), ca = aa.TypeError;
        Nt.exports = function(e2) {
          if (ia(e2))
            return e2;
          throw ca(oa(e2) + " is not a function");
        };
      });
      var ke = y((ql, Ot) => {
        var Da = Fe();
        Ot.exports = function(e2, r2) {
          var t2 = e2[r2];
          return t2 == null ? void 0 : Da(t2);
        };
      });
      var It = y((Il, qt) => {
        var la = G(), cr = ce(), Dr = K(), lr = De(), ha = la.TypeError;
        qt.exports = function(e2, r2) {
          var t2, s2;
          if (r2 === "string" && Dr(t2 = e2.toString) && !lr(s2 = cr(t2, e2)) || Dr(t2 = e2.valueOf) && !lr(s2 = cr(t2, e2)) || r2 !== "string" && Dr(t2 = e2.toString) && !lr(s2 = cr(t2, e2)))
            return s2;
          throw ha("Can't convert object to primitive value");
        };
      });
      var xt = y((Rl, Rt) => {
        Rt.exports = false;
      });
      var Le = y((xl, kt) => {
        var Pt = G(), pa = Object.defineProperty;
        kt.exports = function(e2, r2) {
          try {
            pa(Pt, e2, { value: r2, configurable: true, writable: true });
          } catch {
            Pt[e2] = r2;
          }
          return r2;
        };
      });
      var Me = y((Pl, Mt) => {
        var fa = G(), da = Le(), Lt = "__core-js_shared__", Ea = fa[Lt] || da(Lt, {});
        Mt.exports = Ea;
      });
      var hr = y((kl, $t) => {
        var Ca = xt(), jt = Me();
        ($t.exports = function(e2, r2) {
          return jt[e2] || (jt[e2] = r2 !== void 0 ? r2 : {});
        })("versions", []).push({ version: "3.22.2", mode: Ca ? "pure" : "global", copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)", license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE", source: "https://github.com/zloirock/core-js" });
      });
      var pr = y((Ll, Ut) => {
        var ma = G(), ga = tr(), Fa = ma.Object;
        Ut.exports = function(e2) {
          return Fa(ga(e2));
        };
      });
      var ae = y((Ml, Gt) => {
        var Aa = Q(), va = pr(), _a4 = Aa({}.hasOwnProperty);
        Gt.exports = Object.hasOwn || function(r2, t2) {
          return _a4(va(r2), t2);
        };
      });
      var fr = y((jl, Vt) => {
        var Sa = Q(), ya = 0, Ta = Math.random(), Ba = Sa(1 .toString);
        Vt.exports = function(e2) {
          return "Symbol(" + (e2 === void 0 ? "" : e2) + ")_" + Ba(++ya + Ta, 36);
        };
      });
      var he = y(($l, Yt) => {
        var ba = G(), wa = hr(), Xt = ae(), Na = fr(), Ht = ar(), Wt = ir(), fe = wa("wks"), le = ba.Symbol, zt = le && le.for, Oa = Wt ? le : le && le.withoutSetter || Na;
        Yt.exports = function(e2) {
          if (!Xt(fe, e2) || !(Ht || typeof fe[e2] == "string")) {
            var r2 = "Symbol." + e2;
            Ht && Xt(le, e2) ? fe[e2] = le[e2] : Wt && zt ? fe[e2] = zt(r2) : fe[e2] = Oa(r2);
          }
          return fe[e2];
        };
      });
      var Zt = y((Ul, Jt) => {
        var qa = G(), Ia = ce(), Qt = De(), Kt = or(), Ra = ke(), xa = It(), Pa = he(), ka = qa.TypeError, La = Pa("toPrimitive");
        Jt.exports = function(e2, r2) {
          if (!Qt(e2) || Kt(e2))
            return e2;
          var t2 = Ra(e2, La), s2;
          if (t2) {
            if (r2 === void 0 && (r2 = "default"), s2 = Ia(t2, e2, r2), !Qt(s2) || Kt(s2))
              return s2;
            throw ka("Can't convert object to primitive value");
          }
          return r2 === void 0 && (r2 = "number"), xa(e2, r2);
        };
      });
      var je = y((Gl, eu) => {
        var Ma = Zt(), ja = or();
        eu.exports = function(e2) {
          var r2 = Ma(e2, "string");
          return ja(r2) ? r2 : r2 + "";
        };
      });
      var uu = y((Vl, tu) => {
        var $a = G(), ru = De(), dr = $a.document, Ua = ru(dr) && ru(dr.createElement);
        tu.exports = function(e2) {
          return Ua ? dr.createElement(e2) : {};
        };
      });
      var Er = y((Xl, nu) => {
        var Ga = oe(), Va = se(), Xa = uu();
        nu.exports = !Ga && !Va(function() {
          return Object.defineProperty(Xa("div"), "a", { get: function() {
            return 7;
          } }).a != 7;
        });
      });
      var Cr = y((au) => {
        var Ha = oe(), za = ce(), Wa = rt(), Ya = qe(), Qa = Re(), Ka = je(), Ja = ae(), Za = Er(), su = Object.getOwnPropertyDescriptor;
        au.f = Ha ? su : function(r2, t2) {
          if (r2 = Qa(r2), t2 = Ka(t2), Za)
            try {
              return su(r2, t2);
            } catch {
            }
          if (Ja(r2, t2))
            return Ya(!za(Wa.f, r2, t2), r2[t2]);
        };
      });
      var ou = y((zl, iu) => {
        var ei = oe(), ri = se();
        iu.exports = ei && ri(function() {
          return Object.defineProperty(function() {
          }, "prototype", { value: 42, writable: false }).prototype != 42;
        });
      });
      var de = y((Wl, Du) => {
        var cu = G(), ti = De(), ui = cu.String, ni = cu.TypeError;
        Du.exports = function(e2) {
          if (ti(e2))
            return e2;
          throw ni(ui(e2) + " is not an object");
        };
      });
      var Ue = y((hu) => {
        var si = G(), ai = oe(), ii = Er(), oi = ou(), $e = de(), lu = je(), ci = si.TypeError, mr = Object.defineProperty, Di = Object.getOwnPropertyDescriptor, gr = "enumerable", Fr = "configurable", Ar = "writable";
        hu.f = ai ? oi ? function(r2, t2, s2) {
          if ($e(r2), t2 = lu(t2), $e(s2), typeof r2 == "function" && t2 === "prototype" && "value" in s2 && Ar in s2 && !s2[Ar]) {
            var c = Di(r2, t2);
            c && c[Ar] && (r2[t2] = s2.value, s2 = { configurable: Fr in s2 ? s2[Fr] : c[Fr], enumerable: gr in s2 ? s2[gr] : c[gr], writable: false });
          }
          return mr(r2, t2, s2);
        } : mr : function(r2, t2, s2) {
          if ($e(r2), t2 = lu(t2), $e(s2), ii)
            try {
              return mr(r2, t2, s2);
            } catch {
            }
          if ("get" in s2 || "set" in s2)
            throw ci("Accessors not supported");
          return "value" in s2 && (r2[t2] = s2.value), r2;
        };
      });
      var Ge = y((Ql, pu) => {
        var li = oe(), hi = Ue(), pi = qe();
        pu.exports = li ? function(e2, r2, t2) {
          return hi.f(e2, r2, pi(1, t2));
        } : function(e2, r2, t2) {
          return e2[r2] = t2, e2;
        };
      });
      var Ve = y((Kl, fu) => {
        var fi = Q(), di = K(), vr = Me(), Ei = fi(Function.toString);
        di(vr.inspectSource) || (vr.inspectSource = function(e2) {
          return Ei(e2);
        });
        fu.exports = vr.inspectSource;
      });
      var Cu = y((Jl, Eu) => {
        var Ci = G(), mi = K(), gi = Ve(), du = Ci.WeakMap;
        Eu.exports = mi(du) && /native code/.test(gi(du));
      });
      var Fu = y((Zl, gu) => {
        var Fi = hr(), Ai = fr(), mu = Fi("keys");
        gu.exports = function(e2) {
          return mu[e2] || (mu[e2] = Ai(e2));
        };
      });
      var _r = y((e2, Au) => {
        Au.exports = {};
      });
      var Bu = y((r2, Tu) => {
        var vi = Cu(), yu = G(), Sr = Q(), _i = De(), Si = Ge(), yr = ae(), Tr = Me(), yi = Fu(), Ti = _r(), vu = "Object already initialized", br = yu.TypeError, Bi = yu.WeakMap, Xe, Ae, He, bi = function(e2) {
          return He(e2) ? Ae(e2) : Xe(e2, {});
        }, wi = function(e2) {
          return function(r3) {
            var t2;
            if (!_i(r3) || (t2 = Ae(r3)).type !== e2)
              throw br("Incompatible receiver, " + e2 + " required");
            return t2;
          };
        };
        vi || Tr.state ? (ie = Tr.state || (Tr.state = new Bi()), _u = Sr(ie.get), Br = Sr(ie.has), Su = Sr(ie.set), Xe = function(e2, r3) {
          if (Br(ie, e2))
            throw new br(vu);
          return r3.facade = e2, Su(ie, e2, r3), r3;
        }, Ae = function(e2) {
          return _u(ie, e2) || {};
        }, He = function(e2) {
          return Br(ie, e2);
        }) : (pe = yi("state"), Ti[pe] = true, Xe = function(e2, r3) {
          if (yr(e2, pe))
            throw new br(vu);
          return r3.facade = e2, Si(e2, pe, r3), r3;
        }, Ae = function(e2) {
          return yr(e2, pe) ? e2[pe] : {};
        }, He = function(e2) {
          return yr(e2, pe);
        });
        var ie, _u, Br, Su, pe;
        Tu.exports = { set: Xe, get: Ae, has: He, enforce: bi, getterFor: wi };
      });
      var Nu = y((t2, wu) => {
        var wr = oe(), Ni = ae(), bu = Function.prototype, Oi = wr && Object.getOwnPropertyDescriptor, Nr = Ni(bu, "name"), qi = Nr && function() {
        }.name === "something", Ii = Nr && (!wr || wr && Oi(bu, "name").configurable);
        wu.exports = { EXISTS: Nr, PROPER: qi, CONFIGURABLE: Ii };
      });
      var xu = y((u2, Ru) => {
        var Ri = G(), Ou = K(), xi = ae(), qu = Ge(), Pi = Le(), ki = Ve(), Iu = Bu(), Li = Nu().CONFIGURABLE, Mi = Iu.get, ji = Iu.enforce, $i = String(String).split("String");
        (Ru.exports = function(e2, r2, t2, s2) {
          var c = s2 ? !!s2.unsafe : false, n = s2 ? !!s2.enumerable : false, a = s2 ? !!s2.noTargetGet : false, p = s2 && s2.name !== void 0 ? s2.name : r2, D;
          if (Ou(t2) && (String(p).slice(0, 7) === "Symbol(" && (p = "[" + String(p).replace(/^Symbol\(([^)]*)\)/, "$1") + "]"), (!xi(t2, "name") || Li && t2.name !== p) && qu(t2, "name", p), D = ji(t2), D.source || (D.source = $i.join(typeof p == "string" ? p : ""))), e2 === Ri) {
            n ? e2[r2] = t2 : Pi(r2, t2);
            return;
          } else
            c ? !a && e2[r2] && (n = true) : delete e2[r2];
          n ? e2[r2] = t2 : qu(e2, r2, t2);
        })(Function.prototype, "toString", function() {
          return Ou(this) && Mi(this).source || ki(this);
        });
      });
      var Or = y((n2, Pu) => {
        var Ui = Math.ceil, Gi = Math.floor;
        Pu.exports = function(e2) {
          var r2 = +e2;
          return r2 !== r2 || r2 === 0 ? 0 : (r2 > 0 ? Gi : Ui)(r2);
        };
      });
      var Lu = y((s2, ku) => {
        var Vi = Or(), Xi = Math.max, Hi = Math.min;
        ku.exports = function(e2, r2) {
          var t2 = Vi(e2);
          return t2 < 0 ? Xi(t2 + r2, 0) : Hi(t2, r2);
        };
      });
      var ju = y((a2, Mu) => {
        var zi = Or(), Wi = Math.min;
        Mu.exports = function(e2) {
          return e2 > 0 ? Wi(zi(e2), 9007199254740991) : 0;
        };
      });
      var ve = y((i2, $u) => {
        var Yi = ju();
        $u.exports = function(e2) {
          return Yi(e2.length);
        };
      });
      var Vu = y((o2, Gu) => {
        var Qi = Re(), Ki = Lu(), Ji = ve(), Uu = function(e2) {
          return function(r2, t2, s2) {
            var c = Qi(r2), n = Ji(c), a = Ki(s2, n), p;
            if (e2 && t2 != t2) {
              for (; n > a; )
                if (p = c[a++], p != p)
                  return true;
            } else
              for (; n > a; a++)
                if ((e2 || a in c) && c[a] === t2)
                  return e2 || a || 0;
            return !e2 && -1;
          };
        };
        Gu.exports = { includes: Uu(true), indexOf: Uu(false) };
      });
      var zu = y((c2, Hu) => {
        var Zi = Q(), qr = ae(), eo = Re(), ro = Vu().indexOf, to = _r(), Xu = Zi([].push);
        Hu.exports = function(e2, r2) {
          var t2 = eo(e2), s2 = 0, c = [], n;
          for (n in t2)
            !qr(to, n) && qr(t2, n) && Xu(c, n);
          for (; r2.length > s2; )
            qr(t2, n = r2[s2++]) && (~ro(c, n) || Xu(c, n));
          return c;
        };
      });
      var Yu = y((D2, Wu) => {
        Wu.exports = ["constructor", "hasOwnProperty", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "valueOf"];
      });
      var Ku = y((Qu) => {
        var uo = zu(), no = Yu(), so = no.concat("length", "prototype");
        Qu.f = Object.getOwnPropertyNames || function(r2) {
          return uo(r2, so);
        };
      });
      var Zu = y((Ju) => {
        Ju.f = Object.getOwnPropertySymbols;
      });
      var rn = y((p2, en) => {
        var ao = ge(), io = Q(), oo = Ku(), co = Zu(), Do = de(), lo = io([].concat);
        en.exports = ao("Reflect", "ownKeys") || function(r2) {
          var t2 = oo.f(Do(r2)), s2 = co.f;
          return s2 ? lo(t2, s2(r2)) : t2;
        };
      });
      var nn = y((f22, un) => {
        var tn = ae(), ho = rn(), po = Cr(), fo = Ue();
        un.exports = function(e2, r2, t2) {
          for (var s2 = ho(r2), c = fo.f, n = po.f, a = 0; a < s2.length; a++) {
            var p = s2[a];
            !tn(e2, p) && !(t2 && tn(t2, p)) && c(e2, p, n(r2, p));
          }
        };
      });
      var an = y((d2, sn) => {
        var Eo = se(), Co = K(), mo = /#|\.prototype\./, _e = function(e2, r2) {
          var t2 = Fo[go(e2)];
          return t2 == vo ? true : t2 == Ao ? false : Co(r2) ? Eo(r2) : !!r2;
        }, go = _e.normalize = function(e2) {
          return String(e2).replace(mo, ".").toLowerCase();
        }, Fo = _e.data = {}, Ao = _e.NATIVE = "N", vo = _e.POLYFILL = "P";
        sn.exports = _e;
      });
      var ze = y((E2, on) => {
        var Ir = G(), _o = Cr().f, So = Ge(), yo = xu(), To = Le(), Bo = nn(), bo = an();
        on.exports = function(e2, r2) {
          var t2 = e2.target, s2 = e2.global, c = e2.stat, n, a, p, D, g, i2;
          if (s2 ? a = Ir : c ? a = Ir[t2] || To(t2, {}) : a = (Ir[t2] || {}).prototype, a)
            for (p in r2) {
              if (g = r2[p], e2.noTargetGet ? (i2 = _o(a, p), D = i2 && i2.value) : D = a[p], n = bo(s2 ? p : t2 + (c ? "." : "#") + p, e2.forced), !n && D !== void 0) {
                if (typeof g == typeof D)
                  continue;
                Bo(g, D);
              }
              (e2.sham || D && D.sham) && So(g, "sham", true), yo(a, p, g, e2);
            }
        };
      });
      var cn = y(() => {
        var wo = ze(), No = G();
        wo({ global: true }, { globalThis: No });
      });
      var Dn = y(() => {
        cn();
      });
      var Rr = y((A2, ln) => {
        var Oo = Ie();
        ln.exports = Array.isArray || function(r2) {
          return Oo(r2) == "Array";
        };
      });
      var xr = y((v2, pn) => {
        var hn = Q(), qo = Fe(), Io = Ne(), Ro = hn(hn.bind);
        pn.exports = function(e2, r2) {
          return qo(e2), r2 === void 0 ? e2 : Io ? Ro(e2, r2) : function() {
            return e2.apply(r2, arguments);
          };
        };
      });
      var En = y((_2, dn) => {
        "use strict";
        var xo = G(), Po = Rr(), ko = ve(), Lo = xr(), Mo = xo.TypeError, fn = function(e2, r2, t2, s2, c, n, a, p) {
          for (var D = c, g = 0, i2 = a ? Lo(a, p) : false, l, h2; g < s2; ) {
            if (g in t2) {
              if (l = i2 ? i2(t2[g], g, r2) : t2[g], n > 0 && Po(l))
                h2 = ko(l), D = fn(e2, r2, l, h2, D, n - 1) - 1;
              else {
                if (D >= 9007199254740991)
                  throw Mo("Exceed the acceptable array length");
                e2[D] = l;
              }
              D++;
            }
            g++;
          }
          return D;
        };
        dn.exports = fn;
      });
      var gn = y((S2, mn) => {
        var jo = he(), $o = jo("toStringTag"), Cn = {};
        Cn[$o] = "z";
        mn.exports = String(Cn) === "[object z]";
      });
      var Pr = y((y2, Fn) => {
        var Uo = G(), Go = gn(), Vo = K(), We = Ie(), Xo = he(), Ho = Xo("toStringTag"), zo = Uo.Object, Wo = We(function() {
          return arguments;
        }()) == "Arguments", Yo = function(e2, r2) {
          try {
            return e2[r2];
          } catch {
          }
        };
        Fn.exports = Go ? We : function(e2) {
          var r2, t2, s2;
          return e2 === void 0 ? "Undefined" : e2 === null ? "Null" : typeof (t2 = Yo(r2 = zo(e2), Ho)) == "string" ? t2 : Wo ? We(r2) : (s2 = We(r2)) == "Object" && Vo(r2.callee) ? "Arguments" : s2;
        };
      });
      var Tn = y((T2, yn) => {
        var Qo = Q(), Ko = se(), An = K(), Jo = Pr(), Zo = ge(), ec = Ve(), vn = function() {
        }, rc = [], _n = Zo("Reflect", "construct"), kr = /^\s*(?:class|function)\b/, tc = Qo(kr.exec), uc = !kr.exec(vn), Se = function(r2) {
          if (!An(r2))
            return false;
          try {
            return _n(vn, rc, r2), true;
          } catch {
            return false;
          }
        }, Sn = function(r2) {
          if (!An(r2))
            return false;
          switch (Jo(r2)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return uc || !!tc(kr, ec(r2));
          } catch {
            return true;
          }
        };
        Sn.sham = true;
        yn.exports = !_n || Ko(function() {
          var e2;
          return Se(Se.call) || !Se(Object) || !Se(function() {
            e2 = true;
          }) || e2;
        }) ? Sn : Se;
      });
      var Nn = y((B2, wn) => {
        var nc = G(), Bn = Rr(), sc = Tn(), ac = De(), ic = he(), oc = ic("species"), bn = nc.Array;
        wn.exports = function(e2) {
          var r2;
          return Bn(e2) && (r2 = e2.constructor, sc(r2) && (r2 === bn || Bn(r2.prototype)) ? r2 = void 0 : ac(r2) && (r2 = r2[oc], r2 === null && (r2 = void 0))), r2 === void 0 ? bn : r2;
        };
      });
      var qn = y((b2, On) => {
        var cc = Nn();
        On.exports = function(e2, r2) {
          return new (cc(e2))(r2 === 0 ? 0 : r2);
        };
      });
      var In = y(() => {
        "use strict";
        var Dc = ze(), lc = En(), hc = Fe(), pc = pr(), fc = ve(), dc = qn();
        Dc({ target: "Array", proto: true }, { flatMap: function(r2) {
          var t2 = pc(this), s2 = fc(t2), c;
          return hc(r2), c = dc(t2, 0), c.length = lc(c, t2, t2, s2, 0, 1, r2, arguments.length > 1 ? arguments[1] : void 0), c;
        } });
      });
      var Lr = y((O2, Rn) => {
        Rn.exports = {};
      });
      var Pn = y((q2, xn) => {
        var Ec = he(), Cc = Lr(), mc = Ec("iterator"), gc = Array.prototype;
        xn.exports = function(e2) {
          return e2 !== void 0 && (Cc.Array === e2 || gc[mc] === e2);
        };
      });
      var Mr = y((I2, Ln) => {
        var Fc = Pr(), kn = ke(), Ac = Lr(), vc = he(), _c = vc("iterator");
        Ln.exports = function(e2) {
          if (e2 != null)
            return kn(e2, _c) || kn(e2, "@@iterator") || Ac[Fc(e2)];
        };
      });
      var jn = y((R2, Mn) => {
        var Sc = G(), yc = ce(), Tc = Fe(), Bc = de(), bc = Pe(), wc = Mr(), Nc = Sc.TypeError;
        Mn.exports = function(e2, r2) {
          var t2 = arguments.length < 2 ? wc(e2) : r2;
          if (Tc(t2))
            return Bc(yc(t2, e2));
          throw Nc(bc(e2) + " is not iterable");
        };
      });
      var Gn = y((x2, Un) => {
        var Oc = ce(), $n = de(), qc = ke();
        Un.exports = function(e2, r2, t2) {
          var s2, c;
          $n(e2);
          try {
            if (s2 = qc(e2, "return"), !s2) {
              if (r2 === "throw")
                throw t2;
              return t2;
            }
            s2 = Oc(s2, e2);
          } catch (n) {
            c = true, s2 = n;
          }
          if (r2 === "throw")
            throw t2;
          if (c)
            throw s2;
          return $n(s2), t2;
        };
      });
      var Wn = y((P2, zn) => {
        var Ic = G(), Rc = xr(), xc = ce(), Pc = de(), kc = Pe(), Lc = Pn(), Mc = ve(), Vn = nr(), jc = jn(), $c = Mr(), Xn = Gn(), Uc = Ic.TypeError, Ye = function(e2, r2) {
          this.stopped = e2, this.result = r2;
        }, Hn = Ye.prototype;
        zn.exports = function(e2, r2, t2) {
          var s2 = t2 && t2.that, c = !!(t2 && t2.AS_ENTRIES), n = !!(t2 && t2.IS_ITERATOR), a = !!(t2 && t2.INTERRUPTED), p = Rc(r2, s2), D, g, i2, l, h2, C, d, m2 = function(B) {
            return D && Xn(D, "normal", B), new Ye(true, B);
          }, T = function(B) {
            return c ? (Pc(B), a ? p(B[0], B[1], m2) : p(B[0], B[1])) : a ? p(B, m2) : p(B);
          };
          if (n)
            D = e2;
          else {
            if (g = $c(e2), !g)
              throw Uc(kc(e2) + " is not iterable");
            if (Lc(g)) {
              for (i2 = 0, l = Mc(e2); l > i2; i2++)
                if (h2 = T(e2[i2]), h2 && Vn(Hn, h2))
                  return h2;
              return new Ye(false);
            }
            D = jc(e2, g);
          }
          for (C = D.next; !(d = xc(C, D)).done; ) {
            try {
              h2 = T(d.value);
            } catch (B) {
              Xn(D, "throw", B);
            }
            if (typeof h2 == "object" && h2 && Vn(Hn, h2))
              return h2;
          }
          return new Ye(false);
        };
      });
      var Qn = y((k2, Yn) => {
        "use strict";
        var Gc = je(), Vc = Ue(), Xc = qe();
        Yn.exports = function(e2, r2, t2) {
          var s2 = Gc(r2);
          s2 in e2 ? Vc.f(e2, s2, Xc(0, t2)) : e2[s2] = t2;
        };
      });
      var Kn = y(() => {
        var Hc = ze(), zc = Wn(), Wc = Qn();
        Hc({ target: "Object", stat: true }, { fromEntries: function(r2) {
          var t2 = {};
          return zc(r2, function(s2, c) {
            Wc(t2, s2, c);
          }, { AS_ENTRIES: true }), t2;
        } });
      });
      var il = y((j2, Bs) => {
        var Yc = ["cliName", "cliCategory", "cliDescription"], Jn, Zn, es, rs, ts, us;
        function Qc(e2, r2) {
          if (e2 == null)
            return {};
          var t2 = Kc(e2, r2), s2, c;
          if (Object.getOwnPropertySymbols) {
            var n = Object.getOwnPropertySymbols(e2);
            for (c = 0; c < n.length; c++)
              s2 = n[c], !(r2.indexOf(s2) >= 0) && (!Object.prototype.propertyIsEnumerable.call(e2, s2) || (t2[s2] = e2[s2]));
          }
          return t2;
        }
        function Kc(e2, r2) {
          if (e2 == null)
            return {};
          var t2 = {}, s2 = Object.keys(e2), c, n;
          for (n = 0; n < s2.length; n++)
            c = s2[n], !(r2.indexOf(c) >= 0) && (t2[c] = e2[c]);
          return t2;
        }
        function Ee(e2, r2) {
          return r2 || (r2 = e2.slice(0)), Object.freeze(Object.defineProperties(e2, { raw: { value: Object.freeze(r2) } }));
        }
        Dn();
        In();
        Kn();
        var Jc = Object.create, Je = Object.defineProperty, Zc = Object.getOwnPropertyDescriptor, $r = Object.getOwnPropertyNames, eD = Object.getPrototypeOf, rD = Object.prototype.hasOwnProperty, Ce = (e2, r2) => function() {
          return e2 && (r2 = (0, e2[$r(e2)[0]])(e2 = 0)), r2;
        }, I = (e2, r2) => function() {
          return r2 || (0, e2[$r(e2)[0]])((r2 = { exports: {} }).exports, r2), r2.exports;
        }, cs = (e2, r2) => {
          for (var t2 in r2)
            Je(e2, t2, { get: r2[t2], enumerable: true });
        }, Ds = (e2, r2, t2, s2) => {
          if (r2 && typeof r2 == "object" || typeof r2 == "function")
            for (let c of $r(r2))
              !rD.call(e2, c) && c !== t2 && Je(e2, c, { get: () => r2[c], enumerable: !(s2 = Zc(r2, c)) || s2.enumerable });
          return e2;
        }, tD = (e2, r2, t2) => (t2 = e2 != null ? Jc(eD(e2)) : {}, Ds(r2 || !e2 || !e2.__esModule ? Je(t2, "default", { value: e2, enumerable: true }) : t2, e2)), ls = (e2) => Ds(Je({}, "__esModule", { value: true }), e2), ns, ss, ye, q = Ce({ "<define:process>"() {
          ns = {}, ss = [], ye = { env: ns, argv: ss };
        } }), hs = I({ "node_modules/angular-html-parser/lib/compiler/src/chars.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true }), e2.$EOF = 0, e2.$BSPACE = 8, e2.$TAB = 9, e2.$LF = 10, e2.$VTAB = 11, e2.$FF = 12, e2.$CR = 13, e2.$SPACE = 32, e2.$BANG = 33, e2.$DQ = 34, e2.$HASH = 35, e2.$$ = 36, e2.$PERCENT = 37, e2.$AMPERSAND = 38, e2.$SQ = 39, e2.$LPAREN = 40, e2.$RPAREN = 41, e2.$STAR = 42, e2.$PLUS = 43, e2.$COMMA = 44, e2.$MINUS = 45, e2.$PERIOD = 46, e2.$SLASH = 47, e2.$COLON = 58, e2.$SEMICOLON = 59, e2.$LT = 60, e2.$EQ = 61, e2.$GT = 62, e2.$QUESTION = 63, e2.$0 = 48, e2.$7 = 55, e2.$9 = 57, e2.$A = 65, e2.$E = 69, e2.$F = 70, e2.$X = 88, e2.$Z = 90, e2.$LBRACKET = 91, e2.$BACKSLASH = 92, e2.$RBRACKET = 93, e2.$CARET = 94, e2.$_ = 95, e2.$a = 97, e2.$b = 98, e2.$e = 101, e2.$f = 102, e2.$n = 110, e2.$r = 114, e2.$t = 116, e2.$u = 117, e2.$v = 118, e2.$x = 120, e2.$z = 122, e2.$LBRACE = 123, e2.$BAR = 124, e2.$RBRACE = 125, e2.$NBSP = 160, e2.$PIPE = 124, e2.$TILDA = 126, e2.$AT = 64, e2.$BT = 96;
          function r2(p) {
            return p >= e2.$TAB && p <= e2.$SPACE || p == e2.$NBSP;
          }
          e2.isWhitespace = r2;
          function t2(p) {
            return e2.$0 <= p && p <= e2.$9;
          }
          e2.isDigit = t2;
          function s2(p) {
            return p >= e2.$a && p <= e2.$z || p >= e2.$A && p <= e2.$Z;
          }
          e2.isAsciiLetter = s2;
          function c(p) {
            return p >= e2.$a && p <= e2.$f || p >= e2.$A && p <= e2.$F || t2(p);
          }
          e2.isAsciiHexDigit = c;
          function n(p) {
            return p === e2.$LF || p === e2.$CR;
          }
          e2.isNewLine = n;
          function a(p) {
            return e2.$0 <= p && p <= e2.$7;
          }
          e2.isOctalDigit = a;
        } }), uD = I({ "node_modules/angular-html-parser/lib/compiler/src/aot/static_symbol.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = class {
            constructor(s2, c, n) {
              this.filePath = s2, this.name = c, this.members = n;
            }
            assertNoMembers() {
              if (this.members.length)
                throw new Error("Illegal state: symbol without members expected, but got ".concat(JSON.stringify(this), "."));
            }
          };
          e2.StaticSymbol = r2;
          var t2 = class {
            constructor() {
              this.cache = /* @__PURE__ */ new Map();
            }
            get(s2, c, n) {
              n = n || [];
              let a = n.length ? ".".concat(n.join(".")) : "", p = '"'.concat(s2, '".').concat(c).concat(a), D = this.cache.get(p);
              return D || (D = new r2(s2, c, n), this.cache.set(p, D)), D;
            }
          };
          e2.StaticSymbolCache = t2;
        } }), nD = I({ "node_modules/angular-html-parser/lib/compiler/src/util.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = /-+([a-z0-9])/g;
          function t2(o) {
            return o.replace(r2, function() {
              for (var E = arguments.length, f3 = new Array(E), F2 = 0; F2 < E; F2++)
                f3[F2] = arguments[F2];
              return f3[1].toUpperCase();
            });
          }
          e2.dashCaseToCamelCase = t2;
          function s2(o, E) {
            return n(o, ":", E);
          }
          e2.splitAtColon = s2;
          function c(o, E) {
            return n(o, ".", E);
          }
          e2.splitAtPeriod = c;
          function n(o, E, f3) {
            let F2 = o.indexOf(E);
            return F2 == -1 ? f3 : [o.slice(0, F2).trim(), o.slice(F2 + 1).trim()];
          }
          function a(o, E, f3) {
            return Array.isArray(o) ? E.visitArray(o, f3) : A2(o) ? E.visitStringMap(o, f3) : o == null || typeof o == "string" || typeof o == "number" || typeof o == "boolean" ? E.visitPrimitive(o, f3) : E.visitOther(o, f3);
          }
          e2.visitValue = a;
          function p(o) {
            return o != null;
          }
          e2.isDefined = p;
          function D(o) {
            return o === void 0 ? null : o;
          }
          e2.noUndefined = D;
          var g = class {
            visitArray(o, E) {
              return o.map((f3) => a(f3, this, E));
            }
            visitStringMap(o, E) {
              let f3 = {};
              return Object.keys(o).forEach((F2) => {
                f3[F2] = a(o[F2], this, E);
              }), f3;
            }
            visitPrimitive(o, E) {
              return o;
            }
            visitOther(o, E) {
              return o;
            }
          };
          e2.ValueTransformer = g, e2.SyncAsync = { assertSync: (o) => {
            if (_(o))
              throw new Error("Illegal state: value cannot be a promise");
            return o;
          }, then: (o, E) => _(o) ? o.then(E) : E(o), all: (o) => o.some(_) ? Promise.all(o) : o };
          function i2(o) {
            throw new Error("Internal Error: ".concat(o));
          }
          e2.error = i2;
          function l(o, E) {
            let f3 = Error(o);
            return f3[h2] = true, E && (f3[C] = E), f3;
          }
          e2.syntaxError = l;
          var h2 = "ngSyntaxError", C = "ngParseErrors";
          function d(o) {
            return o[h2];
          }
          e2.isSyntaxError = d;
          function m2(o) {
            return o[C] || [];
          }
          e2.getParseErrors = m2;
          function T(o) {
            return o.replace(/([.*+?^=!:${}()|[\]\/\\])/g, "\\$1");
          }
          e2.escapeRegExp = T;
          var B = Object.getPrototypeOf({});
          function A2(o) {
            return typeof o == "object" && o !== null && Object.getPrototypeOf(o) === B;
          }
          function N(o) {
            let E = "";
            for (let f3 = 0; f3 < o.length; f3++) {
              let F2 = o.charCodeAt(f3);
              if (F2 >= 55296 && F2 <= 56319 && o.length > f3 + 1) {
                let P = o.charCodeAt(f3 + 1);
                P >= 56320 && P <= 57343 && (f3++, F2 = (F2 - 55296 << 10) + P - 56320 + 65536);
              }
              F2 <= 127 ? E += String.fromCharCode(F2) : F2 <= 2047 ? E += String.fromCharCode(F2 >> 6 & 31 | 192, F2 & 63 | 128) : F2 <= 65535 ? E += String.fromCharCode(F2 >> 12 | 224, F2 >> 6 & 63 | 128, F2 & 63 | 128) : F2 <= 2097151 && (E += String.fromCharCode(F2 >> 18 & 7 | 240, F2 >> 12 & 63 | 128, F2 >> 6 & 63 | 128, F2 & 63 | 128));
            }
            return E;
          }
          e2.utf8Encode = N;
          function R(o) {
            if (typeof o == "string")
              return o;
            if (o instanceof Array)
              return "[" + o.map(R).join(", ") + "]";
            if (o == null)
              return "" + o;
            if (o.overriddenName)
              return "".concat(o.overriddenName);
            if (o.name)
              return "".concat(o.name);
            if (!o.toString)
              return "object";
            let E = o.toString();
            if (E == null)
              return "" + E;
            let f3 = E.indexOf(`
`);
            return f3 === -1 ? E : E.substring(0, f3);
          }
          e2.stringify = R;
          function $(o) {
            return typeof o == "function" && o.hasOwnProperty("__forward_ref__") ? o() : o;
          }
          e2.resolveForwardRef = $;
          function _(o) {
            return !!o && typeof o.then == "function";
          }
          e2.isPromise = _;
          var O = class {
            constructor(o) {
              this.full = o;
              let E = o.split(".");
              this.major = E[0], this.minor = E[1], this.patch = E.slice(2).join(".");
            }
          };
          e2.Version = O;
          var x2 = typeof window < "u" && window, k = typeof self < "u" && typeof WorkerGlobalScope < "u" && self instanceof WorkerGlobalScope && self, M = typeof globalThis < "u" && globalThis, u = M || x2 || k;
          e2.global = u;
        } }), sD = I({ "node_modules/angular-html-parser/lib/compiler/src/compile_metadata.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = uD(), t2 = nD(), s2 = /^(?:(?:\[([^\]]+)\])|(?:\(([^\)]+)\)))|(\@[-\w]+)$/;
          function c(f3) {
            return f3.replace(/\W/g, "_");
          }
          e2.sanitizeIdentifier = c;
          var n = 0;
          function a(f3) {
            if (!f3 || !f3.reference)
              return null;
            let F2 = f3.reference;
            if (F2 instanceof r2.StaticSymbol)
              return F2.name;
            if (F2.__anonymousType)
              return F2.__anonymousType;
            let P = t2.stringify(F2);
            return P.indexOf("(") >= 0 ? (P = "anonymous_".concat(n++), F2.__anonymousType = P) : P = c(P), P;
          }
          e2.identifierName = a;
          function p(f3) {
            let F2 = f3.reference;
            return F2 instanceof r2.StaticSymbol ? F2.filePath : "./".concat(t2.stringify(F2));
          }
          e2.identifierModuleUrl = p;
          function D(f3, F2) {
            return "View_".concat(a({ reference: f3 }), "_").concat(F2);
          }
          e2.viewClassName = D;
          function g(f3) {
            return "RenderType_".concat(a({ reference: f3 }));
          }
          e2.rendererTypeName = g;
          function i2(f3) {
            return "HostView_".concat(a({ reference: f3 }));
          }
          e2.hostViewClassName = i2;
          function l(f3) {
            return "".concat(a({ reference: f3 }), "NgFactory");
          }
          e2.componentFactoryName = l;
          var h2;
          (function(f3) {
            f3[f3.Pipe = 0] = "Pipe", f3[f3.Directive = 1] = "Directive", f3[f3.NgModule = 2] = "NgModule", f3[f3.Injectable = 3] = "Injectable";
          })(h2 = e2.CompileSummaryKind || (e2.CompileSummaryKind = {}));
          function C(f3) {
            return f3.value != null ? c(f3.value) : a(f3.identifier);
          }
          e2.tokenName = C;
          function d(f3) {
            return f3.identifier != null ? f3.identifier.reference : f3.value;
          }
          e2.tokenReference = d;
          var m2 = class {
            constructor() {
              let { moduleUrl: f3, styles: F2, styleUrls: P } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              this.moduleUrl = f3 || null, this.styles = _(F2), this.styleUrls = _(P);
            }
          };
          e2.CompileStylesheetMetadata = m2;
          var T = class {
            constructor(f3) {
              let { encapsulation: F2, template: P, templateUrl: j, htmlAst: W, styles: X, styleUrls: H, externalStylesheets: z, animations: J, ngContentSelectors: Z2, interpolation: ee, isInline: v, preserveWhitespaces: S2 } = f3;
              if (this.encapsulation = F2, this.template = P, this.templateUrl = j, this.htmlAst = W, this.styles = _(X), this.styleUrls = _(H), this.externalStylesheets = _(z), this.animations = J ? x2(J) : [], this.ngContentSelectors = Z2 || [], ee && ee.length != 2)
                throw new Error("'interpolation' should have a start and an end symbol.");
              this.interpolation = ee, this.isInline = v, this.preserveWhitespaces = S2;
            }
            toSummary() {
              return { ngContentSelectors: this.ngContentSelectors, encapsulation: this.encapsulation, styles: this.styles, animations: this.animations };
            }
          };
          e2.CompileTemplateMetadata = T;
          var B = class {
            static create(f3) {
              let { isHost: F2, type: P, isComponent: j, selector: W, exportAs: X, changeDetection: H, inputs: z, outputs: J, host: Z2, providers: ee, viewProviders: v, queries: S2, guards: b, viewQueries: w, entryComponents: L, template: U, componentViewType: V, rendererType: Y, componentFactory: ue } = f3, Be = {}, be = {}, Vr = {};
              Z2 != null && Object.keys(Z2).forEach((re) => {
                let ne = Z2[re], me = re.match(s2);
                me === null ? Vr[re] = ne : me[1] != null ? be[me[1]] = ne : me[2] != null && (Be[me[2]] = ne);
              });
              let Xr = {};
              z != null && z.forEach((re) => {
                let ne = t2.splitAtColon(re, [re, re]);
                Xr[ne[0]] = ne[1];
              });
              let Hr = {};
              return J != null && J.forEach((re) => {
                let ne = t2.splitAtColon(re, [re, re]);
                Hr[ne[0]] = ne[1];
              }), new B({ isHost: F2, type: P, isComponent: !!j, selector: W, exportAs: X, changeDetection: H, inputs: Xr, outputs: Hr, hostListeners: Be, hostProperties: be, hostAttributes: Vr, providers: ee, viewProviders: v, queries: S2, guards: b, viewQueries: w, entryComponents: L, template: U, componentViewType: V, rendererType: Y, componentFactory: ue });
            }
            constructor(f3) {
              let { isHost: F2, type: P, isComponent: j, selector: W, exportAs: X, changeDetection: H, inputs: z, outputs: J, hostListeners: Z2, hostProperties: ee, hostAttributes: v, providers: S2, viewProviders: b, queries: w, guards: L, viewQueries: U, entryComponents: V, template: Y, componentViewType: ue, rendererType: Be, componentFactory: be } = f3;
              this.isHost = !!F2, this.type = P, this.isComponent = j, this.selector = W, this.exportAs = X, this.changeDetection = H, this.inputs = z, this.outputs = J, this.hostListeners = Z2, this.hostProperties = ee, this.hostAttributes = v, this.providers = _(S2), this.viewProviders = _(b), this.queries = _(w), this.guards = L, this.viewQueries = _(U), this.entryComponents = _(V), this.template = Y, this.componentViewType = ue, this.rendererType = Be, this.componentFactory = be;
            }
            toSummary() {
              return { summaryKind: h2.Directive, type: this.type, isComponent: this.isComponent, selector: this.selector, exportAs: this.exportAs, inputs: this.inputs, outputs: this.outputs, hostListeners: this.hostListeners, hostProperties: this.hostProperties, hostAttributes: this.hostAttributes, providers: this.providers, viewProviders: this.viewProviders, queries: this.queries, guards: this.guards, viewQueries: this.viewQueries, entryComponents: this.entryComponents, changeDetection: this.changeDetection, template: this.template && this.template.toSummary(), componentViewType: this.componentViewType, rendererType: this.rendererType, componentFactory: this.componentFactory };
            }
          };
          e2.CompileDirectiveMetadata = B;
          var A2 = class {
            constructor(f3) {
              let { type: F2, name: P, pure: j } = f3;
              this.type = F2, this.name = P, this.pure = !!j;
            }
            toSummary() {
              return { summaryKind: h2.Pipe, type: this.type, name: this.name, pure: this.pure };
            }
          };
          e2.CompilePipeMetadata = A2;
          var N = class {
          };
          e2.CompileShallowModuleMetadata = N;
          var R = class {
            constructor(f3) {
              let { type: F2, providers: P, declaredDirectives: j, exportedDirectives: W, declaredPipes: X, exportedPipes: H, entryComponents: z, bootstrapComponents: J, importedModules: Z2, exportedModules: ee, schemas: v, transitiveModule: S2, id: b } = f3;
              this.type = F2 || null, this.declaredDirectives = _(j), this.exportedDirectives = _(W), this.declaredPipes = _(X), this.exportedPipes = _(H), this.providers = _(P), this.entryComponents = _(z), this.bootstrapComponents = _(J), this.importedModules = _(Z2), this.exportedModules = _(ee), this.schemas = _(v), this.id = b || null, this.transitiveModule = S2 || null;
            }
            toSummary() {
              let f3 = this.transitiveModule;
              return { summaryKind: h2.NgModule, type: this.type, entryComponents: f3.entryComponents, providers: f3.providers, modules: f3.modules, exportedDirectives: f3.exportedDirectives, exportedPipes: f3.exportedPipes };
            }
          };
          e2.CompileNgModuleMetadata = R;
          var $ = class {
            constructor() {
              this.directivesSet = /* @__PURE__ */ new Set(), this.directives = [], this.exportedDirectivesSet = /* @__PURE__ */ new Set(), this.exportedDirectives = [], this.pipesSet = /* @__PURE__ */ new Set(), this.pipes = [], this.exportedPipesSet = /* @__PURE__ */ new Set(), this.exportedPipes = [], this.modulesSet = /* @__PURE__ */ new Set(), this.modules = [], this.entryComponentsSet = /* @__PURE__ */ new Set(), this.entryComponents = [], this.providers = [];
            }
            addProvider(f3, F2) {
              this.providers.push({ provider: f3, module: F2 });
            }
            addDirective(f3) {
              this.directivesSet.has(f3.reference) || (this.directivesSet.add(f3.reference), this.directives.push(f3));
            }
            addExportedDirective(f3) {
              this.exportedDirectivesSet.has(f3.reference) || (this.exportedDirectivesSet.add(f3.reference), this.exportedDirectives.push(f3));
            }
            addPipe(f3) {
              this.pipesSet.has(f3.reference) || (this.pipesSet.add(f3.reference), this.pipes.push(f3));
            }
            addExportedPipe(f3) {
              this.exportedPipesSet.has(f3.reference) || (this.exportedPipesSet.add(f3.reference), this.exportedPipes.push(f3));
            }
            addModule(f3) {
              this.modulesSet.has(f3.reference) || (this.modulesSet.add(f3.reference), this.modules.push(f3));
            }
            addEntryComponent(f3) {
              this.entryComponentsSet.has(f3.componentType) || (this.entryComponentsSet.add(f3.componentType), this.entryComponents.push(f3));
            }
          };
          e2.TransitiveCompileNgModuleMetadata = $;
          function _(f3) {
            return f3 || [];
          }
          var O = class {
            constructor(f3, F2) {
              let { useClass: P, useValue: j, useExisting: W, useFactory: X, deps: H, multi: z } = F2;
              this.token = f3, this.useClass = P || null, this.useValue = j, this.useExisting = W, this.useFactory = X || null, this.dependencies = H || null, this.multi = !!z;
            }
          };
          e2.ProviderMeta = O;
          function x2(f3) {
            return f3.reduce((F2, P) => {
              let j = Array.isArray(P) ? x2(P) : P;
              return F2.concat(j);
            }, []);
          }
          e2.flatten = x2;
          function k(f3) {
            return f3.replace(/(\w+:\/\/[\w:-]+)?(\/+)?/, "ng:///");
          }
          function M(f3, F2, P) {
            let j;
            return P.isInline ? F2.type.reference instanceof r2.StaticSymbol ? j = "".concat(F2.type.reference.filePath, ".").concat(F2.type.reference.name, ".html") : j = "".concat(a(f3), "/").concat(a(F2.type), ".html") : j = P.templateUrl, F2.type.reference instanceof r2.StaticSymbol ? j : k(j);
          }
          e2.templateSourceUrl = M;
          function u(f3, F2) {
            let P = f3.moduleUrl.split(/\/\\/g), j = P[P.length - 1];
            return k("css/".concat(F2).concat(j, ".ngstyle.js"));
          }
          e2.sharedStylesheetJitUrl = u;
          function o(f3) {
            return k("".concat(a(f3.type), "/module.ngfactory.js"));
          }
          e2.ngModuleJitUrl = o;
          function E(f3, F2) {
            return k("".concat(a(f3), "/").concat(a(F2.type), ".ngfactory.js"));
          }
          e2.templateJitUrl = E;
        } }), Te = I({ "node_modules/angular-html-parser/lib/compiler/src/parse_util.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = hs(), t2 = sD(), s2 = class {
            constructor(i2, l, h2, C) {
              this.file = i2, this.offset = l, this.line = h2, this.col = C;
            }
            toString() {
              return this.offset != null ? "".concat(this.file.url, "@").concat(this.line, ":").concat(this.col) : this.file.url;
            }
            moveBy(i2) {
              let l = this.file.content, h2 = l.length, C = this.offset, d = this.line, m2 = this.col;
              for (; C > 0 && i2 < 0; )
                if (C--, i2++, l.charCodeAt(C) == r2.$LF) {
                  d--;
                  let B = l.substr(0, C - 1).lastIndexOf(String.fromCharCode(r2.$LF));
                  m2 = B > 0 ? C - B : C;
                } else
                  m2--;
              for (; C < h2 && i2 > 0; ) {
                let T = l.charCodeAt(C);
                C++, i2--, T == r2.$LF ? (d++, m2 = 0) : m2++;
              }
              return new s2(this.file, C, d, m2);
            }
            getContext(i2, l) {
              let h2 = this.file.content, C = this.offset;
              if (C != null) {
                C > h2.length - 1 && (C = h2.length - 1);
                let d = C, m2 = 0, T = 0;
                for (; m2 < i2 && C > 0 && (C--, m2++, !(h2[C] == `
` && ++T == l)); )
                  ;
                for (m2 = 0, T = 0; m2 < i2 && d < h2.length - 1 && (d++, m2++, !(h2[d] == `
` && ++T == l)); )
                  ;
                return { before: h2.substring(C, this.offset), after: h2.substring(this.offset, d + 1) };
              }
              return null;
            }
          };
          e2.ParseLocation = s2;
          var c = class {
            constructor(i2, l) {
              this.content = i2, this.url = l;
            }
          };
          e2.ParseSourceFile = c;
          var n = class {
            constructor(i2, l) {
              let h2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null;
              this.start = i2, this.end = l, this.details = h2;
            }
            toString() {
              return this.start.file.content.substring(this.start.offset, this.end.offset);
            }
          };
          e2.ParseSourceSpan = n, e2.EMPTY_PARSE_LOCATION = new s2(new c("", ""), 0, 0, 0), e2.EMPTY_SOURCE_SPAN = new n(e2.EMPTY_PARSE_LOCATION, e2.EMPTY_PARSE_LOCATION);
          var a;
          (function(i2) {
            i2[i2.WARNING = 0] = "WARNING", i2[i2.ERROR = 1] = "ERROR";
          })(a = e2.ParseErrorLevel || (e2.ParseErrorLevel = {}));
          var p = class {
            constructor(i2, l) {
              let h2 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : a.ERROR;
              this.span = i2, this.msg = l, this.level = h2;
            }
            contextualMessage() {
              let i2 = this.span.start.getContext(100, 3);
              return i2 ? "".concat(this.msg, ' ("').concat(i2.before, "[").concat(a[this.level], " ->]").concat(i2.after, '")') : this.msg;
            }
            toString() {
              let i2 = this.span.details ? ", ".concat(this.span.details) : "";
              return "".concat(this.contextualMessage(), ": ").concat(this.span.start).concat(i2);
            }
          };
          e2.ParseError = p;
          function D(i2, l) {
            let h2 = t2.identifierModuleUrl(l), C = h2 != null ? "in ".concat(i2, " ").concat(t2.identifierName(l), " in ").concat(h2) : "in ".concat(i2, " ").concat(t2.identifierName(l)), d = new c("", C);
            return new n(new s2(d, -1, -1, -1), new s2(d, -1, -1, -1));
          }
          e2.typeSourceSpan = D;
          function g(i2, l, h2) {
            let C = "in ".concat(i2, " ").concat(l, " in ").concat(h2), d = new c("", C);
            return new n(new s2(d, -1, -1, -1), new s2(d, -1, -1, -1));
          }
          e2.r3JitTypeSourceSpan = g;
        } }), aD = I({ "src/utils/front-matter/parse.js"(e2, r2) {
          "use strict";
          q();
          var t2 = new RegExp("^(?<startDelimiter>-{3}|\\+{3})(?<language>[^\\n]*)\\n(?:|(?<value>.*?)\\n)(?<endDelimiter>\\k<startDelimiter>|\\.{3})[^\\S\\n]*(?:\\n|$)", "s");
          function s2(c) {
            let n = c.match(t2);
            if (!n)
              return { content: c };
            let { startDelimiter: a, language: p, value: D = "", endDelimiter: g } = n.groups, i2 = p.trim() || "yaml";
            if (a === "+++" && (i2 = "toml"), i2 !== "yaml" && a !== g)
              return { content: c };
            let [l] = n;
            return { frontMatter: { type: "front-matter", lang: i2, value: D, startDelimiter: a, endDelimiter: g, raw: l.replace(/\n$/, "") }, content: l.replace(/[^\n]/g, " ") + c.slice(l.length) };
          }
          r2.exports = s2;
        } }), ps = I({ "src/utils/get-last.js"(e2, r2) {
          "use strict";
          q();
          var t2 = (s2) => s2[s2.length - 1];
          r2.exports = t2;
        } }), iD = I({ "src/common/parser-create-error.js"(e2, r2) {
          "use strict";
          q();
          function t2(s2, c) {
            let n = new SyntaxError(s2 + " (" + c.start.line + ":" + c.start.column + ")");
            return n.loc = c, n;
          }
          r2.exports = t2;
        } }), fs4 = {};
        cs(fs4, { default: () => oD });
        function oD(e2) {
          if (typeof e2 != "string")
            throw new TypeError("Expected a string");
          return e2.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
        }
        var cD = Ce({ "node_modules/escape-string-regexp/index.js"() {
          q();
        } }), ds = I({ "node_modules/semver/internal/debug.js"(e2, r2) {
          q();
          var t2 = typeof ye == "object" && ye.env && ye.env.NODE_DEBUG && /\bsemver\b/i.test(ye.env.NODE_DEBUG) ? function() {
            for (var s2 = arguments.length, c = new Array(s2), n = 0; n < s2; n++)
              c[n] = arguments[n];
            return console.error("SEMVER", ...c);
          } : () => {
          };
          r2.exports = t2;
        } }), Es = I({ "node_modules/semver/internal/constants.js"(e2, r2) {
          q();
          var t2 = "2.0.0", s2 = 256, c = Number.MAX_SAFE_INTEGER || 9007199254740991, n = 16;
          r2.exports = { SEMVER_SPEC_VERSION: t2, MAX_LENGTH: s2, MAX_SAFE_INTEGER: c, MAX_SAFE_COMPONENT_LENGTH: n };
        } }), DD = I({ "node_modules/semver/internal/re.js"(e2, r2) {
          q();
          var { MAX_SAFE_COMPONENT_LENGTH: t2 } = Es(), s2 = ds();
          e2 = r2.exports = {};
          var c = e2.re = [], n = e2.src = [], a = e2.t = {}, p = 0, D = (g, i2, l) => {
            let h2 = p++;
            s2(g, h2, i2), a[g] = h2, n[h2] = i2, c[h2] = new RegExp(i2, l ? "g" : void 0);
          };
          D("NUMERICIDENTIFIER", "0|[1-9]\\d*"), D("NUMERICIDENTIFIERLOOSE", "[0-9]+"), D("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*"), D("MAINVERSION", "(".concat(n[a.NUMERICIDENTIFIER], ")\\.(").concat(n[a.NUMERICIDENTIFIER], ")\\.(").concat(n[a.NUMERICIDENTIFIER], ")")), D("MAINVERSIONLOOSE", "(".concat(n[a.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(n[a.NUMERICIDENTIFIERLOOSE], ")\\.(").concat(n[a.NUMERICIDENTIFIERLOOSE], ")")), D("PRERELEASEIDENTIFIER", "(?:".concat(n[a.NUMERICIDENTIFIER], "|").concat(n[a.NONNUMERICIDENTIFIER], ")")), D("PRERELEASEIDENTIFIERLOOSE", "(?:".concat(n[a.NUMERICIDENTIFIERLOOSE], "|").concat(n[a.NONNUMERICIDENTIFIER], ")")), D("PRERELEASE", "(?:-(".concat(n[a.PRERELEASEIDENTIFIER], "(?:\\.").concat(n[a.PRERELEASEIDENTIFIER], ")*))")), D("PRERELEASELOOSE", "(?:-?(".concat(n[a.PRERELEASEIDENTIFIERLOOSE], "(?:\\.").concat(n[a.PRERELEASEIDENTIFIERLOOSE], ")*))")), D("BUILDIDENTIFIER", "[0-9A-Za-z-]+"), D("BUILD", "(?:\\+(".concat(n[a.BUILDIDENTIFIER], "(?:\\.").concat(n[a.BUILDIDENTIFIER], ")*))")), D("FULLPLAIN", "v?".concat(n[a.MAINVERSION]).concat(n[a.PRERELEASE], "?").concat(n[a.BUILD], "?")), D("FULL", "^".concat(n[a.FULLPLAIN], "$")), D("LOOSEPLAIN", "[v=\\s]*".concat(n[a.MAINVERSIONLOOSE]).concat(n[a.PRERELEASELOOSE], "?").concat(n[a.BUILD], "?")), D("LOOSE", "^".concat(n[a.LOOSEPLAIN], "$")), D("GTLT", "((?:<|>)?=?)"), D("XRANGEIDENTIFIERLOOSE", "".concat(n[a.NUMERICIDENTIFIERLOOSE], "|x|X|\\*")), D("XRANGEIDENTIFIER", "".concat(n[a.NUMERICIDENTIFIER], "|x|X|\\*")), D("XRANGEPLAIN", "[v=\\s]*(".concat(n[a.XRANGEIDENTIFIER], ")(?:\\.(").concat(n[a.XRANGEIDENTIFIER], ")(?:\\.(").concat(n[a.XRANGEIDENTIFIER], ")(?:").concat(n[a.PRERELEASE], ")?").concat(n[a.BUILD], "?)?)?")), D("XRANGEPLAINLOOSE", "[v=\\s]*(".concat(n[a.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(n[a.XRANGEIDENTIFIERLOOSE], ")(?:\\.(").concat(n[a.XRANGEIDENTIFIERLOOSE], ")(?:").concat(n[a.PRERELEASELOOSE], ")?").concat(n[a.BUILD], "?)?)?")), D("XRANGE", "^".concat(n[a.GTLT], "\\s*").concat(n[a.XRANGEPLAIN], "$")), D("XRANGELOOSE", "^".concat(n[a.GTLT], "\\s*").concat(n[a.XRANGEPLAINLOOSE], "$")), D("COERCE", "(^|[^\\d])(\\d{1,".concat(t2, "})(?:\\.(\\d{1,").concat(t2, "}))?(?:\\.(\\d{1,").concat(t2, "}))?(?:$|[^\\d])")), D("COERCERTL", n[a.COERCE], true), D("LONETILDE", "(?:~>?)"), D("TILDETRIM", "(\\s*)".concat(n[a.LONETILDE], "\\s+"), true), e2.tildeTrimReplace = "$1~", D("TILDE", "^".concat(n[a.LONETILDE]).concat(n[a.XRANGEPLAIN], "$")), D("TILDELOOSE", "^".concat(n[a.LONETILDE]).concat(n[a.XRANGEPLAINLOOSE], "$")), D("LONECARET", "(?:\\^)"), D("CARETTRIM", "(\\s*)".concat(n[a.LONECARET], "\\s+"), true), e2.caretTrimReplace = "$1^", D("CARET", "^".concat(n[a.LONECARET]).concat(n[a.XRANGEPLAIN], "$")), D("CARETLOOSE", "^".concat(n[a.LONECARET]).concat(n[a.XRANGEPLAINLOOSE], "$")), D("COMPARATORLOOSE", "^".concat(n[a.GTLT], "\\s*(").concat(n[a.LOOSEPLAIN], ")$|^$")), D("COMPARATOR", "^".concat(n[a.GTLT], "\\s*(").concat(n[a.FULLPLAIN], ")$|^$")), D("COMPARATORTRIM", "(\\s*)".concat(n[a.GTLT], "\\s*(").concat(n[a.LOOSEPLAIN], "|").concat(n[a.XRANGEPLAIN], ")"), true), e2.comparatorTrimReplace = "$1$2$3", D("HYPHENRANGE", "^\\s*(".concat(n[a.XRANGEPLAIN], ")\\s+-\\s+(").concat(n[a.XRANGEPLAIN], ")\\s*$")), D("HYPHENRANGELOOSE", "^\\s*(".concat(n[a.XRANGEPLAINLOOSE], ")\\s+-\\s+(").concat(n[a.XRANGEPLAINLOOSE], ")\\s*$")), D("STAR", "(<|>)?=?\\s*\\*"), D("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$"), D("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
        } }), lD = I({ "node_modules/semver/internal/parse-options.js"(e2, r2) {
          q();
          var t2 = ["includePrerelease", "loose", "rtl"], s2 = (c) => c ? typeof c != "object" ? { loose: true } : t2.filter((n) => c[n]).reduce((n, a) => (n[a] = true, n), {}) : {};
          r2.exports = s2;
        } }), hD = I({ "node_modules/semver/internal/identifiers.js"(e2, r2) {
          q();
          var t2 = /^[0-9]+$/, s2 = (n, a) => {
            let p = t2.test(n), D = t2.test(a);
            return p && D && (n = +n, a = +a), n === a ? 0 : p && !D ? -1 : D && !p ? 1 : n < a ? -1 : 1;
          }, c = (n, a) => s2(a, n);
          r2.exports = { compareIdentifiers: s2, rcompareIdentifiers: c };
        } }), pD = I({ "node_modules/semver/classes/semver.js"(e2, r2) {
          q();
          var t2 = ds(), { MAX_LENGTH: s2, MAX_SAFE_INTEGER: c } = Es(), { re: n, t: a } = DD(), p = lD(), { compareIdentifiers: D } = hD(), g = class {
            constructor(i2, l) {
              if (l = p(l), i2 instanceof g) {
                if (i2.loose === !!l.loose && i2.includePrerelease === !!l.includePrerelease)
                  return i2;
                i2 = i2.version;
              } else if (typeof i2 != "string")
                throw new TypeError("Invalid Version: ".concat(i2));
              if (i2.length > s2)
                throw new TypeError("version is longer than ".concat(s2, " characters"));
              t2("SemVer", i2, l), this.options = l, this.loose = !!l.loose, this.includePrerelease = !!l.includePrerelease;
              let h2 = i2.trim().match(l.loose ? n[a.LOOSE] : n[a.FULL]);
              if (!h2)
                throw new TypeError("Invalid Version: ".concat(i2));
              if (this.raw = i2, this.major = +h2[1], this.minor = +h2[2], this.patch = +h2[3], this.major > c || this.major < 0)
                throw new TypeError("Invalid major version");
              if (this.minor > c || this.minor < 0)
                throw new TypeError("Invalid minor version");
              if (this.patch > c || this.patch < 0)
                throw new TypeError("Invalid patch version");
              h2[4] ? this.prerelease = h2[4].split(".").map((C) => {
                if (/^[0-9]+$/.test(C)) {
                  let d = +C;
                  if (d >= 0 && d < c)
                    return d;
                }
                return C;
              }) : this.prerelease = [], this.build = h2[5] ? h2[5].split(".") : [], this.format();
            }
            format() {
              return this.version = "".concat(this.major, ".").concat(this.minor, ".").concat(this.patch), this.prerelease.length && (this.version += "-".concat(this.prerelease.join("."))), this.version;
            }
            toString() {
              return this.version;
            }
            compare(i2) {
              if (t2("SemVer.compare", this.version, this.options, i2), !(i2 instanceof g)) {
                if (typeof i2 == "string" && i2 === this.version)
                  return 0;
                i2 = new g(i2, this.options);
              }
              return i2.version === this.version ? 0 : this.compareMain(i2) || this.comparePre(i2);
            }
            compareMain(i2) {
              return i2 instanceof g || (i2 = new g(i2, this.options)), D(this.major, i2.major) || D(this.minor, i2.minor) || D(this.patch, i2.patch);
            }
            comparePre(i2) {
              if (i2 instanceof g || (i2 = new g(i2, this.options)), this.prerelease.length && !i2.prerelease.length)
                return -1;
              if (!this.prerelease.length && i2.prerelease.length)
                return 1;
              if (!this.prerelease.length && !i2.prerelease.length)
                return 0;
              let l = 0;
              do {
                let h2 = this.prerelease[l], C = i2.prerelease[l];
                if (t2("prerelease compare", l, h2, C), h2 === void 0 && C === void 0)
                  return 0;
                if (C === void 0)
                  return 1;
                if (h2 === void 0)
                  return -1;
                if (h2 === C)
                  continue;
                return D(h2, C);
              } while (++l);
            }
            compareBuild(i2) {
              i2 instanceof g || (i2 = new g(i2, this.options));
              let l = 0;
              do {
                let h2 = this.build[l], C = i2.build[l];
                if (t2("prerelease compare", l, h2, C), h2 === void 0 && C === void 0)
                  return 0;
                if (C === void 0)
                  return 1;
                if (h2 === void 0)
                  return -1;
                if (h2 === C)
                  continue;
                return D(h2, C);
              } while (++l);
            }
            inc(i2, l) {
              switch (i2) {
                case "premajor":
                  this.prerelease.length = 0, this.patch = 0, this.minor = 0, this.major++, this.inc("pre", l);
                  break;
                case "preminor":
                  this.prerelease.length = 0, this.patch = 0, this.minor++, this.inc("pre", l);
                  break;
                case "prepatch":
                  this.prerelease.length = 0, this.inc("patch", l), this.inc("pre", l);
                  break;
                case "prerelease":
                  this.prerelease.length === 0 && this.inc("patch", l), this.inc("pre", l);
                  break;
                case "major":
                  (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) && this.major++, this.minor = 0, this.patch = 0, this.prerelease = [];
                  break;
                case "minor":
                  (this.patch !== 0 || this.prerelease.length === 0) && this.minor++, this.patch = 0, this.prerelease = [];
                  break;
                case "patch":
                  this.prerelease.length === 0 && this.patch++, this.prerelease = [];
                  break;
                case "pre":
                  if (this.prerelease.length === 0)
                    this.prerelease = [0];
                  else {
                    let h2 = this.prerelease.length;
                    for (; --h2 >= 0; )
                      typeof this.prerelease[h2] == "number" && (this.prerelease[h2]++, h2 = -2);
                    h2 === -1 && this.prerelease.push(0);
                  }
                  l && (D(this.prerelease[0], l) === 0 ? isNaN(this.prerelease[1]) && (this.prerelease = [l, 0]) : this.prerelease = [l, 0]);
                  break;
                default:
                  throw new Error("invalid increment argument: ".concat(i2));
              }
              return this.format(), this.raw = this.version, this;
            }
          };
          r2.exports = g;
        } }), Ur = I({ "node_modules/semver/functions/compare.js"(e2, r2) {
          q();
          var t2 = pD(), s2 = (c, n, a) => new t2(c, a).compare(new t2(n, a));
          r2.exports = s2;
        } }), fD = I({ "node_modules/semver/functions/lt.js"(e2, r2) {
          q();
          var t2 = Ur(), s2 = (c, n, a) => t2(c, n, a) < 0;
          r2.exports = s2;
        } }), dD = I({ "node_modules/semver/functions/gte.js"(e2, r2) {
          q();
          var t2 = Ur(), s2 = (c, n, a) => t2(c, n, a) >= 0;
          r2.exports = s2;
        } }), ED = I({ "src/utils/arrayify.js"(e2, r2) {
          "use strict";
          q(), r2.exports = (t2, s2) => Object.entries(t2).map((c) => {
            let [n, a] = c;
            return Object.assign({ [s2]: n }, a);
          });
        } }), CD = I({ "package.json"(e2, r2) {
          r2.exports = { version: "2.7.1" };
        } }), mD = I({ "node_modules/outdent/lib/index.js"(e2, r2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true }), e2.outdent = void 0;
          function t2() {
            for (var A2 = [], N = 0; N < arguments.length; N++)
              A2[N] = arguments[N];
          }
          function s2() {
            return typeof WeakMap < "u" ? /* @__PURE__ */ new WeakMap() : c();
          }
          function c() {
            return { add: t2, delete: t2, get: t2, set: t2, has: function(A2) {
              return false;
            } };
          }
          var n = Object.prototype.hasOwnProperty, a = function(A2, N) {
            return n.call(A2, N);
          };
          function p(A2, N) {
            for (var R in N)
              a(N, R) && (A2[R] = N[R]);
            return A2;
          }
          var D = /^[ \t]*(?:\r\n|\r|\n)/, g = /(?:\r\n|\r|\n)[ \t]*$/, i2 = /^(?:[\r\n]|$)/, l = /(?:\r\n|\r|\n)([ \t]*)(?:[^ \t\r\n]|$)/, h2 = /^[ \t]*[\r\n][ \t\r\n]*$/;
          function C(A2, N, R) {
            var $ = 0, _ = A2[0].match(l);
            _ && ($ = _[1].length);
            var O = "(\\r\\n|\\r|\\n).{0," + $ + "}", x2 = new RegExp(O, "g");
            N && (A2 = A2.slice(1));
            var k = R.newline, M = R.trimLeadingNewline, u = R.trimTrailingNewline, o = typeof k == "string", E = A2.length, f3 = A2.map(function(F2, P) {
              return F2 = F2.replace(x2, "$1"), P === 0 && M && (F2 = F2.replace(D, "")), P === E - 1 && u && (F2 = F2.replace(g, "")), o && (F2 = F2.replace(/\r\n|\n|\r/g, function(j) {
                return k;
              })), F2;
            });
            return f3;
          }
          function d(A2, N) {
            for (var R = "", $ = 0, _ = A2.length; $ < _; $++)
              R += A2[$], $ < _ - 1 && (R += N[$]);
            return R;
          }
          function m2(A2) {
            return a(A2, "raw") && a(A2, "length");
          }
          function T(A2) {
            var N = s2(), R = s2();
            function $(O) {
              for (var x2 = [], k = 1; k < arguments.length; k++)
                x2[k - 1] = arguments[k];
              if (m2(O)) {
                var M = O, u = (x2[0] === $ || x2[0] === B) && h2.test(M[0]) && i2.test(M[1]), o = u ? R : N, E = o.get(M);
                if (E || (E = C(M, u, A2), o.set(M, E)), x2.length === 0)
                  return E[0];
                var f3 = d(E, u ? x2.slice(1) : x2);
                return f3;
              } else
                return T(p(p({}, A2), O || {}));
            }
            var _ = p($, { string: function(O) {
              return C([O], false, A2)[0];
            } });
            return _;
          }
          var B = T({ trimLeadingNewline: true, trimTrailingNewline: true });
          if (e2.outdent = B, e2.default = B, typeof r2 < "u")
            try {
              r2.exports = B, Object.defineProperty(B, "__esModule", { value: true }), B.default = B, B.outdent = B;
            } catch {
            }
        } }), gD = I({ "src/main/core-options.js"(e2, r2) {
          "use strict";
          q();
          var { outdent: t2 } = mD(), s2 = "Config", c = "Editor", n = "Format", a = "Other", p = "Output", D = "Global", g = "Special", i2 = { cursorOffset: { since: "1.4.0", category: g, type: "int", default: -1, range: { start: -1, end: Number.POSITIVE_INFINITY, step: 1 }, description: t2(Jn || (Jn = Ee([`
      Print (to stderr) where a cursor at the given position would move to after formatting.
      This option cannot be used with --range-start and --range-end.
    `]))), cliCategory: c }, endOfLine: { since: "1.15.0", category: D, type: "choice", default: [{ since: "1.15.0", value: "auto" }, { since: "2.0.0", value: "lf" }], description: "Which end of line characters to apply.", choices: [{ value: "lf", description: "Line Feed only (\\n), common on Linux and macOS as well as inside git repos" }, { value: "crlf", description: "Carriage Return + Line Feed characters (\\r\\n), common on Windows" }, { value: "cr", description: "Carriage Return character only (\\r), used very rarely" }, { value: "auto", description: t2(Zn || (Zn = Ee([`
          Maintain existing
          (mixed values within one file are normalised by looking at what's used after the first line)
        `]))) }] }, filepath: { since: "1.4.0", category: g, type: "path", description: "Specify the input filepath. This will be used to do parser inference.", cliName: "stdin-filepath", cliCategory: a, cliDescription: "Path to the file to pretend that stdin comes from." }, insertPragma: { since: "1.8.0", category: g, type: "boolean", default: false, description: "Insert @format pragma into file's first docblock comment.", cliCategory: a }, parser: { since: "0.0.10", category: D, type: "choice", default: [{ since: "0.0.10", value: "babylon" }, { since: "1.13.0", value: void 0 }], description: "Which parser to use.", exception: (l) => typeof l == "string" || typeof l == "function", choices: [{ value: "flow", description: "Flow" }, { value: "babel", since: "1.16.0", description: "JavaScript" }, { value: "babel-flow", since: "1.16.0", description: "Flow" }, { value: "babel-ts", since: "2.0.0", description: "TypeScript" }, { value: "typescript", since: "1.4.0", description: "TypeScript" }, { value: "acorn", since: "2.6.0", description: "JavaScript" }, { value: "espree", since: "2.2.0", description: "JavaScript" }, { value: "meriyah", since: "2.2.0", description: "JavaScript" }, { value: "css", since: "1.7.1", description: "CSS" }, { value: "less", since: "1.7.1", description: "Less" }, { value: "scss", since: "1.7.1", description: "SCSS" }, { value: "json", since: "1.5.0", description: "JSON" }, { value: "json5", since: "1.13.0", description: "JSON5" }, { value: "json-stringify", since: "1.13.0", description: "JSON.stringify" }, { value: "graphql", since: "1.5.0", description: "GraphQL" }, { value: "markdown", since: "1.8.0", description: "Markdown" }, { value: "mdx", since: "1.15.0", description: "MDX" }, { value: "vue", since: "1.10.0", description: "Vue" }, { value: "yaml", since: "1.14.0", description: "YAML" }, { value: "glimmer", since: "2.3.0", description: "Ember / Handlebars" }, { value: "html", since: "1.15.0", description: "HTML" }, { value: "angular", since: "1.15.0", description: "Angular" }, { value: "lwc", since: "1.17.0", description: "Lightning Web Components" }] }, plugins: { since: "1.10.0", type: "path", array: true, default: [{ value: [] }], category: D, description: "Add a plugin. Multiple plugins can be passed as separate `--plugin`s.", exception: (l) => typeof l == "string" || typeof l == "object", cliName: "plugin", cliCategory: s2 }, pluginSearchDirs: { since: "1.13.0", type: "path", array: true, default: [{ value: [] }], category: D, description: t2(es || (es = Ee([`
      Custom directory that contains prettier plugins in node_modules subdirectory.
      Overrides default behavior when plugins are searched relatively to the location of Prettier.
      Multiple values are accepted.
    `]))), exception: (l) => typeof l == "string" || typeof l == "object", cliName: "plugin-search-dir", cliCategory: s2 }, printWidth: { since: "0.0.0", category: D, type: "int", default: 80, description: "The line length where Prettier will try wrap.", range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 } }, rangeEnd: { since: "1.4.0", category: g, type: "int", default: Number.POSITIVE_INFINITY, range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 }, description: t2(rs || (rs = Ee([`
      Format code ending at a given character offset (exclusive).
      The range will extend forwards to the end of the selected statement.
      This option cannot be used with --cursor-offset.
    `]))), cliCategory: c }, rangeStart: { since: "1.4.0", category: g, type: "int", default: 0, range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 }, description: t2(ts || (ts = Ee([`
      Format code starting at a given character offset.
      The range will extend backwards to the start of the first line containing the selected statement.
      This option cannot be used with --cursor-offset.
    `]))), cliCategory: c }, requirePragma: { since: "1.7.0", category: g, type: "boolean", default: false, description: t2(us || (us = Ee([`
      Require either '@prettier' or '@format' to be present in the file's first docblock comment
      in order for it to be formatted.
    `]))), cliCategory: a }, tabWidth: { type: "int", category: D, default: 2, description: "Number of spaces per indentation level.", range: { start: 0, end: Number.POSITIVE_INFINITY, step: 1 } }, useTabs: { since: "1.0.0", category: D, type: "boolean", default: false, description: "Indent with tabs instead of spaces." }, embeddedLanguageFormatting: { since: "2.1.0", category: D, type: "choice", default: [{ since: "2.1.0", value: "auto" }], description: "Control how Prettier formats quoted code embedded in the file.", choices: [{ value: "auto", description: "Format embedded code if Prettier can automatically identify it." }, { value: "off", description: "Never automatically format embedded code." }] } };
          r2.exports = { CATEGORY_CONFIG: s2, CATEGORY_EDITOR: c, CATEGORY_FORMAT: n, CATEGORY_OTHER: a, CATEGORY_OUTPUT: p, CATEGORY_GLOBAL: D, CATEGORY_SPECIAL: g, options: i2 };
        } }), FD = I({ "src/main/support.js"(e2, r2) {
          "use strict";
          q();
          var t2 = { compare: Ur(), lt: fD(), gte: dD() }, s2 = ED(), c = CD().version, n = gD().options;
          function a() {
            let { plugins: D = [], showUnreleased: g = false, showDeprecated: i2 = false, showInternal: l = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, h2 = c.split("-", 1)[0], C = D.flatMap((A2) => A2.languages || []).filter(m2), d = s2(Object.assign({}, ...D.map((A2) => {
              let { options: N } = A2;
              return N;
            }), n), "name").filter((A2) => m2(A2) && T(A2)).sort((A2, N) => A2.name === N.name ? 0 : A2.name < N.name ? -1 : 1).map(B).map((A2) => {
              A2 = Object.assign({}, A2), Array.isArray(A2.default) && (A2.default = A2.default.length === 1 ? A2.default[0].value : A2.default.filter(m2).sort((R, $) => t2.compare($.since, R.since))[0].value), Array.isArray(A2.choices) && (A2.choices = A2.choices.filter((R) => m2(R) && T(R)), A2.name === "parser" && p(A2, C, D));
              let N = Object.fromEntries(D.filter((R) => R.defaultOptions && R.defaultOptions[A2.name] !== void 0).map((R) => [R.name, R.defaultOptions[A2.name]]));
              return Object.assign(Object.assign({}, A2), {}, { pluginDefaults: N });
            });
            return { languages: C, options: d };
            function m2(A2) {
              return g || !("since" in A2) || A2.since && t2.gte(h2, A2.since);
            }
            function T(A2) {
              return i2 || !("deprecated" in A2) || A2.deprecated && t2.lt(h2, A2.deprecated);
            }
            function B(A2) {
              if (l)
                return A2;
              let { cliName: N, cliCategory: R, cliDescription: $ } = A2;
              return Qc(A2, Yc);
            }
          }
          function p(D, g, i2) {
            let l = new Set(D.choices.map((h2) => h2.value));
            for (let h2 of g)
              if (h2.parsers) {
                for (let C of h2.parsers)
                  if (!l.has(C)) {
                    l.add(C);
                    let d = i2.find((T) => T.parsers && T.parsers[C]), m2 = h2.name;
                    d && d.name && (m2 += " (plugin: ".concat(d.name, ")")), D.choices.push({ value: C, description: m2 });
                  }
              }
          }
          r2.exports = { getSupportInfo: a };
        } }), AD = I({ "src/utils/is-non-empty-array.js"(e2, r2) {
          "use strict";
          q();
          function t2(s2) {
            return Array.isArray(s2) && s2.length > 0;
          }
          r2.exports = t2;
        } });
        function vD() {
          let { onlyFirst: e2 = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, r2 = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
          return new RegExp(r2, e2 ? void 0 : "g");
        }
        var _D = Ce({ "node_modules/strip-ansi/node_modules/ansi-regex/index.js"() {
          q();
        } });
        function SD(e2) {
          if (typeof e2 != "string")
            throw new TypeError("Expected a `string`, got `".concat(typeof e2, "`"));
          return e2.replace(vD(), "");
        }
        var yD = Ce({ "node_modules/strip-ansi/index.js"() {
          q(), _D();
        } });
        function TD(e2) {
          return Number.isInteger(e2) ? e2 >= 4352 && (e2 <= 4447 || e2 === 9001 || e2 === 9002 || 11904 <= e2 && e2 <= 12871 && e2 !== 12351 || 12880 <= e2 && e2 <= 19903 || 19968 <= e2 && e2 <= 42182 || 43360 <= e2 && e2 <= 43388 || 44032 <= e2 && e2 <= 55203 || 63744 <= e2 && e2 <= 64255 || 65040 <= e2 && e2 <= 65049 || 65072 <= e2 && e2 <= 65131 || 65281 <= e2 && e2 <= 65376 || 65504 <= e2 && e2 <= 65510 || 110592 <= e2 && e2 <= 110593 || 127488 <= e2 && e2 <= 127569 || 131072 <= e2 && e2 <= 262141) : false;
        }
        var BD = Ce({ "node_modules/is-fullwidth-code-point/index.js"() {
          q();
        } }), bD = I({ "node_modules/emoji-regex/index.js"(e2, r2) {
          "use strict";
          q(), r2.exports = function() {
            return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
          };
        } }), Cs = {};
        cs(Cs, { default: () => wD });
        function wD(e2) {
          if (typeof e2 != "string" || e2.length === 0 || (e2 = SD(e2), e2.length === 0))
            return 0;
          e2 = e2.replace((0, ms.default)(), "  ");
          let r2 = 0;
          for (let t2 = 0; t2 < e2.length; t2++) {
            let s2 = e2.codePointAt(t2);
            s2 <= 31 || s2 >= 127 && s2 <= 159 || s2 >= 768 && s2 <= 879 || (s2 > 65535 && t2++, r2 += TD(s2) ? 2 : 1);
          }
          return r2;
        }
        var ms, ND = Ce({ "node_modules/string-width/index.js"() {
          q(), yD(), BD(), ms = tD(bD());
        } }), OD = I({ "src/utils/get-string-width.js"(e2, r2) {
          "use strict";
          q();
          var t2 = (ND(), ls(Cs)).default, s2 = /[^\x20-\x7F]/;
          function c(n) {
            return n ? s2.test(n) ? t2(n) : n.length : 0;
          }
          r2.exports = c;
        } }), Gr = I({ "src/utils/text/skip.js"(e2, r2) {
          "use strict";
          q();
          function t2(p) {
            return (D, g, i2) => {
              let l = i2 && i2.backwards;
              if (g === false)
                return false;
              let { length: h2 } = D, C = g;
              for (; C >= 0 && C < h2; ) {
                let d = D.charAt(C);
                if (p instanceof RegExp) {
                  if (!p.test(d))
                    return C;
                } else if (!p.includes(d))
                  return C;
                l ? C-- : C++;
              }
              return C === -1 || C === h2 ? C : false;
            };
          }
          var s2 = t2(/\s/), c = t2(" 	"), n = t2(",; 	"), a = t2(/[^\n\r]/);
          r2.exports = { skipWhitespace: s2, skipSpaces: c, skipToLineEnd: n, skipEverythingButNewLine: a };
        } }), gs = I({ "src/utils/text/skip-inline-comment.js"(e2, r2) {
          "use strict";
          q();
          function t2(s2, c) {
            if (c === false)
              return false;
            if (s2.charAt(c) === "/" && s2.charAt(c + 1) === "*") {
              for (let n = c + 2; n < s2.length; ++n)
                if (s2.charAt(n) === "*" && s2.charAt(n + 1) === "/")
                  return n + 2;
            }
            return c;
          }
          r2.exports = t2;
        } }), Fs = I({ "src/utils/text/skip-trailing-comment.js"(e2, r2) {
          "use strict";
          q();
          var { skipEverythingButNewLine: t2 } = Gr();
          function s2(c, n) {
            return n === false ? false : c.charAt(n) === "/" && c.charAt(n + 1) === "/" ? t2(c, n) : n;
          }
          r2.exports = s2;
        } }), As = I({ "src/utils/text/skip-newline.js"(e2, r2) {
          "use strict";
          q();
          function t2(s2, c, n) {
            let a = n && n.backwards;
            if (c === false)
              return false;
            let p = s2.charAt(c);
            if (a) {
              if (s2.charAt(c - 1) === "\r" && p === `
`)
                return c - 2;
              if (p === `
` || p === "\r" || p === "\u2028" || p === "\u2029")
                return c - 1;
            } else {
              if (p === "\r" && s2.charAt(c + 1) === `
`)
                return c + 2;
              if (p === `
` || p === "\r" || p === "\u2028" || p === "\u2029")
                return c + 1;
            }
            return c;
          }
          r2.exports = t2;
        } }), qD = I({ "src/utils/text/get-next-non-space-non-comment-character-index-with-start-index.js"(e2, r2) {
          "use strict";
          q();
          var t2 = gs(), s2 = As(), c = Fs(), { skipSpaces: n } = Gr();
          function a(p, D) {
            let g = null, i2 = D;
            for (; i2 !== g; )
              g = i2, i2 = n(p, i2), i2 = t2(p, i2), i2 = c(p, i2), i2 = s2(p, i2);
            return i2;
          }
          r2.exports = a;
        } }), ID = I({ "src/common/util.js"(e2, r2) {
          "use strict";
          q();
          var { default: t2 } = (cD(), ls(fs4)), s2 = ps(), { getSupportInfo: c } = FD(), n = AD(), a = OD(), { skipWhitespace: p, skipSpaces: D, skipToLineEnd: g, skipEverythingButNewLine: i2 } = Gr(), l = gs(), h2 = Fs(), C = As(), d = qD(), m2 = (v) => v[v.length - 2];
          function T(v) {
            return (S2, b, w) => {
              let L = w && w.backwards;
              if (b === false)
                return false;
              let { length: U } = S2, V = b;
              for (; V >= 0 && V < U; ) {
                let Y = S2.charAt(V);
                if (v instanceof RegExp) {
                  if (!v.test(Y))
                    return V;
                } else if (!v.includes(Y))
                  return V;
                L ? V-- : V++;
              }
              return V === -1 || V === U ? V : false;
            };
          }
          function B(v, S2) {
            let b = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {}, w = D(v, b.backwards ? S2 - 1 : S2, b), L = C(v, w, b);
            return w !== L;
          }
          function A2(v, S2, b) {
            for (let w = S2; w < b; ++w)
              if (v.charAt(w) === `
`)
                return true;
            return false;
          }
          function N(v, S2, b) {
            let w = b(S2) - 1;
            w = D(v, w, { backwards: true }), w = C(v, w, { backwards: true }), w = D(v, w, { backwards: true });
            let L = C(v, w, { backwards: true });
            return w !== L;
          }
          function R(v, S2) {
            let b = null, w = S2;
            for (; w !== b; )
              b = w, w = g(v, w), w = l(v, w), w = D(v, w);
            return w = h2(v, w), w = C(v, w), w !== false && B(v, w);
          }
          function $(v, S2, b) {
            return R(v, b(S2));
          }
          function _(v, S2, b) {
            return d(v, b(S2));
          }
          function O(v, S2, b) {
            return v.charAt(_(v, S2, b));
          }
          function x2(v, S2) {
            let b = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            return D(v, b.backwards ? S2 - 1 : S2, b) !== S2;
          }
          function k(v, S2) {
            let b = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 0, w = 0;
            for (let L = b; L < v.length; ++L)
              v[L] === "	" ? w = w + S2 - w % S2 : w++;
            return w;
          }
          function M(v, S2) {
            let b = v.lastIndexOf(`
`);
            return b === -1 ? 0 : k(v.slice(b + 1).match(/^[\t ]*/)[0], S2);
          }
          function u(v, S2) {
            let b = { quote: '"', regex: /"/g, escaped: "&quot;" }, w = { quote: "'", regex: /'/g, escaped: "&apos;" }, L = S2 === "'" ? w : b, U = L === w ? b : w, V = L;
            if (v.includes(L.quote) || v.includes(U.quote)) {
              let Y = (v.match(L.regex) || []).length, ue = (v.match(U.regex) || []).length;
              V = Y > ue ? U : L;
            }
            return V;
          }
          function o(v, S2) {
            let b = v.slice(1, -1), w = S2.parser === "json" || S2.parser === "json5" && S2.quoteProps === "preserve" && !S2.singleQuote ? '"' : S2.__isInHtmlAttribute ? "'" : u(b, S2.singleQuote ? "'" : '"').quote;
            return E(b, w, !(S2.parser === "css" || S2.parser === "less" || S2.parser === "scss" || S2.__embeddedInHtml));
          }
          function E(v, S2, b) {
            let w = S2 === '"' ? "'" : '"', L = /\\(.)|(["'])/gs, U = v.replace(L, (V, Y, ue) => Y === w ? Y : ue === S2 ? "\\" + ue : ue || (b && /^[^\n\r"'0-7\\bfnrt-vx\u2028\u2029]$/.test(Y) ? Y : "\\" + Y));
            return S2 + U + S2;
          }
          function f3(v) {
            return v.toLowerCase().replace(/^([+-]?[\d.]+e)(?:\+|(-))?0*(\d)/, "$1$2$3").replace(/^([+-]?[\d.]+)e[+-]?0+$/, "$1").replace(/^([+-])?\./, "$10.").replace(/(\.\d+?)0+(?=e|$)/, "$1").replace(/\.(?=e|$)/, "");
          }
          function F2(v, S2) {
            let b = v.match(new RegExp("(".concat(t2(S2), ")+"), "g"));
            return b === null ? 0 : b.reduce((w, L) => Math.max(w, L.length / S2.length), 0);
          }
          function P(v, S2) {
            let b = v.match(new RegExp("(".concat(t2(S2), ")+"), "g"));
            if (b === null)
              return 0;
            let w = /* @__PURE__ */ new Map(), L = 0;
            for (let U of b) {
              let V = U.length / S2.length;
              w.set(V, true), V > L && (L = V);
            }
            for (let U = 1; U < L; U++)
              if (!w.get(U))
                return U;
            return L + 1;
          }
          function j(v, S2) {
            (v.comments || (v.comments = [])).push(S2), S2.printed = false, S2.nodeDescription = ee(v);
          }
          function W(v, S2) {
            S2.leading = true, S2.trailing = false, j(v, S2);
          }
          function X(v, S2, b) {
            S2.leading = false, S2.trailing = false, b && (S2.marker = b), j(v, S2);
          }
          function H(v, S2) {
            S2.leading = false, S2.trailing = true, j(v, S2);
          }
          function z(v, S2) {
            let { languages: b } = c({ plugins: S2.plugins }), w = b.find((L) => {
              let { name: U } = L;
              return U.toLowerCase() === v;
            }) || b.find((L) => {
              let { aliases: U } = L;
              return Array.isArray(U) && U.includes(v);
            }) || b.find((L) => {
              let { extensions: U } = L;
              return Array.isArray(U) && U.includes(".".concat(v));
            });
            return w && w.parsers[0];
          }
          function J(v) {
            return v && v.type === "front-matter";
          }
          function Z2(v) {
            let S2 = /* @__PURE__ */ new WeakMap();
            return function(b) {
              return S2.has(b) || S2.set(b, Symbol(v)), S2.get(b);
            };
          }
          function ee(v) {
            let S2 = v.type || v.kind || "(unknown type)", b = String(v.name || v.id && (typeof v.id == "object" ? v.id.name : v.id) || v.key && (typeof v.key == "object" ? v.key.name : v.key) || v.value && (typeof v.value == "object" ? "" : String(v.value)) || v.operator || "");
            return b.length > 20 && (b = b.slice(0, 19) + "\u2026"), S2 + (b ? " " + b : "");
          }
          r2.exports = { inferParserByLanguage: z, getStringWidth: a, getMaxContinuousCount: F2, getMinNotPresentContinuousCount: P, getPenultimate: m2, getLast: s2, getNextNonSpaceNonCommentCharacterIndexWithStartIndex: d, getNextNonSpaceNonCommentCharacterIndex: _, getNextNonSpaceNonCommentCharacter: O, skip: T, skipWhitespace: p, skipSpaces: D, skipToLineEnd: g, skipEverythingButNewLine: i2, skipInlineComment: l, skipTrailingComment: h2, skipNewline: C, isNextLineEmptyAfterIndex: R, isNextLineEmpty: $, isPreviousLineEmpty: N, hasNewline: B, hasNewlineInRange: A2, hasSpaces: x2, getAlignmentSize: k, getIndentSize: M, getPreferredQuote: u, printString: o, printNumber: f3, makeString: E, addLeadingComment: W, addDanglingComment: X, addTrailingComment: H, isFrontMatterNode: J, isNonEmptyArray: n, createGroupIdMapper: Z2 };
        } }), RD = I({ "vendors/html-tag-names.json"(e2, r2) {
          r2.exports = { htmlTagNames: ["a", "abbr", "acronym", "address", "applet", "area", "article", "aside", "audio", "b", "base", "basefont", "bdi", "bdo", "bgsound", "big", "blink", "blockquote", "body", "br", "button", "canvas", "caption", "center", "cite", "code", "col", "colgroup", "command", "content", "data", "datalist", "dd", "del", "details", "dfn", "dialog", "dir", "div", "dl", "dt", "element", "em", "embed", "fieldset", "figcaption", "figure", "font", "footer", "form", "frame", "frameset", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "i", "iframe", "image", "img", "input", "ins", "isindex", "kbd", "keygen", "label", "legend", "li", "link", "listing", "main", "map", "mark", "marquee", "math", "menu", "menuitem", "meta", "meter", "multicol", "nav", "nextid", "nobr", "noembed", "noframes", "noscript", "object", "ol", "optgroup", "option", "output", "p", "param", "picture", "plaintext", "pre", "progress", "q", "rb", "rbc", "rp", "rt", "rtc", "ruby", "s", "samp", "script", "section", "select", "shadow", "slot", "small", "source", "spacer", "span", "strike", "strong", "style", "sub", "summary", "sup", "svg", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "time", "title", "tr", "track", "tt", "u", "ul", "var", "video", "wbr", "xmp"] };
        } }), vs = I({ "src/language-html/utils/array-to-map.js"(e2, r2) {
          "use strict";
          q();
          function t2(s2) {
            let c = /* @__PURE__ */ Object.create(null);
            for (let n of s2)
              c[n] = true;
            return c;
          }
          r2.exports = t2;
        } }), xD = I({ "src/language-html/utils/html-tag-names.js"(e2, r2) {
          "use strict";
          q();
          var { htmlTagNames: t2 } = RD(), s2 = vs(), c = s2(t2);
          r2.exports = c;
        } }), PD = I({ "vendors/html-element-attributes.json"(e2, r2) {
          r2.exports = { htmlElementAttributes: { "*": ["accesskey", "autocapitalize", "autofocus", "class", "contenteditable", "dir", "draggable", "enterkeyhint", "hidden", "id", "inputmode", "is", "itemid", "itemprop", "itemref", "itemscope", "itemtype", "lang", "nonce", "slot", "spellcheck", "style", "tabindex", "title", "translate"], a: ["charset", "coords", "download", "href", "hreflang", "name", "ping", "referrerpolicy", "rel", "rev", "shape", "target", "type"], applet: ["align", "alt", "archive", "code", "codebase", "height", "hspace", "name", "object", "vspace", "width"], area: ["alt", "coords", "download", "href", "hreflang", "nohref", "ping", "referrerpolicy", "rel", "shape", "target", "type"], audio: ["autoplay", "controls", "crossorigin", "loop", "muted", "preload", "src"], base: ["href", "target"], basefont: ["color", "face", "size"], blockquote: ["cite"], body: ["alink", "background", "bgcolor", "link", "text", "vlink"], br: ["clear"], button: ["disabled", "form", "formaction", "formenctype", "formmethod", "formnovalidate", "formtarget", "name", "type", "value"], canvas: ["height", "width"], caption: ["align"], col: ["align", "char", "charoff", "span", "valign", "width"], colgroup: ["align", "char", "charoff", "span", "valign", "width"], data: ["value"], del: ["cite", "datetime"], details: ["open"], dialog: ["open"], dir: ["compact"], div: ["align"], dl: ["compact"], embed: ["height", "src", "type", "width"], fieldset: ["disabled", "form", "name"], font: ["color", "face", "size"], form: ["accept", "accept-charset", "action", "autocomplete", "enctype", "method", "name", "novalidate", "target"], frame: ["frameborder", "longdesc", "marginheight", "marginwidth", "name", "noresize", "scrolling", "src"], frameset: ["cols", "rows"], h1: ["align"], h2: ["align"], h3: ["align"], h4: ["align"], h5: ["align"], h6: ["align"], head: ["profile"], hr: ["align", "noshade", "size", "width"], html: ["manifest", "version"], iframe: ["align", "allow", "allowfullscreen", "allowpaymentrequest", "allowusermedia", "frameborder", "height", "loading", "longdesc", "marginheight", "marginwidth", "name", "referrerpolicy", "sandbox", "scrolling", "src", "srcdoc", "width"], img: ["align", "alt", "border", "crossorigin", "decoding", "height", "hspace", "ismap", "loading", "longdesc", "name", "referrerpolicy", "sizes", "src", "srcset", "usemap", "vspace", "width"], input: ["accept", "align", "alt", "autocomplete", "checked", "dirname", "disabled", "form", "formaction", "formenctype", "formmethod", "formnovalidate", "formtarget", "height", "ismap", "list", "max", "maxlength", "min", "minlength", "multiple", "name", "pattern", "placeholder", "readonly", "required", "size", "src", "step", "type", "usemap", "value", "width"], ins: ["cite", "datetime"], isindex: ["prompt"], label: ["for", "form"], legend: ["align"], li: ["type", "value"], link: ["as", "charset", "color", "crossorigin", "disabled", "href", "hreflang", "imagesizes", "imagesrcset", "integrity", "media", "referrerpolicy", "rel", "rev", "sizes", "target", "type"], map: ["name"], menu: ["compact"], meta: ["charset", "content", "http-equiv", "media", "name", "scheme"], meter: ["high", "low", "max", "min", "optimum", "value"], object: ["align", "archive", "border", "classid", "codebase", "codetype", "data", "declare", "form", "height", "hspace", "name", "standby", "type", "typemustmatch", "usemap", "vspace", "width"], ol: ["compact", "reversed", "start", "type"], optgroup: ["disabled", "label"], option: ["disabled", "label", "selected", "value"], output: ["for", "form", "name"], p: ["align"], param: ["name", "type", "value", "valuetype"], pre: ["width"], progress: ["max", "value"], q: ["cite"], script: ["async", "charset", "crossorigin", "defer", "integrity", "language", "nomodule", "referrerpolicy", "src", "type"], select: ["autocomplete", "disabled", "form", "multiple", "name", "required", "size"], slot: ["name"], source: ["height", "media", "sizes", "src", "srcset", "type", "width"], style: ["media", "type"], table: ["align", "bgcolor", "border", "cellpadding", "cellspacing", "frame", "rules", "summary", "width"], tbody: ["align", "char", "charoff", "valign"], td: ["abbr", "align", "axis", "bgcolor", "char", "charoff", "colspan", "headers", "height", "nowrap", "rowspan", "scope", "valign", "width"], textarea: ["autocomplete", "cols", "dirname", "disabled", "form", "maxlength", "minlength", "name", "placeholder", "readonly", "required", "rows", "wrap"], tfoot: ["align", "char", "charoff", "valign"], th: ["abbr", "align", "axis", "bgcolor", "char", "charoff", "colspan", "headers", "height", "nowrap", "rowspan", "scope", "valign", "width"], thead: ["align", "char", "charoff", "valign"], time: ["datetime"], tr: ["align", "bgcolor", "char", "charoff", "valign"], track: ["default", "kind", "label", "src", "srclang"], ul: ["compact", "type"], video: ["autoplay", "controls", "crossorigin", "height", "loop", "muted", "playsinline", "poster", "preload", "src", "width"] } };
        } }), kD = I({ "src/language-html/utils/map-object.js"(e2, r2) {
          "use strict";
          q();
          function t2(s2, c) {
            let n = /* @__PURE__ */ Object.create(null);
            for (let [a, p] of Object.entries(s2))
              n[a] = c(p, a);
            return n;
          }
          r2.exports = t2;
        } }), LD = I({ "src/language-html/utils/html-elements-attributes.js"(e2, r2) {
          "use strict";
          q();
          var { htmlElementAttributes: t2 } = PD(), s2 = kD(), c = vs(), n = s2(t2, c);
          r2.exports = n;
        } }), MD = I({ "src/language-html/utils/is-unknown-namespace.js"(e2, r2) {
          "use strict";
          q();
          function t2(s2) {
            return s2.type === "element" && !s2.hasExplicitNamespace && !["html", "svg"].includes(s2.namespace);
          }
          r2.exports = t2;
        } }), jD = I({ "src/language-html/pragma.js"(e2, r2) {
          "use strict";
          q();
          function t2(c) {
            return /^\s*<!--\s*@(?:format|prettier)\s*-->/.test(c);
          }
          function s2(c) {
            return `<!-- @format -->

` + c.replace(/^\s*\n/, "");
          }
          r2.exports = { hasPragma: t2, insertPragma: s2 };
        } }), $D = I({ "src/language-html/ast.js"(e2, r2) {
          "use strict";
          q();
          var t2 = { attrs: true, children: true }, s2 = /* @__PURE__ */ new Set(["parent"]), c = class {
            constructor() {
              let a = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              for (let p of /* @__PURE__ */ new Set([...s2, ...Object.keys(a)]))
                this.setProperty(p, a[p]);
            }
            setProperty(a, p) {
              if (this[a] !== p) {
                if (a in t2 && (p = p.map((D) => this.createChild(D))), !s2.has(a)) {
                  this[a] = p;
                  return;
                }
                Object.defineProperty(this, a, { value: p, enumerable: false, configurable: true });
              }
            }
            map(a) {
              let p;
              for (let D in t2) {
                let g = this[D];
                if (g) {
                  let i2 = n(g, (l) => l.map(a));
                  p !== g && (p || (p = new c({ parent: this.parent })), p.setProperty(D, i2));
                }
              }
              if (p)
                for (let D in this)
                  D in t2 || (p[D] = this[D]);
              return a(p || this);
            }
            walk(a) {
              for (let p in t2) {
                let D = this[p];
                if (D)
                  for (let g = 0; g < D.length; g++)
                    D[g].walk(a);
              }
              a(this);
            }
            createChild(a) {
              let p = a instanceof c ? a.clone() : new c(a);
              return p.setProperty("parent", this), p;
            }
            insertChildBefore(a, p) {
              this.children.splice(this.children.indexOf(a), 0, this.createChild(p));
            }
            removeChild(a) {
              this.children.splice(this.children.indexOf(a), 1);
            }
            replaceChild(a, p) {
              this.children[this.children.indexOf(a)] = this.createChild(p);
            }
            clone() {
              return new c(this);
            }
            get firstChild() {
              var a;
              return (a = this.children) === null || a === void 0 ? void 0 : a[0];
            }
            get lastChild() {
              var a;
              return (a = this.children) === null || a === void 0 ? void 0 : a[this.children.length - 1];
            }
            get prev() {
              var a;
              return (a = this.parent) === null || a === void 0 ? void 0 : a.children[this.parent.children.indexOf(this) - 1];
            }
            get next() {
              var a;
              return (a = this.parent) === null || a === void 0 ? void 0 : a.children[this.parent.children.indexOf(this) + 1];
            }
            get rawName() {
              return this.hasExplicitNamespace ? this.fullName : this.name;
            }
            get fullName() {
              return this.namespace ? this.namespace + ":" + this.name : this.name;
            }
            get attrMap() {
              return Object.fromEntries(this.attrs.map((a) => [a.fullName, a.value]));
            }
          };
          function n(a, p) {
            let D = a.map(p);
            return D.some((g, i2) => g !== a[i2]) ? D : a;
          }
          r2.exports = { Node: c };
        } }), UD = I({ "src/language-html/conditional-comment.js"(e2, r2) {
          "use strict";
          q();
          var { ParseSourceSpan: t2 } = Te(), s2 = [{ regex: /^(\[if([^\]]*)]>)(.*?)<!\s*\[endif]$/s, parse: n }, { regex: /^\[if([^\]]*)]><!$/, parse: a }, { regex: /^<!\s*\[endif]$/, parse: p }];
          function c(D, g) {
            if (D.value)
              for (let { regex: i2, parse: l } of s2) {
                let h2 = D.value.match(i2);
                if (h2)
                  return l(D, g, h2);
              }
            return null;
          }
          function n(D, g, i2) {
            let [, l, h2, C] = i2, d = 4 + l.length, m2 = D.sourceSpan.start.moveBy(d), T = m2.moveBy(C.length), [B, A2] = (() => {
              try {
                return [true, g(C, m2).children];
              } catch {
                let N = { type: "text", value: C, sourceSpan: new t2(m2, T) };
                return [false, [N]];
              }
            })();
            return { type: "ieConditionalComment", complete: B, children: A2, condition: h2.trim().replace(/\s+/g, " "), sourceSpan: D.sourceSpan, startSourceSpan: new t2(D.sourceSpan.start, m2), endSourceSpan: new t2(T, D.sourceSpan.end) };
          }
          function a(D, g, i2) {
            let [, l] = i2;
            return { type: "ieConditionalStartComment", condition: l.trim().replace(/\s+/g, " "), sourceSpan: D.sourceSpan };
          }
          function p(D) {
            return { type: "ieConditionalEndComment", sourceSpan: D.sourceSpan };
          }
          r2.exports = { parseIeConditionalComment: c };
        } }), GD = I({ "src/language-html/loc.js"(e2, r2) {
          "use strict";
          q();
          function t2(c) {
            return c.sourceSpan.start.offset;
          }
          function s2(c) {
            return c.sourceSpan.end.offset;
          }
          r2.exports = { locStart: t2, locEnd: s2 };
        } }), Ze = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/tags.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2;
          (function(D) {
            D[D.RAW_TEXT = 0] = "RAW_TEXT", D[D.ESCAPABLE_RAW_TEXT = 1] = "ESCAPABLE_RAW_TEXT", D[D.PARSABLE_DATA = 2] = "PARSABLE_DATA";
          })(r2 = e2.TagContentType || (e2.TagContentType = {}));
          function t2(D) {
            if (D[0] != ":")
              return [null, D];
            let g = D.indexOf(":", 1);
            if (g == -1)
              throw new Error('Unsupported format "'.concat(D, '" expecting ":namespace:name"'));
            return [D.slice(1, g), D.slice(g + 1)];
          }
          e2.splitNsName = t2;
          function s2(D) {
            return t2(D)[1] === "ng-container";
          }
          e2.isNgContainer = s2;
          function c(D) {
            return t2(D)[1] === "ng-content";
          }
          e2.isNgContent = c;
          function n(D) {
            return t2(D)[1] === "ng-template";
          }
          e2.isNgTemplate = n;
          function a(D) {
            return D === null ? null : t2(D)[0];
          }
          e2.getNsPrefix = a;
          function p(D, g) {
            return D ? ":".concat(D, ":").concat(g) : g;
          }
          e2.mergeNsAndName = p, e2.NAMED_ENTITIES = { Aacute: "\xC1", aacute: "\xE1", Abreve: "\u0102", abreve: "\u0103", ac: "\u223E", acd: "\u223F", acE: "\u223E\u0333", Acirc: "\xC2", acirc: "\xE2", acute: "\xB4", Acy: "\u0410", acy: "\u0430", AElig: "\xC6", aelig: "\xE6", af: "\u2061", Afr: "\u{1D504}", afr: "\u{1D51E}", Agrave: "\xC0", agrave: "\xE0", alefsym: "\u2135", aleph: "\u2135", Alpha: "\u0391", alpha: "\u03B1", Amacr: "\u0100", amacr: "\u0101", amalg: "\u2A3F", AMP: "&", amp: "&", And: "\u2A53", and: "\u2227", andand: "\u2A55", andd: "\u2A5C", andslope: "\u2A58", andv: "\u2A5A", ang: "\u2220", ange: "\u29A4", angle: "\u2220", angmsd: "\u2221", angmsdaa: "\u29A8", angmsdab: "\u29A9", angmsdac: "\u29AA", angmsdad: "\u29AB", angmsdae: "\u29AC", angmsdaf: "\u29AD", angmsdag: "\u29AE", angmsdah: "\u29AF", angrt: "\u221F", angrtvb: "\u22BE", angrtvbd: "\u299D", angsph: "\u2222", angst: "\xC5", angzarr: "\u237C", Aogon: "\u0104", aogon: "\u0105", Aopf: "\u{1D538}", aopf: "\u{1D552}", ap: "\u2248", apacir: "\u2A6F", apE: "\u2A70", ape: "\u224A", apid: "\u224B", apos: "'", ApplyFunction: "\u2061", approx: "\u2248", approxeq: "\u224A", Aring: "\xC5", aring: "\xE5", Ascr: "\u{1D49C}", ascr: "\u{1D4B6}", Assign: "\u2254", ast: "*", asymp: "\u2248", asympeq: "\u224D", Atilde: "\xC3", atilde: "\xE3", Auml: "\xC4", auml: "\xE4", awconint: "\u2233", awint: "\u2A11", backcong: "\u224C", backepsilon: "\u03F6", backprime: "\u2035", backsim: "\u223D", backsimeq: "\u22CD", Backslash: "\u2216", Barv: "\u2AE7", barvee: "\u22BD", Barwed: "\u2306", barwed: "\u2305", barwedge: "\u2305", bbrk: "\u23B5", bbrktbrk: "\u23B6", bcong: "\u224C", Bcy: "\u0411", bcy: "\u0431", bdquo: "\u201E", becaus: "\u2235", Because: "\u2235", because: "\u2235", bemptyv: "\u29B0", bepsi: "\u03F6", bernou: "\u212C", Bernoullis: "\u212C", Beta: "\u0392", beta: "\u03B2", beth: "\u2136", between: "\u226C", Bfr: "\u{1D505}", bfr: "\u{1D51F}", bigcap: "\u22C2", bigcirc: "\u25EF", bigcup: "\u22C3", bigodot: "\u2A00", bigoplus: "\u2A01", bigotimes: "\u2A02", bigsqcup: "\u2A06", bigstar: "\u2605", bigtriangledown: "\u25BD", bigtriangleup: "\u25B3", biguplus: "\u2A04", bigvee: "\u22C1", bigwedge: "\u22C0", bkarow: "\u290D", blacklozenge: "\u29EB", blacksquare: "\u25AA", blacktriangle: "\u25B4", blacktriangledown: "\u25BE", blacktriangleleft: "\u25C2", blacktriangleright: "\u25B8", blank: "\u2423", blk12: "\u2592", blk14: "\u2591", blk34: "\u2593", block: "\u2588", bne: "=\u20E5", bnequiv: "\u2261\u20E5", bNot: "\u2AED", bnot: "\u2310", Bopf: "\u{1D539}", bopf: "\u{1D553}", bot: "\u22A5", bottom: "\u22A5", bowtie: "\u22C8", boxbox: "\u29C9", boxDL: "\u2557", boxDl: "\u2556", boxdL: "\u2555", boxdl: "\u2510", boxDR: "\u2554", boxDr: "\u2553", boxdR: "\u2552", boxdr: "\u250C", boxH: "\u2550", boxh: "\u2500", boxHD: "\u2566", boxHd: "\u2564", boxhD: "\u2565", boxhd: "\u252C", boxHU: "\u2569", boxHu: "\u2567", boxhU: "\u2568", boxhu: "\u2534", boxminus: "\u229F", boxplus: "\u229E", boxtimes: "\u22A0", boxUL: "\u255D", boxUl: "\u255C", boxuL: "\u255B", boxul: "\u2518", boxUR: "\u255A", boxUr: "\u2559", boxuR: "\u2558", boxur: "\u2514", boxV: "\u2551", boxv: "\u2502", boxVH: "\u256C", boxVh: "\u256B", boxvH: "\u256A", boxvh: "\u253C", boxVL: "\u2563", boxVl: "\u2562", boxvL: "\u2561", boxvl: "\u2524", boxVR: "\u2560", boxVr: "\u255F", boxvR: "\u255E", boxvr: "\u251C", bprime: "\u2035", Breve: "\u02D8", breve: "\u02D8", brvbar: "\xA6", Bscr: "\u212C", bscr: "\u{1D4B7}", bsemi: "\u204F", bsim: "\u223D", bsime: "\u22CD", bsol: "\\", bsolb: "\u29C5", bsolhsub: "\u27C8", bull: "\u2022", bullet: "\u2022", bump: "\u224E", bumpE: "\u2AAE", bumpe: "\u224F", Bumpeq: "\u224E", bumpeq: "\u224F", Cacute: "\u0106", cacute: "\u0107", Cap: "\u22D2", cap: "\u2229", capand: "\u2A44", capbrcup: "\u2A49", capcap: "\u2A4B", capcup: "\u2A47", capdot: "\u2A40", CapitalDifferentialD: "\u2145", caps: "\u2229\uFE00", caret: "\u2041", caron: "\u02C7", Cayleys: "\u212D", ccaps: "\u2A4D", Ccaron: "\u010C", ccaron: "\u010D", Ccedil: "\xC7", ccedil: "\xE7", Ccirc: "\u0108", ccirc: "\u0109", Cconint: "\u2230", ccups: "\u2A4C", ccupssm: "\u2A50", Cdot: "\u010A", cdot: "\u010B", cedil: "\xB8", Cedilla: "\xB8", cemptyv: "\u29B2", cent: "\xA2", CenterDot: "\xB7", centerdot: "\xB7", Cfr: "\u212D", cfr: "\u{1D520}", CHcy: "\u0427", chcy: "\u0447", check: "\u2713", checkmark: "\u2713", Chi: "\u03A7", chi: "\u03C7", cir: "\u25CB", circ: "\u02C6", circeq: "\u2257", circlearrowleft: "\u21BA", circlearrowright: "\u21BB", circledast: "\u229B", circledcirc: "\u229A", circleddash: "\u229D", CircleDot: "\u2299", circledR: "\xAE", circledS: "\u24C8", CircleMinus: "\u2296", CirclePlus: "\u2295", CircleTimes: "\u2297", cirE: "\u29C3", cire: "\u2257", cirfnint: "\u2A10", cirmid: "\u2AEF", cirscir: "\u29C2", ClockwiseContourIntegral: "\u2232", CloseCurlyDoubleQuote: "\u201D", CloseCurlyQuote: "\u2019", clubs: "\u2663", clubsuit: "\u2663", Colon: "\u2237", colon: ":", Colone: "\u2A74", colone: "\u2254", coloneq: "\u2254", comma: ",", commat: "@", comp: "\u2201", compfn: "\u2218", complement: "\u2201", complexes: "\u2102", cong: "\u2245", congdot: "\u2A6D", Congruent: "\u2261", Conint: "\u222F", conint: "\u222E", ContourIntegral: "\u222E", Copf: "\u2102", copf: "\u{1D554}", coprod: "\u2210", Coproduct: "\u2210", COPY: "\xA9", copy: "\xA9", copysr: "\u2117", CounterClockwiseContourIntegral: "\u2233", crarr: "\u21B5", Cross: "\u2A2F", cross: "\u2717", Cscr: "\u{1D49E}", cscr: "\u{1D4B8}", csub: "\u2ACF", csube: "\u2AD1", csup: "\u2AD0", csupe: "\u2AD2", ctdot: "\u22EF", cudarrl: "\u2938", cudarrr: "\u2935", cuepr: "\u22DE", cuesc: "\u22DF", cularr: "\u21B6", cularrp: "\u293D", Cup: "\u22D3", cup: "\u222A", cupbrcap: "\u2A48", CupCap: "\u224D", cupcap: "\u2A46", cupcup: "\u2A4A", cupdot: "\u228D", cupor: "\u2A45", cups: "\u222A\uFE00", curarr: "\u21B7", curarrm: "\u293C", curlyeqprec: "\u22DE", curlyeqsucc: "\u22DF", curlyvee: "\u22CE", curlywedge: "\u22CF", curren: "\xA4", curvearrowleft: "\u21B6", curvearrowright: "\u21B7", cuvee: "\u22CE", cuwed: "\u22CF", cwconint: "\u2232", cwint: "\u2231", cylcty: "\u232D", Dagger: "\u2021", dagger: "\u2020", daleth: "\u2138", Darr: "\u21A1", dArr: "\u21D3", darr: "\u2193", dash: "\u2010", Dashv: "\u2AE4", dashv: "\u22A3", dbkarow: "\u290F", dblac: "\u02DD", Dcaron: "\u010E", dcaron: "\u010F", Dcy: "\u0414", dcy: "\u0434", DD: "\u2145", dd: "\u2146", ddagger: "\u2021", ddarr: "\u21CA", DDotrahd: "\u2911", ddotseq: "\u2A77", deg: "\xB0", Del: "\u2207", Delta: "\u0394", delta: "\u03B4", demptyv: "\u29B1", dfisht: "\u297F", Dfr: "\u{1D507}", dfr: "\u{1D521}", dHar: "\u2965", dharl: "\u21C3", dharr: "\u21C2", DiacriticalAcute: "\xB4", DiacriticalDot: "\u02D9", DiacriticalDoubleAcute: "\u02DD", DiacriticalGrave: "`", DiacriticalTilde: "\u02DC", diam: "\u22C4", Diamond: "\u22C4", diamond: "\u22C4", diamondsuit: "\u2666", diams: "\u2666", die: "\xA8", DifferentialD: "\u2146", digamma: "\u03DD", disin: "\u22F2", div: "\xF7", divide: "\xF7", divideontimes: "\u22C7", divonx: "\u22C7", DJcy: "\u0402", djcy: "\u0452", dlcorn: "\u231E", dlcrop: "\u230D", dollar: "$", Dopf: "\u{1D53B}", dopf: "\u{1D555}", Dot: "\xA8", dot: "\u02D9", DotDot: "\u20DC", doteq: "\u2250", doteqdot: "\u2251", DotEqual: "\u2250", dotminus: "\u2238", dotplus: "\u2214", dotsquare: "\u22A1", doublebarwedge: "\u2306", DoubleContourIntegral: "\u222F", DoubleDot: "\xA8", DoubleDownArrow: "\u21D3", DoubleLeftArrow: "\u21D0", DoubleLeftRightArrow: "\u21D4", DoubleLeftTee: "\u2AE4", DoubleLongLeftArrow: "\u27F8", DoubleLongLeftRightArrow: "\u27FA", DoubleLongRightArrow: "\u27F9", DoubleRightArrow: "\u21D2", DoubleRightTee: "\u22A8", DoubleUpArrow: "\u21D1", DoubleUpDownArrow: "\u21D5", DoubleVerticalBar: "\u2225", DownArrow: "\u2193", Downarrow: "\u21D3", downarrow: "\u2193", DownArrowBar: "\u2913", DownArrowUpArrow: "\u21F5", DownBreve: "\u0311", downdownarrows: "\u21CA", downharpoonleft: "\u21C3", downharpoonright: "\u21C2", DownLeftRightVector: "\u2950", DownLeftTeeVector: "\u295E", DownLeftVector: "\u21BD", DownLeftVectorBar: "\u2956", DownRightTeeVector: "\u295F", DownRightVector: "\u21C1", DownRightVectorBar: "\u2957", DownTee: "\u22A4", DownTeeArrow: "\u21A7", drbkarow: "\u2910", drcorn: "\u231F", drcrop: "\u230C", Dscr: "\u{1D49F}", dscr: "\u{1D4B9}", DScy: "\u0405", dscy: "\u0455", dsol: "\u29F6", Dstrok: "\u0110", dstrok: "\u0111", dtdot: "\u22F1", dtri: "\u25BF", dtrif: "\u25BE", duarr: "\u21F5", duhar: "\u296F", dwangle: "\u29A6", DZcy: "\u040F", dzcy: "\u045F", dzigrarr: "\u27FF", Eacute: "\xC9", eacute: "\xE9", easter: "\u2A6E", Ecaron: "\u011A", ecaron: "\u011B", ecir: "\u2256", Ecirc: "\xCA", ecirc: "\xEA", ecolon: "\u2255", Ecy: "\u042D", ecy: "\u044D", eDDot: "\u2A77", Edot: "\u0116", eDot: "\u2251", edot: "\u0117", ee: "\u2147", efDot: "\u2252", Efr: "\u{1D508}", efr: "\u{1D522}", eg: "\u2A9A", Egrave: "\xC8", egrave: "\xE8", egs: "\u2A96", egsdot: "\u2A98", el: "\u2A99", Element: "\u2208", elinters: "\u23E7", ell: "\u2113", els: "\u2A95", elsdot: "\u2A97", Emacr: "\u0112", emacr: "\u0113", empty: "\u2205", emptyset: "\u2205", EmptySmallSquare: "\u25FB", emptyv: "\u2205", EmptyVerySmallSquare: "\u25AB", emsp: "\u2003", emsp13: "\u2004", emsp14: "\u2005", ENG: "\u014A", eng: "\u014B", ensp: "\u2002", Eogon: "\u0118", eogon: "\u0119", Eopf: "\u{1D53C}", eopf: "\u{1D556}", epar: "\u22D5", eparsl: "\u29E3", eplus: "\u2A71", epsi: "\u03B5", Epsilon: "\u0395", epsilon: "\u03B5", epsiv: "\u03F5", eqcirc: "\u2256", eqcolon: "\u2255", eqsim: "\u2242", eqslantgtr: "\u2A96", eqslantless: "\u2A95", Equal: "\u2A75", equals: "=", EqualTilde: "\u2242", equest: "\u225F", Equilibrium: "\u21CC", equiv: "\u2261", equivDD: "\u2A78", eqvparsl: "\u29E5", erarr: "\u2971", erDot: "\u2253", Escr: "\u2130", escr: "\u212F", esdot: "\u2250", Esim: "\u2A73", esim: "\u2242", Eta: "\u0397", eta: "\u03B7", ETH: "\xD0", eth: "\xF0", Euml: "\xCB", euml: "\xEB", euro: "\u20AC", excl: "!", exist: "\u2203", Exists: "\u2203", expectation: "\u2130", ExponentialE: "\u2147", exponentiale: "\u2147", fallingdotseq: "\u2252", Fcy: "\u0424", fcy: "\u0444", female: "\u2640", ffilig: "\uFB03", fflig: "\uFB00", ffllig: "\uFB04", Ffr: "\u{1D509}", ffr: "\u{1D523}", filig: "\uFB01", FilledSmallSquare: "\u25FC", FilledVerySmallSquare: "\u25AA", fjlig: "fj", flat: "\u266D", fllig: "\uFB02", fltns: "\u25B1", fnof: "\u0192", Fopf: "\u{1D53D}", fopf: "\u{1D557}", ForAll: "\u2200", forall: "\u2200", fork: "\u22D4", forkv: "\u2AD9", Fouriertrf: "\u2131", fpartint: "\u2A0D", frac12: "\xBD", frac13: "\u2153", frac14: "\xBC", frac15: "\u2155", frac16: "\u2159", frac18: "\u215B", frac23: "\u2154", frac25: "\u2156", frac34: "\xBE", frac35: "\u2157", frac38: "\u215C", frac45: "\u2158", frac56: "\u215A", frac58: "\u215D", frac78: "\u215E", frasl: "\u2044", frown: "\u2322", Fscr: "\u2131", fscr: "\u{1D4BB}", gacute: "\u01F5", Gamma: "\u0393", gamma: "\u03B3", Gammad: "\u03DC", gammad: "\u03DD", gap: "\u2A86", Gbreve: "\u011E", gbreve: "\u011F", Gcedil: "\u0122", Gcirc: "\u011C", gcirc: "\u011D", Gcy: "\u0413", gcy: "\u0433", Gdot: "\u0120", gdot: "\u0121", gE: "\u2267", ge: "\u2265", gEl: "\u2A8C", gel: "\u22DB", geq: "\u2265", geqq: "\u2267", geqslant: "\u2A7E", ges: "\u2A7E", gescc: "\u2AA9", gesdot: "\u2A80", gesdoto: "\u2A82", gesdotol: "\u2A84", gesl: "\u22DB\uFE00", gesles: "\u2A94", Gfr: "\u{1D50A}", gfr: "\u{1D524}", Gg: "\u22D9", gg: "\u226B", ggg: "\u22D9", gimel: "\u2137", GJcy: "\u0403", gjcy: "\u0453", gl: "\u2277", gla: "\u2AA5", glE: "\u2A92", glj: "\u2AA4", gnap: "\u2A8A", gnapprox: "\u2A8A", gnE: "\u2269", gne: "\u2A88", gneq: "\u2A88", gneqq: "\u2269", gnsim: "\u22E7", Gopf: "\u{1D53E}", gopf: "\u{1D558}", grave: "`", GreaterEqual: "\u2265", GreaterEqualLess: "\u22DB", GreaterFullEqual: "\u2267", GreaterGreater: "\u2AA2", GreaterLess: "\u2277", GreaterSlantEqual: "\u2A7E", GreaterTilde: "\u2273", Gscr: "\u{1D4A2}", gscr: "\u210A", gsim: "\u2273", gsime: "\u2A8E", gsiml: "\u2A90", GT: ">", Gt: "\u226B", gt: ">", gtcc: "\u2AA7", gtcir: "\u2A7A", gtdot: "\u22D7", gtlPar: "\u2995", gtquest: "\u2A7C", gtrapprox: "\u2A86", gtrarr: "\u2978", gtrdot: "\u22D7", gtreqless: "\u22DB", gtreqqless: "\u2A8C", gtrless: "\u2277", gtrsim: "\u2273", gvertneqq: "\u2269\uFE00", gvnE: "\u2269\uFE00", Hacek: "\u02C7", hairsp: "\u200A", half: "\xBD", hamilt: "\u210B", HARDcy: "\u042A", hardcy: "\u044A", hArr: "\u21D4", harr: "\u2194", harrcir: "\u2948", harrw: "\u21AD", Hat: "^", hbar: "\u210F", Hcirc: "\u0124", hcirc: "\u0125", hearts: "\u2665", heartsuit: "\u2665", hellip: "\u2026", hercon: "\u22B9", Hfr: "\u210C", hfr: "\u{1D525}", HilbertSpace: "\u210B", hksearow: "\u2925", hkswarow: "\u2926", hoarr: "\u21FF", homtht: "\u223B", hookleftarrow: "\u21A9", hookrightarrow: "\u21AA", Hopf: "\u210D", hopf: "\u{1D559}", horbar: "\u2015", HorizontalLine: "\u2500", Hscr: "\u210B", hscr: "\u{1D4BD}", hslash: "\u210F", Hstrok: "\u0126", hstrok: "\u0127", HumpDownHump: "\u224E", HumpEqual: "\u224F", hybull: "\u2043", hyphen: "\u2010", Iacute: "\xCD", iacute: "\xED", ic: "\u2063", Icirc: "\xCE", icirc: "\xEE", Icy: "\u0418", icy: "\u0438", Idot: "\u0130", IEcy: "\u0415", iecy: "\u0435", iexcl: "\xA1", iff: "\u21D4", Ifr: "\u2111", ifr: "\u{1D526}", Igrave: "\xCC", igrave: "\xEC", ii: "\u2148", iiiint: "\u2A0C", iiint: "\u222D", iinfin: "\u29DC", iiota: "\u2129", IJlig: "\u0132", ijlig: "\u0133", Im: "\u2111", Imacr: "\u012A", imacr: "\u012B", image: "\u2111", ImaginaryI: "\u2148", imagline: "\u2110", imagpart: "\u2111", imath: "\u0131", imof: "\u22B7", imped: "\u01B5", Implies: "\u21D2", in: "\u2208", incare: "\u2105", infin: "\u221E", infintie: "\u29DD", inodot: "\u0131", Int: "\u222C", int: "\u222B", intcal: "\u22BA", integers: "\u2124", Integral: "\u222B", intercal: "\u22BA", Intersection: "\u22C2", intlarhk: "\u2A17", intprod: "\u2A3C", InvisibleComma: "\u2063", InvisibleTimes: "\u2062", IOcy: "\u0401", iocy: "\u0451", Iogon: "\u012E", iogon: "\u012F", Iopf: "\u{1D540}", iopf: "\u{1D55A}", Iota: "\u0399", iota: "\u03B9", iprod: "\u2A3C", iquest: "\xBF", Iscr: "\u2110", iscr: "\u{1D4BE}", isin: "\u2208", isindot: "\u22F5", isinE: "\u22F9", isins: "\u22F4", isinsv: "\u22F3", isinv: "\u2208", it: "\u2062", Itilde: "\u0128", itilde: "\u0129", Iukcy: "\u0406", iukcy: "\u0456", Iuml: "\xCF", iuml: "\xEF", Jcirc: "\u0134", jcirc: "\u0135", Jcy: "\u0419", jcy: "\u0439", Jfr: "\u{1D50D}", jfr: "\u{1D527}", jmath: "\u0237", Jopf: "\u{1D541}", jopf: "\u{1D55B}", Jscr: "\u{1D4A5}", jscr: "\u{1D4BF}", Jsercy: "\u0408", jsercy: "\u0458", Jukcy: "\u0404", jukcy: "\u0454", Kappa: "\u039A", kappa: "\u03BA", kappav: "\u03F0", Kcedil: "\u0136", kcedil: "\u0137", Kcy: "\u041A", kcy: "\u043A", Kfr: "\u{1D50E}", kfr: "\u{1D528}", kgreen: "\u0138", KHcy: "\u0425", khcy: "\u0445", KJcy: "\u040C", kjcy: "\u045C", Kopf: "\u{1D542}", kopf: "\u{1D55C}", Kscr: "\u{1D4A6}", kscr: "\u{1D4C0}", lAarr: "\u21DA", Lacute: "\u0139", lacute: "\u013A", laemptyv: "\u29B4", lagran: "\u2112", Lambda: "\u039B", lambda: "\u03BB", Lang: "\u27EA", lang: "\u27E8", langd: "\u2991", langle: "\u27E8", lap: "\u2A85", Laplacetrf: "\u2112", laquo: "\xAB", Larr: "\u219E", lArr: "\u21D0", larr: "\u2190", larrb: "\u21E4", larrbfs: "\u291F", larrfs: "\u291D", larrhk: "\u21A9", larrlp: "\u21AB", larrpl: "\u2939", larrsim: "\u2973", larrtl: "\u21A2", lat: "\u2AAB", lAtail: "\u291B", latail: "\u2919", late: "\u2AAD", lates: "\u2AAD\uFE00", lBarr: "\u290E", lbarr: "\u290C", lbbrk: "\u2772", lbrace: "{", lbrack: "[", lbrke: "\u298B", lbrksld: "\u298F", lbrkslu: "\u298D", Lcaron: "\u013D", lcaron: "\u013E", Lcedil: "\u013B", lcedil: "\u013C", lceil: "\u2308", lcub: "{", Lcy: "\u041B", lcy: "\u043B", ldca: "\u2936", ldquo: "\u201C", ldquor: "\u201E", ldrdhar: "\u2967", ldrushar: "\u294B", ldsh: "\u21B2", lE: "\u2266", le: "\u2264", LeftAngleBracket: "\u27E8", LeftArrow: "\u2190", Leftarrow: "\u21D0", leftarrow: "\u2190", LeftArrowBar: "\u21E4", LeftArrowRightArrow: "\u21C6", leftarrowtail: "\u21A2", LeftCeiling: "\u2308", LeftDoubleBracket: "\u27E6", LeftDownTeeVector: "\u2961", LeftDownVector: "\u21C3", LeftDownVectorBar: "\u2959", LeftFloor: "\u230A", leftharpoondown: "\u21BD", leftharpoonup: "\u21BC", leftleftarrows: "\u21C7", LeftRightArrow: "\u2194", Leftrightarrow: "\u21D4", leftrightarrow: "\u2194", leftrightarrows: "\u21C6", leftrightharpoons: "\u21CB", leftrightsquigarrow: "\u21AD", LeftRightVector: "\u294E", LeftTee: "\u22A3", LeftTeeArrow: "\u21A4", LeftTeeVector: "\u295A", leftthreetimes: "\u22CB", LeftTriangle: "\u22B2", LeftTriangleBar: "\u29CF", LeftTriangleEqual: "\u22B4", LeftUpDownVector: "\u2951", LeftUpTeeVector: "\u2960", LeftUpVector: "\u21BF", LeftUpVectorBar: "\u2958", LeftVector: "\u21BC", LeftVectorBar: "\u2952", lEg: "\u2A8B", leg: "\u22DA", leq: "\u2264", leqq: "\u2266", leqslant: "\u2A7D", les: "\u2A7D", lescc: "\u2AA8", lesdot: "\u2A7F", lesdoto: "\u2A81", lesdotor: "\u2A83", lesg: "\u22DA\uFE00", lesges: "\u2A93", lessapprox: "\u2A85", lessdot: "\u22D6", lesseqgtr: "\u22DA", lesseqqgtr: "\u2A8B", LessEqualGreater: "\u22DA", LessFullEqual: "\u2266", LessGreater: "\u2276", lessgtr: "\u2276", LessLess: "\u2AA1", lesssim: "\u2272", LessSlantEqual: "\u2A7D", LessTilde: "\u2272", lfisht: "\u297C", lfloor: "\u230A", Lfr: "\u{1D50F}", lfr: "\u{1D529}", lg: "\u2276", lgE: "\u2A91", lHar: "\u2962", lhard: "\u21BD", lharu: "\u21BC", lharul: "\u296A", lhblk: "\u2584", LJcy: "\u0409", ljcy: "\u0459", Ll: "\u22D8", ll: "\u226A", llarr: "\u21C7", llcorner: "\u231E", Lleftarrow: "\u21DA", llhard: "\u296B", lltri: "\u25FA", Lmidot: "\u013F", lmidot: "\u0140", lmoust: "\u23B0", lmoustache: "\u23B0", lnap: "\u2A89", lnapprox: "\u2A89", lnE: "\u2268", lne: "\u2A87", lneq: "\u2A87", lneqq: "\u2268", lnsim: "\u22E6", loang: "\u27EC", loarr: "\u21FD", lobrk: "\u27E6", LongLeftArrow: "\u27F5", Longleftarrow: "\u27F8", longleftarrow: "\u27F5", LongLeftRightArrow: "\u27F7", Longleftrightarrow: "\u27FA", longleftrightarrow: "\u27F7", longmapsto: "\u27FC", LongRightArrow: "\u27F6", Longrightarrow: "\u27F9", longrightarrow: "\u27F6", looparrowleft: "\u21AB", looparrowright: "\u21AC", lopar: "\u2985", Lopf: "\u{1D543}", lopf: "\u{1D55D}", loplus: "\u2A2D", lotimes: "\u2A34", lowast: "\u2217", lowbar: "_", LowerLeftArrow: "\u2199", LowerRightArrow: "\u2198", loz: "\u25CA", lozenge: "\u25CA", lozf: "\u29EB", lpar: "(", lparlt: "\u2993", lrarr: "\u21C6", lrcorner: "\u231F", lrhar: "\u21CB", lrhard: "\u296D", lrm: "\u200E", lrtri: "\u22BF", lsaquo: "\u2039", Lscr: "\u2112", lscr: "\u{1D4C1}", Lsh: "\u21B0", lsh: "\u21B0", lsim: "\u2272", lsime: "\u2A8D", lsimg: "\u2A8F", lsqb: "[", lsquo: "\u2018", lsquor: "\u201A", Lstrok: "\u0141", lstrok: "\u0142", LT: "<", Lt: "\u226A", lt: "<", ltcc: "\u2AA6", ltcir: "\u2A79", ltdot: "\u22D6", lthree: "\u22CB", ltimes: "\u22C9", ltlarr: "\u2976", ltquest: "\u2A7B", ltri: "\u25C3", ltrie: "\u22B4", ltrif: "\u25C2", ltrPar: "\u2996", lurdshar: "\u294A", luruhar: "\u2966", lvertneqq: "\u2268\uFE00", lvnE: "\u2268\uFE00", macr: "\xAF", male: "\u2642", malt: "\u2720", maltese: "\u2720", Map: "\u2905", map: "\u21A6", mapsto: "\u21A6", mapstodown: "\u21A7", mapstoleft: "\u21A4", mapstoup: "\u21A5", marker: "\u25AE", mcomma: "\u2A29", Mcy: "\u041C", mcy: "\u043C", mdash: "\u2014", mDDot: "\u223A", measuredangle: "\u2221", MediumSpace: "\u205F", Mellintrf: "\u2133", Mfr: "\u{1D510}", mfr: "\u{1D52A}", mho: "\u2127", micro: "\xB5", mid: "\u2223", midast: "*", midcir: "\u2AF0", middot: "\xB7", minus: "\u2212", minusb: "\u229F", minusd: "\u2238", minusdu: "\u2A2A", MinusPlus: "\u2213", mlcp: "\u2ADB", mldr: "\u2026", mnplus: "\u2213", models: "\u22A7", Mopf: "\u{1D544}", mopf: "\u{1D55E}", mp: "\u2213", Mscr: "\u2133", mscr: "\u{1D4C2}", mstpos: "\u223E", Mu: "\u039C", mu: "\u03BC", multimap: "\u22B8", mumap: "\u22B8", nabla: "\u2207", Nacute: "\u0143", nacute: "\u0144", nang: "\u2220\u20D2", nap: "\u2249", napE: "\u2A70\u0338", napid: "\u224B\u0338", napos: "\u0149", napprox: "\u2249", natur: "\u266E", natural: "\u266E", naturals: "\u2115", nbsp: "\xA0", nbump: "\u224E\u0338", nbumpe: "\u224F\u0338", ncap: "\u2A43", Ncaron: "\u0147", ncaron: "\u0148", Ncedil: "\u0145", ncedil: "\u0146", ncong: "\u2247", ncongdot: "\u2A6D\u0338", ncup: "\u2A42", Ncy: "\u041D", ncy: "\u043D", ndash: "\u2013", ne: "\u2260", nearhk: "\u2924", neArr: "\u21D7", nearr: "\u2197", nearrow: "\u2197", nedot: "\u2250\u0338", NegativeMediumSpace: "\u200B", NegativeThickSpace: "\u200B", NegativeThinSpace: "\u200B", NegativeVeryThinSpace: "\u200B", nequiv: "\u2262", nesear: "\u2928", nesim: "\u2242\u0338", NestedGreaterGreater: "\u226B", NestedLessLess: "\u226A", NewLine: `
`, nexist: "\u2204", nexists: "\u2204", Nfr: "\u{1D511}", nfr: "\u{1D52B}", ngE: "\u2267\u0338", nge: "\u2271", ngeq: "\u2271", ngeqq: "\u2267\u0338", ngeqslant: "\u2A7E\u0338", nges: "\u2A7E\u0338", nGg: "\u22D9\u0338", ngsim: "\u2275", nGt: "\u226B\u20D2", ngt: "\u226F", ngtr: "\u226F", nGtv: "\u226B\u0338", nhArr: "\u21CE", nharr: "\u21AE", nhpar: "\u2AF2", ni: "\u220B", nis: "\u22FC", nisd: "\u22FA", niv: "\u220B", NJcy: "\u040A", njcy: "\u045A", nlArr: "\u21CD", nlarr: "\u219A", nldr: "\u2025", nlE: "\u2266\u0338", nle: "\u2270", nLeftarrow: "\u21CD", nleftarrow: "\u219A", nLeftrightarrow: "\u21CE", nleftrightarrow: "\u21AE", nleq: "\u2270", nleqq: "\u2266\u0338", nleqslant: "\u2A7D\u0338", nles: "\u2A7D\u0338", nless: "\u226E", nLl: "\u22D8\u0338", nlsim: "\u2274", nLt: "\u226A\u20D2", nlt: "\u226E", nltri: "\u22EA", nltrie: "\u22EC", nLtv: "\u226A\u0338", nmid: "\u2224", NoBreak: "\u2060", NonBreakingSpace: "\xA0", Nopf: "\u2115", nopf: "\u{1D55F}", Not: "\u2AEC", not: "\xAC", NotCongruent: "\u2262", NotCupCap: "\u226D", NotDoubleVerticalBar: "\u2226", NotElement: "\u2209", NotEqual: "\u2260", NotEqualTilde: "\u2242\u0338", NotExists: "\u2204", NotGreater: "\u226F", NotGreaterEqual: "\u2271", NotGreaterFullEqual: "\u2267\u0338", NotGreaterGreater: "\u226B\u0338", NotGreaterLess: "\u2279", NotGreaterSlantEqual: "\u2A7E\u0338", NotGreaterTilde: "\u2275", NotHumpDownHump: "\u224E\u0338", NotHumpEqual: "\u224F\u0338", notin: "\u2209", notindot: "\u22F5\u0338", notinE: "\u22F9\u0338", notinva: "\u2209", notinvb: "\u22F7", notinvc: "\u22F6", NotLeftTriangle: "\u22EA", NotLeftTriangleBar: "\u29CF\u0338", NotLeftTriangleEqual: "\u22EC", NotLess: "\u226E", NotLessEqual: "\u2270", NotLessGreater: "\u2278", NotLessLess: "\u226A\u0338", NotLessSlantEqual: "\u2A7D\u0338", NotLessTilde: "\u2274", NotNestedGreaterGreater: "\u2AA2\u0338", NotNestedLessLess: "\u2AA1\u0338", notni: "\u220C", notniva: "\u220C", notnivb: "\u22FE", notnivc: "\u22FD", NotPrecedes: "\u2280", NotPrecedesEqual: "\u2AAF\u0338", NotPrecedesSlantEqual: "\u22E0", NotReverseElement: "\u220C", NotRightTriangle: "\u22EB", NotRightTriangleBar: "\u29D0\u0338", NotRightTriangleEqual: "\u22ED", NotSquareSubset: "\u228F\u0338", NotSquareSubsetEqual: "\u22E2", NotSquareSuperset: "\u2290\u0338", NotSquareSupersetEqual: "\u22E3", NotSubset: "\u2282\u20D2", NotSubsetEqual: "\u2288", NotSucceeds: "\u2281", NotSucceedsEqual: "\u2AB0\u0338", NotSucceedsSlantEqual: "\u22E1", NotSucceedsTilde: "\u227F\u0338", NotSuperset: "\u2283\u20D2", NotSupersetEqual: "\u2289", NotTilde: "\u2241", NotTildeEqual: "\u2244", NotTildeFullEqual: "\u2247", NotTildeTilde: "\u2249", NotVerticalBar: "\u2224", npar: "\u2226", nparallel: "\u2226", nparsl: "\u2AFD\u20E5", npart: "\u2202\u0338", npolint: "\u2A14", npr: "\u2280", nprcue: "\u22E0", npre: "\u2AAF\u0338", nprec: "\u2280", npreceq: "\u2AAF\u0338", nrArr: "\u21CF", nrarr: "\u219B", nrarrc: "\u2933\u0338", nrarrw: "\u219D\u0338", nRightarrow: "\u21CF", nrightarrow: "\u219B", nrtri: "\u22EB", nrtrie: "\u22ED", nsc: "\u2281", nsccue: "\u22E1", nsce: "\u2AB0\u0338", Nscr: "\u{1D4A9}", nscr: "\u{1D4C3}", nshortmid: "\u2224", nshortparallel: "\u2226", nsim: "\u2241", nsime: "\u2244", nsimeq: "\u2244", nsmid: "\u2224", nspar: "\u2226", nsqsube: "\u22E2", nsqsupe: "\u22E3", nsub: "\u2284", nsubE: "\u2AC5\u0338", nsube: "\u2288", nsubset: "\u2282\u20D2", nsubseteq: "\u2288", nsubseteqq: "\u2AC5\u0338", nsucc: "\u2281", nsucceq: "\u2AB0\u0338", nsup: "\u2285", nsupE: "\u2AC6\u0338", nsupe: "\u2289", nsupset: "\u2283\u20D2", nsupseteq: "\u2289", nsupseteqq: "\u2AC6\u0338", ntgl: "\u2279", Ntilde: "\xD1", ntilde: "\xF1", ntlg: "\u2278", ntriangleleft: "\u22EA", ntrianglelefteq: "\u22EC", ntriangleright: "\u22EB", ntrianglerighteq: "\u22ED", Nu: "\u039D", nu: "\u03BD", num: "#", numero: "\u2116", numsp: "\u2007", nvap: "\u224D\u20D2", nVDash: "\u22AF", nVdash: "\u22AE", nvDash: "\u22AD", nvdash: "\u22AC", nvge: "\u2265\u20D2", nvgt: ">\u20D2", nvHarr: "\u2904", nvinfin: "\u29DE", nvlArr: "\u2902", nvle: "\u2264\u20D2", nvlt: "<\u20D2", nvltrie: "\u22B4\u20D2", nvrArr: "\u2903", nvrtrie: "\u22B5\u20D2", nvsim: "\u223C\u20D2", nwarhk: "\u2923", nwArr: "\u21D6", nwarr: "\u2196", nwarrow: "\u2196", nwnear: "\u2927", Oacute: "\xD3", oacute: "\xF3", oast: "\u229B", ocir: "\u229A", Ocirc: "\xD4", ocirc: "\xF4", Ocy: "\u041E", ocy: "\u043E", odash: "\u229D", Odblac: "\u0150", odblac: "\u0151", odiv: "\u2A38", odot: "\u2299", odsold: "\u29BC", OElig: "\u0152", oelig: "\u0153", ofcir: "\u29BF", Ofr: "\u{1D512}", ofr: "\u{1D52C}", ogon: "\u02DB", Ograve: "\xD2", ograve: "\xF2", ogt: "\u29C1", ohbar: "\u29B5", ohm: "\u03A9", oint: "\u222E", olarr: "\u21BA", olcir: "\u29BE", olcross: "\u29BB", oline: "\u203E", olt: "\u29C0", Omacr: "\u014C", omacr: "\u014D", Omega: "\u03A9", omega: "\u03C9", Omicron: "\u039F", omicron: "\u03BF", omid: "\u29B6", ominus: "\u2296", Oopf: "\u{1D546}", oopf: "\u{1D560}", opar: "\u29B7", OpenCurlyDoubleQuote: "\u201C", OpenCurlyQuote: "\u2018", operp: "\u29B9", oplus: "\u2295", Or: "\u2A54", or: "\u2228", orarr: "\u21BB", ord: "\u2A5D", order: "\u2134", orderof: "\u2134", ordf: "\xAA", ordm: "\xBA", origof: "\u22B6", oror: "\u2A56", orslope: "\u2A57", orv: "\u2A5B", oS: "\u24C8", Oscr: "\u{1D4AA}", oscr: "\u2134", Oslash: "\xD8", oslash: "\xF8", osol: "\u2298", Otilde: "\xD5", otilde: "\xF5", Otimes: "\u2A37", otimes: "\u2297", otimesas: "\u2A36", Ouml: "\xD6", ouml: "\xF6", ovbar: "\u233D", OverBar: "\u203E", OverBrace: "\u23DE", OverBracket: "\u23B4", OverParenthesis: "\u23DC", par: "\u2225", para: "\xB6", parallel: "\u2225", parsim: "\u2AF3", parsl: "\u2AFD", part: "\u2202", PartialD: "\u2202", Pcy: "\u041F", pcy: "\u043F", percnt: "%", period: ".", permil: "\u2030", perp: "\u22A5", pertenk: "\u2031", Pfr: "\u{1D513}", pfr: "\u{1D52D}", Phi: "\u03A6", phi: "\u03C6", phiv: "\u03D5", phmmat: "\u2133", phone: "\u260E", Pi: "\u03A0", pi: "\u03C0", pitchfork: "\u22D4", piv: "\u03D6", planck: "\u210F", planckh: "\u210E", plankv: "\u210F", plus: "+", plusacir: "\u2A23", plusb: "\u229E", pluscir: "\u2A22", plusdo: "\u2214", plusdu: "\u2A25", pluse: "\u2A72", PlusMinus: "\xB1", plusmn: "\xB1", plussim: "\u2A26", plustwo: "\u2A27", pm: "\xB1", Poincareplane: "\u210C", pointint: "\u2A15", Popf: "\u2119", popf: "\u{1D561}", pound: "\xA3", Pr: "\u2ABB", pr: "\u227A", prap: "\u2AB7", prcue: "\u227C", prE: "\u2AB3", pre: "\u2AAF", prec: "\u227A", precapprox: "\u2AB7", preccurlyeq: "\u227C", Precedes: "\u227A", PrecedesEqual: "\u2AAF", PrecedesSlantEqual: "\u227C", PrecedesTilde: "\u227E", preceq: "\u2AAF", precnapprox: "\u2AB9", precneqq: "\u2AB5", precnsim: "\u22E8", precsim: "\u227E", Prime: "\u2033", prime: "\u2032", primes: "\u2119", prnap: "\u2AB9", prnE: "\u2AB5", prnsim: "\u22E8", prod: "\u220F", Product: "\u220F", profalar: "\u232E", profline: "\u2312", profsurf: "\u2313", prop: "\u221D", Proportion: "\u2237", Proportional: "\u221D", propto: "\u221D", prsim: "\u227E", prurel: "\u22B0", Pscr: "\u{1D4AB}", pscr: "\u{1D4C5}", Psi: "\u03A8", psi: "\u03C8", puncsp: "\u2008", Qfr: "\u{1D514}", qfr: "\u{1D52E}", qint: "\u2A0C", Qopf: "\u211A", qopf: "\u{1D562}", qprime: "\u2057", Qscr: "\u{1D4AC}", qscr: "\u{1D4C6}", quaternions: "\u210D", quatint: "\u2A16", quest: "?", questeq: "\u225F", QUOT: '"', quot: '"', rAarr: "\u21DB", race: "\u223D\u0331", Racute: "\u0154", racute: "\u0155", radic: "\u221A", raemptyv: "\u29B3", Rang: "\u27EB", rang: "\u27E9", rangd: "\u2992", range: "\u29A5", rangle: "\u27E9", raquo: "\xBB", Rarr: "\u21A0", rArr: "\u21D2", rarr: "\u2192", rarrap: "\u2975", rarrb: "\u21E5", rarrbfs: "\u2920", rarrc: "\u2933", rarrfs: "\u291E", rarrhk: "\u21AA", rarrlp: "\u21AC", rarrpl: "\u2945", rarrsim: "\u2974", Rarrtl: "\u2916", rarrtl: "\u21A3", rarrw: "\u219D", rAtail: "\u291C", ratail: "\u291A", ratio: "\u2236", rationals: "\u211A", RBarr: "\u2910", rBarr: "\u290F", rbarr: "\u290D", rbbrk: "\u2773", rbrace: "}", rbrack: "]", rbrke: "\u298C", rbrksld: "\u298E", rbrkslu: "\u2990", Rcaron: "\u0158", rcaron: "\u0159", Rcedil: "\u0156", rcedil: "\u0157", rceil: "\u2309", rcub: "}", Rcy: "\u0420", rcy: "\u0440", rdca: "\u2937", rdldhar: "\u2969", rdquo: "\u201D", rdquor: "\u201D", rdsh: "\u21B3", Re: "\u211C", real: "\u211C", realine: "\u211B", realpart: "\u211C", reals: "\u211D", rect: "\u25AD", REG: "\xAE", reg: "\xAE", ReverseElement: "\u220B", ReverseEquilibrium: "\u21CB", ReverseUpEquilibrium: "\u296F", rfisht: "\u297D", rfloor: "\u230B", Rfr: "\u211C", rfr: "\u{1D52F}", rHar: "\u2964", rhard: "\u21C1", rharu: "\u21C0", rharul: "\u296C", Rho: "\u03A1", rho: "\u03C1", rhov: "\u03F1", RightAngleBracket: "\u27E9", RightArrow: "\u2192", Rightarrow: "\u21D2", rightarrow: "\u2192", RightArrowBar: "\u21E5", RightArrowLeftArrow: "\u21C4", rightarrowtail: "\u21A3", RightCeiling: "\u2309", RightDoubleBracket: "\u27E7", RightDownTeeVector: "\u295D", RightDownVector: "\u21C2", RightDownVectorBar: "\u2955", RightFloor: "\u230B", rightharpoondown: "\u21C1", rightharpoonup: "\u21C0", rightleftarrows: "\u21C4", rightleftharpoons: "\u21CC", rightrightarrows: "\u21C9", rightsquigarrow: "\u219D", RightTee: "\u22A2", RightTeeArrow: "\u21A6", RightTeeVector: "\u295B", rightthreetimes: "\u22CC", RightTriangle: "\u22B3", RightTriangleBar: "\u29D0", RightTriangleEqual: "\u22B5", RightUpDownVector: "\u294F", RightUpTeeVector: "\u295C", RightUpVector: "\u21BE", RightUpVectorBar: "\u2954", RightVector: "\u21C0", RightVectorBar: "\u2953", ring: "\u02DA", risingdotseq: "\u2253", rlarr: "\u21C4", rlhar: "\u21CC", rlm: "\u200F", rmoust: "\u23B1", rmoustache: "\u23B1", rnmid: "\u2AEE", roang: "\u27ED", roarr: "\u21FE", robrk: "\u27E7", ropar: "\u2986", Ropf: "\u211D", ropf: "\u{1D563}", roplus: "\u2A2E", rotimes: "\u2A35", RoundImplies: "\u2970", rpar: ")", rpargt: "\u2994", rppolint: "\u2A12", rrarr: "\u21C9", Rrightarrow: "\u21DB", rsaquo: "\u203A", Rscr: "\u211B", rscr: "\u{1D4C7}", Rsh: "\u21B1", rsh: "\u21B1", rsqb: "]", rsquo: "\u2019", rsquor: "\u2019", rthree: "\u22CC", rtimes: "\u22CA", rtri: "\u25B9", rtrie: "\u22B5", rtrif: "\u25B8", rtriltri: "\u29CE", RuleDelayed: "\u29F4", ruluhar: "\u2968", rx: "\u211E", Sacute: "\u015A", sacute: "\u015B", sbquo: "\u201A", Sc: "\u2ABC", sc: "\u227B", scap: "\u2AB8", Scaron: "\u0160", scaron: "\u0161", sccue: "\u227D", scE: "\u2AB4", sce: "\u2AB0", Scedil: "\u015E", scedil: "\u015F", Scirc: "\u015C", scirc: "\u015D", scnap: "\u2ABA", scnE: "\u2AB6", scnsim: "\u22E9", scpolint: "\u2A13", scsim: "\u227F", Scy: "\u0421", scy: "\u0441", sdot: "\u22C5", sdotb: "\u22A1", sdote: "\u2A66", searhk: "\u2925", seArr: "\u21D8", searr: "\u2198", searrow: "\u2198", sect: "\xA7", semi: ";", seswar: "\u2929", setminus: "\u2216", setmn: "\u2216", sext: "\u2736", Sfr: "\u{1D516}", sfr: "\u{1D530}", sfrown: "\u2322", sharp: "\u266F", SHCHcy: "\u0429", shchcy: "\u0449", SHcy: "\u0428", shcy: "\u0448", ShortDownArrow: "\u2193", ShortLeftArrow: "\u2190", shortmid: "\u2223", shortparallel: "\u2225", ShortRightArrow: "\u2192", ShortUpArrow: "\u2191", shy: "\xAD", Sigma: "\u03A3", sigma: "\u03C3", sigmaf: "\u03C2", sigmav: "\u03C2", sim: "\u223C", simdot: "\u2A6A", sime: "\u2243", simeq: "\u2243", simg: "\u2A9E", simgE: "\u2AA0", siml: "\u2A9D", simlE: "\u2A9F", simne: "\u2246", simplus: "\u2A24", simrarr: "\u2972", slarr: "\u2190", SmallCircle: "\u2218", smallsetminus: "\u2216", smashp: "\u2A33", smeparsl: "\u29E4", smid: "\u2223", smile: "\u2323", smt: "\u2AAA", smte: "\u2AAC", smtes: "\u2AAC\uFE00", SOFTcy: "\u042C", softcy: "\u044C", sol: "/", solb: "\u29C4", solbar: "\u233F", Sopf: "\u{1D54A}", sopf: "\u{1D564}", spades: "\u2660", spadesuit: "\u2660", spar: "\u2225", sqcap: "\u2293", sqcaps: "\u2293\uFE00", sqcup: "\u2294", sqcups: "\u2294\uFE00", Sqrt: "\u221A", sqsub: "\u228F", sqsube: "\u2291", sqsubset: "\u228F", sqsubseteq: "\u2291", sqsup: "\u2290", sqsupe: "\u2292", sqsupset: "\u2290", sqsupseteq: "\u2292", squ: "\u25A1", Square: "\u25A1", square: "\u25A1", SquareIntersection: "\u2293", SquareSubset: "\u228F", SquareSubsetEqual: "\u2291", SquareSuperset: "\u2290", SquareSupersetEqual: "\u2292", SquareUnion: "\u2294", squarf: "\u25AA", squf: "\u25AA", srarr: "\u2192", Sscr: "\u{1D4AE}", sscr: "\u{1D4C8}", ssetmn: "\u2216", ssmile: "\u2323", sstarf: "\u22C6", Star: "\u22C6", star: "\u2606", starf: "\u2605", straightepsilon: "\u03F5", straightphi: "\u03D5", strns: "\xAF", Sub: "\u22D0", sub: "\u2282", subdot: "\u2ABD", subE: "\u2AC5", sube: "\u2286", subedot: "\u2AC3", submult: "\u2AC1", subnE: "\u2ACB", subne: "\u228A", subplus: "\u2ABF", subrarr: "\u2979", Subset: "\u22D0", subset: "\u2282", subseteq: "\u2286", subseteqq: "\u2AC5", SubsetEqual: "\u2286", subsetneq: "\u228A", subsetneqq: "\u2ACB", subsim: "\u2AC7", subsub: "\u2AD5", subsup: "\u2AD3", succ: "\u227B", succapprox: "\u2AB8", succcurlyeq: "\u227D", Succeeds: "\u227B", SucceedsEqual: "\u2AB0", SucceedsSlantEqual: "\u227D", SucceedsTilde: "\u227F", succeq: "\u2AB0", succnapprox: "\u2ABA", succneqq: "\u2AB6", succnsim: "\u22E9", succsim: "\u227F", SuchThat: "\u220B", Sum: "\u2211", sum: "\u2211", sung: "\u266A", Sup: "\u22D1", sup: "\u2283", sup1: "\xB9", sup2: "\xB2", sup3: "\xB3", supdot: "\u2ABE", supdsub: "\u2AD8", supE: "\u2AC6", supe: "\u2287", supedot: "\u2AC4", Superset: "\u2283", SupersetEqual: "\u2287", suphsol: "\u27C9", suphsub: "\u2AD7", suplarr: "\u297B", supmult: "\u2AC2", supnE: "\u2ACC", supne: "\u228B", supplus: "\u2AC0", Supset: "\u22D1", supset: "\u2283", supseteq: "\u2287", supseteqq: "\u2AC6", supsetneq: "\u228B", supsetneqq: "\u2ACC", supsim: "\u2AC8", supsub: "\u2AD4", supsup: "\u2AD6", swarhk: "\u2926", swArr: "\u21D9", swarr: "\u2199", swarrow: "\u2199", swnwar: "\u292A", szlig: "\xDF", Tab: "	", target: "\u2316", Tau: "\u03A4", tau: "\u03C4", tbrk: "\u23B4", Tcaron: "\u0164", tcaron: "\u0165", Tcedil: "\u0162", tcedil: "\u0163", Tcy: "\u0422", tcy: "\u0442", tdot: "\u20DB", telrec: "\u2315", Tfr: "\u{1D517}", tfr: "\u{1D531}", there4: "\u2234", Therefore: "\u2234", therefore: "\u2234", Theta: "\u0398", theta: "\u03B8", thetasym: "\u03D1", thetav: "\u03D1", thickapprox: "\u2248", thicksim: "\u223C", ThickSpace: "\u205F\u200A", thinsp: "\u2009", ThinSpace: "\u2009", thkap: "\u2248", thksim: "\u223C", THORN: "\xDE", thorn: "\xFE", Tilde: "\u223C", tilde: "\u02DC", TildeEqual: "\u2243", TildeFullEqual: "\u2245", TildeTilde: "\u2248", times: "\xD7", timesb: "\u22A0", timesbar: "\u2A31", timesd: "\u2A30", tint: "\u222D", toea: "\u2928", top: "\u22A4", topbot: "\u2336", topcir: "\u2AF1", Topf: "\u{1D54B}", topf: "\u{1D565}", topfork: "\u2ADA", tosa: "\u2929", tprime: "\u2034", TRADE: "\u2122", trade: "\u2122", triangle: "\u25B5", triangledown: "\u25BF", triangleleft: "\u25C3", trianglelefteq: "\u22B4", triangleq: "\u225C", triangleright: "\u25B9", trianglerighteq: "\u22B5", tridot: "\u25EC", trie: "\u225C", triminus: "\u2A3A", TripleDot: "\u20DB", triplus: "\u2A39", trisb: "\u29CD", tritime: "\u2A3B", trpezium: "\u23E2", Tscr: "\u{1D4AF}", tscr: "\u{1D4C9}", TScy: "\u0426", tscy: "\u0446", TSHcy: "\u040B", tshcy: "\u045B", Tstrok: "\u0166", tstrok: "\u0167", twixt: "\u226C", twoheadleftarrow: "\u219E", twoheadrightarrow: "\u21A0", Uacute: "\xDA", uacute: "\xFA", Uarr: "\u219F", uArr: "\u21D1", uarr: "\u2191", Uarrocir: "\u2949", Ubrcy: "\u040E", ubrcy: "\u045E", Ubreve: "\u016C", ubreve: "\u016D", Ucirc: "\xDB", ucirc: "\xFB", Ucy: "\u0423", ucy: "\u0443", udarr: "\u21C5", Udblac: "\u0170", udblac: "\u0171", udhar: "\u296E", ufisht: "\u297E", Ufr: "\u{1D518}", ufr: "\u{1D532}", Ugrave: "\xD9", ugrave: "\xF9", uHar: "\u2963", uharl: "\u21BF", uharr: "\u21BE", uhblk: "\u2580", ulcorn: "\u231C", ulcorner: "\u231C", ulcrop: "\u230F", ultri: "\u25F8", Umacr: "\u016A", umacr: "\u016B", uml: "\xA8", UnderBar: "_", UnderBrace: "\u23DF", UnderBracket: "\u23B5", UnderParenthesis: "\u23DD", Union: "\u22C3", UnionPlus: "\u228E", Uogon: "\u0172", uogon: "\u0173", Uopf: "\u{1D54C}", uopf: "\u{1D566}", UpArrow: "\u2191", Uparrow: "\u21D1", uparrow: "\u2191", UpArrowBar: "\u2912", UpArrowDownArrow: "\u21C5", UpDownArrow: "\u2195", Updownarrow: "\u21D5", updownarrow: "\u2195", UpEquilibrium: "\u296E", upharpoonleft: "\u21BF", upharpoonright: "\u21BE", uplus: "\u228E", UpperLeftArrow: "\u2196", UpperRightArrow: "\u2197", Upsi: "\u03D2", upsi: "\u03C5", upsih: "\u03D2", Upsilon: "\u03A5", upsilon: "\u03C5", UpTee: "\u22A5", UpTeeArrow: "\u21A5", upuparrows: "\u21C8", urcorn: "\u231D", urcorner: "\u231D", urcrop: "\u230E", Uring: "\u016E", uring: "\u016F", urtri: "\u25F9", Uscr: "\u{1D4B0}", uscr: "\u{1D4CA}", utdot: "\u22F0", Utilde: "\u0168", utilde: "\u0169", utri: "\u25B5", utrif: "\u25B4", uuarr: "\u21C8", Uuml: "\xDC", uuml: "\xFC", uwangle: "\u29A7", vangrt: "\u299C", varepsilon: "\u03F5", varkappa: "\u03F0", varnothing: "\u2205", varphi: "\u03D5", varpi: "\u03D6", varpropto: "\u221D", vArr: "\u21D5", varr: "\u2195", varrho: "\u03F1", varsigma: "\u03C2", varsubsetneq: "\u228A\uFE00", varsubsetneqq: "\u2ACB\uFE00", varsupsetneq: "\u228B\uFE00", varsupsetneqq: "\u2ACC\uFE00", vartheta: "\u03D1", vartriangleleft: "\u22B2", vartriangleright: "\u22B3", Vbar: "\u2AEB", vBar: "\u2AE8", vBarv: "\u2AE9", Vcy: "\u0412", vcy: "\u0432", VDash: "\u22AB", Vdash: "\u22A9", vDash: "\u22A8", vdash: "\u22A2", Vdashl: "\u2AE6", Vee: "\u22C1", vee: "\u2228", veebar: "\u22BB", veeeq: "\u225A", vellip: "\u22EE", Verbar: "\u2016", verbar: "|", Vert: "\u2016", vert: "|", VerticalBar: "\u2223", VerticalLine: "|", VerticalSeparator: "\u2758", VerticalTilde: "\u2240", VeryThinSpace: "\u200A", Vfr: "\u{1D519}", vfr: "\u{1D533}", vltri: "\u22B2", vnsub: "\u2282\u20D2", vnsup: "\u2283\u20D2", Vopf: "\u{1D54D}", vopf: "\u{1D567}", vprop: "\u221D", vrtri: "\u22B3", Vscr: "\u{1D4B1}", vscr: "\u{1D4CB}", vsubnE: "\u2ACB\uFE00", vsubne: "\u228A\uFE00", vsupnE: "\u2ACC\uFE00", vsupne: "\u228B\uFE00", Vvdash: "\u22AA", vzigzag: "\u299A", Wcirc: "\u0174", wcirc: "\u0175", wedbar: "\u2A5F", Wedge: "\u22C0", wedge: "\u2227", wedgeq: "\u2259", weierp: "\u2118", Wfr: "\u{1D51A}", wfr: "\u{1D534}", Wopf: "\u{1D54E}", wopf: "\u{1D568}", wp: "\u2118", wr: "\u2240", wreath: "\u2240", Wscr: "\u{1D4B2}", wscr: "\u{1D4CC}", xcap: "\u22C2", xcirc: "\u25EF", xcup: "\u22C3", xdtri: "\u25BD", Xfr: "\u{1D51B}", xfr: "\u{1D535}", xhArr: "\u27FA", xharr: "\u27F7", Xi: "\u039E", xi: "\u03BE", xlArr: "\u27F8", xlarr: "\u27F5", xmap: "\u27FC", xnis: "\u22FB", xodot: "\u2A00", Xopf: "\u{1D54F}", xopf: "\u{1D569}", xoplus: "\u2A01", xotime: "\u2A02", xrArr: "\u27F9", xrarr: "\u27F6", Xscr: "\u{1D4B3}", xscr: "\u{1D4CD}", xsqcup: "\u2A06", xuplus: "\u2A04", xutri: "\u25B3", xvee: "\u22C1", xwedge: "\u22C0", Yacute: "\xDD", yacute: "\xFD", YAcy: "\u042F", yacy: "\u044F", Ycirc: "\u0176", ycirc: "\u0177", Ycy: "\u042B", ycy: "\u044B", yen: "\xA5", Yfr: "\u{1D51C}", yfr: "\u{1D536}", YIcy: "\u0407", yicy: "\u0457", Yopf: "\u{1D550}", yopf: "\u{1D56A}", Yscr: "\u{1D4B4}", yscr: "\u{1D4CE}", YUcy: "\u042E", yucy: "\u044E", Yuml: "\u0178", yuml: "\xFF", Zacute: "\u0179", zacute: "\u017A", Zcaron: "\u017D", zcaron: "\u017E", Zcy: "\u0417", zcy: "\u0437", Zdot: "\u017B", zdot: "\u017C", zeetrf: "\u2128", ZeroWidthSpace: "\u200B", Zeta: "\u0396", zeta: "\u03B6", Zfr: "\u2128", zfr: "\u{1D537}", ZHcy: "\u0416", zhcy: "\u0436", zigrarr: "\u21DD", Zopf: "\u2124", zopf: "\u{1D56B}", Zscr: "\u{1D4B5}", zscr: "\u{1D4CF}", zwj: "\u200D", zwnj: "\u200C" }, e2.NGSP_UNICODE = "\uE500", e2.NAMED_ENTITIES.ngsp = e2.NGSP_UNICODE;
        } }), _s = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/html_tags.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = Ze(), t2 = class {
            constructor() {
              let { closedByChildren: a, implicitNamespacePrefix: p, contentType: D = r2.TagContentType.PARSABLE_DATA, closedByParent: g = false, isVoid: i2 = false, ignoreFirstLf: l = false } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
              this.closedByChildren = {}, this.closedByParent = false, this.canSelfClose = false, a && a.length > 0 && a.forEach((h2) => this.closedByChildren[h2] = true), this.isVoid = i2, this.closedByParent = g || i2, this.implicitNamespacePrefix = p || null, this.contentType = D, this.ignoreFirstLf = l;
            }
            isClosedByChild(a) {
              return this.isVoid || a.toLowerCase() in this.closedByChildren;
            }
          };
          e2.HtmlTagDefinition = t2;
          var s2, c;
          function n(a) {
            return c || (s2 = new t2(), c = { base: new t2({ isVoid: true }), meta: new t2({ isVoid: true }), area: new t2({ isVoid: true }), embed: new t2({ isVoid: true }), link: new t2({ isVoid: true }), img: new t2({ isVoid: true }), input: new t2({ isVoid: true }), param: new t2({ isVoid: true }), hr: new t2({ isVoid: true }), br: new t2({ isVoid: true }), source: new t2({ isVoid: true }), track: new t2({ isVoid: true }), wbr: new t2({ isVoid: true }), p: new t2({ closedByChildren: ["address", "article", "aside", "blockquote", "div", "dl", "fieldset", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "header", "hgroup", "hr", "main", "nav", "ol", "p", "pre", "section", "table", "ul"], closedByParent: true }), thead: new t2({ closedByChildren: ["tbody", "tfoot"] }), tbody: new t2({ closedByChildren: ["tbody", "tfoot"], closedByParent: true }), tfoot: new t2({ closedByChildren: ["tbody"], closedByParent: true }), tr: new t2({ closedByChildren: ["tr"], closedByParent: true }), td: new t2({ closedByChildren: ["td", "th"], closedByParent: true }), th: new t2({ closedByChildren: ["td", "th"], closedByParent: true }), col: new t2({ isVoid: true }), svg: new t2({ implicitNamespacePrefix: "svg" }), math: new t2({ implicitNamespacePrefix: "math" }), li: new t2({ closedByChildren: ["li"], closedByParent: true }), dt: new t2({ closedByChildren: ["dt", "dd"] }), dd: new t2({ closedByChildren: ["dt", "dd"], closedByParent: true }), rb: new t2({ closedByChildren: ["rb", "rt", "rtc", "rp"], closedByParent: true }), rt: new t2({ closedByChildren: ["rb", "rt", "rtc", "rp"], closedByParent: true }), rtc: new t2({ closedByChildren: ["rb", "rtc", "rp"], closedByParent: true }), rp: new t2({ closedByChildren: ["rb", "rt", "rtc", "rp"], closedByParent: true }), optgroup: new t2({ closedByChildren: ["optgroup"], closedByParent: true }), option: new t2({ closedByChildren: ["option", "optgroup"], closedByParent: true }), pre: new t2({ ignoreFirstLf: true }), listing: new t2({ ignoreFirstLf: true }), style: new t2({ contentType: r2.TagContentType.RAW_TEXT }), script: new t2({ contentType: r2.TagContentType.RAW_TEXT }), title: new t2({ contentType: r2.TagContentType.ESCAPABLE_RAW_TEXT }), textarea: new t2({ contentType: r2.TagContentType.ESCAPABLE_RAW_TEXT, ignoreFirstLf: true }) }), c[a] || s2;
          }
          e2.getHtmlTagDefinition = n;
        } }), VD = I({ "node_modules/angular-html-parser/lib/compiler/src/ast_path.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = class {
            constructor(t2) {
              let s2 = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : -1;
              this.path = t2, this.position = s2;
            }
            get empty() {
              return !this.path || !this.path.length;
            }
            get head() {
              return this.path[0];
            }
            get tail() {
              return this.path[this.path.length - 1];
            }
            parentOf(t2) {
              return t2 && this.path[this.path.indexOf(t2) - 1];
            }
            childOf(t2) {
              return this.path[this.path.indexOf(t2) + 1];
            }
            first(t2) {
              for (let s2 = this.path.length - 1; s2 >= 0; s2--) {
                let c = this.path[s2];
                if (c instanceof t2)
                  return c;
              }
            }
            push(t2) {
              this.path.push(t2);
            }
            pop() {
              return this.path.pop();
            }
          };
          e2.AstPath = r2;
        } }), Ss = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/ast.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = VD(), t2 = class {
            constructor(d, m2, T) {
              this.value = d, this.sourceSpan = m2, this.i18n = T, this.type = "text";
            }
            visit(d, m2) {
              return d.visitText(this, m2);
            }
          };
          e2.Text = t2;
          var s2 = class {
            constructor(d, m2) {
              this.value = d, this.sourceSpan = m2, this.type = "cdata";
            }
            visit(d, m2) {
              return d.visitCdata(this, m2);
            }
          };
          e2.CDATA = s2;
          var c = class {
            constructor(d, m2, T, B, A2, N) {
              this.switchValue = d, this.type = m2, this.cases = T, this.sourceSpan = B, this.switchValueSourceSpan = A2, this.i18n = N;
            }
            visit(d, m2) {
              return d.visitExpansion(this, m2);
            }
          };
          e2.Expansion = c;
          var n = class {
            constructor(d, m2, T, B, A2) {
              this.value = d, this.expression = m2, this.sourceSpan = T, this.valueSourceSpan = B, this.expSourceSpan = A2;
            }
            visit(d, m2) {
              return d.visitExpansionCase(this, m2);
            }
          };
          e2.ExpansionCase = n;
          var a = class {
            constructor(d, m2, T) {
              let B = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : null, A2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : null, N = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : null;
              this.name = d, this.value = m2, this.sourceSpan = T, this.valueSpan = B, this.nameSpan = A2, this.i18n = N, this.type = "attribute";
            }
            visit(d, m2) {
              return d.visitAttribute(this, m2);
            }
          };
          e2.Attribute = a;
          var p = class {
            constructor(d, m2, T, B) {
              let A2 = arguments.length > 4 && arguments[4] !== void 0 ? arguments[4] : null, N = arguments.length > 5 && arguments[5] !== void 0 ? arguments[5] : null, R = arguments.length > 6 && arguments[6] !== void 0 ? arguments[6] : null, $ = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : null;
              this.name = d, this.attrs = m2, this.children = T, this.sourceSpan = B, this.startSourceSpan = A2, this.endSourceSpan = N, this.nameSpan = R, this.i18n = $, this.type = "element";
            }
            visit(d, m2) {
              return d.visitElement(this, m2);
            }
          };
          e2.Element = p;
          var D = class {
            constructor(d, m2) {
              this.value = d, this.sourceSpan = m2, this.type = "comment";
            }
            visit(d, m2) {
              return d.visitComment(this, m2);
            }
          };
          e2.Comment = D;
          var g = class {
            constructor(d, m2) {
              this.value = d, this.sourceSpan = m2, this.type = "docType";
            }
            visit(d, m2) {
              return d.visitDocType(this, m2);
            }
          };
          e2.DocType = g;
          function i2(d, m2) {
            let T = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, B = [], A2 = d.visit ? (N) => d.visit(N, T) || N.visit(d, T) : (N) => N.visit(d, T);
            return m2.forEach((N) => {
              let R = A2(N);
              R && B.push(R);
            }), B;
          }
          e2.visitAll = i2;
          var l = class {
            constructor() {
            }
            visitElement(d, m2) {
              this.visitChildren(m2, (T) => {
                T(d.attrs), T(d.children);
              });
            }
            visitAttribute(d, m2) {
            }
            visitText(d, m2) {
            }
            visitCdata(d, m2) {
            }
            visitComment(d, m2) {
            }
            visitDocType(d, m2) {
            }
            visitExpansion(d, m2) {
              return this.visitChildren(m2, (T) => {
                T(d.cases);
              });
            }
            visitExpansionCase(d, m2) {
            }
            visitChildren(d, m2) {
              let T = [], B = this;
              function A2(N) {
                N && T.push(i2(B, N, d));
              }
              return m2(A2), Array.prototype.concat.apply([], T);
            }
          };
          e2.RecursiveVisitor = l;
          function h2(d) {
            let m2 = d.sourceSpan.start.offset, T = d.sourceSpan.end.offset;
            return d instanceof p && (d.endSourceSpan ? T = d.endSourceSpan.end.offset : d.children && d.children.length && (T = h2(d.children[d.children.length - 1]).end)), { start: m2, end: T };
          }
          function C(d, m2) {
            let T = [], B = new class extends l {
              visit(A2, N) {
                let R = h2(A2);
                if (R.start <= m2 && m2 < R.end)
                  T.push(A2);
                else
                  return true;
              }
            }();
            return i2(B, d), new r2.AstPath(T, m2);
          }
          e2.findNode = C;
        } }), XD = I({ "node_modules/angular-html-parser/lib/compiler/src/assertions.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          function r2(c, n) {
            if (n != null) {
              if (!Array.isArray(n))
                throw new Error("Expected '".concat(c, "' to be an array of strings."));
              for (let a = 0; a < n.length; a += 1)
                if (typeof n[a] != "string")
                  throw new Error("Expected '".concat(c, "' to be an array of strings."));
            }
          }
          e2.assertArrayOfStrings = r2;
          var t2 = [/^\s*$/, /[<>]/, /^[{}]$/, /&(#|[a-z])/i, /^\/\//];
          function s2(c, n) {
            if (n != null && !(Array.isArray(n) && n.length == 2))
              throw new Error("Expected '".concat(c, "' to be an array, [start, end]."));
            if (n != null) {
              let a = n[0], p = n[1];
              t2.forEach((D) => {
                if (D.test(a) || D.test(p))
                  throw new Error("['".concat(a, "', '").concat(p, "'] contains unusable interpolation symbol."));
              });
            }
          }
          e2.assertInterpolationSymbols = s2;
        } }), HD = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/interpolation_config.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = XD(), t2 = class {
            constructor(s2, c) {
              this.start = s2, this.end = c;
            }
            static fromArray(s2) {
              return s2 ? (r2.assertInterpolationSymbols("interpolation", s2), new t2(s2[0], s2[1])) : e2.DEFAULT_INTERPOLATION_CONFIG;
            }
          };
          e2.InterpolationConfig = t2, e2.DEFAULT_INTERPOLATION_CONFIG = new t2("{{", "}}");
        } }), zD = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/lexer.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = hs(), t2 = Te(), s2 = HD(), c = Ze(), n;
          (function(u) {
            u[u.TAG_OPEN_START = 0] = "TAG_OPEN_START", u[u.TAG_OPEN_END = 1] = "TAG_OPEN_END", u[u.TAG_OPEN_END_VOID = 2] = "TAG_OPEN_END_VOID", u[u.TAG_CLOSE = 3] = "TAG_CLOSE", u[u.TEXT = 4] = "TEXT", u[u.ESCAPABLE_RAW_TEXT = 5] = "ESCAPABLE_RAW_TEXT", u[u.RAW_TEXT = 6] = "RAW_TEXT", u[u.COMMENT_START = 7] = "COMMENT_START", u[u.COMMENT_END = 8] = "COMMENT_END", u[u.CDATA_START = 9] = "CDATA_START", u[u.CDATA_END = 10] = "CDATA_END", u[u.ATTR_NAME = 11] = "ATTR_NAME", u[u.ATTR_QUOTE = 12] = "ATTR_QUOTE", u[u.ATTR_VALUE = 13] = "ATTR_VALUE", u[u.DOC_TYPE_START = 14] = "DOC_TYPE_START", u[u.DOC_TYPE_END = 15] = "DOC_TYPE_END", u[u.EXPANSION_FORM_START = 16] = "EXPANSION_FORM_START", u[u.EXPANSION_CASE_VALUE = 17] = "EXPANSION_CASE_VALUE", u[u.EXPANSION_CASE_EXP_START = 18] = "EXPANSION_CASE_EXP_START", u[u.EXPANSION_CASE_EXP_END = 19] = "EXPANSION_CASE_EXP_END", u[u.EXPANSION_FORM_END = 20] = "EXPANSION_FORM_END", u[u.EOF = 21] = "EOF";
          })(n = e2.TokenType || (e2.TokenType = {}));
          var a = class {
            constructor(u, o, E) {
              this.type = u, this.parts = o, this.sourceSpan = E;
            }
          };
          e2.Token = a;
          var p = class extends t2.ParseError {
            constructor(u, o, E) {
              super(E, u), this.tokenType = o;
            }
          };
          e2.TokenError = p;
          var D = class {
            constructor(u, o) {
              this.tokens = u, this.errors = o;
            }
          };
          e2.TokenizeResult = D;
          function g(u, o, E) {
            let f3 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : {};
            return new d(new t2.ParseSourceFile(u, o), E, f3).tokenize();
          }
          e2.tokenize = g;
          var i2 = /\r\n?/g;
          function l(u) {
            let o = u === r2.$EOF ? "EOF" : String.fromCharCode(u);
            return 'Unexpected character "'.concat(o, '"');
          }
          function h2(u) {
            return 'Unknown entity "'.concat(u, '" - use the "&#<decimal>;" or  "&#x<hex>;" syntax');
          }
          var C = class {
            constructor(u) {
              this.error = u;
            }
          }, d = class {
            constructor(u, o, E) {
              this._getTagContentType = o, this._currentTokenStart = null, this._currentTokenType = null, this._expansionCaseStack = [], this._inInterpolation = false, this._fullNameStack = [], this.tokens = [], this.errors = [], this._tokenizeIcu = E.tokenizeExpansionForms || false, this._interpolationConfig = E.interpolationConfig || s2.DEFAULT_INTERPOLATION_CONFIG, this._leadingTriviaCodePoints = E.leadingTriviaChars && E.leadingTriviaChars.map((F2) => F2.codePointAt(0) || 0), this._canSelfClose = E.canSelfClose || false, this._allowHtmComponentClosingTags = E.allowHtmComponentClosingTags || false;
              let f3 = E.range || { endPos: u.content.length, startPos: 0, startLine: 0, startCol: 0 };
              this._cursor = E.escapedString ? new k(u, f3) : new x2(u, f3);
              try {
                this._cursor.init();
              } catch (F2) {
                this.handleError(F2);
              }
            }
            _processCarriageReturns(u) {
              return u.replace(i2, `
`);
            }
            tokenize() {
              for (; this._cursor.peek() !== r2.$EOF; ) {
                let u = this._cursor.clone();
                try {
                  if (this._attemptCharCode(r2.$LT))
                    if (this._attemptCharCode(r2.$BANG))
                      this._attemptStr("[CDATA[") ? this._consumeCdata(u) : this._attemptStr("--") ? this._consumeComment(u) : this._attemptStrCaseInsensitive("doctype") ? this._consumeDocType(u) : this._consumeBogusComment(u);
                    else if (this._attemptCharCode(r2.$SLASH))
                      this._consumeTagClose(u);
                    else {
                      let o = this._cursor.clone();
                      this._attemptCharCode(r2.$QUESTION) ? (this._cursor = o, this._consumeBogusComment(u)) : this._consumeTagOpen(u);
                    }
                  else
                    this._tokenizeIcu && this._tokenizeExpansionForm() || this._consumeText();
                } catch (o) {
                  this.handleError(o);
                }
              }
              return this._beginToken(n.EOF), this._endToken([]), new D(O(this.tokens), this.errors);
            }
            _tokenizeExpansionForm() {
              if (this.isExpansionFormStart())
                return this._consumeExpansionFormStart(), true;
              if (R(this._cursor.peek()) && this._isInExpansionForm())
                return this._consumeExpansionCaseStart(), true;
              if (this._cursor.peek() === r2.$RBRACE) {
                if (this._isInExpansionCase())
                  return this._consumeExpansionCaseEnd(), true;
                if (this._isInExpansionForm())
                  return this._consumeExpansionFormEnd(), true;
              }
              return false;
            }
            _beginToken(u) {
              let o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this._cursor.clone();
              this._currentTokenStart = o, this._currentTokenType = u;
            }
            _endToken(u) {
              let o = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : this._cursor.clone();
              if (this._currentTokenStart === null)
                throw new p("Programming error - attempted to end a token when there was no start to the token", this._currentTokenType, this._cursor.getSpan(o));
              if (this._currentTokenType === null)
                throw new p("Programming error - attempted to end a token which has no token type", null, this._cursor.getSpan(this._currentTokenStart));
              let E = new a(this._currentTokenType, u, this._cursor.getSpan(this._currentTokenStart, this._leadingTriviaCodePoints));
              return this.tokens.push(E), this._currentTokenStart = null, this._currentTokenType = null, E;
            }
            _createError(u, o) {
              this._isInExpansionForm() && (u += ` (Do you have an unescaped "{" in your template? Use "{{ '{' }}") to escape it.)`);
              let E = new p(u, this._currentTokenType, o);
              return this._currentTokenStart = null, this._currentTokenType = null, new C(E);
            }
            handleError(u) {
              if (u instanceof M && (u = this._createError(u.msg, this._cursor.getSpan(u.cursor))), u instanceof C)
                this.errors.push(u.error);
              else
                throw u;
            }
            _attemptCharCode(u) {
              return this._cursor.peek() === u ? (this._cursor.advance(), true) : false;
            }
            _attemptCharCodeCaseInsensitive(u) {
              return $(this._cursor.peek(), u) ? (this._cursor.advance(), true) : false;
            }
            _requireCharCode(u) {
              let o = this._cursor.clone();
              if (!this._attemptCharCode(u))
                throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(o));
            }
            _attemptStr(u) {
              let o = u.length;
              if (this._cursor.charsLeft() < o)
                return false;
              let E = this._cursor.clone();
              for (let f3 = 0; f3 < o; f3++)
                if (!this._attemptCharCode(u.charCodeAt(f3)))
                  return this._cursor = E, false;
              return true;
            }
            _attemptStrCaseInsensitive(u) {
              for (let o = 0; o < u.length; o++)
                if (!this._attemptCharCodeCaseInsensitive(u.charCodeAt(o)))
                  return false;
              return true;
            }
            _requireStr(u) {
              let o = this._cursor.clone();
              if (!this._attemptStr(u))
                throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(o));
            }
            _requireStrCaseInsensitive(u) {
              let o = this._cursor.clone();
              if (!this._attemptStrCaseInsensitive(u))
                throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(o));
            }
            _attemptCharCodeUntilFn(u) {
              for (; !u(this._cursor.peek()); )
                this._cursor.advance();
            }
            _requireCharCodeUntilFn(u, o) {
              let E = this._cursor.clone();
              if (this._attemptCharCodeUntilFn(u), this._cursor.clone().diff(E) < o)
                throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(E));
            }
            _attemptUntilChar(u) {
              for (; this._cursor.peek() !== u; )
                this._cursor.advance();
            }
            _readChar(u) {
              if (u && this._cursor.peek() === r2.$AMPERSAND)
                return this._decodeEntity();
              {
                let o = String.fromCodePoint(this._cursor.peek());
                return this._cursor.advance(), o;
              }
            }
            _decodeEntity() {
              let u = this._cursor.clone();
              if (this._cursor.advance(), this._attemptCharCode(r2.$HASH)) {
                let o = this._attemptCharCode(r2.$x) || this._attemptCharCode(r2.$X), E = this._cursor.clone();
                if (this._attemptCharCodeUntilFn(A2), this._cursor.peek() != r2.$SEMICOLON)
                  throw this._createError(l(this._cursor.peek()), this._cursor.getSpan());
                let f3 = this._cursor.getChars(E);
                this._cursor.advance();
                try {
                  let F2 = parseInt(f3, o ? 16 : 10);
                  return String.fromCharCode(F2);
                } catch {
                  throw this._createError(h2(this._cursor.getChars(u)), this._cursor.getSpan());
                }
              } else {
                let o = this._cursor.clone();
                if (this._attemptCharCodeUntilFn(N), this._cursor.peek() != r2.$SEMICOLON)
                  return this._cursor = o, "&";
                let E = this._cursor.getChars(o);
                this._cursor.advance();
                let f3 = c.NAMED_ENTITIES[E];
                if (!f3)
                  throw this._createError(h2(E), this._cursor.getSpan(u));
                return f3;
              }
            }
            _consumeRawText(u, o) {
              this._beginToken(u ? n.ESCAPABLE_RAW_TEXT : n.RAW_TEXT);
              let E = [];
              for (; ; ) {
                let f3 = this._cursor.clone(), F2 = o();
                if (this._cursor = f3, F2)
                  break;
                E.push(this._readChar(u));
              }
              return this._endToken([this._processCarriageReturns(E.join(""))]);
            }
            _consumeComment(u) {
              this._beginToken(n.COMMENT_START, u), this._endToken([]), this._consumeRawText(false, () => this._attemptStr("-->")), this._beginToken(n.COMMENT_END), this._requireStr("-->"), this._endToken([]);
            }
            _consumeBogusComment(u) {
              this._beginToken(n.COMMENT_START, u), this._endToken([]), this._consumeRawText(false, () => this._cursor.peek() === r2.$GT), this._beginToken(n.COMMENT_END), this._cursor.advance(), this._endToken([]);
            }
            _consumeCdata(u) {
              this._beginToken(n.CDATA_START, u), this._endToken([]), this._consumeRawText(false, () => this._attemptStr("]]>")), this._beginToken(n.CDATA_END), this._requireStr("]]>"), this._endToken([]);
            }
            _consumeDocType(u) {
              this._beginToken(n.DOC_TYPE_START, u), this._endToken([]), this._consumeRawText(false, () => this._cursor.peek() === r2.$GT), this._beginToken(n.DOC_TYPE_END), this._cursor.advance(), this._endToken([]);
            }
            _consumePrefixAndName() {
              let u = this._cursor.clone(), o = "";
              for (; this._cursor.peek() !== r2.$COLON && !B(this._cursor.peek()); )
                this._cursor.advance();
              let E;
              this._cursor.peek() === r2.$COLON ? (o = this._cursor.getChars(u), this._cursor.advance(), E = this._cursor.clone()) : E = u, this._requireCharCodeUntilFn(T, o === "" ? 0 : 1);
              let f3 = this._cursor.getChars(E);
              return [o, f3];
            }
            _consumeTagOpen(u) {
              let o, E, f3, F2 = this.tokens.length, P = this._cursor.clone(), j = [];
              try {
                if (!r2.isAsciiLetter(this._cursor.peek()))
                  throw this._createError(l(this._cursor.peek()), this._cursor.getSpan(u));
                for (f3 = this._consumeTagOpenStart(u), E = f3.parts[0], o = f3.parts[1], this._attemptCharCodeUntilFn(m2); this._cursor.peek() !== r2.$SLASH && this._cursor.peek() !== r2.$GT; ) {
                  let [X, H] = this._consumeAttributeName();
                  if (this._attemptCharCodeUntilFn(m2), this._attemptCharCode(r2.$EQ)) {
                    this._attemptCharCodeUntilFn(m2);
                    let z = this._consumeAttributeValue();
                    j.push({ prefix: X, name: H, value: z });
                  } else
                    j.push({ prefix: X, name: H });
                  this._attemptCharCodeUntilFn(m2);
                }
                this._consumeTagOpenEnd();
              } catch (X) {
                if (X instanceof C) {
                  this._cursor = P, f3 && (this.tokens.length = F2), this._beginToken(n.TEXT, u), this._endToken(["<"]);
                  return;
                }
                throw X;
              }
              if (this._canSelfClose && this.tokens[this.tokens.length - 1].type === n.TAG_OPEN_END_VOID)
                return;
              let W = this._getTagContentType(o, E, this._fullNameStack.length > 0, j);
              this._handleFullNameStackForTagOpen(E, o), W === c.TagContentType.RAW_TEXT ? this._consumeRawTextWithTagClose(E, o, false) : W === c.TagContentType.ESCAPABLE_RAW_TEXT && this._consumeRawTextWithTagClose(E, o, true);
            }
            _consumeRawTextWithTagClose(u, o, E) {
              let f3 = this._consumeRawText(E, () => !this._attemptCharCode(r2.$LT) || !this._attemptCharCode(r2.$SLASH) || (this._attemptCharCodeUntilFn(m2), !this._attemptStrCaseInsensitive(u ? "".concat(u, ":").concat(o) : o)) ? false : (this._attemptCharCodeUntilFn(m2), this._attemptCharCode(r2.$GT)));
              this._beginToken(n.TAG_CLOSE), this._requireCharCodeUntilFn((F2) => F2 === r2.$GT, 3), this._cursor.advance(), this._endToken([u, o]), this._handleFullNameStackForTagClose(u, o);
            }
            _consumeTagOpenStart(u) {
              this._beginToken(n.TAG_OPEN_START, u);
              let o = this._consumePrefixAndName();
              return this._endToken(o);
            }
            _consumeAttributeName() {
              let u = this._cursor.peek();
              if (u === r2.$SQ || u === r2.$DQ)
                throw this._createError(l(u), this._cursor.getSpan());
              this._beginToken(n.ATTR_NAME);
              let o = this._consumePrefixAndName();
              return this._endToken(o), o;
            }
            _consumeAttributeValue() {
              let u;
              if (this._cursor.peek() === r2.$SQ || this._cursor.peek() === r2.$DQ) {
                this._beginToken(n.ATTR_QUOTE);
                let o = this._cursor.peek();
                this._cursor.advance(), this._endToken([String.fromCodePoint(o)]), this._beginToken(n.ATTR_VALUE);
                let E = [];
                for (; this._cursor.peek() !== o; )
                  E.push(this._readChar(true));
                u = this._processCarriageReturns(E.join("")), this._endToken([u]), this._beginToken(n.ATTR_QUOTE), this._cursor.advance(), this._endToken([String.fromCodePoint(o)]);
              } else {
                this._beginToken(n.ATTR_VALUE);
                let o = this._cursor.clone();
                this._requireCharCodeUntilFn(T, 1), u = this._processCarriageReturns(this._cursor.getChars(o)), this._endToken([u]);
              }
              return u;
            }
            _consumeTagOpenEnd() {
              let u = this._attemptCharCode(r2.$SLASH) ? n.TAG_OPEN_END_VOID : n.TAG_OPEN_END;
              this._beginToken(u), this._requireCharCode(r2.$GT), this._endToken([]);
            }
            _consumeTagClose(u) {
              if (this._beginToken(n.TAG_CLOSE, u), this._attemptCharCodeUntilFn(m2), this._allowHtmComponentClosingTags && this._attemptCharCode(r2.$SLASH))
                this._attemptCharCodeUntilFn(m2), this._requireCharCode(r2.$GT), this._endToken([]);
              else {
                let [o, E] = this._consumePrefixAndName();
                this._attemptCharCodeUntilFn(m2), this._requireCharCode(r2.$GT), this._endToken([o, E]), this._handleFullNameStackForTagClose(o, E);
              }
            }
            _consumeExpansionFormStart() {
              this._beginToken(n.EXPANSION_FORM_START), this._requireCharCode(r2.$LBRACE), this._endToken([]), this._expansionCaseStack.push(n.EXPANSION_FORM_START), this._beginToken(n.RAW_TEXT);
              let u = this._readUntil(r2.$COMMA);
              this._endToken([u]), this._requireCharCode(r2.$COMMA), this._attemptCharCodeUntilFn(m2), this._beginToken(n.RAW_TEXT);
              let o = this._readUntil(r2.$COMMA);
              this._endToken([o]), this._requireCharCode(r2.$COMMA), this._attemptCharCodeUntilFn(m2);
            }
            _consumeExpansionCaseStart() {
              this._beginToken(n.EXPANSION_CASE_VALUE);
              let u = this._readUntil(r2.$LBRACE).trim();
              this._endToken([u]), this._attemptCharCodeUntilFn(m2), this._beginToken(n.EXPANSION_CASE_EXP_START), this._requireCharCode(r2.$LBRACE), this._endToken([]), this._attemptCharCodeUntilFn(m2), this._expansionCaseStack.push(n.EXPANSION_CASE_EXP_START);
            }
            _consumeExpansionCaseEnd() {
              this._beginToken(n.EXPANSION_CASE_EXP_END), this._requireCharCode(r2.$RBRACE), this._endToken([]), this._attemptCharCodeUntilFn(m2), this._expansionCaseStack.pop();
            }
            _consumeExpansionFormEnd() {
              this._beginToken(n.EXPANSION_FORM_END), this._requireCharCode(r2.$RBRACE), this._endToken([]), this._expansionCaseStack.pop();
            }
            _consumeText() {
              let u = this._cursor.clone();
              this._beginToken(n.TEXT, u);
              let o = [];
              do
                this._interpolationConfig && this._attemptStr(this._interpolationConfig.start) ? (o.push(this._interpolationConfig.start), this._inInterpolation = true) : this._interpolationConfig && this._inInterpolation && this._attemptStr(this._interpolationConfig.end) ? (o.push(this._interpolationConfig.end), this._inInterpolation = false) : o.push(this._readChar(true));
              while (!this._isTextEnd());
              this._endToken([this._processCarriageReturns(o.join(""))]);
            }
            _isTextEnd() {
              return !!(this._cursor.peek() === r2.$LT || this._cursor.peek() === r2.$EOF || this._tokenizeIcu && !this._inInterpolation && (this.isExpansionFormStart() || this._cursor.peek() === r2.$RBRACE && this._isInExpansionCase()));
            }
            _readUntil(u) {
              let o = this._cursor.clone();
              return this._attemptUntilChar(u), this._cursor.getChars(o);
            }
            _isInExpansionCase() {
              return this._expansionCaseStack.length > 0 && this._expansionCaseStack[this._expansionCaseStack.length - 1] === n.EXPANSION_CASE_EXP_START;
            }
            _isInExpansionForm() {
              return this._expansionCaseStack.length > 0 && this._expansionCaseStack[this._expansionCaseStack.length - 1] === n.EXPANSION_FORM_START;
            }
            isExpansionFormStart() {
              if (this._cursor.peek() !== r2.$LBRACE)
                return false;
              if (this._interpolationConfig) {
                let u = this._cursor.clone(), o = this._attemptStr(this._interpolationConfig.start);
                return this._cursor = u, !o;
              }
              return true;
            }
            _handleFullNameStackForTagOpen(u, o) {
              let E = c.mergeNsAndName(u, o);
              (this._fullNameStack.length === 0 || this._fullNameStack[this._fullNameStack.length - 1] === E) && this._fullNameStack.push(E);
            }
            _handleFullNameStackForTagClose(u, o) {
              let E = c.mergeNsAndName(u, o);
              this._fullNameStack.length !== 0 && this._fullNameStack[this._fullNameStack.length - 1] === E && this._fullNameStack.pop();
            }
          };
          function m2(u) {
            return !r2.isWhitespace(u) || u === r2.$EOF;
          }
          function T(u) {
            return r2.isWhitespace(u) || u === r2.$GT || u === r2.$SLASH || u === r2.$SQ || u === r2.$DQ || u === r2.$EQ;
          }
          function B(u) {
            return (u < r2.$a || r2.$z < u) && (u < r2.$A || r2.$Z < u) && (u < r2.$0 || u > r2.$9);
          }
          function A2(u) {
            return u == r2.$SEMICOLON || u == r2.$EOF || !r2.isAsciiHexDigit(u);
          }
          function N(u) {
            return u == r2.$SEMICOLON || u == r2.$EOF || !r2.isAsciiLetter(u);
          }
          function R(u) {
            return u === r2.$EQ || r2.isAsciiLetter(u) || r2.isDigit(u);
          }
          function $(u, o) {
            return _(u) == _(o);
          }
          function _(u) {
            return u >= r2.$a && u <= r2.$z ? u - r2.$a + r2.$A : u;
          }
          function O(u) {
            let o = [], E;
            for (let f3 = 0; f3 < u.length; f3++) {
              let F2 = u[f3];
              E && E.type == n.TEXT && F2.type == n.TEXT ? (E.parts[0] += F2.parts[0], E.sourceSpan.end = F2.sourceSpan.end) : (E = F2, o.push(E));
            }
            return o;
          }
          var x2 = class {
            constructor(u, o) {
              if (u instanceof x2)
                this.file = u.file, this.input = u.input, this.end = u.end, this.state = Object.assign({}, u.state);
              else {
                if (!o)
                  throw new Error("Programming error: the range argument must be provided with a file argument.");
                this.file = u, this.input = u.content, this.end = o.endPos, this.state = { peek: -1, offset: o.startPos, line: o.startLine, column: o.startCol };
              }
            }
            clone() {
              return new x2(this);
            }
            peek() {
              return this.state.peek;
            }
            charsLeft() {
              return this.end - this.state.offset;
            }
            diff(u) {
              return this.state.offset - u.state.offset;
            }
            advance() {
              this.advanceState(this.state);
            }
            init() {
              this.updatePeek(this.state);
            }
            getSpan(u, o) {
              if (u = u || this, o)
                for (u = u.clone(); this.diff(u) > 0 && o.indexOf(u.peek()) !== -1; )
                  u.advance();
              return new t2.ParseSourceSpan(new t2.ParseLocation(u.file, u.state.offset, u.state.line, u.state.column), new t2.ParseLocation(this.file, this.state.offset, this.state.line, this.state.column));
            }
            getChars(u) {
              return this.input.substring(u.state.offset, this.state.offset);
            }
            charAt(u) {
              return this.input.charCodeAt(u);
            }
            advanceState(u) {
              if (u.offset >= this.end)
                throw this.state = u, new M('Unexpected character "EOF"', this);
              let o = this.charAt(u.offset);
              o === r2.$LF ? (u.line++, u.column = 0) : r2.isNewLine(o) || u.column++, u.offset++, this.updatePeek(u);
            }
            updatePeek(u) {
              u.peek = u.offset >= this.end ? r2.$EOF : this.charAt(u.offset);
            }
          }, k = class extends x2 {
            constructor(u, o) {
              u instanceof k ? (super(u), this.internalState = Object.assign({}, u.internalState)) : (super(u, o), this.internalState = this.state);
            }
            advance() {
              this.state = this.internalState, super.advance(), this.processEscapeSequence();
            }
            init() {
              super.init(), this.processEscapeSequence();
            }
            clone() {
              return new k(this);
            }
            getChars(u) {
              let o = u.clone(), E = "";
              for (; o.internalState.offset < this.internalState.offset; )
                E += String.fromCodePoint(o.peek()), o.advance();
              return E;
            }
            processEscapeSequence() {
              let u = () => this.internalState.peek;
              if (u() === r2.$BACKSLASH)
                if (this.internalState = Object.assign({}, this.state), this.advanceState(this.internalState), u() === r2.$n)
                  this.state.peek = r2.$LF;
                else if (u() === r2.$r)
                  this.state.peek = r2.$CR;
                else if (u() === r2.$v)
                  this.state.peek = r2.$VTAB;
                else if (u() === r2.$t)
                  this.state.peek = r2.$TAB;
                else if (u() === r2.$b)
                  this.state.peek = r2.$BSPACE;
                else if (u() === r2.$f)
                  this.state.peek = r2.$FF;
                else if (u() === r2.$u)
                  if (this.advanceState(this.internalState), u() === r2.$LBRACE) {
                    this.advanceState(this.internalState);
                    let o = this.clone(), E = 0;
                    for (; u() !== r2.$RBRACE; )
                      this.advanceState(this.internalState), E++;
                    this.state.peek = this.decodeHexDigits(o, E);
                  } else {
                    let o = this.clone();
                    this.advanceState(this.internalState), this.advanceState(this.internalState), this.advanceState(this.internalState), this.state.peek = this.decodeHexDigits(o, 4);
                  }
                else if (u() === r2.$x) {
                  this.advanceState(this.internalState);
                  let o = this.clone();
                  this.advanceState(this.internalState), this.state.peek = this.decodeHexDigits(o, 2);
                } else if (r2.isOctalDigit(u())) {
                  let o = "", E = 0, f3 = this.clone();
                  for (; r2.isOctalDigit(u()) && E < 3; )
                    f3 = this.clone(), o += String.fromCodePoint(u()), this.advanceState(this.internalState), E++;
                  this.state.peek = parseInt(o, 8), this.internalState = f3.internalState;
                } else
                  r2.isNewLine(this.internalState.peek) ? (this.advanceState(this.internalState), this.state = this.internalState) : this.state.peek = this.internalState.peek;
            }
            decodeHexDigits(u, o) {
              let E = this.input.substr(u.internalState.offset, o), f3 = parseInt(E, 16);
              if (isNaN(f3))
                throw u.state = u.internalState, new M("Invalid hexadecimal escape sequence", u);
              return f3;
            }
          }, M = class {
            constructor(u, o) {
              this.msg = u, this.cursor = o;
            }
          };
          e2.CursorError = M;
        } }), as = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/parser.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = Te(), t2 = Ss(), s2 = zD(), c = Ze(), n = class extends r2.ParseError {
            constructor(i2, l, h2) {
              super(l, h2), this.elementName = i2;
            }
            static create(i2, l, h2) {
              return new n(i2, l, h2);
            }
          };
          e2.TreeError = n;
          var a = class {
            constructor(i2, l) {
              this.rootNodes = i2, this.errors = l;
            }
          };
          e2.ParseTreeResult = a;
          var p = class {
            constructor(i2) {
              this.getTagDefinition = i2;
            }
            parse(i2, l, h2) {
              let C = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, d = arguments.length > 4 ? arguments[4] : void 0, m2 = (x2) => function(k) {
                for (var M = arguments.length, u = new Array(M > 1 ? M - 1 : 0), o = 1; o < M; o++)
                  u[o - 1] = arguments[o];
                return x2(k.toLowerCase(), ...u);
              }, T = C ? this.getTagDefinition : m2(this.getTagDefinition), B = (x2) => T(x2).contentType, A2 = C ? d : m2(d), N = d ? (x2, k, M, u) => {
                let o = A2(x2, k, M, u);
                return o !== void 0 ? o : B(x2);
              } : B, R = s2.tokenize(i2, l, N, h2), $ = h2 && h2.canSelfClose || false, _ = h2 && h2.allowHtmComponentClosingTags || false, O = new D(R.tokens, T, $, _, C).build();
              return new a(O.rootNodes, R.errors.concat(O.errors));
            }
          };
          e2.Parser = p;
          var D = class {
            constructor(i2, l, h2, C, d) {
              this.tokens = i2, this.getTagDefinition = l, this.canSelfClose = h2, this.allowHtmComponentClosingTags = C, this.isTagNameCaseSensitive = d, this._index = -1, this._rootNodes = [], this._errors = [], this._elementStack = [], this._advance();
            }
            build() {
              for (; this._peek.type !== s2.TokenType.EOF; )
                this._peek.type === s2.TokenType.TAG_OPEN_START ? this._consumeStartTag(this._advance()) : this._peek.type === s2.TokenType.TAG_CLOSE ? (this._closeVoidElement(), this._consumeEndTag(this._advance())) : this._peek.type === s2.TokenType.CDATA_START ? (this._closeVoidElement(), this._consumeCdata(this._advance())) : this._peek.type === s2.TokenType.COMMENT_START ? (this._closeVoidElement(), this._consumeComment(this._advance())) : this._peek.type === s2.TokenType.TEXT || this._peek.type === s2.TokenType.RAW_TEXT || this._peek.type === s2.TokenType.ESCAPABLE_RAW_TEXT ? (this._closeVoidElement(), this._consumeText(this._advance())) : this._peek.type === s2.TokenType.EXPANSION_FORM_START ? this._consumeExpansion(this._advance()) : this._peek.type === s2.TokenType.DOC_TYPE_START ? this._consumeDocType(this._advance()) : this._advance();
              return new a(this._rootNodes, this._errors);
            }
            _advance() {
              let i2 = this._peek;
              return this._index < this.tokens.length - 1 && this._index++, this._peek = this.tokens[this._index], i2;
            }
            _advanceIf(i2) {
              return this._peek.type === i2 ? this._advance() : null;
            }
            _consumeCdata(i2) {
              let l = this._advance(), h2 = this._getText(l), C = this._advanceIf(s2.TokenType.CDATA_END);
              this._addToParent(new t2.CDATA(h2, new r2.ParseSourceSpan(i2.sourceSpan.start, (C || l).sourceSpan.end)));
            }
            _consumeComment(i2) {
              let l = this._advanceIf(s2.TokenType.RAW_TEXT), h2 = this._advanceIf(s2.TokenType.COMMENT_END), C = l != null ? l.parts[0].trim() : null, d = new r2.ParseSourceSpan(i2.sourceSpan.start, (h2 || l || i2).sourceSpan.end);
              this._addToParent(new t2.Comment(C, d));
            }
            _consumeDocType(i2) {
              let l = this._advanceIf(s2.TokenType.RAW_TEXT), h2 = this._advanceIf(s2.TokenType.DOC_TYPE_END), C = l != null ? l.parts[0].trim() : null, d = new r2.ParseSourceSpan(i2.sourceSpan.start, (h2 || l || i2).sourceSpan.end);
              this._addToParent(new t2.DocType(C, d));
            }
            _consumeExpansion(i2) {
              let l = this._advance(), h2 = this._advance(), C = [];
              for (; this._peek.type === s2.TokenType.EXPANSION_CASE_VALUE; ) {
                let m2 = this._parseExpansionCase();
                if (!m2)
                  return;
                C.push(m2);
              }
              if (this._peek.type !== s2.TokenType.EXPANSION_FORM_END) {
                this._errors.push(n.create(null, this._peek.sourceSpan, "Invalid ICU message. Missing '}'."));
                return;
              }
              let d = new r2.ParseSourceSpan(i2.sourceSpan.start, this._peek.sourceSpan.end);
              this._addToParent(new t2.Expansion(l.parts[0], h2.parts[0], C, d, l.sourceSpan)), this._advance();
            }
            _parseExpansionCase() {
              let i2 = this._advance();
              if (this._peek.type !== s2.TokenType.EXPANSION_CASE_EXP_START)
                return this._errors.push(n.create(null, this._peek.sourceSpan, "Invalid ICU message. Missing '{'.")), null;
              let l = this._advance(), h2 = this._collectExpansionExpTokens(l);
              if (!h2)
                return null;
              let C = this._advance();
              h2.push(new s2.Token(s2.TokenType.EOF, [], C.sourceSpan));
              let d = new D(h2, this.getTagDefinition, this.canSelfClose, this.allowHtmComponentClosingTags, this.isTagNameCaseSensitive).build();
              if (d.errors.length > 0)
                return this._errors = this._errors.concat(d.errors), null;
              let m2 = new r2.ParseSourceSpan(i2.sourceSpan.start, C.sourceSpan.end), T = new r2.ParseSourceSpan(l.sourceSpan.start, C.sourceSpan.end);
              return new t2.ExpansionCase(i2.parts[0], d.rootNodes, m2, i2.sourceSpan, T);
            }
            _collectExpansionExpTokens(i2) {
              let l = [], h2 = [s2.TokenType.EXPANSION_CASE_EXP_START];
              for (; ; ) {
                if ((this._peek.type === s2.TokenType.EXPANSION_FORM_START || this._peek.type === s2.TokenType.EXPANSION_CASE_EXP_START) && h2.push(this._peek.type), this._peek.type === s2.TokenType.EXPANSION_CASE_EXP_END)
                  if (g(h2, s2.TokenType.EXPANSION_CASE_EXP_START)) {
                    if (h2.pop(), h2.length == 0)
                      return l;
                  } else
                    return this._errors.push(n.create(null, i2.sourceSpan, "Invalid ICU message. Missing '}'.")), null;
                if (this._peek.type === s2.TokenType.EXPANSION_FORM_END)
                  if (g(h2, s2.TokenType.EXPANSION_FORM_START))
                    h2.pop();
                  else
                    return this._errors.push(n.create(null, i2.sourceSpan, "Invalid ICU message. Missing '}'.")), null;
                if (this._peek.type === s2.TokenType.EOF)
                  return this._errors.push(n.create(null, i2.sourceSpan, "Invalid ICU message. Missing '}'.")), null;
                l.push(this._advance());
              }
            }
            _getText(i2) {
              let l = i2.parts[0];
              if (l.length > 0 && l[0] == `
`) {
                let h2 = this._getParentElement();
                h2 != null && h2.children.length == 0 && this.getTagDefinition(h2.name).ignoreFirstLf && (l = l.substring(1));
              }
              return l;
            }
            _consumeText(i2) {
              let l = this._getText(i2);
              l.length > 0 && this._addToParent(new t2.Text(l, i2.sourceSpan));
            }
            _closeVoidElement() {
              let i2 = this._getParentElement();
              i2 && this.getTagDefinition(i2.name).isVoid && this._elementStack.pop();
            }
            _consumeStartTag(i2) {
              let l = i2.parts[0], h2 = i2.parts[1], C = [];
              for (; this._peek.type === s2.TokenType.ATTR_NAME; )
                C.push(this._consumeAttr(this._advance()));
              let d = this._getElementFullName(l, h2, this._getParentElement()), m2 = false;
              if (this._peek.type === s2.TokenType.TAG_OPEN_END_VOID) {
                this._advance(), m2 = true;
                let R = this.getTagDefinition(d);
                this.canSelfClose || R.canSelfClose || c.getNsPrefix(d) !== null || R.isVoid || this._errors.push(n.create(d, i2.sourceSpan, 'Only void and foreign elements can be self closed "'.concat(i2.parts[1], '"')));
              } else
                this._peek.type === s2.TokenType.TAG_OPEN_END && (this._advance(), m2 = false);
              let T = this._peek.sourceSpan.start, B = new r2.ParseSourceSpan(i2.sourceSpan.start, T), A2 = new r2.ParseSourceSpan(i2.sourceSpan.start.moveBy(1), i2.sourceSpan.end), N = new t2.Element(d, C, [], B, B, void 0, A2);
              this._pushElement(N), m2 && (this._popElement(d), N.endSourceSpan = B);
            }
            _pushElement(i2) {
              let l = this._getParentElement();
              l && this.getTagDefinition(l.name).isClosedByChild(i2.name) && this._elementStack.pop(), this._addToParent(i2), this._elementStack.push(i2);
            }
            _consumeEndTag(i2) {
              let l = this.allowHtmComponentClosingTags && i2.parts.length === 0 ? null : this._getElementFullName(i2.parts[0], i2.parts[1], this._getParentElement());
              if (this._getParentElement() && (this._getParentElement().endSourceSpan = i2.sourceSpan), l && this.getTagDefinition(l).isVoid)
                this._errors.push(n.create(l, i2.sourceSpan, 'Void elements do not have end tags "'.concat(i2.parts[1], '"')));
              else if (!this._popElement(l)) {
                let h2 = 'Unexpected closing tag "'.concat(l, '". It may happen when the tag has already been closed by another tag. For more info see https://www.w3.org/TR/html5/syntax.html#closing-elements-that-have-implied-end-tags');
                this._errors.push(n.create(l, i2.sourceSpan, h2));
              }
            }
            _popElement(i2) {
              for (let l = this._elementStack.length - 1; l >= 0; l--) {
                let h2 = this._elementStack[l];
                if (!i2 || (c.getNsPrefix(h2.name) ? h2.name == i2 : h2.name.toLowerCase() == i2.toLowerCase()))
                  return this._elementStack.splice(l, this._elementStack.length - l), true;
                if (!this.getTagDefinition(h2.name).closedByParent)
                  return false;
              }
              return false;
            }
            _consumeAttr(i2) {
              let l = c.mergeNsAndName(i2.parts[0], i2.parts[1]), h2 = i2.sourceSpan.end, C = "", d, m2;
              if (this._peek.type === s2.TokenType.ATTR_QUOTE && (m2 = this._advance().sourceSpan.start), this._peek.type === s2.TokenType.ATTR_VALUE) {
                let T = this._advance();
                C = T.parts[0], h2 = T.sourceSpan.end, d = T.sourceSpan;
              }
              return this._peek.type === s2.TokenType.ATTR_QUOTE && (h2 = this._advance().sourceSpan.end, d = new r2.ParseSourceSpan(m2, h2)), new t2.Attribute(l, C, new r2.ParseSourceSpan(i2.sourceSpan.start, h2), d, i2.sourceSpan);
            }
            _getParentElement() {
              return this._elementStack.length > 0 ? this._elementStack[this._elementStack.length - 1] : null;
            }
            _getParentElementSkippingContainers() {
              let i2 = null;
              for (let l = this._elementStack.length - 1; l >= 0; l--) {
                if (!c.isNgContainer(this._elementStack[l].name))
                  return { parent: this._elementStack[l], container: i2 };
                i2 = this._elementStack[l];
              }
              return { parent: null, container: i2 };
            }
            _addToParent(i2) {
              let l = this._getParentElement();
              l != null ? l.children.push(i2) : this._rootNodes.push(i2);
            }
            _insertBeforeContainer(i2, l, h2) {
              if (!l)
                this._addToParent(h2), this._elementStack.push(h2);
              else {
                if (i2) {
                  let C = i2.children.indexOf(l);
                  i2.children[C] = h2;
                } else
                  this._rootNodes.push(h2);
                h2.children.push(l), this._elementStack.splice(this._elementStack.indexOf(l), 0, h2);
              }
            }
            _getElementFullName(i2, l, h2) {
              return i2 === "" && (i2 = this.getTagDefinition(l).implicitNamespacePrefix || "", i2 === "" && h2 != null && (i2 = c.getNsPrefix(h2.name))), c.mergeNsAndName(i2, l);
            }
          };
          function g(i2, l) {
            return i2.length > 0 && i2[i2.length - 1] === l;
          }
        } }), WD = I({ "node_modules/angular-html-parser/lib/compiler/src/ml_parser/html_parser.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = _s(), t2 = as(), s2 = as();
          e2.ParseTreeResult = s2.ParseTreeResult, e2.TreeError = s2.TreeError;
          var c = class extends t2.Parser {
            constructor() {
              super(r2.getHtmlTagDefinition);
            }
            parse(n, a, p) {
              let D = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : false, g = arguments.length > 4 ? arguments[4] : void 0;
              return super.parse(n, a, p, D, g);
            }
          };
          e2.HtmlParser = c;
        } }), ys = I({ "node_modules/angular-html-parser/lib/angular-html-parser/src/index.js"(e2) {
          "use strict";
          q(), Object.defineProperty(e2, "__esModule", { value: true });
          var r2 = WD(), t2 = Ze();
          e2.TagContentType = t2.TagContentType;
          var s2 = null, c = () => (s2 || (s2 = new r2.HtmlParser()), s2);
          function n(a) {
            let p = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, { canSelfClose: D = false, allowHtmComponentClosingTags: g = false, isTagNameCaseSensitive: i2 = false, getTagContentType: l } = p;
            return c().parse(a, "angular-html-parser", { tokenizeExpansionForms: false, interpolationConfig: void 0, canSelfClose: D, allowHtmComponentClosingTags: g }, i2, l);
          }
          e2.parse = n;
        } });
        q();
        var { ParseSourceSpan: Qe, ParseLocation: is, ParseSourceFile: YD } = Te(), QD = aD(), KD = ps(), JD = iD(), { inferParserByLanguage: ZD } = ID(), el = xD(), jr = LD(), os = MD(), { hasPragma: rl } = jD(), { Node: tl } = $D(), { parseIeConditionalComment: ul } = UD(), { locStart: nl, locEnd: sl } = GD();
        function al(e2, r2, t2) {
          let { recognizeSelfClosing: s2, normalizeTagName: c, normalizeAttributeName: n, allowHtmComponentClosingTags: a, isTagNameCaseSensitive: p, getTagContentType: D } = r2, g = ys(), { RecursiveVisitor: i2, visitAll: l } = Ss(), { ParseSourceSpan: h2 } = Te(), { getHtmlTagDefinition: C } = _s(), { rootNodes: d, errors: m2 } = g.parse(e2, { canSelfClose: s2, allowHtmComponentClosingTags: a, isTagNameCaseSensitive: p, getTagContentType: D });
          if (t2.parser === "vue")
            if (d.some((O) => O.type === "docType" && O.value === "html" || O.type === "element" && O.name.toLowerCase() === "html")) {
              s2 = true, c = true, n = true, a = true, p = false;
              let O = g.parse(e2, { canSelfClose: s2, allowHtmComponentClosingTags: a, isTagNameCaseSensitive: p });
              d = O.rootNodes, m2 = O.errors;
            } else {
              let O = (x2) => {
                if (!x2 || x2.type !== "element" || x2.name !== "template")
                  return false;
                let k = x2.attrs.find((u) => u.name === "lang"), M = k && k.value;
                return !M || ZD(M, t2) === "html";
              };
              if (d.some(O)) {
                let x2, k = () => g.parse(e2, { canSelfClose: s2, allowHtmComponentClosingTags: a, isTagNameCaseSensitive: p }), M = () => x2 || (x2 = k()), u = (o) => M().rootNodes.find((E) => {
                  let { startSourceSpan: f3 } = E;
                  return f3 && f3.start.offset === o.startSourceSpan.start.offset;
                });
                for (let o = 0; o < d.length; o++) {
                  let E = d[o], { endSourceSpan: f3, startSourceSpan: F2 } = E;
                  if (f3 === null)
                    m2 = M().errors, d[o] = u(E) || E;
                  else if (O(E)) {
                    let j = M(), W = F2.end.offset, X = f3.start.offset;
                    for (let H of j.errors) {
                      let { offset: z } = H.span.start;
                      if (W < z && z < X) {
                        m2 = [H];
                        break;
                      }
                    }
                    d[o] = u(E) || E;
                  }
                }
              }
            }
          if (m2.length > 0) {
            let { msg: _, span: { start: O, end: x2 } } = m2[0];
            throw JD(_, { start: { line: O.line + 1, column: O.col + 1 }, end: { line: x2.line + 1, column: x2.col + 1 } });
          }
          let T = (_) => {
            let O = _.name.startsWith(":") ? _.name.slice(1).split(":")[0] : null, x2 = _.nameSpan.toString(), k = O !== null && x2.startsWith("".concat(O, ":")), M = k ? x2.slice(O.length + 1) : x2;
            _.name = M, _.namespace = O, _.hasExplicitNamespace = k;
          }, B = (_) => {
            switch (_.type) {
              case "element":
                T(_);
                for (let O of _.attrs)
                  T(O), O.valueSpan ? (O.value = O.valueSpan.toString(), /["']/.test(O.value[0]) && (O.value = O.value.slice(1, -1))) : O.value = null;
                break;
              case "comment":
                _.value = _.sourceSpan.toString().slice(4, -3);
                break;
              case "text":
                _.value = _.sourceSpan.toString();
                break;
            }
          }, A2 = (_, O) => {
            let x2 = _.toLowerCase();
            return O(x2) ? x2 : _;
          }, N = (_) => {
            if (_.type === "element" && (c && (!_.namespace || _.namespace === _.tagDefinition.implicitNamespacePrefix || os(_)) && (_.name = A2(_.name, (O) => O in el)), n)) {
              let O = jr[_.name] || /* @__PURE__ */ Object.create(null);
              for (let x2 of _.attrs)
                x2.namespace || (x2.name = A2(x2.name, (k) => _.name in jr && (k in jr["*"] || k in O)));
            }
          }, R = (_) => {
            _.sourceSpan && _.endSourceSpan && (_.sourceSpan = new h2(_.sourceSpan.start, _.endSourceSpan.end));
          }, $ = (_) => {
            if (_.type === "element") {
              let O = C(p ? _.name : _.name.toLowerCase());
              !_.namespace || _.namespace === O.implicitNamespacePrefix || os(_) ? _.tagDefinition = O : _.tagDefinition = C("");
            }
          };
          return l(new class extends i2 {
            visit(_) {
              B(_), $(_), N(_), R(_);
            }
          }(), d), d;
        }
        function Ts(e2, r2, t2) {
          let s2 = arguments.length > 3 && arguments[3] !== void 0 ? arguments[3] : true, { frontMatter: c, content: n } = s2 ? QD(e2) : { frontMatter: null, content: e2 }, a = new YD(e2, r2.filepath), p = new is(a, 0, 0, 0), D = p.moveBy(e2.length), g = { type: "root", sourceSpan: new Qe(p, D), children: al(n, t2, r2) };
          if (c) {
            let h2 = new is(a, 0, 0, 0), C = h2.moveBy(c.raw.length);
            c.sourceSpan = new Qe(h2, C), g.children.unshift(c);
          }
          let i2 = new tl(g), l = (h2, C) => {
            let { offset: d } = C, m2 = e2.slice(0, d).replace(/[^\n\r]/g, " "), B = Ts(m2 + h2, r2, t2, false);
            B.sourceSpan = new Qe(C, KD(B.children).sourceSpan.end);
            let A2 = B.children[0];
            return A2.length === d ? B.children.shift() : (A2.sourceSpan = new Qe(A2.sourceSpan.start.moveBy(d), A2.sourceSpan.end), A2.value = A2.value.slice(d)), B;
          };
          return i2.walk((h2) => {
            if (h2.type === "comment") {
              let C = ul(h2, l);
              C && h2.parent.replaceChild(h2, C);
            }
          }), i2;
        }
        function Ke() {
          let { name: e2, recognizeSelfClosing: r2 = false, normalizeTagName: t2 = false, normalizeAttributeName: s2 = false, allowHtmComponentClosingTags: c = false, isTagNameCaseSensitive: n = false, getTagContentType: a } = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
          return { parse: (p, D, g) => Ts(p, Object.assign({ parser: e2 }, g), { recognizeSelfClosing: r2, normalizeTagName: t2, normalizeAttributeName: s2, allowHtmComponentClosingTags: c, isTagNameCaseSensitive: n, getTagContentType: a }), hasPragma: rl, astFormat: "html", locStart: nl, locEnd: sl };
        }
        Bs.exports = { parsers: { html: Ke({ name: "html", recognizeSelfClosing: true, normalizeTagName: true, normalizeAttributeName: true, allowHtmComponentClosingTags: true }), angular: Ke({ name: "angular" }), vue: Ke({ name: "vue", recognizeSelfClosing: true, isTagNameCaseSensitive: true, getTagContentType: (e2, r2, t2, s2) => {
          if (e2.toLowerCase() !== "html" && !t2 && (e2 !== "template" || s2.some((c) => {
            let { name: n, value: a } = c;
            return n === "lang" && a !== "html" && a !== "" && a !== void 0;
          })))
            return ys().TagContentType.RAW_TEXT;
        } }), lwc: Ke({ name: "lwc" }) } };
      });
      return il();
    });
  }
});

// node_modules/prettier/parser-yaml.js
var require_parser_yaml = __commonJS({
  "node_modules/prettier/parser-yaml.js"(exports, module2) {
    (function(e2) {
      if (typeof exports == "object" && typeof module2 == "object")
        module2.exports = e2();
      else if (typeof define == "function" && define.amd)
        define(e2);
      else {
        var i2 = typeof globalThis < "u" ? globalThis : typeof global < "u" ? global : typeof self < "u" ? self : this || {};
        i2.prettierPlugins = i2.prettierPlugins || {}, i2.prettierPlugins.yaml = e2();
      }
    })(function() {
      "use strict";
      var wt = (r2, e2) => () => (e2 || r2((e2 = { exports: {} }).exports, e2), e2.exports);
      var ur = wt((mr, lt) => {
        var De = Object.defineProperty, St = Object.getOwnPropertyDescriptor, Fe = Object.getOwnPropertyNames, Et = Object.prototype.hasOwnProperty, xe = (r2, e2) => function() {
          return r2 && (e2 = (0, r2[Fe(r2)[0]])(r2 = 0)), e2;
        }, F2 = (r2, e2) => function() {
          return e2 || (0, r2[Fe(r2)[0]])((e2 = { exports: {} }).exports, e2), e2.exports;
        }, Mt = (r2, e2) => {
          for (var n in e2)
            De(r2, n, { get: e2[n], enumerable: true });
        }, Ot = (r2, e2, n, c) => {
          if (e2 && typeof e2 == "object" || typeof e2 == "function")
            for (let h2 of Fe(e2))
              !Et.call(r2, h2) && h2 !== n && De(r2, h2, { get: () => e2[h2], enumerable: !(c = St(e2, h2)) || c.enumerable });
          return r2;
        }, se = (r2) => Ot(De({}, "__esModule", { value: true }), r2), Ke, $e, Te, D = xe({ "<define:process>"() {
          Ke = {}, $e = [], Te = { env: Ke, argv: $e };
        } }), Lt = F2({ "src/common/parser-create-error.js"(r2, e2) {
          "use strict";
          D();
          function n(c, h2) {
            let d = new SyntaxError(c + " (" + h2.start.line + ":" + h2.start.column + ")");
            return d.loc = h2, d;
          }
          e2.exports = n;
        } }), At = F2({ "src/language-yaml/pragma.js"(r2, e2) {
          "use strict";
          D();
          function n(d) {
            return /^\s*@(?:prettier|format)\s*$/.test(d);
          }
          function c(d) {
            return /^\s*#[^\S\n]*@(?:prettier|format)\s*?(?:\n|$)/.test(d);
          }
          function h2(d) {
            return `# @format

`.concat(d);
          }
          e2.exports = { isPragma: n, hasPragma: c, insertPragma: h2 };
        } }), Nt = F2({ "src/language-yaml/loc.js"(r2, e2) {
          "use strict";
          D();
          function n(h2) {
            return h2.position.start.offset;
          }
          function c(h2) {
            return h2.position.end.offset;
          }
          e2.exports = { locStart: n, locEnd: c };
        } }), te = {};
        Mt(te, { __assign: () => qe, __asyncDelegator: () => Wt, __asyncGenerator: () => Ft, __asyncValues: () => Vt, __await: () => Ce, __awaiter: () => Rt, __classPrivateFieldGet: () => $t, __classPrivateFieldSet: () => Jt, __createBinding: () => Bt, __decorate: () => kt, __exportStar: () => jt, __extends: () => Tt, __generator: () => qt, __importDefault: () => Kt, __importStar: () => Ut, __makeTemplateObject: () => Qt, __metadata: () => It, __param: () => Pt, __read: () => He, __rest: () => Ct, __spread: () => Yt, __spreadArrays: () => Dt, __values: () => Ye });
        function Tt(r2, e2) {
          Re(r2, e2);
          function n() {
            this.constructor = r2;
          }
          r2.prototype = e2 === null ? Object.create(e2) : (n.prototype = e2.prototype, new n());
        }
        function Ct(r2, e2) {
          var n = {};
          for (var c in r2)
            Object.prototype.hasOwnProperty.call(r2, c) && e2.indexOf(c) < 0 && (n[c] = r2[c]);
          if (r2 != null && typeof Object.getOwnPropertySymbols == "function")
            for (var h2 = 0, c = Object.getOwnPropertySymbols(r2); h2 < c.length; h2++)
              e2.indexOf(c[h2]) < 0 && Object.prototype.propertyIsEnumerable.call(r2, c[h2]) && (n[c[h2]] = r2[c[h2]]);
          return n;
        }
        function kt(r2, e2, n, c) {
          var h2 = arguments.length, d = h2 < 3 ? e2 : c === null ? c = Object.getOwnPropertyDescriptor(e2, n) : c, y;
          if (typeof Reflect == "object" && typeof Reflect.decorate == "function")
            d = Reflect.decorate(r2, e2, n, c);
          else
            for (var E = r2.length - 1; E >= 0; E--)
              (y = r2[E]) && (d = (h2 < 3 ? y(d) : h2 > 3 ? y(e2, n, d) : y(e2, n)) || d);
          return h2 > 3 && d && Object.defineProperty(e2, n, d), d;
        }
        function Pt(r2, e2) {
          return function(n, c) {
            e2(n, c, r2);
          };
        }
        function It(r2, e2) {
          if (typeof Reflect == "object" && typeof Reflect.metadata == "function")
            return Reflect.metadata(r2, e2);
        }
        function Rt(r2, e2, n, c) {
          function h2(d) {
            return d instanceof n ? d : new n(function(y) {
              y(d);
            });
          }
          return new (n || (n = Promise))(function(d, y) {
            function E(M) {
              try {
                S2(c.next(M));
              } catch (T) {
                y(T);
              }
            }
            function I(M) {
              try {
                S2(c.throw(M));
              } catch (T) {
                y(T);
              }
            }
            function S2(M) {
              M.done ? d(M.value) : h2(M.value).then(E, I);
            }
            S2((c = c.apply(r2, e2 || [])).next());
          });
        }
        function qt(r2, e2) {
          var n = { label: 0, sent: function() {
            if (d[0] & 1)
              throw d[1];
            return d[1];
          }, trys: [], ops: [] }, c, h2, d, y;
          return y = { next: E(0), throw: E(1), return: E(2) }, typeof Symbol == "function" && (y[Symbol.iterator] = function() {
            return this;
          }), y;
          function E(S2) {
            return function(M) {
              return I([S2, M]);
            };
          }
          function I(S2) {
            if (c)
              throw new TypeError("Generator is already executing.");
            for (; n; )
              try {
                if (c = 1, h2 && (d = S2[0] & 2 ? h2.return : S2[0] ? h2.throw || ((d = h2.return) && d.call(h2), 0) : h2.next) && !(d = d.call(h2, S2[1])).done)
                  return d;
                switch (h2 = 0, d && (S2 = [S2[0] & 2, d.value]), S2[0]) {
                  case 0:
                  case 1:
                    d = S2;
                    break;
                  case 4:
                    return n.label++, { value: S2[1], done: false };
                  case 5:
                    n.label++, h2 = S2[1], S2 = [0];
                    continue;
                  case 7:
                    S2 = n.ops.pop(), n.trys.pop();
                    continue;
                  default:
                    if (d = n.trys, !(d = d.length > 0 && d[d.length - 1]) && (S2[0] === 6 || S2[0] === 2)) {
                      n = 0;
                      continue;
                    }
                    if (S2[0] === 3 && (!d || S2[1] > d[0] && S2[1] < d[3])) {
                      n.label = S2[1];
                      break;
                    }
                    if (S2[0] === 6 && n.label < d[1]) {
                      n.label = d[1], d = S2;
                      break;
                    }
                    if (d && n.label < d[2]) {
                      n.label = d[2], n.ops.push(S2);
                      break;
                    }
                    d[2] && n.ops.pop(), n.trys.pop();
                    continue;
                }
                S2 = e2.call(r2, n);
              } catch (M) {
                S2 = [6, M], h2 = 0;
              } finally {
                c = d = 0;
              }
            if (S2[0] & 5)
              throw S2[1];
            return { value: S2[0] ? S2[1] : void 0, done: true };
          }
        }
        function Bt(r2, e2, n, c) {
          c === void 0 && (c = n), r2[c] = e2[n];
        }
        function jt(r2, e2) {
          for (var n in r2)
            n !== "default" && !e2.hasOwnProperty(n) && (e2[n] = r2[n]);
        }
        function Ye(r2) {
          var e2 = typeof Symbol == "function" && Symbol.iterator, n = e2 && r2[e2], c = 0;
          if (n)
            return n.call(r2);
          if (r2 && typeof r2.length == "number")
            return { next: function() {
              return r2 && c >= r2.length && (r2 = void 0), { value: r2 && r2[c++], done: !r2 };
            } };
          throw new TypeError(e2 ? "Object is not iterable." : "Symbol.iterator is not defined.");
        }
        function He(r2, e2) {
          var n = typeof Symbol == "function" && r2[Symbol.iterator];
          if (!n)
            return r2;
          var c = n.call(r2), h2, d = [], y;
          try {
            for (; (e2 === void 0 || e2-- > 0) && !(h2 = c.next()).done; )
              d.push(h2.value);
          } catch (E) {
            y = { error: E };
          } finally {
            try {
              h2 && !h2.done && (n = c.return) && n.call(c);
            } finally {
              if (y)
                throw y.error;
            }
          }
          return d;
        }
        function Yt() {
          for (var r2 = [], e2 = 0; e2 < arguments.length; e2++)
            r2 = r2.concat(He(arguments[e2]));
          return r2;
        }
        function Dt() {
          for (var r2 = 0, e2 = 0, n = arguments.length; e2 < n; e2++)
            r2 += arguments[e2].length;
          for (var c = Array(r2), h2 = 0, e2 = 0; e2 < n; e2++)
            for (var d = arguments[e2], y = 0, E = d.length; y < E; y++, h2++)
              c[h2] = d[y];
          return c;
        }
        function Ce(r2) {
          return this instanceof Ce ? (this.v = r2, this) : new Ce(r2);
        }
        function Ft(r2, e2, n) {
          if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
          var c = n.apply(r2, e2 || []), h2, d = [];
          return h2 = {}, y("next"), y("throw"), y("return"), h2[Symbol.asyncIterator] = function() {
            return this;
          }, h2;
          function y(P) {
            c[P] && (h2[P] = function(C) {
              return new Promise(function(q, R) {
                d.push([P, C, q, R]) > 1 || E(P, C);
              });
            });
          }
          function E(P, C) {
            try {
              I(c[P](C));
            } catch (q) {
              T(d[0][3], q);
            }
          }
          function I(P) {
            P.value instanceof Ce ? Promise.resolve(P.value.v).then(S2, M) : T(d[0][2], P);
          }
          function S2(P) {
            E("next", P);
          }
          function M(P) {
            E("throw", P);
          }
          function T(P, C) {
            P(C), d.shift(), d.length && E(d[0][0], d[0][1]);
          }
        }
        function Wt(r2) {
          var e2, n;
          return e2 = {}, c("next"), c("throw", function(h2) {
            throw h2;
          }), c("return"), e2[Symbol.iterator] = function() {
            return this;
          }, e2;
          function c(h2, d) {
            e2[h2] = r2[h2] ? function(y) {
              return (n = !n) ? { value: Ce(r2[h2](y)), done: h2 === "return" } : d ? d(y) : y;
            } : d;
          }
        }
        function Vt(r2) {
          if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
          var e2 = r2[Symbol.asyncIterator], n;
          return e2 ? e2.call(r2) : (r2 = typeof Ye == "function" ? Ye(r2) : r2[Symbol.iterator](), n = {}, c("next"), c("throw"), c("return"), n[Symbol.asyncIterator] = function() {
            return this;
          }, n);
          function c(d) {
            n[d] = r2[d] && function(y) {
              return new Promise(function(E, I) {
                y = r2[d](y), h2(E, I, y.done, y.value);
              });
            };
          }
          function h2(d, y, E, I) {
            Promise.resolve(I).then(function(S2) {
              d({ value: S2, done: E });
            }, y);
          }
        }
        function Qt(r2, e2) {
          return Object.defineProperty ? Object.defineProperty(r2, "raw", { value: e2 }) : r2.raw = e2, r2;
        }
        function Ut(r2) {
          if (r2 && r2.__esModule)
            return r2;
          var e2 = {};
          if (r2 != null)
            for (var n in r2)
              Object.hasOwnProperty.call(r2, n) && (e2[n] = r2[n]);
          return e2.default = r2, e2;
        }
        function Kt(r2) {
          return r2 && r2.__esModule ? r2 : { default: r2 };
        }
        function $t(r2, e2) {
          if (!e2.has(r2))
            throw new TypeError("attempted to get private field on non-instance");
          return e2.get(r2);
        }
        function Jt(r2, e2, n) {
          if (!e2.has(r2))
            throw new TypeError("attempted to set private field on non-instance");
          return e2.set(r2, n), n;
        }
        var Re, qe, ae = xe({ "node_modules/tslib/tslib.es6.js"() {
          D(), Re = function(r2, e2) {
            return Re = Object.setPrototypeOf || { __proto__: [] } instanceof Array && function(n, c) {
              n.__proto__ = c;
            } || function(n, c) {
              for (var h2 in c)
                c.hasOwnProperty(h2) && (n[h2] = c[h2]);
            }, Re(r2, e2);
          }, qe = function() {
            return qe = Object.assign || function(e2) {
              for (var n, c = 1, h2 = arguments.length; c < h2; c++) {
                n = arguments[c];
                for (var d in n)
                  Object.prototype.hasOwnProperty.call(n, d) && (e2[d] = n[d]);
              }
              return e2;
            }, qe.apply(this, arguments);
          };
        } }), xt = F2({ "node_modules/yaml-unist-parser/node_modules/lines-and-columns/build/index.js"(r2) {
          "use strict";
          D(), r2.__esModule = true, r2.LinesAndColumns = void 0;
          var e2 = `
`, n = "\r", c = function() {
            function h2(d) {
              this.string = d;
              for (var y = [0], E = 0; E < d.length; )
                switch (d[E]) {
                  case e2:
                    E += e2.length, y.push(E);
                    break;
                  case n:
                    E += n.length, d[E] === e2 && (E += e2.length), y.push(E);
                    break;
                  default:
                    E++;
                    break;
                }
              this.offsets = y;
            }
            return h2.prototype.locationForIndex = function(d) {
              if (d < 0 || d > this.string.length)
                return null;
              for (var y = 0, E = this.offsets; E[y + 1] <= d; )
                y++;
              var I = d - E[y];
              return { line: y, column: I };
            }, h2.prototype.indexForLocation = function(d) {
              var y = d.line, E = d.column;
              return y < 0 || y >= this.offsets.length || E < 0 || E > this.lengthOfLine(y) ? null : this.offsets[y] + E;
            }, h2.prototype.lengthOfLine = function(d) {
              var y = this.offsets[d], E = d === this.offsets.length - 1 ? this.string.length : this.offsets[d + 1];
              return E - y;
            }, h2;
          }();
          r2.LinesAndColumns = c, r2.default = c;
        } }), Ht = F2({ "node_modules/yaml-unist-parser/lib/utils/define-parents.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c) {
            c === void 0 && (c = null), "children" in n && n.children.forEach(function(h2) {
              return e2(h2, n);
            }), "anchor" in n && n.anchor && e2(n.anchor, n), "tag" in n && n.tag && e2(n.tag, n), "leadingComments" in n && n.leadingComments.forEach(function(h2) {
              return e2(h2, n);
            }), "middleComments" in n && n.middleComments.forEach(function(h2) {
              return e2(h2, n);
            }), "indicatorComment" in n && n.indicatorComment && e2(n.indicatorComment, n), "trailingComment" in n && n.trailingComment && e2(n.trailingComment, n), "endComments" in n && n.endComments.forEach(function(h2) {
              return e2(h2, n);
            }), Object.defineProperty(n, "_parent", { value: c, enumerable: false });
          }
          r2.defineParents = e2;
        } }), We = F2({ "node_modules/yaml-unist-parser/lib/utils/get-point-text.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n) {
            return n.line + ":" + n.column;
          }
          r2.getPointText = e2;
        } }), Gt = F2({ "node_modules/yaml-unist-parser/lib/attach.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Ht(), n = We();
          function c(S2) {
            e2.defineParents(S2);
            var M = h2(S2), T = S2.children.slice();
            S2.comments.sort(function(P, C) {
              return P.position.start.offset - C.position.end.offset;
            }).filter(function(P) {
              return !P._parent;
            }).forEach(function(P) {
              for (; T.length > 1 && P.position.start.line > T[0].position.end.line; )
                T.shift();
              y(P, M, T[0]);
            });
          }
          r2.attachComments = c;
          function h2(S2) {
            for (var M = Array.from(new Array(S2.position.end.line), function() {
              return {};
            }), T = 0, P = S2.comments; T < P.length; T++) {
              var C = P[T];
              M[C.position.start.line - 1].comment = C;
            }
            return d(M, S2), M;
          }
          function d(S2, M) {
            if (M.position.start.offset !== M.position.end.offset) {
              if ("leadingComments" in M) {
                var T = M.position.start, P = S2[T.line - 1].leadingAttachableNode;
                (!P || T.column < P.position.start.column) && (S2[T.line - 1].leadingAttachableNode = M);
              }
              if ("trailingComment" in M && M.position.end.column > 1 && M.type !== "document" && M.type !== "documentHead") {
                var C = M.position.end, q = S2[C.line - 1].trailingAttachableNode;
                (!q || C.column >= q.position.end.column) && (S2[C.line - 1].trailingAttachableNode = M);
              }
              if (M.type !== "root" && M.type !== "document" && M.type !== "documentHead" && M.type !== "documentBody")
                for (var R = M.position, T = R.start, C = R.end, j = [C.line].concat(T.line === C.line ? [] : T.line), K = 0, m2 = j; K < m2.length; K++) {
                  var a = m2[K], t2 = S2[a - 1].trailingNode;
                  (!t2 || C.column >= t2.position.end.column) && (S2[a - 1].trailingNode = M);
                }
              "children" in M && M.children.forEach(function(s2) {
                d(S2, s2);
              });
            }
          }
          function y(S2, M, T) {
            var P = S2.position.start.line, C = M[P - 1].trailingAttachableNode;
            if (C) {
              if (C.trailingComment)
                throw new Error("Unexpected multiple trailing comment at " + n.getPointText(S2.position.start));
              e2.defineParents(S2, C), C.trailingComment = S2;
              return;
            }
            for (var q = P; q >= T.position.start.line; q--) {
              var R = M[q - 1].trailingNode, j = void 0;
              if (R)
                j = R;
              else if (q !== P && M[q - 1].comment)
                j = M[q - 1].comment._parent;
              else
                continue;
              if ((j.type === "sequence" || j.type === "mapping") && (j = j.children[0]), j.type === "mappingItem") {
                var K = j.children, m2 = K[0], a = K[1];
                j = I(m2) ? m2 : a;
              }
              for (; ; ) {
                if (E(j, S2)) {
                  e2.defineParents(S2, j), j.endComments.push(S2);
                  return;
                }
                if (!j._parent)
                  break;
                j = j._parent;
              }
              break;
            }
            for (var q = P + 1; q <= T.position.end.line; q++) {
              var t2 = M[q - 1].leadingAttachableNode;
              if (t2) {
                e2.defineParents(S2, t2), t2.leadingComments.push(S2);
                return;
              }
            }
            var s2 = T.children[1];
            e2.defineParents(S2, s2), s2.endComments.push(S2);
          }
          function E(S2, M) {
            if (S2.position.start.offset < M.position.start.offset && S2.position.end.offset > M.position.end.offset)
              switch (S2.type) {
                case "flowMapping":
                case "flowSequence":
                  return S2.children.length === 0 || M.position.start.line > S2.children[S2.children.length - 1].position.end.line;
              }
            if (M.position.end.offset < S2.position.end.offset)
              return false;
            switch (S2.type) {
              case "sequenceItem":
                return M.position.start.column > S2.position.start.column;
              case "mappingKey":
              case "mappingValue":
                return M.position.start.column > S2._parent.position.start.column && (S2.children.length === 0 || S2.children.length === 1 && S2.children[0].type !== "blockFolded" && S2.children[0].type !== "blockLiteral") && (S2.type === "mappingValue" || I(S2));
              default:
                return false;
            }
          }
          function I(S2) {
            return S2.position.start !== S2.position.end && (S2.children.length === 0 || S2.position.start.offset !== S2.children[0].position.start.offset);
          }
        } }), me = F2({ "node_modules/yaml-unist-parser/lib/factories/node.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c) {
            return { type: n, position: c };
          }
          r2.createNode = e2;
        } }), zt = F2({ "node_modules/yaml-unist-parser/lib/factories/root.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = me();
          function c(h2, d, y) {
            return e2.__assign(e2.__assign({}, n.createNode("root", h2)), { children: d, comments: y });
          }
          r2.createRoot = c;
        } }), Zt = F2({ "node_modules/yaml-unist-parser/lib/preprocess.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n) {
            switch (n.type) {
              case "DOCUMENT":
                for (var c = n.contents.length - 1; c >= 0; c--)
                  n.contents[c].type === "BLANK_LINE" ? n.contents.splice(c, 1) : e2(n.contents[c]);
                for (var c = n.directives.length - 1; c >= 0; c--)
                  n.directives[c].type === "BLANK_LINE" && n.directives.splice(c, 1);
                break;
              case "FLOW_MAP":
              case "FLOW_SEQ":
              case "MAP":
              case "SEQ":
                for (var c = n.items.length - 1; c >= 0; c--) {
                  var h2 = n.items[c];
                  "char" in h2 || (h2.type === "BLANK_LINE" ? n.items.splice(c, 1) : e2(h2));
                }
                break;
              case "MAP_KEY":
              case "MAP_VALUE":
              case "SEQ_ITEM":
                n.node && e2(n.node);
                break;
              case "ALIAS":
              case "BLANK_LINE":
              case "BLOCK_FOLDED":
              case "BLOCK_LITERAL":
              case "COMMENT":
              case "DIRECTIVE":
              case "PLAIN":
              case "QUOTE_DOUBLE":
              case "QUOTE_SINGLE":
                break;
              default:
                throw new Error("Unexpected node type " + JSON.stringify(n.type));
            }
          }
          r2.removeCstBlankLine = e2;
        } }), Oe = F2({ "node_modules/yaml-unist-parser/lib/factories/leading-comment-attachable.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2() {
            return { leadingComments: [] };
          }
          r2.createLeadingCommentAttachable = e2;
        } }), Be = F2({ "node_modules/yaml-unist-parser/lib/factories/trailing-comment-attachable.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n) {
            return n === void 0 && (n = null), { trailingComment: n };
          }
          r2.createTrailingCommentAttachable = e2;
        } }), Se = F2({ "node_modules/yaml-unist-parser/lib/factories/comment-attachable.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Oe(), c = Be();
          function h2() {
            return e2.__assign(e2.__assign({}, n.createLeadingCommentAttachable()), c.createTrailingCommentAttachable());
          }
          r2.createCommentAttachable = h2;
        } }), Xt = F2({ "node_modules/yaml-unist-parser/lib/factories/alias.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Se(), c = me();
          function h2(d, y, E) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, c.createNode("alias", d)), n.createCommentAttachable()), y), { value: E });
          }
          r2.createAlias = h2;
        } }), en = F2({ "node_modules/yaml-unist-parser/lib/transforms/alias.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Xt();
          function n(c, h2) {
            var d = c.cstNode;
            return e2.createAlias(h2.transformRange({ origStart: d.valueRange.origStart - 1, origEnd: d.valueRange.origEnd }), h2.transformContent(c), d.rawValue);
          }
          r2.transformAlias = n;
        } }), tn = F2({ "node_modules/yaml-unist-parser/lib/factories/block-folded.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te));
          function n(c) {
            return e2.__assign(e2.__assign({}, c), { type: "blockFolded" });
          }
          r2.createBlockFolded = n;
        } }), nn = F2({ "node_modules/yaml-unist-parser/lib/factories/block-value.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Oe(), c = me();
          function h2(d, y, E, I, S2, M) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, c.createNode("blockValue", d)), n.createLeadingCommentAttachable()), y), { chomping: E, indent: I, value: S2, indicatorComment: M });
          }
          r2.createBlockValue = h2;
        } }), Ge = F2({ "node_modules/yaml-unist-parser/lib/constants.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2;
          (function(n) {
            n.Tag = "!", n.Anchor = "&", n.Comment = "#";
          })(e2 = r2.PropLeadingCharacter || (r2.PropLeadingCharacter = {}));
        } }), rn = F2({ "node_modules/yaml-unist-parser/lib/factories/anchor.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = me();
          function c(h2, d) {
            return e2.__assign(e2.__assign({}, n.createNode("anchor", h2)), { value: d });
          }
          r2.createAnchor = c;
        } }), Ve = F2({ "node_modules/yaml-unist-parser/lib/factories/comment.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = me();
          function c(h2, d) {
            return e2.__assign(e2.__assign({}, n.createNode("comment", h2)), { value: d });
          }
          r2.createComment = c;
        } }), sn = F2({ "node_modules/yaml-unist-parser/lib/factories/content.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c, h2) {
            return { anchor: c, tag: n, middleComments: h2 };
          }
          r2.createContent = e2;
        } }), an = F2({ "node_modules/yaml-unist-parser/lib/factories/tag.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = me();
          function c(h2, d) {
            return e2.__assign(e2.__assign({}, n.createNode("tag", h2)), { value: d });
          }
          r2.createTag = c;
        } }), ze = F2({ "node_modules/yaml-unist-parser/lib/transforms/content.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Ge(), n = rn(), c = Ve(), h2 = sn(), d = an();
          function y(E, I, S2) {
            S2 === void 0 && (S2 = function() {
              return false;
            });
            for (var M = E.cstNode, T = [], P = null, C = null, q = null, R = 0, j = M.props; R < j.length; R++) {
              var K = j[R], m2 = I.text[K.origStart];
              switch (m2) {
                case e2.PropLeadingCharacter.Tag:
                  P = P || K, C = d.createTag(I.transformRange(K), E.tag);
                  break;
                case e2.PropLeadingCharacter.Anchor:
                  P = P || K, q = n.createAnchor(I.transformRange(K), M.anchor);
                  break;
                case e2.PropLeadingCharacter.Comment: {
                  var a = c.createComment(I.transformRange(K), I.text.slice(K.origStart + 1, K.origEnd));
                  I.comments.push(a), !S2(a) && P && P.origEnd <= K.origStart && K.origEnd <= M.valueRange.origStart && T.push(a);
                  break;
                }
                default:
                  throw new Error("Unexpected leading character " + JSON.stringify(m2));
              }
            }
            return h2.createContent(C, q, T);
          }
          r2.transformContent = y;
        } }), Ze = F2({ "node_modules/yaml-unist-parser/lib/transforms/block-value.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = nn(), n = We(), c = ze(), h2;
          (function(y) {
            y.CLIP = "clip", y.STRIP = "strip", y.KEEP = "keep";
          })(h2 || (h2 = {}));
          function d(y, E) {
            var I = y.cstNode, S2 = 1, M = I.chomping === "CLIP" ? 0 : 1, T = I.header.origEnd - I.header.origStart, P = T - S2 - M !== 0, C = E.transformRange({ origStart: I.header.origStart, origEnd: I.valueRange.origEnd }), q = null, R = c.transformContent(y, E, function(j) {
              var K = C.start.offset < j.position.start.offset && j.position.end.offset < C.end.offset;
              if (!K)
                return false;
              if (q)
                throw new Error("Unexpected multiple indicator comments at " + n.getPointText(j.position.start));
              return q = j, true;
            });
            return e2.createBlockValue(C, R, h2[I.chomping], P ? I.blockIndent : null, I.strValue, q);
          }
          r2.transformAstBlockValue = d;
        } }), on = F2({ "node_modules/yaml-unist-parser/lib/transforms/block-folded.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = tn(), n = Ze();
          function c(h2, d) {
            return e2.createBlockFolded(n.transformAstBlockValue(h2, d));
          }
          r2.transformBlockFolded = c;
        } }), ln = F2({ "node_modules/yaml-unist-parser/lib/factories/block-literal.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te));
          function n(c) {
            return e2.__assign(e2.__assign({}, c), { type: "blockLiteral" });
          }
          r2.createBlockLiteral = n;
        } }), cn = F2({ "node_modules/yaml-unist-parser/lib/transforms/block-literal.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = ln(), n = Ze();
          function c(h2, d) {
            return e2.createBlockLiteral(n.transformAstBlockValue(h2, d));
          }
          r2.transformBlockLiteral = c;
        } }), un = F2({ "node_modules/yaml-unist-parser/lib/transforms/comment.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Ve();
          function n(c, h2) {
            return e2.createComment(h2.transformRange(c.range), c.comment);
          }
          r2.transformComment = n;
        } }), fn = F2({ "node_modules/yaml-unist-parser/lib/factories/directive.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Se(), c = me();
          function h2(d, y, E) {
            return e2.__assign(e2.__assign(e2.__assign({}, c.createNode("directive", d)), n.createCommentAttachable()), { name: y, parameters: E });
          }
          r2.createDirective = h2;
        } }), Qe = F2({ "node_modules/yaml-unist-parser/lib/utils/extract-prop-comments.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Ge(), n = Ve();
          function c(h2, d) {
            for (var y = 0, E = h2.props; y < E.length; y++) {
              var I = E[y], S2 = d.text[I.origStart];
              switch (S2) {
                case e2.PropLeadingCharacter.Comment:
                  d.comments.push(n.createComment(d.transformRange(I), d.text.slice(I.origStart + 1, I.origEnd)));
                  break;
                default:
                  throw new Error("Unexpected leading character " + JSON.stringify(S2));
              }
            }
          }
          r2.extractPropComments = c;
        } }), mn = F2({ "node_modules/yaml-unist-parser/lib/transforms/directive.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = fn(), n = Qe();
          function c(h2, d) {
            return n.extractPropComments(h2, d), e2.createDirective(d.transformRange(h2.range), h2.name, h2.parameters);
          }
          r2.transformDirective = c;
        } }), dn = F2({ "node_modules/yaml-unist-parser/lib/factories/document.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = me(), c = Be();
          function h2(d, y, E, I) {
            return e2.__assign(e2.__assign(e2.__assign({}, n.createNode("document", d)), c.createTrailingCommentAttachable(I)), { children: [y, E] });
          }
          r2.createDocument = h2;
        } }), Le = F2({ "node_modules/yaml-unist-parser/lib/factories/position.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(c, h2) {
            return { start: c, end: h2 };
          }
          r2.createPosition = e2;
          function n(c) {
            return { start: c, end: c };
          }
          r2.createEmptyPosition = n;
        } }), Ee = F2({ "node_modules/yaml-unist-parser/lib/factories/end-comment-attachable.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n) {
            return n === void 0 && (n = []), { endComments: n };
          }
          r2.createEndCommentAttachable = e2;
        } }), hn = F2({ "node_modules/yaml-unist-parser/lib/factories/document-body.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Ee(), c = me();
          function h2(d, y, E) {
            return e2.__assign(e2.__assign(e2.__assign({}, c.createNode("documentBody", d)), n.createEndCommentAttachable(E)), { children: y ? [y] : [] });
          }
          r2.createDocumentBody = h2;
        } }), Ae = F2({ "node_modules/yaml-unist-parser/lib/utils/get-last.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n) {
            return n[n.length - 1];
          }
          r2.getLast = e2;
        } }), Xe = F2({ "node_modules/yaml-unist-parser/lib/utils/get-match-index.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c) {
            var h2 = n.match(c);
            return h2 ? h2.index : -1;
          }
          r2.getMatchIndex = e2;
        } }), gn = F2({ "node_modules/yaml-unist-parser/lib/transforms/document-body.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = hn(), c = Ae(), h2 = Xe(), d = We();
          function y(S2, M, T) {
            var P, C = S2.cstNode, q = E(C, M, T), R = q.comments, j = q.endComments, K = q.documentTrailingComment, m2 = q.documentHeadTrailingComment, a = M.transformNode(S2.contents), t2 = I(C, a, M), s2 = t2.position, i2 = t2.documentEndPoint;
            return (P = M.comments).push.apply(P, e2.__spreadArrays(R, j)), { documentBody: n.createDocumentBody(s2, a, j), documentEndPoint: i2, documentTrailingComment: K, documentHeadTrailingComment: m2 };
          }
          r2.transformDocumentBody = y;
          function E(S2, M, T) {
            for (var P = [], C = [], q = [], R = [], j = false, K = S2.contents.length - 1; K >= 0; K--) {
              var m2 = S2.contents[K];
              if (m2.type === "COMMENT") {
                var a = M.transformNode(m2);
                T && T.line === a.position.start.line ? R.unshift(a) : j ? P.unshift(a) : a.position.start.offset >= S2.valueRange.origEnd ? q.unshift(a) : P.unshift(a);
              } else
                j = true;
            }
            if (q.length > 1)
              throw new Error("Unexpected multiple document trailing comments at " + d.getPointText(q[1].position.start));
            if (R.length > 1)
              throw new Error("Unexpected multiple documentHead trailing comments at " + d.getPointText(R[1].position.start));
            return { comments: P, endComments: C, documentTrailingComment: c.getLast(q) || null, documentHeadTrailingComment: c.getLast(R) || null };
          }
          function I(S2, M, T) {
            var P = h2.getMatchIndex(T.text.slice(S2.valueRange.origEnd), /^\.\.\./), C = P === -1 ? S2.valueRange.origEnd : Math.max(0, S2.valueRange.origEnd - 1);
            T.text[C - 1] === "\r" && C--;
            var q = T.transformRange({ origStart: M !== null ? M.position.start.offset : C, origEnd: C }), R = P === -1 ? q.end : T.transformOffset(S2.valueRange.origEnd + 3);
            return { position: q, documentEndPoint: R };
          }
        } }), pn = F2({ "node_modules/yaml-unist-parser/lib/factories/document-head.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Ee(), c = me(), h2 = Be();
          function d(y, E, I, S2) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, c.createNode("documentHead", y)), n.createEndCommentAttachable(I)), h2.createTrailingCommentAttachable(S2)), { children: E });
          }
          r2.createDocumentHead = d;
        } }), _n = F2({ "node_modules/yaml-unist-parser/lib/transforms/document-head.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = pn(), c = Xe();
          function h2(E, I) {
            var S2, M = E.cstNode, T = d(M, I), P = T.directives, C = T.comments, q = T.endComments, R = y(M, P, I), j = R.position, K = R.endMarkerPoint;
            (S2 = I.comments).push.apply(S2, e2.__spreadArrays(C, q));
            var m2 = function(a) {
              return a && I.comments.push(a), n.createDocumentHead(j, P, q, a);
            };
            return { createDocumentHeadWithTrailingComment: m2, documentHeadEndMarkerPoint: K };
          }
          r2.transformDocumentHead = h2;
          function d(E, I) {
            for (var S2 = [], M = [], T = [], P = false, C = E.directives.length - 1; C >= 0; C--) {
              var q = I.transformNode(E.directives[C]);
              q.type === "comment" ? P ? M.unshift(q) : T.unshift(q) : (P = true, S2.unshift(q));
            }
            return { directives: S2, comments: M, endComments: T };
          }
          function y(E, I, S2) {
            var M = c.getMatchIndex(S2.text.slice(0, E.valueRange.origStart), /---\s*$/);
            M > 0 && !/[\r\n]/.test(S2.text[M - 1]) && (M = -1);
            var T = M === -1 ? { origStart: E.valueRange.origStart, origEnd: E.valueRange.origStart } : { origStart: M, origEnd: M + 3 };
            return I.length !== 0 && (T.origStart = I[0].position.start.offset), { position: S2.transformRange(T), endMarkerPoint: M === -1 ? null : S2.transformOffset(M) };
          }
        } }), vn = F2({ "node_modules/yaml-unist-parser/lib/transforms/document.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = dn(), n = Le(), c = gn(), h2 = _n();
          function d(y, E) {
            var I = h2.transformDocumentHead(y, E), S2 = I.createDocumentHeadWithTrailingComment, M = I.documentHeadEndMarkerPoint, T = c.transformDocumentBody(y, E, M), P = T.documentBody, C = T.documentEndPoint, q = T.documentTrailingComment, R = T.documentHeadTrailingComment, j = S2(R);
            return q && E.comments.push(q), e2.createDocument(n.createPosition(j.position.start, C), j, P, q);
          }
          r2.transformDocument = d;
        } }), et = F2({ "node_modules/yaml-unist-parser/lib/factories/flow-collection.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Se(), c = Ee(), h2 = me();
          function d(y, E, I) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, h2.createNode("flowCollection", y)), n.createCommentAttachable()), c.createEndCommentAttachable()), E), { children: I });
          }
          r2.createFlowCollection = d;
        } }), yn = F2({ "node_modules/yaml-unist-parser/lib/factories/flow-mapping.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = et();
          function c(h2, d, y) {
            return e2.__assign(e2.__assign({}, n.createFlowCollection(h2, d, y)), { type: "flowMapping" });
          }
          r2.createFlowMapping = c;
        } }), tt = F2({ "node_modules/yaml-unist-parser/lib/factories/flow-mapping-item.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Oe(), c = me();
          function h2(d, y, E) {
            return e2.__assign(e2.__assign(e2.__assign({}, c.createNode("flowMappingItem", d)), n.createLeadingCommentAttachable()), { children: [y, E] });
          }
          r2.createFlowMappingItem = h2;
        } }), je = F2({ "node_modules/yaml-unist-parser/lib/utils/extract-comments.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c) {
            for (var h2 = [], d = 0, y = n; d < y.length; d++) {
              var E = y[d];
              E && "type" in E && E.type === "COMMENT" ? c.comments.push(c.transformNode(E)) : h2.push(E);
            }
            return h2;
          }
          r2.extractComments = e2;
        } }), nt = F2({ "node_modules/yaml-unist-parser/lib/utils/get-flow-map-item-additional-ranges.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n) {
            var c = ["?", ":"].map(function(y) {
              var E = n.find(function(I) {
                return "char" in I && I.char === y;
              });
              return E ? { origStart: E.origOffset, origEnd: E.origOffset + 1 } : null;
            }), h2 = c[0], d = c[1];
            return { additionalKeyRange: h2, additionalValueRange: d };
          }
          r2.getFlowMapItemAdditionalRanges = e2;
        } }), rt = F2({ "node_modules/yaml-unist-parser/lib/utils/create-slicer.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c) {
            var h2 = c;
            return function(d) {
              return n.slice(h2, h2 = d);
            };
          }
          r2.createSlicer = e2;
        } }), st = F2({ "node_modules/yaml-unist-parser/lib/utils/group-cst-flow-collection-items.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = rt();
          function n(c) {
            for (var h2 = [], d = e2.createSlicer(c, 1), y = false, E = 1; E < c.length - 1; E++) {
              var I = c[E];
              if ("char" in I && I.char === ",") {
                h2.push(d(E)), d(E + 1), y = false;
                continue;
              }
              y = true;
            }
            return y && h2.push(d(c.length - 1)), h2;
          }
          r2.groupCstFlowCollectionItems = n;
        } }), bn = F2({ "node_modules/yaml-unist-parser/lib/factories/mapping-key.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Ee(), c = me(), h2 = Be();
          function d(y, E) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, c.createNode("mappingKey", y)), h2.createTrailingCommentAttachable()), n.createEndCommentAttachable()), { children: E ? [E] : [] });
          }
          r2.createMappingKey = d;
        } }), wn = F2({ "node_modules/yaml-unist-parser/lib/factories/mapping-value.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Se(), c = Ee(), h2 = me();
          function d(y, E) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, h2.createNode("mappingValue", y)), n.createCommentAttachable()), c.createEndCommentAttachable()), { children: E ? [E] : [] });
          }
          r2.createMappingValue = d;
        } }), Ue = F2({ "node_modules/yaml-unist-parser/lib/transforms/pair.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = bn(), n = wn(), c = Le();
          function h2(d, y, E, I, S2) {
            var M = y.transformNode(d.key), T = y.transformNode(d.value), P = M || I ? e2.createMappingKey(y.transformRange({ origStart: I ? I.origStart : M.position.start.offset, origEnd: M ? M.position.end.offset : I.origStart + 1 }), M) : null, C = T || S2 ? n.createMappingValue(y.transformRange({ origStart: S2 ? S2.origStart : T.position.start.offset, origEnd: T ? T.position.end.offset : S2.origStart + 1 }), T) : null;
            return E(c.createPosition(P ? P.position.start : C.position.start, C ? C.position.end : P.position.end), P || e2.createMappingKey(c.createEmptyPosition(C.position.start), null), C || n.createMappingValue(c.createEmptyPosition(P.position.end), null));
          }
          r2.transformAstPair = h2;
        } }), Sn = F2({ "node_modules/yaml-unist-parser/lib/transforms/flow-map.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = yn(), n = tt(), c = je(), h2 = nt(), d = Ae(), y = st(), E = Ue();
          function I(S2, M) {
            var T = c.extractComments(S2.cstNode.items, M), P = y.groupCstFlowCollectionItems(T), C = S2.items.map(function(j, K) {
              var m2 = P[K], a = h2.getFlowMapItemAdditionalRanges(m2), t2 = a.additionalKeyRange, s2 = a.additionalValueRange;
              return E.transformAstPair(j, M, n.createFlowMappingItem, t2, s2);
            }), q = T[0], R = d.getLast(T);
            return e2.createFlowMapping(M.transformRange({ origStart: q.origOffset, origEnd: R.origOffset + 1 }), M.transformContent(S2), C);
          }
          r2.transformFlowMap = I;
        } }), En = F2({ "node_modules/yaml-unist-parser/lib/factories/flow-sequence.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = et();
          function c(h2, d, y) {
            return e2.__assign(e2.__assign({}, n.createFlowCollection(h2, d, y)), { type: "flowSequence" });
          }
          r2.createFlowSequence = c;
        } }), Mn = F2({ "node_modules/yaml-unist-parser/lib/factories/flow-sequence-item.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = me();
          function c(h2, d) {
            return e2.__assign(e2.__assign({}, n.createNode("flowSequenceItem", h2)), { children: [d] });
          }
          r2.createFlowSequenceItem = c;
        } }), On = F2({ "node_modules/yaml-unist-parser/lib/transforms/flow-seq.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = tt(), n = En(), c = Mn(), h2 = Le(), d = je(), y = nt(), E = Ae(), I = st(), S2 = Ue();
          function M(T, P) {
            var C = d.extractComments(T.cstNode.items, P), q = I.groupCstFlowCollectionItems(C), R = T.items.map(function(m2, a) {
              if (m2.type !== "PAIR") {
                var t2 = P.transformNode(m2);
                return c.createFlowSequenceItem(h2.createPosition(t2.position.start, t2.position.end), t2);
              } else {
                var s2 = q[a], i2 = y.getFlowMapItemAdditionalRanges(s2), f3 = i2.additionalKeyRange, g = i2.additionalValueRange;
                return S2.transformAstPair(m2, P, e2.createFlowMappingItem, f3, g);
              }
            }), j = C[0], K = E.getLast(C);
            return n.createFlowSequence(P.transformRange({ origStart: j.origOffset, origEnd: K.origOffset + 1 }), P.transformContent(T), R);
          }
          r2.transformFlowSeq = M;
        } }), Ln = F2({ "node_modules/yaml-unist-parser/lib/factories/mapping.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Oe(), c = me();
          function h2(d, y, E) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, c.createNode("mapping", d)), n.createLeadingCommentAttachable()), y), { children: E });
          }
          r2.createMapping = h2;
        } }), An = F2({ "node_modules/yaml-unist-parser/lib/factories/mapping-item.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Oe(), c = me();
          function h2(d, y, E) {
            return e2.__assign(e2.__assign(e2.__assign({}, c.createNode("mappingItem", d)), n.createLeadingCommentAttachable()), { children: [y, E] });
          }
          r2.createMappingItem = h2;
        } }), Nn = F2({ "node_modules/yaml-unist-parser/lib/transforms/map.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Ln(), n = An(), c = Le(), h2 = rt(), d = je(), y = Qe(), E = Ae(), I = Ue();
          function S2(T, P) {
            var C = T.cstNode;
            C.items.filter(function(K) {
              return K.type === "MAP_KEY" || K.type === "MAP_VALUE";
            }).forEach(function(K) {
              return y.extractPropComments(K, P);
            });
            var q = d.extractComments(C.items, P), R = M(q), j = T.items.map(function(K, m2) {
              var a = R[m2], t2 = a[0].type === "MAP_VALUE" ? [null, a[0].range] : [a[0].range, a.length === 1 ? null : a[1].range], s2 = t2[0], i2 = t2[1];
              return I.transformAstPair(K, P, n.createMappingItem, s2, i2);
            });
            return e2.createMapping(c.createPosition(j[0].position.start, E.getLast(j).position.end), P.transformContent(T), j);
          }
          r2.transformMap = S2;
          function M(T) {
            for (var P = [], C = h2.createSlicer(T, 0), q = false, R = 0; R < T.length; R++) {
              var j = T[R];
              if (j.type === "MAP_VALUE") {
                P.push(C(R + 1)), q = false;
                continue;
              }
              q && P.push(C(R)), q = true;
            }
            return q && P.push(C(1 / 0)), P;
          }
        } }), Tn = F2({ "node_modules/yaml-unist-parser/lib/factories/plain.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Se(), c = me();
          function h2(d, y, E) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, c.createNode("plain", d)), n.createCommentAttachable()), y), { value: E });
          }
          r2.createPlain = h2;
        } }), Cn = F2({ "node_modules/yaml-unist-parser/lib/utils/find-last-char-index.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c, h2) {
            for (var d = c; d >= 0; d--)
              if (h2.test(n[d]))
                return d;
            return -1;
          }
          r2.findLastCharIndex = e2;
        } }), kn = F2({ "node_modules/yaml-unist-parser/lib/transforms/plain.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Tn(), n = Cn();
          function c(h2, d) {
            var y = h2.cstNode;
            return e2.createPlain(d.transformRange({ origStart: y.valueRange.origStart, origEnd: n.findLastCharIndex(d.text, y.valueRange.origEnd - 1, /\S/) + 1 }), d.transformContent(h2), y.strValue);
          }
          r2.transformPlain = c;
        } }), Pn = F2({ "node_modules/yaml-unist-parser/lib/factories/quote-double.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te));
          function n(c) {
            return e2.__assign(e2.__assign({}, c), { type: "quoteDouble" });
          }
          r2.createQuoteDouble = n;
        } }), In = F2({ "node_modules/yaml-unist-parser/lib/factories/quote-value.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Se(), c = me();
          function h2(d, y, E) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, c.createNode("quoteValue", d)), y), n.createCommentAttachable()), { value: E });
          }
          r2.createQuoteValue = h2;
        } }), at = F2({ "node_modules/yaml-unist-parser/lib/transforms/quote-value.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = In();
          function n(c, h2) {
            var d = c.cstNode;
            return e2.createQuoteValue(h2.transformRange(d.valueRange), h2.transformContent(c), d.strValue);
          }
          r2.transformAstQuoteValue = n;
        } }), Rn = F2({ "node_modules/yaml-unist-parser/lib/transforms/quote-double.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Pn(), n = at();
          function c(h2, d) {
            return e2.createQuoteDouble(n.transformAstQuoteValue(h2, d));
          }
          r2.transformQuoteDouble = c;
        } }), qn = F2({ "node_modules/yaml-unist-parser/lib/factories/quote-single.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te));
          function n(c) {
            return e2.__assign(e2.__assign({}, c), { type: "quoteSingle" });
          }
          r2.createQuoteSingle = n;
        } }), Bn = F2({ "node_modules/yaml-unist-parser/lib/transforms/quote-single.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = qn(), n = at();
          function c(h2, d) {
            return e2.createQuoteSingle(n.transformAstQuoteValue(h2, d));
          }
          r2.transformQuoteSingle = c;
        } }), jn = F2({ "node_modules/yaml-unist-parser/lib/factories/sequence.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Ee(), c = Oe(), h2 = me();
          function d(y, E, I) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, h2.createNode("sequence", y)), c.createLeadingCommentAttachable()), n.createEndCommentAttachable()), E), { children: I });
          }
          r2.createSequence = d;
        } }), Yn = F2({ "node_modules/yaml-unist-parser/lib/factories/sequence-item.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te)), n = Se(), c = Ee(), h2 = me();
          function d(y, E) {
            return e2.__assign(e2.__assign(e2.__assign(e2.__assign({}, h2.createNode("sequenceItem", y)), n.createCommentAttachable()), c.createEndCommentAttachable()), { children: E ? [E] : [] });
          }
          r2.createSequenceItem = d;
        } }), Dn = F2({ "node_modules/yaml-unist-parser/lib/transforms/seq.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Le(), n = jn(), c = Yn(), h2 = je(), d = Qe(), y = Ae();
          function E(I, S2) {
            var M = h2.extractComments(I.cstNode.items, S2), T = M.map(function(P, C) {
              d.extractPropComments(P, S2);
              var q = S2.transformNode(I.items[C]);
              return c.createSequenceItem(e2.createPosition(S2.transformOffset(P.valueRange.origStart), q === null ? S2.transformOffset(P.valueRange.origStart + 1) : q.position.end), q);
            });
            return n.createSequence(e2.createPosition(T[0].position.start, y.getLast(T).position.end), S2.transformContent(I), T);
          }
          r2.transformSeq = E;
        } }), Fn = F2({ "node_modules/yaml-unist-parser/lib/transform.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = en(), n = on(), c = cn(), h2 = un(), d = mn(), y = vn(), E = Sn(), I = On(), S2 = Nn(), M = kn(), T = Rn(), P = Bn(), C = Dn();
          function q(R, j) {
            if (R === null || R.type === void 0 && R.value === null)
              return null;
            switch (R.type) {
              case "ALIAS":
                return e2.transformAlias(R, j);
              case "BLOCK_FOLDED":
                return n.transformBlockFolded(R, j);
              case "BLOCK_LITERAL":
                return c.transformBlockLiteral(R, j);
              case "COMMENT":
                return h2.transformComment(R, j);
              case "DIRECTIVE":
                return d.transformDirective(R, j);
              case "DOCUMENT":
                return y.transformDocument(R, j);
              case "FLOW_MAP":
                return E.transformFlowMap(R, j);
              case "FLOW_SEQ":
                return I.transformFlowSeq(R, j);
              case "MAP":
                return S2.transformMap(R, j);
              case "PLAIN":
                return M.transformPlain(R, j);
              case "QUOTE_DOUBLE":
                return T.transformQuoteDouble(R, j);
              case "QUOTE_SINGLE":
                return P.transformQuoteSingle(R, j);
              case "SEQ":
                return C.transformSeq(R, j);
              default:
                throw new Error("Unexpected node type " + R.type);
            }
          }
          r2.transformNode = q;
        } }), Wn = F2({ "node_modules/yaml-unist-parser/lib/factories/error.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c, h2) {
            var d = new SyntaxError(n);
            return d.name = "YAMLSyntaxError", d.source = c, d.position = h2, d;
          }
          r2.createError = e2;
        } }), Vn = F2({ "node_modules/yaml-unist-parser/lib/transforms/error.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Wn();
          function n(c, h2) {
            var d = c.source.range || c.source.valueRange;
            return e2.createError(c.message, h2.text, h2.transformRange(d));
          }
          r2.transformError = n;
        } }), Qn = F2({ "node_modules/yaml-unist-parser/lib/factories/point.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c, h2) {
            return { offset: n, line: c, column: h2 };
          }
          r2.createPoint = e2;
        } }), Un = F2({ "node_modules/yaml-unist-parser/lib/transforms/offset.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Qn();
          function n(c, h2) {
            c < 0 ? c = 0 : c > h2.text.length && (c = h2.text.length);
            var d = h2.locator.locationForIndex(c);
            return e2.createPoint(c, d.line + 1, d.column + 1);
          }
          r2.transformOffset = n;
        } }), Kn = F2({ "node_modules/yaml-unist-parser/lib/transforms/range.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Le();
          function n(c, h2) {
            return e2.createPosition(h2.transformOffset(c.origStart), h2.transformOffset(c.origEnd));
          }
          r2.transformRange = n;
        } }), $n = F2({ "node_modules/yaml-unist-parser/lib/utils/add-orig-range.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = true;
          function n(y) {
            if (!y.setOrigRanges()) {
              var E = function(I) {
                if (h2(I))
                  return I.origStart = I.start, I.origEnd = I.end, e2;
                if (d(I))
                  return I.origOffset = I.offset, e2;
              };
              y.forEach(function(I) {
                return c(I, E);
              });
            }
          }
          r2.addOrigRange = n;
          function c(y, E) {
            if (!(!y || typeof y != "object") && E(y) !== e2)
              for (var I = 0, S2 = Object.keys(y); I < S2.length; I++) {
                var M = S2[I];
                if (!(M === "context" || M === "error")) {
                  var T = y[M];
                  Array.isArray(T) ? T.forEach(function(P) {
                    return c(P, E);
                  }) : c(T, E);
                }
              }
          }
          function h2(y) {
            return typeof y.start == "number";
          }
          function d(y) {
            return typeof y.offset == "number";
          }
        } }), Jn = F2({ "node_modules/yaml-unist-parser/lib/utils/remove-fake-nodes.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n) {
            if ("children" in n) {
              if (n.children.length === 1) {
                var c = n.children[0];
                if (c.type === "plain" && c.tag === null && c.anchor === null && c.value === "")
                  return n.children.splice(0, 1), n;
              }
              n.children.forEach(e2);
            }
            return n;
          }
          r2.removeFakeNodes = e2;
        } }), xn = F2({ "node_modules/yaml-unist-parser/lib/utils/create-updater.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          function e2(n, c, h2, d) {
            var y = c(n);
            return function(E) {
              d(y, E) && h2(n, y = E);
            };
          }
          r2.createUpdater = e2;
        } }), Hn = F2({ "node_modules/yaml-unist-parser/lib/utils/update-positions.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = xn(), n = Ae();
          function c(M) {
            if (!(M === null || !("children" in M))) {
              var T = M.children;
              if (T.forEach(c), M.type === "document") {
                var P = M.children, C = P[0], q = P[1];
                C.position.start.offset === C.position.end.offset ? C.position.start = C.position.end = q.position.start : q.position.start.offset === q.position.end.offset && (q.position.start = q.position.end = C.position.end);
              }
              var R = e2.createUpdater(M.position, h2, d, I), j = e2.createUpdater(M.position, y, E, S2);
              "endComments" in M && M.endComments.length !== 0 && (R(M.endComments[0].position.start), j(n.getLast(M.endComments).position.end));
              var K = T.filter(function(t2) {
                return t2 !== null;
              });
              if (K.length !== 0) {
                var m2 = K[0], a = n.getLast(K);
                R(m2.position.start), j(a.position.end), "leadingComments" in m2 && m2.leadingComments.length !== 0 && R(m2.leadingComments[0].position.start), "tag" in m2 && m2.tag && R(m2.tag.position.start), "anchor" in m2 && m2.anchor && R(m2.anchor.position.start), "trailingComment" in a && a.trailingComment && j(a.trailingComment.position.end);
              }
            }
          }
          r2.updatePositions = c;
          function h2(M) {
            return M.start;
          }
          function d(M, T) {
            M.start = T;
          }
          function y(M) {
            return M.end;
          }
          function E(M, T) {
            M.end = T;
          }
          function I(M, T) {
            return T.offset < M.offset;
          }
          function S2(M, T) {
            return T.offset > M.offset;
          }
        } }), Me = F2({ "node_modules/yaml/dist/PlainValue-ec8e588e.js"(r2) {
          "use strict";
          D();
          var e2 = { ANCHOR: "&", COMMENT: "#", TAG: "!", DIRECTIVES_END: "-", DOCUMENT_END: "." }, n = { ALIAS: "ALIAS", BLANK_LINE: "BLANK_LINE", BLOCK_FOLDED: "BLOCK_FOLDED", BLOCK_LITERAL: "BLOCK_LITERAL", COMMENT: "COMMENT", DIRECTIVE: "DIRECTIVE", DOCUMENT: "DOCUMENT", FLOW_MAP: "FLOW_MAP", FLOW_SEQ: "FLOW_SEQ", MAP: "MAP", MAP_KEY: "MAP_KEY", MAP_VALUE: "MAP_VALUE", PLAIN: "PLAIN", QUOTE_DOUBLE: "QUOTE_DOUBLE", QUOTE_SINGLE: "QUOTE_SINGLE", SEQ: "SEQ", SEQ_ITEM: "SEQ_ITEM" }, c = "tag:yaml.org,2002:", h2 = { MAP: "tag:yaml.org,2002:map", SEQ: "tag:yaml.org,2002:seq", STR: "tag:yaml.org,2002:str" };
          function d(a) {
            let t2 = [0], s2 = a.indexOf(`
`);
            for (; s2 !== -1; )
              s2 += 1, t2.push(s2), s2 = a.indexOf(`
`, s2);
            return t2;
          }
          function y(a) {
            let t2, s2;
            return typeof a == "string" ? (t2 = d(a), s2 = a) : (Array.isArray(a) && (a = a[0]), a && a.context && (a.lineStarts || (a.lineStarts = d(a.context.src)), t2 = a.lineStarts, s2 = a.context.src)), { lineStarts: t2, src: s2 };
          }
          function E(a, t2) {
            if (typeof a != "number" || a < 0)
              return null;
            let { lineStarts: s2, src: i2 } = y(t2);
            if (!s2 || !i2 || a > i2.length)
              return null;
            for (let g = 0; g < s2.length; ++g) {
              let u = s2[g];
              if (a < u)
                return { line: g, col: a - s2[g - 1] + 1 };
              if (a === u)
                return { line: g + 1, col: 1 };
            }
            let f3 = s2.length;
            return { line: f3, col: a - s2[f3 - 1] + 1 };
          }
          function I(a, t2) {
            let { lineStarts: s2, src: i2 } = y(t2);
            if (!s2 || !(a >= 1) || a > s2.length)
              return null;
            let f3 = s2[a - 1], g = s2[a];
            for (; g && g > f3 && i2[g - 1] === `
`; )
              --g;
            return i2.slice(f3, g);
          }
          function S2(a, t2) {
            let { start: s2, end: i2 } = a, f3 = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : 80, g = I(s2.line, t2);
            if (!g)
              return null;
            let { col: u } = s2;
            if (g.length > f3)
              if (u <= f3 - 10)
                g = g.substr(0, f3 - 1) + "\u2026";
              else {
                let $ = Math.round(f3 / 2);
                g.length > u + $ && (g = g.substr(0, u + $ - 1) + "\u2026"), u -= g.length - f3, g = "\u2026" + g.substr(1 - f3);
              }
            let p = 1, L = "";
            i2 && (i2.line === s2.line && u + (i2.col - s2.col) <= f3 + 1 ? p = i2.col - s2.col : (p = Math.min(g.length + 1, f3) - u, L = "\u2026"));
            let k = u > 1 ? " ".repeat(u - 1) : "", B = "^".repeat(p);
            return "".concat(g, `
`).concat(k).concat(B).concat(L);
          }
          var M = class {
            static copy(a) {
              return new M(a.start, a.end);
            }
            constructor(a, t2) {
              this.start = a, this.end = t2 || a;
            }
            isEmpty() {
              return typeof this.start != "number" || !this.end || this.end <= this.start;
            }
            setOrigRange(a, t2) {
              let { start: s2, end: i2 } = this;
              if (a.length === 0 || i2 <= a[0])
                return this.origStart = s2, this.origEnd = i2, t2;
              let f3 = t2;
              for (; f3 < a.length && !(a[f3] > s2); )
                ++f3;
              this.origStart = s2 + f3;
              let g = f3;
              for (; f3 < a.length && !(a[f3] >= i2); )
                ++f3;
              return this.origEnd = i2 + f3, g;
            }
          }, T = class {
            static addStringTerminator(a, t2, s2) {
              if (s2[s2.length - 1] === `
`)
                return s2;
              let i2 = T.endOfWhiteSpace(a, t2);
              return i2 >= a.length || a[i2] === `
` ? s2 + `
` : s2;
            }
            static atDocumentBoundary(a, t2, s2) {
              let i2 = a[t2];
              if (!i2)
                return true;
              let f3 = a[t2 - 1];
              if (f3 && f3 !== `
`)
                return false;
              if (s2) {
                if (i2 !== s2)
                  return false;
              } else if (i2 !== e2.DIRECTIVES_END && i2 !== e2.DOCUMENT_END)
                return false;
              let g = a[t2 + 1], u = a[t2 + 2];
              if (g !== i2 || u !== i2)
                return false;
              let p = a[t2 + 3];
              return !p || p === `
` || p === "	" || p === " ";
            }
            static endOfIdentifier(a, t2) {
              let s2 = a[t2], i2 = s2 === "<", f3 = i2 ? [`
`, "	", " ", ">"] : [`
`, "	", " ", "[", "]", "{", "}", ","];
              for (; s2 && f3.indexOf(s2) === -1; )
                s2 = a[t2 += 1];
              return i2 && s2 === ">" && (t2 += 1), t2;
            }
            static endOfIndent(a, t2) {
              let s2 = a[t2];
              for (; s2 === " "; )
                s2 = a[t2 += 1];
              return t2;
            }
            static endOfLine(a, t2) {
              let s2 = a[t2];
              for (; s2 && s2 !== `
`; )
                s2 = a[t2 += 1];
              return t2;
            }
            static endOfWhiteSpace(a, t2) {
              let s2 = a[t2];
              for (; s2 === "	" || s2 === " "; )
                s2 = a[t2 += 1];
              return t2;
            }
            static startOfLine(a, t2) {
              let s2 = a[t2 - 1];
              if (s2 === `
`)
                return t2;
              for (; s2 && s2 !== `
`; )
                s2 = a[t2 -= 1];
              return t2 + 1;
            }
            static endOfBlockIndent(a, t2, s2) {
              let i2 = T.endOfIndent(a, s2);
              if (i2 > s2 + t2)
                return i2;
              {
                let f3 = T.endOfWhiteSpace(a, i2), g = a[f3];
                if (!g || g === `
`)
                  return f3;
              }
              return null;
            }
            static atBlank(a, t2, s2) {
              let i2 = a[t2];
              return i2 === `
` || i2 === "	" || i2 === " " || s2 && !i2;
            }
            static nextNodeIsIndented(a, t2, s2) {
              return !a || t2 < 0 ? false : t2 > 0 ? true : s2 && a === "-";
            }
            static normalizeOffset(a, t2) {
              let s2 = a[t2];
              return s2 ? s2 !== `
` && a[t2 - 1] === `
` ? t2 - 1 : T.endOfWhiteSpace(a, t2) : t2;
            }
            static foldNewline(a, t2, s2) {
              let i2 = 0, f3 = false, g = "", u = a[t2 + 1];
              for (; u === " " || u === "	" || u === `
`; ) {
                switch (u) {
                  case `
`:
                    i2 = 0, t2 += 1, g += `
`;
                    break;
                  case "	":
                    i2 <= s2 && (f3 = true), t2 = T.endOfWhiteSpace(a, t2 + 2) - 1;
                    break;
                  case " ":
                    i2 += 1, t2 += 1;
                    break;
                }
                u = a[t2 + 1];
              }
              return g || (g = " "), u && i2 <= s2 && (f3 = true), { fold: g, offset: t2, error: f3 };
            }
            constructor(a, t2, s2) {
              Object.defineProperty(this, "context", { value: s2 || null, writable: true }), this.error = null, this.range = null, this.valueRange = null, this.props = t2 || [], this.type = a, this.value = null;
            }
            getPropValue(a, t2, s2) {
              if (!this.context)
                return null;
              let { src: i2 } = this.context, f3 = this.props[a];
              return f3 && i2[f3.start] === t2 ? i2.slice(f3.start + (s2 ? 1 : 0), f3.end) : null;
            }
            get anchor() {
              for (let a = 0; a < this.props.length; ++a) {
                let t2 = this.getPropValue(a, e2.ANCHOR, true);
                if (t2 != null)
                  return t2;
              }
              return null;
            }
            get comment() {
              let a = [];
              for (let t2 = 0; t2 < this.props.length; ++t2) {
                let s2 = this.getPropValue(t2, e2.COMMENT, true);
                s2 != null && a.push(s2);
              }
              return a.length > 0 ? a.join(`
`) : null;
            }
            commentHasRequiredWhitespace(a) {
              let { src: t2 } = this.context;
              if (this.header && a === this.header.end || !this.valueRange)
                return false;
              let { end: s2 } = this.valueRange;
              return a !== s2 || T.atBlank(t2, s2 - 1);
            }
            get hasComment() {
              if (this.context) {
                let { src: a } = this.context;
                for (let t2 = 0; t2 < this.props.length; ++t2)
                  if (a[this.props[t2].start] === e2.COMMENT)
                    return true;
              }
              return false;
            }
            get hasProps() {
              if (this.context) {
                let { src: a } = this.context;
                for (let t2 = 0; t2 < this.props.length; ++t2)
                  if (a[this.props[t2].start] !== e2.COMMENT)
                    return true;
              }
              return false;
            }
            get includesTrailingLines() {
              return false;
            }
            get jsonLike() {
              return [n.FLOW_MAP, n.FLOW_SEQ, n.QUOTE_DOUBLE, n.QUOTE_SINGLE].indexOf(this.type) !== -1;
            }
            get rangeAsLinePos() {
              if (!this.range || !this.context)
                return;
              let a = E(this.range.start, this.context.root);
              if (!a)
                return;
              let t2 = E(this.range.end, this.context.root);
              return { start: a, end: t2 };
            }
            get rawValue() {
              if (!this.valueRange || !this.context)
                return null;
              let { start: a, end: t2 } = this.valueRange;
              return this.context.src.slice(a, t2);
            }
            get tag() {
              for (let a = 0; a < this.props.length; ++a) {
                let t2 = this.getPropValue(a, e2.TAG, false);
                if (t2 != null) {
                  if (t2[1] === "<")
                    return { verbatim: t2.slice(2, -1) };
                  {
                    let [s2, i2, f3] = t2.match(/^(.*!)([^!]*)$/);
                    return { handle: i2, suffix: f3 };
                  }
                }
              }
              return null;
            }
            get valueRangeContainsNewline() {
              if (!this.valueRange || !this.context)
                return false;
              let { start: a, end: t2 } = this.valueRange, { src: s2 } = this.context;
              for (let i2 = a; i2 < t2; ++i2)
                if (s2[i2] === `
`)
                  return true;
              return false;
            }
            parseComment(a) {
              let { src: t2 } = this.context;
              if (t2[a] === e2.COMMENT) {
                let s2 = T.endOfLine(t2, a + 1), i2 = new M(a, s2);
                return this.props.push(i2), s2;
              }
              return a;
            }
            setOrigRanges(a, t2) {
              return this.range && (t2 = this.range.setOrigRange(a, t2)), this.valueRange && this.valueRange.setOrigRange(a, t2), this.props.forEach((s2) => s2.setOrigRange(a, t2)), t2;
            }
            toString() {
              let { context: { src: a }, range: t2, value: s2 } = this;
              if (s2 != null)
                return s2;
              let i2 = a.slice(t2.start, t2.end);
              return T.addStringTerminator(a, t2.end, i2);
            }
          }, P = class extends Error {
            constructor(a, t2, s2) {
              if (!s2 || !(t2 instanceof T))
                throw new Error("Invalid arguments for new ".concat(a));
              super(), this.name = a, this.message = s2, this.source = t2;
            }
            makePretty() {
              if (!this.source)
                return;
              this.nodeType = this.source.type;
              let a = this.source.context && this.source.context.root;
              if (typeof this.offset == "number") {
                this.range = new M(this.offset, this.offset + 1);
                let t2 = a && E(this.offset, a);
                if (t2) {
                  let s2 = { line: t2.line, col: t2.col + 1 };
                  this.linePos = { start: t2, end: s2 };
                }
                delete this.offset;
              } else
                this.range = this.source.range, this.linePos = this.source.rangeAsLinePos;
              if (this.linePos) {
                let { line: t2, col: s2 } = this.linePos.start;
                this.message += " at line ".concat(t2, ", column ").concat(s2);
                let i2 = a && S2(this.linePos, a);
                i2 && (this.message += `:

`.concat(i2, `
`));
              }
              delete this.source;
            }
          }, C = class extends P {
            constructor(a, t2) {
              super("YAMLReferenceError", a, t2);
            }
          }, q = class extends P {
            constructor(a, t2) {
              super("YAMLSemanticError", a, t2);
            }
          }, R = class extends P {
            constructor(a, t2) {
              super("YAMLSyntaxError", a, t2);
            }
          }, j = class extends P {
            constructor(a, t2) {
              super("YAMLWarning", a, t2);
            }
          };
          function K(a, t2, s2) {
            return t2 in a ? Object.defineProperty(a, t2, { value: s2, enumerable: true, configurable: true, writable: true }) : a[t2] = s2, a;
          }
          var m2 = class extends T {
            static endOfLine(a, t2, s2) {
              let i2 = a[t2], f3 = t2;
              for (; i2 && i2 !== `
` && !(s2 && (i2 === "[" || i2 === "]" || i2 === "{" || i2 === "}" || i2 === ",")); ) {
                let g = a[f3 + 1];
                if (i2 === ":" && (!g || g === `
` || g === "	" || g === " " || s2 && g === ",") || (i2 === " " || i2 === "	") && g === "#")
                  break;
                f3 += 1, i2 = g;
              }
              return f3;
            }
            get strValue() {
              if (!this.valueRange || !this.context)
                return null;
              let { start: a, end: t2 } = this.valueRange, { src: s2 } = this.context, i2 = s2[t2 - 1];
              for (; a < t2 && (i2 === `
` || i2 === "	" || i2 === " "); )
                i2 = s2[--t2 - 1];
              let f3 = "";
              for (let u = a; u < t2; ++u) {
                let p = s2[u];
                if (p === `
`) {
                  let { fold: L, offset: k } = T.foldNewline(s2, u, -1);
                  f3 += L, u = k;
                } else if (p === " " || p === "	") {
                  let L = u, k = s2[u + 1];
                  for (; u < t2 && (k === " " || k === "	"); )
                    u += 1, k = s2[u + 1];
                  k !== `
` && (f3 += u > L ? s2.slice(L, u + 1) : p);
                } else
                  f3 += p;
              }
              let g = s2[a];
              switch (g) {
                case "	": {
                  let u = "Plain value cannot start with a tab character";
                  return { errors: [new q(this, u)], str: f3 };
                }
                case "@":
                case "`": {
                  let u = "Plain value cannot start with reserved character ".concat(g);
                  return { errors: [new q(this, u)], str: f3 };
                }
                default:
                  return f3;
              }
            }
            parseBlockValue(a) {
              let { indent: t2, inFlow: s2, src: i2 } = this.context, f3 = a, g = a;
              for (let u = i2[f3]; u === `
` && !T.atDocumentBoundary(i2, f3 + 1); u = i2[f3]) {
                let p = T.endOfBlockIndent(i2, t2, f3 + 1);
                if (p === null || i2[p] === "#")
                  break;
                i2[p] === `
` ? f3 = p : (g = m2.endOfLine(i2, p, s2), f3 = g);
              }
              return this.valueRange.isEmpty() && (this.valueRange.start = a), this.valueRange.end = g, g;
            }
            parse(a, t2) {
              this.context = a;
              let { inFlow: s2, src: i2 } = a, f3 = t2, g = i2[f3];
              return g && g !== "#" && g !== `
` && (f3 = m2.endOfLine(i2, t2, s2)), this.valueRange = new M(t2, f3), f3 = T.endOfWhiteSpace(i2, f3), f3 = this.parseComment(f3), (!this.hasComment || this.valueRange.isEmpty()) && (f3 = this.parseBlockValue(f3)), f3;
            }
          };
          r2.Char = e2, r2.Node = T, r2.PlainValue = m2, r2.Range = M, r2.Type = n, r2.YAMLError = P, r2.YAMLReferenceError = C, r2.YAMLSemanticError = q, r2.YAMLSyntaxError = R, r2.YAMLWarning = j, r2._defineProperty = K, r2.defaultTagPrefix = c, r2.defaultTags = h2;
        } }), Gn = F2({ "node_modules/yaml/dist/parse-cst.js"(r2) {
          "use strict";
          D();
          var e2 = Me(), n = class extends e2.Node {
            constructor() {
              super(e2.Type.BLANK_LINE);
            }
            get includesTrailingLines() {
              return true;
            }
            parse(m2, a) {
              return this.context = m2, this.range = new e2.Range(a, a + 1), a + 1;
            }
          }, c = class extends e2.Node {
            constructor(m2, a) {
              super(m2, a), this.node = null;
            }
            get includesTrailingLines() {
              return !!this.node && this.node.includesTrailingLines;
            }
            parse(m2, a) {
              this.context = m2;
              let { parseNode: t2, src: s2 } = m2, { atLineStart: i2, lineStart: f3 } = m2;
              !i2 && this.type === e2.Type.SEQ_ITEM && (this.error = new e2.YAMLSemanticError(this, "Sequence items must not have preceding content on the same line"));
              let g = i2 ? a - f3 : m2.indent, u = e2.Node.endOfWhiteSpace(s2, a + 1), p = s2[u], L = p === "#", k = [], B = null;
              for (; p === `
` || p === "#"; ) {
                if (p === "#") {
                  let Q = e2.Node.endOfLine(s2, u + 1);
                  k.push(new e2.Range(u, Q)), u = Q;
                } else {
                  i2 = true, f3 = u + 1;
                  let Q = e2.Node.endOfWhiteSpace(s2, f3);
                  s2[Q] === `
` && k.length === 0 && (B = new n(), f3 = B.parse({ src: s2 }, f3)), u = e2.Node.endOfIndent(s2, f3);
                }
                p = s2[u];
              }
              if (e2.Node.nextNodeIsIndented(p, u - (f3 + g), this.type !== e2.Type.SEQ_ITEM) ? this.node = t2({ atLineStart: i2, inCollection: false, indent: g, lineStart: f3, parent: this }, u) : p && f3 > a + 1 && (u = f3 - 1), this.node) {
                if (B) {
                  let Q = m2.parent.items || m2.parent.contents;
                  Q && Q.push(B);
                }
                k.length && Array.prototype.push.apply(this.props, k), u = this.node.range.end;
              } else if (L) {
                let Q = k[0];
                this.props.push(Q), u = Q.end;
              } else
                u = e2.Node.endOfLine(s2, a + 1);
              let $ = this.node ? this.node.valueRange.end : u;
              return this.valueRange = new e2.Range(a, $), u;
            }
            setOrigRanges(m2, a) {
              return a = super.setOrigRanges(m2, a), this.node ? this.node.setOrigRanges(m2, a) : a;
            }
            toString() {
              let { context: { src: m2 }, node: a, range: t2, value: s2 } = this;
              if (s2 != null)
                return s2;
              let i2 = a ? m2.slice(t2.start, a.range.start) + String(a) : m2.slice(t2.start, t2.end);
              return e2.Node.addStringTerminator(m2, t2.end, i2);
            }
          }, h2 = class extends e2.Node {
            constructor() {
              super(e2.Type.COMMENT);
            }
            parse(m2, a) {
              this.context = m2;
              let t2 = this.parseComment(a);
              return this.range = new e2.Range(a, t2), t2;
            }
          };
          function d(m2) {
            let a = m2;
            for (; a instanceof c; )
              a = a.node;
            if (!(a instanceof y))
              return null;
            let t2 = a.items.length, s2 = -1;
            for (let g = t2 - 1; g >= 0; --g) {
              let u = a.items[g];
              if (u.type === e2.Type.COMMENT) {
                let { indent: p, lineStart: L } = u.context;
                if (p > 0 && u.range.start >= L + p)
                  break;
                s2 = g;
              } else if (u.type === e2.Type.BLANK_LINE)
                s2 = g;
              else
                break;
            }
            if (s2 === -1)
              return null;
            let i2 = a.items.splice(s2, t2 - s2), f3 = i2[0].range.start;
            for (; a.range.end = f3, a.valueRange && a.valueRange.end > f3 && (a.valueRange.end = f3), a !== m2; )
              a = a.context.parent;
            return i2;
          }
          var y = class extends e2.Node {
            static nextContentHasIndent(m2, a, t2) {
              let s2 = e2.Node.endOfLine(m2, a) + 1;
              a = e2.Node.endOfWhiteSpace(m2, s2);
              let i2 = m2[a];
              return i2 ? a >= s2 + t2 ? true : i2 !== "#" && i2 !== `
` ? false : y.nextContentHasIndent(m2, a, t2) : false;
            }
            constructor(m2) {
              super(m2.type === e2.Type.SEQ_ITEM ? e2.Type.SEQ : e2.Type.MAP);
              for (let t2 = m2.props.length - 1; t2 >= 0; --t2)
                if (m2.props[t2].start < m2.context.lineStart) {
                  this.props = m2.props.slice(0, t2 + 1), m2.props = m2.props.slice(t2 + 1);
                  let s2 = m2.props[0] || m2.valueRange;
                  m2.range.start = s2.start;
                  break;
                }
              this.items = [m2];
              let a = d(m2);
              a && Array.prototype.push.apply(this.items, a);
            }
            get includesTrailingLines() {
              return this.items.length > 0;
            }
            parse(m2, a) {
              this.context = m2;
              let { parseNode: t2, src: s2 } = m2, i2 = e2.Node.startOfLine(s2, a), f3 = this.items[0];
              f3.context.parent = this, this.valueRange = e2.Range.copy(f3.valueRange);
              let g = f3.range.start - f3.context.lineStart, u = a;
              u = e2.Node.normalizeOffset(s2, u);
              let p = s2[u], L = e2.Node.endOfWhiteSpace(s2, i2) === u, k = false;
              for (; p; ) {
                for (; p === `
` || p === "#"; ) {
                  if (L && p === `
` && !k) {
                    let Q = new n();
                    if (u = Q.parse({ src: s2 }, u), this.valueRange.end = u, u >= s2.length) {
                      p = null;
                      break;
                    }
                    this.items.push(Q), u -= 1;
                  } else if (p === "#") {
                    if (u < i2 + g && !y.nextContentHasIndent(s2, u, g))
                      return u;
                    let Q = new h2();
                    if (u = Q.parse({ indent: g, lineStart: i2, src: s2 }, u), this.items.push(Q), this.valueRange.end = u, u >= s2.length) {
                      p = null;
                      break;
                    }
                  }
                  if (i2 = u + 1, u = e2.Node.endOfIndent(s2, i2), e2.Node.atBlank(s2, u)) {
                    let Q = e2.Node.endOfWhiteSpace(s2, u), z = s2[Q];
                    (!z || z === `
` || z === "#") && (u = Q);
                  }
                  p = s2[u], L = true;
                }
                if (!p)
                  break;
                if (u !== i2 + g && (L || p !== ":")) {
                  if (u < i2 + g) {
                    i2 > a && (u = i2);
                    break;
                  } else if (!this.error) {
                    let Q = "All collection items must start at the same column";
                    this.error = new e2.YAMLSyntaxError(this, Q);
                  }
                }
                if (f3.type === e2.Type.SEQ_ITEM) {
                  if (p !== "-") {
                    i2 > a && (u = i2);
                    break;
                  }
                } else if (p === "-" && !this.error) {
                  let Q = s2[u + 1];
                  if (!Q || Q === `
` || Q === "	" || Q === " ") {
                    let z = "A collection cannot be both a mapping and a sequence";
                    this.error = new e2.YAMLSyntaxError(this, z);
                  }
                }
                let B = t2({ atLineStart: L, inCollection: true, indent: g, lineStart: i2, parent: this }, u);
                if (!B)
                  return u;
                if (this.items.push(B), this.valueRange.end = B.valueRange.end, u = e2.Node.normalizeOffset(s2, B.range.end), p = s2[u], L = false, k = B.includesTrailingLines, p) {
                  let Q = u - 1, z = s2[Q];
                  for (; z === " " || z === "	"; )
                    z = s2[--Q];
                  z === `
` && (i2 = Q + 1, L = true);
                }
                let $ = d(B);
                $ && Array.prototype.push.apply(this.items, $);
              }
              return u;
            }
            setOrigRanges(m2, a) {
              return a = super.setOrigRanges(m2, a), this.items.forEach((t2) => {
                a = t2.setOrigRanges(m2, a);
              }), a;
            }
            toString() {
              let { context: { src: m2 }, items: a, range: t2, value: s2 } = this;
              if (s2 != null)
                return s2;
              let i2 = m2.slice(t2.start, a[0].range.start) + String(a[0]);
              for (let f3 = 1; f3 < a.length; ++f3) {
                let g = a[f3], { atLineStart: u, indent: p } = g.context;
                if (u)
                  for (let L = 0; L < p; ++L)
                    i2 += " ";
                i2 += String(g);
              }
              return e2.Node.addStringTerminator(m2, t2.end, i2);
            }
          }, E = class extends e2.Node {
            constructor() {
              super(e2.Type.DIRECTIVE), this.name = null;
            }
            get parameters() {
              let m2 = this.rawValue;
              return m2 ? m2.trim().split(/[ \t]+/) : [];
            }
            parseName(m2) {
              let { src: a } = this.context, t2 = m2, s2 = a[t2];
              for (; s2 && s2 !== `
` && s2 !== "	" && s2 !== " "; )
                s2 = a[t2 += 1];
              return this.name = a.slice(m2, t2), t2;
            }
            parseParameters(m2) {
              let { src: a } = this.context, t2 = m2, s2 = a[t2];
              for (; s2 && s2 !== `
` && s2 !== "#"; )
                s2 = a[t2 += 1];
              return this.valueRange = new e2.Range(m2, t2), t2;
            }
            parse(m2, a) {
              this.context = m2;
              let t2 = this.parseName(a + 1);
              return t2 = this.parseParameters(t2), t2 = this.parseComment(t2), this.range = new e2.Range(a, t2), t2;
            }
          }, I = class extends e2.Node {
            static startCommentOrEndBlankLine(m2, a) {
              let t2 = e2.Node.endOfWhiteSpace(m2, a), s2 = m2[t2];
              return s2 === "#" || s2 === `
` ? t2 : a;
            }
            constructor() {
              super(e2.Type.DOCUMENT), this.directives = null, this.contents = null, this.directivesEndMarker = null, this.documentEndMarker = null;
            }
            parseDirectives(m2) {
              let { src: a } = this.context;
              this.directives = [];
              let t2 = true, s2 = false, i2 = m2;
              for (; !e2.Node.atDocumentBoundary(a, i2, e2.Char.DIRECTIVES_END); )
                switch (i2 = I.startCommentOrEndBlankLine(a, i2), a[i2]) {
                  case `
`:
                    if (t2) {
                      let f3 = new n();
                      i2 = f3.parse({ src: a }, i2), i2 < a.length && this.directives.push(f3);
                    } else
                      i2 += 1, t2 = true;
                    break;
                  case "#":
                    {
                      let f3 = new h2();
                      i2 = f3.parse({ src: a }, i2), this.directives.push(f3), t2 = false;
                    }
                    break;
                  case "%":
                    {
                      let f3 = new E();
                      i2 = f3.parse({ parent: this, src: a }, i2), this.directives.push(f3), s2 = true, t2 = false;
                    }
                    break;
                  default:
                    return s2 ? this.error = new e2.YAMLSemanticError(this, "Missing directives-end indicator line") : this.directives.length > 0 && (this.contents = this.directives, this.directives = []), i2;
                }
              return a[i2] ? (this.directivesEndMarker = new e2.Range(i2, i2 + 3), i2 + 3) : (s2 ? this.error = new e2.YAMLSemanticError(this, "Missing directives-end indicator line") : this.directives.length > 0 && (this.contents = this.directives, this.directives = []), i2);
            }
            parseContents(m2) {
              let { parseNode: a, src: t2 } = this.context;
              this.contents || (this.contents = []);
              let s2 = m2;
              for (; t2[s2 - 1] === "-"; )
                s2 -= 1;
              let i2 = e2.Node.endOfWhiteSpace(t2, m2), f3 = s2 === m2;
              for (this.valueRange = new e2.Range(i2); !e2.Node.atDocumentBoundary(t2, i2, e2.Char.DOCUMENT_END); ) {
                switch (t2[i2]) {
                  case `
`:
                    if (f3) {
                      let g = new n();
                      i2 = g.parse({ src: t2 }, i2), i2 < t2.length && this.contents.push(g);
                    } else
                      i2 += 1, f3 = true;
                    s2 = i2;
                    break;
                  case "#":
                    {
                      let g = new h2();
                      i2 = g.parse({ src: t2 }, i2), this.contents.push(g), f3 = false;
                    }
                    break;
                  default: {
                    let g = e2.Node.endOfIndent(t2, i2), p = a({ atLineStart: f3, indent: -1, inFlow: false, inCollection: false, lineStart: s2, parent: this }, g);
                    if (!p)
                      return this.valueRange.end = g;
                    this.contents.push(p), i2 = p.range.end, f3 = false;
                    let L = d(p);
                    L && Array.prototype.push.apply(this.contents, L);
                  }
                }
                i2 = I.startCommentOrEndBlankLine(t2, i2);
              }
              if (this.valueRange.end = i2, t2[i2] && (this.documentEndMarker = new e2.Range(i2, i2 + 3), i2 += 3, t2[i2])) {
                if (i2 = e2.Node.endOfWhiteSpace(t2, i2), t2[i2] === "#") {
                  let g = new h2();
                  i2 = g.parse({ src: t2 }, i2), this.contents.push(g);
                }
                switch (t2[i2]) {
                  case `
`:
                    i2 += 1;
                    break;
                  case void 0:
                    break;
                  default:
                    this.error = new e2.YAMLSyntaxError(this, "Document end marker line cannot have a non-comment suffix");
                }
              }
              return i2;
            }
            parse(m2, a) {
              m2.root = this, this.context = m2;
              let { src: t2 } = m2, s2 = t2.charCodeAt(a) === 65279 ? a + 1 : a;
              return s2 = this.parseDirectives(s2), s2 = this.parseContents(s2), s2;
            }
            setOrigRanges(m2, a) {
              return a = super.setOrigRanges(m2, a), this.directives.forEach((t2) => {
                a = t2.setOrigRanges(m2, a);
              }), this.directivesEndMarker && (a = this.directivesEndMarker.setOrigRange(m2, a)), this.contents.forEach((t2) => {
                a = t2.setOrigRanges(m2, a);
              }), this.documentEndMarker && (a = this.documentEndMarker.setOrigRange(m2, a)), a;
            }
            toString() {
              let { contents: m2, directives: a, value: t2 } = this;
              if (t2 != null)
                return t2;
              let s2 = a.join("");
              return m2.length > 0 && ((a.length > 0 || m2[0].type === e2.Type.COMMENT) && (s2 += `---
`), s2 += m2.join("")), s2[s2.length - 1] !== `
` && (s2 += `
`), s2;
            }
          }, S2 = class extends e2.Node {
            parse(m2, a) {
              this.context = m2;
              let { src: t2 } = m2, s2 = e2.Node.endOfIdentifier(t2, a + 1);
              return this.valueRange = new e2.Range(a + 1, s2), s2 = e2.Node.endOfWhiteSpace(t2, s2), s2 = this.parseComment(s2), s2;
            }
          }, M = { CLIP: "CLIP", KEEP: "KEEP", STRIP: "STRIP" }, T = class extends e2.Node {
            constructor(m2, a) {
              super(m2, a), this.blockIndent = null, this.chomping = M.CLIP, this.header = null;
            }
            get includesTrailingLines() {
              return this.chomping === M.KEEP;
            }
            get strValue() {
              if (!this.valueRange || !this.context)
                return null;
              let { start: m2, end: a } = this.valueRange, { indent: t2, src: s2 } = this.context;
              if (this.valueRange.isEmpty())
                return "";
              let i2 = null, f3 = s2[a - 1];
              for (; f3 === `
` || f3 === "	" || f3 === " "; ) {
                if (a -= 1, a <= m2) {
                  if (this.chomping === M.KEEP)
                    break;
                  return "";
                }
                f3 === `
` && (i2 = a), f3 = s2[a - 1];
              }
              let g = a + 1;
              i2 && (this.chomping === M.KEEP ? (g = i2, a = this.valueRange.end) : a = i2);
              let u = t2 + this.blockIndent, p = this.type === e2.Type.BLOCK_FOLDED, L = true, k = "", B = "", $ = false;
              for (let Q = m2; Q < a; ++Q) {
                for (let ie = 0; ie < u && s2[Q] === " "; ++ie)
                  Q += 1;
                let z = s2[Q];
                if (z === `
`)
                  B === `
` ? k += `
` : B = `
`;
                else {
                  let ie = e2.Node.endOfLine(s2, Q), ue = s2.slice(Q, ie);
                  Q = ie, p && (z === " " || z === "	") && Q < g ? (B === " " ? B = `
` : !$ && !L && B === `
` && (B = `

`), k += B + ue, B = ie < a && s2[ie] || "", $ = true) : (k += B + ue, B = p && Q < g ? " " : `
`, $ = false), L && ue !== "" && (L = false);
                }
              }
              return this.chomping === M.STRIP ? k : k + `
`;
            }
            parseBlockHeader(m2) {
              let { src: a } = this.context, t2 = m2 + 1, s2 = "";
              for (; ; ) {
                let i2 = a[t2];
                switch (i2) {
                  case "-":
                    this.chomping = M.STRIP;
                    break;
                  case "+":
                    this.chomping = M.KEEP;
                    break;
                  case "0":
                  case "1":
                  case "2":
                  case "3":
                  case "4":
                  case "5":
                  case "6":
                  case "7":
                  case "8":
                  case "9":
                    s2 += i2;
                    break;
                  default:
                    return this.blockIndent = Number(s2) || null, this.header = new e2.Range(m2, t2), t2;
                }
                t2 += 1;
              }
            }
            parseBlockValue(m2) {
              let { indent: a, src: t2 } = this.context, s2 = !!this.blockIndent, i2 = m2, f3 = m2, g = 1;
              for (let u = t2[i2]; u === `
` && (i2 += 1, !e2.Node.atDocumentBoundary(t2, i2)); u = t2[i2]) {
                let p = e2.Node.endOfBlockIndent(t2, a, i2);
                if (p === null)
                  break;
                let L = t2[p], k = p - (i2 + a);
                if (this.blockIndent) {
                  if (L && L !== `
` && k < this.blockIndent) {
                    if (t2[p] === "#")
                      break;
                    if (!this.error) {
                      let B = s2 ? "explicit indentation indicator" : "first line", $ = "Block scalars must not be less indented than their ".concat(B);
                      this.error = new e2.YAMLSemanticError(this, $);
                    }
                  }
                } else if (t2[p] !== `
`) {
                  if (k < g) {
                    let B = "Block scalars with more-indented leading empty lines must use an explicit indentation indicator";
                    this.error = new e2.YAMLSemanticError(this, B);
                  }
                  this.blockIndent = k;
                } else
                  k > g && (g = k);
                t2[p] === `
` ? i2 = p : i2 = f3 = e2.Node.endOfLine(t2, p);
              }
              return this.chomping !== M.KEEP && (i2 = t2[f3] ? f3 + 1 : f3), this.valueRange = new e2.Range(m2 + 1, i2), i2;
            }
            parse(m2, a) {
              this.context = m2;
              let { src: t2 } = m2, s2 = this.parseBlockHeader(a);
              return s2 = e2.Node.endOfWhiteSpace(t2, s2), s2 = this.parseComment(s2), s2 = this.parseBlockValue(s2), s2;
            }
            setOrigRanges(m2, a) {
              return a = super.setOrigRanges(m2, a), this.header ? this.header.setOrigRange(m2, a) : a;
            }
          }, P = class extends e2.Node {
            constructor(m2, a) {
              super(m2, a), this.items = null;
            }
            prevNodeIsJsonLike() {
              let m2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : this.items.length, a = this.items[m2 - 1];
              return !!a && (a.jsonLike || a.type === e2.Type.COMMENT && this.prevNodeIsJsonLike(m2 - 1));
            }
            parse(m2, a) {
              this.context = m2;
              let { parseNode: t2, src: s2 } = m2, { indent: i2, lineStart: f3 } = m2, g = s2[a];
              this.items = [{ char: g, offset: a }];
              let u = e2.Node.endOfWhiteSpace(s2, a + 1);
              for (g = s2[u]; g && g !== "]" && g !== "}"; ) {
                switch (g) {
                  case `
`:
                    {
                      f3 = u + 1;
                      let p = e2.Node.endOfWhiteSpace(s2, f3);
                      if (s2[p] === `
`) {
                        let L = new n();
                        f3 = L.parse({ src: s2 }, f3), this.items.push(L);
                      }
                      if (u = e2.Node.endOfIndent(s2, f3), u <= f3 + i2 && (g = s2[u], u < f3 + i2 || g !== "]" && g !== "}")) {
                        let L = "Insufficient indentation in flow collection";
                        this.error = new e2.YAMLSemanticError(this, L);
                      }
                    }
                    break;
                  case ",":
                    this.items.push({ char: g, offset: u }), u += 1;
                    break;
                  case "#":
                    {
                      let p = new h2();
                      u = p.parse({ src: s2 }, u), this.items.push(p);
                    }
                    break;
                  case "?":
                  case ":": {
                    let p = s2[u + 1];
                    if (p === `
` || p === "	" || p === " " || p === "," || g === ":" && this.prevNodeIsJsonLike()) {
                      this.items.push({ char: g, offset: u }), u += 1;
                      break;
                    }
                  }
                  default: {
                    let p = t2({ atLineStart: false, inCollection: false, inFlow: true, indent: -1, lineStart: f3, parent: this }, u);
                    if (!p)
                      return this.valueRange = new e2.Range(a, u), u;
                    this.items.push(p), u = e2.Node.normalizeOffset(s2, p.range.end);
                  }
                }
                u = e2.Node.endOfWhiteSpace(s2, u), g = s2[u];
              }
              return this.valueRange = new e2.Range(a, u + 1), g && (this.items.push({ char: g, offset: u }), u = e2.Node.endOfWhiteSpace(s2, u + 1), u = this.parseComment(u)), u;
            }
            setOrigRanges(m2, a) {
              return a = super.setOrigRanges(m2, a), this.items.forEach((t2) => {
                if (t2 instanceof e2.Node)
                  a = t2.setOrigRanges(m2, a);
                else if (m2.length === 0)
                  t2.origOffset = t2.offset;
                else {
                  let s2 = a;
                  for (; s2 < m2.length && !(m2[s2] > t2.offset); )
                    ++s2;
                  t2.origOffset = t2.offset + s2, a = s2;
                }
              }), a;
            }
            toString() {
              let { context: { src: m2 }, items: a, range: t2, value: s2 } = this;
              if (s2 != null)
                return s2;
              let i2 = a.filter((u) => u instanceof e2.Node), f3 = "", g = t2.start;
              return i2.forEach((u) => {
                let p = m2.slice(g, u.range.start);
                g = u.range.end, f3 += p + String(u), f3[f3.length - 1] === `
` && m2[g - 1] !== `
` && m2[g] === `
` && (g += 1);
              }), f3 += m2.slice(g, t2.end), e2.Node.addStringTerminator(m2, t2.end, f3);
            }
          }, C = class extends e2.Node {
            static endOfQuote(m2, a) {
              let t2 = m2[a];
              for (; t2 && t2 !== '"'; )
                a += t2 === "\\" ? 2 : 1, t2 = m2[a];
              return a + 1;
            }
            get strValue() {
              if (!this.valueRange || !this.context)
                return null;
              let m2 = [], { start: a, end: t2 } = this.valueRange, { indent: s2, src: i2 } = this.context;
              i2[t2 - 1] !== '"' && m2.push(new e2.YAMLSyntaxError(this, 'Missing closing "quote'));
              let f3 = "";
              for (let g = a + 1; g < t2 - 1; ++g) {
                let u = i2[g];
                if (u === `
`) {
                  e2.Node.atDocumentBoundary(i2, g + 1) && m2.push(new e2.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
                  let { fold: p, offset: L, error: k } = e2.Node.foldNewline(i2, g, s2);
                  f3 += p, g = L, k && m2.push(new e2.YAMLSemanticError(this, "Multi-line double-quoted string needs to be sufficiently indented"));
                } else if (u === "\\")
                  switch (g += 1, i2[g]) {
                    case "0":
                      f3 += "\0";
                      break;
                    case "a":
                      f3 += "\x07";
                      break;
                    case "b":
                      f3 += "\b";
                      break;
                    case "e":
                      f3 += "\x1B";
                      break;
                    case "f":
                      f3 += "\f";
                      break;
                    case "n":
                      f3 += `
`;
                      break;
                    case "r":
                      f3 += "\r";
                      break;
                    case "t":
                      f3 += "	";
                      break;
                    case "v":
                      f3 += "\v";
                      break;
                    case "N":
                      f3 += "\x85";
                      break;
                    case "_":
                      f3 += "\xA0";
                      break;
                    case "L":
                      f3 += "\u2028";
                      break;
                    case "P":
                      f3 += "\u2029";
                      break;
                    case " ":
                      f3 += " ";
                      break;
                    case '"':
                      f3 += '"';
                      break;
                    case "/":
                      f3 += "/";
                      break;
                    case "\\":
                      f3 += "\\";
                      break;
                    case "	":
                      f3 += "	";
                      break;
                    case "x":
                      f3 += this.parseCharCode(g + 1, 2, m2), g += 2;
                      break;
                    case "u":
                      f3 += this.parseCharCode(g + 1, 4, m2), g += 4;
                      break;
                    case "U":
                      f3 += this.parseCharCode(g + 1, 8, m2), g += 8;
                      break;
                    case `
`:
                      for (; i2[g + 1] === " " || i2[g + 1] === "	"; )
                        g += 1;
                      break;
                    default:
                      m2.push(new e2.YAMLSyntaxError(this, "Invalid escape sequence ".concat(i2.substr(g - 1, 2)))), f3 += "\\" + i2[g];
                  }
                else if (u === " " || u === "	") {
                  let p = g, L = i2[g + 1];
                  for (; L === " " || L === "	"; )
                    g += 1, L = i2[g + 1];
                  L !== `
` && (f3 += g > p ? i2.slice(p, g + 1) : u);
                } else
                  f3 += u;
              }
              return m2.length > 0 ? { errors: m2, str: f3 } : f3;
            }
            parseCharCode(m2, a, t2) {
              let { src: s2 } = this.context, i2 = s2.substr(m2, a), g = i2.length === a && /^[0-9a-fA-F]+$/.test(i2) ? parseInt(i2, 16) : NaN;
              return isNaN(g) ? (t2.push(new e2.YAMLSyntaxError(this, "Invalid escape sequence ".concat(s2.substr(m2 - 2, a + 2)))), s2.substr(m2 - 2, a + 2)) : String.fromCodePoint(g);
            }
            parse(m2, a) {
              this.context = m2;
              let { src: t2 } = m2, s2 = C.endOfQuote(t2, a + 1);
              return this.valueRange = new e2.Range(a, s2), s2 = e2.Node.endOfWhiteSpace(t2, s2), s2 = this.parseComment(s2), s2;
            }
          }, q = class extends e2.Node {
            static endOfQuote(m2, a) {
              let t2 = m2[a];
              for (; t2; )
                if (t2 === "'") {
                  if (m2[a + 1] !== "'")
                    break;
                  t2 = m2[a += 2];
                } else
                  t2 = m2[a += 1];
              return a + 1;
            }
            get strValue() {
              if (!this.valueRange || !this.context)
                return null;
              let m2 = [], { start: a, end: t2 } = this.valueRange, { indent: s2, src: i2 } = this.context;
              i2[t2 - 1] !== "'" && m2.push(new e2.YAMLSyntaxError(this, "Missing closing 'quote"));
              let f3 = "";
              for (let g = a + 1; g < t2 - 1; ++g) {
                let u = i2[g];
                if (u === `
`) {
                  e2.Node.atDocumentBoundary(i2, g + 1) && m2.push(new e2.YAMLSemanticError(this, "Document boundary indicators are not allowed within string values"));
                  let { fold: p, offset: L, error: k } = e2.Node.foldNewline(i2, g, s2);
                  f3 += p, g = L, k && m2.push(new e2.YAMLSemanticError(this, "Multi-line single-quoted string needs to be sufficiently indented"));
                } else if (u === "'")
                  f3 += u, g += 1, i2[g] !== "'" && m2.push(new e2.YAMLSyntaxError(this, "Unescaped single quote? This should not happen."));
                else if (u === " " || u === "	") {
                  let p = g, L = i2[g + 1];
                  for (; L === " " || L === "	"; )
                    g += 1, L = i2[g + 1];
                  L !== `
` && (f3 += g > p ? i2.slice(p, g + 1) : u);
                } else
                  f3 += u;
              }
              return m2.length > 0 ? { errors: m2, str: f3 } : f3;
            }
            parse(m2, a) {
              this.context = m2;
              let { src: t2 } = m2, s2 = q.endOfQuote(t2, a + 1);
              return this.valueRange = new e2.Range(a, s2), s2 = e2.Node.endOfWhiteSpace(t2, s2), s2 = this.parseComment(s2), s2;
            }
          };
          function R(m2, a) {
            switch (m2) {
              case e2.Type.ALIAS:
                return new S2(m2, a);
              case e2.Type.BLOCK_FOLDED:
              case e2.Type.BLOCK_LITERAL:
                return new T(m2, a);
              case e2.Type.FLOW_MAP:
              case e2.Type.FLOW_SEQ:
                return new P(m2, a);
              case e2.Type.MAP_KEY:
              case e2.Type.MAP_VALUE:
              case e2.Type.SEQ_ITEM:
                return new c(m2, a);
              case e2.Type.COMMENT:
              case e2.Type.PLAIN:
                return new e2.PlainValue(m2, a);
              case e2.Type.QUOTE_DOUBLE:
                return new C(m2, a);
              case e2.Type.QUOTE_SINGLE:
                return new q(m2, a);
              default:
                return null;
            }
          }
          var j = class {
            static parseType(m2, a, t2) {
              switch (m2[a]) {
                case "*":
                  return e2.Type.ALIAS;
                case ">":
                  return e2.Type.BLOCK_FOLDED;
                case "|":
                  return e2.Type.BLOCK_LITERAL;
                case "{":
                  return e2.Type.FLOW_MAP;
                case "[":
                  return e2.Type.FLOW_SEQ;
                case "?":
                  return !t2 && e2.Node.atBlank(m2, a + 1, true) ? e2.Type.MAP_KEY : e2.Type.PLAIN;
                case ":":
                  return !t2 && e2.Node.atBlank(m2, a + 1, true) ? e2.Type.MAP_VALUE : e2.Type.PLAIN;
                case "-":
                  return !t2 && e2.Node.atBlank(m2, a + 1, true) ? e2.Type.SEQ_ITEM : e2.Type.PLAIN;
                case '"':
                  return e2.Type.QUOTE_DOUBLE;
                case "'":
                  return e2.Type.QUOTE_SINGLE;
                default:
                  return e2.Type.PLAIN;
              }
            }
            constructor() {
              let m2 = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, { atLineStart: a, inCollection: t2, inFlow: s2, indent: i2, lineStart: f3, parent: g } = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
              e2._defineProperty(this, "parseNode", (u, p) => {
                if (e2.Node.atDocumentBoundary(this.src, p))
                  return null;
                let L = new j(this, u), { props: k, type: B, valueStart: $ } = L.parseProps(p), Q = R(B, k), z = Q.parse(L, $);
                if (Q.range = new e2.Range(p, z), z <= p && (Q.error = new Error("Node#parse consumed no characters"), Q.error.parseEnd = z, Q.error.source = Q, Q.range.end = p + 1), L.nodeStartsCollection(Q)) {
                  !Q.error && !L.atLineStart && L.parent.type === e2.Type.DOCUMENT && (Q.error = new e2.YAMLSyntaxError(Q, "Block collection must not have preceding content here (e.g. directives-end indicator)"));
                  let ie = new y(Q);
                  return z = ie.parse(new j(L), z), ie.range = new e2.Range(p, z), ie;
                }
                return Q;
              }), this.atLineStart = a != null ? a : m2.atLineStart || false, this.inCollection = t2 != null ? t2 : m2.inCollection || false, this.inFlow = s2 != null ? s2 : m2.inFlow || false, this.indent = i2 != null ? i2 : m2.indent, this.lineStart = f3 != null ? f3 : m2.lineStart, this.parent = g != null ? g : m2.parent || {}, this.root = m2.root, this.src = m2.src;
            }
            nodeStartsCollection(m2) {
              let { inCollection: a, inFlow: t2, src: s2 } = this;
              if (a || t2)
                return false;
              if (m2 instanceof c)
                return true;
              let i2 = m2.range.end;
              return s2[i2] === `
` || s2[i2 - 1] === `
` ? false : (i2 = e2.Node.endOfWhiteSpace(s2, i2), s2[i2] === ":");
            }
            parseProps(m2) {
              let { inFlow: a, parent: t2, src: s2 } = this, i2 = [], f3 = false;
              m2 = this.atLineStart ? e2.Node.endOfIndent(s2, m2) : e2.Node.endOfWhiteSpace(s2, m2);
              let g = s2[m2];
              for (; g === e2.Char.ANCHOR || g === e2.Char.COMMENT || g === e2.Char.TAG || g === `
`; ) {
                if (g === `
`) {
                  let p = m2, L;
                  do
                    L = p + 1, p = e2.Node.endOfIndent(s2, L);
                  while (s2[p] === `
`);
                  let k = p - (L + this.indent), B = t2.type === e2.Type.SEQ_ITEM && t2.context.atLineStart;
                  if (s2[p] !== "#" && !e2.Node.nextNodeIsIndented(s2[p], k, !B))
                    break;
                  this.atLineStart = true, this.lineStart = L, f3 = false, m2 = p;
                } else if (g === e2.Char.COMMENT) {
                  let p = e2.Node.endOfLine(s2, m2 + 1);
                  i2.push(new e2.Range(m2, p)), m2 = p;
                } else {
                  let p = e2.Node.endOfIdentifier(s2, m2 + 1);
                  g === e2.Char.TAG && s2[p] === "," && /^[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+,\d\d\d\d(-\d\d){0,2}\/\S/.test(s2.slice(m2 + 1, p + 13)) && (p = e2.Node.endOfIdentifier(s2, p + 5)), i2.push(new e2.Range(m2, p)), f3 = true, m2 = e2.Node.endOfWhiteSpace(s2, p);
                }
                g = s2[m2];
              }
              f3 && g === ":" && e2.Node.atBlank(s2, m2 + 1, true) && (m2 -= 1);
              let u = j.parseType(s2, m2, a);
              return { props: i2, type: u, valueStart: m2 };
            }
          };
          function K(m2) {
            let a = [];
            m2.indexOf("\r") !== -1 && (m2 = m2.replace(/\r\n?/g, (i2, f3) => (i2.length > 1 && a.push(f3), `
`)));
            let t2 = [], s2 = 0;
            do {
              let i2 = new I(), f3 = new j({ src: m2 });
              s2 = i2.parse(f3, s2), t2.push(i2);
            } while (s2 < m2.length);
            return t2.setOrigRanges = () => {
              if (a.length === 0)
                return false;
              for (let f3 = 1; f3 < a.length; ++f3)
                a[f3] -= f3;
              let i2 = 0;
              for (let f3 = 0; f3 < t2.length; ++f3)
                i2 = t2[f3].setOrigRanges(a, i2);
              return a.splice(0, a.length), true;
            }, t2.toString = () => t2.join(`...
`), t2;
          }
          r2.parse = K;
        } }), ke = F2({ "node_modules/yaml/dist/resolveSeq-d03cb037.js"(r2) {
          "use strict";
          D();
          var e2 = Me();
          function n(o, l, _) {
            if (!_)
              return o;
            let v = _.replace(/[\s\S]^/gm, "$&".concat(l, "#"));
            return "#".concat(v, `
`).concat(l).concat(o);
          }
          function c(o, l, _) {
            return _ ? _.indexOf(`
`) === -1 ? "".concat(o, " #").concat(_) : "".concat(o, `
`) + _.replace(/^/gm, "".concat(l || "", "#")) : o;
          }
          var h2 = class {
          };
          function d(o, l, _) {
            if (Array.isArray(o))
              return o.map((v, b) => d(v, String(b), _));
            if (o && typeof o.toJSON == "function") {
              let v = _ && _.anchors && _.anchors.get(o);
              v && (_.onCreate = (w) => {
                v.res = w, delete _.onCreate;
              });
              let b = o.toJSON(l, _);
              return v && _.onCreate && _.onCreate(b), b;
            }
            return (!_ || !_.keep) && typeof o == "bigint" ? Number(o) : o;
          }
          var y = class extends h2 {
            constructor(o) {
              super(), this.value = o;
            }
            toJSON(o, l) {
              return l && l.keep ? this.value : d(this.value, o, l);
            }
            toString() {
              return String(this.value);
            }
          };
          function E(o, l, _) {
            let v = _;
            for (let b = l.length - 1; b >= 0; --b) {
              let w = l[b];
              if (Number.isInteger(w) && w >= 0) {
                let A2 = [];
                A2[w] = v, v = A2;
              } else {
                let A2 = {};
                Object.defineProperty(A2, w, { value: v, writable: true, enumerable: true, configurable: true }), v = A2;
              }
            }
            return o.createNode(v, false);
          }
          var I = (o) => o == null || typeof o == "object" && o[Symbol.iterator]().next().done, S2 = class extends h2 {
            constructor(o) {
              super(), e2._defineProperty(this, "items", []), this.schema = o;
            }
            addIn(o, l) {
              if (I(o))
                this.add(l);
              else {
                let [_, ...v] = o, b = this.get(_, true);
                if (b instanceof S2)
                  b.addIn(v, l);
                else if (b === void 0 && this.schema)
                  this.set(_, E(this.schema, v, l));
                else
                  throw new Error("Expected YAML collection at ".concat(_, ". Remaining path: ").concat(v));
              }
            }
            deleteIn(o) {
              let [l, ..._] = o;
              if (_.length === 0)
                return this.delete(l);
              let v = this.get(l, true);
              if (v instanceof S2)
                return v.deleteIn(_);
              throw new Error("Expected YAML collection at ".concat(l, ". Remaining path: ").concat(_));
            }
            getIn(o, l) {
              let [_, ...v] = o, b = this.get(_, true);
              return v.length === 0 ? !l && b instanceof y ? b.value : b : b instanceof S2 ? b.getIn(v, l) : void 0;
            }
            hasAllNullValues() {
              return this.items.every((o) => {
                if (!o || o.type !== "PAIR")
                  return false;
                let l = o.value;
                return l == null || l instanceof y && l.value == null && !l.commentBefore && !l.comment && !l.tag;
              });
            }
            hasIn(o) {
              let [l, ..._] = o;
              if (_.length === 0)
                return this.has(l);
              let v = this.get(l, true);
              return v instanceof S2 ? v.hasIn(_) : false;
            }
            setIn(o, l) {
              let [_, ...v] = o;
              if (v.length === 0)
                this.set(_, l);
              else {
                let b = this.get(_, true);
                if (b instanceof S2)
                  b.setIn(v, l);
                else if (b === void 0 && this.schema)
                  this.set(_, E(this.schema, v, l));
                else
                  throw new Error("Expected YAML collection at ".concat(_, ". Remaining path: ").concat(v));
              }
            }
            toJSON() {
              return null;
            }
            toString(o, l, _, v) {
              let { blockItem: b, flowChars: w, isMap: A2, itemIndent: N } = l, { indent: Y, indentStep: W, stringify: U } = o, H = this.type === e2.Type.FLOW_MAP || this.type === e2.Type.FLOW_SEQ || o.inFlow;
              H && (N += W);
              let oe = A2 && this.hasAllNullValues();
              o = Object.assign({}, o, { allNullValues: oe, indent: N, inFlow: H, type: null });
              let le = false, Z2 = false, ee = this.items.reduce((de, re, he) => {
                let ce;
                re && (!le && re.spaceBefore && de.push({ type: "comment", str: "" }), re.commentBefore && re.commentBefore.match(/^.*$/gm).forEach((Ie) => {
                  de.push({ type: "comment", str: "#".concat(Ie) });
                }), re.comment && (ce = re.comment), H && (!le && re.spaceBefore || re.commentBefore || re.comment || re.key && (re.key.commentBefore || re.key.comment) || re.value && (re.value.commentBefore || re.value.comment)) && (Z2 = true)), le = false;
                let fe = U(re, o, () => ce = null, () => le = true);
                return H && !Z2 && fe.includes(`
`) && (Z2 = true), H && he < this.items.length - 1 && (fe += ","), fe = c(fe, N, ce), le && (ce || H) && (le = false), de.push({ type: "item", str: fe }), de;
              }, []), X;
              if (ee.length === 0)
                X = w.start + w.end;
              else if (H) {
                let { start: de, end: re } = w, he = ee.map((ce) => ce.str);
                if (Z2 || he.reduce((ce, fe) => ce + fe.length + 2, 2) > S2.maxFlowStringSingleLineLength) {
                  X = de;
                  for (let ce of he)
                    X += ce ? `
`.concat(W).concat(Y).concat(ce) : `
`;
                  X += `
`.concat(Y).concat(re);
                } else
                  X = "".concat(de, " ").concat(he.join(" "), " ").concat(re);
              } else {
                let de = ee.map(b);
                X = de.shift();
                for (let re of de)
                  X += re ? `
`.concat(Y).concat(re) : `
`;
              }
              return this.comment ? (X += `
` + this.comment.replace(/^/gm, "".concat(Y, "#")), _ && _()) : le && v && v(), X;
            }
          };
          e2._defineProperty(S2, "maxFlowStringSingleLineLength", 60);
          function M(o) {
            let l = o instanceof y ? o.value : o;
            return l && typeof l == "string" && (l = Number(l)), Number.isInteger(l) && l >= 0 ? l : null;
          }
          var T = class extends S2 {
            add(o) {
              this.items.push(o);
            }
            delete(o) {
              let l = M(o);
              return typeof l != "number" ? false : this.items.splice(l, 1).length > 0;
            }
            get(o, l) {
              let _ = M(o);
              if (typeof _ != "number")
                return;
              let v = this.items[_];
              return !l && v instanceof y ? v.value : v;
            }
            has(o) {
              let l = M(o);
              return typeof l == "number" && l < this.items.length;
            }
            set(o, l) {
              let _ = M(o);
              if (typeof _ != "number")
                throw new Error("Expected a valid index, not ".concat(o, "."));
              this.items[_] = l;
            }
            toJSON(o, l) {
              let _ = [];
              l && l.onCreate && l.onCreate(_);
              let v = 0;
              for (let b of this.items)
                _.push(d(b, String(v++), l));
              return _;
            }
            toString(o, l, _) {
              return o ? super.toString(o, { blockItem: (v) => v.type === "comment" ? v.str : "- ".concat(v.str), flowChars: { start: "[", end: "]" }, isMap: false, itemIndent: (o.indent || "") + "  " }, l, _) : JSON.stringify(this);
            }
          }, P = (o, l, _) => l === null ? "" : typeof l != "object" ? String(l) : o instanceof h2 && _ && _.doc ? o.toString({ anchors: /* @__PURE__ */ Object.create(null), doc: _.doc, indent: "", indentStep: _.indentStep, inFlow: true, inStringifyKey: true, stringify: _.stringify }) : JSON.stringify(l), C = class extends h2 {
            constructor(o) {
              let l = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : null;
              super(), this.key = o, this.value = l, this.type = C.Type.PAIR;
            }
            get commentBefore() {
              return this.key instanceof h2 ? this.key.commentBefore : void 0;
            }
            set commentBefore(o) {
              if (this.key == null && (this.key = new y(null)), this.key instanceof h2)
                this.key.commentBefore = o;
              else {
                let l = "Pair.commentBefore is an alias for Pair.key.commentBefore. To set it, the key must be a Node.";
                throw new Error(l);
              }
            }
            addToJSMap(o, l) {
              let _ = d(this.key, "", o);
              if (l instanceof Map) {
                let v = d(this.value, _, o);
                l.set(_, v);
              } else if (l instanceof Set)
                l.add(_);
              else {
                let v = P(this.key, _, o), b = d(this.value, v, o);
                v in l ? Object.defineProperty(l, v, { value: b, writable: true, enumerable: true, configurable: true }) : l[v] = b;
              }
              return l;
            }
            toJSON(o, l) {
              let _ = l && l.mapAsMap ? /* @__PURE__ */ new Map() : {};
              return this.addToJSMap(l, _);
            }
            toString(o, l, _) {
              if (!o || !o.doc)
                return JSON.stringify(this);
              let { indent: v, indentSeq: b, simpleKeys: w } = o.doc.options, { key: A2, value: N } = this, Y = A2 instanceof h2 && A2.comment;
              if (w) {
                if (Y)
                  throw new Error("With simple keys, key nodes cannot have comments");
                if (A2 instanceof S2) {
                  let ce = "With simple keys, collection cannot be used as a key value";
                  throw new Error(ce);
                }
              }
              let W = !w && (!A2 || Y || (A2 instanceof h2 ? A2 instanceof S2 || A2.type === e2.Type.BLOCK_FOLDED || A2.type === e2.Type.BLOCK_LITERAL : typeof A2 == "object")), { doc: U, indent: H, indentStep: oe, stringify: le } = o;
              o = Object.assign({}, o, { implicitKey: !W, indent: H + oe });
              let Z2 = false, ee = le(A2, o, () => Y = null, () => Z2 = true);
              if (ee = c(ee, o.indent, Y), !W && ee.length > 1024) {
                if (w)
                  throw new Error("With simple keys, single line scalar must not span more than 1024 characters");
                W = true;
              }
              if (o.allNullValues && !w)
                return this.comment ? (ee = c(ee, o.indent, this.comment), l && l()) : Z2 && !Y && _ && _(), o.inFlow && !W ? ee : "? ".concat(ee);
              ee = W ? "? ".concat(ee, `
`).concat(H, ":") : "".concat(ee, ":"), this.comment && (ee = c(ee, o.indent, this.comment), l && l());
              let X = "", de = null;
              if (N instanceof h2) {
                if (N.spaceBefore && (X = `
`), N.commentBefore) {
                  let ce = N.commentBefore.replace(/^/gm, "".concat(o.indent, "#"));
                  X += `
`.concat(ce);
                }
                de = N.comment;
              } else
                N && typeof N == "object" && (N = U.schema.createNode(N, true));
              o.implicitKey = false, !W && !this.comment && N instanceof y && (o.indentAtStart = ee.length + 1), Z2 = false, !b && v >= 2 && !o.inFlow && !W && N instanceof T && N.type !== e2.Type.FLOW_SEQ && !N.tag && !U.anchors.getName(N) && (o.indent = o.indent.substr(2));
              let re = le(N, o, () => de = null, () => Z2 = true), he = " ";
              return X || this.comment ? he = "".concat(X, `
`).concat(o.indent) : !W && N instanceof S2 ? (!(re[0] === "[" || re[0] === "{") || re.includes(`
`)) && (he = `
`.concat(o.indent)) : re[0] === `
` && (he = ""), Z2 && !de && _ && _(), c(ee + he + re, o.indent, de);
            }
          };
          e2._defineProperty(C, "Type", { PAIR: "PAIR", MERGE_PAIR: "MERGE_PAIR" });
          var q = (o, l) => {
            if (o instanceof R) {
              let _ = l.get(o.source);
              return _.count * _.aliasCount;
            } else if (o instanceof S2) {
              let _ = 0;
              for (let v of o.items) {
                let b = q(v, l);
                b > _ && (_ = b);
              }
              return _;
            } else if (o instanceof C) {
              let _ = q(o.key, l), v = q(o.value, l);
              return Math.max(_, v);
            }
            return 1;
          }, R = class extends h2 {
            static stringify(o, l) {
              let { range: _, source: v } = o, { anchors: b, doc: w, implicitKey: A2, inStringifyKey: N } = l, Y = Object.keys(b).find((U) => b[U] === v);
              if (!Y && N && (Y = w.anchors.getName(v) || w.anchors.newName()), Y)
                return "*".concat(Y).concat(A2 ? " " : "");
              let W = w.anchors.getName(v) ? "Alias node must be after source node" : "Source node not found for alias node";
              throw new Error("".concat(W, " [").concat(_, "]"));
            }
            constructor(o) {
              super(), this.source = o, this.type = e2.Type.ALIAS;
            }
            set tag(o) {
              throw new Error("Alias nodes cannot have tags");
            }
            toJSON(o, l) {
              if (!l)
                return d(this.source, o, l);
              let { anchors: _, maxAliasCount: v } = l, b = _.get(this.source);
              if (!b || b.res === void 0) {
                let w = "This should not happen: Alias anchor was not resolved?";
                throw this.cstNode ? new e2.YAMLReferenceError(this.cstNode, w) : new ReferenceError(w);
              }
              if (v >= 0 && (b.count += 1, b.aliasCount === 0 && (b.aliasCount = q(this.source, _)), b.count * b.aliasCount > v)) {
                let w = "Excessive alias count indicates a resource exhaustion attack";
                throw this.cstNode ? new e2.YAMLReferenceError(this.cstNode, w) : new ReferenceError(w);
              }
              return b.res;
            }
            toString(o) {
              return R.stringify(this, o);
            }
          };
          e2._defineProperty(R, "default", true);
          function j(o, l) {
            let _ = l instanceof y ? l.value : l;
            for (let v of o)
              if (v instanceof C && (v.key === l || v.key === _ || v.key && v.key.value === _))
                return v;
          }
          var K = class extends S2 {
            add(o, l) {
              o ? o instanceof C || (o = new C(o.key || o, o.value)) : o = new C(o);
              let _ = j(this.items, o.key), v = this.schema && this.schema.sortMapEntries;
              if (_)
                if (l)
                  _.value = o.value;
                else
                  throw new Error("Key ".concat(o.key, " already set"));
              else if (v) {
                let b = this.items.findIndex((w) => v(o, w) < 0);
                b === -1 ? this.items.push(o) : this.items.splice(b, 0, o);
              } else
                this.items.push(o);
            }
            delete(o) {
              let l = j(this.items, o);
              return l ? this.items.splice(this.items.indexOf(l), 1).length > 0 : false;
            }
            get(o, l) {
              let _ = j(this.items, o), v = _ && _.value;
              return !l && v instanceof y ? v.value : v;
            }
            has(o) {
              return !!j(this.items, o);
            }
            set(o, l) {
              this.add(new C(o, l), true);
            }
            toJSON(o, l, _) {
              let v = _ ? new _() : l && l.mapAsMap ? /* @__PURE__ */ new Map() : {};
              l && l.onCreate && l.onCreate(v);
              for (let b of this.items)
                b.addToJSMap(l, v);
              return v;
            }
            toString(o, l, _) {
              if (!o)
                return JSON.stringify(this);
              for (let v of this.items)
                if (!(v instanceof C))
                  throw new Error("Map items must all be pairs; found ".concat(JSON.stringify(v), " instead"));
              return super.toString(o, { blockItem: (v) => v.str, flowChars: { start: "{", end: "}" }, isMap: true, itemIndent: o.indent || "" }, l, _);
            }
          }, m2 = "<<", a = class extends C {
            constructor(o) {
              if (o instanceof C) {
                let l = o.value;
                l instanceof T || (l = new T(), l.items.push(o.value), l.range = o.value.range), super(o.key, l), this.range = o.range;
              } else
                super(new y(m2), new T());
              this.type = C.Type.MERGE_PAIR;
            }
            addToJSMap(o, l) {
              for (let { source: _ } of this.value.items) {
                if (!(_ instanceof K))
                  throw new Error("Merge sources must be maps");
                let v = _.toJSON(null, o, Map);
                for (let [b, w] of v)
                  l instanceof Map ? l.has(b) || l.set(b, w) : l instanceof Set ? l.add(b) : Object.prototype.hasOwnProperty.call(l, b) || Object.defineProperty(l, b, { value: w, writable: true, enumerable: true, configurable: true });
              }
              return l;
            }
            toString(o, l) {
              let _ = this.value;
              if (_.items.length > 1)
                return super.toString(o, l);
              this.value = _.items[0];
              let v = super.toString(o, l);
              return this.value = _, v;
            }
          }, t2 = { defaultType: e2.Type.BLOCK_LITERAL, lineWidth: 76 }, s2 = { trueStr: "true", falseStr: "false" }, i2 = { asBigInt: false }, f3 = { nullStr: "null" }, g = { defaultType: e2.Type.PLAIN, doubleQuoted: { jsonEncoding: false, minMultiLineLength: 40 }, fold: { lineWidth: 80, minContentWidth: 20 } };
          function u(o, l, _) {
            for (let { format: v, test: b, resolve: w } of l)
              if (b) {
                let A2 = o.match(b);
                if (A2) {
                  let N = w.apply(null, A2);
                  return N instanceof y || (N = new y(N)), v && (N.format = v), N;
                }
              }
            return _ && (o = _(o)), new y(o);
          }
          var p = "flow", L = "block", k = "quoted", B = (o, l) => {
            let _ = o[l + 1];
            for (; _ === " " || _ === "	"; ) {
              do
                _ = o[l += 1];
              while (_ && _ !== `
`);
              _ = o[l + 1];
            }
            return l;
          };
          function $(o, l, _, v) {
            let { indentAtStart: b, lineWidth: w = 80, minContentWidth: A2 = 20, onFold: N, onOverflow: Y } = v;
            if (!w || w < 0)
              return o;
            let W = Math.max(1 + A2, 1 + w - l.length);
            if (o.length <= W)
              return o;
            let U = [], H = {}, oe = w - l.length;
            typeof b == "number" && (b > w - Math.max(2, A2) ? U.push(0) : oe = w - b);
            let le, Z2, ee = false, X = -1, de = -1, re = -1;
            _ === L && (X = B(o, X), X !== -1 && (oe = X + W));
            for (let ce; ce = o[X += 1]; ) {
              if (_ === k && ce === "\\") {
                switch (de = X, o[X + 1]) {
                  case "x":
                    X += 3;
                    break;
                  case "u":
                    X += 5;
                    break;
                  case "U":
                    X += 9;
                    break;
                  default:
                    X += 1;
                }
                re = X;
              }
              if (ce === `
`)
                _ === L && (X = B(o, X)), oe = X + W, le = void 0;
              else {
                if (ce === " " && Z2 && Z2 !== " " && Z2 !== `
` && Z2 !== "	") {
                  let fe = o[X + 1];
                  fe && fe !== " " && fe !== `
` && fe !== "	" && (le = X);
                }
                if (X >= oe)
                  if (le)
                    U.push(le), oe = le + W, le = void 0;
                  else if (_ === k) {
                    for (; Z2 === " " || Z2 === "	"; )
                      Z2 = ce, ce = o[X += 1], ee = true;
                    let fe = X > re + 1 ? X - 2 : de - 1;
                    if (H[fe])
                      return o;
                    U.push(fe), H[fe] = true, oe = fe + W, le = void 0;
                  } else
                    ee = true;
              }
              Z2 = ce;
            }
            if (ee && Y && Y(), U.length === 0)
              return o;
            N && N();
            let he = o.slice(0, U[0]);
            for (let ce = 0; ce < U.length; ++ce) {
              let fe = U[ce], Ie = U[ce + 1] || o.length;
              fe === 0 ? he = `
`.concat(l).concat(o.slice(0, Ie)) : (_ === k && H[fe] && (he += "".concat(o[fe], "\\")), he += `
`.concat(l).concat(o.slice(fe + 1, Ie)));
            }
            return he;
          }
          var Q = (o) => {
            let { indentAtStart: l } = o;
            return l ? Object.assign({ indentAtStart: l }, g.fold) : g.fold;
          }, z = (o) => /^(%|---|\.\.\.)/m.test(o);
          function ie(o, l, _) {
            if (!l || l < 0)
              return false;
            let v = l - _, b = o.length;
            if (b <= v)
              return false;
            for (let w = 0, A2 = 0; w < b; ++w)
              if (o[w] === `
`) {
                if (w - A2 > v)
                  return true;
                if (A2 = w + 1, b - A2 <= v)
                  return false;
              }
            return true;
          }
          function ue(o, l) {
            let { implicitKey: _ } = l, { jsonEncoding: v, minMultiLineLength: b } = g.doubleQuoted, w = JSON.stringify(o);
            if (v)
              return w;
            let A2 = l.indent || (z(o) ? "  " : ""), N = "", Y = 0;
            for (let W = 0, U = w[W]; U; U = w[++W])
              if (U === " " && w[W + 1] === "\\" && w[W + 2] === "n" && (N += w.slice(Y, W) + "\\ ", W += 1, Y = W, U = "\\"), U === "\\")
                switch (w[W + 1]) {
                  case "u":
                    {
                      N += w.slice(Y, W);
                      let H = w.substr(W + 2, 4);
                      switch (H) {
                        case "0000":
                          N += "\\0";
                          break;
                        case "0007":
                          N += "\\a";
                          break;
                        case "000b":
                          N += "\\v";
                          break;
                        case "001b":
                          N += "\\e";
                          break;
                        case "0085":
                          N += "\\N";
                          break;
                        case "00a0":
                          N += "\\_";
                          break;
                        case "2028":
                          N += "\\L";
                          break;
                        case "2029":
                          N += "\\P";
                          break;
                        default:
                          H.substr(0, 2) === "00" ? N += "\\x" + H.substr(2) : N += w.substr(W, 6);
                      }
                      W += 5, Y = W + 1;
                    }
                    break;
                  case "n":
                    if (_ || w[W + 2] === '"' || w.length < b)
                      W += 1;
                    else {
                      for (N += w.slice(Y, W) + `

`; w[W + 2] === "\\" && w[W + 3] === "n" && w[W + 4] !== '"'; )
                        N += `
`, W += 2;
                      N += A2, w[W + 2] === " " && (N += "\\"), W += 1, Y = W + 1;
                    }
                    break;
                  default:
                    W += 1;
                }
            return N = Y ? N + w.slice(Y) : w, _ ? N : $(N, A2, k, Q(l));
          }
          function pe(o, l) {
            if (l.implicitKey) {
              if (/\n/.test(o))
                return ue(o, l);
            } else if (/[ \t]\n|\n[ \t]/.test(o))
              return ue(o, l);
            let _ = l.indent || (z(o) ? "  " : ""), v = "'" + o.replace(/'/g, "''").replace(/\n+/g, `$&
`.concat(_)) + "'";
            return l.implicitKey ? v : $(v, _, p, Q(l));
          }
          function ge(o, l, _, v) {
            let { comment: b, type: w, value: A2 } = o;
            if (/\n[\t ]+$/.test(A2) || /^\s*$/.test(A2))
              return ue(A2, l);
            let N = l.indent || (l.forceBlockIndent || z(A2) ? "  " : ""), Y = N ? "2" : "1", W = w === e2.Type.BLOCK_FOLDED ? false : w === e2.Type.BLOCK_LITERAL ? true : !ie(A2, g.fold.lineWidth, N.length), U = W ? "|" : ">";
            if (!A2)
              return U + `
`;
            let H = "", oe = "";
            if (A2 = A2.replace(/[\n\t ]*$/, (Z2) => {
              let ee = Z2.indexOf(`
`);
              return ee === -1 ? U += "-" : (A2 === Z2 || ee !== Z2.length - 1) && (U += "+", v && v()), oe = Z2.replace(/\n$/, ""), "";
            }).replace(/^[\n ]*/, (Z2) => {
              Z2.indexOf(" ") !== -1 && (U += Y);
              let ee = Z2.match(/ +$/);
              return ee ? (H = Z2.slice(0, -ee[0].length), ee[0]) : (H = Z2, "");
            }), oe && (oe = oe.replace(/\n+(?!\n|$)/g, "$&".concat(N))), H && (H = H.replace(/\n+/g, "$&".concat(N))), b && (U += " #" + b.replace(/ ?[\r\n]+/g, " "), _ && _()), !A2)
              return "".concat(U).concat(Y, `
`).concat(N).concat(oe);
            if (W)
              return A2 = A2.replace(/\n+/g, "$&".concat(N)), "".concat(U, `
`).concat(N).concat(H).concat(A2).concat(oe);
            A2 = A2.replace(/\n+/g, `
$&`).replace(/(?:^|\n)([\t ].*)(?:([\n\t ]*)\n(?![\n\t ]))?/g, "$1$2").replace(/\n+/g, "$&".concat(N));
            let le = $("".concat(H).concat(A2).concat(oe), N, L, g.fold);
            return "".concat(U, `
`).concat(N).concat(le);
          }
          function O(o, l, _, v) {
            let { comment: b, type: w, value: A2 } = o, { actualString: N, implicitKey: Y, indent: W, inFlow: U } = l;
            if (Y && /[\n[\]{},]/.test(A2) || U && /[[\]{},]/.test(A2))
              return ue(A2, l);
            if (!A2 || /^[\n\t ,[\]{}#&*!|>'"%@`]|^[?-]$|^[?-][ \t]|[\n:][ \t]|[ \t]\n|[\n\t ]#|[\n\t :]$/.test(A2))
              return Y || U || A2.indexOf(`
`) === -1 ? A2.indexOf('"') !== -1 && A2.indexOf("'") === -1 ? pe(A2, l) : ue(A2, l) : ge(o, l, _, v);
            if (!Y && !U && w !== e2.Type.PLAIN && A2.indexOf(`
`) !== -1)
              return ge(o, l, _, v);
            if (W === "" && z(A2))
              return l.forceBlockIndent = true, ge(o, l, _, v);
            let H = A2.replace(/\n+/g, `$&
`.concat(W));
            if (N) {
              let { tags: le } = l.doc.schema;
              if (typeof u(H, le, le.scalarFallback).value != "string")
                return ue(A2, l);
            }
            let oe = Y ? H : $(H, W, p, Q(l));
            return b && !U && (oe.indexOf(`
`) !== -1 || b.indexOf(`
`) !== -1) ? (_ && _(), n(oe, W, b)) : oe;
          }
          function V(o, l, _, v) {
            let { defaultType: b } = g, { implicitKey: w, inFlow: A2 } = l, { type: N, value: Y } = o;
            typeof Y != "string" && (Y = String(Y), o = Object.assign({}, o, { value: Y }));
            let W = (H) => {
              switch (H) {
                case e2.Type.BLOCK_FOLDED:
                case e2.Type.BLOCK_LITERAL:
                  return ge(o, l, _, v);
                case e2.Type.QUOTE_DOUBLE:
                  return ue(Y, l);
                case e2.Type.QUOTE_SINGLE:
                  return pe(Y, l);
                case e2.Type.PLAIN:
                  return O(o, l, _, v);
                default:
                  return null;
              }
            };
            (N !== e2.Type.QUOTE_DOUBLE && /[\x00-\x08\x0b-\x1f\x7f-\x9f]/.test(Y) || (w || A2) && (N === e2.Type.BLOCK_FOLDED || N === e2.Type.BLOCK_LITERAL)) && (N = e2.Type.QUOTE_DOUBLE);
            let U = W(N);
            if (U === null && (U = W(b), U === null))
              throw new Error("Unsupported default string type ".concat(b));
            return U;
          }
          function J(o) {
            let { format: l, minFractionDigits: _, tag: v, value: b } = o;
            if (typeof b == "bigint")
              return String(b);
            if (!isFinite(b))
              return isNaN(b) ? ".nan" : b < 0 ? "-.inf" : ".inf";
            let w = JSON.stringify(b);
            if (!l && _ && (!v || v === "tag:yaml.org,2002:float") && /^\d/.test(w)) {
              let A2 = w.indexOf(".");
              A2 < 0 && (A2 = w.length, w += ".");
              let N = _ - (w.length - A2 - 1);
              for (; N-- > 0; )
                w += "0";
            }
            return w;
          }
          function x2(o, l) {
            let _, v;
            switch (l.type) {
              case e2.Type.FLOW_MAP:
                _ = "}", v = "flow map";
                break;
              case e2.Type.FLOW_SEQ:
                _ = "]", v = "flow sequence";
                break;
              default:
                o.push(new e2.YAMLSemanticError(l, "Not a flow collection!?"));
                return;
            }
            let b;
            for (let w = l.items.length - 1; w >= 0; --w) {
              let A2 = l.items[w];
              if (!A2 || A2.type !== e2.Type.COMMENT) {
                b = A2;
                break;
              }
            }
            if (b && b.char !== _) {
              let w = "Expected ".concat(v, " to end with ").concat(_), A2;
              typeof b.offset == "number" ? (A2 = new e2.YAMLSemanticError(l, w), A2.offset = b.offset + 1) : (A2 = new e2.YAMLSemanticError(b, w), b.range && b.range.end && (A2.offset = b.range.end - b.range.start)), o.push(A2);
            }
          }
          function G(o, l) {
            let _ = l.context.src[l.range.start - 1];
            if (_ !== `
` && _ !== "	" && _ !== " ") {
              let v = "Comments must be separated from other tokens by white space characters";
              o.push(new e2.YAMLSemanticError(l, v));
            }
          }
          function ne(o, l) {
            let _ = String(l), v = _.substr(0, 8) + "..." + _.substr(-8);
            return new e2.YAMLSemanticError(o, 'The "'.concat(v, '" key is too long'));
          }
          function _e(o, l) {
            for (let { afterKey: _, before: v, comment: b } of l) {
              let w = o.items[v];
              w ? (_ && w.value && (w = w.value), b === void 0 ? (_ || !w.commentBefore) && (w.spaceBefore = true) : w.commentBefore ? w.commentBefore += `
` + b : w.commentBefore = b) : b !== void 0 && (o.comment ? o.comment += `
` + b : o.comment = b);
            }
          }
          function ye(o, l) {
            let _ = l.strValue;
            return _ ? typeof _ == "string" ? _ : (_.errors.forEach((v) => {
              v.source || (v.source = l), o.errors.push(v);
            }), _.str) : "";
          }
          function be(o, l) {
            let { handle: _, suffix: v } = l.tag, b = o.tagPrefixes.find((w) => w.handle === _);
            if (!b) {
              let w = o.getDefaults().tagPrefixes;
              if (w && (b = w.find((A2) => A2.handle === _)), !b)
                throw new e2.YAMLSemanticError(l, "The ".concat(_, " tag handle is non-default and was not declared."));
            }
            if (!v)
              throw new e2.YAMLSemanticError(l, "The ".concat(_, " tag has no suffix."));
            if (_ === "!" && (o.version || o.options.version) === "1.0") {
              if (v[0] === "^")
                return o.warnings.push(new e2.YAMLWarning(l, "YAML 1.0 ^ tag expansion is not supported")), v;
              if (/[:/]/.test(v)) {
                let w = v.match(/^([a-z0-9-]+)\/(.*)/i);
                return w ? "tag:".concat(w[1], ".yaml.org,2002:").concat(w[2]) : "tag:".concat(v);
              }
            }
            return b.prefix + decodeURIComponent(v);
          }
          function ve(o, l) {
            let { tag: _, type: v } = l, b = false;
            if (_) {
              let { handle: w, suffix: A2, verbatim: N } = _;
              if (N) {
                if (N !== "!" && N !== "!!")
                  return N;
                let Y = "Verbatim tags aren't resolved, so ".concat(N, " is invalid.");
                o.errors.push(new e2.YAMLSemanticError(l, Y));
              } else if (w === "!" && !A2)
                b = true;
              else
                try {
                  return be(o, l);
                } catch (Y) {
                  o.errors.push(Y);
                }
            }
            switch (v) {
              case e2.Type.BLOCK_FOLDED:
              case e2.Type.BLOCK_LITERAL:
              case e2.Type.QUOTE_DOUBLE:
              case e2.Type.QUOTE_SINGLE:
                return e2.defaultTags.STR;
              case e2.Type.FLOW_MAP:
              case e2.Type.MAP:
                return e2.defaultTags.MAP;
              case e2.Type.FLOW_SEQ:
              case e2.Type.SEQ:
                return e2.defaultTags.SEQ;
              case e2.Type.PLAIN:
                return b ? e2.defaultTags.STR : null;
              default:
                return null;
            }
          }
          function Ne(o, l, _) {
            let { tags: v } = o.schema, b = [];
            for (let A2 of v)
              if (A2.tag === _)
                if (A2.test)
                  b.push(A2);
                else {
                  let N = A2.resolve(o, l);
                  return N instanceof S2 ? N : new y(N);
                }
            let w = ye(o, l);
            return typeof w == "string" && b.length > 0 ? u(w, b, v.scalarFallback) : null;
          }
          function Pe(o) {
            let { type: l } = o;
            switch (l) {
              case e2.Type.FLOW_MAP:
              case e2.Type.MAP:
                return e2.defaultTags.MAP;
              case e2.Type.FLOW_SEQ:
              case e2.Type.SEQ:
                return e2.defaultTags.SEQ;
              default:
                return e2.defaultTags.STR;
            }
          }
          function ct(o, l, _) {
            try {
              let v = Ne(o, l, _);
              if (v)
                return _ && l.tag && (v.tag = _), v;
            } catch (v) {
              return v.source || (v.source = l), o.errors.push(v), null;
            }
            try {
              let v = Pe(l);
              if (!v)
                throw new Error("The tag ".concat(_, " is unavailable"));
              let b = "The tag ".concat(_, " is unavailable, falling back to ").concat(v);
              o.warnings.push(new e2.YAMLWarning(l, b));
              let w = Ne(o, l, v);
              return w.tag = _, w;
            } catch (v) {
              let b = new e2.YAMLReferenceError(l, v.message);
              return b.stack = v.stack, o.errors.push(b), null;
            }
          }
          var ut = (o) => {
            if (!o)
              return false;
            let { type: l } = o;
            return l === e2.Type.MAP_KEY || l === e2.Type.MAP_VALUE || l === e2.Type.SEQ_ITEM;
          };
          function ft(o, l) {
            let _ = { before: [], after: [] }, v = false, b = false, w = ut(l.context.parent) ? l.context.parent.props.concat(l.props) : l.props;
            for (let { start: A2, end: N } of w)
              switch (l.context.src[A2]) {
                case e2.Char.COMMENT: {
                  if (!l.commentHasRequiredWhitespace(A2)) {
                    let H = "Comments must be separated from other tokens by white space characters";
                    o.push(new e2.YAMLSemanticError(l, H));
                  }
                  let { header: Y, valueRange: W } = l;
                  (W && (A2 > W.start || Y && A2 > Y.start) ? _.after : _.before).push(l.context.src.slice(A2 + 1, N));
                  break;
                }
                case e2.Char.ANCHOR:
                  if (v) {
                    let Y = "A node can have at most one anchor";
                    o.push(new e2.YAMLSemanticError(l, Y));
                  }
                  v = true;
                  break;
                case e2.Char.TAG:
                  if (b) {
                    let Y = "A node can have at most one tag";
                    o.push(new e2.YAMLSemanticError(l, Y));
                  }
                  b = true;
                  break;
              }
            return { comments: _, hasAnchor: v, hasTag: b };
          }
          function mt(o, l) {
            let { anchors: _, errors: v, schema: b } = o;
            if (l.type === e2.Type.ALIAS) {
              let A2 = l.rawValue, N = _.getNode(A2);
              if (!N) {
                let W = "Aliased anchor not found: ".concat(A2);
                return v.push(new e2.YAMLReferenceError(l, W)), null;
              }
              let Y = new R(N);
              return _._cstAliases.push(Y), Y;
            }
            let w = ve(o, l);
            if (w)
              return ct(o, l, w);
            if (l.type !== e2.Type.PLAIN) {
              let A2 = "Failed to resolve ".concat(l.type, " node here");
              return v.push(new e2.YAMLSyntaxError(l, A2)), null;
            }
            try {
              let A2 = ye(o, l);
              return u(A2, b.tags, b.tags.scalarFallback);
            } catch (A2) {
              return A2.source || (A2.source = l), v.push(A2), null;
            }
          }
          function we(o, l) {
            if (!l)
              return null;
            l.error && o.errors.push(l.error);
            let { comments: _, hasAnchor: v, hasTag: b } = ft(o.errors, l);
            if (v) {
              let { anchors: A2 } = o, N = l.anchor, Y = A2.getNode(N);
              Y && (A2.map[A2.newName(N)] = Y), A2.map[N] = l;
            }
            if (l.type === e2.Type.ALIAS && (v || b)) {
              let A2 = "An alias node must not specify any properties";
              o.errors.push(new e2.YAMLSemanticError(l, A2));
            }
            let w = mt(o, l);
            if (w) {
              w.range = [l.range.start, l.range.end], o.options.keepCstNodes && (w.cstNode = l), o.options.keepNodeTypes && (w.type = l.type);
              let A2 = _.before.join(`
`);
              A2 && (w.commentBefore = w.commentBefore ? "".concat(w.commentBefore, `
`).concat(A2) : A2);
              let N = _.after.join(`
`);
              N && (w.comment = w.comment ? "".concat(w.comment, `
`).concat(N) : N);
            }
            return l.resolved = w;
          }
          function dt(o, l) {
            if (l.type !== e2.Type.MAP && l.type !== e2.Type.FLOW_MAP) {
              let A2 = "A ".concat(l.type, " node cannot be resolved as a mapping");
              return o.errors.push(new e2.YAMLSyntaxError(l, A2)), null;
            }
            let { comments: _, items: v } = l.type === e2.Type.FLOW_MAP ? _t(o, l) : pt(o, l), b = new K();
            b.items = v, _e(b, _);
            let w = false;
            for (let A2 = 0; A2 < v.length; ++A2) {
              let { key: N } = v[A2];
              if (N instanceof S2 && (w = true), o.schema.merge && N && N.value === m2) {
                v[A2] = new a(v[A2]);
                let Y = v[A2].value.items, W = null;
                Y.some((U) => {
                  if (U instanceof R) {
                    let { type: H } = U.source;
                    return H === e2.Type.MAP || H === e2.Type.FLOW_MAP ? false : W = "Merge nodes aliases can only point to maps";
                  }
                  return W = "Merge nodes can only have Alias nodes as values";
                }), W && o.errors.push(new e2.YAMLSemanticError(l, W));
              } else
                for (let Y = A2 + 1; Y < v.length; ++Y) {
                  let { key: W } = v[Y];
                  if (N === W || N && W && Object.prototype.hasOwnProperty.call(N, "value") && N.value === W.value) {
                    let U = 'Map keys must be unique; "'.concat(N, '" is repeated');
                    o.errors.push(new e2.YAMLSemanticError(l, U));
                    break;
                  }
                }
            }
            if (w && !o.options.mapAsMap) {
              let A2 = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
              o.warnings.push(new e2.YAMLWarning(l, A2));
            }
            return l.resolved = b, b;
          }
          var ht = (o) => {
            let { context: { lineStart: l, node: _, src: v }, props: b } = o;
            if (b.length === 0)
              return false;
            let { start: w } = b[0];
            if (_ && w > _.valueRange.start || v[w] !== e2.Char.COMMENT)
              return false;
            for (let A2 = l; A2 < w; ++A2)
              if (v[A2] === `
`)
                return false;
            return true;
          };
          function gt(o, l) {
            if (!ht(o))
              return;
            let _ = o.getPropValue(0, e2.Char.COMMENT, true), v = false, b = l.value.commentBefore;
            if (b && b.startsWith(_))
              l.value.commentBefore = b.substr(_.length + 1), v = true;
            else {
              let w = l.value.comment;
              !o.node && w && w.startsWith(_) && (l.value.comment = w.substr(_.length + 1), v = true);
            }
            v && (l.comment = _);
          }
          function pt(o, l) {
            let _ = [], v = [], b, w = null;
            for (let A2 = 0; A2 < l.items.length; ++A2) {
              let N = l.items[A2];
              switch (N.type) {
                case e2.Type.BLANK_LINE:
                  _.push({ afterKey: !!b, before: v.length });
                  break;
                case e2.Type.COMMENT:
                  _.push({ afterKey: !!b, before: v.length, comment: N.comment });
                  break;
                case e2.Type.MAP_KEY:
                  b !== void 0 && v.push(new C(b)), N.error && o.errors.push(N.error), b = we(o, N.node), w = null;
                  break;
                case e2.Type.MAP_VALUE:
                  {
                    if (b === void 0 && (b = null), N.error && o.errors.push(N.error), !N.context.atLineStart && N.node && N.node.type === e2.Type.MAP && !N.node.context.atLineStart) {
                      let U = "Nested mappings are not allowed in compact mappings";
                      o.errors.push(new e2.YAMLSemanticError(N.node, U));
                    }
                    let Y = N.node;
                    if (!Y && N.props.length > 0) {
                      Y = new e2.PlainValue(e2.Type.PLAIN, []), Y.context = { parent: N, src: N.context.src };
                      let U = N.range.start + 1;
                      if (Y.range = { start: U, end: U }, Y.valueRange = { start: U, end: U }, typeof N.range.origStart == "number") {
                        let H = N.range.origStart + 1;
                        Y.range.origStart = Y.range.origEnd = H, Y.valueRange.origStart = Y.valueRange.origEnd = H;
                      }
                    }
                    let W = new C(b, we(o, Y));
                    gt(N, W), v.push(W), b && typeof w == "number" && N.range.start > w + 1024 && o.errors.push(ne(l, b)), b = void 0, w = null;
                  }
                  break;
                default:
                  b !== void 0 && v.push(new C(b)), b = we(o, N), w = N.range.start, N.error && o.errors.push(N.error);
                  e:
                    for (let Y = A2 + 1; ; ++Y) {
                      let W = l.items[Y];
                      switch (W && W.type) {
                        case e2.Type.BLANK_LINE:
                        case e2.Type.COMMENT:
                          continue e;
                        case e2.Type.MAP_VALUE:
                          break e;
                        default: {
                          let U = "Implicit map keys need to be followed by map values";
                          o.errors.push(new e2.YAMLSemanticError(N, U));
                          break e;
                        }
                      }
                    }
                  if (N.valueRangeContainsNewline) {
                    let Y = "Implicit map keys need to be on a single line";
                    o.errors.push(new e2.YAMLSemanticError(N, Y));
                  }
              }
            }
            return b !== void 0 && v.push(new C(b)), { comments: _, items: v };
          }
          function _t(o, l) {
            let _ = [], v = [], b, w = false, A2 = "{";
            for (let N = 0; N < l.items.length; ++N) {
              let Y = l.items[N];
              if (typeof Y.char == "string") {
                let { char: W, offset: U } = Y;
                if (W === "?" && b === void 0 && !w) {
                  w = true, A2 = ":";
                  continue;
                }
                if (W === ":") {
                  if (b === void 0 && (b = null), A2 === ":") {
                    A2 = ",";
                    continue;
                  }
                } else if (w && (b === void 0 && W !== "," && (b = null), w = false), b !== void 0 && (v.push(new C(b)), b = void 0, W === ",")) {
                  A2 = ":";
                  continue;
                }
                if (W === "}") {
                  if (N === l.items.length - 1)
                    continue;
                } else if (W === A2) {
                  A2 = ":";
                  continue;
                }
                let H = "Flow map contains an unexpected ".concat(W), oe = new e2.YAMLSyntaxError(l, H);
                oe.offset = U, o.errors.push(oe);
              } else
                Y.type === e2.Type.BLANK_LINE ? _.push({ afterKey: !!b, before: v.length }) : Y.type === e2.Type.COMMENT ? (G(o.errors, Y), _.push({ afterKey: !!b, before: v.length, comment: Y.comment })) : b === void 0 ? (A2 === "," && o.errors.push(new e2.YAMLSemanticError(Y, "Separator , missing in flow map")), b = we(o, Y)) : (A2 !== "," && o.errors.push(new e2.YAMLSemanticError(Y, "Indicator : missing in flow map entry")), v.push(new C(b, we(o, Y))), b = void 0, w = false);
            }
            return x2(o.errors, l), b !== void 0 && v.push(new C(b)), { comments: _, items: v };
          }
          function vt(o, l) {
            if (l.type !== e2.Type.SEQ && l.type !== e2.Type.FLOW_SEQ) {
              let w = "A ".concat(l.type, " node cannot be resolved as a sequence");
              return o.errors.push(new e2.YAMLSyntaxError(l, w)), null;
            }
            let { comments: _, items: v } = l.type === e2.Type.FLOW_SEQ ? bt(o, l) : yt(o, l), b = new T();
            if (b.items = v, _e(b, _), !o.options.mapAsMap && v.some((w) => w instanceof C && w.key instanceof S2)) {
              let w = "Keys with collection values will be stringified as YAML due to JS Object restrictions. Use mapAsMap: true to avoid this.";
              o.warnings.push(new e2.YAMLWarning(l, w));
            }
            return l.resolved = b, b;
          }
          function yt(o, l) {
            let _ = [], v = [];
            for (let b = 0; b < l.items.length; ++b) {
              let w = l.items[b];
              switch (w.type) {
                case e2.Type.BLANK_LINE:
                  _.push({ before: v.length });
                  break;
                case e2.Type.COMMENT:
                  _.push({ comment: w.comment, before: v.length });
                  break;
                case e2.Type.SEQ_ITEM:
                  if (w.error && o.errors.push(w.error), v.push(we(o, w.node)), w.hasProps) {
                    let A2 = "Sequence items cannot have tags or anchors before the - indicator";
                    o.errors.push(new e2.YAMLSemanticError(w, A2));
                  }
                  break;
                default:
                  w.error && o.errors.push(w.error), o.errors.push(new e2.YAMLSyntaxError(w, "Unexpected ".concat(w.type, " node in sequence")));
              }
            }
            return { comments: _, items: v };
          }
          function bt(o, l) {
            let _ = [], v = [], b = false, w, A2 = null, N = "[", Y = null;
            for (let W = 0; W < l.items.length; ++W) {
              let U = l.items[W];
              if (typeof U.char == "string") {
                let { char: H, offset: oe } = U;
                if (H !== ":" && (b || w !== void 0) && (b && w === void 0 && (w = N ? v.pop() : null), v.push(new C(w)), b = false, w = void 0, A2 = null), H === N)
                  N = null;
                else if (!N && H === "?")
                  b = true;
                else if (N !== "[" && H === ":" && w === void 0) {
                  if (N === ",") {
                    if (w = v.pop(), w instanceof C) {
                      let le = "Chaining flow sequence pairs is invalid", Z2 = new e2.YAMLSemanticError(l, le);
                      Z2.offset = oe, o.errors.push(Z2);
                    }
                    if (!b && typeof A2 == "number") {
                      let le = U.range ? U.range.start : U.offset;
                      le > A2 + 1024 && o.errors.push(ne(l, w));
                      let { src: Z2 } = Y.context;
                      for (let ee = A2; ee < le; ++ee)
                        if (Z2[ee] === `
`) {
                          let X = "Implicit keys of flow sequence pairs need to be on a single line";
                          o.errors.push(new e2.YAMLSemanticError(Y, X));
                          break;
                        }
                    }
                  } else
                    w = null;
                  A2 = null, b = false, N = null;
                } else if (N === "[" || H !== "]" || W < l.items.length - 1) {
                  let le = "Flow sequence contains an unexpected ".concat(H), Z2 = new e2.YAMLSyntaxError(l, le);
                  Z2.offset = oe, o.errors.push(Z2);
                }
              } else if (U.type === e2.Type.BLANK_LINE)
                _.push({ before: v.length });
              else if (U.type === e2.Type.COMMENT)
                G(o.errors, U), _.push({ comment: U.comment, before: v.length });
              else {
                if (N) {
                  let oe = "Expected a ".concat(N, " in flow sequence");
                  o.errors.push(new e2.YAMLSemanticError(U, oe));
                }
                let H = we(o, U);
                w === void 0 ? (v.push(H), Y = U) : (v.push(new C(w, H)), w = void 0), A2 = U.range.start, N = ",";
              }
            }
            return x2(o.errors, l), w !== void 0 && v.push(new C(w)), { comments: _, items: v };
          }
          r2.Alias = R, r2.Collection = S2, r2.Merge = a, r2.Node = h2, r2.Pair = C, r2.Scalar = y, r2.YAMLMap = K, r2.YAMLSeq = T, r2.addComment = c, r2.binaryOptions = t2, r2.boolOptions = s2, r2.findPair = j, r2.intOptions = i2, r2.isEmptyPath = I, r2.nullOptions = f3, r2.resolveMap = dt, r2.resolveNode = we, r2.resolveSeq = vt, r2.resolveString = ye, r2.strOptions = g, r2.stringifyNumber = J, r2.stringifyString = V, r2.toJSON = d;
        } }), it = F2({ "node_modules/yaml/dist/warnings-1000a372.js"(r2) {
          "use strict";
          D();
          var e2 = Me(), n = ke(), c = { identify: (u) => u instanceof Uint8Array, default: false, tag: "tag:yaml.org,2002:binary", resolve: (u, p) => {
            let L = n.resolveString(u, p);
            if (typeof Buffer == "function")
              return Buffer.from(L, "base64");
            if (typeof atob == "function") {
              let k = atob(L.replace(/[\n\r]/g, "")), B = new Uint8Array(k.length);
              for (let $ = 0; $ < k.length; ++$)
                B[$] = k.charCodeAt($);
              return B;
            } else {
              let k = "This environment does not support reading binary tags; either Buffer or atob is required";
              return u.errors.push(new e2.YAMLReferenceError(p, k)), null;
            }
          }, options: n.binaryOptions, stringify: (u, p, L, k) => {
            let { comment: B, type: $, value: Q } = u, z;
            if (typeof Buffer == "function")
              z = Q instanceof Buffer ? Q.toString("base64") : Buffer.from(Q.buffer).toString("base64");
            else if (typeof btoa == "function") {
              let ie = "";
              for (let ue = 0; ue < Q.length; ++ue)
                ie += String.fromCharCode(Q[ue]);
              z = btoa(ie);
            } else
              throw new Error("This environment does not support writing binary tags; either Buffer or btoa is required");
            if ($ || ($ = n.binaryOptions.defaultType), $ === e2.Type.QUOTE_DOUBLE)
              Q = z;
            else {
              let { lineWidth: ie } = n.binaryOptions, ue = Math.ceil(z.length / ie), pe = new Array(ue);
              for (let ge = 0, O = 0; ge < ue; ++ge, O += ie)
                pe[ge] = z.substr(O, ie);
              Q = pe.join($ === e2.Type.BLOCK_LITERAL ? `
` : " ");
            }
            return n.stringifyString({ comment: B, type: $, value: Q }, p, L, k);
          } };
          function h2(u, p) {
            let L = n.resolveSeq(u, p);
            for (let k = 0; k < L.items.length; ++k) {
              let B = L.items[k];
              if (!(B instanceof n.Pair)) {
                if (B instanceof n.YAMLMap) {
                  if (B.items.length > 1) {
                    let Q = "Each pair must have its own sequence indicator";
                    throw new e2.YAMLSemanticError(p, Q);
                  }
                  let $ = B.items[0] || new n.Pair();
                  B.commentBefore && ($.commentBefore = $.commentBefore ? "".concat(B.commentBefore, `
`).concat($.commentBefore) : B.commentBefore), B.comment && ($.comment = $.comment ? "".concat(B.comment, `
`).concat($.comment) : B.comment), B = $;
                }
                L.items[k] = B instanceof n.Pair ? B : new n.Pair(B);
              }
            }
            return L;
          }
          function d(u, p, L) {
            let k = new n.YAMLSeq(u);
            k.tag = "tag:yaml.org,2002:pairs";
            for (let B of p) {
              let $, Q;
              if (Array.isArray(B))
                if (B.length === 2)
                  $ = B[0], Q = B[1];
                else
                  throw new TypeError("Expected [key, value] tuple: ".concat(B));
              else if (B && B instanceof Object) {
                let ie = Object.keys(B);
                if (ie.length === 1)
                  $ = ie[0], Q = B[$];
                else
                  throw new TypeError("Expected { key: value } tuple: ".concat(B));
              } else
                $ = B;
              let z = u.createPair($, Q, L);
              k.items.push(z);
            }
            return k;
          }
          var y = { default: false, tag: "tag:yaml.org,2002:pairs", resolve: h2, createNode: d }, E = class extends n.YAMLSeq {
            constructor() {
              super(), e2._defineProperty(this, "add", n.YAMLMap.prototype.add.bind(this)), e2._defineProperty(this, "delete", n.YAMLMap.prototype.delete.bind(this)), e2._defineProperty(this, "get", n.YAMLMap.prototype.get.bind(this)), e2._defineProperty(this, "has", n.YAMLMap.prototype.has.bind(this)), e2._defineProperty(this, "set", n.YAMLMap.prototype.set.bind(this)), this.tag = E.tag;
            }
            toJSON(u, p) {
              let L = /* @__PURE__ */ new Map();
              p && p.onCreate && p.onCreate(L);
              for (let k of this.items) {
                let B, $;
                if (k instanceof n.Pair ? (B = n.toJSON(k.key, "", p), $ = n.toJSON(k.value, B, p)) : B = n.toJSON(k, "", p), L.has(B))
                  throw new Error("Ordered maps must not include duplicate keys");
                L.set(B, $);
              }
              return L;
            }
          };
          e2._defineProperty(E, "tag", "tag:yaml.org,2002:omap");
          function I(u, p) {
            let L = h2(u, p), k = [];
            for (let { key: B } of L.items)
              if (B instanceof n.Scalar)
                if (k.includes(B.value)) {
                  let $ = "Ordered maps must not include duplicate keys";
                  throw new e2.YAMLSemanticError(p, $);
                } else
                  k.push(B.value);
            return Object.assign(new E(), L);
          }
          function S2(u, p, L) {
            let k = d(u, p, L), B = new E();
            return B.items = k.items, B;
          }
          var M = { identify: (u) => u instanceof Map, nodeClass: E, default: false, tag: "tag:yaml.org,2002:omap", resolve: I, createNode: S2 }, T = class extends n.YAMLMap {
            constructor() {
              super(), this.tag = T.tag;
            }
            add(u) {
              let p = u instanceof n.Pair ? u : new n.Pair(u);
              n.findPair(this.items, p.key) || this.items.push(p);
            }
            get(u, p) {
              let L = n.findPair(this.items, u);
              return !p && L instanceof n.Pair ? L.key instanceof n.Scalar ? L.key.value : L.key : L;
            }
            set(u, p) {
              if (typeof p != "boolean")
                throw new Error("Expected boolean value for set(key, value) in a YAML set, not ".concat(typeof p));
              let L = n.findPair(this.items, u);
              L && !p ? this.items.splice(this.items.indexOf(L), 1) : !L && p && this.items.push(new n.Pair(u));
            }
            toJSON(u, p) {
              return super.toJSON(u, p, Set);
            }
            toString(u, p, L) {
              if (!u)
                return JSON.stringify(this);
              if (this.hasAllNullValues())
                return super.toString(u, p, L);
              throw new Error("Set items must all have null values");
            }
          };
          e2._defineProperty(T, "tag", "tag:yaml.org,2002:set");
          function P(u, p) {
            let L = n.resolveMap(u, p);
            if (!L.hasAllNullValues())
              throw new e2.YAMLSemanticError(p, "Set items must all have null values");
            return Object.assign(new T(), L);
          }
          function C(u, p, L) {
            let k = new T();
            for (let B of p)
              k.items.push(u.createPair(B, null, L));
            return k;
          }
          var q = { identify: (u) => u instanceof Set, nodeClass: T, default: false, tag: "tag:yaml.org,2002:set", resolve: P, createNode: C }, R = (u, p) => {
            let L = p.split(":").reduce((k, B) => k * 60 + Number(B), 0);
            return u === "-" ? -L : L;
          }, j = (u) => {
            let { value: p } = u;
            if (isNaN(p) || !isFinite(p))
              return n.stringifyNumber(p);
            let L = "";
            p < 0 && (L = "-", p = Math.abs(p));
            let k = [p % 60];
            return p < 60 ? k.unshift(0) : (p = Math.round((p - k[0]) / 60), k.unshift(p % 60), p >= 60 && (p = Math.round((p - k[0]) / 60), k.unshift(p))), L + k.map((B) => B < 10 ? "0" + String(B) : String(B)).join(":").replace(/000000\d*$/, "");
          }, K = { identify: (u) => typeof u == "number", default: true, tag: "tag:yaml.org,2002:int", format: "TIME", test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+)$/, resolve: (u, p, L) => R(p, L.replace(/_/g, "")), stringify: j }, m2 = { identify: (u) => typeof u == "number", default: true, tag: "tag:yaml.org,2002:float", format: "TIME", test: /^([-+]?)([0-9][0-9_]*(?::[0-5]?[0-9])+\.[0-9_]*)$/, resolve: (u, p, L) => R(p, L.replace(/_/g, "")), stringify: j }, a = { identify: (u) => u instanceof Date, default: true, tag: "tag:yaml.org,2002:timestamp", test: RegExp("^(?:([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})(?:(?:t|T|[ \\t]+)([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2}(\\.[0-9]+)?)(?:[ \\t]*(Z|[-+][012]?[0-9](?::[0-9]{2})?))?)?)$"), resolve: (u, p, L, k, B, $, Q, z, ie) => {
            z && (z = (z + "00").substr(1, 3));
            let ue = Date.UTC(p, L - 1, k, B || 0, $ || 0, Q || 0, z || 0);
            if (ie && ie !== "Z") {
              let pe = R(ie[0], ie.slice(1));
              Math.abs(pe) < 30 && (pe *= 60), ue -= 6e4 * pe;
            }
            return new Date(ue);
          }, stringify: (u) => {
            let { value: p } = u;
            return p.toISOString().replace(/((T00:00)?:00)?\.000Z$/, "");
          } };
          function t2(u) {
            let p = typeof Te < "u" && Te.env || {};
            return u ? typeof YAML_SILENCE_DEPRECATION_WARNINGS < "u" ? !YAML_SILENCE_DEPRECATION_WARNINGS : !p.YAML_SILENCE_DEPRECATION_WARNINGS : typeof YAML_SILENCE_WARNINGS < "u" ? !YAML_SILENCE_WARNINGS : !p.YAML_SILENCE_WARNINGS;
          }
          function s2(u, p) {
            if (t2(false)) {
              let L = typeof Te < "u" && Te.emitWarning;
              L ? L(u, p) : console.warn(p ? "".concat(p, ": ").concat(u) : u);
            }
          }
          function i2(u) {
            if (t2(true)) {
              let p = u.replace(/.*yaml[/\\]/i, "").replace(/\.js$/, "").replace(/\\/g, "/");
              s2("The endpoint 'yaml/".concat(p, "' will be removed in a future release."), "DeprecationWarning");
            }
          }
          var f3 = {};
          function g(u, p) {
            if (!f3[u] && t2(true)) {
              f3[u] = true;
              let L = "The option '".concat(u, "' will be removed in a future release");
              L += p ? ", use '".concat(p, "' instead.") : ".", s2(L, "DeprecationWarning");
            }
          }
          r2.binary = c, r2.floatTime = m2, r2.intTime = K, r2.omap = M, r2.pairs = y, r2.set = q, r2.timestamp = a, r2.warn = s2, r2.warnFileDeprecation = i2, r2.warnOptionDeprecation = g;
        } }), ot = F2({ "node_modules/yaml/dist/Schema-88e323a7.js"(r2) {
          "use strict";
          D();
          var e2 = Me(), n = ke(), c = it();
          function h2(O, V, J) {
            let x2 = new n.YAMLMap(O);
            if (V instanceof Map)
              for (let [G, ne] of V)
                x2.items.push(O.createPair(G, ne, J));
            else if (V && typeof V == "object")
              for (let G of Object.keys(V))
                x2.items.push(O.createPair(G, V[G], J));
            return typeof O.sortMapEntries == "function" && x2.items.sort(O.sortMapEntries), x2;
          }
          var d = { createNode: h2, default: true, nodeClass: n.YAMLMap, tag: "tag:yaml.org,2002:map", resolve: n.resolveMap };
          function y(O, V, J) {
            let x2 = new n.YAMLSeq(O);
            if (V && V[Symbol.iterator])
              for (let G of V) {
                let ne = O.createNode(G, J.wrapScalars, null, J);
                x2.items.push(ne);
              }
            return x2;
          }
          var E = { createNode: y, default: true, nodeClass: n.YAMLSeq, tag: "tag:yaml.org,2002:seq", resolve: n.resolveSeq }, I = { identify: (O) => typeof O == "string", default: true, tag: "tag:yaml.org,2002:str", resolve: n.resolveString, stringify(O, V, J, x2) {
            return V = Object.assign({ actualString: true }, V), n.stringifyString(O, V, J, x2);
          }, options: n.strOptions }, S2 = [d, E, I], M = (O) => typeof O == "bigint" || Number.isInteger(O), T = (O, V, J) => n.intOptions.asBigInt ? BigInt(O) : parseInt(V, J);
          function P(O, V, J) {
            let { value: x2 } = O;
            return M(x2) && x2 >= 0 ? J + x2.toString(V) : n.stringifyNumber(O);
          }
          var C = { identify: (O) => O == null, createNode: (O, V, J) => J.wrapScalars ? new n.Scalar(null) : null, default: true, tag: "tag:yaml.org,2002:null", test: /^(?:~|[Nn]ull|NULL)?$/, resolve: () => null, options: n.nullOptions, stringify: () => n.nullOptions.nullStr }, q = { identify: (O) => typeof O == "boolean", default: true, tag: "tag:yaml.org,2002:bool", test: /^(?:[Tt]rue|TRUE|[Ff]alse|FALSE)$/, resolve: (O) => O[0] === "t" || O[0] === "T", options: n.boolOptions, stringify: (O) => {
            let { value: V } = O;
            return V ? n.boolOptions.trueStr : n.boolOptions.falseStr;
          } }, R = { identify: (O) => M(O) && O >= 0, default: true, tag: "tag:yaml.org,2002:int", format: "OCT", test: /^0o([0-7]+)$/, resolve: (O, V) => T(O, V, 8), options: n.intOptions, stringify: (O) => P(O, 8, "0o") }, j = { identify: M, default: true, tag: "tag:yaml.org,2002:int", test: /^[-+]?[0-9]+$/, resolve: (O) => T(O, O, 10), options: n.intOptions, stringify: n.stringifyNumber }, K = { identify: (O) => M(O) && O >= 0, default: true, tag: "tag:yaml.org,2002:int", format: "HEX", test: /^0x([0-9a-fA-F]+)$/, resolve: (O, V) => T(O, V, 16), options: n.intOptions, stringify: (O) => P(O, 16, "0x") }, m2 = { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^(?:[-+]?\.inf|(\.nan))$/i, resolve: (O, V) => V ? NaN : O[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY, stringify: n.stringifyNumber }, a = { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", format: "EXP", test: /^[-+]?(?:\.[0-9]+|[0-9]+(?:\.[0-9]*)?)[eE][-+]?[0-9]+$/, resolve: (O) => parseFloat(O), stringify: (O) => {
            let { value: V } = O;
            return Number(V).toExponential();
          } }, t2 = { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^[-+]?(?:\.([0-9]+)|[0-9]+\.([0-9]*))$/, resolve(O, V, J) {
            let x2 = V || J, G = new n.Scalar(parseFloat(O));
            return x2 && x2[x2.length - 1] === "0" && (G.minFractionDigits = x2.length), G;
          }, stringify: n.stringifyNumber }, s2 = S2.concat([C, q, R, j, K, m2, a, t2]), i2 = (O) => typeof O == "bigint" || Number.isInteger(O), f3 = (O) => {
            let { value: V } = O;
            return JSON.stringify(V);
          }, g = [d, E, { identify: (O) => typeof O == "string", default: true, tag: "tag:yaml.org,2002:str", resolve: n.resolveString, stringify: f3 }, { identify: (O) => O == null, createNode: (O, V, J) => J.wrapScalars ? new n.Scalar(null) : null, default: true, tag: "tag:yaml.org,2002:null", test: /^null$/, resolve: () => null, stringify: f3 }, { identify: (O) => typeof O == "boolean", default: true, tag: "tag:yaml.org,2002:bool", test: /^true|false$/, resolve: (O) => O === "true", stringify: f3 }, { identify: i2, default: true, tag: "tag:yaml.org,2002:int", test: /^-?(?:0|[1-9][0-9]*)$/, resolve: (O) => n.intOptions.asBigInt ? BigInt(O) : parseInt(O, 10), stringify: (O) => {
            let { value: V } = O;
            return i2(V) ? V.toString() : JSON.stringify(V);
          } }, { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^-?(?:0|[1-9][0-9]*)(?:\.[0-9]*)?(?:[eE][-+]?[0-9]+)?$/, resolve: (O) => parseFloat(O), stringify: f3 }];
          g.scalarFallback = (O) => {
            throw new SyntaxError("Unresolved plain scalar ".concat(JSON.stringify(O)));
          };
          var u = (O) => {
            let { value: V } = O;
            return V ? n.boolOptions.trueStr : n.boolOptions.falseStr;
          }, p = (O) => typeof O == "bigint" || Number.isInteger(O);
          function L(O, V, J) {
            let x2 = V.replace(/_/g, "");
            if (n.intOptions.asBigInt) {
              switch (J) {
                case 2:
                  x2 = "0b".concat(x2);
                  break;
                case 8:
                  x2 = "0o".concat(x2);
                  break;
                case 16:
                  x2 = "0x".concat(x2);
                  break;
              }
              let ne = BigInt(x2);
              return O === "-" ? BigInt(-1) * ne : ne;
            }
            let G = parseInt(x2, J);
            return O === "-" ? -1 * G : G;
          }
          function k(O, V, J) {
            let { value: x2 } = O;
            if (p(x2)) {
              let G = x2.toString(V);
              return x2 < 0 ? "-" + J + G.substr(1) : J + G;
            }
            return n.stringifyNumber(O);
          }
          var B = S2.concat([{ identify: (O) => O == null, createNode: (O, V, J) => J.wrapScalars ? new n.Scalar(null) : null, default: true, tag: "tag:yaml.org,2002:null", test: /^(?:~|[Nn]ull|NULL)?$/, resolve: () => null, options: n.nullOptions, stringify: () => n.nullOptions.nullStr }, { identify: (O) => typeof O == "boolean", default: true, tag: "tag:yaml.org,2002:bool", test: /^(?:Y|y|[Yy]es|YES|[Tt]rue|TRUE|[Oo]n|ON)$/, resolve: () => true, options: n.boolOptions, stringify: u }, { identify: (O) => typeof O == "boolean", default: true, tag: "tag:yaml.org,2002:bool", test: /^(?:N|n|[Nn]o|NO|[Ff]alse|FALSE|[Oo]ff|OFF)$/i, resolve: () => false, options: n.boolOptions, stringify: u }, { identify: p, default: true, tag: "tag:yaml.org,2002:int", format: "BIN", test: /^([-+]?)0b([0-1_]+)$/, resolve: (O, V, J) => L(V, J, 2), stringify: (O) => k(O, 2, "0b") }, { identify: p, default: true, tag: "tag:yaml.org,2002:int", format: "OCT", test: /^([-+]?)0([0-7_]+)$/, resolve: (O, V, J) => L(V, J, 8), stringify: (O) => k(O, 8, "0") }, { identify: p, default: true, tag: "tag:yaml.org,2002:int", test: /^([-+]?)([0-9][0-9_]*)$/, resolve: (O, V, J) => L(V, J, 10), stringify: n.stringifyNumber }, { identify: p, default: true, tag: "tag:yaml.org,2002:int", format: "HEX", test: /^([-+]?)0x([0-9a-fA-F_]+)$/, resolve: (O, V, J) => L(V, J, 16), stringify: (O) => k(O, 16, "0x") }, { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^(?:[-+]?\.inf|(\.nan))$/i, resolve: (O, V) => V ? NaN : O[0] === "-" ? Number.NEGATIVE_INFINITY : Number.POSITIVE_INFINITY, stringify: n.stringifyNumber }, { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", format: "EXP", test: /^[-+]?([0-9][0-9_]*)?(\.[0-9_]*)?[eE][-+]?[0-9]+$/, resolve: (O) => parseFloat(O.replace(/_/g, "")), stringify: (O) => {
            let { value: V } = O;
            return Number(V).toExponential();
          } }, { identify: (O) => typeof O == "number", default: true, tag: "tag:yaml.org,2002:float", test: /^[-+]?(?:[0-9][0-9_]*)?\.([0-9_]*)$/, resolve(O, V) {
            let J = new n.Scalar(parseFloat(O.replace(/_/g, "")));
            if (V) {
              let x2 = V.replace(/_/g, "");
              x2[x2.length - 1] === "0" && (J.minFractionDigits = x2.length);
            }
            return J;
          }, stringify: n.stringifyNumber }], c.binary, c.omap, c.pairs, c.set, c.intTime, c.floatTime, c.timestamp), $ = { core: s2, failsafe: S2, json: g, yaml11: B }, Q = { binary: c.binary, bool: q, float: t2, floatExp: a, floatNaN: m2, floatTime: c.floatTime, int: j, intHex: K, intOct: R, intTime: c.intTime, map: d, null: C, omap: c.omap, pairs: c.pairs, seq: E, set: c.set, timestamp: c.timestamp };
          function z(O, V, J) {
            if (V) {
              let x2 = J.filter((ne) => ne.tag === V), G = x2.find((ne) => !ne.format) || x2[0];
              if (!G)
                throw new Error("Tag ".concat(V, " not found"));
              return G;
            }
            return J.find((x2) => (x2.identify && x2.identify(O) || x2.class && O instanceof x2.class) && !x2.format);
          }
          function ie(O, V, J) {
            if (O instanceof n.Node)
              return O;
            let { defaultPrefix: x2, onTagObj: G, prevObjects: ne, schema: _e, wrapScalars: ye } = J;
            V && V.startsWith("!!") && (V = x2 + V.slice(2));
            let be = z(O, V, _e.tags);
            if (!be) {
              if (typeof O.toJSON == "function" && (O = O.toJSON()), !O || typeof O != "object")
                return ye ? new n.Scalar(O) : O;
              be = O instanceof Map ? d : O[Symbol.iterator] ? E : d;
            }
            G && (G(be), delete J.onTagObj);
            let ve = { value: void 0, node: void 0 };
            if (O && typeof O == "object" && ne) {
              let Ne = ne.get(O);
              if (Ne) {
                let Pe = new n.Alias(Ne);
                return J.aliasNodes.push(Pe), Pe;
              }
              ve.value = O, ne.set(O, ve);
            }
            return ve.node = be.createNode ? be.createNode(J.schema, O, J) : ye ? new n.Scalar(O) : O, V && ve.node instanceof n.Node && (ve.node.tag = V), ve.node;
          }
          function ue(O, V, J, x2) {
            let G = O[x2.replace(/\W/g, "")];
            if (!G) {
              let ne = Object.keys(O).map((_e) => JSON.stringify(_e)).join(", ");
              throw new Error('Unknown schema "'.concat(x2, '"; use one of ').concat(ne));
            }
            if (Array.isArray(J))
              for (let ne of J)
                G = G.concat(ne);
            else
              typeof J == "function" && (G = J(G.slice()));
            for (let ne = 0; ne < G.length; ++ne) {
              let _e = G[ne];
              if (typeof _e == "string") {
                let ye = V[_e];
                if (!ye) {
                  let be = Object.keys(V).map((ve) => JSON.stringify(ve)).join(", ");
                  throw new Error('Unknown custom tag "'.concat(_e, '"; use one of ').concat(be));
                }
                G[ne] = ye;
              }
            }
            return G;
          }
          var pe = (O, V) => O.key < V.key ? -1 : O.key > V.key ? 1 : 0, ge = class {
            constructor(O) {
              let { customTags: V, merge: J, schema: x2, sortMapEntries: G, tags: ne } = O;
              this.merge = !!J, this.name = x2, this.sortMapEntries = G === true ? pe : G || null, !V && ne && c.warnOptionDeprecation("tags", "customTags"), this.tags = ue($, Q, V || ne, x2);
            }
            createNode(O, V, J, x2) {
              let G = { defaultPrefix: ge.defaultPrefix, schema: this, wrapScalars: V }, ne = x2 ? Object.assign(x2, G) : G;
              return ie(O, J, ne);
            }
            createPair(O, V, J) {
              J || (J = { wrapScalars: true });
              let x2 = this.createNode(O, J.wrapScalars, null, J), G = this.createNode(V, J.wrapScalars, null, J);
              return new n.Pair(x2, G);
            }
          };
          e2._defineProperty(ge, "defaultPrefix", e2.defaultTagPrefix), e2._defineProperty(ge, "defaultTags", e2.defaultTags), r2.Schema = ge;
        } }), zn = F2({ "node_modules/yaml/dist/Document-9b4560a1.js"(r2) {
          "use strict";
          D();
          var e2 = Me(), n = ke(), c = ot(), h2 = { anchorPrefix: "a", customTags: null, indent: 2, indentSeq: true, keepCstNodes: false, keepNodeTypes: true, keepBlobsInJSON: true, mapAsMap: false, maxAliasCount: 100, prettyErrors: false, simpleKeys: false, version: "1.2" }, d = { get binary() {
            return n.binaryOptions;
          }, set binary(t2) {
            Object.assign(n.binaryOptions, t2);
          }, get bool() {
            return n.boolOptions;
          }, set bool(t2) {
            Object.assign(n.boolOptions, t2);
          }, get int() {
            return n.intOptions;
          }, set int(t2) {
            Object.assign(n.intOptions, t2);
          }, get null() {
            return n.nullOptions;
          }, set null(t2) {
            Object.assign(n.nullOptions, t2);
          }, get str() {
            return n.strOptions;
          }, set str(t2) {
            Object.assign(n.strOptions, t2);
          } }, y = { "1.0": { schema: "yaml-1.1", merge: true, tagPrefixes: [{ handle: "!", prefix: e2.defaultTagPrefix }, { handle: "!!", prefix: "tag:private.yaml.org,2002:" }] }, 1.1: { schema: "yaml-1.1", merge: true, tagPrefixes: [{ handle: "!", prefix: "!" }, { handle: "!!", prefix: e2.defaultTagPrefix }] }, 1.2: { schema: "core", merge: false, tagPrefixes: [{ handle: "!", prefix: "!" }, { handle: "!!", prefix: e2.defaultTagPrefix }] } };
          function E(t2, s2) {
            if ((t2.version || t2.options.version) === "1.0") {
              let g = s2.match(/^tag:private\.yaml\.org,2002:([^:/]+)$/);
              if (g)
                return "!" + g[1];
              let u = s2.match(/^tag:([a-zA-Z0-9-]+)\.yaml\.org,2002:(.*)/);
              return u ? "!".concat(u[1], "/").concat(u[2]) : "!".concat(s2.replace(/^tag:/, ""));
            }
            let i2 = t2.tagPrefixes.find((g) => s2.indexOf(g.prefix) === 0);
            if (!i2) {
              let g = t2.getDefaults().tagPrefixes;
              i2 = g && g.find((u) => s2.indexOf(u.prefix) === 0);
            }
            if (!i2)
              return s2[0] === "!" ? s2 : "!<".concat(s2, ">");
            let f3 = s2.substr(i2.prefix.length).replace(/[!,[\]{}]/g, (g) => ({ "!": "%21", ",": "%2C", "[": "%5B", "]": "%5D", "{": "%7B", "}": "%7D" })[g]);
            return i2.handle + f3;
          }
          function I(t2, s2) {
            if (s2 instanceof n.Alias)
              return n.Alias;
            if (s2.tag) {
              let g = t2.filter((u) => u.tag === s2.tag);
              if (g.length > 0)
                return g.find((u) => u.format === s2.format) || g[0];
            }
            let i2, f3;
            if (s2 instanceof n.Scalar) {
              f3 = s2.value;
              let g = t2.filter((u) => u.identify && u.identify(f3) || u.class && f3 instanceof u.class);
              i2 = g.find((u) => u.format === s2.format) || g.find((u) => !u.format);
            } else
              f3 = s2, i2 = t2.find((g) => g.nodeClass && f3 instanceof g.nodeClass);
            if (!i2) {
              let g = f3 && f3.constructor ? f3.constructor.name : typeof f3;
              throw new Error("Tag not resolved for ".concat(g, " value"));
            }
            return i2;
          }
          function S2(t2, s2, i2) {
            let { anchors: f3, doc: g } = i2, u = [], p = g.anchors.getName(t2);
            return p && (f3[p] = t2, u.push("&".concat(p))), t2.tag ? u.push(E(g, t2.tag)) : s2.default || u.push(E(g, s2.tag)), u.join(" ");
          }
          function M(t2, s2, i2, f3) {
            let { anchors: g, schema: u } = s2.doc, p;
            if (!(t2 instanceof n.Node)) {
              let B = { aliasNodes: [], onTagObj: ($) => p = $, prevObjects: /* @__PURE__ */ new Map() };
              t2 = u.createNode(t2, true, null, B);
              for (let $ of B.aliasNodes) {
                $.source = $.source.node;
                let Q = g.getName($.source);
                Q || (Q = g.newName(), g.map[Q] = $.source);
              }
            }
            if (t2 instanceof n.Pair)
              return t2.toString(s2, i2, f3);
            p || (p = I(u.tags, t2));
            let L = S2(t2, p, s2);
            L.length > 0 && (s2.indentAtStart = (s2.indentAtStart || 0) + L.length + 1);
            let k = typeof p.stringify == "function" ? p.stringify(t2, s2, i2, f3) : t2 instanceof n.Scalar ? n.stringifyString(t2, s2, i2, f3) : t2.toString(s2, i2, f3);
            return L ? t2 instanceof n.Scalar || k[0] === "{" || k[0] === "[" ? "".concat(L, " ").concat(k) : "".concat(L, `
`).concat(s2.indent).concat(k) : k;
          }
          var T = class {
            static validAnchorNode(t2) {
              return t2 instanceof n.Scalar || t2 instanceof n.YAMLSeq || t2 instanceof n.YAMLMap;
            }
            constructor(t2) {
              e2._defineProperty(this, "map", /* @__PURE__ */ Object.create(null)), this.prefix = t2;
            }
            createAlias(t2, s2) {
              return this.setAnchor(t2, s2), new n.Alias(t2);
            }
            createMergePair() {
              let t2 = new n.Merge();
              for (var s2 = arguments.length, i2 = new Array(s2), f3 = 0; f3 < s2; f3++)
                i2[f3] = arguments[f3];
              return t2.value.items = i2.map((g) => {
                if (g instanceof n.Alias) {
                  if (g.source instanceof n.YAMLMap)
                    return g;
                } else if (g instanceof n.YAMLMap)
                  return this.createAlias(g);
                throw new Error("Merge sources must be Map nodes or their Aliases");
              }), t2;
            }
            getName(t2) {
              let { map: s2 } = this;
              return Object.keys(s2).find((i2) => s2[i2] === t2);
            }
            getNames() {
              return Object.keys(this.map);
            }
            getNode(t2) {
              return this.map[t2];
            }
            newName(t2) {
              t2 || (t2 = this.prefix);
              let s2 = Object.keys(this.map);
              for (let i2 = 1; ; ++i2) {
                let f3 = "".concat(t2).concat(i2);
                if (!s2.includes(f3))
                  return f3;
              }
            }
            resolveNodes() {
              let { map: t2, _cstAliases: s2 } = this;
              Object.keys(t2).forEach((i2) => {
                t2[i2] = t2[i2].resolved;
              }), s2.forEach((i2) => {
                i2.source = i2.source.resolved;
              }), delete this._cstAliases;
            }
            setAnchor(t2, s2) {
              if (t2 != null && !T.validAnchorNode(t2))
                throw new Error("Anchors may only be set for Scalar, Seq and Map nodes");
              if (s2 && /[\x00-\x19\s,[\]{}]/.test(s2))
                throw new Error("Anchor names must not contain whitespace or control characters");
              let { map: i2 } = this, f3 = t2 && Object.keys(i2).find((g) => i2[g] === t2);
              if (f3)
                if (s2)
                  f3 !== s2 && (delete i2[f3], i2[s2] = t2);
                else
                  return f3;
              else {
                if (!s2) {
                  if (!t2)
                    return null;
                  s2 = this.newName();
                }
                i2[s2] = t2;
              }
              return s2;
            }
          }, P = (t2, s2) => {
            if (t2 && typeof t2 == "object") {
              let { tag: i2 } = t2;
              t2 instanceof n.Collection ? (i2 && (s2[i2] = true), t2.items.forEach((f3) => P(f3, s2))) : t2 instanceof n.Pair ? (P(t2.key, s2), P(t2.value, s2)) : t2 instanceof n.Scalar && i2 && (s2[i2] = true);
            }
            return s2;
          }, C = (t2) => Object.keys(P(t2, {}));
          function q(t2, s2) {
            let i2 = { before: [], after: [] }, f3, g = false;
            for (let u of s2)
              if (u.valueRange) {
                if (f3 !== void 0) {
                  let L = "Document contains trailing content not separated by a ... or --- line";
                  t2.errors.push(new e2.YAMLSyntaxError(u, L));
                  break;
                }
                let p = n.resolveNode(t2, u);
                g && (p.spaceBefore = true, g = false), f3 = p;
              } else
                u.comment !== null ? (f3 === void 0 ? i2.before : i2.after).push(u.comment) : u.type === e2.Type.BLANK_LINE && (g = true, f3 === void 0 && i2.before.length > 0 && !t2.commentBefore && (t2.commentBefore = i2.before.join(`
`), i2.before = []));
            if (t2.contents = f3 || null, !f3)
              t2.comment = i2.before.concat(i2.after).join(`
`) || null;
            else {
              let u = i2.before.join(`
`);
              if (u) {
                let p = f3 instanceof n.Collection && f3.items[0] ? f3.items[0] : f3;
                p.commentBefore = p.commentBefore ? "".concat(u, `
`).concat(p.commentBefore) : u;
              }
              t2.comment = i2.after.join(`
`) || null;
            }
          }
          function R(t2, s2) {
            let { tagPrefixes: i2 } = t2, [f3, g] = s2.parameters;
            if (!f3 || !g) {
              let u = "Insufficient parameters given for %TAG directive";
              throw new e2.YAMLSemanticError(s2, u);
            }
            if (i2.some((u) => u.handle === f3)) {
              let u = "The %TAG directive must only be given at most once per handle in the same document.";
              throw new e2.YAMLSemanticError(s2, u);
            }
            return { handle: f3, prefix: g };
          }
          function j(t2, s2) {
            let [i2] = s2.parameters;
            if (s2.name === "YAML:1.0" && (i2 = "1.0"), !i2) {
              let f3 = "Insufficient parameters given for %YAML directive";
              throw new e2.YAMLSemanticError(s2, f3);
            }
            if (!y[i2]) {
              let f3 = t2.version || t2.options.version, g = "Document will be parsed as YAML ".concat(f3, " rather than YAML ").concat(i2);
              t2.warnings.push(new e2.YAMLWarning(s2, g));
            }
            return i2;
          }
          function K(t2, s2, i2) {
            let f3 = [], g = false;
            for (let u of s2) {
              let { comment: p, name: L } = u;
              switch (L) {
                case "TAG":
                  try {
                    t2.tagPrefixes.push(R(t2, u));
                  } catch (k) {
                    t2.errors.push(k);
                  }
                  g = true;
                  break;
                case "YAML":
                case "YAML:1.0":
                  if (t2.version) {
                    let k = "The %YAML directive must only be given at most once per document.";
                    t2.errors.push(new e2.YAMLSemanticError(u, k));
                  }
                  try {
                    t2.version = j(t2, u);
                  } catch (k) {
                    t2.errors.push(k);
                  }
                  g = true;
                  break;
                default:
                  if (L) {
                    let k = "YAML only supports %TAG and %YAML directives, and not %".concat(L);
                    t2.warnings.push(new e2.YAMLWarning(u, k));
                  }
              }
              p && f3.push(p);
            }
            if (i2 && !g && (t2.version || i2.version || t2.options.version) === "1.1") {
              let u = (p) => {
                let { handle: L, prefix: k } = p;
                return { handle: L, prefix: k };
              };
              t2.tagPrefixes = i2.tagPrefixes.map(u), t2.version = i2.version;
            }
            t2.commentBefore = f3.join(`
`) || null;
          }
          function m2(t2) {
            if (t2 instanceof n.Collection)
              return true;
            throw new Error("Expected a YAML collection as document contents");
          }
          var a = class {
            constructor(t2) {
              this.anchors = new T(t2.anchorPrefix), this.commentBefore = null, this.comment = null, this.contents = null, this.directivesEndMarker = null, this.errors = [], this.options = t2, this.schema = null, this.tagPrefixes = [], this.version = null, this.warnings = [];
            }
            add(t2) {
              return m2(this.contents), this.contents.add(t2);
            }
            addIn(t2, s2) {
              m2(this.contents), this.contents.addIn(t2, s2);
            }
            delete(t2) {
              return m2(this.contents), this.contents.delete(t2);
            }
            deleteIn(t2) {
              return n.isEmptyPath(t2) ? this.contents == null ? false : (this.contents = null, true) : (m2(this.contents), this.contents.deleteIn(t2));
            }
            getDefaults() {
              return a.defaults[this.version] || a.defaults[this.options.version] || {};
            }
            get(t2, s2) {
              return this.contents instanceof n.Collection ? this.contents.get(t2, s2) : void 0;
            }
            getIn(t2, s2) {
              return n.isEmptyPath(t2) ? !s2 && this.contents instanceof n.Scalar ? this.contents.value : this.contents : this.contents instanceof n.Collection ? this.contents.getIn(t2, s2) : void 0;
            }
            has(t2) {
              return this.contents instanceof n.Collection ? this.contents.has(t2) : false;
            }
            hasIn(t2) {
              return n.isEmptyPath(t2) ? this.contents !== void 0 : this.contents instanceof n.Collection ? this.contents.hasIn(t2) : false;
            }
            set(t2, s2) {
              m2(this.contents), this.contents.set(t2, s2);
            }
            setIn(t2, s2) {
              n.isEmptyPath(t2) ? this.contents = s2 : (m2(this.contents), this.contents.setIn(t2, s2));
            }
            setSchema(t2, s2) {
              if (!t2 && !s2 && this.schema)
                return;
              typeof t2 == "number" && (t2 = t2.toFixed(1)), t2 === "1.0" || t2 === "1.1" || t2 === "1.2" ? (this.version ? this.version = t2 : this.options.version = t2, delete this.options.schema) : t2 && typeof t2 == "string" && (this.options.schema = t2), Array.isArray(s2) && (this.options.customTags = s2);
              let i2 = Object.assign({}, this.getDefaults(), this.options);
              this.schema = new c.Schema(i2);
            }
            parse(t2, s2) {
              this.options.keepCstNodes && (this.cstNode = t2), this.options.keepNodeTypes && (this.type = "DOCUMENT");
              let { directives: i2 = [], contents: f3 = [], directivesEndMarker: g, error: u, valueRange: p } = t2;
              if (u && (u.source || (u.source = this), this.errors.push(u)), K(this, i2, s2), g && (this.directivesEndMarker = true), this.range = p ? [p.start, p.end] : null, this.setSchema(), this.anchors._cstAliases = [], q(this, f3), this.anchors.resolveNodes(), this.options.prettyErrors) {
                for (let L of this.errors)
                  L instanceof e2.YAMLError && L.makePretty();
                for (let L of this.warnings)
                  L instanceof e2.YAMLError && L.makePretty();
              }
              return this;
            }
            listNonDefaultTags() {
              return C(this.contents).filter((t2) => t2.indexOf(c.Schema.defaultPrefix) !== 0);
            }
            setTagPrefix(t2, s2) {
              if (t2[0] !== "!" || t2[t2.length - 1] !== "!")
                throw new Error("Handle must start and end with !");
              if (s2) {
                let i2 = this.tagPrefixes.find((f3) => f3.handle === t2);
                i2 ? i2.prefix = s2 : this.tagPrefixes.push({ handle: t2, prefix: s2 });
              } else
                this.tagPrefixes = this.tagPrefixes.filter((i2) => i2.handle !== t2);
            }
            toJSON(t2, s2) {
              let { keepBlobsInJSON: i2, mapAsMap: f3, maxAliasCount: g } = this.options, u = i2 && (typeof t2 != "string" || !(this.contents instanceof n.Scalar)), p = { doc: this, indentStep: "  ", keep: u, mapAsMap: u && !!f3, maxAliasCount: g, stringify: M }, L = Object.keys(this.anchors.map);
              L.length > 0 && (p.anchors = new Map(L.map((B) => [this.anchors.map[B], { alias: [], aliasCount: 0, count: 1 }])));
              let k = n.toJSON(this.contents, t2, p);
              if (typeof s2 == "function" && p.anchors)
                for (let { count: B, res: $ } of p.anchors.values())
                  s2($, B);
              return k;
            }
            toString() {
              if (this.errors.length > 0)
                throw new Error("Document with errors cannot be stringified");
              let t2 = this.options.indent;
              if (!Number.isInteger(t2) || t2 <= 0) {
                let L = JSON.stringify(t2);
                throw new Error('"indent" option must be a positive integer, not '.concat(L));
              }
              this.setSchema();
              let s2 = [], i2 = false;
              if (this.version) {
                let L = "%YAML 1.2";
                this.schema.name === "yaml-1.1" && (this.version === "1.0" ? L = "%YAML:1.0" : this.version === "1.1" && (L = "%YAML 1.1")), s2.push(L), i2 = true;
              }
              let f3 = this.listNonDefaultTags();
              this.tagPrefixes.forEach((L) => {
                let { handle: k, prefix: B } = L;
                f3.some(($) => $.indexOf(B) === 0) && (s2.push("%TAG ".concat(k, " ").concat(B)), i2 = true);
              }), (i2 || this.directivesEndMarker) && s2.push("---"), this.commentBefore && ((i2 || !this.directivesEndMarker) && s2.unshift(""), s2.unshift(this.commentBefore.replace(/^/gm, "#")));
              let g = { anchors: /* @__PURE__ */ Object.create(null), doc: this, indent: "", indentStep: " ".repeat(t2), stringify: M }, u = false, p = null;
              if (this.contents) {
                this.contents instanceof n.Node && (this.contents.spaceBefore && (i2 || this.directivesEndMarker) && s2.push(""), this.contents.commentBefore && s2.push(this.contents.commentBefore.replace(/^/gm, "#")), g.forceBlockIndent = !!this.comment, p = this.contents.comment);
                let L = p ? null : () => u = true, k = M(this.contents, g, () => p = null, L);
                s2.push(n.addComment(k, "", p));
              } else
                this.contents !== void 0 && s2.push(M(this.contents, g));
              return this.comment && ((!u || p) && s2[s2.length - 1] !== "" && s2.push(""), s2.push(this.comment.replace(/^/gm, "#"))), s2.join(`
`) + `
`;
            }
          };
          e2._defineProperty(a, "defaults", y), r2.Document = a, r2.defaultOptions = h2, r2.scalarOptions = d;
        } }), Zn = F2({ "node_modules/yaml/dist/index.js"(r2) {
          "use strict";
          D();
          var e2 = Gn(), n = zn(), c = ot(), h2 = Me(), d = it();
          ke();
          function y(C) {
            let q = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : true, R = arguments.length > 2 ? arguments[2] : void 0;
            R === void 0 && typeof q == "string" && (R = q, q = true);
            let j = Object.assign({}, n.Document.defaults[n.defaultOptions.version], n.defaultOptions);
            return new c.Schema(j).createNode(C, q, R);
          }
          var E = class extends n.Document {
            constructor(C) {
              super(Object.assign({}, n.defaultOptions, C));
            }
          };
          function I(C, q) {
            let R = [], j;
            for (let K of e2.parse(C)) {
              let m2 = new E(q);
              m2.parse(K, j), R.push(m2), j = m2;
            }
            return R;
          }
          function S2(C, q) {
            let R = e2.parse(C), j = new E(q).parse(R[0]);
            if (R.length > 1) {
              let K = "Source contains multiple documents; please use YAML.parseAllDocuments()";
              j.errors.unshift(new h2.YAMLSemanticError(R[1], K));
            }
            return j;
          }
          function M(C, q) {
            let R = S2(C, q);
            if (R.warnings.forEach((j) => d.warn(j)), R.errors.length > 0)
              throw R.errors[0];
            return R.toJSON();
          }
          function T(C, q) {
            let R = new E(q);
            return R.contents = C, String(R);
          }
          var P = { createNode: y, defaultOptions: n.defaultOptions, Document: E, parse: M, parseAllDocuments: I, parseCST: e2.parse, parseDocument: S2, scalarOptions: n.scalarOptions, stringify: T };
          r2.YAML = P;
        } }), Je = F2({ "node_modules/yaml/index.js"(r2, e2) {
          D(), e2.exports = Zn().YAML;
        } }), Xn = F2({ "node_modules/yaml/dist/util.js"(r2) {
          "use strict";
          D();
          var e2 = ke(), n = Me();
          r2.findPair = e2.findPair, r2.parseMap = e2.resolveMap, r2.parseSeq = e2.resolveSeq, r2.stringifyNumber = e2.stringifyNumber, r2.stringifyString = e2.stringifyString, r2.toJSON = e2.toJSON, r2.Type = n.Type, r2.YAMLError = n.YAMLError, r2.YAMLReferenceError = n.YAMLReferenceError, r2.YAMLSemanticError = n.YAMLSemanticError, r2.YAMLSyntaxError = n.YAMLSyntaxError, r2.YAMLWarning = n.YAMLWarning;
        } }), er = F2({ "node_modules/yaml/util.js"(r2) {
          D();
          var e2 = Xn();
          r2.findPair = e2.findPair, r2.toJSON = e2.toJSON, r2.parseMap = e2.parseMap, r2.parseSeq = e2.parseSeq, r2.stringifyNumber = e2.stringifyNumber, r2.stringifyString = e2.stringifyString, r2.Type = e2.Type, r2.YAMLError = e2.YAMLError, r2.YAMLReferenceError = e2.YAMLReferenceError, r2.YAMLSemanticError = e2.YAMLSemanticError, r2.YAMLSyntaxError = e2.YAMLSyntaxError, r2.YAMLWarning = e2.YAMLWarning;
        } }), tr = F2({ "node_modules/yaml-unist-parser/lib/yaml.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = Je();
          r2.Document = e2.Document;
          var n = Je();
          r2.parseCST = n.parseCST;
          var c = er();
          r2.YAMLError = c.YAMLError, r2.YAMLSyntaxError = c.YAMLSyntaxError, r2.YAMLSemanticError = c.YAMLSemanticError;
        } }), nr = F2({ "node_modules/yaml-unist-parser/lib/parse.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = xt(), n = Gt(), c = zt(), h2 = Zt(), d = Fn(), y = ze(), E = Vn(), I = Un(), S2 = Kn(), M = $n(), T = Jn(), P = Hn(), C = tr();
          function q(R) {
            var j = C.parseCST(R);
            M.addOrigRange(j);
            for (var K = j.map(function(k) {
              return new C.Document({ merge: false, keepCstNodes: true }).parse(k);
            }), m2 = new e2.default(R), a = [], t2 = { text: R, locator: m2, comments: a, transformOffset: function(k) {
              return I.transformOffset(k, t2);
            }, transformRange: function(k) {
              return S2.transformRange(k, t2);
            }, transformNode: function(k) {
              return d.transformNode(k, t2);
            }, transformContent: function(k) {
              return y.transformContent(k, t2);
            } }, s2 = 0, i2 = K; s2 < i2.length; s2++)
              for (var f3 = i2[s2], g = 0, u = f3.errors; g < u.length; g++) {
                var p = u[g];
                if (!(p instanceof C.YAMLSemanticError && p.message === 'Map keys must be unique; "<<" is repeated'))
                  throw E.transformError(p, t2);
              }
            K.forEach(function(k) {
              return h2.removeCstBlankLine(k.cstNode);
            });
            var L = c.createRoot(t2.transformRange({ origStart: 0, origEnd: t2.text.length }), K.map(t2.transformNode), a);
            return n.attachComments(L), P.updatePositions(L), T.removeFakeNodes(L), L;
          }
          r2.parse = q;
        } }), rr = F2({ "node_modules/yaml-unist-parser/lib/index.js"(r2) {
          "use strict";
          D(), r2.__esModule = true;
          var e2 = (ae(), se(te));
          e2.__exportStar(nr(), r2);
        } });
        D();
        var sr = Lt(), { hasPragma: ar } = At(), { locStart: ir, locEnd: or } = Nt();
        function lr(r2) {
          let { parse: e2 } = rr();
          try {
            let n = e2(r2);
            return delete n.comments, n;
          } catch (n) {
            throw n != null && n.position ? sr(n.message, n.position) : n;
          }
        }
        var cr = { astFormat: "yaml", parse: lr, hasPragma: ar, locStart: ir, locEnd: or };
        lt.exports = { parsers: { yaml: cr } };
      });
      return ur();
    });
  }
});

// node_modules/prettier/index.js
var require_prettier = __commonJS({
  "node_modules/prettier/index.js"(exports, module2) {
    "use strict";
    var __getOwnPropNames2 = Object.getOwnPropertyNames;
    var __commonJS2 = (cb, mod) => function __require() {
      return mod || (0, cb[__getOwnPropNames2(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
    };
    var require_global = __commonJS2({
      "node_modules/core-js/internals/global.js"(exports2, module22) {
        var check = function(it) {
          return it && it.Math == Math && it;
        };
        module22.exports = check(typeof globalThis == "object" && globalThis) || check(typeof window == "object" && window) || check(typeof self == "object" && self) || check(typeof global == "object" && global) || function() {
          return this;
        }() || Function("return this")();
      }
    });
    var require_fails = __commonJS2({
      "node_modules/core-js/internals/fails.js"(exports2, module22) {
        module22.exports = function(exec3) {
          try {
            return !!exec3();
          } catch (error) {
            return true;
          }
        };
      }
    });
    var require_descriptors = __commonJS2({
      "node_modules/core-js/internals/descriptors.js"(exports2, module22) {
        var fails = require_fails();
        module22.exports = !fails(function() {
          return Object.defineProperty({}, 1, { get: function() {
            return 7;
          } })[1] != 7;
        });
      }
    });
    var require_function_bind_native = __commonJS2({
      "node_modules/core-js/internals/function-bind-native.js"(exports2, module22) {
        var fails = require_fails();
        module22.exports = !fails(function() {
          var test = function() {
          }.bind();
          return typeof test != "function" || test.hasOwnProperty("prototype");
        });
      }
    });
    var require_function_call = __commonJS2({
      "node_modules/core-js/internals/function-call.js"(exports2, module22) {
        var NATIVE_BIND = require_function_bind_native();
        var call = Function.prototype.call;
        module22.exports = NATIVE_BIND ? call.bind(call) : function() {
          return call.apply(call, arguments);
        };
      }
    });
    var require_object_property_is_enumerable = __commonJS2({
      "node_modules/core-js/internals/object-property-is-enumerable.js"(exports2) {
        "use strict";
        var $propertyIsEnumerable = {}.propertyIsEnumerable;
        var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
        var NASHORN_BUG = getOwnPropertyDescriptor && !$propertyIsEnumerable.call({ 1: 2 }, 1);
        exports2.f = NASHORN_BUG ? function propertyIsEnumerable(V) {
          var descriptor = getOwnPropertyDescriptor(this, V);
          return !!descriptor && descriptor.enumerable;
        } : $propertyIsEnumerable;
      }
    });
    var require_create_property_descriptor = __commonJS2({
      "node_modules/core-js/internals/create-property-descriptor.js"(exports2, module22) {
        module22.exports = function(bitmap, value) {
          return {
            enumerable: !(bitmap & 1),
            configurable: !(bitmap & 2),
            writable: !(bitmap & 4),
            value
          };
        };
      }
    });
    var require_function_uncurry_this = __commonJS2({
      "node_modules/core-js/internals/function-uncurry-this.js"(exports2, module22) {
        var NATIVE_BIND = require_function_bind_native();
        var FunctionPrototype = Function.prototype;
        var bind = FunctionPrototype.bind;
        var call = FunctionPrototype.call;
        var uncurryThis = NATIVE_BIND && bind.bind(call, call);
        module22.exports = NATIVE_BIND ? function(fn) {
          return fn && uncurryThis(fn);
        } : function(fn) {
          return fn && function() {
            return call.apply(fn, arguments);
          };
        };
      }
    });
    var require_classof_raw = __commonJS2({
      "node_modules/core-js/internals/classof-raw.js"(exports2, module22) {
        var uncurryThis = require_function_uncurry_this();
        var toString = uncurryThis({}.toString);
        var stringSlice = uncurryThis("".slice);
        module22.exports = function(it) {
          return stringSlice(toString(it), 8, -1);
        };
      }
    });
    var require_indexed_object = __commonJS2({
      "node_modules/core-js/internals/indexed-object.js"(exports2, module22) {
        var global2 = require_global();
        var uncurryThis = require_function_uncurry_this();
        var fails = require_fails();
        var classof = require_classof_raw();
        var Object2 = global2.Object;
        var split = uncurryThis("".split);
        module22.exports = fails(function() {
          return !Object2("z").propertyIsEnumerable(0);
        }) ? function(it) {
          return classof(it) == "String" ? split(it, "") : Object2(it);
        } : Object2;
      }
    });
    var require_require_object_coercible = __commonJS2({
      "node_modules/core-js/internals/require-object-coercible.js"(exports2, module22) {
        var global2 = require_global();
        var TypeError2 = global2.TypeError;
        module22.exports = function(it) {
          if (it == void 0)
            throw TypeError2("Can't call method on " + it);
          return it;
        };
      }
    });
    var require_to_indexed_object = __commonJS2({
      "node_modules/core-js/internals/to-indexed-object.js"(exports2, module22) {
        var IndexedObject = require_indexed_object();
        var requireObjectCoercible = require_require_object_coercible();
        module22.exports = function(it) {
          return IndexedObject(requireObjectCoercible(it));
        };
      }
    });
    var require_is_callable = __commonJS2({
      "node_modules/core-js/internals/is-callable.js"(exports2, module22) {
        module22.exports = function(argument) {
          return typeof argument == "function";
        };
      }
    });
    var require_is_object = __commonJS2({
      "node_modules/core-js/internals/is-object.js"(exports2, module22) {
        var isCallable = require_is_callable();
        module22.exports = function(it) {
          return typeof it == "object" ? it !== null : isCallable(it);
        };
      }
    });
    var require_get_built_in = __commonJS2({
      "node_modules/core-js/internals/get-built-in.js"(exports2, module22) {
        var global2 = require_global();
        var isCallable = require_is_callable();
        var aFunction = function(argument) {
          return isCallable(argument) ? argument : void 0;
        };
        module22.exports = function(namespace, method) {
          return arguments.length < 2 ? aFunction(global2[namespace]) : global2[namespace] && global2[namespace][method];
        };
      }
    });
    var require_object_is_prototype_of = __commonJS2({
      "node_modules/core-js/internals/object-is-prototype-of.js"(exports2, module22) {
        var uncurryThis = require_function_uncurry_this();
        module22.exports = uncurryThis({}.isPrototypeOf);
      }
    });
    var require_engine_user_agent = __commonJS2({
      "node_modules/core-js/internals/engine-user-agent.js"(exports2, module22) {
        var getBuiltIn = require_get_built_in();
        module22.exports = getBuiltIn("navigator", "userAgent") || "";
      }
    });
    var require_engine_v8_version = __commonJS2({
      "node_modules/core-js/internals/engine-v8-version.js"(exports2, module22) {
        var global2 = require_global();
        var userAgent2 = require_engine_user_agent();
        var process2 = global2.process;
        var Deno = global2.Deno;
        var versions = process2 && process2.versions || Deno && Deno.version;
        var v8 = versions && versions.v8;
        var match;
        var version2;
        if (v8) {
          match = v8.split(".");
          version2 = match[0] > 0 && match[0] < 4 ? 1 : +(match[0] + match[1]);
        }
        if (!version2 && userAgent2) {
          match = userAgent2.match(/Edge\/(\d+)/);
          if (!match || match[1] >= 74) {
            match = userAgent2.match(/Chrome\/(\d+)/);
            if (match)
              version2 = +match[1];
          }
        }
        module22.exports = version2;
      }
    });
    var require_native_symbol = __commonJS2({
      "node_modules/core-js/internals/native-symbol.js"(exports2, module22) {
        var V8_VERSION = require_engine_v8_version();
        var fails = require_fails();
        module22.exports = !!Object.getOwnPropertySymbols && !fails(function() {
          var symbol = Symbol();
          return !String(symbol) || !(Object(symbol) instanceof Symbol) || !Symbol.sham && V8_VERSION && V8_VERSION < 41;
        });
      }
    });
    var require_use_symbol_as_uid = __commonJS2({
      "node_modules/core-js/internals/use-symbol-as-uid.js"(exports2, module22) {
        var NATIVE_SYMBOL = require_native_symbol();
        module22.exports = NATIVE_SYMBOL && !Symbol.sham && typeof Symbol.iterator == "symbol";
      }
    });
    var require_is_symbol = __commonJS2({
      "node_modules/core-js/internals/is-symbol.js"(exports2, module22) {
        var global2 = require_global();
        var getBuiltIn = require_get_built_in();
        var isCallable = require_is_callable();
        var isPrototypeOf = require_object_is_prototype_of();
        var USE_SYMBOL_AS_UID = require_use_symbol_as_uid();
        var Object2 = global2.Object;
        module22.exports = USE_SYMBOL_AS_UID ? function(it) {
          return typeof it == "symbol";
        } : function(it) {
          var $Symbol = getBuiltIn("Symbol");
          return isCallable($Symbol) && isPrototypeOf($Symbol.prototype, Object2(it));
        };
      }
    });
    var require_try_to_string = __commonJS2({
      "node_modules/core-js/internals/try-to-string.js"(exports2, module22) {
        var global2 = require_global();
        var String2 = global2.String;
        module22.exports = function(argument) {
          try {
            return String2(argument);
          } catch (error) {
            return "Object";
          }
        };
      }
    });
    var require_a_callable = __commonJS2({
      "node_modules/core-js/internals/a-callable.js"(exports2, module22) {
        var global2 = require_global();
        var isCallable = require_is_callable();
        var tryToString = require_try_to_string();
        var TypeError2 = global2.TypeError;
        module22.exports = function(argument) {
          if (isCallable(argument))
            return argument;
          throw TypeError2(tryToString(argument) + " is not a function");
        };
      }
    });
    var require_get_method = __commonJS2({
      "node_modules/core-js/internals/get-method.js"(exports2, module22) {
        var aCallable = require_a_callable();
        module22.exports = function(V, P) {
          var func = V[P];
          return func == null ? void 0 : aCallable(func);
        };
      }
    });
    var require_ordinary_to_primitive = __commonJS2({
      "node_modules/core-js/internals/ordinary-to-primitive.js"(exports2, module22) {
        var global2 = require_global();
        var call = require_function_call();
        var isCallable = require_is_callable();
        var isObject3 = require_is_object();
        var TypeError2 = global2.TypeError;
        module22.exports = function(input, pref) {
          var fn, val;
          if (pref === "string" && isCallable(fn = input.toString) && !isObject3(val = call(fn, input)))
            return val;
          if (isCallable(fn = input.valueOf) && !isObject3(val = call(fn, input)))
            return val;
          if (pref !== "string" && isCallable(fn = input.toString) && !isObject3(val = call(fn, input)))
            return val;
          throw TypeError2("Can't convert object to primitive value");
        };
      }
    });
    var require_is_pure = __commonJS2({
      "node_modules/core-js/internals/is-pure.js"(exports2, module22) {
        module22.exports = false;
      }
    });
    var require_set_global = __commonJS2({
      "node_modules/core-js/internals/set-global.js"(exports2, module22) {
        var global2 = require_global();
        var defineProperty = Object.defineProperty;
        module22.exports = function(key, value) {
          try {
            defineProperty(global2, key, { value, configurable: true, writable: true });
          } catch (error) {
            global2[key] = value;
          }
          return value;
        };
      }
    });
    var require_shared_store = __commonJS2({
      "node_modules/core-js/internals/shared-store.js"(exports2, module22) {
        var global2 = require_global();
        var setGlobal = require_set_global();
        var SHARED = "__core-js_shared__";
        var store = global2[SHARED] || setGlobal(SHARED, {});
        module22.exports = store;
      }
    });
    var require_shared = __commonJS2({
      "node_modules/core-js/internals/shared.js"(exports2, module22) {
        var IS_PURE = require_is_pure();
        var store = require_shared_store();
        (module22.exports = function(key, value) {
          return store[key] || (store[key] = value !== void 0 ? value : {});
        })("versions", []).push({
          version: "3.22.2",
          mode: IS_PURE ? "pure" : "global",
          copyright: "\xA9 2014-2022 Denis Pushkarev (zloirock.ru)",
          license: "https://github.com/zloirock/core-js/blob/v3.22.2/LICENSE",
          source: "https://github.com/zloirock/core-js"
        });
      }
    });
    var require_to_object = __commonJS2({
      "node_modules/core-js/internals/to-object.js"(exports2, module22) {
        var global2 = require_global();
        var requireObjectCoercible = require_require_object_coercible();
        var Object2 = global2.Object;
        module22.exports = function(argument) {
          return Object2(requireObjectCoercible(argument));
        };
      }
    });
    var require_has_own_property = __commonJS2({
      "node_modules/core-js/internals/has-own-property.js"(exports2, module22) {
        var uncurryThis = require_function_uncurry_this();
        var toObject = require_to_object();
        var hasOwnProperty = uncurryThis({}.hasOwnProperty);
        module22.exports = Object.hasOwn || function hasOwn(it, key) {
          return hasOwnProperty(toObject(it), key);
        };
      }
    });
    var require_uid = __commonJS2({
      "node_modules/core-js/internals/uid.js"(exports2, module22) {
        var uncurryThis = require_function_uncurry_this();
        var id = 0;
        var postfix = Math.random();
        var toString = uncurryThis(1 .toString);
        module22.exports = function(key) {
          return "Symbol(" + (key === void 0 ? "" : key) + ")_" + toString(++id + postfix, 36);
        };
      }
    });
    var require_well_known_symbol = __commonJS2({
      "node_modules/core-js/internals/well-known-symbol.js"(exports2, module22) {
        var global2 = require_global();
        var shared = require_shared();
        var hasOwn = require_has_own_property();
        var uid = require_uid();
        var NATIVE_SYMBOL = require_native_symbol();
        var USE_SYMBOL_AS_UID = require_use_symbol_as_uid();
        var WellKnownSymbolsStore = shared("wks");
        var Symbol2 = global2.Symbol;
        var symbolFor = Symbol2 && Symbol2["for"];
        var createWellKnownSymbol = USE_SYMBOL_AS_UID ? Symbol2 : Symbol2 && Symbol2.withoutSetter || uid;
        module22.exports = function(name) {
          if (!hasOwn(WellKnownSymbolsStore, name) || !(NATIVE_SYMBOL || typeof WellKnownSymbolsStore[name] == "string")) {
            var description = "Symbol." + name;
            if (NATIVE_SYMBOL && hasOwn(Symbol2, name)) {
              WellKnownSymbolsStore[name] = Symbol2[name];
            } else if (USE_SYMBOL_AS_UID && symbolFor) {
              WellKnownSymbolsStore[name] = symbolFor(description);
            } else {
              WellKnownSymbolsStore[name] = createWellKnownSymbol(description);
            }
          }
          return WellKnownSymbolsStore[name];
        };
      }
    });
    var require_to_primitive = __commonJS2({
      "node_modules/core-js/internals/to-primitive.js"(exports2, module22) {
        var global2 = require_global();
        var call = require_function_call();
        var isObject3 = require_is_object();
        var isSymbol = require_is_symbol();
        var getMethod = require_get_method();
        var ordinaryToPrimitive = require_ordinary_to_primitive();
        var wellKnownSymbol = require_well_known_symbol();
        var TypeError2 = global2.TypeError;
        var TO_PRIMITIVE = wellKnownSymbol("toPrimitive");
        module22.exports = function(input, pref) {
          if (!isObject3(input) || isSymbol(input))
            return input;
          var exoticToPrim = getMethod(input, TO_PRIMITIVE);
          var result;
          if (exoticToPrim) {
            if (pref === void 0)
              pref = "default";
            result = call(exoticToPrim, input, pref);
            if (!isObject3(result) || isSymbol(result))
              return result;
            throw TypeError2("Can't convert object to primitive value");
          }
          if (pref === void 0)
            pref = "number";
          return ordinaryToPrimitive(input, pref);
        };
      }
    });
    var require_to_property_key = __commonJS2({
      "node_modules/core-js/internals/to-property-key.js"(exports2, module22) {
        var toPrimitive = require_to_primitive();
        var isSymbol = require_is_symbol();
        module22.exports = function(argument) {
          var key = toPrimitive(argument, "string");
          return isSymbol(key) ? key : key + "";
        };
      }
    });
    var require_document_create_element = __commonJS2({
      "node_modules/core-js/internals/document-create-element.js"(exports2, module22) {
        var global2 = require_global();
        var isObject3 = require_is_object();
        var document2 = global2.document;
        var EXISTS = isObject3(document2) && isObject3(document2.createElement);
        module22.exports = function(it) {
          return EXISTS ? document2.createElement(it) : {};
        };
      }
    });
    var require_ie8_dom_define = __commonJS2({
      "node_modules/core-js/internals/ie8-dom-define.js"(exports2, module22) {
        var DESCRIPTORS = require_descriptors();
        var fails = require_fails();
        var createElement = require_document_create_element();
        module22.exports = !DESCRIPTORS && !fails(function() {
          return Object.defineProperty(createElement("div"), "a", {
            get: function() {
              return 7;
            }
          }).a != 7;
        });
      }
    });
    var require_object_get_own_property_descriptor = __commonJS2({
      "node_modules/core-js/internals/object-get-own-property-descriptor.js"(exports2) {
        var DESCRIPTORS = require_descriptors();
        var call = require_function_call();
        var propertyIsEnumerableModule = require_object_property_is_enumerable();
        var createPropertyDescriptor = require_create_property_descriptor();
        var toIndexedObject = require_to_indexed_object();
        var toPropertyKey = require_to_property_key();
        var hasOwn = require_has_own_property();
        var IE8_DOM_DEFINE = require_ie8_dom_define();
        var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
        exports2.f = DESCRIPTORS ? $getOwnPropertyDescriptor : function getOwnPropertyDescriptor(O, P) {
          O = toIndexedObject(O);
          P = toPropertyKey(P);
          if (IE8_DOM_DEFINE)
            try {
              return $getOwnPropertyDescriptor(O, P);
            } catch (error) {
            }
          if (hasOwn(O, P))
            return createPropertyDescriptor(!call(propertyIsEnumerableModule.f, O, P), O[P]);
        };
      }
    });
    var require_v8_prototype_define_bug = __commonJS2({
      "node_modules/core-js/internals/v8-prototype-define-bug.js"(exports2, module22) {
        var DESCRIPTORS = require_descriptors();
        var fails = require_fails();
        module22.exports = DESCRIPTORS && fails(function() {
          return Object.defineProperty(function() {
          }, "prototype", {
            value: 42,
            writable: false
          }).prototype != 42;
        });
      }
    });
    var require_an_object = __commonJS2({
      "node_modules/core-js/internals/an-object.js"(exports2, module22) {
        var global2 = require_global();
        var isObject3 = require_is_object();
        var String2 = global2.String;
        var TypeError2 = global2.TypeError;
        module22.exports = function(argument) {
          if (isObject3(argument))
            return argument;
          throw TypeError2(String2(argument) + " is not an object");
        };
      }
    });
    var require_object_define_property = __commonJS2({
      "node_modules/core-js/internals/object-define-property.js"(exports2) {
        var global2 = require_global();
        var DESCRIPTORS = require_descriptors();
        var IE8_DOM_DEFINE = require_ie8_dom_define();
        var V8_PROTOTYPE_DEFINE_BUG = require_v8_prototype_define_bug();
        var anObject = require_an_object();
        var toPropertyKey = require_to_property_key();
        var TypeError2 = global2.TypeError;
        var $defineProperty = Object.defineProperty;
        var $getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
        var ENUMERABLE = "enumerable";
        var CONFIGURABLE = "configurable";
        var WRITABLE = "writable";
        exports2.f = DESCRIPTORS ? V8_PROTOTYPE_DEFINE_BUG ? function defineProperty(O, P, Attributes) {
          anObject(O);
          P = toPropertyKey(P);
          anObject(Attributes);
          if (typeof O === "function" && P === "prototype" && "value" in Attributes && WRITABLE in Attributes && !Attributes[WRITABLE]) {
            var current = $getOwnPropertyDescriptor(O, P);
            if (current && current[WRITABLE]) {
              O[P] = Attributes.value;
              Attributes = {
                configurable: CONFIGURABLE in Attributes ? Attributes[CONFIGURABLE] : current[CONFIGURABLE],
                enumerable: ENUMERABLE in Attributes ? Attributes[ENUMERABLE] : current[ENUMERABLE],
                writable: false
              };
            }
          }
          return $defineProperty(O, P, Attributes);
        } : $defineProperty : function defineProperty(O, P, Attributes) {
          anObject(O);
          P = toPropertyKey(P);
          anObject(Attributes);
          if (IE8_DOM_DEFINE)
            try {
              return $defineProperty(O, P, Attributes);
            } catch (error) {
            }
          if ("get" in Attributes || "set" in Attributes)
            throw TypeError2("Accessors not supported");
          if ("value" in Attributes)
            O[P] = Attributes.value;
          return O;
        };
      }
    });
    var require_create_non_enumerable_property = __commonJS2({
      "node_modules/core-js/internals/create-non-enumerable-property.js"(exports2, module22) {
        var DESCRIPTORS = require_descriptors();
        var definePropertyModule = require_object_define_property();
        var createPropertyDescriptor = require_create_property_descriptor();
        module22.exports = DESCRIPTORS ? function(object, key, value) {
          return definePropertyModule.f(object, key, createPropertyDescriptor(1, value));
        } : function(object, key, value) {
          object[key] = value;
          return object;
        };
      }
    });
    var require_inspect_source = __commonJS2({
      "node_modules/core-js/internals/inspect-source.js"(exports2, module22) {
        var uncurryThis = require_function_uncurry_this();
        var isCallable = require_is_callable();
        var store = require_shared_store();
        var functionToString = uncurryThis(Function.toString);
        if (!isCallable(store.inspectSource)) {
          store.inspectSource = function(it) {
            return functionToString(it);
          };
        }
        module22.exports = store.inspectSource;
      }
    });
    var require_native_weak_map = __commonJS2({
      "node_modules/core-js/internals/native-weak-map.js"(exports2, module22) {
        var global2 = require_global();
        var isCallable = require_is_callable();
        var inspectSource = require_inspect_source();
        var WeakMap2 = global2.WeakMap;
        module22.exports = isCallable(WeakMap2) && /native code/.test(inspectSource(WeakMap2));
      }
    });
    var require_shared_key = __commonJS2({
      "node_modules/core-js/internals/shared-key.js"(exports2, module22) {
        var shared = require_shared();
        var uid = require_uid();
        var keys = shared("keys");
        module22.exports = function(key) {
          return keys[key] || (keys[key] = uid(key));
        };
      }
    });
    var require_hidden_keys = __commonJS2({
      "node_modules/core-js/internals/hidden-keys.js"(exports2, module22) {
        module22.exports = {};
      }
    });
    var require_internal_state = __commonJS2({
      "node_modules/core-js/internals/internal-state.js"(exports2, module22) {
        var NATIVE_WEAK_MAP = require_native_weak_map();
        var global2 = require_global();
        var uncurryThis = require_function_uncurry_this();
        var isObject3 = require_is_object();
        var createNonEnumerableProperty = require_create_non_enumerable_property();
        var hasOwn = require_has_own_property();
        var shared = require_shared_store();
        var sharedKey = require_shared_key();
        var hiddenKeys = require_hidden_keys();
        var OBJECT_ALREADY_INITIALIZED = "Object already initialized";
        var TypeError2 = global2.TypeError;
        var WeakMap2 = global2.WeakMap;
        var set;
        var get;
        var has;
        var enforce = function(it) {
          return has(it) ? get(it) : set(it, {});
        };
        var getterFor = function(TYPE2) {
          return function(it) {
            var state;
            if (!isObject3(it) || (state = get(it)).type !== TYPE2) {
              throw TypeError2("Incompatible receiver, " + TYPE2 + " required");
            }
            return state;
          };
        };
        if (NATIVE_WEAK_MAP || shared.state) {
          store = shared.state || (shared.state = new WeakMap2());
          wmget = uncurryThis(store.get);
          wmhas = uncurryThis(store.has);
          wmset = uncurryThis(store.set);
          set = function(it, metadata) {
            if (wmhas(store, it))
              throw new TypeError2(OBJECT_ALREADY_INITIALIZED);
            metadata.facade = it;
            wmset(store, it, metadata);
            return metadata;
          };
          get = function(it) {
            return wmget(store, it) || {};
          };
          has = function(it) {
            return wmhas(store, it);
          };
        } else {
          STATE = sharedKey("state");
          hiddenKeys[STATE] = true;
          set = function(it, metadata) {
            if (hasOwn(it, STATE))
              throw new TypeError2(OBJECT_ALREADY_INITIALIZED);
            metadata.facade = it;
            createNonEnumerableProperty(it, STATE, metadata);
            return metadata;
          };
          get = function(it) {
            return hasOwn(it, STATE) ? it[STATE] : {};
          };
          has = function(it) {
            return hasOwn(it, STATE);
          };
        }
        var store;
        var wmget;
        var wmhas;
        var wmset;
        var STATE;
        module22.exports = {
          set,
          get,
          has,
          enforce,
          getterFor
        };
      }
    });
    var require_function_name = __commonJS2({
      "node_modules/core-js/internals/function-name.js"(exports2, module22) {
        var DESCRIPTORS = require_descriptors();
        var hasOwn = require_has_own_property();
        var FunctionPrototype = Function.prototype;
        var getDescriptor = DESCRIPTORS && Object.getOwnPropertyDescriptor;
        var EXISTS = hasOwn(FunctionPrototype, "name");
        var PROPER = EXISTS && function something() {
        }.name === "something";
        var CONFIGURABLE = EXISTS && (!DESCRIPTORS || DESCRIPTORS && getDescriptor(FunctionPrototype, "name").configurable);
        module22.exports = {
          EXISTS,
          PROPER,
          CONFIGURABLE
        };
      }
    });
    var require_redefine = __commonJS2({
      "node_modules/core-js/internals/redefine.js"(exports2, module22) {
        var global2 = require_global();
        var isCallable = require_is_callable();
        var hasOwn = require_has_own_property();
        var createNonEnumerableProperty = require_create_non_enumerable_property();
        var setGlobal = require_set_global();
        var inspectSource = require_inspect_source();
        var InternalStateModule = require_internal_state();
        var CONFIGURABLE_FUNCTION_NAME = require_function_name().CONFIGURABLE;
        var getInternalState = InternalStateModule.get;
        var enforceInternalState = InternalStateModule.enforce;
        var TEMPLATE = String(String).split("String");
        (module22.exports = function(O, key, value, options) {
          var unsafe = options ? !!options.unsafe : false;
          var simple = options ? !!options.enumerable : false;
          var noTargetGet = options ? !!options.noTargetGet : false;
          var name = options && options.name !== void 0 ? options.name : key;
          var state;
          if (isCallable(value)) {
            if (String(name).slice(0, 7) === "Symbol(") {
              name = "[" + String(name).replace(/^Symbol\(([^)]*)\)/, "$1") + "]";
            }
            if (!hasOwn(value, "name") || CONFIGURABLE_FUNCTION_NAME && value.name !== name) {
              createNonEnumerableProperty(value, "name", name);
            }
            state = enforceInternalState(value);
            if (!state.source) {
              state.source = TEMPLATE.join(typeof name == "string" ? name : "");
            }
          }
          if (O === global2) {
            if (simple)
              O[key] = value;
            else
              setGlobal(key, value);
            return;
          } else if (!unsafe) {
            delete O[key];
          } else if (!noTargetGet && O[key]) {
            simple = true;
          }
          if (simple)
            O[key] = value;
          else
            createNonEnumerableProperty(O, key, value);
        })(Function.prototype, "toString", function toString() {
          return isCallable(this) && getInternalState(this).source || inspectSource(this);
        });
      }
    });
    var require_to_integer_or_infinity = __commonJS2({
      "node_modules/core-js/internals/to-integer-or-infinity.js"(exports2, module22) {
        var ceil = Math.ceil;
        var floor = Math.floor;
        module22.exports = function(argument) {
          var number = +argument;
          return number !== number || number === 0 ? 0 : (number > 0 ? floor : ceil)(number);
        };
      }
    });
    var require_to_absolute_index = __commonJS2({
      "node_modules/core-js/internals/to-absolute-index.js"(exports2, module22) {
        var toIntegerOrInfinity = require_to_integer_or_infinity();
        var max = Math.max;
        var min = Math.min;
        module22.exports = function(index, length) {
          var integer = toIntegerOrInfinity(index);
          return integer < 0 ? max(integer + length, 0) : min(integer, length);
        };
      }
    });
    var require_to_length = __commonJS2({
      "node_modules/core-js/internals/to-length.js"(exports2, module22) {
        var toIntegerOrInfinity = require_to_integer_or_infinity();
        var min = Math.min;
        module22.exports = function(argument) {
          return argument > 0 ? min(toIntegerOrInfinity(argument), 9007199254740991) : 0;
        };
      }
    });
    var require_length_of_array_like = __commonJS2({
      "node_modules/core-js/internals/length-of-array-like.js"(exports2, module22) {
        var toLength = require_to_length();
        module22.exports = function(obj) {
          return toLength(obj.length);
        };
      }
    });
    var require_array_includes = __commonJS2({
      "node_modules/core-js/internals/array-includes.js"(exports2, module22) {
        var toIndexedObject = require_to_indexed_object();
        var toAbsoluteIndex = require_to_absolute_index();
        var lengthOfArrayLike = require_length_of_array_like();
        var createMethod = function(IS_INCLUDES) {
          return function($this, el, fromIndex) {
            var O = toIndexedObject($this);
            var length = lengthOfArrayLike(O);
            var index = toAbsoluteIndex(fromIndex, length);
            var value;
            if (IS_INCLUDES && el != el)
              while (length > index) {
                value = O[index++];
                if (value != value)
                  return true;
              }
            else
              for (; length > index; index++) {
                if ((IS_INCLUDES || index in O) && O[index] === el)
                  return IS_INCLUDES || index || 0;
              }
            return !IS_INCLUDES && -1;
          };
        };
        module22.exports = {
          includes: createMethod(true),
          indexOf: createMethod(false)
        };
      }
    });
    var require_object_keys_internal = __commonJS2({
      "node_modules/core-js/internals/object-keys-internal.js"(exports2, module22) {
        var uncurryThis = require_function_uncurry_this();
        var hasOwn = require_has_own_property();
        var toIndexedObject = require_to_indexed_object();
        var indexOf = require_array_includes().indexOf;
        var hiddenKeys = require_hidden_keys();
        var push2 = uncurryThis([].push);
        module22.exports = function(object, names) {
          var O = toIndexedObject(object);
          var i2 = 0;
          var result = [];
          var key;
          for (key in O)
            !hasOwn(hiddenKeys, key) && hasOwn(O, key) && push2(result, key);
          while (names.length > i2)
            if (hasOwn(O, key = names[i2++])) {
              ~indexOf(result, key) || push2(result, key);
            }
          return result;
        };
      }
    });
    var require_enum_bug_keys = __commonJS2({
      "node_modules/core-js/internals/enum-bug-keys.js"(exports2, module22) {
        module22.exports = [
          "constructor",
          "hasOwnProperty",
          "isPrototypeOf",
          "propertyIsEnumerable",
          "toLocaleString",
          "toString",
          "valueOf"
        ];
      }
    });
    var require_object_get_own_property_names = __commonJS2({
      "node_modules/core-js/internals/object-get-own-property-names.js"(exports2) {
        var internalObjectKeys = require_object_keys_internal();
        var enumBugKeys = require_enum_bug_keys();
        var hiddenKeys = enumBugKeys.concat("length", "prototype");
        exports2.f = Object.getOwnPropertyNames || function getOwnPropertyNames(O) {
          return internalObjectKeys(O, hiddenKeys);
        };
      }
    });
    var require_object_get_own_property_symbols = __commonJS2({
      "node_modules/core-js/internals/object-get-own-property-symbols.js"(exports2) {
        exports2.f = Object.getOwnPropertySymbols;
      }
    });
    var require_own_keys = __commonJS2({
      "node_modules/core-js/internals/own-keys.js"(exports2, module22) {
        var getBuiltIn = require_get_built_in();
        var uncurryThis = require_function_uncurry_this();
        var getOwnPropertyNamesModule = require_object_get_own_property_names();
        var getOwnPropertySymbolsModule = require_object_get_own_property_symbols();
        var anObject = require_an_object();
        var concat = uncurryThis([].concat);
        module22.exports = getBuiltIn("Reflect", "ownKeys") || function ownKeys(it) {
          var keys = getOwnPropertyNamesModule.f(anObject(it));
          var getOwnPropertySymbols = getOwnPropertySymbolsModule.f;
          return getOwnPropertySymbols ? concat(keys, getOwnPropertySymbols(it)) : keys;
        };
      }
    });
    var require_copy_constructor_properties = __commonJS2({
      "node_modules/core-js/internals/copy-constructor-properties.js"(exports2, module22) {
        var hasOwn = require_has_own_property();
        var ownKeys = require_own_keys();
        var getOwnPropertyDescriptorModule = require_object_get_own_property_descriptor();
        var definePropertyModule = require_object_define_property();
        module22.exports = function(target, source, exceptions) {
          var keys = ownKeys(source);
          var defineProperty = definePropertyModule.f;
          var getOwnPropertyDescriptor = getOwnPropertyDescriptorModule.f;
          for (var i2 = 0; i2 < keys.length; i2++) {
            var key = keys[i2];
            if (!hasOwn(target, key) && !(exceptions && hasOwn(exceptions, key))) {
              defineProperty(target, key, getOwnPropertyDescriptor(source, key));
            }
          }
        };
      }
    });
    var require_is_forced = __commonJS2({
      "node_modules/core-js/internals/is-forced.js"(exports2, module22) {
        var fails = require_fails();
        var isCallable = require_is_callable();
        var replacement = /#|\.prototype\./;
        var isForced = function(feature, detection) {
          var value = data[normalize(feature)];
          return value == POLYFILL ? true : value == NATIVE ? false : isCallable(detection) ? fails(detection) : !!detection;
        };
        var normalize = isForced.normalize = function(string) {
          return String(string).replace(replacement, ".").toLowerCase();
        };
        var data = isForced.data = {};
        var NATIVE = isForced.NATIVE = "N";
        var POLYFILL = isForced.POLYFILL = "P";
        module22.exports = isForced;
      }
    });
    var require_export = __commonJS2({
      "node_modules/core-js/internals/export.js"(exports2, module22) {
        var global2 = require_global();
        var getOwnPropertyDescriptor = require_object_get_own_property_descriptor().f;
        var createNonEnumerableProperty = require_create_non_enumerable_property();
        var redefine = require_redefine();
        var setGlobal = require_set_global();
        var copyConstructorProperties = require_copy_constructor_properties();
        var isForced = require_is_forced();
        module22.exports = function(options, source) {
          var TARGET = options.target;
          var GLOBAL = options.global;
          var STATIC = options.stat;
          var FORCED, target, key, targetProperty, sourceProperty, descriptor;
          if (GLOBAL) {
            target = global2;
          } else if (STATIC) {
            target = global2[TARGET] || setGlobal(TARGET, {});
          } else {
            target = (global2[TARGET] || {}).prototype;
          }
          if (target)
            for (key in source) {
              sourceProperty = source[key];
              if (options.noTargetGet) {
                descriptor = getOwnPropertyDescriptor(target, key);
                targetProperty = descriptor && descriptor.value;
              } else
                targetProperty = target[key];
              FORCED = isForced(GLOBAL ? key : TARGET + (STATIC ? "." : "#") + key, options.forced);
              if (!FORCED && targetProperty !== void 0) {
                if (typeof sourceProperty == typeof targetProperty)
                  continue;
                copyConstructorProperties(sourceProperty, targetProperty);
              }
              if (options.sham || targetProperty && targetProperty.sham) {
                createNonEnumerableProperty(sourceProperty, "sham", true);
              }
              redefine(target, key, sourceProperty, options);
            }
        };
      }
    });
    var require_is_array = __commonJS2({
      "node_modules/core-js/internals/is-array.js"(exports2, module22) {
        var classof = require_classof_raw();
        module22.exports = Array.isArray || function isArray2(argument) {
          return classof(argument) == "Array";
        };
      }
    });
    var require_function_bind_context = __commonJS2({
      "node_modules/core-js/internals/function-bind-context.js"(exports2, module22) {
        var uncurryThis = require_function_uncurry_this();
        var aCallable = require_a_callable();
        var NATIVE_BIND = require_function_bind_native();
        var bind = uncurryThis(uncurryThis.bind);
        module22.exports = function(fn, that) {
          aCallable(fn);
          return that === void 0 ? fn : NATIVE_BIND ? bind(fn, that) : function() {
            return fn.apply(that, arguments);
          };
        };
      }
    });
    var require_flatten_into_array = __commonJS2({
      "node_modules/core-js/internals/flatten-into-array.js"(exports2, module22) {
        "use strict";
        var global2 = require_global();
        var isArray2 = require_is_array();
        var lengthOfArrayLike = require_length_of_array_like();
        var bind = require_function_bind_context();
        var TypeError2 = global2.TypeError;
        var flattenIntoArray = function(target, original, source, sourceLen, start, depth, mapper, thisArg) {
          var targetIndex = start;
          var sourceIndex = 0;
          var mapFn = mapper ? bind(mapper, thisArg) : false;
          var element, elementLen;
          while (sourceIndex < sourceLen) {
            if (sourceIndex in source) {
              element = mapFn ? mapFn(source[sourceIndex], sourceIndex, original) : source[sourceIndex];
              if (depth > 0 && isArray2(element)) {
                elementLen = lengthOfArrayLike(element);
                targetIndex = flattenIntoArray(target, original, element, elementLen, targetIndex, depth - 1) - 1;
              } else {
                if (targetIndex >= 9007199254740991)
                  throw TypeError2("Exceed the acceptable array length");
                target[targetIndex] = element;
              }
              targetIndex++;
            }
            sourceIndex++;
          }
          return targetIndex;
        };
        module22.exports = flattenIntoArray;
      }
    });
    var require_to_string_tag_support = __commonJS2({
      "node_modules/core-js/internals/to-string-tag-support.js"(exports2, module22) {
        var wellKnownSymbol = require_well_known_symbol();
        var TO_STRING_TAG = wellKnownSymbol("toStringTag");
        var test = {};
        test[TO_STRING_TAG] = "z";
        module22.exports = String(test) === "[object z]";
      }
    });
    var require_classof = __commonJS2({
      "node_modules/core-js/internals/classof.js"(exports2, module22) {
        var global2 = require_global();
        var TO_STRING_TAG_SUPPORT = require_to_string_tag_support();
        var isCallable = require_is_callable();
        var classofRaw = require_classof_raw();
        var wellKnownSymbol = require_well_known_symbol();
        var TO_STRING_TAG = wellKnownSymbol("toStringTag");
        var Object2 = global2.Object;
        var CORRECT_ARGUMENTS = classofRaw(function() {
          return arguments;
        }()) == "Arguments";
        var tryGet = function(it, key) {
          try {
            return it[key];
          } catch (error) {
          }
        };
        module22.exports = TO_STRING_TAG_SUPPORT ? classofRaw : function(it) {
          var O, tag, result;
          return it === void 0 ? "Undefined" : it === null ? "Null" : typeof (tag = tryGet(O = Object2(it), TO_STRING_TAG)) == "string" ? tag : CORRECT_ARGUMENTS ? classofRaw(O) : (result = classofRaw(O)) == "Object" && isCallable(O.callee) ? "Arguments" : result;
        };
      }
    });
    var require_is_constructor = __commonJS2({
      "node_modules/core-js/internals/is-constructor.js"(exports2, module22) {
        var uncurryThis = require_function_uncurry_this();
        var fails = require_fails();
        var isCallable = require_is_callable();
        var classof = require_classof();
        var getBuiltIn = require_get_built_in();
        var inspectSource = require_inspect_source();
        var noop2 = function() {
        };
        var empty = [];
        var construct = getBuiltIn("Reflect", "construct");
        var constructorRegExp = /^\s*(?:class|function)\b/;
        var exec3 = uncurryThis(constructorRegExp.exec);
        var INCORRECT_TO_STRING = !constructorRegExp.exec(noop2);
        var isConstructorModern = function isConstructor(argument) {
          if (!isCallable(argument))
            return false;
          try {
            construct(noop2, empty, argument);
            return true;
          } catch (error) {
            return false;
          }
        };
        var isConstructorLegacy = function isConstructor(argument) {
          if (!isCallable(argument))
            return false;
          switch (classof(argument)) {
            case "AsyncFunction":
            case "GeneratorFunction":
            case "AsyncGeneratorFunction":
              return false;
          }
          try {
            return INCORRECT_TO_STRING || !!exec3(constructorRegExp, inspectSource(argument));
          } catch (error) {
            return true;
          }
        };
        isConstructorLegacy.sham = true;
        module22.exports = !construct || fails(function() {
          var called;
          return isConstructorModern(isConstructorModern.call) || !isConstructorModern(Object) || !isConstructorModern(function() {
            called = true;
          }) || called;
        }) ? isConstructorLegacy : isConstructorModern;
      }
    });
    var require_array_species_constructor = __commonJS2({
      "node_modules/core-js/internals/array-species-constructor.js"(exports2, module22) {
        var global2 = require_global();
        var isArray2 = require_is_array();
        var isConstructor = require_is_constructor();
        var isObject3 = require_is_object();
        var wellKnownSymbol = require_well_known_symbol();
        var SPECIES = wellKnownSymbol("species");
        var Array2 = global2.Array;
        module22.exports = function(originalArray) {
          var C;
          if (isArray2(originalArray)) {
            C = originalArray.constructor;
            if (isConstructor(C) && (C === Array2 || isArray2(C.prototype)))
              C = void 0;
            else if (isObject3(C)) {
              C = C[SPECIES];
              if (C === null)
                C = void 0;
            }
          }
          return C === void 0 ? Array2 : C;
        };
      }
    });
    var require_array_species_create = __commonJS2({
      "node_modules/core-js/internals/array-species-create.js"(exports2, module22) {
        var arraySpeciesConstructor = require_array_species_constructor();
        module22.exports = function(originalArray, length) {
          return new (arraySpeciesConstructor(originalArray))(length === 0 ? 0 : length);
        };
      }
    });
    var require_es_array_flat_map = __commonJS2({
      "node_modules/core-js/modules/es.array.flat-map.js"() {
        "use strict";
        var $ = require_export();
        var flattenIntoArray = require_flatten_into_array();
        var aCallable = require_a_callable();
        var toObject = require_to_object();
        var lengthOfArrayLike = require_length_of_array_like();
        var arraySpeciesCreate = require_array_species_create();
        $({ target: "Array", proto: true }, {
          flatMap: function flatMap(callbackfn) {
            var O = toObject(this);
            var sourceLen = lengthOfArrayLike(O);
            var A2;
            aCallable(callbackfn);
            A2 = arraySpeciesCreate(O, 0);
            A2.length = flattenIntoArray(A2, O, O, sourceLen, 0, 1, callbackfn, arguments.length > 1 ? arguments[1] : void 0);
            return A2;
          }
        });
      }
    });
    var require_iterators = __commonJS2({
      "node_modules/core-js/internals/iterators.js"(exports2, module22) {
        module22.exports = {};
      }
    });
    var require_is_array_iterator_method = __commonJS2({
      "node_modules/core-js/internals/is-array-iterator-method.js"(exports2, module22) {
        var wellKnownSymbol = require_well_known_symbol();
        var Iterators = require_iterators();
        var ITERATOR = wellKnownSymbol("iterator");
        var ArrayPrototype = Array.prototype;
        module22.exports = function(it) {
          return it !== void 0 && (Iterators.Array === it || ArrayPrototype[ITERATOR] === it);
        };
      }
    });
    var require_get_iterator_method = __commonJS2({
      "node_modules/core-js/internals/get-iterator-method.js"(exports2, module22) {
        var classof = require_classof();
        var getMethod = require_get_method();
        var Iterators = require_iterators();
        var wellKnownSymbol = require_well_known_symbol();
        var ITERATOR = wellKnownSymbol("iterator");
        module22.exports = function(it) {
          if (it != void 0)
            return getMethod(it, ITERATOR) || getMethod(it, "@@iterator") || Iterators[classof(it)];
        };
      }
    });
    var require_get_iterator = __commonJS2({
      "node_modules/core-js/internals/get-iterator.js"(exports2, module22) {
        var global2 = require_global();
        var call = require_function_call();
        var aCallable = require_a_callable();
        var anObject = require_an_object();
        var tryToString = require_try_to_string();
        var getIteratorMethod = require_get_iterator_method();
        var TypeError2 = global2.TypeError;
        module22.exports = function(argument, usingIterator) {
          var iteratorMethod = arguments.length < 2 ? getIteratorMethod(argument) : usingIterator;
          if (aCallable(iteratorMethod))
            return anObject(call(iteratorMethod, argument));
          throw TypeError2(tryToString(argument) + " is not iterable");
        };
      }
    });
    var require_iterator_close = __commonJS2({
      "node_modules/core-js/internals/iterator-close.js"(exports2, module22) {
        var call = require_function_call();
        var anObject = require_an_object();
        var getMethod = require_get_method();
        module22.exports = function(iterator2, kind, value) {
          var innerResult, innerError;
          anObject(iterator2);
          try {
            innerResult = getMethod(iterator2, "return");
            if (!innerResult) {
              if (kind === "throw")
                throw value;
              return value;
            }
            innerResult = call(innerResult, iterator2);
          } catch (error) {
            innerError = true;
            innerResult = error;
          }
          if (kind === "throw")
            throw value;
          if (innerError)
            throw innerResult;
          anObject(innerResult);
          return value;
        };
      }
    });
    var require_iterate = __commonJS2({
      "node_modules/core-js/internals/iterate.js"(exports2, module22) {
        var global2 = require_global();
        var bind = require_function_bind_context();
        var call = require_function_call();
        var anObject = require_an_object();
        var tryToString = require_try_to_string();
        var isArrayIteratorMethod = require_is_array_iterator_method();
        var lengthOfArrayLike = require_length_of_array_like();
        var isPrototypeOf = require_object_is_prototype_of();
        var getIterator = require_get_iterator();
        var getIteratorMethod = require_get_iterator_method();
        var iteratorClose = require_iterator_close();
        var TypeError2 = global2.TypeError;
        var Result = function(stopped, result) {
          this.stopped = stopped;
          this.result = result;
        };
        var ResultPrototype = Result.prototype;
        module22.exports = function(iterable, unboundFunction, options) {
          var that = options && options.that;
          var AS_ENTRIES = !!(options && options.AS_ENTRIES);
          var IS_ITERATOR = !!(options && options.IS_ITERATOR);
          var INTERRUPTED = !!(options && options.INTERRUPTED);
          var fn = bind(unboundFunction, that);
          var iterator2, iterFn, index, length, result, next, step;
          var stop = function(condition) {
            if (iterator2)
              iteratorClose(iterator2, "normal", condition);
            return new Result(true, condition);
          };
          var callFn = function(value) {
            if (AS_ENTRIES) {
              anObject(value);
              return INTERRUPTED ? fn(value[0], value[1], stop) : fn(value[0], value[1]);
            }
            return INTERRUPTED ? fn(value, stop) : fn(value);
          };
          if (IS_ITERATOR) {
            iterator2 = iterable;
          } else {
            iterFn = getIteratorMethod(iterable);
            if (!iterFn)
              throw TypeError2(tryToString(iterable) + " is not iterable");
            if (isArrayIteratorMethod(iterFn)) {
              for (index = 0, length = lengthOfArrayLike(iterable); length > index; index++) {
                result = callFn(iterable[index]);
                if (result && isPrototypeOf(ResultPrototype, result))
                  return result;
              }
              return new Result(false);
            }
            iterator2 = getIterator(iterable, iterFn);
          }
          next = iterator2.next;
          while (!(step = call(next, iterator2)).done) {
            try {
              result = callFn(step.value);
            } catch (error) {
              iteratorClose(iterator2, "throw", error);
            }
            if (typeof result == "object" && result && isPrototypeOf(ResultPrototype, result))
              return result;
          }
          return new Result(false);
        };
      }
    });
    var require_create_property = __commonJS2({
      "node_modules/core-js/internals/create-property.js"(exports2, module22) {
        "use strict";
        var toPropertyKey = require_to_property_key();
        var definePropertyModule = require_object_define_property();
        var createPropertyDescriptor = require_create_property_descriptor();
        module22.exports = function(object, key, value) {
          var propertyKey = toPropertyKey(key);
          if (propertyKey in object)
            definePropertyModule.f(object, propertyKey, createPropertyDescriptor(0, value));
          else
            object[propertyKey] = value;
        };
      }
    });
    var require_es_object_from_entries = __commonJS2({
      "node_modules/core-js/modules/es.object.from-entries.js"() {
        var $ = require_export();
        var iterate = require_iterate();
        var createProperty = require_create_property();
        $({ target: "Object", stat: true }, {
          fromEntries: function fromEntries(iterable) {
            var obj = {};
            iterate(iterable, function(k, v) {
              createProperty(obj, k, v);
            }, { AS_ENTRIES: true });
            return obj;
          }
        });
      }
    });
    var require_es_array_flat = __commonJS2({
      "node_modules/core-js/modules/es.array.flat.js"() {
        "use strict";
        var $ = require_export();
        var flattenIntoArray = require_flatten_into_array();
        var toObject = require_to_object();
        var lengthOfArrayLike = require_length_of_array_like();
        var toIntegerOrInfinity = require_to_integer_or_infinity();
        var arraySpeciesCreate = require_array_species_create();
        $({ target: "Array", proto: true }, {
          flat: function flat() {
            var depthArg = arguments.length ? arguments[0] : void 0;
            var O = toObject(this);
            var sourceLen = lengthOfArrayLike(O);
            var A2 = arraySpeciesCreate(O, 0);
            A2.length = flattenIntoArray(A2, O, O, sourceLen, 0, depthArg === void 0 ? 1 : toIntegerOrInfinity(depthArg));
            return A2;
          }
        });
      }
    });
    var _excluded = ["cliName", "cliCategory", "cliDescription"];
    var _excluded2 = ["_"];
    var _excluded3 = ["overrides"];
    var _excluded4 = ["languageId"];
    function _objectWithoutProperties(source, excluded) {
      if (source == null)
        return {};
      var target = _objectWithoutPropertiesLoose(source, excluded);
      var key, i2;
      if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for (i2 = 0; i2 < sourceSymbolKeys.length; i2++) {
          key = sourceSymbolKeys[i2];
          if (excluded.indexOf(key) >= 0)
            continue;
          if (!Object.prototype.propertyIsEnumerable.call(source, key))
            continue;
          target[key] = source[key];
        }
      }
      return target;
    }
    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null)
        return {};
      var target = {};
      var sourceKeys = Object.keys(source);
      var key, i2;
      for (i2 = 0; i2 < sourceKeys.length; i2++) {
        key = sourceKeys[i2];
        if (excluded.indexOf(key) >= 0)
          continue;
        target[key] = source[key];
      }
      return target;
    }
    require_es_array_flat_map();
    require_es_object_from_entries();
    require_es_array_flat();
    var __create2 = Object.create;
    var __defProp2 = Object.defineProperty;
    var __getOwnPropDesc2 = Object.getOwnPropertyDescriptor;
    var __getOwnPropNames22 = Object.getOwnPropertyNames;
    var __getProtoOf2 = Object.getPrototypeOf;
    var __hasOwnProp2 = Object.prototype.hasOwnProperty;
    var __esm2 = (fn, res) => function __init() {
      return fn && (res = (0, fn[__getOwnPropNames22(fn)[0]])(fn = 0)), res;
    };
    var __commonJS22 = (cb, mod) => function __require() {
      return mod || (0, cb[__getOwnPropNames22(cb)[0]])((mod = {
        exports: {}
      }).exports, mod), mod.exports;
    };
    var __export2 = (target, all) => {
      for (var name in all)
        __defProp2(target, name, {
          get: all[name],
          enumerable: true
        });
    };
    var __copyProps2 = (to, from, except, desc) => {
      if (from && typeof from === "object" || typeof from === "function") {
        for (let key of __getOwnPropNames22(from))
          if (!__hasOwnProp2.call(to, key) && key !== except)
            __defProp2(to, key, {
              get: () => from[key],
              enumerable: !(desc = __getOwnPropDesc2(from, key)) || desc.enumerable
            });
      }
      return to;
    };
    var __toESM2 = (mod, isNodeMode, target) => (target = mod != null ? __create2(__getProtoOf2(mod)) : {}, __copyProps2(isNodeMode || !mod || !mod.__esModule ? __defProp2(target, "default", {
      value: mod,
      enumerable: true
    }) : target, mod));
    var __toCommonJS2 = (mod) => __copyProps2(__defProp2({}, "__esModule", {
      value: true
    }), mod);
    var require_base = __commonJS22({
      "node_modules/diff/lib/diff/base.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2["default"] = Diff;
        function Diff() {
        }
        Diff.prototype = {
          diff: function diff2(oldString, newString) {
            var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
            var callback = options.callback;
            if (typeof options === "function") {
              callback = options;
              options = {};
            }
            this.options = options;
            var self2 = this;
            function done(value) {
              if (callback) {
                setTimeout(function() {
                  callback(void 0, value);
                }, 0);
                return true;
              } else {
                return value;
              }
            }
            oldString = this.castInput(oldString);
            newString = this.castInput(newString);
            oldString = this.removeEmpty(this.tokenize(oldString));
            newString = this.removeEmpty(this.tokenize(newString));
            var newLen = newString.length, oldLen = oldString.length;
            var editLength = 1;
            var maxEditLength = newLen + oldLen;
            var bestPath = [{
              newPos: -1,
              components: []
            }];
            var oldPos = this.extractCommon(bestPath[0], newString, oldString, 0);
            if (bestPath[0].newPos + 1 >= newLen && oldPos + 1 >= oldLen) {
              return done([{
                value: this.join(newString),
                count: newString.length
              }]);
            }
            function execEditLength() {
              for (var diagonalPath = -1 * editLength; diagonalPath <= editLength; diagonalPath += 2) {
                var basePath = void 0;
                var addPath = bestPath[diagonalPath - 1], removePath = bestPath[diagonalPath + 1], _oldPos = (removePath ? removePath.newPos : 0) - diagonalPath;
                if (addPath) {
                  bestPath[diagonalPath - 1] = void 0;
                }
                var canAdd = addPath && addPath.newPos + 1 < newLen, canRemove = removePath && 0 <= _oldPos && _oldPos < oldLen;
                if (!canAdd && !canRemove) {
                  bestPath[diagonalPath] = void 0;
                  continue;
                }
                if (!canAdd || canRemove && addPath.newPos < removePath.newPos) {
                  basePath = clonePath(removePath);
                  self2.pushComponent(basePath.components, void 0, true);
                } else {
                  basePath = addPath;
                  basePath.newPos++;
                  self2.pushComponent(basePath.components, true, void 0);
                }
                _oldPos = self2.extractCommon(basePath, newString, oldString, diagonalPath);
                if (basePath.newPos + 1 >= newLen && _oldPos + 1 >= oldLen) {
                  return done(buildValues(self2, basePath.components, newString, oldString, self2.useLongestToken));
                } else {
                  bestPath[diagonalPath] = basePath;
                }
              }
              editLength++;
            }
            if (callback) {
              (function exec3() {
                setTimeout(function() {
                  if (editLength > maxEditLength) {
                    return callback();
                  }
                  if (!execEditLength()) {
                    exec3();
                  }
                }, 0);
              })();
            } else {
              while (editLength <= maxEditLength) {
                var ret = execEditLength();
                if (ret) {
                  return ret;
                }
              }
            }
          },
          pushComponent: function pushComponent(components, added, removed) {
            var last = components[components.length - 1];
            if (last && last.added === added && last.removed === removed) {
              components[components.length - 1] = {
                count: last.count + 1,
                added,
                removed
              };
            } else {
              components.push({
                count: 1,
                added,
                removed
              });
            }
          },
          extractCommon: function extractCommon(basePath, newString, oldString, diagonalPath) {
            var newLen = newString.length, oldLen = oldString.length, newPos = basePath.newPos, oldPos = newPos - diagonalPath, commonCount = 0;
            while (newPos + 1 < newLen && oldPos + 1 < oldLen && this.equals(newString[newPos + 1], oldString[oldPos + 1])) {
              newPos++;
              oldPos++;
              commonCount++;
            }
            if (commonCount) {
              basePath.components.push({
                count: commonCount
              });
            }
            basePath.newPos = newPos;
            return oldPos;
          },
          equals: function equals(left, right) {
            if (this.options.comparator) {
              return this.options.comparator(left, right);
            } else {
              return left === right || this.options.ignoreCase && left.toLowerCase() === right.toLowerCase();
            }
          },
          removeEmpty: function removeEmpty(array) {
            var ret = [];
            for (var i2 = 0; i2 < array.length; i2++) {
              if (array[i2]) {
                ret.push(array[i2]);
              }
            }
            return ret;
          },
          castInput: function castInput(value) {
            return value;
          },
          tokenize: function tokenize(value) {
            return value.split("");
          },
          join: function join(chars) {
            return chars.join("");
          }
        };
        function buildValues(diff2, components, newString, oldString, useLongestToken) {
          var componentPos = 0, componentLen = components.length, newPos = 0, oldPos = 0;
          for (; componentPos < componentLen; componentPos++) {
            var component = components[componentPos];
            if (!component.removed) {
              if (!component.added && useLongestToken) {
                var value = newString.slice(newPos, newPos + component.count);
                value = value.map(function(value2, i2) {
                  var oldValue = oldString[oldPos + i2];
                  return oldValue.length > value2.length ? oldValue : value2;
                });
                component.value = diff2.join(value);
              } else {
                component.value = diff2.join(newString.slice(newPos, newPos + component.count));
              }
              newPos += component.count;
              if (!component.added) {
                oldPos += component.count;
              }
            } else {
              component.value = diff2.join(oldString.slice(oldPos, oldPos + component.count));
              oldPos += component.count;
              if (componentPos && components[componentPos - 1].added) {
                var tmp = components[componentPos - 1];
                components[componentPos - 1] = components[componentPos];
                components[componentPos] = tmp;
              }
            }
          }
          var lastComponent = components[componentLen - 1];
          if (componentLen > 1 && typeof lastComponent.value === "string" && (lastComponent.added || lastComponent.removed) && diff2.equals("", lastComponent.value)) {
            components[componentLen - 2].value += lastComponent.value;
            components.pop();
          }
          return components;
        }
        function clonePath(path4) {
          return {
            newPos: path4.newPos,
            components: path4.components.slice(0)
          };
        }
      }
    });
    var require_array2 = __commonJS22({
      "node_modules/diff/lib/diff/array.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.diffArrays = diffArrays;
        exports2.arrayDiff = void 0;
        var _base = _interopRequireDefault(require_base());
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            "default": obj
          };
        }
        var arrayDiff = new _base["default"]();
        exports2.arrayDiff = arrayDiff;
        arrayDiff.tokenize = function(value) {
          return value.slice();
        };
        arrayDiff.join = arrayDiff.removeEmpty = function(value) {
          return value;
        };
        function diffArrays(oldArr, newArr, callback) {
          return arrayDiff.diff(oldArr, newArr, callback);
        }
      }
    });
    var escape_string_regexp_exports = {};
    __export2(escape_string_regexp_exports, {
      default: () => escapeStringRegexp
    });
    function escapeStringRegexp(string) {
      if (typeof string !== "string") {
        throw new TypeError("Expected a string");
      }
      return string.replace(/[|\\{}()[\]^$+*?.]/g, "\\$&").replace(/-/g, "\\x2d");
    }
    var init_escape_string_regexp = __esm2({
      "node_modules/escape-string-regexp/index.js"() {
      }
    });
    var require_get_last = __commonJS22({
      "src/utils/get-last.js"(exports2, module22) {
        "use strict";
        var getLast = (arr) => arr[arr.length - 1];
        module22.exports = getLast;
      }
    });
    var require_debug2 = __commonJS22({
      "node_modules/semver/internal/debug.js"(exports2, module22) {
        var debug = typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG) ? (...args) => console.error("SEMVER", ...args) : () => {
        };
        module22.exports = debug;
      }
    });
    var require_constants5 = __commonJS22({
      "node_modules/semver/internal/constants.js"(exports2, module22) {
        var SEMVER_SPEC_VERSION = "2.0.0";
        var MAX_LENGTH = 256;
        var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
        var MAX_SAFE_COMPONENT_LENGTH = 16;
        module22.exports = {
          SEMVER_SPEC_VERSION,
          MAX_LENGTH,
          MAX_SAFE_INTEGER,
          MAX_SAFE_COMPONENT_LENGTH
        };
      }
    });
    var require_re2 = __commonJS22({
      "node_modules/semver/internal/re.js"(exports2, module22) {
        var {
          MAX_SAFE_COMPONENT_LENGTH
        } = require_constants5();
        var debug = require_debug2();
        exports2 = module22.exports = {};
        var re = exports2.re = [];
        var src = exports2.src = [];
        var t2 = exports2.t = {};
        var R = 0;
        var createToken = (name, value, isGlobal) => {
          const index = R++;
          debug(name, index, value);
          t2[name] = index;
          src[index] = value;
          re[index] = new RegExp(value, isGlobal ? "g" : void 0);
        };
        createToken("NUMERICIDENTIFIER", "0|[1-9]\\d*");
        createToken("NUMERICIDENTIFIERLOOSE", "[0-9]+");
        createToken("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*");
        createToken("MAINVERSION", `(${src[t2.NUMERICIDENTIFIER]})\\.(${src[t2.NUMERICIDENTIFIER]})\\.(${src[t2.NUMERICIDENTIFIER]})`);
        createToken("MAINVERSIONLOOSE", `(${src[t2.NUMERICIDENTIFIERLOOSE]})\\.(${src[t2.NUMERICIDENTIFIERLOOSE]})\\.(${src[t2.NUMERICIDENTIFIERLOOSE]})`);
        createToken("PRERELEASEIDENTIFIER", `(?:${src[t2.NUMERICIDENTIFIER]}|${src[t2.NONNUMERICIDENTIFIER]})`);
        createToken("PRERELEASEIDENTIFIERLOOSE", `(?:${src[t2.NUMERICIDENTIFIERLOOSE]}|${src[t2.NONNUMERICIDENTIFIER]})`);
        createToken("PRERELEASE", `(?:-(${src[t2.PRERELEASEIDENTIFIER]}(?:\\.${src[t2.PRERELEASEIDENTIFIER]})*))`);
        createToken("PRERELEASELOOSE", `(?:-?(${src[t2.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${src[t2.PRERELEASEIDENTIFIERLOOSE]})*))`);
        createToken("BUILDIDENTIFIER", "[0-9A-Za-z-]+");
        createToken("BUILD", `(?:\\+(${src[t2.BUILDIDENTIFIER]}(?:\\.${src[t2.BUILDIDENTIFIER]})*))`);
        createToken("FULLPLAIN", `v?${src[t2.MAINVERSION]}${src[t2.PRERELEASE]}?${src[t2.BUILD]}?`);
        createToken("FULL", `^${src[t2.FULLPLAIN]}$`);
        createToken("LOOSEPLAIN", `[v=\\s]*${src[t2.MAINVERSIONLOOSE]}${src[t2.PRERELEASELOOSE]}?${src[t2.BUILD]}?`);
        createToken("LOOSE", `^${src[t2.LOOSEPLAIN]}$`);
        createToken("GTLT", "((?:<|>)?=?)");
        createToken("XRANGEIDENTIFIERLOOSE", `${src[t2.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);
        createToken("XRANGEIDENTIFIER", `${src[t2.NUMERICIDENTIFIER]}|x|X|\\*`);
        createToken("XRANGEPLAIN", `[v=\\s]*(${src[t2.XRANGEIDENTIFIER]})(?:\\.(${src[t2.XRANGEIDENTIFIER]})(?:\\.(${src[t2.XRANGEIDENTIFIER]})(?:${src[t2.PRERELEASE]})?${src[t2.BUILD]}?)?)?`);
        createToken("XRANGEPLAINLOOSE", `[v=\\s]*(${src[t2.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t2.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t2.XRANGEIDENTIFIERLOOSE]})(?:${src[t2.PRERELEASELOOSE]})?${src[t2.BUILD]}?)?)?`);
        createToken("XRANGE", `^${src[t2.GTLT]}\\s*${src[t2.XRANGEPLAIN]}$`);
        createToken("XRANGELOOSE", `^${src[t2.GTLT]}\\s*${src[t2.XRANGEPLAINLOOSE]}$`);
        createToken("COERCE", `${"(^|[^\\d])(\\d{1,"}${MAX_SAFE_COMPONENT_LENGTH}})(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:$|[^\\d])`);
        createToken("COERCERTL", src[t2.COERCE], true);
        createToken("LONETILDE", "(?:~>?)");
        createToken("TILDETRIM", `(\\s*)${src[t2.LONETILDE]}\\s+`, true);
        exports2.tildeTrimReplace = "$1~";
        createToken("TILDE", `^${src[t2.LONETILDE]}${src[t2.XRANGEPLAIN]}$`);
        createToken("TILDELOOSE", `^${src[t2.LONETILDE]}${src[t2.XRANGEPLAINLOOSE]}$`);
        createToken("LONECARET", "(?:\\^)");
        createToken("CARETTRIM", `(\\s*)${src[t2.LONECARET]}\\s+`, true);
        exports2.caretTrimReplace = "$1^";
        createToken("CARET", `^${src[t2.LONECARET]}${src[t2.XRANGEPLAIN]}$`);
        createToken("CARETLOOSE", `^${src[t2.LONECARET]}${src[t2.XRANGEPLAINLOOSE]}$`);
        createToken("COMPARATORLOOSE", `^${src[t2.GTLT]}\\s*(${src[t2.LOOSEPLAIN]})$|^$`);
        createToken("COMPARATOR", `^${src[t2.GTLT]}\\s*(${src[t2.FULLPLAIN]})$|^$`);
        createToken("COMPARATORTRIM", `(\\s*)${src[t2.GTLT]}\\s*(${src[t2.LOOSEPLAIN]}|${src[t2.XRANGEPLAIN]})`, true);
        exports2.comparatorTrimReplace = "$1$2$3";
        createToken("HYPHENRANGE", `^\\s*(${src[t2.XRANGEPLAIN]})\\s+-\\s+(${src[t2.XRANGEPLAIN]})\\s*$`);
        createToken("HYPHENRANGELOOSE", `^\\s*(${src[t2.XRANGEPLAINLOOSE]})\\s+-\\s+(${src[t2.XRANGEPLAINLOOSE]})\\s*$`);
        createToken("STAR", "(<|>)?=?\\s*\\*");
        createToken("GTE0", "^\\s*>=\\s*0\\.0\\.0\\s*$");
        createToken("GTE0PRE", "^\\s*>=\\s*0\\.0\\.0-0\\s*$");
      }
    });
    var require_parse_options2 = __commonJS22({
      "node_modules/semver/internal/parse-options.js"(exports2, module22) {
        var opts = ["includePrerelease", "loose", "rtl"];
        var parseOptions = (options) => !options ? {} : typeof options !== "object" ? {
          loose: true
        } : opts.filter((k) => options[k]).reduce((o, k) => {
          o[k] = true;
          return o;
        }, {});
        module22.exports = parseOptions;
      }
    });
    var require_identifiers2 = __commonJS22({
      "node_modules/semver/internal/identifiers.js"(exports2, module22) {
        var numeric = /^[0-9]+$/;
        var compareIdentifiers = (a, b) => {
          const anum = numeric.test(a);
          const bnum = numeric.test(b);
          if (anum && bnum) {
            a = +a;
            b = +b;
          }
          return a === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a < b ? -1 : 1;
        };
        var rcompareIdentifiers = (a, b) => compareIdentifiers(b, a);
        module22.exports = {
          compareIdentifiers,
          rcompareIdentifiers
        };
      }
    });
    var require_semver4 = __commonJS22({
      "node_modules/semver/classes/semver.js"(exports2, module22) {
        var debug = require_debug2();
        var {
          MAX_LENGTH,
          MAX_SAFE_INTEGER
        } = require_constants5();
        var {
          re,
          t: t2
        } = require_re2();
        var parseOptions = require_parse_options2();
        var {
          compareIdentifiers
        } = require_identifiers2();
        var SemVer = class {
          constructor(version2, options) {
            options = parseOptions(options);
            if (version2 instanceof SemVer) {
              if (version2.loose === !!options.loose && version2.includePrerelease === !!options.includePrerelease) {
                return version2;
              } else {
                version2 = version2.version;
              }
            } else if (typeof version2 !== "string") {
              throw new TypeError(`Invalid Version: ${version2}`);
            }
            if (version2.length > MAX_LENGTH) {
              throw new TypeError(`version is longer than ${MAX_LENGTH} characters`);
            }
            debug("SemVer", version2, options);
            this.options = options;
            this.loose = !!options.loose;
            this.includePrerelease = !!options.includePrerelease;
            const m2 = version2.trim().match(options.loose ? re[t2.LOOSE] : re[t2.FULL]);
            if (!m2) {
              throw new TypeError(`Invalid Version: ${version2}`);
            }
            this.raw = version2;
            this.major = +m2[1];
            this.minor = +m2[2];
            this.patch = +m2[3];
            if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
              throw new TypeError("Invalid major version");
            }
            if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
              throw new TypeError("Invalid minor version");
            }
            if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
              throw new TypeError("Invalid patch version");
            }
            if (!m2[4]) {
              this.prerelease = [];
            } else {
              this.prerelease = m2[4].split(".").map((id) => {
                if (/^[0-9]+$/.test(id)) {
                  const num = +id;
                  if (num >= 0 && num < MAX_SAFE_INTEGER) {
                    return num;
                  }
                }
                return id;
              });
            }
            this.build = m2[5] ? m2[5].split(".") : [];
            this.format();
          }
          format() {
            this.version = `${this.major}.${this.minor}.${this.patch}`;
            if (this.prerelease.length) {
              this.version += `-${this.prerelease.join(".")}`;
            }
            return this.version;
          }
          toString() {
            return this.version;
          }
          compare(other) {
            debug("SemVer.compare", this.version, this.options, other);
            if (!(other instanceof SemVer)) {
              if (typeof other === "string" && other === this.version) {
                return 0;
              }
              other = new SemVer(other, this.options);
            }
            if (other.version === this.version) {
              return 0;
            }
            return this.compareMain(other) || this.comparePre(other);
          }
          compareMain(other) {
            if (!(other instanceof SemVer)) {
              other = new SemVer(other, this.options);
            }
            return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
          }
          comparePre(other) {
            if (!(other instanceof SemVer)) {
              other = new SemVer(other, this.options);
            }
            if (this.prerelease.length && !other.prerelease.length) {
              return -1;
            } else if (!this.prerelease.length && other.prerelease.length) {
              return 1;
            } else if (!this.prerelease.length && !other.prerelease.length) {
              return 0;
            }
            let i2 = 0;
            do {
              const a = this.prerelease[i2];
              const b = other.prerelease[i2];
              debug("prerelease compare", i2, a, b);
              if (a === void 0 && b === void 0) {
                return 0;
              } else if (b === void 0) {
                return 1;
              } else if (a === void 0) {
                return -1;
              } else if (a === b) {
                continue;
              } else {
                return compareIdentifiers(a, b);
              }
            } while (++i2);
          }
          compareBuild(other) {
            if (!(other instanceof SemVer)) {
              other = new SemVer(other, this.options);
            }
            let i2 = 0;
            do {
              const a = this.build[i2];
              const b = other.build[i2];
              debug("prerelease compare", i2, a, b);
              if (a === void 0 && b === void 0) {
                return 0;
              } else if (b === void 0) {
                return 1;
              } else if (a === void 0) {
                return -1;
              } else if (a === b) {
                continue;
              } else {
                return compareIdentifiers(a, b);
              }
            } while (++i2);
          }
          inc(release, identifier) {
            switch (release) {
              case "premajor":
                this.prerelease.length = 0;
                this.patch = 0;
                this.minor = 0;
                this.major++;
                this.inc("pre", identifier);
                break;
              case "preminor":
                this.prerelease.length = 0;
                this.patch = 0;
                this.minor++;
                this.inc("pre", identifier);
                break;
              case "prepatch":
                this.prerelease.length = 0;
                this.inc("patch", identifier);
                this.inc("pre", identifier);
                break;
              case "prerelease":
                if (this.prerelease.length === 0) {
                  this.inc("patch", identifier);
                }
                this.inc("pre", identifier);
                break;
              case "major":
                if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
                  this.major++;
                }
                this.minor = 0;
                this.patch = 0;
                this.prerelease = [];
                break;
              case "minor":
                if (this.patch !== 0 || this.prerelease.length === 0) {
                  this.minor++;
                }
                this.patch = 0;
                this.prerelease = [];
                break;
              case "patch":
                if (this.prerelease.length === 0) {
                  this.patch++;
                }
                this.prerelease = [];
                break;
              case "pre":
                if (this.prerelease.length === 0) {
                  this.prerelease = [0];
                } else {
                  let i2 = this.prerelease.length;
                  while (--i2 >= 0) {
                    if (typeof this.prerelease[i2] === "number") {
                      this.prerelease[i2]++;
                      i2 = -2;
                    }
                  }
                  if (i2 === -1) {
                    this.prerelease.push(0);
                  }
                }
                if (identifier) {
                  if (compareIdentifiers(this.prerelease[0], identifier) === 0) {
                    if (isNaN(this.prerelease[1])) {
                      this.prerelease = [identifier, 0];
                    }
                  } else {
                    this.prerelease = [identifier, 0];
                  }
                }
                break;
              default:
                throw new Error(`invalid increment argument: ${release}`);
            }
            this.format();
            this.raw = this.version;
            return this;
          }
        };
        module22.exports = SemVer;
      }
    });
    var require_compare2 = __commonJS22({
      "node_modules/semver/functions/compare.js"(exports2, module22) {
        var SemVer = require_semver4();
        var compare = (a, b, loose) => new SemVer(a, loose).compare(new SemVer(b, loose));
        module22.exports = compare;
      }
    });
    var require_lt2 = __commonJS22({
      "node_modules/semver/functions/lt.js"(exports2, module22) {
        var compare = require_compare2();
        var lt = (a, b, loose) => compare(a, b, loose) < 0;
        module22.exports = lt;
      }
    });
    var require_gte2 = __commonJS22({
      "node_modules/semver/functions/gte.js"(exports2, module22) {
        var compare = require_compare2();
        var gte = (a, b, loose) => compare(a, b, loose) >= 0;
        module22.exports = gte;
      }
    });
    var require_arrayify = __commonJS22({
      "src/utils/arrayify.js"(exports2, module22) {
        "use strict";
        module22.exports = (object, keyName) => Object.entries(object).map(([key, value]) => Object.assign({
          [keyName]: key
        }, value));
      }
    });
    var require_lib8 = __commonJS22({
      "node_modules/outdent/lib/index.js"(exports2, module22) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.outdent = void 0;
        function noop2() {
          var args = [];
          for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
          }
        }
        function createWeakMap() {
          if (typeof WeakMap !== "undefined") {
            return /* @__PURE__ */ new WeakMap();
          } else {
            return fakeSetOrMap();
          }
        }
        function fakeSetOrMap() {
          return {
            add: noop2,
            delete: noop2,
            get: noop2,
            set: noop2,
            has: function(k) {
              return false;
            }
          };
        }
        var hop = Object.prototype.hasOwnProperty;
        var has = function(obj, prop) {
          return hop.call(obj, prop);
        };
        function extend(target, source) {
          for (var prop in source) {
            if (has(source, prop)) {
              target[prop] = source[prop];
            }
          }
          return target;
        }
        var reLeadingNewline = /^[ \t]*(?:\r\n|\r|\n)/;
        var reTrailingNewline = /(?:\r\n|\r|\n)[ \t]*$/;
        var reStartsWithNewlineOrIsEmpty = /^(?:[\r\n]|$)/;
        var reDetectIndentation = /(?:\r\n|\r|\n)([ \t]*)(?:[^ \t\r\n]|$)/;
        var reOnlyWhitespaceWithAtLeastOneNewline = /^[ \t]*[\r\n][ \t\r\n]*$/;
        function _outdentArray(strings, firstInterpolatedValueSetsIndentationLevel, options) {
          var indentationLevel = 0;
          var match = strings[0].match(reDetectIndentation);
          if (match) {
            indentationLevel = match[1].length;
          }
          var reSource = "(\\r\\n|\\r|\\n).{0," + indentationLevel + "}";
          var reMatchIndent = new RegExp(reSource, "g");
          if (firstInterpolatedValueSetsIndentationLevel) {
            strings = strings.slice(1);
          }
          var newline = options.newline, trimLeadingNewline = options.trimLeadingNewline, trimTrailingNewline = options.trimTrailingNewline;
          var normalizeNewlines = typeof newline === "string";
          var l = strings.length;
          var outdentedStrings = strings.map(function(v, i2) {
            v = v.replace(reMatchIndent, "$1");
            if (i2 === 0 && trimLeadingNewline) {
              v = v.replace(reLeadingNewline, "");
            }
            if (i2 === l - 1 && trimTrailingNewline) {
              v = v.replace(reTrailingNewline, "");
            }
            if (normalizeNewlines) {
              v = v.replace(/\r\n|\n|\r/g, function(_) {
                return newline;
              });
            }
            return v;
          });
          return outdentedStrings;
        }
        function concatStringsAndValues(strings, values) {
          var ret = "";
          for (var i2 = 0, l = strings.length; i2 < l; i2++) {
            ret += strings[i2];
            if (i2 < l - 1) {
              ret += values[i2];
            }
          }
          return ret;
        }
        function isTemplateStringsArray(v) {
          return has(v, "raw") && has(v, "length");
        }
        function createInstance(options) {
          var arrayAutoIndentCache = createWeakMap();
          var arrayFirstInterpSetsIndentCache = createWeakMap();
          function outdent(stringsOrOptions) {
            var values = [];
            for (var _i = 1; _i < arguments.length; _i++) {
              values[_i - 1] = arguments[_i];
            }
            if (isTemplateStringsArray(stringsOrOptions)) {
              var strings = stringsOrOptions;
              var firstInterpolatedValueSetsIndentationLevel = (values[0] === outdent || values[0] === defaultOutdent) && reOnlyWhitespaceWithAtLeastOneNewline.test(strings[0]) && reStartsWithNewlineOrIsEmpty.test(strings[1]);
              var cache = firstInterpolatedValueSetsIndentationLevel ? arrayFirstInterpSetsIndentCache : arrayAutoIndentCache;
              var renderedArray = cache.get(strings);
              if (!renderedArray) {
                renderedArray = _outdentArray(strings, firstInterpolatedValueSetsIndentationLevel, options);
                cache.set(strings, renderedArray);
              }
              if (values.length === 0) {
                return renderedArray[0];
              }
              var rendered = concatStringsAndValues(renderedArray, firstInterpolatedValueSetsIndentationLevel ? values.slice(1) : values);
              return rendered;
            } else {
              return createInstance(extend(extend({}, options), stringsOrOptions || {}));
            }
          }
          var fullOutdent = extend(outdent, {
            string: function(str) {
              return _outdentArray([str], false, options)[0];
            }
          });
          return fullOutdent;
        }
        var defaultOutdent = createInstance({
          trimLeadingNewline: true,
          trimTrailingNewline: true
        });
        exports2.outdent = defaultOutdent;
        exports2.default = defaultOutdent;
        if (typeof module22 !== "undefined") {
          try {
            module22.exports = defaultOutdent;
            Object.defineProperty(defaultOutdent, "__esModule", {
              value: true
            });
            defaultOutdent.default = defaultOutdent;
            defaultOutdent.outdent = defaultOutdent;
          } catch (e2) {
          }
        }
      }
    });
    var require_core_options = __commonJS22({
      "src/main/core-options.js"(exports2, module22) {
        "use strict";
        var {
          outdent
        } = require_lib8();
        var CATEGORY_CONFIG = "Config";
        var CATEGORY_EDITOR = "Editor";
        var CATEGORY_FORMAT = "Format";
        var CATEGORY_OTHER = "Other";
        var CATEGORY_OUTPUT = "Output";
        var CATEGORY_GLOBAL = "Global";
        var CATEGORY_SPECIAL = "Special";
        var options = {
          cursorOffset: {
            since: "1.4.0",
            category: CATEGORY_SPECIAL,
            type: "int",
            default: -1,
            range: {
              start: -1,
              end: Number.POSITIVE_INFINITY,
              step: 1
            },
            description: outdent`
      Print (to stderr) where a cursor at the given position would move to after formatting.
      This option cannot be used with --range-start and --range-end.
    `,
            cliCategory: CATEGORY_EDITOR
          },
          endOfLine: {
            since: "1.15.0",
            category: CATEGORY_GLOBAL,
            type: "choice",
            default: [{
              since: "1.15.0",
              value: "auto"
            }, {
              since: "2.0.0",
              value: "lf"
            }],
            description: "Which end of line characters to apply.",
            choices: [{
              value: "lf",
              description: "Line Feed only (\\n), common on Linux and macOS as well as inside git repos"
            }, {
              value: "crlf",
              description: "Carriage Return + Line Feed characters (\\r\\n), common on Windows"
            }, {
              value: "cr",
              description: "Carriage Return character only (\\r), used very rarely"
            }, {
              value: "auto",
              description: outdent`
          Maintain existing
          (mixed values within one file are normalised by looking at what's used after the first line)
        `
            }]
          },
          filepath: {
            since: "1.4.0",
            category: CATEGORY_SPECIAL,
            type: "path",
            description: "Specify the input filepath. This will be used to do parser inference.",
            cliName: "stdin-filepath",
            cliCategory: CATEGORY_OTHER,
            cliDescription: "Path to the file to pretend that stdin comes from."
          },
          insertPragma: {
            since: "1.8.0",
            category: CATEGORY_SPECIAL,
            type: "boolean",
            default: false,
            description: "Insert @format pragma into file's first docblock comment.",
            cliCategory: CATEGORY_OTHER
          },
          parser: {
            since: "0.0.10",
            category: CATEGORY_GLOBAL,
            type: "choice",
            default: [{
              since: "0.0.10",
              value: "babylon"
            }, {
              since: "1.13.0",
              value: void 0
            }],
            description: "Which parser to use.",
            exception: (value) => typeof value === "string" || typeof value === "function",
            choices: [{
              value: "flow",
              description: "Flow"
            }, {
              value: "babel",
              since: "1.16.0",
              description: "JavaScript"
            }, {
              value: "babel-flow",
              since: "1.16.0",
              description: "Flow"
            }, {
              value: "babel-ts",
              since: "2.0.0",
              description: "TypeScript"
            }, {
              value: "typescript",
              since: "1.4.0",
              description: "TypeScript"
            }, {
              value: "acorn",
              since: "2.6.0",
              description: "JavaScript"
            }, {
              value: "espree",
              since: "2.2.0",
              description: "JavaScript"
            }, {
              value: "meriyah",
              since: "2.2.0",
              description: "JavaScript"
            }, {
              value: "css",
              since: "1.7.1",
              description: "CSS"
            }, {
              value: "less",
              since: "1.7.1",
              description: "Less"
            }, {
              value: "scss",
              since: "1.7.1",
              description: "SCSS"
            }, {
              value: "json",
              since: "1.5.0",
              description: "JSON"
            }, {
              value: "json5",
              since: "1.13.0",
              description: "JSON5"
            }, {
              value: "json-stringify",
              since: "1.13.0",
              description: "JSON.stringify"
            }, {
              value: "graphql",
              since: "1.5.0",
              description: "GraphQL"
            }, {
              value: "markdown",
              since: "1.8.0",
              description: "Markdown"
            }, {
              value: "mdx",
              since: "1.15.0",
              description: "MDX"
            }, {
              value: "vue",
              since: "1.10.0",
              description: "Vue"
            }, {
              value: "yaml",
              since: "1.14.0",
              description: "YAML"
            }, {
              value: "glimmer",
              since: "2.3.0",
              description: "Ember / Handlebars"
            }, {
              value: "html",
              since: "1.15.0",
              description: "HTML"
            }, {
              value: "angular",
              since: "1.15.0",
              description: "Angular"
            }, {
              value: "lwc",
              since: "1.17.0",
              description: "Lightning Web Components"
            }]
          },
          plugins: {
            since: "1.10.0",
            type: "path",
            array: true,
            default: [{
              value: []
            }],
            category: CATEGORY_GLOBAL,
            description: "Add a plugin. Multiple plugins can be passed as separate `--plugin`s.",
            exception: (value) => typeof value === "string" || typeof value === "object",
            cliName: "plugin",
            cliCategory: CATEGORY_CONFIG
          },
          pluginSearchDirs: {
            since: "1.13.0",
            type: "path",
            array: true,
            default: [{
              value: []
            }],
            category: CATEGORY_GLOBAL,
            description: outdent`
      Custom directory that contains prettier plugins in node_modules subdirectory.
      Overrides default behavior when plugins are searched relatively to the location of Prettier.
      Multiple values are accepted.
    `,
            exception: (value) => typeof value === "string" || typeof value === "object",
            cliName: "plugin-search-dir",
            cliCategory: CATEGORY_CONFIG
          },
          printWidth: {
            since: "0.0.0",
            category: CATEGORY_GLOBAL,
            type: "int",
            default: 80,
            description: "The line length where Prettier will try wrap.",
            range: {
              start: 0,
              end: Number.POSITIVE_INFINITY,
              step: 1
            }
          },
          rangeEnd: {
            since: "1.4.0",
            category: CATEGORY_SPECIAL,
            type: "int",
            default: Number.POSITIVE_INFINITY,
            range: {
              start: 0,
              end: Number.POSITIVE_INFINITY,
              step: 1
            },
            description: outdent`
      Format code ending at a given character offset (exclusive).
      The range will extend forwards to the end of the selected statement.
      This option cannot be used with --cursor-offset.
    `,
            cliCategory: CATEGORY_EDITOR
          },
          rangeStart: {
            since: "1.4.0",
            category: CATEGORY_SPECIAL,
            type: "int",
            default: 0,
            range: {
              start: 0,
              end: Number.POSITIVE_INFINITY,
              step: 1
            },
            description: outdent`
      Format code starting at a given character offset.
      The range will extend backwards to the start of the first line containing the selected statement.
      This option cannot be used with --cursor-offset.
    `,
            cliCategory: CATEGORY_EDITOR
          },
          requirePragma: {
            since: "1.7.0",
            category: CATEGORY_SPECIAL,
            type: "boolean",
            default: false,
            description: outdent`
      Require either '@prettier' or '@format' to be present in the file's first docblock comment
      in order for it to be formatted.
    `,
            cliCategory: CATEGORY_OTHER
          },
          tabWidth: {
            type: "int",
            category: CATEGORY_GLOBAL,
            default: 2,
            description: "Number of spaces per indentation level.",
            range: {
              start: 0,
              end: Number.POSITIVE_INFINITY,
              step: 1
            }
          },
          useTabs: {
            since: "1.0.0",
            category: CATEGORY_GLOBAL,
            type: "boolean",
            default: false,
            description: "Indent with tabs instead of spaces."
          },
          embeddedLanguageFormatting: {
            since: "2.1.0",
            category: CATEGORY_GLOBAL,
            type: "choice",
            default: [{
              since: "2.1.0",
              value: "auto"
            }],
            description: "Control how Prettier formats quoted code embedded in the file.",
            choices: [{
              value: "auto",
              description: "Format embedded code if Prettier can automatically identify it."
            }, {
              value: "off",
              description: "Never automatically format embedded code."
            }]
          }
        };
        module22.exports = {
          CATEGORY_CONFIG,
          CATEGORY_EDITOR,
          CATEGORY_FORMAT,
          CATEGORY_OTHER,
          CATEGORY_OUTPUT,
          CATEGORY_GLOBAL,
          CATEGORY_SPECIAL,
          options
        };
      }
    });
    var require_support = __commonJS22({
      "src/main/support.js"(exports2, module22) {
        "use strict";
        var semver2 = {
          compare: require_compare2(),
          lt: require_lt2(),
          gte: require_gte2()
        };
        var arrayify = require_arrayify();
        var currentVersion = require_package().version;
        var coreOptions = require_core_options().options;
        function getSupportInfo2({
          plugins: plugins2 = [],
          showUnreleased = false,
          showDeprecated = false,
          showInternal = false
        } = {}) {
          const version2 = currentVersion.split("-", 1)[0];
          const languages = plugins2.flatMap((plugin) => plugin.languages || []).filter(filterSince);
          const options = arrayify(Object.assign({}, ...plugins2.map(({
            options: options2
          }) => options2), coreOptions), "name").filter((option) => filterSince(option) && filterDeprecated(option)).sort((a, b) => a.name === b.name ? 0 : a.name < b.name ? -1 : 1).map(mapInternal).map((option) => {
            option = Object.assign({}, option);
            if (Array.isArray(option.default)) {
              option.default = option.default.length === 1 ? option.default[0].value : option.default.filter(filterSince).sort((info1, info2) => semver2.compare(info2.since, info1.since))[0].value;
            }
            if (Array.isArray(option.choices)) {
              option.choices = option.choices.filter((option2) => filterSince(option2) && filterDeprecated(option2));
              if (option.name === "parser") {
                collectParsersFromLanguages(option, languages, plugins2);
              }
            }
            const pluginDefaults = Object.fromEntries(plugins2.filter((plugin) => plugin.defaultOptions && plugin.defaultOptions[option.name] !== void 0).map((plugin) => [plugin.name, plugin.defaultOptions[option.name]]));
            return Object.assign(Object.assign({}, option), {}, {
              pluginDefaults
            });
          });
          return {
            languages,
            options
          };
          function filterSince(object) {
            return showUnreleased || !("since" in object) || object.since && semver2.gte(version2, object.since);
          }
          function filterDeprecated(object) {
            return showDeprecated || !("deprecated" in object) || object.deprecated && semver2.lt(version2, object.deprecated);
          }
          function mapInternal(object) {
            if (showInternal) {
              return object;
            }
            const {
              cliName,
              cliCategory,
              cliDescription
            } = object, newObject = _objectWithoutProperties(object, _excluded);
            return newObject;
          }
        }
        function collectParsersFromLanguages(option, languages, plugins2) {
          const existingValues = new Set(option.choices.map((choice) => choice.value));
          for (const language of languages) {
            if (language.parsers) {
              for (const value of language.parsers) {
                if (!existingValues.has(value)) {
                  existingValues.add(value);
                  const plugin = plugins2.find((plugin2) => plugin2.parsers && plugin2.parsers[value]);
                  let description = language.name;
                  if (plugin && plugin.name) {
                    description += ` (plugin: ${plugin.name})`;
                  }
                  option.choices.push({
                    value,
                    description
                  });
                }
              }
            }
          }
        }
        module22.exports = {
          getSupportInfo: getSupportInfo2
        };
      }
    });
    var require_is_non_empty_array = __commonJS22({
      "src/utils/is-non-empty-array.js"(exports2, module22) {
        "use strict";
        function isNonEmptyArray(object) {
          return Array.isArray(object) && object.length > 0;
        }
        module22.exports = isNonEmptyArray;
      }
    });
    function ansiRegex({
      onlyFirst = false
    } = {}) {
      const pattern = ["[\\u001B\\u009B][[\\]()#;?]*(?:(?:(?:(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]+)*|[a-zA-Z\\d]+(?:;[-a-zA-Z\\d\\/#&.:=?%@~_]*)*)?\\u0007)", "(?:(?:\\d{1,4}(?:;\\d{0,4})*)?[\\dA-PR-TZcf-ntqry=><~]))"].join("|");
      return new RegExp(pattern, onlyFirst ? void 0 : "g");
    }
    var init_ansi_regex = __esm2({
      "node_modules/strip-ansi/node_modules/ansi-regex/index.js"() {
      }
    });
    function stripAnsi(string) {
      if (typeof string !== "string") {
        throw new TypeError(`Expected a \`string\`, got \`${typeof string}\``);
      }
      return string.replace(ansiRegex(), "");
    }
    var init_strip_ansi = __esm2({
      "node_modules/strip-ansi/index.js"() {
        init_ansi_regex();
      }
    });
    function isFullwidthCodePoint(codePoint) {
      if (!Number.isInteger(codePoint)) {
        return false;
      }
      return codePoint >= 4352 && (codePoint <= 4447 || codePoint === 9001 || codePoint === 9002 || 11904 <= codePoint && codePoint <= 12871 && codePoint !== 12351 || 12880 <= codePoint && codePoint <= 19903 || 19968 <= codePoint && codePoint <= 42182 || 43360 <= codePoint && codePoint <= 43388 || 44032 <= codePoint && codePoint <= 55203 || 63744 <= codePoint && codePoint <= 64255 || 65040 <= codePoint && codePoint <= 65049 || 65072 <= codePoint && codePoint <= 65131 || 65281 <= codePoint && codePoint <= 65376 || 65504 <= codePoint && codePoint <= 65510 || 110592 <= codePoint && codePoint <= 110593 || 127488 <= codePoint && codePoint <= 127569 || 131072 <= codePoint && codePoint <= 262141);
    }
    var init_is_fullwidth_code_point = __esm2({
      "node_modules/is-fullwidth-code-point/index.js"() {
      }
    });
    var require_emoji_regex = __commonJS22({
      "node_modules/emoji-regex/index.js"(exports2, module22) {
        "use strict";
        module22.exports = function() {
          return /\uD83C\uDFF4\uDB40\uDC67\uDB40\uDC62(?:\uDB40\uDC77\uDB40\uDC6C\uDB40\uDC73|\uDB40\uDC73\uDB40\uDC63\uDB40\uDC74|\uDB40\uDC65\uDB40\uDC6E\uDB40\uDC67)\uDB40\uDC7F|(?:\uD83E\uDDD1\uD83C\uDFFF\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFF\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFE])|(?:\uD83E\uDDD1\uD83C\uDFFE\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFE\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFD\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFD\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFC\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFC\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|(?:\uD83E\uDDD1\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83E\uDDD1|\uD83D\uDC69\uD83C\uDFFB\u200D\uD83E\uDD1D\u200D(?:\uD83D[\uDC68\uDC69]))(?:\uD83C[\uDFFC-\uDFFF])|\uD83D\uDC68(?:\uD83C\uDFFB(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFC-\uDFFF])|[\u2695\u2696\u2708]\uFE0F|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))?|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFF]))|\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D)?\uD83D\uDC68|(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFE])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB-\uDFFD\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFC\uDFFE\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83E\uDD1D\u200D\uD83D\uDC68(?:\uD83C[\uDFFB\uDFFD-\uDFFF])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])\uFE0F|\u200D(?:(?:\uD83D[\uDC68\uDC69])\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D[\uDC66\uDC67])|\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC)?|(?:\uD83D\uDC69(?:\uD83C\uDFFB\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|(?:\uD83C[\uDFFC-\uDFFF])\u200D\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69]))|\uD83E\uDDD1(?:\uD83C[\uDFFB-\uDFFF])\u200D\uD83E\uDD1D\u200D\uD83E\uDDD1)(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67]))|\uD83D\uDC69(?:\u200D(?:\u2764\uFE0F\u200D(?:\uD83D\uDC8B\u200D(?:\uD83D[\uDC68\uDC69])|\uD83D[\uDC68\uDC69])|\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83E\uDDD1(?:\u200D(?:\uD83E\uDD1D\u200D\uD83E\uDDD1|\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFF\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFE\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFD\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFC\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD])|\uD83C\uDFFB\u200D(?:\uD83C[\uDF3E\uDF73\uDF7C\uDF84\uDF93\uDFA4\uDFA8\uDFEB\uDFED]|\uD83D[\uDCBB\uDCBC\uDD27\uDD2C\uDE80\uDE92]|\uD83E[\uDDAF-\uDDB3\uDDBC\uDDBD]))|\uD83D\uDC69\u200D\uD83D\uDC66\u200D\uD83D\uDC66|\uD83D\uDC69\u200D\uD83D\uDC69\u200D(?:\uD83D[\uDC66\uDC67])|\uD83D\uDC69\u200D\uD83D\uDC67\u200D(?:\uD83D[\uDC66\uDC67])|(?:\uD83D\uDC41\uFE0F\u200D\uD83D\uDDE8|\uD83E\uDDD1(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDC69(?:\uD83C\uDFFF\u200D[\u2695\u2696\u2708]|\uD83C\uDFFE\u200D[\u2695\u2696\u2708]|\uD83C\uDFFD\u200D[\u2695\u2696\u2708]|\uD83C\uDFFC\u200D[\u2695\u2696\u2708]|\uD83C\uDFFB\u200D[\u2695\u2696\u2708]|\u200D[\u2695\u2696\u2708])|\uD83D\uDE36\u200D\uD83C\uDF2B|\uD83C\uDFF3\uFE0F\u200D\u26A7|\uD83D\uDC3B\u200D\u2744|(?:(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF])\u200D[\u2640\u2642]|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])\u200D[\u2640\u2642]|\uD83C\uDFF4\u200D\u2620|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])\u200D[\u2640\u2642]|[\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u2328\u23CF\u23ED-\u23EF\u23F1\u23F2\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB\u25FC\u2600-\u2604\u260E\u2611\u2618\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u2692\u2694-\u2697\u2699\u269B\u269C\u26A0\u26A7\u26B0\u26B1\u26C8\u26CF\u26D1\u26D3\u26E9\u26F0\u26F1\u26F4\u26F7\u26F8\u2702\u2708\u2709\u270F\u2712\u2714\u2716\u271D\u2721\u2733\u2734\u2744\u2747\u2763\u27A1\u2934\u2935\u2B05-\u2B07\u3030\u303D\u3297\u3299]|\uD83C[\uDD70\uDD71\uDD7E\uDD7F\uDE02\uDE37\uDF21\uDF24-\uDF2C\uDF36\uDF7D\uDF96\uDF97\uDF99-\uDF9B\uDF9E\uDF9F\uDFCD\uDFCE\uDFD4-\uDFDF\uDFF5\uDFF7]|\uD83D[\uDC3F\uDCFD\uDD49\uDD4A\uDD6F\uDD70\uDD73\uDD76-\uDD79\uDD87\uDD8A-\uDD8D\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA\uDECB\uDECD-\uDECF\uDEE0-\uDEE5\uDEE9\uDEF0\uDEF3])\uFE0F|\uD83C\uDFF3\uFE0F\u200D\uD83C\uDF08|\uD83D\uDC69\u200D\uD83D\uDC67|\uD83D\uDC69\u200D\uD83D\uDC66|\uD83D\uDE35\u200D\uD83D\uDCAB|\uD83D\uDE2E\u200D\uD83D\uDCA8|\uD83D\uDC15\u200D\uD83E\uDDBA|\uD83E\uDDD1(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83D\uDC69(?:\uD83C\uDFFF|\uD83C\uDFFE|\uD83C\uDFFD|\uD83C\uDFFC|\uD83C\uDFFB)?|\uD83C\uDDFD\uD83C\uDDF0|\uD83C\uDDF6\uD83C\uDDE6|\uD83C\uDDF4\uD83C\uDDF2|\uD83D\uDC08\u200D\u2B1B|\u2764\uFE0F\u200D(?:\uD83D\uDD25|\uD83E\uDE79)|\uD83D\uDC41\uFE0F|\uD83C\uDFF3\uFE0F|\uD83C\uDDFF(?:\uD83C[\uDDE6\uDDF2\uDDFC])|\uD83C\uDDFE(?:\uD83C[\uDDEA\uDDF9])|\uD83C\uDDFC(?:\uD83C[\uDDEB\uDDF8])|\uD83C\uDDFB(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDEE\uDDF3\uDDFA])|\uD83C\uDDFA(?:\uD83C[\uDDE6\uDDEC\uDDF2\uDDF3\uDDF8\uDDFE\uDDFF])|\uD83C\uDDF9(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDED\uDDEF-\uDDF4\uDDF7\uDDF9\uDDFB\uDDFC\uDDFF])|\uD83C\uDDF8(?:\uD83C[\uDDE6-\uDDEA\uDDEC-\uDDF4\uDDF7-\uDDF9\uDDFB\uDDFD-\uDDFF])|\uD83C\uDDF7(?:\uD83C[\uDDEA\uDDF4\uDDF8\uDDFA\uDDFC])|\uD83C\uDDF5(?:\uD83C[\uDDE6\uDDEA-\uDDED\uDDF0-\uDDF3\uDDF7-\uDDF9\uDDFC\uDDFE])|\uD83C\uDDF3(?:\uD83C[\uDDE6\uDDE8\uDDEA-\uDDEC\uDDEE\uDDF1\uDDF4\uDDF5\uDDF7\uDDFA\uDDFF])|\uD83C\uDDF2(?:\uD83C[\uDDE6\uDDE8-\uDDED\uDDF0-\uDDFF])|\uD83C\uDDF1(?:\uD83C[\uDDE6-\uDDE8\uDDEE\uDDF0\uDDF7-\uDDFB\uDDFE])|\uD83C\uDDF0(?:\uD83C[\uDDEA\uDDEC-\uDDEE\uDDF2\uDDF3\uDDF5\uDDF7\uDDFC\uDDFE\uDDFF])|\uD83C\uDDEF(?:\uD83C[\uDDEA\uDDF2\uDDF4\uDDF5])|\uD83C\uDDEE(?:\uD83C[\uDDE8-\uDDEA\uDDF1-\uDDF4\uDDF6-\uDDF9])|\uD83C\uDDED(?:\uD83C[\uDDF0\uDDF2\uDDF3\uDDF7\uDDF9\uDDFA])|\uD83C\uDDEC(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEE\uDDF1-\uDDF3\uDDF5-\uDDFA\uDDFC\uDDFE])|\uD83C\uDDEB(?:\uD83C[\uDDEE-\uDDF0\uDDF2\uDDF4\uDDF7])|\uD83C\uDDEA(?:\uD83C[\uDDE6\uDDE8\uDDEA\uDDEC\uDDED\uDDF7-\uDDFA])|\uD83C\uDDE9(?:\uD83C[\uDDEA\uDDEC\uDDEF\uDDF0\uDDF2\uDDF4\uDDFF])|\uD83C\uDDE8(?:\uD83C[\uDDE6\uDDE8\uDDE9\uDDEB-\uDDEE\uDDF0-\uDDF5\uDDF7\uDDFA-\uDDFF])|\uD83C\uDDE7(?:\uD83C[\uDDE6\uDDE7\uDDE9-\uDDEF\uDDF1-\uDDF4\uDDF6-\uDDF9\uDDFB\uDDFC\uDDFE\uDDFF])|\uD83C\uDDE6(?:\uD83C[\uDDE8-\uDDEC\uDDEE\uDDF1\uDDF2\uDDF4\uDDF6-\uDDFA\uDDFC\uDDFD\uDDFF])|[#\*0-9]\uFE0F\u20E3|\u2764\uFE0F|(?:\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD])(?:\uD83C[\uDFFB-\uDFFF])|(?:\u26F9|\uD83C[\uDFCB\uDFCC]|\uD83D\uDD75)(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|\uD83C\uDFF4|(?:[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5])(?:\uD83C[\uDFFB-\uDFFF])|(?:[\u261D\u270C\u270D]|\uD83D[\uDD74\uDD90])(?:\uFE0F|\uD83C[\uDFFB-\uDFFF])|[\u270A\u270B]|\uD83C[\uDF85\uDFC2\uDFC7]|\uD83D[\uDC08\uDC15\uDC3B\uDC42\uDC43\uDC46-\uDC50\uDC66\uDC67\uDC6B-\uDC6D\uDC72\uDC74-\uDC76\uDC78\uDC7C\uDC83\uDC85\uDC8F\uDC91\uDCAA\uDD7A\uDD95\uDD96\uDE2E\uDE35\uDE36\uDE4C\uDE4F\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1C\uDD1E\uDD1F\uDD30-\uDD34\uDD36\uDD77\uDDB5\uDDB6\uDDBB\uDDD2\uDDD3\uDDD5]|\uD83C[\uDFC3\uDFC4\uDFCA]|\uD83D[\uDC6E\uDC70\uDC71\uDC73\uDC77\uDC81\uDC82\uDC86\uDC87\uDE45-\uDE47\uDE4B\uDE4D\uDE4E\uDEA3\uDEB4-\uDEB6]|\uD83E[\uDD26\uDD35\uDD37-\uDD39\uDD3D\uDD3E\uDDB8\uDDB9\uDDCD-\uDDCF\uDDD4\uDDD6-\uDDDD]|\uD83D\uDC6F|\uD83E[\uDD3C\uDDDE\uDDDF]|[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF84\uDF86-\uDF93\uDFA0-\uDFC1\uDFC5\uDFC6\uDFC8\uDFC9\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC07\uDC09-\uDC14\uDC16-\uDC3A\uDC3C-\uDC3E\uDC40\uDC44\uDC45\uDC51-\uDC65\uDC6A\uDC79-\uDC7B\uDC7D-\uDC80\uDC84\uDC88-\uDC8E\uDC90\uDC92-\uDCA9\uDCAB-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDDA4\uDDFB-\uDE2D\uDE2F-\uDE34\uDE37-\uDE44\uDE48-\uDE4A\uDE80-\uDEA2\uDEA4-\uDEB3\uDEB7-\uDEBF\uDEC1-\uDEC5\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0D\uDD0E\uDD10-\uDD17\uDD1D\uDD20-\uDD25\uDD27-\uDD2F\uDD3A\uDD3F-\uDD45\uDD47-\uDD76\uDD78\uDD7A-\uDDB4\uDDB7\uDDBA\uDDBC-\uDDCB\uDDD0\uDDE0-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6]|(?:[\u231A\u231B\u23E9-\u23EC\u23F0\u23F3\u25FD\u25FE\u2614\u2615\u2648-\u2653\u267F\u2693\u26A1\u26AA\u26AB\u26BD\u26BE\u26C4\u26C5\u26CE\u26D4\u26EA\u26F2\u26F3\u26F5\u26FA\u26FD\u2705\u270A\u270B\u2728\u274C\u274E\u2753-\u2755\u2757\u2795-\u2797\u27B0\u27BF\u2B1B\u2B1C\u2B50\u2B55]|\uD83C[\uDC04\uDCCF\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE1A\uDE2F\uDE32-\uDE36\uDE38-\uDE3A\uDE50\uDE51\uDF00-\uDF20\uDF2D-\uDF35\uDF37-\uDF7C\uDF7E-\uDF93\uDFA0-\uDFCA\uDFCF-\uDFD3\uDFE0-\uDFF0\uDFF4\uDFF8-\uDFFF]|\uD83D[\uDC00-\uDC3E\uDC40\uDC42-\uDCFC\uDCFF-\uDD3D\uDD4B-\uDD4E\uDD50-\uDD67\uDD7A\uDD95\uDD96\uDDA4\uDDFB-\uDE4F\uDE80-\uDEC5\uDECC\uDED0-\uDED2\uDED5-\uDED7\uDEEB\uDEEC\uDEF4-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])|(?:[#\*0-9\xA9\xAE\u203C\u2049\u2122\u2139\u2194-\u2199\u21A9\u21AA\u231A\u231B\u2328\u23CF\u23E9-\u23F3\u23F8-\u23FA\u24C2\u25AA\u25AB\u25B6\u25C0\u25FB-\u25FE\u2600-\u2604\u260E\u2611\u2614\u2615\u2618\u261D\u2620\u2622\u2623\u2626\u262A\u262E\u262F\u2638-\u263A\u2640\u2642\u2648-\u2653\u265F\u2660\u2663\u2665\u2666\u2668\u267B\u267E\u267F\u2692-\u2697\u2699\u269B\u269C\u26A0\u26A1\u26A7\u26AA\u26AB\u26B0\u26B1\u26BD\u26BE\u26C4\u26C5\u26C8\u26CE\u26CF\u26D1\u26D3\u26D4\u26E9\u26EA\u26F0-\u26F5\u26F7-\u26FA\u26FD\u2702\u2705\u2708-\u270D\u270F\u2712\u2714\u2716\u271D\u2721\u2728\u2733\u2734\u2744\u2747\u274C\u274E\u2753-\u2755\u2757\u2763\u2764\u2795-\u2797\u27A1\u27B0\u27BF\u2934\u2935\u2B05-\u2B07\u2B1B\u2B1C\u2B50\u2B55\u3030\u303D\u3297\u3299]|\uD83C[\uDC04\uDCCF\uDD70\uDD71\uDD7E\uDD7F\uDD8E\uDD91-\uDD9A\uDDE6-\uDDFF\uDE01\uDE02\uDE1A\uDE2F\uDE32-\uDE3A\uDE50\uDE51\uDF00-\uDF21\uDF24-\uDF93\uDF96\uDF97\uDF99-\uDF9B\uDF9E-\uDFF0\uDFF3-\uDFF5\uDFF7-\uDFFF]|\uD83D[\uDC00-\uDCFD\uDCFF-\uDD3D\uDD49-\uDD4E\uDD50-\uDD67\uDD6F\uDD70\uDD73-\uDD7A\uDD87\uDD8A-\uDD8D\uDD90\uDD95\uDD96\uDDA4\uDDA5\uDDA8\uDDB1\uDDB2\uDDBC\uDDC2-\uDDC4\uDDD1-\uDDD3\uDDDC-\uDDDE\uDDE1\uDDE3\uDDE8\uDDEF\uDDF3\uDDFA-\uDE4F\uDE80-\uDEC5\uDECB-\uDED2\uDED5-\uDED7\uDEE0-\uDEE5\uDEE9\uDEEB\uDEEC\uDEF0\uDEF3-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD0C-\uDD3A\uDD3C-\uDD45\uDD47-\uDD78\uDD7A-\uDDCB\uDDCD-\uDDFF\uDE70-\uDE74\uDE78-\uDE7A\uDE80-\uDE86\uDE90-\uDEA8\uDEB0-\uDEB6\uDEC0-\uDEC2\uDED0-\uDED6])\uFE0F|(?:[\u261D\u26F9\u270A-\u270D]|\uD83C[\uDF85\uDFC2-\uDFC4\uDFC7\uDFCA-\uDFCC]|\uD83D[\uDC42\uDC43\uDC46-\uDC50\uDC66-\uDC78\uDC7C\uDC81-\uDC83\uDC85-\uDC87\uDC8F\uDC91\uDCAA\uDD74\uDD75\uDD7A\uDD90\uDD95\uDD96\uDE45-\uDE47\uDE4B-\uDE4F\uDEA3\uDEB4-\uDEB6\uDEC0\uDECC]|\uD83E[\uDD0C\uDD0F\uDD18-\uDD1F\uDD26\uDD30-\uDD39\uDD3C-\uDD3E\uDD77\uDDB5\uDDB6\uDDB8\uDDB9\uDDBB\uDDCD-\uDDCF\uDDD1-\uDDDD])/g;
        };
      }
    });
    var string_width_exports = {};
    __export2(string_width_exports, {
      default: () => stringWidth
    });
    function stringWidth(string) {
      if (typeof string !== "string" || string.length === 0) {
        return 0;
      }
      string = stripAnsi(string);
      if (string.length === 0) {
        return 0;
      }
      string = string.replace((0, import_emoji_regex.default)(), "  ");
      let width = 0;
      for (let index = 0; index < string.length; index++) {
        const codePoint = string.codePointAt(index);
        if (codePoint <= 31 || codePoint >= 127 && codePoint <= 159) {
          continue;
        }
        if (codePoint >= 768 && codePoint <= 879) {
          continue;
        }
        if (codePoint > 65535) {
          index++;
        }
        width += isFullwidthCodePoint(codePoint) ? 2 : 1;
      }
      return width;
    }
    var import_emoji_regex;
    var init_string_width = __esm2({
      "node_modules/string-width/index.js"() {
        init_strip_ansi();
        init_is_fullwidth_code_point();
        import_emoji_regex = __toESM2(require_emoji_regex());
      }
    });
    var require_get_string_width = __commonJS22({
      "src/utils/get-string-width.js"(exports2, module22) {
        "use strict";
        var stringWidth2 = (init_string_width(), __toCommonJS2(string_width_exports)).default;
        var notAsciiRegex = /[^\x20-\x7F]/;
        function getStringWidth(text) {
          if (!text) {
            return 0;
          }
          if (!notAsciiRegex.test(text)) {
            return text.length;
          }
          return stringWidth2(text);
        }
        module22.exports = getStringWidth;
      }
    });
    var require_skip = __commonJS22({
      "src/utils/text/skip.js"(exports2, module22) {
        "use strict";
        function skip(chars) {
          return (text, index, opts) => {
            const backwards = opts && opts.backwards;
            if (index === false) {
              return false;
            }
            const {
              length
            } = text;
            let cursor = index;
            while (cursor >= 0 && cursor < length) {
              const c = text.charAt(cursor);
              if (chars instanceof RegExp) {
                if (!chars.test(c)) {
                  return cursor;
                }
              } else if (!chars.includes(c)) {
                return cursor;
              }
              backwards ? cursor-- : cursor++;
            }
            if (cursor === -1 || cursor === length) {
              return cursor;
            }
            return false;
          };
        }
        var skipWhitespace = skip(/\s/);
        var skipSpaces = skip(" 	");
        var skipToLineEnd = skip(",; 	");
        var skipEverythingButNewLine = skip(/[^\n\r]/);
        module22.exports = {
          skipWhitespace,
          skipSpaces,
          skipToLineEnd,
          skipEverythingButNewLine
        };
      }
    });
    var require_skip_inline_comment = __commonJS22({
      "src/utils/text/skip-inline-comment.js"(exports2, module22) {
        "use strict";
        function skipInlineComment(text, index) {
          if (index === false) {
            return false;
          }
          if (text.charAt(index) === "/" && text.charAt(index + 1) === "*") {
            for (let i2 = index + 2; i2 < text.length; ++i2) {
              if (text.charAt(i2) === "*" && text.charAt(i2 + 1) === "/") {
                return i2 + 2;
              }
            }
          }
          return index;
        }
        module22.exports = skipInlineComment;
      }
    });
    var require_skip_trailing_comment = __commonJS22({
      "src/utils/text/skip-trailing-comment.js"(exports2, module22) {
        "use strict";
        var {
          skipEverythingButNewLine
        } = require_skip();
        function skipTrailingComment(text, index) {
          if (index === false) {
            return false;
          }
          if (text.charAt(index) === "/" && text.charAt(index + 1) === "/") {
            return skipEverythingButNewLine(text, index);
          }
          return index;
        }
        module22.exports = skipTrailingComment;
      }
    });
    var require_skip_newline = __commonJS22({
      "src/utils/text/skip-newline.js"(exports2, module22) {
        "use strict";
        function skipNewline(text, index, opts) {
          const backwards = opts && opts.backwards;
          if (index === false) {
            return false;
          }
          const atIndex = text.charAt(index);
          if (backwards) {
            if (text.charAt(index - 1) === "\r" && atIndex === "\n") {
              return index - 2;
            }
            if (atIndex === "\n" || atIndex === "\r" || atIndex === "\u2028" || atIndex === "\u2029") {
              return index - 1;
            }
          } else {
            if (atIndex === "\r" && text.charAt(index + 1) === "\n") {
              return index + 2;
            }
            if (atIndex === "\n" || atIndex === "\r" || atIndex === "\u2028" || atIndex === "\u2029") {
              return index + 1;
            }
          }
          return index;
        }
        module22.exports = skipNewline;
      }
    });
    var require_get_next_non_space_non_comment_character_index_with_start_index = __commonJS22({
      "src/utils/text/get-next-non-space-non-comment-character-index-with-start-index.js"(exports2, module22) {
        "use strict";
        var skipInlineComment = require_skip_inline_comment();
        var skipNewline = require_skip_newline();
        var skipTrailingComment = require_skip_trailing_comment();
        var {
          skipSpaces
        } = require_skip();
        function getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, idx) {
          let oldIdx = null;
          let nextIdx = idx;
          while (nextIdx !== oldIdx) {
            oldIdx = nextIdx;
            nextIdx = skipSpaces(text, nextIdx);
            nextIdx = skipInlineComment(text, nextIdx);
            nextIdx = skipTrailingComment(text, nextIdx);
            nextIdx = skipNewline(text, nextIdx);
          }
          return nextIdx;
        }
        module22.exports = getNextNonSpaceNonCommentCharacterIndexWithStartIndex;
      }
    });
    var require_util = __commonJS22({
      "src/common/util.js"(exports2, module22) {
        "use strict";
        var {
          default: escapeStringRegexp2
        } = (init_escape_string_regexp(), __toCommonJS2(escape_string_regexp_exports));
        var getLast = require_get_last();
        var {
          getSupportInfo: getSupportInfo2
        } = require_support();
        var isNonEmptyArray = require_is_non_empty_array();
        var getStringWidth = require_get_string_width();
        var {
          skipWhitespace,
          skipSpaces,
          skipToLineEnd,
          skipEverythingButNewLine
        } = require_skip();
        var skipInlineComment = require_skip_inline_comment();
        var skipTrailingComment = require_skip_trailing_comment();
        var skipNewline = require_skip_newline();
        var getNextNonSpaceNonCommentCharacterIndexWithStartIndex = require_get_next_non_space_non_comment_character_index_with_start_index();
        var getPenultimate = (arr) => arr[arr.length - 2];
        function skip(chars) {
          return (text, index, opts) => {
            const backwards = opts && opts.backwards;
            if (index === false) {
              return false;
            }
            const {
              length
            } = text;
            let cursor = index;
            while (cursor >= 0 && cursor < length) {
              const c = text.charAt(cursor);
              if (chars instanceof RegExp) {
                if (!chars.test(c)) {
                  return cursor;
                }
              } else if (!chars.includes(c)) {
                return cursor;
              }
              backwards ? cursor-- : cursor++;
            }
            if (cursor === -1 || cursor === length) {
              return cursor;
            }
            return false;
          };
        }
        function hasNewline(text, index, opts = {}) {
          const idx = skipSpaces(text, opts.backwards ? index - 1 : index, opts);
          const idx2 = skipNewline(text, idx, opts);
          return idx !== idx2;
        }
        function hasNewlineInRange(text, start, end) {
          for (let i2 = start; i2 < end; ++i2) {
            if (text.charAt(i2) === "\n") {
              return true;
            }
          }
          return false;
        }
        function isPreviousLineEmpty(text, node, locStart) {
          let idx = locStart(node) - 1;
          idx = skipSpaces(text, idx, {
            backwards: true
          });
          idx = skipNewline(text, idx, {
            backwards: true
          });
          idx = skipSpaces(text, idx, {
            backwards: true
          });
          const idx2 = skipNewline(text, idx, {
            backwards: true
          });
          return idx !== idx2;
        }
        function isNextLineEmptyAfterIndex(text, index) {
          let oldIdx = null;
          let idx = index;
          while (idx !== oldIdx) {
            oldIdx = idx;
            idx = skipToLineEnd(text, idx);
            idx = skipInlineComment(text, idx);
            idx = skipSpaces(text, idx);
          }
          idx = skipTrailingComment(text, idx);
          idx = skipNewline(text, idx);
          return idx !== false && hasNewline(text, idx);
        }
        function isNextLineEmpty(text, node, locEnd) {
          return isNextLineEmptyAfterIndex(text, locEnd(node));
        }
        function getNextNonSpaceNonCommentCharacterIndex(text, node, locEnd) {
          return getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, locEnd(node));
        }
        function getNextNonSpaceNonCommentCharacter(text, node, locEnd) {
          return text.charAt(getNextNonSpaceNonCommentCharacterIndex(text, node, locEnd));
        }
        function hasSpaces(text, index, opts = {}) {
          const idx = skipSpaces(text, opts.backwards ? index - 1 : index, opts);
          return idx !== index;
        }
        function getAlignmentSize(value, tabWidth, startIndex = 0) {
          let size = 0;
          for (let i2 = startIndex; i2 < value.length; ++i2) {
            if (value[i2] === "	") {
              size = size + tabWidth - size % tabWidth;
            } else {
              size++;
            }
          }
          return size;
        }
        function getIndentSize(value, tabWidth) {
          const lastNewlineIndex = value.lastIndexOf("\n");
          if (lastNewlineIndex === -1) {
            return 0;
          }
          return getAlignmentSize(value.slice(lastNewlineIndex + 1).match(/^[\t ]*/)[0], tabWidth);
        }
        function getPreferredQuote(rawContent, preferredQuote) {
          const double = {
            quote: '"',
            regex: /"/g,
            escaped: "&quot;"
          };
          const single = {
            quote: "'",
            regex: /'/g,
            escaped: "&apos;"
          };
          const preferred = preferredQuote === "'" ? single : double;
          const alternate = preferred === single ? double : single;
          let result = preferred;
          if (rawContent.includes(preferred.quote) || rawContent.includes(alternate.quote)) {
            const numPreferredQuotes = (rawContent.match(preferred.regex) || []).length;
            const numAlternateQuotes = (rawContent.match(alternate.regex) || []).length;
            result = numPreferredQuotes > numAlternateQuotes ? alternate : preferred;
          }
          return result;
        }
        function printString(raw, options) {
          const rawContent = raw.slice(1, -1);
          const enclosingQuote = options.parser === "json" || options.parser === "json5" && options.quoteProps === "preserve" && !options.singleQuote ? '"' : options.__isInHtmlAttribute ? "'" : getPreferredQuote(rawContent, options.singleQuote ? "'" : '"').quote;
          return makeString(rawContent, enclosingQuote, !(options.parser === "css" || options.parser === "less" || options.parser === "scss" || options.__embeddedInHtml));
        }
        function makeString(rawContent, enclosingQuote, unescapeUnnecessaryEscapes) {
          const otherQuote = enclosingQuote === '"' ? "'" : '"';
          const regex = /\\(.)|(["'])/gs;
          const newContent = rawContent.replace(regex, (match, escaped, quote) => {
            if (escaped === otherQuote) {
              return escaped;
            }
            if (quote === enclosingQuote) {
              return "\\" + quote;
            }
            if (quote) {
              return quote;
            }
            return unescapeUnnecessaryEscapes && /^[^\n\r"'0-7\\bfnrt-vx\u2028\u2029]$/.test(escaped) ? escaped : "\\" + escaped;
          });
          return enclosingQuote + newContent + enclosingQuote;
        }
        function printNumber(rawNumber) {
          return rawNumber.toLowerCase().replace(/^([+-]?[\d.]+e)(?:\+|(-))?0*(\d)/, "$1$2$3").replace(/^([+-]?[\d.]+)e[+-]?0+$/, "$1").replace(/^([+-])?\./, "$10.").replace(/(\.\d+?)0+(?=e|$)/, "$1").replace(/\.(?=e|$)/, "");
        }
        function getMaxContinuousCount(str, target) {
          const results = str.match(new RegExp(`(${escapeStringRegexp2(target)})+`, "g"));
          if (results === null) {
            return 0;
          }
          return results.reduce((maxCount, result) => Math.max(maxCount, result.length / target.length), 0);
        }
        function getMinNotPresentContinuousCount(str, target) {
          const matches = str.match(new RegExp(`(${escapeStringRegexp2(target)})+`, "g"));
          if (matches === null) {
            return 0;
          }
          const countPresent = /* @__PURE__ */ new Map();
          let max = 0;
          for (const match of matches) {
            const count = match.length / target.length;
            countPresent.set(count, true);
            if (count > max) {
              max = count;
            }
          }
          for (let i2 = 1; i2 < max; i2++) {
            if (!countPresent.get(i2)) {
              return i2;
            }
          }
          return max + 1;
        }
        function addCommentHelper(node, comment) {
          const comments = node.comments || (node.comments = []);
          comments.push(comment);
          comment.printed = false;
          comment.nodeDescription = describeNodeForDebugging(node);
        }
        function addLeadingComment(node, comment) {
          comment.leading = true;
          comment.trailing = false;
          addCommentHelper(node, comment);
        }
        function addDanglingComment(node, comment, marker) {
          comment.leading = false;
          comment.trailing = false;
          if (marker) {
            comment.marker = marker;
          }
          addCommentHelper(node, comment);
        }
        function addTrailingComment(node, comment) {
          comment.leading = false;
          comment.trailing = true;
          addCommentHelper(node, comment);
        }
        function inferParserByLanguage(language, options) {
          const {
            languages
          } = getSupportInfo2({
            plugins: options.plugins
          });
          const matched = languages.find(({
            name
          }) => name.toLowerCase() === language) || languages.find(({
            aliases
          }) => Array.isArray(aliases) && aliases.includes(language)) || languages.find(({
            extensions
          }) => Array.isArray(extensions) && extensions.includes(`.${language}`));
          return matched && matched.parsers[0];
        }
        function isFrontMatterNode(node) {
          return node && node.type === "front-matter";
        }
        function createGroupIdMapper(description) {
          const groupIds = /* @__PURE__ */ new WeakMap();
          return function(node) {
            if (!groupIds.has(node)) {
              groupIds.set(node, Symbol(description));
            }
            return groupIds.get(node);
          };
        }
        function describeNodeForDebugging(node) {
          const nodeType = node.type || node.kind || "(unknown type)";
          let nodeName = String(node.name || node.id && (typeof node.id === "object" ? node.id.name : node.id) || node.key && (typeof node.key === "object" ? node.key.name : node.key) || node.value && (typeof node.value === "object" ? "" : String(node.value)) || node.operator || "");
          if (nodeName.length > 20) {
            nodeName = nodeName.slice(0, 19) + "\u2026";
          }
          return nodeType + (nodeName ? " " + nodeName : "");
        }
        module22.exports = {
          inferParserByLanguage,
          getStringWidth,
          getMaxContinuousCount,
          getMinNotPresentContinuousCount,
          getPenultimate,
          getLast,
          getNextNonSpaceNonCommentCharacterIndexWithStartIndex,
          getNextNonSpaceNonCommentCharacterIndex,
          getNextNonSpaceNonCommentCharacter,
          skip,
          skipWhitespace,
          skipSpaces,
          skipToLineEnd,
          skipEverythingButNewLine,
          skipInlineComment,
          skipTrailingComment,
          skipNewline,
          isNextLineEmptyAfterIndex,
          isNextLineEmpty,
          isPreviousLineEmpty,
          hasNewline,
          hasNewlineInRange,
          hasSpaces,
          getAlignmentSize,
          getIndentSize,
          getPreferredQuote,
          printString,
          printNumber,
          makeString,
          addLeadingComment,
          addDanglingComment,
          addTrailingComment,
          isFrontMatterNode,
          isNonEmptyArray,
          createGroupIdMapper
        };
      }
    });
    var require_end_of_line = __commonJS22({
      "src/common/end-of-line.js"(exports2, module22) {
        "use strict";
        function guessEndOfLine(text) {
          const index = text.indexOf("\r");
          if (index >= 0) {
            return text.charAt(index + 1) === "\n" ? "crlf" : "cr";
          }
          return "lf";
        }
        function convertEndOfLineToChars(value) {
          switch (value) {
            case "cr":
              return "\r";
            case "crlf":
              return "\r\n";
            default:
              return "\n";
          }
        }
        function countEndOfLineChars(text, eol) {
          let regex;
          switch (eol) {
            case "\n":
              regex = /\n/g;
              break;
            case "\r":
              regex = /\r/g;
              break;
            case "\r\n":
              regex = /\r\n/g;
              break;
            default:
              throw new Error(`Unexpected "eol" ${JSON.stringify(eol)}.`);
          }
          const endOfLines = text.match(regex);
          return endOfLines ? endOfLines.length : 0;
        }
        function normalizeEndOfLine(text) {
          return text.replace(/\r\n?/g, "\n");
        }
        module22.exports = {
          guessEndOfLine,
          convertEndOfLineToChars,
          countEndOfLineChars,
          normalizeEndOfLine
        };
      }
    });
    var require_errors = __commonJS22({
      "src/common/errors.js"(exports2, module22) {
        "use strict";
        var ConfigError = class extends Error {
        };
        var DebugError = class extends Error {
        };
        var UndefinedParserError = class extends Error {
        };
        var ArgExpansionBailout = class extends Error {
        };
        module22.exports = {
          ConfigError,
          DebugError,
          UndefinedParserError,
          ArgExpansionBailout
        };
      }
    });
    var tslib_es6_exports = {};
    __export2(tslib_es6_exports, {
      __assign: () => __assign,
      __asyncDelegator: () => __asyncDelegator,
      __asyncGenerator: () => __asyncGenerator,
      __asyncValues: () => __asyncValues,
      __await: () => __await,
      __awaiter: () => __awaiter,
      __classPrivateFieldGet: () => __classPrivateFieldGet,
      __classPrivateFieldSet: () => __classPrivateFieldSet,
      __createBinding: () => __createBinding,
      __decorate: () => __decorate,
      __exportStar: () => __exportStar,
      __extends: () => __extends,
      __generator: () => __generator,
      __importDefault: () => __importDefault,
      __importStar: () => __importStar,
      __makeTemplateObject: () => __makeTemplateObject,
      __metadata: () => __metadata,
      __param: () => __param,
      __read: () => __read,
      __rest: () => __rest,
      __spread: () => __spread,
      __spreadArrays: () => __spreadArrays,
      __values: () => __values
    });
    function __extends(d, b) {
      extendStatics(d, b);
      function __() {
        this.constructor = d;
      }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    function __rest(s2, e2) {
      var t2 = {};
      for (var p in s2)
        if (Object.prototype.hasOwnProperty.call(s2, p) && e2.indexOf(p) < 0)
          t2[p] = s2[p];
      if (s2 != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i2 = 0, p = Object.getOwnPropertySymbols(s2); i2 < p.length; i2++) {
          if (e2.indexOf(p[i2]) < 0 && Object.prototype.propertyIsEnumerable.call(s2, p[i2]))
            t2[p[i2]] = s2[p[i2]];
        }
      return t2;
    }
    function __decorate(decorators, target, key, desc) {
      var c = arguments.length, r2 = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
        r2 = Reflect.decorate(decorators, target, key, desc);
      else
        for (var i2 = decorators.length - 1; i2 >= 0; i2--)
          if (d = decorators[i2])
            r2 = (c < 3 ? d(r2) : c > 3 ? d(target, key, r2) : d(target, key)) || r2;
      return c > 3 && r2 && Object.defineProperty(target, key, r2), r2;
    }
    function __param(paramIndex, decorator) {
      return function(target, key) {
        decorator(target, key, paramIndex);
      };
    }
    function __metadata(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
        return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function(resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function(resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e2) {
            reject(e2);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e2) {
            reject(e2);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    }
    function __generator(thisArg, body) {
      var _ = {
        label: 0,
        sent: function() {
          if (t2[0] & 1)
            throw t2[1];
          return t2[1];
        },
        trys: [],
        ops: []
      }, f3, y, t2, g;
      return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
      }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
      }), g;
      function verb(n) {
        return function(v) {
          return step([n, v]);
        };
      }
      function step(op) {
        if (f3)
          throw new TypeError("Generator is already executing.");
        while (_)
          try {
            if (f3 = 1, y && (t2 = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t2 = y["return"]) && t2.call(y), 0) : y.next) && !(t2 = t2.call(y, op[1])).done)
              return t2;
            if (y = 0, t2)
              op = [op[0] & 2, t2.value];
            switch (op[0]) {
              case 0:
              case 1:
                t2 = op;
                break;
              case 4:
                _.label++;
                return {
                  value: op[1],
                  done: false
                };
              case 5:
                _.label++;
                y = op[1];
                op = [0];
                continue;
              case 7:
                op = _.ops.pop();
                _.trys.pop();
                continue;
              default:
                if (!(t2 = _.trys, t2 = t2.length > 0 && t2[t2.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                  _ = 0;
                  continue;
                }
                if (op[0] === 3 && (!t2 || op[1] > t2[0] && op[1] < t2[3])) {
                  _.label = op[1];
                  break;
                }
                if (op[0] === 6 && _.label < t2[1]) {
                  _.label = t2[1];
                  t2 = op;
                  break;
                }
                if (t2 && _.label < t2[2]) {
                  _.label = t2[2];
                  _.ops.push(op);
                  break;
                }
                if (t2[2])
                  _.ops.pop();
                _.trys.pop();
                continue;
            }
            op = body.call(thisArg, _);
          } catch (e2) {
            op = [6, e2];
            y = 0;
          } finally {
            f3 = t2 = 0;
          }
        if (op[0] & 5)
          throw op[1];
        return {
          value: op[0] ? op[1] : void 0,
          done: true
        };
      }
    }
    function __createBinding(o, m2, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m2[k];
    }
    function __exportStar(m2, exports2) {
      for (var p in m2)
        if (p !== "default" && !exports2.hasOwnProperty(p))
          exports2[p] = m2[p];
    }
    function __values(o) {
      var s2 = typeof Symbol === "function" && Symbol.iterator, m2 = s2 && o[s2], i2 = 0;
      if (m2)
        return m2.call(o);
      if (o && typeof o.length === "number")
        return {
          next: function() {
            if (o && i2 >= o.length)
              o = void 0;
            return {
              value: o && o[i2++],
              done: !o
            };
          }
        };
      throw new TypeError(s2 ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
      var m2 = typeof Symbol === "function" && o[Symbol.iterator];
      if (!m2)
        return o;
      var i2 = m2.call(o), r2, ar = [], e2;
      try {
        while ((n === void 0 || n-- > 0) && !(r2 = i2.next()).done)
          ar.push(r2.value);
      } catch (error) {
        e2 = {
          error
        };
      } finally {
        try {
          if (r2 && !r2.done && (m2 = i2["return"]))
            m2.call(i2);
        } finally {
          if (e2)
            throw e2.error;
        }
      }
      return ar;
    }
    function __spread() {
      for (var ar = [], i2 = 0; i2 < arguments.length; i2++)
        ar = ar.concat(__read(arguments[i2]));
      return ar;
    }
    function __spreadArrays() {
      for (var s2 = 0, i2 = 0, il = arguments.length; i2 < il; i2++)
        s2 += arguments[i2].length;
      for (var r2 = Array(s2), k = 0, i2 = 0; i2 < il; i2++)
        for (var a = arguments[i2], j = 0, jl = a.length; j < jl; j++, k++)
          r2[k] = a[j];
      return r2;
    }
    function __await(v) {
      return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
      if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
      var g = generator.apply(thisArg, _arguments || []), i2, q = [];
      return i2 = {}, verb("next"), verb("throw"), verb("return"), i2[Symbol.asyncIterator] = function() {
        return this;
      }, i2;
      function verb(n) {
        if (g[n])
          i2[n] = function(v) {
            return new Promise(function(a, b) {
              q.push([n, v, a, b]) > 1 || resume(n, v);
            });
          };
      }
      function resume(n, v) {
        try {
          step(g[n](v));
        } catch (e2) {
          settle(q[0][3], e2);
        }
      }
      function step(r2) {
        r2.value instanceof __await ? Promise.resolve(r2.value.v).then(fulfill, reject) : settle(q[0][2], r2);
      }
      function fulfill(value) {
        resume("next", value);
      }
      function reject(value) {
        resume("throw", value);
      }
      function settle(f3, v) {
        if (f3(v), q.shift(), q.length)
          resume(q[0][0], q[0][1]);
      }
    }
    function __asyncDelegator(o) {
      var i2, p;
      return i2 = {}, verb("next"), verb("throw", function(e2) {
        throw e2;
      }), verb("return"), i2[Symbol.iterator] = function() {
        return this;
      }, i2;
      function verb(n, f3) {
        i2[n] = o[n] ? function(v) {
          return (p = !p) ? {
            value: __await(o[n](v)),
            done: n === "return"
          } : f3 ? f3(v) : v;
        } : f3;
      }
    }
    function __asyncValues(o) {
      if (!Symbol.asyncIterator)
        throw new TypeError("Symbol.asyncIterator is not defined.");
      var m2 = o[Symbol.asyncIterator], i2;
      return m2 ? m2.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i2 = {}, verb("next"), verb("throw"), verb("return"), i2[Symbol.asyncIterator] = function() {
        return this;
      }, i2);
      function verb(n) {
        i2[n] = o[n] && function(v) {
          return new Promise(function(resolve, reject) {
            v = o[n](v), settle(resolve, reject, v.done, v.value);
          });
        };
      }
      function settle(resolve, reject, d, v) {
        Promise.resolve(v).then(function(v2) {
          resolve({
            value: v2,
            done: d
          });
        }, reject);
      }
    }
    function __makeTemplateObject(cooked, raw) {
      if (Object.defineProperty) {
        Object.defineProperty(cooked, "raw", {
          value: raw
        });
      } else {
        cooked.raw = raw;
      }
      return cooked;
    }
    function __importStar(mod) {
      if (mod && mod.__esModule)
        return mod;
      var result = {};
      if (mod != null) {
        for (var k in mod)
          if (Object.hasOwnProperty.call(mod, k))
            result[k] = mod[k];
      }
      result.default = mod;
      return result;
    }
    function __importDefault(mod) {
      return mod && mod.__esModule ? mod : {
        default: mod
      };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
      if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
      }
      return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
      if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
      }
      privateMap.set(receiver, value);
      return value;
    }
    var extendStatics;
    var __assign;
    var init_tslib_es6 = __esm2({
      "node_modules/tslib/tslib.es6.js"() {
        extendStatics = function(d, b) {
          extendStatics = Object.setPrototypeOf || {
            __proto__: []
          } instanceof Array && function(d2, b2) {
            d2.__proto__ = b2;
          } || function(d2, b2) {
            for (var p in b2)
              if (b2.hasOwnProperty(p))
                d2[p] = b2[p];
          };
          return extendStatics(d, b);
        };
        __assign = function() {
          __assign = Object.assign || function __assign2(t2) {
            for (var s2, i2 = 1, n = arguments.length; i2 < n; i2++) {
              s2 = arguments[i2];
              for (var p in s2)
                if (Object.prototype.hasOwnProperty.call(s2, p))
                  t2[p] = s2[p];
            }
            return t2;
          };
          return __assign.apply(this, arguments);
        };
      }
    });
    var require_api = __commonJS22({
      "node_modules/vnopts/lib/descriptors/api.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.apiDescriptor = {
          key: (key) => /^[$_a-zA-Z][$_a-zA-Z0-9]*$/.test(key) ? key : JSON.stringify(key),
          value(value) {
            if (value === null || typeof value !== "object") {
              return JSON.stringify(value);
            }
            if (Array.isArray(value)) {
              return `[${value.map((subValue) => exports2.apiDescriptor.value(subValue)).join(", ")}]`;
            }
            const keys = Object.keys(value);
            return keys.length === 0 ? "{}" : `{ ${keys.map((key) => `${exports2.apiDescriptor.key(key)}: ${exports2.apiDescriptor.value(value[key])}`).join(", ")} }`;
          },
          pair: ({
            key,
            value
          }) => exports2.apiDescriptor.value({
            [key]: value
          })
        };
      }
    });
    var require_descriptors2 = __commonJS22({
      "node_modules/vnopts/lib/descriptors/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_api(), exports2);
      }
    });
    var require_escape_string_regexp2 = __commonJS22({
      "node_modules/vnopts/node_modules/escape-string-regexp/index.js"(exports2, module22) {
        "use strict";
        var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
        module22.exports = function(str) {
          if (typeof str !== "string") {
            throw new TypeError("Expected a string");
          }
          return str.replace(matchOperatorsRe, "\\$&");
        };
      }
    });
    var require_color_name2 = __commonJS22({
      "node_modules/color-name/index.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          "aliceblue": [240, 248, 255],
          "antiquewhite": [250, 235, 215],
          "aqua": [0, 255, 255],
          "aquamarine": [127, 255, 212],
          "azure": [240, 255, 255],
          "beige": [245, 245, 220],
          "bisque": [255, 228, 196],
          "black": [0, 0, 0],
          "blanchedalmond": [255, 235, 205],
          "blue": [0, 0, 255],
          "blueviolet": [138, 43, 226],
          "brown": [165, 42, 42],
          "burlywood": [222, 184, 135],
          "cadetblue": [95, 158, 160],
          "chartreuse": [127, 255, 0],
          "chocolate": [210, 105, 30],
          "coral": [255, 127, 80],
          "cornflowerblue": [100, 149, 237],
          "cornsilk": [255, 248, 220],
          "crimson": [220, 20, 60],
          "cyan": [0, 255, 255],
          "darkblue": [0, 0, 139],
          "darkcyan": [0, 139, 139],
          "darkgoldenrod": [184, 134, 11],
          "darkgray": [169, 169, 169],
          "darkgreen": [0, 100, 0],
          "darkgrey": [169, 169, 169],
          "darkkhaki": [189, 183, 107],
          "darkmagenta": [139, 0, 139],
          "darkolivegreen": [85, 107, 47],
          "darkorange": [255, 140, 0],
          "darkorchid": [153, 50, 204],
          "darkred": [139, 0, 0],
          "darksalmon": [233, 150, 122],
          "darkseagreen": [143, 188, 143],
          "darkslateblue": [72, 61, 139],
          "darkslategray": [47, 79, 79],
          "darkslategrey": [47, 79, 79],
          "darkturquoise": [0, 206, 209],
          "darkviolet": [148, 0, 211],
          "deeppink": [255, 20, 147],
          "deepskyblue": [0, 191, 255],
          "dimgray": [105, 105, 105],
          "dimgrey": [105, 105, 105],
          "dodgerblue": [30, 144, 255],
          "firebrick": [178, 34, 34],
          "floralwhite": [255, 250, 240],
          "forestgreen": [34, 139, 34],
          "fuchsia": [255, 0, 255],
          "gainsboro": [220, 220, 220],
          "ghostwhite": [248, 248, 255],
          "gold": [255, 215, 0],
          "goldenrod": [218, 165, 32],
          "gray": [128, 128, 128],
          "green": [0, 128, 0],
          "greenyellow": [173, 255, 47],
          "grey": [128, 128, 128],
          "honeydew": [240, 255, 240],
          "hotpink": [255, 105, 180],
          "indianred": [205, 92, 92],
          "indigo": [75, 0, 130],
          "ivory": [255, 255, 240],
          "khaki": [240, 230, 140],
          "lavender": [230, 230, 250],
          "lavenderblush": [255, 240, 245],
          "lawngreen": [124, 252, 0],
          "lemonchiffon": [255, 250, 205],
          "lightblue": [173, 216, 230],
          "lightcoral": [240, 128, 128],
          "lightcyan": [224, 255, 255],
          "lightgoldenrodyellow": [250, 250, 210],
          "lightgray": [211, 211, 211],
          "lightgreen": [144, 238, 144],
          "lightgrey": [211, 211, 211],
          "lightpink": [255, 182, 193],
          "lightsalmon": [255, 160, 122],
          "lightseagreen": [32, 178, 170],
          "lightskyblue": [135, 206, 250],
          "lightslategray": [119, 136, 153],
          "lightslategrey": [119, 136, 153],
          "lightsteelblue": [176, 196, 222],
          "lightyellow": [255, 255, 224],
          "lime": [0, 255, 0],
          "limegreen": [50, 205, 50],
          "linen": [250, 240, 230],
          "magenta": [255, 0, 255],
          "maroon": [128, 0, 0],
          "mediumaquamarine": [102, 205, 170],
          "mediumblue": [0, 0, 205],
          "mediumorchid": [186, 85, 211],
          "mediumpurple": [147, 112, 219],
          "mediumseagreen": [60, 179, 113],
          "mediumslateblue": [123, 104, 238],
          "mediumspringgreen": [0, 250, 154],
          "mediumturquoise": [72, 209, 204],
          "mediumvioletred": [199, 21, 133],
          "midnightblue": [25, 25, 112],
          "mintcream": [245, 255, 250],
          "mistyrose": [255, 228, 225],
          "moccasin": [255, 228, 181],
          "navajowhite": [255, 222, 173],
          "navy": [0, 0, 128],
          "oldlace": [253, 245, 230],
          "olive": [128, 128, 0],
          "olivedrab": [107, 142, 35],
          "orange": [255, 165, 0],
          "orangered": [255, 69, 0],
          "orchid": [218, 112, 214],
          "palegoldenrod": [238, 232, 170],
          "palegreen": [152, 251, 152],
          "paleturquoise": [175, 238, 238],
          "palevioletred": [219, 112, 147],
          "papayawhip": [255, 239, 213],
          "peachpuff": [255, 218, 185],
          "peru": [205, 133, 63],
          "pink": [255, 192, 203],
          "plum": [221, 160, 221],
          "powderblue": [176, 224, 230],
          "purple": [128, 0, 128],
          "rebeccapurple": [102, 51, 153],
          "red": [255, 0, 0],
          "rosybrown": [188, 143, 143],
          "royalblue": [65, 105, 225],
          "saddlebrown": [139, 69, 19],
          "salmon": [250, 128, 114],
          "sandybrown": [244, 164, 96],
          "seagreen": [46, 139, 87],
          "seashell": [255, 245, 238],
          "sienna": [160, 82, 45],
          "silver": [192, 192, 192],
          "skyblue": [135, 206, 235],
          "slateblue": [106, 90, 205],
          "slategray": [112, 128, 144],
          "slategrey": [112, 128, 144],
          "snow": [255, 250, 250],
          "springgreen": [0, 255, 127],
          "steelblue": [70, 130, 180],
          "tan": [210, 180, 140],
          "teal": [0, 128, 128],
          "thistle": [216, 191, 216],
          "tomato": [255, 99, 71],
          "turquoise": [64, 224, 208],
          "violet": [238, 130, 238],
          "wheat": [245, 222, 179],
          "white": [255, 255, 255],
          "whitesmoke": [245, 245, 245],
          "yellow": [255, 255, 0],
          "yellowgreen": [154, 205, 50]
        };
      }
    });
    var require_conversions2 = __commonJS22({
      "node_modules/color-convert/conversions.js"(exports2, module22) {
        var cssKeywords = require_color_name2();
        var reverseKeywords = {};
        for (key in cssKeywords) {
          if (cssKeywords.hasOwnProperty(key)) {
            reverseKeywords[cssKeywords[key]] = key;
          }
        }
        var key;
        var convert2 = module22.exports = {
          rgb: {
            channels: 3,
            labels: "rgb"
          },
          hsl: {
            channels: 3,
            labels: "hsl"
          },
          hsv: {
            channels: 3,
            labels: "hsv"
          },
          hwb: {
            channels: 3,
            labels: "hwb"
          },
          cmyk: {
            channels: 4,
            labels: "cmyk"
          },
          xyz: {
            channels: 3,
            labels: "xyz"
          },
          lab: {
            channels: 3,
            labels: "lab"
          },
          lch: {
            channels: 3,
            labels: "lch"
          },
          hex: {
            channels: 1,
            labels: ["hex"]
          },
          keyword: {
            channels: 1,
            labels: ["keyword"]
          },
          ansi16: {
            channels: 1,
            labels: ["ansi16"]
          },
          ansi256: {
            channels: 1,
            labels: ["ansi256"]
          },
          hcg: {
            channels: 3,
            labels: ["h", "c", "g"]
          },
          apple: {
            channels: 3,
            labels: ["r16", "g16", "b16"]
          },
          gray: {
            channels: 1,
            labels: ["gray"]
          }
        };
        for (model in convert2) {
          if (convert2.hasOwnProperty(model)) {
            if (!("channels" in convert2[model])) {
              throw new Error("missing channels property: " + model);
            }
            if (!("labels" in convert2[model])) {
              throw new Error("missing channel labels property: " + model);
            }
            if (convert2[model].labels.length !== convert2[model].channels) {
              throw new Error("channel and label counts mismatch: " + model);
            }
            channels = convert2[model].channels;
            labels = convert2[model].labels;
            delete convert2[model].channels;
            delete convert2[model].labels;
            Object.defineProperty(convert2[model], "channels", {
              value: channels
            });
            Object.defineProperty(convert2[model], "labels", {
              value: labels
            });
          }
        }
        var channels;
        var labels;
        var model;
        convert2.rgb.hsl = function(rgb) {
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var min = Math.min(r2, g, b);
          var max = Math.max(r2, g, b);
          var delta = max - min;
          var h2;
          var s2;
          var l;
          if (max === min) {
            h2 = 0;
          } else if (r2 === max) {
            h2 = (g - b) / delta;
          } else if (g === max) {
            h2 = 2 + (b - r2) / delta;
          } else if (b === max) {
            h2 = 4 + (r2 - g) / delta;
          }
          h2 = Math.min(h2 * 60, 360);
          if (h2 < 0) {
            h2 += 360;
          }
          l = (min + max) / 2;
          if (max === min) {
            s2 = 0;
          } else if (l <= 0.5) {
            s2 = delta / (max + min);
          } else {
            s2 = delta / (2 - max - min);
          }
          return [h2, s2 * 100, l * 100];
        };
        convert2.rgb.hsv = function(rgb) {
          var rdif;
          var gdif;
          var bdif;
          var h2;
          var s2;
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var v = Math.max(r2, g, b);
          var diff2 = v - Math.min(r2, g, b);
          var diffc = function(c) {
            return (v - c) / 6 / diff2 + 1 / 2;
          };
          if (diff2 === 0) {
            h2 = s2 = 0;
          } else {
            s2 = diff2 / v;
            rdif = diffc(r2);
            gdif = diffc(g);
            bdif = diffc(b);
            if (r2 === v) {
              h2 = bdif - gdif;
            } else if (g === v) {
              h2 = 1 / 3 + rdif - bdif;
            } else if (b === v) {
              h2 = 2 / 3 + gdif - rdif;
            }
            if (h2 < 0) {
              h2 += 1;
            } else if (h2 > 1) {
              h2 -= 1;
            }
          }
          return [h2 * 360, s2 * 100, v * 100];
        };
        convert2.rgb.hwb = function(rgb) {
          var r2 = rgb[0];
          var g = rgb[1];
          var b = rgb[2];
          var h2 = convert2.rgb.hsl(rgb)[0];
          var w = 1 / 255 * Math.min(r2, Math.min(g, b));
          b = 1 - 1 / 255 * Math.max(r2, Math.max(g, b));
          return [h2, w * 100, b * 100];
        };
        convert2.rgb.cmyk = function(rgb) {
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var c;
          var m2;
          var y;
          var k;
          k = Math.min(1 - r2, 1 - g, 1 - b);
          c = (1 - r2 - k) / (1 - k) || 0;
          m2 = (1 - g - k) / (1 - k) || 0;
          y = (1 - b - k) / (1 - k) || 0;
          return [c * 100, m2 * 100, y * 100, k * 100];
        };
        function comparativeDistance(x2, y) {
          return Math.pow(x2[0] - y[0], 2) + Math.pow(x2[1] - y[1], 2) + Math.pow(x2[2] - y[2], 2);
        }
        convert2.rgb.keyword = function(rgb) {
          var reversed = reverseKeywords[rgb];
          if (reversed) {
            return reversed;
          }
          var currentClosestDistance = Infinity;
          var currentClosestKeyword;
          for (var keyword in cssKeywords) {
            if (cssKeywords.hasOwnProperty(keyword)) {
              var value = cssKeywords[keyword];
              var distance = comparativeDistance(rgb, value);
              if (distance < currentClosestDistance) {
                currentClosestDistance = distance;
                currentClosestKeyword = keyword;
              }
            }
          }
          return currentClosestKeyword;
        };
        convert2.keyword.rgb = function(keyword) {
          return cssKeywords[keyword];
        };
        convert2.rgb.xyz = function(rgb) {
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          r2 = r2 > 0.04045 ? Math.pow((r2 + 0.055) / 1.055, 2.4) : r2 / 12.92;
          g = g > 0.04045 ? Math.pow((g + 0.055) / 1.055, 2.4) : g / 12.92;
          b = b > 0.04045 ? Math.pow((b + 0.055) / 1.055, 2.4) : b / 12.92;
          var x2 = r2 * 0.4124 + g * 0.3576 + b * 0.1805;
          var y = r2 * 0.2126 + g * 0.7152 + b * 0.0722;
          var z = r2 * 0.0193 + g * 0.1192 + b * 0.9505;
          return [x2 * 100, y * 100, z * 100];
        };
        convert2.rgb.lab = function(rgb) {
          var xyz = convert2.rgb.xyz(rgb);
          var x2 = xyz[0];
          var y = xyz[1];
          var z = xyz[2];
          var l;
          var a;
          var b;
          x2 /= 95.047;
          y /= 100;
          z /= 108.883;
          x2 = x2 > 8856e-6 ? Math.pow(x2, 1 / 3) : 7.787 * x2 + 16 / 116;
          y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
          z = z > 8856e-6 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
          l = 116 * y - 16;
          a = 500 * (x2 - y);
          b = 200 * (y - z);
          return [l, a, b];
        };
        convert2.hsl.rgb = function(hsl) {
          var h2 = hsl[0] / 360;
          var s2 = hsl[1] / 100;
          var l = hsl[2] / 100;
          var t1;
          var t2;
          var t3;
          var rgb;
          var val;
          if (s2 === 0) {
            val = l * 255;
            return [val, val, val];
          }
          if (l < 0.5) {
            t2 = l * (1 + s2);
          } else {
            t2 = l + s2 - l * s2;
          }
          t1 = 2 * l - t2;
          rgb = [0, 0, 0];
          for (var i2 = 0; i2 < 3; i2++) {
            t3 = h2 + 1 / 3 * -(i2 - 1);
            if (t3 < 0) {
              t3++;
            }
            if (t3 > 1) {
              t3--;
            }
            if (6 * t3 < 1) {
              val = t1 + (t2 - t1) * 6 * t3;
            } else if (2 * t3 < 1) {
              val = t2;
            } else if (3 * t3 < 2) {
              val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
            } else {
              val = t1;
            }
            rgb[i2] = val * 255;
          }
          return rgb;
        };
        convert2.hsl.hsv = function(hsl) {
          var h2 = hsl[0];
          var s2 = hsl[1] / 100;
          var l = hsl[2] / 100;
          var smin = s2;
          var lmin = Math.max(l, 0.01);
          var sv;
          var v;
          l *= 2;
          s2 *= l <= 1 ? l : 2 - l;
          smin *= lmin <= 1 ? lmin : 2 - lmin;
          v = (l + s2) / 2;
          sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s2 / (l + s2);
          return [h2, sv * 100, v * 100];
        };
        convert2.hsv.rgb = function(hsv) {
          var h2 = hsv[0] / 60;
          var s2 = hsv[1] / 100;
          var v = hsv[2] / 100;
          var hi = Math.floor(h2) % 6;
          var f3 = h2 - Math.floor(h2);
          var p = 255 * v * (1 - s2);
          var q = 255 * v * (1 - s2 * f3);
          var t2 = 255 * v * (1 - s2 * (1 - f3));
          v *= 255;
          switch (hi) {
            case 0:
              return [v, t2, p];
            case 1:
              return [q, v, p];
            case 2:
              return [p, v, t2];
            case 3:
              return [p, q, v];
            case 4:
              return [t2, p, v];
            case 5:
              return [v, p, q];
          }
        };
        convert2.hsv.hsl = function(hsv) {
          var h2 = hsv[0];
          var s2 = hsv[1] / 100;
          var v = hsv[2] / 100;
          var vmin = Math.max(v, 0.01);
          var lmin;
          var sl;
          var l;
          l = (2 - s2) * v;
          lmin = (2 - s2) * vmin;
          sl = s2 * vmin;
          sl /= lmin <= 1 ? lmin : 2 - lmin;
          sl = sl || 0;
          l /= 2;
          return [h2, sl * 100, l * 100];
        };
        convert2.hwb.rgb = function(hwb) {
          var h2 = hwb[0] / 360;
          var wh = hwb[1] / 100;
          var bl = hwb[2] / 100;
          var ratio = wh + bl;
          var i2;
          var v;
          var f3;
          var n;
          if (ratio > 1) {
            wh /= ratio;
            bl /= ratio;
          }
          i2 = Math.floor(6 * h2);
          v = 1 - bl;
          f3 = 6 * h2 - i2;
          if ((i2 & 1) !== 0) {
            f3 = 1 - f3;
          }
          n = wh + f3 * (v - wh);
          var r2;
          var g;
          var b;
          switch (i2) {
            default:
            case 6:
            case 0:
              r2 = v;
              g = n;
              b = wh;
              break;
            case 1:
              r2 = n;
              g = v;
              b = wh;
              break;
            case 2:
              r2 = wh;
              g = v;
              b = n;
              break;
            case 3:
              r2 = wh;
              g = n;
              b = v;
              break;
            case 4:
              r2 = n;
              g = wh;
              b = v;
              break;
            case 5:
              r2 = v;
              g = wh;
              b = n;
              break;
          }
          return [r2 * 255, g * 255, b * 255];
        };
        convert2.cmyk.rgb = function(cmyk) {
          var c = cmyk[0] / 100;
          var m2 = cmyk[1] / 100;
          var y = cmyk[2] / 100;
          var k = cmyk[3] / 100;
          var r2;
          var g;
          var b;
          r2 = 1 - Math.min(1, c * (1 - k) + k);
          g = 1 - Math.min(1, m2 * (1 - k) + k);
          b = 1 - Math.min(1, y * (1 - k) + k);
          return [r2 * 255, g * 255, b * 255];
        };
        convert2.xyz.rgb = function(xyz) {
          var x2 = xyz[0] / 100;
          var y = xyz[1] / 100;
          var z = xyz[2] / 100;
          var r2;
          var g;
          var b;
          r2 = x2 * 3.2406 + y * -1.5372 + z * -0.4986;
          g = x2 * -0.9689 + y * 1.8758 + z * 0.0415;
          b = x2 * 0.0557 + y * -0.204 + z * 1.057;
          r2 = r2 > 31308e-7 ? 1.055 * Math.pow(r2, 1 / 2.4) - 0.055 : r2 * 12.92;
          g = g > 31308e-7 ? 1.055 * Math.pow(g, 1 / 2.4) - 0.055 : g * 12.92;
          b = b > 31308e-7 ? 1.055 * Math.pow(b, 1 / 2.4) - 0.055 : b * 12.92;
          r2 = Math.min(Math.max(0, r2), 1);
          g = Math.min(Math.max(0, g), 1);
          b = Math.min(Math.max(0, b), 1);
          return [r2 * 255, g * 255, b * 255];
        };
        convert2.xyz.lab = function(xyz) {
          var x2 = xyz[0];
          var y = xyz[1];
          var z = xyz[2];
          var l;
          var a;
          var b;
          x2 /= 95.047;
          y /= 100;
          z /= 108.883;
          x2 = x2 > 8856e-6 ? Math.pow(x2, 1 / 3) : 7.787 * x2 + 16 / 116;
          y = y > 8856e-6 ? Math.pow(y, 1 / 3) : 7.787 * y + 16 / 116;
          z = z > 8856e-6 ? Math.pow(z, 1 / 3) : 7.787 * z + 16 / 116;
          l = 116 * y - 16;
          a = 500 * (x2 - y);
          b = 200 * (y - z);
          return [l, a, b];
        };
        convert2.lab.xyz = function(lab) {
          var l = lab[0];
          var a = lab[1];
          var b = lab[2];
          var x2;
          var y;
          var z;
          y = (l + 16) / 116;
          x2 = a / 500 + y;
          z = y - b / 200;
          var y2 = Math.pow(y, 3);
          var x22 = Math.pow(x2, 3);
          var z2 = Math.pow(z, 3);
          y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
          x2 = x22 > 8856e-6 ? x22 : (x2 - 16 / 116) / 7.787;
          z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
          x2 *= 95.047;
          y *= 100;
          z *= 108.883;
          return [x2, y, z];
        };
        convert2.lab.lch = function(lab) {
          var l = lab[0];
          var a = lab[1];
          var b = lab[2];
          var hr;
          var h2;
          var c;
          hr = Math.atan2(b, a);
          h2 = hr * 360 / 2 / Math.PI;
          if (h2 < 0) {
            h2 += 360;
          }
          c = Math.sqrt(a * a + b * b);
          return [l, c, h2];
        };
        convert2.lch.lab = function(lch) {
          var l = lch[0];
          var c = lch[1];
          var h2 = lch[2];
          var a;
          var b;
          var hr;
          hr = h2 / 360 * 2 * Math.PI;
          a = c * Math.cos(hr);
          b = c * Math.sin(hr);
          return [l, a, b];
        };
        convert2.rgb.ansi16 = function(args) {
          var r2 = args[0];
          var g = args[1];
          var b = args[2];
          var value = 1 in arguments ? arguments[1] : convert2.rgb.hsv(args)[2];
          value = Math.round(value / 50);
          if (value === 0) {
            return 30;
          }
          var ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r2 / 255));
          if (value === 2) {
            ansi += 60;
          }
          return ansi;
        };
        convert2.hsv.ansi16 = function(args) {
          return convert2.rgb.ansi16(convert2.hsv.rgb(args), args[2]);
        };
        convert2.rgb.ansi256 = function(args) {
          var r2 = args[0];
          var g = args[1];
          var b = args[2];
          if (r2 === g && g === b) {
            if (r2 < 8) {
              return 16;
            }
            if (r2 > 248) {
              return 231;
            }
            return Math.round((r2 - 8) / 247 * 24) + 232;
          }
          var ansi = 16 + 36 * Math.round(r2 / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
          return ansi;
        };
        convert2.ansi16.rgb = function(args) {
          var color = args % 10;
          if (color === 0 || color === 7) {
            if (args > 50) {
              color += 3.5;
            }
            color = color / 10.5 * 255;
            return [color, color, color];
          }
          var mult = (~~(args > 50) + 1) * 0.5;
          var r2 = (color & 1) * mult * 255;
          var g = (color >> 1 & 1) * mult * 255;
          var b = (color >> 2 & 1) * mult * 255;
          return [r2, g, b];
        };
        convert2.ansi256.rgb = function(args) {
          if (args >= 232) {
            var c = (args - 232) * 10 + 8;
            return [c, c, c];
          }
          args -= 16;
          var rem;
          var r2 = Math.floor(args / 36) / 5 * 255;
          var g = Math.floor((rem = args % 36) / 6) / 5 * 255;
          var b = rem % 6 / 5 * 255;
          return [r2, g, b];
        };
        convert2.rgb.hex = function(args) {
          var integer = ((Math.round(args[0]) & 255) << 16) + ((Math.round(args[1]) & 255) << 8) + (Math.round(args[2]) & 255);
          var string = integer.toString(16).toUpperCase();
          return "000000".substring(string.length) + string;
        };
        convert2.hex.rgb = function(args) {
          var match = args.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
          if (!match) {
            return [0, 0, 0];
          }
          var colorString = match[0];
          if (match[0].length === 3) {
            colorString = colorString.split("").map(function(char) {
              return char + char;
            }).join("");
          }
          var integer = parseInt(colorString, 16);
          var r2 = integer >> 16 & 255;
          var g = integer >> 8 & 255;
          var b = integer & 255;
          return [r2, g, b];
        };
        convert2.rgb.hcg = function(rgb) {
          var r2 = rgb[0] / 255;
          var g = rgb[1] / 255;
          var b = rgb[2] / 255;
          var max = Math.max(Math.max(r2, g), b);
          var min = Math.min(Math.min(r2, g), b);
          var chroma = max - min;
          var grayscale;
          var hue;
          if (chroma < 1) {
            grayscale = min / (1 - chroma);
          } else {
            grayscale = 0;
          }
          if (chroma <= 0) {
            hue = 0;
          } else if (max === r2) {
            hue = (g - b) / chroma % 6;
          } else if (max === g) {
            hue = 2 + (b - r2) / chroma;
          } else {
            hue = 4 + (r2 - g) / chroma + 4;
          }
          hue /= 6;
          hue %= 1;
          return [hue * 360, chroma * 100, grayscale * 100];
        };
        convert2.hsl.hcg = function(hsl) {
          var s2 = hsl[1] / 100;
          var l = hsl[2] / 100;
          var c = 1;
          var f3 = 0;
          if (l < 0.5) {
            c = 2 * s2 * l;
          } else {
            c = 2 * s2 * (1 - l);
          }
          if (c < 1) {
            f3 = (l - 0.5 * c) / (1 - c);
          }
          return [hsl[0], c * 100, f3 * 100];
        };
        convert2.hsv.hcg = function(hsv) {
          var s2 = hsv[1] / 100;
          var v = hsv[2] / 100;
          var c = s2 * v;
          var f3 = 0;
          if (c < 1) {
            f3 = (v - c) / (1 - c);
          }
          return [hsv[0], c * 100, f3 * 100];
        };
        convert2.hcg.rgb = function(hcg) {
          var h2 = hcg[0] / 360;
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          if (c === 0) {
            return [g * 255, g * 255, g * 255];
          }
          var pure = [0, 0, 0];
          var hi = h2 % 1 * 6;
          var v = hi % 1;
          var w = 1 - v;
          var mg = 0;
          switch (Math.floor(hi)) {
            case 0:
              pure[0] = 1;
              pure[1] = v;
              pure[2] = 0;
              break;
            case 1:
              pure[0] = w;
              pure[1] = 1;
              pure[2] = 0;
              break;
            case 2:
              pure[0] = 0;
              pure[1] = 1;
              pure[2] = v;
              break;
            case 3:
              pure[0] = 0;
              pure[1] = w;
              pure[2] = 1;
              break;
            case 4:
              pure[0] = v;
              pure[1] = 0;
              pure[2] = 1;
              break;
            default:
              pure[0] = 1;
              pure[1] = 0;
              pure[2] = w;
          }
          mg = (1 - c) * g;
          return [(c * pure[0] + mg) * 255, (c * pure[1] + mg) * 255, (c * pure[2] + mg) * 255];
        };
        convert2.hcg.hsv = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var v = c + g * (1 - c);
          var f3 = 0;
          if (v > 0) {
            f3 = c / v;
          }
          return [hcg[0], f3 * 100, v * 100];
        };
        convert2.hcg.hsl = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var l = g * (1 - c) + 0.5 * c;
          var s2 = 0;
          if (l > 0 && l < 0.5) {
            s2 = c / (2 * l);
          } else if (l >= 0.5 && l < 1) {
            s2 = c / (2 * (1 - l));
          }
          return [hcg[0], s2 * 100, l * 100];
        };
        convert2.hcg.hwb = function(hcg) {
          var c = hcg[1] / 100;
          var g = hcg[2] / 100;
          var v = c + g * (1 - c);
          return [hcg[0], (v - c) * 100, (1 - v) * 100];
        };
        convert2.hwb.hcg = function(hwb) {
          var w = hwb[1] / 100;
          var b = hwb[2] / 100;
          var v = 1 - b;
          var c = v - w;
          var g = 0;
          if (c < 1) {
            g = (v - c) / (1 - c);
          }
          return [hwb[0], c * 100, g * 100];
        };
        convert2.apple.rgb = function(apple) {
          return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
        };
        convert2.rgb.apple = function(rgb) {
          return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
        };
        convert2.gray.rgb = function(args) {
          return [args[0] / 100 * 255, args[0] / 100 * 255, args[0] / 100 * 255];
        };
        convert2.gray.hsl = convert2.gray.hsv = function(args) {
          return [0, 0, args[0]];
        };
        convert2.gray.hwb = function(gray) {
          return [0, 100, gray[0]];
        };
        convert2.gray.cmyk = function(gray) {
          return [0, 0, 0, gray[0]];
        };
        convert2.gray.lab = function(gray) {
          return [gray[0], 0, 0];
        };
        convert2.gray.hex = function(gray) {
          var val = Math.round(gray[0] / 100 * 255) & 255;
          var integer = (val << 16) + (val << 8) + val;
          var string = integer.toString(16).toUpperCase();
          return "000000".substring(string.length) + string;
        };
        convert2.rgb.gray = function(rgb) {
          var val = (rgb[0] + rgb[1] + rgb[2]) / 3;
          return [val / 255 * 100];
        };
      }
    });
    var require_route2 = __commonJS22({
      "node_modules/color-convert/route.js"(exports2, module22) {
        var conversions = require_conversions2();
        function buildGraph() {
          var graph = {};
          var models = Object.keys(conversions);
          for (var len = models.length, i2 = 0; i2 < len; i2++) {
            graph[models[i2]] = {
              distance: -1,
              parent: null
            };
          }
          return graph;
        }
        function deriveBFS(fromModel) {
          var graph = buildGraph();
          var queue = [fromModel];
          graph[fromModel].distance = 0;
          while (queue.length) {
            var current = queue.pop();
            var adjacents = Object.keys(conversions[current]);
            for (var len = adjacents.length, i2 = 0; i2 < len; i2++) {
              var adjacent = adjacents[i2];
              var node = graph[adjacent];
              if (node.distance === -1) {
                node.distance = graph[current].distance + 1;
                node.parent = current;
                queue.unshift(adjacent);
              }
            }
          }
          return graph;
        }
        function link(from, to) {
          return function(args) {
            return to(from(args));
          };
        }
        function wrapConversion(toModel, graph) {
          var path4 = [graph[toModel].parent, toModel];
          var fn = conversions[graph[toModel].parent][toModel];
          var cur = graph[toModel].parent;
          while (graph[cur].parent) {
            path4.unshift(graph[cur].parent);
            fn = link(conversions[graph[cur].parent][cur], fn);
            cur = graph[cur].parent;
          }
          fn.conversion = path4;
          return fn;
        }
        module22.exports = function(fromModel) {
          var graph = deriveBFS(fromModel);
          var conversion = {};
          var models = Object.keys(graph);
          for (var len = models.length, i2 = 0; i2 < len; i2++) {
            var toModel = models[i2];
            var node = graph[toModel];
            if (node.parent === null) {
              continue;
            }
            conversion[toModel] = wrapConversion(toModel, graph);
          }
          return conversion;
        };
      }
    });
    var require_color_convert2 = __commonJS22({
      "node_modules/color-convert/index.js"(exports2, module22) {
        var conversions = require_conversions2();
        var route = require_route2();
        var convert2 = {};
        var models = Object.keys(conversions);
        function wrapRaw(fn) {
          var wrappedFn = function(args) {
            if (args === void 0 || args === null) {
              return args;
            }
            if (arguments.length > 1) {
              args = Array.prototype.slice.call(arguments);
            }
            return fn(args);
          };
          if ("conversion" in fn) {
            wrappedFn.conversion = fn.conversion;
          }
          return wrappedFn;
        }
        function wrapRounded(fn) {
          var wrappedFn = function(args) {
            if (args === void 0 || args === null) {
              return args;
            }
            if (arguments.length > 1) {
              args = Array.prototype.slice.call(arguments);
            }
            var result = fn(args);
            if (typeof result === "object") {
              for (var len = result.length, i2 = 0; i2 < len; i2++) {
                result[i2] = Math.round(result[i2]);
              }
            }
            return result;
          };
          if ("conversion" in fn) {
            wrappedFn.conversion = fn.conversion;
          }
          return wrappedFn;
        }
        models.forEach(function(fromModel) {
          convert2[fromModel] = {};
          Object.defineProperty(convert2[fromModel], "channels", {
            value: conversions[fromModel].channels
          });
          Object.defineProperty(convert2[fromModel], "labels", {
            value: conversions[fromModel].labels
          });
          var routes = route(fromModel);
          var routeModels = Object.keys(routes);
          routeModels.forEach(function(toModel) {
            var fn = routes[toModel];
            convert2[fromModel][toModel] = wrapRounded(fn);
            convert2[fromModel][toModel].raw = wrapRaw(fn);
          });
        });
        module22.exports = convert2;
      }
    });
    var require_ansi_styles2 = __commonJS22({
      "node_modules/ansi-styles/index.js"(exports2, module22) {
        "use strict";
        var colorConvert = require_color_convert2();
        var wrapAnsi16 = (fn, offset) => function() {
          const code = fn.apply(colorConvert, arguments);
          return `\x1B[${code + offset}m`;
        };
        var wrapAnsi256 = (fn, offset) => function() {
          const code = fn.apply(colorConvert, arguments);
          return `\x1B[${38 + offset};5;${code}m`;
        };
        var wrapAnsi16m = (fn, offset) => function() {
          const rgb = fn.apply(colorConvert, arguments);
          return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
        };
        function assembleStyles() {
          const codes = /* @__PURE__ */ new Map();
          const styles = {
            modifier: {
              reset: [0, 0],
              bold: [1, 22],
              dim: [2, 22],
              italic: [3, 23],
              underline: [4, 24],
              inverse: [7, 27],
              hidden: [8, 28],
              strikethrough: [9, 29]
            },
            color: {
              black: [30, 39],
              red: [31, 39],
              green: [32, 39],
              yellow: [33, 39],
              blue: [34, 39],
              magenta: [35, 39],
              cyan: [36, 39],
              white: [37, 39],
              gray: [90, 39],
              redBright: [91, 39],
              greenBright: [92, 39],
              yellowBright: [93, 39],
              blueBright: [94, 39],
              magentaBright: [95, 39],
              cyanBright: [96, 39],
              whiteBright: [97, 39]
            },
            bgColor: {
              bgBlack: [40, 49],
              bgRed: [41, 49],
              bgGreen: [42, 49],
              bgYellow: [43, 49],
              bgBlue: [44, 49],
              bgMagenta: [45, 49],
              bgCyan: [46, 49],
              bgWhite: [47, 49],
              bgBlackBright: [100, 49],
              bgRedBright: [101, 49],
              bgGreenBright: [102, 49],
              bgYellowBright: [103, 49],
              bgBlueBright: [104, 49],
              bgMagentaBright: [105, 49],
              bgCyanBright: [106, 49],
              bgWhiteBright: [107, 49]
            }
          };
          styles.color.grey = styles.color.gray;
          for (const groupName of Object.keys(styles)) {
            const group = styles[groupName];
            for (const styleName of Object.keys(group)) {
              const style = group[styleName];
              styles[styleName] = {
                open: `\x1B[${style[0]}m`,
                close: `\x1B[${style[1]}m`
              };
              group[styleName] = styles[styleName];
              codes.set(style[0], style[1]);
            }
            Object.defineProperty(styles, groupName, {
              value: group,
              enumerable: false
            });
            Object.defineProperty(styles, "codes", {
              value: codes,
              enumerable: false
            });
          }
          const ansi2ansi = (n) => n;
          const rgb2rgb = (r2, g, b) => [r2, g, b];
          styles.color.close = "\x1B[39m";
          styles.bgColor.close = "\x1B[49m";
          styles.color.ansi = {
            ansi: wrapAnsi16(ansi2ansi, 0)
          };
          styles.color.ansi256 = {
            ansi256: wrapAnsi256(ansi2ansi, 0)
          };
          styles.color.ansi16m = {
            rgb: wrapAnsi16m(rgb2rgb, 0)
          };
          styles.bgColor.ansi = {
            ansi: wrapAnsi16(ansi2ansi, 10)
          };
          styles.bgColor.ansi256 = {
            ansi256: wrapAnsi256(ansi2ansi, 10)
          };
          styles.bgColor.ansi16m = {
            rgb: wrapAnsi16m(rgb2rgb, 10)
          };
          for (let key of Object.keys(colorConvert)) {
            if (typeof colorConvert[key] !== "object") {
              continue;
            }
            const suite = colorConvert[key];
            if (key === "ansi16") {
              key = "ansi";
            }
            if ("ansi16" in suite) {
              styles.color.ansi[key] = wrapAnsi16(suite.ansi16, 0);
              styles.bgColor.ansi[key] = wrapAnsi16(suite.ansi16, 10);
            }
            if ("ansi256" in suite) {
              styles.color.ansi256[key] = wrapAnsi256(suite.ansi256, 0);
              styles.bgColor.ansi256[key] = wrapAnsi256(suite.ansi256, 10);
            }
            if ("rgb" in suite) {
              styles.color.ansi16m[key] = wrapAnsi16m(suite.rgb, 0);
              styles.bgColor.ansi16m[key] = wrapAnsi16m(suite.rgb, 10);
            }
          }
          return styles;
        }
        Object.defineProperty(module22, "exports", {
          enumerable: true,
          get: assembleStyles
        });
      }
    });
    var require_has_flag2 = __commonJS22({
      "node_modules/vnopts/node_modules/has-flag/index.js"(exports2, module22) {
        "use strict";
        module22.exports = (flag, argv) => {
          argv = argv || process.argv;
          const prefix2 = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
          const pos = argv.indexOf(prefix2 + flag);
          const terminatorPos = argv.indexOf("--");
          return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
        };
      }
    });
    var require_supports_color2 = __commonJS22({
      "node_modules/vnopts/node_modules/supports-color/index.js"(exports2, module22) {
        "use strict";
        var os = require("os");
        var hasFlag = require_has_flag2();
        var env = process.env;
        var forceColor;
        if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
          forceColor = false;
        } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
          forceColor = true;
        }
        if ("FORCE_COLOR" in env) {
          forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
        }
        function translateLevel(level) {
          if (level === 0) {
            return false;
          }
          return {
            level,
            hasBasic: true,
            has256: level >= 2,
            has16m: level >= 3
          };
        }
        function supportsColor(stream) {
          if (forceColor === false) {
            return 0;
          }
          if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
            return 3;
          }
          if (hasFlag("color=256")) {
            return 2;
          }
          if (stream && !stream.isTTY && forceColor !== true) {
            return 0;
          }
          const min = forceColor ? 1 : 0;
          if (process.platform === "win32") {
            const osRelease = os.release().split(".");
            if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
              return Number(osRelease[2]) >= 14931 ? 3 : 2;
            }
            return 1;
          }
          if ("CI" in env) {
            if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
              return 1;
            }
            return min;
          }
          if ("TEAMCITY_VERSION" in env) {
            return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
          }
          if (env.COLORTERM === "truecolor") {
            return 3;
          }
          if ("TERM_PROGRAM" in env) {
            const version2 = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
            switch (env.TERM_PROGRAM) {
              case "iTerm.app":
                return version2 >= 3 ? 3 : 2;
              case "Apple_Terminal":
                return 2;
            }
          }
          if (/-256(color)?$/i.test(env.TERM)) {
            return 2;
          }
          if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
            return 1;
          }
          if ("COLORTERM" in env) {
            return 1;
          }
          if (env.TERM === "dumb") {
            return min;
          }
          return min;
        }
        function getSupportLevel(stream) {
          const level = supportsColor(stream);
          return translateLevel(level);
        }
        module22.exports = {
          supportsColor: getSupportLevel,
          stdout: getSupportLevel(process.stdout),
          stderr: getSupportLevel(process.stderr)
        };
      }
    });
    var require_templates2 = __commonJS22({
      "node_modules/vnopts/node_modules/chalk/templates.js"(exports2, module22) {
        "use strict";
        var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
        var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
        var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
        var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
        var ESCAPES = /* @__PURE__ */ new Map([["n", "\n"], ["r", "\r"], ["t", "	"], ["b", "\b"], ["f", "\f"], ["v", "\v"], ["0", "\0"], ["\\", "\\"], ["e", "\x1B"], ["a", "\x07"]]);
        function unescape2(c) {
          if (c[0] === "u" && c.length === 5 || c[0] === "x" && c.length === 3) {
            return String.fromCharCode(parseInt(c.slice(1), 16));
          }
          return ESCAPES.get(c) || c;
        }
        function parseArguments(name, args) {
          const results = [];
          const chunks = args.trim().split(/\s*,\s*/g);
          let matches;
          for (const chunk of chunks) {
            if (!isNaN(chunk)) {
              results.push(Number(chunk));
            } else if (matches = chunk.match(STRING_REGEX)) {
              results.push(matches[2].replace(ESCAPE_REGEX, (m2, escape, chr) => escape ? unescape2(escape) : chr));
            } else {
              throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
            }
          }
          return results;
        }
        function parseStyle(style) {
          STYLE_REGEX.lastIndex = 0;
          const results = [];
          let matches;
          while ((matches = STYLE_REGEX.exec(style)) !== null) {
            const name = matches[1];
            if (matches[2]) {
              const args = parseArguments(name, matches[2]);
              results.push([name].concat(args));
            } else {
              results.push([name]);
            }
          }
          return results;
        }
        function buildStyle(chalk3, styles) {
          const enabled = {};
          for (const layer of styles) {
            for (const style of layer.styles) {
              enabled[style[0]] = layer.inverse ? null : style.slice(1);
            }
          }
          let current = chalk3;
          for (const styleName of Object.keys(enabled)) {
            if (Array.isArray(enabled[styleName])) {
              if (!(styleName in current)) {
                throw new Error(`Unknown Chalk style: ${styleName}`);
              }
              if (enabled[styleName].length > 0) {
                current = current[styleName].apply(current, enabled[styleName]);
              } else {
                current = current[styleName];
              }
            }
          }
          return current;
        }
        module22.exports = (chalk3, tmp) => {
          const styles = [];
          const chunks = [];
          let chunk = [];
          tmp.replace(TEMPLATE_REGEX, (m2, escapeChar, inverse, style, close, chr) => {
            if (escapeChar) {
              chunk.push(unescape2(escapeChar));
            } else if (style) {
              const str = chunk.join("");
              chunk = [];
              chunks.push(styles.length === 0 ? str : buildStyle(chalk3, styles)(str));
              styles.push({
                inverse,
                styles: parseStyle(style)
              });
            } else if (close) {
              if (styles.length === 0) {
                throw new Error("Found extraneous } in Chalk template literal");
              }
              chunks.push(buildStyle(chalk3, styles)(chunk.join("")));
              chunk = [];
              styles.pop();
            } else {
              chunk.push(chr);
            }
          });
          chunks.push(chunk.join(""));
          if (styles.length > 0) {
            const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
            throw new Error(errMsg);
          }
          return chunks.join("");
        };
      }
    });
    var require_chalk2 = __commonJS22({
      "node_modules/vnopts/node_modules/chalk/index.js"(exports2, module22) {
        "use strict";
        var escapeStringRegexp2 = require_escape_string_regexp2();
        var ansiStyles = require_ansi_styles2();
        var stdoutColor = require_supports_color2().stdout;
        var template = require_templates2();
        var isSimpleWindowsTerm = process.platform === "win32" && !(process.env.TERM || "").toLowerCase().startsWith("xterm");
        var levelMapping = ["ansi", "ansi", "ansi256", "ansi16m"];
        var skipModels = /* @__PURE__ */ new Set(["gray"]);
        var styles = /* @__PURE__ */ Object.create(null);
        function applyOptions(obj, options) {
          options = options || {};
          const scLevel = stdoutColor ? stdoutColor.level : 0;
          obj.level = options.level === void 0 ? scLevel : options.level;
          obj.enabled = "enabled" in options ? options.enabled : obj.level > 0;
        }
        function Chalk(options) {
          if (!this || !(this instanceof Chalk) || this.template) {
            const chalk3 = {};
            applyOptions(chalk3, options);
            chalk3.template = function() {
              const args = [].slice.call(arguments);
              return chalkTag.apply(null, [chalk3.template].concat(args));
            };
            Object.setPrototypeOf(chalk3, Chalk.prototype);
            Object.setPrototypeOf(chalk3.template, chalk3);
            chalk3.template.constructor = Chalk;
            return chalk3.template;
          }
          applyOptions(this, options);
        }
        if (isSimpleWindowsTerm) {
          ansiStyles.blue.open = "\x1B[94m";
        }
        for (const key of Object.keys(ansiStyles)) {
          ansiStyles[key].closeRe = new RegExp(escapeStringRegexp2(ansiStyles[key].close), "g");
          styles[key] = {
            get() {
              const codes = ansiStyles[key];
              return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
            }
          };
        }
        styles.visible = {
          get() {
            return build.call(this, this._styles || [], true, "visible");
          }
        };
        ansiStyles.color.closeRe = new RegExp(escapeStringRegexp2(ansiStyles.color.close), "g");
        for (const model of Object.keys(ansiStyles.color.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          styles[model] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.color.close,
                  closeRe: ansiStyles.color.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp2(ansiStyles.bgColor.close), "g");
        for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
          styles[bgModel] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.bgColor.close,
                  closeRe: ansiStyles.bgColor.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        var proto = Object.defineProperties(() => {
        }, styles);
        function build(_styles, _empty, key) {
          const builder = function() {
            return applyStyle.apply(builder, arguments);
          };
          builder._styles = _styles;
          builder._empty = _empty;
          const self2 = this;
          Object.defineProperty(builder, "level", {
            enumerable: true,
            get() {
              return self2.level;
            },
            set(level) {
              self2.level = level;
            }
          });
          Object.defineProperty(builder, "enabled", {
            enumerable: true,
            get() {
              return self2.enabled;
            },
            set(enabled) {
              self2.enabled = enabled;
            }
          });
          builder.hasGrey = this.hasGrey || key === "gray" || key === "grey";
          builder.__proto__ = proto;
          return builder;
        }
        function applyStyle() {
          const args = arguments;
          const argsLen = args.length;
          let str = String(arguments[0]);
          if (argsLen === 0) {
            return "";
          }
          if (argsLen > 1) {
            for (let a = 1; a < argsLen; a++) {
              str += " " + args[a];
            }
          }
          if (!this.enabled || this.level <= 0 || !str) {
            return this._empty ? "" : str;
          }
          const originalDim = ansiStyles.dim.open;
          if (isSimpleWindowsTerm && this.hasGrey) {
            ansiStyles.dim.open = "";
          }
          for (const code of this._styles.slice().reverse()) {
            str = code.open + str.replace(code.closeRe, code.open) + code.close;
            str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
          }
          ansiStyles.dim.open = originalDim;
          return str;
        }
        function chalkTag(chalk3, strings) {
          if (!Array.isArray(strings)) {
            return [].slice.call(arguments, 1).join(" ");
          }
          const args = [].slice.call(arguments, 2);
          const parts = [strings.raw[0]];
          for (let i2 = 1; i2 < strings.length; i2++) {
            parts.push(String(args[i2 - 1]).replace(/[{}\\]/g, "\\$&"));
            parts.push(String(strings.raw[i2]));
          }
          return template(chalk3, parts.join(""));
        }
        Object.defineProperties(Chalk.prototype, styles);
        module22.exports = Chalk();
        module22.exports.supportsColor = stdoutColor;
        module22.exports.default = module22.exports;
      }
    });
    var require_common3 = __commonJS22({
      "node_modules/vnopts/lib/handlers/deprecated/common.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var chalk_1 = require_chalk2();
        exports2.commonDeprecatedHandler = (keyOrPair, redirectTo, {
          descriptor
        }) => {
          const messages = [`${chalk_1.default.yellow(typeof keyOrPair === "string" ? descriptor.key(keyOrPair) : descriptor.pair(keyOrPair))} is deprecated`];
          if (redirectTo) {
            messages.push(`we now treat it as ${chalk_1.default.blue(typeof redirectTo === "string" ? descriptor.key(redirectTo) : descriptor.pair(redirectTo))}`);
          }
          return messages.join("; ") + ".";
        };
      }
    });
    var require_deprecated = __commonJS22({
      "node_modules/vnopts/lib/handlers/deprecated/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_common3(), exports2);
      }
    });
    var require_common22 = __commonJS22({
      "node_modules/vnopts/lib/handlers/invalid/common.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var chalk_1 = require_chalk2();
        exports2.commonInvalidHandler = (key, value, utils) => [`Invalid ${chalk_1.default.red(utils.descriptor.key(key))} value.`, `Expected ${chalk_1.default.blue(utils.schemas[key].expected(utils))},`, `but received ${chalk_1.default.red(utils.descriptor.value(value))}.`].join(" ");
      }
    });
    var require_invalid = __commonJS22({
      "node_modules/vnopts/lib/handlers/invalid/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_common22(), exports2);
      }
    });
    var require_leven = __commonJS22({
      "node_modules/vnopts/node_modules/leven/index.js"(exports2, module22) {
        "use strict";
        var arr = [];
        var charCodeCache = [];
        module22.exports = function(a, b) {
          if (a === b) {
            return 0;
          }
          var swap = a;
          if (a.length > b.length) {
            a = b;
            b = swap;
          }
          var aLen = a.length;
          var bLen = b.length;
          if (aLen === 0) {
            return bLen;
          }
          if (bLen === 0) {
            return aLen;
          }
          while (aLen > 0 && a.charCodeAt(~-aLen) === b.charCodeAt(~-bLen)) {
            aLen--;
            bLen--;
          }
          if (aLen === 0) {
            return bLen;
          }
          var start = 0;
          while (start < aLen && a.charCodeAt(start) === b.charCodeAt(start)) {
            start++;
          }
          aLen -= start;
          bLen -= start;
          if (aLen === 0) {
            return bLen;
          }
          var bCharCode;
          var ret;
          var tmp;
          var tmp2;
          var i2 = 0;
          var j = 0;
          while (i2 < aLen) {
            charCodeCache[start + i2] = a.charCodeAt(start + i2);
            arr[i2] = ++i2;
          }
          while (j < bLen) {
            bCharCode = b.charCodeAt(start + j);
            tmp = j++;
            ret = j;
            for (i2 = 0; i2 < aLen; i2++) {
              tmp2 = bCharCode === charCodeCache[start + i2] ? tmp : tmp + 1;
              tmp = arr[i2];
              ret = arr[i2] = tmp > ret ? tmp2 > ret ? ret + 1 : tmp2 : tmp2 > tmp ? tmp + 1 : tmp2;
            }
          }
          return ret;
        };
      }
    });
    var require_leven2 = __commonJS22({
      "node_modules/vnopts/lib/handlers/unknown/leven.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var chalk_1 = require_chalk2();
        var leven = require_leven();
        exports2.levenUnknownHandler = (key, value, {
          descriptor,
          logger,
          schemas
        }) => {
          const messages = [`Ignored unknown option ${chalk_1.default.yellow(descriptor.pair({
            key,
            value
          }))}.`];
          const suggestion = Object.keys(schemas).sort().find((knownKey) => leven(key, knownKey) < 3);
          if (suggestion) {
            messages.push(`Did you mean ${chalk_1.default.blue(descriptor.key(suggestion))}?`);
          }
          logger.warn(messages.join(" "));
        };
      }
    });
    var require_unknown = __commonJS22({
      "node_modules/vnopts/lib/handlers/unknown/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_leven2(), exports2);
      }
    });
    var require_handlers = __commonJS22({
      "node_modules/vnopts/lib/handlers/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_deprecated(), exports2);
        tslib_1.__exportStar(require_invalid(), exports2);
        tslib_1.__exportStar(require_unknown(), exports2);
      }
    });
    var require_schema2 = __commonJS22({
      "node_modules/vnopts/lib/schema.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var HANDLER_KEYS = ["default", "expected", "validate", "deprecated", "forward", "redirect", "overlap", "preprocess", "postprocess"];
        function createSchema(SchemaConstructor, parameters) {
          const schema = new SchemaConstructor(parameters);
          const subSchema = Object.create(schema);
          for (const handlerKey of HANDLER_KEYS) {
            if (handlerKey in parameters) {
              subSchema[handlerKey] = normalizeHandler(parameters[handlerKey], schema, Schema.prototype[handlerKey].length);
            }
          }
          return subSchema;
        }
        exports2.createSchema = createSchema;
        var Schema = class {
          constructor(parameters) {
            this.name = parameters.name;
          }
          static create(parameters) {
            return createSchema(this, parameters);
          }
          default(_utils) {
            return void 0;
          }
          expected(_utils) {
            return "nothing";
          }
          validate(_value, _utils) {
            return false;
          }
          deprecated(_value, _utils) {
            return false;
          }
          forward(_value, _utils) {
            return void 0;
          }
          redirect(_value, _utils) {
            return void 0;
          }
          overlap(currentValue, _newValue, _utils) {
            return currentValue;
          }
          preprocess(value, _utils) {
            return value;
          }
          postprocess(value, _utils) {
            return value;
          }
        };
        exports2.Schema = Schema;
        function normalizeHandler(handler, superSchema, handlerArgumentsLength) {
          return typeof handler === "function" ? (...args) => handler(...args.slice(0, handlerArgumentsLength - 1), superSchema, ...args.slice(handlerArgumentsLength - 1)) : () => handler;
        }
      }
    });
    var require_alias = __commonJS22({
      "node_modules/vnopts/lib/schemas/alias.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var schema_1 = require_schema2();
        var AliasSchema = class extends schema_1.Schema {
          constructor(parameters) {
            super(parameters);
            this._sourceName = parameters.sourceName;
          }
          expected(utils) {
            return utils.schemas[this._sourceName].expected(utils);
          }
          validate(value, utils) {
            return utils.schemas[this._sourceName].validate(value, utils);
          }
          redirect(_value, _utils) {
            return this._sourceName;
          }
        };
        exports2.AliasSchema = AliasSchema;
      }
    });
    var require_any = __commonJS22({
      "node_modules/vnopts/lib/schemas/any.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var schema_1 = require_schema2();
        var AnySchema = class extends schema_1.Schema {
          expected() {
            return "anything";
          }
          validate() {
            return true;
          }
        };
        exports2.AnySchema = AnySchema;
      }
    });
    var require_array22 = __commonJS22({
      "node_modules/vnopts/lib/schemas/array.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        var schema_1 = require_schema2();
        var ArraySchema = class extends schema_1.Schema {
          constructor(_a4) {
            var {
              valueSchema,
              name = valueSchema.name
            } = _a4, handlers = tslib_1.__rest(_a4, ["valueSchema", "name"]);
            super(Object.assign({}, handlers, {
              name
            }));
            this._valueSchema = valueSchema;
          }
          expected(utils) {
            return `an array of ${this._valueSchema.expected(utils)}`;
          }
          validate(value, utils) {
            if (!Array.isArray(value)) {
              return false;
            }
            const invalidValues = [];
            for (const subValue of value) {
              const subValidateResult = utils.normalizeValidateResult(this._valueSchema.validate(subValue, utils), subValue);
              if (subValidateResult !== true) {
                invalidValues.push(subValidateResult.value);
              }
            }
            return invalidValues.length === 0 ? true : {
              value: invalidValues
            };
          }
          deprecated(value, utils) {
            const deprecatedResult = [];
            for (const subValue of value) {
              const subDeprecatedResult = utils.normalizeDeprecatedResult(this._valueSchema.deprecated(subValue, utils), subValue);
              if (subDeprecatedResult !== false) {
                deprecatedResult.push(...subDeprecatedResult.map(({
                  value: deprecatedValue
                }) => ({
                  value: [deprecatedValue]
                })));
              }
            }
            return deprecatedResult;
          }
          forward(value, utils) {
            const forwardResult = [];
            for (const subValue of value) {
              const subForwardResult = utils.normalizeForwardResult(this._valueSchema.forward(subValue, utils), subValue);
              forwardResult.push(...subForwardResult.map(wrapTransferResult));
            }
            return forwardResult;
          }
          redirect(value, utils) {
            const remain = [];
            const redirect = [];
            for (const subValue of value) {
              const subRedirectResult = utils.normalizeRedirectResult(this._valueSchema.redirect(subValue, utils), subValue);
              if ("remain" in subRedirectResult) {
                remain.push(subRedirectResult.remain);
              }
              redirect.push(...subRedirectResult.redirect.map(wrapTransferResult));
            }
            return remain.length === 0 ? {
              redirect
            } : {
              redirect,
              remain
            };
          }
          overlap(currentValue, newValue) {
            return currentValue.concat(newValue);
          }
        };
        exports2.ArraySchema = ArraySchema;
        function wrapTransferResult({
          from,
          to
        }) {
          return {
            from: [from],
            to
          };
        }
      }
    });
    var require_boolean = __commonJS22({
      "node_modules/vnopts/lib/schemas/boolean.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var schema_1 = require_schema2();
        var BooleanSchema = class extends schema_1.Schema {
          expected() {
            return "true or false";
          }
          validate(value) {
            return typeof value === "boolean";
          }
        };
        exports2.BooleanSchema = BooleanSchema;
      }
    });
    var require_utils11 = __commonJS22({
      "node_modules/vnopts/lib/utils.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        function recordFromArray(array, mainKey) {
          const record = /* @__PURE__ */ Object.create(null);
          for (const value of array) {
            const key = value[mainKey];
            if (record[key]) {
              throw new Error(`Duplicate ${mainKey} ${JSON.stringify(key)}`);
            }
            record[key] = value;
          }
          return record;
        }
        exports2.recordFromArray = recordFromArray;
        function mapFromArray(array, mainKey) {
          const map = /* @__PURE__ */ new Map();
          for (const value of array) {
            const key = value[mainKey];
            if (map.has(key)) {
              throw new Error(`Duplicate ${mainKey} ${JSON.stringify(key)}`);
            }
            map.set(key, value);
          }
          return map;
        }
        exports2.mapFromArray = mapFromArray;
        function createAutoChecklist() {
          const map = /* @__PURE__ */ Object.create(null);
          return (id) => {
            const idString = JSON.stringify(id);
            if (map[idString]) {
              return true;
            }
            map[idString] = true;
            return false;
          };
        }
        exports2.createAutoChecklist = createAutoChecklist;
        function partition(array, predicate) {
          const trueArray = [];
          const falseArray = [];
          for (const value of array) {
            if (predicate(value)) {
              trueArray.push(value);
            } else {
              falseArray.push(value);
            }
          }
          return [trueArray, falseArray];
        }
        exports2.partition = partition;
        function isInt(value) {
          return value === Math.floor(value);
        }
        exports2.isInt = isInt;
        function comparePrimitive(a, b) {
          if (a === b) {
            return 0;
          }
          const typeofA = typeof a;
          const typeofB = typeof b;
          const orders = ["undefined", "object", "boolean", "number", "string"];
          if (typeofA !== typeofB) {
            return orders.indexOf(typeofA) - orders.indexOf(typeofB);
          }
          if (typeofA !== "string") {
            return Number(a) - Number(b);
          }
          return a.localeCompare(b);
        }
        exports2.comparePrimitive = comparePrimitive;
        function normalizeDefaultResult(result) {
          return result === void 0 ? {} : result;
        }
        exports2.normalizeDefaultResult = normalizeDefaultResult;
        function normalizeValidateResult(result, value) {
          return result === true ? true : result === false ? {
            value
          } : result;
        }
        exports2.normalizeValidateResult = normalizeValidateResult;
        function normalizeDeprecatedResult(result, value, doNotNormalizeTrue = false) {
          return result === false ? false : result === true ? doNotNormalizeTrue ? true : [{
            value
          }] : "value" in result ? [result] : result.length === 0 ? false : result;
        }
        exports2.normalizeDeprecatedResult = normalizeDeprecatedResult;
        function normalizeTransferResult(result, value) {
          return typeof result === "string" || "key" in result ? {
            from: value,
            to: result
          } : "from" in result ? {
            from: result.from,
            to: result.to
          } : {
            from: value,
            to: result.to
          };
        }
        exports2.normalizeTransferResult = normalizeTransferResult;
        function normalizeForwardResult(result, value) {
          return result === void 0 ? [] : Array.isArray(result) ? result.map((transferResult) => normalizeTransferResult(transferResult, value)) : [normalizeTransferResult(result, value)];
        }
        exports2.normalizeForwardResult = normalizeForwardResult;
        function normalizeRedirectResult(result, value) {
          const redirect = normalizeForwardResult(typeof result === "object" && "redirect" in result ? result.redirect : result, value);
          return redirect.length === 0 ? {
            remain: value,
            redirect
          } : typeof result === "object" && "remain" in result ? {
            remain: result.remain,
            redirect
          } : {
            redirect
          };
        }
        exports2.normalizeRedirectResult = normalizeRedirectResult;
      }
    });
    var require_choice = __commonJS22({
      "node_modules/vnopts/lib/schemas/choice.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var schema_1 = require_schema2();
        var utils_1 = require_utils11();
        var ChoiceSchema = class extends schema_1.Schema {
          constructor(parameters) {
            super(parameters);
            this._choices = utils_1.mapFromArray(parameters.choices.map((choice) => choice && typeof choice === "object" ? choice : {
              value: choice
            }), "value");
          }
          expected({
            descriptor
          }) {
            const choiceValues = Array.from(this._choices.keys()).map((value) => this._choices.get(value)).filter((choiceInfo) => !choiceInfo.deprecated).map((choiceInfo) => choiceInfo.value).sort(utils_1.comparePrimitive).map(descriptor.value);
            const head = choiceValues.slice(0, -2);
            const tail = choiceValues.slice(-2);
            return head.concat(tail.join(" or ")).join(", ");
          }
          validate(value) {
            return this._choices.has(value);
          }
          deprecated(value) {
            const choiceInfo = this._choices.get(value);
            return choiceInfo && choiceInfo.deprecated ? {
              value
            } : false;
          }
          forward(value) {
            const choiceInfo = this._choices.get(value);
            return choiceInfo ? choiceInfo.forward : void 0;
          }
          redirect(value) {
            const choiceInfo = this._choices.get(value);
            return choiceInfo ? choiceInfo.redirect : void 0;
          }
        };
        exports2.ChoiceSchema = ChoiceSchema;
      }
    });
    var require_number = __commonJS22({
      "node_modules/vnopts/lib/schemas/number.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var schema_1 = require_schema2();
        var NumberSchema = class extends schema_1.Schema {
          expected() {
            return "a number";
          }
          validate(value, _utils) {
            return typeof value === "number";
          }
        };
        exports2.NumberSchema = NumberSchema;
      }
    });
    var require_integer = __commonJS22({
      "node_modules/vnopts/lib/schemas/integer.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var utils_1 = require_utils11();
        var number_1 = require_number();
        var IntegerSchema = class extends number_1.NumberSchema {
          expected() {
            return "an integer";
          }
          validate(value, utils) {
            return utils.normalizeValidateResult(super.validate(value, utils), value) === true && utils_1.isInt(value);
          }
        };
        exports2.IntegerSchema = IntegerSchema;
      }
    });
    var require_string2 = __commonJS22({
      "node_modules/vnopts/lib/schemas/string.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var schema_1 = require_schema2();
        var StringSchema = class extends schema_1.Schema {
          expected() {
            return "a string";
          }
          validate(value) {
            return typeof value === "string";
          }
        };
        exports2.StringSchema = StringSchema;
      }
    });
    var require_schemas = __commonJS22({
      "node_modules/vnopts/lib/schemas/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_alias(), exports2);
        tslib_1.__exportStar(require_any(), exports2);
        tslib_1.__exportStar(require_array22(), exports2);
        tslib_1.__exportStar(require_boolean(), exports2);
        tslib_1.__exportStar(require_choice(), exports2);
        tslib_1.__exportStar(require_integer(), exports2);
        tslib_1.__exportStar(require_number(), exports2);
        tslib_1.__exportStar(require_string2(), exports2);
      }
    });
    var require_defaults = __commonJS22({
      "node_modules/vnopts/lib/defaults.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var api_1 = require_api();
        var common_1 = require_common3();
        var invalid_1 = require_invalid();
        var leven_1 = require_leven2();
        exports2.defaultDescriptor = api_1.apiDescriptor;
        exports2.defaultUnknownHandler = leven_1.levenUnknownHandler;
        exports2.defaultInvalidHandler = invalid_1.commonInvalidHandler;
        exports2.defaultDeprecatedHandler = common_1.commonDeprecatedHandler;
      }
    });
    var require_normalize = __commonJS22({
      "node_modules/vnopts/lib/normalize.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var defaults_1 = require_defaults();
        var utils_1 = require_utils11();
        exports2.normalize = (options, schemas, opts) => new Normalizer(schemas, opts).normalize(options);
        var Normalizer = class {
          constructor(schemas, opts) {
            const {
              logger = console,
              descriptor = defaults_1.defaultDescriptor,
              unknown = defaults_1.defaultUnknownHandler,
              invalid = defaults_1.defaultInvalidHandler,
              deprecated = defaults_1.defaultDeprecatedHandler
            } = opts || {};
            this._utils = {
              descriptor,
              logger: logger || {
                warn: () => {
                }
              },
              schemas: utils_1.recordFromArray(schemas, "name"),
              normalizeDefaultResult: utils_1.normalizeDefaultResult,
              normalizeDeprecatedResult: utils_1.normalizeDeprecatedResult,
              normalizeForwardResult: utils_1.normalizeForwardResult,
              normalizeRedirectResult: utils_1.normalizeRedirectResult,
              normalizeValidateResult: utils_1.normalizeValidateResult
            };
            this._unknownHandler = unknown;
            this._invalidHandler = invalid;
            this._deprecatedHandler = deprecated;
            this.cleanHistory();
          }
          cleanHistory() {
            this._hasDeprecationWarned = utils_1.createAutoChecklist();
          }
          normalize(options) {
            const normalized = {};
            const restOptionsArray = [options];
            const applyNormalization = () => {
              while (restOptionsArray.length !== 0) {
                const currentOptions = restOptionsArray.shift();
                const transferredOptionsArray = this._applyNormalization(currentOptions, normalized);
                restOptionsArray.push(...transferredOptionsArray);
              }
            };
            applyNormalization();
            for (const key of Object.keys(this._utils.schemas)) {
              const schema = this._utils.schemas[key];
              if (!(key in normalized)) {
                const defaultResult = utils_1.normalizeDefaultResult(schema.default(this._utils));
                if ("value" in defaultResult) {
                  restOptionsArray.push({
                    [key]: defaultResult.value
                  });
                }
              }
            }
            applyNormalization();
            for (const key of Object.keys(this._utils.schemas)) {
              const schema = this._utils.schemas[key];
              if (key in normalized) {
                normalized[key] = schema.postprocess(normalized[key], this._utils);
              }
            }
            return normalized;
          }
          _applyNormalization(options, normalized) {
            const transferredOptionsArray = [];
            const [knownOptionNames, unknownOptionNames] = utils_1.partition(Object.keys(options), (key) => key in this._utils.schemas);
            for (const key of knownOptionNames) {
              const schema = this._utils.schemas[key];
              const value = schema.preprocess(options[key], this._utils);
              const validateResult = utils_1.normalizeValidateResult(schema.validate(value, this._utils), value);
              if (validateResult !== true) {
                const {
                  value: invalidValue
                } = validateResult;
                const errorMessageOrError = this._invalidHandler(key, invalidValue, this._utils);
                throw typeof errorMessageOrError === "string" ? new Error(errorMessageOrError) : errorMessageOrError;
              }
              const appendTransferredOptions = ({
                from,
                to
              }) => {
                transferredOptionsArray.push(typeof to === "string" ? {
                  [to]: from
                } : {
                  [to.key]: to.value
                });
              };
              const warnDeprecated = ({
                value: currentValue,
                redirectTo
              }) => {
                const deprecatedResult = utils_1.normalizeDeprecatedResult(schema.deprecated(currentValue, this._utils), value, true);
                if (deprecatedResult === false) {
                  return;
                }
                if (deprecatedResult === true) {
                  if (!this._hasDeprecationWarned(key)) {
                    this._utils.logger.warn(this._deprecatedHandler(key, redirectTo, this._utils));
                  }
                } else {
                  for (const {
                    value: deprecatedValue
                  } of deprecatedResult) {
                    const pair = {
                      key,
                      value: deprecatedValue
                    };
                    if (!this._hasDeprecationWarned(pair)) {
                      const redirectToPair = typeof redirectTo === "string" ? {
                        key: redirectTo,
                        value: deprecatedValue
                      } : redirectTo;
                      this._utils.logger.warn(this._deprecatedHandler(pair, redirectToPair, this._utils));
                    }
                  }
                }
              };
              const forwardResult = utils_1.normalizeForwardResult(schema.forward(value, this._utils), value);
              forwardResult.forEach(appendTransferredOptions);
              const redirectResult = utils_1.normalizeRedirectResult(schema.redirect(value, this._utils), value);
              redirectResult.redirect.forEach(appendTransferredOptions);
              if ("remain" in redirectResult) {
                const remainingValue = redirectResult.remain;
                normalized[key] = key in normalized ? schema.overlap(normalized[key], remainingValue, this._utils) : remainingValue;
                warnDeprecated({
                  value: remainingValue
                });
              }
              for (const {
                from,
                to
              } of redirectResult.redirect) {
                warnDeprecated({
                  value: from,
                  redirectTo: to
                });
              }
            }
            for (const key of unknownOptionNames) {
              const value = options[key];
              const unknownResult = this._unknownHandler(key, value, this._utils);
              if (unknownResult) {
                for (const unknownKey of Object.keys(unknownResult)) {
                  const unknownOption = {
                    [unknownKey]: unknownResult[unknownKey]
                  };
                  if (unknownKey in this._utils.schemas) {
                    transferredOptionsArray.push(unknownOption);
                  } else {
                    Object.assign(normalized, unknownOption);
                  }
                }
              }
            }
            return transferredOptionsArray;
          }
        };
        exports2.Normalizer = Normalizer;
      }
    });
    var require_lib22 = __commonJS22({
      "node_modules/vnopts/lib/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var tslib_1 = (init_tslib_es6(), __toCommonJS2(tslib_es6_exports));
        tslib_1.__exportStar(require_descriptors2(), exports2);
        tslib_1.__exportStar(require_handlers(), exports2);
        tslib_1.__exportStar(require_schemas(), exports2);
        tslib_1.__exportStar(require_normalize(), exports2);
        tslib_1.__exportStar(require_schema2(), exports2);
      }
    });
    var require_options_normalizer = __commonJS22({
      "src/main/options-normalizer.js"(exports2, module22) {
        "use strict";
        var vnopts = require_lib22();
        var getLast = require_get_last();
        var cliDescriptor = {
          key: (key) => key.length === 1 ? `-${key}` : `--${key}`,
          value: (value) => vnopts.apiDescriptor.value(value),
          pair: ({
            key,
            value
          }) => value === false ? `--no-${key}` : value === true ? cliDescriptor.key(key) : value === "" ? `${cliDescriptor.key(key)} without an argument` : `${cliDescriptor.key(key)}=${value}`
        };
        var getFlagSchema = ({
          colorsModule,
          levenshteinDistance
        }) => class FlagSchema extends vnopts.ChoiceSchema {
          constructor({
            name,
            flags
          }) {
            super({
              name,
              choices: flags
            });
            this._flags = [...flags].sort();
          }
          preprocess(value, utils) {
            if (typeof value === "string" && value.length > 0 && !this._flags.includes(value)) {
              const suggestion = this._flags.find((flag) => levenshteinDistance(flag, value) < 3);
              if (suggestion) {
                utils.logger.warn([`Unknown flag ${colorsModule.yellow(utils.descriptor.value(value))},`, `did you mean ${colorsModule.blue(utils.descriptor.value(suggestion))}?`].join(" "));
                return suggestion;
              }
            }
            return value;
          }
          expected() {
            return "a flag";
          }
        };
        var hasDeprecationWarned;
        function normalizeOptions(options, optionInfos, {
          logger = false,
          isCLI = false,
          passThrough = false,
          colorsModule = null,
          levenshteinDistance = null
        } = {}) {
          const unknown = !passThrough ? (key, value, options2) => {
            const _options2$schemas = options2.schemas, {
              _
            } = _options2$schemas, schemas2 = _objectWithoutProperties(_options2$schemas, _excluded2);
            return vnopts.levenUnknownHandler(key, value, Object.assign(Object.assign({}, options2), {}, {
              schemas: schemas2
            }));
          } : Array.isArray(passThrough) ? (key, value) => !passThrough.includes(key) ? void 0 : {
            [key]: value
          } : (key, value) => ({
            [key]: value
          });
          const descriptor = isCLI ? cliDescriptor : vnopts.apiDescriptor;
          const schemas = optionInfosToSchemas(optionInfos, {
            isCLI,
            colorsModule,
            levenshteinDistance
          });
          const normalizer = new vnopts.Normalizer(schemas, {
            logger,
            unknown,
            descriptor
          });
          const shouldSuppressDuplicateDeprecationWarnings = logger !== false;
          if (shouldSuppressDuplicateDeprecationWarnings && hasDeprecationWarned) {
            normalizer._hasDeprecationWarned = hasDeprecationWarned;
          }
          const normalized = normalizer.normalize(options);
          if (shouldSuppressDuplicateDeprecationWarnings) {
            hasDeprecationWarned = normalizer._hasDeprecationWarned;
          }
          if (isCLI && normalized["plugin-search"] === false) {
            normalized["plugin-search-dir"] = false;
          }
          return normalized;
        }
        function optionInfosToSchemas(optionInfos, {
          isCLI,
          colorsModule,
          levenshteinDistance
        }) {
          const schemas = [];
          if (isCLI) {
            schemas.push(vnopts.AnySchema.create({
              name: "_"
            }));
          }
          for (const optionInfo of optionInfos) {
            schemas.push(optionInfoToSchema(optionInfo, {
              isCLI,
              optionInfos,
              colorsModule,
              levenshteinDistance
            }));
            if (optionInfo.alias && isCLI) {
              schemas.push(vnopts.AliasSchema.create({
                name: optionInfo.alias,
                sourceName: optionInfo.name
              }));
            }
          }
          return schemas;
        }
        function optionInfoToSchema(optionInfo, {
          isCLI,
          optionInfos,
          colorsModule,
          levenshteinDistance
        }) {
          const {
            name
          } = optionInfo;
          if (name === "plugin-search-dir" || name === "pluginSearchDirs") {
            return vnopts.AnySchema.create({
              name,
              preprocess(value) {
                if (value === false) {
                  return value;
                }
                value = Array.isArray(value) ? value : [value];
                return value;
              },
              validate(value) {
                if (value === false) {
                  return true;
                }
                return value.every((dir) => typeof dir === "string");
              },
              expected() {
                return "false or paths to plugin search dir";
              }
            });
          }
          const parameters = {
            name
          };
          let SchemaConstructor;
          const handlers = {};
          switch (optionInfo.type) {
            case "int":
              SchemaConstructor = vnopts.IntegerSchema;
              if (isCLI) {
                parameters.preprocess = Number;
              }
              break;
            case "string":
              SchemaConstructor = vnopts.StringSchema;
              break;
            case "choice":
              SchemaConstructor = vnopts.ChoiceSchema;
              parameters.choices = optionInfo.choices.map((choiceInfo) => typeof choiceInfo === "object" && choiceInfo.redirect ? Object.assign(Object.assign({}, choiceInfo), {}, {
                redirect: {
                  to: {
                    key: optionInfo.name,
                    value: choiceInfo.redirect
                  }
                }
              }) : choiceInfo);
              break;
            case "boolean":
              SchemaConstructor = vnopts.BooleanSchema;
              break;
            case "flag":
              SchemaConstructor = getFlagSchema({
                colorsModule,
                levenshteinDistance
              });
              parameters.flags = optionInfos.flatMap((optionInfo2) => [optionInfo2.alias, optionInfo2.description && optionInfo2.name, optionInfo2.oppositeDescription && `no-${optionInfo2.name}`].filter(Boolean));
              break;
            case "path":
              SchemaConstructor = vnopts.StringSchema;
              break;
            default:
              throw new Error(`Unexpected type ${optionInfo.type}`);
          }
          if (optionInfo.exception) {
            parameters.validate = (value, schema, utils) => optionInfo.exception(value) || schema.validate(value, utils);
          } else {
            parameters.validate = (value, schema, utils) => value === void 0 || schema.validate(value, utils);
          }
          if (optionInfo.redirect) {
            handlers.redirect = (value) => !value ? void 0 : {
              to: {
                key: optionInfo.redirect.option,
                value: optionInfo.redirect.value
              }
            };
          }
          if (optionInfo.deprecated) {
            handlers.deprecated = true;
          }
          if (isCLI && !optionInfo.array) {
            const originalPreprocess = parameters.preprocess || ((x2) => x2);
            parameters.preprocess = (value, schema, utils) => schema.preprocess(originalPreprocess(Array.isArray(value) ? getLast(value) : value), utils);
          }
          return optionInfo.array ? vnopts.ArraySchema.create(Object.assign(Object.assign(Object.assign({}, isCLI ? {
            preprocess: (v) => Array.isArray(v) ? v : [v]
          } : {}), handlers), {}, {
            valueSchema: SchemaConstructor.create(parameters)
          })) : SchemaConstructor.create(Object.assign(Object.assign({}, parameters), handlers));
        }
        function normalizeApiOptions(options, optionInfos, opts) {
          return normalizeOptions(options, optionInfos, opts);
        }
        function normalizeCliOptions(options, optionInfos, opts) {
          if (false) {
            if (!opts.colorsModule) {
              throw new Error("'colorsModule' option is required.");
            }
            if (!opts.levenshteinDistance) {
              throw new Error("'levenshteinDistance' option is required.");
            }
          }
          return normalizeOptions(options, optionInfos, Object.assign({
            isCLI: true
          }, opts));
        }
        module22.exports = {
          normalizeApiOptions,
          normalizeCliOptions
        };
      }
    });
    var require_loc = __commonJS22({
      "src/language-js/loc.js"(exports2, module22) {
        "use strict";
        var isNonEmptyArray = require_is_non_empty_array();
        function locStart(node, opts) {
          const {
            ignoreDecorators
          } = opts || {};
          if (!ignoreDecorators) {
            const decorators = node.declaration && node.declaration.decorators || node.decorators;
            if (isNonEmptyArray(decorators)) {
              return locStart(decorators[0]);
            }
          }
          return node.range ? node.range[0] : node.start;
        }
        function locEnd(node) {
          return node.range ? node.range[1] : node.end;
        }
        function hasSameLocStart(nodeA, nodeB) {
          const nodeAStart = locStart(nodeA);
          return Number.isInteger(nodeAStart) && nodeAStart === locStart(nodeB);
        }
        function hasSameLocEnd(nodeA, nodeB) {
          const nodeAEnd = locEnd(nodeA);
          return Number.isInteger(nodeAEnd) && nodeAEnd === locEnd(nodeB);
        }
        function hasSameLoc(nodeA, nodeB) {
          return hasSameLocStart(nodeA, nodeB) && hasSameLocEnd(nodeA, nodeB);
        }
        module22.exports = {
          locStart,
          locEnd,
          hasSameLocStart,
          hasSameLoc
        };
      }
    });
    var require_load_parser = __commonJS22({
      "src/main/load-parser.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var {
          ConfigError
        } = require_errors();
        var {
          locStart,
          locEnd
        } = require_loc();
        function requireParser(parser) {
          try {
            return {
              parse: require(path4.resolve(process.cwd(), parser)),
              astFormat: "estree",
              locStart,
              locEnd
            };
          } catch {
            throw new ConfigError(`Couldn't resolve parser "${parser}"`);
          }
        }
        module22.exports = requireParser;
      }
    });
    var require_js_tokens = __commonJS22({
      "node_modules/js-tokens/index.js"(exports2) {
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.default = /((['"])(?:(?!\2|\\).|\\(?:\r\n|[\s\S]))*(\2)?|`(?:[^`\\$]|\\[\s\S]|\$(?!\{)|\$\{(?:[^{}]|\{[^}]*\}?)*\}?)*(`)?)|(\/\/.*)|(\/\*(?:[^*]|\*(?!\/))*(\*\/)?)|(\/(?!\*)(?:\[(?:(?![\]\\]).|\\.)*\]|(?![\/\]\\]).|\\.)+\/(?:(?!\s*(?:\b|[\u0080-\uFFFF$\\'"~({]|[+\-!](?!=)|\.?\d))|[gmiyus]{1,6}\b(?![\u0080-\uFFFF$\\]|\s*(?:[+\-*%&|^<>!=?({]|\/(?![\/*])))))|(0[xX][\da-fA-F]+|0[oO][0-7]+|0[bB][01]+|(?:\d*\.\d+|\d+\.?)(?:[eE][+-]?\d+)?)|((?!\d)(?:(?!\s)[$\w\u0080-\uFFFF]|\\u[\da-fA-F]{4}|\\u\{[\da-fA-F]+\})+)|(--|\+\+|&&|\|\||=>|\.{3}|(?:[+\-\/%&|^]|\*{1,2}|<{1,2}|>{1,3}|!=?|={1,2})=?|[?~.,:;[\](){}])|(\s+)|(^$|[\s\S])/g;
        exports2.matchToToken = function(match) {
          var token = {
            type: "invalid",
            value: match[0],
            closed: void 0
          };
          if (match[1])
            token.type = "string", token.closed = !!(match[3] || match[4]);
          else if (match[5])
            token.type = "comment";
          else if (match[6])
            token.type = "comment", token.closed = !!match[7];
          else if (match[8])
            token.type = "regex";
          else if (match[9])
            token.type = "number";
          else if (match[10])
            token.type = "name";
          else if (match[11])
            token.type = "punctuator";
          else if (match[12])
            token.type = "whitespace";
          return token;
        };
      }
    });
    var require_identifier = __commonJS22({
      "node_modules/@babel/helper-validator-identifier/lib/identifier.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.isIdentifierChar = isIdentifierChar;
        exports2.isIdentifierName = isIdentifierName;
        exports2.isIdentifierStart = isIdentifierStart;
        var nonASCIIidentifierStartChars = "\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1878\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u31A0-\u31BF\u31F0-\u31FF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC";
        var nonASCIIidentifierChars = "\u200C\u200D\xB7\u0300-\u036F\u0387\u0483-\u0487\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u0669\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u06F0-\u06F9\u0711\u0730-\u074A\u07A6-\u07B0\u07C0-\u07C9\u07EB-\u07F3\u07FD\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u0898-\u089F\u08CA-\u08E1\u08E3-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0966-\u096F\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u09E6-\u09EF\u09FE\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A66-\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0AE6-\u0AEF\u0AFA-\u0AFF\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B55-\u0B57\u0B62\u0B63\u0B66-\u0B6F\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0BE6-\u0BEF\u0C00-\u0C04\u0C3C\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C66-\u0C6F\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0CE6-\u0CEF\u0D00-\u0D03\u0D3B\u0D3C\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D66-\u0D6F\u0D81-\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0E50-\u0E59\u0EB1\u0EB4-\u0EBC\u0EC8-\u0ECD\u0ED0-\u0ED9\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1040-\u1049\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F-\u109D\u135D-\u135F\u1369-\u1371\u1712-\u1715\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u17E0-\u17E9\u180B-\u180D\u180F-\u1819\u18A9\u1920-\u192B\u1930-\u193B\u1946-\u194F\u19D0-\u19DA\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AB0-\u1ABD\u1ABF-\u1ACE\u1B00-\u1B04\u1B34-\u1B44\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BB0-\u1BB9\u1BE6-\u1BF3\u1C24-\u1C37\u1C40-\u1C49\u1C50-\u1C59\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF4\u1CF7-\u1CF9\u1DC0-\u1DFF\u203F\u2040\u2054\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA620-\uA629\uA66F\uA674-\uA67D\uA69E\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA82C\uA880\uA881\uA8B4-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F1\uA8FF-\uA909\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9D0-\uA9D9\uA9E5\uA9F0-\uA9F9\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA50-\uAA59\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uABF0-\uABF9\uFB1E\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFF10-\uFF19\uFF3F";
        var nonASCIIidentifierStart = new RegExp("[" + nonASCIIidentifierStartChars + "]");
        var nonASCIIidentifier = new RegExp("[" + nonASCIIidentifierStartChars + nonASCIIidentifierChars + "]");
        nonASCIIidentifierStartChars = nonASCIIidentifierChars = null;
        var astralIdentifierStartCodes = [0, 11, 2, 25, 2, 18, 2, 1, 2, 14, 3, 13, 35, 122, 70, 52, 268, 28, 4, 48, 48, 31, 14, 29, 6, 37, 11, 29, 3, 35, 5, 7, 2, 4, 43, 157, 19, 35, 5, 35, 5, 39, 9, 51, 13, 10, 2, 14, 2, 6, 2, 1, 2, 10, 2, 14, 2, 6, 2, 1, 68, 310, 10, 21, 11, 7, 25, 5, 2, 41, 2, 8, 70, 5, 3, 0, 2, 43, 2, 1, 4, 0, 3, 22, 11, 22, 10, 30, 66, 18, 2, 1, 11, 21, 11, 25, 71, 55, 7, 1, 65, 0, 16, 3, 2, 2, 2, 28, 43, 28, 4, 28, 36, 7, 2, 27, 28, 53, 11, 21, 11, 18, 14, 17, 111, 72, 56, 50, 14, 50, 14, 35, 349, 41, 7, 1, 79, 28, 11, 0, 9, 21, 43, 17, 47, 20, 28, 22, 13, 52, 58, 1, 3, 0, 14, 44, 33, 24, 27, 35, 30, 0, 3, 0, 9, 34, 4, 0, 13, 47, 15, 3, 22, 0, 2, 0, 36, 17, 2, 24, 85, 6, 2, 0, 2, 3, 2, 14, 2, 9, 8, 46, 39, 7, 3, 1, 3, 21, 2, 6, 2, 1, 2, 4, 4, 0, 19, 0, 13, 4, 159, 52, 19, 3, 21, 2, 31, 47, 21, 1, 2, 0, 185, 46, 42, 3, 37, 47, 21, 0, 60, 42, 14, 0, 72, 26, 38, 6, 186, 43, 117, 63, 32, 7, 3, 0, 3, 7, 2, 1, 2, 23, 16, 0, 2, 0, 95, 7, 3, 38, 17, 0, 2, 0, 29, 0, 11, 39, 8, 0, 22, 0, 12, 45, 20, 0, 19, 72, 264, 8, 2, 36, 18, 0, 50, 29, 113, 6, 2, 1, 2, 37, 22, 0, 26, 5, 2, 1, 2, 31, 15, 0, 328, 18, 190, 0, 80, 921, 103, 110, 18, 195, 2637, 96, 16, 1070, 4050, 582, 8634, 568, 8, 30, 18, 78, 18, 29, 19, 47, 17, 3, 32, 20, 6, 18, 689, 63, 129, 74, 6, 0, 67, 12, 65, 1, 2, 0, 29, 6135, 9, 1237, 43, 8, 8936, 3, 2, 6, 2, 1, 2, 290, 46, 2, 18, 3, 9, 395, 2309, 106, 6, 12, 4, 8, 8, 9, 5991, 84, 2, 70, 2, 1, 3, 0, 3, 1, 3, 3, 2, 11, 2, 0, 2, 6, 2, 64, 2, 3, 3, 7, 2, 6, 2, 27, 2, 3, 2, 4, 2, 0, 4, 6, 2, 339, 3, 24, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 30, 2, 24, 2, 7, 1845, 30, 482, 44, 11, 6, 17, 0, 322, 29, 19, 43, 1269, 6, 2, 3, 2, 1, 2, 14, 2, 196, 60, 67, 8, 0, 1205, 3, 2, 26, 2, 1, 2, 0, 3, 0, 2, 9, 2, 3, 2, 0, 2, 0, 7, 0, 5, 0, 2, 0, 2, 0, 2, 2, 2, 1, 2, 0, 3, 0, 2, 0, 2, 0, 2, 0, 2, 0, 2, 1, 2, 0, 3, 3, 2, 6, 2, 3, 2, 3, 2, 0, 2, 9, 2, 16, 6, 2, 2, 4, 2, 16, 4421, 42719, 33, 4152, 8, 221, 3, 5761, 15, 7472, 3104, 541, 1507, 4938];
        var astralIdentifierCodes = [509, 0, 227, 0, 150, 4, 294, 9, 1368, 2, 2, 1, 6, 3, 41, 2, 5, 0, 166, 1, 574, 3, 9, 9, 370, 1, 154, 10, 50, 3, 123, 2, 54, 14, 32, 10, 3, 1, 11, 3, 46, 10, 8, 0, 46, 9, 7, 2, 37, 13, 2, 9, 6, 1, 45, 0, 13, 2, 49, 13, 9, 3, 2, 11, 83, 11, 7, 0, 161, 11, 6, 9, 7, 3, 56, 1, 2, 6, 3, 1, 3, 2, 10, 0, 11, 1, 3, 6, 4, 4, 193, 17, 10, 9, 5, 0, 82, 19, 13, 9, 214, 6, 3, 8, 28, 1, 83, 16, 16, 9, 82, 12, 9, 9, 84, 14, 5, 9, 243, 14, 166, 9, 71, 5, 2, 1, 3, 3, 2, 0, 2, 1, 13, 9, 120, 6, 3, 6, 4, 0, 29, 9, 41, 6, 2, 3, 9, 0, 10, 10, 47, 15, 406, 7, 2, 7, 17, 9, 57, 21, 2, 13, 123, 5, 4, 0, 2, 1, 2, 6, 2, 0, 9, 9, 49, 4, 2, 1, 2, 4, 9, 9, 330, 3, 19306, 9, 87, 9, 39, 4, 60, 6, 26, 9, 1014, 0, 2, 54, 8, 3, 82, 0, 12, 1, 19628, 1, 4706, 45, 3, 22, 543, 4, 4, 5, 9, 7, 3, 6, 31, 3, 149, 2, 1418, 49, 513, 54, 5, 49, 9, 0, 15, 0, 23, 4, 2, 14, 1361, 6, 2, 16, 3, 6, 2, 1, 2, 4, 262, 6, 10, 9, 357, 0, 62, 13, 1495, 6, 110, 6, 6, 9, 4759, 9, 787719, 239];
        function isInAstralSet(code, set) {
          let pos = 65536;
          for (let i2 = 0, length = set.length; i2 < length; i2 += 2) {
            pos += set[i2];
            if (pos > code)
              return false;
            pos += set[i2 + 1];
            if (pos >= code)
              return true;
          }
          return false;
        }
        function isIdentifierStart(code) {
          if (code < 65)
            return code === 36;
          if (code <= 90)
            return true;
          if (code < 97)
            return code === 95;
          if (code <= 122)
            return true;
          if (code <= 65535) {
            return code >= 170 && nonASCIIidentifierStart.test(String.fromCharCode(code));
          }
          return isInAstralSet(code, astralIdentifierStartCodes);
        }
        function isIdentifierChar(code) {
          if (code < 48)
            return code === 36;
          if (code < 58)
            return true;
          if (code < 65)
            return false;
          if (code <= 90)
            return true;
          if (code < 97)
            return code === 95;
          if (code <= 122)
            return true;
          if (code <= 65535) {
            return code >= 170 && nonASCIIidentifier.test(String.fromCharCode(code));
          }
          return isInAstralSet(code, astralIdentifierStartCodes) || isInAstralSet(code, astralIdentifierCodes);
        }
        function isIdentifierName(name) {
          let isFirst = true;
          for (let i2 = 0; i2 < name.length; i2++) {
            let cp = name.charCodeAt(i2);
            if ((cp & 64512) === 55296 && i2 + 1 < name.length) {
              const trail = name.charCodeAt(++i2);
              if ((trail & 64512) === 56320) {
                cp = 65536 + ((cp & 1023) << 10) + (trail & 1023);
              }
            }
            if (isFirst) {
              isFirst = false;
              if (!isIdentifierStart(cp)) {
                return false;
              }
            } else if (!isIdentifierChar(cp)) {
              return false;
            }
          }
          return !isFirst;
        }
      }
    });
    var require_keyword = __commonJS22({
      "node_modules/@babel/helper-validator-identifier/lib/keyword.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.isKeyword = isKeyword;
        exports2.isReservedWord = isReservedWord;
        exports2.isStrictBindOnlyReservedWord = isStrictBindOnlyReservedWord;
        exports2.isStrictBindReservedWord = isStrictBindReservedWord;
        exports2.isStrictReservedWord = isStrictReservedWord;
        var reservedWords = {
          keyword: ["break", "case", "catch", "continue", "debugger", "default", "do", "else", "finally", "for", "function", "if", "return", "switch", "throw", "try", "var", "const", "while", "with", "new", "this", "super", "class", "extends", "export", "import", "null", "true", "false", "in", "instanceof", "typeof", "void", "delete"],
          strict: ["implements", "interface", "let", "package", "private", "protected", "public", "static", "yield"],
          strictBind: ["eval", "arguments"]
        };
        var keywords = new Set(reservedWords.keyword);
        var reservedWordsStrictSet = new Set(reservedWords.strict);
        var reservedWordsStrictBindSet = new Set(reservedWords.strictBind);
        function isReservedWord(word, inModule) {
          return inModule && word === "await" || word === "enum";
        }
        function isStrictReservedWord(word, inModule) {
          return isReservedWord(word, inModule) || reservedWordsStrictSet.has(word);
        }
        function isStrictBindOnlyReservedWord(word) {
          return reservedWordsStrictBindSet.has(word);
        }
        function isStrictBindReservedWord(word, inModule) {
          return isStrictReservedWord(word, inModule) || isStrictBindOnlyReservedWord(word);
        }
        function isKeyword(word) {
          return keywords.has(word);
        }
      }
    });
    var require_lib32 = __commonJS22({
      "node_modules/@babel/helper-validator-identifier/lib/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        Object.defineProperty(exports2, "isIdentifierChar", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierChar;
          }
        });
        Object.defineProperty(exports2, "isIdentifierName", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierName;
          }
        });
        Object.defineProperty(exports2, "isIdentifierStart", {
          enumerable: true,
          get: function() {
            return _identifier.isIdentifierStart;
          }
        });
        Object.defineProperty(exports2, "isKeyword", {
          enumerable: true,
          get: function() {
            return _keyword.isKeyword;
          }
        });
        Object.defineProperty(exports2, "isReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isReservedWord;
          }
        });
        Object.defineProperty(exports2, "isStrictBindOnlyReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictBindOnlyReservedWord;
          }
        });
        Object.defineProperty(exports2, "isStrictBindReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictBindReservedWord;
          }
        });
        Object.defineProperty(exports2, "isStrictReservedWord", {
          enumerable: true,
          get: function() {
            return _keyword.isStrictReservedWord;
          }
        });
        var _identifier = require_identifier();
        var _keyword = require_keyword();
      }
    });
    var require_escape_string_regexp22 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/escape-string-regexp/index.js"(exports2, module22) {
        "use strict";
        var matchOperatorsRe = /[|\\{}()[\]^$+*?.]/g;
        module22.exports = function(str) {
          if (typeof str !== "string") {
            throw new TypeError("Expected a string");
          }
          return str.replace(matchOperatorsRe, "\\$&");
        };
      }
    });
    var require_has_flag22 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/has-flag/index.js"(exports2, module22) {
        "use strict";
        module22.exports = (flag, argv) => {
          argv = argv || process.argv;
          const prefix2 = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
          const pos = argv.indexOf(prefix2 + flag);
          const terminatorPos = argv.indexOf("--");
          return pos !== -1 && (terminatorPos === -1 ? true : pos < terminatorPos);
        };
      }
    });
    var require_supports_color22 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/supports-color/index.js"(exports2, module22) {
        "use strict";
        var os = require("os");
        var hasFlag = require_has_flag22();
        var env = process.env;
        var forceColor;
        if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false")) {
          forceColor = false;
        } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
          forceColor = true;
        }
        if ("FORCE_COLOR" in env) {
          forceColor = env.FORCE_COLOR.length === 0 || parseInt(env.FORCE_COLOR, 10) !== 0;
        }
        function translateLevel(level) {
          if (level === 0) {
            return false;
          }
          return {
            level,
            hasBasic: true,
            has256: level >= 2,
            has16m: level >= 3
          };
        }
        function supportsColor(stream) {
          if (forceColor === false) {
            return 0;
          }
          if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
            return 3;
          }
          if (hasFlag("color=256")) {
            return 2;
          }
          if (stream && !stream.isTTY && forceColor !== true) {
            return 0;
          }
          const min = forceColor ? 1 : 0;
          if (process.platform === "win32") {
            const osRelease = os.release().split(".");
            if (Number(process.versions.node.split(".")[0]) >= 8 && Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
              return Number(osRelease[2]) >= 14931 ? 3 : 2;
            }
            return 1;
          }
          if ("CI" in env) {
            if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
              return 1;
            }
            return min;
          }
          if ("TEAMCITY_VERSION" in env) {
            return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
          }
          if (env.COLORTERM === "truecolor") {
            return 3;
          }
          if ("TERM_PROGRAM" in env) {
            const version2 = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
            switch (env.TERM_PROGRAM) {
              case "iTerm.app":
                return version2 >= 3 ? 3 : 2;
              case "Apple_Terminal":
                return 2;
            }
          }
          if (/-256(color)?$/i.test(env.TERM)) {
            return 2;
          }
          if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
            return 1;
          }
          if ("COLORTERM" in env) {
            return 1;
          }
          if (env.TERM === "dumb") {
            return min;
          }
          return min;
        }
        function getSupportLevel(stream) {
          const level = supportsColor(stream);
          return translateLevel(level);
        }
        module22.exports = {
          supportsColor: getSupportLevel,
          stdout: getSupportLevel(process.stdout),
          stderr: getSupportLevel(process.stderr)
        };
      }
    });
    var require_templates22 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/chalk/templates.js"(exports2, module22) {
        "use strict";
        var TEMPLATE_REGEX = /(?:\\(u[a-f\d]{4}|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
        var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
        var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
        var ESCAPE_REGEX = /\\(u[a-f\d]{4}|x[a-f\d]{2}|.)|([^\\])/gi;
        var ESCAPES = /* @__PURE__ */ new Map([["n", "\n"], ["r", "\r"], ["t", "	"], ["b", "\b"], ["f", "\f"], ["v", "\v"], ["0", "\0"], ["\\", "\\"], ["e", "\x1B"], ["a", "\x07"]]);
        function unescape2(c) {
          if (c[0] === "u" && c.length === 5 || c[0] === "x" && c.length === 3) {
            return String.fromCharCode(parseInt(c.slice(1), 16));
          }
          return ESCAPES.get(c) || c;
        }
        function parseArguments(name, args) {
          const results = [];
          const chunks = args.trim().split(/\s*,\s*/g);
          let matches;
          for (const chunk of chunks) {
            if (!isNaN(chunk)) {
              results.push(Number(chunk));
            } else if (matches = chunk.match(STRING_REGEX)) {
              results.push(matches[2].replace(ESCAPE_REGEX, (m2, escape, chr) => escape ? unescape2(escape) : chr));
            } else {
              throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
            }
          }
          return results;
        }
        function parseStyle(style) {
          STYLE_REGEX.lastIndex = 0;
          const results = [];
          let matches;
          while ((matches = STYLE_REGEX.exec(style)) !== null) {
            const name = matches[1];
            if (matches[2]) {
              const args = parseArguments(name, matches[2]);
              results.push([name].concat(args));
            } else {
              results.push([name]);
            }
          }
          return results;
        }
        function buildStyle(chalk3, styles) {
          const enabled = {};
          for (const layer of styles) {
            for (const style of layer.styles) {
              enabled[style[0]] = layer.inverse ? null : style.slice(1);
            }
          }
          let current = chalk3;
          for (const styleName of Object.keys(enabled)) {
            if (Array.isArray(enabled[styleName])) {
              if (!(styleName in current)) {
                throw new Error(`Unknown Chalk style: ${styleName}`);
              }
              if (enabled[styleName].length > 0) {
                current = current[styleName].apply(current, enabled[styleName]);
              } else {
                current = current[styleName];
              }
            }
          }
          return current;
        }
        module22.exports = (chalk3, tmp) => {
          const styles = [];
          const chunks = [];
          let chunk = [];
          tmp.replace(TEMPLATE_REGEX, (m2, escapeChar, inverse, style, close, chr) => {
            if (escapeChar) {
              chunk.push(unescape2(escapeChar));
            } else if (style) {
              const str = chunk.join("");
              chunk = [];
              chunks.push(styles.length === 0 ? str : buildStyle(chalk3, styles)(str));
              styles.push({
                inverse,
                styles: parseStyle(style)
              });
            } else if (close) {
              if (styles.length === 0) {
                throw new Error("Found extraneous } in Chalk template literal");
              }
              chunks.push(buildStyle(chalk3, styles)(chunk.join("")));
              chunk = [];
              styles.pop();
            } else {
              chunk.push(chr);
            }
          });
          chunks.push(chunk.join(""));
          if (styles.length > 0) {
            const errMsg = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
            throw new Error(errMsg);
          }
          return chunks.join("");
        };
      }
    });
    var require_chalk22 = __commonJS22({
      "node_modules/@babel/highlight/node_modules/chalk/index.js"(exports2, module22) {
        "use strict";
        var escapeStringRegexp2 = require_escape_string_regexp22();
        var ansiStyles = require_ansi_styles2();
        var stdoutColor = require_supports_color22().stdout;
        var template = require_templates22();
        var isSimpleWindowsTerm = process.platform === "win32" && !(process.env.TERM || "").toLowerCase().startsWith("xterm");
        var levelMapping = ["ansi", "ansi", "ansi256", "ansi16m"];
        var skipModels = /* @__PURE__ */ new Set(["gray"]);
        var styles = /* @__PURE__ */ Object.create(null);
        function applyOptions(obj, options) {
          options = options || {};
          const scLevel = stdoutColor ? stdoutColor.level : 0;
          obj.level = options.level === void 0 ? scLevel : options.level;
          obj.enabled = "enabled" in options ? options.enabled : obj.level > 0;
        }
        function Chalk(options) {
          if (!this || !(this instanceof Chalk) || this.template) {
            const chalk3 = {};
            applyOptions(chalk3, options);
            chalk3.template = function() {
              const args = [].slice.call(arguments);
              return chalkTag.apply(null, [chalk3.template].concat(args));
            };
            Object.setPrototypeOf(chalk3, Chalk.prototype);
            Object.setPrototypeOf(chalk3.template, chalk3);
            chalk3.template.constructor = Chalk;
            return chalk3.template;
          }
          applyOptions(this, options);
        }
        if (isSimpleWindowsTerm) {
          ansiStyles.blue.open = "\x1B[94m";
        }
        for (const key of Object.keys(ansiStyles)) {
          ansiStyles[key].closeRe = new RegExp(escapeStringRegexp2(ansiStyles[key].close), "g");
          styles[key] = {
            get() {
              const codes = ansiStyles[key];
              return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, key);
            }
          };
        }
        styles.visible = {
          get() {
            return build.call(this, this._styles || [], true, "visible");
          }
        };
        ansiStyles.color.closeRe = new RegExp(escapeStringRegexp2(ansiStyles.color.close), "g");
        for (const model of Object.keys(ansiStyles.color.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          styles[model] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.color[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.color.close,
                  closeRe: ansiStyles.color.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        ansiStyles.bgColor.closeRe = new RegExp(escapeStringRegexp2(ansiStyles.bgColor.close), "g");
        for (const model of Object.keys(ansiStyles.bgColor.ansi)) {
          if (skipModels.has(model)) {
            continue;
          }
          const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
          styles[bgModel] = {
            get() {
              const level = this.level;
              return function() {
                const open = ansiStyles.bgColor[levelMapping[level]][model].apply(null, arguments);
                const codes = {
                  open,
                  close: ansiStyles.bgColor.close,
                  closeRe: ansiStyles.bgColor.closeRe
                };
                return build.call(this, this._styles ? this._styles.concat(codes) : [codes], this._empty, model);
              };
            }
          };
        }
        var proto = Object.defineProperties(() => {
        }, styles);
        function build(_styles, _empty, key) {
          const builder = function() {
            return applyStyle.apply(builder, arguments);
          };
          builder._styles = _styles;
          builder._empty = _empty;
          const self2 = this;
          Object.defineProperty(builder, "level", {
            enumerable: true,
            get() {
              return self2.level;
            },
            set(level) {
              self2.level = level;
            }
          });
          Object.defineProperty(builder, "enabled", {
            enumerable: true,
            get() {
              return self2.enabled;
            },
            set(enabled) {
              self2.enabled = enabled;
            }
          });
          builder.hasGrey = this.hasGrey || key === "gray" || key === "grey";
          builder.__proto__ = proto;
          return builder;
        }
        function applyStyle() {
          const args = arguments;
          const argsLen = args.length;
          let str = String(arguments[0]);
          if (argsLen === 0) {
            return "";
          }
          if (argsLen > 1) {
            for (let a = 1; a < argsLen; a++) {
              str += " " + args[a];
            }
          }
          if (!this.enabled || this.level <= 0 || !str) {
            return this._empty ? "" : str;
          }
          const originalDim = ansiStyles.dim.open;
          if (isSimpleWindowsTerm && this.hasGrey) {
            ansiStyles.dim.open = "";
          }
          for (const code of this._styles.slice().reverse()) {
            str = code.open + str.replace(code.closeRe, code.open) + code.close;
            str = str.replace(/\r?\n/g, `${code.close}$&${code.open}`);
          }
          ansiStyles.dim.open = originalDim;
          return str;
        }
        function chalkTag(chalk3, strings) {
          if (!Array.isArray(strings)) {
            return [].slice.call(arguments, 1).join(" ");
          }
          const args = [].slice.call(arguments, 2);
          const parts = [strings.raw[0]];
          for (let i2 = 1; i2 < strings.length; i2++) {
            parts.push(String(args[i2 - 1]).replace(/[{}\\]/g, "\\$&"));
            parts.push(String(strings.raw[i2]));
          }
          return template(chalk3, parts.join(""));
        }
        Object.defineProperties(Chalk.prototype, styles);
        module22.exports = Chalk();
        module22.exports.supportsColor = stdoutColor;
        module22.exports.default = module22.exports;
      }
    });
    var require_lib42 = __commonJS22({
      "node_modules/@babel/highlight/lib/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.default = highlight;
        exports2.getChalk = getChalk;
        exports2.shouldHighlight = shouldHighlight;
        var _jsTokens = require_js_tokens();
        var _helperValidatorIdentifier = require_lib32();
        var _chalk = require_chalk22();
        var sometimesKeywords = /* @__PURE__ */ new Set(["as", "async", "from", "get", "of", "set"]);
        function getDefs(chalk3) {
          return {
            keyword: chalk3.cyan,
            capitalized: chalk3.yellow,
            jsxIdentifier: chalk3.yellow,
            punctuator: chalk3.yellow,
            number: chalk3.magenta,
            string: chalk3.green,
            regex: chalk3.magenta,
            comment: chalk3.grey,
            invalid: chalk3.white.bgRed.bold
          };
        }
        var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
        var BRACKET = /^[()[\]{}]$/;
        var tokenize;
        {
          const JSX_TAG = /^[a-z][\w-]*$/i;
          const getTokenType = function(token, offset, text) {
            if (token.type === "name") {
              if ((0, _helperValidatorIdentifier.isKeyword)(token.value) || (0, _helperValidatorIdentifier.isStrictReservedWord)(token.value, true) || sometimesKeywords.has(token.value)) {
                return "keyword";
              }
              if (JSX_TAG.test(token.value) && (text[offset - 1] === "<" || text.substr(offset - 2, 2) == "</")) {
                return "jsxIdentifier";
              }
              if (token.value[0] !== token.value[0].toLowerCase()) {
                return "capitalized";
              }
            }
            if (token.type === "punctuator" && BRACKET.test(token.value)) {
              return "bracket";
            }
            if (token.type === "invalid" && (token.value === "@" || token.value === "#")) {
              return "punctuator";
            }
            return token.type;
          };
          tokenize = function* (text) {
            let match;
            while (match = _jsTokens.default.exec(text)) {
              const token = _jsTokens.matchToToken(match);
              yield {
                type: getTokenType(token, match.index, text),
                value: token.value
              };
            }
          };
        }
        function highlightTokens(defs, text) {
          let highlighted = "";
          for (const {
            type,
            value
          } of tokenize(text)) {
            const colorize = defs[type];
            if (colorize) {
              highlighted += value.split(NEWLINE).map((str) => colorize(str)).join("\n");
            } else {
              highlighted += value;
            }
          }
          return highlighted;
        }
        function shouldHighlight(options) {
          return !!_chalk.supportsColor || options.forceColor;
        }
        function getChalk(options) {
          return options.forceColor ? new _chalk.constructor({
            enabled: true,
            level: 1
          }) : _chalk;
        }
        function highlight(code, options = {}) {
          if (code !== "" && shouldHighlight(options)) {
            const chalk3 = getChalk(options);
            const defs = getDefs(chalk3);
            return highlightTokens(defs, code);
          } else {
            return code;
          }
        }
      }
    });
    var require_lib52 = __commonJS22({
      "node_modules/@babel/code-frame/lib/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.codeFrameColumns = codeFrameColumns;
        exports2.default = _default;
        var _highlight = require_lib42();
        var deprecationWarningShown = false;
        function getDefs(chalk3) {
          return {
            gutter: chalk3.grey,
            marker: chalk3.red.bold,
            message: chalk3.red.bold
          };
        }
        var NEWLINE = /\r\n|[\n\r\u2028\u2029]/;
        function getMarkerLines(loc, source, opts) {
          const startLoc = Object.assign({
            column: 0,
            line: -1
          }, loc.start);
          const endLoc = Object.assign({}, startLoc, loc.end);
          const {
            linesAbove = 2,
            linesBelow = 3
          } = opts || {};
          const startLine = startLoc.line;
          const startColumn = startLoc.column;
          const endLine = endLoc.line;
          const endColumn = endLoc.column;
          let start = Math.max(startLine - (linesAbove + 1), 0);
          let end = Math.min(source.length, endLine + linesBelow);
          if (startLine === -1) {
            start = 0;
          }
          if (endLine === -1) {
            end = source.length;
          }
          const lineDiff = endLine - startLine;
          const markerLines = {};
          if (lineDiff) {
            for (let i2 = 0; i2 <= lineDiff; i2++) {
              const lineNumber = i2 + startLine;
              if (!startColumn) {
                markerLines[lineNumber] = true;
              } else if (i2 === 0) {
                const sourceLength = source[lineNumber - 1].length;
                markerLines[lineNumber] = [startColumn, sourceLength - startColumn + 1];
              } else if (i2 === lineDiff) {
                markerLines[lineNumber] = [0, endColumn];
              } else {
                const sourceLength = source[lineNumber - i2].length;
                markerLines[lineNumber] = [0, sourceLength];
              }
            }
          } else {
            if (startColumn === endColumn) {
              if (startColumn) {
                markerLines[startLine] = [startColumn, 0];
              } else {
                markerLines[startLine] = true;
              }
            } else {
              markerLines[startLine] = [startColumn, endColumn - startColumn];
            }
          }
          return {
            start,
            end,
            markerLines
          };
        }
        function codeFrameColumns(rawLines, loc, opts = {}) {
          const highlighted = (opts.highlightCode || opts.forceColor) && (0, _highlight.shouldHighlight)(opts);
          const chalk3 = (0, _highlight.getChalk)(opts);
          const defs = getDefs(chalk3);
          const maybeHighlight = (chalkFn, string) => {
            return highlighted ? chalkFn(string) : string;
          };
          const lines = rawLines.split(NEWLINE);
          const {
            start,
            end,
            markerLines
          } = getMarkerLines(loc, lines, opts);
          const hasColumns = loc.start && typeof loc.start.column === "number";
          const numberMaxWidth = String(end).length;
          const highlightedLines = highlighted ? (0, _highlight.default)(rawLines, opts) : rawLines;
          let frame = highlightedLines.split(NEWLINE, end).slice(start, end).map((line, index) => {
            const number = start + 1 + index;
            const paddedNumber = ` ${number}`.slice(-numberMaxWidth);
            const gutter = ` ${paddedNumber} |`;
            const hasMarker = markerLines[number];
            const lastMarkerLine = !markerLines[number + 1];
            if (hasMarker) {
              let markerLine = "";
              if (Array.isArray(hasMarker)) {
                const markerSpacing = line.slice(0, Math.max(hasMarker[0] - 1, 0)).replace(/[^\t]/g, " ");
                const numberOfMarkers = hasMarker[1] || 1;
                markerLine = ["\n ", maybeHighlight(defs.gutter, gutter.replace(/\d/g, " ")), " ", markerSpacing, maybeHighlight(defs.marker, "^").repeat(numberOfMarkers)].join("");
                if (lastMarkerLine && opts.message) {
                  markerLine += " " + maybeHighlight(defs.message, opts.message);
                }
              }
              return [maybeHighlight(defs.marker, ">"), maybeHighlight(defs.gutter, gutter), line.length > 0 ? ` ${line}` : "", markerLine].join("");
            } else {
              return ` ${maybeHighlight(defs.gutter, gutter)}${line.length > 0 ? ` ${line}` : ""}`;
            }
          }).join("\n");
          if (opts.message && !hasColumns) {
            frame = `${" ".repeat(numberMaxWidth + 1)}${opts.message}
${frame}`;
          }
          if (highlighted) {
            return chalk3.reset(frame);
          } else {
            return frame;
          }
        }
        function _default(rawLines, lineNumber, colNumber, opts = {}) {
          if (!deprecationWarningShown) {
            deprecationWarningShown = true;
            const message = "Passing lineNumber and colNumber is deprecated to @babel/code-frame. Please use `codeFrameColumns`.";
            if (process.emitWarning) {
              process.emitWarning(message, "DeprecationWarning");
            } else {
              const deprecationError = new Error(message);
              deprecationError.name = "DeprecationWarning";
              console.warn(new Error(message));
            }
          }
          colNumber = Math.max(colNumber, 0);
          const location = {
            start: {
              column: colNumber,
              line: lineNumber
            }
          };
          return codeFrameColumns(rawLines, location, opts);
        }
      }
    });
    var require_parser = __commonJS22({
      "src/main/parser.js"(exports2, module22) {
        "use strict";
        var {
          ConfigError
        } = require_errors();
        var jsLoc = require_loc();
        var loadParser = require_load_parser();
        var {
          locStart,
          locEnd
        } = jsLoc;
        var ownNames = Object.getOwnPropertyNames;
        var ownDescriptor = Object.getOwnPropertyDescriptor;
        function getParsers(options) {
          const parsers = {};
          for (const plugin of options.plugins) {
            if (!plugin.parsers) {
              continue;
            }
            for (const name of ownNames(plugin.parsers)) {
              Object.defineProperty(parsers, name, ownDescriptor(plugin.parsers, name));
            }
          }
          return parsers;
        }
        function resolveParser(opts, parsers = getParsers(opts)) {
          if (typeof opts.parser === "function") {
            return {
              parse: opts.parser,
              astFormat: "estree",
              locStart,
              locEnd
            };
          }
          if (typeof opts.parser === "string") {
            if (Object.prototype.hasOwnProperty.call(parsers, opts.parser)) {
              return parsers[opts.parser];
            }
            if (false) {
              throw new ConfigError(`Couldn't resolve parser "${opts.parser}". Parsers must be explicitly added to the standalone bundle.`);
            }
            return loadParser(opts.parser);
          }
        }
        function parse3(text, opts) {
          const parsers = getParsers(opts);
          const parsersForCustomParserApi = Object.defineProperties({}, Object.fromEntries(Object.keys(parsers).map((parserName) => [parserName, {
            enumerable: true,
            get() {
              return parsers[parserName].parse;
            }
          }])));
          const parser = resolveParser(opts, parsers);
          try {
            if (parser.preprocess) {
              text = parser.preprocess(text, opts);
            }
            return {
              text,
              ast: parser.parse(text, parsersForCustomParserApi, opts)
            };
          } catch (error) {
            const {
              loc
            } = error;
            if (loc) {
              const {
                codeFrameColumns
              } = require_lib52();
              error.codeFrame = codeFrameColumns(text, loc, {
                highlightCode: true
              });
              error.message += "\n" + error.codeFrame;
              throw error;
            }
            throw error.stack;
          }
        }
        module22.exports = {
          parse: parse3,
          resolveParser
        };
      }
    });
    var require_readlines = __commonJS22({
      "node_modules/n-readlines/readlines.js"(exports2, module22) {
        "use strict";
        var fs4 = require("fs");
        var LineByLine = class {
          constructor(file, options) {
            options = options || {};
            if (!options.readChunk)
              options.readChunk = 1024;
            if (!options.newLineCharacter) {
              options.newLineCharacter = 10;
            } else {
              options.newLineCharacter = options.newLineCharacter.charCodeAt(0);
            }
            if (typeof file === "number") {
              this.fd = file;
            } else {
              this.fd = fs4.openSync(file, "r");
            }
            this.options = options;
            this.newLineCharacter = options.newLineCharacter;
            this.reset();
          }
          _searchInBuffer(buffer, hexNeedle) {
            let found = -1;
            for (let i2 = 0; i2 <= buffer.length; i2++) {
              let b_byte = buffer[i2];
              if (b_byte === hexNeedle) {
                found = i2;
                break;
              }
            }
            return found;
          }
          reset() {
            this.eofReached = false;
            this.linesCache = [];
            this.fdPosition = 0;
          }
          close() {
            fs4.closeSync(this.fd);
            this.fd = null;
          }
          _extractLines(buffer) {
            let line;
            const lines = [];
            let bufferPosition = 0;
            let lastNewLineBufferPosition = 0;
            while (true) {
              let bufferPositionValue = buffer[bufferPosition++];
              if (bufferPositionValue === this.newLineCharacter) {
                line = buffer.slice(lastNewLineBufferPosition, bufferPosition);
                lines.push(line);
                lastNewLineBufferPosition = bufferPosition;
              } else if (bufferPositionValue === void 0) {
                break;
              }
            }
            let leftovers = buffer.slice(lastNewLineBufferPosition, bufferPosition);
            if (leftovers.length) {
              lines.push(leftovers);
            }
            return lines;
          }
          _readChunk(lineLeftovers) {
            let totalBytesRead = 0;
            let bytesRead;
            const buffers = [];
            do {
              const readBuffer = new Buffer(this.options.readChunk);
              bytesRead = fs4.readSync(this.fd, readBuffer, 0, this.options.readChunk, this.fdPosition);
              totalBytesRead = totalBytesRead + bytesRead;
              this.fdPosition = this.fdPosition + bytesRead;
              buffers.push(readBuffer);
            } while (bytesRead && this._searchInBuffer(buffers[buffers.length - 1], this.options.newLineCharacter) === -1);
            let bufferData = Buffer.concat(buffers);
            if (bytesRead < this.options.readChunk) {
              this.eofReached = true;
              bufferData = bufferData.slice(0, totalBytesRead);
            }
            if (totalBytesRead) {
              this.linesCache = this._extractLines(bufferData);
              if (lineLeftovers) {
                this.linesCache[0] = Buffer.concat([lineLeftovers, this.linesCache[0]]);
              }
            }
            return totalBytesRead;
          }
          next() {
            if (!this.fd)
              return false;
            let line = false;
            if (this.eofReached && this.linesCache.length === 0) {
              return line;
            }
            let bytesRead;
            if (!this.linesCache.length) {
              bytesRead = this._readChunk();
            }
            if (this.linesCache.length) {
              line = this.linesCache.shift();
              const lastLineCharacter = line[line.length - 1];
              if (lastLineCharacter !== this.newLineCharacter) {
                bytesRead = this._readChunk(line);
                if (bytesRead) {
                  line = this.linesCache.shift();
                }
              }
            }
            if (this.eofReached && this.linesCache.length === 0) {
              this.close();
            }
            if (line && line[line.length - 1] === this.newLineCharacter) {
              line = line.slice(0, line.length - 1);
            }
            return line;
          }
        };
        module22.exports = LineByLine;
      }
    });
    var require_get_interpreter = __commonJS22({
      "src/utils/get-interpreter.js"(exports2, module22) {
        "use strict";
        var fs4 = require("fs");
        var readlines = require_readlines();
        function getInterpreter(filepath) {
          if (typeof filepath !== "string") {
            return "";
          }
          let fd;
          try {
            fd = fs4.openSync(filepath, "r");
          } catch {
            return "";
          }
          try {
            const liner = new readlines(fd);
            const firstLine = liner.next().toString("utf8");
            const m1 = firstLine.match(/^#!\/(?:usr\/)?bin\/env\s+(\S+)/);
            if (m1) {
              return m1[1];
            }
            const m2 = firstLine.match(/^#!\/(?:usr\/(?:local\/)?)?bin\/(\S+)/);
            if (m2) {
              return m2[1];
            }
            return "";
          } catch {
            return "";
          } finally {
            try {
              fs4.closeSync(fd);
            } catch {
            }
          }
        }
        module22.exports = getInterpreter;
      }
    });
    var require_options = __commonJS22({
      "src/main/options.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var {
          UndefinedParserError
        } = require_errors();
        var {
          getSupportInfo: getSupportInfo2
        } = require_support();
        var normalizer = require_options_normalizer();
        var {
          resolveParser
        } = require_parser();
        var hiddenDefaults = {
          astFormat: "estree",
          printer: {},
          originalText: void 0,
          locStart: null,
          locEnd: null
        };
        function normalize(options, opts = {}) {
          const rawOptions = Object.assign({}, options);
          const supportOptions = getSupportInfo2({
            plugins: options.plugins,
            showUnreleased: true,
            showDeprecated: true
          }).options;
          const defaults = Object.assign(Object.assign({}, hiddenDefaults), Object.fromEntries(supportOptions.filter((optionInfo) => optionInfo.default !== void 0).map((option) => [option.name, option.default])));
          if (!rawOptions.parser) {
            if (!rawOptions.filepath) {
              const logger = opts.logger || console;
              logger.warn("No parser and no filepath given, using 'babel' the parser now but this will throw an error in the future. Please specify a parser or a filepath so one can be inferred.");
              rawOptions.parser = "babel";
            } else {
              rawOptions.parser = inferParser(rawOptions.filepath, rawOptions.plugins);
              if (!rawOptions.parser) {
                throw new UndefinedParserError(`No parser could be inferred for file: ${rawOptions.filepath}`);
              }
            }
          }
          const parser = resolveParser(normalizer.normalizeApiOptions(rawOptions, [supportOptions.find((x2) => x2.name === "parser")], {
            passThrough: true,
            logger: false
          }));
          rawOptions.astFormat = parser.astFormat;
          rawOptions.locEnd = parser.locEnd;
          rawOptions.locStart = parser.locStart;
          const plugin = getPlugin(rawOptions);
          rawOptions.printer = plugin.printers[rawOptions.astFormat];
          const pluginDefaults = Object.fromEntries(supportOptions.filter((optionInfo) => optionInfo.pluginDefaults && optionInfo.pluginDefaults[plugin.name] !== void 0).map((optionInfo) => [optionInfo.name, optionInfo.pluginDefaults[plugin.name]]));
          const mixedDefaults = Object.assign(Object.assign({}, defaults), pluginDefaults);
          for (const [k, value] of Object.entries(mixedDefaults)) {
            if (rawOptions[k] === null || rawOptions[k] === void 0) {
              rawOptions[k] = value;
            }
          }
          if (rawOptions.parser === "json") {
            rawOptions.trailingComma = "none";
          }
          return normalizer.normalizeApiOptions(rawOptions, supportOptions, Object.assign({
            passThrough: Object.keys(hiddenDefaults)
          }, opts));
        }
        function getPlugin(options) {
          const {
            astFormat
          } = options;
          if (!astFormat) {
            throw new Error("getPlugin() requires astFormat to be set");
          }
          const printerPlugin = options.plugins.find((plugin) => plugin.printers && plugin.printers[astFormat]);
          if (!printerPlugin) {
            throw new Error(`Couldn't find plugin for AST format "${astFormat}"`);
          }
          return printerPlugin;
        }
        function inferParser(filepath, plugins2) {
          const filename = path4.basename(filepath).toLowerCase();
          const languages = getSupportInfo2({
            plugins: plugins2
          }).languages.filter((language2) => language2.since !== null);
          let language = languages.find((language2) => language2.extensions && language2.extensions.some((extension) => filename.endsWith(extension)) || language2.filenames && language2.filenames.some((name) => name.toLowerCase() === filename));
          if (!language && !filename.includes(".")) {
            const getInterpreter = require_get_interpreter();
            const interpreter = getInterpreter(filepath);
            language = languages.find((language2) => language2.interpreters && language2.interpreters.includes(interpreter));
          }
          return language && language.parsers[0];
        }
        module22.exports = {
          normalize,
          hiddenDefaults,
          inferParser
        };
      }
    });
    var require_massage_ast = __commonJS22({
      "src/main/massage-ast.js"(exports2, module22) {
        "use strict";
        function massageAST(ast, options, parent) {
          if (Array.isArray(ast)) {
            return ast.map((e2) => massageAST(e2, options, parent)).filter(Boolean);
          }
          if (!ast || typeof ast !== "object") {
            return ast;
          }
          const cleanFunction = options.printer.massageAstNode;
          let ignoredProperties;
          if (cleanFunction && cleanFunction.ignoredProperties) {
            ignoredProperties = cleanFunction.ignoredProperties;
          } else {
            ignoredProperties = /* @__PURE__ */ new Set();
          }
          const newObj = {};
          for (const [key, value] of Object.entries(ast)) {
            if (!ignoredProperties.has(key) && typeof value !== "function") {
              newObj[key] = massageAST(value, options, ast);
            }
          }
          if (cleanFunction) {
            const result = cleanFunction(ast, newObj, parent);
            if (result === null) {
              return;
            }
            if (result) {
              return result;
            }
          }
          return newObj;
        }
        module22.exports = massageAST;
      }
    });
    var require_comments = __commonJS22({
      "src/main/comments.js"(exports2, module22) {
        "use strict";
        var assert = require("assert");
        var {
          builders: {
            line,
            hardline,
            breakParent,
            indent,
            lineSuffix,
            join,
            cursor
          }
        } = require_doc();
        var {
          hasNewline,
          skipNewline,
          skipSpaces,
          isPreviousLineEmpty,
          addLeadingComment,
          addDanglingComment,
          addTrailingComment
        } = require_util();
        var childNodesCache = /* @__PURE__ */ new WeakMap();
        function getSortedChildNodes(node, options, resultArray) {
          if (!node) {
            return;
          }
          const {
            printer,
            locStart,
            locEnd
          } = options;
          if (resultArray) {
            if (printer.canAttachComment && printer.canAttachComment(node)) {
              let i2;
              for (i2 = resultArray.length - 1; i2 >= 0; --i2) {
                if (locStart(resultArray[i2]) <= locStart(node) && locEnd(resultArray[i2]) <= locEnd(node)) {
                  break;
                }
              }
              resultArray.splice(i2 + 1, 0, node);
              return;
            }
          } else if (childNodesCache.has(node)) {
            return childNodesCache.get(node);
          }
          const childNodes = printer.getCommentChildNodes && printer.getCommentChildNodes(node, options) || typeof node === "object" && Object.entries(node).filter(([key]) => key !== "enclosingNode" && key !== "precedingNode" && key !== "followingNode" && key !== "tokens" && key !== "comments" && key !== "parent").map(([, value]) => value);
          if (!childNodes) {
            return;
          }
          if (!resultArray) {
            resultArray = [];
            childNodesCache.set(node, resultArray);
          }
          for (const childNode of childNodes) {
            getSortedChildNodes(childNode, options, resultArray);
          }
          return resultArray;
        }
        function decorateComment(node, comment, options, enclosingNode) {
          const {
            locStart,
            locEnd
          } = options;
          const commentStart = locStart(comment);
          const commentEnd = locEnd(comment);
          const childNodes = getSortedChildNodes(node, options);
          let precedingNode;
          let followingNode;
          let left = 0;
          let right = childNodes.length;
          while (left < right) {
            const middle = left + right >> 1;
            const child = childNodes[middle];
            const start = locStart(child);
            const end = locEnd(child);
            if (start <= commentStart && commentEnd <= end) {
              return decorateComment(child, comment, options, child);
            }
            if (end <= commentStart) {
              precedingNode = child;
              left = middle + 1;
              continue;
            }
            if (commentEnd <= start) {
              followingNode = child;
              right = middle;
              continue;
            }
            throw new Error("Comment location overlaps with node location");
          }
          if (enclosingNode && enclosingNode.type === "TemplateLiteral") {
            const {
              quasis
            } = enclosingNode;
            const commentIndex = findExpressionIndexForComment(quasis, comment, options);
            if (precedingNode && findExpressionIndexForComment(quasis, precedingNode, options) !== commentIndex) {
              precedingNode = null;
            }
            if (followingNode && findExpressionIndexForComment(quasis, followingNode, options) !== commentIndex) {
              followingNode = null;
            }
          }
          return {
            enclosingNode,
            precedingNode,
            followingNode
          };
        }
        var returnFalse = () => false;
        function attach(comments, ast, text, options) {
          if (!Array.isArray(comments)) {
            return;
          }
          const tiesToBreak = [];
          const {
            locStart,
            locEnd,
            printer: {
              handleComments = {}
            }
          } = options;
          const {
            avoidAstMutation,
            ownLine: handleOwnLineComment = returnFalse,
            endOfLine: handleEndOfLineComment = returnFalse,
            remaining: handleRemainingComment = returnFalse
          } = handleComments;
          const decoratedComments = comments.map((comment, index) => Object.assign(Object.assign({}, decorateComment(ast, comment, options)), {}, {
            comment,
            text,
            options,
            ast,
            isLastComment: comments.length - 1 === index
          }));
          for (const [index, context2] of decoratedComments.entries()) {
            const {
              comment,
              precedingNode,
              enclosingNode,
              followingNode,
              text: text2,
              options: options2,
              ast: ast2,
              isLastComment
            } = context2;
            if (options2.parser === "json" || options2.parser === "json5" || options2.parser === "__js_expression" || options2.parser === "__vue_expression" || options2.parser === "__vue_ts_expression") {
              if (locStart(comment) - locStart(ast2) <= 0) {
                addLeadingComment(ast2, comment);
                continue;
              }
              if (locEnd(comment) - locEnd(ast2) >= 0) {
                addTrailingComment(ast2, comment);
                continue;
              }
            }
            let args;
            if (avoidAstMutation) {
              args = [context2];
            } else {
              comment.enclosingNode = enclosingNode;
              comment.precedingNode = precedingNode;
              comment.followingNode = followingNode;
              args = [comment, text2, options2, ast2, isLastComment];
            }
            if (isOwnLineComment(text2, options2, decoratedComments, index)) {
              comment.placement = "ownLine";
              if (handleOwnLineComment(...args)) {
              } else if (followingNode) {
                addLeadingComment(followingNode, comment);
              } else if (precedingNode) {
                addTrailingComment(precedingNode, comment);
              } else if (enclosingNode) {
                addDanglingComment(enclosingNode, comment);
              } else {
                addDanglingComment(ast2, comment);
              }
            } else if (isEndOfLineComment(text2, options2, decoratedComments, index)) {
              comment.placement = "endOfLine";
              if (handleEndOfLineComment(...args)) {
              } else if (precedingNode) {
                addTrailingComment(precedingNode, comment);
              } else if (followingNode) {
                addLeadingComment(followingNode, comment);
              } else if (enclosingNode) {
                addDanglingComment(enclosingNode, comment);
              } else {
                addDanglingComment(ast2, comment);
              }
            } else {
              comment.placement = "remaining";
              if (handleRemainingComment(...args)) {
              } else if (precedingNode && followingNode) {
                const tieCount = tiesToBreak.length;
                if (tieCount > 0) {
                  const lastTie = tiesToBreak[tieCount - 1];
                  if (lastTie.followingNode !== followingNode) {
                    breakTies(tiesToBreak, text2, options2);
                  }
                }
                tiesToBreak.push(context2);
              } else if (precedingNode) {
                addTrailingComment(precedingNode, comment);
              } else if (followingNode) {
                addLeadingComment(followingNode, comment);
              } else if (enclosingNode) {
                addDanglingComment(enclosingNode, comment);
              } else {
                addDanglingComment(ast2, comment);
              }
            }
          }
          breakTies(tiesToBreak, text, options);
          if (!avoidAstMutation) {
            for (const comment of comments) {
              delete comment.precedingNode;
              delete comment.enclosingNode;
              delete comment.followingNode;
            }
          }
        }
        var isAllEmptyAndNoLineBreak = (text) => !/[\S\n\u2028\u2029]/.test(text);
        function isOwnLineComment(text, options, decoratedComments, commentIndex) {
          const {
            comment,
            precedingNode
          } = decoratedComments[commentIndex];
          const {
            locStart,
            locEnd
          } = options;
          let start = locStart(comment);
          if (precedingNode) {
            for (let index = commentIndex - 1; index >= 0; index--) {
              const {
                comment: comment2,
                precedingNode: currentCommentPrecedingNode
              } = decoratedComments[index];
              if (currentCommentPrecedingNode !== precedingNode || !isAllEmptyAndNoLineBreak(text.slice(locEnd(comment2), start))) {
                break;
              }
              start = locStart(comment2);
            }
          }
          return hasNewline(text, start, {
            backwards: true
          });
        }
        function isEndOfLineComment(text, options, decoratedComments, commentIndex) {
          const {
            comment,
            followingNode
          } = decoratedComments[commentIndex];
          const {
            locStart,
            locEnd
          } = options;
          let end = locEnd(comment);
          if (followingNode) {
            for (let index = commentIndex + 1; index < decoratedComments.length; index++) {
              const {
                comment: comment2,
                followingNode: currentCommentFollowingNode
              } = decoratedComments[index];
              if (currentCommentFollowingNode !== followingNode || !isAllEmptyAndNoLineBreak(text.slice(end, locStart(comment2)))) {
                break;
              }
              end = locEnd(comment2);
            }
          }
          return hasNewline(text, end);
        }
        function breakTies(tiesToBreak, text, options) {
          const tieCount = tiesToBreak.length;
          if (tieCount === 0) {
            return;
          }
          const {
            precedingNode,
            followingNode,
            enclosingNode
          } = tiesToBreak[0];
          const gapRegExp = options.printer.getGapRegex && options.printer.getGapRegex(enclosingNode) || /^[\s(]*$/;
          let gapEndPos = options.locStart(followingNode);
          let indexOfFirstLeadingComment;
          for (indexOfFirstLeadingComment = tieCount; indexOfFirstLeadingComment > 0; --indexOfFirstLeadingComment) {
            const {
              comment,
              precedingNode: currentCommentPrecedingNode,
              followingNode: currentCommentFollowingNode
            } = tiesToBreak[indexOfFirstLeadingComment - 1];
            assert.strictEqual(currentCommentPrecedingNode, precedingNode);
            assert.strictEqual(currentCommentFollowingNode, followingNode);
            const gap = text.slice(options.locEnd(comment), gapEndPos);
            if (gapRegExp.test(gap)) {
              gapEndPos = options.locStart(comment);
            } else {
              break;
            }
          }
          for (const [i2, {
            comment
          }] of tiesToBreak.entries()) {
            if (i2 < indexOfFirstLeadingComment) {
              addTrailingComment(precedingNode, comment);
            } else {
              addLeadingComment(followingNode, comment);
            }
          }
          for (const node of [precedingNode, followingNode]) {
            if (node.comments && node.comments.length > 1) {
              node.comments.sort((a, b) => options.locStart(a) - options.locStart(b));
            }
          }
          tiesToBreak.length = 0;
        }
        function printComment(path4, options) {
          const comment = path4.getValue();
          comment.printed = true;
          return options.printer.printComment(path4, options);
        }
        function findExpressionIndexForComment(quasis, comment, options) {
          const startPos = options.locStart(comment) - 1;
          for (let i2 = 1; i2 < quasis.length; ++i2) {
            if (startPos < options.locStart(quasis[i2])) {
              return i2 - 1;
            }
          }
          return 0;
        }
        function printLeadingComment(path4, options) {
          const comment = path4.getValue();
          const parts = [printComment(path4, options)];
          const {
            printer,
            originalText,
            locStart,
            locEnd
          } = options;
          const isBlock = printer.isBlockComment && printer.isBlockComment(comment);
          if (isBlock) {
            const lineBreak = hasNewline(originalText, locEnd(comment)) ? hasNewline(originalText, locStart(comment), {
              backwards: true
            }) ? hardline : line : " ";
            parts.push(lineBreak);
          } else {
            parts.push(hardline);
          }
          const index = skipNewline(originalText, skipSpaces(originalText, locEnd(comment)));
          if (index !== false && hasNewline(originalText, index)) {
            parts.push(hardline);
          }
          return parts;
        }
        function printTrailingComment(path4, options) {
          const comment = path4.getValue();
          const printed = printComment(path4, options);
          const {
            printer,
            originalText,
            locStart
          } = options;
          const isBlock = printer.isBlockComment && printer.isBlockComment(comment);
          if (hasNewline(originalText, locStart(comment), {
            backwards: true
          })) {
            const isLineBeforeEmpty = isPreviousLineEmpty(originalText, comment, locStart);
            return lineSuffix([hardline, isLineBeforeEmpty ? hardline : "", printed]);
          }
          let parts = [" ", printed];
          if (!isBlock) {
            parts = [lineSuffix(parts), breakParent];
          }
          return parts;
        }
        function printDanglingComments(path4, options, sameIndent, filter) {
          const parts = [];
          const node = path4.getValue();
          if (!node || !node.comments) {
            return "";
          }
          path4.each(() => {
            const comment = path4.getValue();
            if (!comment.leading && !comment.trailing && (!filter || filter(comment))) {
              parts.push(printComment(path4, options));
            }
          }, "comments");
          if (parts.length === 0) {
            return "";
          }
          if (sameIndent) {
            return join(hardline, parts);
          }
          return indent([hardline, join(hardline, parts)]);
        }
        function printCommentsSeparately(path4, options, ignored) {
          const value = path4.getValue();
          if (!value) {
            return {};
          }
          let comments = value.comments || [];
          if (ignored) {
            comments = comments.filter((comment) => !ignored.has(comment));
          }
          const isCursorNode = value === options.cursorNode;
          if (comments.length === 0) {
            const maybeCursor = isCursorNode ? cursor : "";
            return {
              leading: maybeCursor,
              trailing: maybeCursor
            };
          }
          const leadingParts = [];
          const trailingParts = [];
          path4.each(() => {
            const comment = path4.getValue();
            if (ignored && ignored.has(comment)) {
              return;
            }
            const {
              leading,
              trailing
            } = comment;
            if (leading) {
              leadingParts.push(printLeadingComment(path4, options));
            } else if (trailing) {
              trailingParts.push(printTrailingComment(path4, options));
            }
          }, "comments");
          if (isCursorNode) {
            leadingParts.unshift(cursor);
            trailingParts.push(cursor);
          }
          return {
            leading: leadingParts,
            trailing: trailingParts
          };
        }
        function printComments(path4, doc2, options, ignored) {
          const {
            leading,
            trailing
          } = printCommentsSeparately(path4, options, ignored);
          if (!leading && !trailing) {
            return doc2;
          }
          return [leading, doc2, trailing];
        }
        function ensureAllCommentsPrinted(astComments) {
          if (!astComments) {
            return;
          }
          for (const comment of astComments) {
            if (!comment.printed) {
              throw new Error('Comment "' + comment.value.trim() + '" was not printed. Please report this error!');
            }
            delete comment.printed;
          }
        }
        module22.exports = {
          attach,
          printComments,
          printCommentsSeparately,
          printDanglingComments,
          getSortedChildNodes,
          ensureAllCommentsPrinted
        };
      }
    });
    var require_ast_path = __commonJS22({
      "src/common/ast-path.js"(exports2, module22) {
        "use strict";
        var getLast = require_get_last();
        function getNodeHelper(path4, count) {
          const stackIndex = getNodeStackIndexHelper(path4.stack, count);
          return stackIndex === -1 ? null : path4.stack[stackIndex];
        }
        function getNodeStackIndexHelper(stack, count) {
          for (let i2 = stack.length - 1; i2 >= 0; i2 -= 2) {
            const value = stack[i2];
            if (value && !Array.isArray(value) && --count < 0) {
              return i2;
            }
          }
          return -1;
        }
        var AstPath = class {
          constructor(value) {
            this.stack = [value];
          }
          getName() {
            const {
              stack
            } = this;
            const {
              length
            } = stack;
            if (length > 1) {
              return stack[length - 2];
            }
            return null;
          }
          getValue() {
            return getLast(this.stack);
          }
          getNode(count = 0) {
            return getNodeHelper(this, count);
          }
          getParentNode(count = 0) {
            return getNodeHelper(this, count + 1);
          }
          call(callback, ...names) {
            const {
              stack
            } = this;
            const {
              length
            } = stack;
            let value = getLast(stack);
            for (const name of names) {
              value = value[name];
              stack.push(name, value);
            }
            const result = callback(this);
            stack.length = length;
            return result;
          }
          callParent(callback, count = 0) {
            const stackIndex = getNodeStackIndexHelper(this.stack, count + 1);
            const parentValues = this.stack.splice(stackIndex + 1);
            const result = callback(this);
            this.stack.push(...parentValues);
            return result;
          }
          each(callback, ...names) {
            const {
              stack
            } = this;
            const {
              length
            } = stack;
            let value = getLast(stack);
            for (const name of names) {
              value = value[name];
              stack.push(name, value);
            }
            for (let i2 = 0; i2 < value.length; ++i2) {
              stack.push(i2, value[i2]);
              callback(this, i2, value);
              stack.length -= 2;
            }
            stack.length = length;
          }
          map(callback, ...names) {
            const result = [];
            this.each((path4, index, value) => {
              result[index] = callback(path4, index, value);
            }, ...names);
            return result;
          }
          try(callback) {
            const {
              stack
            } = this;
            const stackBackup = [...stack];
            try {
              return callback();
            } finally {
              stack.length = 0;
              stack.push(...stackBackup);
            }
          }
          match(...predicates) {
            let stackPointer = this.stack.length - 1;
            let name = null;
            let node = this.stack[stackPointer--];
            for (const predicate of predicates) {
              if (node === void 0) {
                return false;
              }
              let number = null;
              if (typeof name === "number") {
                number = name;
                name = this.stack[stackPointer--];
                node = this.stack[stackPointer--];
              }
              if (predicate && !predicate(node, name, number)) {
                return false;
              }
              name = this.stack[stackPointer--];
              node = this.stack[stackPointer--];
            }
            return true;
          }
          findAncestor(predicate) {
            let stackPointer = this.stack.length - 1;
            let name = null;
            let node = this.stack[stackPointer--];
            while (node) {
              let number = null;
              if (typeof name === "number") {
                number = name;
                name = this.stack[stackPointer--];
                node = this.stack[stackPointer--];
              }
              if (name !== null && predicate(node, name, number)) {
                return node;
              }
              name = this.stack[stackPointer--];
              node = this.stack[stackPointer--];
            }
          }
        };
        module22.exports = AstPath;
      }
    });
    var require_multiparser = __commonJS22({
      "src/main/multiparser.js"(exports2, module22) {
        "use strict";
        var {
          utils: {
            stripTrailingHardline
          }
        } = require_doc();
        var {
          normalize
        } = require_options();
        var comments = require_comments();
        function printSubtree(path4, print, options, printAstToDoc) {
          if (options.printer.embed && options.embeddedLanguageFormatting === "auto") {
            return options.printer.embed(path4, print, (text, partialNextOptions, textToDocOptions) => textToDoc(text, partialNextOptions, options, printAstToDoc, textToDocOptions), options);
          }
        }
        function textToDoc(text, partialNextOptions, parentOptions, printAstToDoc, {
          stripTrailingHardline: shouldStripTrailingHardline = false
        } = {}) {
          const nextOptions = normalize(Object.assign(Object.assign(Object.assign({}, parentOptions), partialNextOptions), {}, {
            parentParser: parentOptions.parser,
            originalText: text
          }), {
            passThrough: true
          });
          const result = require_parser().parse(text, nextOptions);
          const {
            ast
          } = result;
          text = result.text;
          const astComments = ast.comments;
          delete ast.comments;
          comments.attach(astComments, ast, text, nextOptions);
          nextOptions[Symbol.for("comments")] = astComments || [];
          nextOptions[Symbol.for("tokens")] = ast.tokens || [];
          const doc2 = printAstToDoc(ast, nextOptions);
          comments.ensureAllCommentsPrinted(astComments);
          if (shouldStripTrailingHardline) {
            if (typeof doc2 === "string") {
              return doc2.replace(/(?:\r?\n)*$/, "");
            }
            return stripTrailingHardline(doc2);
          }
          return doc2;
        }
        module22.exports = {
          printSubtree
        };
      }
    });
    var require_ast_to_doc = __commonJS22({
      "src/main/ast-to-doc.js"(exports2, module22) {
        "use strict";
        var AstPath = require_ast_path();
        var {
          builders: {
            hardline,
            addAlignmentToDoc
          },
          utils: {
            propagateBreaks
          }
        } = require_doc();
        var {
          printComments
        } = require_comments();
        var multiparser = require_multiparser();
        function printAstToDoc(ast, options, alignmentSize = 0) {
          const {
            printer
          } = options;
          if (printer.preprocess) {
            ast = printer.preprocess(ast, options);
          }
          const cache = /* @__PURE__ */ new Map();
          const path4 = new AstPath(ast);
          let doc2 = mainPrint();
          if (alignmentSize > 0) {
            doc2 = addAlignmentToDoc([hardline, doc2], alignmentSize, options.tabWidth);
          }
          propagateBreaks(doc2);
          return doc2;
          function mainPrint(selector, args) {
            if (selector === void 0 || selector === path4) {
              return mainPrintInternal(args);
            }
            if (Array.isArray(selector)) {
              return path4.call(() => mainPrintInternal(args), ...selector);
            }
            return path4.call(() => mainPrintInternal(args), selector);
          }
          function mainPrintInternal(args) {
            const value = path4.getValue();
            const shouldCache = value && typeof value === "object" && args === void 0;
            if (shouldCache && cache.has(value)) {
              return cache.get(value);
            }
            const doc3 = callPluginPrintFunction(path4, options, mainPrint, args);
            if (shouldCache) {
              cache.set(value, doc3);
            }
            return doc3;
          }
        }
        function printPrettierIgnoredNode(node, options) {
          const {
            originalText,
            [Symbol.for("comments")]: comments,
            locStart,
            locEnd
          } = options;
          const start = locStart(node);
          const end = locEnd(node);
          const printedComments = /* @__PURE__ */ new Set();
          for (const comment of comments) {
            if (locStart(comment) >= start && locEnd(comment) <= end) {
              comment.printed = true;
              printedComments.add(comment);
            }
          }
          return {
            doc: originalText.slice(start, end),
            printedComments
          };
        }
        function callPluginPrintFunction(path4, options, printPath, args) {
          const node = path4.getValue();
          const {
            printer
          } = options;
          let doc2;
          let printedComments;
          if (printer.hasPrettierIgnore && printer.hasPrettierIgnore(path4)) {
            ({
              doc: doc2,
              printedComments
            } = printPrettierIgnoredNode(node, options));
          } else {
            if (node) {
              try {
                doc2 = multiparser.printSubtree(path4, printPath, options, printAstToDoc);
              } catch (error) {
                if (process.env.PRETTIER_DEBUG) {
                  throw error;
                }
              }
            }
            if (!doc2) {
              doc2 = printer.print(path4, options, printPath, args);
            }
          }
          if (!printer.willPrintOwnComments || !printer.willPrintOwnComments(path4, options)) {
            doc2 = printComments(path4, doc2, options, printedComments);
          }
          return doc2;
        }
        module22.exports = printAstToDoc;
      }
    });
    var require_range_util = __commonJS22({
      "src/main/range-util.js"(exports2, module22) {
        "use strict";
        var assert = require("assert");
        var comments = require_comments();
        var isJsonParser = ({
          parser
        }) => parser === "json" || parser === "json5" || parser === "json-stringify";
        function findCommonAncestor(startNodeAndParents, endNodeAndParents) {
          const startNodeAndAncestors = [startNodeAndParents.node, ...startNodeAndParents.parentNodes];
          const endNodeAndAncestors = /* @__PURE__ */ new Set([endNodeAndParents.node, ...endNodeAndParents.parentNodes]);
          return startNodeAndAncestors.find((node) => jsonSourceElements.has(node.type) && endNodeAndAncestors.has(node));
        }
        function dropRootParents(parents) {
          let lastParentIndex = parents.length - 1;
          for (; ; ) {
            const parent = parents[lastParentIndex];
            if (parent && (parent.type === "Program" || parent.type === "File")) {
              lastParentIndex--;
            } else {
              break;
            }
          }
          return parents.slice(0, lastParentIndex + 1);
        }
        function findSiblingAncestors(startNodeAndParents, endNodeAndParents, {
          locStart,
          locEnd
        }) {
          let resultStartNode = startNodeAndParents.node;
          let resultEndNode = endNodeAndParents.node;
          if (resultStartNode === resultEndNode) {
            return {
              startNode: resultStartNode,
              endNode: resultEndNode
            };
          }
          const startNodeStart = locStart(startNodeAndParents.node);
          for (const endParent of dropRootParents(endNodeAndParents.parentNodes)) {
            if (locStart(endParent) >= startNodeStart) {
              resultEndNode = endParent;
            } else {
              break;
            }
          }
          const endNodeEnd = locEnd(endNodeAndParents.node);
          for (const startParent of dropRootParents(startNodeAndParents.parentNodes)) {
            if (locEnd(startParent) <= endNodeEnd) {
              resultStartNode = startParent;
            } else {
              break;
            }
          }
          return {
            startNode: resultStartNode,
            endNode: resultEndNode
          };
        }
        function findNodeAtOffset(node, offset, options, predicate, parentNodes = [], type) {
          const {
            locStart,
            locEnd
          } = options;
          const start = locStart(node);
          const end = locEnd(node);
          if (offset > end || offset < start || type === "rangeEnd" && offset === start || type === "rangeStart" && offset === end) {
            return;
          }
          for (const childNode of comments.getSortedChildNodes(node, options)) {
            const childResult = findNodeAtOffset(childNode, offset, options, predicate, [node, ...parentNodes], type);
            if (childResult) {
              return childResult;
            }
          }
          if (!predicate || predicate(node, parentNodes[0])) {
            return {
              node,
              parentNodes
            };
          }
        }
        function isJsSourceElement(type, parentType) {
          return parentType !== "DeclareExportDeclaration" && type !== "TypeParameterDeclaration" && (type === "Directive" || type === "TypeAlias" || type === "TSExportAssignment" || type.startsWith("Declare") || type.startsWith("TSDeclare") || type.endsWith("Statement") || type.endsWith("Declaration"));
        }
        var jsonSourceElements = /* @__PURE__ */ new Set(["ObjectExpression", "ArrayExpression", "StringLiteral", "NumericLiteral", "BooleanLiteral", "NullLiteral", "UnaryExpression", "TemplateLiteral"]);
        var graphqlSourceElements = /* @__PURE__ */ new Set(["OperationDefinition", "FragmentDefinition", "VariableDefinition", "TypeExtensionDefinition", "ObjectTypeDefinition", "FieldDefinition", "DirectiveDefinition", "EnumTypeDefinition", "EnumValueDefinition", "InputValueDefinition", "InputObjectTypeDefinition", "SchemaDefinition", "OperationTypeDefinition", "InterfaceTypeDefinition", "UnionTypeDefinition", "ScalarTypeDefinition"]);
        function isSourceElement(opts, node, parentNode) {
          if (!node) {
            return false;
          }
          switch (opts.parser) {
            case "flow":
            case "babel":
            case "babel-flow":
            case "babel-ts":
            case "typescript":
            case "acorn":
            case "espree":
            case "meriyah":
            case "__babel_estree":
              return isJsSourceElement(node.type, parentNode && parentNode.type);
            case "json":
            case "json5":
            case "json-stringify":
              return jsonSourceElements.has(node.type);
            case "graphql":
              return graphqlSourceElements.has(node.kind);
            case "vue":
              return node.tag !== "root";
          }
          return false;
        }
        function calculateRange(text, opts, ast) {
          let {
            rangeStart: start,
            rangeEnd: end,
            locStart,
            locEnd
          } = opts;
          assert.ok(end > start);
          const firstNonWhitespaceCharacterIndex = text.slice(start, end).search(/\S/);
          const isAllWhitespace = firstNonWhitespaceCharacterIndex === -1;
          if (!isAllWhitespace) {
            start += firstNonWhitespaceCharacterIndex;
            for (; end > start; --end) {
              if (/\S/.test(text[end - 1])) {
                break;
              }
            }
          }
          const startNodeAndParents = findNodeAtOffset(ast, start, opts, (node, parentNode) => isSourceElement(opts, node, parentNode), [], "rangeStart");
          const endNodeAndParents = isAllWhitespace ? startNodeAndParents : findNodeAtOffset(ast, end, opts, (node) => isSourceElement(opts, node), [], "rangeEnd");
          if (!startNodeAndParents || !endNodeAndParents) {
            return {
              rangeStart: 0,
              rangeEnd: 0
            };
          }
          let startNode;
          let endNode;
          if (isJsonParser(opts)) {
            const commonAncestor = findCommonAncestor(startNodeAndParents, endNodeAndParents);
            startNode = commonAncestor;
            endNode = commonAncestor;
          } else {
            ({
              startNode,
              endNode
            } = findSiblingAncestors(startNodeAndParents, endNodeAndParents, opts));
          }
          return {
            rangeStart: Math.min(locStart(startNode), locStart(endNode)),
            rangeEnd: Math.max(locEnd(startNode), locEnd(endNode))
          };
        }
        module22.exports = {
          calculateRange,
          findNodeAtOffset
        };
      }
    });
    var require_core3 = __commonJS22({
      "src/main/core.js"(exports2, module22) {
        "use strict";
        var {
          diffArrays
        } = require_array2();
        var {
          printer: {
            printDocToString
          },
          debug: {
            printDocToDebug
          }
        } = require_doc();
        var {
          getAlignmentSize
        } = require_util();
        var {
          guessEndOfLine,
          convertEndOfLineToChars,
          countEndOfLineChars,
          normalizeEndOfLine
        } = require_end_of_line();
        var normalizeOptions = require_options().normalize;
        var massageAST = require_massage_ast();
        var comments = require_comments();
        var parser = require_parser();
        var printAstToDoc = require_ast_to_doc();
        var rangeUtil = require_range_util();
        var BOM = "\uFEFF";
        var CURSOR = Symbol("cursor");
        function attachComments(text, ast, opts) {
          const astComments = ast.comments;
          if (astComments) {
            delete ast.comments;
            comments.attach(astComments, ast, text, opts);
          }
          opts[Symbol.for("comments")] = astComments || [];
          opts[Symbol.for("tokens")] = ast.tokens || [];
          opts.originalText = text;
          return astComments;
        }
        function coreFormat(originalText, opts, addAlignmentSize = 0) {
          if (!originalText || originalText.trim().length === 0) {
            return {
              formatted: "",
              cursorOffset: -1,
              comments: []
            };
          }
          const {
            ast,
            text
          } = parser.parse(originalText, opts);
          if (opts.cursorOffset >= 0) {
            const nodeResult = rangeUtil.findNodeAtOffset(ast, opts.cursorOffset, opts);
            if (nodeResult && nodeResult.node) {
              opts.cursorNode = nodeResult.node;
            }
          }
          const astComments = attachComments(text, ast, opts);
          const doc2 = printAstToDoc(ast, opts, addAlignmentSize);
          const result = printDocToString(doc2, opts);
          comments.ensureAllCommentsPrinted(astComments);
          if (addAlignmentSize > 0) {
            const trimmed = result.formatted.trim();
            if (result.cursorNodeStart !== void 0) {
              result.cursorNodeStart -= result.formatted.indexOf(trimmed);
            }
            result.formatted = trimmed + convertEndOfLineToChars(opts.endOfLine);
          }
          if (opts.cursorOffset >= 0) {
            let oldCursorNodeStart;
            let oldCursorNodeText;
            let cursorOffsetRelativeToOldCursorNode;
            let newCursorNodeStart;
            let newCursorNodeText;
            if (opts.cursorNode && result.cursorNodeText) {
              oldCursorNodeStart = opts.locStart(opts.cursorNode);
              oldCursorNodeText = text.slice(oldCursorNodeStart, opts.locEnd(opts.cursorNode));
              cursorOffsetRelativeToOldCursorNode = opts.cursorOffset - oldCursorNodeStart;
              newCursorNodeStart = result.cursorNodeStart;
              newCursorNodeText = result.cursorNodeText;
            } else {
              oldCursorNodeStart = 0;
              oldCursorNodeText = text;
              cursorOffsetRelativeToOldCursorNode = opts.cursorOffset;
              newCursorNodeStart = 0;
              newCursorNodeText = result.formatted;
            }
            if (oldCursorNodeText === newCursorNodeText) {
              return {
                formatted: result.formatted,
                cursorOffset: newCursorNodeStart + cursorOffsetRelativeToOldCursorNode,
                comments: astComments
              };
            }
            const oldCursorNodeCharArray = [...oldCursorNodeText];
            oldCursorNodeCharArray.splice(cursorOffsetRelativeToOldCursorNode, 0, CURSOR);
            const newCursorNodeCharArray = [...newCursorNodeText];
            const cursorNodeDiff = diffArrays(oldCursorNodeCharArray, newCursorNodeCharArray);
            let cursorOffset = newCursorNodeStart;
            for (const entry of cursorNodeDiff) {
              if (entry.removed) {
                if (entry.value.includes(CURSOR)) {
                  break;
                }
              } else {
                cursorOffset += entry.count;
              }
            }
            return {
              formatted: result.formatted,
              cursorOffset,
              comments: astComments
            };
          }
          return {
            formatted: result.formatted,
            cursorOffset: -1,
            comments: astComments
          };
        }
        function formatRange(originalText, opts) {
          const {
            ast,
            text
          } = parser.parse(originalText, opts);
          const {
            rangeStart,
            rangeEnd
          } = rangeUtil.calculateRange(text, opts, ast);
          const rangeString = text.slice(rangeStart, rangeEnd);
          const rangeStart2 = Math.min(rangeStart, text.lastIndexOf("\n", rangeStart) + 1);
          const indentString = text.slice(rangeStart2, rangeStart).match(/^\s*/)[0];
          const alignmentSize = getAlignmentSize(indentString, opts.tabWidth);
          const rangeResult = coreFormat(rangeString, Object.assign(Object.assign({}, opts), {}, {
            rangeStart: 0,
            rangeEnd: Number.POSITIVE_INFINITY,
            cursorOffset: opts.cursorOffset > rangeStart && opts.cursorOffset <= rangeEnd ? opts.cursorOffset - rangeStart : -1,
            endOfLine: "lf"
          }), alignmentSize);
          const rangeTrimmed = rangeResult.formatted.trimEnd();
          let {
            cursorOffset
          } = opts;
          if (cursorOffset > rangeEnd) {
            cursorOffset += rangeTrimmed.length - rangeString.length;
          } else if (rangeResult.cursorOffset >= 0) {
            cursorOffset = rangeResult.cursorOffset + rangeStart;
          }
          let formatted = text.slice(0, rangeStart) + rangeTrimmed + text.slice(rangeEnd);
          if (opts.endOfLine !== "lf") {
            const eol = convertEndOfLineToChars(opts.endOfLine);
            if (cursorOffset >= 0 && eol === "\r\n") {
              cursorOffset += countEndOfLineChars(formatted.slice(0, cursorOffset), "\n");
            }
            formatted = formatted.replace(/\n/g, eol);
          }
          return {
            formatted,
            cursorOffset,
            comments: rangeResult.comments
          };
        }
        function ensureIndexInText(text, index, defaultValue) {
          if (typeof index !== "number" || Number.isNaN(index) || index < 0 || index > text.length) {
            return defaultValue;
          }
          return index;
        }
        function normalizeIndexes(text, options) {
          let {
            cursorOffset,
            rangeStart,
            rangeEnd
          } = options;
          cursorOffset = ensureIndexInText(text, cursorOffset, -1);
          rangeStart = ensureIndexInText(text, rangeStart, 0);
          rangeEnd = ensureIndexInText(text, rangeEnd, text.length);
          return Object.assign(Object.assign({}, options), {}, {
            cursorOffset,
            rangeStart,
            rangeEnd
          });
        }
        function normalizeInputAndOptions(text, options) {
          let {
            cursorOffset,
            rangeStart,
            rangeEnd,
            endOfLine
          } = normalizeIndexes(text, options);
          const hasBOM = text.charAt(0) === BOM;
          if (hasBOM) {
            text = text.slice(1);
            cursorOffset--;
            rangeStart--;
            rangeEnd--;
          }
          if (endOfLine === "auto") {
            endOfLine = guessEndOfLine(text);
          }
          if (text.includes("\r")) {
            const countCrlfBefore = (index) => countEndOfLineChars(text.slice(0, Math.max(index, 0)), "\r\n");
            cursorOffset -= countCrlfBefore(cursorOffset);
            rangeStart -= countCrlfBefore(rangeStart);
            rangeEnd -= countCrlfBefore(rangeEnd);
            text = normalizeEndOfLine(text);
          }
          return {
            hasBOM,
            text,
            options: normalizeIndexes(text, Object.assign(Object.assign({}, options), {}, {
              cursorOffset,
              rangeStart,
              rangeEnd,
              endOfLine
            }))
          };
        }
        function hasPragma(text, options) {
          const selectedParser = parser.resolveParser(options);
          return !selectedParser.hasPragma || selectedParser.hasPragma(text);
        }
        function formatWithCursor2(originalText, originalOptions) {
          let {
            hasBOM,
            text,
            options
          } = normalizeInputAndOptions(originalText, normalizeOptions(originalOptions));
          if (options.rangeStart >= options.rangeEnd && text !== "" || options.requirePragma && !hasPragma(text, options)) {
            return {
              formatted: originalText,
              cursorOffset: originalOptions.cursorOffset,
              comments: []
            };
          }
          let result;
          if (options.rangeStart > 0 || options.rangeEnd < text.length) {
            result = formatRange(text, options);
          } else {
            if (!options.requirePragma && options.insertPragma && options.printer.insertPragma && !hasPragma(text, options)) {
              text = options.printer.insertPragma(text);
            }
            result = coreFormat(text, options);
          }
          if (hasBOM) {
            result.formatted = BOM + result.formatted;
            if (result.cursorOffset >= 0) {
              result.cursorOffset++;
            }
          }
          return result;
        }
        module22.exports = {
          formatWithCursor: formatWithCursor2,
          parse(originalText, originalOptions, massage) {
            const {
              text,
              options
            } = normalizeInputAndOptions(originalText, normalizeOptions(originalOptions));
            const parsed = parser.parse(text, options);
            if (massage) {
              parsed.ast = massageAST(parsed.ast, options);
            }
            return parsed;
          },
          formatAST(ast, options) {
            options = normalizeOptions(options);
            const doc2 = printAstToDoc(ast, options);
            return printDocToString(doc2, options);
          },
          formatDoc(doc2, options) {
            return formatWithCursor2(printDocToDebug(doc2), Object.assign(Object.assign({}, options), {}, {
              parser: "__js_expression"
            })).formatted;
          },
          printToDoc(originalText, options) {
            options = normalizeOptions(options);
            const {
              ast,
              text
            } = parser.parse(originalText, options);
            attachComments(text, ast, options);
            return printAstToDoc(ast, options);
          },
          printDocToString(doc2, options) {
            return printDocToString(doc2, normalizeOptions(options));
          }
        };
      }
    });
    var require_utils22 = __commonJS22({
      "node_modules/braces/lib/utils.js"(exports2) {
        "use strict";
        exports2.isInteger = (num) => {
          if (typeof num === "number") {
            return Number.isInteger(num);
          }
          if (typeof num === "string" && num.trim() !== "") {
            return Number.isInteger(Number(num));
          }
          return false;
        };
        exports2.find = (node, type) => node.nodes.find((node2) => node2.type === type);
        exports2.exceedsLimit = (min, max, step = 1, limit) => {
          if (limit === false)
            return false;
          if (!exports2.isInteger(min) || !exports2.isInteger(max))
            return false;
          return (Number(max) - Number(min)) / Number(step) >= limit;
        };
        exports2.escapeNode = (block, n = 0, type) => {
          let node = block.nodes[n];
          if (!node)
            return;
          if (type && node.type === type || node.type === "open" || node.type === "close") {
            if (node.escaped !== true) {
              node.value = "\\" + node.value;
              node.escaped = true;
            }
          }
        };
        exports2.encloseBrace = (node) => {
          if (node.type !== "brace")
            return false;
          if (node.commas >> 0 + node.ranges >> 0 === 0) {
            node.invalid = true;
            return true;
          }
          return false;
        };
        exports2.isInvalidBrace = (block) => {
          if (block.type !== "brace")
            return false;
          if (block.invalid === true || block.dollar)
            return true;
          if (block.commas >> 0 + block.ranges >> 0 === 0) {
            block.invalid = true;
            return true;
          }
          if (block.open !== true || block.close !== true) {
            block.invalid = true;
            return true;
          }
          return false;
        };
        exports2.isOpenOrClose = (node) => {
          if (node.type === "open" || node.type === "close") {
            return true;
          }
          return node.open === true || node.close === true;
        };
        exports2.reduce = (nodes) => nodes.reduce((acc, node) => {
          if (node.type === "text")
            acc.push(node.value);
          if (node.type === "range")
            node.type = "text";
          return acc;
        }, []);
        exports2.flatten = (...args) => {
          const result = [];
          const flat = (arr) => {
            for (let i2 = 0; i2 < arr.length; i2++) {
              let ele = arr[i2];
              Array.isArray(ele) ? flat(ele, result) : ele !== void 0 && result.push(ele);
            }
            return result;
          };
          flat(args);
          return result;
        };
      }
    });
    var require_stringify2 = __commonJS22({
      "node_modules/braces/lib/stringify.js"(exports2, module22) {
        "use strict";
        var utils = require_utils22();
        module22.exports = (ast, options = {}) => {
          let stringify = (node, parent = {}) => {
            let invalidBlock = options.escapeInvalid && utils.isInvalidBrace(parent);
            let invalidNode = node.invalid === true && options.escapeInvalid === true;
            let output = "";
            if (node.value) {
              if ((invalidBlock || invalidNode) && utils.isOpenOrClose(node)) {
                return "\\" + node.value;
              }
              return node.value;
            }
            if (node.value) {
              return node.value;
            }
            if (node.nodes) {
              for (let child of node.nodes) {
                output += stringify(child);
              }
            }
            return output;
          };
          return stringify(ast);
        };
      }
    });
    var require_is_number2 = __commonJS22({
      "node_modules/is-number/index.js"(exports2, module22) {
        "use strict";
        module22.exports = function(num) {
          if (typeof num === "number") {
            return num - num === 0;
          }
          if (typeof num === "string" && num.trim() !== "") {
            return Number.isFinite ? Number.isFinite(+num) : isFinite(+num);
          }
          return false;
        };
      }
    });
    var require_to_regex_range2 = __commonJS22({
      "node_modules/to-regex-range/index.js"(exports2, module22) {
        "use strict";
        var isNumber = require_is_number2();
        var toRegexRange = (min, max, options) => {
          if (isNumber(min) === false) {
            throw new TypeError("toRegexRange: expected the first argument to be a number");
          }
          if (max === void 0 || min === max) {
            return String(min);
          }
          if (isNumber(max) === false) {
            throw new TypeError("toRegexRange: expected the second argument to be a number.");
          }
          let opts = Object.assign({
            relaxZeros: true
          }, options);
          if (typeof opts.strictZeros === "boolean") {
            opts.relaxZeros = opts.strictZeros === false;
          }
          let relax = String(opts.relaxZeros);
          let shorthand = String(opts.shorthand);
          let capture = String(opts.capture);
          let wrap = String(opts.wrap);
          let cacheKey = min + ":" + max + "=" + relax + shorthand + capture + wrap;
          if (toRegexRange.cache.hasOwnProperty(cacheKey)) {
            return toRegexRange.cache[cacheKey].result;
          }
          let a = Math.min(min, max);
          let b = Math.max(min, max);
          if (Math.abs(a - b) === 1) {
            let result = min + "|" + max;
            if (opts.capture) {
              return `(${result})`;
            }
            if (opts.wrap === false) {
              return result;
            }
            return `(?:${result})`;
          }
          let isPadded = hasPadding(min) || hasPadding(max);
          let state = {
            min,
            max,
            a,
            b
          };
          let positives = [];
          let negatives = [];
          if (isPadded) {
            state.isPadded = isPadded;
            state.maxLen = String(state.max).length;
          }
          if (a < 0) {
            let newMin = b < 0 ? Math.abs(b) : 1;
            negatives = splitToPatterns(newMin, Math.abs(a), state, opts);
            a = state.a = 0;
          }
          if (b >= 0) {
            positives = splitToPatterns(a, b, state, opts);
          }
          state.negatives = negatives;
          state.positives = positives;
          state.result = collatePatterns(negatives, positives, opts);
          if (opts.capture === true) {
            state.result = `(${state.result})`;
          } else if (opts.wrap !== false && positives.length + negatives.length > 1) {
            state.result = `(?:${state.result})`;
          }
          toRegexRange.cache[cacheKey] = state;
          return state.result;
        };
        function collatePatterns(neg, pos, options) {
          let onlyNegative = filterPatterns(neg, pos, "-", false, options) || [];
          let onlyPositive = filterPatterns(pos, neg, "", false, options) || [];
          let intersected = filterPatterns(neg, pos, "-?", true, options) || [];
          let subpatterns = onlyNegative.concat(intersected).concat(onlyPositive);
          return subpatterns.join("|");
        }
        function splitToRanges(min, max) {
          let nines = 1;
          let zeros = 1;
          let stop = countNines(min, nines);
          let stops = /* @__PURE__ */ new Set([max]);
          while (min <= stop && stop <= max) {
            stops.add(stop);
            nines += 1;
            stop = countNines(min, nines);
          }
          stop = countZeros(max + 1, zeros) - 1;
          while (min < stop && stop <= max) {
            stops.add(stop);
            zeros += 1;
            stop = countZeros(max + 1, zeros) - 1;
          }
          stops = [...stops];
          stops.sort(compare);
          return stops;
        }
        function rangeToPattern(start, stop, options) {
          if (start === stop) {
            return {
              pattern: start,
              count: [],
              digits: 0
            };
          }
          let zipped = zip(start, stop);
          let digits = zipped.length;
          let pattern = "";
          let count = 0;
          for (let i2 = 0; i2 < digits; i2++) {
            let [startDigit, stopDigit] = zipped[i2];
            if (startDigit === stopDigit) {
              pattern += startDigit;
            } else if (startDigit !== "0" || stopDigit !== "9") {
              pattern += toCharacterClass(startDigit, stopDigit, options);
            } else {
              count++;
            }
          }
          if (count) {
            pattern += options.shorthand === true ? "\\d" : "[0-9]";
          }
          return {
            pattern,
            count: [count],
            digits
          };
        }
        function splitToPatterns(min, max, tok, options) {
          let ranges = splitToRanges(min, max);
          let tokens = [];
          let start = min;
          let prev;
          for (let i2 = 0; i2 < ranges.length; i2++) {
            let max2 = ranges[i2];
            let obj = rangeToPattern(String(start), String(max2), options);
            let zeros = "";
            if (!tok.isPadded && prev && prev.pattern === obj.pattern) {
              if (prev.count.length > 1) {
                prev.count.pop();
              }
              prev.count.push(obj.count[0]);
              prev.string = prev.pattern + toQuantifier(prev.count);
              start = max2 + 1;
              continue;
            }
            if (tok.isPadded) {
              zeros = padZeros(max2, tok, options);
            }
            obj.string = zeros + obj.pattern + toQuantifier(obj.count);
            tokens.push(obj);
            start = max2 + 1;
            prev = obj;
          }
          return tokens;
        }
        function filterPatterns(arr, comparison, prefix2, intersection, options) {
          let result = [];
          for (let ele of arr) {
            let {
              string
            } = ele;
            if (!intersection && !contains(comparison, "string", string)) {
              result.push(prefix2 + string);
            }
            if (intersection && contains(comparison, "string", string)) {
              result.push(prefix2 + string);
            }
          }
          return result;
        }
        function zip(a, b) {
          let arr = [];
          for (let i2 = 0; i2 < a.length; i2++)
            arr.push([a[i2], b[i2]]);
          return arr;
        }
        function compare(a, b) {
          return a > b ? 1 : b > a ? -1 : 0;
        }
        function contains(arr, key, val) {
          return arr.some((ele) => ele[key] === val);
        }
        function countNines(min, len) {
          return Number(String(min).slice(0, -len) + "9".repeat(len));
        }
        function countZeros(integer, zeros) {
          return integer - integer % Math.pow(10, zeros);
        }
        function toQuantifier(digits) {
          let [start = 0, stop = ""] = digits;
          if (stop || start > 1) {
            return `{${start + (stop ? "," + stop : "")}}`;
          }
          return "";
        }
        function toCharacterClass(a, b, options) {
          return `[${a}${b - a === 1 ? "" : "-"}${b}]`;
        }
        function hasPadding(str) {
          return /^-?(0+)\d/.test(str);
        }
        function padZeros(value, tok, options) {
          if (!tok.isPadded) {
            return value;
          }
          let diff2 = Math.abs(tok.maxLen - String(value).length);
          let relax = options.relaxZeros !== false;
          switch (diff2) {
            case 0:
              return "";
            case 1:
              return relax ? "0?" : "0";
            case 2:
              return relax ? "0{0,2}" : "00";
            default: {
              return relax ? `0{0,${diff2}}` : `0{${diff2}}`;
            }
          }
        }
        toRegexRange.cache = {};
        toRegexRange.clearCache = () => toRegexRange.cache = {};
        module22.exports = toRegexRange;
      }
    });
    var require_fill_range2 = __commonJS22({
      "node_modules/fill-range/index.js"(exports2, module22) {
        "use strict";
        var util2 = require("util");
        var toRegexRange = require_to_regex_range2();
        var isObject3 = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
        var transform = (toNumber) => {
          return (value) => toNumber === true ? Number(value) : String(value);
        };
        var isValidValue = (value) => {
          return typeof value === "number" || typeof value === "string" && value !== "";
        };
        var isNumber = (num) => Number.isInteger(+num);
        var zeros = (input) => {
          let value = `${input}`;
          let index = -1;
          if (value[0] === "-")
            value = value.slice(1);
          if (value === "0")
            return false;
          while (value[++index] === "0")
            ;
          return index > 0;
        };
        var stringify = (start, end, options) => {
          if (typeof start === "string" || typeof end === "string") {
            return true;
          }
          return options.stringify === true;
        };
        var pad = (input, maxLength, toNumber) => {
          if (maxLength > 0) {
            let dash = input[0] === "-" ? "-" : "";
            if (dash)
              input = input.slice(1);
            input = dash + input.padStart(dash ? maxLength - 1 : maxLength, "0");
          }
          if (toNumber === false) {
            return String(input);
          }
          return input;
        };
        var toMaxLen = (input, maxLength) => {
          let negative = input[0] === "-" ? "-" : "";
          if (negative) {
            input = input.slice(1);
            maxLength--;
          }
          while (input.length < maxLength)
            input = "0" + input;
          return negative ? "-" + input : input;
        };
        var toSequence = (parts, options) => {
          parts.negatives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
          parts.positives.sort((a, b) => a < b ? -1 : a > b ? 1 : 0);
          let prefix2 = options.capture ? "" : "?:";
          let positives = "";
          let negatives = "";
          let result;
          if (parts.positives.length) {
            positives = parts.positives.join("|");
          }
          if (parts.negatives.length) {
            negatives = `-(${prefix2}${parts.negatives.join("|")})`;
          }
          if (positives && negatives) {
            result = `${positives}|${negatives}`;
          } else {
            result = positives || negatives;
          }
          if (options.wrap) {
            return `(${prefix2}${result})`;
          }
          return result;
        };
        var toRange = (a, b, isNumbers, options) => {
          if (isNumbers) {
            return toRegexRange(a, b, Object.assign({
              wrap: false
            }, options));
          }
          let start = String.fromCharCode(a);
          if (a === b)
            return start;
          let stop = String.fromCharCode(b);
          return `[${start}-${stop}]`;
        };
        var toRegex = (start, end, options) => {
          if (Array.isArray(start)) {
            let wrap = options.wrap === true;
            let prefix2 = options.capture ? "" : "?:";
            return wrap ? `(${prefix2}${start.join("|")})` : start.join("|");
          }
          return toRegexRange(start, end, options);
        };
        var rangeError = (...args) => {
          return new RangeError("Invalid range arguments: " + util2.inspect(...args));
        };
        var invalidRange = (start, end, options) => {
          if (options.strictRanges === true)
            throw rangeError([start, end]);
          return [];
        };
        var invalidStep = (step, options) => {
          if (options.strictRanges === true) {
            throw new TypeError(`Expected step "${step}" to be a number`);
          }
          return [];
        };
        var fillNumbers = (start, end, step = 1, options = {}) => {
          let a = Number(start);
          let b = Number(end);
          if (!Number.isInteger(a) || !Number.isInteger(b)) {
            if (options.strictRanges === true)
              throw rangeError([start, end]);
            return [];
          }
          if (a === 0)
            a = 0;
          if (b === 0)
            b = 0;
          let descending = a > b;
          let startString = String(start);
          let endString = String(end);
          let stepString = String(step);
          step = Math.max(Math.abs(step), 1);
          let padded = zeros(startString) || zeros(endString) || zeros(stepString);
          let maxLen = padded ? Math.max(startString.length, endString.length, stepString.length) : 0;
          let toNumber = padded === false && stringify(start, end, options) === false;
          let format2 = options.transform || transform(toNumber);
          if (options.toRegex && step === 1) {
            return toRange(toMaxLen(start, maxLen), toMaxLen(end, maxLen), true, options);
          }
          let parts = {
            negatives: [],
            positives: []
          };
          let push2 = (num) => parts[num < 0 ? "negatives" : "positives"].push(Math.abs(num));
          let range = [];
          let index = 0;
          while (descending ? a >= b : a <= b) {
            if (options.toRegex === true && step > 1) {
              push2(a);
            } else {
              range.push(pad(format2(a, index), maxLen, toNumber));
            }
            a = descending ? a - step : a + step;
            index++;
          }
          if (options.toRegex === true) {
            return step > 1 ? toSequence(parts, options) : toRegex(range, null, Object.assign({
              wrap: false
            }, options));
          }
          return range;
        };
        var fillLetters = (start, end, step = 1, options = {}) => {
          if (!isNumber(start) && start.length > 1 || !isNumber(end) && end.length > 1) {
            return invalidRange(start, end, options);
          }
          let format2 = options.transform || ((val) => String.fromCharCode(val));
          let a = `${start}`.charCodeAt(0);
          let b = `${end}`.charCodeAt(0);
          let descending = a > b;
          let min = Math.min(a, b);
          let max = Math.max(a, b);
          if (options.toRegex && step === 1) {
            return toRange(min, max, false, options);
          }
          let range = [];
          let index = 0;
          while (descending ? a >= b : a <= b) {
            range.push(format2(a, index));
            a = descending ? a - step : a + step;
            index++;
          }
          if (options.toRegex === true) {
            return toRegex(range, null, {
              wrap: false,
              options
            });
          }
          return range;
        };
        var fill = (start, end, step, options = {}) => {
          if (end == null && isValidValue(start)) {
            return [start];
          }
          if (!isValidValue(start) || !isValidValue(end)) {
            return invalidRange(start, end, options);
          }
          if (typeof step === "function") {
            return fill(start, end, 1, {
              transform: step
            });
          }
          if (isObject3(step)) {
            return fill(start, end, 0, step);
          }
          let opts = Object.assign({}, options);
          if (opts.capture === true)
            opts.wrap = true;
          step = step || opts.step || 1;
          if (!isNumber(step)) {
            if (step != null && !isObject3(step))
              return invalidStep(step, opts);
            return fill(start, end, 1, step);
          }
          if (isNumber(start) && isNumber(end)) {
            return fillNumbers(start, end, step, opts);
          }
          return fillLetters(start, end, Math.max(Math.abs(step), 1), opts);
        };
        module22.exports = fill;
      }
    });
    var require_compile2 = __commonJS22({
      "node_modules/braces/lib/compile.js"(exports2, module22) {
        "use strict";
        var fill = require_fill_range2();
        var utils = require_utils22();
        var compile = (ast, options = {}) => {
          let walk = (node, parent = {}) => {
            let invalidBlock = utils.isInvalidBrace(parent);
            let invalidNode = node.invalid === true && options.escapeInvalid === true;
            let invalid = invalidBlock === true || invalidNode === true;
            let prefix2 = options.escapeInvalid === true ? "\\" : "";
            let output = "";
            if (node.isOpen === true) {
              return prefix2 + node.value;
            }
            if (node.isClose === true) {
              return prefix2 + node.value;
            }
            if (node.type === "open") {
              return invalid ? prefix2 + node.value : "(";
            }
            if (node.type === "close") {
              return invalid ? prefix2 + node.value : ")";
            }
            if (node.type === "comma") {
              return node.prev.type === "comma" ? "" : invalid ? node.value : "|";
            }
            if (node.value) {
              return node.value;
            }
            if (node.nodes && node.ranges > 0) {
              let args = utils.reduce(node.nodes);
              let range = fill(...args, Object.assign(Object.assign({}, options), {}, {
                wrap: false,
                toRegex: true
              }));
              if (range.length !== 0) {
                return args.length > 1 && range.length > 1 ? `(${range})` : range;
              }
            }
            if (node.nodes) {
              for (let child of node.nodes) {
                output += walk(child, node);
              }
            }
            return output;
          };
          return walk(ast);
        };
        module22.exports = compile;
      }
    });
    var require_expand2 = __commonJS22({
      "node_modules/braces/lib/expand.js"(exports2, module22) {
        "use strict";
        var fill = require_fill_range2();
        var stringify = require_stringify2();
        var utils = require_utils22();
        var append = (queue = "", stash = "", enclose = false) => {
          let result = [];
          queue = [].concat(queue);
          stash = [].concat(stash);
          if (!stash.length)
            return queue;
          if (!queue.length) {
            return enclose ? utils.flatten(stash).map((ele) => `{${ele}}`) : stash;
          }
          for (let item of queue) {
            if (Array.isArray(item)) {
              for (let value of item) {
                result.push(append(value, stash, enclose));
              }
            } else {
              for (let ele of stash) {
                if (enclose === true && typeof ele === "string")
                  ele = `{${ele}}`;
                result.push(Array.isArray(ele) ? append(item, ele, enclose) : item + ele);
              }
            }
          }
          return utils.flatten(result);
        };
        var expand2 = (ast, options = {}) => {
          let rangeLimit = options.rangeLimit === void 0 ? 1e3 : options.rangeLimit;
          let walk = (node, parent = {}) => {
            node.queue = [];
            let p = parent;
            let q = parent.queue;
            while (p.type !== "brace" && p.type !== "root" && p.parent) {
              p = p.parent;
              q = p.queue;
            }
            if (node.invalid || node.dollar) {
              q.push(append(q.pop(), stringify(node, options)));
              return;
            }
            if (node.type === "brace" && node.invalid !== true && node.nodes.length === 2) {
              q.push(append(q.pop(), ["{}"]));
              return;
            }
            if (node.nodes && node.ranges > 0) {
              let args = utils.reduce(node.nodes);
              if (utils.exceedsLimit(...args, options.step, rangeLimit)) {
                throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.");
              }
              let range = fill(...args, options);
              if (range.length === 0) {
                range = stringify(node, options);
              }
              q.push(append(q.pop(), range));
              node.nodes = [];
              return;
            }
            let enclose = utils.encloseBrace(node);
            let queue = node.queue;
            let block = node;
            while (block.type !== "brace" && block.type !== "root" && block.parent) {
              block = block.parent;
              queue = block.queue;
            }
            for (let i2 = 0; i2 < node.nodes.length; i2++) {
              let child = node.nodes[i2];
              if (child.type === "comma" && node.type === "brace") {
                if (i2 === 1)
                  queue.push("");
                queue.push("");
                continue;
              }
              if (child.type === "close") {
                q.push(append(q.pop(), queue, enclose));
                continue;
              }
              if (child.value && child.type !== "open") {
                queue.push(append(queue.pop(), child.value));
                continue;
              }
              if (child.nodes) {
                walk(child, node);
              }
            }
            return queue;
          };
          return utils.flatten(walk(ast));
        };
        module22.exports = expand2;
      }
    });
    var require_constants22 = __commonJS22({
      "node_modules/braces/lib/constants.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          MAX_LENGTH: 1024 * 64,
          CHAR_0: "0",
          CHAR_9: "9",
          CHAR_UPPERCASE_A: "A",
          CHAR_LOWERCASE_A: "a",
          CHAR_UPPERCASE_Z: "Z",
          CHAR_LOWERCASE_Z: "z",
          CHAR_LEFT_PARENTHESES: "(",
          CHAR_RIGHT_PARENTHESES: ")",
          CHAR_ASTERISK: "*",
          CHAR_AMPERSAND: "&",
          CHAR_AT: "@",
          CHAR_BACKSLASH: "\\",
          CHAR_BACKTICK: "`",
          CHAR_CARRIAGE_RETURN: "\r",
          CHAR_CIRCUMFLEX_ACCENT: "^",
          CHAR_COLON: ":",
          CHAR_COMMA: ",",
          CHAR_DOLLAR: "$",
          CHAR_DOT: ".",
          CHAR_DOUBLE_QUOTE: '"',
          CHAR_EQUAL: "=",
          CHAR_EXCLAMATION_MARK: "!",
          CHAR_FORM_FEED: "\f",
          CHAR_FORWARD_SLASH: "/",
          CHAR_HASH: "#",
          CHAR_HYPHEN_MINUS: "-",
          CHAR_LEFT_ANGLE_BRACKET: "<",
          CHAR_LEFT_CURLY_BRACE: "{",
          CHAR_LEFT_SQUARE_BRACKET: "[",
          CHAR_LINE_FEED: "\n",
          CHAR_NO_BREAK_SPACE: "\xA0",
          CHAR_PERCENT: "%",
          CHAR_PLUS: "+",
          CHAR_QUESTION_MARK: "?",
          CHAR_RIGHT_ANGLE_BRACKET: ">",
          CHAR_RIGHT_CURLY_BRACE: "}",
          CHAR_RIGHT_SQUARE_BRACKET: "]",
          CHAR_SEMICOLON: ";",
          CHAR_SINGLE_QUOTE: "'",
          CHAR_SPACE: " ",
          CHAR_TAB: "	",
          CHAR_UNDERSCORE: "_",
          CHAR_VERTICAL_LINE: "|",
          CHAR_ZERO_WIDTH_NOBREAK_SPACE: "\uFEFF"
        };
      }
    });
    var require_parse4 = __commonJS22({
      "node_modules/braces/lib/parse.js"(exports2, module22) {
        "use strict";
        var stringify = require_stringify2();
        var {
          MAX_LENGTH,
          CHAR_BACKSLASH,
          CHAR_BACKTICK,
          CHAR_COMMA,
          CHAR_DOT,
          CHAR_LEFT_PARENTHESES,
          CHAR_RIGHT_PARENTHESES,
          CHAR_LEFT_CURLY_BRACE,
          CHAR_RIGHT_CURLY_BRACE,
          CHAR_LEFT_SQUARE_BRACKET,
          CHAR_RIGHT_SQUARE_BRACKET,
          CHAR_DOUBLE_QUOTE,
          CHAR_SINGLE_QUOTE,
          CHAR_NO_BREAK_SPACE,
          CHAR_ZERO_WIDTH_NOBREAK_SPACE
        } = require_constants22();
        var parse3 = (input, options = {}) => {
          if (typeof input !== "string") {
            throw new TypeError("Expected a string");
          }
          let opts = options || {};
          let max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
          if (input.length > max) {
            throw new SyntaxError(`Input length (${input.length}), exceeds max characters (${max})`);
          }
          let ast = {
            type: "root",
            input,
            nodes: []
          };
          let stack = [ast];
          let block = ast;
          let prev = ast;
          let brackets = 0;
          let length = input.length;
          let index = 0;
          let depth = 0;
          let value;
          let memo = {};
          const advance = () => input[index++];
          const push2 = (node) => {
            if (node.type === "text" && prev.type === "dot") {
              prev.type = "text";
            }
            if (prev && prev.type === "text" && node.type === "text") {
              prev.value += node.value;
              return;
            }
            block.nodes.push(node);
            node.parent = block;
            node.prev = prev;
            prev = node;
            return node;
          };
          push2({
            type: "bos"
          });
          while (index < length) {
            block = stack[stack.length - 1];
            value = advance();
            if (value === CHAR_ZERO_WIDTH_NOBREAK_SPACE || value === CHAR_NO_BREAK_SPACE) {
              continue;
            }
            if (value === CHAR_BACKSLASH) {
              push2({
                type: "text",
                value: (options.keepEscaping ? value : "") + advance()
              });
              continue;
            }
            if (value === CHAR_RIGHT_SQUARE_BRACKET) {
              push2({
                type: "text",
                value: "\\" + value
              });
              continue;
            }
            if (value === CHAR_LEFT_SQUARE_BRACKET) {
              brackets++;
              let closed = true;
              let next;
              while (index < length && (next = advance())) {
                value += next;
                if (next === CHAR_LEFT_SQUARE_BRACKET) {
                  brackets++;
                  continue;
                }
                if (next === CHAR_BACKSLASH) {
                  value += advance();
                  continue;
                }
                if (next === CHAR_RIGHT_SQUARE_BRACKET) {
                  brackets--;
                  if (brackets === 0) {
                    break;
                  }
                }
              }
              push2({
                type: "text",
                value
              });
              continue;
            }
            if (value === CHAR_LEFT_PARENTHESES) {
              block = push2({
                type: "paren",
                nodes: []
              });
              stack.push(block);
              push2({
                type: "text",
                value
              });
              continue;
            }
            if (value === CHAR_RIGHT_PARENTHESES) {
              if (block.type !== "paren") {
                push2({
                  type: "text",
                  value
                });
                continue;
              }
              block = stack.pop();
              push2({
                type: "text",
                value
              });
              block = stack[stack.length - 1];
              continue;
            }
            if (value === CHAR_DOUBLE_QUOTE || value === CHAR_SINGLE_QUOTE || value === CHAR_BACKTICK) {
              let open = value;
              let next;
              if (options.keepQuotes !== true) {
                value = "";
              }
              while (index < length && (next = advance())) {
                if (next === CHAR_BACKSLASH) {
                  value += next + advance();
                  continue;
                }
                if (next === open) {
                  if (options.keepQuotes === true)
                    value += next;
                  break;
                }
                value += next;
              }
              push2({
                type: "text",
                value
              });
              continue;
            }
            if (value === CHAR_LEFT_CURLY_BRACE) {
              depth++;
              let dollar = prev.value && prev.value.slice(-1) === "$" || block.dollar === true;
              let brace = {
                type: "brace",
                open: true,
                close: false,
                dollar,
                depth,
                commas: 0,
                ranges: 0,
                nodes: []
              };
              block = push2(brace);
              stack.push(block);
              push2({
                type: "open",
                value
              });
              continue;
            }
            if (value === CHAR_RIGHT_CURLY_BRACE) {
              if (block.type !== "brace") {
                push2({
                  type: "text",
                  value
                });
                continue;
              }
              let type = "close";
              block = stack.pop();
              block.close = true;
              push2({
                type,
                value
              });
              depth--;
              block = stack[stack.length - 1];
              continue;
            }
            if (value === CHAR_COMMA && depth > 0) {
              if (block.ranges > 0) {
                block.ranges = 0;
                let open = block.nodes.shift();
                block.nodes = [open, {
                  type: "text",
                  value: stringify(block)
                }];
              }
              push2({
                type: "comma",
                value
              });
              block.commas++;
              continue;
            }
            if (value === CHAR_DOT && depth > 0 && block.commas === 0) {
              let siblings = block.nodes;
              if (depth === 0 || siblings.length === 0) {
                push2({
                  type: "text",
                  value
                });
                continue;
              }
              if (prev.type === "dot") {
                block.range = [];
                prev.value += value;
                prev.type = "range";
                if (block.nodes.length !== 3 && block.nodes.length !== 5) {
                  block.invalid = true;
                  block.ranges = 0;
                  prev.type = "text";
                  continue;
                }
                block.ranges++;
                block.args = [];
                continue;
              }
              if (prev.type === "range") {
                siblings.pop();
                let before = siblings[siblings.length - 1];
                before.value += prev.value + value;
                prev = before;
                block.ranges--;
                continue;
              }
              push2({
                type: "dot",
                value
              });
              continue;
            }
            push2({
              type: "text",
              value
            });
          }
          do {
            block = stack.pop();
            if (block.type !== "root") {
              block.nodes.forEach((node) => {
                if (!node.nodes) {
                  if (node.type === "open")
                    node.isOpen = true;
                  if (node.type === "close")
                    node.isClose = true;
                  if (!node.nodes)
                    node.type = "text";
                  node.invalid = true;
                }
              });
              let parent = stack[stack.length - 1];
              let index2 = parent.nodes.indexOf(block);
              parent.nodes.splice(index2, 1, ...block.nodes);
            }
          } while (stack.length > 0);
          push2({
            type: "eos"
          });
          return ast;
        };
        module22.exports = parse3;
      }
    });
    var require_braces2 = __commonJS22({
      "node_modules/braces/index.js"(exports2, module22) {
        "use strict";
        var stringify = require_stringify2();
        var compile = require_compile2();
        var expand2 = require_expand2();
        var parse3 = require_parse4();
        var braces = (input, options = {}) => {
          let output = [];
          if (Array.isArray(input)) {
            for (let pattern of input) {
              let result = braces.create(pattern, options);
              if (Array.isArray(result)) {
                output.push(...result);
              } else {
                output.push(result);
              }
            }
          } else {
            output = [].concat(braces.create(input, options));
          }
          if (options && options.expand === true && options.nodupes === true) {
            output = [...new Set(output)];
          }
          return output;
        };
        braces.parse = (input, options = {}) => parse3(input, options);
        braces.stringify = (input, options = {}) => {
          if (typeof input === "string") {
            return stringify(braces.parse(input, options), options);
          }
          return stringify(input, options);
        };
        braces.compile = (input, options = {}) => {
          if (typeof input === "string") {
            input = braces.parse(input, options);
          }
          return compile(input, options);
        };
        braces.expand = (input, options = {}) => {
          if (typeof input === "string") {
            input = braces.parse(input, options);
          }
          let result = expand2(input, options);
          if (options.noempty === true) {
            result = result.filter(Boolean);
          }
          if (options.nodupes === true) {
            result = [...new Set(result)];
          }
          return result;
        };
        braces.create = (input, options = {}) => {
          if (input === "" || input.length < 3) {
            return [input];
          }
          return options.expand !== true ? braces.compile(input, options) : braces.expand(input, options);
        };
        module22.exports = braces;
      }
    });
    var require_constants32 = __commonJS22({
      "node_modules/picomatch/lib/constants.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var WIN_SLASH = "\\\\/";
        var WIN_NO_SLASH = `[^${WIN_SLASH}]`;
        var DOT_LITERAL = "\\.";
        var PLUS_LITERAL = "\\+";
        var QMARK_LITERAL = "\\?";
        var SLASH_LITERAL = "\\/";
        var ONE_CHAR = "(?=.)";
        var QMARK = "[^/]";
        var END_ANCHOR = `(?:${SLASH_LITERAL}|$)`;
        var START_ANCHOR = `(?:^|${SLASH_LITERAL})`;
        var DOTS_SLASH = `${DOT_LITERAL}{1,2}${END_ANCHOR}`;
        var NO_DOT = `(?!${DOT_LITERAL})`;
        var NO_DOTS = `(?!${START_ANCHOR}${DOTS_SLASH})`;
        var NO_DOT_SLASH = `(?!${DOT_LITERAL}{0,1}${END_ANCHOR})`;
        var NO_DOTS_SLASH = `(?!${DOTS_SLASH})`;
        var QMARK_NO_DOT = `[^.${SLASH_LITERAL}]`;
        var STAR = `${QMARK}*?`;
        var POSIX_CHARS = {
          DOT_LITERAL,
          PLUS_LITERAL,
          QMARK_LITERAL,
          SLASH_LITERAL,
          ONE_CHAR,
          QMARK,
          END_ANCHOR,
          DOTS_SLASH,
          NO_DOT,
          NO_DOTS,
          NO_DOT_SLASH,
          NO_DOTS_SLASH,
          QMARK_NO_DOT,
          STAR,
          START_ANCHOR
        };
        var WINDOWS_CHARS = Object.assign(Object.assign({}, POSIX_CHARS), {}, {
          SLASH_LITERAL: `[${WIN_SLASH}]`,
          QMARK: WIN_NO_SLASH,
          STAR: `${WIN_NO_SLASH}*?`,
          DOTS_SLASH: `${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$)`,
          NO_DOT: `(?!${DOT_LITERAL})`,
          NO_DOTS: `(?!(?:^|[${WIN_SLASH}])${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
          NO_DOT_SLASH: `(?!${DOT_LITERAL}{0,1}(?:[${WIN_SLASH}]|$))`,
          NO_DOTS_SLASH: `(?!${DOT_LITERAL}{1,2}(?:[${WIN_SLASH}]|$))`,
          QMARK_NO_DOT: `[^.${WIN_SLASH}]`,
          START_ANCHOR: `(?:^|[${WIN_SLASH}])`,
          END_ANCHOR: `(?:[${WIN_SLASH}]|$)`
        });
        var POSIX_REGEX_SOURCE = {
          alnum: "a-zA-Z0-9",
          alpha: "a-zA-Z",
          ascii: "\\x00-\\x7F",
          blank: " \\t",
          cntrl: "\\x00-\\x1F\\x7F",
          digit: "0-9",
          graph: "\\x21-\\x7E",
          lower: "a-z",
          print: "\\x20-\\x7E ",
          punct: "\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",
          space: " \\t\\r\\n\\v\\f",
          upper: "A-Z",
          word: "A-Za-z0-9_",
          xdigit: "A-Fa-f0-9"
        };
        module22.exports = {
          MAX_LENGTH: 1024 * 64,
          POSIX_REGEX_SOURCE,
          REGEX_BACKSLASH: /\\(?![*+?^${}(|)[\]])/g,
          REGEX_NON_SPECIAL_CHARS: /^[^@![\].,$*+?^{}()|\\/]+/,
          REGEX_SPECIAL_CHARS: /[-*+?.^${}(|)[\]]/,
          REGEX_SPECIAL_CHARS_BACKREF: /(\\?)((\W)(\3*))/g,
          REGEX_SPECIAL_CHARS_GLOBAL: /([-*+?.^${}(|)[\]])/g,
          REGEX_REMOVE_BACKSLASH: /(?:\[.*?[^\\]\]|\\(?=.))/g,
          REPLACEMENTS: {
            "***": "*",
            "**/**": "**",
            "**/**/**": "**"
          },
          CHAR_0: 48,
          CHAR_9: 57,
          CHAR_UPPERCASE_A: 65,
          CHAR_LOWERCASE_A: 97,
          CHAR_UPPERCASE_Z: 90,
          CHAR_LOWERCASE_Z: 122,
          CHAR_LEFT_PARENTHESES: 40,
          CHAR_RIGHT_PARENTHESES: 41,
          CHAR_ASTERISK: 42,
          CHAR_AMPERSAND: 38,
          CHAR_AT: 64,
          CHAR_BACKWARD_SLASH: 92,
          CHAR_CARRIAGE_RETURN: 13,
          CHAR_CIRCUMFLEX_ACCENT: 94,
          CHAR_COLON: 58,
          CHAR_COMMA: 44,
          CHAR_DOT: 46,
          CHAR_DOUBLE_QUOTE: 34,
          CHAR_EQUAL: 61,
          CHAR_EXCLAMATION_MARK: 33,
          CHAR_FORM_FEED: 12,
          CHAR_FORWARD_SLASH: 47,
          CHAR_GRAVE_ACCENT: 96,
          CHAR_HASH: 35,
          CHAR_HYPHEN_MINUS: 45,
          CHAR_LEFT_ANGLE_BRACKET: 60,
          CHAR_LEFT_CURLY_BRACE: 123,
          CHAR_LEFT_SQUARE_BRACKET: 91,
          CHAR_LINE_FEED: 10,
          CHAR_NO_BREAK_SPACE: 160,
          CHAR_PERCENT: 37,
          CHAR_PLUS: 43,
          CHAR_QUESTION_MARK: 63,
          CHAR_RIGHT_ANGLE_BRACKET: 62,
          CHAR_RIGHT_CURLY_BRACE: 125,
          CHAR_RIGHT_SQUARE_BRACKET: 93,
          CHAR_SEMICOLON: 59,
          CHAR_SINGLE_QUOTE: 39,
          CHAR_SPACE: 32,
          CHAR_TAB: 9,
          CHAR_UNDERSCORE: 95,
          CHAR_VERTICAL_LINE: 124,
          CHAR_ZERO_WIDTH_NOBREAK_SPACE: 65279,
          SEP: path4.sep,
          extglobChars(chars) {
            return {
              "!": {
                type: "negate",
                open: "(?:(?!(?:",
                close: `))${chars.STAR})`
              },
              "?": {
                type: "qmark",
                open: "(?:",
                close: ")?"
              },
              "+": {
                type: "plus",
                open: "(?:",
                close: ")+"
              },
              "*": {
                type: "star",
                open: "(?:",
                close: ")*"
              },
              "@": {
                type: "at",
                open: "(?:",
                close: ")"
              }
            };
          },
          globChars(win32) {
            return win32 === true ? WINDOWS_CHARS : POSIX_CHARS;
          }
        };
      }
    });
    var require_utils32 = __commonJS22({
      "node_modules/picomatch/lib/utils.js"(exports2) {
        "use strict";
        var path4 = require("path");
        var win32 = process.platform === "win32";
        var {
          REGEX_BACKSLASH,
          REGEX_REMOVE_BACKSLASH,
          REGEX_SPECIAL_CHARS,
          REGEX_SPECIAL_CHARS_GLOBAL
        } = require_constants32();
        exports2.isObject = (val) => val !== null && typeof val === "object" && !Array.isArray(val);
        exports2.hasRegexChars = (str) => REGEX_SPECIAL_CHARS.test(str);
        exports2.isRegexChar = (str) => str.length === 1 && exports2.hasRegexChars(str);
        exports2.escapeRegex = (str) => str.replace(REGEX_SPECIAL_CHARS_GLOBAL, "\\$1");
        exports2.toPosixSlashes = (str) => str.replace(REGEX_BACKSLASH, "/");
        exports2.removeBackslashes = (str) => {
          return str.replace(REGEX_REMOVE_BACKSLASH, (match) => {
            return match === "\\" ? "" : match;
          });
        };
        exports2.supportsLookbehinds = () => {
          const segs = process.version.slice(1).split(".").map(Number);
          if (segs.length === 3 && segs[0] >= 9 || segs[0] === 8 && segs[1] >= 10) {
            return true;
          }
          return false;
        };
        exports2.isWindows = (options) => {
          if (options && typeof options.windows === "boolean") {
            return options.windows;
          }
          return win32 === true || path4.sep === "\\";
        };
        exports2.escapeLast = (input, char, lastIdx) => {
          const idx = input.lastIndexOf(char, lastIdx);
          if (idx === -1)
            return input;
          if (input[idx - 1] === "\\")
            return exports2.escapeLast(input, char, idx - 1);
          return `${input.slice(0, idx)}\\${input.slice(idx)}`;
        };
        exports2.removePrefix = (input, state = {}) => {
          let output = input;
          if (output.startsWith("./")) {
            output = output.slice(2);
            state.prefix = "./";
          }
          return output;
        };
        exports2.wrapOutput = (input, state = {}, options = {}) => {
          const prepend = options.contains ? "" : "^";
          const append = options.contains ? "" : "$";
          let output = `${prepend}(?:${input})${append}`;
          if (state.negated === true) {
            output = `(?:^(?!${output}).*$)`;
          }
          return output;
        };
      }
    });
    var require_scan2 = __commonJS22({
      "node_modules/picomatch/lib/scan.js"(exports2, module22) {
        "use strict";
        var utils = require_utils32();
        var {
          CHAR_ASTERISK,
          CHAR_AT,
          CHAR_BACKWARD_SLASH,
          CHAR_COMMA,
          CHAR_DOT,
          CHAR_EXCLAMATION_MARK,
          CHAR_FORWARD_SLASH,
          CHAR_LEFT_CURLY_BRACE,
          CHAR_LEFT_PARENTHESES,
          CHAR_LEFT_SQUARE_BRACKET,
          CHAR_PLUS,
          CHAR_QUESTION_MARK,
          CHAR_RIGHT_CURLY_BRACE,
          CHAR_RIGHT_PARENTHESES,
          CHAR_RIGHT_SQUARE_BRACKET
        } = require_constants32();
        var isPathSeparator = (code) => {
          return code === CHAR_FORWARD_SLASH || code === CHAR_BACKWARD_SLASH;
        };
        var depth = (token) => {
          if (token.isPrefix !== true) {
            token.depth = token.isGlobstar ? Infinity : 1;
          }
        };
        var scan = (input, options) => {
          const opts = options || {};
          const length = input.length - 1;
          const scanToEnd = opts.parts === true || opts.scanToEnd === true;
          const slashes = [];
          const tokens = [];
          const parts = [];
          let str = input;
          let index = -1;
          let start = 0;
          let lastIndex = 0;
          let isBrace = false;
          let isBracket = false;
          let isGlob = false;
          let isExtglob = false;
          let isGlobstar = false;
          let braceEscaped = false;
          let backslashes = false;
          let negated = false;
          let negatedExtglob = false;
          let finished = false;
          let braces = 0;
          let prev;
          let code;
          let token = {
            value: "",
            depth: 0,
            isGlob: false
          };
          const eos = () => index >= length;
          const peek = () => str.charCodeAt(index + 1);
          const advance = () => {
            prev = code;
            return str.charCodeAt(++index);
          };
          while (index < length) {
            code = advance();
            let next;
            if (code === CHAR_BACKWARD_SLASH) {
              backslashes = token.backslashes = true;
              code = advance();
              if (code === CHAR_LEFT_CURLY_BRACE) {
                braceEscaped = true;
              }
              continue;
            }
            if (braceEscaped === true || code === CHAR_LEFT_CURLY_BRACE) {
              braces++;
              while (eos() !== true && (code = advance())) {
                if (code === CHAR_BACKWARD_SLASH) {
                  backslashes = token.backslashes = true;
                  advance();
                  continue;
                }
                if (code === CHAR_LEFT_CURLY_BRACE) {
                  braces++;
                  continue;
                }
                if (braceEscaped !== true && code === CHAR_DOT && (code = advance()) === CHAR_DOT) {
                  isBrace = token.isBrace = true;
                  isGlob = token.isGlob = true;
                  finished = true;
                  if (scanToEnd === true) {
                    continue;
                  }
                  break;
                }
                if (braceEscaped !== true && code === CHAR_COMMA) {
                  isBrace = token.isBrace = true;
                  isGlob = token.isGlob = true;
                  finished = true;
                  if (scanToEnd === true) {
                    continue;
                  }
                  break;
                }
                if (code === CHAR_RIGHT_CURLY_BRACE) {
                  braces--;
                  if (braces === 0) {
                    braceEscaped = false;
                    isBrace = token.isBrace = true;
                    finished = true;
                    break;
                  }
                }
              }
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (code === CHAR_FORWARD_SLASH) {
              slashes.push(index);
              tokens.push(token);
              token = {
                value: "",
                depth: 0,
                isGlob: false
              };
              if (finished === true)
                continue;
              if (prev === CHAR_DOT && index === start + 1) {
                start += 2;
                continue;
              }
              lastIndex = index + 1;
              continue;
            }
            if (opts.noext !== true) {
              const isExtglobChar = code === CHAR_PLUS || code === CHAR_AT || code === CHAR_ASTERISK || code === CHAR_QUESTION_MARK || code === CHAR_EXCLAMATION_MARK;
              if (isExtglobChar === true && peek() === CHAR_LEFT_PARENTHESES) {
                isGlob = token.isGlob = true;
                isExtglob = token.isExtglob = true;
                finished = true;
                if (code === CHAR_EXCLAMATION_MARK && index === start) {
                  negatedExtglob = true;
                }
                if (scanToEnd === true) {
                  while (eos() !== true && (code = advance())) {
                    if (code === CHAR_BACKWARD_SLASH) {
                      backslashes = token.backslashes = true;
                      code = advance();
                      continue;
                    }
                    if (code === CHAR_RIGHT_PARENTHESES) {
                      isGlob = token.isGlob = true;
                      finished = true;
                      break;
                    }
                  }
                  continue;
                }
                break;
              }
            }
            if (code === CHAR_ASTERISK) {
              if (prev === CHAR_ASTERISK)
                isGlobstar = token.isGlobstar = true;
              isGlob = token.isGlob = true;
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (code === CHAR_QUESTION_MARK) {
              isGlob = token.isGlob = true;
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (code === CHAR_LEFT_SQUARE_BRACKET) {
              while (eos() !== true && (next = advance())) {
                if (next === CHAR_BACKWARD_SLASH) {
                  backslashes = token.backslashes = true;
                  advance();
                  continue;
                }
                if (next === CHAR_RIGHT_SQUARE_BRACKET) {
                  isBracket = token.isBracket = true;
                  isGlob = token.isGlob = true;
                  finished = true;
                  break;
                }
              }
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
            if (opts.nonegate !== true && code === CHAR_EXCLAMATION_MARK && index === start) {
              negated = token.negated = true;
              start++;
              continue;
            }
            if (opts.noparen !== true && code === CHAR_LEFT_PARENTHESES) {
              isGlob = token.isGlob = true;
              if (scanToEnd === true) {
                while (eos() !== true && (code = advance())) {
                  if (code === CHAR_LEFT_PARENTHESES) {
                    backslashes = token.backslashes = true;
                    code = advance();
                    continue;
                  }
                  if (code === CHAR_RIGHT_PARENTHESES) {
                    finished = true;
                    break;
                  }
                }
                continue;
              }
              break;
            }
            if (isGlob === true) {
              finished = true;
              if (scanToEnd === true) {
                continue;
              }
              break;
            }
          }
          if (opts.noext === true) {
            isExtglob = false;
            isGlob = false;
          }
          let base = str;
          let prefix2 = "";
          let glob = "";
          if (start > 0) {
            prefix2 = str.slice(0, start);
            str = str.slice(start);
            lastIndex -= start;
          }
          if (base && isGlob === true && lastIndex > 0) {
            base = str.slice(0, lastIndex);
            glob = str.slice(lastIndex);
          } else if (isGlob === true) {
            base = "";
            glob = str;
          } else {
            base = str;
          }
          if (base && base !== "" && base !== "/" && base !== str) {
            if (isPathSeparator(base.charCodeAt(base.length - 1))) {
              base = base.slice(0, -1);
            }
          }
          if (opts.unescape === true) {
            if (glob)
              glob = utils.removeBackslashes(glob);
            if (base && backslashes === true) {
              base = utils.removeBackslashes(base);
            }
          }
          const state = {
            prefix: prefix2,
            input,
            start,
            base,
            glob,
            isBrace,
            isBracket,
            isGlob,
            isExtglob,
            isGlobstar,
            negated,
            negatedExtglob
          };
          if (opts.tokens === true) {
            state.maxDepth = 0;
            if (!isPathSeparator(code)) {
              tokens.push(token);
            }
            state.tokens = tokens;
          }
          if (opts.parts === true || opts.tokens === true) {
            let prevIndex;
            for (let idx = 0; idx < slashes.length; idx++) {
              const n = prevIndex ? prevIndex + 1 : start;
              const i2 = slashes[idx];
              const value = input.slice(n, i2);
              if (opts.tokens) {
                if (idx === 0 && start !== 0) {
                  tokens[idx].isPrefix = true;
                  tokens[idx].value = prefix2;
                } else {
                  tokens[idx].value = value;
                }
                depth(tokens[idx]);
                state.maxDepth += tokens[idx].depth;
              }
              if (idx !== 0 || value !== "") {
                parts.push(value);
              }
              prevIndex = i2;
            }
            if (prevIndex && prevIndex + 1 < input.length) {
              const value = input.slice(prevIndex + 1);
              parts.push(value);
              if (opts.tokens) {
                tokens[tokens.length - 1].value = value;
                depth(tokens[tokens.length - 1]);
                state.maxDepth += tokens[tokens.length - 1].depth;
              }
            }
            state.slashes = slashes;
            state.parts = parts;
          }
          return state;
        };
        module22.exports = scan;
      }
    });
    var require_parse22 = __commonJS22({
      "node_modules/picomatch/lib/parse.js"(exports2, module22) {
        "use strict";
        var constants = require_constants32();
        var utils = require_utils32();
        var {
          MAX_LENGTH,
          POSIX_REGEX_SOURCE,
          REGEX_NON_SPECIAL_CHARS,
          REGEX_SPECIAL_CHARS_BACKREF,
          REPLACEMENTS
        } = constants;
        var expandRange = (args, options) => {
          if (typeof options.expandRange === "function") {
            return options.expandRange(...args, options);
          }
          args.sort();
          const value = `[${args.join("-")}]`;
          try {
            new RegExp(value);
          } catch (ex) {
            return args.map((v) => utils.escapeRegex(v)).join("..");
          }
          return value;
        };
        var syntaxError = (type, char) => {
          return `Missing ${type}: "${char}" - use "\\\\${char}" to match literal characters`;
        };
        var parse3 = (input, options) => {
          if (typeof input !== "string") {
            throw new TypeError("Expected a string");
          }
          input = REPLACEMENTS[input] || input;
          const opts = Object.assign({}, options);
          const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
          let len = input.length;
          if (len > max) {
            throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
          }
          const bos = {
            type: "bos",
            value: "",
            output: opts.prepend || ""
          };
          const tokens = [bos];
          const capture = opts.capture ? "" : "?:";
          const win32 = utils.isWindows(options);
          const PLATFORM_CHARS = constants.globChars(win32);
          const EXTGLOB_CHARS = constants.extglobChars(PLATFORM_CHARS);
          const {
            DOT_LITERAL,
            PLUS_LITERAL,
            SLASH_LITERAL,
            ONE_CHAR,
            DOTS_SLASH,
            NO_DOT,
            NO_DOT_SLASH,
            NO_DOTS_SLASH,
            QMARK,
            QMARK_NO_DOT,
            STAR,
            START_ANCHOR
          } = PLATFORM_CHARS;
          const globstar = (opts2) => {
            return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
          };
          const nodot = opts.dot ? "" : NO_DOT;
          const qmarkNoDot = opts.dot ? QMARK : QMARK_NO_DOT;
          let star = opts.bash === true ? globstar(opts) : STAR;
          if (opts.capture) {
            star = `(${star})`;
          }
          if (typeof opts.noext === "boolean") {
            opts.noextglob = opts.noext;
          }
          const state = {
            input,
            index: -1,
            start: 0,
            dot: opts.dot === true,
            consumed: "",
            output: "",
            prefix: "",
            backtrack: false,
            negated: false,
            brackets: 0,
            braces: 0,
            parens: 0,
            quotes: 0,
            globstar: false,
            tokens
          };
          input = utils.removePrefix(input, state);
          len = input.length;
          const extglobs = [];
          const braces = [];
          const stack = [];
          let prev = bos;
          let value;
          const eos = () => state.index === len - 1;
          const peek = state.peek = (n = 1) => input[state.index + n];
          const advance = state.advance = () => input[++state.index] || "";
          const remaining = () => input.slice(state.index + 1);
          const consume = (value2 = "", num = 0) => {
            state.consumed += value2;
            state.index += num;
          };
          const append = (token) => {
            state.output += token.output != null ? token.output : token.value;
            consume(token.value);
          };
          const negate = () => {
            let count = 1;
            while (peek() === "!" && (peek(2) !== "(" || peek(3) === "?")) {
              advance();
              state.start++;
              count++;
            }
            if (count % 2 === 0) {
              return false;
            }
            state.negated = true;
            state.start++;
            return true;
          };
          const increment = (type) => {
            state[type]++;
            stack.push(type);
          };
          const decrement = (type) => {
            state[type]--;
            stack.pop();
          };
          const push2 = (tok) => {
            if (prev.type === "globstar") {
              const isBrace = state.braces > 0 && (tok.type === "comma" || tok.type === "brace");
              const isExtglob = tok.extglob === true || extglobs.length && (tok.type === "pipe" || tok.type === "paren");
              if (tok.type !== "slash" && tok.type !== "paren" && !isBrace && !isExtglob) {
                state.output = state.output.slice(0, -prev.output.length);
                prev.type = "star";
                prev.value = "*";
                prev.output = star;
                state.output += prev.output;
              }
            }
            if (extglobs.length && tok.type !== "paren") {
              extglobs[extglobs.length - 1].inner += tok.value;
            }
            if (tok.value || tok.output)
              append(tok);
            if (prev && prev.type === "text" && tok.type === "text") {
              prev.value += tok.value;
              prev.output = (prev.output || "") + tok.value;
              return;
            }
            tok.prev = prev;
            tokens.push(tok);
            prev = tok;
          };
          const extglobOpen = (type, value2) => {
            const token = Object.assign(Object.assign({}, EXTGLOB_CHARS[value2]), {}, {
              conditions: 1,
              inner: ""
            });
            token.prev = prev;
            token.parens = state.parens;
            token.output = state.output;
            const output = (opts.capture ? "(" : "") + token.open;
            increment("parens");
            push2({
              type,
              value: value2,
              output: state.output ? "" : ONE_CHAR
            });
            push2({
              type: "paren",
              extglob: true,
              value: advance(),
              output
            });
            extglobs.push(token);
          };
          const extglobClose = (token) => {
            let output = token.close + (opts.capture ? ")" : "");
            let rest;
            if (token.type === "negate") {
              let extglobStar = star;
              if (token.inner && token.inner.length > 1 && token.inner.includes("/")) {
                extglobStar = globstar(opts);
              }
              if (extglobStar !== star || eos() || /^\)+$/.test(remaining())) {
                output = token.close = `)$))${extglobStar}`;
              }
              if (token.inner.includes("*") && (rest = remaining()) && /^\.[^\\/.]+$/.test(rest)) {
                const expression = parse3(rest, Object.assign(Object.assign({}, options), {}, {
                  fastpaths: false
                })).output;
                output = token.close = `)${expression})${extglobStar})`;
              }
              if (token.prev.type === "bos") {
                state.negatedExtglob = true;
              }
            }
            push2({
              type: "paren",
              extglob: true,
              value,
              output
            });
            decrement("parens");
          };
          if (opts.fastpaths !== false && !/(^[*!]|[/()[\]{}"])/.test(input)) {
            let backslashes = false;
            let output = input.replace(REGEX_SPECIAL_CHARS_BACKREF, (m2, esc, chars, first, rest, index) => {
              if (first === "\\") {
                backslashes = true;
                return m2;
              }
              if (first === "?") {
                if (esc) {
                  return esc + first + (rest ? QMARK.repeat(rest.length) : "");
                }
                if (index === 0) {
                  return qmarkNoDot + (rest ? QMARK.repeat(rest.length) : "");
                }
                return QMARK.repeat(chars.length);
              }
              if (first === ".") {
                return DOT_LITERAL.repeat(chars.length);
              }
              if (first === "*") {
                if (esc) {
                  return esc + first + (rest ? star : "");
                }
                return star;
              }
              return esc ? m2 : `\\${m2}`;
            });
            if (backslashes === true) {
              if (opts.unescape === true) {
                output = output.replace(/\\/g, "");
              } else {
                output = output.replace(/\\+/g, (m2) => {
                  return m2.length % 2 === 0 ? "\\\\" : m2 ? "\\" : "";
                });
              }
            }
            if (output === input && opts.contains === true) {
              state.output = input;
              return state;
            }
            state.output = utils.wrapOutput(output, state, options);
            return state;
          }
          while (!eos()) {
            value = advance();
            if (value === "\0") {
              continue;
            }
            if (value === "\\") {
              const next = peek();
              if (next === "/" && opts.bash !== true) {
                continue;
              }
              if (next === "." || next === ";") {
                continue;
              }
              if (!next) {
                value += "\\";
                push2({
                  type: "text",
                  value
                });
                continue;
              }
              const match = /^\\+/.exec(remaining());
              let slashes = 0;
              if (match && match[0].length > 2) {
                slashes = match[0].length;
                state.index += slashes;
                if (slashes % 2 !== 0) {
                  value += "\\";
                }
              }
              if (opts.unescape === true) {
                value = advance();
              } else {
                value += advance();
              }
              if (state.brackets === 0) {
                push2({
                  type: "text",
                  value
                });
                continue;
              }
            }
            if (state.brackets > 0 && (value !== "]" || prev.value === "[" || prev.value === "[^")) {
              if (opts.posix !== false && value === ":") {
                const inner = prev.value.slice(1);
                if (inner.includes("[")) {
                  prev.posix = true;
                  if (inner.includes(":")) {
                    const idx = prev.value.lastIndexOf("[");
                    const pre = prev.value.slice(0, idx);
                    const rest2 = prev.value.slice(idx + 2);
                    const posix = POSIX_REGEX_SOURCE[rest2];
                    if (posix) {
                      prev.value = pre + posix;
                      state.backtrack = true;
                      advance();
                      if (!bos.output && tokens.indexOf(prev) === 1) {
                        bos.output = ONE_CHAR;
                      }
                      continue;
                    }
                  }
                }
              }
              if (value === "[" && peek() !== ":" || value === "-" && peek() === "]") {
                value = `\\${value}`;
              }
              if (value === "]" && (prev.value === "[" || prev.value === "[^")) {
                value = `\\${value}`;
              }
              if (opts.posix === true && value === "!" && prev.value === "[") {
                value = "^";
              }
              prev.value += value;
              append({
                value
              });
              continue;
            }
            if (state.quotes === 1 && value !== '"') {
              value = utils.escapeRegex(value);
              prev.value += value;
              append({
                value
              });
              continue;
            }
            if (value === '"') {
              state.quotes = state.quotes === 1 ? 0 : 1;
              if (opts.keepQuotes === true) {
                push2({
                  type: "text",
                  value
                });
              }
              continue;
            }
            if (value === "(") {
              increment("parens");
              push2({
                type: "paren",
                value
              });
              continue;
            }
            if (value === ")") {
              if (state.parens === 0 && opts.strictBrackets === true) {
                throw new SyntaxError(syntaxError("opening", "("));
              }
              const extglob = extglobs[extglobs.length - 1];
              if (extglob && state.parens === extglob.parens + 1) {
                extglobClose(extglobs.pop());
                continue;
              }
              push2({
                type: "paren",
                value,
                output: state.parens ? ")" : "\\)"
              });
              decrement("parens");
              continue;
            }
            if (value === "[") {
              if (opts.nobracket === true || !remaining().includes("]")) {
                if (opts.nobracket !== true && opts.strictBrackets === true) {
                  throw new SyntaxError(syntaxError("closing", "]"));
                }
                value = `\\${value}`;
              } else {
                increment("brackets");
              }
              push2({
                type: "bracket",
                value
              });
              continue;
            }
            if (value === "]") {
              if (opts.nobracket === true || prev && prev.type === "bracket" && prev.value.length === 1) {
                push2({
                  type: "text",
                  value,
                  output: `\\${value}`
                });
                continue;
              }
              if (state.brackets === 0) {
                if (opts.strictBrackets === true) {
                  throw new SyntaxError(syntaxError("opening", "["));
                }
                push2({
                  type: "text",
                  value,
                  output: `\\${value}`
                });
                continue;
              }
              decrement("brackets");
              const prevValue = prev.value.slice(1);
              if (prev.posix !== true && prevValue[0] === "^" && !prevValue.includes("/")) {
                value = `/${value}`;
              }
              prev.value += value;
              append({
                value
              });
              if (opts.literalBrackets === false || utils.hasRegexChars(prevValue)) {
                continue;
              }
              const escaped = utils.escapeRegex(prev.value);
              state.output = state.output.slice(0, -prev.value.length);
              if (opts.literalBrackets === true) {
                state.output += escaped;
                prev.value = escaped;
                continue;
              }
              prev.value = `(${capture}${escaped}|${prev.value})`;
              state.output += prev.value;
              continue;
            }
            if (value === "{" && opts.nobrace !== true) {
              increment("braces");
              const open = {
                type: "brace",
                value,
                output: "(",
                outputIndex: state.output.length,
                tokensIndex: state.tokens.length
              };
              braces.push(open);
              push2(open);
              continue;
            }
            if (value === "}") {
              const brace = braces[braces.length - 1];
              if (opts.nobrace === true || !brace) {
                push2({
                  type: "text",
                  value,
                  output: value
                });
                continue;
              }
              let output = ")";
              if (brace.dots === true) {
                const arr = tokens.slice();
                const range = [];
                for (let i2 = arr.length - 1; i2 >= 0; i2--) {
                  tokens.pop();
                  if (arr[i2].type === "brace") {
                    break;
                  }
                  if (arr[i2].type !== "dots") {
                    range.unshift(arr[i2].value);
                  }
                }
                output = expandRange(range, opts);
                state.backtrack = true;
              }
              if (brace.comma !== true && brace.dots !== true) {
                const out = state.output.slice(0, brace.outputIndex);
                const toks = state.tokens.slice(brace.tokensIndex);
                brace.value = brace.output = "\\{";
                value = output = "\\}";
                state.output = out;
                for (const t2 of toks) {
                  state.output += t2.output || t2.value;
                }
              }
              push2({
                type: "brace",
                value,
                output
              });
              decrement("braces");
              braces.pop();
              continue;
            }
            if (value === "|") {
              if (extglobs.length > 0) {
                extglobs[extglobs.length - 1].conditions++;
              }
              push2({
                type: "text",
                value
              });
              continue;
            }
            if (value === ",") {
              let output = value;
              const brace = braces[braces.length - 1];
              if (brace && stack[stack.length - 1] === "braces") {
                brace.comma = true;
                output = "|";
              }
              push2({
                type: "comma",
                value,
                output
              });
              continue;
            }
            if (value === "/") {
              if (prev.type === "dot" && state.index === state.start + 1) {
                state.start = state.index + 1;
                state.consumed = "";
                state.output = "";
                tokens.pop();
                prev = bos;
                continue;
              }
              push2({
                type: "slash",
                value,
                output: SLASH_LITERAL
              });
              continue;
            }
            if (value === ".") {
              if (state.braces > 0 && prev.type === "dot") {
                if (prev.value === ".")
                  prev.output = DOT_LITERAL;
                const brace = braces[braces.length - 1];
                prev.type = "dots";
                prev.output += value;
                prev.value += value;
                brace.dots = true;
                continue;
              }
              if (state.braces + state.parens === 0 && prev.type !== "bos" && prev.type !== "slash") {
                push2({
                  type: "text",
                  value,
                  output: DOT_LITERAL
                });
                continue;
              }
              push2({
                type: "dot",
                value,
                output: DOT_LITERAL
              });
              continue;
            }
            if (value === "?") {
              const isGroup = prev && prev.value === "(";
              if (!isGroup && opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
                extglobOpen("qmark", value);
                continue;
              }
              if (prev && prev.type === "paren") {
                const next = peek();
                let output = value;
                if (next === "<" && !utils.supportsLookbehinds()) {
                  throw new Error("Node.js v10 or higher is required for regex lookbehinds");
                }
                if (prev.value === "(" && !/[!=<:]/.test(next) || next === "<" && !/<([!=]|\w+>)/.test(remaining())) {
                  output = `\\${value}`;
                }
                push2({
                  type: "text",
                  value,
                  output
                });
                continue;
              }
              if (opts.dot !== true && (prev.type === "slash" || prev.type === "bos")) {
                push2({
                  type: "qmark",
                  value,
                  output: QMARK_NO_DOT
                });
                continue;
              }
              push2({
                type: "qmark",
                value,
                output: QMARK
              });
              continue;
            }
            if (value === "!") {
              if (opts.noextglob !== true && peek() === "(") {
                if (peek(2) !== "?" || !/[!=<:]/.test(peek(3))) {
                  extglobOpen("negate", value);
                  continue;
                }
              }
              if (opts.nonegate !== true && state.index === 0) {
                negate();
                continue;
              }
            }
            if (value === "+") {
              if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
                extglobOpen("plus", value);
                continue;
              }
              if (prev && prev.value === "(" || opts.regex === false) {
                push2({
                  type: "plus",
                  value,
                  output: PLUS_LITERAL
                });
                continue;
              }
              if (prev && (prev.type === "bracket" || prev.type === "paren" || prev.type === "brace") || state.parens > 0) {
                push2({
                  type: "plus",
                  value
                });
                continue;
              }
              push2({
                type: "plus",
                value: PLUS_LITERAL
              });
              continue;
            }
            if (value === "@") {
              if (opts.noextglob !== true && peek() === "(" && peek(2) !== "?") {
                push2({
                  type: "at",
                  extglob: true,
                  value,
                  output: ""
                });
                continue;
              }
              push2({
                type: "text",
                value
              });
              continue;
            }
            if (value !== "*") {
              if (value === "$" || value === "^") {
                value = `\\${value}`;
              }
              const match = REGEX_NON_SPECIAL_CHARS.exec(remaining());
              if (match) {
                value += match[0];
                state.index += match[0].length;
              }
              push2({
                type: "text",
                value
              });
              continue;
            }
            if (prev && (prev.type === "globstar" || prev.star === true)) {
              prev.type = "star";
              prev.star = true;
              prev.value += value;
              prev.output = star;
              state.backtrack = true;
              state.globstar = true;
              consume(value);
              continue;
            }
            let rest = remaining();
            if (opts.noextglob !== true && /^\([^?]/.test(rest)) {
              extglobOpen("star", value);
              continue;
            }
            if (prev.type === "star") {
              if (opts.noglobstar === true) {
                consume(value);
                continue;
              }
              const prior = prev.prev;
              const before = prior.prev;
              const isStart = prior.type === "slash" || prior.type === "bos";
              const afterStar = before && (before.type === "star" || before.type === "globstar");
              if (opts.bash === true && (!isStart || rest[0] && rest[0] !== "/")) {
                push2({
                  type: "star",
                  value,
                  output: ""
                });
                continue;
              }
              const isBrace = state.braces > 0 && (prior.type === "comma" || prior.type === "brace");
              const isExtglob = extglobs.length && (prior.type === "pipe" || prior.type === "paren");
              if (!isStart && prior.type !== "paren" && !isBrace && !isExtglob) {
                push2({
                  type: "star",
                  value,
                  output: ""
                });
                continue;
              }
              while (rest.slice(0, 3) === "/**") {
                const after = input[state.index + 4];
                if (after && after !== "/") {
                  break;
                }
                rest = rest.slice(3);
                consume("/**", 3);
              }
              if (prior.type === "bos" && eos()) {
                prev.type = "globstar";
                prev.value += value;
                prev.output = globstar(opts);
                state.output = prev.output;
                state.globstar = true;
                consume(value);
                continue;
              }
              if (prior.type === "slash" && prior.prev.type !== "bos" && !afterStar && eos()) {
                state.output = state.output.slice(0, -(prior.output + prev.output).length);
                prior.output = `(?:${prior.output}`;
                prev.type = "globstar";
                prev.output = globstar(opts) + (opts.strictSlashes ? ")" : "|$)");
                prev.value += value;
                state.globstar = true;
                state.output += prior.output + prev.output;
                consume(value);
                continue;
              }
              if (prior.type === "slash" && prior.prev.type !== "bos" && rest[0] === "/") {
                const end = rest[1] !== void 0 ? "|$" : "";
                state.output = state.output.slice(0, -(prior.output + prev.output).length);
                prior.output = `(?:${prior.output}`;
                prev.type = "globstar";
                prev.output = `${globstar(opts)}${SLASH_LITERAL}|${SLASH_LITERAL}${end})`;
                prev.value += value;
                state.output += prior.output + prev.output;
                state.globstar = true;
                consume(value + advance());
                push2({
                  type: "slash",
                  value: "/",
                  output: ""
                });
                continue;
              }
              if (prior.type === "bos" && rest[0] === "/") {
                prev.type = "globstar";
                prev.value += value;
                prev.output = `(?:^|${SLASH_LITERAL}|${globstar(opts)}${SLASH_LITERAL})`;
                state.output = prev.output;
                state.globstar = true;
                consume(value + advance());
                push2({
                  type: "slash",
                  value: "/",
                  output: ""
                });
                continue;
              }
              state.output = state.output.slice(0, -prev.output.length);
              prev.type = "globstar";
              prev.output = globstar(opts);
              prev.value += value;
              state.output += prev.output;
              state.globstar = true;
              consume(value);
              continue;
            }
            const token = {
              type: "star",
              value,
              output: star
            };
            if (opts.bash === true) {
              token.output = ".*?";
              if (prev.type === "bos" || prev.type === "slash") {
                token.output = nodot + token.output;
              }
              push2(token);
              continue;
            }
            if (prev && (prev.type === "bracket" || prev.type === "paren") && opts.regex === true) {
              token.output = value;
              push2(token);
              continue;
            }
            if (state.index === state.start || prev.type === "slash" || prev.type === "dot") {
              if (prev.type === "dot") {
                state.output += NO_DOT_SLASH;
                prev.output += NO_DOT_SLASH;
              } else if (opts.dot === true) {
                state.output += NO_DOTS_SLASH;
                prev.output += NO_DOTS_SLASH;
              } else {
                state.output += nodot;
                prev.output += nodot;
              }
              if (peek() !== "*") {
                state.output += ONE_CHAR;
                prev.output += ONE_CHAR;
              }
            }
            push2(token);
          }
          while (state.brackets > 0) {
            if (opts.strictBrackets === true)
              throw new SyntaxError(syntaxError("closing", "]"));
            state.output = utils.escapeLast(state.output, "[");
            decrement("brackets");
          }
          while (state.parens > 0) {
            if (opts.strictBrackets === true)
              throw new SyntaxError(syntaxError("closing", ")"));
            state.output = utils.escapeLast(state.output, "(");
            decrement("parens");
          }
          while (state.braces > 0) {
            if (opts.strictBrackets === true)
              throw new SyntaxError(syntaxError("closing", "}"));
            state.output = utils.escapeLast(state.output, "{");
            decrement("braces");
          }
          if (opts.strictSlashes !== true && (prev.type === "star" || prev.type === "bracket")) {
            push2({
              type: "maybe_slash",
              value: "",
              output: `${SLASH_LITERAL}?`
            });
          }
          if (state.backtrack === true) {
            state.output = "";
            for (const token of state.tokens) {
              state.output += token.output != null ? token.output : token.value;
              if (token.suffix) {
                state.output += token.suffix;
              }
            }
          }
          return state;
        };
        parse3.fastpaths = (input, options) => {
          const opts = Object.assign({}, options);
          const max = typeof opts.maxLength === "number" ? Math.min(MAX_LENGTH, opts.maxLength) : MAX_LENGTH;
          const len = input.length;
          if (len > max) {
            throw new SyntaxError(`Input length: ${len}, exceeds maximum allowed length: ${max}`);
          }
          input = REPLACEMENTS[input] || input;
          const win32 = utils.isWindows(options);
          const {
            DOT_LITERAL,
            SLASH_LITERAL,
            ONE_CHAR,
            DOTS_SLASH,
            NO_DOT,
            NO_DOTS,
            NO_DOTS_SLASH,
            STAR,
            START_ANCHOR
          } = constants.globChars(win32);
          const nodot = opts.dot ? NO_DOTS : NO_DOT;
          const slashDot = opts.dot ? NO_DOTS_SLASH : NO_DOT;
          const capture = opts.capture ? "" : "?:";
          const state = {
            negated: false,
            prefix: ""
          };
          let star = opts.bash === true ? ".*?" : STAR;
          if (opts.capture) {
            star = `(${star})`;
          }
          const globstar = (opts2) => {
            if (opts2.noglobstar === true)
              return star;
            return `(${capture}(?:(?!${START_ANCHOR}${opts2.dot ? DOTS_SLASH : DOT_LITERAL}).)*?)`;
          };
          const create = (str) => {
            switch (str) {
              case "*":
                return `${nodot}${ONE_CHAR}${star}`;
              case ".*":
                return `${DOT_LITERAL}${ONE_CHAR}${star}`;
              case "*.*":
                return `${nodot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
              case "*/*":
                return `${nodot}${star}${SLASH_LITERAL}${ONE_CHAR}${slashDot}${star}`;
              case "**":
                return nodot + globstar(opts);
              case "**/*":
                return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${ONE_CHAR}${star}`;
              case "**/*.*":
                return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${slashDot}${star}${DOT_LITERAL}${ONE_CHAR}${star}`;
              case "**/.*":
                return `(?:${nodot}${globstar(opts)}${SLASH_LITERAL})?${DOT_LITERAL}${ONE_CHAR}${star}`;
              default: {
                const match = /^(.*?)\.(\w+)$/.exec(str);
                if (!match)
                  return;
                const source2 = create(match[1]);
                if (!source2)
                  return;
                return source2 + DOT_LITERAL + match[2];
              }
            }
          };
          const output = utils.removePrefix(input, state);
          let source = create(output);
          if (source && opts.strictSlashes !== true) {
            source += `${SLASH_LITERAL}?`;
          }
          return source;
        };
        module22.exports = parse3;
      }
    });
    var require_picomatch3 = __commonJS22({
      "node_modules/picomatch/lib/picomatch.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var scan = require_scan2();
        var parse3 = require_parse22();
        var utils = require_utils32();
        var constants = require_constants32();
        var isObject3 = (val) => val && typeof val === "object" && !Array.isArray(val);
        var picomatch = (glob, options, returnState = false) => {
          if (Array.isArray(glob)) {
            const fns = glob.map((input) => picomatch(input, options, returnState));
            const arrayMatcher = (str) => {
              for (const isMatch of fns) {
                const state2 = isMatch(str);
                if (state2)
                  return state2;
              }
              return false;
            };
            return arrayMatcher;
          }
          const isState = isObject3(glob) && glob.tokens && glob.input;
          if (glob === "" || typeof glob !== "string" && !isState) {
            throw new TypeError("Expected pattern to be a non-empty string");
          }
          const opts = options || {};
          const posix = utils.isWindows(options);
          const regex = isState ? picomatch.compileRe(glob, options) : picomatch.makeRe(glob, options, false, true);
          const state = regex.state;
          delete regex.state;
          let isIgnored = () => false;
          if (opts.ignore) {
            const ignoreOpts = Object.assign(Object.assign({}, options), {}, {
              ignore: null,
              onMatch: null,
              onResult: null
            });
            isIgnored = picomatch(opts.ignore, ignoreOpts, returnState);
          }
          const matcher = (input, returnObject = false) => {
            const {
              isMatch,
              match,
              output
            } = picomatch.test(input, regex, options, {
              glob,
              posix
            });
            const result = {
              glob,
              state,
              regex,
              posix,
              input,
              output,
              match,
              isMatch
            };
            if (typeof opts.onResult === "function") {
              opts.onResult(result);
            }
            if (isMatch === false) {
              result.isMatch = false;
              return returnObject ? result : false;
            }
            if (isIgnored(input)) {
              if (typeof opts.onIgnore === "function") {
                opts.onIgnore(result);
              }
              result.isMatch = false;
              return returnObject ? result : false;
            }
            if (typeof opts.onMatch === "function") {
              opts.onMatch(result);
            }
            return returnObject ? result : true;
          };
          if (returnState) {
            matcher.state = state;
          }
          return matcher;
        };
        picomatch.test = (input, regex, options, {
          glob,
          posix
        } = {}) => {
          if (typeof input !== "string") {
            throw new TypeError("Expected input to be a string");
          }
          if (input === "") {
            return {
              isMatch: false,
              output: ""
            };
          }
          const opts = options || {};
          const format2 = opts.format || (posix ? utils.toPosixSlashes : null);
          let match = input === glob;
          let output = match && format2 ? format2(input) : input;
          if (match === false) {
            output = format2 ? format2(input) : input;
            match = output === glob;
          }
          if (match === false || opts.capture === true) {
            if (opts.matchBase === true || opts.basename === true) {
              match = picomatch.matchBase(input, regex, options, posix);
            } else {
              match = regex.exec(output);
            }
          }
          return {
            isMatch: Boolean(match),
            match,
            output
          };
        };
        picomatch.matchBase = (input, glob, options, posix = utils.isWindows(options)) => {
          const regex = glob instanceof RegExp ? glob : picomatch.makeRe(glob, options);
          return regex.test(path4.basename(input));
        };
        picomatch.isMatch = (str, patterns, options) => picomatch(patterns, options)(str);
        picomatch.parse = (pattern, options) => {
          if (Array.isArray(pattern))
            return pattern.map((p) => picomatch.parse(p, options));
          return parse3(pattern, Object.assign(Object.assign({}, options), {}, {
            fastpaths: false
          }));
        };
        picomatch.scan = (input, options) => scan(input, options);
        picomatch.compileRe = (state, options, returnOutput = false, returnState = false) => {
          if (returnOutput === true) {
            return state.output;
          }
          const opts = options || {};
          const prepend = opts.contains ? "" : "^";
          const append = opts.contains ? "" : "$";
          let source = `${prepend}(?:${state.output})${append}`;
          if (state && state.negated === true) {
            source = `^(?!${source}).*$`;
          }
          const regex = picomatch.toRegex(source, options);
          if (returnState === true) {
            regex.state = state;
          }
          return regex;
        };
        picomatch.makeRe = (input, options = {}, returnOutput = false, returnState = false) => {
          if (!input || typeof input !== "string") {
            throw new TypeError("Expected a non-empty string");
          }
          let parsed = {
            negated: false,
            fastpaths: true
          };
          if (options.fastpaths !== false && (input[0] === "." || input[0] === "*")) {
            parsed.output = parse3.fastpaths(input, options);
          }
          if (!parsed.output) {
            parsed = parse3(input, options);
          }
          return picomatch.compileRe(parsed, options, returnOutput, returnState);
        };
        picomatch.toRegex = (source, options) => {
          try {
            const opts = options || {};
            return new RegExp(source, opts.flags || (opts.nocase ? "i" : ""));
          } catch (err) {
            if (options && options.debug === true)
              throw err;
            return /$^/;
          }
        };
        picomatch.constants = constants;
        module22.exports = picomatch;
      }
    });
    var require_picomatch22 = __commonJS22({
      "node_modules/picomatch/index.js"(exports2, module22) {
        "use strict";
        module22.exports = require_picomatch3();
      }
    });
    var require_micromatch2 = __commonJS22({
      "node_modules/micromatch/index.js"(exports2, module22) {
        "use strict";
        var util2 = require("util");
        var braces = require_braces2();
        var picomatch = require_picomatch22();
        var utils = require_utils32();
        var isEmptyString = (val) => val === "" || val === "./";
        var micromatch2 = (list, patterns, options) => {
          patterns = [].concat(patterns);
          list = [].concat(list);
          let omit2 = /* @__PURE__ */ new Set();
          let keep = /* @__PURE__ */ new Set();
          let items = /* @__PURE__ */ new Set();
          let negatives = 0;
          let onResult = (state) => {
            items.add(state.output);
            if (options && options.onResult) {
              options.onResult(state);
            }
          };
          for (let i2 = 0; i2 < patterns.length; i2++) {
            let isMatch = picomatch(String(patterns[i2]), Object.assign(Object.assign({}, options), {}, {
              onResult
            }), true);
            let negated = isMatch.state.negated || isMatch.state.negatedExtglob;
            if (negated)
              negatives++;
            for (let item of list) {
              let matched = isMatch(item, true);
              let match = negated ? !matched.isMatch : matched.isMatch;
              if (!match)
                continue;
              if (negated) {
                omit2.add(matched.output);
              } else {
                omit2.delete(matched.output);
                keep.add(matched.output);
              }
            }
          }
          let result = negatives === patterns.length ? [...items] : [...keep];
          let matches = result.filter((item) => !omit2.has(item));
          if (options && matches.length === 0) {
            if (options.failglob === true) {
              throw new Error(`No matches found for "${patterns.join(", ")}"`);
            }
            if (options.nonull === true || options.nullglob === true) {
              return options.unescape ? patterns.map((p) => p.replace(/\\/g, "")) : patterns;
            }
          }
          return matches;
        };
        micromatch2.match = micromatch2;
        micromatch2.matcher = (pattern, options) => picomatch(pattern, options);
        micromatch2.isMatch = (str, patterns, options) => picomatch(patterns, options)(str);
        micromatch2.any = micromatch2.isMatch;
        micromatch2.not = (list, patterns, options = {}) => {
          patterns = [].concat(patterns).map(String);
          let result = /* @__PURE__ */ new Set();
          let items = [];
          let onResult = (state) => {
            if (options.onResult)
              options.onResult(state);
            items.push(state.output);
          };
          let matches = new Set(micromatch2(list, patterns, Object.assign(Object.assign({}, options), {}, {
            onResult
          })));
          for (let item of items) {
            if (!matches.has(item)) {
              result.add(item);
            }
          }
          return [...result];
        };
        micromatch2.contains = (str, pattern, options) => {
          if (typeof str !== "string") {
            throw new TypeError(`Expected a string: "${util2.inspect(str)}"`);
          }
          if (Array.isArray(pattern)) {
            return pattern.some((p) => micromatch2.contains(str, p, options));
          }
          if (typeof pattern === "string") {
            if (isEmptyString(str) || isEmptyString(pattern)) {
              return false;
            }
            if (str.includes(pattern) || str.startsWith("./") && str.slice(2).includes(pattern)) {
              return true;
            }
          }
          return micromatch2.isMatch(str, pattern, Object.assign(Object.assign({}, options), {}, {
            contains: true
          }));
        };
        micromatch2.matchKeys = (obj, patterns, options) => {
          if (!utils.isObject(obj)) {
            throw new TypeError("Expected the first argument to be an object");
          }
          let keys = micromatch2(Object.keys(obj), patterns, options);
          let res = {};
          for (let key of keys)
            res[key] = obj[key];
          return res;
        };
        micromatch2.some = (list, patterns, options) => {
          let items = [].concat(list);
          for (let pattern of [].concat(patterns)) {
            let isMatch = picomatch(String(pattern), options);
            if (items.some((item) => isMatch(item))) {
              return true;
            }
          }
          return false;
        };
        micromatch2.every = (list, patterns, options) => {
          let items = [].concat(list);
          for (let pattern of [].concat(patterns)) {
            let isMatch = picomatch(String(pattern), options);
            if (!items.every((item) => isMatch(item))) {
              return false;
            }
          }
          return true;
        };
        micromatch2.all = (str, patterns, options) => {
          if (typeof str !== "string") {
            throw new TypeError(`Expected a string: "${util2.inspect(str)}"`);
          }
          return [].concat(patterns).every((p) => picomatch(p, options)(str));
        };
        micromatch2.capture = (glob, input, options) => {
          let posix = utils.isWindows(options);
          let regex = picomatch.makeRe(String(glob), Object.assign(Object.assign({}, options), {}, {
            capture: true
          }));
          let match = regex.exec(posix ? utils.toPosixSlashes(input) : input);
          if (match) {
            return match.slice(1).map((v) => v === void 0 ? "" : v);
          }
        };
        micromatch2.makeRe = (...args) => picomatch.makeRe(...args);
        micromatch2.scan = (...args) => picomatch.scan(...args);
        micromatch2.parse = (patterns, options) => {
          let res = [];
          for (let pattern of [].concat(patterns || [])) {
            for (let str of braces(String(pattern), options)) {
              res.push(picomatch.parse(str, options));
            }
          }
          return res;
        };
        micromatch2.braces = (pattern, options) => {
          if (typeof pattern !== "string")
            throw new TypeError("Expected a string");
          if (options && options.nobrace === true || !/\{.*\}/.test(pattern)) {
            return [pattern];
          }
          return braces(pattern, options);
        };
        micromatch2.braceExpand = (pattern, options) => {
          if (typeof pattern !== "string")
            throw new TypeError("Expected a string");
          return micromatch2.braces(pattern, Object.assign(Object.assign({}, options), {}, {
            expand: true
          }));
        };
        module22.exports = micromatch2;
      }
    });
    var require_parser2 = __commonJS22({
      "node_modules/@iarna/toml/lib/parser.js"(exports2, module22) {
        "use strict";
        var ParserEND = 1114112;
        var ParserError = class extends Error {
          constructor(msg, filename, linenumber) {
            super("[ParserError] " + msg, filename, linenumber);
            this.name = "ParserError";
            this.code = "ParserError";
            if (Error.captureStackTrace)
              Error.captureStackTrace(this, ParserError);
          }
        };
        var State = class {
          constructor(parser) {
            this.parser = parser;
            this.buf = "";
            this.returned = null;
            this.result = null;
            this.resultTable = null;
            this.resultArr = null;
          }
        };
        var Parser = class {
          constructor() {
            this.pos = 0;
            this.col = 0;
            this.line = 0;
            this.obj = {};
            this.ctx = this.obj;
            this.stack = [];
            this._buf = "";
            this.char = null;
            this.ii = 0;
            this.state = new State(this.parseStart);
          }
          parse(str) {
            if (str.length === 0 || str.length == null)
              return;
            this._buf = String(str);
            this.ii = -1;
            this.char = -1;
            let getNext;
            while (getNext === false || this.nextChar()) {
              getNext = this.runOne();
            }
            this._buf = null;
          }
          nextChar() {
            if (this.char === 10) {
              ++this.line;
              this.col = -1;
            }
            ++this.ii;
            this.char = this._buf.codePointAt(this.ii);
            ++this.pos;
            ++this.col;
            return this.haveBuffer();
          }
          haveBuffer() {
            return this.ii < this._buf.length;
          }
          runOne() {
            return this.state.parser.call(this, this.state.returned);
          }
          finish() {
            this.char = ParserEND;
            let last;
            do {
              last = this.state.parser;
              this.runOne();
            } while (this.state.parser !== last);
            this.ctx = null;
            this.state = null;
            this._buf = null;
            return this.obj;
          }
          next(fn) {
            if (typeof fn !== "function")
              throw new ParserError("Tried to set state to non-existent state: " + JSON.stringify(fn));
            this.state.parser = fn;
          }
          goto(fn) {
            this.next(fn);
            return this.runOne();
          }
          call(fn, returnWith) {
            if (returnWith)
              this.next(returnWith);
            this.stack.push(this.state);
            this.state = new State(fn);
          }
          callNow(fn, returnWith) {
            this.call(fn, returnWith);
            return this.runOne();
          }
          return(value) {
            if (this.stack.length === 0)
              throw this.error(new ParserError("Stack underflow"));
            if (value === void 0)
              value = this.state.buf;
            this.state = this.stack.pop();
            this.state.returned = value;
          }
          returnNow(value) {
            this.return(value);
            return this.runOne();
          }
          consume() {
            if (this.char === ParserEND)
              throw this.error(new ParserError("Unexpected end-of-buffer"));
            this.state.buf += this._buf[this.ii];
          }
          error(err) {
            err.line = this.line;
            err.col = this.col;
            err.pos = this.pos;
            return err;
          }
          parseStart() {
            throw new ParserError("Must declare a parseStart method");
          }
        };
        Parser.END = ParserEND;
        Parser.Error = ParserError;
        module22.exports = Parser;
      }
    });
    var require_create_datetime = __commonJS22({
      "node_modules/@iarna/toml/lib/create-datetime.js"(exports2, module22) {
        "use strict";
        module22.exports = (value) => {
          const date = new Date(value);
          if (isNaN(date)) {
            throw new TypeError("Invalid Datetime");
          } else {
            return date;
          }
        };
      }
    });
    var require_format_num = __commonJS22({
      "node_modules/@iarna/toml/lib/format-num.js"(exports2, module22) {
        "use strict";
        module22.exports = (d, num) => {
          num = String(num);
          while (num.length < d)
            num = "0" + num;
          return num;
        };
      }
    });
    var require_create_datetime_float = __commonJS22({
      "node_modules/@iarna/toml/lib/create-datetime-float.js"(exports2, module22) {
        "use strict";
        var f3 = require_format_num();
        var FloatingDateTime = class extends Date {
          constructor(value) {
            super(value + "Z");
            this.isFloating = true;
          }
          toISOString() {
            const date = `${this.getUTCFullYear()}-${f3(2, this.getUTCMonth() + 1)}-${f3(2, this.getUTCDate())}`;
            const time = `${f3(2, this.getUTCHours())}:${f3(2, this.getUTCMinutes())}:${f3(2, this.getUTCSeconds())}.${f3(3, this.getUTCMilliseconds())}`;
            return `${date}T${time}`;
          }
        };
        module22.exports = (value) => {
          const date = new FloatingDateTime(value);
          if (isNaN(date)) {
            throw new TypeError("Invalid Datetime");
          } else {
            return date;
          }
        };
      }
    });
    var require_create_date = __commonJS22({
      "node_modules/@iarna/toml/lib/create-date.js"(exports2, module22) {
        "use strict";
        var f3 = require_format_num();
        var DateTime = global.Date;
        var Date2 = class extends DateTime {
          constructor(value) {
            super(value);
            this.isDate = true;
          }
          toISOString() {
            return `${this.getUTCFullYear()}-${f3(2, this.getUTCMonth() + 1)}-${f3(2, this.getUTCDate())}`;
          }
        };
        module22.exports = (value) => {
          const date = new Date2(value);
          if (isNaN(date)) {
            throw new TypeError("Invalid Datetime");
          } else {
            return date;
          }
        };
      }
    });
    var require_create_time = __commonJS22({
      "node_modules/@iarna/toml/lib/create-time.js"(exports2, module22) {
        "use strict";
        var f3 = require_format_num();
        var Time = class extends Date {
          constructor(value) {
            super(`0000-01-01T${value}Z`);
            this.isTime = true;
          }
          toISOString() {
            return `${f3(2, this.getUTCHours())}:${f3(2, this.getUTCMinutes())}:${f3(2, this.getUTCSeconds())}.${f3(3, this.getUTCMilliseconds())}`;
          }
        };
        module22.exports = (value) => {
          const date = new Time(value);
          if (isNaN(date)) {
            throw new TypeError("Invalid Datetime");
          } else {
            return date;
          }
        };
      }
    });
    var require_toml_parser = __commonJS22({
      "node_modules/@iarna/toml/lib/toml-parser.js"(exports2, module22) {
        "use strict";
        module22.exports = makeParserClass(require_parser2());
        module22.exports.makeParserClass = makeParserClass;
        var TomlError = class extends Error {
          constructor(msg) {
            super(msg);
            this.name = "TomlError";
            if (Error.captureStackTrace)
              Error.captureStackTrace(this, TomlError);
            this.fromTOML = true;
            this.wrapped = null;
          }
        };
        TomlError.wrap = (err) => {
          const terr = new TomlError(err.message);
          terr.code = err.code;
          terr.wrapped = err;
          return terr;
        };
        module22.exports.TomlError = TomlError;
        var createDateTime = require_create_datetime();
        var createDateTimeFloat = require_create_datetime_float();
        var createDate = require_create_date();
        var createTime = require_create_time();
        var CTRL_I = 9;
        var CTRL_J = 10;
        var CTRL_M = 13;
        var CTRL_CHAR_BOUNDARY = 31;
        var CHAR_SP = 32;
        var CHAR_QUOT = 34;
        var CHAR_NUM = 35;
        var CHAR_APOS = 39;
        var CHAR_PLUS = 43;
        var CHAR_COMMA = 44;
        var CHAR_HYPHEN = 45;
        var CHAR_PERIOD = 46;
        var CHAR_0 = 48;
        var CHAR_1 = 49;
        var CHAR_7 = 55;
        var CHAR_9 = 57;
        var CHAR_COLON = 58;
        var CHAR_EQUALS = 61;
        var CHAR_A = 65;
        var CHAR_E = 69;
        var CHAR_F = 70;
        var CHAR_T = 84;
        var CHAR_U = 85;
        var CHAR_Z = 90;
        var CHAR_LOWBAR = 95;
        var CHAR_a = 97;
        var CHAR_b = 98;
        var CHAR_e = 101;
        var CHAR_f = 102;
        var CHAR_i = 105;
        var CHAR_l = 108;
        var CHAR_n = 110;
        var CHAR_o = 111;
        var CHAR_r = 114;
        var CHAR_s = 115;
        var CHAR_t = 116;
        var CHAR_u = 117;
        var CHAR_x = 120;
        var CHAR_z = 122;
        var CHAR_LCUB = 123;
        var CHAR_RCUB = 125;
        var CHAR_LSQB = 91;
        var CHAR_BSOL = 92;
        var CHAR_RSQB = 93;
        var CHAR_DEL = 127;
        var SURROGATE_FIRST = 55296;
        var SURROGATE_LAST = 57343;
        var escapes = {
          [CHAR_b]: "\b",
          [CHAR_t]: "	",
          [CHAR_n]: "\n",
          [CHAR_f]: "\f",
          [CHAR_r]: "\r",
          [CHAR_QUOT]: '"',
          [CHAR_BSOL]: "\\"
        };
        function isDigit(cp) {
          return cp >= CHAR_0 && cp <= CHAR_9;
        }
        function isHexit(cp) {
          return cp >= CHAR_A && cp <= CHAR_F || cp >= CHAR_a && cp <= CHAR_f || cp >= CHAR_0 && cp <= CHAR_9;
        }
        function isBit(cp) {
          return cp === CHAR_1 || cp === CHAR_0;
        }
        function isOctit(cp) {
          return cp >= CHAR_0 && cp <= CHAR_7;
        }
        function isAlphaNumQuoteHyphen(cp) {
          return cp >= CHAR_A && cp <= CHAR_Z || cp >= CHAR_a && cp <= CHAR_z || cp >= CHAR_0 && cp <= CHAR_9 || cp === CHAR_APOS || cp === CHAR_QUOT || cp === CHAR_LOWBAR || cp === CHAR_HYPHEN;
        }
        function isAlphaNumHyphen(cp) {
          return cp >= CHAR_A && cp <= CHAR_Z || cp >= CHAR_a && cp <= CHAR_z || cp >= CHAR_0 && cp <= CHAR_9 || cp === CHAR_LOWBAR || cp === CHAR_HYPHEN;
        }
        var _type2 = Symbol("type");
        var _declared = Symbol("declared");
        var hasOwnProperty = Object.prototype.hasOwnProperty;
        var defineProperty = Object.defineProperty;
        var descriptor = {
          configurable: true,
          enumerable: true,
          writable: true,
          value: void 0
        };
        function hasKey(obj, key) {
          if (hasOwnProperty.call(obj, key))
            return true;
          if (key === "__proto__")
            defineProperty(obj, "__proto__", descriptor);
          return false;
        }
        var INLINE_TABLE = Symbol("inline-table");
        function InlineTable() {
          return Object.defineProperties({}, {
            [_type2]: {
              value: INLINE_TABLE
            }
          });
        }
        function isInlineTable(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type2] === INLINE_TABLE;
        }
        var TABLE = Symbol("table");
        function Table() {
          return Object.defineProperties({}, {
            [_type2]: {
              value: TABLE
            },
            [_declared]: {
              value: false,
              writable: true
            }
          });
        }
        function isTable(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type2] === TABLE;
        }
        var _contentType = Symbol("content-type");
        var INLINE_LIST = Symbol("inline-list");
        function InlineList(type) {
          return Object.defineProperties([], {
            [_type2]: {
              value: INLINE_LIST
            },
            [_contentType]: {
              value: type
            }
          });
        }
        function isInlineList(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type2] === INLINE_LIST;
        }
        var LIST = Symbol("list");
        function List() {
          return Object.defineProperties([], {
            [_type2]: {
              value: LIST
            }
          });
        }
        function isList(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type2] === LIST;
        }
        var _custom;
        try {
          const utilInspect = require("util").inspect;
          _custom = utilInspect.custom;
        } catch (_) {
        }
        var _inspect = _custom || "inspect";
        var BoxedBigInt = class {
          constructor(value) {
            try {
              this.value = global.BigInt.asIntN(64, value);
            } catch (_) {
              this.value = null;
            }
            Object.defineProperty(this, _type2, {
              value: INTEGER
            });
          }
          isNaN() {
            return this.value === null;
          }
          toString() {
            return String(this.value);
          }
          [_inspect]() {
            return `[BigInt: ${this.toString()}]}`;
          }
          valueOf() {
            return this.value;
          }
        };
        var INTEGER = Symbol("integer");
        function Integer(value) {
          let num = Number(value);
          if (Object.is(num, -0))
            num = 0;
          if (global.BigInt && !Number.isSafeInteger(num)) {
            return new BoxedBigInt(value);
          } else {
            return Object.defineProperties(new Number(num), {
              isNaN: {
                value: function() {
                  return isNaN(this);
                }
              },
              [_type2]: {
                value: INTEGER
              },
              [_inspect]: {
                value: () => `[Integer: ${value}]`
              }
            });
          }
        }
        function isInteger(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type2] === INTEGER;
        }
        var FLOAT = Symbol("float");
        function Float(value) {
          return Object.defineProperties(new Number(value), {
            [_type2]: {
              value: FLOAT
            },
            [_inspect]: {
              value: () => `[Float: ${value}]`
            }
          });
        }
        function isFloat(obj) {
          if (obj === null || typeof obj !== "object")
            return false;
          return obj[_type2] === FLOAT;
        }
        function tomlType(value) {
          const type = typeof value;
          if (type === "object") {
            if (value === null)
              return "null";
            if (value instanceof Date)
              return "datetime";
            if (_type2 in value) {
              switch (value[_type2]) {
                case INLINE_TABLE:
                  return "inline-table";
                case INLINE_LIST:
                  return "inline-list";
                case TABLE:
                  return "table";
                case LIST:
                  return "list";
                case FLOAT:
                  return "float";
                case INTEGER:
                  return "integer";
              }
            }
          }
          return type;
        }
        function makeParserClass(Parser) {
          class TOMLParser extends Parser {
            constructor() {
              super();
              this.ctx = this.obj = Table();
            }
            atEndOfWord() {
              return this.char === CHAR_NUM || this.char === CTRL_I || this.char === CHAR_SP || this.atEndOfLine();
            }
            atEndOfLine() {
              return this.char === Parser.END || this.char === CTRL_J || this.char === CTRL_M;
            }
            parseStart() {
              if (this.char === Parser.END) {
                return null;
              } else if (this.char === CHAR_LSQB) {
                return this.call(this.parseTableOrList);
              } else if (this.char === CHAR_NUM) {
                return this.call(this.parseComment);
              } else if (this.char === CTRL_J || this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M) {
                return null;
              } else if (isAlphaNumQuoteHyphen(this.char)) {
                return this.callNow(this.parseAssignStatement);
              } else {
                throw this.error(new TomlError(`Unknown character "${this.char}"`));
              }
            }
            parseWhitespaceToEOL() {
              if (this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M) {
                return null;
              } else if (this.char === CHAR_NUM) {
                return this.goto(this.parseComment);
              } else if (this.char === Parser.END || this.char === CTRL_J) {
                return this.return();
              } else {
                throw this.error(new TomlError("Unexpected character, expected only whitespace or comments till end of line"));
              }
            }
            parseAssignStatement() {
              return this.callNow(this.parseAssign, this.recordAssignStatement);
            }
            recordAssignStatement(kv) {
              let target = this.ctx;
              let finalKey = kv.key.pop();
              for (let kw of kv.key) {
                if (hasKey(target, kw) && (!isTable(target[kw]) || target[kw][_declared])) {
                  throw this.error(new TomlError("Can't redefine existing key"));
                }
                target = target[kw] = target[kw] || Table();
              }
              if (hasKey(target, finalKey)) {
                throw this.error(new TomlError("Can't redefine existing key"));
              }
              if (isInteger(kv.value) || isFloat(kv.value)) {
                target[finalKey] = kv.value.valueOf();
              } else {
                target[finalKey] = kv.value;
              }
              return this.goto(this.parseWhitespaceToEOL);
            }
            parseAssign() {
              return this.callNow(this.parseKeyword, this.recordAssignKeyword);
            }
            recordAssignKeyword(key) {
              if (this.state.resultTable) {
                this.state.resultTable.push(key);
              } else {
                this.state.resultTable = [key];
              }
              return this.goto(this.parseAssignKeywordPreDot);
            }
            parseAssignKeywordPreDot() {
              if (this.char === CHAR_PERIOD) {
                return this.next(this.parseAssignKeywordPostDot);
              } else if (this.char !== CHAR_SP && this.char !== CTRL_I) {
                return this.goto(this.parseAssignEqual);
              }
            }
            parseAssignKeywordPostDot() {
              if (this.char !== CHAR_SP && this.char !== CTRL_I) {
                return this.callNow(this.parseKeyword, this.recordAssignKeyword);
              }
            }
            parseAssignEqual() {
              if (this.char === CHAR_EQUALS) {
                return this.next(this.parseAssignPreValue);
              } else {
                throw this.error(new TomlError('Invalid character, expected "="'));
              }
            }
            parseAssignPreValue() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else {
                return this.callNow(this.parseValue, this.recordAssignValue);
              }
            }
            recordAssignValue(value) {
              return this.returnNow({
                key: this.state.resultTable,
                value
              });
            }
            parseComment() {
              do {
                if (this.char === Parser.END || this.char === CTRL_J) {
                  return this.return();
                }
              } while (this.nextChar());
            }
            parseTableOrList() {
              if (this.char === CHAR_LSQB) {
                this.next(this.parseList);
              } else {
                return this.goto(this.parseTable);
              }
            }
            parseTable() {
              this.ctx = this.obj;
              return this.goto(this.parseTableNext);
            }
            parseTableNext() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else {
                return this.callNow(this.parseKeyword, this.parseTableMore);
              }
            }
            parseTableMore(keyword) {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === CHAR_RSQB) {
                if (hasKey(this.ctx, keyword) && (!isTable(this.ctx[keyword]) || this.ctx[keyword][_declared])) {
                  throw this.error(new TomlError("Can't redefine existing key"));
                } else {
                  this.ctx = this.ctx[keyword] = this.ctx[keyword] || Table();
                  this.ctx[_declared] = true;
                }
                return this.next(this.parseWhitespaceToEOL);
              } else if (this.char === CHAR_PERIOD) {
                if (!hasKey(this.ctx, keyword)) {
                  this.ctx = this.ctx[keyword] = Table();
                } else if (isTable(this.ctx[keyword])) {
                  this.ctx = this.ctx[keyword];
                } else if (isList(this.ctx[keyword])) {
                  this.ctx = this.ctx[keyword][this.ctx[keyword].length - 1];
                } else {
                  throw this.error(new TomlError("Can't redefine existing key"));
                }
                return this.next(this.parseTableNext);
              } else {
                throw this.error(new TomlError("Unexpected character, expected whitespace, . or ]"));
              }
            }
            parseList() {
              this.ctx = this.obj;
              return this.goto(this.parseListNext);
            }
            parseListNext() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else {
                return this.callNow(this.parseKeyword, this.parseListMore);
              }
            }
            parseListMore(keyword) {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === CHAR_RSQB) {
                if (!hasKey(this.ctx, keyword)) {
                  this.ctx[keyword] = List();
                }
                if (isInlineList(this.ctx[keyword])) {
                  throw this.error(new TomlError("Can't extend an inline array"));
                } else if (isList(this.ctx[keyword])) {
                  const next = Table();
                  this.ctx[keyword].push(next);
                  this.ctx = next;
                } else {
                  throw this.error(new TomlError("Can't redefine an existing key"));
                }
                return this.next(this.parseListEnd);
              } else if (this.char === CHAR_PERIOD) {
                if (!hasKey(this.ctx, keyword)) {
                  this.ctx = this.ctx[keyword] = Table();
                } else if (isInlineList(this.ctx[keyword])) {
                  throw this.error(new TomlError("Can't extend an inline array"));
                } else if (isInlineTable(this.ctx[keyword])) {
                  throw this.error(new TomlError("Can't extend an inline table"));
                } else if (isList(this.ctx[keyword])) {
                  this.ctx = this.ctx[keyword][this.ctx[keyword].length - 1];
                } else if (isTable(this.ctx[keyword])) {
                  this.ctx = this.ctx[keyword];
                } else {
                  throw this.error(new TomlError("Can't redefine an existing key"));
                }
                return this.next(this.parseListNext);
              } else {
                throw this.error(new TomlError("Unexpected character, expected whitespace, . or ]"));
              }
            }
            parseListEnd(keyword) {
              if (this.char === CHAR_RSQB) {
                return this.next(this.parseWhitespaceToEOL);
              } else {
                throw this.error(new TomlError("Unexpected character, expected whitespace, . or ]"));
              }
            }
            parseValue() {
              if (this.char === Parser.END) {
                throw this.error(new TomlError("Key without value"));
              } else if (this.char === CHAR_QUOT) {
                return this.next(this.parseDoubleString);
              }
              if (this.char === CHAR_APOS) {
                return this.next(this.parseSingleString);
              } else if (this.char === CHAR_HYPHEN || this.char === CHAR_PLUS) {
                return this.goto(this.parseNumberSign);
              } else if (this.char === CHAR_i) {
                return this.next(this.parseInf);
              } else if (this.char === CHAR_n) {
                return this.next(this.parseNan);
              } else if (isDigit(this.char)) {
                return this.goto(this.parseNumberOrDateTime);
              } else if (this.char === CHAR_t || this.char === CHAR_f) {
                return this.goto(this.parseBoolean);
              } else if (this.char === CHAR_LSQB) {
                return this.call(this.parseInlineList, this.recordValue);
              } else if (this.char === CHAR_LCUB) {
                return this.call(this.parseInlineTable, this.recordValue);
              } else {
                throw this.error(new TomlError("Unexpected character, expecting string, number, datetime, boolean, inline array or inline table"));
              }
            }
            recordValue(value) {
              return this.returnNow(value);
            }
            parseInf() {
              if (this.char === CHAR_n) {
                return this.next(this.parseInf2);
              } else {
                throw this.error(new TomlError('Unexpected character, expected "inf", "+inf" or "-inf"'));
              }
            }
            parseInf2() {
              if (this.char === CHAR_f) {
                if (this.state.buf === "-") {
                  return this.return(-Infinity);
                } else {
                  return this.return(Infinity);
                }
              } else {
                throw this.error(new TomlError('Unexpected character, expected "inf", "+inf" or "-inf"'));
              }
            }
            parseNan() {
              if (this.char === CHAR_a) {
                return this.next(this.parseNan2);
              } else {
                throw this.error(new TomlError('Unexpected character, expected "nan"'));
              }
            }
            parseNan2() {
              if (this.char === CHAR_n) {
                return this.return(NaN);
              } else {
                throw this.error(new TomlError('Unexpected character, expected "nan"'));
              }
            }
            parseKeyword() {
              if (this.char === CHAR_QUOT) {
                return this.next(this.parseBasicString);
              } else if (this.char === CHAR_APOS) {
                return this.next(this.parseLiteralString);
              } else {
                return this.goto(this.parseBareKey);
              }
            }
            parseBareKey() {
              do {
                if (this.char === Parser.END) {
                  throw this.error(new TomlError("Key ended without value"));
                } else if (isAlphaNumHyphen(this.char)) {
                  this.consume();
                } else if (this.state.buf.length === 0) {
                  throw this.error(new TomlError("Empty bare keys are not allowed"));
                } else {
                  return this.returnNow();
                }
              } while (this.nextChar());
            }
            parseSingleString() {
              if (this.char === CHAR_APOS) {
                return this.next(this.parseLiteralMultiStringMaybe);
              } else {
                return this.goto(this.parseLiteralString);
              }
            }
            parseLiteralString() {
              do {
                if (this.char === CHAR_APOS) {
                  return this.return();
                } else if (this.atEndOfLine()) {
                  throw this.error(new TomlError("Unterminated string"));
                } else if (this.char === CHAR_DEL || this.char <= CTRL_CHAR_BOUNDARY && this.char !== CTRL_I) {
                  throw this.errorControlCharInString();
                } else {
                  this.consume();
                }
              } while (this.nextChar());
            }
            parseLiteralMultiStringMaybe() {
              if (this.char === CHAR_APOS) {
                return this.next(this.parseLiteralMultiString);
              } else {
                return this.returnNow();
              }
            }
            parseLiteralMultiString() {
              if (this.char === CTRL_M) {
                return null;
              } else if (this.char === CTRL_J) {
                return this.next(this.parseLiteralMultiStringContent);
              } else {
                return this.goto(this.parseLiteralMultiStringContent);
              }
            }
            parseLiteralMultiStringContent() {
              do {
                if (this.char === CHAR_APOS) {
                  return this.next(this.parseLiteralMultiEnd);
                } else if (this.char === Parser.END) {
                  throw this.error(new TomlError("Unterminated multi-line string"));
                } else if (this.char === CHAR_DEL || this.char <= CTRL_CHAR_BOUNDARY && this.char !== CTRL_I && this.char !== CTRL_J && this.char !== CTRL_M) {
                  throw this.errorControlCharInString();
                } else {
                  this.consume();
                }
              } while (this.nextChar());
            }
            parseLiteralMultiEnd() {
              if (this.char === CHAR_APOS) {
                return this.next(this.parseLiteralMultiEnd2);
              } else {
                this.state.buf += "'";
                return this.goto(this.parseLiteralMultiStringContent);
              }
            }
            parseLiteralMultiEnd2() {
              if (this.char === CHAR_APOS) {
                return this.return();
              } else {
                this.state.buf += "''";
                return this.goto(this.parseLiteralMultiStringContent);
              }
            }
            parseDoubleString() {
              if (this.char === CHAR_QUOT) {
                return this.next(this.parseMultiStringMaybe);
              } else {
                return this.goto(this.parseBasicString);
              }
            }
            parseBasicString() {
              do {
                if (this.char === CHAR_BSOL) {
                  return this.call(this.parseEscape, this.recordEscapeReplacement);
                } else if (this.char === CHAR_QUOT) {
                  return this.return();
                } else if (this.atEndOfLine()) {
                  throw this.error(new TomlError("Unterminated string"));
                } else if (this.char === CHAR_DEL || this.char <= CTRL_CHAR_BOUNDARY && this.char !== CTRL_I) {
                  throw this.errorControlCharInString();
                } else {
                  this.consume();
                }
              } while (this.nextChar());
            }
            recordEscapeReplacement(replacement) {
              this.state.buf += replacement;
              return this.goto(this.parseBasicString);
            }
            parseMultiStringMaybe() {
              if (this.char === CHAR_QUOT) {
                return this.next(this.parseMultiString);
              } else {
                return this.returnNow();
              }
            }
            parseMultiString() {
              if (this.char === CTRL_M) {
                return null;
              } else if (this.char === CTRL_J) {
                return this.next(this.parseMultiStringContent);
              } else {
                return this.goto(this.parseMultiStringContent);
              }
            }
            parseMultiStringContent() {
              do {
                if (this.char === CHAR_BSOL) {
                  return this.call(this.parseMultiEscape, this.recordMultiEscapeReplacement);
                } else if (this.char === CHAR_QUOT) {
                  return this.next(this.parseMultiEnd);
                } else if (this.char === Parser.END) {
                  throw this.error(new TomlError("Unterminated multi-line string"));
                } else if (this.char === CHAR_DEL || this.char <= CTRL_CHAR_BOUNDARY && this.char !== CTRL_I && this.char !== CTRL_J && this.char !== CTRL_M) {
                  throw this.errorControlCharInString();
                } else {
                  this.consume();
                }
              } while (this.nextChar());
            }
            errorControlCharInString() {
              let displayCode = "\\u00";
              if (this.char < 16) {
                displayCode += "0";
              }
              displayCode += this.char.toString(16);
              return this.error(new TomlError(`Control characters (codes < 0x1f and 0x7f) are not allowed in strings, use ${displayCode} instead`));
            }
            recordMultiEscapeReplacement(replacement) {
              this.state.buf += replacement;
              return this.goto(this.parseMultiStringContent);
            }
            parseMultiEnd() {
              if (this.char === CHAR_QUOT) {
                return this.next(this.parseMultiEnd2);
              } else {
                this.state.buf += '"';
                return this.goto(this.parseMultiStringContent);
              }
            }
            parseMultiEnd2() {
              if (this.char === CHAR_QUOT) {
                return this.return();
              } else {
                this.state.buf += '""';
                return this.goto(this.parseMultiStringContent);
              }
            }
            parseMultiEscape() {
              if (this.char === CTRL_M || this.char === CTRL_J) {
                return this.next(this.parseMultiTrim);
              } else if (this.char === CHAR_SP || this.char === CTRL_I) {
                return this.next(this.parsePreMultiTrim);
              } else {
                return this.goto(this.parseEscape);
              }
            }
            parsePreMultiTrim() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === CTRL_M || this.char === CTRL_J) {
                return this.next(this.parseMultiTrim);
              } else {
                throw this.error(new TomlError("Can't escape whitespace"));
              }
            }
            parseMultiTrim() {
              if (this.char === CTRL_J || this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M) {
                return null;
              } else {
                return this.returnNow();
              }
            }
            parseEscape() {
              if (this.char in escapes) {
                return this.return(escapes[this.char]);
              } else if (this.char === CHAR_u) {
                return this.call(this.parseSmallUnicode, this.parseUnicodeReturn);
              } else if (this.char === CHAR_U) {
                return this.call(this.parseLargeUnicode, this.parseUnicodeReturn);
              } else {
                throw this.error(new TomlError("Unknown escape character: " + this.char));
              }
            }
            parseUnicodeReturn(char) {
              try {
                const codePoint = parseInt(char, 16);
                if (codePoint >= SURROGATE_FIRST && codePoint <= SURROGATE_LAST) {
                  throw this.error(new TomlError("Invalid unicode, character in range 0xD800 - 0xDFFF is reserved"));
                }
                return this.returnNow(String.fromCodePoint(codePoint));
              } catch (err) {
                throw this.error(TomlError.wrap(err));
              }
            }
            parseSmallUnicode() {
              if (!isHexit(this.char)) {
                throw this.error(new TomlError("Invalid character in unicode sequence, expected hex"));
              } else {
                this.consume();
                if (this.state.buf.length >= 4)
                  return this.return();
              }
            }
            parseLargeUnicode() {
              if (!isHexit(this.char)) {
                throw this.error(new TomlError("Invalid character in unicode sequence, expected hex"));
              } else {
                this.consume();
                if (this.state.buf.length >= 8)
                  return this.return();
              }
            }
            parseNumberSign() {
              this.consume();
              return this.next(this.parseMaybeSignedInfOrNan);
            }
            parseMaybeSignedInfOrNan() {
              if (this.char === CHAR_i) {
                return this.next(this.parseInf);
              } else if (this.char === CHAR_n) {
                return this.next(this.parseNan);
              } else {
                return this.callNow(this.parseNoUnder, this.parseNumberIntegerStart);
              }
            }
            parseNumberIntegerStart() {
              if (this.char === CHAR_0) {
                this.consume();
                return this.next(this.parseNumberIntegerExponentOrDecimal);
              } else {
                return this.goto(this.parseNumberInteger);
              }
            }
            parseNumberIntegerExponentOrDecimal() {
              if (this.char === CHAR_PERIOD) {
                this.consume();
                return this.call(this.parseNoUnder, this.parseNumberFloat);
              } else if (this.char === CHAR_E || this.char === CHAR_e) {
                this.consume();
                return this.next(this.parseNumberExponentSign);
              } else {
                return this.returnNow(Integer(this.state.buf));
              }
            }
            parseNumberInteger() {
              if (isDigit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnder);
              } else if (this.char === CHAR_E || this.char === CHAR_e) {
                this.consume();
                return this.next(this.parseNumberExponentSign);
              } else if (this.char === CHAR_PERIOD) {
                this.consume();
                return this.call(this.parseNoUnder, this.parseNumberFloat);
              } else {
                const result = Integer(this.state.buf);
                if (result.isNaN()) {
                  throw this.error(new TomlError("Invalid number"));
                } else {
                  return this.returnNow(result);
                }
              }
            }
            parseNoUnder() {
              if (this.char === CHAR_LOWBAR || this.char === CHAR_PERIOD || this.char === CHAR_E || this.char === CHAR_e) {
                throw this.error(new TomlError("Unexpected character, expected digit"));
              } else if (this.atEndOfWord()) {
                throw this.error(new TomlError("Incomplete number"));
              }
              return this.returnNow();
            }
            parseNoUnderHexOctBinLiteral() {
              if (this.char === CHAR_LOWBAR || this.char === CHAR_PERIOD) {
                throw this.error(new TomlError("Unexpected character, expected digit"));
              } else if (this.atEndOfWord()) {
                throw this.error(new TomlError("Incomplete number"));
              }
              return this.returnNow();
            }
            parseNumberFloat() {
              if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnder, this.parseNumberFloat);
              } else if (isDigit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_E || this.char === CHAR_e) {
                this.consume();
                return this.next(this.parseNumberExponentSign);
              } else {
                return this.returnNow(Float(this.state.buf));
              }
            }
            parseNumberExponentSign() {
              if (isDigit(this.char)) {
                return this.goto(this.parseNumberExponent);
              } else if (this.char === CHAR_HYPHEN || this.char === CHAR_PLUS) {
                this.consume();
                this.call(this.parseNoUnder, this.parseNumberExponent);
              } else {
                throw this.error(new TomlError("Unexpected character, expected -, + or digit"));
              }
            }
            parseNumberExponent() {
              if (isDigit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnder);
              } else {
                return this.returnNow(Float(this.state.buf));
              }
            }
            parseNumberOrDateTime() {
              if (this.char === CHAR_0) {
                this.consume();
                return this.next(this.parseNumberBaseOrDateTime);
              } else {
                return this.goto(this.parseNumberOrDateTimeOnly);
              }
            }
            parseNumberOrDateTimeOnly() {
              if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnder, this.parseNumberInteger);
              } else if (isDigit(this.char)) {
                this.consume();
                if (this.state.buf.length > 4)
                  this.next(this.parseNumberInteger);
              } else if (this.char === CHAR_E || this.char === CHAR_e) {
                this.consume();
                return this.next(this.parseNumberExponentSign);
              } else if (this.char === CHAR_PERIOD) {
                this.consume();
                return this.call(this.parseNoUnder, this.parseNumberFloat);
              } else if (this.char === CHAR_HYPHEN) {
                return this.goto(this.parseDateTime);
              } else if (this.char === CHAR_COLON) {
                return this.goto(this.parseOnlyTimeHour);
              } else {
                return this.returnNow(Integer(this.state.buf));
              }
            }
            parseDateTimeOnly() {
              if (this.state.buf.length < 4) {
                if (isDigit(this.char)) {
                  return this.consume();
                } else if (this.char === CHAR_COLON) {
                  return this.goto(this.parseOnlyTimeHour);
                } else {
                  throw this.error(new TomlError("Expected digit while parsing year part of a date"));
                }
              } else {
                if (this.char === CHAR_HYPHEN) {
                  return this.goto(this.parseDateTime);
                } else {
                  throw this.error(new TomlError("Expected hyphen (-) while parsing year part of date"));
                }
              }
            }
            parseNumberBaseOrDateTime() {
              if (this.char === CHAR_b) {
                this.consume();
                return this.call(this.parseNoUnderHexOctBinLiteral, this.parseIntegerBin);
              } else if (this.char === CHAR_o) {
                this.consume();
                return this.call(this.parseNoUnderHexOctBinLiteral, this.parseIntegerOct);
              } else if (this.char === CHAR_x) {
                this.consume();
                return this.call(this.parseNoUnderHexOctBinLiteral, this.parseIntegerHex);
              } else if (this.char === CHAR_PERIOD) {
                return this.goto(this.parseNumberInteger);
              } else if (isDigit(this.char)) {
                return this.goto(this.parseDateTimeOnly);
              } else {
                return this.returnNow(Integer(this.state.buf));
              }
            }
            parseIntegerHex() {
              if (isHexit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnderHexOctBinLiteral);
              } else {
                const result = Integer(this.state.buf);
                if (result.isNaN()) {
                  throw this.error(new TomlError("Invalid number"));
                } else {
                  return this.returnNow(result);
                }
              }
            }
            parseIntegerOct() {
              if (isOctit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnderHexOctBinLiteral);
              } else {
                const result = Integer(this.state.buf);
                if (result.isNaN()) {
                  throw this.error(new TomlError("Invalid number"));
                } else {
                  return this.returnNow(result);
                }
              }
            }
            parseIntegerBin() {
              if (isBit(this.char)) {
                this.consume();
              } else if (this.char === CHAR_LOWBAR) {
                return this.call(this.parseNoUnderHexOctBinLiteral);
              } else {
                const result = Integer(this.state.buf);
                if (result.isNaN()) {
                  throw this.error(new TomlError("Invalid number"));
                } else {
                  return this.returnNow(result);
                }
              }
            }
            parseDateTime() {
              if (this.state.buf.length < 4) {
                throw this.error(new TomlError("Years less than 1000 must be zero padded to four characters"));
              }
              this.state.result = this.state.buf;
              this.state.buf = "";
              return this.next(this.parseDateMonth);
            }
            parseDateMonth() {
              if (this.char === CHAR_HYPHEN) {
                if (this.state.buf.length < 2) {
                  throw this.error(new TomlError("Months less than 10 must be zero padded to two characters"));
                }
                this.state.result += "-" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseDateDay);
              } else if (isDigit(this.char)) {
                this.consume();
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseDateDay() {
              if (this.char === CHAR_T || this.char === CHAR_SP) {
                if (this.state.buf.length < 2) {
                  throw this.error(new TomlError("Days less than 10 must be zero padded to two characters"));
                }
                this.state.result += "-" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseStartTimeHour);
              } else if (this.atEndOfWord()) {
                return this.returnNow(createDate(this.state.result + "-" + this.state.buf));
              } else if (isDigit(this.char)) {
                this.consume();
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseStartTimeHour() {
              if (this.atEndOfWord()) {
                return this.returnNow(createDate(this.state.result));
              } else {
                return this.goto(this.parseTimeHour);
              }
            }
            parseTimeHour() {
              if (this.char === CHAR_COLON) {
                if (this.state.buf.length < 2) {
                  throw this.error(new TomlError("Hours less than 10 must be zero padded to two characters"));
                }
                this.state.result += "T" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseTimeMin);
              } else if (isDigit(this.char)) {
                this.consume();
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseTimeMin() {
              if (this.state.buf.length < 2 && isDigit(this.char)) {
                this.consume();
              } else if (this.state.buf.length === 2 && this.char === CHAR_COLON) {
                this.state.result += ":" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseTimeSec);
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseTimeSec() {
              if (isDigit(this.char)) {
                this.consume();
                if (this.state.buf.length === 2) {
                  this.state.result += ":" + this.state.buf;
                  this.state.buf = "";
                  return this.next(this.parseTimeZoneOrFraction);
                }
              } else {
                throw this.error(new TomlError("Incomplete datetime"));
              }
            }
            parseOnlyTimeHour() {
              if (this.char === CHAR_COLON) {
                if (this.state.buf.length < 2) {
                  throw this.error(new TomlError("Hours less than 10 must be zero padded to two characters"));
                }
                this.state.result = this.state.buf;
                this.state.buf = "";
                return this.next(this.parseOnlyTimeMin);
              } else {
                throw this.error(new TomlError("Incomplete time"));
              }
            }
            parseOnlyTimeMin() {
              if (this.state.buf.length < 2 && isDigit(this.char)) {
                this.consume();
              } else if (this.state.buf.length === 2 && this.char === CHAR_COLON) {
                this.state.result += ":" + this.state.buf;
                this.state.buf = "";
                return this.next(this.parseOnlyTimeSec);
              } else {
                throw this.error(new TomlError("Incomplete time"));
              }
            }
            parseOnlyTimeSec() {
              if (isDigit(this.char)) {
                this.consume();
                if (this.state.buf.length === 2) {
                  return this.next(this.parseOnlyTimeFractionMaybe);
                }
              } else {
                throw this.error(new TomlError("Incomplete time"));
              }
            }
            parseOnlyTimeFractionMaybe() {
              this.state.result += ":" + this.state.buf;
              if (this.char === CHAR_PERIOD) {
                this.state.buf = "";
                this.next(this.parseOnlyTimeFraction);
              } else {
                return this.return(createTime(this.state.result));
              }
            }
            parseOnlyTimeFraction() {
              if (isDigit(this.char)) {
                this.consume();
              } else if (this.atEndOfWord()) {
                if (this.state.buf.length === 0)
                  throw this.error(new TomlError("Expected digit in milliseconds"));
                return this.returnNow(createTime(this.state.result + "." + this.state.buf));
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected period (.), minus (-), plus (+) or Z"));
              }
            }
            parseTimeZoneOrFraction() {
              if (this.char === CHAR_PERIOD) {
                this.consume();
                this.next(this.parseDateTimeFraction);
              } else if (this.char === CHAR_HYPHEN || this.char === CHAR_PLUS) {
                this.consume();
                this.next(this.parseTimeZoneHour);
              } else if (this.char === CHAR_Z) {
                this.consume();
                return this.return(createDateTime(this.state.result + this.state.buf));
              } else if (this.atEndOfWord()) {
                return this.returnNow(createDateTimeFloat(this.state.result + this.state.buf));
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected period (.), minus (-), plus (+) or Z"));
              }
            }
            parseDateTimeFraction() {
              if (isDigit(this.char)) {
                this.consume();
              } else if (this.state.buf.length === 1) {
                throw this.error(new TomlError("Expected digit in milliseconds"));
              } else if (this.char === CHAR_HYPHEN || this.char === CHAR_PLUS) {
                this.consume();
                this.next(this.parseTimeZoneHour);
              } else if (this.char === CHAR_Z) {
                this.consume();
                return this.return(createDateTime(this.state.result + this.state.buf));
              } else if (this.atEndOfWord()) {
                return this.returnNow(createDateTimeFloat(this.state.result + this.state.buf));
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected period (.), minus (-), plus (+) or Z"));
              }
            }
            parseTimeZoneHour() {
              if (isDigit(this.char)) {
                this.consume();
                if (/\d\d$/.test(this.state.buf))
                  return this.next(this.parseTimeZoneSep);
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected digit"));
              }
            }
            parseTimeZoneSep() {
              if (this.char === CHAR_COLON) {
                this.consume();
                this.next(this.parseTimeZoneMin);
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected colon"));
              }
            }
            parseTimeZoneMin() {
              if (isDigit(this.char)) {
                this.consume();
                if (/\d\d$/.test(this.state.buf))
                  return this.return(createDateTime(this.state.result + this.state.buf));
              } else {
                throw this.error(new TomlError("Unexpected character in datetime, expected digit"));
              }
            }
            parseBoolean() {
              if (this.char === CHAR_t) {
                this.consume();
                return this.next(this.parseTrue_r);
              } else if (this.char === CHAR_f) {
                this.consume();
                return this.next(this.parseFalse_a);
              }
            }
            parseTrue_r() {
              if (this.char === CHAR_r) {
                this.consume();
                return this.next(this.parseTrue_u);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseTrue_u() {
              if (this.char === CHAR_u) {
                this.consume();
                return this.next(this.parseTrue_e);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseTrue_e() {
              if (this.char === CHAR_e) {
                return this.return(true);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseFalse_a() {
              if (this.char === CHAR_a) {
                this.consume();
                return this.next(this.parseFalse_l);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseFalse_l() {
              if (this.char === CHAR_l) {
                this.consume();
                return this.next(this.parseFalse_s);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseFalse_s() {
              if (this.char === CHAR_s) {
                this.consume();
                return this.next(this.parseFalse_e);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseFalse_e() {
              if (this.char === CHAR_e) {
                return this.return(false);
              } else {
                throw this.error(new TomlError("Invalid boolean, expected true or false"));
              }
            }
            parseInlineList() {
              if (this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M || this.char === CTRL_J) {
                return null;
              } else if (this.char === Parser.END) {
                throw this.error(new TomlError("Unterminated inline array"));
              } else if (this.char === CHAR_NUM) {
                return this.call(this.parseComment);
              } else if (this.char === CHAR_RSQB) {
                return this.return(this.state.resultArr || InlineList());
              } else {
                return this.callNow(this.parseValue, this.recordInlineListValue);
              }
            }
            recordInlineListValue(value) {
              if (this.state.resultArr) {
                const listType = this.state.resultArr[_contentType];
                const valueType = tomlType(value);
                if (listType !== valueType) {
                  throw this.error(new TomlError(`Inline lists must be a single type, not a mix of ${listType} and ${valueType}`));
                }
              } else {
                this.state.resultArr = InlineList(tomlType(value));
              }
              if (isFloat(value) || isInteger(value)) {
                this.state.resultArr.push(value.valueOf());
              } else {
                this.state.resultArr.push(value);
              }
              return this.goto(this.parseInlineListNext);
            }
            parseInlineListNext() {
              if (this.char === CHAR_SP || this.char === CTRL_I || this.char === CTRL_M || this.char === CTRL_J) {
                return null;
              } else if (this.char === CHAR_NUM) {
                return this.call(this.parseComment);
              } else if (this.char === CHAR_COMMA) {
                return this.next(this.parseInlineList);
              } else if (this.char === CHAR_RSQB) {
                return this.goto(this.parseInlineList);
              } else {
                throw this.error(new TomlError("Invalid character, expected whitespace, comma (,) or close bracket (])"));
              }
            }
            parseInlineTable() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === Parser.END || this.char === CHAR_NUM || this.char === CTRL_J || this.char === CTRL_M) {
                throw this.error(new TomlError("Unterminated inline array"));
              } else if (this.char === CHAR_RCUB) {
                return this.return(this.state.resultTable || InlineTable());
              } else {
                if (!this.state.resultTable)
                  this.state.resultTable = InlineTable();
                return this.callNow(this.parseAssign, this.recordInlineTableValue);
              }
            }
            recordInlineTableValue(kv) {
              let target = this.state.resultTable;
              let finalKey = kv.key.pop();
              for (let kw of kv.key) {
                if (hasKey(target, kw) && (!isTable(target[kw]) || target[kw][_declared])) {
                  throw this.error(new TomlError("Can't redefine existing key"));
                }
                target = target[kw] = target[kw] || Table();
              }
              if (hasKey(target, finalKey)) {
                throw this.error(new TomlError("Can't redefine existing key"));
              }
              if (isInteger(kv.value) || isFloat(kv.value)) {
                target[finalKey] = kv.value.valueOf();
              } else {
                target[finalKey] = kv.value;
              }
              return this.goto(this.parseInlineTableNext);
            }
            parseInlineTableNext() {
              if (this.char === CHAR_SP || this.char === CTRL_I) {
                return null;
              } else if (this.char === Parser.END || this.char === CHAR_NUM || this.char === CTRL_J || this.char === CTRL_M) {
                throw this.error(new TomlError("Unterminated inline array"));
              } else if (this.char === CHAR_COMMA) {
                return this.next(this.parseInlineTable);
              } else if (this.char === CHAR_RCUB) {
                return this.goto(this.parseInlineTable);
              } else {
                throw this.error(new TomlError("Invalid character, expected whitespace, comma (,) or close bracket (])"));
              }
            }
          }
          return TOMLParser;
        }
      }
    });
    var require_parse_pretty_error = __commonJS22({
      "node_modules/@iarna/toml/parse-pretty-error.js"(exports2, module22) {
        "use strict";
        module22.exports = prettyError;
        function prettyError(err, buf) {
          if (err.pos == null || err.line == null)
            return err;
          let msg = err.message;
          msg += ` at row ${err.line + 1}, col ${err.col + 1}, pos ${err.pos}:
`;
          if (buf && buf.split) {
            const lines = buf.split(/\n/);
            const lineNumWidth = String(Math.min(lines.length, err.line + 3)).length;
            let linePadding = " ";
            while (linePadding.length < lineNumWidth)
              linePadding += " ";
            for (let ii = Math.max(0, err.line - 1); ii < Math.min(lines.length, err.line + 2); ++ii) {
              let lineNum = String(ii + 1);
              if (lineNum.length < lineNumWidth)
                lineNum = " " + lineNum;
              if (err.line === ii) {
                msg += lineNum + "> " + lines[ii] + "\n";
                msg += linePadding + "  ";
                for (let hh = 0; hh < err.col; ++hh) {
                  msg += " ";
                }
                msg += "^\n";
              } else {
                msg += lineNum + ": " + lines[ii] + "\n";
              }
            }
          }
          err.message = msg + "\n";
          return err;
        }
      }
    });
    var require_parse_string = __commonJS22({
      "node_modules/@iarna/toml/parse-string.js"(exports2, module22) {
        "use strict";
        module22.exports = parseString;
        var TOMLParser = require_toml_parser();
        var prettyError = require_parse_pretty_error();
        function parseString(str) {
          if (global.Buffer && global.Buffer.isBuffer(str)) {
            str = str.toString("utf8");
          }
          const parser = new TOMLParser();
          try {
            parser.parse(str);
            return parser.finish();
          } catch (err) {
            throw prettyError(err, str);
          }
        }
      }
    });
    var require_load_toml = __commonJS22({
      "src/utils/load-toml.js"(exports2, module22) {
        "use strict";
        var parse3 = require_parse_string();
        module22.exports = function(filePath, content) {
          try {
            return parse3(content);
          } catch (error) {
            error.message = `TOML Error in ${filePath}:
${error.message}`;
            throw error;
          }
        };
      }
    });
    var require_unicode = __commonJS22({
      "node_modules/json5/lib/unicode.js"(exports2, module22) {
        module22.exports.Space_Separator = /[\u1680\u2000-\u200A\u202F\u205F\u3000]/;
        module22.exports.ID_Start = /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE83\uDE86-\uDE89\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]/;
        module22.exports.ID_Continue = /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u0860-\u086A\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u09FC\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9-\u0AFF\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D00-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF9\u1D00-\u1DF9\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312E\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FEA\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF2D-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDE00-\uDE3E\uDE47\uDE50-\uDE83\uDE86-\uDE99\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD36\uDD3A\uDD3C\uDD3D\uDD3F-\uDD47\uDD50-\uDD59]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0\uDFE1]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00-\uDD1E\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/;
      }
    });
    var require_util2 = __commonJS22({
      "node_modules/json5/lib/util.js"(exports2, module22) {
        var unicode = require_unicode();
        module22.exports = {
          isSpaceSeparator(c) {
            return typeof c === "string" && unicode.Space_Separator.test(c);
          },
          isIdStartChar(c) {
            return typeof c === "string" && (c >= "a" && c <= "z" || c >= "A" && c <= "Z" || c === "$" || c === "_" || unicode.ID_Start.test(c));
          },
          isIdContinueChar(c) {
            return typeof c === "string" && (c >= "a" && c <= "z" || c >= "A" && c <= "Z" || c >= "0" && c <= "9" || c === "$" || c === "_" || c === "\u200C" || c === "\u200D" || unicode.ID_Continue.test(c));
          },
          isDigit(c) {
            return typeof c === "string" && /[0-9]/.test(c);
          },
          isHexDigit(c) {
            return typeof c === "string" && /[0-9A-Fa-f]/.test(c);
          }
        };
      }
    });
    var require_parse32 = __commonJS22({
      "node_modules/json5/lib/parse.js"(exports2, module22) {
        var util2 = require_util2();
        var source;
        var parseState;
        var stack;
        var pos;
        var line;
        var column;
        var token;
        var key;
        var root;
        module22.exports = function parse3(text, reviver) {
          source = String(text);
          parseState = "start";
          stack = [];
          pos = 0;
          line = 1;
          column = 0;
          token = void 0;
          key = void 0;
          root = void 0;
          do {
            token = lex();
            parseStates[parseState]();
          } while (token.type !== "eof");
          if (typeof reviver === "function") {
            return internalize({
              "": root
            }, "", reviver);
          }
          return root;
        };
        function internalize(holder, name, reviver) {
          const value = holder[name];
          if (value != null && typeof value === "object") {
            for (const key2 in value) {
              const replacement = internalize(value, key2, reviver);
              if (replacement === void 0) {
                delete value[key2];
              } else {
                value[key2] = replacement;
              }
            }
          }
          return reviver.call(holder, name, value);
        }
        var lexState;
        var buffer;
        var doubleQuote;
        var sign;
        var c;
        function lex() {
          lexState = "default";
          buffer = "";
          doubleQuote = false;
          sign = 1;
          for (; ; ) {
            c = peek();
            const token2 = lexStates[lexState]();
            if (token2) {
              return token2;
            }
          }
        }
        function peek() {
          if (source[pos]) {
            return String.fromCodePoint(source.codePointAt(pos));
          }
        }
        function read2() {
          const c2 = peek();
          if (c2 === "\n") {
            line++;
            column = 0;
          } else if (c2) {
            column += c2.length;
          } else {
            column++;
          }
          if (c2) {
            pos += c2.length;
          }
          return c2;
        }
        var lexStates = {
          default() {
            switch (c) {
              case "	":
              case "\v":
              case "\f":
              case " ":
              case "\xA0":
              case "\uFEFF":
              case "\n":
              case "\r":
              case "\u2028":
              case "\u2029":
                read2();
                return;
              case "/":
                read2();
                lexState = "comment";
                return;
              case void 0:
                read2();
                return newToken("eof");
            }
            if (util2.isSpaceSeparator(c)) {
              read2();
              return;
            }
            return lexStates[parseState]();
          },
          comment() {
            switch (c) {
              case "*":
                read2();
                lexState = "multiLineComment";
                return;
              case "/":
                read2();
                lexState = "singleLineComment";
                return;
            }
            throw invalidChar(read2());
          },
          multiLineComment() {
            switch (c) {
              case "*":
                read2();
                lexState = "multiLineCommentAsterisk";
                return;
              case void 0:
                throw invalidChar(read2());
            }
            read2();
          },
          multiLineCommentAsterisk() {
            switch (c) {
              case "*":
                read2();
                return;
              case "/":
                read2();
                lexState = "default";
                return;
              case void 0:
                throw invalidChar(read2());
            }
            read2();
            lexState = "multiLineComment";
          },
          singleLineComment() {
            switch (c) {
              case "\n":
              case "\r":
              case "\u2028":
              case "\u2029":
                read2();
                lexState = "default";
                return;
              case void 0:
                read2();
                return newToken("eof");
            }
            read2();
          },
          value() {
            switch (c) {
              case "{":
              case "[":
                return newToken("punctuator", read2());
              case "n":
                read2();
                literal("ull");
                return newToken("null", null);
              case "t":
                read2();
                literal("rue");
                return newToken("boolean", true);
              case "f":
                read2();
                literal("alse");
                return newToken("boolean", false);
              case "-":
              case "+":
                if (read2() === "-") {
                  sign = -1;
                }
                lexState = "sign";
                return;
              case ".":
                buffer = read2();
                lexState = "decimalPointLeading";
                return;
              case "0":
                buffer = read2();
                lexState = "zero";
                return;
              case "1":
              case "2":
              case "3":
              case "4":
              case "5":
              case "6":
              case "7":
              case "8":
              case "9":
                buffer = read2();
                lexState = "decimalInteger";
                return;
              case "I":
                read2();
                literal("nfinity");
                return newToken("numeric", Infinity);
              case "N":
                read2();
                literal("aN");
                return newToken("numeric", NaN);
              case '"':
              case "'":
                doubleQuote = read2() === '"';
                buffer = "";
                lexState = "string";
                return;
            }
            throw invalidChar(read2());
          },
          identifierNameStartEscape() {
            if (c !== "u") {
              throw invalidChar(read2());
            }
            read2();
            const u = unicodeEscape();
            switch (u) {
              case "$":
              case "_":
                break;
              default:
                if (!util2.isIdStartChar(u)) {
                  throw invalidIdentifier();
                }
                break;
            }
            buffer += u;
            lexState = "identifierName";
          },
          identifierName() {
            switch (c) {
              case "$":
              case "_":
              case "\u200C":
              case "\u200D":
                buffer += read2();
                return;
              case "\\":
                read2();
                lexState = "identifierNameEscape";
                return;
            }
            if (util2.isIdContinueChar(c)) {
              buffer += read2();
              return;
            }
            return newToken("identifier", buffer);
          },
          identifierNameEscape() {
            if (c !== "u") {
              throw invalidChar(read2());
            }
            read2();
            const u = unicodeEscape();
            switch (u) {
              case "$":
              case "_":
              case "\u200C":
              case "\u200D":
                break;
              default:
                if (!util2.isIdContinueChar(u)) {
                  throw invalidIdentifier();
                }
                break;
            }
            buffer += u;
            lexState = "identifierName";
          },
          sign() {
            switch (c) {
              case ".":
                buffer = read2();
                lexState = "decimalPointLeading";
                return;
              case "0":
                buffer = read2();
                lexState = "zero";
                return;
              case "1":
              case "2":
              case "3":
              case "4":
              case "5":
              case "6":
              case "7":
              case "8":
              case "9":
                buffer = read2();
                lexState = "decimalInteger";
                return;
              case "I":
                read2();
                literal("nfinity");
                return newToken("numeric", sign * Infinity);
              case "N":
                read2();
                literal("aN");
                return newToken("numeric", NaN);
            }
            throw invalidChar(read2());
          },
          zero() {
            switch (c) {
              case ".":
                buffer += read2();
                lexState = "decimalPoint";
                return;
              case "e":
              case "E":
                buffer += read2();
                lexState = "decimalExponent";
                return;
              case "x":
              case "X":
                buffer += read2();
                lexState = "hexadecimal";
                return;
            }
            return newToken("numeric", sign * 0);
          },
          decimalInteger() {
            switch (c) {
              case ".":
                buffer += read2();
                lexState = "decimalPoint";
                return;
              case "e":
              case "E":
                buffer += read2();
                lexState = "decimalExponent";
                return;
            }
            if (util2.isDigit(c)) {
              buffer += read2();
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          decimalPointLeading() {
            if (util2.isDigit(c)) {
              buffer += read2();
              lexState = "decimalFraction";
              return;
            }
            throw invalidChar(read2());
          },
          decimalPoint() {
            switch (c) {
              case "e":
              case "E":
                buffer += read2();
                lexState = "decimalExponent";
                return;
            }
            if (util2.isDigit(c)) {
              buffer += read2();
              lexState = "decimalFraction";
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          decimalFraction() {
            switch (c) {
              case "e":
              case "E":
                buffer += read2();
                lexState = "decimalExponent";
                return;
            }
            if (util2.isDigit(c)) {
              buffer += read2();
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          decimalExponent() {
            switch (c) {
              case "+":
              case "-":
                buffer += read2();
                lexState = "decimalExponentSign";
                return;
            }
            if (util2.isDigit(c)) {
              buffer += read2();
              lexState = "decimalExponentInteger";
              return;
            }
            throw invalidChar(read2());
          },
          decimalExponentSign() {
            if (util2.isDigit(c)) {
              buffer += read2();
              lexState = "decimalExponentInteger";
              return;
            }
            throw invalidChar(read2());
          },
          decimalExponentInteger() {
            if (util2.isDigit(c)) {
              buffer += read2();
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          hexadecimal() {
            if (util2.isHexDigit(c)) {
              buffer += read2();
              lexState = "hexadecimalInteger";
              return;
            }
            throw invalidChar(read2());
          },
          hexadecimalInteger() {
            if (util2.isHexDigit(c)) {
              buffer += read2();
              return;
            }
            return newToken("numeric", sign * Number(buffer));
          },
          string() {
            switch (c) {
              case "\\":
                read2();
                buffer += escape();
                return;
              case '"':
                if (doubleQuote) {
                  read2();
                  return newToken("string", buffer);
                }
                buffer += read2();
                return;
              case "'":
                if (!doubleQuote) {
                  read2();
                  return newToken("string", buffer);
                }
                buffer += read2();
                return;
              case "\n":
              case "\r":
                throw invalidChar(read2());
              case "\u2028":
              case "\u2029":
                separatorChar(c);
                break;
              case void 0:
                throw invalidChar(read2());
            }
            buffer += read2();
          },
          start() {
            switch (c) {
              case "{":
              case "[":
                return newToken("punctuator", read2());
            }
            lexState = "value";
          },
          beforePropertyName() {
            switch (c) {
              case "$":
              case "_":
                buffer = read2();
                lexState = "identifierName";
                return;
              case "\\":
                read2();
                lexState = "identifierNameStartEscape";
                return;
              case "}":
                return newToken("punctuator", read2());
              case '"':
              case "'":
                doubleQuote = read2() === '"';
                lexState = "string";
                return;
            }
            if (util2.isIdStartChar(c)) {
              buffer += read2();
              lexState = "identifierName";
              return;
            }
            throw invalidChar(read2());
          },
          afterPropertyName() {
            if (c === ":") {
              return newToken("punctuator", read2());
            }
            throw invalidChar(read2());
          },
          beforePropertyValue() {
            lexState = "value";
          },
          afterPropertyValue() {
            switch (c) {
              case ",":
              case "}":
                return newToken("punctuator", read2());
            }
            throw invalidChar(read2());
          },
          beforeArrayValue() {
            if (c === "]") {
              return newToken("punctuator", read2());
            }
            lexState = "value";
          },
          afterArrayValue() {
            switch (c) {
              case ",":
              case "]":
                return newToken("punctuator", read2());
            }
            throw invalidChar(read2());
          },
          end() {
            throw invalidChar(read2());
          }
        };
        function newToken(type, value) {
          return {
            type,
            value,
            line,
            column
          };
        }
        function literal(s2) {
          for (const c2 of s2) {
            const p = peek();
            if (p !== c2) {
              throw invalidChar(read2());
            }
            read2();
          }
        }
        function escape() {
          const c2 = peek();
          switch (c2) {
            case "b":
              read2();
              return "\b";
            case "f":
              read2();
              return "\f";
            case "n":
              read2();
              return "\n";
            case "r":
              read2();
              return "\r";
            case "t":
              read2();
              return "	";
            case "v":
              read2();
              return "\v";
            case "0":
              read2();
              if (util2.isDigit(peek())) {
                throw invalidChar(read2());
              }
              return "\0";
            case "x":
              read2();
              return hexEscape();
            case "u":
              read2();
              return unicodeEscape();
            case "\n":
            case "\u2028":
            case "\u2029":
              read2();
              return "";
            case "\r":
              read2();
              if (peek() === "\n") {
                read2();
              }
              return "";
            case "1":
            case "2":
            case "3":
            case "4":
            case "5":
            case "6":
            case "7":
            case "8":
            case "9":
              throw invalidChar(read2());
            case void 0:
              throw invalidChar(read2());
          }
          return read2();
        }
        function hexEscape() {
          let buffer2 = "";
          let c2 = peek();
          if (!util2.isHexDigit(c2)) {
            throw invalidChar(read2());
          }
          buffer2 += read2();
          c2 = peek();
          if (!util2.isHexDigit(c2)) {
            throw invalidChar(read2());
          }
          buffer2 += read2();
          return String.fromCodePoint(parseInt(buffer2, 16));
        }
        function unicodeEscape() {
          let buffer2 = "";
          let count = 4;
          while (count-- > 0) {
            const c2 = peek();
            if (!util2.isHexDigit(c2)) {
              throw invalidChar(read2());
            }
            buffer2 += read2();
          }
          return String.fromCodePoint(parseInt(buffer2, 16));
        }
        var parseStates = {
          start() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            push2();
          },
          beforePropertyName() {
            switch (token.type) {
              case "identifier":
              case "string":
                key = token.value;
                parseState = "afterPropertyName";
                return;
              case "punctuator":
                pop();
                return;
              case "eof":
                throw invalidEOF();
            }
          },
          afterPropertyName() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            parseState = "beforePropertyValue";
          },
          beforePropertyValue() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            push2();
          },
          beforeArrayValue() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            if (token.type === "punctuator" && token.value === "]") {
              pop();
              return;
            }
            push2();
          },
          afterPropertyValue() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            switch (token.value) {
              case ",":
                parseState = "beforePropertyName";
                return;
              case "}":
                pop();
            }
          },
          afterArrayValue() {
            if (token.type === "eof") {
              throw invalidEOF();
            }
            switch (token.value) {
              case ",":
                parseState = "beforeArrayValue";
                return;
              case "]":
                pop();
            }
          },
          end() {
          }
        };
        function push2() {
          let value;
          switch (token.type) {
            case "punctuator":
              switch (token.value) {
                case "{":
                  value = {};
                  break;
                case "[":
                  value = [];
                  break;
              }
              break;
            case "null":
            case "boolean":
            case "numeric":
            case "string":
              value = token.value;
              break;
          }
          if (root === void 0) {
            root = value;
          } else {
            const parent = stack[stack.length - 1];
            if (Array.isArray(parent)) {
              parent.push(value);
            } else {
              parent[key] = value;
            }
          }
          if (value !== null && typeof value === "object") {
            stack.push(value);
            if (Array.isArray(value)) {
              parseState = "beforeArrayValue";
            } else {
              parseState = "beforePropertyName";
            }
          } else {
            const current = stack[stack.length - 1];
            if (current == null) {
              parseState = "end";
            } else if (Array.isArray(current)) {
              parseState = "afterArrayValue";
            } else {
              parseState = "afterPropertyValue";
            }
          }
        }
        function pop() {
          stack.pop();
          const current = stack[stack.length - 1];
          if (current == null) {
            parseState = "end";
          } else if (Array.isArray(current)) {
            parseState = "afterArrayValue";
          } else {
            parseState = "afterPropertyValue";
          }
        }
        function invalidChar(c2) {
          if (c2 === void 0) {
            return syntaxError(`JSON5: invalid end of input at ${line}:${column}`);
          }
          return syntaxError(`JSON5: invalid character '${formatChar(c2)}' at ${line}:${column}`);
        }
        function invalidEOF() {
          return syntaxError(`JSON5: invalid end of input at ${line}:${column}`);
        }
        function invalidIdentifier() {
          column -= 5;
          return syntaxError(`JSON5: invalid identifier character at ${line}:${column}`);
        }
        function separatorChar(c2) {
          console.warn(`JSON5: '${formatChar(c2)}' in strings is not valid ECMAScript; consider escaping`);
        }
        function formatChar(c2) {
          const replacements = {
            "'": "\\'",
            '"': '\\"',
            "\\": "\\\\",
            "\b": "\\b",
            "\f": "\\f",
            "\n": "\\n",
            "\r": "\\r",
            "	": "\\t",
            "\v": "\\v",
            "\0": "\\0",
            "\u2028": "\\u2028",
            "\u2029": "\\u2029"
          };
          if (replacements[c2]) {
            return replacements[c2];
          }
          if (c2 < " ") {
            const hexString = c2.charCodeAt(0).toString(16);
            return "\\x" + ("00" + hexString).substring(hexString.length);
          }
          return c2;
        }
        function syntaxError(message) {
          const err = new SyntaxError(message);
          err.lineNumber = line;
          err.columnNumber = column;
          return err;
        }
      }
    });
    var require_stringify22 = __commonJS22({
      "node_modules/json5/lib/stringify.js"(exports2, module22) {
        var util2 = require_util2();
        module22.exports = function stringify(value, replacer, space) {
          const stack = [];
          let indent = "";
          let propertyList;
          let replacerFunc;
          let gap = "";
          let quote;
          if (replacer != null && typeof replacer === "object" && !Array.isArray(replacer)) {
            space = replacer.space;
            quote = replacer.quote;
            replacer = replacer.replacer;
          }
          if (typeof replacer === "function") {
            replacerFunc = replacer;
          } else if (Array.isArray(replacer)) {
            propertyList = [];
            for (const v of replacer) {
              let item;
              if (typeof v === "string") {
                item = v;
              } else if (typeof v === "number" || v instanceof String || v instanceof Number) {
                item = String(v);
              }
              if (item !== void 0 && propertyList.indexOf(item) < 0) {
                propertyList.push(item);
              }
            }
          }
          if (space instanceof Number) {
            space = Number(space);
          } else if (space instanceof String) {
            space = String(space);
          }
          if (typeof space === "number") {
            if (space > 0) {
              space = Math.min(10, Math.floor(space));
              gap = "          ".substr(0, space);
            }
          } else if (typeof space === "string") {
            gap = space.substr(0, 10);
          }
          return serializeProperty("", {
            "": value
          });
          function serializeProperty(key, holder) {
            let value2 = holder[key];
            if (value2 != null) {
              if (typeof value2.toJSON5 === "function") {
                value2 = value2.toJSON5(key);
              } else if (typeof value2.toJSON === "function") {
                value2 = value2.toJSON(key);
              }
            }
            if (replacerFunc) {
              value2 = replacerFunc.call(holder, key, value2);
            }
            if (value2 instanceof Number) {
              value2 = Number(value2);
            } else if (value2 instanceof String) {
              value2 = String(value2);
            } else if (value2 instanceof Boolean) {
              value2 = value2.valueOf();
            }
            switch (value2) {
              case null:
                return "null";
              case true:
                return "true";
              case false:
                return "false";
            }
            if (typeof value2 === "string") {
              return quoteString(value2, false);
            }
            if (typeof value2 === "number") {
              return String(value2);
            }
            if (typeof value2 === "object") {
              return Array.isArray(value2) ? serializeArray(value2) : serializeObject(value2);
            }
            return void 0;
          }
          function quoteString(value2) {
            const quotes = {
              "'": 0.1,
              '"': 0.2
            };
            const replacements = {
              "'": "\\'",
              '"': '\\"',
              "\\": "\\\\",
              "\b": "\\b",
              "\f": "\\f",
              "\n": "\\n",
              "\r": "\\r",
              "	": "\\t",
              "\v": "\\v",
              "\0": "\\0",
              "\u2028": "\\u2028",
              "\u2029": "\\u2029"
            };
            let product = "";
            for (let i2 = 0; i2 < value2.length; i2++) {
              const c = value2[i2];
              switch (c) {
                case "'":
                case '"':
                  quotes[c]++;
                  product += c;
                  continue;
                case "\0":
                  if (util2.isDigit(value2[i2 + 1])) {
                    product += "\\x00";
                    continue;
                  }
              }
              if (replacements[c]) {
                product += replacements[c];
                continue;
              }
              if (c < " ") {
                let hexString = c.charCodeAt(0).toString(16);
                product += "\\x" + ("00" + hexString).substring(hexString.length);
                continue;
              }
              product += c;
            }
            const quoteChar = quote || Object.keys(quotes).reduce((a, b) => quotes[a] < quotes[b] ? a : b);
            product = product.replace(new RegExp(quoteChar, "g"), replacements[quoteChar]);
            return quoteChar + product + quoteChar;
          }
          function serializeObject(value2) {
            if (stack.indexOf(value2) >= 0) {
              throw TypeError("Converting circular structure to JSON5");
            }
            stack.push(value2);
            let stepback = indent;
            indent = indent + gap;
            let keys = propertyList || Object.keys(value2);
            let partial = [];
            for (const key of keys) {
              const propertyString = serializeProperty(key, value2);
              if (propertyString !== void 0) {
                let member = serializeKey(key) + ":";
                if (gap !== "") {
                  member += " ";
                }
                member += propertyString;
                partial.push(member);
              }
            }
            let final;
            if (partial.length === 0) {
              final = "{}";
            } else {
              let properties;
              if (gap === "") {
                properties = partial.join(",");
                final = "{" + properties + "}";
              } else {
                let separator = ",\n" + indent;
                properties = partial.join(separator);
                final = "{\n" + indent + properties + ",\n" + stepback + "}";
              }
            }
            stack.pop();
            indent = stepback;
            return final;
          }
          function serializeKey(key) {
            if (key.length === 0) {
              return quoteString(key, true);
            }
            const firstChar = String.fromCodePoint(key.codePointAt(0));
            if (!util2.isIdStartChar(firstChar)) {
              return quoteString(key, true);
            }
            for (let i2 = firstChar.length; i2 < key.length; i2++) {
              if (!util2.isIdContinueChar(String.fromCodePoint(key.codePointAt(i2)))) {
                return quoteString(key, true);
              }
            }
            return key;
          }
          function serializeArray(value2) {
            if (stack.indexOf(value2) >= 0) {
              throw TypeError("Converting circular structure to JSON5");
            }
            stack.push(value2);
            let stepback = indent;
            indent = indent + gap;
            let partial = [];
            for (let i2 = 0; i2 < value2.length; i2++) {
              const propertyString = serializeProperty(String(i2), value2);
              partial.push(propertyString !== void 0 ? propertyString : "null");
            }
            let final;
            if (partial.length === 0) {
              final = "[]";
            } else {
              if (gap === "") {
                let properties = partial.join(",");
                final = "[" + properties + "]";
              } else {
                let separator = ",\n" + indent;
                let properties = partial.join(separator);
                final = "[\n" + indent + properties + ",\n" + stepback + "]";
              }
            }
            stack.pop();
            indent = stepback;
            return final;
          }
        };
      }
    });
    var require_lib62 = __commonJS22({
      "node_modules/json5/lib/index.js"(exports2, module22) {
        var parse3 = require_parse32();
        var stringify = require_stringify22();
        var JSON5 = {
          parse: parse3,
          stringify
        };
        module22.exports = JSON5;
      }
    });
    var require_load_json5 = __commonJS22({
      "src/utils/load-json5.js"(exports2, module22) {
        "use strict";
        var {
          parse: parse3
        } = require_lib62();
        module22.exports = function(filePath, content) {
          try {
            return parse3(content);
          } catch (error) {
            error.message = `JSON5 Error in ${filePath}:
${error.message}`;
            throw error;
          }
        };
      }
    });
    var require_partition = __commonJS22({
      "src/utils/partition.js"(exports2, module22) {
        "use strict";
        function partition(array, predicate) {
          const result = [[], []];
          for (const value of array) {
            result[predicate(value) ? 0 : 1].push(value);
          }
          return result;
        }
        module22.exports = partition;
      }
    });
    var require_homedir = __commonJS22({
      "node_modules/resolve/lib/homedir.js"(exports2, module22) {
        "use strict";
        var os = require("os");
        module22.exports = os.homedir || function homedir() {
          var home = process.env.HOME;
          var user = process.env.LOGNAME || process.env.USER || process.env.LNAME || process.env.USERNAME;
          if (process.platform === "win32") {
            return process.env.USERPROFILE || process.env.HOMEDRIVE + process.env.HOMEPATH || home || null;
          }
          if (process.platform === "darwin") {
            return home || (user ? "/Users/" + user : null);
          }
          if (process.platform === "linux") {
            return home || (process.getuid() === 0 ? "/root" : user ? "/home/" + user : null);
          }
          return home || null;
        };
      }
    });
    var require_caller = __commonJS22({
      "node_modules/resolve/lib/caller.js"(exports2, module22) {
        module22.exports = function() {
          var origPrepareStackTrace = Error.prepareStackTrace;
          Error.prepareStackTrace = function(_, stack2) {
            return stack2;
          };
          var stack = new Error().stack;
          Error.prepareStackTrace = origPrepareStackTrace;
          return stack[2].getFileName();
        };
      }
    });
    var require_path_parse = __commonJS22({
      "node_modules/path-parse/index.js"(exports2, module22) {
        "use strict";
        var isWindows = process.platform === "win32";
        var splitWindowsRe = /^(((?:[a-zA-Z]:|[\\\/]{2}[^\\\/]+[\\\/]+[^\\\/]+)?[\\\/]?)(?:[^\\\/]*[\\\/])*)((\.{1,2}|[^\\\/]+?|)(\.[^.\/\\]*|))[\\\/]*$/;
        var win32 = {};
        function win32SplitPath(filename) {
          return splitWindowsRe.exec(filename).slice(1);
        }
        win32.parse = function(pathString) {
          if (typeof pathString !== "string") {
            throw new TypeError("Parameter 'pathString' must be a string, not " + typeof pathString);
          }
          var allParts = win32SplitPath(pathString);
          if (!allParts || allParts.length !== 5) {
            throw new TypeError("Invalid path '" + pathString + "'");
          }
          return {
            root: allParts[1],
            dir: allParts[0] === allParts[1] ? allParts[0] : allParts[0].slice(0, -1),
            base: allParts[2],
            ext: allParts[4],
            name: allParts[3]
          };
        };
        var splitPathRe = /^((\/?)(?:[^\/]*\/)*)((\.{1,2}|[^\/]+?|)(\.[^.\/]*|))[\/]*$/;
        var posix = {};
        function posixSplitPath(filename) {
          return splitPathRe.exec(filename).slice(1);
        }
        posix.parse = function(pathString) {
          if (typeof pathString !== "string") {
            throw new TypeError("Parameter 'pathString' must be a string, not " + typeof pathString);
          }
          var allParts = posixSplitPath(pathString);
          if (!allParts || allParts.length !== 5) {
            throw new TypeError("Invalid path '" + pathString + "'");
          }
          return {
            root: allParts[1],
            dir: allParts[0].slice(0, -1),
            base: allParts[2],
            ext: allParts[4],
            name: allParts[3]
          };
        };
        if (isWindows)
          module22.exports = win32.parse;
        else
          module22.exports = posix.parse;
        module22.exports.posix = posix.parse;
        module22.exports.win32 = win32.parse;
      }
    });
    var require_node_modules_paths = __commonJS22({
      "node_modules/resolve/lib/node-modules-paths.js"(exports2, module22) {
        var path4 = require("path");
        var parse3 = path4.parse || require_path_parse();
        var getNodeModulesDirs = function getNodeModulesDirs2(absoluteStart, modules) {
          var prefix2 = "/";
          if (/^([A-Za-z]:)/.test(absoluteStart)) {
            prefix2 = "";
          } else if (/^\\\\/.test(absoluteStart)) {
            prefix2 = "\\\\";
          }
          var paths = [absoluteStart];
          var parsed = parse3(absoluteStart);
          while (parsed.dir !== paths[paths.length - 1]) {
            paths.push(parsed.dir);
            parsed = parse3(parsed.dir);
          }
          return paths.reduce(function(dirs, aPath) {
            return dirs.concat(modules.map(function(moduleDir) {
              return path4.resolve(prefix2, aPath, moduleDir);
            }));
          }, []);
        };
        module22.exports = function nodeModulesPaths(start, opts, request2) {
          var modules = opts && opts.moduleDirectory ? [].concat(opts.moduleDirectory) : ["node_modules"];
          if (opts && typeof opts.paths === "function") {
            return opts.paths(request2, start, function() {
              return getNodeModulesDirs(start, modules);
            }, opts);
          }
          var dirs = getNodeModulesDirs(start, modules);
          return opts && opts.paths ? dirs.concat(opts.paths) : dirs;
        };
      }
    });
    var require_normalize_options = __commonJS22({
      "node_modules/resolve/lib/normalize-options.js"(exports2, module22) {
        module22.exports = function(x2, opts) {
          return opts || {};
        };
      }
    });
    var require_implementation = __commonJS22({
      "node_modules/function-bind/implementation.js"(exports2, module22) {
        "use strict";
        var ERROR_MESSAGE = "Function.prototype.bind called on incompatible ";
        var slice = Array.prototype.slice;
        var toStr = Object.prototype.toString;
        var funcType = "[object Function]";
        module22.exports = function bind(that) {
          var target = this;
          if (typeof target !== "function" || toStr.call(target) !== funcType) {
            throw new TypeError(ERROR_MESSAGE + target);
          }
          var args = slice.call(arguments, 1);
          var bound;
          var binder = function() {
            if (this instanceof bound) {
              var result = target.apply(this, args.concat(slice.call(arguments)));
              if (Object(result) === result) {
                return result;
              }
              return this;
            } else {
              return target.apply(that, args.concat(slice.call(arguments)));
            }
          };
          var boundLength = Math.max(0, target.length - args.length);
          var boundArgs = [];
          for (var i2 = 0; i2 < boundLength; i2++) {
            boundArgs.push("$" + i2);
          }
          bound = Function("binder", "return function (" + boundArgs.join(",") + "){ return binder.apply(this,arguments); }")(binder);
          if (target.prototype) {
            var Empty = function Empty2() {
            };
            Empty.prototype = target.prototype;
            bound.prototype = new Empty();
            Empty.prototype = null;
          }
          return bound;
        };
      }
    });
    var require_function_bind = __commonJS22({
      "node_modules/function-bind/index.js"(exports2, module22) {
        "use strict";
        var implementation = require_implementation();
        module22.exports = Function.prototype.bind || implementation;
      }
    });
    var require_src = __commonJS22({
      "node_modules/has/src/index.js"(exports2, module22) {
        "use strict";
        var bind = require_function_bind();
        module22.exports = bind.call(Function.call, Object.prototype.hasOwnProperty);
      }
    });
    var require_core22 = __commonJS22({
      "node_modules/is-core-module/core.json"(exports2, module22) {
        module22.exports = {
          assert: true,
          "node:assert": [">= 14.18 && < 15", ">= 16"],
          "assert/strict": ">= 15",
          "node:assert/strict": ">= 16",
          async_hooks: ">= 8",
          "node:async_hooks": [">= 14.18 && < 15", ">= 16"],
          buffer_ieee754: ">= 0.5 && < 0.9.7",
          buffer: true,
          "node:buffer": [">= 14.18 && < 15", ">= 16"],
          child_process: true,
          "node:child_process": [">= 14.18 && < 15", ">= 16"],
          cluster: ">= 0.5",
          "node:cluster": [">= 14.18 && < 15", ">= 16"],
          console: true,
          "node:console": [">= 14.18 && < 15", ">= 16"],
          constants: true,
          "node:constants": [">= 14.18 && < 15", ">= 16"],
          crypto: true,
          "node:crypto": [">= 14.18 && < 15", ">= 16"],
          _debug_agent: ">= 1 && < 8",
          _debugger: "< 8",
          dgram: true,
          "node:dgram": [">= 14.18 && < 15", ">= 16"],
          diagnostics_channel: [">= 14.17 && < 15", ">= 15.1"],
          "node:diagnostics_channel": [">= 14.18 && < 15", ">= 16"],
          dns: true,
          "node:dns": [">= 14.18 && < 15", ">= 16"],
          "dns/promises": ">= 15",
          "node:dns/promises": ">= 16",
          domain: ">= 0.7.12",
          "node:domain": [">= 14.18 && < 15", ">= 16"],
          events: true,
          "node:events": [">= 14.18 && < 15", ">= 16"],
          freelist: "< 6",
          fs: true,
          "node:fs": [">= 14.18 && < 15", ">= 16"],
          "fs/promises": [">= 10 && < 10.1", ">= 14"],
          "node:fs/promises": [">= 14.18 && < 15", ">= 16"],
          _http_agent: ">= 0.11.1",
          "node:_http_agent": [">= 14.18 && < 15", ">= 16"],
          _http_client: ">= 0.11.1",
          "node:_http_client": [">= 14.18 && < 15", ">= 16"],
          _http_common: ">= 0.11.1",
          "node:_http_common": [">= 14.18 && < 15", ">= 16"],
          _http_incoming: ">= 0.11.1",
          "node:_http_incoming": [">= 14.18 && < 15", ">= 16"],
          _http_outgoing: ">= 0.11.1",
          "node:_http_outgoing": [">= 14.18 && < 15", ">= 16"],
          _http_server: ">= 0.11.1",
          "node:_http_server": [">= 14.18 && < 15", ">= 16"],
          http: true,
          "node:http": [">= 14.18 && < 15", ">= 16"],
          http2: ">= 8.8",
          "node:http2": [">= 14.18 && < 15", ">= 16"],
          https: true,
          "node:https": [">= 14.18 && < 15", ">= 16"],
          inspector: ">= 8",
          "node:inspector": [">= 14.18 && < 15", ">= 16"],
          _linklist: "< 8",
          module: true,
          "node:module": [">= 14.18 && < 15", ">= 16"],
          net: true,
          "node:net": [">= 14.18 && < 15", ">= 16"],
          "node-inspect/lib/_inspect": ">= 7.6 && < 12",
          "node-inspect/lib/internal/inspect_client": ">= 7.6 && < 12",
          "node-inspect/lib/internal/inspect_repl": ">= 7.6 && < 12",
          os: true,
          "node:os": [">= 14.18 && < 15", ">= 16"],
          path: true,
          "node:path": [">= 14.18 && < 15", ">= 16"],
          "path/posix": ">= 15.3",
          "node:path/posix": ">= 16",
          "path/win32": ">= 15.3",
          "node:path/win32": ">= 16",
          perf_hooks: ">= 8.5",
          "node:perf_hooks": [">= 14.18 && < 15", ">= 16"],
          process: ">= 1",
          "node:process": [">= 14.18 && < 15", ">= 16"],
          punycode: ">= 0.5",
          "node:punycode": [">= 14.18 && < 15", ">= 16"],
          querystring: true,
          "node:querystring": [">= 14.18 && < 15", ">= 16"],
          readline: true,
          "node:readline": [">= 14.18 && < 15", ">= 16"],
          "readline/promises": ">= 17",
          "node:readline/promises": ">= 17",
          repl: true,
          "node:repl": [">= 14.18 && < 15", ">= 16"],
          smalloc: ">= 0.11.5 && < 3",
          _stream_duplex: ">= 0.9.4",
          "node:_stream_duplex": [">= 14.18 && < 15", ">= 16"],
          _stream_transform: ">= 0.9.4",
          "node:_stream_transform": [">= 14.18 && < 15", ">= 16"],
          _stream_wrap: ">= 1.4.1",
          "node:_stream_wrap": [">= 14.18 && < 15", ">= 16"],
          _stream_passthrough: ">= 0.9.4",
          "node:_stream_passthrough": [">= 14.18 && < 15", ">= 16"],
          _stream_readable: ">= 0.9.4",
          "node:_stream_readable": [">= 14.18 && < 15", ">= 16"],
          _stream_writable: ">= 0.9.4",
          "node:_stream_writable": [">= 14.18 && < 15", ">= 16"],
          stream: true,
          "node:stream": [">= 14.18 && < 15", ">= 16"],
          "stream/consumers": ">= 16.7",
          "node:stream/consumers": ">= 16.7",
          "stream/promises": ">= 15",
          "node:stream/promises": ">= 16",
          "stream/web": ">= 16.5",
          "node:stream/web": ">= 16.5",
          string_decoder: true,
          "node:string_decoder": [">= 14.18 && < 15", ">= 16"],
          sys: [">= 0.4 && < 0.7", ">= 0.8"],
          "node:sys": [">= 14.18 && < 15", ">= 16"],
          timers: true,
          "node:timers": [">= 14.18 && < 15", ">= 16"],
          "timers/promises": ">= 15",
          "node:timers/promises": ">= 16",
          _tls_common: ">= 0.11.13",
          "node:_tls_common": [">= 14.18 && < 15", ">= 16"],
          _tls_legacy: ">= 0.11.3 && < 10",
          _tls_wrap: ">= 0.11.3",
          "node:_tls_wrap": [">= 14.18 && < 15", ">= 16"],
          tls: true,
          "node:tls": [">= 14.18 && < 15", ">= 16"],
          trace_events: ">= 10",
          "node:trace_events": [">= 14.18 && < 15", ">= 16"],
          tty: true,
          "node:tty": [">= 14.18 && < 15", ">= 16"],
          url: true,
          "node:url": [">= 14.18 && < 15", ">= 16"],
          util: true,
          "node:util": [">= 14.18 && < 15", ">= 16"],
          "util/types": ">= 15.3",
          "node:util/types": ">= 16",
          "v8/tools/arguments": ">= 10 && < 12",
          "v8/tools/codemap": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/consarray": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/csvparser": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/logreader": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/profile_view": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/splaytree": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          v8: ">= 1",
          "node:v8": [">= 14.18 && < 15", ">= 16"],
          vm: true,
          "node:vm": [">= 14.18 && < 15", ">= 16"],
          wasi: ">= 13.4 && < 13.5",
          worker_threads: ">= 11.7",
          "node:worker_threads": [">= 14.18 && < 15", ">= 16"],
          zlib: ">= 0.5",
          "node:zlib": [">= 14.18 && < 15", ">= 16"]
        };
      }
    });
    var require_is_core_module = __commonJS22({
      "node_modules/is-core-module/index.js"(exports2, module22) {
        "use strict";
        var has = require_src();
        function specifierIncluded(current, specifier) {
          var nodeParts = current.split(".");
          var parts = specifier.split(" ");
          var op = parts.length > 1 ? parts[0] : "=";
          var versionParts = (parts.length > 1 ? parts[1] : parts[0]).split(".");
          for (var i2 = 0; i2 < 3; ++i2) {
            var cur = parseInt(nodeParts[i2] || 0, 10);
            var ver = parseInt(versionParts[i2] || 0, 10);
            if (cur === ver) {
              continue;
            }
            if (op === "<") {
              return cur < ver;
            }
            if (op === ">=") {
              return cur >= ver;
            }
            return false;
          }
          return op === ">=";
        }
        function matchesRange(current, range) {
          var specifiers = range.split(/ ?&& ?/);
          if (specifiers.length === 0) {
            return false;
          }
          for (var i2 = 0; i2 < specifiers.length; ++i2) {
            if (!specifierIncluded(current, specifiers[i2])) {
              return false;
            }
          }
          return true;
        }
        function versionIncluded(nodeVersion, specifierValue) {
          if (typeof specifierValue === "boolean") {
            return specifierValue;
          }
          var current = typeof nodeVersion === "undefined" ? process.versions && process.versions.node : nodeVersion;
          if (typeof current !== "string") {
            throw new TypeError(typeof nodeVersion === "undefined" ? "Unable to determine current node version" : "If provided, a valid node version is required");
          }
          if (specifierValue && typeof specifierValue === "object") {
            for (var i2 = 0; i2 < specifierValue.length; ++i2) {
              if (matchesRange(current, specifierValue[i2])) {
                return true;
              }
            }
            return false;
          }
          return matchesRange(current, specifierValue);
        }
        var data = require_core22();
        module22.exports = function isCore(x2, nodeVersion) {
          return has(data, x2) && versionIncluded(nodeVersion, data[x2]);
        };
      }
    });
    var require_async6 = __commonJS22({
      "node_modules/resolve/lib/async.js"(exports2, module22) {
        var fs4 = require("fs");
        var getHomedir = require_homedir();
        var path4 = require("path");
        var caller = require_caller();
        var nodeModulesPaths = require_node_modules_paths();
        var normalizeOptions = require_normalize_options();
        var isCore = require_is_core_module();
        var realpathFS = fs4.realpath && typeof fs4.realpath.native === "function" ? fs4.realpath.native : fs4.realpath;
        var homedir = getHomedir();
        var defaultPaths = function() {
          return [path4.join(homedir, ".node_modules"), path4.join(homedir, ".node_libraries")];
        };
        var defaultIsFile = function isFile(file, cb) {
          fs4.stat(file, function(err, stat3) {
            if (!err) {
              return cb(null, stat3.isFile() || stat3.isFIFO());
            }
            if (err.code === "ENOENT" || err.code === "ENOTDIR")
              return cb(null, false);
            return cb(err);
          });
        };
        var defaultIsDir = function isDirectory(dir, cb) {
          fs4.stat(dir, function(err, stat3) {
            if (!err) {
              return cb(null, stat3.isDirectory());
            }
            if (err.code === "ENOENT" || err.code === "ENOTDIR")
              return cb(null, false);
            return cb(err);
          });
        };
        var defaultRealpath = function realpath(x2, cb) {
          realpathFS(x2, function(realpathErr, realPath) {
            if (realpathErr && realpathErr.code !== "ENOENT")
              cb(realpathErr);
            else
              cb(null, realpathErr ? x2 : realPath);
          });
        };
        var maybeRealpath = function maybeRealpath2(realpath, x2, opts, cb) {
          if (opts && opts.preserveSymlinks === false) {
            realpath(x2, cb);
          } else {
            cb(null, x2);
          }
        };
        var defaultReadPackage = function defaultReadPackage2(readFile, pkgfile, cb) {
          readFile(pkgfile, function(readFileErr, body) {
            if (readFileErr)
              cb(readFileErr);
            else {
              try {
                var pkg = JSON.parse(body);
                cb(null, pkg);
              } catch (jsonErr) {
                cb(null);
              }
            }
          });
        };
        var getPackageCandidates = function getPackageCandidates2(x2, start, opts) {
          var dirs = nodeModulesPaths(start, opts, x2);
          for (var i2 = 0; i2 < dirs.length; i2++) {
            dirs[i2] = path4.join(dirs[i2], x2);
          }
          return dirs;
        };
        module22.exports = function resolve(x2, options, callback) {
          var cb = callback;
          var opts = options;
          if (typeof options === "function") {
            cb = opts;
            opts = {};
          }
          if (typeof x2 !== "string") {
            var err = new TypeError("Path must be a string.");
            return process.nextTick(function() {
              cb(err);
            });
          }
          opts = normalizeOptions(x2, opts);
          var isFile = opts.isFile || defaultIsFile;
          var isDirectory = opts.isDirectory || defaultIsDir;
          var readFile = opts.readFile || fs4.readFile;
          var realpath = opts.realpath || defaultRealpath;
          var readPackage = opts.readPackage || defaultReadPackage;
          if (opts.readFile && opts.readPackage) {
            var conflictErr = new TypeError("`readFile` and `readPackage` are mutually exclusive.");
            return process.nextTick(function() {
              cb(conflictErr);
            });
          }
          var packageIterator = opts.packageIterator;
          var extensions = opts.extensions || [".js"];
          var includeCoreModules = opts.includeCoreModules !== false;
          var basedir = opts.basedir || path4.dirname(caller());
          var parent = opts.filename || basedir;
          opts.paths = opts.paths || defaultPaths();
          var absoluteStart = path4.resolve(basedir);
          maybeRealpath(realpath, absoluteStart, opts, function(err2, realStart) {
            if (err2)
              cb(err2);
            else
              init(realStart);
          });
          var res;
          function init(basedir2) {
            if (/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/.test(x2)) {
              res = path4.resolve(basedir2, x2);
              if (x2 === "." || x2 === ".." || x2.slice(-1) === "/")
                res += "/";
              if (/\/$/.test(x2) && res === basedir2) {
                loadAsDirectory(res, opts.package, onfile);
              } else
                loadAsFile(res, opts.package, onfile);
            } else if (includeCoreModules && isCore(x2)) {
              return cb(null, x2);
            } else
              loadNodeModules(x2, basedir2, function(err2, n, pkg) {
                if (err2)
                  cb(err2);
                else if (n) {
                  return maybeRealpath(realpath, n, opts, function(err3, realN) {
                    if (err3) {
                      cb(err3);
                    } else {
                      cb(null, realN, pkg);
                    }
                  });
                } else {
                  var moduleError = new Error("Cannot find module '" + x2 + "' from '" + parent + "'");
                  moduleError.code = "MODULE_NOT_FOUND";
                  cb(moduleError);
                }
              });
          }
          function onfile(err2, m2, pkg) {
            if (err2)
              cb(err2);
            else if (m2)
              cb(null, m2, pkg);
            else
              loadAsDirectory(res, function(err3, d, pkg2) {
                if (err3)
                  cb(err3);
                else if (d) {
                  maybeRealpath(realpath, d, opts, function(err4, realD) {
                    if (err4) {
                      cb(err4);
                    } else {
                      cb(null, realD, pkg2);
                    }
                  });
                } else {
                  var moduleError = new Error("Cannot find module '" + x2 + "' from '" + parent + "'");
                  moduleError.code = "MODULE_NOT_FOUND";
                  cb(moduleError);
                }
              });
          }
          function loadAsFile(x22, thePackage, callback2) {
            var loadAsFilePackage = thePackage;
            var cb2 = callback2;
            if (typeof loadAsFilePackage === "function") {
              cb2 = loadAsFilePackage;
              loadAsFilePackage = void 0;
            }
            var exts = [""].concat(extensions);
            load(exts, x22, loadAsFilePackage);
            function load(exts2, x3, loadPackage) {
              if (exts2.length === 0)
                return cb2(null, void 0, loadPackage);
              var file = x3 + exts2[0];
              var pkg = loadPackage;
              if (pkg)
                onpkg(null, pkg);
              else
                loadpkg(path4.dirname(file), onpkg);
              function onpkg(err2, pkg_, dir) {
                pkg = pkg_;
                if (err2)
                  return cb2(err2);
                if (dir && pkg && opts.pathFilter) {
                  var rfile = path4.relative(dir, file);
                  var rel = rfile.slice(0, rfile.length - exts2[0].length);
                  var r2 = opts.pathFilter(pkg, x3, rel);
                  if (r2)
                    return load([""].concat(extensions.slice()), path4.resolve(dir, r2), pkg);
                }
                isFile(file, onex);
              }
              function onex(err2, ex) {
                if (err2)
                  return cb2(err2);
                if (ex)
                  return cb2(null, file, pkg);
                load(exts2.slice(1), x3, pkg);
              }
            }
          }
          function loadpkg(dir, cb2) {
            if (dir === "" || dir === "/")
              return cb2(null);
            if (process.platform === "win32" && /^\w:[/\\]*$/.test(dir)) {
              return cb2(null);
            }
            if (/[/\\]node_modules[/\\]*$/.test(dir))
              return cb2(null);
            maybeRealpath(realpath, dir, opts, function(unwrapErr, pkgdir) {
              if (unwrapErr)
                return loadpkg(path4.dirname(dir), cb2);
              var pkgfile = path4.join(pkgdir, "package.json");
              isFile(pkgfile, function(err2, ex) {
                if (!ex)
                  return loadpkg(path4.dirname(dir), cb2);
                readPackage(readFile, pkgfile, function(err3, pkgParam) {
                  if (err3)
                    cb2(err3);
                  var pkg = pkgParam;
                  if (pkg && opts.packageFilter) {
                    pkg = opts.packageFilter(pkg, pkgfile);
                  }
                  cb2(null, pkg, dir);
                });
              });
            });
          }
          function loadAsDirectory(x22, loadAsDirectoryPackage, callback2) {
            var cb2 = callback2;
            var fpkg = loadAsDirectoryPackage;
            if (typeof fpkg === "function") {
              cb2 = fpkg;
              fpkg = opts.package;
            }
            maybeRealpath(realpath, x22, opts, function(unwrapErr, pkgdir) {
              if (unwrapErr)
                return cb2(unwrapErr);
              var pkgfile = path4.join(pkgdir, "package.json");
              isFile(pkgfile, function(err2, ex) {
                if (err2)
                  return cb2(err2);
                if (!ex)
                  return loadAsFile(path4.join(x22, "index"), fpkg, cb2);
                readPackage(readFile, pkgfile, function(err3, pkgParam) {
                  if (err3)
                    return cb2(err3);
                  var pkg = pkgParam;
                  if (pkg && opts.packageFilter) {
                    pkg = opts.packageFilter(pkg, pkgfile);
                  }
                  if (pkg && pkg.main) {
                    if (typeof pkg.main !== "string") {
                      var mainError = new TypeError("package \u201C" + pkg.name + "\u201D `main` must be a string");
                      mainError.code = "INVALID_PACKAGE_MAIN";
                      return cb2(mainError);
                    }
                    if (pkg.main === "." || pkg.main === "./") {
                      pkg.main = "index";
                    }
                    loadAsFile(path4.resolve(x22, pkg.main), pkg, function(err4, m2, pkg2) {
                      if (err4)
                        return cb2(err4);
                      if (m2)
                        return cb2(null, m2, pkg2);
                      if (!pkg2)
                        return loadAsFile(path4.join(x22, "index"), pkg2, cb2);
                      var dir = path4.resolve(x22, pkg2.main);
                      loadAsDirectory(dir, pkg2, function(err5, n, pkg3) {
                        if (err5)
                          return cb2(err5);
                        if (n)
                          return cb2(null, n, pkg3);
                        loadAsFile(path4.join(x22, "index"), pkg3, cb2);
                      });
                    });
                    return;
                  }
                  loadAsFile(path4.join(x22, "/index"), pkg, cb2);
                });
              });
            });
          }
          function processDirs(cb2, dirs) {
            if (dirs.length === 0)
              return cb2(null, void 0);
            var dir = dirs[0];
            isDirectory(path4.dirname(dir), isdir);
            function isdir(err2, isdir2) {
              if (err2)
                return cb2(err2);
              if (!isdir2)
                return processDirs(cb2, dirs.slice(1));
              loadAsFile(dir, opts.package, onfile2);
            }
            function onfile2(err2, m2, pkg) {
              if (err2)
                return cb2(err2);
              if (m2)
                return cb2(null, m2, pkg);
              loadAsDirectory(dir, opts.package, ondir);
            }
            function ondir(err2, n, pkg) {
              if (err2)
                return cb2(err2);
              if (n)
                return cb2(null, n, pkg);
              processDirs(cb2, dirs.slice(1));
            }
          }
          function loadNodeModules(x22, start, cb2) {
            var thunk = function() {
              return getPackageCandidates(x22, start, opts);
            };
            processDirs(cb2, packageIterator ? packageIterator(x22, start, thunk, opts) : thunk());
          }
        };
      }
    });
    var require_core32 = __commonJS22({
      "node_modules/resolve/lib/core.json"(exports2, module22) {
        module22.exports = {
          assert: true,
          "node:assert": [">= 14.18 && < 15", ">= 16"],
          "assert/strict": ">= 15",
          "node:assert/strict": ">= 16",
          async_hooks: ">= 8",
          "node:async_hooks": [">= 14.18 && < 15", ">= 16"],
          buffer_ieee754: ">= 0.5 && < 0.9.7",
          buffer: true,
          "node:buffer": [">= 14.18 && < 15", ">= 16"],
          child_process: true,
          "node:child_process": [">= 14.18 && < 15", ">= 16"],
          cluster: ">= 0.5",
          "node:cluster": [">= 14.18 && < 15", ">= 16"],
          console: true,
          "node:console": [">= 14.18 && < 15", ">= 16"],
          constants: true,
          "node:constants": [">= 14.18 && < 15", ">= 16"],
          crypto: true,
          "node:crypto": [">= 14.18 && < 15", ">= 16"],
          _debug_agent: ">= 1 && < 8",
          _debugger: "< 8",
          dgram: true,
          "node:dgram": [">= 14.18 && < 15", ">= 16"],
          diagnostics_channel: [">= 14.17 && < 15", ">= 15.1"],
          "node:diagnostics_channel": [">= 14.18 && < 15", ">= 16"],
          dns: true,
          "node:dns": [">= 14.18 && < 15", ">= 16"],
          "dns/promises": ">= 15",
          "node:dns/promises": ">= 16",
          domain: ">= 0.7.12",
          "node:domain": [">= 14.18 && < 15", ">= 16"],
          events: true,
          "node:events": [">= 14.18 && < 15", ">= 16"],
          freelist: "< 6",
          fs: true,
          "node:fs": [">= 14.18 && < 15", ">= 16"],
          "fs/promises": [">= 10 && < 10.1", ">= 14"],
          "node:fs/promises": [">= 14.18 && < 15", ">= 16"],
          _http_agent: ">= 0.11.1",
          "node:_http_agent": [">= 14.18 && < 15", ">= 16"],
          _http_client: ">= 0.11.1",
          "node:_http_client": [">= 14.18 && < 15", ">= 16"],
          _http_common: ">= 0.11.1",
          "node:_http_common": [">= 14.18 && < 15", ">= 16"],
          _http_incoming: ">= 0.11.1",
          "node:_http_incoming": [">= 14.18 && < 15", ">= 16"],
          _http_outgoing: ">= 0.11.1",
          "node:_http_outgoing": [">= 14.18 && < 15", ">= 16"],
          _http_server: ">= 0.11.1",
          "node:_http_server": [">= 14.18 && < 15", ">= 16"],
          http: true,
          "node:http": [">= 14.18 && < 15", ">= 16"],
          http2: ">= 8.8",
          "node:http2": [">= 14.18 && < 15", ">= 16"],
          https: true,
          "node:https": [">= 14.18 && < 15", ">= 16"],
          inspector: ">= 8",
          "node:inspector": [">= 14.18 && < 15", ">= 16"],
          _linklist: "< 8",
          module: true,
          "node:module": [">= 14.18 && < 15", ">= 16"],
          net: true,
          "node:net": [">= 14.18 && < 15", ">= 16"],
          "node-inspect/lib/_inspect": ">= 7.6 && < 12",
          "node-inspect/lib/internal/inspect_client": ">= 7.6 && < 12",
          "node-inspect/lib/internal/inspect_repl": ">= 7.6 && < 12",
          os: true,
          "node:os": [">= 14.18 && < 15", ">= 16"],
          path: true,
          "node:path": [">= 14.18 && < 15", ">= 16"],
          "path/posix": ">= 15.3",
          "node:path/posix": ">= 16",
          "path/win32": ">= 15.3",
          "node:path/win32": ">= 16",
          perf_hooks: ">= 8.5",
          "node:perf_hooks": [">= 14.18 && < 15", ">= 16"],
          process: ">= 1",
          "node:process": [">= 14.18 && < 15", ">= 16"],
          punycode: ">= 0.5",
          "node:punycode": [">= 14.18 && < 15", ">= 16"],
          querystring: true,
          "node:querystring": [">= 14.18 && < 15", ">= 16"],
          readline: true,
          "node:readline": [">= 14.18 && < 15", ">= 16"],
          "readline/promises": ">= 17",
          "node:readline/promises": ">= 17",
          repl: true,
          "node:repl": [">= 14.18 && < 15", ">= 16"],
          smalloc: ">= 0.11.5 && < 3",
          _stream_duplex: ">= 0.9.4",
          "node:_stream_duplex": [">= 14.18 && < 15", ">= 16"],
          _stream_transform: ">= 0.9.4",
          "node:_stream_transform": [">= 14.18 && < 15", ">= 16"],
          _stream_wrap: ">= 1.4.1",
          "node:_stream_wrap": [">= 14.18 && < 15", ">= 16"],
          _stream_passthrough: ">= 0.9.4",
          "node:_stream_passthrough": [">= 14.18 && < 15", ">= 16"],
          _stream_readable: ">= 0.9.4",
          "node:_stream_readable": [">= 14.18 && < 15", ">= 16"],
          _stream_writable: ">= 0.9.4",
          "node:_stream_writable": [">= 14.18 && < 15", ">= 16"],
          stream: true,
          "node:stream": [">= 14.18 && < 15", ">= 16"],
          "stream/consumers": ">= 16.7",
          "node:stream/consumers": ">= 16.7",
          "stream/promises": ">= 15",
          "node:stream/promises": ">= 16",
          "stream/web": ">= 16.5",
          "node:stream/web": ">= 16.5",
          string_decoder: true,
          "node:string_decoder": [">= 14.18 && < 15", ">= 16"],
          sys: [">= 0.4 && < 0.7", ">= 0.8"],
          "node:sys": [">= 14.18 && < 15", ">= 16"],
          timers: true,
          "node:timers": [">= 14.18 && < 15", ">= 16"],
          "timers/promises": ">= 15",
          "node:timers/promises": ">= 16",
          _tls_common: ">= 0.11.13",
          "node:_tls_common": [">= 14.18 && < 15", ">= 16"],
          _tls_legacy: ">= 0.11.3 && < 10",
          _tls_wrap: ">= 0.11.3",
          "node:_tls_wrap": [">= 14.18 && < 15", ">= 16"],
          tls: true,
          "node:tls": [">= 14.18 && < 15", ">= 16"],
          trace_events: ">= 10",
          "node:trace_events": [">= 14.18 && < 15", ">= 16"],
          tty: true,
          "node:tty": [">= 14.18 && < 15", ">= 16"],
          url: true,
          "node:url": [">= 14.18 && < 15", ">= 16"],
          util: true,
          "node:util": [">= 14.18 && < 15", ">= 16"],
          "util/types": ">= 15.3",
          "node:util/types": ">= 16",
          "v8/tools/arguments": ">= 10 && < 12",
          "v8/tools/codemap": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/consarray": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/csvparser": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/logreader": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/profile_view": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          "v8/tools/splaytree": [">= 4.4 && < 5", ">= 5.2 && < 12"],
          v8: ">= 1",
          "node:v8": [">= 14.18 && < 15", ">= 16"],
          vm: true,
          "node:vm": [">= 14.18 && < 15", ">= 16"],
          wasi: ">= 13.4 && < 13.5",
          worker_threads: ">= 11.7",
          "node:worker_threads": [">= 14.18 && < 15", ">= 16"],
          zlib: ">= 0.5",
          "node:zlib": [">= 14.18 && < 15", ">= 16"]
        };
      }
    });
    var require_core4 = __commonJS22({
      "node_modules/resolve/lib/core.js"(exports2, module22) {
        var current = process.versions && process.versions.node && process.versions.node.split(".") || [];
        function specifierIncluded(specifier) {
          var parts = specifier.split(" ");
          var op = parts.length > 1 ? parts[0] : "=";
          var versionParts = (parts.length > 1 ? parts[1] : parts[0]).split(".");
          for (var i2 = 0; i2 < 3; ++i2) {
            var cur = parseInt(current[i2] || 0, 10);
            var ver = parseInt(versionParts[i2] || 0, 10);
            if (cur === ver) {
              continue;
            }
            if (op === "<") {
              return cur < ver;
            } else if (op === ">=") {
              return cur >= ver;
            }
            return false;
          }
          return op === ">=";
        }
        function matchesRange(range) {
          var specifiers = range.split(/ ?&& ?/);
          if (specifiers.length === 0) {
            return false;
          }
          for (var i2 = 0; i2 < specifiers.length; ++i2) {
            if (!specifierIncluded(specifiers[i2])) {
              return false;
            }
          }
          return true;
        }
        function versionIncluded(specifierValue) {
          if (typeof specifierValue === "boolean") {
            return specifierValue;
          }
          if (specifierValue && typeof specifierValue === "object") {
            for (var i2 = 0; i2 < specifierValue.length; ++i2) {
              if (matchesRange(specifierValue[i2])) {
                return true;
              }
            }
            return false;
          }
          return matchesRange(specifierValue);
        }
        var data = require_core32();
        var core22 = {};
        for (mod in data) {
          if (Object.prototype.hasOwnProperty.call(data, mod)) {
            core22[mod] = versionIncluded(data[mod]);
          }
        }
        var mod;
        module22.exports = core22;
      }
    });
    var require_is_core = __commonJS22({
      "node_modules/resolve/lib/is-core.js"(exports2, module22) {
        var isCoreModule = require_is_core_module();
        module22.exports = function isCore(x2) {
          return isCoreModule(x2);
        };
      }
    });
    var require_sync7 = __commonJS22({
      "node_modules/resolve/lib/sync.js"(exports2, module22) {
        var isCore = require_is_core_module();
        var fs4 = require("fs");
        var path4 = require("path");
        var getHomedir = require_homedir();
        var caller = require_caller();
        var nodeModulesPaths = require_node_modules_paths();
        var normalizeOptions = require_normalize_options();
        var realpathFS = fs4.realpathSync && typeof fs4.realpathSync.native === "function" ? fs4.realpathSync.native : fs4.realpathSync;
        var homedir = getHomedir();
        var defaultPaths = function() {
          return [path4.join(homedir, ".node_modules"), path4.join(homedir, ".node_libraries")];
        };
        var defaultIsFile = function isFile(file) {
          try {
            var stat3 = fs4.statSync(file, {
              throwIfNoEntry: false
            });
          } catch (e2) {
            if (e2 && (e2.code === "ENOENT" || e2.code === "ENOTDIR"))
              return false;
            throw e2;
          }
          return !!stat3 && (stat3.isFile() || stat3.isFIFO());
        };
        var defaultIsDir = function isDirectory(dir) {
          try {
            var stat3 = fs4.statSync(dir, {
              throwIfNoEntry: false
            });
          } catch (e2) {
            if (e2 && (e2.code === "ENOENT" || e2.code === "ENOTDIR"))
              return false;
            throw e2;
          }
          return !!stat3 && stat3.isDirectory();
        };
        var defaultRealpathSync = function realpathSync(x2) {
          try {
            return realpathFS(x2);
          } catch (realpathErr) {
            if (realpathErr.code !== "ENOENT") {
              throw realpathErr;
            }
          }
          return x2;
        };
        var maybeRealpathSync = function maybeRealpathSync2(realpathSync, x2, opts) {
          if (opts && opts.preserveSymlinks === false) {
            return realpathSync(x2);
          }
          return x2;
        };
        var defaultReadPackageSync = function defaultReadPackageSync2(readFileSync, pkgfile) {
          var body = readFileSync(pkgfile);
          try {
            var pkg = JSON.parse(body);
            return pkg;
          } catch (jsonErr) {
          }
        };
        var getPackageCandidates = function getPackageCandidates2(x2, start, opts) {
          var dirs = nodeModulesPaths(start, opts, x2);
          for (var i2 = 0; i2 < dirs.length; i2++) {
            dirs[i2] = path4.join(dirs[i2], x2);
          }
          return dirs;
        };
        module22.exports = function resolveSync(x2, options) {
          if (typeof x2 !== "string") {
            throw new TypeError("Path must be a string.");
          }
          var opts = normalizeOptions(x2, options);
          var isFile = opts.isFile || defaultIsFile;
          var readFileSync = opts.readFileSync || fs4.readFileSync;
          var isDirectory = opts.isDirectory || defaultIsDir;
          var realpathSync = opts.realpathSync || defaultRealpathSync;
          var readPackageSync = opts.readPackageSync || defaultReadPackageSync;
          if (opts.readFileSync && opts.readPackageSync) {
            throw new TypeError("`readFileSync` and `readPackageSync` are mutually exclusive.");
          }
          var packageIterator = opts.packageIterator;
          var extensions = opts.extensions || [".js"];
          var includeCoreModules = opts.includeCoreModules !== false;
          var basedir = opts.basedir || path4.dirname(caller());
          var parent = opts.filename || basedir;
          opts.paths = opts.paths || defaultPaths();
          var absoluteStart = maybeRealpathSync(realpathSync, path4.resolve(basedir), opts);
          if (/^(?:\.\.?(?:\/|$)|\/|([A-Za-z]:)?[/\\])/.test(x2)) {
            var res = path4.resolve(absoluteStart, x2);
            if (x2 === "." || x2 === ".." || x2.slice(-1) === "/")
              res += "/";
            var m2 = loadAsFileSync(res) || loadAsDirectorySync(res);
            if (m2)
              return maybeRealpathSync(realpathSync, m2, opts);
          } else if (includeCoreModules && isCore(x2)) {
            return x2;
          } else {
            var n = loadNodeModulesSync(x2, absoluteStart);
            if (n)
              return maybeRealpathSync(realpathSync, n, opts);
          }
          var err = new Error("Cannot find module '" + x2 + "' from '" + parent + "'");
          err.code = "MODULE_NOT_FOUND";
          throw err;
          function loadAsFileSync(x22) {
            var pkg = loadpkg(path4.dirname(x22));
            if (pkg && pkg.dir && pkg.pkg && opts.pathFilter) {
              var rfile = path4.relative(pkg.dir, x22);
              var r2 = opts.pathFilter(pkg.pkg, x22, rfile);
              if (r2) {
                x22 = path4.resolve(pkg.dir, r2);
              }
            }
            if (isFile(x22)) {
              return x22;
            }
            for (var i2 = 0; i2 < extensions.length; i2++) {
              var file = x22 + extensions[i2];
              if (isFile(file)) {
                return file;
              }
            }
          }
          function loadpkg(dir) {
            if (dir === "" || dir === "/")
              return;
            if (process.platform === "win32" && /^\w:[/\\]*$/.test(dir)) {
              return;
            }
            if (/[/\\]node_modules[/\\]*$/.test(dir))
              return;
            var pkgfile = path4.join(maybeRealpathSync(realpathSync, dir, opts), "package.json");
            if (!isFile(pkgfile)) {
              return loadpkg(path4.dirname(dir));
            }
            var pkg = readPackageSync(readFileSync, pkgfile);
            if (pkg && opts.packageFilter) {
              pkg = opts.packageFilter(pkg, dir);
            }
            return {
              pkg,
              dir
            };
          }
          function loadAsDirectorySync(x22) {
            var pkgfile = path4.join(maybeRealpathSync(realpathSync, x22, opts), "/package.json");
            if (isFile(pkgfile)) {
              try {
                var pkg = readPackageSync(readFileSync, pkgfile);
              } catch (e2) {
              }
              if (pkg && opts.packageFilter) {
                pkg = opts.packageFilter(pkg, x22);
              }
              if (pkg && pkg.main) {
                if (typeof pkg.main !== "string") {
                  var mainError = new TypeError("package \u201C" + pkg.name + "\u201D `main` must be a string");
                  mainError.code = "INVALID_PACKAGE_MAIN";
                  throw mainError;
                }
                if (pkg.main === "." || pkg.main === "./") {
                  pkg.main = "index";
                }
                try {
                  var m22 = loadAsFileSync(path4.resolve(x22, pkg.main));
                  if (m22)
                    return m22;
                  var n2 = loadAsDirectorySync(path4.resolve(x22, pkg.main));
                  if (n2)
                    return n2;
                } catch (e2) {
                }
              }
            }
            return loadAsFileSync(path4.join(x22, "/index"));
          }
          function loadNodeModulesSync(x22, start) {
            var thunk = function() {
              return getPackageCandidates(x22, start, opts);
            };
            var dirs = packageIterator ? packageIterator(x22, start, thunk, opts) : thunk();
            for (var i2 = 0; i2 < dirs.length; i2++) {
              var dir = dirs[i2];
              if (isDirectory(path4.dirname(dir))) {
                var m22 = loadAsFileSync(dir);
                if (m22)
                  return m22;
                var n2 = loadAsDirectorySync(dir);
                if (n2)
                  return n2;
              }
            }
          }
        };
      }
    });
    var require_resolve = __commonJS22({
      "node_modules/resolve/index.js"(exports2, module22) {
        var async = require_async6();
        async.core = require_core4();
        async.isCore = require_is_core();
        async.sync = require_sync7();
        module22.exports = async;
      }
    });
    var require_resolve2 = __commonJS22({
      "src/common/resolve.js"(exports2, module22) {
        "use strict";
        var {
          resolve
        } = require;
        if (resolve.length === 1 || process.env.PRETTIER_FALLBACK_RESOLVE) {
          resolve = (id, options) => {
            let basedir;
            if (options && options.paths && options.paths.length === 1) {
              basedir = options.paths[0];
            }
            return require_resolve().sync(id, {
              basedir
            });
          };
        }
        module22.exports = resolve;
      }
    });
    function mimicFunction(to, from, {
      ignoreNonConfigurable = false
    } = {}) {
      const {
        name
      } = to;
      for (const property of Reflect.ownKeys(from)) {
        copyProperty(to, from, property, ignoreNonConfigurable);
      }
      changePrototype(to, from);
      changeToString(to, from, name);
      return to;
    }
    var copyProperty;
    var canCopyProperty;
    var changePrototype;
    var wrappedToString;
    var toStringDescriptor;
    var toStringName;
    var changeToString;
    var init_mimic_fn = __esm2({
      "node_modules/mimic-fn/index.js"() {
        copyProperty = (to, from, property, ignoreNonConfigurable) => {
          if (property === "length" || property === "prototype") {
            return;
          }
          if (property === "arguments" || property === "caller") {
            return;
          }
          const toDescriptor = Object.getOwnPropertyDescriptor(to, property);
          const fromDescriptor = Object.getOwnPropertyDescriptor(from, property);
          if (!canCopyProperty(toDescriptor, fromDescriptor) && ignoreNonConfigurable) {
            return;
          }
          Object.defineProperty(to, property, fromDescriptor);
        };
        canCopyProperty = function(toDescriptor, fromDescriptor) {
          return toDescriptor === void 0 || toDescriptor.configurable || toDescriptor.writable === fromDescriptor.writable && toDescriptor.enumerable === fromDescriptor.enumerable && toDescriptor.configurable === fromDescriptor.configurable && (toDescriptor.writable || toDescriptor.value === fromDescriptor.value);
        };
        changePrototype = (to, from) => {
          const fromPrototype = Object.getPrototypeOf(from);
          if (fromPrototype === Object.getPrototypeOf(to)) {
            return;
          }
          Object.setPrototypeOf(to, fromPrototype);
        };
        wrappedToString = (withName, fromBody) => `/* Wrapped ${withName}*/
${fromBody}`;
        toStringDescriptor = Object.getOwnPropertyDescriptor(Function.prototype, "toString");
        toStringName = Object.getOwnPropertyDescriptor(Function.prototype.toString, "name");
        changeToString = (to, from, name) => {
          const withName = name === "" ? "" : `with ${name.trim()}() `;
          const newToString = wrappedToString.bind(null, withName, from.toString());
          Object.defineProperty(newToString, "name", toStringName);
          Object.defineProperty(to, "toString", Object.assign(Object.assign({}, toStringDescriptor), {}, {
            value: newToString
          }));
        };
      }
    });
    var require_p_defer = __commonJS22({
      "node_modules/p-defer/index.js"(exports2, module22) {
        "use strict";
        module22.exports = () => {
          const ret = {};
          ret.promise = new Promise((resolve, reject) => {
            ret.resolve = resolve;
            ret.reject = reject;
          });
          return ret;
        };
      }
    });
    var require_dist = __commonJS22({
      "node_modules/map-age-cleaner/dist/index.js"(exports2, module22) {
        "use strict";
        var __awaiter2 = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
          return new (P || (P = Promise))(function(resolve, reject) {
            function fulfilled(value) {
              try {
                step(generator.next(value));
              } catch (e2) {
                reject(e2);
              }
            }
            function rejected(value) {
              try {
                step(generator["throw"](value));
              } catch (e2) {
                reject(e2);
              }
            }
            function step(result) {
              result.done ? resolve(result.value) : new P(function(resolve2) {
                resolve2(result.value);
              }).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
          });
        };
        var __importDefault2 = exports2 && exports2.__importDefault || function(mod) {
          return mod && mod.__esModule ? mod : {
            "default": mod
          };
        };
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var p_defer_1 = __importDefault2(require_p_defer());
        function mapAgeCleaner2(map, property = "maxAge") {
          let processingKey;
          let processingTimer;
          let processingDeferred;
          const cleanup = () => __awaiter2(this, void 0, void 0, function* () {
            if (processingKey !== void 0) {
              return;
            }
            const setupTimer = (item) => __awaiter2(this, void 0, void 0, function* () {
              processingDeferred = p_defer_1.default();
              const delay = item[1][property] - Date.now();
              if (delay <= 0) {
                map.delete(item[0]);
                processingDeferred.resolve();
                return;
              }
              processingKey = item[0];
              processingTimer = setTimeout(() => {
                map.delete(item[0]);
                if (processingDeferred) {
                  processingDeferred.resolve();
                }
              }, delay);
              if (typeof processingTimer.unref === "function") {
                processingTimer.unref();
              }
              return processingDeferred.promise;
            });
            try {
              for (const entry of map) {
                yield setupTimer(entry);
              }
            } catch (_a4) {
            }
            processingKey = void 0;
          });
          const reset = () => {
            processingKey = void 0;
            if (processingTimer !== void 0) {
              clearTimeout(processingTimer);
              processingTimer = void 0;
            }
            if (processingDeferred !== void 0) {
              processingDeferred.reject(void 0);
              processingDeferred = void 0;
            }
          };
          const originalSet = map.set.bind(map);
          map.set = (key, value) => {
            if (map.has(key)) {
              map.delete(key);
            }
            const result = originalSet(key, value);
            if (processingKey && processingKey === key) {
              reset();
            }
            cleanup();
            return result;
          };
          cleanup();
          return map;
        }
        exports2.default = mapAgeCleaner2;
        module22.exports = mapAgeCleaner2;
        module22.exports.default = mapAgeCleaner2;
      }
    });
    var dist_exports = {};
    __export2(dist_exports, {
      default: () => mem,
      memClear: () => memClear,
      memDecorator: () => memDecorator
    });
    function mem(fn, {
      cacheKey,
      cache = /* @__PURE__ */ new Map(),
      maxAge
    } = {}) {
      if (typeof maxAge === "number") {
        (0, import_map_age_cleaner.default)(cache);
      }
      const memoized = function(...arguments_) {
        const key = cacheKey ? cacheKey(arguments_) : arguments_[0];
        const cacheItem = cache.get(key);
        if (cacheItem) {
          return cacheItem.data;
        }
        const result = fn.apply(this, arguments_);
        cache.set(key, {
          data: result,
          maxAge: maxAge ? Date.now() + maxAge : Number.POSITIVE_INFINITY
        });
        return result;
      };
      mimicFunction(memoized, fn, {
        ignoreNonConfigurable: true
      });
      cacheStore.set(memoized, cache);
      return memoized;
    }
    function memDecorator(options = {}) {
      const instanceMap = /* @__PURE__ */ new WeakMap();
      return (target, propertyKey, descriptor) => {
        const input = target[propertyKey];
        if (typeof input !== "function") {
          throw new TypeError("The decorated value must be a function");
        }
        delete descriptor.value;
        delete descriptor.writable;
        descriptor.get = function() {
          if (!instanceMap.has(this)) {
            const value = mem(input, options);
            instanceMap.set(this, value);
            return value;
          }
          return instanceMap.get(this);
        };
      };
    }
    function memClear(fn) {
      const cache = cacheStore.get(fn);
      if (!cache) {
        throw new TypeError("Can't clear a function that was not memoized!");
      }
      if (typeof cache.clear !== "function") {
        throw new TypeError("The cache Map can't be cleared!");
      }
      cache.clear();
    }
    var import_map_age_cleaner;
    var cacheStore;
    var init_dist = __esm2({
      "node_modules/mem/dist/index.js"() {
        init_mimic_fn();
        import_map_age_cleaner = __toESM2(require_dist());
        cacheStore = /* @__PURE__ */ new WeakMap();
      }
    });
    var require_pseudomap = __commonJS22({
      "node_modules/pseudomap/pseudomap.js"(exports2, module22) {
        var hasOwnProperty = Object.prototype.hasOwnProperty;
        module22.exports = PseudoMap;
        function PseudoMap(set2) {
          if (!(this instanceof PseudoMap))
            throw new TypeError("Constructor PseudoMap requires 'new'");
          this.clear();
          if (set2) {
            if (set2 instanceof PseudoMap || typeof Map === "function" && set2 instanceof Map)
              set2.forEach(function(value, key) {
                this.set(key, value);
              }, this);
            else if (Array.isArray(set2))
              set2.forEach(function(kv) {
                this.set(kv[0], kv[1]);
              }, this);
            else
              throw new TypeError("invalid argument");
          }
        }
        PseudoMap.prototype.forEach = function(fn, thisp) {
          thisp = thisp || this;
          Object.keys(this._data).forEach(function(k) {
            if (k !== "size")
              fn.call(thisp, this._data[k].value, this._data[k].key);
          }, this);
        };
        PseudoMap.prototype.has = function(k) {
          return !!find2(this._data, k);
        };
        PseudoMap.prototype.get = function(k) {
          var res = find2(this._data, k);
          return res && res.value;
        };
        PseudoMap.prototype.set = function(k, v) {
          set(this._data, k, v);
        };
        PseudoMap.prototype.delete = function(k) {
          var res = find2(this._data, k);
          if (res) {
            delete this._data[res._index];
            this._data.size--;
          }
        };
        PseudoMap.prototype.clear = function() {
          var data = /* @__PURE__ */ Object.create(null);
          data.size = 0;
          Object.defineProperty(this, "_data", {
            value: data,
            enumerable: false,
            configurable: true,
            writable: false
          });
        };
        Object.defineProperty(PseudoMap.prototype, "size", {
          get: function() {
            return this._data.size;
          },
          set: function(n) {
          },
          enumerable: true,
          configurable: true
        });
        PseudoMap.prototype.values = PseudoMap.prototype.keys = PseudoMap.prototype.entries = function() {
          throw new Error("iterators are not implemented in this version");
        };
        function same(a, b) {
          return a === b || a !== a && b !== b;
        }
        function Entry(k, v, i2) {
          this.key = k;
          this.value = v;
          this._index = i2;
        }
        function find2(data, k) {
          for (var i2 = 0, s2 = "_" + k, key = s2; hasOwnProperty.call(data, key); key = s2 + i2++) {
            if (same(data[key].key, k))
              return data[key];
          }
        }
        function set(data, k, v) {
          for (var i2 = 0, s2 = "_" + k, key = s2; hasOwnProperty.call(data, key); key = s2 + i2++) {
            if (same(data[key].key, k)) {
              data[key].value = v;
              return;
            }
          }
          data.size++;
          data[key] = new Entry(k, v, key);
        }
      }
    });
    var require_map2 = __commonJS22({
      "node_modules/pseudomap/map.js"(exports2, module22) {
        if (process.env.npm_package_name === "pseudomap" && process.env.npm_lifecycle_script === "test")
          process.env.TEST_PSEUDOMAP = "true";
        if (typeof Map === "function" && !process.env.TEST_PSEUDOMAP) {
          module22.exports = Map;
        } else {
          module22.exports = require_pseudomap();
        }
      }
    });
    var require_yallist2 = __commonJS22({
      "node_modules/editorconfig/node_modules/yallist/yallist.js"(exports2, module22) {
        module22.exports = Yallist;
        Yallist.Node = Node;
        Yallist.create = Yallist;
        function Yallist(list) {
          var self2 = this;
          if (!(self2 instanceof Yallist)) {
            self2 = new Yallist();
          }
          self2.tail = null;
          self2.head = null;
          self2.length = 0;
          if (list && typeof list.forEach === "function") {
            list.forEach(function(item) {
              self2.push(item);
            });
          } else if (arguments.length > 0) {
            for (var i2 = 0, l = arguments.length; i2 < l; i2++) {
              self2.push(arguments[i2]);
            }
          }
          return self2;
        }
        Yallist.prototype.removeNode = function(node) {
          if (node.list !== this) {
            throw new Error("removing node which does not belong to this list");
          }
          var next = node.next;
          var prev = node.prev;
          if (next) {
            next.prev = prev;
          }
          if (prev) {
            prev.next = next;
          }
          if (node === this.head) {
            this.head = next;
          }
          if (node === this.tail) {
            this.tail = prev;
          }
          node.list.length--;
          node.next = null;
          node.prev = null;
          node.list = null;
        };
        Yallist.prototype.unshiftNode = function(node) {
          if (node === this.head) {
            return;
          }
          if (node.list) {
            node.list.removeNode(node);
          }
          var head = this.head;
          node.list = this;
          node.next = head;
          if (head) {
            head.prev = node;
          }
          this.head = node;
          if (!this.tail) {
            this.tail = node;
          }
          this.length++;
        };
        Yallist.prototype.pushNode = function(node) {
          if (node === this.tail) {
            return;
          }
          if (node.list) {
            node.list.removeNode(node);
          }
          var tail = this.tail;
          node.list = this;
          node.prev = tail;
          if (tail) {
            tail.next = node;
          }
          this.tail = node;
          if (!this.head) {
            this.head = node;
          }
          this.length++;
        };
        Yallist.prototype.push = function() {
          for (var i2 = 0, l = arguments.length; i2 < l; i2++) {
            push2(this, arguments[i2]);
          }
          return this.length;
        };
        Yallist.prototype.unshift = function() {
          for (var i2 = 0, l = arguments.length; i2 < l; i2++) {
            unshift(this, arguments[i2]);
          }
          return this.length;
        };
        Yallist.prototype.pop = function() {
          if (!this.tail) {
            return void 0;
          }
          var res = this.tail.value;
          this.tail = this.tail.prev;
          if (this.tail) {
            this.tail.next = null;
          } else {
            this.head = null;
          }
          this.length--;
          return res;
        };
        Yallist.prototype.shift = function() {
          if (!this.head) {
            return void 0;
          }
          var res = this.head.value;
          this.head = this.head.next;
          if (this.head) {
            this.head.prev = null;
          } else {
            this.tail = null;
          }
          this.length--;
          return res;
        };
        Yallist.prototype.forEach = function(fn, thisp) {
          thisp = thisp || this;
          for (var walker = this.head, i2 = 0; walker !== null; i2++) {
            fn.call(thisp, walker.value, i2, this);
            walker = walker.next;
          }
        };
        Yallist.prototype.forEachReverse = function(fn, thisp) {
          thisp = thisp || this;
          for (var walker = this.tail, i2 = this.length - 1; walker !== null; i2--) {
            fn.call(thisp, walker.value, i2, this);
            walker = walker.prev;
          }
        };
        Yallist.prototype.get = function(n) {
          for (var i2 = 0, walker = this.head; walker !== null && i2 < n; i2++) {
            walker = walker.next;
          }
          if (i2 === n && walker !== null) {
            return walker.value;
          }
        };
        Yallist.prototype.getReverse = function(n) {
          for (var i2 = 0, walker = this.tail; walker !== null && i2 < n; i2++) {
            walker = walker.prev;
          }
          if (i2 === n && walker !== null) {
            return walker.value;
          }
        };
        Yallist.prototype.map = function(fn, thisp) {
          thisp = thisp || this;
          var res = new Yallist();
          for (var walker = this.head; walker !== null; ) {
            res.push(fn.call(thisp, walker.value, this));
            walker = walker.next;
          }
          return res;
        };
        Yallist.prototype.mapReverse = function(fn, thisp) {
          thisp = thisp || this;
          var res = new Yallist();
          for (var walker = this.tail; walker !== null; ) {
            res.push(fn.call(thisp, walker.value, this));
            walker = walker.prev;
          }
          return res;
        };
        Yallist.prototype.reduce = function(fn, initial) {
          var acc;
          var walker = this.head;
          if (arguments.length > 1) {
            acc = initial;
          } else if (this.head) {
            walker = this.head.next;
            acc = this.head.value;
          } else {
            throw new TypeError("Reduce of empty list with no initial value");
          }
          for (var i2 = 0; walker !== null; i2++) {
            acc = fn(acc, walker.value, i2);
            walker = walker.next;
          }
          return acc;
        };
        Yallist.prototype.reduceReverse = function(fn, initial) {
          var acc;
          var walker = this.tail;
          if (arguments.length > 1) {
            acc = initial;
          } else if (this.tail) {
            walker = this.tail.prev;
            acc = this.tail.value;
          } else {
            throw new TypeError("Reduce of empty list with no initial value");
          }
          for (var i2 = this.length - 1; walker !== null; i2--) {
            acc = fn(acc, walker.value, i2);
            walker = walker.prev;
          }
          return acc;
        };
        Yallist.prototype.toArray = function() {
          var arr = new Array(this.length);
          for (var i2 = 0, walker = this.head; walker !== null; i2++) {
            arr[i2] = walker.value;
            walker = walker.next;
          }
          return arr;
        };
        Yallist.prototype.toArrayReverse = function() {
          var arr = new Array(this.length);
          for (var i2 = 0, walker = this.tail; walker !== null; i2++) {
            arr[i2] = walker.value;
            walker = walker.prev;
          }
          return arr;
        };
        Yallist.prototype.slice = function(from, to) {
          to = to || this.length;
          if (to < 0) {
            to += this.length;
          }
          from = from || 0;
          if (from < 0) {
            from += this.length;
          }
          var ret = new Yallist();
          if (to < from || to < 0) {
            return ret;
          }
          if (from < 0) {
            from = 0;
          }
          if (to > this.length) {
            to = this.length;
          }
          for (var i2 = 0, walker = this.head; walker !== null && i2 < from; i2++) {
            walker = walker.next;
          }
          for (; walker !== null && i2 < to; i2++, walker = walker.next) {
            ret.push(walker.value);
          }
          return ret;
        };
        Yallist.prototype.sliceReverse = function(from, to) {
          to = to || this.length;
          if (to < 0) {
            to += this.length;
          }
          from = from || 0;
          if (from < 0) {
            from += this.length;
          }
          var ret = new Yallist();
          if (to < from || to < 0) {
            return ret;
          }
          if (from < 0) {
            from = 0;
          }
          if (to > this.length) {
            to = this.length;
          }
          for (var i2 = this.length, walker = this.tail; walker !== null && i2 > to; i2--) {
            walker = walker.prev;
          }
          for (; walker !== null && i2 > from; i2--, walker = walker.prev) {
            ret.push(walker.value);
          }
          return ret;
        };
        Yallist.prototype.reverse = function() {
          var head = this.head;
          var tail = this.tail;
          for (var walker = head; walker !== null; walker = walker.prev) {
            var p = walker.prev;
            walker.prev = walker.next;
            walker.next = p;
          }
          this.head = tail;
          this.tail = head;
          return this;
        };
        function push2(self2, item) {
          self2.tail = new Node(item, self2.tail, null, self2);
          if (!self2.head) {
            self2.head = self2.tail;
          }
          self2.length++;
        }
        function unshift(self2, item) {
          self2.head = new Node(item, null, self2.head, self2);
          if (!self2.tail) {
            self2.tail = self2.head;
          }
          self2.length++;
        }
        function Node(value, prev, next, list) {
          if (!(this instanceof Node)) {
            return new Node(value, prev, next, list);
          }
          this.list = list;
          this.value = value;
          if (prev) {
            prev.next = this;
            this.prev = prev;
          } else {
            this.prev = null;
          }
          if (next) {
            next.prev = this;
            this.next = next;
          } else {
            this.next = null;
          }
        }
      }
    });
    var require_lru_cache2 = __commonJS22({
      "node_modules/editorconfig/node_modules/lru-cache/index.js"(exports2, module22) {
        "use strict";
        module22.exports = LRUCache;
        var Map2 = require_map2();
        var util2 = require("util");
        var Yallist = require_yallist2();
        var hasSymbol = typeof Symbol === "function" && process.env._nodeLRUCacheForceNoSymbol !== "1";
        var makeSymbol;
        if (hasSymbol) {
          makeSymbol = function(key) {
            return Symbol(key);
          };
        } else {
          makeSymbol = function(key) {
            return "_" + key;
          };
        }
        var MAX = makeSymbol("max");
        var LENGTH = makeSymbol("length");
        var LENGTH_CALCULATOR = makeSymbol("lengthCalculator");
        var ALLOW_STALE = makeSymbol("allowStale");
        var MAX_AGE = makeSymbol("maxAge");
        var DISPOSE = makeSymbol("dispose");
        var NO_DISPOSE_ON_SET = makeSymbol("noDisposeOnSet");
        var LRU_LIST = makeSymbol("lruList");
        var CACHE = makeSymbol("cache");
        function naiveLength() {
          return 1;
        }
        function LRUCache(options) {
          if (!(this instanceof LRUCache)) {
            return new LRUCache(options);
          }
          if (typeof options === "number") {
            options = {
              max: options
            };
          }
          if (!options) {
            options = {};
          }
          var max = this[MAX] = options.max;
          if (!max || !(typeof max === "number") || max <= 0) {
            this[MAX] = Infinity;
          }
          var lc = options.length || naiveLength;
          if (typeof lc !== "function") {
            lc = naiveLength;
          }
          this[LENGTH_CALCULATOR] = lc;
          this[ALLOW_STALE] = options.stale || false;
          this[MAX_AGE] = options.maxAge || 0;
          this[DISPOSE] = options.dispose;
          this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
          this.reset();
        }
        Object.defineProperty(LRUCache.prototype, "max", {
          set: function(mL) {
            if (!mL || !(typeof mL === "number") || mL <= 0) {
              mL = Infinity;
            }
            this[MAX] = mL;
            trim(this);
          },
          get: function() {
            return this[MAX];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "allowStale", {
          set: function(allowStale) {
            this[ALLOW_STALE] = !!allowStale;
          },
          get: function() {
            return this[ALLOW_STALE];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "maxAge", {
          set: function(mA) {
            if (!mA || !(typeof mA === "number") || mA < 0) {
              mA = 0;
            }
            this[MAX_AGE] = mA;
            trim(this);
          },
          get: function() {
            return this[MAX_AGE];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "lengthCalculator", {
          set: function(lC) {
            if (typeof lC !== "function") {
              lC = naiveLength;
            }
            if (lC !== this[LENGTH_CALCULATOR]) {
              this[LENGTH_CALCULATOR] = lC;
              this[LENGTH] = 0;
              this[LRU_LIST].forEach(function(hit) {
                hit.length = this[LENGTH_CALCULATOR](hit.value, hit.key);
                this[LENGTH] += hit.length;
              }, this);
            }
            trim(this);
          },
          get: function() {
            return this[LENGTH_CALCULATOR];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "length", {
          get: function() {
            return this[LENGTH];
          },
          enumerable: true
        });
        Object.defineProperty(LRUCache.prototype, "itemCount", {
          get: function() {
            return this[LRU_LIST].length;
          },
          enumerable: true
        });
        LRUCache.prototype.rforEach = function(fn, thisp) {
          thisp = thisp || this;
          for (var walker = this[LRU_LIST].tail; walker !== null; ) {
            var prev = walker.prev;
            forEachStep(this, fn, walker, thisp);
            walker = prev;
          }
        };
        function forEachStep(self2, fn, node, thisp) {
          var hit = node.value;
          if (isStale(self2, hit)) {
            del(self2, node);
            if (!self2[ALLOW_STALE]) {
              hit = void 0;
            }
          }
          if (hit) {
            fn.call(thisp, hit.value, hit.key, self2);
          }
        }
        LRUCache.prototype.forEach = function(fn, thisp) {
          thisp = thisp || this;
          for (var walker = this[LRU_LIST].head; walker !== null; ) {
            var next = walker.next;
            forEachStep(this, fn, walker, thisp);
            walker = next;
          }
        };
        LRUCache.prototype.keys = function() {
          return this[LRU_LIST].toArray().map(function(k) {
            return k.key;
          }, this);
        };
        LRUCache.prototype.values = function() {
          return this[LRU_LIST].toArray().map(function(k) {
            return k.value;
          }, this);
        };
        LRUCache.prototype.reset = function() {
          if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
            this[LRU_LIST].forEach(function(hit) {
              this[DISPOSE](hit.key, hit.value);
            }, this);
          }
          this[CACHE] = new Map2();
          this[LRU_LIST] = new Yallist();
          this[LENGTH] = 0;
        };
        LRUCache.prototype.dump = function() {
          return this[LRU_LIST].map(function(hit) {
            if (!isStale(this, hit)) {
              return {
                k: hit.key,
                v: hit.value,
                e: hit.now + (hit.maxAge || 0)
              };
            }
          }, this).toArray().filter(function(h2) {
            return h2;
          });
        };
        LRUCache.prototype.dumpLru = function() {
          return this[LRU_LIST];
        };
        LRUCache.prototype.inspect = function(n, opts) {
          var str = "LRUCache {";
          var extras = false;
          var as = this[ALLOW_STALE];
          if (as) {
            str += "\n  allowStale: true";
            extras = true;
          }
          var max = this[MAX];
          if (max && max !== Infinity) {
            if (extras) {
              str += ",";
            }
            str += "\n  max: " + util2.inspect(max, opts);
            extras = true;
          }
          var maxAge = this[MAX_AGE];
          if (maxAge) {
            if (extras) {
              str += ",";
            }
            str += "\n  maxAge: " + util2.inspect(maxAge, opts);
            extras = true;
          }
          var lc = this[LENGTH_CALCULATOR];
          if (lc && lc !== naiveLength) {
            if (extras) {
              str += ",";
            }
            str += "\n  length: " + util2.inspect(this[LENGTH], opts);
            extras = true;
          }
          var didFirst = false;
          this[LRU_LIST].forEach(function(item) {
            if (didFirst) {
              str += ",\n  ";
            } else {
              if (extras) {
                str += ",\n";
              }
              didFirst = true;
              str += "\n  ";
            }
            var key = util2.inspect(item.key).split("\n").join("\n  ");
            var val = {
              value: item.value
            };
            if (item.maxAge !== maxAge) {
              val.maxAge = item.maxAge;
            }
            if (lc !== naiveLength) {
              val.length = item.length;
            }
            if (isStale(this, item)) {
              val.stale = true;
            }
            val = util2.inspect(val, opts).split("\n").join("\n  ");
            str += key + " => " + val;
          });
          if (didFirst || extras) {
            str += "\n";
          }
          str += "}";
          return str;
        };
        LRUCache.prototype.set = function(key, value, maxAge) {
          maxAge = maxAge || this[MAX_AGE];
          var now = maxAge ? Date.now() : 0;
          var len = this[LENGTH_CALCULATOR](value, key);
          if (this[CACHE].has(key)) {
            if (len > this[MAX]) {
              del(this, this[CACHE].get(key));
              return false;
            }
            var node = this[CACHE].get(key);
            var item = node.value;
            if (this[DISPOSE]) {
              if (!this[NO_DISPOSE_ON_SET]) {
                this[DISPOSE](key, item.value);
              }
            }
            item.now = now;
            item.maxAge = maxAge;
            item.value = value;
            this[LENGTH] += len - item.length;
            item.length = len;
            this.get(key);
            trim(this);
            return true;
          }
          var hit = new Entry(key, value, len, now, maxAge);
          if (hit.length > this[MAX]) {
            if (this[DISPOSE]) {
              this[DISPOSE](key, value);
            }
            return false;
          }
          this[LENGTH] += hit.length;
          this[LRU_LIST].unshift(hit);
          this[CACHE].set(key, this[LRU_LIST].head);
          trim(this);
          return true;
        };
        LRUCache.prototype.has = function(key) {
          if (!this[CACHE].has(key))
            return false;
          var hit = this[CACHE].get(key).value;
          if (isStale(this, hit)) {
            return false;
          }
          return true;
        };
        LRUCache.prototype.get = function(key) {
          return get(this, key, true);
        };
        LRUCache.prototype.peek = function(key) {
          return get(this, key, false);
        };
        LRUCache.prototype.pop = function() {
          var node = this[LRU_LIST].tail;
          if (!node)
            return null;
          del(this, node);
          return node.value;
        };
        LRUCache.prototype.del = function(key) {
          del(this, this[CACHE].get(key));
        };
        LRUCache.prototype.load = function(arr) {
          this.reset();
          var now = Date.now();
          for (var l = arr.length - 1; l >= 0; l--) {
            var hit = arr[l];
            var expiresAt = hit.e || 0;
            if (expiresAt === 0) {
              this.set(hit.k, hit.v);
            } else {
              var maxAge = expiresAt - now;
              if (maxAge > 0) {
                this.set(hit.k, hit.v, maxAge);
              }
            }
          }
        };
        LRUCache.prototype.prune = function() {
          var self2 = this;
          this[CACHE].forEach(function(value, key) {
            get(self2, key, false);
          });
        };
        function get(self2, key, doUse) {
          var node = self2[CACHE].get(key);
          if (node) {
            var hit = node.value;
            if (isStale(self2, hit)) {
              del(self2, node);
              if (!self2[ALLOW_STALE])
                hit = void 0;
            } else {
              if (doUse) {
                self2[LRU_LIST].unshiftNode(node);
              }
            }
            if (hit)
              hit = hit.value;
          }
          return hit;
        }
        function isStale(self2, hit) {
          if (!hit || !hit.maxAge && !self2[MAX_AGE]) {
            return false;
          }
          var stale = false;
          var diff2 = Date.now() - hit.now;
          if (hit.maxAge) {
            stale = diff2 > hit.maxAge;
          } else {
            stale = self2[MAX_AGE] && diff2 > self2[MAX_AGE];
          }
          return stale;
        }
        function trim(self2) {
          if (self2[LENGTH] > self2[MAX]) {
            for (var walker = self2[LRU_LIST].tail; self2[LENGTH] > self2[MAX] && walker !== null; ) {
              var prev = walker.prev;
              del(self2, walker);
              walker = prev;
            }
          }
        }
        function del(self2, node) {
          if (node) {
            var hit = node.value;
            if (self2[DISPOSE]) {
              self2[DISPOSE](hit.key, hit.value);
            }
            self2[LENGTH] -= hit.length;
            self2[CACHE].delete(hit.key);
            self2[LRU_LIST].removeNode(node);
          }
        }
        function Entry(key, value, length, now, maxAge) {
          this.key = key;
          this.value = value;
          this.length = length;
          this.now = now;
          this.maxAge = maxAge || 0;
        }
      }
    });
    var require_sigmund = __commonJS22({
      "node_modules/sigmund/sigmund.js"(exports2, module22) {
        module22.exports = sigmund;
        function sigmund(subject, maxSessions) {
          maxSessions = maxSessions || 10;
          var notes = [];
          var analysis = "";
          var RE = RegExp;
          function psychoAnalyze(subject2, session) {
            if (session > maxSessions)
              return;
            if (typeof subject2 === "function" || typeof subject2 === "undefined") {
              return;
            }
            if (typeof subject2 !== "object" || !subject2 || subject2 instanceof RE) {
              analysis += subject2;
              return;
            }
            if (notes.indexOf(subject2) !== -1 || session === maxSessions)
              return;
            notes.push(subject2);
            analysis += "{";
            Object.keys(subject2).forEach(function(issue, _, __) {
              if (issue.charAt(0) === "_")
                return;
              var to = typeof subject2[issue];
              if (to === "function" || to === "undefined")
                return;
              analysis += issue;
              psychoAnalyze(subject2[issue], session + 1);
            });
          }
          psychoAnalyze(subject, 0);
          return analysis;
        }
      }
    });
    var require_fnmatch = __commonJS22({
      "node_modules/editorconfig/src/lib/fnmatch.js"(exports2, module22) {
        var platform = typeof process === "object" ? process.platform : "win32";
        if (module22)
          module22.exports = minimatch;
        else
          exports2.minimatch = minimatch;
        minimatch.Minimatch = Minimatch;
        var LRU = require_lru_cache2();
        var cache = minimatch.cache = new LRU({
          max: 100
        });
        var GLOBSTAR = minimatch.GLOBSTAR = Minimatch.GLOBSTAR = {};
        var sigmund = require_sigmund();
        var path4 = require("path");
        var qmark = "[^/]";
        var star = qmark + "*?";
        var twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?";
        var twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?";
        var reSpecials = charSet("().*{}+?[]^$\\!");
        function charSet(s2) {
          return s2.split("").reduce(function(set, c) {
            set[c] = true;
            return set;
          }, {});
        }
        var slashSplit = /\/+/;
        minimatch.monkeyPatch = monkeyPatch;
        function monkeyPatch() {
          var desc = Object.getOwnPropertyDescriptor(String.prototype, "match");
          var orig = desc.value;
          desc.value = function(p) {
            if (p instanceof Minimatch)
              return p.match(this);
            return orig.call(this, p);
          };
          Object.defineProperty(String.prototype, desc);
        }
        minimatch.filter = filter;
        function filter(pattern, options) {
          options = options || {};
          return function(p, i2, list) {
            return minimatch(p, pattern, options);
          };
        }
        function ext(a, b) {
          a = a || {};
          b = b || {};
          var t2 = {};
          Object.keys(b).forEach(function(k) {
            t2[k] = b[k];
          });
          Object.keys(a).forEach(function(k) {
            t2[k] = a[k];
          });
          return t2;
        }
        minimatch.defaults = function(def) {
          if (!def || !Object.keys(def).length)
            return minimatch;
          var orig = minimatch;
          var m2 = function minimatch2(p, pattern, options) {
            return orig.minimatch(p, pattern, ext(def, options));
          };
          m2.Minimatch = function Minimatch2(pattern, options) {
            return new orig.Minimatch(pattern, ext(def, options));
          };
          return m2;
        };
        Minimatch.defaults = function(def) {
          if (!def || !Object.keys(def).length)
            return Minimatch;
          return minimatch.defaults(def).Minimatch;
        };
        function minimatch(p, pattern, options) {
          if (typeof pattern !== "string") {
            throw new TypeError("glob pattern string required");
          }
          if (!options)
            options = {};
          if (!options.nocomment && pattern.charAt(0) === "#") {
            return false;
          }
          if (pattern.trim() === "")
            return p === "";
          return new Minimatch(pattern, options).match(p);
        }
        function Minimatch(pattern, options) {
          if (!(this instanceof Minimatch)) {
            return new Minimatch(pattern, options, cache);
          }
          if (typeof pattern !== "string") {
            throw new TypeError("glob pattern string required");
          }
          if (!options)
            options = {};
          if (platform === "win32") {
            pattern = pattern.split("\\").join("/");
          }
          var cacheKey = pattern + "\n" + sigmund(options);
          var cached = minimatch.cache.get(cacheKey);
          if (cached)
            return cached;
          minimatch.cache.set(cacheKey, this);
          this.options = options;
          this.set = [];
          this.pattern = pattern;
          this.regexp = null;
          this.negate = false;
          this.comment = false;
          this.empty = false;
          this.make();
        }
        Minimatch.prototype.make = make;
        function make() {
          if (this._made)
            return;
          var pattern = this.pattern;
          var options = this.options;
          if (!options.nocomment && pattern.charAt(0) === "#") {
            this.comment = true;
            return;
          }
          if (!pattern) {
            this.empty = true;
            return;
          }
          this.parseNegate();
          var set = this.globSet = this.braceExpand();
          if (options.debug)
            console.error(this.pattern, set);
          set = this.globParts = set.map(function(s2) {
            return s2.split(slashSplit);
          });
          if (options.debug)
            console.error(this.pattern, set);
          set = set.map(function(s2, si, set2) {
            return s2.map(this.parse, this);
          }, this);
          if (options.debug)
            console.error(this.pattern, set);
          set = set.filter(function(s2) {
            return s2.indexOf(false) === -1;
          });
          if (options.debug)
            console.error(this.pattern, set);
          this.set = set;
        }
        Minimatch.prototype.parseNegate = parseNegate;
        function parseNegate() {
          var pattern = this.pattern, negate = false, options = this.options, negateOffset = 0;
          if (options.nonegate)
            return;
          for (var i2 = 0, l = pattern.length; i2 < l && pattern.charAt(i2) === "!"; i2++) {
            negate = !negate;
            negateOffset++;
          }
          if (negateOffset)
            this.pattern = pattern.substr(negateOffset);
          this.negate = negate;
        }
        minimatch.braceExpand = function(pattern, options) {
          return new Minimatch(pattern, options).braceExpand();
        };
        Minimatch.prototype.braceExpand = braceExpand;
        function braceExpand(pattern, options) {
          options = options || this.options;
          pattern = typeof pattern === "undefined" ? this.pattern : pattern;
          if (typeof pattern === "undefined") {
            throw new Error("undefined pattern");
          }
          if (options.nobrace || !pattern.match(/\{.*\}/)) {
            return [pattern];
          }
          var escaping = false;
          if (pattern.charAt(0) !== "{") {
            var prefix2 = null;
            for (var i2 = 0, l = pattern.length; i2 < l; i2++) {
              var c = pattern.charAt(i2);
              if (c === "\\") {
                escaping = !escaping;
              } else if (c === "{" && !escaping) {
                prefix2 = pattern.substr(0, i2);
                break;
              }
            }
            if (prefix2 === null) {
              return [pattern];
            }
            var tail = braceExpand(pattern.substr(i2), options);
            return tail.map(function(t2) {
              return prefix2 + t2;
            });
          }
          var numset = pattern.match(/^\{(-?[0-9]+)\.\.(-?[0-9]+)\}/);
          if (numset) {
            var suf = braceExpand(pattern.substr(numset[0].length), options), start = +numset[1], end = +numset[2], inc = start > end ? -1 : 1, set = [];
            for (var i2 = start; i2 != end + inc; i2 += inc) {
              for (var ii = 0, ll = suf.length; ii < ll; ii++) {
                set.push(i2 + suf[ii]);
              }
            }
            return set;
          }
          var i2 = 1, depth = 1, set = [], member = "", sawEnd = false, escaping = false;
          function addMember() {
            set.push(member);
            member = "";
          }
          FOR:
            for (i2 = 1, l = pattern.length; i2 < l; i2++) {
              var c = pattern.charAt(i2);
              if (escaping) {
                escaping = false;
                member += "\\" + c;
              } else {
                switch (c) {
                  case "\\":
                    escaping = true;
                    continue;
                  case "{":
                    depth++;
                    member += "{";
                    continue;
                  case "}":
                    depth--;
                    if (depth === 0) {
                      addMember();
                      i2++;
                      break FOR;
                    } else {
                      member += c;
                      continue;
                    }
                  case ",":
                    if (depth === 1) {
                      addMember();
                    } else {
                      member += c;
                    }
                    continue;
                  default:
                    member += c;
                    continue;
                }
              }
            }
          if (depth !== 0) {
            return braceExpand("\\" + pattern, options);
          }
          var suf = braceExpand(pattern.substr(i2), options);
          var addBraces = set.length === 1;
          set = set.map(function(p) {
            return braceExpand(p, options);
          });
          set = set.reduce(function(l2, r2) {
            return l2.concat(r2);
          });
          if (addBraces) {
            set = set.map(function(s2) {
              return "{" + s2 + "}";
            });
          }
          var ret = [];
          for (var i2 = 0, l = set.length; i2 < l; i2++) {
            for (var ii = 0, ll = suf.length; ii < ll; ii++) {
              ret.push(set[i2] + suf[ii]);
            }
          }
          return ret;
        }
        Minimatch.prototype.parse = parse3;
        var SUBPARSE = {};
        function parse3(pattern, isSub) {
          var options = this.options;
          if (!options.noglobstar && pattern === "**")
            return GLOBSTAR;
          if (pattern === "")
            return "";
          var re = "", hasMagic = !!options.nocase, escaping = false, patternListStack = [], plType, stateChar, inClass = false, reClassStart = -1, classStart = -1, patternStart = pattern.charAt(0) === "." ? "" : options.dot ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)";
          function clearStateChar() {
            if (stateChar) {
              switch (stateChar) {
                case "*":
                  re += star;
                  hasMagic = true;
                  break;
                case "?":
                  re += qmark;
                  hasMagic = true;
                  break;
                default:
                  re += "\\" + stateChar;
                  break;
              }
              stateChar = false;
            }
          }
          for (var i2 = 0, len = pattern.length, c; i2 < len && (c = pattern.charAt(i2)); i2++) {
            if (options.debug) {
              console.error("%s	%s %s %j", pattern, i2, re, c);
            }
            if (escaping && reSpecials[c]) {
              re += "\\" + c;
              escaping = false;
              continue;
            }
            SWITCH:
              switch (c) {
                case "/":
                  return false;
                case "\\":
                  clearStateChar();
                  escaping = true;
                  continue;
                case "?":
                case "*":
                case "+":
                case "@":
                case "!":
                  if (options.debug) {
                    console.error("%s	%s %s %j <-- stateChar", pattern, i2, re, c);
                  }
                  if (inClass) {
                    if (c === "!" && i2 === classStart + 1)
                      c = "^";
                    re += c;
                    continue;
                  }
                  clearStateChar();
                  stateChar = c;
                  if (options.noext)
                    clearStateChar();
                  continue;
                case "(":
                  if (inClass) {
                    re += "(";
                    continue;
                  }
                  if (!stateChar) {
                    re += "\\(";
                    continue;
                  }
                  plType = stateChar;
                  patternListStack.push({
                    type: plType,
                    start: i2 - 1,
                    reStart: re.length
                  });
                  re += stateChar === "!" ? "(?:(?!" : "(?:";
                  stateChar = false;
                  continue;
                case ")":
                  if (inClass || !patternListStack.length) {
                    re += "\\)";
                    continue;
                  }
                  hasMagic = true;
                  re += ")";
                  plType = patternListStack.pop().type;
                  switch (plType) {
                    case "!":
                      re += "[^/]*?)";
                      break;
                    case "?":
                    case "+":
                    case "*":
                      re += plType;
                    case "@":
                      break;
                  }
                  continue;
                case "|":
                  if (inClass || !patternListStack.length || escaping) {
                    re += "\\|";
                    escaping = false;
                    continue;
                  }
                  re += "|";
                  continue;
                case "[":
                  clearStateChar();
                  if (inClass) {
                    re += "\\" + c;
                    continue;
                  }
                  inClass = true;
                  classStart = i2;
                  reClassStart = re.length;
                  re += c;
                  continue;
                case "]":
                  if (i2 === classStart + 1 || !inClass) {
                    re += "\\" + c;
                    escaping = false;
                    continue;
                  }
                  hasMagic = true;
                  inClass = false;
                  re += c;
                  continue;
                default:
                  clearStateChar();
                  if (escaping) {
                    escaping = false;
                  } else if (reSpecials[c] && !(c === "^" && inClass)) {
                    re += "\\";
                  }
                  re += c;
              }
          }
          if (inClass) {
            var cs = pattern.substr(classStart + 1), sp = this.parse(cs, SUBPARSE);
            re = re.substr(0, reClassStart) + "\\[" + sp[0];
            hasMagic = hasMagic || sp[1];
          }
          var pl;
          while (pl = patternListStack.pop()) {
            var tail = re.slice(pl.reStart + 3);
            tail = tail.replace(/((?:\\{2})*)(\\?)\|/g, function(_, $1, $2) {
              if (!$2) {
                $2 = "\\";
              }
              return $1 + $1 + $2 + "|";
            });
            var t2 = pl.type === "*" ? star : pl.type === "?" ? qmark : "\\" + pl.type;
            hasMagic = true;
            re = re.slice(0, pl.reStart) + t2 + "\\(" + tail;
          }
          clearStateChar();
          if (escaping) {
            re += "\\\\";
          }
          var addPatternStart = false;
          switch (re.charAt(0)) {
            case ".":
            case "[":
            case "(":
              addPatternStart = true;
          }
          if (re !== "" && hasMagic)
            re = "(?=.)" + re;
          if (addPatternStart)
            re = patternStart + re;
          if (isSub === SUBPARSE) {
            return [re, hasMagic];
          }
          if (!hasMagic) {
            return globUnescape(pattern);
          }
          var flags = options.nocase ? "i" : "", regExp = new RegExp("^" + re + "$", flags);
          regExp._glob = pattern;
          regExp._src = re;
          return regExp;
        }
        minimatch.makeRe = function(pattern, options) {
          return new Minimatch(pattern, options || {}).makeRe();
        };
        Minimatch.prototype.makeRe = makeRe;
        function makeRe() {
          if (this.regexp || this.regexp === false)
            return this.regexp;
          var set = this.set;
          if (!set.length)
            return this.regexp = false;
          var options = this.options;
          var twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot, flags = options.nocase ? "i" : "";
          var re = set.map(function(pattern) {
            return pattern.map(function(p) {
              return p === GLOBSTAR ? twoStar : typeof p === "string" ? regExpEscape(p) : p._src;
            }).join("\\/");
          }).join("|");
          re = "^(?:" + re + ")$";
          if (this.negate)
            re = "^(?!" + re + ").*$";
          try {
            return this.regexp = new RegExp(re, flags);
          } catch (ex) {
            return this.regexp = false;
          }
        }
        minimatch.match = function(list, pattern, options) {
          var mm = new Minimatch(pattern, options);
          list = list.filter(function(f3) {
            return mm.match(f3);
          });
          if (options.nonull && !list.length) {
            list.push(pattern);
          }
          return list;
        };
        Minimatch.prototype.match = match;
        function match(f3, partial) {
          if (this.comment)
            return false;
          if (this.empty)
            return f3 === "";
          if (f3 === "/" && partial)
            return true;
          var options = this.options;
          if (platform === "win32") {
            f3 = f3.split("\\").join("/");
          }
          f3 = f3.split(slashSplit);
          if (options.debug) {
            console.error(this.pattern, "split", f3);
          }
          var set = this.set;
          for (var i2 = 0, l = set.length; i2 < l; i2++) {
            var pattern = set[i2];
            var hit = this.matchOne(f3, pattern, partial);
            if (hit) {
              if (options.flipNegate)
                return true;
              return !this.negate;
            }
          }
          if (options.flipNegate)
            return false;
          return this.negate;
        }
        Minimatch.prototype.matchOne = function(file, pattern, partial) {
          var options = this.options;
          if (options.debug) {
            console.error("matchOne", {
              "this": this,
              file,
              pattern
            });
          }
          if (options.matchBase && pattern.length === 1) {
            file = path4.basename(file.join("/")).split("/");
          }
          if (options.debug) {
            console.error("matchOne", file.length, pattern.length);
          }
          for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
            if (options.debug) {
              console.error("matchOne loop");
            }
            var p = pattern[pi], f3 = file[fi];
            if (options.debug) {
              console.error(pattern, p, f3);
            }
            if (p === false)
              return false;
            if (p === GLOBSTAR) {
              if (options.debug)
                console.error("GLOBSTAR", [pattern, p, f3]);
              var fr = fi, pr = pi + 1;
              if (pr === pl) {
                if (options.debug)
                  console.error("** at the end");
                for (; fi < fl; fi++) {
                  if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".")
                    return false;
                }
                return true;
              }
              WHILE:
                while (fr < fl) {
                  var swallowee = file[fr];
                  if (options.debug) {
                    console.error("\nglobstar while", file, fr, pattern, pr, swallowee);
                  }
                  if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
                    if (options.debug)
                      console.error("globstar found match!", fr, fl, swallowee);
                    return true;
                  } else {
                    if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
                      if (options.debug)
                        console.error("dot detected!", file, fr, pattern, pr);
                      break WHILE;
                    }
                    if (options.debug)
                      console.error("globstar swallow a segment, and continue");
                    fr++;
                  }
                }
              if (partial) {
                if (fr === fl)
                  return true;
              }
              return false;
            }
            var hit;
            if (typeof p === "string") {
              if (options.nocase) {
                hit = f3.toLowerCase() === p.toLowerCase();
              } else {
                hit = f3 === p;
              }
              if (options.debug) {
                console.error("string match", p, f3, hit);
              }
            } else {
              hit = f3.match(p);
              if (options.debug) {
                console.error("pattern match", p, f3, hit);
              }
            }
            if (!hit)
              return false;
          }
          if (fi === fl && pi === pl) {
            return true;
          } else if (fi === fl) {
            return partial;
          } else if (pi === pl) {
            var emptyFileEnd = fi === fl - 1 && file[fi] === "";
            return emptyFileEnd;
          }
          throw new Error("wtf?");
        };
        function globUnescape(s2) {
          return s2.replace(/\\(.)/g, "$1");
        }
        function regExpEscape(s2) {
          return s2.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
        }
      }
    });
    var require_ini = __commonJS22({
      "node_modules/editorconfig/src/lib/ini.js"(exports2) {
        "use strict";
        var __awaiter2 = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
          return new (P || (P = Promise))(function(resolve, reject) {
            function fulfilled(value) {
              try {
                step(generator.next(value));
              } catch (e2) {
                reject(e2);
              }
            }
            function rejected(value) {
              try {
                step(generator["throw"](value));
              } catch (e2) {
                reject(e2);
              }
            }
            function step(result) {
              result.done ? resolve(result.value) : new P(function(resolve2) {
                resolve2(result.value);
              }).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
          });
        };
        var __generator2 = exports2 && exports2.__generator || function(thisArg, body) {
          var _ = {
            label: 0,
            sent: function() {
              if (t2[0] & 1)
                throw t2[1];
              return t2[1];
            },
            trys: [],
            ops: []
          }, f3, y, t2, g;
          return g = {
            next: verb(0),
            "throw": verb(1),
            "return": verb(2)
          }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
            return this;
          }), g;
          function verb(n) {
            return function(v) {
              return step([n, v]);
            };
          }
          function step(op) {
            if (f3)
              throw new TypeError("Generator is already executing.");
            while (_)
              try {
                if (f3 = 1, y && (t2 = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t2 = y["return"]) && t2.call(y), 0) : y.next) && !(t2 = t2.call(y, op[1])).done)
                  return t2;
                if (y = 0, t2)
                  op = [op[0] & 2, t2.value];
                switch (op[0]) {
                  case 0:
                  case 1:
                    t2 = op;
                    break;
                  case 4:
                    _.label++;
                    return {
                      value: op[1],
                      done: false
                    };
                  case 5:
                    _.label++;
                    y = op[1];
                    op = [0];
                    continue;
                  case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                  default:
                    if (!(t2 = _.trys, t2 = t2.length > 0 && t2[t2.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                      _ = 0;
                      continue;
                    }
                    if (op[0] === 3 && (!t2 || op[1] > t2[0] && op[1] < t2[3])) {
                      _.label = op[1];
                      break;
                    }
                    if (op[0] === 6 && _.label < t2[1]) {
                      _.label = t2[1];
                      t2 = op;
                      break;
                    }
                    if (t2 && _.label < t2[2]) {
                      _.label = t2[2];
                      _.ops.push(op);
                      break;
                    }
                    if (t2[2])
                      _.ops.pop();
                    _.trys.pop();
                    continue;
                }
                op = body.call(thisArg, _);
              } catch (e2) {
                op = [6, e2];
                y = 0;
              } finally {
                f3 = t2 = 0;
              }
            if (op[0] & 5)
              throw op[1];
            return {
              value: op[0] ? op[1] : void 0,
              done: true
            };
          }
        };
        var __importStar2 = exports2 && exports2.__importStar || function(mod) {
          if (mod && mod.__esModule)
            return mod;
          var result = {};
          if (mod != null) {
            for (var k in mod)
              if (Object.hasOwnProperty.call(mod, k))
                result[k] = mod[k];
          }
          result["default"] = mod;
          return result;
        };
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var fs4 = __importStar2(require("fs"));
        var regex = {
          section: /^\s*\[(([^#;]|\\#|\\;)+)\]\s*([#;].*)?$/,
          param: /^\s*([\w\.\-\_]+)\s*[=:]\s*(.*?)\s*([#;].*)?$/,
          comment: /^\s*[#;].*$/
        };
        function parse3(file) {
          return __awaiter2(this, void 0, void 0, function() {
            return __generator2(this, function(_a4) {
              return [2, new Promise(function(resolve, reject) {
                fs4.readFile(file, "utf8", function(err, data) {
                  if (err) {
                    reject(err);
                    return;
                  }
                  resolve(parseString(data));
                });
              })];
            });
          });
        }
        exports2.parse = parse3;
        function parseSync(file) {
          return parseString(fs4.readFileSync(file, "utf8"));
        }
        exports2.parseSync = parseSync;
        function parseString(data) {
          var sectionBody = {};
          var sectionName = null;
          var value = [[sectionName, sectionBody]];
          var lines = data.split(/\r\n|\r|\n/);
          lines.forEach(function(line) {
            var match;
            if (regex.comment.test(line)) {
              return;
            }
            if (regex.param.test(line)) {
              match = line.match(regex.param);
              sectionBody[match[1]] = match[2];
            } else if (regex.section.test(line)) {
              match = line.match(regex.section);
              sectionName = match[1];
              sectionBody = {};
              value.push([sectionName, sectionBody]);
            }
          });
          return value;
        }
        exports2.parseString = parseString;
      }
    });
    var require_package2 = __commonJS22({
      "node_modules/editorconfig/package.json"(exports2, module22) {
        module22.exports = {
          name: "editorconfig",
          version: "0.15.3",
          description: "EditorConfig File Locator and Interpreter for Node.js",
          keywords: ["editorconfig", "core"],
          main: "src/index.js",
          contributors: ["Hong Xu (topbug.net)", "Jed Mao (https://github.com/jedmao/)", "Trey Hunner (http://treyhunner.com)"],
          directories: {
            bin: "./bin",
            lib: "./lib"
          },
          scripts: {
            clean: "rimraf dist",
            prebuild: "npm run clean",
            build: "tsc",
            pretest: "npm run lint && npm run build && npm run copy && cmake .",
            test: "ctest .",
            "pretest:ci": "npm run pretest",
            "test:ci": "ctest -VV --output-on-failure .",
            lint: "npm run eclint && npm run tslint",
            eclint: 'eclint check --indent_size ignore "src/**"',
            tslint: "tslint --project tsconfig.json --exclude package.json",
            copy: "cpy .npmignore LICENSE README.md CHANGELOG.md dist && cpy bin/* dist/bin && cpy src/lib/fnmatch*.* dist/src/lib",
            prepub: "npm run lint && npm run build && npm run copy",
            pub: "npm publish ./dist"
          },
          repository: {
            type: "git",
            url: "git://github.com/editorconfig/editorconfig-core-js.git"
          },
          bugs: "https://github.com/editorconfig/editorconfig-core-js/issues",
          author: "EditorConfig Team",
          license: "MIT",
          dependencies: {
            commander: "^2.19.0",
            "lru-cache": "^4.1.5",
            semver: "^5.6.0",
            sigmund: "^1.0.1"
          },
          devDependencies: {
            "@types/mocha": "^5.2.6",
            "@types/node": "^10.12.29",
            "@types/semver": "^5.5.0",
            "cpy-cli": "^2.0.0",
            eclint: "^2.8.1",
            mocha: "^5.2.0",
            rimraf: "^2.6.3",
            should: "^13.2.3",
            tslint: "^5.13.1",
            typescript: "^3.3.3333"
          }
        };
      }
    });
    var require_src2 = __commonJS22({
      "node_modules/editorconfig/src/index.js"(exports2) {
        "use strict";
        var __awaiter2 = exports2 && exports2.__awaiter || function(thisArg, _arguments, P, generator) {
          return new (P || (P = Promise))(function(resolve, reject) {
            function fulfilled(value) {
              try {
                step(generator.next(value));
              } catch (e2) {
                reject(e2);
              }
            }
            function rejected(value) {
              try {
                step(generator["throw"](value));
              } catch (e2) {
                reject(e2);
              }
            }
            function step(result) {
              result.done ? resolve(result.value) : new P(function(resolve2) {
                resolve2(result.value);
              }).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
          });
        };
        var __generator2 = exports2 && exports2.__generator || function(thisArg, body) {
          var _ = {
            label: 0,
            sent: function() {
              if (t2[0] & 1)
                throw t2[1];
              return t2[1];
            },
            trys: [],
            ops: []
          }, f3, y, t2, g;
          return g = {
            next: verb(0),
            "throw": verb(1),
            "return": verb(2)
          }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
            return this;
          }), g;
          function verb(n) {
            return function(v) {
              return step([n, v]);
            };
          }
          function step(op) {
            if (f3)
              throw new TypeError("Generator is already executing.");
            while (_)
              try {
                if (f3 = 1, y && (t2 = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t2 = y["return"]) && t2.call(y), 0) : y.next) && !(t2 = t2.call(y, op[1])).done)
                  return t2;
                if (y = 0, t2)
                  op = [op[0] & 2, t2.value];
                switch (op[0]) {
                  case 0:
                  case 1:
                    t2 = op;
                    break;
                  case 4:
                    _.label++;
                    return {
                      value: op[1],
                      done: false
                    };
                  case 5:
                    _.label++;
                    y = op[1];
                    op = [0];
                    continue;
                  case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                  default:
                    if (!(t2 = _.trys, t2 = t2.length > 0 && t2[t2.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                      _ = 0;
                      continue;
                    }
                    if (op[0] === 3 && (!t2 || op[1] > t2[0] && op[1] < t2[3])) {
                      _.label = op[1];
                      break;
                    }
                    if (op[0] === 6 && _.label < t2[1]) {
                      _.label = t2[1];
                      t2 = op;
                      break;
                    }
                    if (t2 && _.label < t2[2]) {
                      _.label = t2[2];
                      _.ops.push(op);
                      break;
                    }
                    if (t2[2])
                      _.ops.pop();
                    _.trys.pop();
                    continue;
                }
                op = body.call(thisArg, _);
              } catch (e2) {
                op = [6, e2];
                y = 0;
              } finally {
                f3 = t2 = 0;
              }
            if (op[0] & 5)
              throw op[1];
            return {
              value: op[0] ? op[1] : void 0,
              done: true
            };
          }
        };
        var __importStar2 = exports2 && exports2.__importStar || function(mod) {
          if (mod && mod.__esModule)
            return mod;
          var result = {};
          if (mod != null) {
            for (var k in mod)
              if (Object.hasOwnProperty.call(mod, k))
                result[k] = mod[k];
          }
          result["default"] = mod;
          return result;
        };
        var __importDefault2 = exports2 && exports2.__importDefault || function(mod) {
          return mod && mod.__esModule ? mod : {
            "default": mod
          };
        };
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var fs4 = __importStar2(require("fs"));
        var path4 = __importStar2(require("path"));
        var semver2 = {
          gte: require_gte2()
        };
        var fnmatch_1 = __importDefault2(require_fnmatch());
        var ini_1 = require_ini();
        exports2.parseString = ini_1.parseString;
        var package_json_1 = __importDefault2(require_package2());
        var knownProps = {
          end_of_line: true,
          indent_style: true,
          indent_size: true,
          insert_final_newline: true,
          trim_trailing_whitespace: true,
          charset: true
        };
        function fnmatch(filepath, glob) {
          var matchOptions = {
            matchBase: true,
            dot: true,
            noext: true
          };
          glob = glob.replace(/\*\*/g, "{*,**/**/**}");
          return fnmatch_1.default(filepath, glob, matchOptions);
        }
        function getConfigFileNames(filepath, options) {
          var paths = [];
          do {
            filepath = path4.dirname(filepath);
            paths.push(path4.join(filepath, options.config));
          } while (filepath !== options.root);
          return paths;
        }
        function processMatches(matches, version2) {
          if ("indent_style" in matches && matches.indent_style === "tab" && !("indent_size" in matches) && semver2.gte(version2, "0.10.0")) {
            matches.indent_size = "tab";
          }
          if ("indent_size" in matches && !("tab_width" in matches) && matches.indent_size !== "tab") {
            matches.tab_width = matches.indent_size;
          }
          if ("indent_size" in matches && "tab_width" in matches && matches.indent_size === "tab") {
            matches.indent_size = matches.tab_width;
          }
          return matches;
        }
        function processOptions(options, filepath) {
          if (options === void 0) {
            options = {};
          }
          return {
            config: options.config || ".editorconfig",
            version: options.version || package_json_1.default.version,
            root: path4.resolve(options.root || path4.parse(filepath).root)
          };
        }
        function buildFullGlob(pathPrefix, glob) {
          switch (glob.indexOf("/")) {
            case -1:
              glob = "**/" + glob;
              break;
            case 0:
              glob = glob.substring(1);
              break;
            default:
              break;
          }
          return path4.join(pathPrefix, glob);
        }
        function extendProps(props, options) {
          if (props === void 0) {
            props = {};
          }
          if (options === void 0) {
            options = {};
          }
          for (var key in options) {
            if (options.hasOwnProperty(key)) {
              var value = options[key];
              var key2 = key.toLowerCase();
              var value2 = value;
              if (knownProps[key2]) {
                value2 = value.toLowerCase();
              }
              try {
                value2 = JSON.parse(value);
              } catch (e2) {
              }
              if (typeof value === "undefined" || value === null) {
                value2 = String(value);
              }
              props[key2] = value2;
            }
          }
          return props;
        }
        function parseFromConfigs(configs, filepath, options) {
          return processMatches(configs.reverse().reduce(function(matches, file) {
            var pathPrefix = path4.dirname(file.name);
            file.contents.forEach(function(section) {
              var glob = section[0];
              var options2 = section[1];
              if (!glob) {
                return;
              }
              var fullGlob = buildFullGlob(pathPrefix, glob);
              if (!fnmatch(filepath, fullGlob)) {
                return;
              }
              matches = extendProps(matches, options2);
            });
            return matches;
          }, {}), options.version);
        }
        function getConfigsForFiles(files) {
          var configs = [];
          for (var i2 in files) {
            if (files.hasOwnProperty(i2)) {
              var file = files[i2];
              var contents = ini_1.parseString(file.contents);
              configs.push({
                name: file.name,
                contents
              });
              if ((contents[0][1].root || "").toLowerCase() === "true") {
                break;
              }
            }
          }
          return configs;
        }
        function readConfigFiles(filepaths) {
          return __awaiter2(this, void 0, void 0, function() {
            return __generator2(this, function(_a4) {
              return [2, Promise.all(filepaths.map(function(name) {
                return new Promise(function(resolve) {
                  fs4.readFile(name, "utf8", function(err, data) {
                    resolve({
                      name,
                      contents: err ? "" : data
                    });
                  });
                });
              }))];
            });
          });
        }
        function readConfigFilesSync(filepaths) {
          var files = [];
          var file;
          filepaths.forEach(function(filepath) {
            try {
              file = fs4.readFileSync(filepath, "utf8");
            } catch (e2) {
              file = "";
            }
            files.push({
              name: filepath,
              contents: file
            });
          });
          return files;
        }
        function opts(filepath, options) {
          if (options === void 0) {
            options = {};
          }
          var resolvedFilePath = path4.resolve(filepath);
          return [resolvedFilePath, processOptions(options, resolvedFilePath)];
        }
        function parseFromFiles(filepath, files, options) {
          if (options === void 0) {
            options = {};
          }
          return __awaiter2(this, void 0, void 0, function() {
            var _a4, resolvedFilePath, processedOptions;
            return __generator2(this, function(_b) {
              _a4 = opts(filepath, options), resolvedFilePath = _a4[0], processedOptions = _a4[1];
              return [2, files.then(getConfigsForFiles).then(function(configs) {
                return parseFromConfigs(configs, resolvedFilePath, processedOptions);
              })];
            });
          });
        }
        exports2.parseFromFiles = parseFromFiles;
        function parseFromFilesSync(filepath, files, options) {
          if (options === void 0) {
            options = {};
          }
          var _a4 = opts(filepath, options), resolvedFilePath = _a4[0], processedOptions = _a4[1];
          return parseFromConfigs(getConfigsForFiles(files), resolvedFilePath, processedOptions);
        }
        exports2.parseFromFilesSync = parseFromFilesSync;
        function parse3(_filepath, _options) {
          if (_options === void 0) {
            _options = {};
          }
          return __awaiter2(this, void 0, void 0, function() {
            var _a4, resolvedFilePath, processedOptions, filepaths;
            return __generator2(this, function(_b) {
              _a4 = opts(_filepath, _options), resolvedFilePath = _a4[0], processedOptions = _a4[1];
              filepaths = getConfigFileNames(resolvedFilePath, processedOptions);
              return [2, readConfigFiles(filepaths).then(getConfigsForFiles).then(function(configs) {
                return parseFromConfigs(configs, resolvedFilePath, processedOptions);
              })];
            });
          });
        }
        exports2.parse = parse3;
        function parseSync(_filepath, _options) {
          if (_options === void 0) {
            _options = {};
          }
          var _a4 = opts(_filepath, _options), resolvedFilePath = _a4[0], processedOptions = _a4[1];
          var filepaths = getConfigFileNames(resolvedFilePath, processedOptions);
          var files = readConfigFilesSync(filepaths);
          return parseFromConfigs(getConfigsForFiles(files), resolvedFilePath, processedOptions);
        }
        exports2.parseSync = parseSync;
      }
    });
    var require_editorconfig_to_prettier = __commonJS22({
      "node_modules/editorconfig-to-prettier/index.js"(exports2, module22) {
        module22.exports = editorConfigToPrettier;
        function removeUnset(editorConfig) {
          const result = {};
          const keys = Object.keys(editorConfig);
          for (let i2 = 0; i2 < keys.length; i2++) {
            const key = keys[i2];
            if (editorConfig[key] === "unset") {
              continue;
            }
            result[key] = editorConfig[key];
          }
          return result;
        }
        function editorConfigToPrettier(editorConfig) {
          if (!editorConfig) {
            return null;
          }
          editorConfig = removeUnset(editorConfig);
          if (Object.keys(editorConfig).length === 0) {
            return null;
          }
          const result = {};
          if (editorConfig.indent_style) {
            result.useTabs = editorConfig.indent_style === "tab";
          }
          if (editorConfig.indent_size === "tab") {
            result.useTabs = true;
          }
          if (result.useTabs && editorConfig.tab_width) {
            result.tabWidth = editorConfig.tab_width;
          } else if (editorConfig.indent_style === "space" && editorConfig.indent_size && editorConfig.indent_size !== "tab") {
            result.tabWidth = editorConfig.indent_size;
          } else if (editorConfig.tab_width !== void 0) {
            result.tabWidth = editorConfig.tab_width;
          }
          if (editorConfig.max_line_length && editorConfig.max_line_length !== "off") {
            result.printWidth = editorConfig.max_line_length;
          }
          if (editorConfig.quote_type === "single") {
            result.singleQuote = true;
          } else if (editorConfig.quote_type === "double") {
            result.singleQuote = false;
          }
          if (["cr", "crlf", "lf"].indexOf(editorConfig.end_of_line) !== -1) {
            result.endOfLine = editorConfig.end_of_line;
          }
          if (editorConfig.insert_final_newline === false || editorConfig.insert_final_newline === true) {
            result.insertFinalNewline = editorConfig.insert_final_newline;
          }
          return result;
        }
      }
    });
    var require_find_project_root = __commonJS22({
      "src/config/find-project-root.js"(exports2, module22) {
        "use strict";
        var fs4 = require("fs");
        var path4 = require("path");
        var MARKERS = [".git", ".hg"];
        var markerExists = (directory) => MARKERS.some((mark) => fs4.existsSync(path4.join(directory, mark)));
        function findProjectRoot(directory) {
          while (!markerExists(directory)) {
            const parentDirectory = path4.resolve(directory, "..");
            if (parentDirectory === directory) {
              break;
            }
            directory = parentDirectory;
          }
          return directory;
        }
        module22.exports = findProjectRoot;
      }
    });
    var require_resolve_config_editorconfig = __commonJS22({
      "src/config/resolve-config-editorconfig.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var editorconfig = require_src2();
        var editorConfigToPrettier = require_editorconfig_to_prettier();
        var {
          default: mem2,
          memClear: memClear2
        } = (init_dist(), __toCommonJS2(dist_exports));
        var findProjectRoot = require_find_project_root();
        var jsonStringifyMem = (fn) => mem2(fn, {
          cacheKey: JSON.stringify
        });
        var maybeParse = (filePath, parse3) => filePath && parse3(filePath, {
          root: findProjectRoot(path4.dirname(path4.resolve(filePath)))
        });
        var editorconfigAsyncNoCache = async (filePath) => editorConfigToPrettier(await maybeParse(filePath, editorconfig.parse));
        var editorconfigAsyncWithCache = jsonStringifyMem(editorconfigAsyncNoCache);
        var editorconfigSyncNoCache = (filePath) => editorConfigToPrettier(maybeParse(filePath, editorconfig.parseSync));
        var editorconfigSyncWithCache = jsonStringifyMem(editorconfigSyncNoCache);
        function getLoadFunction(opts) {
          if (!opts.editorconfig) {
            return () => null;
          }
          if (opts.sync) {
            return opts.cache ? editorconfigSyncWithCache : editorconfigSyncNoCache;
          }
          return opts.cache ? editorconfigAsyncWithCache : editorconfigAsyncNoCache;
        }
        function clearCache() {
          memClear2(editorconfigSyncWithCache);
          memClear2(editorconfigAsyncWithCache);
        }
        module22.exports = {
          getLoadFunction,
          clearCache
        };
      }
    });
    var require_resolve_config = __commonJS22({
      "src/config/resolve-config.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var micromatch2 = require_micromatch2();
        var thirdParty = require_third_party();
        var loadToml = require_load_toml();
        var loadJson5 = require_load_json5();
        var partition = require_partition();
        var resolve = require_resolve2();
        var {
          default: mem2,
          memClear: memClear2
        } = (init_dist(), __toCommonJS2(dist_exports));
        var resolveEditorConfig = require_resolve_config_editorconfig();
        var getExplorerMemoized = mem2((opts) => {
          const cosmiconfig = thirdParty["cosmiconfig" + (opts.sync ? "Sync" : "")];
          const explorer = cosmiconfig("prettier", {
            cache: opts.cache,
            transform: (result) => {
              if (result && result.config) {
                if (typeof result.config === "string") {
                  const dir = path4.dirname(result.filepath);
                  const modulePath = resolve(result.config, {
                    paths: [dir]
                  });
                  result.config = require(modulePath);
                }
                if (typeof result.config !== "object") {
                  throw new TypeError(`Config is only allowed to be an object, but received ${typeof result.config} in "${result.filepath}"`);
                }
                delete result.config.$schema;
              }
              return result;
            },
            searchPlaces: ["package.json", ".prettierrc", ".prettierrc.json", ".prettierrc.yaml", ".prettierrc.yml", ".prettierrc.json5", ".prettierrc.js", ".prettierrc.cjs", "prettier.config.js", "prettier.config.cjs", ".prettierrc.toml"],
            loaders: {
              ".toml": loadToml,
              ".json5": loadJson5
            }
          });
          return explorer;
        }, {
          cacheKey: JSON.stringify
        });
        function getExplorer(opts) {
          opts = Object.assign({
            sync: false,
            cache: false
          }, opts);
          return getExplorerMemoized(opts);
        }
        function _resolveConfig(filePath, opts, sync2) {
          opts = Object.assign({
            useCache: true
          }, opts);
          const loadOpts = {
            cache: Boolean(opts.useCache),
            sync: Boolean(sync2),
            editorconfig: Boolean(opts.editorconfig)
          };
          const {
            load,
            search
          } = getExplorer(loadOpts);
          const loadEditorConfig = resolveEditorConfig.getLoadFunction(loadOpts);
          const arr = [opts.config ? load(opts.config) : search(filePath), loadEditorConfig(filePath)];
          const unwrapAndMerge = ([result, editorConfigured]) => {
            const merged = Object.assign(Object.assign({}, editorConfigured), mergeOverrides(result, filePath));
            for (const optionName of ["plugins", "pluginSearchDirs"]) {
              if (Array.isArray(merged[optionName])) {
                merged[optionName] = merged[optionName].map((value) => typeof value === "string" && value.startsWith(".") ? path4.resolve(path4.dirname(result.filepath), value) : value);
              }
            }
            if (!result && !editorConfigured) {
              return null;
            }
            delete merged.insertFinalNewline;
            return merged;
          };
          if (loadOpts.sync) {
            return unwrapAndMerge(arr);
          }
          return Promise.all(arr).then(unwrapAndMerge);
        }
        var resolveConfig = (filePath, opts) => _resolveConfig(filePath, opts, false);
        resolveConfig.sync = (filePath, opts) => _resolveConfig(filePath, opts, true);
        function clearCache() {
          memClear2(getExplorerMemoized);
          resolveEditorConfig.clearCache();
        }
        async function resolveConfigFile(filePath) {
          const {
            search
          } = getExplorer({
            sync: false
          });
          const result = await search(filePath);
          return result ? result.filepath : null;
        }
        resolveConfigFile.sync = (filePath) => {
          const {
            search
          } = getExplorer({
            sync: true
          });
          const result = search(filePath);
          return result ? result.filepath : null;
        };
        function mergeOverrides(configResult, filePath) {
          const {
            config: config2,
            filepath: configPath
          } = configResult || {};
          const _ref = config2 || {}, {
            overrides
          } = _ref, options = _objectWithoutProperties(_ref, _excluded3);
          if (filePath && overrides) {
            const relativeFilePath = path4.relative(path4.dirname(configPath), filePath);
            for (const override of overrides) {
              if (pathMatchesGlobs(relativeFilePath, override.files, override.excludeFiles)) {
                Object.assign(options, override.options);
              }
            }
          }
          return options;
        }
        function pathMatchesGlobs(filePath, patterns, excludedPatterns) {
          const patternList = Array.isArray(patterns) ? patterns : [patterns];
          const [withSlashes, withoutSlashes] = partition(patternList, (pattern) => pattern.includes("/"));
          return micromatch2.isMatch(filePath, withoutSlashes, {
            ignore: excludedPatterns,
            basename: true,
            dot: true
          }) || micromatch2.isMatch(filePath, withSlashes, {
            ignore: excludedPatterns,
            basename: false,
            dot: true
          });
        }
        module22.exports = {
          resolveConfig,
          resolveConfigFile,
          clearCache
        };
      }
    });
    var require_ignore2 = __commonJS22({
      "node_modules/ignore/index.js"(exports2, module22) {
        function makeArray(subject) {
          return Array.isArray(subject) ? subject : [subject];
        }
        var EMPTY = "";
        var SPACE2 = " ";
        var ESCAPE = "\\";
        var REGEX_TEST_BLANK_LINE = /^\s+$/;
        var REGEX_REPLACE_LEADING_EXCAPED_EXCLAMATION = /^\\!/;
        var REGEX_REPLACE_LEADING_EXCAPED_HASH = /^\\#/;
        var REGEX_SPLITALL_CRLF = /\r?\n/g;
        var REGEX_TEST_INVALID_PATH = /^\.*\/|^\.+$/;
        var SLASH = "/";
        var KEY_IGNORE = typeof Symbol !== "undefined" ? Symbol.for("node-ignore") : "node-ignore";
        var define2 = (object, key, value) => Object.defineProperty(object, key, {
          value
        });
        var REGEX_REGEXP_RANGE = /([0-z])-([0-z])/g;
        var RETURN_FALSE = () => false;
        var sanitizeRange = (range) => range.replace(REGEX_REGEXP_RANGE, (match, from, to) => from.charCodeAt(0) <= to.charCodeAt(0) ? match : EMPTY);
        var cleanRangeBackSlash = (slashes) => {
          const {
            length
          } = slashes;
          return slashes.slice(0, length - length % 2);
        };
        var REPLACERS = [[/\\?\s+$/, (match) => match.indexOf("\\") === 0 ? SPACE2 : EMPTY], [/\\\s/g, () => SPACE2], [/[\\$.|*+(){^]/g, (match) => `\\${match}`], [/(?!\\)\?/g, () => "[^/]"], [/^\//, () => "^"], [/\//g, () => "\\/"], [/^\^*\\\*\\\*\\\//, () => "^(?:.*\\/)?"], [/^(?=[^^])/, function startingReplacer() {
          return !/\/(?!$)/.test(this) ? "(?:^|\\/)" : "^";
        }], [/\\\/\\\*\\\*(?=\\\/|$)/g, (_, index, str) => index + 6 < str.length ? "(?:\\/[^\\/]+)*" : "\\/.+"], [/(^|[^\\]+)\\\*(?=.+)/g, (_, p1) => `${p1}[^\\/]*`], [/\\\\\\(?=[$.|*+(){^])/g, () => ESCAPE], [/\\\\/g, () => ESCAPE], [/(\\)?\[([^\]/]*?)(\\*)($|\])/g, (match, leadEscape, range, endEscape, close) => leadEscape === ESCAPE ? `\\[${range}${cleanRangeBackSlash(endEscape)}${close}` : close === "]" ? endEscape.length % 2 === 0 ? `[${sanitizeRange(range)}${endEscape}]` : "[]" : "[]"], [/(?:[^*])$/, (match) => /\/$/.test(match) ? `${match}$` : `${match}(?=$|\\/$)`], [/(\^|\\\/)?\\\*$/, (_, p1) => {
          const prefix2 = p1 ? `${p1}[^/]+` : "[^/]*";
          return `${prefix2}(?=$|\\/$)`;
        }]];
        var regexCache = /* @__PURE__ */ Object.create(null);
        var makeRegex = (pattern, ignoreCase) => {
          let source = regexCache[pattern];
          if (!source) {
            source = REPLACERS.reduce((prev, current) => prev.replace(current[0], current[1].bind(pattern)), pattern);
            regexCache[pattern] = source;
          }
          return ignoreCase ? new RegExp(source, "i") : new RegExp(source);
        };
        var isString = (subject) => typeof subject === "string";
        var checkPattern = (pattern) => pattern && isString(pattern) && !REGEX_TEST_BLANK_LINE.test(pattern) && pattern.indexOf("#") !== 0;
        var splitPattern = (pattern) => pattern.split(REGEX_SPLITALL_CRLF);
        var IgnoreRule = class {
          constructor(origin, pattern, negative, regex) {
            this.origin = origin;
            this.pattern = pattern;
            this.negative = negative;
            this.regex = regex;
          }
        };
        var createRule = (pattern, ignoreCase) => {
          const origin = pattern;
          let negative = false;
          if (pattern.indexOf("!") === 0) {
            negative = true;
            pattern = pattern.substr(1);
          }
          pattern = pattern.replace(REGEX_REPLACE_LEADING_EXCAPED_EXCLAMATION, "!").replace(REGEX_REPLACE_LEADING_EXCAPED_HASH, "#");
          const regex = makeRegex(pattern, ignoreCase);
          return new IgnoreRule(origin, pattern, negative, regex);
        };
        var throwError = (message, Ctor) => {
          throw new Ctor(message);
        };
        var checkPath = (path4, originalPath, doThrow) => {
          if (!isString(path4)) {
            return doThrow(`path must be a string, but got \`${originalPath}\``, TypeError);
          }
          if (!path4) {
            return doThrow(`path must not be empty`, TypeError);
          }
          if (checkPath.isNotRelative(path4)) {
            const r2 = "`path.relative()`d";
            return doThrow(`path should be a ${r2} string, but got "${originalPath}"`, RangeError);
          }
          return true;
        };
        var isNotRelative = (path4) => REGEX_TEST_INVALID_PATH.test(path4);
        checkPath.isNotRelative = isNotRelative;
        checkPath.convert = (p) => p;
        var Ignore = class {
          constructor({
            ignorecase = true,
            ignoreCase = ignorecase,
            allowRelativePaths = false
          } = {}) {
            define2(this, KEY_IGNORE, true);
            this._rules = [];
            this._ignoreCase = ignoreCase;
            this._allowRelativePaths = allowRelativePaths;
            this._initCache();
          }
          _initCache() {
            this._ignoreCache = /* @__PURE__ */ Object.create(null);
            this._testCache = /* @__PURE__ */ Object.create(null);
          }
          _addPattern(pattern) {
            if (pattern && pattern[KEY_IGNORE]) {
              this._rules = this._rules.concat(pattern._rules);
              this._added = true;
              return;
            }
            if (checkPattern(pattern)) {
              const rule = createRule(pattern, this._ignoreCase);
              this._added = true;
              this._rules.push(rule);
            }
          }
          add(pattern) {
            this._added = false;
            makeArray(isString(pattern) ? splitPattern(pattern) : pattern).forEach(this._addPattern, this);
            if (this._added) {
              this._initCache();
            }
            return this;
          }
          addPattern(pattern) {
            return this.add(pattern);
          }
          _testOne(path4, checkUnignored) {
            let ignored = false;
            let unignored = false;
            this._rules.forEach((rule) => {
              const {
                negative
              } = rule;
              if (unignored === negative && ignored !== unignored || negative && !ignored && !unignored && !checkUnignored) {
                return;
              }
              const matched = rule.regex.test(path4);
              if (matched) {
                ignored = !negative;
                unignored = negative;
              }
            });
            return {
              ignored,
              unignored
            };
          }
          _test(originalPath, cache, checkUnignored, slices) {
            const path4 = originalPath && checkPath.convert(originalPath);
            checkPath(path4, originalPath, this._allowRelativePaths ? RETURN_FALSE : throwError);
            return this._t(path4, cache, checkUnignored, slices);
          }
          _t(path4, cache, checkUnignored, slices) {
            if (path4 in cache) {
              return cache[path4];
            }
            if (!slices) {
              slices = path4.split(SLASH);
            }
            slices.pop();
            if (!slices.length) {
              return cache[path4] = this._testOne(path4, checkUnignored);
            }
            const parent = this._t(slices.join(SLASH) + SLASH, cache, checkUnignored, slices);
            return cache[path4] = parent.ignored ? parent : this._testOne(path4, checkUnignored);
          }
          ignores(path4) {
            return this._test(path4, this._ignoreCache, false).ignored;
          }
          createFilter() {
            return (path4) => !this.ignores(path4);
          }
          filter(paths) {
            return makeArray(paths).filter(this.createFilter());
          }
          test(path4) {
            return this._test(path4, this._testCache, true);
          }
        };
        var factory = (options) => new Ignore(options);
        var isPathValid = (path4) => checkPath(path4 && checkPath.convert(path4), path4, RETURN_FALSE);
        factory.isPathValid = isPathValid;
        factory.default = factory;
        module22.exports = factory;
        if (typeof process !== "undefined" && (process.env && process.env.IGNORE_TEST_WIN32 || process.platform === "win32")) {
          const makePosix = (str) => /^\\\\\?\\/.test(str) || /["<>|\u0000-\u001F]+/u.test(str) ? str : str.replace(/\\/g, "/");
          checkPath.convert = makePosix;
          const REGIX_IS_WINDOWS_PATH_ABSOLUTE = /^[a-z]:\//i;
          checkPath.isNotRelative = (path4) => REGIX_IS_WINDOWS_PATH_ABSOLUTE.test(path4) || isNotRelative(path4);
        }
      }
    });
    var require_get_file_content_or_null = __commonJS22({
      "src/utils/get-file-content-or-null.js"(exports2, module22) {
        "use strict";
        var fs4 = require("fs");
        var fsAsync = fs4.promises;
        async function getFileContentOrNull(filename) {
          try {
            return await fsAsync.readFile(filename, "utf8");
          } catch (error) {
            return handleError(filename, error);
          }
        }
        getFileContentOrNull.sync = function(filename) {
          try {
            return fs4.readFileSync(filename, "utf8");
          } catch (error) {
            return handleError(filename, error);
          }
        };
        function handleError(filename, error) {
          if (error && error.code === "ENOENT") {
            return null;
          }
          throw new Error(`Unable to read ${filename}: ${error.message}`);
        }
        module22.exports = getFileContentOrNull;
      }
    });
    var require_create_ignorer = __commonJS22({
      "src/common/create-ignorer.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var ignore = require_ignore2().default;
        var getFileContentOrNull = require_get_file_content_or_null();
        async function createIgnorer(ignorePath, withNodeModules) {
          const ignoreContent = ignorePath ? await getFileContentOrNull(path4.resolve(ignorePath)) : null;
          return _createIgnorer(ignoreContent, withNodeModules);
        }
        createIgnorer.sync = function(ignorePath, withNodeModules) {
          const ignoreContent = !ignorePath ? null : getFileContentOrNull.sync(path4.resolve(ignorePath));
          return _createIgnorer(ignoreContent, withNodeModules);
        };
        function _createIgnorer(ignoreContent, withNodeModules) {
          const ignorer = ignore({
            allowRelativePaths: true
          }).add(ignoreContent || "");
          if (!withNodeModules) {
            ignorer.add("node_modules");
          }
          return ignorer;
        }
        module22.exports = createIgnorer;
      }
    });
    var require_get_file_info = __commonJS22({
      "src/common/get-file-info.js"(exports2, module22) {
        "use strict";
        var path4 = require("path");
        var options = require_options();
        var config2 = require_resolve_config();
        var createIgnorer = require_create_ignorer();
        async function getFileInfo2(filePath, opts) {
          if (typeof filePath !== "string") {
            throw new TypeError(`expect \`filePath\` to be a string, got \`${typeof filePath}\``);
          }
          const ignorer = await createIgnorer(opts.ignorePath, opts.withNodeModules);
          return _getFileInfo({
            ignorer,
            filePath,
            plugins: opts.plugins,
            resolveConfig: opts.resolveConfig,
            ignorePath: opts.ignorePath,
            sync: false
          });
        }
        getFileInfo2.sync = function(filePath, opts) {
          if (typeof filePath !== "string") {
            throw new TypeError(`expect \`filePath\` to be a string, got \`${typeof filePath}\``);
          }
          const ignorer = createIgnorer.sync(opts.ignorePath, opts.withNodeModules);
          return _getFileInfo({
            ignorer,
            filePath,
            plugins: opts.plugins,
            resolveConfig: opts.resolveConfig,
            ignorePath: opts.ignorePath,
            sync: true
          });
        };
        function getFileParser(resolvedConfig, filePath, plugins2) {
          if (resolvedConfig && resolvedConfig.parser) {
            return resolvedConfig.parser;
          }
          const inferredParser = options.inferParser(filePath, plugins2);
          if (inferredParser) {
            return inferredParser;
          }
          return null;
        }
        function _getFileInfo({
          ignorer,
          filePath,
          plugins: plugins2,
          resolveConfig = false,
          ignorePath,
          sync: sync2 = false
        }) {
          const normalizedFilePath = normalizeFilePath(filePath, ignorePath);
          const fileInfo = {
            ignored: ignorer.ignores(normalizedFilePath),
            inferredParser: null
          };
          if (fileInfo.ignored) {
            return fileInfo;
          }
          let resolvedConfig;
          if (resolveConfig) {
            if (sync2) {
              resolvedConfig = config2.resolveConfig.sync(filePath);
            } else {
              return config2.resolveConfig(filePath).then((resolvedConfig2) => {
                fileInfo.inferredParser = getFileParser(resolvedConfig2, filePath, plugins2);
                return fileInfo;
              });
            }
          }
          fileInfo.inferredParser = getFileParser(resolvedConfig, filePath, plugins2);
          return fileInfo;
        }
        function normalizeFilePath(filePath, ignorePath) {
          return ignorePath ? path4.relative(path4.dirname(ignorePath), filePath) : filePath;
        }
        module22.exports = getFileInfo2;
      }
    });
    var require_util_shared = __commonJS22({
      "src/common/util-shared.js"(exports2, module22) {
        "use strict";
        var {
          getMaxContinuousCount,
          getStringWidth,
          getAlignmentSize,
          getIndentSize,
          skip,
          skipWhitespace,
          skipSpaces,
          skipNewline,
          skipToLineEnd,
          skipEverythingButNewLine,
          skipInlineComment,
          skipTrailingComment,
          hasNewline,
          hasNewlineInRange,
          hasSpaces,
          isNextLineEmpty,
          isNextLineEmptyAfterIndex,
          isPreviousLineEmpty,
          getNextNonSpaceNonCommentCharacterIndex,
          makeString,
          addLeadingComment,
          addDanglingComment,
          addTrailingComment
        } = require_util();
        module22.exports = {
          getMaxContinuousCount,
          getStringWidth,
          getAlignmentSize,
          getIndentSize,
          skip,
          skipWhitespace,
          skipSpaces,
          skipNewline,
          skipToLineEnd,
          skipEverythingButNewLine,
          skipInlineComment,
          skipTrailingComment,
          hasNewline,
          hasNewlineInRange,
          hasSpaces,
          isNextLineEmpty,
          isNextLineEmptyAfterIndex,
          isPreviousLineEmpty,
          getNextNonSpaceNonCommentCharacterIndex,
          makeString,
          addLeadingComment,
          addDanglingComment,
          addTrailingComment
        };
      }
    });
    var require_array3 = __commonJS22({
      "node_modules/fast-glob/out/utils/array.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.splitWhen = exports2.flatten = void 0;
        function flatten2(items) {
          return items.reduce((collection, item) => [].concat(collection, item), []);
        }
        exports2.flatten = flatten2;
        function splitWhen(items, predicate) {
          const result = [[]];
          let groupIndex = 0;
          for (const item of items) {
            if (predicate(item)) {
              groupIndex++;
              result[groupIndex] = [];
            } else {
              result[groupIndex].push(item);
            }
          }
          return result;
        }
        exports2.splitWhen = splitWhen;
      }
    });
    var require_errno2 = __commonJS22({
      "node_modules/fast-glob/out/utils/errno.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.isEnoentCodeError = void 0;
        function isEnoentCodeError(error) {
          return error.code === "ENOENT";
        }
        exports2.isEnoentCodeError = isEnoentCodeError;
      }
    });
    var require_fs9 = __commonJS22({
      "node_modules/fast-glob/out/utils/fs.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.createDirentFromStats = void 0;
        var DirentFromStats = class {
          constructor(name, stats) {
            this.name = name;
            this.isBlockDevice = stats.isBlockDevice.bind(stats);
            this.isCharacterDevice = stats.isCharacterDevice.bind(stats);
            this.isDirectory = stats.isDirectory.bind(stats);
            this.isFIFO = stats.isFIFO.bind(stats);
            this.isFile = stats.isFile.bind(stats);
            this.isSocket = stats.isSocket.bind(stats);
            this.isSymbolicLink = stats.isSymbolicLink.bind(stats);
          }
        };
        function createDirentFromStats(name, stats) {
          return new DirentFromStats(name, stats);
        }
        exports2.createDirentFromStats = createDirentFromStats;
      }
    });
    var require_path2 = __commonJS22({
      "node_modules/fast-glob/out/utils/path.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.removeLeadingDotSegment = exports2.escape = exports2.makeAbsolute = exports2.unixify = void 0;
        var path4 = require("path");
        var LEADING_DOT_SEGMENT_CHARACTERS_COUNT = 2;
        var UNESCAPED_GLOB_SYMBOLS_RE = /(\\?)([()*?[\]{|}]|^!|[!+@](?=\())/g;
        function unixify(filepath) {
          return filepath.replace(/\\/g, "/");
        }
        exports2.unixify = unixify;
        function makeAbsolute(cwd, filepath) {
          return path4.resolve(cwd, filepath);
        }
        exports2.makeAbsolute = makeAbsolute;
        function escape(pattern) {
          return pattern.replace(UNESCAPED_GLOB_SYMBOLS_RE, "\\$2");
        }
        exports2.escape = escape;
        function removeLeadingDotSegment(entry) {
          if (entry.charAt(0) === ".") {
            const secondCharactery = entry.charAt(1);
            if (secondCharactery === "/" || secondCharactery === "\\") {
              return entry.slice(LEADING_DOT_SEGMENT_CHARACTERS_COUNT);
            }
          }
          return entry;
        }
        exports2.removeLeadingDotSegment = removeLeadingDotSegment;
      }
    });
    var require_is_extglob2 = __commonJS22({
      "node_modules/is-extglob/index.js"(exports2, module22) {
        module22.exports = function isExtglob(str) {
          if (typeof str !== "string" || str === "") {
            return false;
          }
          var match;
          while (match = /(\\).|([@?!+*]\(.*\))/g.exec(str)) {
            if (match[2])
              return true;
            str = str.slice(match.index + match[0].length);
          }
          return false;
        };
      }
    });
    var require_is_glob2 = __commonJS22({
      "node_modules/is-glob/index.js"(exports2, module22) {
        var isExtglob = require_is_extglob2();
        var chars = {
          "{": "}",
          "(": ")",
          "[": "]"
        };
        var strictCheck = function(str) {
          if (str[0] === "!") {
            return true;
          }
          var index = 0;
          var pipeIndex = -2;
          var closeSquareIndex = -2;
          var closeCurlyIndex = -2;
          var closeParenIndex = -2;
          var backSlashIndex = -2;
          while (index < str.length) {
            if (str[index] === "*") {
              return true;
            }
            if (str[index + 1] === "?" && /[\].+)]/.test(str[index])) {
              return true;
            }
            if (closeSquareIndex !== -1 && str[index] === "[" && str[index + 1] !== "]") {
              if (closeSquareIndex < index) {
                closeSquareIndex = str.indexOf("]", index);
              }
              if (closeSquareIndex > index) {
                if (backSlashIndex === -1 || backSlashIndex > closeSquareIndex) {
                  return true;
                }
                backSlashIndex = str.indexOf("\\", index);
                if (backSlashIndex === -1 || backSlashIndex > closeSquareIndex) {
                  return true;
                }
              }
            }
            if (closeCurlyIndex !== -1 && str[index] === "{" && str[index + 1] !== "}") {
              closeCurlyIndex = str.indexOf("}", index);
              if (closeCurlyIndex > index) {
                backSlashIndex = str.indexOf("\\", index);
                if (backSlashIndex === -1 || backSlashIndex > closeCurlyIndex) {
                  return true;
                }
              }
            }
            if (closeParenIndex !== -1 && str[index] === "(" && str[index + 1] === "?" && /[:!=]/.test(str[index + 2]) && str[index + 3] !== ")") {
              closeParenIndex = str.indexOf(")", index);
              if (closeParenIndex > index) {
                backSlashIndex = str.indexOf("\\", index);
                if (backSlashIndex === -1 || backSlashIndex > closeParenIndex) {
                  return true;
                }
              }
            }
            if (pipeIndex !== -1 && str[index] === "(" && str[index + 1] !== "|") {
              if (pipeIndex < index) {
                pipeIndex = str.indexOf("|", index);
              }
              if (pipeIndex !== -1 && str[pipeIndex + 1] !== ")") {
                closeParenIndex = str.indexOf(")", pipeIndex);
                if (closeParenIndex > pipeIndex) {
                  backSlashIndex = str.indexOf("\\", pipeIndex);
                  if (backSlashIndex === -1 || backSlashIndex > closeParenIndex) {
                    return true;
                  }
                }
              }
            }
            if (str[index] === "\\") {
              var open = str[index + 1];
              index += 2;
              var close = chars[open];
              if (close) {
                var n = str.indexOf(close, index);
                if (n !== -1) {
                  index = n + 1;
                }
              }
              if (str[index] === "!") {
                return true;
              }
            } else {
              index++;
            }
          }
          return false;
        };
        var relaxedCheck = function(str) {
          if (str[0] === "!") {
            return true;
          }
          var index = 0;
          while (index < str.length) {
            if (/[*?{}()[\]]/.test(str[index])) {
              return true;
            }
            if (str[index] === "\\") {
              var open = str[index + 1];
              index += 2;
              var close = chars[open];
              if (close) {
                var n = str.indexOf(close, index);
                if (n !== -1) {
                  index = n + 1;
                }
              }
              if (str[index] === "!") {
                return true;
              }
            } else {
              index++;
            }
          }
          return false;
        };
        module22.exports = function isGlob(str, options) {
          if (typeof str !== "string" || str === "") {
            return false;
          }
          if (isExtglob(str)) {
            return true;
          }
          var check = strictCheck;
          if (options && options.strict === false) {
            check = relaxedCheck;
          }
          return check(str);
        };
      }
    });
    var require_glob_parent2 = __commonJS22({
      "node_modules/glob-parent/index.js"(exports2, module22) {
        "use strict";
        var isGlob = require_is_glob2();
        var pathPosixDirname = require("path").posix.dirname;
        var isWin32 = require("os").platform() === "win32";
        var slash = "/";
        var backslash = /\\/g;
        var enclosure = /[\{\[].*[\}\]]$/;
        var globby = /(^|[^\\])([\{\[]|\([^\)]+$)/;
        var escaped = /\\([\!\*\?\|\[\]\(\)\{\}])/g;
        module22.exports = function globParent(str, opts) {
          var options = Object.assign({
            flipBackslashes: true
          }, opts);
          if (options.flipBackslashes && isWin32 && str.indexOf(slash) < 0) {
            str = str.replace(backslash, slash);
          }
          if (enclosure.test(str)) {
            str += slash;
          }
          str += "a";
          do {
            str = pathPosixDirname(str);
          } while (isGlob(str) || globby.test(str));
          return str.replace(escaped, "$1");
        };
      }
    });
    var require_pattern2 = __commonJS22({
      "node_modules/fast-glob/out/utils/pattern.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.matchAny = exports2.convertPatternsToRe = exports2.makeRe = exports2.getPatternParts = exports2.expandBraceExpansion = exports2.expandPatternsWithBraceExpansion = exports2.isAffectDepthOfReadingPattern = exports2.endsWithSlashGlobStar = exports2.hasGlobStar = exports2.getBaseDirectory = exports2.isPatternRelatedToParentDirectory = exports2.getPatternsOutsideCurrentDirectory = exports2.getPatternsInsideCurrentDirectory = exports2.getPositivePatterns = exports2.getNegativePatterns = exports2.isPositivePattern = exports2.isNegativePattern = exports2.convertToNegativePattern = exports2.convertToPositivePattern = exports2.isDynamicPattern = exports2.isStaticPattern = void 0;
        var path4 = require("path");
        var globParent = require_glob_parent2();
        var micromatch2 = require_micromatch2();
        var GLOBSTAR = "**";
        var ESCAPE_SYMBOL = "\\";
        var COMMON_GLOB_SYMBOLS_RE = /[*?]|^!/;
        var REGEX_CHARACTER_CLASS_SYMBOLS_RE = /\[[^[]*]/;
        var REGEX_GROUP_SYMBOLS_RE = /(?:^|[^!*+?@])\([^(]*\|[^|]*\)/;
        var GLOB_EXTENSION_SYMBOLS_RE = /[!*+?@]\([^(]*\)/;
        var BRACE_EXPANSION_SEPARATORS_RE = /,|\.\./;
        function isStaticPattern(pattern, options = {}) {
          return !isDynamicPattern(pattern, options);
        }
        exports2.isStaticPattern = isStaticPattern;
        function isDynamicPattern(pattern, options = {}) {
          if (pattern === "") {
            return false;
          }
          if (options.caseSensitiveMatch === false || pattern.includes(ESCAPE_SYMBOL)) {
            return true;
          }
          if (COMMON_GLOB_SYMBOLS_RE.test(pattern) || REGEX_CHARACTER_CLASS_SYMBOLS_RE.test(pattern) || REGEX_GROUP_SYMBOLS_RE.test(pattern)) {
            return true;
          }
          if (options.extglob !== false && GLOB_EXTENSION_SYMBOLS_RE.test(pattern)) {
            return true;
          }
          if (options.braceExpansion !== false && hasBraceExpansion(pattern)) {
            return true;
          }
          return false;
        }
        exports2.isDynamicPattern = isDynamicPattern;
        function hasBraceExpansion(pattern) {
          const openingBraceIndex = pattern.indexOf("{");
          if (openingBraceIndex === -1) {
            return false;
          }
          const closingBraceIndex = pattern.indexOf("}", openingBraceIndex + 1);
          if (closingBraceIndex === -1) {
            return false;
          }
          const braceContent = pattern.slice(openingBraceIndex, closingBraceIndex);
          return BRACE_EXPANSION_SEPARATORS_RE.test(braceContent);
        }
        function convertToPositivePattern(pattern) {
          return isNegativePattern(pattern) ? pattern.slice(1) : pattern;
        }
        exports2.convertToPositivePattern = convertToPositivePattern;
        function convertToNegativePattern(pattern) {
          return "!" + pattern;
        }
        exports2.convertToNegativePattern = convertToNegativePattern;
        function isNegativePattern(pattern) {
          return pattern.startsWith("!") && pattern[1] !== "(";
        }
        exports2.isNegativePattern = isNegativePattern;
        function isPositivePattern(pattern) {
          return !isNegativePattern(pattern);
        }
        exports2.isPositivePattern = isPositivePattern;
        function getNegativePatterns(patterns) {
          return patterns.filter(isNegativePattern);
        }
        exports2.getNegativePatterns = getNegativePatterns;
        function getPositivePatterns(patterns) {
          return patterns.filter(isPositivePattern);
        }
        exports2.getPositivePatterns = getPositivePatterns;
        function getPatternsInsideCurrentDirectory(patterns) {
          return patterns.filter((pattern) => !isPatternRelatedToParentDirectory(pattern));
        }
        exports2.getPatternsInsideCurrentDirectory = getPatternsInsideCurrentDirectory;
        function getPatternsOutsideCurrentDirectory(patterns) {
          return patterns.filter(isPatternRelatedToParentDirectory);
        }
        exports2.getPatternsOutsideCurrentDirectory = getPatternsOutsideCurrentDirectory;
        function isPatternRelatedToParentDirectory(pattern) {
          return pattern.startsWith("..") || pattern.startsWith("./..");
        }
        exports2.isPatternRelatedToParentDirectory = isPatternRelatedToParentDirectory;
        function getBaseDirectory(pattern) {
          return globParent(pattern, {
            flipBackslashes: false
          });
        }
        exports2.getBaseDirectory = getBaseDirectory;
        function hasGlobStar(pattern) {
          return pattern.includes(GLOBSTAR);
        }
        exports2.hasGlobStar = hasGlobStar;
        function endsWithSlashGlobStar(pattern) {
          return pattern.endsWith("/" + GLOBSTAR);
        }
        exports2.endsWithSlashGlobStar = endsWithSlashGlobStar;
        function isAffectDepthOfReadingPattern(pattern) {
          const basename2 = path4.basename(pattern);
          return endsWithSlashGlobStar(pattern) || isStaticPattern(basename2);
        }
        exports2.isAffectDepthOfReadingPattern = isAffectDepthOfReadingPattern;
        function expandPatternsWithBraceExpansion(patterns) {
          return patterns.reduce((collection, pattern) => {
            return collection.concat(expandBraceExpansion(pattern));
          }, []);
        }
        exports2.expandPatternsWithBraceExpansion = expandPatternsWithBraceExpansion;
        function expandBraceExpansion(pattern) {
          return micromatch2.braces(pattern, {
            expand: true,
            nodupes: true
          });
        }
        exports2.expandBraceExpansion = expandBraceExpansion;
        function getPatternParts(pattern, options) {
          let {
            parts
          } = micromatch2.scan(pattern, Object.assign(Object.assign({}, options), {
            parts: true
          }));
          if (parts.length === 0) {
            parts = [pattern];
          }
          if (parts[0].startsWith("/")) {
            parts[0] = parts[0].slice(1);
            parts.unshift("");
          }
          return parts;
        }
        exports2.getPatternParts = getPatternParts;
        function makeRe(pattern, options) {
          return micromatch2.makeRe(pattern, options);
        }
        exports2.makeRe = makeRe;
        function convertPatternsToRe(patterns, options) {
          return patterns.map((pattern) => makeRe(pattern, options));
        }
        exports2.convertPatternsToRe = convertPatternsToRe;
        function matchAny(entry, patternsRe) {
          return patternsRe.some((patternRe) => patternRe.test(entry));
        }
        exports2.matchAny = matchAny;
      }
    });
    var require_merge22 = __commonJS22({
      "node_modules/merge2/index.js"(exports2, module22) {
        "use strict";
        var Stream4 = require("stream");
        var PassThrough4 = Stream4.PassThrough;
        var slice = Array.prototype.slice;
        module22.exports = merge2;
        function merge2() {
          const streamsQueue = [];
          const args = slice.call(arguments);
          let merging = false;
          let options = args[args.length - 1];
          if (options && !Array.isArray(options) && options.pipe == null) {
            args.pop();
          } else {
            options = {};
          }
          const doEnd = options.end !== false;
          const doPipeError = options.pipeError === true;
          if (options.objectMode == null) {
            options.objectMode = true;
          }
          if (options.highWaterMark == null) {
            options.highWaterMark = 64 * 1024;
          }
          const mergedStream = PassThrough4(options);
          function addStream() {
            for (let i2 = 0, len = arguments.length; i2 < len; i2++) {
              streamsQueue.push(pauseStreams(arguments[i2], options));
            }
            mergeStream();
            return this;
          }
          function mergeStream() {
            if (merging) {
              return;
            }
            merging = true;
            let streams = streamsQueue.shift();
            if (!streams) {
              process.nextTick(endStream);
              return;
            }
            if (!Array.isArray(streams)) {
              streams = [streams];
            }
            let pipesCount = streams.length + 1;
            function next() {
              if (--pipesCount > 0) {
                return;
              }
              merging = false;
              mergeStream();
            }
            function pipe(stream) {
              function onend() {
                stream.removeListener("merge2UnpipeEnd", onend);
                stream.removeListener("end", onend);
                if (doPipeError) {
                  stream.removeListener("error", onerror);
                }
                next();
              }
              function onerror(err) {
                mergedStream.emit("error", err);
              }
              if (stream._readableState.endEmitted) {
                return next();
              }
              stream.on("merge2UnpipeEnd", onend);
              stream.on("end", onend);
              if (doPipeError) {
                stream.on("error", onerror);
              }
              stream.pipe(mergedStream, {
                end: false
              });
              stream.resume();
            }
            for (let i2 = 0; i2 < streams.length; i2++) {
              pipe(streams[i2]);
            }
            next();
          }
          function endStream() {
            merging = false;
            mergedStream.emit("queueDrain");
            if (doEnd) {
              mergedStream.end();
            }
          }
          mergedStream.setMaxListeners(0);
          mergedStream.add = addStream;
          mergedStream.on("unpipe", function(stream) {
            stream.emit("merge2UnpipeEnd");
          });
          if (args.length) {
            addStream.apply(null, args);
          }
          return mergedStream;
        }
        function pauseStreams(streams, options) {
          if (!Array.isArray(streams)) {
            if (!streams._readableState && streams.pipe) {
              streams = streams.pipe(PassThrough4(options));
            }
            if (!streams._readableState || !streams.pause || !streams.pipe) {
              throw new Error("Only readable stream can be merged.");
            }
            streams.pause();
          } else {
            for (let i2 = 0, len = streams.length; i2 < len; i2++) {
              streams[i2] = pauseStreams(streams[i2], options);
            }
          }
          return streams;
        }
      }
    });
    var require_stream5 = __commonJS22({
      "node_modules/fast-glob/out/utils/stream.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.merge = void 0;
        var merge2 = require_merge22();
        function merge3(streams) {
          const mergedStream = merge2(streams);
          streams.forEach((stream) => {
            stream.once("error", (error) => mergedStream.emit("error", error));
          });
          mergedStream.once("close", () => propagateCloseEventToSources(streams));
          mergedStream.once("end", () => propagateCloseEventToSources(streams));
          return mergedStream;
        }
        exports2.merge = merge3;
        function propagateCloseEventToSources(streams) {
          streams.forEach((stream) => stream.emit("close"));
        }
      }
    });
    var require_string22 = __commonJS22({
      "node_modules/fast-glob/out/utils/string.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.isEmpty = exports2.isString = void 0;
        function isString(input) {
          return typeof input === "string";
        }
        exports2.isString = isString;
        function isEmpty(input) {
          return input === "";
        }
        exports2.isEmpty = isEmpty;
      }
    });
    var require_utils42 = __commonJS22({
      "node_modules/fast-glob/out/utils/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.string = exports2.stream = exports2.pattern = exports2.path = exports2.fs = exports2.errno = exports2.array = void 0;
        var array = require_array3();
        exports2.array = array;
        var errno = require_errno2();
        exports2.errno = errno;
        var fs4 = require_fs9();
        exports2.fs = fs4;
        var path4 = require_path2();
        exports2.path = path4;
        var pattern = require_pattern2();
        exports2.pattern = pattern;
        var stream = require_stream5();
        exports2.stream = stream;
        var string = require_string22();
        exports2.string = string;
      }
    });
    var require_tasks2 = __commonJS22({
      "node_modules/fast-glob/out/managers/tasks.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.convertPatternGroupToTask = exports2.convertPatternGroupsToTasks = exports2.groupPatternsByBaseDirectory = exports2.getNegativePatternsAsPositive = exports2.getPositivePatterns = exports2.convertPatternsToTasks = exports2.generate = void 0;
        var utils = require_utils42();
        function generate(patterns, settings) {
          const positivePatterns = getPositivePatterns(patterns);
          const negativePatterns = getNegativePatternsAsPositive(patterns, settings.ignore);
          const staticPatterns = positivePatterns.filter((pattern) => utils.pattern.isStaticPattern(pattern, settings));
          const dynamicPatterns = positivePatterns.filter((pattern) => utils.pattern.isDynamicPattern(pattern, settings));
          const staticTasks = convertPatternsToTasks(staticPatterns, negativePatterns, false);
          const dynamicTasks = convertPatternsToTasks(dynamicPatterns, negativePatterns, true);
          return staticTasks.concat(dynamicTasks);
        }
        exports2.generate = generate;
        function convertPatternsToTasks(positive, negative, dynamic) {
          const tasks = [];
          const patternsOutsideCurrentDirectory = utils.pattern.getPatternsOutsideCurrentDirectory(positive);
          const patternsInsideCurrentDirectory = utils.pattern.getPatternsInsideCurrentDirectory(positive);
          const outsideCurrentDirectoryGroup = groupPatternsByBaseDirectory(patternsOutsideCurrentDirectory);
          const insideCurrentDirectoryGroup = groupPatternsByBaseDirectory(patternsInsideCurrentDirectory);
          tasks.push(...convertPatternGroupsToTasks(outsideCurrentDirectoryGroup, negative, dynamic));
          if ("." in insideCurrentDirectoryGroup) {
            tasks.push(convertPatternGroupToTask(".", patternsInsideCurrentDirectory, negative, dynamic));
          } else {
            tasks.push(...convertPatternGroupsToTasks(insideCurrentDirectoryGroup, negative, dynamic));
          }
          return tasks;
        }
        exports2.convertPatternsToTasks = convertPatternsToTasks;
        function getPositivePatterns(patterns) {
          return utils.pattern.getPositivePatterns(patterns);
        }
        exports2.getPositivePatterns = getPositivePatterns;
        function getNegativePatternsAsPositive(patterns, ignore) {
          const negative = utils.pattern.getNegativePatterns(patterns).concat(ignore);
          const positive = negative.map(utils.pattern.convertToPositivePattern);
          return positive;
        }
        exports2.getNegativePatternsAsPositive = getNegativePatternsAsPositive;
        function groupPatternsByBaseDirectory(patterns) {
          const group = {};
          return patterns.reduce((collection, pattern) => {
            const base = utils.pattern.getBaseDirectory(pattern);
            if (base in collection) {
              collection[base].push(pattern);
            } else {
              collection[base] = [pattern];
            }
            return collection;
          }, group);
        }
        exports2.groupPatternsByBaseDirectory = groupPatternsByBaseDirectory;
        function convertPatternGroupsToTasks(positive, negative, dynamic) {
          return Object.keys(positive).map((base) => {
            return convertPatternGroupToTask(base, positive[base], negative, dynamic);
          });
        }
        exports2.convertPatternGroupsToTasks = convertPatternGroupsToTasks;
        function convertPatternGroupToTask(base, positive, negative, dynamic) {
          return {
            dynamic,
            positive,
            negative,
            base,
            patterns: [].concat(positive, negative.map(utils.pattern.convertToNegativePattern))
          };
        }
        exports2.convertPatternGroupToTask = convertPatternGroupToTask;
      }
    });
    var require_patterns2 = __commonJS22({
      "node_modules/fast-glob/out/managers/patterns.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.removeDuplicateSlashes = exports2.transform = void 0;
        var DOUBLE_SLASH_RE = /(?!^)\/{2,}/g;
        function transform(patterns) {
          return patterns.map((pattern) => removeDuplicateSlashes(pattern));
        }
        exports2.transform = transform;
        function removeDuplicateSlashes(pattern) {
          return pattern.replace(DOUBLE_SLASH_RE, "/");
        }
        exports2.removeDuplicateSlashes = removeDuplicateSlashes;
      }
    });
    var require_async22 = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/providers/async.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.read = void 0;
        function read2(path4, settings, callback) {
          settings.fs.lstat(path4, (lstatError, lstat) => {
            if (lstatError !== null) {
              callFailureCallback(callback, lstatError);
              return;
            }
            if (!lstat.isSymbolicLink() || !settings.followSymbolicLink) {
              callSuccessCallback(callback, lstat);
              return;
            }
            settings.fs.stat(path4, (statError, stat3) => {
              if (statError !== null) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                  callFailureCallback(callback, statError);
                  return;
                }
                callSuccessCallback(callback, lstat);
                return;
              }
              if (settings.markSymbolicLink) {
                stat3.isSymbolicLink = () => true;
              }
              callSuccessCallback(callback, stat3);
            });
          });
        }
        exports2.read = read2;
        function callFailureCallback(callback, error) {
          callback(error);
        }
        function callSuccessCallback(callback, result) {
          callback(null, result);
        }
      }
    });
    var require_sync22 = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/providers/sync.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.read = void 0;
        function read2(path4, settings) {
          const lstat = settings.fs.lstatSync(path4);
          if (!lstat.isSymbolicLink() || !settings.followSymbolicLink) {
            return lstat;
          }
          try {
            const stat3 = settings.fs.statSync(path4);
            if (settings.markSymbolicLink) {
              stat3.isSymbolicLink = () => true;
            }
            return stat3;
          } catch (error) {
            if (!settings.throwErrorOnBrokenSymbolicLink) {
              return lstat;
            }
            throw error;
          }
        }
        exports2.read = read2;
      }
    });
    var require_fs22 = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/adapters/fs.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.createFileSystemAdapter = exports2.FILE_SYSTEM_ADAPTER = void 0;
        var fs4 = require("fs");
        exports2.FILE_SYSTEM_ADAPTER = {
          lstat: fs4.lstat,
          stat: fs4.stat,
          lstatSync: fs4.lstatSync,
          statSync: fs4.statSync
        };
        function createFileSystemAdapter(fsMethods) {
          if (fsMethods === void 0) {
            return exports2.FILE_SYSTEM_ADAPTER;
          }
          return Object.assign(Object.assign({}, exports2.FILE_SYSTEM_ADAPTER), fsMethods);
        }
        exports2.createFileSystemAdapter = createFileSystemAdapter;
      }
    });
    var require_settings5 = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/settings.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var fs4 = require_fs22();
        var Settings = class {
          constructor(_options = {}) {
            this._options = _options;
            this.followSymbolicLink = this._getValue(this._options.followSymbolicLink, true);
            this.fs = fs4.createFileSystemAdapter(this._options.fs);
            this.markSymbolicLink = this._getValue(this._options.markSymbolicLink, false);
            this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, true);
          }
          _getValue(option, value) {
            return option !== null && option !== void 0 ? option : value;
          }
        };
        exports2.default = Settings;
      }
    });
    var require_out5 = __commonJS22({
      "node_modules/@nodelib/fs.stat/out/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.statSync = exports2.stat = exports2.Settings = void 0;
        var async = require_async22();
        var sync2 = require_sync22();
        var settings_1 = require_settings5();
        exports2.Settings = settings_1.default;
        function stat3(path4, optionsOrSettingsOrCallback, callback) {
          if (typeof optionsOrSettingsOrCallback === "function") {
            async.read(path4, getSettings(), optionsOrSettingsOrCallback);
            return;
          }
          async.read(path4, getSettings(optionsOrSettingsOrCallback), callback);
        }
        exports2.stat = stat3;
        function statSync2(path4, optionsOrSettings) {
          const settings = getSettings(optionsOrSettings);
          return sync2.read(path4, settings);
        }
        exports2.statSync = statSync2;
        function getSettings(settingsOrOptions = {}) {
          if (settingsOrOptions instanceof settings_1.default) {
            return settingsOrOptions;
          }
          return new settings_1.default(settingsOrOptions);
        }
      }
    });
    var require_queue_microtask = __commonJS22({
      "node_modules/queue-microtask/index.js"(exports2, module22) {
        var promise;
        module22.exports = typeof queueMicrotask === "function" ? queueMicrotask.bind(typeof window !== "undefined" ? window : global) : (cb) => (promise || (promise = Promise.resolve())).then(cb).catch((err) => setTimeout(() => {
          throw err;
        }, 0));
      }
    });
    var require_run_parallel2 = __commonJS22({
      "node_modules/run-parallel/index.js"(exports2, module22) {
        module22.exports = runParallel;
        var queueMicrotask2 = require_queue_microtask();
        function runParallel(tasks, cb) {
          let results, pending, keys;
          let isSync = true;
          if (Array.isArray(tasks)) {
            results = [];
            pending = tasks.length;
          } else {
            keys = Object.keys(tasks);
            results = {};
            pending = keys.length;
          }
          function done(err) {
            function end() {
              if (cb)
                cb(err, results);
              cb = null;
            }
            if (isSync)
              queueMicrotask2(end);
            else
              end();
          }
          function each(i2, err, result) {
            results[i2] = result;
            if (--pending === 0 || err) {
              done(err);
            }
          }
          if (!pending) {
            done(null);
          } else if (keys) {
            keys.forEach(function(key) {
              tasks[key](function(err, result) {
                each(key, err, result);
              });
            });
          } else {
            tasks.forEach(function(task, i2) {
              task(function(err, result) {
                each(i2, err, result);
              });
            });
          }
          isSync = false;
        }
      }
    });
    var require_constants42 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/constants.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.IS_SUPPORT_READDIR_WITH_FILE_TYPES = void 0;
        var NODE_PROCESS_VERSION_PARTS = process.versions.node.split(".");
        if (NODE_PROCESS_VERSION_PARTS[0] === void 0 || NODE_PROCESS_VERSION_PARTS[1] === void 0) {
          throw new Error(`Unexpected behavior. The 'process.versions.node' variable has invalid value: ${process.versions.node}`);
        }
        var MAJOR_VERSION = Number.parseInt(NODE_PROCESS_VERSION_PARTS[0], 10);
        var MINOR_VERSION = Number.parseInt(NODE_PROCESS_VERSION_PARTS[1], 10);
        var SUPPORTED_MAJOR_VERSION = 10;
        var SUPPORTED_MINOR_VERSION = 10;
        var IS_MATCHED_BY_MAJOR = MAJOR_VERSION > SUPPORTED_MAJOR_VERSION;
        var IS_MATCHED_BY_MAJOR_AND_MINOR = MAJOR_VERSION === SUPPORTED_MAJOR_VERSION && MINOR_VERSION >= SUPPORTED_MINOR_VERSION;
        exports2.IS_SUPPORT_READDIR_WITH_FILE_TYPES = IS_MATCHED_BY_MAJOR || IS_MATCHED_BY_MAJOR_AND_MINOR;
      }
    });
    var require_fs32 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/utils/fs.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.createDirentFromStats = void 0;
        var DirentFromStats = class {
          constructor(name, stats) {
            this.name = name;
            this.isBlockDevice = stats.isBlockDevice.bind(stats);
            this.isCharacterDevice = stats.isCharacterDevice.bind(stats);
            this.isDirectory = stats.isDirectory.bind(stats);
            this.isFIFO = stats.isFIFO.bind(stats);
            this.isFile = stats.isFile.bind(stats);
            this.isSocket = stats.isSocket.bind(stats);
            this.isSymbolicLink = stats.isSymbolicLink.bind(stats);
          }
        };
        function createDirentFromStats(name, stats) {
          return new DirentFromStats(name, stats);
        }
        exports2.createDirentFromStats = createDirentFromStats;
      }
    });
    var require_utils52 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/utils/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.fs = void 0;
        var fs4 = require_fs32();
        exports2.fs = fs4;
      }
    });
    var require_common32 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/providers/common.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.joinPathSegments = void 0;
        function joinPathSegments(a, b, separator) {
          if (a.endsWith(separator)) {
            return a + b;
          }
          return a + separator + b;
        }
        exports2.joinPathSegments = joinPathSegments;
      }
    });
    var require_async32 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/providers/async.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.readdir = exports2.readdirWithFileTypes = exports2.read = void 0;
        var fsStat = require_out5();
        var rpl = require_run_parallel2();
        var constants_1 = require_constants42();
        var utils = require_utils52();
        var common = require_common32();
        function read2(directory, settings, callback) {
          if (!settings.stats && constants_1.IS_SUPPORT_READDIR_WITH_FILE_TYPES) {
            readdirWithFileTypes(directory, settings, callback);
            return;
          }
          readdir(directory, settings, callback);
        }
        exports2.read = read2;
        function readdirWithFileTypes(directory, settings, callback) {
          settings.fs.readdir(directory, {
            withFileTypes: true
          }, (readdirError, dirents) => {
            if (readdirError !== null) {
              callFailureCallback(callback, readdirError);
              return;
            }
            const entries = dirents.map((dirent) => ({
              dirent,
              name: dirent.name,
              path: common.joinPathSegments(directory, dirent.name, settings.pathSegmentSeparator)
            }));
            if (!settings.followSymbolicLinks) {
              callSuccessCallback(callback, entries);
              return;
            }
            const tasks = entries.map((entry) => makeRplTaskEntry(entry, settings));
            rpl(tasks, (rplError, rplEntries) => {
              if (rplError !== null) {
                callFailureCallback(callback, rplError);
                return;
              }
              callSuccessCallback(callback, rplEntries);
            });
          });
        }
        exports2.readdirWithFileTypes = readdirWithFileTypes;
        function makeRplTaskEntry(entry, settings) {
          return (done) => {
            if (!entry.dirent.isSymbolicLink()) {
              done(null, entry);
              return;
            }
            settings.fs.stat(entry.path, (statError, stats) => {
              if (statError !== null) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                  done(statError);
                  return;
                }
                done(null, entry);
                return;
              }
              entry.dirent = utils.fs.createDirentFromStats(entry.name, stats);
              done(null, entry);
            });
          };
        }
        function readdir(directory, settings, callback) {
          settings.fs.readdir(directory, (readdirError, names) => {
            if (readdirError !== null) {
              callFailureCallback(callback, readdirError);
              return;
            }
            const tasks = names.map((name) => {
              const path4 = common.joinPathSegments(directory, name, settings.pathSegmentSeparator);
              return (done) => {
                fsStat.stat(path4, settings.fsStatSettings, (error, stats) => {
                  if (error !== null) {
                    done(error);
                    return;
                  }
                  const entry = {
                    name,
                    path: path4,
                    dirent: utils.fs.createDirentFromStats(name, stats)
                  };
                  if (settings.stats) {
                    entry.stats = stats;
                  }
                  done(null, entry);
                });
              };
            });
            rpl(tasks, (rplError, entries) => {
              if (rplError !== null) {
                callFailureCallback(callback, rplError);
                return;
              }
              callSuccessCallback(callback, entries);
            });
          });
        }
        exports2.readdir = readdir;
        function callFailureCallback(callback, error) {
          callback(error);
        }
        function callSuccessCallback(callback, result) {
          callback(null, result);
        }
      }
    });
    var require_sync32 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/providers/sync.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.readdir = exports2.readdirWithFileTypes = exports2.read = void 0;
        var fsStat = require_out5();
        var constants_1 = require_constants42();
        var utils = require_utils52();
        var common = require_common32();
        function read2(directory, settings) {
          if (!settings.stats && constants_1.IS_SUPPORT_READDIR_WITH_FILE_TYPES) {
            return readdirWithFileTypes(directory, settings);
          }
          return readdir(directory, settings);
        }
        exports2.read = read2;
        function readdirWithFileTypes(directory, settings) {
          const dirents = settings.fs.readdirSync(directory, {
            withFileTypes: true
          });
          return dirents.map((dirent) => {
            const entry = {
              dirent,
              name: dirent.name,
              path: common.joinPathSegments(directory, dirent.name, settings.pathSegmentSeparator)
            };
            if (entry.dirent.isSymbolicLink() && settings.followSymbolicLinks) {
              try {
                const stats = settings.fs.statSync(entry.path);
                entry.dirent = utils.fs.createDirentFromStats(entry.name, stats);
              } catch (error) {
                if (settings.throwErrorOnBrokenSymbolicLink) {
                  throw error;
                }
              }
            }
            return entry;
          });
        }
        exports2.readdirWithFileTypes = readdirWithFileTypes;
        function readdir(directory, settings) {
          const names = settings.fs.readdirSync(directory);
          return names.map((name) => {
            const entryPath = common.joinPathSegments(directory, name, settings.pathSegmentSeparator);
            const stats = fsStat.statSync(entryPath, settings.fsStatSettings);
            const entry = {
              name,
              path: entryPath,
              dirent: utils.fs.createDirentFromStats(name, stats)
            };
            if (settings.stats) {
              entry.stats = stats;
            }
            return entry;
          });
        }
        exports2.readdir = readdir;
      }
    });
    var require_fs42 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/adapters/fs.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.createFileSystemAdapter = exports2.FILE_SYSTEM_ADAPTER = void 0;
        var fs4 = require("fs");
        exports2.FILE_SYSTEM_ADAPTER = {
          lstat: fs4.lstat,
          stat: fs4.stat,
          lstatSync: fs4.lstatSync,
          statSync: fs4.statSync,
          readdir: fs4.readdir,
          readdirSync: fs4.readdirSync
        };
        function createFileSystemAdapter(fsMethods) {
          if (fsMethods === void 0) {
            return exports2.FILE_SYSTEM_ADAPTER;
          }
          return Object.assign(Object.assign({}, exports2.FILE_SYSTEM_ADAPTER), fsMethods);
        }
        exports2.createFileSystemAdapter = createFileSystemAdapter;
      }
    });
    var require_settings22 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/settings.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var path4 = require("path");
        var fsStat = require_out5();
        var fs4 = require_fs42();
        var Settings = class {
          constructor(_options = {}) {
            this._options = _options;
            this.followSymbolicLinks = this._getValue(this._options.followSymbolicLinks, false);
            this.fs = fs4.createFileSystemAdapter(this._options.fs);
            this.pathSegmentSeparator = this._getValue(this._options.pathSegmentSeparator, path4.sep);
            this.stats = this._getValue(this._options.stats, false);
            this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, true);
            this.fsStatSettings = new fsStat.Settings({
              followSymbolicLink: this.followSymbolicLinks,
              fs: this.fs,
              throwErrorOnBrokenSymbolicLink: this.throwErrorOnBrokenSymbolicLink
            });
          }
          _getValue(option, value) {
            return option !== null && option !== void 0 ? option : value;
          }
        };
        exports2.default = Settings;
      }
    });
    var require_out22 = __commonJS22({
      "node_modules/@nodelib/fs.scandir/out/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.Settings = exports2.scandirSync = exports2.scandir = void 0;
        var async = require_async32();
        var sync2 = require_sync32();
        var settings_1 = require_settings22();
        exports2.Settings = settings_1.default;
        function scandir(path4, optionsOrSettingsOrCallback, callback) {
          if (typeof optionsOrSettingsOrCallback === "function") {
            async.read(path4, getSettings(), optionsOrSettingsOrCallback);
            return;
          }
          async.read(path4, getSettings(optionsOrSettingsOrCallback), callback);
        }
        exports2.scandir = scandir;
        function scandirSync(path4, optionsOrSettings) {
          const settings = getSettings(optionsOrSettings);
          return sync2.read(path4, settings);
        }
        exports2.scandirSync = scandirSync;
        function getSettings(settingsOrOptions = {}) {
          if (settingsOrOptions instanceof settings_1.default) {
            return settingsOrOptions;
          }
          return new settings_1.default(settingsOrOptions);
        }
      }
    });
    var require_reusify2 = __commonJS22({
      "node_modules/reusify/reusify.js"(exports2, module22) {
        "use strict";
        function reusify(Constructor) {
          var head = new Constructor();
          var tail = head;
          function get() {
            var current = head;
            if (current.next) {
              head = current.next;
            } else {
              head = new Constructor();
              tail = head;
            }
            current.next = null;
            return current;
          }
          function release(obj) {
            tail.next = obj;
            tail = obj;
          }
          return {
            get,
            release
          };
        }
        module22.exports = reusify;
      }
    });
    var require_queue2 = __commonJS22({
      "node_modules/fastq/queue.js"(exports2, module22) {
        "use strict";
        var reusify = require_reusify2();
        function fastqueue(context2, worker, concurrency) {
          if (typeof context2 === "function") {
            concurrency = worker;
            worker = context2;
            context2 = null;
          }
          if (concurrency < 1) {
            throw new Error("fastqueue concurrency must be greater than 1");
          }
          var cache = reusify(Task);
          var queueHead = null;
          var queueTail = null;
          var _running = 0;
          var errorHandler = null;
          var self2 = {
            push: push2,
            drain: noop2,
            saturated: noop2,
            pause,
            paused: false,
            concurrency,
            running,
            resume,
            idle,
            length,
            getQueue,
            unshift,
            empty: noop2,
            kill,
            killAndDrain,
            error
          };
          return self2;
          function running() {
            return _running;
          }
          function pause() {
            self2.paused = true;
          }
          function length() {
            var current = queueHead;
            var counter = 0;
            while (current) {
              current = current.next;
              counter++;
            }
            return counter;
          }
          function getQueue() {
            var current = queueHead;
            var tasks = [];
            while (current) {
              tasks.push(current.value);
              current = current.next;
            }
            return tasks;
          }
          function resume() {
            if (!self2.paused)
              return;
            self2.paused = false;
            for (var i2 = 0; i2 < self2.concurrency; i2++) {
              _running++;
              release();
            }
          }
          function idle() {
            return _running === 0 && self2.length() === 0;
          }
          function push2(value, done) {
            var current = cache.get();
            current.context = context2;
            current.release = release;
            current.value = value;
            current.callback = done || noop2;
            current.errorHandler = errorHandler;
            if (_running === self2.concurrency || self2.paused) {
              if (queueTail) {
                queueTail.next = current;
                queueTail = current;
              } else {
                queueHead = current;
                queueTail = current;
                self2.saturated();
              }
            } else {
              _running++;
              worker.call(context2, current.value, current.worked);
            }
          }
          function unshift(value, done) {
            var current = cache.get();
            current.context = context2;
            current.release = release;
            current.value = value;
            current.callback = done || noop2;
            if (_running === self2.concurrency || self2.paused) {
              if (queueHead) {
                current.next = queueHead;
                queueHead = current;
              } else {
                queueHead = current;
                queueTail = current;
                self2.saturated();
              }
            } else {
              _running++;
              worker.call(context2, current.value, current.worked);
            }
          }
          function release(holder) {
            if (holder) {
              cache.release(holder);
            }
            var next = queueHead;
            if (next) {
              if (!self2.paused) {
                if (queueTail === queueHead) {
                  queueTail = null;
                }
                queueHead = next.next;
                next.next = null;
                worker.call(context2, next.value, next.worked);
                if (queueTail === null) {
                  self2.empty();
                }
              } else {
                _running--;
              }
            } else if (--_running === 0) {
              self2.drain();
            }
          }
          function kill() {
            queueHead = null;
            queueTail = null;
            self2.drain = noop2;
          }
          function killAndDrain() {
            queueHead = null;
            queueTail = null;
            self2.drain();
            self2.drain = noop2;
          }
          function error(handler) {
            errorHandler = handler;
          }
        }
        function noop2() {
        }
        function Task() {
          this.value = null;
          this.callback = noop2;
          this.next = null;
          this.release = noop2;
          this.context = null;
          this.errorHandler = null;
          var self2 = this;
          this.worked = function worked(err, result) {
            var callback = self2.callback;
            var errorHandler = self2.errorHandler;
            var val = self2.value;
            self2.value = null;
            self2.callback = noop2;
            if (self2.errorHandler) {
              errorHandler(err, val);
            }
            callback.call(self2.context, err, result);
            self2.release(self2);
          };
        }
        function queueAsPromised(context2, worker, concurrency) {
          if (typeof context2 === "function") {
            concurrency = worker;
            worker = context2;
            context2 = null;
          }
          function asyncWrapper(arg, cb) {
            worker.call(this, arg).then(function(res) {
              cb(null, res);
            }, cb);
          }
          var queue = fastqueue(context2, asyncWrapper, concurrency);
          var pushCb = queue.push;
          var unshiftCb = queue.unshift;
          queue.push = push2;
          queue.unshift = unshift;
          queue.drained = drained;
          return queue;
          function push2(value) {
            var p = new Promise(function(resolve, reject) {
              pushCb(value, function(err, result) {
                if (err) {
                  reject(err);
                  return;
                }
                resolve(result);
              });
            });
            p.catch(noop2);
            return p;
          }
          function unshift(value) {
            var p = new Promise(function(resolve, reject) {
              unshiftCb(value, function(err, result) {
                if (err) {
                  reject(err);
                  return;
                }
                resolve(result);
              });
            });
            p.catch(noop2);
            return p;
          }
          function drained() {
            var previousDrain = queue.drain;
            var p = new Promise(function(resolve) {
              queue.drain = function() {
                previousDrain();
                resolve();
              };
            });
            return p;
          }
        }
        module22.exports = fastqueue;
        module22.exports.promise = queueAsPromised;
      }
    });
    var require_common4 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/readers/common.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.joinPathSegments = exports2.replacePathSegmentSeparator = exports2.isAppliedFilter = exports2.isFatalError = void 0;
        function isFatalError(settings, error) {
          if (settings.errorFilter === null) {
            return true;
          }
          return !settings.errorFilter(error);
        }
        exports2.isFatalError = isFatalError;
        function isAppliedFilter(filter, value) {
          return filter === null || filter(value);
        }
        exports2.isAppliedFilter = isAppliedFilter;
        function replacePathSegmentSeparator(filepath, separator) {
          return filepath.split(/[/\\]/).join(separator);
        }
        exports2.replacePathSegmentSeparator = replacePathSegmentSeparator;
        function joinPathSegments(a, b, separator) {
          if (a === "") {
            return b;
          }
          if (a.endsWith(separator)) {
            return a + b;
          }
          return a + separator + b;
        }
        exports2.joinPathSegments = joinPathSegments;
      }
    });
    var require_reader3 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/readers/reader.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var common = require_common4();
        var Reader = class {
          constructor(_root, _settings) {
            this._root = _root;
            this._settings = _settings;
            this._root = common.replacePathSegmentSeparator(_root, _settings.pathSegmentSeparator);
          }
        };
        exports2.default = Reader;
      }
    });
    var require_async42 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/readers/async.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var events_1 = require("events");
        var fsScandir = require_out22();
        var fastq = require_queue2();
        var common = require_common4();
        var reader_1 = require_reader3();
        var AsyncReader = class extends reader_1.default {
          constructor(_root, _settings) {
            super(_root, _settings);
            this._settings = _settings;
            this._scandir = fsScandir.scandir;
            this._emitter = new events_1.EventEmitter();
            this._queue = fastq(this._worker.bind(this), this._settings.concurrency);
            this._isFatalError = false;
            this._isDestroyed = false;
            this._queue.drain = () => {
              if (!this._isFatalError) {
                this._emitter.emit("end");
              }
            };
          }
          read() {
            this._isFatalError = false;
            this._isDestroyed = false;
            setImmediate(() => {
              this._pushToQueue(this._root, this._settings.basePath);
            });
            return this._emitter;
          }
          get isDestroyed() {
            return this._isDestroyed;
          }
          destroy() {
            if (this._isDestroyed) {
              throw new Error("The reader is already destroyed");
            }
            this._isDestroyed = true;
            this._queue.killAndDrain();
          }
          onEntry(callback) {
            this._emitter.on("entry", callback);
          }
          onError(callback) {
            this._emitter.once("error", callback);
          }
          onEnd(callback) {
            this._emitter.once("end", callback);
          }
          _pushToQueue(directory, base) {
            const queueItem = {
              directory,
              base
            };
            this._queue.push(queueItem, (error) => {
              if (error !== null) {
                this._handleError(error);
              }
            });
          }
          _worker(item, done) {
            this._scandir(item.directory, this._settings.fsScandirSettings, (error, entries) => {
              if (error !== null) {
                done(error, void 0);
                return;
              }
              for (const entry of entries) {
                this._handleEntry(entry, item.base);
              }
              done(null, void 0);
            });
          }
          _handleError(error) {
            if (this._isDestroyed || !common.isFatalError(this._settings, error)) {
              return;
            }
            this._isFatalError = true;
            this._isDestroyed = true;
            this._emitter.emit("error", error);
          }
          _handleEntry(entry, base) {
            if (this._isDestroyed || this._isFatalError) {
              return;
            }
            const fullpath = entry.path;
            if (base !== void 0) {
              entry.path = common.joinPathSegments(base, entry.name, this._settings.pathSegmentSeparator);
            }
            if (common.isAppliedFilter(this._settings.entryFilter, entry)) {
              this._emitEntry(entry);
            }
            if (entry.dirent.isDirectory() && common.isAppliedFilter(this._settings.deepFilter, entry)) {
              this._pushToQueue(fullpath, base === void 0 ? void 0 : entry.path);
            }
          }
          _emitEntry(entry) {
            this._emitter.emit("entry", entry);
          }
        };
        exports2.default = AsyncReader;
      }
    });
    var require_async52 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/providers/async.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var async_1 = require_async42();
        var AsyncProvider = class {
          constructor(_root, _settings) {
            this._root = _root;
            this._settings = _settings;
            this._reader = new async_1.default(this._root, this._settings);
            this._storage = [];
          }
          read(callback) {
            this._reader.onError((error) => {
              callFailureCallback(callback, error);
            });
            this._reader.onEntry((entry) => {
              this._storage.push(entry);
            });
            this._reader.onEnd(() => {
              callSuccessCallback(callback, this._storage);
            });
            this._reader.read();
          }
        };
        exports2.default = AsyncProvider;
        function callFailureCallback(callback, error) {
          callback(error);
        }
        function callSuccessCallback(callback, entries) {
          callback(null, entries);
        }
      }
    });
    var require_stream22 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/providers/stream.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var stream_1 = require("stream");
        var async_1 = require_async42();
        var StreamProvider = class {
          constructor(_root, _settings) {
            this._root = _root;
            this._settings = _settings;
            this._reader = new async_1.default(this._root, this._settings);
            this._stream = new stream_1.Readable({
              objectMode: true,
              read: () => {
              },
              destroy: () => {
                if (!this._reader.isDestroyed) {
                  this._reader.destroy();
                }
              }
            });
          }
          read() {
            this._reader.onError((error) => {
              this._stream.emit("error", error);
            });
            this._reader.onEntry((entry) => {
              this._stream.push(entry);
            });
            this._reader.onEnd(() => {
              this._stream.push(null);
            });
            this._reader.read();
            return this._stream;
          }
        };
        exports2.default = StreamProvider;
      }
    });
    var require_sync42 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/readers/sync.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var fsScandir = require_out22();
        var common = require_common4();
        var reader_1 = require_reader3();
        var SyncReader = class extends reader_1.default {
          constructor() {
            super(...arguments);
            this._scandir = fsScandir.scandirSync;
            this._storage = [];
            this._queue = /* @__PURE__ */ new Set();
          }
          read() {
            this._pushToQueue(this._root, this._settings.basePath);
            this._handleQueue();
            return this._storage;
          }
          _pushToQueue(directory, base) {
            this._queue.add({
              directory,
              base
            });
          }
          _handleQueue() {
            for (const item of this._queue.values()) {
              this._handleDirectory(item.directory, item.base);
            }
          }
          _handleDirectory(directory, base) {
            try {
              const entries = this._scandir(directory, this._settings.fsScandirSettings);
              for (const entry of entries) {
                this._handleEntry(entry, base);
              }
            } catch (error) {
              this._handleError(error);
            }
          }
          _handleError(error) {
            if (!common.isFatalError(this._settings, error)) {
              return;
            }
            throw error;
          }
          _handleEntry(entry, base) {
            const fullpath = entry.path;
            if (base !== void 0) {
              entry.path = common.joinPathSegments(base, entry.name, this._settings.pathSegmentSeparator);
            }
            if (common.isAppliedFilter(this._settings.entryFilter, entry)) {
              this._pushToStorage(entry);
            }
            if (entry.dirent.isDirectory() && common.isAppliedFilter(this._settings.deepFilter, entry)) {
              this._pushToQueue(fullpath, base === void 0 ? void 0 : entry.path);
            }
          }
          _pushToStorage(entry) {
            this._storage.push(entry);
          }
        };
        exports2.default = SyncReader;
      }
    });
    var require_sync52 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/providers/sync.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var sync_1 = require_sync42();
        var SyncProvider = class {
          constructor(_root, _settings) {
            this._root = _root;
            this._settings = _settings;
            this._reader = new sync_1.default(this._root, this._settings);
          }
          read() {
            return this._reader.read();
          }
        };
        exports2.default = SyncProvider;
      }
    });
    var require_settings32 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/settings.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var path4 = require("path");
        var fsScandir = require_out22();
        var Settings = class {
          constructor(_options = {}) {
            this._options = _options;
            this.basePath = this._getValue(this._options.basePath, void 0);
            this.concurrency = this._getValue(this._options.concurrency, Number.POSITIVE_INFINITY);
            this.deepFilter = this._getValue(this._options.deepFilter, null);
            this.entryFilter = this._getValue(this._options.entryFilter, null);
            this.errorFilter = this._getValue(this._options.errorFilter, null);
            this.pathSegmentSeparator = this._getValue(this._options.pathSegmentSeparator, path4.sep);
            this.fsScandirSettings = new fsScandir.Settings({
              followSymbolicLinks: this._options.followSymbolicLinks,
              fs: this._options.fs,
              pathSegmentSeparator: this._options.pathSegmentSeparator,
              stats: this._options.stats,
              throwErrorOnBrokenSymbolicLink: this._options.throwErrorOnBrokenSymbolicLink
            });
          }
          _getValue(option, value) {
            return option !== null && option !== void 0 ? option : value;
          }
        };
        exports2.default = Settings;
      }
    });
    var require_out32 = __commonJS22({
      "node_modules/@nodelib/fs.walk/out/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.Settings = exports2.walkStream = exports2.walkSync = exports2.walk = void 0;
        var async_1 = require_async52();
        var stream_1 = require_stream22();
        var sync_1 = require_sync52();
        var settings_1 = require_settings32();
        exports2.Settings = settings_1.default;
        function walk(directory, optionsOrSettingsOrCallback, callback) {
          if (typeof optionsOrSettingsOrCallback === "function") {
            new async_1.default(directory, getSettings()).read(optionsOrSettingsOrCallback);
            return;
          }
          new async_1.default(directory, getSettings(optionsOrSettingsOrCallback)).read(callback);
        }
        exports2.walk = walk;
        function walkSync(directory, optionsOrSettings) {
          const settings = getSettings(optionsOrSettings);
          const provider = new sync_1.default(directory, settings);
          return provider.read();
        }
        exports2.walkSync = walkSync;
        function walkStream(directory, optionsOrSettings) {
          const settings = getSettings(optionsOrSettings);
          const provider = new stream_1.default(directory, settings);
          return provider.read();
        }
        exports2.walkStream = walkStream;
        function getSettings(settingsOrOptions = {}) {
          if (settingsOrOptions instanceof settings_1.default) {
            return settingsOrOptions;
          }
          return new settings_1.default(settingsOrOptions);
        }
      }
    });
    var require_reader22 = __commonJS22({
      "node_modules/fast-glob/out/readers/reader.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var path4 = require("path");
        var fsStat = require_out5();
        var utils = require_utils42();
        var Reader = class {
          constructor(_settings) {
            this._settings = _settings;
            this._fsStatSettings = new fsStat.Settings({
              followSymbolicLink: this._settings.followSymbolicLinks,
              fs: this._settings.fs,
              throwErrorOnBrokenSymbolicLink: this._settings.followSymbolicLinks
            });
          }
          _getFullEntryPath(filepath) {
            return path4.resolve(this._settings.cwd, filepath);
          }
          _makeEntry(stats, pattern) {
            const entry = {
              name: pattern,
              path: pattern,
              dirent: utils.fs.createDirentFromStats(pattern, stats)
            };
            if (this._settings.stats) {
              entry.stats = stats;
            }
            return entry;
          }
          _isFatalError(error) {
            return !utils.errno.isEnoentCodeError(error) && !this._settings.suppressErrors;
          }
        };
        exports2.default = Reader;
      }
    });
    var require_stream32 = __commonJS22({
      "node_modules/fast-glob/out/readers/stream.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var stream_1 = require("stream");
        var fsStat = require_out5();
        var fsWalk = require_out32();
        var reader_1 = require_reader22();
        var ReaderStream = class extends reader_1.default {
          constructor() {
            super(...arguments);
            this._walkStream = fsWalk.walkStream;
            this._stat = fsStat.stat;
          }
          dynamic(root, options) {
            return this._walkStream(root, options);
          }
          static(patterns, options) {
            const filepaths = patterns.map(this._getFullEntryPath, this);
            const stream = new stream_1.PassThrough({
              objectMode: true
            });
            stream._write = (index, _enc, done) => {
              return this._getEntry(filepaths[index], patterns[index], options).then((entry) => {
                if (entry !== null && options.entryFilter(entry)) {
                  stream.push(entry);
                }
                if (index === filepaths.length - 1) {
                  stream.end();
                }
                done();
              }).catch(done);
            };
            for (let i2 = 0; i2 < filepaths.length; i2++) {
              stream.write(i2);
            }
            return stream;
          }
          _getEntry(filepath, pattern, options) {
            return this._getStat(filepath).then((stats) => this._makeEntry(stats, pattern)).catch((error) => {
              if (options.errorFilter(error)) {
                return null;
              }
              throw error;
            });
          }
          _getStat(filepath) {
            return new Promise((resolve, reject) => {
              this._stat(filepath, this._fsStatSettings, (error, stats) => {
                return error === null ? resolve(stats) : reject(error);
              });
            });
          }
        };
        exports2.default = ReaderStream;
      }
    });
    var require_matcher2 = __commonJS22({
      "node_modules/fast-glob/out/providers/matchers/matcher.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var Matcher = class {
          constructor(_patterns, _settings, _micromatchOptions) {
            this._patterns = _patterns;
            this._settings = _settings;
            this._micromatchOptions = _micromatchOptions;
            this._storage = [];
            this._fillStorage();
          }
          _fillStorage() {
            const patterns = utils.pattern.expandPatternsWithBraceExpansion(this._patterns);
            for (const pattern of patterns) {
              const segments = this._getPatternSegments(pattern);
              const sections = this._splitSegmentsIntoSections(segments);
              this._storage.push({
                complete: sections.length <= 1,
                pattern,
                segments,
                sections
              });
            }
          }
          _getPatternSegments(pattern) {
            const parts = utils.pattern.getPatternParts(pattern, this._micromatchOptions);
            return parts.map((part) => {
              const dynamic = utils.pattern.isDynamicPattern(part, this._settings);
              if (!dynamic) {
                return {
                  dynamic: false,
                  pattern: part
                };
              }
              return {
                dynamic: true,
                pattern: part,
                patternRe: utils.pattern.makeRe(part, this._micromatchOptions)
              };
            });
          }
          _splitSegmentsIntoSections(segments) {
            return utils.array.splitWhen(segments, (segment) => segment.dynamic && utils.pattern.hasGlobStar(segment.pattern));
          }
        };
        exports2.default = Matcher;
      }
    });
    var require_partial2 = __commonJS22({
      "node_modules/fast-glob/out/providers/matchers/partial.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var matcher_1 = require_matcher2();
        var PartialMatcher = class extends matcher_1.default {
          match(filepath) {
            const parts = filepath.split("/");
            const levels = parts.length;
            const patterns = this._storage.filter((info) => !info.complete || info.segments.length > levels);
            for (const pattern of patterns) {
              const section = pattern.sections[0];
              if (!pattern.complete && levels > section.length) {
                return true;
              }
              const match = parts.every((part, index) => {
                const segment = pattern.segments[index];
                if (segment.dynamic && segment.patternRe.test(part)) {
                  return true;
                }
                if (!segment.dynamic && segment.pattern === part) {
                  return true;
                }
                return false;
              });
              if (match) {
                return true;
              }
            }
            return false;
          }
        };
        exports2.default = PartialMatcher;
      }
    });
    var require_deep2 = __commonJS22({
      "node_modules/fast-glob/out/providers/filters/deep.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var partial_1 = require_partial2();
        var DeepFilter = class {
          constructor(_settings, _micromatchOptions) {
            this._settings = _settings;
            this._micromatchOptions = _micromatchOptions;
          }
          getFilter(basePath, positive, negative) {
            const matcher = this._getMatcher(positive);
            const negativeRe = this._getNegativePatternsRe(negative);
            return (entry) => this._filter(basePath, entry, matcher, negativeRe);
          }
          _getMatcher(patterns) {
            return new partial_1.default(patterns, this._settings, this._micromatchOptions);
          }
          _getNegativePatternsRe(patterns) {
            const affectDepthOfReadingPatterns = patterns.filter(utils.pattern.isAffectDepthOfReadingPattern);
            return utils.pattern.convertPatternsToRe(affectDepthOfReadingPatterns, this._micromatchOptions);
          }
          _filter(basePath, entry, matcher, negativeRe) {
            if (this._isSkippedByDeep(basePath, entry.path)) {
              return false;
            }
            if (this._isSkippedSymbolicLink(entry)) {
              return false;
            }
            const filepath = utils.path.removeLeadingDotSegment(entry.path);
            if (this._isSkippedByPositivePatterns(filepath, matcher)) {
              return false;
            }
            return this._isSkippedByNegativePatterns(filepath, negativeRe);
          }
          _isSkippedByDeep(basePath, entryPath) {
            if (this._settings.deep === Infinity) {
              return false;
            }
            return this._getEntryLevel(basePath, entryPath) >= this._settings.deep;
          }
          _getEntryLevel(basePath, entryPath) {
            const entryPathDepth = entryPath.split("/").length;
            if (basePath === "") {
              return entryPathDepth;
            }
            const basePathDepth = basePath.split("/").length;
            return entryPathDepth - basePathDepth;
          }
          _isSkippedSymbolicLink(entry) {
            return !this._settings.followSymbolicLinks && entry.dirent.isSymbolicLink();
          }
          _isSkippedByPositivePatterns(entryPath, matcher) {
            return !this._settings.baseNameMatch && !matcher.match(entryPath);
          }
          _isSkippedByNegativePatterns(entryPath, patternsRe) {
            return !utils.pattern.matchAny(entryPath, patternsRe);
          }
        };
        exports2.default = DeepFilter;
      }
    });
    var require_entry3 = __commonJS22({
      "node_modules/fast-glob/out/providers/filters/entry.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var EntryFilter = class {
          constructor(_settings, _micromatchOptions) {
            this._settings = _settings;
            this._micromatchOptions = _micromatchOptions;
            this.index = /* @__PURE__ */ new Map();
          }
          getFilter(positive, negative) {
            const positiveRe = utils.pattern.convertPatternsToRe(positive, this._micromatchOptions);
            const negativeRe = utils.pattern.convertPatternsToRe(negative, this._micromatchOptions);
            return (entry) => this._filter(entry, positiveRe, negativeRe);
          }
          _filter(entry, positiveRe, negativeRe) {
            if (this._settings.unique && this._isDuplicateEntry(entry)) {
              return false;
            }
            if (this._onlyFileFilter(entry) || this._onlyDirectoryFilter(entry)) {
              return false;
            }
            if (this._isSkippedByAbsoluteNegativePatterns(entry.path, negativeRe)) {
              return false;
            }
            const filepath = this._settings.baseNameMatch ? entry.name : entry.path;
            const isMatched = this._isMatchToPatterns(filepath, positiveRe) && !this._isMatchToPatterns(entry.path, negativeRe);
            if (this._settings.unique && isMatched) {
              this._createIndexRecord(entry);
            }
            return isMatched;
          }
          _isDuplicateEntry(entry) {
            return this.index.has(entry.path);
          }
          _createIndexRecord(entry) {
            this.index.set(entry.path, void 0);
          }
          _onlyFileFilter(entry) {
            return this._settings.onlyFiles && !entry.dirent.isFile();
          }
          _onlyDirectoryFilter(entry) {
            return this._settings.onlyDirectories && !entry.dirent.isDirectory();
          }
          _isSkippedByAbsoluteNegativePatterns(entryPath, patternsRe) {
            if (!this._settings.absolute) {
              return false;
            }
            const fullpath = utils.path.makeAbsolute(this._settings.cwd, entryPath);
            return utils.pattern.matchAny(fullpath, patternsRe);
          }
          _isMatchToPatterns(entryPath, patternsRe) {
            const filepath = utils.path.removeLeadingDotSegment(entryPath);
            return utils.pattern.matchAny(filepath, patternsRe) || utils.pattern.matchAny(filepath + "/", patternsRe);
          }
        };
        exports2.default = EntryFilter;
      }
    });
    var require_error2 = __commonJS22({
      "node_modules/fast-glob/out/providers/filters/error.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var ErrorFilter = class {
          constructor(_settings) {
            this._settings = _settings;
          }
          getFilter() {
            return (error) => this._isNonFatalError(error);
          }
          _isNonFatalError(error) {
            return utils.errno.isEnoentCodeError(error) || this._settings.suppressErrors;
          }
        };
        exports2.default = ErrorFilter;
      }
    });
    var require_entry22 = __commonJS22({
      "node_modules/fast-glob/out/providers/transformers/entry.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var utils = require_utils42();
        var EntryTransformer = class {
          constructor(_settings) {
            this._settings = _settings;
          }
          getTransformer() {
            return (entry) => this._transform(entry);
          }
          _transform(entry) {
            let filepath = entry.path;
            if (this._settings.absolute) {
              filepath = utils.path.makeAbsolute(this._settings.cwd, filepath);
              filepath = utils.path.unixify(filepath);
            }
            if (this._settings.markDirectories && entry.dirent.isDirectory()) {
              filepath += "/";
            }
            if (!this._settings.objectMode) {
              return filepath;
            }
            return Object.assign(Object.assign({}, entry), {
              path: filepath
            });
          }
        };
        exports2.default = EntryTransformer;
      }
    });
    var require_provider2 = __commonJS22({
      "node_modules/fast-glob/out/providers/provider.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var path4 = require("path");
        var deep_1 = require_deep2();
        var entry_1 = require_entry3();
        var error_1 = require_error2();
        var entry_2 = require_entry22();
        var Provider = class {
          constructor(_settings) {
            this._settings = _settings;
            this.errorFilter = new error_1.default(this._settings);
            this.entryFilter = new entry_1.default(this._settings, this._getMicromatchOptions());
            this.deepFilter = new deep_1.default(this._settings, this._getMicromatchOptions());
            this.entryTransformer = new entry_2.default(this._settings);
          }
          _getRootDirectory(task) {
            return path4.resolve(this._settings.cwd, task.base);
          }
          _getReaderOptions(task) {
            const basePath = task.base === "." ? "" : task.base;
            return {
              basePath,
              pathSegmentSeparator: "/",
              concurrency: this._settings.concurrency,
              deepFilter: this.deepFilter.getFilter(basePath, task.positive, task.negative),
              entryFilter: this.entryFilter.getFilter(task.positive, task.negative),
              errorFilter: this.errorFilter.getFilter(),
              followSymbolicLinks: this._settings.followSymbolicLinks,
              fs: this._settings.fs,
              stats: this._settings.stats,
              throwErrorOnBrokenSymbolicLink: this._settings.throwErrorOnBrokenSymbolicLink,
              transform: this.entryTransformer.getTransformer()
            };
          }
          _getMicromatchOptions() {
            return {
              dot: this._settings.dot,
              matchBase: this._settings.baseNameMatch,
              nobrace: !this._settings.braceExpansion,
              nocase: !this._settings.caseSensitiveMatch,
              noext: !this._settings.extglob,
              noglobstar: !this._settings.globstar,
              posix: true,
              strictSlashes: false
            };
          }
        };
        exports2.default = Provider;
      }
    });
    var require_async62 = __commonJS22({
      "node_modules/fast-glob/out/providers/async.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var stream_1 = require_stream32();
        var provider_1 = require_provider2();
        var ProviderAsync = class extends provider_1.default {
          constructor() {
            super(...arguments);
            this._reader = new stream_1.default(this._settings);
          }
          read(task) {
            const root = this._getRootDirectory(task);
            const options = this._getReaderOptions(task);
            const entries = [];
            return new Promise((resolve, reject) => {
              const stream = this.api(root, task, options);
              stream.once("error", reject);
              stream.on("data", (entry) => entries.push(options.transform(entry)));
              stream.once("end", () => resolve(entries));
            });
          }
          api(root, task, options) {
            if (task.dynamic) {
              return this._reader.dynamic(root, options);
            }
            return this._reader.static(task.patterns, options);
          }
        };
        exports2.default = ProviderAsync;
      }
    });
    var require_stream42 = __commonJS22({
      "node_modules/fast-glob/out/providers/stream.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var stream_1 = require("stream");
        var stream_2 = require_stream32();
        var provider_1 = require_provider2();
        var ProviderStream = class extends provider_1.default {
          constructor() {
            super(...arguments);
            this._reader = new stream_2.default(this._settings);
          }
          read(task) {
            const root = this._getRootDirectory(task);
            const options = this._getReaderOptions(task);
            const source = this.api(root, task, options);
            const destination = new stream_1.Readable({
              objectMode: true,
              read: () => {
              }
            });
            source.once("error", (error) => destination.emit("error", error)).on("data", (entry) => destination.emit("data", options.transform(entry))).once("end", () => destination.emit("end"));
            destination.once("close", () => source.destroy());
            return destination;
          }
          api(root, task, options) {
            if (task.dynamic) {
              return this._reader.dynamic(root, options);
            }
            return this._reader.static(task.patterns, options);
          }
        };
        exports2.default = ProviderStream;
      }
    });
    var require_sync62 = __commonJS22({
      "node_modules/fast-glob/out/readers/sync.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var fsStat = require_out5();
        var fsWalk = require_out32();
        var reader_1 = require_reader22();
        var ReaderSync = class extends reader_1.default {
          constructor() {
            super(...arguments);
            this._walkSync = fsWalk.walkSync;
            this._statSync = fsStat.statSync;
          }
          dynamic(root, options) {
            return this._walkSync(root, options);
          }
          static(patterns, options) {
            const entries = [];
            for (const pattern of patterns) {
              const filepath = this._getFullEntryPath(pattern);
              const entry = this._getEntry(filepath, pattern, options);
              if (entry === null || !options.entryFilter(entry)) {
                continue;
              }
              entries.push(entry);
            }
            return entries;
          }
          _getEntry(filepath, pattern, options) {
            try {
              const stats = this._getStat(filepath);
              return this._makeEntry(stats, pattern);
            } catch (error) {
              if (options.errorFilter(error)) {
                return null;
              }
              throw error;
            }
          }
          _getStat(filepath) {
            return this._statSync(filepath, this._fsStatSettings);
          }
        };
        exports2.default = ReaderSync;
      }
    });
    var require_sync72 = __commonJS22({
      "node_modules/fast-glob/out/providers/sync.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var sync_1 = require_sync62();
        var provider_1 = require_provider2();
        var ProviderSync = class extends provider_1.default {
          constructor() {
            super(...arguments);
            this._reader = new sync_1.default(this._settings);
          }
          read(task) {
            const root = this._getRootDirectory(task);
            const options = this._getReaderOptions(task);
            const entries = this.api(root, task, options);
            return entries.map(options.transform);
          }
          api(root, task, options) {
            if (task.dynamic) {
              return this._reader.dynamic(root, options);
            }
            return this._reader.static(task.patterns, options);
          }
        };
        exports2.default = ProviderSync;
      }
    });
    var require_settings42 = __commonJS22({
      "node_modules/fast-glob/out/settings.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.DEFAULT_FILE_SYSTEM_ADAPTER = void 0;
        var fs4 = require("fs");
        var os = require("os");
        var CPU_COUNT = Math.max(os.cpus().length, 1);
        exports2.DEFAULT_FILE_SYSTEM_ADAPTER = {
          lstat: fs4.lstat,
          lstatSync: fs4.lstatSync,
          stat: fs4.stat,
          statSync: fs4.statSync,
          readdir: fs4.readdir,
          readdirSync: fs4.readdirSync
        };
        var Settings = class {
          constructor(_options = {}) {
            this._options = _options;
            this.absolute = this._getValue(this._options.absolute, false);
            this.baseNameMatch = this._getValue(this._options.baseNameMatch, false);
            this.braceExpansion = this._getValue(this._options.braceExpansion, true);
            this.caseSensitiveMatch = this._getValue(this._options.caseSensitiveMatch, true);
            this.concurrency = this._getValue(this._options.concurrency, CPU_COUNT);
            this.cwd = this._getValue(this._options.cwd, process.cwd());
            this.deep = this._getValue(this._options.deep, Infinity);
            this.dot = this._getValue(this._options.dot, false);
            this.extglob = this._getValue(this._options.extglob, true);
            this.followSymbolicLinks = this._getValue(this._options.followSymbolicLinks, true);
            this.fs = this._getFileSystemMethods(this._options.fs);
            this.globstar = this._getValue(this._options.globstar, true);
            this.ignore = this._getValue(this._options.ignore, []);
            this.markDirectories = this._getValue(this._options.markDirectories, false);
            this.objectMode = this._getValue(this._options.objectMode, false);
            this.onlyDirectories = this._getValue(this._options.onlyDirectories, false);
            this.onlyFiles = this._getValue(this._options.onlyFiles, true);
            this.stats = this._getValue(this._options.stats, false);
            this.suppressErrors = this._getValue(this._options.suppressErrors, false);
            this.throwErrorOnBrokenSymbolicLink = this._getValue(this._options.throwErrorOnBrokenSymbolicLink, false);
            this.unique = this._getValue(this._options.unique, true);
            if (this.onlyDirectories) {
              this.onlyFiles = false;
            }
            if (this.stats) {
              this.objectMode = true;
            }
          }
          _getValue(option, value) {
            return option === void 0 ? value : option;
          }
          _getFileSystemMethods(methods = {}) {
            return Object.assign(Object.assign({}, exports2.DEFAULT_FILE_SYSTEM_ADAPTER), methods);
          }
        };
        exports2.default = Settings;
      }
    });
    var require_out42 = __commonJS22({
      "node_modules/fast-glob/out/index.js"(exports2, module22) {
        "use strict";
        var taskManager = require_tasks2();
        var patternManager = require_patterns2();
        var async_1 = require_async62();
        var stream_1 = require_stream42();
        var sync_1 = require_sync72();
        var settings_1 = require_settings42();
        var utils = require_utils42();
        async function FastGlob(source, options) {
          assertPatternsInput(source);
          const works = getWorks(source, async_1.default, options);
          const result = await Promise.all(works);
          return utils.array.flatten(result);
        }
        (function(FastGlob2) {
          function sync2(source, options) {
            assertPatternsInput(source);
            const works = getWorks(source, sync_1.default, options);
            return utils.array.flatten(works);
          }
          FastGlob2.sync = sync2;
          function stream(source, options) {
            assertPatternsInput(source);
            const works = getWorks(source, stream_1.default, options);
            return utils.stream.merge(works);
          }
          FastGlob2.stream = stream;
          function generateTasks(source, options) {
            assertPatternsInput(source);
            const patterns = patternManager.transform([].concat(source));
            const settings = new settings_1.default(options);
            return taskManager.generate(patterns, settings);
          }
          FastGlob2.generateTasks = generateTasks;
          function isDynamicPattern(source, options) {
            assertPatternsInput(source);
            const settings = new settings_1.default(options);
            return utils.pattern.isDynamicPattern(source, settings);
          }
          FastGlob2.isDynamicPattern = isDynamicPattern;
          function escapePath(source) {
            assertPatternsInput(source);
            return utils.path.escape(source);
          }
          FastGlob2.escapePath = escapePath;
        })(FastGlob || (FastGlob = {}));
        function getWorks(source, _Provider, options) {
          const patterns = patternManager.transform([].concat(source));
          const settings = new settings_1.default(options);
          const tasks = taskManager.generate(patterns, settings);
          const provider = new _Provider(settings);
          return tasks.map(provider.read, provider);
        }
        function assertPatternsInput(input) {
          const source = [].concat(input);
          const isValidSource = source.every((item) => utils.string.isString(item) && !utils.string.isEmpty(item));
          if (!isValidSource) {
            throw new TypeError("Patterns must be a string (non empty) or an array of strings");
          }
        }
        module22.exports = FastGlob;
      }
    });
    var require_uniq_by_key = __commonJS22({
      "src/utils/uniq-by-key.js"(exports2, module22) {
        "use strict";
        function uniqByKey(array, key) {
          const result = [];
          const seen = /* @__PURE__ */ new Set();
          for (const element of array) {
            const value = element[key];
            if (!seen.has(value)) {
              seen.add(value);
              result.push(element);
            }
          }
          return result;
        }
        module22.exports = uniqByKey;
      }
    });
    var require_create_language = __commonJS22({
      "src/utils/create-language.js"(exports2, module22) {
        "use strict";
        module22.exports = function(linguistData, override) {
          const {
            languageId
          } = linguistData, rest = _objectWithoutProperties(linguistData, _excluded4);
          return Object.assign(Object.assign({
            linguistLanguageId: languageId
          }, rest), override(linguistData));
        };
      }
    });
    var require_ast = __commonJS22({
      "node_modules/esutils/lib/ast.js"(exports2, module22) {
        (function() {
          "use strict";
          function isExpression(node) {
            if (node == null) {
              return false;
            }
            switch (node.type) {
              case "ArrayExpression":
              case "AssignmentExpression":
              case "BinaryExpression":
              case "CallExpression":
              case "ConditionalExpression":
              case "FunctionExpression":
              case "Identifier":
              case "Literal":
              case "LogicalExpression":
              case "MemberExpression":
              case "NewExpression":
              case "ObjectExpression":
              case "SequenceExpression":
              case "ThisExpression":
              case "UnaryExpression":
              case "UpdateExpression":
                return true;
            }
            return false;
          }
          function isIterationStatement(node) {
            if (node == null) {
              return false;
            }
            switch (node.type) {
              case "DoWhileStatement":
              case "ForInStatement":
              case "ForStatement":
              case "WhileStatement":
                return true;
            }
            return false;
          }
          function isStatement(node) {
            if (node == null) {
              return false;
            }
            switch (node.type) {
              case "BlockStatement":
              case "BreakStatement":
              case "ContinueStatement":
              case "DebuggerStatement":
              case "DoWhileStatement":
              case "EmptyStatement":
              case "ExpressionStatement":
              case "ForInStatement":
              case "ForStatement":
              case "IfStatement":
              case "LabeledStatement":
              case "ReturnStatement":
              case "SwitchStatement":
              case "ThrowStatement":
              case "TryStatement":
              case "VariableDeclaration":
              case "WhileStatement":
              case "WithStatement":
                return true;
            }
            return false;
          }
          function isSourceElement(node) {
            return isStatement(node) || node != null && node.type === "FunctionDeclaration";
          }
          function trailingStatement(node) {
            switch (node.type) {
              case "IfStatement":
                if (node.alternate != null) {
                  return node.alternate;
                }
                return node.consequent;
              case "LabeledStatement":
              case "ForStatement":
              case "ForInStatement":
              case "WhileStatement":
              case "WithStatement":
                return node.body;
            }
            return null;
          }
          function isProblematicIfStatement(node) {
            var current;
            if (node.type !== "IfStatement") {
              return false;
            }
            if (node.alternate == null) {
              return false;
            }
            current = node.consequent;
            do {
              if (current.type === "IfStatement") {
                if (current.alternate == null) {
                  return true;
                }
              }
              current = trailingStatement(current);
            } while (current);
            return false;
          }
          module22.exports = {
            isExpression,
            isStatement,
            isIterationStatement,
            isSourceElement,
            isProblematicIfStatement,
            trailingStatement
          };
        })();
      }
    });
    var require_code = __commonJS22({
      "node_modules/esutils/lib/code.js"(exports2, module22) {
        (function() {
          "use strict";
          var ES6Regex, ES5Regex, NON_ASCII_WHITESPACES, IDENTIFIER_START, IDENTIFIER_PART, ch;
          ES5Regex = {
            NonAsciiIdentifierStart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/,
            NonAsciiIdentifierPart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19D9\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u2E2F\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099\u309A\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]/
          };
          ES6Regex = {
            NonAsciiIdentifierStart: /[\xAA\xB5\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u05D0-\u05EA\u05F0-\u05F2\u0620-\u064A\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07CA-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u08A0-\u08B4\u08B6-\u08BD\u0904-\u0939\u093D\u0950\u0958-\u0961\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09F0\u09F1\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B71\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CF1\u0CF2\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D5F-\u0D61\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0EDC-\u0EDF\u0F00\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u1820-\u1877\u1880-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1950-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u1A00-\u1A16\u1A20-\u1A54\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B83-\u1BA0\u1BAE\u1BAF\u1BBA-\u1BE5\u1C00-\u1C23\u1C4D-\u1C4F\u1C5A-\u1C7D\u1C80-\u1C88\u1CE9-\u1CEC\u1CEE-\u1CF1\u1CF5\u1CF6\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2071\u207F\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309B-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA61F\uA62A\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA840-\uA873\uA882-\uA8B3\uA8F2-\uA8F7\uA8FB\uA8FD\uA90A-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF\uA9E0-\uA9E4\uA9E6-\uA9EF\uA9FA-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABE2\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDE80-\uDE9C\uDEA0-\uDED0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE4\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC03-\uDC37\uDC83-\uDCAF\uDCD0-\uDCE8\uDD03-\uDD26\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE80-\uDEAA\uDF00-\uDF19]|\uD806[\uDCA0-\uDCDF\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC72-\uDC8F]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50\uDF93-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB]|\uD83A[\uDC00-\uDCC4\uDD00-\uDD43]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]/,
            NonAsciiIdentifierPart: /[\xAA\xB5\xB7\xBA\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0300-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u0483-\u0487\u048A-\u052F\u0531-\u0556\u0559\u0561-\u0587\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u05D0-\u05EA\u05F0-\u05F2\u0610-\u061A\u0620-\u0669\u066E-\u06D3\u06D5-\u06DC\u06DF-\u06E8\u06EA-\u06FC\u06FF\u0710-\u074A\u074D-\u07B1\u07C0-\u07F5\u07FA\u0800-\u082D\u0840-\u085B\u08A0-\u08B4\u08B6-\u08BD\u08D4-\u08E1\u08E3-\u0963\u0966-\u096F\u0971-\u0983\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BC-\u09C4\u09C7\u09C8\u09CB-\u09CE\u09D7\u09DC\u09DD\u09DF-\u09E3\u09E6-\u09F1\u0A01-\u0A03\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A59-\u0A5C\u0A5E\u0A66-\u0A75\u0A81-\u0A83\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABC-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AD0\u0AE0-\u0AE3\u0AE6-\u0AEF\u0AF9\u0B01-\u0B03\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3C-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B5C\u0B5D\u0B5F-\u0B63\u0B66-\u0B6F\u0B71\u0B82\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD0\u0BD7\u0BE6-\u0BEF\u0C00-\u0C03\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C58-\u0C5A\u0C60-\u0C63\u0C66-\u0C6F\u0C80-\u0C83\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBC-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CDE\u0CE0-\u0CE3\u0CE6-\u0CEF\u0CF1\u0CF2\u0D01-\u0D03\u0D05-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D-\u0D44\u0D46-\u0D48\u0D4A-\u0D4E\u0D54-\u0D57\u0D5F-\u0D63\u0D66-\u0D6F\u0D7A-\u0D7F\u0D82\u0D83\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DE6-\u0DEF\u0DF2\u0DF3\u0E01-\u0E3A\u0E40-\u0E4E\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E87\u0E88\u0E8A\u0E8D\u0E94-\u0E97\u0E99-\u0E9F\u0EA1-\u0EA3\u0EA5\u0EA7\u0EAA\u0EAB\u0EAD-\u0EB9\u0EBB-\u0EBD\u0EC0-\u0EC4\u0EC6\u0EC8-\u0ECD\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F18\u0F19\u0F20-\u0F29\u0F35\u0F37\u0F39\u0F3E-\u0F47\u0F49-\u0F6C\u0F71-\u0F84\u0F86-\u0F97\u0F99-\u0FBC\u0FC6\u1000-\u1049\u1050-\u109D\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u135D-\u135F\u1369-\u1371\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1714\u1720-\u1734\u1740-\u1753\u1760-\u176C\u176E-\u1770\u1772\u1773\u1780-\u17D3\u17D7\u17DC\u17DD\u17E0-\u17E9\u180B-\u180D\u1810-\u1819\u1820-\u1877\u1880-\u18AA\u18B0-\u18F5\u1900-\u191E\u1920-\u192B\u1930-\u193B\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A1B\u1A20-\u1A5E\u1A60-\u1A7C\u1A7F-\u1A89\u1A90-\u1A99\u1AA7\u1AB0-\u1ABD\u1B00-\u1B4B\u1B50-\u1B59\u1B6B-\u1B73\u1B80-\u1BF3\u1C00-\u1C37\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1CD0-\u1CD2\u1CD4-\u1CF6\u1CF8\u1CF9\u1D00-\u1DF5\u1DFB-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u200C\u200D\u203F\u2040\u2054\u2071\u207F\u2090-\u209C\u20D0-\u20DC\u20E1\u20E5-\u20F0\u2102\u2107\u210A-\u2113\u2115\u2118-\u211D\u2124\u2126\u2128\u212A-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2160-\u2188\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CF3\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D7F-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2DE0-\u2DFF\u3005-\u3007\u3021-\u302F\u3031-\u3035\u3038-\u303C\u3041-\u3096\u3099-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312D\u3131-\u318E\u31A0-\u31BA\u31F0-\u31FF\u3400-\u4DB5\u4E00-\u9FD5\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66F\uA674-\uA67D\uA67F-\uA6F1\uA717-\uA71F\uA722-\uA788\uA78B-\uA7AE\uA7B0-\uA7B7\uA7F7-\uA827\uA840-\uA873\uA880-\uA8C5\uA8D0-\uA8D9\uA8E0-\uA8F7\uA8FB\uA8FD\uA900-\uA92D\uA930-\uA953\uA960-\uA97C\uA980-\uA9C0\uA9CF-\uA9D9\uA9E0-\uA9FE\uAA00-\uAA36\uAA40-\uAA4D\uAA50-\uAA59\uAA60-\uAA76\uAA7A-\uAAC2\uAADB-\uAADD\uAAE0-\uAAEF\uAAF2-\uAAF6\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB65\uAB70-\uABEA\uABEC\uABED\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE00-\uFE0F\uFE20-\uFE2F\uFE33\uFE34\uFE4D-\uFE4F\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF3F\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD40-\uDD74\uDDFD\uDE80-\uDE9C\uDEA0-\uDED0\uDEE0\uDF00-\uDF1F\uDF30-\uDF4A\uDF50-\uDF7A\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC60-\uDC76\uDC80-\uDC9E\uDCE0-\uDCF2\uDCF4\uDCF5\uDD00-\uDD15\uDD20-\uDD39\uDD80-\uDDB7\uDDBE\uDDBF\uDE00-\uDE03\uDE05\uDE06\uDE0C-\uDE13\uDE15-\uDE17\uDE19-\uDE33\uDE38-\uDE3A\uDE3F\uDE60-\uDE7C\uDE80-\uDE9C\uDEC0-\uDEC7\uDEC9-\uDEE6\uDF00-\uDF35\uDF40-\uDF55\uDF60-\uDF72\uDF80-\uDF91]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2]|\uD804[\uDC00-\uDC46\uDC66-\uDC6F\uDC7F-\uDCBA\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD00-\uDD34\uDD36-\uDD3F\uDD50-\uDD73\uDD76\uDD80-\uDDC4\uDDCA-\uDDCC\uDDD0-\uDDDA\uDDDC\uDE00-\uDE11\uDE13-\uDE37\uDE3E\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEEA\uDEF0-\uDEF9\uDF00-\uDF03\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3C-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF50\uDF57\uDF5D-\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDC00-\uDC4A\uDC50-\uDC59\uDC80-\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDB5\uDDB8-\uDDC0\uDDD8-\uDDDD\uDE00-\uDE40\uDE44\uDE50-\uDE59\uDE80-\uDEB7\uDEC0-\uDEC9\uDF00-\uDF19\uDF1D-\uDF2B\uDF30-\uDF39]|\uD806[\uDCA0-\uDCE9\uDCFF\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC36\uDC38-\uDC40\uDC50-\uDC59\uDC72-\uDC8F\uDC92-\uDCA7\uDCA9-\uDCB6]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDEF0-\uDEF4\uDF00-\uDF36\uDF40-\uDF43\uDF50-\uDF59\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDF00-\uDF44\uDF50-\uDF7E\uDF8F-\uDF9F\uDFE0]|\uD821[\uDC00-\uDFEC]|\uD822[\uDC00-\uDEF2]|\uD82C[\uDC00\uDC01]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD836[\uDE00-\uDE36\uDE3B-\uDE6C\uDE75\uDE84\uDE9B-\uDE9F\uDEA1-\uDEAF]|\uD838[\uDC00-\uDC06\uDC08-\uDC18\uDC1B-\uDC21\uDC23\uDC24\uDC26-\uDC2A]|\uD83A[\uDC00-\uDCC4\uDCD0-\uDCD6\uDD00-\uDD4A\uDD50-\uDD59]|\uD83B[\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD869[\uDC00-\uDED6\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1]|\uD87E[\uDC00-\uDE1D]|\uDB40[\uDD00-\uDDEF]/
          };
          function isDecimalDigit(ch2) {
            return 48 <= ch2 && ch2 <= 57;
          }
          function isHexDigit(ch2) {
            return 48 <= ch2 && ch2 <= 57 || 97 <= ch2 && ch2 <= 102 || 65 <= ch2 && ch2 <= 70;
          }
          function isOctalDigit(ch2) {
            return ch2 >= 48 && ch2 <= 55;
          }
          NON_ASCII_WHITESPACES = [5760, 8192, 8193, 8194, 8195, 8196, 8197, 8198, 8199, 8200, 8201, 8202, 8239, 8287, 12288, 65279];
          function isWhiteSpace(ch2) {
            return ch2 === 32 || ch2 === 9 || ch2 === 11 || ch2 === 12 || ch2 === 160 || ch2 >= 5760 && NON_ASCII_WHITESPACES.indexOf(ch2) >= 0;
          }
          function isLineTerminator(ch2) {
            return ch2 === 10 || ch2 === 13 || ch2 === 8232 || ch2 === 8233;
          }
          function fromCodePoint(cp) {
            if (cp <= 65535) {
              return String.fromCharCode(cp);
            }
            var cu1 = String.fromCharCode(Math.floor((cp - 65536) / 1024) + 55296);
            var cu2 = String.fromCharCode((cp - 65536) % 1024 + 56320);
            return cu1 + cu2;
          }
          IDENTIFIER_START = new Array(128);
          for (ch = 0; ch < 128; ++ch) {
            IDENTIFIER_START[ch] = ch >= 97 && ch <= 122 || ch >= 65 && ch <= 90 || ch === 36 || ch === 95;
          }
          IDENTIFIER_PART = new Array(128);
          for (ch = 0; ch < 128; ++ch) {
            IDENTIFIER_PART[ch] = ch >= 97 && ch <= 122 || ch >= 65 && ch <= 90 || ch >= 48 && ch <= 57 || ch === 36 || ch === 95;
          }
          function isIdentifierStartES5(ch2) {
            return ch2 < 128 ? IDENTIFIER_START[ch2] : ES5Regex.NonAsciiIdentifierStart.test(fromCodePoint(ch2));
          }
          function isIdentifierPartES5(ch2) {
            return ch2 < 128 ? IDENTIFIER_PART[ch2] : ES5Regex.NonAsciiIdentifierPart.test(fromCodePoint(ch2));
          }
          function isIdentifierStartES6(ch2) {
            return ch2 < 128 ? IDENTIFIER_START[ch2] : ES6Regex.NonAsciiIdentifierStart.test(fromCodePoint(ch2));
          }
          function isIdentifierPartES6(ch2) {
            return ch2 < 128 ? IDENTIFIER_PART[ch2] : ES6Regex.NonAsciiIdentifierPart.test(fromCodePoint(ch2));
          }
          module22.exports = {
            isDecimalDigit,
            isHexDigit,
            isOctalDigit,
            isWhiteSpace,
            isLineTerminator,
            isIdentifierStartES5,
            isIdentifierPartES5,
            isIdentifierStartES6,
            isIdentifierPartES6
          };
        })();
      }
    });
    var require_keyword2 = __commonJS22({
      "node_modules/esutils/lib/keyword.js"(exports2, module22) {
        (function() {
          "use strict";
          var code = require_code();
          function isStrictModeReservedWordES6(id) {
            switch (id) {
              case "implements":
              case "interface":
              case "package":
              case "private":
              case "protected":
              case "public":
              case "static":
              case "let":
                return true;
              default:
                return false;
            }
          }
          function isKeywordES5(id, strict) {
            if (!strict && id === "yield") {
              return false;
            }
            return isKeywordES6(id, strict);
          }
          function isKeywordES6(id, strict) {
            if (strict && isStrictModeReservedWordES6(id)) {
              return true;
            }
            switch (id.length) {
              case 2:
                return id === "if" || id === "in" || id === "do";
              case 3:
                return id === "var" || id === "for" || id === "new" || id === "try";
              case 4:
                return id === "this" || id === "else" || id === "case" || id === "void" || id === "with" || id === "enum";
              case 5:
                return id === "while" || id === "break" || id === "catch" || id === "throw" || id === "const" || id === "yield" || id === "class" || id === "super";
              case 6:
                return id === "return" || id === "typeof" || id === "delete" || id === "switch" || id === "export" || id === "import";
              case 7:
                return id === "default" || id === "finally" || id === "extends";
              case 8:
                return id === "function" || id === "continue" || id === "debugger";
              case 10:
                return id === "instanceof";
              default:
                return false;
            }
          }
          function isReservedWordES5(id, strict) {
            return id === "null" || id === "true" || id === "false" || isKeywordES5(id, strict);
          }
          function isReservedWordES6(id, strict) {
            return id === "null" || id === "true" || id === "false" || isKeywordES6(id, strict);
          }
          function isRestrictedWord(id) {
            return id === "eval" || id === "arguments";
          }
          function isIdentifierNameES5(id) {
            var i2, iz, ch;
            if (id.length === 0) {
              return false;
            }
            ch = id.charCodeAt(0);
            if (!code.isIdentifierStartES5(ch)) {
              return false;
            }
            for (i2 = 1, iz = id.length; i2 < iz; ++i2) {
              ch = id.charCodeAt(i2);
              if (!code.isIdentifierPartES5(ch)) {
                return false;
              }
            }
            return true;
          }
          function decodeUtf16(lead, trail) {
            return (lead - 55296) * 1024 + (trail - 56320) + 65536;
          }
          function isIdentifierNameES6(id) {
            var i2, iz, ch, lowCh, check;
            if (id.length === 0) {
              return false;
            }
            check = code.isIdentifierStartES6;
            for (i2 = 0, iz = id.length; i2 < iz; ++i2) {
              ch = id.charCodeAt(i2);
              if (55296 <= ch && ch <= 56319) {
                ++i2;
                if (i2 >= iz) {
                  return false;
                }
                lowCh = id.charCodeAt(i2);
                if (!(56320 <= lowCh && lowCh <= 57343)) {
                  return false;
                }
                ch = decodeUtf16(ch, lowCh);
              }
              if (!check(ch)) {
                return false;
              }
              check = code.isIdentifierPartES6;
            }
            return true;
          }
          function isIdentifierES5(id, strict) {
            return isIdentifierNameES5(id) && !isReservedWordES5(id, strict);
          }
          function isIdentifierES6(id, strict) {
            return isIdentifierNameES6(id) && !isReservedWordES6(id, strict);
          }
          module22.exports = {
            isKeywordES5,
            isKeywordES6,
            isReservedWordES5,
            isReservedWordES6,
            isRestrictedWord,
            isIdentifierNameES5,
            isIdentifierNameES6,
            isIdentifierES5,
            isIdentifierES6
          };
        })();
      }
    });
    var require_utils62 = __commonJS22({
      "node_modules/esutils/lib/utils.js"(exports2) {
        (function() {
          "use strict";
          exports2.ast = require_ast();
          exports2.code = require_code();
          exports2.keyword = require_keyword2();
        })();
      }
    });
    var require_is_block_comment = __commonJS22({
      "src/language-js/utils/is-block-comment.js"(exports2, module22) {
        "use strict";
        var BLOCK_COMMENT_TYPES = /* @__PURE__ */ new Set(["Block", "CommentBlock", "MultiLine"]);
        var isBlockComment = (comment) => BLOCK_COMMENT_TYPES.has(comment === null || comment === void 0 ? void 0 : comment.type);
        module22.exports = isBlockComment;
      }
    });
    var require_is_node_matches = __commonJS22({
      "src/language-js/utils/is-node-matches.js"(exports2, module22) {
        "use strict";
        function isNodeMatchesNameOrPath(node, nameOrPath) {
          const names = nameOrPath.split(".");
          for (let index = names.length - 1; index >= 0; index--) {
            const name = names[index];
            if (index === 0) {
              return node.type === "Identifier" && node.name === name;
            }
            if (node.type !== "MemberExpression" || node.optional || node.computed || node.property.type !== "Identifier" || node.property.name !== name) {
              return false;
            }
            node = node.object;
          }
        }
        function isNodeMatches(node, nameOrPaths) {
          return nameOrPaths.some((nameOrPath) => isNodeMatchesNameOrPath(node, nameOrPath));
        }
        module22.exports = isNodeMatches;
      }
    });
    var require_utils72 = __commonJS22({
      "src/language-js/utils/index.js"(exports2, module22) {
        "use strict";
        var isIdentifierName = require_utils62().keyword.isIdentifierNameES5;
        var {
          getLast,
          hasNewline,
          skipWhitespace,
          isNonEmptyArray,
          isNextLineEmptyAfterIndex,
          getStringWidth
        } = require_util();
        var {
          locStart,
          locEnd,
          hasSameLocStart
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        var isNodeMatches = require_is_node_matches();
        var NON_LINE_TERMINATING_WHITE_SPACE = "(?:(?=.)\\s)";
        var FLOW_SHORTHAND_ANNOTATION = new RegExp(`^${NON_LINE_TERMINATING_WHITE_SPACE}*:`);
        var FLOW_ANNOTATION = new RegExp(`^${NON_LINE_TERMINATING_WHITE_SPACE}*::`);
        function hasFlowShorthandAnnotationComment(node) {
          var _node$extra, _node$trailingComment;
          return ((_node$extra = node.extra) === null || _node$extra === void 0 ? void 0 : _node$extra.parenthesized) && isBlockComment((_node$trailingComment = node.trailingComments) === null || _node$trailingComment === void 0 ? void 0 : _node$trailingComment[0]) && FLOW_SHORTHAND_ANNOTATION.test(node.trailingComments[0].value);
        }
        function hasFlowAnnotationComment(comments) {
          const firstComment = comments === null || comments === void 0 ? void 0 : comments[0];
          return isBlockComment(firstComment) && FLOW_ANNOTATION.test(firstComment.value);
        }
        function hasNode(node, fn) {
          if (!node || typeof node !== "object") {
            return false;
          }
          if (Array.isArray(node)) {
            return node.some((value) => hasNode(value, fn));
          }
          const result = fn(node);
          return typeof result === "boolean" ? result : Object.values(node).some((value) => hasNode(value, fn));
        }
        function hasNakedLeftSide(node) {
          return node.type === "AssignmentExpression" || node.type === "BinaryExpression" || node.type === "LogicalExpression" || node.type === "NGPipeExpression" || node.type === "ConditionalExpression" || isCallExpression(node) || isMemberExpression(node) || node.type === "SequenceExpression" || node.type === "TaggedTemplateExpression" || node.type === "BindExpression" || node.type === "UpdateExpression" && !node.prefix || node.type === "TSAsExpression" || node.type === "TSNonNullExpression";
        }
        function getLeftSide(node) {
          var _ref2, _ref3, _ref4, _ref5, _ref6, _node$left;
          if (node.expressions) {
            return node.expressions[0];
          }
          return (_ref2 = (_ref3 = (_ref4 = (_ref5 = (_ref6 = (_node$left = node.left) !== null && _node$left !== void 0 ? _node$left : node.test) !== null && _ref6 !== void 0 ? _ref6 : node.callee) !== null && _ref5 !== void 0 ? _ref5 : node.object) !== null && _ref4 !== void 0 ? _ref4 : node.tag) !== null && _ref3 !== void 0 ? _ref3 : node.argument) !== null && _ref2 !== void 0 ? _ref2 : node.expression;
        }
        function getLeftSidePathName(path4, node) {
          if (node.expressions) {
            return ["expressions", 0];
          }
          if (node.left) {
            return ["left"];
          }
          if (node.test) {
            return ["test"];
          }
          if (node.object) {
            return ["object"];
          }
          if (node.callee) {
            return ["callee"];
          }
          if (node.tag) {
            return ["tag"];
          }
          if (node.argument) {
            return ["argument"];
          }
          if (node.expression) {
            return ["expression"];
          }
          throw new Error("Unexpected node has no left side.");
        }
        function createTypeCheckFunction(types3) {
          types3 = new Set(types3);
          return (node) => types3.has(node === null || node === void 0 ? void 0 : node.type);
        }
        var isLineComment = createTypeCheckFunction(["Line", "CommentLine", "SingleLine", "HashbangComment", "HTMLOpen", "HTMLClose"]);
        var isExportDeclaration = createTypeCheckFunction(["ExportDefaultDeclaration", "ExportDefaultSpecifier", "DeclareExportDeclaration", "ExportNamedDeclaration", "ExportAllDeclaration"]);
        function getParentExportDeclaration(path4) {
          const parentNode = path4.getParentNode();
          if (path4.getName() === "declaration" && isExportDeclaration(parentNode)) {
            return parentNode;
          }
          return null;
        }
        var isLiteral = createTypeCheckFunction(["BooleanLiteral", "DirectiveLiteral", "Literal", "NullLiteral", "NumericLiteral", "BigIntLiteral", "DecimalLiteral", "RegExpLiteral", "StringLiteral", "TemplateLiteral", "TSTypeLiteral", "JSXText"]);
        function isNumericLiteral(node) {
          return node.type === "NumericLiteral" || node.type === "Literal" && typeof node.value === "number";
        }
        function isSignedNumericLiteral(node) {
          return node.type === "UnaryExpression" && (node.operator === "+" || node.operator === "-") && isNumericLiteral(node.argument);
        }
        function isStringLiteral(node) {
          return node.type === "StringLiteral" || node.type === "Literal" && typeof node.value === "string";
        }
        var isObjectType = createTypeCheckFunction(["ObjectTypeAnnotation", "TSTypeLiteral", "TSMappedType"]);
        var isFunctionOrArrowExpression = createTypeCheckFunction(["FunctionExpression", "ArrowFunctionExpression"]);
        function isFunctionOrArrowExpressionWithBody(node) {
          return node.type === "FunctionExpression" || node.type === "ArrowFunctionExpression" && node.body.type === "BlockStatement";
        }
        function isAngularTestWrapper(node) {
          return isCallExpression(node) && node.callee.type === "Identifier" && ["async", "inject", "fakeAsync", "waitForAsync"].includes(node.callee.name);
        }
        var isJsxNode = createTypeCheckFunction(["JSXElement", "JSXFragment"]);
        function isTheOnlyJsxElementInMarkdown(options, path4) {
          if (options.parentParser !== "markdown" && options.parentParser !== "mdx") {
            return false;
          }
          const node = path4.getNode();
          if (!node.expression || !isJsxNode(node.expression)) {
            return false;
          }
          const parent = path4.getParentNode();
          return parent.type === "Program" && parent.body.length === 1;
        }
        function isGetterOrSetter(node) {
          return node.kind === "get" || node.kind === "set";
        }
        function isFunctionNotation(node) {
          return isGetterOrSetter(node) || hasSameLocStart(node, node.value);
        }
        function isObjectTypePropertyAFunction(node) {
          return (node.type === "ObjectTypeProperty" || node.type === "ObjectTypeInternalSlot") && node.value.type === "FunctionTypeAnnotation" && !node.static && !isFunctionNotation(node);
        }
        function isTypeAnnotationAFunction(node) {
          return (node.type === "TypeAnnotation" || node.type === "TSTypeAnnotation") && node.typeAnnotation.type === "FunctionTypeAnnotation" && !node.static && !hasSameLocStart(node, node.typeAnnotation);
        }
        var isBinaryish = createTypeCheckFunction(["BinaryExpression", "LogicalExpression", "NGPipeExpression"]);
        function isMemberish(node) {
          return isMemberExpression(node) || node.type === "BindExpression" && Boolean(node.object);
        }
        var simpleTypeAnnotations = /* @__PURE__ */ new Set(["AnyTypeAnnotation", "TSAnyKeyword", "NullLiteralTypeAnnotation", "TSNullKeyword", "ThisTypeAnnotation", "TSThisType", "NumberTypeAnnotation", "TSNumberKeyword", "VoidTypeAnnotation", "TSVoidKeyword", "BooleanTypeAnnotation", "TSBooleanKeyword", "BigIntTypeAnnotation", "TSBigIntKeyword", "SymbolTypeAnnotation", "TSSymbolKeyword", "StringTypeAnnotation", "TSStringKeyword", "BooleanLiteralTypeAnnotation", "StringLiteralTypeAnnotation", "BigIntLiteralTypeAnnotation", "NumberLiteralTypeAnnotation", "TSLiteralType", "TSTemplateLiteralType", "EmptyTypeAnnotation", "MixedTypeAnnotation", "TSNeverKeyword", "TSObjectKeyword", "TSUndefinedKeyword", "TSUnknownKeyword"]);
        function isSimpleType(node) {
          if (!node) {
            return false;
          }
          if ((node.type === "GenericTypeAnnotation" || node.type === "TSTypeReference") && !node.typeParameters) {
            return true;
          }
          if (simpleTypeAnnotations.has(node.type)) {
            return true;
          }
          return false;
        }
        function isUnitTestSetUp(node) {
          const unitTestSetUpRe = /^(?:before|after)(?:Each|All)$/;
          return node.callee.type === "Identifier" && unitTestSetUpRe.test(node.callee.name) && node.arguments.length === 1;
        }
        var testCallCalleePatterns = ["it", "it.only", "it.skip", "describe", "describe.only", "describe.skip", "test", "test.only", "test.skip", "test.step", "test.describe", "test.describe.only", "test.describe.parallel", "test.describe.parallel.only", "test.describe.serial", "test.describe.serial.only", "skip", "xit", "xdescribe", "xtest", "fit", "fdescribe", "ftest"];
        function isTestCallCallee(node) {
          return isNodeMatches(node, testCallCalleePatterns);
        }
        function isTestCall(node, parent) {
          if (node.type !== "CallExpression") {
            return false;
          }
          if (node.arguments.length === 1) {
            if (isAngularTestWrapper(node) && parent && isTestCall(parent)) {
              return isFunctionOrArrowExpression(node.arguments[0]);
            }
            if (isUnitTestSetUp(node)) {
              return isAngularTestWrapper(node.arguments[0]);
            }
          } else if (node.arguments.length === 2 || node.arguments.length === 3) {
            if ((node.arguments[0].type === "TemplateLiteral" || isStringLiteral(node.arguments[0])) && isTestCallCallee(node.callee)) {
              if (node.arguments[2] && !isNumericLiteral(node.arguments[2])) {
                return false;
              }
              return (node.arguments.length === 2 ? isFunctionOrArrowExpression(node.arguments[1]) : isFunctionOrArrowExpressionWithBody(node.arguments[1]) && getFunctionParameters(node.arguments[1]).length <= 1) || isAngularTestWrapper(node.arguments[1]);
            }
          }
          return false;
        }
        var isCallExpression = createTypeCheckFunction(["CallExpression", "OptionalCallExpression"]);
        var isMemberExpression = createTypeCheckFunction(["MemberExpression", "OptionalMemberExpression"]);
        function isSimpleTemplateLiteral(node) {
          let expressionsKey = "expressions";
          if (node.type === "TSTemplateLiteralType") {
            expressionsKey = "types";
          }
          const expressions = node[expressionsKey];
          if (expressions.length === 0) {
            return false;
          }
          return expressions.every((expr) => {
            if (hasComment(expr)) {
              return false;
            }
            if (expr.type === "Identifier" || expr.type === "ThisExpression") {
              return true;
            }
            if (isMemberExpression(expr)) {
              let head = expr;
              while (isMemberExpression(head)) {
                if (head.property.type !== "Identifier" && head.property.type !== "Literal" && head.property.type !== "StringLiteral" && head.property.type !== "NumericLiteral") {
                  return false;
                }
                head = head.object;
                if (hasComment(head)) {
                  return false;
                }
              }
              if (head.type === "Identifier" || head.type === "ThisExpression") {
                return true;
              }
              return false;
            }
            return false;
          });
        }
        function getTypeScriptMappedTypeModifier(tokenNode, keyword) {
          if (tokenNode === "+" || tokenNode === "-") {
            return tokenNode + keyword;
          }
          return keyword;
        }
        function isFlowAnnotationComment(text, typeAnnotation) {
          const start = locStart(typeAnnotation);
          const end = skipWhitespace(text, locEnd(typeAnnotation));
          return end !== false && text.slice(start, start + 2) === "/*" && text.slice(end, end + 2) === "*/";
        }
        function hasLeadingOwnLineComment(text, node) {
          if (isJsxNode(node)) {
            return hasNodeIgnoreComment(node);
          }
          return hasComment(node, CommentCheckFlags.Leading, (comment) => hasNewline(text, locEnd(comment)));
        }
        function isStringPropSafeToUnquote(node, options) {
          return options.parser !== "json" && isStringLiteral(node.key) && rawText(node.key).slice(1, -1) === node.key.value && (isIdentifierName(node.key.value) && !(options.parser === "babel-ts" && node.type === "ClassProperty" || options.parser === "typescript" && node.type === "PropertyDefinition") || isSimpleNumber(node.key.value) && String(Number(node.key.value)) === node.key.value && (options.parser === "babel" || options.parser === "acorn" || options.parser === "espree" || options.parser === "meriyah" || options.parser === "__babel_estree"));
        }
        function isSimpleNumber(numberString) {
          return /^(?:\d+|\d+\.\d+)$/.test(numberString);
        }
        function isJestEachTemplateLiteral(node, parentNode) {
          const jestEachTriggerRegex = /^[fx]?(?:describe|it|test)$/;
          return parentNode.type === "TaggedTemplateExpression" && parentNode.quasi === node && parentNode.tag.type === "MemberExpression" && parentNode.tag.property.type === "Identifier" && parentNode.tag.property.name === "each" && (parentNode.tag.object.type === "Identifier" && jestEachTriggerRegex.test(parentNode.tag.object.name) || parentNode.tag.object.type === "MemberExpression" && parentNode.tag.object.property.type === "Identifier" && (parentNode.tag.object.property.name === "only" || parentNode.tag.object.property.name === "skip") && parentNode.tag.object.object.type === "Identifier" && jestEachTriggerRegex.test(parentNode.tag.object.object.name));
        }
        function templateLiteralHasNewLines(template) {
          return template.quasis.some((quasi) => quasi.value.raw.includes("\n"));
        }
        function isTemplateOnItsOwnLine(node, text) {
          return (node.type === "TemplateLiteral" && templateLiteralHasNewLines(node) || node.type === "TaggedTemplateExpression" && templateLiteralHasNewLines(node.quasi)) && !hasNewline(text, locStart(node), {
            backwards: true
          });
        }
        function needsHardlineAfterDanglingComment(node) {
          if (!hasComment(node)) {
            return false;
          }
          const lastDanglingComment = getLast(getComments(node, CommentCheckFlags.Dangling));
          return lastDanglingComment && !isBlockComment(lastDanglingComment);
        }
        function isFunctionCompositionArgs(args) {
          if (args.length <= 1) {
            return false;
          }
          let count = 0;
          for (const arg of args) {
            if (isFunctionOrArrowExpression(arg)) {
              count += 1;
              if (count > 1) {
                return true;
              }
            } else if (isCallExpression(arg)) {
              for (const childArg of arg.arguments) {
                if (isFunctionOrArrowExpression(childArg)) {
                  return true;
                }
              }
            }
          }
          return false;
        }
        function isLongCurriedCallExpression(path4) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          return isCallExpression(node) && isCallExpression(parent) && parent.callee === node && node.arguments.length > parent.arguments.length && parent.arguments.length > 0;
        }
        function isSimpleCallArgument(node, depth) {
          if (depth >= 2) {
            return false;
          }
          const isChildSimple = (child) => isSimpleCallArgument(child, depth + 1);
          const regexpPattern = node.type === "Literal" && "regex" in node && node.regex.pattern || node.type === "RegExpLiteral" && node.pattern;
          if (regexpPattern && getStringWidth(regexpPattern) > 5) {
            return false;
          }
          if (node.type === "Literal" || node.type === "BigIntLiteral" || node.type === "DecimalLiteral" || node.type === "BooleanLiteral" || node.type === "NullLiteral" || node.type === "NumericLiteral" || node.type === "RegExpLiteral" || node.type === "StringLiteral" || node.type === "Identifier" || node.type === "ThisExpression" || node.type === "Super" || node.type === "PrivateName" || node.type === "PrivateIdentifier" || node.type === "ArgumentPlaceholder" || node.type === "Import") {
            return true;
          }
          if (node.type === "TemplateLiteral") {
            return node.quasis.every((element) => !element.value.raw.includes("\n")) && node.expressions.every(isChildSimple);
          }
          if (node.type === "ObjectExpression") {
            return node.properties.every((p) => !p.computed && (p.shorthand || p.value && isChildSimple(p.value)));
          }
          if (node.type === "ArrayExpression") {
            return node.elements.every((x2) => x2 === null || isChildSimple(x2));
          }
          if (isCallLikeExpression(node)) {
            return (node.type === "ImportExpression" || isSimpleCallArgument(node.callee, depth)) && getCallArguments(node).every(isChildSimple);
          }
          if (isMemberExpression(node)) {
            return isSimpleCallArgument(node.object, depth) && isSimpleCallArgument(node.property, depth);
          }
          if (node.type === "UnaryExpression" && (node.operator === "!" || node.operator === "-")) {
            return isSimpleCallArgument(node.argument, depth);
          }
          if (node.type === "TSNonNullExpression") {
            return isSimpleCallArgument(node.expression, depth);
          }
          return false;
        }
        function rawText(node) {
          var _node$extra$raw, _node$extra2;
          return (_node$extra$raw = (_node$extra2 = node.extra) === null || _node$extra2 === void 0 ? void 0 : _node$extra2.raw) !== null && _node$extra$raw !== void 0 ? _node$extra$raw : node.raw;
        }
        function identity(x2) {
          return x2;
        }
        function isTSXFile(options) {
          return options.filepath && /\.tsx$/i.test(options.filepath);
        }
        function shouldPrintComma(options, level = "es5") {
          return options.trailingComma === "es5" && level === "es5" || options.trailingComma === "all" && (level === "all" || level === "es5");
        }
        function startsWithNoLookaheadToken(node, forbidFunctionClassAndDoExpr) {
          node = getLeftMost(node);
          switch (node.type) {
            case "FunctionExpression":
            case "ClassExpression":
            case "DoExpression":
              return forbidFunctionClassAndDoExpr;
            case "ObjectExpression":
              return true;
            case "MemberExpression":
            case "OptionalMemberExpression":
              return startsWithNoLookaheadToken(node.object, forbidFunctionClassAndDoExpr);
            case "TaggedTemplateExpression":
              if (node.tag.type === "FunctionExpression") {
                return false;
              }
              return startsWithNoLookaheadToken(node.tag, forbidFunctionClassAndDoExpr);
            case "CallExpression":
            case "OptionalCallExpression":
              if (node.callee.type === "FunctionExpression") {
                return false;
              }
              return startsWithNoLookaheadToken(node.callee, forbidFunctionClassAndDoExpr);
            case "ConditionalExpression":
              return startsWithNoLookaheadToken(node.test, forbidFunctionClassAndDoExpr);
            case "UpdateExpression":
              return !node.prefix && startsWithNoLookaheadToken(node.argument, forbidFunctionClassAndDoExpr);
            case "BindExpression":
              return node.object && startsWithNoLookaheadToken(node.object, forbidFunctionClassAndDoExpr);
            case "SequenceExpression":
              return startsWithNoLookaheadToken(node.expressions[0], forbidFunctionClassAndDoExpr);
            case "TSAsExpression":
            case "TSNonNullExpression":
              return startsWithNoLookaheadToken(node.expression, forbidFunctionClassAndDoExpr);
            default:
              return false;
          }
        }
        var equalityOperators = {
          "==": true,
          "!=": true,
          "===": true,
          "!==": true
        };
        var multiplicativeOperators = {
          "*": true,
          "/": true,
          "%": true
        };
        var bitshiftOperators = {
          ">>": true,
          ">>>": true,
          "<<": true
        };
        function shouldFlatten(parentOp, nodeOp) {
          if (getPrecedence(nodeOp) !== getPrecedence(parentOp)) {
            return false;
          }
          if (parentOp === "**") {
            return false;
          }
          if (equalityOperators[parentOp] && equalityOperators[nodeOp]) {
            return false;
          }
          if (nodeOp === "%" && multiplicativeOperators[parentOp] || parentOp === "%" && multiplicativeOperators[nodeOp]) {
            return false;
          }
          if (nodeOp !== parentOp && multiplicativeOperators[nodeOp] && multiplicativeOperators[parentOp]) {
            return false;
          }
          if (bitshiftOperators[parentOp] && bitshiftOperators[nodeOp]) {
            return false;
          }
          return true;
        }
        var PRECEDENCE = new Map([["|>"], ["??"], ["||"], ["&&"], ["|"], ["^"], ["&"], ["==", "===", "!=", "!=="], ["<", ">", "<=", ">=", "in", "instanceof"], [">>", "<<", ">>>"], ["+", "-"], ["*", "/", "%"], ["**"]].flatMap((operators, index) => operators.map((operator) => [operator, index])));
        function getPrecedence(operator) {
          return PRECEDENCE.get(operator);
        }
        function getLeftMost(node) {
          while (node.left) {
            node = node.left;
          }
          return node;
        }
        function isBitwiseOperator(operator) {
          return Boolean(bitshiftOperators[operator]) || operator === "|" || operator === "^" || operator === "&";
        }
        function hasRestParameter(node) {
          var _getLast;
          if (node.rest) {
            return true;
          }
          const parameters = getFunctionParameters(node);
          return ((_getLast = getLast(parameters)) === null || _getLast === void 0 ? void 0 : _getLast.type) === "RestElement";
        }
        var functionParametersCache = /* @__PURE__ */ new WeakMap();
        function getFunctionParameters(node) {
          if (functionParametersCache.has(node)) {
            return functionParametersCache.get(node);
          }
          const parameters = [];
          if (node.this) {
            parameters.push(node.this);
          }
          if (Array.isArray(node.parameters)) {
            parameters.push(...node.parameters);
          } else if (Array.isArray(node.params)) {
            parameters.push(...node.params);
          }
          if (node.rest) {
            parameters.push(node.rest);
          }
          functionParametersCache.set(node, parameters);
          return parameters;
        }
        function iterateFunctionParametersPath(path4, iteratee) {
          const node = path4.getValue();
          let index = 0;
          const callback = (childPath) => iteratee(childPath, index++);
          if (node.this) {
            path4.call(callback, "this");
          }
          if (Array.isArray(node.parameters)) {
            path4.each(callback, "parameters");
          } else if (Array.isArray(node.params)) {
            path4.each(callback, "params");
          }
          if (node.rest) {
            path4.call(callback, "rest");
          }
        }
        var callArgumentsCache = /* @__PURE__ */ new WeakMap();
        function getCallArguments(node) {
          if (callArgumentsCache.has(node)) {
            return callArgumentsCache.get(node);
          }
          let args = node.arguments;
          if (node.type === "ImportExpression") {
            args = [node.source];
            if (node.attributes) {
              args.push(node.attributes);
            }
          }
          callArgumentsCache.set(node, args);
          return args;
        }
        function iterateCallArgumentsPath(path4, iteratee) {
          const node = path4.getValue();
          if (node.type === "ImportExpression") {
            path4.call((sourcePath) => iteratee(sourcePath, 0), "source");
            if (node.attributes) {
              path4.call((sourcePath) => iteratee(sourcePath, 1), "attributes");
            }
          } else {
            path4.each(iteratee, "arguments");
          }
        }
        function isPrettierIgnoreComment(comment) {
          return comment.value.trim() === "prettier-ignore" && !comment.unignore;
        }
        function hasNodeIgnoreComment(node) {
          return node && (node.prettierIgnore || hasComment(node, CommentCheckFlags.PrettierIgnore));
        }
        function hasIgnoreComment(path4) {
          const node = path4.getValue();
          return hasNodeIgnoreComment(node);
        }
        var CommentCheckFlags = {
          Leading: 1 << 1,
          Trailing: 1 << 2,
          Dangling: 1 << 3,
          Block: 1 << 4,
          Line: 1 << 5,
          PrettierIgnore: 1 << 6,
          First: 1 << 7,
          Last: 1 << 8
        };
        var getCommentTestFunction = (flags, fn) => {
          if (typeof flags === "function") {
            fn = flags;
            flags = 0;
          }
          if (flags || fn) {
            return (comment, index, comments) => !(flags & CommentCheckFlags.Leading && !comment.leading || flags & CommentCheckFlags.Trailing && !comment.trailing || flags & CommentCheckFlags.Dangling && (comment.leading || comment.trailing) || flags & CommentCheckFlags.Block && !isBlockComment(comment) || flags & CommentCheckFlags.Line && !isLineComment(comment) || flags & CommentCheckFlags.First && index !== 0 || flags & CommentCheckFlags.Last && index !== comments.length - 1 || flags & CommentCheckFlags.PrettierIgnore && !isPrettierIgnoreComment(comment) || fn && !fn(comment));
          }
        };
        function hasComment(node, flags, fn) {
          if (!isNonEmptyArray(node === null || node === void 0 ? void 0 : node.comments)) {
            return false;
          }
          const test = getCommentTestFunction(flags, fn);
          return test ? node.comments.some(test) : true;
        }
        function getComments(node, flags, fn) {
          if (!Array.isArray(node === null || node === void 0 ? void 0 : node.comments)) {
            return [];
          }
          const test = getCommentTestFunction(flags, fn);
          return test ? node.comments.filter(test) : node.comments;
        }
        var isNextLineEmpty = (node, {
          originalText
        }) => isNextLineEmptyAfterIndex(originalText, locEnd(node));
        function isCallLikeExpression(node) {
          return isCallExpression(node) || node.type === "NewExpression" || node.type === "ImportExpression";
        }
        function isObjectProperty(node) {
          return node && (node.type === "ObjectProperty" || node.type === "Property" && !node.method && node.kind === "init");
        }
        function isEnabledHackPipeline(options) {
          return Boolean(options.__isUsingHackPipeline);
        }
        var markerForIfWithoutBlockAndSameLineComment = Symbol("ifWithoutBlockAndSameLineComment");
        module22.exports = {
          getFunctionParameters,
          iterateFunctionParametersPath,
          getCallArguments,
          iterateCallArgumentsPath,
          hasRestParameter,
          getLeftSide,
          getLeftSidePathName,
          getParentExportDeclaration,
          getTypeScriptMappedTypeModifier,
          hasFlowAnnotationComment,
          hasFlowShorthandAnnotationComment,
          hasLeadingOwnLineComment,
          hasNakedLeftSide,
          hasNode,
          hasIgnoreComment,
          hasNodeIgnoreComment,
          identity,
          isBinaryish,
          isCallLikeExpression,
          isEnabledHackPipeline,
          isLineComment,
          isPrettierIgnoreComment,
          isCallExpression,
          isMemberExpression,
          isExportDeclaration,
          isFlowAnnotationComment,
          isFunctionCompositionArgs,
          isFunctionNotation,
          isFunctionOrArrowExpression,
          isGetterOrSetter,
          isJestEachTemplateLiteral,
          isJsxNode,
          isLiteral,
          isLongCurriedCallExpression,
          isSimpleCallArgument,
          isMemberish,
          isNumericLiteral,
          isSignedNumericLiteral,
          isObjectProperty,
          isObjectType,
          isObjectTypePropertyAFunction,
          isSimpleType,
          isSimpleNumber,
          isSimpleTemplateLiteral,
          isStringLiteral,
          isStringPropSafeToUnquote,
          isTemplateOnItsOwnLine,
          isTestCall,
          isTheOnlyJsxElementInMarkdown,
          isTSXFile,
          isTypeAnnotationAFunction,
          isNextLineEmpty,
          needsHardlineAfterDanglingComment,
          rawText,
          shouldPrintComma,
          isBitwiseOperator,
          shouldFlatten,
          startsWithNoLookaheadToken,
          getPrecedence,
          hasComment,
          getComments,
          CommentCheckFlags,
          markerForIfWithoutBlockAndSameLineComment
        };
      }
    });
    var require_template_literal = __commonJS22({
      "src/language-js/print/template-literal.js"(exports2, module22) {
        "use strict";
        var getLast = require_get_last();
        var {
          getStringWidth,
          getIndentSize
        } = require_util();
        var {
          builders: {
            join,
            hardline,
            softline,
            group,
            indent,
            align,
            lineSuffixBoundary,
            addAlignmentToDoc
          },
          printer: {
            printDocToString
          },
          utils: {
            mapDoc
          }
        } = require_doc();
        var {
          isBinaryish,
          isJestEachTemplateLiteral,
          isSimpleTemplateLiteral,
          hasComment,
          isMemberExpression
        } = require_utils72();
        function printTemplateLiteral(path4, print, options) {
          const node = path4.getValue();
          const isTemplateLiteral = node.type === "TemplateLiteral";
          if (isTemplateLiteral && isJestEachTemplateLiteral(node, path4.getParentNode())) {
            const printed = printJestEachTemplateLiteral(path4, options, print);
            if (printed) {
              return printed;
            }
          }
          let expressionsKey = "expressions";
          if (node.type === "TSTemplateLiteralType") {
            expressionsKey = "types";
          }
          const parts = [];
          let expressions = path4.map(print, expressionsKey);
          const isSimple = isSimpleTemplateLiteral(node);
          if (isSimple) {
            expressions = expressions.map((doc2) => printDocToString(doc2, Object.assign(Object.assign({}, options), {}, {
              printWidth: Number.POSITIVE_INFINITY
            })).formatted);
          }
          parts.push(lineSuffixBoundary, "`");
          path4.each((childPath) => {
            const i2 = childPath.getName();
            parts.push(print());
            if (i2 < expressions.length) {
              const {
                tabWidth
              } = options;
              const quasi = childPath.getValue();
              const indentSize = getIndentSize(quasi.value.raw, tabWidth);
              let printed = expressions[i2];
              if (!isSimple) {
                const expression = node[expressionsKey][i2];
                if (hasComment(expression) || isMemberExpression(expression) || expression.type === "ConditionalExpression" || expression.type === "SequenceExpression" || expression.type === "TSAsExpression" || isBinaryish(expression)) {
                  printed = [indent([softline, printed]), softline];
                }
              }
              const aligned = indentSize === 0 && quasi.value.raw.endsWith("\n") ? align(Number.NEGATIVE_INFINITY, printed) : addAlignmentToDoc(printed, indentSize, tabWidth);
              parts.push(group(["${", aligned, lineSuffixBoundary, "}"]));
            }
          }, "quasis");
          parts.push("`");
          return parts;
        }
        function printJestEachTemplateLiteral(path4, options, print) {
          const node = path4.getNode();
          const headerNames = node.quasis[0].value.raw.trim().split(/\s*\|\s*/);
          if (headerNames.length > 1 || headerNames.some((headerName) => headerName.length > 0)) {
            options.__inJestEach = true;
            const expressions = path4.map(print, "expressions");
            options.__inJestEach = false;
            const parts = [];
            const stringifiedExpressions = expressions.map((doc2) => "${" + printDocToString(doc2, Object.assign(Object.assign({}, options), {}, {
              printWidth: Number.POSITIVE_INFINITY,
              endOfLine: "lf"
            })).formatted + "}");
            const tableBody = [{
              hasLineBreak: false,
              cells: []
            }];
            for (let i2 = 1; i2 < node.quasis.length; i2++) {
              const row = getLast(tableBody);
              const correspondingExpression = stringifiedExpressions[i2 - 1];
              row.cells.push(correspondingExpression);
              if (correspondingExpression.includes("\n")) {
                row.hasLineBreak = true;
              }
              if (node.quasis[i2].value.raw.includes("\n")) {
                tableBody.push({
                  hasLineBreak: false,
                  cells: []
                });
              }
            }
            const maxColumnCount = Math.max(headerNames.length, ...tableBody.map((row) => row.cells.length));
            const maxColumnWidths = Array.from({
              length: maxColumnCount
            }).fill(0);
            const table = [{
              cells: headerNames
            }, ...tableBody.filter((row) => row.cells.length > 0)];
            for (const {
              cells
            } of table.filter((row) => !row.hasLineBreak)) {
              for (const [index, cell] of cells.entries()) {
                maxColumnWidths[index] = Math.max(maxColumnWidths[index], getStringWidth(cell));
              }
            }
            parts.push(lineSuffixBoundary, "`", indent([hardline, join(hardline, table.map((row) => join(" | ", row.cells.map((cell, index) => row.hasLineBreak ? cell : cell + " ".repeat(maxColumnWidths[index] - getStringWidth(cell))))))]), hardline, "`");
            return parts;
          }
        }
        function printTemplateExpression(path4, print) {
          const node = path4.getValue();
          let printed = print();
          if (hasComment(node)) {
            printed = group([indent([softline, printed]), softline]);
          }
          return ["${", printed, lineSuffixBoundary, "}"];
        }
        function printTemplateExpressions(path4, print) {
          return path4.map((path22) => printTemplateExpression(path22, print), "expressions");
        }
        function escapeTemplateCharacters(doc2, raw) {
          return mapDoc(doc2, (currentDoc) => {
            if (typeof currentDoc === "string") {
              return raw ? currentDoc.replace(/(\\*)`/g, "$1$1\\`") : uncookTemplateElementValue(currentDoc);
            }
            return currentDoc;
          });
        }
        function uncookTemplateElementValue(cookedValue) {
          return cookedValue.replace(/([\\`]|\${)/g, "\\$1");
        }
        module22.exports = {
          printTemplateLiteral,
          printTemplateExpressions,
          escapeTemplateCharacters,
          uncookTemplateElementValue
        };
      }
    });
    var require_markdown = __commonJS22({
      "src/language-js/embed/markdown.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            indent,
            softline,
            literalline,
            dedentToRoot
          }
        } = require_doc();
        var {
          escapeTemplateCharacters
        } = require_template_literal();
        function format2(path4, print, textToDoc) {
          const node = path4.getValue();
          let text = node.quasis[0].value.raw.replace(/((?:\\\\)*)\\`/g, (_, backslashes) => "\\".repeat(backslashes.length / 2) + "`");
          const indentation = getIndentation(text);
          const hasIndent = indentation !== "";
          if (hasIndent) {
            text = text.replace(new RegExp(`^${indentation}`, "gm"), "");
          }
          const doc2 = escapeTemplateCharacters(textToDoc(text, {
            parser: "markdown",
            __inJsTemplate: true
          }, {
            stripTrailingHardline: true
          }), true);
          return ["`", hasIndent ? indent([softline, doc2]) : [literalline, dedentToRoot(doc2)], softline, "`"];
        }
        function getIndentation(str) {
          const firstMatchedIndent = str.match(/^([^\S\n]*)\S/m);
          return firstMatchedIndent === null ? "" : firstMatchedIndent[1];
        }
        module22.exports = format2;
      }
    });
    var require_css = __commonJS22({
      "src/language-js/embed/css.js"(exports2, module22) {
        "use strict";
        var {
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            indent,
            hardline,
            softline
          },
          utils: {
            mapDoc,
            replaceEndOfLine,
            cleanDoc
          }
        } = require_doc();
        var {
          printTemplateExpressions
        } = require_template_literal();
        function format2(path4, print, textToDoc) {
          const node = path4.getValue();
          const rawQuasis = node.quasis.map((q) => q.value.raw);
          let placeholderID = 0;
          const text = rawQuasis.reduce((prevVal, currVal, idx) => idx === 0 ? currVal : prevVal + "@prettier-placeholder-" + placeholderID++ + "-id" + currVal, "");
          const doc2 = textToDoc(text, {
            parser: "scss"
          }, {
            stripTrailingHardline: true
          });
          const expressionDocs = printTemplateExpressions(path4, print);
          return transformCssDoc(doc2, node, expressionDocs);
        }
        function transformCssDoc(quasisDoc, parentNode, expressionDocs) {
          const isEmpty = parentNode.quasis.length === 1 && !parentNode.quasis[0].value.raw.trim();
          if (isEmpty) {
            return "``";
          }
          const newDoc = replacePlaceholders(quasisDoc, expressionDocs);
          if (!newDoc) {
            throw new Error("Couldn't insert all the expressions");
          }
          return ["`", indent([hardline, newDoc]), softline, "`"];
        }
        function replacePlaceholders(quasisDoc, expressionDocs) {
          if (!isNonEmptyArray(expressionDocs)) {
            return quasisDoc;
          }
          let replaceCounter = 0;
          const newDoc = mapDoc(cleanDoc(quasisDoc), (doc2) => {
            if (typeof doc2 !== "string" || !doc2.includes("@prettier-placeholder")) {
              return doc2;
            }
            return doc2.split(/@prettier-placeholder-(\d+)-id/).map((component, idx) => {
              if (idx % 2 === 0) {
                return replaceEndOfLine(component);
              }
              replaceCounter++;
              return expressionDocs[component];
            });
          });
          return expressionDocs.length === replaceCounter ? newDoc : null;
        }
        module22.exports = format2;
      }
    });
    var require_graphql = __commonJS22({
      "src/language-js/embed/graphql.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            indent,
            join,
            hardline
          }
        } = require_doc();
        var {
          escapeTemplateCharacters,
          printTemplateExpressions
        } = require_template_literal();
        function format2(path4, print, textToDoc) {
          const node = path4.getValue();
          const numQuasis = node.quasis.length;
          if (numQuasis === 1 && node.quasis[0].value.raw.trim() === "") {
            return "``";
          }
          const expressionDocs = printTemplateExpressions(path4, print);
          const parts = [];
          for (let i2 = 0; i2 < numQuasis; i2++) {
            const templateElement = node.quasis[i2];
            const isFirst = i2 === 0;
            const isLast = i2 === numQuasis - 1;
            const text = templateElement.value.cooked;
            const lines = text.split("\n");
            const numLines = lines.length;
            const expressionDoc = expressionDocs[i2];
            const startsWithBlankLine = numLines > 2 && lines[0].trim() === "" && lines[1].trim() === "";
            const endsWithBlankLine = numLines > 2 && lines[numLines - 1].trim() === "" && lines[numLines - 2].trim() === "";
            const commentsAndWhitespaceOnly = lines.every((line) => /^\s*(?:#[^\n\r]*)?$/.test(line));
            if (!isLast && /#[^\n\r]*$/.test(lines[numLines - 1])) {
              return null;
            }
            let doc2 = null;
            if (commentsAndWhitespaceOnly) {
              doc2 = printGraphqlComments(lines);
            } else {
              doc2 = textToDoc(text, {
                parser: "graphql"
              }, {
                stripTrailingHardline: true
              });
            }
            if (doc2) {
              doc2 = escapeTemplateCharacters(doc2, false);
              if (!isFirst && startsWithBlankLine) {
                parts.push("");
              }
              parts.push(doc2);
              if (!isLast && endsWithBlankLine) {
                parts.push("");
              }
            } else if (!isFirst && !isLast && startsWithBlankLine) {
              parts.push("");
            }
            if (expressionDoc) {
              parts.push(expressionDoc);
            }
          }
          return ["`", indent([hardline, join(hardline, parts)]), hardline, "`"];
        }
        function printGraphqlComments(lines) {
          const parts = [];
          let seenComment = false;
          const array = lines.map((textLine) => textLine.trim());
          for (const [i2, textLine] of array.entries()) {
            if (textLine === "") {
              continue;
            }
            if (array[i2 - 1] === "" && seenComment) {
              parts.push([hardline, textLine]);
            } else {
              parts.push(textLine);
            }
            seenComment = true;
          }
          return parts.length === 0 ? null : join(hardline, parts);
        }
        module22.exports = format2;
      }
    });
    var require_html = __commonJS22({
      "src/language-js/embed/html.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            indent,
            line,
            hardline,
            group
          },
          utils: {
            mapDoc
          }
        } = require_doc();
        var {
          printTemplateExpressions,
          uncookTemplateElementValue
        } = require_template_literal();
        var htmlTemplateLiteralCounter = 0;
        function format2(path4, print, textToDoc, options, {
          parser
        }) {
          const node = path4.getValue();
          const counter = htmlTemplateLiteralCounter;
          htmlTemplateLiteralCounter = htmlTemplateLiteralCounter + 1 >>> 0;
          const composePlaceholder = (index) => `PRETTIER_HTML_PLACEHOLDER_${index}_${counter}_IN_JS`;
          const text = node.quasis.map((quasi, index, quasis) => index === quasis.length - 1 ? quasi.value.cooked : quasi.value.cooked + composePlaceholder(index)).join("");
          const expressionDocs = printTemplateExpressions(path4, print);
          if (expressionDocs.length === 0 && text.trim().length === 0) {
            return "``";
          }
          const placeholderRegex = new RegExp(composePlaceholder("(\\d+)"), "g");
          let topLevelCount = 0;
          const doc2 = textToDoc(text, {
            parser,
            __onHtmlRoot(root) {
              topLevelCount = root.children.length;
            }
          }, {
            stripTrailingHardline: true
          });
          const contentDoc = mapDoc(doc2, (doc3) => {
            if (typeof doc3 !== "string") {
              return doc3;
            }
            const parts = [];
            const components = doc3.split(placeholderRegex);
            for (let i2 = 0; i2 < components.length; i2++) {
              let component = components[i2];
              if (i2 % 2 === 0) {
                if (component) {
                  component = uncookTemplateElementValue(component);
                  if (options.__embeddedInHtml) {
                    component = component.replace(/<\/(script)\b/gi, "<\\/$1");
                  }
                  parts.push(component);
                }
                continue;
              }
              const placeholderIndex = Number(component);
              parts.push(expressionDocs[placeholderIndex]);
            }
            return parts;
          });
          const leadingWhitespace = /^\s/.test(text) ? " " : "";
          const trailingWhitespace = /\s$/.test(text) ? " " : "";
          const linebreak = options.htmlWhitespaceSensitivity === "ignore" ? hardline : leadingWhitespace && trailingWhitespace ? line : null;
          if (linebreak) {
            return group(["`", indent([linebreak, group(contentDoc)]), linebreak, "`"]);
          }
          return group(["`", leadingWhitespace, topLevelCount > 1 ? indent(group(contentDoc)) : group(contentDoc), trailingWhitespace, "`"]);
        }
        module22.exports = format2;
      }
    });
    var require_embed = __commonJS22({
      "src/language-js/embed.js"(exports2, module22) {
        "use strict";
        var {
          hasComment,
          CommentCheckFlags,
          isObjectProperty
        } = require_utils72();
        var formatMarkdown = require_markdown();
        var formatCss = require_css();
        var formatGraphql = require_graphql();
        var formatHtml = require_html();
        function getLanguage(path4) {
          if (isStyledJsx(path4) || isStyledComponents(path4) || isCssProp(path4) || isAngularComponentStyles(path4)) {
            return "css";
          }
          if (isGraphQL(path4)) {
            return "graphql";
          }
          if (isHtml(path4)) {
            return "html";
          }
          if (isAngularComponentTemplate(path4)) {
            return "angular";
          }
          if (isMarkdown(path4)) {
            return "markdown";
          }
        }
        function embed(path4, print, textToDoc, options) {
          const node = path4.getValue();
          if (node.type !== "TemplateLiteral" || hasInvalidCookedValue(node)) {
            return;
          }
          const language = getLanguage(path4);
          if (!language) {
            return;
          }
          if (language === "markdown") {
            return formatMarkdown(path4, print, textToDoc);
          }
          if (language === "css") {
            return formatCss(path4, print, textToDoc);
          }
          if (language === "graphql") {
            return formatGraphql(path4, print, textToDoc);
          }
          if (language === "html" || language === "angular") {
            return formatHtml(path4, print, textToDoc, options, {
              parser: language
            });
          }
        }
        function isMarkdown(path4) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          return parent && parent.type === "TaggedTemplateExpression" && node.quasis.length === 1 && parent.tag.type === "Identifier" && (parent.tag.name === "md" || parent.tag.name === "markdown");
        }
        function isStyledJsx(path4) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          const parentParent = path4.getParentNode(1);
          return parentParent && node.quasis && parent.type === "JSXExpressionContainer" && parentParent.type === "JSXElement" && parentParent.openingElement.name.name === "style" && parentParent.openingElement.attributes.some((attribute) => attribute.name.name === "jsx") || parent && parent.type === "TaggedTemplateExpression" && parent.tag.type === "Identifier" && parent.tag.name === "css" || parent && parent.type === "TaggedTemplateExpression" && parent.tag.type === "MemberExpression" && parent.tag.object.name === "css" && (parent.tag.property.name === "global" || parent.tag.property.name === "resolve");
        }
        function isAngularComponentStyles(path4) {
          return path4.match((node) => node.type === "TemplateLiteral", (node, name) => node.type === "ArrayExpression" && name === "elements", (node, name) => isObjectProperty(node) && node.key.type === "Identifier" && node.key.name === "styles" && name === "value", ...angularComponentObjectExpressionPredicates);
        }
        function isAngularComponentTemplate(path4) {
          return path4.match((node) => node.type === "TemplateLiteral", (node, name) => isObjectProperty(node) && node.key.type === "Identifier" && node.key.name === "template" && name === "value", ...angularComponentObjectExpressionPredicates);
        }
        var angularComponentObjectExpressionPredicates = [(node, name) => node.type === "ObjectExpression" && name === "properties", (node, name) => node.type === "CallExpression" && node.callee.type === "Identifier" && node.callee.name === "Component" && name === "arguments", (node, name) => node.type === "Decorator" && name === "expression"];
        function isStyledComponents(path4) {
          const parent = path4.getParentNode();
          if (!parent || parent.type !== "TaggedTemplateExpression") {
            return false;
          }
          const tag = parent.tag.type === "ParenthesizedExpression" ? parent.tag.expression : parent.tag;
          switch (tag.type) {
            case "MemberExpression":
              return isStyledIdentifier(tag.object) || isStyledExtend(tag);
            case "CallExpression":
              return isStyledIdentifier(tag.callee) || tag.callee.type === "MemberExpression" && (tag.callee.object.type === "MemberExpression" && (isStyledIdentifier(tag.callee.object.object) || isStyledExtend(tag.callee.object)) || tag.callee.object.type === "CallExpression" && isStyledIdentifier(tag.callee.object.callee));
            case "Identifier":
              return tag.name === "css";
            default:
              return false;
          }
        }
        function isCssProp(path4) {
          const parent = path4.getParentNode();
          const parentParent = path4.getParentNode(1);
          return parentParent && parent.type === "JSXExpressionContainer" && parentParent.type === "JSXAttribute" && parentParent.name.type === "JSXIdentifier" && parentParent.name.name === "css";
        }
        function isStyledIdentifier(node) {
          return node.type === "Identifier" && node.name === "styled";
        }
        function isStyledExtend(node) {
          return /^[A-Z]/.test(node.object.name) && node.property.name === "extend";
        }
        function isGraphQL(path4) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          return hasLanguageComment(node, "GraphQL") || parent && (parent.type === "TaggedTemplateExpression" && (parent.tag.type === "MemberExpression" && parent.tag.object.name === "graphql" && parent.tag.property.name === "experimental" || parent.tag.type === "Identifier" && (parent.tag.name === "gql" || parent.tag.name === "graphql")) || parent.type === "CallExpression" && parent.callee.type === "Identifier" && parent.callee.name === "graphql");
        }
        function hasLanguageComment(node, languageName) {
          return hasComment(node, CommentCheckFlags.Block | CommentCheckFlags.Leading, ({
            value
          }) => value === ` ${languageName} `);
        }
        function isHtml(path4) {
          return hasLanguageComment(path4.getValue(), "HTML") || path4.match((node) => node.type === "TemplateLiteral", (node, name) => node.type === "TaggedTemplateExpression" && node.tag.type === "Identifier" && node.tag.name === "html" && name === "quasi");
        }
        function hasInvalidCookedValue({
          quasis
        }) {
          return quasis.some(({
            value: {
              cooked
            }
          }) => cooked === null);
        }
        module22.exports = embed;
      }
    });
    var require_clean2 = __commonJS22({
      "src/language-js/clean.js"(exports2, module22) {
        "use strict";
        var isBlockComment = require_is_block_comment();
        var ignoredProperties = /* @__PURE__ */ new Set(["range", "raw", "comments", "leadingComments", "trailingComments", "innerComments", "extra", "start", "end", "loc", "flags", "errors", "tokens"]);
        var removeTemplateElementsValue = (node) => {
          for (const templateElement of node.quasis) {
            delete templateElement.value;
          }
        };
        function clean(ast, newObj, parent) {
          if (ast.type === "Program") {
            delete newObj.sourceType;
          }
          if (ast.type === "BigIntLiteral" || ast.type === "BigIntLiteralTypeAnnotation") {
            if (newObj.value) {
              newObj.value = newObj.value.toLowerCase();
            }
          }
          if (ast.type === "BigIntLiteral" || ast.type === "Literal") {
            if (newObj.bigint) {
              newObj.bigint = newObj.bigint.toLowerCase();
            }
          }
          if (ast.type === "DecimalLiteral") {
            newObj.value = Number(newObj.value);
          }
          if (ast.type === "Literal" && newObj.decimal) {
            newObj.decimal = Number(newObj.decimal);
          }
          if (ast.type === "EmptyStatement") {
            return null;
          }
          if (ast.type === "JSXText") {
            return null;
          }
          if (ast.type === "JSXExpressionContainer" && (ast.expression.type === "Literal" || ast.expression.type === "StringLiteral") && ast.expression.value === " ") {
            return null;
          }
          if ((ast.type === "Property" || ast.type === "ObjectProperty" || ast.type === "MethodDefinition" || ast.type === "ClassProperty" || ast.type === "ClassMethod" || ast.type === "PropertyDefinition" || ast.type === "TSDeclareMethod" || ast.type === "TSPropertySignature" || ast.type === "ObjectTypeProperty") && typeof ast.key === "object" && ast.key && (ast.key.type === "Literal" || ast.key.type === "NumericLiteral" || ast.key.type === "StringLiteral" || ast.key.type === "Identifier")) {
            delete newObj.key;
          }
          if (ast.type === "JSXElement" && ast.openingElement.name.name === "style" && ast.openingElement.attributes.some((attr) => attr.name.name === "jsx")) {
            for (const {
              type,
              expression: expression2
            } of newObj.children) {
              if (type === "JSXExpressionContainer" && expression2.type === "TemplateLiteral") {
                removeTemplateElementsValue(expression2);
              }
            }
          }
          if (ast.type === "JSXAttribute" && ast.name.name === "css" && ast.value.type === "JSXExpressionContainer" && ast.value.expression.type === "TemplateLiteral") {
            removeTemplateElementsValue(newObj.value.expression);
          }
          if (ast.type === "JSXAttribute" && ast.value && ast.value.type === "Literal" && /["']|&quot;|&apos;/.test(ast.value.value)) {
            newObj.value.value = newObj.value.value.replace(/["']|&quot;|&apos;/g, '"');
          }
          const expression = ast.expression || ast.callee;
          if (ast.type === "Decorator" && expression.type === "CallExpression" && expression.callee.name === "Component" && expression.arguments.length === 1) {
            const astProps = ast.expression.arguments[0].properties;
            for (const [index, prop] of newObj.expression.arguments[0].properties.entries()) {
              switch (astProps[index].key.name) {
                case "styles":
                  if (prop.value.type === "ArrayExpression") {
                    removeTemplateElementsValue(prop.value.elements[0]);
                  }
                  break;
                case "template":
                  if (prop.value.type === "TemplateLiteral") {
                    removeTemplateElementsValue(prop.value);
                  }
                  break;
              }
            }
          }
          if (ast.type === "TaggedTemplateExpression" && (ast.tag.type === "MemberExpression" || ast.tag.type === "Identifier" && (ast.tag.name === "gql" || ast.tag.name === "graphql" || ast.tag.name === "css" || ast.tag.name === "md" || ast.tag.name === "markdown" || ast.tag.name === "html") || ast.tag.type === "CallExpression")) {
            removeTemplateElementsValue(newObj.quasi);
          }
          if (ast.type === "TemplateLiteral") {
            var _ast$leadingComments;
            const hasLanguageComment = (_ast$leadingComments = ast.leadingComments) === null || _ast$leadingComments === void 0 ? void 0 : _ast$leadingComments.some((comment) => isBlockComment(comment) && ["GraphQL", "HTML"].some((languageName) => comment.value === ` ${languageName} `));
            if (hasLanguageComment || parent.type === "CallExpression" && parent.callee.name === "graphql" || !ast.leadingComments) {
              removeTemplateElementsValue(newObj);
            }
          }
          if (ast.type === "InterpreterDirective") {
            newObj.value = newObj.value.trimEnd();
          }
          if ((ast.type === "TSIntersectionType" || ast.type === "TSUnionType") && ast.types.length === 1) {
            return newObj.types[0];
          }
        }
        clean.ignoredProperties = ignoredProperties;
        module22.exports = clean;
      }
    });
    var require_detect_newline = __commonJS22({
      "node_modules/detect-newline/index.js"(exports2, module22) {
        "use strict";
        var detectNewline = (string) => {
          if (typeof string !== "string") {
            throw new TypeError("Expected a string");
          }
          const newlines = string.match(/(?:\r?\n)/g) || [];
          if (newlines.length === 0) {
            return;
          }
          const crlf = newlines.filter((newline) => newline === "\r\n").length;
          const lf = newlines.length - crlf;
          return crlf > lf ? "\r\n" : "\n";
        };
        module22.exports = detectNewline;
        module22.exports.graceful = (string) => typeof string === "string" && detectNewline(string) || "\n";
      }
    });
    var require_build = __commonJS22({
      "node_modules/jest-docblock/build/index.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.extract = extract;
        exports2.parse = parse3;
        exports2.parseWithComments = parseWithComments;
        exports2.print = print;
        exports2.strip = strip;
        function _os() {
          const data = require("os");
          _os = function() {
            return data;
          };
          return data;
        }
        function _detectNewline() {
          const data = _interopRequireDefault(require_detect_newline());
          _detectNewline = function() {
            return data;
          };
          return data;
        }
        function _interopRequireDefault(obj) {
          return obj && obj.__esModule ? obj : {
            default: obj
          };
        }
        var commentEndRe = /\*\/$/;
        var commentStartRe = /^\/\*\*/;
        var docblockRe = /^\s*(\/\*\*?(.|\r?\n)*?\*\/)/;
        var lineCommentRe = /(^|\s+)\/\/([^\r\n]*)/g;
        var ltrimNewlineRe = /^(\r?\n)+/;
        var multilineRe = /(?:^|\r?\n) *(@[^\r\n]*?) *\r?\n *(?![^@\r\n]*\/\/[^]*)([^@\r\n\s][^@\r\n]+?) *\r?\n/g;
        var propertyRe = /(?:^|\r?\n) *@(\S+) *([^\r\n]*)/g;
        var stringStartRe = /(\r?\n|^) *\* ?/g;
        var STRING_ARRAY = [];
        function extract(contents) {
          const match = contents.match(docblockRe);
          return match ? match[0].trimLeft() : "";
        }
        function strip(contents) {
          const match = contents.match(docblockRe);
          return match && match[0] ? contents.substring(match[0].length) : contents;
        }
        function parse3(docblock) {
          return parseWithComments(docblock).pragmas;
        }
        function parseWithComments(docblock) {
          const line = (0, _detectNewline().default)(docblock) || _os().EOL;
          docblock = docblock.replace(commentStartRe, "").replace(commentEndRe, "").replace(stringStartRe, "$1");
          let prev = "";
          while (prev !== docblock) {
            prev = docblock;
            docblock = docblock.replace(multilineRe, `${line}$1 $2${line}`);
          }
          docblock = docblock.replace(ltrimNewlineRe, "").trimRight();
          const result = /* @__PURE__ */ Object.create(null);
          const comments = docblock.replace(propertyRe, "").replace(ltrimNewlineRe, "").trimRight();
          let match;
          while (match = propertyRe.exec(docblock)) {
            const nextPragma = match[2].replace(lineCommentRe, "");
            if (typeof result[match[1]] === "string" || Array.isArray(result[match[1]])) {
              result[match[1]] = STRING_ARRAY.concat(result[match[1]], nextPragma);
            } else {
              result[match[1]] = nextPragma;
            }
          }
          return {
            comments,
            pragmas: result
          };
        }
        function print({
          comments = "",
          pragmas = {}
        }) {
          const line = (0, _detectNewline().default)(comments) || _os().EOL;
          const head = "/**";
          const start = " *";
          const tail = " */";
          const keys = Object.keys(pragmas);
          const printedObject = keys.map((key) => printKeyValues(key, pragmas[key])).reduce((arr, next) => arr.concat(next), []).map((keyValue) => start + " " + keyValue + line).join("");
          if (!comments) {
            if (keys.length === 0) {
              return "";
            }
            if (keys.length === 1 && !Array.isArray(pragmas[keys[0]])) {
              const value = pragmas[keys[0]];
              return `${head} ${printKeyValues(keys[0], value)[0]}${tail}`;
            }
          }
          const printedComments = comments.split(line).map((textLine) => `${start} ${textLine}`).join(line) + line;
          return head + line + (comments ? printedComments : "") + (comments && keys.length ? start + line : "") + printedObject + tail;
        }
        function printKeyValues(key, valueOrArray) {
          return STRING_ARRAY.concat(valueOrArray).map((value) => `@${key} ${value}`.trim());
        }
      }
    });
    var require_get_shebang = __commonJS22({
      "src/language-js/utils/get-shebang.js"(exports2, module22) {
        "use strict";
        function getShebang(text) {
          if (!text.startsWith("#!")) {
            return "";
          }
          const index = text.indexOf("\n");
          if (index === -1) {
            return text;
          }
          return text.slice(0, index);
        }
        module22.exports = getShebang;
      }
    });
    var require_pragma = __commonJS22({
      "src/language-js/pragma.js"(exports2, module22) {
        "use strict";
        var {
          parseWithComments,
          strip,
          extract,
          print
        } = require_build();
        var {
          normalizeEndOfLine
        } = require_end_of_line();
        var getShebang = require_get_shebang();
        function parseDocBlock(text) {
          const shebang = getShebang(text);
          if (shebang) {
            text = text.slice(shebang.length + 1);
          }
          const docBlock = extract(text);
          const {
            pragmas,
            comments
          } = parseWithComments(docBlock);
          return {
            shebang,
            text,
            pragmas,
            comments
          };
        }
        function hasPragma(text) {
          const pragmas = Object.keys(parseDocBlock(text).pragmas);
          return pragmas.includes("prettier") || pragmas.includes("format");
        }
        function insertPragma(originalText) {
          const {
            shebang,
            text,
            pragmas,
            comments
          } = parseDocBlock(originalText);
          const strippedText = strip(text);
          const docBlock = print({
            pragmas: Object.assign({
              format: ""
            }, pragmas),
            comments: comments.trimStart()
          });
          return (shebang ? `${shebang}
` : "") + normalizeEndOfLine(docBlock) + (strippedText.startsWith("\n") ? "\n" : "\n\n") + strippedText;
        }
        module22.exports = {
          hasPragma,
          insertPragma
        };
      }
    });
    var require_comments2 = __commonJS22({
      "src/language-js/comments.js"(exports2, module22) {
        "use strict";
        var {
          getLast,
          hasNewline,
          getNextNonSpaceNonCommentCharacterIndexWithStartIndex,
          getNextNonSpaceNonCommentCharacter,
          hasNewlineInRange,
          addLeadingComment,
          addTrailingComment,
          addDanglingComment,
          getNextNonSpaceNonCommentCharacterIndex,
          isNonEmptyArray
        } = require_util();
        var {
          getFunctionParameters,
          isPrettierIgnoreComment,
          isJsxNode,
          hasFlowShorthandAnnotationComment,
          hasFlowAnnotationComment,
          hasIgnoreComment,
          isCallLikeExpression,
          getCallArguments,
          isCallExpression,
          isMemberExpression,
          isObjectProperty,
          isLineComment,
          getComments,
          CommentCheckFlags,
          markerForIfWithoutBlockAndSameLineComment
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        function handleOwnLineComment(context2) {
          return [handleIgnoreComments, handleLastFunctionArgComments, handleMemberExpressionComments, handleIfStatementComments, handleWhileComments, handleTryStatementComments, handleClassComments, handleForComments, handleUnionTypeComments, handleOnlyComments, handleModuleSpecifiersComments, handleAssignmentPatternComments, handleMethodNameComments, handleLabeledStatementComments, handleBreakAndContinueStatementComments].some((fn) => fn(context2));
        }
        function handleEndOfLineComment(context2) {
          return [handleClosureTypeCastComments, handleLastFunctionArgComments, handleConditionalExpressionComments, handleModuleSpecifiersComments, handleIfStatementComments, handleWhileComments, handleTryStatementComments, handleClassComments, handleLabeledStatementComments, handleCallExpressionComments, handlePropertyComments, handleOnlyComments, handleVariableDeclaratorComments, handleBreakAndContinueStatementComments, handleSwitchDefaultCaseComments].some((fn) => fn(context2));
        }
        function handleRemainingComment(context2) {
          return [handleIgnoreComments, handleIfStatementComments, handleWhileComments, handleObjectPropertyAssignment, handleCommentInEmptyParens, handleMethodNameComments, handleOnlyComments, handleCommentAfterArrowParams, handleFunctionNameComments, handleTSMappedTypeComments, handleBreakAndContinueStatementComments, handleTSFunctionTrailingComments].some((fn) => fn(context2));
        }
        function addBlockStatementFirstComment(node, comment) {
          const firstNonEmptyNode = (node.body || node.properties).find(({
            type
          }) => type !== "EmptyStatement");
          if (firstNonEmptyNode) {
            addLeadingComment(firstNonEmptyNode, comment);
          } else {
            addDanglingComment(node, comment);
          }
        }
        function addBlockOrNotComment(node, comment) {
          if (node.type === "BlockStatement") {
            addBlockStatementFirstComment(node, comment);
          } else {
            addLeadingComment(node, comment);
          }
        }
        function handleClosureTypeCastComments({
          comment,
          followingNode
        }) {
          if (followingNode && isTypeCastComment(comment)) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleIfStatementComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode,
          text
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "IfStatement" || !followingNode) {
            return false;
          }
          const nextCharacter = getNextNonSpaceNonCommentCharacter(text, comment, locEnd);
          if (nextCharacter === ")") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if (precedingNode === enclosingNode.consequent && followingNode === enclosingNode.alternate) {
            if (precedingNode.type === "BlockStatement") {
              addTrailingComment(precedingNode, comment);
            } else {
              const isSingleLineComment = comment.type === "SingleLine" || comment.loc.start.line === comment.loc.end.line;
              const isSameLineComment = comment.loc.start.line === precedingNode.loc.start.line;
              if (isSingleLineComment && isSameLineComment) {
                addDanglingComment(precedingNode, comment, markerForIfWithoutBlockAndSameLineComment);
              } else {
                addDanglingComment(enclosingNode, comment);
              }
            }
            return true;
          }
          if (followingNode.type === "BlockStatement") {
            addBlockStatementFirstComment(followingNode, comment);
            return true;
          }
          if (followingNode.type === "IfStatement") {
            addBlockOrNotComment(followingNode.consequent, comment);
            return true;
          }
          if (enclosingNode.consequent === followingNode) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleWhileComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode,
          text
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "WhileStatement" || !followingNode) {
            return false;
          }
          const nextCharacter = getNextNonSpaceNonCommentCharacter(text, comment, locEnd);
          if (nextCharacter === ")") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if (followingNode.type === "BlockStatement") {
            addBlockStatementFirstComment(followingNode, comment);
            return true;
          }
          if (enclosingNode.body === followingNode) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleTryStatementComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "TryStatement" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "CatchClause" || !followingNode) {
            return false;
          }
          if (enclosingNode.type === "CatchClause" && precedingNode) {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if (followingNode.type === "BlockStatement") {
            addBlockStatementFirstComment(followingNode, comment);
            return true;
          }
          if (followingNode.type === "TryStatement") {
            addBlockOrNotComment(followingNode.finalizer, comment);
            return true;
          }
          if (followingNode.type === "CatchClause") {
            addBlockOrNotComment(followingNode.body, comment);
            return true;
          }
          return false;
        }
        function handleMemberExpressionComments({
          comment,
          enclosingNode,
          followingNode
        }) {
          if (isMemberExpression(enclosingNode) && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "Identifier") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleConditionalExpressionComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode,
          text
        }) {
          const isSameLineAsPrecedingNode = precedingNode && !hasNewlineInRange(text, locEnd(precedingNode), locStart(comment));
          if ((!precedingNode || !isSameLineAsPrecedingNode) && ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ConditionalExpression" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSConditionalType") && followingNode) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleObjectPropertyAssignment({
          comment,
          precedingNode,
          enclosingNode
        }) {
          if (isObjectProperty(enclosingNode) && enclosingNode.shorthand && enclosingNode.key === precedingNode && enclosingNode.value.type === "AssignmentPattern") {
            addTrailingComment(enclosingNode.value.left, comment);
            return true;
          }
          return false;
        }
        var classLikeNodeTypes = /* @__PURE__ */ new Set(["ClassDeclaration", "ClassExpression", "DeclareClass", "DeclareInterface", "InterfaceDeclaration", "TSInterfaceDeclaration"]);
        function handleClassComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode
        }) {
          if (classLikeNodeTypes.has(enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type)) {
            if (isNonEmptyArray(enclosingNode.decorators) && !(followingNode && followingNode.type === "Decorator")) {
              addTrailingComment(getLast(enclosingNode.decorators), comment);
              return true;
            }
            if (enclosingNode.body && followingNode === enclosingNode.body) {
              addBlockStatementFirstComment(enclosingNode.body, comment);
              return true;
            }
            if (followingNode) {
              if (enclosingNode.superClass && followingNode === enclosingNode.superClass && precedingNode && (precedingNode === enclosingNode.id || precedingNode === enclosingNode.typeParameters)) {
                addTrailingComment(precedingNode, comment);
                return true;
              }
              for (const prop of ["implements", "extends", "mixins"]) {
                if (enclosingNode[prop] && followingNode === enclosingNode[prop][0]) {
                  if (precedingNode && (precedingNode === enclosingNode.id || precedingNode === enclosingNode.typeParameters || precedingNode === enclosingNode.superClass)) {
                    addTrailingComment(precedingNode, comment);
                  } else {
                    addDanglingComment(enclosingNode, comment, prop);
                  }
                  return true;
                }
              }
            }
          }
          return false;
        }
        var propertyLikeNodeTypes = /* @__PURE__ */ new Set(["ClassMethod", "ClassProperty", "PropertyDefinition", "TSAbstractPropertyDefinition", "TSAbstractMethodDefinition", "TSDeclareMethod", "MethodDefinition"]);
        function handleMethodNameComments({
          comment,
          precedingNode,
          enclosingNode,
          text
        }) {
          if (enclosingNode && precedingNode && getNextNonSpaceNonCommentCharacter(text, comment, locEnd) === "(" && (enclosingNode.type === "Property" || enclosingNode.type === "TSDeclareMethod" || enclosingNode.type === "TSAbstractMethodDefinition") && precedingNode.type === "Identifier" && enclosingNode.key === precedingNode && getNextNonSpaceNonCommentCharacter(text, precedingNode, locEnd) !== ":") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if ((precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "Decorator" && propertyLikeNodeTypes.has(enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type)) {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          return false;
        }
        var functionLikeNodeTypes = /* @__PURE__ */ new Set(["FunctionDeclaration", "FunctionExpression", "ClassMethod", "MethodDefinition", "ObjectMethod"]);
        function handleFunctionNameComments({
          comment,
          precedingNode,
          enclosingNode,
          text
        }) {
          if (getNextNonSpaceNonCommentCharacter(text, comment, locEnd) !== "(") {
            return false;
          }
          if (precedingNode && functionLikeNodeTypes.has(enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type)) {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          return false;
        }
        function handleCommentAfterArrowParams({
          comment,
          enclosingNode,
          text
        }) {
          if (!((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ArrowFunctionExpression")) {
            return false;
          }
          const index = getNextNonSpaceNonCommentCharacterIndex(text, comment, locEnd);
          if (index !== false && text.slice(index, index + 2) === "=>") {
            addDanglingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleCommentInEmptyParens({
          comment,
          enclosingNode,
          text
        }) {
          if (getNextNonSpaceNonCommentCharacter(text, comment, locEnd) !== ")") {
            return false;
          }
          if (enclosingNode && (isRealFunctionLikeNode(enclosingNode) && getFunctionParameters(enclosingNode).length === 0 || isCallLikeExpression(enclosingNode) && getCallArguments(enclosingNode).length === 0)) {
            addDanglingComment(enclosingNode, comment);
            return true;
          }
          if (((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "MethodDefinition" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSAbstractMethodDefinition") && getFunctionParameters(enclosingNode.value).length === 0) {
            addDanglingComment(enclosingNode.value, comment);
            return true;
          }
          return false;
        }
        function handleLastFunctionArgComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode,
          text
        }) {
          if ((precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "FunctionTypeParam" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "FunctionTypeAnnotation" && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) !== "FunctionTypeParam") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if (((precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "Identifier" || (precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "AssignmentPattern") && enclosingNode && isRealFunctionLikeNode(enclosingNode) && getNextNonSpaceNonCommentCharacter(text, comment, locEnd) === ")") {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "FunctionDeclaration" && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "BlockStatement") {
            const functionParamRightParenIndex = (() => {
              const parameters = getFunctionParameters(enclosingNode);
              if (parameters.length > 0) {
                return getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, locEnd(getLast(parameters)));
              }
              const functionParamLeftParenIndex = getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, locEnd(enclosingNode.id));
              return functionParamLeftParenIndex !== false && getNextNonSpaceNonCommentCharacterIndexWithStartIndex(text, functionParamLeftParenIndex + 1);
            })();
            if (locStart(comment) > functionParamRightParenIndex) {
              addBlockStatementFirstComment(followingNode, comment);
              return true;
            }
          }
          return false;
        }
        function handleLabeledStatementComments({
          comment,
          enclosingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "LabeledStatement") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleBreakAndContinueStatementComments({
          comment,
          enclosingNode
        }) {
          if (((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ContinueStatement" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "BreakStatement") && !enclosingNode.label) {
            addTrailingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleCallExpressionComments({
          comment,
          precedingNode,
          enclosingNode
        }) {
          if (isCallExpression(enclosingNode) && precedingNode && enclosingNode.callee === precedingNode && enclosingNode.arguments.length > 0) {
            addLeadingComment(enclosingNode.arguments[0], comment);
            return true;
          }
          return false;
        }
        function handleUnionTypeComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "UnionTypeAnnotation" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSUnionType") {
            if (isPrettierIgnoreComment(comment)) {
              followingNode.prettierIgnore = true;
              comment.unignore = true;
            }
            if (precedingNode) {
              addTrailingComment(precedingNode, comment);
              return true;
            }
            return false;
          }
          if (((followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "UnionTypeAnnotation" || (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "TSUnionType") && isPrettierIgnoreComment(comment)) {
            followingNode.types[0].prettierIgnore = true;
            comment.unignore = true;
          }
          return false;
        }
        function handlePropertyComments({
          comment,
          enclosingNode
        }) {
          if (isObjectProperty(enclosingNode)) {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleOnlyComments({
          comment,
          enclosingNode,
          followingNode,
          ast,
          isLastComment
        }) {
          if (ast && ast.body && ast.body.length === 0) {
            if (isLastComment) {
              addDanglingComment(ast, comment);
            } else {
              addLeadingComment(ast, comment);
            }
            return true;
          }
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "Program" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.body.length) === 0 && !isNonEmptyArray(enclosingNode.directives)) {
            if (isLastComment) {
              addDanglingComment(enclosingNode, comment);
            } else {
              addLeadingComment(enclosingNode, comment);
            }
            return true;
          }
          if ((followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "Program" && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.body.length) === 0 && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ModuleExpression") {
            addDanglingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleForComments({
          comment,
          enclosingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ForInStatement" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ForOfStatement") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleModuleSpecifiersComments({
          comment,
          precedingNode,
          enclosingNode,
          text
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ImportSpecifier" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ExportSpecifier") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          const isImportDeclaration = (precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "ImportSpecifier" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ImportDeclaration";
          const isExportDeclaration = (precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "ExportSpecifier" && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "ExportNamedDeclaration";
          if ((isImportDeclaration || isExportDeclaration) && hasNewline(text, locEnd(comment))) {
            addTrailingComment(precedingNode, comment);
            return true;
          }
          return false;
        }
        function handleAssignmentPatternComments({
          comment,
          enclosingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "AssignmentPattern") {
            addLeadingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        var assignmentLikeNodeTypes = /* @__PURE__ */ new Set(["VariableDeclarator", "AssignmentExpression", "TypeAlias", "TSTypeAliasDeclaration"]);
        var complexExprNodeTypes = /* @__PURE__ */ new Set(["ObjectExpression", "ArrayExpression", "TemplateLiteral", "TaggedTemplateExpression", "ObjectTypeAnnotation", "TSTypeLiteral"]);
        function handleVariableDeclaratorComments({
          comment,
          enclosingNode,
          followingNode
        }) {
          if (assignmentLikeNodeTypes.has(enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) && followingNode && (complexExprNodeTypes.has(followingNode.type) || isBlockComment(comment))) {
            addLeadingComment(followingNode, comment);
            return true;
          }
          return false;
        }
        function handleTSFunctionTrailingComments({
          comment,
          enclosingNode,
          followingNode,
          text
        }) {
          if (!followingNode && ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSMethodSignature" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSDeclareFunction" || (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSAbstractMethodDefinition") && getNextNonSpaceNonCommentCharacter(text, comment, locEnd) === ";") {
            addTrailingComment(enclosingNode, comment);
            return true;
          }
          return false;
        }
        function handleIgnoreComments({
          comment,
          enclosingNode,
          followingNode
        }) {
          if (isPrettierIgnoreComment(comment) && (enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) === "TSMappedType" && (followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "TSTypeParameter" && followingNode.constraint) {
            enclosingNode.prettierIgnore = true;
            comment.unignore = true;
            return true;
          }
        }
        function handleTSMappedTypeComments({
          comment,
          precedingNode,
          enclosingNode,
          followingNode
        }) {
          if ((enclosingNode === null || enclosingNode === void 0 ? void 0 : enclosingNode.type) !== "TSMappedType") {
            return false;
          }
          if ((followingNode === null || followingNode === void 0 ? void 0 : followingNode.type) === "TSTypeParameter" && followingNode.name) {
            addLeadingComment(followingNode.name, comment);
            return true;
          }
          if ((precedingNode === null || precedingNode === void 0 ? void 0 : precedingNode.type) === "TSTypeParameter" && precedingNode.constraint) {
            addTrailingComment(precedingNode.constraint, comment);
            return true;
          }
          return false;
        }
        function handleSwitchDefaultCaseComments({
          comment,
          enclosingNode,
          followingNode
        }) {
          if (!enclosingNode || enclosingNode.type !== "SwitchCase" || enclosingNode.test) {
            return false;
          }
          if (followingNode.type === "BlockStatement" && isLineComment(comment)) {
            addBlockStatementFirstComment(followingNode, comment);
          } else {
            addDanglingComment(enclosingNode, comment);
          }
          return true;
        }
        function isRealFunctionLikeNode(node) {
          return node.type === "ArrowFunctionExpression" || node.type === "FunctionExpression" || node.type === "FunctionDeclaration" || node.type === "ObjectMethod" || node.type === "ClassMethod" || node.type === "TSDeclareFunction" || node.type === "TSCallSignatureDeclaration" || node.type === "TSConstructSignatureDeclaration" || node.type === "TSMethodSignature" || node.type === "TSConstructorType" || node.type === "TSFunctionType" || node.type === "TSDeclareMethod";
        }
        function getCommentChildNodes(node, options) {
          if ((options.parser === "typescript" || options.parser === "flow" || options.parser === "acorn" || options.parser === "espree" || options.parser === "meriyah" || options.parser === "__babel_estree") && node.type === "MethodDefinition" && node.value && node.value.type === "FunctionExpression" && getFunctionParameters(node.value).length === 0 && !node.value.returnType && !isNonEmptyArray(node.value.typeParameters) && node.value.body) {
            return [...node.decorators || [], node.key, node.value.body];
          }
        }
        function isTypeCastComment(comment) {
          return isBlockComment(comment) && comment.value[0] === "*" && /@type\b/.test(comment.value);
        }
        function willPrintOwnComments(path4) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          const hasFlowAnnotations = (node2) => hasFlowAnnotationComment(getComments(node2, CommentCheckFlags.Leading)) || hasFlowAnnotationComment(getComments(node2, CommentCheckFlags.Trailing));
          return (node && (isJsxNode(node) || hasFlowShorthandAnnotationComment(node) || isCallExpression(parent) && hasFlowAnnotations(node)) || parent && (parent.type === "JSXSpreadAttribute" || parent.type === "JSXSpreadChild" || parent.type === "UnionTypeAnnotation" || parent.type === "TSUnionType" || (parent.type === "ClassDeclaration" || parent.type === "ClassExpression") && parent.superClass === node)) && (!hasIgnoreComment(path4) || parent.type === "UnionTypeAnnotation" || parent.type === "TSUnionType");
        }
        module22.exports = {
          handleOwnLineComment,
          handleEndOfLineComment,
          handleRemainingComment,
          isTypeCastComment,
          getCommentChildNodes,
          willPrintOwnComments
        };
      }
    });
    var require_needs_parens = __commonJS22({
      "src/language-js/needs-parens.js"(exports2, module22) {
        "use strict";
        var getLast = require_get_last();
        var isNonEmptyArray = require_is_non_empty_array();
        var {
          getFunctionParameters,
          getLeftSidePathName,
          hasFlowShorthandAnnotationComment,
          hasNakedLeftSide,
          hasNode,
          isBitwiseOperator,
          startsWithNoLookaheadToken,
          shouldFlatten,
          getPrecedence,
          isCallExpression,
          isMemberExpression,
          isObjectProperty
        } = require_utils72();
        function needsParens(path4, options) {
          const parent = path4.getParentNode();
          if (!parent) {
            return false;
          }
          const name = path4.getName();
          const node = path4.getNode();
          if (options.__isInHtmlInterpolation && !options.bracketSpacing && endsWithRightBracket(node) && isFollowedByRightBracket(path4)) {
            return true;
          }
          if (isStatement(node)) {
            return false;
          }
          if (options.parser !== "flow" && hasFlowShorthandAnnotationComment(path4.getValue())) {
            return true;
          }
          if (node.type === "Identifier") {
            if (node.extra && node.extra.parenthesized && /^PRETTIER_HTML_PLACEHOLDER_\d+_\d+_IN_JS$/.test(node.name)) {
              return true;
            }
            if (name === "left" && node.name === "async" && parent.type === "ForOfStatement" && !parent.await) {
              return true;
            }
            return false;
          }
          switch (parent.type) {
            case "ParenthesizedExpression":
              return false;
            case "ClassDeclaration":
            case "ClassExpression": {
              if (name === "superClass" && (node.type === "ArrowFunctionExpression" || node.type === "AssignmentExpression" || node.type === "AwaitExpression" || node.type === "BinaryExpression" || node.type === "ConditionalExpression" || node.type === "LogicalExpression" || node.type === "NewExpression" || node.type === "ObjectExpression" || node.type === "SequenceExpression" || node.type === "TaggedTemplateExpression" || node.type === "UnaryExpression" || node.type === "UpdateExpression" || node.type === "YieldExpression" || node.type === "TSNonNullExpression")) {
                return true;
              }
              break;
            }
            case "ExportDefaultDeclaration": {
              return shouldWrapFunctionForExportDefault(path4, options) || node.type === "SequenceExpression";
            }
            case "Decorator": {
              if (name === "expression") {
                let hasCallExpression = false;
                let hasMemberExpression = false;
                let current = node;
                while (current) {
                  switch (current.type) {
                    case "MemberExpression":
                      hasMemberExpression = true;
                      current = current.object;
                      break;
                    case "CallExpression":
                      if (hasMemberExpression || hasCallExpression) {
                        return options.parser !== "typescript";
                      }
                      hasCallExpression = true;
                      current = current.callee;
                      break;
                    case "Identifier":
                      return false;
                    case "TaggedTemplateExpression":
                      return options.parser !== "typescript";
                    default:
                      return true;
                  }
                }
                return true;
              }
              break;
            }
            case "ExpressionStatement": {
              if (startsWithNoLookaheadToken(node, true)) {
                return true;
              }
              break;
            }
            case "ArrowFunctionExpression": {
              if (name === "body" && node.type !== "SequenceExpression" && startsWithNoLookaheadToken(node, false)) {
                return true;
              }
              break;
            }
          }
          switch (node.type) {
            case "UpdateExpression":
              if (parent.type === "UnaryExpression") {
                return node.prefix && (node.operator === "++" && parent.operator === "+" || node.operator === "--" && parent.operator === "-");
              }
            case "UnaryExpression":
              switch (parent.type) {
                case "UnaryExpression":
                  return node.operator === parent.operator && (node.operator === "+" || node.operator === "-");
                case "BindExpression":
                  return true;
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                case "TaggedTemplateExpression":
                  return true;
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "BinaryExpression":
                  return name === "left" && parent.operator === "**";
                case "TSNonNullExpression":
                  return true;
                default:
                  return false;
              }
            case "BinaryExpression": {
              if (parent.type === "UpdateExpression") {
                return true;
              }
              if (node.operator === "in" && isPathInForStatementInitializer(path4)) {
                return true;
              }
              if (node.operator === "|>" && node.extra && node.extra.parenthesized) {
                const grandParent = path4.getParentNode(1);
                if (grandParent.type === "BinaryExpression" && grandParent.operator === "|>") {
                  return true;
                }
              }
            }
            case "TSTypeAssertion":
            case "TSAsExpression":
            case "LogicalExpression":
              switch (parent.type) {
                case "TSAsExpression":
                  return node.type !== "TSAsExpression";
                case "ConditionalExpression":
                  return node.type === "TSAsExpression";
                case "CallExpression":
                case "NewExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "ClassExpression":
                case "ClassDeclaration":
                  return name === "superClass";
                case "TSTypeAssertion":
                case "TaggedTemplateExpression":
                case "UnaryExpression":
                case "JSXSpreadAttribute":
                case "SpreadElement":
                case "SpreadProperty":
                case "BindExpression":
                case "AwaitExpression":
                case "TSNonNullExpression":
                case "UpdateExpression":
                  return true;
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                case "AssignmentExpression":
                case "AssignmentPattern":
                  return name === "left" && (node.type === "TSTypeAssertion" || node.type === "TSAsExpression");
                case "LogicalExpression":
                  if (node.type === "LogicalExpression") {
                    return parent.operator !== node.operator;
                  }
                case "BinaryExpression": {
                  const {
                    operator,
                    type
                  } = node;
                  if (!operator && type !== "TSTypeAssertion") {
                    return true;
                  }
                  const precedence = getPrecedence(operator);
                  const parentOperator = parent.operator;
                  const parentPrecedence = getPrecedence(parentOperator);
                  if (parentPrecedence > precedence) {
                    return true;
                  }
                  if (name === "right" && parentPrecedence === precedence) {
                    return true;
                  }
                  if (parentPrecedence === precedence && !shouldFlatten(parentOperator, operator)) {
                    return true;
                  }
                  if (parentPrecedence < precedence && operator === "%") {
                    return parentOperator === "+" || parentOperator === "-";
                  }
                  if (isBitwiseOperator(parentOperator)) {
                    return true;
                  }
                  return false;
                }
                default:
                  return false;
              }
            case "SequenceExpression":
              switch (parent.type) {
                case "ReturnStatement":
                  return false;
                case "ForStatement":
                  return false;
                case "ExpressionStatement":
                  return name !== "expression";
                case "ArrowFunctionExpression":
                  return name !== "body";
                default:
                  return true;
              }
            case "YieldExpression":
              if (parent.type === "UnaryExpression" || parent.type === "AwaitExpression" || parent.type === "TSAsExpression" || parent.type === "TSNonNullExpression") {
                return true;
              }
            case "AwaitExpression":
              switch (parent.type) {
                case "TaggedTemplateExpression":
                case "UnaryExpression":
                case "LogicalExpression":
                case "SpreadElement":
                case "SpreadProperty":
                case "TSAsExpression":
                case "TSNonNullExpression":
                case "BindExpression":
                  return true;
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "ConditionalExpression":
                  return name === "test";
                case "BinaryExpression": {
                  if (!node.argument && parent.operator === "|>") {
                    return false;
                  }
                  return true;
                }
                default:
                  return false;
              }
            case "TSConditionalType":
              if (name === "extendsType" && parent.type === "TSConditionalType") {
                return true;
              }
            case "TSFunctionType":
            case "TSConstructorType":
              if (name === "checkType" && parent.type === "TSConditionalType") {
                return true;
              }
            case "TSUnionType":
            case "TSIntersectionType":
              if ((parent.type === "TSUnionType" || parent.type === "TSIntersectionType") && parent.types.length > 1 && (!node.types || node.types.length > 1)) {
                return true;
              }
            case "TSInferType":
              if (node.type === "TSInferType" && parent.type === "TSRestType") {
                return false;
              }
            case "TSTypeOperator":
              return parent.type === "TSArrayType" || parent.type === "TSOptionalType" || parent.type === "TSRestType" || name === "objectType" && parent.type === "TSIndexedAccessType" || parent.type === "TSTypeOperator" || parent.type === "TSTypeAnnotation" && path4.getParentNode(1).type.startsWith("TSJSDoc");
            case "ArrayTypeAnnotation":
              return parent.type === "NullableTypeAnnotation";
            case "IntersectionTypeAnnotation":
            case "UnionTypeAnnotation":
              return parent.type === "ArrayTypeAnnotation" || parent.type === "NullableTypeAnnotation" || parent.type === "IntersectionTypeAnnotation" || parent.type === "UnionTypeAnnotation" || name === "objectType" && (parent.type === "IndexedAccessType" || parent.type === "OptionalIndexedAccessType");
            case "NullableTypeAnnotation":
              return parent.type === "ArrayTypeAnnotation" || name === "objectType" && (parent.type === "IndexedAccessType" || parent.type === "OptionalIndexedAccessType");
            case "FunctionTypeAnnotation": {
              const ancestor = parent.type === "NullableTypeAnnotation" ? path4.getParentNode(1) : parent;
              return ancestor.type === "UnionTypeAnnotation" || ancestor.type === "IntersectionTypeAnnotation" || ancestor.type === "ArrayTypeAnnotation" || name === "objectType" && (ancestor.type === "IndexedAccessType" || ancestor.type === "OptionalIndexedAccessType") || ancestor.type === "NullableTypeAnnotation" || parent.type === "FunctionTypeParam" && parent.name === null && getFunctionParameters(node).some((param) => param.typeAnnotation && param.typeAnnotation.type === "NullableTypeAnnotation");
            }
            case "OptionalIndexedAccessType":
              return name === "objectType" && parent.type === "IndexedAccessType";
            case "TypeofTypeAnnotation":
              return name === "objectType" && (parent.type === "IndexedAccessType" || parent.type === "OptionalIndexedAccessType");
            case "StringLiteral":
            case "NumericLiteral":
            case "Literal":
              if (typeof node.value === "string" && parent.type === "ExpressionStatement" && !parent.directive) {
                const grandParent = path4.getParentNode(1);
                return grandParent.type === "Program" || grandParent.type === "BlockStatement";
              }
              return name === "object" && parent.type === "MemberExpression" && typeof node.value === "number";
            case "AssignmentExpression": {
              const grandParent = path4.getParentNode(1);
              if (name === "body" && parent.type === "ArrowFunctionExpression") {
                return true;
              }
              if (name === "key" && (parent.type === "ClassProperty" || parent.type === "PropertyDefinition") && parent.computed) {
                return false;
              }
              if ((name === "init" || name === "update") && parent.type === "ForStatement") {
                return false;
              }
              if (parent.type === "ExpressionStatement") {
                return node.left.type === "ObjectPattern";
              }
              if (name === "key" && parent.type === "TSPropertySignature") {
                return false;
              }
              if (parent.type === "AssignmentExpression") {
                return false;
              }
              if (parent.type === "SequenceExpression" && grandParent && grandParent.type === "ForStatement" && (grandParent.init === parent || grandParent.update === parent)) {
                return false;
              }
              if (name === "value" && parent.type === "Property" && grandParent && grandParent.type === "ObjectPattern" && grandParent.properties.includes(parent)) {
                return false;
              }
              if (parent.type === "NGChainedExpression") {
                return false;
              }
              return true;
            }
            case "ConditionalExpression":
              switch (parent.type) {
                case "TaggedTemplateExpression":
                case "UnaryExpression":
                case "SpreadElement":
                case "SpreadProperty":
                case "BinaryExpression":
                case "LogicalExpression":
                case "NGPipeExpression":
                case "ExportDefaultDeclaration":
                case "AwaitExpression":
                case "JSXSpreadAttribute":
                case "TSTypeAssertion":
                case "TypeCastExpression":
                case "TSAsExpression":
                case "TSNonNullExpression":
                  return true;
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "ConditionalExpression":
                  return name === "test";
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                default:
                  return false;
              }
            case "FunctionExpression":
              switch (parent.type) {
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "TaggedTemplateExpression":
                  return true;
                default:
                  return false;
              }
            case "ArrowFunctionExpression":
              switch (parent.type) {
                case "BinaryExpression":
                  return parent.operator !== "|>" || node.extra && node.extra.parenthesized;
                case "NewExpression":
                case "CallExpression":
                case "OptionalCallExpression":
                  return name === "callee";
                case "MemberExpression":
                case "OptionalMemberExpression":
                  return name === "object";
                case "TSAsExpression":
                case "TSNonNullExpression":
                case "BindExpression":
                case "TaggedTemplateExpression":
                case "UnaryExpression":
                case "LogicalExpression":
                case "AwaitExpression":
                case "TSTypeAssertion":
                  return true;
                case "ConditionalExpression":
                  return name === "test";
                default:
                  return false;
              }
            case "ClassExpression":
              if (isNonEmptyArray(node.decorators)) {
                return true;
              }
              switch (parent.type) {
                case "NewExpression":
                  return name === "callee";
                default:
                  return false;
              }
            case "OptionalMemberExpression":
            case "OptionalCallExpression": {
              const parentParent = path4.getParentNode(1);
              if (name === "object" && parent.type === "MemberExpression" || name === "callee" && (parent.type === "CallExpression" || parent.type === "NewExpression") || parent.type === "TSNonNullExpression" && parentParent.type === "MemberExpression" && parentParent.object === parent) {
                return true;
              }
            }
            case "CallExpression":
            case "MemberExpression":
            case "TaggedTemplateExpression":
            case "TSNonNullExpression":
              if (name === "callee" && (parent.type === "BindExpression" || parent.type === "NewExpression")) {
                let object = node;
                while (object) {
                  switch (object.type) {
                    case "CallExpression":
                    case "OptionalCallExpression":
                      return true;
                    case "MemberExpression":
                    case "OptionalMemberExpression":
                    case "BindExpression":
                      object = object.object;
                      break;
                    case "TaggedTemplateExpression":
                      object = object.tag;
                      break;
                    case "TSNonNullExpression":
                      object = object.expression;
                      break;
                    default:
                      return false;
                  }
                }
              }
              return false;
            case "BindExpression":
              return name === "callee" && (parent.type === "BindExpression" || parent.type === "NewExpression") || name === "object" && isMemberExpression(parent);
            case "NGPipeExpression":
              if (parent.type === "NGRoot" || parent.type === "NGMicrosyntaxExpression" || parent.type === "ObjectProperty" && !(node.extra && node.extra.parenthesized) || parent.type === "ArrayExpression" || isCallExpression(parent) && parent.arguments[name] === node || name === "right" && parent.type === "NGPipeExpression" || name === "property" && parent.type === "MemberExpression" || parent.type === "AssignmentExpression") {
                return false;
              }
              return true;
            case "JSXFragment":
            case "JSXElement":
              return name === "callee" || name === "left" && parent.type === "BinaryExpression" && parent.operator === "<" || parent.type !== "ArrayExpression" && parent.type !== "ArrowFunctionExpression" && parent.type !== "AssignmentExpression" && parent.type !== "AssignmentPattern" && parent.type !== "BinaryExpression" && parent.type !== "NewExpression" && parent.type !== "ConditionalExpression" && parent.type !== "ExpressionStatement" && parent.type !== "JsExpressionRoot" && parent.type !== "JSXAttribute" && parent.type !== "JSXElement" && parent.type !== "JSXExpressionContainer" && parent.type !== "JSXFragment" && parent.type !== "LogicalExpression" && !isCallExpression(parent) && !isObjectProperty(parent) && parent.type !== "ReturnStatement" && parent.type !== "ThrowStatement" && parent.type !== "TypeCastExpression" && parent.type !== "VariableDeclarator" && parent.type !== "YieldExpression";
            case "TypeAnnotation":
              return name === "returnType" && parent.type === "ArrowFunctionExpression" && includesFunctionTypeInObjectType(node);
          }
          return false;
        }
        function isStatement(node) {
          return node.type === "BlockStatement" || node.type === "BreakStatement" || node.type === "ClassBody" || node.type === "ClassDeclaration" || node.type === "ClassMethod" || node.type === "ClassProperty" || node.type === "PropertyDefinition" || node.type === "ClassPrivateProperty" || node.type === "ContinueStatement" || node.type === "DebuggerStatement" || node.type === "DeclareClass" || node.type === "DeclareExportAllDeclaration" || node.type === "DeclareExportDeclaration" || node.type === "DeclareFunction" || node.type === "DeclareInterface" || node.type === "DeclareModule" || node.type === "DeclareModuleExports" || node.type === "DeclareVariable" || node.type === "DoWhileStatement" || node.type === "EnumDeclaration" || node.type === "ExportAllDeclaration" || node.type === "ExportDefaultDeclaration" || node.type === "ExportNamedDeclaration" || node.type === "ExpressionStatement" || node.type === "ForInStatement" || node.type === "ForOfStatement" || node.type === "ForStatement" || node.type === "FunctionDeclaration" || node.type === "IfStatement" || node.type === "ImportDeclaration" || node.type === "InterfaceDeclaration" || node.type === "LabeledStatement" || node.type === "MethodDefinition" || node.type === "ReturnStatement" || node.type === "SwitchStatement" || node.type === "ThrowStatement" || node.type === "TryStatement" || node.type === "TSDeclareFunction" || node.type === "TSEnumDeclaration" || node.type === "TSImportEqualsDeclaration" || node.type === "TSInterfaceDeclaration" || node.type === "TSModuleDeclaration" || node.type === "TSNamespaceExportDeclaration" || node.type === "TypeAlias" || node.type === "VariableDeclaration" || node.type === "WhileStatement" || node.type === "WithStatement";
        }
        function isPathInForStatementInitializer(path4) {
          let i2 = 0;
          let node = path4.getValue();
          while (node) {
            const parent = path4.getParentNode(i2++);
            if (parent && parent.type === "ForStatement" && parent.init === node) {
              return true;
            }
            node = parent;
          }
          return false;
        }
        function includesFunctionTypeInObjectType(node) {
          return hasNode(node, (n1) => n1.type === "ObjectTypeAnnotation" && hasNode(n1, (n2) => n2.type === "FunctionTypeAnnotation" || void 0) || void 0);
        }
        function endsWithRightBracket(node) {
          switch (node.type) {
            case "ObjectExpression":
              return true;
            default:
              return false;
          }
        }
        function isFollowedByRightBracket(path4) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          const name = path4.getName();
          switch (parent.type) {
            case "NGPipeExpression":
              if (typeof name === "number" && parent.arguments[name] === node && parent.arguments.length - 1 === name) {
                return path4.callParent(isFollowedByRightBracket);
              }
              break;
            case "ObjectProperty":
              if (name === "value") {
                const parentParent = path4.getParentNode(1);
                return getLast(parentParent.properties) === parent;
              }
              break;
            case "BinaryExpression":
            case "LogicalExpression":
              if (name === "right") {
                return path4.callParent(isFollowedByRightBracket);
              }
              break;
            case "ConditionalExpression":
              if (name === "alternate") {
                return path4.callParent(isFollowedByRightBracket);
              }
              break;
            case "UnaryExpression":
              if (parent.prefix) {
                return path4.callParent(isFollowedByRightBracket);
              }
              break;
          }
          return false;
        }
        function shouldWrapFunctionForExportDefault(path4, options) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          if (node.type === "FunctionExpression" || node.type === "ClassExpression") {
            return parent.type === "ExportDefaultDeclaration" || !needsParens(path4, options);
          }
          if (!hasNakedLeftSide(node) || parent.type !== "ExportDefaultDeclaration" && needsParens(path4, options)) {
            return false;
          }
          return path4.call((childPath) => shouldWrapFunctionForExportDefault(childPath, options), ...getLeftSidePathName(path4, node));
        }
        module22.exports = needsParens;
      }
    });
    var require_print_preprocess = __commonJS22({
      "src/language-js/print-preprocess.js"(exports2, module22) {
        "use strict";
        function preprocess(ast, options) {
          switch (options.parser) {
            case "json":
            case "json5":
            case "json-stringify":
            case "__js_expression":
            case "__vue_expression":
            case "__vue_ts_expression":
              return Object.assign(Object.assign({}, ast), {}, {
                type: options.parser.startsWith("__") ? "JsExpressionRoot" : "JsonRoot",
                node: ast,
                comments: [],
                rootMarker: options.rootMarker
              });
            default:
              return ast;
          }
        }
        module22.exports = preprocess;
      }
    });
    var require_html_binding = __commonJS22({
      "src/language-js/print/html-binding.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            join,
            line,
            group,
            softline,
            indent
          }
        } = require_doc();
        function printHtmlBinding(path4, options, print) {
          const node = path4.getValue();
          if (options.__onHtmlBindingRoot && path4.getName() === null) {
            options.__onHtmlBindingRoot(node, options);
          }
          if (node.type !== "File") {
            return;
          }
          if (options.__isVueForBindingLeft) {
            return path4.call((functionDeclarationPath) => {
              const printed = join([",", line], functionDeclarationPath.map(print, "params"));
              const {
                params
              } = functionDeclarationPath.getValue();
              if (params.length === 1) {
                return printed;
              }
              return ["(", indent([softline, group(printed)]), softline, ")"];
            }, "program", "body", 0);
          }
          if (options.__isVueBindings) {
            return path4.call((functionDeclarationPath) => join([",", line], functionDeclarationPath.map(print, "params")), "program", "body", 0);
          }
        }
        function isVueEventBindingExpression(node) {
          switch (node.type) {
            case "MemberExpression":
              switch (node.property.type) {
                case "Identifier":
                case "NumericLiteral":
                case "StringLiteral":
                  return isVueEventBindingExpression(node.object);
              }
              return false;
            case "Identifier":
              return true;
            default:
              return false;
          }
        }
        module22.exports = {
          isVueEventBindingExpression,
          printHtmlBinding
        };
      }
    });
    var require_binaryish = __commonJS22({
      "src/language-js/print/binaryish.js"(exports2, module22) {
        "use strict";
        var {
          printComments
        } = require_comments();
        var {
          getLast
        } = require_util();
        var {
          builders: {
            join,
            line,
            softline,
            group,
            indent,
            align,
            ifBreak,
            indentIfBreak
          },
          utils: {
            cleanDoc,
            getDocParts,
            isConcat
          }
        } = require_doc();
        var {
          hasLeadingOwnLineComment,
          isBinaryish,
          isJsxNode,
          shouldFlatten,
          hasComment,
          CommentCheckFlags,
          isCallExpression,
          isMemberExpression,
          isObjectProperty,
          isEnabledHackPipeline
        } = require_utils72();
        var uid = 0;
        function printBinaryishExpression(path4, options, print) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          const parentParent = path4.getParentNode(1);
          const isInsideParenthesis = node !== parent.body && (parent.type === "IfStatement" || parent.type === "WhileStatement" || parent.type === "SwitchStatement" || parent.type === "DoWhileStatement");
          const isHackPipeline = isEnabledHackPipeline(options) && node.operator === "|>";
          const parts = printBinaryishExpressions(path4, print, options, false, isInsideParenthesis);
          if (isInsideParenthesis) {
            return parts;
          }
          if (isHackPipeline) {
            return group(parts);
          }
          if (isCallExpression(parent) && parent.callee === node || parent.type === "UnaryExpression" || isMemberExpression(parent) && !parent.computed) {
            return group([indent([softline, ...parts]), softline]);
          }
          const shouldNotIndent = parent.type === "ReturnStatement" || parent.type === "ThrowStatement" || parent.type === "JSXExpressionContainer" && parentParent.type === "JSXAttribute" || node.operator !== "|" && parent.type === "JsExpressionRoot" || node.type !== "NGPipeExpression" && (parent.type === "NGRoot" && options.parser === "__ng_binding" || parent.type === "NGMicrosyntaxExpression" && parentParent.type === "NGMicrosyntax" && parentParent.body.length === 1) || node === parent.body && parent.type === "ArrowFunctionExpression" || node !== parent.body && parent.type === "ForStatement" || parent.type === "ConditionalExpression" && parentParent.type !== "ReturnStatement" && parentParent.type !== "ThrowStatement" && !isCallExpression(parentParent) || parent.type === "TemplateLiteral";
          const shouldIndentIfInlining = parent.type === "AssignmentExpression" || parent.type === "VariableDeclarator" || parent.type === "ClassProperty" || parent.type === "PropertyDefinition" || parent.type === "TSAbstractPropertyDefinition" || parent.type === "ClassPrivateProperty" || isObjectProperty(parent);
          const samePrecedenceSubExpression = isBinaryish(node.left) && shouldFlatten(node.operator, node.left.operator);
          if (shouldNotIndent || shouldInlineLogicalExpression(node) && !samePrecedenceSubExpression || !shouldInlineLogicalExpression(node) && shouldIndentIfInlining) {
            return group(parts);
          }
          if (parts.length === 0) {
            return "";
          }
          const hasJsx = isJsxNode(node.right);
          const firstGroupIndex = parts.findIndex((part) => typeof part !== "string" && !Array.isArray(part) && part.type === "group");
          const headParts = parts.slice(0, firstGroupIndex === -1 ? 1 : firstGroupIndex + 1);
          const rest = parts.slice(headParts.length, hasJsx ? -1 : void 0);
          const groupId = Symbol("logicalChain-" + ++uid);
          const chain = group([...headParts, indent(rest)], {
            id: groupId
          });
          if (!hasJsx) {
            return chain;
          }
          const jsxPart = getLast(parts);
          return group([chain, indentIfBreak(jsxPart, {
            groupId
          })]);
        }
        function printBinaryishExpressions(path4, print, options, isNested, isInsideParenthesis) {
          const node = path4.getValue();
          if (!isBinaryish(node)) {
            return [group(print())];
          }
          let parts = [];
          if (shouldFlatten(node.operator, node.left.operator)) {
            parts = path4.call((left) => printBinaryishExpressions(left, print, options, true, isInsideParenthesis), "left");
          } else {
            parts.push(group(print("left")));
          }
          const shouldInline = shouldInlineLogicalExpression(node);
          const lineBeforeOperator = (node.operator === "|>" || node.type === "NGPipeExpression" || node.operator === "|" && options.parser === "__vue_expression") && !hasLeadingOwnLineComment(options.originalText, node.right);
          const operator = node.type === "NGPipeExpression" ? "|" : node.operator;
          const rightSuffix = node.type === "NGPipeExpression" && node.arguments.length > 0 ? group(indent([softline, ": ", join([softline, ":", ifBreak(" ")], path4.map(print, "arguments").map((arg) => align(2, group(arg))))])) : "";
          let right;
          if (shouldInline) {
            right = [operator, " ", print("right"), rightSuffix];
          } else {
            const isHackPipeline = isEnabledHackPipeline(options) && operator === "|>";
            const rightContent = isHackPipeline ? path4.call((left) => printBinaryishExpressions(left, print, options, true, isInsideParenthesis), "right") : print("right");
            right = [lineBeforeOperator ? line : "", operator, lineBeforeOperator ? " " : line, rightContent, rightSuffix];
          }
          const parent = path4.getParentNode();
          const shouldBreak = hasComment(node.left, CommentCheckFlags.Trailing | CommentCheckFlags.Line);
          const shouldGroup = shouldBreak || !(isInsideParenthesis && node.type === "LogicalExpression") && parent.type !== node.type && node.left.type !== node.type && node.right.type !== node.type;
          parts.push(lineBeforeOperator ? "" : " ", shouldGroup ? group(right, {
            shouldBreak
          }) : right);
          if (isNested && hasComment(node)) {
            const printed = cleanDoc(printComments(path4, parts, options));
            if (isConcat(printed) || printed.type === "fill") {
              return getDocParts(printed);
            }
            return [printed];
          }
          return parts;
        }
        function shouldInlineLogicalExpression(node) {
          if (node.type !== "LogicalExpression") {
            return false;
          }
          if (node.right.type === "ObjectExpression" && node.right.properties.length > 0) {
            return true;
          }
          if (node.right.type === "ArrayExpression" && node.right.elements.length > 0) {
            return true;
          }
          if (isJsxNode(node.right)) {
            return true;
          }
          return false;
        }
        module22.exports = {
          printBinaryishExpression,
          shouldInlineLogicalExpression
        };
      }
    });
    var require_angular = __commonJS22({
      "src/language-js/print/angular.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            join,
            line,
            group
          }
        } = require_doc();
        var {
          hasNode,
          hasComment,
          getComments
        } = require_utils72();
        var {
          printBinaryishExpression
        } = require_binaryish();
        function printAngular(path4, options, print) {
          const node = path4.getValue();
          if (!node.type.startsWith("NG")) {
            return;
          }
          switch (node.type) {
            case "NGRoot":
              return [print("node"), !hasComment(node.node) ? "" : " //" + getComments(node.node)[0].value.trimEnd()];
            case "NGPipeExpression":
              return printBinaryishExpression(path4, options, print);
            case "NGChainedExpression":
              return group(join([";", line], path4.map((childPath) => hasNgSideEffect(childPath) ? print() : ["(", print(), ")"], "expressions")));
            case "NGEmptyExpression":
              return "";
            case "NGQuotedExpression":
              return [node.prefix, ": ", node.value.trim()];
            case "NGMicrosyntax":
              return path4.map((childPath, index) => [index === 0 ? "" : isNgForOf(childPath.getValue(), index, node) ? " " : [";", line], print()], "body");
            case "NGMicrosyntaxKey":
              return /^[$_a-z][\w$]*(?:-[$_a-z][\w$])*$/i.test(node.name) ? node.name : JSON.stringify(node.name);
            case "NGMicrosyntaxExpression":
              return [print("expression"), node.alias === null ? "" : [" as ", print("alias")]];
            case "NGMicrosyntaxKeyedExpression": {
              const index = path4.getName();
              const parentNode = path4.getParentNode();
              const shouldNotPrintColon = isNgForOf(node, index, parentNode) || (index === 1 && (node.key.name === "then" || node.key.name === "else") || index === 2 && node.key.name === "else" && parentNode.body[index - 1].type === "NGMicrosyntaxKeyedExpression" && parentNode.body[index - 1].key.name === "then") && parentNode.body[0].type === "NGMicrosyntaxExpression";
              return [print("key"), shouldNotPrintColon ? " " : ": ", print("expression")];
            }
            case "NGMicrosyntaxLet":
              return ["let ", print("key"), node.value === null ? "" : [" = ", print("value")]];
            case "NGMicrosyntaxAs":
              return [print("key"), " as ", print("alias")];
            default:
              throw new Error(`Unknown Angular node type: ${JSON.stringify(node.type)}.`);
          }
        }
        function isNgForOf(node, index, parentNode) {
          return node.type === "NGMicrosyntaxKeyedExpression" && node.key.name === "of" && index === 1 && parentNode.body[0].type === "NGMicrosyntaxLet" && parentNode.body[0].value === null;
        }
        function hasNgSideEffect(path4) {
          return hasNode(path4.getValue(), (node) => {
            switch (node.type) {
              case void 0:
                return false;
              case "CallExpression":
              case "OptionalCallExpression":
              case "AssignmentExpression":
                return true;
            }
          });
        }
        module22.exports = {
          printAngular
        };
      }
    });
    var require_jsx = __commonJS22({
      "src/language-js/print/jsx.js"(exports2, module22) {
        "use strict";
        var {
          printComments,
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            line,
            hardline,
            softline,
            group,
            indent,
            conditionalGroup,
            fill,
            ifBreak,
            lineSuffixBoundary,
            join
          },
          utils: {
            willBreak
          }
        } = require_doc();
        var {
          getLast,
          getPreferredQuote
        } = require_util();
        var {
          isJsxNode,
          rawText,
          isLiteral,
          isCallExpression,
          isStringLiteral,
          isBinaryish,
          hasComment,
          CommentCheckFlags,
          hasNodeIgnoreComment
        } = require_utils72();
        var pathNeedsParens = require_needs_parens();
        var {
          willPrintOwnComments
        } = require_comments2();
        var isEmptyStringOrAnyLine = (doc2) => doc2 === "" || doc2 === line || doc2 === hardline || doc2 === softline;
        function printJsxElementInternal(path4, options, print) {
          const node = path4.getValue();
          if (node.type === "JSXElement" && isEmptyJsxElement(node)) {
            return [print("openingElement"), print("closingElement")];
          }
          const openingLines = node.type === "JSXElement" ? print("openingElement") : print("openingFragment");
          const closingLines = node.type === "JSXElement" ? print("closingElement") : print("closingFragment");
          if (node.children.length === 1 && node.children[0].type === "JSXExpressionContainer" && (node.children[0].expression.type === "TemplateLiteral" || node.children[0].expression.type === "TaggedTemplateExpression")) {
            return [openingLines, ...path4.map(print, "children"), closingLines];
          }
          node.children = node.children.map((child) => {
            if (isJsxWhitespaceExpression(child)) {
              return {
                type: "JSXText",
                value: " ",
                raw: " "
              };
            }
            return child;
          });
          const containsTag = node.children.some(isJsxNode);
          const containsMultipleExpressions = node.children.filter((child) => child.type === "JSXExpressionContainer").length > 1;
          const containsMultipleAttributes = node.type === "JSXElement" && node.openingElement.attributes.length > 1;
          let forcedBreak = willBreak(openingLines) || containsTag || containsMultipleAttributes || containsMultipleExpressions;
          const isMdxBlock = path4.getParentNode().rootMarker === "mdx";
          const rawJsxWhitespace = options.singleQuote ? "{' '}" : '{" "}';
          const jsxWhitespace = isMdxBlock ? " " : ifBreak([rawJsxWhitespace, softline], " ");
          const isFacebookTranslationTag = node.openingElement && node.openingElement.name && node.openingElement.name.name === "fbt";
          const children = printJsxChildren(path4, options, print, jsxWhitespace, isFacebookTranslationTag);
          const containsText = node.children.some((child) => isMeaningfulJsxText(child));
          for (let i2 = children.length - 2; i2 >= 0; i2--) {
            const isPairOfEmptyStrings = children[i2] === "" && children[i2 + 1] === "";
            const isPairOfHardlines = children[i2] === hardline && children[i2 + 1] === "" && children[i2 + 2] === hardline;
            const isLineFollowedByJsxWhitespace = (children[i2] === softline || children[i2] === hardline) && children[i2 + 1] === "" && children[i2 + 2] === jsxWhitespace;
            const isJsxWhitespaceFollowedByLine = children[i2] === jsxWhitespace && children[i2 + 1] === "" && (children[i2 + 2] === softline || children[i2 + 2] === hardline);
            const isDoubleJsxWhitespace = children[i2] === jsxWhitespace && children[i2 + 1] === "" && children[i2 + 2] === jsxWhitespace;
            const isPairOfHardOrSoftLines = children[i2] === softline && children[i2 + 1] === "" && children[i2 + 2] === hardline || children[i2] === hardline && children[i2 + 1] === "" && children[i2 + 2] === softline;
            if (isPairOfHardlines && containsText || isPairOfEmptyStrings || isLineFollowedByJsxWhitespace || isDoubleJsxWhitespace || isPairOfHardOrSoftLines) {
              children.splice(i2, 2);
            } else if (isJsxWhitespaceFollowedByLine) {
              children.splice(i2 + 1, 2);
            }
          }
          while (children.length > 0 && isEmptyStringOrAnyLine(getLast(children))) {
            children.pop();
          }
          while (children.length > 1 && isEmptyStringOrAnyLine(children[0]) && isEmptyStringOrAnyLine(children[1])) {
            children.shift();
            children.shift();
          }
          const multilineChildren = [];
          for (const [i2, child] of children.entries()) {
            if (child === jsxWhitespace) {
              if (i2 === 1 && children[i2 - 1] === "") {
                if (children.length === 2) {
                  multilineChildren.push(rawJsxWhitespace);
                  continue;
                }
                multilineChildren.push([rawJsxWhitespace, hardline]);
                continue;
              } else if (i2 === children.length - 1) {
                multilineChildren.push(rawJsxWhitespace);
                continue;
              } else if (children[i2 - 1] === "" && children[i2 - 2] === hardline) {
                multilineChildren.push(rawJsxWhitespace);
                continue;
              }
            }
            multilineChildren.push(child);
            if (willBreak(child)) {
              forcedBreak = true;
            }
          }
          const content = containsText ? fill(multilineChildren) : group(multilineChildren, {
            shouldBreak: true
          });
          if (isMdxBlock) {
            return content;
          }
          const multiLineElem = group([openingLines, indent([hardline, content]), hardline, closingLines]);
          if (forcedBreak) {
            return multiLineElem;
          }
          return conditionalGroup([group([openingLines, ...children, closingLines]), multiLineElem]);
        }
        function printJsxChildren(path4, options, print, jsxWhitespace, isFacebookTranslationTag) {
          const parts = [];
          path4.each((childPath, i2, children) => {
            const child = childPath.getValue();
            if (isLiteral(child)) {
              const text = rawText(child);
              if (isMeaningfulJsxText(child)) {
                const words = text.split(matchJsxWhitespaceRegex);
                if (words[0] === "") {
                  parts.push("");
                  words.shift();
                  if (/\n/.test(words[0])) {
                    const next = children[i2 + 1];
                    parts.push(separatorWithWhitespace(isFacebookTranslationTag, words[1], child, next));
                  } else {
                    parts.push(jsxWhitespace);
                  }
                  words.shift();
                }
                let endWhitespace;
                if (getLast(words) === "") {
                  words.pop();
                  endWhitespace = words.pop();
                }
                if (words.length === 0) {
                  return;
                }
                for (const [i22, word] of words.entries()) {
                  if (i22 % 2 === 1) {
                    parts.push(line);
                  } else {
                    parts.push(word);
                  }
                }
                if (endWhitespace !== void 0) {
                  if (/\n/.test(endWhitespace)) {
                    const next = children[i2 + 1];
                    parts.push(separatorWithWhitespace(isFacebookTranslationTag, getLast(parts), child, next));
                  } else {
                    parts.push(jsxWhitespace);
                  }
                } else {
                  const next = children[i2 + 1];
                  parts.push(separatorNoWhitespace(isFacebookTranslationTag, getLast(parts), child, next));
                }
              } else if (/\n/.test(text)) {
                if (text.match(/\n/g).length > 1) {
                  parts.push("", hardline);
                }
              } else {
                parts.push("", jsxWhitespace);
              }
            } else {
              const printedChild = print();
              parts.push(printedChild);
              const next = children[i2 + 1];
              const directlyFollowedByMeaningfulText = next && isMeaningfulJsxText(next);
              if (directlyFollowedByMeaningfulText) {
                const firstWord = trimJsxWhitespace(rawText(next)).split(matchJsxWhitespaceRegex)[0];
                parts.push(separatorNoWhitespace(isFacebookTranslationTag, firstWord, child, next));
              } else {
                parts.push(hardline);
              }
            }
          }, "children");
          return parts;
        }
        function separatorNoWhitespace(isFacebookTranslationTag, child, childNode, nextNode) {
          if (isFacebookTranslationTag) {
            return "";
          }
          if (childNode.type === "JSXElement" && !childNode.closingElement || nextNode && nextNode.type === "JSXElement" && !nextNode.closingElement) {
            return child.length === 1 ? softline : hardline;
          }
          return softline;
        }
        function separatorWithWhitespace(isFacebookTranslationTag, child, childNode, nextNode) {
          if (isFacebookTranslationTag) {
            return hardline;
          }
          if (child.length === 1) {
            return childNode.type === "JSXElement" && !childNode.closingElement || nextNode && nextNode.type === "JSXElement" && !nextNode.closingElement ? hardline : softline;
          }
          return hardline;
        }
        function maybeWrapJsxElementInParens(path4, elem, options) {
          const parent = path4.getParentNode();
          if (!parent) {
            return elem;
          }
          const NO_WRAP_PARENTS = {
            ArrayExpression: true,
            JSXAttribute: true,
            JSXElement: true,
            JSXExpressionContainer: true,
            JSXFragment: true,
            ExpressionStatement: true,
            CallExpression: true,
            OptionalCallExpression: true,
            ConditionalExpression: true,
            JsExpressionRoot: true
          };
          if (NO_WRAP_PARENTS[parent.type]) {
            return elem;
          }
          const shouldBreak = path4.match(void 0, (node) => node.type === "ArrowFunctionExpression", isCallExpression, (node) => node.type === "JSXExpressionContainer");
          const needsParens = pathNeedsParens(path4, options);
          return group([needsParens ? "" : ifBreak("("), indent([softline, elem]), softline, needsParens ? "" : ifBreak(")")], {
            shouldBreak
          });
        }
        function printJsxAttribute(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          parts.push(print("name"));
          if (node.value) {
            let res;
            if (isStringLiteral(node.value)) {
              const raw = rawText(node.value);
              let final = raw.slice(1, -1).replace(/&apos;/g, "'").replace(/&quot;/g, '"');
              const {
                escaped,
                quote,
                regex
              } = getPreferredQuote(final, options.jsxSingleQuote ? "'" : '"');
              final = final.replace(regex, escaped);
              res = [quote, final, quote];
            } else {
              res = print("value");
            }
            parts.push("=", res);
          }
          return parts;
        }
        function printJsxExpressionContainer(path4, options, print) {
          const node = path4.getValue();
          const shouldInline = (node2, parent) => node2.type === "JSXEmptyExpression" || !hasComment(node2) && (node2.type === "ArrayExpression" || node2.type === "ObjectExpression" || node2.type === "ArrowFunctionExpression" || node2.type === "AwaitExpression" && (shouldInline(node2.argument, node2) || node2.argument.type === "JSXElement") || isCallExpression(node2) || node2.type === "FunctionExpression" || node2.type === "TemplateLiteral" || node2.type === "TaggedTemplateExpression" || node2.type === "DoExpression" || isJsxNode(parent) && (node2.type === "ConditionalExpression" || isBinaryish(node2)));
          if (shouldInline(node.expression, path4.getParentNode(0))) {
            return group(["{", print("expression"), lineSuffixBoundary, "}"]);
          }
          return group(["{", indent([softline, print("expression")]), softline, lineSuffixBoundary, "}"]);
        }
        function printJsxOpeningElement(path4, options, print) {
          const node = path4.getValue();
          const nameHasComments = node.name && hasComment(node.name) || node.typeParameters && hasComment(node.typeParameters);
          if (node.selfClosing && node.attributes.length === 0 && !nameHasComments) {
            return ["<", print("name"), print("typeParameters"), " />"];
          }
          if (node.attributes && node.attributes.length === 1 && node.attributes[0].value && isStringLiteral(node.attributes[0].value) && !node.attributes[0].value.value.includes("\n") && !nameHasComments && !hasComment(node.attributes[0])) {
            return group(["<", print("name"), print("typeParameters"), " ", ...path4.map(print, "attributes"), node.selfClosing ? " />" : ">"]);
          }
          const lastAttrHasTrailingComments = node.attributes.length > 0 && hasComment(getLast(node.attributes), CommentCheckFlags.Trailing);
          const bracketSameLine = node.attributes.length === 0 && !nameHasComments || (options.bracketSameLine || options.jsxBracketSameLine) && (!nameHasComments || node.attributes.length > 0) && !lastAttrHasTrailingComments;
          const shouldBreak = node.attributes && node.attributes.some((attr) => attr.value && isStringLiteral(attr.value) && attr.value.value.includes("\n"));
          const attributeLine = options.singleAttributePerLine && node.attributes.length > 1 ? hardline : line;
          return group(["<", print("name"), print("typeParameters"), indent(path4.map(() => [attributeLine, print()], "attributes")), node.selfClosing ? line : bracketSameLine ? ">" : softline, node.selfClosing ? "/>" : bracketSameLine ? "" : ">"], {
            shouldBreak
          });
        }
        function printJsxClosingElement(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          parts.push("</");
          const printed = print("name");
          if (hasComment(node.name, CommentCheckFlags.Leading | CommentCheckFlags.Line)) {
            parts.push(indent([hardline, printed]), hardline);
          } else if (hasComment(node.name, CommentCheckFlags.Leading | CommentCheckFlags.Block)) {
            parts.push(" ", printed);
          } else {
            parts.push(printed);
          }
          parts.push(">");
          return parts;
        }
        function printJsxOpeningClosingFragment(path4, options) {
          const node = path4.getValue();
          const nodeHasComment = hasComment(node);
          const hasOwnLineComment = hasComment(node, CommentCheckFlags.Line);
          const isOpeningFragment = node.type === "JSXOpeningFragment";
          return [isOpeningFragment ? "<" : "</", indent([hasOwnLineComment ? hardline : nodeHasComment && !isOpeningFragment ? " " : "", printDanglingComments(path4, options, true)]), hasOwnLineComment ? hardline : "", ">"];
        }
        function printJsxElement(path4, options, print) {
          const elem = printComments(path4, printJsxElementInternal(path4, options, print), options);
          return maybeWrapJsxElementInParens(path4, elem, options);
        }
        function printJsxEmptyExpression(path4, options) {
          const node = path4.getValue();
          const requiresHardline = hasComment(node, CommentCheckFlags.Line);
          return [printDanglingComments(path4, options, !requiresHardline), requiresHardline ? hardline : ""];
        }
        function printJsxSpreadAttribute(path4, options, print) {
          const node = path4.getValue();
          return ["{", path4.call((p) => {
            const printed = ["...", print()];
            const node2 = p.getValue();
            if (!hasComment(node2) || !willPrintOwnComments(p)) {
              return printed;
            }
            return [indent([softline, printComments(p, printed, options)]), softline];
          }, node.type === "JSXSpreadAttribute" ? "argument" : "expression"), "}"];
        }
        function printJsx(path4, options, print) {
          const node = path4.getValue();
          if (!node.type.startsWith("JSX")) {
            return;
          }
          switch (node.type) {
            case "JSXAttribute":
              return printJsxAttribute(path4, options, print);
            case "JSXIdentifier":
              return String(node.name);
            case "JSXNamespacedName":
              return join(":", [print("namespace"), print("name")]);
            case "JSXMemberExpression":
              return join(".", [print("object"), print("property")]);
            case "JSXSpreadAttribute":
              return printJsxSpreadAttribute(path4, options, print);
            case "JSXSpreadChild": {
              const printJsxSpreadChild = printJsxSpreadAttribute;
              return printJsxSpreadChild(path4, options, print);
            }
            case "JSXExpressionContainer":
              return printJsxExpressionContainer(path4, options, print);
            case "JSXFragment":
            case "JSXElement":
              return printJsxElement(path4, options, print);
            case "JSXOpeningElement":
              return printJsxOpeningElement(path4, options, print);
            case "JSXClosingElement":
              return printJsxClosingElement(path4, options, print);
            case "JSXOpeningFragment":
            case "JSXClosingFragment":
              return printJsxOpeningClosingFragment(path4, options);
            case "JSXEmptyExpression":
              return printJsxEmptyExpression(path4, options);
            case "JSXText":
              throw new Error("JSXTest should be handled by JSXElement");
            default:
              throw new Error(`Unknown JSX node type: ${JSON.stringify(node.type)}.`);
          }
        }
        var jsxWhitespaceChars = " \n\r	";
        var matchJsxWhitespaceRegex = new RegExp("([" + jsxWhitespaceChars + "]+)");
        var containsNonJsxWhitespaceRegex = new RegExp("[^" + jsxWhitespaceChars + "]");
        var trimJsxWhitespace = (text) => text.replace(new RegExp("(?:^" + matchJsxWhitespaceRegex.source + "|" + matchJsxWhitespaceRegex.source + "$)"), "");
        function isEmptyJsxElement(node) {
          if (node.children.length === 0) {
            return true;
          }
          if (node.children.length > 1) {
            return false;
          }
          const child = node.children[0];
          return isLiteral(child) && !isMeaningfulJsxText(child);
        }
        function isMeaningfulJsxText(node) {
          return isLiteral(node) && (containsNonJsxWhitespaceRegex.test(rawText(node)) || !/\n/.test(rawText(node)));
        }
        function isJsxWhitespaceExpression(node) {
          return node.type === "JSXExpressionContainer" && isLiteral(node.expression) && node.expression.value === " " && !hasComment(node.expression);
        }
        function hasJsxIgnoreComment(path4) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          if (!parent || !node || !isJsxNode(node) || !isJsxNode(parent)) {
            return false;
          }
          const index = parent.children.indexOf(node);
          let prevSibling = null;
          for (let i2 = index; i2 > 0; i2--) {
            const candidate = parent.children[i2 - 1];
            if (candidate.type === "JSXText" && !isMeaningfulJsxText(candidate)) {
              continue;
            }
            prevSibling = candidate;
            break;
          }
          return prevSibling && prevSibling.type === "JSXExpressionContainer" && prevSibling.expression.type === "JSXEmptyExpression" && hasNodeIgnoreComment(prevSibling.expression);
        }
        module22.exports = {
          hasJsxIgnoreComment,
          printJsx
        };
      }
    });
    var require_misc = __commonJS22({
      "src/language-js/print/misc.js"(exports2, module22) {
        "use strict";
        var {
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            indent,
            join,
            line
          }
        } = require_doc();
        var {
          isFlowAnnotationComment
        } = require_utils72();
        function printOptionalToken(path4) {
          const node = path4.getValue();
          if (!node.optional || node.type === "Identifier" && node === path4.getParentNode().key) {
            return "";
          }
          if (node.type === "OptionalCallExpression" || node.type === "OptionalMemberExpression" && node.computed) {
            return "?.";
          }
          return "?";
        }
        function printDefiniteToken(path4) {
          return path4.getValue().definite || path4.match(void 0, (node, name) => name === "id" && node.type === "VariableDeclarator" && node.definite) ? "!" : "";
        }
        function printFunctionTypeParameters(path4, options, print) {
          const fun = path4.getValue();
          if (fun.typeArguments) {
            return print("typeArguments");
          }
          if (fun.typeParameters) {
            return print("typeParameters");
          }
          return "";
        }
        function printTypeAnnotation(path4, options, print) {
          const node = path4.getValue();
          if (!node.typeAnnotation) {
            return "";
          }
          const parentNode = path4.getParentNode();
          const isFunctionDeclarationIdentifier = parentNode.type === "DeclareFunction" && parentNode.id === node;
          if (isFlowAnnotationComment(options.originalText, node.typeAnnotation)) {
            return [" /*: ", print("typeAnnotation"), " */"];
          }
          return [isFunctionDeclarationIdentifier ? "" : ": ", print("typeAnnotation")];
        }
        function printBindExpressionCallee(path4, options, print) {
          return ["::", print("callee")];
        }
        function printTypeScriptModifiers(path4, options, print) {
          const node = path4.getValue();
          if (!isNonEmptyArray(node.modifiers)) {
            return "";
          }
          return [join(" ", path4.map(print, "modifiers")), " "];
        }
        function adjustClause(node, clause, forceSpace) {
          if (node.type === "EmptyStatement") {
            return ";";
          }
          if (node.type === "BlockStatement" || forceSpace) {
            return [" ", clause];
          }
          return indent([line, clause]);
        }
        function printRestSpread(path4, options, print) {
          return ["...", print("argument"), printTypeAnnotation(path4, options, print)];
        }
        module22.exports = {
          printOptionalToken,
          printDefiniteToken,
          printFunctionTypeParameters,
          printBindExpressionCallee,
          printTypeScriptModifiers,
          printTypeAnnotation,
          printRestSpread,
          adjustClause
        };
      }
    });
    var require_array4 = __commonJS22({
      "src/language-js/print/array.js"(exports2, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            line,
            softline,
            hardline,
            group,
            indent,
            ifBreak,
            fill
          }
        } = require_doc();
        var {
          getLast,
          hasNewline
        } = require_util();
        var {
          shouldPrintComma,
          hasComment,
          CommentCheckFlags,
          isNextLineEmpty,
          isNumericLiteral,
          isSignedNumericLiteral
        } = require_utils72();
        var {
          locStart
        } = require_loc();
        var {
          printOptionalToken,
          printTypeAnnotation
        } = require_misc();
        function printArray(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          const openBracket = node.type === "TupleExpression" ? "#[" : "[";
          const closeBracket = "]";
          if (node.elements.length === 0) {
            if (!hasComment(node, CommentCheckFlags.Dangling)) {
              parts.push(openBracket, closeBracket);
            } else {
              parts.push(group([openBracket, printDanglingComments(path4, options), softline, closeBracket]));
            }
          } else {
            const lastElem = getLast(node.elements);
            const canHaveTrailingComma = !(lastElem && lastElem.type === "RestElement");
            const needsForcedTrailingComma = lastElem === null;
            const groupId = Symbol("array");
            const shouldBreak = !options.__inJestEach && node.elements.length > 1 && node.elements.every((element, i2, elements) => {
              const elementType = element && element.type;
              if (elementType !== "ArrayExpression" && elementType !== "ObjectExpression") {
                return false;
              }
              const nextElement = elements[i2 + 1];
              if (nextElement && elementType !== nextElement.type) {
                return false;
              }
              const itemsKey = elementType === "ArrayExpression" ? "elements" : "properties";
              return element[itemsKey] && element[itemsKey].length > 1;
            });
            const shouldUseConciseFormatting = isConciselyPrintedArray(node, options);
            const trailingComma = !canHaveTrailingComma ? "" : needsForcedTrailingComma ? "," : !shouldPrintComma(options) ? "" : shouldUseConciseFormatting ? ifBreak(",", "", {
              groupId
            }) : ifBreak(",");
            parts.push(group([openBracket, indent([softline, shouldUseConciseFormatting ? printArrayItemsConcisely(path4, options, print, trailingComma) : [printArrayItems(path4, options, "elements", print), trailingComma], printDanglingComments(path4, options, true)]), softline, closeBracket], {
              shouldBreak,
              id: groupId
            }));
          }
          parts.push(printOptionalToken(path4), printTypeAnnotation(path4, options, print));
          return parts;
        }
        function isConciselyPrintedArray(node, options) {
          return node.elements.length > 1 && node.elements.every((element) => element && (isNumericLiteral(element) || isSignedNumericLiteral(element) && !hasComment(element.argument)) && !hasComment(element, CommentCheckFlags.Trailing | CommentCheckFlags.Line, (comment) => !hasNewline(options.originalText, locStart(comment), {
            backwards: true
          })));
        }
        function printArrayItems(path4, options, printPath, print) {
          const printedElements = [];
          let separatorParts = [];
          path4.each((childPath) => {
            printedElements.push(separatorParts, group(print()));
            separatorParts = [",", line];
            if (childPath.getValue() && isNextLineEmpty(childPath.getValue(), options)) {
              separatorParts.push(softline);
            }
          }, printPath);
          return printedElements;
        }
        function printArrayItemsConcisely(path4, options, print, trailingComma) {
          const parts = [];
          path4.each((childPath, i2, elements) => {
            const isLast = i2 === elements.length - 1;
            parts.push([print(), isLast ? trailingComma : ","]);
            if (!isLast) {
              parts.push(isNextLineEmpty(childPath.getValue(), options) ? [hardline, hardline] : hasComment(elements[i2 + 1], CommentCheckFlags.Leading | CommentCheckFlags.Line) ? hardline : line);
            }
          }, "elements");
          return fill(parts);
        }
        module22.exports = {
          printArray,
          printArrayItems,
          isConciselyPrintedArray
        };
      }
    });
    var require_call_arguments = __commonJS22({
      "src/language-js/print/call-arguments.js"(exports2, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          getLast,
          getPenultimate
        } = require_util();
        var {
          getFunctionParameters,
          hasComment,
          CommentCheckFlags,
          isFunctionCompositionArgs,
          isJsxNode,
          isLongCurriedCallExpression,
          shouldPrintComma,
          getCallArguments,
          iterateCallArgumentsPath,
          isNextLineEmpty,
          isCallExpression,
          isStringLiteral,
          isObjectProperty
        } = require_utils72();
        var {
          builders: {
            line,
            hardline,
            softline,
            group,
            indent,
            conditionalGroup,
            ifBreak,
            breakParent
          },
          utils: {
            willBreak
          }
        } = require_doc();
        var {
          ArgExpansionBailout
        } = require_errors();
        var {
          isConciselyPrintedArray
        } = require_array4();
        function printCallArguments(path4, options, print) {
          const node = path4.getValue();
          const isDynamicImport = node.type === "ImportExpression";
          const args = getCallArguments(node);
          if (args.length === 0) {
            return ["(", printDanglingComments(path4, options, true), ")"];
          }
          if (isReactHookCallWithDepsArray(args)) {
            return ["(", print(["arguments", 0]), ", ", print(["arguments", 1]), ")"];
          }
          let anyArgEmptyLine = false;
          let hasEmptyLineFollowingFirstArg = false;
          const lastArgIndex = args.length - 1;
          const printedArguments = [];
          iterateCallArgumentsPath(path4, (argPath, index) => {
            const arg = argPath.getNode();
            const parts = [print()];
            if (index === lastArgIndex) {
            } else if (isNextLineEmpty(arg, options)) {
              if (index === 0) {
                hasEmptyLineFollowingFirstArg = true;
              }
              anyArgEmptyLine = true;
              parts.push(",", hardline, hardline);
            } else {
              parts.push(",", line);
            }
            printedArguments.push(parts);
          });
          const maybeTrailingComma = !(isDynamicImport || node.callee && node.callee.type === "Import") && shouldPrintComma(options, "all") ? "," : "";
          function allArgsBrokenOut() {
            return group(["(", indent([line, ...printedArguments]), maybeTrailingComma, line, ")"], {
              shouldBreak: true
            });
          }
          if (anyArgEmptyLine || path4.getParentNode().type !== "Decorator" && isFunctionCompositionArgs(args)) {
            return allArgsBrokenOut();
          }
          const shouldGroupFirst = shouldGroupFirstArg(args);
          const shouldGroupLast = shouldGroupLastArg(args, options);
          if (shouldGroupFirst || shouldGroupLast) {
            if (shouldGroupFirst ? printedArguments.slice(1).some(willBreak) : printedArguments.slice(0, -1).some(willBreak)) {
              return allArgsBrokenOut();
            }
            let printedExpanded = [];
            try {
              path4.try(() => {
                iterateCallArgumentsPath(path4, (argPath, i2) => {
                  if (shouldGroupFirst && i2 === 0) {
                    printedExpanded = [[print([], {
                      expandFirstArg: true
                    }), printedArguments.length > 1 ? "," : "", hasEmptyLineFollowingFirstArg ? hardline : line, hasEmptyLineFollowingFirstArg ? hardline : ""], ...printedArguments.slice(1)];
                  }
                  if (shouldGroupLast && i2 === lastArgIndex) {
                    printedExpanded = [...printedArguments.slice(0, -1), print([], {
                      expandLastArg: true
                    })];
                  }
                });
              });
            } catch (caught) {
              if (caught instanceof ArgExpansionBailout) {
                return allArgsBrokenOut();
              }
              throw caught;
            }
            return [printedArguments.some(willBreak) ? breakParent : "", conditionalGroup([["(", ...printedExpanded, ")"], shouldGroupFirst ? ["(", group(printedExpanded[0], {
              shouldBreak: true
            }), ...printedExpanded.slice(1), ")"] : ["(", ...printedArguments.slice(0, -1), group(getLast(printedExpanded), {
              shouldBreak: true
            }), ")"], allArgsBrokenOut()])];
          }
          const contents = ["(", indent([softline, ...printedArguments]), ifBreak(maybeTrailingComma), softline, ")"];
          if (isLongCurriedCallExpression(path4)) {
            return contents;
          }
          return group(contents, {
            shouldBreak: printedArguments.some(willBreak) || anyArgEmptyLine
          });
        }
        function couldGroupArg(arg, arrowChainRecursion = false) {
          return arg.type === "ObjectExpression" && (arg.properties.length > 0 || hasComment(arg)) || arg.type === "ArrayExpression" && (arg.elements.length > 0 || hasComment(arg)) || arg.type === "TSTypeAssertion" && couldGroupArg(arg.expression) || arg.type === "TSAsExpression" && couldGroupArg(arg.expression) || arg.type === "FunctionExpression" || arg.type === "ArrowFunctionExpression" && (!arg.returnType || !arg.returnType.typeAnnotation || arg.returnType.typeAnnotation.type !== "TSTypeReference" || isNonEmptyBlockStatement(arg.body)) && (arg.body.type === "BlockStatement" || arg.body.type === "ArrowFunctionExpression" && couldGroupArg(arg.body, true) || arg.body.type === "ObjectExpression" || arg.body.type === "ArrayExpression" || !arrowChainRecursion && (isCallExpression(arg.body) || arg.body.type === "ConditionalExpression") || isJsxNode(arg.body)) || arg.type === "DoExpression" || arg.type === "ModuleExpression";
        }
        function shouldGroupLastArg(args, options) {
          const lastArg = getLast(args);
          const penultimateArg = getPenultimate(args);
          return !hasComment(lastArg, CommentCheckFlags.Leading) && !hasComment(lastArg, CommentCheckFlags.Trailing) && couldGroupArg(lastArg) && (!penultimateArg || penultimateArg.type !== lastArg.type) && (args.length !== 2 || penultimateArg.type !== "ArrowFunctionExpression" || lastArg.type !== "ArrayExpression") && !(args.length > 1 && lastArg.type === "ArrayExpression" && isConciselyPrintedArray(lastArg, options));
        }
        function shouldGroupFirstArg(args) {
          if (args.length !== 2) {
            return false;
          }
          const [firstArg, secondArg] = args;
          if (firstArg.type === "ModuleExpression" && isTypeModuleObjectExpression(secondArg)) {
            return true;
          }
          return !hasComment(firstArg) && (firstArg.type === "FunctionExpression" || firstArg.type === "ArrowFunctionExpression" && firstArg.body.type === "BlockStatement") && secondArg.type !== "FunctionExpression" && secondArg.type !== "ArrowFunctionExpression" && secondArg.type !== "ConditionalExpression" && !couldGroupArg(secondArg);
        }
        function isReactHookCallWithDepsArray(args) {
          return args.length === 2 && args[0].type === "ArrowFunctionExpression" && getFunctionParameters(args[0]).length === 0 && args[0].body.type === "BlockStatement" && args[1].type === "ArrayExpression" && !args.some((arg) => hasComment(arg));
        }
        function isNonEmptyBlockStatement(node) {
          return node.type === "BlockStatement" && (node.body.some((node2) => node2.type !== "EmptyStatement") || hasComment(node, CommentCheckFlags.Dangling));
        }
        function isTypeModuleObjectExpression(node) {
          return node.type === "ObjectExpression" && node.properties.length === 1 && isObjectProperty(node.properties[0]) && node.properties[0].key.type === "Identifier" && node.properties[0].key.name === "type" && isStringLiteral(node.properties[0].value) && node.properties[0].value.value === "module";
        }
        module22.exports = printCallArguments;
      }
    });
    var require_member = __commonJS22({
      "src/language-js/print/member.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            softline,
            group,
            indent,
            label
          }
        } = require_doc();
        var {
          isNumericLiteral,
          isMemberExpression,
          isCallExpression
        } = require_utils72();
        var {
          printOptionalToken
        } = require_misc();
        function printMemberExpression(path4, options, print) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          let firstNonMemberParent;
          let i2 = 0;
          do {
            firstNonMemberParent = path4.getParentNode(i2);
            i2++;
          } while (firstNonMemberParent && (isMemberExpression(firstNonMemberParent) || firstNonMemberParent.type === "TSNonNullExpression"));
          const objectDoc = print("object");
          const lookupDoc = printMemberLookup(path4, options, print);
          const shouldInline = firstNonMemberParent && (firstNonMemberParent.type === "NewExpression" || firstNonMemberParent.type === "BindExpression" || firstNonMemberParent.type === "AssignmentExpression" && firstNonMemberParent.left.type !== "Identifier") || node.computed || node.object.type === "Identifier" && node.property.type === "Identifier" && !isMemberExpression(parent) || (parent.type === "AssignmentExpression" || parent.type === "VariableDeclarator") && (isCallExpression(node.object) && node.object.arguments.length > 0 || node.object.type === "TSNonNullExpression" && isCallExpression(node.object.expression) && node.object.expression.arguments.length > 0 || objectDoc.label === "member-chain");
          return label(objectDoc.label === "member-chain" ? "member-chain" : "member", [objectDoc, shouldInline ? lookupDoc : group(indent([softline, lookupDoc]))]);
        }
        function printMemberLookup(path4, options, print) {
          const property = print("property");
          const node = path4.getValue();
          const optional = printOptionalToken(path4);
          if (!node.computed) {
            return [optional, ".", property];
          }
          if (!node.property || isNumericLiteral(node.property)) {
            return [optional, "[", property, "]"];
          }
          return group([optional, "[", indent([softline, property]), softline, "]"]);
        }
        module22.exports = {
          printMemberExpression,
          printMemberLookup
        };
      }
    });
    var require_member_chain = __commonJS22({
      "src/language-js/print/member-chain.js"(exports2, module22) {
        "use strict";
        var {
          printComments
        } = require_comments();
        var {
          getLast,
          isNextLineEmptyAfterIndex,
          getNextNonSpaceNonCommentCharacterIndex
        } = require_util();
        var pathNeedsParens = require_needs_parens();
        var {
          isCallExpression,
          isMemberExpression,
          isFunctionOrArrowExpression,
          isLongCurriedCallExpression,
          isMemberish,
          isNumericLiteral,
          isSimpleCallArgument,
          hasComment,
          CommentCheckFlags,
          isNextLineEmpty
        } = require_utils72();
        var {
          locEnd
        } = require_loc();
        var {
          builders: {
            join,
            hardline,
            group,
            indent,
            conditionalGroup,
            breakParent,
            label
          },
          utils: {
            willBreak
          }
        } = require_doc();
        var printCallArguments = require_call_arguments();
        var {
          printMemberLookup
        } = require_member();
        var {
          printOptionalToken,
          printFunctionTypeParameters,
          printBindExpressionCallee
        } = require_misc();
        function printMemberChain(path4, options, print) {
          const parent = path4.getParentNode();
          const isExpressionStatement = !parent || parent.type === "ExpressionStatement";
          const printedNodes = [];
          function shouldInsertEmptyLineAfter(node2) {
            const {
              originalText
            } = options;
            const nextCharIndex = getNextNonSpaceNonCommentCharacterIndex(originalText, node2, locEnd);
            const nextChar = originalText.charAt(nextCharIndex);
            if (nextChar === ")") {
              return nextCharIndex !== false && isNextLineEmptyAfterIndex(originalText, nextCharIndex + 1);
            }
            return isNextLineEmpty(node2, options);
          }
          function rec(path22) {
            const node2 = path22.getValue();
            if (isCallExpression(node2) && (isMemberish(node2.callee) || isCallExpression(node2.callee))) {
              printedNodes.unshift({
                node: node2,
                printed: [printComments(path22, [printOptionalToken(path22), printFunctionTypeParameters(path22, options, print), printCallArguments(path22, options, print)], options), shouldInsertEmptyLineAfter(node2) ? hardline : ""]
              });
              path22.call((callee) => rec(callee), "callee");
            } else if (isMemberish(node2)) {
              printedNodes.unshift({
                node: node2,
                needsParens: pathNeedsParens(path22, options),
                printed: printComments(path22, isMemberExpression(node2) ? printMemberLookup(path22, options, print) : printBindExpressionCallee(path22, options, print), options)
              });
              path22.call((object) => rec(object), "object");
            } else if (node2.type === "TSNonNullExpression") {
              printedNodes.unshift({
                node: node2,
                printed: printComments(path22, "!", options)
              });
              path22.call((expression) => rec(expression), "expression");
            } else {
              printedNodes.unshift({
                node: node2,
                printed: print()
              });
            }
          }
          const node = path4.getValue();
          printedNodes.unshift({
            node,
            printed: [printOptionalToken(path4), printFunctionTypeParameters(path4, options, print), printCallArguments(path4, options, print)]
          });
          if (node.callee) {
            path4.call((callee) => rec(callee), "callee");
          }
          const groups = [];
          let currentGroup = [printedNodes[0]];
          let i2 = 1;
          for (; i2 < printedNodes.length; ++i2) {
            if (printedNodes[i2].node.type === "TSNonNullExpression" || isCallExpression(printedNodes[i2].node) || isMemberExpression(printedNodes[i2].node) && printedNodes[i2].node.computed && isNumericLiteral(printedNodes[i2].node.property)) {
              currentGroup.push(printedNodes[i2]);
            } else {
              break;
            }
          }
          if (!isCallExpression(printedNodes[0].node)) {
            for (; i2 + 1 < printedNodes.length; ++i2) {
              if (isMemberish(printedNodes[i2].node) && isMemberish(printedNodes[i2 + 1].node)) {
                currentGroup.push(printedNodes[i2]);
              } else {
                break;
              }
            }
          }
          groups.push(currentGroup);
          currentGroup = [];
          let hasSeenCallExpression = false;
          for (; i2 < printedNodes.length; ++i2) {
            if (hasSeenCallExpression && isMemberish(printedNodes[i2].node)) {
              if (printedNodes[i2].node.computed && isNumericLiteral(printedNodes[i2].node.property)) {
                currentGroup.push(printedNodes[i2]);
                continue;
              }
              groups.push(currentGroup);
              currentGroup = [];
              hasSeenCallExpression = false;
            }
            if (isCallExpression(printedNodes[i2].node) || printedNodes[i2].node.type === "ImportExpression") {
              hasSeenCallExpression = true;
            }
            currentGroup.push(printedNodes[i2]);
            if (hasComment(printedNodes[i2].node, CommentCheckFlags.Trailing)) {
              groups.push(currentGroup);
              currentGroup = [];
              hasSeenCallExpression = false;
            }
          }
          if (currentGroup.length > 0) {
            groups.push(currentGroup);
          }
          function isFactory(name) {
            return /^[A-Z]|^[$_]+$/.test(name);
          }
          function isShort(name) {
            return name.length <= options.tabWidth;
          }
          function shouldNotWrap(groups2) {
            const hasComputed = groups2[1].length > 0 && groups2[1][0].node.computed;
            if (groups2[0].length === 1) {
              const firstNode = groups2[0][0].node;
              return firstNode.type === "ThisExpression" || firstNode.type === "Identifier" && (isFactory(firstNode.name) || isExpressionStatement && isShort(firstNode.name) || hasComputed);
            }
            const lastNode = getLast(groups2[0]).node;
            return isMemberExpression(lastNode) && lastNode.property.type === "Identifier" && (isFactory(lastNode.property.name) || hasComputed);
          }
          const shouldMerge = groups.length >= 2 && !hasComment(groups[1][0].node) && shouldNotWrap(groups);
          function printGroup(printedGroup) {
            const printed = printedGroup.map((tuple) => tuple.printed);
            if (printedGroup.length > 0 && getLast(printedGroup).needsParens) {
              return ["(", ...printed, ")"];
            }
            return printed;
          }
          function printIndentedGroup(groups2) {
            if (groups2.length === 0) {
              return "";
            }
            return indent(group([hardline, join(hardline, groups2.map(printGroup))]));
          }
          const printedGroups = groups.map(printGroup);
          const oneLine = printedGroups;
          const cutoff = shouldMerge ? 3 : 2;
          const flatGroups = groups.flat();
          const nodeHasComment = flatGroups.slice(1, -1).some((node2) => hasComment(node2.node, CommentCheckFlags.Leading)) || flatGroups.slice(0, -1).some((node2) => hasComment(node2.node, CommentCheckFlags.Trailing)) || groups[cutoff] && hasComment(groups[cutoff][0].node, CommentCheckFlags.Leading);
          if (groups.length <= cutoff && !nodeHasComment) {
            if (isLongCurriedCallExpression(path4)) {
              return oneLine;
            }
            return group(oneLine);
          }
          const lastNodeBeforeIndent = getLast(groups[shouldMerge ? 1 : 0]).node;
          const shouldHaveEmptyLineBeforeIndent = !isCallExpression(lastNodeBeforeIndent) && shouldInsertEmptyLineAfter(lastNodeBeforeIndent);
          const expanded = [printGroup(groups[0]), shouldMerge ? groups.slice(1, 2).map(printGroup) : "", shouldHaveEmptyLineBeforeIndent ? hardline : "", printIndentedGroup(groups.slice(shouldMerge ? 2 : 1))];
          const callExpressions = printedNodes.map(({
            node: node2
          }) => node2).filter(isCallExpression);
          function lastGroupWillBreakAndOtherCallsHaveFunctionArguments() {
            const lastGroupNode = getLast(getLast(groups)).node;
            const lastGroupDoc = getLast(printedGroups);
            return isCallExpression(lastGroupNode) && willBreak(lastGroupDoc) && callExpressions.slice(0, -1).some((node2) => node2.arguments.some(isFunctionOrArrowExpression));
          }
          let result;
          if (nodeHasComment || callExpressions.length > 2 && callExpressions.some((expr) => !expr.arguments.every((arg) => isSimpleCallArgument(arg, 0))) || printedGroups.slice(0, -1).some(willBreak) || lastGroupWillBreakAndOtherCallsHaveFunctionArguments()) {
            result = group(expanded);
          } else {
            result = [willBreak(oneLine) || shouldHaveEmptyLineBeforeIndent ? breakParent : "", conditionalGroup([oneLine, expanded])];
          }
          return label("member-chain", result);
        }
        module22.exports = printMemberChain;
      }
    });
    var require_call_expression = __commonJS22({
      "src/language-js/print/call-expression.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            join,
            group
          }
        } = require_doc();
        var pathNeedsParens = require_needs_parens();
        var {
          getCallArguments,
          hasFlowAnnotationComment,
          isCallExpression,
          isMemberish,
          isStringLiteral,
          isTemplateOnItsOwnLine,
          isTestCall,
          iterateCallArgumentsPath
        } = require_utils72();
        var printMemberChain = require_member_chain();
        var printCallArguments = require_call_arguments();
        var {
          printOptionalToken,
          printFunctionTypeParameters
        } = require_misc();
        function printCallExpression(path4, options, print) {
          const node = path4.getValue();
          const parentNode = path4.getParentNode();
          const isNew = node.type === "NewExpression";
          const isDynamicImport = node.type === "ImportExpression";
          const optional = printOptionalToken(path4);
          const args = getCallArguments(node);
          if (args.length > 0 && (!isDynamicImport && !isNew && isCommonsJsOrAmdCall(node, parentNode) || args.length === 1 && isTemplateOnItsOwnLine(args[0], options.originalText) || !isNew && isTestCall(node, parentNode))) {
            const printed = [];
            iterateCallArgumentsPath(path4, () => {
              printed.push(print());
            });
            return [isNew ? "new " : "", print("callee"), optional, printFunctionTypeParameters(path4, options, print), "(", join(", ", printed), ")"];
          }
          const isIdentifierWithFlowAnnotation = (options.parser === "babel" || options.parser === "babel-flow") && node.callee && node.callee.type === "Identifier" && hasFlowAnnotationComment(node.callee.trailingComments);
          if (isIdentifierWithFlowAnnotation) {
            node.callee.trailingComments[0].printed = true;
          }
          if (!isDynamicImport && !isNew && isMemberish(node.callee) && !path4.call((path22) => pathNeedsParens(path22, options), "callee")) {
            return printMemberChain(path4, options, print);
          }
          const contents = [isNew ? "new " : "", isDynamicImport ? "import" : print("callee"), optional, isIdentifierWithFlowAnnotation ? `/*:: ${node.callee.trailingComments[0].value.slice(2).trim()} */` : "", printFunctionTypeParameters(path4, options, print), printCallArguments(path4, options, print)];
          if (isDynamicImport || isCallExpression(node.callee)) {
            return group(contents);
          }
          return contents;
        }
        function isCommonsJsOrAmdCall(node, parentNode) {
          if (node.callee.type !== "Identifier") {
            return false;
          }
          if (node.callee.name === "require") {
            return true;
          }
          if (node.callee.name === "define") {
            const args = getCallArguments(node);
            return parentNode.type === "ExpressionStatement" && (args.length === 1 || args.length === 2 && args[0].type === "ArrayExpression" || args.length === 3 && isStringLiteral(args[0]) && args[1].type === "ArrayExpression");
          }
          return false;
        }
        module22.exports = {
          printCallExpression
        };
      }
    });
    var require_assignment = __commonJS22({
      "src/language-js/print/assignment.js"(exports2, module22) {
        "use strict";
        var {
          isNonEmptyArray,
          getStringWidth
        } = require_util();
        var {
          builders: {
            line,
            group,
            indent,
            indentIfBreak,
            lineSuffixBoundary
          },
          utils: {
            cleanDoc,
            willBreak,
            canBreak
          }
        } = require_doc();
        var {
          hasLeadingOwnLineComment,
          isBinaryish,
          isStringLiteral,
          isLiteral,
          isNumericLiteral,
          isCallExpression,
          isMemberExpression,
          getCallArguments,
          rawText,
          hasComment,
          isSignedNumericLiteral,
          isObjectProperty
        } = require_utils72();
        var {
          shouldInlineLogicalExpression
        } = require_binaryish();
        var {
          printCallExpression
        } = require_call_expression();
        function printAssignment(path4, options, print, leftDoc, operator, rightPropertyName) {
          const layout = chooseLayout(path4, options, print, leftDoc, rightPropertyName);
          const rightDoc = print(rightPropertyName, {
            assignmentLayout: layout
          });
          switch (layout) {
            case "break-after-operator":
              return group([group(leftDoc), operator, group(indent([line, rightDoc]))]);
            case "never-break-after-operator":
              return group([group(leftDoc), operator, " ", rightDoc]);
            case "fluid": {
              const groupId = Symbol("assignment");
              return group([group(leftDoc), operator, group(indent(line), {
                id: groupId
              }), lineSuffixBoundary, indentIfBreak(rightDoc, {
                groupId
              })]);
            }
            case "break-lhs":
              return group([leftDoc, operator, " ", group(rightDoc)]);
            case "chain":
              return [group(leftDoc), operator, line, rightDoc];
            case "chain-tail":
              return [group(leftDoc), operator, indent([line, rightDoc])];
            case "chain-tail-arrow-chain":
              return [group(leftDoc), operator, rightDoc];
            case "only-left":
              return leftDoc;
          }
        }
        function printAssignmentExpression(path4, options, print) {
          const node = path4.getValue();
          return printAssignment(path4, options, print, print("left"), [" ", node.operator], "right");
        }
        function printVariableDeclarator(path4, options, print) {
          return printAssignment(path4, options, print, print("id"), " =", "init");
        }
        function chooseLayout(path4, options, print, leftDoc, rightPropertyName) {
          const node = path4.getValue();
          const rightNode = node[rightPropertyName];
          if (!rightNode) {
            return "only-left";
          }
          const isTail = !isAssignment(rightNode);
          const shouldUseChainFormatting = path4.match(isAssignment, isAssignmentOrVariableDeclarator, (node2) => !isTail || node2.type !== "ExpressionStatement" && node2.type !== "VariableDeclaration");
          if (shouldUseChainFormatting) {
            return !isTail ? "chain" : rightNode.type === "ArrowFunctionExpression" && rightNode.body.type === "ArrowFunctionExpression" ? "chain-tail-arrow-chain" : "chain-tail";
          }
          const isHeadOfLongChain = !isTail && isAssignment(rightNode.right);
          if (isHeadOfLongChain || hasLeadingOwnLineComment(options.originalText, rightNode)) {
            return "break-after-operator";
          }
          if (rightNode.type === "CallExpression" && rightNode.callee.name === "require" || options.parser === "json5" || options.parser === "json") {
            return "never-break-after-operator";
          }
          if (isComplexDestructuring(node) || isComplexTypeAliasParams(node) || hasComplexTypeAnnotation(node) || isArrowFunctionVariableDeclarator(node) && canBreak(leftDoc)) {
            return "break-lhs";
          }
          const hasShortKey = isObjectPropertyWithShortKey(node, leftDoc, options);
          if (path4.call(() => shouldBreakAfterOperator(path4, options, print, hasShortKey), rightPropertyName)) {
            return "break-after-operator";
          }
          if (hasShortKey || rightNode.type === "TemplateLiteral" || rightNode.type === "TaggedTemplateExpression" || rightNode.type === "BooleanLiteral" || isNumericLiteral(rightNode) || rightNode.type === "ClassExpression") {
            return "never-break-after-operator";
          }
          return "fluid";
        }
        function shouldBreakAfterOperator(path4, options, print, hasShortKey) {
          const rightNode = path4.getValue();
          if (isBinaryish(rightNode) && !shouldInlineLogicalExpression(rightNode)) {
            return true;
          }
          switch (rightNode.type) {
            case "StringLiteralTypeAnnotation":
            case "SequenceExpression":
              return true;
            case "ConditionalExpression": {
              const {
                test
              } = rightNode;
              return isBinaryish(test) && !shouldInlineLogicalExpression(test);
            }
            case "ClassExpression":
              return isNonEmptyArray(rightNode.decorators);
          }
          if (hasShortKey) {
            return false;
          }
          let node = rightNode;
          const propertiesForPath = [];
          for (; ; ) {
            if (node.type === "UnaryExpression") {
              node = node.argument;
              propertiesForPath.push("argument");
            } else if (node.type === "TSNonNullExpression") {
              node = node.expression;
              propertiesForPath.push("expression");
            } else {
              break;
            }
          }
          if (isStringLiteral(node) || path4.call(() => isPoorlyBreakableMemberOrCallChain(path4, options, print), ...propertiesForPath)) {
            return true;
          }
          return false;
        }
        function isComplexDestructuring(node) {
          if (isAssignmentOrVariableDeclarator(node)) {
            const leftNode = node.left || node.id;
            return leftNode.type === "ObjectPattern" && leftNode.properties.length > 2 && leftNode.properties.some((property) => isObjectProperty(property) && (!property.shorthand || property.value && property.value.type === "AssignmentPattern"));
          }
          return false;
        }
        function isAssignment(node) {
          return node.type === "AssignmentExpression";
        }
        function isAssignmentOrVariableDeclarator(node) {
          return isAssignment(node) || node.type === "VariableDeclarator";
        }
        function isComplexTypeAliasParams(node) {
          const typeParams = getTypeParametersFromTypeAlias(node);
          if (isNonEmptyArray(typeParams)) {
            const constraintPropertyName = node.type === "TSTypeAliasDeclaration" ? "constraint" : "bound";
            if (typeParams.length > 1 && typeParams.some((param) => param[constraintPropertyName] || param.default)) {
              return true;
            }
          }
          return false;
        }
        function getTypeParametersFromTypeAlias(node) {
          if (isTypeAlias(node) && node.typeParameters && node.typeParameters.params) {
            return node.typeParameters.params;
          }
          return null;
        }
        function isTypeAlias(node) {
          return node.type === "TSTypeAliasDeclaration" || node.type === "TypeAlias";
        }
        function hasComplexTypeAnnotation(node) {
          if (node.type !== "VariableDeclarator") {
            return false;
          }
          const {
            typeAnnotation
          } = node.id;
          if (!typeAnnotation || !typeAnnotation.typeAnnotation) {
            return false;
          }
          const typeParams = getTypeParametersFromTypeReference(typeAnnotation.typeAnnotation);
          return isNonEmptyArray(typeParams) && typeParams.length > 1 && typeParams.some((param) => isNonEmptyArray(getTypeParametersFromTypeReference(param)) || param.type === "TSConditionalType");
        }
        function isArrowFunctionVariableDeclarator(node) {
          return node.type === "VariableDeclarator" && node.init && node.init.type === "ArrowFunctionExpression";
        }
        function getTypeParametersFromTypeReference(node) {
          if (isTypeReference(node) && node.typeParameters && node.typeParameters.params) {
            return node.typeParameters.params;
          }
          return null;
        }
        function isTypeReference(node) {
          return node.type === "TSTypeReference" || node.type === "GenericTypeAnnotation";
        }
        function isPoorlyBreakableMemberOrCallChain(path4, options, print, deep = false) {
          const node = path4.getValue();
          const goDeeper = () => isPoorlyBreakableMemberOrCallChain(path4, options, print, true);
          if (node.type === "TSNonNullExpression") {
            return path4.call(goDeeper, "expression");
          }
          if (isCallExpression(node)) {
            const doc2 = printCallExpression(path4, options, print);
            if (doc2.label === "member-chain") {
              return false;
            }
            const args = getCallArguments(node);
            const isPoorlyBreakableCall = args.length === 0 || args.length === 1 && isLoneShortArgument(args[0], options);
            if (!isPoorlyBreakableCall) {
              return false;
            }
            if (isCallExpressionWithComplexTypeArguments(node, print)) {
              return false;
            }
            return path4.call(goDeeper, "callee");
          }
          if (isMemberExpression(node)) {
            return path4.call(goDeeper, "object");
          }
          return deep && (node.type === "Identifier" || node.type === "ThisExpression");
        }
        var LONE_SHORT_ARGUMENT_THRESHOLD_RATE = 0.25;
        function isLoneShortArgument(node, {
          printWidth
        }) {
          if (hasComment(node)) {
            return false;
          }
          const threshold = printWidth * LONE_SHORT_ARGUMENT_THRESHOLD_RATE;
          if (node.type === "ThisExpression" || node.type === "Identifier" && node.name.length <= threshold || isSignedNumericLiteral(node) && !hasComment(node.argument)) {
            return true;
          }
          const regexpPattern = node.type === "Literal" && "regex" in node && node.regex.pattern || node.type === "RegExpLiteral" && node.pattern;
          if (regexpPattern) {
            return regexpPattern.length <= threshold;
          }
          if (isStringLiteral(node)) {
            return rawText(node).length <= threshold;
          }
          if (node.type === "TemplateLiteral") {
            return node.expressions.length === 0 && node.quasis[0].value.raw.length <= threshold && !node.quasis[0].value.raw.includes("\n");
          }
          return isLiteral(node);
        }
        function isObjectPropertyWithShortKey(node, keyDoc, options) {
          if (!isObjectProperty(node)) {
            return false;
          }
          keyDoc = cleanDoc(keyDoc);
          const MIN_OVERLAP_FOR_BREAK = 3;
          return typeof keyDoc === "string" && getStringWidth(keyDoc) < options.tabWidth + MIN_OVERLAP_FOR_BREAK;
        }
        function isCallExpressionWithComplexTypeArguments(node, print) {
          const typeArgs = getTypeArgumentsFromCallExpression(node);
          if (isNonEmptyArray(typeArgs)) {
            if (typeArgs.length > 1) {
              return true;
            }
            if (typeArgs.length === 1) {
              const firstArg = typeArgs[0];
              if (firstArg.type === "TSUnionType" || firstArg.type === "UnionTypeAnnotation" || firstArg.type === "TSIntersectionType" || firstArg.type === "IntersectionTypeAnnotation" || firstArg.type === "TSTypeLiteral" || firstArg.type === "ObjectTypeAnnotation") {
                return true;
              }
            }
            const typeArgsKeyName = node.typeParameters ? "typeParameters" : "typeArguments";
            if (willBreak(print(typeArgsKeyName))) {
              return true;
            }
          }
          return false;
        }
        function getTypeArgumentsFromCallExpression(node) {
          return node.typeParameters && node.typeParameters.params || node.typeArguments && node.typeArguments.params;
        }
        module22.exports = {
          printVariableDeclarator,
          printAssignmentExpression,
          printAssignment,
          isArrowFunctionVariableDeclarator
        };
      }
    });
    var require_function_parameters = __commonJS22({
      "src/language-js/print/function-parameters.js"(exports2, module22) {
        "use strict";
        var {
          getNextNonSpaceNonCommentCharacter
        } = require_util();
        var {
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            line,
            hardline,
            softline,
            group,
            indent,
            ifBreak
          },
          utils: {
            removeLines,
            willBreak
          }
        } = require_doc();
        var {
          getFunctionParameters,
          iterateFunctionParametersPath,
          isSimpleType,
          isTestCall,
          isTypeAnnotationAFunction,
          isObjectType,
          isObjectTypePropertyAFunction,
          hasRestParameter,
          shouldPrintComma,
          hasComment,
          isNextLineEmpty
        } = require_utils72();
        var {
          locEnd
        } = require_loc();
        var {
          ArgExpansionBailout
        } = require_errors();
        var {
          printFunctionTypeParameters
        } = require_misc();
        function printFunctionParameters(path4, print, options, expandArg, printTypeParams) {
          const functionNode = path4.getValue();
          const parameters = getFunctionParameters(functionNode);
          const typeParams = printTypeParams ? printFunctionTypeParameters(path4, options, print) : "";
          if (parameters.length === 0) {
            return [typeParams, "(", printDanglingComments(path4, options, true, (comment) => getNextNonSpaceNonCommentCharacter(options.originalText, comment, locEnd) === ")"), ")"];
          }
          const parent = path4.getParentNode();
          const isParametersInTestCall = isTestCall(parent);
          const shouldHugParameters = shouldHugFunctionParameters(functionNode);
          const printed = [];
          iterateFunctionParametersPath(path4, (parameterPath, index) => {
            const isLastParameter = index === parameters.length - 1;
            if (isLastParameter && functionNode.rest) {
              printed.push("...");
            }
            printed.push(print());
            if (isLastParameter) {
              return;
            }
            printed.push(",");
            if (isParametersInTestCall || shouldHugParameters) {
              printed.push(" ");
            } else if (isNextLineEmpty(parameters[index], options)) {
              printed.push(hardline, hardline);
            } else {
              printed.push(line);
            }
          });
          if (expandArg) {
            if (willBreak(typeParams) || willBreak(printed)) {
              throw new ArgExpansionBailout();
            }
            return group([removeLines(typeParams), "(", removeLines(printed), ")"]);
          }
          const hasNotParameterDecorator = parameters.every((node) => !node.decorators);
          if (shouldHugParameters && hasNotParameterDecorator) {
            return [typeParams, "(", ...printed, ")"];
          }
          if (isParametersInTestCall) {
            return [typeParams, "(", ...printed, ")"];
          }
          const isFlowShorthandWithOneArg = (isObjectTypePropertyAFunction(parent) || isTypeAnnotationAFunction(parent) || parent.type === "TypeAlias" || parent.type === "UnionTypeAnnotation" || parent.type === "TSUnionType" || parent.type === "IntersectionTypeAnnotation" || parent.type === "FunctionTypeAnnotation" && parent.returnType === functionNode) && parameters.length === 1 && parameters[0].name === null && functionNode.this !== parameters[0] && parameters[0].typeAnnotation && functionNode.typeParameters === null && isSimpleType(parameters[0].typeAnnotation) && !functionNode.rest;
          if (isFlowShorthandWithOneArg) {
            if (options.arrowParens === "always") {
              return ["(", ...printed, ")"];
            }
            return printed;
          }
          return [typeParams, "(", indent([softline, ...printed]), ifBreak(!hasRestParameter(functionNode) && shouldPrintComma(options, "all") ? "," : ""), softline, ")"];
        }
        function shouldHugFunctionParameters(node) {
          if (!node) {
            return false;
          }
          const parameters = getFunctionParameters(node);
          if (parameters.length !== 1) {
            return false;
          }
          const [parameter] = parameters;
          return !hasComment(parameter) && (parameter.type === "ObjectPattern" || parameter.type === "ArrayPattern" || parameter.type === "Identifier" && parameter.typeAnnotation && (parameter.typeAnnotation.type === "TypeAnnotation" || parameter.typeAnnotation.type === "TSTypeAnnotation") && isObjectType(parameter.typeAnnotation.typeAnnotation) || parameter.type === "FunctionTypeParam" && isObjectType(parameter.typeAnnotation) || parameter.type === "AssignmentPattern" && (parameter.left.type === "ObjectPattern" || parameter.left.type === "ArrayPattern") && (parameter.right.type === "Identifier" || parameter.right.type === "ObjectExpression" && parameter.right.properties.length === 0 || parameter.right.type === "ArrayExpression" && parameter.right.elements.length === 0));
        }
        function getReturnTypeNode(functionNode) {
          let returnTypeNode;
          if (functionNode.returnType) {
            returnTypeNode = functionNode.returnType;
            if (returnTypeNode.typeAnnotation) {
              returnTypeNode = returnTypeNode.typeAnnotation;
            }
          } else if (functionNode.typeAnnotation) {
            returnTypeNode = functionNode.typeAnnotation;
          }
          return returnTypeNode;
        }
        function shouldGroupFunctionParameters(functionNode, returnTypeDoc) {
          const returnTypeNode = getReturnTypeNode(functionNode);
          if (!returnTypeNode) {
            return false;
          }
          const typeParameters = functionNode.typeParameters && functionNode.typeParameters.params;
          if (typeParameters) {
            if (typeParameters.length > 1) {
              return false;
            }
            if (typeParameters.length === 1) {
              const typeParameter = typeParameters[0];
              if (typeParameter.constraint || typeParameter.default) {
                return false;
              }
            }
          }
          return getFunctionParameters(functionNode).length === 1 && (isObjectType(returnTypeNode) || willBreak(returnTypeDoc));
        }
        module22.exports = {
          printFunctionParameters,
          shouldHugFunctionParameters,
          shouldGroupFunctionParameters
        };
      }
    });
    var require_type_annotation = __commonJS22({
      "src/language-js/print/type-annotation.js"(exports2, module22) {
        "use strict";
        var {
          printComments,
          printDanglingComments
        } = require_comments();
        var {
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            group,
            join,
            line,
            softline,
            indent,
            align,
            ifBreak
          }
        } = require_doc();
        var pathNeedsParens = require_needs_parens();
        var {
          locStart
        } = require_loc();
        var {
          isSimpleType,
          isObjectType,
          hasLeadingOwnLineComment,
          isObjectTypePropertyAFunction,
          shouldPrintComma
        } = require_utils72();
        var {
          printAssignment
        } = require_assignment();
        var {
          printFunctionParameters,
          shouldGroupFunctionParameters
        } = require_function_parameters();
        var {
          printArrayItems
        } = require_array4();
        function shouldHugType(node) {
          if (isSimpleType(node) || isObjectType(node)) {
            return true;
          }
          if (node.type === "UnionTypeAnnotation" || node.type === "TSUnionType") {
            const voidCount = node.types.filter((node2) => node2.type === "VoidTypeAnnotation" || node2.type === "TSVoidKeyword" || node2.type === "NullLiteralTypeAnnotation" || node2.type === "TSNullKeyword").length;
            const hasObject = node.types.some((node2) => node2.type === "ObjectTypeAnnotation" || node2.type === "TSTypeLiteral" || node2.type === "GenericTypeAnnotation" || node2.type === "TSTypeReference");
            if (node.types.length - 1 === voidCount && hasObject) {
              return true;
            }
          }
          return false;
        }
        function printOpaqueType(path4, options, print) {
          const semi = options.semi ? ";" : "";
          const node = path4.getValue();
          const parts = [];
          parts.push("opaque type ", print("id"), print("typeParameters"));
          if (node.supertype) {
            parts.push(": ", print("supertype"));
          }
          if (node.impltype) {
            parts.push(" = ", print("impltype"));
          }
          parts.push(semi);
          return parts;
        }
        function printTypeAlias(path4, options, print) {
          const semi = options.semi ? ";" : "";
          const node = path4.getValue();
          const parts = [];
          if (node.declare) {
            parts.push("declare ");
          }
          parts.push("type ", print("id"), print("typeParameters"));
          const rightPropertyName = node.type === "TSTypeAliasDeclaration" ? "typeAnnotation" : "right";
          return [printAssignment(path4, options, print, parts, " =", rightPropertyName), semi];
        }
        function printIntersectionType(path4, options, print) {
          const node = path4.getValue();
          const types3 = path4.map(print, "types");
          const result = [];
          let wasIndented = false;
          for (let i2 = 0; i2 < types3.length; ++i2) {
            if (i2 === 0) {
              result.push(types3[i2]);
            } else if (isObjectType(node.types[i2 - 1]) && isObjectType(node.types[i2])) {
              result.push([" & ", wasIndented ? indent(types3[i2]) : types3[i2]]);
            } else if (!isObjectType(node.types[i2 - 1]) && !isObjectType(node.types[i2])) {
              result.push(indent([" &", line, types3[i2]]));
            } else {
              if (i2 > 1) {
                wasIndented = true;
              }
              result.push(" & ", i2 > 1 ? indent(types3[i2]) : types3[i2]);
            }
          }
          return group(result);
        }
        function printUnionType(path4, options, print) {
          const node = path4.getValue();
          const parent = path4.getParentNode();
          const shouldIndent = parent.type !== "TypeParameterInstantiation" && parent.type !== "TSTypeParameterInstantiation" && parent.type !== "GenericTypeAnnotation" && parent.type !== "TSTypeReference" && parent.type !== "TSTypeAssertion" && parent.type !== "TupleTypeAnnotation" && parent.type !== "TSTupleType" && !(parent.type === "FunctionTypeParam" && !parent.name && path4.getParentNode(1).this !== parent) && !((parent.type === "TypeAlias" || parent.type === "VariableDeclarator" || parent.type === "TSTypeAliasDeclaration") && hasLeadingOwnLineComment(options.originalText, node));
          const shouldHug = shouldHugType(node);
          const printed = path4.map((typePath) => {
            let printedType = print();
            if (!shouldHug) {
              printedType = align(2, printedType);
            }
            return printComments(typePath, printedType, options);
          }, "types");
          if (shouldHug) {
            return join(" | ", printed);
          }
          const shouldAddStartLine = shouldIndent && !hasLeadingOwnLineComment(options.originalText, node);
          const code = [ifBreak([shouldAddStartLine ? line : "", "| "]), join([line, "| "], printed)];
          if (pathNeedsParens(path4, options)) {
            return group([indent(code), softline]);
          }
          if (parent.type === "TupleTypeAnnotation" && parent.types.length > 1 || parent.type === "TSTupleType" && parent.elementTypes.length > 1) {
            return group([indent([ifBreak(["(", softline]), code]), softline, ifBreak(")")]);
          }
          return group(shouldIndent ? indent(code) : code);
        }
        function printFunctionType(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          const parent = path4.getParentNode(0);
          const parentParent = path4.getParentNode(1);
          const parentParentParent = path4.getParentNode(2);
          let isArrowFunctionTypeAnnotation = node.type === "TSFunctionType" || !((parent.type === "ObjectTypeProperty" || parent.type === "ObjectTypeInternalSlot") && !parent.variance && !parent.optional && locStart(parent) === locStart(node) || parent.type === "ObjectTypeCallProperty" || parentParentParent && parentParentParent.type === "DeclareFunction");
          let needsColon = isArrowFunctionTypeAnnotation && (parent.type === "TypeAnnotation" || parent.type === "TSTypeAnnotation");
          const needsParens = needsColon && isArrowFunctionTypeAnnotation && (parent.type === "TypeAnnotation" || parent.type === "TSTypeAnnotation") && parentParent.type === "ArrowFunctionExpression";
          if (isObjectTypePropertyAFunction(parent)) {
            isArrowFunctionTypeAnnotation = true;
            needsColon = true;
          }
          if (needsParens) {
            parts.push("(");
          }
          const parametersDoc = printFunctionParameters(path4, print, options, false, true);
          const returnTypeDoc = node.returnType || node.predicate || node.typeAnnotation ? [isArrowFunctionTypeAnnotation ? " => " : ": ", print("returnType"), print("predicate"), print("typeAnnotation")] : "";
          const shouldGroupParameters = shouldGroupFunctionParameters(node, returnTypeDoc);
          parts.push(shouldGroupParameters ? group(parametersDoc) : parametersDoc);
          if (returnTypeDoc) {
            parts.push(returnTypeDoc);
          }
          if (needsParens) {
            parts.push(")");
          }
          return group(parts);
        }
        function printTupleType(path4, options, print) {
          const node = path4.getValue();
          const typesField = node.type === "TSTupleType" ? "elementTypes" : "types";
          const types3 = node[typesField];
          const isNonEmptyTuple = isNonEmptyArray(types3);
          const bracketsDelimiterLine = isNonEmptyTuple ? softline : "";
          return group(["[", indent([bracketsDelimiterLine, printArrayItems(path4, options, typesField, print)]), ifBreak(isNonEmptyTuple && shouldPrintComma(options, "all") ? "," : ""), printDanglingComments(path4, options, true), bracketsDelimiterLine, "]"]);
        }
        function printIndexedAccessType(path4, options, print) {
          const node = path4.getValue();
          const leftDelimiter = node.type === "OptionalIndexedAccessType" && node.optional ? "?.[" : "[";
          return [print("objectType"), leftDelimiter, print("indexType"), "]"];
        }
        function printJSDocType(path4, print, token) {
          const node = path4.getValue();
          return [node.postfix ? "" : token, print("typeAnnotation"), node.postfix ? token : ""];
        }
        module22.exports = {
          printOpaqueType,
          printTypeAlias,
          printIntersectionType,
          printUnionType,
          printFunctionType,
          printTupleType,
          printIndexedAccessType,
          shouldHugType,
          printJSDocType
        };
      }
    });
    var require_type_parameters = __commonJS22({
      "src/language-js/print/type-parameters.js"(exports2, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            join,
            line,
            hardline,
            softline,
            group,
            indent,
            ifBreak
          }
        } = require_doc();
        var {
          isTestCall,
          hasComment,
          CommentCheckFlags,
          isTSXFile,
          shouldPrintComma,
          getFunctionParameters,
          isObjectType
        } = require_utils72();
        var {
          createGroupIdMapper
        } = require_util();
        var {
          shouldHugType
        } = require_type_annotation();
        var {
          isArrowFunctionVariableDeclarator
        } = require_assignment();
        var getTypeParametersGroupId = createGroupIdMapper("typeParameters");
        function printTypeParameters(path4, options, print, paramsKey) {
          const node = path4.getValue();
          if (!node[paramsKey]) {
            return "";
          }
          if (!Array.isArray(node[paramsKey])) {
            return print(paramsKey);
          }
          const grandparent = path4.getNode(2);
          const isParameterInTestCall = grandparent && isTestCall(grandparent);
          const isArrowFunctionVariable = path4.match((node2) => !(node2[paramsKey].length === 1 && isObjectType(node2[paramsKey][0])), void 0, (node2, name) => name === "typeAnnotation", (node2) => node2.type === "Identifier", isArrowFunctionVariableDeclarator);
          const shouldInline = !isArrowFunctionVariable && (isParameterInTestCall || node[paramsKey].length === 0 || node[paramsKey].length === 1 && (node[paramsKey][0].type === "NullableTypeAnnotation" || shouldHugType(node[paramsKey][0])));
          if (shouldInline) {
            return ["<", join(", ", path4.map(print, paramsKey)), printDanglingCommentsForInline(path4, options), ">"];
          }
          const trailingComma = node.type === "TSTypeParameterInstantiation" ? "" : getFunctionParameters(node).length === 1 && isTSXFile(options) && !node[paramsKey][0].constraint && path4.getParentNode().type === "ArrowFunctionExpression" ? "," : shouldPrintComma(options, "all") ? ifBreak(",") : "";
          return group(["<", indent([softline, join([",", line], path4.map(print, paramsKey))]), trailingComma, softline, ">"], {
            id: getTypeParametersGroupId(node)
          });
        }
        function printDanglingCommentsForInline(path4, options) {
          const node = path4.getValue();
          if (!hasComment(node, CommentCheckFlags.Dangling)) {
            return "";
          }
          const hasOnlyBlockComments = !hasComment(node, CommentCheckFlags.Line);
          const printed = printDanglingComments(path4, options, hasOnlyBlockComments);
          if (hasOnlyBlockComments) {
            return printed;
          }
          return [printed, hardline];
        }
        function printTypeParameter(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          const parent = path4.getParentNode();
          if (parent.type === "TSMappedType") {
            parts.push("[", print("name"));
            if (node.constraint) {
              parts.push(" in ", print("constraint"));
            }
            if (parent.nameType) {
              parts.push(" as ", path4.callParent(() => print("nameType")));
            }
            parts.push("]");
            return parts;
          }
          if (node.variance) {
            parts.push(print("variance"));
          }
          if (node.in) {
            parts.push("in ");
          }
          if (node.out) {
            parts.push("out ");
          }
          parts.push(print("name"));
          if (node.bound) {
            parts.push(": ", print("bound"));
          }
          if (node.constraint) {
            parts.push(" extends ", print("constraint"));
          }
          if (node.default) {
            parts.push(" = ", print("default"));
          }
          return parts;
        }
        module22.exports = {
          printTypeParameter,
          printTypeParameters,
          getTypeParametersGroupId
        };
      }
    });
    var require_property = __commonJS22({
      "src/language-js/print/property.js"(exports2, module22) {
        "use strict";
        var {
          printComments
        } = require_comments();
        var {
          printString,
          printNumber
        } = require_util();
        var {
          isNumericLiteral,
          isSimpleNumber,
          isStringLiteral,
          isStringPropSafeToUnquote,
          rawText
        } = require_utils72();
        var {
          printAssignment
        } = require_assignment();
        var needsQuoteProps = /* @__PURE__ */ new WeakMap();
        function printPropertyKey(path4, options, print) {
          const node = path4.getNode();
          if (node.computed) {
            return ["[", print("key"), "]"];
          }
          const parent = path4.getParentNode();
          const {
            key
          } = node;
          if (node.type === "ClassPrivateProperty" && key.type === "Identifier") {
            return ["#", print("key")];
          }
          if (options.quoteProps === "consistent" && !needsQuoteProps.has(parent)) {
            const objectHasStringProp = (parent.properties || parent.body || parent.members).some((prop) => !prop.computed && prop.key && isStringLiteral(prop.key) && !isStringPropSafeToUnquote(prop, options));
            needsQuoteProps.set(parent, objectHasStringProp);
          }
          if ((key.type === "Identifier" || isNumericLiteral(key) && isSimpleNumber(printNumber(rawText(key))) && String(key.value) === printNumber(rawText(key)) && !(options.parser === "typescript" || options.parser === "babel-ts")) && (options.parser === "json" || options.quoteProps === "consistent" && needsQuoteProps.get(parent))) {
            const prop = printString(JSON.stringify(key.type === "Identifier" ? key.name : key.value.toString()), options);
            return path4.call((keyPath) => printComments(keyPath, prop, options), "key");
          }
          if (isStringPropSafeToUnquote(node, options) && (options.quoteProps === "as-needed" || options.quoteProps === "consistent" && !needsQuoteProps.get(parent))) {
            return path4.call((keyPath) => printComments(keyPath, /^\d/.test(key.value) ? printNumber(key.value) : key.value, options), "key");
          }
          return print("key");
        }
        function printProperty(path4, options, print) {
          const node = path4.getValue();
          if (node.shorthand) {
            return print("value");
          }
          return printAssignment(path4, options, print, printPropertyKey(path4, options, print), ":", "value");
        }
        module22.exports = {
          printProperty,
          printPropertyKey
        };
      }
    });
    var require_function2 = __commonJS22({
      "src/language-js/print/function.js"(exports2, module22) {
        "use strict";
        var assert = require("assert");
        var {
          printDanglingComments,
          printCommentsSeparately
        } = require_comments();
        var getLast = require_get_last();
        var {
          getNextNonSpaceNonCommentCharacterIndex
        } = require_util();
        var {
          builders: {
            line,
            softline,
            group,
            indent,
            ifBreak,
            hardline,
            join,
            indentIfBreak
          },
          utils: {
            removeLines,
            willBreak
          }
        } = require_doc();
        var {
          ArgExpansionBailout
        } = require_errors();
        var {
          getFunctionParameters,
          hasLeadingOwnLineComment,
          isFlowAnnotationComment,
          isJsxNode,
          isTemplateOnItsOwnLine,
          shouldPrintComma,
          startsWithNoLookaheadToken,
          isBinaryish,
          isLineComment,
          hasComment,
          getComments,
          CommentCheckFlags,
          isCallLikeExpression,
          isCallExpression,
          getCallArguments,
          hasNakedLeftSide,
          getLeftSide
        } = require_utils72();
        var {
          locEnd
        } = require_loc();
        var {
          printFunctionParameters,
          shouldGroupFunctionParameters
        } = require_function_parameters();
        var {
          printPropertyKey
        } = require_property();
        var {
          printFunctionTypeParameters
        } = require_misc();
        function printFunction(path4, print, options, args) {
          const node = path4.getValue();
          let expandArg = false;
          if ((node.type === "FunctionDeclaration" || node.type === "FunctionExpression") && args && args.expandLastArg) {
            const parent = path4.getParentNode();
            if (isCallExpression(parent) && getCallArguments(parent).length > 1) {
              expandArg = true;
            }
          }
          const parts = [];
          if (node.type === "TSDeclareFunction" && node.declare) {
            parts.push("declare ");
          }
          if (node.async) {
            parts.push("async ");
          }
          if (node.generator) {
            parts.push("function* ");
          } else {
            parts.push("function ");
          }
          if (node.id) {
            parts.push(print("id"));
          }
          const parametersDoc = printFunctionParameters(path4, print, options, expandArg);
          const returnTypeDoc = printReturnType(path4, print, options);
          const shouldGroupParameters = shouldGroupFunctionParameters(node, returnTypeDoc);
          parts.push(printFunctionTypeParameters(path4, options, print), group([shouldGroupParameters ? group(parametersDoc) : parametersDoc, returnTypeDoc]), node.body ? " " : "", print("body"));
          if (options.semi && (node.declare || !node.body)) {
            parts.push(";");
          }
          return parts;
        }
        function printMethod(path4, options, print) {
          const node = path4.getNode();
          const {
            kind
          } = node;
          const value = node.value || node;
          const parts = [];
          if (!kind || kind === "init" || kind === "method" || kind === "constructor") {
            if (value.async) {
              parts.push("async ");
            }
          } else {
            assert.ok(kind === "get" || kind === "set");
            parts.push(kind, " ");
          }
          if (value.generator) {
            parts.push("*");
          }
          parts.push(printPropertyKey(path4, options, print), node.optional || node.key.optional ? "?" : "");
          if (node === value) {
            parts.push(printMethodInternal(path4, options, print));
          } else if (value.type === "FunctionExpression") {
            parts.push(path4.call((path22) => printMethodInternal(path22, options, print), "value"));
          } else {
            parts.push(print("value"));
          }
          return parts;
        }
        function printMethodInternal(path4, options, print) {
          const node = path4.getNode();
          const parametersDoc = printFunctionParameters(path4, print, options);
          const returnTypeDoc = printReturnType(path4, print, options);
          const shouldGroupParameters = shouldGroupFunctionParameters(node, returnTypeDoc);
          const parts = [printFunctionTypeParameters(path4, options, print), group([shouldGroupParameters ? group(parametersDoc) : parametersDoc, returnTypeDoc])];
          if (node.body) {
            parts.push(" ", print("body"));
          } else {
            parts.push(options.semi ? ";" : "");
          }
          return parts;
        }
        function printArrowFunctionSignature(path4, options, print, args) {
          const node = path4.getValue();
          const parts = [];
          if (node.async) {
            parts.push("async ");
          }
          if (shouldPrintParamsWithoutParens(path4, options)) {
            parts.push(print(["params", 0]));
          } else {
            const expandArg = args && (args.expandLastArg || args.expandFirstArg);
            let returnTypeDoc = printReturnType(path4, print, options);
            if (expandArg) {
              if (willBreak(returnTypeDoc)) {
                throw new ArgExpansionBailout();
              }
              returnTypeDoc = group(removeLines(returnTypeDoc));
            }
            parts.push(group([printFunctionParameters(path4, print, options, expandArg, true), returnTypeDoc]));
          }
          const dangling = printDanglingComments(path4, options, true, (comment) => {
            const nextCharacter = getNextNonSpaceNonCommentCharacterIndex(options.originalText, comment, locEnd);
            return nextCharacter !== false && options.originalText.slice(nextCharacter, nextCharacter + 2) === "=>";
          });
          if (dangling) {
            parts.push(" ", dangling);
          }
          return parts;
        }
        function printArrowChain(path4, args, signatures, shouldBreak, bodyDoc, tailNode) {
          const name = path4.getName();
          const parent = path4.getParentNode();
          const isCallee = isCallLikeExpression(parent) && name === "callee";
          const isAssignmentRhs = Boolean(args && args.assignmentLayout);
          const shouldPutBodyOnSeparateLine = tailNode.body.type !== "BlockStatement" && tailNode.body.type !== "ObjectExpression" && tailNode.body.type !== "SequenceExpression";
          const shouldBreakBeforeChain = isCallee && shouldPutBodyOnSeparateLine || args && args.assignmentLayout === "chain-tail-arrow-chain";
          const groupId = Symbol("arrow-chain");
          if (tailNode.body.type === "SequenceExpression") {
            bodyDoc = group(["(", indent([softline, bodyDoc]), softline, ")"]);
          }
          return group([group(indent([isCallee || isAssignmentRhs ? softline : "", group(join([" =>", line], signatures), {
            shouldBreak
          })]), {
            id: groupId,
            shouldBreak: shouldBreakBeforeChain
          }), " =>", indentIfBreak(shouldPutBodyOnSeparateLine ? indent([line, bodyDoc]) : [" ", bodyDoc], {
            groupId
          }), isCallee ? ifBreak(softline, "", {
            groupId
          }) : ""]);
        }
        function printArrowFunction(path4, options, print, args) {
          let node = path4.getValue();
          const signatures = [];
          const body = [];
          let chainShouldBreak = false;
          (function rec() {
            const doc2 = printArrowFunctionSignature(path4, options, print, args);
            if (signatures.length === 0) {
              signatures.push(doc2);
            } else {
              const {
                leading,
                trailing
              } = printCommentsSeparately(path4, options);
              signatures.push([leading, doc2]);
              body.unshift(trailing);
            }
            chainShouldBreak = chainShouldBreak || node.returnType && getFunctionParameters(node).length > 0 || node.typeParameters || getFunctionParameters(node).some((param) => param.type !== "Identifier");
            if (node.body.type !== "ArrowFunctionExpression" || args && args.expandLastArg) {
              body.unshift(print("body", args));
            } else {
              node = node.body;
              path4.call(rec, "body");
            }
          })();
          if (signatures.length > 1) {
            return printArrowChain(path4, args, signatures, chainShouldBreak, body, node);
          }
          const parts = signatures;
          parts.push(" =>");
          if (!hasLeadingOwnLineComment(options.originalText, node.body) && (node.body.type === "ArrayExpression" || node.body.type === "ObjectExpression" || node.body.type === "BlockStatement" || isJsxNode(node.body) || isTemplateOnItsOwnLine(node.body, options.originalText) || node.body.type === "ArrowFunctionExpression" || node.body.type === "DoExpression")) {
            return group([...parts, " ", body]);
          }
          if (node.body.type === "SequenceExpression") {
            return group([...parts, group([" (", indent([softline, body]), softline, ")"])]);
          }
          const shouldAddSoftLine = (args && args.expandLastArg || path4.getParentNode().type === "JSXExpressionContainer") && !hasComment(node);
          const printTrailingComma = args && args.expandLastArg && shouldPrintComma(options, "all");
          const shouldAddParens = node.body.type === "ConditionalExpression" && !startsWithNoLookaheadToken(node.body, false);
          return group([...parts, group([indent([line, shouldAddParens ? ifBreak("", "(") : "", body, shouldAddParens ? ifBreak("", ")") : ""]), shouldAddSoftLine ? [ifBreak(printTrailingComma ? "," : ""), softline] : ""])]);
        }
        function canPrintParamsWithoutParens(node) {
          const parameters = getFunctionParameters(node);
          return parameters.length === 1 && !node.typeParameters && !hasComment(node, CommentCheckFlags.Dangling) && parameters[0].type === "Identifier" && !parameters[0].typeAnnotation && !hasComment(parameters[0]) && !parameters[0].optional && !node.predicate && !node.returnType;
        }
        function shouldPrintParamsWithoutParens(path4, options) {
          if (options.arrowParens === "always") {
            return false;
          }
          if (options.arrowParens === "avoid") {
            const node = path4.getValue();
            return canPrintParamsWithoutParens(node);
          }
          return false;
        }
        function printReturnType(path4, print, options) {
          const node = path4.getValue();
          const returnType = print("returnType");
          if (node.returnType && isFlowAnnotationComment(options.originalText, node.returnType)) {
            return [" /*: ", returnType, " */"];
          }
          const parts = [returnType];
          if (node.returnType && node.returnType.typeAnnotation) {
            parts.unshift(": ");
          }
          if (node.predicate) {
            parts.push(node.returnType ? " " : ": ", print("predicate"));
          }
          return parts;
        }
        function printReturnOrThrowArgument(path4, options, print) {
          const node = path4.getValue();
          const semi = options.semi ? ";" : "";
          const parts = [];
          if (node.argument) {
            if (returnArgumentHasLeadingComment(options, node.argument)) {
              parts.push([" (", indent([hardline, print("argument")]), hardline, ")"]);
            } else if (isBinaryish(node.argument) || node.argument.type === "SequenceExpression") {
              parts.push(group([ifBreak(" (", " "), indent([softline, print("argument")]), softline, ifBreak(")")]));
            } else {
              parts.push(" ", print("argument"));
            }
          }
          const comments = getComments(node);
          const lastComment = getLast(comments);
          const isLastCommentLine = lastComment && isLineComment(lastComment);
          if (isLastCommentLine) {
            parts.push(semi);
          }
          if (hasComment(node, CommentCheckFlags.Dangling)) {
            parts.push(" ", printDanglingComments(path4, options, true));
          }
          if (!isLastCommentLine) {
            parts.push(semi);
          }
          return parts;
        }
        function printReturnStatement(path4, options, print) {
          return ["return", printReturnOrThrowArgument(path4, options, print)];
        }
        function printThrowStatement(path4, options, print) {
          return ["throw", printReturnOrThrowArgument(path4, options, print)];
        }
        function returnArgumentHasLeadingComment(options, argument) {
          if (hasLeadingOwnLineComment(options.originalText, argument)) {
            return true;
          }
          if (hasNakedLeftSide(argument)) {
            let leftMost = argument;
            let newLeftMost;
            while (newLeftMost = getLeftSide(leftMost)) {
              leftMost = newLeftMost;
              if (hasLeadingOwnLineComment(options.originalText, leftMost)) {
                return true;
              }
            }
          }
          return false;
        }
        module22.exports = {
          printFunction,
          printArrowFunction,
          printMethod,
          printReturnStatement,
          printThrowStatement,
          printMethodInternal,
          shouldPrintParamsWithoutParens
        };
      }
    });
    var require_decorators = __commonJS22({
      "src/language-js/print/decorators.js"(exports2, module22) {
        "use strict";
        var {
          isNonEmptyArray,
          hasNewline
        } = require_util();
        var {
          builders: {
            line,
            hardline,
            join,
            breakParent,
            group
          }
        } = require_doc();
        var {
          locStart,
          locEnd
        } = require_loc();
        var {
          getParentExportDeclaration
        } = require_utils72();
        function printClassMemberDecorators(path4, options, print) {
          const node = path4.getValue();
          return group([join(line, path4.map(print, "decorators")), hasNewlineBetweenOrAfterDecorators(node, options) ? hardline : line]);
        }
        function printDecoratorsBeforeExport(path4, options, print) {
          return [join(hardline, path4.map(print, "declaration", "decorators")), hardline];
        }
        function printDecorators(path4, options, print) {
          const node = path4.getValue();
          const {
            decorators
          } = node;
          if (!isNonEmptyArray(decorators) || hasDecoratorsBeforeExport(path4.getParentNode())) {
            return;
          }
          const shouldBreak = node.type === "ClassExpression" || node.type === "ClassDeclaration" || hasNewlineBetweenOrAfterDecorators(node, options);
          return [getParentExportDeclaration(path4) ? hardline : shouldBreak ? breakParent : "", join(line, path4.map(print, "decorators")), line];
        }
        function hasNewlineBetweenOrAfterDecorators(node, options) {
          return node.decorators.some((decorator) => hasNewline(options.originalText, locEnd(decorator)));
        }
        function hasDecoratorsBeforeExport(node) {
          if (node.type !== "ExportDefaultDeclaration" && node.type !== "ExportNamedDeclaration" && node.type !== "DeclareExportDeclaration") {
            return false;
          }
          const decorators = node.declaration && node.declaration.decorators;
          return isNonEmptyArray(decorators) && locStart(node, {
            ignoreDecorators: true
          }) > locStart(decorators[0]);
        }
        module22.exports = {
          printDecorators,
          printClassMemberDecorators,
          printDecoratorsBeforeExport,
          hasDecoratorsBeforeExport
        };
      }
    });
    var require_class = __commonJS22({
      "src/language-js/print/class.js"(exports2, module22) {
        "use strict";
        var {
          isNonEmptyArray,
          createGroupIdMapper
        } = require_util();
        var {
          printComments,
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            join,
            line,
            hardline,
            softline,
            group,
            indent,
            ifBreak
          }
        } = require_doc();
        var {
          hasComment,
          CommentCheckFlags
        } = require_utils72();
        var {
          getTypeParametersGroupId
        } = require_type_parameters();
        var {
          printMethod
        } = require_function2();
        var {
          printOptionalToken,
          printTypeAnnotation,
          printDefiniteToken
        } = require_misc();
        var {
          printPropertyKey
        } = require_property();
        var {
          printAssignment
        } = require_assignment();
        var {
          printClassMemberDecorators
        } = require_decorators();
        function printClass(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          if (node.declare) {
            parts.push("declare ");
          }
          if (node.abstract) {
            parts.push("abstract ");
          }
          parts.push("class");
          const groupMode = node.id && hasComment(node.id, CommentCheckFlags.Trailing) || node.typeParameters && hasComment(node.typeParameters, CommentCheckFlags.Trailing) || node.superClass && hasComment(node.superClass) || isNonEmptyArray(node.extends) || isNonEmptyArray(node.mixins) || isNonEmptyArray(node.implements);
          const partsGroup = [];
          const extendsParts = [];
          if (node.id) {
            partsGroup.push(" ", print("id"));
          }
          partsGroup.push(print("typeParameters"));
          if (node.superClass) {
            const printed = [printSuperClass(path4, options, print), print("superTypeParameters")];
            const printedWithComments = path4.call((superClass) => ["extends ", printComments(superClass, printed, options)], "superClass");
            if (groupMode) {
              extendsParts.push(line, group(printedWithComments));
            } else {
              extendsParts.push(" ", printedWithComments);
            }
          } else {
            extendsParts.push(printList(path4, options, print, "extends"));
          }
          extendsParts.push(printList(path4, options, print, "mixins"), printList(path4, options, print, "implements"));
          if (groupMode) {
            let printedPartsGroup;
            if (shouldIndentOnlyHeritageClauses(node)) {
              printedPartsGroup = [...partsGroup, indent(extendsParts)];
            } else {
              printedPartsGroup = indent([...partsGroup, extendsParts]);
            }
            parts.push(group(printedPartsGroup, {
              id: getHeritageGroupId(node)
            }));
          } else {
            parts.push(...partsGroup, ...extendsParts);
          }
          parts.push(" ", print("body"));
          return parts;
        }
        var getHeritageGroupId = createGroupIdMapper("heritageGroup");
        function printHardlineAfterHeritage(node) {
          return ifBreak(hardline, "", {
            groupId: getHeritageGroupId(node)
          });
        }
        function hasMultipleHeritage(node) {
          return ["superClass", "extends", "mixins", "implements"].filter((key) => Boolean(node[key])).length > 1;
        }
        function shouldIndentOnlyHeritageClauses(node) {
          return node.typeParameters && !hasComment(node.typeParameters, CommentCheckFlags.Trailing | CommentCheckFlags.Line) && !hasMultipleHeritage(node);
        }
        function printList(path4, options, print, listName) {
          const node = path4.getValue();
          if (!isNonEmptyArray(node[listName])) {
            return "";
          }
          const printedLeadingComments = printDanglingComments(path4, options, true, ({
            marker
          }) => marker === listName);
          return [shouldIndentOnlyHeritageClauses(node) ? ifBreak(" ", line, {
            groupId: getTypeParametersGroupId(node.typeParameters)
          }) : line, printedLeadingComments, printedLeadingComments && hardline, listName, group(indent([line, join([",", line], path4.map(print, listName))]))];
        }
        function printSuperClass(path4, options, print) {
          const printed = print("superClass");
          const parent = path4.getParentNode();
          if (parent.type === "AssignmentExpression") {
            return group(ifBreak(["(", indent([softline, printed]), softline, ")"], printed));
          }
          return printed;
        }
        function printClassMethod(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          if (isNonEmptyArray(node.decorators)) {
            parts.push(printClassMemberDecorators(path4, options, print));
          }
          if (node.accessibility) {
            parts.push(node.accessibility + " ");
          }
          if (node.readonly) {
            parts.push("readonly ");
          }
          if (node.declare) {
            parts.push("declare ");
          }
          if (node.static) {
            parts.push("static ");
          }
          if (node.type === "TSAbstractMethodDefinition" || node.abstract) {
            parts.push("abstract ");
          }
          if (node.override) {
            parts.push("override ");
          }
          parts.push(printMethod(path4, options, print));
          return parts;
        }
        function printClassProperty(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          const semi = options.semi ? ";" : "";
          if (isNonEmptyArray(node.decorators)) {
            parts.push(printClassMemberDecorators(path4, options, print));
          }
          if (node.accessibility) {
            parts.push(node.accessibility + " ");
          }
          if (node.declare) {
            parts.push("declare ");
          }
          if (node.static) {
            parts.push("static ");
          }
          if (node.type === "TSAbstractPropertyDefinition" || node.abstract) {
            parts.push("abstract ");
          }
          if (node.override) {
            parts.push("override ");
          }
          if (node.readonly) {
            parts.push("readonly ");
          }
          if (node.variance) {
            parts.push(print("variance"));
          }
          if (node.type === "ClassAccessorProperty") {
            parts.push("accessor ");
          }
          parts.push(printPropertyKey(path4, options, print), printOptionalToken(path4), printDefiniteToken(path4), printTypeAnnotation(path4, options, print));
          return [printAssignment(path4, options, print, parts, " =", "value"), semi];
        }
        module22.exports = {
          printClass,
          printClassMethod,
          printClassProperty,
          printHardlineAfterHeritage
        };
      }
    });
    var require_interface = __commonJS22({
      "src/language-js/print/interface.js"(exports2, module22) {
        "use strict";
        var {
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            join,
            line,
            group,
            indent,
            ifBreak
          }
        } = require_doc();
        var {
          hasComment,
          identity,
          CommentCheckFlags
        } = require_utils72();
        var {
          getTypeParametersGroupId
        } = require_type_parameters();
        var {
          printTypeScriptModifiers
        } = require_misc();
        function printInterface(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          if (node.declare) {
            parts.push("declare ");
          }
          if (node.type === "TSInterfaceDeclaration") {
            parts.push(node.abstract ? "abstract " : "", printTypeScriptModifiers(path4, options, print));
          }
          parts.push("interface");
          const partsGroup = [];
          const extendsParts = [];
          if (node.type !== "InterfaceTypeAnnotation") {
            partsGroup.push(" ", print("id"), print("typeParameters"));
          }
          const shouldIndentOnlyHeritageClauses = node.typeParameters && !hasComment(node.typeParameters, CommentCheckFlags.Trailing | CommentCheckFlags.Line);
          if (isNonEmptyArray(node.extends)) {
            extendsParts.push(shouldIndentOnlyHeritageClauses ? ifBreak(" ", line, {
              groupId: getTypeParametersGroupId(node.typeParameters)
            }) : line, "extends ", (node.extends.length === 1 ? identity : indent)(join([",", line], path4.map(print, "extends"))));
          }
          if (node.id && hasComment(node.id, CommentCheckFlags.Trailing) || isNonEmptyArray(node.extends)) {
            if (shouldIndentOnlyHeritageClauses) {
              parts.push(group([...partsGroup, indent(extendsParts)]));
            } else {
              parts.push(group(indent([...partsGroup, ...extendsParts])));
            }
          } else {
            parts.push(...partsGroup, ...extendsParts);
          }
          parts.push(" ", print("body"));
          return group(parts);
        }
        module22.exports = {
          printInterface
        };
      }
    });
    var require_module = __commonJS22({
      "src/language-js/print/module.js"(exports2, module22) {
        "use strict";
        var {
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            softline,
            group,
            indent,
            join,
            line,
            ifBreak,
            hardline
          }
        } = require_doc();
        var {
          printDanglingComments
        } = require_comments();
        var {
          hasComment,
          CommentCheckFlags,
          shouldPrintComma,
          needsHardlineAfterDanglingComment,
          isStringLiteral,
          rawText
        } = require_utils72();
        var {
          locStart,
          hasSameLoc
        } = require_loc();
        var {
          hasDecoratorsBeforeExport,
          printDecoratorsBeforeExport
        } = require_decorators();
        function printImportDeclaration(path4, options, print) {
          const node = path4.getValue();
          const semi = options.semi ? ";" : "";
          const parts = [];
          const {
            importKind
          } = node;
          parts.push("import");
          if (importKind && importKind !== "value") {
            parts.push(" ", importKind);
          }
          parts.push(printModuleSpecifiers(path4, options, print), printModuleSource(path4, options, print), printImportAssertions(path4, options, print), semi);
          return parts;
        }
        function printExportDeclaration(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          if (hasDecoratorsBeforeExport(node)) {
            parts.push(printDecoratorsBeforeExport(path4, options, print));
          }
          const {
            type,
            exportKind,
            declaration
          } = node;
          parts.push("export");
          const isDefaultExport = node.default || type === "ExportDefaultDeclaration";
          if (isDefaultExport) {
            parts.push(" default");
          }
          if (hasComment(node, CommentCheckFlags.Dangling)) {
            parts.push(" ", printDanglingComments(path4, options, true));
            if (needsHardlineAfterDanglingComment(node)) {
              parts.push(hardline);
            }
          }
          if (declaration) {
            parts.push(" ", print("declaration"));
          } else {
            parts.push(exportKind === "type" ? " type" : "", printModuleSpecifiers(path4, options, print), printModuleSource(path4, options, print), printImportAssertions(path4, options, print));
          }
          if (shouldExportDeclarationPrintSemi(node, options)) {
            parts.push(";");
          }
          return parts;
        }
        function printExportAllDeclaration(path4, options, print) {
          const node = path4.getValue();
          const semi = options.semi ? ";" : "";
          const parts = [];
          const {
            exportKind,
            exported
          } = node;
          parts.push("export");
          if (exportKind === "type") {
            parts.push(" type");
          }
          parts.push(" *");
          if (exported) {
            parts.push(" as ", print("exported"));
          }
          parts.push(printModuleSource(path4, options, print), printImportAssertions(path4, options, print), semi);
          return parts;
        }
        function shouldExportDeclarationPrintSemi(node, options) {
          if (!options.semi) {
            return false;
          }
          const {
            type,
            declaration
          } = node;
          const isDefaultExport = node.default || type === "ExportDefaultDeclaration";
          if (!declaration) {
            return true;
          }
          const {
            type: declarationType
          } = declaration;
          if (isDefaultExport && declarationType !== "ClassDeclaration" && declarationType !== "FunctionDeclaration" && declarationType !== "TSInterfaceDeclaration" && declarationType !== "DeclareClass" && declarationType !== "DeclareFunction" && declarationType !== "TSDeclareFunction" && declarationType !== "EnumDeclaration") {
            return true;
          }
          return false;
        }
        function printModuleSource(path4, options, print) {
          const node = path4.getValue();
          if (!node.source) {
            return "";
          }
          const parts = [];
          if (!shouldNotPrintSpecifiers(node, options)) {
            parts.push(" from");
          }
          parts.push(" ", print("source"));
          return parts;
        }
        function printModuleSpecifiers(path4, options, print) {
          const node = path4.getValue();
          if (shouldNotPrintSpecifiers(node, options)) {
            return "";
          }
          const parts = [" "];
          if (isNonEmptyArray(node.specifiers)) {
            const standaloneSpecifiers = [];
            const groupedSpecifiers = [];
            path4.each(() => {
              const specifierType = path4.getValue().type;
              if (specifierType === "ExportNamespaceSpecifier" || specifierType === "ExportDefaultSpecifier" || specifierType === "ImportNamespaceSpecifier" || specifierType === "ImportDefaultSpecifier") {
                standaloneSpecifiers.push(print());
              } else if (specifierType === "ExportSpecifier" || specifierType === "ImportSpecifier") {
                groupedSpecifiers.push(print());
              } else {
                throw new Error(`Unknown specifier type ${JSON.stringify(specifierType)}`);
              }
            }, "specifiers");
            parts.push(join(", ", standaloneSpecifiers));
            if (groupedSpecifiers.length > 0) {
              if (standaloneSpecifiers.length > 0) {
                parts.push(", ");
              }
              const canBreak = groupedSpecifiers.length > 1 || standaloneSpecifiers.length > 0 || node.specifiers.some((node2) => hasComment(node2));
              if (canBreak) {
                parts.push(group(["{", indent([options.bracketSpacing ? line : softline, join([",", line], groupedSpecifiers)]), ifBreak(shouldPrintComma(options) ? "," : ""), options.bracketSpacing ? line : softline, "}"]));
              } else {
                parts.push(["{", options.bracketSpacing ? " " : "", ...groupedSpecifiers, options.bracketSpacing ? " " : "", "}"]);
              }
            }
          } else {
            parts.push("{}");
          }
          return parts;
        }
        function shouldNotPrintSpecifiers(node, options) {
          const {
            type,
            importKind,
            source,
            specifiers
          } = node;
          if (type !== "ImportDeclaration" || isNonEmptyArray(specifiers) || importKind === "type") {
            return false;
          }
          return !/{\s*}/.test(options.originalText.slice(locStart(node), locStart(source)));
        }
        function printImportAssertions(path4, options, print) {
          const node = path4.getNode();
          if (isNonEmptyArray(node.assertions)) {
            return [" assert {", options.bracketSpacing ? " " : "", join(", ", path4.map(print, "assertions")), options.bracketSpacing ? " " : "", "}"];
          }
          return "";
        }
        function printModuleSpecifier(path4, options, print) {
          const node = path4.getNode();
          const {
            type
          } = node;
          const parts = [];
          const kind = type === "ImportSpecifier" ? node.importKind : node.exportKind;
          if (kind && kind !== "value") {
            parts.push(kind, " ");
          }
          const isImport = type.startsWith("Import");
          const leftSideProperty = isImport ? "imported" : "local";
          const rightSideProperty = isImport ? "local" : "exported";
          const leftSideNode = node[leftSideProperty];
          const rightSideNode = node[rightSideProperty];
          let left = "";
          let right = "";
          if (type === "ExportNamespaceSpecifier" || type === "ImportNamespaceSpecifier") {
            left = "*";
          } else if (leftSideNode) {
            left = print(leftSideProperty);
          }
          if (rightSideNode && !isShorthandSpecifier(node)) {
            right = print(rightSideProperty);
          }
          parts.push(left, left && right ? " as " : "", right);
          return parts;
        }
        function isShorthandSpecifier(specifier) {
          if (specifier.type !== "ImportSpecifier" && specifier.type !== "ExportSpecifier") {
            return false;
          }
          const {
            local,
            [specifier.type === "ImportSpecifier" ? "imported" : "exported"]: importedOrExported
          } = specifier;
          if (local.type !== importedOrExported.type || !hasSameLoc(local, importedOrExported)) {
            return false;
          }
          if (isStringLiteral(local)) {
            return local.value === importedOrExported.value && rawText(local) === rawText(importedOrExported);
          }
          switch (local.type) {
            case "Identifier":
              return local.name === importedOrExported.name;
            default:
              return false;
          }
        }
        module22.exports = {
          printImportDeclaration,
          printExportDeclaration,
          printExportAllDeclaration,
          printModuleSpecifier
        };
      }
    });
    var require_object = __commonJS22({
      "src/language-js/print/object.js"(exports2, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          builders: {
            line,
            softline,
            group,
            indent,
            ifBreak,
            hardline
          }
        } = require_doc();
        var {
          getLast,
          hasNewlineInRange,
          hasNewline,
          isNonEmptyArray
        } = require_util();
        var {
          shouldPrintComma,
          hasComment,
          getComments,
          CommentCheckFlags,
          isNextLineEmpty
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var {
          printOptionalToken,
          printTypeAnnotation
        } = require_misc();
        var {
          shouldHugFunctionParameters
        } = require_function_parameters();
        var {
          shouldHugType
        } = require_type_annotation();
        var {
          printHardlineAfterHeritage
        } = require_class();
        function printObject(path4, options, print) {
          const semi = options.semi ? ";" : "";
          const node = path4.getValue();
          let propertiesField;
          if (node.type === "TSTypeLiteral") {
            propertiesField = "members";
          } else if (node.type === "TSInterfaceBody") {
            propertiesField = "body";
          } else {
            propertiesField = "properties";
          }
          const isTypeAnnotation = node.type === "ObjectTypeAnnotation";
          const fields = [propertiesField];
          if (isTypeAnnotation) {
            fields.push("indexers", "callProperties", "internalSlots");
          }
          const firstProperty = fields.map((field) => node[field][0]).sort((a, b) => locStart(a) - locStart(b))[0];
          const parent = path4.getParentNode(0);
          const isFlowInterfaceLikeBody = isTypeAnnotation && parent && (parent.type === "InterfaceDeclaration" || parent.type === "DeclareInterface" || parent.type === "DeclareClass") && path4.getName() === "body";
          const shouldBreak = node.type === "TSInterfaceBody" || isFlowInterfaceLikeBody || node.type === "ObjectPattern" && parent.type !== "FunctionDeclaration" && parent.type !== "FunctionExpression" && parent.type !== "ArrowFunctionExpression" && parent.type !== "ObjectMethod" && parent.type !== "ClassMethod" && parent.type !== "ClassPrivateMethod" && parent.type !== "AssignmentPattern" && parent.type !== "CatchClause" && node.properties.some((property) => property.value && (property.value.type === "ObjectPattern" || property.value.type === "ArrayPattern")) || node.type !== "ObjectPattern" && firstProperty && hasNewlineInRange(options.originalText, locStart(node), locStart(firstProperty));
          const separator = isFlowInterfaceLikeBody ? ";" : node.type === "TSInterfaceBody" || node.type === "TSTypeLiteral" ? ifBreak(semi, ";") : ",";
          const leftBrace = node.type === "RecordExpression" ? "#{" : node.exact ? "{|" : "{";
          const rightBrace = node.exact ? "|}" : "}";
          const propsAndLoc = [];
          for (const field of fields) {
            path4.each((childPath) => {
              const node2 = childPath.getValue();
              propsAndLoc.push({
                node: node2,
                printed: print(),
                loc: locStart(node2)
              });
            }, field);
          }
          if (fields.length > 1) {
            propsAndLoc.sort((a, b) => a.loc - b.loc);
          }
          let separatorParts = [];
          const props = propsAndLoc.map((prop) => {
            const result = [...separatorParts, group(prop.printed)];
            separatorParts = [separator, line];
            if ((prop.node.type === "TSPropertySignature" || prop.node.type === "TSMethodSignature" || prop.node.type === "TSConstructSignatureDeclaration") && hasComment(prop.node, CommentCheckFlags.PrettierIgnore)) {
              separatorParts.shift();
            }
            if (isNextLineEmpty(prop.node, options)) {
              separatorParts.push(hardline);
            }
            return result;
          });
          if (node.inexact) {
            let printed;
            if (hasComment(node, CommentCheckFlags.Dangling)) {
              const hasLineComments = hasComment(node, CommentCheckFlags.Line);
              const printedDanglingComments = printDanglingComments(path4, options, true);
              printed = [printedDanglingComments, hasLineComments || hasNewline(options.originalText, locEnd(getLast(getComments(node)))) ? hardline : line, "..."];
            } else {
              printed = ["..."];
            }
            props.push([...separatorParts, ...printed]);
          }
          const lastElem = getLast(node[propertiesField]);
          const canHaveTrailingSeparator = !(node.inexact || lastElem && lastElem.type === "RestElement" || lastElem && (lastElem.type === "TSPropertySignature" || lastElem.type === "TSCallSignatureDeclaration" || lastElem.type === "TSMethodSignature" || lastElem.type === "TSConstructSignatureDeclaration") && hasComment(lastElem, CommentCheckFlags.PrettierIgnore));
          let content;
          if (props.length === 0) {
            if (!hasComment(node, CommentCheckFlags.Dangling)) {
              return [leftBrace, rightBrace, printTypeAnnotation(path4, options, print)];
            }
            content = group([leftBrace, printDanglingComments(path4, options), softline, rightBrace, printOptionalToken(path4), printTypeAnnotation(path4, options, print)]);
          } else {
            content = [isFlowInterfaceLikeBody && isNonEmptyArray(node.properties) ? printHardlineAfterHeritage(parent) : "", leftBrace, indent([options.bracketSpacing ? line : softline, ...props]), ifBreak(canHaveTrailingSeparator && (separator !== "," || shouldPrintComma(options)) ? separator : ""), options.bracketSpacing ? line : softline, rightBrace, printOptionalToken(path4), printTypeAnnotation(path4, options, print)];
          }
          if (path4.match((node2) => node2.type === "ObjectPattern" && !node2.decorators, (node2, name, number) => shouldHugFunctionParameters(node2) && (name === "params" || name === "parameters" || name === "this" || name === "rest") && number === 0) || path4.match(shouldHugType, (node2, name) => name === "typeAnnotation", (node2, name) => name === "typeAnnotation", (node2, name, number) => shouldHugFunctionParameters(node2) && (name === "params" || name === "parameters" || name === "this" || name === "rest") && number === 0) || !shouldBreak && path4.match((node2) => node2.type === "ObjectPattern", (node2) => node2.type === "AssignmentExpression" || node2.type === "VariableDeclarator")) {
            return content;
          }
          return group(content, {
            shouldBreak
          });
        }
        module22.exports = {
          printObject
        };
      }
    });
    var require_flow = __commonJS22({
      "src/language-js/print/flow.js"(exports2, module22) {
        "use strict";
        var assert = require("assert");
        var {
          printDanglingComments
        } = require_comments();
        var {
          printString,
          printNumber
        } = require_util();
        var {
          builders: {
            hardline,
            softline,
            group,
            indent
          }
        } = require_doc();
        var {
          getParentExportDeclaration,
          isFunctionNotation,
          isGetterOrSetter,
          rawText,
          shouldPrintComma
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var {
          printClass
        } = require_class();
        var {
          printOpaqueType,
          printTypeAlias,
          printIntersectionType,
          printUnionType,
          printFunctionType,
          printTupleType,
          printIndexedAccessType
        } = require_type_annotation();
        var {
          printInterface
        } = require_interface();
        var {
          printTypeParameter,
          printTypeParameters
        } = require_type_parameters();
        var {
          printExportDeclaration,
          printExportAllDeclaration
        } = require_module();
        var {
          printArrayItems
        } = require_array4();
        var {
          printObject
        } = require_object();
        var {
          printPropertyKey
        } = require_property();
        var {
          printOptionalToken,
          printTypeAnnotation,
          printRestSpread
        } = require_misc();
        function printFlow(path4, options, print) {
          const node = path4.getValue();
          const semi = options.semi ? ";" : "";
          const parts = [];
          switch (node.type) {
            case "DeclareClass":
              return printFlowDeclaration(path4, printClass(path4, options, print));
            case "DeclareFunction":
              return printFlowDeclaration(path4, ["function ", print("id"), node.predicate ? " " : "", print("predicate"), semi]);
            case "DeclareModule":
              return printFlowDeclaration(path4, ["module ", print("id"), " ", print("body")]);
            case "DeclareModuleExports":
              return printFlowDeclaration(path4, ["module.exports", ": ", print("typeAnnotation"), semi]);
            case "DeclareVariable":
              return printFlowDeclaration(path4, ["var ", print("id"), semi]);
            case "DeclareOpaqueType":
              return printFlowDeclaration(path4, printOpaqueType(path4, options, print));
            case "DeclareInterface":
              return printFlowDeclaration(path4, printInterface(path4, options, print));
            case "DeclareTypeAlias":
              return printFlowDeclaration(path4, printTypeAlias(path4, options, print));
            case "DeclareExportDeclaration":
              return printFlowDeclaration(path4, printExportDeclaration(path4, options, print));
            case "DeclareExportAllDeclaration":
              return printFlowDeclaration(path4, printExportAllDeclaration(path4, options, print));
            case "OpaqueType":
              return printOpaqueType(path4, options, print);
            case "TypeAlias":
              return printTypeAlias(path4, options, print);
            case "IntersectionTypeAnnotation":
              return printIntersectionType(path4, options, print);
            case "UnionTypeAnnotation":
              return printUnionType(path4, options, print);
            case "FunctionTypeAnnotation":
              return printFunctionType(path4, options, print);
            case "TupleTypeAnnotation":
              return printTupleType(path4, options, print);
            case "GenericTypeAnnotation":
              return [print("id"), printTypeParameters(path4, options, print, "typeParameters")];
            case "IndexedAccessType":
            case "OptionalIndexedAccessType":
              return printIndexedAccessType(path4, options, print);
            case "TypeAnnotation":
              return print("typeAnnotation");
            case "TypeParameter":
              return printTypeParameter(path4, options, print);
            case "TypeofTypeAnnotation":
              return ["typeof ", print("argument")];
            case "ExistsTypeAnnotation":
              return "*";
            case "EmptyTypeAnnotation":
              return "empty";
            case "MixedTypeAnnotation":
              return "mixed";
            case "ArrayTypeAnnotation":
              return [print("elementType"), "[]"];
            case "BooleanLiteralTypeAnnotation":
              return String(node.value);
            case "EnumDeclaration":
              return ["enum ", print("id"), " ", print("body")];
            case "EnumBooleanBody":
            case "EnumNumberBody":
            case "EnumStringBody":
            case "EnumSymbolBody": {
              if (node.type === "EnumSymbolBody" || node.explicitType) {
                let type = null;
                switch (node.type) {
                  case "EnumBooleanBody":
                    type = "boolean";
                    break;
                  case "EnumNumberBody":
                    type = "number";
                    break;
                  case "EnumStringBody":
                    type = "string";
                    break;
                  case "EnumSymbolBody":
                    type = "symbol";
                    break;
                }
                parts.push("of ", type, " ");
              }
              if (node.members.length === 0 && !node.hasUnknownMembers) {
                parts.push(group(["{", printDanglingComments(path4, options), softline, "}"]));
              } else {
                const members = node.members.length > 0 ? [hardline, printArrayItems(path4, options, "members", print), node.hasUnknownMembers || shouldPrintComma(options) ? "," : ""] : [];
                parts.push(group(["{", indent([...members, ...node.hasUnknownMembers ? [hardline, "..."] : []]), printDanglingComments(path4, options, true), hardline, "}"]));
              }
              return parts;
            }
            case "EnumBooleanMember":
            case "EnumNumberMember":
            case "EnumStringMember":
              return [print("id"), " = ", typeof node.init === "object" ? print("init") : String(node.init)];
            case "EnumDefaultedMember":
              return print("id");
            case "FunctionTypeParam": {
              const name = node.name ? print("name") : path4.getParentNode().this === node ? "this" : "";
              return [name, printOptionalToken(path4), name ? ": " : "", print("typeAnnotation")];
            }
            case "InterfaceDeclaration":
            case "InterfaceTypeAnnotation":
              return printInterface(path4, options, print);
            case "ClassImplements":
            case "InterfaceExtends":
              return [print("id"), print("typeParameters")];
            case "NullableTypeAnnotation":
              return ["?", print("typeAnnotation")];
            case "Variance": {
              const {
                kind
              } = node;
              assert.ok(kind === "plus" || kind === "minus");
              return kind === "plus" ? "+" : "-";
            }
            case "ObjectTypeCallProperty":
              if (node.static) {
                parts.push("static ");
              }
              parts.push(print("value"));
              return parts;
            case "ObjectTypeIndexer": {
              return [node.static ? "static " : "", node.variance ? print("variance") : "", "[", print("id"), node.id ? ": " : "", print("key"), "]: ", print("value")];
            }
            case "ObjectTypeProperty": {
              let modifier = "";
              if (node.proto) {
                modifier = "proto ";
              } else if (node.static) {
                modifier = "static ";
              }
              return [modifier, isGetterOrSetter(node) ? node.kind + " " : "", node.variance ? print("variance") : "", printPropertyKey(path4, options, print), printOptionalToken(path4), isFunctionNotation(node) ? "" : ": ", print("value")];
            }
            case "ObjectTypeAnnotation":
              return printObject(path4, options, print);
            case "ObjectTypeInternalSlot":
              return [node.static ? "static " : "", "[[", print("id"), "]]", printOptionalToken(path4), node.method ? "" : ": ", print("value")];
            case "ObjectTypeSpreadProperty":
              return printRestSpread(path4, options, print);
            case "QualifiedTypeofIdentifier":
            case "QualifiedTypeIdentifier":
              return [print("qualification"), ".", print("id")];
            case "StringLiteralTypeAnnotation":
              return printString(rawText(node), options);
            case "NumberLiteralTypeAnnotation":
              assert.strictEqual(typeof node.value, "number");
            case "BigIntLiteralTypeAnnotation":
              if (node.extra) {
                return printNumber(node.extra.raw);
              }
              return printNumber(node.raw);
            case "TypeCastExpression": {
              return ["(", print("expression"), printTypeAnnotation(path4, options, print), ")"];
            }
            case "TypeParameterDeclaration":
            case "TypeParameterInstantiation": {
              const printed = printTypeParameters(path4, options, print, "params");
              if (options.parser === "flow") {
                const start = locStart(node);
                const end = locEnd(node);
                const commentStartIndex = options.originalText.lastIndexOf("/*", start);
                const commentEndIndex = options.originalText.indexOf("*/", end);
                if (commentStartIndex !== -1 && commentEndIndex !== -1) {
                  const comment = options.originalText.slice(commentStartIndex + 2, commentEndIndex).trim();
                  if (comment.startsWith("::") && !comment.includes("/*") && !comment.includes("*/")) {
                    return ["/*:: ", printed, " */"];
                  }
                }
              }
              return printed;
            }
            case "InferredPredicate":
              return "%checks";
            case "DeclaredPredicate":
              return ["%checks(", print("value"), ")"];
            case "AnyTypeAnnotation":
              return "any";
            case "BooleanTypeAnnotation":
              return "boolean";
            case "BigIntTypeAnnotation":
              return "bigint";
            case "NullLiteralTypeAnnotation":
              return "null";
            case "NumberTypeAnnotation":
              return "number";
            case "SymbolTypeAnnotation":
              return "symbol";
            case "StringTypeAnnotation":
              return "string";
            case "VoidTypeAnnotation":
              return "void";
            case "ThisTypeAnnotation":
              return "this";
            case "Node":
            case "Printable":
            case "SourceLocation":
            case "Position":
            case "Statement":
            case "Function":
            case "Pattern":
            case "Expression":
            case "Declaration":
            case "Specifier":
            case "NamedSpecifier":
            case "Comment":
            case "MemberTypeAnnotation":
            case "Type":
              throw new Error("unprintable type: " + JSON.stringify(node.type));
          }
        }
        function printFlowDeclaration(path4, printed) {
          const parentExportDecl = getParentExportDeclaration(path4);
          if (parentExportDecl) {
            assert.strictEqual(parentExportDecl.type, "DeclareExportDeclaration");
            return printed;
          }
          return ["declare ", printed];
        }
        module22.exports = {
          printFlow
        };
      }
    });
    var require_is_ts_keyword_type = __commonJS22({
      "src/language-js/utils/is-ts-keyword-type.js"(exports2, module22) {
        "use strict";
        function isTsKeywordType({
          type
        }) {
          return type.startsWith("TS") && type.endsWith("Keyword");
        }
        module22.exports = isTsKeywordType;
      }
    });
    var require_ternary = __commonJS22({
      "src/language-js/print/ternary.js"(exports2, module22) {
        "use strict";
        var {
          hasNewlineInRange
        } = require_util();
        var {
          isJsxNode,
          getComments,
          isCallExpression,
          isMemberExpression
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        var {
          builders: {
            line,
            softline,
            group,
            indent,
            align,
            ifBreak,
            dedent,
            breakParent
          }
        } = require_doc();
        function conditionalExpressionChainContainsJsx(node) {
          const conditionalExpressions = [node];
          for (let index = 0; index < conditionalExpressions.length; index++) {
            const conditionalExpression = conditionalExpressions[index];
            for (const property of ["test", "consequent", "alternate"]) {
              const node2 = conditionalExpression[property];
              if (isJsxNode(node2)) {
                return true;
              }
              if (node2.type === "ConditionalExpression") {
                conditionalExpressions.push(node2);
              }
            }
          }
          return false;
        }
        function printTernaryTest(path4, options, print) {
          const node = path4.getValue();
          const isConditionalExpression = node.type === "ConditionalExpression";
          const alternateNodePropertyName = isConditionalExpression ? "alternate" : "falseType";
          const parent = path4.getParentNode();
          const printed = isConditionalExpression ? print("test") : [print("checkType"), " ", "extends", " ", print("extendsType")];
          if (parent.type === node.type && parent[alternateNodePropertyName] === node) {
            return align(2, printed);
          }
          return printed;
        }
        var ancestorNameMap = /* @__PURE__ */ new Map([["AssignmentExpression", "right"], ["VariableDeclarator", "init"], ["ReturnStatement", "argument"], ["ThrowStatement", "argument"], ["UnaryExpression", "argument"], ["YieldExpression", "argument"]]);
        function shouldExtraIndentForConditionalExpression(path4) {
          const node = path4.getValue();
          if (node.type !== "ConditionalExpression") {
            return false;
          }
          let parent;
          let child = node;
          for (let ancestorCount = 0; !parent; ancestorCount++) {
            const node2 = path4.getParentNode(ancestorCount);
            if (isCallExpression(node2) && node2.callee === child || isMemberExpression(node2) && node2.object === child || node2.type === "TSNonNullExpression" && node2.expression === child) {
              child = node2;
              continue;
            }
            if (node2.type === "NewExpression" && node2.callee === child || node2.type === "TSAsExpression" && node2.expression === child) {
              parent = path4.getParentNode(ancestorCount + 1);
              child = node2;
            } else {
              parent = node2;
            }
          }
          if (child === node) {
            return false;
          }
          return parent[ancestorNameMap.get(parent.type)] === child;
        }
        function printTernary(path4, options, print) {
          const node = path4.getValue();
          const isConditionalExpression = node.type === "ConditionalExpression";
          const consequentNodePropertyName = isConditionalExpression ? "consequent" : "trueType";
          const alternateNodePropertyName = isConditionalExpression ? "alternate" : "falseType";
          const testNodePropertyNames = isConditionalExpression ? ["test"] : ["checkType", "extendsType"];
          const consequentNode = node[consequentNodePropertyName];
          const alternateNode = node[alternateNodePropertyName];
          const parts = [];
          let jsxMode = false;
          const parent = path4.getParentNode();
          const isParentTest = parent.type === node.type && testNodePropertyNames.some((prop) => parent[prop] === node);
          let forceNoIndent = parent.type === node.type && !isParentTest;
          let currentParent;
          let previousParent;
          let i2 = 0;
          do {
            previousParent = currentParent || node;
            currentParent = path4.getParentNode(i2);
            i2++;
          } while (currentParent && currentParent.type === node.type && testNodePropertyNames.every((prop) => currentParent[prop] !== previousParent));
          const firstNonConditionalParent = currentParent || parent;
          const lastConditionalParent = previousParent;
          if (isConditionalExpression && (isJsxNode(node[testNodePropertyNames[0]]) || isJsxNode(consequentNode) || isJsxNode(alternateNode) || conditionalExpressionChainContainsJsx(lastConditionalParent))) {
            jsxMode = true;
            forceNoIndent = true;
            const wrap = (doc2) => [ifBreak("("), indent([softline, doc2]), softline, ifBreak(")")];
            const isNil = (node2) => node2.type === "NullLiteral" || node2.type === "Literal" && node2.value === null || node2.type === "Identifier" && node2.name === "undefined";
            parts.push(" ? ", isNil(consequentNode) ? print(consequentNodePropertyName) : wrap(print(consequentNodePropertyName)), " : ", alternateNode.type === node.type || isNil(alternateNode) ? print(alternateNodePropertyName) : wrap(print(alternateNodePropertyName)));
          } else {
            const part = [line, "? ", consequentNode.type === node.type ? ifBreak("", "(") : "", align(2, print(consequentNodePropertyName)), consequentNode.type === node.type ? ifBreak("", ")") : "", line, ": ", alternateNode.type === node.type ? print(alternateNodePropertyName) : align(2, print(alternateNodePropertyName))];
            parts.push(parent.type !== node.type || parent[alternateNodePropertyName] === node || isParentTest ? part : options.useTabs ? dedent(indent(part)) : align(Math.max(0, options.tabWidth - 2), part));
          }
          const comments = [...testNodePropertyNames.map((propertyName) => getComments(node[propertyName])), getComments(consequentNode), getComments(alternateNode)].flat();
          const shouldBreak = comments.some((comment) => isBlockComment(comment) && hasNewlineInRange(options.originalText, locStart(comment), locEnd(comment)));
          const maybeGroup = (doc2) => parent === firstNonConditionalParent ? group(doc2, {
            shouldBreak
          }) : shouldBreak ? [doc2, breakParent] : doc2;
          const breakClosingParen = !jsxMode && (isMemberExpression(parent) || parent.type === "NGPipeExpression" && parent.left === node) && !parent.computed;
          const shouldExtraIndent = shouldExtraIndentForConditionalExpression(path4);
          const result = maybeGroup([printTernaryTest(path4, options, print), forceNoIndent ? parts : indent(parts), isConditionalExpression && breakClosingParen && !shouldExtraIndent ? softline : ""]);
          return isParentTest || shouldExtraIndent ? group([indent([softline, result]), softline]) : result;
        }
        module22.exports = {
          printTernary
        };
      }
    });
    var require_statement = __commonJS22({
      "src/language-js/print/statement.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            hardline
          }
        } = require_doc();
        var pathNeedsParens = require_needs_parens();
        var {
          getLeftSidePathName,
          hasNakedLeftSide,
          isJsxNode,
          isTheOnlyJsxElementInMarkdown,
          hasComment,
          CommentCheckFlags,
          isNextLineEmpty
        } = require_utils72();
        var {
          shouldPrintParamsWithoutParens
        } = require_function2();
        function printStatementSequence(path4, options, print, property) {
          const node = path4.getValue();
          const parts = [];
          const isClassBody = node.type === "ClassBody";
          const lastStatement = getLastStatement(node[property]);
          path4.each((path22, index, statements) => {
            const node2 = path22.getValue();
            if (node2.type === "EmptyStatement") {
              return;
            }
            const printed = print();
            if (!options.semi && !isClassBody && !isTheOnlyJsxElementInMarkdown(options, path22) && statementNeedsASIProtection(path22, options)) {
              if (hasComment(node2, CommentCheckFlags.Leading)) {
                parts.push(print([], {
                  needsSemi: true
                }));
              } else {
                parts.push(";", printed);
              }
            } else {
              parts.push(printed);
            }
            if (!options.semi && isClassBody && isClassProperty(node2) && shouldPrintSemicolonAfterClassProperty(node2, statements[index + 1])) {
              parts.push(";");
            }
            if (node2 !== lastStatement) {
              parts.push(hardline);
              if (isNextLineEmpty(node2, options)) {
                parts.push(hardline);
              }
            }
          }, property);
          return parts;
        }
        function getLastStatement(statements) {
          for (let i2 = statements.length - 1; i2 >= 0; i2--) {
            const statement = statements[i2];
            if (statement.type !== "EmptyStatement") {
              return statement;
            }
          }
        }
        function statementNeedsASIProtection(path4, options) {
          const node = path4.getNode();
          if (node.type !== "ExpressionStatement") {
            return false;
          }
          return path4.call((childPath) => expressionNeedsASIProtection(childPath, options), "expression");
        }
        function expressionNeedsASIProtection(path4, options) {
          const node = path4.getValue();
          switch (node.type) {
            case "ParenthesizedExpression":
            case "TypeCastExpression":
            case "ArrayExpression":
            case "ArrayPattern":
            case "TemplateLiteral":
            case "TemplateElement":
            case "RegExpLiteral":
              return true;
            case "ArrowFunctionExpression": {
              if (!shouldPrintParamsWithoutParens(path4, options)) {
                return true;
              }
              break;
            }
            case "UnaryExpression": {
              const {
                prefix: prefix2,
                operator
              } = node;
              if (prefix2 && (operator === "+" || operator === "-")) {
                return true;
              }
              break;
            }
            case "BindExpression": {
              if (!node.object) {
                return true;
              }
              break;
            }
            case "Literal": {
              if (node.regex) {
                return true;
              }
              break;
            }
            default: {
              if (isJsxNode(node)) {
                return true;
              }
            }
          }
          if (pathNeedsParens(path4, options)) {
            return true;
          }
          if (!hasNakedLeftSide(node)) {
            return false;
          }
          return path4.call((childPath) => expressionNeedsASIProtection(childPath, options), ...getLeftSidePathName(path4, node));
        }
        function printBody(path4, options, print) {
          return printStatementSequence(path4, options, print, "body");
        }
        function printSwitchCaseConsequent(path4, options, print) {
          return printStatementSequence(path4, options, print, "consequent");
        }
        var isClassProperty = ({
          type
        }) => type === "ClassProperty" || type === "PropertyDefinition" || type === "ClassPrivateProperty" || type === "ClassAccessorProperty";
        function shouldPrintSemicolonAfterClassProperty(node, nextNode) {
          const name = node.key && node.key.name;
          if ((name === "static" || name === "get" || name === "set") && !node.value && !node.typeAnnotation) {
            return true;
          }
          if (!nextNode) {
            return false;
          }
          if (nextNode.static || nextNode.accessibility) {
            return false;
          }
          if (!nextNode.computed) {
            const name2 = nextNode.key && nextNode.key.name;
            if (name2 === "in" || name2 === "instanceof") {
              return true;
            }
          }
          if (isClassProperty(nextNode) && nextNode.variance && !nextNode.static && !nextNode.declare) {
            return true;
          }
          switch (nextNode.type) {
            case "ClassProperty":
            case "PropertyDefinition":
            case "TSAbstractPropertyDefinition":
              return nextNode.computed;
            case "MethodDefinition":
            case "TSAbstractMethodDefinition":
            case "ClassMethod":
            case "ClassPrivateMethod": {
              const isAsync = nextNode.value ? nextNode.value.async : nextNode.async;
              if (isAsync || nextNode.kind === "get" || nextNode.kind === "set") {
                return false;
              }
              const isGenerator = nextNode.value ? nextNode.value.generator : nextNode.generator;
              if (nextNode.computed || isGenerator) {
                return true;
              }
              return false;
            }
            case "TSIndexSignature":
              return true;
          }
          return false;
        }
        module22.exports = {
          printBody,
          printSwitchCaseConsequent
        };
      }
    });
    var require_block = __commonJS22({
      "src/language-js/print/block.js"(exports2, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            hardline,
            indent
          }
        } = require_doc();
        var {
          hasComment,
          CommentCheckFlags,
          isNextLineEmpty
        } = require_utils72();
        var {
          printHardlineAfterHeritage
        } = require_class();
        var {
          printBody
        } = require_statement();
        function printBlock(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          if (node.type === "StaticBlock") {
            parts.push("static ");
          }
          if (node.type === "ClassBody" && isNonEmptyArray(node.body)) {
            const parent = path4.getParentNode();
            parts.push(printHardlineAfterHeritage(parent));
          }
          parts.push("{");
          const printed = printBlockBody(path4, options, print);
          if (printed) {
            parts.push(indent([hardline, printed]), hardline);
          } else {
            const parent = path4.getParentNode();
            const parentParent = path4.getParentNode(1);
            if (!(parent.type === "ArrowFunctionExpression" || parent.type === "FunctionExpression" || parent.type === "FunctionDeclaration" || parent.type === "ObjectMethod" || parent.type === "ClassMethod" || parent.type === "ClassPrivateMethod" || parent.type === "ForStatement" || parent.type === "WhileStatement" || parent.type === "DoWhileStatement" || parent.type === "DoExpression" || parent.type === "CatchClause" && !parentParent.finalizer || parent.type === "TSModuleDeclaration" || parent.type === "TSDeclareFunction" || node.type === "StaticBlock" || node.type === "ClassBody")) {
              parts.push(hardline);
            }
          }
          parts.push("}");
          return parts;
        }
        function printBlockBody(path4, options, print) {
          const node = path4.getValue();
          const nodeHasDirectives = isNonEmptyArray(node.directives);
          const nodeHasBody = node.body.some((node2) => node2.type !== "EmptyStatement");
          const nodeHasComment = hasComment(node, CommentCheckFlags.Dangling);
          if (!nodeHasDirectives && !nodeHasBody && !nodeHasComment) {
            return "";
          }
          const parts = [];
          if (nodeHasDirectives) {
            path4.each((childPath, index, directives) => {
              parts.push(print());
              if (index < directives.length - 1 || nodeHasBody || nodeHasComment) {
                parts.push(hardline);
                if (isNextLineEmpty(childPath.getValue(), options)) {
                  parts.push(hardline);
                }
              }
            }, "directives");
          }
          if (nodeHasBody) {
            parts.push(printBody(path4, options, print));
          }
          if (nodeHasComment) {
            parts.push(printDanglingComments(path4, options, true));
          }
          if (node.type === "Program") {
            const parent = path4.getParentNode();
            if (!parent || parent.type !== "ModuleExpression") {
              parts.push(hardline);
            }
          }
          return parts;
        }
        module22.exports = {
          printBlock,
          printBlockBody
        };
      }
    });
    var require_typescript = __commonJS22({
      "src/language-js/print/typescript.js"(exports2, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          hasNewlineInRange
        } = require_util();
        var {
          builders: {
            join,
            line,
            hardline,
            softline,
            group,
            indent,
            conditionalGroup,
            ifBreak
          }
        } = require_doc();
        var {
          isLiteral,
          getTypeScriptMappedTypeModifier,
          shouldPrintComma,
          isCallExpression,
          isMemberExpression
        } = require_utils72();
        var isTsKeywordType = require_is_ts_keyword_type();
        var {
          locStart,
          locEnd
        } = require_loc();
        var {
          printOptionalToken,
          printTypeScriptModifiers
        } = require_misc();
        var {
          printTernary
        } = require_ternary();
        var {
          printFunctionParameters,
          shouldGroupFunctionParameters
        } = require_function_parameters();
        var {
          printTemplateLiteral
        } = require_template_literal();
        var {
          printArrayItems
        } = require_array4();
        var {
          printObject
        } = require_object();
        var {
          printClassProperty,
          printClassMethod
        } = require_class();
        var {
          printTypeParameter,
          printTypeParameters
        } = require_type_parameters();
        var {
          printPropertyKey
        } = require_property();
        var {
          printFunction,
          printMethodInternal
        } = require_function2();
        var {
          printInterface
        } = require_interface();
        var {
          printBlock
        } = require_block();
        var {
          printTypeAlias,
          printIntersectionType,
          printUnionType,
          printFunctionType,
          printTupleType,
          printIndexedAccessType,
          printJSDocType
        } = require_type_annotation();
        function printTypescript(path4, options, print) {
          const node = path4.getValue();
          if (!node.type.startsWith("TS")) {
            return;
          }
          if (isTsKeywordType(node)) {
            return node.type.slice(2, -7).toLowerCase();
          }
          const semi = options.semi ? ";" : "";
          const parts = [];
          switch (node.type) {
            case "TSThisType":
              return "this";
            case "TSTypeAssertion": {
              const shouldBreakAfterCast = !(node.expression.type === "ArrayExpression" || node.expression.type === "ObjectExpression");
              const castGroup = group(["<", indent([softline, print("typeAnnotation")]), softline, ">"]);
              const exprContents = [ifBreak("("), indent([softline, print("expression")]), softline, ifBreak(")")];
              if (shouldBreakAfterCast) {
                return conditionalGroup([[castGroup, print("expression")], [castGroup, group(exprContents, {
                  shouldBreak: true
                })], [castGroup, print("expression")]]);
              }
              return group([castGroup, print("expression")]);
            }
            case "TSDeclareFunction":
              return printFunction(path4, print, options);
            case "TSExportAssignment":
              return ["export = ", print("expression"), semi];
            case "TSModuleBlock":
              return printBlock(path4, options, print);
            case "TSInterfaceBody":
            case "TSTypeLiteral":
              return printObject(path4, options, print);
            case "TSTypeAliasDeclaration":
              return printTypeAlias(path4, options, print);
            case "TSQualifiedName":
              return join(".", [print("left"), print("right")]);
            case "TSAbstractMethodDefinition":
            case "TSDeclareMethod":
              return printClassMethod(path4, options, print);
            case "TSAbstractPropertyDefinition":
              return printClassProperty(path4, options, print);
            case "TSInterfaceHeritage":
            case "TSExpressionWithTypeArguments":
              parts.push(print("expression"));
              if (node.typeParameters) {
                parts.push(print("typeParameters"));
              }
              return parts;
            case "TSTemplateLiteralType":
              return printTemplateLiteral(path4, print, options);
            case "TSNamedTupleMember":
              return [print("label"), node.optional ? "?" : "", ": ", print("elementType")];
            case "TSRestType":
              return ["...", print("typeAnnotation")];
            case "TSOptionalType":
              return [print("typeAnnotation"), "?"];
            case "TSInterfaceDeclaration":
              return printInterface(path4, options, print);
            case "TSClassImplements":
              return [print("expression"), print("typeParameters")];
            case "TSTypeParameterDeclaration":
            case "TSTypeParameterInstantiation":
              return printTypeParameters(path4, options, print, "params");
            case "TSTypeParameter":
              return printTypeParameter(path4, options, print);
            case "TSAsExpression": {
              parts.push(print("expression"), " as ", print("typeAnnotation"));
              const parent = path4.getParentNode();
              if (isCallExpression(parent) && parent.callee === node || isMemberExpression(parent) && parent.object === node) {
                return group([indent([softline, ...parts]), softline]);
              }
              return parts;
            }
            case "TSArrayType":
              return [print("elementType"), "[]"];
            case "TSPropertySignature": {
              if (node.readonly) {
                parts.push("readonly ");
              }
              parts.push(printPropertyKey(path4, options, print), printOptionalToken(path4));
              if (node.typeAnnotation) {
                parts.push(": ", print("typeAnnotation"));
              }
              if (node.initializer) {
                parts.push(" = ", print("initializer"));
              }
              return parts;
            }
            case "TSParameterProperty":
              if (node.accessibility) {
                parts.push(node.accessibility + " ");
              }
              if (node.export) {
                parts.push("export ");
              }
              if (node.static) {
                parts.push("static ");
              }
              if (node.override) {
                parts.push("override ");
              }
              if (node.readonly) {
                parts.push("readonly ");
              }
              parts.push(print("parameter"));
              return parts;
            case "TSTypeQuery":
              return ["typeof ", print("exprName"), print("typeParameters")];
            case "TSIndexSignature": {
              const parent = path4.getParentNode();
              const trailingComma = node.parameters.length > 1 ? ifBreak(shouldPrintComma(options) ? "," : "") : "";
              const parametersGroup = group([indent([softline, join([", ", softline], path4.map(print, "parameters"))]), trailingComma, softline]);
              return [node.export ? "export " : "", node.accessibility ? [node.accessibility, " "] : "", node.static ? "static " : "", node.readonly ? "readonly " : "", node.declare ? "declare " : "", "[", node.parameters ? parametersGroup : "", node.typeAnnotation ? "]: " : "]", node.typeAnnotation ? print("typeAnnotation") : "", parent.type === "ClassBody" ? semi : ""];
            }
            case "TSTypePredicate":
              return [node.asserts ? "asserts " : "", print("parameterName"), node.typeAnnotation ? [" is ", print("typeAnnotation")] : ""];
            case "TSNonNullExpression":
              return [print("expression"), "!"];
            case "TSImportType":
              return [!node.isTypeOf ? "" : "typeof ", "import(", print(node.parameter ? "parameter" : "argument"), ")", !node.qualifier ? "" : [".", print("qualifier")], printTypeParameters(path4, options, print, "typeParameters")];
            case "TSLiteralType":
              return print("literal");
            case "TSIndexedAccessType":
              return printIndexedAccessType(path4, options, print);
            case "TSConstructSignatureDeclaration":
            case "TSCallSignatureDeclaration":
            case "TSConstructorType": {
              if (node.type === "TSConstructorType" && node.abstract) {
                parts.push("abstract ");
              }
              if (node.type !== "TSCallSignatureDeclaration") {
                parts.push("new ");
              }
              parts.push(group(printFunctionParameters(path4, print, options, false, true)));
              if (node.returnType || node.typeAnnotation) {
                const isType = node.type === "TSConstructorType";
                parts.push(isType ? " => " : ": ", print("returnType"), print("typeAnnotation"));
              }
              return parts;
            }
            case "TSTypeOperator":
              return [node.operator, " ", print("typeAnnotation")];
            case "TSMappedType": {
              const shouldBreak = hasNewlineInRange(options.originalText, locStart(node), locEnd(node));
              return group(["{", indent([options.bracketSpacing ? line : softline, node.readonly ? [getTypeScriptMappedTypeModifier(node.readonly, "readonly"), " "] : "", printTypeScriptModifiers(path4, options, print), print("typeParameter"), node.optional ? getTypeScriptMappedTypeModifier(node.optional, "?") : "", node.typeAnnotation ? ": " : "", print("typeAnnotation"), ifBreak(semi)]), printDanglingComments(path4, options, true), options.bracketSpacing ? line : softline, "}"], {
                shouldBreak
              });
            }
            case "TSMethodSignature": {
              const kind = node.kind && node.kind !== "method" ? `${node.kind} ` : "";
              parts.push(node.accessibility ? [node.accessibility, " "] : "", kind, node.export ? "export " : "", node.static ? "static " : "", node.readonly ? "readonly " : "", node.abstract ? "abstract " : "", node.declare ? "declare " : "", node.computed ? "[" : "", print("key"), node.computed ? "]" : "", printOptionalToken(path4));
              const parametersDoc = printFunctionParameters(path4, print, options, false, true);
              const returnTypePropertyName = node.returnType ? "returnType" : "typeAnnotation";
              const returnTypeNode = node[returnTypePropertyName];
              const returnTypeDoc = returnTypeNode ? print(returnTypePropertyName) : "";
              const shouldGroupParameters = shouldGroupFunctionParameters(node, returnTypeDoc);
              parts.push(shouldGroupParameters ? group(parametersDoc) : parametersDoc);
              if (returnTypeNode) {
                parts.push(": ", group(returnTypeDoc));
              }
              return group(parts);
            }
            case "TSNamespaceExportDeclaration":
              parts.push("export as namespace ", print("id"));
              if (options.semi) {
                parts.push(";");
              }
              return group(parts);
            case "TSEnumDeclaration":
              if (node.declare) {
                parts.push("declare ");
              }
              if (node.modifiers) {
                parts.push(printTypeScriptModifiers(path4, options, print));
              }
              if (node.const) {
                parts.push("const ");
              }
              parts.push("enum ", print("id"), " ");
              if (node.members.length === 0) {
                parts.push(group(["{", printDanglingComments(path4, options), softline, "}"]));
              } else {
                parts.push(group(["{", indent([hardline, printArrayItems(path4, options, "members", print), shouldPrintComma(options, "es5") ? "," : ""]), printDanglingComments(path4, options, true), hardline, "}"]));
              }
              return parts;
            case "TSEnumMember":
              if (node.computed) {
                parts.push("[", print("id"), "]");
              } else {
                parts.push(print("id"));
              }
              if (node.initializer) {
                parts.push(" = ", print("initializer"));
              }
              return parts;
            case "TSImportEqualsDeclaration":
              if (node.isExport) {
                parts.push("export ");
              }
              parts.push("import ");
              if (node.importKind && node.importKind !== "value") {
                parts.push(node.importKind, " ");
              }
              parts.push(print("id"), " = ", print("moduleReference"));
              if (options.semi) {
                parts.push(";");
              }
              return group(parts);
            case "TSExternalModuleReference":
              return ["require(", print("expression"), ")"];
            case "TSModuleDeclaration": {
              const parent = path4.getParentNode();
              const isExternalModule = isLiteral(node.id);
              const parentIsDeclaration = parent.type === "TSModuleDeclaration";
              const bodyIsDeclaration = node.body && node.body.type === "TSModuleDeclaration";
              if (parentIsDeclaration) {
                parts.push(".");
              } else {
                if (node.declare) {
                  parts.push("declare ");
                }
                parts.push(printTypeScriptModifiers(path4, options, print));
                const textBetweenNodeAndItsId = options.originalText.slice(locStart(node), locStart(node.id));
                const isGlobalDeclaration = node.id.type === "Identifier" && node.id.name === "global" && !/namespace|module/.test(textBetweenNodeAndItsId);
                if (!isGlobalDeclaration) {
                  parts.push(isExternalModule || /(?:^|\s)module(?:\s|$)/.test(textBetweenNodeAndItsId) ? "module " : "namespace ");
                }
              }
              parts.push(print("id"));
              if (bodyIsDeclaration) {
                parts.push(print("body"));
              } else if (node.body) {
                parts.push(" ", group(print("body")));
              } else {
                parts.push(semi);
              }
              return parts;
            }
            case "TSConditionalType":
              return printTernary(path4, options, print);
            case "TSInferType":
              return ["infer", " ", print("typeParameter")];
            case "TSIntersectionType":
              return printIntersectionType(path4, options, print);
            case "TSUnionType":
              return printUnionType(path4, options, print);
            case "TSFunctionType":
              return printFunctionType(path4, options, print);
            case "TSTupleType":
              return printTupleType(path4, options, print);
            case "TSTypeReference":
              return [print("typeName"), printTypeParameters(path4, options, print, "typeParameters")];
            case "TSTypeAnnotation":
              return print("typeAnnotation");
            case "TSEmptyBodyFunctionExpression":
              return printMethodInternal(path4, options, print);
            case "TSJSDocAllType":
              return "*";
            case "TSJSDocUnknownType":
              return "?";
            case "TSJSDocNullableType":
              return printJSDocType(path4, print, "?");
            case "TSJSDocNonNullableType":
              return printJSDocType(path4, print, "!");
            case "TSInstantiationExpression":
              return [print("expression"), print("typeParameters")];
            default:
              throw new Error(`Unknown TypeScript node type: ${JSON.stringify(node.type)}.`);
          }
        }
        module22.exports = {
          printTypescript
        };
      }
    });
    var require_comment = __commonJS22({
      "src/language-js/print/comment.js"(exports2, module22) {
        "use strict";
        var {
          hasNewline
        } = require_util();
        var {
          builders: {
            join,
            hardline
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          isLineComment
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        function printComment(commentPath, options) {
          const comment = commentPath.getValue();
          if (isLineComment(comment)) {
            return options.originalText.slice(locStart(comment), locEnd(comment)).trimEnd();
          }
          if (isBlockComment(comment)) {
            if (isIndentableBlockComment(comment)) {
              const printed = printIndentableBlockComment(comment);
              if (comment.trailing && !hasNewline(options.originalText, locStart(comment), {
                backwards: true
              })) {
                return [hardline, printed];
              }
              return printed;
            }
            const commentEnd = locEnd(comment);
            const isInsideFlowComment = options.originalText.slice(commentEnd - 3, commentEnd) === "*-/";
            return ["/*", replaceTextEndOfLine(comment.value), isInsideFlowComment ? "*-/" : "*/"];
          }
          throw new Error("Not a comment: " + JSON.stringify(comment));
        }
        function isIndentableBlockComment(comment) {
          const lines = `*${comment.value}*`.split("\n");
          return lines.length > 1 && lines.every((line) => line.trim()[0] === "*");
        }
        function printIndentableBlockComment(comment) {
          const lines = comment.value.split("\n");
          return ["/*", join(hardline, lines.map((line, index) => index === 0 ? line.trimEnd() : " " + (index < lines.length - 1 ? line.trim() : line.trimStart()))), "*/"];
        }
        module22.exports = {
          printComment
        };
      }
    });
    var require_literal = __commonJS22({
      "src/language-js/print/literal.js"(exports2, module22) {
        "use strict";
        var {
          printString,
          printNumber
        } = require_util();
        function printLiteral(path4, options) {
          const node = path4.getNode();
          switch (node.type) {
            case "RegExpLiteral":
              return printRegex(node);
            case "BigIntLiteral":
              return printBigInt(node.bigint || node.extra.raw);
            case "NumericLiteral":
              return printNumber(node.extra.raw);
            case "StringLiteral":
              return printString(node.extra.raw, options);
            case "NullLiteral":
              return "null";
            case "BooleanLiteral":
              return String(node.value);
            case "DecimalLiteral":
              return printNumber(node.value) + "m";
            case "Literal": {
              if (node.regex) {
                return printRegex(node.regex);
              }
              if (node.bigint) {
                return printBigInt(node.raw);
              }
              if (node.decimal) {
                return printNumber(node.decimal) + "m";
              }
              const {
                value
              } = node;
              if (typeof value === "number") {
                return printNumber(node.raw);
              }
              if (typeof value === "string") {
                return printString(node.raw, options);
              }
              return String(value);
            }
          }
        }
        function printBigInt(raw) {
          return raw.toLowerCase();
        }
        function printRegex({
          pattern,
          flags
        }) {
          flags = [...flags].sort().join("");
          return `/${pattern}/${flags}`;
        }
        module22.exports = {
          printLiteral
        };
      }
    });
    var require_printer_estree = __commonJS22({
      "src/language-js/printer-estree.js"(exports2, module22) {
        "use strict";
        var {
          printDanglingComments
        } = require_comments();
        var {
          hasNewline
        } = require_util();
        var {
          builders: {
            join,
            line,
            hardline,
            softline,
            group,
            indent
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var embed = require_embed();
        var clean = require_clean2();
        var {
          insertPragma
        } = require_pragma();
        var handleComments = require_comments2();
        var pathNeedsParens = require_needs_parens();
        var preprocess = require_print_preprocess();
        var {
          hasFlowShorthandAnnotationComment,
          hasComment,
          CommentCheckFlags,
          isTheOnlyJsxElementInMarkdown,
          isLineComment,
          isNextLineEmpty,
          needsHardlineAfterDanglingComment,
          rawText,
          hasIgnoreComment,
          isCallExpression,
          isMemberExpression,
          markerForIfWithoutBlockAndSameLineComment
        } = require_utils72();
        var {
          locStart,
          locEnd
        } = require_loc();
        var isBlockComment = require_is_block_comment();
        var {
          printHtmlBinding,
          isVueEventBindingExpression
        } = require_html_binding();
        var {
          printAngular
        } = require_angular();
        var {
          printJsx,
          hasJsxIgnoreComment
        } = require_jsx();
        var {
          printFlow
        } = require_flow();
        var {
          printTypescript
        } = require_typescript();
        var {
          printOptionalToken,
          printBindExpressionCallee,
          printTypeAnnotation,
          adjustClause,
          printRestSpread,
          printDefiniteToken
        } = require_misc();
        var {
          printImportDeclaration,
          printExportDeclaration,
          printExportAllDeclaration,
          printModuleSpecifier
        } = require_module();
        var {
          printTernary
        } = require_ternary();
        var {
          printTemplateLiteral
        } = require_template_literal();
        var {
          printArray
        } = require_array4();
        var {
          printObject
        } = require_object();
        var {
          printClass,
          printClassMethod,
          printClassProperty
        } = require_class();
        var {
          printProperty
        } = require_property();
        var {
          printFunction,
          printArrowFunction,
          printMethod,
          printReturnStatement,
          printThrowStatement
        } = require_function2();
        var {
          printCallExpression
        } = require_call_expression();
        var {
          printVariableDeclarator,
          printAssignmentExpression
        } = require_assignment();
        var {
          printBinaryishExpression
        } = require_binaryish();
        var {
          printSwitchCaseConsequent
        } = require_statement();
        var {
          printMemberExpression
        } = require_member();
        var {
          printBlock,
          printBlockBody
        } = require_block();
        var {
          printComment
        } = require_comment();
        var {
          printLiteral
        } = require_literal();
        var {
          printDecorators
        } = require_decorators();
        function genericPrint(path4, options, print, args) {
          const printed = printPathNoParens(path4, options, print, args);
          if (!printed) {
            return "";
          }
          const node = path4.getValue();
          const {
            type
          } = node;
          if (type === "ClassMethod" || type === "ClassPrivateMethod" || type === "ClassProperty" || type === "ClassAccessorProperty" || type === "PropertyDefinition" || type === "TSAbstractPropertyDefinition" || type === "ClassPrivateProperty" || type === "MethodDefinition" || type === "TSAbstractMethodDefinition" || type === "TSDeclareMethod") {
            return printed;
          }
          let parts = [printed];
          const printedDecorators = printDecorators(path4, options, print);
          const isClassExpressionWithDecorators = node.type === "ClassExpression" && printedDecorators;
          if (printedDecorators) {
            parts = [...printedDecorators, printed];
            if (!isClassExpressionWithDecorators) {
              return group(parts);
            }
          }
          const needsParens = pathNeedsParens(path4, options);
          if (!needsParens) {
            if (args && args.needsSemi) {
              parts.unshift(";");
            }
            if (parts.length === 1 && parts[0] === printed) {
              return printed;
            }
            return parts;
          }
          if (isClassExpressionWithDecorators) {
            parts = [indent([line, ...parts])];
          }
          parts.unshift("(");
          if (args && args.needsSemi) {
            parts.unshift(";");
          }
          if (hasFlowShorthandAnnotationComment(node)) {
            const [comment] = node.trailingComments;
            parts.push(" /*", comment.value.trimStart(), "*/");
            comment.printed = true;
          }
          if (isClassExpressionWithDecorators) {
            parts.push(line);
          }
          parts.push(")");
          return parts;
        }
        function printPathNoParens(path4, options, print, args) {
          const node = path4.getValue();
          const semi = options.semi ? ";" : "";
          if (!node) {
            return "";
          }
          if (typeof node === "string") {
            return node;
          }
          for (const printer of [printLiteral, printHtmlBinding, printAngular, printJsx, printFlow, printTypescript]) {
            const printed = printer(path4, options, print);
            if (typeof printed !== "undefined") {
              return printed;
            }
          }
          let parts = [];
          switch (node.type) {
            case "JsExpressionRoot":
              return print("node");
            case "JsonRoot":
              return [print("node"), hardline];
            case "File":
              if (node.program && node.program.interpreter) {
                parts.push(print(["program", "interpreter"]));
              }
              parts.push(print("program"));
              return parts;
            case "Program":
              return printBlockBody(path4, options, print);
            case "EmptyStatement":
              return "";
            case "ExpressionStatement": {
              if (node.directive) {
                return [printDirective(node.expression, options), semi];
              }
              if (options.parser === "__vue_event_binding" || options.parser === "__vue_ts_event_binding") {
                const parent = path4.getParentNode();
                if (parent.type === "Program" && parent.body.length === 1 && parent.body[0] === node) {
                  return [print("expression"), isVueEventBindingExpression(node.expression) ? ";" : ""];
                }
              }
              const danglingComment = printDanglingComments(path4, options, true, ({
                marker
              }) => marker === markerForIfWithoutBlockAndSameLineComment);
              return [print("expression"), isTheOnlyJsxElementInMarkdown(options, path4) ? "" : semi, danglingComment ? [" ", danglingComment] : ""];
            }
            case "ParenthesizedExpression": {
              const shouldHug = !hasComment(node.expression) && (node.expression.type === "ObjectExpression" || node.expression.type === "ArrayExpression");
              if (shouldHug) {
                return ["(", print("expression"), ")"];
              }
              return group(["(", indent([softline, print("expression")]), softline, ")"]);
            }
            case "AssignmentExpression":
              return printAssignmentExpression(path4, options, print);
            case "VariableDeclarator":
              return printVariableDeclarator(path4, options, print);
            case "BinaryExpression":
            case "LogicalExpression":
              return printBinaryishExpression(path4, options, print);
            case "AssignmentPattern":
              return [print("left"), " = ", print("right")];
            case "OptionalMemberExpression":
            case "MemberExpression": {
              return printMemberExpression(path4, options, print);
            }
            case "MetaProperty":
              return [print("meta"), ".", print("property")];
            case "BindExpression":
              if (node.object) {
                parts.push(print("object"));
              }
              parts.push(group(indent([softline, printBindExpressionCallee(path4, options, print)])));
              return parts;
            case "Identifier": {
              return [node.name, printOptionalToken(path4), printDefiniteToken(path4), printTypeAnnotation(path4, options, print)];
            }
            case "V8IntrinsicIdentifier":
              return ["%", node.name];
            case "SpreadElement":
            case "SpreadElementPattern":
            case "SpreadProperty":
            case "SpreadPropertyPattern":
            case "RestElement":
              return printRestSpread(path4, options, print);
            case "FunctionDeclaration":
            case "FunctionExpression":
              return printFunction(path4, print, options, args);
            case "ArrowFunctionExpression":
              return printArrowFunction(path4, options, print, args);
            case "YieldExpression":
              parts.push("yield");
              if (node.delegate) {
                parts.push("*");
              }
              if (node.argument) {
                parts.push(" ", print("argument"));
              }
              return parts;
            case "AwaitExpression": {
              parts.push("await");
              if (node.argument) {
                parts.push(" ", print("argument"));
                const parent = path4.getParentNode();
                if (isCallExpression(parent) && parent.callee === node || isMemberExpression(parent) && parent.object === node) {
                  parts = [indent([softline, ...parts]), softline];
                  const parentAwaitOrBlock = path4.findAncestor((node2) => node2.type === "AwaitExpression" || node2.type === "BlockStatement");
                  if (!parentAwaitOrBlock || parentAwaitOrBlock.type !== "AwaitExpression") {
                    return group(parts);
                  }
                }
              }
              return parts;
            }
            case "ExportDefaultDeclaration":
            case "ExportNamedDeclaration":
              return printExportDeclaration(path4, options, print);
            case "ExportAllDeclaration":
              return printExportAllDeclaration(path4, options, print);
            case "ImportDeclaration":
              return printImportDeclaration(path4, options, print);
            case "ImportSpecifier":
            case "ExportSpecifier":
            case "ImportNamespaceSpecifier":
            case "ExportNamespaceSpecifier":
            case "ImportDefaultSpecifier":
            case "ExportDefaultSpecifier":
              return printModuleSpecifier(path4, options, print);
            case "ImportAttribute":
              return [print("key"), ": ", print("value")];
            case "Import":
              return "import";
            case "BlockStatement":
            case "StaticBlock":
            case "ClassBody":
              return printBlock(path4, options, print);
            case "ThrowStatement":
              return printThrowStatement(path4, options, print);
            case "ReturnStatement":
              return printReturnStatement(path4, options, print);
            case "NewExpression":
            case "ImportExpression":
            case "OptionalCallExpression":
            case "CallExpression":
              return printCallExpression(path4, options, print);
            case "ObjectExpression":
            case "ObjectPattern":
            case "RecordExpression":
              return printObject(path4, options, print);
            case "ObjectProperty":
            case "Property":
              if (node.method || node.kind === "get" || node.kind === "set") {
                return printMethod(path4, options, print);
              }
              return printProperty(path4, options, print);
            case "ObjectMethod":
              return printMethod(path4, options, print);
            case "Decorator":
              return ["@", print("expression")];
            case "ArrayExpression":
            case "ArrayPattern":
            case "TupleExpression":
              return printArray(path4, options, print);
            case "SequenceExpression": {
              const parent = path4.getParentNode(0);
              if (parent.type === "ExpressionStatement" || parent.type === "ForStatement") {
                const parts2 = [];
                path4.each((expressionPath, index) => {
                  if (index === 0) {
                    parts2.push(print());
                  } else {
                    parts2.push(",", indent([line, print()]));
                  }
                }, "expressions");
                return group(parts2);
              }
              return group(join([",", line], path4.map(print, "expressions")));
            }
            case "ThisExpression":
              return "this";
            case "Super":
              return "super";
            case "Directive":
              return [print("value"), semi];
            case "DirectiveLiteral":
              return printDirective(node, options);
            case "UnaryExpression":
              parts.push(node.operator);
              if (/[a-z]$/.test(node.operator)) {
                parts.push(" ");
              }
              if (hasComment(node.argument)) {
                parts.push(group(["(", indent([softline, print("argument")]), softline, ")"]));
              } else {
                parts.push(print("argument"));
              }
              return parts;
            case "UpdateExpression":
              parts.push(print("argument"), node.operator);
              if (node.prefix) {
                parts.reverse();
              }
              return parts;
            case "ConditionalExpression":
              return printTernary(path4, options, print);
            case "VariableDeclaration": {
              const printed = path4.map(print, "declarations");
              const parentNode = path4.getParentNode();
              const isParentForLoop = parentNode.type === "ForStatement" || parentNode.type === "ForInStatement" || parentNode.type === "ForOfStatement";
              const hasValue = node.declarations.some((decl) => decl.init);
              let firstVariable;
              if (printed.length === 1 && !hasComment(node.declarations[0])) {
                firstVariable = printed[0];
              } else if (printed.length > 0) {
                firstVariable = indent(printed[0]);
              }
              parts = [node.declare ? "declare " : "", node.kind, firstVariable ? [" ", firstVariable] : "", indent(printed.slice(1).map((p) => [",", hasValue && !isParentForLoop ? hardline : line, p]))];
              if (!(isParentForLoop && parentNode.body !== node)) {
                parts.push(semi);
              }
              return group(parts);
            }
            case "WithStatement":
              return group(["with (", print("object"), ")", adjustClause(node.body, print("body"))]);
            case "IfStatement": {
              const con = adjustClause(node.consequent, print("consequent"));
              const opening = group(["if (", group([indent([softline, print("test")]), softline]), ")", con]);
              parts.push(opening);
              if (node.alternate) {
                const commentOnOwnLine = hasComment(node.consequent, CommentCheckFlags.Trailing | CommentCheckFlags.Line) || needsHardlineAfterDanglingComment(node);
                const elseOnSameLine = node.consequent.type === "BlockStatement" && !commentOnOwnLine;
                parts.push(elseOnSameLine ? " " : hardline);
                if (hasComment(node, CommentCheckFlags.Dangling)) {
                  parts.push(printDanglingComments(path4, options, true), commentOnOwnLine ? hardline : " ");
                }
                parts.push("else", group(adjustClause(node.alternate, print("alternate"), node.alternate.type === "IfStatement")));
              }
              return parts;
            }
            case "ForStatement": {
              const body = adjustClause(node.body, print("body"));
              const dangling = printDanglingComments(path4, options, true);
              const printedComments = dangling ? [dangling, softline] : "";
              if (!node.init && !node.test && !node.update) {
                return [printedComments, group(["for (;;)", body])];
              }
              return [printedComments, group(["for (", group([indent([softline, print("init"), ";", line, print("test"), ";", line, print("update")]), softline]), ")", body])];
            }
            case "WhileStatement":
              return group(["while (", group([indent([softline, print("test")]), softline]), ")", adjustClause(node.body, print("body"))]);
            case "ForInStatement":
              return group(["for (", print("left"), " in ", print("right"), ")", adjustClause(node.body, print("body"))]);
            case "ForOfStatement":
              return group(["for", node.await ? " await" : "", " (", print("left"), " of ", print("right"), ")", adjustClause(node.body, print("body"))]);
            case "DoWhileStatement": {
              const clause = adjustClause(node.body, print("body"));
              const doBody = group(["do", clause]);
              parts = [doBody];
              if (node.body.type === "BlockStatement") {
                parts.push(" ");
              } else {
                parts.push(hardline);
              }
              parts.push("while (", group([indent([softline, print("test")]), softline]), ")", semi);
              return parts;
            }
            case "DoExpression":
              return [node.async ? "async " : "", "do ", print("body")];
            case "BreakStatement":
              parts.push("break");
              if (node.label) {
                parts.push(" ", print("label"));
              }
              parts.push(semi);
              return parts;
            case "ContinueStatement":
              parts.push("continue");
              if (node.label) {
                parts.push(" ", print("label"));
              }
              parts.push(semi);
              return parts;
            case "LabeledStatement":
              if (node.body.type === "EmptyStatement") {
                return [print("label"), ":;"];
              }
              return [print("label"), ": ", print("body")];
            case "TryStatement":
              return ["try ", print("block"), node.handler ? [" ", print("handler")] : "", node.finalizer ? [" finally ", print("finalizer")] : ""];
            case "CatchClause":
              if (node.param) {
                const parameterHasComments = hasComment(node.param, (comment) => !isBlockComment(comment) || comment.leading && hasNewline(options.originalText, locEnd(comment)) || comment.trailing && hasNewline(options.originalText, locStart(comment), {
                  backwards: true
                }));
                const param = print("param");
                return ["catch ", parameterHasComments ? ["(", indent([softline, param]), softline, ") "] : ["(", param, ") "], print("body")];
              }
              return ["catch ", print("body")];
            case "SwitchStatement":
              return [group(["switch (", indent([softline, print("discriminant")]), softline, ")"]), " {", node.cases.length > 0 ? indent([hardline, join(hardline, path4.map((casePath, index, cases) => {
                const caseNode = casePath.getValue();
                return [print(), index !== cases.length - 1 && isNextLineEmpty(caseNode, options) ? hardline : ""];
              }, "cases"))]) : "", hardline, "}"];
            case "SwitchCase": {
              if (node.test) {
                parts.push("case ", print("test"), ":");
              } else {
                parts.push("default:");
              }
              if (hasComment(node, CommentCheckFlags.Dangling)) {
                parts.push(" ", printDanglingComments(path4, options, true));
              }
              const consequent = node.consequent.filter((node2) => node2.type !== "EmptyStatement");
              if (consequent.length > 0) {
                const cons = printSwitchCaseConsequent(path4, options, print);
                parts.push(consequent.length === 1 && consequent[0].type === "BlockStatement" ? [" ", cons] : indent([hardline, cons]));
              }
              return parts;
            }
            case "DebuggerStatement":
              return ["debugger", semi];
            case "ClassDeclaration":
            case "ClassExpression":
              return printClass(path4, options, print);
            case "ClassMethod":
            case "ClassPrivateMethod":
            case "MethodDefinition":
              return printClassMethod(path4, options, print);
            case "ClassProperty":
            case "PropertyDefinition":
            case "ClassPrivateProperty":
            case "ClassAccessorProperty":
              return printClassProperty(path4, options, print);
            case "TemplateElement":
              return replaceTextEndOfLine(node.value.raw);
            case "TemplateLiteral":
              return printTemplateLiteral(path4, print, options);
            case "TaggedTemplateExpression":
              return [print("tag"), print("typeParameters"), print("quasi")];
            case "PrivateIdentifier":
              return ["#", print("name")];
            case "PrivateName":
              return ["#", print("id")];
            case "InterpreterDirective":
              parts.push("#!", node.value, hardline);
              if (isNextLineEmpty(node, options)) {
                parts.push(hardline);
              }
              return parts;
            case "TopicReference":
              return "%";
            case "ArgumentPlaceholder":
              return "?";
            case "ModuleExpression": {
              parts.push("module {");
              const printed = print("body");
              if (printed) {
                parts.push(indent([hardline, printed]), hardline);
              }
              parts.push("}");
              return parts;
            }
            default:
              throw new Error("unknown type: " + JSON.stringify(node.type));
          }
        }
        function printDirective(node, options) {
          const raw = rawText(node);
          const rawContent = raw.slice(1, -1);
          if (rawContent.includes('"') || rawContent.includes("'")) {
            return raw;
          }
          const enclosingQuote = options.singleQuote ? "'" : '"';
          return enclosingQuote + rawContent + enclosingQuote;
        }
        function canAttachComment(node) {
          return node.type && !isBlockComment(node) && !isLineComment(node) && node.type !== "EmptyStatement" && node.type !== "TemplateElement" && node.type !== "Import" && node.type !== "TSEmptyBodyFunctionExpression";
        }
        module22.exports = {
          preprocess,
          print: genericPrint,
          embed,
          insertPragma,
          massageAstNode: clean,
          hasPrettierIgnore(path4) {
            return hasIgnoreComment(path4) || hasJsxIgnoreComment(path4);
          },
          willPrintOwnComments: handleComments.willPrintOwnComments,
          canAttachComment,
          printComment,
          isBlockComment,
          handleComments: {
            avoidAstMutation: true,
            ownLine: handleComments.handleOwnLineComment,
            endOfLine: handleComments.handleEndOfLineComment,
            remaining: handleComments.handleRemainingComment
          },
          getCommentChildNodes: handleComments.getCommentChildNodes
        };
      }
    });
    var require_printer_estree_json = __commonJS22({
      "src/language-js/printer-estree-json.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            hardline,
            indent,
            join
          }
        } = require_doc();
        var preprocess = require_print_preprocess();
        function genericPrint(path4, options, print) {
          const node = path4.getValue();
          switch (node.type) {
            case "JsonRoot":
              return [print("node"), hardline];
            case "ArrayExpression": {
              if (node.elements.length === 0) {
                return "[]";
              }
              const printed = path4.map(() => path4.getValue() === null ? "null" : print(), "elements");
              return ["[", indent([hardline, join([",", hardline], printed)]), hardline, "]"];
            }
            case "ObjectExpression":
              return node.properties.length === 0 ? "{}" : ["{", indent([hardline, join([",", hardline], path4.map(print, "properties"))]), hardline, "}"];
            case "ObjectProperty":
              return [print("key"), ": ", print("value")];
            case "UnaryExpression":
              return [node.operator === "+" ? "" : node.operator, print("argument")];
            case "NullLiteral":
              return "null";
            case "BooleanLiteral":
              return node.value ? "true" : "false";
            case "StringLiteral":
            case "NumericLiteral":
              return JSON.stringify(node.value);
            case "Identifier": {
              const parent = path4.getParentNode();
              if (parent && parent.type === "ObjectProperty" && parent.key === node) {
                return JSON.stringify(node.name);
              }
              return node.name;
            }
            case "TemplateLiteral":
              return print(["quasis", 0]);
            case "TemplateElement":
              return JSON.stringify(node.value.cooked);
            default:
              throw new Error("unknown type: " + JSON.stringify(node.type));
          }
        }
        var ignoredProperties = /* @__PURE__ */ new Set(["start", "end", "extra", "loc", "comments", "leadingComments", "trailingComments", "innerComments", "errors", "range", "tokens"]);
        function clean(node, newNode) {
          const {
            type
          } = node;
          if (type === "ObjectProperty" && node.key.type === "Identifier") {
            newNode.key = {
              type: "StringLiteral",
              value: node.key.name
            };
            return;
          }
          if (type === "UnaryExpression" && node.operator === "+") {
            return newNode.argument;
          }
          if (type === "ArrayExpression") {
            for (const [index, element] of node.elements.entries()) {
              if (element === null) {
                newNode.elements.splice(index, 0, {
                  type: "NullLiteral"
                });
              }
            }
            return;
          }
          if (type === "TemplateLiteral") {
            return {
              type: "StringLiteral",
              value: node.quasis[0].value.cooked
            };
          }
        }
        clean.ignoredProperties = ignoredProperties;
        module22.exports = {
          preprocess,
          print: genericPrint,
          massageAstNode: clean
        };
      }
    });
    var require_common_options = __commonJS22({
      "src/common/common-options.js"(exports2, module22) {
        "use strict";
        var CATEGORY_COMMON = "Common";
        module22.exports = {
          bracketSpacing: {
            since: "0.0.0",
            category: CATEGORY_COMMON,
            type: "boolean",
            default: true,
            description: "Print spaces between brackets.",
            oppositeDescription: "Do not print spaces between brackets."
          },
          singleQuote: {
            since: "0.0.0",
            category: CATEGORY_COMMON,
            type: "boolean",
            default: false,
            description: "Use single quotes instead of double quotes."
          },
          proseWrap: {
            since: "1.8.2",
            category: CATEGORY_COMMON,
            type: "choice",
            default: [{
              since: "1.8.2",
              value: true
            }, {
              since: "1.9.0",
              value: "preserve"
            }],
            description: "How to wrap prose.",
            choices: [{
              since: "1.9.0",
              value: "always",
              description: "Wrap prose if it exceeds the print width."
            }, {
              since: "1.9.0",
              value: "never",
              description: "Do not wrap prose."
            }, {
              since: "1.9.0",
              value: "preserve",
              description: "Wrap prose as-is."
            }]
          },
          bracketSameLine: {
            since: "2.4.0",
            category: CATEGORY_COMMON,
            type: "boolean",
            default: false,
            description: "Put > of opening tags on the last line instead of on a new line."
          },
          singleAttributePerLine: {
            since: "2.6.0",
            category: CATEGORY_COMMON,
            type: "boolean",
            default: false,
            description: "Enforce single attribute per line in HTML, Vue and JSX."
          }
        };
      }
    });
    var require_options2 = __commonJS22({
      "src/language-js/options.js"(exports2, module22) {
        "use strict";
        var commonOptions = require_common_options();
        var CATEGORY_JAVASCRIPT = "JavaScript";
        module22.exports = {
          arrowParens: {
            since: "1.9.0",
            category: CATEGORY_JAVASCRIPT,
            type: "choice",
            default: [{
              since: "1.9.0",
              value: "avoid"
            }, {
              since: "2.0.0",
              value: "always"
            }],
            description: "Include parentheses around a sole arrow function parameter.",
            choices: [{
              value: "always",
              description: "Always include parens. Example: `(x) => x`"
            }, {
              value: "avoid",
              description: "Omit parens when possible. Example: `x => x`"
            }]
          },
          bracketSameLine: commonOptions.bracketSameLine,
          bracketSpacing: commonOptions.bracketSpacing,
          jsxBracketSameLine: {
            since: "0.17.0",
            category: CATEGORY_JAVASCRIPT,
            type: "boolean",
            description: "Put > on the last line instead of at a new line.",
            deprecated: "2.4.0"
          },
          semi: {
            since: "1.0.0",
            category: CATEGORY_JAVASCRIPT,
            type: "boolean",
            default: true,
            description: "Print semicolons.",
            oppositeDescription: "Do not print semicolons, except at the beginning of lines which may need them."
          },
          singleQuote: commonOptions.singleQuote,
          jsxSingleQuote: {
            since: "1.15.0",
            category: CATEGORY_JAVASCRIPT,
            type: "boolean",
            default: false,
            description: "Use single quotes in JSX."
          },
          quoteProps: {
            since: "1.17.0",
            category: CATEGORY_JAVASCRIPT,
            type: "choice",
            default: "as-needed",
            description: "Change when properties in objects are quoted.",
            choices: [{
              value: "as-needed",
              description: "Only add quotes around object properties where required."
            }, {
              value: "consistent",
              description: "If at least one property in an object requires quotes, quote all properties."
            }, {
              value: "preserve",
              description: "Respect the input use of quotes in object properties."
            }]
          },
          trailingComma: {
            since: "0.0.0",
            category: CATEGORY_JAVASCRIPT,
            type: "choice",
            default: [{
              since: "0.0.0",
              value: false
            }, {
              since: "0.19.0",
              value: "none"
            }, {
              since: "2.0.0",
              value: "es5"
            }],
            description: "Print trailing commas wherever possible when multi-line.",
            choices: [{
              value: "es5",
              description: "Trailing commas where valid in ES5 (objects, arrays, etc.)"
            }, {
              value: "none",
              description: "No trailing commas."
            }, {
              value: "all",
              description: "Trailing commas wherever possible (including function arguments)."
            }]
          },
          singleAttributePerLine: commonOptions.singleAttributePerLine
        };
      }
    });
    var require_parsers = __commonJS22({
      "src/language-js/parse/parsers.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          get babel() {
            return require_parser_babel().parsers.babel;
          },
          get "babel-flow"() {
            return require_parser_babel().parsers["babel-flow"];
          },
          get "babel-ts"() {
            return require_parser_babel().parsers["babel-ts"];
          },
          get json() {
            return require_parser_babel().parsers.json;
          },
          get json5() {
            return require_parser_babel().parsers.json5;
          },
          get "json-stringify"() {
            return require_parser_babel().parsers["json-stringify"];
          },
          get __js_expression() {
            return require_parser_babel().parsers.__js_expression;
          },
          get __vue_expression() {
            return require_parser_babel().parsers.__vue_expression;
          },
          get __vue_ts_expression() {
            return require_parser_babel().parsers.__vue_ts_expression;
          },
          get __vue_event_binding() {
            return require_parser_babel().parsers.__vue_event_binding;
          },
          get __vue_ts_event_binding() {
            return require_parser_babel().parsers.__vue_ts_event_binding;
          },
          get flow() {
            return require_parser_flow().parsers.flow;
          },
          get typescript() {
            return require_parser_typescript().parsers.typescript;
          },
          get __ng_action() {
            return require_parser_angular().parsers.__ng_action;
          },
          get __ng_binding() {
            return require_parser_angular().parsers.__ng_binding;
          },
          get __ng_interpolation() {
            return require_parser_angular().parsers.__ng_interpolation;
          },
          get __ng_directive() {
            return require_parser_angular().parsers.__ng_directive;
          },
          get acorn() {
            return require_parser_espree().parsers.acorn;
          },
          get espree() {
            return require_parser_espree().parsers.espree;
          },
          get meriyah() {
            return require_parser_meriyah().parsers.meriyah;
          },
          get __babel_estree() {
            return require_parser_babel().parsers.__babel_estree;
          }
        };
      }
    });
    var require_JavaScript = __commonJS22({
      "node_modules/linguist-languages/data/JavaScript.json"(exports2, module22) {
        module22.exports = {
          name: "JavaScript",
          type: "programming",
          tmScope: "source.js",
          aceMode: "javascript",
          codemirrorMode: "javascript",
          codemirrorMimeType: "text/javascript",
          color: "#f1e05a",
          aliases: ["js", "node"],
          extensions: [".js", "._js", ".bones", ".cjs", ".es", ".es6", ".frag", ".gs", ".jake", ".javascript", ".jsb", ".jscad", ".jsfl", ".jslib", ".jsm", ".jspre", ".jss", ".jsx", ".mjs", ".njs", ".pac", ".sjs", ".ssjs", ".xsjs", ".xsjslib"],
          filenames: ["Jakefile"],
          interpreters: ["chakra", "d8", "gjs", "js", "node", "nodejs", "qjs", "rhino", "v8", "v8-shell"],
          languageId: 183
        };
      }
    });
    var require_TypeScript = __commonJS22({
      "node_modules/linguist-languages/data/TypeScript.json"(exports2, module22) {
        module22.exports = {
          name: "TypeScript",
          type: "programming",
          color: "#3178c6",
          aliases: ["ts"],
          interpreters: ["deno", "ts-node"],
          extensions: [".ts", ".cts", ".mts"],
          tmScope: "source.ts",
          aceMode: "typescript",
          codemirrorMode: "javascript",
          codemirrorMimeType: "application/typescript",
          languageId: 378
        };
      }
    });
    var require_TSX = __commonJS22({
      "node_modules/linguist-languages/data/TSX.json"(exports2, module22) {
        module22.exports = {
          name: "TSX",
          type: "programming",
          color: "#3178c6",
          group: "TypeScript",
          extensions: [".tsx"],
          tmScope: "source.tsx",
          aceMode: "javascript",
          codemirrorMode: "jsx",
          codemirrorMimeType: "text/jsx",
          languageId: 94901924
        };
      }
    });
    var require_JSON = __commonJS22({
      "node_modules/linguist-languages/data/JSON.json"(exports2, module22) {
        module22.exports = {
          name: "JSON",
          type: "data",
          color: "#292929",
          tmScope: "source.json",
          aceMode: "json",
          codemirrorMode: "javascript",
          codemirrorMimeType: "application/json",
          aliases: ["geojson", "jsonl", "topojson"],
          extensions: [".json", ".4DForm", ".4DProject", ".avsc", ".geojson", ".gltf", ".har", ".ice", ".JSON-tmLanguage", ".jsonl", ".mcmeta", ".tfstate", ".tfstate.backup", ".topojson", ".webapp", ".webmanifest", ".yy", ".yyp"],
          filenames: [".arcconfig", ".auto-changelog", ".c8rc", ".htmlhintrc", ".imgbotconfig", ".nycrc", ".tern-config", ".tern-project", ".watchmanconfig", "Pipfile.lock", "composer.lock", "mcmod.info"],
          languageId: 174
        };
      }
    });
    var require_JSON_with_Comments = __commonJS22({
      "node_modules/linguist-languages/data/JSON with Comments.json"(exports2, module22) {
        module22.exports = {
          name: "JSON with Comments",
          type: "data",
          color: "#292929",
          group: "JSON",
          tmScope: "source.js",
          aceMode: "javascript",
          codemirrorMode: "javascript",
          codemirrorMimeType: "text/javascript",
          aliases: ["jsonc"],
          extensions: [".jsonc", ".code-snippets", ".sublime-build", ".sublime-commands", ".sublime-completions", ".sublime-keymap", ".sublime-macro", ".sublime-menu", ".sublime-mousemap", ".sublime-project", ".sublime-settings", ".sublime-theme", ".sublime-workspace", ".sublime_metrics", ".sublime_session"],
          filenames: [".babelrc", ".devcontainer.json", ".eslintrc.json", ".jscsrc", ".jshintrc", ".jslintrc", "api-extractor.json", "devcontainer.json", "jsconfig.json", "language-configuration.json", "tsconfig.json", "tslint.json"],
          languageId: 423
        };
      }
    });
    var require_JSON5 = __commonJS22({
      "node_modules/linguist-languages/data/JSON5.json"(exports2, module22) {
        module22.exports = {
          name: "JSON5",
          type: "data",
          color: "#267CB9",
          extensions: [".json5"],
          tmScope: "source.js",
          aceMode: "javascript",
          codemirrorMode: "javascript",
          codemirrorMimeType: "application/json",
          languageId: 175
        };
      }
    });
    var require_language_js = __commonJS22({
      "src/language-js/index.js"(exports2, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var estreePrinter = require_printer_estree();
        var estreeJsonPrinter = require_printer_estree_json();
        var options = require_options2();
        var parsers = require_parsers();
        var languages = [createLanguage(require_JavaScript(), (data) => ({
          since: "0.0.0",
          parsers: ["babel", "acorn", "espree", "meriyah", "babel-flow", "babel-ts", "flow", "typescript"],
          vscodeLanguageIds: ["javascript", "mongo"],
          interpreters: [...data.interpreters, "zx"],
          extensions: [...data.extensions.filter((extension) => extension !== ".jsx"), ".wxs"]
        })), createLanguage(require_JavaScript(), () => ({
          name: "Flow",
          since: "0.0.0",
          parsers: ["flow", "babel-flow"],
          vscodeLanguageIds: ["javascript"],
          aliases: [],
          filenames: [],
          extensions: [".js.flow"]
        })), createLanguage(require_JavaScript(), () => ({
          name: "JSX",
          since: "0.0.0",
          parsers: ["babel", "babel-flow", "babel-ts", "flow", "typescript", "espree", "meriyah"],
          vscodeLanguageIds: ["javascriptreact"],
          aliases: void 0,
          filenames: void 0,
          extensions: [".jsx"],
          group: "JavaScript",
          interpreters: void 0,
          tmScope: "source.js.jsx",
          aceMode: "javascript",
          codemirrorMode: "jsx",
          codemirrorMimeType: "text/jsx",
          color: void 0
        })), createLanguage(require_TypeScript(), () => ({
          since: "1.4.0",
          parsers: ["typescript", "babel-ts"],
          vscodeLanguageIds: ["typescript"]
        })), createLanguage(require_TSX(), () => ({
          since: "1.4.0",
          parsers: ["typescript", "babel-ts"],
          vscodeLanguageIds: ["typescriptreact"]
        })), createLanguage(require_JSON(), () => ({
          name: "JSON.stringify",
          since: "1.13.0",
          parsers: ["json-stringify"],
          vscodeLanguageIds: ["json"],
          extensions: [".importmap"],
          filenames: ["package.json", "package-lock.json", "composer.json"]
        })), createLanguage(require_JSON(), (data) => ({
          since: "1.5.0",
          parsers: ["json"],
          vscodeLanguageIds: ["json"],
          extensions: data.extensions.filter((extension) => extension !== ".jsonl")
        })), createLanguage(require_JSON_with_Comments(), (data) => ({
          since: "1.5.0",
          parsers: ["json"],
          vscodeLanguageIds: ["jsonc"],
          filenames: [...data.filenames, ".eslintrc", ".swcrc"]
        })), createLanguage(require_JSON5(), () => ({
          since: "1.13.0",
          parsers: ["json5"],
          vscodeLanguageIds: ["json5"]
        }))];
        var printers = {
          estree: estreePrinter,
          "estree-json": estreeJsonPrinter
        };
        module22.exports = {
          languages,
          options,
          printers,
          parsers
        };
      }
    });
    var require_clean22 = __commonJS22({
      "src/language-css/clean.js"(exports2, module22) {
        "use strict";
        var {
          isFrontMatterNode
        } = require_util();
        var getLast = require_get_last();
        var ignoredProperties = /* @__PURE__ */ new Set(["raw", "raws", "sourceIndex", "source", "before", "after", "trailingComma"]);
        function clean(ast, newObj, parent) {
          if (isFrontMatterNode(ast) && ast.lang === "yaml") {
            delete newObj.value;
          }
          if (ast.type === "css-comment" && parent.type === "css-root" && parent.nodes.length > 0) {
            if (parent.nodes[0] === ast || isFrontMatterNode(parent.nodes[0]) && parent.nodes[1] === ast) {
              delete newObj.text;
              if (/^\*\s*@(?:format|prettier)\s*$/.test(ast.text)) {
                return null;
              }
            }
            if (parent.type === "css-root" && getLast(parent.nodes) === ast) {
              return null;
            }
          }
          if (ast.type === "value-root") {
            delete newObj.text;
          }
          if (ast.type === "media-query" || ast.type === "media-query-list" || ast.type === "media-feature-expression") {
            delete newObj.value;
          }
          if (ast.type === "css-rule") {
            delete newObj.params;
          }
          if (ast.type === "selector-combinator") {
            newObj.value = newObj.value.replace(/\s+/g, " ");
          }
          if (ast.type === "media-feature") {
            newObj.value = newObj.value.replace(/ /g, "");
          }
          if (ast.type === "value-word" && (ast.isColor && ast.isHex || ["initial", "inherit", "unset", "revert"].includes(newObj.value.replace().toLowerCase())) || ast.type === "media-feature" || ast.type === "selector-root-invalid" || ast.type === "selector-pseudo") {
            newObj.value = newObj.value.toLowerCase();
          }
          if (ast.type === "css-decl") {
            newObj.prop = newObj.prop.toLowerCase();
          }
          if (ast.type === "css-atrule" || ast.type === "css-import") {
            newObj.name = newObj.name.toLowerCase();
          }
          if (ast.type === "value-number") {
            newObj.unit = newObj.unit.toLowerCase();
          }
          if ((ast.type === "media-feature" || ast.type === "media-keyword" || ast.type === "media-type" || ast.type === "media-unknown" || ast.type === "media-url" || ast.type === "media-value" || ast.type === "selector-attribute" || ast.type === "selector-string" || ast.type === "selector-class" || ast.type === "selector-combinator" || ast.type === "value-string") && newObj.value) {
            newObj.value = cleanCSSStrings(newObj.value);
          }
          if (ast.type === "selector-attribute") {
            newObj.attribute = newObj.attribute.trim();
            if (newObj.namespace) {
              if (typeof newObj.namespace === "string") {
                newObj.namespace = newObj.namespace.trim();
                if (newObj.namespace.length === 0) {
                  newObj.namespace = true;
                }
              }
            }
            if (newObj.value) {
              newObj.value = newObj.value.trim().replace(/^["']|["']$/g, "");
              delete newObj.quoted;
            }
          }
          if ((ast.type === "media-value" || ast.type === "media-type" || ast.type === "value-number" || ast.type === "selector-root-invalid" || ast.type === "selector-class" || ast.type === "selector-combinator" || ast.type === "selector-tag") && newObj.value) {
            newObj.value = newObj.value.replace(/([\d+.Ee-]+)([A-Za-z]*)/g, (match, numStr, unit) => {
              const num = Number(numStr);
              return Number.isNaN(num) ? match : num + unit.toLowerCase();
            });
          }
          if (ast.type === "selector-tag") {
            const lowercasedValue = ast.value.toLowerCase();
            if (["from", "to"].includes(lowercasedValue)) {
              newObj.value = lowercasedValue;
            }
          }
          if (ast.type === "css-atrule" && ast.name.toLowerCase() === "supports") {
            delete newObj.value;
          }
          if (ast.type === "selector-unknown") {
            delete newObj.value;
          }
          if (ast.type === "value-comma_group") {
            const index = ast.groups.findIndex((node) => node.type === "value-number" && node.unit === "...");
            if (index !== -1) {
              newObj.groups[index].unit = "";
              newObj.groups.splice(index + 1, 0, {
                type: "value-word",
                value: "...",
                isColor: false,
                isHex: false
              });
            }
          }
        }
        clean.ignoredProperties = ignoredProperties;
        function cleanCSSStrings(value) {
          return value.replace(/'/g, '"').replace(/\\([^\dA-Fa-f])/g, "$1");
        }
        module22.exports = clean;
      }
    });
    var require_print = __commonJS22({
      "src/utils/front-matter/print.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            hardline,
            markAsRoot
          }
        } = require_doc();
        function print(node, textToDoc) {
          if (node.lang === "yaml") {
            const value = node.value.trim();
            const doc2 = value ? textToDoc(value, {
              parser: "yaml"
            }, {
              stripTrailingHardline: true
            }) : "";
            return markAsRoot([node.startDelimiter, hardline, doc2, doc2 ? hardline : "", node.endDelimiter]);
          }
        }
        module22.exports = print;
      }
    });
    var require_embed2 = __commonJS22({
      "src/language-css/embed.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            hardline
          }
        } = require_doc();
        var printFrontMatter = require_print();
        function embed(path4, print, textToDoc) {
          const node = path4.getValue();
          if (node.type === "front-matter") {
            const doc2 = printFrontMatter(node, textToDoc);
            return doc2 ? [doc2, hardline] : "";
          }
        }
        module22.exports = embed;
      }
    });
    var require_parse42 = __commonJS22({
      "src/utils/front-matter/parse.js"(exports2, module22) {
        "use strict";
        var frontMatterRegex = new RegExp("^(?<startDelimiter>-{3}|\\+{3})(?<language>[^\\n]*)\\n(?:|(?<value>.*?)\\n)(?<endDelimiter>\\k<startDelimiter>|\\.{3})[^\\S\\n]*(?:\\n|$)", "s");
        function parse3(text) {
          const match = text.match(frontMatterRegex);
          if (!match) {
            return {
              content: text
            };
          }
          const {
            startDelimiter,
            language,
            value = "",
            endDelimiter
          } = match.groups;
          let lang = language.trim() || "yaml";
          if (startDelimiter === "+++") {
            lang = "toml";
          }
          if (lang !== "yaml" && startDelimiter !== endDelimiter) {
            return {
              content: text
            };
          }
          const [raw] = match;
          const frontMatter = {
            type: "front-matter",
            lang,
            value,
            startDelimiter,
            endDelimiter,
            raw: raw.replace(/\n$/, "")
          };
          return {
            frontMatter,
            content: raw.replace(/[^\n]/g, " ") + text.slice(raw.length)
          };
        }
        module22.exports = parse3;
      }
    });
    var require_pragma2 = __commonJS22({
      "src/language-css/pragma.js"(exports2, module22) {
        "use strict";
        var jsPragma = require_pragma();
        var parseFrontMatter = require_parse42();
        function hasPragma(text) {
          return jsPragma.hasPragma(parseFrontMatter(text).content);
        }
        function insertPragma(text) {
          const {
            frontMatter,
            content
          } = parseFrontMatter(text);
          return (frontMatter ? frontMatter.raw + "\n\n" : "") + jsPragma.insertPragma(content);
        }
        module22.exports = {
          hasPragma,
          insertPragma
        };
      }
    });
    var require_utils82 = __commonJS22({
      "src/language-css/utils/index.js"(exports2, module22) {
        "use strict";
        var colorAdjusterFunctions = /* @__PURE__ */ new Set(["red", "green", "blue", "alpha", "a", "rgb", "hue", "h", "saturation", "s", "lightness", "l", "whiteness", "w", "blackness", "b", "tint", "shade", "blend", "blenda", "contrast", "hsl", "hsla", "hwb", "hwba"]);
        function getAncestorCounter(path4, typeOrTypes) {
          const types3 = Array.isArray(typeOrTypes) ? typeOrTypes : [typeOrTypes];
          let counter = -1;
          let ancestorNode;
          while (ancestorNode = path4.getParentNode(++counter)) {
            if (types3.includes(ancestorNode.type)) {
              return counter;
            }
          }
          return -1;
        }
        function getAncestorNode(path4, typeOrTypes) {
          const counter = getAncestorCounter(path4, typeOrTypes);
          return counter === -1 ? null : path4.getParentNode(counter);
        }
        function getPropOfDeclNode(path4) {
          var _declAncestorNode$pro;
          const declAncestorNode = getAncestorNode(path4, "css-decl");
          return declAncestorNode === null || declAncestorNode === void 0 ? void 0 : (_declAncestorNode$pro = declAncestorNode.prop) === null || _declAncestorNode$pro === void 0 ? void 0 : _declAncestorNode$pro.toLowerCase();
        }
        var wideKeywords = /* @__PURE__ */ new Set(["initial", "inherit", "unset", "revert"]);
        function isWideKeywords(value) {
          return wideKeywords.has(value.toLowerCase());
        }
        function isKeyframeAtRuleKeywords(path4, value) {
          const atRuleAncestorNode = getAncestorNode(path4, "css-atrule");
          return (atRuleAncestorNode === null || atRuleAncestorNode === void 0 ? void 0 : atRuleAncestorNode.name) && atRuleAncestorNode.name.toLowerCase().endsWith("keyframes") && ["from", "to"].includes(value.toLowerCase());
        }
        function maybeToLowerCase(value) {
          return value.includes("$") || value.includes("@") || value.includes("#") || value.startsWith("%") || value.startsWith("--") || value.startsWith(":--") || value.includes("(") && value.includes(")") ? value : value.toLowerCase();
        }
        function insideValueFunctionNode(path4, functionName) {
          var _funcAncestorNode$val;
          const funcAncestorNode = getAncestorNode(path4, "value-func");
          return (funcAncestorNode === null || funcAncestorNode === void 0 ? void 0 : (_funcAncestorNode$val = funcAncestorNode.value) === null || _funcAncestorNode$val === void 0 ? void 0 : _funcAncestorNode$val.toLowerCase()) === functionName;
        }
        function insideICSSRuleNode(path4) {
          var _ruleAncestorNode$raw;
          const ruleAncestorNode = getAncestorNode(path4, "css-rule");
          const selector = ruleAncestorNode === null || ruleAncestorNode === void 0 ? void 0 : (_ruleAncestorNode$raw = ruleAncestorNode.raws) === null || _ruleAncestorNode$raw === void 0 ? void 0 : _ruleAncestorNode$raw.selector;
          return selector && (selector.startsWith(":import") || selector.startsWith(":export"));
        }
        function insideAtRuleNode(path4, atRuleNameOrAtRuleNames) {
          const atRuleNames = Array.isArray(atRuleNameOrAtRuleNames) ? atRuleNameOrAtRuleNames : [atRuleNameOrAtRuleNames];
          const atRuleAncestorNode = getAncestorNode(path4, "css-atrule");
          return atRuleAncestorNode && atRuleNames.includes(atRuleAncestorNode.name.toLowerCase());
        }
        function insideURLFunctionInImportAtRuleNode(path4) {
          const node = path4.getValue();
          const atRuleAncestorNode = getAncestorNode(path4, "css-atrule");
          return (atRuleAncestorNode === null || atRuleAncestorNode === void 0 ? void 0 : atRuleAncestorNode.name) === "import" && node.groups[0].value === "url" && node.groups.length === 2;
        }
        function isURLFunctionNode(node) {
          return node.type === "value-func" && node.value.toLowerCase() === "url";
        }
        function isLastNode(path4, node) {
          var _path$getParentNode;
          const nodes = (_path$getParentNode = path4.getParentNode()) === null || _path$getParentNode === void 0 ? void 0 : _path$getParentNode.nodes;
          return nodes && nodes.indexOf(node) === nodes.length - 1;
        }
        function isDetachedRulesetDeclarationNode(node) {
          const {
            selector
          } = node;
          if (!selector) {
            return false;
          }
          return typeof selector === "string" && /^@.+:.*$/.test(selector) || selector.value && /^@.+:.*$/.test(selector.value);
        }
        function isForKeywordNode(node) {
          return node.type === "value-word" && ["from", "through", "end"].includes(node.value);
        }
        function isIfElseKeywordNode(node) {
          return node.type === "value-word" && ["and", "or", "not"].includes(node.value);
        }
        function isEachKeywordNode(node) {
          return node.type === "value-word" && node.value === "in";
        }
        function isMultiplicationNode(node) {
          return node.type === "value-operator" && node.value === "*";
        }
        function isDivisionNode(node) {
          return node.type === "value-operator" && node.value === "/";
        }
        function isAdditionNode(node) {
          return node.type === "value-operator" && node.value === "+";
        }
        function isSubtractionNode(node) {
          return node.type === "value-operator" && node.value === "-";
        }
        function isModuloNode(node) {
          return node.type === "value-operator" && node.value === "%";
        }
        function isMathOperatorNode(node) {
          return isMultiplicationNode(node) || isDivisionNode(node) || isAdditionNode(node) || isSubtractionNode(node) || isModuloNode(node);
        }
        function isEqualityOperatorNode(node) {
          return node.type === "value-word" && ["==", "!="].includes(node.value);
        }
        function isRelationalOperatorNode(node) {
          return node.type === "value-word" && ["<", ">", "<=", ">="].includes(node.value);
        }
        function isSCSSControlDirectiveNode(node) {
          return node.type === "css-atrule" && ["if", "else", "for", "each", "while"].includes(node.name);
        }
        function isDetachedRulesetCallNode(node) {
          var _node$raws;
          return ((_node$raws = node.raws) === null || _node$raws === void 0 ? void 0 : _node$raws.params) && /^\(\s*\)$/.test(node.raws.params);
        }
        function isTemplatePlaceholderNode(node) {
          return node.name.startsWith("prettier-placeholder");
        }
        function isTemplatePropNode(node) {
          return node.prop.startsWith("@prettier-placeholder");
        }
        function isPostcssSimpleVarNode(currentNode, nextNode) {
          return currentNode.value === "$$" && currentNode.type === "value-func" && (nextNode === null || nextNode === void 0 ? void 0 : nextNode.type) === "value-word" && !nextNode.raws.before;
        }
        function hasComposesNode(node) {
          var _node$value, _node$value$group;
          return ((_node$value = node.value) === null || _node$value === void 0 ? void 0 : _node$value.type) === "value-root" && ((_node$value$group = node.value.group) === null || _node$value$group === void 0 ? void 0 : _node$value$group.type) === "value-value" && node.prop.toLowerCase() === "composes";
        }
        function hasParensAroundNode(node) {
          var _node$value2, _node$value2$group, _node$value2$group$gr;
          return ((_node$value2 = node.value) === null || _node$value2 === void 0 ? void 0 : (_node$value2$group = _node$value2.group) === null || _node$value2$group === void 0 ? void 0 : (_node$value2$group$gr = _node$value2$group.group) === null || _node$value2$group$gr === void 0 ? void 0 : _node$value2$group$gr.type) === "value-paren_group" && node.value.group.group.open !== null && node.value.group.group.close !== null;
        }
        function hasEmptyRawBefore(node) {
          var _node$raws2;
          return ((_node$raws2 = node.raws) === null || _node$raws2 === void 0 ? void 0 : _node$raws2.before) === "";
        }
        function isKeyValuePairNode(node) {
          var _node$groups, _node$groups$;
          return node.type === "value-comma_group" && ((_node$groups = node.groups) === null || _node$groups === void 0 ? void 0 : (_node$groups$ = _node$groups[1]) === null || _node$groups$ === void 0 ? void 0 : _node$groups$.type) === "value-colon";
        }
        function isKeyValuePairInParenGroupNode(node) {
          var _node$groups2;
          return node.type === "value-paren_group" && ((_node$groups2 = node.groups) === null || _node$groups2 === void 0 ? void 0 : _node$groups2[0]) && isKeyValuePairNode(node.groups[0]);
        }
        function isSCSSMapItemNode(path4) {
          var _declNode$prop;
          const node = path4.getValue();
          if (node.groups.length === 0) {
            return false;
          }
          const parentParentNode = path4.getParentNode(1);
          if (!isKeyValuePairInParenGroupNode(node) && !(parentParentNode && isKeyValuePairInParenGroupNode(parentParentNode))) {
            return false;
          }
          const declNode = getAncestorNode(path4, "css-decl");
          if (declNode !== null && declNode !== void 0 && (_declNode$prop = declNode.prop) !== null && _declNode$prop !== void 0 && _declNode$prop.startsWith("$")) {
            return true;
          }
          if (isKeyValuePairInParenGroupNode(parentParentNode)) {
            return true;
          }
          if (parentParentNode.type === "value-func") {
            return true;
          }
          return false;
        }
        function isInlineValueCommentNode(node) {
          return node.type === "value-comment" && node.inline;
        }
        function isHashNode(node) {
          return node.type === "value-word" && node.value === "#";
        }
        function isLeftCurlyBraceNode(node) {
          return node.type === "value-word" && node.value === "{";
        }
        function isRightCurlyBraceNode(node) {
          return node.type === "value-word" && node.value === "}";
        }
        function isWordNode(node) {
          return ["value-word", "value-atword"].includes(node.type);
        }
        function isColonNode(node) {
          return (node === null || node === void 0 ? void 0 : node.type) === "value-colon";
        }
        function isKeyInValuePairNode(node, parentNode) {
          if (!isKeyValuePairNode(parentNode)) {
            return false;
          }
          const {
            groups
          } = parentNode;
          const index = groups.indexOf(node);
          if (index === -1) {
            return false;
          }
          return isColonNode(groups[index + 1]);
        }
        function isMediaAndSupportsKeywords(node) {
          return node.value && ["not", "and", "or"].includes(node.value.toLowerCase());
        }
        function isColorAdjusterFuncNode(node) {
          if (node.type !== "value-func") {
            return false;
          }
          return colorAdjusterFunctions.has(node.value.toLowerCase());
        }
        function lastLineHasInlineComment(text) {
          return /\/\//.test(text.split(/[\n\r]/).pop());
        }
        function isAtWordPlaceholderNode(node) {
          return (node === null || node === void 0 ? void 0 : node.type) === "value-atword" && node.value.startsWith("prettier-placeholder-");
        }
        function isConfigurationNode(node, parentNode) {
          var _node$open, _node$close;
          if (((_node$open = node.open) === null || _node$open === void 0 ? void 0 : _node$open.value) !== "(" || ((_node$close = node.close) === null || _node$close === void 0 ? void 0 : _node$close.value) !== ")" || node.groups.some((group) => group.type !== "value-comma_group")) {
            return false;
          }
          if (parentNode.type === "value-comma_group") {
            const prevIdx = parentNode.groups.indexOf(node) - 1;
            const maybeWithNode = parentNode.groups[prevIdx];
            if ((maybeWithNode === null || maybeWithNode === void 0 ? void 0 : maybeWithNode.type) === "value-word" && maybeWithNode.value === "with") {
              return true;
            }
          }
          return false;
        }
        function isParenGroupNode(node) {
          var _node$open2, _node$close2;
          return node.type === "value-paren_group" && ((_node$open2 = node.open) === null || _node$open2 === void 0 ? void 0 : _node$open2.value) === "(" && ((_node$close2 = node.close) === null || _node$close2 === void 0 ? void 0 : _node$close2.value) === ")";
        }
        module22.exports = {
          getAncestorCounter,
          getAncestorNode,
          getPropOfDeclNode,
          maybeToLowerCase,
          insideValueFunctionNode,
          insideICSSRuleNode,
          insideAtRuleNode,
          insideURLFunctionInImportAtRuleNode,
          isKeyframeAtRuleKeywords,
          isWideKeywords,
          isLastNode,
          isSCSSControlDirectiveNode,
          isDetachedRulesetDeclarationNode,
          isRelationalOperatorNode,
          isEqualityOperatorNode,
          isMultiplicationNode,
          isDivisionNode,
          isAdditionNode,
          isSubtractionNode,
          isModuloNode,
          isMathOperatorNode,
          isEachKeywordNode,
          isForKeywordNode,
          isURLFunctionNode,
          isIfElseKeywordNode,
          hasComposesNode,
          hasParensAroundNode,
          hasEmptyRawBefore,
          isDetachedRulesetCallNode,
          isTemplatePlaceholderNode,
          isTemplatePropNode,
          isPostcssSimpleVarNode,
          isKeyValuePairNode,
          isKeyValuePairInParenGroupNode,
          isKeyInValuePairNode,
          isSCSSMapItemNode,
          isInlineValueCommentNode,
          isHashNode,
          isLeftCurlyBraceNode,
          isRightCurlyBraceNode,
          isWordNode,
          isColonNode,
          isMediaAndSupportsKeywords,
          isColorAdjusterFuncNode,
          lastLineHasInlineComment,
          isAtWordPlaceholderNode,
          isConfigurationNode,
          isParenGroupNode
        };
      }
    });
    var require_line_column_to_index = __commonJS22({
      "src/utils/line-column-to-index.js"(exports2, module22) {
        "use strict";
        module22.exports = function(lineColumn, text) {
          let index = 0;
          for (let i2 = 0; i2 < lineColumn.line - 1; ++i2) {
            index = text.indexOf("\n", index) + 1;
          }
          return index + lineColumn.column;
        };
      }
    });
    var require_loc2 = __commonJS22({
      "src/language-css/loc.js"(exports2, module22) {
        "use strict";
        var {
          skipEverythingButNewLine
        } = require_skip();
        var getLast = require_get_last();
        var lineColumnToIndex = require_line_column_to_index();
        function calculateLocStart(node, text) {
          if (typeof node.sourceIndex === "number") {
            return node.sourceIndex;
          }
          return node.source ? lineColumnToIndex(node.source.start, text) - 1 : null;
        }
        function calculateLocEnd(node, text) {
          if (node.type === "css-comment" && node.inline) {
            return skipEverythingButNewLine(text, node.source.startOffset);
          }
          const endNode = node.nodes && getLast(node.nodes);
          if (endNode && node.source && !node.source.end) {
            node = endNode;
          }
          if (node.source && node.source.end) {
            return lineColumnToIndex(node.source.end, text);
          }
          return null;
        }
        function calculateLoc(node, text) {
          if (node.source) {
            node.source.startOffset = calculateLocStart(node, text);
            node.source.endOffset = calculateLocEnd(node, text);
          }
          for (const key in node) {
            const child = node[key];
            if (key === "source" || !child || typeof child !== "object") {
              continue;
            }
            if (child.type === "value-root" || child.type === "value-unknown") {
              calculateValueNodeLoc(child, getValueRootOffset(node), child.text || child.value);
            } else {
              calculateLoc(child, text);
            }
          }
        }
        function calculateValueNodeLoc(node, rootOffset, text) {
          if (node.source) {
            node.source.startOffset = calculateLocStart(node, text) + rootOffset;
            node.source.endOffset = calculateLocEnd(node, text) + rootOffset;
          }
          for (const key in node) {
            const child = node[key];
            if (key === "source" || !child || typeof child !== "object") {
              continue;
            }
            calculateValueNodeLoc(child, rootOffset, text);
          }
        }
        function getValueRootOffset(node) {
          let result = node.source.startOffset;
          if (typeof node.prop === "string") {
            result += node.prop.length;
          }
          if (node.type === "css-atrule" && typeof node.name === "string") {
            result += 1 + node.name.length + node.raws.afterName.match(/^\s*:?\s*/)[0].length;
          }
          if (node.type !== "css-atrule" && node.raws && typeof node.raws.between === "string") {
            result += node.raws.between.length;
          }
          return result;
        }
        function replaceQuotesInInlineComments(text) {
          let state = "initial";
          let stateToReturnFromQuotes = "initial";
          let inlineCommentStartIndex;
          let inlineCommentContainsQuotes = false;
          const inlineCommentsToReplace = [];
          for (let i2 = 0; i2 < text.length; i2++) {
            const c = text[i2];
            switch (state) {
              case "initial":
                if (c === "'") {
                  state = "single-quotes";
                  continue;
                }
                if (c === '"') {
                  state = "double-quotes";
                  continue;
                }
                if ((c === "u" || c === "U") && text.slice(i2, i2 + 4).toLowerCase() === "url(") {
                  state = "url";
                  i2 += 3;
                  continue;
                }
                if (c === "*" && text[i2 - 1] === "/") {
                  state = "comment-block";
                  continue;
                }
                if (c === "/" && text[i2 - 1] === "/") {
                  state = "comment-inline";
                  inlineCommentStartIndex = i2 - 1;
                  continue;
                }
                continue;
              case "single-quotes":
                if (c === "'" && text[i2 - 1] !== "\\") {
                  state = stateToReturnFromQuotes;
                  stateToReturnFromQuotes = "initial";
                }
                if (c === "\n" || c === "\r") {
                  return text;
                }
                continue;
              case "double-quotes":
                if (c === '"' && text[i2 - 1] !== "\\") {
                  state = stateToReturnFromQuotes;
                  stateToReturnFromQuotes = "initial";
                }
                if (c === "\n" || c === "\r") {
                  return text;
                }
                continue;
              case "url":
                if (c === ")") {
                  state = "initial";
                }
                if (c === "\n" || c === "\r") {
                  return text;
                }
                if (c === "'") {
                  state = "single-quotes";
                  stateToReturnFromQuotes = "url";
                  continue;
                }
                if (c === '"') {
                  state = "double-quotes";
                  stateToReturnFromQuotes = "url";
                  continue;
                }
                continue;
              case "comment-block":
                if (c === "/" && text[i2 - 1] === "*") {
                  state = "initial";
                }
                continue;
              case "comment-inline":
                if (c === '"' || c === "'" || c === "*") {
                  inlineCommentContainsQuotes = true;
                }
                if (c === "\n" || c === "\r") {
                  if (inlineCommentContainsQuotes) {
                    inlineCommentsToReplace.push([inlineCommentStartIndex, i2]);
                  }
                  state = "initial";
                  inlineCommentContainsQuotes = false;
                }
                continue;
            }
          }
          for (const [start, end] of inlineCommentsToReplace) {
            text = text.slice(0, start) + text.slice(start, end).replace(/["'*]/g, " ") + text.slice(end);
          }
          return text;
        }
        function locStart(node) {
          return node.source.startOffset;
        }
        function locEnd(node) {
          return node.source.endOffset;
        }
        module22.exports = {
          locStart,
          locEnd,
          calculateLoc,
          replaceQuotesInInlineComments
        };
      }
    });
    var require_is_less_parser = __commonJS22({
      "src/language-css/utils/is-less-parser.js"(exports2, module22) {
        "use strict";
        function isLessParser(options) {
          return options.parser === "css" || options.parser === "less";
        }
        module22.exports = isLessParser;
      }
    });
    var require_is_scss = __commonJS22({
      "src/language-css/utils/is-scss.js"(exports2, module22) {
        "use strict";
        function isSCSS(parser, text) {
          const hasExplicitParserChoice = parser === "less" || parser === "scss";
          const IS_POSSIBLY_SCSS = /(?:\w\s*:\s*[^:}]+|#){|@import[^\n]+(?:url|,)/;
          return hasExplicitParserChoice ? parser === "scss" : IS_POSSIBLY_SCSS.test(text);
        }
        module22.exports = isSCSS;
      }
    });
    var require_css_units_evaluate = __commonJS22({
      "src/language-css/utils/css-units.evaluate.js"(exports2, module22) {
        module22.exports = {
          em: "em",
          rem: "rem",
          ex: "ex",
          rex: "rex",
          cap: "cap",
          rcap: "rcap",
          ch: "ch",
          rch: "rch",
          ic: "ic",
          ric: "ric",
          lh: "lh",
          rlh: "rlh",
          vw: "vw",
          svw: "svw",
          lvw: "lvw",
          dvw: "dvw",
          vh: "vh",
          svh: "svh",
          lvh: "lvh",
          dvh: "dvh",
          vi: "vi",
          svi: "svi",
          lvi: "lvi",
          dvi: "dvi",
          vb: "vb",
          svb: "svb",
          lvb: "lvb",
          dvb: "dvb",
          vmin: "vmin",
          svmin: "svmin",
          lvmin: "lvmin",
          dvmin: "dvmin",
          vmax: "vmax",
          svmax: "svmax",
          lvmax: "lvmax",
          dvmax: "dvmax",
          cm: "cm",
          mm: "mm",
          q: "Q",
          in: "in",
          pt: "pt",
          pc: "pc",
          px: "px",
          deg: "deg",
          grad: "grad",
          rad: "rad",
          turn: "turn",
          s: "s",
          ms: "ms",
          hz: "Hz",
          khz: "kHz",
          dpi: "dpi",
          dpcm: "dpcm",
          dppx: "dppx",
          x: "x"
        };
      }
    });
    var require_print_unit = __commonJS22({
      "src/language-css/utils/print-unit.js"(exports2, module22) {
        "use strict";
        var CSS_UNITS = require_css_units_evaluate();
        function printUnit(unit) {
          const lowercased = unit.toLowerCase();
          return Object.prototype.hasOwnProperty.call(CSS_UNITS, lowercased) ? CSS_UNITS[lowercased] : unit;
        }
        module22.exports = printUnit;
      }
    });
    var require_printer_postcss = __commonJS22({
      "src/language-css/printer-postcss.js"(exports2, module22) {
        "use strict";
        var getLast = require_get_last();
        var {
          printNumber,
          printString,
          hasNewline,
          isFrontMatterNode,
          isNextLineEmpty,
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            join,
            line,
            hardline,
            softline,
            group,
            fill,
            indent,
            dedent,
            ifBreak,
            breakParent
          },
          utils: {
            removeLines,
            getDocParts
          }
        } = require_doc();
        var clean = require_clean22();
        var embed = require_embed2();
        var {
          insertPragma
        } = require_pragma2();
        var {
          getAncestorNode,
          getPropOfDeclNode,
          maybeToLowerCase,
          insideValueFunctionNode,
          insideICSSRuleNode,
          insideAtRuleNode,
          insideURLFunctionInImportAtRuleNode,
          isKeyframeAtRuleKeywords,
          isWideKeywords,
          isLastNode,
          isSCSSControlDirectiveNode,
          isDetachedRulesetDeclarationNode,
          isRelationalOperatorNode,
          isEqualityOperatorNode,
          isMultiplicationNode,
          isDivisionNode,
          isAdditionNode,
          isSubtractionNode,
          isMathOperatorNode,
          isEachKeywordNode,
          isForKeywordNode,
          isURLFunctionNode,
          isIfElseKeywordNode,
          hasComposesNode,
          hasParensAroundNode,
          hasEmptyRawBefore,
          isKeyValuePairNode,
          isKeyInValuePairNode,
          isDetachedRulesetCallNode,
          isTemplatePlaceholderNode,
          isTemplatePropNode,
          isPostcssSimpleVarNode,
          isSCSSMapItemNode,
          isInlineValueCommentNode,
          isHashNode,
          isLeftCurlyBraceNode,
          isRightCurlyBraceNode,
          isWordNode,
          isColonNode,
          isMediaAndSupportsKeywords,
          isColorAdjusterFuncNode,
          lastLineHasInlineComment,
          isAtWordPlaceholderNode,
          isConfigurationNode,
          isParenGroupNode
        } = require_utils82();
        var {
          locStart,
          locEnd
        } = require_loc2();
        var isLessParser = require_is_less_parser();
        var isSCSS = require_is_scss();
        var printUnit = require_print_unit();
        function shouldPrintComma(options) {
          return options.trailingComma === "es5" || options.trailingComma === "all";
        }
        function genericPrint(path4, options, print) {
          const node = path4.getValue();
          if (!node) {
            return "";
          }
          if (typeof node === "string") {
            return node;
          }
          switch (node.type) {
            case "front-matter":
              return [node.raw, hardline];
            case "css-root": {
              const nodes = printNodeSequence(path4, options, print);
              const after = node.raws.after.trim();
              return [nodes, after ? ` ${after}` : "", getDocParts(nodes).length > 0 ? hardline : ""];
            }
            case "css-comment": {
              const isInlineComment = node.inline || node.raws.inline;
              const text = options.originalText.slice(locStart(node), locEnd(node));
              return isInlineComment ? text.trimEnd() : text;
            }
            case "css-rule": {
              return [print("selector"), node.important ? " !important" : "", node.nodes ? [node.selector && node.selector.type === "selector-unknown" && lastLineHasInlineComment(node.selector.value) ? line : " ", "{", node.nodes.length > 0 ? indent([hardline, printNodeSequence(path4, options, print)]) : "", hardline, "}", isDetachedRulesetDeclarationNode(node) ? ";" : ""] : ";"];
            }
            case "css-decl": {
              const parentNode = path4.getParentNode();
              const {
                between: rawBetween
              } = node.raws;
              const trimmedBetween = rawBetween.trim();
              const isColon = trimmedBetween === ":";
              let value = hasComposesNode(node) ? removeLines(print("value")) : print("value");
              if (!isColon && lastLineHasInlineComment(trimmedBetween)) {
                value = indent([hardline, dedent(value)]);
              }
              return [node.raws.before.replace(/[\s;]/g, ""), insideICSSRuleNode(path4) ? node.prop : maybeToLowerCase(node.prop), trimmedBetween.startsWith("//") ? " " : "", trimmedBetween, node.extend ? "" : " ", isLessParser(options) && node.extend && node.selector ? ["extend(", print("selector"), ")"] : "", value, node.raws.important ? node.raws.important.replace(/\s*!\s*important/i, " !important") : node.important ? " !important" : "", node.raws.scssDefault ? node.raws.scssDefault.replace(/\s*!default/i, " !default") : node.scssDefault ? " !default" : "", node.raws.scssGlobal ? node.raws.scssGlobal.replace(/\s*!global/i, " !global") : node.scssGlobal ? " !global" : "", node.nodes ? [" {", indent([softline, printNodeSequence(path4, options, print)]), softline, "}"] : isTemplatePropNode(node) && !parentNode.raws.semicolon && options.originalText[locEnd(node) - 1] !== ";" ? "" : options.__isHTMLStyleAttribute && isLastNode(path4, node) ? ifBreak(";") : ";"];
            }
            case "css-atrule": {
              const parentNode = path4.getParentNode();
              const isTemplatePlaceholderNodeWithoutSemiColon = isTemplatePlaceholderNode(node) && !parentNode.raws.semicolon && options.originalText[locEnd(node) - 1] !== ";";
              if (isLessParser(options)) {
                if (node.mixin) {
                  return [print("selector"), node.important ? " !important" : "", isTemplatePlaceholderNodeWithoutSemiColon ? "" : ";"];
                }
                if (node.function) {
                  return [node.name, print("params"), isTemplatePlaceholderNodeWithoutSemiColon ? "" : ";"];
                }
                if (node.variable) {
                  return ["@", node.name, ": ", node.value ? print("value") : "", node.raws.between.trim() ? node.raws.between.trim() + " " : "", node.nodes ? ["{", indent([node.nodes.length > 0 ? softline : "", printNodeSequence(path4, options, print)]), softline, "}"] : "", isTemplatePlaceholderNodeWithoutSemiColon ? "" : ";"];
                }
              }
              return ["@", isDetachedRulesetCallNode(node) || node.name.endsWith(":") ? node.name : maybeToLowerCase(node.name), node.params ? [isDetachedRulesetCallNode(node) ? "" : isTemplatePlaceholderNode(node) ? node.raws.afterName === "" ? "" : node.name.endsWith(":") ? " " : /^\s*\n\s*\n/.test(node.raws.afterName) ? [hardline, hardline] : /^\s*\n/.test(node.raws.afterName) ? hardline : " " : " ", print("params")] : "", node.selector ? indent([" ", print("selector")]) : "", node.value ? group([" ", print("value"), isSCSSControlDirectiveNode(node) ? hasParensAroundNode(node) ? " " : line : ""]) : node.name === "else" ? " " : "", node.nodes ? [isSCSSControlDirectiveNode(node) ? "" : node.selector && !node.selector.nodes && typeof node.selector.value === "string" && lastLineHasInlineComment(node.selector.value) || !node.selector && typeof node.params === "string" && lastLineHasInlineComment(node.params) ? line : " ", "{", indent([node.nodes.length > 0 ? softline : "", printNodeSequence(path4, options, print)]), softline, "}"] : isTemplatePlaceholderNodeWithoutSemiColon ? "" : ";"];
            }
            case "media-query-list": {
              const parts = [];
              path4.each((childPath) => {
                const node2 = childPath.getValue();
                if (node2.type === "media-query" && node2.value === "") {
                  return;
                }
                parts.push(print());
              }, "nodes");
              return group(indent(join(line, parts)));
            }
            case "media-query": {
              return [join(" ", path4.map(print, "nodes")), isLastNode(path4, node) ? "" : ","];
            }
            case "media-type": {
              return adjustNumbers(adjustStrings(node.value, options));
            }
            case "media-feature-expression": {
              if (!node.nodes) {
                return node.value;
              }
              return ["(", ...path4.map(print, "nodes"), ")"];
            }
            case "media-feature": {
              return maybeToLowerCase(adjustStrings(node.value.replace(/ +/g, " "), options));
            }
            case "media-colon": {
              return [node.value, " "];
            }
            case "media-value": {
              return adjustNumbers(adjustStrings(node.value, options));
            }
            case "media-keyword": {
              return adjustStrings(node.value, options);
            }
            case "media-url": {
              return adjustStrings(node.value.replace(/^url\(\s+/gi, "url(").replace(/\s+\)$/g, ")"), options);
            }
            case "media-unknown": {
              return node.value;
            }
            case "selector-root": {
              return group([insideAtRuleNode(path4, "custom-selector") ? [getAncestorNode(path4, "css-atrule").customSelector, line] : "", join([",", insideAtRuleNode(path4, ["extend", "custom-selector", "nest"]) ? line : hardline], path4.map(print, "nodes"))]);
            }
            case "selector-selector": {
              return group(indent(path4.map(print, "nodes")));
            }
            case "selector-comment": {
              return node.value;
            }
            case "selector-string": {
              return adjustStrings(node.value, options);
            }
            case "selector-tag": {
              const parentNode = path4.getParentNode();
              const index = parentNode && parentNode.nodes.indexOf(node);
              const prevNode = index && parentNode.nodes[index - 1];
              return [node.namespace ? [node.namespace === true ? "" : node.namespace.trim(), "|"] : "", prevNode.type === "selector-nesting" ? node.value : adjustNumbers(isKeyframeAtRuleKeywords(path4, node.value) ? node.value.toLowerCase() : node.value)];
            }
            case "selector-id": {
              return ["#", node.value];
            }
            case "selector-class": {
              return [".", adjustNumbers(adjustStrings(node.value, options))];
            }
            case "selector-attribute": {
              return ["[", node.namespace ? [node.namespace === true ? "" : node.namespace.trim(), "|"] : "", node.attribute.trim(), node.operator ? node.operator : "", node.value ? quoteAttributeValue(adjustStrings(node.value.trim(), options), options) : "", node.insensitive ? " i" : "", "]"];
            }
            case "selector-combinator": {
              if (node.value === "+" || node.value === ">" || node.value === "~" || node.value === ">>>") {
                const parentNode = path4.getParentNode();
                const leading2 = parentNode.type === "selector-selector" && parentNode.nodes[0] === node ? "" : line;
                return [leading2, node.value, isLastNode(path4, node) ? "" : " "];
              }
              const leading = node.value.trim().startsWith("(") ? line : "";
              const value = adjustNumbers(adjustStrings(node.value.trim(), options)) || line;
              return [leading, value];
            }
            case "selector-universal": {
              return [node.namespace ? [node.namespace === true ? "" : node.namespace.trim(), "|"] : "", node.value];
            }
            case "selector-pseudo": {
              return [maybeToLowerCase(node.value), isNonEmptyArray(node.nodes) ? ["(", join(", ", path4.map(print, "nodes")), ")"] : ""];
            }
            case "selector-nesting": {
              return node.value;
            }
            case "selector-unknown": {
              const ruleAncestorNode = getAncestorNode(path4, "css-rule");
              if (ruleAncestorNode && ruleAncestorNode.isSCSSNesterProperty) {
                return adjustNumbers(adjustStrings(maybeToLowerCase(node.value), options));
              }
              const parentNode = path4.getParentNode();
              if (parentNode.raws && parentNode.raws.selector) {
                const start = locStart(parentNode);
                const end = start + parentNode.raws.selector.length;
                return options.originalText.slice(start, end).trim();
              }
              const grandParent = path4.getParentNode(1);
              if (parentNode.type === "value-paren_group" && grandParent && grandParent.type === "value-func" && grandParent.value === "selector") {
                const start = locEnd(parentNode.open) + 1;
                const end = locStart(parentNode.close);
                const selector = options.originalText.slice(start, end).trim();
                return lastLineHasInlineComment(selector) ? [breakParent, selector] : selector;
              }
              return node.value;
            }
            case "value-value":
            case "value-root": {
              return print("group");
            }
            case "value-comment": {
              return options.originalText.slice(locStart(node), locEnd(node));
            }
            case "value-comma_group": {
              const parentNode = path4.getParentNode();
              const parentParentNode = path4.getParentNode(1);
              const declAncestorProp = getPropOfDeclNode(path4);
              const isGridValue = declAncestorProp && parentNode.type === "value-value" && (declAncestorProp === "grid" || declAncestorProp.startsWith("grid-template"));
              const atRuleAncestorNode = getAncestorNode(path4, "css-atrule");
              const isControlDirective = atRuleAncestorNode && isSCSSControlDirectiveNode(atRuleAncestorNode);
              const hasInlineComment = node.groups.some((node2) => isInlineValueCommentNode(node2));
              const printed = path4.map(print, "groups");
              const parts = [];
              const insideURLFunction = insideValueFunctionNode(path4, "url");
              let insideSCSSInterpolationInString = false;
              let didBreak = false;
              for (let i2 = 0; i2 < node.groups.length; ++i2) {
                parts.push(printed[i2]);
                const iPrevNode = node.groups[i2 - 1];
                const iNode = node.groups[i2];
                const iNextNode = node.groups[i2 + 1];
                const iNextNextNode = node.groups[i2 + 2];
                if (insideURLFunction) {
                  if (iNextNode && isAdditionNode(iNextNode) || isAdditionNode(iNode)) {
                    parts.push(" ");
                  }
                  continue;
                }
                if (insideAtRuleNode(path4, "forward") && iNode.type === "value-word" && iNode.value && iPrevNode !== void 0 && iPrevNode.type === "value-word" && iPrevNode.value === "as" && iNextNode.type === "value-operator" && iNextNode.value === "*") {
                  continue;
                }
                if (!iNextNode) {
                  continue;
                }
                if (iNode.type === "value-word" && iNode.value.endsWith("-") && isAtWordPlaceholderNode(iNextNode)) {
                  continue;
                }
                const isStartSCSSInterpolationInString = iNode.type === "value-string" && iNode.value.startsWith("#{");
                const isEndingSCSSInterpolationInString = insideSCSSInterpolationInString && iNextNode.type === "value-string" && iNextNode.value.endsWith("}");
                if (isStartSCSSInterpolationInString || isEndingSCSSInterpolationInString) {
                  insideSCSSInterpolationInString = !insideSCSSInterpolationInString;
                  continue;
                }
                if (insideSCSSInterpolationInString) {
                  continue;
                }
                if (isColonNode(iNode) || isColonNode(iNextNode)) {
                  continue;
                }
                if (iNode.type === "value-atword" && iNode.value === "") {
                  continue;
                }
                if (iNode.value === "~") {
                  continue;
                }
                if (iNode.value && iNode.value.includes("\\") && iNextNode && iNextNode.type !== "value-comment") {
                  continue;
                }
                if (iPrevNode && iPrevNode.value && iPrevNode.value.indexOf("\\") === iPrevNode.value.length - 1 && iNode.type === "value-operator" && iNode.value === "/") {
                  continue;
                }
                if (iNode.value === "\\") {
                  continue;
                }
                if (isPostcssSimpleVarNode(iNode, iNextNode)) {
                  continue;
                }
                if (isHashNode(iNode) || isLeftCurlyBraceNode(iNode) || isRightCurlyBraceNode(iNextNode) || isLeftCurlyBraceNode(iNextNode) && hasEmptyRawBefore(iNextNode) || isRightCurlyBraceNode(iNode) && hasEmptyRawBefore(iNextNode)) {
                  continue;
                }
                if (iNode.value === "--" && isHashNode(iNextNode)) {
                  continue;
                }
                const isMathOperator = isMathOperatorNode(iNode);
                const isNextMathOperator = isMathOperatorNode(iNextNode);
                if ((isMathOperator && isHashNode(iNextNode) || isNextMathOperator && isRightCurlyBraceNode(iNode)) && hasEmptyRawBefore(iNextNode)) {
                  continue;
                }
                if (!iPrevNode && isDivisionNode(iNode)) {
                  continue;
                }
                if (insideValueFunctionNode(path4, "calc") && (isAdditionNode(iNode) || isAdditionNode(iNextNode) || isSubtractionNode(iNode) || isSubtractionNode(iNextNode)) && hasEmptyRawBefore(iNextNode)) {
                  continue;
                }
                const isColorAdjusterNode = (isAdditionNode(iNode) || isSubtractionNode(iNode)) && i2 === 0 && (iNextNode.type === "value-number" || iNextNode.isHex) && parentParentNode && isColorAdjusterFuncNode(parentParentNode) && !hasEmptyRawBefore(iNextNode);
                const requireSpaceBeforeOperator = iNextNextNode && iNextNextNode.type === "value-func" || iNextNextNode && isWordNode(iNextNextNode) || iNode.type === "value-func" || isWordNode(iNode);
                const requireSpaceAfterOperator = iNextNode.type === "value-func" || isWordNode(iNextNode) || iPrevNode && iPrevNode.type === "value-func" || iPrevNode && isWordNode(iPrevNode);
                if (!(isMultiplicationNode(iNextNode) || isMultiplicationNode(iNode)) && !insideValueFunctionNode(path4, "calc") && !isColorAdjusterNode && (isDivisionNode(iNextNode) && !requireSpaceBeforeOperator || isDivisionNode(iNode) && !requireSpaceAfterOperator || isAdditionNode(iNextNode) && !requireSpaceBeforeOperator || isAdditionNode(iNode) && !requireSpaceAfterOperator || isSubtractionNode(iNextNode) || isSubtractionNode(iNode)) && (hasEmptyRawBefore(iNextNode) || isMathOperator && (!iPrevNode || iPrevNode && isMathOperatorNode(iPrevNode)))) {
                  continue;
                }
                if (isInlineValueCommentNode(iNode)) {
                  if (parentNode.type === "value-paren_group") {
                    parts.push(dedent(hardline));
                    continue;
                  }
                  parts.push(hardline);
                  continue;
                }
                if (isControlDirective && (isEqualityOperatorNode(iNextNode) || isRelationalOperatorNode(iNextNode) || isIfElseKeywordNode(iNextNode) || isEachKeywordNode(iNode) || isForKeywordNode(iNode))) {
                  parts.push(" ");
                  continue;
                }
                if (atRuleAncestorNode && atRuleAncestorNode.name.toLowerCase() === "namespace") {
                  parts.push(" ");
                  continue;
                }
                if (isGridValue) {
                  if (iNode.source && iNextNode.source && iNode.source.start.line !== iNextNode.source.start.line) {
                    parts.push(hardline);
                    didBreak = true;
                  } else {
                    parts.push(" ");
                  }
                  continue;
                }
                if (isNextMathOperator) {
                  parts.push(" ");
                  continue;
                }
                if (iNextNode && iNextNode.value === "...") {
                  continue;
                }
                if (isAtWordPlaceholderNode(iNode) && isAtWordPlaceholderNode(iNextNode) && locEnd(iNode) === locStart(iNextNode)) {
                  continue;
                }
                if (isAtWordPlaceholderNode(iNode) && isParenGroupNode(iNextNode) && locEnd(iNode) === locStart(iNextNode.open)) {
                  parts.push(softline);
                  continue;
                }
                if (iNode.value === "with" && isParenGroupNode(iNextNode)) {
                  parts.push(" ");
                  continue;
                }
                parts.push(line);
              }
              if (hasInlineComment) {
                parts.push(breakParent);
              }
              if (didBreak) {
                parts.unshift(hardline);
              }
              if (isControlDirective) {
                return group(indent(parts));
              }
              if (insideURLFunctionInImportAtRuleNode(path4)) {
                return group(fill(parts));
              }
              return group(indent(fill(parts)));
            }
            case "value-paren_group": {
              const parentNode = path4.getParentNode();
              if (parentNode && isURLFunctionNode(parentNode) && (node.groups.length === 1 || node.groups.length > 0 && node.groups[0].type === "value-comma_group" && node.groups[0].groups.length > 0 && node.groups[0].groups[0].type === "value-word" && node.groups[0].groups[0].value.startsWith("data:"))) {
                return [node.open ? print("open") : "", join(",", path4.map(print, "groups")), node.close ? print("close") : ""];
              }
              if (!node.open) {
                const printed2 = path4.map(print, "groups");
                const res = [];
                for (let i2 = 0; i2 < printed2.length; i2++) {
                  if (i2 !== 0) {
                    res.push([",", line]);
                  }
                  res.push(printed2[i2]);
                }
                return group(indent(fill(res)));
              }
              const isSCSSMapItem = isSCSSMapItemNode(path4);
              const lastItem = getLast(node.groups);
              const isLastItemComment = lastItem && lastItem.type === "value-comment";
              const isKey = isKeyInValuePairNode(node, parentNode);
              const isConfiguration = isConfigurationNode(node, parentNode);
              const shouldBreak = isConfiguration || isSCSSMapItem && !isKey;
              const shouldDedent = isConfiguration || isKey;
              const printed = group([node.open ? print("open") : "", indent([softline, join([line], path4.map((childPath, index) => {
                const child = childPath.getValue();
                const isLast = index === node.groups.length - 1;
                const printed2 = [print(), isLast ? "" : ","];
                if (isKeyValuePairNode(child) && child.type === "value-comma_group" && child.groups && child.groups[0].type !== "value-paren_group" && child.groups[2] && child.groups[2].type === "value-paren_group") {
                  const parts = getDocParts(printed2[0].contents.contents);
                  parts[1] = group(parts[1]);
                  return group(dedent(printed2));
                }
                if (!isLast && child.type === "value-comma_group" && isNonEmptyArray(child.groups)) {
                  const last = getLast(child.groups);
                  if (last.source && isNextLineEmpty(options.originalText, last, locEnd)) {
                    printed2.push(hardline);
                  }
                }
                return printed2;
              }, "groups"))]), ifBreak(!isLastItemComment && isSCSS(options.parser, options.originalText) && isSCSSMapItem && shouldPrintComma(options) ? "," : ""), softline, node.close ? print("close") : ""], {
                shouldBreak
              });
              return shouldDedent ? dedent(printed) : printed;
            }
            case "value-func": {
              return [node.value, insideAtRuleNode(path4, "supports") && isMediaAndSupportsKeywords(node) ? " " : "", print("group")];
            }
            case "value-paren": {
              return node.value;
            }
            case "value-number": {
              return [printCssNumber(node.value), printUnit(node.unit)];
            }
            case "value-operator": {
              return node.value;
            }
            case "value-word": {
              if (node.isColor && node.isHex || isWideKeywords(node.value)) {
                return node.value.toLowerCase();
              }
              return node.value;
            }
            case "value-colon": {
              const parentNode = path4.getParentNode();
              const index = parentNode && parentNode.groups.indexOf(node);
              const prevNode = index && parentNode.groups[index - 1];
              return [node.value, prevNode && typeof prevNode.value === "string" && getLast(prevNode.value) === "\\" || insideValueFunctionNode(path4, "url") ? "" : line];
            }
            case "value-comma": {
              return [node.value, " "];
            }
            case "value-string": {
              return printString(node.raws.quote + node.value + node.raws.quote, options);
            }
            case "value-atword": {
              return ["@", node.value];
            }
            case "value-unicode-range": {
              return node.value;
            }
            case "value-unknown": {
              return node.value;
            }
            default:
              throw new Error(`Unknown postcss type ${JSON.stringify(node.type)}`);
          }
        }
        function printNodeSequence(path4, options, print) {
          const parts = [];
          path4.each((pathChild, i2, nodes) => {
            const prevNode = nodes[i2 - 1];
            if (prevNode && prevNode.type === "css-comment" && prevNode.text.trim() === "prettier-ignore") {
              const childNode = pathChild.getValue();
              parts.push(options.originalText.slice(locStart(childNode), locEnd(childNode)));
            } else {
              parts.push(print());
            }
            if (i2 !== nodes.length - 1) {
              if (nodes[i2 + 1].type === "css-comment" && !hasNewline(options.originalText, locStart(nodes[i2 + 1]), {
                backwards: true
              }) && !isFrontMatterNode(nodes[i2]) || nodes[i2 + 1].type === "css-atrule" && nodes[i2 + 1].name === "else" && nodes[i2].type !== "css-comment") {
                parts.push(" ");
              } else {
                parts.push(options.__isHTMLStyleAttribute ? line : hardline);
                if (isNextLineEmpty(options.originalText, pathChild.getValue(), locEnd) && !isFrontMatterNode(nodes[i2])) {
                  parts.push(hardline);
                }
              }
            }
          }, "nodes");
          return parts;
        }
        var STRING_REGEX = /(["'])(?:(?!\1)[^\\]|\\.)*\1/gs;
        var NUMBER_REGEX = /(?:\d*\.\d+|\d+\.?)(?:[Ee][+-]?\d+)?/g;
        var STANDARD_UNIT_REGEX = /[A-Za-z]+/g;
        var WORD_PART_REGEX = /[$@]?[A-Z_a-z\u0080-\uFFFF][\w\u0080-\uFFFF-]*/g;
        var ADJUST_NUMBERS_REGEX = new RegExp(STRING_REGEX.source + `|(${WORD_PART_REGEX.source})?(${NUMBER_REGEX.source})(${STANDARD_UNIT_REGEX.source})?`, "g");
        function adjustStrings(value, options) {
          return value.replace(STRING_REGEX, (match) => printString(match, options));
        }
        function quoteAttributeValue(value, options) {
          const quote = options.singleQuote ? "'" : '"';
          return value.includes('"') || value.includes("'") ? value : quote + value + quote;
        }
        function adjustNumbers(value) {
          return value.replace(ADJUST_NUMBERS_REGEX, (match, quote, wordPart, number, unit) => !wordPart && number ? printCssNumber(number) + maybeToLowerCase(unit || "") : match);
        }
        function printCssNumber(rawNumber) {
          return printNumber(rawNumber).replace(/\.0(?=$|e)/, "");
        }
        module22.exports = {
          print: genericPrint,
          embed,
          insertPragma,
          massageAstNode: clean
        };
      }
    });
    var require_options3 = __commonJS22({
      "src/language-css/options.js"(exports2, module22) {
        "use strict";
        var commonOptions = require_common_options();
        module22.exports = {
          singleQuote: commonOptions.singleQuote
        };
      }
    });
    var require_parsers2 = __commonJS22({
      "src/language-css/parsers.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          get css() {
            return require_parser_postcss().parsers.css;
          },
          get less() {
            return require_parser_postcss().parsers.less;
          },
          get scss() {
            return require_parser_postcss().parsers.scss;
          }
        };
      }
    });
    var require_CSS = __commonJS22({
      "node_modules/linguist-languages/data/CSS.json"(exports2, module22) {
        module22.exports = {
          name: "CSS",
          type: "markup",
          tmScope: "source.css",
          aceMode: "css",
          codemirrorMode: "css",
          codemirrorMimeType: "text/css",
          color: "#563d7c",
          extensions: [".css"],
          languageId: 50
        };
      }
    });
    var require_PostCSS = __commonJS22({
      "node_modules/linguist-languages/data/PostCSS.json"(exports2, module22) {
        module22.exports = {
          name: "PostCSS",
          type: "markup",
          color: "#dc3a0c",
          tmScope: "source.postcss",
          group: "CSS",
          extensions: [".pcss", ".postcss"],
          aceMode: "text",
          languageId: 262764437
        };
      }
    });
    var require_Less = __commonJS22({
      "node_modules/linguist-languages/data/Less.json"(exports2, module22) {
        module22.exports = {
          name: "Less",
          type: "markup",
          color: "#1d365d",
          aliases: ["less-css"],
          extensions: [".less"],
          tmScope: "source.css.less",
          aceMode: "less",
          codemirrorMode: "css",
          codemirrorMimeType: "text/css",
          languageId: 198
        };
      }
    });
    var require_SCSS = __commonJS22({
      "node_modules/linguist-languages/data/SCSS.json"(exports2, module22) {
        module22.exports = {
          name: "SCSS",
          type: "markup",
          color: "#c6538c",
          tmScope: "source.css.scss",
          aceMode: "scss",
          codemirrorMode: "css",
          codemirrorMimeType: "text/x-scss",
          extensions: [".scss"],
          languageId: 329
        };
      }
    });
    var require_language_css = __commonJS22({
      "src/language-css/index.js"(exports2, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_postcss();
        var options = require_options3();
        var parsers = require_parsers2();
        var languages = [createLanguage(require_CSS(), (data) => ({
          since: "1.4.0",
          parsers: ["css"],
          vscodeLanguageIds: ["css"],
          extensions: [...data.extensions, ".wxss"]
        })), createLanguage(require_PostCSS(), () => ({
          since: "1.4.0",
          parsers: ["css"],
          vscodeLanguageIds: ["postcss"]
        })), createLanguage(require_Less(), () => ({
          since: "1.4.0",
          parsers: ["less"],
          vscodeLanguageIds: ["less"]
        })), createLanguage(require_SCSS(), () => ({
          since: "1.4.0",
          parsers: ["scss"],
          vscodeLanguageIds: ["scss"]
        }))];
        var printers = {
          postcss: printer
        };
        module22.exports = {
          languages,
          options,
          printers,
          parsers
        };
      }
    });
    var require_loc3 = __commonJS22({
      "src/language-handlebars/loc.js"(exports2, module22) {
        "use strict";
        function locStart(node) {
          return node.loc.start.offset;
        }
        function locEnd(node) {
          return node.loc.end.offset;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_clean3 = __commonJS22({
      "src/language-handlebars/clean.js"(exports2, module22) {
        "use strict";
        function clean(ast, newNode) {
          if (ast.type === "TextNode") {
            const trimmed = ast.chars.trim();
            if (!trimmed) {
              return null;
            }
            newNode.chars = trimmed.replace(/[\t\n\f\r ]+/g, " ");
          }
          if (ast.type === "AttrNode" && ast.name.toLowerCase() === "class") {
            delete newNode.value;
          }
        }
        clean.ignoredProperties = /* @__PURE__ */ new Set(["loc", "selfClosing"]);
        module22.exports = clean;
      }
    });
    var require_html_void_elements = __commonJS22({
      "vendors/html-void-elements.json"(exports2, module22) {
        module22.exports = {
          htmlVoidElements: ["area", "base", "basefont", "bgsound", "br", "col", "command", "embed", "frame", "hr", "image", "img", "input", "isindex", "keygen", "link", "menuitem", "meta", "nextid", "param", "source", "track", "wbr"]
        };
      }
    });
    var require_utils92 = __commonJS22({
      "src/language-handlebars/utils.js"(exports2, module22) {
        "use strict";
        var {
          htmlVoidElements
        } = require_html_void_elements();
        var getLast = require_get_last();
        function isLastNodeOfSiblings(path4) {
          const node = path4.getValue();
          const parentNode = path4.getParentNode(0);
          if (isParentOfSomeType(path4, ["ElementNode"]) && getLast(parentNode.children) === node) {
            return true;
          }
          if (isParentOfSomeType(path4, ["Block"]) && getLast(parentNode.body) === node) {
            return true;
          }
          return false;
        }
        function isUppercase(string) {
          return string.toUpperCase() === string;
        }
        function isGlimmerComponent(node) {
          return isNodeOfSomeType(node, ["ElementNode"]) && typeof node.tag === "string" && !node.tag.startsWith(":") && (isUppercase(node.tag[0]) || node.tag.includes("."));
        }
        var voidTags = new Set(htmlVoidElements);
        function isVoid(node) {
          return voidTags.has(node.tag) || isGlimmerComponent(node) && node.children.every((node2) => isWhitespaceNode(node2));
        }
        function isWhitespaceNode(node) {
          return isNodeOfSomeType(node, ["TextNode"]) && !/\S/.test(node.chars);
        }
        function isNodeOfSomeType(node, types3) {
          return node && types3.includes(node.type);
        }
        function isParentOfSomeType(path4, types3) {
          const parentNode = path4.getParentNode(0);
          return isNodeOfSomeType(parentNode, types3);
        }
        function isPreviousNodeOfSomeType(path4, types3) {
          const previousNode = getPreviousNode(path4);
          return isNodeOfSomeType(previousNode, types3);
        }
        function isNextNodeOfSomeType(path4, types3) {
          const nextNode = getNextNode(path4);
          return isNodeOfSomeType(nextNode, types3);
        }
        function getSiblingNode(path4, offset) {
          var _path$getParentNode2, _ref7, _ref8, _parentNode$children;
          const node = path4.getValue();
          const parentNode = (_path$getParentNode2 = path4.getParentNode(0)) !== null && _path$getParentNode2 !== void 0 ? _path$getParentNode2 : {};
          const children = (_ref7 = (_ref8 = (_parentNode$children = parentNode.children) !== null && _parentNode$children !== void 0 ? _parentNode$children : parentNode.body) !== null && _ref8 !== void 0 ? _ref8 : parentNode.parts) !== null && _ref7 !== void 0 ? _ref7 : [];
          const index = children.indexOf(node);
          return index !== -1 && children[index + offset];
        }
        function getPreviousNode(path4, lookBack = 1) {
          return getSiblingNode(path4, -lookBack);
        }
        function getNextNode(path4) {
          return getSiblingNode(path4, 1);
        }
        function isPrettierIgnoreNode(node) {
          return isNodeOfSomeType(node, ["MustacheCommentStatement"]) && typeof node.value === "string" && node.value.trim() === "prettier-ignore";
        }
        function hasPrettierIgnore(path4) {
          const node = path4.getValue();
          const previousPreviousNode = getPreviousNode(path4, 2);
          return isPrettierIgnoreNode(node) || isPrettierIgnoreNode(previousPreviousNode);
        }
        module22.exports = {
          getNextNode,
          getPreviousNode,
          hasPrettierIgnore,
          isLastNodeOfSiblings,
          isNextNodeOfSomeType,
          isNodeOfSomeType,
          isParentOfSomeType,
          isPreviousNodeOfSomeType,
          isVoid,
          isWhitespaceNode
        };
      }
    });
    var require_printer_glimmer = __commonJS22({
      "src/language-handlebars/printer-glimmer.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            dedent,
            fill,
            group,
            hardline,
            ifBreak,
            indent,
            join,
            line,
            softline
          },
          utils: {
            getDocParts,
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          getPreferredQuote,
          isNonEmptyArray
        } = require_util();
        var {
          locStart,
          locEnd
        } = require_loc3();
        var clean = require_clean3();
        var {
          getNextNode,
          getPreviousNode,
          hasPrettierIgnore,
          isLastNodeOfSiblings,
          isNextNodeOfSomeType,
          isNodeOfSomeType,
          isParentOfSomeType,
          isPreviousNodeOfSomeType,
          isVoid,
          isWhitespaceNode
        } = require_utils92();
        var NEWLINES_TO_PRESERVE_MAX = 2;
        function print(path4, options, print2) {
          const node = path4.getValue();
          if (!node) {
            return "";
          }
          if (hasPrettierIgnore(path4)) {
            return options.originalText.slice(locStart(node), locEnd(node));
          }
          const favoriteQuote = options.singleQuote ? "'" : '"';
          switch (node.type) {
            case "Block":
            case "Program":
            case "Template": {
              return group(path4.map(print2, "body"));
            }
            case "ElementNode": {
              const startingTag = group(printStartingTag(path4, print2));
              const escapeNextElementNode = options.htmlWhitespaceSensitivity === "ignore" && isNextNodeOfSomeType(path4, ["ElementNode"]) ? softline : "";
              if (isVoid(node)) {
                return [startingTag, escapeNextElementNode];
              }
              const endingTag = ["</", node.tag, ">"];
              if (node.children.length === 0) {
                return [startingTag, indent(endingTag), escapeNextElementNode];
              }
              if (options.htmlWhitespaceSensitivity === "ignore") {
                return [startingTag, indent(printChildren(path4, options, print2)), hardline, indent(endingTag), escapeNextElementNode];
              }
              return [startingTag, indent(group(printChildren(path4, options, print2))), indent(endingTag), escapeNextElementNode];
            }
            case "BlockStatement": {
              const pp = path4.getParentNode(1);
              const isElseIf = pp && pp.inverse && pp.inverse.body.length === 1 && pp.inverse.body[0] === node && pp.inverse.body[0].path.parts[0] === "if";
              if (isElseIf) {
                return [printElseIfBlock(path4, print2), printProgram(path4, print2, options), printInverse(path4, print2, options)];
              }
              return [printOpenBlock(path4, print2), group([printProgram(path4, print2, options), printInverse(path4, print2, options), printCloseBlock(path4, print2, options)])];
            }
            case "ElementModifierStatement": {
              return group(["{{", printPathAndParams(path4, print2), "}}"]);
            }
            case "MustacheStatement": {
              return group([printOpeningMustache(node), printPathAndParams(path4, print2), printClosingMustache(node)]);
            }
            case "SubExpression": {
              return group(["(", printSubExpressionPathAndParams(path4, print2), softline, ")"]);
            }
            case "AttrNode": {
              const isText = node.value.type === "TextNode";
              const isEmptyText = isText && node.value.chars === "";
              if (isEmptyText && locStart(node.value) === locEnd(node.value)) {
                return node.name;
              }
              const quote = isText ? getPreferredQuote(node.value.chars, favoriteQuote).quote : node.value.type === "ConcatStatement" ? getPreferredQuote(node.value.parts.filter((part) => part.type === "TextNode").map((part) => part.chars).join(""), favoriteQuote).quote : "";
              const valueDoc = print2("value");
              return [node.name, "=", quote, node.name === "class" && quote ? group(indent(valueDoc)) : valueDoc, quote];
            }
            case "ConcatStatement": {
              return path4.map(print2, "parts");
            }
            case "Hash": {
              return join(line, path4.map(print2, "pairs"));
            }
            case "HashPair": {
              return [node.key, "=", print2("value")];
            }
            case "TextNode": {
              let text = node.chars.replace(/{{/g, "\\{{");
              const attrName = getCurrentAttributeName(path4);
              if (attrName) {
                if (attrName === "class") {
                  const formattedClasses = text.trim().split(/\s+/).join(" ");
                  let leadingSpace2 = false;
                  let trailingSpace2 = false;
                  if (isParentOfSomeType(path4, ["ConcatStatement"])) {
                    if (isPreviousNodeOfSomeType(path4, ["MustacheStatement"]) && /^\s/.test(text)) {
                      leadingSpace2 = true;
                    }
                    if (isNextNodeOfSomeType(path4, ["MustacheStatement"]) && /\s$/.test(text) && formattedClasses !== "") {
                      trailingSpace2 = true;
                    }
                  }
                  return [leadingSpace2 ? line : "", formattedClasses, trailingSpace2 ? line : ""];
                }
                return replaceTextEndOfLine(text);
              }
              const whitespacesOnlyRE = /^[\t\n\f\r ]*$/;
              const isWhitespaceOnly = whitespacesOnlyRE.test(text);
              const isFirstElement = !getPreviousNode(path4);
              const isLastElement = !getNextNode(path4);
              if (options.htmlWhitespaceSensitivity !== "ignore") {
                const leadingWhitespacesRE = /^[\t\n\f\r ]*/;
                const trailingWhitespacesRE = /[\t\n\f\r ]*$/;
                const shouldTrimTrailingNewlines = isLastElement && isParentOfSomeType(path4, ["Template"]);
                const shouldTrimLeadingNewlines = isFirstElement && isParentOfSomeType(path4, ["Template"]);
                if (isWhitespaceOnly) {
                  if (shouldTrimLeadingNewlines || shouldTrimTrailingNewlines) {
                    return "";
                  }
                  let breaks = [line];
                  const newlines = countNewLines(text);
                  if (newlines) {
                    breaks = generateHardlines(newlines);
                  }
                  if (isLastNodeOfSiblings(path4)) {
                    breaks = breaks.map((newline) => dedent(newline));
                  }
                  return breaks;
                }
                const [lead] = text.match(leadingWhitespacesRE);
                const [tail] = text.match(trailingWhitespacesRE);
                let leadBreaks = [];
                if (lead) {
                  leadBreaks = [line];
                  const leadingNewlines = countNewLines(lead);
                  if (leadingNewlines) {
                    leadBreaks = generateHardlines(leadingNewlines);
                  }
                  text = text.replace(leadingWhitespacesRE, "");
                }
                let trailBreaks = [];
                if (tail) {
                  if (!shouldTrimTrailingNewlines) {
                    trailBreaks = [line];
                    const trailingNewlines = countNewLines(tail);
                    if (trailingNewlines) {
                      trailBreaks = generateHardlines(trailingNewlines);
                    }
                    if (isLastNodeOfSiblings(path4)) {
                      trailBreaks = trailBreaks.map((hardline2) => dedent(hardline2));
                    }
                  }
                  text = text.replace(trailingWhitespacesRE, "");
                }
                return [...leadBreaks, fill(getTextValueParts(text)), ...trailBreaks];
              }
              const lineBreaksCount = countNewLines(text);
              let leadingLineBreaksCount = countLeadingNewLines(text);
              let trailingLineBreaksCount = countTrailingNewLines(text);
              if ((isFirstElement || isLastElement) && isWhitespaceOnly && isParentOfSomeType(path4, ["Block", "ElementNode", "Template"])) {
                return "";
              }
              if (isWhitespaceOnly && lineBreaksCount) {
                leadingLineBreaksCount = Math.min(lineBreaksCount, NEWLINES_TO_PRESERVE_MAX);
                trailingLineBreaksCount = 0;
              } else {
                if (isNextNodeOfSomeType(path4, ["BlockStatement", "ElementNode"])) {
                  trailingLineBreaksCount = Math.max(trailingLineBreaksCount, 1);
                }
                if (isPreviousNodeOfSomeType(path4, ["BlockStatement", "ElementNode"])) {
                  leadingLineBreaksCount = Math.max(leadingLineBreaksCount, 1);
                }
              }
              let leadingSpace = "";
              let trailingSpace = "";
              if (trailingLineBreaksCount === 0 && isNextNodeOfSomeType(path4, ["MustacheStatement"])) {
                trailingSpace = " ";
              }
              if (leadingLineBreaksCount === 0 && isPreviousNodeOfSomeType(path4, ["MustacheStatement"])) {
                leadingSpace = " ";
              }
              if (isFirstElement) {
                leadingLineBreaksCount = 0;
                leadingSpace = "";
              }
              if (isLastElement) {
                trailingLineBreaksCount = 0;
                trailingSpace = "";
              }
              text = text.replace(/^[\t\n\f\r ]+/g, leadingSpace).replace(/[\t\n\f\r ]+$/, trailingSpace);
              return [...generateHardlines(leadingLineBreaksCount), fill(getTextValueParts(text)), ...generateHardlines(trailingLineBreaksCount)];
            }
            case "MustacheCommentStatement": {
              const start = locStart(node);
              const end = locEnd(node);
              const isLeftWhiteSpaceSensitive = options.originalText.charAt(start + 2) === "~";
              const isRightWhitespaceSensitive = options.originalText.charAt(end - 3) === "~";
              const dashes = node.value.includes("}}") ? "--" : "";
              return ["{{", isLeftWhiteSpaceSensitive ? "~" : "", "!", dashes, node.value, dashes, isRightWhitespaceSensitive ? "~" : "", "}}"];
            }
            case "PathExpression": {
              return node.original;
            }
            case "BooleanLiteral": {
              return String(node.value);
            }
            case "CommentStatement": {
              return ["<!--", node.value, "-->"];
            }
            case "StringLiteral": {
              if (needsOppositeQuote(path4)) {
                const printFavoriteQuote = !options.singleQuote ? "'" : '"';
                return printStringLiteral(node.value, printFavoriteQuote);
              }
              return printStringLiteral(node.value, favoriteQuote);
            }
            case "NumberLiteral": {
              return String(node.value);
            }
            case "UndefinedLiteral": {
              return "undefined";
            }
            case "NullLiteral": {
              return "null";
            }
            default:
              throw new Error("unknown glimmer type: " + JSON.stringify(node.type));
          }
        }
        function sortByLoc(a, b) {
          return locStart(a) - locStart(b);
        }
        function printStartingTag(path4, print2) {
          const node = path4.getValue();
          const types3 = ["attributes", "modifiers", "comments"].filter((property) => isNonEmptyArray(node[property]));
          const attributes = types3.flatMap((type) => node[type]).sort(sortByLoc);
          for (const attributeType of types3) {
            path4.each((attributePath) => {
              const index = attributes.indexOf(attributePath.getValue());
              attributes.splice(index, 1, [line, print2()]);
            }, attributeType);
          }
          if (isNonEmptyArray(node.blockParams)) {
            attributes.push(line, printBlockParams(node));
          }
          return ["<", node.tag, indent(attributes), printStartingTagEndMarker(node)];
        }
        function printChildren(path4, options, print2) {
          const node = path4.getValue();
          const isEmpty = node.children.every((node2) => isWhitespaceNode(node2));
          if (options.htmlWhitespaceSensitivity === "ignore" && isEmpty) {
            return "";
          }
          return path4.map((childPath, childIndex) => {
            const printedChild = print2();
            if (childIndex === 0 && options.htmlWhitespaceSensitivity === "ignore") {
              return [softline, printedChild];
            }
            return printedChild;
          }, "children");
        }
        function printStartingTagEndMarker(node) {
          if (isVoid(node)) {
            return ifBreak([softline, "/>"], [" />", softline]);
          }
          return ifBreak([softline, ">"], ">");
        }
        function printOpeningMustache(node) {
          const mustache = node.escaped === false ? "{{{" : "{{";
          const strip = node.strip && node.strip.open ? "~" : "";
          return [mustache, strip];
        }
        function printClosingMustache(node) {
          const mustache = node.escaped === false ? "}}}" : "}}";
          const strip = node.strip && node.strip.close ? "~" : "";
          return [strip, mustache];
        }
        function printOpeningBlockOpeningMustache(node) {
          const opening = printOpeningMustache(node);
          const strip = node.openStrip.open ? "~" : "";
          return [opening, strip, "#"];
        }
        function printOpeningBlockClosingMustache(node) {
          const closing = printClosingMustache(node);
          const strip = node.openStrip.close ? "~" : "";
          return [strip, closing];
        }
        function printClosingBlockOpeningMustache(node) {
          const opening = printOpeningMustache(node);
          const strip = node.closeStrip.open ? "~" : "";
          return [opening, strip, "/"];
        }
        function printClosingBlockClosingMustache(node) {
          const closing = printClosingMustache(node);
          const strip = node.closeStrip.close ? "~" : "";
          return [strip, closing];
        }
        function printInverseBlockOpeningMustache(node) {
          const opening = printOpeningMustache(node);
          const strip = node.inverseStrip.open ? "~" : "";
          return [opening, strip];
        }
        function printInverseBlockClosingMustache(node) {
          const closing = printClosingMustache(node);
          const strip = node.inverseStrip.close ? "~" : "";
          return [strip, closing];
        }
        function printOpenBlock(path4, print2) {
          const node = path4.getValue();
          const openingMustache = printOpeningBlockOpeningMustache(node);
          const closingMustache = printOpeningBlockClosingMustache(node);
          const attributes = [printPath(path4, print2)];
          const params = printParams(path4, print2);
          if (params) {
            attributes.push(line, params);
          }
          if (isNonEmptyArray(node.program.blockParams)) {
            const block = printBlockParams(node.program);
            attributes.push(line, block);
          }
          return group([openingMustache, indent(attributes), softline, closingMustache]);
        }
        function printElseBlock(node, options) {
          return [options.htmlWhitespaceSensitivity === "ignore" ? hardline : "", printInverseBlockOpeningMustache(node), "else", printInverseBlockClosingMustache(node)];
        }
        function printElseIfBlock(path4, print2) {
          const parentNode = path4.getParentNode(1);
          return [printInverseBlockOpeningMustache(parentNode), "else if ", printParams(path4, print2), printInverseBlockClosingMustache(parentNode)];
        }
        function printCloseBlock(path4, print2, options) {
          const node = path4.getValue();
          if (options.htmlWhitespaceSensitivity === "ignore") {
            const escape = blockStatementHasOnlyWhitespaceInProgram(node) ? softline : hardline;
            return [escape, printClosingBlockOpeningMustache(node), print2("path"), printClosingBlockClosingMustache(node)];
          }
          return [printClosingBlockOpeningMustache(node), print2("path"), printClosingBlockClosingMustache(node)];
        }
        function blockStatementHasOnlyWhitespaceInProgram(node) {
          return isNodeOfSomeType(node, ["BlockStatement"]) && node.program.body.every((node2) => isWhitespaceNode(node2));
        }
        function blockStatementHasElseIf(node) {
          return blockStatementHasElse(node) && node.inverse.body.length === 1 && isNodeOfSomeType(node.inverse.body[0], ["BlockStatement"]) && node.inverse.body[0].path.parts[0] === "if";
        }
        function blockStatementHasElse(node) {
          return isNodeOfSomeType(node, ["BlockStatement"]) && node.inverse;
        }
        function printProgram(path4, print2, options) {
          const node = path4.getValue();
          if (blockStatementHasOnlyWhitespaceInProgram(node)) {
            return "";
          }
          const program = print2("program");
          if (options.htmlWhitespaceSensitivity === "ignore") {
            return indent([hardline, program]);
          }
          return indent(program);
        }
        function printInverse(path4, print2, options) {
          const node = path4.getValue();
          const inverse = print2("inverse");
          const printed = options.htmlWhitespaceSensitivity === "ignore" ? [hardline, inverse] : inverse;
          if (blockStatementHasElseIf(node)) {
            return printed;
          }
          if (blockStatementHasElse(node)) {
            return [printElseBlock(node, options), indent(printed)];
          }
          return "";
        }
        function getTextValueParts(value) {
          return getDocParts(join(line, splitByHtmlWhitespace(value)));
        }
        function splitByHtmlWhitespace(string) {
          return string.split(/[\t\n\f\r ]+/);
        }
        function getCurrentAttributeName(path4) {
          for (let depth = 0; depth < 2; depth++) {
            const parentNode = path4.getParentNode(depth);
            if (parentNode && parentNode.type === "AttrNode") {
              return parentNode.name.toLowerCase();
            }
          }
        }
        function countNewLines(string) {
          string = typeof string === "string" ? string : "";
          return string.split("\n").length - 1;
        }
        function countLeadingNewLines(string) {
          string = typeof string === "string" ? string : "";
          const newLines = (string.match(/^([^\S\n\r]*[\n\r])+/g) || [])[0] || "";
          return countNewLines(newLines);
        }
        function countTrailingNewLines(string) {
          string = typeof string === "string" ? string : "";
          const newLines = (string.match(/([\n\r][^\S\n\r]*)+$/g) || [])[0] || "";
          return countNewLines(newLines);
        }
        function generateHardlines(number = 0) {
          return Array.from({
            length: Math.min(number, NEWLINES_TO_PRESERVE_MAX)
          }).fill(hardline);
        }
        function printStringLiteral(stringLiteral, favoriteQuote) {
          const {
            quote,
            regex
          } = getPreferredQuote(stringLiteral, favoriteQuote);
          return [quote, stringLiteral.replace(regex, `\\${quote}`), quote];
        }
        function needsOppositeQuote(path4) {
          let index = 0;
          let parentNode = path4.getParentNode(index);
          while (parentNode && isNodeOfSomeType(parentNode, ["SubExpression"])) {
            index++;
            parentNode = path4.getParentNode(index);
          }
          if (parentNode && isNodeOfSomeType(path4.getParentNode(index + 1), ["ConcatStatement"]) && isNodeOfSomeType(path4.getParentNode(index + 2), ["AttrNode"])) {
            return true;
          }
          return false;
        }
        function printSubExpressionPathAndParams(path4, print2) {
          const printed = printPath(path4, print2);
          const params = printParams(path4, print2);
          if (!params) {
            return printed;
          }
          return indent([printed, line, group(params)]);
        }
        function printPathAndParams(path4, print2) {
          const p = printPath(path4, print2);
          const params = printParams(path4, print2);
          if (!params) {
            return p;
          }
          return [indent([p, line, params]), softline];
        }
        function printPath(path4, print2) {
          return print2("path");
        }
        function printParams(path4, print2) {
          const node = path4.getValue();
          const parts = [];
          if (node.params.length > 0) {
            const params = path4.map(print2, "params");
            parts.push(...params);
          }
          if (node.hash && node.hash.pairs.length > 0) {
            const hash = print2("hash");
            parts.push(hash);
          }
          if (parts.length === 0) {
            return "";
          }
          return join(line, parts);
        }
        function printBlockParams(node) {
          return ["as |", node.blockParams.join(" "), "|"];
        }
        module22.exports = {
          print,
          massageAstNode: clean
        };
      }
    });
    var require_parsers3 = __commonJS22({
      "src/language-handlebars/parsers.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          get glimmer() {
            return require_parser_glimmer().parsers.glimmer;
          }
        };
      }
    });
    var require_Handlebars = __commonJS22({
      "node_modules/linguist-languages/data/Handlebars.json"(exports2, module22) {
        module22.exports = {
          name: "Handlebars",
          type: "markup",
          color: "#f7931e",
          aliases: ["hbs", "htmlbars"],
          extensions: [".handlebars", ".hbs"],
          tmScope: "text.html.handlebars",
          aceMode: "handlebars",
          languageId: 155
        };
      }
    });
    var require_language_handlebars = __commonJS22({
      "src/language-handlebars/index.js"(exports2, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_glimmer();
        var parsers = require_parsers3();
        var languages = [createLanguage(require_Handlebars(), () => ({
          since: "2.3.0",
          parsers: ["glimmer"],
          vscodeLanguageIds: ["handlebars"]
        }))];
        var printers = {
          glimmer: printer
        };
        module22.exports = {
          languages,
          printers,
          parsers
        };
      }
    });
    var require_pragma3 = __commonJS22({
      "src/language-graphql/pragma.js"(exports2, module22) {
        "use strict";
        function hasPragma(text) {
          return /^\s*#[^\S\n]*@(?:format|prettier)\s*(?:\n|$)/.test(text);
        }
        function insertPragma(text) {
          return "# @format\n\n" + text;
        }
        module22.exports = {
          hasPragma,
          insertPragma
        };
      }
    });
    var require_loc4 = __commonJS22({
      "src/language-graphql/loc.js"(exports2, module22) {
        "use strict";
        function locStart(node) {
          if (typeof node.start === "number") {
            return node.start;
          }
          return node.loc && node.loc.start;
        }
        function locEnd(node) {
          if (typeof node.end === "number") {
            return node.end;
          }
          return node.loc && node.loc.end;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_printer_graphql = __commonJS22({
      "src/language-graphql/printer-graphql.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            join,
            hardline,
            line,
            softline,
            group,
            indent,
            ifBreak
          }
        } = require_doc();
        var {
          isNextLineEmpty,
          isNonEmptyArray
        } = require_util();
        var {
          insertPragma
        } = require_pragma3();
        var {
          locStart,
          locEnd
        } = require_loc4();
        function genericPrint(path4, options, print) {
          const node = path4.getValue();
          if (!node) {
            return "";
          }
          if (typeof node === "string") {
            return node;
          }
          switch (node.kind) {
            case "Document": {
              const parts = [];
              path4.each((pathChild, index, definitions) => {
                parts.push(print());
                if (index !== definitions.length - 1) {
                  parts.push(hardline);
                  if (isNextLineEmpty(options.originalText, pathChild.getValue(), locEnd)) {
                    parts.push(hardline);
                  }
                }
              }, "definitions");
              return [...parts, hardline];
            }
            case "OperationDefinition": {
              const hasOperation = options.originalText[locStart(node)] !== "{";
              const hasName = Boolean(node.name);
              return [hasOperation ? node.operation : "", hasOperation && hasName ? [" ", print("name")] : "", hasOperation && !hasName && isNonEmptyArray(node.variableDefinitions) ? " " : "", isNonEmptyArray(node.variableDefinitions) ? group(["(", indent([softline, join([ifBreak("", ", "), softline], path4.map(print, "variableDefinitions"))]), softline, ")"]) : "", printDirectives(path4, print, node), node.selectionSet ? !hasOperation && !hasName ? "" : " " : "", print("selectionSet")];
            }
            case "FragmentDefinition": {
              return ["fragment ", print("name"), isNonEmptyArray(node.variableDefinitions) ? group(["(", indent([softline, join([ifBreak("", ", "), softline], path4.map(print, "variableDefinitions"))]), softline, ")"]) : "", " on ", print("typeCondition"), printDirectives(path4, print, node), " ", print("selectionSet")];
            }
            case "SelectionSet": {
              return ["{", indent([hardline, join(hardline, printSequence(path4, options, print, "selections"))]), hardline, "}"];
            }
            case "Field": {
              return group([node.alias ? [print("alias"), ": "] : "", print("name"), node.arguments.length > 0 ? group(["(", indent([softline, join([ifBreak("", ", "), softline], printSequence(path4, options, print, "arguments"))]), softline, ")"]) : "", printDirectives(path4, print, node), node.selectionSet ? " " : "", print("selectionSet")]);
            }
            case "Name": {
              return node.value;
            }
            case "StringValue": {
              if (node.block) {
                const lines = node.value.replace(/"""/g, "\\$&").split("\n");
                if (lines.length === 1) {
                  lines[0] = lines[0].trim();
                }
                if (lines.every((line2) => line2 === "")) {
                  lines.length = 0;
                }
                return join(hardline, ['"""', ...lines, '"""']);
              }
              return ['"', node.value.replace(/["\\]/g, "\\$&").replace(/\n/g, "\\n"), '"'];
            }
            case "IntValue":
            case "FloatValue":
            case "EnumValue": {
              return node.value;
            }
            case "BooleanValue": {
              return node.value ? "true" : "false";
            }
            case "NullValue": {
              return "null";
            }
            case "Variable": {
              return ["$", print("name")];
            }
            case "ListValue": {
              return group(["[", indent([softline, join([ifBreak("", ", "), softline], path4.map(print, "values"))]), softline, "]"]);
            }
            case "ObjectValue": {
              return group(["{", options.bracketSpacing && node.fields.length > 0 ? " " : "", indent([softline, join([ifBreak("", ", "), softline], path4.map(print, "fields"))]), softline, ifBreak("", options.bracketSpacing && node.fields.length > 0 ? " " : ""), "}"]);
            }
            case "ObjectField":
            case "Argument": {
              return [print("name"), ": ", print("value")];
            }
            case "Directive": {
              return ["@", print("name"), node.arguments.length > 0 ? group(["(", indent([softline, join([ifBreak("", ", "), softline], printSequence(path4, options, print, "arguments"))]), softline, ")"]) : ""];
            }
            case "NamedType": {
              return print("name");
            }
            case "VariableDefinition": {
              return [print("variable"), ": ", print("type"), node.defaultValue ? [" = ", print("defaultValue")] : "", printDirectives(path4, print, node)];
            }
            case "ObjectTypeExtension":
            case "ObjectTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "ObjectTypeExtension" ? "extend " : "", "type ", print("name"), node.interfaces.length > 0 ? [" implements ", ...printInterfaces(path4, options, print)] : "", printDirectives(path4, print, node), node.fields.length > 0 ? [" {", indent([hardline, join(hardline, printSequence(path4, options, print, "fields"))]), hardline, "}"] : ""];
            }
            case "FieldDefinition": {
              return [print("description"), node.description ? hardline : "", print("name"), node.arguments.length > 0 ? group(["(", indent([softline, join([ifBreak("", ", "), softline], printSequence(path4, options, print, "arguments"))]), softline, ")"]) : "", ": ", print("type"), printDirectives(path4, print, node)];
            }
            case "DirectiveDefinition": {
              return [print("description"), node.description ? hardline : "", "directive ", "@", print("name"), node.arguments.length > 0 ? group(["(", indent([softline, join([ifBreak("", ", "), softline], printSequence(path4, options, print, "arguments"))]), softline, ")"]) : "", node.repeatable ? " repeatable" : "", " on ", join(" | ", path4.map(print, "locations"))];
            }
            case "EnumTypeExtension":
            case "EnumTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "EnumTypeExtension" ? "extend " : "", "enum ", print("name"), printDirectives(path4, print, node), node.values.length > 0 ? [" {", indent([hardline, join(hardline, printSequence(path4, options, print, "values"))]), hardline, "}"] : ""];
            }
            case "EnumValueDefinition": {
              return [print("description"), node.description ? hardline : "", print("name"), printDirectives(path4, print, node)];
            }
            case "InputValueDefinition": {
              return [print("description"), node.description ? node.description.block ? hardline : line : "", print("name"), ": ", print("type"), node.defaultValue ? [" = ", print("defaultValue")] : "", printDirectives(path4, print, node)];
            }
            case "InputObjectTypeExtension":
            case "InputObjectTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "InputObjectTypeExtension" ? "extend " : "", "input ", print("name"), printDirectives(path4, print, node), node.fields.length > 0 ? [" {", indent([hardline, join(hardline, printSequence(path4, options, print, "fields"))]), hardline, "}"] : ""];
            }
            case "SchemaExtension": {
              return ["extend schema", printDirectives(path4, print, node), ...node.operationTypes.length > 0 ? [" {", indent([hardline, join(hardline, printSequence(path4, options, print, "operationTypes"))]), hardline, "}"] : []];
            }
            case "SchemaDefinition": {
              return [print("description"), node.description ? hardline : "", "schema", printDirectives(path4, print, node), " {", node.operationTypes.length > 0 ? indent([hardline, join(hardline, printSequence(path4, options, print, "operationTypes"))]) : "", hardline, "}"];
            }
            case "OperationTypeDefinition": {
              return [print("operation"), ": ", print("type")];
            }
            case "InterfaceTypeExtension":
            case "InterfaceTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "InterfaceTypeExtension" ? "extend " : "", "interface ", print("name"), node.interfaces.length > 0 ? [" implements ", ...printInterfaces(path4, options, print)] : "", printDirectives(path4, print, node), node.fields.length > 0 ? [" {", indent([hardline, join(hardline, printSequence(path4, options, print, "fields"))]), hardline, "}"] : ""];
            }
            case "FragmentSpread": {
              return ["...", print("name"), printDirectives(path4, print, node)];
            }
            case "InlineFragment": {
              return ["...", node.typeCondition ? [" on ", print("typeCondition")] : "", printDirectives(path4, print, node), " ", print("selectionSet")];
            }
            case "UnionTypeExtension":
            case "UnionTypeDefinition": {
              return group([print("description"), node.description ? hardline : "", group([node.kind === "UnionTypeExtension" ? "extend " : "", "union ", print("name"), printDirectives(path4, print, node), node.types.length > 0 ? [" =", ifBreak("", " "), indent([ifBreak([line, "  "]), join([line, "| "], path4.map(print, "types"))])] : ""])]);
            }
            case "ScalarTypeExtension":
            case "ScalarTypeDefinition": {
              return [print("description"), node.description ? hardline : "", node.kind === "ScalarTypeExtension" ? "extend " : "", "scalar ", print("name"), printDirectives(path4, print, node)];
            }
            case "NonNullType": {
              return [print("type"), "!"];
            }
            case "ListType": {
              return ["[", print("type"), "]"];
            }
            default:
              throw new Error("unknown graphql type: " + JSON.stringify(node.kind));
          }
        }
        function printDirectives(path4, print, node) {
          if (node.directives.length === 0) {
            return "";
          }
          const printed = join(line, path4.map(print, "directives"));
          if (node.kind === "FragmentDefinition" || node.kind === "OperationDefinition") {
            return group([line, printed]);
          }
          return [" ", group(indent([softline, printed]))];
        }
        function printSequence(path4, options, print, property) {
          return path4.map((path22, index, sequence) => {
            const printed = print();
            if (index < sequence.length - 1 && isNextLineEmpty(options.originalText, path22.getValue(), locEnd)) {
              return [printed, hardline];
            }
            return printed;
          }, property);
        }
        function canAttachComment(node) {
          return node.kind && node.kind !== "Comment";
        }
        function printComment(commentPath) {
          const comment = commentPath.getValue();
          if (comment.kind === "Comment") {
            return "#" + comment.value.trimEnd();
          }
          throw new Error("Not a comment: " + JSON.stringify(comment));
        }
        function printInterfaces(path4, options, print) {
          const node = path4.getNode();
          const parts = [];
          const {
            interfaces
          } = node;
          const printed = path4.map((node2) => print(node2), "interfaces");
          for (let index = 0; index < interfaces.length; index++) {
            const interfaceNode = interfaces[index];
            parts.push(printed[index]);
            const nextInterfaceNode = interfaces[index + 1];
            if (nextInterfaceNode) {
              const textBetween = options.originalText.slice(interfaceNode.loc.end, nextInterfaceNode.loc.start);
              const hasComment = textBetween.includes("#");
              const separator = textBetween.replace(/#.*/g, "").trim();
              parts.push(separator === "," ? "," : " &", hasComment ? line : " ");
            }
          }
          return parts;
        }
        function clean(node, newNode) {
          if (node.kind === "StringValue" && node.block && !node.value.includes("\n")) {
            newNode.value = newNode.value.trim();
          }
        }
        clean.ignoredProperties = /* @__PURE__ */ new Set(["loc", "comments"]);
        function hasPrettierIgnore(path4) {
          var _node$comments;
          const node = path4.getValue();
          return node === null || node === void 0 ? void 0 : (_node$comments = node.comments) === null || _node$comments === void 0 ? void 0 : _node$comments.some((comment) => comment.value.trim() === "prettier-ignore");
        }
        module22.exports = {
          print: genericPrint,
          massageAstNode: clean,
          hasPrettierIgnore,
          insertPragma,
          printComment,
          canAttachComment
        };
      }
    });
    var require_options4 = __commonJS22({
      "src/language-graphql/options.js"(exports2, module22) {
        "use strict";
        var commonOptions = require_common_options();
        module22.exports = {
          bracketSpacing: commonOptions.bracketSpacing
        };
      }
    });
    var require_parsers4 = __commonJS22({
      "src/language-graphql/parsers.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          get graphql() {
            return require_parser_graphql().parsers.graphql;
          }
        };
      }
    });
    var require_GraphQL = __commonJS22({
      "node_modules/linguist-languages/data/GraphQL.json"(exports2, module22) {
        module22.exports = {
          name: "GraphQL",
          type: "data",
          color: "#e10098",
          extensions: [".graphql", ".gql", ".graphqls"],
          tmScope: "source.graphql",
          aceMode: "text",
          languageId: 139
        };
      }
    });
    var require_language_graphql = __commonJS22({
      "src/language-graphql/index.js"(exports2, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_graphql();
        var options = require_options4();
        var parsers = require_parsers4();
        var languages = [createLanguage(require_GraphQL(), () => ({
          since: "1.5.0",
          parsers: ["graphql"],
          vscodeLanguageIds: ["graphql"]
        }))];
        var printers = {
          graphql: printer
        };
        module22.exports = {
          languages,
          options,
          printers,
          parsers
        };
      }
    });
    var require_loc5 = __commonJS22({
      "src/language-markdown/loc.js"(exports2, module22) {
        "use strict";
        function locStart(node) {
          return node.position.start.offset;
        }
        function locEnd(node) {
          return node.position.end.offset;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_constants_evaluate = __commonJS22({
      "src/language-markdown/constants.evaluate.js"(exports2, module22) {
        module22.exports = {
          cjkPattern: "(?:[\\u02ea-\\u02eb\\u1100-\\u11ff\\u2e80-\\u2e99\\u2e9b-\\u2ef3\\u2f00-\\u2fd5\\u2ff0-\\u303f\\u3041-\\u3096\\u3099-\\u309f\\u30a1-\\u30fa\\u30fc-\\u30ff\\u3105-\\u312f\\u3131-\\u318e\\u3190-\\u3191\\u3196-\\u31ba\\u31c0-\\u31e3\\u31f0-\\u321e\\u322a-\\u3247\\u3260-\\u327e\\u328a-\\u32b0\\u32c0-\\u32cb\\u32d0-\\u3370\\u337b-\\u337f\\u33e0-\\u33fe\\u3400-\\u4db5\\u4e00-\\u9fef\\ua960-\\ua97c\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\uf900-\\ufa6d\\ufa70-\\ufad9\\ufe10-\\ufe1f\\ufe30-\\ufe6f\\uff00-\\uffef]|[\\ud840-\\ud868\\ud86a-\\ud86c\\ud86f-\\ud872\\ud874-\\ud879][\\udc00-\\udfff]|\\ud82c[\\udc00-\\udd1e\\udd50-\\udd52\\udd64-\\udd67]|\\ud83c[\\ude00\\ude50-\\ude51]|\\ud869[\\udc00-\\uded6\\udf00-\\udfff]|\\ud86d[\\udc00-\\udf34\\udf40-\\udfff]|\\ud86e[\\udc00-\\udc1d\\udc20-\\udfff]|\\ud873[\\udc00-\\udea1\\udeb0-\\udfff]|\\ud87a[\\udc00-\\udfe0]|\\ud87e[\\udc00-\\ude1d])(?:[\\ufe00-\\ufe0f]|\\udb40[\\udd00-\\uddef])?",
          kPattern: "[\\u1100-\\u11ff\\u3001-\\u3003\\u3008-\\u3011\\u3013-\\u301f\\u302e-\\u3030\\u3037\\u30fb\\u3131-\\u318e\\u3200-\\u321e\\u3260-\\u327e\\ua960-\\ua97c\\uac00-\\ud7a3\\ud7b0-\\ud7c6\\ud7cb-\\ud7fb\\ufe45-\\ufe46\\uff61-\\uff65\\uffa0-\\uffbe\\uffc2-\\uffc7\\uffca-\\uffcf\\uffd2-\\uffd7\\uffda-\\uffdc]",
          punctuationPattern: "[\\u0021-\\u002f\\u003a-\\u0040\\u005b-\\u0060\\u007b-\\u007e\\u00a1\\u00a7\\u00ab\\u00b6-\\u00b7\\u00bb\\u00bf\\u037e\\u0387\\u055a-\\u055f\\u0589-\\u058a\\u05be\\u05c0\\u05c3\\u05c6\\u05f3-\\u05f4\\u0609-\\u060a\\u060c-\\u060d\\u061b\\u061e-\\u061f\\u066a-\\u066d\\u06d4\\u0700-\\u070d\\u07f7-\\u07f9\\u0830-\\u083e\\u085e\\u0964-\\u0965\\u0970\\u09fd\\u0a76\\u0af0\\u0c77\\u0c84\\u0df4\\u0e4f\\u0e5a-\\u0e5b\\u0f04-\\u0f12\\u0f14\\u0f3a-\\u0f3d\\u0f85\\u0fd0-\\u0fd4\\u0fd9-\\u0fda\\u104a-\\u104f\\u10fb\\u1360-\\u1368\\u1400\\u166e\\u169b-\\u169c\\u16eb-\\u16ed\\u1735-\\u1736\\u17d4-\\u17d6\\u17d8-\\u17da\\u1800-\\u180a\\u1944-\\u1945\\u1a1e-\\u1a1f\\u1aa0-\\u1aa6\\u1aa8-\\u1aad\\u1b5a-\\u1b60\\u1bfc-\\u1bff\\u1c3b-\\u1c3f\\u1c7e-\\u1c7f\\u1cc0-\\u1cc7\\u1cd3\\u2010-\\u2027\\u2030-\\u2043\\u2045-\\u2051\\u2053-\\u205e\\u207d-\\u207e\\u208d-\\u208e\\u2308-\\u230b\\u2329-\\u232a\\u2768-\\u2775\\u27c5-\\u27c6\\u27e6-\\u27ef\\u2983-\\u2998\\u29d8-\\u29db\\u29fc-\\u29fd\\u2cf9-\\u2cfc\\u2cfe-\\u2cff\\u2d70\\u2e00-\\u2e2e\\u2e30-\\u2e4f\\u3001-\\u3003\\u3008-\\u3011\\u3014-\\u301f\\u3030\\u303d\\u30a0\\u30fb\\ua4fe-\\ua4ff\\ua60d-\\ua60f\\ua673\\ua67e\\ua6f2-\\ua6f7\\ua874-\\ua877\\ua8ce-\\ua8cf\\ua8f8-\\ua8fa\\ua8fc\\ua92e-\\ua92f\\ua95f\\ua9c1-\\ua9cd\\ua9de-\\ua9df\\uaa5c-\\uaa5f\\uaade-\\uaadf\\uaaf0-\\uaaf1\\uabeb\\ufd3e-\\ufd3f\\ufe10-\\ufe19\\ufe30-\\ufe52\\ufe54-\\ufe61\\ufe63\\ufe68\\ufe6a-\\ufe6b\\uff01-\\uff03\\uff05-\\uff0a\\uff0c-\\uff0f\\uff1a-\\uff1b\\uff1f-\\uff20\\uff3b-\\uff3d\\uff3f\\uff5b\\uff5d\\uff5f-\\uff65]|\\ud800[\\udd00-\\udd02\\udf9f\\udfd0]|\\ud801[\\udd6f]|\\ud802[\\udc57\\udd1f\\udd3f\\ude50-\\ude58\\ude7f\\udef0-\\udef6\\udf39-\\udf3f\\udf99-\\udf9c]|\\ud803[\\udf55-\\udf59]|\\ud804[\\udc47-\\udc4d\\udcbb-\\udcbc\\udcbe-\\udcc1\\udd40-\\udd43\\udd74-\\udd75\\uddc5-\\uddc8\\uddcd\\udddb\\udddd-\\udddf\\ude38-\\ude3d\\udea9]|\\ud805[\\udc4b-\\udc4f\\udc5b\\udc5d\\udcc6\\uddc1-\\uddd7\\ude41-\\ude43\\ude60-\\ude6c\\udf3c-\\udf3e]|\\ud806[\\udc3b\\udde2\\ude3f-\\ude46\\ude9a-\\ude9c\\ude9e-\\udea2]|\\ud807[\\udc41-\\udc45\\udc70-\\udc71\\udef7-\\udef8\\udfff]|\\ud809[\\udc70-\\udc74]|\\ud81a[\\ude6e-\\ude6f\\udef5\\udf37-\\udf3b\\udf44]|\\ud81b[\\ude97-\\ude9a\\udfe2]|\\ud82f[\\udc9f]|\\ud836[\\ude87-\\ude8b]|\\ud83a[\\udd5e-\\udd5f]"
        };
      }
    });
    var require_utils102 = __commonJS22({
      "src/language-markdown/utils.js"(exports2, module22) {
        "use strict";
        var {
          getLast
        } = require_util();
        var {
          locStart,
          locEnd
        } = require_loc5();
        var {
          cjkPattern,
          kPattern,
          punctuationPattern
        } = require_constants_evaluate();
        var INLINE_NODE_TYPES = ["liquidNode", "inlineCode", "emphasis", "esComment", "strong", "delete", "wikiLink", "link", "linkReference", "image", "imageReference", "footnote", "footnoteReference", "sentence", "whitespace", "word", "break", "inlineMath"];
        var INLINE_NODE_WRAPPER_TYPES = [...INLINE_NODE_TYPES, "tableCell", "paragraph", "heading"];
        var kRegex = new RegExp(kPattern);
        var punctuationRegex = new RegExp(punctuationPattern);
        function splitText(text, options) {
          const KIND_NON_CJK = "non-cjk";
          const KIND_CJ_LETTER = "cj-letter";
          const KIND_K_LETTER = "k-letter";
          const KIND_CJK_PUNCTUATION = "cjk-punctuation";
          const nodes = [];
          const tokens = (options.proseWrap === "preserve" ? text : text.replace(new RegExp(`(${cjkPattern})
(${cjkPattern})`, "g"), "$1$2")).split(/([\t\n ]+)/);
          for (const [index, token] of tokens.entries()) {
            if (index % 2 === 1) {
              nodes.push({
                type: "whitespace",
                value: /\n/.test(token) ? "\n" : " "
              });
              continue;
            }
            if ((index === 0 || index === tokens.length - 1) && token === "") {
              continue;
            }
            const innerTokens = token.split(new RegExp(`(${cjkPattern})`));
            for (const [innerIndex, innerToken] of innerTokens.entries()) {
              if ((innerIndex === 0 || innerIndex === innerTokens.length - 1) && innerToken === "") {
                continue;
              }
              if (innerIndex % 2 === 0) {
                if (innerToken !== "") {
                  appendNode({
                    type: "word",
                    value: innerToken,
                    kind: KIND_NON_CJK,
                    hasLeadingPunctuation: punctuationRegex.test(innerToken[0]),
                    hasTrailingPunctuation: punctuationRegex.test(getLast(innerToken))
                  });
                }
                continue;
              }
              appendNode(punctuationRegex.test(innerToken) ? {
                type: "word",
                value: innerToken,
                kind: KIND_CJK_PUNCTUATION,
                hasLeadingPunctuation: true,
                hasTrailingPunctuation: true
              } : {
                type: "word",
                value: innerToken,
                kind: kRegex.test(innerToken) ? KIND_K_LETTER : KIND_CJ_LETTER,
                hasLeadingPunctuation: false,
                hasTrailingPunctuation: false
              });
            }
          }
          return nodes;
          function appendNode(node) {
            const lastNode = getLast(nodes);
            if (lastNode && lastNode.type === "word") {
              if (lastNode.kind === KIND_NON_CJK && node.kind === KIND_CJ_LETTER && !lastNode.hasTrailingPunctuation || lastNode.kind === KIND_CJ_LETTER && node.kind === KIND_NON_CJK && !node.hasLeadingPunctuation) {
                nodes.push({
                  type: "whitespace",
                  value: " "
                });
              } else if (!isBetween(KIND_NON_CJK, KIND_CJK_PUNCTUATION) && ![lastNode.value, node.value].some((value) => /\u3000/.test(value))) {
                nodes.push({
                  type: "whitespace",
                  value: ""
                });
              }
            }
            nodes.push(node);
            function isBetween(kind1, kind2) {
              return lastNode.kind === kind1 && node.kind === kind2 || lastNode.kind === kind2 && node.kind === kind1;
            }
          }
        }
        function getOrderedListItemInfo(orderListItem, originalText) {
          const [, numberText, marker, leadingSpaces] = originalText.slice(orderListItem.position.start.offset, orderListItem.position.end.offset).match(/^\s*(\d+)(\.|\))(\s*)/);
          return {
            numberText,
            marker,
            leadingSpaces
          };
        }
        function hasGitDiffFriendlyOrderedList(node, options) {
          if (!node.ordered) {
            return false;
          }
          if (node.children.length < 2) {
            return false;
          }
          const firstNumber = Number(getOrderedListItemInfo(node.children[0], options.originalText).numberText);
          const secondNumber = Number(getOrderedListItemInfo(node.children[1], options.originalText).numberText);
          if (firstNumber === 0 && node.children.length > 2) {
            const thirdNumber = Number(getOrderedListItemInfo(node.children[2], options.originalText).numberText);
            return secondNumber === 1 && thirdNumber === 1;
          }
          return secondNumber === 1;
        }
        function getFencedCodeBlockValue(node, originalText) {
          const {
            value
          } = node;
          if (node.position.end.offset === originalText.length && value.endsWith("\n") && originalText.endsWith("\n")) {
            return value.slice(0, -1);
          }
          return value;
        }
        function mapAst(ast, handler) {
          return function preorder(node, index, parentStack) {
            const newNode = Object.assign({}, handler(node, index, parentStack));
            if (newNode.children) {
              newNode.children = newNode.children.map((child, index2) => preorder(child, index2, [newNode, ...parentStack]));
            }
            return newNode;
          }(ast, null, []);
        }
        function isAutolink(node) {
          if ((node === null || node === void 0 ? void 0 : node.type) !== "link" || node.children.length !== 1) {
            return false;
          }
          const [child] = node.children;
          return locStart(node) === locStart(child) && locEnd(node) === locEnd(child);
        }
        module22.exports = {
          mapAst,
          splitText,
          punctuationPattern,
          getFencedCodeBlockValue,
          getOrderedListItemInfo,
          hasGitDiffFriendlyOrderedList,
          INLINE_NODE_TYPES,
          INLINE_NODE_WRAPPER_TYPES,
          isAutolink
        };
      }
    });
    var require_embed3 = __commonJS22({
      "src/language-markdown/embed.js"(exports2, module22) {
        "use strict";
        var {
          inferParserByLanguage,
          getMaxContinuousCount
        } = require_util();
        var {
          builders: {
            hardline,
            markAsRoot
          },
          utils: {
            replaceEndOfLine
          }
        } = require_doc();
        var printFrontMatter = require_print();
        var {
          getFencedCodeBlockValue
        } = require_utils102();
        function embed(path4, print, textToDoc, options) {
          const node = path4.getValue();
          if (node.type === "code" && node.lang !== null) {
            const parser = inferParserByLanguage(node.lang, options);
            if (parser) {
              const styleUnit = options.__inJsTemplate ? "~" : "`";
              const style = styleUnit.repeat(Math.max(3, getMaxContinuousCount(node.value, styleUnit) + 1));
              const newOptions = {
                parser
              };
              if (node.lang === "tsx") {
                newOptions.filepath = "dummy.tsx";
              }
              const doc2 = textToDoc(getFencedCodeBlockValue(node, options.originalText), newOptions, {
                stripTrailingHardline: true
              });
              return markAsRoot([style, node.lang, node.meta ? " " + node.meta : "", hardline, replaceEndOfLine(doc2), hardline, style]);
            }
          }
          switch (node.type) {
            case "front-matter":
              return printFrontMatter(node, textToDoc);
            case "importExport":
              return [textToDoc(node.value, {
                parser: "babel"
              }, {
                stripTrailingHardline: true
              }), hardline];
            case "jsx":
              return textToDoc(`<$>${node.value}</$>`, {
                parser: "__js_expression",
                rootMarker: "mdx"
              }, {
                stripTrailingHardline: true
              });
          }
          return null;
        }
        module22.exports = embed;
      }
    });
    var require_pragma4 = __commonJS22({
      "src/language-markdown/pragma.js"(exports2, module22) {
        "use strict";
        var parseFrontMatter = require_parse42();
        var pragmas = ["format", "prettier"];
        function startWithPragma(text) {
          const pragma = `@(${pragmas.join("|")})`;
          const regex = new RegExp([`<!--\\s*${pragma}\\s*-->`, `{\\s*\\/\\*\\s*${pragma}\\s*\\*\\/\\s*}`, `<!--.*\r?
[\\s\\S]*(^|
)[^\\S
]*${pragma}[^\\S
]*($|
)[\\s\\S]*
.*-->`].join("|"), "m");
          const matched = text.match(regex);
          return (matched === null || matched === void 0 ? void 0 : matched.index) === 0;
        }
        module22.exports = {
          startWithPragma,
          hasPragma: (text) => startWithPragma(parseFrontMatter(text).content.trimStart()),
          insertPragma: (text) => {
            const extracted = parseFrontMatter(text);
            const pragma = `<!-- @${pragmas[0]} -->`;
            return extracted.frontMatter ? `${extracted.frontMatter.raw}

${pragma}

${extracted.content}` : `${pragma}

${extracted.content}`;
          }
        };
      }
    });
    var require_print_preprocess2 = __commonJS22({
      "src/language-markdown/print-preprocess.js"(exports2, module22) {
        "use strict";
        var getLast = require_get_last();
        var {
          getOrderedListItemInfo,
          mapAst,
          splitText
        } = require_utils102();
        var isSingleCharRegex = /^.$/su;
        function preprocess(ast, options) {
          ast = restoreUnescapedCharacter(ast, options);
          ast = mergeContinuousTexts(ast);
          ast = transformInlineCode(ast);
          ast = transformIndentedCodeblockAndMarkItsParentList(ast, options);
          ast = markAlignedList(ast, options);
          ast = splitTextIntoSentences(ast, options);
          ast = transformImportExport(ast);
          ast = mergeContinuousImportExport(ast);
          return ast;
        }
        function transformImportExport(ast) {
          return mapAst(ast, (node) => {
            if (node.type !== "import" && node.type !== "export") {
              return node;
            }
            return Object.assign(Object.assign({}, node), {}, {
              type: "importExport"
            });
          });
        }
        function transformInlineCode(ast) {
          return mapAst(ast, (node) => {
            if (node.type !== "inlineCode") {
              return node;
            }
            return Object.assign(Object.assign({}, node), {}, {
              value: node.value.replace(/\s+/g, " ")
            });
          });
        }
        function restoreUnescapedCharacter(ast, options) {
          return mapAst(ast, (node) => node.type !== "text" || node.value === "*" || node.value === "_" || !isSingleCharRegex.test(node.value) || node.position.end.offset - node.position.start.offset === node.value.length ? node : Object.assign(Object.assign({}, node), {}, {
            value: options.originalText.slice(node.position.start.offset, node.position.end.offset)
          }));
        }
        function mergeContinuousImportExport(ast) {
          return mergeChildren(ast, (prevNode, node) => prevNode.type === "importExport" && node.type === "importExport", (prevNode, node) => ({
            type: "importExport",
            value: prevNode.value + "\n\n" + node.value,
            position: {
              start: prevNode.position.start,
              end: node.position.end
            }
          }));
        }
        function mergeChildren(ast, shouldMerge, mergeNode) {
          return mapAst(ast, (node) => {
            if (!node.children) {
              return node;
            }
            const children = node.children.reduce((current, child) => {
              const lastChild = getLast(current);
              if (lastChild && shouldMerge(lastChild, child)) {
                current.splice(-1, 1, mergeNode(lastChild, child));
              } else {
                current.push(child);
              }
              return current;
            }, []);
            return Object.assign(Object.assign({}, node), {}, {
              children
            });
          });
        }
        function mergeContinuousTexts(ast) {
          return mergeChildren(ast, (prevNode, node) => prevNode.type === "text" && node.type === "text", (prevNode, node) => ({
            type: "text",
            value: prevNode.value + node.value,
            position: {
              start: prevNode.position.start,
              end: node.position.end
            }
          }));
        }
        function splitTextIntoSentences(ast, options) {
          return mapAst(ast, (node, index, [parentNode]) => {
            if (node.type !== "text") {
              return node;
            }
            let {
              value
            } = node;
            if (parentNode.type === "paragraph") {
              if (index === 0) {
                value = value.trimStart();
              }
              if (index === parentNode.children.length - 1) {
                value = value.trimEnd();
              }
            }
            return {
              type: "sentence",
              position: node.position,
              children: splitText(value, options)
            };
          });
        }
        function transformIndentedCodeblockAndMarkItsParentList(ast, options) {
          return mapAst(ast, (node, index, parentStack) => {
            if (node.type === "code") {
              const isIndented = /^\n?(?: {4,}|\t)/.test(options.originalText.slice(node.position.start.offset, node.position.end.offset));
              node.isIndented = isIndented;
              if (isIndented) {
                for (let i2 = 0; i2 < parentStack.length; i2++) {
                  const parent = parentStack[i2];
                  if (parent.hasIndentedCodeblock) {
                    break;
                  }
                  if (parent.type === "list") {
                    parent.hasIndentedCodeblock = true;
                  }
                }
              }
            }
            return node;
          });
        }
        function markAlignedList(ast, options) {
          return mapAst(ast, (node, index, parentStack) => {
            if (node.type === "list" && node.children.length > 0) {
              for (let i2 = 0; i2 < parentStack.length; i2++) {
                const parent = parentStack[i2];
                if (parent.type === "list" && !parent.isAligned) {
                  node.isAligned = false;
                  return node;
                }
              }
              node.isAligned = isAligned(node);
            }
            return node;
          });
          function getListItemStart(listItem) {
            return listItem.children.length === 0 ? -1 : listItem.children[0].position.start.column - 1;
          }
          function isAligned(list) {
            if (!list.ordered) {
              return true;
            }
            const [firstItem, secondItem] = list.children;
            const firstInfo = getOrderedListItemInfo(firstItem, options.originalText);
            if (firstInfo.leadingSpaces.length > 1) {
              return true;
            }
            const firstStart = getListItemStart(firstItem);
            if (firstStart === -1) {
              return false;
            }
            if (list.children.length === 1) {
              return firstStart % options.tabWidth === 0;
            }
            const secondStart = getListItemStart(secondItem);
            if (firstStart !== secondStart) {
              return false;
            }
            if (firstStart % options.tabWidth === 0) {
              return true;
            }
            const secondInfo = getOrderedListItemInfo(secondItem, options.originalText);
            return secondInfo.leadingSpaces.length > 1;
          }
        }
        module22.exports = preprocess;
      }
    });
    var require_clean4 = __commonJS22({
      "src/language-markdown/clean.js"(exports2, module22) {
        "use strict";
        var {
          isFrontMatterNode
        } = require_util();
        var {
          startWithPragma
        } = require_pragma4();
        var ignoredProperties = /* @__PURE__ */ new Set(["position", "raw"]);
        function clean(ast, newObj, parent) {
          if (ast.type === "front-matter" || ast.type === "code" || ast.type === "yaml" || ast.type === "import" || ast.type === "export" || ast.type === "jsx") {
            delete newObj.value;
          }
          if (ast.type === "list") {
            delete newObj.isAligned;
          }
          if (ast.type === "list" || ast.type === "listItem") {
            delete newObj.spread;
            delete newObj.loose;
          }
          if (ast.type === "text") {
            return null;
          }
          if (ast.type === "inlineCode") {
            newObj.value = ast.value.replace(/[\t\n ]+/g, " ");
          }
          if (ast.type === "wikiLink") {
            newObj.value = ast.value.trim().replace(/[\t\n]+/g, " ");
          }
          if (ast.type === "definition" || ast.type === "linkReference") {
            newObj.label = ast.label.trim().replace(/[\t\n ]+/g, " ").toLowerCase();
          }
          if ((ast.type === "definition" || ast.type === "link" || ast.type === "image") && ast.title) {
            newObj.title = ast.title.replace(/\\(["')])/g, "$1");
          }
          if (parent && parent.type === "root" && parent.children.length > 0 && (parent.children[0] === ast || isFrontMatterNode(parent.children[0]) && parent.children[1] === ast) && ast.type === "html" && startWithPragma(ast.value)) {
            return null;
          }
        }
        clean.ignoredProperties = ignoredProperties;
        module22.exports = clean;
      }
    });
    var require_printer_markdown = __commonJS22({
      "src/language-markdown/printer-markdown.js"(exports2, module22) {
        "use strict";
        var {
          getLast,
          getMinNotPresentContinuousCount,
          getMaxContinuousCount,
          getStringWidth,
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            breakParent,
            join,
            line,
            literalline,
            markAsRoot,
            hardline,
            softline,
            ifBreak,
            fill,
            align,
            indent,
            group,
            hardlineWithoutBreakParent
          },
          utils: {
            normalizeDoc,
            replaceTextEndOfLine
          },
          printer: {
            printDocToString
          }
        } = require_doc();
        var embed = require_embed3();
        var {
          insertPragma
        } = require_pragma4();
        var {
          locStart,
          locEnd
        } = require_loc5();
        var preprocess = require_print_preprocess2();
        var clean = require_clean4();
        var {
          getFencedCodeBlockValue,
          hasGitDiffFriendlyOrderedList,
          splitText,
          punctuationPattern,
          INLINE_NODE_TYPES,
          INLINE_NODE_WRAPPER_TYPES,
          isAutolink
        } = require_utils102();
        var TRAILING_HARDLINE_NODES = /* @__PURE__ */ new Set(["importExport"]);
        var SINGLE_LINE_NODE_TYPES = ["heading", "tableCell", "link", "wikiLink"];
        var SIBLING_NODE_TYPES = /* @__PURE__ */ new Set(["listItem", "definition", "footnoteDefinition"]);
        function genericPrint(path4, options, print) {
          const node = path4.getValue();
          if (shouldRemainTheSameContent(path4)) {
            return splitText(options.originalText.slice(node.position.start.offset, node.position.end.offset), options).map((node2) => node2.type === "word" ? node2.value : node2.value === "" ? "" : printLine(path4, node2.value, options));
          }
          switch (node.type) {
            case "front-matter":
              return options.originalText.slice(node.position.start.offset, node.position.end.offset);
            case "root":
              if (node.children.length === 0) {
                return "";
              }
              return [normalizeDoc(printRoot(path4, options, print)), !TRAILING_HARDLINE_NODES.has(getLastDescendantNode(node).type) ? hardline : ""];
            case "paragraph":
              return printChildren(path4, options, print, {
                postprocessor: fill
              });
            case "sentence":
              return printChildren(path4, options, print);
            case "word": {
              let escapedValue = node.value.replace(/\*/g, "\\$&").replace(new RegExp([`(^|${punctuationPattern})(_+)`, `(_+)(${punctuationPattern}|$)`].join("|"), "g"), (_, text1, underscore1, underscore2, text2) => (underscore1 ? `${text1}${underscore1}` : `${underscore2}${text2}`).replace(/_/g, "\\_"));
              const isFirstSentence = (node2, name, index) => node2.type === "sentence" && index === 0;
              const isLastChildAutolink = (node2, name, index) => isAutolink(node2.children[index - 1]);
              if (escapedValue !== node.value && (path4.match(void 0, isFirstSentence, isLastChildAutolink) || path4.match(void 0, isFirstSentence, (node2, name, index) => node2.type === "emphasis" && index === 0, isLastChildAutolink))) {
                escapedValue = escapedValue.replace(/^(\\?[*_])+/, (prefix2) => prefix2.replace(/\\/g, ""));
              }
              return escapedValue;
            }
            case "whitespace": {
              const parentNode = path4.getParentNode();
              const index = parentNode.children.indexOf(node);
              const nextNode = parentNode.children[index + 1];
              const proseWrap = nextNode && /^>|^(?:[*+-]|#{1,6}|\d+[).])$/.test(nextNode.value) ? "never" : options.proseWrap;
              return printLine(path4, node.value, {
                proseWrap
              });
            }
            case "emphasis": {
              let style;
              if (isAutolink(node.children[0])) {
                style = options.originalText[node.position.start.offset];
              } else {
                const parentNode = path4.getParentNode();
                const index = parentNode.children.indexOf(node);
                const prevNode = parentNode.children[index - 1];
                const nextNode = parentNode.children[index + 1];
                const hasPrevOrNextWord = prevNode && prevNode.type === "sentence" && prevNode.children.length > 0 && getLast(prevNode.children).type === "word" && !getLast(prevNode.children).hasTrailingPunctuation || nextNode && nextNode.type === "sentence" && nextNode.children.length > 0 && nextNode.children[0].type === "word" && !nextNode.children[0].hasLeadingPunctuation;
                style = hasPrevOrNextWord || getAncestorNode(path4, "emphasis") ? "*" : "_";
              }
              return [style, printChildren(path4, options, print), style];
            }
            case "strong":
              return ["**", printChildren(path4, options, print), "**"];
            case "delete":
              return ["~~", printChildren(path4, options, print), "~~"];
            case "inlineCode": {
              const backtickCount = getMinNotPresentContinuousCount(node.value, "`");
              const style = "`".repeat(backtickCount || 1);
              const gap = backtickCount && !/^\s/.test(node.value) ? " " : "";
              return [style, gap, node.value, gap, style];
            }
            case "wikiLink": {
              let contents = "";
              if (options.proseWrap === "preserve") {
                contents = node.value;
              } else {
                contents = node.value.replace(/[\t\n]+/g, " ");
              }
              return ["[[", contents, "]]"];
            }
            case "link":
              switch (options.originalText[node.position.start.offset]) {
                case "<": {
                  const mailto = "mailto:";
                  const url = node.url.startsWith(mailto) && options.originalText.slice(node.position.start.offset + 1, node.position.start.offset + 1 + mailto.length) !== mailto ? node.url.slice(mailto.length) : node.url;
                  return ["<", url, ">"];
                }
                case "[":
                  return ["[", printChildren(path4, options, print), "](", printUrl(node.url, ")"), printTitle(node.title, options), ")"];
                default:
                  return options.originalText.slice(node.position.start.offset, node.position.end.offset);
              }
            case "image":
              return ["![", node.alt || "", "](", printUrl(node.url, ")"), printTitle(node.title, options), ")"];
            case "blockquote":
              return ["> ", align("> ", printChildren(path4, options, print))];
            case "heading":
              return ["#".repeat(node.depth) + " ", printChildren(path4, options, print)];
            case "code": {
              if (node.isIndented) {
                const alignment = " ".repeat(4);
                return align(alignment, [alignment, ...replaceTextEndOfLine(node.value, hardline)]);
              }
              const styleUnit = options.__inJsTemplate ? "~" : "`";
              const style = styleUnit.repeat(Math.max(3, getMaxContinuousCount(node.value, styleUnit) + 1));
              return [style, node.lang || "", node.meta ? " " + node.meta : "", hardline, ...replaceTextEndOfLine(getFencedCodeBlockValue(node, options.originalText), hardline), hardline, style];
            }
            case "html": {
              const parentNode = path4.getParentNode();
              const value = parentNode.type === "root" && getLast(parentNode.children) === node ? node.value.trimEnd() : node.value;
              const isHtmlComment = /^<!--.*-->$/s.test(value);
              return replaceTextEndOfLine(value, isHtmlComment ? hardline : markAsRoot(literalline));
            }
            case "list": {
              const nthSiblingIndex = getNthListSiblingIndex(node, path4.getParentNode());
              const isGitDiffFriendlyOrderedList = hasGitDiffFriendlyOrderedList(node, options);
              return printChildren(path4, options, print, {
                processor: (childPath, index) => {
                  const prefix2 = getPrefix();
                  const childNode = childPath.getValue();
                  if (childNode.children.length === 2 && childNode.children[1].type === "html" && childNode.children[0].position.start.column !== childNode.children[1].position.start.column) {
                    return [prefix2, printListItem(childPath, options, print, prefix2)];
                  }
                  return [prefix2, align(" ".repeat(prefix2.length), printListItem(childPath, options, print, prefix2))];
                  function getPrefix() {
                    const rawPrefix = node.ordered ? (index === 0 ? node.start : isGitDiffFriendlyOrderedList ? 1 : node.start + index) + (nthSiblingIndex % 2 === 0 ? ". " : ") ") : nthSiblingIndex % 2 === 0 ? "- " : "* ";
                    return node.isAligned || node.hasIndentedCodeblock ? alignListPrefix(rawPrefix, options) : rawPrefix;
                  }
                }
              });
            }
            case "thematicBreak": {
              const counter = getAncestorCounter(path4, "list");
              if (counter === -1) {
                return "---";
              }
              const nthSiblingIndex = getNthListSiblingIndex(path4.getParentNode(counter), path4.getParentNode(counter + 1));
              return nthSiblingIndex % 2 === 0 ? "***" : "---";
            }
            case "linkReference":
              return ["[", printChildren(path4, options, print), "]", node.referenceType === "full" ? ["[", node.identifier, "]"] : node.referenceType === "collapsed" ? "[]" : ""];
            case "imageReference":
              switch (node.referenceType) {
                case "full":
                  return ["![", node.alt || "", "][", node.identifier, "]"];
                default:
                  return ["![", node.alt, "]", node.referenceType === "collapsed" ? "[]" : ""];
              }
            case "definition": {
              const lineOrSpace = options.proseWrap === "always" ? line : " ";
              return group(["[", node.identifier, "]:", indent([lineOrSpace, printUrl(node.url), node.title === null ? "" : [lineOrSpace, printTitle(node.title, options, false)]])]);
            }
            case "footnote":
              return ["[^", printChildren(path4, options, print), "]"];
            case "footnoteReference":
              return ["[^", node.identifier, "]"];
            case "footnoteDefinition": {
              const nextNode = path4.getParentNode().children[path4.getName() + 1];
              const shouldInlineFootnote = node.children.length === 1 && node.children[0].type === "paragraph" && (options.proseWrap === "never" || options.proseWrap === "preserve" && node.children[0].position.start.line === node.children[0].position.end.line);
              return ["[^", node.identifier, "]: ", shouldInlineFootnote ? printChildren(path4, options, print) : group([align(" ".repeat(4), printChildren(path4, options, print, {
                processor: (childPath, index) => index === 0 ? group([softline, print()]) : print()
              })), nextNode && nextNode.type === "footnoteDefinition" ? softline : ""])];
            }
            case "table":
              return printTable(path4, options, print);
            case "tableCell":
              return printChildren(path4, options, print);
            case "break":
              return /\s/.test(options.originalText[node.position.start.offset]) ? ["  ", markAsRoot(literalline)] : ["\\", hardline];
            case "liquidNode":
              return replaceTextEndOfLine(node.value, hardline);
            case "importExport":
              return [node.value, hardline];
            case "esComment":
              return ["{/* ", node.value, " */}"];
            case "jsx":
              return node.value;
            case "math":
              return ["$$", hardline, node.value ? [...replaceTextEndOfLine(node.value, hardline), hardline] : "", "$$"];
            case "inlineMath": {
              return options.originalText.slice(locStart(node), locEnd(node));
            }
            case "tableRow":
            case "listItem":
            default:
              throw new Error(`Unknown markdown type ${JSON.stringify(node.type)}`);
          }
        }
        function printListItem(path4, options, print, listPrefix) {
          const node = path4.getValue();
          const prefix2 = node.checked === null ? "" : node.checked ? "[x] " : "[ ] ";
          return [prefix2, printChildren(path4, options, print, {
            processor: (childPath, index) => {
              if (index === 0 && childPath.getValue().type !== "list") {
                return align(" ".repeat(prefix2.length), print());
              }
              const alignment = " ".repeat(clamp(options.tabWidth - listPrefix.length, 0, 3));
              return [alignment, align(alignment, print())];
            }
          })];
        }
        function alignListPrefix(prefix2, options) {
          const additionalSpaces = getAdditionalSpaces();
          return prefix2 + " ".repeat(additionalSpaces >= 4 ? 0 : additionalSpaces);
          function getAdditionalSpaces() {
            const restSpaces = prefix2.length % options.tabWidth;
            return restSpaces === 0 ? 0 : options.tabWidth - restSpaces;
          }
        }
        function getNthListSiblingIndex(node, parentNode) {
          return getNthSiblingIndex(node, parentNode, (siblingNode) => siblingNode.ordered === node.ordered);
        }
        function getNthSiblingIndex(node, parentNode, condition) {
          let index = -1;
          for (const childNode of parentNode.children) {
            if (childNode.type === node.type && condition(childNode)) {
              index++;
            } else {
              index = -1;
            }
            if (childNode === node) {
              return index;
            }
          }
        }
        function getAncestorCounter(path4, typeOrTypes) {
          const types3 = Array.isArray(typeOrTypes) ? typeOrTypes : [typeOrTypes];
          let counter = -1;
          let ancestorNode;
          while (ancestorNode = path4.getParentNode(++counter)) {
            if (types3.includes(ancestorNode.type)) {
              return counter;
            }
          }
          return -1;
        }
        function getAncestorNode(path4, typeOrTypes) {
          const counter = getAncestorCounter(path4, typeOrTypes);
          return counter === -1 ? null : path4.getParentNode(counter);
        }
        function printLine(path4, value, options) {
          if (options.proseWrap === "preserve" && value === "\n") {
            return hardline;
          }
          const isBreakable = options.proseWrap === "always" && !getAncestorNode(path4, SINGLE_LINE_NODE_TYPES);
          return value !== "" ? isBreakable ? line : " " : isBreakable ? softline : "";
        }
        function printTable(path4, options, print) {
          const node = path4.getValue();
          const columnMaxWidths = [];
          const contents = path4.map((rowPath) => rowPath.map((cellPath, columnIndex) => {
            const text = printDocToString(print(), options).formatted;
            const width = getStringWidth(text);
            columnMaxWidths[columnIndex] = Math.max(columnMaxWidths[columnIndex] || 3, width);
            return {
              text,
              width
            };
          }, "children"), "children");
          const alignedTable = printTableContents(false);
          if (options.proseWrap !== "never") {
            return [breakParent, alignedTable];
          }
          const compactTable = printTableContents(true);
          return [breakParent, group(ifBreak(compactTable, alignedTable))];
          function printTableContents(isCompact) {
            const parts = [printRow(contents[0], isCompact), printAlign(isCompact)];
            if (contents.length > 1) {
              parts.push(join(hardlineWithoutBreakParent, contents.slice(1).map((rowContents) => printRow(rowContents, isCompact))));
            }
            return join(hardlineWithoutBreakParent, parts);
          }
          function printAlign(isCompact) {
            const align2 = columnMaxWidths.map((width, index) => {
              const align3 = node.align[index];
              const first = align3 === "center" || align3 === "left" ? ":" : "-";
              const last = align3 === "center" || align3 === "right" ? ":" : "-";
              const middle = isCompact ? "-" : "-".repeat(width - 2);
              return `${first}${middle}${last}`;
            });
            return `| ${align2.join(" | ")} |`;
          }
          function printRow(rowContents, isCompact) {
            const columns = rowContents.map(({
              text,
              width
            }, columnIndex) => {
              if (isCompact) {
                return text;
              }
              const spaces = columnMaxWidths[columnIndex] - width;
              const align2 = node.align[columnIndex];
              let before = 0;
              if (align2 === "right") {
                before = spaces;
              } else if (align2 === "center") {
                before = Math.floor(spaces / 2);
              }
              const after = spaces - before;
              return `${" ".repeat(before)}${text}${" ".repeat(after)}`;
            });
            return `| ${columns.join(" | ")} |`;
          }
        }
        function printRoot(path4, options, print) {
          const ignoreRanges = [];
          let ignoreStart = null;
          const {
            children
          } = path4.getValue();
          for (const [index, childNode] of children.entries()) {
            switch (isPrettierIgnore(childNode)) {
              case "start":
                if (ignoreStart === null) {
                  ignoreStart = {
                    index,
                    offset: childNode.position.end.offset
                  };
                }
                break;
              case "end":
                if (ignoreStart !== null) {
                  ignoreRanges.push({
                    start: ignoreStart,
                    end: {
                      index,
                      offset: childNode.position.start.offset
                    }
                  });
                  ignoreStart = null;
                }
                break;
              default:
                break;
            }
          }
          return printChildren(path4, options, print, {
            processor: (childPath, index) => {
              if (ignoreRanges.length > 0) {
                const ignoreRange = ignoreRanges[0];
                if (index === ignoreRange.start.index) {
                  return [children[ignoreRange.start.index].value, options.originalText.slice(ignoreRange.start.offset, ignoreRange.end.offset), children[ignoreRange.end.index].value];
                }
                if (ignoreRange.start.index < index && index < ignoreRange.end.index) {
                  return false;
                }
                if (index === ignoreRange.end.index) {
                  ignoreRanges.shift();
                  return false;
                }
              }
              return print();
            }
          });
        }
        function printChildren(path4, options, print, events = {}) {
          const {
            postprocessor
          } = events;
          const processor = events.processor || (() => print());
          const node = path4.getValue();
          const parts = [];
          let lastChildNode;
          path4.each((childPath, index) => {
            const childNode = childPath.getValue();
            const result = processor(childPath, index);
            if (result !== false) {
              const data = {
                parts,
                prevNode: lastChildNode,
                parentNode: node,
                options
              };
              if (shouldPrePrintHardline(childNode, data)) {
                parts.push(hardline);
                if (lastChildNode && TRAILING_HARDLINE_NODES.has(lastChildNode.type)) {
                  if (shouldPrePrintTripleHardline(childNode, data)) {
                    parts.push(hardline);
                  }
                } else {
                  if (shouldPrePrintDoubleHardline(childNode, data) || shouldPrePrintTripleHardline(childNode, data)) {
                    parts.push(hardline);
                  }
                  if (shouldPrePrintTripleHardline(childNode, data)) {
                    parts.push(hardline);
                  }
                }
              }
              parts.push(result);
              lastChildNode = childNode;
            }
          }, "children");
          return postprocessor ? postprocessor(parts) : parts;
        }
        function getLastDescendantNode(node) {
          let current = node;
          while (isNonEmptyArray(current.children)) {
            current = getLast(current.children);
          }
          return current;
        }
        function isPrettierIgnore(node) {
          let match;
          if (node.type === "html") {
            match = node.value.match(/^<!--\s*prettier-ignore(?:-(start|end))?\s*-->$/);
          } else {
            let comment;
            if (node.type === "esComment") {
              comment = node;
            } else if (node.type === "paragraph" && node.children.length === 1 && node.children[0].type === "esComment") {
              comment = node.children[0];
            }
            if (comment) {
              match = comment.value.match(/^prettier-ignore(?:-(start|end))?$/);
            }
          }
          return match ? match[1] || "next" : false;
        }
        function shouldPrePrintHardline(node, data) {
          const isFirstNode = data.parts.length === 0;
          const isInlineNode = INLINE_NODE_TYPES.includes(node.type);
          const isInlineHTML = node.type === "html" && INLINE_NODE_WRAPPER_TYPES.includes(data.parentNode.type);
          return !isFirstNode && !isInlineNode && !isInlineHTML;
        }
        function shouldPrePrintDoubleHardline(node, data) {
          var _data$prevNode, _data$prevNode2, _data$prevNode3;
          const isSequence = (data.prevNode && data.prevNode.type) === node.type;
          const isSiblingNode = isSequence && SIBLING_NODE_TYPES.has(node.type);
          const isInTightListItem = data.parentNode.type === "listItem" && !data.parentNode.loose;
          const isPrevNodeLooseListItem = ((_data$prevNode = data.prevNode) === null || _data$prevNode === void 0 ? void 0 : _data$prevNode.type) === "listItem" && data.prevNode.loose;
          const isPrevNodePrettierIgnore = isPrettierIgnore(data.prevNode) === "next";
          const isBlockHtmlWithoutBlankLineBetweenPrevHtml = node.type === "html" && ((_data$prevNode2 = data.prevNode) === null || _data$prevNode2 === void 0 ? void 0 : _data$prevNode2.type) === "html" && data.prevNode.position.end.line + 1 === node.position.start.line;
          const isHtmlDirectAfterListItem = node.type === "html" && data.parentNode.type === "listItem" && ((_data$prevNode3 = data.prevNode) === null || _data$prevNode3 === void 0 ? void 0 : _data$prevNode3.type) === "paragraph" && data.prevNode.position.end.line + 1 === node.position.start.line;
          return isPrevNodeLooseListItem || !(isSiblingNode || isInTightListItem || isPrevNodePrettierIgnore || isBlockHtmlWithoutBlankLineBetweenPrevHtml || isHtmlDirectAfterListItem);
        }
        function shouldPrePrintTripleHardline(node, data) {
          const isPrevNodeList = data.prevNode && data.prevNode.type === "list";
          const isIndentedCode = node.type === "code" && node.isIndented;
          return isPrevNodeList && isIndentedCode;
        }
        function shouldRemainTheSameContent(path4) {
          const ancestorNode = getAncestorNode(path4, ["linkReference", "imageReference"]);
          return ancestorNode && (ancestorNode.type !== "linkReference" || ancestorNode.referenceType !== "full");
        }
        function printUrl(url, dangerousCharOrChars = []) {
          const dangerousChars = [" ", ...Array.isArray(dangerousCharOrChars) ? dangerousCharOrChars : [dangerousCharOrChars]];
          return new RegExp(dangerousChars.map((x2) => `\\${x2}`).join("|")).test(url) ? `<${url}>` : url;
        }
        function printTitle(title, options, printSpace = true) {
          if (!title) {
            return "";
          }
          if (printSpace) {
            return " " + printTitle(title, options, false);
          }
          title = title.replace(/\\(["')])/g, "$1");
          if (title.includes('"') && title.includes("'") && !title.includes(")")) {
            return `(${title})`;
          }
          const singleCount = title.split("'").length - 1;
          const doubleCount = title.split('"').length - 1;
          const quote = singleCount > doubleCount ? '"' : doubleCount > singleCount ? "'" : options.singleQuote ? "'" : '"';
          title = title.replace(/\\/, "\\\\");
          title = title.replace(new RegExp(`(${quote})`, "g"), "\\$1");
          return `${quote}${title}${quote}`;
        }
        function clamp(value, min, max) {
          return value < min ? min : value > max ? max : value;
        }
        function hasPrettierIgnore(path4) {
          const index = Number(path4.getName());
          if (index === 0) {
            return false;
          }
          const prevNode = path4.getParentNode().children[index - 1];
          return isPrettierIgnore(prevNode) === "next";
        }
        module22.exports = {
          preprocess,
          print: genericPrint,
          embed,
          massageAstNode: clean,
          hasPrettierIgnore,
          insertPragma
        };
      }
    });
    var require_options5 = __commonJS22({
      "src/language-markdown/options.js"(exports2, module22) {
        "use strict";
        var commonOptions = require_common_options();
        module22.exports = {
          proseWrap: commonOptions.proseWrap,
          singleQuote: commonOptions.singleQuote
        };
      }
    });
    var require_parsers5 = __commonJS22({
      "src/language-markdown/parsers.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          get remark() {
            return require_parser_markdown().parsers.remark;
          },
          get markdown() {
            return require_parser_markdown().parsers.remark;
          },
          get mdx() {
            return require_parser_markdown().parsers.mdx;
          }
        };
      }
    });
    var require_Markdown = __commonJS22({
      "node_modules/linguist-languages/data/Markdown.json"(exports2, module22) {
        module22.exports = {
          name: "Markdown",
          type: "prose",
          color: "#083fa1",
          aliases: ["pandoc"],
          aceMode: "markdown",
          codemirrorMode: "gfm",
          codemirrorMimeType: "text/x-gfm",
          wrap: true,
          extensions: [".md", ".livemd", ".markdown", ".mdown", ".mdwn", ".mdx", ".mkd", ".mkdn", ".mkdown", ".ronn", ".scd", ".workbook"],
          filenames: ["contents.lr"],
          tmScope: "source.gfm",
          languageId: 222
        };
      }
    });
    var require_language_markdown = __commonJS22({
      "src/language-markdown/index.js"(exports2, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_markdown();
        var options = require_options5();
        var parsers = require_parsers5();
        var languages = [createLanguage(require_Markdown(), (data) => ({
          since: "1.8.0",
          parsers: ["markdown"],
          vscodeLanguageIds: ["markdown"],
          filenames: [...data.filenames, "README"],
          extensions: data.extensions.filter((extension) => extension !== ".mdx")
        })), createLanguage(require_Markdown(), () => ({
          name: "MDX",
          since: "1.15.0",
          parsers: ["mdx"],
          vscodeLanguageIds: ["mdx"],
          filenames: [],
          extensions: [".mdx"]
        }))];
        var printers = {
          mdast: printer
        };
        module22.exports = {
          languages,
          options,
          printers,
          parsers
        };
      }
    });
    var require_clean5 = __commonJS22({
      "src/language-html/clean.js"(exports2, module22) {
        "use strict";
        var {
          isFrontMatterNode
        } = require_util();
        var ignoredProperties = /* @__PURE__ */ new Set(["sourceSpan", "startSourceSpan", "endSourceSpan", "nameSpan", "valueSpan"]);
        function clean(ast, newNode) {
          if (ast.type === "text" || ast.type === "comment") {
            return null;
          }
          if (isFrontMatterNode(ast) || ast.type === "yaml" || ast.type === "toml") {
            return null;
          }
          if (ast.type === "attribute") {
            delete newNode.value;
          }
          if (ast.type === "docType") {
            delete newNode.value;
          }
        }
        clean.ignoredProperties = ignoredProperties;
        module22.exports = clean;
      }
    });
    var require_constants_evaluate2 = __commonJS22({
      "src/language-html/constants.evaluate.js"(exports2, module22) {
        module22.exports = {
          CSS_DISPLAY_TAGS: {
            area: "none",
            base: "none",
            basefont: "none",
            datalist: "none",
            head: "none",
            link: "none",
            meta: "none",
            noembed: "none",
            noframes: "none",
            param: "block",
            rp: "none",
            script: "block",
            source: "block",
            style: "none",
            template: "inline",
            track: "block",
            title: "none",
            html: "block",
            body: "block",
            address: "block",
            blockquote: "block",
            center: "block",
            div: "block",
            figure: "block",
            figcaption: "block",
            footer: "block",
            form: "block",
            header: "block",
            hr: "block",
            legend: "block",
            listing: "block",
            main: "block",
            p: "block",
            plaintext: "block",
            pre: "block",
            xmp: "block",
            slot: "contents",
            ruby: "ruby",
            rt: "ruby-text",
            article: "block",
            aside: "block",
            h1: "block",
            h2: "block",
            h3: "block",
            h4: "block",
            h5: "block",
            h6: "block",
            hgroup: "block",
            nav: "block",
            section: "block",
            dir: "block",
            dd: "block",
            dl: "block",
            dt: "block",
            ol: "block",
            ul: "block",
            li: "list-item",
            table: "table",
            caption: "table-caption",
            colgroup: "table-column-group",
            col: "table-column",
            thead: "table-header-group",
            tbody: "table-row-group",
            tfoot: "table-footer-group",
            tr: "table-row",
            td: "table-cell",
            th: "table-cell",
            fieldset: "block",
            button: "inline-block",
            details: "block",
            summary: "block",
            dialog: "block",
            meter: "inline-block",
            progress: "inline-block",
            object: "inline-block",
            video: "inline-block",
            audio: "inline-block",
            select: "inline-block",
            option: "block",
            optgroup: "block"
          },
          CSS_DISPLAY_DEFAULT: "inline",
          CSS_WHITE_SPACE_TAGS: {
            listing: "pre",
            plaintext: "pre",
            pre: "pre",
            xmp: "pre",
            nobr: "nowrap",
            table: "initial",
            textarea: "pre-wrap"
          },
          CSS_WHITE_SPACE_DEFAULT: "normal"
        };
      }
    });
    var require_is_unknown_namespace = __commonJS22({
      "src/language-html/utils/is-unknown-namespace.js"(exports2, module22) {
        "use strict";
        function isUnknownNamespace(node) {
          return node.type === "element" && !node.hasExplicitNamespace && !["html", "svg"].includes(node.namespace);
        }
        module22.exports = isUnknownNamespace;
      }
    });
    var require_utils112 = __commonJS22({
      "src/language-html/utils/index.js"(exports2, module22) {
        "use strict";
        var {
          inferParserByLanguage,
          isFrontMatterNode
        } = require_util();
        var {
          builders: {
            line,
            hardline,
            join
          },
          utils: {
            getDocParts,
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          CSS_DISPLAY_TAGS,
          CSS_DISPLAY_DEFAULT,
          CSS_WHITE_SPACE_TAGS,
          CSS_WHITE_SPACE_DEFAULT
        } = require_constants_evaluate2();
        var isUnknownNamespace = require_is_unknown_namespace();
        var HTML_WHITESPACE = /* @__PURE__ */ new Set(["	", "\n", "\f", "\r", " "]);
        var htmlTrimStart = (string) => string.replace(/^[\t\n\f\r ]+/, "");
        var htmlTrimEnd = (string) => string.replace(/[\t\n\f\r ]+$/, "");
        var htmlTrim = (string) => htmlTrimStart(htmlTrimEnd(string));
        var htmlTrimLeadingBlankLines = (string) => string.replace(/^[\t\f\r ]*\n/g, "");
        var htmlTrimPreserveIndentation = (string) => htmlTrimLeadingBlankLines(htmlTrimEnd(string));
        var splitByHtmlWhitespace = (string) => string.split(/[\t\n\f\r ]+/);
        var getLeadingHtmlWhitespace = (string) => string.match(/^[\t\n\f\r ]*/)[0];
        var getLeadingAndTrailingHtmlWhitespace = (string) => {
          const [, leadingWhitespace, text, trailingWhitespace] = string.match(/^([\t\n\f\r ]*)(.*?)([\t\n\f\r ]*)$/s);
          return {
            leadingWhitespace,
            trailingWhitespace,
            text
          };
        };
        var hasHtmlWhitespace = (string) => /[\t\n\f\r ]/.test(string);
        function shouldPreserveContent(node, options) {
          if (node.type === "ieConditionalComment" && node.lastChild && !node.lastChild.isSelfClosing && !node.lastChild.endSourceSpan) {
            return true;
          }
          if (node.type === "ieConditionalComment" && !node.complete) {
            return true;
          }
          if (isPreLikeNode(node) && node.children.some((child) => child.type !== "text" && child.type !== "interpolation")) {
            return true;
          }
          if (isVueNonHtmlBlock(node, options) && !isScriptLikeTag(node) && node.type !== "interpolation") {
            return true;
          }
          return false;
        }
        function hasPrettierIgnore(node) {
          if (node.type === "attribute") {
            return false;
          }
          if (!node.parent) {
            return false;
          }
          if (!node.prev) {
            return false;
          }
          return isPrettierIgnore(node.prev);
        }
        function isPrettierIgnore(node) {
          return node.type === "comment" && node.value.trim() === "prettier-ignore";
        }
        function isTextLikeNode(node) {
          return node.type === "text" || node.type === "comment";
        }
        function isScriptLikeTag(node) {
          return node.type === "element" && (node.fullName === "script" || node.fullName === "style" || node.fullName === "svg:style" || isUnknownNamespace(node) && (node.name === "script" || node.name === "style"));
        }
        function canHaveInterpolation(node) {
          return node.children && !isScriptLikeTag(node);
        }
        function isWhitespaceSensitiveNode(node) {
          return isScriptLikeTag(node) || node.type === "interpolation" || isIndentationSensitiveNode(node);
        }
        function isIndentationSensitiveNode(node) {
          return getNodeCssStyleWhiteSpace(node).startsWith("pre");
        }
        function isLeadingSpaceSensitiveNode(node, options) {
          const isLeadingSpaceSensitive = _isLeadingSpaceSensitiveNode();
          if (isLeadingSpaceSensitive && !node.prev && node.parent && node.parent.tagDefinition && node.parent.tagDefinition.ignoreFirstLf) {
            return node.type === "interpolation";
          }
          return isLeadingSpaceSensitive;
          function _isLeadingSpaceSensitiveNode() {
            if (isFrontMatterNode(node)) {
              return false;
            }
            if ((node.type === "text" || node.type === "interpolation") && node.prev && (node.prev.type === "text" || node.prev.type === "interpolation")) {
              return true;
            }
            if (!node.parent || node.parent.cssDisplay === "none") {
              return false;
            }
            if (isPreLikeNode(node.parent)) {
              return true;
            }
            if (!node.prev && (node.parent.type === "root" || isPreLikeNode(node) && node.parent || isScriptLikeTag(node.parent) || isVueCustomBlock(node.parent, options) || !isFirstChildLeadingSpaceSensitiveCssDisplay(node.parent.cssDisplay))) {
              return false;
            }
            if (node.prev && !isNextLeadingSpaceSensitiveCssDisplay(node.prev.cssDisplay)) {
              return false;
            }
            return true;
          }
        }
        function isTrailingSpaceSensitiveNode(node, options) {
          if (isFrontMatterNode(node)) {
            return false;
          }
          if ((node.type === "text" || node.type === "interpolation") && node.next && (node.next.type === "text" || node.next.type === "interpolation")) {
            return true;
          }
          if (!node.parent || node.parent.cssDisplay === "none") {
            return false;
          }
          if (isPreLikeNode(node.parent)) {
            return true;
          }
          if (!node.next && (node.parent.type === "root" || isPreLikeNode(node) && node.parent || isScriptLikeTag(node.parent) || isVueCustomBlock(node.parent, options) || !isLastChildTrailingSpaceSensitiveCssDisplay(node.parent.cssDisplay))) {
            return false;
          }
          if (node.next && !isPrevTrailingSpaceSensitiveCssDisplay(node.next.cssDisplay)) {
            return false;
          }
          return true;
        }
        function isDanglingSpaceSensitiveNode(node) {
          return isDanglingSpaceSensitiveCssDisplay(node.cssDisplay) && !isScriptLikeTag(node);
        }
        function forceNextEmptyLine(node) {
          return isFrontMatterNode(node) || node.next && node.sourceSpan.end && node.sourceSpan.end.line + 1 < node.next.sourceSpan.start.line;
        }
        function forceBreakContent(node) {
          return forceBreakChildren(node) || node.type === "element" && node.children.length > 0 && (["body", "script", "style"].includes(node.name) || node.children.some((child) => hasNonTextChild(child))) || node.firstChild && node.firstChild === node.lastChild && node.firstChild.type !== "text" && hasLeadingLineBreak(node.firstChild) && (!node.lastChild.isTrailingSpaceSensitive || hasTrailingLineBreak(node.lastChild));
        }
        function forceBreakChildren(node) {
          return node.type === "element" && node.children.length > 0 && (["html", "head", "ul", "ol", "select"].includes(node.name) || node.cssDisplay.startsWith("table") && node.cssDisplay !== "table-cell");
        }
        function preferHardlineAsLeadingSpaces(node) {
          return preferHardlineAsSurroundingSpaces(node) || node.prev && preferHardlineAsTrailingSpaces(node.prev) || hasSurroundingLineBreak(node);
        }
        function preferHardlineAsTrailingSpaces(node) {
          return preferHardlineAsSurroundingSpaces(node) || node.type === "element" && node.fullName === "br" || hasSurroundingLineBreak(node);
        }
        function hasSurroundingLineBreak(node) {
          return hasLeadingLineBreak(node) && hasTrailingLineBreak(node);
        }
        function hasLeadingLineBreak(node) {
          return node.hasLeadingSpaces && (node.prev ? node.prev.sourceSpan.end.line < node.sourceSpan.start.line : node.parent.type === "root" || node.parent.startSourceSpan.end.line < node.sourceSpan.start.line);
        }
        function hasTrailingLineBreak(node) {
          return node.hasTrailingSpaces && (node.next ? node.next.sourceSpan.start.line > node.sourceSpan.end.line : node.parent.type === "root" || node.parent.endSourceSpan && node.parent.endSourceSpan.start.line > node.sourceSpan.end.line);
        }
        function preferHardlineAsSurroundingSpaces(node) {
          switch (node.type) {
            case "ieConditionalComment":
            case "comment":
            case "directive":
              return true;
            case "element":
              return ["script", "select"].includes(node.name);
          }
          return false;
        }
        function getLastDescendant(node) {
          return node.lastChild ? getLastDescendant(node.lastChild) : node;
        }
        function hasNonTextChild(node) {
          return node.children && node.children.some((child) => child.type !== "text");
        }
        function _inferScriptParser(node) {
          const {
            type,
            lang
          } = node.attrMap;
          if (type === "module" || type === "text/javascript" || type === "text/babel" || type === "application/javascript" || lang === "jsx") {
            return "babel";
          }
          if (type === "application/x-typescript" || lang === "ts" || lang === "tsx") {
            return "typescript";
          }
          if (type === "text/markdown") {
            return "markdown";
          }
          if (type === "text/html") {
            return "html";
          }
          if (type && (type.endsWith("json") || type.endsWith("importmap")) || type === "speculationrules") {
            return "json";
          }
          if (type === "text/x-handlebars-template") {
            return "glimmer";
          }
        }
        function inferStyleParser(node, options) {
          const {
            lang
          } = node.attrMap;
          if (!lang || lang === "postcss" || lang === "css") {
            return "css";
          }
          if (lang === "scss") {
            return "scss";
          }
          if (lang === "less") {
            return "less";
          }
          if (lang === "stylus") {
            return inferParserByLanguage("stylus", options);
          }
        }
        function inferScriptParser(node, options) {
          if (node.name === "script" && !node.attrMap.src) {
            if (!node.attrMap.lang && !node.attrMap.type) {
              return "babel";
            }
            return _inferScriptParser(node);
          }
          if (node.name === "style") {
            return inferStyleParser(node, options);
          }
          if (options && isVueNonHtmlBlock(node, options)) {
            return _inferScriptParser(node) || !("src" in node.attrMap) && inferParserByLanguage(node.attrMap.lang, options);
          }
        }
        function isBlockLikeCssDisplay(cssDisplay) {
          return cssDisplay === "block" || cssDisplay === "list-item" || cssDisplay.startsWith("table");
        }
        function isFirstChildLeadingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay) && cssDisplay !== "inline-block";
        }
        function isLastChildTrailingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay) && cssDisplay !== "inline-block";
        }
        function isPrevTrailingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay);
        }
        function isNextLeadingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay);
        }
        function isDanglingSpaceSensitiveCssDisplay(cssDisplay) {
          return !isBlockLikeCssDisplay(cssDisplay) && cssDisplay !== "inline-block";
        }
        function isPreLikeNode(node) {
          return getNodeCssStyleWhiteSpace(node).startsWith("pre");
        }
        function countParents(path4, predicate) {
          let counter = 0;
          for (let i2 = path4.stack.length - 1; i2 >= 0; i2--) {
            const value = path4.stack[i2];
            if (value && typeof value === "object" && !Array.isArray(value) && predicate(value)) {
              counter++;
            }
          }
          return counter;
        }
        function hasParent(node, fn) {
          let current = node;
          while (current) {
            if (fn(current)) {
              return true;
            }
            current = current.parent;
          }
          return false;
        }
        function getNodeCssStyleDisplay(node, options) {
          if (node.prev && node.prev.type === "comment") {
            const match = node.prev.value.match(/^\s*display:\s*([a-z]+)\s*$/);
            if (match) {
              return match[1];
            }
          }
          let isInSvgForeignObject = false;
          if (node.type === "element" && node.namespace === "svg") {
            if (hasParent(node, (parent) => parent.fullName === "svg:foreignObject")) {
              isInSvgForeignObject = true;
            } else {
              return node.name === "svg" ? "inline-block" : "block";
            }
          }
          switch (options.htmlWhitespaceSensitivity) {
            case "strict":
              return "inline";
            case "ignore":
              return "block";
            default: {
              if (options.parser === "vue" && node.parent && node.parent.type === "root") {
                return "block";
              }
              return node.type === "element" && (!node.namespace || isInSvgForeignObject || isUnknownNamespace(node)) && CSS_DISPLAY_TAGS[node.name] || CSS_DISPLAY_DEFAULT;
            }
          }
        }
        function getNodeCssStyleWhiteSpace(node) {
          return node.type === "element" && (!node.namespace || isUnknownNamespace(node)) && CSS_WHITE_SPACE_TAGS[node.name] || CSS_WHITE_SPACE_DEFAULT;
        }
        function getMinIndentation(text) {
          let minIndentation = Number.POSITIVE_INFINITY;
          for (const lineText of text.split("\n")) {
            if (lineText.length === 0) {
              continue;
            }
            if (!HTML_WHITESPACE.has(lineText[0])) {
              return 0;
            }
            const indentation = getLeadingHtmlWhitespace(lineText).length;
            if (lineText.length === indentation) {
              continue;
            }
            if (indentation < minIndentation) {
              minIndentation = indentation;
            }
          }
          return minIndentation === Number.POSITIVE_INFINITY ? 0 : minIndentation;
        }
        function dedentString(text, minIndent = getMinIndentation(text)) {
          return minIndent === 0 ? text : text.split("\n").map((lineText) => lineText.slice(minIndent)).join("\n");
        }
        function countChars(text, char) {
          let counter = 0;
          for (let i2 = 0; i2 < text.length; i2++) {
            if (text[i2] === char) {
              counter++;
            }
          }
          return counter;
        }
        function unescapeQuoteEntities(text) {
          return text.replace(/&apos;/g, "'").replace(/&quot;/g, '"');
        }
        var vueRootElementsSet = /* @__PURE__ */ new Set(["template", "style", "script"]);
        function isVueCustomBlock(node, options) {
          return isVueSfcBlock(node, options) && !vueRootElementsSet.has(node.fullName);
        }
        function isVueSfcBlock(node, options) {
          return options.parser === "vue" && node.type === "element" && node.parent.type === "root" && node.fullName.toLowerCase() !== "html";
        }
        function isVueNonHtmlBlock(node, options) {
          return isVueSfcBlock(node, options) && (isVueCustomBlock(node, options) || node.attrMap.lang && node.attrMap.lang !== "html");
        }
        function isVueSlotAttribute(attribute) {
          const attributeName = attribute.fullName;
          return attributeName.charAt(0) === "#" || attributeName === "slot-scope" || attributeName === "v-slot" || attributeName.startsWith("v-slot:");
        }
        function isVueSfcBindingsAttribute(attribute, options) {
          const element = attribute.parent;
          if (!isVueSfcBlock(element, options)) {
            return false;
          }
          const tagName = element.fullName;
          const attributeName = attribute.fullName;
          return tagName === "script" && attributeName === "setup" || tagName === "style" && attributeName === "vars";
        }
        function getTextValueParts(node, value = node.value) {
          return node.parent.isWhitespaceSensitive ? node.parent.isIndentationSensitive ? replaceTextEndOfLine(value) : replaceTextEndOfLine(dedentString(htmlTrimPreserveIndentation(value)), hardline) : getDocParts(join(line, splitByHtmlWhitespace(value)));
        }
        function isVueScriptTag(node, options) {
          return isVueSfcBlock(node, options) && node.name === "script";
        }
        module22.exports = {
          htmlTrim,
          htmlTrimPreserveIndentation,
          hasHtmlWhitespace,
          getLeadingAndTrailingHtmlWhitespace,
          canHaveInterpolation,
          countChars,
          countParents,
          dedentString,
          forceBreakChildren,
          forceBreakContent,
          forceNextEmptyLine,
          getLastDescendant,
          getNodeCssStyleDisplay,
          getNodeCssStyleWhiteSpace,
          hasPrettierIgnore,
          inferScriptParser,
          isVueCustomBlock,
          isVueNonHtmlBlock,
          isVueScriptTag,
          isVueSlotAttribute,
          isVueSfcBindingsAttribute,
          isVueSfcBlock,
          isDanglingSpaceSensitiveNode,
          isIndentationSensitiveNode,
          isLeadingSpaceSensitiveNode,
          isPreLikeNode,
          isScriptLikeTag,
          isTextLikeNode,
          isTrailingSpaceSensitiveNode,
          isWhitespaceSensitiveNode,
          isUnknownNamespace,
          preferHardlineAsLeadingSpaces,
          preferHardlineAsTrailingSpaces,
          shouldPreserveContent,
          unescapeQuoteEntities,
          getTextValueParts
        };
      }
    });
    var require_chars = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/chars.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        exports2.$EOF = 0;
        exports2.$BSPACE = 8;
        exports2.$TAB = 9;
        exports2.$LF = 10;
        exports2.$VTAB = 11;
        exports2.$FF = 12;
        exports2.$CR = 13;
        exports2.$SPACE = 32;
        exports2.$BANG = 33;
        exports2.$DQ = 34;
        exports2.$HASH = 35;
        exports2.$$ = 36;
        exports2.$PERCENT = 37;
        exports2.$AMPERSAND = 38;
        exports2.$SQ = 39;
        exports2.$LPAREN = 40;
        exports2.$RPAREN = 41;
        exports2.$STAR = 42;
        exports2.$PLUS = 43;
        exports2.$COMMA = 44;
        exports2.$MINUS = 45;
        exports2.$PERIOD = 46;
        exports2.$SLASH = 47;
        exports2.$COLON = 58;
        exports2.$SEMICOLON = 59;
        exports2.$LT = 60;
        exports2.$EQ = 61;
        exports2.$GT = 62;
        exports2.$QUESTION = 63;
        exports2.$0 = 48;
        exports2.$7 = 55;
        exports2.$9 = 57;
        exports2.$A = 65;
        exports2.$E = 69;
        exports2.$F = 70;
        exports2.$X = 88;
        exports2.$Z = 90;
        exports2.$LBRACKET = 91;
        exports2.$BACKSLASH = 92;
        exports2.$RBRACKET = 93;
        exports2.$CARET = 94;
        exports2.$_ = 95;
        exports2.$a = 97;
        exports2.$b = 98;
        exports2.$e = 101;
        exports2.$f = 102;
        exports2.$n = 110;
        exports2.$r = 114;
        exports2.$t = 116;
        exports2.$u = 117;
        exports2.$v = 118;
        exports2.$x = 120;
        exports2.$z = 122;
        exports2.$LBRACE = 123;
        exports2.$BAR = 124;
        exports2.$RBRACE = 125;
        exports2.$NBSP = 160;
        exports2.$PIPE = 124;
        exports2.$TILDA = 126;
        exports2.$AT = 64;
        exports2.$BT = 96;
        function isWhitespace(code) {
          return code >= exports2.$TAB && code <= exports2.$SPACE || code == exports2.$NBSP;
        }
        exports2.isWhitespace = isWhitespace;
        function isDigit(code) {
          return exports2.$0 <= code && code <= exports2.$9;
        }
        exports2.isDigit = isDigit;
        function isAsciiLetter(code) {
          return code >= exports2.$a && code <= exports2.$z || code >= exports2.$A && code <= exports2.$Z;
        }
        exports2.isAsciiLetter = isAsciiLetter;
        function isAsciiHexDigit(code) {
          return code >= exports2.$a && code <= exports2.$f || code >= exports2.$A && code <= exports2.$F || isDigit(code);
        }
        exports2.isAsciiHexDigit = isAsciiHexDigit;
        function isNewLine(code) {
          return code === exports2.$LF || code === exports2.$CR;
        }
        exports2.isNewLine = isNewLine;
        function isOctalDigit(code) {
          return exports2.$0 <= code && code <= exports2.$7;
        }
        exports2.isOctalDigit = isOctalDigit;
      }
    });
    var require_static_symbol = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/aot/static_symbol.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var StaticSymbol = class {
          constructor(filePath, name, members) {
            this.filePath = filePath;
            this.name = name;
            this.members = members;
          }
          assertNoMembers() {
            if (this.members.length) {
              throw new Error(`Illegal state: symbol without members expected, but got ${JSON.stringify(this)}.`);
            }
          }
        };
        exports2.StaticSymbol = StaticSymbol;
        var StaticSymbolCache = class {
          constructor() {
            this.cache = /* @__PURE__ */ new Map();
          }
          get(declarationFile, name, members) {
            members = members || [];
            const memberSuffix = members.length ? `.${members.join(".")}` : "";
            const key = `"${declarationFile}".${name}${memberSuffix}`;
            let result = this.cache.get(key);
            if (!result) {
              result = new StaticSymbol(declarationFile, name, members);
              this.cache.set(key, result);
            }
            return result;
          }
        };
        exports2.StaticSymbolCache = StaticSymbolCache;
      }
    });
    var require_util3 = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/util.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var DASH_CASE_REGEXP = /-+([a-z0-9])/g;
        function dashCaseToCamelCase(input) {
          return input.replace(DASH_CASE_REGEXP, (...m2) => m2[1].toUpperCase());
        }
        exports2.dashCaseToCamelCase = dashCaseToCamelCase;
        function splitAtColon(input, defaultValues) {
          return _splitAt(input, ":", defaultValues);
        }
        exports2.splitAtColon = splitAtColon;
        function splitAtPeriod(input, defaultValues) {
          return _splitAt(input, ".", defaultValues);
        }
        exports2.splitAtPeriod = splitAtPeriod;
        function _splitAt(input, character, defaultValues) {
          const characterIndex = input.indexOf(character);
          if (characterIndex == -1)
            return defaultValues;
          return [input.slice(0, characterIndex).trim(), input.slice(characterIndex + 1).trim()];
        }
        function visitValue(value, visitor, context2) {
          if (Array.isArray(value)) {
            return visitor.visitArray(value, context2);
          }
          if (isStrictStringMap(value)) {
            return visitor.visitStringMap(value, context2);
          }
          if (value == null || typeof value == "string" || typeof value == "number" || typeof value == "boolean") {
            return visitor.visitPrimitive(value, context2);
          }
          return visitor.visitOther(value, context2);
        }
        exports2.visitValue = visitValue;
        function isDefined2(val) {
          return val !== null && val !== void 0;
        }
        exports2.isDefined = isDefined2;
        function noUndefined(val) {
          return val === void 0 ? null : val;
        }
        exports2.noUndefined = noUndefined;
        var ValueTransformer = class {
          visitArray(arr, context2) {
            return arr.map((value) => visitValue(value, this, context2));
          }
          visitStringMap(map, context2) {
            const result = {};
            Object.keys(map).forEach((key) => {
              result[key] = visitValue(map[key], this, context2);
            });
            return result;
          }
          visitPrimitive(value, context2) {
            return value;
          }
          visitOther(value, context2) {
            return value;
          }
        };
        exports2.ValueTransformer = ValueTransformer;
        exports2.SyncAsync = {
          assertSync: (value) => {
            if (isPromise(value)) {
              throw new Error(`Illegal state: value cannot be a promise`);
            }
            return value;
          },
          then: (value, cb) => {
            return isPromise(value) ? value.then(cb) : cb(value);
          },
          all: (syncAsyncValues) => {
            return syncAsyncValues.some(isPromise) ? Promise.all(syncAsyncValues) : syncAsyncValues;
          }
        };
        function error(msg) {
          throw new Error(`Internal Error: ${msg}`);
        }
        exports2.error = error;
        function syntaxError(msg, parseErrors) {
          const error2 = Error(msg);
          error2[ERROR_SYNTAX_ERROR] = true;
          if (parseErrors)
            error2[ERROR_PARSE_ERRORS] = parseErrors;
          return error2;
        }
        exports2.syntaxError = syntaxError;
        var ERROR_SYNTAX_ERROR = "ngSyntaxError";
        var ERROR_PARSE_ERRORS = "ngParseErrors";
        function isSyntaxError(error2) {
          return error2[ERROR_SYNTAX_ERROR];
        }
        exports2.isSyntaxError = isSyntaxError;
        function getParseErrors(error2) {
          return error2[ERROR_PARSE_ERRORS] || [];
        }
        exports2.getParseErrors = getParseErrors;
        function escapeRegExp(s2) {
          return s2.replace(/([.*+?^=!:${}()|[\]\/\\])/g, "\\$1");
        }
        exports2.escapeRegExp = escapeRegExp;
        var STRING_MAP_PROTO = Object.getPrototypeOf({});
        function isStrictStringMap(obj) {
          return typeof obj === "object" && obj !== null && Object.getPrototypeOf(obj) === STRING_MAP_PROTO;
        }
        function utf8Encode(str) {
          let encoded = "";
          for (let index = 0; index < str.length; index++) {
            let codePoint = str.charCodeAt(index);
            if (codePoint >= 55296 && codePoint <= 56319 && str.length > index + 1) {
              const low = str.charCodeAt(index + 1);
              if (low >= 56320 && low <= 57343) {
                index++;
                codePoint = (codePoint - 55296 << 10) + low - 56320 + 65536;
              }
            }
            if (codePoint <= 127) {
              encoded += String.fromCharCode(codePoint);
            } else if (codePoint <= 2047) {
              encoded += String.fromCharCode(codePoint >> 6 & 31 | 192, codePoint & 63 | 128);
            } else if (codePoint <= 65535) {
              encoded += String.fromCharCode(codePoint >> 12 | 224, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
            } else if (codePoint <= 2097151) {
              encoded += String.fromCharCode(codePoint >> 18 & 7 | 240, codePoint >> 12 & 63 | 128, codePoint >> 6 & 63 | 128, codePoint & 63 | 128);
            }
          }
          return encoded;
        }
        exports2.utf8Encode = utf8Encode;
        function stringify(token) {
          if (typeof token === "string") {
            return token;
          }
          if (token instanceof Array) {
            return "[" + token.map(stringify).join(", ") + "]";
          }
          if (token == null) {
            return "" + token;
          }
          if (token.overriddenName) {
            return `${token.overriddenName}`;
          }
          if (token.name) {
            return `${token.name}`;
          }
          if (!token.toString) {
            return "object";
          }
          const res = token.toString();
          if (res == null) {
            return "" + res;
          }
          const newLineIndex = res.indexOf("\n");
          return newLineIndex === -1 ? res : res.substring(0, newLineIndex);
        }
        exports2.stringify = stringify;
        function resolveForwardRef(type) {
          if (typeof type === "function" && type.hasOwnProperty("__forward_ref__")) {
            return type();
          } else {
            return type;
          }
        }
        exports2.resolveForwardRef = resolveForwardRef;
        function isPromise(obj) {
          return !!obj && typeof obj.then === "function";
        }
        exports2.isPromise = isPromise;
        var Version = class {
          constructor(full) {
            this.full = full;
            const splits = full.split(".");
            this.major = splits[0];
            this.minor = splits[1];
            this.patch = splits.slice(2).join(".");
          }
        };
        exports2.Version = Version;
        var __window = typeof window !== "undefined" && window;
        var __self = typeof self !== "undefined" && typeof WorkerGlobalScope !== "undefined" && self instanceof WorkerGlobalScope && self;
        var __global = typeof global !== "undefined" && global;
        var _global = __global || __window || __self;
        exports2.global = _global;
      }
    });
    var require_compile_metadata = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/compile_metadata.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var static_symbol_1 = require_static_symbol();
        var util_1 = require_util3();
        var HOST_REG_EXP = /^(?:(?:\[([^\]]+)\])|(?:\(([^\)]+)\)))|(\@[-\w]+)$/;
        function sanitizeIdentifier(name) {
          return name.replace(/\W/g, "_");
        }
        exports2.sanitizeIdentifier = sanitizeIdentifier;
        var _anonymousTypeIndex = 0;
        function identifierName(compileIdentifier) {
          if (!compileIdentifier || !compileIdentifier.reference) {
            return null;
          }
          const ref = compileIdentifier.reference;
          if (ref instanceof static_symbol_1.StaticSymbol) {
            return ref.name;
          }
          if (ref["__anonymousType"]) {
            return ref["__anonymousType"];
          }
          let identifier = util_1.stringify(ref);
          if (identifier.indexOf("(") >= 0) {
            identifier = `anonymous_${_anonymousTypeIndex++}`;
            ref["__anonymousType"] = identifier;
          } else {
            identifier = sanitizeIdentifier(identifier);
          }
          return identifier;
        }
        exports2.identifierName = identifierName;
        function identifierModuleUrl(compileIdentifier) {
          const ref = compileIdentifier.reference;
          if (ref instanceof static_symbol_1.StaticSymbol) {
            return ref.filePath;
          }
          return `./${util_1.stringify(ref)}`;
        }
        exports2.identifierModuleUrl = identifierModuleUrl;
        function viewClassName(compType, embeddedTemplateIndex) {
          return `View_${identifierName({
            reference: compType
          })}_${embeddedTemplateIndex}`;
        }
        exports2.viewClassName = viewClassName;
        function rendererTypeName(compType) {
          return `RenderType_${identifierName({
            reference: compType
          })}`;
        }
        exports2.rendererTypeName = rendererTypeName;
        function hostViewClassName(compType) {
          return `HostView_${identifierName({
            reference: compType
          })}`;
        }
        exports2.hostViewClassName = hostViewClassName;
        function componentFactoryName(compType) {
          return `${identifierName({
            reference: compType
          })}NgFactory`;
        }
        exports2.componentFactoryName = componentFactoryName;
        var CompileSummaryKind;
        (function(CompileSummaryKind2) {
          CompileSummaryKind2[CompileSummaryKind2["Pipe"] = 0] = "Pipe";
          CompileSummaryKind2[CompileSummaryKind2["Directive"] = 1] = "Directive";
          CompileSummaryKind2[CompileSummaryKind2["NgModule"] = 2] = "NgModule";
          CompileSummaryKind2[CompileSummaryKind2["Injectable"] = 3] = "Injectable";
        })(CompileSummaryKind = exports2.CompileSummaryKind || (exports2.CompileSummaryKind = {}));
        function tokenName(token) {
          return token.value != null ? sanitizeIdentifier(token.value) : identifierName(token.identifier);
        }
        exports2.tokenName = tokenName;
        function tokenReference(token) {
          if (token.identifier != null) {
            return token.identifier.reference;
          } else {
            return token.value;
          }
        }
        exports2.tokenReference = tokenReference;
        var CompileStylesheetMetadata = class {
          constructor({
            moduleUrl,
            styles,
            styleUrls
          } = {}) {
            this.moduleUrl = moduleUrl || null;
            this.styles = _normalizeArray(styles);
            this.styleUrls = _normalizeArray(styleUrls);
          }
        };
        exports2.CompileStylesheetMetadata = CompileStylesheetMetadata;
        var CompileTemplateMetadata = class {
          constructor({
            encapsulation,
            template,
            templateUrl,
            htmlAst,
            styles,
            styleUrls,
            externalStylesheets,
            animations,
            ngContentSelectors,
            interpolation,
            isInline,
            preserveWhitespaces
          }) {
            this.encapsulation = encapsulation;
            this.template = template;
            this.templateUrl = templateUrl;
            this.htmlAst = htmlAst;
            this.styles = _normalizeArray(styles);
            this.styleUrls = _normalizeArray(styleUrls);
            this.externalStylesheets = _normalizeArray(externalStylesheets);
            this.animations = animations ? flatten2(animations) : [];
            this.ngContentSelectors = ngContentSelectors || [];
            if (interpolation && interpolation.length != 2) {
              throw new Error(`'interpolation' should have a start and an end symbol.`);
            }
            this.interpolation = interpolation;
            this.isInline = isInline;
            this.preserveWhitespaces = preserveWhitespaces;
          }
          toSummary() {
            return {
              ngContentSelectors: this.ngContentSelectors,
              encapsulation: this.encapsulation,
              styles: this.styles,
              animations: this.animations
            };
          }
        };
        exports2.CompileTemplateMetadata = CompileTemplateMetadata;
        var CompileDirectiveMetadata = class {
          static create({
            isHost,
            type,
            isComponent,
            selector,
            exportAs,
            changeDetection,
            inputs,
            outputs,
            host,
            providers,
            viewProviders,
            queries,
            guards,
            viewQueries,
            entryComponents,
            template,
            componentViewType,
            rendererType,
            componentFactory
          }) {
            const hostListeners = {};
            const hostProperties = {};
            const hostAttributes = {};
            if (host != null) {
              Object.keys(host).forEach((key) => {
                const value = host[key];
                const matches = key.match(HOST_REG_EXP);
                if (matches === null) {
                  hostAttributes[key] = value;
                } else if (matches[1] != null) {
                  hostProperties[matches[1]] = value;
                } else if (matches[2] != null) {
                  hostListeners[matches[2]] = value;
                }
              });
            }
            const inputsMap = {};
            if (inputs != null) {
              inputs.forEach((bindConfig) => {
                const parts = util_1.splitAtColon(bindConfig, [bindConfig, bindConfig]);
                inputsMap[parts[0]] = parts[1];
              });
            }
            const outputsMap = {};
            if (outputs != null) {
              outputs.forEach((bindConfig) => {
                const parts = util_1.splitAtColon(bindConfig, [bindConfig, bindConfig]);
                outputsMap[parts[0]] = parts[1];
              });
            }
            return new CompileDirectiveMetadata({
              isHost,
              type,
              isComponent: !!isComponent,
              selector,
              exportAs,
              changeDetection,
              inputs: inputsMap,
              outputs: outputsMap,
              hostListeners,
              hostProperties,
              hostAttributes,
              providers,
              viewProviders,
              queries,
              guards,
              viewQueries,
              entryComponents,
              template,
              componentViewType,
              rendererType,
              componentFactory
            });
          }
          constructor({
            isHost,
            type,
            isComponent,
            selector,
            exportAs,
            changeDetection,
            inputs,
            outputs,
            hostListeners,
            hostProperties,
            hostAttributes,
            providers,
            viewProviders,
            queries,
            guards,
            viewQueries,
            entryComponents,
            template,
            componentViewType,
            rendererType,
            componentFactory
          }) {
            this.isHost = !!isHost;
            this.type = type;
            this.isComponent = isComponent;
            this.selector = selector;
            this.exportAs = exportAs;
            this.changeDetection = changeDetection;
            this.inputs = inputs;
            this.outputs = outputs;
            this.hostListeners = hostListeners;
            this.hostProperties = hostProperties;
            this.hostAttributes = hostAttributes;
            this.providers = _normalizeArray(providers);
            this.viewProviders = _normalizeArray(viewProviders);
            this.queries = _normalizeArray(queries);
            this.guards = guards;
            this.viewQueries = _normalizeArray(viewQueries);
            this.entryComponents = _normalizeArray(entryComponents);
            this.template = template;
            this.componentViewType = componentViewType;
            this.rendererType = rendererType;
            this.componentFactory = componentFactory;
          }
          toSummary() {
            return {
              summaryKind: CompileSummaryKind.Directive,
              type: this.type,
              isComponent: this.isComponent,
              selector: this.selector,
              exportAs: this.exportAs,
              inputs: this.inputs,
              outputs: this.outputs,
              hostListeners: this.hostListeners,
              hostProperties: this.hostProperties,
              hostAttributes: this.hostAttributes,
              providers: this.providers,
              viewProviders: this.viewProviders,
              queries: this.queries,
              guards: this.guards,
              viewQueries: this.viewQueries,
              entryComponents: this.entryComponents,
              changeDetection: this.changeDetection,
              template: this.template && this.template.toSummary(),
              componentViewType: this.componentViewType,
              rendererType: this.rendererType,
              componentFactory: this.componentFactory
            };
          }
        };
        exports2.CompileDirectiveMetadata = CompileDirectiveMetadata;
        var CompilePipeMetadata = class {
          constructor({
            type,
            name,
            pure
          }) {
            this.type = type;
            this.name = name;
            this.pure = !!pure;
          }
          toSummary() {
            return {
              summaryKind: CompileSummaryKind.Pipe,
              type: this.type,
              name: this.name,
              pure: this.pure
            };
          }
        };
        exports2.CompilePipeMetadata = CompilePipeMetadata;
        var CompileShallowModuleMetadata = class {
        };
        exports2.CompileShallowModuleMetadata = CompileShallowModuleMetadata;
        var CompileNgModuleMetadata = class {
          constructor({
            type,
            providers,
            declaredDirectives,
            exportedDirectives,
            declaredPipes,
            exportedPipes,
            entryComponents,
            bootstrapComponents,
            importedModules,
            exportedModules,
            schemas,
            transitiveModule,
            id
          }) {
            this.type = type || null;
            this.declaredDirectives = _normalizeArray(declaredDirectives);
            this.exportedDirectives = _normalizeArray(exportedDirectives);
            this.declaredPipes = _normalizeArray(declaredPipes);
            this.exportedPipes = _normalizeArray(exportedPipes);
            this.providers = _normalizeArray(providers);
            this.entryComponents = _normalizeArray(entryComponents);
            this.bootstrapComponents = _normalizeArray(bootstrapComponents);
            this.importedModules = _normalizeArray(importedModules);
            this.exportedModules = _normalizeArray(exportedModules);
            this.schemas = _normalizeArray(schemas);
            this.id = id || null;
            this.transitiveModule = transitiveModule || null;
          }
          toSummary() {
            const module3 = this.transitiveModule;
            return {
              summaryKind: CompileSummaryKind.NgModule,
              type: this.type,
              entryComponents: module3.entryComponents,
              providers: module3.providers,
              modules: module3.modules,
              exportedDirectives: module3.exportedDirectives,
              exportedPipes: module3.exportedPipes
            };
          }
        };
        exports2.CompileNgModuleMetadata = CompileNgModuleMetadata;
        var TransitiveCompileNgModuleMetadata = class {
          constructor() {
            this.directivesSet = /* @__PURE__ */ new Set();
            this.directives = [];
            this.exportedDirectivesSet = /* @__PURE__ */ new Set();
            this.exportedDirectives = [];
            this.pipesSet = /* @__PURE__ */ new Set();
            this.pipes = [];
            this.exportedPipesSet = /* @__PURE__ */ new Set();
            this.exportedPipes = [];
            this.modulesSet = /* @__PURE__ */ new Set();
            this.modules = [];
            this.entryComponentsSet = /* @__PURE__ */ new Set();
            this.entryComponents = [];
            this.providers = [];
          }
          addProvider(provider, module3) {
            this.providers.push({
              provider,
              module: module3
            });
          }
          addDirective(id) {
            if (!this.directivesSet.has(id.reference)) {
              this.directivesSet.add(id.reference);
              this.directives.push(id);
            }
          }
          addExportedDirective(id) {
            if (!this.exportedDirectivesSet.has(id.reference)) {
              this.exportedDirectivesSet.add(id.reference);
              this.exportedDirectives.push(id);
            }
          }
          addPipe(id) {
            if (!this.pipesSet.has(id.reference)) {
              this.pipesSet.add(id.reference);
              this.pipes.push(id);
            }
          }
          addExportedPipe(id) {
            if (!this.exportedPipesSet.has(id.reference)) {
              this.exportedPipesSet.add(id.reference);
              this.exportedPipes.push(id);
            }
          }
          addModule(id) {
            if (!this.modulesSet.has(id.reference)) {
              this.modulesSet.add(id.reference);
              this.modules.push(id);
            }
          }
          addEntryComponent(ec) {
            if (!this.entryComponentsSet.has(ec.componentType)) {
              this.entryComponentsSet.add(ec.componentType);
              this.entryComponents.push(ec);
            }
          }
        };
        exports2.TransitiveCompileNgModuleMetadata = TransitiveCompileNgModuleMetadata;
        function _normalizeArray(obj) {
          return obj || [];
        }
        var ProviderMeta = class {
          constructor(token, {
            useClass,
            useValue,
            useExisting,
            useFactory,
            deps,
            multi
          }) {
            this.token = token;
            this.useClass = useClass || null;
            this.useValue = useValue;
            this.useExisting = useExisting;
            this.useFactory = useFactory || null;
            this.dependencies = deps || null;
            this.multi = !!multi;
          }
        };
        exports2.ProviderMeta = ProviderMeta;
        function flatten2(list) {
          return list.reduce((flat, item) => {
            const flatItem = Array.isArray(item) ? flatten2(item) : item;
            return flat.concat(flatItem);
          }, []);
        }
        exports2.flatten = flatten2;
        function jitSourceUrl(url) {
          return url.replace(/(\w+:\/\/[\w:-]+)?(\/+)?/, "ng:///");
        }
        function templateSourceUrl(ngModuleType, compMeta, templateMeta) {
          let url;
          if (templateMeta.isInline) {
            if (compMeta.type.reference instanceof static_symbol_1.StaticSymbol) {
              url = `${compMeta.type.reference.filePath}.${compMeta.type.reference.name}.html`;
            } else {
              url = `${identifierName(ngModuleType)}/${identifierName(compMeta.type)}.html`;
            }
          } else {
            url = templateMeta.templateUrl;
          }
          return compMeta.type.reference instanceof static_symbol_1.StaticSymbol ? url : jitSourceUrl(url);
        }
        exports2.templateSourceUrl = templateSourceUrl;
        function sharedStylesheetJitUrl(meta, id) {
          const pathParts = meta.moduleUrl.split(/\/\\/g);
          const baseName = pathParts[pathParts.length - 1];
          return jitSourceUrl(`css/${id}${baseName}.ngstyle.js`);
        }
        exports2.sharedStylesheetJitUrl = sharedStylesheetJitUrl;
        function ngModuleJitUrl(moduleMeta) {
          return jitSourceUrl(`${identifierName(moduleMeta.type)}/module.ngfactory.js`);
        }
        exports2.ngModuleJitUrl = ngModuleJitUrl;
        function templateJitUrl(ngModuleType, compMeta) {
          return jitSourceUrl(`${identifierName(ngModuleType)}/${identifierName(compMeta.type)}.ngfactory.js`);
        }
        exports2.templateJitUrl = templateJitUrl;
      }
    });
    var require_parse_util = __commonJS22({
      "node_modules/angular-html-parser/lib/compiler/src/parse_util.js"(exports2) {
        "use strict";
        Object.defineProperty(exports2, "__esModule", {
          value: true
        });
        var chars = require_chars();
        var compile_metadata_1 = require_compile_metadata();
        var ParseLocation = class {
          constructor(file, offset, line, col) {
            this.file = file;
            this.offset = offset;
            this.line = line;
            this.col = col;
          }
          toString() {
            return this.offset != null ? `${this.file.url}@${this.line}:${this.col}` : this.file.url;
          }
          moveBy(delta) {
            const source = this.file.content;
            const len = source.length;
            let offset = this.offset;
            let line = this.line;
            let col = this.col;
            while (offset > 0 && delta < 0) {
              offset--;
              delta++;
              const ch = source.charCodeAt(offset);
              if (ch == chars.$LF) {
                line--;
                const priorLine = source.substr(0, offset - 1).lastIndexOf(String.fromCharCode(chars.$LF));
                col = priorLine > 0 ? offset - priorLine : offset;
              } else {
                col--;
              }
            }
            while (offset < len && delta > 0) {
              const ch = source.charCodeAt(offset);
              offset++;
              delta--;
              if (ch == chars.$LF) {
                line++;
                col = 0;
              } else {
                col++;
              }
            }
            return new ParseLocation(this.file, offset, line, col);
          }
          getContext(maxChars, maxLines) {
            const content = this.file.content;
            let startOffset = this.offset;
            if (startOffset != null) {
              if (startOffset > content.length - 1) {
                startOffset = content.length - 1;
              }
              let endOffset = startOffset;
              let ctxChars = 0;
              let ctxLines = 0;
              while (ctxChars < maxChars && startOffset > 0) {
                startOffset--;
                ctxChars++;
                if (content[startOffset] == "\n") {
                  if (++ctxLines == maxLines) {
                    break;
                  }
                }
              }
              ctxChars = 0;
              ctxLines = 0;
              while (ctxChars < maxChars && endOffset < content.length - 1) {
                endOffset++;
                ctxChars++;
                if (content[endOffset] == "\n") {
                  if (++ctxLines == maxLines) {
                    break;
                  }
                }
              }
              return {
                before: content.substring(startOffset, this.offset),
                after: content.substring(this.offset, endOffset + 1)
              };
            }
            return null;
          }
        };
        exports2.ParseLocation = ParseLocation;
        var ParseSourceFile = class {
          constructor(content, url) {
            this.content = content;
            this.url = url;
          }
        };
        exports2.ParseSourceFile = ParseSourceFile;
        var ParseSourceSpan = class {
          constructor(start, end, details = null) {
            this.start = start;
            this.end = end;
            this.details = details;
          }
          toString() {
            return this.start.file.content.substring(this.start.offset, this.end.offset);
          }
        };
        exports2.ParseSourceSpan = ParseSourceSpan;
        exports2.EMPTY_PARSE_LOCATION = new ParseLocation(new ParseSourceFile("", ""), 0, 0, 0);
        exports2.EMPTY_SOURCE_SPAN = new ParseSourceSpan(exports2.EMPTY_PARSE_LOCATION, exports2.EMPTY_PARSE_LOCATION);
        var ParseErrorLevel;
        (function(ParseErrorLevel2) {
          ParseErrorLevel2[ParseErrorLevel2["WARNING"] = 0] = "WARNING";
          ParseErrorLevel2[ParseErrorLevel2["ERROR"] = 1] = "ERROR";
        })(ParseErrorLevel = exports2.ParseErrorLevel || (exports2.ParseErrorLevel = {}));
        var ParseError = class {
          constructor(span, msg, level = ParseErrorLevel.ERROR) {
            this.span = span;
            this.msg = msg;
            this.level = level;
          }
          contextualMessage() {
            const ctx = this.span.start.getContext(100, 3);
            return ctx ? `${this.msg} ("${ctx.before}[${ParseErrorLevel[this.level]} ->]${ctx.after}")` : this.msg;
          }
          toString() {
            const details = this.span.details ? `, ${this.span.details}` : "";
            return `${this.contextualMessage()}: ${this.span.start}${details}`;
          }
        };
        exports2.ParseError = ParseError;
        function typeSourceSpan(kind, type) {
          const moduleUrl = compile_metadata_1.identifierModuleUrl(type);
          const sourceFileName = moduleUrl != null ? `in ${kind} ${compile_metadata_1.identifierName(type)} in ${moduleUrl}` : `in ${kind} ${compile_metadata_1.identifierName(type)}`;
          const sourceFile = new ParseSourceFile("", sourceFileName);
          return new ParseSourceSpan(new ParseLocation(sourceFile, -1, -1, -1), new ParseLocation(sourceFile, -1, -1, -1));
        }
        exports2.typeSourceSpan = typeSourceSpan;
        function r3JitTypeSourceSpan(kind, typeName, sourceUrl) {
          const sourceFileName = `in ${kind} ${typeName} in ${sourceUrl}`;
          const sourceFile = new ParseSourceFile("", sourceFileName);
          return new ParseSourceSpan(new ParseLocation(sourceFile, -1, -1, -1), new ParseLocation(sourceFile, -1, -1, -1));
        }
        exports2.r3JitTypeSourceSpan = r3JitTypeSourceSpan;
      }
    });
    var require_print_preprocess3 = __commonJS22({
      "src/language-html/print-preprocess.js"(exports2, module22) {
        "use strict";
        var {
          ParseSourceSpan
        } = require_parse_util();
        var {
          htmlTrim,
          getLeadingAndTrailingHtmlWhitespace,
          hasHtmlWhitespace,
          canHaveInterpolation,
          getNodeCssStyleDisplay,
          isDanglingSpaceSensitiveNode,
          isIndentationSensitiveNode,
          isLeadingSpaceSensitiveNode,
          isTrailingSpaceSensitiveNode,
          isWhitespaceSensitiveNode,
          isVueScriptTag
        } = require_utils112();
        var PREPROCESS_PIPELINE = [removeIgnorableFirstLf, mergeIfConditionalStartEndCommentIntoElementOpeningTag, mergeCdataIntoText, extractInterpolation, extractWhitespaces, addCssDisplay, addIsSelfClosing, addHasHtmComponentClosingTag, addIsSpaceSensitive, mergeSimpleElementIntoText, markTsScript];
        function preprocess(ast, options) {
          for (const fn of PREPROCESS_PIPELINE) {
            fn(ast, options);
          }
          return ast;
        }
        function removeIgnorableFirstLf(ast) {
          ast.walk((node) => {
            if (node.type === "element" && node.tagDefinition.ignoreFirstLf && node.children.length > 0 && node.children[0].type === "text" && node.children[0].value[0] === "\n") {
              const text = node.children[0];
              if (text.value.length === 1) {
                node.removeChild(text);
              } else {
                text.value = text.value.slice(1);
              }
            }
          });
        }
        function mergeIfConditionalStartEndCommentIntoElementOpeningTag(ast) {
          const isTarget = (node) => node.type === "element" && node.prev && node.prev.type === "ieConditionalStartComment" && node.prev.sourceSpan.end.offset === node.startSourceSpan.start.offset && node.firstChild && node.firstChild.type === "ieConditionalEndComment" && node.firstChild.sourceSpan.start.offset === node.startSourceSpan.end.offset;
          ast.walk((node) => {
            if (node.children) {
              for (let i2 = 0; i2 < node.children.length; i2++) {
                const child = node.children[i2];
                if (!isTarget(child)) {
                  continue;
                }
                const ieConditionalStartComment = child.prev;
                const ieConditionalEndComment = child.firstChild;
                node.removeChild(ieConditionalStartComment);
                i2--;
                const startSourceSpan = new ParseSourceSpan(ieConditionalStartComment.sourceSpan.start, ieConditionalEndComment.sourceSpan.end);
                const sourceSpan = new ParseSourceSpan(startSourceSpan.start, child.sourceSpan.end);
                child.condition = ieConditionalStartComment.condition;
                child.sourceSpan = sourceSpan;
                child.startSourceSpan = startSourceSpan;
                child.removeChild(ieConditionalEndComment);
              }
            }
          });
        }
        function mergeNodeIntoText(ast, shouldMerge, getValue) {
          ast.walk((node) => {
            if (node.children) {
              for (let i2 = 0; i2 < node.children.length; i2++) {
                const child = node.children[i2];
                if (child.type !== "text" && !shouldMerge(child)) {
                  continue;
                }
                if (child.type !== "text") {
                  child.type = "text";
                  child.value = getValue(child);
                }
                const prevChild = child.prev;
                if (!prevChild || prevChild.type !== "text") {
                  continue;
                }
                prevChild.value += child.value;
                prevChild.sourceSpan = new ParseSourceSpan(prevChild.sourceSpan.start, child.sourceSpan.end);
                node.removeChild(child);
                i2--;
              }
            }
          });
        }
        function mergeCdataIntoText(ast) {
          return mergeNodeIntoText(ast, (node) => node.type === "cdata", (node) => `<![CDATA[${node.value}]]>`);
        }
        function mergeSimpleElementIntoText(ast) {
          const isSimpleElement = (node) => node.type === "element" && node.attrs.length === 0 && node.children.length === 1 && node.firstChild.type === "text" && !hasHtmlWhitespace(node.children[0].value) && !node.firstChild.hasLeadingSpaces && !node.firstChild.hasTrailingSpaces && node.isLeadingSpaceSensitive && !node.hasLeadingSpaces && node.isTrailingSpaceSensitive && !node.hasTrailingSpaces && node.prev && node.prev.type === "text" && node.next && node.next.type === "text";
          ast.walk((node) => {
            if (node.children) {
              for (let i2 = 0; i2 < node.children.length; i2++) {
                const child = node.children[i2];
                if (!isSimpleElement(child)) {
                  continue;
                }
                const prevChild = child.prev;
                const nextChild = child.next;
                prevChild.value += `<${child.rawName}>` + child.firstChild.value + `</${child.rawName}>` + nextChild.value;
                prevChild.sourceSpan = new ParseSourceSpan(prevChild.sourceSpan.start, nextChild.sourceSpan.end);
                prevChild.isTrailingSpaceSensitive = nextChild.isTrailingSpaceSensitive;
                prevChild.hasTrailingSpaces = nextChild.hasTrailingSpaces;
                node.removeChild(child);
                i2--;
                node.removeChild(nextChild);
              }
            }
          });
        }
        function extractInterpolation(ast, options) {
          if (options.parser === "html") {
            return;
          }
          const interpolationRegex = /{{(.+?)}}/s;
          ast.walk((node) => {
            if (!canHaveInterpolation(node)) {
              return;
            }
            for (const child of node.children) {
              if (child.type !== "text") {
                continue;
              }
              let startSourceSpan = child.sourceSpan.start;
              let endSourceSpan = null;
              const components = child.value.split(interpolationRegex);
              for (let i2 = 0; i2 < components.length; i2++, startSourceSpan = endSourceSpan) {
                const value = components[i2];
                if (i2 % 2 === 0) {
                  endSourceSpan = startSourceSpan.moveBy(value.length);
                  if (value.length > 0) {
                    node.insertChildBefore(child, {
                      type: "text",
                      value,
                      sourceSpan: new ParseSourceSpan(startSourceSpan, endSourceSpan)
                    });
                  }
                  continue;
                }
                endSourceSpan = startSourceSpan.moveBy(value.length + 4);
                node.insertChildBefore(child, {
                  type: "interpolation",
                  sourceSpan: new ParseSourceSpan(startSourceSpan, endSourceSpan),
                  children: value.length === 0 ? [] : [{
                    type: "text",
                    value,
                    sourceSpan: new ParseSourceSpan(startSourceSpan.moveBy(2), endSourceSpan.moveBy(-2))
                  }]
                });
              }
              node.removeChild(child);
            }
          });
        }
        function extractWhitespaces(ast) {
          ast.walk((node) => {
            if (!node.children) {
              return;
            }
            if (node.children.length === 0 || node.children.length === 1 && node.children[0].type === "text" && htmlTrim(node.children[0].value).length === 0) {
              node.hasDanglingSpaces = node.children.length > 0;
              node.children = [];
              return;
            }
            const isWhitespaceSensitive = isWhitespaceSensitiveNode(node);
            const isIndentationSensitive = isIndentationSensitiveNode(node);
            if (!isWhitespaceSensitive) {
              for (let i2 = 0; i2 < node.children.length; i2++) {
                const child = node.children[i2];
                if (child.type !== "text") {
                  continue;
                }
                const {
                  leadingWhitespace,
                  text,
                  trailingWhitespace
                } = getLeadingAndTrailingHtmlWhitespace(child.value);
                const prevChild = child.prev;
                const nextChild = child.next;
                if (!text) {
                  node.removeChild(child);
                  i2--;
                  if (leadingWhitespace || trailingWhitespace) {
                    if (prevChild) {
                      prevChild.hasTrailingSpaces = true;
                    }
                    if (nextChild) {
                      nextChild.hasLeadingSpaces = true;
                    }
                  }
                } else {
                  child.value = text;
                  child.sourceSpan = new ParseSourceSpan(child.sourceSpan.start.moveBy(leadingWhitespace.length), child.sourceSpan.end.moveBy(-trailingWhitespace.length));
                  if (leadingWhitespace) {
                    if (prevChild) {
                      prevChild.hasTrailingSpaces = true;
                    }
                    child.hasLeadingSpaces = true;
                  }
                  if (trailingWhitespace) {
                    child.hasTrailingSpaces = true;
                    if (nextChild) {
                      nextChild.hasLeadingSpaces = true;
                    }
                  }
                }
              }
            }
            node.isWhitespaceSensitive = isWhitespaceSensitive;
            node.isIndentationSensitive = isIndentationSensitive;
          });
        }
        function addIsSelfClosing(ast) {
          ast.walk((node) => {
            node.isSelfClosing = !node.children || node.type === "element" && (node.tagDefinition.isVoid || node.startSourceSpan === node.endSourceSpan);
          });
        }
        function addHasHtmComponentClosingTag(ast, options) {
          ast.walk((node) => {
            if (node.type !== "element") {
              return;
            }
            node.hasHtmComponentClosingTag = node.endSourceSpan && /^<\s*\/\s*\/\s*>$/.test(options.originalText.slice(node.endSourceSpan.start.offset, node.endSourceSpan.end.offset));
          });
        }
        function addCssDisplay(ast, options) {
          ast.walk((node) => {
            node.cssDisplay = getNodeCssStyleDisplay(node, options);
          });
        }
        function addIsSpaceSensitive(ast, options) {
          ast.walk((node) => {
            const {
              children
            } = node;
            if (!children) {
              return;
            }
            if (children.length === 0) {
              node.isDanglingSpaceSensitive = isDanglingSpaceSensitiveNode(node);
              return;
            }
            for (const child of children) {
              child.isLeadingSpaceSensitive = isLeadingSpaceSensitiveNode(child, options);
              child.isTrailingSpaceSensitive = isTrailingSpaceSensitiveNode(child, options);
            }
            for (let index = 0; index < children.length; index++) {
              const child = children[index];
              child.isLeadingSpaceSensitive = index === 0 ? child.isLeadingSpaceSensitive : child.prev.isTrailingSpaceSensitive && child.isLeadingSpaceSensitive;
              child.isTrailingSpaceSensitive = index === children.length - 1 ? child.isTrailingSpaceSensitive : child.next.isLeadingSpaceSensitive && child.isTrailingSpaceSensitive;
            }
          });
        }
        function markTsScript(ast, options) {
          if (options.parser === "vue") {
            const vueScriptTag = ast.children.find((child) => isVueScriptTag(child, options));
            if (!vueScriptTag) {
              return;
            }
            const {
              lang
            } = vueScriptTag.attrMap;
            if (lang === "ts" || lang === "typescript") {
              options.__should_parse_vue_template_with_ts = true;
            }
          }
        }
        module22.exports = preprocess;
      }
    });
    var require_pragma5 = __commonJS22({
      "src/language-html/pragma.js"(exports2, module22) {
        "use strict";
        function hasPragma(text) {
          return /^\s*<!--\s*@(?:format|prettier)\s*-->/.test(text);
        }
        function insertPragma(text) {
          return "<!-- @format -->\n\n" + text.replace(/^\s*\n/, "");
        }
        module22.exports = {
          hasPragma,
          insertPragma
        };
      }
    });
    var require_loc6 = __commonJS22({
      "src/language-html/loc.js"(exports2, module22) {
        "use strict";
        function locStart(node) {
          return node.sourceSpan.start.offset;
        }
        function locEnd(node) {
          return node.sourceSpan.end.offset;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_tag = __commonJS22({
      "src/language-html/print/tag.js"(exports2, module22) {
        "use strict";
        var assert = require("assert");
        var {
          isNonEmptyArray
        } = require_util();
        var {
          builders: {
            indent,
            join,
            line,
            softline,
            hardline
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          locStart,
          locEnd
        } = require_loc6();
        var {
          isTextLikeNode,
          getLastDescendant,
          isPreLikeNode,
          hasPrettierIgnore,
          shouldPreserveContent,
          isVueSfcBlock
        } = require_utils112();
        function printClosingTag(node, options) {
          return [node.isSelfClosing ? "" : printClosingTagStart(node, options), printClosingTagEnd(node, options)];
        }
        function printClosingTagStart(node, options) {
          return node.lastChild && needsToBorrowParentClosingTagStartMarker(node.lastChild) ? "" : [printClosingTagPrefix(node, options), printClosingTagStartMarker(node, options)];
        }
        function printClosingTagEnd(node, options) {
          return (node.next ? needsToBorrowPrevClosingTagEndMarker(node.next) : needsToBorrowLastChildClosingTagEndMarker(node.parent)) ? "" : [printClosingTagEndMarker(node, options), printClosingTagSuffix(node, options)];
        }
        function printClosingTagPrefix(node, options) {
          return needsToBorrowLastChildClosingTagEndMarker(node) ? printClosingTagEndMarker(node.lastChild, options) : "";
        }
        function printClosingTagSuffix(node, options) {
          return needsToBorrowParentClosingTagStartMarker(node) ? printClosingTagStartMarker(node.parent, options) : needsToBorrowNextOpeningTagStartMarker(node) ? printOpeningTagStartMarker(node.next) : "";
        }
        function printClosingTagStartMarker(node, options) {
          assert(!node.isSelfClosing);
          if (shouldNotPrintClosingTag(node, options)) {
            return "";
          }
          switch (node.type) {
            case "ieConditionalComment":
              return "<!";
            case "element":
              if (node.hasHtmComponentClosingTag) {
                return "<//";
              }
            default:
              return `</${node.rawName}`;
          }
        }
        function printClosingTagEndMarker(node, options) {
          if (shouldNotPrintClosingTag(node, options)) {
            return "";
          }
          switch (node.type) {
            case "ieConditionalComment":
            case "ieConditionalEndComment":
              return "[endif]-->";
            case "ieConditionalStartComment":
              return "]><!-->";
            case "interpolation":
              return "}}";
            case "element":
              if (node.isSelfClosing) {
                return "/>";
              }
            default:
              return ">";
          }
        }
        function shouldNotPrintClosingTag(node, options) {
          return !node.isSelfClosing && !node.endSourceSpan && (hasPrettierIgnore(node) || shouldPreserveContent(node.parent, options));
        }
        function needsToBorrowPrevClosingTagEndMarker(node) {
          return node.prev && node.prev.type !== "docType" && !isTextLikeNode(node.prev) && node.isLeadingSpaceSensitive && !node.hasLeadingSpaces;
        }
        function needsToBorrowLastChildClosingTagEndMarker(node) {
          return node.lastChild && node.lastChild.isTrailingSpaceSensitive && !node.lastChild.hasTrailingSpaces && !isTextLikeNode(getLastDescendant(node.lastChild)) && !isPreLikeNode(node);
        }
        function needsToBorrowParentClosingTagStartMarker(node) {
          return !node.next && !node.hasTrailingSpaces && node.isTrailingSpaceSensitive && isTextLikeNode(getLastDescendant(node));
        }
        function needsToBorrowNextOpeningTagStartMarker(node) {
          return node.next && !isTextLikeNode(node.next) && isTextLikeNode(node) && node.isTrailingSpaceSensitive && !node.hasTrailingSpaces;
        }
        function getPrettierIgnoreAttributeCommentData(value) {
          const match = value.trim().match(/^prettier-ignore-attribute(?:\s+(.+))?$/s);
          if (!match) {
            return false;
          }
          if (!match[1]) {
            return true;
          }
          return match[1].split(/\s+/);
        }
        function needsToBorrowParentOpeningTagEndMarker(node) {
          return !node.prev && node.isLeadingSpaceSensitive && !node.hasLeadingSpaces;
        }
        function printAttributes(path4, options, print) {
          const node = path4.getValue();
          if (!isNonEmptyArray(node.attrs)) {
            return node.isSelfClosing ? " " : "";
          }
          const ignoreAttributeData = node.prev && node.prev.type === "comment" && getPrettierIgnoreAttributeCommentData(node.prev.value);
          const hasPrettierIgnoreAttribute = typeof ignoreAttributeData === "boolean" ? () => ignoreAttributeData : Array.isArray(ignoreAttributeData) ? (attribute) => ignoreAttributeData.includes(attribute.rawName) : () => false;
          const printedAttributes = path4.map((attributePath) => {
            const attribute = attributePath.getValue();
            return hasPrettierIgnoreAttribute(attribute) ? replaceTextEndOfLine(options.originalText.slice(locStart(attribute), locEnd(attribute))) : print();
          }, "attrs");
          const forceNotToBreakAttrContent = node.type === "element" && node.fullName === "script" && node.attrs.length === 1 && node.attrs[0].fullName === "src" && node.children.length === 0;
          const shouldPrintAttributePerLine = options.singleAttributePerLine && node.attrs.length > 1 && !isVueSfcBlock(node, options);
          const attributeLine = shouldPrintAttributePerLine ? hardline : line;
          const parts = [indent([forceNotToBreakAttrContent ? " " : line, join(attributeLine, printedAttributes)])];
          if (node.firstChild && needsToBorrowParentOpeningTagEndMarker(node.firstChild) || node.isSelfClosing && needsToBorrowLastChildClosingTagEndMarker(node.parent) || forceNotToBreakAttrContent) {
            parts.push(node.isSelfClosing ? " " : "");
          } else {
            parts.push(options.bracketSameLine ? node.isSelfClosing ? " " : "" : node.isSelfClosing ? line : softline);
          }
          return parts;
        }
        function printOpeningTagEnd(node) {
          return node.firstChild && needsToBorrowParentOpeningTagEndMarker(node.firstChild) ? "" : printOpeningTagEndMarker(node);
        }
        function printOpeningTag(path4, options, print) {
          const node = path4.getValue();
          return [printOpeningTagStart(node, options), printAttributes(path4, options, print), node.isSelfClosing ? "" : printOpeningTagEnd(node)];
        }
        function printOpeningTagStart(node, options) {
          return node.prev && needsToBorrowNextOpeningTagStartMarker(node.prev) ? "" : [printOpeningTagPrefix(node, options), printOpeningTagStartMarker(node)];
        }
        function printOpeningTagPrefix(node, options) {
          return needsToBorrowParentOpeningTagEndMarker(node) ? printOpeningTagEndMarker(node.parent) : needsToBorrowPrevClosingTagEndMarker(node) ? printClosingTagEndMarker(node.prev, options) : "";
        }
        function printOpeningTagStartMarker(node) {
          switch (node.type) {
            case "ieConditionalComment":
            case "ieConditionalStartComment":
              return `<!--[if ${node.condition}`;
            case "ieConditionalEndComment":
              return "<!--<!";
            case "interpolation":
              return "{{";
            case "docType":
              return "<!DOCTYPE";
            case "element":
              if (node.condition) {
                return `<!--[if ${node.condition}]><!--><${node.rawName}`;
              }
            default:
              return `<${node.rawName}`;
          }
        }
        function printOpeningTagEndMarker(node) {
          assert(!node.isSelfClosing);
          switch (node.type) {
            case "ieConditionalComment":
              return "]>";
            case "element":
              if (node.condition) {
                return "><!--<![endif]-->";
              }
            default:
              return ">";
          }
        }
        module22.exports = {
          printClosingTag,
          printClosingTagStart,
          printClosingTagStartMarker,
          printClosingTagEndMarker,
          printClosingTagSuffix,
          printClosingTagEnd,
          needsToBorrowLastChildClosingTagEndMarker,
          needsToBorrowParentClosingTagStartMarker,
          needsToBorrowPrevClosingTagEndMarker,
          printOpeningTag,
          printOpeningTagStart,
          printOpeningTagPrefix,
          printOpeningTagStartMarker,
          printOpeningTagEndMarker,
          needsToBorrowNextOpeningTagStartMarker,
          needsToBorrowParentOpeningTagEndMarker
        };
      }
    });
    var require_parse_srcset = __commonJS22({
      "node_modules/parse-srcset/src/parse-srcset.js"(exports2, module22) {
        (function(root, factory) {
          if (typeof define === "function" && define.amd) {
            define([], factory);
          } else if (typeof module22 === "object" && module22.exports) {
            module22.exports = factory();
          } else {
            root.parseSrcset = factory();
          }
        })(exports2, function() {
          return function(input, options) {
            var logger = options && options.logger || console;
            function isSpace(c2) {
              return c2 === " " || c2 === "	" || c2 === "\n" || c2 === "\f" || c2 === "\r";
            }
            function collectCharacters(regEx) {
              var chars, match = regEx.exec(input.substring(pos));
              if (match) {
                chars = match[0];
                pos += chars.length;
                return chars;
              }
            }
            var inputLength = input.length, regexLeadingSpaces = /^[ \t\n\r\u000c]+/, regexLeadingCommasOrSpaces = /^[, \t\n\r\u000c]+/, regexLeadingNotSpaces = /^[^ \t\n\r\u000c]+/, regexTrailingCommas = /[,]+$/, regexNonNegativeInteger = /^\d+$/, regexFloatingPoint = /^-?(?:[0-9]+|[0-9]*\.[0-9]+)(?:[eE][+-]?[0-9]+)?$/, url, descriptors, currentDescriptor, state, c, pos = 0, candidates = [];
            while (true) {
              collectCharacters(regexLeadingCommasOrSpaces);
              if (pos >= inputLength) {
                return candidates;
              }
              url = collectCharacters(regexLeadingNotSpaces);
              descriptors = [];
              if (url.slice(-1) === ",") {
                url = url.replace(regexTrailingCommas, "");
                parseDescriptors();
              } else {
                tokenize();
              }
            }
            function tokenize() {
              collectCharacters(regexLeadingSpaces);
              currentDescriptor = "";
              state = "in descriptor";
              while (true) {
                c = input.charAt(pos);
                if (state === "in descriptor") {
                  if (isSpace(c)) {
                    if (currentDescriptor) {
                      descriptors.push(currentDescriptor);
                      currentDescriptor = "";
                      state = "after descriptor";
                    }
                  } else if (c === ",") {
                    pos += 1;
                    if (currentDescriptor) {
                      descriptors.push(currentDescriptor);
                    }
                    parseDescriptors();
                    return;
                  } else if (c === "(") {
                    currentDescriptor = currentDescriptor + c;
                    state = "in parens";
                  } else if (c === "") {
                    if (currentDescriptor) {
                      descriptors.push(currentDescriptor);
                    }
                    parseDescriptors();
                    return;
                  } else {
                    currentDescriptor = currentDescriptor + c;
                  }
                } else if (state === "in parens") {
                  if (c === ")") {
                    currentDescriptor = currentDescriptor + c;
                    state = "in descriptor";
                  } else if (c === "") {
                    descriptors.push(currentDescriptor);
                    parseDescriptors();
                    return;
                  } else {
                    currentDescriptor = currentDescriptor + c;
                  }
                } else if (state === "after descriptor") {
                  if (isSpace(c)) {
                  } else if (c === "") {
                    parseDescriptors();
                    return;
                  } else {
                    state = "in descriptor";
                    pos -= 1;
                  }
                }
                pos += 1;
              }
            }
            function parseDescriptors() {
              var pError = false, w, d, h2, i2, candidate = {}, desc, lastChar, value, intVal, floatVal;
              for (i2 = 0; i2 < descriptors.length; i2++) {
                desc = descriptors[i2];
                lastChar = desc[desc.length - 1];
                value = desc.substring(0, desc.length - 1);
                intVal = parseInt(value, 10);
                floatVal = parseFloat(value);
                if (regexNonNegativeInteger.test(value) && lastChar === "w") {
                  if (w || d) {
                    pError = true;
                  }
                  if (intVal === 0) {
                    pError = true;
                  } else {
                    w = intVal;
                  }
                } else if (regexFloatingPoint.test(value) && lastChar === "x") {
                  if (w || d || h2) {
                    pError = true;
                  }
                  if (floatVal < 0) {
                    pError = true;
                  } else {
                    d = floatVal;
                  }
                } else if (regexNonNegativeInteger.test(value) && lastChar === "h") {
                  if (h2 || d) {
                    pError = true;
                  }
                  if (intVal === 0) {
                    pError = true;
                  } else {
                    h2 = intVal;
                  }
                } else {
                  pError = true;
                }
              }
              if (!pError) {
                candidate.url = url;
                if (w) {
                  candidate.w = w;
                }
                if (d) {
                  candidate.d = d;
                }
                if (h2) {
                  candidate.h = h2;
                }
                candidates.push(candidate);
              } else if (logger && logger.error) {
                logger.error("Invalid srcset descriptor found in '" + input + "' at '" + desc + "'.");
              }
            }
          };
        });
      }
    });
    var require_syntax_attribute = __commonJS22({
      "src/language-html/syntax-attribute.js"(exports2, module22) {
        "use strict";
        var parseSrcset = require_parse_srcset();
        var {
          builders: {
            ifBreak,
            join,
            line
          }
        } = require_doc();
        function printImgSrcset(value) {
          const srcset = parseSrcset(value, {
            logger: {
              error(message) {
                throw new Error(message);
              }
            }
          });
          const hasW = srcset.some(({
            w
          }) => w);
          const hasH = srcset.some(({
            h: h2
          }) => h2);
          const hasX = srcset.some(({
            d
          }) => d);
          if (hasW + hasH + hasX > 1) {
            throw new Error("Mixed descriptor in srcset is not supported");
          }
          const key = hasW ? "w" : hasH ? "h" : "d";
          const unit = hasW ? "w" : hasH ? "h" : "x";
          const getMax = (values) => Math.max(...values);
          const urls = srcset.map((src) => src.url);
          const maxUrlLength = getMax(urls.map((url) => url.length));
          const descriptors = srcset.map((src) => src[key]).map((descriptor) => descriptor ? descriptor.toString() : "");
          const descriptorLeftLengths = descriptors.map((descriptor) => {
            const index = descriptor.indexOf(".");
            return index === -1 ? descriptor.length : index;
          });
          const maxDescriptorLeftLength = getMax(descriptorLeftLengths);
          return join([",", line], urls.map((url, index) => {
            const parts = [url];
            const descriptor = descriptors[index];
            if (descriptor) {
              const urlPadding = maxUrlLength - url.length + 1;
              const descriptorPadding = maxDescriptorLeftLength - descriptorLeftLengths[index];
              const alignment = " ".repeat(urlPadding + descriptorPadding);
              parts.push(ifBreak(alignment, " "), descriptor + unit);
            }
            return parts;
          }));
        }
        function printClassNames(value) {
          return value.trim().split(/\s+/).join(" ");
        }
        module22.exports = {
          printImgSrcset,
          printClassNames
        };
      }
    });
    var require_syntax_vue = __commonJS22({
      "src/language-html/syntax-vue.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            group
          }
        } = require_doc();
        function printVueFor(value, textToDoc) {
          const {
            left,
            operator,
            right
          } = parseVueFor(value);
          return [group(textToDoc(`function _(${left}) {}`, {
            parser: "babel",
            __isVueForBindingLeft: true
          })), " ", operator, " ", textToDoc(right, {
            parser: "__js_expression"
          }, {
            stripTrailingHardline: true
          })];
        }
        function parseVueFor(value) {
          const forAliasRE = /(.*?)\s+(in|of)\s+(.*)/s;
          const forIteratorRE = /,([^,\]}]*)(?:,([^,\]}]*))?$/;
          const stripParensRE = /^\(|\)$/g;
          const inMatch = value.match(forAliasRE);
          if (!inMatch) {
            return;
          }
          const res = {};
          res.for = inMatch[3].trim();
          if (!res.for) {
            return;
          }
          const alias = inMatch[1].trim().replace(stripParensRE, "");
          const iteratorMatch = alias.match(forIteratorRE);
          if (iteratorMatch) {
            res.alias = alias.replace(forIteratorRE, "");
            res.iterator1 = iteratorMatch[1].trim();
            if (iteratorMatch[2]) {
              res.iterator2 = iteratorMatch[2].trim();
            }
          } else {
            res.alias = alias;
          }
          const left = [res.alias, res.iterator1, res.iterator2];
          if (left.some((part, index) => !part && (index === 0 || left.slice(index + 1).some(Boolean)))) {
            return;
          }
          return {
            left: left.filter(Boolean).join(","),
            operator: inMatch[2],
            right: res.for
          };
        }
        function printVueBindings(value, textToDoc) {
          return textToDoc(`function _(${value}) {}`, {
            parser: "babel",
            __isVueBindings: true
          });
        }
        function isVueEventBindingExpression(eventBindingValue) {
          const fnExpRE = /^(?:[\w$]+|\([^)]*\))\s*=>|^function\s*\(/;
          const simplePathRE = /^[$A-Z_a-z][\w$]*(?:\.[$A-Z_a-z][\w$]*|\['[^']*']|\["[^"]*"]|\[\d+]|\[[$A-Z_a-z][\w$]*])*$/;
          const value = eventBindingValue.trim();
          return fnExpRE.test(value) || simplePathRE.test(value);
        }
        module22.exports = {
          isVueEventBindingExpression,
          printVueFor,
          printVueBindings
        };
      }
    });
    var require_get_node_content = __commonJS22({
      "src/language-html/get-node-content.js"(exports2, module22) {
        "use strict";
        var {
          needsToBorrowParentClosingTagStartMarker,
          printClosingTagStartMarker,
          needsToBorrowLastChildClosingTagEndMarker,
          printClosingTagEndMarker,
          needsToBorrowParentOpeningTagEndMarker,
          printOpeningTagEndMarker
        } = require_tag();
        function getNodeContent(node, options) {
          let start = node.startSourceSpan.end.offset;
          if (node.firstChild && needsToBorrowParentOpeningTagEndMarker(node.firstChild)) {
            start -= printOpeningTagEndMarker(node).length;
          }
          let end = node.endSourceSpan.start.offset;
          if (node.lastChild && needsToBorrowParentClosingTagStartMarker(node.lastChild)) {
            end += printClosingTagStartMarker(node, options).length;
          } else if (needsToBorrowLastChildClosingTagEndMarker(node)) {
            end -= printClosingTagEndMarker(node.lastChild, options).length;
          }
          return options.originalText.slice(start, end);
        }
        module22.exports = getNodeContent;
      }
    });
    var require_embed4 = __commonJS22({
      "src/language-html/embed.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            breakParent,
            group,
            hardline,
            indent,
            line,
            fill,
            softline
          },
          utils: {
            mapDoc,
            replaceTextEndOfLine
          }
        } = require_doc();
        var printFrontMatter = require_print();
        var {
          printClosingTag,
          printClosingTagSuffix,
          needsToBorrowPrevClosingTagEndMarker,
          printOpeningTagPrefix,
          printOpeningTag
        } = require_tag();
        var {
          printImgSrcset,
          printClassNames
        } = require_syntax_attribute();
        var {
          printVueFor,
          printVueBindings,
          isVueEventBindingExpression
        } = require_syntax_vue();
        var {
          isScriptLikeTag,
          isVueNonHtmlBlock,
          inferScriptParser,
          htmlTrimPreserveIndentation,
          dedentString,
          unescapeQuoteEntities,
          isVueSlotAttribute,
          isVueSfcBindingsAttribute,
          getTextValueParts
        } = require_utils112();
        var getNodeContent = require_get_node_content();
        function printEmbeddedAttributeValue(node, htmlTextToDoc, options) {
          const isKeyMatched = (patterns) => new RegExp(patterns.join("|")).test(node.fullName);
          const getValue = () => unescapeQuoteEntities(node.value);
          let shouldHug = false;
          const __onHtmlBindingRoot = (root, options2) => {
            const rootNode = root.type === "NGRoot" ? root.node.type === "NGMicrosyntax" && root.node.body.length === 1 && root.node.body[0].type === "NGMicrosyntaxExpression" ? root.node.body[0].expression : root.node : root.type === "JsExpressionRoot" ? root.node : root;
            if (rootNode && (rootNode.type === "ObjectExpression" || rootNode.type === "ArrayExpression" || options2.parser === "__vue_expression" && (rootNode.type === "TemplateLiteral" || rootNode.type === "StringLiteral"))) {
              shouldHug = true;
            }
          };
          const printHug = (doc2) => group(doc2);
          const printExpand = (doc2, canHaveTrailingWhitespace = true) => group([indent([softline, doc2]), canHaveTrailingWhitespace ? softline : ""]);
          const printMaybeHug = (doc2) => shouldHug ? printHug(doc2) : printExpand(doc2);
          const attributeTextToDoc = (code, opts) => htmlTextToDoc(code, Object.assign({
            __onHtmlBindingRoot,
            __embeddedInHtml: true
          }, opts));
          if (node.fullName === "srcset" && (node.parent.fullName === "img" || node.parent.fullName === "source")) {
            return printExpand(printImgSrcset(getValue()));
          }
          if (node.fullName === "class" && !options.parentParser) {
            const value = getValue();
            if (!value.includes("{{")) {
              return printClassNames(value);
            }
          }
          if (node.fullName === "style" && !options.parentParser) {
            const value = getValue();
            if (!value.includes("{{")) {
              return printExpand(attributeTextToDoc(value, {
                parser: "css",
                __isHTMLStyleAttribute: true
              }));
            }
          }
          if (options.parser === "vue") {
            if (node.fullName === "v-for") {
              return printVueFor(getValue(), attributeTextToDoc);
            }
            if (isVueSlotAttribute(node) || isVueSfcBindingsAttribute(node, options)) {
              return printVueBindings(getValue(), attributeTextToDoc);
            }
            const vueEventBindingPatterns = ["^@", "^v-on:"];
            const vueExpressionBindingPatterns = ["^:", "^v-bind:"];
            const jsExpressionBindingPatterns = ["^v-"];
            if (isKeyMatched(vueEventBindingPatterns)) {
              const value = getValue();
              const parser = isVueEventBindingExpression(value) ? "__js_expression" : options.__should_parse_vue_template_with_ts ? "__vue_ts_event_binding" : "__vue_event_binding";
              return printMaybeHug(attributeTextToDoc(value, {
                parser
              }));
            }
            if (isKeyMatched(vueExpressionBindingPatterns)) {
              return printMaybeHug(attributeTextToDoc(getValue(), {
                parser: "__vue_expression"
              }));
            }
            if (isKeyMatched(jsExpressionBindingPatterns)) {
              return printMaybeHug(attributeTextToDoc(getValue(), {
                parser: "__js_expression"
              }));
            }
          }
          if (options.parser === "angular") {
            const ngTextToDoc = (code, opts) => attributeTextToDoc(code, Object.assign(Object.assign({}, opts), {}, {
              trailingComma: "none"
            }));
            const ngDirectiveBindingPatterns = ["^\\*"];
            const ngStatementBindingPatterns = ["^\\(.+\\)$", "^on-"];
            const ngExpressionBindingPatterns = ["^\\[.+\\]$", "^bind(on)?-", "^ng-(if|show|hide|class|style)$"];
            const ngI18nPatterns = ["^i18n(-.+)?$"];
            if (isKeyMatched(ngStatementBindingPatterns)) {
              return printMaybeHug(ngTextToDoc(getValue(), {
                parser: "__ng_action"
              }));
            }
            if (isKeyMatched(ngExpressionBindingPatterns)) {
              return printMaybeHug(ngTextToDoc(getValue(), {
                parser: "__ng_binding"
              }));
            }
            if (isKeyMatched(ngI18nPatterns)) {
              const value2 = getValue().trim();
              return printExpand(fill(getTextValueParts(node, value2)), !value2.includes("@@"));
            }
            if (isKeyMatched(ngDirectiveBindingPatterns)) {
              return printMaybeHug(ngTextToDoc(getValue(), {
                parser: "__ng_directive"
              }));
            }
            const interpolationRegex = /{{(.+?)}}/s;
            const value = getValue();
            if (interpolationRegex.test(value)) {
              const parts = [];
              for (const [index, part] of value.split(interpolationRegex).entries()) {
                if (index % 2 === 0) {
                  parts.push(replaceTextEndOfLine(part));
                } else {
                  try {
                    parts.push(group(["{{", indent([line, ngTextToDoc(part, {
                      parser: "__ng_interpolation",
                      __isInHtmlInterpolation: true
                    })]), line, "}}"]));
                  } catch {
                    parts.push("{{", replaceTextEndOfLine(part), "}}");
                  }
                }
              }
              return group(parts);
            }
          }
          return null;
        }
        function embed(path4, print, textToDoc, options) {
          const node = path4.getValue();
          switch (node.type) {
            case "element": {
              if (isScriptLikeTag(node) || node.type === "interpolation") {
                return;
              }
              if (!node.isSelfClosing && isVueNonHtmlBlock(node, options)) {
                const parser = inferScriptParser(node, options);
                if (!parser) {
                  return;
                }
                const content = getNodeContent(node, options);
                let isEmpty = /^\s*$/.test(content);
                let doc2 = "";
                if (!isEmpty) {
                  doc2 = textToDoc(htmlTrimPreserveIndentation(content), {
                    parser,
                    __embeddedInHtml: true
                  }, {
                    stripTrailingHardline: true
                  });
                  isEmpty = doc2 === "";
                }
                return [printOpeningTagPrefix(node, options), group(printOpeningTag(path4, options, print)), isEmpty ? "" : hardline, doc2, isEmpty ? "" : hardline, printClosingTag(node, options), printClosingTagSuffix(node, options)];
              }
              break;
            }
            case "text": {
              if (isScriptLikeTag(node.parent)) {
                const parser = inferScriptParser(node.parent, options);
                if (parser) {
                  const value = parser === "markdown" ? dedentString(node.value.replace(/^[^\S\n]*\n/, "")) : node.value;
                  const textToDocOptions = {
                    parser,
                    __embeddedInHtml: true
                  };
                  if (options.parser === "html" && parser === "babel") {
                    let sourceType = "script";
                    const {
                      attrMap
                    } = node.parent;
                    if (attrMap && (attrMap.type === "module" || attrMap.type === "text/babel" && attrMap["data-type"] === "module")) {
                      sourceType = "module";
                    }
                    textToDocOptions.__babelSourceType = sourceType;
                  }
                  return [breakParent, printOpeningTagPrefix(node, options), textToDoc(value, textToDocOptions, {
                    stripTrailingHardline: true
                  }), printClosingTagSuffix(node, options)];
                }
              } else if (node.parent.type === "interpolation") {
                const textToDocOptions = {
                  __isInHtmlInterpolation: true,
                  __embeddedInHtml: true
                };
                if (options.parser === "angular") {
                  textToDocOptions.parser = "__ng_interpolation";
                  textToDocOptions.trailingComma = "none";
                } else if (options.parser === "vue") {
                  textToDocOptions.parser = options.__should_parse_vue_template_with_ts ? "__vue_ts_expression" : "__vue_expression";
                } else {
                  textToDocOptions.parser = "__js_expression";
                }
                return [indent([line, textToDoc(node.value, textToDocOptions, {
                  stripTrailingHardline: true
                })]), node.parent.next && needsToBorrowPrevClosingTagEndMarker(node.parent.next) ? " " : line];
              }
              break;
            }
            case "attribute": {
              if (!node.value) {
                break;
              }
              if (/^PRETTIER_HTML_PLACEHOLDER_\d+_\d+_IN_JS$/.test(options.originalText.slice(node.valueSpan.start.offset, node.valueSpan.end.offset))) {
                return [node.rawName, "=", node.value];
              }
              if (options.parser === "lwc") {
                const interpolationRegex = /^{.*}$/s;
                if (interpolationRegex.test(options.originalText.slice(node.valueSpan.start.offset, node.valueSpan.end.offset))) {
                  return [node.rawName, "=", node.value];
                }
              }
              const embeddedAttributeValueDoc = printEmbeddedAttributeValue(node, (code, opts) => textToDoc(code, Object.assign({
                __isInHtmlAttribute: true,
                __embeddedInHtml: true
              }, opts), {
                stripTrailingHardline: true
              }), options);
              if (embeddedAttributeValueDoc) {
                return [node.rawName, '="', group(mapDoc(embeddedAttributeValueDoc, (doc2) => typeof doc2 === "string" ? doc2.replace(/"/g, "&quot;") : doc2)), '"'];
              }
              break;
            }
            case "front-matter":
              return printFrontMatter(node, textToDoc);
          }
        }
        module22.exports = embed;
      }
    });
    var require_children = __commonJS22({
      "src/language-html/print/children.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            breakParent,
            group,
            ifBreak,
            line,
            softline,
            hardline
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          locStart,
          locEnd
        } = require_loc6();
        var {
          forceBreakChildren,
          forceNextEmptyLine,
          isTextLikeNode,
          hasPrettierIgnore,
          preferHardlineAsLeadingSpaces
        } = require_utils112();
        var {
          printOpeningTagPrefix,
          needsToBorrowNextOpeningTagStartMarker,
          printOpeningTagStartMarker,
          needsToBorrowPrevClosingTagEndMarker,
          printClosingTagEndMarker,
          printClosingTagSuffix,
          needsToBorrowParentClosingTagStartMarker
        } = require_tag();
        function printChild(childPath, options, print) {
          const child = childPath.getValue();
          if (hasPrettierIgnore(child)) {
            return [printOpeningTagPrefix(child, options), ...replaceTextEndOfLine(options.originalText.slice(locStart(child) + (child.prev && needsToBorrowNextOpeningTagStartMarker(child.prev) ? printOpeningTagStartMarker(child).length : 0), locEnd(child) - (child.next && needsToBorrowPrevClosingTagEndMarker(child.next) ? printClosingTagEndMarker(child, options).length : 0))), printClosingTagSuffix(child, options)];
          }
          return print();
        }
        function printBetweenLine(prevNode, nextNode) {
          return isTextLikeNode(prevNode) && isTextLikeNode(nextNode) ? prevNode.isTrailingSpaceSensitive ? prevNode.hasTrailingSpaces ? preferHardlineAsLeadingSpaces(nextNode) ? hardline : line : "" : preferHardlineAsLeadingSpaces(nextNode) ? hardline : softline : needsToBorrowNextOpeningTagStartMarker(prevNode) && (hasPrettierIgnore(nextNode) || nextNode.firstChild || nextNode.isSelfClosing || nextNode.type === "element" && nextNode.attrs.length > 0) || prevNode.type === "element" && prevNode.isSelfClosing && needsToBorrowPrevClosingTagEndMarker(nextNode) ? "" : !nextNode.isLeadingSpaceSensitive || preferHardlineAsLeadingSpaces(nextNode) || needsToBorrowPrevClosingTagEndMarker(nextNode) && prevNode.lastChild && needsToBorrowParentClosingTagStartMarker(prevNode.lastChild) && prevNode.lastChild.lastChild && needsToBorrowParentClosingTagStartMarker(prevNode.lastChild.lastChild) ? hardline : nextNode.hasLeadingSpaces ? line : softline;
        }
        function printChildren(path4, options, print) {
          const node = path4.getValue();
          if (forceBreakChildren(node)) {
            return [breakParent, ...path4.map((childPath) => {
              const childNode = childPath.getValue();
              const prevBetweenLine = !childNode.prev ? "" : printBetweenLine(childNode.prev, childNode);
              return [!prevBetweenLine ? "" : [prevBetweenLine, forceNextEmptyLine(childNode.prev) ? hardline : ""], printChild(childPath, options, print)];
            }, "children")];
          }
          const groupIds = node.children.map(() => Symbol(""));
          return path4.map((childPath, childIndex) => {
            const childNode = childPath.getValue();
            if (isTextLikeNode(childNode)) {
              if (childNode.prev && isTextLikeNode(childNode.prev)) {
                const prevBetweenLine2 = printBetweenLine(childNode.prev, childNode);
                if (prevBetweenLine2) {
                  if (forceNextEmptyLine(childNode.prev)) {
                    return [hardline, hardline, printChild(childPath, options, print)];
                  }
                  return [prevBetweenLine2, printChild(childPath, options, print)];
                }
              }
              return printChild(childPath, options, print);
            }
            const prevParts = [];
            const leadingParts = [];
            const trailingParts = [];
            const nextParts = [];
            const prevBetweenLine = childNode.prev ? printBetweenLine(childNode.prev, childNode) : "";
            const nextBetweenLine = childNode.next ? printBetweenLine(childNode, childNode.next) : "";
            if (prevBetweenLine) {
              if (forceNextEmptyLine(childNode.prev)) {
                prevParts.push(hardline, hardline);
              } else if (prevBetweenLine === hardline) {
                prevParts.push(hardline);
              } else {
                if (isTextLikeNode(childNode.prev)) {
                  leadingParts.push(prevBetweenLine);
                } else {
                  leadingParts.push(ifBreak("", softline, {
                    groupId: groupIds[childIndex - 1]
                  }));
                }
              }
            }
            if (nextBetweenLine) {
              if (forceNextEmptyLine(childNode)) {
                if (isTextLikeNode(childNode.next)) {
                  nextParts.push(hardline, hardline);
                }
              } else if (nextBetweenLine === hardline) {
                if (isTextLikeNode(childNode.next)) {
                  nextParts.push(hardline);
                }
              } else {
                trailingParts.push(nextBetweenLine);
              }
            }
            return [...prevParts, group([...leadingParts, group([printChild(childPath, options, print), ...trailingParts], {
              id: groupIds[childIndex]
            })]), ...nextParts];
          }, "children");
        }
        module22.exports = {
          printChildren
        };
      }
    });
    var require_element = __commonJS22({
      "src/language-html/print/element.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            breakParent,
            dedentToRoot,
            group,
            ifBreak,
            indentIfBreak,
            indent,
            line,
            softline
          },
          utils: {
            replaceTextEndOfLine
          }
        } = require_doc();
        var getNodeContent = require_get_node_content();
        var {
          shouldPreserveContent,
          isScriptLikeTag,
          isVueCustomBlock,
          countParents,
          forceBreakContent
        } = require_utils112();
        var {
          printOpeningTagPrefix,
          printOpeningTag,
          printClosingTagSuffix,
          printClosingTag,
          needsToBorrowPrevClosingTagEndMarker,
          needsToBorrowLastChildClosingTagEndMarker
        } = require_tag();
        var {
          printChildren
        } = require_children();
        function printElement(path4, options, print) {
          const node = path4.getValue();
          if (shouldPreserveContent(node, options)) {
            return [printOpeningTagPrefix(node, options), group(printOpeningTag(path4, options, print)), ...replaceTextEndOfLine(getNodeContent(node, options)), ...printClosingTag(node, options), printClosingTagSuffix(node, options)];
          }
          const shouldHugContent = node.children.length === 1 && node.firstChild.type === "interpolation" && node.firstChild.isLeadingSpaceSensitive && !node.firstChild.hasLeadingSpaces && node.lastChild.isTrailingSpaceSensitive && !node.lastChild.hasTrailingSpaces;
          const attrGroupId = Symbol("element-attr-group-id");
          const printTag = (doc2) => group([group(printOpeningTag(path4, options, print), {
            id: attrGroupId
          }), doc2, printClosingTag(node, options)]);
          const printChildrenDoc = (childrenDoc) => {
            if (shouldHugContent) {
              return indentIfBreak(childrenDoc, {
                groupId: attrGroupId
              });
            }
            if ((isScriptLikeTag(node) || isVueCustomBlock(node, options)) && node.parent.type === "root" && options.parser === "vue" && !options.vueIndentScriptAndStyle) {
              return childrenDoc;
            }
            return indent(childrenDoc);
          };
          const printLineBeforeChildren = () => {
            if (shouldHugContent) {
              return ifBreak(softline, "", {
                groupId: attrGroupId
              });
            }
            if (node.firstChild.hasLeadingSpaces && node.firstChild.isLeadingSpaceSensitive) {
              return line;
            }
            if (node.firstChild.type === "text" && node.isWhitespaceSensitive && node.isIndentationSensitive) {
              return dedentToRoot(softline);
            }
            return softline;
          };
          const printLineAfterChildren = () => {
            const needsToBorrow = node.next ? needsToBorrowPrevClosingTagEndMarker(node.next) : needsToBorrowLastChildClosingTagEndMarker(node.parent);
            if (needsToBorrow) {
              if (node.lastChild.hasTrailingSpaces && node.lastChild.isTrailingSpaceSensitive) {
                return " ";
              }
              return "";
            }
            if (shouldHugContent) {
              return ifBreak(softline, "", {
                groupId: attrGroupId
              });
            }
            if (node.lastChild.hasTrailingSpaces && node.lastChild.isTrailingSpaceSensitive) {
              return line;
            }
            if ((node.lastChild.type === "comment" || node.lastChild.type === "text" && node.isWhitespaceSensitive && node.isIndentationSensitive) && new RegExp(`\\n[\\t ]{${options.tabWidth * countParents(path4, (node2) => node2.parent && node2.parent.type !== "root")}}$`).test(node.lastChild.value)) {
              return "";
            }
            return softline;
          };
          if (node.children.length === 0) {
            return printTag(node.hasDanglingSpaces && node.isDanglingSpaceSensitive ? line : "");
          }
          return printTag([forceBreakContent(node) ? breakParent : "", printChildrenDoc([printLineBeforeChildren(), printChildren(path4, options, print)]), printLineAfterChildren()]);
        }
        module22.exports = {
          printElement
        };
      }
    });
    var require_printer_html = __commonJS22({
      "src/language-html/printer-html.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            fill,
            group,
            hardline,
            literalline
          },
          utils: {
            cleanDoc,
            getDocParts,
            isConcat,
            replaceTextEndOfLine
          }
        } = require_doc();
        var clean = require_clean5();
        var {
          countChars,
          unescapeQuoteEntities,
          getTextValueParts
        } = require_utils112();
        var preprocess = require_print_preprocess3();
        var {
          insertPragma
        } = require_pragma5();
        var {
          locStart,
          locEnd
        } = require_loc6();
        var embed = require_embed4();
        var {
          printClosingTagSuffix,
          printClosingTagEnd,
          printOpeningTagPrefix,
          printOpeningTagStart
        } = require_tag();
        var {
          printElement
        } = require_element();
        var {
          printChildren
        } = require_children();
        function genericPrint(path4, options, print) {
          const node = path4.getValue();
          switch (node.type) {
            case "front-matter":
              return replaceTextEndOfLine(node.raw);
            case "root":
              if (options.__onHtmlRoot) {
                options.__onHtmlRoot(node);
              }
              return [group(printChildren(path4, options, print)), hardline];
            case "element":
            case "ieConditionalComment": {
              return printElement(path4, options, print);
            }
            case "ieConditionalStartComment":
            case "ieConditionalEndComment":
              return [printOpeningTagStart(node), printClosingTagEnd(node)];
            case "interpolation":
              return [printOpeningTagStart(node, options), ...path4.map(print, "children"), printClosingTagEnd(node, options)];
            case "text": {
              if (node.parent.type === "interpolation") {
                const trailingNewlineRegex = /\n[^\S\n]*$/;
                const hasTrailingNewline = trailingNewlineRegex.test(node.value);
                const value = hasTrailingNewline ? node.value.replace(trailingNewlineRegex, "") : node.value;
                return [...replaceTextEndOfLine(value), hasTrailingNewline ? hardline : ""];
              }
              const printed = cleanDoc([printOpeningTagPrefix(node, options), ...getTextValueParts(node), printClosingTagSuffix(node, options)]);
              if (isConcat(printed) || printed.type === "fill") {
                return fill(getDocParts(printed));
              }
              return printed;
            }
            case "docType":
              return [group([printOpeningTagStart(node, options), " ", node.value.replace(/^html\b/i, "html").replace(/\s+/g, " ")]), printClosingTagEnd(node, options)];
            case "comment": {
              return [printOpeningTagPrefix(node, options), ...replaceTextEndOfLine(options.originalText.slice(locStart(node), locEnd(node)), literalline), printClosingTagSuffix(node, options)];
            }
            case "attribute": {
              if (node.value === null) {
                return node.rawName;
              }
              const value = unescapeQuoteEntities(node.value);
              const singleQuoteCount = countChars(value, "'");
              const doubleQuoteCount = countChars(value, '"');
              const quote = singleQuoteCount < doubleQuoteCount ? "'" : '"';
              return [node.rawName, "=", quote, ...replaceTextEndOfLine(quote === '"' ? value.replace(/"/g, "&quot;") : value.replace(/'/g, "&apos;")), quote];
            }
            default:
              throw new Error(`Unexpected node type ${node.type}`);
          }
        }
        module22.exports = {
          preprocess,
          print: genericPrint,
          insertPragma,
          massageAstNode: clean,
          embed
        };
      }
    });
    var require_options6 = __commonJS22({
      "src/language-html/options.js"(exports2, module22) {
        "use strict";
        var commonOptions = require_common_options();
        var CATEGORY_HTML = "HTML";
        module22.exports = {
          bracketSameLine: commonOptions.bracketSameLine,
          htmlWhitespaceSensitivity: {
            since: "1.15.0",
            category: CATEGORY_HTML,
            type: "choice",
            default: "css",
            description: "How to handle whitespaces in HTML.",
            choices: [{
              value: "css",
              description: "Respect the default value of CSS display property."
            }, {
              value: "strict",
              description: "Whitespaces are considered sensitive."
            }, {
              value: "ignore",
              description: "Whitespaces are considered insensitive."
            }]
          },
          singleAttributePerLine: commonOptions.singleAttributePerLine,
          vueIndentScriptAndStyle: {
            since: "1.19.0",
            category: CATEGORY_HTML,
            type: "boolean",
            default: false,
            description: "Indent script and style tags in Vue files."
          }
        };
      }
    });
    var require_parsers6 = __commonJS22({
      "src/language-html/parsers.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          get html() {
            return require_parser_html().parsers.html;
          },
          get vue() {
            return require_parser_html().parsers.vue;
          },
          get angular() {
            return require_parser_html().parsers.angular;
          },
          get lwc() {
            return require_parser_html().parsers.lwc;
          }
        };
      }
    });
    var require_HTML = __commonJS22({
      "node_modules/linguist-languages/data/HTML.json"(exports2, module22) {
        module22.exports = {
          name: "HTML",
          type: "markup",
          tmScope: "text.html.basic",
          aceMode: "html",
          codemirrorMode: "htmlmixed",
          codemirrorMimeType: "text/html",
          color: "#e34c26",
          aliases: ["xhtml"],
          extensions: [".html", ".hta", ".htm", ".html.hl", ".inc", ".xht", ".xhtml"],
          languageId: 146
        };
      }
    });
    var require_Vue = __commonJS22({
      "node_modules/linguist-languages/data/Vue.json"(exports2, module22) {
        module22.exports = {
          name: "Vue",
          type: "markup",
          color: "#41b883",
          extensions: [".vue"],
          tmScope: "text.html.vue",
          aceMode: "html",
          languageId: 391
        };
      }
    });
    var require_language_html = __commonJS22({
      "src/language-html/index.js"(exports2, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_html();
        var options = require_options6();
        var parsers = require_parsers6();
        var languages = [createLanguage(require_HTML(), () => ({
          name: "Angular",
          since: "1.15.0",
          parsers: ["angular"],
          vscodeLanguageIds: ["html"],
          extensions: [".component.html"],
          filenames: []
        })), createLanguage(require_HTML(), (data) => ({
          since: "1.15.0",
          parsers: ["html"],
          vscodeLanguageIds: ["html"],
          extensions: [...data.extensions, ".mjml"]
        })), createLanguage(require_HTML(), () => ({
          name: "Lightning Web Components",
          since: "1.17.0",
          parsers: ["lwc"],
          vscodeLanguageIds: ["html"],
          extensions: [],
          filenames: []
        })), createLanguage(require_Vue(), () => ({
          since: "1.10.0",
          parsers: ["vue"],
          vscodeLanguageIds: ["vue"]
        }))];
        var printers = {
          html: printer
        };
        module22.exports = {
          languages,
          printers,
          options,
          parsers
        };
      }
    });
    var require_pragma6 = __commonJS22({
      "src/language-yaml/pragma.js"(exports2, module22) {
        "use strict";
        function isPragma(text) {
          return /^\s*@(?:prettier|format)\s*$/.test(text);
        }
        function hasPragma(text) {
          return /^\s*#[^\S\n]*@(?:prettier|format)\s*?(?:\n|$)/.test(text);
        }
        function insertPragma(text) {
          return `# @format

${text}`;
        }
        module22.exports = {
          isPragma,
          hasPragma,
          insertPragma
        };
      }
    });
    var require_loc7 = __commonJS22({
      "src/language-yaml/loc.js"(exports2, module22) {
        "use strict";
        function locStart(node) {
          return node.position.start.offset;
        }
        function locEnd(node) {
          return node.position.end.offset;
        }
        module22.exports = {
          locStart,
          locEnd
        };
      }
    });
    var require_embed5 = __commonJS22({
      "src/language-yaml/embed.js"(exports2, module22) {
        "use strict";
        function embed(path4, print, textToDoc, options) {
          const node = path4.getValue();
          if (node.type === "root" && options.filepath && /(?:[/\\]|^)\.(?:prettier|stylelint)rc$/.test(options.filepath)) {
            return textToDoc(options.originalText, Object.assign(Object.assign({}, options), {}, {
              parser: "json"
            }));
          }
        }
        module22.exports = embed;
      }
    });
    var require_utils12 = __commonJS22({
      "src/language-yaml/utils.js"(exports2, module22) {
        "use strict";
        var {
          getLast,
          isNonEmptyArray
        } = require_util();
        function getAncestorCount(path4, filter) {
          let counter = 0;
          const pathStackLength = path4.stack.length - 1;
          for (let i2 = 0; i2 < pathStackLength; i2++) {
            const value = path4.stack[i2];
            if (isNode(value) && filter(value)) {
              counter++;
            }
          }
          return counter;
        }
        function isNode(value, types3) {
          return value && typeof value.type === "string" && (!types3 || types3.includes(value.type));
        }
        function mapNode(node, callback, parent) {
          return callback("children" in node ? Object.assign(Object.assign({}, node), {}, {
            children: node.children.map((childNode) => mapNode(childNode, callback, node))
          }) : node, parent);
        }
        function defineShortcut(x2, key, getter) {
          Object.defineProperty(x2, key, {
            get: getter,
            enumerable: false
          });
        }
        function isNextLineEmpty(node, text) {
          let newlineCount = 0;
          const textLength = text.length;
          for (let i2 = node.position.end.offset - 1; i2 < textLength; i2++) {
            const char = text[i2];
            if (char === "\n") {
              newlineCount++;
            }
            if (newlineCount === 1 && /\S/.test(char)) {
              return false;
            }
            if (newlineCount === 2) {
              return true;
            }
          }
          return false;
        }
        function isLastDescendantNode(path4) {
          const node = path4.getValue();
          switch (node.type) {
            case "tag":
            case "anchor":
            case "comment":
              return false;
          }
          const pathStackLength = path4.stack.length;
          for (let i2 = 1; i2 < pathStackLength; i2++) {
            const item = path4.stack[i2];
            const parentItem = path4.stack[i2 - 1];
            if (Array.isArray(parentItem) && typeof item === "number" && item !== parentItem.length - 1) {
              return false;
            }
          }
          return true;
        }
        function getLastDescendantNode(node) {
          return isNonEmptyArray(node.children) ? getLastDescendantNode(getLast(node.children)) : node;
        }
        function isPrettierIgnore(comment) {
          return comment.value.trim() === "prettier-ignore";
        }
        function hasPrettierIgnore(path4) {
          const node = path4.getValue();
          if (node.type === "documentBody") {
            const document2 = path4.getParentNode();
            return hasEndComments(document2.head) && isPrettierIgnore(getLast(document2.head.endComments));
          }
          return hasLeadingComments(node) && isPrettierIgnore(getLast(node.leadingComments));
        }
        function isEmptyNode(node) {
          return !isNonEmptyArray(node.children) && !hasComments(node);
        }
        function hasComments(node) {
          return hasLeadingComments(node) || hasMiddleComments(node) || hasIndicatorComment(node) || hasTrailingComment(node) || hasEndComments(node);
        }
        function hasLeadingComments(node) {
          return isNonEmptyArray(node === null || node === void 0 ? void 0 : node.leadingComments);
        }
        function hasMiddleComments(node) {
          return isNonEmptyArray(node === null || node === void 0 ? void 0 : node.middleComments);
        }
        function hasIndicatorComment(node) {
          return node === null || node === void 0 ? void 0 : node.indicatorComment;
        }
        function hasTrailingComment(node) {
          return node === null || node === void 0 ? void 0 : node.trailingComment;
        }
        function hasEndComments(node) {
          return isNonEmptyArray(node === null || node === void 0 ? void 0 : node.endComments);
        }
        function splitWithSingleSpace(text) {
          const parts = [];
          let lastPart;
          for (const part of text.split(/( +)/)) {
            if (part !== " ") {
              if (lastPart === " ") {
                parts.push(part);
              } else {
                parts.push((parts.pop() || "") + part);
              }
            } else if (lastPart === void 0) {
              parts.unshift("");
            }
            lastPart = part;
          }
          if (lastPart === " ") {
            parts.push((parts.pop() || "") + " ");
          }
          if (parts[0] === "") {
            parts.shift();
            parts.unshift(" " + (parts.shift() || ""));
          }
          return parts;
        }
        function getFlowScalarLineContents(nodeType, content, options) {
          const rawLineContents = content.split("\n").map((lineContent, index, lineContents) => index === 0 && index === lineContents.length - 1 ? lineContent : index !== 0 && index !== lineContents.length - 1 ? lineContent.trim() : index === 0 ? lineContent.trimEnd() : lineContent.trimStart());
          if (options.proseWrap === "preserve") {
            return rawLineContents.map((lineContent) => lineContent.length === 0 ? [] : [lineContent]);
          }
          return rawLineContents.map((lineContent) => lineContent.length === 0 ? [] : splitWithSingleSpace(lineContent)).reduce((reduced, lineContentWords, index) => index !== 0 && rawLineContents[index - 1].length > 0 && lineContentWords.length > 0 && !(nodeType === "quoteDouble" && getLast(getLast(reduced)).endsWith("\\")) ? [...reduced.slice(0, -1), [...getLast(reduced), ...lineContentWords]] : [...reduced, lineContentWords], []).map((lineContentWords) => options.proseWrap === "never" ? [lineContentWords.join(" ")] : lineContentWords);
        }
        function getBlockValueLineContents(node, {
          parentIndent,
          isLastDescendant,
          options
        }) {
          const content = node.position.start.line === node.position.end.line ? "" : options.originalText.slice(node.position.start.offset, node.position.end.offset).match(/^[^\n]*\n(.*)$/s)[1];
          let leadingSpaceCount;
          if (node.indent === null) {
            const matches = content.match(/^(?<leadingSpace> *)[^\n\r ]/m);
            leadingSpaceCount = matches ? matches.groups.leadingSpace.length : Number.POSITIVE_INFINITY;
          } else {
            leadingSpaceCount = node.indent - 1 + parentIndent;
          }
          const rawLineContents = content.split("\n").map((lineContent) => lineContent.slice(leadingSpaceCount));
          if (options.proseWrap === "preserve" || node.type === "blockLiteral") {
            return removeUnnecessaryTrailingNewlines(rawLineContents.map((lineContent) => lineContent.length === 0 ? [] : [lineContent]));
          }
          return removeUnnecessaryTrailingNewlines(rawLineContents.map((lineContent) => lineContent.length === 0 ? [] : splitWithSingleSpace(lineContent)).reduce((reduced, lineContentWords, index) => index !== 0 && rawLineContents[index - 1].length > 0 && lineContentWords.length > 0 && !/^\s/.test(lineContentWords[0]) && !/^\s|\s$/.test(getLast(reduced)) ? [...reduced.slice(0, -1), [...getLast(reduced), ...lineContentWords]] : [...reduced, lineContentWords], []).map((lineContentWords) => lineContentWords.reduce((reduced, word) => reduced.length > 0 && /\s$/.test(getLast(reduced)) ? [...reduced.slice(0, -1), getLast(reduced) + " " + word] : [...reduced, word], [])).map((lineContentWords) => options.proseWrap === "never" ? [lineContentWords.join(" ")] : lineContentWords));
          function removeUnnecessaryTrailingNewlines(lineContents) {
            if (node.chomping === "keep") {
              return getLast(lineContents).length === 0 ? lineContents.slice(0, -1) : lineContents;
            }
            let trailingNewlineCount = 0;
            for (let i2 = lineContents.length - 1; i2 >= 0; i2--) {
              if (lineContents[i2].length === 0) {
                trailingNewlineCount++;
              } else {
                break;
              }
            }
            return trailingNewlineCount === 0 ? lineContents : trailingNewlineCount >= 2 && !isLastDescendant ? lineContents.slice(0, -(trailingNewlineCount - 1)) : lineContents.slice(0, -trailingNewlineCount);
          }
        }
        function isInlineNode(node) {
          if (!node) {
            return true;
          }
          switch (node.type) {
            case "plain":
            case "quoteDouble":
            case "quoteSingle":
            case "alias":
            case "flowMapping":
            case "flowSequence":
              return true;
            default:
              return false;
          }
        }
        module22.exports = {
          getLast,
          getAncestorCount,
          isNode,
          isEmptyNode,
          isInlineNode,
          mapNode,
          defineShortcut,
          isNextLineEmpty,
          isLastDescendantNode,
          getBlockValueLineContents,
          getFlowScalarLineContents,
          getLastDescendantNode,
          hasPrettierIgnore,
          hasLeadingComments,
          hasMiddleComments,
          hasIndicatorComment,
          hasTrailingComment,
          hasEndComments
        };
      }
    });
    var require_print_preprocess4 = __commonJS22({
      "src/language-yaml/print-preprocess.js"(exports2, module22) {
        "use strict";
        var {
          defineShortcut,
          mapNode
        } = require_utils12();
        function preprocess(ast) {
          return mapNode(ast, defineShortcuts);
        }
        function defineShortcuts(node) {
          switch (node.type) {
            case "document":
              defineShortcut(node, "head", () => node.children[0]);
              defineShortcut(node, "body", () => node.children[1]);
              break;
            case "documentBody":
            case "sequenceItem":
            case "flowSequenceItem":
            case "mappingKey":
            case "mappingValue":
              defineShortcut(node, "content", () => node.children[0]);
              break;
            case "mappingItem":
            case "flowMappingItem":
              defineShortcut(node, "key", () => node.children[0]);
              defineShortcut(node, "value", () => node.children[1]);
              break;
          }
          return node;
        }
        module22.exports = preprocess;
      }
    });
    var require_misc2 = __commonJS22({
      "src/language-yaml/print/misc.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            softline,
            align
          }
        } = require_doc();
        var {
          hasEndComments,
          isNextLineEmpty,
          isNode
        } = require_utils12();
        var printedEmptyLineCache = /* @__PURE__ */ new WeakMap();
        function printNextEmptyLine(path4, originalText) {
          const node = path4.getValue();
          const root = path4.stack[0];
          let isNextEmptyLinePrintedSet;
          if (printedEmptyLineCache.has(root)) {
            isNextEmptyLinePrintedSet = printedEmptyLineCache.get(root);
          } else {
            isNextEmptyLinePrintedSet = /* @__PURE__ */ new Set();
            printedEmptyLineCache.set(root, isNextEmptyLinePrintedSet);
          }
          if (!isNextEmptyLinePrintedSet.has(node.position.end.line)) {
            isNextEmptyLinePrintedSet.add(node.position.end.line);
            if (isNextLineEmpty(node, originalText) && !shouldPrintEndComments(path4.getParentNode())) {
              return softline;
            }
          }
          return "";
        }
        function shouldPrintEndComments(node) {
          return hasEndComments(node) && !isNode(node, ["documentHead", "documentBody", "flowMapping", "flowSequence"]);
        }
        function alignWithSpaces(width, doc2) {
          return align(" ".repeat(width), doc2);
        }
        module22.exports = {
          alignWithSpaces,
          shouldPrintEndComments,
          printNextEmptyLine
        };
      }
    });
    var require_flow_mapping_sequence = __commonJS22({
      "src/language-yaml/print/flow-mapping-sequence.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            ifBreak,
            line,
            softline,
            hardline,
            join
          }
        } = require_doc();
        var {
          isEmptyNode,
          getLast,
          hasEndComments
        } = require_utils12();
        var {
          printNextEmptyLine,
          alignWithSpaces
        } = require_misc2();
        function printFlowMapping(path4, print, options) {
          const node = path4.getValue();
          const isMapping = node.type === "flowMapping";
          const openMarker = isMapping ? "{" : "[";
          const closeMarker = isMapping ? "}" : "]";
          let bracketSpacing = softline;
          if (isMapping && node.children.length > 0 && options.bracketSpacing) {
            bracketSpacing = line;
          }
          const lastItem = getLast(node.children);
          const isLastItemEmptyMappingItem = lastItem && lastItem.type === "flowMappingItem" && isEmptyNode(lastItem.key) && isEmptyNode(lastItem.value);
          return [openMarker, alignWithSpaces(options.tabWidth, [bracketSpacing, printChildren(path4, print, options), options.trailingComma === "none" ? "" : ifBreak(","), hasEndComments(node) ? [hardline, join(hardline, path4.map(print, "endComments"))] : ""]), isLastItemEmptyMappingItem ? "" : bracketSpacing, closeMarker];
        }
        function printChildren(path4, print, options) {
          const node = path4.getValue();
          const parts = path4.map((childPath, index) => [print(), index === node.children.length - 1 ? "" : [",", line, node.children[index].position.start.line !== node.children[index + 1].position.start.line ? printNextEmptyLine(childPath, options.originalText) : ""]], "children");
          return parts;
        }
        module22.exports = {
          printFlowMapping,
          printFlowSequence: printFlowMapping
        };
      }
    });
    var require_mapping_item = __commonJS22({
      "src/language-yaml/print/mapping-item.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            conditionalGroup,
            group,
            hardline,
            ifBreak,
            join,
            line
          }
        } = require_doc();
        var {
          hasLeadingComments,
          hasMiddleComments,
          hasTrailingComment,
          hasEndComments,
          isNode,
          isEmptyNode,
          isInlineNode
        } = require_utils12();
        var {
          alignWithSpaces
        } = require_misc2();
        function printMappingItem(node, parentNode, path4, print, options) {
          const {
            key,
            value
          } = node;
          const isEmptyMappingKey = isEmptyNode(key);
          const isEmptyMappingValue = isEmptyNode(value);
          if (isEmptyMappingKey && isEmptyMappingValue) {
            return ": ";
          }
          const printedKey = print("key");
          const spaceBeforeColon = needsSpaceInFrontOfMappingValue(node) ? " " : "";
          if (isEmptyMappingValue) {
            if (node.type === "flowMappingItem" && parentNode.type === "flowMapping") {
              return printedKey;
            }
            if (node.type === "mappingItem" && isAbsolutelyPrintedAsSingleLineNode(key.content, options) && !hasTrailingComment(key.content) && (!parentNode.tag || parentNode.tag.value !== "tag:yaml.org,2002:set")) {
              return [printedKey, spaceBeforeColon, ":"];
            }
            return ["? ", alignWithSpaces(2, printedKey)];
          }
          const printedValue = print("value");
          if (isEmptyMappingKey) {
            return [": ", alignWithSpaces(2, printedValue)];
          }
          if (hasLeadingComments(value) || !isInlineNode(key.content)) {
            return ["? ", alignWithSpaces(2, printedKey), hardline, join("", path4.map(print, "value", "leadingComments").map((comment) => [comment, hardline])), ": ", alignWithSpaces(2, printedValue)];
          }
          if (isSingleLineNode(key.content) && !hasLeadingComments(key.content) && !hasMiddleComments(key.content) && !hasTrailingComment(key.content) && !hasEndComments(key) && !hasLeadingComments(value.content) && !hasMiddleComments(value.content) && !hasEndComments(value) && isAbsolutelyPrintedAsSingleLineNode(value.content, options)) {
            return [printedKey, spaceBeforeColon, ": ", printedValue];
          }
          const groupId = Symbol("mappingKey");
          const groupedKey = group([ifBreak("? "), group(alignWithSpaces(2, printedKey), {
            id: groupId
          })]);
          const explicitMappingValue = [hardline, ": ", alignWithSpaces(2, printedValue)];
          const implicitMappingValueParts = [spaceBeforeColon, ":"];
          if (hasLeadingComments(value.content) || hasEndComments(value) && value.content && !isNode(value.content, ["mapping", "sequence"]) || parentNode.type === "mapping" && hasTrailingComment(key.content) && isInlineNode(value.content) || isNode(value.content, ["mapping", "sequence"]) && value.content.tag === null && value.content.anchor === null) {
            implicitMappingValueParts.push(hardline);
          } else if (value.content) {
            implicitMappingValueParts.push(line);
          }
          implicitMappingValueParts.push(printedValue);
          const implicitMappingValue = alignWithSpaces(options.tabWidth, implicitMappingValueParts);
          if (isAbsolutelyPrintedAsSingleLineNode(key.content, options) && !hasLeadingComments(key.content) && !hasMiddleComments(key.content) && !hasEndComments(key)) {
            return conditionalGroup([[printedKey, implicitMappingValue]]);
          }
          return conditionalGroup([[groupedKey, ifBreak(explicitMappingValue, implicitMappingValue, {
            groupId
          })]]);
        }
        function isAbsolutelyPrintedAsSingleLineNode(node, options) {
          if (!node) {
            return true;
          }
          switch (node.type) {
            case "plain":
            case "quoteSingle":
            case "quoteDouble":
              break;
            case "alias":
              return true;
            default:
              return false;
          }
          if (options.proseWrap === "preserve") {
            return node.position.start.line === node.position.end.line;
          }
          if (/\\$/m.test(options.originalText.slice(node.position.start.offset, node.position.end.offset))) {
            return false;
          }
          switch (options.proseWrap) {
            case "never":
              return !node.value.includes("\n");
            case "always":
              return !/[\n ]/.test(node.value);
            default:
              return false;
          }
        }
        function needsSpaceInFrontOfMappingValue(node) {
          return node.key.content && node.key.content.type === "alias";
        }
        function isSingleLineNode(node) {
          if (!node) {
            return true;
          }
          switch (node.type) {
            case "plain":
            case "quoteDouble":
            case "quoteSingle":
              return node.position.start.line === node.position.end.line;
            case "alias":
              return true;
            default:
              return false;
          }
        }
        module22.exports = printMappingItem;
      }
    });
    var require_block2 = __commonJS22({
      "src/language-yaml/print/block.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            dedent,
            dedentToRoot,
            fill,
            hardline,
            join,
            line,
            literalline,
            markAsRoot
          },
          utils: {
            getDocParts
          }
        } = require_doc();
        var {
          getAncestorCount,
          getBlockValueLineContents,
          hasIndicatorComment,
          isLastDescendantNode,
          isNode
        } = require_utils12();
        var {
          alignWithSpaces
        } = require_misc2();
        function printBlock(path4, print, options) {
          const node = path4.getValue();
          const parentIndent = getAncestorCount(path4, (ancestorNode) => isNode(ancestorNode, ["sequence", "mapping"]));
          const isLastDescendant = isLastDescendantNode(path4);
          const parts = [node.type === "blockFolded" ? ">" : "|"];
          if (node.indent !== null) {
            parts.push(node.indent.toString());
          }
          if (node.chomping !== "clip") {
            parts.push(node.chomping === "keep" ? "+" : "-");
          }
          if (hasIndicatorComment(node)) {
            parts.push(" ", print("indicatorComment"));
          }
          const lineContents = getBlockValueLineContents(node, {
            parentIndent,
            isLastDescendant,
            options
          });
          const contentsParts = [];
          for (const [index, lineWords] of lineContents.entries()) {
            if (index === 0) {
              contentsParts.push(hardline);
            }
            contentsParts.push(fill(getDocParts(join(line, lineWords))));
            if (index !== lineContents.length - 1) {
              contentsParts.push(lineWords.length === 0 ? hardline : markAsRoot(literalline));
            } else if (node.chomping === "keep" && isLastDescendant) {
              contentsParts.push(dedentToRoot(lineWords.length === 0 ? hardline : literalline));
            }
          }
          if (node.indent === null) {
            parts.push(dedent(alignWithSpaces(options.tabWidth, contentsParts)));
          } else {
            parts.push(dedentToRoot(alignWithSpaces(node.indent - 1 + parentIndent, contentsParts)));
          }
          return parts;
        }
        module22.exports = printBlock;
      }
    });
    var require_printer_yaml = __commonJS22({
      "src/language-yaml/printer-yaml.js"(exports2, module22) {
        "use strict";
        var {
          builders: {
            breakParent,
            fill,
            group,
            hardline,
            join,
            line,
            lineSuffix,
            literalline
          },
          utils: {
            getDocParts,
            replaceTextEndOfLine
          }
        } = require_doc();
        var {
          isPreviousLineEmpty
        } = require_util();
        var {
          insertPragma,
          isPragma
        } = require_pragma6();
        var {
          locStart
        } = require_loc7();
        var embed = require_embed5();
        var {
          getFlowScalarLineContents,
          getLastDescendantNode,
          hasLeadingComments,
          hasMiddleComments,
          hasTrailingComment,
          hasEndComments,
          hasPrettierIgnore,
          isLastDescendantNode,
          isNode,
          isInlineNode
        } = require_utils12();
        var preprocess = require_print_preprocess4();
        var {
          alignWithSpaces,
          printNextEmptyLine,
          shouldPrintEndComments
        } = require_misc2();
        var {
          printFlowMapping,
          printFlowSequence
        } = require_flow_mapping_sequence();
        var printMappingItem = require_mapping_item();
        var printBlock = require_block2();
        function genericPrint(path4, options, print) {
          const node = path4.getValue();
          const parts = [];
          if (node.type !== "mappingValue" && hasLeadingComments(node)) {
            parts.push([join(hardline, path4.map(print, "leadingComments")), hardline]);
          }
          const {
            tag,
            anchor
          } = node;
          if (tag) {
            parts.push(print("tag"));
          }
          if (tag && anchor) {
            parts.push(" ");
          }
          if (anchor) {
            parts.push(print("anchor"));
          }
          let nextEmptyLine = "";
          if (isNode(node, ["mapping", "sequence", "comment", "directive", "mappingItem", "sequenceItem"]) && !isLastDescendantNode(path4)) {
            nextEmptyLine = printNextEmptyLine(path4, options.originalText);
          }
          if (tag || anchor) {
            if (isNode(node, ["sequence", "mapping"]) && !hasMiddleComments(node)) {
              parts.push(hardline);
            } else {
              parts.push(" ");
            }
          }
          if (hasMiddleComments(node)) {
            parts.push([node.middleComments.length === 1 ? "" : hardline, join(hardline, path4.map(print, "middleComments")), hardline]);
          }
          const parentNode = path4.getParentNode();
          if (hasPrettierIgnore(path4)) {
            parts.push(replaceTextEndOfLine(options.originalText.slice(node.position.start.offset, node.position.end.offset).trimEnd(), literalline));
          } else {
            parts.push(group(printNode(node, parentNode, path4, options, print)));
          }
          if (hasTrailingComment(node) && !isNode(node, ["document", "documentHead"])) {
            parts.push(lineSuffix([node.type === "mappingValue" && !node.content ? "" : " ", parentNode.type === "mappingKey" && path4.getParentNode(2).type === "mapping" && isInlineNode(node) ? "" : breakParent, print("trailingComment")]));
          }
          if (shouldPrintEndComments(node)) {
            parts.push(alignWithSpaces(node.type === "sequenceItem" ? 2 : 0, [hardline, join(hardline, path4.map((path22) => [isPreviousLineEmpty(options.originalText, path22.getValue(), locStart) ? hardline : "", print()], "endComments"))]));
          }
          parts.push(nextEmptyLine);
          return parts;
        }
        function printNode(node, parentNode, path4, options, print) {
          switch (node.type) {
            case "root": {
              const {
                children
              } = node;
              const parts = [];
              path4.each((childPath, index) => {
                const document2 = children[index];
                const nextDocument = children[index + 1];
                if (index !== 0) {
                  parts.push(hardline);
                }
                parts.push(print());
                if (shouldPrintDocumentEndMarker(document2, nextDocument)) {
                  parts.push(hardline, "...");
                  if (hasTrailingComment(document2)) {
                    parts.push(" ", print("trailingComment"));
                  }
                } else if (nextDocument && !hasTrailingComment(nextDocument.head)) {
                  parts.push(hardline, "---");
                }
              }, "children");
              const lastDescendantNode = getLastDescendantNode(node);
              if (!isNode(lastDescendantNode, ["blockLiteral", "blockFolded"]) || lastDescendantNode.chomping !== "keep") {
                parts.push(hardline);
              }
              return parts;
            }
            case "document": {
              const nextDocument = parentNode.children[path4.getName() + 1];
              const parts = [];
              if (shouldPrintDocumentHeadEndMarker(node, nextDocument, parentNode, options) === "head") {
                if (node.head.children.length > 0 || node.head.endComments.length > 0) {
                  parts.push(print("head"));
                }
                if (hasTrailingComment(node.head)) {
                  parts.push(["---", " ", print(["head", "trailingComment"])]);
                } else {
                  parts.push("---");
                }
              }
              if (shouldPrintDocumentBody(node)) {
                parts.push(print("body"));
              }
              return join(hardline, parts);
            }
            case "documentHead":
              return join(hardline, [...path4.map(print, "children"), ...path4.map(print, "endComments")]);
            case "documentBody": {
              const {
                children,
                endComments
              } = node;
              let separator = "";
              if (children.length > 0 && endComments.length > 0) {
                const lastDescendantNode = getLastDescendantNode(node);
                if (isNode(lastDescendantNode, ["blockFolded", "blockLiteral"])) {
                  if (lastDescendantNode.chomping !== "keep") {
                    separator = [hardline, hardline];
                  }
                } else {
                  separator = hardline;
                }
              }
              return [join(hardline, path4.map(print, "children")), separator, join(hardline, path4.map(print, "endComments"))];
            }
            case "directive":
              return ["%", join(" ", [node.name, ...node.parameters])];
            case "comment":
              return ["#", node.value];
            case "alias":
              return ["*", node.value];
            case "tag":
              return options.originalText.slice(node.position.start.offset, node.position.end.offset);
            case "anchor":
              return ["&", node.value];
            case "plain":
              return printFlowScalarContent(node.type, options.originalText.slice(node.position.start.offset, node.position.end.offset), options);
            case "quoteDouble":
            case "quoteSingle": {
              const singleQuote = "'";
              const doubleQuote = '"';
              const raw = options.originalText.slice(node.position.start.offset + 1, node.position.end.offset - 1);
              if (node.type === "quoteSingle" && raw.includes("\\") || node.type === "quoteDouble" && /\\[^"]/.test(raw)) {
                const originalQuote = node.type === "quoteDouble" ? doubleQuote : singleQuote;
                return [originalQuote, printFlowScalarContent(node.type, raw, options), originalQuote];
              }
              if (raw.includes(doubleQuote)) {
                return [singleQuote, printFlowScalarContent(node.type, node.type === "quoteDouble" ? raw.replace(/\\"/g, doubleQuote).replace(/'/g, singleQuote.repeat(2)) : raw, options), singleQuote];
              }
              if (raw.includes(singleQuote)) {
                return [doubleQuote, printFlowScalarContent(node.type, node.type === "quoteSingle" ? raw.replace(/''/g, singleQuote) : raw, options), doubleQuote];
              }
              const quote = options.singleQuote ? singleQuote : doubleQuote;
              return [quote, printFlowScalarContent(node.type, raw, options), quote];
            }
            case "blockFolded":
            case "blockLiteral": {
              return printBlock(path4, print, options);
            }
            case "mapping":
            case "sequence":
              return join(hardline, path4.map(print, "children"));
            case "sequenceItem":
              return ["- ", alignWithSpaces(2, node.content ? print("content") : "")];
            case "mappingKey":
            case "mappingValue":
              return !node.content ? "" : print("content");
            case "mappingItem":
            case "flowMappingItem": {
              return printMappingItem(node, parentNode, path4, print, options);
            }
            case "flowMapping":
              return printFlowMapping(path4, print, options);
            case "flowSequence":
              return printFlowSequence(path4, print, options);
            case "flowSequenceItem":
              return print("content");
            default:
              throw new Error(`Unexpected node type ${node.type}`);
          }
        }
        function shouldPrintDocumentBody(document2) {
          return document2.body.children.length > 0 || hasEndComments(document2.body);
        }
        function shouldPrintDocumentEndMarker(document2, nextDocument) {
          return hasTrailingComment(document2) || nextDocument && (nextDocument.head.children.length > 0 || hasEndComments(nextDocument.head));
        }
        function shouldPrintDocumentHeadEndMarker(document2, nextDocument, root, options) {
          if (root.children[0] === document2 && /---(?:\s|$)/.test(options.originalText.slice(locStart(document2), locStart(document2) + 4)) || document2.head.children.length > 0 || hasEndComments(document2.head) || hasTrailingComment(document2.head)) {
            return "head";
          }
          if (shouldPrintDocumentEndMarker(document2, nextDocument)) {
            return false;
          }
          return nextDocument ? "root" : false;
        }
        function printFlowScalarContent(nodeType, content, options) {
          const lineContents = getFlowScalarLineContents(nodeType, content, options);
          return join(hardline, lineContents.map((lineContentWords) => fill(getDocParts(join(line, lineContentWords)))));
        }
        function clean(node, newNode) {
          if (isNode(newNode)) {
            delete newNode.position;
            switch (newNode.type) {
              case "comment":
                if (isPragma(newNode.value)) {
                  return null;
                }
                break;
              case "quoteDouble":
              case "quoteSingle":
                newNode.type = "quote";
                break;
            }
          }
        }
        module22.exports = {
          preprocess,
          embed,
          print: genericPrint,
          massageAstNode: clean,
          insertPragma
        };
      }
    });
    var require_options7 = __commonJS22({
      "src/language-yaml/options.js"(exports2, module22) {
        "use strict";
        var commonOptions = require_common_options();
        module22.exports = {
          bracketSpacing: commonOptions.bracketSpacing,
          singleQuote: commonOptions.singleQuote,
          proseWrap: commonOptions.proseWrap
        };
      }
    });
    var require_parsers7 = __commonJS22({
      "src/language-yaml/parsers.js"(exports2, module22) {
        "use strict";
        module22.exports = {
          get yaml() {
            return require_parser_yaml().parsers.yaml;
          }
        };
      }
    });
    var require_YAML = __commonJS22({
      "node_modules/linguist-languages/data/YAML.json"(exports2, module22) {
        module22.exports = {
          name: "YAML",
          type: "data",
          color: "#cb171e",
          tmScope: "source.yaml",
          aliases: ["yml"],
          extensions: [".yml", ".mir", ".reek", ".rviz", ".sublime-syntax", ".syntax", ".yaml", ".yaml-tmlanguage", ".yaml.sed", ".yml.mysql"],
          filenames: [".clang-format", ".clang-tidy", ".gemrc", "CITATION.cff", "glide.lock", "yarn.lock"],
          aceMode: "yaml",
          codemirrorMode: "yaml",
          codemirrorMimeType: "text/x-yaml",
          languageId: 407
        };
      }
    });
    var require_language_yaml = __commonJS22({
      "src/language-yaml/index.js"(exports2, module22) {
        "use strict";
        var createLanguage = require_create_language();
        var printer = require_printer_yaml();
        var options = require_options7();
        var parsers = require_parsers7();
        var languages = [createLanguage(require_YAML(), (data) => ({
          since: "1.14.0",
          parsers: ["yaml"],
          vscodeLanguageIds: ["yaml", "ansible", "home-assistant"],
          filenames: [...data.filenames.filter((filename) => filename !== "yarn.lock"), ".prettierrc", ".stylelintrc"]
        }))];
        module22.exports = {
          languages,
          printers: {
            yaml: printer
          },
          options,
          parsers
        };
      }
    });
    var require_languages = __commonJS22({
      "src/languages.js"(exports2, module22) {
        "use strict";
        module22.exports = [require_language_js(), require_language_css(), require_language_handlebars(), require_language_graphql(), require_language_markdown(), require_language_html(), require_language_yaml()];
      }
    });
    var require_load_plugins = __commonJS22({
      "src/common/load-plugins.js"(exports2, module22) {
        "use strict";
        var fs4 = require("fs");
        var path4 = require("path");
        var fastGlob = require_out42();
        var partition = require_partition();
        var uniqByKey = require_uniq_by_key();
        var internalPlugins = require_languages();
        var {
          default: mem2,
          memClear: memClear2
        } = (init_dist(), __toCommonJS2(dist_exports));
        var thirdParty = require_third_party();
        var resolve = require_resolve2();
        var memoizedLoad = mem2(load, {
          cacheKey: JSON.stringify
        });
        var memoizedSearch = mem2(findPluginsInNodeModules);
        var clearCache = () => {
          memClear2(memoizedLoad);
          memClear2(memoizedSearch);
        };
        function load(plugins2, pluginSearchDirs) {
          if (!plugins2) {
            plugins2 = [];
          }
          if (pluginSearchDirs === false) {
            pluginSearchDirs = [];
          } else {
            pluginSearchDirs = pluginSearchDirs || [];
            if (pluginSearchDirs.length === 0) {
              const autoLoadDir = thirdParty.findParentDir(__dirname, "node_modules");
              if (autoLoadDir) {
                pluginSearchDirs = [autoLoadDir];
              }
            }
          }
          const [externalPluginNames, externalPluginInstances] = partition(plugins2, (plugin) => typeof plugin === "string");
          const externalManualLoadPluginInfos = externalPluginNames.map((pluginName) => {
            let requirePath;
            try {
              requirePath = resolve(path4.resolve(process.cwd(), pluginName));
            } catch {
              requirePath = resolve(pluginName, {
                paths: [process.cwd()]
              });
            }
            return {
              name: pluginName,
              requirePath
            };
          });
          const externalAutoLoadPluginInfos = pluginSearchDirs.flatMap((pluginSearchDir) => {
            const resolvedPluginSearchDir = path4.resolve(process.cwd(), pluginSearchDir);
            const nodeModulesDir = path4.resolve(resolvedPluginSearchDir, "node_modules");
            if (!isDirectory(nodeModulesDir) && !isDirectory(resolvedPluginSearchDir)) {
              throw new Error(`${pluginSearchDir} does not exist or is not a directory`);
            }
            return memoizedSearch(nodeModulesDir).map((pluginName) => ({
              name: pluginName,
              requirePath: resolve(pluginName, {
                paths: [resolvedPluginSearchDir]
              })
            }));
          });
          const externalPlugins = [...uniqByKey([...externalManualLoadPluginInfos, ...externalAutoLoadPluginInfos], "requirePath").map((externalPluginInfo) => Object.assign({
            name: externalPluginInfo.name
          }, require(externalPluginInfo.requirePath))), ...externalPluginInstances];
          return [...internalPlugins, ...externalPlugins];
        }
        function findPluginsInNodeModules(nodeModulesDir) {
          const pluginPackageJsonPaths = fastGlob.sync(["prettier-plugin-*/package.json", "@*/prettier-plugin-*/package.json", "@prettier/plugin-*/package.json"], {
            cwd: nodeModulesDir
          });
          return pluginPackageJsonPaths.map(path4.dirname);
        }
        function isDirectory(dir) {
          try {
            return fs4.statSync(dir).isDirectory();
          } catch {
            return false;
          }
        }
        module22.exports = {
          loadPlugins: memoizedLoad,
          clearCache
        };
      }
    });
    var {
      version
    } = require_package();
    var core2 = require_core3();
    var {
      getSupportInfo
    } = require_support();
    var getFileInfo = require_get_file_info();
    var sharedUtil = require_util_shared();
    var plugins = require_load_plugins();
    var config = require_resolve_config();
    var doc = require_doc();
    function _withPlugins(fn, optsArgIdx = 1) {
      return (...args) => {
        const opts = args[optsArgIdx] || {};
        args[optsArgIdx] = Object.assign(Object.assign({}, opts), {}, {
          plugins: plugins.loadPlugins(opts.plugins, opts.pluginSearchDirs)
        });
        return fn(...args);
      };
    }
    function withPlugins(fn, optsArgIdx) {
      const resultingFn = _withPlugins(fn, optsArgIdx);
      if (fn.sync) {
        resultingFn.sync = _withPlugins(fn.sync, optsArgIdx);
      }
      return resultingFn;
    }
    var formatWithCursor = withPlugins(core2.formatWithCursor);
    module2.exports = {
      formatWithCursor,
      format(text, opts) {
        return formatWithCursor(text, opts).formatted;
      },
      check(text, opts) {
        const {
          formatted
        } = formatWithCursor(text, opts);
        return formatted === text;
      },
      doc,
      resolveConfig: config.resolveConfig,
      resolveConfigFile: config.resolveConfigFile,
      clearConfigCache() {
        config.clearCache();
        plugins.clearCache();
      },
      getFileInfo: withPlugins(getFileInfo),
      getSupportInfo: withPlugins(getSupportInfo, 0),
      version,
      util: sharedUtil,
      __internal: {
        errors: require_errors(),
        coreOptions: require_core_options(),
        createIgnorer: require_create_ignorer(),
        optionsModule: require_options(),
        optionsNormalizer: require_options_normalizer(),
        utils: {
          arrayify: require_arrayify(),
          getLast: require_get_last(),
          partition: require_partition(),
          isNonEmptyArray: require_util().isNonEmptyArray
        }
      },
      __debug: {
        parse: withPlugins(core2.parse),
        formatAST: withPlugins(core2.formatAST),
        formatDoc: withPlugins(core2.formatDoc),
        printToDoc: withPlugins(core2.printToDoc),
        printDocToString: withPlugins(core2.printDocToString)
      }
    };
  }
});

// src/index.ts
var core = __toESM(require_core());
var github = __toESM(require_github());

// src/utils.ts
var import_exec = __toESM(require_exec());
var import_fs_extra = __toESM(require_lib3());
async function setupGitCredentials(githubToken) {
  await import_fs_extra.default.writeFile(
    `${process.env.HOME}/.netrc`,
    `machine github.com
login github-actions[bot]
password ${githubToken}`
  );
}
async function execWithOutput(command, args, options) {
  let myOutput = "";
  let myError = "";
  return {
    code: await (0, import_exec.exec)(command, args, {
      listeners: {
        stdout: (data) => {
          myOutput += data.toString();
        },
        stderr: (data) => {
          myError += data.toString();
        }
      },
      ...options
    }),
    stdout: myOutput,
    stderr: myError
  };
}
var setupGitUser = async () => {
  await (0, import_exec.exec)("git", ["config", "user.name", `"github-actions[bot]"`]);
  await (0, import_exec.exec)("git", [
    "config",
    "user.email",
    `"github-actions[bot]@users.noreply.github.com"`
  ]);
};

// node_modules/node-fetch/src/index.js
var import_node_http2 = __toESM(require("http"), 1);
var import_node_https = __toESM(require("https"), 1);
var import_node_zlib = __toESM(require("zlib"), 1);
var import_node_stream2 = __toESM(require("stream"), 1);
var import_node_buffer2 = require("buffer");

// node_modules/data-uri-to-buffer/dist/index.js
function dataUriToBuffer(uri) {
  if (!/^data:/i.test(uri)) {
    throw new TypeError('`uri` does not appear to be a Data URI (must begin with "data:")');
  }
  uri = uri.replace(/\r?\n/g, "");
  const firstComma = uri.indexOf(",");
  if (firstComma === -1 || firstComma <= 4) {
    throw new TypeError("malformed data: URI");
  }
  const meta = uri.substring(5, firstComma).split(";");
  let charset = "";
  let base64 = false;
  const type = meta[0] || "text/plain";
  let typeFull = type;
  for (let i2 = 1; i2 < meta.length; i2++) {
    if (meta[i2] === "base64") {
      base64 = true;
    } else {
      typeFull += `;${meta[i2]}`;
      if (meta[i2].indexOf("charset=") === 0) {
        charset = meta[i2].substring(8);
      }
    }
  }
  if (!meta[0] && !charset.length) {
    typeFull += ";charset=US-ASCII";
    charset = "US-ASCII";
  }
  const encoding = base64 ? "base64" : "ascii";
  const data = unescape(uri.substring(firstComma + 1));
  const buffer = Buffer.from(data, encoding);
  buffer.type = type;
  buffer.typeFull = typeFull;
  buffer.charset = charset;
  return buffer;
}
var dist_default = dataUriToBuffer;

// node_modules/node-fetch/src/body.js
var import_node_stream = __toESM(require("stream"), 1);
var import_node_util = require("util");
var import_node_buffer = require("buffer");
init_fetch_blob();
init_esm_min();

// node_modules/node-fetch/src/errors/base.js
var FetchBaseError = class extends Error {
  constructor(message, type) {
    super(message);
    Error.captureStackTrace(this, this.constructor);
    this.type = type;
  }
  get name() {
    return this.constructor.name;
  }
  get [Symbol.toStringTag]() {
    return this.constructor.name;
  }
};

// node_modules/node-fetch/src/errors/fetch-error.js
var FetchError2 = class extends FetchBaseError {
  constructor(message, type, systemError) {
    super(message, type);
    if (systemError) {
      this.code = this.errno = systemError.code;
      this.erroredSysCall = systemError.syscall;
    }
  }
};

// node_modules/node-fetch/src/utils/is.js
var NAME = Symbol.toStringTag;
var isURLSearchParameters = (object) => {
  return typeof object === "object" && typeof object.append === "function" && typeof object.delete === "function" && typeof object.get === "function" && typeof object.getAll === "function" && typeof object.has === "function" && typeof object.set === "function" && typeof object.sort === "function" && object[NAME] === "URLSearchParams";
};
var isBlob2 = (object) => {
  return object && typeof object === "object" && typeof object.arrayBuffer === "function" && typeof object.type === "string" && typeof object.stream === "function" && typeof object.constructor === "function" && /^(Blob|File)$/.test(object[NAME]);
};
var isAbortSignal2 = (object) => {
  return typeof object === "object" && (object[NAME] === "AbortSignal" || object[NAME] === "EventTarget");
};
var isDomainOrSubdomain3 = (destination, original) => {
  const orig = new URL(original).hostname;
  const dest = new URL(destination).hostname;
  return orig === dest || orig.endsWith(`.${dest}`);
};
var isSameProtocol = (destination, original) => {
  const orig = new URL(original).protocol;
  const dest = new URL(destination).protocol;
  return orig === dest;
};

// node_modules/node-fetch/src/body.js
var pipeline = (0, import_node_util.promisify)(import_node_stream.default.pipeline);
var INTERNALS2 = Symbol("Body internals");
var Body2 = class {
  constructor(body, {
    size = 0
  } = {}) {
    let boundary = null;
    if (body === null) {
      body = null;
    } else if (isURLSearchParameters(body)) {
      body = import_node_buffer.Buffer.from(body.toString());
    } else if (isBlob2(body)) {
    } else if (import_node_buffer.Buffer.isBuffer(body)) {
    } else if (import_node_util.types.isAnyArrayBuffer(body)) {
      body = import_node_buffer.Buffer.from(body);
    } else if (ArrayBuffer.isView(body)) {
      body = import_node_buffer.Buffer.from(body.buffer, body.byteOffset, body.byteLength);
    } else if (body instanceof import_node_stream.default) {
    } else if (body instanceof FormData) {
      body = formDataToBlob(body);
      boundary = body.type.split("=")[1];
    } else {
      body = import_node_buffer.Buffer.from(String(body));
    }
    let stream = body;
    if (import_node_buffer.Buffer.isBuffer(body)) {
      stream = import_node_stream.default.Readable.from(body);
    } else if (isBlob2(body)) {
      stream = import_node_stream.default.Readable.from(body.stream());
    }
    this[INTERNALS2] = {
      body,
      stream,
      boundary,
      disturbed: false,
      error: null
    };
    this.size = size;
    if (body instanceof import_node_stream.default) {
      body.on("error", (error_) => {
        const error = error_ instanceof FetchBaseError ? error_ : new FetchError2(`Invalid response body while trying to fetch ${this.url}: ${error_.message}`, "system", error_);
        this[INTERNALS2].error = error;
      });
    }
  }
  get body() {
    return this[INTERNALS2].stream;
  }
  get bodyUsed() {
    return this[INTERNALS2].disturbed;
  }
  async arrayBuffer() {
    const { buffer, byteOffset, byteLength } = await consumeBody2(this);
    return buffer.slice(byteOffset, byteOffset + byteLength);
  }
  async formData() {
    const ct = this.headers.get("content-type");
    if (ct.startsWith("application/x-www-form-urlencoded")) {
      const formData = new FormData();
      const parameters = new URLSearchParams(await this.text());
      for (const [name, value] of parameters) {
        formData.append(name, value);
      }
      return formData;
    }
    const { toFormData: toFormData2 } = await Promise.resolve().then(() => (init_multipart_parser(), multipart_parser_exports));
    return toFormData2(this.body, ct);
  }
  async blob() {
    const ct = this.headers && this.headers.get("content-type") || this[INTERNALS2].body && this[INTERNALS2].body.type || "";
    const buf = await this.arrayBuffer();
    return new fetch_blob_default([buf], {
      type: ct
    });
  }
  async json() {
    const text = await this.text();
    return JSON.parse(text);
  }
  async text() {
    const buffer = await consumeBody2(this);
    return new TextDecoder().decode(buffer);
  }
  buffer() {
    return consumeBody2(this);
  }
};
Body2.prototype.buffer = (0, import_node_util.deprecate)(Body2.prototype.buffer, "Please use 'response.arrayBuffer()' instead of 'response.buffer()'", "node-fetch#buffer");
Object.defineProperties(Body2.prototype, {
  body: { enumerable: true },
  bodyUsed: { enumerable: true },
  arrayBuffer: { enumerable: true },
  blob: { enumerable: true },
  json: { enumerable: true },
  text: { enumerable: true },
  data: { get: (0, import_node_util.deprecate)(
    () => {
    },
    "data doesn't exist, use json(), text(), arrayBuffer(), or body instead",
    "https://github.com/node-fetch/node-fetch/issues/1000 (response)"
  ) }
});
async function consumeBody2(data) {
  if (data[INTERNALS2].disturbed) {
    throw new TypeError(`body used already for: ${data.url}`);
  }
  data[INTERNALS2].disturbed = true;
  if (data[INTERNALS2].error) {
    throw data[INTERNALS2].error;
  }
  const { body } = data;
  if (body === null) {
    return import_node_buffer.Buffer.alloc(0);
  }
  if (!(body instanceof import_node_stream.default)) {
    return import_node_buffer.Buffer.alloc(0);
  }
  const accum = [];
  let accumBytes = 0;
  try {
    for await (const chunk of body) {
      if (data.size > 0 && accumBytes + chunk.length > data.size) {
        const error = new FetchError2(`content size at ${data.url} over limit: ${data.size}`, "max-size");
        body.destroy(error);
        throw error;
      }
      accumBytes += chunk.length;
      accum.push(chunk);
    }
  } catch (error) {
    const error_ = error instanceof FetchBaseError ? error : new FetchError2(`Invalid response body while trying to fetch ${data.url}: ${error.message}`, "system", error);
    throw error_;
  }
  if (body.readableEnded === true || body._readableState.ended === true) {
    try {
      if (accum.every((c) => typeof c === "string")) {
        return import_node_buffer.Buffer.from(accum.join(""));
      }
      return import_node_buffer.Buffer.concat(accum, accumBytes);
    } catch (error) {
      throw new FetchError2(`Could not create Buffer from response body for ${data.url}: ${error.message}`, "system", error);
    }
  } else {
    throw new FetchError2(`Premature close of server response while trying to fetch ${data.url}`);
  }
}
var clone2 = (instance, highWaterMark) => {
  let p1;
  let p2;
  let { body } = instance[INTERNALS2];
  if (instance.bodyUsed) {
    throw new Error("cannot clone body after it is used");
  }
  if (body instanceof import_node_stream.default && typeof body.getBoundary !== "function") {
    p1 = new import_node_stream.PassThrough({ highWaterMark });
    p2 = new import_node_stream.PassThrough({ highWaterMark });
    body.pipe(p1);
    body.pipe(p2);
    instance[INTERNALS2].stream = p1;
    body = p2;
  }
  return body;
};
var getNonSpecFormDataBoundary = (0, import_node_util.deprecate)(
  (body) => body.getBoundary(),
  "form-data doesn't follow the spec and requires special treatment. Use alternative package",
  "https://github.com/node-fetch/node-fetch/issues/1167"
);
var extractContentType2 = (body, request2) => {
  if (body === null) {
    return null;
  }
  if (typeof body === "string") {
    return "text/plain;charset=UTF-8";
  }
  if (isURLSearchParameters(body)) {
    return "application/x-www-form-urlencoded;charset=UTF-8";
  }
  if (isBlob2(body)) {
    return body.type || null;
  }
  if (import_node_buffer.Buffer.isBuffer(body) || import_node_util.types.isAnyArrayBuffer(body) || ArrayBuffer.isView(body)) {
    return null;
  }
  if (body instanceof FormData) {
    return `multipart/form-data; boundary=${request2[INTERNALS2].boundary}`;
  }
  if (body && typeof body.getBoundary === "function") {
    return `multipart/form-data;boundary=${getNonSpecFormDataBoundary(body)}`;
  }
  if (body instanceof import_node_stream.default) {
    return null;
  }
  return "text/plain;charset=UTF-8";
};
var getTotalBytes2 = (request2) => {
  const { body } = request2[INTERNALS2];
  if (body === null) {
    return 0;
  }
  if (isBlob2(body)) {
    return body.size;
  }
  if (import_node_buffer.Buffer.isBuffer(body)) {
    return body.length;
  }
  if (body && typeof body.getLengthSync === "function") {
    return body.hasKnownLength && body.hasKnownLength() ? body.getLengthSync() : null;
  }
  return null;
};
var writeToStream2 = async (dest, { body }) => {
  if (body === null) {
    dest.end();
  } else {
    await pipeline(body, dest);
  }
};

// node_modules/node-fetch/src/headers.js
var import_node_util2 = require("util");
var import_node_http = __toESM(require("http"), 1);
var validateHeaderName = typeof import_node_http.default.validateHeaderName === "function" ? import_node_http.default.validateHeaderName : (name) => {
  if (!/^[\^`\-\w!#$%&'*+.|~]+$/.test(name)) {
    const error = new TypeError(`Header name must be a valid HTTP token [${name}]`);
    Object.defineProperty(error, "code", { value: "ERR_INVALID_HTTP_TOKEN" });
    throw error;
  }
};
var validateHeaderValue = typeof import_node_http.default.validateHeaderValue === "function" ? import_node_http.default.validateHeaderValue : (name, value) => {
  if (/[^\t\u0020-\u007E\u0080-\u00FF]/.test(value)) {
    const error = new TypeError(`Invalid character in header content ["${name}"]`);
    Object.defineProperty(error, "code", { value: "ERR_INVALID_CHAR" });
    throw error;
  }
};
var Headers2 = class extends URLSearchParams {
  constructor(init) {
    let result = [];
    if (init instanceof Headers2) {
      const raw = init.raw();
      for (const [name, values] of Object.entries(raw)) {
        result.push(...values.map((value) => [name, value]));
      }
    } else if (init == null) {
    } else if (typeof init === "object" && !import_node_util2.types.isBoxedPrimitive(init)) {
      const method = init[Symbol.iterator];
      if (method == null) {
        result.push(...Object.entries(init));
      } else {
        if (typeof method !== "function") {
          throw new TypeError("Header pairs must be iterable");
        }
        result = [...init].map((pair) => {
          if (typeof pair !== "object" || import_node_util2.types.isBoxedPrimitive(pair)) {
            throw new TypeError("Each header pair must be an iterable object");
          }
          return [...pair];
        }).map((pair) => {
          if (pair.length !== 2) {
            throw new TypeError("Each header pair must be a name/value tuple");
          }
          return [...pair];
        });
      }
    } else {
      throw new TypeError("Failed to construct 'Headers': The provided value is not of type '(sequence<sequence<ByteString>> or record<ByteString, ByteString>)");
    }
    result = result.length > 0 ? result.map(([name, value]) => {
      validateHeaderName(name);
      validateHeaderValue(name, String(value));
      return [String(name).toLowerCase(), String(value)];
    }) : void 0;
    super(result);
    return new Proxy(this, {
      get(target, p, receiver) {
        switch (p) {
          case "append":
          case "set":
            return (name, value) => {
              validateHeaderName(name);
              validateHeaderValue(name, String(value));
              return URLSearchParams.prototype[p].call(
                target,
                String(name).toLowerCase(),
                String(value)
              );
            };
          case "delete":
          case "has":
          case "getAll":
            return (name) => {
              validateHeaderName(name);
              return URLSearchParams.prototype[p].call(
                target,
                String(name).toLowerCase()
              );
            };
          case "keys":
            return () => {
              target.sort();
              return new Set(URLSearchParams.prototype.keys.call(target)).keys();
            };
          default:
            return Reflect.get(target, p, receiver);
        }
      }
    });
  }
  get [Symbol.toStringTag]() {
    return this.constructor.name;
  }
  toString() {
    return Object.prototype.toString.call(this);
  }
  get(name) {
    const values = this.getAll(name);
    if (values.length === 0) {
      return null;
    }
    let value = values.join(", ");
    if (/^content-encoding$/i.test(name)) {
      value = value.toLowerCase();
    }
    return value;
  }
  forEach(callback, thisArg = void 0) {
    for (const name of this.keys()) {
      Reflect.apply(callback, thisArg, [this.get(name), name, this]);
    }
  }
  *values() {
    for (const name of this.keys()) {
      yield this.get(name);
    }
  }
  *entries() {
    for (const name of this.keys()) {
      yield [name, this.get(name)];
    }
  }
  [Symbol.iterator]() {
    return this.entries();
  }
  raw() {
    return [...this.keys()].reduce((result, key) => {
      result[key] = this.getAll(key);
      return result;
    }, {});
  }
  [Symbol.for("nodejs.util.inspect.custom")]() {
    return [...this.keys()].reduce((result, key) => {
      const values = this.getAll(key);
      if (key === "host") {
        result[key] = values[0];
      } else {
        result[key] = values.length > 1 ? values : values[0];
      }
      return result;
    }, {});
  }
};
Object.defineProperties(
  Headers2.prototype,
  ["get", "entries", "forEach", "values"].reduce((result, property) => {
    result[property] = { enumerable: true };
    return result;
  }, {})
);
function fromRawHeaders(headers = []) {
  return new Headers2(
    headers.reduce((result, value, index, array) => {
      if (index % 2 === 0) {
        result.push(array.slice(index, index + 2));
      }
      return result;
    }, []).filter(([name, value]) => {
      try {
        validateHeaderName(name);
        validateHeaderValue(name, String(value));
        return true;
      } catch {
        return false;
      }
    })
  );
}

// node_modules/node-fetch/src/utils/is-redirect.js
var redirectStatus = /* @__PURE__ */ new Set([301, 302, 303, 307, 308]);
var isRedirect = (code) => {
  return redirectStatus.has(code);
};

// node_modules/node-fetch/src/response.js
var INTERNALS3 = Symbol("Response internals");
var Response2 = class extends Body2 {
  constructor(body = null, options = {}) {
    super(body, options);
    const status = options.status != null ? options.status : 200;
    const headers = new Headers2(options.headers);
    if (body !== null && !headers.has("Content-Type")) {
      const contentType = extractContentType2(body, this);
      if (contentType) {
        headers.append("Content-Type", contentType);
      }
    }
    this[INTERNALS3] = {
      type: "default",
      url: options.url,
      status,
      statusText: options.statusText || "",
      headers,
      counter: options.counter,
      highWaterMark: options.highWaterMark
    };
  }
  get type() {
    return this[INTERNALS3].type;
  }
  get url() {
    return this[INTERNALS3].url || "";
  }
  get status() {
    return this[INTERNALS3].status;
  }
  get ok() {
    return this[INTERNALS3].status >= 200 && this[INTERNALS3].status < 300;
  }
  get redirected() {
    return this[INTERNALS3].counter > 0;
  }
  get statusText() {
    return this[INTERNALS3].statusText;
  }
  get headers() {
    return this[INTERNALS3].headers;
  }
  get highWaterMark() {
    return this[INTERNALS3].highWaterMark;
  }
  clone() {
    return new Response2(clone2(this, this.highWaterMark), {
      type: this.type,
      url: this.url,
      status: this.status,
      statusText: this.statusText,
      headers: this.headers,
      ok: this.ok,
      redirected: this.redirected,
      size: this.size,
      highWaterMark: this.highWaterMark
    });
  }
  static redirect(url, status = 302) {
    if (!isRedirect(status)) {
      throw new RangeError('Failed to execute "redirect" on "response": Invalid status code');
    }
    return new Response2(null, {
      headers: {
        location: new URL(url).toString()
      },
      status
    });
  }
  static error() {
    const response = new Response2(null, { status: 0, statusText: "" });
    response[INTERNALS3].type = "error";
    return response;
  }
  get [Symbol.toStringTag]() {
    return "Response";
  }
};
Object.defineProperties(Response2.prototype, {
  type: { enumerable: true },
  url: { enumerable: true },
  status: { enumerable: true },
  ok: { enumerable: true },
  redirected: { enumerable: true },
  statusText: { enumerable: true },
  headers: { enumerable: true },
  clone: { enumerable: true }
});

// node_modules/node-fetch/src/request.js
var import_node_url = require("url");
var import_node_util3 = require("util");

// node_modules/node-fetch/src/utils/get-search.js
var getSearch = (parsedURL) => {
  if (parsedURL.search) {
    return parsedURL.search;
  }
  const lastOffset = parsedURL.href.length - 1;
  const hash = parsedURL.hash || (parsedURL.href[lastOffset] === "#" ? "#" : "");
  return parsedURL.href[lastOffset - hash.length] === "?" ? "?" : "";
};

// node_modules/node-fetch/src/utils/referrer.js
var import_node_net = require("net");
function stripURLForUseAsAReferrer(url, originOnly = false) {
  if (url == null) {
    return "no-referrer";
  }
  url = new URL(url);
  if (/^(about|blob|data):$/.test(url.protocol)) {
    return "no-referrer";
  }
  url.username = "";
  url.password = "";
  url.hash = "";
  if (originOnly) {
    url.pathname = "";
    url.search = "";
  }
  return url;
}
var ReferrerPolicy = /* @__PURE__ */ new Set([
  "",
  "no-referrer",
  "no-referrer-when-downgrade",
  "same-origin",
  "origin",
  "strict-origin",
  "origin-when-cross-origin",
  "strict-origin-when-cross-origin",
  "unsafe-url"
]);
var DEFAULT_REFERRER_POLICY = "strict-origin-when-cross-origin";
function validateReferrerPolicy(referrerPolicy) {
  if (!ReferrerPolicy.has(referrerPolicy)) {
    throw new TypeError(`Invalid referrerPolicy: ${referrerPolicy}`);
  }
  return referrerPolicy;
}
function isOriginPotentiallyTrustworthy(url) {
  if (/^(http|ws)s:$/.test(url.protocol)) {
    return true;
  }
  const hostIp = url.host.replace(/(^\[)|(]$)/g, "");
  const hostIPVersion = (0, import_node_net.isIP)(hostIp);
  if (hostIPVersion === 4 && /^127\./.test(hostIp)) {
    return true;
  }
  if (hostIPVersion === 6 && /^(((0+:){7})|(::(0+:){0,6}))0*1$/.test(hostIp)) {
    return true;
  }
  if (url.host === "localhost" || url.host.endsWith(".localhost")) {
    return false;
  }
  if (url.protocol === "file:") {
    return true;
  }
  return false;
}
function isUrlPotentiallyTrustworthy(url) {
  if (/^about:(blank|srcdoc)$/.test(url)) {
    return true;
  }
  if (url.protocol === "data:") {
    return true;
  }
  if (/^(blob|filesystem):$/.test(url.protocol)) {
    return true;
  }
  return isOriginPotentiallyTrustworthy(url);
}
function determineRequestsReferrer(request2, { referrerURLCallback, referrerOriginCallback } = {}) {
  if (request2.referrer === "no-referrer" || request2.referrerPolicy === "") {
    return null;
  }
  const policy = request2.referrerPolicy;
  if (request2.referrer === "about:client") {
    return "no-referrer";
  }
  const referrerSource = request2.referrer;
  let referrerURL = stripURLForUseAsAReferrer(referrerSource);
  let referrerOrigin = stripURLForUseAsAReferrer(referrerSource, true);
  if (referrerURL.toString().length > 4096) {
    referrerURL = referrerOrigin;
  }
  if (referrerURLCallback) {
    referrerURL = referrerURLCallback(referrerURL);
  }
  if (referrerOriginCallback) {
    referrerOrigin = referrerOriginCallback(referrerOrigin);
  }
  const currentURL = new URL(request2.url);
  switch (policy) {
    case "no-referrer":
      return "no-referrer";
    case "origin":
      return referrerOrigin;
    case "unsafe-url":
      return referrerURL;
    case "strict-origin":
      if (isUrlPotentiallyTrustworthy(referrerURL) && !isUrlPotentiallyTrustworthy(currentURL)) {
        return "no-referrer";
      }
      return referrerOrigin.toString();
    case "strict-origin-when-cross-origin":
      if (referrerURL.origin === currentURL.origin) {
        return referrerURL;
      }
      if (isUrlPotentiallyTrustworthy(referrerURL) && !isUrlPotentiallyTrustworthy(currentURL)) {
        return "no-referrer";
      }
      return referrerOrigin;
    case "same-origin":
      if (referrerURL.origin === currentURL.origin) {
        return referrerURL;
      }
      return "no-referrer";
    case "origin-when-cross-origin":
      if (referrerURL.origin === currentURL.origin) {
        return referrerURL;
      }
      return referrerOrigin;
    case "no-referrer-when-downgrade":
      if (isUrlPotentiallyTrustworthy(referrerURL) && !isUrlPotentiallyTrustworthy(currentURL)) {
        return "no-referrer";
      }
      return referrerURL;
    default:
      throw new TypeError(`Invalid referrerPolicy: ${policy}`);
  }
}
function parseReferrerPolicyFromHeader(headers) {
  const policyTokens = (headers.get("referrer-policy") || "").split(/[,\s]+/);
  let policy = "";
  for (const token of policyTokens) {
    if (token && ReferrerPolicy.has(token)) {
      policy = token;
    }
  }
  return policy;
}

// node_modules/node-fetch/src/request.js
var INTERNALS4 = Symbol("Request internals");
var isRequest2 = (object) => {
  return typeof object === "object" && typeof object[INTERNALS4] === "object";
};
var doBadDataWarn = (0, import_node_util3.deprecate)(
  () => {
  },
  ".data is not a valid RequestInit property, use .body instead",
  "https://github.com/node-fetch/node-fetch/issues/1000 (request)"
);
var Request2 = class extends Body2 {
  constructor(input, init = {}) {
    let parsedURL;
    if (isRequest2(input)) {
      parsedURL = new URL(input.url);
    } else {
      parsedURL = new URL(input);
      input = {};
    }
    if (parsedURL.username !== "" || parsedURL.password !== "") {
      throw new TypeError(`${parsedURL} is an url with embedded credentials.`);
    }
    let method = init.method || input.method || "GET";
    if (/^(delete|get|head|options|post|put)$/i.test(method)) {
      method = method.toUpperCase();
    }
    if (!isRequest2(init) && "data" in init) {
      doBadDataWarn();
    }
    if ((init.body != null || isRequest2(input) && input.body !== null) && (method === "GET" || method === "HEAD")) {
      throw new TypeError("Request with GET/HEAD method cannot have body");
    }
    const inputBody = init.body ? init.body : isRequest2(input) && input.body !== null ? clone2(input) : null;
    super(inputBody, {
      size: init.size || input.size || 0
    });
    const headers = new Headers2(init.headers || input.headers || {});
    if (inputBody !== null && !headers.has("Content-Type")) {
      const contentType = extractContentType2(inputBody, this);
      if (contentType) {
        headers.set("Content-Type", contentType);
      }
    }
    let signal = isRequest2(input) ? input.signal : null;
    if ("signal" in init) {
      signal = init.signal;
    }
    if (signal != null && !isAbortSignal2(signal)) {
      throw new TypeError("Expected signal to be an instanceof AbortSignal or EventTarget");
    }
    let referrer = init.referrer == null ? input.referrer : init.referrer;
    if (referrer === "") {
      referrer = "no-referrer";
    } else if (referrer) {
      const parsedReferrer = new URL(referrer);
      referrer = /^about:(\/\/)?client$/.test(parsedReferrer) ? "client" : parsedReferrer;
    } else {
      referrer = void 0;
    }
    this[INTERNALS4] = {
      method,
      redirect: init.redirect || input.redirect || "follow",
      headers,
      parsedURL,
      signal,
      referrer
    };
    this.follow = init.follow === void 0 ? input.follow === void 0 ? 20 : input.follow : init.follow;
    this.compress = init.compress === void 0 ? input.compress === void 0 ? true : input.compress : init.compress;
    this.counter = init.counter || input.counter || 0;
    this.agent = init.agent || input.agent;
    this.highWaterMark = init.highWaterMark || input.highWaterMark || 16384;
    this.insecureHTTPParser = init.insecureHTTPParser || input.insecureHTTPParser || false;
    this.referrerPolicy = init.referrerPolicy || input.referrerPolicy || "";
  }
  get method() {
    return this[INTERNALS4].method;
  }
  get url() {
    return (0, import_node_url.format)(this[INTERNALS4].parsedURL);
  }
  get headers() {
    return this[INTERNALS4].headers;
  }
  get redirect() {
    return this[INTERNALS4].redirect;
  }
  get signal() {
    return this[INTERNALS4].signal;
  }
  get referrer() {
    if (this[INTERNALS4].referrer === "no-referrer") {
      return "";
    }
    if (this[INTERNALS4].referrer === "client") {
      return "about:client";
    }
    if (this[INTERNALS4].referrer) {
      return this[INTERNALS4].referrer.toString();
    }
    return void 0;
  }
  get referrerPolicy() {
    return this[INTERNALS4].referrerPolicy;
  }
  set referrerPolicy(referrerPolicy) {
    this[INTERNALS4].referrerPolicy = validateReferrerPolicy(referrerPolicy);
  }
  clone() {
    return new Request2(this);
  }
  get [Symbol.toStringTag]() {
    return "Request";
  }
};
Object.defineProperties(Request2.prototype, {
  method: { enumerable: true },
  url: { enumerable: true },
  headers: { enumerable: true },
  redirect: { enumerable: true },
  clone: { enumerable: true },
  signal: { enumerable: true },
  referrer: { enumerable: true },
  referrerPolicy: { enumerable: true }
});
var getNodeRequestOptions2 = (request2) => {
  const { parsedURL } = request2[INTERNALS4];
  const headers = new Headers2(request2[INTERNALS4].headers);
  if (!headers.has("Accept")) {
    headers.set("Accept", "*/*");
  }
  let contentLengthValue = null;
  if (request2.body === null && /^(post|put)$/i.test(request2.method)) {
    contentLengthValue = "0";
  }
  if (request2.body !== null) {
    const totalBytes = getTotalBytes2(request2);
    if (typeof totalBytes === "number" && !Number.isNaN(totalBytes)) {
      contentLengthValue = String(totalBytes);
    }
  }
  if (contentLengthValue) {
    headers.set("Content-Length", contentLengthValue);
  }
  if (request2.referrerPolicy === "") {
    request2.referrerPolicy = DEFAULT_REFERRER_POLICY;
  }
  if (request2.referrer && request2.referrer !== "no-referrer") {
    request2[INTERNALS4].referrer = determineRequestsReferrer(request2);
  } else {
    request2[INTERNALS4].referrer = "no-referrer";
  }
  if (request2[INTERNALS4].referrer instanceof URL) {
    headers.set("Referer", request2.referrer);
  }
  if (!headers.has("User-Agent")) {
    headers.set("User-Agent", "node-fetch");
  }
  if (request2.compress && !headers.has("Accept-Encoding")) {
    headers.set("Accept-Encoding", "gzip, deflate, br");
  }
  let { agent } = request2;
  if (typeof agent === "function") {
    agent = agent(parsedURL);
  }
  if (!headers.has("Connection") && !agent) {
    headers.set("Connection", "close");
  }
  const search = getSearch(parsedURL);
  const options = {
    path: parsedURL.pathname + search,
    method: request2.method,
    headers: headers[Symbol.for("nodejs.util.inspect.custom")](),
    insecureHTTPParser: request2.insecureHTTPParser,
    agent
  };
  return {
    parsedURL,
    options
  };
};

// node_modules/node-fetch/src/errors/abort-error.js
var AbortError2 = class extends FetchBaseError {
  constructor(message, type = "aborted") {
    super(message, type);
  }
};

// node_modules/node-fetch/src/index.js
init_esm_min();
init_from();
var supportedSchemas = /* @__PURE__ */ new Set(["data:", "http:", "https:"]);
async function fetch2(url, options_) {
  return new Promise((resolve, reject) => {
    const request2 = new Request2(url, options_);
    const { parsedURL, options } = getNodeRequestOptions2(request2);
    if (!supportedSchemas.has(parsedURL.protocol)) {
      throw new TypeError(`node-fetch cannot load ${url}. URL scheme "${parsedURL.protocol.replace(/:$/, "")}" is not supported.`);
    }
    if (parsedURL.protocol === "data:") {
      const data = dist_default(request2.url);
      const response2 = new Response2(data, { headers: { "Content-Type": data.typeFull } });
      resolve(response2);
      return;
    }
    const send = (parsedURL.protocol === "https:" ? import_node_https.default : import_node_http2.default).request;
    const { signal } = request2;
    let response = null;
    const abort = () => {
      const error = new AbortError2("The operation was aborted.");
      reject(error);
      if (request2.body && request2.body instanceof import_node_stream2.default.Readable) {
        request2.body.destroy(error);
      }
      if (!response || !response.body) {
        return;
      }
      response.body.emit("error", error);
    };
    if (signal && signal.aborted) {
      abort();
      return;
    }
    const abortAndFinalize = () => {
      abort();
      finalize();
    };
    const request_ = send(parsedURL.toString(), options);
    if (signal) {
      signal.addEventListener("abort", abortAndFinalize);
    }
    const finalize = () => {
      request_.abort();
      if (signal) {
        signal.removeEventListener("abort", abortAndFinalize);
      }
    };
    request_.on("error", (error) => {
      reject(new FetchError2(`request to ${request2.url} failed, reason: ${error.message}`, "system", error));
      finalize();
    });
    fixResponseChunkedTransferBadEnding(request_, (error) => {
      if (response && response.body) {
        response.body.destroy(error);
      }
    });
    if (process.version < "v14") {
      request_.on("socket", (s2) => {
        let endedWithEventsCount;
        s2.prependListener("end", () => {
          endedWithEventsCount = s2._eventsCount;
        });
        s2.prependListener("close", (hadError) => {
          if (response && endedWithEventsCount < s2._eventsCount && !hadError) {
            const error = new Error("Premature close");
            error.code = "ERR_STREAM_PREMATURE_CLOSE";
            response.body.emit("error", error);
          }
        });
      });
    }
    request_.on("response", (response_) => {
      request_.setTimeout(0);
      const headers = fromRawHeaders(response_.rawHeaders);
      if (isRedirect(response_.statusCode)) {
        const location = headers.get("Location");
        let locationURL = null;
        try {
          locationURL = location === null ? null : new URL(location, request2.url);
        } catch {
          if (request2.redirect !== "manual") {
            reject(new FetchError2(`uri requested responds with an invalid redirect URL: ${location}`, "invalid-redirect"));
            finalize();
            return;
          }
        }
        switch (request2.redirect) {
          case "error":
            reject(new FetchError2(`uri requested responds with a redirect, redirect mode is set to error: ${request2.url}`, "no-redirect"));
            finalize();
            return;
          case "manual":
            break;
          case "follow": {
            if (locationURL === null) {
              break;
            }
            if (request2.counter >= request2.follow) {
              reject(new FetchError2(`maximum redirect reached at: ${request2.url}`, "max-redirect"));
              finalize();
              return;
            }
            const requestOptions = {
              headers: new Headers2(request2.headers),
              follow: request2.follow,
              counter: request2.counter + 1,
              agent: request2.agent,
              compress: request2.compress,
              method: request2.method,
              body: clone2(request2),
              signal: request2.signal,
              size: request2.size,
              referrer: request2.referrer,
              referrerPolicy: request2.referrerPolicy
            };
            if (!isDomainOrSubdomain3(request2.url, locationURL) || !isSameProtocol(request2.url, locationURL)) {
              for (const name of ["authorization", "www-authenticate", "cookie", "cookie2"]) {
                requestOptions.headers.delete(name);
              }
            }
            if (response_.statusCode !== 303 && request2.body && options_.body instanceof import_node_stream2.default.Readable) {
              reject(new FetchError2("Cannot follow redirect with body being a readable stream", "unsupported-redirect"));
              finalize();
              return;
            }
            if (response_.statusCode === 303 || (response_.statusCode === 301 || response_.statusCode === 302) && request2.method === "POST") {
              requestOptions.method = "GET";
              requestOptions.body = void 0;
              requestOptions.headers.delete("content-length");
            }
            const responseReferrerPolicy = parseReferrerPolicyFromHeader(headers);
            if (responseReferrerPolicy) {
              requestOptions.referrerPolicy = responseReferrerPolicy;
            }
            resolve(fetch2(new Request2(locationURL, requestOptions)));
            finalize();
            return;
          }
          default:
            return reject(new TypeError(`Redirect option '${request2.redirect}' is not a valid value of RequestRedirect`));
        }
      }
      if (signal) {
        response_.once("end", () => {
          signal.removeEventListener("abort", abortAndFinalize);
        });
      }
      let body = (0, import_node_stream2.pipeline)(response_, new import_node_stream2.PassThrough(), (error) => {
        if (error) {
          reject(error);
        }
      });
      if (process.version < "v12.10") {
        response_.on("aborted", abortAndFinalize);
      }
      const responseOptions = {
        url: request2.url,
        status: response_.statusCode,
        statusText: response_.statusMessage,
        headers,
        size: request2.size,
        counter: request2.counter,
        highWaterMark: request2.highWaterMark
      };
      const codings = headers.get("Content-Encoding");
      if (!request2.compress || request2.method === "HEAD" || codings === null || response_.statusCode === 204 || response_.statusCode === 304) {
        response = new Response2(body, responseOptions);
        resolve(response);
        return;
      }
      const zlibOptions = {
        flush: import_node_zlib.default.Z_SYNC_FLUSH,
        finishFlush: import_node_zlib.default.Z_SYNC_FLUSH
      };
      if (codings === "gzip" || codings === "x-gzip") {
        body = (0, import_node_stream2.pipeline)(body, import_node_zlib.default.createGunzip(zlibOptions), (error) => {
          if (error) {
            reject(error);
          }
        });
        response = new Response2(body, responseOptions);
        resolve(response);
        return;
      }
      if (codings === "deflate" || codings === "x-deflate") {
        const raw = (0, import_node_stream2.pipeline)(response_, new import_node_stream2.PassThrough(), (error) => {
          if (error) {
            reject(error);
          }
        });
        raw.once("data", (chunk) => {
          if ((chunk[0] & 15) === 8) {
            body = (0, import_node_stream2.pipeline)(body, import_node_zlib.default.createInflate(), (error) => {
              if (error) {
                reject(error);
              }
            });
          } else {
            body = (0, import_node_stream2.pipeline)(body, import_node_zlib.default.createInflateRaw(), (error) => {
              if (error) {
                reject(error);
              }
            });
          }
          response = new Response2(body, responseOptions);
          resolve(response);
        });
        raw.once("end", () => {
          if (!response) {
            response = new Response2(body, responseOptions);
            resolve(response);
          }
        });
        return;
      }
      if (codings === "br") {
        body = (0, import_node_stream2.pipeline)(body, import_node_zlib.default.createBrotliDecompress(), (error) => {
          if (error) {
            reject(error);
          }
        });
        response = new Response2(body, responseOptions);
        resolve(response);
        return;
      }
      response = new Response2(body, responseOptions);
      resolve(response);
    });
    writeToStream2(request_, request2).catch(reject);
  });
}
function fixResponseChunkedTransferBadEnding(request2, errorCallback) {
  const LAST_CHUNK = import_node_buffer2.Buffer.from("0\r\n\r\n");
  let isChunkedTransfer = false;
  let properLastChunkReceived = false;
  let previousChunk;
  request2.on("response", (response) => {
    const { headers } = response;
    isChunkedTransfer = headers["transfer-encoding"] === "chunked" && !headers["content-length"];
  });
  request2.on("socket", (socket) => {
    const onSocketClose = () => {
      if (isChunkedTransfer && !properLastChunkReceived) {
        const error = new Error("Premature close");
        error.code = "ERR_STREAM_PREMATURE_CLOSE";
        errorCallback(error);
      }
    };
    const onData = (buf) => {
      properLastChunkReceived = import_node_buffer2.Buffer.compare(buf.slice(-5), LAST_CHUNK) === 0;
      if (!properLastChunkReceived && previousChunk) {
        properLastChunkReceived = import_node_buffer2.Buffer.compare(previousChunk.slice(-3), LAST_CHUNK.slice(0, 3)) === 0 && import_node_buffer2.Buffer.compare(buf.slice(-2), LAST_CHUNK.slice(3)) === 0;
      }
      previousChunk = buf;
    };
    socket.prependListener("close", onSocketClose);
    socket.on("data", onData);
    request2.on("close", () => {
      socket.removeListener("close", onSocketClose);
      socket.removeListener("data", onData);
    });
  });
}

// src/index.ts
var import_get_packages = __toESM(require_get_packages_cjs());
var import_path3 = __toESM(require("path"));
var import_json_diff_ts = __toESM(require_lib6());

// node_modules/@changesets/config/dist/config.esm.js
var import_fs_extra3 = __toESM(require_lib7());
var import_path2 = __toESM(require("path"));
var import_micromatch = __toESM(require_micromatch());

// node_modules/@changesets/errors/dist/errors.esm.js
var import_extendable_error = __toESM(require_bld());
var ValidationError = class extends import_extendable_error.default {
};

// node_modules/@changesets/logger/dist/logger.esm.js
var import_chalk = __toESM(require_chalk());
var import_util = __toESM(require("util"));
var prefix = "\u{1F98B} ";
function format(args, customPrefix) {
  let fullPrefix = prefix + (customPrefix === void 0 ? "" : " " + customPrefix);
  return fullPrefix + import_util.default.format("", ...args).split("\n").join("\n" + fullPrefix + " ");
}
function warn(...args) {
  console.warn(format(args, import_chalk.default.yellow("warn")));
}

// node_modules/@changesets/get-dependents-graph/dist/get-dependents-graph.esm.js
var import_semver = __toESM(require_semver());
var import_chalk2 = __toESM(require_chalk());
var DEPENDENCY_TYPES = ["dependencies", "devDependencies", "peerDependencies", "optionalDependencies"];
var getAllDependencies = (config) => {
  const allDependencies = /* @__PURE__ */ new Map();
  for (const type of DEPENDENCY_TYPES) {
    const deps = config[type];
    if (!deps)
      continue;
    for (const name of Object.keys(deps)) {
      const depRange = deps[name];
      if ((depRange.startsWith("link:") || depRange.startsWith("file:")) && type === "devDependencies") {
        continue;
      }
      allDependencies.set(name, depRange);
    }
  }
  return allDependencies;
};
var isProtocolRange = (range) => range.indexOf(":") !== -1;
var getValidRange = (potentialRange) => {
  if (isProtocolRange(potentialRange)) {
    return null;
  }
  try {
    return new import_semver.default.Range(potentialRange);
  } catch (_unused) {
    return null;
  }
};
function getDependencyGraph(packages, opts) {
  const graph = /* @__PURE__ */ new Map();
  let valid = true;
  const packagesByName = {
    [packages.root.packageJson.name]: packages.root
  };
  const queue = [packages.root];
  for (const pkg of packages.packages) {
    queue.push(pkg);
    packagesByName[pkg.packageJson.name] = pkg;
  }
  for (const pkg of queue) {
    const {
      name
    } = pkg.packageJson;
    const dependencies = [];
    const allDependencies = getAllDependencies(pkg.packageJson);
    for (let [depName, depRange] of allDependencies) {
      const match = packagesByName[depName];
      if (!match)
        continue;
      const expected = match.packageJson.version;
      const usesWorkspaceRange = depRange.startsWith("workspace:");
      if (usesWorkspaceRange) {
        depRange = depRange.replace(/^workspace:/, "");
        if (depRange === "*" || depRange === "^" || depRange === "~") {
          dependencies.push(depName);
          continue;
        }
      } else if ((opts === null || opts === void 0 ? void 0 : opts.bumpVersionsWithWorkspaceProtocolOnly) === true) {
        continue;
      }
      const range = getValidRange(depRange);
      if (range && !range.test(expected) || isProtocolRange(depRange)) {
        valid = false;
        console.error(`Package ${import_chalk2.default.cyan(`"${name}"`)} must depend on the current version of ${import_chalk2.default.cyan(`"${depName}"`)}: ${import_chalk2.default.green(`"${expected}"`)} vs ${import_chalk2.default.red(`"${depRange}"`)}`);
        continue;
      }
      if (!range) {
        continue;
      }
      dependencies.push(depName);
    }
    graph.set(name, {
      pkg,
      dependencies
    });
  }
  return {
    graph,
    valid
  };
}
function getDependentsGraph(packages, opts) {
  const graph = /* @__PURE__ */ new Map();
  const {
    graph: dependencyGraph
  } = getDependencyGraph(packages, {
    bumpVersionsWithWorkspaceProtocolOnly: (opts === null || opts === void 0 ? void 0 : opts.bumpVersionsWithWorkspaceProtocolOnly) === true
  });
  const dependentsLookup = {};
  packages.packages.forEach((pkg) => {
    dependentsLookup[pkg.packageJson.name] = {
      pkg,
      dependents: []
    };
  });
  packages.packages.forEach((pkg) => {
    const dependent = pkg.packageJson.name;
    const valFromDependencyGraph = dependencyGraph.get(dependent);
    if (valFromDependencyGraph) {
      const dependencies = valFromDependencyGraph.dependencies;
      dependencies.forEach((dependency) => {
        dependentsLookup[dependency].dependents.push(dependent);
      });
    }
  });
  Object.keys(dependentsLookup).forEach((key) => {
    graph.set(key, dependentsLookup[key]);
  });
  const simplifiedDependentsGraph = /* @__PURE__ */ new Map();
  graph.forEach((pkgInfo, pkgName) => {
    simplifiedDependentsGraph.set(pkgName, pkgInfo.dependents);
  });
  return simplifiedDependentsGraph;
}

// node_modules/@changesets/config/dist/config.esm.js
var packageJson = {
  name: "@changesets/config",
  version: "2.1.0",
  description: "Utilities for reading and parsing Changeset's config",
  main: "dist/config.cjs.js",
  module: "dist/config.esm.js",
  license: "MIT",
  repository: "https://github.com/changesets/changesets/tree/main/packages/config",
  files: [
    "dist",
    "schema.json"
  ],
  dependencies: {
    "@changesets/errors": "^0.1.4",
    "@changesets/get-dependents-graph": "^1.3.3",
    "@changesets/logger": "^0.0.5",
    "@changesets/types": "^5.1.0",
    "@manypkg/get-packages": "^1.1.3",
    "fs-extra": "^7.0.1",
    micromatch: "^4.0.2"
  },
  devDependencies: {
    "@types/micromatch": "^4.0.1",
    fixturez: "^1.1.0",
    "jest-in-case": "^1.0.2"
  }
};
var defaultWrittenConfig = {
  $schema: `https://unpkg.com/@changesets/config@${packageJson.version}/schema.json`,
  changelog: "@changesets/cli/changelog",
  commit: false,
  fixed: [],
  linked: [],
  access: "restricted",
  baseBranch: "master",
  updateInternalDependencies: "patch",
  ignore: []
};
function flatten(arr) {
  return [].concat(...arr);
}
function getNormalizedChangelogOption(thing) {
  if (thing === false) {
    return false;
  }
  if (typeof thing === "string") {
    return [thing, null];
  }
  return thing;
}
function getNormalizedCommitOption(thing) {
  if (thing === false) {
    return false;
  }
  if (thing === true) {
    return ["@changesets/cli/commit", {
      skipCI: "version"
    }];
  }
  if (typeof thing === "string") {
    return [thing, null];
  }
  return thing;
}
function getUnmatchedPatterns(listOfPackageNamesOrGlob, pkgNames) {
  return listOfPackageNamesOrGlob.filter((pkgNameOrGlob) => !pkgNames.some((pkgName) => import_micromatch.default.isMatch(pkgName, pkgNameOrGlob)));
}
var havePackageGroupsCorrectShape = (pkgGroups) => {
  return isArray(pkgGroups) && pkgGroups.every((arr) => isArray(arr) && arr.every((pkgName) => typeof pkgName === "string"));
};
function isArray(arg) {
  return Array.isArray(arg);
}
var read = async (cwd, packages) => {
  let json = await (0, import_fs_extra3.readJSON)(import_path2.default.join(cwd, ".changeset", "config.json"));
  return parse2(json, packages);
};
var parse2 = (json, packages) => {
  var _json$snapshot$prerel, _json$snapshot, _json$snapshot2, _json$___experimental, _json$___experimental2, _json$___experimental3, _json$___experimental4;
  let messages = [];
  let pkgNames = packages.packages.map(({
    packageJson: packageJson2
  }) => packageJson2.name);
  if (json.changelog !== void 0 && json.changelog !== false && typeof json.changelog !== "string" && !(isArray(json.changelog) && json.changelog.length === 2 && typeof json.changelog[0] === "string")) {
    messages.push(`The \`changelog\` option is set as ${JSON.stringify(json.changelog, null, 2)} when the only valid values are undefined, a module path(e.g. "@changesets/cli/changelog" or "./some-module") or a tuple with a module path and config for the changelog generator(e.g. ["@changesets/cli/changelog", { someOption: true }])`);
  }
  let normalizedAccess = json.access;
  if (json.access === "private") {
    normalizedAccess = "restricted";
    warn('The `access` option is set as "private", but this is actually not a valid value - the correct form is "restricted".');
  }
  if (normalizedAccess !== void 0 && normalizedAccess !== "restricted" && normalizedAccess !== "public") {
    messages.push(`The \`access\` option is set as ${JSON.stringify(normalizedAccess, null, 2)} when the only valid values are undefined, "public" or "restricted"`);
  }
  if (json.commit !== void 0 && typeof json.commit !== "boolean" && typeof json.commit !== "string" && !(isArray(json.commit) && json.commit.length === 2 && typeof json.commit[0] === "string")) {
    messages.push(`The \`commit\` option is set as ${JSON.stringify(json.commit, null, 2)} when the only valid values are undefined or a boolean or a module path (e.g. "@changesets/cli/commit" or "./some-module") or a tuple with a module path and config for the commit message generator (e.g. ["@changesets/cli/commit", { "skipCI": "version" }])`);
  }
  if (json.baseBranch !== void 0 && typeof json.baseBranch !== "string") {
    messages.push(`The \`baseBranch\` option is set as ${JSON.stringify(json.baseBranch, null, 2)} but the \`baseBranch\` option can only be set as a string`);
  }
  let fixed = [];
  if (json.fixed !== void 0) {
    if (!havePackageGroupsCorrectShape(json.fixed)) {
      messages.push(`The \`fixed\` option is set as ${JSON.stringify(json.fixed, null, 2)} when the only valid values are undefined or an array of arrays of package names`);
    } else {
      let foundPkgNames = /* @__PURE__ */ new Set();
      let duplicatedPkgNames = /* @__PURE__ */ new Set();
      for (let fixedGroup of json.fixed) {
        messages.push(...getUnmatchedPatterns(fixedGroup, pkgNames).map((pkgOrGlob) => `The package or glob expression "${pkgOrGlob}" specified in the \`fixed\` option does not match any package in the project. You may have misspelled the package name or provided an invalid glob expression. Note that glob expressions must be defined according to https://www.npmjs.com/package/micromatch.`));
        let expandedFixedGroup = (0, import_micromatch.default)(pkgNames, fixedGroup);
        fixed.push(expandedFixedGroup);
        for (let fixedPkgName of expandedFixedGroup) {
          if (foundPkgNames.has(fixedPkgName)) {
            duplicatedPkgNames.add(fixedPkgName);
          }
          foundPkgNames.add(fixedPkgName);
        }
      }
      if (duplicatedPkgNames.size) {
        duplicatedPkgNames.forEach((pkgName) => {
          messages.push(`The package "${pkgName}" is defined in multiple sets of fixed packages. Packages can only be defined in a single set of fixed packages. If you are using glob expressions, make sure that they are valid according to https://www.npmjs.com/package/micromatch.`);
        });
      }
    }
  }
  let linked = [];
  if (json.linked !== void 0) {
    if (!havePackageGroupsCorrectShape(json.linked)) {
      messages.push(`The \`linked\` option is set as ${JSON.stringify(json.linked, null, 2)} when the only valid values are undefined or an array of arrays of package names`);
    } else {
      let foundPkgNames = /* @__PURE__ */ new Set();
      let duplicatedPkgNames = /* @__PURE__ */ new Set();
      for (let linkedGroup of json.linked) {
        messages.push(...getUnmatchedPatterns(linkedGroup, pkgNames).map((pkgOrGlob) => `The package or glob expression "${pkgOrGlob}" specified in the \`linked\` option does not match any package in the project. You may have misspelled the package name or provided an invalid glob expression. Note that glob expressions must be defined according to https://www.npmjs.com/package/micromatch.`));
        let expandedLinkedGroup = (0, import_micromatch.default)(pkgNames, linkedGroup);
        linked.push(expandedLinkedGroup);
        for (let linkedPkgName of expandedLinkedGroup) {
          if (foundPkgNames.has(linkedPkgName)) {
            duplicatedPkgNames.add(linkedPkgName);
          }
          foundPkgNames.add(linkedPkgName);
        }
      }
      if (duplicatedPkgNames.size) {
        duplicatedPkgNames.forEach((pkgName) => {
          messages.push(`The package "${pkgName}" is defined in multiple sets of linked packages. Packages can only be defined in a single set of linked packages. If you are using glob expressions, make sure that they are valid according to https://www.npmjs.com/package/micromatch.`);
        });
      }
    }
  }
  const allFixedPackages = new Set(flatten(fixed));
  const allLinkedPackages = new Set(flatten(linked));
  allFixedPackages.forEach((pkgName) => {
    if (allLinkedPackages.has(pkgName)) {
      messages.push(`The package "${pkgName}" can be found in both fixed and linked groups. A package can only be either fixed or linked.`);
    }
  });
  if (json.updateInternalDependencies !== void 0 && !["patch", "minor"].includes(json.updateInternalDependencies)) {
    messages.push(`The \`updateInternalDependencies\` option is set as ${JSON.stringify(json.updateInternalDependencies, null, 2)} but can only be 'patch' or 'minor'`);
  }
  if (json.ignore) {
    if (!(isArray(json.ignore) && json.ignore.every((pkgName) => typeof pkgName === "string"))) {
      messages.push(`The \`ignore\` option is set as ${JSON.stringify(json.ignore, null, 2)} when the only valid values are undefined or an array of package names`);
    } else {
      messages.push(...getUnmatchedPatterns(json.ignore, pkgNames).map((pkgOrGlob) => `The package or glob expression "${pkgOrGlob}" is specified in the \`ignore\` option but it is not found in the project. You may have misspelled the package name or provided an invalid glob expression. Note that glob expressions must be defined according to https://www.npmjs.com/package/micromatch.`));
      const dependentsGraph = getDependentsGraph(packages);
      for (const ignoredPackage of json.ignore) {
        const dependents = dependentsGraph.get(ignoredPackage) || [];
        for (const dependent of dependents) {
          if (!json.ignore.includes(dependent)) {
            messages.push(`The package "${dependent}" depends on the ignored package "${ignoredPackage}", but "${dependent}" is not being ignored. Please add "${dependent}" to the \`ignore\` option.`);
          }
        }
      }
    }
  }
  const {
    snapshot
  } = json;
  if (snapshot !== void 0) {
    if (snapshot.useCalculatedVersion !== void 0 && typeof snapshot.useCalculatedVersion !== "boolean") {
      messages.push(`The \`snapshot.useCalculatedVersion\` option is set as ${JSON.stringify(snapshot.useCalculatedVersion, null, 2)} when the only valid values are undefined or a boolean`);
    }
    if (snapshot.prereleaseTemplate !== void 0 && typeof snapshot.prereleaseTemplate !== "string") {
      messages.push(`The \`snapshot.prereleaseTemplate\` option is set as ${JSON.stringify(snapshot.prereleaseTemplate, null, 2)} when the only valid values are undefined, or a template string.`);
    }
  }
  if (json.___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH !== void 0) {
    const {
      onlyUpdatePeerDependentsWhenOutOfRange,
      updateInternalDependents,
      useCalculatedVersionForSnapshots
    } = json.___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH;
    if (onlyUpdatePeerDependentsWhenOutOfRange !== void 0 && typeof onlyUpdatePeerDependentsWhenOutOfRange !== "boolean") {
      messages.push(`The \`onlyUpdatePeerDependentsWhenOutOfRange\` option is set as ${JSON.stringify(onlyUpdatePeerDependentsWhenOutOfRange, null, 2)} when the only valid values are undefined or a boolean`);
    }
    if (updateInternalDependents !== void 0 && !["always", "out-of-range"].includes(updateInternalDependents)) {
      messages.push(`The \`updateInternalDependents\` option is set as ${JSON.stringify(updateInternalDependents, null, 2)} but can only be 'always' or 'out-of-range'`);
    }
    if (useCalculatedVersionForSnapshots && useCalculatedVersionForSnapshots !== void 0) {
      console.warn(`Experimental flag "useCalculatedVersionForSnapshots" is deprecated since snapshot feature became stable. Please use "snapshot.useCalculatedVersion" instead.`);
      if (typeof useCalculatedVersionForSnapshots !== "boolean") {
        messages.push(`The \`useCalculatedVersionForSnapshots\` option is set as ${JSON.stringify(useCalculatedVersionForSnapshots, null, 2)} when the only valid values are undefined or a boolean`);
      }
    }
  }
  if (messages.length) {
    throw new ValidationError(`Some errors occurred when validating the changesets config:
` + messages.join("\n"));
  }
  let config = {
    changelog: getNormalizedChangelogOption(json.changelog === void 0 ? defaultWrittenConfig.changelog : json.changelog),
    access: normalizedAccess === void 0 ? defaultWrittenConfig.access : normalizedAccess,
    commit: getNormalizedCommitOption(json.commit === void 0 ? defaultWrittenConfig.commit : json.commit),
    fixed,
    linked,
    baseBranch: json.baseBranch === void 0 ? defaultWrittenConfig.baseBranch : json.baseBranch,
    updateInternalDependencies: json.updateInternalDependencies === void 0 ? defaultWrittenConfig.updateInternalDependencies : json.updateInternalDependencies,
    ignore: json.ignore === void 0 ? defaultWrittenConfig.ignore : (0, import_micromatch.default)(pkgNames, json.ignore),
    bumpVersionsWithWorkspaceProtocolOnly: json.bumpVersionsWithWorkspaceProtocolOnly === true,
    snapshot: {
      prereleaseTemplate: (_json$snapshot$prerel = (_json$snapshot = json.snapshot) === null || _json$snapshot === void 0 ? void 0 : _json$snapshot.prereleaseTemplate) !== null && _json$snapshot$prerel !== void 0 ? _json$snapshot$prerel : null,
      useCalculatedVersion: ((_json$snapshot2 = json.snapshot) === null || _json$snapshot2 === void 0 ? void 0 : _json$snapshot2.useCalculatedVersion) !== void 0 ? json.snapshot.useCalculatedVersion : ((_json$___experimental = json.___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH) === null || _json$___experimental === void 0 ? void 0 : _json$___experimental.useCalculatedVersionForSnapshots) !== void 0 ? (_json$___experimental2 = json.___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH) === null || _json$___experimental2 === void 0 ? void 0 : _json$___experimental2.useCalculatedVersionForSnapshots : false
    },
    ___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH: {
      onlyUpdatePeerDependentsWhenOutOfRange: json.___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH === void 0 || json.___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH.onlyUpdatePeerDependentsWhenOutOfRange === void 0 ? false : json.___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH.onlyUpdatePeerDependentsWhenOutOfRange,
      updateInternalDependents: (_json$___experimental3 = (_json$___experimental4 = json.___experimentalUnsafeOptions_WILL_CHANGE_IN_PATCH) === null || _json$___experimental4 === void 0 ? void 0 : _json$___experimental4.updateInternalDependents) !== null && _json$___experimental3 !== void 0 ? _json$___experimental3 : "out-of-range"
    }
  };
  return config;
};
var fakePackage = {
  dir: "",
  packageJson: {
    name: "",
    version: ""
  }
};
var defaultConfig = parse2(defaultWrittenConfig, {
  root: fakePackage,
  tool: "root",
  packages: [fakePackage]
});

// src/index.ts
var import_fs_extra4 = __toESM(require_lib3());

// src/git-utils.ts
var import_exec2 = __toESM(require_exec());
var fetch3 = async () => {
  await (0, import_exec2.exec)("git", ["fetch"]);
};
var push = async (branch, { force } = {}) => {
  await (0, import_exec2.exec)(
    "git",
    [
      "push",
      "origin",
      branch ? `HEAD:${branch}` : void 0,
      force && "--force"
    ].filter(Boolean)
  );
};
var switchToMaybeExistingBranch = async (branch) => {
  await execWithOutput("git", ["checkout", "-t", `origin/${branch}`]);
};
var commitAll = async (message) => {
  await (0, import_exec2.exec)("git", ["add", "."]);
  await (0, import_exec2.exec)("git", ["commit", "-m", message]);
};
var checkIfClean = async () => {
  const { stdout } = await execWithOutput("git", ["status", "--porcelain"]);
  return !stdout.length;
};

// src/index.ts
var import_sanitize_filename = __toESM(require_sanitize_filename());
var import_semver2 = __toESM(require_semver3());
var import_prettier = __toESM(require_prettier());
function textify(d, location) {
  var _a4;
  const link = `[\`${d.key}@${d.value}\` \u2197\uFE0E](https://www.npmjs.com/package/${d.key}/v/${((_a4 = (0, import_semver2.coerce)(d.value)) == null ? void 0 : _a4.version) ?? d.value})`;
  switch (d.type) {
    case import_json_diff_ts.Operation.ADD: {
      return `Added dependency ${link} (to \`${location}\`)`;
    }
    case import_json_diff_ts.Operation.UPDATE: {
      return `Updated dependency ${link} (from \`${d.oldValue}\`, in \`${location}\`)`;
    }
    case import_json_diff_ts.Operation.REMOVE: {
      return `Removed dependency ${link} (from \`${location}\`)`;
    }
  }
}
async function tryPrettier(workdir, content) {
  try {
    const prettierConfig = await import_prettier.default.resolveConfig(workdir).catch((e2) => {
      console.warn(`Failed to load prettier config file (using default)`, e2);
      return {};
    });
    return import_prettier.default.format(content, {
      ...prettierConfig,
      parser: "yaml"
    });
  } catch (e2) {
    console.warn(`Failed to run prettier:`, e2);
    return content;
  }
}
async function fetchFile(pat, file) {
  return await fetch2(
    `https://raw.githubusercontent.com/${file.owner}/${file.repo}/${file.ref}/${file.path}`,
    {
      headers: {
        Authorization: `Token ${pat}`
      }
    }
  ).catch((err) => {
    console.error(
      `Failed to file content from GitHub on a specific ref:`,
      file,
      err
    );
    throw err;
  });
}
async function fetchJsonFile(pat, file) {
  return await fetchFile(pat, file).then(async (x2) => {
    const textBody = await x2.text();
    try {
      return JSON.parse(textBody);
    } catch (e2) {
      console.warn(`Malformed JSON response from GitHub:`, textBody);
      throw e2;
    }
  }).catch((e2) => {
    console.warn(`Failed to parse JSON file: `, file, e2);
    return null;
  });
}
(async () => {
  var _a4;
  let githubToken = process.env.GITHUB_TOKEN;
  if (!githubToken) {
    core.setFailed("Please add the GITHUB_TOKEN to the changesets action");
    return;
  }
  const baseSha = (_a4 = github.context.payload.pull_request) == null ? void 0 : _a4.base.sha;
  if (!baseSha) {
    core.setFailed(
      "Failed to locate base SHA, please make sure you are running in a PR context"
    );
    return;
  }
  console.debug(`Using base Git SHA for checking previous state: ${baseSha}`);
  await setupGitUser();
  await setupGitCredentials(githubToken);
  const issueContext = github.context.issue;
  if (!(issueContext == null ? void 0 : issueContext.number)) {
    core.warning(`Failed to locate a PR associated with the Action context`);
    core.setFailed(`Failed to locate a PR associated with the Action context`);
    return;
  }
  const workdir = process.cwd();
  const packages = await (0, import_get_packages.getPackages)(workdir);
  const changesetsConfig = await read(workdir, packages).catch((e2) => {
    console.warn(
      `Failed to read changesets config: ${e2.message}, using default config...`
    );
    return defaultConfig;
  });
  const relevantPackages = packages.packages.filter(
    (pkg) => !changesetsConfig.ignore.includes(pkg.packageJson.name) && !pkg.packageJson.private
  ).map((p) => ({
    ...p,
    absolutePath: `${p.dir}/package.json`,
    relativePath: import_path3.default.relative(workdir, `${p.dir}/package.json`)
  }));
  console.debug(
    "found relevant packages to check:",
    relevantPackages.map((v) => {
      var _a5;
      return ((_a5 = v.packageJson) == null ? void 0 : _a5.name) || v.dir;
    })
  );
  const changes = /* @__PURE__ */ new Map();
  for (const pkg of relevantPackages) {
    const oldPackageFile = await fetchJsonFile(githubToken, {
      ...github.context.repo,
      path: pkg.relativePath,
      ref: baseSha
    });
    if (oldPackageFile) {
      if (!changes.has(pkg.packageJson.name)) {
        changes.set(pkg.packageJson.name, {
          dependencies: [],
          peerDependencies: []
        });
      }
      changes.get(pkg.packageJson.name).dependencies = (0, import_json_diff_ts.diff)(
        oldPackageFile.dependencies || {},
        pkg.packageJson.dependencies || {}
      );
      changes.get(pkg.packageJson.name).peerDependencies = (0, import_json_diff_ts.diff)(
        oldPackageFile.peerDependencies || {},
        pkg.packageJson.peerDependencies || {}
      );
    } else {
      core.warning(
        `Failed to locate previous file content of ${pkg.relativePath}, skipping ${pkg.packageJson.name}...`
      );
    }
  }
  const branch = github.context.payload.pull_request.head.ref;
  await fetch3();
  await switchToMaybeExistingBranch(branch);
  const changesetBase = import_path3.default.resolve(workdir, ".changeset");
  await (0, import_fs_extra4.mkdirp)(changesetBase).catch(() => null);
  for (const [key, value] of changes) {
    const changes2 = [
      ...value.dependencies.map((d) => textify(d, "dependencies")),
      ...value.peerDependencies.map((d) => textify(d, "peerDependencies"))
    ].map((t2) => `- ${t2}`);
    console.debug("package update summary", {
      key,
      changes: changes2
    });
    const cleanName = (0, import_sanitize_filename.default)(key, {
      replacement: "_"
    });
    const filePath = import_path3.default.resolve(
      changesetBase,
      `${cleanName}-${issueContext.number}-dependencies.md`
    );
    if (changes2.length === 0) {
      const stats = await (0, import_fs_extra4.stat)(filePath).catch(() => null);
      if (stats && stats.isFile()) {
        await (0, import_fs_extra4.unlink)(filePath);
      }
      continue;
    }
    const changeset = {
      releases: [
        {
          name: key,
          type: "patch"
        }
      ],
      summary: changes2.join("\n")
    };
    const changesetContents = `---
${changeset.releases.map((release) => `"${release.name}": ${release.type}`).join("\n")}
---

dependencies updates: 

${changeset.summary}
`;
    console.debug(`Writing changeset to ${filePath}`, changesetContents);
    const formattedOutput = await tryPrettier(workdir, changesetContents);
    await (0, import_fs_extra4.writeFile)(filePath, formattedOutput);
  }
  if (!await checkIfClean()) {
    await commitAll(
      `chore(dependencies): updated changesets for modified dependencies`
    );
    await push();
  }
})().catch((err) => {
  console.error(err);
  core.setFailed(err.message);
});
/*!
 * fill-range <https://github.com/jonschlinkert/fill-range>
 *
 * Copyright (c) 2014-present, Jon Schlinkert.
 * Licensed under the MIT License.
 */
/*!
 * is-extglob <https://github.com/jonschlinkert/is-extglob>
 *
 * Copyright (c) 2014-2016, Jon Schlinkert.
 * Licensed under the MIT License.
 */
/*!
 * is-glob <https://github.com/jonschlinkert/is-glob>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */
/*!
 * is-number <https://github.com/jonschlinkert/is-number>
 *
 * Copyright (c) 2014-present, Jon Schlinkert.
 * Released under the MIT License.
 */
/*!
 * is-plain-object <https://github.com/jonschlinkert/is-plain-object>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */
/*!
 * isobject <https://github.com/jonschlinkert/isobject>
 *
 * Copyright (c) 2014-2017, Jon Schlinkert.
 * Released under the MIT License.
 */
/*!
 * to-regex-range <https://github.com/micromatch/to-regex-range>
 *
 * Copyright (c) 2015-present, Jon Schlinkert.
 * Released under the MIT License.
 */
/*! fetch-blob. MIT License. Jimmy Wärting <https://jimmy.warting.se/opensource> */
/*! formdata-polyfill. MIT License. Jimmy Wärting <https://jimmy.warting.se/opensource> */
/*! node-domexception. MIT License. Jimmy Wärting <https://jimmy.warting.se/opensource> */
/*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
